(function() {
  var ensureLoaded, getCompiledCode, loaded, modules, normalize, require, resolve, used;
  if (this.global == null) {
    this.global = (function() {
      return this;
    })();
  }
  if (this.require != null) {
    return;
  }
  used = {};
  require = function(path) {
    var i, m, object, originalPath, steps;
    if (path === 'ion/browser/require') {
      return require;
    }
    originalPath = path;
    m = modules[path];
    if (!m) {
      if (path[path.length - 1] !== '/') {
        path += '/';
      }
      path += "index";
      m = modules[path];
    }
    if (!m) {
      steps = path.replace(/\/index$/, "").split(/\//);
      object = this;
      i = 0;
      while ((object != null) && i < steps.length) {
        object = object[steps[i]];
        i++;
      }
      if (object != null) {
        m = modules[originalPath] = {
          exports: object
        };
      }
    }
    if (!m) {
      throw new Error("Couldn't find module for: " + path);
    }
    if (!m.exports) {
      m.exports = {};
      m.id = path;
      m.call(this, m, m.exports, resolve(path));
    }
    used[path] = true;
    return m.exports;
  };
  modules = {};
  require.getUnusedIds = function() {
    var key, results;
    results = [];
    for (key in modules) {
      if (!used[key]) {
        results.push(key);
      }
    }
    return results;
  };
  normalize = require.normalize = function(curr, path) {
    var i, seg, segs;
    segs = curr.split("/");
    seg = void 0;
    if (path[0] !== ".") {
      return path;
    }
    segs.pop();
    path = path.split("/");
    i = 0;
    while (i < path.length) {
      seg = path[i];
      if (seg === "..") {
        segs.pop();
      } else {
        if (seg !== ".") {
          segs.push(seg);
        }
      }
      ++i;
    }
    return segs.join("/");
  };
  resolve = function(path) {
    return function(p) {
      return require(normalize(path, p));
    };
  };
  require.register = function(path, fn) {
    return modules[path] = fn;
  };
  require.loadAll = function() {
    var id, _results;
    _results = [];
    for (id in modules) {
      _results.push(require(id));
    }
    return _results;
  };
  require.getModuleIds = function() {
    return Object.keys(modules);
  };
  require.runTests = function(callback) {
    var fn;
    fn = function() {
      return require("ion/browser/tester").runTests(require.getModuleIds(), callback);
    };
    if (global.setTimeout != null) {
      return setTimeout(fn, 0);
    } else {
      return fn();
    }
  };
  getCompiledCode = function(scriptElement) {
    var compiledCode, compiler, source;
    source = scriptElement.innerHTML;
    compiledCode = sessionStorage.getItem(source);
    if (compiledCode == null) {
      console.log('checking source code, didnt find it, so compiling');
      compiler = require('ion/compiler');
      compiledCode = compiler.compile(source);
      sessionStorage.setItem(source, compiledCode);
    }
    return compiledCode;
  };
  require.compileScripts = function() {
    var compiledCode, compiledWrapper, ion, removeLastResult, result, scriptElement, template, _i, _len, _ref;
    ion = require('ion');
    _ref = document.querySelectorAll("script[type=ion]");
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      scriptElement = _ref[_i];
      compiledCode = getCompiledCode(scriptElement);
      compiledWrapper = eval("(function(){ " + compiledCode + " })");
      result = compiledWrapper.call(scriptElement);
      if (result != null) {
        if (typeof result.template) {
          template = result.call(scriptElement);
          removeLastResult = null;
          template.observe(function(templateResult) {
            var container;
            if (typeof removeLastResult === "function") {
              removeLastResult();
            }
            removeLastResult = null;
            if (templateResult != null) {
              container = scriptElement.parentElement;
              if (global.Polymer) {
                container = Polymer.dom(container);
              }
              container.appendChild(templateResult);
              return removeLastResult = function() {
                return scriptElement.parentElement.removeChild(templateResult);
              };
            }
          });
        } else {
          scriptElement.parentElement.appendChild(document.createTextNode(result));
        }
      }
    }
    return ion.sync();
  };
  if (typeof module === "undefined") {
    this.require = require;
  } else {
    module.exports = require;
  }
  if (global.window != null) {
    loaded = false;
    ensureLoaded = function() {
      if (!loaded) {
        loaded = true;
        return require.compileScripts();
      }
    };
    window.addEventListener('load', ensureLoaded);
    return window.addEventListener('WebComponentsReady', ensureLoaded);
  }
})();

void (function(){var _ion_Object_ = function(module,exports,require){'use strict';
var ion = require('./');
var typeKey = ion.typeKey;
var _ref2 = {};
{
    _ref2[typeKey] = ion.patch.combine(_ref2[typeKey], {
        visible: false,
        type: 'string',
        get: function () {
            return this.constructor.name;
        },
        set: function () {
        }
    });
    _ref2.toJSON = function () {
        var properties = {};
        properties[typeKey] = this[typeKey];
        {
            var _ref = this;
            for (var key in _ref) {
                var value = _ref[key];
                var descriptor = this.constructor.properties != null ? this.constructor.properties[key] : void 0;
                if ((descriptor != null ? descriptor.serializable : void 0) !== false) {
                    properties[key] = value;
                }
            }
        }
        return properties;
    };
}
var Object = ion.defineClass({
        name: 'Object',
        constructor: function Object(properties) {
            for (var _i = 0; _i < arguments.length; _i++) {
                var arg = arguments[_i];
                if (arg != null) {
                    for (var key in arg) {
                        var value = arg[key];
                        this[key] = value;
                    }
                }
            }
        },
        typeKey: typeKey,
        is: function (object) {
            return object != null ? object.constructor.types != null ? object.constructor.types.has != null ? object.constructor.types.has(this) : void 0 : void 0 : void 0;
        },
        properties: _ref2,
        test: function () {
            var object = new Object();
            if (!Object.is(object))
                throw new Error('Assertion Failed: (Object.is(object))');
        }
    }, null);
module.exports = exports = Object;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/Object',_ion_Object_);
    else
      _ion_Object_.call(this, module, exports, require);
  }
  else {
    _ion_Object_.call(this);
  }
}).call(this)

'use strict';
(function () {
    if (!(global.window != null)) {
        return;
    }
    var defaultNS = 'http://www.w3.org/1999/xhtml';
    var capitalize = function (x) {
        return x[0].toUpperCase() + x.substring(1);
    };
    var registerElements = function (elements, ns) {
        if (ns == null)
            ns = defaultNS;
        for (var _i = 0; _i < elements.length; _i++) {
            var name = elements[_i];
            var jsName = name.split('-').map(capitalize).join('');
            window[jsName] = function (ns, name) {
                return function (attributes) {
                    var ion = require('ion');
                    var isValue = void 0;
                    for (var _i2 = 0; _i2 < arguments.length; _i2++) {
                        var arg = arguments[_i2];
                        if ((arg != null ? arg.is : void 0) != null) {
                            isValue = arg.is;
                        }
                    }
                    var element = document.createElementNS(ns, name, isValue);
                    for (var _i3 = 0; _i3 < arguments.length; _i3++) {
                        var arg = arguments[_i3];
                        if (arg != null) {
                            for (var key in arg) {
                                var value = arg[key];
                                if (value != null) {
                                    element.setAttribute(key, value);
                                }
                            }
                        }
                    }
                    return element;
                };
            }(ns, name);
        }
    };
    global.registerElements = registerElements;
    var syncOnRefresh = function (e) {
        var ion = require('ion');
        requestAnimationFrame(ion.sync);
    };
    window.addEventListener('hashchange', syncOnRefresh);
    window.addEventListener('transitionend', syncOnRefresh);
    window.document.addEventListener('keypress', syncOnRefresh);
    window.document.addEventListener('keydown', syncOnRefresh);
    window.document.addEventListener('keyup', syncOnRefresh);
    var nsElements = {
            'http://www.w3.org/1999/xhtml': [
                'div',
                'span',
                'input',
                'textarea',
                'a',
                'br',
                'img',
                'p',
                'button',
                'caption',
                'fieldset',
                'form',
                'frame',
                'frameset',
                'h1',
                'h2',
                'h3',
                'h4',
                'h5',
                'h6',
                'hr',
                'legend',
                'menu',
                'option',
                'select',
                'script',
                'pre',
                'table',
                'tbody',
                'td',
                'tr',
                'thead',
                'canvas',
                'head',
                'meta',
                'body',
                'script',
                'section',
                'header',
                'footer',
                'article',
                'ul',
                'ol',
                'li',
                'label',
                'strong',
                'datalist'
            ],
            'http://www.w3.org/2000/svg': [
                'svg',
                'path',
                'circle',
                'text'
            ]
        };
    for (var ns in nsElements) {
        var elements = nsElements[ns];
        registerElements(elements, ns);
    }
}());
void (function(){var _ion_browser_index_ = function(module,exports,require){Object.defineProperty(exports, 'elements', {get:function(){ return require('./elements') }, enumerable: true}) 
Object.defineProperty(exports, 'require', {get:function(){ return require('./require') }, enumerable: true}) 
Object.defineProperty(exports, 'tester', {get:function(){ return require('./tester') }, enumerable: true}) 
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/browser/index',_ion_browser_index_);
    else
      _ion_browser_index_.call(this, module, exports, require);
  }
  else {
    _ion_browser_index_.call(this);
  }
}).call(this)
void (function(){var _ion_browser_tester_ = function(module,exports,require){var args, file, manifest, manifestFile, moduleId, modules, np, runTest, runTests, spawnTests, utility, _i, _len, _ref;

runTest = function(name, test, callback) {
  var e, expectedCallbacks, key, result, value;
  expectedCallbacks = [];
  if (typeof test === 'object') {
    for (key in test) {
      value = test[key];
      expectedCallbacks = expectedCallbacks.concat(runTest(name + ' ' + key, value, callback));
    }
  } else if (typeof test === 'function') {
    if (/^\s*function\s*[a-zA-Z_0-9]*\s*\(\s*(done)?\s*\)/.test(test.toString())) {
      expectedCallbacks.push(name);
      try {
        if (test.length === 1) {
          test(function(error, warning) {
            return callback(name, error, warning);
          });
        } else {
          result = test();
          callback(name, null, result);
        }
      } catch (_error) {
        e = _error;
        callback(name, e, null);
      }
    }
  }
  return expectedCallbacks;
};

exports.spawnTests = spawnTests = function(manifestFile) {
  var command;
  command = "node " + __filename + " " + manifestFile;
  require('../builder/utility').spawn(command);
};

exports.runTests = runTests = function(moduleIds, callback) {
  var array, duration, e, error, expectedCallbacks, getIncompleteCallbacks, handler, inc, key, module, moduleId, name, timeout, waitingForFinishTimeout, warning, _i, _len;
  if (!moduleIds) {
    throw new Error("moduleIds is required");
  }
  if (callback == null) {
    callback = exports.createCallback();
  }
  expectedCallbacks = {};
  waitingForFinishTimeout = null;
  handler = function(name, error, warning) {
    var inc;
    expectedCallbacks[name] = true;
    callback(name, error, warning);
    if (waitingForFinishTimeout != null) {
      inc = getIncompleteCallbacks();
      if (inc.length === 0) {
        clearTimeout(waitingForFinishTimeout);
        return callback();
      }
    }
  };
  for (key in moduleIds) {
    moduleId = moduleIds[key];
    try {
      module = require(moduleId);
      name = Array.isArray(moduleIds) ? moduleId : key;
      array = runTest(name, module.test, handler);
      for (_i = 0, _len = array.length; _i < _len; _i++) {
        name = array[_i];
        if (expectedCallbacks[name] == null) {
          expectedCallbacks[name] = false;
        }
      }
    } catch (_error) {
      e = _error;
      handler(moduleId, e, null);
    }
  }
  getIncompleteCallbacks = function() {
    var value;
    return (function() {
      var _results;
      _results = [];
      for (name in expectedCallbacks) {
        value = expectedCallbacks[name];
        if (!value) {
          _results.push(name);
        }
      }
      return _results;
    })();
  };
  inc = getIncompleteCallbacks();
  if (inc.length === 0) {
    return callback();
  } else {
    duration = 1000;
    error = "Timed out after " + duration + " ms";
    warning = void 0;
    timeout = (function(_this) {
      return function() {
        var _j, _len1;
        inc = getIncompleteCallbacks();
        for (_j = 0, _len1 = inc.length; _j < _len1; _j++) {
          name = inc[_j];
          callback(name, error, warning);
        }
        return callback();
      };
    })(this);
    if (global.setTimeout != null) {
      return waitingForFinishTimeout = setTimeout(timeout, duration);
    } else {
      error = void 0;
      warning = "Platform missing setTimeout";
      return timeout();
    }
  }
};

exports.createCallback = function(options, html) {
  var beep, blue, endColor, endLine, fails, green, log, plain, red, start, tests, _ref, _ref1, _ref2, _ref3, _ref4, _ref5, _ref6, _ref7;
  if (html == null) {
    html = global.window != null;
  }
  if (options == null) {
    options = html ? {
      red: '<span style="color:red;white-space:pre">',
      green: '<span style="color:green;white-space:pre">',
      blue: '<span style="color:blue;white-space:pre">',
      plain: '<span>',
      endColor: '</span>',
      log: function(x) {
        return document.body.innerHTML += x;
      },
      beep: '',
      endLine: '<br>'
    } : {};
  }
  red = (_ref = options.red) != null ? _ref : '\u001b[31m';
  green = (_ref1 = options.green) != null ? _ref1 : '\u001b[32m';
  blue = (_ref2 = options.blue) != null ? _ref2 : '\u001b[36m';
  endColor = (_ref3 = options.endColor) != null ? _ref3 : '\u001b[0m';
  plain = (_ref4 = options.plain) != null ? _ref4 : '';
  beep = (_ref5 = options.beep) != null ? _ref5 : '\u0007';
  log = (_ref6 = options.log) != null ? _ref6 : function(x) {
    return console.log(x);
  };
  endLine = (_ref7 = options.endLine) != null ? _ref7 : '';
  tests = 0;
  fails = 0;
  start = null;
  return function(name, error, result) {
    var color, finish, passed, time, title, _ref10, _ref8, _ref9;
    if (start == null) {
      start = new Date().getTime();
    }
    if (name != null) {
      tests++;
      if (error != null) {
        fails++;
      }
      color = error != null ? red : result != null ? blue : null;
      if (color != null) {
        return log(color + name + ": " + ((_ref8 = (_ref9 = (_ref10 = error != null ? error.stack : void 0) != null ? _ref10 : error) != null ? _ref9 : result) != null ? _ref8 : "") + endColor + endLine);
      } else {
        return process.stdout.write('.');
      }
    } else {
      finish = new Date().getTime();
      time = finish - start;
      passed = tests - fails;
      log(endLine);
      color = passed === tests ? green : red + beep;
      log(color + (title = "" + passed + "/" + tests + " Passed (" + time + " ms).") + endColor + endLine);
      if (global.document) {
        document.title = title;
      }
      return log(endLine);
    }
  };
};

exports.test = function() {
  var assert, tests;
  assert = {
    equal: function(a, b) {
      if (!a == b) {
        throw new Error("" + a + " != " + b);
      }
    }
  };
  tests = {
    alpha: function() {
      throw "Failure";
    },
    beta: function() {},
    charlie: function() {
      return "Return value";
    }
  };
  runTest('fail', (function() {
    throw 'Failure';
  }), function(name, error, result) {
    assert.equal(name, 'fail');
    assert.equal(error, 'Failure');
    return assert.equal(result, null);
  });
  runTest('pass', (function() {}), function(name, error, result) {
    assert.equal(name, 'pass');
    assert.equal(error, null);
    return assert.equal(result, null);
  });
  runTest('warn', (function() {
    return 'warning';
  }), function(name, error, result) {
    assert.equal(name, 'warn');
    assert.equal(error, null);
    return assert.equal(result, 'warning');
  });
};

if (require.main === module) {
  np = require('path');
  args = process.argv.slice(2).map(function(x) {
    return x.replace(/\\/g, '\/');
  });
  if (args.length < 1) {
    console.log("Usage: tester manifestFile");
    return;
  }
  manifestFile = args[0];
  utility = require('../builder/utility');
  manifest = JSON.parse(utility.read(manifestFile));
  modules = {};
  _ref = manifest.files;
  for (_i = 0, _len = _ref.length; _i < _len; _i++) {
    file = _ref[_i];
    moduleId = np.join(process.cwd(), np.dirname(manifestFile), file);
    modules[file] = moduleId;
  }
  runTests(modules);
}

  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/browser/tester',_ion_browser_tester_);
    else
      _ion_browser_tester_.call(this, module, exports, require);
  }
  else {
    _ion_browser_tester_.call(this);
  }
}).call(this)
void (function(){var _ion_builder_Directory_ = function(module,exports,require){'use strict';
if (global.Window) {
    return;
}
var ion = require('../'), fs = require('fs'), np = require('path'), utility = require('./utility'), watcher = require('./watcher'), File = require('./File');
var Directory = ion.defineClass({
        name: 'Directory',
        constructor: function Directory(path) {
            if (path != null) {
                this.path = String(path);
            }
        },
        properties: {
            create: function () {
                utility.makeDirectories(this.path);
            },
            exists: {
                get: function () {
                    return fs.existsSync(this.path);
                }
            },
            path: '.',
            toString: function () {
                return this.path;
            },
            get: function (path) {
                if (this.hasOwnProperty(path) || this[path] != null) {
                    return this[path];
                }
                path = this.getAbsoluteName(path);
                if (fs.existsSync(path)) {
                    return utility.read(path);
                } else {
                    return void 0;
                }
            },
            set: function (path, content) {
                if (this.hasOwnProperty(path) || this[path] != null) {
                    return this[path] = content;
                }
                path = this.getAbsoluteName(path);
                if (content != null) {
                    console.log('Writing: ' + path);
                } else {
                    console.log('Deleting: ' + path);
                }
                utility.write(path, content);
                return content;
            },
            read: function (path) {
                if (this.hasOwnProperty(path) || this[path] != null) {
                    return this[path];
                }
                path = this.getAbsoluteName(path);
                if (fs.existsSync(path)) {
                    return utility.read(path);
                } else {
                    return void 0;
                }
            },
            write: function (path, content, options) {
                if (options == null)
                    options = {};
                var _ref = options;
                var encoding = _ref.encoding;
                var force = _ref.force;
                if (!(content != null)) {
                    return;
                }
                if (this.hasOwnProperty(path) || this[path] != null) {
                    return this[path] = content;
                }
                path = this.getAbsoluteName(path);
                if (force || utility.read(path, encoding) !== content) {
                    console.log('Writing: ' + path);
                    utility.write(path, content, encoding);
                }
            },
            delete: function (path) {
                console.log('Deleting: ' + path);
                path = this.getAbsoluteName(path);
                utility.write(path, null);
            },
            getFile: function (path) {
                return new File(this.getAbsoluteName(path));
            },
            getDirectory: function (path) {
                return new Directory(this.getAbsoluteName(path));
            },
            getRelativeName: function (path) {
                return np.relative(this.path, String(path));
            },
            getAbsoluteName: function (path) {
                return np.join(this.path, String(path));
            },
            search: function (include, exclude, options) {
                options = options != null ? options : { initial: false };
                if (include != null) {
                    options.include = include;
                }
                if (exclude != null) {
                    options.exclude = exclude;
                }
                var results = {};
                ion.makeReactive(results, ion.bind(function () {
                    var unwatch = watcher.watchDirectory(this.path, options, ion.bind(function (filename) {
                            var path = this.getRelativeName(filename);
                            if (fs.existsSync(filename)) {
                                if (!(results[path] != null)) {
                                    results[path] = new File(filename);
                                } else {
                                    var file = results[path];
                                    var modified = utility.getModified(filename);
                                    if (modified !== file.modified) {
                                        file.modified = modified;
                                    } else {
                                        return;
                                    }
                                }
                            } else {
                                delete results[path];
                            }
                            ion.sync();
                        }, this));
                    return unwatch;
                }, this));
                var files = utility.list(this.path, options);
                for (var _i = 0; _i < files.length; _i++) {
                    var path = files[_i];
                    results[this.getRelativeName(path)] = new File(path);
                }
                return results;
            }
        }
    });
module.exports = exports = Directory;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/builder/Directory',_ion_builder_Directory_);
    else
      _ion_builder_Directory_.call(this, module, exports, require);
  }
  else {
    _ion_builder_Directory_.call(this);
  }
}).call(this)
void (function(){var _ion_builder_File_ = function(module,exports,require){'use strict';
if (global.Window) {
    return;
}
var ion = require('../'), fs = require('fs'), np = require('path'), utility = require('./utility');
var File = ion.defineClass({
        name: 'File',
        constructor: function File(path) {
            if ((path != null ? path.constructor : void 0) === File) {
                return path;
            }
            if (this.constructor !== File) {
                return new File(path);
            }
            if (typeof path !== 'string') {
                throw new Error('path string is required');
            }
            Object.defineProperties(this, {
                path: {
                    value: path,
                    enumerable: true,
                    writable: false
                }
            });
            this.modified = utility.getModified(path);
            ion.makeReactive(this, ion.bind(function () {
                var watcher;
                if (utility.exists(this.path)) {
                    watcher = fs.watch(this.path, ion.bind(function () {
                        var modified = utility.getModified(this.path);
                        if (this.modified !== modified) {
                            this.modified = modified;
                            ion.sync();
                        }
                    }, this));
                }
                return function () {
                    return watcher != null ? watcher.close() : void 0;
                };
            }, this));
        },
        properties: {
            isFile: {
                get: function () {
                    return !this.isDirectory;
                }
            },
            isDirectory: {
                get: function () {
                    return utility.isDirectory(this.path);
                }
            },
            directoryName: {
                get: function () {
                    return np.dirname(this.path) != null ? np.dirname(this.path) : '';
                }
            },
            exists: {
                get: function () {
                    return utility.exists(this.path);
                }
            },
            copyFrom: function (file) {
                file = File(file);
                var content = file.read(null);
                if (content.length === 0) {
                    console.log('XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX\nXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX\n' + file + ' ' + file.modified + '\nXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX\nXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX');
                } else {
                    this.write(content, null);
                    console.log('Copied: ' + np.normalize(this.path));
                }
            },
            read: function () {
                var _lastModified = {};
                var _content = {};
                return function (encoding) {
                    if (utility.exists(this.path)) {
                        var modified = utility.getModified(this.path);
                        var content;
                        if (modified === _lastModified[this.path]) {
                            content = _content[this.path];
                        } else {
                            content = utility.read(this.path, encoding);
                            if (content.length > 0) {
                                _content[this.path] = content;
                                _lastModified[this.path] = modified;
                            } else {
                                delete _content[this.path];
                                delete _lastModified[this.path];
                            }
                        }
                        return content;
                    } else {
                        return null;
                    }
                };
            }(),
            getExtension: function () {
                var index = this.path.lastIndexOf('.');
                return index < 0 ? '' : this.path.substring(index);
            },
            write: function (content, encoding, forceWrite) {
                if (forceWrite == null)
                    forceWrite = false;
                utility.write(this.path, content, encoding);
            },
            delete: function () {
                return utility.write(this.path, null);
            },
            toString: function () {
                return this.path;
            },
            valueOf: function () {
                return this.path;
            }
        }
    });
module.exports = exports = File;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/builder/File',_ion_builder_File_);
    else
      _ion_builder_File_.call(this, module, exports, require);
  }
  else {
    _ion_builder_File_.call(this);
  }
}).call(this)
void (function(){var _ion_builder_ModuleBuilder_ = function(module,exports,require){'use strict';
if (global.window) {
    return;
}
var ion = require('../'), np = require('path'), File = require('./File'), Directory = require('./Directory'), builder = require('./'), utility = require('./utility'), compilers = {
        '.coffee': { compile: builder.compileCoffeeScript },
        '.pegjs': { compile: builder.compilePegjs },
        '.js': { compile: builder.shimJavascript },
        '.ion': {
            compile: builder.compileIon,
            compileWithSourceMap: builder.compileIonWithSourceMap
        }
    };
module.exports = exports = ion.template(function (packagePatch) {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'packageJson',
                            loc: {
                                start: {
                                    line: 26,
                                    column: 8,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                },
                                end: {
                                    line: 26,
                                    column: 19,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'ion',
                                    loc: {
                                        start: {
                                            line: 26,
                                            column: 22,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        },
                                        end: {
                                            line: 26,
                                            column: 25,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'patch',
                                    loc: {
                                        start: {
                                            line: 26,
                                            column: 26,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        },
                                        end: {
                                            line: 26,
                                            column: 31,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 26,
                                        column: 22,
                                        fixed: true,
                                        source: 'ion/builder/ModuleBuilder.ion'
                                    },
                                    end: {
                                        line: 26,
                                        column: 31,
                                        fixed: true,
                                        source: 'ion/builder/ModuleBuilder.ion'
                                    }
                                }
                            },
                            arguments: [
                                {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'JSON',
                                            loc: {
                                                start: {
                                                    line: 26,
                                                    column: 32,
                                                    fixed: true,
                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                },
                                                end: {
                                                    line: 26,
                                                    column: 36,
                                                    fixed: true,
                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'parse',
                                            loc: {
                                                start: {
                                                    line: 26,
                                                    column: 37,
                                                    fixed: true,
                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                },
                                                end: {
                                                    line: 26,
                                                    column: 42,
                                                    fixed: true,
                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 26,
                                                column: 32,
                                                fixed: true,
                                                source: 'ion/builder/ModuleBuilder.ion'
                                            },
                                            end: {
                                                line: 26,
                                                column: 42,
                                                fixed: true,
                                                source: 'ion/builder/ModuleBuilder.ion'
                                            }
                                        }
                                    },
                                    arguments: [{
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'NewExpression',
                                                    callee: {
                                                        type: 'Identifier',
                                                        name: 'File',
                                                        loc: {
                                                            start: {
                                                                line: 26,
                                                                column: 47,
                                                                fixed: true,
                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                            },
                                                            end: {
                                                                line: 26,
                                                                column: 51,
                                                                fixed: true,
                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [{
                                                            type: 'Literal',
                                                            value: 'package.json'
                                                        }],
                                                    loc: {
                                                        start: {
                                                            line: 26,
                                                            column: 43,
                                                            fixed: true,
                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 26,
                                                            column: 67,
                                                            fixed: true,
                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'read',
                                                    loc: {
                                                        start: {
                                                            line: 26,
                                                            column: 68,
                                                            fixed: true,
                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 26,
                                                            column: 72,
                                                            fixed: true,
                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 26,
                                                        column: 43,
                                                        fixed: true,
                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                    },
                                                    end: {
                                                        line: 26,
                                                        column: 72,
                                                        fixed: true,
                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                    }
                                                }
                                            },
                                            arguments: [],
                                            loc: {
                                                start: {
                                                    line: 26,
                                                    column: 43,
                                                    fixed: true,
                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                },
                                                end: {
                                                    line: 26,
                                                    column: 74,
                                                    fixed: true,
                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                }
                                            }
                                        }],
                                    loc: {
                                        start: {
                                            line: 26,
                                            column: 32,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        },
                                        end: {
                                            line: 26,
                                            column: 75,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        }
                                    }
                                },
                                {
                                    type: 'ConditionalExpression',
                                    test: {
                                        type: 'BinaryExpression',
                                        operator: '!=',
                                        left: {
                                            type: 'Identifier',
                                            name: 'packagePatch',
                                            loc: {
                                                start: {
                                                    line: 26,
                                                    column: 77,
                                                    fixed: true,
                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                },
                                                end: {
                                                    line: 26,
                                                    column: 89,
                                                    fixed: true,
                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                }
                                            }
                                        },
                                        right: {
                                            type: 'Literal',
                                            value: null
                                        }
                                    },
                                    consequent: {
                                        type: 'Identifier',
                                        name: 'packagePatch',
                                        loc: {
                                            start: {
                                                line: 26,
                                                column: 77,
                                                fixed: true,
                                                source: 'ion/builder/ModuleBuilder.ion'
                                            },
                                            end: {
                                                line: 26,
                                                column: 89,
                                                fixed: true,
                                                source: 'ion/builder/ModuleBuilder.ion'
                                            }
                                        }
                                    },
                                    alternate: {
                                        type: 'ObjectExpression',
                                        properties: []
                                    }
                                }
                            ],
                            loc: {
                                start: {
                                    line: 26,
                                    column: 22,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                },
                                end: {
                                    line: 26,
                                    column: 95,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'inputs',
                            loc: {
                                start: {
                                    line: 27,
                                    column: 8,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                },
                                end: {
                                    line: 27,
                                    column: 14,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Function',
                                context: true,
                                value: function (_context) {
                                    return function (packageJson) {
                                        var Directory = _context.get('Directory');
                                        var names = packageJson.directories.src != null ? packageJson.directories.src : 'src';
                                        if (!Array.isArray(names)) {
                                            names = [names];
                                        }
                                        var _ref = [];
                                        for (var _i = 0; _i < names.length; _i++) {
                                            var name = names[_i];
                                            _ref.push(new Directory(name));
                                        }
                                        return _ref;
                                    };
                                }
                            },
                            arguments: [{
                                    type: 'Identifier',
                                    name: 'packageJson',
                                    loc: {
                                        start: {
                                            line: 27,
                                            column: 21,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        },
                                        end: {
                                            line: 27,
                                            column: 32,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        }
                                    }
                                }],
                            loc: {
                                start: {
                                    line: 27,
                                    column: 17,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                },
                                end: {
                                    line: 32,
                                    column: 8,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'input',
                            loc: {
                                start: {
                                    line: 32,
                                    column: 8,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                },
                                end: {
                                    line: 32,
                                    column: 13,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            computed: true,
                            object: {
                                type: 'Identifier',
                                name: 'inputs',
                                loc: {
                                    start: {
                                        line: 32,
                                        column: 16,
                                        fixed: true,
                                        source: 'ion/builder/ModuleBuilder.ion'
                                    },
                                    end: {
                                        line: 32,
                                        column: 22,
                                        fixed: true,
                                        source: 'ion/builder/ModuleBuilder.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Literal',
                                value: 0
                            },
                            loc: {
                                start: {
                                    line: 32,
                                    column: 16,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                },
                                end: {
                                    line: 32,
                                    column: 25,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'output',
                            loc: {
                                start: {
                                    line: 33,
                                    column: 8,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                },
                                end: {
                                    line: 33,
                                    column: 14,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                }
                            }
                        },
                        init: {
                            type: 'NewExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Directory',
                                loc: {
                                    start: {
                                        line: 33,
                                        column: 21,
                                        fixed: true,
                                        source: 'ion/builder/ModuleBuilder.ion'
                                    },
                                    end: {
                                        line: 33,
                                        column: 30,
                                        fixed: true,
                                        source: 'ion/builder/ModuleBuilder.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ConditionalExpression',
                                    test: {
                                        type: 'BinaryExpression',
                                        operator: '!=',
                                        left: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'packageJson',
                                                    loc: {
                                                        start: {
                                                            line: 33,
                                                            column: 31,
                                                            fixed: true,
                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 33,
                                                            column: 42,
                                                            fixed: true,
                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'directories',
                                                    loc: {
                                                        start: {
                                                            line: 33,
                                                            column: 43,
                                                            fixed: true,
                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 33,
                                                            column: 54,
                                                            fixed: true,
                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 33,
                                                        column: 31,
                                                        fixed: true,
                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                    },
                                                    end: {
                                                        line: 33,
                                                        column: 54,
                                                        fixed: true,
                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'lib',
                                                loc: {
                                                    start: {
                                                        line: 33,
                                                        column: 55,
                                                        fixed: true,
                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                    },
                                                    end: {
                                                        line: 33,
                                                        column: 58,
                                                        fixed: true,
                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 33,
                                                    column: 31,
                                                    fixed: true,
                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                },
                                                end: {
                                                    line: 33,
                                                    column: 58,
                                                    fixed: true,
                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                }
                                            }
                                        },
                                        right: {
                                            type: 'Literal',
                                            value: null
                                        }
                                    },
                                    consequent: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'packageJson',
                                                loc: {
                                                    start: {
                                                        line: 33,
                                                        column: 31,
                                                        fixed: true,
                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                    },
                                                    end: {
                                                        line: 33,
                                                        column: 42,
                                                        fixed: true,
                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'directories',
                                                loc: {
                                                    start: {
                                                        line: 33,
                                                        column: 43,
                                                        fixed: true,
                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                    },
                                                    end: {
                                                        line: 33,
                                                        column: 54,
                                                        fixed: true,
                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 33,
                                                    column: 31,
                                                    fixed: true,
                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                },
                                                end: {
                                                    line: 33,
                                                    column: 54,
                                                    fixed: true,
                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'lib',
                                            loc: {
                                                start: {
                                                    line: 33,
                                                    column: 55,
                                                    fixed: true,
                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                },
                                                end: {
                                                    line: 33,
                                                    column: 58,
                                                    fixed: true,
                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 33,
                                                column: 31,
                                                fixed: true,
                                                source: 'ion/builder/ModuleBuilder.ion'
                                            },
                                            end: {
                                                line: 33,
                                                column: 58,
                                                fixed: true,
                                                source: 'ion/builder/ModuleBuilder.ion'
                                            }
                                        }
                                    },
                                    alternate: {
                                        type: 'Literal',
                                        value: 'lib'
                                    }
                                }],
                            loc: {
                                start: {
                                    line: 33,
                                    column: 17,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                },
                                end: {
                                    line: 33,
                                    column: 67,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '3'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'moduleName',
                            loc: {
                                start: {
                                    line: 34,
                                    column: 8,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                },
                                end: {
                                    line: 34,
                                    column: 18,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ConditionalExpression',
                            test: {
                                type: 'BinaryExpression',
                                operator: '!=',
                                left: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'packageJson',
                                        loc: {
                                            start: {
                                                line: 34,
                                                column: 21,
                                                fixed: true,
                                                source: 'ion/builder/ModuleBuilder.ion'
                                            },
                                            end: {
                                                line: 34,
                                                column: 32,
                                                fixed: true,
                                                source: 'ion/builder/ModuleBuilder.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'name',
                                        loc: {
                                            start: {
                                                line: 34,
                                                column: 33,
                                                fixed: true,
                                                source: 'ion/builder/ModuleBuilder.ion'
                                            },
                                            end: {
                                                line: 34,
                                                column: 37,
                                                fixed: true,
                                                source: 'ion/builder/ModuleBuilder.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 34,
                                            column: 21,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        },
                                        end: {
                                            line: 34,
                                            column: 37,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: null
                                }
                            },
                            consequent: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'packageJson',
                                    loc: {
                                        start: {
                                            line: 34,
                                            column: 21,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        },
                                        end: {
                                            line: 34,
                                            column: 32,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'name',
                                    loc: {
                                        start: {
                                            line: 34,
                                            column: 33,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        },
                                        end: {
                                            line: 34,
                                            column: 37,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 34,
                                        column: 21,
                                        fixed: true,
                                        source: 'ion/builder/ModuleBuilder.ion'
                                    },
                                    end: {
                                        line: 34,
                                        column: 37,
                                        fixed: true,
                                        source: 'ion/builder/ModuleBuilder.ion'
                                    }
                                }
                            },
                            alternate: {
                                type: 'Literal',
                                value: ''
                            }
                        }
                    }],
                kind: 'let',
                order: '4'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'extensions',
                            loc: {
                                start: {
                                    line: 37,
                                    column: 8,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                },
                                end: {
                                    line: 37,
                                    column: 18,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'Object',
                                    loc: {
                                        start: {
                                            line: 37,
                                            column: 21,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        },
                                        end: {
                                            line: 37,
                                            column: 27,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'keys',
                                    loc: {
                                        start: {
                                            line: 37,
                                            column: 28,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        },
                                        end: {
                                            line: 37,
                                            column: 32,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 37,
                                        column: 21,
                                        fixed: true,
                                        source: 'ion/builder/ModuleBuilder.ion'
                                    },
                                    end: {
                                        line: 37,
                                        column: 32,
                                        fixed: true,
                                        source: 'ion/builder/ModuleBuilder.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'Identifier',
                                    name: 'compilers',
                                    loc: {
                                        start: {
                                            line: 37,
                                            column: 33,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        },
                                        end: {
                                            line: 37,
                                            column: 42,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        }
                                    }
                                }],
                            loc: {
                                start: {
                                    line: 37,
                                    column: 21,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                },
                                end: {
                                    line: 37,
                                    column: 43,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '5'
            },
            {
                type: 'ForOfStatement',
                left: {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'thisInput',
                                loc: {
                                    start: {
                                        line: 38,
                                        column: 8,
                                        fixed: true,
                                        source: 'ion/builder/ModuleBuilder.ion'
                                    },
                                    end: {
                                        line: 38,
                                        column: 17,
                                        fixed: true,
                                        source: 'ion/builder/ModuleBuilder.ion'
                                    }
                                }
                            },
                            init: null
                        }],
                    kind: 'let'
                },
                right: {
                    type: 'Identifier',
                    name: 'inputs',
                    loc: {
                        start: {
                            line: 38,
                            column: 21,
                            fixed: true,
                            source: 'ion/builder/ModuleBuilder.ion'
                        },
                        end: {
                            line: 38,
                            column: 27,
                            fixed: true,
                            source: 'ion/builder/ModuleBuilder.ion'
                        }
                    }
                },
                body: {
                    type: 'BlockStatement',
                    body: [{
                            type: 'ForInStatement',
                            left: {
                                type: 'VariableDeclaration',
                                declarations: [
                                    {
                                        type: 'VariableDeclarator',
                                        id: {
                                            type: 'Identifier',
                                            name: 'path',
                                            loc: {
                                                start: {
                                                    line: 39,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                },
                                                end: {
                                                    line: 39,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                }
                                            }
                                        },
                                        init: null
                                    },
                                    {
                                        type: 'VariableDeclarator',
                                        id: {
                                            type: 'Identifier',
                                            name: 'source',
                                            loc: {
                                                start: {
                                                    line: 39,
                                                    column: 18,
                                                    fixed: true,
                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                },
                                                end: {
                                                    line: 39,
                                                    column: 24,
                                                    fixed: true,
                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                }
                                            }
                                        },
                                        init: null
                                    }
                                ],
                                kind: 'let'
                            },
                            right: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'thisInput',
                                        loc: {
                                            start: {
                                                line: 39,
                                                column: 28,
                                                fixed: true,
                                                source: 'ion/builder/ModuleBuilder.ion'
                                            },
                                            end: {
                                                line: 39,
                                                column: 37,
                                                fixed: true,
                                                source: 'ion/builder/ModuleBuilder.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'search',
                                        loc: {
                                            start: {
                                                line: 39,
                                                column: 38,
                                                fixed: true,
                                                source: 'ion/builder/ModuleBuilder.ion'
                                            },
                                            end: {
                                                line: 39,
                                                column: 44,
                                                fixed: true,
                                                source: 'ion/builder/ModuleBuilder.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 39,
                                            column: 28,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        },
                                        end: {
                                            line: 39,
                                            column: 44,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        }
                                    }
                                },
                                arguments: [
                                    {
                                        type: 'Identifier',
                                        name: 'extensions',
                                        loc: {
                                            start: {
                                                line: 39,
                                                column: 45,
                                                fixed: true,
                                                source: 'ion/builder/ModuleBuilder.ion'
                                            },
                                            end: {
                                                line: 39,
                                                column: 55,
                                                fixed: true,
                                                source: 'ion/builder/ModuleBuilder.ion'
                                            }
                                        }
                                    },
                                    {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'packageJson',
                                                loc: {
                                                    start: {
                                                        line: 39,
                                                        column: 57,
                                                        fixed: true,
                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                    },
                                                    end: {
                                                        line: 39,
                                                        column: 68,
                                                        fixed: true,
                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'build',
                                                loc: {
                                                    start: {
                                                        line: 39,
                                                        column: 69,
                                                        fixed: true,
                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                    },
                                                    end: {
                                                        line: 39,
                                                        column: 74,
                                                        fixed: true,
                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 39,
                                                    column: 57,
                                                    fixed: true,
                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                },
                                                end: {
                                                    line: 39,
                                                    column: 74,
                                                    fixed: true,
                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'exclude',
                                            loc: {
                                                start: {
                                                    line: 39,
                                                    column: 75,
                                                    fixed: true,
                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                },
                                                end: {
                                                    line: 39,
                                                    column: 82,
                                                    fixed: true,
                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 39,
                                                column: 57,
                                                fixed: true,
                                                source: 'ion/builder/ModuleBuilder.ion'
                                            },
                                            end: {
                                                line: 39,
                                                column: 82,
                                                fixed: true,
                                                source: 'ion/builder/ModuleBuilder.ion'
                                            }
                                        }
                                    }
                                ],
                                loc: {
                                    start: {
                                        line: 39,
                                        column: 28,
                                        fixed: true,
                                        source: 'ion/builder/ModuleBuilder.ion'
                                    },
                                    end: {
                                        line: 39,
                                        column: 83,
                                        fixed: true,
                                        source: 'ion/builder/ModuleBuilder.ion'
                                    }
                                }
                            },
                            body: {
                                type: 'BlockStatement',
                                body: [{
                                        type: 'IfStatement',
                                        test: {
                                            type: 'UnaryExpression',
                                            operator: '!',
                                            argument: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'source',
                                                    loc: {
                                                        start: {
                                                            line: 40,
                                                            column: 19,
                                                            fixed: true,
                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 40,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'isDirectory',
                                                    loc: {
                                                        start: {
                                                            line: 40,
                                                            column: 26,
                                                            fixed: true,
                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 40,
                                                            column: 37,
                                                            fixed: true,
                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 40,
                                                        column: 19,
                                                        fixed: true,
                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                    },
                                                    end: {
                                                        line: 40,
                                                        column: 37,
                                                        fixed: true,
                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                    }
                                                }
                                            }
                                        },
                                        consequent: {
                                            type: 'BlockStatement',
                                            body: [
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'compiler',
                                                                loc: {
                                                                    start: {
                                                                        line: 41,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 41,
                                                                        column: 28,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'MemberExpression',
                                                                computed: true,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'compilers',
                                                                    loc: {
                                                                        start: {
                                                                            line: 41,
                                                                            column: 31,
                                                                            fixed: true,
                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                        },
                                                                        end: {
                                                                            line: 41,
                                                                            column: 40,
                                                                            fixed: true,
                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'source',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 41,
                                                                                    column: 41,
                                                                                    fixed: true,
                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 41,
                                                                                    column: 47,
                                                                                    fixed: true,
                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'getExtension',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 41,
                                                                                    column: 48,
                                                                                    fixed: true,
                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 41,
                                                                                    column: 60,
                                                                                    fixed: true,
                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 41,
                                                                                column: 41,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            },
                                                                            end: {
                                                                                line: 41,
                                                                                column: 60,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [],
                                                                    loc: {
                                                                        start: {
                                                                            line: 41,
                                                                            column: 41,
                                                                            fixed: true,
                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                        },
                                                                        end: {
                                                                            line: 41,
                                                                            column: 62,
                                                                            fixed: true,
                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 41,
                                                                        column: 31,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 41,
                                                                        column: 63,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'targetPath',
                                                                loc: {
                                                                    start: {
                                                                        line: 42,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 42,
                                                                        column: 30,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'builder',
                                                                        loc: {
                                                                            start: {
                                                                                line: 42,
                                                                                column: 33,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            },
                                                                            end: {
                                                                                line: 42,
                                                                                column: 40,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'changeExtension',
                                                                        loc: {
                                                                            start: {
                                                                                line: 42,
                                                                                column: 41,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            },
                                                                            end: {
                                                                                line: 42,
                                                                                column: 56,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 42,
                                                                            column: 33,
                                                                            fixed: true,
                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                        },
                                                                        end: {
                                                                            line: 42,
                                                                            column: 56,
                                                                            fixed: true,
                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [
                                                                    {
                                                                        type: 'Identifier',
                                                                        name: 'path',
                                                                        loc: {
                                                                            start: {
                                                                                line: 42,
                                                                                column: 57,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            },
                                                                            end: {
                                                                                line: 42,
                                                                                column: 61,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    {
                                                                        type: 'Literal',
                                                                        value: '.js'
                                                                    }
                                                                ],
                                                                loc: {
                                                                    start: {
                                                                        line: 42,
                                                                        column: 33,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 42,
                                                                        column: 69,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '1'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'outputFile',
                                                                loc: {
                                                                    start: {
                                                                        line: 43,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 43,
                                                                        column: 30,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'output',
                                                                        loc: {
                                                                            start: {
                                                                                line: 43,
                                                                                column: 33,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            },
                                                                            end: {
                                                                                line: 43,
                                                                                column: 39,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'getFile',
                                                                        loc: {
                                                                            start: {
                                                                                line: 43,
                                                                                column: 40,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            },
                                                                            end: {
                                                                                line: 43,
                                                                                column: 47,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 43,
                                                                            column: 33,
                                                                            fixed: true,
                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                        },
                                                                        end: {
                                                                            line: 43,
                                                                            column: 47,
                                                                            fixed: true,
                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'Identifier',
                                                                        name: 'targetPath',
                                                                        loc: {
                                                                            start: {
                                                                                line: 43,
                                                                                column: 48,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            },
                                                                            end: {
                                                                                line: 43,
                                                                                column: 58,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            }
                                                                        }
                                                                    }],
                                                                loc: {
                                                                    start: {
                                                                        line: 43,
                                                                        column: 33,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 43,
                                                                        column: 59,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '2'
                                                },
                                                {
                                                    type: 'IfStatement',
                                                    test: {
                                                        type: 'BinaryExpression',
                                                        operator: '>',
                                                        left: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'source',
                                                                loc: {
                                                                    start: {
                                                                        line: 44,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 44,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'modified',
                                                                loc: {
                                                                    start: {
                                                                        line: 44,
                                                                        column: 26,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 44,
                                                                        column: 34,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 44,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                },
                                                                end: {
                                                                    line: 44,
                                                                    column: 34,
                                                                    fixed: true,
                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                }
                                                            }
                                                        },
                                                        right: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'outputFile',
                                                                loc: {
                                                                    start: {
                                                                        line: 44,
                                                                        column: 37,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 44,
                                                                        column: 47,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'modified',
                                                                loc: {
                                                                    start: {
                                                                        line: 44,
                                                                        column: 48,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 44,
                                                                        column: 56,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 44,
                                                                    column: 37,
                                                                    fixed: true,
                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                },
                                                                end: {
                                                                    line: 44,
                                                                    column: 56,
                                                                    fixed: true,
                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                }
                                                            }
                                                        }
                                                    },
                                                    consequent: {
                                                        type: 'BlockStatement',
                                                        body: [{
                                                                type: 'IfStatement',
                                                                test: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'source',
                                                                        loc: {
                                                                            start: {
                                                                                line: 52,
                                                                                column: 23,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            },
                                                                            end: {
                                                                                line: 52,
                                                                                column: 29,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'exists',
                                                                        loc: {
                                                                            start: {
                                                                                line: 52,
                                                                                column: 30,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            },
                                                                            end: {
                                                                                line: 52,
                                                                                column: 36,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 52,
                                                                            column: 23,
                                                                            fixed: true,
                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                        },
                                                                        end: {
                                                                            line: 52,
                                                                            column: 36,
                                                                            fixed: true,
                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                        }
                                                                    }
                                                                },
                                                                consequent: {
                                                                    type: 'BlockStatement',
                                                                    body: [{
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'UnaryExpression',
                                                                                operator: 'void',
                                                                                argument: {
                                                                                    type: 'CallExpression',
                                                                                    callee: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'output',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 53,
                                                                                                    column: 29,
                                                                                                    fixed: true,
                                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 53,
                                                                                                    column: 35,
                                                                                                    fixed: true,
                                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'write',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 53,
                                                                                                    column: 36,
                                                                                                    fixed: true,
                                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 53,
                                                                                                    column: 41,
                                                                                                    fixed: true,
                                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 53,
                                                                                                column: 29,
                                                                                                fixed: true,
                                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 53,
                                                                                                column: 41,
                                                                                                fixed: true,
                                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    arguments: [
                                                                                        {
                                                                                            type: 'Identifier',
                                                                                            name: 'targetPath',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 53,
                                                                                                    column: 42,
                                                                                                    fixed: true,
                                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 53,
                                                                                                    column: 52,
                                                                                                    fixed: true,
                                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        {
                                                                                            type: 'CallExpression',
                                                                                            callee: {
                                                                                                type: 'MemberExpression',
                                                                                                computed: false,
                                                                                                object: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'compiler',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 53,
                                                                                                            column: 54,
                                                                                                            fixed: true,
                                                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 53,
                                                                                                            column: 62,
                                                                                                            fixed: true,
                                                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'compile',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 53,
                                                                                                            column: 63,
                                                                                                            fixed: true,
                                                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 53,
                                                                                                            column: 70,
                                                                                                            fixed: true,
                                                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 53,
                                                                                                        column: 54,
                                                                                                        fixed: true,
                                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 53,
                                                                                                        column: 70,
                                                                                                        fixed: true,
                                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            arguments: [
                                                                                                {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'source',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 53,
                                                                                                            column: 71,
                                                                                                            fixed: true,
                                                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 53,
                                                                                                            column: 77,
                                                                                                            fixed: true,
                                                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'packageJson',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 53,
                                                                                                            column: 79,
                                                                                                            fixed: true,
                                                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 53,
                                                                                                            column: 90,
                                                                                                            fixed: true,
                                                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                                                        }
                                                                                                    }
                                                                                                }
                                                                                            ],
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 53,
                                                                                                    column: 54,
                                                                                                    fixed: true,
                                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 53,
                                                                                                    column: 91,
                                                                                                    fixed: true,
                                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        {
                                                                                            type: 'ObjectExpression',
                                                                                            properties: [{
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'force',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 53,
                                                                                                                column: 94,
                                                                                                                fixed: true,
                                                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 53,
                                                                                                                column: 99,
                                                                                                                fixed: true,
                                                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'Literal',
                                                                                                        value: true
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '0'
                                                                                                }]
                                                                                        }
                                                                                    ],
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 53,
                                                                                            column: 29,
                                                                                            fixed: true,
                                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 53,
                                                                                            column: 106,
                                                                                            fixed: true,
                                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                                        }
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 53,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 53,
                                                                                    column: 106,
                                                                                    fixed: true,
                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                alternate: {
                                                                    type: 'BlockStatement',
                                                                    body: [{
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'UnaryExpression',
                                                                                operator: 'void',
                                                                                argument: {
                                                                                    type: 'CallExpression',
                                                                                    callee: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'output',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 55,
                                                                                                    column: 29,
                                                                                                    fixed: true,
                                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 55,
                                                                                                    column: 35,
                                                                                                    fixed: true,
                                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'delete',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 55,
                                                                                                    column: 36,
                                                                                                    fixed: true,
                                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 55,
                                                                                                    column: 42,
                                                                                                    fixed: true,
                                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 55,
                                                                                                column: 29,
                                                                                                fixed: true,
                                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 55,
                                                                                                column: 42,
                                                                                                fixed: true,
                                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    arguments: [{
                                                                                            type: 'Identifier',
                                                                                            name: 'targetPath',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 55,
                                                                                                    column: 43,
                                                                                                    fixed: true,
                                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 55,
                                                                                                    column: 53,
                                                                                                    fixed: true,
                                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                                }
                                                                                            }
                                                                                        }],
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 55,
                                                                                            column: 29,
                                                                                            fixed: true,
                                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 55,
                                                                                            column: 54,
                                                                                            fixed: true,
                                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                                        }
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 55,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 55,
                                                                                    column: 54,
                                                                                    fixed: true,
                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    alternate: null,
                                                    order: '3'
                                                }
                                            ]
                                        },
                                        alternate: null,
                                        order: '0'
                                    }]
                            },
                            remove: null,
                            order: '0'
                        }]
                },
                remove: null,
                order: '6'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'potentialIndexDirectories',
                            loc: {
                                start: {
                                    line: 58,
                                    column: 8,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                },
                                end: {
                                    line: 58,
                                    column: 33,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'input',
                                        loc: {
                                            start: {
                                                line: 58,
                                                column: 36,
                                                fixed: true,
                                                source: 'ion/builder/ModuleBuilder.ion'
                                            },
                                            end: {
                                                line: 58,
                                                column: 41,
                                                fixed: true,
                                                source: 'ion/builder/ModuleBuilder.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'search',
                                        loc: {
                                            start: {
                                                line: 58,
                                                column: 42,
                                                fixed: true,
                                                source: 'ion/builder/ModuleBuilder.ion'
                                            },
                                            end: {
                                                line: 58,
                                                column: 48,
                                                fixed: true,
                                                source: 'ion/builder/ModuleBuilder.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 58,
                                            column: 36,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        },
                                        end: {
                                            line: 58,
                                            column: 48,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        }
                                    }
                                },
                                arguments: [
                                    {
                                        type: 'Literal',
                                        value: null
                                    },
                                    {
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'extensions',
                                                loc: {
                                                    start: {
                                                        line: 58,
                                                        column: 55,
                                                        fixed: true,
                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                    },
                                                    end: {
                                                        line: 58,
                                                        column: 65,
                                                        fixed: true,
                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'concat',
                                                loc: {
                                                    start: {
                                                        line: 58,
                                                        column: 66,
                                                        fixed: true,
                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                    },
                                                    end: {
                                                        line: 58,
                                                        column: 72,
                                                        fixed: true,
                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 58,
                                                    column: 55,
                                                    fixed: true,
                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                },
                                                end: {
                                                    line: 58,
                                                    column: 72,
                                                    fixed: true,
                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                }
                                            }
                                        },
                                        arguments: [{
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'packageJson',
                                                        loc: {
                                                            start: {
                                                                line: 58,
                                                                column: 73,
                                                                fixed: true,
                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                            },
                                                            end: {
                                                                line: 58,
                                                                column: 84,
                                                                fixed: true,
                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'build',
                                                        loc: {
                                                            start: {
                                                                line: 58,
                                                                column: 85,
                                                                fixed: true,
                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                            },
                                                            end: {
                                                                line: 58,
                                                                column: 90,
                                                                fixed: true,
                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 58,
                                                            column: 73,
                                                            fixed: true,
                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 58,
                                                            column: 90,
                                                            fixed: true,
                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'exclude',
                                                    loc: {
                                                        start: {
                                                            line: 58,
                                                            column: 91,
                                                            fixed: true,
                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 58,
                                                            column: 98,
                                                            fixed: true,
                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 58,
                                                        column: 73,
                                                        fixed: true,
                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                    },
                                                    end: {
                                                        line: 58,
                                                        column: 98,
                                                        fixed: true,
                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                    }
                                                }
                                            }],
                                        loc: {
                                            start: {
                                                line: 58,
                                                column: 55,
                                                fixed: true,
                                                source: 'ion/builder/ModuleBuilder.ion'
                                            },
                                            end: {
                                                line: 58,
                                                column: 99,
                                                fixed: true,
                                                source: 'ion/builder/ModuleBuilder.ion'
                                            }
                                        }
                                    }
                                ],
                                loc: {
                                    start: {
                                        line: 58,
                                        column: 36,
                                        fixed: true,
                                        source: 'ion/builder/ModuleBuilder.ion'
                                    },
                                    end: {
                                        line: 58,
                                        column: 100,
                                        fixed: true,
                                        source: 'ion/builder/ModuleBuilder.ion'
                                    }
                                }
                            },
                            properties: [{
                                    type: 'Property',
                                    key: {
                                        type: 'Literal',
                                        value: '.'
                                    },
                                    value: {
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'input',
                                                loc: {
                                                    start: {
                                                        line: 59,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                    },
                                                    end: {
                                                        line: 59,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'getFile',
                                                loc: {
                                                    start: {
                                                        line: 59,
                                                        column: 21,
                                                        fixed: true,
                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                    },
                                                    end: {
                                                        line: 59,
                                                        column: 28,
                                                        fixed: true,
                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 59,
                                                    column: 15,
                                                    fixed: true,
                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                },
                                                end: {
                                                    line: 59,
                                                    column: 28,
                                                    fixed: true,
                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                }
                                            }
                                        },
                                        arguments: [{
                                                type: 'Literal',
                                                value: '.'
                                            }],
                                        loc: {
                                            start: {
                                                line: 59,
                                                column: 15,
                                                fixed: true,
                                                source: 'ion/builder/ModuleBuilder.ion'
                                            },
                                            end: {
                                                line: 59,
                                                column: 33,
                                                fixed: true,
                                                source: 'ion/builder/ModuleBuilder.ion'
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    computed: true,
                                    order: '0'
                                }]
                        }
                    }],
                kind: 'let',
                order: '7'
            },
            {
                type: 'ForInStatement',
                left: {
                    type: 'VariableDeclaration',
                    declarations: [
                        {
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'path',
                                loc: {
                                    start: {
                                        line: 60,
                                        column: 8,
                                        fixed: true,
                                        source: 'ion/builder/ModuleBuilder.ion'
                                    },
                                    end: {
                                        line: 60,
                                        column: 12,
                                        fixed: true,
                                        source: 'ion/builder/ModuleBuilder.ion'
                                    }
                                }
                            },
                            init: null
                        },
                        {
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'file',
                                loc: {
                                    start: {
                                        line: 60,
                                        column: 14,
                                        fixed: true,
                                        source: 'ion/builder/ModuleBuilder.ion'
                                    },
                                    end: {
                                        line: 60,
                                        column: 18,
                                        fixed: true,
                                        source: 'ion/builder/ModuleBuilder.ion'
                                    }
                                }
                            },
                            init: null
                        }
                    ],
                    kind: 'let'
                },
                right: {
                    type: 'Identifier',
                    name: 'potentialIndexDirectories',
                    loc: {
                        start: {
                            line: 60,
                            column: 22,
                            fixed: true,
                            source: 'ion/builder/ModuleBuilder.ion'
                        },
                        end: {
                            line: 60,
                            column: 47,
                            fixed: true,
                            source: 'ion/builder/ModuleBuilder.ion'
                        }
                    }
                },
                body: {
                    type: 'BlockStatement',
                    body: [{
                            type: 'IfStatement',
                            test: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'file',
                                    loc: {
                                        start: {
                                            line: 61,
                                            column: 11,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        },
                                        end: {
                                            line: 61,
                                            column: 15,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'isDirectory',
                                    loc: {
                                        start: {
                                            line: 61,
                                            column: 16,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        },
                                        end: {
                                            line: 61,
                                            column: 27,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 61,
                                        column: 11,
                                        fixed: true,
                                        source: 'ion/builder/ModuleBuilder.ion'
                                    },
                                    end: {
                                        line: 61,
                                        column: 27,
                                        fixed: true,
                                        source: 'ion/builder/ModuleBuilder.ion'
                                    }
                                }
                            },
                            consequent: {
                                type: 'BlockStatement',
                                body: [
                                    {
                                        type: 'VariableDeclaration',
                                        declarations: [{
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'isInputFile',
                                                    loc: {
                                                        start: {
                                                            line: 63,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 63,
                                                            column: 27,
                                                            fixed: true,
                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                        }
                                                    }
                                                },
                                                init: {
                                                    type: 'BinaryExpression',
                                                    operator: '||',
                                                    left: {
                                                        type: 'BinaryExpression',
                                                        operator: '||',
                                                        left: {
                                                            type: 'BinaryExpression',
                                                            operator: '||',
                                                            left: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'input',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 63,
                                                                                    column: 30,
                                                                                    fixed: true,
                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 63,
                                                                                    column: 35,
                                                                                    fixed: true,
                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'getFile',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 63,
                                                                                    column: 36,
                                                                                    fixed: true,
                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 63,
                                                                                    column: 43,
                                                                                    fixed: true,
                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 63,
                                                                                column: 30,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            },
                                                                            end: {
                                                                                line: 63,
                                                                                column: 43,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [{
                                                                            type: 'BinaryExpression',
                                                                            operator: '+',
                                                                            left: {
                                                                                type: 'Identifier',
                                                                                name: 'path',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 63,
                                                                                        column: 44,
                                                                                        fixed: true,
                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 63,
                                                                                        column: 48,
                                                                                        fixed: true,
                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            right: {
                                                                                type: 'Literal',
                                                                                value: '/index.js'
                                                                            }
                                                                        }],
                                                                    loc: {
                                                                        start: {
                                                                            line: 63,
                                                                            column: 30,
                                                                            fixed: true,
                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                        },
                                                                        end: {
                                                                            line: 63,
                                                                            column: 63,
                                                                            fixed: true,
                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'exists',
                                                                    loc: {
                                                                        start: {
                                                                            line: 63,
                                                                            column: 64,
                                                                            fixed: true,
                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                        },
                                                                        end: {
                                                                            line: 63,
                                                                            column: 70,
                                                                            fixed: true,
                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 63,
                                                                        column: 30,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 63,
                                                                        column: 70,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    }
                                                                }
                                                            },
                                                            right: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'input',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 63,
                                                                                    column: 74,
                                                                                    fixed: true,
                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 63,
                                                                                    column: 79,
                                                                                    fixed: true,
                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'getFile',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 63,
                                                                                    column: 80,
                                                                                    fixed: true,
                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 63,
                                                                                    column: 87,
                                                                                    fixed: true,
                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 63,
                                                                                column: 74,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            },
                                                                            end: {
                                                                                line: 63,
                                                                                column: 87,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [{
                                                                            type: 'BinaryExpression',
                                                                            operator: '+',
                                                                            left: {
                                                                                type: 'Identifier',
                                                                                name: 'path',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 63,
                                                                                        column: 88,
                                                                                        fixed: true,
                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 63,
                                                                                        column: 92,
                                                                                        fixed: true,
                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            right: {
                                                                                type: 'Literal',
                                                                                value: '/index.ion'
                                                                            }
                                                                        }],
                                                                    loc: {
                                                                        start: {
                                                                            line: 63,
                                                                            column: 74,
                                                                            fixed: true,
                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                        },
                                                                        end: {
                                                                            line: 63,
                                                                            column: 108,
                                                                            fixed: true,
                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'exists',
                                                                    loc: {
                                                                        start: {
                                                                            line: 63,
                                                                            column: 109,
                                                                            fixed: true,
                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                        },
                                                                        end: {
                                                                            line: 63,
                                                                            column: 115,
                                                                            fixed: true,
                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 63,
                                                                        column: 74,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 63,
                                                                        column: 115,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    }
                                                                }
                                                            }
                                                        },
                                                        right: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'input',
                                                                        loc: {
                                                                            start: {
                                                                                line: 63,
                                                                                column: 119,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            },
                                                                            end: {
                                                                                line: 63,
                                                                                column: 124,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'getFile',
                                                                        loc: {
                                                                            start: {
                                                                                line: 63,
                                                                                column: 125,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            },
                                                                            end: {
                                                                                line: 63,
                                                                                column: 132,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 63,
                                                                            column: 119,
                                                                            fixed: true,
                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                        },
                                                                        end: {
                                                                            line: 63,
                                                                            column: 132,
                                                                            fixed: true,
                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'BinaryExpression',
                                                                        operator: '+',
                                                                        left: {
                                                                            type: 'Identifier',
                                                                            name: 'path',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 63,
                                                                                    column: 133,
                                                                                    fixed: true,
                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 63,
                                                                                    column: 137,
                                                                                    fixed: true,
                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        right: {
                                                                            type: 'Literal',
                                                                            value: '/index.coffee'
                                                                        }
                                                                    }],
                                                                loc: {
                                                                    start: {
                                                                        line: 63,
                                                                        column: 119,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 63,
                                                                        column: 156,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'exists',
                                                                loc: {
                                                                    start: {
                                                                        line: 63,
                                                                        column: 157,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 63,
                                                                        column: 163,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 63,
                                                                    column: 119,
                                                                    fixed: true,
                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                },
                                                                end: {
                                                                    line: 63,
                                                                    column: 163,
                                                                    fixed: true,
                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                }
                                                            }
                                                        }
                                                    },
                                                    right: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'input',
                                                                    loc: {
                                                                        start: {
                                                                            line: 63,
                                                                            column: 167,
                                                                            fixed: true,
                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                        },
                                                                        end: {
                                                                            line: 63,
                                                                            column: 172,
                                                                            fixed: true,
                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'getFile',
                                                                    loc: {
                                                                        start: {
                                                                            line: 63,
                                                                            column: 173,
                                                                            fixed: true,
                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                        },
                                                                        end: {
                                                                            line: 63,
                                                                            column: 180,
                                                                            fixed: true,
                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 63,
                                                                        column: 167,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 63,
                                                                        column: 180,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [{
                                                                    type: 'BinaryExpression',
                                                                    operator: '+',
                                                                    left: {
                                                                        type: 'Identifier',
                                                                        name: 'path',
                                                                        loc: {
                                                                            start: {
                                                                                line: 63,
                                                                                column: 181,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            },
                                                                            end: {
                                                                                line: 63,
                                                                                column: 185,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    right: {
                                                                        type: 'Literal',
                                                                        value: '/index.ts'
                                                                    }
                                                                }],
                                                            loc: {
                                                                start: {
                                                                    line: 63,
                                                                    column: 167,
                                                                    fixed: true,
                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                },
                                                                end: {
                                                                    line: 63,
                                                                    column: 200,
                                                                    fixed: true,
                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'exists',
                                                            loc: {
                                                                start: {
                                                                    line: 63,
                                                                    column: 201,
                                                                    fixed: true,
                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                },
                                                                end: {
                                                                    line: 63,
                                                                    column: 207,
                                                                    fixed: true,
                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 63,
                                                                column: 167,
                                                                fixed: true,
                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                            },
                                                            end: {
                                                                line: 63,
                                                                column: 207,
                                                                fixed: true,
                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                            }
                                                        }
                                                    }
                                                }
                                            }],
                                        kind: 'let',
                                        order: '0'
                                    },
                                    {
                                        type: 'IfStatement',
                                        test: {
                                            type: 'UnaryExpression',
                                            operator: '!',
                                            argument: {
                                                type: 'Identifier',
                                                name: 'isInputFile',
                                                loc: {
                                                    start: {
                                                        line: 64,
                                                        column: 19,
                                                        fixed: true,
                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                    },
                                                    end: {
                                                        line: 64,
                                                        column: 30,
                                                        fixed: true,
                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                    }
                                                }
                                            }
                                        },
                                        consequent: {
                                            type: 'BlockStatement',
                                            body: [
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'indexDirectory',
                                                                loc: {
                                                                    start: {
                                                                        line: 66,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 66,
                                                                        column: 34,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'output',
                                                                        loc: {
                                                                            start: {
                                                                                line: 66,
                                                                                column: 37,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            },
                                                                            end: {
                                                                                line: 66,
                                                                                column: 43,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'getDirectory',
                                                                        loc: {
                                                                            start: {
                                                                                line: 66,
                                                                                column: 44,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            },
                                                                            end: {
                                                                                line: 66,
                                                                                column: 56,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 66,
                                                                            column: 37,
                                                                            fixed: true,
                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                        },
                                                                        end: {
                                                                            line: 66,
                                                                            column: 56,
                                                                            fixed: true,
                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'Identifier',
                                                                        name: 'path',
                                                                        loc: {
                                                                            start: {
                                                                                line: 66,
                                                                                column: 57,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            },
                                                                            end: {
                                                                                line: 66,
                                                                                column: 61,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            }
                                                                        }
                                                                    }],
                                                                loc: {
                                                                    start: {
                                                                        line: 66,
                                                                        column: 37,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 66,
                                                                        column: 62,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'indexName',
                                                                loc: {
                                                                    start: {
                                                                        line: 67,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 67,
                                                                        column: 29,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'Literal',
                                                                value: 'index.js'
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '1'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'indexFile',
                                                                loc: {
                                                                    start: {
                                                                        line: 68,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 68,
                                                                        column: 29,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'indexDirectory',
                                                                        loc: {
                                                                            start: {
                                                                                line: 68,
                                                                                column: 32,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            },
                                                                            end: {
                                                                                line: 68,
                                                                                column: 46,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'getFile',
                                                                        loc: {
                                                                            start: {
                                                                                line: 68,
                                                                                column: 47,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            },
                                                                            end: {
                                                                                line: 68,
                                                                                column: 54,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 68,
                                                                            column: 32,
                                                                            fixed: true,
                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                        },
                                                                        end: {
                                                                            line: 68,
                                                                            column: 54,
                                                                            fixed: true,
                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'Identifier',
                                                                        name: 'indexName',
                                                                        loc: {
                                                                            start: {
                                                                                line: 68,
                                                                                column: 55,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            },
                                                                            end: {
                                                                                line: 68,
                                                                                column: 64,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            }
                                                                        }
                                                                    }],
                                                                loc: {
                                                                    start: {
                                                                        line: 68,
                                                                        column: 32,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 68,
                                                                        column: 65,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '2'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'lines',
                                                                loc: {
                                                                    start: {
                                                                        line: 70,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 70,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'ObjectExpression',
                                                                objectType: {
                                                                    type: 'ObjectExpression',
                                                                    properties: []
                                                                },
                                                                properties: [{
                                                                        type: 'ForInStatement',
                                                                        left: {
                                                                            type: 'VariableDeclaration',
                                                                            declarations: [
                                                                                {
                                                                                    type: 'VariableDeclarator',
                                                                                    id: {
                                                                                        type: 'Identifier',
                                                                                        name: 'key',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 71,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 71,
                                                                                                column: 27,
                                                                                                fixed: true,
                                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    init: null
                                                                                },
                                                                                {
                                                                                    type: 'VariableDeclarator',
                                                                                    id: {
                                                                                        type: 'Identifier',
                                                                                        name: 'childFile',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 71,
                                                                                                column: 29,
                                                                                                fixed: true,
                                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 71,
                                                                                                column: 38,
                                                                                                fixed: true,
                                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    init: null
                                                                                }
                                                                            ],
                                                                            kind: 'let'
                                                                        },
                                                                        right: {
                                                                            type: 'CallExpression',
                                                                            callee: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'Identifier',
                                                                                    name: 'indexDirectory',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 71,
                                                                                            column: 42,
                                                                                            fixed: true,
                                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 71,
                                                                                            column: 56,
                                                                                            fixed: true,
                                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'search',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 71,
                                                                                            column: 57,
                                                                                            fixed: true,
                                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 71,
                                                                                            column: 63,
                                                                                            fixed: true,
                                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 71,
                                                                                        column: 42,
                                                                                        fixed: true,
                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 71,
                                                                                        column: 63,
                                                                                        fixed: true,
                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            arguments: [
                                                                                {
                                                                                    type: 'Literal',
                                                                                    value: null
                                                                                },
                                                                                {
                                                                                    type: 'Literal',
                                                                                    value: null
                                                                                },
                                                                                {
                                                                                    type: 'ObjectExpression',
                                                                                    properties: [{
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'recursive',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 71,
                                                                                                        column: 77,
                                                                                                        fixed: true,
                                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 71,
                                                                                                        column: 86,
                                                                                                        fixed: true,
                                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'Literal',
                                                                                                value: false
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '0'
                                                                                        }]
                                                                                }
                                                                            ],
                                                                            loc: {
                                                                                start: {
                                                                                    line: 71,
                                                                                    column: 42,
                                                                                    fixed: true,
                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 71,
                                                                                    column: 94,
                                                                                    fixed: true,
                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        body: {
                                                                            type: 'BlockStatement',
                                                                            body: [{
                                                                                    type: 'IfStatement',
                                                                                    test: {
                                                                                        type: 'BinaryExpression',
                                                                                        operator: '&&',
                                                                                        left: {
                                                                                            type: 'BinaryExpression',
                                                                                            operator: '!==',
                                                                                            left: {
                                                                                                type: 'Identifier',
                                                                                                name: 'key',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 72,
                                                                                                        column: 27,
                                                                                                        fixed: true,
                                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 72,
                                                                                                        column: 30,
                                                                                                        fixed: true,
                                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            right: {
                                                                                                type: 'Identifier',
                                                                                                name: 'indexName',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 72,
                                                                                                        column: 36,
                                                                                                        fixed: true,
                                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 72,
                                                                                                        column: 45,
                                                                                                        fixed: true,
                                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        right: {
                                                                                            type: 'BinaryExpression',
                                                                                            operator: '||',
                                                                                            left: {
                                                                                                type: 'CallExpression',
                                                                                                callee: {
                                                                                                    type: 'MemberExpression',
                                                                                                    computed: false,
                                                                                                    object: {
                                                                                                        type: 'MemberExpression',
                                                                                                        computed: false,
                                                                                                        object: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'childFile',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 72,
                                                                                                                    column: 51,
                                                                                                                    fixed: true,
                                                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 72,
                                                                                                                    column: 60,
                                                                                                                    fixed: true,
                                                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        property: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'path',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 72,
                                                                                                                    column: 61,
                                                                                                                    fixed: true,
                                                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 72,
                                                                                                                    column: 65,
                                                                                                                    fixed: true,
                                                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 72,
                                                                                                                column: 51,
                                                                                                                fixed: true,
                                                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 72,
                                                                                                                column: 65,
                                                                                                                fixed: true,
                                                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    property: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'endsWith',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 72,
                                                                                                                column: 66,
                                                                                                                fixed: true,
                                                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 72,
                                                                                                                column: 74,
                                                                                                                fixed: true,
                                                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 72,
                                                                                                            column: 51,
                                                                                                            fixed: true,
                                                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 72,
                                                                                                            column: 74,
                                                                                                            fixed: true,
                                                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                arguments: [{
                                                                                                        type: 'Literal',
                                                                                                        value: '.js'
                                                                                                    }],
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 72,
                                                                                                        column: 51,
                                                                                                        fixed: true,
                                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 72,
                                                                                                        column: 81,
                                                                                                        fixed: true,
                                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            right: {
                                                                                                type: 'MemberExpression',
                                                                                                computed: false,
                                                                                                object: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'childFile',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 72,
                                                                                                            column: 85,
                                                                                                            fixed: true,
                                                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 72,
                                                                                                            column: 94,
                                                                                                            fixed: true,
                                                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'isDirectory',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 72,
                                                                                                            column: 95,
                                                                                                            fixed: true,
                                                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 72,
                                                                                                            column: 106,
                                                                                                            fixed: true,
                                                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 72,
                                                                                                        column: 85,
                                                                                                        fixed: true,
                                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 72,
                                                                                                        column: 106,
                                                                                                        fixed: true,
                                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    consequent: {
                                                                                        type: 'BlockStatement',
                                                                                        body: [
                                                                                            {
                                                                                                type: 'VariableDeclaration',
                                                                                                declarations: [{
                                                                                                        type: 'VariableDeclarator',
                                                                                                        id: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'name',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 73,
                                                                                                                    column: 32,
                                                                                                                    fixed: true,
                                                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 73,
                                                                                                                    column: 36,
                                                                                                                    fixed: true,
                                                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        init: {
                                                                                                            type: 'ConditionalExpression',
                                                                                                            test: {
                                                                                                                type: 'MemberExpression',
                                                                                                                computed: false,
                                                                                                                object: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'childFile',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 73,
                                                                                                                            column: 39,
                                                                                                                            fixed: true,
                                                                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 73,
                                                                                                                            column: 48,
                                                                                                                            fixed: true,
                                                                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                property: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'isDirectory',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 73,
                                                                                                                            column: 49,
                                                                                                                            fixed: true,
                                                                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 73,
                                                                                                                            column: 60,
                                                                                                                            fixed: true,
                                                                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 73,
                                                                                                                        column: 39,
                                                                                                                        fixed: true,
                                                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 73,
                                                                                                                        column: 60,
                                                                                                                        fixed: true,
                                                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            consequent: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'key',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 73,
                                                                                                                        column: 63,
                                                                                                                        fixed: true,
                                                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 73,
                                                                                                                        column: 66,
                                                                                                                        fixed: true,
                                                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            alternate: {
                                                                                                                type: 'CallExpression',
                                                                                                                callee: {
                                                                                                                    type: 'MemberExpression',
                                                                                                                    computed: false,
                                                                                                                    object: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'key',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 73,
                                                                                                                                column: 69,
                                                                                                                                fixed: true,
                                                                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 73,
                                                                                                                                column: 72,
                                                                                                                                fixed: true,
                                                                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    property: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'substring',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 73,
                                                                                                                                column: 73,
                                                                                                                                fixed: true,
                                                                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 73,
                                                                                                                                column: 82,
                                                                                                                                fixed: true,
                                                                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 73,
                                                                                                                            column: 69,
                                                                                                                            fixed: true,
                                                                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 73,
                                                                                                                            column: 82,
                                                                                                                            fixed: true,
                                                                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                arguments: [
                                                                                                                    {
                                                                                                                        type: 'Literal',
                                                                                                                        value: 0
                                                                                                                    },
                                                                                                                    {
                                                                                                                        type: 'CallExpression',
                                                                                                                        callee: {
                                                                                                                            type: 'MemberExpression',
                                                                                                                            computed: false,
                                                                                                                            object: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'key',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 73,
                                                                                                                                        column: 86,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 73,
                                                                                                                                        column: 89,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            property: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'lastIndexOf',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 73,
                                                                                                                                        column: 90,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 73,
                                                                                                                                        column: 101,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 73,
                                                                                                                                    column: 86,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 73,
                                                                                                                                    column: 101,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        arguments: [{
                                                                                                                                type: 'Literal',
                                                                                                                                value: '.js'
                                                                                                                            }],
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 73,
                                                                                                                                column: 86,
                                                                                                                                fixed: true,
                                                                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 73,
                                                                                                                                column: 108,
                                                                                                                                fixed: true,
                                                                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    }
                                                                                                                ],
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 73,
                                                                                                                        column: 69,
                                                                                                                        fixed: true,
                                                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 73,
                                                                                                                        column: 109,
                                                                                                                        fixed: true,
                                                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            }
                                                                                                        }
                                                                                                    }],
                                                                                                kind: 'let',
                                                                                                order: '0'
                                                                                            },
                                                                                            {
                                                                                                type: 'IfStatement',
                                                                                                test: {
                                                                                                    type: 'BinaryExpression',
                                                                                                    operator: '&&',
                                                                                                    left: {
                                                                                                        type: 'UnaryExpression',
                                                                                                        operator: '!',
                                                                                                        argument: {
                                                                                                            type: 'CallExpression',
                                                                                                            callee: {
                                                                                                                type: 'MemberExpression',
                                                                                                                computed: false,
                                                                                                                object: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'name',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 74,
                                                                                                                            column: 35,
                                                                                                                            fixed: true,
                                                                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 74,
                                                                                                                            column: 39,
                                                                                                                            fixed: true,
                                                                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                property: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'startsWith',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 74,
                                                                                                                            column: 40,
                                                                                                                            fixed: true,
                                                                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 74,
                                                                                                                            column: 50,
                                                                                                                            fixed: true,
                                                                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 74,
                                                                                                                        column: 35,
                                                                                                                        fixed: true,
                                                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 74,
                                                                                                                        column: 50,
                                                                                                                        fixed: true,
                                                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            arguments: [{
                                                                                                                    type: 'Literal',
                                                                                                                    value: '_'
                                                                                                                }],
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 74,
                                                                                                                    column: 35,
                                                                                                                    fixed: true,
                                                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 74,
                                                                                                                    column: 55,
                                                                                                                    fixed: true,
                                                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    right: {
                                                                                                        type: 'BinaryExpression',
                                                                                                        operator: '!==',
                                                                                                        left: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'name',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 74,
                                                                                                                    column: 60,
                                                                                                                    fixed: true,
                                                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 74,
                                                                                                                    column: 64,
                                                                                                                    fixed: true,
                                                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        right: {
                                                                                                            type: 'Literal',
                                                                                                            value: ''
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                consequent: {
                                                                                                    type: 'BlockStatement',
                                                                                                    body: [{
                                                                                                            type: 'Property',
                                                                                                            key: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'key',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 75,
                                                                                                                        column: 33,
                                                                                                                        fixed: true,
                                                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 75,
                                                                                                                        column: 36,
                                                                                                                        fixed: true,
                                                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            value: {
                                                                                                                type: 'BinaryExpression',
                                                                                                                operator: '+',
                                                                                                                left: {
                                                                                                                    type: 'BinaryExpression',
                                                                                                                    operator: '+',
                                                                                                                    left: {
                                                                                                                        type: 'BinaryExpression',
                                                                                                                        operator: '+',
                                                                                                                        left: {
                                                                                                                            type: 'BinaryExpression',
                                                                                                                            operator: '+',
                                                                                                                            left: {
                                                                                                                                type: 'Literal',
                                                                                                                                value: 'Object.defineProperty(exports, \''
                                                                                                                            },
                                                                                                                            right: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'name',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 75,
                                                                                                                                        column: 74,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 75,
                                                                                                                                        column: 78,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        right: {
                                                                                                                            type: 'Literal',
                                                                                                                            value: '\', {get:function(){ return require(\'./'
                                                                                                                        }
                                                                                                                    },
                                                                                                                    right: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'name',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 75,
                                                                                                                                column: 120,
                                                                                                                                fixed: true,
                                                                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 75,
                                                                                                                                column: 124,
                                                                                                                                fixed: true,
                                                                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                right: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: '\') }, enumerable: true}) '
                                                                                                                }
                                                                                                            },
                                                                                                            kind: 'init',
                                                                                                            computed: true,
                                                                                                            order: '0'
                                                                                                        }]
                                                                                                },
                                                                                                alternate: null,
                                                                                                order: '1'
                                                                                            }
                                                                                        ]
                                                                                    },
                                                                                    alternate: null,
                                                                                    order: '0'
                                                                                }]
                                                                        },
                                                                        remove: null,
                                                                        order: '0'
                                                                    }]
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '3'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'linesString',
                                                                loc: {
                                                                    start: {
                                                                        line: 77,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 77,
                                                                        column: 31,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'ObjectExpression',
                                                                                objectType: {
                                                                                    type: 'ArrayExpression',
                                                                                    elements: []
                                                                                },
                                                                                properties: [{
                                                                                        type: 'ForInStatement',
                                                                                        left: {
                                                                                            type: 'VariableDeclaration',
                                                                                            declarations: [
                                                                                                {
                                                                                                    type: 'VariableDeclarator',
                                                                                                    id: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'key',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 77,
                                                                                                                column: 45,
                                                                                                                fixed: true,
                                                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 77,
                                                                                                                column: 48,
                                                                                                                fixed: true,
                                                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    init: null
                                                                                                },
                                                                                                {
                                                                                                    type: 'VariableDeclarator',
                                                                                                    id: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'value',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 77,
                                                                                                                column: 50,
                                                                                                                fixed: true,
                                                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 77,
                                                                                                                column: 55,
                                                                                                                fixed: true,
                                                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    init: null
                                                                                                }
                                                                                            ],
                                                                                            kind: 'let'
                                                                                        },
                                                                                        right: {
                                                                                            type: 'Identifier',
                                                                                            name: 'lines',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 77,
                                                                                                    column: 59,
                                                                                                    fixed: true,
                                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 77,
                                                                                                    column: 64,
                                                                                                    fixed: true,
                                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        body: {
                                                                                            type: 'ExpressionStatement',
                                                                                            expression: {
                                                                                                type: 'Identifier',
                                                                                                name: 'value',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 77,
                                                                                                        column: 35,
                                                                                                        fixed: true,
                                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 77,
                                                                                                        column: 40,
                                                                                                        fixed: true,
                                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'concat',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 77,
                                                                                        column: 66,
                                                                                        fixed: true,
                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 77,
                                                                                        column: 72,
                                                                                        fixed: true,
                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 77,
                                                                                    column: 34,
                                                                                    fixed: true,
                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 77,
                                                                                    column: 72,
                                                                                    fixed: true,
                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [{
                                                                                type: 'ArrayExpression',
                                                                                elements: [{
                                                                                        type: 'Literal',
                                                                                        value: 'Object.freeze(exports)'
                                                                                    }]
                                                                            }],
                                                                        loc: {
                                                                            start: {
                                                                                line: 77,
                                                                                column: 34,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            },
                                                                            end: {
                                                                                line: 77,
                                                                                column: 100,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'join',
                                                                        loc: {
                                                                            start: {
                                                                                line: 77,
                                                                                column: 101,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            },
                                                                            end: {
                                                                                line: 77,
                                                                                column: 105,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 77,
                                                                            column: 34,
                                                                            fixed: true,
                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                        },
                                                                        end: {
                                                                            line: 77,
                                                                            column: 105,
                                                                            fixed: true,
                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'Literal',
                                                                        value: '\n'
                                                                    }],
                                                                loc: {
                                                                    start: {
                                                                        line: 77,
                                                                        column: 34,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 77,
                                                                        column: 111,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '4'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'indexModuleId',
                                                                loc: {
                                                                    start: {
                                                                        line: 80,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 80,
                                                                        column: 33,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'np',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 80,
                                                                                        column: 36,
                                                                                        fixed: true,
                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 80,
                                                                                        column: 38,
                                                                                        fixed: true,
                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'join',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 80,
                                                                                        column: 39,
                                                                                        fixed: true,
                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 80,
                                                                                        column: 43,
                                                                                        fixed: true,
                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 80,
                                                                                    column: 36,
                                                                                    fixed: true,
                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 80,
                                                                                    column: 43,
                                                                                    fixed: true,
                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [
                                                                            {
                                                                                type: 'Identifier',
                                                                                name: 'moduleName',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 80,
                                                                                        column: 44,
                                                                                        fixed: true,
                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 80,
                                                                                        column: 54,
                                                                                        fixed: true,
                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            {
                                                                                type: 'Identifier',
                                                                                name: 'path',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 80,
                                                                                        column: 56,
                                                                                        fixed: true,
                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 80,
                                                                                        column: 60,
                                                                                        fixed: true,
                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            {
                                                                                type: 'Literal',
                                                                                value: 'index'
                                                                            }
                                                                        ],
                                                                        loc: {
                                                                            start: {
                                                                                line: 80,
                                                                                column: 36,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            },
                                                                            end: {
                                                                                line: 80,
                                                                                column: 70,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'replace',
                                                                        loc: {
                                                                            start: {
                                                                                line: 80,
                                                                                column: 71,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            },
                                                                            end: {
                                                                                line: 80,
                                                                                column: 78,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 80,
                                                                            column: 36,
                                                                            fixed: true,
                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                        },
                                                                        end: {
                                                                            line: 80,
                                                                            column: 78,
                                                                            fixed: true,
                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [
                                                                    {
                                                                        type: 'Literal',
                                                                        value: /\\/g
                                                                    },
                                                                    {
                                                                        type: 'Literal',
                                                                        value: '/'
                                                                    }
                                                                ],
                                                                loc: {
                                                                    start: {
                                                                        line: 80,
                                                                        column: 36,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 80,
                                                                        column: 90,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '5'
                                                },
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'UnaryExpression',
                                                        operator: 'void',
                                                        argument: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'indexDirectory',
                                                                    loc: {
                                                                        start: {
                                                                            line: 81,
                                                                            column: 21,
                                                                            fixed: true,
                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                        },
                                                                        end: {
                                                                            line: 81,
                                                                            column: 35,
                                                                            fixed: true,
                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'write',
                                                                    loc: {
                                                                        start: {
                                                                            line: 81,
                                                                            column: 36,
                                                                            fixed: true,
                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                        },
                                                                        end: {
                                                                            line: 81,
                                                                            column: 41,
                                                                            fixed: true,
                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 81,
                                                                        column: 21,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 81,
                                                                        column: 41,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [
                                                                {
                                                                    type: 'Identifier',
                                                                    name: 'indexName',
                                                                    loc: {
                                                                        start: {
                                                                            line: 81,
                                                                            column: 42,
                                                                            fixed: true,
                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                        },
                                                                        end: {
                                                                            line: 81,
                                                                            column: 51,
                                                                            fixed: true,
                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                        }
                                                                    }
                                                                },
                                                                {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'builder',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 81,
                                                                                    column: 53,
                                                                                    fixed: true,
                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 81,
                                                                                    column: 60,
                                                                                    fixed: true,
                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'addBrowserShim',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 81,
                                                                                    column: 61,
                                                                                    fixed: true,
                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 81,
                                                                                    column: 75,
                                                                                    fixed: true,
                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 81,
                                                                                column: 53,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            },
                                                                            end: {
                                                                                line: 81,
                                                                                column: 75,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [
                                                                        {
                                                                            type: 'Identifier',
                                                                            name: 'linesString',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 81,
                                                                                    column: 76,
                                                                                    fixed: true,
                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 81,
                                                                                    column: 87,
                                                                                    fixed: true,
                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        {
                                                                            type: 'Identifier',
                                                                            name: 'indexModuleId',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 81,
                                                                                    column: 89,
                                                                                    fixed: true,
                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 81,
                                                                                    column: 102,
                                                                                    fixed: true,
                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                }
                                                                            }
                                                                        }
                                                                    ],
                                                                    loc: {
                                                                        start: {
                                                                            line: 81,
                                                                            column: 53,
                                                                            fixed: true,
                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                        },
                                                                        end: {
                                                                            line: 81,
                                                                            column: 103,
                                                                            fixed: true,
                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                        }
                                                                    }
                                                                }
                                                            ],
                                                            loc: {
                                                                start: {
                                                                    line: 81,
                                                                    column: 21,
                                                                    fixed: true,
                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                },
                                                                end: {
                                                                    line: 81,
                                                                    column: 104,
                                                                    fixed: true,
                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                }
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 81,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 81,
                                                            column: 104,
                                                            fixed: true,
                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                        }
                                                    },
                                                    order: '6'
                                                }
                                            ]
                                        },
                                        alternate: null,
                                        order: '1'
                                    }
                                ]
                            },
                            alternate: null,
                            order: '0'
                        }]
                },
                remove: null,
                order: '8'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'rawFiles',
                            loc: {
                                start: {
                                    line: 85,
                                    column: 8,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                },
                                end: {
                                    line: 85,
                                    column: 16,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'output',
                                    loc: {
                                        start: {
                                            line: 85,
                                            column: 19,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        },
                                        end: {
                                            line: 85,
                                            column: 25,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'search',
                                    loc: {
                                        start: {
                                            line: 85,
                                            column: 26,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        },
                                        end: {
                                            line: 85,
                                            column: 32,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 85,
                                        column: 19,
                                        fixed: true,
                                        source: 'ion/builder/ModuleBuilder.ion'
                                    },
                                    end: {
                                        line: 85,
                                        column: 32,
                                        fixed: true,
                                        source: 'ion/builder/ModuleBuilder.ion'
                                    }
                                }
                            },
                            arguments: [
                                {
                                    type: 'Literal',
                                    value: '.js'
                                },
                                {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'ArrayExpression',
                                            elements: [
                                                {
                                                    type: 'Literal',
                                                    value: /^_/
                                                },
                                                {
                                                    type: 'Literal',
                                                    value: 'node_modules'
                                                }
                                            ]
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'concat',
                                            loc: {
                                                start: {
                                                    line: 85,
                                                    column: 63,
                                                    fixed: true,
                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                },
                                                end: {
                                                    line: 85,
                                                    column: 69,
                                                    fixed: true,
                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 85,
                                                column: 40,
                                                fixed: true,
                                                source: 'ion/builder/ModuleBuilder.ion'
                                            },
                                            end: {
                                                line: 85,
                                                column: 69,
                                                fixed: true,
                                                source: 'ion/builder/ModuleBuilder.ion'
                                            }
                                        }
                                    },
                                    arguments: [{
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'packageJson',
                                                    loc: {
                                                        start: {
                                                            line: 85,
                                                            column: 70,
                                                            fixed: true,
                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 85,
                                                            column: 81,
                                                            fixed: true,
                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'build',
                                                    loc: {
                                                        start: {
                                                            line: 85,
                                                            column: 82,
                                                            fixed: true,
                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 85,
                                                            column: 87,
                                                            fixed: true,
                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 85,
                                                        column: 70,
                                                        fixed: true,
                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                    },
                                                    end: {
                                                        line: 85,
                                                        column: 87,
                                                        fixed: true,
                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'exclude',
                                                loc: {
                                                    start: {
                                                        line: 85,
                                                        column: 88,
                                                        fixed: true,
                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                    },
                                                    end: {
                                                        line: 85,
                                                        column: 95,
                                                        fixed: true,
                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 85,
                                                    column: 70,
                                                    fixed: true,
                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                },
                                                end: {
                                                    line: 85,
                                                    column: 95,
                                                    fixed: true,
                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                }
                                            }
                                        }],
                                    loc: {
                                        start: {
                                            line: 85,
                                            column: 40,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        },
                                        end: {
                                            line: 85,
                                            column: 96,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        }
                                    }
                                }
                            ],
                            loc: {
                                start: {
                                    line: 85,
                                    column: 19,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                },
                                end: {
                                    line: 85,
                                    column: 97,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '9'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'outputFiles',
                            loc: {
                                start: {
                                    line: 86,
                                    column: 8,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                },
                                end: {
                                    line: 86,
                                    column: 19,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'ObjectExpression',
                                properties: []
                            },
                            properties: [{
                                    type: 'ForInStatement',
                                    left: {
                                        type: 'VariableDeclaration',
                                        declarations: [
                                            {
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'key',
                                                    loc: {
                                                        start: {
                                                            line: 87,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 87,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                        }
                                                    }
                                                },
                                                init: null
                                            },
                                            {
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'file',
                                                    loc: {
                                                        start: {
                                                            line: 87,
                                                            column: 17,
                                                            fixed: true,
                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 87,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                        }
                                                    }
                                                },
                                                init: null
                                            }
                                        ],
                                        kind: 'let'
                                    },
                                    right: {
                                        type: 'Identifier',
                                        name: 'rawFiles',
                                        loc: {
                                            start: {
                                                line: 87,
                                                column: 25,
                                                fixed: true,
                                                source: 'ion/builder/ModuleBuilder.ion'
                                            },
                                            end: {
                                                line: 87,
                                                column: 33,
                                                fixed: true,
                                                source: 'ion/builder/ModuleBuilder.ion'
                                            }
                                        }
                                    },
                                    body: {
                                        type: 'BlockStatement',
                                        body: [{
                                                type: 'IfStatement',
                                                test: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'file',
                                                        loc: {
                                                            start: {
                                                                line: 88,
                                                                column: 15,
                                                                fixed: true,
                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                            },
                                                            end: {
                                                                line: 88,
                                                                column: 19,
                                                                fixed: true,
                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'exists',
                                                        loc: {
                                                            start: {
                                                                line: 88,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                            },
                                                            end: {
                                                                line: 88,
                                                                column: 26,
                                                                fixed: true,
                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 88,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 88,
                                                            column: 26,
                                                            fixed: true,
                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                        }
                                                    }
                                                },
                                                consequent: {
                                                    type: 'BlockStatement',
                                                    body: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'key',
                                                                loc: {
                                                                    start: {
                                                                        line: 89,
                                                                        column: 17,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 89,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Identifier',
                                                                name: 'file',
                                                                loc: {
                                                                    start: {
                                                                        line: 89,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 89,
                                                                        column: 27,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    }
                                                                }
                                                            },
                                                            kind: 'init',
                                                            computed: true,
                                                            order: '0'
                                                        }]
                                                },
                                                alternate: {
                                                    type: 'BlockStatement',
                                                    body: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'key',
                                                                loc: {
                                                                    start: {
                                                                        line: 91,
                                                                        column: 17,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 91,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Literal',
                                                                value: null
                                                            },
                                                            kind: 'init',
                                                            computed: true,
                                                            order: '0'
                                                        }]
                                                },
                                                order: '0'
                                            }]
                                    },
                                    remove: null,
                                    order: '0'
                                }]
                        }
                    }],
                kind: 'let',
                order: ':'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'top',
                            loc: {
                                start: {
                                    line: 92,
                                    column: 8,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                },
                                end: {
                                    line: 92,
                                    column: 11,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'ArrayExpression',
                                elements: []
                            },
                            properties: [{
                                    type: 'ForInStatement',
                                    left: {
                                        type: 'VariableDeclaration',
                                        declarations: [{
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'key',
                                                    loc: {
                                                        start: {
                                                            line: 92,
                                                            column: 23,
                                                            fixed: true,
                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 92,
                                                            column: 26,
                                                            fixed: true,
                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                        }
                                                    }
                                                },
                                                init: null
                                            }],
                                        kind: 'let'
                                    },
                                    right: {
                                        type: 'Identifier',
                                        name: 'outputFiles',
                                        loc: {
                                            start: {
                                                line: 92,
                                                column: 30,
                                                fixed: true,
                                                source: 'ion/builder/ModuleBuilder.ion'
                                            },
                                            end: {
                                                line: 92,
                                                column: 41,
                                                fixed: true,
                                                source: 'ion/builder/ModuleBuilder.ion'
                                            }
                                        }
                                    },
                                    body: {
                                        type: 'BlockStatement',
                                        body: [{
                                                type: 'IfStatement',
                                                test: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'key',
                                                            loc: {
                                                                start: {
                                                                    line: 92,
                                                                    column: 45,
                                                                    fixed: true,
                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                },
                                                                end: {
                                                                    line: 92,
                                                                    column: 48,
                                                                    fixed: true,
                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'endsWith',
                                                            loc: {
                                                                start: {
                                                                    line: 92,
                                                                    column: 49,
                                                                    fixed: true,
                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                },
                                                                end: {
                                                                    line: 92,
                                                                    column: 57,
                                                                    fixed: true,
                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 92,
                                                                column: 45,
                                                                fixed: true,
                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                            },
                                                            end: {
                                                                line: 92,
                                                                column: 57,
                                                                fixed: true,
                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [{
                                                            type: 'Literal',
                                                            value: 'require.js'
                                                        }],
                                                    loc: {
                                                        start: {
                                                            line: 92,
                                                            column: 45,
                                                            fixed: true,
                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 92,
                                                            column: 71,
                                                            fixed: true,
                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                        }
                                                    }
                                                },
                                                consequent: {
                                                    type: 'BlockStatement',
                                                    body: [{
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'Identifier',
                                                                name: 'key',
                                                                loc: {
                                                                    start: {
                                                                        line: 92,
                                                                        column: 15,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 92,
                                                                        column: 18,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    }
                                                                }
                                                            },
                                                            order: '0'
                                                        }]
                                                },
                                                order: '0'
                                            }]
                                    },
                                    order: '0'
                                }]
                        }
                    }],
                kind: 'let',
                order: ';'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'sortedFiles',
                            loc: {
                                start: {
                                    line: 93,
                                    column: 8,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                },
                                end: {
                                    line: 93,
                                    column: 19,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'top',
                                    loc: {
                                        start: {
                                            line: 93,
                                            column: 22,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        },
                                        end: {
                                            line: 93,
                                            column: 25,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'concat',
                                    loc: {
                                        start: {
                                            line: 93,
                                            column: 26,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        },
                                        end: {
                                            line: 93,
                                            column: 32,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 93,
                                        column: 22,
                                        fixed: true,
                                        source: 'ion/builder/ModuleBuilder.ion'
                                    },
                                    end: {
                                        line: 93,
                                        column: 32,
                                        fixed: true,
                                        source: 'ion/builder/ModuleBuilder.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ObjectExpression',
                                    objectType: {
                                        type: 'ArrayExpression',
                                        elements: []
                                    },
                                    properties: [{
                                            type: 'ForInStatement',
                                            left: {
                                                type: 'VariableDeclaration',
                                                declarations: [
                                                    {
                                                        type: 'VariableDeclarator',
                                                        id: {
                                                            type: 'Identifier',
                                                            name: 'key',
                                                            loc: {
                                                                start: {
                                                                    line: 93,
                                                                    column: 42,
                                                                    fixed: true,
                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                },
                                                                end: {
                                                                    line: 93,
                                                                    column: 45,
                                                                    fixed: true,
                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                }
                                                            }
                                                        },
                                                        init: null
                                                    },
                                                    {
                                                        type: 'VariableDeclarator',
                                                        id: {
                                                            type: 'Identifier',
                                                            name: 'file',
                                                            loc: {
                                                                start: {
                                                                    line: 93,
                                                                    column: 47,
                                                                    fixed: true,
                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                },
                                                                end: {
                                                                    line: 93,
                                                                    column: 51,
                                                                    fixed: true,
                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                }
                                                            }
                                                        },
                                                        init: null
                                                    }
                                                ],
                                                kind: 'let'
                                            },
                                            right: {
                                                type: 'Identifier',
                                                name: 'outputFiles',
                                                loc: {
                                                    start: {
                                                        line: 93,
                                                        column: 55,
                                                        fixed: true,
                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                    },
                                                    end: {
                                                        line: 93,
                                                        column: 66,
                                                        fixed: true,
                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                    }
                                                }
                                            },
                                            body: {
                                                type: 'BlockStatement',
                                                body: [{
                                                        type: 'IfStatement',
                                                        test: {
                                                            type: 'BinaryExpression',
                                                            operator: '&&',
                                                            left: {
                                                                type: 'BinaryExpression',
                                                                operator: '&&',
                                                                left: {
                                                                    type: 'UnaryExpression',
                                                                    operator: '!',
                                                                    argument: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'builder',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 93,
                                                                                        column: 74,
                                                                                        fixed: true,
                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 93,
                                                                                        column: 81,
                                                                                        fixed: true,
                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'isPrivate',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 93,
                                                                                        column: 82,
                                                                                        fixed: true,
                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 93,
                                                                                        column: 91,
                                                                                        fixed: true,
                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 93,
                                                                                    column: 74,
                                                                                    fixed: true,
                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 93,
                                                                                    column: 91,
                                                                                    fixed: true,
                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [{
                                                                                type: 'Identifier',
                                                                                name: 'key',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 93,
                                                                                        column: 92,
                                                                                        fixed: true,
                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 93,
                                                                                        column: 95,
                                                                                        fixed: true,
                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                    }
                                                                                }
                                                                            }],
                                                                        loc: {
                                                                            start: {
                                                                                line: 93,
                                                                                column: 74,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            },
                                                                            end: {
                                                                                line: 93,
                                                                                column: 96,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            }
                                                                        }
                                                                    }
                                                                },
                                                                right: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '<',
                                                                    left: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'top',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 93,
                                                                                        column: 101,
                                                                                        fixed: true,
                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 93,
                                                                                        column: 104,
                                                                                        fixed: true,
                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'indexOf',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 93,
                                                                                        column: 105,
                                                                                        fixed: true,
                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 93,
                                                                                        column: 112,
                                                                                        fixed: true,
                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 93,
                                                                                    column: 101,
                                                                                    fixed: true,
                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 93,
                                                                                    column: 112,
                                                                                    fixed: true,
                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [{
                                                                                type: 'Identifier',
                                                                                name: 'key',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 93,
                                                                                        column: 113,
                                                                                        fixed: true,
                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 93,
                                                                                        column: 116,
                                                                                        fixed: true,
                                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                                    }
                                                                                }
                                                                            }],
                                                                        loc: {
                                                                            start: {
                                                                                line: 93,
                                                                                column: 101,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            },
                                                                            end: {
                                                                                line: 93,
                                                                                column: 117,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    right: {
                                                                        type: 'Literal',
                                                                        value: 0
                                                                    }
                                                                }
                                                            },
                                                            right: {
                                                                type: 'UnaryExpression',
                                                                operator: '?',
                                                                argument: {
                                                                    type: 'Identifier',
                                                                    name: 'file',
                                                                    loc: {
                                                                        start: {
                                                                            line: 93,
                                                                            column: 126,
                                                                            fixed: true,
                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                        },
                                                                        end: {
                                                                            line: 93,
                                                                            column: 130,
                                                                            fixed: true,
                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        },
                                                        consequent: {
                                                            type: 'BlockStatement',
                                                            body: [{
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'Identifier',
                                                                        name: 'key',
                                                                        loc: {
                                                                            start: {
                                                                                line: 93,
                                                                                column: 34,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            },
                                                                            end: {
                                                                                line: 93,
                                                                                column: 37,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    order: '0'
                                                                }]
                                                        },
                                                        order: '0'
                                                    }]
                                            },
                                            order: '0'
                                        }]
                                }],
                            loc: {
                                start: {
                                    line: 93,
                                    column: 22,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                },
                                end: {
                                    line: 93,
                                    column: 133,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '<'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'manifestFileName',
                            loc: {
                                start: {
                                    line: 94,
                                    column: 8,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                },
                                end: {
                                    line: 94,
                                    column: 24,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                }
                            }
                        },
                        init: {
                            type: 'Literal',
                            value: 'manifest.json'
                        }
                    }],
                kind: 'let',
                order: '='
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'manifestFile',
                            loc: {
                                start: {
                                    line: 95,
                                    column: 8,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                },
                                end: {
                                    line: 95,
                                    column: 20,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'output',
                                    loc: {
                                        start: {
                                            line: 95,
                                            column: 23,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        },
                                        end: {
                                            line: 95,
                                            column: 29,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'getFile',
                                    loc: {
                                        start: {
                                            line: 95,
                                            column: 30,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        },
                                        end: {
                                            line: 95,
                                            column: 37,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 95,
                                        column: 23,
                                        fixed: true,
                                        source: 'ion/builder/ModuleBuilder.ion'
                                    },
                                    end: {
                                        line: 95,
                                        column: 37,
                                        fixed: true,
                                        source: 'ion/builder/ModuleBuilder.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'Identifier',
                                    name: 'manifestFileName',
                                    loc: {
                                        start: {
                                            line: 95,
                                            column: 38,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        },
                                        end: {
                                            line: 95,
                                            column: 54,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        }
                                    }
                                }],
                            loc: {
                                start: {
                                    line: 95,
                                    column: 23,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                },
                                end: {
                                    line: 95,
                                    column: 55,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '>'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'manifest',
                            loc: {
                                start: {
                                    line: 96,
                                    column: 8,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                },
                                end: {
                                    line: 96,
                                    column: 16,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'modified',
                                        loc: {
                                            start: {
                                                line: 97,
                                                column: 8,
                                                fixed: true,
                                                source: 'ion/builder/ModuleBuilder.ion'
                                            },
                                            end: {
                                                line: 97,
                                                column: 16,
                                                fixed: true,
                                                source: 'ion/builder/ModuleBuilder.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'Math',
                                                    loc: {
                                                        start: {
                                                            line: 97,
                                                            column: 18,
                                                            fixed: true,
                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 97,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'max',
                                                    loc: {
                                                        start: {
                                                            line: 97,
                                                            column: 23,
                                                            fixed: true,
                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 97,
                                                            column: 26,
                                                            fixed: true,
                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 97,
                                                        column: 18,
                                                        fixed: true,
                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                    },
                                                    end: {
                                                        line: 97,
                                                        column: 26,
                                                        fixed: true,
                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'apply',
                                                loc: {
                                                    start: {
                                                        line: 97,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                    },
                                                    end: {
                                                        line: 97,
                                                        column: 32,
                                                        fixed: true,
                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 97,
                                                    column: 18,
                                                    fixed: true,
                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                },
                                                end: {
                                                    line: 97,
                                                    column: 32,
                                                    fixed: true,
                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                }
                                            }
                                        },
                                        arguments: [
                                            {
                                                type: 'Literal',
                                                value: null
                                            },
                                            {
                                                type: 'ObjectExpression',
                                                objectType: {
                                                    type: 'ArrayExpression',
                                                    elements: []
                                                },
                                                properties: [{
                                                        type: 'ForInStatement',
                                                        left: {
                                                            type: 'VariableDeclaration',
                                                            declarations: [
                                                                {
                                                                    type: 'VariableDeclarator',
                                                                    id: {
                                                                        type: 'Identifier',
                                                                        name: 'path',
                                                                        loc: {
                                                                            start: {
                                                                                line: 97,
                                                                                column: 58,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            },
                                                                            end: {
                                                                                line: 97,
                                                                                column: 62,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    init: null
                                                                },
                                                                {
                                                                    type: 'VariableDeclarator',
                                                                    id: {
                                                                        type: 'Identifier',
                                                                        name: 'file',
                                                                        loc: {
                                                                            start: {
                                                                                line: 97,
                                                                                column: 64,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            },
                                                                            end: {
                                                                                line: 97,
                                                                                column: 68,
                                                                                fixed: true,
                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    init: null
                                                                }
                                                            ],
                                                            kind: 'let'
                                                        },
                                                        right: {
                                                            type: 'Identifier',
                                                            name: 'outputFiles',
                                                            loc: {
                                                                start: {
                                                                    line: 97,
                                                                    column: 72,
                                                                    fixed: true,
                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                },
                                                                end: {
                                                                    line: 97,
                                                                    column: 83,
                                                                    fixed: true,
                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                }
                                                            }
                                                        },
                                                        body: {
                                                            type: 'BlockStatement',
                                                            body: [{
                                                                    type: 'IfStatement',
                                                                    test: {
                                                                        type: 'UnaryExpression',
                                                                        operator: '?',
                                                                        argument: {
                                                                            type: 'Identifier',
                                                                            name: 'file',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 97,
                                                                                    column: 87,
                                                                                    fixed: true,
                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 97,
                                                                                    column: 91,
                                                                                    fixed: true,
                                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                                }
                                                                            }
                                                                        }
                                                                    },
                                                                    consequent: {
                                                                        type: 'BlockStatement',
                                                                        body: [{
                                                                                type: 'ExpressionStatement',
                                                                                expression: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'file',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 97,
                                                                                                column: 40,
                                                                                                fixed: true,
                                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 97,
                                                                                                column: 44,
                                                                                                fixed: true,
                                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'modified',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 97,
                                                                                                column: 45,
                                                                                                fixed: true,
                                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 97,
                                                                                                column: 53,
                                                                                                fixed: true,
                                                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 97,
                                                                                            column: 40,
                                                                                            fixed: true,
                                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 97,
                                                                                            column: 53,
                                                                                            fixed: true,
                                                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                order: '0'
                                                                            }]
                                                                    },
                                                                    order: '0'
                                                                }]
                                                        },
                                                        order: '0'
                                                    }]
                                            }
                                        ],
                                        loc: {
                                            start: {
                                                line: 97,
                                                column: 18,
                                                fixed: true,
                                                source: 'ion/builder/ModuleBuilder.ion'
                                            },
                                            end: {
                                                line: 97,
                                                column: 94,
                                                fixed: true,
                                                source: 'ion/builder/ModuleBuilder.ion'
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'files',
                                        loc: {
                                            start: {
                                                line: 98,
                                                column: 8,
                                                fixed: true,
                                                source: 'ion/builder/ModuleBuilder.ion'
                                            },
                                            end: {
                                                line: 98,
                                                column: 13,
                                                fixed: true,
                                                source: 'ion/builder/ModuleBuilder.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        objectType: {
                                            type: 'ArrayExpression',
                                            elements: []
                                        },
                                        properties: [{
                                                type: 'ForOfStatement',
                                                left: {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'path',
                                                                loc: {
                                                                    start: {
                                                                        line: 98,
                                                                        column: 48,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 98,
                                                                        column: 52,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: null
                                                        }],
                                                    kind: 'let'
                                                },
                                                right: {
                                                    type: 'Identifier',
                                                    name: 'sortedFiles',
                                                    loc: {
                                                        start: {
                                                            line: 98,
                                                            column: 56,
                                                            fixed: true,
                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 98,
                                                            column: 67,
                                                            fixed: true,
                                                            source: 'ion/builder/ModuleBuilder.ion'
                                                        }
                                                    }
                                                },
                                                body: {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'builder',
                                                                loc: {
                                                                    start: {
                                                                        line: 98,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 98,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'normalizePath',
                                                                loc: {
                                                                    start: {
                                                                        line: 98,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 98,
                                                                        column: 37,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 98,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                },
                                                                end: {
                                                                    line: 98,
                                                                    column: 37,
                                                                    fixed: true,
                                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [{
                                                                type: 'Identifier',
                                                                name: 'path',
                                                                loc: {
                                                                    start: {
                                                                        line: 98,
                                                                        column: 38,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 98,
                                                                        column: 42,
                                                                        fixed: true,
                                                                        source: 'ion/builder/ModuleBuilder.ion'
                                                                    }
                                                                }
                                                            }],
                                                        loc: {
                                                            start: {
                                                                line: 98,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                            },
                                                            end: {
                                                                line: 98,
                                                                column: 43,
                                                                fixed: true,
                                                                source: 'ion/builder/ModuleBuilder.ion'
                                                            }
                                                        }
                                                    }
                                                },
                                                order: '0'
                                            }]
                                    },
                                    kind: 'init',
                                    order: '1'
                                }
                            ]
                        }
                    }],
                kind: 'let',
                order: '?'
            },
            {
                type: 'ExpressionStatement',
                expression: {
                    type: 'CallExpression',
                    callee: {
                        type: 'MemberExpression',
                        computed: false,
                        object: {
                            type: 'Identifier',
                            name: 'output',
                            loc: {
                                start: {
                                    line: 99,
                                    column: 4,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                },
                                end: {
                                    line: 99,
                                    column: 10,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                }
                            }
                        },
                        property: {
                            type: 'Identifier',
                            name: 'write',
                            loc: {
                                start: {
                                    line: 99,
                                    column: 11,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                },
                                end: {
                                    line: 99,
                                    column: 16,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                }
                            }
                        },
                        loc: {
                            start: {
                                line: 99,
                                column: 4,
                                fixed: true,
                                source: 'ion/builder/ModuleBuilder.ion'
                            },
                            end: {
                                line: 99,
                                column: 16,
                                fixed: true,
                                source: 'ion/builder/ModuleBuilder.ion'
                            }
                        }
                    },
                    arguments: [
                        {
                            type: 'Identifier',
                            name: 'manifestFileName',
                            loc: {
                                start: {
                                    line: 99,
                                    column: 17,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                },
                                end: {
                                    line: 99,
                                    column: 33,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                }
                            }
                        },
                        {
                            type: 'CallExpression',
                            callee: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'JSON',
                                    loc: {
                                        start: {
                                            line: 99,
                                            column: 35,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        },
                                        end: {
                                            line: 99,
                                            column: 39,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'stringify',
                                    loc: {
                                        start: {
                                            line: 99,
                                            column: 40,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        },
                                        end: {
                                            line: 99,
                                            column: 49,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 99,
                                        column: 35,
                                        fixed: true,
                                        source: 'ion/builder/ModuleBuilder.ion'
                                    },
                                    end: {
                                        line: 99,
                                        column: 49,
                                        fixed: true,
                                        source: 'ion/builder/ModuleBuilder.ion'
                                    }
                                }
                            },
                            arguments: [
                                {
                                    type: 'Identifier',
                                    name: 'manifest',
                                    loc: {
                                        start: {
                                            line: 99,
                                            column: 50,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        },
                                        end: {
                                            line: 99,
                                            column: 58,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        }
                                    }
                                },
                                {
                                    type: 'Literal',
                                    value: null
                                },
                                {
                                    type: 'Literal',
                                    value: '  '
                                },
                                {
                                    type: 'Identifier',
                                    name: 'sortedFiles',
                                    loc: {
                                        start: {
                                            line: 99,
                                            column: 72,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        },
                                        end: {
                                            line: 99,
                                            column: 83,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        }
                                    }
                                }
                            ],
                            loc: {
                                start: {
                                    line: 99,
                                    column: 35,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                },
                                end: {
                                    line: 99,
                                    column: 84,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                }
                            }
                        }
                    ],
                    loc: {
                        start: {
                            line: 99,
                            column: 4,
                            fixed: true,
                            source: 'ion/builder/ModuleBuilder.ion'
                        },
                        end: {
                            line: 99,
                            column: 85,
                            fixed: true,
                            source: 'ion/builder/ModuleBuilder.ion'
                        }
                    }
                },
                loc: {
                    start: {
                        line: 99,
                        column: 4,
                        fixed: true,
                        source: 'ion/builder/ModuleBuilder.ion'
                    },
                    end: {
                        line: 99,
                        column: 85,
                        fixed: true,
                        source: 'ion/builder/ModuleBuilder.ion'
                    }
                },
                order: '@'
            },
            {
                type: 'IfStatement',
                test: {
                    type: 'BinaryExpression',
                    operator: '!==',
                    left: {
                        type: 'MemberExpression',
                        computed: false,
                        object: {
                            type: 'MemberExpression',
                            computed: false,
                            object: {
                                type: 'Identifier',
                                name: 'packageJson',
                                loc: {
                                    start: {
                                        line: 102,
                                        column: 7,
                                        fixed: true,
                                        source: 'ion/builder/ModuleBuilder.ion'
                                    },
                                    end: {
                                        line: 102,
                                        column: 18,
                                        fixed: true,
                                        source: 'ion/builder/ModuleBuilder.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'build',
                                loc: {
                                    start: {
                                        line: 102,
                                        column: 19,
                                        fixed: true,
                                        source: 'ion/builder/ModuleBuilder.ion'
                                    },
                                    end: {
                                        line: 102,
                                        column: 24,
                                        fixed: true,
                                        source: 'ion/builder/ModuleBuilder.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 102,
                                    column: 7,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                },
                                end: {
                                    line: 102,
                                    column: 24,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                }
                            }
                        },
                        property: {
                            type: 'Identifier',
                            name: 'test',
                            loc: {
                                start: {
                                    line: 102,
                                    column: 25,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                },
                                end: {
                                    line: 102,
                                    column: 29,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                }
                            }
                        },
                        loc: {
                            start: {
                                line: 102,
                                column: 7,
                                fixed: true,
                                source: 'ion/builder/ModuleBuilder.ion'
                            },
                            end: {
                                line: 102,
                                column: 29,
                                fixed: true,
                                source: 'ion/builder/ModuleBuilder.ion'
                            }
                        }
                    },
                    right: {
                        type: 'Literal',
                        value: false
                    }
                },
                consequent: {
                    type: 'BlockStatement',
                    body: [{
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'builder',
                                        loc: {
                                            start: {
                                                line: 103,
                                                column: 8,
                                                fixed: true,
                                                source: 'ion/builder/ModuleBuilder.ion'
                                            },
                                            end: {
                                                line: 103,
                                                column: 15,
                                                fixed: true,
                                                source: 'ion/builder/ModuleBuilder.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'runTests',
                                        loc: {
                                            start: {
                                                line: 103,
                                                column: 16,
                                                fixed: true,
                                                source: 'ion/builder/ModuleBuilder.ion'
                                            },
                                            end: {
                                                line: 103,
                                                column: 24,
                                                fixed: true,
                                                source: 'ion/builder/ModuleBuilder.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 103,
                                            column: 8,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        },
                                        end: {
                                            line: 103,
                                            column: 24,
                                            fixed: true,
                                            source: 'ion/builder/ModuleBuilder.ion'
                                        }
                                    }
                                },
                                arguments: [
                                    {
                                        type: 'Identifier',
                                        name: 'manifestFile',
                                        loc: {
                                            start: {
                                                line: 103,
                                                column: 25,
                                                fixed: true,
                                                source: 'ion/builder/ModuleBuilder.ion'
                                            },
                                            end: {
                                                line: 103,
                                                column: 37,
                                                fixed: true,
                                                source: 'ion/builder/ModuleBuilder.ion'
                                            }
                                        }
                                    },
                                    {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'manifestFile',
                                            loc: {
                                                start: {
                                                    line: 103,
                                                    column: 39,
                                                    fixed: true,
                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                },
                                                end: {
                                                    line: 103,
                                                    column: 51,
                                                    fixed: true,
                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'modified',
                                            loc: {
                                                start: {
                                                    line: 103,
                                                    column: 52,
                                                    fixed: true,
                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                },
                                                end: {
                                                    line: 103,
                                                    column: 60,
                                                    fixed: true,
                                                    source: 'ion/builder/ModuleBuilder.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 103,
                                                column: 39,
                                                fixed: true,
                                                source: 'ion/builder/ModuleBuilder.ion'
                                            },
                                            end: {
                                                line: 103,
                                                column: 60,
                                                fixed: true,
                                                source: 'ion/builder/ModuleBuilder.ion'
                                            }
                                        }
                                    }
                                ],
                                loc: {
                                    start: {
                                        line: 103,
                                        column: 8,
                                        fixed: true,
                                        source: 'ion/builder/ModuleBuilder.ion'
                                    },
                                    end: {
                                        line: 103,
                                        column: 61,
                                        fixed: true,
                                        source: 'ion/builder/ModuleBuilder.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 103,
                                    column: 8,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                },
                                end: {
                                    line: 103,
                                    column: 61,
                                    fixed: true,
                                    source: 'ion/builder/ModuleBuilder.ion'
                                }
                            },
                            order: '0'
                        }]
                },
                alternate: null,
                order: 'A'
            }
        ],
        bound: false
    }, {
        this: this,
        ion: ion,
        packagePatch: packagePatch,
        np: np,
        File: File,
        Directory: Directory,
        builder: builder,
        utility: utility,
        compilers: compilers
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/builder/ModuleBuilder',_ion_builder_ModuleBuilder_);
    else
      _ion_builder_ModuleBuilder_.call(this, module, exports, require);
  }
  else {
    _ion_builder_ModuleBuilder_.call(this);
  }
}).call(this)
void (function(){var _ion_builder_WebsiteBuilder_ = function(module,exports,require){'use strict';
var ion = require('../'), _ref, _ref2, clientJsDir = 'js', serverJsDir = 'WEB-INF/js', serverJavaDir = 'WEB-INF/java', np = require('path'), fs = require('fs');
_ref = ion;
var builder = _ref.builder;
_ref2 = builder;
var File = _ref2.File;
var Directory = _ref2.Directory;
var utility = _ref2.utility;
var ModuleBuilder = _ref2.ModuleBuilder;
module.exports = exports = ion.template(function () {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [
                    {
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'packageJson',
                            loc: {
                                start: {
                                    line: 14,
                                    column: 8,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                },
                                end: {
                                    line: 14,
                                    column: 19,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'JSON',
                                    loc: {
                                        start: {
                                            line: 14,
                                            column: 22,
                                            fixed: true,
                                            source: 'ion/builder/WebsiteBuilder.ion'
                                        },
                                        end: {
                                            line: 14,
                                            column: 26,
                                            fixed: true,
                                            source: 'ion/builder/WebsiteBuilder.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'parse',
                                    loc: {
                                        start: {
                                            line: 14,
                                            column: 27,
                                            fixed: true,
                                            source: 'ion/builder/WebsiteBuilder.ion'
                                        },
                                        end: {
                                            line: 14,
                                            column: 32,
                                            fixed: true,
                                            source: 'ion/builder/WebsiteBuilder.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 14,
                                        column: 22,
                                        fixed: true,
                                        source: 'ion/builder/WebsiteBuilder.ion'
                                    },
                                    end: {
                                        line: 14,
                                        column: 32,
                                        fixed: true,
                                        source: 'ion/builder/WebsiteBuilder.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'NewExpression',
                                            callee: {
                                                type: 'Identifier',
                                                name: 'File',
                                                loc: {
                                                    start: {
                                                        line: 14,
                                                        column: 37,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    },
                                                    end: {
                                                        line: 14,
                                                        column: 41,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    }
                                                }
                                            },
                                            arguments: [{
                                                    type: 'Literal',
                                                    value: 'package.json'
                                                }],
                                            loc: {
                                                start: {
                                                    line: 14,
                                                    column: 33,
                                                    fixed: true,
                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                },
                                                end: {
                                                    line: 14,
                                                    column: 57,
                                                    fixed: true,
                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'read',
                                            loc: {
                                                start: {
                                                    line: 14,
                                                    column: 58,
                                                    fixed: true,
                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                },
                                                end: {
                                                    line: 14,
                                                    column: 62,
                                                    fixed: true,
                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 14,
                                                column: 33,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            },
                                            end: {
                                                line: 14,
                                                column: 62,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            }
                                        }
                                    },
                                    arguments: [],
                                    loc: {
                                        start: {
                                            line: 14,
                                            column: 33,
                                            fixed: true,
                                            source: 'ion/builder/WebsiteBuilder.ion'
                                        },
                                        end: {
                                            line: 14,
                                            column: 64,
                                            fixed: true,
                                            source: 'ion/builder/WebsiteBuilder.ion'
                                        }
                                    }
                                }],
                            loc: {
                                start: {
                                    line: 14,
                                    column: 22,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                },
                                end: {
                                    line: 14,
                                    column: 65,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                }
                            }
                        }
                    },
                    {
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'input',
                            loc: {
                                start: {
                                    line: 15,
                                    column: 8,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                },
                                end: {
                                    line: 15,
                                    column: 13,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                }
                            }
                        },
                        init: {
                            type: 'NewExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Directory',
                                loc: {
                                    start: {
                                        line: 15,
                                        column: 20,
                                        fixed: true,
                                        source: 'ion/builder/WebsiteBuilder.ion'
                                    },
                                    end: {
                                        line: 15,
                                        column: 29,
                                        fixed: true,
                                        source: 'ion/builder/WebsiteBuilder.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ConditionalExpression',
                                    test: {
                                        type: 'BinaryExpression',
                                        operator: '!=',
                                        left: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'packageJson',
                                                    loc: {
                                                        start: {
                                                            line: 15,
                                                            column: 30,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 15,
                                                            column: 41,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'directories',
                                                    loc: {
                                                        start: {
                                                            line: 15,
                                                            column: 42,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 15,
                                                            column: 53,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 15,
                                                        column: 30,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    },
                                                    end: {
                                                        line: 15,
                                                        column: 53,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'src',
                                                loc: {
                                                    start: {
                                                        line: 15,
                                                        column: 54,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    },
                                                    end: {
                                                        line: 15,
                                                        column: 57,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 15,
                                                    column: 30,
                                                    fixed: true,
                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                },
                                                end: {
                                                    line: 15,
                                                    column: 57,
                                                    fixed: true,
                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                }
                                            }
                                        },
                                        right: {
                                            type: 'Literal',
                                            value: null
                                        }
                                    },
                                    consequent: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'packageJson',
                                                loc: {
                                                    start: {
                                                        line: 15,
                                                        column: 30,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    },
                                                    end: {
                                                        line: 15,
                                                        column: 41,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'directories',
                                                loc: {
                                                    start: {
                                                        line: 15,
                                                        column: 42,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    },
                                                    end: {
                                                        line: 15,
                                                        column: 53,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 15,
                                                    column: 30,
                                                    fixed: true,
                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                },
                                                end: {
                                                    line: 15,
                                                    column: 53,
                                                    fixed: true,
                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'src',
                                            loc: {
                                                start: {
                                                    line: 15,
                                                    column: 54,
                                                    fixed: true,
                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                },
                                                end: {
                                                    line: 15,
                                                    column: 57,
                                                    fixed: true,
                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 15,
                                                column: 30,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            },
                                            end: {
                                                line: 15,
                                                column: 57,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            }
                                        }
                                    },
                                    alternate: {
                                        type: 'Literal',
                                        value: 'src'
                                    }
                                }],
                            loc: {
                                start: {
                                    line: 15,
                                    column: 16,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                },
                                end: {
                                    line: 15,
                                    column: 66,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                }
                            }
                        }
                    },
                    {
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'output',
                            loc: {
                                start: {
                                    line: 16,
                                    column: 8,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                },
                                end: {
                                    line: 16,
                                    column: 14,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                }
                            }
                        },
                        init: {
                            type: 'NewExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Directory',
                                loc: {
                                    start: {
                                        line: 16,
                                        column: 21,
                                        fixed: true,
                                        source: 'ion/builder/WebsiteBuilder.ion'
                                    },
                                    end: {
                                        line: 16,
                                        column: 30,
                                        fixed: true,
                                        source: 'ion/builder/WebsiteBuilder.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ConditionalExpression',
                                    test: {
                                        type: 'BinaryExpression',
                                        operator: '!=',
                                        left: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'packageJson',
                                                    loc: {
                                                        start: {
                                                            line: 16,
                                                            column: 31,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 16,
                                                            column: 42,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'directories',
                                                    loc: {
                                                        start: {
                                                            line: 16,
                                                            column: 43,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 16,
                                                            column: 54,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 16,
                                                        column: 31,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    },
                                                    end: {
                                                        line: 16,
                                                        column: 54,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'www',
                                                loc: {
                                                    start: {
                                                        line: 16,
                                                        column: 55,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    },
                                                    end: {
                                                        line: 16,
                                                        column: 58,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 16,
                                                    column: 31,
                                                    fixed: true,
                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                },
                                                end: {
                                                    line: 16,
                                                    column: 58,
                                                    fixed: true,
                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                }
                                            }
                                        },
                                        right: {
                                            type: 'Literal',
                                            value: null
                                        }
                                    },
                                    consequent: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'packageJson',
                                                loc: {
                                                    start: {
                                                        line: 16,
                                                        column: 31,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    },
                                                    end: {
                                                        line: 16,
                                                        column: 42,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'directories',
                                                loc: {
                                                    start: {
                                                        line: 16,
                                                        column: 43,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    },
                                                    end: {
                                                        line: 16,
                                                        column: 54,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 16,
                                                    column: 31,
                                                    fixed: true,
                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                },
                                                end: {
                                                    line: 16,
                                                    column: 54,
                                                    fixed: true,
                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'www',
                                            loc: {
                                                start: {
                                                    line: 16,
                                                    column: 55,
                                                    fixed: true,
                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                },
                                                end: {
                                                    line: 16,
                                                    column: 58,
                                                    fixed: true,
                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 16,
                                                column: 31,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            },
                                            end: {
                                                line: 16,
                                                column: 58,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            }
                                        }
                                    },
                                    alternate: {
                                        type: 'Literal',
                                        value: 'debug'
                                    }
                                }],
                            loc: {
                                start: {
                                    line: 16,
                                    column: 17,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                },
                                end: {
                                    line: 16,
                                    column: 69,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                }
                            }
                        }
                    },
                    {
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'clientOutput',
                            loc: {
                                start: {
                                    line: 17,
                                    column: 8,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                },
                                end: {
                                    line: 17,
                                    column: 20,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'output',
                                    loc: {
                                        start: {
                                            line: 17,
                                            column: 23,
                                            fixed: true,
                                            source: 'ion/builder/WebsiteBuilder.ion'
                                        },
                                        end: {
                                            line: 17,
                                            column: 29,
                                            fixed: true,
                                            source: 'ion/builder/WebsiteBuilder.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'getDirectory',
                                    loc: {
                                        start: {
                                            line: 17,
                                            column: 30,
                                            fixed: true,
                                            source: 'ion/builder/WebsiteBuilder.ion'
                                        },
                                        end: {
                                            line: 17,
                                            column: 42,
                                            fixed: true,
                                            source: 'ion/builder/WebsiteBuilder.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 17,
                                        column: 23,
                                        fixed: true,
                                        source: 'ion/builder/WebsiteBuilder.ion'
                                    },
                                    end: {
                                        line: 17,
                                        column: 42,
                                        fixed: true,
                                        source: 'ion/builder/WebsiteBuilder.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'Identifier',
                                    name: 'clientJsDir',
                                    loc: {
                                        start: {
                                            line: 17,
                                            column: 43,
                                            fixed: true,
                                            source: 'ion/builder/WebsiteBuilder.ion'
                                        },
                                        end: {
                                            line: 17,
                                            column: 54,
                                            fixed: true,
                                            source: 'ion/builder/WebsiteBuilder.ion'
                                        }
                                    }
                                }],
                            loc: {
                                start: {
                                    line: 17,
                                    column: 23,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                },
                                end: {
                                    line: 17,
                                    column: 55,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                }
                            }
                        }
                    },
                    {
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'serverOutput',
                            loc: {
                                start: {
                                    line: 18,
                                    column: 8,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                },
                                end: {
                                    line: 18,
                                    column: 20,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'output',
                                    loc: {
                                        start: {
                                            line: 18,
                                            column: 23,
                                            fixed: true,
                                            source: 'ion/builder/WebsiteBuilder.ion'
                                        },
                                        end: {
                                            line: 18,
                                            column: 29,
                                            fixed: true,
                                            source: 'ion/builder/WebsiteBuilder.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'getDirectory',
                                    loc: {
                                        start: {
                                            line: 18,
                                            column: 30,
                                            fixed: true,
                                            source: 'ion/builder/WebsiteBuilder.ion'
                                        },
                                        end: {
                                            line: 18,
                                            column: 42,
                                            fixed: true,
                                            source: 'ion/builder/WebsiteBuilder.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 18,
                                        column: 23,
                                        fixed: true,
                                        source: 'ion/builder/WebsiteBuilder.ion'
                                    },
                                    end: {
                                        line: 18,
                                        column: 42,
                                        fixed: true,
                                        source: 'ion/builder/WebsiteBuilder.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'Identifier',
                                    name: 'serverJsDir',
                                    loc: {
                                        start: {
                                            line: 18,
                                            column: 43,
                                            fixed: true,
                                            source: 'ion/builder/WebsiteBuilder.ion'
                                        },
                                        end: {
                                            line: 18,
                                            column: 54,
                                            fixed: true,
                                            source: 'ion/builder/WebsiteBuilder.ion'
                                        }
                                    }
                                }],
                            loc: {
                                start: {
                                    line: 18,
                                    column: 23,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                },
                                end: {
                                    line: 18,
                                    column: 55,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                }
                            }
                        }
                    },
                    {
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'nodepaths',
                            loc: {
                                start: {
                                    line: 19,
                                    column: 8,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                },
                                end: {
                                    line: 19,
                                    column: 17,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ArrayExpression',
                            elements: [{
                                    type: 'Literal',
                                    value: 'node_modules'
                                }]
                        }
                    }
                ],
                kind: 'const',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'glassPages',
                            loc: {
                                start: {
                                    line: 23,
                                    column: 8,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                },
                                end: {
                                    line: 23,
                                    column: 18,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                }
                            }
                        },
                        init: {
                            type: 'NewExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Directory',
                                loc: {
                                    start: {
                                        line: 23,
                                        column: 25,
                                        fixed: true,
                                        source: 'ion/builder/WebsiteBuilder.ion'
                                    },
                                    end: {
                                        line: 23,
                                        column: 34,
                                        fixed: true,
                                        source: 'ion/builder/WebsiteBuilder.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'Literal',
                                    value: '../glass-pages/dist'
                                }],
                            loc: {
                                start: {
                                    line: 23,
                                    column: 21,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                },
                                end: {
                                    line: 23,
                                    column: 57,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'IfStatement',
                test: {
                    type: 'MemberExpression',
                    computed: false,
                    object: {
                        type: 'Identifier',
                        name: 'glassPages',
                        loc: {
                            start: {
                                line: 24,
                                column: 7,
                                fixed: true,
                                source: 'ion/builder/WebsiteBuilder.ion'
                            },
                            end: {
                                line: 24,
                                column: 17,
                                fixed: true,
                                source: 'ion/builder/WebsiteBuilder.ion'
                            }
                        }
                    },
                    property: {
                        type: 'Identifier',
                        name: 'exists',
                        loc: {
                            start: {
                                line: 24,
                                column: 18,
                                fixed: true,
                                source: 'ion/builder/WebsiteBuilder.ion'
                            },
                            end: {
                                line: 24,
                                column: 24,
                                fixed: true,
                                source: 'ion/builder/WebsiteBuilder.ion'
                            }
                        }
                    },
                    loc: {
                        start: {
                            line: 24,
                            column: 7,
                            fixed: true,
                            source: 'ion/builder/WebsiteBuilder.ion'
                        },
                        end: {
                            line: 24,
                            column: 24,
                            fixed: true,
                            source: 'ion/builder/WebsiteBuilder.ion'
                        }
                    }
                },
                consequent: {
                    type: 'BlockStatement',
                    body: [
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'javaDirectory',
                                        loc: {
                                            start: {
                                                line: 25,
                                                column: 12,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            },
                                            end: {
                                                line: 25,
                                                column: 25,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'input',
                                                loc: {
                                                    start: {
                                                        line: 25,
                                                        column: 28,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    },
                                                    end: {
                                                        line: 25,
                                                        column: 33,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'getDirectory',
                                                loc: {
                                                    start: {
                                                        line: 25,
                                                        column: 34,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    },
                                                    end: {
                                                        line: 25,
                                                        column: 46,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 25,
                                                    column: 28,
                                                    fixed: true,
                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                },
                                                end: {
                                                    line: 25,
                                                    column: 46,
                                                    fixed: true,
                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                }
                                            }
                                        },
                                        arguments: [{
                                                type: 'Identifier',
                                                name: 'serverJavaDir',
                                                loc: {
                                                    start: {
                                                        line: 25,
                                                        column: 47,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    },
                                                    end: {
                                                        line: 25,
                                                        column: 60,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    }
                                                }
                                            }],
                                        loc: {
                                            start: {
                                                line: 25,
                                                column: 28,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            },
                                            end: {
                                                line: 25,
                                                column: 61,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '0'
                        },
                        {
                            type: 'ForInStatement',
                            left: {
                                type: 'VariableDeclaration',
                                declarations: [
                                    {
                                        type: 'VariableDeclarator',
                                        id: {
                                            type: 'Identifier',
                                            name: 'key',
                                            loc: {
                                                start: {
                                                    line: 26,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                },
                                                end: {
                                                    line: 26,
                                                    column: 15,
                                                    fixed: true,
                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                }
                                            }
                                        },
                                        init: null
                                    },
                                    {
                                        type: 'VariableDeclarator',
                                        id: {
                                            type: 'Identifier',
                                            name: 'source',
                                            loc: {
                                                start: {
                                                    line: 26,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                },
                                                end: {
                                                    line: 26,
                                                    column: 23,
                                                    fixed: true,
                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                }
                                            }
                                        },
                                        init: null
                                    }
                                ],
                                kind: 'let'
                            },
                            right: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'glassPages',
                                        loc: {
                                            start: {
                                                line: 26,
                                                column: 27,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            },
                                            end: {
                                                line: 26,
                                                column: 37,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'search',
                                        loc: {
                                            start: {
                                                line: 26,
                                                column: 38,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            },
                                            end: {
                                                line: 26,
                                                column: 44,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 26,
                                            column: 27,
                                            fixed: true,
                                            source: 'ion/builder/WebsiteBuilder.ion'
                                        },
                                        end: {
                                            line: 26,
                                            column: 44,
                                            fixed: true,
                                            source: 'ion/builder/WebsiteBuilder.ion'
                                        }
                                    }
                                },
                                arguments: [],
                                loc: {
                                    start: {
                                        line: 26,
                                        column: 27,
                                        fixed: true,
                                        source: 'ion/builder/WebsiteBuilder.ion'
                                    },
                                    end: {
                                        line: 26,
                                        column: 46,
                                        fixed: true,
                                        source: 'ion/builder/WebsiteBuilder.ion'
                                    }
                                }
                            },
                            body: {
                                type: 'BlockStatement',
                                body: [
                                    {
                                        type: 'VariableDeclaration',
                                        declarations: [{
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'target',
                                                    loc: {
                                                        start: {
                                                            line: 27,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 27,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        }
                                                    }
                                                },
                                                init: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'javaDirectory',
                                                            loc: {
                                                                start: {
                                                                    line: 27,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                },
                                                                end: {
                                                                    line: 27,
                                                                    column: 38,
                                                                    fixed: true,
                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'getFile',
                                                            loc: {
                                                                start: {
                                                                    line: 27,
                                                                    column: 39,
                                                                    fixed: true,
                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                },
                                                                end: {
                                                                    line: 27,
                                                                    column: 46,
                                                                    fixed: true,
                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 27,
                                                                column: 25,
                                                                fixed: true,
                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                            },
                                                            end: {
                                                                line: 27,
                                                                column: 46,
                                                                fixed: true,
                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [{
                                                            type: 'Identifier',
                                                            name: 'key',
                                                            loc: {
                                                                start: {
                                                                    line: 27,
                                                                    column: 47,
                                                                    fixed: true,
                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                },
                                                                end: {
                                                                    line: 27,
                                                                    column: 50,
                                                                    fixed: true,
                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                }
                                                            }
                                                        }],
                                                    loc: {
                                                        start: {
                                                            line: 27,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 27,
                                                            column: 51,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        }
                                                    }
                                                }
                                            }],
                                        kind: 'let',
                                        order: '0'
                                    },
                                    {
                                        type: 'IfStatement',
                                        test: {
                                            type: 'BinaryExpression',
                                            operator: '<',
                                            left: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'target',
                                                    loc: {
                                                        start: {
                                                            line: 28,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 28,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'modified',
                                                    loc: {
                                                        start: {
                                                            line: 28,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 28,
                                                            column: 30,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 28,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    },
                                                    end: {
                                                        line: 28,
                                                        column: 30,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    }
                                                }
                                            },
                                            right: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'source',
                                                    loc: {
                                                        start: {
                                                            line: 28,
                                                            column: 33,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 28,
                                                            column: 39,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'modified',
                                                    loc: {
                                                        start: {
                                                            line: 28,
                                                            column: 40,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 28,
                                                            column: 48,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 28,
                                                        column: 33,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    },
                                                    end: {
                                                        line: 28,
                                                        column: 48,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    }
                                                }
                                            }
                                        },
                                        consequent: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'target',
                                                                loc: {
                                                                    start: {
                                                                        line: 29,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 29,
                                                                        column: 22,
                                                                        fixed: true,
                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'copyFrom',
                                                                loc: {
                                                                    start: {
                                                                        line: 29,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 29,
                                                                        column: 31,
                                                                        fixed: true,
                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 29,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                },
                                                                end: {
                                                                    line: 29,
                                                                    column: 31,
                                                                    fixed: true,
                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [{
                                                                type: 'Identifier',
                                                                name: 'source',
                                                                loc: {
                                                                    start: {
                                                                        line: 29,
                                                                        column: 32,
                                                                        fixed: true,
                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 29,
                                                                        column: 38,
                                                                        fixed: true,
                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                    }
                                                                }
                                                            }],
                                                        loc: {
                                                            start: {
                                                                line: 29,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                            },
                                                            end: {
                                                                line: 29,
                                                                column: 39,
                                                                fixed: true,
                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 29,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 29,
                                                            column: 39,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        alternate: null,
                                        order: '1'
                                    }
                                ]
                            },
                            remove: null,
                            order: '1'
                        }
                    ]
                },
                alternate: null,
                order: '2'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'copyModules',
                            loc: {
                                start: {
                                    line: 31,
                                    column: 8,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                },
                                end: {
                                    line: 31,
                                    column: 19,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                }
                            }
                        },
                        init: {
                            type: 'Function',
                            context: true,
                            value: function (_ps) {
                                return ion.template(function (modules, outputDirectory) {
                                    return ion.createRuntime({
                                        type: 'Template',
                                        id: null,
                                        body: [{
                                                type: 'ForOfStatement',
                                                left: {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'moduleName',
                                                                loc: {
                                                                    start: {
                                                                        line: 32,
                                                                        column: 12,
                                                                        fixed: true,
                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 32,
                                                                        column: 22,
                                                                        fixed: true,
                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: null
                                                        }],
                                                    kind: 'let'
                                                },
                                                right: {
                                                    type: 'Identifier',
                                                    name: 'modules',
                                                    loc: {
                                                        start: {
                                                            line: 32,
                                                            column: 26,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 32,
                                                            column: 33,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        }
                                                    }
                                                },
                                                body: {
                                                    type: 'BlockStatement',
                                                    body: [{
                                                            type: 'ForOfStatement',
                                                            left: {
                                                                type: 'VariableDeclaration',
                                                                declarations: [{
                                                                        type: 'VariableDeclarator',
                                                                        id: {
                                                                            type: 'Identifier',
                                                                            name: 'nodepath',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 33,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 33,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        init: null
                                                                    }],
                                                                kind: 'let'
                                                            },
                                                            right: {
                                                                type: 'Identifier',
                                                                name: 'nodepaths',
                                                                loc: {
                                                                    start: {
                                                                        line: 33,
                                                                        column: 28,
                                                                        fixed: true,
                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 33,
                                                                        column: 37,
                                                                        fixed: true,
                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                    }
                                                                }
                                                            },
                                                            body: {
                                                                type: 'BlockStatement',
                                                                body: [
                                                                    {
                                                                        type: 'VariableDeclaration',
                                                                        declarations: [{
                                                                                type: 'VariableDeclarator',
                                                                                id: {
                                                                                    type: 'Identifier',
                                                                                    name: 'directory',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 34,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 34,
                                                                                            column: 29,
                                                                                            fixed: true,
                                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                init: {
                                                                                    type: 'NewExpression',
                                                                                    callee: {
                                                                                        type: 'Identifier',
                                                                                        name: 'Directory',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 34,
                                                                                                column: 36,
                                                                                                fixed: true,
                                                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 34,
                                                                                                column: 45,
                                                                                                fixed: true,
                                                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    arguments: [{
                                                                                            type: 'CallExpression',
                                                                                            callee: {
                                                                                                type: 'MemberExpression',
                                                                                                computed: false,
                                                                                                object: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'np',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 34,
                                                                                                            column: 46,
                                                                                                            fixed: true,
                                                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 34,
                                                                                                            column: 48,
                                                                                                            fixed: true,
                                                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'join',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 34,
                                                                                                            column: 49,
                                                                                                            fixed: true,
                                                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 34,
                                                                                                            column: 53,
                                                                                                            fixed: true,
                                                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 34,
                                                                                                        column: 46,
                                                                                                        fixed: true,
                                                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 34,
                                                                                                        column: 53,
                                                                                                        fixed: true,
                                                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            arguments: [
                                                                                                {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'nodepath',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 34,
                                                                                                            column: 54,
                                                                                                            fixed: true,
                                                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 34,
                                                                                                            column: 62,
                                                                                                            fixed: true,
                                                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                {
                                                                                                    type: 'BinaryExpression',
                                                                                                    operator: '+',
                                                                                                    left: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'moduleName',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 34,
                                                                                                                column: 64,
                                                                                                                fixed: true,
                                                                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 34,
                                                                                                                column: 74,
                                                                                                                fixed: true,
                                                                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    right: {
                                                                                                        type: 'Literal',
                                                                                                        value: '/lib'
                                                                                                    }
                                                                                                }
                                                                                            ],
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 34,
                                                                                                    column: 46,
                                                                                                    fixed: true,
                                                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 34,
                                                                                                    column: 84,
                                                                                                    fixed: true,
                                                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                }
                                                                                            }
                                                                                        }],
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 34,
                                                                                            column: 32,
                                                                                            fixed: true,
                                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 34,
                                                                                            column: 85,
                                                                                            fixed: true,
                                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                                        }
                                                                                    }
                                                                                }
                                                                            }],
                                                                        kind: 'let',
                                                                        order: '0'
                                                                    },
                                                                    {
                                                                        type: 'ForInStatement',
                                                                        left: {
                                                                            type: 'VariableDeclaration',
                                                                            declarations: [
                                                                                {
                                                                                    type: 'VariableDeclarator',
                                                                                    id: {
                                                                                        type: 'Identifier',
                                                                                        name: 'key',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 35,
                                                                                                column: 20,
                                                                                                fixed: true,
                                                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 35,
                                                                                                column: 23,
                                                                                                fixed: true,
                                                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    init: null
                                                                                },
                                                                                {
                                                                                    type: 'VariableDeclarator',
                                                                                    id: {
                                                                                        type: 'Identifier',
                                                                                        name: 'source',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 35,
                                                                                                column: 25,
                                                                                                fixed: true,
                                                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 35,
                                                                                                column: 31,
                                                                                                fixed: true,
                                                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    init: null
                                                                                }
                                                                            ],
                                                                            kind: 'let'
                                                                        },
                                                                        right: {
                                                                            type: 'CallExpression',
                                                                            callee: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'Identifier',
                                                                                    name: 'directory',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 35,
                                                                                            column: 35,
                                                                                            fixed: true,
                                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 35,
                                                                                            column: 44,
                                                                                            fixed: true,
                                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'search',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 35,
                                                                                            column: 45,
                                                                                            fixed: true,
                                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 35,
                                                                                            column: 51,
                                                                                            fixed: true,
                                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 35,
                                                                                        column: 35,
                                                                                        fixed: true,
                                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 35,
                                                                                        column: 51,
                                                                                        fixed: true,
                                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            arguments: [
                                                                                {
                                                                                    type: 'ArrayExpression',
                                                                                    elements: [
                                                                                        {
                                                                                            type: 'Literal',
                                                                                            value: '.js'
                                                                                        },
                                                                                        {
                                                                                            type: 'Literal',
                                                                                            value: '.map'
                                                                                        },
                                                                                        {
                                                                                            type: 'Literal',
                                                                                            value: '.json'
                                                                                        }
                                                                                    ]
                                                                                },
                                                                                {
                                                                                    type: 'CallExpression',
                                                                                    callee: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'ArrayExpression',
                                                                                            elements: []
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'concat',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 35,
                                                                                                    column: 79,
                                                                                                    fixed: true,
                                                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 35,
                                                                                                    column: 85,
                                                                                                    fixed: true,
                                                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 35,
                                                                                                column: 76,
                                                                                                fixed: true,
                                                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 35,
                                                                                                column: 85,
                                                                                                fixed: true,
                                                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    arguments: [{
                                                                                            type: 'MemberExpression',
                                                                                            computed: false,
                                                                                            object: {
                                                                                                type: 'MemberExpression',
                                                                                                computed: false,
                                                                                                object: {
                                                                                                    type: 'MemberExpression',
                                                                                                    computed: false,
                                                                                                    object: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'packageJson',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 35,
                                                                                                                column: 86,
                                                                                                                fixed: true,
                                                                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 35,
                                                                                                                column: 97,
                                                                                                                fixed: true,
                                                                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    property: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'build',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 35,
                                                                                                                column: 98,
                                                                                                                fixed: true,
                                                                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 35,
                                                                                                                column: 103,
                                                                                                                fixed: true,
                                                                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 35,
                                                                                                            column: 86,
                                                                                                            fixed: true,
                                                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 35,
                                                                                                            column: 103,
                                                                                                            fixed: true,
                                                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'client',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 35,
                                                                                                            column: 104,
                                                                                                            fixed: true,
                                                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 35,
                                                                                                            column: 110,
                                                                                                            fixed: true,
                                                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 35,
                                                                                                        column: 86,
                                                                                                        fixed: true,
                                                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 35,
                                                                                                        column: 110,
                                                                                                        fixed: true,
                                                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            property: {
                                                                                                type: 'Identifier',
                                                                                                name: 'exclude',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 35,
                                                                                                        column: 111,
                                                                                                        fixed: true,
                                                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 35,
                                                                                                        column: 118,
                                                                                                        fixed: true,
                                                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 35,
                                                                                                    column: 86,
                                                                                                    fixed: true,
                                                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 35,
                                                                                                    column: 118,
                                                                                                    fixed: true,
                                                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                }
                                                                                            }
                                                                                        }],
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 35,
                                                                                            column: 76,
                                                                                            fixed: true,
                                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 35,
                                                                                            column: 119,
                                                                                            fixed: true,
                                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                                        }
                                                                                    }
                                                                                }
                                                                            ],
                                                                            loc: {
                                                                                start: {
                                                                                    line: 35,
                                                                                    column: 35,
                                                                                    fixed: true,
                                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 35,
                                                                                    column: 120,
                                                                                    fixed: true,
                                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        body: {
                                                                            type: 'BlockStatement',
                                                                            body: [
                                                                                {
                                                                                    type: 'VariableDeclaration',
                                                                                    declarations: [{
                                                                                            type: 'VariableDeclarator',
                                                                                            id: {
                                                                                                type: 'Identifier',
                                                                                                name: 'target',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 36,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 36,
                                                                                                        column: 30,
                                                                                                        fixed: true,
                                                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            init: {
                                                                                                type: 'CallExpression',
                                                                                                callee: {
                                                                                                    type: 'MemberExpression',
                                                                                                    computed: false,
                                                                                                    object: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'outputDirectory',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 36,
                                                                                                                column: 33,
                                                                                                                fixed: true,
                                                                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 36,
                                                                                                                column: 48,
                                                                                                                fixed: true,
                                                                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    property: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'getFile',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 36,
                                                                                                                column: 49,
                                                                                                                fixed: true,
                                                                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 36,
                                                                                                                column: 56,
                                                                                                                fixed: true,
                                                                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 36,
                                                                                                            column: 33,
                                                                                                            fixed: true,
                                                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 36,
                                                                                                            column: 56,
                                                                                                            fixed: true,
                                                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                arguments: [{
                                                                                                        type: 'CallExpression',
                                                                                                        callee: {
                                                                                                            type: 'MemberExpression',
                                                                                                            computed: false,
                                                                                                            object: {
                                                                                                                type: 'MemberExpression',
                                                                                                                computed: false,
                                                                                                                object: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'source',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 36,
                                                                                                                            column: 57,
                                                                                                                            fixed: true,
                                                                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 36,
                                                                                                                            column: 63,
                                                                                                                            fixed: true,
                                                                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                property: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'path',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 36,
                                                                                                                            column: 64,
                                                                                                                            fixed: true,
                                                                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 36,
                                                                                                                            column: 68,
                                                                                                                            fixed: true,
                                                                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 36,
                                                                                                                        column: 57,
                                                                                                                        fixed: true,
                                                                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 36,
                                                                                                                        column: 68,
                                                                                                                        fixed: true,
                                                                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            property: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'substring',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 36,
                                                                                                                        column: 69,
                                                                                                                        fixed: true,
                                                                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 36,
                                                                                                                        column: 78,
                                                                                                                        fixed: true,
                                                                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 36,
                                                                                                                    column: 57,
                                                                                                                    fixed: true,
                                                                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 36,
                                                                                                                    column: 78,
                                                                                                                    fixed: true,
                                                                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        arguments: [{
                                                                                                                type: 'MemberExpression',
                                                                                                                computed: false,
                                                                                                                object: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'nodepath',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 36,
                                                                                                                            column: 79,
                                                                                                                            fixed: true,
                                                                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 36,
                                                                                                                            column: 87,
                                                                                                                            fixed: true,
                                                                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                property: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'length',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 36,
                                                                                                                            column: 88,
                                                                                                                            fixed: true,
                                                                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 36,
                                                                                                                            column: 94,
                                                                                                                            fixed: true,
                                                                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 36,
                                                                                                                        column: 79,
                                                                                                                        fixed: true,
                                                                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 36,
                                                                                                                        column: 94,
                                                                                                                        fixed: true,
                                                                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            }],
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 36,
                                                                                                                column: 57,
                                                                                                                fixed: true,
                                                                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 36,
                                                                                                                column: 95,
                                                                                                                fixed: true,
                                                                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    }],
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 36,
                                                                                                        column: 33,
                                                                                                        fixed: true,
                                                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 36,
                                                                                                        column: 96,
                                                                                                        fixed: true,
                                                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        }],
                                                                                    kind: 'let',
                                                                                    order: '0'
                                                                                },
                                                                                {
                                                                                    type: 'IfStatement',
                                                                                    test: {
                                                                                        type: 'BinaryExpression',
                                                                                        operator: '<',
                                                                                        left: {
                                                                                            type: 'MemberExpression',
                                                                                            computed: false,
                                                                                            object: {
                                                                                                type: 'Identifier',
                                                                                                name: 'target',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 37,
                                                                                                        column: 23,
                                                                                                        fixed: true,
                                                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 37,
                                                                                                        column: 29,
                                                                                                        fixed: true,
                                                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            property: {
                                                                                                type: 'Identifier',
                                                                                                name: 'modified',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 37,
                                                                                                        column: 30,
                                                                                                        fixed: true,
                                                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 37,
                                                                                                        column: 38,
                                                                                                        fixed: true,
                                                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 37,
                                                                                                    column: 23,
                                                                                                    fixed: true,
                                                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 37,
                                                                                                    column: 38,
                                                                                                    fixed: true,
                                                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        right: {
                                                                                            type: 'MemberExpression',
                                                                                            computed: false,
                                                                                            object: {
                                                                                                type: 'Identifier',
                                                                                                name: 'source',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 37,
                                                                                                        column: 41,
                                                                                                        fixed: true,
                                                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 37,
                                                                                                        column: 47,
                                                                                                        fixed: true,
                                                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            property: {
                                                                                                type: 'Identifier',
                                                                                                name: 'modified',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 37,
                                                                                                        column: 48,
                                                                                                        fixed: true,
                                                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 37,
                                                                                                        column: 56,
                                                                                                        fixed: true,
                                                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 37,
                                                                                                    column: 41,
                                                                                                    fixed: true,
                                                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 37,
                                                                                                    column: 56,
                                                                                                    fixed: true,
                                                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                }
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    consequent: {
                                                                                        type: 'BlockStatement',
                                                                                        body: [{
                                                                                                type: 'ExpressionStatement',
                                                                                                expression: {
                                                                                                    type: 'CallExpression',
                                                                                                    callee: {
                                                                                                        type: 'MemberExpression',
                                                                                                        computed: false,
                                                                                                        object: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'target',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 38,
                                                                                                                    column: 24,
                                                                                                                    fixed: true,
                                                                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 38,
                                                                                                                    column: 30,
                                                                                                                    fixed: true,
                                                                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        property: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'copyFrom',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 38,
                                                                                                                    column: 31,
                                                                                                                    fixed: true,
                                                                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 38,
                                                                                                                    column: 39,
                                                                                                                    fixed: true,
                                                                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 38,
                                                                                                                column: 24,
                                                                                                                fixed: true,
                                                                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 38,
                                                                                                                column: 39,
                                                                                                                fixed: true,
                                                                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    arguments: [{
                                                                                                            type: 'Identifier',
                                                                                                            name: 'source',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 38,
                                                                                                                    column: 40,
                                                                                                                    fixed: true,
                                                                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 38,
                                                                                                                    column: 46,
                                                                                                                    fixed: true,
                                                                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        }],
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 38,
                                                                                                            column: 24,
                                                                                                            fixed: true,
                                                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 38,
                                                                                                            column: 47,
                                                                                                            fixed: true,
                                                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 38,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 38,
                                                                                                        column: 47,
                                                                                                        fixed: true,
                                                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                    }
                                                                                                },
                                                                                                order: '0'
                                                                                            }]
                                                                                    },
                                                                                    alternate: null,
                                                                                    order: '1'
                                                                                }
                                                                            ]
                                                                        },
                                                                        remove: {
                                                                            type: 'BlockStatement',
                                                                            body: [{
                                                                                    type: 'ExpressionStatement',
                                                                                    expression: {
                                                                                        type: 'CallExpression',
                                                                                        callee: {
                                                                                            type: 'MemberExpression',
                                                                                            computed: false,
                                                                                            object: {
                                                                                                type: 'Identifier',
                                                                                                name: 'target',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 40,
                                                                                                        column: 20,
                                                                                                        fixed: true,
                                                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 40,
                                                                                                        column: 26,
                                                                                                        fixed: true,
                                                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            property: {
                                                                                                type: 'Identifier',
                                                                                                name: 'delete',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 40,
                                                                                                        column: 27,
                                                                                                        fixed: true,
                                                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 40,
                                                                                                        column: 33,
                                                                                                        fixed: true,
                                                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 40,
                                                                                                    column: 20,
                                                                                                    fixed: true,
                                                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 40,
                                                                                                    column: 33,
                                                                                                    fixed: true,
                                                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        arguments: [],
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 40,
                                                                                                column: 20,
                                                                                                fixed: true,
                                                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 40,
                                                                                                column: 35,
                                                                                                fixed: true,
                                                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 40,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 40,
                                                                                            column: 35,
                                                                                            fixed: true,
                                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                                        }
                                                                                    },
                                                                                    order: '0'
                                                                                }]
                                                                        },
                                                                        order: '1'
                                                                    }
                                                                ]
                                                            },
                                                            remove: null,
                                                            order: '0'
                                                        }]
                                                },
                                                remove: null,
                                                order: '0'
                                            }],
                                        bound: false,
                                        name: {
                                            type: 'Identifier',
                                            name: 'copyModules',
                                            loc: {
                                                start: {
                                                    line: 31,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                },
                                                end: {
                                                    line: 31,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                }
                                            }
                                        },
                                        scope: {
                                            type: 'Identifier',
                                            name: '_ps'
                                        }
                                    }, {
                                        this: this,
                                        modules: modules,
                                        outputDirectory: outputDirectory,
                                        _ps: _ps,
                                        ion: ion,
                                        _ref: _ref,
                                        _ref2: _ref2,
                                        clientJsDir: clientJsDir,
                                        serverJsDir: serverJsDir,
                                        serverJavaDir: serverJavaDir,
                                        np: np,
                                        fs: fs,
                                        builder: builder,
                                        File: File,
                                        Directory: Directory,
                                        utility: utility,
                                        ModuleBuilder: ModuleBuilder
                                    }, _ps);
                                });
                            }
                        }
                    }],
                kind: 'let',
                order: '3'
            },
            {
                type: 'ExpressionStatement',
                expression: {
                    type: 'CallExpression',
                    callee: {
                        type: 'Identifier',
                        name: 'copyModules',
                        loc: {
                            start: {
                                line: 42,
                                column: 4,
                                fixed: true,
                                source: 'ion/builder/WebsiteBuilder.ion'
                            },
                            end: {
                                line: 42,
                                column: 15,
                                fixed: true,
                                source: 'ion/builder/WebsiteBuilder.ion'
                            }
                        }
                    },
                    arguments: [
                        {
                            type: 'MemberExpression',
                            computed: false,
                            object: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'packageJson',
                                        loc: {
                                            start: {
                                                line: 42,
                                                column: 16,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            },
                                            end: {
                                                line: 42,
                                                column: 27,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'build',
                                        loc: {
                                            start: {
                                                line: 42,
                                                column: 28,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            },
                                            end: {
                                                line: 42,
                                                column: 33,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 42,
                                            column: 16,
                                            fixed: true,
                                            source: 'ion/builder/WebsiteBuilder.ion'
                                        },
                                        end: {
                                            line: 42,
                                            column: 33,
                                            fixed: true,
                                            source: 'ion/builder/WebsiteBuilder.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'client',
                                    loc: {
                                        start: {
                                            line: 42,
                                            column: 34,
                                            fixed: true,
                                            source: 'ion/builder/WebsiteBuilder.ion'
                                        },
                                        end: {
                                            line: 42,
                                            column: 40,
                                            fixed: true,
                                            source: 'ion/builder/WebsiteBuilder.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 42,
                                        column: 16,
                                        fixed: true,
                                        source: 'ion/builder/WebsiteBuilder.ion'
                                    },
                                    end: {
                                        line: 42,
                                        column: 40,
                                        fixed: true,
                                        source: 'ion/builder/WebsiteBuilder.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'modules',
                                loc: {
                                    start: {
                                        line: 42,
                                        column: 41,
                                        fixed: true,
                                        source: 'ion/builder/WebsiteBuilder.ion'
                                    },
                                    end: {
                                        line: 42,
                                        column: 48,
                                        fixed: true,
                                        source: 'ion/builder/WebsiteBuilder.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 42,
                                    column: 16,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                },
                                end: {
                                    line: 42,
                                    column: 48,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                }
                            }
                        },
                        {
                            type: 'Identifier',
                            name: 'clientOutput',
                            loc: {
                                start: {
                                    line: 42,
                                    column: 50,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                },
                                end: {
                                    line: 42,
                                    column: 62,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                }
                            }
                        }
                    ],
                    loc: {
                        start: {
                            line: 42,
                            column: 4,
                            fixed: true,
                            source: 'ion/builder/WebsiteBuilder.ion'
                        },
                        end: {
                            line: 42,
                            column: 63,
                            fixed: true,
                            source: 'ion/builder/WebsiteBuilder.ion'
                        }
                    }
                },
                loc: {
                    start: {
                        line: 42,
                        column: 4,
                        fixed: true,
                        source: 'ion/builder/WebsiteBuilder.ion'
                    },
                    end: {
                        line: 42,
                        column: 63,
                        fixed: true,
                        source: 'ion/builder/WebsiteBuilder.ion'
                    }
                },
                order: '4'
            },
            {
                type: 'ExpressionStatement',
                expression: {
                    type: 'CallExpression',
                    callee: {
                        type: 'Identifier',
                        name: 'copyModules',
                        loc: {
                            start: {
                                line: 43,
                                column: 4,
                                fixed: true,
                                source: 'ion/builder/WebsiteBuilder.ion'
                            },
                            end: {
                                line: 43,
                                column: 15,
                                fixed: true,
                                source: 'ion/builder/WebsiteBuilder.ion'
                            }
                        }
                    },
                    arguments: [
                        {
                            type: 'MemberExpression',
                            computed: false,
                            object: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'packageJson',
                                        loc: {
                                            start: {
                                                line: 43,
                                                column: 16,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            },
                                            end: {
                                                line: 43,
                                                column: 27,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'build',
                                        loc: {
                                            start: {
                                                line: 43,
                                                column: 28,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            },
                                            end: {
                                                line: 43,
                                                column: 33,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 43,
                                            column: 16,
                                            fixed: true,
                                            source: 'ion/builder/WebsiteBuilder.ion'
                                        },
                                        end: {
                                            line: 43,
                                            column: 33,
                                            fixed: true,
                                            source: 'ion/builder/WebsiteBuilder.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'server',
                                    loc: {
                                        start: {
                                            line: 43,
                                            column: 34,
                                            fixed: true,
                                            source: 'ion/builder/WebsiteBuilder.ion'
                                        },
                                        end: {
                                            line: 43,
                                            column: 40,
                                            fixed: true,
                                            source: 'ion/builder/WebsiteBuilder.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 43,
                                        column: 16,
                                        fixed: true,
                                        source: 'ion/builder/WebsiteBuilder.ion'
                                    },
                                    end: {
                                        line: 43,
                                        column: 40,
                                        fixed: true,
                                        source: 'ion/builder/WebsiteBuilder.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'modules',
                                loc: {
                                    start: {
                                        line: 43,
                                        column: 41,
                                        fixed: true,
                                        source: 'ion/builder/WebsiteBuilder.ion'
                                    },
                                    end: {
                                        line: 43,
                                        column: 48,
                                        fixed: true,
                                        source: 'ion/builder/WebsiteBuilder.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 43,
                                    column: 16,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                },
                                end: {
                                    line: 43,
                                    column: 48,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                }
                            }
                        },
                        {
                            type: 'Identifier',
                            name: 'serverOutput',
                            loc: {
                                start: {
                                    line: 43,
                                    column: 50,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                },
                                end: {
                                    line: 43,
                                    column: 62,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                }
                            }
                        }
                    ],
                    loc: {
                        start: {
                            line: 43,
                            column: 4,
                            fixed: true,
                            source: 'ion/builder/WebsiteBuilder.ion'
                        },
                        end: {
                            line: 43,
                            column: 63,
                            fixed: true,
                            source: 'ion/builder/WebsiteBuilder.ion'
                        }
                    }
                },
                loc: {
                    start: {
                        line: 43,
                        column: 4,
                        fixed: true,
                        source: 'ion/builder/WebsiteBuilder.ion'
                    },
                    end: {
                        line: 43,
                        column: 63,
                        fixed: true,
                        source: 'ion/builder/WebsiteBuilder.ion'
                    }
                },
                order: '5'
            },
            {
                type: 'ExpressionStatement',
                expression: {
                    type: 'CallExpression',
                    callee: {
                        type: 'Identifier',
                        name: 'ModuleBuilder',
                        loc: {
                            start: {
                                line: 46,
                                column: 4,
                                fixed: true,
                                source: 'ion/builder/WebsiteBuilder.ion'
                            },
                            end: {
                                line: 46,
                                column: 17,
                                fixed: true,
                                source: 'ion/builder/WebsiteBuilder.ion'
                            }
                        }
                    },
                    arguments: [{
                            type: 'ObjectExpression',
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'directories',
                                        loc: {
                                            start: {
                                                line: 47,
                                                column: 8,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            },
                                            end: {
                                                line: 47,
                                                column: 19,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'src',
                                                    loc: {
                                                        start: {
                                                            line: 48,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 48,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'BinaryExpression',
                                                    operator: '+',
                                                    left: {
                                                        type: 'Identifier',
                                                        name: 'input',
                                                        loc: {
                                                            start: {
                                                                line: 48,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                            },
                                                            end: {
                                                                line: 48,
                                                                column: 21,
                                                                fixed: true,
                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                            }
                                                        }
                                                    },
                                                    right: {
                                                        type: 'Literal',
                                                        value: '/js'
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'lib',
                                                    loc: {
                                                        start: {
                                                            line: 49,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 49,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'BinaryExpression',
                                                    operator: '+',
                                                    left: {
                                                        type: 'BinaryExpression',
                                                        operator: '+',
                                                        left: {
                                                            type: 'Identifier',
                                                            name: 'output',
                                                            loc: {
                                                                start: {
                                                                    line: 49,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                },
                                                                end: {
                                                                    line: 49,
                                                                    column: 22,
                                                                    fixed: true,
                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                }
                                                            }
                                                        },
                                                        right: {
                                                            type: 'Literal',
                                                            value: '/'
                                                        }
                                                    },
                                                    right: {
                                                        type: 'Identifier',
                                                        name: 'clientJsDir',
                                                        loc: {
                                                            start: {
                                                                line: 49,
                                                                column: 31,
                                                                fixed: true,
                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                            },
                                                            end: {
                                                                line: 49,
                                                                column: 42,
                                                                fixed: true,
                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                            }
                                                        }
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'build',
                                        loc: {
                                            start: {
                                                line: 50,
                                                column: 8,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            },
                                            end: {
                                                line: 50,
                                                column: 13,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'exclude',
                                                    loc: {
                                                        start: {
                                                            line: 51,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 51,
                                                            column: 19,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'packageJson',
                                                                loc: {
                                                                    start: {
                                                                        line: 51,
                                                                        column: 21,
                                                                        fixed: true,
                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 51,
                                                                        column: 32,
                                                                        fixed: true,
                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'build',
                                                                loc: {
                                                                    start: {
                                                                        line: 51,
                                                                        column: 33,
                                                                        fixed: true,
                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 51,
                                                                        column: 38,
                                                                        fixed: true,
                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 51,
                                                                    column: 21,
                                                                    fixed: true,
                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                },
                                                                end: {
                                                                    line: 51,
                                                                    column: 38,
                                                                    fixed: true,
                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'client',
                                                            loc: {
                                                                start: {
                                                                    line: 51,
                                                                    column: 39,
                                                                    fixed: true,
                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                },
                                                                end: {
                                                                    line: 51,
                                                                    column: 45,
                                                                    fixed: true,
                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 51,
                                                                column: 21,
                                                                fixed: true,
                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                            },
                                                            end: {
                                                                line: 51,
                                                                column: 45,
                                                                fixed: true,
                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'exclude',
                                                        loc: {
                                                            start: {
                                                                line: 51,
                                                                column: 46,
                                                                fixed: true,
                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                            },
                                                            end: {
                                                                line: 51,
                                                                column: 53,
                                                                fixed: true,
                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 51,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 51,
                                                            column: 53,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        }
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'test',
                                                    loc: {
                                                        start: {
                                                            line: 52,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 52,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: false
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    order: '1'
                                }
                            ]
                        }],
                    loc: {
                        start: {
                            line: 46,
                            column: 4,
                            fixed: true,
                            source: 'ion/builder/WebsiteBuilder.ion'
                        },
                        end: {
                            line: 53,
                            column: 5,
                            fixed: true,
                            source: 'ion/builder/WebsiteBuilder.ion'
                        }
                    }
                },
                loc: {
                    start: {
                        line: 46,
                        column: 4,
                        fixed: true,
                        source: 'ion/builder/WebsiteBuilder.ion'
                    },
                    end: {
                        line: 53,
                        column: 5,
                        fixed: true,
                        source: 'ion/builder/WebsiteBuilder.ion'
                    }
                },
                order: '6'
            },
            {
                type: 'ExpressionStatement',
                expression: {
                    type: 'CallExpression',
                    callee: {
                        type: 'Identifier',
                        name: 'ModuleBuilder',
                        loc: {
                            start: {
                                line: 56,
                                column: 4,
                                fixed: true,
                                source: 'ion/builder/WebsiteBuilder.ion'
                            },
                            end: {
                                line: 56,
                                column: 17,
                                fixed: true,
                                source: 'ion/builder/WebsiteBuilder.ion'
                            }
                        }
                    },
                    arguments: [{
                            type: 'ObjectExpression',
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'directories',
                                        loc: {
                                            start: {
                                                line: 57,
                                                column: 8,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            },
                                            end: {
                                                line: 57,
                                                column: 19,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'src',
                                                    loc: {
                                                        start: {
                                                            line: 58,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 58,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'BinaryExpression',
                                                    operator: '+',
                                                    left: {
                                                        type: 'Identifier',
                                                        name: 'input',
                                                        loc: {
                                                            start: {
                                                                line: 58,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                            },
                                                            end: {
                                                                line: 58,
                                                                column: 21,
                                                                fixed: true,
                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                            }
                                                        }
                                                    },
                                                    right: {
                                                        type: 'Literal',
                                                        value: '/js'
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'lib',
                                                    loc: {
                                                        start: {
                                                            line: 59,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 59,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'BinaryExpression',
                                                    operator: '+',
                                                    left: {
                                                        type: 'BinaryExpression',
                                                        operator: '+',
                                                        left: {
                                                            type: 'Identifier',
                                                            name: 'output',
                                                            loc: {
                                                                start: {
                                                                    line: 59,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                },
                                                                end: {
                                                                    line: 59,
                                                                    column: 22,
                                                                    fixed: true,
                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                }
                                                            }
                                                        },
                                                        right: {
                                                            type: 'Literal',
                                                            value: '/'
                                                        }
                                                    },
                                                    right: {
                                                        type: 'Identifier',
                                                        name: 'serverJsDir',
                                                        loc: {
                                                            start: {
                                                                line: 59,
                                                                column: 31,
                                                                fixed: true,
                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                            },
                                                            end: {
                                                                line: 59,
                                                                column: 42,
                                                                fixed: true,
                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                            }
                                                        }
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'build',
                                        loc: {
                                            start: {
                                                line: 60,
                                                column: 8,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            },
                                            end: {
                                                line: 60,
                                                column: 13,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'exclude',
                                                    loc: {
                                                        start: {
                                                            line: 61,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 61,
                                                            column: 19,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'packageJson',
                                                                loc: {
                                                                    start: {
                                                                        line: 61,
                                                                        column: 21,
                                                                        fixed: true,
                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 61,
                                                                        column: 32,
                                                                        fixed: true,
                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'build',
                                                                loc: {
                                                                    start: {
                                                                        line: 61,
                                                                        column: 33,
                                                                        fixed: true,
                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 61,
                                                                        column: 38,
                                                                        fixed: true,
                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 61,
                                                                    column: 21,
                                                                    fixed: true,
                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                },
                                                                end: {
                                                                    line: 61,
                                                                    column: 38,
                                                                    fixed: true,
                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'server',
                                                            loc: {
                                                                start: {
                                                                    line: 61,
                                                                    column: 39,
                                                                    fixed: true,
                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                },
                                                                end: {
                                                                    line: 61,
                                                                    column: 45,
                                                                    fixed: true,
                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 61,
                                                                column: 21,
                                                                fixed: true,
                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                            },
                                                            end: {
                                                                line: 61,
                                                                column: 45,
                                                                fixed: true,
                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'exclude',
                                                        loc: {
                                                            start: {
                                                                line: 61,
                                                                column: 46,
                                                                fixed: true,
                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                            },
                                                            end: {
                                                                line: 61,
                                                                column: 53,
                                                                fixed: true,
                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 61,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 61,
                                                            column: 53,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        }
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'test',
                                                    loc: {
                                                        start: {
                                                            line: 62,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 62,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: true
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    order: '1'
                                }
                            ]
                        }],
                    loc: {
                        start: {
                            line: 56,
                            column: 4,
                            fixed: true,
                            source: 'ion/builder/WebsiteBuilder.ion'
                        },
                        end: {
                            line: 63,
                            column: 5,
                            fixed: true,
                            source: 'ion/builder/WebsiteBuilder.ion'
                        }
                    }
                },
                loc: {
                    start: {
                        line: 56,
                        column: 4,
                        fixed: true,
                        source: 'ion/builder/WebsiteBuilder.ion'
                    },
                    end: {
                        line: 63,
                        column: 5,
                        fixed: true,
                        source: 'ion/builder/WebsiteBuilder.ion'
                    }
                },
                order: '7'
            },
            {
                type: 'ForInStatement',
                left: {
                    type: 'VariableDeclaration',
                    declarations: [
                        {
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'path',
                                loc: {
                                    start: {
                                        line: 66,
                                        column: 8,
                                        fixed: true,
                                        source: 'ion/builder/WebsiteBuilder.ion'
                                    },
                                    end: {
                                        line: 66,
                                        column: 12,
                                        fixed: true,
                                        source: 'ion/builder/WebsiteBuilder.ion'
                                    }
                                }
                            },
                            init: null
                        },
                        {
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'file',
                                loc: {
                                    start: {
                                        line: 66,
                                        column: 14,
                                        fixed: true,
                                        source: 'ion/builder/WebsiteBuilder.ion'
                                    },
                                    end: {
                                        line: 66,
                                        column: 18,
                                        fixed: true,
                                        source: 'ion/builder/WebsiteBuilder.ion'
                                    }
                                }
                            },
                            init: null
                        }
                    ],
                    kind: 'let'
                },
                right: {
                    type: 'CallExpression',
                    callee: {
                        type: 'MemberExpression',
                        computed: false,
                        object: {
                            type: 'Identifier',
                            name: 'input',
                            loc: {
                                start: {
                                    line: 66,
                                    column: 22,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                },
                                end: {
                                    line: 66,
                                    column: 27,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                }
                            }
                        },
                        property: {
                            type: 'Identifier',
                            name: 'search',
                            loc: {
                                start: {
                                    line: 66,
                                    column: 28,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                },
                                end: {
                                    line: 66,
                                    column: 34,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                }
                            }
                        },
                        loc: {
                            start: {
                                line: 66,
                                column: 22,
                                fixed: true,
                                source: 'ion/builder/WebsiteBuilder.ion'
                            },
                            end: {
                                line: 66,
                                column: 34,
                                fixed: true,
                                source: 'ion/builder/WebsiteBuilder.ion'
                            }
                        }
                    },
                    arguments: [
                        {
                            type: 'Literal',
                            value: null
                        },
                        {
                            type: 'ArrayExpression',
                            elements: [
                                {
                                    type: 'Literal',
                                    value: '.js'
                                },
                                {
                                    type: 'Literal',
                                    value: '.DS_Store'
                                },
                                {
                                    type: 'Literal',
                                    value: '.ionpage'
                                },
                                {
                                    type: 'Literal',
                                    value: '.coffeepage'
                                },
                                {
                                    type: 'Literal',
                                    value: '.coffee'
                                },
                                {
                                    type: 'Literal',
                                    value: '.java'
                                },
                                {
                                    type: 'Literal',
                                    value: '.class'
                                },
                                {
                                    type: 'Literal',
                                    value: '.jar'
                                },
                                {
                                    type: 'Literal',
                                    value: '.ion'
                                }
                            ]
                        }
                    ],
                    loc: {
                        start: {
                            line: 66,
                            column: 22,
                            fixed: true,
                            source: 'ion/builder/WebsiteBuilder.ion'
                        },
                        end: {
                            line: 66,
                            column: 130,
                            fixed: true,
                            source: 'ion/builder/WebsiteBuilder.ion'
                        }
                    }
                },
                body: {
                    type: 'BlockStatement',
                    body: [{
                            type: 'IfStatement',
                            test: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'file',
                                    loc: {
                                        start: {
                                            line: 67,
                                            column: 11,
                                            fixed: true,
                                            source: 'ion/builder/WebsiteBuilder.ion'
                                        },
                                        end: {
                                            line: 67,
                                            column: 15,
                                            fixed: true,
                                            source: 'ion/builder/WebsiteBuilder.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'isFile',
                                    loc: {
                                        start: {
                                            line: 67,
                                            column: 16,
                                            fixed: true,
                                            source: 'ion/builder/WebsiteBuilder.ion'
                                        },
                                        end: {
                                            line: 67,
                                            column: 22,
                                            fixed: true,
                                            source: 'ion/builder/WebsiteBuilder.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 67,
                                        column: 11,
                                        fixed: true,
                                        source: 'ion/builder/WebsiteBuilder.ion'
                                    },
                                    end: {
                                        line: 67,
                                        column: 22,
                                        fixed: true,
                                        source: 'ion/builder/WebsiteBuilder.ion'
                                    }
                                }
                            },
                            consequent: {
                                type: 'BlockStatement',
                                body: [{
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'output',
                                                    loc: {
                                                        start: {
                                                            line: 68,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 68,
                                                            column: 18,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'write',
                                                    loc: {
                                                        start: {
                                                            line: 68,
                                                            column: 19,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 68,
                                                            column: 24,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 68,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    },
                                                    end: {
                                                        line: 68,
                                                        column: 24,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    }
                                                }
                                            },
                                            arguments: [
                                                {
                                                    type: 'Identifier',
                                                    name: 'path',
                                                    loc: {
                                                        start: {
                                                            line: 68,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 68,
                                                            column: 29,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        }
                                                    }
                                                },
                                                {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'file',
                                                            loc: {
                                                                start: {
                                                                    line: 68,
                                                                    column: 31,
                                                                    fixed: true,
                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                },
                                                                end: {
                                                                    line: 68,
                                                                    column: 35,
                                                                    fixed: true,
                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'read',
                                                            loc: {
                                                                start: {
                                                                    line: 68,
                                                                    column: 36,
                                                                    fixed: true,
                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                },
                                                                end: {
                                                                    line: 68,
                                                                    column: 40,
                                                                    fixed: true,
                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 68,
                                                                column: 31,
                                                                fixed: true,
                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                            },
                                                            end: {
                                                                line: 68,
                                                                column: 40,
                                                                fixed: true,
                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [{
                                                            type: 'Literal',
                                                            value: null
                                                        }],
                                                    loc: {
                                                        start: {
                                                            line: 68,
                                                            column: 31,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 68,
                                                            column: 46,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        }
                                                    }
                                                },
                                                {
                                                    type: 'Literal',
                                                    value: null
                                                }
                                            ],
                                            loc: {
                                                start: {
                                                    line: 68,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                },
                                                end: {
                                                    line: 68,
                                                    column: 53,
                                                    fixed: true,
                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 68,
                                                column: 12,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            },
                                            end: {
                                                line: 68,
                                                column: 53,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            }
                                        },
                                        order: '0'
                                    }]
                            },
                            alternate: null,
                            order: '0'
                        }]
                },
                remove: {
                    type: 'BlockStatement',
                    body: [{
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'output',
                                        loc: {
                                            start: {
                                                line: 70,
                                                column: 8,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            },
                                            end: {
                                                line: 70,
                                                column: 14,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'delete',
                                        loc: {
                                            start: {
                                                line: 70,
                                                column: 15,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            },
                                            end: {
                                                line: 70,
                                                column: 21,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 70,
                                            column: 8,
                                            fixed: true,
                                            source: 'ion/builder/WebsiteBuilder.ion'
                                        },
                                        end: {
                                            line: 70,
                                            column: 21,
                                            fixed: true,
                                            source: 'ion/builder/WebsiteBuilder.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'Identifier',
                                        name: 'path',
                                        loc: {
                                            start: {
                                                line: 70,
                                                column: 22,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            },
                                            end: {
                                                line: 70,
                                                column: 26,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            }
                                        }
                                    }],
                                loc: {
                                    start: {
                                        line: 70,
                                        column: 8,
                                        fixed: true,
                                        source: 'ion/builder/WebsiteBuilder.ion'
                                    },
                                    end: {
                                        line: 70,
                                        column: 27,
                                        fixed: true,
                                        source: 'ion/builder/WebsiteBuilder.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 70,
                                    column: 8,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                },
                                end: {
                                    line: 70,
                                    column: 27,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                }
                            },
                            order: '0'
                        }]
                },
                order: '8'
            },
            {
                type: 'ForInStatement',
                left: {
                    type: 'VariableDeclaration',
                    declarations: [
                        {
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'path',
                                loc: {
                                    start: {
                                        line: 73,
                                        column: 8,
                                        fixed: true,
                                        source: 'ion/builder/WebsiteBuilder.ion'
                                    },
                                    end: {
                                        line: 73,
                                        column: 12,
                                        fixed: true,
                                        source: 'ion/builder/WebsiteBuilder.ion'
                                    }
                                }
                            },
                            init: null
                        },
                        {
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'file',
                                loc: {
                                    start: {
                                        line: 73,
                                        column: 14,
                                        fixed: true,
                                        source: 'ion/builder/WebsiteBuilder.ion'
                                    },
                                    end: {
                                        line: 73,
                                        column: 18,
                                        fixed: true,
                                        source: 'ion/builder/WebsiteBuilder.ion'
                                    }
                                }
                            },
                            init: null
                        }
                    ],
                    kind: 'let'
                },
                right: {
                    type: 'CallExpression',
                    callee: {
                        type: 'MemberExpression',
                        computed: false,
                        object: {
                            type: 'Identifier',
                            name: 'input',
                            loc: {
                                start: {
                                    line: 73,
                                    column: 22,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                },
                                end: {
                                    line: 73,
                                    column: 27,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                }
                            }
                        },
                        property: {
                            type: 'Identifier',
                            name: 'search',
                            loc: {
                                start: {
                                    line: 73,
                                    column: 28,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                },
                                end: {
                                    line: 73,
                                    column: 34,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                }
                            }
                        },
                        loc: {
                            start: {
                                line: 73,
                                column: 22,
                                fixed: true,
                                source: 'ion/builder/WebsiteBuilder.ion'
                            },
                            end: {
                                line: 73,
                                column: 34,
                                fixed: true,
                                source: 'ion/builder/WebsiteBuilder.ion'
                            }
                        }
                    },
                    arguments: [
                        {
                            type: 'Literal',
                            value: '.ion'
                        },
                        {
                            type: 'Literal',
                            value: 'js'
                        }
                    ],
                    loc: {
                        start: {
                            line: 73,
                            column: 22,
                            fixed: true,
                            source: 'ion/builder/WebsiteBuilder.ion'
                        },
                        end: {
                            line: 73,
                            column: 48,
                            fixed: true,
                            source: 'ion/builder/WebsiteBuilder.ion'
                        }
                    }
                },
                body: {
                    type: 'BlockStatement',
                    body: [
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'targetPath',
                                        loc: {
                                            start: {
                                                line: 74,
                                                column: 12,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            },
                                            end: {
                                                line: 74,
                                                column: 22,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'builder',
                                                loc: {
                                                    start: {
                                                        line: 74,
                                                        column: 25,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    },
                                                    end: {
                                                        line: 74,
                                                        column: 32,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'changeExtension',
                                                loc: {
                                                    start: {
                                                        line: 74,
                                                        column: 33,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    },
                                                    end: {
                                                        line: 74,
                                                        column: 48,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 74,
                                                    column: 25,
                                                    fixed: true,
                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                },
                                                end: {
                                                    line: 74,
                                                    column: 48,
                                                    fixed: true,
                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                }
                                            }
                                        },
                                        arguments: [
                                            {
                                                type: 'Identifier',
                                                name: 'path',
                                                loc: {
                                                    start: {
                                                        line: 74,
                                                        column: 49,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    },
                                                    end: {
                                                        line: 74,
                                                        column: 53,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    }
                                                }
                                            },
                                            {
                                                type: 'Literal',
                                                value: '.js'
                                            }
                                        ],
                                        loc: {
                                            start: {
                                                line: 74,
                                                column: 25,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            },
                                            end: {
                                                line: 74,
                                                column: 61,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '0'
                        },
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'output',
                                        loc: {
                                            start: {
                                                line: 75,
                                                column: 8,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            },
                                            end: {
                                                line: 75,
                                                column: 14,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'write',
                                        loc: {
                                            start: {
                                                line: 75,
                                                column: 15,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            },
                                            end: {
                                                line: 75,
                                                column: 20,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 75,
                                            column: 8,
                                            fixed: true,
                                            source: 'ion/builder/WebsiteBuilder.ion'
                                        },
                                        end: {
                                            line: 75,
                                            column: 20,
                                            fixed: true,
                                            source: 'ion/builder/WebsiteBuilder.ion'
                                        }
                                    }
                                },
                                arguments: [
                                    {
                                        type: 'Identifier',
                                        name: 'targetPath',
                                        loc: {
                                            start: {
                                                line: 75,
                                                column: 21,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            },
                                            end: {
                                                line: 75,
                                                column: 31,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            }
                                        }
                                    },
                                    {
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'builder',
                                                loc: {
                                                    start: {
                                                        line: 75,
                                                        column: 33,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    },
                                                    end: {
                                                        line: 75,
                                                        column: 40,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'compileIon',
                                                loc: {
                                                    start: {
                                                        line: 75,
                                                        column: 41,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    },
                                                    end: {
                                                        line: 75,
                                                        column: 51,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 75,
                                                    column: 33,
                                                    fixed: true,
                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                },
                                                end: {
                                                    line: 75,
                                                    column: 51,
                                                    fixed: true,
                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                }
                                            }
                                        },
                                        arguments: [{
                                                type: 'Identifier',
                                                name: 'file',
                                                loc: {
                                                    start: {
                                                        line: 75,
                                                        column: 52,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    },
                                                    end: {
                                                        line: 75,
                                                        column: 56,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    }
                                                }
                                            }],
                                        loc: {
                                            start: {
                                                line: 75,
                                                column: 33,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            },
                                            end: {
                                                line: 75,
                                                column: 57,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            }
                                        }
                                    }
                                ],
                                loc: {
                                    start: {
                                        line: 75,
                                        column: 8,
                                        fixed: true,
                                        source: 'ion/builder/WebsiteBuilder.ion'
                                    },
                                    end: {
                                        line: 75,
                                        column: 58,
                                        fixed: true,
                                        source: 'ion/builder/WebsiteBuilder.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 75,
                                    column: 8,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                },
                                end: {
                                    line: 75,
                                    column: 58,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                }
                            },
                            order: '1'
                        }
                    ]
                },
                remove: {
                    type: 'BlockStatement',
                    body: [{
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'output',
                                        loc: {
                                            start: {
                                                line: 77,
                                                column: 8,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            },
                                            end: {
                                                line: 77,
                                                column: 14,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'delete',
                                        loc: {
                                            start: {
                                                line: 77,
                                                column: 15,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            },
                                            end: {
                                                line: 77,
                                                column: 21,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 77,
                                            column: 8,
                                            fixed: true,
                                            source: 'ion/builder/WebsiteBuilder.ion'
                                        },
                                        end: {
                                            line: 77,
                                            column: 21,
                                            fixed: true,
                                            source: 'ion/builder/WebsiteBuilder.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'Identifier',
                                        name: 'targetPath',
                                        loc: {
                                            start: {
                                                line: 77,
                                                column: 22,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            },
                                            end: {
                                                line: 77,
                                                column: 32,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            }
                                        }
                                    }],
                                loc: {
                                    start: {
                                        line: 77,
                                        column: 8,
                                        fixed: true,
                                        source: 'ion/builder/WebsiteBuilder.ion'
                                    },
                                    end: {
                                        line: 77,
                                        column: 33,
                                        fixed: true,
                                        source: 'ion/builder/WebsiteBuilder.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 77,
                                    column: 8,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                },
                                end: {
                                    line: 77,
                                    column: 33,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                }
                            },
                            order: '0'
                        }]
                },
                order: '9'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'pageOutput',
                            loc: {
                                start: {
                                    line: 80,
                                    column: 8,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                },
                                end: {
                                    line: 80,
                                    column: 18,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'output',
                                    loc: {
                                        start: {
                                            line: 80,
                                            column: 21,
                                            fixed: true,
                                            source: 'ion/builder/WebsiteBuilder.ion'
                                        },
                                        end: {
                                            line: 80,
                                            column: 27,
                                            fixed: true,
                                            source: 'ion/builder/WebsiteBuilder.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'getDirectory',
                                    loc: {
                                        start: {
                                            line: 80,
                                            column: 28,
                                            fixed: true,
                                            source: 'ion/builder/WebsiteBuilder.ion'
                                        },
                                        end: {
                                            line: 80,
                                            column: 40,
                                            fixed: true,
                                            source: 'ion/builder/WebsiteBuilder.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 80,
                                        column: 21,
                                        fixed: true,
                                        source: 'ion/builder/WebsiteBuilder.ion'
                                    },
                                    end: {
                                        line: 80,
                                        column: 40,
                                        fixed: true,
                                        source: 'ion/builder/WebsiteBuilder.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'Literal',
                                    value: 'WEB-INF/pages'
                                }],
                            loc: {
                                start: {
                                    line: 80,
                                    column: 21,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                },
                                end: {
                                    line: 80,
                                    column: 57,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: ':'
            },
            {
                type: 'ForInStatement',
                left: {
                    type: 'VariableDeclaration',
                    declarations: [
                        {
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'path',
                                loc: {
                                    start: {
                                        line: 81,
                                        column: 8,
                                        fixed: true,
                                        source: 'ion/builder/WebsiteBuilder.ion'
                                    },
                                    end: {
                                        line: 81,
                                        column: 12,
                                        fixed: true,
                                        source: 'ion/builder/WebsiteBuilder.ion'
                                    }
                                }
                            },
                            init: null
                        },
                        {
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'file',
                                loc: {
                                    start: {
                                        line: 81,
                                        column: 14,
                                        fixed: true,
                                        source: 'ion/builder/WebsiteBuilder.ion'
                                    },
                                    end: {
                                        line: 81,
                                        column: 18,
                                        fixed: true,
                                        source: 'ion/builder/WebsiteBuilder.ion'
                                    }
                                }
                            },
                            init: null
                        }
                    ],
                    kind: 'let'
                },
                right: {
                    type: 'CallExpression',
                    callee: {
                        type: 'MemberExpression',
                        computed: false,
                        object: {
                            type: 'Identifier',
                            name: 'input',
                            loc: {
                                start: {
                                    line: 81,
                                    column: 22,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                },
                                end: {
                                    line: 81,
                                    column: 27,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                }
                            }
                        },
                        property: {
                            type: 'Identifier',
                            name: 'search',
                            loc: {
                                start: {
                                    line: 81,
                                    column: 28,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                },
                                end: {
                                    line: 81,
                                    column: 34,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                }
                            }
                        },
                        loc: {
                            start: {
                                line: 81,
                                column: 22,
                                fixed: true,
                                source: 'ion/builder/WebsiteBuilder.ion'
                            },
                            end: {
                                line: 81,
                                column: 34,
                                fixed: true,
                                source: 'ion/builder/WebsiteBuilder.ion'
                            }
                        }
                    },
                    arguments: [{
                            type: 'Literal',
                            value: '.ionpage'
                        }],
                    loc: {
                        start: {
                            line: 81,
                            column: 22,
                            fixed: true,
                            source: 'ion/builder/WebsiteBuilder.ion'
                        },
                        end: {
                            line: 81,
                            column: 46,
                            fixed: true,
                            source: 'ion/builder/WebsiteBuilder.ion'
                        }
                    }
                },
                body: {
                    type: 'BlockStatement',
                    body: [
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'targetPath',
                                        loc: {
                                            start: {
                                                line: 82,
                                                column: 12,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            },
                                            end: {
                                                line: 82,
                                                column: 22,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'builder',
                                                loc: {
                                                    start: {
                                                        line: 82,
                                                        column: 25,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    },
                                                    end: {
                                                        line: 82,
                                                        column: 32,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'changeExtension',
                                                loc: {
                                                    start: {
                                                        line: 82,
                                                        column: 33,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    },
                                                    end: {
                                                        line: 82,
                                                        column: 48,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 82,
                                                    column: 25,
                                                    fixed: true,
                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                },
                                                end: {
                                                    line: 82,
                                                    column: 48,
                                                    fixed: true,
                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                }
                                            }
                                        },
                                        arguments: [
                                            {
                                                type: 'Identifier',
                                                name: 'path',
                                                loc: {
                                                    start: {
                                                        line: 82,
                                                        column: 49,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    },
                                                    end: {
                                                        line: 82,
                                                        column: 53,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    }
                                                }
                                            },
                                            {
                                                type: 'Literal',
                                                value: '.js'
                                            }
                                        ],
                                        loc: {
                                            start: {
                                                line: 82,
                                                column: 25,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            },
                                            end: {
                                                line: 82,
                                                column: 61,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '0'
                        },
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'pageOutput',
                                        loc: {
                                            start: {
                                                line: 83,
                                                column: 8,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            },
                                            end: {
                                                line: 83,
                                                column: 18,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'write',
                                        loc: {
                                            start: {
                                                line: 83,
                                                column: 19,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            },
                                            end: {
                                                line: 83,
                                                column: 24,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 83,
                                            column: 8,
                                            fixed: true,
                                            source: 'ion/builder/WebsiteBuilder.ion'
                                        },
                                        end: {
                                            line: 83,
                                            column: 24,
                                            fixed: true,
                                            source: 'ion/builder/WebsiteBuilder.ion'
                                        }
                                    }
                                },
                                arguments: [
                                    {
                                        type: 'Identifier',
                                        name: 'targetPath',
                                        loc: {
                                            start: {
                                                line: 83,
                                                column: 25,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            },
                                            end: {
                                                line: 83,
                                                column: 35,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            }
                                        }
                                    },
                                    {
                                        type: 'BinaryExpression',
                                        operator: '+',
                                        left: {
                                            type: 'BinaryExpression',
                                            operator: '+',
                                            left: {
                                                type: 'BinaryExpression',
                                                operator: '+',
                                                left: {
                                                    type: 'BinaryExpression',
                                                    operator: '+',
                                                    left: {
                                                        type: 'Literal',
                                                        value: '(function '
                                                    },
                                                    right: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'path',
                                                                loc: {
                                                                    start: {
                                                                        line: 83,
                                                                        column: 50,
                                                                        fixed: true,
                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 83,
                                                                        column: 54,
                                                                        fixed: true,
                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'replace',
                                                                loc: {
                                                                    start: {
                                                                        line: 83,
                                                                        column: 55,
                                                                        fixed: true,
                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 83,
                                                                        column: 62,
                                                                        fixed: true,
                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 83,
                                                                    column: 50,
                                                                    fixed: true,
                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                },
                                                                end: {
                                                                    line: 83,
                                                                    column: 62,
                                                                    fixed: true,
                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [
                                                            {
                                                                type: 'Literal',
                                                                value: /[\.\/\\]/g
                                                            },
                                                            {
                                                                type: 'Literal',
                                                                value: '_'
                                                            }
                                                        ],
                                                        loc: {
                                                            start: {
                                                                line: 83,
                                                                column: 50,
                                                                fixed: true,
                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                            },
                                                            end: {
                                                                line: 83,
                                                                column: 80,
                                                                fixed: true,
                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                            }
                                                        }
                                                    }
                                                },
                                                right: {
                                                    type: 'Literal',
                                                    value: '(){ '
                                                }
                                            },
                                            right: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'builder',
                                                        loc: {
                                                            start: {
                                                                line: 83,
                                                                column: 88,
                                                                fixed: true,
                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                            },
                                                            end: {
                                                                line: 83,
                                                                column: 95,
                                                                fixed: true,
                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'compileIon',
                                                        loc: {
                                                            start: {
                                                                line: 83,
                                                                column: 96,
                                                                fixed: true,
                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                            },
                                                            end: {
                                                                line: 83,
                                                                column: 106,
                                                                fixed: true,
                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 83,
                                                            column: 88,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 83,
                                                            column: 106,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [{
                                                        type: 'Identifier',
                                                        name: 'file',
                                                        loc: {
                                                            start: {
                                                                line: 83,
                                                                column: 107,
                                                                fixed: true,
                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                            },
                                                            end: {
                                                                line: 83,
                                                                column: 111,
                                                                fixed: true,
                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                            }
                                                        }
                                                    }],
                                                loc: {
                                                    start: {
                                                        line: 83,
                                                        column: 88,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    },
                                                    end: {
                                                        line: 83,
                                                        column: 112,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    }
                                                }
                                            }
                                        },
                                        right: {
                                            type: 'Literal',
                                            value: ' })'
                                        }
                                    }
                                ],
                                loc: {
                                    start: {
                                        line: 83,
                                        column: 8,
                                        fixed: true,
                                        source: 'ion/builder/WebsiteBuilder.ion'
                                    },
                                    end: {
                                        line: 83,
                                        column: 119,
                                        fixed: true,
                                        source: 'ion/builder/WebsiteBuilder.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 83,
                                    column: 8,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                },
                                end: {
                                    line: 83,
                                    column: 119,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                }
                            },
                            order: '1'
                        }
                    ]
                },
                remove: {
                    type: 'BlockStatement',
                    body: [{
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'pageOutput',
                                        loc: {
                                            start: {
                                                line: 85,
                                                column: 8,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            },
                                            end: {
                                                line: 85,
                                                column: 18,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'delete',
                                        loc: {
                                            start: {
                                                line: 85,
                                                column: 19,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            },
                                            end: {
                                                line: 85,
                                                column: 25,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 85,
                                            column: 8,
                                            fixed: true,
                                            source: 'ion/builder/WebsiteBuilder.ion'
                                        },
                                        end: {
                                            line: 85,
                                            column: 25,
                                            fixed: true,
                                            source: 'ion/builder/WebsiteBuilder.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'Identifier',
                                        name: 'targetPath',
                                        loc: {
                                            start: {
                                                line: 85,
                                                column: 26,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            },
                                            end: {
                                                line: 85,
                                                column: 36,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            }
                                        }
                                    }],
                                loc: {
                                    start: {
                                        line: 85,
                                        column: 8,
                                        fixed: true,
                                        source: 'ion/builder/WebsiteBuilder.ion'
                                    },
                                    end: {
                                        line: 85,
                                        column: 37,
                                        fixed: true,
                                        source: 'ion/builder/WebsiteBuilder.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 85,
                                    column: 8,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                },
                                end: {
                                    line: 85,
                                    column: 37,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                }
                            },
                            order: '0'
                        }]
                },
                order: ';'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'files',
                            loc: {
                                start: {
                                    line: 88,
                                    column: 8,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                },
                                end: {
                                    line: 88,
                                    column: 13,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'ObjectExpression',
                                properties: []
                            },
                            properties: [{
                                    type: 'ForOfStatement',
                                    left: {
                                        type: 'VariableDeclaration',
                                        declarations: [{
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'manifestFilename',
                                                    loc: {
                                                        start: {
                                                            line: 89,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 89,
                                                            column: 28,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        }
                                                    }
                                                },
                                                init: null
                                            }],
                                        kind: 'let'
                                    },
                                    right: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'packageJson',
                                                loc: {
                                                    start: {
                                                        line: 89,
                                                        column: 32,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    },
                                                    end: {
                                                        line: 89,
                                                        column: 43,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'build',
                                                loc: {
                                                    start: {
                                                        line: 89,
                                                        column: 44,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    },
                                                    end: {
                                                        line: 89,
                                                        column: 49,
                                                        fixed: true,
                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 89,
                                                    column: 32,
                                                    fixed: true,
                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                },
                                                end: {
                                                    line: 89,
                                                    column: 49,
                                                    fixed: true,
                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'manifests',
                                            loc: {
                                                start: {
                                                    line: 89,
                                                    column: 50,
                                                    fixed: true,
                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                },
                                                end: {
                                                    line: 89,
                                                    column: 59,
                                                    fixed: true,
                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 89,
                                                column: 32,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            },
                                            end: {
                                                line: 89,
                                                column: 59,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            }
                                        }
                                    },
                                    body: {
                                        type: 'BlockStatement',
                                        body: [
                                            {
                                                type: 'VariableDeclaration',
                                                declarations: [{
                                                        type: 'VariableDeclarator',
                                                        id: {
                                                            type: 'Identifier',
                                                            name: 'manifestFile',
                                                            loc: {
                                                                start: {
                                                                    line: 90,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                },
                                                                end: {
                                                                    line: 90,
                                                                    column: 28,
                                                                    fixed: true,
                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                }
                                                            }
                                                        },
                                                        init: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'clientOutput',
                                                                    loc: {
                                                                        start: {
                                                                            line: 90,
                                                                            column: 31,
                                                                            fixed: true,
                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                        },
                                                                        end: {
                                                                            line: 90,
                                                                            column: 43,
                                                                            fixed: true,
                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'getFile',
                                                                    loc: {
                                                                        start: {
                                                                            line: 90,
                                                                            column: 44,
                                                                            fixed: true,
                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                        },
                                                                        end: {
                                                                            line: 90,
                                                                            column: 51,
                                                                            fixed: true,
                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 90,
                                                                        column: 31,
                                                                        fixed: true,
                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 90,
                                                                        column: 51,
                                                                        fixed: true,
                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [{
                                                                    type: 'Identifier',
                                                                    name: 'manifestFilename',
                                                                    loc: {
                                                                        start: {
                                                                            line: 90,
                                                                            column: 52,
                                                                            fixed: true,
                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                        },
                                                                        end: {
                                                                            line: 90,
                                                                            column: 68,
                                                                            fixed: true,
                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                        }
                                                                    }
                                                                }],
                                                            loc: {
                                                                start: {
                                                                    line: 90,
                                                                    column: 31,
                                                                    fixed: true,
                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                },
                                                                end: {
                                                                    line: 90,
                                                                    column: 69,
                                                                    fixed: true,
                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                }
                                                            }
                                                        }
                                                    }],
                                                kind: 'let',
                                                order: '0'
                                            },
                                            {
                                                type: 'VariableDeclaration',
                                                declarations: [{
                                                        type: 'VariableDeclarator',
                                                        id: {
                                                            type: 'Identifier',
                                                            name: 'manifest',
                                                            loc: {
                                                                start: {
                                                                    line: 91,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                },
                                                                end: {
                                                                    line: 91,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                }
                                                            }
                                                        },
                                                        init: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'JSON',
                                                                    loc: {
                                                                        start: {
                                                                            line: 91,
                                                                            column: 27,
                                                                            fixed: true,
                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                        },
                                                                        end: {
                                                                            line: 91,
                                                                            column: 31,
                                                                            fixed: true,
                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'parse',
                                                                    loc: {
                                                                        start: {
                                                                            line: 91,
                                                                            column: 32,
                                                                            fixed: true,
                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                        },
                                                                        end: {
                                                                            line: 91,
                                                                            column: 37,
                                                                            fixed: true,
                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 91,
                                                                        column: 27,
                                                                        fixed: true,
                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 91,
                                                                        column: 37,
                                                                        fixed: true,
                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [{
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'manifestFile',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 91,
                                                                                    column: 38,
                                                                                    fixed: true,
                                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 91,
                                                                                    column: 50,
                                                                                    fixed: true,
                                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'read',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 91,
                                                                                    column: 51,
                                                                                    fixed: true,
                                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 91,
                                                                                    column: 55,
                                                                                    fixed: true,
                                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 91,
                                                                                column: 38,
                                                                                fixed: true,
                                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                                            },
                                                                            end: {
                                                                                line: 91,
                                                                                column: 55,
                                                                                fixed: true,
                                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [],
                                                                    loc: {
                                                                        start: {
                                                                            line: 91,
                                                                            column: 38,
                                                                            fixed: true,
                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                        },
                                                                        end: {
                                                                            line: 91,
                                                                            column: 57,
                                                                            fixed: true,
                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                        }
                                                                    }
                                                                }],
                                                            loc: {
                                                                start: {
                                                                    line: 91,
                                                                    column: 27,
                                                                    fixed: true,
                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                },
                                                                end: {
                                                                    line: 91,
                                                                    column: 58,
                                                                    fixed: true,
                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                }
                                                            }
                                                        }
                                                    }],
                                                kind: 'let',
                                                order: '1'
                                            },
                                            {
                                                type: 'ForOfStatement',
                                                left: {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'jsfile',
                                                                loc: {
                                                                    start: {
                                                                        line: 92,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 92,
                                                                        column: 22,
                                                                        fixed: true,
                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: null
                                                        }],
                                                    kind: 'let'
                                                },
                                                right: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'manifest',
                                                        loc: {
                                                            start: {
                                                                line: 92,
                                                                column: 26,
                                                                fixed: true,
                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                            },
                                                            end: {
                                                                line: 92,
                                                                column: 34,
                                                                fixed: true,
                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'files',
                                                        loc: {
                                                            start: {
                                                                line: 92,
                                                                column: 35,
                                                                fixed: true,
                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                            },
                                                            end: {
                                                                line: 92,
                                                                column: 40,
                                                                fixed: true,
                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 92,
                                                            column: 26,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 92,
                                                            column: 40,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        }
                                                    }
                                                },
                                                body: {
                                                    type: 'BlockStatement',
                                                    body: [
                                                        {
                                                            type: 'VariableDeclaration',
                                                            declarations: [{
                                                                    type: 'VariableDeclarator',
                                                                    id: {
                                                                        type: 'Identifier',
                                                                        name: 'jspath',
                                                                        loc: {
                                                                            start: {
                                                                                line: 93,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                                            },
                                                                            end: {
                                                                                line: 93,
                                                                                column: 26,
                                                                                fixed: true,
                                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    init: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'CallExpression',
                                                                                callee: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'np',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 93,
                                                                                                column: 29,
                                                                                                fixed: true,
                                                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 93,
                                                                                                column: 31,
                                                                                                fixed: true,
                                                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'join',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 93,
                                                                                                column: 32,
                                                                                                fixed: true,
                                                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 93,
                                                                                                column: 36,
                                                                                                fixed: true,
                                                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 93,
                                                                                            column: 29,
                                                                                            fixed: true,
                                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 93,
                                                                                            column: 36,
                                                                                            fixed: true,
                                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                arguments: [
                                                                                    {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'manifestFile',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 93,
                                                                                                    column: 37,
                                                                                                    fixed: true,
                                                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 93,
                                                                                                    column: 49,
                                                                                                    fixed: true,
                                                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'directoryName',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 93,
                                                                                                    column: 50,
                                                                                                    fixed: true,
                                                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 93,
                                                                                                    column: 63,
                                                                                                    fixed: true,
                                                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 93,
                                                                                                column: 37,
                                                                                                fixed: true,
                                                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 93,
                                                                                                column: 63,
                                                                                                fixed: true,
                                                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    {
                                                                                        type: 'Identifier',
                                                                                        name: 'jsfile',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 93,
                                                                                                column: 65,
                                                                                                fixed: true,
                                                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 93,
                                                                                                column: 71,
                                                                                                fixed: true,
                                                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                ],
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 93,
                                                                                        column: 29,
                                                                                        fixed: true,
                                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 93,
                                                                                        column: 72,
                                                                                        fixed: true,
                                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'substring',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 93,
                                                                                        column: 73,
                                                                                        fixed: true,
                                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 93,
                                                                                        column: 82,
                                                                                        fixed: true,
                                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 93,
                                                                                    column: 29,
                                                                                    fixed: true,
                                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 93,
                                                                                    column: 82,
                                                                                    fixed: true,
                                                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [{
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'output',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 93,
                                                                                                column: 83,
                                                                                                fixed: true,
                                                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 93,
                                                                                                column: 89,
                                                                                                fixed: true,
                                                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'path',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 93,
                                                                                                column: 90,
                                                                                                fixed: true,
                                                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 93,
                                                                                                column: 94,
                                                                                                fixed: true,
                                                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 93,
                                                                                            column: 83,
                                                                                            fixed: true,
                                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 93,
                                                                                            column: 94,
                                                                                            fixed: true,
                                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'length',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 93,
                                                                                            column: 95,
                                                                                            fixed: true,
                                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 93,
                                                                                            column: 101,
                                                                                            fixed: true,
                                                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 93,
                                                                                        column: 83,
                                                                                        fixed: true,
                                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 93,
                                                                                        column: 101,
                                                                                        fixed: true,
                                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                                    }
                                                                                }
                                                                            }],
                                                                        loc: {
                                                                            start: {
                                                                                line: 93,
                                                                                column: 29,
                                                                                fixed: true,
                                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                                            },
                                                                            end: {
                                                                                line: 93,
                                                                                column: 102,
                                                                                fixed: true,
                                                                                source: 'ion/builder/WebsiteBuilder.ion'
                                                                            }
                                                                        }
                                                                    }
                                                                }],
                                                            kind: 'let',
                                                            order: '0'
                                                        },
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'jspath',
                                                                loc: {
                                                                    start: {
                                                                        line: 94,
                                                                        column: 17,
                                                                        fixed: true,
                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 94,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Literal',
                                                                value: true
                                                            },
                                                            kind: 'init',
                                                            computed: true,
                                                            order: '1'
                                                        }
                                                    ]
                                                },
                                                remove: {
                                                    type: 'BlockStatement',
                                                    body: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'jspath',
                                                                loc: {
                                                                    start: {
                                                                        line: 96,
                                                                        column: 17,
                                                                        fixed: true,
                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 96,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Literal',
                                                                value: false
                                                            },
                                                            kind: 'init',
                                                            computed: true,
                                                            order: '0'
                                                        }]
                                                },
                                                order: '2'
                                            }
                                        ]
                                    },
                                    remove: null,
                                    order: '0'
                                }]
                        }
                    }],
                kind: 'let',
                order: '<'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'scripts',
                            loc: {
                                start: {
                                    line: 97,
                                    column: 8,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                },
                                end: {
                                    line: 97,
                                    column: 15,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'ArrayExpression',
                                elements: []
                            },
                            properties: [{
                                    type: 'ForInStatement',
                                    left: {
                                        type: 'VariableDeclaration',
                                        declarations: [
                                            {
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'key',
                                                    loc: {
                                                        start: {
                                                            line: 97,
                                                            column: 27,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 97,
                                                            column: 30,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        }
                                                    }
                                                },
                                                init: null
                                            },
                                            {
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'value',
                                                    loc: {
                                                        start: {
                                                            line: 97,
                                                            column: 32,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 97,
                                                            column: 37,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        }
                                                    }
                                                },
                                                init: null
                                            }
                                        ],
                                        kind: 'let'
                                    },
                                    right: {
                                        type: 'Identifier',
                                        name: 'files',
                                        loc: {
                                            start: {
                                                line: 97,
                                                column: 41,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            },
                                            end: {
                                                line: 97,
                                                column: 46,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            }
                                        }
                                    },
                                    body: {
                                        type: 'BlockStatement',
                                        body: [{
                                                type: 'IfStatement',
                                                test: {
                                                    type: 'Identifier',
                                                    name: 'value',
                                                    loc: {
                                                        start: {
                                                            line: 97,
                                                            column: 50,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        },
                                                        end: {
                                                            line: 97,
                                                            column: 55,
                                                            fixed: true,
                                                            source: 'ion/builder/WebsiteBuilder.ion'
                                                        }
                                                    }
                                                },
                                                consequent: {
                                                    type: 'BlockStatement',
                                                    body: [{
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'Identifier',
                                                                name: 'key',
                                                                loc: {
                                                                    start: {
                                                                        line: 97,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                    },
                                                                    end: {
                                                                        line: 97,
                                                                        column: 22,
                                                                        fixed: true,
                                                                        source: 'ion/builder/WebsiteBuilder.ion'
                                                                    }
                                                                }
                                                            },
                                                            order: '0'
                                                        }]
                                                },
                                                order: '0'
                                            }]
                                    },
                                    order: '0'
                                }]
                        }
                    }],
                kind: 'let',
                order: '='
            },
            {
                type: 'ExpressionStatement',
                expression: {
                    type: 'CallExpression',
                    callee: {
                        type: 'MemberExpression',
                        computed: false,
                        object: {
                            type: 'Identifier',
                            name: 'output',
                            loc: {
                                start: {
                                    line: 98,
                                    column: 4,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                },
                                end: {
                                    line: 98,
                                    column: 10,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                }
                            }
                        },
                        property: {
                            type: 'Identifier',
                            name: 'write',
                            loc: {
                                start: {
                                    line: 98,
                                    column: 11,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                },
                                end: {
                                    line: 98,
                                    column: 16,
                                    fixed: true,
                                    source: 'ion/builder/WebsiteBuilder.ion'
                                }
                            }
                        },
                        loc: {
                            start: {
                                line: 98,
                                column: 4,
                                fixed: true,
                                source: 'ion/builder/WebsiteBuilder.ion'
                            },
                            end: {
                                line: 98,
                                column: 16,
                                fixed: true,
                                source: 'ion/builder/WebsiteBuilder.ion'
                            }
                        }
                    },
                    arguments: [
                        {
                            type: 'Literal',
                            value: 'scripts.js'
                        },
                        {
                            type: 'BinaryExpression',
                            operator: '+',
                            left: {
                                type: 'BinaryExpression',
                                operator: '+',
                                left: {
                                    type: 'Literal',
                                    value: '('
                                },
                                right: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'JSON',
                                            loc: {
                                                start: {
                                                    line: 101,
                                                    column: 15,
                                                    fixed: true,
                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                },
                                                end: {
                                                    line: 101,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'stringify',
                                            loc: {
                                                start: {
                                                    line: 101,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                },
                                                end: {
                                                    line: 101,
                                                    column: 29,
                                                    fixed: true,
                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 101,
                                                column: 15,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            },
                                            end: {
                                                line: 101,
                                                column: 29,
                                                fixed: true,
                                                source: 'ion/builder/WebsiteBuilder.ion'
                                            }
                                        }
                                    },
                                    arguments: [{
                                            type: 'Identifier',
                                            name: 'scripts',
                                            loc: {
                                                start: {
                                                    line: 101,
                                                    column: 30,
                                                    fixed: true,
                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                },
                                                end: {
                                                    line: 101,
                                                    column: 37,
                                                    fixed: true,
                                                    source: 'ion/builder/WebsiteBuilder.ion'
                                                }
                                            }
                                        }],
                                    loc: {
                                        start: {
                                            line: 101,
                                            column: 15,
                                            fixed: true,
                                            source: 'ion/builder/WebsiteBuilder.ion'
                                        },
                                        end: {
                                            line: 101,
                                            column: 38,
                                            fixed: true,
                                            source: 'ion/builder/WebsiteBuilder.ion'
                                        }
                                    }
                                }
                            },
                            right: {
                                type: 'Literal',
                                value: '\n.forEach(function(a) {\n    document.writeln("<script src=\'" + a + "\'></script>")\n}));'
                            }
                        }
                    ],
                    loc: {
                        start: {
                            line: 98,
                            column: 4,
                            fixed: true,
                            source: 'ion/builder/WebsiteBuilder.ion'
                        },
                        end: {
                            line: 106,
                            column: 5,
                            fixed: true,
                            source: 'ion/builder/WebsiteBuilder.ion'
                        }
                    }
                },
                loc: {
                    start: {
                        line: 98,
                        column: 4,
                        fixed: true,
                        source: 'ion/builder/WebsiteBuilder.ion'
                    },
                    end: {
                        line: 106,
                        column: 5,
                        fixed: true,
                        source: 'ion/builder/WebsiteBuilder.ion'
                    }
                },
                order: '>'
            }
        ],
        bound: false
    }, {
        this: this,
        ion: ion,
        _ref: _ref,
        _ref2: _ref2,
        clientJsDir: clientJsDir,
        serverJsDir: serverJsDir,
        serverJavaDir: serverJavaDir,
        np: np,
        fs: fs,
        builder: builder,
        File: File,
        Directory: Directory,
        utility: utility,
        ModuleBuilder: ModuleBuilder
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/builder/WebsiteBuilder',_ion_builder_WebsiteBuilder_);
    else
      _ion_builder_WebsiteBuilder_.call(this, module, exports, require);
  }
  else {
    _ion_builder_WebsiteBuilder_.call(this);
  }
}).call(this)
void (function(){var _ion_builder_index_ = function(module,exports,require){var addBrowserShim, changeExtension, compileCoffeeScript, compileIon, compileIonWithSourceMap, compilePegjs, compilePegs, exports, fs, getModuleId, ion, isPrivate, name, normalizePath, np, removeExtension, shimJavascript, showPrettyError, syntaxErrorToString, utility, _, _fn, _i, _len, _ref;

if (global.window) {
  return;
}

_ = require('./nodash');

utility = require('./utility');

fs = require('fs');

np = require('path');

ion = require('../');

process.on('uncaughtException', function(e) {
  var _ref;
  return console.error((_ref = e.stack) != null ? _ref : e);
});

module.exports = exports = {
  removeExtension: removeExtension = utility.removeExtension,
  changeExtension: changeExtension = utility.changeExtension,
  normalizePath: normalizePath = utility.normalizePath,
  isPrivate: isPrivate = function(path) {
    var result;
    if (path == null) {
      return false;
    }
    path = normalizePath(path);
    result = path[0] === '_' || path.indexOf('/_') >= 0;
    return result;
  },
  link: function(object) {
    var existingPath, isDirectory, key, value, _results;
    _results = [];
    for (key in object) {
      value = object[key];
      if (!fs.existsSync(key)) {
        console.error("link source not found: " + key);
        continue;
      }
      isDirectory = utility.isDirectory(key);
      existingPath = np.relative(value, key);
      _results.push(console.log("link EXISTING: " + existing + "  LINK: " + value));
    }
    return _results;
  },
  runFile: function(file) {
    var code, js;
    if (!fs.existsSync(file)) {
      console.warn("File not found: {{file}}");
      return;
    }
    code = utility.read(file);
    js = ion.compiler.compile(code);
    return eval(js);
  },
  runTests: (function() {
    var fn;
    fn = function(manifestFile) {
      return require('../browser/tester').spawnTests(manifestFile);
    };
    return _.debounce(_.throttle(fn, 100), 2000);
  })(),
  buildScriptIncludeFile: function(files, base) {
    if (base == null) {
      base = '';
    }
    return files.map(function(x) {
      return "document.writeln(\"<script type='text/javascript' src='" + base + (normalizePath(x)) + "'></script>\");";
    }).join('\n');
  },
  getModuleId: getModuleId = function(source, packageObject) {
    var dir, path, root, srcDirectory, _i, _len;
    if (typeof source === 'string') {
      root = source;
      path = packageObject;
      return normalizePath(removeExtension(np.join(root, path)));
    }
    if (packageObject != null) {
      srcDirectory = packageObject.directories.src;
      if (Array.isArray(srcDirectory)) {
        for (_i = 0, _len = srcDirectory.length; _i < _len; _i++) {
          dir = srcDirectory[_i];
          if (source.path.startsWith(dir)) {
            srcDirectory = dir;
            break;
          }
        }
        if (Array.isArray(srcDirectory)) {
          throw new Error("Couldn't find correct source directory for " + source);
        }
      }
      return normalizePath(removeExtension(np.join(packageObject.name, np.relative(srcDirectory, source.path))));
    } else {
      return null;
    }
  },
  showPrettyError: showPrettyError = function(e, filename, input) {
    var beep, message;
    message = e.message = syntaxErrorToString(e, filename, input);
    beep = '\x07';
    return console.error(message + beep);
  },
  syntaxErrorToString: syntaxErrorToString = function(e, filename, code) {
    var codeLine, colorize, end, first_column, first_line, last_column, last_line, marker, repeat, start, _ref, _ref1;
    if (e.location == null) {
      return e.toString();
    }
    repeat = function(str, n) {
      var res;
      res = '';
      while (n > 0) {
        if (n & 1) {
          res += str;
        }
        n >>>= 1;
        str += str;
      }
      return res;
    };
    _ref = e.location, first_line = _ref.first_line, first_column = _ref.first_column, last_line = _ref.last_line, last_column = _ref.last_column;
    if (last_line == null) {
      last_line = first_line;
    }
    if (last_column == null) {
      last_column = first_column;
    }
    codeLine = code.split('\n')[first_line];
    start = first_column;
    end = first_line === last_line ? last_column + 1 : codeLine.length;
    marker = repeat(' ', start) + repeat('^', end - start);
    colorize = function(str) {
      return "\x1B[1;31m" + str + "\x1B[0m";
    };
    codeLine = codeLine.slice(0, start) + colorize(codeLine.slice(start, end)) + codeLine.slice(end);
    marker = colorize(marker);
    return "" + filename + ":" + (first_line + 1) + ":" + (first_column + 1) + ": error: " + ((_ref1 = e.originalMessage) != null ? _ref1 : e.message) + "\n\n" + codeLine + "\n" + marker;
  },
  compileCoffeeScript: compileCoffeeScript = function(source, packageObject) {
    var compiled, cs, e, filename, input, moduleId, options;
    if (source.modified === 0) {
      return;
    }
    moduleId = typeof packageObject === 'string' ? packageObject : getModuleId(source, packageObject);
    input = source.read();
    filename = source.path;
    cs = require('coffee-script');
    try {
      compiled = cs.compile(input, options = {
        bare: true
      });
      compiled = addBrowserShim(compiled, moduleId, input);
      return compiled;
    } catch (_error) {
      e = _error;
      showPrettyError(e, filename, input);
    }
  },
  compilePegjs: compilePegjs = function(source, packageObject) {
    var e, filename, input, moduleId, parser, peg;
    if (source.modified === 0) {
      return;
    }
    moduleId = typeof packageObject === 'string' ? packageObject : getModuleId(source, packageObject);
    filename = source.path;
    try {
      peg = require('pegjs');
      input = source.read();
      parser = peg.buildParser(input, {
        cache: true,
        output: "source"
      });
      source = "module.exports = " + parser;
      source = addBrowserShim(source, moduleId);
      return source;
    } catch (_error) {
      e = _error;
      return console.error(e);
    }
  },
  compilePegs: compilePegs = function(source, packageObject) {
    var e, filename, input, moduleId, parser, peg;
    if (source.modified === 0) {
      return;
    }
    moduleId = typeof packageObject === 'string' ? packageObject : getModuleId(source, packageObject);
    filename = source.path;
    try {
      peg = require('pegs').bootstrap;
      input = source.read();
      parser = peg.parse(input);
      source = parser;
      source = addBrowserShim(source, moduleId);
      return source;
    } catch (_error) {
      e = _error;
      return console.error(e);
    }
  },
  compileIon: compileIon = function(source, packageObject) {
    var _ref;
    return (_ref = compileIonWithSourceMap(source, packageObject)) != null ? _ref[0] : void 0;
  },
  compileIonWithSourceMap: compileIonWithSourceMap = function(source, packageObject) {
    var e, filename, input, ionCompiler, map, moduleId, _ref;
    if (source.modified === 0) {
      return;
    }
    moduleId = typeof packageObject === 'string' ? packageObject : getModuleId(source, packageObject);
    filename = source.path;
    try {
      ionCompiler = require('../compiler');
      input = source.read();
      _ref = ionCompiler.compileWithSourceMap(input, {
        source: moduleId + ".ion",
        sourceMap: filename.split(/[\/\\]/).pop()
      }), source = _ref[0], map = _ref[1];
      source = addBrowserShim(source, moduleId, input);
      return [source, map];
    } catch (_error) {
      e = _error;
      return console.error(String(e));
    }
  },
  shimJavascript: shimJavascript = function(source, packageObject) {
    var moduleId, result;
    if (source.modified === 0) {
      return;
    }
    moduleId = typeof packageObject === 'string' ? packageObject : getModuleId(source, packageObject);
    result = addBrowserShim(source.read(), moduleId);
    return result;
  },
  addBrowserShim: addBrowserShim = function(sourceText, moduleId, originalSource) {
    var safeId, stripValue;
    if ((originalSource != null ? originalSource.substring(0, 2) : void 0) === "#!") {
      stripValue = "#!browser";
      if (sourceText.startsWith(stripValue)) {
        sourceText = sourceText.substring(stripValue.length);
      }
      return sourceText;
    }
    if (moduleId != null) {
      safeId = "_" + moduleId.replace(/[^a-zA-Z0-9]/g, '_') + "_";
      sourceText = "void (function(){var " + safeId + " = function(module,exports,require){" + sourceText + "\n  }\n  if (typeof require === 'function') {\n    if (require.register)\n      require.register('" + moduleId + "'," + safeId + ");\n    else\n      " + safeId + ".call(this, module, exports, require);\n  }\n  else {\n    " + safeId + ".call(this);\n  }\n}).call(this)";
    }
    return sourceText;
  }
};

_ref = ["ModuleBuilder", "WebsiteBuilder", "File", "Directory", "utility"];
_fn = function(name) {
  return Object.defineProperty(exports, name, {
    enumerable: true,
    get: function() {
      return require("./" + name);
    }
  });
};
for (_i = 0, _len = _ref.length; _i < _len; _i++) {
  name = _ref[_i];
  _fn(name);
}

  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/builder/index',_ion_builder_index_);
    else
      _ion_builder_index_.call(this, module, exports, require);
  }
  else {
    _ion_builder_index_.call(this);
  }
}).call(this)
void (function(){var _ion_builder_nodash_ = function(module,exports,require){
function isObject(value) {
  const type = typeof value
  return value != null && (type == 'object' || type == 'function')
}

function debounce(func, wait, options) {
  let lastArgs,
    lastThis,
    maxWait,
    result,
    timerId,
    lastCallTime

  let lastInvokeTime = 0
  let leading = false
  let maxing = false
  let trailing = true

  if (typeof func != 'function') {
    throw new TypeError('Expected a function')
  }
  wait = +wait || 0
  if (isObject(options)) {
    leading = !!options.leading
    maxing = 'maxWait' in options
    maxWait = maxing ? Math.max(+options.maxWait || 0, wait) : maxWait
    trailing = 'trailing' in options ? !!options.trailing : trailing
  }

  function invokeFunc(time) {
    const args = lastArgs
    const thisArg = lastThis

    lastArgs = lastThis = undefined
    lastInvokeTime = time
    result = func.apply(thisArg, args)
    return result
  }

  function leadingEdge(time) {
    // Reset any `maxWait` timer.
    lastInvokeTime = time
    // Start the timer for the trailing edge.
    timerId = setTimeout(timerExpired, wait)
    // Invoke the leading edge.
    return leading ? invokeFunc(time) : result
  }

  function remainingWait(time) {
    const timeSinceLastCall = time - lastCallTime
    const timeSinceLastInvoke = time - lastInvokeTime
    const result = wait - timeSinceLastCall

    return maxing ? Math.min(result, maxWait - timeSinceLastInvoke) : result
  }

  function shouldInvoke(time) {
    const timeSinceLastCall = time - lastCallTime
    const timeSinceLastInvoke = time - lastInvokeTime

    // Either this is the first call, activity has stopped and we're at the
    // trailing edge, the system time has gone backwards and we're treating
    // it as the trailing edge, or we've hit the `maxWait` limit.
    return (lastCallTime === undefined || (timeSinceLastCall >= wait) ||
      (timeSinceLastCall < 0) || (maxing && timeSinceLastInvoke >= maxWait))
  }

  function timerExpired() {
    const time = Date.now()
    if (shouldInvoke(time)) {
      return trailingEdge(time)
    }
    // Restart the timer.
    timerId = setTimeout(timerExpired, remainingWait(time))
  }

  function trailingEdge(time) {
    timerId = undefined

    // Only invoke if we have `lastArgs` which means `func` has been
    // debounced at least once.
    if (trailing && lastArgs) {
      return invokeFunc(time)
    }
    lastArgs = lastThis = undefined
    return result
  }

  function cancel() {
    if (timerId !== undefined) {
      clearTimeout(timerId)
    }
    lastInvokeTime = 0
    lastArgs = lastCallTime = lastThis = timerId = undefined
  }

  function flush() {
    return timerId === undefined ? result : trailingEdge(Date.now())
  }

  function debounced(...args) {
    const time = Date.now()
    const isInvoking = shouldInvoke(time)

    lastArgs = args
    lastThis = this
    lastCallTime = time

    if (isInvoking) {
      if (timerId === undefined) {
        return leadingEdge(lastCallTime)
      }
      if (maxing) {
        // Handle invocations in a tight loop.
        timerId = setTimeout(timerExpired, wait)
        return invokeFunc(lastCallTime)
      }
    }
    if (timerId === undefined) {
      timerId = setTimeout(timerExpired, wait)
    }
    return result
  }
  debounced.cancel = cancel
  debounced.flush = flush
  return debounced
}

function throttle(func, wait, options) {
  let leading = true
  let trailing = true

  if (typeof func != 'function') {
    throw new TypeError('Expected a function')
  }
  if (isObject(options)) {
    leading = 'leading' in options ? !!options.leading : leading
    trailing = 'trailing' in options ? !!options.trailing : trailing
  }
  return debounce(func, wait, {
    'leading': leading,
    'maxWait': wait,
    'trailing': trailing
  })
}

exports.throttle = throttle
exports.debounce = debounce

  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/builder/nodash',_ion_builder_nodash_);
    else
      _ion_builder_nodash_.call(this, module, exports, require);
  }
  else {
    _ion_builder_nodash_.call(this);
  }
}).call(this)
void (function(){var _ion_builder_utility_ = function(module,exports,require){var buildCoffee, changeExtension, copy, copyMetadata, cp, exec, exists, exports, fixCommand, fs, getModified, getStats, isDirectory, isFile, isMatch, isWindows, list, makeDirectories, makeParentDirectories, normalizePath, np, read, removeExtension, spawn, touch, watchCoffee, write;

if (global.window) {
  return;
}

fs = require('fs');

np = require('path');

cp = require('child_process');

isWindows = process.platform === 'win32';

fixCommand = function(command) {
  if (!isWindows) {
    command = command.replace(/\.cmd\b/, "");
  }
  return command;
};

module.exports = exports = {
  spawn: spawn = function(command, options, callback) {
    var args, child, e, originalCommand;
    originalCommand = command;
    if (command == null) {
      return typeof callback === "function" ? callback() : void 0;
    }
    command = fixCommand(command);
    if (typeof options === 'function') {
      callback = options;
      options = null;
    }
    if (options == null) {
      options = {};
    }
    if (options.stdio == null) {
      options.stdio = 'inherit';
    }
    args = command.split(/\s+/);
    command = args.shift();
    try {
      child = cp.spawn(command, args, options);
      if (callback != null) {
        child.on('exit', callback);
      }
      child.on('error', function(error) {
        console.log("Error running " + originalCommand + "\n" + error);
        return typeof callback === "function" ? callback() : void 0;
      });
    } catch (_error) {
      e = _error;
      console.log(originalCommand);
      throw e;
    }
    return child;
  },
  exec: exec = function(command, options, callback) {
    var e, originalCommand;
    originalCommand = command;
    if (command == null) {
      return typeof callback === "function" ? callback() : void 0;
    }
    command = fixCommand(command);
    if (typeof options === 'function') {
      callback = options;
      options = null;
    }
    if (options == null) {
      options = {};
    }
    try {
      return cp.exec(command, options, function(err, stdout, stderr) {
        if (err != null) {
          console.log(err);
        }
        if (stdout != null) {
          console.log(stdout.toString());
        }
        if (stderr != null) {
          console.log(stderr.toString());
        }
        return typeof callback === "function" ? callback() : void 0;
      });
    } catch (_error) {
      e = _error;
      console.log(originalCommand);
      throw e;
    }
  },
  copyMetadata: copyMetadata = function(source, target) {
    var file, from, to, _i, _len, _ref, _results;
    _ref = ["package.json", "README.md"];
    _results = [];
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      file = _ref[_i];
      from = np.join(source, file);
      to = np.join(target, file);
      if (exists(from)) {
        _results.push(copy(from, to));
      } else {
        _results.push(void 0);
      }
    }
    return _results;
  },
  buildCoffee: buildCoffee = function(input, output, callback) {
    return spawn("coffee.cmd -c -o " + output + " " + input, callback);
  },
  watchCoffee: watchCoffee = function(input, output) {
    return spawn("coffee.cmd -w -c -o " + output + " " + input);
  },
  isMatch: isMatch = function(value, match, defaultValue) {
    var item, _i, _len;
    if (defaultValue == null) {
      defaultValue = false;
    }
    if (match == null) {
      return defaultValue;
    }
    if ('function' === typeof match) {
      return match(value);
    }
    if (Array.isArray(match)) {
      for (_i = 0, _len = match.length; _i < _len; _i++) {
        item = match[_i];
        if (isMatch(value, item)) {
          return true;
        }
      }
      return false;
    }
    value = normalizePath(value);
    if (typeof match === 'string') {
      return value.startsWith(match) || value.endsWith(match);
    }
    value = value.split(/[\/\\]/g).pop();
    return typeof match.test === "function" ? match.test(value) : void 0;
  },
  defaultFileExclude: ["node_modules", "www"],
  removeExtension: removeExtension = function(file) {
    var dot;
    dot = file.lastIndexOf('.');
    if (dot > 0) {
      return file.substring(0, dot);
    } else {
      return file;
    }
  },
  changeExtension: changeExtension = function(file, ext) {
    return removeExtension(file) + ext;
  },
  touch: touch = function(file) {
    var now;
    now = new Date();
    return fs.utimesSync(file, now, now);
  },
  getModified: getModified = function(path) {
    var date, e, stats, time;
    try {
      stats = getStats(path);
      if ((stats != null ? stats.mtime : void 0) != null) {
        date = new Date(stats.mtime);
        time = date.getTime();
        return time;
      } else {
        return 0;
      }
    } catch (_error) {
      e = _error;
      console.warn(e);
    }
    return 0;
  },
  exists: exists = function(file) {
    return fs.existsSync(file);
  },
  getStats: getStats = function(file) {
    var e;
    try {
      return fs.statSync(file);
    } catch (_error) {
      e = _error;
      return null;
    }
  },
  isFile: isFile = function(file) {
    var _ref;
    return ((_ref = getStats(file)) != null ? typeof _ref.isFile === "function" ? _ref.isFile() : void 0 : void 0) === true;
  },
  isDirectory: isDirectory = function(file) {
    var _ref;
    return ((_ref = getStats(file)) != null ? typeof _ref.isDirectory === "function" ? _ref.isDirectory() : void 0 : void 0) === true;
  },
  list: list = function(dir, options, files) {
    var exclude, file, recursive, _i, _len, _ref, _ref1, _ref2;
    if (options == null) {
      options = {};
    }
    if (files == null) {
      files = [];
    }
    exclude = (_ref = options.exclude) != null ? _ref : exports.defaultFileExclude;
    recursive = (_ref1 = options.recursive) != null ? _ref1 : true;
    if (exists(dir)) {
      _ref2 = fs.readdirSync(dir);
      for (_i = 0, _len = _ref2.length; _i < _len; _i++) {
        file = _ref2[_i];
        file = np.join(dir, file);
        if (!isMatch(file, exclude, false)) {
          if (isMatch(file, options.include, true)) {
            files.push(file);
          }
          if (recursive && isDirectory(file)) {
            list(file, options, files);
          }
        }
      }
    }
    return files;
  },
  makeDirectories: makeDirectories = function(dir) {
    if (typeof dir !== 'string') {
      throw new Error("dir is not a string: " + (JSON.stringify(dir)));
    }
    if (!exists(dir)) {
      makeDirectories(np.dirname(dir));
      return fs.mkdirSync(dir);
    }
  },
  makeParentDirectories: makeParentDirectories = function(file) {
    return makeDirectories(np.dirname(file));
  },
  read: read = function(file, encoding) {
    if (encoding === void 0) {
      encoding = 'utf8';
    }
    if (!exists(file)) {
      return null;
    }
    return fs.readFileSync(file, encoding);
  },
  write: write = function(file, content, encoding) {
    makeParentDirectories(file);
    if (content != null) {
      if (encoding === void 0 && typeof content === 'string') {
        encoding = 'utf8';
      }
      return fs.writeFileSync(file, content, encoding);
    } else if (exists(file)) {
      return fs.unlinkSync(file);
    }
  },
  copy: copy = function(source, target, include) {
    var content, file, files, _i, _len, _results;
    target = np.normalize(target);
    if (isFile(source)) {
      if (isMatch(source, include, true)) {
        content = read(source);
        write(target, content);
        return console.log("Copied: " + (np.normalize(target)));
      }
    } else if (isDirectory(source)) {
      files = fs.readdirSync(source);
      _results = [];
      for (_i = 0, _len = files.length; _i < _len; _i++) {
        file = files[_i];
        _results.push(copy(np.join(source, file), np.join(target, file), include));
      }
      return _results;
    }
  },
  normalizePath: normalizePath = function(path) {
    return path != null ? path.replace(/\\/g, "\/") : void 0;
  },
  watchCopy: function(input, output, include) {
    var watcher;
    watcher = require('./watcher');
    return watcher.watchDirectory(input, {
      include: include
    }, function(inputFile) {
      var outputFile;
      outputFile = np.join(output, np.relative(input, inputFile));
      return copy(inputFile, outputFile);
    });
  },
  getMatches: function(s, regex, group) {
    var match, results;
    if (!regex.global) {
      throw 'regex must be declared with global modifier /trailing/g';
    }
    results = [];
    while (match = regex.exec(s)) {
      results.push(group > 0 ? match[group] : match);
    }
    return results;
  }
};

  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/builder/utility',_ion_builder_utility_);
    else
      _ion_builder_utility_.call(this, module, exports, require);
  }
  else {
    _ion_builder_utility_.call(this);
  }
}).call(this)
void (function(){var _ion_builder_watcher_ = function(module,exports,require){var allWatchers, fs, ion, np, util;

if (global.window) {
  return;
}

ion = require('../');

fs = require('fs');

np = require('path');

util = require('./utility');

exports.watchDirectory = function(dirname, options, listener) {
  var filter, fsListener, initial, notifyListener, unwatchFile, watchFile, watchedFiles;
  if (listener == null) {
    listener = options;
    options = {};
  }
  if (options.persistent == null) {
    options.persistent = true;
  }
  if (options.interval == null) {
    options.interval = 100;
  }
  if (options.recursive == null) {
    options.recursive = true;
  }
  if (options.initial == null) {
    options.initial = 'initial';
  }
  if (options.exclude == null) {
    options.exclude = util.defaultFileExclude;
  }
  filter = function(name) {
    if (util.isMatch(name, options.exclude, false)) {
      return false;
    } else {
      return util.isMatch(name, options.include, true);
    }
  };
  watchedFiles = {};
  notifyListener = function(filename, curr, prev, change, async) {
    if (async == null) {
      async = false;
    }
    if (filter(filename)) {
      if (async) {
        return ion.setImmediate(function() {
          return listener(filename, curr, prev, change);
        });
      } else {
        return listener(filename, curr, prev, change);
      }
    }
  };
  fsListener = function(filename, depth, curr, prev) {
    var change;
    change = curr.nlink === 0 ? 'deleted' : prev.nlink === 0 ? 'created' : 'modified';
    notifyListener(filename, curr, prev, change);
    if (change !== 'deleted') {
      return watchFile(filename, depth, curr);
    } else {
      return unwatchFile(filename);
    }
  };
  unwatchFile = function(filename) {
    fs.unwatchFile(filename, watchedFiles[filename]);
    delete watchedFiles[filename];
    return allWatchers[filename]--;
  };
  watchFile = function(filename, depth, stats) {
    var boundListener, child, _i, _len, _ref;
    if (depth == null) {
      depth = 0;
    }
    if (fs.existsSync(filename)) {
      if (stats == null) {
        stats = fs.statSync(filename);
      }
      if (stats.nlink > 0) {
        if (stats.isDirectory()) {
          if (!util.isMatch(filename, options.exclude, false)) {
            if (depth === 0 || options.recursive) {
              _ref = fs.readdirSync(filename);
              for (_i = 0, _len = _ref.length; _i < _len; _i++) {
                child = _ref[_i];
                child = np.join(filename, child);
                watchFile(child, depth + 1);
              }
            }
          }
        }
        if (watchedFiles[filename] == null) {
          if (allWatchers[filename] == null) {
            allWatchers[filename] = 0;
          }
          allWatchers[filename]++;
          boundListener = fsListener.bind(this, filename, depth);
          watchedFiles[filename] = boundListener;
          fs.watchFile(filename, options, boundListener);
          if (initial) {
            notifyListener(filename, stats, stats, initial, true);
          }
        }
      }
    }
  };
  initial = options.initial;
  watchFile(dirname);
  initial = 'created';
  return function() {
    var key, _results;
    _results = [];
    for (key in watchedFiles) {
      _results.push(unwatchFile(key));
    }
    return _results;
  };
};

allWatchers = {};

  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/builder/watcher',_ion_builder_watcher_);
    else
      _ion_builder_watcher_.call(this, module, exports, require);
  }
  else {
    _ion_builder_watcher_.call(this);
  }
}).call(this)
void (function(){var _ion_compiler_astFunctions_ = function(module,exports,require){'use strict';
var ion = exports.ion = require('../'), addStatement = exports.addStatement = function (node, statement, index, offset) {
        var body = node.body;
        if (body.type === 'BlockStatement') {
            body = body.body;
        } else if (!Array.isArray(body)) {
            node.body = {
                type: 'BlockStatement',
                body: body = [node.body]
            };
        }
        if (!(index != null)) {
            index = 0;
        } else if (index.type != null) {
            index = body.indexOf(index) + (offset != null ? offset : 1);
        }
        index = Math.max(0, Math.min(index, body.length));
        body.splice(index, 0, statement);
    }, forEachDestructuringAssignment = exports.forEachDestructuringAssignment = function (pattern, expression, callback) {
        if (pattern.type === 'Identifier') {
            callback(pattern, expression);
        } else if (pattern.properties != null) {
            {
                var _ref = pattern.properties;
                for (var _i = 0; _i < _ref.length; _i++) {
                    var _ref3 = _ref[_i];
                    var key = _ref3.key;
                    var value = _ref3.value;
                    forEachDestructuringAssignment(value, {
                        type: 'MemberExpression',
                        object: expression,
                        property: key,
                        computed: key.type !== 'Identifier'
                    }, callback);
                }
            }
        } else if (pattern.elements != null) {
            {
                var _ref2 = pattern.elements;
                for (var _i2 = 0; _i2 < _ref2.length; _i2++) {
                    var index = _i2;
                    var value = _ref2[_i2];
                    forEachDestructuringAssignment(value, {
                        type: 'MemberExpression',
                        object: expression,
                        property: {
                            type: 'Literal',
                            value: index
                        },
                        computed: true
                    }, callback);
                }
            }
        }
    };
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/compiler/astFunctions',_ion_compiler_astFunctions_);
    else
      _ion_compiler_astFunctions_.call(this, module, exports, require);
  }
  else {
    _ion_compiler_astFunctions_.call(this);
  }
}).call(this)
void (function(){var _ion_compiler_common_ = function(module,exports,require){'use strict';
var ion = require('../'), lineDelimiter = '\n', isEmpty = function (s) {
        return !(s != null) || s.length === 0 || (s.trim != null ? s.trim().length : void 0) === 0;
    }, trimRight = function (s) {
        return s.replace(/[\s\xA0]+$/g, '');
    };
var indentToken = exports.indentToken = '{{{{', outdentToken = exports.outdentToken = '}}}}', splitLines = exports.splitLines = function (s) {
        return s.split(lineDelimiter);
    }, joinLines = exports.joinLines = function (array) {
        return array.join(lineDelimiter);
    }, getIndent = exports.getIndent = function (s, regex) {
        regex = regex != null ? regex : /^([ ]*)/;
        return (regex.exec(s) != null ? regex.exec(s)[1].length : void 0) != null ? regex.exec(s)[1].length : Number.MAX_VALUE;
    }, unindentString = exports.unindentString = function (s, sourceMapping) {
        var lines = splitLines(trimRight(s));
        var minIndent = unindentLines(lines);
        if (sourceMapping != null) {
            sourceMapping.columnOffset = minIndent;
        }
        return joinLines(lines);
    }, getMinIndent = exports.getMinIndent = function (lines, regex) {
        var minIndent = Number.MAX_VALUE;
        for (var i = 0; i < lines.length; i++) {
            var line = lines[i];
            var next = lines[i + 1];
            if (typeof line === 'string' && (!isEmpty(line) || typeof next === 'object')) {
                minIndent = Math.min(minIndent, getIndent(line, regex));
            }
        }
        return minIndent;
    }, unindentLines = exports.unindentLines = function (lines) {
        var minIndent = getMinIndent(lines);
        for (var _i = 0; _i < lines.length; _i++) {
            var i = _i;
            var line = lines[_i];
            if (typeof line === 'string') {
                lines[i] = isEmpty(line) ? '' : line.substring(minIndent);
            }
        }
        return minIndent;
    };
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/compiler/common',_ion_compiler_common_);
    else
      _ion_compiler_common_.call(this, module, exports, require);
  }
  else {
    _ion_compiler_common_.call(this);
  }
}).call(this)
void (function(){var _ion_compiler_escodegen_index_ = function(module,exports,require){/*
  Copyright (C) 2012-2013 Yusuke Suzuki <utatane.tea@gmail.com>
  Copyright (C) 2012-2013 Michael Ficarra <escodegen.copyright@michael.ficarra.me>
  Copyright (C) 2012-2013 Mathias Bynens <mathias@qiwi.be>
  Copyright (C) 2013 Irakli Gozalishvili <rfobic@gmail.com>
  Copyright (C) 2012 Robert Gust-Bardon <donate@robert.gust-bardon.org>
  Copyright (C) 2012 John Freeman <jfreeman08@gmail.com>
  Copyright (C) 2011-2012 Ariya Hidayat <ariya.hidayat@gmail.com>
  Copyright (C) 2012 Joost-Wim Boekesteijn <joost-wim@boekesteijn.nl>
  Copyright (C) 2012 Kris Kowal <kris.kowal@cixar.com>
  Copyright (C) 2012 Arpad Borsos <arpad.borsos@googlemail.com>

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> BE LIABLE FOR ANY
  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
  (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/*global exports:true, generateStatement:true, generateExpression:true, require:true, global:true*/
(function () {
    'use strict';

    var Syntax,
        Precedence,
        BinaryPrecedence,
        SourceNode,
        estraverse,
        esutils,
        isArray,
        base,
        indent,
        json,
        renumber,
        hexadecimal,
        quotes,
        escapeless,
        newline,
        space,
        parentheses,
        semicolons,
        safeConcatenation,
        directive,
        extra,
        parse,
        sourceMap,
        FORMAT_MINIFY,
        FORMAT_DEFAULTS;

    estraverse = require('../estraverse');
    esutils = require('../esutils');

    Syntax = {
        AssignmentExpression: 'AssignmentExpression',
        ArrayExpression: 'ArrayExpression',
        ArrayPattern: 'ArrayPattern',
        ArrowFunctionExpression: 'ArrowFunctionExpression',
        BlockStatement: 'BlockStatement',
        BinaryExpression: 'BinaryExpression',
        BreakStatement: 'BreakStatement',
        CallExpression: 'CallExpression',
        CatchClause: 'CatchClause',
        ComprehensionBlock: 'ComprehensionBlock',
        ComprehensionExpression: 'ComprehensionExpression',
        ConditionalExpression: 'ConditionalExpression',
        ContinueStatement: 'ContinueStatement',
        DirectiveStatement: 'DirectiveStatement',
        DoWhileStatement: 'DoWhileStatement',
        DebuggerStatement: 'DebuggerStatement',
        EmptyStatement: 'EmptyStatement',
        ExportDeclaration: 'ExportDeclaration',
        ExpressionStatement: 'ExpressionStatement',
        ForStatement: 'ForStatement',
        ForInStatement: 'ForInStatement',
        ForOfStatement: 'ForOfStatement',
        FunctionDeclaration: 'FunctionDeclaration',
        FunctionExpression: 'FunctionExpression',
        GeneratorExpression: 'GeneratorExpression',
        Identifier: 'Identifier',
        IfStatement: 'IfStatement',
        ImportDeclaration: 'ImportDeclaration',
        Literal: 'Literal',
        LabeledStatement: 'LabeledStatement',
        LogicalExpression: 'LogicalExpression',
        MemberExpression: 'MemberExpression',
        NewExpression: 'NewExpression',
        ObjectExpression: 'ObjectExpression',
        ObjectPattern: 'ObjectPattern',
        Program: 'Program',
        Property: 'Property',
        ReturnStatement: 'ReturnStatement',
        SequenceExpression: 'SequenceExpression',
        SwitchStatement: 'SwitchStatement',
        SwitchCase: 'SwitchCase',
        ThisExpression: 'ThisExpression',
        ThrowStatement: 'ThrowStatement',
        TryStatement: 'TryStatement',
        UnaryExpression: 'UnaryExpression',
        UpdateExpression: 'UpdateExpression',
        VariableDeclaration: 'VariableDeclaration',
        VariableDeclarator: 'VariableDeclarator',
        WhileStatement: 'WhileStatement',
        WithStatement: 'WithStatement',
        YieldExpression: 'YieldExpression'
    };

    Precedence = {
        Sequence: 0,
        Yield: 1,
        Assignment: 1,
        Conditional: 2,
        ArrowFunction: 2,
        LogicalOR: 3,
        LogicalAND: 4,
        BitwiseOR: 5,
        BitwiseXOR: 6,
        BitwiseAND: 7,
        Equality: 8,
        Relational: 9,
        BitwiseSHIFT: 10,
        Additive: 11,
        Multiplicative: 12,
        Unary: 13,
        Postfix: 14,
        Call: 15,
        New: 16,
        Member: 17,
        Primary: 18
    };

    BinaryPrecedence = {
        '||': Precedence.LogicalOR,
        '&&': Precedence.LogicalAND,
        '|': Precedence.BitwiseOR,
        '^': Precedence.BitwiseXOR,
        '&': Precedence.BitwiseAND,
        '==': Precedence.Equality,
        '!=': Precedence.Equality,
        '===': Precedence.Equality,
        '!==': Precedence.Equality,
        'is': Precedence.Equality,
        'isnt': Precedence.Equality,
        '<': Precedence.Relational,
        '>': Precedence.Relational,
        '<=': Precedence.Relational,
        '>=': Precedence.Relational,
        'in': Precedence.Relational,
        'instanceof': Precedence.Relational,
        '<<': Precedence.BitwiseSHIFT,
        '>>': Precedence.BitwiseSHIFT,
        '>>>': Precedence.BitwiseSHIFT,
        '+': Precedence.Additive,
        '-': Precedence.Additive,
        '*': Precedence.Multiplicative,
        '%': Precedence.Multiplicative,
        '/': Precedence.Multiplicative
    };

    function getDefaultOptions() {
        // default options
        return {
            indent: null,
            base: null,
            parse: null,
            comment: false,
            format: {
                indent: {
                    style: '    ',
                    base: 0,
                    adjustMultilineComment: false
                },
                newline: '\n',
                space: ' ',
                json: false,
                renumber: false,
                hexadecimal: false,
                quotes: 'single',
                escapeless: false,
                compact: false,
                parentheses: true,
                semicolons: true,
                safeConcatenation: false
            },
            moz: {
                comprehensionExpressionStartsWithAssignment: false,
                starlessGenerator: false,
                parenthesizedComprehensionBlock: false
            },
            sourceMap: null,
            sourceMapRoot: null,
            sourceMapWithCode: false,
            directive: false,
            raw: true,
            verbatim: null
        };
    }

    function stringRepeat(str, num) {
        var result = '';

        for (num |= 0; num > 0; num >>>= 1, str += str) {
            if (num & 1) {
                result += str;
            }
        }

        return result;
    }

    isArray = Array.isArray;
    if (!isArray) {
        isArray = function isArray(array) {
            return Object.prototype.toString.call(array) === '[object Array]';
        };
    }

    function hasLineTerminator(str) {
        return (/[\r\n]/g).test(str);
    }

    function endsWithLineTerminator(str) {
        var len = str.length;
        return len && esutils.code.isLineTerminator(str.charCodeAt(len - 1));
    }

    function updateDeeply(target, override) {
        var key, val;

        function isHashObject(target) {
            return typeof target === 'object' && target instanceof Object && !(target instanceof RegExp);
        }

        for (key in override) {
            if (override.hasOwnProperty(key)) {
                val = override[key];
                if (isHashObject(val)) {
                    if (isHashObject(target[key])) {
                        updateDeeply(target[key], val);
                    } else {
                        target[key] = updateDeeply({}, val);
                    }
                } else {
                    target[key] = val;
                }
            }
        }
        return target;
    }

    function generateNumber(value) {
        var result, point, temp, exponent, pos;

        if (value !== value) {
            throw new Error('Numeric literal whose value is NaN');
        }
        if (value < 0 || (value === 0 && 1 / value < 0)) {
            throw new Error('Numeric literal whose value is negative');
        }

        if (value === 1 / 0) {
            return json ? 'null' : renumber ? '1e400' : '1e+400';
        }

        result = '' + value;
        if (!renumber || result.length < 3) {
            return result;
        }

        point = result.indexOf('.');
        if (!json && result.charCodeAt(0) === 0x30  /* 0 */ && point === 1) {
            point = 0;
            result = result.slice(1);
        }
        temp = result;
        result = result.replace('e+', 'e');
        exponent = 0;
        if ((pos = temp.indexOf('e')) > 0) {
            exponent = +temp.slice(pos + 1);
            temp = temp.slice(0, pos);
        }
        if (point >= 0) {
            exponent -= temp.length - point - 1;
            temp = +(temp.slice(0, point) + temp.slice(point + 1)) + '';
        }
        pos = 0;
        while (temp.charCodeAt(temp.length + pos - 1) === 0x30  /* 0 */) {
            --pos;
        }
        if (pos !== 0) {
            exponent -= pos;
            temp = temp.slice(0, pos);
        }
        if (exponent !== 0) {
            temp += 'e' + exponent;
        }
        if ((temp.length < result.length ||
                    (hexadecimal && value > 1e12 && Math.floor(value) === value && (temp = '0x' + value.toString(16)).length < result.length)) &&
                +temp === value) {
            result = temp;
        }

        return result;
    }

    // Generate valid RegExp expression.
    // This function is based on https://github.com/Constellation/iv Engine

    function escapeRegExpCharacter(ch, previousIsBackslash) {
        // not handling '\' and handling \u2028 or \u2029 to unicode escape sequence
        if ((ch & ~1) === 0x2028) {
            return (previousIsBackslash ? 'u' : '\\u') + ((ch === 0x2028) ? '2028' : '2029');
        } else if (ch === 10 || ch === 13) {  // \n, \r
            return (previousIsBackslash ? '' : '\\') + ((ch === 10) ? 'n' : 'r');
        }
        return String.fromCharCode(ch);
    }

    function generateRegExp(reg) {
        var match, result, flags, i, iz, ch, characterInBrack, previousIsBackslash;

        result = reg.toString();

        if (reg.source) {
            // extract flag from toString result
            match = result.match(/\/([^/]*)$/);
            if (!match) {
                return result;
            }

            flags = match[1];
            result = '';

            characterInBrack = false;
            previousIsBackslash = false;
            for (i = 0, iz = reg.source.length; i < iz; ++i) {
                ch = reg.source.charCodeAt(i);

                if (!previousIsBackslash) {
                    if (characterInBrack) {
                        if (ch === 93) {  // ]
                            characterInBrack = false;
                        }
                    } else {
                        if (ch === 47) {  // /
                            result += '\\';
                        } else if (ch === 91) {  // [
                            characterInBrack = true;
                        }
                    }
                    result += escapeRegExpCharacter(ch, previousIsBackslash);
                    previousIsBackslash = ch === 92;  // \
                } else {
                    // if new RegExp("\\\n') is provided, create /\n/
                    result += escapeRegExpCharacter(ch, previousIsBackslash);
                    // prevent like /\\[/]/
                    previousIsBackslash = false;
                }
            }

            return '/' + result + '/' + flags;
        }

        return result;
    }

    function escapeAllowedCharacter(code, next) {
        var hex, result = '\\';

        switch (code) {
        case 0x08  /* \b */:
            result += 'b';
            break;
        case 0x0C  /* \f */:
            result += 'f';
            break;
        case 0x09  /* \t */:
            result += 't';
            break;
        default:
            hex = code.toString(16).toUpperCase();
            if (json || code > 0xFF) {
                result += 'u' + '0000'.slice(hex.length) + hex;
            } else if (code === 0x0000 && !esutils.code.isDecimalDigit(next)) {
                result += '0';
            } else if (code === 0x000B  /* \v */) { // '\v'
                result += 'x0B';
            } else {
                result += 'x' + '00'.slice(hex.length) + hex;
            }
            break;
        }

        return result;
    }

    function escapeDisallowedCharacter(code) {
        var result = '\\';
        switch (code) {
        case 0x5C  /* \ */:
            result += '\\';
            break;
        case 0x0A  /* \n */:
            result += 'n';
            break;
        case 0x0D  /* \r */:
            result += 'r';
            break;
        case 0x2028:
            result += 'u2028';
            break;
        case 0x2029:
            result += 'u2029';
            break;
        default:
            throw new Error('Incorrectly classified character');
        }

        return result;
    }

    function escapeDirective(str) {
        var i, iz, code, quote;

        quote = quotes === 'double' ? '"' : '\'';
        for (i = 0, iz = str.length; i < iz; ++i) {
            code = str.charCodeAt(i);
            if (code === 0x27  /* ' */) {
                quote = '"';
                break;
            } else if (code === 0x22  /* " */) {
                quote = '\'';
                break;
            } else if (code === 0x5C  /* \ */) {
                ++i;
            }
        }

        return quote + str + quote;
    }

    function escapeString(str) {
        var result = '', i, len, code, singleQuotes = 0, doubleQuotes = 0, single, quote;

        for (i = 0, len = str.length; i < len; ++i) {
            code = str.charCodeAt(i);
            if (code === 0x27  /* ' */) {
                ++singleQuotes;
            } else if (code === 0x22  /* " */) {
                ++doubleQuotes;
            } else if (code === 0x2F  /* / */ && json) {
                result += '\\';
            } else if (esutils.code.isLineTerminator(code) || code === 0x5C  /* \ */) {
                result += escapeDisallowedCharacter(code);
                continue;
            } else if ((json && code < 0x20  /* SP */) || !(json || escapeless || (code >= 0x20  /* SP */ && code <= 0x7E  /* ~ */))) {
                result += escapeAllowedCharacter(code, str.charCodeAt(i + 1));
                continue;
            }
            result += String.fromCharCode(code);
        }

        single = !(quotes === 'double' || (quotes === 'auto' && doubleQuotes < singleQuotes));
        quote = single ? '\'' : '"';

        if (!(single ? singleQuotes : doubleQuotes)) {
            return quote + result + quote;
        }

        str = result;
        result = quote;

        for (i = 0, len = str.length; i < len; ++i) {
            code = str.charCodeAt(i);
            if ((code === 0x27  /* ' */ && single) || (code === 0x22  /* " */ && !single)) {
                result += '\\';
            }
            result += String.fromCharCode(code);
        }

        return result + quote;
    }

    /**
     * flatten an array to a string, where the array can contain
     * either strings or nested arrays
     */
    function flattenToString(arr) {
        var i, iz, elem, result = '';
        for (i = 0, iz = arr.length; i < iz; ++i) {
            elem = arr[i];
            result += isArray(elem) ? flattenToString(elem) : elem;
        }
        return result;
    }

    /**
     * convert generated to a SourceNode when source maps are enabled.
     */
    function toSourceNodeWhenNeeded(generated, node) {
        if (!sourceMap) {
            // with no source maps, generated is either an
            // array or a string.  if an array, flatten it.
            // if a string, just return it
            if (isArray(generated)) {
                return flattenToString(generated);
            } else {
                return generated;
            }
        }
        if (node == null) {
            if (generated instanceof SourceNode) {
                return generated;
            } else {
                node = {};
            }
        }
        if (node.loc == null) {
            return new SourceNode(null, null, sourceMap, generated, node.name || null);
        }
        return new SourceNode(node.loc.start.line, node.loc.start.column, (sourceMap === true ? node.loc.source || null : sourceMap), generated, node.name || null);
    }

    function noEmptySpace() {
        return (space) ? space : ' ';
    }

    function join(left, right) {
        var leftSource = toSourceNodeWhenNeeded(left).toString(),
            rightSource = toSourceNodeWhenNeeded(right).toString(),
            leftCharCode = leftSource.charCodeAt(leftSource.length - 1),
            rightCharCode = rightSource.charCodeAt(0);

        if ((leftCharCode === 0x2B  /* + */ || leftCharCode === 0x2D  /* - */) && leftCharCode === rightCharCode ||
        esutils.code.isIdentifierPart(leftCharCode) && esutils.code.isIdentifierPart(rightCharCode) ||
        leftCharCode === 0x2F  /* / */ && rightCharCode === 0x69  /* i */) { // infix word operators all start with `i`
            return [left, noEmptySpace(), right];
        } else if (esutils.code.isWhiteSpace(leftCharCode) || esutils.code.isLineTerminator(leftCharCode) ||
                esutils.code.isWhiteSpace(rightCharCode) || esutils.code.isLineTerminator(rightCharCode)) {
            return [left, right];
        }
        return [left, space, right];
    }

    function addIndent(stmt) {
        return [base, stmt];
    }

    function withIndent(fn) {
        var previousBase, result;
        previousBase = base;
        base += indent;
        result = fn.call(this, base);
        base = previousBase;
        return result;
    }

    function calculateSpaces(str) {
        var i;
        for (i = str.length - 1; i >= 0; --i) {
            if (esutils.code.isLineTerminator(str.charCodeAt(i))) {
                break;
            }
        }
        return (str.length - 1) - i;
    }

    function adjustMultilineComment(value, specialBase) {
        var array, i, len, line, j, spaces, previousBase, sn;

        array = value.split(/\r\n|[\r\n]/);
        spaces = Number.MAX_VALUE;

        // first line doesn't have indentation
        for (i = 1, len = array.length; i < len; ++i) {
            line = array[i];
            j = 0;
            while (j < line.length && esutils.code.isWhiteSpace(line.charCodeAt(j))) {
                ++j;
            }
            if (spaces > j) {
                spaces = j;
            }
        }

        if (typeof specialBase !== 'undefined') {
            // pattern like
            // {
            //   var t = 20;  /*
            //                 * this is comment
            //                 */
            // }
            previousBase = base;
            if (array[1][spaces] === '*') {
                specialBase += ' ';
            }
            base = specialBase;
        } else {
            if (spaces & 1) {
                // /*
                //  *
                //  */
                // If spaces are odd number, above pattern is considered.
                // We waste 1 space.
                --spaces;
            }
            previousBase = base;
        }

        for (i = 1, len = array.length; i < len; ++i) {
            sn = toSourceNodeWhenNeeded(addIndent(array[i].slice(spaces)));
            array[i] = sourceMap ? sn.join('') : sn;
        }

        base = previousBase;

        return array.join('\n');
    }

    function generateComment(comment, specialBase) {
        if (comment.type === 'Line') {
            if (endsWithLineTerminator(comment.value)) {
                return '//' + comment.value;
            } else {
                // Always use LineTerminator
                return '//' + comment.value + '\n';
            }
        }
        if (extra.format.indent.adjustMultilineComment && /[\n\r]/.test(comment.value)) {
            return adjustMultilineComment('/*' + comment.value + '*/', specialBase);
        }
        return '/*' + comment.value + '*/';
    }

    function addComments(stmt, result) {
        var i, len, comment, save, tailingToStatement, specialBase, fragment;

        if (stmt.leadingComments && stmt.leadingComments.length > 0) {
            save = result;

            comment = stmt.leadingComments[0];
            result = [];
            if (safeConcatenation && stmt.type === Syntax.Program && stmt.body.length === 0) {
                result.push('\n');
            }
            result.push(generateComment(comment));
            if (!endsWithLineTerminator(toSourceNodeWhenNeeded(result).toString())) {
                result.push('\n');
            }

            for (i = 1, len = stmt.leadingComments.length; i < len; ++i) {
                comment = stmt.leadingComments[i];
                fragment = [generateComment(comment)];
                if (!endsWithLineTerminator(toSourceNodeWhenNeeded(fragment).toString())) {
                    fragment.push('\n');
                }
                result.push(addIndent(fragment));
            }

            result.push(addIndent(save));
        }

        if (stmt.trailingComments) {
            tailingToStatement = !endsWithLineTerminator(toSourceNodeWhenNeeded(result).toString());
            specialBase = stringRepeat(' ', calculateSpaces(toSourceNodeWhenNeeded([base, result, indent]).toString()));
            for (i = 0, len = stmt.trailingComments.length; i < len; ++i) {
                comment = stmt.trailingComments[i];
                if (tailingToStatement) {
                    // We assume target like following script
                    //
                    // var t = 20;  /**
                    //               * This is comment of t
                    //               */
                    if (i === 0) {
                        // first case
                        result = [result, indent];
                    } else {
                        result = [result, specialBase];
                    }
                    result.push(generateComment(comment, specialBase));
                } else {
                    result = [result, addIndent(generateComment(comment))];
                }
                if (i !== len - 1 && !endsWithLineTerminator(toSourceNodeWhenNeeded(result).toString())) {
                    result = [result, '\n'];
                }
            }
        }

        return result;
    }

    function parenthesize(text, current, should) {
        if (current < should) {
            return ['(', text, ')'];
        }
        return text;
    }

    function maybeBlock(stmt, semicolonOptional, functionBody) {
        var result, noLeadingComment;

        noLeadingComment = !extra.comment || !stmt.leadingComments;

        if (stmt.type === Syntax.BlockStatement && noLeadingComment) {
            return [space, generateStatement(stmt, { functionBody: functionBody })];
        }

        if (stmt.type === Syntax.EmptyStatement && noLeadingComment) {
            return ';';
        }

        withIndent(function () {
            result = [newline, addIndent(generateStatement(stmt, { semicolonOptional: semicolonOptional, functionBody: functionBody }))];
        });

        return result;
    }

    function maybeBlockSuffix(stmt, result) {
        var ends = endsWithLineTerminator(toSourceNodeWhenNeeded(result).toString());
        if (stmt.type === Syntax.BlockStatement && (!extra.comment || !stmt.leadingComments) && !ends) {
            return [result, space];
        }
        if (ends) {
            return [result, base];
        }
        return [result, newline, base];
    }

    function generateVerbatimString(string) {
        var i, iz, result;
        result = string.split(/\r\n|\n/);
        for (i = 1, iz = result.length; i < iz; i++) {
            result[i] = newline + base + result[i];
        }
        return result;
    }

    function generateVerbatim(expr, option) {
        var verbatim, result, prec;
        verbatim = expr[extra.verbatim];

        if (typeof verbatim === 'string') {
            result = parenthesize(generateVerbatimString(verbatim), Precedence.Sequence, option.precedence);
        } else {
            // verbatim is object
            result = generateVerbatimString(verbatim.content);
            prec = (verbatim.precedence != null) ? verbatim.precedence : Precedence.Sequence;
            result = parenthesize(result, prec, option.precedence);
        }

        return toSourceNodeWhenNeeded(result, expr);
    }

    function generateIdentifier(node) {
        return toSourceNodeWhenNeeded(node.name, node);
    }

    function generatePattern(node, options) {
        var result;

        if (node.type === Syntax.Identifier) {
            result = generateIdentifier(node);
        } else {
            result = generateExpression(node, {
                precedence: options.precedence,
                allowIn: options.allowIn,
                allowCall: true
            });
        }

        return result;
    }

    function generateFunctionBody(node) {
        var result, i, len, expr, arrow;

        arrow = node.type === Syntax.ArrowFunctionExpression;

        if (arrow && node.params.length === 1 && node.params[0].type === Syntax.Identifier) {
            // arg => { } case
            result = [generateIdentifier(node.params[0])];
        } else {
            result = ['('];
            for (i = 0, len = node.params.length; i < len; ++i) {
                result.push(generatePattern(node.params[i], {
                    precedence: Precedence.Assignment,
                    allowIn: true
                }));
                if (i + 1 < len) {
                    result.push(',' + space);
                }
            }
            result.push(')');
        }

        if (arrow) {
            result.push(space);
            result.push('=>');
        }

        if (node.expression) {
            result.push(space);
            expr = generateExpression(node.body, {
                precedence: Precedence.Assignment,
                allowIn: true,
                allowCall: true
            });
            if (expr.toString().charAt(0) === '{') {
                expr = ['(', expr, ')'];
            }
            result.push(expr);
        } else {
            result.push(maybeBlock(node.body, false, true));
        }
        return result;
    }

    function generateIterationForStatement(operator, stmt, semicolonIsNotNeeded) {
        var result = ['for' + space + '('];
        withIndent(function () {
            if (stmt.left.type === Syntax.VariableDeclaration) {
                withIndent(function () {
                    result.push(stmt.left.kind + noEmptySpace());
                    result.push(generateStatement(stmt.left.declarations[0], {
                        allowIn: false
                    }));
                });
            } else {
                result.push(generateExpression(stmt.left, {
                    precedence: Precedence.Call,
                    allowIn: true,
                    allowCall: true
                }));
            }

            result = join(result, operator);
            result = [join(
                result,
                generateExpression(stmt.right, {
                    precedence: Precedence.Sequence,
                    allowIn: true,
                    allowCall: true
                })
            ), ')'];
        });
        result.push(maybeBlock(stmt.body, semicolonIsNotNeeded));
        return result;
    }

    function generateLiteral(expr) {
        var raw;
        if (expr.hasOwnProperty('raw') && parse && extra.raw) {
            try {
                raw = parse(expr.raw).body[0].expression;
                if (raw.type === Syntax.Literal) {
                    if (raw.value === expr.value) {
                        return expr.raw;
                    }
                }
            } catch (e) {
                // not use raw property
            }
        }

        if (expr.value === null) {
            return 'null';
        }

        if (typeof expr.value === 'string') {
            return escapeString(expr.value);
        }

        if (typeof expr.value === 'number') {
            return generateNumber(expr.value);
        }

        if (typeof expr.value === 'boolean') {
            return expr.value ? 'true' : 'false';
        }

        return generateRegExp(expr.value);
    }

    function generateExpression(expr, option) {
        var result,
            precedence,
            type,
            currentPrecedence,
            i,
            len,
            fragment,
            multiline,
            leftCharCode,
            leftSource,
            rightCharCode,
            allowIn,
            allowCall,
            allowUnparenthesizedNew,
            property,
            isGenerator;

        precedence = option.precedence;
        allowIn = option.allowIn;
        allowCall = option.allowCall;
        type = expr.type || option.type;

        if (extra.verbatim && expr.hasOwnProperty(extra.verbatim)) {
            return generateVerbatim(expr, option);
        }

        switch (type) {
        case Syntax.SequenceExpression:
            result = [];
            allowIn |= (Precedence.Sequence < precedence);
            for (i = 0, len = expr.expressions.length; i < len; ++i) {
                result.push(generateExpression(expr.expressions[i], {
                    precedence: Precedence.Assignment,
                    allowIn: allowIn,
                    allowCall: true
                }));
                if (i + 1 < len) {
                    result.push(',' + space);
                }
            }
            result = parenthesize(result, Precedence.Sequence, precedence);
            break;

        case Syntax.AssignmentExpression:
            allowIn |= (Precedence.Assignment < precedence);
            result = parenthesize(
                [
                    generateExpression(expr.left, {
                        precedence: Precedence.Call,
                        allowIn: allowIn,
                        allowCall: true
                    }),
                    space + expr.operator + space,
                    generateExpression(expr.right, {
                        precedence: Precedence.Assignment,
                        allowIn: allowIn,
                        allowCall: true
                    })
                ],
                Precedence.Assignment,
                precedence
            );
            break;

        case Syntax.ArrowFunctionExpression:
            allowIn |= (Precedence.ArrowFunction < precedence);
            result = parenthesize(generateFunctionBody(expr), Precedence.ArrowFunction, precedence);
            break;

        case Syntax.ConditionalExpression:
            allowIn |= (Precedence.Conditional < precedence);
            result = parenthesize(
                [
                    generateExpression(expr.test, {
                        precedence: Precedence.LogicalOR,
                        allowIn: allowIn,
                        allowCall: true
                    }),
                    space + '?' + space,
                    generateExpression(expr.consequent, {
                        precedence: Precedence.Assignment,
                        allowIn: allowIn,
                        allowCall: true
                    }),
                    space + ':' + space,
                    generateExpression(expr.alternate, {
                        precedence: Precedence.Assignment,
                        allowIn: allowIn,
                        allowCall: true
                    })
                ],
                Precedence.Conditional,
                precedence
            );
            break;

        case Syntax.LogicalExpression:
        case Syntax.BinaryExpression:
            currentPrecedence = BinaryPrecedence[expr.operator];

            allowIn |= (currentPrecedence < precedence);

            fragment = generateExpression(expr.left, {
                precedence: currentPrecedence,
                allowIn: allowIn,
                allowCall: true
            });

            leftSource = fragment.toString();

            if (leftSource.charCodeAt(leftSource.length - 1) === 0x2F /* / */ && esutils.code.isIdentifierPart(expr.operator.charCodeAt(0))) {
                result = [fragment, noEmptySpace(), expr.operator];
            } else {
                result = join(fragment, expr.operator);
            }

            fragment = generateExpression(expr.right, {
                precedence: currentPrecedence + 1,
                allowIn: allowIn,
                allowCall: true
            });

            if (expr.operator === '/' && fragment.toString().charAt(0) === '/' ||
            expr.operator.slice(-1) === '<' && fragment.toString().slice(0, 3) === '!--') {
                // If '/' concats with '/' or `<` concats with `!--`, it is interpreted as comment start
                result.push(noEmptySpace());
                result.push(fragment);
            } else {
                result = join(result, fragment);
            }

            if (expr.operator === 'in' && !allowIn) {
                result = ['(', result, ')'];
            } else {
                result = parenthesize(result, currentPrecedence, precedence);
            }

            break;

        case Syntax.CallExpression:
            result = [generateExpression(expr.callee, {
                precedence: Precedence.Call,
                allowIn: true,
                allowCall: true,
                allowUnparenthesizedNew: false
            })];

            result.push('(');
            for (i = 0, len = expr['arguments'].length; i < len; ++i) {
                result.push(generateExpression(expr['arguments'][i], {
                    precedence: Precedence.Assignment,
                    allowIn: true,
                    allowCall: true
                }));
                if (i + 1 < len) {
                    result.push(',' + space);
                }
            }
            result.push(')');

            if (!allowCall) {
                result = ['(', result, ')'];
            } else {
                result = parenthesize(result, Precedence.Call, precedence);
            }
            break;

        case Syntax.NewExpression:
            len = expr['arguments'].length;
            allowUnparenthesizedNew = option.allowUnparenthesizedNew === undefined || option.allowUnparenthesizedNew;

            result = join(
                'new',
                generateExpression(expr.callee, {
                    precedence: Precedence.New,
                    allowIn: true,
                    allowCall: false,
                    allowUnparenthesizedNew: allowUnparenthesizedNew && !parentheses && len === 0
                })
            );

            if (!allowUnparenthesizedNew || parentheses || len > 0) {
                result.push('(');
                for (i = 0; i < len; ++i) {
                    result.push(generateExpression(expr['arguments'][i], {
                        precedence: Precedence.Assignment,
                        allowIn: true,
                        allowCall: true
                    }));
                    if (i + 1 < len) {
                        result.push(',' + space);
                    }
                }
                result.push(')');
            }

            result = parenthesize(result, Precedence.New, precedence);
            break;

        case Syntax.MemberExpression:
            result = [generateExpression(expr.object, {
                precedence: Precedence.Call,
                allowIn: true,
                allowCall: allowCall,
                allowUnparenthesizedNew: false
            })];

            if (expr.computed) {
                result.push('[');
                result.push(generateExpression(expr.property, {
                    precedence: Precedence.Sequence,
                    allowIn: true,
                    allowCall: allowCall
                }));
                result.push(']');
            } else {
                if (expr.object.type === Syntax.Literal && typeof expr.object.value === 'number') {
                    fragment = toSourceNodeWhenNeeded(result).toString();
                    // When the following conditions are all true,
                    //   1. No floating point
                    //   2. Don't have exponents
                    //   3. The last character is a decimal digit
                    //   4. Not hexadecimal OR octal number literal
                    // we should add a floating point.
                    if (
                            fragment.indexOf('.') < 0 &&
                            !/[eExX]/.test(fragment) &&
                            esutils.code.isDecimalDigit(fragment.charCodeAt(fragment.length - 1)) &&
                            !(fragment.length >= 2 && fragment.charCodeAt(0) === 48)  // '0'
                            ) {
                        result.push('.');
                    }
                }
                result.push('.');
                result.push(generateIdentifier(expr.property));
            }

            result = parenthesize(result, Precedence.Member, precedence);
            break;

        case Syntax.UnaryExpression:
            fragment = generateExpression(expr.argument, {
                precedence: Precedence.Unary,
                allowIn: true,
                allowCall: true
            });

            if (space === '') {
                result = join(expr.operator, fragment);
            } else {
                result = [expr.operator];
                if (expr.operator.length > 2) {
                    // delete, void, typeof
                    // get `typeof []`, not `typeof[]`
                    result = join(result, fragment);
                } else {
                    // Prevent inserting spaces between operator and argument if it is unnecessary
                    // like, `!cond`
                    leftSource = toSourceNodeWhenNeeded(result).toString();
                    leftCharCode = leftSource.charCodeAt(leftSource.length - 1);
                    rightCharCode = fragment.toString().charCodeAt(0);

                    if (((leftCharCode === 0x2B  /* + */ || leftCharCode === 0x2D  /* - */) && leftCharCode === rightCharCode) ||
                            (esutils.code.isIdentifierPart(leftCharCode) && esutils.code.isIdentifierPart(rightCharCode))) {
                        result.push(noEmptySpace());
                        result.push(fragment);
                    } else {
                        result.push(fragment);
                    }
                }
            }
            result = parenthesize(result, Precedence.Unary, precedence);
            break;

        case Syntax.YieldExpression:
            if (expr.delegate) {
                result = 'yield*';
            } else {
                result = 'yield';
            }
            if (expr.argument) {
                result = join(
                    result,
                    generateExpression(expr.argument, {
                        precedence: Precedence.Yield,
                        allowIn: true,
                        allowCall: true
                    })
                );
            }
            result = parenthesize(result, Precedence.Yield, precedence);
            break;

        case Syntax.UpdateExpression:
            if (expr.prefix) {
                result = parenthesize(
                    [
                        expr.operator,
                        generateExpression(expr.argument, {
                            precedence: Precedence.Unary,
                            allowIn: true,
                            allowCall: true
                        })
                    ],
                    Precedence.Unary,
                    precedence
                );
            } else {
                result = parenthesize(
                    [
                        generateExpression(expr.argument, {
                            precedence: Precedence.Postfix,
                            allowIn: true,
                            allowCall: true
                        }),
                        expr.operator
                    ],
                    Precedence.Postfix,
                    precedence
                );
            }
            break;

        case Syntax.FunctionExpression:
            isGenerator = expr.generator && !extra.moz.starlessGenerator;
            result = isGenerator ? 'function*' : 'function';

            if (expr.id) {
                result = [result, (isGenerator) ? space : noEmptySpace(),
                          generateIdentifier(expr.id),
                          generateFunctionBody(expr)];
            } else {
                result = [result + space, generateFunctionBody(expr)];
            }

            break;

        case Syntax.ArrayPattern:
        case Syntax.ArrayExpression:
            if (!expr.elements.length) {
                result = '[]';
                break;
            }
            multiline = expr.elements.length > 1;
            result = ['[', multiline ? newline : ''];
            withIndent(function (indent) {
                for (i = 0, len = expr.elements.length; i < len; ++i) {
                    if (!expr.elements[i]) {
                        if (multiline) {
                            result.push(indent);
                        }
                        if (i + 1 === len) {
                            result.push(',');
                        }
                    } else {
                        result.push(multiline ? indent : '');
                        result.push(generateExpression(expr.elements[i], {
                            precedence: Precedence.Assignment,
                            allowIn: true,
                            allowCall: true
                        }));
                    }
                    if (i + 1 < len) {
                        result.push(',' + (multiline ? newline : space));
                    }
                }
            });
            if (multiline && !endsWithLineTerminator(toSourceNodeWhenNeeded(result).toString())) {
                result.push(newline);
            }
            result.push(multiline ? base : '');
            result.push(']');
            break;

        case Syntax.Property:
            if (expr.kind === 'get' || expr.kind === 'set') {
                result = [
                    expr.kind, noEmptySpace(),
                    generateExpression(expr.key, {
                        precedence: Precedence.Sequence,
                        allowIn: true,
                        allowCall: true
                    }),
                    generateFunctionBody(expr.value)
                ];
            } else {
                if (expr.shorthand) {
                    result = generateExpression(expr.key, {
                        precedence: Precedence.Sequence,
                        allowIn: true,
                        allowCall: true
                    });
                } else if (expr.method) {
                    result = [];
                    if (expr.value.generator) {
                        result.push('*');
                    }
                    result.push(generateExpression(expr.key, {
                        precedence: Precedence.Sequence,
                        allowIn: true,
                        allowCall: true
                    }));
                    result.push(generateFunctionBody(expr.value));
                } else {
                    result = [
                        generateExpression(expr.key, {
                            precedence: Precedence.Sequence,
                            allowIn: true,
                            allowCall: true
                        }),
                        ':' + space,
                        generateExpression(expr.value, {
                            precedence: Precedence.Assignment,
                            allowIn: true,
                            allowCall: true
                        })
                    ];
                }
            }
            break;

        case Syntax.ObjectExpression:
            if (!expr.properties.length) {
                result = '{}';
                break;
            }
            multiline = expr.properties.length > 1;

            withIndent(function () {
                fragment = generateExpression(expr.properties[0], {
                    precedence: Precedence.Sequence,
                    allowIn: true,
                    allowCall: true,
                    type: Syntax.Property
                });
            });

            if (!multiline) {
                // issues 4
                // Do not transform from
                //   dejavu.Class.declare({
                //       method2: function () {}
                //   });
                // to
                //   dejavu.Class.declare({method2: function () {
                //       }});
                if (!hasLineTerminator(toSourceNodeWhenNeeded(fragment).toString())) {
                    result = [ '{', space, fragment, space, '}' ];
                    break;
                }
            }

            withIndent(function (indent) {
                result = [ '{', newline, indent, fragment ];

                if (multiline) {
                    result.push(',' + newline);
                    for (i = 1, len = expr.properties.length; i < len; ++i) {
                        result.push(indent);
                        result.push(generateExpression(expr.properties[i], {
                            precedence: Precedence.Sequence,
                            allowIn: true,
                            allowCall: true,
                            type: Syntax.Property
                        }));
                        if (i + 1 < len) {
                            result.push(',' + newline);
                        }
                    }
                }
            });

            if (!endsWithLineTerminator(toSourceNodeWhenNeeded(result).toString())) {
                result.push(newline);
            }
            result.push(base);
            result.push('}');
            break;

        case Syntax.ObjectPattern:
            if (!expr.properties.length) {
                result = '{}';
                break;
            }

            multiline = false;
            if (expr.properties.length === 1) {
                property = expr.properties[0];
                if (property.value.type !== Syntax.Identifier) {
                    multiline = true;
                }
            } else {
                for (i = 0, len = expr.properties.length; i < len; ++i) {
                    property = expr.properties[i];
                    if (!property.shorthand) {
                        multiline = true;
                        break;
                    }
                }
            }
            result = ['{', multiline ? newline : '' ];

            withIndent(function (indent) {
                for (i = 0, len = expr.properties.length; i < len; ++i) {
                    result.push(multiline ? indent : '');
                    result.push(generateExpression(expr.properties[i], {
                        precedence: Precedence.Sequence,
                        allowIn: true,
                        allowCall: true
                    }));
                    if (i + 1 < len) {
                        result.push(',' + (multiline ? newline : space));
                    }
                }
            });

            if (multiline && !endsWithLineTerminator(toSourceNodeWhenNeeded(result).toString())) {
                result.push(newline);
            }
            result.push(multiline ? base : '');
            result.push('}');
            break;

        case Syntax.ThisExpression:
            result = 'this';
            break;

        case Syntax.Identifier:
            result = generateIdentifier(expr);
            break;

        case Syntax.Literal:
            result = generateLiteral(expr);
            break;

        case Syntax.GeneratorExpression:
        case Syntax.ComprehensionExpression:
            // GeneratorExpression should be parenthesized with (...), ComprehensionExpression with [...]
            // Due to https://bugzilla.mozilla.org/show_bug.cgi?id=883468 position of expr.body can differ in Spidermonkey and ES6
            result = (type === Syntax.GeneratorExpression) ? ['('] : ['['];

            if (extra.moz.comprehensionExpressionStartsWithAssignment) {
                fragment = generateExpression(expr.body, {
                    precedence: Precedence.Assignment,
                    allowIn: true,
                    allowCall: true
                });

                result.push(fragment);
            }

            if (expr.blocks) {
                withIndent(function () {
                    for (i = 0, len = expr.blocks.length; i < len; ++i) {
                        fragment = generateExpression(expr.blocks[i], {
                            precedence: Precedence.Sequence,
                            allowIn: true,
                            allowCall: true
                        });

                        if (i > 0 || extra.moz.comprehensionExpressionStartsWithAssignment) {
                            result = join(result, fragment);
                        } else {
                            result.push(fragment);
                        }
                    }
                });
            }

            if (expr.filter) {
                result = join(result, 'if' + space);
                fragment = generateExpression(expr.filter, {
                    precedence: Precedence.Sequence,
                    allowIn: true,
                    allowCall: true
                });
                if (extra.moz.parenthesizedComprehensionBlock) {
                    result = join(result, [ '(', fragment, ')' ]);
                } else {
                    result = join(result, fragment);
                }
            }

            if (!extra.moz.comprehensionExpressionStartsWithAssignment) {
                fragment = generateExpression(expr.body, {
                    precedence: Precedence.Assignment,
                    allowIn: true,
                    allowCall: true
                });

                result = join(result, fragment);
            }

            result.push((type === Syntax.GeneratorExpression) ? ')' : ']');
            break;

        case Syntax.ComprehensionBlock:
            if (expr.left.type === Syntax.VariableDeclaration) {
                fragment = [
                    expr.left.kind, noEmptySpace(),
                    generateStatement(expr.left.declarations[0], {
                        allowIn: false
                    })
                ];
            } else {
                fragment = generateExpression(expr.left, {
                    precedence: Precedence.Call,
                    allowIn: true,
                    allowCall: true
                });
            }

            fragment = join(fragment, expr.of ? 'of' : 'in');
            fragment = join(fragment, generateExpression(expr.right, {
                precedence: Precedence.Sequence,
                allowIn: true,
                allowCall: true
            }));

            if (extra.moz.parenthesizedComprehensionBlock) {
                result = [ 'for' + space + '(', fragment, ')' ];
            } else {
                result = join('for' + space, fragment);
            }
            break;

        default:
            throw new Error('Unknown expression type: ' + expr.type);
        }

        if (extra.comment) {
            result = addComments(expr,result);
        }
        return toSourceNodeWhenNeeded(result, expr);
    }

    function generateStatement(stmt, option) {
        var i,
            len,
            result,
            node,
            specifier,
            allowIn,
            functionBody,
            directiveContext,
            fragment,
            semicolon,
            isGenerator;

        allowIn = true;
        semicolon = ';';
        functionBody = false;
        directiveContext = false;
        if (option) {
            allowIn = option.allowIn === undefined || option.allowIn;
            if (!semicolons && option.semicolonOptional === true) {
                semicolon = '';
            }
            functionBody = option.functionBody;
            directiveContext = option.directiveContext;
        }

        switch (stmt.type) {
        case Syntax.BlockStatement:
            result = ['{', newline];

            withIndent(function () {
                for (i = 0, len = stmt.body.length; i < len; ++i) {
                    fragment = addIndent(generateStatement(stmt.body[i], {
                        semicolonOptional: i === len - 1,
                        directiveContext: functionBody
                    }));
                    result.push(fragment);
                    if (!endsWithLineTerminator(toSourceNodeWhenNeeded(fragment).toString())) {
                        result.push(newline);
                    }
                }
            });

            result.push(addIndent('}'));
            break;

        case Syntax.BreakStatement:
            if (stmt.label) {
                result = 'break ' + stmt.label.name + semicolon;
            } else {
                result = 'break' + semicolon;
            }
            break;

        case Syntax.ContinueStatement:
            if (stmt.label) {
                result = 'continue ' + stmt.label.name + semicolon;
            } else {
                result = 'continue' + semicolon;
            }
            break;

        case Syntax.DirectiveStatement:
            if (extra.raw && stmt.raw) {
                result = stmt.raw + semicolon;
            } else {
                result = escapeDirective(stmt.directive) + semicolon;
            }
            break;

        case Syntax.DoWhileStatement:
            // Because `do 42 while (cond)` is Syntax Error. We need semicolon.
            result = join('do', maybeBlock(stmt.body));
            result = maybeBlockSuffix(stmt.body, result);
            result = join(result, [
                'while' + space + '(',
                generateExpression(stmt.test, {
                    precedence: Precedence.Sequence,
                    allowIn: true,
                    allowCall: true
                }),
                ')' + semicolon
            ]);
            break;

        case Syntax.CatchClause:
            withIndent(function () {
                var guard;

                result = [
                    'catch' + space + '(',
                    generateExpression(stmt.param, {
                        precedence: Precedence.Sequence,
                        allowIn: true,
                        allowCall: true
                    }),
                    ')'
                ];

                if (stmt.guard) {
                    guard = generateExpression(stmt.guard, {
                        precedence: Precedence.Sequence,
                        allowIn: true,
                        allowCall: true
                    });

                    result.splice(2, 0, ' if ', guard);
                }
            });
            result.push(maybeBlock(stmt.body));
            break;

        case Syntax.DebuggerStatement:
            result = 'debugger' + semicolon;
            break;

        case Syntax.EmptyStatement:
            result = ';';
            break;

        case Syntax.ExportDeclaration:
            result = 'export ';
            if (stmt.declaration) {
                // FunctionDeclaration or VariableDeclaration
                result = [result, generateStatement(stmt.declaration, { semicolonOptional: semicolon === '' })];
                break;
            }
            break;

        case Syntax.ExpressionStatement:
            result = [generateExpression(stmt.expression, {
                precedence: Precedence.Sequence,
                allowIn: true,
                allowCall: true
            })];
            // 12.4 '{', 'function' is not allowed in this position.
            // wrap expression with parentheses
            fragment = toSourceNodeWhenNeeded(result).toString();
            if (fragment.charAt(0) === '{' ||  // ObjectExpression
                    (fragment.slice(0, 8) === 'function' && '* ('.indexOf(fragment.charAt(8)) >= 0) ||  // function or generator
                    (directive && directiveContext && stmt.expression.type === Syntax.Literal && typeof stmt.expression.value === 'string')) {
                result = ['(', result, ')' + semicolon];
            } else {
                result.push(semicolon);
            }
            break;

        case Syntax.ImportDeclaration:
            // ES6: 15.2.1 valid import declarations:
            //     - import ImportClause FromClause ;
            //     - import ModuleSpecifier ;
            // If no ImportClause is present,
            // this should be `import ModuleSpecifier` so skip `from`
            //
            // ModuleSpecifier is StringLiteral.
            if (stmt.specifiers.length === 0) {
                // import ModuleSpecifier ;
                result = [
                    'import',
                    space,
                    generateLiteral(stmt.source)
                ];
            } else {
                // import ImportClause FromClause ;
                if (stmt.kind === 'default') {
                    // import ... from "...";
                    result = [
                        'import',
                        noEmptySpace(),
                        stmt.specifiers[0].id.name,
                        noEmptySpace()
                    ];
                } else {
                    // stmt.kind === 'named'
                    result = [
                        'import',
                        space,
                        '{',
                    ];

                    if (stmt.specifiers.length === 1) {
                        // import { ... } from "...";
                        specifier = stmt.specifiers[0];
                        result.push(space + specifier.id.name);
                        if (specifier.name) {
                            result.push(noEmptySpace() + 'as' + noEmptySpace() + specifier.name.name);
                        }
                        result.push(space + '}' + space);
                    } else {
                        // import {
                        //    ...,
                        //    ...,
                        // } from "...";
                        withIndent(function (indent) {
                            var i, iz;
                            result.push(newline);
                            for (i = 0, iz = stmt.specifiers.length; i < iz; ++i) {
                                specifier = stmt.specifiers[i];
                                result.push(indent + specifier.id.name);
                                if (specifier.name) {
                                    result.push(noEmptySpace() + 'as' + noEmptySpace() + specifier.name.name);
                                }

                                if (i + 1 < iz) {
                                    result.push(',' + newline);
                                }
                            }
                        });
                        if (!endsWithLineTerminator(toSourceNodeWhenNeeded(result).toString())) {
                            result.push(newline);
                        }
                        result.push(base + '}' + space);
                    }
                }

                result.push('from' + space);
                result.push(generateLiteral(stmt.source));
            }
            result.push(semicolon);
            break;

        case Syntax.VariableDeclarator:
            if (stmt.init) {
                result = [
                    generateExpression(stmt.id, {
                        precedence: Precedence.Assignment,
                        allowIn: allowIn,
                        allowCall: true
                    }),
                    space,
                    '=',
                    space,
                    generateExpression(stmt.init, {
                        precedence: Precedence.Assignment,
                        allowIn: allowIn,
                        allowCall: true
                    })
                ];
            } else {
                result = generatePattern(stmt.id, {
                    precedence: Precedence.Assignment,
                    allowIn: allowIn
                });
            }
            break;

        case Syntax.VariableDeclaration:
            result = [stmt.kind];
            // special path for
            // var x = function () {
            // };
            if (stmt.declarations.length === 1 && stmt.declarations[0].init &&
                    stmt.declarations[0].init.type === Syntax.FunctionExpression) {
                result.push(noEmptySpace());
                result.push(generateStatement(stmt.declarations[0], {
                    allowIn: allowIn
                }));
            } else {
                // VariableDeclarator is typed as Statement,
                // but joined with comma (not LineTerminator).
                // So if comment is attached to target node, we should specialize.
                withIndent(function () {
                    node = stmt.declarations[0];
                    if (extra.comment && node.leadingComments) {
                        result.push('\n');
                        result.push(addIndent(generateStatement(node, {
                            allowIn: allowIn
                        })));
                    } else {
                        result.push(noEmptySpace());
                        result.push(generateStatement(node, {
                            allowIn: allowIn
                        }));
                    }

                    for (i = 1, len = stmt.declarations.length; i < len; ++i) {
                        node = stmt.declarations[i];
                        if (extra.comment && node.leadingComments) {
                            result.push(',' + newline);
                            result.push(addIndent(generateStatement(node, {
                                allowIn: allowIn
                            })));
                        } else {
                            result.push(',' + space);
                            result.push(generateStatement(node, {
                                allowIn: allowIn
                            }));
                        }
                    }
                });
            }
            result.push(semicolon);
            break;

        case Syntax.ThrowStatement:
            result = [join(
                'throw',
                generateExpression(stmt.argument, {
                    precedence: Precedence.Sequence,
                    allowIn: true,
                    allowCall: true
                })
            ), semicolon];
            break;

        case Syntax.TryStatement:
            result = ['try', maybeBlock(stmt.block)];
            result = maybeBlockSuffix(stmt.block, result);

            if (stmt.handlers) {
                // old interface
                for (i = 0, len = stmt.handlers.length; i < len; ++i) {
                    result = join(result, generateStatement(stmt.handlers[i]));
                    if (stmt.finalizer || i + 1 !== len) {
                        result = maybeBlockSuffix(stmt.handlers[i].body, result);
                    }
                }
            } else {
                stmt.guardedHandlers = stmt.guardedHandlers || [];

                for (i = 0, len = stmt.guardedHandlers.length; i < len; ++i) {
                    result = join(result, generateStatement(stmt.guardedHandlers[i]));
                    if (stmt.finalizer || i + 1 !== len) {
                        result = maybeBlockSuffix(stmt.guardedHandlers[i].body, result);
                    }
                }

                // new interface
                if (stmt.handler) {
                    if (isArray(stmt.handler)) {
                        for (i = 0, len = stmt.handler.length; i < len; ++i) {
                            result = join(result, generateStatement(stmt.handler[i]));
                            if (stmt.finalizer || i + 1 !== len) {
                                result = maybeBlockSuffix(stmt.handler[i].body, result);
                            }
                        }
                    } else {
                        result = join(result, generateStatement(stmt.handler));
                        if (stmt.finalizer) {
                            result = maybeBlockSuffix(stmt.handler.body, result);
                        }
                    }
                }
            }
            if (stmt.finalizer) {
                result = join(result, ['finally', maybeBlock(stmt.finalizer)]);
            }
            break;

        case Syntax.SwitchStatement:
            withIndent(function () {
                result = [
                    'switch' + space + '(',
                    generateExpression(stmt.discriminant, {
                        precedence: Precedence.Sequence,
                        allowIn: true,
                        allowCall: true
                    }),
                    ')' + space + '{' + newline
                ];
            });
            if (stmt.cases) {
                for (i = 0, len = stmt.cases.length; i < len; ++i) {
                    fragment = addIndent(generateStatement(stmt.cases[i], {semicolonOptional: i === len - 1}));
                    result.push(fragment);
                    if (!endsWithLineTerminator(toSourceNodeWhenNeeded(fragment).toString())) {
                        result.push(newline);
                    }
                }
            }
            result.push(addIndent('}'));
            break;

        case Syntax.SwitchCase:
            withIndent(function () {
                if (stmt.test) {
                    result = [
                        join('case', generateExpression(stmt.test, {
                            precedence: Precedence.Sequence,
                            allowIn: true,
                            allowCall: true
                        })),
                        ':'
                    ];
                } else {
                    result = ['default:'];
                }

                i = 0;
                len = stmt.consequent.length;
                if (len && stmt.consequent[0].type === Syntax.BlockStatement) {
                    fragment = maybeBlock(stmt.consequent[0]);
                    result.push(fragment);
                    i = 1;
                }

                if (i !== len && !endsWithLineTerminator(toSourceNodeWhenNeeded(result).toString())) {
                    result.push(newline);
                }

                for (; i < len; ++i) {
                    fragment = addIndent(generateStatement(stmt.consequent[i], {semicolonOptional: i === len - 1 && semicolon === ''}));
                    result.push(fragment);
                    if (i + 1 !== len && !endsWithLineTerminator(toSourceNodeWhenNeeded(fragment).toString())) {
                        result.push(newline);
                    }
                }
            });
            break;

        case Syntax.IfStatement:
            withIndent(function () {
                result = [
                    'if' + space + '(',
                    generateExpression(stmt.test, {
                        precedence: Precedence.Sequence,
                        allowIn: true,
                        allowCall: true
                    }),
                    ')'
                ];
            });
            if (stmt.alternate) {
                result.push(maybeBlock(stmt.consequent));
                result = maybeBlockSuffix(stmt.consequent, result);
                if (stmt.alternate.type === Syntax.IfStatement) {
                    result = join(result, ['else ', generateStatement(stmt.alternate, {semicolonOptional: semicolon === ''})]);
                } else {
                    result = join(result, join('else', maybeBlock(stmt.alternate, semicolon === '')));
                }
            } else {
                result.push(maybeBlock(stmt.consequent, semicolon === ''));
            }
            break;

        case Syntax.ForStatement:
            withIndent(function () {
                result = ['for' + space + '('];
                if (stmt.init) {
                    if (stmt.init.type === Syntax.VariableDeclaration) {
                        result.push(generateStatement(stmt.init, {allowIn: false}));
                    } else {
                        result.push(generateExpression(stmt.init, {
                            precedence: Precedence.Sequence,
                            allowIn: false,
                            allowCall: true
                        }));
                        result.push(';');
                    }
                } else {
                    result.push(';');
                }

                if (stmt.test) {
                    result.push(space);
                    result.push(generateExpression(stmt.test, {
                        precedence: Precedence.Sequence,
                        allowIn: true,
                        allowCall: true
                    }));
                    result.push(';');
                } else {
                    result.push(';');
                }

                if (stmt.update) {
                    result.push(space);
                    result.push(generateExpression(stmt.update, {
                        precedence: Precedence.Sequence,
                        allowIn: true,
                        allowCall: true
                    }));
                    result.push(')');
                } else {
                    result.push(')');
                }
            });

            result.push(maybeBlock(stmt.body, semicolon === ''));
            break;

        case Syntax.ForInStatement:
            result = generateIterationForStatement('in', stmt, semicolon === '');
            break;

        case Syntax.ForOfStatement:
            result = generateIterationForStatement('of', stmt, semicolon === '');
            break;

        case Syntax.LabeledStatement:
            result = [stmt.label.name + ':', maybeBlock(stmt.body, semicolon === '')];
            break;

        case Syntax.Program:
            len = stmt.body.length;
            result = [safeConcatenation && len > 0 ? '\n' : ''];
            for (i = 0; i < len; ++i) {
                fragment = addIndent(
                    generateStatement(stmt.body[i], {
                        semicolonOptional: !safeConcatenation && i === len - 1,
                        directiveContext: true
                    })
                );
                result.push(fragment);
                if (i + 1 < len && !endsWithLineTerminator(toSourceNodeWhenNeeded(fragment).toString())) {
                    result.push(newline);
                }
            }
            break;

        case Syntax.FunctionDeclaration:
            isGenerator = stmt.generator && !extra.moz.starlessGenerator;
            result = [
                (isGenerator ? 'function*' : 'function'),
                (isGenerator ? space : noEmptySpace()),
                generateIdentifier(stmt.id),
                generateFunctionBody(stmt)
            ];
            break;

        case Syntax.ReturnStatement:
            if (stmt.argument) {
                result = [join(
                    'return',
                    generateExpression(stmt.argument, {
                        precedence: Precedence.Sequence,
                        allowIn: true,
                        allowCall: true
                    })
                ), semicolon];
            } else {
                result = ['return' + semicolon];
            }
            break;

        case Syntax.WhileStatement:
            withIndent(function () {
                result = [
                    'while' + space + '(',
                    generateExpression(stmt.test, {
                        precedence: Precedence.Sequence,
                        allowIn: true,
                        allowCall: true
                    }),
                    ')'
                ];
            });
            result.push(maybeBlock(stmt.body, semicolon === ''));
            break;

        case Syntax.WithStatement:
            withIndent(function () {
                result = [
                    'with' + space + '(',
                    generateExpression(stmt.object, {
                        precedence: Precedence.Sequence,
                        allowIn: true,
                        allowCall: true
                    }),
                    ')'
                ];
            });
            result.push(maybeBlock(stmt.body, semicolon === ''));
            break;

        default:
            throw new Error('Unknown statement type: ' + stmt.type);
        }

        // Attach comments

        if (extra.comment) {
            result = addComments(stmt, result);
        }

        fragment = toSourceNodeWhenNeeded(result).toString();
        if (stmt.type === Syntax.Program && !safeConcatenation && newline === '' &&  fragment.charAt(fragment.length - 1) === '\n') {
            result = sourceMap ? toSourceNodeWhenNeeded(result).replaceRight(/\s+$/, '') : fragment.replace(/\s+$/, '');
        }

        return toSourceNodeWhenNeeded(result, stmt);
    }

    function generate(node, options) {
        var defaultOptions = getDefaultOptions(), result, pair;

        if (options != null) {
            // Obsolete options
            //
            //   `options.indent`
            //   `options.base`
            //
            // Instead of them, we can use `option.format.indent`.
            if (typeof options.indent === 'string') {
                defaultOptions.format.indent.style = options.indent;
            }
            if (typeof options.base === 'number') {
                defaultOptions.format.indent.base = options.base;
            }
            options = updateDeeply(defaultOptions, options);
            indent = options.format.indent.style;
            if (typeof options.base === 'string') {
                base = options.base;
            } else {
                base = stringRepeat(indent, options.format.indent.base);
            }
        } else {
            options = defaultOptions;
            indent = options.format.indent.style;
            base = stringRepeat(indent, options.format.indent.base);
        }
        json = options.format.json;
        renumber = options.format.renumber;
        hexadecimal = json ? false : options.format.hexadecimal;
        quotes = json ? 'double' : options.format.quotes;
        escapeless = options.format.escapeless;
        newline = options.format.newline;
        space = options.format.space;
        if (options.format.compact) {
            newline = space = indent = base = '';
        }
        parentheses = options.format.parentheses;
        semicolons = options.format.semicolons;
        safeConcatenation = options.format.safeConcatenation;
        directive = options.directive;
        parse = json ? null : options.parse;
        sourceMap = options.sourceMap;
        extra = options;

        if (sourceMap) {
            if (!global.window) {
                // We assume environment is node.js
                // And prevent from including source-map by browserify
                SourceNode = require('source-map').SourceNode;
            } else {
                SourceNode = global.sourceMap.SourceNode;
            }
        }

        switch (node.type) {
        case Syntax.BlockStatement:
        case Syntax.BreakStatement:
        case Syntax.CatchClause:
        case Syntax.ContinueStatement:
        case Syntax.DirectiveStatement:
        case Syntax.DoWhileStatement:
        case Syntax.DebuggerStatement:
        case Syntax.EmptyStatement:
        case Syntax.ExpressionStatement:
        case Syntax.ForStatement:
        case Syntax.ForInStatement:
        case Syntax.ForOfStatement:
        case Syntax.FunctionDeclaration:
        case Syntax.IfStatement:
        case Syntax.LabeledStatement:
        case Syntax.Program:
        case Syntax.ReturnStatement:
        case Syntax.SwitchStatement:
        case Syntax.SwitchCase:
        case Syntax.ThrowStatement:
        case Syntax.TryStatement:
        case Syntax.VariableDeclaration:
        case Syntax.VariableDeclarator:
        case Syntax.WhileStatement:
        case Syntax.WithStatement:
            result = generateStatement(node);
            break;

        case Syntax.AssignmentExpression:
        case Syntax.ArrayExpression:
        case Syntax.ArrayPattern:
        case Syntax.BinaryExpression:
        case Syntax.CallExpression:
        case Syntax.ConditionalExpression:
        case Syntax.FunctionExpression:
        case Syntax.Identifier:
        case Syntax.Literal:
        case Syntax.LogicalExpression:
        case Syntax.MemberExpression:
        case Syntax.NewExpression:
        case Syntax.ObjectExpression:
        case Syntax.ObjectPattern:
        case Syntax.Property:
        case Syntax.SequenceExpression:
        case Syntax.ThisExpression:
        case Syntax.UnaryExpression:
        case Syntax.UpdateExpression:
        case Syntax.YieldExpression:

            result = generateExpression(node, {
                precedence: Precedence.Sequence,
                allowIn: true,
                allowCall: true
            });
            break;

        default:
            throw new Error('Unknown node type: ' + node.type);
        }

        if (!sourceMap) {
            pair = {code: result.toString(), map: null};
            return options.sourceMapWithCode ? pair : pair.code;
        }


        pair = result.toStringWithSourceMap({
            file: options.file,
            sourceRoot: options.sourceMapRoot
        });

        if (options.sourceContent) {
            pair.map.setSourceContent(options.sourceMap,
                                      options.sourceContent);
        }

        if (options.sourceMapWithCode) {
            return pair;
        }

        return pair.map.toString();
    }

    FORMAT_MINIFY = {
        indent: {
            style: '',
            base: 0
        },
        renumber: true,
        hexadecimal: true,
        quotes: 'auto',
        escapeless: true,
        compact: true,
        parentheses: false,
        semicolons: false
    };

    FORMAT_DEFAULTS = getDefaultOptions().format;

    exports.generate = generate;
    exports.attachComments = estraverse.attachComments;
    exports.Precedence = updateDeeply({}, Precedence);
    exports.browser = false;
    exports.FORMAT_MINIFY = FORMAT_MINIFY;
    exports.FORMAT_DEFAULTS = FORMAT_DEFAULTS;
}());
/* vim: set sw=4 ts=4 et tw=80 : */
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/compiler/escodegen/index',_ion_compiler_escodegen_index_);
    else
      _ion_compiler_escodegen_index_.call(this, module, exports, require);
  }
  else {
    _ion_compiler_escodegen_index_.call(this);
  }
}).call(this)
void (function(){var _ion_compiler_estraverse_index_ = function(module,exports,require){/*
  Copyright (C) 2012-2013 Yusuke Suzuki <utatane.tea@gmail.com>
  Copyright (C) 2012 Ariya Hidayat <ariya.hidayat@gmail.com>

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> BE LIABLE FOR ANY
  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
  (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
/*jslint vars:false, bitwise:true*/
/*jshint indent:4*/
/*global exports:true, define:true*/
(function (root, factory) {
    'use strict';

    // Universal Module Definition (UMD) to support AMD, CommonJS/Node.js,
    // and plain browser loading,
    if (typeof define === 'function' && define.amd) {
        define(['exports'], factory);
    } else if (typeof exports !== 'undefined') {
        factory(exports);
    } else {
        factory((root.estraverse = {}));
    }
}(this, function (exports) {
    'use strict';

    var Syntax,
        isArray,
        VisitorOption,
        VisitorKeys,
        BREAK,
        SKIP;

    Syntax = {
        AssignmentExpression: 'AssignmentExpression',
        ArrayExpression: 'ArrayExpression',
        ArrayPattern: 'ArrayPattern',
        ArrowFunctionExpression: 'ArrowFunctionExpression',
        BlockStatement: 'BlockStatement',
        BinaryExpression: 'BinaryExpression',
        BreakStatement: 'BreakStatement',
        CallExpression: 'CallExpression',
        CatchClause: 'CatchClause',
        ClassBody: 'ClassBody',
        ClassDeclaration: 'ClassDeclaration',
        ClassExpression: 'ClassExpression',
        ConditionalExpression: 'ConditionalExpression',
        ContinueStatement: 'ContinueStatement',
        DebuggerStatement: 'DebuggerStatement',
        DirectiveStatement: 'DirectiveStatement',
        DoWhileStatement: 'DoWhileStatement',
        EmptyStatement: 'EmptyStatement',
        ExpressionStatement: 'ExpressionStatement',
        ForStatement: 'ForStatement',
        ForInStatement: 'ForInStatement',
        FunctionDeclaration: 'FunctionDeclaration',
        FunctionExpression: 'FunctionExpression',
        Identifier: 'Identifier',
        IfStatement: 'IfStatement',
        Literal: 'Literal',
        LabeledStatement: 'LabeledStatement',
        LogicalExpression: 'LogicalExpression',
        MemberExpression: 'MemberExpression',
        MethodDefinition: 'MethodDefinition',
        NewExpression: 'NewExpression',
        ObjectExpression: 'ObjectExpression',
        ObjectPattern: 'ObjectPattern',
        Program: 'Program',
        Property: 'Property',
        ReturnStatement: 'ReturnStatement',
        SequenceExpression: 'SequenceExpression',
        SwitchStatement: 'SwitchStatement',
        SwitchCase: 'SwitchCase',
        ThisExpression: 'ThisExpression',
        ThrowStatement: 'ThrowStatement',
        TryStatement: 'TryStatement',
        UnaryExpression: 'UnaryExpression',
        UpdateExpression: 'UpdateExpression',
        VariableDeclaration: 'VariableDeclaration',
        VariableDeclarator: 'VariableDeclarator',
        WhileStatement: 'WhileStatement',
        WithStatement: 'WithStatement',
        YieldExpression: 'YieldExpression'
    };

    function ignoreJSHintError() { }

    isArray = Array.isArray;
    if (!isArray) {
        isArray = function isArray(array) {
            return Object.prototype.toString.call(array) === '[object Array]';
        };
    }

    function deepCopy(obj) {
        var ret = {}, key, val;
        for (key in obj) {
            if (obj.hasOwnProperty(key)) {
                val = obj[key];
                if (typeof val === 'object' && val !== null) {
                    ret[key] = deepCopy(val);
                } else {
                    ret[key] = val;
                }
            }
        }
        return ret;
    }

    function shallowCopy(obj) {
        var ret = {}, key;
        for (key in obj) {
            if (obj.hasOwnProperty(key)) {
                ret[key] = obj[key];
            }
        }
        return ret;
    }
    ignoreJSHintError(shallowCopy);

    // based on LLVM libc++ upper_bound / lower_bound
    // MIT License

    function upperBound(array, func) {
        var diff, len, i, current;

        len = array.length;
        i = 0;

        while (len) {
            diff = len >>> 1;
            current = i + diff;
            if (func(array[current])) {
                len = diff;
            } else {
                i = current + 1;
                len -= diff + 1;
            }
        }
        return i;
    }

    function lowerBound(array, func) {
        var diff, len, i, current;

        len = array.length;
        i = 0;

        while (len) {
            diff = len >>> 1;
            current = i + diff;
            if (func(array[current])) {
                i = current + 1;
                len -= diff + 1;
            } else {
                len = diff;
            }
        }
        return i;
    }
    ignoreJSHintError(lowerBound);

    VisitorKeys = {
        AssignmentExpression: ['left', 'right'],
        ArrayExpression: ['elements'],
        ArrayPattern: ['elements'],
        ArrowFunctionExpression: ['params', 'defaults', 'rest', 'body'],
        BlockStatement: ['body'],
        BinaryExpression: ['left', 'right'],
        BreakStatement: ['label'],
        CallExpression: ['callee', 'arguments'],
        CatchClause: ['param', 'body'],
        ClassBody: ['body'],
        ClassDeclaration: ['id', 'body', 'superClass'],
        ClassExpression: ['id', 'body', 'superClass'],
        ConditionalExpression: ['test', 'consequent', 'alternate'],
        ContinueStatement: ['label'],
        DebuggerStatement: [],
        DirectiveStatement: [],
        DoWhileStatement: ['body', 'test'],
        EmptyStatement: [],
        ExpressionStatement: ['expression'],
        ForStatement: ['init', 'test', 'update', 'body'],
        ForInStatement: ['left', 'right', 'body'],
        ForOfStatement: ['left', 'right', 'body'],
        FunctionDeclaration: ['id', 'params', 'defaults', 'rest', 'body'],
        FunctionExpression: ['id', 'params', 'defaults', 'rest', 'body'],
        Identifier: [],
        IfStatement: ['test', 'consequent', 'alternate'],
        Literal: [],
        LabeledStatement: ['label', 'body'],
        LogicalExpression: ['left', 'right'],
        MemberExpression: ['object', 'property'],
        MethodDefinition: ['key', 'value'],
        NewExpression: ['callee', 'arguments'],
        ObjectExpression: ['properties'],
        ObjectPattern: ['properties'],
        Program: ['body'],
        Property: ['key', 'value'],
        ReturnStatement: ['argument'],
        SequenceExpression: ['expressions'],
        SwitchStatement: ['discriminant', 'cases'],
        SwitchCase: ['test', 'consequent'],
        ThisExpression: [],
        ThrowStatement: ['argument'],
        TryStatement: ['block', 'handlers', 'handler', 'guardedHandlers', 'finalizer'],
        UnaryExpression: ['argument'],
        UpdateExpression: ['argument'],
        VariableDeclaration: ['declarations'],
        VariableDeclarator: ['id', 'init'],
        WhileStatement: ['test', 'body'],
        WithStatement: ['object', 'body'],
        YieldExpression: ['argument']
    };

    // unique id
    BREAK = {};
    SKIP = {};

    VisitorOption = {
        Break: BREAK,
        Skip: SKIP
    };

    function Reference(parent, key) {
        this.parent = parent;
        this.key = key;
    }

    Reference.prototype.replace = function replace(node) {
        this.parent[this.key] = node;
    };

    function Element(node, path, wrap, ref) {
        this.node = node;
        this.path = path;
        this.wrap = wrap;
        this.ref = ref;
    }

    function Controller() { }

    // API:
    // return property path array from root to current node
    Controller.prototype.path = function path() {
        var i, iz, j, jz, result, element;

        function addToPath(result, path) {
            if (isArray(path)) {
                for (j = 0, jz = path.length; j < jz; ++j) {
                    result.push(path[j]);
                }
            } else {
                result.push(path);
            }
        }

        // root node
        if (!this.__current.path) {
            return null;
        }

        // first node is sentinel, second node is root element
        result = [];
        for (i = 2, iz = this.__leavelist.length; i < iz; ++i) {
            element = this.__leavelist[i];
            addToPath(result, element.path);
        }
        addToPath(result, this.__current.path);
        return result;
    };

    // API:
    // return array of parent elements
    Controller.prototype.parents = function parents() {
        var i, iz, result;

        // first node is sentinel
        result = [];
        for (i = 1, iz = this.__leavelist.length; i < iz; ++i) {
            result.push(this.__leavelist[i].node);
        }

        return result;
    };

    // API:
    // return current node
    Controller.prototype.current = function current() {
        return this.__current.node;
    };

    Controller.prototype.__execute = function __execute(callback, element) {
        var previous, result;

        result = undefined;

        previous  = this.__current;
        this.__current = element;
        this.__state = null;
        if (callback) {
            result = callback.call(this, element.node, this.__leavelist[this.__leavelist.length - 1].node);
        }
        this.__current = previous;

        return result;
    };

    // API:
    // notify control skip / break
    Controller.prototype.notify = function notify(flag) {
        this.__state = flag;
    };

    // API:
    // skip child nodes of current node
    Controller.prototype.skip = function () {
        this.notify(SKIP);
    };

    // API:
    // break traversals
    Controller.prototype['break'] = function () {
        this.notify(BREAK);
    };

    Controller.prototype.__initialize = function(root, visitor) {
        this.visitor = visitor;
        this.root = root;
        this.__worklist = [];
        this.__leavelist = [];
        this.__current = null;
        this.__state = null;
    };

    Controller.prototype.traverse = function traverse(root, visitor) {
        var worklist,
            leavelist,
            element,
            node,
            nodeType,
            ret,
            key,
            current,
            current2,
            candidates,
            candidate,
            sentinel;

        this.__initialize(root, visitor);

        sentinel = {};

        // reference
        worklist = this.__worklist;
        leavelist = this.__leavelist;

        // initialize
        worklist.push(new Element(root, null, null, null));
        leavelist.push(new Element(null, null, null, null));

        while (worklist.length) {
            element = worklist.pop();

            if (element === sentinel) {
                element = leavelist.pop();

                ret = this.__execute(visitor.leave, element);

                if (this.__state === BREAK || ret === BREAK) {
                    return;
                }
                continue;
            }

            if (element.node) {

                ret = this.__execute(visitor.enter, element);

                if (this.__state === BREAK || ret === BREAK) {
                    return;
                }

                worklist.push(sentinel);
                leavelist.push(element);

                if (this.__state === SKIP || ret === SKIP) {
                    continue;
                }

                node = element.node;
                nodeType = element.wrap || node.type;
                candidates = VisitorKeys[nodeType];

                current = candidates.length;
                while ((current -= 1) >= 0) {
                    key = candidates[current];
                    candidate = node[key];
                    if (!candidate) {
                        continue;
                    }

                    if (!isArray(candidate)) {
                        worklist.push(new Element(candidate, key, null, null));
                        continue;
                    }

                    current2 = candidate.length;
                    while ((current2 -= 1) >= 0) {
                        if (!candidate[current2]) {
                            continue;
                        }
                        if ((nodeType === Syntax.ObjectExpression || nodeType === Syntax.ObjectPattern) && 'properties' === candidates[current]) {
                            element = new Element(candidate[current2], [key, current2], 'Property', null);
                        } else {
                            element = new Element(candidate[current2], [key, current2], null, null);
                        }
                        worklist.push(element);
                    }
                }
            }
        }
    };

    Controller.prototype.replace = function replace(root, visitor) {
        var worklist,
            leavelist,
            node,
            nodeType,
            target,
            element,
            current,
            current2,
            candidates,
            candidate,
            sentinel,
            outer,
            key;

        this.__initialize(root, visitor);

        sentinel = {};

        // reference
        worklist = this.__worklist;
        leavelist = this.__leavelist;

        // initialize
        outer = {
            root: root
        };
        element = new Element(root, null, null, new Reference(outer, 'root'));
        worklist.push(element);
        leavelist.push(element);

        while (worklist.length) {
            element = worklist.pop();

            if (element === sentinel) {
                element = leavelist.pop();

                target = this.__execute(visitor.leave, element);

                // node may be replaced with null,
                // so distinguish between undefined and null in this place
                if (target !== undefined && target !== BREAK && target !== SKIP) {
                    // replace
                    element.ref.replace(target);
                }

                if (this.__state === BREAK || target === BREAK) {
                    return outer.root;
                }
                continue;
            }

            target = this.__execute(visitor.enter, element);

            // node may be replaced with null,
            // so distinguish between undefined and null in this place
            if (target !== undefined && target !== BREAK && target !== SKIP) {
                // replace
                element.ref.replace(target);
                element.node = target;
            }

            if (this.__state === BREAK || target === BREAK) {
                return outer.root;
            }

            // node may be null
            node = element.node;
            if (!node) {
                continue;
            }

            worklist.push(sentinel);
            leavelist.push(element);

            if (this.__state === SKIP || target === SKIP) {
                continue;
            }

            nodeType = element.wrap || node.type;
            candidates = VisitorKeys[nodeType];

            current = candidates.length;
            while ((current -= 1) >= 0) {
                key = candidates[current];
                candidate = node[key];
                if (!candidate) {
                    continue;
                }

                if (!isArray(candidate)) {
                    worklist.push(new Element(candidate, key, null, new Reference(node, key)));
                    continue;
                }

                current2 = candidate.length;
                while ((current2 -= 1) >= 0) {
                    if (!candidate[current2]) {
                        continue;
                    }
                    if (nodeType === Syntax.ObjectExpression && 'properties' === candidates[current]) {
                        element = new Element(candidate[current2], [key, current2], 'Property', new Reference(candidate, current2));
                    } else {
                        element = new Element(candidate[current2], [key, current2], null, new Reference(candidate, current2));
                    }
                    worklist.push(element);
                }
            }
        }

        return outer.root;
    };

    function traverse(root, visitor) {
        var controller = new Controller();
        return controller.traverse(root, visitor);
    }

    function replace(root, visitor) {
        var controller = new Controller();
        return controller.replace(root, visitor);
    }

    function extendCommentRange(comment, tokens) {
        var target;

        target = upperBound(tokens, function search(token) {
            return token.range[0] > comment.range[0];
        });

        comment.extendedRange = [comment.range[0], comment.range[1]];

        if (target !== tokens.length) {
            comment.extendedRange[1] = tokens[target].range[0];
        }

        target -= 1;
        if (target >= 0) {
            comment.extendedRange[0] = tokens[target].range[1];
        }

        return comment;
    }

    function attachComments(tree, providedComments, tokens) {
        // At first, we should calculate extended comment ranges.
        var comments = [], comment, len, i, cursor;

        if (!tree.range) {
            throw new Error('attachComments needs range information');
        }

        // tokens array is empty, we attach comments to tree as 'leadingComments'
        if (!tokens.length) {
            if (providedComments.length) {
                for (i = 0, len = providedComments.length; i < len; i += 1) {
                    comment = deepCopy(providedComments[i]);
                    comment.extendedRange = [0, tree.range[0]];
                    comments.push(comment);
                }
                tree.leadingComments = comments;
            }
            return tree;
        }

        for (i = 0, len = providedComments.length; i < len; i += 1) {
            comments.push(extendCommentRange(deepCopy(providedComments[i]), tokens));
        }

        // This is based on John Freeman's implementation.
        cursor = 0;
        traverse(tree, {
            enter: function (node) {
                var comment;

                while (cursor < comments.length) {
                    comment = comments[cursor];
                    if (comment.extendedRange[1] > node.range[0]) {
                        break;
                    }

                    if (comment.extendedRange[1] === node.range[0]) {
                        if (!node.leadingComments) {
                            node.leadingComments = [];
                        }
                        node.leadingComments.push(comment);
                        comments.splice(cursor, 1);
                    } else {
                        cursor += 1;
                    }
                }

                // already out of owned node
                if (cursor === comments.length) {
                    return VisitorOption.Break;
                }

                if (comments[cursor].extendedRange[0] > node.range[1]) {
                    return VisitorOption.Skip;
                }
            }
        });

        cursor = 0;
        traverse(tree, {
            leave: function (node) {
                var comment;

                while (cursor < comments.length) {
                    comment = comments[cursor];
                    if (node.range[1] < comment.extendedRange[0]) {
                        break;
                    }

                    if (node.range[1] === comment.extendedRange[0]) {
                        if (!node.trailingComments) {
                            node.trailingComments = [];
                        }
                        node.trailingComments.push(comment);
                        comments.splice(cursor, 1);
                    } else {
                        cursor += 1;
                    }
                }

                // already out of owned node
                if (cursor === comments.length) {
                    return VisitorOption.Break;
                }

                if (comments[cursor].extendedRange[0] > node.range[1]) {
                    return VisitorOption.Skip;
                }
            }
        });

        return tree;
    }

    exports.version = '1.5.1-dev';
    exports.Syntax = Syntax;
    exports.traverse = traverse;
    exports.replace = replace;
    exports.attachComments = attachComments;
    exports.VisitorKeys = VisitorKeys;
    exports.VisitorOption = VisitorOption;
    exports.Controller = Controller;
}));
/* vim: set sw=4 ts=4 et tw=80 : */
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/compiler/estraverse/index',_ion_compiler_estraverse_index_);
    else
      _ion_compiler_estraverse_index_.call(this, module, exports, require);
  }
  else {
    _ion_compiler_estraverse_index_.call(this);
  }
}).call(this)
void (function(){var _ion_compiler_esutils_code_ = function(module,exports,require){/*
  Copyright (C) 2013 Yusuke Suzuki <utatane.tea@gmail.com>

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> BE LIABLE FOR ANY
  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
  (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

(function () {
    'use strict';

    var Regex;

    // See `tools/generate-identifier-regex.js`.
    Regex = {
        NonAsciiIdentifierStart: new RegExp('[\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u0527\u0531-\u0556\u0559\u0561-\u0587\u05D0-\u05EA\u05F0-\u05F2\u0620-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u08A0\u08A2-\u08AC\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0977\u0979-\u097F\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C33\u0C35-\u0C39\u0C3D\u0C58\u0C59\u0C60\u0C61\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D60\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F4\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F0\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1877\u1880-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191C\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19C1-\u19C7\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1CE9-\u1CEC\u1CEE-\u1CF1\u1CF5\u1CF6\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312D\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FCC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA61F\uA62A\uA62B\uA640-\uA66E\uA67F-\uA697\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA78E\uA790-\uA793\uA7A0-\uA7AA\uA7F8-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A\uAA80-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uABC0-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]'),
        NonAsciiIdentifierPart: new RegExp('[\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0300-\u0374\u0376\u0377\u037A-\u037D\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u0483-\u0487\u048A-\u0527\u0531-\u0556\u0559\u0561-\u0587\u0591-\u05BD\u05BF\u05C1\u05C2\u05C4\u05C5\u05C7\u05D0-\u05EA\u05F0-\u05F2\u0610-\u061A\u0620-\u0669\u066E-\u06D3\u06D5-\u06DC\u06DF-\u06E8\u06EA-\u06FC\u06FF\u0710-\u074A\u074D-\u07B1\u07C0-\u07F5\u07FA\u0800-\u082D\u0840-\u085B\u08A0\u08A2-\u08AC\u08E4-\u08FE\u0900-\u0963\u0966-\u096F\u0971-\u0977\u0979-\u097F\u0981-\u0983\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BC-\u09C4\u09C7\u09C8\u09CB-\u09CE\u09D7\u09DC\u09DD\u09DF-\u09E3\u09E6-\u09F1\u0A01-\u0A03\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A3C\u0A3E-\u0A42\u0A47\u0A48\u0A4B-\u0A4D\u0A51\u0A59-\u0A5C\u0A5E\u0A66-\u0A75\u0A81-\u0A83\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABC-\u0AC5\u0AC7-\u0AC9\u0ACB-\u0ACD\u0AD0\u0AE0-\u0AE3\u0AE6-\u0AEF\u0B01-\u0B03\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3C-\u0B44\u0B47\u0B48\u0B4B-\u0B4D\u0B56\u0B57\u0B5C\u0B5D\u0B5F-\u0B63\u0B66-\u0B6F\u0B71\u0B82\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BBE-\u0BC2\u0BC6-\u0BC8\u0BCA-\u0BCD\u0BD0\u0BD7\u0BE6-\u0BEF\u0C01-\u0C03\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C33\u0C35-\u0C39\u0C3D-\u0C44\u0C46-\u0C48\u0C4A-\u0C4D\u0C55\u0C56\u0C58\u0C59\u0C60-\u0C63\u0C66-\u0C6F\u0C82\u0C83\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBC-\u0CC4\u0CC6-\u0CC8\u0CCA-\u0CCD\u0CD5\u0CD6\u0CDE\u0CE0-\u0CE3\u0CE6-\u0CEF\u0CF1\u0CF2\u0D02\u0D03\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D-\u0D44\u0D46-\u0D48\u0D4A-\u0D4E\u0D57\u0D60-\u0D63\u0D66-\u0D6F\u0D7A-\u0D7F\u0D82\u0D83\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DCA\u0DCF-\u0DD4\u0DD6\u0DD8-\u0DDF\u0DF2\u0DF3\u0E01-\u0E3A\u0E40-\u0E4E\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB9\u0EBB-\u0EBD\u0EC0-\u0EC4\u0EC6\u0EC8-\u0ECD\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F18\u0F19\u0F20-\u0F29\u0F35\u0F37\u0F39\u0F3E-\u0F47\u0F49-\u0F6C\u0F71-\u0F84\u0F86-\u0F97\u0F99-\u0FBC\u0FC6\u1000-\u1049\u1050-\u109D\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u135D-\u135F\u1380-\u138F\u13A0-\u13F4\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F0\u1700-\u170C\u170E-\u1714\u1720-\u1734\u1740-\u1753\u1760-\u176C\u176E-\u1770\u1772\u1773\u1780-\u17D3\u17D7\u17DC\u17DD\u17E0-\u17E9\u180B-\u180D\u1810-\u1819\u1820-\u1877\u1880-\u18AA\u18B0-\u18F5\u1900-\u191C\u1920-\u192B\u1930-\u193B\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19D9\u1A00-\u1A1B\u1A20-\u1A5E\u1A60-\u1A7C\u1A7F-\u1A89\u1A90-\u1A99\u1AA7\u1B00-\u1B4B\u1B50-\u1B59\u1B6B-\u1B73\u1B80-\u1BF3\u1C00-\u1C37\u1C40-\u1C49\u1C4D-\u1C7D\u1CD0-\u1CD2\u1CD4-\u1CF6\u1D00-\u1DE6\u1DFC-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u200C\u200D\u203F\u2040\u2054\u2071\u207F\u2090-\u209C\u20D0-\u20DC\u20E1\u20E5-\u20F0\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D7F-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2DE0-\u2DFF\u2E2F\u3005-\u3007\u3021-\u302F\u3031-\u3035\u3038-\u303C\u3041-\u3096\u3099\u309A\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312D\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FCC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66F\uA674-\uA67D\uA67F-\uA697\uA69F-\uA6F1\uA717-\uA71F\uA722-\uA788\uA78B-\uA78E\uA790-\uA793\uA7A0-\uA7AA\uA7F8-\uA827\uA840-\uA873\uA880-\uA8C4\uA8D0-\uA8D9\uA8E0-\uA8F7\uA8FB\uA900-\uA92D\uA930-\uA953\uA960-\uA97C\uA980-\uA9C0\uA9CF-\uA9D9\uAA00-\uAA36\uAA40-\uAA4D\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7B\uAA80-\uAAC2\uAADB-\uAADD\uAAE0-\uAAEF\uAAF2-\uAAF6\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uABC0-\uABEA\uABEC\uABED\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE00-\uFE0F\uFE20-\uFE26\uFE33\uFE34\uFE4D-\uFE4F\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF3F\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]')
    };

    function isDecimalDigit(ch) {
        return (ch >= 48 && ch <= 57);   // 0..9
    }

    function isHexDigit(ch) {
        return isDecimalDigit(ch) || (97 <= ch && ch <= 102) || (65 <= ch && ch <= 70);
    }

    function isOctalDigit(ch) {
        return (ch >= 48 && ch <= 55);   // 0..7
    }

    // 7.2 White Space

    function isWhiteSpace(ch) {
        return (ch === 0x20) || (ch === 0x09) || (ch === 0x0B) || (ch === 0x0C) || (ch === 0xA0) ||
            (ch >= 0x1680 && [0x1680, 0x180E, 0x2000, 0x2001, 0x2002, 0x2003, 0x2004, 0x2005, 0x2006, 0x2007, 0x2008, 0x2009, 0x200A, 0x202F, 0x205F, 0x3000, 0xFEFF].indexOf(ch) >= 0);
    }

    // 7.3 Line Terminators

    function isLineTerminator(ch) {
        return (ch === 0x0A) || (ch === 0x0D) || (ch === 0x2028) || (ch === 0x2029);
    }

    // 7.6 Identifier Names and Identifiers

    function isIdentifierStart(ch) {
        return (ch === 36) || (ch === 95) ||  // $ (dollar) and _ (underscore)
            (ch >= 65 && ch <= 90) ||         // A..Z
            (ch >= 97 && ch <= 122) ||        // a..z
            (ch === 92) ||                    // \ (backslash)
            ((ch >= 0x80) && Regex.NonAsciiIdentifierStart.test(String.fromCharCode(ch)));
    }

    function isIdentifierPart(ch) {
        return (ch === 36) || (ch === 95) ||  // $ (dollar) and _ (underscore)
            (ch >= 65 && ch <= 90) ||         // A..Z
            (ch >= 97 && ch <= 122) ||        // a..z
            (ch >= 48 && ch <= 57) ||         // 0..9
            (ch === 92) ||                    // \ (backslash)
            ((ch >= 0x80) && Regex.NonAsciiIdentifierPart.test(String.fromCharCode(ch)));
    }

    module.exports = {
        isDecimalDigit: isDecimalDigit,
        isHexDigit: isHexDigit,
        isOctalDigit: isOctalDigit,
        isWhiteSpace: isWhiteSpace,
        isLineTerminator: isLineTerminator,
        isIdentifierStart: isIdentifierStart,
        isIdentifierPart: isIdentifierPart
    };
}());
/* vim: set sw=4 ts=4 et tw=80 : */
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/compiler/esutils/code',_ion_compiler_esutils_code_);
    else
      _ion_compiler_esutils_code_.call(this, module, exports, require);
  }
  else {
    _ion_compiler_esutils_code_.call(this);
  }
}).call(this)
void (function(){var _ion_compiler_esutils_index_ = function(module,exports,require){/*
  Copyright (C) 2013 Yusuke Suzuki <utatane.tea@gmail.com>

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> BE LIABLE FOR ANY
  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
  (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/


(function () {
    'use strict';

    exports.code = require('./code');
    exports.keyword = require('./keyword');
}());
/* vim: set sw=4 ts=4 et tw=80 : */
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/compiler/esutils/index',_ion_compiler_esutils_index_);
    else
      _ion_compiler_esutils_index_.call(this, module, exports, require);
  }
  else {
    _ion_compiler_esutils_index_.call(this);
  }
}).call(this)
void (function(){var _ion_compiler_esutils_keyword_ = function(module,exports,require){/*
  Copyright (C) 2013 Yusuke Suzuki <utatane.tea@gmail.com>

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> BE LIABLE FOR ANY
  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
  (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

(function () {
    'use strict';

    var code = require('./code');

    function isStrictModeReservedWordES6(id) {
        switch (id) {
        case 'implements':
        case 'interface':
        case 'package':
        case 'private':
        case 'protected':
        case 'public':
        case 'static':
        case 'let':
            return true;
        default:
            return false;
        }
    }

    function isKeywordES5(id, strict) {
        // yield should not be treated as keyword under non-strict mode.
        if (!strict && id === 'yield') {
            return false;
        }
        return isKeywordES6(id, strict);
    }

    function isKeywordES6(id, strict) {
        if (strict && isStrictModeReservedWordES6(id)) {
            return true;
        }

        switch (id.length) {
        case 2:
            return (id === 'if') || (id === 'in') || (id === 'do');
        case 3:
            return (id === 'var') || (id === 'for') || (id === 'new') || (id === 'try');
        case 4:
            return (id === 'this') || (id === 'else') || (id === 'case') ||
                (id === 'void') || (id === 'with') || (id === 'enum');
        case 5:
            return (id === 'while') || (id === 'break') || (id === 'catch') ||
                (id === 'throw') || (id === 'const') || (id === 'yield') ||
                (id === 'class') || (id === 'super');
        case 6:
            return (id === 'return') || (id === 'typeof') || (id === 'delete') ||
                (id === 'switch') || (id === 'export') || (id === 'import');
        case 7:
            return (id === 'default') || (id === 'finally') || (id === 'extends');
        case 8:
            return (id === 'function') || (id === 'continue') || (id === 'debugger');
        case 10:
            return (id === 'instanceof');
        default:
            return false;
        }
    }

    function isRestrictedWord(id) {
        return id === 'eval' || id === 'arguments';
    }

    function isIdentifierName(id) {
        var i, iz, ch;

        if (id.length === 0) {
            return false;
        }

        ch = id.charCodeAt(0);
        if (!code.isIdentifierStart(ch) || ch === 92) {  // \ (backslash)
            return false;
        }

        for (i = 1, iz = id.length; i < iz; ++i) {
            ch = id.charCodeAt(i);
            if (!code.isIdentifierPart(ch) || ch === 92) {  // \ (backslash)
                return false;
            }
        }
        return true;
    }

    module.exports = {
        isKeywordES5: isKeywordES5,
        isKeywordES6: isKeywordES6,
        isRestrictedWord: isRestrictedWord,
        isIdentifierName: isIdentifierName
    };
}());
/* vim: set sw=4 ts=4 et tw=80 : */
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/compiler/esutils/keyword',_ion_compiler_esutils_keyword_);
    else
      _ion_compiler_esutils_keyword_.call(this, module, exports, require);
  }
  else {
    _ion_compiler_esutils_keyword_.call(this);
  }
}).call(this)
void (function(){var _ion_compiler_index_ = function(module,exports,require){'use strict';
var ion = require('../'), makePrettyError = function (e, source, id) {
        if (typeof e.line === 'number' && typeof e.column === 'number' && e.line > 0 && e.column > 0) {
            var line = source.split('\n')[e.line - 1];
            var caret = '^';
            for (var i = 1; i < e.column; i++) {
                caret = ' ' + caret;
            }
            var newMessage = '' + (id != null ? id : '(anonymous)') + ':' + e.line + ':' + e.column + ': ' + e.message + '\n' + line + '\n' + caret;
            e.originalMessage = e.message;
            e.message = newMessage;
            e.stack = newMessage;
        }
    };
var parse = exports.parse = function (content, options) {
        if (options == null)
            options = {};
        options.generate = false;
        return compile(content, options);
    }, compile = exports.compile = function (content, options) {
        if (options == null)
            options = {};
        return compileWithSourceMap(content, options)[0];
    }, compileWithSourceMap = exports.compileWithSourceMap = function (content, options) {
        if (options == null)
            options = {};
        var header = '';
        if (content.startsWith('#!')) {
            header = content.split(/\r|\n/)[0] + '\n';
        }
        options.loc = options.loc != null ? options.loc : true;
        options.target = options.target != null ? options.target : 'es5';
        var preprocessor = require('./preprocessor'), parser = require('./parser'), postprocessor = require('./postprocessor'), escodegen = require('./escodegen');
        var sourceMapping = {}, result = preprocessor.preprocess(content, sourceMapping), sourceMap = null, preprocessed = result, sourceLocationsFixed = false, dump = function (description) {
                if (options.debug) {
                    console.log('-' + description + '--------------------------------------');
                    console.log(typeof result === 'string' ? result : JSON.stringify(result, null, '  '));
                    console.log('---------------------------------------------------');
                }
            };
        try {
            dump('Preprocessed');
            result = parser.parse(result, options);
            dump('Parsed');
            result = preprocessor.fixSourceLocations(result, sourceMapping, options.source);
            sourceLocationsFixed = true;
            if (options.postprocess !== false) {
                result = postprocessor.postprocess(result, options);
                if ((options != null ? options.generate : void 0) !== false) {
                    var generateOptions = {};
                    {
                        generateOptions.sourceMapWithCode = true;
                        if (!(global.window != null)) {
                            generateOptions.sourceMap = options.sourceMap != null ? options.sourceMap : options.source;
                        }
                        generateOptions.sourceContent = content;
                        generateOptions.verbatim = 'verbatim';
                    }
                    var output = escodegen.generate(result, generateOptions);
                    result = output.code;
                    dump('Generated');
                    sourceMap = output.map != null ? output.map.toString() : void 0;
                }
            }
        } catch (e) {
            if (!sourceLocationsFixed) {
                preprocessor.fixSourceLocation(e, sourceMapping);
            }
            makePrettyError(e, content, options.source);
            throw e;
        }
        return [
            header + result,
            sourceMap
        ];
    };
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/compiler/index',_ion_compiler_index_);
    else
      _ion_compiler_index_.call(this, module, exports, require);
  }
  else {
    _ion_compiler_index_.call(this);
  }
}).call(this)
void (function(){var _ion_compiler_nodes_ = function(module,exports,require){'use strict';
var ion = require('../');
var Identifier = exports.Identifier = { location: true }, NewExpression = exports.NewExpression = { location: true }, CallExpression = exports.CallExpression = { location: true }, ExpressionStatement = exports.ExpressionStatement = { location: true }, MemberExpression = exports.MemberExpression = { location: true }, BlockStatement = exports.BlockStatement = {
        isBlock: true,
        newScope: true
    }, Program = exports.Program = {
        isBlock: true,
        newScope: true,
        reactive: false
    }, FunctionExpression = exports.FunctionExpression = {
        isFunction: true,
        paramKind: 'let',
        newScope: true,
        shadow: true,
        reactive: false
    }, FunctionDeclaration = exports.FunctionDeclaration = FunctionExpression, Template = exports.Template = {
        isFunction: true,
        paramKind: 'const',
        newScope: true,
        shadow: true,
        reactive: true
    }, ForStatement = exports.ForStatement = {
        newScope: true,
        allowedInReactive: false
    }, ForInStatement = exports.ForInStatement = { newScope: true }, ForOfStatement = exports.ForOfStatement = { newScope: true }, ExportStatement = exports.ExportStatement = { allowedInReactive: false }, ClassExpression = exports.ClassExpression = { allowedInReactive: false }, ThrowStatement = exports.ThrowStatement = { allowedInReactive: false }, TryStatement = exports.TryStatement = { allowedInReactive: false };
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/compiler/nodes',_ion_compiler_nodes_);
    else
      _ion_compiler_nodes_.call(this, module, exports, require);
  }
  else {
    _ion_compiler_nodes_.call(this);
  }
}).call(this)
void (function(){var _ion_compiler_parser_ = function(module,exports,require){module.exports = (function() {
  /*
   * Generated by PEG.js 0.8.0.
   *
   * http://pegjs.majda.cz/
   */

  function peg$subclass(child, parent) {
    function ctor() { this.constructor = child; }
    ctor.prototype = parent.prototype;
    child.prototype = new ctor();
  }

  function SyntaxError(message, expected, found, offset, line, column) {
    this.message  = message;
    this.expected = expected;
    this.found    = found;
    this.offset   = offset;
    this.line     = line;
    this.column   = column;

    this.name     = "SyntaxError";
  }

  peg$subclass(SyntaxError, Error);

  function parse(input) {
    var options = arguments.length > 1 ? arguments[1] : {},

        peg$FAILED = {},

        peg$startRuleFunctions = { Program: peg$parseProgram },
        peg$startRuleFunction  = peg$parseProgram,

        peg$c0 = peg$FAILED,
        peg$c1 = function(start, body, end) { return node("Program", {body:body}, start, end) },
        peg$c2 = function(a) { return a.body },
        peg$c3 = [],
        peg$c4 = null,
        peg$c5 = ",",
        peg$c6 = { type: "literal", value: ",", description: "\",\"" },
        peg$c7 = function(a) { return a },
        peg$c8 = function(start, value, end) { return node('ExportStatement', {value:value}, start, end) },
        peg$c9 = function(start, argument, end) { return node("ReturnStatement", {argument:argument}, start, end) },
        peg$c10 = function(start, argument, end) { return node("ThrowStatement", {argument:argument}, start, end) },
        peg$c11 = function(start, end) { return node("BreakStatement", {}, start, end) },
        peg$c12 = function(start, end) { return node("ContinueStatement", {}, start, end) },
        peg$c13 = function(a) {return {expression:a, text:text()}},
        peg$c14 = function(start, properties, end) { return node('AssertStatement', properties, start, end) },
        peg$c15 = function(start, expression, end) { return node("ExpressionStatement", {expression:expression}, start, end) },
        peg$c16 = void 0,
        peg$c17 = function(start, f, end) { return node("ActivateStatement", {argument: f}, start, end) },
        peg$c18 = function(a) {return a},
        peg$c19 = function(start, test, consequent, alternate, end) { return node("IfStatement", {test:test, consequent:consequent, alternate:alternate}, start, end) },
        peg$c20 = function(start, block, handler, finalizer, end) { return node("TryStatement", {block:block, handler:handler, finalizer:finalizer}, start, end) },
        peg$c21 = function(start, block, finalizer, end) { return node("TryStatement", {block:block, finalizer:finalizer}, start, end) },
        peg$c22 = function(start, param, body, end) { return node("CatchClause", {param:param, guard:null, body:body}, start, end) },
        peg$c23 = function(start, test, body, end) { return node("WhileStatement", {test:test, body:body}, start, end)},
        peg$c24 = function() { return "ForOfStatement" },
        peg$c25 = function() { return "ForInStatement" },
        peg$c26 = function(test) { return test },
        peg$c27 = function(left, type, right, test, inner) { return {type:type, left:left, right:right, test:test || undefined, inner: inner || undefined} },
        peg$c28 = function(start, a, end) { return node("BlockStatement", {body:a.body}, start, end) },
        peg$c29 = function(start, head, body, remove, end) {
                head = clone(head)
                head.body = body
                head.remove = remove
                return node(head.type, head, start, end)
            },
        peg$c30 = ";",
        peg$c31 = { type: "literal", value: ";", description: "\";\"" },
        peg$c32 = function(init, test, update) {return {type:"ForStatement", init, test, update}},
        peg$c33 = function(start, head, body, end) {
                head = clone(head)
                head.body = body
                return node("ForStatement", head, start, end)
            },
        peg$c34 = "[",
        peg$c35 = { type: "literal", value: "[", description: "\"[\"" },
        peg$c36 = "]",
        peg$c37 = { type: "literal", value: "]", description: "\"]\"" },
        peg$c38 = function(start, value, comprehension, end) {
                // value must be defined AFTER comprehension so that it reflects the actual order of usage.
                // This is important for the checkVariableDeclarations processor.
                return node("ArrayExpression", {comprehension:comprehension, value:value}, start, end)
            },
        peg$c39 = function(start, body, end) { return node("BlockStatement", {body:body}, start, end) },
        peg$c40 = function(start, name, _extends, properties, end) {
                if (name == null)
                    name = {name:null,computed:false}
                return node("ClassExpression", {name:name.name, computed:name.computed, 'extends':_extends || [], properties:(properties != null ? properties.body : [])}, start, end)
            },
        peg$c41 = function(name) { return {name:name,computed:false} },
        peg$c42 = function(name) { return {name:name,computed:true} },
        peg$c43 = function(baseClasses) { return baseClasses },
        peg$c44 = ".",
        peg$c45 = { type: "literal", value: ".", description: "\".\"" },
        peg$c46 = function(head, tail) { return [head].concat(tail) },
        peg$c47 = function(key) { return {key:key} },
        peg$c48 = function(key) { return {key:key, computed: true} },
        peg$c49 = "property ",
        peg$c50 = { type: "literal", value: "property ", description: "\"property \"" },
        peg$c51 = ":",
        peg$c52 = { type: "literal", value: ":", description: "\":\"" },
        peg$c53 = function(start, left, value, end) { return node("Property", { key: left.key, value:value, kind: 'init', computed:left.computed, define:true }, start, end) },
        peg$c54 = function(start, left, value, end) { return node("Property", { key: left.key, value:value, kind: 'init', computed:left.computed }, start, end) },
        peg$c55 = function(start, kind, declarations, end) { return node("VariableDeclaration", {declarations:declarations, kind:kind != null ? kind : "let"}, start, end) },
        peg$c56 = function(declarations) { return declarations },
        peg$c57 = function(start, func, end) { return node("VariableDeclarator", {id:func.id,init:func}, start, end) },
        peg$c58 = function(start, pattern, init, end) { return node("VariableDeclarator", {id:pattern,init:init}, start, end) },
        peg$c59 = "=",
        peg$c60 = { type: "literal", value: "=", description: "\"=\"" },
        peg$c61 = function(pattern) { /* due to packrat parsing, you MUST clone before modifying anything. */ pattern = clone(pattern); pattern.type = "ObjectPattern"; return pattern },
        peg$c62 = function(pattern) { /* due to packrat parsing, you MUST clone before modifying anything. */ pattern = clone(pattern); pattern.type = "ArrayPattern"; return pattern },
        peg$c63 = "...",
        peg$c64 = { type: "literal", value: "...", description: "\"...\"" },
        peg$c65 = function(start, e, end) { return node("SpreadExpression", {expression:e}, start, end) },
        peg$c66 = "deep ",
        peg$c67 = { type: "literal", value: "deep ", description: "\"deep \"" },
        peg$c68 = function(start, deep, head, tail) {
                // convert array of arrays to just a flat array
                tail = tail.reduce(function(a,b){ return a.concat(b)}, [])
                var e = leftAssociateCallsOrMembers(start, head, tail)
                if (deep)
                    e.deep = true
                return e
            },
        peg$c69 = function(e) { return e },
        peg$c70 = "void",
        peg$c71 = { type: "literal", value: "void", description: "\"void\"" },
        peg$c72 = function(start, e, end) { return node('UnaryExpression', {operator:"void", argument:e}, start, end) },
        peg$c73 = "(",
        peg$c74 = { type: "literal", value: "(", description: "\"(\"" },
        peg$c75 = ")",
        peg$c76 = { type: "literal", value: ")", description: "\")\"" },
        peg$c77 = function(args) { return args},
        peg$c78 = "(..)",
        peg$c79 = { type: "literal", value: "(..)", description: "\"(..)\"" },
        peg$c80 = function(arg) { return arg },
        peg$c81 = function(property) { return property },
        peg$c82 = function(start, properties, end) { return [node("ObjectExpression", {properties:properties}, start, end)] },
        peg$c83 = function(start, callee, args, end) {
                if (callee.type === 'NewExpression' && callee.arguments == null)
                    return node("NewExpression", {callee: callee.callee, arguments: args}, start, end)
                return node("CallExpression", {callee: callee, arguments: args}, start, end)
            },
        peg$c84 = "+=",
        peg$c85 = { type: "literal", value: "+=", description: "\"+=\"" },
        peg$c86 = "-=",
        peg$c87 = { type: "literal", value: "-=", description: "\"-=\"" },
        peg$c88 = "*=",
        peg$c89 = { type: "literal", value: "*=", description: "\"*=\"" },
        peg$c90 = "/=",
        peg$c91 = { type: "literal", value: "/=", description: "\"/=\"" },
        peg$c92 = "%=",
        peg$c93 = { type: "literal", value: "%=", description: "\"%=\"" },
        peg$c94 = "<<=",
        peg$c95 = { type: "literal", value: "<<=", description: "\"<<=\"" },
        peg$c96 = ">>=",
        peg$c97 = { type: "literal", value: ">>=", description: "\">>=\"" },
        peg$c98 = ">>>=",
        peg$c99 = { type: "literal", value: ">>>=", description: "\">>>=\"" },
        peg$c100 = "^=",
        peg$c101 = { type: "literal", value: "^=", description: "\"^=\"" },
        peg$c102 = "&=",
        peg$c103 = { type: "literal", value: "&=", description: "\"&=\"" },
        peg$c104 = "??=",
        peg$c105 = { type: "literal", value: "??=", description: "\"??=\"" },
        peg$c106 = "?=",
        peg$c107 = { type: "literal", value: "?=", description: "\"?=\"" },
        peg$c108 = ":=",
        peg$c109 = { type: "literal", value: ":=", description: "\":=\"" },
        peg$c110 = function(start, left, op, right, end) { return node("AssignmentExpression", {operator:op, left:left, right:right}, start, end) },
        peg$c111 = "?",
        peg$c112 = { type: "literal", value: "?", description: "\"?\"" },
        peg$c113 = function(start, test, consequent, alternate, end) { return node('ConditionalExpression', {test:test,consequent:consequent,alternate:alternate}, start, end) },
        peg$c114 = "??",
        peg$c115 = { type: "literal", value: "??", description: "\"??\"" },
        peg$c116 = function(start, head, tail) { return leftAssociateBinaryExpressions(start, head, tail) },
        peg$c117 = "|",
        peg$c118 = { type: "literal", value: "|", description: "\"|\"" },
        peg$c119 = "^",
        peg$c120 = { type: "literal", value: "^", description: "\"^\"" },
        peg$c121 = "&",
        peg$c122 = { type: "literal", value: "&", description: "\"&\"" },
        peg$c123 = "<=",
        peg$c124 = { type: "literal", value: "<=", description: "\"<=\"" },
        peg$c125 = ">=",
        peg$c126 = { type: "literal", value: ">=", description: "\">=\"" },
        peg$c127 = "<",
        peg$c128 = { type: "literal", value: "<", description: "\"<\"" },
        peg$c129 = ">",
        peg$c130 = { type: "literal", value: ">", description: "\">\"" },
        peg$c131 = ">>>",
        peg$c132 = { type: "literal", value: ">>>", description: "\">>>\"" },
        peg$c133 = ">>",
        peg$c134 = { type: "literal", value: ">>", description: "\">>\"" },
        peg$c135 = "<<",
        peg$c136 = { type: "literal", value: "<<", description: "\"<<\"" },
        peg$c137 = "+",
        peg$c138 = { type: "literal", value: "+", description: "\"+\"" },
        peg$c139 = "-",
        peg$c140 = { type: "literal", value: "-", description: "\"-\"" },
        peg$c141 = "*",
        peg$c142 = { type: "literal", value: "*", description: "\"*\"" },
        peg$c143 = "/",
        peg$c144 = { type: "literal", value: "/", description: "\"/\"" },
        peg$c145 = "%",
        peg$c146 = { type: "literal", value: "%", description: "\"%\"" },
        peg$c147 = function(start, op, arg, end) { return node('UnaryExpression', {operator:op, argument:arg}, start, end) },
        peg$c148 = { type: "other", description: "unaryOperator" },
        peg$c149 = "~",
        peg$c150 = { type: "literal", value: "~", description: "\"~\"" },
        peg$c151 = "++",
        peg$c152 = { type: "literal", value: "++", description: "\"++\"" },
        peg$c153 = "--",
        peg$c154 = { type: "literal", value: "--", description: "\"--\"" },
        peg$c155 = function(start, op, arg, end) { return node('UpdateExpression', {operator:op, argument:arg, prefix:true}, start, end) },
        peg$c156 = function(start, arg, op, end) { return node('UpdateExpression', {operator:op, argument:arg, prefix:false}, start, end) },
        peg$c157 = function(start, arg, op, end) { return node('UnaryExpression', {operator:op, argument:arg}, start, end) },
        peg$c158 = function(start, head, tail) { return leftAssociateCallsOrMembers(start, head, tail) },
        peg$c159 = function() {return true},
        peg$c160 = function(existential, args, end) { return ["callee", node("CallExpression", {callee:null, arguments:args, existential:existential || undefined}), end] },
        peg$c161 = function(existential, property, end) { return ["object", node("MemberExpression", {computed:true, object:null, property:property, existential:existential || undefined}), end] },
        peg$c162 = function(existential, property, end) { return ["object", node("MemberExpression", {computed:false, object:null, property:property, existential:existential || undefined}), end] },
        peg$c163 = function(a) { return a ? a : [] },
        peg$c164 = function(start, a, end) { return [node("ObjectExpression", {properties:a || []}, start, end)] },
        peg$c165 = function(c) {return c},
        peg$c166 = function(a, b) { return [a].concat(b) },
        peg$c167 = function(start, callee, args, end) { return node("NewExpression", {callee:callee,arguments:args || null}, start, end) },
        peg$c168 = function(start, name, end) { return node('ImportExpression', {name:name}, start, end) },
        peg$c169 = function(start, f, end) {
                var args;
                if (f.params != null)
                    args = f.params.map(function(x){ return x.name != null ? clone(x) : error("do parameters must be Identifiers") })
                else
                    args = []
                return node("CallExpression", {callee:f,arguments:args}, start, end)
            },
        peg$c170 = function(start, f, end) {
                return node("UndoStatement", {callee:f}, start, end)
            },
        peg$c171 = "->",
        peg$c172 = { type: "literal", value: "->", description: "\"->\"" },
        peg$c173 = function() { return false },
        peg$c174 = "=>",
        peg$c175 = { type: "literal", value: "=>", description: "\"=>\"" },
        peg$c176 = function() { return true },
        peg$c177 = function(start, template, id, params, bound, body, end) {
                if (params == null) params = []
                paramPatterns = params.map(function(x) { return x[0] })
                paramDefaults = params.map(function(x) { return x[1] })
                // convert expression closures to return statements in a block
                if (body == null)
                    body = node('BlockStatement', {body:[]})
                else if (body.type === 'ThrowStatement')
                    body = node('BlockStatement', {body:[body]})
                else if (body.type !== 'BlockStatement')
                    body = node('BlockStatement', {body:[node('ReturnStatement', {argument:body})]})

                let quotedId = null
                if (typeof id == 'string') {
                    quotedId = id
                    id = undefined
                }
                let expression = node('FunctionExpression', {id:id, params:paramPatterns, defaults:paramDefaults, body:body, bound:bound, template:template ? true : undefined}, start, end)
                // if quoted name, we will call Object.assign
                if (quotedId != null) {
                    expression = node('CallExpression', {
                        callee: node('MemberExpression', {
                            object: node('Identifier', {name:'Object'}),
                            property: node('Identifier', {name:'assign'})
                        }),
                        arguments: [
                            expression,
                            node('ObjectExpression', {
                                properties: [
                                    node('Property', {
                                        key: node('Identifier', {name:'id'}),
                                        value: node('Literal', {value:quotedId})
                                    })
                                ]
                            })
                        ]
                    })
                }
                return expression
            },
        peg$c178 = function(params) { return params != null ? params : [] },
        peg$c179 = function(param, init) { return [param,init] },
        peg$c180 = { type: "other", description: "primaryExpression" },
        peg$c181 = "`",
        peg$c182 = { type: "literal", value: "`", description: "\"`\"" },
        peg$c183 = { type: "any", description: "any character" },
        peg$c184 = function(start, a, end) { return node("JavascriptExpression", {text:text().slice(1, -1)}, start, end) },
        peg$c185 = function(start, elements, end) { return node("ArrayExpression", {elements:elements || []}, start, end) },
        peg$c186 = function(item) {return item},
        peg$c187 = "{",
        peg$c188 = { type: "literal", value: "{", description: "\"{\"" },
        peg$c189 = "}",
        peg$c190 = { type: "literal", value: "}", description: "\"}\"" },
        peg$c191 = function(start, assignments, end) { return node("ObjectExpression", {properties:assignments || []}, start, end) },
        peg$c192 = function(start, key, end) { return node("Property", { key: key, value:clone(key), kind: 'init'}, start, end) },
        peg$c193 = function(start, type, properties, end) { return node("ObjectExpression", {objectType:type,properties:properties.body}, start, end) },
        peg$c194 = function(start, properties, end) { return node("ObjectExpression", {properties:properties.body}, start, end) },
        peg$c195 = { type: "other", description: "group" },
        peg$c196 = function(expression) { return expression },
        peg$c197 = function(value) { return value },
        peg$c198 = function(start, name, end) { return node("Identifier", {name:name}, start, end) },
        peg$c199 = { type: "other", description: "this" },
        peg$c200 = "@@",
        peg$c201 = { type: "literal", value: "@@", description: "\"@@\"" },
        peg$c202 = function(start, property, end) { return thisExpression(start, end, "constructor", property) },
        peg$c203 = "@",
        peg$c204 = { type: "literal", value: "@", description: "\"@\"" },
        peg$c205 = function(start, property, end) { return thisExpression(start, end, property) },
        peg$c206 = function(start, end) { return thisExpression(start, end, "constructor") },
        peg$c207 = function(start, end) { return thisExpression(start, end) },
        peg$c208 = { type: "other", description: "literal" },
        peg$c209 = function(start, value, end) { return node('Literal', {value:value}, start, end) },
        peg$c210 = function(start, end) { return node('UnaryExpression', {operator:'void', prefix:true, argument:node('Literal', {value:0}, start, end)}, start, end) },
        peg$c211 = function() { return {line:line(),column:column()-1} },
        peg$c212 = function() { return offset() },
        peg$c213 = function(a, b) { return new RegExp(a, b) },
        peg$c214 = "\\",
        peg$c215 = { type: "literal", value: "\\", description: "\"\\\\\"" },
        peg$c216 = /^[^\/]/,
        peg$c217 = { type: "class", value: "[^\\/]", description: "[^\\/]" },
        peg$c218 = /^[gimy]/,
        peg$c219 = { type: "class", value: "[gimy]", description: "[gimy]" },
        peg$c220 = "'",
        peg$c221 = { type: "literal", value: "'", description: "\"'\"" },
        peg$c222 = /^['\\\/bfnrt]/,
        peg$c223 = { type: "class", value: "['\\\\\\/bfnrt]", description: "['\\\\\\/bfnrt]" },
        peg$c224 = "u",
        peg$c225 = { type: "literal", value: "u", description: "\"u\"" },
        peg$c226 = /^[^'\\\r\n]/,
        peg$c227 = { type: "class", value: "[^'\\\\\\r\\n]", description: "[^'\\\\\\r\\n]" },
        peg$c228 = function(content) { return eval(text()) },
        peg$c229 = "\"",
        peg$c230 = { type: "literal", value: "\"", description: "\"\\\"\"" },
        peg$c231 = /^["\\\/bfnrt]/,
        peg$c232 = { type: "class", value: "[\"\\\\\\/bfnrt]", description: "[\"\\\\\\/bfnrt]" },
        peg$c233 = /^[^"\\\r\n]/,
        peg$c234 = { type: "class", value: "[^\"\\\\\\r\\n]", description: "[^\"\\\\\\r\\n]" },
        peg$c235 = function(content) { return JSON.parse(text()) },
        peg$c236 = "\"\"",
        peg$c237 = { type: "literal", value: "\"\"", description: "\"\\\"\\\"\"" },
        peg$c238 = function(start, content, end) { return concatenate(unindent(content)) },
        peg$c239 = function(a) { return Array.prototype.concat.apply([], a) },
        peg$c240 = "{{",
        peg$c241 = { type: "literal", value: "{{", description: "\"{{\"" },
        peg$c242 = function() { return text() },
        peg$c243 = "''",
        peg$c244 = { type: "literal", value: "''", description: "\"''\"" },
        peg$c245 = "}}",
        peg$c246 = { type: "literal", value: "}}", description: "\"}}\"" },
        peg$c247 = function(a) { return concatenate(a) },
        peg$c248 = function() { return JSON.parse('"' + text() + '"') },
        peg$c249 = /^[+\-]/,
        peg$c250 = { type: "class", value: "[+\\-]", description: "[+\\-]" },
        peg$c251 = /^[eE]/,
        peg$c252 = { type: "class", value: "[eE]", description: "[eE]" },
        peg$c253 = function() { return parseFloat(text()) },
        peg$c254 = function() { return parseInt(text()) },
        peg$c255 = /^[0-9]/,
        peg$c256 = { type: "class", value: "[0-9]", description: "[0-9]" },
        peg$c257 = "0",
        peg$c258 = { type: "literal", value: "0", description: "\"0\"" },
        peg$c259 = "0x",
        peg$c260 = { type: "literal", value: "0x", description: "\"0x\"" },
        peg$c261 = function() { return parseInt(text(), 16) },
        peg$c262 = /^[0-9a-fA-F]/,
        peg$c263 = { type: "class", value: "[0-9a-fA-F]", description: "[0-9a-fA-F]" },
        peg$c264 = { type: "other", description: "identifier" },
        peg$c265 = { type: "other", description: "identifierName" },
        peg$c266 = /^[$_]/,
        peg$c267 = { type: "class", value: "[$_]", description: "[$_]" },
        peg$c268 = "\\u",
        peg$c269 = { type: "literal", value: "\\u", description: "\"\\\\u\"" },
        peg$c270 = function(h0, h1, h2, h3) { return String.fromCharCode(parseInt(h0 + h1 + h2 + h3, 16)); },
        peg$c271 = /^[A-Z\xC0-\xD6\xD8-\xDE\u0100\u0102\u0104\u0106\u0108\u010A\u010C\u010E\u0110\u0112\u0114\u0116\u0118\u011A\u011C\u011E\u0120\u0122\u0124\u0126\u0128\u012A\u012C\u012E\u0130\u0132\u0134\u0136\u0139\u013B\u013D\u013F\u0141\u0143\u0145\u0147\u014A\u014C\u014E\u0150\u0152\u0154\u0156\u0158\u015A\u015C\u015E\u0160\u0162\u0164\u0166\u0168\u016A\u016C\u016E\u0170\u0172\u0174\u0176\u0178\u0179\u017B\u017D\u0181\u0182\u0184\u0186\u0187\u0189-\u018B\u018E-\u0191\u0193\u0194\u0196-\u0198\u019C\u019D\u019F\u01A0\u01A2\u01A4\u01A6\u01A7\u01A9\u01AC\u01AE\u01AF\u01B1-\u01B3\u01B5\u01B7\u01B8\u01BC\u01C4\u01C7\u01CA\u01CD\u01CF\u01D1\u01D3\u01D5\u01D7\u01D9\u01DB\u01DE\u01E0\u01E2\u01E4\u01E6\u01E8\u01EA\u01EC\u01EE\u01F1\u01F4\u01F6-\u01F8\u01FA\u01FC\u01FE\u0200\u0202\u0204\u0206\u0208\u020A\u020C\u020E\u0210\u0212\u0214\u0216\u0218\u021A\u021C\u021E\u0220\u0222\u0224\u0226\u0228\u022A\u022C\u022E\u0230\u0232\u023A\u023B\u023D\u023E\u0241\u0243-\u0246\u0248\u024A\u024C\u024E\u0370\u0372\u0376\u0386\u0388-\u038A\u038C\u038E\u038F\u0391-\u03A1\u03A3-\u03AB\u03CF\u03D2-\u03D4\u03D8\u03DA\u03DC\u03DE\u03E0\u03E2\u03E4\u03E6\u03E8\u03EA\u03EC\u03EE\u03F4\u03F7\u03F9\u03FA\u03FD-\u042F\u0460\u0462\u0464\u0466\u0468\u046A\u046C\u046E\u0470\u0472\u0474\u0476\u0478\u047A\u047C\u047E\u0480\u048A\u048C\u048E\u0490\u0492\u0494\u0496\u0498\u049A\u049C\u049E\u04A0\u04A2\u04A4\u04A6\u04A8\u04AA\u04AC\u04AE\u04B0\u04B2\u04B4\u04B6\u04B8\u04BA\u04BC\u04BE\u04C0\u04C1\u04C3\u04C5\u04C7\u04C9\u04CB\u04CD\u04D0\u04D2\u04D4\u04D6\u04D8\u04DA\u04DC\u04DE\u04E0\u04E2\u04E4\u04E6\u04E8\u04EA\u04EC\u04EE\u04F0\u04F2\u04F4\u04F6\u04F8\u04FA\u04FC\u04FE\u0500\u0502\u0504\u0506\u0508\u050A\u050C\u050E\u0510\u0512\u0514\u0516\u0518\u051A\u051C\u051E\u0520\u0522\u0524\u0526\u0531-\u0556\u10A0-\u10C5\u1E00\u1E02\u1E04\u1E06\u1E08\u1E0A\u1E0C\u1E0E\u1E10\u1E12\u1E14\u1E16\u1E18\u1E1A\u1E1C\u1E1E\u1E20\u1E22\u1E24\u1E26\u1E28\u1E2A\u1E2C\u1E2E\u1E30\u1E32\u1E34\u1E36\u1E38\u1E3A\u1E3C\u1E3E\u1E40\u1E42\u1E44\u1E46\u1E48\u1E4A\u1E4C\u1E4E\u1E50\u1E52\u1E54\u1E56\u1E58\u1E5A\u1E5C\u1E5E\u1E60\u1E62\u1E64\u1E66\u1E68\u1E6A\u1E6C\u1E6E\u1E70\u1E72\u1E74\u1E76\u1E78\u1E7A\u1E7C\u1E7E\u1E80\u1E82\u1E84\u1E86\u1E88\u1E8A\u1E8C\u1E8E\u1E90\u1E92\u1E94\u1E9E\u1EA0\u1EA2\u1EA4\u1EA6\u1EA8\u1EAA\u1EAC\u1EAE\u1EB0\u1EB2\u1EB4\u1EB6\u1EB8\u1EBA\u1EBC\u1EBE\u1EC0\u1EC2\u1EC4\u1EC6\u1EC8\u1ECA\u1ECC\u1ECE\u1ED0\u1ED2\u1ED4\u1ED6\u1ED8\u1EDA\u1EDC\u1EDE\u1EE0\u1EE2\u1EE4\u1EE6\u1EE8\u1EEA\u1EEC\u1EEE\u1EF0\u1EF2\u1EF4\u1EF6\u1EF8\u1EFA\u1EFC\u1EFE\u1F08-\u1F0F\u1F18-\u1F1D\u1F28-\u1F2F\u1F38-\u1F3F\u1F48-\u1F4D\u1F59\u1F5B\u1F5D\u1F5F\u1F68-\u1F6F\u1FB8-\u1FBB\u1FC8-\u1FCB\u1FD8-\u1FDB\u1FE8-\u1FEC\u1FF8-\u1FFB\u2102\u2107\u210B-\u210D\u2110-\u2112\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u2130-\u2133\u213E\u213F\u2145\u2183\u2C00-\u2C2E\u2C60\u2C62-\u2C64\u2C67\u2C69\u2C6B\u2C6D-\u2C70\u2C72\u2C75\u2C7E-\u2C80\u2C82\u2C84\u2C86\u2C88\u2C8A\u2C8C\u2C8E\u2C90\u2C92\u2C94\u2C96\u2C98\u2C9A\u2C9C\u2C9E\u2CA0\u2CA2\u2CA4\u2CA6\u2CA8\u2CAA\u2CAC\u2CAE\u2CB0\u2CB2\u2CB4\u2CB6\u2CB8\u2CBA\u2CBC\u2CBE\u2CC0\u2CC2\u2CC4\u2CC6\u2CC8\u2CCA\u2CCC\u2CCE\u2CD0\u2CD2\u2CD4\u2CD6\u2CD8\u2CDA\u2CDC\u2CDE\u2CE0\u2CE2\u2CEB\u2CED\uA640\uA642\uA644\uA646\uA648\uA64A\uA64C\uA64E\uA650\uA652\uA654\uA656\uA658\uA65A\uA65C\uA65E\uA660\uA662\uA664\uA666\uA668\uA66A\uA66C\uA680\uA682\uA684\uA686\uA688\uA68A\uA68C\uA68E\uA690\uA692\uA694\uA696\uA722\uA724\uA726\uA728\uA72A\uA72C\uA72E\uA732\uA734\uA736\uA738\uA73A\uA73C\uA73E\uA740\uA742\uA744\uA746\uA748\uA74A\uA74C\uA74E\uA750\uA752\uA754\uA756\uA758\uA75A\uA75C\uA75E\uA760\uA762\uA764\uA766\uA768\uA76A\uA76C\uA76E\uA779\uA77B\uA77D\uA77E\uA780\uA782\uA784\uA786\uA78B\uA78D\uA790\uA7A0\uA7A2\uA7A4\uA7A6\uA7A8\uFF21-\uFF3Aa-z\xAA\xB5\xBA\xDF-\xF6\xF8-\xFF\u0101\u0103\u0105\u0107\u0109\u010B\u010D\u010F\u0111\u0113\u0115\u0117\u0119\u011B\u011D\u011F\u0121\u0123\u0125\u0127\u0129\u012B\u012D\u012F\u0131\u0133\u0135\u0137\u0138\u013A\u013C\u013E\u0140\u0142\u0144\u0146\u0148\u0149\u014B\u014D\u014F\u0151\u0153\u0155\u0157\u0159\u015B\u015D\u015F\u0161\u0163\u0165\u0167\u0169\u016B\u016D\u016F\u0171\u0173\u0175\u0177\u017A\u017C\u017E-\u0180\u0183\u0185\u0188\u018C\u018D\u0192\u0195\u0199-\u019B\u019E\u01A1\u01A3\u01A5\u01A8\u01AA\u01AB\u01AD\u01B0\u01B4\u01B6\u01B9\u01BA\u01BD-\u01BF\u01C6\u01C9\u01CC\u01CE\u01D0\u01D2\u01D4\u01D6\u01D8\u01DA\u01DC\u01DD\u01DF\u01E1\u01E3\u01E5\u01E7\u01E9\u01EB\u01ED\u01EF\u01F0\u01F3\u01F5\u01F9\u01FB\u01FD\u01FF\u0201\u0203\u0205\u0207\u0209\u020B\u020D\u020F\u0211\u0213\u0215\u0217\u0219\u021B\u021D\u021F\u0221\u0223\u0225\u0227\u0229\u022B\u022D\u022F\u0231\u0233-\u0239\u023C\u023F\u0240\u0242\u0247\u0249\u024B\u024D\u024F-\u0293\u0295-\u02AF\u0371\u0373\u0377\u037B-\u037D\u0390\u03AC-\u03CE\u03D0\u03D1\u03D5-\u03D7\u03D9\u03DB\u03DD\u03DF\u03E1\u03E3\u03E5\u03E7\u03E9\u03EB\u03ED\u03EF-\u03F3\u03F5\u03F8\u03FB\u03FC\u0430-\u045F\u0461\u0463\u0465\u0467\u0469\u046B\u046D\u046F\u0471\u0473\u0475\u0477\u0479\u047B\u047D\u047F\u0481\u048B\u048D\u048F\u0491\u0493\u0495\u0497\u0499\u049B\u049D\u049F\u04A1\u04A3\u04A5\u04A7\u04A9\u04AB\u04AD\u04AF\u04B1\u04B3\u04B5\u04B7\u04B9\u04BB\u04BD\u04BF\u04C2\u04C4\u04C6\u04C8\u04CA\u04CC\u04CE\u04CF\u04D1\u04D3\u04D5\u04D7\u04D9\u04DB\u04DD\u04DF\u04E1\u04E3\u04E5\u04E7\u04E9\u04EB\u04ED\u04EF\u04F1\u04F3\u04F5\u04F7\u04F9\u04FB\u04FD\u04FF\u0501\u0503\u0505\u0507\u0509\u050B\u050D\u050F\u0511\u0513\u0515\u0517\u0519\u051B\u051D\u051F\u0521\u0523\u0525\u0527\u0561-\u0587\u1D00-\u1D2B\u1D62-\u1D77\u1D79-\u1D9A\u1E01\u1E03\u1E05\u1E07\u1E09\u1E0B\u1E0D\u1E0F\u1E11\u1E13\u1E15\u1E17\u1E19\u1E1B\u1E1D\u1E1F\u1E21\u1E23\u1E25\u1E27\u1E29\u1E2B\u1E2D\u1E2F\u1E31\u1E33\u1E35\u1E37\u1E39\u1E3B\u1E3D\u1E3F\u1E41\u1E43\u1E45\u1E47\u1E49\u1E4B\u1E4D\u1E4F\u1E51\u1E53\u1E55\u1E57\u1E59\u1E5B\u1E5D\u1E5F\u1E61\u1E63\u1E65\u1E67\u1E69\u1E6B\u1E6D\u1E6F\u1E71\u1E73\u1E75\u1E77\u1E79\u1E7B\u1E7D\u1E7F\u1E81\u1E83\u1E85\u1E87\u1E89\u1E8B\u1E8D\u1E8F\u1E91\u1E93\u1E95-\u1E9D\u1E9F\u1EA1\u1EA3\u1EA5\u1EA7\u1EA9\u1EAB\u1EAD\u1EAF\u1EB1\u1EB3\u1EB5\u1EB7\u1EB9\u1EBB\u1EBD\u1EBF\u1EC1\u1EC3\u1EC5\u1EC7\u1EC9\u1ECB\u1ECD\u1ECF\u1ED1\u1ED3\u1ED5\u1ED7\u1ED9\u1EDB\u1EDD\u1EDF\u1EE1\u1EE3\u1EE5\u1EE7\u1EE9\u1EEB\u1EED\u1EEF\u1EF1\u1EF3\u1EF5\u1EF7\u1EF9\u1EFB\u1EFD\u1EFF-\u1F07\u1F10-\u1F15\u1F20-\u1F27\u1F30-\u1F37\u1F40-\u1F45\u1F50-\u1F57\u1F60-\u1F67\u1F70-\u1F7D\u1F80-\u1F87\u1F90-\u1F97\u1FA0-\u1FA7\u1FB0-\u1FB4\u1FB6\u1FB7\u1FBE\u1FC2-\u1FC4\u1FC6\u1FC7\u1FD0-\u1FD3\u1FD6\u1FD7\u1FE0-\u1FE7\u1FF2-\u1FF4\u1FF6\u1FF7\u210A\u210E\u210F\u2113\u212F\u2134\u2139\u213C\u213D\u2146-\u2149\u214E\u2184\u2C30-\u2C5E\u2C61\u2C65\u2C66\u2C68\u2C6A\u2C6C\u2C71\u2C73\u2C74\u2C76-\u2C7C\u2C81\u2C83\u2C85\u2C87\u2C89\u2C8B\u2C8D\u2C8F\u2C91\u2C93\u2C95\u2C97\u2C99\u2C9B\u2C9D\u2C9F\u2CA1\u2CA3\u2CA5\u2CA7\u2CA9\u2CAB\u2CAD\u2CAF\u2CB1\u2CB3\u2CB5\u2CB7\u2CB9\u2CBB\u2CBD\u2CBF\u2CC1\u2CC3\u2CC5\u2CC7\u2CC9\u2CCB\u2CCD\u2CCF\u2CD1\u2CD3\u2CD5\u2CD7\u2CD9\u2CDB\u2CDD\u2CDF\u2CE1\u2CE3\u2CE4\u2CEC\u2CEE\u2D00-\u2D25\uA641\uA643\uA645\uA647\uA649\uA64B\uA64D\uA64F\uA651\uA653\uA655\uA657\uA659\uA65B\uA65D\uA65F\uA661\uA663\uA665\uA667\uA669\uA66B\uA66D\uA681\uA683\uA685\uA687\uA689\uA68B\uA68D\uA68F\uA691\uA693\uA695\uA697\uA723\uA725\uA727\uA729\uA72B\uA72D\uA72F-\uA731\uA733\uA735\uA737\uA739\uA73B\uA73D\uA73F\uA741\uA743\uA745\uA747\uA749\uA74B\uA74D\uA74F\uA751\uA753\uA755\uA757\uA759\uA75B\uA75D\uA75F\uA761\uA763\uA765\uA767\uA769\uA76B\uA76D\uA76F\uA771-\uA778\uA77A\uA77C\uA77F\uA781\uA783\uA785\uA787\uA78C\uA78E\uA791\uA7A1\uA7A3\uA7A5\uA7A7\uA7A9\uA7FA\uFB00-\uFB06\uFB13-\uFB17\uFF41-\uFF5A\u01C5\u01C8\u01CB\u01F2\u1F88-\u1F8F\u1F98-\u1F9F\u1FA8-\u1FAF\u1FBC\u1FCC\u1FFC\u02B0-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0374\u037A\u0559\u0640\u06E5\u06E6\u07F4\u07F5\u07FA\u081A\u0824\u0828\u0971\u0E46\u0EC6\u10FC\u17D7\u1843\u1AA7\u1C78-\u1C7D\u1D2C-\u1D61\u1D78\u1D9B-\u1DBF\u2071\u207F\u2090-\u209C\u2C7D\u2D6F\u2E2F\u3005\u3031-\u3035\u303B\u309D\u309E\u30FC-\u30FE\uA015\uA4F8-\uA4FD\uA60C\uA67F\uA717-\uA71F\uA770\uA788\uA9CF\uAA70\uAADD\uFF70\uFF9E\uFF9F\u01BB\u01C0-\u01C3\u0294\u05D0-\u05EA\u05F0-\u05F2\u0620-\u063F\u0641-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u0800-\u0815\u0840-\u0858\u0904-\u0939\u093D\u0950\u0958-\u0961\u0972-\u0977\u0979-\u097F\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C33\u0C35-\u0C39\u0C3D\u0C58\u0C59\u0C60\u0C61\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D60\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E45\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EDC\u0EDD\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10D0-\u10FA\u1100-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F4\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17DC\u1820-\u1842\u1844-\u1877\u1880-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191C\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19C1-\u19C7\u1A00-\u1A16\u1A20-\u1A54\u1B05-\u1B33\u1B45-\u1B4B\u1B83-\u1BA0\u1BAE\u1BAF\u1BC0-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C77\u1CE9-\u1CEC\u1CEE-\u1CF1\u2135-\u2138\u2D30-\u2D65\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u3006\u303C\u3041-\u3096\u309F\u30A1-\u30FA\u30FF\u3105-\u312D\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400\u4DB5\u4E00\u9FCB\uA000-\uA014\uA016-\uA48C\uA4D0-\uA4F7\uA500-\uA60B\uA610-\uA61F\uA62A\uA62B\uA66E\uA6A0-\uA6E5\uA7FB-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA6F\uAA71-\uAA76\uAA7A\uAA80-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB\uAADC\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uABC0-\uABE2\uAC00\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA2D\uFA30-\uFA6D\uFA70-\uFAD9\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF66-\uFF6F\uFF71-\uFF9D\uFFA0-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC\u16EE-\u16F0\u2160-\u2182\u2185-\u2188\u3007\u3021-\u3029\u3038-\u303A\uA6E6-\uA6EF]/,
        peg$c272 = { type: "class", value: "[A-Z\\xC0-\\xD6\\xD8-\\xDE\\u0100\\u0102\\u0104\\u0106\\u0108\\u010A\\u010C\\u010E\\u0110\\u0112\\u0114\\u0116\\u0118\\u011A\\u011C\\u011E\\u0120\\u0122\\u0124\\u0126\\u0128\\u012A\\u012C\\u012E\\u0130\\u0132\\u0134\\u0136\\u0139\\u013B\\u013D\\u013F\\u0141\\u0143\\u0145\\u0147\\u014A\\u014C\\u014E\\u0150\\u0152\\u0154\\u0156\\u0158\\u015A\\u015C\\u015E\\u0160\\u0162\\u0164\\u0166\\u0168\\u016A\\u016C\\u016E\\u0170\\u0172\\u0174\\u0176\\u0178\\u0179\\u017B\\u017D\\u0181\\u0182\\u0184\\u0186\\u0187\\u0189-\\u018B\\u018E-\\u0191\\u0193\\u0194\\u0196-\\u0198\\u019C\\u019D\\u019F\\u01A0\\u01A2\\u01A4\\u01A6\\u01A7\\u01A9\\u01AC\\u01AE\\u01AF\\u01B1-\\u01B3\\u01B5\\u01B7\\u01B8\\u01BC\\u01C4\\u01C7\\u01CA\\u01CD\\u01CF\\u01D1\\u01D3\\u01D5\\u01D7\\u01D9\\u01DB\\u01DE\\u01E0\\u01E2\\u01E4\\u01E6\\u01E8\\u01EA\\u01EC\\u01EE\\u01F1\\u01F4\\u01F6-\\u01F8\\u01FA\\u01FC\\u01FE\\u0200\\u0202\\u0204\\u0206\\u0208\\u020A\\u020C\\u020E\\u0210\\u0212\\u0214\\u0216\\u0218\\u021A\\u021C\\u021E\\u0220\\u0222\\u0224\\u0226\\u0228\\u022A\\u022C\\u022E\\u0230\\u0232\\u023A\\u023B\\u023D\\u023E\\u0241\\u0243-\\u0246\\u0248\\u024A\\u024C\\u024E\\u0370\\u0372\\u0376\\u0386\\u0388-\\u038A\\u038C\\u038E\\u038F\\u0391-\\u03A1\\u03A3-\\u03AB\\u03CF\\u03D2-\\u03D4\\u03D8\\u03DA\\u03DC\\u03DE\\u03E0\\u03E2\\u03E4\\u03E6\\u03E8\\u03EA\\u03EC\\u03EE\\u03F4\\u03F7\\u03F9\\u03FA\\u03FD-\\u042F\\u0460\\u0462\\u0464\\u0466\\u0468\\u046A\\u046C\\u046E\\u0470\\u0472\\u0474\\u0476\\u0478\\u047A\\u047C\\u047E\\u0480\\u048A\\u048C\\u048E\\u0490\\u0492\\u0494\\u0496\\u0498\\u049A\\u049C\\u049E\\u04A0\\u04A2\\u04A4\\u04A6\\u04A8\\u04AA\\u04AC\\u04AE\\u04B0\\u04B2\\u04B4\\u04B6\\u04B8\\u04BA\\u04BC\\u04BE\\u04C0\\u04C1\\u04C3\\u04C5\\u04C7\\u04C9\\u04CB\\u04CD\\u04D0\\u04D2\\u04D4\\u04D6\\u04D8\\u04DA\\u04DC\\u04DE\\u04E0\\u04E2\\u04E4\\u04E6\\u04E8\\u04EA\\u04EC\\u04EE\\u04F0\\u04F2\\u04F4\\u04F6\\u04F8\\u04FA\\u04FC\\u04FE\\u0500\\u0502\\u0504\\u0506\\u0508\\u050A\\u050C\\u050E\\u0510\\u0512\\u0514\\u0516\\u0518\\u051A\\u051C\\u051E\\u0520\\u0522\\u0524\\u0526\\u0531-\\u0556\\u10A0-\\u10C5\\u1E00\\u1E02\\u1E04\\u1E06\\u1E08\\u1E0A\\u1E0C\\u1E0E\\u1E10\\u1E12\\u1E14\\u1E16\\u1E18\\u1E1A\\u1E1C\\u1E1E\\u1E20\\u1E22\\u1E24\\u1E26\\u1E28\\u1E2A\\u1E2C\\u1E2E\\u1E30\\u1E32\\u1E34\\u1E36\\u1E38\\u1E3A\\u1E3C\\u1E3E\\u1E40\\u1E42\\u1E44\\u1E46\\u1E48\\u1E4A\\u1E4C\\u1E4E\\u1E50\\u1E52\\u1E54\\u1E56\\u1E58\\u1E5A\\u1E5C\\u1E5E\\u1E60\\u1E62\\u1E64\\u1E66\\u1E68\\u1E6A\\u1E6C\\u1E6E\\u1E70\\u1E72\\u1E74\\u1E76\\u1E78\\u1E7A\\u1E7C\\u1E7E\\u1E80\\u1E82\\u1E84\\u1E86\\u1E88\\u1E8A\\u1E8C\\u1E8E\\u1E90\\u1E92\\u1E94\\u1E9E\\u1EA0\\u1EA2\\u1EA4\\u1EA6\\u1EA8\\u1EAA\\u1EAC\\u1EAE\\u1EB0\\u1EB2\\u1EB4\\u1EB6\\u1EB8\\u1EBA\\u1EBC\\u1EBE\\u1EC0\\u1EC2\\u1EC4\\u1EC6\\u1EC8\\u1ECA\\u1ECC\\u1ECE\\u1ED0\\u1ED2\\u1ED4\\u1ED6\\u1ED8\\u1EDA\\u1EDC\\u1EDE\\u1EE0\\u1EE2\\u1EE4\\u1EE6\\u1EE8\\u1EEA\\u1EEC\\u1EEE\\u1EF0\\u1EF2\\u1EF4\\u1EF6\\u1EF8\\u1EFA\\u1EFC\\u1EFE\\u1F08-\\u1F0F\\u1F18-\\u1F1D\\u1F28-\\u1F2F\\u1F38-\\u1F3F\\u1F48-\\u1F4D\\u1F59\\u1F5B\\u1F5D\\u1F5F\\u1F68-\\u1F6F\\u1FB8-\\u1FBB\\u1FC8-\\u1FCB\\u1FD8-\\u1FDB\\u1FE8-\\u1FEC\\u1FF8-\\u1FFB\\u2102\\u2107\\u210B-\\u210D\\u2110-\\u2112\\u2115\\u2119-\\u211D\\u2124\\u2126\\u2128\\u212A-\\u212D\\u2130-\\u2133\\u213E\\u213F\\u2145\\u2183\\u2C00-\\u2C2E\\u2C60\\u2C62-\\u2C64\\u2C67\\u2C69\\u2C6B\\u2C6D-\\u2C70\\u2C72\\u2C75\\u2C7E-\\u2C80\\u2C82\\u2C84\\u2C86\\u2C88\\u2C8A\\u2C8C\\u2C8E\\u2C90\\u2C92\\u2C94\\u2C96\\u2C98\\u2C9A\\u2C9C\\u2C9E\\u2CA0\\u2CA2\\u2CA4\\u2CA6\\u2CA8\\u2CAA\\u2CAC\\u2CAE\\u2CB0\\u2CB2\\u2CB4\\u2CB6\\u2CB8\\u2CBA\\u2CBC\\u2CBE\\u2CC0\\u2CC2\\u2CC4\\u2CC6\\u2CC8\\u2CCA\\u2CCC\\u2CCE\\u2CD0\\u2CD2\\u2CD4\\u2CD6\\u2CD8\\u2CDA\\u2CDC\\u2CDE\\u2CE0\\u2CE2\\u2CEB\\u2CED\\uA640\\uA642\\uA644\\uA646\\uA648\\uA64A\\uA64C\\uA64E\\uA650\\uA652\\uA654\\uA656\\uA658\\uA65A\\uA65C\\uA65E\\uA660\\uA662\\uA664\\uA666\\uA668\\uA66A\\uA66C\\uA680\\uA682\\uA684\\uA686\\uA688\\uA68A\\uA68C\\uA68E\\uA690\\uA692\\uA694\\uA696\\uA722\\uA724\\uA726\\uA728\\uA72A\\uA72C\\uA72E\\uA732\\uA734\\uA736\\uA738\\uA73A\\uA73C\\uA73E\\uA740\\uA742\\uA744\\uA746\\uA748\\uA74A\\uA74C\\uA74E\\uA750\\uA752\\uA754\\uA756\\uA758\\uA75A\\uA75C\\uA75E\\uA760\\uA762\\uA764\\uA766\\uA768\\uA76A\\uA76C\\uA76E\\uA779\\uA77B\\uA77D\\uA77E\\uA780\\uA782\\uA784\\uA786\\uA78B\\uA78D\\uA790\\uA7A0\\uA7A2\\uA7A4\\uA7A6\\uA7A8\\uFF21-\\uFF3Aa-z\\xAA\\xB5\\xBA\\xDF-\\xF6\\xF8-\\xFF\\u0101\\u0103\\u0105\\u0107\\u0109\\u010B\\u010D\\u010F\\u0111\\u0113\\u0115\\u0117\\u0119\\u011B\\u011D\\u011F\\u0121\\u0123\\u0125\\u0127\\u0129\\u012B\\u012D\\u012F\\u0131\\u0133\\u0135\\u0137\\u0138\\u013A\\u013C\\u013E\\u0140\\u0142\\u0144\\u0146\\u0148\\u0149\\u014B\\u014D\\u014F\\u0151\\u0153\\u0155\\u0157\\u0159\\u015B\\u015D\\u015F\\u0161\\u0163\\u0165\\u0167\\u0169\\u016B\\u016D\\u016F\\u0171\\u0173\\u0175\\u0177\\u017A\\u017C\\u017E-\\u0180\\u0183\\u0185\\u0188\\u018C\\u018D\\u0192\\u0195\\u0199-\\u019B\\u019E\\u01A1\\u01A3\\u01A5\\u01A8\\u01AA\\u01AB\\u01AD\\u01B0\\u01B4\\u01B6\\u01B9\\u01BA\\u01BD-\\u01BF\\u01C6\\u01C9\\u01CC\\u01CE\\u01D0\\u01D2\\u01D4\\u01D6\\u01D8\\u01DA\\u01DC\\u01DD\\u01DF\\u01E1\\u01E3\\u01E5\\u01E7\\u01E9\\u01EB\\u01ED\\u01EF\\u01F0\\u01F3\\u01F5\\u01F9\\u01FB\\u01FD\\u01FF\\u0201\\u0203\\u0205\\u0207\\u0209\\u020B\\u020D\\u020F\\u0211\\u0213\\u0215\\u0217\\u0219\\u021B\\u021D\\u021F\\u0221\\u0223\\u0225\\u0227\\u0229\\u022B\\u022D\\u022F\\u0231\\u0233-\\u0239\\u023C\\u023F\\u0240\\u0242\\u0247\\u0249\\u024B\\u024D\\u024F-\\u0293\\u0295-\\u02AF\\u0371\\u0373\\u0377\\u037B-\\u037D\\u0390\\u03AC-\\u03CE\\u03D0\\u03D1\\u03D5-\\u03D7\\u03D9\\u03DB\\u03DD\\u03DF\\u03E1\\u03E3\\u03E5\\u03E7\\u03E9\\u03EB\\u03ED\\u03EF-\\u03F3\\u03F5\\u03F8\\u03FB\\u03FC\\u0430-\\u045F\\u0461\\u0463\\u0465\\u0467\\u0469\\u046B\\u046D\\u046F\\u0471\\u0473\\u0475\\u0477\\u0479\\u047B\\u047D\\u047F\\u0481\\u048B\\u048D\\u048F\\u0491\\u0493\\u0495\\u0497\\u0499\\u049B\\u049D\\u049F\\u04A1\\u04A3\\u04A5\\u04A7\\u04A9\\u04AB\\u04AD\\u04AF\\u04B1\\u04B3\\u04B5\\u04B7\\u04B9\\u04BB\\u04BD\\u04BF\\u04C2\\u04C4\\u04C6\\u04C8\\u04CA\\u04CC\\u04CE\\u04CF\\u04D1\\u04D3\\u04D5\\u04D7\\u04D9\\u04DB\\u04DD\\u04DF\\u04E1\\u04E3\\u04E5\\u04E7\\u04E9\\u04EB\\u04ED\\u04EF\\u04F1\\u04F3\\u04F5\\u04F7\\u04F9\\u04FB\\u04FD\\u04FF\\u0501\\u0503\\u0505\\u0507\\u0509\\u050B\\u050D\\u050F\\u0511\\u0513\\u0515\\u0517\\u0519\\u051B\\u051D\\u051F\\u0521\\u0523\\u0525\\u0527\\u0561-\\u0587\\u1D00-\\u1D2B\\u1D62-\\u1D77\\u1D79-\\u1D9A\\u1E01\\u1E03\\u1E05\\u1E07\\u1E09\\u1E0B\\u1E0D\\u1E0F\\u1E11\\u1E13\\u1E15\\u1E17\\u1E19\\u1E1B\\u1E1D\\u1E1F\\u1E21\\u1E23\\u1E25\\u1E27\\u1E29\\u1E2B\\u1E2D\\u1E2F\\u1E31\\u1E33\\u1E35\\u1E37\\u1E39\\u1E3B\\u1E3D\\u1E3F\\u1E41\\u1E43\\u1E45\\u1E47\\u1E49\\u1E4B\\u1E4D\\u1E4F\\u1E51\\u1E53\\u1E55\\u1E57\\u1E59\\u1E5B\\u1E5D\\u1E5F\\u1E61\\u1E63\\u1E65\\u1E67\\u1E69\\u1E6B\\u1E6D\\u1E6F\\u1E71\\u1E73\\u1E75\\u1E77\\u1E79\\u1E7B\\u1E7D\\u1E7F\\u1E81\\u1E83\\u1E85\\u1E87\\u1E89\\u1E8B\\u1E8D\\u1E8F\\u1E91\\u1E93\\u1E95-\\u1E9D\\u1E9F\\u1EA1\\u1EA3\\u1EA5\\u1EA7\\u1EA9\\u1EAB\\u1EAD\\u1EAF\\u1EB1\\u1EB3\\u1EB5\\u1EB7\\u1EB9\\u1EBB\\u1EBD\\u1EBF\\u1EC1\\u1EC3\\u1EC5\\u1EC7\\u1EC9\\u1ECB\\u1ECD\\u1ECF\\u1ED1\\u1ED3\\u1ED5\\u1ED7\\u1ED9\\u1EDB\\u1EDD\\u1EDF\\u1EE1\\u1EE3\\u1EE5\\u1EE7\\u1EE9\\u1EEB\\u1EED\\u1EEF\\u1EF1\\u1EF3\\u1EF5\\u1EF7\\u1EF9\\u1EFB\\u1EFD\\u1EFF-\\u1F07\\u1F10-\\u1F15\\u1F20-\\u1F27\\u1F30-\\u1F37\\u1F40-\\u1F45\\u1F50-\\u1F57\\u1F60-\\u1F67\\u1F70-\\u1F7D\\u1F80-\\u1F87\\u1F90-\\u1F97\\u1FA0-\\u1FA7\\u1FB0-\\u1FB4\\u1FB6\\u1FB7\\u1FBE\\u1FC2-\\u1FC4\\u1FC6\\u1FC7\\u1FD0-\\u1FD3\\u1FD6\\u1FD7\\u1FE0-\\u1FE7\\u1FF2-\\u1FF4\\u1FF6\\u1FF7\\u210A\\u210E\\u210F\\u2113\\u212F\\u2134\\u2139\\u213C\\u213D\\u2146-\\u2149\\u214E\\u2184\\u2C30-\\u2C5E\\u2C61\\u2C65\\u2C66\\u2C68\\u2C6A\\u2C6C\\u2C71\\u2C73\\u2C74\\u2C76-\\u2C7C\\u2C81\\u2C83\\u2C85\\u2C87\\u2C89\\u2C8B\\u2C8D\\u2C8F\\u2C91\\u2C93\\u2C95\\u2C97\\u2C99\\u2C9B\\u2C9D\\u2C9F\\u2CA1\\u2CA3\\u2CA5\\u2CA7\\u2CA9\\u2CAB\\u2CAD\\u2CAF\\u2CB1\\u2CB3\\u2CB5\\u2CB7\\u2CB9\\u2CBB\\u2CBD\\u2CBF\\u2CC1\\u2CC3\\u2CC5\\u2CC7\\u2CC9\\u2CCB\\u2CCD\\u2CCF\\u2CD1\\u2CD3\\u2CD5\\u2CD7\\u2CD9\\u2CDB\\u2CDD\\u2CDF\\u2CE1\\u2CE3\\u2CE4\\u2CEC\\u2CEE\\u2D00-\\u2D25\\uA641\\uA643\\uA645\\uA647\\uA649\\uA64B\\uA64D\\uA64F\\uA651\\uA653\\uA655\\uA657\\uA659\\uA65B\\uA65D\\uA65F\\uA661\\uA663\\uA665\\uA667\\uA669\\uA66B\\uA66D\\uA681\\uA683\\uA685\\uA687\\uA689\\uA68B\\uA68D\\uA68F\\uA691\\uA693\\uA695\\uA697\\uA723\\uA725\\uA727\\uA729\\uA72B\\uA72D\\uA72F-\\uA731\\uA733\\uA735\\uA737\\uA739\\uA73B\\uA73D\\uA73F\\uA741\\uA743\\uA745\\uA747\\uA749\\uA74B\\uA74D\\uA74F\\uA751\\uA753\\uA755\\uA757\\uA759\\uA75B\\uA75D\\uA75F\\uA761\\uA763\\uA765\\uA767\\uA769\\uA76B\\uA76D\\uA76F\\uA771-\\uA778\\uA77A\\uA77C\\uA77F\\uA781\\uA783\\uA785\\uA787\\uA78C\\uA78E\\uA791\\uA7A1\\uA7A3\\uA7A5\\uA7A7\\uA7A9\\uA7FA\\uFB00-\\uFB06\\uFB13-\\uFB17\\uFF41-\\uFF5A\\u01C5\\u01C8\\u01CB\\u01F2\\u1F88-\\u1F8F\\u1F98-\\u1F9F\\u1FA8-\\u1FAF\\u1FBC\\u1FCC\\u1FFC\\u02B0-\\u02C1\\u02C6-\\u02D1\\u02E0-\\u02E4\\u02EC\\u02EE\\u0374\\u037A\\u0559\\u0640\\u06E5\\u06E6\\u07F4\\u07F5\\u07FA\\u081A\\u0824\\u0828\\u0971\\u0E46\\u0EC6\\u10FC\\u17D7\\u1843\\u1AA7\\u1C78-\\u1C7D\\u1D2C-\\u1D61\\u1D78\\u1D9B-\\u1DBF\\u2071\\u207F\\u2090-\\u209C\\u2C7D\\u2D6F\\u2E2F\\u3005\\u3031-\\u3035\\u303B\\u309D\\u309E\\u30FC-\\u30FE\\uA015\\uA4F8-\\uA4FD\\uA60C\\uA67F\\uA717-\\uA71F\\uA770\\uA788\\uA9CF\\uAA70\\uAADD\\uFF70\\uFF9E\\uFF9F\\u01BB\\u01C0-\\u01C3\\u0294\\u05D0-\\u05EA\\u05F0-\\u05F2\\u0620-\\u063F\\u0641-\\u064A\\u066E\\u066F\\u0671-\\u06D3\\u06D5\\u06EE\\u06EF\\u06FA-\\u06FC\\u06FF\\u0710\\u0712-\\u072F\\u074D-\\u07A5\\u07B1\\u07CA-\\u07EA\\u0800-\\u0815\\u0840-\\u0858\\u0904-\\u0939\\u093D\\u0950\\u0958-\\u0961\\u0972-\\u0977\\u0979-\\u097F\\u0985-\\u098C\\u098F\\u0990\\u0993-\\u09A8\\u09AA-\\u09B0\\u09B2\\u09B6-\\u09B9\\u09BD\\u09CE\\u09DC\\u09DD\\u09DF-\\u09E1\\u09F0\\u09F1\\u0A05-\\u0A0A\\u0A0F\\u0A10\\u0A13-\\u0A28\\u0A2A-\\u0A30\\u0A32\\u0A33\\u0A35\\u0A36\\u0A38\\u0A39\\u0A59-\\u0A5C\\u0A5E\\u0A72-\\u0A74\\u0A85-\\u0A8D\\u0A8F-\\u0A91\\u0A93-\\u0AA8\\u0AAA-\\u0AB0\\u0AB2\\u0AB3\\u0AB5-\\u0AB9\\u0ABD\\u0AD0\\u0AE0\\u0AE1\\u0B05-\\u0B0C\\u0B0F\\u0B10\\u0B13-\\u0B28\\u0B2A-\\u0B30\\u0B32\\u0B33\\u0B35-\\u0B39\\u0B3D\\u0B5C\\u0B5D\\u0B5F-\\u0B61\\u0B71\\u0B83\\u0B85-\\u0B8A\\u0B8E-\\u0B90\\u0B92-\\u0B95\\u0B99\\u0B9A\\u0B9C\\u0B9E\\u0B9F\\u0BA3\\u0BA4\\u0BA8-\\u0BAA\\u0BAE-\\u0BB9\\u0BD0\\u0C05-\\u0C0C\\u0C0E-\\u0C10\\u0C12-\\u0C28\\u0C2A-\\u0C33\\u0C35-\\u0C39\\u0C3D\\u0C58\\u0C59\\u0C60\\u0C61\\u0C85-\\u0C8C\\u0C8E-\\u0C90\\u0C92-\\u0CA8\\u0CAA-\\u0CB3\\u0CB5-\\u0CB9\\u0CBD\\u0CDE\\u0CE0\\u0CE1\\u0CF1\\u0CF2\\u0D05-\\u0D0C\\u0D0E-\\u0D10\\u0D12-\\u0D3A\\u0D3D\\u0D4E\\u0D60\\u0D61\\u0D7A-\\u0D7F\\u0D85-\\u0D96\\u0D9A-\\u0DB1\\u0DB3-\\u0DBB\\u0DBD\\u0DC0-\\u0DC6\\u0E01-\\u0E30\\u0E32\\u0E33\\u0E40-\\u0E45\\u0E81\\u0E82\\u0E84\\u0E87\\u0E88\\u0E8A\\u0E8D\\u0E94-\\u0E97\\u0E99-\\u0E9F\\u0EA1-\\u0EA3\\u0EA5\\u0EA7\\u0EAA\\u0EAB\\u0EAD-\\u0EB0\\u0EB2\\u0EB3\\u0EBD\\u0EC0-\\u0EC4\\u0EDC\\u0EDD\\u0F00\\u0F40-\\u0F47\\u0F49-\\u0F6C\\u0F88-\\u0F8C\\u1000-\\u102A\\u103F\\u1050-\\u1055\\u105A-\\u105D\\u1061\\u1065\\u1066\\u106E-\\u1070\\u1075-\\u1081\\u108E\\u10D0-\\u10FA\\u1100-\\u1248\\u124A-\\u124D\\u1250-\\u1256\\u1258\\u125A-\\u125D\\u1260-\\u1288\\u128A-\\u128D\\u1290-\\u12B0\\u12B2-\\u12B5\\u12B8-\\u12BE\\u12C0\\u12C2-\\u12C5\\u12C8-\\u12D6\\u12D8-\\u1310\\u1312-\\u1315\\u1318-\\u135A\\u1380-\\u138F\\u13A0-\\u13F4\\u1401-\\u166C\\u166F-\\u167F\\u1681-\\u169A\\u16A0-\\u16EA\\u1700-\\u170C\\u170E-\\u1711\\u1720-\\u1731\\u1740-\\u1751\\u1760-\\u176C\\u176E-\\u1770\\u1780-\\u17B3\\u17DC\\u1820-\\u1842\\u1844-\\u1877\\u1880-\\u18A8\\u18AA\\u18B0-\\u18F5\\u1900-\\u191C\\u1950-\\u196D\\u1970-\\u1974\\u1980-\\u19AB\\u19C1-\\u19C7\\u1A00-\\u1A16\\u1A20-\\u1A54\\u1B05-\\u1B33\\u1B45-\\u1B4B\\u1B83-\\u1BA0\\u1BAE\\u1BAF\\u1BC0-\\u1BE5\\u1C00-\\u1C23\\u1C4D-\\u1C4F\\u1C5A-\\u1C77\\u1CE9-\\u1CEC\\u1CEE-\\u1CF1\\u2135-\\u2138\\u2D30-\\u2D65\\u2D80-\\u2D96\\u2DA0-\\u2DA6\\u2DA8-\\u2DAE\\u2DB0-\\u2DB6\\u2DB8-\\u2DBE\\u2DC0-\\u2DC6\\u2DC8-\\u2DCE\\u2DD0-\\u2DD6\\u2DD8-\\u2DDE\\u3006\\u303C\\u3041-\\u3096\\u309F\\u30A1-\\u30FA\\u30FF\\u3105-\\u312D\\u3131-\\u318E\\u31A0-\\u31BA\\u31F0-\\u31FF\\u3400\\u4DB5\\u4E00\\u9FCB\\uA000-\\uA014\\uA016-\\uA48C\\uA4D0-\\uA4F7\\uA500-\\uA60B\\uA610-\\uA61F\\uA62A\\uA62B\\uA66E\\uA6A0-\\uA6E5\\uA7FB-\\uA801\\uA803-\\uA805\\uA807-\\uA80A\\uA80C-\\uA822\\uA840-\\uA873\\uA882-\\uA8B3\\uA8F2-\\uA8F7\\uA8FB\\uA90A-\\uA925\\uA930-\\uA946\\uA960-\\uA97C\\uA984-\\uA9B2\\uAA00-\\uAA28\\uAA40-\\uAA42\\uAA44-\\uAA4B\\uAA60-\\uAA6F\\uAA71-\\uAA76\\uAA7A\\uAA80-\\uAAAF\\uAAB1\\uAAB5\\uAAB6\\uAAB9-\\uAABD\\uAAC0\\uAAC2\\uAADB\\uAADC\\uAB01-\\uAB06\\uAB09-\\uAB0E\\uAB11-\\uAB16\\uAB20-\\uAB26\\uAB28-\\uAB2E\\uABC0-\\uABE2\\uAC00\\uD7A3\\uD7B0-\\uD7C6\\uD7CB-\\uD7FB\\uF900-\\uFA2D\\uFA30-\\uFA6D\\uFA70-\\uFAD9\\uFB1D\\uFB1F-\\uFB28\\uFB2A-\\uFB36\\uFB38-\\uFB3C\\uFB3E\\uFB40\\uFB41\\uFB43\\uFB44\\uFB46-\\uFBB1\\uFBD3-\\uFD3D\\uFD50-\\uFD8F\\uFD92-\\uFDC7\\uFDF0-\\uFDFB\\uFE70-\\uFE74\\uFE76-\\uFEFC\\uFF66-\\uFF6F\\uFF71-\\uFF9D\\uFFA0-\\uFFBE\\uFFC2-\\uFFC7\\uFFCA-\\uFFCF\\uFFD2-\\uFFD7\\uFFDA-\\uFFDC\\u16EE-\\u16F0\\u2160-\\u2182\\u2185-\\u2188\\u3007\\u3021-\\u3029\\u3038-\\u303A\\uA6E6-\\uA6EF]", description: "[A-Z\\xC0-\\xD6\\xD8-\\xDE\\u0100\\u0102\\u0104\\u0106\\u0108\\u010A\\u010C\\u010E\\u0110\\u0112\\u0114\\u0116\\u0118\\u011A\\u011C\\u011E\\u0120\\u0122\\u0124\\u0126\\u0128\\u012A\\u012C\\u012E\\u0130\\u0132\\u0134\\u0136\\u0139\\u013B\\u013D\\u013F\\u0141\\u0143\\u0145\\u0147\\u014A\\u014C\\u014E\\u0150\\u0152\\u0154\\u0156\\u0158\\u015A\\u015C\\u015E\\u0160\\u0162\\u0164\\u0166\\u0168\\u016A\\u016C\\u016E\\u0170\\u0172\\u0174\\u0176\\u0178\\u0179\\u017B\\u017D\\u0181\\u0182\\u0184\\u0186\\u0187\\u0189-\\u018B\\u018E-\\u0191\\u0193\\u0194\\u0196-\\u0198\\u019C\\u019D\\u019F\\u01A0\\u01A2\\u01A4\\u01A6\\u01A7\\u01A9\\u01AC\\u01AE\\u01AF\\u01B1-\\u01B3\\u01B5\\u01B7\\u01B8\\u01BC\\u01C4\\u01C7\\u01CA\\u01CD\\u01CF\\u01D1\\u01D3\\u01D5\\u01D7\\u01D9\\u01DB\\u01DE\\u01E0\\u01E2\\u01E4\\u01E6\\u01E8\\u01EA\\u01EC\\u01EE\\u01F1\\u01F4\\u01F6-\\u01F8\\u01FA\\u01FC\\u01FE\\u0200\\u0202\\u0204\\u0206\\u0208\\u020A\\u020C\\u020E\\u0210\\u0212\\u0214\\u0216\\u0218\\u021A\\u021C\\u021E\\u0220\\u0222\\u0224\\u0226\\u0228\\u022A\\u022C\\u022E\\u0230\\u0232\\u023A\\u023B\\u023D\\u023E\\u0241\\u0243-\\u0246\\u0248\\u024A\\u024C\\u024E\\u0370\\u0372\\u0376\\u0386\\u0388-\\u038A\\u038C\\u038E\\u038F\\u0391-\\u03A1\\u03A3-\\u03AB\\u03CF\\u03D2-\\u03D4\\u03D8\\u03DA\\u03DC\\u03DE\\u03E0\\u03E2\\u03E4\\u03E6\\u03E8\\u03EA\\u03EC\\u03EE\\u03F4\\u03F7\\u03F9\\u03FA\\u03FD-\\u042F\\u0460\\u0462\\u0464\\u0466\\u0468\\u046A\\u046C\\u046E\\u0470\\u0472\\u0474\\u0476\\u0478\\u047A\\u047C\\u047E\\u0480\\u048A\\u048C\\u048E\\u0490\\u0492\\u0494\\u0496\\u0498\\u049A\\u049C\\u049E\\u04A0\\u04A2\\u04A4\\u04A6\\u04A8\\u04AA\\u04AC\\u04AE\\u04B0\\u04B2\\u04B4\\u04B6\\u04B8\\u04BA\\u04BC\\u04BE\\u04C0\\u04C1\\u04C3\\u04C5\\u04C7\\u04C9\\u04CB\\u04CD\\u04D0\\u04D2\\u04D4\\u04D6\\u04D8\\u04DA\\u04DC\\u04DE\\u04E0\\u04E2\\u04E4\\u04E6\\u04E8\\u04EA\\u04EC\\u04EE\\u04F0\\u04F2\\u04F4\\u04F6\\u04F8\\u04FA\\u04FC\\u04FE\\u0500\\u0502\\u0504\\u0506\\u0508\\u050A\\u050C\\u050E\\u0510\\u0512\\u0514\\u0516\\u0518\\u051A\\u051C\\u051E\\u0520\\u0522\\u0524\\u0526\\u0531-\\u0556\\u10A0-\\u10C5\\u1E00\\u1E02\\u1E04\\u1E06\\u1E08\\u1E0A\\u1E0C\\u1E0E\\u1E10\\u1E12\\u1E14\\u1E16\\u1E18\\u1E1A\\u1E1C\\u1E1E\\u1E20\\u1E22\\u1E24\\u1E26\\u1E28\\u1E2A\\u1E2C\\u1E2E\\u1E30\\u1E32\\u1E34\\u1E36\\u1E38\\u1E3A\\u1E3C\\u1E3E\\u1E40\\u1E42\\u1E44\\u1E46\\u1E48\\u1E4A\\u1E4C\\u1E4E\\u1E50\\u1E52\\u1E54\\u1E56\\u1E58\\u1E5A\\u1E5C\\u1E5E\\u1E60\\u1E62\\u1E64\\u1E66\\u1E68\\u1E6A\\u1E6C\\u1E6E\\u1E70\\u1E72\\u1E74\\u1E76\\u1E78\\u1E7A\\u1E7C\\u1E7E\\u1E80\\u1E82\\u1E84\\u1E86\\u1E88\\u1E8A\\u1E8C\\u1E8E\\u1E90\\u1E92\\u1E94\\u1E9E\\u1EA0\\u1EA2\\u1EA4\\u1EA6\\u1EA8\\u1EAA\\u1EAC\\u1EAE\\u1EB0\\u1EB2\\u1EB4\\u1EB6\\u1EB8\\u1EBA\\u1EBC\\u1EBE\\u1EC0\\u1EC2\\u1EC4\\u1EC6\\u1EC8\\u1ECA\\u1ECC\\u1ECE\\u1ED0\\u1ED2\\u1ED4\\u1ED6\\u1ED8\\u1EDA\\u1EDC\\u1EDE\\u1EE0\\u1EE2\\u1EE4\\u1EE6\\u1EE8\\u1EEA\\u1EEC\\u1EEE\\u1EF0\\u1EF2\\u1EF4\\u1EF6\\u1EF8\\u1EFA\\u1EFC\\u1EFE\\u1F08-\\u1F0F\\u1F18-\\u1F1D\\u1F28-\\u1F2F\\u1F38-\\u1F3F\\u1F48-\\u1F4D\\u1F59\\u1F5B\\u1F5D\\u1F5F\\u1F68-\\u1F6F\\u1FB8-\\u1FBB\\u1FC8-\\u1FCB\\u1FD8-\\u1FDB\\u1FE8-\\u1FEC\\u1FF8-\\u1FFB\\u2102\\u2107\\u210B-\\u210D\\u2110-\\u2112\\u2115\\u2119-\\u211D\\u2124\\u2126\\u2128\\u212A-\\u212D\\u2130-\\u2133\\u213E\\u213F\\u2145\\u2183\\u2C00-\\u2C2E\\u2C60\\u2C62-\\u2C64\\u2C67\\u2C69\\u2C6B\\u2C6D-\\u2C70\\u2C72\\u2C75\\u2C7E-\\u2C80\\u2C82\\u2C84\\u2C86\\u2C88\\u2C8A\\u2C8C\\u2C8E\\u2C90\\u2C92\\u2C94\\u2C96\\u2C98\\u2C9A\\u2C9C\\u2C9E\\u2CA0\\u2CA2\\u2CA4\\u2CA6\\u2CA8\\u2CAA\\u2CAC\\u2CAE\\u2CB0\\u2CB2\\u2CB4\\u2CB6\\u2CB8\\u2CBA\\u2CBC\\u2CBE\\u2CC0\\u2CC2\\u2CC4\\u2CC6\\u2CC8\\u2CCA\\u2CCC\\u2CCE\\u2CD0\\u2CD2\\u2CD4\\u2CD6\\u2CD8\\u2CDA\\u2CDC\\u2CDE\\u2CE0\\u2CE2\\u2CEB\\u2CED\\uA640\\uA642\\uA644\\uA646\\uA648\\uA64A\\uA64C\\uA64E\\uA650\\uA652\\uA654\\uA656\\uA658\\uA65A\\uA65C\\uA65E\\uA660\\uA662\\uA664\\uA666\\uA668\\uA66A\\uA66C\\uA680\\uA682\\uA684\\uA686\\uA688\\uA68A\\uA68C\\uA68E\\uA690\\uA692\\uA694\\uA696\\uA722\\uA724\\uA726\\uA728\\uA72A\\uA72C\\uA72E\\uA732\\uA734\\uA736\\uA738\\uA73A\\uA73C\\uA73E\\uA740\\uA742\\uA744\\uA746\\uA748\\uA74A\\uA74C\\uA74E\\uA750\\uA752\\uA754\\uA756\\uA758\\uA75A\\uA75C\\uA75E\\uA760\\uA762\\uA764\\uA766\\uA768\\uA76A\\uA76C\\uA76E\\uA779\\uA77B\\uA77D\\uA77E\\uA780\\uA782\\uA784\\uA786\\uA78B\\uA78D\\uA790\\uA7A0\\uA7A2\\uA7A4\\uA7A6\\uA7A8\\uFF21-\\uFF3Aa-z\\xAA\\xB5\\xBA\\xDF-\\xF6\\xF8-\\xFF\\u0101\\u0103\\u0105\\u0107\\u0109\\u010B\\u010D\\u010F\\u0111\\u0113\\u0115\\u0117\\u0119\\u011B\\u011D\\u011F\\u0121\\u0123\\u0125\\u0127\\u0129\\u012B\\u012D\\u012F\\u0131\\u0133\\u0135\\u0137\\u0138\\u013A\\u013C\\u013E\\u0140\\u0142\\u0144\\u0146\\u0148\\u0149\\u014B\\u014D\\u014F\\u0151\\u0153\\u0155\\u0157\\u0159\\u015B\\u015D\\u015F\\u0161\\u0163\\u0165\\u0167\\u0169\\u016B\\u016D\\u016F\\u0171\\u0173\\u0175\\u0177\\u017A\\u017C\\u017E-\\u0180\\u0183\\u0185\\u0188\\u018C\\u018D\\u0192\\u0195\\u0199-\\u019B\\u019E\\u01A1\\u01A3\\u01A5\\u01A8\\u01AA\\u01AB\\u01AD\\u01B0\\u01B4\\u01B6\\u01B9\\u01BA\\u01BD-\\u01BF\\u01C6\\u01C9\\u01CC\\u01CE\\u01D0\\u01D2\\u01D4\\u01D6\\u01D8\\u01DA\\u01DC\\u01DD\\u01DF\\u01E1\\u01E3\\u01E5\\u01E7\\u01E9\\u01EB\\u01ED\\u01EF\\u01F0\\u01F3\\u01F5\\u01F9\\u01FB\\u01FD\\u01FF\\u0201\\u0203\\u0205\\u0207\\u0209\\u020B\\u020D\\u020F\\u0211\\u0213\\u0215\\u0217\\u0219\\u021B\\u021D\\u021F\\u0221\\u0223\\u0225\\u0227\\u0229\\u022B\\u022D\\u022F\\u0231\\u0233-\\u0239\\u023C\\u023F\\u0240\\u0242\\u0247\\u0249\\u024B\\u024D\\u024F-\\u0293\\u0295-\\u02AF\\u0371\\u0373\\u0377\\u037B-\\u037D\\u0390\\u03AC-\\u03CE\\u03D0\\u03D1\\u03D5-\\u03D7\\u03D9\\u03DB\\u03DD\\u03DF\\u03E1\\u03E3\\u03E5\\u03E7\\u03E9\\u03EB\\u03ED\\u03EF-\\u03F3\\u03F5\\u03F8\\u03FB\\u03FC\\u0430-\\u045F\\u0461\\u0463\\u0465\\u0467\\u0469\\u046B\\u046D\\u046F\\u0471\\u0473\\u0475\\u0477\\u0479\\u047B\\u047D\\u047F\\u0481\\u048B\\u048D\\u048F\\u0491\\u0493\\u0495\\u0497\\u0499\\u049B\\u049D\\u049F\\u04A1\\u04A3\\u04A5\\u04A7\\u04A9\\u04AB\\u04AD\\u04AF\\u04B1\\u04B3\\u04B5\\u04B7\\u04B9\\u04BB\\u04BD\\u04BF\\u04C2\\u04C4\\u04C6\\u04C8\\u04CA\\u04CC\\u04CE\\u04CF\\u04D1\\u04D3\\u04D5\\u04D7\\u04D9\\u04DB\\u04DD\\u04DF\\u04E1\\u04E3\\u04E5\\u04E7\\u04E9\\u04EB\\u04ED\\u04EF\\u04F1\\u04F3\\u04F5\\u04F7\\u04F9\\u04FB\\u04FD\\u04FF\\u0501\\u0503\\u0505\\u0507\\u0509\\u050B\\u050D\\u050F\\u0511\\u0513\\u0515\\u0517\\u0519\\u051B\\u051D\\u051F\\u0521\\u0523\\u0525\\u0527\\u0561-\\u0587\\u1D00-\\u1D2B\\u1D62-\\u1D77\\u1D79-\\u1D9A\\u1E01\\u1E03\\u1E05\\u1E07\\u1E09\\u1E0B\\u1E0D\\u1E0F\\u1E11\\u1E13\\u1E15\\u1E17\\u1E19\\u1E1B\\u1E1D\\u1E1F\\u1E21\\u1E23\\u1E25\\u1E27\\u1E29\\u1E2B\\u1E2D\\u1E2F\\u1E31\\u1E33\\u1E35\\u1E37\\u1E39\\u1E3B\\u1E3D\\u1E3F\\u1E41\\u1E43\\u1E45\\u1E47\\u1E49\\u1E4B\\u1E4D\\u1E4F\\u1E51\\u1E53\\u1E55\\u1E57\\u1E59\\u1E5B\\u1E5D\\u1E5F\\u1E61\\u1E63\\u1E65\\u1E67\\u1E69\\u1E6B\\u1E6D\\u1E6F\\u1E71\\u1E73\\u1E75\\u1E77\\u1E79\\u1E7B\\u1E7D\\u1E7F\\u1E81\\u1E83\\u1E85\\u1E87\\u1E89\\u1E8B\\u1E8D\\u1E8F\\u1E91\\u1E93\\u1E95-\\u1E9D\\u1E9F\\u1EA1\\u1EA3\\u1EA5\\u1EA7\\u1EA9\\u1EAB\\u1EAD\\u1EAF\\u1EB1\\u1EB3\\u1EB5\\u1EB7\\u1EB9\\u1EBB\\u1EBD\\u1EBF\\u1EC1\\u1EC3\\u1EC5\\u1EC7\\u1EC9\\u1ECB\\u1ECD\\u1ECF\\u1ED1\\u1ED3\\u1ED5\\u1ED7\\u1ED9\\u1EDB\\u1EDD\\u1EDF\\u1EE1\\u1EE3\\u1EE5\\u1EE7\\u1EE9\\u1EEB\\u1EED\\u1EEF\\u1EF1\\u1EF3\\u1EF5\\u1EF7\\u1EF9\\u1EFB\\u1EFD\\u1EFF-\\u1F07\\u1F10-\\u1F15\\u1F20-\\u1F27\\u1F30-\\u1F37\\u1F40-\\u1F45\\u1F50-\\u1F57\\u1F60-\\u1F67\\u1F70-\\u1F7D\\u1F80-\\u1F87\\u1F90-\\u1F97\\u1FA0-\\u1FA7\\u1FB0-\\u1FB4\\u1FB6\\u1FB7\\u1FBE\\u1FC2-\\u1FC4\\u1FC6\\u1FC7\\u1FD0-\\u1FD3\\u1FD6\\u1FD7\\u1FE0-\\u1FE7\\u1FF2-\\u1FF4\\u1FF6\\u1FF7\\u210A\\u210E\\u210F\\u2113\\u212F\\u2134\\u2139\\u213C\\u213D\\u2146-\\u2149\\u214E\\u2184\\u2C30-\\u2C5E\\u2C61\\u2C65\\u2C66\\u2C68\\u2C6A\\u2C6C\\u2C71\\u2C73\\u2C74\\u2C76-\\u2C7C\\u2C81\\u2C83\\u2C85\\u2C87\\u2C89\\u2C8B\\u2C8D\\u2C8F\\u2C91\\u2C93\\u2C95\\u2C97\\u2C99\\u2C9B\\u2C9D\\u2C9F\\u2CA1\\u2CA3\\u2CA5\\u2CA7\\u2CA9\\u2CAB\\u2CAD\\u2CAF\\u2CB1\\u2CB3\\u2CB5\\u2CB7\\u2CB9\\u2CBB\\u2CBD\\u2CBF\\u2CC1\\u2CC3\\u2CC5\\u2CC7\\u2CC9\\u2CCB\\u2CCD\\u2CCF\\u2CD1\\u2CD3\\u2CD5\\u2CD7\\u2CD9\\u2CDB\\u2CDD\\u2CDF\\u2CE1\\u2CE3\\u2CE4\\u2CEC\\u2CEE\\u2D00-\\u2D25\\uA641\\uA643\\uA645\\uA647\\uA649\\uA64B\\uA64D\\uA64F\\uA651\\uA653\\uA655\\uA657\\uA659\\uA65B\\uA65D\\uA65F\\uA661\\uA663\\uA665\\uA667\\uA669\\uA66B\\uA66D\\uA681\\uA683\\uA685\\uA687\\uA689\\uA68B\\uA68D\\uA68F\\uA691\\uA693\\uA695\\uA697\\uA723\\uA725\\uA727\\uA729\\uA72B\\uA72D\\uA72F-\\uA731\\uA733\\uA735\\uA737\\uA739\\uA73B\\uA73D\\uA73F\\uA741\\uA743\\uA745\\uA747\\uA749\\uA74B\\uA74D\\uA74F\\uA751\\uA753\\uA755\\uA757\\uA759\\uA75B\\uA75D\\uA75F\\uA761\\uA763\\uA765\\uA767\\uA769\\uA76B\\uA76D\\uA76F\\uA771-\\uA778\\uA77A\\uA77C\\uA77F\\uA781\\uA783\\uA785\\uA787\\uA78C\\uA78E\\uA791\\uA7A1\\uA7A3\\uA7A5\\uA7A7\\uA7A9\\uA7FA\\uFB00-\\uFB06\\uFB13-\\uFB17\\uFF41-\\uFF5A\\u01C5\\u01C8\\u01CB\\u01F2\\u1F88-\\u1F8F\\u1F98-\\u1F9F\\u1FA8-\\u1FAF\\u1FBC\\u1FCC\\u1FFC\\u02B0-\\u02C1\\u02C6-\\u02D1\\u02E0-\\u02E4\\u02EC\\u02EE\\u0374\\u037A\\u0559\\u0640\\u06E5\\u06E6\\u07F4\\u07F5\\u07FA\\u081A\\u0824\\u0828\\u0971\\u0E46\\u0EC6\\u10FC\\u17D7\\u1843\\u1AA7\\u1C78-\\u1C7D\\u1D2C-\\u1D61\\u1D78\\u1D9B-\\u1DBF\\u2071\\u207F\\u2090-\\u209C\\u2C7D\\u2D6F\\u2E2F\\u3005\\u3031-\\u3035\\u303B\\u309D\\u309E\\u30FC-\\u30FE\\uA015\\uA4F8-\\uA4FD\\uA60C\\uA67F\\uA717-\\uA71F\\uA770\\uA788\\uA9CF\\uAA70\\uAADD\\uFF70\\uFF9E\\uFF9F\\u01BB\\u01C0-\\u01C3\\u0294\\u05D0-\\u05EA\\u05F0-\\u05F2\\u0620-\\u063F\\u0641-\\u064A\\u066E\\u066F\\u0671-\\u06D3\\u06D5\\u06EE\\u06EF\\u06FA-\\u06FC\\u06FF\\u0710\\u0712-\\u072F\\u074D-\\u07A5\\u07B1\\u07CA-\\u07EA\\u0800-\\u0815\\u0840-\\u0858\\u0904-\\u0939\\u093D\\u0950\\u0958-\\u0961\\u0972-\\u0977\\u0979-\\u097F\\u0985-\\u098C\\u098F\\u0990\\u0993-\\u09A8\\u09AA-\\u09B0\\u09B2\\u09B6-\\u09B9\\u09BD\\u09CE\\u09DC\\u09DD\\u09DF-\\u09E1\\u09F0\\u09F1\\u0A05-\\u0A0A\\u0A0F\\u0A10\\u0A13-\\u0A28\\u0A2A-\\u0A30\\u0A32\\u0A33\\u0A35\\u0A36\\u0A38\\u0A39\\u0A59-\\u0A5C\\u0A5E\\u0A72-\\u0A74\\u0A85-\\u0A8D\\u0A8F-\\u0A91\\u0A93-\\u0AA8\\u0AAA-\\u0AB0\\u0AB2\\u0AB3\\u0AB5-\\u0AB9\\u0ABD\\u0AD0\\u0AE0\\u0AE1\\u0B05-\\u0B0C\\u0B0F\\u0B10\\u0B13-\\u0B28\\u0B2A-\\u0B30\\u0B32\\u0B33\\u0B35-\\u0B39\\u0B3D\\u0B5C\\u0B5D\\u0B5F-\\u0B61\\u0B71\\u0B83\\u0B85-\\u0B8A\\u0B8E-\\u0B90\\u0B92-\\u0B95\\u0B99\\u0B9A\\u0B9C\\u0B9E\\u0B9F\\u0BA3\\u0BA4\\u0BA8-\\u0BAA\\u0BAE-\\u0BB9\\u0BD0\\u0C05-\\u0C0C\\u0C0E-\\u0C10\\u0C12-\\u0C28\\u0C2A-\\u0C33\\u0C35-\\u0C39\\u0C3D\\u0C58\\u0C59\\u0C60\\u0C61\\u0C85-\\u0C8C\\u0C8E-\\u0C90\\u0C92-\\u0CA8\\u0CAA-\\u0CB3\\u0CB5-\\u0CB9\\u0CBD\\u0CDE\\u0CE0\\u0CE1\\u0CF1\\u0CF2\\u0D05-\\u0D0C\\u0D0E-\\u0D10\\u0D12-\\u0D3A\\u0D3D\\u0D4E\\u0D60\\u0D61\\u0D7A-\\u0D7F\\u0D85-\\u0D96\\u0D9A-\\u0DB1\\u0DB3-\\u0DBB\\u0DBD\\u0DC0-\\u0DC6\\u0E01-\\u0E30\\u0E32\\u0E33\\u0E40-\\u0E45\\u0E81\\u0E82\\u0E84\\u0E87\\u0E88\\u0E8A\\u0E8D\\u0E94-\\u0E97\\u0E99-\\u0E9F\\u0EA1-\\u0EA3\\u0EA5\\u0EA7\\u0EAA\\u0EAB\\u0EAD-\\u0EB0\\u0EB2\\u0EB3\\u0EBD\\u0EC0-\\u0EC4\\u0EDC\\u0EDD\\u0F00\\u0F40-\\u0F47\\u0F49-\\u0F6C\\u0F88-\\u0F8C\\u1000-\\u102A\\u103F\\u1050-\\u1055\\u105A-\\u105D\\u1061\\u1065\\u1066\\u106E-\\u1070\\u1075-\\u1081\\u108E\\u10D0-\\u10FA\\u1100-\\u1248\\u124A-\\u124D\\u1250-\\u1256\\u1258\\u125A-\\u125D\\u1260-\\u1288\\u128A-\\u128D\\u1290-\\u12B0\\u12B2-\\u12B5\\u12B8-\\u12BE\\u12C0\\u12C2-\\u12C5\\u12C8-\\u12D6\\u12D8-\\u1310\\u1312-\\u1315\\u1318-\\u135A\\u1380-\\u138F\\u13A0-\\u13F4\\u1401-\\u166C\\u166F-\\u167F\\u1681-\\u169A\\u16A0-\\u16EA\\u1700-\\u170C\\u170E-\\u1711\\u1720-\\u1731\\u1740-\\u1751\\u1760-\\u176C\\u176E-\\u1770\\u1780-\\u17B3\\u17DC\\u1820-\\u1842\\u1844-\\u1877\\u1880-\\u18A8\\u18AA\\u18B0-\\u18F5\\u1900-\\u191C\\u1950-\\u196D\\u1970-\\u1974\\u1980-\\u19AB\\u19C1-\\u19C7\\u1A00-\\u1A16\\u1A20-\\u1A54\\u1B05-\\u1B33\\u1B45-\\u1B4B\\u1B83-\\u1BA0\\u1BAE\\u1BAF\\u1BC0-\\u1BE5\\u1C00-\\u1C23\\u1C4D-\\u1C4F\\u1C5A-\\u1C77\\u1CE9-\\u1CEC\\u1CEE-\\u1CF1\\u2135-\\u2138\\u2D30-\\u2D65\\u2D80-\\u2D96\\u2DA0-\\u2DA6\\u2DA8-\\u2DAE\\u2DB0-\\u2DB6\\u2DB8-\\u2DBE\\u2DC0-\\u2DC6\\u2DC8-\\u2DCE\\u2DD0-\\u2DD6\\u2DD8-\\u2DDE\\u3006\\u303C\\u3041-\\u3096\\u309F\\u30A1-\\u30FA\\u30FF\\u3105-\\u312D\\u3131-\\u318E\\u31A0-\\u31BA\\u31F0-\\u31FF\\u3400\\u4DB5\\u4E00\\u9FCB\\uA000-\\uA014\\uA016-\\uA48C\\uA4D0-\\uA4F7\\uA500-\\uA60B\\uA610-\\uA61F\\uA62A\\uA62B\\uA66E\\uA6A0-\\uA6E5\\uA7FB-\\uA801\\uA803-\\uA805\\uA807-\\uA80A\\uA80C-\\uA822\\uA840-\\uA873\\uA882-\\uA8B3\\uA8F2-\\uA8F7\\uA8FB\\uA90A-\\uA925\\uA930-\\uA946\\uA960-\\uA97C\\uA984-\\uA9B2\\uAA00-\\uAA28\\uAA40-\\uAA42\\uAA44-\\uAA4B\\uAA60-\\uAA6F\\uAA71-\\uAA76\\uAA7A\\uAA80-\\uAAAF\\uAAB1\\uAAB5\\uAAB6\\uAAB9-\\uAABD\\uAAC0\\uAAC2\\uAADB\\uAADC\\uAB01-\\uAB06\\uAB09-\\uAB0E\\uAB11-\\uAB16\\uAB20-\\uAB26\\uAB28-\\uAB2E\\uABC0-\\uABE2\\uAC00\\uD7A3\\uD7B0-\\uD7C6\\uD7CB-\\uD7FB\\uF900-\\uFA2D\\uFA30-\\uFA6D\\uFA70-\\uFAD9\\uFB1D\\uFB1F-\\uFB28\\uFB2A-\\uFB36\\uFB38-\\uFB3C\\uFB3E\\uFB40\\uFB41\\uFB43\\uFB44\\uFB46-\\uFBB1\\uFBD3-\\uFD3D\\uFD50-\\uFD8F\\uFD92-\\uFDC7\\uFDF0-\\uFDFB\\uFE70-\\uFE74\\uFE76-\\uFEFC\\uFF66-\\uFF6F\\uFF71-\\uFF9D\\uFFA0-\\uFFBE\\uFFC2-\\uFFC7\\uFFCA-\\uFFCF\\uFFD2-\\uFFD7\\uFFDA-\\uFFDC\\u16EE-\\u16F0\\u2160-\\u2182\\u2185-\\u2188\\u3007\\u3021-\\u3029\\u3038-\\u303A\\uA6E6-\\uA6EF]" },
        peg$c273 = "\uD82C",
        peg$c274 = { type: "literal", value: "\uD82C", description: "\"\\uD82C\"" },
        peg$c275 = /^[\uDC00\uDC01]/,
        peg$c276 = { type: "class", value: "[\\uDC00\\uDC01]", description: "[\\uDC00\\uDC01]" },
        peg$c277 = "\uD808",
        peg$c278 = { type: "literal", value: "\uD808", description: "\"\\uD808\"" },
        peg$c279 = /^[\uDC00-\uDF6E]/,
        peg$c280 = { type: "class", value: "[\\uDC00-\\uDF6E]", description: "[\\uDC00-\\uDF6E]" },
        peg$c281 = "\uD869",
        peg$c282 = { type: "literal", value: "\uD869", description: "\"\\uD869\"" },
        peg$c283 = /^[\uDED6\uDF00]/,
        peg$c284 = { type: "class", value: "[\\uDED6\\uDF00]", description: "[\\uDED6\\uDF00]" },
        peg$c285 = "\uD809",
        peg$c286 = { type: "literal", value: "\uD809", description: "\"\\uD809\"" },
        peg$c287 = /^[\uDC00-\uDC62]/,
        peg$c288 = { type: "class", value: "[\\uDC00-\\uDC62]", description: "[\\uDC00-\\uDC62]" },
        peg$c289 = "\uD835",
        peg$c290 = { type: "literal", value: "\uD835", description: "\"\\uD835\"" },
        peg$c291 = /^[\uDC00-\uDC19\uDC34-\uDC4D\uDC68-\uDC81\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB5\uDCD0-\uDCE9\uDD04\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD38\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD6C-\uDD85\uDDA0-\uDDB9\uDDD4-\uDDED\uDE08-\uDE21\uDE3C-\uDE55\uDE70-\uDE89\uDEA8-\uDEC0\uDEE2-\uDEFA\uDF1C-\uDF34\uDF56-\uDF6E\uDF90-\uDFA8\uDFCA\uDC1A-\uDC33\uDC4E-\uDC54\uDC56-\uDC67\uDC82-\uDC9B\uDCB6-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDCCF\uDCEA-\uDD03\uDD1E-\uDD37\uDD52-\uDD6B\uDD86-\uDD9F\uDDBA-\uDDD3\uDDEE-\uDE07\uDE22-\uDE3B\uDE56-\uDE6F\uDE8A-\uDEA5\uDEC2-\uDEDA\uDEDC-\uDEE1\uDEFC-\uDF14\uDF16-\uDF1B\uDF36-\uDF4E\uDF50-\uDF55\uDF70-\uDF88\uDF8A-\uDF8F\uDFAA-\uDFC2\uDFC4-\uDFC9\uDFCB]/,
        peg$c292 = { type: "class", value: "[\\uDC00-\\uDC19\\uDC34-\\uDC4D\\uDC68-\\uDC81\\uDC9C\\uDC9E\\uDC9F\\uDCA2\\uDCA5\\uDCA6\\uDCA9-\\uDCAC\\uDCAE-\\uDCB5\\uDCD0-\\uDCE9\\uDD04\\uDD05\\uDD07-\\uDD0A\\uDD0D-\\uDD14\\uDD16-\\uDD1C\\uDD38\\uDD39\\uDD3B-\\uDD3E\\uDD40-\\uDD44\\uDD46\\uDD4A-\\uDD50\\uDD6C-\\uDD85\\uDDA0-\\uDDB9\\uDDD4-\\uDDED\\uDE08-\\uDE21\\uDE3C-\\uDE55\\uDE70-\\uDE89\\uDEA8-\\uDEC0\\uDEE2-\\uDEFA\\uDF1C-\\uDF34\\uDF56-\\uDF6E\\uDF90-\\uDFA8\\uDFCA\\uDC1A-\\uDC33\\uDC4E-\\uDC54\\uDC56-\\uDC67\\uDC82-\\uDC9B\\uDCB6-\\uDCB9\\uDCBB\\uDCBD-\\uDCC3\\uDCC5-\\uDCCF\\uDCEA-\\uDD03\\uDD1E-\\uDD37\\uDD52-\\uDD6B\\uDD86-\\uDD9F\\uDDBA-\\uDDD3\\uDDEE-\\uDE07\\uDE22-\\uDE3B\\uDE56-\\uDE6F\\uDE8A-\\uDEA5\\uDEC2-\\uDEDA\\uDEDC-\\uDEE1\\uDEFC-\\uDF14\\uDF16-\\uDF1B\\uDF36-\\uDF4E\\uDF50-\\uDF55\\uDF70-\\uDF88\\uDF8A-\\uDF8F\\uDFAA-\\uDFC2\\uDFC4-\\uDFC9\\uDFCB]", description: "[\\uDC00-\\uDC19\\uDC34-\\uDC4D\\uDC68-\\uDC81\\uDC9C\\uDC9E\\uDC9F\\uDCA2\\uDCA5\\uDCA6\\uDCA9-\\uDCAC\\uDCAE-\\uDCB5\\uDCD0-\\uDCE9\\uDD04\\uDD05\\uDD07-\\uDD0A\\uDD0D-\\uDD14\\uDD16-\\uDD1C\\uDD38\\uDD39\\uDD3B-\\uDD3E\\uDD40-\\uDD44\\uDD46\\uDD4A-\\uDD50\\uDD6C-\\uDD85\\uDDA0-\\uDDB9\\uDDD4-\\uDDED\\uDE08-\\uDE21\\uDE3C-\\uDE55\\uDE70-\\uDE89\\uDEA8-\\uDEC0\\uDEE2-\\uDEFA\\uDF1C-\\uDF34\\uDF56-\\uDF6E\\uDF90-\\uDFA8\\uDFCA\\uDC1A-\\uDC33\\uDC4E-\\uDC54\\uDC56-\\uDC67\\uDC82-\\uDC9B\\uDCB6-\\uDCB9\\uDCBB\\uDCBD-\\uDCC3\\uDCC5-\\uDCCF\\uDCEA-\\uDD03\\uDD1E-\\uDD37\\uDD52-\\uDD6B\\uDD86-\\uDD9F\\uDDBA-\\uDDD3\\uDDEE-\\uDE07\\uDE22-\\uDE3B\\uDE56-\\uDE6F\\uDE8A-\\uDEA5\\uDEC2-\\uDEDA\\uDEDC-\\uDEE1\\uDEFC-\\uDF14\\uDF16-\\uDF1B\\uDF36-\\uDF4E\\uDF50-\\uDF55\\uDF70-\\uDF88\\uDF8A-\\uDF8F\\uDFAA-\\uDFC2\\uDFC4-\\uDFC9\\uDFCB]" },
        peg$c293 = "\uD804",
        peg$c294 = { type: "literal", value: "\uD804", description: "\"\\uD804\"" },
        peg$c295 = /^[\uDC03-\uDC37\uDC83-\uDCAF]/,
        peg$c296 = { type: "class", value: "[\\uDC03-\\uDC37\\uDC83-\\uDCAF]", description: "[\\uDC03-\\uDC37\\uDC83-\\uDCAF]" },
        peg$c297 = "\uD800",
        peg$c298 = { type: "literal", value: "\uD800", description: "\"\\uD800\"" },
        peg$c299 = /^[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDE80-\uDE9C\uDEA0-\uDED0\uDF00-\uDF1E\uDF30-\uDF40\uDF42-\uDF49\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDD40-\uDD74\uDF41\uDF4A\uDFD1-\uDFD5]/,
        peg$c300 = { type: "class", value: "[\\uDC00-\\uDC0B\\uDC0D-\\uDC26\\uDC28-\\uDC3A\\uDC3C\\uDC3D\\uDC3F-\\uDC4D\\uDC50-\\uDC5D\\uDC80-\\uDCFA\\uDE80-\\uDE9C\\uDEA0-\\uDED0\\uDF00-\\uDF1E\\uDF30-\\uDF40\\uDF42-\\uDF49\\uDF80-\\uDF9D\\uDFA0-\\uDFC3\\uDFC8-\\uDFCF\\uDD40-\\uDD74\\uDF41\\uDF4A\\uDFD1-\\uDFD5]", description: "[\\uDC00-\\uDC0B\\uDC0D-\\uDC26\\uDC28-\\uDC3A\\uDC3C\\uDC3D\\uDC3F-\\uDC4D\\uDC50-\\uDC5D\\uDC80-\\uDCFA\\uDE80-\\uDE9C\\uDEA0-\\uDED0\\uDF00-\\uDF1E\\uDF30-\\uDF40\\uDF42-\\uDF49\\uDF80-\\uDF9D\\uDFA0-\\uDFC3\\uDFC8-\\uDFCF\\uDD40-\\uDD74\\uDF41\\uDF4A\\uDFD1-\\uDFD5]" },
        peg$c301 = "\uD80C",
        peg$c302 = { type: "literal", value: "\uD80C", description: "\"\\uD80C\"" },
        peg$c303 = /^[\uDC00-\uDFFF]/,
        peg$c304 = { type: "class", value: "[\\uDC00-\\uDFFF]", description: "[\\uDC00-\\uDFFF]" },
        peg$c305 = "\uD801",
        peg$c306 = { type: "literal", value: "\uD801", description: "\"\\uD801\"" },
        peg$c307 = /^[\uDC00-\uDC9D]/,
        peg$c308 = { type: "class", value: "[\\uDC00-\\uDC9D]", description: "[\\uDC00-\\uDC9D]" },
        peg$c309 = "\uD86E",
        peg$c310 = { type: "literal", value: "\uD86E", description: "\"\\uD86E\"" },
        peg$c311 = /^[\uDC1D]/,
        peg$c312 = { type: "class", value: "[\\uDC1D]", description: "[\\uDC1D]" },
        peg$c313 = "\uD803",
        peg$c314 = { type: "literal", value: "\uD803", description: "\"\\uD803\"" },
        peg$c315 = /^[\uDC00-\uDC48]/,
        peg$c316 = { type: "class", value: "[\\uDC00-\\uDC48]", description: "[\\uDC00-\\uDC48]" },
        peg$c317 = "\uD840",
        peg$c318 = { type: "literal", value: "\uD840", description: "\"\\uD840\"" },
        peg$c319 = /^[\uDC00]/,
        peg$c320 = { type: "class", value: "[\\uDC00]", description: "[\\uDC00]" },
        peg$c321 = "\uD87E",
        peg$c322 = { type: "literal", value: "\uD87E", description: "\"\\uD87E\"" },
        peg$c323 = /^[\uDC00-\uDE1D]/,
        peg$c324 = { type: "class", value: "[\\uDC00-\\uDE1D]", description: "[\\uDC00-\\uDE1D]" },
        peg$c325 = "\uD86D",
        peg$c326 = { type: "literal", value: "\uD86D", description: "\"\\uD86D\"" },
        peg$c327 = /^[\uDF34\uDF40]/,
        peg$c328 = { type: "class", value: "[\\uDF34\\uDF40]", description: "[\\uDF34\\uDF40]" },
        peg$c329 = "\uD81A",
        peg$c330 = { type: "literal", value: "\uD81A", description: "\"\\uD81A\"" },
        peg$c331 = /^[\uDC00-\uDE38]/,
        peg$c332 = { type: "class", value: "[\\uDC00-\\uDE38]", description: "[\\uDC00-\\uDE38]" },
        peg$c333 = "\uD802",
        peg$c334 = { type: "literal", value: "\uD802", description: "\"\\uD802\"" },
        peg$c335 = /^[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDD00-\uDD15\uDD20-\uDD39\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE33\uDE60-\uDE7C\uDF00-\uDF35\uDF40-\uDF55\uDF60-\uDF72]/,
        peg$c336 = { type: "class", value: "[\\uDC00-\\uDC05\\uDC08\\uDC0A-\\uDC35\\uDC37\\uDC38\\uDC3C\\uDC3F-\\uDC55\\uDD00-\\uDD15\\uDD20-\\uDD39\\uDE00\\uDE10-\\uDE13\\uDE15-\\uDE17\\uDE19-\\uDE33\\uDE60-\\uDE7C\\uDF00-\\uDF35\\uDF40-\\uDF55\\uDF60-\\uDF72]", description: "[\\uDC00-\\uDC05\\uDC08\\uDC0A-\\uDC35\\uDC37\\uDC38\\uDC3C\\uDC3F-\\uDC55\\uDD00-\\uDD15\\uDD20-\\uDD39\\uDE00\\uDE10-\\uDE13\\uDE15-\\uDE17\\uDE19-\\uDE33\\uDE60-\\uDE7C\\uDF00-\\uDF35\\uDF40-\\uDF55\\uDF60-\\uDF72]" },
        peg$c337 = "\uD80D",
        peg$c338 = { type: "literal", value: "\uD80D", description: "\"\\uD80D\"" },
        peg$c339 = /^[\uDC00-\uDC2E]/,
        peg$c340 = { type: "class", value: "[\\uDC00-\\uDC2E]", description: "[\\uDC00-\\uDC2E]" },
        peg$c341 = /^[\u0300-\u036F\u0483-\u0487\u0591-\u05BD\u05BF\u05C1\u05C2\u05C4\u05C5\u05C7\u0610-\u061A\u064B-\u065F\u0670\u06D6-\u06DC\u06DF-\u06E4\u06E7\u06E8\u06EA-\u06ED\u0711\u0730-\u074A\u07A6-\u07B0\u07EB-\u07F3\u0816-\u0819\u081B-\u0823\u0825-\u0827\u0829-\u082D\u0859-\u085B\u0900-\u0902\u093A\u093C\u0941-\u0948\u094D\u0951-\u0957\u0962\u0963\u0981\u09BC\u09C1-\u09C4\u09CD\u09E2\u09E3\u0A01\u0A02\u0A3C\u0A41\u0A42\u0A47\u0A48\u0A4B-\u0A4D\u0A51\u0A70\u0A71\u0A75\u0A81\u0A82\u0ABC\u0AC1-\u0AC5\u0AC7\u0AC8\u0ACD\u0AE2\u0AE3\u0B01\u0B3C\u0B3F\u0B41-\u0B44\u0B4D\u0B56\u0B62\u0B63\u0B82\u0BC0\u0BCD\u0C3E-\u0C40\u0C46-\u0C48\u0C4A-\u0C4D\u0C55\u0C56\u0C62\u0C63\u0CBC\u0CBF\u0CC6\u0CCC\u0CCD\u0CE2\u0CE3\u0D41-\u0D44\u0D4D\u0D62\u0D63\u0DCA\u0DD2-\u0DD4\u0DD6\u0E31\u0E34-\u0E3A\u0E47-\u0E4E\u0EB1\u0EB4-\u0EB9\u0EBB\u0EBC\u0EC8-\u0ECD\u0F18\u0F19\u0F35\u0F37\u0F39\u0F71-\u0F7E\u0F80-\u0F84\u0F86\u0F87\u0F8D-\u0F97\u0F99-\u0FBC\u0FC6\u102D-\u1030\u1032-\u1037\u1039\u103A\u103D\u103E\u1058\u1059\u105E-\u1060\u1071-\u1074\u1082\u1085\u1086\u108D\u109D\u135D-\u135F\u1712-\u1714\u1732-\u1734\u1752\u1753\u1772\u1773\u17B7-\u17BD\u17C6\u17C9-\u17D3\u17DD\u180B-\u180D\u18A9\u1920-\u1922\u1927\u1928\u1932\u1939-\u193B\u1A17\u1A18\u1A56\u1A58-\u1A5E\u1A60\u1A62\u1A65-\u1A6C\u1A73-\u1A7C\u1A7F\u1B00-\u1B03\u1B34\u1B36-\u1B3A\u1B3C\u1B42\u1B6B-\u1B73\u1B80\u1B81\u1BA2-\u1BA5\u1BA8\u1BA9\u1BE6\u1BE8\u1BE9\u1BED\u1BEF-\u1BF1\u1C2C-\u1C33\u1C36\u1C37\u1CD0-\u1CD2\u1CD4-\u1CE0\u1CE2-\u1CE8\u1CED\u1DC0-\u1DE6\u1DFC-\u1DFF\u20D0-\u20DC\u20E1\u20E5-\u20F0\u2CEF-\u2CF1\u2D7F\u2DE0-\u2DFF\u302A-\u302F\u3099\u309A\uA66F\uA67C\uA67D\uA6F0\uA6F1\uA802\uA806\uA80B\uA825\uA826\uA8C4\uA8E0-\uA8F1\uA926-\uA92D\uA947-\uA951\uA980-\uA982\uA9B3\uA9B6-\uA9B9\uA9BC\uAA29-\uAA2E\uAA31\uAA32\uAA35\uAA36\uAA43\uAA4C\uAAB0\uAAB2-\uAAB4\uAAB7\uAAB8\uAABE\uAABF\uAAC1\uABE5\uABE8\uABED\uFB1E\uFE00-\uFE0F\uFE20-\uFE26\u0903\u093B\u093E-\u0940\u0949-\u094C\u094E\u094F\u0982\u0983\u09BE-\u09C0\u09C7\u09C8\u09CB\u09CC\u09D7\u0A03\u0A3E-\u0A40\u0A83\u0ABE-\u0AC0\u0AC9\u0ACB\u0ACC\u0B02\u0B03\u0B3E\u0B40\u0B47\u0B48\u0B4B\u0B4C\u0B57\u0BBE\u0BBF\u0BC1\u0BC2\u0BC6-\u0BC8\u0BCA-\u0BCC\u0BD7\u0C01-\u0C03\u0C41-\u0C44\u0C82\u0C83\u0CBE\u0CC0-\u0CC4\u0CC7\u0CC8\u0CCA\u0CCB\u0CD5\u0CD6\u0D02\u0D03\u0D3E-\u0D40\u0D46-\u0D48\u0D4A-\u0D4C\u0D57\u0D82\u0D83\u0DCF-\u0DD1\u0DD8-\u0DDF\u0DF2\u0DF3\u0F3E\u0F3F\u0F7F\u102B\u102C\u1031\u1038\u103B\u103C\u1056\u1057\u1062-\u1064\u1067-\u106D\u1083\u1084\u1087-\u108C\u108F\u109A-\u109C\u17B6\u17BE-\u17C5\u17C7\u17C8\u1923-\u1926\u1929-\u192B\u1930\u1931\u1933-\u1938\u19B0-\u19C0\u19C8\u19C9\u1A19-\u1A1B\u1A55\u1A57\u1A61\u1A63\u1A64\u1A6D-\u1A72\u1B04\u1B35\u1B3B\u1B3D-\u1B41\u1B43\u1B44\u1B82\u1BA1\u1BA6\u1BA7\u1BAA\u1BE7\u1BEA-\u1BEC\u1BEE\u1BF2\u1BF3\u1C24-\u1C2B\u1C34\u1C35\u1CE1\u1CF2\uA823\uA824\uA827\uA880\uA881\uA8B4-\uA8C3\uA952\uA953\uA983\uA9B4\uA9B5\uA9BA\uA9BB\uA9BD-\uA9C0\uAA2F\uAA30\uAA33\uAA34\uAA4D\uAA7B\uABE3\uABE4\uABE6\uABE7\uABE9\uABEA\uABEC]/,
        peg$c342 = { type: "class", value: "[\\u0300-\\u036F\\u0483-\\u0487\\u0591-\\u05BD\\u05BF\\u05C1\\u05C2\\u05C4\\u05C5\\u05C7\\u0610-\\u061A\\u064B-\\u065F\\u0670\\u06D6-\\u06DC\\u06DF-\\u06E4\\u06E7\\u06E8\\u06EA-\\u06ED\\u0711\\u0730-\\u074A\\u07A6-\\u07B0\\u07EB-\\u07F3\\u0816-\\u0819\\u081B-\\u0823\\u0825-\\u0827\\u0829-\\u082D\\u0859-\\u085B\\u0900-\\u0902\\u093A\\u093C\\u0941-\\u0948\\u094D\\u0951-\\u0957\\u0962\\u0963\\u0981\\u09BC\\u09C1-\\u09C4\\u09CD\\u09E2\\u09E3\\u0A01\\u0A02\\u0A3C\\u0A41\\u0A42\\u0A47\\u0A48\\u0A4B-\\u0A4D\\u0A51\\u0A70\\u0A71\\u0A75\\u0A81\\u0A82\\u0ABC\\u0AC1-\\u0AC5\\u0AC7\\u0AC8\\u0ACD\\u0AE2\\u0AE3\\u0B01\\u0B3C\\u0B3F\\u0B41-\\u0B44\\u0B4D\\u0B56\\u0B62\\u0B63\\u0B82\\u0BC0\\u0BCD\\u0C3E-\\u0C40\\u0C46-\\u0C48\\u0C4A-\\u0C4D\\u0C55\\u0C56\\u0C62\\u0C63\\u0CBC\\u0CBF\\u0CC6\\u0CCC\\u0CCD\\u0CE2\\u0CE3\\u0D41-\\u0D44\\u0D4D\\u0D62\\u0D63\\u0DCA\\u0DD2-\\u0DD4\\u0DD6\\u0E31\\u0E34-\\u0E3A\\u0E47-\\u0E4E\\u0EB1\\u0EB4-\\u0EB9\\u0EBB\\u0EBC\\u0EC8-\\u0ECD\\u0F18\\u0F19\\u0F35\\u0F37\\u0F39\\u0F71-\\u0F7E\\u0F80-\\u0F84\\u0F86\\u0F87\\u0F8D-\\u0F97\\u0F99-\\u0FBC\\u0FC6\\u102D-\\u1030\\u1032-\\u1037\\u1039\\u103A\\u103D\\u103E\\u1058\\u1059\\u105E-\\u1060\\u1071-\\u1074\\u1082\\u1085\\u1086\\u108D\\u109D\\u135D-\\u135F\\u1712-\\u1714\\u1732-\\u1734\\u1752\\u1753\\u1772\\u1773\\u17B7-\\u17BD\\u17C6\\u17C9-\\u17D3\\u17DD\\u180B-\\u180D\\u18A9\\u1920-\\u1922\\u1927\\u1928\\u1932\\u1939-\\u193B\\u1A17\\u1A18\\u1A56\\u1A58-\\u1A5E\\u1A60\\u1A62\\u1A65-\\u1A6C\\u1A73-\\u1A7C\\u1A7F\\u1B00-\\u1B03\\u1B34\\u1B36-\\u1B3A\\u1B3C\\u1B42\\u1B6B-\\u1B73\\u1B80\\u1B81\\u1BA2-\\u1BA5\\u1BA8\\u1BA9\\u1BE6\\u1BE8\\u1BE9\\u1BED\\u1BEF-\\u1BF1\\u1C2C-\\u1C33\\u1C36\\u1C37\\u1CD0-\\u1CD2\\u1CD4-\\u1CE0\\u1CE2-\\u1CE8\\u1CED\\u1DC0-\\u1DE6\\u1DFC-\\u1DFF\\u20D0-\\u20DC\\u20E1\\u20E5-\\u20F0\\u2CEF-\\u2CF1\\u2D7F\\u2DE0-\\u2DFF\\u302A-\\u302F\\u3099\\u309A\\uA66F\\uA67C\\uA67D\\uA6F0\\uA6F1\\uA802\\uA806\\uA80B\\uA825\\uA826\\uA8C4\\uA8E0-\\uA8F1\\uA926-\\uA92D\\uA947-\\uA951\\uA980-\\uA982\\uA9B3\\uA9B6-\\uA9B9\\uA9BC\\uAA29-\\uAA2E\\uAA31\\uAA32\\uAA35\\uAA36\\uAA43\\uAA4C\\uAAB0\\uAAB2-\\uAAB4\\uAAB7\\uAAB8\\uAABE\\uAABF\\uAAC1\\uABE5\\uABE8\\uABED\\uFB1E\\uFE00-\\uFE0F\\uFE20-\\uFE26\\u0903\\u093B\\u093E-\\u0940\\u0949-\\u094C\\u094E\\u094F\\u0982\\u0983\\u09BE-\\u09C0\\u09C7\\u09C8\\u09CB\\u09CC\\u09D7\\u0A03\\u0A3E-\\u0A40\\u0A83\\u0ABE-\\u0AC0\\u0AC9\\u0ACB\\u0ACC\\u0B02\\u0B03\\u0B3E\\u0B40\\u0B47\\u0B48\\u0B4B\\u0B4C\\u0B57\\u0BBE\\u0BBF\\u0BC1\\u0BC2\\u0BC6-\\u0BC8\\u0BCA-\\u0BCC\\u0BD7\\u0C01-\\u0C03\\u0C41-\\u0C44\\u0C82\\u0C83\\u0CBE\\u0CC0-\\u0CC4\\u0CC7\\u0CC8\\u0CCA\\u0CCB\\u0CD5\\u0CD6\\u0D02\\u0D03\\u0D3E-\\u0D40\\u0D46-\\u0D48\\u0D4A-\\u0D4C\\u0D57\\u0D82\\u0D83\\u0DCF-\\u0DD1\\u0DD8-\\u0DDF\\u0DF2\\u0DF3\\u0F3E\\u0F3F\\u0F7F\\u102B\\u102C\\u1031\\u1038\\u103B\\u103C\\u1056\\u1057\\u1062-\\u1064\\u1067-\\u106D\\u1083\\u1084\\u1087-\\u108C\\u108F\\u109A-\\u109C\\u17B6\\u17BE-\\u17C5\\u17C7\\u17C8\\u1923-\\u1926\\u1929-\\u192B\\u1930\\u1931\\u1933-\\u1938\\u19B0-\\u19C0\\u19C8\\u19C9\\u1A19-\\u1A1B\\u1A55\\u1A57\\u1A61\\u1A63\\u1A64\\u1A6D-\\u1A72\\u1B04\\u1B35\\u1B3B\\u1B3D-\\u1B41\\u1B43\\u1B44\\u1B82\\u1BA1\\u1BA6\\u1BA7\\u1BAA\\u1BE7\\u1BEA-\\u1BEC\\u1BEE\\u1BF2\\u1BF3\\u1C24-\\u1C2B\\u1C34\\u1C35\\u1CE1\\u1CF2\\uA823\\uA824\\uA827\\uA880\\uA881\\uA8B4-\\uA8C3\\uA952\\uA953\\uA983\\uA9B4\\uA9B5\\uA9BA\\uA9BB\\uA9BD-\\uA9C0\\uAA2F\\uAA30\\uAA33\\uAA34\\uAA4D\\uAA7B\\uABE3\\uABE4\\uABE6\\uABE7\\uABE9\\uABEA\\uABEC]", description: "[\\u0300-\\u036F\\u0483-\\u0487\\u0591-\\u05BD\\u05BF\\u05C1\\u05C2\\u05C4\\u05C5\\u05C7\\u0610-\\u061A\\u064B-\\u065F\\u0670\\u06D6-\\u06DC\\u06DF-\\u06E4\\u06E7\\u06E8\\u06EA-\\u06ED\\u0711\\u0730-\\u074A\\u07A6-\\u07B0\\u07EB-\\u07F3\\u0816-\\u0819\\u081B-\\u0823\\u0825-\\u0827\\u0829-\\u082D\\u0859-\\u085B\\u0900-\\u0902\\u093A\\u093C\\u0941-\\u0948\\u094D\\u0951-\\u0957\\u0962\\u0963\\u0981\\u09BC\\u09C1-\\u09C4\\u09CD\\u09E2\\u09E3\\u0A01\\u0A02\\u0A3C\\u0A41\\u0A42\\u0A47\\u0A48\\u0A4B-\\u0A4D\\u0A51\\u0A70\\u0A71\\u0A75\\u0A81\\u0A82\\u0ABC\\u0AC1-\\u0AC5\\u0AC7\\u0AC8\\u0ACD\\u0AE2\\u0AE3\\u0B01\\u0B3C\\u0B3F\\u0B41-\\u0B44\\u0B4D\\u0B56\\u0B62\\u0B63\\u0B82\\u0BC0\\u0BCD\\u0C3E-\\u0C40\\u0C46-\\u0C48\\u0C4A-\\u0C4D\\u0C55\\u0C56\\u0C62\\u0C63\\u0CBC\\u0CBF\\u0CC6\\u0CCC\\u0CCD\\u0CE2\\u0CE3\\u0D41-\\u0D44\\u0D4D\\u0D62\\u0D63\\u0DCA\\u0DD2-\\u0DD4\\u0DD6\\u0E31\\u0E34-\\u0E3A\\u0E47-\\u0E4E\\u0EB1\\u0EB4-\\u0EB9\\u0EBB\\u0EBC\\u0EC8-\\u0ECD\\u0F18\\u0F19\\u0F35\\u0F37\\u0F39\\u0F71-\\u0F7E\\u0F80-\\u0F84\\u0F86\\u0F87\\u0F8D-\\u0F97\\u0F99-\\u0FBC\\u0FC6\\u102D-\\u1030\\u1032-\\u1037\\u1039\\u103A\\u103D\\u103E\\u1058\\u1059\\u105E-\\u1060\\u1071-\\u1074\\u1082\\u1085\\u1086\\u108D\\u109D\\u135D-\\u135F\\u1712-\\u1714\\u1732-\\u1734\\u1752\\u1753\\u1772\\u1773\\u17B7-\\u17BD\\u17C6\\u17C9-\\u17D3\\u17DD\\u180B-\\u180D\\u18A9\\u1920-\\u1922\\u1927\\u1928\\u1932\\u1939-\\u193B\\u1A17\\u1A18\\u1A56\\u1A58-\\u1A5E\\u1A60\\u1A62\\u1A65-\\u1A6C\\u1A73-\\u1A7C\\u1A7F\\u1B00-\\u1B03\\u1B34\\u1B36-\\u1B3A\\u1B3C\\u1B42\\u1B6B-\\u1B73\\u1B80\\u1B81\\u1BA2-\\u1BA5\\u1BA8\\u1BA9\\u1BE6\\u1BE8\\u1BE9\\u1BED\\u1BEF-\\u1BF1\\u1C2C-\\u1C33\\u1C36\\u1C37\\u1CD0-\\u1CD2\\u1CD4-\\u1CE0\\u1CE2-\\u1CE8\\u1CED\\u1DC0-\\u1DE6\\u1DFC-\\u1DFF\\u20D0-\\u20DC\\u20E1\\u20E5-\\u20F0\\u2CEF-\\u2CF1\\u2D7F\\u2DE0-\\u2DFF\\u302A-\\u302F\\u3099\\u309A\\uA66F\\uA67C\\uA67D\\uA6F0\\uA6F1\\uA802\\uA806\\uA80B\\uA825\\uA826\\uA8C4\\uA8E0-\\uA8F1\\uA926-\\uA92D\\uA947-\\uA951\\uA980-\\uA982\\uA9B3\\uA9B6-\\uA9B9\\uA9BC\\uAA29-\\uAA2E\\uAA31\\uAA32\\uAA35\\uAA36\\uAA43\\uAA4C\\uAAB0\\uAAB2-\\uAAB4\\uAAB7\\uAAB8\\uAABE\\uAABF\\uAAC1\\uABE5\\uABE8\\uABED\\uFB1E\\uFE00-\\uFE0F\\uFE20-\\uFE26\\u0903\\u093B\\u093E-\\u0940\\u0949-\\u094C\\u094E\\u094F\\u0982\\u0983\\u09BE-\\u09C0\\u09C7\\u09C8\\u09CB\\u09CC\\u09D7\\u0A03\\u0A3E-\\u0A40\\u0A83\\u0ABE-\\u0AC0\\u0AC9\\u0ACB\\u0ACC\\u0B02\\u0B03\\u0B3E\\u0B40\\u0B47\\u0B48\\u0B4B\\u0B4C\\u0B57\\u0BBE\\u0BBF\\u0BC1\\u0BC2\\u0BC6-\\u0BC8\\u0BCA-\\u0BCC\\u0BD7\\u0C01-\\u0C03\\u0C41-\\u0C44\\u0C82\\u0C83\\u0CBE\\u0CC0-\\u0CC4\\u0CC7\\u0CC8\\u0CCA\\u0CCB\\u0CD5\\u0CD6\\u0D02\\u0D03\\u0D3E-\\u0D40\\u0D46-\\u0D48\\u0D4A-\\u0D4C\\u0D57\\u0D82\\u0D83\\u0DCF-\\u0DD1\\u0DD8-\\u0DDF\\u0DF2\\u0DF3\\u0F3E\\u0F3F\\u0F7F\\u102B\\u102C\\u1031\\u1038\\u103B\\u103C\\u1056\\u1057\\u1062-\\u1064\\u1067-\\u106D\\u1083\\u1084\\u1087-\\u108C\\u108F\\u109A-\\u109C\\u17B6\\u17BE-\\u17C5\\u17C7\\u17C8\\u1923-\\u1926\\u1929-\\u192B\\u1930\\u1931\\u1933-\\u1938\\u19B0-\\u19C0\\u19C8\\u19C9\\u1A19-\\u1A1B\\u1A55\\u1A57\\u1A61\\u1A63\\u1A64\\u1A6D-\\u1A72\\u1B04\\u1B35\\u1B3B\\u1B3D-\\u1B41\\u1B43\\u1B44\\u1B82\\u1BA1\\u1BA6\\u1BA7\\u1BAA\\u1BE7\\u1BEA-\\u1BEC\\u1BEE\\u1BF2\\u1BF3\\u1C24-\\u1C2B\\u1C34\\u1C35\\u1CE1\\u1CF2\\uA823\\uA824\\uA827\\uA880\\uA881\\uA8B4-\\uA8C3\\uA952\\uA953\\uA983\\uA9B4\\uA9B5\\uA9BA\\uA9BB\\uA9BD-\\uA9C0\\uAA2F\\uAA30\\uAA33\\uAA34\\uAA4D\\uAA7B\\uABE3\\uABE4\\uABE6\\uABE7\\uABE9\\uABEA\\uABEC]" },
        peg$c343 = "\uDB40",
        peg$c344 = { type: "literal", value: "\uDB40", description: "\"\\uDB40\"" },
        peg$c345 = /^[\uDD00-\uDDEF]/,
        peg$c346 = { type: "class", value: "[\\uDD00-\\uDDEF]", description: "[\\uDD00-\\uDDEF]" },
        peg$c347 = "\uD834",
        peg$c348 = { type: "literal", value: "\uD834", description: "\"\\uD834\"" },
        peg$c349 = /^[\uDD67-\uDD69\uDD7B-\uDD82\uDD85-\uDD8B\uDDAA-\uDDAD\uDE42-\uDE44\uDD65\uDD66\uDD6D-\uDD72]/,
        peg$c350 = { type: "class", value: "[\\uDD67-\\uDD69\\uDD7B-\\uDD82\\uDD85-\\uDD8B\\uDDAA-\\uDDAD\\uDE42-\\uDE44\\uDD65\\uDD66\\uDD6D-\\uDD72]", description: "[\\uDD67-\\uDD69\\uDD7B-\\uDD82\\uDD85-\\uDD8B\\uDDAA-\\uDDAD\\uDE42-\\uDE44\\uDD65\\uDD66\\uDD6D-\\uDD72]" },
        peg$c351 = /^[\uDC01\uDC38-\uDC46\uDC80\uDC81\uDCB3-\uDCB6\uDCB9\uDCBA\uDC00\uDC02\uDC82\uDCB0-\uDCB2\uDCB7\uDCB8]/,
        peg$c352 = { type: "class", value: "[\\uDC01\\uDC38-\\uDC46\\uDC80\\uDC81\\uDCB3-\\uDCB6\\uDCB9\\uDCBA\\uDC00\\uDC02\\uDC82\\uDCB0-\\uDCB2\\uDCB7\\uDCB8]", description: "[\\uDC01\\uDC38-\\uDC46\\uDC80\\uDC81\\uDCB3-\\uDCB6\\uDCB9\\uDCBA\\uDC00\\uDC02\\uDC82\\uDCB0-\\uDCB2\\uDCB7\\uDCB8]" },
        peg$c353 = /^[\uDDFD]/,
        peg$c354 = { type: "class", value: "[\\uDDFD]", description: "[\\uDDFD]" },
        peg$c355 = /^[\uDE01-\uDE03\uDE05\uDE06\uDE0C-\uDE0F\uDE38-\uDE3A\uDE3F]/,
        peg$c356 = { type: "class", value: "[\\uDE01-\\uDE03\\uDE05\\uDE06\\uDE0C-\\uDE0F\\uDE38-\\uDE3A\\uDE3F]", description: "[\\uDE01-\\uDE03\\uDE05\\uDE06\\uDE0C-\\uDE0F\\uDE38-\\uDE3A\\uDE3F]" },
        peg$c357 = /^[0-9\u0660-\u0669\u06F0-\u06F9\u07C0-\u07C9\u0966-\u096F\u09E6-\u09EF\u0A66-\u0A6F\u0AE6-\u0AEF\u0B66-\u0B6F\u0BE6-\u0BEF\u0C66-\u0C6F\u0CE6-\u0CEF\u0D66-\u0D6F\u0E50-\u0E59\u0ED0-\u0ED9\u0F20-\u0F29\u1040-\u1049\u1090-\u1099\u17E0-\u17E9\u1810-\u1819\u1946-\u194F\u19D0-\u19D9\u1A80-\u1A89\u1A90-\u1A99\u1B50-\u1B59\u1BB0-\u1BB9\u1C40-\u1C49\u1C50-\u1C59\uA620-\uA629\uA8D0-\uA8D9\uA900-\uA909\uA9D0-\uA9D9\uAA50-\uAA59\uABF0-\uABF9\uFF10-\uFF19]/,
        peg$c358 = { type: "class", value: "[0-9\\u0660-\\u0669\\u06F0-\\u06F9\\u07C0-\\u07C9\\u0966-\\u096F\\u09E6-\\u09EF\\u0A66-\\u0A6F\\u0AE6-\\u0AEF\\u0B66-\\u0B6F\\u0BE6-\\u0BEF\\u0C66-\\u0C6F\\u0CE6-\\u0CEF\\u0D66-\\u0D6F\\u0E50-\\u0E59\\u0ED0-\\u0ED9\\u0F20-\\u0F29\\u1040-\\u1049\\u1090-\\u1099\\u17E0-\\u17E9\\u1810-\\u1819\\u1946-\\u194F\\u19D0-\\u19D9\\u1A80-\\u1A89\\u1A90-\\u1A99\\u1B50-\\u1B59\\u1BB0-\\u1BB9\\u1C40-\\u1C49\\u1C50-\\u1C59\\uA620-\\uA629\\uA8D0-\\uA8D9\\uA900-\\uA909\\uA9D0-\\uA9D9\\uAA50-\\uAA59\\uABF0-\\uABF9\\uFF10-\\uFF19]", description: "[0-9\\u0660-\\u0669\\u06F0-\\u06F9\\u07C0-\\u07C9\\u0966-\\u096F\\u09E6-\\u09EF\\u0A66-\\u0A6F\\u0AE6-\\u0AEF\\u0B66-\\u0B6F\\u0BE6-\\u0BEF\\u0C66-\\u0C6F\\u0CE6-\\u0CEF\\u0D66-\\u0D6F\\u0E50-\\u0E59\\u0ED0-\\u0ED9\\u0F20-\\u0F29\\u1040-\\u1049\\u1090-\\u1099\\u17E0-\\u17E9\\u1810-\\u1819\\u1946-\\u194F\\u19D0-\\u19D9\\u1A80-\\u1A89\\u1A90-\\u1A99\\u1B50-\\u1B59\\u1BB0-\\u1BB9\\u1C40-\\u1C49\\u1C50-\\u1C59\\uA620-\\uA629\\uA8D0-\\uA8D9\\uA900-\\uA909\\uA9D0-\\uA9D9\\uAA50-\\uAA59\\uABF0-\\uABF9\\uFF10-\\uFF19]" },
        peg$c359 = /^[\uDFCE-\uDFFF]/,
        peg$c360 = { type: "class", value: "[\\uDFCE-\\uDFFF]", description: "[\\uDFCE-\\uDFFF]" },
        peg$c361 = /^[\uDC66-\uDC6F]/,
        peg$c362 = { type: "class", value: "[\\uDC66-\\uDC6F]", description: "[\\uDC66-\\uDC6F]" },
        peg$c363 = /^[\uDCA0-\uDCA9]/,
        peg$c364 = { type: "class", value: "[\\uDCA0-\\uDCA9]", description: "[\\uDCA0-\\uDCA9]" },
        peg$c365 = /^[_\u203F\u2040\u2054\uFE33\uFE34\uFE4D-\uFE4F\uFF3F]/,
        peg$c366 = { type: "class", value: "[_\\u203F\\u2040\\u2054\\uFE33\\uFE34\\uFE4D-\\uFE4F\\uFF3F]", description: "[_\\u203F\\u2040\\u2054\\uFE33\\uFE34\\uFE4D-\\uFE4F\\uFF3F]" },
        peg$c367 = "\u200C",
        peg$c368 = { type: "literal", value: "\u200C", description: "\"\\u200C\"" },
        peg$c369 = "\u200D",
        peg$c370 = { type: "literal", value: "\u200D", description: "\"\\u200D\"" },
        peg$c371 = "true",
        peg$c372 = { type: "literal", value: "true", description: "\"true\"" },
        peg$c373 = "false",
        peg$c374 = { type: "literal", value: "false", description: "\"false\"" },
        peg$c375 = "new",
        peg$c376 = { type: "literal", value: "new", description: "\"new\"" },
        peg$c377 = "this",
        peg$c378 = { type: "literal", value: "this", description: "\"this\"" },
        peg$c379 = "null",
        peg$c380 = { type: "literal", value: "null", description: "\"null\"" },
        peg$c381 = function() { return null },
        peg$c382 = "undefined",
        peg$c383 = { type: "literal", value: "undefined", description: "\"undefined\"" },
        peg$c384 = function() { return undefined },
        peg$c385 = "and",
        peg$c386 = { type: "literal", value: "and", description: "\"and\"" },
        peg$c387 = function() { return "&&" },
        peg$c388 = "or",
        peg$c389 = { type: "literal", value: "or", description: "\"or\"" },
        peg$c390 = function() { return "||" },
        peg$c391 = "is",
        peg$c392 = { type: "literal", value: "is", description: "\"is\"" },
        peg$c393 = function() { return "===" },
        peg$c394 = "isnt",
        peg$c395 = { type: "literal", value: "isnt", description: "\"isnt\"" },
        peg$c396 = function() { return "!==" },
        peg$c397 = "not",
        peg$c398 = { type: "literal", value: "not", description: "\"not\"" },
        peg$c399 = function() { return "!" },
        peg$c400 = "typeof",
        peg$c401 = { type: "literal", value: "typeof", description: "\"typeof\"" },
        peg$c402 = function() { return "typeof"},
        peg$c403 = function() { return "void"},
        peg$c404 = "delete",
        peg$c405 = { type: "literal", value: "delete", description: "\"delete\"" },
        peg$c406 = function() { return "delete"},
        peg$c407 = "var",
        peg$c408 = { type: "literal", value: "var", description: "\"var\"" },
        peg$c409 = "const",
        peg$c410 = { type: "literal", value: "const", description: "\"const\"" },
        peg$c411 = function() { return "const" },
        peg$c412 = "let",
        peg$c413 = { type: "literal", value: "let", description: "\"let\"" },
        peg$c414 = function() { return "let" },
        peg$c415 = "in",
        peg$c416 = { type: "literal", value: "in", description: "\"in\"" },
        peg$c417 = function() { return "in" },
        peg$c418 = "instanceof",
        peg$c419 = { type: "literal", value: "instanceof", description: "\"instanceof\"" },
        peg$c420 = function() { return "instanceof" },
        peg$c421 = "while",
        peg$c422 = { type: "literal", value: "while", description: "\"while\"" },
        peg$c423 = "for",
        peg$c424 = { type: "literal", value: "for", description: "\"for\"" },
        peg$c425 = "of",
        peg$c426 = { type: "literal", value: "of", description: "\"of\"" },
        peg$c427 = "if",
        peg$c428 = { type: "literal", value: "if", description: "\"if\"" },
        peg$c429 = "else",
        peg$c430 = { type: "literal", value: "else", description: "\"else\"" },
        peg$c431 = "return",
        peg$c432 = { type: "literal", value: "return", description: "\"return\"" },
        peg$c433 = "try",
        peg$c434 = { type: "literal", value: "try", description: "\"try\"" },
        peg$c435 = "catch",
        peg$c436 = { type: "literal", value: "catch", description: "\"catch\"" },
        peg$c437 = "finally",
        peg$c438 = { type: "literal", value: "finally", description: "\"finally\"" },
        peg$c439 = "throw",
        peg$c440 = { type: "literal", value: "throw", description: "\"throw\"" },
        peg$c441 = "break",
        peg$c442 = { type: "literal", value: "break", description: "\"break\"" },
        peg$c443 = "continue",
        peg$c444 = { type: "literal", value: "continue", description: "\"continue\"" },
        peg$c445 = "do",
        peg$c446 = { type: "literal", value: "do", description: "\"do\"" },
        peg$c447 = "undo",
        peg$c448 = { type: "literal", value: "undo", description: "\"undo\"" },
        peg$c449 = "import",
        peg$c450 = { type: "literal", value: "import", description: "\"import\"" },
        peg$c451 = "export",
        peg$c452 = { type: "literal", value: "export", description: "\"export\"" },
        peg$c453 = "class",
        peg$c454 = { type: "literal", value: "class", description: "\"class\"" },
        peg$c455 = "extends",
        peg$c456 = { type: "literal", value: "extends", description: "\"extends\"" },
        peg$c457 = "assert",
        peg$c458 = { type: "literal", value: "assert", description: "\"assert\"" },
        peg$c459 = "template",
        peg$c460 = { type: "literal", value: "template", description: "\"template\"" },
        peg$c461 = "activate",
        peg$c462 = { type: "literal", value: "activate", description: "\"activate\"" },
        peg$c463 = { type: "other", description: "INDENT" },
        peg$c464 = "{{{{",
        peg$c465 = { type: "literal", value: "{{{{", description: "\"{{{{\"" },
        peg$c466 = { type: "other", description: "OUTDENT" },
        peg$c467 = "}}}}",
        peg$c468 = { type: "literal", value: "}}}}", description: "\"}}}}\"" },
        peg$c469 = { type: "other", description: "space" },
        peg$c470 = " ",
        peg$c471 = { type: "literal", value: " ", description: "\" \"" },
        peg$c472 = "#",
        peg$c473 = { type: "literal", value: "#", description: "\"#\"" },
        peg$c474 = "\n",
        peg$c475 = { type: "literal", value: "\n", description: "\"\\n\"" },
        peg$c476 = { type: "other", description: "end of line" },
        peg$c477 = "\r",
        peg$c478 = { type: "literal", value: "\r", description: "\"\\r\"" },
        peg$c479 = { type: "other", description: "end of file" },

        peg$currPos          = 0,
        peg$reportedPos      = 0,
        peg$cachedPos        = 0,
        peg$cachedPosDetails = { line: 1, column: 1, seenCR: false },
        peg$maxFailPos       = 0,
        peg$maxFailExpected  = [],
        peg$silentFails      = 0,

        peg$cache = {},
        peg$result;

    if ("startRule" in options) {
      if (!(options.startRule in peg$startRuleFunctions)) {
        throw new Error("Can't start parsing from rule \"" + options.startRule + "\".");
      }

      peg$startRuleFunction = peg$startRuleFunctions[options.startRule];
    }

    function text() {
      return input.substring(peg$reportedPos, peg$currPos);
    }

    function offset() {
      return peg$reportedPos;
    }

    function line() {
      return peg$computePosDetails(peg$reportedPos).line;
    }

    function column() {
      return peg$computePosDetails(peg$reportedPos).column;
    }

    function expected(description) {
      throw peg$buildException(
        null,
        [{ type: "other", description: description }],
        peg$reportedPos
      );
    }

    function error(message) {
      throw peg$buildException(message, null, peg$reportedPos);
    }

    function peg$computePosDetails(pos) {
      function advance(details, startPos, endPos) {
        var p, ch;

        for (p = startPos; p < endPos; p++) {
          ch = input.charAt(p);
          if (ch === "\n") {
            if (!details.seenCR) { details.line++; }
            details.column = 1;
            details.seenCR = false;
          } else if (ch === "\r" || ch === "\u2028" || ch === "\u2029") {
            details.line++;
            details.column = 1;
            details.seenCR = true;
          } else {
            details.column++;
            details.seenCR = false;
          }
        }
      }

      if (peg$cachedPos !== pos) {
        if (peg$cachedPos > pos) {
          peg$cachedPos = 0;
          peg$cachedPosDetails = { line: 1, column: 1, seenCR: false };
        }
        advance(peg$cachedPosDetails, peg$cachedPos, pos);
        peg$cachedPos = pos;
      }

      return peg$cachedPosDetails;
    }

    function peg$fail(expected) {
      if (peg$currPos < peg$maxFailPos) { return; }

      if (peg$currPos > peg$maxFailPos) {
        peg$maxFailPos = peg$currPos;
        peg$maxFailExpected = [];
      }

      peg$maxFailExpected.push(expected);
    }

    function peg$buildException(message, expected, pos) {
      function cleanupExpected(expected) {
        var i = 1;

        expected.sort(function(a, b) {
          if (a.description < b.description) {
            return -1;
          } else if (a.description > b.description) {
            return 1;
          } else {
            return 0;
          }
        });

        while (i < expected.length) {
          if (expected[i - 1] === expected[i]) {
            expected.splice(i, 1);
          } else {
            i++;
          }
        }
      }

      function buildMessage(expected, found) {
        function stringEscape(s) {
          function hex(ch) { return ch.charCodeAt(0).toString(16).toUpperCase(); }

          return s
            .replace(/\\/g,   '\\\\')
            .replace(/"/g,    '\\"')
            .replace(/\x08/g, '\\b')
            .replace(/\t/g,   '\\t')
            .replace(/\n/g,   '\\n')
            .replace(/\f/g,   '\\f')
            .replace(/\r/g,   '\\r')
            .replace(/[\x00-\x07\x0B\x0E\x0F]/g, function(ch) { return '\\x0' + hex(ch); })
            .replace(/[\x10-\x1F\x80-\xFF]/g,    function(ch) { return '\\x'  + hex(ch); })
            .replace(/[\u0180-\u0FFF]/g,         function(ch) { return '\\u0' + hex(ch); })
            .replace(/[\u1080-\uFFFF]/g,         function(ch) { return '\\u'  + hex(ch); });
        }

        var expectedDescs = new Array(expected.length),
            expectedDesc, foundDesc, i;

        for (i = 0; i < expected.length; i++) {
          expectedDescs[i] = expected[i].description;
        }

        expectedDesc = expected.length > 1
          ? expectedDescs.slice(0, -1).join(", ")
              + " or "
              + expectedDescs[expected.length - 1]
          : expectedDescs[0];

        foundDesc = found ? "\"" + stringEscape(found) + "\"" : "end of input";

        return "Expected " + expectedDesc + " but " + foundDesc + " found.";
      }

      var posDetails = peg$computePosDetails(pos),
          found      = pos < input.length ? input.charAt(pos) : null;

      if (expected !== null) {
        cleanupExpected(expected);
      }

      return new SyntaxError(
        message !== null ? message : buildMessage(expected, found),
        expected,
        found,
        pos,
        posDetails.line,
        posDetails.column
      );
    }

    function peg$parseProgram() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 0,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        s2 = peg$parseProgramStatements();
        if (s2 !== peg$FAILED) {
          s3 = peg$parsestart();
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c1(s1, s2, s3);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseProgramStatements() {
      var s0, s1;

      var key    = peg$currPos * 189 + 1,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parseBlockStatement();
      if (s1 !== peg$FAILED) {
        peg$reportedPos = s0;
        s1 = peg$c2(s1);
      }
      s0 = s1;
      if (s0 === peg$FAILED) {
        s0 = [];
        s1 = peg$parseStatement();
        while (s1 !== peg$FAILED) {
          s0.push(s1);
          s1 = peg$parseStatement();
        }
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseStatement() {
      var s0, s1, s2, s3, s4, s5, s6;

      var key    = peg$currPos * 189 + 2,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parseeol();
      if (s1 === peg$FAILED) {
        s1 = peg$c4;
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$parse_();
        if (s2 !== peg$FAILED) {
          s3 = peg$parseUndoStatement();
          if (s3 === peg$FAILED) {
            s3 = peg$parseAssertStatement();
            if (s3 === peg$FAILED) {
              s3 = peg$parseExportStatement();
              if (s3 === peg$FAILED) {
                s3 = peg$parseVariableDeclaration();
                if (s3 === peg$FAILED) {
                  s3 = peg$parsePropertyDeclaration();
                  if (s3 === peg$FAILED) {
                    s3 = peg$parsePropertyDefinition();
                    if (s3 === peg$FAILED) {
                      s3 = peg$parseIterationStatement();
                      if (s3 === peg$FAILED) {
                        s3 = peg$parseIfStatement();
                        if (s3 === peg$FAILED) {
                          s3 = peg$parseReturnStatement();
                          if (s3 === peg$FAILED) {
                            s3 = peg$parseBreakStatement();
                            if (s3 === peg$FAILED) {
                              s3 = peg$parseContinueStatement();
                              if (s3 === peg$FAILED) {
                                s3 = peg$parseThrowStatement();
                                if (s3 === peg$FAILED) {
                                  s3 = peg$parseTryStatement();
                                  if (s3 === peg$FAILED) {
                                    s3 = peg$parseActivateStatement();
                                    if (s3 === peg$FAILED) {
                                      s3 = peg$parseExpressionStatement();
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
          if (s3 !== peg$FAILED) {
            s4 = peg$parseeol();
            if (s4 === peg$FAILED) {
              s4 = peg$currPos;
              s5 = peg$parse_();
              if (s5 !== peg$FAILED) {
                if (input.charCodeAt(peg$currPos) === 44) {
                  s6 = peg$c5;
                  peg$currPos++;
                } else {
                  s6 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$c6); }
                }
                if (s6 !== peg$FAILED) {
                  s5 = [s5, s6];
                  s4 = s5;
                } else {
                  peg$currPos = s4;
                  s4 = peg$c0;
                }
              } else {
                peg$currPos = s4;
                s4 = peg$c0;
              }
            }
            if (s4 !== peg$FAILED) {
              peg$reportedPos = s0;
              s1 = peg$c7(s3);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseExportStatement() {
      var s0, s1, s2, s3, s4, s5;

      var key    = peg$currPos * 189 + 3,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        s2 = peg$parseexport();
        if (s2 !== peg$FAILED) {
          s3 = peg$parse_();
          if (s3 !== peg$FAILED) {
            s4 = peg$parseVariableDeclaration();
            if (s4 === peg$FAILED) {
              s4 = peg$parseRightHandSideExpression();
            }
            if (s4 !== peg$FAILED) {
              s5 = peg$parsestart();
              if (s5 !== peg$FAILED) {
                peg$reportedPos = s0;
                s1 = peg$c8(s1, s4, s5);
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseReturnStatement() {
      var s0, s1, s2, s3, s4, s5;

      var key    = peg$currPos * 189 + 4,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        s2 = peg$parsereturn();
        if (s2 !== peg$FAILED) {
          s3 = peg$parse_();
          if (s3 !== peg$FAILED) {
            s4 = peg$parseRightHandSideExpression();
            if (s4 === peg$FAILED) {
              s4 = peg$c4;
            }
            if (s4 !== peg$FAILED) {
              s5 = peg$parsestart();
              if (s5 !== peg$FAILED) {
                peg$reportedPos = s0;
                s1 = peg$c9(s1, s4, s5);
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseThrowStatement() {
      var s0, s1, s2, s3, s4, s5;

      var key    = peg$currPos * 189 + 5,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        s2 = peg$parsethrow();
        if (s2 !== peg$FAILED) {
          s3 = peg$parse_();
          if (s3 !== peg$FAILED) {
            s4 = peg$parseRightHandSideExpression();
            if (s4 !== peg$FAILED) {
              s5 = peg$parsestart();
              if (s5 !== peg$FAILED) {
                peg$reportedPos = s0;
                s1 = peg$c10(s1, s4, s5);
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseBreakStatement() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 6,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        s2 = peg$parsebreak();
        if (s2 !== peg$FAILED) {
          s3 = peg$parsestart();
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c11(s1, s3);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseContinueStatement() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 7,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        s2 = peg$parsecontinue();
        if (s2 !== peg$FAILED) {
          s3 = peg$parsestart();
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c12(s1, s3);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseAssertStatement() {
      var s0, s1, s2, s3, s4, s5;

      var key    = peg$currPos * 189 + 8,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        s2 = peg$parseassert();
        if (s2 !== peg$FAILED) {
          s3 = peg$parse_();
          if (s3 !== peg$FAILED) {
            s4 = peg$currPos;
            s5 = peg$parseExpression();
            if (s5 !== peg$FAILED) {
              peg$reportedPos = s4;
              s5 = peg$c13(s5);
            }
            s4 = s5;
            if (s4 !== peg$FAILED) {
              s5 = peg$parsestart();
              if (s5 !== peg$FAILED) {
                peg$reportedPos = s0;
                s1 = peg$c14(s1, s4, s5);
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseExpressionStatement() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 9,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        s2 = peg$parseExpression();
        if (s2 !== peg$FAILED) {
          s3 = peg$parsestart();
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c15(s1, s2, s3);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseActivateStatement() {
      var s0, s1, s2, s3, s4, s5, s6;

      var key    = peg$currPos * 189 + 10,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        s2 = peg$parseactivate();
        if (s2 !== peg$FAILED) {
          s3 = peg$parse_();
          if (s3 !== peg$FAILED) {
            s4 = peg$currPos;
            peg$silentFails++;
            s5 = peg$parsetemplate();
            peg$silentFails--;
            if (s5 !== peg$FAILED) {
              peg$currPos = s4;
              s4 = peg$c16;
            } else {
              s4 = peg$c0;
            }
            if (s4 !== peg$FAILED) {
              s5 = peg$parseFunctionExpression();
              if (s5 !== peg$FAILED) {
                s6 = peg$parsestart();
                if (s6 !== peg$FAILED) {
                  peg$reportedPos = s0;
                  s1 = peg$c17(s1, s5, s6);
                  s0 = s1;
                } else {
                  peg$currPos = s0;
                  s0 = peg$c0;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseIfStatement() {
      var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11;

      var key    = peg$currPos * 189 + 11,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        s2 = peg$parseif();
        if (s2 !== peg$FAILED) {
          s3 = peg$parse_();
          if (s3 !== peg$FAILED) {
            s4 = peg$parseAssignmentExpression();
            if (s4 !== peg$FAILED) {
              s5 = peg$parseBlockStatement();
              if (s5 !== peg$FAILED) {
                s6 = peg$currPos;
                s7 = peg$parseeol();
                if (s7 !== peg$FAILED) {
                  s8 = peg$parse_();
                  if (s8 !== peg$FAILED) {
                    s9 = peg$parseelse();
                    if (s9 !== peg$FAILED) {
                      s10 = peg$parse_();
                      if (s10 !== peg$FAILED) {
                        s11 = peg$parseIfStatement();
                        if (s11 === peg$FAILED) {
                          s11 = peg$parseBlockStatement();
                        }
                        if (s11 !== peg$FAILED) {
                          peg$reportedPos = s6;
                          s7 = peg$c18(s11);
                          s6 = s7;
                        } else {
                          peg$currPos = s6;
                          s6 = peg$c0;
                        }
                      } else {
                        peg$currPos = s6;
                        s6 = peg$c0;
                      }
                    } else {
                      peg$currPos = s6;
                      s6 = peg$c0;
                    }
                  } else {
                    peg$currPos = s6;
                    s6 = peg$c0;
                  }
                } else {
                  peg$currPos = s6;
                  s6 = peg$c0;
                }
                if (s6 === peg$FAILED) {
                  s6 = peg$c4;
                }
                if (s6 !== peg$FAILED) {
                  s7 = peg$parsestart();
                  if (s7 !== peg$FAILED) {
                    peg$reportedPos = s0;
                    s1 = peg$c19(s1, s4, s5, s6, s7);
                    s0 = s1;
                  } else {
                    peg$currPos = s0;
                    s0 = peg$c0;
                  }
                } else {
                  peg$currPos = s0;
                  s0 = peg$c0;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseTryStatement() {
      var s0, s1, s2, s3, s4, s5, s6;

      var key    = peg$currPos * 189 + 12,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        s2 = peg$parsetry();
        if (s2 !== peg$FAILED) {
          s3 = peg$parseBlockStatement();
          if (s3 !== peg$FAILED) {
            s4 = peg$parsecatchClause();
            if (s4 !== peg$FAILED) {
              s5 = peg$parsefinallyClause();
              if (s5 === peg$FAILED) {
                s5 = peg$c4;
              }
              if (s5 !== peg$FAILED) {
                s6 = peg$parsestart();
                if (s6 !== peg$FAILED) {
                  peg$reportedPos = s0;
                  s1 = peg$c20(s1, s3, s4, s5, s6);
                  s0 = s1;
                } else {
                  peg$currPos = s0;
                  s0 = peg$c0;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        s1 = peg$parsestart();
        if (s1 !== peg$FAILED) {
          s2 = peg$parsetry();
          if (s2 !== peg$FAILED) {
            s3 = peg$parseBlockStatement();
            if (s3 !== peg$FAILED) {
              s4 = peg$parsefinallyClause();
              if (s4 !== peg$FAILED) {
                s5 = peg$parsestart();
                if (s5 !== peg$FAILED) {
                  peg$reportedPos = s0;
                  s1 = peg$c21(s1, s3, s4, s5);
                  s0 = s1;
                } else {
                  peg$currPos = s0;
                  s0 = peg$c0;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsefinallyClause() {
      var s0, s1, s2, s3, s4;

      var key    = peg$currPos * 189 + 13,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parseeol();
      if (s1 !== peg$FAILED) {
        s2 = peg$parse_();
        if (s2 !== peg$FAILED) {
          s3 = peg$parsefinally();
          if (s3 !== peg$FAILED) {
            s4 = peg$parseBlockStatement();
            if (s4 !== peg$FAILED) {
              peg$reportedPos = s0;
              s1 = peg$c7(s4);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsecatchClause() {
      var s0, s1, s2, s3, s4, s5, s6, s7, s8;

      var key    = peg$currPos * 189 + 14,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        s2 = peg$parseeol();
        if (s2 !== peg$FAILED) {
          s3 = peg$parse_();
          if (s3 !== peg$FAILED) {
            s4 = peg$parsecatch();
            if (s4 !== peg$FAILED) {
              s5 = peg$parse_();
              if (s5 !== peg$FAILED) {
                s6 = peg$parseIdentifier();
                if (s6 !== peg$FAILED) {
                  s7 = peg$parseBlockStatement();
                  if (s7 !== peg$FAILED) {
                    s8 = peg$parsestart();
                    if (s8 !== peg$FAILED) {
                      peg$reportedPos = s0;
                      s1 = peg$c22(s1, s6, s7, s8);
                      s0 = s1;
                    } else {
                      peg$currPos = s0;
                      s0 = peg$c0;
                    }
                  } else {
                    peg$currPos = s0;
                    s0 = peg$c0;
                  }
                } else {
                  peg$currPos = s0;
                  s0 = peg$c0;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseIterationStatement() {
      var s0;

      var key    = peg$currPos * 189 + 15,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$parseWhileStatement();
      if (s0 === peg$FAILED) {
        s0 = peg$parseForInOfStatement();
        if (s0 === peg$FAILED) {
          s0 = peg$parseForStatement();
        }
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseWhileStatement() {
      var s0, s1, s2, s3, s4, s5, s6;

      var key    = peg$currPos * 189 + 16,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        s2 = peg$parsewhile();
        if (s2 !== peg$FAILED) {
          s3 = peg$parse_();
          if (s3 !== peg$FAILED) {
            s4 = peg$parseAssignmentExpression();
            if (s4 !== peg$FAILED) {
              s5 = peg$parseBlockStatement();
              if (s5 !== peg$FAILED) {
                s6 = peg$parsestart();
                if (s6 !== peg$FAILED) {
                  peg$reportedPos = s0;
                  s1 = peg$c23(s1, s4, s5, s6);
                  s0 = s1;
                } else {
                  peg$currPos = s0;
                  s0 = peg$c0;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseForInOfHead() {
      var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12;

      var key    = peg$currPos * 189 + 17,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsefor();
      if (s1 !== peg$FAILED) {
        s2 = peg$parse_();
        if (s2 !== peg$FAILED) {
          s3 = peg$parseVariableDeclarationKindOptional();
          if (s3 !== peg$FAILED) {
            s4 = peg$parse_();
            if (s4 !== peg$FAILED) {
              s5 = peg$currPos;
              s6 = peg$parsein();
              if (s6 !== peg$FAILED) {
                peg$reportedPos = s5;
                s6 = peg$c24();
              }
              s5 = s6;
              if (s5 === peg$FAILED) {
                s5 = peg$currPos;
                s6 = peg$parseof();
                if (s6 !== peg$FAILED) {
                  peg$reportedPos = s5;
                  s6 = peg$c25();
                }
                s5 = s6;
              }
              if (s5 !== peg$FAILED) {
                s6 = peg$parse_();
                if (s6 !== peg$FAILED) {
                  s7 = peg$parseAssignmentExpression();
                  if (s7 !== peg$FAILED) {
                    s8 = peg$parse_();
                    if (s8 !== peg$FAILED) {
                      s9 = peg$currPos;
                      s10 = peg$parseif();
                      if (s10 !== peg$FAILED) {
                        s11 = peg$parse_();
                        if (s11 !== peg$FAILED) {
                          s12 = peg$parseAssignmentExpression();
                          if (s12 !== peg$FAILED) {
                            peg$reportedPos = s9;
                            s10 = peg$c26(s12);
                            s9 = s10;
                          } else {
                            peg$currPos = s9;
                            s9 = peg$c0;
                          }
                        } else {
                          peg$currPos = s9;
                          s9 = peg$c0;
                        }
                      } else {
                        peg$currPos = s9;
                        s9 = peg$c0;
                      }
                      if (s9 === peg$FAILED) {
                        s9 = peg$c4;
                      }
                      if (s9 !== peg$FAILED) {
                        s10 = peg$parse_();
                        if (s10 !== peg$FAILED) {
                          s11 = peg$parseForInOfHead();
                          if (s11 === peg$FAILED) {
                            s11 = peg$c4;
                          }
                          if (s11 !== peg$FAILED) {
                            peg$reportedPos = s0;
                            s1 = peg$c27(s3, s5, s7, s9, s11);
                            s0 = s1;
                          } else {
                            peg$currPos = s0;
                            s0 = peg$c0;
                          }
                        } else {
                          peg$currPos = s0;
                          s0 = peg$c0;
                        }
                      } else {
                        peg$currPos = s0;
                        s0 = peg$c0;
                      }
                    } else {
                      peg$currPos = s0;
                      s0 = peg$c0;
                    }
                  } else {
                    peg$currPos = s0;
                    s0 = peg$c0;
                  }
                } else {
                  peg$currPos = s0;
                  s0 = peg$c0;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseForInOfElseStatement() {
      var s0, s1, s2, s3, s4, s5, s6, s7;

      var key    = peg$currPos * 189 + 18,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parseeol();
      if (s1 !== peg$FAILED) {
        s2 = peg$parse_();
        if (s2 !== peg$FAILED) {
          s3 = peg$parsestart();
          if (s3 !== peg$FAILED) {
            s4 = peg$parseelse();
            if (s4 !== peg$FAILED) {
              s5 = peg$parse_();
              if (s5 !== peg$FAILED) {
                s6 = peg$parseBlockStatement();
                if (s6 !== peg$FAILED) {
                  s7 = peg$parsestart();
                  if (s7 !== peg$FAILED) {
                    peg$reportedPos = s0;
                    s1 = peg$c28(s3, s6, s7);
                    s0 = s1;
                  } else {
                    peg$currPos = s0;
                    s0 = peg$c0;
                  }
                } else {
                  peg$currPos = s0;
                  s0 = peg$c0;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseForInOfStatement() {
      var s0, s1, s2, s3, s4, s5;

      var key    = peg$currPos * 189 + 19,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        s2 = peg$parseForInOfHead();
        if (s2 !== peg$FAILED) {
          s3 = peg$parseBlockStatement();
          if (s3 !== peg$FAILED) {
            s4 = peg$parseForInOfElseStatement();
            if (s4 === peg$FAILED) {
              s4 = peg$c4;
            }
            if (s4 !== peg$FAILED) {
              s5 = peg$parsestart();
              if (s5 !== peg$FAILED) {
                peg$reportedPos = s0;
                s1 = peg$c29(s1, s2, s3, s4, s5);
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseForHead() {
      var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11;

      var key    = peg$currPos * 189 + 20,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsefor();
      if (s1 !== peg$FAILED) {
        s2 = peg$parse_();
        if (s2 !== peg$FAILED) {
          s3 = peg$parseVariableDeclaration();
          if (s3 === peg$FAILED) {
            s3 = peg$parseAssignmentExpression();
          }
          if (s3 === peg$FAILED) {
            s3 = peg$c4;
          }
          if (s3 !== peg$FAILED) {
            s4 = peg$parse_();
            if (s4 !== peg$FAILED) {
              if (input.charCodeAt(peg$currPos) === 59) {
                s5 = peg$c30;
                peg$currPos++;
              } else {
                s5 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c31); }
              }
              if (s5 !== peg$FAILED) {
                s6 = peg$parse_();
                if (s6 !== peg$FAILED) {
                  s7 = peg$parseAssignmentExpression();
                  if (s7 === peg$FAILED) {
                    s7 = peg$c4;
                  }
                  if (s7 !== peg$FAILED) {
                    s8 = peg$parse_();
                    if (s8 !== peg$FAILED) {
                      if (input.charCodeAt(peg$currPos) === 59) {
                        s9 = peg$c30;
                        peg$currPos++;
                      } else {
                        s9 = peg$FAILED;
                        if (peg$silentFails === 0) { peg$fail(peg$c31); }
                      }
                      if (s9 !== peg$FAILED) {
                        s10 = peg$parse_();
                        if (s10 !== peg$FAILED) {
                          s11 = peg$parseAssignmentExpression();
                          if (s11 === peg$FAILED) {
                            s11 = peg$c4;
                          }
                          if (s11 !== peg$FAILED) {
                            peg$reportedPos = s0;
                            s1 = peg$c32(s3, s7, s11);
                            s0 = s1;
                          } else {
                            peg$currPos = s0;
                            s0 = peg$c0;
                          }
                        } else {
                          peg$currPos = s0;
                          s0 = peg$c0;
                        }
                      } else {
                        peg$currPos = s0;
                        s0 = peg$c0;
                      }
                    } else {
                      peg$currPos = s0;
                      s0 = peg$c0;
                    }
                  } else {
                    peg$currPos = s0;
                    s0 = peg$c0;
                  }
                } else {
                  peg$currPos = s0;
                  s0 = peg$c0;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseForStatement() {
      var s0, s1, s2, s3, s4;

      var key    = peg$currPos * 189 + 21,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        s2 = peg$parseForHead();
        if (s2 !== peg$FAILED) {
          s3 = peg$parseBlockStatement();
          if (s3 !== peg$FAILED) {
            s4 = peg$parsestart();
            if (s4 !== peg$FAILED) {
              peg$reportedPos = s0;
              s1 = peg$c33(s1, s2, s3, s4);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseArrayComprehension() {
      var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9;

      var key    = peg$currPos * 189 + 22,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        if (input.charCodeAt(peg$currPos) === 91) {
          s2 = peg$c34;
          peg$currPos++;
        } else {
          s2 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c35); }
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$parse_();
          if (s3 !== peg$FAILED) {
            s4 = peg$parseAssignmentExpression();
            if (s4 !== peg$FAILED) {
              s5 = peg$parse_();
              if (s5 !== peg$FAILED) {
                s6 = peg$parseForInOfHead();
                if (s6 === peg$FAILED) {
                  s6 = peg$parseForHead();
                }
                if (s6 !== peg$FAILED) {
                  s7 = peg$parse_();
                  if (s7 !== peg$FAILED) {
                    if (input.charCodeAt(peg$currPos) === 93) {
                      s8 = peg$c36;
                      peg$currPos++;
                    } else {
                      s8 = peg$FAILED;
                      if (peg$silentFails === 0) { peg$fail(peg$c37); }
                    }
                    if (s8 !== peg$FAILED) {
                      s9 = peg$parsestart();
                      if (s9 !== peg$FAILED) {
                        peg$reportedPos = s0;
                        s1 = peg$c38(s1, s4, s6, s9);
                        s0 = s1;
                      } else {
                        peg$currPos = s0;
                        s0 = peg$c0;
                      }
                    } else {
                      peg$currPos = s0;
                      s0 = peg$c0;
                    }
                  } else {
                    peg$currPos = s0;
                    s0 = peg$c0;
                  }
                } else {
                  peg$currPos = s0;
                  s0 = peg$c0;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseBlockStatement() {
      var s0, s1, s2, s3, s4, s5, s6;

      var key    = peg$currPos * 189 + 23,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parseindent();
      if (s1 !== peg$FAILED) {
        s2 = peg$parseeol();
        if (s2 !== peg$FAILED) {
          s3 = peg$parsestart();
          if (s3 !== peg$FAILED) {
            s4 = [];
            s5 = peg$parseStatement();
            while (s5 !== peg$FAILED) {
              s4.push(s5);
              s5 = peg$parseStatement();
            }
            if (s4 !== peg$FAILED) {
              s5 = peg$parsestart();
              if (s5 !== peg$FAILED) {
                s6 = peg$parseoutdent();
                if (s6 !== peg$FAILED) {
                  peg$reportedPos = s0;
                  s1 = peg$c39(s3, s4, s5);
                  s0 = s1;
                } else {
                  peg$currPos = s0;
                  s0 = peg$c0;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseClassExpression() {
      var s0, s1, s2, s3, s4, s5, s6, s7, s8;

      var key    = peg$currPos * 189 + 24,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        s2 = peg$parseclass();
        if (s2 !== peg$FAILED) {
          s3 = peg$parse_();
          if (s3 !== peg$FAILED) {
            s4 = peg$parseclassName();
            if (s4 === peg$FAILED) {
              s4 = peg$c4;
            }
            if (s4 !== peg$FAILED) {
              s5 = peg$parse_();
              if (s5 !== peg$FAILED) {
                s6 = peg$parseclassExtends();
                if (s6 === peg$FAILED) {
                  s6 = peg$c4;
                }
                if (s6 !== peg$FAILED) {
                  s7 = peg$parseBlockStatement();
                  if (s7 === peg$FAILED) {
                    s7 = peg$c4;
                  }
                  if (s7 !== peg$FAILED) {
                    s8 = peg$parsestart();
                    if (s8 !== peg$FAILED) {
                      peg$reportedPos = s0;
                      s1 = peg$c40(s1, s4, s6, s7, s8);
                      s0 = s1;
                    } else {
                      peg$currPos = s0;
                      s0 = peg$c0;
                    }
                  } else {
                    peg$currPos = s0;
                    s0 = peg$c0;
                  }
                } else {
                  peg$currPos = s0;
                  s0 = peg$c0;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseclassName() {
      var s0, s1, s2, s3, s4, s5;

      var key    = peg$currPos * 189 + 25,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parseIdentifier();
      if (s1 !== peg$FAILED) {
        peg$reportedPos = s0;
        s1 = peg$c41(s1);
      }
      s0 = s1;
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        if (input.charCodeAt(peg$currPos) === 91) {
          s1 = peg$c34;
          peg$currPos++;
        } else {
          s1 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c35); }
        }
        if (s1 !== peg$FAILED) {
          s2 = peg$parse_();
          if (s2 !== peg$FAILED) {
            s3 = peg$parseAssignmentExpression();
            if (s3 !== peg$FAILED) {
              s4 = peg$parse_();
              if (s4 !== peg$FAILED) {
                if (input.charCodeAt(peg$currPos) === 93) {
                  s5 = peg$c36;
                  peg$currPos++;
                } else {
                  s5 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$c37); }
                }
                if (s5 !== peg$FAILED) {
                  peg$reportedPos = s0;
                  s1 = peg$c42(s3);
                  s0 = s1;
                } else {
                  peg$currPos = s0;
                  s0 = peg$c0;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseclassExtends() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 26,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parseextends();
      if (s1 !== peg$FAILED) {
        s2 = peg$parse_();
        if (s2 !== peg$FAILED) {
          s3 = peg$parseelementList();
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c43(s3);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsepath() {
      var s0, s1, s2, s3, s4, s5;

      var key    = peg$currPos * 189 + 27,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parseIdentifier();
      if (s1 !== peg$FAILED) {
        s2 = [];
        s3 = peg$currPos;
        if (input.charCodeAt(peg$currPos) === 46) {
          s4 = peg$c44;
          peg$currPos++;
        } else {
          s4 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c45); }
        }
        if (s4 !== peg$FAILED) {
          s5 = peg$parseIdentifier();
          if (s5 !== peg$FAILED) {
            peg$reportedPos = s3;
            s4 = peg$c18(s5);
            s3 = s4;
          } else {
            peg$currPos = s3;
            s3 = peg$c0;
          }
        } else {
          peg$currPos = s3;
          s3 = peg$c0;
        }
        if (s3 !== peg$FAILED) {
          while (s3 !== peg$FAILED) {
            s2.push(s3);
            s3 = peg$currPos;
            if (input.charCodeAt(peg$currPos) === 46) {
              s4 = peg$c44;
              peg$currPos++;
            } else {
              s4 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c45); }
            }
            if (s4 !== peg$FAILED) {
              s5 = peg$parseIdentifier();
              if (s5 !== peg$FAILED) {
                peg$reportedPos = s3;
                s4 = peg$c18(s5);
                s3 = s4;
              } else {
                peg$currPos = s3;
                s3 = peg$c0;
              }
            } else {
              peg$currPos = s3;
              s3 = peg$c0;
            }
          }
        } else {
          s2 = peg$c0;
        }
        if (s2 !== peg$FAILED) {
          peg$reportedPos = s0;
          s1 = peg$c46(s1, s2);
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsepropertyLeft() {
      var s0, s1, s2, s3, s4, s5;

      var key    = peg$currPos * 189 + 28,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsepath();
      if (s1 === peg$FAILED) {
        s1 = peg$parseIdentifierName();
        if (s1 === peg$FAILED) {
          s1 = peg$parseStringOrNumberLiteral();
        }
      }
      if (s1 !== peg$FAILED) {
        peg$reportedPos = s0;
        s1 = peg$c47(s1);
      }
      s0 = s1;
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        if (input.charCodeAt(peg$currPos) === 91) {
          s1 = peg$c34;
          peg$currPos++;
        } else {
          s1 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c35); }
        }
        if (s1 !== peg$FAILED) {
          s2 = peg$parse_();
          if (s2 !== peg$FAILED) {
            s3 = peg$parseAssignmentExpression();
            if (s3 !== peg$FAILED) {
              s4 = peg$parse_();
              if (s4 !== peg$FAILED) {
                if (input.charCodeAt(peg$currPos) === 93) {
                  s5 = peg$c36;
                  peg$currPos++;
                } else {
                  s5 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$c37); }
                }
                if (s5 !== peg$FAILED) {
                  peg$reportedPos = s0;
                  s1 = peg$c48(s3);
                  s0 = s1;
                } else {
                  peg$currPos = s0;
                  s0 = peg$c0;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsePropertyDefinition() {
      var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9;

      var key    = peg$currPos * 189 + 29,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        if (input.substr(peg$currPos, 9) === peg$c49) {
          s2 = peg$c49;
          peg$currPos += 9;
        } else {
          s2 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c50); }
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$parse_();
          if (s3 !== peg$FAILED) {
            s4 = peg$parsepropertyLeft();
            if (s4 !== peg$FAILED) {
              s5 = peg$parse_();
              if (s5 !== peg$FAILED) {
                if (input.charCodeAt(peg$currPos) === 58) {
                  s6 = peg$c51;
                  peg$currPos++;
                } else {
                  s6 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$c52); }
                }
                if (s6 !== peg$FAILED) {
                  s7 = peg$parse_();
                  if (s7 !== peg$FAILED) {
                    s8 = peg$parseRightHandSideExpression();
                    if (s8 !== peg$FAILED) {
                      s9 = peg$parsestart();
                      if (s9 !== peg$FAILED) {
                        peg$reportedPos = s0;
                        s1 = peg$c53(s1, s4, s8, s9);
                        s0 = s1;
                      } else {
                        peg$currPos = s0;
                        s0 = peg$c0;
                      }
                    } else {
                      peg$currPos = s0;
                      s0 = peg$c0;
                    }
                  } else {
                    peg$currPos = s0;
                    s0 = peg$c0;
                  }
                } else {
                  peg$currPos = s0;
                  s0 = peg$c0;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsePropertyDeclaration() {
      var s0, s1, s2, s3, s4, s5, s6, s7;

      var key    = peg$currPos * 189 + 30,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        s2 = peg$parsepropertyLeft();
        if (s2 !== peg$FAILED) {
          s3 = peg$parse_();
          if (s3 !== peg$FAILED) {
            if (input.charCodeAt(peg$currPos) === 58) {
              s4 = peg$c51;
              peg$currPos++;
            } else {
              s4 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c52); }
            }
            if (s4 !== peg$FAILED) {
              s5 = peg$parse_();
              if (s5 !== peg$FAILED) {
                s6 = peg$parseRightHandSideExpression();
                if (s6 !== peg$FAILED) {
                  s7 = peg$parsestart();
                  if (s7 !== peg$FAILED) {
                    peg$reportedPos = s0;
                    s1 = peg$c54(s1, s2, s6, s7);
                    s0 = s1;
                  } else {
                    peg$currPos = s0;
                    s0 = peg$c0;
                  }
                } else {
                  peg$currPos = s0;
                  s0 = peg$c0;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseVariableDeclaration() {
      var s0, s1, s2;

      var key    = peg$currPos * 189 + 31,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$currPos;
      peg$silentFails++;
      s2 = peg$parsevariableKind();
      peg$silentFails--;
      if (s2 !== peg$FAILED) {
        peg$currPos = s1;
        s1 = peg$c16;
      } else {
        s1 = peg$c0;
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$parseVariableDeclarationKindOptional();
        if (s2 !== peg$FAILED) {
          peg$reportedPos = s0;
          s1 = peg$c7(s2);
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseVariableDeclarationKindOptional() {
      var s0, s1, s2, s3, s4, s5;

      var key    = peg$currPos * 189 + 32,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        s2 = peg$parsevariableKind();
        if (s2 === peg$FAILED) {
          s2 = peg$c4;
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$parse_();
          if (s3 !== peg$FAILED) {
            s4 = peg$parsevariableDeclaratorList();
            if (s4 !== peg$FAILED) {
              s5 = peg$parsestart();
              if (s5 !== peg$FAILED) {
                peg$reportedPos = s0;
                s1 = peg$c55(s1, s2, s4, s5);
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsevariableKind() {
      var s0;

      var key    = peg$currPos * 189 + 33,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$parselet();
      if (s0 === peg$FAILED) {
        s0 = peg$parseconst();
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsevariableDeclaratorList() {
      var s0;

      var key    = peg$currPos * 189 + 34,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$parsemultilineVariableDeclaratorList();
      if (s0 === peg$FAILED) {
        s0 = peg$parseinlineVariableDeclaratorList();
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseinlineVariableDeclaratorList() {
      var s0, s1, s2, s3, s4, s5, s6, s7;

      var key    = peg$currPos * 189 + 35,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parseVariableDeclarator();
      if (s1 !== peg$FAILED) {
        s2 = [];
        s3 = peg$currPos;
        s4 = peg$parse_();
        if (s4 !== peg$FAILED) {
          if (input.charCodeAt(peg$currPos) === 44) {
            s5 = peg$c5;
            peg$currPos++;
          } else {
            s5 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c6); }
          }
          if (s5 !== peg$FAILED) {
            s6 = peg$parse_();
            if (s6 !== peg$FAILED) {
              s7 = peg$parseVariableDeclarator();
              if (s7 !== peg$FAILED) {
                peg$reportedPos = s3;
                s4 = peg$c18(s7);
                s3 = s4;
              } else {
                peg$currPos = s3;
                s3 = peg$c0;
              }
            } else {
              peg$currPos = s3;
              s3 = peg$c0;
            }
          } else {
            peg$currPos = s3;
            s3 = peg$c0;
          }
        } else {
          peg$currPos = s3;
          s3 = peg$c0;
        }
        while (s3 !== peg$FAILED) {
          s2.push(s3);
          s3 = peg$currPos;
          s4 = peg$parse_();
          if (s4 !== peg$FAILED) {
            if (input.charCodeAt(peg$currPos) === 44) {
              s5 = peg$c5;
              peg$currPos++;
            } else {
              s5 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c6); }
            }
            if (s5 !== peg$FAILED) {
              s6 = peg$parse_();
              if (s6 !== peg$FAILED) {
                s7 = peg$parseVariableDeclarator();
                if (s7 !== peg$FAILED) {
                  peg$reportedPos = s3;
                  s4 = peg$c18(s7);
                  s3 = s4;
                } else {
                  peg$currPos = s3;
                  s3 = peg$c0;
                }
              } else {
                peg$currPos = s3;
                s3 = peg$c0;
              }
            } else {
              peg$currPos = s3;
              s3 = peg$c0;
            }
          } else {
            peg$currPos = s3;
            s3 = peg$c0;
          }
        }
        if (s2 !== peg$FAILED) {
          peg$reportedPos = s0;
          s1 = peg$c46(s1, s2);
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsemultilineVariableDeclaratorList() {
      var s0, s1, s2, s3, s4, s5, s6, s7;

      var key    = peg$currPos * 189 + 36,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parseindent();
      if (s1 !== peg$FAILED) {
        s2 = peg$parseeol();
        if (s2 !== peg$FAILED) {
          s3 = [];
          s4 = peg$currPos;
          s5 = peg$parse_();
          if (s5 !== peg$FAILED) {
            s6 = peg$parseVariableDeclarator();
            if (s6 !== peg$FAILED) {
              s7 = peg$parseeol();
              if (s7 === peg$FAILED) {
                s7 = peg$c4;
              }
              if (s7 !== peg$FAILED) {
                peg$reportedPos = s4;
                s5 = peg$c7(s6);
                s4 = s5;
              } else {
                peg$currPos = s4;
                s4 = peg$c0;
              }
            } else {
              peg$currPos = s4;
              s4 = peg$c0;
            }
          } else {
            peg$currPos = s4;
            s4 = peg$c0;
          }
          if (s4 !== peg$FAILED) {
            while (s4 !== peg$FAILED) {
              s3.push(s4);
              s4 = peg$currPos;
              s5 = peg$parse_();
              if (s5 !== peg$FAILED) {
                s6 = peg$parseVariableDeclarator();
                if (s6 !== peg$FAILED) {
                  s7 = peg$parseeol();
                  if (s7 === peg$FAILED) {
                    s7 = peg$c4;
                  }
                  if (s7 !== peg$FAILED) {
                    peg$reportedPos = s4;
                    s5 = peg$c7(s6);
                    s4 = s5;
                  } else {
                    peg$currPos = s4;
                    s4 = peg$c0;
                  }
                } else {
                  peg$currPos = s4;
                  s4 = peg$c0;
                }
              } else {
                peg$currPos = s4;
                s4 = peg$c0;
              }
            }
          } else {
            s3 = peg$c0;
          }
          if (s3 !== peg$FAILED) {
            s4 = peg$parseoutdent();
            if (s4 !== peg$FAILED) {
              peg$reportedPos = s0;
              s1 = peg$c56(s3);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseVariableDeclarator() {
      var s0, s1, s2, s3, s4, s5;

      var key    = peg$currPos * 189 + 37,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        s3 = peg$parseIdentifier();
        peg$silentFails--;
        if (s3 !== peg$FAILED) {
          peg$currPos = s2;
          s2 = peg$c16;
        } else {
          s2 = peg$c0;
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$parseFunctionExpression();
          if (s3 !== peg$FAILED) {
            s4 = peg$parsestart();
            if (s4 !== peg$FAILED) {
              peg$reportedPos = s0;
              s1 = peg$c57(s1, s3, s4);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        s1 = peg$parsestart();
        if (s1 !== peg$FAILED) {
          s2 = peg$parsePattern();
          if (s2 !== peg$FAILED) {
            s3 = peg$parse_();
            if (s3 !== peg$FAILED) {
              s4 = peg$parsevariableInitializer();
              if (s4 === peg$FAILED) {
                s4 = peg$c4;
              }
              if (s4 !== peg$FAILED) {
                s5 = peg$parsestart();
                if (s5 !== peg$FAILED) {
                  peg$reportedPos = s0;
                  s1 = peg$c58(s1, s2, s4, s5);
                  s0 = s1;
                } else {
                  peg$currPos = s0;
                  s0 = peg$c0;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsevariableInitializer() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 38,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.charCodeAt(peg$currPos) === 61) {
        s1 = peg$c59;
        peg$currPos++;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c60); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$parse_();
        if (s2 !== peg$FAILED) {
          s3 = peg$parseRightHandSideExpression();
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c7(s3);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsePattern() {
      var s0;

      var key    = peg$currPos * 189 + 39,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$parseIdentifier();
      if (s0 === peg$FAILED) {
        s0 = peg$parseObjectPattern();
        if (s0 === peg$FAILED) {
          s0 = peg$parseArrayPattern();
        }
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseObjectPattern() {
      var s0, s1;

      var key    = peg$currPos * 189 + 40,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parseObjectLiteral();
      if (s1 !== peg$FAILED) {
        peg$reportedPos = s0;
        s1 = peg$c61(s1);
      }
      s0 = s1;

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseArrayPattern() {
      var s0, s1;

      var key    = peg$currPos * 189 + 41,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parseArrayLiteral();
      if (s1 !== peg$FAILED) {
        peg$reportedPos = s0;
        s1 = peg$c62(s1);
      }
      s0 = s1;

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseSpreadPattern() {
      var s0;

      var key    = peg$currPos * 189 + 42,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$parseSpreadIdentifier();
      if (s0 === peg$FAILED) {
        s0 = peg$parsePattern();
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsespread() {
      var s0;

      var key    = peg$currPos * 189 + 43,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      if (input.substr(peg$currPos, 3) === peg$c63) {
        s0 = peg$c63;
        peg$currPos += 3;
      } else {
        s0 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c64); }
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseSpreadExpression() {
      var s0, s1, s2, s3, s4, s5;

      var key    = peg$currPos * 189 + 44,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        s2 = peg$parsespread();
        if (s2 !== peg$FAILED) {
          s3 = peg$parse_();
          if (s3 !== peg$FAILED) {
            s4 = peg$parseAssignmentExpression();
            if (s4 !== peg$FAILED) {
              s5 = peg$parsestart();
              if (s5 !== peg$FAILED) {
                peg$reportedPos = s0;
                s1 = peg$c65(s1, s4, s5);
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }
      if (s0 === peg$FAILED) {
        s0 = peg$parseAssignmentExpression();
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseSpreadIdentifier() {
      var s0, s1, s2, s3, s4, s5;

      var key    = peg$currPos * 189 + 45,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        s2 = peg$parsespread();
        if (s2 !== peg$FAILED) {
          s3 = peg$parse_();
          if (s3 !== peg$FAILED) {
            s4 = peg$parseIdentifier();
            if (s4 !== peg$FAILED) {
              s5 = peg$parsestart();
              if (s5 !== peg$FAILED) {
                peg$reportedPos = s0;
                s1 = peg$c65(s1, s4, s5);
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }
      if (s0 === peg$FAILED) {
        s0 = peg$parseIdentifier();
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseRightHandSideExpression() {
      var s0;

      var key    = peg$currPos * 189 + 46,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$parseImpliedObjectExpression();
      if (s0 === peg$FAILED) {
        s0 = peg$parseExpression();
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseExpression() {
      var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11;

      var key    = peg$currPos * 189 + 47,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        if (input.substr(peg$currPos, 5) === peg$c66) {
          s2 = peg$c66;
          peg$currPos += 5;
        } else {
          s2 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c67); }
        }
        if (s2 === peg$FAILED) {
          s2 = peg$c4;
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$parse_();
          if (s3 !== peg$FAILED) {
            s4 = peg$parseMultilineExpression();
            if (s4 === peg$FAILED) {
              s4 = peg$parseAssignmentExpression();
            }
            if (s4 !== peg$FAILED) {
              s5 = [];
              s6 = peg$currPos;
              s7 = peg$parseeol();
              if (s7 !== peg$FAILED) {
                s8 = peg$parse_();
                if (s8 !== peg$FAILED) {
                  s9 = peg$currPos;
                  peg$silentFails++;
                  if (input.charCodeAt(peg$currPos) === 46) {
                    s10 = peg$c44;
                    peg$currPos++;
                  } else {
                    s10 = peg$FAILED;
                    if (peg$silentFails === 0) { peg$fail(peg$c45); }
                  }
                  peg$silentFails--;
                  if (s10 !== peg$FAILED) {
                    peg$currPos = s9;
                    s9 = peg$c16;
                  } else {
                    s9 = peg$c0;
                  }
                  if (s9 !== peg$FAILED) {
                    s10 = [];
                    s11 = peg$parsetailCall();
                    if (s11 === peg$FAILED) {
                      s11 = peg$parsetailMember();
                    }
                    while (s11 !== peg$FAILED) {
                      s10.push(s11);
                      s11 = peg$parsetailCall();
                      if (s11 === peg$FAILED) {
                        s11 = peg$parsetailMember();
                      }
                    }
                    if (s10 !== peg$FAILED) {
                      peg$reportedPos = s6;
                      s7 = peg$c7(s10);
                      s6 = s7;
                    } else {
                      peg$currPos = s6;
                      s6 = peg$c0;
                    }
                  } else {
                    peg$currPos = s6;
                    s6 = peg$c0;
                  }
                } else {
                  peg$currPos = s6;
                  s6 = peg$c0;
                }
              } else {
                peg$currPos = s6;
                s6 = peg$c0;
              }
              while (s6 !== peg$FAILED) {
                s5.push(s6);
                s6 = peg$currPos;
                s7 = peg$parseeol();
                if (s7 !== peg$FAILED) {
                  s8 = peg$parse_();
                  if (s8 !== peg$FAILED) {
                    s9 = peg$currPos;
                    peg$silentFails++;
                    if (input.charCodeAt(peg$currPos) === 46) {
                      s10 = peg$c44;
                      peg$currPos++;
                    } else {
                      s10 = peg$FAILED;
                      if (peg$silentFails === 0) { peg$fail(peg$c45); }
                    }
                    peg$silentFails--;
                    if (s10 !== peg$FAILED) {
                      peg$currPos = s9;
                      s9 = peg$c16;
                    } else {
                      s9 = peg$c0;
                    }
                    if (s9 !== peg$FAILED) {
                      s10 = [];
                      s11 = peg$parsetailCall();
                      if (s11 === peg$FAILED) {
                        s11 = peg$parsetailMember();
                      }
                      while (s11 !== peg$FAILED) {
                        s10.push(s11);
                        s11 = peg$parsetailCall();
                        if (s11 === peg$FAILED) {
                          s11 = peg$parsetailMember();
                        }
                      }
                      if (s10 !== peg$FAILED) {
                        peg$reportedPos = s6;
                        s7 = peg$c7(s10);
                        s6 = s7;
                      } else {
                        peg$currPos = s6;
                        s6 = peg$c0;
                      }
                    } else {
                      peg$currPos = s6;
                      s6 = peg$c0;
                    }
                  } else {
                    peg$currPos = s6;
                    s6 = peg$c0;
                  }
                } else {
                  peg$currPos = s6;
                  s6 = peg$c0;
                }
              }
              if (s5 !== peg$FAILED) {
                peg$reportedPos = s0;
                s1 = peg$c68(s1, s2, s4, s5);
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseMultilineChainExpression() {
      var s0, s1, s2, s3, s4;

      var key    = peg$currPos * 189 + 48,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parseeol();
      if (s1 === peg$FAILED) {
        s1 = peg$c4;
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        if (input.charCodeAt(peg$currPos) === 46) {
          s3 = peg$c44;
          peg$currPos++;
        } else {
          s3 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c45); }
        }
        peg$silentFails--;
        if (s3 !== peg$FAILED) {
          peg$currPos = s2;
          s2 = peg$c16;
        } else {
          s2 = peg$c0;
        }
        if (s2 !== peg$FAILED) {
          s3 = [];
          s4 = peg$parsetailCall();
          if (s4 === peg$FAILED) {
            s4 = peg$parsetailMember();
          }
          while (s4 !== peg$FAILED) {
            s3.push(s4);
            s4 = peg$parsetailCall();
            if (s4 === peg$FAILED) {
              s4 = peg$parsetailMember();
            }
          }
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c69(s3);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseMultilineExpression() {
      var s0;

      var key    = peg$currPos * 189 + 49,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$parseClassExpression();
      if (s0 === peg$FAILED) {
        s0 = peg$parseMultilineStringTemplate();
        if (s0 === peg$FAILED) {
          s0 = peg$parseMultilineStringLiteral();
          if (s0 === peg$FAILED) {
            s0 = peg$parseVoidTypedObjectExpression();
            if (s0 === peg$FAILED) {
              s0 = peg$parseTypedObjectExpression();
              if (s0 === peg$FAILED) {
                s0 = peg$parseMultilineCallExpression();
              }
            }
          }
        }
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseVoidTypedObjectExpression() {
      var s0, s1, s2, s3, s4, s5;

      var key    = peg$currPos * 189 + 50,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        if (input.substr(peg$currPos, 4) === peg$c70) {
          s2 = peg$c70;
          peg$currPos += 4;
        } else {
          s2 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c71); }
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$parse_();
          if (s3 !== peg$FAILED) {
            s4 = peg$parseTypedObjectExpression();
            if (s4 !== peg$FAILED) {
              s5 = peg$parsestart();
              if (s5 !== peg$FAILED) {
                peg$reportedPos = s0;
                s1 = peg$c72(s1, s4, s5);
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsemultilineArguments() {
      var s0;

      var key    = peg$currPos * 189 + 51,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$parsemultilineArgumentsNested();
      if (s0 === peg$FAILED) {
        s0 = peg$parsemultilineArgumentsIndented();
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsemultilineArgumentsNested() {
      var s0, s1, s2, s3, s4, s5, s6, s7, s8;

      var key    = peg$currPos * 189 + 52,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.charCodeAt(peg$currPos) === 40) {
        s1 = peg$c73;
        peg$currPos++;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c74); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$parseindent();
        if (s2 !== peg$FAILED) {
          s3 = peg$parseeol();
          if (s3 !== peg$FAILED) {
            s4 = peg$parsemultilineArgumentsBlock();
            if (s4 !== peg$FAILED) {
              s5 = peg$parseoutdent();
              if (s5 !== peg$FAILED) {
                s6 = peg$parseeol();
                if (s6 !== peg$FAILED) {
                  s7 = peg$parse_();
                  if (s7 !== peg$FAILED) {
                    if (input.charCodeAt(peg$currPos) === 41) {
                      s8 = peg$c75;
                      peg$currPos++;
                    } else {
                      s8 = peg$FAILED;
                      if (peg$silentFails === 0) { peg$fail(peg$c76); }
                    }
                    if (s8 !== peg$FAILED) {
                      peg$reportedPos = s0;
                      s1 = peg$c77(s4);
                      s0 = s1;
                    } else {
                      peg$currPos = s0;
                      s0 = peg$c0;
                    }
                  } else {
                    peg$currPos = s0;
                    s0 = peg$c0;
                  }
                } else {
                  peg$currPos = s0;
                  s0 = peg$c0;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsemultilineArgumentsIndented() {
      var s0, s1, s2, s3, s4, s5;

      var key    = peg$currPos * 189 + 53,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 4) === peg$c78) {
        s1 = peg$c78;
        peg$currPos += 4;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c79); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$parseindent();
        if (s2 !== peg$FAILED) {
          s3 = peg$parseeol();
          if (s3 !== peg$FAILED) {
            s4 = peg$parsemultilineArgumentsBlock();
            if (s4 !== peg$FAILED) {
              s5 = peg$parseoutdent();
              if (s5 !== peg$FAILED) {
                peg$reportedPos = s0;
                s1 = peg$c77(s4);
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsemultilineArgumentsBlock() {
      var s0, s1, s2, s3, s4, s5, s6;

      var key    = peg$currPos * 189 + 54,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = [];
      s1 = peg$currPos;
      s2 = peg$parse_();
      if (s2 !== peg$FAILED) {
        s3 = peg$parseExpression();
        if (s3 !== peg$FAILED) {
          s4 = peg$parseeol();
          if (s4 === peg$FAILED) {
            if (input.charCodeAt(peg$currPos) === 44) {
              s4 = peg$c5;
              peg$currPos++;
            } else {
              s4 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c6); }
            }
          }
          if (s4 !== peg$FAILED) {
            peg$reportedPos = s1;
            s2 = peg$c80(s3);
            s1 = s2;
          } else {
            peg$currPos = s1;
            s1 = peg$c0;
          }
        } else {
          peg$currPos = s1;
          s1 = peg$c0;
        }
      } else {
        peg$currPos = s1;
        s1 = peg$c0;
      }
      if (s1 !== peg$FAILED) {
        while (s1 !== peg$FAILED) {
          s0.push(s1);
          s1 = peg$currPos;
          s2 = peg$parse_();
          if (s2 !== peg$FAILED) {
            s3 = peg$parseExpression();
            if (s3 !== peg$FAILED) {
              s4 = peg$parseeol();
              if (s4 === peg$FAILED) {
                if (input.charCodeAt(peg$currPos) === 44) {
                  s4 = peg$c5;
                  peg$currPos++;
                } else {
                  s4 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$c6); }
                }
              }
              if (s4 !== peg$FAILED) {
                peg$reportedPos = s1;
                s2 = peg$c80(s3);
                s1 = s2;
              } else {
                peg$currPos = s1;
                s1 = peg$c0;
              }
            } else {
              peg$currPos = s1;
              s1 = peg$c0;
            }
          } else {
            peg$currPos = s1;
            s1 = peg$c0;
          }
        }
      } else {
        s0 = peg$c0;
      }
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        s1 = peg$parsestart();
        if (s1 !== peg$FAILED) {
          s2 = [];
          s3 = peg$currPos;
          s4 = peg$parse_();
          if (s4 !== peg$FAILED) {
            s5 = peg$parsePropertyDeclaration();
            if (s5 !== peg$FAILED) {
              s6 = peg$parseeol();
              if (s6 === peg$FAILED) {
                if (input.charCodeAt(peg$currPos) === 44) {
                  s6 = peg$c5;
                  peg$currPos++;
                } else {
                  s6 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$c6); }
                }
              }
              if (s6 !== peg$FAILED) {
                peg$reportedPos = s3;
                s4 = peg$c81(s5);
                s3 = s4;
              } else {
                peg$currPos = s3;
                s3 = peg$c0;
              }
            } else {
              peg$currPos = s3;
              s3 = peg$c0;
            }
          } else {
            peg$currPos = s3;
            s3 = peg$c0;
          }
          if (s3 !== peg$FAILED) {
            while (s3 !== peg$FAILED) {
              s2.push(s3);
              s3 = peg$currPos;
              s4 = peg$parse_();
              if (s4 !== peg$FAILED) {
                s5 = peg$parsePropertyDeclaration();
                if (s5 !== peg$FAILED) {
                  s6 = peg$parseeol();
                  if (s6 === peg$FAILED) {
                    if (input.charCodeAt(peg$currPos) === 44) {
                      s6 = peg$c5;
                      peg$currPos++;
                    } else {
                      s6 = peg$FAILED;
                      if (peg$silentFails === 0) { peg$fail(peg$c6); }
                    }
                  }
                  if (s6 !== peg$FAILED) {
                    peg$reportedPos = s3;
                    s4 = peg$c81(s5);
                    s3 = s4;
                  } else {
                    peg$currPos = s3;
                    s3 = peg$c0;
                  }
                } else {
                  peg$currPos = s3;
                  s3 = peg$c0;
                }
              } else {
                peg$currPos = s3;
                s3 = peg$c0;
              }
            }
          } else {
            s2 = peg$c0;
          }
          if (s2 !== peg$FAILED) {
            s3 = peg$parsestart();
            if (s3 !== peg$FAILED) {
              peg$reportedPos = s0;
              s1 = peg$c82(s1, s2, s3);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseMultilineCallExpression() {
      var s0, s1, s2, s3, s4;

      var key    = peg$currPos * 189 + 55,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        s2 = peg$parseAssignmentExpression();
        if (s2 !== peg$FAILED) {
          s3 = peg$parsemultilineArguments();
          if (s3 !== peg$FAILED) {
            s4 = peg$parsestart();
            if (s4 !== peg$FAILED) {
              peg$reportedPos = s0;
              s1 = peg$c83(s1, s2, s3, s4);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseAssignmentExpression() {
      var s0, s1, s2, s3, s4, s5, s6, s7;

      var key    = peg$currPos * 189 + 56,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        s2 = peg$parseConditionalOrDefaultExpression();
        if (s2 !== peg$FAILED) {
          s3 = peg$parse_();
          if (s3 !== peg$FAILED) {
            if (input.charCodeAt(peg$currPos) === 61) {
              s4 = peg$c59;
              peg$currPos++;
            } else {
              s4 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c60); }
            }
            if (s4 === peg$FAILED) {
              if (input.substr(peg$currPos, 2) === peg$c84) {
                s4 = peg$c84;
                peg$currPos += 2;
              } else {
                s4 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c85); }
              }
              if (s4 === peg$FAILED) {
                if (input.substr(peg$currPos, 2) === peg$c86) {
                  s4 = peg$c86;
                  peg$currPos += 2;
                } else {
                  s4 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$c87); }
                }
                if (s4 === peg$FAILED) {
                  if (input.substr(peg$currPos, 2) === peg$c88) {
                    s4 = peg$c88;
                    peg$currPos += 2;
                  } else {
                    s4 = peg$FAILED;
                    if (peg$silentFails === 0) { peg$fail(peg$c89); }
                  }
                  if (s4 === peg$FAILED) {
                    if (input.substr(peg$currPos, 2) === peg$c90) {
                      s4 = peg$c90;
                      peg$currPos += 2;
                    } else {
                      s4 = peg$FAILED;
                      if (peg$silentFails === 0) { peg$fail(peg$c91); }
                    }
                    if (s4 === peg$FAILED) {
                      if (input.substr(peg$currPos, 2) === peg$c92) {
                        s4 = peg$c92;
                        peg$currPos += 2;
                      } else {
                        s4 = peg$FAILED;
                        if (peg$silentFails === 0) { peg$fail(peg$c93); }
                      }
                      if (s4 === peg$FAILED) {
                        if (input.substr(peg$currPos, 3) === peg$c94) {
                          s4 = peg$c94;
                          peg$currPos += 3;
                        } else {
                          s4 = peg$FAILED;
                          if (peg$silentFails === 0) { peg$fail(peg$c95); }
                        }
                        if (s4 === peg$FAILED) {
                          if (input.substr(peg$currPos, 3) === peg$c96) {
                            s4 = peg$c96;
                            peg$currPos += 3;
                          } else {
                            s4 = peg$FAILED;
                            if (peg$silentFails === 0) { peg$fail(peg$c97); }
                          }
                          if (s4 === peg$FAILED) {
                            if (input.substr(peg$currPos, 4) === peg$c98) {
                              s4 = peg$c98;
                              peg$currPos += 4;
                            } else {
                              s4 = peg$FAILED;
                              if (peg$silentFails === 0) { peg$fail(peg$c99); }
                            }
                            if (s4 === peg$FAILED) {
                              if (input.substr(peg$currPos, 2) === peg$c90) {
                                s4 = peg$c90;
                                peg$currPos += 2;
                              } else {
                                s4 = peg$FAILED;
                                if (peg$silentFails === 0) { peg$fail(peg$c91); }
                              }
                              if (s4 === peg$FAILED) {
                                if (input.substr(peg$currPos, 2) === peg$c100) {
                                  s4 = peg$c100;
                                  peg$currPos += 2;
                                } else {
                                  s4 = peg$FAILED;
                                  if (peg$silentFails === 0) { peg$fail(peg$c101); }
                                }
                                if (s4 === peg$FAILED) {
                                  if (input.substr(peg$currPos, 2) === peg$c102) {
                                    s4 = peg$c102;
                                    peg$currPos += 2;
                                  } else {
                                    s4 = peg$FAILED;
                                    if (peg$silentFails === 0) { peg$fail(peg$c103); }
                                  }
                                  if (s4 === peg$FAILED) {
                                    if (input.substr(peg$currPos, 3) === peg$c104) {
                                      s4 = peg$c104;
                                      peg$currPos += 3;
                                    } else {
                                      s4 = peg$FAILED;
                                      if (peg$silentFails === 0) { peg$fail(peg$c105); }
                                    }
                                    if (s4 === peg$FAILED) {
                                      if (input.substr(peg$currPos, 2) === peg$c106) {
                                        s4 = peg$c106;
                                        peg$currPos += 2;
                                      } else {
                                        s4 = peg$FAILED;
                                        if (peg$silentFails === 0) { peg$fail(peg$c107); }
                                      }
                                      if (s4 === peg$FAILED) {
                                        if (input.substr(peg$currPos, 2) === peg$c108) {
                                          s4 = peg$c108;
                                          peg$currPos += 2;
                                        } else {
                                          s4 = peg$FAILED;
                                          if (peg$silentFails === 0) { peg$fail(peg$c109); }
                                        }
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
            if (s4 !== peg$FAILED) {
              s5 = peg$parse_();
              if (s5 !== peg$FAILED) {
                s6 = peg$parseRightHandSideExpression();
                if (s6 !== peg$FAILED) {
                  s7 = peg$parsestart();
                  if (s7 !== peg$FAILED) {
                    peg$reportedPos = s0;
                    s1 = peg$c110(s1, s2, s4, s6, s7);
                    s0 = s1;
                  } else {
                    peg$currPos = s0;
                    s0 = peg$c0;
                  }
                } else {
                  peg$currPos = s0;
                  s0 = peg$c0;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }
      if (s0 === peg$FAILED) {
        s0 = peg$parseConditionalOrDefaultExpression();
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseConditionalOrDefaultExpression() {
      var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11;

      var key    = peg$currPos * 189 + 57,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        s2 = peg$parseLogicalOrExpression();
        if (s2 !== peg$FAILED) {
          s3 = peg$parse_();
          if (s3 !== peg$FAILED) {
            if (input.charCodeAt(peg$currPos) === 63) {
              s4 = peg$c111;
              peg$currPos++;
            } else {
              s4 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c112); }
            }
            if (s4 !== peg$FAILED) {
              s5 = peg$parse_();
              if (s5 !== peg$FAILED) {
                s6 = peg$parseConditionalOrDefaultExpression();
                if (s6 !== peg$FAILED) {
                  s7 = peg$parse_();
                  if (s7 !== peg$FAILED) {
                    if (input.charCodeAt(peg$currPos) === 58) {
                      s8 = peg$c51;
                      peg$currPos++;
                    } else {
                      s8 = peg$FAILED;
                      if (peg$silentFails === 0) { peg$fail(peg$c52); }
                    }
                    if (s8 !== peg$FAILED) {
                      s9 = peg$parse_();
                      if (s9 !== peg$FAILED) {
                        s10 = peg$parseConditionalOrDefaultExpression();
                        if (s10 !== peg$FAILED) {
                          s11 = peg$parsestart();
                          if (s11 !== peg$FAILED) {
                            peg$reportedPos = s0;
                            s1 = peg$c113(s1, s2, s6, s10, s11);
                            s0 = s1;
                          } else {
                            peg$currPos = s0;
                            s0 = peg$c0;
                          }
                        } else {
                          peg$currPos = s0;
                          s0 = peg$c0;
                        }
                      } else {
                        peg$currPos = s0;
                        s0 = peg$c0;
                      }
                    } else {
                      peg$currPos = s0;
                      s0 = peg$c0;
                    }
                  } else {
                    peg$currPos = s0;
                    s0 = peg$c0;
                  }
                } else {
                  peg$currPos = s0;
                  s0 = peg$c0;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        s1 = peg$parsestart();
        if (s1 !== peg$FAILED) {
          s2 = peg$parseLogicalOrExpression();
          if (s2 !== peg$FAILED) {
            s3 = [];
            s4 = peg$currPos;
            s5 = peg$parse_();
            if (s5 !== peg$FAILED) {
              if (input.substr(peg$currPos, 2) === peg$c114) {
                s6 = peg$c114;
                peg$currPos += 2;
              } else {
                s6 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c115); }
              }
              if (s6 === peg$FAILED) {
                if (input.charCodeAt(peg$currPos) === 63) {
                  s6 = peg$c111;
                  peg$currPos++;
                } else {
                  s6 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$c112); }
                }
              }
              if (s6 !== peg$FAILED) {
                s7 = peg$parse_();
                if (s7 !== peg$FAILED) {
                  s8 = peg$parseLogicalOrExpression();
                  if (s8 !== peg$FAILED) {
                    s9 = peg$parsestart();
                    if (s9 !== peg$FAILED) {
                      s5 = [s5, s6, s7, s8, s9];
                      s4 = s5;
                    } else {
                      peg$currPos = s4;
                      s4 = peg$c0;
                    }
                  } else {
                    peg$currPos = s4;
                    s4 = peg$c0;
                  }
                } else {
                  peg$currPos = s4;
                  s4 = peg$c0;
                }
              } else {
                peg$currPos = s4;
                s4 = peg$c0;
              }
            } else {
              peg$currPos = s4;
              s4 = peg$c0;
            }
            while (s4 !== peg$FAILED) {
              s3.push(s4);
              s4 = peg$currPos;
              s5 = peg$parse_();
              if (s5 !== peg$FAILED) {
                if (input.substr(peg$currPos, 2) === peg$c114) {
                  s6 = peg$c114;
                  peg$currPos += 2;
                } else {
                  s6 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$c115); }
                }
                if (s6 === peg$FAILED) {
                  if (input.charCodeAt(peg$currPos) === 63) {
                    s6 = peg$c111;
                    peg$currPos++;
                  } else {
                    s6 = peg$FAILED;
                    if (peg$silentFails === 0) { peg$fail(peg$c112); }
                  }
                }
                if (s6 !== peg$FAILED) {
                  s7 = peg$parse_();
                  if (s7 !== peg$FAILED) {
                    s8 = peg$parseLogicalOrExpression();
                    if (s8 !== peg$FAILED) {
                      s9 = peg$parsestart();
                      if (s9 !== peg$FAILED) {
                        s5 = [s5, s6, s7, s8, s9];
                        s4 = s5;
                      } else {
                        peg$currPos = s4;
                        s4 = peg$c0;
                      }
                    } else {
                      peg$currPos = s4;
                      s4 = peg$c0;
                    }
                  } else {
                    peg$currPos = s4;
                    s4 = peg$c0;
                  }
                } else {
                  peg$currPos = s4;
                  s4 = peg$c0;
                }
              } else {
                peg$currPos = s4;
                s4 = peg$c0;
              }
            }
            if (s3 !== peg$FAILED) {
              peg$reportedPos = s0;
              s1 = peg$c116(s1, s2, s3);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
        if (s0 === peg$FAILED) {
          s0 = peg$parseLogicalOrExpression();
        }
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseLogicalOrExpression() {
      var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9;

      var key    = peg$currPos * 189 + 58,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        s2 = peg$parseLogicalAndExpression();
        if (s2 !== peg$FAILED) {
          s3 = [];
          s4 = peg$currPos;
          s5 = peg$parse_();
          if (s5 !== peg$FAILED) {
            s6 = peg$parseor();
            if (s6 !== peg$FAILED) {
              s7 = peg$parse_();
              if (s7 !== peg$FAILED) {
                s8 = peg$parseLogicalAndExpression();
                if (s8 !== peg$FAILED) {
                  s9 = peg$parsestart();
                  if (s9 !== peg$FAILED) {
                    s5 = [s5, s6, s7, s8, s9];
                    s4 = s5;
                  } else {
                    peg$currPos = s4;
                    s4 = peg$c0;
                  }
                } else {
                  peg$currPos = s4;
                  s4 = peg$c0;
                }
              } else {
                peg$currPos = s4;
                s4 = peg$c0;
              }
            } else {
              peg$currPos = s4;
              s4 = peg$c0;
            }
          } else {
            peg$currPos = s4;
            s4 = peg$c0;
          }
          while (s4 !== peg$FAILED) {
            s3.push(s4);
            s4 = peg$currPos;
            s5 = peg$parse_();
            if (s5 !== peg$FAILED) {
              s6 = peg$parseor();
              if (s6 !== peg$FAILED) {
                s7 = peg$parse_();
                if (s7 !== peg$FAILED) {
                  s8 = peg$parseLogicalAndExpression();
                  if (s8 !== peg$FAILED) {
                    s9 = peg$parsestart();
                    if (s9 !== peg$FAILED) {
                      s5 = [s5, s6, s7, s8, s9];
                      s4 = s5;
                    } else {
                      peg$currPos = s4;
                      s4 = peg$c0;
                    }
                  } else {
                    peg$currPos = s4;
                    s4 = peg$c0;
                  }
                } else {
                  peg$currPos = s4;
                  s4 = peg$c0;
                }
              } else {
                peg$currPos = s4;
                s4 = peg$c0;
              }
            } else {
              peg$currPos = s4;
              s4 = peg$c0;
            }
          }
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c116(s1, s2, s3);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseLogicalAndExpression() {
      var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9;

      var key    = peg$currPos * 189 + 59,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        s2 = peg$parseBitwiseOrExpression();
        if (s2 !== peg$FAILED) {
          s3 = [];
          s4 = peg$currPos;
          s5 = peg$parse_();
          if (s5 !== peg$FAILED) {
            s6 = peg$parseand();
            if (s6 !== peg$FAILED) {
              s7 = peg$parse_();
              if (s7 !== peg$FAILED) {
                s8 = peg$parseBitwiseOrExpression();
                if (s8 !== peg$FAILED) {
                  s9 = peg$parsestart();
                  if (s9 !== peg$FAILED) {
                    s5 = [s5, s6, s7, s8, s9];
                    s4 = s5;
                  } else {
                    peg$currPos = s4;
                    s4 = peg$c0;
                  }
                } else {
                  peg$currPos = s4;
                  s4 = peg$c0;
                }
              } else {
                peg$currPos = s4;
                s4 = peg$c0;
              }
            } else {
              peg$currPos = s4;
              s4 = peg$c0;
            }
          } else {
            peg$currPos = s4;
            s4 = peg$c0;
          }
          while (s4 !== peg$FAILED) {
            s3.push(s4);
            s4 = peg$currPos;
            s5 = peg$parse_();
            if (s5 !== peg$FAILED) {
              s6 = peg$parseand();
              if (s6 !== peg$FAILED) {
                s7 = peg$parse_();
                if (s7 !== peg$FAILED) {
                  s8 = peg$parseBitwiseOrExpression();
                  if (s8 !== peg$FAILED) {
                    s9 = peg$parsestart();
                    if (s9 !== peg$FAILED) {
                      s5 = [s5, s6, s7, s8, s9];
                      s4 = s5;
                    } else {
                      peg$currPos = s4;
                      s4 = peg$c0;
                    }
                  } else {
                    peg$currPos = s4;
                    s4 = peg$c0;
                  }
                } else {
                  peg$currPos = s4;
                  s4 = peg$c0;
                }
              } else {
                peg$currPos = s4;
                s4 = peg$c0;
              }
            } else {
              peg$currPos = s4;
              s4 = peg$c0;
            }
          }
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c116(s1, s2, s3);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseBitwiseOrExpression() {
      var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9;

      var key    = peg$currPos * 189 + 60,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        s2 = peg$parseBitwiseXorExpression();
        if (s2 !== peg$FAILED) {
          s3 = [];
          s4 = peg$currPos;
          s5 = peg$parse_();
          if (s5 !== peg$FAILED) {
            if (input.charCodeAt(peg$currPos) === 124) {
              s6 = peg$c117;
              peg$currPos++;
            } else {
              s6 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c118); }
            }
            if (s6 !== peg$FAILED) {
              s7 = peg$parse_();
              if (s7 !== peg$FAILED) {
                s8 = peg$parseBitwiseXorExpression();
                if (s8 !== peg$FAILED) {
                  s9 = peg$parsestart();
                  if (s9 !== peg$FAILED) {
                    s5 = [s5, s6, s7, s8, s9];
                    s4 = s5;
                  } else {
                    peg$currPos = s4;
                    s4 = peg$c0;
                  }
                } else {
                  peg$currPos = s4;
                  s4 = peg$c0;
                }
              } else {
                peg$currPos = s4;
                s4 = peg$c0;
              }
            } else {
              peg$currPos = s4;
              s4 = peg$c0;
            }
          } else {
            peg$currPos = s4;
            s4 = peg$c0;
          }
          while (s4 !== peg$FAILED) {
            s3.push(s4);
            s4 = peg$currPos;
            s5 = peg$parse_();
            if (s5 !== peg$FAILED) {
              if (input.charCodeAt(peg$currPos) === 124) {
                s6 = peg$c117;
                peg$currPos++;
              } else {
                s6 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c118); }
              }
              if (s6 !== peg$FAILED) {
                s7 = peg$parse_();
                if (s7 !== peg$FAILED) {
                  s8 = peg$parseBitwiseXorExpression();
                  if (s8 !== peg$FAILED) {
                    s9 = peg$parsestart();
                    if (s9 !== peg$FAILED) {
                      s5 = [s5, s6, s7, s8, s9];
                      s4 = s5;
                    } else {
                      peg$currPos = s4;
                      s4 = peg$c0;
                    }
                  } else {
                    peg$currPos = s4;
                    s4 = peg$c0;
                  }
                } else {
                  peg$currPos = s4;
                  s4 = peg$c0;
                }
              } else {
                peg$currPos = s4;
                s4 = peg$c0;
              }
            } else {
              peg$currPos = s4;
              s4 = peg$c0;
            }
          }
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c116(s1, s2, s3);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseBitwiseXorExpression() {
      var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9;

      var key    = peg$currPos * 189 + 61,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        s2 = peg$parseBitwiseAndExpression();
        if (s2 !== peg$FAILED) {
          s3 = [];
          s4 = peg$currPos;
          s5 = peg$parse_();
          if (s5 !== peg$FAILED) {
            if (input.charCodeAt(peg$currPos) === 94) {
              s6 = peg$c119;
              peg$currPos++;
            } else {
              s6 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c120); }
            }
            if (s6 !== peg$FAILED) {
              s7 = peg$parse_();
              if (s7 !== peg$FAILED) {
                s8 = peg$parseBitwiseAndExpression();
                if (s8 !== peg$FAILED) {
                  s9 = peg$parsestart();
                  if (s9 !== peg$FAILED) {
                    s5 = [s5, s6, s7, s8, s9];
                    s4 = s5;
                  } else {
                    peg$currPos = s4;
                    s4 = peg$c0;
                  }
                } else {
                  peg$currPos = s4;
                  s4 = peg$c0;
                }
              } else {
                peg$currPos = s4;
                s4 = peg$c0;
              }
            } else {
              peg$currPos = s4;
              s4 = peg$c0;
            }
          } else {
            peg$currPos = s4;
            s4 = peg$c0;
          }
          while (s4 !== peg$FAILED) {
            s3.push(s4);
            s4 = peg$currPos;
            s5 = peg$parse_();
            if (s5 !== peg$FAILED) {
              if (input.charCodeAt(peg$currPos) === 94) {
                s6 = peg$c119;
                peg$currPos++;
              } else {
                s6 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c120); }
              }
              if (s6 !== peg$FAILED) {
                s7 = peg$parse_();
                if (s7 !== peg$FAILED) {
                  s8 = peg$parseBitwiseAndExpression();
                  if (s8 !== peg$FAILED) {
                    s9 = peg$parsestart();
                    if (s9 !== peg$FAILED) {
                      s5 = [s5, s6, s7, s8, s9];
                      s4 = s5;
                    } else {
                      peg$currPos = s4;
                      s4 = peg$c0;
                    }
                  } else {
                    peg$currPos = s4;
                    s4 = peg$c0;
                  }
                } else {
                  peg$currPos = s4;
                  s4 = peg$c0;
                }
              } else {
                peg$currPos = s4;
                s4 = peg$c0;
              }
            } else {
              peg$currPos = s4;
              s4 = peg$c0;
            }
          }
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c116(s1, s2, s3);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseBitwiseAndExpression() {
      var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9;

      var key    = peg$currPos * 189 + 62,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        s2 = peg$parseEqualityExpression();
        if (s2 !== peg$FAILED) {
          s3 = [];
          s4 = peg$currPos;
          s5 = peg$parse_();
          if (s5 !== peg$FAILED) {
            if (input.charCodeAt(peg$currPos) === 38) {
              s6 = peg$c121;
              peg$currPos++;
            } else {
              s6 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c122); }
            }
            if (s6 !== peg$FAILED) {
              s7 = peg$parse_();
              if (s7 !== peg$FAILED) {
                s8 = peg$parseEqualityExpression();
                if (s8 !== peg$FAILED) {
                  s9 = peg$parsestart();
                  if (s9 !== peg$FAILED) {
                    s5 = [s5, s6, s7, s8, s9];
                    s4 = s5;
                  } else {
                    peg$currPos = s4;
                    s4 = peg$c0;
                  }
                } else {
                  peg$currPos = s4;
                  s4 = peg$c0;
                }
              } else {
                peg$currPos = s4;
                s4 = peg$c0;
              }
            } else {
              peg$currPos = s4;
              s4 = peg$c0;
            }
          } else {
            peg$currPos = s4;
            s4 = peg$c0;
          }
          while (s4 !== peg$FAILED) {
            s3.push(s4);
            s4 = peg$currPos;
            s5 = peg$parse_();
            if (s5 !== peg$FAILED) {
              if (input.charCodeAt(peg$currPos) === 38) {
                s6 = peg$c121;
                peg$currPos++;
              } else {
                s6 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c122); }
              }
              if (s6 !== peg$FAILED) {
                s7 = peg$parse_();
                if (s7 !== peg$FAILED) {
                  s8 = peg$parseEqualityExpression();
                  if (s8 !== peg$FAILED) {
                    s9 = peg$parsestart();
                    if (s9 !== peg$FAILED) {
                      s5 = [s5, s6, s7, s8, s9];
                      s4 = s5;
                    } else {
                      peg$currPos = s4;
                      s4 = peg$c0;
                    }
                  } else {
                    peg$currPos = s4;
                    s4 = peg$c0;
                  }
                } else {
                  peg$currPos = s4;
                  s4 = peg$c0;
                }
              } else {
                peg$currPos = s4;
                s4 = peg$c0;
              }
            } else {
              peg$currPos = s4;
              s4 = peg$c0;
            }
          }
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c116(s1, s2, s3);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseEqualityExpression() {
      var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9;

      var key    = peg$currPos * 189 + 63,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        s2 = peg$parseRelationalExpression();
        if (s2 !== peg$FAILED) {
          s3 = [];
          s4 = peg$currPos;
          s5 = peg$parse_();
          if (s5 !== peg$FAILED) {
            s6 = peg$parseis();
            if (s6 === peg$FAILED) {
              s6 = peg$parseisnt();
            }
            if (s6 !== peg$FAILED) {
              s7 = peg$parse_();
              if (s7 !== peg$FAILED) {
                s8 = peg$parseRelationalExpression();
                if (s8 !== peg$FAILED) {
                  s9 = peg$parsestart();
                  if (s9 !== peg$FAILED) {
                    s5 = [s5, s6, s7, s8, s9];
                    s4 = s5;
                  } else {
                    peg$currPos = s4;
                    s4 = peg$c0;
                  }
                } else {
                  peg$currPos = s4;
                  s4 = peg$c0;
                }
              } else {
                peg$currPos = s4;
                s4 = peg$c0;
              }
            } else {
              peg$currPos = s4;
              s4 = peg$c0;
            }
          } else {
            peg$currPos = s4;
            s4 = peg$c0;
          }
          while (s4 !== peg$FAILED) {
            s3.push(s4);
            s4 = peg$currPos;
            s5 = peg$parse_();
            if (s5 !== peg$FAILED) {
              s6 = peg$parseis();
              if (s6 === peg$FAILED) {
                s6 = peg$parseisnt();
              }
              if (s6 !== peg$FAILED) {
                s7 = peg$parse_();
                if (s7 !== peg$FAILED) {
                  s8 = peg$parseRelationalExpression();
                  if (s8 !== peg$FAILED) {
                    s9 = peg$parsestart();
                    if (s9 !== peg$FAILED) {
                      s5 = [s5, s6, s7, s8, s9];
                      s4 = s5;
                    } else {
                      peg$currPos = s4;
                      s4 = peg$c0;
                    }
                  } else {
                    peg$currPos = s4;
                    s4 = peg$c0;
                  }
                } else {
                  peg$currPos = s4;
                  s4 = peg$c0;
                }
              } else {
                peg$currPos = s4;
                s4 = peg$c0;
              }
            } else {
              peg$currPos = s4;
              s4 = peg$c0;
            }
          }
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c116(s1, s2, s3);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseRelationalExpression() {
      var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9;

      var key    = peg$currPos * 189 + 64,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        s2 = peg$parseBitwiseShiftExpression();
        if (s2 !== peg$FAILED) {
          s3 = [];
          s4 = peg$currPos;
          s5 = peg$parse_();
          if (s5 !== peg$FAILED) {
            if (input.substr(peg$currPos, 2) === peg$c123) {
              s6 = peg$c123;
              peg$currPos += 2;
            } else {
              s6 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c124); }
            }
            if (s6 === peg$FAILED) {
              if (input.substr(peg$currPos, 2) === peg$c125) {
                s6 = peg$c125;
                peg$currPos += 2;
              } else {
                s6 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c126); }
              }
              if (s6 === peg$FAILED) {
                if (input.charCodeAt(peg$currPos) === 60) {
                  s6 = peg$c127;
                  peg$currPos++;
                } else {
                  s6 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$c128); }
                }
                if (s6 === peg$FAILED) {
                  if (input.charCodeAt(peg$currPos) === 62) {
                    s6 = peg$c129;
                    peg$currPos++;
                  } else {
                    s6 = peg$FAILED;
                    if (peg$silentFails === 0) { peg$fail(peg$c130); }
                  }
                  if (s6 === peg$FAILED) {
                    s6 = peg$parsein();
                    if (s6 === peg$FAILED) {
                      s6 = peg$parseinstanceof();
                    }
                  }
                }
              }
            }
            if (s6 !== peg$FAILED) {
              s7 = peg$parse_();
              if (s7 !== peg$FAILED) {
                s8 = peg$parseBitwiseShiftExpression();
                if (s8 !== peg$FAILED) {
                  s9 = peg$parsestart();
                  if (s9 !== peg$FAILED) {
                    s5 = [s5, s6, s7, s8, s9];
                    s4 = s5;
                  } else {
                    peg$currPos = s4;
                    s4 = peg$c0;
                  }
                } else {
                  peg$currPos = s4;
                  s4 = peg$c0;
                }
              } else {
                peg$currPos = s4;
                s4 = peg$c0;
              }
            } else {
              peg$currPos = s4;
              s4 = peg$c0;
            }
          } else {
            peg$currPos = s4;
            s4 = peg$c0;
          }
          while (s4 !== peg$FAILED) {
            s3.push(s4);
            s4 = peg$currPos;
            s5 = peg$parse_();
            if (s5 !== peg$FAILED) {
              if (input.substr(peg$currPos, 2) === peg$c123) {
                s6 = peg$c123;
                peg$currPos += 2;
              } else {
                s6 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c124); }
              }
              if (s6 === peg$FAILED) {
                if (input.substr(peg$currPos, 2) === peg$c125) {
                  s6 = peg$c125;
                  peg$currPos += 2;
                } else {
                  s6 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$c126); }
                }
                if (s6 === peg$FAILED) {
                  if (input.charCodeAt(peg$currPos) === 60) {
                    s6 = peg$c127;
                    peg$currPos++;
                  } else {
                    s6 = peg$FAILED;
                    if (peg$silentFails === 0) { peg$fail(peg$c128); }
                  }
                  if (s6 === peg$FAILED) {
                    if (input.charCodeAt(peg$currPos) === 62) {
                      s6 = peg$c129;
                      peg$currPos++;
                    } else {
                      s6 = peg$FAILED;
                      if (peg$silentFails === 0) { peg$fail(peg$c130); }
                    }
                    if (s6 === peg$FAILED) {
                      s6 = peg$parsein();
                      if (s6 === peg$FAILED) {
                        s6 = peg$parseinstanceof();
                      }
                    }
                  }
                }
              }
              if (s6 !== peg$FAILED) {
                s7 = peg$parse_();
                if (s7 !== peg$FAILED) {
                  s8 = peg$parseBitwiseShiftExpression();
                  if (s8 !== peg$FAILED) {
                    s9 = peg$parsestart();
                    if (s9 !== peg$FAILED) {
                      s5 = [s5, s6, s7, s8, s9];
                      s4 = s5;
                    } else {
                      peg$currPos = s4;
                      s4 = peg$c0;
                    }
                  } else {
                    peg$currPos = s4;
                    s4 = peg$c0;
                  }
                } else {
                  peg$currPos = s4;
                  s4 = peg$c0;
                }
              } else {
                peg$currPos = s4;
                s4 = peg$c0;
              }
            } else {
              peg$currPos = s4;
              s4 = peg$c0;
            }
          }
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c116(s1, s2, s3);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseBitwiseShiftExpression() {
      var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9;

      var key    = peg$currPos * 189 + 65,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        s2 = peg$parseAdditiveExpression();
        if (s2 !== peg$FAILED) {
          s3 = [];
          s4 = peg$currPos;
          s5 = peg$parse_();
          if (s5 !== peg$FAILED) {
            if (input.substr(peg$currPos, 3) === peg$c131) {
              s6 = peg$c131;
              peg$currPos += 3;
            } else {
              s6 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c132); }
            }
            if (s6 === peg$FAILED) {
              if (input.substr(peg$currPos, 2) === peg$c133) {
                s6 = peg$c133;
                peg$currPos += 2;
              } else {
                s6 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c134); }
              }
              if (s6 === peg$FAILED) {
                if (input.substr(peg$currPos, 2) === peg$c135) {
                  s6 = peg$c135;
                  peg$currPos += 2;
                } else {
                  s6 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$c136); }
                }
              }
            }
            if (s6 !== peg$FAILED) {
              s7 = peg$parse_();
              if (s7 !== peg$FAILED) {
                s8 = peg$parseAdditiveExpression();
                if (s8 !== peg$FAILED) {
                  s9 = peg$parsestart();
                  if (s9 !== peg$FAILED) {
                    s5 = [s5, s6, s7, s8, s9];
                    s4 = s5;
                  } else {
                    peg$currPos = s4;
                    s4 = peg$c0;
                  }
                } else {
                  peg$currPos = s4;
                  s4 = peg$c0;
                }
              } else {
                peg$currPos = s4;
                s4 = peg$c0;
              }
            } else {
              peg$currPos = s4;
              s4 = peg$c0;
            }
          } else {
            peg$currPos = s4;
            s4 = peg$c0;
          }
          while (s4 !== peg$FAILED) {
            s3.push(s4);
            s4 = peg$currPos;
            s5 = peg$parse_();
            if (s5 !== peg$FAILED) {
              if (input.substr(peg$currPos, 3) === peg$c131) {
                s6 = peg$c131;
                peg$currPos += 3;
              } else {
                s6 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c132); }
              }
              if (s6 === peg$FAILED) {
                if (input.substr(peg$currPos, 2) === peg$c133) {
                  s6 = peg$c133;
                  peg$currPos += 2;
                } else {
                  s6 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$c134); }
                }
                if (s6 === peg$FAILED) {
                  if (input.substr(peg$currPos, 2) === peg$c135) {
                    s6 = peg$c135;
                    peg$currPos += 2;
                  } else {
                    s6 = peg$FAILED;
                    if (peg$silentFails === 0) { peg$fail(peg$c136); }
                  }
                }
              }
              if (s6 !== peg$FAILED) {
                s7 = peg$parse_();
                if (s7 !== peg$FAILED) {
                  s8 = peg$parseAdditiveExpression();
                  if (s8 !== peg$FAILED) {
                    s9 = peg$parsestart();
                    if (s9 !== peg$FAILED) {
                      s5 = [s5, s6, s7, s8, s9];
                      s4 = s5;
                    } else {
                      peg$currPos = s4;
                      s4 = peg$c0;
                    }
                  } else {
                    peg$currPos = s4;
                    s4 = peg$c0;
                  }
                } else {
                  peg$currPos = s4;
                  s4 = peg$c0;
                }
              } else {
                peg$currPos = s4;
                s4 = peg$c0;
              }
            } else {
              peg$currPos = s4;
              s4 = peg$c0;
            }
          }
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c116(s1, s2, s3);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseAdditiveExpression() {
      var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9;

      var key    = peg$currPos * 189 + 66,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        s2 = peg$parseMultiplicativeExpression();
        if (s2 !== peg$FAILED) {
          s3 = [];
          s4 = peg$currPos;
          s5 = peg$parse_();
          if (s5 !== peg$FAILED) {
            if (input.charCodeAt(peg$currPos) === 43) {
              s6 = peg$c137;
              peg$currPos++;
            } else {
              s6 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c138); }
            }
            if (s6 === peg$FAILED) {
              if (input.charCodeAt(peg$currPos) === 45) {
                s6 = peg$c139;
                peg$currPos++;
              } else {
                s6 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c140); }
              }
            }
            if (s6 !== peg$FAILED) {
              s7 = peg$parse_();
              if (s7 !== peg$FAILED) {
                s8 = peg$parseMultiplicativeExpression();
                if (s8 !== peg$FAILED) {
                  s9 = peg$parsestart();
                  if (s9 !== peg$FAILED) {
                    s5 = [s5, s6, s7, s8, s9];
                    s4 = s5;
                  } else {
                    peg$currPos = s4;
                    s4 = peg$c0;
                  }
                } else {
                  peg$currPos = s4;
                  s4 = peg$c0;
                }
              } else {
                peg$currPos = s4;
                s4 = peg$c0;
              }
            } else {
              peg$currPos = s4;
              s4 = peg$c0;
            }
          } else {
            peg$currPos = s4;
            s4 = peg$c0;
          }
          while (s4 !== peg$FAILED) {
            s3.push(s4);
            s4 = peg$currPos;
            s5 = peg$parse_();
            if (s5 !== peg$FAILED) {
              if (input.charCodeAt(peg$currPos) === 43) {
                s6 = peg$c137;
                peg$currPos++;
              } else {
                s6 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c138); }
              }
              if (s6 === peg$FAILED) {
                if (input.charCodeAt(peg$currPos) === 45) {
                  s6 = peg$c139;
                  peg$currPos++;
                } else {
                  s6 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$c140); }
                }
              }
              if (s6 !== peg$FAILED) {
                s7 = peg$parse_();
                if (s7 !== peg$FAILED) {
                  s8 = peg$parseMultiplicativeExpression();
                  if (s8 !== peg$FAILED) {
                    s9 = peg$parsestart();
                    if (s9 !== peg$FAILED) {
                      s5 = [s5, s6, s7, s8, s9];
                      s4 = s5;
                    } else {
                      peg$currPos = s4;
                      s4 = peg$c0;
                    }
                  } else {
                    peg$currPos = s4;
                    s4 = peg$c0;
                  }
                } else {
                  peg$currPos = s4;
                  s4 = peg$c0;
                }
              } else {
                peg$currPos = s4;
                s4 = peg$c0;
              }
            } else {
              peg$currPos = s4;
              s4 = peg$c0;
            }
          }
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c116(s1, s2, s3);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseMultiplicativeExpression() {
      var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9;

      var key    = peg$currPos * 189 + 67,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        s2 = peg$parseUnaryExpression();
        if (s2 !== peg$FAILED) {
          s3 = [];
          s4 = peg$currPos;
          s5 = peg$parse_();
          if (s5 !== peg$FAILED) {
            if (input.charCodeAt(peg$currPos) === 42) {
              s6 = peg$c141;
              peg$currPos++;
            } else {
              s6 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c142); }
            }
            if (s6 === peg$FAILED) {
              if (input.charCodeAt(peg$currPos) === 47) {
                s6 = peg$c143;
                peg$currPos++;
              } else {
                s6 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c144); }
              }
              if (s6 === peg$FAILED) {
                if (input.charCodeAt(peg$currPos) === 37) {
                  s6 = peg$c145;
                  peg$currPos++;
                } else {
                  s6 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$c146); }
                }
              }
            }
            if (s6 !== peg$FAILED) {
              s7 = peg$parse_();
              if (s7 !== peg$FAILED) {
                s8 = peg$parseUnaryExpression();
                if (s8 !== peg$FAILED) {
                  s9 = peg$parsestart();
                  if (s9 !== peg$FAILED) {
                    s5 = [s5, s6, s7, s8, s9];
                    s4 = s5;
                  } else {
                    peg$currPos = s4;
                    s4 = peg$c0;
                  }
                } else {
                  peg$currPos = s4;
                  s4 = peg$c0;
                }
              } else {
                peg$currPos = s4;
                s4 = peg$c0;
              }
            } else {
              peg$currPos = s4;
              s4 = peg$c0;
            }
          } else {
            peg$currPos = s4;
            s4 = peg$c0;
          }
          while (s4 !== peg$FAILED) {
            s3.push(s4);
            s4 = peg$currPos;
            s5 = peg$parse_();
            if (s5 !== peg$FAILED) {
              if (input.charCodeAt(peg$currPos) === 42) {
                s6 = peg$c141;
                peg$currPos++;
              } else {
                s6 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c142); }
              }
              if (s6 === peg$FAILED) {
                if (input.charCodeAt(peg$currPos) === 47) {
                  s6 = peg$c143;
                  peg$currPos++;
                } else {
                  s6 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$c144); }
                }
                if (s6 === peg$FAILED) {
                  if (input.charCodeAt(peg$currPos) === 37) {
                    s6 = peg$c145;
                    peg$currPos++;
                  } else {
                    s6 = peg$FAILED;
                    if (peg$silentFails === 0) { peg$fail(peg$c146); }
                  }
                }
              }
              if (s6 !== peg$FAILED) {
                s7 = peg$parse_();
                if (s7 !== peg$FAILED) {
                  s8 = peg$parseUnaryExpression();
                  if (s8 !== peg$FAILED) {
                    s9 = peg$parsestart();
                    if (s9 !== peg$FAILED) {
                      s5 = [s5, s6, s7, s8, s9];
                      s4 = s5;
                    } else {
                      peg$currPos = s4;
                      s4 = peg$c0;
                    }
                  } else {
                    peg$currPos = s4;
                    s4 = peg$c0;
                  }
                } else {
                  peg$currPos = s4;
                  s4 = peg$c0;
                }
              } else {
                peg$currPos = s4;
                s4 = peg$c0;
              }
            } else {
              peg$currPos = s4;
              s4 = peg$c0;
            }
          }
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c116(s1, s2, s3);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseUnaryExpression() {
      var s0, s1, s2, s3, s4, s5;

      var key    = peg$currPos * 189 + 68,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        s2 = peg$parseunaryOperator();
        if (s2 !== peg$FAILED) {
          s3 = peg$parse_();
          if (s3 !== peg$FAILED) {
            s4 = peg$parseUpdateExpression();
            if (s4 !== peg$FAILED) {
              s5 = peg$parsestart();
              if (s5 !== peg$FAILED) {
                peg$reportedPos = s0;
                s1 = peg$c147(s1, s2, s4, s5);
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }
      if (s0 === peg$FAILED) {
        s0 = peg$parseUpdateExpression();
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseunaryOperator() {
      var s0, s1;

      var key    = peg$currPos * 189 + 69,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      peg$silentFails++;
      s0 = peg$parsenot();
      if (s0 === peg$FAILED) {
        if (input.charCodeAt(peg$currPos) === 45) {
          s0 = peg$c139;
          peg$currPos++;
        } else {
          s0 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c140); }
        }
        if (s0 === peg$FAILED) {
          if (input.charCodeAt(peg$currPos) === 43) {
            s0 = peg$c137;
            peg$currPos++;
          } else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c138); }
          }
          if (s0 === peg$FAILED) {
            if (input.charCodeAt(peg$currPos) === 126) {
              s0 = peg$c149;
              peg$currPos++;
            } else {
              s0 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c150); }
            }
            if (s0 === peg$FAILED) {
              s0 = peg$parsetypeof();
              if (s0 === peg$FAILED) {
                s0 = peg$parsevoid();
                if (s0 === peg$FAILED) {
                  s0 = peg$parsedelete();
                }
              }
            }
          }
        }
      }
      peg$silentFails--;
      if (s0 === peg$FAILED) {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c148); }
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseUpdateExpression() {
      var s0, s1, s2, s3, s4, s5, s6;

      var key    = peg$currPos * 189 + 70,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        if (input.substr(peg$currPos, 2) === peg$c151) {
          s2 = peg$c151;
          peg$currPos += 2;
        } else {
          s2 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c152); }
        }
        if (s2 === peg$FAILED) {
          if (input.substr(peg$currPos, 2) === peg$c153) {
            s2 = peg$c153;
            peg$currPos += 2;
          } else {
            s2 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c154); }
          }
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$parseCallExpression();
          if (s3 !== peg$FAILED) {
            s4 = peg$parsestart();
            if (s4 !== peg$FAILED) {
              peg$reportedPos = s0;
              s1 = peg$c155(s1, s2, s3, s4);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        s1 = peg$parsestart();
        if (s1 !== peg$FAILED) {
          s2 = peg$parse_();
          if (s2 !== peg$FAILED) {
            s3 = peg$parseCallExpression();
            if (s3 !== peg$FAILED) {
              if (input.substr(peg$currPos, 2) === peg$c151) {
                s4 = peg$c151;
                peg$currPos += 2;
              } else {
                s4 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c152); }
              }
              if (s4 === peg$FAILED) {
                if (input.substr(peg$currPos, 2) === peg$c153) {
                  s4 = peg$c153;
                  peg$currPos += 2;
                } else {
                  s4 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$c154); }
                }
              }
              if (s4 !== peg$FAILED) {
                s5 = peg$parsestart();
                if (s5 !== peg$FAILED) {
                  peg$reportedPos = s0;
                  s1 = peg$c156(s1, s3, s4, s5);
                  s0 = s1;
                } else {
                  peg$currPos = s0;
                  s0 = peg$c0;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
        if (s0 === peg$FAILED) {
          s0 = peg$currPos;
          s1 = peg$parsestart();
          if (s1 !== peg$FAILED) {
            s2 = peg$parse_();
            if (s2 !== peg$FAILED) {
              s3 = peg$parseCallExpression();
              if (s3 !== peg$FAILED) {
                if (input.charCodeAt(peg$currPos) === 63) {
                  s4 = peg$c111;
                  peg$currPos++;
                } else {
                  s4 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$c112); }
                }
                if (s4 !== peg$FAILED) {
                  s5 = peg$currPos;
                  peg$silentFails++;
                  if (input.charCodeAt(peg$currPos) === 46) {
                    s6 = peg$c44;
                    peg$currPos++;
                  } else {
                    s6 = peg$FAILED;
                    if (peg$silentFails === 0) { peg$fail(peg$c45); }
                  }
                  peg$silentFails--;
                  if (s6 === peg$FAILED) {
                    s5 = peg$c16;
                  } else {
                    peg$currPos = s5;
                    s5 = peg$c0;
                  }
                  if (s5 !== peg$FAILED) {
                    s6 = peg$parsestart();
                    if (s6 !== peg$FAILED) {
                      peg$reportedPos = s0;
                      s1 = peg$c157(s1, s3, s4, s6);
                      s0 = s1;
                    } else {
                      peg$currPos = s0;
                      s0 = peg$c0;
                    }
                  } else {
                    peg$currPos = s0;
                    s0 = peg$c0;
                  }
                } else {
                  peg$currPos = s0;
                  s0 = peg$c0;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
          if (s0 === peg$FAILED) {
            s0 = peg$parseCallExpression();
          }
        }
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseCallExpression() {
      var s0, s1, s2, s3, s4;

      var key    = peg$currPos * 189 + 71,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        s2 = peg$parseMemberExpression();
        if (s2 !== peg$FAILED) {
          s3 = [];
          s4 = peg$parsetailCall();
          if (s4 === peg$FAILED) {
            s4 = peg$parsetailMember();
          }
          while (s4 !== peg$FAILED) {
            s3.push(s4);
            s4 = peg$parsetailCall();
            if (s4 === peg$FAILED) {
              s4 = peg$parsetailMember();
            }
          }
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c158(s1, s2, s3);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsetailCall() {
      var s0, s1, s2, s3, s4;

      var key    = peg$currPos * 189 + 72,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parse_();
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        if (input.charCodeAt(peg$currPos) === 63) {
          s3 = peg$c111;
          peg$currPos++;
        } else {
          s3 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c112); }
        }
        if (s3 !== peg$FAILED) {
          peg$reportedPos = s2;
          s3 = peg$c159();
        }
        s2 = s3;
        if (s2 === peg$FAILED) {
          s2 = peg$c4;
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$parsearguments();
          if (s3 !== peg$FAILED) {
            s4 = peg$parsestart();
            if (s4 !== peg$FAILED) {
              peg$reportedPos = s0;
              s1 = peg$c160(s2, s3, s4);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsetailMember() {
      var s0, s1, s2, s3, s4, s5, s6, s7, s8;

      var key    = peg$currPos * 189 + 73,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parse_();
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        if (input.charCodeAt(peg$currPos) === 63) {
          s3 = peg$c111;
          peg$currPos++;
        } else {
          s3 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c112); }
        }
        if (s3 !== peg$FAILED) {
          peg$reportedPos = s2;
          s3 = peg$c159();
        }
        s2 = s3;
        if (s2 === peg$FAILED) {
          s2 = peg$c4;
        }
        if (s2 !== peg$FAILED) {
          if (input.charCodeAt(peg$currPos) === 91) {
            s3 = peg$c34;
            peg$currPos++;
          } else {
            s3 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c35); }
          }
          if (s3 !== peg$FAILED) {
            s4 = peg$parse_();
            if (s4 !== peg$FAILED) {
              s5 = peg$parseAssignmentExpression();
              if (s5 !== peg$FAILED) {
                s6 = peg$parse_();
                if (s6 !== peg$FAILED) {
                  if (input.charCodeAt(peg$currPos) === 93) {
                    s7 = peg$c36;
                    peg$currPos++;
                  } else {
                    s7 = peg$FAILED;
                    if (peg$silentFails === 0) { peg$fail(peg$c37); }
                  }
                  if (s7 !== peg$FAILED) {
                    s8 = peg$parsestart();
                    if (s8 !== peg$FAILED) {
                      peg$reportedPos = s0;
                      s1 = peg$c161(s2, s5, s8);
                      s0 = s1;
                    } else {
                      peg$currPos = s0;
                      s0 = peg$c0;
                    }
                  } else {
                    peg$currPos = s0;
                    s0 = peg$c0;
                  }
                } else {
                  peg$currPos = s0;
                  s0 = peg$c0;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        s1 = peg$parse_();
        if (s1 !== peg$FAILED) {
          s2 = peg$currPos;
          if (input.charCodeAt(peg$currPos) === 63) {
            s3 = peg$c111;
            peg$currPos++;
          } else {
            s3 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c112); }
          }
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s2;
            s3 = peg$c159();
          }
          s2 = s3;
          if (s2 === peg$FAILED) {
            s2 = peg$c4;
          }
          if (s2 !== peg$FAILED) {
            if (input.charCodeAt(peg$currPos) === 46) {
              s3 = peg$c44;
              peg$currPos++;
            } else {
              s3 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c45); }
            }
            if (s3 !== peg$FAILED) {
              s4 = peg$parse_();
              if (s4 !== peg$FAILED) {
                s5 = peg$parseIdentifierName();
                if (s5 !== peg$FAILED) {
                  s6 = peg$parsestart();
                  if (s6 !== peg$FAILED) {
                    peg$reportedPos = s0;
                    s1 = peg$c162(s2, s5, s6);
                    s0 = s1;
                  } else {
                    peg$currPos = s0;
                    s0 = peg$c0;
                  }
                } else {
                  peg$currPos = s0;
                  s0 = peg$c0;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsearguments() {
      var s0;

      var key    = peg$currPos * 189 + 74,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$parseinlineArguments();
      if (s0 === peg$FAILED) {
        s0 = peg$parsemultilineArguments();
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseinlineArguments() {
      var s0;

      var key    = peg$currPos * 189 + 75,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$parseinlineArgmentsList();
      if (s0 === peg$FAILED) {
        s0 = peg$parseinlineArgumentsObject();
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseinlineArgmentsList() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 76,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.charCodeAt(peg$currPos) === 40) {
        s1 = peg$c73;
        peg$currPos++;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c74); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$parseargumentList();
        if (s2 === peg$FAILED) {
          s2 = peg$c4;
        }
        if (s2 !== peg$FAILED) {
          if (input.charCodeAt(peg$currPos) === 41) {
            s3 = peg$c75;
            peg$currPos++;
          } else {
            s3 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c76); }
          }
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c163(s2);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseinlineArgumentsObject() {
      var s0, s1, s2, s3, s4, s5;

      var key    = peg$currPos * 189 + 77,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.charCodeAt(peg$currPos) === 40) {
        s1 = peg$c73;
        peg$currPos++;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c74); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$parsestart();
        if (s2 !== peg$FAILED) {
          s3 = peg$parsepropertyAssignmentList();
          if (s3 !== peg$FAILED) {
            s4 = peg$parsestart();
            if (s4 !== peg$FAILED) {
              if (input.charCodeAt(peg$currPos) === 41) {
                s5 = peg$c75;
                peg$currPos++;
              } else {
                s5 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c76); }
              }
              if (s5 !== peg$FAILED) {
                peg$reportedPos = s0;
                s1 = peg$c164(s2, s3, s4);
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseargumentList() {
      var s0, s1, s2, s3, s4, s5, s6, s7;

      var key    = peg$currPos * 189 + 78,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parseExpression();
      if (s1 !== peg$FAILED) {
        s2 = [];
        s3 = peg$currPos;
        s4 = peg$parse_();
        if (s4 !== peg$FAILED) {
          if (input.charCodeAt(peg$currPos) === 44) {
            s5 = peg$c5;
            peg$currPos++;
          } else {
            s5 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c6); }
          }
          if (s5 !== peg$FAILED) {
            s6 = peg$parse_();
            if (s6 !== peg$FAILED) {
              s7 = peg$parseExpression();
              if (s7 !== peg$FAILED) {
                peg$reportedPos = s3;
                s4 = peg$c165(s7);
                s3 = s4;
              } else {
                peg$currPos = s3;
                s3 = peg$c0;
              }
            } else {
              peg$currPos = s3;
              s3 = peg$c0;
            }
          } else {
            peg$currPos = s3;
            s3 = peg$c0;
          }
        } else {
          peg$currPos = s3;
          s3 = peg$c0;
        }
        while (s3 !== peg$FAILED) {
          s2.push(s3);
          s3 = peg$currPos;
          s4 = peg$parse_();
          if (s4 !== peg$FAILED) {
            if (input.charCodeAt(peg$currPos) === 44) {
              s5 = peg$c5;
              peg$currPos++;
            } else {
              s5 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c6); }
            }
            if (s5 !== peg$FAILED) {
              s6 = peg$parse_();
              if (s6 !== peg$FAILED) {
                s7 = peg$parseExpression();
                if (s7 !== peg$FAILED) {
                  peg$reportedPos = s3;
                  s4 = peg$c165(s7);
                  s3 = s4;
                } else {
                  peg$currPos = s3;
                  s3 = peg$c0;
                }
              } else {
                peg$currPos = s3;
                s3 = peg$c0;
              }
            } else {
              peg$currPos = s3;
              s3 = peg$c0;
            }
          } else {
            peg$currPos = s3;
            s3 = peg$c0;
          }
        }
        if (s2 !== peg$FAILED) {
          peg$reportedPos = s0;
          s1 = peg$c166(s1, s2);
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseMemberExpression() {
      var s0, s1, s2, s3, s4;

      var key    = peg$currPos * 189 + 79,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        s2 = peg$parseDoExpression();
        if (s2 === peg$FAILED) {
          s2 = peg$parseImportExpression();
          if (s2 === peg$FAILED) {
            s2 = peg$parseFunctionExpression();
            if (s2 === peg$FAILED) {
              s2 = peg$parseNewExpression();
              if (s2 === peg$FAILED) {
                s2 = peg$parsePrimaryExpression();
              }
            }
          }
        }
        if (s2 !== peg$FAILED) {
          s3 = [];
          s4 = peg$parsetailMember();
          while (s4 !== peg$FAILED) {
            s3.push(s4);
            s4 = peg$parsetailMember();
          }
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c158(s1, s2, s3);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseNewExpression() {
      var s0, s1, s2, s3, s4, s5, s6;

      var key    = peg$currPos * 189 + 80,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        s2 = peg$parsenew();
        if (s2 !== peg$FAILED) {
          s3 = peg$parse_();
          if (s3 !== peg$FAILED) {
            s4 = peg$parseMemberExpression();
            if (s4 !== peg$FAILED) {
              s5 = peg$parsearguments();
              if (s5 === peg$FAILED) {
                s5 = peg$c4;
              }
              if (s5 !== peg$FAILED) {
                s6 = peg$parsestart();
                if (s6 !== peg$FAILED) {
                  peg$reportedPos = s0;
                  s1 = peg$c167(s1, s4, s5, s6);
                  s0 = s1;
                } else {
                  peg$currPos = s0;
                  s0 = peg$c0;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseImportExpression() {
      var s0, s1, s2, s3, s4, s5;

      var key    = peg$currPos * 189 + 81,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        s2 = peg$parseimport();
        if (s2 !== peg$FAILED) {
          s3 = peg$parse_();
          if (s3 !== peg$FAILED) {
            s4 = peg$parseGroupExpression();
            if (s4 === peg$FAILED) {
              s4 = peg$parseAssignmentExpression();
            }
            if (s4 !== peg$FAILED) {
              s5 = peg$parsestart();
              if (s5 !== peg$FAILED) {
                peg$reportedPos = s0;
                s1 = peg$c168(s1, s4, s5);
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseDoExpression() {
      var s0, s1, s2, s3, s4, s5;

      var key    = peg$currPos * 189 + 82,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        s2 = peg$parsedo();
        if (s2 !== peg$FAILED) {
          s3 = peg$parse_();
          if (s3 !== peg$FAILED) {
            s4 = peg$parseExpression();
            if (s4 !== peg$FAILED) {
              s5 = peg$parsestart();
              if (s5 !== peg$FAILED) {
                peg$reportedPos = s0;
                s1 = peg$c169(s1, s4, s5);
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseUndoStatement() {
      var s0, s1, s2, s3, s4, s5;

      var key    = peg$currPos * 189 + 83,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        s2 = peg$parseundo();
        if (s2 !== peg$FAILED) {
          s3 = peg$parse_();
          if (s3 !== peg$FAILED) {
            s4 = peg$parseFunctionExpression();
            if (s4 !== peg$FAILED) {
              s5 = peg$parsestart();
              if (s5 !== peg$FAILED) {
                peg$reportedPos = s0;
                s1 = peg$c170(s1, s4, s5);
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseFunctionExpression() {
      var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11;

      var key    = peg$currPos * 189 + 84,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        s2 = peg$parsetemplate();
        if (s2 === peg$FAILED) {
          s2 = peg$c4;
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$parse_();
          if (s3 !== peg$FAILED) {
            s4 = peg$parseIdentifier();
            if (s4 === peg$FAILED) {
              s4 = peg$parsesimpleString();
            }
            if (s4 === peg$FAILED) {
              s4 = peg$c4;
            }
            if (s4 !== peg$FAILED) {
              s5 = peg$parse_();
              if (s5 !== peg$FAILED) {
                s6 = peg$parseformalParameterList();
                if (s6 === peg$FAILED) {
                  s6 = peg$c4;
                }
                if (s6 !== peg$FAILED) {
                  s7 = peg$parse_();
                  if (s7 !== peg$FAILED) {
                    s8 = peg$currPos;
                    if (input.substr(peg$currPos, 2) === peg$c171) {
                      s9 = peg$c171;
                      peg$currPos += 2;
                    } else {
                      s9 = peg$FAILED;
                      if (peg$silentFails === 0) { peg$fail(peg$c172); }
                    }
                    if (s9 !== peg$FAILED) {
                      peg$reportedPos = s8;
                      s9 = peg$c173();
                    }
                    s8 = s9;
                    if (s8 === peg$FAILED) {
                      s8 = peg$currPos;
                      if (input.substr(peg$currPos, 2) === peg$c174) {
                        s9 = peg$c174;
                        peg$currPos += 2;
                      } else {
                        s9 = peg$FAILED;
                        if (peg$silentFails === 0) { peg$fail(peg$c175); }
                      }
                      if (s9 !== peg$FAILED) {
                        peg$reportedPos = s8;
                        s9 = peg$c176();
                      }
                      s8 = s9;
                    }
                    if (s8 !== peg$FAILED) {
                      s9 = peg$parse_();
                      if (s9 !== peg$FAILED) {
                        s10 = peg$parseExpression();
                        if (s10 === peg$FAILED) {
                          s10 = peg$parseThrowStatement();
                          if (s10 === peg$FAILED) {
                            s10 = peg$parseBlockStatement();
                          }
                        }
                        if (s10 === peg$FAILED) {
                          s10 = peg$c4;
                        }
                        if (s10 !== peg$FAILED) {
                          s11 = peg$parsestart();
                          if (s11 !== peg$FAILED) {
                            peg$reportedPos = s0;
                            s1 = peg$c177(s1, s2, s4, s6, s8, s10, s11);
                            s0 = s1;
                          } else {
                            peg$currPos = s0;
                            s0 = peg$c0;
                          }
                        } else {
                          peg$currPos = s0;
                          s0 = peg$c0;
                        }
                      } else {
                        peg$currPos = s0;
                        s0 = peg$c0;
                      }
                    } else {
                      peg$currPos = s0;
                      s0 = peg$c0;
                    }
                  } else {
                    peg$currPos = s0;
                    s0 = peg$c0;
                  }
                } else {
                  peg$currPos = s0;
                  s0 = peg$c0;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseformalParameterList() {
      var s0, s1, s2, s3, s4, s5;

      var key    = peg$currPos * 189 + 85,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.charCodeAt(peg$currPos) === 40) {
        s1 = peg$c73;
        peg$currPos++;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c74); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$parse_();
        if (s2 !== peg$FAILED) {
          s3 = peg$parseformalParameters();
          if (s3 === peg$FAILED) {
            s3 = peg$c4;
          }
          if (s3 !== peg$FAILED) {
            s4 = peg$parse_();
            if (s4 !== peg$FAILED) {
              if (input.charCodeAt(peg$currPos) === 41) {
                s5 = peg$c75;
                peg$currPos++;
              } else {
                s5 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c76); }
              }
              if (s5 !== peg$FAILED) {
                peg$reportedPos = s0;
                s1 = peg$c178(s3);
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseformalParameters() {
      var s0, s1, s2, s3, s4, s5, s6, s7;

      var key    = peg$currPos * 189 + 86,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parseformalParameter();
      if (s1 !== peg$FAILED) {
        s2 = [];
        s3 = peg$currPos;
        s4 = peg$parse_();
        if (s4 !== peg$FAILED) {
          if (input.charCodeAt(peg$currPos) === 44) {
            s5 = peg$c5;
            peg$currPos++;
          } else {
            s5 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c6); }
          }
          if (s5 !== peg$FAILED) {
            s6 = peg$parse_();
            if (s6 !== peg$FAILED) {
              s7 = peg$parseformalParameter();
              if (s7 !== peg$FAILED) {
                peg$reportedPos = s3;
                s4 = peg$c7(s7);
                s3 = s4;
              } else {
                peg$currPos = s3;
                s3 = peg$c0;
              }
            } else {
              peg$currPos = s3;
              s3 = peg$c0;
            }
          } else {
            peg$currPos = s3;
            s3 = peg$c0;
          }
        } else {
          peg$currPos = s3;
          s3 = peg$c0;
        }
        while (s3 !== peg$FAILED) {
          s2.push(s3);
          s3 = peg$currPos;
          s4 = peg$parse_();
          if (s4 !== peg$FAILED) {
            if (input.charCodeAt(peg$currPos) === 44) {
              s5 = peg$c5;
              peg$currPos++;
            } else {
              s5 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c6); }
            }
            if (s5 !== peg$FAILED) {
              s6 = peg$parse_();
              if (s6 !== peg$FAILED) {
                s7 = peg$parseformalParameter();
                if (s7 !== peg$FAILED) {
                  peg$reportedPos = s3;
                  s4 = peg$c7(s7);
                  s3 = s4;
                } else {
                  peg$currPos = s3;
                  s3 = peg$c0;
                }
              } else {
                peg$currPos = s3;
                s3 = peg$c0;
              }
            } else {
              peg$currPos = s3;
              s3 = peg$c0;
            }
          } else {
            peg$currPos = s3;
            s3 = peg$c0;
          }
        }
        if (s2 !== peg$FAILED) {
          peg$reportedPos = s0;
          s1 = peg$c46(s1, s2);
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseformalParameter() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 87,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parseSpreadPattern();
      if (s1 !== peg$FAILED) {
        s2 = peg$parse_();
        if (s2 !== peg$FAILED) {
          s3 = peg$parseformalParameterInitializer();
          if (s3 === peg$FAILED) {
            s3 = peg$c4;
          }
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c179(s1, s3);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseformalParameterInitializer() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 88,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.charCodeAt(peg$currPos) === 61) {
        s1 = peg$c59;
        peg$currPos++;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c60); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$parse_();
        if (s2 !== peg$FAILED) {
          s3 = peg$parseAssignmentExpression();
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c7(s3);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsePrimaryExpression() {
      var s0, s1;

      var key    = peg$currPos * 189 + 89,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      peg$silentFails++;
      s0 = peg$parseThisExpression();
      if (s0 === peg$FAILED) {
        s0 = peg$parseIdentifier();
        if (s0 === peg$FAILED) {
          s0 = peg$parseLiteral();
          if (s0 === peg$FAILED) {
            s0 = peg$parseArrayLiteral();
            if (s0 === peg$FAILED) {
              s0 = peg$parseArrayComprehension();
              if (s0 === peg$FAILED) {
                s0 = peg$parseObjectLiteral();
                if (s0 === peg$FAILED) {
                  s0 = peg$parseGroupExpression();
                  if (s0 === peg$FAILED) {
                    s0 = peg$parseJavascriptExpression();
                  }
                }
              }
            }
          }
        }
      }
      peg$silentFails--;
      if (s0 === peg$FAILED) {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c180); }
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseJavascriptExpression() {
      var s0, s1, s2, s3, s4, s5, s6;

      var key    = peg$currPos * 189 + 90,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        if (input.charCodeAt(peg$currPos) === 96) {
          s2 = peg$c181;
          peg$currPos++;
        } else {
          s2 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c182); }
        }
        if (s2 !== peg$FAILED) {
          s3 = [];
          s4 = peg$currPos;
          s5 = peg$currPos;
          peg$silentFails++;
          if (input.charCodeAt(peg$currPos) === 96) {
            s6 = peg$c181;
            peg$currPos++;
          } else {
            s6 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c182); }
          }
          peg$silentFails--;
          if (s6 === peg$FAILED) {
            s5 = peg$c16;
          } else {
            peg$currPos = s5;
            s5 = peg$c0;
          }
          if (s5 !== peg$FAILED) {
            if (input.length > peg$currPos) {
              s6 = input.charAt(peg$currPos);
              peg$currPos++;
            } else {
              s6 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c183); }
            }
            if (s6 !== peg$FAILED) {
              s5 = [s5, s6];
              s4 = s5;
            } else {
              peg$currPos = s4;
              s4 = peg$c0;
            }
          } else {
            peg$currPos = s4;
            s4 = peg$c0;
          }
          if (s4 !== peg$FAILED) {
            while (s4 !== peg$FAILED) {
              s3.push(s4);
              s4 = peg$currPos;
              s5 = peg$currPos;
              peg$silentFails++;
              if (input.charCodeAt(peg$currPos) === 96) {
                s6 = peg$c181;
                peg$currPos++;
              } else {
                s6 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c182); }
              }
              peg$silentFails--;
              if (s6 === peg$FAILED) {
                s5 = peg$c16;
              } else {
                peg$currPos = s5;
                s5 = peg$c0;
              }
              if (s5 !== peg$FAILED) {
                if (input.length > peg$currPos) {
                  s6 = input.charAt(peg$currPos);
                  peg$currPos++;
                } else {
                  s6 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$c183); }
                }
                if (s6 !== peg$FAILED) {
                  s5 = [s5, s6];
                  s4 = s5;
                } else {
                  peg$currPos = s4;
                  s4 = peg$c0;
                }
              } else {
                peg$currPos = s4;
                s4 = peg$c0;
              }
            }
          } else {
            s3 = peg$c0;
          }
          if (s3 !== peg$FAILED) {
            if (input.charCodeAt(peg$currPos) === 96) {
              s4 = peg$c181;
              peg$currPos++;
            } else {
              s4 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c182); }
            }
            if (s4 !== peg$FAILED) {
              s5 = peg$parsestart();
              if (s5 !== peg$FAILED) {
                peg$reportedPos = s0;
                s1 = peg$c184(s1, s3, s5);
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseArrayLiteral() {
      var s0, s1, s2, s3, s4, s5, s6, s7;

      var key    = peg$currPos * 189 + 91,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        if (input.charCodeAt(peg$currPos) === 91) {
          s2 = peg$c34;
          peg$currPos++;
        } else {
          s2 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c35); }
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$parse_();
          if (s3 !== peg$FAILED) {
            s4 = peg$parseelementList();
            if (s4 === peg$FAILED) {
              s4 = peg$c4;
            }
            if (s4 !== peg$FAILED) {
              s5 = peg$parse_();
              if (s5 !== peg$FAILED) {
                if (input.charCodeAt(peg$currPos) === 93) {
                  s6 = peg$c36;
                  peg$currPos++;
                } else {
                  s6 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$c37); }
                }
                if (s6 !== peg$FAILED) {
                  s7 = peg$parsestart();
                  if (s7 !== peg$FAILED) {
                    peg$reportedPos = s0;
                    s1 = peg$c185(s1, s4, s7);
                    s0 = s1;
                  } else {
                    peg$currPos = s0;
                    s0 = peg$c0;
                  }
                } else {
                  peg$currPos = s0;
                  s0 = peg$c0;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseelementList() {
      var s0, s1, s2, s3, s4, s5, s6, s7;

      var key    = peg$currPos * 189 + 92,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parseAssignmentExpression();
      if (s1 !== peg$FAILED) {
        s2 = [];
        s3 = peg$currPos;
        s4 = peg$parse_();
        if (s4 !== peg$FAILED) {
          if (input.charCodeAt(peg$currPos) === 44) {
            s5 = peg$c5;
            peg$currPos++;
          } else {
            s5 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c6); }
          }
          if (s5 !== peg$FAILED) {
            s6 = peg$parse_();
            if (s6 !== peg$FAILED) {
              s7 = peg$parseAssignmentExpression();
              if (s7 !== peg$FAILED) {
                peg$reportedPos = s3;
                s4 = peg$c186(s7);
                s3 = s4;
              } else {
                peg$currPos = s3;
                s3 = peg$c0;
              }
            } else {
              peg$currPos = s3;
              s3 = peg$c0;
            }
          } else {
            peg$currPos = s3;
            s3 = peg$c0;
          }
        } else {
          peg$currPos = s3;
          s3 = peg$c0;
        }
        while (s3 !== peg$FAILED) {
          s2.push(s3);
          s3 = peg$currPos;
          s4 = peg$parse_();
          if (s4 !== peg$FAILED) {
            if (input.charCodeAt(peg$currPos) === 44) {
              s5 = peg$c5;
              peg$currPos++;
            } else {
              s5 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c6); }
            }
            if (s5 !== peg$FAILED) {
              s6 = peg$parse_();
              if (s6 !== peg$FAILED) {
                s7 = peg$parseAssignmentExpression();
                if (s7 !== peg$FAILED) {
                  peg$reportedPos = s3;
                  s4 = peg$c186(s7);
                  s3 = s4;
                } else {
                  peg$currPos = s3;
                  s3 = peg$c0;
                }
              } else {
                peg$currPos = s3;
                s3 = peg$c0;
              }
            } else {
              peg$currPos = s3;
              s3 = peg$c0;
            }
          } else {
            peg$currPos = s3;
            s3 = peg$c0;
          }
        }
        if (s2 !== peg$FAILED) {
          peg$reportedPos = s0;
          s1 = peg$c46(s1, s2);
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseObjectLiteral() {
      var s0, s1, s2, s3, s4, s5, s6, s7;

      var key    = peg$currPos * 189 + 93,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        if (input.charCodeAt(peg$currPos) === 123) {
          s2 = peg$c187;
          peg$currPos++;
        } else {
          s2 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c188); }
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$parse_();
          if (s3 !== peg$FAILED) {
            s4 = peg$parsepropertyAssignmentList();
            if (s4 === peg$FAILED) {
              s4 = peg$c4;
            }
            if (s4 !== peg$FAILED) {
              s5 = peg$parse_();
              if (s5 !== peg$FAILED) {
                if (input.charCodeAt(peg$currPos) === 125) {
                  s6 = peg$c189;
                  peg$currPos++;
                } else {
                  s6 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$c190); }
                }
                if (s6 !== peg$FAILED) {
                  s7 = peg$parsestart();
                  if (s7 !== peg$FAILED) {
                    peg$reportedPos = s0;
                    s1 = peg$c191(s1, s4, s7);
                    s0 = s1;
                  } else {
                    peg$currPos = s0;
                    s0 = peg$c0;
                  }
                } else {
                  peg$currPos = s0;
                  s0 = peg$c0;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsepropertyAssignmentList() {
      var s0, s1, s2, s3, s4, s5, s6, s7;

      var key    = peg$currPos * 189 + 94,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsepropertyAssignment();
      if (s1 !== peg$FAILED) {
        s2 = [];
        s3 = peg$currPos;
        s4 = peg$parse_();
        if (s4 !== peg$FAILED) {
          if (input.charCodeAt(peg$currPos) === 44) {
            s5 = peg$c5;
            peg$currPos++;
          } else {
            s5 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c6); }
          }
          if (s5 !== peg$FAILED) {
            s6 = peg$parse_();
            if (s6 !== peg$FAILED) {
              s7 = peg$parsepropertyAssignment();
              if (s7 !== peg$FAILED) {
                peg$reportedPos = s3;
                s4 = peg$c186(s7);
                s3 = s4;
              } else {
                peg$currPos = s3;
                s3 = peg$c0;
              }
            } else {
              peg$currPos = s3;
              s3 = peg$c0;
            }
          } else {
            peg$currPos = s3;
            s3 = peg$c0;
          }
        } else {
          peg$currPos = s3;
          s3 = peg$c0;
        }
        while (s3 !== peg$FAILED) {
          s2.push(s3);
          s3 = peg$currPos;
          s4 = peg$parse_();
          if (s4 !== peg$FAILED) {
            if (input.charCodeAt(peg$currPos) === 44) {
              s5 = peg$c5;
              peg$currPos++;
            } else {
              s5 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c6); }
            }
            if (s5 !== peg$FAILED) {
              s6 = peg$parse_();
              if (s6 !== peg$FAILED) {
                s7 = peg$parsepropertyAssignment();
                if (s7 !== peg$FAILED) {
                  peg$reportedPos = s3;
                  s4 = peg$c186(s7);
                  s3 = s4;
                } else {
                  peg$currPos = s3;
                  s3 = peg$c0;
                }
              } else {
                peg$currPos = s3;
                s3 = peg$c0;
              }
            } else {
              peg$currPos = s3;
              s3 = peg$c0;
            }
          } else {
            peg$currPos = s3;
            s3 = peg$c0;
          }
        }
        if (s2 !== peg$FAILED) {
          peg$reportedPos = s0;
          s1 = peg$c46(s1, s2);
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsepropertyAssignment() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 95,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$parsePropertyDeclaration();
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        s1 = peg$parsestart();
        if (s1 !== peg$FAILED) {
          s2 = peg$parseIdentifierName();
          if (s2 !== peg$FAILED) {
            s3 = peg$parsestart();
            if (s3 !== peg$FAILED) {
              peg$reportedPos = s0;
              s1 = peg$c192(s1, s2, s3);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseTypedObjectExpression() {
      var s0, s1, s2, s3, s4, s5;

      var key    = peg$currPos * 189 + 96,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        if (input.charCodeAt(peg$currPos) === 40) {
          s3 = peg$c73;
          peg$currPos++;
        } else {
          s3 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c74); }
        }
        peg$silentFails--;
        if (s3 === peg$FAILED) {
          s2 = peg$c16;
        } else {
          peg$currPos = s2;
          s2 = peg$c0;
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$parseMultilineCallExpression();
          if (s3 === peg$FAILED) {
            s3 = peg$parseAssignmentExpression();
          }
          if (s3 !== peg$FAILED) {
            s4 = peg$parseBlockStatement();
            if (s4 !== peg$FAILED) {
              s5 = peg$parsestart();
              if (s5 !== peg$FAILED) {
                peg$reportedPos = s0;
                s1 = peg$c193(s1, s3, s4, s5);
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseImpliedObjectExpression() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 97,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        s2 = peg$parseBlockStatement();
        if (s2 !== peg$FAILED) {
          s3 = peg$parsestart();
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c194(s1, s2, s3);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseGroupExpression() {
      var s0, s1, s2, s3, s4, s5;

      var key    = peg$currPos * 189 + 98,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      peg$silentFails++;
      s0 = peg$currPos;
      if (input.charCodeAt(peg$currPos) === 40) {
        s1 = peg$c73;
        peg$currPos++;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c74); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$parse_();
        if (s2 !== peg$FAILED) {
          s3 = peg$parseAssignmentExpression();
          if (s3 !== peg$FAILED) {
            s4 = peg$parse_();
            if (s4 !== peg$FAILED) {
              if (input.charCodeAt(peg$currPos) === 41) {
                s5 = peg$c75;
                peg$currPos++;
              } else {
                s5 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c76); }
              }
              if (s5 !== peg$FAILED) {
                peg$reportedPos = s0;
                s1 = peg$c196(s3);
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }
      peg$silentFails--;
      if (s0 === peg$FAILED) {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c195); }
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseIdentifier() {
      var s0, s1, s2;

      var key    = peg$currPos * 189 + 99,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$currPos;
      peg$silentFails++;
      s2 = peg$parsereserved();
      peg$silentFails--;
      if (s2 === peg$FAILED) {
        s1 = peg$c16;
      } else {
        peg$currPos = s1;
        s1 = peg$c0;
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$parseIdentifierName();
        if (s2 !== peg$FAILED) {
          peg$reportedPos = s0;
          s1 = peg$c197(s2);
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseIdentifierName() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 100,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        s2 = peg$parseidentifierName();
        if (s2 !== peg$FAILED) {
          s3 = peg$parsestart();
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c198(s1, s2, s3);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseThisExpression() {
      var s0, s1, s2, s3, s4;

      var key    = peg$currPos * 189 + 101,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      peg$silentFails++;
      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        if (input.substr(peg$currPos, 2) === peg$c200) {
          s2 = peg$c200;
          peg$currPos += 2;
        } else {
          s2 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c201); }
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$parseIdentifierName();
          if (s3 !== peg$FAILED) {
            s4 = peg$parsestart();
            if (s4 !== peg$FAILED) {
              peg$reportedPos = s0;
              s1 = peg$c202(s1, s3, s4);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        s1 = peg$parsestart();
        if (s1 !== peg$FAILED) {
          if (input.charCodeAt(peg$currPos) === 64) {
            s2 = peg$c203;
            peg$currPos++;
          } else {
            s2 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c204); }
          }
          if (s2 !== peg$FAILED) {
            s3 = peg$parseIdentifierName();
            if (s3 !== peg$FAILED) {
              s4 = peg$parsestart();
              if (s4 !== peg$FAILED) {
                peg$reportedPos = s0;
                s1 = peg$c205(s1, s3, s4);
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
        if (s0 === peg$FAILED) {
          s0 = peg$currPos;
          s1 = peg$parsestart();
          if (s1 !== peg$FAILED) {
            if (input.substr(peg$currPos, 2) === peg$c200) {
              s2 = peg$c200;
              peg$currPos += 2;
            } else {
              s2 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c201); }
            }
            if (s2 !== peg$FAILED) {
              s3 = peg$parsestart();
              if (s3 !== peg$FAILED) {
                peg$reportedPos = s0;
                s1 = peg$c206(s1, s3);
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
          if (s0 === peg$FAILED) {
            s0 = peg$currPos;
            s1 = peg$parsestart();
            if (s1 !== peg$FAILED) {
              s2 = peg$parsethis();
              if (s2 === peg$FAILED) {
                if (input.charCodeAt(peg$currPos) === 64) {
                  s2 = peg$c203;
                  peg$currPos++;
                } else {
                  s2 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$c204); }
                }
              }
              if (s2 !== peg$FAILED) {
                s3 = peg$parsestart();
                if (s3 !== peg$FAILED) {
                  peg$reportedPos = s0;
                  s1 = peg$c207(s1, s3);
                  s0 = s1;
                } else {
                  peg$currPos = s0;
                  s0 = peg$c0;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          }
        }
      }
      peg$silentFails--;
      if (s0 === peg$FAILED) {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c199); }
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseStringOrNumberLiteral() {
      var s0, s1, s2;

      var key    = peg$currPos * 189 + 102,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$currPos;
      peg$silentFails++;
      s2 = peg$parsesimpleString();
      if (s2 === peg$FAILED) {
        s2 = peg$parsenumber();
      }
      peg$silentFails--;
      if (s2 !== peg$FAILED) {
        peg$currPos = s1;
        s1 = peg$c16;
      } else {
        s1 = peg$c0;
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$parseLiteral();
        if (s2 !== peg$FAILED) {
          peg$reportedPos = s0;
          s1 = peg$c197(s2);
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseLiteral() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 103,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      peg$silentFails++;
      s0 = peg$parseStringTemplate();
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        s1 = peg$parsestart();
        if (s1 !== peg$FAILED) {
          s2 = peg$parsenumber();
          if (s2 === peg$FAILED) {
            s2 = peg$parsesimpleString();
            if (s2 === peg$FAILED) {
              s2 = peg$parseboolean();
              if (s2 === peg$FAILED) {
                s2 = peg$parseregex();
                if (s2 === peg$FAILED) {
                  s2 = peg$parsenull();
                }
              }
            }
          }
          if (s2 !== peg$FAILED) {
            s3 = peg$parsestart();
            if (s3 !== peg$FAILED) {
              peg$reportedPos = s0;
              s1 = peg$c209(s1, s2, s3);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
        if (s0 === peg$FAILED) {
          s0 = peg$currPos;
          s1 = peg$parsestart();
          if (s1 !== peg$FAILED) {
            s2 = peg$parseundefined();
            if (s2 !== peg$FAILED) {
              s3 = peg$parsestart();
              if (s3 !== peg$FAILED) {
                peg$reportedPos = s0;
                s1 = peg$c210(s1, s3);
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        }
      }
      peg$silentFails--;
      if (s0 === peg$FAILED) {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c208); }
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsestart() {
      var s0, s1;

      var key    = peg$currPos * 189 + 104,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      peg$reportedPos = peg$currPos;
      s1 = peg$c159();
      if (s1) {
        s1 = peg$c16;
      } else {
        s1 = peg$c0;
      }
      if (s1 !== peg$FAILED) {
        peg$reportedPos = s0;
        s1 = peg$c211();
      }
      s0 = s1;

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseoffset() {
      var s0, s1;

      var key    = peg$currPos * 189 + 105,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      peg$reportedPos = peg$currPos;
      s1 = peg$c159();
      if (s1) {
        s1 = peg$c16;
      } else {
        s1 = peg$c0;
      }
      if (s1 !== peg$FAILED) {
        peg$reportedPos = s0;
        s1 = peg$c212();
      }
      s0 = s1;

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseboolean() {
      var s0;

      var key    = peg$currPos * 189 + 106,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$parsetrue();
      if (s0 === peg$FAILED) {
        s0 = peg$parsefalse();
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseregex() {
      var s0, s1, s2, s3, s4;

      var key    = peg$currPos * 189 + 107,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.charCodeAt(peg$currPos) === 47) {
        s1 = peg$c143;
        peg$currPos++;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c144); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$parseregexBody();
        if (s2 !== peg$FAILED) {
          if (input.charCodeAt(peg$currPos) === 47) {
            s3 = peg$c143;
            peg$currPos++;
          } else {
            s3 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c144); }
          }
          if (s3 !== peg$FAILED) {
            s4 = peg$parseregexOptions();
            if (s4 !== peg$FAILED) {
              peg$reportedPos = s0;
              s1 = peg$c213(s2, s4);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseregexBody() {
      var s0, s1, s2, s3, s4;

      var key    = peg$currPos * 189 + 108,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = [];
      s2 = peg$currPos;
      if (input.charCodeAt(peg$currPos) === 92) {
        s3 = peg$c214;
        peg$currPos++;
      } else {
        s3 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c215); }
      }
      if (s3 !== peg$FAILED) {
        if (input.length > peg$currPos) {
          s4 = input.charAt(peg$currPos);
          peg$currPos++;
        } else {
          s4 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c183); }
        }
        if (s4 !== peg$FAILED) {
          s3 = [s3, s4];
          s2 = s3;
        } else {
          peg$currPos = s2;
          s2 = peg$c0;
        }
      } else {
        peg$currPos = s2;
        s2 = peg$c0;
      }
      if (s2 === peg$FAILED) {
        if (peg$c216.test(input.charAt(peg$currPos))) {
          s2 = input.charAt(peg$currPos);
          peg$currPos++;
        } else {
          s2 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c217); }
        }
      }
      while (s2 !== peg$FAILED) {
        s1.push(s2);
        s2 = peg$currPos;
        if (input.charCodeAt(peg$currPos) === 92) {
          s3 = peg$c214;
          peg$currPos++;
        } else {
          s3 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c215); }
        }
        if (s3 !== peg$FAILED) {
          if (input.length > peg$currPos) {
            s4 = input.charAt(peg$currPos);
            peg$currPos++;
          } else {
            s4 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c183); }
          }
          if (s4 !== peg$FAILED) {
            s3 = [s3, s4];
            s2 = s3;
          } else {
            peg$currPos = s2;
            s2 = peg$c0;
          }
        } else {
          peg$currPos = s2;
          s2 = peg$c0;
        }
        if (s2 === peg$FAILED) {
          if (peg$c216.test(input.charAt(peg$currPos))) {
            s2 = input.charAt(peg$currPos);
            peg$currPos++;
          } else {
            s2 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c217); }
          }
        }
      }
      if (s1 !== peg$FAILED) {
        s1 = input.substring(s0, peg$currPos);
      }
      s0 = s1;

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseregexOptions() {
      var s0, s1, s2;

      var key    = peg$currPos * 189 + 109,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = [];
      if (peg$c218.test(input.charAt(peg$currPos))) {
        s2 = input.charAt(peg$currPos);
        peg$currPos++;
      } else {
        s2 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c219); }
      }
      while (s2 !== peg$FAILED) {
        s1.push(s2);
        if (peg$c218.test(input.charAt(peg$currPos))) {
          s2 = input.charAt(peg$currPos);
          peg$currPos++;
        } else {
          s2 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c219); }
        }
      }
      if (s1 !== peg$FAILED) {
        s1 = input.substring(s0, peg$currPos);
      }
      s0 = s1;

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsesimpleString() {
      var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10;

      var key    = peg$currPos * 189 + 110,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.charCodeAt(peg$currPos) === 39) {
        s1 = peg$c220;
        peg$currPos++;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c221); }
      }
      if (s1 !== peg$FAILED) {
        s2 = [];
        s3 = peg$currPos;
        if (input.charCodeAt(peg$currPos) === 92) {
          s4 = peg$c214;
          peg$currPos++;
        } else {
          s4 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c215); }
        }
        if (s4 !== peg$FAILED) {
          if (peg$c222.test(input.charAt(peg$currPos))) {
            s5 = input.charAt(peg$currPos);
            peg$currPos++;
          } else {
            s5 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c223); }
          }
          if (s5 === peg$FAILED) {
            s5 = peg$currPos;
            if (input.charCodeAt(peg$currPos) === 117) {
              s6 = peg$c224;
              peg$currPos++;
            } else {
              s6 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c225); }
            }
            if (s6 !== peg$FAILED) {
              s7 = peg$parsehexDigit();
              if (s7 !== peg$FAILED) {
                s8 = peg$parsehexDigit();
                if (s8 !== peg$FAILED) {
                  s9 = peg$parsehexDigit();
                  if (s9 !== peg$FAILED) {
                    s10 = peg$parsehexDigit();
                    if (s10 !== peg$FAILED) {
                      s6 = [s6, s7, s8, s9, s10];
                      s5 = s6;
                    } else {
                      peg$currPos = s5;
                      s5 = peg$c0;
                    }
                  } else {
                    peg$currPos = s5;
                    s5 = peg$c0;
                  }
                } else {
                  peg$currPos = s5;
                  s5 = peg$c0;
                }
              } else {
                peg$currPos = s5;
                s5 = peg$c0;
              }
            } else {
              peg$currPos = s5;
              s5 = peg$c0;
            }
          }
          if (s5 !== peg$FAILED) {
            s4 = [s4, s5];
            s3 = s4;
          } else {
            peg$currPos = s3;
            s3 = peg$c0;
          }
        } else {
          peg$currPos = s3;
          s3 = peg$c0;
        }
        if (s3 === peg$FAILED) {
          if (peg$c226.test(input.charAt(peg$currPos))) {
            s3 = input.charAt(peg$currPos);
            peg$currPos++;
          } else {
            s3 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c227); }
          }
        }
        while (s3 !== peg$FAILED) {
          s2.push(s3);
          s3 = peg$currPos;
          if (input.charCodeAt(peg$currPos) === 92) {
            s4 = peg$c214;
            peg$currPos++;
          } else {
            s4 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c215); }
          }
          if (s4 !== peg$FAILED) {
            if (peg$c222.test(input.charAt(peg$currPos))) {
              s5 = input.charAt(peg$currPos);
              peg$currPos++;
            } else {
              s5 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c223); }
            }
            if (s5 === peg$FAILED) {
              s5 = peg$currPos;
              if (input.charCodeAt(peg$currPos) === 117) {
                s6 = peg$c224;
                peg$currPos++;
              } else {
                s6 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c225); }
              }
              if (s6 !== peg$FAILED) {
                s7 = peg$parsehexDigit();
                if (s7 !== peg$FAILED) {
                  s8 = peg$parsehexDigit();
                  if (s8 !== peg$FAILED) {
                    s9 = peg$parsehexDigit();
                    if (s9 !== peg$FAILED) {
                      s10 = peg$parsehexDigit();
                      if (s10 !== peg$FAILED) {
                        s6 = [s6, s7, s8, s9, s10];
                        s5 = s6;
                      } else {
                        peg$currPos = s5;
                        s5 = peg$c0;
                      }
                    } else {
                      peg$currPos = s5;
                      s5 = peg$c0;
                    }
                  } else {
                    peg$currPos = s5;
                    s5 = peg$c0;
                  }
                } else {
                  peg$currPos = s5;
                  s5 = peg$c0;
                }
              } else {
                peg$currPos = s5;
                s5 = peg$c0;
              }
            }
            if (s5 !== peg$FAILED) {
              s4 = [s4, s5];
              s3 = s4;
            } else {
              peg$currPos = s3;
              s3 = peg$c0;
            }
          } else {
            peg$currPos = s3;
            s3 = peg$c0;
          }
          if (s3 === peg$FAILED) {
            if (peg$c226.test(input.charAt(peg$currPos))) {
              s3 = input.charAt(peg$currPos);
              peg$currPos++;
            } else {
              s3 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c227); }
            }
          }
        }
        if (s2 !== peg$FAILED) {
          if (input.charCodeAt(peg$currPos) === 39) {
            s3 = peg$c220;
            peg$currPos++;
          } else {
            s3 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c221); }
          }
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c228(s2);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        if (input.charCodeAt(peg$currPos) === 34) {
          s1 = peg$c229;
          peg$currPos++;
        } else {
          s1 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c230); }
        }
        if (s1 !== peg$FAILED) {
          s2 = [];
          s3 = peg$currPos;
          if (input.charCodeAt(peg$currPos) === 92) {
            s4 = peg$c214;
            peg$currPos++;
          } else {
            s4 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c215); }
          }
          if (s4 !== peg$FAILED) {
            if (peg$c231.test(input.charAt(peg$currPos))) {
              s5 = input.charAt(peg$currPos);
              peg$currPos++;
            } else {
              s5 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c232); }
            }
            if (s5 === peg$FAILED) {
              s5 = peg$currPos;
              if (input.charCodeAt(peg$currPos) === 117) {
                s6 = peg$c224;
                peg$currPos++;
              } else {
                s6 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c225); }
              }
              if (s6 !== peg$FAILED) {
                s7 = peg$parsehexDigit();
                if (s7 !== peg$FAILED) {
                  s8 = peg$parsehexDigit();
                  if (s8 !== peg$FAILED) {
                    s9 = peg$parsehexDigit();
                    if (s9 !== peg$FAILED) {
                      s10 = peg$parsehexDigit();
                      if (s10 !== peg$FAILED) {
                        s6 = [s6, s7, s8, s9, s10];
                        s5 = s6;
                      } else {
                        peg$currPos = s5;
                        s5 = peg$c0;
                      }
                    } else {
                      peg$currPos = s5;
                      s5 = peg$c0;
                    }
                  } else {
                    peg$currPos = s5;
                    s5 = peg$c0;
                  }
                } else {
                  peg$currPos = s5;
                  s5 = peg$c0;
                }
              } else {
                peg$currPos = s5;
                s5 = peg$c0;
              }
            }
            if (s5 !== peg$FAILED) {
              s4 = [s4, s5];
              s3 = s4;
            } else {
              peg$currPos = s3;
              s3 = peg$c0;
            }
          } else {
            peg$currPos = s3;
            s3 = peg$c0;
          }
          if (s3 === peg$FAILED) {
            if (peg$c233.test(input.charAt(peg$currPos))) {
              s3 = input.charAt(peg$currPos);
              peg$currPos++;
            } else {
              s3 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c234); }
            }
          }
          while (s3 !== peg$FAILED) {
            s2.push(s3);
            s3 = peg$currPos;
            if (input.charCodeAt(peg$currPos) === 92) {
              s4 = peg$c214;
              peg$currPos++;
            } else {
              s4 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c215); }
            }
            if (s4 !== peg$FAILED) {
              if (peg$c231.test(input.charAt(peg$currPos))) {
                s5 = input.charAt(peg$currPos);
                peg$currPos++;
              } else {
                s5 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c232); }
              }
              if (s5 === peg$FAILED) {
                s5 = peg$currPos;
                if (input.charCodeAt(peg$currPos) === 117) {
                  s6 = peg$c224;
                  peg$currPos++;
                } else {
                  s6 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$c225); }
                }
                if (s6 !== peg$FAILED) {
                  s7 = peg$parsehexDigit();
                  if (s7 !== peg$FAILED) {
                    s8 = peg$parsehexDigit();
                    if (s8 !== peg$FAILED) {
                      s9 = peg$parsehexDigit();
                      if (s9 !== peg$FAILED) {
                        s10 = peg$parsehexDigit();
                        if (s10 !== peg$FAILED) {
                          s6 = [s6, s7, s8, s9, s10];
                          s5 = s6;
                        } else {
                          peg$currPos = s5;
                          s5 = peg$c0;
                        }
                      } else {
                        peg$currPos = s5;
                        s5 = peg$c0;
                      }
                    } else {
                      peg$currPos = s5;
                      s5 = peg$c0;
                    }
                  } else {
                    peg$currPos = s5;
                    s5 = peg$c0;
                  }
                } else {
                  peg$currPos = s5;
                  s5 = peg$c0;
                }
              }
              if (s5 !== peg$FAILED) {
                s4 = [s4, s5];
                s3 = s4;
              } else {
                peg$currPos = s3;
                s3 = peg$c0;
              }
            } else {
              peg$currPos = s3;
              s3 = peg$c0;
            }
            if (s3 === peg$FAILED) {
              if (peg$c233.test(input.charAt(peg$currPos))) {
                s3 = input.charAt(peg$currPos);
                peg$currPos++;
              } else {
                s3 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c234); }
              }
            }
          }
          if (s2 !== peg$FAILED) {
            if (input.charCodeAt(peg$currPos) === 34) {
              s3 = peg$c229;
              peg$currPos++;
            } else {
              s3 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c230); }
            }
            if (s3 !== peg$FAILED) {
              peg$reportedPos = s0;
              s1 = peg$c235(s2);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseMultilineStringTemplate() {
      var s0, s1, s2, s3, s4, s5;

      var key    = peg$currPos * 189 + 111,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        if (input.substr(peg$currPos, 2) === peg$c236) {
          s2 = peg$c236;
          peg$currPos += 2;
        } else {
          s2 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c237); }
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$parseeol();
          if (s3 !== peg$FAILED) {
            s4 = peg$parsemultilineStringTemplateContent();
            if (s4 !== peg$FAILED) {
              s5 = peg$parsestart();
              if (s5 !== peg$FAILED) {
                peg$reportedPos = s0;
                s1 = peg$c238(s1, s4, s5);
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsemultilineStringTemplateContent() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 112,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parseindent();
      if (s1 !== peg$FAILED) {
        s2 = [];
        s3 = peg$parsemultilineStringTemplateLine();
        if (s3 === peg$FAILED) {
          s3 = peg$parsemultilineStringTemplateContent();
        }
        while (s3 !== peg$FAILED) {
          s2.push(s3);
          s3 = peg$parsemultilineStringTemplateLine();
          if (s3 === peg$FAILED) {
            s3 = peg$parsemultilineStringTemplateContent();
          }
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$parseoutdent();
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c239(s2);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsemultilineStringTemplateLine() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 113,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$currPos;
      peg$silentFails++;
      s2 = peg$parseindent();
      peg$silentFails--;
      if (s2 === peg$FAILED) {
        s1 = peg$c16;
      } else {
        peg$currPos = s1;
        s1 = peg$c0;
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        s3 = peg$parseoutdent();
        peg$silentFails--;
        if (s3 === peg$FAILED) {
          s2 = peg$c16;
        } else {
          peg$currPos = s2;
          s2 = peg$c0;
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$parsestringInterpolation();
          if (s3 === peg$FAILED) {
            s3 = peg$parsemultilineStringTemplatePart();
          }
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c7(s3);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsemultilineStringTemplatePart() {
      var s0, s1, s2, s3, s4, s5, s6;

      var key    = peg$currPos * 189 + 114,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parseeol_nocomments();
      if (s1 === peg$FAILED) {
        s1 = peg$c4;
      }
      if (s1 !== peg$FAILED) {
        s2 = [];
        s3 = peg$currPos;
        s4 = peg$currPos;
        peg$silentFails++;
        if (input.substr(peg$currPos, 2) === peg$c240) {
          s5 = peg$c240;
          peg$currPos += 2;
        } else {
          s5 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c241); }
        }
        peg$silentFails--;
        if (s5 === peg$FAILED) {
          s4 = peg$c16;
        } else {
          peg$currPos = s4;
          s4 = peg$c0;
        }
        if (s4 !== peg$FAILED) {
          s5 = peg$currPos;
          peg$silentFails++;
          s6 = peg$parseeol_nocomments();
          peg$silentFails--;
          if (s6 === peg$FAILED) {
            s5 = peg$c16;
          } else {
            peg$currPos = s5;
            s5 = peg$c0;
          }
          if (s5 !== peg$FAILED) {
            if (input.length > peg$currPos) {
              s6 = input.charAt(peg$currPos);
              peg$currPos++;
            } else {
              s6 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c183); }
            }
            if (s6 !== peg$FAILED) {
              s4 = [s4, s5, s6];
              s3 = s4;
            } else {
              peg$currPos = s3;
              s3 = peg$c0;
            }
          } else {
            peg$currPos = s3;
            s3 = peg$c0;
          }
        } else {
          peg$currPos = s3;
          s3 = peg$c0;
        }
        if (s3 !== peg$FAILED) {
          while (s3 !== peg$FAILED) {
            s2.push(s3);
            s3 = peg$currPos;
            s4 = peg$currPos;
            peg$silentFails++;
            if (input.substr(peg$currPos, 2) === peg$c240) {
              s5 = peg$c240;
              peg$currPos += 2;
            } else {
              s5 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c241); }
            }
            peg$silentFails--;
            if (s5 === peg$FAILED) {
              s4 = peg$c16;
            } else {
              peg$currPos = s4;
              s4 = peg$c0;
            }
            if (s4 !== peg$FAILED) {
              s5 = peg$currPos;
              peg$silentFails++;
              s6 = peg$parseeol_nocomments();
              peg$silentFails--;
              if (s6 === peg$FAILED) {
                s5 = peg$c16;
              } else {
                peg$currPos = s5;
                s5 = peg$c0;
              }
              if (s5 !== peg$FAILED) {
                if (input.length > peg$currPos) {
                  s6 = input.charAt(peg$currPos);
                  peg$currPos++;
                } else {
                  s6 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$c183); }
                }
                if (s6 !== peg$FAILED) {
                  s4 = [s4, s5, s6];
                  s3 = s4;
                } else {
                  peg$currPos = s3;
                  s3 = peg$c0;
                }
              } else {
                peg$currPos = s3;
                s3 = peg$c0;
              }
            } else {
              peg$currPos = s3;
              s3 = peg$c0;
            }
          }
        } else {
          s2 = peg$c0;
        }
        if (s2 !== peg$FAILED) {
          peg$reportedPos = s0;
          s1 = peg$c242();
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseMultilineStringLiteral() {
      var s0, s1, s2, s3, s4, s5;

      var key    = peg$currPos * 189 + 115,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parsestart();
      if (s1 !== peg$FAILED) {
        if (input.substr(peg$currPos, 2) === peg$c243) {
          s2 = peg$c243;
          peg$currPos += 2;
        } else {
          s2 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c244); }
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$parseeol_nocomments();
          if (s3 !== peg$FAILED) {
            s4 = peg$parsemultilineStringLiteralContent();
            if (s4 !== peg$FAILED) {
              s5 = peg$parsestart();
              if (s5 !== peg$FAILED) {
                peg$reportedPos = s0;
                s1 = peg$c238(s1, s4, s5);
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsemultilineStringLiteralContent() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 116,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parseindent();
      if (s1 !== peg$FAILED) {
        s2 = [];
        s3 = peg$parsemultilineStringLiteralLine();
        if (s3 === peg$FAILED) {
          s3 = peg$parsemultilineStringLiteralContent();
        }
        while (s3 !== peg$FAILED) {
          s2.push(s3);
          s3 = peg$parsemultilineStringLiteralLine();
          if (s3 === peg$FAILED) {
            s3 = peg$parsemultilineStringLiteralContent();
          }
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$parseoutdent();
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c239(s2);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsemultilineStringLiteralLine() {
      var s0, s1, s2, s3, s4, s5, s6, s7;

      var key    = peg$currPos * 189 + 117,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$currPos;
      peg$silentFails++;
      s2 = peg$parseindent();
      peg$silentFails--;
      if (s2 === peg$FAILED) {
        s1 = peg$c16;
      } else {
        peg$currPos = s1;
        s1 = peg$c0;
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        s3 = peg$parseoutdent();
        peg$silentFails--;
        if (s3 === peg$FAILED) {
          s2 = peg$c16;
        } else {
          peg$currPos = s2;
          s2 = peg$c0;
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$parseeol_nocomments();
          if (s3 === peg$FAILED) {
            s3 = peg$c4;
          }
          if (s3 !== peg$FAILED) {
            s4 = [];
            s5 = peg$currPos;
            s6 = peg$currPos;
            peg$silentFails++;
            s7 = peg$parseeol_nocomments();
            peg$silentFails--;
            if (s7 === peg$FAILED) {
              s6 = peg$c16;
            } else {
              peg$currPos = s6;
              s6 = peg$c0;
            }
            if (s6 !== peg$FAILED) {
              if (input.length > peg$currPos) {
                s7 = input.charAt(peg$currPos);
                peg$currPos++;
              } else {
                s7 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c183); }
              }
              if (s7 !== peg$FAILED) {
                s6 = [s6, s7];
                s5 = s6;
              } else {
                peg$currPos = s5;
                s5 = peg$c0;
              }
            } else {
              peg$currPos = s5;
              s5 = peg$c0;
            }
            if (s5 !== peg$FAILED) {
              while (s5 !== peg$FAILED) {
                s4.push(s5);
                s5 = peg$currPos;
                s6 = peg$currPos;
                peg$silentFails++;
                s7 = peg$parseeol_nocomments();
                peg$silentFails--;
                if (s7 === peg$FAILED) {
                  s6 = peg$c16;
                } else {
                  peg$currPos = s6;
                  s6 = peg$c0;
                }
                if (s6 !== peg$FAILED) {
                  if (input.length > peg$currPos) {
                    s7 = input.charAt(peg$currPos);
                    peg$currPos++;
                  } else {
                    s7 = peg$FAILED;
                    if (peg$silentFails === 0) { peg$fail(peg$c183); }
                  }
                  if (s7 !== peg$FAILED) {
                    s6 = [s6, s7];
                    s5 = s6;
                  } else {
                    peg$currPos = s5;
                    s5 = peg$c0;
                  }
                } else {
                  peg$currPos = s5;
                  s5 = peg$c0;
                }
              }
            } else {
              s4 = peg$c0;
            }
            if (s4 !== peg$FAILED) {
              peg$reportedPos = s0;
              s1 = peg$c242();
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsestringInterpolation() {
      var s0, s1, s2, s3, s4, s5;

      var key    = peg$currPos * 189 + 118,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 2) === peg$c240) {
        s1 = peg$c240;
        peg$currPos += 2;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c241); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$parse_();
        if (s2 !== peg$FAILED) {
          s3 = peg$parseAssignmentExpression();
          if (s3 !== peg$FAILED) {
            s4 = peg$parse_();
            if (s4 !== peg$FAILED) {
              if (input.substr(peg$currPos, 2) === peg$c245) {
                s5 = peg$c245;
                peg$currPos += 2;
              } else {
                s5 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c246); }
              }
              if (s5 !== peg$FAILED) {
                peg$reportedPos = s0;
                s1 = peg$c196(s3);
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseStringTemplate() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 119,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.charCodeAt(peg$currPos) === 34) {
        s1 = peg$c229;
        peg$currPos++;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c230); }
      }
      if (s1 !== peg$FAILED) {
        s2 = [];
        s3 = peg$parsestringTemplateChars();
        if (s3 === peg$FAILED) {
          s3 = peg$parsestringInterpolation();
        }
        while (s3 !== peg$FAILED) {
          s2.push(s3);
          s3 = peg$parsestringTemplateChars();
          if (s3 === peg$FAILED) {
            s3 = peg$parsestringInterpolation();
          }
        }
        if (s2 !== peg$FAILED) {
          if (input.charCodeAt(peg$currPos) === 34) {
            s3 = peg$c229;
            peg$currPos++;
          } else {
            s3 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c230); }
          }
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c247(s2);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsestringTemplateChars() {
      var s0, s1, s2;

      var key    = peg$currPos * 189 + 120,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = [];
      s2 = peg$parsestringTemplateChar();
      if (s2 !== peg$FAILED) {
        while (s2 !== peg$FAILED) {
          s1.push(s2);
          s2 = peg$parsestringTemplateChar();
        }
      } else {
        s1 = peg$c0;
      }
      if (s1 !== peg$FAILED) {
        peg$reportedPos = s0;
        s1 = peg$c248();
      }
      s0 = s1;

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsestringTemplateChar() {
      var s0, s1, s2, s3, s4, s5;

      var key    = peg$currPos * 189 + 121,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.charCodeAt(peg$currPos) === 92) {
        s1 = peg$c214;
        peg$currPos++;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c215); }
      }
      if (s1 !== peg$FAILED) {
        if (peg$c231.test(input.charAt(peg$currPos))) {
          s2 = input.charAt(peg$currPos);
          peg$currPos++;
        } else {
          s2 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c232); }
        }
        if (s2 !== peg$FAILED) {
          s1 = [s1, s2];
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        if (input.charCodeAt(peg$currPos) === 117) {
          s1 = peg$c224;
          peg$currPos++;
        } else {
          s1 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c225); }
        }
        if (s1 !== peg$FAILED) {
          s2 = peg$parsehexDigit();
          if (s2 !== peg$FAILED) {
            s3 = peg$parsehexDigit();
            if (s3 !== peg$FAILED) {
              s4 = peg$parsehexDigit();
              if (s4 !== peg$FAILED) {
                s5 = peg$parsehexDigit();
                if (s5 !== peg$FAILED) {
                  s1 = [s1, s2, s3, s4, s5];
                  s0 = s1;
                } else {
                  peg$currPos = s0;
                  s0 = peg$c0;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      }
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        s1 = peg$currPos;
        peg$silentFails++;
        if (input.substr(peg$currPos, 2) === peg$c240) {
          s2 = peg$c240;
          peg$currPos += 2;
        } else {
          s2 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c241); }
        }
        peg$silentFails--;
        if (s2 === peg$FAILED) {
          s1 = peg$c16;
        } else {
          peg$currPos = s1;
          s1 = peg$c0;
        }
        if (s1 !== peg$FAILED) {
          if (peg$c233.test(input.charAt(peg$currPos))) {
            s2 = input.charAt(peg$currPos);
            peg$currPos++;
          } else {
            s2 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c234); }
          }
          if (s2 !== peg$FAILED) {
            s1 = [s1, s2];
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsenumber() {
      var s0;

      var key    = peg$currPos * 189 + 122,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$parsedecimal();
      if (s0 === peg$FAILED) {
        s0 = peg$parsehexInteger();
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsedecimal() {
      var s0, s1, s2, s3, s4, s5, s6, s7;

      var key    = peg$currPos * 189 + 123,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (peg$c249.test(input.charAt(peg$currPos))) {
        s1 = input.charAt(peg$currPos);
        peg$currPos++;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c250); }
      }
      if (s1 === peg$FAILED) {
        s1 = peg$c4;
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        s3 = peg$parsedecimalInteger();
        if (s3 !== peg$FAILED) {
          s4 = peg$currPos;
          if (input.charCodeAt(peg$currPos) === 46) {
            s5 = peg$c44;
            peg$currPos++;
          } else {
            s5 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c45); }
          }
          if (s5 !== peg$FAILED) {
            s6 = [];
            s7 = peg$parsedecimalDigit();
            if (s7 !== peg$FAILED) {
              while (s7 !== peg$FAILED) {
                s6.push(s7);
                s7 = peg$parsedecimalDigit();
              }
            } else {
              s6 = peg$c0;
            }
            if (s6 !== peg$FAILED) {
              s5 = [s5, s6];
              s4 = s5;
            } else {
              peg$currPos = s4;
              s4 = peg$c0;
            }
          } else {
            peg$currPos = s4;
            s4 = peg$c0;
          }
          if (s4 === peg$FAILED) {
            s4 = peg$c4;
          }
          if (s4 !== peg$FAILED) {
            s3 = [s3, s4];
            s2 = s3;
          } else {
            peg$currPos = s2;
            s2 = peg$c0;
          }
        } else {
          peg$currPos = s2;
          s2 = peg$c0;
        }
        if (s2 === peg$FAILED) {
          s2 = peg$currPos;
          if (input.charCodeAt(peg$currPos) === 46) {
            s3 = peg$c44;
            peg$currPos++;
          } else {
            s3 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c45); }
          }
          if (s3 !== peg$FAILED) {
            s4 = [];
            s5 = peg$parsedecimalDigit();
            if (s5 !== peg$FAILED) {
              while (s5 !== peg$FAILED) {
                s4.push(s5);
                s5 = peg$parsedecimalDigit();
              }
            } else {
              s4 = peg$c0;
            }
            if (s4 !== peg$FAILED) {
              s3 = [s3, s4];
              s2 = s3;
            } else {
              peg$currPos = s2;
              s2 = peg$c0;
            }
          } else {
            peg$currPos = s2;
            s2 = peg$c0;
          }
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$currPos;
          if (peg$c251.test(input.charAt(peg$currPos))) {
            s4 = input.charAt(peg$currPos);
            peg$currPos++;
          } else {
            s4 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c252); }
          }
          if (s4 !== peg$FAILED) {
            if (peg$c249.test(input.charAt(peg$currPos))) {
              s5 = input.charAt(peg$currPos);
              peg$currPos++;
            } else {
              s5 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c250); }
            }
            if (s5 === peg$FAILED) {
              s5 = peg$c4;
            }
            if (s5 !== peg$FAILED) {
              s6 = [];
              s7 = peg$parsedecimalDigit();
              if (s7 !== peg$FAILED) {
                while (s7 !== peg$FAILED) {
                  s6.push(s7);
                  s7 = peg$parsedecimalDigit();
                }
              } else {
                s6 = peg$c0;
              }
              if (s6 !== peg$FAILED) {
                s4 = [s4, s5, s6];
                s3 = s4;
              } else {
                peg$currPos = s3;
                s3 = peg$c0;
              }
            } else {
              peg$currPos = s3;
              s3 = peg$c0;
            }
          } else {
            peg$currPos = s3;
            s3 = peg$c0;
          }
          if (s3 === peg$FAILED) {
            s3 = peg$c4;
          }
          if (s3 !== peg$FAILED) {
            s4 = peg$currPos;
            peg$silentFails++;
            s5 = peg$parseidentifierPart();
            peg$silentFails--;
            if (s5 === peg$FAILED) {
              s4 = peg$c16;
            } else {
              peg$currPos = s4;
              s4 = peg$c0;
            }
            if (s4 !== peg$FAILED) {
              peg$reportedPos = s0;
              s1 = peg$c253();
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseinteger() {
      var s0, s1, s2, s3, s4;

      var key    = peg$currPos * 189 + 124,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (peg$c249.test(input.charAt(peg$currPos))) {
        s1 = input.charAt(peg$currPos);
        peg$currPos++;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c250); }
      }
      if (s1 === peg$FAILED) {
        s1 = peg$c4;
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$parsedecimalInteger();
        if (s2 !== peg$FAILED) {
          s3 = peg$currPos;
          peg$silentFails++;
          s4 = peg$parseidentifierPart();
          peg$silentFails--;
          if (s4 === peg$FAILED) {
            s3 = peg$c16;
          } else {
            peg$currPos = s3;
            s3 = peg$c0;
          }
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c254();
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsedecimalDigit() {
      var s0;

      var key    = peg$currPos * 189 + 125,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      if (peg$c255.test(input.charAt(peg$currPos))) {
        s0 = input.charAt(peg$currPos);
        peg$currPos++;
      } else {
        s0 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c256); }
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsenonzeroDigit() {
      var s0, s1, s2;

      var key    = peg$currPos * 189 + 126,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$currPos;
      peg$silentFails++;
      if (input.charCodeAt(peg$currPos) === 48) {
        s2 = peg$c257;
        peg$currPos++;
      } else {
        s2 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c258); }
      }
      peg$silentFails--;
      if (s2 === peg$FAILED) {
        s1 = peg$c16;
      } else {
        peg$currPos = s1;
        s1 = peg$c0;
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$parsedecimalDigit();
        if (s2 !== peg$FAILED) {
          s1 = [s1, s2];
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsedecimalInteger() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 127,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      if (input.charCodeAt(peg$currPos) === 48) {
        s0 = peg$c257;
        peg$currPos++;
      } else {
        s0 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c258); }
      }
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        s1 = peg$parsenonzeroDigit();
        if (s1 !== peg$FAILED) {
          s2 = [];
          s3 = peg$parsedecimalDigit();
          while (s3 !== peg$FAILED) {
            s2.push(s3);
            s3 = peg$parsedecimalDigit();
          }
          if (s2 !== peg$FAILED) {
            s1 = [s1, s2];
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsehexInteger() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 128,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 2) === peg$c259) {
        s1 = peg$c259;
        peg$currPos += 2;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c260); }
      }
      if (s1 !== peg$FAILED) {
        s2 = [];
        s3 = peg$parsehexDigit();
        if (s3 !== peg$FAILED) {
          while (s3 !== peg$FAILED) {
            s2.push(s3);
            s3 = peg$parsehexDigit();
          }
        } else {
          s2 = peg$c0;
        }
        if (s2 !== peg$FAILED) {
          peg$reportedPos = s0;
          s1 = peg$c261();
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsehexDigit() {
      var s0;

      var key    = peg$currPos * 189 + 129,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      if (peg$c262.test(input.charAt(peg$currPos))) {
        s0 = input.charAt(peg$currPos);
        peg$currPos++;
      } else {
        s0 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c263); }
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseidentifier() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 130,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      peg$silentFails++;
      s0 = peg$currPos;
      s1 = peg$currPos;
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parsereserved();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = peg$c16;
      } else {
        peg$currPos = s2;
        s2 = peg$c0;
      }
      if (s2 !== peg$FAILED) {
        s3 = peg$parseidentifierName();
        if (s3 !== peg$FAILED) {
          s2 = [s2, s3];
          s1 = s2;
        } else {
          peg$currPos = s1;
          s1 = peg$c0;
        }
      } else {
        peg$currPos = s1;
        s1 = peg$c0;
      }
      if (s1 !== peg$FAILED) {
        s1 = input.substring(s0, peg$currPos);
      }
      s0 = s1;
      peg$silentFails--;
      if (s0 === peg$FAILED) {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c264); }
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseidentifierName() {
      var s0, s1, s2, s3, s4;

      var key    = peg$currPos * 189 + 131,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      peg$silentFails++;
      s0 = peg$currPos;
      s1 = peg$currPos;
      s2 = peg$parseidentifierStart();
      if (s2 !== peg$FAILED) {
        s3 = [];
        s4 = peg$parseidentifierPart();
        while (s4 !== peg$FAILED) {
          s3.push(s4);
          s4 = peg$parseidentifierPart();
        }
        if (s3 !== peg$FAILED) {
          s2 = [s2, s3];
          s1 = s2;
        } else {
          peg$currPos = s1;
          s1 = peg$c0;
        }
      } else {
        peg$currPos = s1;
        s1 = peg$c0;
      }
      if (s1 !== peg$FAILED) {
        s1 = input.substring(s0, peg$currPos);
      }
      s0 = s1;
      peg$silentFails--;
      if (s0 === peg$FAILED) {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c265); }
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseidentifierStart() {
      var s0;

      var key    = peg$currPos * 189 + 132,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$parseunicodeLetter();
      if (s0 === peg$FAILED) {
        if (peg$c266.test(input.charAt(peg$currPos))) {
          s0 = input.charAt(peg$currPos);
          peg$currPos++;
        } else {
          s0 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c267); }
        }
        if (s0 === peg$FAILED) {
          s0 = peg$parseunicodeEscapeSequence();
        }
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseidentifierPart() {
      var s0;

      var key    = peg$currPos * 189 + 133,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$parseidentifierStart();
      if (s0 === peg$FAILED) {
        s0 = peg$parseunicodeCombiningMark();
        if (s0 === peg$FAILED) {
          s0 = peg$parseunicodeDigit();
          if (s0 === peg$FAILED) {
            s0 = peg$parseunicodeConnectorPunctuation();
            if (s0 === peg$FAILED) {
              s0 = peg$parsezwnj();
              if (s0 === peg$FAILED) {
                s0 = peg$parsezwj();
              }
            }
          }
        }
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseunicodeEscapeSequence() {
      var s0, s1, s2, s3, s4, s5;

      var key    = peg$currPos * 189 + 134,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 2) === peg$c268) {
        s1 = peg$c268;
        peg$currPos += 2;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c269); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$parsehexDigit();
        if (s2 !== peg$FAILED) {
          s3 = peg$parsehexDigit();
          if (s3 !== peg$FAILED) {
            s4 = peg$parsehexDigit();
            if (s4 !== peg$FAILED) {
              s5 = peg$parsehexDigit();
              if (s5 !== peg$FAILED) {
                peg$reportedPos = s0;
                s1 = peg$c270(s2, s3, s4, s5);
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseunicodeLetter() {
      var s0, s1, s2;

      var key    = peg$currPos * 189 + 135,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      if (peg$c271.test(input.charAt(peg$currPos))) {
        s0 = input.charAt(peg$currPos);
        peg$currPos++;
      } else {
        s0 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c272); }
      }
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        if (input.charCodeAt(peg$currPos) === 55340) {
          s1 = peg$c273;
          peg$currPos++;
        } else {
          s1 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c274); }
        }
        if (s1 !== peg$FAILED) {
          if (peg$c275.test(input.charAt(peg$currPos))) {
            s2 = input.charAt(peg$currPos);
            peg$currPos++;
          } else {
            s2 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c276); }
          }
          if (s2 !== peg$FAILED) {
            s1 = [s1, s2];
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
        if (s0 === peg$FAILED) {
          s0 = peg$currPos;
          if (input.charCodeAt(peg$currPos) === 55304) {
            s1 = peg$c277;
            peg$currPos++;
          } else {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c278); }
          }
          if (s1 !== peg$FAILED) {
            if (peg$c279.test(input.charAt(peg$currPos))) {
              s2 = input.charAt(peg$currPos);
              peg$currPos++;
            } else {
              s2 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c280); }
            }
            if (s2 !== peg$FAILED) {
              s1 = [s1, s2];
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
          if (s0 === peg$FAILED) {
            s0 = peg$currPos;
            if (input.charCodeAt(peg$currPos) === 55401) {
              s1 = peg$c281;
              peg$currPos++;
            } else {
              s1 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c282); }
            }
            if (s1 !== peg$FAILED) {
              if (peg$c283.test(input.charAt(peg$currPos))) {
                s2 = input.charAt(peg$currPos);
                peg$currPos++;
              } else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c284); }
              }
              if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
            if (s0 === peg$FAILED) {
              s0 = peg$currPos;
              if (input.charCodeAt(peg$currPos) === 55305) {
                s1 = peg$c285;
                peg$currPos++;
              } else {
                s1 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c286); }
              }
              if (s1 !== peg$FAILED) {
                if (peg$c287.test(input.charAt(peg$currPos))) {
                  s2 = input.charAt(peg$currPos);
                  peg$currPos++;
                } else {
                  s2 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$c288); }
                }
                if (s2 !== peg$FAILED) {
                  s1 = [s1, s2];
                  s0 = s1;
                } else {
                  peg$currPos = s0;
                  s0 = peg$c0;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
              if (s0 === peg$FAILED) {
                s0 = peg$currPos;
                if (input.charCodeAt(peg$currPos) === 55349) {
                  s1 = peg$c289;
                  peg$currPos++;
                } else {
                  s1 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$c290); }
                }
                if (s1 !== peg$FAILED) {
                  if (peg$c291.test(input.charAt(peg$currPos))) {
                    s2 = input.charAt(peg$currPos);
                    peg$currPos++;
                  } else {
                    s2 = peg$FAILED;
                    if (peg$silentFails === 0) { peg$fail(peg$c292); }
                  }
                  if (s2 !== peg$FAILED) {
                    s1 = [s1, s2];
                    s0 = s1;
                  } else {
                    peg$currPos = s0;
                    s0 = peg$c0;
                  }
                } else {
                  peg$currPos = s0;
                  s0 = peg$c0;
                }
                if (s0 === peg$FAILED) {
                  s0 = peg$currPos;
                  if (input.charCodeAt(peg$currPos) === 55300) {
                    s1 = peg$c293;
                    peg$currPos++;
                  } else {
                    s1 = peg$FAILED;
                    if (peg$silentFails === 0) { peg$fail(peg$c294); }
                  }
                  if (s1 !== peg$FAILED) {
                    if (peg$c295.test(input.charAt(peg$currPos))) {
                      s2 = input.charAt(peg$currPos);
                      peg$currPos++;
                    } else {
                      s2 = peg$FAILED;
                      if (peg$silentFails === 0) { peg$fail(peg$c296); }
                    }
                    if (s2 !== peg$FAILED) {
                      s1 = [s1, s2];
                      s0 = s1;
                    } else {
                      peg$currPos = s0;
                      s0 = peg$c0;
                    }
                  } else {
                    peg$currPos = s0;
                    s0 = peg$c0;
                  }
                  if (s0 === peg$FAILED) {
                    s0 = peg$currPos;
                    if (input.charCodeAt(peg$currPos) === 55296) {
                      s1 = peg$c297;
                      peg$currPos++;
                    } else {
                      s1 = peg$FAILED;
                      if (peg$silentFails === 0) { peg$fail(peg$c298); }
                    }
                    if (s1 !== peg$FAILED) {
                      if (peg$c299.test(input.charAt(peg$currPos))) {
                        s2 = input.charAt(peg$currPos);
                        peg$currPos++;
                      } else {
                        s2 = peg$FAILED;
                        if (peg$silentFails === 0) { peg$fail(peg$c300); }
                      }
                      if (s2 !== peg$FAILED) {
                        s1 = [s1, s2];
                        s0 = s1;
                      } else {
                        peg$currPos = s0;
                        s0 = peg$c0;
                      }
                    } else {
                      peg$currPos = s0;
                      s0 = peg$c0;
                    }
                    if (s0 === peg$FAILED) {
                      s0 = peg$currPos;
                      if (input.charCodeAt(peg$currPos) === 55308) {
                        s1 = peg$c301;
                        peg$currPos++;
                      } else {
                        s1 = peg$FAILED;
                        if (peg$silentFails === 0) { peg$fail(peg$c302); }
                      }
                      if (s1 !== peg$FAILED) {
                        if (peg$c303.test(input.charAt(peg$currPos))) {
                          s2 = input.charAt(peg$currPos);
                          peg$currPos++;
                        } else {
                          s2 = peg$FAILED;
                          if (peg$silentFails === 0) { peg$fail(peg$c304); }
                        }
                        if (s2 !== peg$FAILED) {
                          s1 = [s1, s2];
                          s0 = s1;
                        } else {
                          peg$currPos = s0;
                          s0 = peg$c0;
                        }
                      } else {
                        peg$currPos = s0;
                        s0 = peg$c0;
                      }
                      if (s0 === peg$FAILED) {
                        s0 = peg$currPos;
                        if (input.charCodeAt(peg$currPos) === 55297) {
                          s1 = peg$c305;
                          peg$currPos++;
                        } else {
                          s1 = peg$FAILED;
                          if (peg$silentFails === 0) { peg$fail(peg$c306); }
                        }
                        if (s1 !== peg$FAILED) {
                          if (peg$c307.test(input.charAt(peg$currPos))) {
                            s2 = input.charAt(peg$currPos);
                            peg$currPos++;
                          } else {
                            s2 = peg$FAILED;
                            if (peg$silentFails === 0) { peg$fail(peg$c308); }
                          }
                          if (s2 !== peg$FAILED) {
                            s1 = [s1, s2];
                            s0 = s1;
                          } else {
                            peg$currPos = s0;
                            s0 = peg$c0;
                          }
                        } else {
                          peg$currPos = s0;
                          s0 = peg$c0;
                        }
                        if (s0 === peg$FAILED) {
                          s0 = peg$currPos;
                          if (input.charCodeAt(peg$currPos) === 55406) {
                            s1 = peg$c309;
                            peg$currPos++;
                          } else {
                            s1 = peg$FAILED;
                            if (peg$silentFails === 0) { peg$fail(peg$c310); }
                          }
                          if (s1 !== peg$FAILED) {
                            if (peg$c311.test(input.charAt(peg$currPos))) {
                              s2 = input.charAt(peg$currPos);
                              peg$currPos++;
                            } else {
                              s2 = peg$FAILED;
                              if (peg$silentFails === 0) { peg$fail(peg$c312); }
                            }
                            if (s2 !== peg$FAILED) {
                              s1 = [s1, s2];
                              s0 = s1;
                            } else {
                              peg$currPos = s0;
                              s0 = peg$c0;
                            }
                          } else {
                            peg$currPos = s0;
                            s0 = peg$c0;
                          }
                          if (s0 === peg$FAILED) {
                            s0 = peg$currPos;
                            if (input.charCodeAt(peg$currPos) === 55299) {
                              s1 = peg$c313;
                              peg$currPos++;
                            } else {
                              s1 = peg$FAILED;
                              if (peg$silentFails === 0) { peg$fail(peg$c314); }
                            }
                            if (s1 !== peg$FAILED) {
                              if (peg$c315.test(input.charAt(peg$currPos))) {
                                s2 = input.charAt(peg$currPos);
                                peg$currPos++;
                              } else {
                                s2 = peg$FAILED;
                                if (peg$silentFails === 0) { peg$fail(peg$c316); }
                              }
                              if (s2 !== peg$FAILED) {
                                s1 = [s1, s2];
                                s0 = s1;
                              } else {
                                peg$currPos = s0;
                                s0 = peg$c0;
                              }
                            } else {
                              peg$currPos = s0;
                              s0 = peg$c0;
                            }
                            if (s0 === peg$FAILED) {
                              s0 = peg$currPos;
                              if (input.charCodeAt(peg$currPos) === 55360) {
                                s1 = peg$c317;
                                peg$currPos++;
                              } else {
                                s1 = peg$FAILED;
                                if (peg$silentFails === 0) { peg$fail(peg$c318); }
                              }
                              if (s1 !== peg$FAILED) {
                                if (peg$c319.test(input.charAt(peg$currPos))) {
                                  s2 = input.charAt(peg$currPos);
                                  peg$currPos++;
                                } else {
                                  s2 = peg$FAILED;
                                  if (peg$silentFails === 0) { peg$fail(peg$c320); }
                                }
                                if (s2 !== peg$FAILED) {
                                  s1 = [s1, s2];
                                  s0 = s1;
                                } else {
                                  peg$currPos = s0;
                                  s0 = peg$c0;
                                }
                              } else {
                                peg$currPos = s0;
                                s0 = peg$c0;
                              }
                              if (s0 === peg$FAILED) {
                                s0 = peg$currPos;
                                if (input.charCodeAt(peg$currPos) === 55422) {
                                  s1 = peg$c321;
                                  peg$currPos++;
                                } else {
                                  s1 = peg$FAILED;
                                  if (peg$silentFails === 0) { peg$fail(peg$c322); }
                                }
                                if (s1 !== peg$FAILED) {
                                  if (peg$c323.test(input.charAt(peg$currPos))) {
                                    s2 = input.charAt(peg$currPos);
                                    peg$currPos++;
                                  } else {
                                    s2 = peg$FAILED;
                                    if (peg$silentFails === 0) { peg$fail(peg$c324); }
                                  }
                                  if (s2 !== peg$FAILED) {
                                    s1 = [s1, s2];
                                    s0 = s1;
                                  } else {
                                    peg$currPos = s0;
                                    s0 = peg$c0;
                                  }
                                } else {
                                  peg$currPos = s0;
                                  s0 = peg$c0;
                                }
                                if (s0 === peg$FAILED) {
                                  s0 = peg$currPos;
                                  if (input.charCodeAt(peg$currPos) === 55405) {
                                    s1 = peg$c325;
                                    peg$currPos++;
                                  } else {
                                    s1 = peg$FAILED;
                                    if (peg$silentFails === 0) { peg$fail(peg$c326); }
                                  }
                                  if (s1 !== peg$FAILED) {
                                    if (peg$c327.test(input.charAt(peg$currPos))) {
                                      s2 = input.charAt(peg$currPos);
                                      peg$currPos++;
                                    } else {
                                      s2 = peg$FAILED;
                                      if (peg$silentFails === 0) { peg$fail(peg$c328); }
                                    }
                                    if (s2 !== peg$FAILED) {
                                      s1 = [s1, s2];
                                      s0 = s1;
                                    } else {
                                      peg$currPos = s0;
                                      s0 = peg$c0;
                                    }
                                  } else {
                                    peg$currPos = s0;
                                    s0 = peg$c0;
                                  }
                                  if (s0 === peg$FAILED) {
                                    s0 = peg$currPos;
                                    if (input.charCodeAt(peg$currPos) === 55322) {
                                      s1 = peg$c329;
                                      peg$currPos++;
                                    } else {
                                      s1 = peg$FAILED;
                                      if (peg$silentFails === 0) { peg$fail(peg$c330); }
                                    }
                                    if (s1 !== peg$FAILED) {
                                      if (peg$c331.test(input.charAt(peg$currPos))) {
                                        s2 = input.charAt(peg$currPos);
                                        peg$currPos++;
                                      } else {
                                        s2 = peg$FAILED;
                                        if (peg$silentFails === 0) { peg$fail(peg$c332); }
                                      }
                                      if (s2 !== peg$FAILED) {
                                        s1 = [s1, s2];
                                        s0 = s1;
                                      } else {
                                        peg$currPos = s0;
                                        s0 = peg$c0;
                                      }
                                    } else {
                                      peg$currPos = s0;
                                      s0 = peg$c0;
                                    }
                                    if (s0 === peg$FAILED) {
                                      s0 = peg$currPos;
                                      if (input.charCodeAt(peg$currPos) === 55298) {
                                        s1 = peg$c333;
                                        peg$currPos++;
                                      } else {
                                        s1 = peg$FAILED;
                                        if (peg$silentFails === 0) { peg$fail(peg$c334); }
                                      }
                                      if (s1 !== peg$FAILED) {
                                        if (peg$c335.test(input.charAt(peg$currPos))) {
                                          s2 = input.charAt(peg$currPos);
                                          peg$currPos++;
                                        } else {
                                          s2 = peg$FAILED;
                                          if (peg$silentFails === 0) { peg$fail(peg$c336); }
                                        }
                                        if (s2 !== peg$FAILED) {
                                          s1 = [s1, s2];
                                          s0 = s1;
                                        } else {
                                          peg$currPos = s0;
                                          s0 = peg$c0;
                                        }
                                      } else {
                                        peg$currPos = s0;
                                        s0 = peg$c0;
                                      }
                                      if (s0 === peg$FAILED) {
                                        s0 = peg$currPos;
                                        if (input.charCodeAt(peg$currPos) === 55309) {
                                          s1 = peg$c337;
                                          peg$currPos++;
                                        } else {
                                          s1 = peg$FAILED;
                                          if (peg$silentFails === 0) { peg$fail(peg$c338); }
                                        }
                                        if (s1 !== peg$FAILED) {
                                          if (peg$c339.test(input.charAt(peg$currPos))) {
                                            s2 = input.charAt(peg$currPos);
                                            peg$currPos++;
                                          } else {
                                            s2 = peg$FAILED;
                                            if (peg$silentFails === 0) { peg$fail(peg$c340); }
                                          }
                                          if (s2 !== peg$FAILED) {
                                            s1 = [s1, s2];
                                            s0 = s1;
                                          } else {
                                            peg$currPos = s0;
                                            s0 = peg$c0;
                                          }
                                        } else {
                                          peg$currPos = s0;
                                          s0 = peg$c0;
                                        }
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseunicodeCombiningMark() {
      var s0, s1, s2;

      var key    = peg$currPos * 189 + 136,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      if (peg$c341.test(input.charAt(peg$currPos))) {
        s0 = input.charAt(peg$currPos);
        peg$currPos++;
      } else {
        s0 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c342); }
      }
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        if (input.charCodeAt(peg$currPos) === 56128) {
          s1 = peg$c343;
          peg$currPos++;
        } else {
          s1 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c344); }
        }
        if (s1 !== peg$FAILED) {
          if (peg$c345.test(input.charAt(peg$currPos))) {
            s2 = input.charAt(peg$currPos);
            peg$currPos++;
          } else {
            s2 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c346); }
          }
          if (s2 !== peg$FAILED) {
            s1 = [s1, s2];
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
        if (s0 === peg$FAILED) {
          s0 = peg$currPos;
          if (input.charCodeAt(peg$currPos) === 55348) {
            s1 = peg$c347;
            peg$currPos++;
          } else {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c348); }
          }
          if (s1 !== peg$FAILED) {
            if (peg$c349.test(input.charAt(peg$currPos))) {
              s2 = input.charAt(peg$currPos);
              peg$currPos++;
            } else {
              s2 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c350); }
            }
            if (s2 !== peg$FAILED) {
              s1 = [s1, s2];
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
          if (s0 === peg$FAILED) {
            s0 = peg$currPos;
            if (input.charCodeAt(peg$currPos) === 55300) {
              s1 = peg$c293;
              peg$currPos++;
            } else {
              s1 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c294); }
            }
            if (s1 !== peg$FAILED) {
              if (peg$c351.test(input.charAt(peg$currPos))) {
                s2 = input.charAt(peg$currPos);
                peg$currPos++;
              } else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c352); }
              }
              if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
            if (s0 === peg$FAILED) {
              s0 = peg$currPos;
              if (input.charCodeAt(peg$currPos) === 55296) {
                s1 = peg$c297;
                peg$currPos++;
              } else {
                s1 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c298); }
              }
              if (s1 !== peg$FAILED) {
                if (peg$c353.test(input.charAt(peg$currPos))) {
                  s2 = input.charAt(peg$currPos);
                  peg$currPos++;
                } else {
                  s2 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$c354); }
                }
                if (s2 !== peg$FAILED) {
                  s1 = [s1, s2];
                  s0 = s1;
                } else {
                  peg$currPos = s0;
                  s0 = peg$c0;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
              if (s0 === peg$FAILED) {
                s0 = peg$currPos;
                if (input.charCodeAt(peg$currPos) === 55298) {
                  s1 = peg$c333;
                  peg$currPos++;
                } else {
                  s1 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$c334); }
                }
                if (s1 !== peg$FAILED) {
                  if (peg$c355.test(input.charAt(peg$currPos))) {
                    s2 = input.charAt(peg$currPos);
                    peg$currPos++;
                  } else {
                    s2 = peg$FAILED;
                    if (peg$silentFails === 0) { peg$fail(peg$c356); }
                  }
                  if (s2 !== peg$FAILED) {
                    s1 = [s1, s2];
                    s0 = s1;
                  } else {
                    peg$currPos = s0;
                    s0 = peg$c0;
                  }
                } else {
                  peg$currPos = s0;
                  s0 = peg$c0;
                }
              }
            }
          }
        }
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseunicodeDigit() {
      var s0, s1, s2;

      var key    = peg$currPos * 189 + 137,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      if (peg$c357.test(input.charAt(peg$currPos))) {
        s0 = input.charAt(peg$currPos);
        peg$currPos++;
      } else {
        s0 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c358); }
      }
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        if (input.charCodeAt(peg$currPos) === 55349) {
          s1 = peg$c289;
          peg$currPos++;
        } else {
          s1 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c290); }
        }
        if (s1 !== peg$FAILED) {
          if (peg$c359.test(input.charAt(peg$currPos))) {
            s2 = input.charAt(peg$currPos);
            peg$currPos++;
          } else {
            s2 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c360); }
          }
          if (s2 !== peg$FAILED) {
            s1 = [s1, s2];
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
        if (s0 === peg$FAILED) {
          s0 = peg$currPos;
          if (input.charCodeAt(peg$currPos) === 55300) {
            s1 = peg$c293;
            peg$currPos++;
          } else {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c294); }
          }
          if (s1 !== peg$FAILED) {
            if (peg$c361.test(input.charAt(peg$currPos))) {
              s2 = input.charAt(peg$currPos);
              peg$currPos++;
            } else {
              s2 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c362); }
            }
            if (s2 !== peg$FAILED) {
              s1 = [s1, s2];
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
          if (s0 === peg$FAILED) {
            s0 = peg$currPos;
            if (input.charCodeAt(peg$currPos) === 55297) {
              s1 = peg$c305;
              peg$currPos++;
            } else {
              s1 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c306); }
            }
            if (s1 !== peg$FAILED) {
              if (peg$c363.test(input.charAt(peg$currPos))) {
                s2 = input.charAt(peg$currPos);
                peg$currPos++;
              } else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c364); }
              }
              if (s2 !== peg$FAILED) {
                s1 = [s1, s2];
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$c0;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c0;
            }
          }
        }
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseunicodeConnectorPunctuation() {
      var s0;

      var key    = peg$currPos * 189 + 138,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      if (peg$c365.test(input.charAt(peg$currPos))) {
        s0 = input.charAt(peg$currPos);
        peg$currPos++;
      } else {
        s0 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c366); }
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsezwnj() {
      var s0;

      var key    = peg$currPos * 189 + 139,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      if (input.charCodeAt(peg$currPos) === 8204) {
        s0 = peg$c367;
        peg$currPos++;
      } else {
        s0 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c368); }
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsezwj() {
      var s0;

      var key    = peg$currPos * 189 + 140,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      if (input.charCodeAt(peg$currPos) === 8205) {
        s0 = peg$c369;
        peg$currPos++;
      } else {
        s0 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c370); }
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsereserved() {
      var s0;

      var key    = peg$currPos * 189 + 141,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$parsenull();
      if (s0 === peg$FAILED) {
        s0 = peg$parseundefined();
        if (s0 === peg$FAILED) {
          s0 = peg$parsetypeof();
          if (s0 === peg$FAILED) {
            s0 = peg$parsevoid();
            if (s0 === peg$FAILED) {
              s0 = peg$parsedelete();
              if (s0 === peg$FAILED) {
                s0 = peg$parsenew();
                if (s0 === peg$FAILED) {
                  s0 = peg$parsetrue();
                  if (s0 === peg$FAILED) {
                    s0 = peg$parsefalse();
                    if (s0 === peg$FAILED) {
                      s0 = peg$parsevar();
                      if (s0 === peg$FAILED) {
                        s0 = peg$parseconst();
                        if (s0 === peg$FAILED) {
                          s0 = peg$parselet();
                          if (s0 === peg$FAILED) {
                            s0 = peg$parsewhile();
                            if (s0 === peg$FAILED) {
                              s0 = peg$parsefor();
                              if (s0 === peg$FAILED) {
                                s0 = peg$parsein();
                                if (s0 === peg$FAILED) {
                                  s0 = peg$parseof();
                                  if (s0 === peg$FAILED) {
                                    s0 = peg$parseif();
                                    if (s0 === peg$FAILED) {
                                      s0 = peg$parseelse();
                                      if (s0 === peg$FAILED) {
                                        s0 = peg$parsereturn();
                                        if (s0 === peg$FAILED) {
                                          s0 = peg$parsetry();
                                          if (s0 === peg$FAILED) {
                                            s0 = peg$parsecatch();
                                            if (s0 === peg$FAILED) {
                                              s0 = peg$parsefinally();
                                              if (s0 === peg$FAILED) {
                                                s0 = peg$parsethrow();
                                                if (s0 === peg$FAILED) {
                                                  s0 = peg$parsebreak();
                                                  if (s0 === peg$FAILED) {
                                                    s0 = peg$parsecontinue();
                                                    if (s0 === peg$FAILED) {
                                                      s0 = peg$parsedo();
                                                      if (s0 === peg$FAILED) {
                                                        s0 = peg$parseimport();
                                                        if (s0 === peg$FAILED) {
                                                          s0 = peg$parseexport();
                                                          if (s0 === peg$FAILED) {
                                                            s0 = peg$parseclass();
                                                            if (s0 === peg$FAILED) {
                                                              s0 = peg$parseextends();
                                                            }
                                                          }
                                                        }
                                                      }
                                                    }
                                                  }
                                                }
                                              }
                                            }
                                          }
                                        }
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsetrue() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 142,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 4) === peg$c371) {
        s1 = peg$c371;
        peg$currPos += 4;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c372); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        s3 = peg$parseidentifierPart();
        peg$silentFails--;
        if (s3 === peg$FAILED) {
          s2 = peg$c16;
        } else {
          peg$currPos = s2;
          s2 = peg$c0;
        }
        if (s2 !== peg$FAILED) {
          peg$reportedPos = s0;
          s1 = peg$c176();
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsefalse() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 143,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 5) === peg$c373) {
        s1 = peg$c373;
        peg$currPos += 5;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c374); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        s3 = peg$parseidentifierPart();
        peg$silentFails--;
        if (s3 === peg$FAILED) {
          s2 = peg$c16;
        } else {
          peg$currPos = s2;
          s2 = peg$c0;
        }
        if (s2 !== peg$FAILED) {
          peg$reportedPos = s0;
          s1 = peg$c173();
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsenew() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 144,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 3) === peg$c375) {
        s1 = peg$c375;
        peg$currPos += 3;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c376); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        s3 = peg$parseidentifierPart();
        peg$silentFails--;
        if (s3 === peg$FAILED) {
          s2 = peg$c16;
        } else {
          peg$currPos = s2;
          s2 = peg$c0;
        }
        if (s2 !== peg$FAILED) {
          s1 = [s1, s2];
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsethis() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 145,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 4) === peg$c377) {
        s1 = peg$c377;
        peg$currPos += 4;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c378); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        s3 = peg$parseidentifierPart();
        peg$silentFails--;
        if (s3 === peg$FAILED) {
          s2 = peg$c16;
        } else {
          peg$currPos = s2;
          s2 = peg$c0;
        }
        if (s2 !== peg$FAILED) {
          s1 = [s1, s2];
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsenull() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 146,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 4) === peg$c379) {
        s1 = peg$c379;
        peg$currPos += 4;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c380); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        s3 = peg$parseidentifierPart();
        peg$silentFails--;
        if (s3 === peg$FAILED) {
          s2 = peg$c16;
        } else {
          peg$currPos = s2;
          s2 = peg$c0;
        }
        if (s2 !== peg$FAILED) {
          peg$reportedPos = s0;
          s1 = peg$c381();
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseundefined() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 147,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 9) === peg$c382) {
        s1 = peg$c382;
        peg$currPos += 9;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c383); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        s3 = peg$parseidentifierPart();
        peg$silentFails--;
        if (s3 === peg$FAILED) {
          s2 = peg$c16;
        } else {
          peg$currPos = s2;
          s2 = peg$c0;
        }
        if (s2 !== peg$FAILED) {
          peg$reportedPos = s0;
          s1 = peg$c384();
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseand() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 148,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 3) === peg$c385) {
        s1 = peg$c385;
        peg$currPos += 3;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c386); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        s3 = peg$parseidentifierPart();
        peg$silentFails--;
        if (s3 === peg$FAILED) {
          s2 = peg$c16;
        } else {
          peg$currPos = s2;
          s2 = peg$c0;
        }
        if (s2 !== peg$FAILED) {
          peg$reportedPos = s0;
          s1 = peg$c387();
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseor() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 149,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 2) === peg$c388) {
        s1 = peg$c388;
        peg$currPos += 2;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c389); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        s3 = peg$parseidentifierPart();
        peg$silentFails--;
        if (s3 === peg$FAILED) {
          s2 = peg$c16;
        } else {
          peg$currPos = s2;
          s2 = peg$c0;
        }
        if (s2 !== peg$FAILED) {
          peg$reportedPos = s0;
          s1 = peg$c390();
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseis() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 150,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 2) === peg$c391) {
        s1 = peg$c391;
        peg$currPos += 2;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c392); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        s3 = peg$parseidentifierPart();
        peg$silentFails--;
        if (s3 === peg$FAILED) {
          s2 = peg$c16;
        } else {
          peg$currPos = s2;
          s2 = peg$c0;
        }
        if (s2 !== peg$FAILED) {
          peg$reportedPos = s0;
          s1 = peg$c393();
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseisnt() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 151,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 4) === peg$c394) {
        s1 = peg$c394;
        peg$currPos += 4;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c395); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        s3 = peg$parseidentifierPart();
        peg$silentFails--;
        if (s3 === peg$FAILED) {
          s2 = peg$c16;
        } else {
          peg$currPos = s2;
          s2 = peg$c0;
        }
        if (s2 !== peg$FAILED) {
          peg$reportedPos = s0;
          s1 = peg$c396();
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsenot() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 152,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 3) === peg$c397) {
        s1 = peg$c397;
        peg$currPos += 3;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c398); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        s3 = peg$parseidentifierPart();
        peg$silentFails--;
        if (s3 === peg$FAILED) {
          s2 = peg$c16;
        } else {
          peg$currPos = s2;
          s2 = peg$c0;
        }
        if (s2 !== peg$FAILED) {
          peg$reportedPos = s0;
          s1 = peg$c399();
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsetypeof() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 153,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 6) === peg$c400) {
        s1 = peg$c400;
        peg$currPos += 6;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c401); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        s3 = peg$parseidentifierPart();
        peg$silentFails--;
        if (s3 === peg$FAILED) {
          s2 = peg$c16;
        } else {
          peg$currPos = s2;
          s2 = peg$c0;
        }
        if (s2 !== peg$FAILED) {
          peg$reportedPos = s0;
          s1 = peg$c402();
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsevoid() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 154,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 4) === peg$c70) {
        s1 = peg$c70;
        peg$currPos += 4;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c71); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        s3 = peg$parseidentifierPart();
        peg$silentFails--;
        if (s3 === peg$FAILED) {
          s2 = peg$c16;
        } else {
          peg$currPos = s2;
          s2 = peg$c0;
        }
        if (s2 !== peg$FAILED) {
          peg$reportedPos = s0;
          s1 = peg$c403();
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsedelete() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 155,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 6) === peg$c404) {
        s1 = peg$c404;
        peg$currPos += 6;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c405); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        s3 = peg$parseidentifierPart();
        peg$silentFails--;
        if (s3 === peg$FAILED) {
          s2 = peg$c16;
        } else {
          peg$currPos = s2;
          s2 = peg$c0;
        }
        if (s2 !== peg$FAILED) {
          peg$reportedPos = s0;
          s1 = peg$c406();
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsevar() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 156,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 3) === peg$c407) {
        s1 = peg$c407;
        peg$currPos += 3;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c408); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        s3 = peg$parseidentifierPart();
        peg$silentFails--;
        if (s3 === peg$FAILED) {
          s2 = peg$c16;
        } else {
          peg$currPos = s2;
          s2 = peg$c0;
        }
        if (s2 !== peg$FAILED) {
          s1 = [s1, s2];
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseconst() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 157,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 5) === peg$c409) {
        s1 = peg$c409;
        peg$currPos += 5;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c410); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        s3 = peg$parseidentifierPart();
        peg$silentFails--;
        if (s3 === peg$FAILED) {
          s2 = peg$c16;
        } else {
          peg$currPos = s2;
          s2 = peg$c0;
        }
        if (s2 !== peg$FAILED) {
          peg$reportedPos = s0;
          s1 = peg$c411();
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parselet() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 158,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 3) === peg$c412) {
        s1 = peg$c412;
        peg$currPos += 3;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c413); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        s3 = peg$parseidentifierPart();
        peg$silentFails--;
        if (s3 === peg$FAILED) {
          s2 = peg$c16;
        } else {
          peg$currPos = s2;
          s2 = peg$c0;
        }
        if (s2 !== peg$FAILED) {
          peg$reportedPos = s0;
          s1 = peg$c414();
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsein() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 159,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 2) === peg$c415) {
        s1 = peg$c415;
        peg$currPos += 2;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c416); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        s3 = peg$parseidentifierPart();
        peg$silentFails--;
        if (s3 === peg$FAILED) {
          s2 = peg$c16;
        } else {
          peg$currPos = s2;
          s2 = peg$c0;
        }
        if (s2 !== peg$FAILED) {
          peg$reportedPos = s0;
          s1 = peg$c417();
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseinstanceof() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 160,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 10) === peg$c418) {
        s1 = peg$c418;
        peg$currPos += 10;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c419); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        s3 = peg$parseidentifierPart();
        peg$silentFails--;
        if (s3 === peg$FAILED) {
          s2 = peg$c16;
        } else {
          peg$currPos = s2;
          s2 = peg$c0;
        }
        if (s2 !== peg$FAILED) {
          peg$reportedPos = s0;
          s1 = peg$c420();
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsewhile() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 161,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 5) === peg$c421) {
        s1 = peg$c421;
        peg$currPos += 5;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c422); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        s3 = peg$parseidentifierPart();
        peg$silentFails--;
        if (s3 === peg$FAILED) {
          s2 = peg$c16;
        } else {
          peg$currPos = s2;
          s2 = peg$c0;
        }
        if (s2 !== peg$FAILED) {
          s1 = [s1, s2];
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsefor() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 162,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 3) === peg$c423) {
        s1 = peg$c423;
        peg$currPos += 3;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c424); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        s3 = peg$parseidentifierPart();
        peg$silentFails--;
        if (s3 === peg$FAILED) {
          s2 = peg$c16;
        } else {
          peg$currPos = s2;
          s2 = peg$c0;
        }
        if (s2 !== peg$FAILED) {
          s1 = [s1, s2];
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseof() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 163,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 2) === peg$c425) {
        s1 = peg$c425;
        peg$currPos += 2;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c426); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        s3 = peg$parseidentifierPart();
        peg$silentFails--;
        if (s3 === peg$FAILED) {
          s2 = peg$c16;
        } else {
          peg$currPos = s2;
          s2 = peg$c0;
        }
        if (s2 !== peg$FAILED) {
          s1 = [s1, s2];
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseif() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 164,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 2) === peg$c427) {
        s1 = peg$c427;
        peg$currPos += 2;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c428); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        s3 = peg$parseidentifierPart();
        peg$silentFails--;
        if (s3 === peg$FAILED) {
          s2 = peg$c16;
        } else {
          peg$currPos = s2;
          s2 = peg$c0;
        }
        if (s2 !== peg$FAILED) {
          s1 = [s1, s2];
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseelse() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 165,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 4) === peg$c429) {
        s1 = peg$c429;
        peg$currPos += 4;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c430); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        s3 = peg$parseidentifierPart();
        peg$silentFails--;
        if (s3 === peg$FAILED) {
          s2 = peg$c16;
        } else {
          peg$currPos = s2;
          s2 = peg$c0;
        }
        if (s2 !== peg$FAILED) {
          s1 = [s1, s2];
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsereturn() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 166,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 6) === peg$c431) {
        s1 = peg$c431;
        peg$currPos += 6;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c432); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        s3 = peg$parseidentifierPart();
        peg$silentFails--;
        if (s3 === peg$FAILED) {
          s2 = peg$c16;
        } else {
          peg$currPos = s2;
          s2 = peg$c0;
        }
        if (s2 !== peg$FAILED) {
          s1 = [s1, s2];
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsetry() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 167,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 3) === peg$c433) {
        s1 = peg$c433;
        peg$currPos += 3;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c434); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        s3 = peg$parseidentifierPart();
        peg$silentFails--;
        if (s3 === peg$FAILED) {
          s2 = peg$c16;
        } else {
          peg$currPos = s2;
          s2 = peg$c0;
        }
        if (s2 !== peg$FAILED) {
          s1 = [s1, s2];
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsecatch() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 168,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 5) === peg$c435) {
        s1 = peg$c435;
        peg$currPos += 5;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c436); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        s3 = peg$parseidentifierPart();
        peg$silentFails--;
        if (s3 === peg$FAILED) {
          s2 = peg$c16;
        } else {
          peg$currPos = s2;
          s2 = peg$c0;
        }
        if (s2 !== peg$FAILED) {
          s1 = [s1, s2];
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsefinally() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 169,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 7) === peg$c437) {
        s1 = peg$c437;
        peg$currPos += 7;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c438); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        s3 = peg$parseidentifierPart();
        peg$silentFails--;
        if (s3 === peg$FAILED) {
          s2 = peg$c16;
        } else {
          peg$currPos = s2;
          s2 = peg$c0;
        }
        if (s2 !== peg$FAILED) {
          s1 = [s1, s2];
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsethrow() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 170,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 5) === peg$c439) {
        s1 = peg$c439;
        peg$currPos += 5;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c440); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        s3 = peg$parseidentifierPart();
        peg$silentFails--;
        if (s3 === peg$FAILED) {
          s2 = peg$c16;
        } else {
          peg$currPos = s2;
          s2 = peg$c0;
        }
        if (s2 !== peg$FAILED) {
          s1 = [s1, s2];
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsebreak() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 171,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 5) === peg$c441) {
        s1 = peg$c441;
        peg$currPos += 5;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c442); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        s3 = peg$parseidentifierPart();
        peg$silentFails--;
        if (s3 === peg$FAILED) {
          s2 = peg$c16;
        } else {
          peg$currPos = s2;
          s2 = peg$c0;
        }
        if (s2 !== peg$FAILED) {
          s1 = [s1, s2];
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsecontinue() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 172,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 8) === peg$c443) {
        s1 = peg$c443;
        peg$currPos += 8;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c444); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        s3 = peg$parseidentifierPart();
        peg$silentFails--;
        if (s3 === peg$FAILED) {
          s2 = peg$c16;
        } else {
          peg$currPos = s2;
          s2 = peg$c0;
        }
        if (s2 !== peg$FAILED) {
          s1 = [s1, s2];
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsedo() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 173,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 2) === peg$c445) {
        s1 = peg$c445;
        peg$currPos += 2;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c446); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        s3 = peg$parseidentifierPart();
        peg$silentFails--;
        if (s3 === peg$FAILED) {
          s2 = peg$c16;
        } else {
          peg$currPos = s2;
          s2 = peg$c0;
        }
        if (s2 !== peg$FAILED) {
          s1 = [s1, s2];
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseundo() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 174,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 4) === peg$c447) {
        s1 = peg$c447;
        peg$currPos += 4;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c448); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        s3 = peg$parseidentifierPart();
        peg$silentFails--;
        if (s3 === peg$FAILED) {
          s2 = peg$c16;
        } else {
          peg$currPos = s2;
          s2 = peg$c0;
        }
        if (s2 !== peg$FAILED) {
          s1 = [s1, s2];
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseimport() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 175,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 6) === peg$c449) {
        s1 = peg$c449;
        peg$currPos += 6;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c450); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        s3 = peg$parseidentifierPart();
        peg$silentFails--;
        if (s3 === peg$FAILED) {
          s2 = peg$c16;
        } else {
          peg$currPos = s2;
          s2 = peg$c0;
        }
        if (s2 !== peg$FAILED) {
          s1 = [s1, s2];
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseexport() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 176,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 6) === peg$c451) {
        s1 = peg$c451;
        peg$currPos += 6;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c452); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        s3 = peg$parseidentifierPart();
        peg$silentFails--;
        if (s3 === peg$FAILED) {
          s2 = peg$c16;
        } else {
          peg$currPos = s2;
          s2 = peg$c0;
        }
        if (s2 !== peg$FAILED) {
          s1 = [s1, s2];
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseclass() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 177,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 5) === peg$c453) {
        s1 = peg$c453;
        peg$currPos += 5;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c454); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        s3 = peg$parseidentifierPart();
        peg$silentFails--;
        if (s3 === peg$FAILED) {
          s2 = peg$c16;
        } else {
          peg$currPos = s2;
          s2 = peg$c0;
        }
        if (s2 !== peg$FAILED) {
          s1 = [s1, s2];
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseextends() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 178,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 7) === peg$c455) {
        s1 = peg$c455;
        peg$currPos += 7;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c456); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        s3 = peg$parseidentifierPart();
        peg$silentFails--;
        if (s3 === peg$FAILED) {
          s2 = peg$c16;
        } else {
          peg$currPos = s2;
          s2 = peg$c0;
        }
        if (s2 !== peg$FAILED) {
          s1 = [s1, s2];
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseassert() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 179,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 6) === peg$c457) {
        s1 = peg$c457;
        peg$currPos += 6;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c458); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        s3 = peg$parseidentifierPart();
        peg$silentFails--;
        if (s3 === peg$FAILED) {
          s2 = peg$c16;
        } else {
          peg$currPos = s2;
          s2 = peg$c0;
        }
        if (s2 !== peg$FAILED) {
          s1 = [s1, s2];
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsetemplate() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 180,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 8) === peg$c459) {
        s1 = peg$c459;
        peg$currPos += 8;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c460); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        s3 = peg$parseidentifierPart();
        peg$silentFails--;
        if (s3 === peg$FAILED) {
          s2 = peg$c16;
        } else {
          peg$currPos = s2;
          s2 = peg$c0;
        }
        if (s2 !== peg$FAILED) {
          s1 = [s1, s2];
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseactivate() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 181,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      if (input.substr(peg$currPos, 8) === peg$c461) {
        s1 = peg$c461;
        peg$currPos += 8;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c462); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        s3 = peg$parseidentifierPart();
        peg$silentFails--;
        if (s3 === peg$FAILED) {
          s2 = peg$c16;
        } else {
          peg$currPos = s2;
          s2 = peg$c0;
        }
        if (s2 !== peg$FAILED) {
          s1 = [s1, s2];
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseindent() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 182,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      peg$silentFails++;
      s0 = peg$currPos;
      s1 = peg$parseeol();
      if (s1 === peg$FAILED) {
        s1 = peg$c4;
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$parse_();
        if (s2 !== peg$FAILED) {
          if (input.substr(peg$currPos, 4) === peg$c464) {
            s3 = peg$c464;
            peg$currPos += 4;
          } else {
            s3 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c465); }
          }
          if (s3 !== peg$FAILED) {
            s1 = [s1, s2, s3];
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }
      peg$silentFails--;
      if (s0 === peg$FAILED) {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c463); }
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseoutdent() {
      var s0, s1, s2, s3;

      var key    = peg$currPos * 189 + 183,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      peg$silentFails++;
      s0 = peg$currPos;
      s1 = peg$parseeol();
      if (s1 === peg$FAILED) {
        s1 = peg$c4;
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$parse_();
        if (s2 !== peg$FAILED) {
          if (input.substr(peg$currPos, 4) === peg$c467) {
            s3 = peg$c467;
            peg$currPos += 4;
          } else {
            s3 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c468); }
          }
          if (s3 !== peg$FAILED) {
            s1 = [s1, s2, s3];
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }
      peg$silentFails--;
      if (s0 === peg$FAILED) {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c466); }
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parse_() {
      var s0, s1;

      var key    = peg$currPos * 189 + 184,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      peg$silentFails++;
      s0 = [];
      if (input.charCodeAt(peg$currPos) === 32) {
        s1 = peg$c470;
        peg$currPos++;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c471); }
      }
      while (s1 !== peg$FAILED) {
        s0.push(s1);
        if (input.charCodeAt(peg$currPos) === 32) {
          s1 = peg$c470;
          peg$currPos++;
        } else {
          s1 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c471); }
        }
      }
      peg$silentFails--;
      if (s0 === peg$FAILED) {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c469); }
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parsecomment() {
      var s0, s1, s2, s3, s4, s5, s6;

      var key    = peg$currPos * 189 + 185,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parse_();
      if (s1 !== peg$FAILED) {
        if (input.charCodeAt(peg$currPos) === 35) {
          s2 = peg$c472;
          peg$currPos++;
        } else {
          s2 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c473); }
        }
        if (s2 !== peg$FAILED) {
          s3 = [];
          s4 = peg$currPos;
          s5 = peg$currPos;
          peg$silentFails++;
          if (input.charCodeAt(peg$currPos) === 10) {
            s6 = peg$c474;
            peg$currPos++;
          } else {
            s6 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c475); }
          }
          peg$silentFails--;
          if (s6 === peg$FAILED) {
            s5 = peg$c16;
          } else {
            peg$currPos = s5;
            s5 = peg$c0;
          }
          if (s5 !== peg$FAILED) {
            if (input.length > peg$currPos) {
              s6 = input.charAt(peg$currPos);
              peg$currPos++;
            } else {
              s6 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c183); }
            }
            if (s6 !== peg$FAILED) {
              s5 = [s5, s6];
              s4 = s5;
            } else {
              peg$currPos = s4;
              s4 = peg$c0;
            }
          } else {
            peg$currPos = s4;
            s4 = peg$c0;
          }
          while (s4 !== peg$FAILED) {
            s3.push(s4);
            s4 = peg$currPos;
            s5 = peg$currPos;
            peg$silentFails++;
            if (input.charCodeAt(peg$currPos) === 10) {
              s6 = peg$c474;
              peg$currPos++;
            } else {
              s6 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c475); }
            }
            peg$silentFails--;
            if (s6 === peg$FAILED) {
              s5 = peg$c16;
            } else {
              peg$currPos = s5;
              s5 = peg$c0;
            }
            if (s5 !== peg$FAILED) {
              if (input.length > peg$currPos) {
                s6 = input.charAt(peg$currPos);
                peg$currPos++;
              } else {
                s6 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c183); }
              }
              if (s6 !== peg$FAILED) {
                s5 = [s5, s6];
                s4 = s5;
              } else {
                peg$currPos = s4;
                s4 = peg$c0;
              }
            } else {
              peg$currPos = s4;
              s4 = peg$c0;
            }
          }
          if (s3 !== peg$FAILED) {
            s1 = [s1, s2, s3];
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseeol() {
      var s0, s1, s2, s3, s4, s5, s6, s7;

      var key    = peg$currPos * 189 + 186,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      peg$silentFails++;
      s0 = peg$currPos;
      s1 = peg$parse_();
      if (s1 !== peg$FAILED) {
        s2 = peg$parsecomment();
        if (s2 === peg$FAILED) {
          s2 = peg$c4;
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$parseeof();
          if (s3 === peg$FAILED) {
            s3 = [];
            s4 = peg$currPos;
            if (input.charCodeAt(peg$currPos) === 13) {
              s5 = peg$c477;
              peg$currPos++;
            } else {
              s5 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c478); }
            }
            if (s5 === peg$FAILED) {
              s5 = peg$c4;
            }
            if (s5 !== peg$FAILED) {
              if (input.charCodeAt(peg$currPos) === 10) {
                s6 = peg$c474;
                peg$currPos++;
              } else {
                s6 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c475); }
              }
              if (s6 !== peg$FAILED) {
                s7 = peg$parsecomment();
                if (s7 === peg$FAILED) {
                  s7 = peg$c4;
                }
                if (s7 !== peg$FAILED) {
                  s5 = [s5, s6, s7];
                  s4 = s5;
                } else {
                  peg$currPos = s4;
                  s4 = peg$c0;
                }
              } else {
                peg$currPos = s4;
                s4 = peg$c0;
              }
            } else {
              peg$currPos = s4;
              s4 = peg$c0;
            }
            if (s4 !== peg$FAILED) {
              while (s4 !== peg$FAILED) {
                s3.push(s4);
                s4 = peg$currPos;
                if (input.charCodeAt(peg$currPos) === 13) {
                  s5 = peg$c477;
                  peg$currPos++;
                } else {
                  s5 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$c478); }
                }
                if (s5 === peg$FAILED) {
                  s5 = peg$c4;
                }
                if (s5 !== peg$FAILED) {
                  if (input.charCodeAt(peg$currPos) === 10) {
                    s6 = peg$c474;
                    peg$currPos++;
                  } else {
                    s6 = peg$FAILED;
                    if (peg$silentFails === 0) { peg$fail(peg$c475); }
                  }
                  if (s6 !== peg$FAILED) {
                    s7 = peg$parsecomment();
                    if (s7 === peg$FAILED) {
                      s7 = peg$c4;
                    }
                    if (s7 !== peg$FAILED) {
                      s5 = [s5, s6, s7];
                      s4 = s5;
                    } else {
                      peg$currPos = s4;
                      s4 = peg$c0;
                    }
                  } else {
                    peg$currPos = s4;
                    s4 = peg$c0;
                  }
                } else {
                  peg$currPos = s4;
                  s4 = peg$c0;
                }
              }
            } else {
              s3 = peg$c0;
            }
          }
          if (s3 !== peg$FAILED) {
            s1 = [s1, s2, s3];
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c0;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }
      peg$silentFails--;
      if (s0 === peg$FAILED) {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c476); }
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseeol_nocomments() {
      var s0, s1, s2, s3, s4, s5;

      var key    = peg$currPos * 189 + 187,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      s0 = peg$currPos;
      s1 = peg$parse_();
      if (s1 !== peg$FAILED) {
        s2 = peg$parseeof();
        if (s2 === peg$FAILED) {
          s2 = [];
          s3 = peg$currPos;
          if (input.charCodeAt(peg$currPos) === 13) {
            s4 = peg$c477;
            peg$currPos++;
          } else {
            s4 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c478); }
          }
          if (s4 === peg$FAILED) {
            s4 = peg$c4;
          }
          if (s4 !== peg$FAILED) {
            if (input.charCodeAt(peg$currPos) === 10) {
              s5 = peg$c474;
              peg$currPos++;
            } else {
              s5 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c475); }
            }
            if (s5 !== peg$FAILED) {
              s4 = [s4, s5];
              s3 = s4;
            } else {
              peg$currPos = s3;
              s3 = peg$c0;
            }
          } else {
            peg$currPos = s3;
            s3 = peg$c0;
          }
          if (s3 !== peg$FAILED) {
            while (s3 !== peg$FAILED) {
              s2.push(s3);
              s3 = peg$currPos;
              if (input.charCodeAt(peg$currPos) === 13) {
                s4 = peg$c477;
                peg$currPos++;
              } else {
                s4 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c478); }
              }
              if (s4 === peg$FAILED) {
                s4 = peg$c4;
              }
              if (s4 !== peg$FAILED) {
                if (input.charCodeAt(peg$currPos) === 10) {
                  s5 = peg$c474;
                  peg$currPos++;
                } else {
                  s5 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$c475); }
                }
                if (s5 !== peg$FAILED) {
                  s4 = [s4, s5];
                  s3 = s4;
                } else {
                  peg$currPos = s3;
                  s3 = peg$c0;
                }
              } else {
                peg$currPos = s3;
                s3 = peg$c0;
              }
            }
          } else {
            s2 = peg$c0;
          }
        }
        if (s2 !== peg$FAILED) {
          s1 = [s1, s2];
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c0;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }

    function peg$parseeof() {
      var s0, s1;

      var key    = peg$currPos * 189 + 188,
          cached = peg$cache[key];

      if (cached) {
        peg$currPos = cached.nextPos;
        return cached.result;
      }

      peg$silentFails++;
      s0 = peg$currPos;
      peg$silentFails++;
      if (input.length > peg$currPos) {
        s1 = input.charAt(peg$currPos);
        peg$currPos++;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c183); }
      }
      peg$silentFails--;
      if (s1 === peg$FAILED) {
        s0 = peg$c16;
      } else {
        peg$currPos = s0;
        s0 = peg$c0;
      }
      peg$silentFails--;
      if (s0 === peg$FAILED) {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c479); }
      }

      peg$cache[key] = { nextPos: peg$currPos, result: s0 };

      return s0;
    }


        var common = require("./common");
        var primitive = {string:true,number:true,boolean:true,function:true}
        function clone(object) {
            if (object === undefined || object === null || object.constructor === RegExp || primitive[typeof object])
                return object
            var copy = Array.isArray(object) ? [] : {}
            for (key in object) {
                var value = object[key]
                copy[key] = clone(value)
            }
            return copy
        }
        function isValidIdentifier(name) {
            return /^[a-z_$][a-z_$0-9]*$/.test(name)
        }
        function node(type, properties, start, end) {
            var node = {type:type}
            if (properties != null) {
                for (var key in properties) {
                    node[key] = properties[key]
                }
            }
            setLoc(node, start, end)
            return node
        }
        function setLoc(node, start, end) {
            if (options.loc) {
                if (start != null) {
                    node.loc = {start:start}
                    if (end != null)
                        node.loc.end = end
                }
            }
        }
        function thisExpression(start, end, property) {
            var thisExpression = node("ThisExpression", null, start, end);
            for (var i = 2; i < arguments.length; i++) {
                var property = arguments[i]
                if (typeof property === 'string')
                    property = {type:'Identifier', name:property}
                thisExpression = node("MemberExpression", {object:thisExpression,property:property}, start, end);
            }
            return thisExpression;
        }
        function binaryExpression(op, left, right, start, end) {
            return node("BinaryExpression", {operator:op, left:left, right:right}, start, end)
        }
        function leftAssociateBinaryExpressions(start, head, tail) {
            var result = head
            for (var i = 0; i < tail.length; i++)
                result = binaryExpression(tail[i][1], result, tail[i][3], start, tail[i][4])
            return result
        }
        function leftAssociateCallsOrMembers(start, head, tail) {
            var result = head
            if (tail != null) {
                for (var i = 0; i < tail.length; i++) {
                    var next = tail[i][1]
                    setLoc(next, start, tail[i][2])
                    next[tail[i][0]] = result
                    result = next
                }
            }
            return result
        }
        function unindent(content) {
            //  content consists of strings and/or Expressions
            //  strings that start lines should start with \n
            var minIndent = common.getMinIndent(content, /\n([ ]+)/)
            var replacement = "\n"
            var find = replacement
            var i, line;
            for (i = 0; i < minIndent; i++) {
                find += " "
            }
            for (i = 0; i < content.length; i++) {
                line = content[i]
                if (typeof line === 'string')
                    content[i] = line.replace(find, replacement)
            }

            //  trim the starting /n
            if (typeof content[0] === 'string' && content[0][0] === '\n')
                content[0] = content[0].substring(1)

            // console.log('===============================================')
            // console.log(content)
            // console.log('===============================================')

            joinAdjacentStrings(content)

            // console.log(content)
            // console.log('===============================================')
            return content
        }
        function joinAdjacentStrings(content) {
            for (var i = 1; i < content.length;) {
                var left = content[i - 1]
                var right = content[i]
                if (typeof left === 'string' && typeof right === 'string')
                    content.splice(i - 1, 2, left + right)
                else
                    i++
            }
        }
        function toNode(value) {
            return value.type != null ? value : node("Literal", {value:value})
        }
        function concatenate(content) {
            if (typeof content[0] !== 'string')
                content.unshift("")
            var result = toNode(content.shift())
            while (content.length > 0) {
                var right = toNode(content.shift())
                result = node("BinaryExpression", {operator:"+", left:result, right:right})
            }
            return result
        }


    peg$result = peg$startRuleFunction();

    if (peg$result !== peg$FAILED && peg$currPos === input.length) {
      return peg$result;
    } else {
      if (peg$result !== peg$FAILED && peg$currPos < input.length) {
        peg$fail({ type: "end", description: "end of input" });
      }

      throw peg$buildException(null, peg$maxFailExpected, peg$maxFailPos);
    }
  }

  return {
    SyntaxError: SyntaxError,
    parse:       parse
  };
})()
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/compiler/parser',_ion_compiler_parser_);
    else
      _ion_compiler_parser_.call(this, module, exports, require);
  }
  else {
    _ion_compiler_parser_.call(this);
  }
}).call(this)
void (function(){var _ion_compiler_postprocessor_ = function(module,exports,require){var activateStatements, addOrderPropertyToStatements, addPropertyDeclaration, addStatement, addUseStrictAndRequireIon, arrayComprehensionsToES5, assertStatements, basicTraverse, block, callFunctionBindForFatArrows, checkVariableDeclarations, classExpressions, convertForInToForLength, createForInLoopValueVariable, createTemplateFunctionClone, createTemplateRuntime, defaultAssignmentsToDefaultOperators, defaultOperatorsToConditionals, destructuringAssignments, ensureIonVariable, existentialExpression, extractForLoopRightVariable, extractForLoopsInnerAndTest, extractReactiveForPatterns, falseExpression, forEachDestructuringAssignment, functionDeclarations, functionParameterDefaultValuesToES5, getExternalIdentifiers, getPathExpression, getReferenceIdentifiers, globalOptions, hoistVariables, ion, ionExpression, isAncestorObjectExpression, isConstantLiteral, isFunctionNode, isObjectPatch, isPattern, isReferenceNode, isSimpleObjectExpression, isSuperExpression, isVariableReference, javascriptExpressions, letAndConstToVar, namedFunctionsAndNewArguments, nodeToLiteral, nodejsModules, nodes, nullExpression, patchAssignmentExpression, propertyDefinitions, propertyStatements, removeLocationInfo, setNodeOutputValues, spreadExpressions, superExpressions, thisExpression, traverse, trueExpression, typedObjectExpressions, undefinedExpression, validateTemplateNodes, variableDeclarationExpressions, wrapTemplateInnerFunctions, _ref;

traverse = require('./traverseAst').traverse;

basicTraverse = require('./traverse').traverse;

_ref = require('./astFunctions'), addStatement = _ref.addStatement, forEachDestructuringAssignment = _ref.forEachDestructuringAssignment;

nodes = require('./nodes');

ion = require('../');

undefinedExpression = Object.freeze({
  type: 'UnaryExpression',
  argument: {
    type: 'Literal',
    value: 0
  },
  operator: 'void',
  prefix: true
});

nullExpression = Object.freeze({
  type: 'Literal',
  value: null
});

trueExpression = Object.freeze({
  type: 'Literal',
  value: true
});

falseExpression = Object.freeze({
  type: 'Literal',
  value: false
});

ionExpression = Object.freeze({
  type: 'Identifier',
  name: 'ion'
});

thisExpression = Object.freeze({
  type: 'ThisExpression'
});

isPattern = function(node) {
  return (node.properties != null) || (node.elements != null);
};

isVariableReference = function(node, parent, key) {
  return node.type === 'Identifier' && ((parent == null) || !(parent.type === 'MemberExpression' && key === 'property' || parent.type === 'Property' && key === 'key'));
};

isObjectPatch = function(node) {
  return (node != null) && node.type === 'ObjectExpression' && ((node.objectType != null) || (node.create != null));
};

isConstantLiteral = function(node, parent, key) {
  var computed, index, type, value, _i, _j, _len, _len1, _ref1, _ref2, _ref3;
  if (isObjectPatch(node)) {
    return false;
  }
  if (node == null) {
    return false;
  }
  if (node.type === 'Literal') {
    return true;
  }
  if (isVariableReference(node, parent, key)) {
    return false;
  }
  if (node.type === 'ObjectExpression') {
    _ref1 = node.properties;
    for (index = _i = 0, _len = _ref1.length; _i < _len; index = ++_i) {
      _ref2 = _ref1[index], type = _ref2.type, value = _ref2.value, computed = _ref2.computed;
      if (computed || type !== 'Property' || !isConstantLiteral(value, node, index)) {
        return false;
      }
    }
    return true;
  } else if (node.type === 'ArrayExpression') {
    _ref3 = node.elements;
    for (index = _j = 0, _len1 = _ref3.length; _j < _len1; index = ++_j) {
      value = _ref3[index];
      if (!isConstantLiteral(value, node, index)) {
        return false;
      }
    }
    return true;
  } else {
    return false;
  }
};

nodeToLiteral = function(object, checkForLiteral) {
  var item, key, node, value;
  if (checkForLiteral !== false && isObjectPatch(object)) {
    checkForLiteral = false;
  }
  node = null;
  if ((object != null ? object.toLiteral : void 0) != null) {
    node = object != null ? object.toLiteral() : void 0;
  } else if (Array.isArray(object)) {
    node = {
      type: 'ArrayExpression',
      elements: (function() {
        var _i, _len, _results;
        _results = [];
        for (_i = 0, _len = object.length; _i < _len; _i++) {
          item = object[_i];
          _results.push(nodeToLiteral(item, checkForLiteral));
        }
        return _results;
      })()
    };
  } else if ((object != null ? object.constructor : void 0) === Object) {
    node = {
      type: 'ObjectExpression',
      properties: []
    };
    for (key in object) {
      value = object[key];
      if (value !== void 0) {
        node.properties.push({
          key: {
            type: 'Identifier',
            name: key
          },
          value: nodeToLiteral(value, checkForLiteral),
          kind: 'init'
        });
      }
    }
  } else {
    node = {
      type: 'Literal',
      value: object
    };
  }
  return node;
};

getPathExpression = function(path) {
  var i, result, step, steps, _i, _len;
  steps = path.split('.');
  if (steps[0] === 'this') {
    result = {
      type: 'ThisExpression'
    };
  } else {
    result = {
      type: 'Identifier',
      name: steps[0]
    };
  }
  for (i = _i = 0, _len = steps.length; _i < _len; i = ++_i) {
    step = steps[i];
    if (i > 0) {
      result = {
        type: 'MemberExpression',
        object: result,
        property: {
          type: 'Identifier',
          name: step
        }
      };
    }
  }
  return result;
};

isFunctionNode = function(node) {
  var _ref1, _ref2;
  return (_ref1 = (_ref2 = nodes[node != null ? node.type : void 0]) != null ? _ref2.isFunction : void 0) != null ? _ref1 : false;
};

block = function(node) {
  if (node.type !== 'BlockStatement') {
    node = {
      type: 'BlockStatement',
      body: [node]
    };
  }
  return node;
};

extractReactiveForPatterns = function(node, context) {
  var declarator, index, ref, _i, _len, _ref1, _results;
  if (!context.reactive) {
    return;
  }
  if (node.type === 'ForOfStatement' || node.type === 'ForInStatement') {
    _ref1 = node.left.declarations;
    _results = [];
    for (index = _i = 0, _len = _ref1.length; _i < _len; index = ++_i) {
      declarator = _ref1[index];
      if (!(isPattern(declarator.id))) {
        continue;
      }
      ref = context.getNewInternalIdentifier();
      context.addStatement({
        type: 'VariableDeclaration',
        declarations: [
          {
            type: 'VariableDeclarator',
            id: declarator.id,
            init: ref
          }
        ]
      });
      _results.push(declarator.id = ref);
    }
    return _results;
  }
};

extractForLoopRightVariable = function(node, context) {
  var ref, right;
  if (context.reactive) {
    return;
  }
  if (node.type === 'ForOfStatement' || (node.type === 'ForInStatement' && node.left.declarations.length > 1)) {
    if (node.left.declarations.length > 2) {
      throw context.error("too many declarations", node.left.declarations[2]);
    }
    right = node.right;
    if (right.type !== "Identifier") {
      ref = context.getNewInternalIdentifier();
      node.right = ref;
      return context.replace({
        type: "BlockStatement",
        body: [
          {
            type: "VariableDeclaration",
            declarations: [
              {
                type: "VariableDeclarator",
                id: ref,
                init: right
              }
            ],
            kind: node.left.kind
          }, node
        ]
      });
    }
  }
};

createForInLoopValueVariable = function(node, context) {
  var valueDeclarator;
  if (context.reactive) {
    return;
  }
  if (node.type === 'ForInStatement' && node.left.declarations.length > 1) {
    valueDeclarator = node.left.declarations[1];
    if (node.visited_createForInLoopValueVariable) {
      return;
    }
    node.visited_createForInLoopValueVariable = true;
    return context.addVariable({
      id: valueDeclarator.id,
      init: {
        type: 'MemberExpression',
        computed: true,
        object: node.right,
        property: node.left.declarations[0].id
      }
    });
  }
};

convertForInToForLength = function(node, context) {
  var loopIndex, userIndex, _ref1;
  if (context.reactive) {
    return;
  }
  if (node.type === 'ForOfStatement') {
    userIndex = (_ref1 = node.left.declarations[1]) != null ? _ref1.id : void 0;
    loopIndex = context.getNewInternalIdentifier("_i");
    addStatement(node, {
      type: "VariableDeclaration",
      declarations: [
        {
          type: "VariableDeclarator",
          id: node.left.declarations[0].id,
          init: {
            type: "MemberExpression",
            object: node.right,
            property: loopIndex,
            computed: true
          }
        }
      ],
      kind: node.left.kind
    });
    if (userIndex != null) {
      addStatement(node, {
        type: "VariableDeclaration",
        declarations: [
          {
            type: "VariableDeclarator",
            id: userIndex,
            init: loopIndex
          }
        ],
        kind: node.left.kind
      });
    }
    return context.replace({
      type: 'ForStatement',
      init: {
        type: "VariableDeclaration",
        declarations: [
          {
            type: "VariableDeclarator",
            id: loopIndex,
            init: {
              type: "Literal",
              value: 0
            }
          }
        ],
        kind: 'let'
      },
      test: {
        type: "BinaryExpression",
        operator: "<",
        left: loopIndex,
        right: {
          type: "MemberExpression",
          object: node.right,
          property: {
            type: "Identifier",
            name: "length"
          },
          computed: false
        }
      },
      update: {
        type: "UpdateExpression",
        operator: "++",
        argument: loopIndex,
        prefix: false
      },
      body: node.body
    });
  }
};

callFunctionBindForFatArrows = function(node, context) {
  if (node.type === 'FunctionExpression' && node.bound) {
    delete node.bound;
    ensureIonVariable(context);
    return context.replace({
      type: "CallExpression",
      callee: getPathExpression('ion.bind'),
      "arguments": [node, thisExpression]
    });
  }
};

nodejsModules = function(node, context) {
  var declarator, _i, _ref1, _results;
  if (node.type === 'ImportExpression') {
    node.type = 'CallExpression';
    node.callee = {
      type: 'Identifier',
      name: 'require'
    };
    node["arguments"] = [node.name];
    return delete node.name;
  } else if (node.type === 'ExportStatement') {
    if (node.value.type === 'VariableDeclaration') {
      context.exports = true;
      context.replace(node.value);
      _ref1 = node.value.declarations;
      _results = [];
      for (_i = _ref1.length - 1; _i >= 0; _i += -1) {
        declarator = _ref1[_i];
        if (declarator.init == null) {
          throw context.error("Export variables must have an init value", declarator);
        }
        _results.push(declarator.init = {
          type: 'AssignmentExpression',
          operator: '=',
          left: {
            type: 'MemberExpression',
            object: {
              type: 'Identifier',
              name: 'exports'
            },
            property: declarator.id
          },
          right: declarator.init
        });
      }
      return _results;
    } else {
      if (context.exports) {
        throw context.error("default export must be first");
      }
      return context.replace({
        type: 'ExpressionStatement',
        expression: {
          type: 'AssignmentExpression',
          operator: '=',
          left: {
            type: 'MemberExpression',
            object: {
              type: 'Identifier',
              name: 'module'
            },
            property: {
              type: 'Identifier',
              name: 'exports'
            }
          },
          right: {
            type: 'AssignmentExpression',
            operator: '=',
            left: {
              type: 'Identifier',
              name: 'exports'
            },
            right: node.value
          }
        }
      });
    }
  }
};

destructuringAssignments = function(node, context) {
  var count, declarator, declaratorIndex, expression, index, pattern, statement, statements, tempId, _i, _j, _k, _len, _len1, _len2, _ref1, _ref2;
  if (isFunctionNode(node)) {
    _ref1 = node.params;
    for (index = _i = 0, _len = _ref1.length; _i < _len; index = ++_i) {
      pattern = _ref1[index];
      if (!(isPattern(pattern))) {
        continue;
      }
      tempId = context.getNewInternalIdentifier();
      node.params[index] = tempId;
      statements = [];
      forEachDestructuringAssignment(pattern, tempId, function(id, expression) {
        return statements.unshift({
          type: 'VariableDeclaration',
          declarations: [
            {
              type: 'VariableDeclarator',
              id: id,
              init: expression
            }
          ],
          kind: 'let'
        });
      });
      for (_j = 0, _len1 = statements.length; _j < _len1; _j++) {
        statement = statements[_j];
        context.addStatement(statement);
      }
    }
  }
  if (node.type === 'VariableDeclaration' && context.isParentBlock()) {
    count = 0;
    _ref2 = node.declarations;
    for (declaratorIndex = _k = 0, _len2 = _ref2.length; _k < _len2; declaratorIndex = ++_k) {
      declarator = _ref2[declaratorIndex];
      if (!(isPattern(declarator.id))) {
        continue;
      }
      pattern = declarator.id;
      tempId = context.getNewInternalIdentifier();
      declarator.id = tempId;
      if ((declarator.init != null) && declaratorIndex > 0) {
        context.addStatement({
          type: 'ExpressionStatement',
          expression: {
            type: 'AssignmentExpression',
            operator: '=',
            left: tempId,
            right: declarator.init
          }
        }, ++count);
        declarator.init = null;
        node.kind = 'let';
      }
      forEachDestructuringAssignment(pattern, tempId, function(id, expression) {
        return context.addStatement({
          type: 'VariableDeclaration',
          declarations: [
            {
              type: 'VariableDeclarator',
              id: id,
              init: expression
            }
          ],
          kind: 'let'
        }, ++count);
      });
    }
  }
  if (node.type === 'ExpressionStatement' && node.expression.operator === '=') {
    expression = node.expression;
    pattern = expression.left;
    if (isPattern(pattern)) {
      tempId = context.getNewInternalIdentifier();
      context.replace({
        type: 'VariableDeclaration',
        declarations: [
          {
            type: 'VariableDeclarator',
            id: tempId,
            init: expression.right
          }
        ],
        kind: 'const'
      });
      count = 0;
      return forEachDestructuringAssignment(pattern, tempId, function(id, expression) {
        return context.addStatement({
          type: 'ExpressionStatement',
          expression: {
            type: 'AssignmentExpression',
            operator: '=',
            left: id,
            right: expression
          }
        }, ++count);
      });
    }
  }
};

defaultOperatorsToConditionals = function(node, context) {
  if (node.type === 'BinaryExpression' && (node.operator === '??' || node.operator === '?')) {
    return context.replace({
      type: 'ConditionalExpression',
      test: {
        type: 'BinaryExpression',
        operator: '!=',
        left: node.left,
        right: node.operator === '??' ? undefinedExpression : nullExpression
      },
      consequent: node.left,
      alternate: node.right
    });
  }
};

defaultAssignmentsToDefaultOperators = function(node, context) {
  if (node.type === 'AssignmentExpression' && (node.operator === '?=' || node.operator === '??=')) {
    node.right = {
      type: 'BinaryExpression',
      operator: node.operator === '?=' ? '?' : '??',
      left: node.left,
      right: node.right
    };
    return node.operator = '=';
  }
};

existentialExpression = function(node, context) {
  var existentialChild, existentialChildObject, getExistentialDescendantObject, _ref1;
  if (node.type === 'UnaryExpression' && node.operator === '?') {
    context.replace({
      type: 'BinaryExpression',
      operator: '!=',
      left: node.argument,
      right: nullExpression
    });
  }
  if (node.type === 'MemberExpression' || node.type === 'CallExpression' && !context.reactive) {
    getExistentialDescendantObject = function(check) {
      var result, _ref1;
      result = null;
      if (check.type === 'MemberExpression' || check.type === 'CallExpression') {
        result = getExistentialDescendantObject((_ref1 = check.object) != null ? _ref1 : check.callee);
        if (check.existential) {
          if (result == null) {
            result = check;
          }
        }
      }
      return result;
    };
    existentialChild = getExistentialDescendantObject(node);
    if (existentialChild != null) {
      existentialChildObject = (_ref1 = existentialChild.object) != null ? _ref1 : existentialChild.callee;
      delete existentialChild.existential;
      return context.replace({
        type: 'ConditionalExpression',
        test: {
          type: 'BinaryExpression',
          operator: '!=',
          left: existentialChildObject,
          right: nullExpression
        },
        consequent: node,
        alternate: undefinedExpression
      });
    }
  }
};

ensureIonVariable = function(context, required) {
  if (required == null) {
    required = true;
  }
  return context.ancestorNodes[0].requiresIon = required;
};

addUseStrictAndRequireIon = {
  enter: function(node, context) {
    var d, _i, _len, _ref1, _ref2, _results;
    if (node.type === 'VariableDeclaration' && ((_ref1 = context.parentNode()) != null ? _ref1.type : void 0) === 'Program') {
      _ref2 = node.declarations;
      _results = [];
      for (_i = 0, _len = _ref2.length; _i < _len; _i++) {
        d = _ref2[_i];
        if (!(d.id.name === 'ion')) {
          continue;
        }
        ensureIonVariable(context, false);
        break;
      }
      return _results;
    }
  },
  exit: function(node, context) {
    if (node.type === 'Program') {
      if (node.requiresIon) {
        delete node.requiresIon;
        context.addVariable({
          offset: Number.MIN_VALUE,
          kind: 'const',
          id: ionExpression,
          init: {
            type: 'ImportExpression',
            name: {
              type: 'Literal',
              value: 'ion'
            }
          }
        });
      }
      return node.body.unshift({
        type: 'ExpressionStatement',
        expression: {
          type: 'Literal',
          value: 'use strict'
        }
      });
    }
  }
};

extractForLoopsInnerAndTest = function(node, context) {
  if (node.type === 'ForInStatement' || node.type === 'ForOfStatement') {
    if (node.inner != null) {
      node.inner.body = node.body;
      node.body = node.inner;
      delete node.inner;
    }
    if (node.test != null) {
      node.body = block({
        type: 'IfStatement',
        test: node.test,
        consequent: block(node.body)
      });
      return delete node.test;
    }
  }
};

arrayComprehensionsToES5 = function(node, context) {
  var forStatement, tempId;
  if (node.type === 'ArrayExpression' && (node.value != null) && (node.comprehension != null)) {
    if (context.reactive) {
      forStatement = node.comprehension;
      forStatement.body = {
        type: 'ExpressionStatement',
        expression: node.value
      };
      return context.replace({
        type: 'ObjectExpression',
        objectType: {
          type: 'ArrayExpression',
          elements: []
        },
        properties: [forStatement]
      });
    } else {
      tempId = context.addVariable({
        offset: 0,
        init: {
          type: 'ArrayExpression',
          elements: []
        }
      });
      forStatement = node.comprehension;
      forStatement.body = {
        type: 'ExpressionStatement',
        expression: {
          type: 'CallExpression',
          callee: {
            type: 'MemberExpression',
            object: tempId,
            property: {
              type: 'Identifier',
              name: 'push'
            }
          },
          "arguments": [node.value]
        }
      };
      context.addStatement(0, forStatement);
      return context.replace(tempId);
    }
  }
};

functionParameterDefaultValuesToES5 = function(node, context) {
  var defaultValue, index, param, _i, _ref1, _ref2, _results;
  if (context.reactive) {
    return;
  }
  if (isFunctionNode(node) && (node.params != null) && (node.defaults != null)) {
    _ref1 = node.params;
    _results = [];
    for (index = _i = _ref1.length - 1; _i >= 0; index = _i += -1) {
      param = _ref1[index];
      defaultValue = (_ref2 = node.defaults) != null ? _ref2[index] : void 0;
      if (defaultValue != null) {
        context.addStatement({
          type: 'IfStatement',
          test: {
            type: 'BinaryExpression',
            operator: '==',
            left: param,
            right: nullExpression
          },
          consequent: {
            type: 'ExpressionStatement',
            expression: {
              type: 'AssignmentExpression',
              operator: '=',
              left: param,
              right: defaultValue
            }
          }
        });
        _results.push(node.defaults[index] = void 0);
      } else {
        _results.push(void 0);
      }
    }
    return _results;
  }
};

isSimpleObjectExpression = function(node) {
  var isArray, isSimple, property, _i, _len, _ref1, _ref2;
  if (node.type !== 'ObjectExpression') {
    return false;
  }
  isArray = ((_ref1 = node.objectType) != null ? _ref1.type : void 0) === "ArrayExpression";
  isSimple = true;
  if (node.properties != null) {
    _ref2 = node.properties;
    for (_i = 0, _len = _ref2.length; _i < _len; _i++) {
      property = _ref2[_i];
      if (isArray) {
        if (property.type !== 'ExpressionStatement') {
          isSimple = false;
          break;
        }
      } else {
        if (property.type !== 'Property' || property.computed) {
          isSimple = false;
          break;
        }
      }
    }
  }
  return isSimple;
};

typedObjectExpressions = function(node, context) {
  var addPosition, element, elements, expressionStatement, getExistingObjectIdIfTempVarNotNeeded, grandNode, initialValue, isArray, isSimple, objectId, objectType, parentNode, statements, _i, _j, _len, _len1, _ref1, _ref2, _ref3;
  if (context.reactive) {
    return;
  }
  if (node.type === 'ObjectExpression' && node.simple !== true) {
    isArray = ((_ref1 = node.objectType) != null ? _ref1.type : void 0) === "ArrayExpression";
    isSimple = isSimpleObjectExpression(node);
    if (isSimple) {
      if (isArray) {
        elements = [];
        if (node.objectType != null) {
          _ref2 = node.objectType.elements;
          for (_i = 0, _len = _ref2.length; _i < _len; _i++) {
            element = _ref2[_i];
            elements.push(element);
          }
        }
        _ref3 = node.properties;
        for (_j = 0, _len1 = _ref3.length; _j < _len1; _j++) {
          expressionStatement = _ref3[_j];
          elements.push(expressionStatement.expression);
        }
        context.replace({
          type: "ArrayExpression",
          elements: elements
        });
        return;
      }
      if ((node.objectType == null) || (node.objectType.type === 'ObjectExpression' && node.objectType.properties.length === 0)) {
        delete node.objectType;
        Object.defineProperty(node, 'simple', {
          value: true
        });
        return;
      }
      objectType = node.objectType;
      delete node.objectType;
      if (isSimpleObjectExpression(objectType)) {
        node.properties = objectType.properties.concat(node.properties);
        Object.defineProperty(node, 'simple', {
          value: true
        });
        return;
      } else {
        ensureIonVariable(context);
        context.replace({
          type: 'CallExpression',
          callee: getPathExpression('ion.patch.combine'),
          "arguments": [objectType, node]
        });
        return;
      }
    }
    if (node.objectType == null) {
      initialValue = {
        type: 'ObjectExpression',
        properties: []
      };
    } else {
      initialValue = node.objectType;
    }
    parentNode = context.parentNode();
    grandNode = context.ancestorNodes[context.ancestorNodes.length - 2];
    addPosition = 0;
    getExistingObjectIdIfTempVarNotNeeded = function(node, parentNode, grandNode) {
      if (parentNode.type === 'VariableDeclarator') {
        return parentNode.id;
      }
      if (parentNode.type === 'AssignmentExpression' && parentNode.left.type === 'Identifier' && (grandNode != null ? grandNode.type : void 0) === 'ExpressionStatement') {
        return parentNode.left;
      }
      return null;
    };
    objectId = getExistingObjectIdIfTempVarNotNeeded(node, parentNode, grandNode);
    if (objectId != null) {
      context.replace(initialValue);
      addPosition = 1;
    } else {
      objectId = context.addVariable({
        offset: 0,
        init: initialValue
      });
      context.replace(objectId);
    }
    statements = [];
    setNodeOutputValues(context, node.properties, objectId, statements, isArray);
    if (statements.length === 1) {
      return context.addStatement(statements[0], addPosition);
    } else {
      return context.addStatement({
        type: 'BlockStatement',
        body: statements
      }, addPosition);
    }
  }
};

setNodeOutputValues = function(context, nodes, outputId, statements, isArray) {
  var subnodeEnter, subnodeExit;
  if (statements == null) {
    statements = [];
  }
  subnodeEnter = function(subnode, subcontext) {
    if (subcontext.outputStack == null) {
      subcontext.outputStack = [outputId];
    }
    if (subnode.type === 'ObjectExpression' || subnode.type === 'ArrayExpression') {
      return subcontext.skip();
    }
    if (subnode.type === 'Property') {
      subnode.output = subcontext.outputStack[subcontext.outputStack.length - 1];
      subcontext.outputStack.push({
        type: 'MemberExpression',
        object: subnode.output,
        property: subnode.key,
        computed: subnode.computed || subnode.key.type !== 'Identifier'
      });
    } else if (isFunctionNode(subnode)) {
      subcontext.skip();
    } else if (subnode.type === 'ExpressionStatement') {
      if (!isArray) {
        ensureIonVariable(context);
      }
      subnode = subcontext.replace({
        type: 'ExpressionStatement',
        expression: {
          type: 'CallExpression',
          callee: {
            type: 'MemberExpression',
            object: isArray ? outputId : ionExpression,
            property: {
              type: 'Identifier',
              name: isArray ? 'push' : 'add'
            }
          },
          "arguments": isArray ? [subnode.expression] : [outputId, subnode.expression]
        }
      });
      subcontext.skip();
    }
    if (subcontext.parentNode() == null) {
      return statements.push(subnode);
    }
  };
  subnodeExit = function(subnode, subcontext) {
    if (subnode.type === 'Property') {
      return subcontext.outputStack.pop();
    }
  };
  traverse(nodes, subnodeEnter, subnodeExit);
  return statements;
};

propertyStatements = function(node, context) {
  var left, parent, right;
  if (context.reactive) {
    return;
  }
  parent = context.parentNode();
  if (node.type === 'Property' && !(parent.type === 'ObjectExpression' || parent.type === 'ObjectPattern')) {
    if (node.output != null) {
      if (node.value.type === 'ObjectExpression') {
        left = {
          type: 'MemberExpression',
          object: node.output,
          property: node.key,
          computed: node.computed
        };
        if (node.value.type === 'ObjectExpression' && (node.value.objectType == null)) {
          ensureIonVariable(context);
          right = {
            type: 'CallExpression',
            callee: getPathExpression('ion.patch.combine'),
            "arguments": [ion.clone(left, true), node.value]
          };
        } else {
          right = node.value;
        }
        return context.replace({
          type: 'ExpressionStatement',
          expression: {
            type: 'AssignmentExpression',
            operator: '=',
            left: left,
            right: right
          }
        });
      } else {
        return context.replace({
          type: 'ExpressionStatement',
          expression: {
            type: 'AssignmentExpression',
            operator: '=',
            left: {
              type: 'MemberExpression',
              object: node.output,
              property: node.key,
              computed: node.computed
            },
            right: node.value
          }
        });
      }
    } else {
      throw context.error("Property assignment only valid within an object declaration", node);
    }
  }
};

patchAssignmentExpression = function(node, context) {
  if (node.type === 'AssignmentExpression' && node.operator === ':=') {
    ensureIonVariable(context);
    return context.replace({
      type: 'AssignmentExpression',
      operator: '=',
      left: node.left,
      right: {
        type: 'CallExpression',
        callee: getPathExpression('ion.patch.combine'),
        "arguments": [ion.clone(node.left, true), node.right]
      }
    });
  }
};

classExpressions = function(node, context) {
  var classExpression, hasIdentifierName, name, properties, property, _base, _i, _len;
  if (node.type === 'ClassExpression') {
    ensureIonVariable(context);
    properties = node.properties;
    hasIdentifierName = (node.name != null) && !node.computed;
    if (node.name != null) {
      name = hasIdentifierName ? {
        type: 'Literal',
        value: node.name.name
      } : node.name;
      properties = [
        {
          type: 'Property',
          key: {
            type: 'Identifier',
            name: 'name'
          },
          value: name
        }
      ].concat(properties);
    }
    if (hasIdentifierName) {
      for (_i = 0, _len = properties.length; _i < _len; _i++) {
        property = properties[_i];
        if (property.key.name === 'constructor') {
          if ((_base = property.value).id == null) {
            _base.id = node.name;
          }
        }
      }
    }
    classExpression = {
      type: 'CallExpression',
      callee: {
        type: 'MemberExpression',
        object: ionExpression,
        property: {
          type: 'Identifier',
          name: 'defineClass'
        }
      },
      "arguments": [
        {
          type: 'ObjectExpression',
          properties: properties
        }
      ].concat(node["extends"])
    };
    if (hasIdentifierName) {
      context.addVariable({
        id: node.name,
        kind: 'const',
        init: classExpression,
        offset: 0
      });
      return context.replace(node.name);
    } else {
      return context.replace(classExpression);
    }
  }
};

checkVariableDeclarations = {
  enter: function(node, context) {
    var variable, _base;
    if (node.type === 'AssignmentExpression') {
      if (node.left.type === 'Identifier') {
        variable = context.getVariableInfo(node.left.name);
        if (variable == null) {
          throw context.error("cannot assign to undeclared variable " + node.left.name);
        }
        if (variable.kind === 'const') {
          throw context.error("cannot assign to a const", node.left);
        }
      }
      if (context.reactive) {
        throw context.error("cannot assign within templates", node);
      }
    }
    if (isVariableReference(node, context.parentNode(), context.key())) {
      return ((_base = context.scope()).usage != null ? _base.usage : _base.usage = {})[node.name] = node;
    }
  },
  variable: function(variable, context) {
    var checkScope, existing, scope, shadow, used, _i, _j, _ref1, _ref2, _ref3, _ref4, _ref5, _results;
    scope = context.scope();
    existing = context.getVariableInfo(variable.name);
    if (existing != null) {
      shadow = false;
      _ref1 = context.scopeStack;
      for (_i = _ref1.length - 1; _i >= 0; _i += -1) {
        checkScope = _ref1[_i];
        if (checkScope === (existing != null ? existing.scope : void 0)) {
          break;
        }
        if ((_ref2 = nodes[checkScope.node.type]) != null ? _ref2.shadow : void 0) {
          shadow = true;
          break;
        }
      }
      if (!shadow) {
        throw context.error("Cannot redeclare variable " + variable.name, variable.node);
      }
    }
    _ref3 = context.scopeStack;
    _results = [];
    for (_j = _ref3.length - 1; _j >= 0; _j += -1) {
      checkScope = _ref3[_j];
      used = (_ref4 = checkScope.usage) != null ? _ref4[variable.name] : void 0;
      if (used != null) {
        throw context.error("Cannot use variable '" + variable.name + "' before declaration", used);
      }
      if ((_ref5 = nodes[checkScope.node.type]) != null ? _ref5.shadow : void 0) {
        break;
      } else {
        _results.push(void 0);
      }
    }
    return _results;
  }
};

isAncestorObjectExpression = function(context) {
  var ancestor, _i, _ref1;
  _ref1 = context.ancestorNodes;
  for (_i = _ref1.length - 1; _i >= 0; _i += -1) {
    ancestor = _ref1[_i];
    if (ancestor.type === 'ObjectExpression') {
      return true;
    }
    if (isFunctionNode(ancestor)) {
      return false;
    }
  }
  return false;
};

namedFunctionsAndNewArguments = function(node, context) {
  var _base, _base1, _ref1;
  if (context.reactive) {
    return;
  }
  if (node.type === 'NewExpression') {
    if (node["arguments"] == null) {
      node["arguments"] = [];
    }
  }
  if (node.type === 'VariableDeclarator' && ((_ref1 = node.init) != null ? _ref1.type : void 0) === 'FunctionExpression') {
    if ((_base = node.init).name == null) {
      _base.name = node.id;
    }
  }
  if (node.type === 'Property' && node.value.type === 'FunctionExpression' && node.key.type === 'Identifier') {
    if (node.key.name !== 'constructor') {
      return (_base1 = node.value).name != null ? _base1.name : _base1.name = node.key;
    }
  }
};

assertStatements = function(node, context) {
  if (node.type === 'AssertStatement') {
    return context.replace({
      type: 'IfStatement',
      test: {
        type: 'UnaryExpression',
        prefix: true,
        operator: '!',
        argument: node.expression
      },
      consequent: {
        type: 'ThrowStatement',
        argument: {
          type: 'NewExpression',
          callee: {
            type: 'Identifier',
            name: 'Error'
          },
          "arguments": [
            {
              type: 'Literal',
              value: "Assertion Failed: (" + node.text + ")"
            }
          ]
        }
      }
    });
  }
};

isSuperExpression = function(node, context) {
  var parentNode;
  parentNode = context.parentNode();
  if (node.type === 'Identifier' && node.name === 'super' && parentNode.type !== 'CallExpression' && parentNode.type !== 'MemberExpression') {
    return true;
  }
  if (node.type === 'CallExpression' && node.callee.type === 'Identifier' && node.callee.name === 'super') {
    return true;
  }
  return false;
};

superExpressions = function(node, context) {
  var applyOrCall, args, classNode, functionNode, functionProperty, isConstructor, superFunction, _ref1, _ref2;
  if (isSuperExpression(node, context)) {
    classNode = context.getAncestor(function(node) {
      return node.type === 'ClassExpression';
    });
    functionNode = context.getAncestor(isFunctionNode);
    functionProperty = context.ancestorNodes[context.ancestorNodes.indexOf(functionNode) - 1];
    isConstructor = (functionProperty != null ? (_ref1 = functionProperty.key) != null ? _ref1.name : void 0 : void 0) === 'constructor';
    if ((classNode == null) || !(((functionNode != null ? functionNode.name : void 0) != null) || isConstructor)) {
      throw context.error("super can only be used within named class functions", node);
    }
    args = [
      {
        type: 'ThisExpression'
      }
    ];
    if (node.type === 'Identifier') {
      args.push({
        type: 'Identifier',
        name: 'arguments'
      });
      applyOrCall = 'apply';
    } else {
      args = args.concat(node["arguments"]);
      applyOrCall = 'call';
    }
    superFunction = getPathExpression("" + classNode.name.name + ".super");
    if (!isConstructor) {
      superFunction = {
        type: 'MemberExpression',
        object: {
          type: 'MemberExpression',
          object: superFunction,
          property: {
            type: 'Identifier',
            name: 'prototype'
          }
        },
        property: (_ref2 = functionNode.name) != null ? _ref2 : 'constructor'
      };
    }
    return context.replace({
      type: 'CallExpression',
      callee: {
        type: 'MemberExpression',
        object: superFunction,
        property: {
          type: 'Identifier',
          name: applyOrCall
        }
      },
      "arguments": args
    });
  }
};

spreadExpressions = function(node, context) {
  var args, finalParameters, getOffsetFromArgumentsLength, index, param, spread, spreadIndex, _i, _len, _ref1;
  if (isFunctionNode(node)) {
    spread = null;
    spreadIndex = null;
    _ref1 = node.params;
    for (index = _i = 0, _len = _ref1.length; _i < _len; index = ++_i) {
      param = _ref1[index];
      if (param.type === 'SpreadExpression') {
        spread = param;
        spreadIndex = index;
        break;
      }
    }
    if (spread != null) {
      node.params[spreadIndex] = {
        type: 'Identifier',
        name: "___" + spread.expression.name
      };
      args = [
        {
          type: 'Identifier',
          name: 'arguments'
        }, {
          type: 'Literal',
          value: spreadIndex
        }
      ];
      finalParameters = node.params.length - 1 - spreadIndex;
      if (finalParameters > 0) {
        getOffsetFromArgumentsLength = function(offset) {
          return {
            type: 'BinaryExpression',
            operator: '-',
            left: getPathExpression('arguments.length'),
            right: {
              type: 'Literal',
              value: offset
            }
          };
        };
        args.push(getOffsetFromArgumentsLength(finalParameters));
        index = node.params.length - 1;
        while (index > spreadIndex) {
          param = node.params[index--];
          context.addStatement({
            type: 'ExpressionStatement',
            expression: {
              type: 'AssignmentExpression',
              operator: '=',
              left: param,
              right: {
                type: 'MemberExpression',
                computed: true,
                object: getPathExpression('arguments'),
                property: getOffsetFromArgumentsLength(node.params.length - 1 - index)
              }
            }
          });
        }
      }
      return context.addVariable({
        id: spread.expression,
        init: {
          type: 'CallExpression',
          callee: getPathExpression('Array.prototype.slice.call'),
          "arguments": args
        }
      });
    }
  }
};

validateTemplateNodes = function(node, context) {
  var _ref1;
  if (context.reactive) {
    if (((_ref1 = nodes[node.type]) != null ? _ref1.allowedInReactive : void 0) === false) {
      throw context.error(node.type + " not allowed in templates", node);
    }
  }
};

removeLocationInfo = function(node) {
  return traverse(node, function(node) {
    var _ref1;
    if ((node.loc != null) && !((_ref1 = nodes[node != null ? node.type : void 0]) != null ? _ref1.location : void 0)) {
      delete node.loc;
    }
    return node;
  });
};

isReferenceNode = function(node, context) {
  var parentNode;
  if (node.type !== 'Identifier') {
    return false;
  }
  parentNode = context.parentNode();
  if (isFunctionNode(parentNode)) {
    return false;
  }
  if ((parentNode != null ? parentNode.type : void 0) === 'VariableDeclarator' && context.key() === 'id') {
    return false;
  }
  if ((parentNode != null ? parentNode.type : void 0) === 'MemberExpression' && !(parentNode != null ? parentNode.computed : void 0) && context.key() === 'property') {
    return false;
  }
  if ((parentNode != null ? parentNode.type : void 0) === 'Property' && context.key() === 'key') {
    return false;
  }
  return true;
};

getReferenceIdentifiers = function(node, callback) {
  var results;
  results = {};
  if (callback == null) {
    callback = function(node) {
      return results[node.name] = node;
    };
  }
  traverse(node, function(node, context) {
    var isRef;
    isRef = isReferenceNode(node, context);
    if (isRef) {
      return callback(node, context);
    }
  });
  return results;
};

getExternalIdentifiers = function(node, callback) {
  getReferenceIdentifiers(node, function(node, context) {
    if (context.getVariableInfo(node.name) != null) {
      return;
    }
    return callback(node, context);
  });
};

wrapTemplateInnerFunctions = function(node, context) {
  var contextId, id, name, requiresWrapper, variables;
  if (context.parentReactive()) {
    if (node.type === 'FunctionExpression' && (node.toLiteral == null)) {
      variables = {};
      getExternalIdentifiers(node, function(id) {
        var _ref1, _ref2;
        if (id.name === 'ion' || (id.name !== ((_ref1 = node.id) != null ? _ref1.name : void 0) && (((_ref2 = context.scope()) != null ? _ref2.variables[id.name] : void 0) != null))) {
          return variables[id.name] = id;
        }
      });
      requiresWrapper = Object.keys(variables).length > 0;
      if (requiresWrapper) {
        contextId = context.getNewInternalIdentifier('_context');
        node.body.body.unshift({
          type: 'VariableDeclaration',
          kind: 'const',
          declarations: (function() {
            var _results;
            _results = [];
            for (name in variables) {
              id = variables[name];
              _results.push({
                type: 'VariableDeclarator',
                id: id,
                init: {
                  type: 'CallExpression',
                  callee: getPathExpression("" + contextId.name + ".get"),
                  "arguments": [
                    {
                      type: 'Literal',
                      value: id.name
                    }
                  ]
                }
              });
            }
            return _results;
          })()
        });
        node = {
          type: 'FunctionExpression',
          params: [contextId],
          body: {
            type: 'BlockStatement',
            body: [
              {
                type: 'ReturnStatement',
                argument: node
              }
            ]
          }
        };
      }
      node.toLiteral = function() {
        return this;
      };
      return context.replace({
        type: 'Function',
        context: requiresWrapper,
        value: node
      });
    }
  }
};

createTemplateFunctionClone = function(node, context) {
  var inner, newNode, scope;
  if (isFunctionNode(node) && node.template === true) {
    delete node.template;
    node.type = 'Template';
    ensureIonVariable(context);
    newNode = {
      type: 'CallExpression',
      callee: getPathExpression('ion.template'),
      "arguments": [node],
      toLiteral: function() {
        return this;
      }
    };
    inner = context.parentReactive();
    if (inner) {
      scope = context.getNewInternalIdentifier('_ps');
      node.scope = scope;
      newNode = {
        type: 'Function',
        context: true,
        value: {
          type: 'FunctionExpression',
          params: [scope],
          toLiteral: function() {
            return this;
          },
          body: block({
            type: 'ReturnStatement',
            argument: newNode
          })
        }
      };
    }
    return context.replace(newNode);
  }
};

createTemplateRuntime = function(node, context) {
  var args, id, key, name, newNode, params, referenceIds, template, templateId, value, variables, _i, _j, _len, _len1, _ref1, _ref2, _ref3, _ref4;
  if (node.type === 'Template') {
    template = removeLocationInfo(node);
    templateId = node.id;
    args = {
      type: 'ObjectExpression',
      properties: []
    };
    variables = {
      "this": thisExpression
    };
    referenceIds = getReferenceIdentifiers(node);
    _ref1 = ['require', 'module', 'exports', 'ion'];
    for (_i = 0, _len = _ref1.length; _i < _len; _i++) {
      name = _ref1[_i];
      if (referenceIds[name] != null) {
        variables[name] = {
          type: 'Identifier',
          name: name
        };
      }
    }
    _ref2 = template.params;
    for (_j = 0, _len1 = _ref2.length; _j < _len1; _j++) {
      id = _ref2[_j];
      variables[id.name] = id;
    }
    _ref3 = context.scope().variables;
    for (key in _ref3) {
      value = _ref3[key];
      id = value.id;
      variables[id.name] = id;
    }
    for (key in variables) {
      id = variables[key];
      args.properties.push({
        key: id,
        value: id,
        kind: 'init'
      });
    }
    params = template.params;
    template.body = template.body.body;
    delete template.params;
    delete template.defaults;
    newNode = {
      type: 'FunctionExpression',
      params: params,
      body: {
        type: 'BlockStatement',
        body: [
          {
            type: 'ReturnStatement',
            argument: {
              type: 'CallExpression',
              callee: getPathExpression('ion.createRuntime'),
              "arguments": [nodeToLiteral(template), args, (_ref4 = node.scope) != null ? _ref4 : nullExpression]
            }
          }
        ]
      }
    };
    if (templateId != null) {
      newNode.id = templateId;
    }
    return context.replace(newNode);
  }
};

javascriptExpressions = function(node, context) {
  var e, errorNode, esprima, expression, message, program, _ref1, _ref2;
  if (node.type === 'JavascriptExpression') {
    try {
      esprima = require('esprima');
    } catch (_error) {
      e = _error;
      node.type = 'VerbatimExpression';
      node.verbatim = node.text;
      return;
    }
    try {
      program = esprima.parse(node.text);
      expression = program.body[0].expression;
      return context.replace(expression);
    } catch (_error) {
      e = _error;
      errorNode = ion.clone(node, true);
      if ((_ref1 = errorNode.loc) != null) {
        _ref1.start.line += e.lineNumber - 1;
      }
      if ((_ref2 = errorNode.loc) != null) {
        _ref2.start.column += e.column - 1 + "`".length;
      }
      message = e.message.substring(e.message.indexOf(':') + 1).trim();
      throw context.error(message, errorNode);
    }
  }
};

functionDeclarations = function(node, context) {
  var func, _ref1, _ref2;
  if (node.type === 'VariableDeclaration' && node.kind === 'const' && node.declarations.length === 1 && ((_ref1 = node.declarations[0].init) != null ? _ref1.type : void 0) === 'FunctionExpression' && ((_ref2 = node.declarations[0].init.id) != null ? _ref2.name : void 0) === node.declarations[0].id.name) {
    func = node.declarations[0].init;
    func.type = 'FunctionDeclaration';
    context.replace(func);
  }
  if (node.type === 'ExpressionStatement' && node.expression.type === 'FunctionExpression') {
    throw context.error('Function Expression is a noop', node);
  }
};

letAndConstToVar = function(node, context) {
  if (node.type === 'VariableDeclaration' && node.kind !== 'var') {
    return node.kind = 'var';
  }
};

activateStatements = function(node, context) {
  if (node.type === 'ActivateStatement') {
    return context.replace({
      type: 'ExpressionStatement',
      expression: {
        type: 'CallExpression',
        callee: {
          type: 'MemberExpression',
          object: {
            type: 'CallExpression',
            callee: node.argument,
            "arguments": []
          },
          property: {
            type: 'Identifier',
            name: 'observe'
          }
        },
        "arguments": []
      }
    });
  }
};

hoistVariables = function(node, context) {};

variableDeclarationExpressions = function(node, context) {
  if (node.type === 'VariableDeclarationExpression') {
    context.addStatement(0, {
      type: 'VariableDeclaration',
      declarations: node.declarations,
      kind: node.kind
    });
    return context.replace(node.declarations[0].id);
  }
};

addPropertyDeclaration = function(node, context) {
  var parentNode, temp, tempId, _ref1;
  if (node.type === 'Property' && node.add) {
    parentNode = context.parentNode();
    if (!(parentNode.type === 'ObjectExpression')) {
      throw context.error("property assignment only valid within ObjectExpression", node);
    }
    temp = context.getVariable({
      prefix: "_" + ((_ref1 = node.key.name) != null ? _ref1 : "value"),
      init: node.value
    });
    tempId = temp.declarations[0].id;
    context.replace(temp);
    context.insertAfter({
      type: 'ExpressionStatement',
      expression: tempId
    });
    return context.insertAfter({
      type: 'Property',
      key: node.key,
      value: tempId
    });
  }
};

propertyDefinitions = function(node, context) {
  var def, definitions, property, _i, _j, _len, _len1, _ref1;
  if (node.type === 'ObjectExpression') {
    definitions = null;
    _ref1 = node.properties;
    for (_i = 0, _len = _ref1.length; _i < _len; _i++) {
      property = _ref1[_i];
      if (property.define) {
        if (definitions == null) {
          definitions = [];
        }
        definitions.push(property);
      }
    }
    if (definitions != null) {
      for (_j = 0, _len1 = definitions.length; _j < _len1; _j++) {
        def = definitions[_j];
        node.properties.remove(def);
        def.define = false;
      }
      return context.replace({
        type: 'CallExpression',
        callee: getPathExpression('Object.defineProperties'),
        "arguments": [
          node, {
            type: 'ObjectExpression',
            properties: definitions
          }
        ]
      });
    }
  }
};

addOrderPropertyToStatements = function(node, context) {
  var index, order, statement, _i, _len, _ref1, _ref2, _results;
  if (node.body || node.properties) {
    _ref2 = (_ref1 = node.body) != null ? _ref1 : node.properties;
    _results = [];
    for (index = _i = 0, _len = _ref2.length; _i < _len; index = ++_i) {
      statement = _ref2[index];
      order = String.fromCharCode(48 + index);
      _results.push(statement.order = order);
    }
    return _results;
  }
};

globalOptions = {};

exports.postprocess = function(program, options) {
  var enter, exit, previousContext, steps, traversal, variable, _i, _len;
  steps = [[namedFunctionsAndNewArguments, superExpressions, activateStatements, addPropertyDeclaration, propertyDefinitions], [destructuringAssignments, callFunctionBindForFatArrows], [createTemplateFunctionClone], [javascriptExpressions, arrayComprehensionsToES5, variableDeclarationExpressions, checkVariableDeclarations, hoistVariables], [extractForLoopsInnerAndTest, extractForLoopRightVariable], [extractReactiveForPatterns, validateTemplateNodes, classExpressions], [createForInLoopValueVariable, convertForInToForLength, typedObjectExpressions, propertyStatements, defaultAssignmentsToDefaultOperators], [defaultOperatorsToConditionals, destructuringAssignments], [wrapTemplateInnerFunctions, nodejsModules], [addOrderPropertyToStatements], [existentialExpression, createTemplateRuntime, functionParameterDefaultValuesToES5, patchAssignmentExpression], [addUseStrictAndRequireIon], [nodejsModules, spreadExpressions, assertStatements, functionDeclarations]];
  if ((options != null ? options.target : void 0) === 'es5') {
    steps.push([letAndConstToVar]);
  }
  previousContext = null;
  for (_i = 0, _len = steps.length; _i < _len; _i++) {
    traversal = steps[_i];
    enter = function(node, context) {
      var handler, step, _j, _len1, _ref1, _results;
      previousContext = context;
      if (context.options == null) {
        context.options = options;
      }
      _results = [];
      for (_j = 0, _len1 = traversal.length; _j < _len1; _j++) {
        step = traversal[_j];
        if (!(node != null)) {
          continue;
        }
        handler = (_ref1 = step.enter) != null ? _ref1 : (typeof step === 'function' ? step : null);
        if (handler != null) {
          handler(node, context);
          _results.push(node = context.current());
        } else {
          _results.push(void 0);
        }
      }
      return _results;
    };
    exit = function(node, context) {
      var handler, step, _j, _ref1, _results;
      _results = [];
      for (_j = traversal.length - 1; _j >= 0; _j += -1) {
        step = traversal[_j];
        if (!(node != null)) {
          continue;
        }
        handler = (_ref1 = step.exit) != null ? _ref1 : null;
        if (handler != null) {
          handler(node, context);
          _results.push(node = context.current());
        } else {
          _results.push(void 0);
        }
      }
      return _results;
    };
    variable = function(node, context, kind, name) {
      var handler, step, _j, _len1, _ref1, _results;
      _results = [];
      for (_j = 0, _len1 = traversal.length; _j < _len1; _j++) {
        step = traversal[_j];
        if (!(node != null)) {
          continue;
        }
        handler = (_ref1 = step.variable) != null ? _ref1 : null;
        if (handler != null) {
          handler(node, context, kind, name);
          _results.push(node = context.current());
        } else {
          _results.push(void 0);
        }
      }
      return _results;
    };
    traverse(program, enter, exit, variable, previousContext);
  }
  return program;
};

  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/compiler/postprocessor',_ion_compiler_postprocessor_);
    else
      _ion_compiler_postprocessor_.call(this, module, exports, require);
  }
  else {
    _ion_compiler_postprocessor_.call(this);
  }
}).call(this)
void (function(){var _ion_compiler_preprocessor_ = function(module,exports,require){var common, fixSourceLocation, fixSourceLocations, getSpace, preprocess;

common = require('./common');

getSpace = function(size) {
  var i, result, _i;
  result = [];
  for (i = _i = 0; 0 <= size ? _i < size : _i > size; i = 0 <= size ? ++_i : --_i) {
    result.push(" ");
  }
  return result.join("");
};

exports.isMarkdownCommented = function(source) {
  return /(\n|^)[^\s\n][^\n]*\n(\s*\n)+\s+[^\s\n]/.test(source);
};

exports.fixSourceLocation = fixSourceLocation = function(location, sourceMapping, source) {
  var _ref;
  if (!location.fixed) {
    location.fixed = true;
    location.line = sourceMapping[location.line - 1] + 1;
    location.column += (_ref = sourceMapping.columnOffset) != null ? _ref : 0;
    return location.source != null ? location.source : location.source = source;
  }
};

exports.fixSourceLocations = fixSourceLocations = function(program, sourceMapping, source) {
  require('./traverseAst').traverse(program, function(node) {
    var _ref, _ref1;
    if (((_ref = node.loc) != null ? _ref.start : void 0) != null) {
      fixSourceLocation(node.loc.start, sourceMapping, source);
    }
    if (((_ref1 = node.loc) != null ? _ref1.end : void 0) != null) {
      return fixSourceLocation(node.loc.end, sourceMapping, source);
    }
  });
  return program;
};

exports.preprocess = preprocess = function(source, sourceMapping) {
  var baseIndent, comment, indent, indentStack, index, isEmpty, isMarkdownCommented, line, lines, nonCommentCount, outdent, output, totalIndent, writeLine, _i, _len;
  isMarkdownCommented = false;
  baseIndent = isMarkdownCommented ? 1 : 0;
  totalIndent = 0;
  indentStack = [];
  lines = common.splitLines(source);
  nonCommentCount = 0;
  writeLine = function(line, inputIndex) {
    var trimmed;
    if (inputIndex != null) {
      if (sourceMapping != null) {
        sourceMapping[output.length] = inputIndex;
      }
    }
    trimmed = line.trim();
    if (trimmed.length > 0 && line.trim()[0] !== '#') {
      nonCommentCount++;
    }
    return output.push(line);
  };
  outdent = function(inputIndex) {
    var _ref;
    indentStack.pop();
    totalIndent = (_ref = indentStack[indentStack.length - 1]) != null ? _ref : 0;
    if (totalIndent >= baseIndent) {
      return writeLine(getSpace(totalIndent) + common.outdentToken, inputIndex);
    }
  };
  output = [];
  for (index = _i = 0, _len = lines.length; _i < _len; index = ++_i) {
    line = lines[index];
    indent = common.getIndent(line);
    isEmpty = line.trim().length === 0;
    if (!isEmpty) {
      if (indent > totalIndent) {
        if (totalIndent >= baseIndent) {
          writeLine(getSpace(totalIndent) + common.indentToken, index);
        }
        totalIndent = indent;
        indentStack.push(indent);
      } else {
        while (indent < totalIndent) {
          outdent(index);
        }
      }
    }
    comment = isMarkdownCommented && indent === 0 && !isEmpty;
    if (!comment) {
      writeLine(line, index);
    }
  }
  while (indentStack.length > 0) {
    outdent(lines.length);
  }
  if (nonCommentCount === 0) {
    return "";
  } else {
    return common.unindentString(common.joinLines(output), sourceMapping);
  }
};

  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/compiler/preprocessor',_ion_compiler_preprocessor_);
    else
      _ion_compiler_preprocessor_.call(this, module, exports, require);
  }
  else {
    _ion_compiler_preprocessor_.call(this);
  }
}).call(this)
void (function(){var _ion_compiler_traverse_ = function(module,exports,require){exports.traverse = function(graph, enterCallback, exitCallback) {
  var context, removed, result, skip, traverseNode;
  result = graph;
  skip = false;
  removed = 0;
  context = {
    path: [],
    ancestors: [],
    skip: function() {
      return skip = true;
    },
    key: function() {
      return this.path[this.path.length - 1];
    },
    parent: function() {
      return this.ancestors[this.ancestors.length - 1];
    },
    remove: function(node) {
      var index, parent;
      if (node == null) {
        throw new Error("You must specify the node to remove");
      }
      parent = this.parent();
      if (Array.isArray(parent)) {
        index = parent.indexOf(node);
        parent.splice(index, 1);
        return removed++;
      } else {
        return delete parent[this.key()];
      }
    },
    insertAfter: function(node) {
      var parent;
      parent = this.parent();
      if (!Array.isArray(parent)) {
        throw new Error("Parent must be an array");
      }
      return parent.splice(Number(this.key()) + 1, 0, node);
    },
    replace: function(value) {
      var parent;
      if (value === void 0) {
        throw new Error("You must specify a replacement value");
      }
      parent = this.parent();
      if (parent != null) {
        return parent[this.key()] = value;
      } else {
        return result = value;
      }
    },
    previous: function() {
      var _ref;
      return (_ref = this.parent()) != null ? _ref[this.key() - 1] : void 0;
    },
    next: function() {
      var _ref;
      return (_ref = this.parent()) != null ? _ref[this.key() + 1] : void 0;
    },
    current: function() {
      var parent;
      parent = this.parent();
      if (parent != null) {
        return parent[this.key()];
      } else {
        return result;
      }
    }
  };
  traverseNode = function(node) {
    var index, key, newNode, value;
    if ((node != null) && typeof node === 'object') {
      if (typeof enterCallback === "function") {
        enterCallback(node, context);
      }
      if (skip) {
        skip = false;
      } else {
        while (node !== (newNode = context.current())) {
          if (typeof exitCallback === "function") {
            exitCallback(node, context);
          }
          node = newNode;
          if (node != null) {
            if (typeof enterCallback === "function") {
              enterCallback(node, context);
            }
          } else {
            break;
          }
        }
        if ((node != null) && typeof node === 'object') {
          context.ancestors.push(node);
          if (Array.isArray(node)) {
            index = 0;
            while (index < node.length) {
              value = node[index];
              context.path.push(index);
              traverseNode(value);
              context.path.pop();
              index++;
              if (removed > 0) {
                index -= removed;
                removed = 0;
              }
            }
          } else {
            for (key in node) {
              value = node[key];
              context.path.push(key);
              traverseNode(value);
              context.path.pop();
            }
          }
          context.ancestors.pop();
        }
      }
      if (node != null) {
        return typeof exitCallback === "function" ? exitCallback(node, context) : void 0;
      }
    }
  };
  traverseNode(graph);
  return result;
};

exports.test = function() {
  var graph;
  graph = {
    id: 'root',
    alpha: 1,
    beta: {
      id: 'beta',
      charlie: 2,
      delta: 3
    },
    echo: {
      id: 'echo',
      foxtrot: 1
    }
  };
  if (graph !== exports.traverse(graph, function() {})) {
    throw new Error("traverse should have returned graph");
  }
  if (2 !== exports.traverse(graph, function(node, context) {
    return context.replace(2);
  })) {
    throw new Error("traverse should have returned 2");
  }
};

  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/compiler/traverse',_ion_compiler_traverse_);
    else
      _ion_compiler_traverse_.call(this, module, exports, require);
  }
  else {
    _ion_compiler_traverse_.call(this);
  }
}).call(this)
void (function(){var _ion_compiler_traverseAst_ = function(module,exports,require){var addStatement, basicTraverse, nodes, trackVariableDeclaration, trackVariableDeclarations;

basicTraverse = require('./traverse');

nodes = require('./nodes');

addStatement = require("./astFunctions").addStatement;

trackVariableDeclaration = function(context, node, kind, name) {
  var scope, variable;
  if (name == null) {
    name = node.name;
  }
  scope = context.scope();
  if (scope == null) {
    return;
  }
  variable = {
    kind: kind,
    id: {
      type: 'Identifier',
      name: name
    },
    name: name,
    node: node,
    scope: scope
  };
  if (typeof context.variableCallback === "function") {
    context.variableCallback(variable, context);
  }
  return scope.variables[name] = variable;
};

trackVariableDeclarations = function(context, node, kind) {
  var declarator, item, _i, _j, _len, _len1, _ref, _results, _results1;
  if (kind == null) {
    kind = 'let';
  }
  if (Array.isArray(node)) {
    _results = [];
    for (_i = 0, _len = node.length; _i < _len; _i++) {
      item = node[_i];
      _results.push(trackVariableDeclarations(context, item, kind));
    }
    return _results;
  } else {
    if (node.type === 'FunctionDeclaration') {
      kind = 'const';
      if (node.id != null) {
        return trackVariableDeclarations(context, node.id, kind);
      }
    } else if (node.type === 'VariableDeclaration') {
      kind = node.kind;
      _ref = node.declarations;
      _results1 = [];
      for (_j = 0, _len1 = _ref.length; _j < _len1; _j++) {
        declarator = _ref[_j];
        _results1.push(trackVariableDeclarations(context, declarator.id, kind));
      }
      return _results1;
    } else if (node.type === "Identifier") {
      return trackVariableDeclaration(context, node, kind);
    } else if (node.type === "ObjectPattern") {
      return basicTraverse.traverse(node, function(child, newContext) {
        var name, _ref1;
        if ((child.key != null) && (child.value != null)) {
          name = (_ref1 = child.key.value) != null ? _ref1 : child.key.name;
          trackVariableDeclaration(context, child, kind, name);
          return newContext.skip();
        }
      });
    } else if (node.type === "ArrayPattern") {
      return basicTraverse.traverse(node, function(child, newContext) {
        if (child.type === 'Identifier') {
          trackVariableDeclaration(context, child, kind);
          return newContext.skip();
        }
      });
    }
  }
};

exports.traverse = function(program, enterCallback, exitCallback, variableCallback, previousContext) {
  var ourEnter, ourExit;
  ourEnter = function(node, context) {
    var nodeInfo, _ref, _ref1, _ref2;
    if (context.variableCallback == null) {
      context.variableCallback = variableCallback;
    }
    if (context.scopeStack == null) {
      context.scopeStack = [];
    }
    if (context.scope == null) {
      context.scope = function() {
        return this.scopeStack[this.scopeStack.length - 1];
      };
    }
    if (context.ancestorNodes == null) {
      context.ancestorNodes = [];
    }
    if (context.getAncestor == null) {
      context.getAncestor = function(predicate) {
        var ancestor, _i, _ref;
        _ref = this.ancestorNodes;
        for (_i = _ref.length - 1; _i >= 0; _i += -1) {
          ancestor = _ref[_i];
          if (predicate(ancestor)) {
            return ancestor;
          }
        }
        return null;
      };
    }
    if (context.rootNode == null) {
      context.rootNode = function() {
        return this.ancestorNodes[0];
      };
    }
    if (context.parentNode == null) {
      context.parentNode = function() {
        return this.ancestorNodes[this.ancestorNodes.length - 1];
      };
    }
    if (context.parentScope == null) {
      context.parentScope = function() {
        return this.scopeStack[this.scopeStack.length - 2];
      };
    }
    if (context.parentReactive == null) {
      context.parentReactive = function() {
        return this._reactiveStack[this._reactiveStack.length - 1];
      };
    }
    if (context.isParentBlock == null) {
      context.isParentBlock = function() {
        var _ref, _ref1, _ref2;
        return (_ref = (_ref1 = nodes[(_ref2 = this.parentNode()) != null ? _ref2.type : void 0]) != null ? _ref1.isBlock : void 0) != null ? _ref : false;
      };
    }
    if (context.getVariableInfo == null) {
      context.getVariableInfo = function(id) {
        return this.scope().variables[id];
      };
    }
    if (context._variableCounts == null) {
      context._variableCounts = (_ref = previousContext != null ? previousContext._variableCounts : void 0) != null ? _ref : {};
    }
    if (context.getNewInternalIdentifier == null) {
      context.getNewInternalIdentifier = function(prefix) {
        var count, counts, name;
        if (prefix == null) {
          prefix = '_ref';
        }
        counts = this._variableCounts;
        count = counts[prefix] != null ? counts[prefix] : counts[prefix] = 1;
        counts[prefix]++;
        name = count === 1 ? prefix : prefix + count;
        return {
          type: 'Identifier',
          name: name
        };
      };
    }
    if (context.getAncestorChildOf == null) {
      context.getAncestorChildOf = function(ancestor) {
        var index, _ref1;
        index = this.ancestorNodes.indexOf(ancestor);
        if (index >= 0) {
          return (_ref1 = this.ancestorNodes[index + 1]) != null ? _ref1 : this.current();
        } else {
          return void 0;
        }
      };
    }
    if (context.getSharedVariableId == null) {
      context.getSharedVariableId = function(name) {
        var _ref1, _ref2;
        return (_ref1 = (_ref2 = this.getVariableInfo(name)) != null ? _ref2.id : void 0) != null ? _ref1 : this.addVariable({
          id: name,
          offset: Number.MIN_VALUE
        });
      };
    }
    if (context.addStatement == null) {
      context.addStatement = function(statement, offset, addToNode) {
        var _ref1;
        if (typeof statement === 'number') {
          _ref1 = [offset, statement], statement = _ref1[0], offset = _ref1[1];
        }
        if (addToNode == null) {
          addToNode = this.scope().node;
        }
        trackVariableDeclarations(context, statement);
        return addStatement(addToNode, statement, this.getAncestorChildOf(addToNode), offset);
      };
    }
    if (context.addVariable == null) {
      context.addVariable = function(options) {
        var variable;
        variable = this.getVariable(options);
        this.addStatement(variable, options.offset);
        return variable.declarations[0].id;
      };
    }
    if (context.getVariable == null) {
      context.getVariable = function(options) {
        var variable;
        if (options == null) {
          options = {};
        }
        if (typeof options.id === 'string') {
          options.id = {
            type: 'Identifier',
            name: options.id
          };
        }
        if (options.id == null) {
          options.id = this.getNewInternalIdentifier(options.prefix);
        }
        if (options.kind == null) {
          options.kind = 'let';
        }
        variable = {
          type: "VariableDeclaration",
          declarations: [
            {
              type: "VariableDeclarator",
              id: options.id,
              init: options.init
            }
          ],
          kind: options.kind
        };
        return variable;
      };
    }
    context.error = function(message, node) {
      var e, _ref1, _ref2, _ref3, _ref4, _ref5, _ref6, _ref7, _ref8;
      if (node == null) {
        node = this.current();
      }
      e = new Error(message);
      e.line = (_ref1 = node.loc) != null ? (_ref2 = _ref1.start) != null ? _ref2.line : void 0 : void 0;
      e.column = ((_ref3 = node.loc) != null ? (_ref4 = _ref3.start) != null ? _ref4.column : void 0 : void 0) + 1;
      e.lineEnd = (_ref5 = node.loc) != null ? (_ref6 = _ref5.end) != null ? _ref6.line : void 0 : void 0;
      e.columnEnd = ((_ref7 = node.loc) != null ? (_ref8 = _ref7.end) != null ? _ref8.column : void 0 : void 0) + 1;
      return e;
    };
    if (node.type != null) {
      nodeInfo = nodes[node.type];
      if ((nodeInfo != null ? nodeInfo.reactive : void 0) != null) {
        (context._reactiveStack != null ? context._reactiveStack : context._reactiveStack = []).push(context.reactive);
        context.reactive = nodeInfo.reactive;
      }
      if (nodeInfo != null ? nodeInfo.newScope : void 0) {
        context.scopeStack.push({
          variables: Object.create((_ref1 = (_ref2 = context.scope()) != null ? _ref2.variables : void 0) != null ? _ref1 : {}),
          node: node
        });
      }
      if (Array.isArray(node.body)) {
        trackVariableDeclarations(context, node.body);
      }
      if (nodeInfo != null ? nodeInfo.isFunction : void 0) {
        trackVariableDeclarations(context, node.params, nodeInfo.paramKind);
      } else if (node.type === 'ForInStatement' || node.type === 'ForOfStatement') {
        trackVariableDeclarations(context, node.left);
      } else if (node.type === 'ObjectExpression') {
        trackVariableDeclarations(context, node.properties);
      }
      if (typeof enterCallback === "function") {
        enterCallback(node, context);
      }
      return context.ancestorNodes.push(node);
    }
  };
  ourExit = function(node, context) {
    var nodeInfo;
    if (node.type != null) {
      nodeInfo = nodes[node.type];
      if ((nodeInfo != null ? nodeInfo.reactive : void 0) != null) {
        context.reactive = context._reactiveStack.pop();
      }
      context.ancestorNodes.pop();
      if (typeof exitCallback === "function") {
        exitCallback(node, context);
      }
      if (nodeInfo != null ? nodeInfo.newScope : void 0) {
        return context.scopeStack.pop();
      }
    }
  };
  return basicTraverse.traverse(program, ourEnter, ourExit);
};

  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/compiler/traverseAst',_ion_compiler_traverseAst_);
    else
      _ion_compiler_traverseAst_.call(this, module, exports, require);
  }
  else {
    _ion_compiler_traverseAst_.call(this);
  }
}).call(this)
void (function(){var _ion_es6_Array_ = function(module,exports,require){'use strict';
if (!(Array.prototype.add != null)) {
    Object.defineProperty(Array.prototype, 'add', {
        value: function (item, index) {
            this.splice(index, 0, item);
        }
    });
}
if (!(Array.prototype.remove != null)) {
    Object.defineProperty(Array.prototype, 'remove', {
        value: function () {
            for (var _i = 0; _i < arguments.length; _i++) {
                var item = arguments[_i];
                var index = this.lastIndexOf(item);
                if (index >= 0) {
                    this.splice(index, 1);
                }
            }
        }
    });
}
if (!(Array.prototype.contains != null)) {
    Object.defineProperty(Array.prototype, 'contains', {
        value: function (item) {
            return this.indexOf(item) >= 0;
        }
    });
}
if (!(Array.prototype.includes != null)) {
    Object.defineProperty(Array.prototype, 'includes', {
        value: function (item) {
            return this.indexOf(item) >= 0;
        }
    });
}
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/es6/Array',_ion_es6_Array_);
    else
      _ion_es6_Array_.call(this, module, exports, require);
  }
  else {
    _ion_es6_Array_.call(this);
  }
}).call(this)
void (function(){var _ion_es6_CustomEvent_ = function(module,exports,require){

if (global.ActiveXObject || "ActiveXObject" in global) {
    (function(){
        console.warn("Shimming CustomEvent")
        function CustomEvent ( event, params ) {
            params = params || { bubbles: false, cancelable: false, detail: undefined };
            var evt = document.createEvent( 'CustomEvent' );
            evt.initCustomEvent( event, params.bubbles, params.cancelable, params.detail );
            return evt;
        }
        CustomEvent.prototype = window.Event.prototype;
        window.CustomEvent = CustomEvent;
    })()
}
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/es6/CustomEvent',_ion_es6_CustomEvent_);
    else
      _ion_es6_CustomEvent_.call(this, module, exports, require);
  }
  else {
    _ion_es6_CustomEvent_.call(this);
  }
}).call(this)
void (function(){var _ion_es6_Element_closest_ = function(module,exports,require){if (global.window && window.Element && !Element.prototype.closest) {
    Element.prototype.closest = 
    function(s) {
        var matches = (this.document || this.ownerDocument).querySelectorAll(s),
            i,
            el = this;
        do {
            i = matches.length;
            while (--i >= 0 && matches.item(i) !== el) {};
        } while ((i < 0) && (el = el.parentElement)); 
        return el;
    };
}
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/es6/Element.closest',_ion_es6_Element_closest_);
    else
      _ion_es6_Element_closest_.call(this, module, exports, require);
  }
  else {
    _ion_es6_Element_closest_.call(this);
  }
}).call(this)
void (function(){var _ion_es6_Function_ = function(module,exports,require){
// Fix Function#name on browsers that do not support it (IE):
if (!(function f() {}).name) {
    Object.defineProperty(Function.prototype, 'name', {
        get: function() {
            var name = this.toString().match(/^\s*function\s*(\S*)\s*\(/)[1]
            Object.defineProperty(this, 'name', {value:name})
            return name
        }
    });
}

  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/es6/Function',_ion_es6_Function_);
    else
      _ion_es6_Function_.call(this, module, exports, require);
  }
  else {
    _ion_es6_Function_.call(this);
  }
}).call(this)
void (function(){var _ion_es6_Map_ = function(module,exports,require){'use strict';
var ion = null;
var uniqueCounter = 0;
var idName = '_Map_id_';
var getId = function (key) {
    if (!(key != null)) {
        return String(key);
    }
    if (typeof key === 'string' || typeof key === 'number' || typeof key === 'boolean') {
        return '_' + key;
    }
    var id = key[idName];
    if (!(id != null)) {
        var def = Object.getOwnPropertyDescriptor(key, idName);
        if (def != null) {
            id = def.value;
        } else {
            id = ++uniqueCounter;
            Object.defineProperty(key, idName, { value: id });
        }
    }
    return id;
};
function MapShim(pairs) {
    if (pairs != null) {
        throw new Error('Don\'t add items in the constructor, IE implementation of Set breaks this');
    }
    var lookup = {};
    var keys = [];
    var methods = {
            get: function (key) {
                return lookup[getId(key)];
            },
            set: function (key, value) {
                var id = getId(key);
                if (!lookup.hasOwnProperty(id)) {
                    keys.push(key);
                }
                lookup[id] = value;
                return value;
            },
            has: function (key) {
                var id = getId(key);
                return lookup.hasOwnProperty(id);
            },
            delete: function (key) {
                var id = getId(key);
                keys.remove(key);
                delete lookup[id];
            },
            clear: function () {
                lookup = {};
                keys = [];
            },
            forEach: function (callback, thisArg) {
                for (var _i = 0; _i < keys.length; _i++) {
                    var key = keys[_i];
                    var value = this.get(key);
                    callback.call(thisArg, value, key, this);
                }
            }
        };
    for (var key in methods) {
        var value = methods[key];
        Object.defineProperty(this, key, { value: value });
    }
}
if (!((global.Map != null ? global.Map.prototype.forEach : void 0) != null)) {
    if (global.window) {
        console.warn('Shimming Map');
    }
    global.Map = MapShim;
}
var test = exports.test = function () {
        var Map = global.Map;
        var map = new Map();
        map.set('a', 1);
        map.set('b', 2);
        if (!(Object.keys(map).length === 0))
            throw new Error('Assertion Failed: (Object.keys(map).length is 0)');
        if (!map.has('a'))
            throw new Error('Assertion Failed: (map.has(\'a\'))');
        if (!!map.has('c'))
            throw new Error('Assertion Failed: (not map.has(\'c\'))');
        if (!(map.get('a') === 1))
            throw new Error('Assertion Failed: (map.get(\'a\') is 1)');
        if (!(map.get('b') === 2))
            throw new Error('Assertion Failed: (map.get(\'b\') is 2)');
        if (!(map.get('c') === void 0))
            throw new Error('Assertion Failed: (map.get(\'c\') is undefined)');
        var mykey1 = {};
        map.set(mykey1, 'one');
        if (!(Object.keys(mykey1).length === 0))
            throw new Error('Assertion Failed: (Object.keys(mykey1).length is 0)');
        if (!(map.get(mykey1) === 'one'))
            throw new Error('Assertion Failed: (map.get(mykey1) is "one")');
    };
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/es6/Map',_ion_es6_Map_);
    else
      _ion_es6_Map_.call(this, module, exports, require);
  }
  else {
    _ion_es6_Map_.call(this);
  }
}).call(this)
void (function(){var _ion_es6_Object_ = function(module,exports,require){'use strict';
if (!(Object.is != null)) {
    Object.defineProperty(Object, 'is', {
        value: function (a, b) {
            if (a === b) {
                if (a === 0) {
                    return 1 / a === 1 / b;
                }
                return true;
            }
            return a !== a && b !== b;
        }
    });
}
Object.isEmpty = function (object) {
    if (!(object != null)) {
        return true;
    }
    if (typeof object === 'string') {
        return object.trim().length === 0;
    }
    if (Array.isArray(object)) {
        return object.length === 0;
    }
    if (object.constructor === Object) {
        for (var key in object) {
            return false;
        }
        return true;
    }
    return false;
};
var test = exports.test = function () {
        if (!Object.isEmpty(null))
            throw new Error('Assertion Failed: (Object.isEmpty(null))');
        if (!Object.isEmpty())
            throw new Error('Assertion Failed: (Object.isEmpty())');
        if (!Object.isEmpty(void 0))
            throw new Error('Assertion Failed: (Object.isEmpty(undefined))');
        if (!Object.isEmpty([]))
            throw new Error('Assertion Failed: (Object.isEmpty([]))');
        if (!Object.isEmpty({}))
            throw new Error('Assertion Failed: (Object.isEmpty({}))');
        if (!Object.isEmpty(''))
            throw new Error('Assertion Failed: (Object.isEmpty(""))');
        if (!Object.isEmpty(' '))
            throw new Error('Assertion Failed: (Object.isEmpty(" "))');
        if (!!Object.isEmpty([1]))
            throw new Error('Assertion Failed: (not Object.isEmpty([1]))');
        if (!!Object.isEmpty({ x: 1 }))
            throw new Error('Assertion Failed: (not Object.isEmpty({x:1}))');
        if (!!Object.isEmpty('h'))
            throw new Error('Assertion Failed: (not Object.isEmpty("h"))');
        if (!!Object.isEmpty(true))
            throw new Error('Assertion Failed: (not Object.isEmpty(true))');
        if (!!Object.isEmpty(false))
            throw new Error('Assertion Failed: (not Object.isEmpty(false))');
        if (!!Object.isEmpty(45))
            throw new Error('Assertion Failed: (not Object.isEmpty(45))');
        if (!!Object.isEmpty(new Date()))
            throw new Error('Assertion Failed: (not Object.isEmpty(new Date()))');
    };
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/es6/Object',_ion_es6_Object_);
    else
      _ion_es6_Object_.call(this, module, exports, require);
  }
  else {
    _ion_es6_Object_.call(this);
  }
}).call(this)
void (function(){var _ion_es6_Object_observe_ = function(module,exports,require){'use strict';
var observerMap = new Map(), nextCheckMap = new Map(), changedObjects = new Map();
global.observerMap = observerMap;
var clone = function (object, properties) {
        if (properties != null) {
            var _ref2 = {};
            for (var key in properties) {
                _ref2[key] = object[key];
            }
            return _ref2;
        } else {
            var _ref3 = {};
            for (var key in object) {
                var value = object[key];
                _ref3[key] = value;
            }
            return _ref3;
        }
    }, getChanges = function (oldValue, newValue, properties) {
        var changes = null;
        var change = function (type, name, oldValue, object) {
            changes = changes != null ? changes : [];
            changes.push({
                type: type,
                name: name,
                oldValue: oldValue,
                object: object
            });
        };
        var checkForChange = function (property) {
            if (newValue.constructor === Object) {
                if (oldValue.hasOwnProperty(name)) {
                    var oldPropertyValue = oldValue[name];
                    if (!newValue.hasOwnProperty(name)) {
                        if (oldPropertyValue !== void 0) {
                            change('delete', name, oldPropertyValue, newValue);
                        }
                    } else {
                        var newPropertyValue = newValue[name];
                        if (!Object.is(newPropertyValue, oldPropertyValue)) {
                            change('update', name, oldPropertyValue, newValue);
                        }
                    }
                } else if (newValue.hasOwnProperty(name)) {
                    change('add', name, void 0, newValue);
                }
            } else {
                var oldPropertyValue = oldValue[name];
                var newPropertyValue = newValue[name];
                if (!Object.is(newPropertyValue, oldPropertyValue)) {
                    change('update', name, oldPropertyValue, newValue);
                }
            }
        };
        if (properties != null) {
            for (var name in properties) {
                checkForChange(name);
            }
        } else {
            for (var name in oldValue) {
                checkForChange(name);
            }
            for (var name in newValue) {
                if (!oldValue.hasOwnProperty(name)) {
                    checkForChange(name);
                }
            }
        }
        return changes;
    };
var observe = exports.observe = function (object, callback, property, edge) {
        if (Object.isFrozen(object)) {
            return;
        }
        var meta = observerMap.get(object);
        if (!(meta != null)) {
            var _ref4 = {};
            _ref4[property] = 0;
            meta = {
                object: object,
                properties: {},
                all: 0,
                clone: clone(object, property ? _ref4 : null),
                callbacks: []
            };
            observerMap.set(object, meta);
        }
        if (property != null) {
            meta.properties[property] = meta.properties[property] != null ? meta.properties[property] : 0;
            meta.properties[property]++;
        } else {
            meta.all++;
        }
        meta.callbacks.push(callback);
    }, unobserve = exports.unobserve = function (object, callback, property) {
        var meta = observerMap.get(object);
        if (meta != null) {
            meta.callbacks.remove(callback);
            if (meta.callbacks.length === 0) {
                observerMap.delete(object);
            }
            if (property != null) {
                meta.properties[property]--;
                if (meta.properties[property] === 0) {
                    delete meta.properties[property];
                }
            } else {
                meta.all--;
            }
        }
    }, nextCheck = exports.nextCheck = function (fn) {
        nextCheckMap.set(fn, fn);
    }, changed = exports.changed = function (obj) {
        for (var _i = 0; _i < arguments.length; _i++) {
            var object = arguments[_i];
            changedObjects.set(object, object);
        }
    }, checkForChanges = exports.checkForChanges = function (source) {
        var changes;
        var maxCycles = 100;
        for (var i = 0; i < maxCycles; i++) {
            var changeCount = 0;
            var check = function (meta) {
                var properties = meta.all > 0 ? null : meta.properties;
                changes = getChanges(meta.clone, meta.object, properties);
                if (changes != null) {
                    changeCount++;
                    meta.clone = clone(meta.object, properties);
                    {
                        var _ref = meta.callbacks.slice(0);
                        for (var _i2 = 0; _i2 < _ref.length; _i2++) {
                            var callback = _ref[_i2];
                            callback(changes);
                        }
                    }
                }
            };
            var metas = Array.from(observerMap.values());
            metas.reverse();
            metas.forEach(check);
            var pendingChecks = nextCheckMap.size;
            var currentCheckMap = nextCheckMap;
            nextCheckMap = new Map();
            currentCheckMap.forEach(function (callback) {
                callback();
            });
            currentCheckMap.clear();
            if (changeCount === 0 && pendingChecks === 0) {
                return;
            }
        }
        throw new Error('Circular Object.observe dependency');
    }, test = exports.test = function () {
        var object = {
                a: 1,
                b: {
                    c: 2,
                    d: 3
                }
            };
        var changes;
        var handler = function (c) {
            changes = c;
        };
        observe(object, handler);
        object.a = 2;
        delete object.b;
        object.c = 5;
        changed(object);
        checkForChanges();
        if (!(JSON.stringify(changes) === JSON.stringify([
                {
                    'type': 'update',
                    'name': 'a',
                    'oldValue': 1,
                    'object': {
                        'a': 2,
                        'c': 5
                    }
                },
                {
                    'type': 'delete',
                    'name': 'b',
                    'oldValue': {
                        'c': 2,
                        'd': 3
                    },
                    'object': {
                        'a': 2,
                        'c': 5
                    }
                },
                {
                    'type': 'add',
                    'name': 'c',
                    'object': {
                        'a': 2,
                        'c': 5
                    }
                }
            ])))
            throw new Error('Assertion Failed: (JSON.stringify(changes) is JSON.stringify([{"type":"update","name":"a","oldValue":1,"object":{"a":2,"c":5}},{"type":"delete","name":"b","oldValue":{"c":2,"d":3},"object":{"a":2,"c":5}},{"type":"add","name":"c","object":{"a":2,"c":5}}]))');
        unobserve(object, handler);
    };
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/es6/Object.observe',_ion_es6_Object_observe_);
    else
      _ion_es6_Object_observe_.call(this, module, exports, require);
  }
  else {
    _ion_es6_Object_observe_.call(this);
  }
}).call(this)
void (function(){var _ion_es6_Set_ = function(module,exports,require){'use strict';
var ion = require('../');
require('./Map');
function SetShim(items) {
    if (items != null) {
        throw new Error('Don\'t add items in the constructor, IE implementation of Set breaks this');
    }
    var map = new Map();
    var methods = {
            has: function (key) {
                return map.has(key);
            },
            delete: function (key) {
                return map.delete(key);
            },
            add: function (key) {
                return map.set(key, true);
            },
            forEach: function (callback, thisArg) {
                map.forEach(ion.bind(function (value, key) {
                    callback.call(thisArg, key, this);
                }, this));
            }
        };
    for (var key in methods) {
        var value = methods[key];
        Object.defineProperty(this, key, { value: value });
    }
}
if (!(global.Set != null) || !(Set.prototype.forEach != null)) {
    if (global.window) {
        console.warn('Shimming Set');
    }
    global.Set = SetShim;
}
var test = exports.test = function () {
        var Set = global.Set;
        var a = {};
        var b = function () {
        };
        var set = new Set();
        set.add(a);
        set.add(b);
        if (!set.has(a))
            throw new Error('Assertion Failed: (set.has(a))');
        if (!set.has(b))
            throw new Error('Assertion Failed: (set.has(b))');
        set.delete(b);
        if (!!set.has(b))
            throw new Error('Assertion Failed: (not set.has(b))');
        set.add(b);
        if (!set.has(b))
            throw new Error('Assertion Failed: (set.has(b))');
    };
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/es6/Set',_ion_es6_Set_);
    else
      _ion_es6_Set_.call(this, module, exports, require);
  }
  else {
    _ion_es6_Set_.call(this);
  }
}).call(this)
void (function(){var _ion_es6_String_ = function(module,exports,require){// if (!String.prototype.endsWith) {
//     Object.defineProperty(String.prototype, 'endsWith', {
//         value: function (searchString, position) {
//             position = position || this.length;
//             position = position - searchString.length;
//             var lastIndex = this.lastIndexOf(searchString);
//             return lastIndex !== -1 && lastIndex === position;
//         }
//     });
// }

// if (!String.prototype.startsWith) {
//   Object.defineProperty(String.prototype, 'startsWith', {
//     value: function (searchString, position) {
//       position = position || 0;
//       return this.indexOf(searchString, position) === position;
//     }
//   });
// }

// deprecated in favor of includes
if (!String.prototype.contains ) {
    String.prototype.contains = function() {
        return this.indexOf(arguments) !== -1;
    };
}

if (!String.prototype.includes ) {
    String.prototype.includes = function() {
        return this.indexOf(arguments) !== -1;
    };
}
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/es6/String',_ion_es6_String_);
    else
      _ion_es6_String_.call(this, module, exports, require);
  }
  else {
    _ion_es6_String_.call(this);
  }
}).call(this)
void (function(){var _ion_es6_index_ = function(module,exports,require){'use strict';
require('./String');
require('./Map');
require('./Set');
require('./Object');
require('./Function');
require('./Array');
require('./CustomEvent');
require('./Element.closest');
require('./sugar').extend();
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/es6/index',_ion_es6_index_);
    else
      _ion_es6_index_.call(this, module, exports, require);
  }
  else {
    _ion_es6_index_.call(this);
  }
}).call(this)
void (function(){var _ion_es6_sugar_ = function(module,exports,require){/*
 *  Sugar Custom 2017.04.21
 *
 *  Freely distributable and licensed under the MIT-style license.
 *  Copyright (c)  Andrew Plummer
 *  https://sugarjs.com/
 *
 * ---------------------------- */
(function() {
  'use strict';

  /***
   * @module Core
   * @description Core functionality including the ability to define methods and
   *              extend onto natives.
   *
   ***/

  // The global to export.
  var Sugar;

  // The name of Sugar in the global namespace.
  var SUGAR_GLOBAL = 'Sugar';

  // Natives available on initialization. Letting Object go first to ensure its
  // global is set by the time the rest are checking for chainable Object methods.
  var NATIVE_NAMES = 'Object Number String Array Date RegExp Function';

  // Static method flag
  var STATIC   = 0x1;

  // Instance method flag
  var INSTANCE = 0x2;

  // IE8 has a broken defineProperty but no defineProperties so this saves a try/catch.
  var PROPERTY_DESCRIPTOR_SUPPORT = !!(Object.defineProperty && Object.defineProperties);

  // The global context. Rhino uses a different "global" keyword so
  // do an extra check to be sure that it's actually the global context.
  var globalContext = typeof global !== 'undefined' && global.Object === Object ? global : this;

  // Is the environment node?
  var hasExports = typeof module !== 'undefined' && module.exports;

  // Whether object instance methods can be mapped to the prototype.
  var allowObjectPrototype = false;

  // A map from Array to SugarArray.
  var namespacesByName = {};

  // A map from [object Object] to namespace.
  var namespacesByClassString = {};

  // Defining properties.
  var defineProperty = PROPERTY_DESCRIPTOR_SUPPORT ?  Object.defineProperty : definePropertyShim;

  // A default chainable class for unknown types.
  var DefaultChainable = getNewChainableClass('Chainable');


  // Global methods

  function setupGlobal() {
    Sugar = globalContext[SUGAR_GLOBAL];
    // istanbul ignore if
    if (Sugar) {
      // Reuse already defined Sugar global object.
      return;
    }
    Sugar = function(arg) {
      forEachProperty(Sugar, function(sugarNamespace, name) {
        // Although only the only enumerable properties on the global
        // object are Sugar namespaces, environments that can't set
        // non-enumerable properties will step through the utility methods
        // as well here, so use this check to only allow true namespaces.
        if (hasOwn(namespacesByName, name)) {
          sugarNamespace.extend(arg);
        }
      });
      return Sugar;
    };
    // istanbul ignore else
    if (hasExports) {
      module.exports = Sugar;
    } else {
      try {
        globalContext[SUGAR_GLOBAL] = Sugar;
      } catch (e) {
        // Contexts such as QML have a read-only global context.
      }
    }
    forEachProperty(NATIVE_NAMES.split(' '), function(name) {
      createNamespace(name);
    });
    setGlobalProperties();
  }

  /***
   * @method createNamespace(name)
   * @returns SugarNamespace
   * @namespace Sugar
   * @short Creates a new Sugar namespace.
   * @extra This method is for plugin developers who want to define methods to be
   *        used with natives that Sugar does not handle by default. The new
   *        namespace will appear on the `Sugar` global with all the methods of
   *        normal namespaces, including the ability to define new methods. When
   *        extended, any defined methods will be mapped to `name` in the global
   *        context.
   *
   * @example
   *
   *   Sugar.createNamespace('Boolean');
   *
   * @param {string} name - The namespace name.
   *
   ***/
  function createNamespace(name) {

    // Is the current namespace Object?
    var isObject = name === 'Object';

    // A Sugar namespace is also a chainable class: Sugar.Array, etc.
    var sugarNamespace = getNewChainableClass(name, true);

    /***
     * @method extend([opts])
     * @returns Sugar
     * @namespace Sugar
     * @short Extends Sugar defined methods onto natives.
     * @extra This method can be called on individual namespaces like
     *        `Sugar.Array` or on the `Sugar` global itself, in which case
     *        [opts] will be forwarded to each `extend` call. For more,
     *        see `extending`.
     *
     * @options
     *
     *   methods           An array of method names to explicitly extend.
     *
     *   except            An array of method names or global namespaces (`Array`,
     *                     `String`) to explicitly exclude. Namespaces should be the
     *                     actual global objects, not strings.
     *
     *   namespaces        An array of global namespaces (`Array`, `String`) to
     *                     explicitly extend. Namespaces should be the actual
     *                     global objects, not strings.
     *
     *   enhance           A shortcut to disallow all "enhance" flags at once
     *                     (flags listed below). For more, see `enhanced methods`.
     *                     Default is `true`.
     *
     *   enhanceString     A boolean allowing String enhancements. Default is `true`.
     *
     *   enhanceArray      A boolean allowing Array enhancements. Default is `true`.
     *
     *   objectPrototype   A boolean allowing Sugar to extend Object.prototype
     *                     with instance methods. This option is off by default
     *                     and should generally not be used except with caution.
     *                     For more, see `object methods`.
     *
     * @example
     *
     *   Sugar.Array.extend();
     *   Sugar.extend();
     *
     * @option {Array<string>} [methods]
     * @option {Array<string|NativeConstructor>} [except]
     * @option {Array<NativeConstructor>} [namespaces]
     * @option {boolean} [enhance]
     * @option {boolean} [enhanceString]
     * @option {boolean} [enhanceArray]
     * @option {boolean} [objectPrototype]
     * @param {ExtendOptions} [opts]
     *
     ***
     * @method extend([opts])
     * @returns SugarNamespace
     * @namespace SugarNamespace
     * @short Extends Sugar defined methods for a specific namespace onto natives.
     * @param {ExtendOptions} [opts]
     *
     ***/
    var extend = function (opts) {

      var nativeClass = globalContext[name], nativeProto = nativeClass.prototype;
      var staticMethods = {}, instanceMethods = {}, methodsByName;

      function objectRestricted(name, target) {
        return isObject && target === nativeProto &&
               (!allowObjectPrototype || name === 'get' || name === 'set');
      }

      function arrayOptionExists(field, val) {
        var arr = opts[field];
        if (arr) {
          for (var i = 0, el; el = arr[i]; i++) {
            if (el === val) {
              return true;
            }
          }
        }
        return false;
      }

      function arrayOptionExcludes(field, val) {
        return opts[field] && !arrayOptionExists(field, val);
      }

      function disallowedByFlags(methodName, target, flags) {
        // Disallowing methods by flag currently only applies if methods already
        // exist to avoid enhancing native methods, as aliases should still be
        // extended (i.e. Array#all should still be extended even if Array#every
        // is being disallowed by a flag).
        if (!target[methodName] || !flags) {
          return false;
        }
        for (var i = 0; i < flags.length; i++) {
          if (opts[flags[i]] === false) {
            return true;
          }
        }
      }

      function namespaceIsExcepted() {
        return arrayOptionExists('except', nativeClass) ||
               arrayOptionExcludes('namespaces', nativeClass);
      }

      function methodIsExcepted(methodName) {
        return arrayOptionExists('except', methodName);
      }

      function canExtend(methodName, method, target) {
        return !objectRestricted(methodName, target) &&
               !disallowedByFlags(methodName, target, method.flags) &&
               !methodIsExcepted(methodName);
      }

      opts = opts || {};
      methodsByName = opts.methods;

      if (namespaceIsExcepted()) {
        return;
      } else if (isObject && typeof opts.objectPrototype === 'boolean') {
        // Store "objectPrototype" flag for future reference.
        allowObjectPrototype = opts.objectPrototype;
      }

      forEachProperty(methodsByName || sugarNamespace, function(method, methodName) {
        if (methodsByName) {
          // If we have method names passed in an array,
          // then we need to flip the key and value here
          // and find the method in the Sugar namespace.
          methodName = method;
          method = sugarNamespace[methodName];
        }
        if (hasOwn(method, 'instance') && canExtend(methodName, method, nativeProto)) {
          instanceMethods[methodName] = method.instance;
        }
        if(hasOwn(method, 'static') && canExtend(methodName, method, nativeClass)) {
          staticMethods[methodName] = method;
        }
      });

      // Accessing the extend target each time instead of holding a reference as
      // it may have been overwritten (for example Date by Sinon). Also need to
      // access through the global to allow extension of user-defined namespaces.
      extendNative(nativeClass, staticMethods);
      extendNative(nativeProto, instanceMethods);

      if (!methodsByName) {
        // If there are no method names passed, then
        // all methods in the namespace will be extended
        // to the native. This includes all future defined
        // methods, so add a flag here to check later.
        setProperty(sugarNamespace, 'active', true);
      }
      return sugarNamespace;
    };

    function defineWithOptionCollect(methodName, instance, args) {
      setProperty(sugarNamespace, methodName, function(arg1, arg2, arg3) {
        var opts = collectDefineOptions(arg1, arg2, arg3);
        defineMethods(sugarNamespace, opts.methods, instance, args, opts.last);
        return sugarNamespace;
      });
    }

    /***
     * @method defineStatic(methods)
     * @returns SugarNamespace
     * @namespace SugarNamespace
     * @short Defines static methods on the namespace that can later be extended
     *        onto the native globals.
     * @extra Accepts either a single object mapping names to functions, or name
     *        and function as two arguments. If `extend` was previously called
     *        with no arguments, the method will be immediately mapped to its
     *        native when defined.
     *
     * @example
     *
     *   Sugar.Number.defineStatic({
     *     isOdd: function (num) {
     *       return num % 2 === 1;
     *     }
     *   });
     *
     * @signature defineStatic(methodName, methodFn)
     * @param {Object} methods - Methods to be defined.
     * @param {string} methodName - Name of a single method to be defined.
     * @param {Function} methodFn - Function body of a single method to be defined.
     ***/
    defineWithOptionCollect('defineStatic', STATIC);

    /***
     * @method defineInstance(methods)
     * @returns SugarNamespace
     * @namespace SugarNamespace
     * @short Defines methods on the namespace that can later be extended as
     *        instance methods onto the native prototype.
     * @extra Accepts either a single object mapping names to functions, or name
     *        and function as two arguments. All functions should accept the
     *        native for which they are mapped as their first argument, and should
     *        never refer to `this`. If `extend` was previously called with no
     *        arguments, the method will be immediately mapped to its native when
     *        defined.
     *
     *        Methods cannot accept more than 4 arguments in addition to the
     *        native (5 arguments total). Any additional arguments will not be
     *        mapped. If the method needs to accept unlimited arguments, use
     *        `defineInstanceWithArguments`. Otherwise if more options are
     *        required, use an options object instead.
     *
     * @example
     *
     *   Sugar.Number.defineInstance({
     *     square: function (num) {
     *       return num * num;
     *     }
     *   });
     *
     * @signature defineInstance(methodName, methodFn)
     * @param {Object} methods - Methods to be defined.
     * @param {string} methodName - Name of a single method to be defined.
     * @param {Function} methodFn - Function body of a single method to be defined.
     ***/
    defineWithOptionCollect('defineInstance', INSTANCE);

    /***
     * @method defineInstanceAndStatic(methods)
     * @returns SugarNamespace
     * @namespace SugarNamespace
     * @short A shortcut to define both static and instance methods on the namespace.
     * @extra This method is intended for use with `Object` instance methods. Sugar
     *        will not map any methods to `Object.prototype` by default, so defining
     *        instance methods as static helps facilitate their proper use.
     *
     * @example
     *
     *   Sugar.Object.defineInstanceAndStatic({
     *     isAwesome: function (obj) {
     *       // check if obj is awesome!
     *     }
     *   });
     *
     * @signature defineInstanceAndStatic(methodName, methodFn)
     * @param {Object} methods - Methods to be defined.
     * @param {string} methodName - Name of a single method to be defined.
     * @param {Function} methodFn - Function body of a single method to be defined.
     ***/
    defineWithOptionCollect('defineInstanceAndStatic', INSTANCE | STATIC);


    /***
     * @method defineStaticWithArguments(methods)
     * @returns SugarNamespace
     * @namespace SugarNamespace
     * @short Defines static methods that collect arguments.
     * @extra This method is identical to `defineStatic`, except that when defined
     *        methods are called, they will collect any arguments past `n - 1`,
     *        where `n` is the number of arguments that the method accepts.
     *        Collected arguments will be passed to the method in an array
     *        as the last argument defined on the function.
     *
     * @example
     *
     *   Sugar.Number.defineStaticWithArguments({
     *     addAll: function (num, args) {
     *       for (var i = 0; i < args.length; i++) {
     *         num += args[i];
     *       }
     *       return num;
     *     }
     *   });
     *
     * @signature defineStaticWithArguments(methodName, methodFn)
     * @param {Object} methods - Methods to be defined.
     * @param {string} methodName - Name of a single method to be defined.
     * @param {Function} methodFn - Function body of a single method to be defined.
     ***/
    defineWithOptionCollect('defineStaticWithArguments', STATIC, true);

    /***
     * @method defineInstanceWithArguments(methods)
     * @returns SugarNamespace
     * @namespace SugarNamespace
     * @short Defines instance methods that collect arguments.
     * @extra This method is identical to `defineInstance`, except that when
     *        defined methods are called, they will collect any arguments past
     *        `n - 1`, where `n` is the number of arguments that the method
     *        accepts. Collected arguments will be passed to the method as the
     *        last argument defined on the function.
     *
     * @example
     *
     *   Sugar.Number.defineInstanceWithArguments({
     *     addAll: function (num, args) {
     *       for (var i = 0; i < args.length; i++) {
     *         num += args[i];
     *       }
     *       return num;
     *     }
     *   });
     *
     * @signature defineInstanceWithArguments(methodName, methodFn)
     * @param {Object} methods - Methods to be defined.
     * @param {string} methodName - Name of a single method to be defined.
     * @param {Function} methodFn - Function body of a single method to be defined.
     ***/
    defineWithOptionCollect('defineInstanceWithArguments', INSTANCE, true);

    /***
     * @method defineStaticPolyfill(methods)
     * @returns SugarNamespace
     * @namespace SugarNamespace
     * @short Defines static methods that are mapped onto the native if they do
     *        not already exist.
     * @extra Intended only for use creating polyfills that follow the ECMAScript
     *        spec. Accepts either a single object mapping names to functions, or
     *        name and function as two arguments. Note that polyfill methods will
     *        be immediately mapped onto their native prototype regardless of the
     *        use of `extend`.
     *
     * @example
     *
     *   Sugar.Object.defineStaticPolyfill({
     *     keys: function (obj) {
     *       // get keys!
     *     }
     *   });
     *
     * @signature defineStaticPolyfill(methodName, methodFn)
     * @param {Object} methods - Methods to be defined.
     * @param {string} methodName - Name of a single method to be defined.
     * @param {Function} methodFn - Function body of a single method to be defined.
     ***/
    setProperty(sugarNamespace, 'defineStaticPolyfill', function(arg1, arg2, arg3) {
      var opts = collectDefineOptions(arg1, arg2, arg3);
      extendNative(globalContext[name], opts.methods, true, opts.last);
      return sugarNamespace;
    });

    /***
     * @method defineInstancePolyfill(methods)
     * @returns SugarNamespace
     * @namespace SugarNamespace
     * @short Defines instance methods that are mapped onto the native prototype
     *        if they do not already exist.
     * @extra Intended only for use creating polyfills that follow the ECMAScript
     *        spec. Accepts either a single object mapping names to functions, or
     *        name and function as two arguments. This method differs from
     *        `defineInstance` as there is no static signature (as the method
     *        is mapped as-is to the native), so it should refer to its `this`
     *        object. Note that polyfill methods will be immediately mapped onto
     *        their native prototype regardless of the use of `extend`.
     *
     * @example
     *
     *   Sugar.Array.defineInstancePolyfill({
     *     indexOf: function (arr, el) {
     *       // index finding code here!
     *     }
     *   });
     *
     * @signature defineInstancePolyfill(methodName, methodFn)
     * @param {Object} methods - Methods to be defined.
     * @param {string} methodName - Name of a single method to be defined.
     * @param {Function} methodFn - Function body of a single method to be defined.
     ***/
    setProperty(sugarNamespace, 'defineInstancePolyfill', function(arg1, arg2, arg3) {
      var opts = collectDefineOptions(arg1, arg2, arg3);
      extendNative(globalContext[name].prototype, opts.methods, true, opts.last);
      // Map instance polyfills to chainable as well.
      forEachProperty(opts.methods, function(fn, methodName) {
        defineChainableMethod(sugarNamespace, methodName, fn);
      });
      return sugarNamespace;
    });

    /***
     * @method alias(toName, from)
     * @returns SugarNamespace
     * @namespace SugarNamespace
     * @short Aliases one Sugar method to another.
     *
     * @example
     *
     *   Sugar.Array.alias('all', 'every');
     *
     * @signature alias(toName, fn)
     * @param {string} toName - Name for new method.
     * @param {string|Function} from - Method to alias, or string shortcut.
     ***/
    setProperty(sugarNamespace, 'alias', function(name, source) {
      var method = typeof source === 'string' ? sugarNamespace[source] : source;
      setMethod(sugarNamespace, name, method);
      return sugarNamespace;
    });

    // Each namespace can extend only itself through its .extend method.
    setProperty(sugarNamespace, 'extend', extend);

    // Cache the class to namespace relationship for later use.
    namespacesByName[name] = sugarNamespace;
    namespacesByClassString['[object ' + name + ']'] = sugarNamespace;

    mapNativeToChainable(name);
    mapObjectChainablesToNamespace(sugarNamespace);


    // Export
    return Sugar[name] = sugarNamespace;
  }

  function setGlobalProperties() {
    setProperty(Sugar, 'extend', Sugar);
    setProperty(Sugar, 'toString', toString);
    setProperty(Sugar, 'createNamespace', createNamespace);

    setProperty(Sugar, 'util', {
      'hasOwn': hasOwn,
      'getOwn': getOwn,
      'setProperty': setProperty,
      'classToString': classToString,
      'defineProperty': defineProperty,
      'forEachProperty': forEachProperty,
      'mapNativeToChainable': mapNativeToChainable
    });
  }

  function toString() {
    return SUGAR_GLOBAL;
  }


  // Defining Methods

  function defineMethods(sugarNamespace, methods, type, args, flags) {
    forEachProperty(methods, function(method, methodName) {
      var instanceMethod, staticMethod = method;
      if (args) {
        staticMethod = wrapMethodWithArguments(method);
      }
      if (flags) {
        staticMethod.flags = flags;
      }

      // A method may define its own custom implementation, so
      // make sure that's not the case before creating one.
      if (type & INSTANCE && !method.instance) {
        instanceMethod = wrapInstanceMethod(method, args);
        setProperty(staticMethod, 'instance', instanceMethod);
      }

      if (type & STATIC) {
        setProperty(staticMethod, 'static', true);
      }

      setMethod(sugarNamespace, methodName, staticMethod);

      if (sugarNamespace.active) {
        // If the namespace has been activated (.extend has been called),
        // then map this method as well.
        sugarNamespace.extend(methodName);
      }
    });
  }

  function collectDefineOptions(arg1, arg2, arg3) {
    var methods, last;
    if (typeof arg1 === 'string') {
      methods = {};
      methods[arg1] = arg2;
      last = arg3;
    } else {
      methods = arg1;
      last = arg2;
    }
    return {
      last: last,
      methods: methods
    };
  }

  function wrapInstanceMethod(fn, args) {
    return args ? wrapMethodWithArguments(fn, true) : wrapInstanceMethodFixed(fn);
  }

  function wrapMethodWithArguments(fn, instance) {
    // Functions accepting enumerated arguments will always have "args" as the
    // last argument, so subtract one from the function length to get the point
    // at which to start collecting arguments. If this is an instance method on
    // a prototype, then "this" will be pushed into the arguments array so start
    // collecting 1 argument earlier.
    var startCollect = fn.length - 1 - (instance ? 1 : 0);
    return function() {
      var args = [], collectedArgs = [], len;
      if (instance) {
        args.push(this);
      }
      len = Math.max(arguments.length, startCollect);
      // Optimized: no leaking arguments
      for (var i = 0; i < len; i++) {
        if (i < startCollect) {
          args.push(arguments[i]);
        } else {
          collectedArgs.push(arguments[i]);
        }
      }
      args.push(collectedArgs);
      return fn.apply(this, args);
    };
  }

  function wrapInstanceMethodFixed(fn) {
    switch(fn.length) {
      // Wrapped instance methods will always be passed the instance
      // as the first argument, but requiring the argument to be defined
      // may cause confusion here, so return the same wrapped function regardless.
      case 0:
      case 1:
        return function() {
          return fn(this);
        };
      case 2:
        return function(a) {
          return fn(this, a);
        };
      case 3:
        return function(a, b) {
          return fn(this, a, b);
        };
      case 4:
        return function(a, b, c) {
          return fn(this, a, b, c);
        };
      case 5:
        return function(a, b, c, d) {
          return fn(this, a, b, c, d);
        };
    }
  }

  // Method helpers

  function extendNative(target, source, polyfill, override) {
    forEachProperty(source, function(method, name) {
      if (polyfill && !override && target[name]) {
        // Method exists, so bail.
        return;
      }
      setProperty(target, name, method);
    });
  }

  function setMethod(sugarNamespace, methodName, method) {
    sugarNamespace[methodName] = method;
    if (method.instance) {
      defineChainableMethod(sugarNamespace, methodName, method.instance, true);
    }
  }


  // Chainables

  function getNewChainableClass(name) {
    var fn = function SugarChainable(obj, arg) {
      if (!(this instanceof fn)) {
        return new fn(obj, arg);
      }
      if (this.constructor !== fn) {
        // Allow modules to define their own constructors.
        obj = this.constructor.apply(obj, arguments);
      }
      this.raw = obj;
    };
    setProperty(fn, 'toString', function() {
      return SUGAR_GLOBAL + name;
    });
    setProperty(fn.prototype, 'valueOf', function() {
      return this.raw;
    });
    return fn;
  }

  function defineChainableMethod(sugarNamespace, methodName, fn) {
    var wrapped = wrapWithChainableResult(fn), existing, collision, dcp;
    dcp = DefaultChainable.prototype;
    existing = dcp[methodName];

    // If the method was previously defined on the default chainable, then a
    // collision exists, so set the method to a disambiguation function that will
    // lazily evaluate the object and find it's associated chainable. An extra
    // check is required to avoid false positives from Object inherited methods.
    collision = existing && existing !== Object.prototype[methodName];

    // The disambiguation function is only required once.
    if (!existing || !existing.disambiguate) {
      dcp[methodName] = collision ? disambiguateMethod(methodName) : wrapped;
    }

    // The target chainable always receives the wrapped method. Additionally,
    // if the target chainable is Sugar.Object, then map the wrapped method
    // to all other namespaces as well if they do not define their own method
    // of the same name. This way, a Sugar.Number will have methods like
    // isEqual that can be called on any object without having to traverse up
    // the prototype chain and perform disambiguation, which costs cycles.
    // Note that the "if" block below actually does nothing on init as Object
    // goes first and no other namespaces exist yet. However it needs to be
    // here as Object instance methods defined later also need to be mapped
    // back onto existing namespaces.
    sugarNamespace.prototype[methodName] = wrapped;
    if (sugarNamespace === Sugar.Object) {
      mapObjectChainableToAllNamespaces(methodName, wrapped);
    }
  }

  function mapObjectChainablesToNamespace(sugarNamespace) {
    forEachProperty(Sugar.Object && Sugar.Object.prototype, function(val, methodName) {
      if (typeof val === 'function') {
        setObjectChainableOnNamespace(sugarNamespace, methodName, val);
      }
    });
  }

  function mapObjectChainableToAllNamespaces(methodName, fn) {
    forEachProperty(namespacesByName, function(sugarNamespace) {
      setObjectChainableOnNamespace(sugarNamespace, methodName, fn);
    });
  }

  function setObjectChainableOnNamespace(sugarNamespace, methodName, fn) {
    var proto = sugarNamespace.prototype;
    if (!hasOwn(proto, methodName)) {
      proto[methodName] = fn;
    }
  }

  function wrapWithChainableResult(fn) {
    return function() {
      return new DefaultChainable(fn.apply(this.raw, arguments));
    };
  }

  function disambiguateMethod(methodName) {
    var fn = function() {
      var raw = this.raw, sugarNamespace;
      if (raw != null) {
        // Find the Sugar namespace for this unknown.
        sugarNamespace = namespacesByClassString[classToString(raw)];
      }
      if (!sugarNamespace) {
        // If no sugarNamespace can be resolved, then default
        // back to Sugar.Object so that undefined and other
        // non-supported types can still have basic object
        // methods called on them, such as type checks.
        sugarNamespace = Sugar.Object;
      }

      return new sugarNamespace(raw)[methodName].apply(this, arguments);
    };
    fn.disambiguate = true;
    return fn;
  }

  function mapNativeToChainable(name, methodNames) {
    var sugarNamespace = namespacesByName[name],
        nativeProto = globalContext[name].prototype;

    if (!methodNames && ownPropertyNames) {
      methodNames = ownPropertyNames(nativeProto);
    }

    forEachProperty(methodNames, function(methodName) {
      if (nativeMethodProhibited(methodName)) {
        // Sugar chainables have their own constructors as well as "valueOf"
        // methods, so exclude them here. The __proto__ argument should be trapped
        // by the function check below, however simply accessing this property on
        // Object.prototype causes QML to segfault, so pre-emptively excluding it.
        return;
      }
      try {
        var fn = nativeProto[methodName];
        if (typeof fn !== 'function') {
          // Bail on anything not a function.
          return;
        }
      } catch (e) {
        // Function.prototype has properties that
        // will throw errors when accessed.
        return;
      }
      defineChainableMethod(sugarNamespace, methodName, fn);
    });
  }

  function nativeMethodProhibited(methodName) {
    return methodName === 'constructor' ||
           methodName === 'valueOf' ||
           methodName === '__proto__';
  }


  // Util

  // Internal references
  var ownPropertyNames = Object.getOwnPropertyNames,
      internalToString = Object.prototype.toString,
      internalHasOwnProperty = Object.prototype.hasOwnProperty;

  // Defining this as a variable here as the ES5 module
  // overwrites it to patch DONTENUM.
  var forEachProperty = function (obj, fn) {
    for(var key in obj) {
      if (!hasOwn(obj, key)) continue;
      if (fn.call(obj, obj[key], key, obj) === false) break;
    }
  };

  // istanbul ignore next
  function definePropertyShim(obj, prop, descriptor) {
    obj[prop] = descriptor.value;
  }

  function setProperty(target, name, value, enumerable) {
    defineProperty(target, name, {
      value: value,
      enumerable: !!enumerable,
      configurable: true,
      writable: true
    });
  }

  // PERF: Attempts to speed this method up get very Heisenbergy. Quickly
  // returning based on typeof works for primitives, but slows down object
  // types. Even === checks on null and undefined (no typeof) will end up
  // basically breaking even. This seems to be as fast as it can go.
  function classToString(obj) {
    return internalToString.call(obj);
  }

  function hasOwn(obj, prop) {
    return !!obj && internalHasOwnProperty.call(obj, prop);
  }

  function getOwn(obj, prop) {
    if (hasOwn(obj, prop)) {
      return obj[prop];
    }
  }

  setupGlobal();

  /***
   * @module Common
   * @description Internal utility and common methods.
   ***/


  // Flag allowing native methods to be enhanced
  var ENHANCEMENTS_FLAG = 'enhance';

  // For type checking, etc. Excludes object as this is more nuanced.
  var NATIVE_TYPES = 'Boolean Number String Date RegExp Function Array Error Set Map';

  // Do strings have no keys?
  var NO_KEYS_IN_STRING_OBJECTS = !('0' in Object('a'));

  // Prefix for private properties
  var PRIVATE_PROP_PREFIX = '_sugar_';

  // Matches 1..2 style ranges in properties
  var PROPERTY_RANGE_REG = /^(.*?)\[([-\d]*)\.\.([-\d]*)\](.*)$/;

  // WhiteSpace/LineTerminator as defined in ES5.1 plus Unicode characters in the Space, Separator category.
  var TRIM_CHARS = '\u0009\u000A\u000B\u000C\u000D\u0020\u00A0\u1680\u180E\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200A\u202F\u205F\u2028\u2029\u3000\uFEFF';

  // Regex for matching a formatted string
  var STRING_FORMAT_REG = /([{}])\1|\{([^}]*)\}|(%)%|(%(\w*))/g;

  // Common chars
  var HALF_WIDTH_ZERO = 0x30,
      FULL_WIDTH_ZERO = 0xff10,
      HALF_WIDTH_PERIOD   = '.',
      FULL_WIDTH_PERIOD   = '．',
      HALF_WIDTH_COMMA    = ',',
      OPEN_BRACE  = '{',
      CLOSE_BRACE = '}';

  // Namespace aliases
  var sugarObject   = Sugar.Object,
      sugarArray    = Sugar.Array,
      sugarDate     = Sugar.Date,
      sugarString   = Sugar.String,
      sugarNumber   = Sugar.Number,
      sugarFunction = Sugar.Function,
      sugarRegExp   = Sugar.RegExp;

  // Core utility aliases
  var hasOwn               = Sugar.util.hasOwn,
      getOwn               = Sugar.util.getOwn,
      setProperty          = Sugar.util.setProperty,
      classToString        = Sugar.util.classToString,
      defineProperty       = Sugar.util.defineProperty,
      forEachProperty      = Sugar.util.forEachProperty,
      mapNativeToChainable = Sugar.util.mapNativeToChainable;

  // Class checks
  var isSerializable,
      isBoolean, isNumber, isString,
      isDate, isRegExp, isFunction,
      isArray, isSet, isMap, isError;

  function buildClassChecks() {

    var knownTypes = {};

    function addCoreTypes() {

      var names = spaceSplit(NATIVE_TYPES);

      isBoolean = buildPrimitiveClassCheck(names[0]);
      isNumber  = buildPrimitiveClassCheck(names[1]);
      isString  = buildPrimitiveClassCheck(names[2]);

      isDate   = buildClassCheck(names[3]);
      isRegExp = buildClassCheck(names[4]);

      // Wanted to enhance performance here by using simply "typeof"
      // but Firefox has two major issues that make this impossible,
      // one fixed, the other not, so perform a full class check here.
      //
      // 1. Regexes can be typeof "function" in FF < 3
      //    https://bugzilla.mozilla.org/show_bug.cgi?id=61911 (fixed)
      //
      // 2. HTMLEmbedElement and HTMLObjectElement are be typeof "function"
      //    https://bugzilla.mozilla.org/show_bug.cgi?id=268945 (won't fix)
      isFunction = buildClassCheck(names[5]);


      isArray = Array.isArray || buildClassCheck(names[6]);
      isError = buildClassCheck(names[7]);

      isSet = buildClassCheck(names[8], typeof Set !== 'undefined' && Set);
      isMap = buildClassCheck(names[9], typeof Map !== 'undefined' && Map);

      // Add core types as known so that they can be checked by value below,
      // notably excluding Functions and adding Arguments and Error.
      addKnownType('Arguments');
      addKnownType(names[0]);
      addKnownType(names[1]);
      addKnownType(names[2]);
      addKnownType(names[3]);
      addKnownType(names[4]);
      addKnownType(names[6]);

    }

    function addArrayTypes() {
      var types = 'Int8 Uint8 Uint8Clamped Int16 Uint16 Int32 Uint32 Float32 Float64';
      forEach(spaceSplit(types), function(str) {
        addKnownType(str + 'Array');
      });
    }

    function addKnownType(className) {
      var str = '[object '+ className +']';
      knownTypes[str] = true;
    }

    function isKnownType(className) {
      return knownTypes[className];
    }

    function buildClassCheck(className, globalObject) {
      // istanbul ignore if
      if (globalObject && isClass(new globalObject, 'Object')) {
        return getConstructorClassCheck(globalObject);
      } else {
        return getToStringClassCheck(className);
      }
    }

    // Map and Set may be [object Object] in certain IE environments.
    // In this case we need to perform a check using the constructor
    // instead of Object.prototype.toString.
    // istanbul ignore next
    function getConstructorClassCheck(obj) {
      var ctorStr = String(obj);
      return function(obj) {
        return String(obj.constructor) === ctorStr;
      };
    }

    function getToStringClassCheck(className) {
      return function(obj, str) {
        // perf: Returning up front on instanceof appears to be slower.
        return isClass(obj, className, str);
      };
    }

    function buildPrimitiveClassCheck(className) {
      var type = className.toLowerCase();
      return function(obj) {
        var t = typeof obj;
        return t === type || t === 'object' && isClass(obj, className);
      };
    }

    addCoreTypes();
    addArrayTypes();

    isSerializable = function(obj, className) {
      // Only known objects can be serialized. This notably excludes functions,
      // host objects, Symbols (which are matched by reference), and instances
      // of classes. The latter can arguably be matched by value, but
      // distinguishing between these and host objects -- which should never be
      // compared by value -- is very tricky so not dealing with it here.
      className = className || classToString(obj);
      return isKnownType(className) || isPlainObject(obj, className);
    };

  }

  function isClass(obj, className, str) {
    if (!str) {
      str = classToString(obj);
    }
    return str === '[object '+ className +']';
  }

  // Wrapping the core's "define" methods to
  // save a few bytes in the minified script.
  function wrapNamespace(method) {
    return function(sugarNamespace, arg1, arg2) {
      sugarNamespace[method](arg1, arg2);
    };
  }

  // Method define aliases
  var alias                       = wrapNamespace('alias'),
      defineStatic                = wrapNamespace('defineStatic'),
      defineInstance              = wrapNamespace('defineInstance'),
      defineStaticPolyfill        = wrapNamespace('defineStaticPolyfill'),
      defineInstancePolyfill      = wrapNamespace('defineInstancePolyfill'),
      defineInstanceAndStatic     = wrapNamespace('defineInstanceAndStatic'),
      defineInstanceWithArguments = wrapNamespace('defineInstanceWithArguments');

  function defineInstanceSimilar(sugarNamespace, set, fn, flags) {
    defineInstance(sugarNamespace, collectSimilarMethods(set, fn), flags);
  }

  function collectSimilarMethods(set, fn) {
    var methods = {};
    if (isString(set)) {
      set = spaceSplit(set);
    }
    forEach(set, function(el, i) {
      fn(methods, el, i);
    });
    return methods;
  }

  // This song and dance is to fix methods to a different length
  // from what they actually accept in order to stay in line with
  // spec. Additionally passing argument length, as some methods
  // throw assertion errors based on this (undefined check is not
  // enough). Fortunately for now spec is such that passing 3
  // actual arguments covers all requirements. Note that passing
  // the argument length also forces the compiler to not rewrite
  // length of the compiled function.
  function fixArgumentLength(fn) {
    var staticFn = function(a) {
      var args = arguments;
      return fn(a, args[1], args[2], args.length - 1);
    };
    staticFn.instance = function(b) {
      var args = arguments;
      return fn(this, b, args[1], args.length);
    };
    return staticFn;
  }

  function defineAccessor(namespace, name, fn) {
    setProperty(namespace, name, fn);
  }

  function defineOptionsAccessor(namespace, defaults) {
    var obj = simpleClone(defaults);

    function getOption(name) {
      return obj[name];
    }

    function setOption(arg1, arg2) {
      var options;
      if (arguments.length === 1) {
        options = arg1;
      } else {
        options = {};
        options[arg1] = arg2;
      }
      forEachProperty(options, function(val, name) {
        if (val === null) {
          val = defaults[name];
        }
        obj[name] = val;
      });
    }

    defineAccessor(namespace, 'getOption', getOption);
    defineAccessor(namespace, 'setOption', setOption);
    return getOption;
  }

  function assertCallable(obj) {
    if (!isFunction(obj)) {
      throw new TypeError('Function is not callable');
    }
  }

  function assertArray(obj) {
    if (!isArray(obj)) {
      throw new TypeError('Array required');
    }
  }

  function assertWritable(obj) {
    if (isPrimitive(obj)) {
      // If strict mode is active then primitives will throw an
      // error when attempting to write properties. We can't be
      // sure if strict mode is available, so pre-emptively
      // throw an error here to ensure consistent behavior.
      throw new TypeError('Property cannot be written');
    }
  }

  // Coerces an object to a positive integer.
  // Does not allow Infinity.
  function coercePositiveInteger(n) {
    n = +n || 0;
    if (n < 0 || !isNumber(n) || !isFinite(n)) {
      throw new RangeError('Invalid number');
    }
    return trunc(n);
  }

  function isDefined(o) {
    return o !== undefined;
  }

  function isUndefined(o) {
    return o === undefined;
  }

  function privatePropertyAccessor(key) {
    var privateKey = PRIVATE_PROP_PREFIX + key;
    return function(obj, val) {
      if (arguments.length > 1) {
        setProperty(obj, privateKey, val);
        return obj;
      }
      return obj[privateKey];
    };
  }

  function setChainableConstructor(sugarNamespace, createFn) {
    sugarNamespace.prototype.constructor = function() {
      return createFn.apply(this, arguments);
    };
  }

  function getKeys(obj) {
    return Object.keys(obj);
  }

  function deepGetProperty(obj, key, any) {
    return handleDeepProperty(obj, key, any, false);
  }

  function handleDeepProperty(obj, key, any, has, fill, fillLast, val) {
    var ns, bs, ps, cbi, set, isLast, isPush, isIndex, nextIsIndex, exists;
    ns = obj || undefined;
    if (key == null) return;

    if (isObjectType(key)) {
      // Allow array and array-like accessors
      bs = [key];
    } else {
      key = String(key);
      if (key.indexOf('..') !== -1) {
        return handleArrayIndexRange(obj, key, any, val);
      }
      bs = key.split('[');
    }

    set = isDefined(val);

    for (var i = 0, blen = bs.length; i < blen; i++) {
      ps = bs[i];

      if (isString(ps)) {
        ps = periodSplit(ps);
      }

      for (var j = 0, plen = ps.length; j < plen; j++) {
        key = ps[j];

        // Is this the last key?
        isLast = i === blen - 1 && j === plen - 1;

        // Index of the closing ]
        cbi = key.indexOf(']');

        // Is the key an array index?
        isIndex = cbi !== -1;

        // Is this array push syntax "[]"?
        isPush = set && cbi === 0;

        // If the bracket split was successful and this is the last element
        // in the dot split, then we know the next key will be an array index.
        nextIsIndex = blen > 1 && j === plen - 1;

        if (isPush) {
          // Set the index to the end of the array
          key = ns.length;
        } else if (isIndex) {
          // Remove the closing ]
          key = key.slice(0, -1);
        }

        // If the array index is less than 0, then
        // add its length to allow negative indexes.
        if (isIndex && key < 0) {
          key = +key + ns.length;
        }

        // Bracket keys may look like users[5] or just [5], so the leading
        // characters are optional. We can enter the namespace if this is the
        // 2nd part, if there is only 1 part, or if there is an explicit key.
        if (i || key || blen === 1) {

          exists = any ? key in ns : hasOwn(ns, key);

          // Non-existent namespaces are only filled if they are intermediate
          // (not at the end) or explicitly filling the last.
          if (fill && (!isLast || fillLast) && !exists) {
            // For our purposes, last only needs to be an array.
            ns = ns[key] = nextIsIndex || (fillLast && isLast) ? [] : {};
            continue;
          }

          if (has) {
            if (isLast || !exists) {
              return exists;
            }
          } else if (set && isLast) {
            assertWritable(ns);
            ns[key] = val;
          }

          ns = exists ? ns[key] : undefined;
        }

      }
    }
    return ns;
  }

  // Get object property with support for 0..1 style range notation.
  function handleArrayIndexRange(obj, key, any, val) {
    var match, start, end, leading, trailing, arr, set;
    match = key.match(PROPERTY_RANGE_REG);
    if (!match) {
      return;
    }

    set = isDefined(val);
    leading = match[1];

    if (leading) {
      arr = handleDeepProperty(obj, leading, any, false, set ? true : false, true);
    } else {
      arr = obj;
    }

    assertArray(arr);

    trailing = match[4];
    start    = match[2] ? +match[2] : 0;
    end      = match[3] ? +match[3] : arr.length;

    // A range of 0..1 is inclusive, so we need to add 1 to the end. If this
    // pushes the index from -1 to 0, then set it to the full length of the
    // array, otherwise it will return nothing.
    end = end === -1 ? arr.length : end + 1;

    if (set) {
      for (var i = start; i < end; i++) {
        handleDeepProperty(arr, i + trailing, any, false, true, false, val);
      }
    } else {
      arr = arr.slice(start, end);

      // If there are trailing properties, then they need to be mapped for each
      // element in the array.
      if (trailing) {
        if (trailing.charAt(0) === HALF_WIDTH_PERIOD) {
          // Need to chomp the period if one is trailing after the range. We
          // can't do this at the regex level because it will be required if
          // we're setting the value as it needs to be concatentated together
          // with the array index to be set.
          trailing = trailing.slice(1);
        }
        return arr.map(function(el) {
          return handleDeepProperty(el, trailing);
        });
      }
    }
    return arr;
  }

  function getOwnKey(obj, key) {
    if (hasOwn(obj, key)) {
      return key;
    }
  }

  function isObjectType(obj, type) {
    return !!obj && (type || typeof obj) === 'object';
  }

  function isPrimitive(obj, type) {
    type = type || typeof obj;
    return obj == null || type === 'string' || type === 'number' || type === 'boolean';
  }

  function isPlainObject(obj, className) {
    return isObjectType(obj) &&
           isClass(obj, 'Object', className) &&
           hasValidPlainObjectPrototype(obj) &&
           hasOwnEnumeratedProperties(obj);
  }

  function hasValidPlainObjectPrototype(obj) {
    var hasToString = 'toString' in obj;
    var hasConstructor = 'constructor' in obj;
    // An object created with Object.create(null) has no methods in the
    // prototype chain, so check if any are missing. The additional hasToString
    // check is for false positives on some host objects in old IE which have
    // toString but no constructor. If the object has an inherited constructor,
    // then check if it is Object (the "isPrototypeOf" tapdance here is a more
    // robust way of ensuring this if the global has been hijacked). Note that
    // accessing the constructor directly (without "in" or "hasOwnProperty")
    // will throw a permissions error in IE8 on cross-domain windows.
    return (!hasConstructor && !hasToString) ||
            (hasConstructor && !hasOwn(obj, 'constructor') &&
             hasOwn(obj.constructor.prototype, 'isPrototypeOf'));
  }

  function hasOwnEnumeratedProperties(obj) {
    // Plain objects are generally defined as having enumerated properties
    // all their own, however in early IE environments without defineProperty,
    // there may also be enumerated methods in the prototype chain, so check
    // for both of these cases.
    var objectProto = Object.prototype;
    for (var key in obj) {
      var val = obj[key];
      if (!hasOwn(obj, key) && val !== objectProto[key]) {
        return false;
      }
    }
    return true;
  }

  function simpleClone(obj) {
    return simpleMerge({}, obj);
  }

  function simpleMerge(target, source) {
    forEachProperty(source, function(val, key) {
      target[key] = val;
    });
    return target;
  }

  // Make primtives types like strings into objects.
  function coercePrimitiveToObject(obj) {
    if (isPrimitive(obj)) {
      obj = Object(obj);
    }
    // istanbul ignore if
    if (NO_KEYS_IN_STRING_OBJECTS && isString(obj)) {
      forceStringCoercion(obj);
    }
    return obj;
  }

  // Force strings to have their indexes set in
  // environments that don't do this automatically.
  // istanbul ignore next
  function forceStringCoercion(obj) {
    var i = 0, chr;
    while (chr = obj.charAt(i)) {
      obj[i++] = chr;
    }
  }

  // Serializes an object in a way that will provide a token unique
  // to the type, class, and value of an object. Host objects, class
  // instances etc, are not serializable, and are held in an array
  // of references that will return the index as a unique identifier
  // for the object. This array is passed from outside so that the
  // calling function can decide when to dispose of this array.
  function serializeInternal(obj, refs, stack) {
    var type = typeof obj, className, value, ref;

    // Return quickly for primitives to save cycles
    if (isPrimitive(obj, type) && !isRealNaN(obj)) {
      return type + obj;
    }

    className = classToString(obj);

    if (!isSerializable(obj, className)) {
      ref = indexOf(refs, obj);
      if (ref === -1) {
        ref = refs.length;
        refs.push(obj);
      }
      return ref;
    } else if (isObjectType(obj)) {
      value = serializeDeep(obj, refs, stack) + obj.toString();
    } else if (1 / obj === -Infinity) {
      value = '-0';
    } else if (obj.valueOf) {
      value = obj.valueOf();
    }
    return type + className + value;
  }

  function serializeDeep(obj, refs, stack) {
    var result = '';
    iterateWithCyclicCheck(obj, true, stack, function(key, val, cyc, stack) {
      result += cyc ? 'CYC' : key + serializeInternal(val, refs, stack);
    });
    return result;
  }

  function iterateWithCyclicCheck(obj, sortedKeys, stack, fn) {

    function next(val, key) {
      var cyc = false;

      // Allowing a step into the structure before triggering this check to save
      // cycles on standard JSON structures and also to try as hard as possible to
      // catch basic properties that may have been modified.
      if (stack.length > 1) {
        var i = stack.length;
        while (i--) {
          if (stack[i] === val) {
            cyc = true;
          }
        }
      }

      stack.push(val);
      fn(key, val, cyc, stack);
      stack.pop();
    }

    function iterateWithSortedKeys() {
      // Sorted keys is required for serialization, where object order
      // does not matter but stringified order does.
      var arr = getKeys(obj).sort(), key;
      for (var i = 0; i < arr.length; i++) {
        key = arr[i];
        next(obj[key], arr[i]);
      }
    }

    // This method for checking for cyclic structures was egregiously stolen from
    // the ingenious method by @kitcambridge from the Underscore script:
    // https://github.com/documentcloud/underscore/issues/240
    if (!stack) {
      stack = [];
    }

    if (sortedKeys) {
      iterateWithSortedKeys();
    } else {
      forEachProperty(obj, next);
    }
  }

  function isArrayIndex(n) {
    return n >>> 0 == n && n != 0xFFFFFFFF;
  }

  function iterateOverSparseArray(arr, fn, fromIndex, loop) {
    var indexes = getSparseArrayIndexes(arr, fromIndex, loop), index;
    for (var i = 0, len = indexes.length; i < len; i++) {
      index = indexes[i];
      fn.call(arr, arr[index], index, arr);
    }
    return arr;
  }

  // It's unclear whether or not sparse arrays qualify as "simple enumerables".
  // If they are not, however, the wrapping function will be deoptimized, so
  // isolate here (also to share between es5 and array modules).
  function getSparseArrayIndexes(arr, fromIndex, loop, fromRight) {
    var indexes = [], i;
    for (i in arr) {
      if (isArrayIndex(i) && (loop || (fromRight ? i <= fromIndex : i >= fromIndex))) {
        indexes.push(+i);
      }
    }
    indexes.sort(function(a, b) {
      var aLoop = a > fromIndex;
      var bLoop = b > fromIndex;
      // This block cannot be reached unless ES5 methods are being shimmed.
      // istanbul ignore if
      if (aLoop !== bLoop) {
        return aLoop ? -1 : 1;
      }
      return a - b;
    });
    return indexes;
  }

  function getEntriesForIndexes(obj, find, loop, isString) {
    var result, length = obj.length;
    if (!isArray(find)) {
      return entryAtIndex(obj, find, length, loop, isString);
    }
    result = new Array(find.length);
    forEach(find, function(index, i) {
      result[i] = entryAtIndex(obj, index, length, loop, isString);
    });
    return result;
  }

  function getNormalizedIndex(index, length, loop) {
    if (index && loop) {
      index = index % length;
    }
    if (index < 0) index = length + index;
    return index;
  }

  function entryAtIndex(obj, index, length, loop, isString) {
    index = getNormalizedIndex(index, length, loop);
    return isString ? obj.charAt(index) : obj[index];
  }

  function spaceSplit(str) {
    return str.split(' ');
  }

  function commaSplit(str) {
    return str.split(HALF_WIDTH_COMMA);
  }

  function periodSplit(str) {
    return str.split(HALF_WIDTH_PERIOD);
  }

  function forEach(arr, fn) {
    for (var i = 0, len = arr.length; i < len; i++) {
      if (!(i in arr)) {
        return iterateOverSparseArray(arr, fn, i);
      }
      fn(arr[i], i);
    }
  }

  function filter(arr, fn) {
    var result = [];
    for (var i = 0, len = arr.length; i < len; i++) {
      var el = arr[i];
      if (i in arr && fn(el, i)) {
        result.push(el);
      }
    }
    return result;
  }

  function map(arr, fn) {
    // perf: Not using fixed array len here as it may be sparse.
    var result = [];
    for (var i = 0, len = arr.length; i < len; i++) {
      if (i in arr) {
        result.push(fn(arr[i], i));
      }
    }
    return result;
  }

  function indexOf(arr, el) {
    for (var i = 0, len = arr.length; i < len; i++) {
      if (i in arr && arr[i] === el) return i;
    }
    return -1;
  }

  // istanbul ignore next
  var trunc = Math.trunc || function(n) {
    if (n === 0 || !isFinite(n)) return n;
    return n < 0 ? ceil(n) : floor(n);
  };

  function isRealNaN(obj) {
    // This is only true of NaN
    return obj != null && obj !== obj;
  }

  function withPrecision(val, precision, fn) {
    var multiplier = pow(10, abs(precision || 0));
    fn = fn || round;
    if (precision < 0) multiplier = 1 / multiplier;
    return fn(val * multiplier) / multiplier;
  }

  function padNumber(num, place, sign, base, replacement) {
    var str = abs(num).toString(base || 10);
    str = repeatString(replacement || '0', place - str.replace(/\.\d+/, '').length) + str;
    if (sign || num < 0) {
      str = (num < 0 ? '-' : '+') + str;
    }
    return str;
  }

  function getOrdinalSuffix(num) {
    if (num >= 11 && num <= 13) {
      return 'th';
    } else {
      switch(num % 10) {
        case 1:  return 'st';
        case 2:  return 'nd';
        case 3:  return 'rd';
        default: return 'th';
      }
    }
  }

  // Fullwidth number helpers
  var fullWidthNumberReg, fullWidthNumberMap, fullWidthNumbers;

  function buildFullWidthNumber() {
    var fwp = FULL_WIDTH_PERIOD, hwp = HALF_WIDTH_PERIOD, hwc = HALF_WIDTH_COMMA, fwn = '';
    fullWidthNumberMap = {};
    for (var i = 0, digit; i <= 9; i++) {
      digit = chr(i + FULL_WIDTH_ZERO);
      fwn += digit;
      fullWidthNumberMap[digit] = chr(i + HALF_WIDTH_ZERO);
    }
    fullWidthNumberMap[hwc] = '';
    fullWidthNumberMap[fwp] = hwp;
    // Mapping this to itself to capture it easily
    // in stringToNumber to detect decimals later.
    fullWidthNumberMap[hwp] = hwp;
    fullWidthNumberReg = allCharsReg(fwn + fwp + hwc + hwp);
    fullWidthNumbers = fwn;
  }

  // Takes into account full-width characters, commas, and decimals.
  function stringToNumber(str, base) {
    var sanitized, isDecimal;
    sanitized = str.replace(fullWidthNumberReg, function(chr) {
      var replacement = getOwn(fullWidthNumberMap, chr);
      if (replacement === HALF_WIDTH_PERIOD) {
        isDecimal = true;
      }
      return replacement;
    });
    return isDecimal ? parseFloat(sanitized) : parseInt(sanitized, base || 10);
  }

  // Math aliases
  var abs   = Math.abs,
      pow   = Math.pow,
      min   = Math.min,
      max   = Math.max,
      ceil  = Math.ceil,
      floor = Math.floor,
      round = Math.round;

  var chr = String.fromCharCode;

  function trim(str) {
    return str.trim();
  }

  function repeatString(str, num) {
    var result = '';
    str = str.toString();
    while (num > 0) {
      if (num & 1) {
        result += str;
      }
      if (num >>= 1) {
        str += str;
      }
    }
    return result;
  }

  function simpleCapitalize(str) {
    return str.charAt(0).toUpperCase() + str.slice(1);
  }

  function createFormatMatcher(bracketMatcher, percentMatcher, precheck) {

    var reg = STRING_FORMAT_REG;
    var compileMemoized = memoizeFunction(compile);

    function getToken(format, match) {
      var get, token, literal, fn;
      var bKey = match[2];
      var pLit = match[3];
      var pKey = match[5];
      if (match[4] && percentMatcher) {
        token = pKey;
        get = percentMatcher;
      } else if (bKey) {
        token = bKey;
        get = bracketMatcher;
      } else if (pLit && percentMatcher) {
        literal = pLit;
      } else {
        literal = match[1] || match[0];
      }
      if (get) {
        assertPassesPrecheck(precheck, bKey, pKey);
        fn = function(obj, opt) {
          return get(obj, token, opt);
        };
      }
      format.push(fn || getLiteral(literal));
    }

    function getSubstring(format, str, start, end) {
      if (end > start) {
        var sub = str.slice(start, end);
        assertNoUnmatched(sub, OPEN_BRACE);
        assertNoUnmatched(sub, CLOSE_BRACE);
        format.push(function() {
          return sub;
        });
      }
    }

    function getLiteral(str) {
      return function() {
        return str;
      };
    }

    function assertPassesPrecheck(precheck, bt, pt) {
      if (precheck && !precheck(bt, pt)) {
        throw new TypeError('Invalid token '+ (bt || pt) +' in format string');
      }
    }

    function assertNoUnmatched(str, chr) {
      if (str.indexOf(chr) !== -1) {
        throw new TypeError('Unmatched '+ chr +' in format string');
      }
    }

    function compile(str) {
      var format = [], lastIndex = 0, match;
      reg.lastIndex = 0;
      while(match = reg.exec(str)) {
        getSubstring(format, str, lastIndex, match.index);
        getToken(format, match);
        lastIndex = reg.lastIndex;
      }
      getSubstring(format, str, lastIndex, str.length);
      return format;
    }

    return function(str, obj, opt) {
      var format = compileMemoized(str), result = '';
      for (var i = 0; i < format.length; i++) {
        result += format[i](obj, opt);
      }
      return result;
    };
  }

  var Inflections = {};

  function getAcronym(str) {
    return Inflections.acronyms && Inflections.acronyms.find(str);
  }

  function getHumanWord(str) {
    return Inflections.human && Inflections.human.find(str);
  }

  function runHumanRules(str) {
    return Inflections.human && Inflections.human.runRules(str) || str;
  }

  function allCharsReg(src) {
    return RegExp('[' + src + ']', 'g');
  }

  function getRegExpFlags(reg, add) {
    var flags = '';
    add = add || '';
    function checkFlag(prop, flag) {
      if (prop || add.indexOf(flag) > -1) {
        flags += flag;
      }
    }
    checkFlag(reg.global, 'g');
    checkFlag(reg.ignoreCase, 'i');
    checkFlag(reg.multiline, 'm');
    checkFlag(reg.sticky, 'y');
    return flags;
  }

  function escapeRegExp(str) {
    if (!isString(str)) str = String(str);
    return str.replace(/([\\\/\'*+?|()\[\]{}.^$-])/g,'\\$1');
  }

  var _utc = privatePropertyAccessor('utc');

  function callDateGet(d, method) {
    return d['get' + (_utc(d) ? 'UTC' : '') + method]();
  }

  function callDateSet(d, method, value, safe) {
    // "Safe" denotes not setting the date if the value is the same as what is
    // currently set. In theory this should be a noop, however it will cause
    // timezone shifts when in the middle of a DST fallback. This is unavoidable
    // as the notation itself is ambiguous (i.e. there are two "1:00ams" on
    // November 1st, 2015 in northern hemisphere timezones that follow DST),
    // however when advancing or rewinding dates this can throw off calculations
    // so avoiding this unintentional shifting on an opt-in basis.
    if (safe && value === callDateGet(d, method, value)) {
      return;
    }
    d['set' + (_utc(d) ? 'UTC' : '') + method](value);
  }

  var INTERNAL_MEMOIZE_LIMIT = 1000;

  // Note that attemps to consolidate this with Function#memoize
  // ended up clunky as that is also serializing arguments. Separating
  // these implementations turned out to be simpler.
  function memoizeFunction(fn) {
    var memo = {}, counter = 0;

    return function(key) {
      if (hasOwn(memo, key)) {
        return memo[key];
      }
      // istanbul ignore if
      if (counter === INTERNAL_MEMOIZE_LIMIT) {
        memo = {};
        counter = 0;
      }
      counter++;
      return memo[key] = fn(key);
    };
  }

  buildClassChecks();

  buildFullWidthNumber();

  /***
   * @module ES6
   * @description Polyfills that provide basic ES6 compatibility. This module
   *              provides the base for Sugar functionality, but is not a full
   *              polyfill suite.
   *
   ***/


  function getCoercedStringSubject(obj) {
    if (obj == null) {
      throw new TypeError('String required.');
    }
    return String(obj);
  }

  function getCoercedSearchString(obj) {
    if (isRegExp(obj)) {
      throw new TypeError();
    }
    return String(obj);
  }

  defineInstancePolyfill(sugarString, {

    /***
     * @method includes(search, [pos] = 0)
     * @returns Boolean
     * @polyfill ES6
     * @short Returns true if `search` is contained within the string.
     * @extra Search begins at [pos], which defaults to the beginning of the
     *        string. Sugar enhances this method to allow matching a regex.
     *
     * @example
     *
     *   'jumpy'.includes('py')      -> true
     *   'broken'.includes('ken', 3) -> true
     *   'broken'.includes('bro', 3) -> false
     *
     ***/
    'includes': function(searchString) {
      // Force compiler to respect argument length.
      var argLen = arguments.length, pos = arguments[1];
      var str = getCoercedStringSubject(this);
      searchString = getCoercedSearchString(searchString);
      return str.indexOf(searchString, pos) !== -1;
    },

    /***
     * @method startsWith(search, [pos] = 0)
     * @returns Boolean
     * @polyfill ES6
     * @short Returns true if the string starts with substring `search`.
     * @extra Search begins at [pos], which defaults to the entire string length.
     *
     * @example
     *
     *   'hello'.startsWith('hell')   -> true
     *   'hello'.startsWith('HELL')   -> false
     *   'hello'.startsWith('ell', 1) -> true
     *
     ***/
    'startsWith': function(searchString) {
      // Force compiler to respect argument length.
      var argLen = arguments.length, position = arguments[1];
      var str, start, pos, len, searchLength;
      str = getCoercedStringSubject(this);
      searchString = getCoercedSearchString(searchString);
      pos = +position || 0;
      len = str.length;
      start = min(max(pos, 0), len);
      searchLength = searchString.length;
      if (searchLength + start > len) {
        return false;
      }
      if (str.substr(start, searchLength) === searchString) {
        return true;
      }
      return false;
    },

    /***
     * @method endsWith(search, [pos] = length)
     * @returns Boolean
     * @polyfill ES6
     * @short Returns true if the string ends with substring `search`.
     * @extra Search ends at [pos], which defaults to the entire string length.
     *
     * @example
     *
     *   'jumpy'.endsWith('py')    -> true
     *   'jumpy'.endsWith('MPY')   -> false
     *   'jumpy'.endsWith('mp', 4) -> false
     *
     ***/
    'endsWith': function(searchString) {
      // Force compiler to respect argument length.
      var argLen = arguments.length, endPosition = arguments[1];
      var str, start, end, pos, len, searchLength;
      str = getCoercedStringSubject(this);
      searchString = getCoercedSearchString(searchString);
      len = str.length;
      pos = len;
      if (isDefined(endPosition)) {
        pos = +endPosition || 0;
      }
      end = min(max(pos, 0), len);
      searchLength = searchString.length;
      start = end - searchLength;
      if (start < 0) {
        return false;
      }
      if (str.substr(start, searchLength) === searchString) {
        return true;
      }
      return false;
    },

    /***
     * @method repeat([num] = 0)
     * @returns String
     * @polyfill ES6
     * @short Returns the string repeated [num] times.
     *
     * @example
     *
     *   'jumpy'.repeat(2) -> 'jumpyjumpy'
     *   'a'.repeat(5)     -> 'aaaaa'
     *   'a'.repeat(0)     -> ''
     *
     ***/
    'repeat': function(num) {
      num = coercePositiveInteger(num);
      return repeatString(this, num);
    }

  });

  defineStaticPolyfill(sugarNumber, {

    /***
     * @method isNaN(value)
     * @returns Boolean
     * @polyfill ES6
     * @static
     * @short Returns true only if the number is `NaN`.
     * @extra This is differs from the global `isNaN`, which returns true for
     *        anything that is not a number.
     *
     * @example
     *
     *   Number.isNaN(NaN) -> true
     *   Number.isNaN('n') -> false
     *
     ***/
    'isNaN': function(obj) {
      return isRealNaN(obj);
    }

  });

  function getCoercedObject(obj) {
    if (obj == null) {
      throw new TypeError('Object required.');
    }
    return coercePrimitiveToObject(obj);
  }

  defineStaticPolyfill(sugarArray, {

    /***
     * @method from(a, [mapFn], [context])
     * @returns Mixed
     * @polyfill ES6
     * @static
     * @short Creates an array from an array-like object.
     * @extra If [mapFn] is passed, it will be map each element of the array.
     *        [context] is the `this` object if passed.
     *
     * @callback mapFn
     *
     *   el   The element of the current iteration.
     *   i    The index of the current iteration.
     *   arr  A reference to the array.
     *
     * @example
     *
     *   Array.from({0:'a',1:'b',length:2}); -> ['a','b']
     *
     ***/
    'from': function(a) {
      // Force compiler to respect argument length.
      var argLen = arguments.length, mapFn = arguments[1], context = arguments[2];
      var len, arr;
      if (isDefined(mapFn)) {
        assertCallable(mapFn);
      }
      a = getCoercedObject(a);
      len = trunc(max(0, a.length || 0));
      if (!isArrayIndex(len)) {
        throw new RangeError('Invalid array length');
      }
      if (isFunction(this)) {
        arr = new this(len);
        arr.length = len;
      } else {
        arr = new Array(len);
      }
      for (var i = 0; i < len; i++) {
        setProperty(arr, i, isDefined(mapFn) ? mapFn.call(context, a[i], i) : a[i], true);
      }
      return arr;
    }

  });

  defineInstancePolyfill(sugarArray, {

    'find': function(f) {
      // Force compiler to respect argument length.
      var argLen = arguments.length, context = arguments[1];
      assertCallable(f);
      for (var i = 0, len = this.length; i < len; i++) {
        if (f.call(context, this[i], i, this)) {
          return this[i];
        }
      }
    },

    'findIndex': function(f) {
      // Force compiler to respect argument length.
      var argLen = arguments.length, context = arguments[1];
      assertCallable(f);
      for (var i = 0, len = this.length; i < len; i++) {
        if (f.call(context, this[i], i, this)) {
          return i;
        }
      }
      return -1;
    }

  });

  /***
   * @module ES7
   * @description Polyfills that provide basic ES7 compatibility. This module
   *              provides the base for Sugar functionality, but is not a full
   *              polyfill suite.
   *
   ***/


  function sameValueZero(a, b) {
    if (isRealNaN(a)) {
      return isRealNaN(b);
    }
    return a === b ? a !== 0 || 1 / a === 1 / b : false;
  }

  defineInstancePolyfill(sugarArray, {

    /***
     * @method includes(search, [fromIndex] = 0)
     * @returns Boolean
     * @polyfill ES7
     * @short Returns true if `search` is contained within the array.
     * @extra Search begins at [fromIndex], which defaults to the beginning of the
     *        array.
     *
     * @example
     *
     *   [1,2,3].includes(2)    -> true
     *   [1,2,3].includes(4)    -> false
     *   [1,2,3].includes(2, 3) -> false
     *
     ***/
    'includes': function(search) {
      // Force compiler to respect argument length.
      var argLen = arguments.length, fromIndex = arguments[1];
      var arr = this, len;
      if (isString(arr)) return arr.includes(search, fromIndex);
      fromIndex = fromIndex ? fromIndex.valueOf() : 0;
      len = arr.length;
      if (fromIndex < 0) {
        fromIndex = max(0, fromIndex + len);
      }
      for (var i = fromIndex; i < len; i++) {
        if (sameValueZero(search, arr[i])) {
          return true;
        }
      }
      return false;
    }

  });

  /***
   * @module Date
   * @description Date parsing and formatting, relative formats, number shortcuts,
   *              and locale support with default English locales.
   *
   ***/


  var DATE_OPTIONS = {
    'newDateInternal': defaultNewDate
  };

  var LOCALE_ARRAY_FIELDS = [
    'months', 'weekdays', 'units', 'numerals', 'placeholders',
    'articles', 'tokens', 'timeMarkers', 'ampm', 'timeSuffixes',
    'parse', 'timeParse', 'timeFrontParse', 'modifiers'
  ];

  // Regex for stripping Timezone Abbreviations
  var TIMEZONE_ABBREVIATION_REG = /(\w{3})[()\s\d]*$/;

  // One minute in milliseconds
  var MINUTES = 60 * 1000;

  // Date unit indexes
  var HOURS_INDEX   = 3,
      DAY_INDEX     = 4,
      WEEK_INDEX    = 5,
      MONTH_INDEX   = 6,
      YEAR_INDEX    = 7;

  // ISO Defaults
  var ISO_FIRST_DAY_OF_WEEK = 1,
      ISO_FIRST_DAY_OF_WEEK_YEAR = 4;

  var ParsingTokens = {
    'yyyy': {
      param: 'year',
      src: '\\d{4}'
    },
    'MM': {
      param: 'month',
      src: '[01]?\\d'
    },
    'dd': {
      param: 'date',
      src: '[0123]?\\d'
    },
    'hh': {
      param: 'hour',
      src: '[0-2]?\\d'
    },
    'mm': {
      param: 'minute',
      src: '[0-5]\\d'
    },
    'ss': {
      param: 'second',
      src: '[0-5]\\d(?:[,.]\\d+)?'
    },
    'yy': {
      param: 'year',
      src: '\\d{2}'
    },
    'y': {
      param: 'year',
      src: '\\d'
    },
    'yearSign': {
      src: '[+-]',
      sign: true
    },
    'tzHour': {
      src: '[0-1]\\d'
    },
    'tzMinute': {
      src: '[0-5]\\d'
    },
    'tzSign': {
      src: '[+−-]',
      sign: true
    },
    'ihh': {
      param: 'hour',
      src: '[0-2]?\\d(?:[,.]\\d+)?'
    },
    'imm': {
      param: 'minute',
      src: '[0-5]\\d(?:[,.]\\d+)?'
    },
    'GMT': {
      param: 'utc',
      src: 'GMT',
      val: 1
    },
    'Z': {
      param: 'utc',
      src: 'Z',
      val: 1
    },
    'timestamp': {
      src: '\\d+'
    }
  };

  var LocalizedParsingTokens = {
    'year': {
      base: 'yyyy',
      requiresSuffix: true
    },
    'month': {
      base: 'MM',
      requiresSuffix: true
    },
    'date': {
      base: 'dd',
      requiresSuffix: true
    },
    'hour': {
      base: 'hh',
      requiresSuffixOr: ':'
    },
    'minute': {
      base: 'mm'
    },
    'second': {
      base: 'ss'
    },
    'num': {
      src: '\\d+',
      requiresNumerals: true
    }
  };

  var CoreParsingFormats = [
    {
      // 12-1978
      // 08-1978 (MDY)
      src: '{MM}[-.\\/]{yyyy}'
    },
    {
      // 12/08/1978
      // 08/12/1978 (MDY)
      time: true,
      src: '{dd}[-.\\/]{MM}(?:[-.\\/]{yyyy|yy|y})?',
      mdy: '{MM}[-.\\/]{dd}(?:[-.\\/]{yyyy|yy|y})?'
    },
    {
      // 1975-08-25
      time: true,
      src: '{yyyy}[-.\\/]{MM}(?:[-.\\/]{dd})?'
    },
    {
      // .NET JSON
      src: '\\\\/Date\\({timestamp}(?:[+-]\\d{4,4})?\\)\\\\/'
    },
    {
      // ISO-8601
      src: '{yearSign?}{yyyy}(?:-?{MM}(?:-?{dd}(?:T{ihh}(?::?{imm}(?::?{ss})?)?)?)?)?{tzOffset?}'
    }
  ];

  var CoreOutputFormats = {
    'ISO8601': '{yyyy}-{MM}-{dd}T{HH}:{mm}:{ss}.{SSS}{Z}',
    'RFC1123': '{Dow}, {dd} {Mon} {yyyy} {HH}:{mm}:{ss} {ZZ}',
    'RFC1036': '{Weekday}, {dd}-{Mon}-{yy} {HH}:{mm}:{ss} {ZZ}'
  };

  var FormatTokensBase = [
    {
      ldml: 'Dow',
      strf: 'a',
      lowerToken: 'dow',
      get: function(d, localeCode) {
        return localeManager.get(localeCode).getWeekdayName(getWeekday(d), 2);
      }
    },
    {
      ldml: 'Weekday',
      strf: 'A',
      lowerToken: 'weekday',
      allowAlternates: true,
      get: function(d, localeCode, alternate) {
        return localeManager.get(localeCode).getWeekdayName(getWeekday(d), alternate);
      }
    },
    {
      ldml: 'Mon',
      strf: 'b h',
      lowerToken: 'mon',
      get: function(d, localeCode) {
        return localeManager.get(localeCode).getMonthName(getMonth(d), 2);
      }
    },
    {
      ldml: 'Month',
      strf: 'B',
      lowerToken: 'month',
      allowAlternates: true,
      get: function(d, localeCode, alternate) {
        return localeManager.get(localeCode).getMonthName(getMonth(d), alternate);
      }
    },
    {
      strf: 'C',
      get: function(d) {
        return getYear(d).toString().slice(0, 2);
      }
    },
    {
      ldml: 'd date day',
      strf: 'd',
      strfPadding: 2,
      ldmlPaddedToken: 'dd',
      ordinalToken: 'do',
      get: function(d) {
        return getDate(d);
      }
    },
    {
      strf: 'e',
      get: function(d) {
        return padNumber(getDate(d), 2, false, 10, ' ');
      }
    },
    {
      ldml: 'H 24hr',
      strf: 'H',
      strfPadding: 2,
      ldmlPaddedToken: 'HH',
      get: function(d) {
        return getHours(d);
      }
    },
    {
      ldml: 'h hours 12hr',
      strf: 'I',
      strfPadding: 2,
      ldmlPaddedToken: 'hh',
      get: function(d) {
        return getHours(d) % 12 || 12;
      }
    },
    {
      ldml: 'D',
      strf: 'j',
      strfPadding: 3,
      ldmlPaddedToken: 'DDD',
      get: function(d) {
        var s = setUnitAndLowerToEdge(cloneDate(d), MONTH_INDEX);
        return getDaysSince(d, s) + 1;
      }
    },
    {
      ldml: 'M',
      strf: 'm',
      strfPadding: 2,
      ordinalToken: 'Mo',
      ldmlPaddedToken: 'MM',
      get: function(d) {
        return getMonth(d) + 1;
      }
    },
    {
      ldml: 'm minutes',
      strf: 'M',
      strfPadding: 2,
      ldmlPaddedToken: 'mm',
      get: function(d) {
        return callDateGet(d, 'Minutes');
      }
    },
    {
      ldml: 'Q',
      get: function(d) {
        return ceil((getMonth(d) + 1) / 3);
      }
    },
    {
      ldml: 'TT',
      strf: 'p',
      get: function(d, localeCode) {
        return getMeridiemToken(d, localeCode);
      }
    },
    {
      ldml: 'tt',
      strf: 'P',
      get: function(d, localeCode) {
        return getMeridiemToken(d, localeCode).toLowerCase();
      }
    },
    {
      ldml: 'T',
      lowerToken: 't',
      get: function(d, localeCode) {
        return getMeridiemToken(d, localeCode).charAt(0);
      }
    },
    {
      ldml: 's seconds',
      strf: 'S',
      strfPadding: 2,
      ldmlPaddedToken: 'ss',
      get: function(d) {
        return callDateGet(d, 'Seconds');
      }
    },
    {
      ldml: 'S ms',
      strfPadding: 3,
      ldmlPaddedToken: 'SSS',
      get: function(d) {
        return callDateGet(d, 'Milliseconds');
      }
    },
    {
      ldml: 'e',
      strf: 'u',
      ordinalToken: 'eo',
      get: function(d) {
        return getWeekday(d) || 7;
      }
    },
    {
      strf: 'U',
      strfPadding: 2,
      get: function(d) {
        // Sunday first, 0-53
        return getWeekNumber(d, false, 0);
      }
    },
    {
      ldml: 'W',
      strf: 'V',
      strfPadding: 2,
      ordinalToken: 'Wo',
      ldmlPaddedToken: 'WW',
      get: function(d) {
        // Monday first, 1-53 (ISO8601)
        return getWeekNumber(d, true);
      }
    },
    {
      strf: 'w',
      get: function(d) {
        return getWeekday(d);
      }
    },
    {
      ldml: 'w',
      ordinalToken: 'wo',
      ldmlPaddedToken: 'ww',
      get: function(d, localeCode) {
        // Locale dependent, 1-53
        var loc = localeManager.get(localeCode),
            dow = loc.getFirstDayOfWeek(localeCode),
            doy = loc.getFirstDayOfWeekYear(localeCode);
        return getWeekNumber(d, true, dow, doy);
      }
    },
    {
      strf: 'W',
      strfPadding: 2,
      get: function(d) {
        // Monday first, 0-53
        return getWeekNumber(d, false);
      }
    },
    {
      ldmlPaddedToken: 'gggg',
      ldmlTwoDigitToken: 'gg',
      get: function(d, localeCode) {
        return getWeekYear(d, localeCode);
      }
    },
    {
      strf: 'G',
      strfPadding: 4,
      strfTwoDigitToken: 'g',
      ldmlPaddedToken: 'GGGG',
      ldmlTwoDigitToken: 'GG',
      get: function(d, localeCode) {
        return getWeekYear(d, localeCode, true);
      }
    },
    {
      ldml: 'year',
      ldmlPaddedToken: 'yyyy',
      ldmlTwoDigitToken: 'yy',
      strf: 'Y',
      strfPadding: 4,
      strfTwoDigitToken: 'y',
      get: function(d) {
        return getYear(d);
      }
    },
    {
      ldml: 'ZZ',
      strf: 'z',
      get: function(d) {
        return getUTCOffset(d);
      }
    },
    {
      ldml: 'X',
      get: function(d) {
        return trunc(d.getTime() / 1000);
      }
    },
    {
      ldml: 'x',
      get: function(d) {
        return d.getTime();
      }
    },
    {
      ldml: 'Z',
      get: function(d) {
        return getUTCOffset(d, true);
      }
    },
    {
      ldml: 'z',
      strf: 'Z',
      get: function(d) {
        // Note that this is not accurate in all browsing environments!
        // https://github.com/moment/moment/issues/162
        // It will continue to be supported for Node and usage with the
        // understanding that it may be blank.
        var match = d.toString().match(TIMEZONE_ABBREVIATION_REG);
        return match ? match[1]: '';
      }
    },
    {
      strf: 'D',
      alias: '%m/%d/%y'
    },
    {
      strf: 'F',
      alias: '%Y-%m-%d'
    },
    {
      strf: 'r',
      alias: '%I:%M:%S %p'
    },
    {
      strf: 'R',
      alias: '%H:%M'
    },
    {
      strf: 'T',
      alias: '%H:%M:%S'
    },
    {
      strf: 'x',
      alias: '{short}'
    },
    {
      strf: 'X',
      alias: '{time}'
    },
    {
      strf: 'c',
      alias: '{stamp}'
    }
  ];

  var DateUnits = [
    {
      name: 'millisecond',
      method: 'Milliseconds',
      multiplier: 1,
      start: 0,
      end: 999
    },
    {
      name: 'second',
      method: 'Seconds',
      multiplier: 1000,
      start: 0,
      end: 59
    },
    {
      name: 'minute',
      method: 'Minutes',
      multiplier: 60 * 1000,
      start: 0,
      end: 59
    },
    {
      name: 'hour',
      method: 'Hours',
      multiplier: 60 * 60 * 1000,
      start: 0,
      end: 23
    },
    {
      name: 'day',
      alias: 'date',
      method: 'Date',
      ambiguous: true,
      multiplier: 24 * 60 * 60 * 1000,
      start: 1,
      end: function(d) {
        return getDaysInMonth(d);
      }
    },
    {
      name: 'week',
      method: 'ISOWeek',
      ambiguous: true,
      multiplier: 7 * 24 * 60 * 60 * 1000
    },
    {
      name: 'month',
      method: 'Month',
      ambiguous: true,
      multiplier: 30.4375 * 24 * 60 * 60 * 1000,
      start: 0,
      end: 11
    },
    {
      name: 'year',
      method: 'FullYear',
      ambiguous: true,
      multiplier: 365.25 * 24 * 60 * 60 * 1000,
      start: 0
    }
  ];

  /***
   * @method getOption(name)
   * @returns Mixed
   * @accessor
   * @short Gets an option used internally by Date.
   * @example
   *
   *   Sugar.Date.getOption('newDateInternal');
   *
   * @param {string} name
   *
   ***
   * @method setOption(name, value)
   * @accessor
   * @short Sets an option used internally by Date.
   * @extra If `value` is `null`, the default value will be restored.
   * @options
   *
   *   newDateInternal   Sugar's internal date constructor. Date methods often
   *                     construct a `new Date()` internally as a reference point
   *                     (`isToday`, relative formats like `tomorrow`, etc). This
   *                     can be overridden if you need it to be something else.
   *                     Most commonly, this allows you to return a shifted date
   *                     to simulate a specific timezone, as dates in Javascript
   *                     are always local.
   *
   * @example
   *
   *   Sugar.Date.setOption('newDateInternal', function() {
   *     var d = new Date(), offset;
   *     offset = (d.getTimezoneOffset() - 600) * 60 * 1000; // Hawaii time!
   *     d.setTime(d.getTime() + offset);
   *     return d;
   *   });
   *
   * @signature setOption(options)
   * @param {DateOptions} options
   * @param {string} name
   * @param {any} value
   * @option {Function} newDateInternal
   *
   ***/
  var _dateOptions = defineOptionsAccessor(sugarDate, DATE_OPTIONS);

  function setDateChainableConstructor() {
    setChainableConstructor(sugarDate, createDate);
  }

  function getNewDate() {
    return _dateOptions('newDateInternal')();
  }

  function defaultNewDate() {
    return new Date;
  }

  function cloneDate(d) {
    // Rhino environments have a bug where new Date(d) truncates
    // milliseconds so need to call getTime() here.
    var clone = new Date(d.getTime());
    _utc(clone, !!_utc(d));
    return clone;
  }

  function dateIsValid(d) {
    return !isNaN(d.getTime());
  }

  function assertDateIsValid(d) {
    if (!dateIsValid(d)) {
      throw new TypeError('Date is not valid');
    }
  }

  function getHours(d) {
    return callDateGet(d, 'Hours');
  }

  function getWeekday(d) {
    return callDateGet(d, 'Day');
  }

  function getDate(d) {
    return callDateGet(d, 'Date');
  }

  function getMonth(d) {
    return callDateGet(d, 'Month');
  }

  function getYear(d) {
    return callDateGet(d, 'FullYear');
  }

  function setDate(d, val) {
    callDateSet(d, 'Date', val);
  }

  function setMonth(d, val) {
    callDateSet(d, 'Month', val);
  }

  function setYear(d, val) {
    callDateSet(d, 'FullYear', val);
  }

  function getDaysInMonth(d) {
    return 32 - callDateGet(new Date(getYear(d), getMonth(d), 32), 'Date');
  }

  function setWeekday(d, dow, dir) {
    if (!isNumber(dow)) return;
    var currentWeekday = getWeekday(d);
    if (dir) {
      // Allow a "direction" parameter to determine whether a weekday can
      // be set beyond the current weekday in either direction.
      var ndir = dir > 0 ? 1 : -1;
      var offset = dow % 7 - currentWeekday;
      if (offset && offset / abs(offset) !== ndir) {
        dow += 7 * ndir;
      }
    }
    setDate(d, getDate(d) + dow - currentWeekday);
    return d.getTime();
  }

  // Normal callDateSet method with ability
  // to handle ISOWeek setting as well.
  function callDateSetWithWeek(d, method, value, safe) {
    if (method === 'ISOWeek') {
      setISOWeekNumber(d, value);
    } else {
      callDateSet(d, method, value, safe);
    }
  }

  function isUTC(d) {
    return !!_utc(d) || tzOffset(d) === 0;
  }

  function getUTCOffset(d, iso) {
    var offset = _utc(d) ? 0 : tzOffset(d), hours, mins, colon;
    colon  = iso === true ? ':' : '';
    if (!offset && iso) return 'Z';
    hours = padNumber(trunc(-offset / 60), 2, true);
    mins = padNumber(abs(offset % 60), 2);
    return  hours + colon + mins;
  }

  function tzOffset(d) {
    return d.getTimezoneOffset();
  }

  function collectDateArguments(args, allowDuration) {
    var arg1 = args[0], arg2 = args[1];
    if (allowDuration && isString(arg1)) {
      arg1 = getDateParamsFromString(arg1);
    } else if (isNumber(arg1) && isNumber(arg2)) {
      arg1 = collectDateParamsFromArguments(args);
      arg2 = null;
    } else {
      if (isObjectType(arg1)) {
        arg1 = simpleClone(arg1);
      }
    }
    return [arg1, arg2];
  }

  function collectDateParamsFromArguments(args) {
    var params = {}, index = 0;
    walkUnitDown(YEAR_INDEX, function(unit) {
      var arg = args[index++];
      if (isDefined(arg)) {
        params[unit.name] = arg;
      }
    });
    return params;
  }

  function getDateParamsFromString(str) {
    var match, num, params = {};
    match = str.match(/^(-?\d*[\d.]\d*)?\s?(\w+?)s?$/i);
    if (match) {
      if (isUndefined(num)) {
        num = +match[1];
        if (isNaN(num)) {
          num = 1;
        }
      }
      params[match[2].toLowerCase()] = num;
    }
    return params;
  }

  // Years -> Milliseconds
  function iterateOverDateUnits(fn, startIndex, endIndex) {
    endIndex = endIndex || 0;
    if (isUndefined(startIndex)) {
      startIndex = YEAR_INDEX;
    }
    for (var index = startIndex; index >= endIndex; index--) {
      if (fn(DateUnits[index], index) === false) {
        break;
      }
    }
  }

  // Years -> Milliseconds using getLower/Higher methods
  function walkUnitDown(unitIndex, fn) {
    while (unitIndex >= 0) {
      if (fn(DateUnits[unitIndex], unitIndex) === false) {
        break;
      }
      unitIndex = getLowerUnitIndex(unitIndex);
    }
  }

  // Moving lower from specific unit
  function getLowerUnitIndex(index) {
    if (index === MONTH_INDEX) {
      return DAY_INDEX;
    } else if (index === WEEK_INDEX) {
      return HOURS_INDEX;
    }
    return index - 1;
  }

  // Moving higher from specific unit
  function getHigherUnitIndex(index) {
    return index === DAY_INDEX ? MONTH_INDEX : index + 1;
  }

  // Years -> Milliseconds checking all date params including "weekday"
  function iterateOverDateParams(params, fn, startIndex, endIndex) {

    function run(name, unit, i) {
      var val = getDateParam(params, name);
      if (isDefined(val)) {
        fn(name, val, unit, i);
      }
    }

    iterateOverDateUnits(function (unit, i) {
      var result = run(unit.name, unit, i);
      if (result !== false && i === DAY_INDEX) {
        // Check for "weekday", which has a distinct meaning
        // in the context of setting a date, but has the same
        // meaning as "day" as a unit of time.
        result = run('weekday', unit, i);
      }
      return result;
    }, startIndex, endIndex);

  }

  // Years -> Days
  function iterateOverHigherDateParams(params, fn) {
    iterateOverDateParams(params, fn, YEAR_INDEX, DAY_INDEX);
  }

  function advanceDate(d, unit, num, reset) {
    var set = {};
    set[unit] = num;
    return updateDate(d, set, reset, 1);
  }

  function advanceDateWithArgs(d, args, dir) {
    args = collectDateArguments(args, true);
    return updateDate(d, args[0], args[1], dir);
  }

  function resetTime(d) {
    return setUnitAndLowerToEdge(d, HOURS_INDEX);
  }

  function resetLowerUnits(d, unitIndex) {
    return setUnitAndLowerToEdge(d, getLowerUnitIndex(unitIndex));
  }

  function moveToBeginningOfWeek(d, firstDayOfWeek) {
    setWeekday(d, floor((getWeekday(d) - firstDayOfWeek) / 7) * 7 + firstDayOfWeek);
    return d;
  }

  function moveToEndOfWeek(d, firstDayOfWeek) {
    var target = firstDayOfWeek - 1;
    setWeekday(d, ceil((getWeekday(d) - target) / 7) * 7 + target);
    return d;
  }

  function moveToBeginningOfUnit(d, unitIndex, localeCode) {
    if (unitIndex === WEEK_INDEX) {
      moveToBeginningOfWeek(d, localeManager.get(localeCode).getFirstDayOfWeek());
    }
    return setUnitAndLowerToEdge(d, getLowerUnitIndex(unitIndex));
  }

  function moveToEndOfUnit(d, unitIndex, localeCode, stopIndex) {
    if (unitIndex === WEEK_INDEX) {
      moveToEndOfWeek(d, localeManager.get(localeCode).getFirstDayOfWeek());
    }
    return setUnitAndLowerToEdge(d, getLowerUnitIndex(unitIndex), stopIndex, true);
  }

  function setUnitAndLowerToEdge(d, startIndex, stopIndex, end) {
    walkUnitDown(startIndex, function(unit, i) {
      var val = end ? unit.end : unit.start;
      if (isFunction(val)) {
        val = val(d);
      }
      callDateSet(d, unit.method, val);
      return !isDefined(stopIndex) || i > stopIndex;
    });
    return d;
  }

  function getDateParamKey(params, key) {
    return getOwnKey(params, key) ||
           getOwnKey(params, key + 's') ||
           (key === 'day' && getOwnKey(params, 'date'));
  }

  function getDateParam(params, key) {
    return getOwn(params, getDateParamKey(params, key));
  }

  function deleteDateParam(params, key) {
    delete params[getDateParamKey(params, key)];
  }

  function getUnitIndexForParamName(name) {
    var params = {}, unitIndex;
    params[name] = 1;
    iterateOverDateParams(params, function(name, val, unit, i) {
      unitIndex = i;
      return false;
    });
    return unitIndex;
  }

  function getDaysSince(d1, d2) {
    return getTimeDistanceForUnit(d1, d2, DateUnits[DAY_INDEX]);
  }

  function getTimeDistanceForUnit(d1, d2, unit) {
    var fwd = d2 > d1, num, tmp;
    if (!fwd) {
      tmp = d2;
      d2  = d1;
      d1  = tmp;
    }
    num = d2 - d1;
    if (unit.multiplier > 1) {
      num = trunc(num / unit.multiplier);
    }
    // For higher order with potential ambiguity, use the numeric calculation
    // as a starting point, then iterate until we pass the target date.
    if (unit.ambiguous) {
      d1 = cloneDate(d1);
      if (num) {
        advanceDate(d1, unit.name, num);
      }
      while (d1 < d2) {
        advanceDate(d1, unit.name, 1);
        if (d1 > d2) {
          break;
        }
        num += 1;
      }
    }
    return fwd ? -num : num;
  }

  function getParsingTokenValue(token, str) {
    var val;
    if (token.val) {
      val = token.val;
    } else if (token.sign) {
      val = str === '+' ? 1 : -1;
    } else if (token.bool) {
      val = !!val;
    } else {
      val = +str.replace(/,/, '.');
    }
    if (token.param === 'month') {
      val -= 1;
    }
    return val;
  }

  function getYearFromAbbreviation(str, d, prefer) {
    // Following IETF here, adding 1900 or 2000 depending on the last two digits.
    // Note that this makes no accordance for what should happen after 2050, but
    // intentionally ignoring this for now. https://www.ietf.org/rfc/rfc2822.txt
    var val = +str, delta;
    val += val < 50 ? 2000 : 1900;
    if (prefer) {
      delta = val - getYear(d);
      if (delta / abs(delta) !== prefer) {
        val += prefer * 100;
      }
    }
    return val;
  }

  function setISOWeekNumber(d, num) {
    if (isNumber(num)) {
      // Intentionally avoiding updateDate here to prevent circular dependencies.
      var isoWeek = cloneDate(d), dow = getWeekday(d);
      moveToFirstDayOfWeekYear(isoWeek, ISO_FIRST_DAY_OF_WEEK, ISO_FIRST_DAY_OF_WEEK_YEAR);
      setDate(isoWeek, getDate(isoWeek) + 7 * (num - 1));
      setYear(d, getYear(isoWeek));
      setMonth(d, getMonth(isoWeek));
      setDate(d, getDate(isoWeek));
      setWeekday(d, dow || 7);
    }
    return d.getTime();
  }

  function getWeekNumber(d, allowPrevious, firstDayOfWeek, firstDayOfWeekYear) {
    var isoWeek, n = 0;
    if (isUndefined(firstDayOfWeek)) {
      firstDayOfWeek = ISO_FIRST_DAY_OF_WEEK;
    }
    if (isUndefined(firstDayOfWeekYear)) {
      firstDayOfWeekYear = ISO_FIRST_DAY_OF_WEEK_YEAR;
    }
    // Moving to the end of the week allows for forward year traversal, ie
    // Dec 29 2014 is actually week 01 of 2015.
    isoWeek = moveToEndOfWeek(cloneDate(d), firstDayOfWeek);
    moveToFirstDayOfWeekYear(isoWeek, firstDayOfWeek, firstDayOfWeekYear);
    if (allowPrevious && d < isoWeek) {
      // If the date is still before the start of the year, then it should be
      // the last week of the previous year, ie Jan 1 2016 is actually week 53
      // of 2015, so move to the beginning of the week to traverse the year.
      isoWeek = moveToBeginningOfWeek(cloneDate(d), firstDayOfWeek);
      moveToFirstDayOfWeekYear(isoWeek, firstDayOfWeek, firstDayOfWeekYear);
    }
    while (isoWeek <= d) {
      // Doing a very simple walk to get the week number.
      setDate(isoWeek, getDate(isoWeek) + 7);
      n++;
    }
    return n;
  }

  function getWeekYear(d, localeCode, iso) {
    var year, month, firstDayOfWeek, firstDayOfWeekYear, week, loc;
    year = getYear(d);
    month = getMonth(d);
    if (month === 0 || month === 11) {
      if (!iso) {
        loc = localeManager.get(localeCode);
        firstDayOfWeek = loc.getFirstDayOfWeek(localeCode);
        firstDayOfWeekYear = loc.getFirstDayOfWeekYear(localeCode);
      }
      week = getWeekNumber(d, false, firstDayOfWeek, firstDayOfWeekYear);
      if (month === 0 && week === 0) {
        year -= 1;
      } else if (month === 11 && week === 1) {
        year += 1;
      }
    }
    return year;
  }

  function moveToFirstDayOfWeekYear(d, firstDayOfWeek, firstDayOfWeekYear) {
    setUnitAndLowerToEdge(d, MONTH_INDEX);
    setDate(d, firstDayOfWeekYear);
    moveToBeginningOfWeek(d, firstDayOfWeek);
  }

  function dateRelative(d, dRelative, arg1, arg2) {
    var adu, format, type, localeCode, fn;
    assertDateIsValid(d);
    if (isFunction(arg1)) {
      fn = arg1;
    } else {
      localeCode = arg1;
      fn = arg2;
    }
    adu = getAdjustedUnitForDate(d, dRelative);
    if (fn) {
      format = fn.apply(d, adu.concat(localeManager.get(localeCode)));
      if (format) {
        return dateFormat(d, format, localeCode);
      }
    }
    // Adjust up if time is in ms, as this doesn't
    // look very good for a standard relative date.
    if (adu[1] === 0) {
      adu[1] = 1;
      adu[0] = 1;
    }
    if (dRelative) {
      type = 'duration';
    } else if (adu[2] > 0) {
      type = 'future';
    } else {
      type = 'past';
    }
    return localeManager.get(localeCode).getRelativeFormat(adu, type);
  }

  // Gets an "adjusted date unit" which is a way of representing
  // the largest possible meaningful unit. In other words, if passed
  // 3600000, this will return an array which represents "1 hour".
  function getAdjustedUnit(ms, fn) {
    var unitIndex = 0, value = 0;
    iterateOverDateUnits(function(unit, i) {
      value = abs(fn(unit));
      if (value >= 1) {
        unitIndex = i;
        return false;
      }
    });
    return [value, unitIndex, ms];
  }

  // Gets the adjusted unit based on simple division by
  // date unit multiplier.
  function getAdjustedUnitForNumber(ms) {
    return getAdjustedUnit(ms, function(unit) {
      return trunc(withPrecision(ms / unit.multiplier, 1));
    });
  }

  // Gets the adjusted unit using the unitsFromNow methods,
  // which use internal date methods that neatly avoid vaguely
  // defined units of time (days in month, leap years, etc).
  // Reserving dRelative to allow another date to be relative to.
  function getAdjustedUnitForDate(d, dRelative) {
    var ms;
    if (!dRelative) {
      dRelative = getNewDate();
      if (d > dRelative) {
        // If our date is greater than the one that we got from getNewDate, it
        // means that we are finding the unit for a date that is in the future
        // relative to now. However, often the incoming date was created in
        // the same cycle as our comparison, but our "now" date will have been
        // created an instant after it, creating situations where "5 minutes from
        // now" becomes "4 minutes from now" in the same tick. To prevent this,
        // subtract a buffer of 10ms to compensate.
        dRelative = new Date(dRelative.getTime() - 10);
      }
    }
    ms = d - dRelative;
    return getAdjustedUnit(ms, function(u) {
      return abs(getTimeDistanceForUnit(d, dRelative, u));
    });
  }

  // Formatting tokens
  var ldmlTokens, strfTokens;

  function dateFormat(d, format, localeCode) {
    assertDateIsValid(d);
    format = CoreOutputFormats[format] || format || '{long}';
    return dateFormatMatcher(format, d, localeCode);
  }

  function getMeridiemToken(d, localeCode) {
    var hours = getHours(d);
    return localeManager.get(localeCode).ampm[trunc(hours / 12)] || '';
  }

  function buildDateFormatTokens() {

    function addFormats(target, tokens, fn) {
      if (tokens) {
        forEach(spaceSplit(tokens), function(token) {
          target[token] = fn;
        });
      }
    }

    function buildLowercase(get) {
      return function(d, localeCode) {
        return get(d, localeCode).toLowerCase();
      };
    }

    function buildOrdinal(get) {
      return function(d, localeCode) {
        var n = get(d, localeCode);
        return n + localeManager.get(localeCode).getOrdinal(n);
      };
    }

    function buildPadded(get, padding) {
      return function(d, localeCode) {
        return padNumber(get(d, localeCode), padding);
      };
    }

    function buildTwoDigits(get) {
      return function(d, localeCode) {
        return get(d, localeCode) % 100;
      };
    }

    function buildAlias(alias) {
      return function(d, localeCode) {
        return dateFormatMatcher(alias, d, localeCode);
      };
    }

    function buildAlternates(f) {
      for (var n = 1; n <= 5; n++) {
        buildAlternate(f, n);
      }
    }

    function buildAlternate(f, n) {
      var alternate = function(d, localeCode) {
        return f.get(d, localeCode, n);
      };
      addFormats(ldmlTokens, f.ldml + n, alternate);
      if (f.lowerToken) {
        ldmlTokens[f.lowerToken + n] = buildLowercase(alternate);
      }
    }

    function getIdentityFormat(name) {
      return function(d, localeCode) {
        var loc = localeManager.get(localeCode);
        return dateFormatMatcher(loc[name], d, localeCode);
      };
    }

    ldmlTokens = {};
    strfTokens = {};

    forEach(FormatTokensBase, function(f) {
      var get = f.get, getPadded;
      if (f.lowerToken) {
        ldmlTokens[f.lowerToken] = buildLowercase(get);
      }
      if (f.ordinalToken) {
        ldmlTokens[f.ordinalToken] = buildOrdinal(get, f);
      }
      if (f.ldmlPaddedToken) {
        ldmlTokens[f.ldmlPaddedToken] = buildPadded(get, f.ldmlPaddedToken.length);
      }
      if (f.ldmlTwoDigitToken) {
        ldmlTokens[f.ldmlTwoDigitToken] = buildPadded(buildTwoDigits(get), 2);
      }
      if (f.strfTwoDigitToken) {
        strfTokens[f.strfTwoDigitToken] = buildPadded(buildTwoDigits(get), 2);
      }
      if (f.strfPadding) {
        getPadded = buildPadded(get, f.strfPadding);
      }
      if (f.alias) {
        get = buildAlias(f.alias);
      }
      if (f.allowAlternates) {
        buildAlternates(f);
      }
      addFormats(ldmlTokens, f.ldml, get);
      addFormats(strfTokens, f.strf, getPadded || get);
    });

    forEachProperty(CoreOutputFormats, function(src, name) {
      addFormats(ldmlTokens, name, buildAlias(src));
    });

    defineInstanceSimilar(sugarDate, 'short medium long full', function(methods, name) {
      var fn = getIdentityFormat(name);
      addFormats(ldmlTokens, name, fn);
      methods[name] = fn;
    });

    addFormats(ldmlTokens, 'time', getIdentityFormat('time'));
    addFormats(ldmlTokens, 'stamp', getIdentityFormat('stamp'));
  }

  var dateFormatMatcher;

  function buildDateFormatMatcher() {

    function getLdml(d, token, localeCode) {
      return getOwn(ldmlTokens, token)(d, localeCode);
    }

    function getStrf(d, token, localeCode) {
      return getOwn(strfTokens, token)(d, localeCode);
    }

    function checkDateToken(ldml, strf) {
      return hasOwn(ldmlTokens, ldml) || hasOwn(strfTokens, strf);
    }

    // Format matcher for LDML or STRF tokens.
    dateFormatMatcher = createFormatMatcher(getLdml, getStrf, checkDateToken);
  }

  function fullCompareDate(date, d, margin) {
    var tmp;
    if (!dateIsValid(date)) return;
    if (isString(d)) {
      d = trim(d).toLowerCase();
      switch(true) {
        case d === 'future':    return date.getTime() > getNewDate().getTime();
        case d === 'past':      return date.getTime() < getNewDate().getTime();
        case d === 'today':     return compareDay(date);
        case d === 'tomorrow':  return compareDay(date,  1);
        case d === 'yesterday': return compareDay(date, -1);
        case d === 'weekday':   return getWeekday(date) > 0 && getWeekday(date) < 6;
        case d === 'weekend':   return getWeekday(date) === 0 || getWeekday(date) === 6;

        case (isDefined(tmp = English.weekdayMap[d])):
          return getWeekday(date) === tmp;
        case (isDefined(tmp = English.monthMap[d])):
          return getMonth(date) === tmp;
      }
    }
    return compareDate(date, d, margin);
  }

  function compareDate(date, d, margin, localeCode, options) {
    var loMargin = 0, hiMargin = 0, timezoneShift, compareEdges, override, min, max, p, t;

    function getTimezoneShift() {
      // If there is any specificity in the date then we're implicitly not
      // checking absolute time, so ignore timezone shifts.
      if (p.set && p.set.specificity) {
        return 0;
      }
      return (tzOffset(p.date) - tzOffset(date)) * MINUTES;
    }

    function addSpecificUnit() {
      var unit = DateUnits[p.set.specificity];
      return advanceDate(cloneDate(p.date), unit.name, 1).getTime() - 1;
    }

    if (_utc(date)) {
      options = options || {};
      options.fromUTC = true;
      options.setUTC = true;
    }

    p = getExtendedDate(null, d, options, true);

    if (margin > 0) {
      loMargin = hiMargin = margin;
      override = true;
    }
    if (!dateIsValid(p.date)) return false;
    if (p.set && p.set.specificity) {
      if (isDefined(p.set.edge) || isDefined(p.set.shift)) {
        compareEdges = true;
        moveToBeginningOfUnit(p.date, p.set.specificity, localeCode);
      }
      if (compareEdges || p.set.specificity === MONTH_INDEX) {
        max = moveToEndOfUnit(cloneDate(p.date), p.set.specificity, localeCode).getTime();
      } else {
        max = addSpecificUnit();
      }
      if (!override && isDefined(p.set.sign) && p.set.specificity) {
        // If the time is relative, there can occasionally be an disparity between
        // the relative date and "now", which it is being compared to, so set an
        // extra margin to account for this.
        loMargin = 50;
        hiMargin = -50;
      }
    }
    t   = date.getTime();
    min = p.date.getTime();
    max = max || min;
    timezoneShift = getTimezoneShift();
    if (timezoneShift) {
      min -= timezoneShift;
      max -= timezoneShift;
    }
    return t >= (min - loMargin) && t <= (max + hiMargin);
  }

  function compareDay(d, shift) {
    var comp = getNewDate();
    if (shift) {
      setDate(comp, getDate(comp) + shift);
    }
    return getYear(d) === getYear(comp) &&
           getMonth(d) === getMonth(comp) &&
           getDate(d) === getDate(comp);
  }

  function createDate(d, options, forceClone) {
    return getExtendedDate(null, d, options, forceClone).date;
  }

  function createDateWithContext(contextDate, d, options, forceClone) {
    return getExtendedDate(contextDate, d, options, forceClone).date;
  }

  function getExtendedDate(contextDate, d, opt, forceClone) {

    var date, set, loc, options, afterCallbacks, relative, weekdayDir;

    afterCallbacks = [];
    options = getDateOptions(opt);

    function getDateOptions(opt) {
      var options = isString(opt) ? { locale: opt } : opt || {};
      options.prefer = +!!getOwn(options, 'future') - +!!getOwn(options, 'past');
      return options;
    }

    function getFormatParams(match, dif) {
      var set = getOwn(options, 'params') || {};
      forEach(dif.to, function(field, i) {
        var str = match[i + 1], token, val;
        if (!str) return;
        if (field === 'yy' || field === 'y') {
          field = 'year';
          val = getYearFromAbbreviation(str, date, getOwn(options, 'prefer'));
        } else if (token = getOwn(ParsingTokens, field)) {
          field = token.param || field;
          val = getParsingTokenValue(token, str);
        } else {
          val = loc.getTokenValue(field, str);
        }
        set[field] = val;
      });
      return set;
    }

    // Clone date will set the utc flag, but it will
    // be overriden later, so set option flags instead.
    function cloneDateByFlag(d, clone) {
      if (_utc(d) && !isDefined(getOwn(options, 'fromUTC'))) {
        options.fromUTC = true;
      }
      if (_utc(d) && !isDefined(getOwn(options, 'setUTC'))) {
        options.setUTC = true;
      }
      if (clone) {
        d = new Date(d.getTime());
      }
      return d;
    }

    function afterDateSet(fn) {
      afterCallbacks.push(fn);
    }

    function fireCallbacks() {
      forEach(afterCallbacks, function(fn) {
        fn.call();
      });
    }

    function parseStringDate(str) {

      str = str.toLowerCase();

      // The act of getting the locale will initialize
      // if it is missing and add the required formats.
      loc = localeManager.get(getOwn(options, 'locale'));

      for (var i = 0, dif, match; dif = loc.compiledFormats[i]; i++) {
        match = str.match(dif.reg);
        if (match) {

          // Note that caching the format will modify the compiledFormats array
          // which is not a good idea to do inside its for loop, however we
          // know at this point that we have a matched format and that we will
          // break out below, so simpler to do it here.
          loc.cacheFormat(dif, i);

          set = getFormatParams(match, dif);

          if (isDefined(set.timestamp)) {
            str = set.timestamp;
            set = null;
            break;
          }

          if (isDefined(set.ampm)) {
            handleAmpm(set.ampm);
          }

          if (set.utc || isDefined(set.tzHour)) {
            handleTimezoneOffset(set.tzHour, set.tzMinute, set.tzSign);
          }

          if (isDefined(set.shift) && isUndefined(set.unit)) {
            // "next january", "next monday", etc
            handleUnitlessShift();
          }

          if (isDefined(set.num) && isUndefined(set.unit)) {
            // "the second of January", etc
            handleUnitlessNum(set.num);
          }

          if (set.midday) {
            // "noon" and "midnight"
            handleMidday(set.midday);
          }

          if (isDefined(set.day)) {
            // Relative day localizations such as "today" and "tomorrow".
            handleRelativeDay(set.day);
          }

          if (isDefined(set.unit)) {
            // "3 days ago", etc
            handleRelativeUnit(set.unit);
          }

          if (set.edge) {
            // "the end of January", etc
            handleEdge(set.edge, set);
          }

          if (set.yearSign) {
            set.year *= set.yearSign;
          }

          break;
        }
      }

      if (!set) {
        // Fall back to native parsing
        date = new Date(str);
        if (getOwn(options, 'fromUTC')) {
          // Falling back to system date here which cannot be parsed as UTC,
          // so if we're forcing UTC then simply add the offset.
          date.setTime(date.getTime() + (tzOffset(date) * MINUTES));
        }
      } else if (relative) {
        updateDate(date, set, false, 1);
      } else {
        if (_utc(date)) {
          // UTC times can traverse into other days or even months,
          // so preemtively reset the time here to prevent this.
          resetTime(date);
        }
        updateDate(date, set, true, 0, getOwn(options, 'prefer'), weekdayDir);
      }
      fireCallbacks();
      return date;
    }

    function handleAmpm(ampm) {
      if (ampm === 1 && set.hour < 12) {
        // If the time is 1pm-11pm advance the time by 12 hours.
        set.hour += 12;
      } else if (ampm === 0 && set.hour === 12) {
        // If it is 12:00am then set the hour to 0.
        set.hour = 0;
      }
    }

    function handleTimezoneOffset(tzHour, tzMinute, tzSign) {
      // Adjust for timezone offset
      _utc(date, true);
      var offset = (tzSign || 1) * ((tzHour || 0) * 60 + (tzMinute || 0));
      if (offset) {
        set.minute = (set.minute || 0) - offset;
      }
    }

    function handleUnitlessShift() {
      if (isDefined(set.month)) {
        // "next January"
        set.unit = YEAR_INDEX;
      } else if (isDefined(set.weekday)) {
        // "next Monday"
        set.unit = WEEK_INDEX;
      }
    }

    function handleUnitlessNum(num) {
      if (isDefined(set.weekday)) {
        // "The second Tuesday of March"
        setOrdinalWeekday(num);
      } else if (isDefined(set.month)) {
        // "The second of March"
        set.date = set.num;
      }
    }

    function handleMidday(hour) {
      set.hour = hour % 24;
      if (hour > 23) {
        // If the date has hours past 24, we need to prevent it from traversing
        // into a new day as that would make it being part of a new week in
        // ambiguous dates such as "Monday".
        afterDateSet(function() {
          advanceDate(date, 'date', trunc(hour / 24));
        });
      }
    }

    function handleRelativeDay() {
      resetTime(date);
      if (isUndefined(set.unit)) {
        set.unit = DAY_INDEX;
        set.num  = set.day;
        delete set.day;
      }
    }

    function handleRelativeUnit(unitIndex) {
      var num = isDefined(set.num) ? set.num : 1;

      // If a weekday is defined, there are 3 possible formats being applied:
      //
      // 1. "the day after monday": unit is days
      // 2. "next monday": short for "next week monday", unit is weeks
      // 3. "the 2nd monday of next month": unit is months
      //
      // In the first case, we need to set the weekday up front, as the day is
      // relative to it. The second case also needs to be handled up front for
      // formats like "next monday at midnight" which will have its weekday reset
      // if not set up front. The last case will set up the params necessary to
      // shift the weekday and allow separateAbsoluteUnits below to handle setting
      // it after the date has been shifted.
      if(isDefined(set.weekday)) {
        if(unitIndex === MONTH_INDEX) {
          setOrdinalWeekday(num);
          num = 1;
        } else {
          updateDate(date, { weekday: set.weekday }, true);
          delete set.weekday;
        }
      }

      if (set.half) {
        // Allow localized "half" as a standalone colloquialism. Purposely avoiding
        // the locale number system to reduce complexity. The units "month" and
        // "week" are purposely excluded in the English date formats below, as
        // "half a week" and "half a month" are meaningless as exact dates.
        num *= set.half;
      }

      if (isDefined(set.shift)) {
        // Shift and unit, ie "next month", "last week", etc.
        num *= set.shift;
      } else if (set.sign) {
        // Unit and sign, ie "months ago", "weeks from now", etc.
        num *= set.sign;
      }

      if (isDefined(set.day)) {
        // "the day after tomorrow"
        num += set.day;
        delete set.day;
      }

      // Formats like "the 15th of last month" or "6:30pm of next week"
      // contain absolute units in addition to relative ones, so separate
      // them here, remove them from the params, and set up a callback to
      // set them after the relative ones have been set.
      separateAbsoluteUnits(unitIndex);

      // Finally shift the unit.
      set[English.units[unitIndex]] = num;
      relative = true;
    }

    function handleEdge(edge, params) {
      var edgeIndex = params.unit, weekdayOfMonth;
      if (!edgeIndex) {
        // If we have "the end of January", then we need to find the unit index.
        iterateOverHigherDateParams(params, function(unitName, val, unit, i) {
          if (unitName === 'weekday' && isDefined(params.month)) {
            // If both a month and weekday exist, then we have a format like
            // "the last tuesday in November, 2012", where the "last" is still
            // relative to the end of the month, so prevent the unit "weekday"
            // from taking over.
            return;
          }
          edgeIndex = i;
        });
      }
      if (edgeIndex === MONTH_INDEX && isDefined(params.weekday)) {
        // If a weekday in a month exists (as described above),
        // then set it up to be set after the date has been shifted.
        weekdayOfMonth = params.weekday;
        delete params.weekday;
      }
      afterDateSet(function() {
        var stopIndex;
        // "edge" values that are at the very edge are "2" so the beginning of the
        // year is -2 and the end of the year is 2. Conversely, the "last day" is
        // actually 00:00am so it is 1. -1 is reserved but unused for now.
        if (edge < 0) {
          moveToBeginningOfUnit(date, edgeIndex, getOwn(options, 'locale'));
        } else if (edge > 0) {
          if (edge === 1) {
            stopIndex = DAY_INDEX;
            moveToBeginningOfUnit(date, DAY_INDEX);
          }
          moveToEndOfUnit(date, edgeIndex, getOwn(options, 'locale'), stopIndex);
        }
        if (isDefined(weekdayOfMonth)) {
          setWeekday(date, weekdayOfMonth, -edge);
          resetTime(date);
        }
      });
      if (edgeIndex === MONTH_INDEX) {
        params.specificity = DAY_INDEX;
      } else {
        params.specificity = edgeIndex - 1;
      }
    }

    function setOrdinalWeekday(num) {
      // If we have "the 2nd Tuesday of June", then pass the "weekdayDir"
      // flag along to updateDate so that the date does not accidentally traverse
      // into the previous month. This needs to be independent of the "prefer"
      // flag because we are only ensuring that the weekday is in the future, not
      // the entire date.
      set.weekday = 7 * (num - 1) + set.weekday;
      set.date = 1;
      weekdayDir = 1;
    }

    function separateAbsoluteUnits(unitIndex) {
      var params;

      iterateOverDateParams(set, function(name, val, unit, i) {
        // If there is a time unit set that is more specific than
        // the matched unit we have a string like "5:30am in 2 minutes",
        // which is meaningless, so invalidate the date...
        if (i >= unitIndex) {
          date.setTime(NaN);
          return false;
        } else if (i < unitIndex) {
          // ...otherwise set the params to set the absolute date
          // as a callback after the relative date has been set.
          params = params || {};
          params[name] = val;
          deleteDateParam(set, name);
        }
      });
      if (params) {
        afterDateSet(function() {
          updateDate(date, params, true, false, getOwn(options, 'prefer'), weekdayDir);
        });
        if (set.edge) {
          // "the end of March of next year"
          handleEdge(set.edge, params);
          delete set.edge;
        }
      }
    }

    if (contextDate && d) {
      // If a context date is passed ("get" and "unitsFromNow"),
      // then use it as the starting point.
      date = cloneDateByFlag(contextDate, true);
    } else {
      date = getNewDate();
    }

    _utc(date, getOwn(options, 'fromUTC'));

    if (isString(d)) {
      date = parseStringDate(d);
    } else if (isDate(d)) {
      date = cloneDateByFlag(d, hasOwn(options, 'clone') || forceClone);
    } else if (isObjectType(d)) {
      set = simpleClone(d);
      updateDate(date, set, true);
    } else if (isNumber(d) || d === null) {
      date.setTime(d);
    }
    // A date created by parsing a string presumes that the format *itself* is
    // UTC, but not that the date, once created, should be manipulated as such. In
    // other words, if you are creating a date object from a server time
    // "2012-11-15T12:00:00Z", in the majority of cases you are using it to create
    // a date that will, after creation, be manipulated as local, so reset the utc
    // flag here unless "setUTC" is also set.
    _utc(date, !!getOwn(options, 'setUTC'));
    return {
      set: set,
      date: date
    };
  }

  function updateDate(d, params, reset, advance, prefer, weekdayDir) {
    var upperUnitIndex;

    function setUpperUnit(unitName, unitIndex) {
      if (prefer && !upperUnitIndex) {
        if (unitName === 'weekday') {
          upperUnitIndex = WEEK_INDEX;
        } else {
          upperUnitIndex = getHigherUnitIndex(unitIndex);
        }
      }
    }

    function setSpecificity(unitIndex) {
      // Other functions may preemptively set the specificity before arriving
      // here so concede to them if they have already set more specific units.
      if (unitIndex > params.specificity) {
        return;
      }
      params.specificity = unitIndex;
    }

    function canDisambiguate() {
      if (!upperUnitIndex || upperUnitIndex > YEAR_INDEX) {
        return;
      }
      switch(prefer) {
        case -1: return d > getNewDate();
        case  1: return d < getNewDate();
      }
    }

    function disambiguateHigherUnit() {
      var unit = DateUnits[upperUnitIndex];
      advance = prefer;
      setUnit(unit.name, 1, unit, upperUnitIndex);
    }

    function handleFraction(unit, unitIndex, fraction) {
      if (unitIndex) {
        var lowerUnit = DateUnits[getLowerUnitIndex(unitIndex)];
        var val = round(unit.multiplier / lowerUnit.multiplier * fraction);
        params[lowerUnit.name] = val;
      }
    }

    function monthHasShifted(d, targetMonth) {
      if (targetMonth < 0) {
        targetMonth = targetMonth % 12 + 12;
      }
      return targetMonth % 12 !== getMonth(d);
    }

    function setUnit(unitName, value, unit, unitIndex) {
      var method = unit.method, checkMonth, fraction;

      setUpperUnit(unitName, unitIndex);
      setSpecificity(unitIndex);

      fraction = value % 1;
      if (fraction) {
        handleFraction(unit, unitIndex, fraction);
        value = trunc(value);
      }

      if (unitName === 'weekday') {
        if (!advance) {
          // Weekdays are always considered absolute units so simply set them
          // here even if it is an "advance" operation. This is to help avoid
          // ambiguous meanings in "advance" as well as to neatly allow formats
          // like "Wednesday of next week" without more complex logic.
          setWeekday(d, value, weekdayDir);
        }
        return;
      }
      checkMonth = unitIndex === MONTH_INDEX && getDate(d) > 28;

      // If we are advancing or rewinding, then we need we need to set the
      // absolute time if the unit is "hours" or less. This is due to the fact
      // that setting by method is ambiguous during DST shifts. For example,
      // 1:00am on November 1st 2015 occurs twice in North American timezones
      // with DST, the second time being after the clocks are rolled back at
      // 2:00am. When springing forward this is automatically handled as there
      // is no 2:00am so the date automatically jumps to 3:00am. However, when
      // rolling back, setHours(2) will always choose the first "2am" even if
      // the date is currently set to the second, causing unintended jumps.
      // This ambiguity is unavoidable when setting dates as the notation is
      // ambiguous. However when advancing, we clearly want the resulting date
      // to be an acutal hour ahead, which can only be accomplished by setting
      // the absolute time. Conversely, any unit higher than "hours" MUST use
      // the internal set methods, as they are ambiguous as absolute units of
      // time. Years may be 365 or 366 days depending on leap years, months are
      // all over the place, and even days may be 23-25 hours depending on DST
      // shifts. Finally, note that the kind of jumping described above will
      // occur when calling ANY "set" method on the date and will occur even if
      // the value being set is identical to the one currently set (i.e.
      // setHours(2) on a date at 2am may not be a noop). This is precarious,
      // so avoiding this situation in callDateSet by checking up front that
      // the value is not the same before setting.
      if (advance && !unit.ambiguous) {
        d.setTime(d.getTime() + (value * advance * unit.multiplier));
        return;
      } else if (advance) {
        if (unitIndex === WEEK_INDEX) {
          value *= 7;
          method = DateUnits[DAY_INDEX].method;
        }
        value = (value * advance) + callDateGet(d, method);
      }
      callDateSetWithWeek(d, method, value, advance);
      if (checkMonth && monthHasShifted(d, value)) {
        // As we are setting the units in reverse order, there is a chance that
        // our date may accidentally traverse into a new month, such as setting
        // { month: 1, date 15 } on January 31st. Check for this here and reset
        // the date to the last day of the previous month if this has happened.
        setDate(d, 0);
      }
    }

    if (isNumber(params) && advance) {
      // If param is a number and advancing, the number is in milliseconds.
      params = { millisecond: params };
    } else if (isNumber(params)) {
      // Otherwise just set the timestamp and return.
      d.setTime(params);
      return d;
    }

    iterateOverDateParams(params, setUnit);

    if (reset && params.specificity) {
      resetLowerUnits(d, params.specificity);
    }

    // If past or future is preferred, then the process of "disambiguation" will
    // ensure that an ambiguous time/date ("4pm", "thursday", "June", etc.) will
    // be in the past or future. Weeks are only considered ambiguous if there is
    // a weekday, i.e. "thursday" is an ambiguous week, but "the 4th" is an
    // ambiguous month.
    if (canDisambiguate()) {
      disambiguateHigherUnit();
    }
    return d;
  }

  // Locale helpers
  var English, localeManager;

  function getEnglishVariant(v) {
    return simpleMerge(simpleClone(EnglishLocaleBaseDefinition), v);
  }

  function arrayToRegAlternates(arr) {
    var joined = arr.join('');
    if (!arr || !arr.length) {
      return '';
    }
    if (joined.length === arr.length) {
      return '[' + joined + ']';
    }
    // map handles sparse arrays so no need to compact the array here.
    return map(arr, escapeRegExp).join('|');
  }

  function getRegNonCapturing(src, opt) {
    if (src.length > 1) {
      src = '(?:' + src + ')';
    }
    if (opt) {
      src += '?';
    }
    return src;
  }

  function getParsingTokenWithSuffix(field, src, suffix) {
    var token = LocalizedParsingTokens[field];
    if (token.requiresSuffix) {
      src = getRegNonCapturing(src + getRegNonCapturing(suffix));
    } else if (token.requiresSuffixOr) {
      src += getRegNonCapturing(token.requiresSuffixOr + '|' + suffix);
    } else {
      src += getRegNonCapturing(suffix, true);
    }
    return src;
  }

  function getArrayWithOffset(arr, n, alternate, offset) {
    var val;
    if (alternate > 1) {
      val = arr[n + (alternate - 1) * offset];
    }
    return val || arr[n];
  }

  function buildLocales() {

    function LocaleManager(loc) {
      this.locales = {};
      this.add(loc);
    }

    LocaleManager.prototype = {

      get: function(code, fallback) {
        var loc = this.locales[code];
        if (!loc && LazyLoadedLocales[code]) {
          loc = this.add(code, LazyLoadedLocales[code]);
        } else if (!loc && code) {
          loc = this.locales[code.slice(0, 2)];
        }
        return loc || fallback === false ? loc : this.current;
      },

      getAll: function() {
        return this.locales;
      },

      set: function(code) {
        var loc = this.get(code, false);
        if (!loc) {
          throw new TypeError('Invalid Locale: ' + code);
        }
        return this.current = loc;
      },

      add: function(code, def) {
        if (!def) {
          def = code;
          code = def.code;
        } else {
          def.code = code;
        }
        var loc = def.compiledFormats ? def : getNewLocale(def);
        this.locales[code] = loc;
        if (!this.current) {
          this.current = loc;
        }
        return loc;
      },

      remove: function(code) {
        if (this.current.code === code) {
          this.current = this.get('en');
        }
        return delete this.locales[code];
      }

    };

    // Sorry about this guys...
    English = getNewLocale(AmericanEnglishDefinition);
    localeManager = new LocaleManager(English);
  }

  function getNewLocale(def) {

    function Locale(def) {
      this.init(def);
    }

    Locale.prototype = {

      getMonthName: function(n, alternate) {
        if (this.monthSuffix) {
          return (n + 1) + this.monthSuffix;
        }
        return getArrayWithOffset(this.months, n, alternate, 12);
      },

      getWeekdayName: function(n, alternate) {
        return getArrayWithOffset(this.weekdays, n, alternate, 7);
      },

      getTokenValue: function(field, str) {
        var map = this[field + 'Map'], val;
        if (map) {
          val = map[str];
        }
        if (isUndefined(val)) {
          val = this.getNumber(str);
          if (field === 'month') {
            // Months are the only numeric date field
            // whose value is not the same as its number.
            val -= 1;
          }
        }
        return val;
      },

      getNumber: function(str) {
        var num = this.numeralMap[str];
        if (isDefined(num)) {
          return num;
        }
        // The unary plus operator here show better performance and handles
        // every format that parseFloat does with the exception of trailing
        // characters, which are guaranteed not to be in our string at this point.
        num = +str.replace(/,/, '.');
        if (!isNaN(num)) {
          return num;
        }
        num = this.getNumeralValue(str);
        if (!isNaN(num)) {
          this.numeralMap[str] = num;
          return num;
        }
        return num;
      },

      getNumeralValue: function(str) {
        var place = 1, num = 0, lastWasPlace, isPlace, numeral, digit, arr;
        // Note that "numerals" that need to be converted through this method are
        // all considered to be single characters in order to handle CJK. This
        // method is by no means unique to CJK, but the complexity of handling
        // inflections in non-CJK languages adds too much overhead for not enough
        // value, so avoiding for now.
        arr = str.split('');
        for (var i = arr.length - 1; numeral = arr[i]; i--) {
          digit = getOwn(this.numeralMap, numeral);
          if (isUndefined(digit)) {
            digit = getOwn(fullWidthNumberMap, numeral) || 0;
          }
          isPlace = digit > 0 && digit % 10 === 0;
          if (isPlace) {
            if (lastWasPlace) {
              num += place;
            }
            if (i) {
              place = digit;
            } else {
              num += digit;
            }
          } else {
            num += digit * place;
            place *= 10;
          }
          lastWasPlace = isPlace;
        }
        return num;
      },

      getOrdinal: function(n) {
        var suffix = this.ordinalSuffix;
        return suffix || getOrdinalSuffix(n);
      },

      getRelativeFormat: function(adu, type) {
        return this.convertAdjustedToFormat(adu, type);
      },

      getDuration: function(ms) {
        return this.convertAdjustedToFormat(getAdjustedUnitForNumber(max(0, ms)), 'duration');
      },

      getFirstDayOfWeek: function() {
        var val = this.firstDayOfWeek;
        return isDefined(val) ? val : ISO_FIRST_DAY_OF_WEEK;
      },

      getFirstDayOfWeekYear: function() {
        return this.firstDayOfWeekYear || ISO_FIRST_DAY_OF_WEEK_YEAR;
      },

      convertAdjustedToFormat: function(adu, type) {
        var sign, unit, mult,
            num    = adu[0],
            u      = adu[1],
            ms     = adu[2],
            format = this[type] || this.relative;
        if (isFunction(format)) {
          return format.call(this, num, u, ms, type);
        }
        mult = !this.plural || num === 1 ? 0 : 1;
        unit = this.units[mult * 8 + u] || this.units[u];
        sign = this[ms > 0 ? 'fromNow' : 'ago'];
        return format.replace(/\{(.*?)\}/g, function(full, match) {
          switch(match) {
            case 'num': return num;
            case 'unit': return unit;
            case 'sign': return sign;
          }
        });
      },

      cacheFormat: function(dif, i) {
        this.compiledFormats.splice(i, 1);
        this.compiledFormats.unshift(dif);
      },

      addFormat: function(src, to) {
        var loc = this;

        function getTokenSrc(str) {
          var suffix, src, val,
              opt   = str.match(/\?$/),
              nc    = str.match(/^(\d+)\??$/),
              slice = str.match(/(\d)(?:-(\d))?/),
              key   = str.replace(/[^a-z]+$/i, '');

          // Allowing alias tokens such as {time}
          if (val = getOwn(loc.parsingAliases, key)) {
            src = replaceParsingTokens(val);
            if (opt) {
              src = getRegNonCapturing(src, true);
            }
            return src;
          }

          if (nc) {
            src = loc.tokens[nc[1]];
          } else if (val = getOwn(ParsingTokens, key)) {
            src = val.src;
          } else {
            val = getOwn(loc.parsingTokens, key) || getOwn(loc, key);

            // Both the "months" array and the "month" parsing token can be accessed
            // by either {month} or {months}, falling back as necessary, however
            // regardless of whether or not a fallback occurs, the final field to
            // be passed to addRawFormat must be normalized as singular.
            key = key.replace(/s$/, '');

            if (!val) {
              val = getOwn(loc.parsingTokens, key) || getOwn(loc, key + 's');
            }

            if (isString(val)) {
              src = val;
              suffix = loc[key + 'Suffix'];
            } else {
              if (slice) {
                val = filter(val, function(m, i) {
                  var mod = i % (loc.units ? 8 : val.length);
                  return mod >= slice[1] && mod <= (slice[2] || slice[1]);
                });
              }
              src = arrayToRegAlternates(val);
            }
          }
          if (!src) {
            return '';
          }
          if (nc) {
            // Non-capturing tokens like {0}
            src = getRegNonCapturing(src);
          } else {
            // Capturing group and add to parsed tokens
            to.push(key);
            src = '(' + src + ')';
          }
          if (suffix) {
            // Date/time suffixes such as those in CJK
            src = getParsingTokenWithSuffix(key, src, suffix);
          }
          if (opt) {
            src += '?';
          }
          return src;
        }

        function replaceParsingTokens(str) {

          // Make spaces optional
          str = str.replace(/ /g, ' ?');

          return str.replace(/\{([^,]+?)\}/g, function(match, token) {
            var tokens = token.split('|'), src;
            if (tokens.length > 1) {
              src = getRegNonCapturing(map(tokens, getTokenSrc).join('|'));
            } else {
              src = getTokenSrc(token);
            }
            return src;
          });
        }

        if (!to) {
          to = [];
          src = replaceParsingTokens(src);
        }

        loc.addRawFormat(src, to);
      },

      addRawFormat: function(format, to) {
        this.compiledFormats.unshift({
          reg: RegExp('^ *' + format + ' *$', 'i'),
          to: to
        });
      },

      init: function(def) {
        var loc = this;

        // -- Initialization helpers

        function initFormats() {
          loc.compiledFormats = [];
          loc.parsingAliases = {};
          loc.parsingTokens = {};
        }

        function initDefinition() {
          simpleMerge(loc, def);
        }

        function initArrayFields() {
          forEach(LOCALE_ARRAY_FIELDS, function(name) {
            var val = loc[name];
            if (isString(val)) {
              loc[name] = commaSplit(val);
            } else if (!val) {
              loc[name] = [];
            }
          });
        }

        // -- Value array build helpers

        function buildValueArray(name, mod, map, fn) {
          var field = name, all = [], setMap;
          if (!loc[field]) {
            field += 's';
          }
          if (!map) {
            map = {};
            setMap = true;
          }
          forAllAlternates(field, function(alt, j, i) {
            var idx = j * mod + i, val;
            val = fn ? fn(i) : i;
            map[alt] = val;
            map[alt.toLowerCase()] = val;
            all[idx] = alt;
          });
          loc[field] = all;
          if (setMap) {
            loc[name + 'Map'] = map;
          }
        }

        function forAllAlternates(field, fn) {
          forEach(loc[field], function(str, i) {
            forEachAlternate(str, function(alt, j) {
              fn(alt, j, i);
            });
          });
        }

        function forEachAlternate(str, fn) {
          var arr = map(str.split('+'), function(split) {
            return split.replace(/(.+):(.+)$/, function(full, base, suffixes) {
              return map(suffixes.split('|'), function(suffix) {
                return base + suffix;
              }).join('|');
            });
          }).join('|');
          forEach(arr.split('|'), fn);
        }

        function buildNumerals() {
          var map = {};
          buildValueArray('numeral', 10, map);
          buildValueArray('article', 1, map, function() {
            return 1;
          });
          buildValueArray('placeholder', 4, map, function(n) {
            return pow(10, n + 1);
          });
          loc.numeralMap = map;
        }

        function buildTimeFormats() {
          loc.parsingAliases['time'] = getTimeFormat();
          loc.parsingAliases['tzOffset'] = getTZOffsetFormat();
        }

        function getTimeFormat() {
          var src;
          if (loc.ampmFront) {
            // "ampmFront" exists mostly for CJK locales, which also presume that
            // time suffixes exist, allowing this to be a simpler regex.
            src = '{ampm?} {hour} (?:{minute} (?::?{second})?)?';
          } else if(loc.ampm.length) {
            src = '{hour}(?:[.:]{minute}(?:[.:]{second})? {ampm?}| {ampm})';
          } else {
            src = '{hour}(?:[.:]{minute}(?:[.:]{second})?)';
          }
          return src;
        }

        function getTZOffsetFormat() {
          return '(?:{Z}|{GMT?}(?:{tzSign}{tzHour}(?::?{tzMinute}(?: \\([\\w\\s]+\\))?)?)?)?';
        }

        function buildParsingTokens() {
          forEachProperty(LocalizedParsingTokens, function(token, name) {
            var src, arr;
            src = token.base ? ParsingTokens[token.base].src : token.src;
            if (token.requiresNumerals || loc.numeralUnits) {
              src += getNumeralSrc();
            }
            arr = loc[name + 's'];
            if (arr && arr.length) {
              src += '|' + arrayToRegAlternates(arr);
            }
            loc.parsingTokens[name] = src;
          });
        }

        function getNumeralSrc() {
          var all, src = '';
          all = loc.numerals.concat(loc.placeholders).concat(loc.articles);
          if (loc.allowsFullWidth) {
            all = all.concat(fullWidthNumbers.split(''));
          }
          if (all.length) {
            src = '|(?:' + arrayToRegAlternates(all) + ')+';
          }
          return src;
        }

        function buildTimeSuffixes() {
          iterateOverDateUnits(function(unit, i) {
            var token = loc.timeSuffixes[i];
            if (token) {
              loc[(unit.alias || unit.name) + 'Suffix'] = token;
            }
          });
        }

        function buildModifiers() {
          forEach(loc.modifiers, function(modifier) {
            var name = modifier.name, mapKey = name + 'Map', map;
            map = loc[mapKey] || {};
            forEachAlternate(modifier.src, function(alt, j) {
              var token = getOwn(loc.parsingTokens, name), val = modifier.value;
              map[alt] = val;
              loc.parsingTokens[name] = token ? token + '|' + alt : alt;
              if (modifier.name === 'sign' && j === 0) {
                // Hooking in here to set the first "fromNow" or "ago" modifier
                // directly on the locale, so that it can be reused in the
                // relative format.
                loc[val === 1 ? 'fromNow' : 'ago'] = alt;
              }
            });
            loc[mapKey] = map;
          });
        }

        // -- Format adding helpers

        function addCoreFormats() {
          forEach(CoreParsingFormats, function(df) {
            var src = df.src;
            if (df.mdy && loc.mdy) {
              // Use the mm/dd/yyyy variant if it
              // exists and the locale requires it
              src = df.mdy;
            }
            if (df.time) {
              // Core formats that allow time require the time
              // reg on both sides, so add both versions here.
              loc.addFormat(getFormatWithTime(src, true));
              loc.addFormat(getFormatWithTime(src));
            } else {
              loc.addFormat(src);
            }
          });
          loc.addFormat('{time}');
        }

        function addLocaleFormats() {
          addFormatSet('parse');
          addFormatSet('timeParse', true);
          addFormatSet('timeFrontParse', true, true);
        }

        function addFormatSet(field, allowTime, timeFront) {
          forEach(loc[field], function(format) {
            if (allowTime) {
              format = getFormatWithTime(format, timeFront);
            }
            loc.addFormat(format);
          });
        }

        function getFormatWithTime(baseFormat, timeBefore) {
          if (timeBefore) {
            return getTimeBefore() + baseFormat;
          }
          return baseFormat + getTimeAfter();
        }

        function getTimeBefore() {
          return getRegNonCapturing('{time}[,\\s\\u3000]', true);
        }

        function getTimeAfter() {
          var markers = ',?[\\s\\u3000]', localized;
          localized = arrayToRegAlternates(loc.timeMarkers);
          if (localized) {
            markers += '| (?:' + localized + ') ';
          }
          markers = getRegNonCapturing(markers, loc.timeMarkerOptional);
          return getRegNonCapturing(markers + '{time}', true);
        }

        initFormats();
        initDefinition();
        initArrayFields();

        buildValueArray('month', 12);
        buildValueArray('weekday', 7);
        buildValueArray('unit', 8);
        buildValueArray('ampm', 2);

        buildNumerals();
        buildTimeFormats();
        buildParsingTokens();
        buildTimeSuffixes();
        buildModifiers();

        // The order of these formats is important. Order is reversed so formats
        // that are initialized later will take precedence. Generally, this means
        // that more specific formats should come later.
        addCoreFormats();
        addLocaleFormats();

      }

    };

    return new Locale(def);
  }

  /***
   * @method [units]Since(d, [options])
   * @returns Number
   * @short Returns the time since [d].
   * @extra [d] will accept a date object, timestamp, or string. If not specified,
   *        [d] is assumed to be now. `unitsAgo` is provided as an alias to make
   *        this more readable when [d] is assumed to be the current date.
   *        [options] can be an object or a locale code as a string. See `create`
   *        for more.
   *
   * @set
   *   millisecondsSince
   *   secondsSince
   *   minutesSince
   *   hoursSince
   *   daysSince
   *   weeksSince
   *   monthsSince
   *   yearsSince
   *
   * @example
   *
   *   new Date().millisecondsSince('1 hour ago') -> 3,600,000
   *   new Date().daysSince('1 week ago')         -> 7
   *   new Date().yearsSince('15 years ago')      -> 15
   *   lastYear.yearsAgo()                 -> 1
   *
   * @param {string|number|Date} d
   * @param {DateCreateOptions} options
   *
   ***
   * @method [units]Ago()
   * @returns Number
   * @short Returns the time ago in the appropriate unit.
   *
   * @set
   *   millisecondsAgo
   *   secondsAgo
   *   minutesAgo
   *   hoursAgo
   *   daysAgo
   *   weeksAgo
   *   monthsAgo
   *   yearsAgo
   *
   * @example
   *
   *   lastYear.millisecondsAgo() -> 3,600,000
   *   lastYear.daysAgo()         -> 7
   *   lastYear.yearsAgo()        -> 15
   *
   ***
   * @method [units]Until([d], [options])
   * @returns Number
   * @short Returns the time until [d].
   * @extra [d] will accept a date object, timestamp, or string. If not specified,
   *        [d] is assumed to be now. `unitsFromNow` is provided as an alias to
   *        make this more readable when [d] is assumed to be the current date.
   *        [options] can be an object or a locale code as a string. See `create`
   *        for more.
   *
   *
   * @set
   *   millisecondsUntil
   *   secondsUntil
   *   minutesUntil
   *   hoursUntil
   *   daysUntil
   *   weeksUntil
   *   monthsUntil
   *   yearsUntil
   *
   * @example
   *
   *   new Date().millisecondsUntil('1 hour from now') -> 3,600,000
   *   new Date().daysUntil('1 week from now')         -> 7
   *   new Date().yearsUntil('15 years from now')      -> 15
   *   nextYear.yearsFromNow()                  -> 1
   *
   * @param {string|number|Date} d
   * @param {DateCreateOptions} options
   *
   ***
   * @method [units]FromNow()
   * @returns Number
   * @short Returns the time from now in the appropriate unit.
   *
   * @set
   *   millisecondsFromNow
   *   secondsFromNow
   *   minutesFromNow
   *   hoursFromNow
   *   daysFromNow
   *   weeksFromNow
   *   monthsFromNow
   *   yearsFromNow
   *
   * @example
   *
   *   nextYear.millisecondsFromNow() -> 3,600,000
   *   nextYear.daysFromNow()         -> 7
   *   nextYear.yearsFromNow()        -> 15
   *
   ***
   * @method add[Units](n, [reset] = false)
   * @returns Date
   * @short Adds `n` units to the date. If [reset] is true, all lower units will
   *        be reset.
   * @extra This method modifies the date! Note that in the case of `addMonths`,
   *        the date may fall on a date that doesn't exist (i.e. February 30). In
   *        this case the date will be shifted to the last day of the month. Don't
   *        use `addMonths` if you need precision.
   *
   * @set
   *   addMilliseconds
   *   addSeconds
   *   addMinutes
   *   addHours
   *   addDays
   *   addWeeks
   *   addMonths
   *   addYears
   *
   * @example
   *
   *   new Date().addYears(5)        -> current time + 5 years
   *   new Date().addDays(5)         -> current time + 5 days
   *   new Date().addDays(5, true)   -> current time + 5 days (time reset)
   *
   * @param {number} n
   * @param {boolean} [reset]
   *
   ***
   * @method isLast[Unit]([localeCode])
   * @returns Boolean
   * @short Returns true if the date is last week, month, or year.
   * @extra This method takes an optional locale code for `isLastWeek`, which is
   *        locale dependent. The default locale code is `en`, which places
   *        Sunday at the beginning of the week. You can pass `en-GB` as a quick
   *        way to force Monday as the beginning of the week.
   *
   * @set
   *   isLastWeek
   *   isLastMonth
   *   isLastYear
   *
   * @example
   *
   *   yesterday.isLastWeek()  -> true or false?
   *   yesterday.isLastMonth() -> probably not...
   *   yesterday.isLastYear()  -> even less likely...
   *
   * @param {string} [localeCode]
   *
   ***
   * @method isThis[Unit]([localeCode])
   * @returns Boolean
   * @short Returns true if the date is this week, month, or year.
   * @extra This method takes an optional locale code for `isThisWeek`, which is
   *        locale dependent. The default locale code is `en`, which places
   *        Sunday at the beginning of the week. You can pass `en-GB` as a quick
   *        way to force Monday as the beginning of the week.
   *
   * @set
   *   isThisWeek
   *   isThisMonth
   *   isThisYear
   *
   * @example
   *
   *   tomorrow.isThisWeek()  -> true or false?
   *   tomorrow.isThisMonth() -> probably...
   *   tomorrow.isThisYear()  -> signs point to yes...
   *
   * @param {string} [localeCode]
   *
   ***
   * @method isNext[Unit]([localeCode])
   * @returns Boolean
   * @short Returns true if the date is next week, month, or year.
   * @extra This method takes an optional locale code for `isNextWeek`, which is
   *        locale dependent. The default locale code is `en`, which places
   *        Sunday at the beginning of the week. You can pass `en-GB` as a quick
   *        way to force Monday as the beginning of the week.
   *
   * @set
   *   isNextWeek
   *   isNextMonth
   *   isNextYear
   *
   * @example
   *
   *   tomorrow.isNextWeek()  -> true or false?
   *   tomorrow.isNextMonth() -> probably not...
   *   tomorrow.isNextYear()  -> even less likely...
   *
   * @param {string} [localeCode]
   *
   ***
   * @method beginningOf[Unit]([localeCode])
   * @returns Date
   * @short Sets the date to the beginning of the appropriate unit.
   * @extra This method modifies the date! A locale code can be passed for
   *        `beginningOfWeek`, which is locale dependent. If consistency is
   *        needed, use `beginningOfISOWeek` instead.
   *
   * @set
   *   beginningOfDay
   *   beginningOfWeek
   *   beginningOfMonth
   *   beginningOfYear
   *
   * @example
   *
   *   new Date().beginningOfDay()   -> the beginning of today (resets the time)
   *   new Date().beginningOfWeek()  -> the beginning of the week
   *   new Date().beginningOfMonth() -> the beginning of the month
   *   new Date().beginningOfYear()  -> the beginning of the year
   *
   * @param {string} [localeCode]
   *
   ***
   * @method endOf[Unit]([localeCode])
   * @returns Date
   * @short Sets the date to the end of the appropriate unit.
   * @extra This method modifies the date! A locale code can be passed for
   *        `endOfWeek`, which is locale dependent. If consistency is needed, use
   *        `endOfISOWeek` instead.
   *
   * @set
   *   endOfDay
   *   endOfWeek
   *   endOfMonth
   *   endOfYear
   *
   * @example
   *
   *   new Date().endOfDay()   -> the end of today (sets the time to 23:59:59.999)
   *   new Date().endOfWeek()  -> the end of the week
   *   new Date().endOfMonth() -> the end of the month
   *   new Date().endOfYear()  -> the end of the year
   *
   * @param {string} [localeCode]
   *
   ***/
  function buildDateUnitMethods() {

    defineInstanceSimilar(sugarDate, DateUnits, function(methods, unit, index) {
      var name = unit.name, caps = simpleCapitalize(name);

      if (index > DAY_INDEX) {
        forEach(['Last','This','Next'], function(shift) {
          methods['is' + shift + caps] = function(d, localeCode) {
            return compareDate(d, shift + ' ' + name, 0, localeCode, { locale: 'en' });
          };
        });
      }
      if (index > HOURS_INDEX) {
        methods['beginningOf' + caps] = function(d, localeCode) {
          return moveToBeginningOfUnit(d, index, localeCode);
        };
        methods['endOf' + caps] = function(d, localeCode) {
          return moveToEndOfUnit(d, index, localeCode);
        };
      }

      methods['add' + caps + 's'] = function(d, num, reset) {
        return advanceDate(d, name, num, reset);
      };

      var since = function(date, d, options) {
        return getTimeDistanceForUnit(date, createDateWithContext(date, d, options, true), unit);
      };
      var until = function(date, d, options) {
        return getTimeDistanceForUnit(createDateWithContext(date, d, options, true), date, unit);
      };

      methods[name + 'sAgo']   = methods[name + 'sUntil']   = until;
      methods[name + 'sSince'] = methods[name + 'sFromNow'] = since;

    });

  }

  /***
   * @method is[Day]()
   * @returns Boolean
   * @short Returns true if the date falls on the specified day.
   *
   * @set
   *   isToday
   *   isYesterday
   *   isTomorrow
   *   isWeekday
   *   isWeekend
   *   isSunday
   *   isMonday
   *   isTuesday
   *   isWednesday
   *   isThursday
   *   isFriday
   *   isSaturday
   *
   * @example
   *
   *   tomorrow.isToday() -> false
   *   thursday.isTomorrow() -> ?
   *   yesterday.isWednesday() -> ?
   *   today.isWeekend() -> ?
   *
   ***
   * @method isFuture()
   * @returns Boolean
   * @short Returns true if the date is in the future.
   *
   * @example
   *
   *   lastWeek.isFuture() -> false
   *   nextWeek.isFuture() -> true
   *
   ***
   * @method isPast()
   * @returns Boolean
   * @short Returns true if the date is in the past.
   *
   * @example
   *
   *   lastWeek.isPast() -> true
   *   nextWeek.isPast() -> false
   *
   ***/
  function buildRelativeAliases() {
    var special  = spaceSplit('Today Yesterday Tomorrow Weekday Weekend Future Past');
    var weekdays = English.weekdays.slice(0, 7);
    var months   = English.months.slice(0, 12);
    var together = special.concat(weekdays).concat(months);
    defineInstanceSimilar(sugarDate, together, function(methods, name) {
      methods['is'+ name] = function(d) {
        return fullCompareDate(d, name);
      };
    });
  }

  defineStatic(sugarDate, {

    /***
     * @method create(d, [options])
     * @returns Date
     * @static
     * @short Alternate date constructor which accepts text formats, a timestamp,
     *        objects, or another date.
     * @extra If no argument is given, the date is assumed to be now. The second
     *        argument can either be an options object or a locale code as a
     *        shortcut. For more, see `date parsing`.
     *
     * @options
     *
     *   locale     A locale code to parse the date in. This can also be passed as
     *              the second argument to this method. Default is the current
     *              locale, which is `en` if none is set.
     *
     *   past       If `true`, ambiguous dates like `Sunday` will be parsed as
     *              `last Sunday`. Note that non-ambiguous dates are not
     *              guaranteed to be in the past.
     *              Default is `false`.
     *
     *   future     If `true`, ambiguous dates like `Sunday` will be parsed as
     *              `next Sunday`. Note that non-ambiguous dates are not
     *              guaranteed to be in the future.
     *              Default is `false`.
     *
     *   fromUTC    If `true`, dates with no timezone notation will be parsed as
     *              UTC (no timezone offset). This is useful for server
     *              timestamps, etc. Note that this flag is not required if the
     *              timezone is specified in the string, either as an explicit
     *              value (ex. +0900 or -09:00) or "Z", which is UTC time.
     *
     *   setUTC     If `true`, this will set a flag on the date that tells Sugar
     *              to internally use UTC methods like `getUTCHours` when handling
     *              it. This flag is the same as calling the `setUTC` method on
     *              the date after parsing is complete. Note that this is
     *              different from `fromUTC`, which parses a string as UTC, but
     *              does not set this flag.
     *
     *   clone      If `true` and `d` is a date, it will be cloned.
     *
     *   params     An optional object that is populated with properties that are
     *              parsed from string input. This option is useful when parsed
     *              properties need to be retained.
     *
     * @example
     *
     *   Date.create('July')                      -> July of this year
     *   Date.create('1776')                      -> 1776
     *   Date.create('today')                     -> today
     *   Date.create('Wednesday')                 -> This wednesday
     *   Date.create('next Friday')               -> Next friday
     *   Date.create('July 4, 1776')              -> July 4, 1776
     *   Date.create(-446806800000)               -> November 5, 1955
     *   Date.create('1776年07月04日', 'ja')      -> July 4, 1776
     *   Date.create('August', {past: true})      -> August of this or last year
     *   Date.create('August', {future: true})    -> August of this or next year
     *   Date.create('Thursday', {fromUTC: true}) -> Thursday at 12:00am UTC time
     *
     * @param {string|number|Date} d
     * @param {DateCreateOptions} [options]
     *
     * @option {string} [locale]
     * @option {boolean} [past]
     * @option {boolean} [future]
     * @option {boolean} [fromUTC]
     * @option {boolean} [setUTC]
     * @option {boolean} [clone]
     * @option {Object} [params]
     *
     ***/
    'create': function(d, options) {
      return createDate(d, options);
    },

    /***
     * @method getLocale([localeCode] = current)
     * @returns Locale
     * @static
     * @short Gets the locale object for the given code, or the current locale.
     * @extra The locale object has various properties that dictate how dates are
     *        parsed and formatted for that locale. The locale object is exposed
     *        here mostly for introspection - it should be uncommon to need to
     *        maniplate the object itself. For more, see `date locales`.
     *
     * @example
     *
     *   Date.getLocale()     -> Returns the current locale
     *   Date.getLocale('en') -> Returns the EN locale
     *
     * @param {string} [localeCode]
     *
     ***/
    'getLocale': function(code) {
      return localeManager.get(code, !code);
    },

    /***
     * @method getAllLocales()
     * @returns Array<Locale>
     * @static
     * @short Returns all available locales as an object.
     * @extra For more, see `date locales`.
     * @example
     *
     *   Date.getAllLocales()
     *
     ***/
    'getAllLocales': function() {
      return localeManager.getAll();
    },

    /***
     * @method getAllLocaleCodes()
     * @returns string[]
     * @static
     * @short Returns all available locale codes as an array of strings.
     * @extra For more, see `date locales`.
     * @example
     *
     *   Date.getAllLocaleCodes()
     *
     ***/
    'getAllLocaleCodes': function() {
      return getKeys(localeManager.getAll());
    },

    /***
     * @method setLocale(localeCode)
     * @returns Locale
     * @static
     * @short Sets the current locale to be used with dates.
     * @extra Sugar has native support for 17 major locales. In addition, you can
     *        define a new locale with `addLocale`. For more, see `date locales`.
     * @example
     *
     *   Date.setLocale('en')
     *
     * @param {string} localeCode
     *
     ***/
    'setLocale': function(code) {
      return localeManager.set(code);
    },

    /***
     * @method addLocale(localeCode, def)
     * @returns Locale
     * @static
     * @short Adds a locale definition to the locales understood by Sugar.
     * @extra This method should only be required for adding locale definitions
     *        that don't already exist. For more, see `date locales`.
     * @example
     *
     *   Date.addLocale('eo', {})
     *
     * @param {string} localeCode
     * @param {Object} def
     *
     ***/
    'addLocale': function(code, set) {
      return localeManager.add(code, set);
    },

    /***
     * @method removeLocale(localeCode)
     * @returns Locale
     * @static
     * @short Deletes the the locale by `localeCode` from Sugar's known locales.
     * @extra For more, see `date locales`.
     * @example
     *
     *   Date.removeLocale('foo')
     *
     * @param {string} localeCode
     *
     ***/
    'removeLocale': function(code) {
      return localeManager.remove(code);
    }

  });

  defineInstanceWithArguments(sugarDate, {

    /***
     * @method set(set, [reset] = false)
     * @returns Date
     * @short Sets the date object.
     * @extra This method accepts multiple formats including a single number as
     *        a timestamp, an object, or enumerated arguments. If [reset] is
     *        `true`, any units more specific than those passed will be reset.
     *
     * @example
     *
     *   new Date().set({year:2011,month:11,day:31}) -> December 31, 2011
     *   new Date().set(2011, 11, 31)                -> December 31, 2011
     *   new Date().set(86400000)                    -> 1 day after Jan 1, 1970
     *   new Date().set({year:2004,month:6}, true)   -> June 1, 2004, 00:00:00.000
     *
     * @signature set(milliseconds)
     * @signature set(year, month, [day], [hour], [minute], [second], [millliseconds])
     * @param {Object} set
     * @param {boolean} [reset]
     * @param {number} year
     * @param {number} month
     * @param {number} [day]
     * @param {number} [hour]
     * @param {number} [minute]
     * @param {number} [second]
     * @param {number} [milliseconds]
     *
     ***/
    'set': function(d, args) {
      args = collectDateArguments(args);
      return updateDate(d, args[0], args[1]);
    },

    /***
     * @method advance(set, [reset] = false)
     * @returns Date
     * @short Shifts the date forward.
     * @extra `set` accepts multiple formats including an object, a string in the
     *        format "3 days", a single number as milliseconds, or enumerated
     *        parameters (as with the Date constructor). If [reset] is `true`, any
     *        units more specific than those passed will be reset. This method
     *        modifies the date!
     *
     * @example
     *
     *   new Date().advance({ year: 2 }) -> 2 years in the future
     *   new Date().advance('2 hours')   -> 2 hours in the future
     *   new Date().advance(0, 2, 3)     -> 2 months 3 days in the future
     *   new Date().advance(86400000)    -> 1 day in the future
     *
     * @signature advance(milliseconds)
     * @signature advance(year, month, [day], [hour], [minute], [second], [millliseconds])
     * @param {string|Object} set
     * @param {boolean} [reset]
     * @param {number} year
     * @param {number} month
     * @param {number} [day]
     * @param {number} [hour]
     * @param {number} [minute]
     * @param {number} [second]
     * @param {number} [milliseconds]
     *
     ***/
    'advance': function(d, args) {
      return advanceDateWithArgs(d, args, 1);
    },

    /***
     * @method rewind(set, [reset] = false)
     * @returns Date
     * @short Shifts the date backward.
     * @extra [set] accepts multiple formats including an object, a string in the
     *        format "3 days", a single number as milliseconds, or enumerated
     *        parameters (as with the Date constructor). If [reset] is `true`, any
     *        units more specific than those passed will be reset. This method
     *        modifies the date!
     *
     * @example
     *
     *   new Date().rewind({ year: 2 }) -> 2 years in the past
     *   new Date().rewind('2 weeks')   -> 2 weeks in the past
     *   new Date().rewind(0, 2, 3)     -> 2 months 3 days in the past
     *   new Date().rewind(86400000)    -> 1 day in the past
     *
     * @signature advance(milliseconds)
     * @signature advance(year, month, [day], [hour], [minute], [second], [millliseconds])
     * @param {string|Object} set
     * @param {boolean} [reset]
     * @param {number} year
     * @param {number} month
     * @param {number} [day]
     * @param {number} [hour]
     * @param {number} [minute]
     * @param {number} [second]
     * @param {number} [milliseconds]
     *
     ***/
    'rewind': function(d, args) {
      return advanceDateWithArgs(d, args, -1);
    }

  });

  defineInstance(sugarDate, {

    /***
     * @method get(d, [options])
     * @returns Date
     * @short Gets a new date using the current one as a starting point.
     * @extra This method is identical to `Date.create`, except that relative
     *        formats like `next month` are relative to the date instance rather
     *        than the current date. Accepts a locale code as a string in place
     *        of [options]. See `create` for more.
     *
     * @example
     *
     *   nextYear.get('monday') -> monday of the week exactly 1 year from now
     *   millenium.get('2 years before') -> 2 years before Jan 1, 2000.
     *
     * @param {string|number|Date} d
     * @param {DateCreateOptions} options
     *
     ***/
    'get': function(date, d, options) {
      return createDateWithContext(date, d, options);
    },

    /***
     * @method setWeekday(dow)
     * @short Sets the weekday of the date, starting with Sunday at `0`.
     * @extra This method modifies the date!
     *
     * @example
     *
     *   d = new Date(); d.setWeekday(1); d; -> Monday of this week
     *   d = new Date(); d.setWeekday(6); d; -> Saturday of this week
     *
     * @param {number} dow
     *
     ***/
    'setWeekday': function(date, dow) {
      return setWeekday(date, dow);
    },

    /***
     * @method setISOWeek(num)
     * @short Sets the week (of the year) as defined by the ISO8601 standard.
     * @extra Note that this standard places Sunday at the end of the week (day 7).
     *        This method modifies the date!
     *
     * @example
     *
     *   d = new Date(); d.setISOWeek(15); d; -> 15th week of the year
     *
     * @param {number} num
     *
     ***/
    'setISOWeek': function(date, num) {
      return setISOWeekNumber(date, num);
    },

    /***
     * @method getISOWeek()
     * @returns Number
     * @short Gets the date's week (of the year) as defined by the ISO8601 standard.
     * @extra Note that this standard places Sunday at the end of the week (day 7).
     *        If `utc` is set on the date, the week will be according to UTC time.
     *
     * @example
     *
     *   new Date().getISOWeek() -> today's week of the year
     *
     ***/
    'getISOWeek': function(date) {
      return getWeekNumber(date, true);
    },

    /***
     * @method beginningOfISOWeek()
     * @returns Date
     * @short Set the date to the beginning of week as defined by ISO8601.
     * @extra Note that this standard places Monday at the start of the week.
     *        This method modifies the date!
     *
     * @example
     *
     *   new Date().beginningOfISOWeek() -> Monday
     *
     ***/
    'beginningOfISOWeek': function(date) {
      var day = getWeekday(date);
      if (day === 0) {
        day = -6;
      } else if (day !== 1) {
        day = 1;
      }
      setWeekday(date, day);
      return resetTime(date);
    },

    /***
     * @method endOfISOWeek()
     * @returns Date
     * @short Set the date to the end of week as defined by this ISO8601 standard.
     * @extra Note that this standard places Sunday at the end of the week.
     *        This method modifies the date!
     *
     * @example
     *
     *   new Date().endOfISOWeek() -> Sunday
     *
     ***/
    'endOfISOWeek': function(date) {
      if (getWeekday(date) !== 0) {
        setWeekday(date, 7);
      }
      return moveToEndOfUnit(date, DAY_INDEX);
    },

    /***
     * @method getUTCOffset([iso] = false)
     * @returns String
     * @short Returns a string representation of the offset from UTC time. If [iso]
     *        is true the offset will be in ISO8601 format.
     *
     * @example
     *
     *   new Date().getUTCOffset()     -> "+0900"
     *   new Date().getUTCOffset(true) -> "+09:00"
     *
     * @param {boolean} iso
     *
     ***/
    'getUTCOffset': function(date, iso) {
      return getUTCOffset(date, iso);
    },

    /***
     * @method setUTC([on] = false)
     * @returns Date
     * @short Controls a flag on the date that tells Sugar to internally use UTC
     *        methods like `getUTCHours`.
     * @extra This flag is most commonly used for output in UTC time with the
     *        `format` method. Note that this flag only governs which methods are
     *        called internally – date native methods like `setHours` will still
     *        return local non-UTC values. This method will modify the date!
     *
     * @example
     *
     *   new Date().setUTC(true).long()  -> formatted with UTC methods
     *   new Date().setUTC(false).long() -> formatted without UTC methods
     *
     * @param {boolean} on
     *
     ***/
    'setUTC': function(date, on) {
      return _utc(date, on);
    },

    /***
     * @method isUTC()
     * @returns Boolean
     * @short Returns true if the date has no timezone offset.
     * @extra This will also return true for dates whose internal utc flag is set
     *        with `setUTC`. Even if the utc flag is set, `getTimezoneOffset`
     *        will always report the same thing as Javascript always reports that
     *        based on the environment's locale.
     *
     * @example
     *
     *   new Date().isUTC() -> true or false (depends on the local offset)
     *   new Date().setUTC(true).isUTC() -> true
     *
     ***/
    'isUTC': function(date) {
      return isUTC(date);
    },

    /***
     * @method isValid()
     * @returns Boolean
     * @short Returns true if the date is valid.
     *
     * @example
     *
     *   new Date().isValid()         -> true
     *   new Date('flexor').isValid() -> false
     *
     ***/
    'isValid': function(date) {
      return dateIsValid(date);
    },

    /***
     * @method isAfter(d, [margin] = 0)
     * @returns Boolean
     * @short Returns true if the date is after `d`.
     * @extra [margin] is to allow extra margin of error in ms. `d` will accept
     *        a date object, timestamp, or string. If not specified, `d` is
     *        assumed to be now. See `create` for formats.
     *
     * @example
     *
     *   today.isAfter('tomorrow')  -> false
     *   today.isAfter('yesterday') -> true
     *
     * @param {string|number|Date} d
     * @param {number} [margin]
     *
     ***/
    'isAfter': function(date, d, margin) {
      return date.getTime() > createDate(d).getTime() - (margin || 0);
    },

    /***
     * @method isBefore(d, [margin] = 0)
     * @returns Boolean
     * @short Returns true if the date is before `d`.
     * @extra [margin] is to allow extra margin of error in ms. `d` will accept
     *        a date object, timestamp, or text format. If not specified, `d` is
     *        assumed to be now. See `create` for formats.
     *
     * @example
     *
     *   today.isBefore('tomorrow')  -> true
     *   today.isBefore('yesterday') -> false
     *
     * @param {string|number|Date} d
     * @param {number} [margin]
     *
     ***/
    'isBefore': function(date, d, margin) {
      return date.getTime() < createDate(d).getTime() + (margin || 0);
    },

    /***
     * @method isBetween(d1, d2, [margin] = 0)
     * @returns Boolean
     * @short Returns true if the date is later or equal to `d1` and before or
     *        equal to `d2`.
     * @extra [margin] is to allow extra margin of error in ms. `d1` and `d2` will
     *        accept a date object, timestamp, or text format. If not specified,
     *        they are assumed to be now.  See `create` for formats.
     *
     * @example
     *
     *   new Date().isBetween('yesterday', 'tomorrow')    -> true
     *   new Date().isBetween('last year', '2 years ago') -> false
     *
     * @param {string|number|Date} d1
     * @param {string|number|Date} d2
     * @param {number} [margin]
     *
     ***/
    'isBetween': function(date, d1, d2, margin) {
      var t  = date.getTime();
      var t1 = createDate(d1).getTime();
      var t2 = createDate(d2).getTime();
      var lo = min(t1, t2);
      var hi = max(t1, t2);
      margin = margin || 0;
      return (lo - margin <= t) && (hi + margin >= t);
    },

    /***
     * @method isLeapYear()
     * @returns Boolean
     * @short Returns true if the date is a leap year.
     *
     * @example
     *
     *   millenium.isLeapYear() -> true
     *
     ***/
    'isLeapYear': function(date) {
      var year = getYear(date);
      return (year % 4 === 0 && year % 100 !== 0) || (year % 400 === 0);
    },

    /***
     * @method daysInMonth()
     * @returns Number
     * @short Returns the number of days in the date's month.
     *
     * @example
     *
     *   may.daysInMonth() -> 31
     *   feb.daysInMonth() -> 28 or 29
     *
     ***/
    'daysInMonth': function(date) {
      return getDaysInMonth(date);
    },

    /***
     * @method format([f], [localeCode] = currentLocaleCode)
     * @returns String
     * @short Returns the date as a string using the format `f`.
     * @extra `f` is a string that contains tokens in either LDML format using
     *        curly braces, or "strftime" format using a percent sign. If `f` is
     *        not specified, the locale specific `{long}` format is used. [localeCode]
     *        is a locale code to use (if not specified the current locale is
     *        used). For more, see `date formatting`.
     *
     * @example
     *
     *   new Date().format()                        -> ex. February 13, 2012 11:21 AM
     *   new Date().format('{Weekday} {d} {Month}') -> ex. Monday July 4
     *   new Date().format('{hh}:{mm}')             -> ex. 15:57
     *   new Date().format('%H:%M')                 -> ex. 15:57
     *   new Date().format('{12hr}:{mm}{tt}')       -> ex. 3:57pm
     *   new Date().format('ISO8601')               -> ex. 2011-07-05 12:24:55.528Z
     *   new Date().format('{Weekday}', 'ja')       -> ex. 先週
     *
     * @param {string} f
     * @param {string} [localeCode]
     *
     ***
     * @method short([localeCode] = currentLocaleCode)
     * @returns String
     * @short Outputs the date in the short format for the current locale.
     * @extra [localeCode] overrides the current locale code if passed.
     *
     * @example
     *
     *   new Date().short()     -> ex. 02/13/2016
     *   new Date().short('fi') -> ex. 13.2.2016
     *
     * @param {string} [localeCode]
     *
     ***
     * @method medium([localeCode] = currentLocaleCode)
     * @returns String
     * @short Outputs the date in the medium format for the current locale.
     * @extra [localeCode] overrides the current locale code if passed.
     *
     * @example
     *
     *   new Date().medium()     -> ex. February 13, 2016
     *   new Date().medium('ja') -> ex. 2016年2月13日
     *
     * @param {string} [localeCode]
     *
     ***
     * @method long([localeCode] = currentLocaleCode)
     * @returns String
     * @short Outputs the date in the long format for the current locale.
     * @extra [localeCode] overrides the current locale code if passed.
     *
     * @example
     *
     *   new Date().long()     -> ex. February 13, 2016 6:22 PM
     *   new Date().long('es') -> ex. 13 de febrero de 2016 18:22
     *
     * @param {string} [localeCode]
     *
     ***
     * @method full([localeCode] = currentLocaleCode)
     * @returns String
     * @short Outputs the date in the full format for the current locale.
     * @extra [localeCode] overrides the current locale code if passed.
     *
     * @example
     *
     *   new Date().full()     -> ex. Saturday, February 13, 2016 6:23 PM
     *   new Date().full('ru') -> ex. суббота, 13 февраля 2016 г., 18:23
     *
     * @param {string} [localeCode]
     *
     ***/
    'format': function(date, f, localeCode) {
      return dateFormat(date, f, localeCode);
    },

    /***
     * @method relative([localeCode] = currentLocaleCode, [relativeFn])
     * @returns String
     * @short Returns the date in a text format relative to the current time,
     *        such as "5 minutes ago".
     * @extra [relativeFn] is a function that can be passed to provide more granular
     *        control over the resulting string. Its return value will be passed
     *        to `format`. If nothing is returned, the relative format will be
     *        used. [relativeFn] can be passed as the first argument in place of
     *        [locale]. For more about formats, see `date formatting`.
     *
     * @callback relativeFn
     *
     *   num   The offset number in `unit`.
     *   unit  A numeric representation of the unit that `num` is in, starting at
     *         0 for ms.
     *   ms    The absolute offset in milliseconds.
     *   loc   The locale object, either specified by [locale] or default.
     *
     * @example
     *
     *   hourAgo.relative() -> 1 hour ago
     *   jan.relative()     -> ex. 5 months ago
     *   jan.relative('ja') -> 3ヶ月前
     *   jan.relative(function(num, unit, ms, loc) {
     *     // Return an absolute date for anything over 6 months.
     *     if(unit == 6 && num > 6 || unit > 6) {
     *       return '{Month} {d}, {yyyy}';
     *     }
     *   }); -> ex. 5 months ago
     *
     * @signature relative([relativeFn])
     * @param {string} [localeCode]
     * @param {relativeFn} [relativeFn]
     * @callbackParam {number} num
     * @callbackParam {number} unit
     * @callbackParam {number} ms
     * @callbackParam {Locale} loc
     * @callbackReturns {string} relativeFn
     *
     ***/
    'relative': function(date, localeCode, relativeFn) {
      return dateRelative(date, null, localeCode, relativeFn);
    },

    /***
     * @method relativeTo(d, [localeCode] = currentLocaleCode)
     * @returns String
     * @short Returns the date in a text format relative to `d`, such as
     *        "5 minutes".
     * @extra `d` will accept a date object, timestamp, or string. [localeCode]
     *        applies to the method output, not `d`.
     *
     * @example
     *
     *   jan.relativeTo(jul)                 -> 5 months
     *   yesterday.relativeTo('today', 'ja') -> 一日
     *
     * @param {string|number|Date} d
     * @param {string} localeCode
     *
     *
     ***/
    'relativeTo': function(date, d, localeCode) {
      return dateRelative(date, createDate(d), localeCode);
    },

    /***
     * @method is(d, [margin] = 0)
     * @returns Boolean
     * @short Returns true if the date matches `d`.
     * @extra `d` will accept a date object, timestamp, or text format. In the
     *        case of objects and text formats, `is` will additionally compare
     *        based on the precision implied in the input. In the case of text
     *        formats `d` will use the currently set locale. [margin] allows an
     *        extra margin of error in milliseconds. See `create` for formats.
     *
     * @example
     *
     *   new Date().is('July')               -> true or false?
     *   new Date().is('1776')               -> false
     *   new Date().is('today')              -> true
     *   new Date().is('weekday')            -> true or false?
     *   new Date().is('July 4, 1776')       -> false
     *   new Date().is(-6106093200000)       -> false
     *   new Date().is(new Date(1776, 6, 4)) -> false
     *
     * @param {string|number|Date} d
     * @param {number} [margin]
     *
     ***/
    'is': function(date, d, margin) {
      return fullCompareDate(date, d, margin);
    },

    /***
     * @method reset([unit] = 'day', [localeCode] = currentLocaleCode)
     * @returns Date
     * @short Resets the date to the beginning of [unit].
     * @extra This method effectively resets all smaller units, pushing the date
     *        to the beginning of [unit]. Default is `day`, which effectively
     *        resets the time. [localeCode] is provided for resetting weeks, which
     *        is locale dependent. This method modifies the date!
     *
     * @example
     *
     *   new Date().reset('day')   -> Beginning of the day
     *   new Date().reset('month') -> Beginning of the month
     *
     * @param {string} [unit]
     * @param {string} [localeCode]
     *
     ***/
    'reset': function(date, unit, localeCode) {
      var unitIndex = unit ? getUnitIndexForParamName(unit) : DAY_INDEX;
      moveToBeginningOfUnit(date, unitIndex, localeCode);
      return date;
    },

    /***
     * @method clone()
     * @returns Date
     * @short Clones the date.
     * @extra Note that the UTC flag will be preserved if set. This flag is
     *        set via the `setUTC` method or an option on `Date.create`.
     *
     * @example
     *
     *   new Date().clone() -> Copy of now
     *
     ***/
    'clone': function(date) {
      return cloneDate(date);
    },

    /***
     * @method iso()
     * @alias toISOString
     *
     ***/
    'iso': function(date) {
      return date.toISOString();
    },

    /***
     * @method getWeekday()
     * @returns Number
     * @short Alias for `getDay`.
     *
     * @example
     *
     *   new Date().getWeekday();    -> (ex.) 3
     *
     ***/
    'getWeekday': function(date) {
      return getWeekday(date);
    },

    /***
     * @method getUTCWeekday()
     * @returns Number
     * @short Alias for `getUTCDay`.
     *
     * @example
     *
     *   new Date().getUTCWeekday(); -> (ex.) 3
     *
     ***/
    'getUTCWeekday': function(date) {
      return date.getUTCDay();
    }

  });

  var EnglishLocaleBaseDefinition = {
    'code': 'en',
    'plural': true,
    'timeMarkers': 'at',
    'ampm': 'AM|A.M.|a,PM|P.M.|p',
    'units': 'millisecond:|s,second:|s,minute:|s,hour:|s,day:|s,week:|s,month:|s,year:|s',
    'months': 'Jan:uary|,Feb:ruary|,Mar:ch|,Apr:il|,May,Jun:e|,Jul:y|,Aug:ust|,Sep:tember|t|,Oct:ober|,Nov:ember|,Dec:ember|',
    'weekdays': 'Sun:day|,Mon:day|,Tue:sday|,Wed:nesday|,Thu:rsday|,Fri:day|,Sat:urday|+weekend',
    'numerals': 'zero,one|first,two|second,three|third,four:|th,five|fifth,six:|th,seven:|th,eight:|h,nin:e|th,ten:|th',
    'articles': 'a,an,the',
    'tokens': 'the,st|nd|rd|th,of|in,a|an,on',
    'time': '{H}:{mm}',
    'past': '{num} {unit} {sign}',
    'future': '{num} {unit} {sign}',
    'duration': '{num} {unit}',
    'modifiers': [
      { 'name': 'half',   'src': 'half', 'value': .5 },
      { 'name': 'midday', 'src': 'noon', 'value': 12 },
      { 'name': 'midday', 'src': 'midnight', 'value': 24 },
      { 'name': 'day',    'src': 'yesterday', 'value': -1 },
      { 'name': 'day',    'src': 'today|tonight', 'value': 0 },
      { 'name': 'day',    'src': 'tomorrow', 'value': 1 },
      { 'name': 'sign',   'src': 'ago|before', 'value': -1 },
      { 'name': 'sign',   'src': 'from now|after|from|in|later', 'value': 1 },
      { 'name': 'edge',   'src': 'first day|first|beginning', 'value': -2 },
      { 'name': 'edge',   'src': 'last day', 'value': 1 },
      { 'name': 'edge',   'src': 'end|last', 'value': 2 },
      { 'name': 'shift',  'src': 'last', 'value': -1 },
      { 'name': 'shift',  'src': 'the|this', 'value': 0 },
      { 'name': 'shift',  'src': 'next', 'value': 1 }
    ],
    'parse': [
      '(?:just)? now',
      '{shift} {unit:5-7}',
      "{months?} (?:{year}|'{yy})",
      '{midday} {4?} {day|weekday}',
      '{months},?(?:[-.\\/\\s]{year})?',
      '{edge} of (?:day)? {day|weekday}',
      '{0} {num}{1?} {weekday} {2} {months},? {year?}',
      '{shift?} {day?} {weekday?} {timeMarker?} {midday}',
      '{sign?} {3?} {half} {3?} {unit:3-4|unit:7} {sign?}',
      '{0?} {edge} {weekday?} {2} {shift?} {unit:4-7?} {months?},? {year?}'
    ],
    'timeParse': [
      '{day|weekday}',
      '{shift} {unit:5?} {weekday}',
      '{0?} {date}{1?} {2?} {months?}',
      '{weekday} {2?} {shift} {unit:5}',
      '{0?} {num} {2?} {months}\\.?,? {year?}',
      '{num?} {unit:4-5} {sign} {day|weekday}',
      '{year}[-.\\/\\s]{months}[-.\\/\\s]{date}',
      '{0|months} {date?}{1?} of {shift} {unit:6-7}',
      '{0?} {num}{1?} {weekday} of {shift} {unit:6}',
      "{date}[-.\\/\\s]{months}[-.\\/\\s](?:{year}|'?{yy})",
      "{weekday?}\\.?,? {months}\\.?,? {date}{1?},? (?:{year}|'{yy})?"
    ],
    'timeFrontParse': [
      '{sign} {num} {unit}',
      '{num} {unit} {sign}',
      '{4?} {day|weekday}'
    ]
  };

  var AmericanEnglishDefinition = getEnglishVariant({
    'mdy': true,
    'firstDayOfWeek': 0,
    'firstDayOfWeekYear': 1,
    'short':  '{MM}/{dd}/{yyyy}',
    'medium': '{Month} {d}, {yyyy}',
    'long':   '{Month} {d}, {yyyy} {time}',
    'full':   '{Weekday}, {Month} {d}, {yyyy} {time}',
    'stamp':  '{Dow} {Mon} {d} {yyyy} {time}',
    'time':   '{h}:{mm} {TT}'
  });

  var BritishEnglishDefinition = getEnglishVariant({
    'short':  '{dd}/{MM}/{yyyy}',
    'medium': '{d} {Month} {yyyy}',
    'long':   '{d} {Month} {yyyy} {H}:{mm}',
    'full':   '{Weekday}, {d} {Month}, {yyyy} {time}',
    'stamp':  '{Dow} {d} {Mon} {yyyy} {time}'
  });

  var CanadianEnglishDefinition = getEnglishVariant({
    'short':  '{yyyy}-{MM}-{dd}',
    'medium': '{d} {Month}, {yyyy}',
    'long':   '{d} {Month}, {yyyy} {H}:{mm}',
    'full':   '{Weekday}, {d} {Month}, {yyyy} {time}',
    'stamp':  '{Dow} {d} {Mon} {yyyy} {time}'
  });

  var LazyLoadedLocales = {
    'en-US': AmericanEnglishDefinition,
    'en-GB': BritishEnglishDefinition,
    'en-AU': BritishEnglishDefinition,
    'en-CA': CanadianEnglishDefinition
  };

  buildLocales();

  buildDateFormatTokens();

  buildDateFormatMatcher();

  buildDateUnitMethods();

  buildRelativeAliases();

  setDateChainableConstructor();

  /***
   * @module String
   * @description String manupulation, encoding, truncation, and formatting, and more.
   *
   ***/


  // Flag allowing native string methods to be enhanced
  var STRING_ENHANCEMENTS_FLAG = 'enhanceString';

  // Matches non-punctuation characters except apostrophe for capitalization.
  var CAPITALIZE_REG = /[^\u0000-\u0040\u005B-\u0060\u007B-\u007F]+('s)?/g;

  // Regex matching camelCase.
  var CAMELIZE_REG = /(^|_)([^_]+)/g;

  // Regex matching any HTML entity.
  var HTML_ENTITY_REG = /&#?(x)?([\w\d]{0,5});/gi;

  // Very basic HTML escaping regex.
  var HTML_ESCAPE_REG = /[&<>]/g;

  // Special HTML entities.
  var HTMLFromEntityMap = {
    'lt':    '<',
    'gt':    '>',
    'amp':   '&',
    'nbsp':  ' ',
    'quot':  '"',
    'apos':  "'"
  };

  var HTMLToEntityMap;

  // Words that should not be capitalized in titles
  var DOWNCASED_WORDS = [
    'and', 'or', 'nor', 'a', 'an', 'the', 'so', 'but', 'to', 'of', 'at',
    'by', 'from', 'into', 'on', 'onto', 'off', 'out', 'in', 'over',
    'with', 'for'
  ];

  // HTML tags that do not have inner content.
  var HTML_VOID_ELEMENTS = [
    'area','base','br','col','command','embed','hr','img',
    'input','keygen','link','meta','param','source','track','wbr'
  ];

  var LEFT_TRIM_REG  = RegExp('^['+ TRIM_CHARS +']+');

  var RIGHT_TRIM_REG = RegExp('['+ TRIM_CHARS +']+$');

  var TRUNC_REG      = RegExp('(?=[' + TRIM_CHARS + '])');

  // Reference to native String#includes to enhance later.
  var nativeIncludes = String.prototype.includes;

  // Base64
  var encodeBase64, decodeBase64;

  // Format matcher for String#format.
  var stringFormatMatcher = createFormatMatcher(deepGetProperty);

  function padString(num, padding) {
    return repeatString(isDefined(padding) ? padding : ' ', num);
  }

  function truncateString(str, length, from, ellipsis, split) {
    var str1, str2, len1, len2;
    if (str.length <= length) {
      return str.toString();
    }
    ellipsis = isUndefined(ellipsis) ? '...' : ellipsis;
    switch(from) {
      case 'left':
        str2 = split ? truncateOnWord(str, length, true) : str.slice(str.length - length);
        return ellipsis + str2;
      case 'middle':
        len1 = ceil(length / 2);
        len2 = floor(length / 2);
        str1 = split ? truncateOnWord(str, len1) : str.slice(0, len1);
        str2 = split ? truncateOnWord(str, len2, true) : str.slice(str.length - len2);
        return str1 + ellipsis + str2;
      default:
        str1 = split ? truncateOnWord(str, length) : str.slice(0, length);
        return str1 + ellipsis;
    }
  }

  function stringEach(str, search, fn) {
    var chunks, chunk, reg, result = [];
    if (isFunction(search)) {
      fn = search;
      reg = /[\s\S]/g;
    } else if (!search) {
      reg = /[\s\S]/g;
    } else if (isString(search)) {
      reg = RegExp(escapeRegExp(search), 'gi');
    } else if (isRegExp(search)) {
      reg = RegExp(search.source, getRegExpFlags(search, 'g'));
    }
    // Getting the entire array of chunks up front as we need to
    // pass this into the callback function as an argument.
    chunks = runGlobalMatch(str, reg);

    if (chunks) {
      for(var i = 0, len = chunks.length, r; i < len; i++) {
        chunk = chunks[i];
        result[i] = chunk;
        if (fn) {
          r = fn.call(str, chunk, i, chunks);
          if (r === false) {
            break;
          } else if (isDefined(r)) {
            result[i] = r;
          }
        }
      }
    }
    return result;
  }

  // "match" in < IE9 has enumable properties that will confuse for..in
  // loops, so ensure that the match is a normal array by manually running
  // "exec". Note that this method is also slightly more performant.
  function runGlobalMatch(str, reg) {
    var result = [], match, lastLastIndex;
    while ((match = reg.exec(str)) != null) {
      if (reg.lastIndex === lastLastIndex) {
        reg.lastIndex += 1;
      } else {
        result.push(match[0]);
      }
      lastLastIndex = reg.lastIndex;
    }
    return result;
  }

  function eachWord(str, fn) {
    return stringEach(trim(str), /\S+/g, fn);
  }

  function stringCodes(str, fn) {
    var codes = new Array(str.length), i, len;
    for(i = 0, len = str.length; i < len; i++) {
      var code = str.charCodeAt(i);
      codes[i] = code;
      if (fn) {
        fn.call(str, code, i, str);
      }
    }
    return codes;
  }

  function stringUnderscore(str) {
    var areg = Inflections.acronyms && Inflections.acronyms.reg;
    return str
      .replace(/[-\s]+/g, '_')
      .replace(areg, function(acronym, index) {
        return (index > 0 ? '_' : '') + acronym.toLowerCase();
      })
      .replace(/([A-Z\d]+)([A-Z][a-z])/g,'$1_$2')
      .replace(/([a-z\d])([A-Z])/g,'$1_$2')
      .toLowerCase();
  }

  function stringCamelize(str, upper) {
    str = stringUnderscore(str);
    return str.replace(CAMELIZE_REG, function(match, pre, word, index) {
      var cap = upper !== false || index > 0, acronym;
      acronym = getAcronym(word);
      if (acronym && cap) {
        return acronym;
      }
      return cap ? stringCapitalize(word, true) : word;
    });
  }

  function stringSpacify(str) {
    return stringUnderscore(str).replace(/_/g, ' ');
  }

  function stringCapitalize(str, downcase, all) {
    if (downcase) {
      str = str.toLowerCase();
    }
    return all ? str.replace(CAPITALIZE_REG, simpleCapitalize) : simpleCapitalize(str);
  }

  function stringTitleize(str) {
    var fullStopPunctuation = /[.:;!]$/, lastHadPunctuation;
    str = runHumanRules(str);
    str = stringSpacify(str);
    return eachWord(str, function(word, index, words) {
      word = getHumanWord(word) || word;
      word = getAcronym(word) || word;
      var hasPunctuation, isFirstOrLast;
      var first = index == 0, last = index == words.length - 1;
      hasPunctuation = fullStopPunctuation.test(word);
      isFirstOrLast = first || last || hasPunctuation || lastHadPunctuation;
      lastHadPunctuation = hasPunctuation;
      if (isFirstOrLast || indexOf(DOWNCASED_WORDS, word) === -1) {
        return stringCapitalize(word, false, true);
      } else {
        return word;
      }
    }).join(' ');
  }

  function stringParameterize(str, separator) {
    if (separator === undefined) separator = '-';
    str = str.replace(/[^a-z0-9\-_]+/gi, separator);
    if (separator) {
      var reg = RegExp('^{s}+|{s}+$|({s}){s}+'.split('{s}').join(escapeRegExp(separator)), 'g');
      str = str.replace(reg, '$1');
    }
    return encodeURI(str.toLowerCase());
  }

  function reverseString(str) {
    return str.split('').reverse().join('');
  }

  function truncateOnWord(str, limit, fromLeft) {
    if (fromLeft) {
      return reverseString(truncateOnWord(reverseString(str), limit));
    }
    var words = str.split(TRUNC_REG);
    var count = 0;
    return filter(words, function(word) {
      count += word.length;
      return count <= limit;
    }).join('');
  }

  function unescapeHTML(str) {
    return str.replace(HTML_ENTITY_REG, function(full, hex, code) {
      var special = HTMLFromEntityMap[code];
      return special || chr(hex ? parseInt(code, 16) : +code);
    });
  }

  function tagIsVoid(tag) {
    return indexOf(HTML_VOID_ELEMENTS, tag.toLowerCase()) !== -1;
  }

  function stringReplaceAll(str, f, replace) {
    var i = 0, tokens;
    if (isString(f)) {
      f = RegExp(escapeRegExp(f), 'g');
    } else if (f && !f.global) {
      f = RegExp(f.source, getRegExpFlags(f, 'g'));
    }
    if (!replace) {
      replace = '';
    } else {
      tokens = replace;
      replace = function() {
        var t = tokens[i++];
        return t != null ? t : '';
      };
    }
    return str.replace(f, replace);
  }

  function replaceTags(str, find, replacement, strip) {
    var tags = isString(find) ? [find] : find, reg, src;
    tags = map(tags || [], function(t) {
      return escapeRegExp(t);
    }).join('|');
    src = tags.replace('all', '') || '[^\\s>]+';
    src = '<(\\/)?(' + src + ')(\\s+[^<>]*?)?\\s*(\\/)?>';
    reg = RegExp(src, 'gi');
    return runTagReplacements(str.toString(), reg, strip, replacement);
  }

  function runTagReplacements(str, reg, strip, replacement, fullString) {

    var match;
    var result = '';
    var currentIndex = 0;
    var openTagName;
    var openTagAttributes;
    var openTagCount = 0;

    function processTag(index, tagName, attributes, tagLength, isVoid) {
      var content = str.slice(currentIndex, index), s = '', r = '';
      if (isString(replacement)) {
        r = replacement;
      } else if (replacement) {
        r = replacement.call(fullString, tagName, content, attributes, fullString) || '';
      }
      if (strip) {
        s = r;
      } else {
        content = r;
      }
      if (content) {
        content = runTagReplacements(content, reg, strip, replacement, fullString);
      }
      result += s + content + (isVoid ? '' : s);
      currentIndex = index + (tagLength || 0);
    }

    fullString = fullString || str;
    reg = RegExp(reg.source, 'gi');

    while(match = reg.exec(str)) {

      var tagName         = match[2];
      var attributes      = (match[3]|| '').slice(1);
      var isClosingTag    = !!match[1];
      var isSelfClosing   = !!match[4];
      var tagLength       = match[0].length;
      var isVoid          = tagIsVoid(tagName);
      var isOpeningTag    = !isClosingTag && !isSelfClosing && !isVoid;
      var isSameAsCurrent = tagName === openTagName;

      if (!openTagName) {
        result += str.slice(currentIndex, match.index);
        currentIndex = match.index;
      }

      if (isOpeningTag) {
        if (!openTagName) {
          openTagName = tagName;
          openTagAttributes = attributes;
          openTagCount++;
          currentIndex += tagLength;
        } else if (isSameAsCurrent) {
          openTagCount++;
        }
      } else if (isClosingTag && isSameAsCurrent) {
        openTagCount--;
        if (openTagCount === 0) {
          processTag(match.index, openTagName, openTagAttributes, tagLength, isVoid);
          openTagName       = null;
          openTagAttributes = null;
        }
      } else if (!openTagName) {
        processTag(match.index, tagName, attributes, tagLength, isVoid);
      }
    }
    if (openTagName) {
      processTag(str.length, openTagName, openTagAttributes);
    }
    result += str.slice(currentIndex);
    return result;
  }

  function numberOrIndex(str, n, from) {
    if (isString(n)) {
      n = str.indexOf(n);
      if (n === -1) {
        n = from ? str.length : 0;
      }
    }
    return n;
  }

  function buildBase64() {
    var encodeAscii, decodeAscii;

    function catchEncodingError(fn) {
      return function(str) {
        try {
          return fn(str);
        } catch(e) {
          return '';
        }
      };
    }

    if (typeof Buffer !== 'undefined') {
      encodeBase64 = function(str) {
        return new Buffer(str).toString('base64');
      };
      decodeBase64 = function(str) {
        return new Buffer(str, 'base64').toString('utf8');
      };
      return;
    }
    if (typeof btoa !== 'undefined') {
      encodeAscii = catchEncodingError(btoa);
      decodeAscii = catchEncodingError(atob);
    } else {
      var key = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=';
      var base64reg = /[^A-Za-z0-9\+\/\=]/g;
      encodeAscii = function(str) {
        var output = '';
        var chr1, chr2, chr3;
        var enc1, enc2, enc3, enc4;
        var i = 0;
        do {
          chr1 = str.charCodeAt(i++);
          chr2 = str.charCodeAt(i++);
          chr3 = str.charCodeAt(i++);
          enc1 = chr1 >> 2;
          enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
          enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
          enc4 = chr3 & 63;
          if (isNaN(chr2)) {
            enc3 = enc4 = 64;
          } else if (isNaN(chr3)) {
            enc4 = 64;
          }
          output += key.charAt(enc1);
          output += key.charAt(enc2);
          output += key.charAt(enc3);
          output += key.charAt(enc4);
          chr1 = chr2 = chr3 = '';
          enc1 = enc2 = enc3 = enc4 = '';
        } while (i < str.length);
        return output;
      };
      decodeAscii = function(input) {
        var output = '';
        var chr1, chr2, chr3;
        var enc1, enc2, enc3, enc4;
        var i = 0;
        if (input.match(base64reg)) {
          return '';
        }
        input = input.replace(/[^A-Za-z0-9\+\/\=]/g, '');
        do {
          enc1 = key.indexOf(input.charAt(i++));
          enc2 = key.indexOf(input.charAt(i++));
          enc3 = key.indexOf(input.charAt(i++));
          enc4 = key.indexOf(input.charAt(i++));
          chr1 = (enc1 << 2) | (enc2 >> 4);
          chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
          chr3 = ((enc3 & 3) << 6) | enc4;
          output = output + chr(chr1);
          if (enc3 != 64) {
            output = output + chr(chr2);
          }
          if (enc4 != 64) {
            output = output + chr(chr3);
          }
          chr1 = chr2 = chr3 = '';
          enc1 = enc2 = enc3 = enc4 = '';
        } while (i < input.length);
        return output;
      };
    }
    encodeBase64 = function(str) {
      return encodeAscii(unescape(encodeURIComponent(str)));
    };
    decodeBase64 = function(str) {
      return decodeURIComponent(escape(decodeAscii(str)));
    };
  }

  function buildEntities() {
    HTMLToEntityMap = {};
    forEachProperty(HTMLFromEntityMap, function(val, key) {
      HTMLToEntityMap[val] = '&' + key + ';';
    });
  }

  function callIncludesWithRegexSupport(str, search, position) {
    if (!isRegExp(search)) {
      return nativeIncludes.call(str, search, position);
    }
    if (position) {
      str = str.slice(position);
    }
    return search.test(str);
  }

  defineInstance(sugarString, {

    // Enhancment to String#includes to allow a regex.
    'includes': fixArgumentLength(callIncludesWithRegexSupport)

  }, [ENHANCEMENTS_FLAG, STRING_ENHANCEMENTS_FLAG]);

  defineInstance(sugarString, {

    /***
     * @method at(index, [loop] = false)
     * @returns Mixed
     * @short Gets the character(s) at a given index.
     * @extra When [loop] is true, overshooting the end of the string will begin
     *        counting from the other end. `index` may be negative. If `index` is
     *        an array, multiple elements will be returned.
     * @example
     *
     *   'jumpy'.at(0)             -> 'j'
     *   'jumpy'.at(2)             -> 'm'
     *   'jumpy'.at(5)             -> ''
     *   'jumpy'.at(5, true)       -> 'j'
     *   'jumpy'.at(-1)            -> 'y'
     *   'lucky charms'.at([2, 4]) -> ['u','k']
     *
     * @param {number|Array<number>} index
     * @param {boolean} [loop]
     *
     ***/
    'at': function(str, index, loop) {
      return getEntriesForIndexes(str, index, loop, true);
    },

    /***
     * @method escapeURL([param] = false)
     * @returns String
     * @short Escapes characters in a string to make a valid URL.
     * @extra If [param] is true, it will also escape valid URL characters. Use
     *        this when the entire string is meant for use in a query string.
     *
     * @example
     *
     *   'a, b, and c'.escapeURL() -> 'a,%20b,%20and%20c'
     *   'http://foo.com/'.escapeURL(true) -> 'http%3A%2F%2Ffoo.com%2F'
     *
     * @param {boolean} [param]
     *
     ***/
    'escapeURL': function(str, param) {
      return param ? encodeURIComponent(str) : encodeURI(str);
    },

    /***
     * @method unescapeURL([partial] = false)
     * @returns String
     * @short Restores escaped characters in a URL escaped string.
     * @extra If [partial] is true, it will only unescape non-valid URL tokens,
     *        and is included here for completeness, but should be rarely needed.
     *
     * @example
     *
     *   'http%3A%2F%2Ffoo.com%2F'.unescapeURL()     -> 'http://foo.com/'
     *   'http%3A%2F%2Ffoo.com%2F'.unescapeURL(true) -> 'http%3A%2F%2Ffoo.com%2F'
     *
     * @param {boolean} [partial]
     *
     ***/
    'unescapeURL': function(str, param) {
      return param ? decodeURI(str) : decodeURIComponent(str);
    },

    /***
     * @method escapeHTML()
     * @returns String
     * @short Converts HTML characters to their entity equivalents.
     *
     * @example
     *
     *   '<p>some text</p>'.escapeHTML() -> '&lt;p&gt;some text&lt;/p&gt;'
     *   'one & two'.escapeHTML()        -> 'one &amp; two'
     *
     ***/
    'escapeHTML': function(str) {
      return str.replace(HTML_ESCAPE_REG, function(chr) {
        return getOwn(HTMLToEntityMap, chr);
      });
    },

    /***
     * @method unescapeHTML()
     * @returns String
     * @short Restores escaped HTML characters.
     *
     * @example
     *
     *   '&lt;p&gt;some text&lt;/p&gt;'.unescapeHTML() -> '<p>some text</p>'
     *   'one &amp; two'.unescapeHTML()                -> 'one & two'
     *
     ***/
    'unescapeHTML': function(str) {
      return unescapeHTML(str);
    },

    /***
     * @method stripTags([tag] = 'all', [replace])
     * @returns String
     * @short Strips HTML tags from the string.
     * @extra [tag] may be an array of tags or 'all', in which case all tags will
     *        be stripped. [replace] will replace what was stripped, and may be a
     *        string or a function of type `replaceFn` to handle replacements. If
     *        this function returns a string, then it will be used for the
     *        replacement. If it returns `undefined`, the tags will be stripped normally.
     *
     * @callback replaceFn
     *
     *   tag     The tag name.
     *   inner   The tag content.
     *   attr    The attributes on the tag, if any, as a string.
     *   outer   The entire matched tag string.
     *
     * @example
     *
     *   '<p>just <b>some</b> text</p>'.stripTags()    -> 'just some text'
     *   '<p>just <b>some</b> text</p>'.stripTags('p') -> 'just <b>some</b> text'
     *   '<p>hi!</p>'.stripTags('p', function(all, content) {
     *     return '|';
     *   }); -> '|hi!|'
     *
     * @param {string} tag
     * @param {string|replaceFn} replace
     * @callbackParam {string} tag
     * @callbackParam {string} inner
     * @callbackParam {string} attr
     * @callbackParam {string} outer
     * @callbackReturns {string} replaceFn
     *
     ***/
    'stripTags': function(str, tag, replace) {
      return replaceTags(str, tag, replace, true);
    },

    /***
     * @method removeTags([tag] = 'all', [replace])
     * @returns String
     * @short Removes HTML tags and their contents from the string.
     * @extra [tag] may be an array of tags or 'all', in which case all tags will
     *        be removed. [replace] will replace what was removed, and may be a
     *        string or a function of type `replaceFn` to handle replacements. If
     *        this function returns a string, then it will be used for the
     *        replacement. If it returns `undefined`, the tags will be removed normally.
     *
     * @callback replaceFn
     *
     *   tag     The tag name.
     *   inner   The tag content.
     *   attr    The attributes on the tag, if any, as a string.
     *   outer   The entire matched tag string.
     *
     * @example
     *
     *   '<p>just <b>some</b> text</p>'.removeTags()    -> ''
     *   '<p>just <b>some</b> text</p>'.removeTags('b') -> '<p>just text</p>'
     *   '<p>hi!</p>'.removeTags('p', function(all, content) {
     *     return 'bye!';
     *   }); -> 'bye!'
     *
     * @param {string} tag
     * @param {string|replaceFn} replace
     * @callbackParam {string} tag
     * @callbackParam {string} inner
     * @callbackParam {string} attr
     * @callbackParam {string} outer
     * @callbackReturns {string} replaceFn
     *
     ***/
    'removeTags': function(str, tag, replace) {
      return replaceTags(str, tag, replace, false);
    },

    /***
     * @method encodeBase64()
     * @returns String
     * @short Encodes the string into base64 encoding.
     * @extra This method wraps native methods when available, and uses a custom
     *        implementation when not available. It can also handle Unicode
     *        string encodings.
     *
     * @example
     *
     *   'gonna get encoded!'.encodeBase64()  -> 'Z29ubmEgZ2V0IGVuY29kZWQh'
     *   'http://twitter.com/'.encodeBase64() -> 'aHR0cDovL3R3aXR0ZXIuY29tLw=='
     *
     ***/
    'encodeBase64': function(str) {
      return encodeBase64(str);
    },

    /***
     * @method decodeBase64()
     * @returns String
     * @short Decodes the string from base64 encoding.
     * @extra This method wraps native methods when available, and uses a custom
     *        implementation when not available. It can also handle Unicode string
     *        encodings.
     *
     * @example
     *
     *   'aHR0cDovL3R3aXR0ZXIuY29tLw=='.decodeBase64() -> 'http://twitter.com/'
     *   'anVzdCBnb3QgZGVjb2RlZA=='.decodeBase64()     -> 'just got decoded!'
     *
     ***/
    'decodeBase64': function(str) {
      return decodeBase64(str);
    },

    /***
     * @method forEach([search], [eachFn])
     * @returns Array
     * @short Runs callback [eachFn] against every character in the string, or
     *        every every occurence of [search] if it is provided.
     * @extra Returns an array of matches. [search] may be either a string or
     *        regex, and defaults to every character in the string. If [eachFn]
     *        returns false at any time it will break out of the loop.
     *
     * @callback eachFn
     *
     *   match  The current match.
     *   i      The current index.
     *   arr    An array of all matches.
     *
     * @example
     *
     *   'jumpy'.forEach(log)     -> ['j','u','m','p','y']
     *   'jumpy'.forEach(/[r-z]/) -> ['u','y']
     *   'jumpy'.forEach(/mp/)    -> ['mp']
     *   'jumpy'.forEach(/[r-z]/, function(m) {
     *     // Called twice: "u", "y"
     *   });
     *
     * @signature forEach(eachFn)
     * @param {string|RegExp} [search]
     * @param {eachFn} [eachFn]
     * @callbackParam {string} match
     * @callbackParam {number} i
     * @callbackParam {Array<string>} arr
     *
     ***/
    'forEach': function(str, search, eachFn) {
      return stringEach(str, search, eachFn);
    },

    /***
     * @method chars([eachCharFn])
     * @returns Array
     * @short Runs [eachCharFn] against each character in the string, and returns an array.
     *
     * @callback eachCharFn
     *
     *   char  The current character.
     *   i     The current index.
     *   arr   An array of all characters.
     *
     * @example
     *
     *   'jumpy'.chars() -> ['j','u','m','p','y']
     *   'jumpy'.chars(function(c) {
     *     // Called 5 times: "j","u","m","p","y"
     *   });
     *
     * @param {eachCharFn} [eachCharFn]
     * @callbackParam {string} char
     * @callbackParam {number} i
     * @callbackParam {Array<string>} arr
     *
     ***/
    'chars': function(str, search, eachCharFn) {
      return stringEach(str, search, eachCharFn);
    },

    /***
     * @method words([eachWordFn])
     * @returns Array
     * @short Runs [eachWordFn] against each word in the string, and returns an array.
     * @extra A "word" is defined as any sequence of non-whitespace characters.
     *
     * @callback eachWordFn
     *
     *   word  The current word.
     *   i     The current index.
     *   arr   An array of all words.
     *
     * @example
     *
     *   'broken wear'.words() -> ['broken','wear']
     *   'broken wear'.words(function(w) {
     *     // Called twice: "broken", "wear"
     *   });
     *
     * @param {eachWordFn} [eachWordFn]
     * @callbackParam {string} word
     * @callbackParam {number} i
     * @callbackParam {Array<string>} arr
     *
     ***/
    'words': function(str, eachWordFn) {
      return stringEach(trim(str), /\S+/g, eachWordFn);
    },

    /***
     * @method lines([eachLineFn])
     * @returns Array
     * @short Runs [eachLineFn] against each line in the string, and returns an array.
     *
     * @callback eachLineFn
     *
     *   line  The current line.
     *   i     The current index.
     *   arr   An array of all lines.
     *
     * @example
     *
     *   lineText.lines() -> array of lines
     *   lineText.lines(function(l) {
     *     // Called once per line
     *   });
     *
     * @param {eachLineFn} [eachLineFn]
     * @callbackParam {string} line
     * @callbackParam {number} i
     * @callbackParam {Array<string>} arr
     *
     ***/
    'lines': function(str, eachLineFn) {
      return stringEach(trim(str), /^.*$/gm, eachLineFn);
    },

    /***
     * @method codes([eachCodeFn])
     * @returns Array
     * @short Runs callback [eachCodeFn] against each character code in the string.
     *        Returns an array of character codes.
     *
     * @callback eachCodeFn
     *
     *   code  The current character code.
     *   i     The current index.
     *   str   The string being operated on.
     *
     * @example
     *
     *   'jumpy'.codes() -> [106,117,109,112,121]
     *   'jumpy'.codes(function(c) {
     *     // Called 5 times: 106, 117, 109, 112, 121
     *   });
     *
     * @param {eachCodeFn} [eachCodeFn]
     * @callbackParam {number} code
     * @callbackParam {number} i
     * @callbackParam {string} str
     *
     ***/
    'codes': function(str, eachCodeFn) {
      return stringCodes(str, eachCodeFn);
    },

    /***
     * @method shift(n)
     * @returns Array
     * @short Shifts each character in the string `n` places in the character map.
     *
     * @example
     *
     *   'a'.shift(1)  -> 'b'
     *   'ク'.shift(1) -> 'グ'
     *
     * @param {number} n
     *
     ***/
    'shift': function(str, n) {
      var result = '';
      n = n || 0;
      stringCodes(str, function(c) {
        result += chr(c + n);
      });
      return result;
    },

    /***
     * @method isBlank()
     * @returns Boolean
     * @short Returns true if the string has length 0 or contains only whitespace.
     *
     * @example
     *
     *   ''.isBlank()      -> true
     *   '   '.isBlank()   -> true
     *   'noway'.isBlank() -> false
     *
     ***/
    'isBlank': function(str) {
      return trim(str).length === 0;
    },

    /***
     * @method isEmpty()
     * @returns Boolean
     * @short Returns true if the string has length 0.
     *
     * @example
     *
     *   ''.isEmpty()  -> true
     *   'a'.isBlank() -> false
     *   ' '.isBlank() -> false
     *
     ***/
    'isEmpty': function(str) {
      return str.length === 0;
    },

    /***
     * @method insert(str, [index] = length)
     * @returns String
     * @short Adds `str` at [index]. Allows negative values.
     *
     * @example
     *
     *   'dopamine'.insert('e', 3)       -> dopeamine
     *   'spelling eror'.insert('r', -3) -> spelling error
     *
     * @param {string} str
     * @param {number} [index]
     *
     ***/
    'insert': function(str, substr, index) {
      index = isUndefined(index) ? str.length : index;
      return str.slice(0, index) + substr + str.slice(index);
    },

    /***
     * @method remove(f)
     * @returns String
     * @short Removes the first occurrence of `f` in the string.
     * @extra `f` can be a either case-sensitive string or a regex. In either case
     *        only the first match will be removed. To remove multiple occurrences,
     *        use `removeAll`.
     *
     * @example
     *
     *   'schfifty five'.remove('f')      -> 'schifty five'
     *   'schfifty five'.remove(/[a-f]/g) -> 'shfifty five'
     *
     * @param {string|RegExp} f
     *
     ***/
    'remove': function(str, f) {
      return str.replace(f, '');
    },

    /***
     * @method removeAll(f)
     * @returns String
     * @short Removes any occurences of `f` in the string.
     * @extra `f` can be either a case-sensitive string or a regex. In either case
     *        all matches will be removed. To remove only a single occurence, use
     *        `remove`.
     *
     * @example
     *
     *   'schfifty five'.removeAll('f')     -> 'schity ive'
     *   'schfifty five'.removeAll(/[a-f]/) -> 'shity iv'
     *
     * @param {string|RegExp} f
     *
     ***/
    'removeAll': function(str, f) {
      return stringReplaceAll(str, f);
    },

    /***
     * @method reverse()
     * @returns String
     * @short Reverses the string.
     *
     * @example
     *
     *   'jumpy'.reverse()        -> 'ypmuj'
     *   'lucky charms'.reverse() -> 'smrahc ykcul'
     *
     ***/
    'reverse': function(str) {
      return reverseString(str);
    },

    /***
     * @method compact()
     * @returns String
     * @short Compacts whitespace in the string to a single space and trims the ends.
     *
     * @example
     *
     *   'too \n much \n space'.compact() -> 'too much space'
     *   'enough \n '.compact()           -> 'enought'
     *
     ***/
    'compact': function(str) {
      return trim(str).replace(/([\r\n\s　])+/g, function(match, whitespace) {
        return whitespace === '　' ? whitespace : ' ';
      });
    },

    /***
     * @method from([index] = 0)
     * @returns String
     * @short Returns a section of the string starting from [index].
     *
     * @example
     *
     *   'lucky charms'.from()   -> 'lucky charms'
     *   'lucky charms'.from(7)  -> 'harms'
     *
     * @param {number} [index]
     *
     ***/
    'from': function(str, from) {
      return str.slice(numberOrIndex(str, from, true));
    },

    /***
     * @method to([index] = end)
     * @returns String
     * @short Returns a section of the string ending at [index].
     *
     * @example
     *
     *   'lucky charms'.to()   -> 'lucky charms'
     *   'lucky charms'.to(7)  -> 'lucky ch'
     *
     * @param {number} [index]
     *
     ***/
    'to': function(str, to) {
      if (isUndefined(to)) to = str.length;
      return str.slice(0, numberOrIndex(str, to));
    },

    /***
     * @method dasherize()
     * @returns String
     * @short Converts underscores and camel casing to hypens.
     *
     * @example
     *
     *   'a_farewell_to_arms'.dasherize() -> 'a-farewell-to-arms'
     *   'capsLock'.dasherize()           -> 'caps-lock'
     *
     ***/
    'dasherize': function(str) {
      return stringUnderscore(str).replace(/_/g, '-');
    },

    /***
     * @method underscore()
     * @returns String
     * @short Converts hyphens and camel casing to underscores.
     *
     * @example
     *
     *   'a-farewell-to-arms'.underscore() -> 'a_farewell_to_arms'
     *   'capsLock'.underscore()           -> 'caps_lock'
     *
     ***/
    'underscore': function(str) {
      return stringUnderscore(str);
    },

    /***
     * @method camelize([upper] = true)
     * @returns String
     * @short Converts underscores and hyphens to camel case.
     * @extra If [upper] is true, the string will be UpperCamelCase. If the
     *        inflections module is included, acronyms can also be defined that
     *        will be used when camelizing.
     *
     * @example
     *
     *   'caps_lock'.camelize()              -> 'CapsLock'
     *   'moz-border-radius'.camelize()      -> 'MozBorderRadius'
     *   'moz-border-radius'.camelize(false) -> 'mozBorderRadius'
     *   'http-method'.camelize()            -> 'HTTPMethod'
     *
     * @param {boolean} [upper]
     *
     ***/
    'camelize': function(str, upper) {
      return stringCamelize(str, upper);
    },

    /***
     * @method spacify()
     * @returns String
     * @short Converts camelcase, underscores, and hyphens to spaces.
     *
     * @example
     *
     *   'camelCase'.spacify()                         -> 'camel case'
     *   'an-ugly-string'.spacify()                    -> 'an ugly string'
     *   'oh-no_youDid-not'.spacify().capitalize(true) -> 'something else'
     *
     ***/
    'spacify': function(str) {
      return stringSpacify(str);
    },

    /***
     * @method titleize()
     * @returns String
     * @short Creates a title version of the string.
     * @extra Capitalizes all the words and replaces some characters in the string
     *        to create a nicer looking title. String#titleize is meant for
     *        creating pretty output.
     *
     * @example
     *
     *   'man from the boondocks'.titleize() -> 'Man from the Boondocks'
     *   'x-men: apocalypse'.titleize() -> 'X Men: Apocalypse'
     *   'TheManWithoutAPast'.titleize() -> 'The Man Without a Past'
     *   'raiders_of_the_lost_ark'.titleize() -> 'Raiders of the Lost Ark'
     *
     ***/
    'titleize': function(str) {
      return stringTitleize(str);
    },

    /***
     * @method parameterize()
     * @returns String
     * @short Replaces special characters in a string so that it may be used as
     *        part of a pretty URL.
     *
     * @example
     *
     *   'hell, no!'.parameterize() -> 'hell-no'
     *
     ***/
    'parameterize': function(str, separator) {
      return stringParameterize(str, separator);
    },

    /***
     * @method truncate(length, [from] = 'right', [ellipsis] = '...')
     * @returns String
     * @short Truncates a string.
     * @extra [from] can be `'right'`, `'left'`, or `'middle'`. If the string is
     *        shorter than `length`, [ellipsis] will not be added.
     *
     * @example
     *
     *   'sittin on the dock'.truncate(10)           -> 'sittin on ...'
     *   'sittin on the dock'.truncate(10, 'left')   -> '...n the dock'
     *   'sittin on the dock'.truncate(10, 'middle') -> 'sitti... dock'
     *
     * @param {number} length
     * @param {string} [from]
     * @param {string} [ellipsis]
     *
     ***/
    'truncate': function(str, length, from, ellipsis) {
      return truncateString(str, length, from, ellipsis);
    },

    /***
     * @method truncateOnWord(length, [from] = 'right', [ellipsis] = '...')
     * @returns String
     * @short Truncates a string without splitting up words.
     * @extra [from] can be `'right'`, `'left'`, or `'middle'`. If the string is
     *        shorter than `length`, [ellipsis] will not be added. A "word" is
     *        defined as any sequence of non-whitespace characters.
     *
     * @example
     *
     *   'here we go'.truncateOnWord(5)         -> 'here...'
     *   'here we go'.truncateOnWord(5, 'left') -> '...we go'
     *
     * @param {number} length
     * @param {string} [from]
     * @param {string} [ellipsis]
     *
     ***/
    'truncateOnWord': function(str, length, from, ellipsis) {
      return truncateString(str, length, from, ellipsis, true);
    },

    /***
     * @method pad(num, [padding] = ' ')
     * @returns String
     * @short Pads the string out with [padding] to be exactly `num` characters.
     *
     * @example
     *
     *   'wasabi'.pad(8)      -> ' wasabi '
     *   'wasabi'.pad(8, '-') -> '-wasabi-'
     *
     * @param {number} num
     * @param {string} [padding]
     *
     ***/
    'pad': function(str, num, padding) {
      var half, front, back;
      num   = coercePositiveInteger(num);
      half  = max(0, num - str.length) / 2;
      front = floor(half);
      back  = ceil(half);
      return padString(front, padding) + str + padString(back, padding);
    },

    /***
     * @method padLeft(num, [padding] = ' ')
     * @returns String
     * @short Pads the string out from the left with [padding] to be exactly
     *        `num` characters.
     *
     * @example
     *
     *   'wasabi'.padLeft(8)      -> '  wasabi'
     *   'wasabi'.padLeft(8, '-') -> '--wasabi'
     *
     * @param {number} num
     * @param {string} [padding]
     *
     ***/
    'padLeft': function(str, num, padding) {
      num = coercePositiveInteger(num);
      return padString(max(0, num - str.length), padding) + str;
    },

    /***
     * @method padRight(num, [padding] = ' ')
     * @returns String
     * @short Pads the string out from the right with [padding] to be exactly
     *        `num` characters.
     *
     * @example
     *
     *   'wasabi'.padRight(8)      -> 'wasabi  '
     *   'wasabi'.padRight(8, '-') -> 'wasabi--'
     *
     * @param {number} num
     * @param {string} [padding]
     *
     ***/
    'padRight': function(str, num, padding) {
      num = coercePositiveInteger(num);
      return str + padString(max(0, num - str.length), padding);
    },

    /***
     * @method first([n] = 1)
     * @returns String
     * @short Returns the first [n] characters of the string.
     *
     * @example
     *
     *   'lucky charms'.first()  -> 'l'
     *   'lucky charms'.first(3) -> 'luc'
     *
     * @param {number} [n]
     *
     ***/
    'first': function(str, num) {
      if (isUndefined(num)) num = 1;
      return str.substr(0, num);
    },

    /***
     * @method last([n] = 1)
     * @returns String
     * @short Returns the last [n] characters of the string.
     *
     * @example
     *
     *   'lucky charms'.last()  -> 's'
     *   'lucky charms'.last(3) -> 'rms'
     *
     * @param {number} [n]
     *
     ***/
    'last': function(str, num) {
      if (isUndefined(num)) num = 1;
      var start = str.length - num < 0 ? 0 : str.length - num;
      return str.substr(start);
    },

    /***
     * @method toNumber([base] = 10)
     * @returns Number
     * @short Converts the string into a number.
     * @extra Any value with a "." fill be converted to a floating point value,
     *        otherwise an integer.
     *
     * @example
     *
     *   '153'.toNumber()    -> 153
     *   '12,000'.toNumber() -> 12000
     *   '10px'.toNumber()   -> 10
     *   'ff'.toNumber(16)   -> 255
     *
     * @param {number} [base]
     *
     ***/
    'toNumber': function(str, base) {
      return stringToNumber(str, base);
    },

    /***
     * @method capitalize([lower] = false, [all] = false)
     * @returns String
     * @short Capitalizes the first character of the string.
     * @extra If [lower] is true, the remainder of the string will be downcased.
     *        If [all] is true, all words in the string will be capitalized.
     *
     * @example
     *
     *   'hello'.capitalize()           -> 'Hello'
     *   'HELLO'.capitalize(true)       -> 'Hello'
     *   'hello kitty'.capitalize()     -> 'Hello kitty'
     *   'hEllO kItTy'.capitalize(true, true) -> 'Hello Kitty'
     *
     * @param {boolean} [lower]
     * @param {boolean} [all]
     *
     ***/
    'capitalize': function(str, lower, all) {
      return stringCapitalize(str, lower, all);
    },

    /***
     * @method trimLeft()
     * @returns String
     * @short Removes leading whitespace from the string.
     * @extra Whitespace is defined as line breaks, tabs, and any character in the
     *        "Space, Separator" Unicode category, conforming to the the ES5 `trim`
     *        spec.
     *
     * @example
     *
     *   '   wasabi   '.trimLeft()  -> 'wasabi   '
     *
     ***/
    'trimLeft': function(str) {
      return str.replace(LEFT_TRIM_REG, '');
    },

    /***
     * @method trimRight()
     * @returns String
     * @short Removes trailing whitespace from the string.
     * @extra Whitespace is defined as line breaks, tabs, and any character in the
     *        "Space, Separator" Unicode category, conforming to the the ES5 `trim`
     *        spec.
     *
     * @example
     *
     *   '   wasabi   '.trimRight() -> '   wasabi'
     *
     ***/
    'trimRight': function(str) {
      return str.replace(RIGHT_TRIM_REG, '');
    }

  });

  defineInstanceWithArguments(sugarString, {

    /***
     * @method replaceAll(f, [str1], [str2], ...)
     * @returns String
     * @short Replaces all occurences of `f` with arguments passed.
     * @extra This method is intended to be a quick way to perform multiple string
     *        replacements quickly when the replacement token differs depending on
     *        position. `f` can be either a case-sensitive string or a regex.
     *        In either case all matches will be replaced.
     *
     * @example
     *
     *   '-x -y -z'.replaceAll('-', 1, 2, 3)               -> '1x 2y 3z'
     *   'one and two'.replaceAll(/one|two/, '1st', '2nd') -> '1st and 2nd'
     *
     * @param {string|RegExp} f
     * @param {string} [str1]
     * @param {string} [str2]
     *
     ***/
    'replaceAll': function(str, f, args) {
      return stringReplaceAll(str, f, args);
    },

    /***
     * @method format(obj1, [obj2], ...)
     * @returns String
     * @short Replaces `{}` tokens in the string with arguments or properties.
     * @extra Tokens support `deep properties`. If a single object is passed, its
     *        properties can be accessed by keywords such as `{name}`. If multiple
     *        objects or a non-object are passed, they can be accessed by the
     *        argument position like `{0}`. Literal braces in the string can be
     *        escaped by repeating them.
     *
     * @example
     *
     *   'Welcome, {name}.'.format({ name: 'Bill' }) -> 'Welcome, Bill.'
     *   'You are {0} years old today.'.format(5)    -> 'You are 5 years old today.'
     *   '{0.name} and {1.name}'.format(users)       -> logs first two users' names
     *   '${currencies.usd.balance}'.format(Harry)   -> "$500"
     *   '{{Hello}}'.format('Hello')                 -> "{Hello}"
     *
     * @param {any} [obj1]
     * @param {any} [obj2]
     *
     ***/
    'format': function(str, args) {
      var arg1 = args[0] && args[0].valueOf();
      // Unwrap if a single object is passed in.
      if (args.length === 1 && isObjectType(arg1)) {
        args = arg1;
      }
      return stringFormatMatcher(str, args);
    }

  });

  buildBase64();

  buildEntities();

  /***
   * @module Function
   * @description Lazy, throttled, and memoized functions, delayed functions and
   *              handling of timers, argument currying.
   *
   ***/


  var _lock     = privatePropertyAccessor('lock');

  var _timers   = privatePropertyAccessor('timers');

  var _partial  = privatePropertyAccessor('partial');

  var _canceled = privatePropertyAccessor('canceled');

  var createInstanceFromPrototype = Object.create || function(prototype) {
    var ctor = function() {};
    ctor.prototype = prototype;
    return new ctor;
  };

  function setDelay(fn, ms, after, scope, args) {
    // Delay of infinity is never called of course...
    ms = coercePositiveInteger(ms || 0);
    if (!_timers(fn)) {
      _timers(fn, []);
    }
    // This is a workaround for <= IE8, which apparently has the
    // ability to call timeouts in the queue on the same tick (ms?)
    // even if functionally they have already been cleared.
    _canceled(fn, false);
    _timers(fn).push(setTimeout(function() {
      if (!_canceled(fn)) {
        after.apply(scope, args || []);
      }
    }, ms));
  }

  function cancelFunction(fn) {
    var timers = _timers(fn), timer;
    if (isArray(timers)) {
      while(timer = timers.shift()) {
        clearTimeout(timer);
      }
    }
    _canceled(fn, true);
    return fn;
  }

  function createLazyFunction(fn, ms, immediate, limit) {
    var queue = [], locked = false, execute, rounded, perExecution, result;
    ms = ms || 1;
    limit = limit || Infinity;
    rounded = ceil(ms);
    perExecution = round(rounded / ms) || 1;
    execute = function() {
      var queueLength = queue.length, maxPerRound;
      if (queueLength == 0) return;
      // Allow fractions of a millisecond by calling
      // multiple times per actual timeout execution
      maxPerRound = max(queueLength - perExecution, 0);
      while(queueLength > maxPerRound) {
        // Getting uber-meta here...
        result = Function.prototype.apply.apply(fn, queue.shift());
        queueLength--;
      }
      setDelay(lazy, rounded, function() {
        locked = false;
        execute();
      });
    };
    function lazy() {
      // If the execution has locked and it's immediate, then
      // allow 1 less in the queue as 1 call has already taken place.
      if (queue.length < limit - (locked && immediate ? 1 : 0)) {
        // Optimized: no leaking arguments
        var args = []; for(var $i = 0, $len = arguments.length; $i < $len; $i++) args.push(arguments[$i]);
        queue.push([this, args]);
      }
      if (!locked) {
        locked = true;
        if (immediate) {
          execute();
        } else {
          setDelay(lazy, rounded, execute);
        }
      }
      // Return the memoized result
      return result;
    }
    return lazy;
  }

  // Collecting arguments in an array instead of
  // passing back the arguments object which will
  // deopt this function in V8.
  function collectArguments() {
    var args = arguments, i = args.length, arr = new Array(i);
    while (i--) {
      arr[i] = args[i];
    }
    return arr;
  }

  function createHashedMemoizeFunction(fn, hashFn, limit) {
    var map = {}, refs = [], counter = 0;
    return function() {
      var hashObj = hashFn.apply(this, arguments);
      var key = serializeInternal(hashObj, refs);
      if (hasOwn(map, key)) {
        return getOwn(map, key);
      }
      if (counter === limit) {
        map = {};
        refs = [];
        counter = 0;
      }
      counter++;
      return map[key] = fn.apply(this, arguments);
    };
  }

  defineInstance(sugarFunction, {

    /***
     * @method lazy([ms] = 1, [immediate] = false, [limit] = Infinity)
     * @returns Function
     * @short Creates a lazy function that, when called repeatedly, will queue
     *        execution and wait [ms] milliseconds to execute.
     * @extra If [immediate] is `true`, first execution will happen immediately,
     *        then lock. If [limit] is a fininte number, calls past [limit] will
     *        be ignored while execution is locked. Compare this to `throttle`,
     *        which will execute only once per [ms] milliseconds. Note that [ms]
     *        can also be a fraction. Calling `cancel` on a lazy function will
     *        clear the entire queue.
     *
     * @example
     *
     *   var fn = logHello.lazy(250);
     *   runTenTimes(fn); -> Logs 10 times each time 250ms later
     *
     *   var fn = logHello.lazy(250, false, 5);
     *   runTenTimes(fn); -> Logs 5 times each time 250ms later
     *
     * @param {number} [ms]
     * @param {number} [limit]
     * @param {boolean} [immediate]
     *
     ***/
    'lazy': function(fn, ms, immediate, limit) {
      return createLazyFunction(fn, ms, immediate, limit);
    },

    /***
     * @method throttle([ms] = 1)
     * @returns Function
     * @short Creates a "throttled" version of the function that will only be
     *        executed once per `ms` milliseconds.
     * @extra This is functionally equivalent to calling `lazy` with a [limit] of
     *        `1` and [immediate] as `true`. `throttle` is appropriate when you
     *        want to make sure a function is only executed at most once for a
     *        given duration.
     *
     * @example
     *
     *   var fn = logHello.throttle(50);
     *   runTenTimes(fn);
     *
     * @param {number} [ms]
     *
     ***/
    'throttle': function(fn, ms) {
      return createLazyFunction(fn, ms, true, 1);
    },

    /***
     * @method debounce([ms] = 1)
     * @returns Function
     * @short Creates a "debounced" function that postpones its execution until
     *        after `ms` milliseconds have passed.
     * @extra This method is useful to execute a function after things have
     *        "settled down". A good example of this is when a user tabs quickly
     *        through form fields, execution of a heavy operation should happen
     *        after a few milliseconds when they have "settled" on a field.
     *
     * @example
     *
     *   var fn = logHello.debounce(250)
     *   runTenTimes(fn); -> called once 250ms later
     *
     * @param {number} [ms]
     *
     ***/
    'debounce': function(fn, ms) {
      function debounced() {
        // Optimized: no leaking arguments
        var args = []; for(var $i = 0, $len = arguments.length; $i < $len; $i++) args.push(arguments[$i]);
        cancelFunction(debounced);
        setDelay(debounced, ms, fn, this, args);
      }
      return debounced;
    },

    /***
     * @method cancel()
     * @returns Function
     * @short Cancels a delayed function scheduled to be run.
     * @extra `delay`, `lazy`, `throttle`, and `debounce` can all set delays.
     *
     * @example
     *
     *   logHello.delay(500).cancel() -> never logs
     *
     ***/
    'cancel': function(fn) {
      return cancelFunction(fn);
    },

    /***
     * @method after(n)
     * @returns Function
     * @short Creates a function that will execute after `n` calls.
     * @extra `after` is useful for running a final callback after a specific
     *        number of operations, often when the order in which the operations
     *        will complete is unknown. The created function will be passed an
     *        array of the arguments that it has collected from each after `n`.
     *        Note that the function will execute on every call after `n`.
     *        Use `once` in conjunction with this method to prevent being
     *        triggered by subsequent calls.
     *
     * @example
     *
     *   var fn = logHello.after(5);
     *   runTenTimes(fn); -> logs 6 times
     *
     *   var fn = logHello.once().after(5)
     *   runTenTimes(fn); -> logs once
     *
     * @param {number} [n]
     *
     ***/
    'after': function(fn, num) {
      var count = 0, collectedArgs = [];
      num = coercePositiveInteger(num);
      return function() {
        // Optimized: no leaking arguments
        var args = []; for(var $i = 0, $len = arguments.length; $i < $len; $i++) args.push(arguments[$i]);
        collectedArgs.push(args);
        count++;
        if (count >= num) {
          return fn.call(this, collectedArgs);
        }
      };
    },

    /***
     * @method once()
     * @returns Function
     * @short Creates a function that will execute only once and store the result.
     * @extra `once` is useful for creating functions that will cache the result
     *        of an expensive operation and use it on subsequent calls. Also it
     *        can be useful for creating initialization functions that only need
     *        to be run once.
     *
     * @example
     *
     *   var fn = logHello.once();
     *   runTenTimes(fn); -> logs once
     *
     ***/
    'once': function(fn) {
      var called = false, val;
      return function() {
        if (called) {
          return val;
        }
        called = true;
        return val = fn.apply(this, arguments);
      };
    },

    /***
     * @method memoize([hashFn], [limit])
     * @returns Function
     * @short Creates a function that will memoize results for unique calls.
     * @extra `memoize` can be thought of as a more powerful `once`. Where `once`
     *        will only call a function once ever, memoized functions will be
     *        called once per unique call. A "unique call" is determined by the
     *        return value of [hashFn], which is passed the arguments of each call.
     *        If [hashFn] is undefined, it will deeply serialize all arguments,
     *        such that any different argument signature will result in a unique
     *        call. [hashFn] may be a string (allows `deep properties`) that acts
     *        as a shortcut to return a property of the first argument passed.
     *        [limit] sets an upper limit on memoized results. The default is no
     *        limit, meaning that unique calls will continue to memoize results.
     *        For most use cases this is fine, however [limit] is useful for more
     *        persistent (often server-side) applications for whom memory leaks
     *        are a concern.
     *
     * @example
     *
     *   var fn = logHello.memoize();
     *   fn(1); fn(1); fn(2); -> logs twice, memoizing once
     *
     *   var fn = calculateUserBalance.memoize('id');
     *   fn(Harry); fn(Mark); fn(Mark); -> logs twice, memoizing once
     *
     * @param {string|Function} [hashFn]
     * @param {number} [limit]
     *
     ***/
    'memoize': function(fn, arg1, arg2) {
      var hashFn, limit, prop;
      if (isNumber(arg1)) {
        limit = arg1;
      } else {
        hashFn = arg1;
        limit  = arg2;
      }
      if (isString(hashFn)) {
        prop = hashFn;
        hashFn = function(obj) {
          return deepGetProperty(obj, prop);
        };
      } else if (!hashFn) {
        hashFn = collectArguments;
      }
      return createHashedMemoizeFunction(fn, hashFn, limit);
    },

    /***
     * @method lock([n])
     * @returns Function
     * @short Locks the number of arguments accepted by the function.
     * @extra If not passed, [n] will be the length of the function. This method
     *        can be called on functions created by `partial`, in which case it
     *        will lock the total arguments during execution.
     *
     * @example
     *
     *   logArgs.lock(2)(1,2,3)      -> logs 1,2
     *
     * @param {number} [n]
     *
     ***/
    'lock': function(fn, n) {
      var lockedFn;
      if (_partial(fn)) {
        _lock(fn, isNumber(n) ? n : null);
        return fn;
      }
      lockedFn = function() {
        arguments.length = min(_lock(lockedFn), arguments.length);
        return fn.apply(this, arguments);
      };
      _lock(lockedFn, isNumber(n) ? n : fn.length);
      return lockedFn;
    }

  });

  defineInstanceWithArguments(sugarFunction, {

    /***
     * @method partial([arg1], [arg2], ...)
     * @returns Function
     * @short Returns a new version of the function which has part of its arguments
     *        pre-emptively filled in, also known as "currying".
     * @extra `undefined` can be passed as any argument, and is a placeholder that
     *        will be replaced with arguments passed when the function is executed.
     *        This allows currying of arguments even when they occur toward the end
     *        of an argument list (the example demonstrates this more clearly).
     *
     * @example
     *
     *   logArgs.partial(undefined, 'b')('a') -> logs a, b
     *
     * @param {any} [arg1]
     * @param {any} [arg2]
     *
     ***/
    'partial': function(fn, curriedArgs) {
      var curriedLen = curriedArgs.length;
      var partialFn = function() {
        var argIndex = 0, applyArgs = [], self = this, lock = _lock(partialFn), result, i;
        for (i = 0; i < curriedLen; i++) {
          var arg = curriedArgs[i];
          if (isDefined(arg)) {
            applyArgs[i] = arg;
          } else {
            applyArgs[i] = arguments[argIndex++];
          }
        }
        for (i = argIndex; i < arguments.length; i++) {
          applyArgs.push(arguments[i]);
        }
        if (lock === null) {
          lock = curriedLen;
        }
        if (isNumber(lock)) {
          applyArgs.length = min(applyArgs.length, lock);
        }
        // If the bound "this" object is an instance of the partialed
        // function, then "new" was used, so preserve the prototype
        // so that constructor functions can also be partialed.
        if (self instanceof partialFn) {
          self = createInstanceFromPrototype(fn.prototype);
          result = fn.apply(self, applyArgs);
          // An explicit return value is allowed from constructors
          // as long as they are of "object" type, so return the
          // correct result here accordingly.
          return isObjectType(result) ? result : self;
        }
        return fn.apply(self, applyArgs);
      };
      _partial(partialFn, true);
      return partialFn;
    },

    /***
     * @method delay([ms] = 1, [arg1], [arg2], ...)
     * @returns Function
     * @short Executes the function after `ms` milliseconds.
     * @extra Returns a reference to itself. `delay` is also a way to execute non-
     *        blocking operations that will wait until the CPU is free. Delayed
     *        functions can be canceled using the `cancel` method. Can also curry
     *        arguments passed in after `ms`.
     *
     * @example
     *
     *   logHello.delay(500)     -> logs after 500ms
     *   logArgs.delay(500, 'a') -> logs "a" after 500ms
     *
     * @param {number} [ms]
     * @param {any} [arg1]
     * @param {any} [arg2]
     *
     ***/
    'delay': function(fn, ms, args) {
      setDelay(fn, ms, fn, fn, args);
      return fn;
    },

    /***
     * @method every([ms] = 1, [arg1], [arg2], ...)
     * @returns Function
     * @short Executes the function every `ms` milliseconds.
     * @extra Returns a reference to itself. `every` uses `setTimeout`, which
     *        means that you are guaranteed a period of idle time equal to [ms]
     *        after execution has finished. Compare this to `setInterval` which
     *        will try to run a function every [ms], even when execution itself
     *        takes up a portion of that time. In most cases avoiding `setInterval`
     *        is better as calls won't "back up" when the CPU is under strain,
     *        however this also means that calls are less likely to happen at
     *        exact intervals of [ms], so the use case here should be considered.
     *        Additionally, `every` can curry arguments passed in after [ms], and
     *        also be canceled with `cancel`.
     *
     * @example
     *
     *   logHello.every(1000)        -> logs every second
     *   logArgs.every(1000, 'Hola') -> logs 'hola' every second
     *
     * @param {number} [ms]
     * @param {any} [arg1]
     * @param {any} [arg2]
     *
     ***/
    'every': function(fn, ms, args) {
      function execute () {
        // Set the delay first here, so that cancel
        // can be called within the executing function.
        setDelay(fn, ms, execute);
        fn.apply(fn, args);
      }
      setDelay(fn, ms, execute);
      return fn;
    }

  });

  /***
   * @module Range
   * @description Date, Number, and String ranges that can be manipulated and compared,
   *              or enumerate over specific points within the range.
   *
   ***/


  var DURATION_UNITS = 'year|month|week|day|hour|minute|second|millisecond';

  var DURATION_REG   = RegExp('(\\d+)?\\s*('+ DURATION_UNITS +')s?', 'i');

  var MULTIPLIERS = {
    'Hours': 60 * 60 * 1000,
    'Minutes': 60 * 1000,
    'Seconds': 1000,
    'Milliseconds': 1
  };

  var PrimitiveRangeConstructor = function(start, end) {
    return new Range(start, end);
  };

  function Range(start, end) {
    this.start = cloneRangeMember(start);
    this.end   = cloneRangeMember(end);
  }

  function getRangeMemberPrimitiveValue(m) {
    if (m == null) return m;
    return isDate(m) ? m.getTime() : m.valueOf();
  }

  function cloneRangeMember(m) {
    if (isDate(m)) {
      return new Date(m.getTime());
    } else {
      return getRangeMemberPrimitiveValue(m);
    }
  }

  function getDateIncrementObject(amt) {
    var match, val, unit;
    if (isNumber(amt)) {
      return [amt, 'Milliseconds'];
    }
    match = amt.match(DURATION_REG);
    val = +match[1] || 1;
    unit = simpleCapitalize(match[2].toLowerCase());
    if (unit.match(/hour|minute|second/i)) {
      unit += 's';
    } else if (unit === 'Year') {
      unit = 'FullYear';
    } else if (unit === 'Week') {
      unit = 'Date';
      val *= 7;
    } else if (unit === 'Day') {
      unit = 'Date';
    }
    return [val, unit];
  }

  function incrementDate(src, amount, unit) {
    var mult = MULTIPLIERS[unit], d;
    if (mult) {
      d = new Date(src.getTime() + (amount * mult));
    } else {
      d = new Date(src);
      callDateSet(d, unit, callDateGet(src, unit) + amount);
    }
    return d;
  }

  defineStatic(sugarString, {

    /***
     * @method range([start], [end])
     * @returns Range
     * @static
     * @short Creates a new string range between [start] and [end]. See `ranges`
     *        for more.
     *
     * @example
     *
     *   String.range('a', 'z')
     *   String.range('t', 'm')
     *
     * @param {string} [start]
     * @param {string} [end]
     *
     ***/
    'range': PrimitiveRangeConstructor

  });

  var FULL_CAPTURED_DURATION = '((?:\\d+)?\\s*(?:' + DURATION_UNITS + '))s?';

  // Duration text formats
  var RANGE_REG_FROM_TO        = /(?:from)?\s*(.+)\s+(?:to|until)\s+(.+)$/i,
      RANGE_REG_REAR_DURATION  = RegExp('(.+)\\s*for\\s*' + FULL_CAPTURED_DURATION, 'i'),
      RANGE_REG_FRONT_DURATION = RegExp('(?:for)?\\s*'+ FULL_CAPTURED_DURATION +'\\s*(?:starting)?\\s(?:at\\s)?(.+)', 'i');

  var DateRangeConstructor = function(start, end) {
    if (arguments.length === 1 && isString(start)) {
      return createDateRangeFromString(start);
    }
    return new Range(getDateForRange(start), getDateForRange(end));
  };

  function createDateRangeFromString(str) {
    var match, datetime, duration, dio, start, end;
    if (sugarDate.get && (match = str.match(RANGE_REG_FROM_TO))) {
      start = getDateForRange(match[1].replace('from', 'at'));
      end = sugarDate.get(start, match[2]);
      return new Range(start, end);
    }
    if (match = str.match(RANGE_REG_FRONT_DURATION)) {
      duration = match[1];
      datetime = match[2];
    }
    if (match = str.match(RANGE_REG_REAR_DURATION)) {
      datetime = match[1];
      duration = match[2];
    }
    if (datetime && duration) {
      start = getDateForRange(datetime);
      dio = getDateIncrementObject(duration);
      end = incrementDate(start, dio[0], dio[1]);
    } else {
      start = str;
    }
    return new Range(getDateForRange(start), getDateForRange(end));
  }

  function getDateForRange(d) {
    if (isDate(d)) {
      return d;
    } else if (d == null) {
      return new Date();
    } else if (sugarDate.create) {
      return sugarDate.create(d);
    }
    return new Date(d);
  }

  defineStatic(sugarDate, {

    /***
     * @method range([start], [end])
     * @returns Range
     * @namespace Date
     * @static
     * @short Creates a new date range between [start] and [end].
     * @extra Arguments may be either dates or strings which will be forwarded to
     *        the date constructor (`create` will be used if present in the build).
     *        If either [start] or [end] are undefined, they will default to the
     *        current date. This method also accepts an alternate syntax of a
     *        single string describing the range in natural language. See `ranges`
     *        for more.
     *
     * @example
     *
     *   Date.range(jan, may)
     *   Date.range('today', 'tomorrow')
     *   Date.range('now', '5 days ago')
     *   Date.range('last Monday')
     *   Date.range('Monday to Friday')
     *   Date.range('tomorrow from 3pm to 5pm')
     *   Date.range('1 hour starting at 5pm Tuesday')
     *
     * @param {string|Date} [start]
     * @param {string|Date} [end]
     *
     ***/
    'range': DateRangeConstructor

  });

  /***
   * @module Locales
   * @description Locale files for the Sugar Date module.
   *
   ***/

  /*
   * Catalan locale definition.
   * See the readme for customization and more information.
   * To set this locale globally:
   *
   * Sugar.Date.setLocale('ca')
   *
   */
  Sugar.Date.addLocale('ca', {
    'plural': true,
    'units': 'milisegon:|s,segon:|s,minut:|s,hor:a|es,di:a|es,setman:a|es,mes:|os,any:|s',
    'months': 'gen:er|,febr:er|,mar:ç|,abr:il|,mai:g|,jun:y|,jul:iol|,ag:ost|,set:embre|,oct:ubre|,nov:embre|,des:embre|',
    'weekdays': 'diumenge|dg,dilluns|dl,dimarts|dt,dimecres|dc,dijous|dj,divendres|dv,dissabte|ds',
    'numerals': 'zero,un,dos,tres,quatre,cinc,sis,set,vuit,nou,deu',
    'tokens': 'el,la,de',
    'short':  '{dd}/{MM}/{yyyy}',
    'medium': '{d} {month} {yyyy}',
    'long':   '{d} {month} {yyyy} {time}',
    'full':   '{weekday} {d} {month} {yyyy} {time}',
    'stamp':  '{dow} {d} {mon} {yyyy} {time}',
    'time':   '{H}:{mm}',
    'past':   '{sign} {num} {unit}',
    'future': '{sign} {num} {unit}',
    'duration': '{num} {unit}',
    'timeMarkers': 'a las',
    'ampm': 'am,pm',
    'modifiers': [
      { 'name': 'day', 'src': "abans d'ahir", 'value': -2 },
      { 'name': 'day', 'src': 'ahir', 'value': -1 },
      { 'name': 'day', 'src': 'avui', 'value': 0 },
      { 'name': 'day', 'src': 'demà|dema', 'value': 1 },
      { 'name': 'sign', 'src': 'fa', 'value': -1 },
      { 'name': 'sign', 'src': 'en', 'value': 1 },
      { 'name': 'shift', 'src': 'passat', 'value': -1 },
      { 'name': 'shift', 'src': 'el proper|la propera', 'value': 1 }
    ],
    'parse': [
      '{sign} {num} {unit}',
      '{num} {unit} {sign}',
      '{0?}{1?} {unit:5-7} {shift}',
      '{0?}{1?} {shift} {unit:5-7}'
    ],
    'timeParse': [
      '{shift} {weekday}',
      '{weekday} {shift}',
      '{date?} {2?} {months}\\.? {2?} {year?}'
    ]
  });


  /*
   * Danish locale definition.
   * See the readme for customization and more information.
   * To set this locale globally:
   *
   * Sugar.Date.setLocale('da')
   *
   */
  Sugar.Date.addLocale('da', {
    'plural': true,
    'units': 'millisekund:|er,sekund:|er,minut:|ter,tim:e|er,dag:|e,ug:e|er|en,måned:|er|en+maaned:|er|en,år:||et+aar:||et',
    'months': 'jan:uar|,feb:ruar|,mar:ts|,apr:il|,maj,jun:i|,jul:i|,aug:ust|,sep:tember|,okt:ober|,nov:ember|,dec:ember|',
    'weekdays': 'søn:dag|+son:dag|,man:dag|,tir:sdag|,ons:dag|,tor:sdag|,fre:dag|,lør:dag|+lor:dag|',
    'numerals': 'nul,en|et,to,tre,fire,fem,seks,syv,otte,ni,ti',
    'tokens':   'den,for',
    'articles': 'den',
    'short':  '{dd}-{MM}-{yyyy}',
    'medium': '{d}. {month} {yyyy}',
    'long':   '{d}. {month} {yyyy} {time}',
    'full':   '{weekday} d. {d}. {month} {yyyy} {time}',
    'stamp':  '{dow} {d} {mon} {yyyy} {time}',
    'time':   '{H}:{mm}',
    'past':   '{num} {unit} {sign}',
    'future': '{sign} {num} {unit}',
    'duration': '{num} {unit}',
    'ampm': 'am,pm',
    'modifiers': [
      { 'name': 'day', 'src': 'forgårs|i forgårs|forgaars|i forgaars', 'value': -2 },
      { 'name': 'day', 'src': 'i går|igår|i gaar|igaar', 'value': -1 },
      { 'name': 'day', 'src': 'i dag|idag', 'value': 0 },
      { 'name': 'day', 'src': 'i morgen|imorgen', 'value': 1 },
      { 'name': 'day', 'src': 'over morgon|overmorgen|i over morgen|i overmorgen|iovermorgen', 'value': 2 },
      { 'name': 'sign', 'src': 'siden', 'value': -1 },
      { 'name': 'sign', 'src': 'om', 'value':  1 },
      { 'name': 'shift', 'src': 'i sidste|sidste', 'value': -1 },
      { 'name': 'shift', 'src': 'denne', 'value': 0 },
      { 'name': 'shift', 'src': 'næste|naeste', 'value': 1 }
    ],
    'parse': [
      '{months} {year?}',
      '{num} {unit} {sign}',
      '{sign} {num} {unit}',
      '{1?} {num} {unit} {sign}',
      '{shift} {unit:5-7}'
    ],
    'timeParse': [
      '{day|weekday}',
      '{date} {months?}\\.? {year?}'
    ],
    'timeFrontParse': [
      '{shift} {weekday}',
      '{0?} {weekday?},? {date}\\.? {months?}\\.? {year?}'
    ]
  });


  /*
   * German locale definition.
   * See the readme for customization and more information.
   * To set this locale globally:
   *
   * Sugar.Date.setLocale('de')
   *
   */
  Sugar.Date.addLocale('de', {
    'plural': true,
    'units': 'Millisekunde:|n,Sekunde:|n,Minute:|n,Stunde:|n,Tag:|en,Woche:|n,Monat:|en,Jahr:|en|e',
    'months': 'Jan:uar|,Feb:ruar|,M:är|ärz|ar|arz,Apr:il|,Mai,Juni,Juli,Aug:ust|,Sept:ember|,Okt:ober|,Nov:ember|,Dez:ember|',
    'weekdays': 'So:nntag|,Mo:ntag|,Di:enstag|,Mi:ttwoch|,Do:nnerstag|,Fr:eitag|,Sa:mstag|',
    'numerals': 'null,ein:|e|er|en|em,zwei,drei,vier,fuenf,sechs,sieben,acht,neun,zehn',
    'tokens': 'der',
    'short': '{dd}.{MM}.{yyyy}',
    'medium': '{d}. {Month} {yyyy}',
    'long': '{d}. {Month} {yyyy} {time}',
    'full': '{Weekday}, {d}. {Month} {yyyy} {time}',
    'stamp': '{Dow} {d} {Mon} {yyyy} {time}',
    'time': '{H}:{mm}',
    'past': '{sign} {num} {unit}',
    'future': '{sign} {num} {unit}',
    'duration': '{num} {unit}',
    'timeMarkers': 'um',
    'ampm': 'am,pm',
    'modifiers': [
      { 'name': 'day', 'src': 'vorgestern', 'value': -2 },
      { 'name': 'day', 'src': 'gestern', 'value': -1 },
      { 'name': 'day', 'src': 'heute', 'value': 0 },
      { 'name': 'day', 'src': 'morgen', 'value': 1 },
      { 'name': 'day', 'src': 'übermorgen|ubermorgen|uebermorgen', 'value': 2 },
      { 'name': 'sign', 'src': 'vor:|her', 'value': -1 },
      { 'name': 'sign', 'src': 'in', 'value': 1 },
      { 'name': 'shift', 'src': 'letzte:|r|n|s', 'value': -1 },
      { 'name': 'shift', 'src': 'nächste:|r|n|s+nachste:|r|n|s+naechste:|r|n|s+kommende:n|r', 'value': 1 }
    ],
    'parse': [
      '{months} {year?}',
      '{sign} {num} {unit}',
      '{num} {unit} {sign}',
      '{shift} {unit:5-7}'
    ],
    'timeParse': [
      '{shift?} {day|weekday}',
      '{weekday?},? {date}\\.? {months?}\\.? {year?}'
    ],
    'timeFrontParse': [
      '{shift} {weekday}',
      '{weekday?},? {date}\\.? {months?}\\.? {year?}'
    ]
  });


  /*
   * Spanish locale definition.
   * See the readme for customization and more information.
   * To set this locale globally:
   *
   * Sugar.Date.setLocale('es')
   *
   */
  Sugar.Date.addLocale('es', {
    'plural': true,
    'units': 'milisegundo:|s,segundo:|s,minuto:|s,hora:|s,día|días|dia|dias,semana:|s,mes:|es,año|años|ano|anos',
    'months': 'ene:ro|,feb:rero|,mar:zo|,abr:il|,may:o|,jun:io|,jul:io|,ago:sto|,sep:tiembre|,oct:ubre|,nov:iembre|,dic:iembre|',
    'weekdays': 'dom:ingo|,lun:es|,mar:tes|,mié:rcoles|+mie:rcoles|,jue:ves|,vie:rnes|,sáb:ado|+sab:ado|',
    'numerals': 'cero,uno,dos,tres,cuatro,cinco,seis,siete,ocho,nueve,diez',
    'tokens': 'el,la,de',
    'short':  '{dd}/{MM}/{yyyy}',
    'medium': '{d} de {Month} de {yyyy}',
    'long':   '{d} de {Month} de {yyyy} {time}',
    'full':   '{weekday}, {d} de {month} de {yyyy} {time}',
    'stamp':  '{dow} {d} {mon} {yyyy} {time}',
    'time':   '{H}:{mm}',
    'past':   '{sign} {num} {unit}',
    'future': '{sign} {num} {unit}',
    'duration': '{num} {unit}',
    'timeMarkers': 'a las',
    'ampm': 'am,pm',
    'modifiers': [
      { 'name': 'day', 'src': 'anteayer', 'value': -2 },
      { 'name': 'day', 'src': 'ayer', 'value': -1 },
      { 'name': 'day', 'src': 'hoy', 'value': 0 },
      { 'name': 'day', 'src': 'mañana|manana', 'value': 1 },
      { 'name': 'sign', 'src': 'hace', 'value': -1 },
      { 'name': 'sign', 'src': 'dentro de', 'value': 1 },
      { 'name': 'shift', 'src': 'pasad:o|a', 'value': -1 },
      { 'name': 'shift', 'src': 'próximo|próxima|proximo|proxima', 'value': 1 }
    ],
    'parse': [
      '{months} {2?} {year?}',
      '{sign} {num} {unit}',
      '{num} {unit} {sign}',
      '{0?}{1?} {unit:5-7} {shift}',
      '{0?}{1?} {shift} {unit:5-7}'
    ],
    'timeParse': [
      '{shift?} {day|weekday} {shift?}',
      '{date} {2?} {months?}\\.? {2?} {year?}'
    ],
    'timeFrontParse': [
      '{shift?} {weekday} {shift?}',
      '{date} {2?} {months?}\\.? {2?} {year?}'
    ]
  });


  /*
   * Finnish locale definition.
   * See the readme for customization and more information.
   * To set this locale globally:
   *
   * Sugar.Date.setLocale('fi')
   *
   */
  Sugar.Date.addLocale('fi', {
    'plural': true,
    'units': 'millisekun:ti|tia|nin|teja|tina,sekun:ti|tia|nin|teja|tina,minuut:ti|tia|in|teja|tina,tun:ti|tia|nin|teja|tina,päiv:ä|ää|än|iä|änä,viik:ko|koa|on|olla|koja|kona,kuukau:si|tta|den+kuussa,vuo:si|tta|den|sia|tena|nna',
    'months': 'tammi:kuuta||kuu,helmi:kuuta||kuu,maalis:kuuta||kuu,huhti:kuuta||kuu,touko:kuuta||kuu,kesä:kuuta||kuu,heinä:kuuta||kuu,elo:kuuta||kuu,syys:kuuta||kuu,loka:kuuta||kuu,marras:kuuta||kuu,joulu:kuuta||kuu',
    'weekdays': 'su:nnuntai||nnuntaina,ma:anantai||anantaina,ti:istai||istaina,ke:skiviikko||skiviikkona,to:rstai||rstaina,pe:rjantai||rjantaina,la:uantai||uantaina',
    'numerals': 'nolla,yksi|ensimmäinen,kaksi|toinen,kolm:e|as,neljä:|s,vii:si|des,kuu:si|des,seitsemä:n|s,kahdeksa:n|s,yhdeksä:n|s,kymmene:n|s',
    'short': '{d}.{M}.{yyyy}',
    'medium': '{d}. {month} {yyyy}',
    'long': '{d}. {month} {yyyy} klo {time}',
    'full': '{weekday} {d}. {month} {yyyy} klo {time}',
    'stamp': '{dow} {d} {mon} {yyyy} {time}',
    'time': '{H}.{mm}',
    'timeMarkers': 'klo,kello',
    'ordinalSuffix': '.',
    'relative': function(num, unit, ms, format) {
      var units = this['units'];
      function numberWithUnit(mult) {
        return num + ' ' + units[(8 * mult) + unit];
      }
      function baseUnit() {
        return numberWithUnit(num === 1 ? 0 : 1);
      }
      switch(format) {
        case 'duration':  return baseUnit();
        case 'past':      return baseUnit() + ' sitten';
        case 'future':    return numberWithUnit(2) + ' kuluttua';
      }
    },
    'modifiers': [
      { 'name': 'day',   'src': 'toissa päivänä', 'value': -2 },
      { 'name': 'day',   'src': 'eilen|eilistä', 'value': -1 },
      { 'name': 'day',   'src': 'tänään', 'value': 0 },
      { 'name': 'day',   'src': 'huomenna|huomista', 'value': 1 },
      { 'name': 'day',   'src': 'ylihuomenna|ylihuomista', 'value': 2 },
      { 'name': 'sign',  'src': 'sitten|aiemmin', 'value': -1 },
      { 'name': 'sign',  'src': 'päästä|kuluttua|myöhemmin', 'value': 1 },
      { 'name': 'edge',  'src': 'lopussa', 'value': 2 },
      { 'name': 'edge',  'src': 'ensimmäinen|ensimmäisenä', 'value': -2 },
      { 'name': 'shift', 'src': 'edel:linen|lisenä', 'value': -1 },
      { 'name': 'shift', 'src': 'viime', 'value': -1 },
      { 'name': 'shift', 'src': 'tä:llä|ssä|nä|mä', 'value': 0 },
      { 'name': 'shift', 'src': 'seuraava|seuraavana|tuleva|tulevana|ensi', 'value': 1 }
    ],
    'parse': [
      '{months} {year?}',
      '{shift} {unit:5-7}'
    ],
    'timeParse': [
      '{shift?} {day|weekday}',
      '{weekday?},? {date}\\.? {months?}\\.? {year?}'
    ],
    'timeFrontParse': [
      '{shift?} {day|weekday}',
      '{num?} {unit} {sign}',
      '{weekday?},? {date}\\.? {months?}\\.? {year?}'
    ]
  });


  /*
   * French locale definition.
   * See the readme for customization and more information.
   * To set this locale globally:
   *
   * Sugar.Date.setLocale('fr')
   *
   */
  Sugar.Date.addLocale('fr', {
    'plural': true,
    'units': 'milliseconde:|s,seconde:|s,minute:|s,heure:|s,jour:|s,semaine:|s,mois,an:|s|née|nee',
    'months': 'janv:ier|,févr:ier|+fevr:ier|,mars,avr:il|,mai,juin,juil:let|,août,sept:embre|,oct:obre|,nov:embre|,déc:embre|+dec:embre|',
    'weekdays': 'dim:anche|,lun:di|,mar:di|,mer:credi|,jeu:di|,ven:dredi|,sam:edi|',
    'numerals': 'zéro,un:|e,deux,trois,quatre,cinq,six,sept,huit,neuf,dix',
    'tokens': "l'|la|le,er",
    'short':  '{dd}/{MM}/{yyyy}',
    'medium': '{d} {month} {yyyy}',
    'long':   '{d} {month} {yyyy} {time}',
    'full':   '{weekday} {d} {month} {yyyy} {time}',
    'stamp':  '{dow} {d} {mon} {yyyy} {time}',
    'time':   '{H}:{mm}',
    'past':   '{sign} {num} {unit}',
    'future': '{sign} {num} {unit}',
    'duration': '{num} {unit}',
    'timeMarkers': 'à',
    'ampm': 'am,pm',
    'modifiers': [
      { 'name': 'day', 'src': 'hier', 'value': -1 },
      { 'name': 'day', 'src': "aujourd'hui", 'value': 0 },
      { 'name': 'day', 'src': 'demain', 'value': 1 },
      { 'name': 'sign', 'src': 'il y a', 'value': -1 },
      { 'name': 'sign', 'src': "dans|d'ici", 'value': 1 },
      { 'name': 'shift', 'src': 'derni:èr|er|ère|ere', 'value': -1 },
      { 'name': 'shift', 'src': 'prochain:|e', 'value': 1 }
    ],
    'parse': [
      '{months} {year?}',
      '{sign} {num} {unit}',
      '{0?} {unit:5-7} {shift}'
    ],
    'timeParse': [
      '{day|weekday} {shift?}',
      '{weekday?},? {0?} {date}{1?} {months}\\.? {year?}'
    ],
    'timeFrontParse': [
      '{0?} {weekday} {shift}',
      '{weekday?},? {0?} {date}{1?} {months}\\.? {year?}'
    ]
  });


  /*
   * Italian locale definition.
   * See the readme for customization and more information.
   * To set this locale globally:
   *
   * Sugar.Date.setLocale('it')
   *
   */
  Sugar.Date.addLocale('it', {
    'plural': true,
    'units': 'millisecond:o|i,second:o|i,minut:o|i,or:a|e,giorn:o|i,settiman:a|e,mes:e|i,ann:o|i',
    'months': 'gen:naio|,feb:braio|,mar:zo|,apr:ile|,mag:gio|,giu:gno|,lug:lio|,ago:sto|,set:tembre|,ott:obre|,nov:embre|,dic:embre|',
    'weekdays': 'dom:enica|,lun:edì||edi,mar:tedì||tedi,mer:coledì||coledi,gio:vedì||vedi,ven:erdì||erdi,sab:ato|',
    'numerals': "zero,un:|a|o|',due,tre,quattro,cinque,sei,sette,otto,nove,dieci",
    'tokens': "l'|la|il",
    'short': '{dd}/{MM}/{yyyy}',
    'medium': '{d} {month} {yyyy}',
    'long': '{d} {month} {yyyy} {time}',
    'full': '{weekday}, {d} {month} {yyyy} {time}',
    'stamp': '{dow} {d} {mon} {yyyy} {time}',
    'time': '{H}:{mm}',
    'past': '{num} {unit} {sign}',
    'future': '{num} {unit} {sign}',
    'duration': '{num} {unit}',
    'timeMarkers': 'alle',
    'ampm': 'am,pm',
    'modifiers': [
      { 'name': 'day', 'src': 'ieri', 'value': -1 },
      { 'name': 'day', 'src': 'oggi', 'value': 0 },
      { 'name': 'day', 'src': 'domani', 'value': 1 },
      { 'name': 'day', 'src': 'dopodomani', 'value': 2 },
      { 'name': 'sign', 'src': 'fa', 'value': -1 },
      { 'name': 'sign', 'src': 'da adesso', 'value': 1 },
      { 'name': 'shift', 'src': 'scors:o|a', 'value': -1 },
      { 'name': 'shift', 'src': 'prossim:o|a', 'value': 1 }
    ],
    'parse': [
      '{months} {year?}',
      '{num} {unit} {sign}',
      '{0?} {unit:5-7} {shift}',
      '{0?} {shift} {unit:5-7}'
    ],
    'timeParse': [
      '{shift?} {day|weekday}',
      '{weekday?},? {date} {months?}\\.? {year?}'
    ],
    'timeFrontParse': [
      '{shift?} {day|weekday}',
      '{weekday?},? {date} {months?}\\.? {year?}'
    ]
  });


  /*
   * Japanese locale definition.
   * See the readme for customization and more information.
   * To set this locale globally:
   *
   * Sugar.Date.setLocale('ja')
   *
   */
  Sugar.Date.addLocale('ja', {
    'ampmFront': true,
    'numeralUnits': true,
    'allowsFullWidth': true,
    'timeMarkerOptional': true,
    'firstDayOfWeek': 0,
    'firstDayOfWeekYear': 1,
    'units': 'ミリ秒,秒,分,時間,日,週間|週,ヶ月|ヵ月|月,年|年度',
    'weekdays': '日:曜日||曜,月:曜日||曜,火:曜日||曜,水:曜日||曜,木:曜日||曜,金:曜日||曜,土:曜日||曜',
    'numerals': '〇,一,二,三,四,五,六,七,八,九',
    'placeholders': '十,百,千,万',
    'timeSuffixes': ',秒,分,時,日,,月,年度?',
    'short':  '{yyyy}/{MM}/{dd}',
    'medium': '{yyyy}年{M}月{d}日',
    'long':   '{yyyy}年{M}月{d}日{time}',
    'full':   '{yyyy}年{M}月{d}日{time} {weekday}',
    'stamp':  '{yyyy}年{M}月{d}日 {H}:{mm} {dow}',
    'time':   '{tt}{h}時{mm}分',
    'past':   '{num}{unit}{sign}',
    'future': '{num}{unit}{sign}',
    'duration': '{num}{unit}',
    'ampm': '午前,午後',
    'modifiers': [
      { 'name': 'day', 'src': '一昨々日|前々々日', 'value': -3 },
      { 'name': 'day', 'src': '一昨日|おととい|前々日', 'value': -2 },
      { 'name': 'day', 'src': '昨日|前日', 'value': -1 },
      { 'name': 'day', 'src': '今日|当日|本日', 'value': 0 },
      { 'name': 'day', 'src': '明日|翌日|次日', 'value': 1 },
      { 'name': 'day', 'src': '明後日|翌々日', 'value': 2 },
      { 'name': 'day', 'src': '明々後日|翌々々日', 'value': 3 },
      { 'name': 'sign', 'src': '前', 'value': -1 },
      { 'name': 'sign', 'src': '後', 'value': 1 },
      { 'name': 'edge', 'src': '始|初日|頭', 'value': -2 },
      { 'name': 'edge', 'src': '末|尻', 'value': 2 },
      { 'name': 'edge', 'src': '末日', 'value': 1 },
      { 'name': 'shift', 'src': '一昨々|前々々', 'value': -3 },
      { 'name': 'shift', 'src': '一昨|前々|先々', 'value': -2 },
      { 'name': 'shift', 'src': '先|昨|去|前', 'value': -1 },
      { 'name': 'shift', 'src': '今|本|当', 'value':  0 },
      { 'name': 'shift', 'src': '来|明|翌|次', 'value':  1 },
      { 'name': 'shift', 'src': '明後|翌々|次々|再来|さ来', 'value': 2 },
      { 'name': 'shift', 'src': '明々後|翌々々', 'value':  3 }
    ],
    'parse': [
      '{month}{edge}',
      '{num}{unit}{sign}',
      '{year?}{month}',
      '{year}'
    ],
    'timeParse': [
      '{day|weekday}',
      '{shift}{unit:5}{weekday?}',
      '{shift}{unit:7}{month}{edge}',
      '{shift}{unit:7}{month?}{date?}',
      '{shift}{unit:6}{edge?}{date?}',
      '{year?}{month?}{date}'
    ]
  });


  /*
   * Korean locale definition.
   * See the readme for customization and more information.
   * To set this locale globally:
   *
   * Sugar.Date.setLocale('ko')
   *
   */
  Sugar.Date.addLocale('ko', {
    'ampmFront': true,
    'numeralUnits': true,
    'units': '밀리초,초,분,시간,일,주,개월|달,년|해',
    'weekdays': '일:요일|,월:요일|,화:요일|,수:요일|,목:요일|,금:요일|,토:요일|',
    'numerals': '영|제로,일|한,이,삼,사,오,육,칠,팔,구,십',
    'short':  '{yyyy}.{MM}.{dd}',
    'medium': '{yyyy}년 {M}월 {d}일',
    'long':   '{yyyy}년 {M}월 {d}일 {time}',
    'full':   '{yyyy}년 {M}월 {d}일 {weekday} {time}',
    'stamp':  '{yyyy}년 {M}월 {d}일 {H}:{mm} {dow}',
    'time':   '{tt} {h}시 {mm}분',
    'past':   '{num}{unit} {sign}',
    'future': '{num}{unit} {sign}',
    'duration': '{num}{unit}',
    'timeSuffixes': ',초,분,시,일,,월,년',
    'ampm': '오전,오후',
    'modifiers': [
      { 'name': 'day', 'src': '그저께', 'value': -2 },
      { 'name': 'day', 'src': '어제', 'value': -1 },
      { 'name': 'day', 'src': '오늘', 'value': 0 },
      { 'name': 'day', 'src': '내일', 'value': 1 },
      { 'name': 'day', 'src': '모레', 'value': 2 },
      { 'name': 'sign', 'src': '전', 'value': -1 },
      { 'name': 'sign', 'src': '후', 'value':  1 },
      { 'name': 'shift', 'src': '지난|작', 'value': -1 },
      { 'name': 'shift', 'src': '이번|올', 'value': 0 },
      { 'name': 'shift', 'src': '다음|내', 'value': 1 }
    ],
    'parse': [
      '{num}{unit} {sign}',
      '{shift?} {unit:5-7}',
      '{year?} {month}',
      '{year}'
    ],
    'timeParse': [
      '{day|weekday}',
      '{shift} {unit:5?} {weekday}',
      '{year?} {month?} {date} {weekday?}'
    ]
  });


  /*
   * Dutch locale definition.
   * See the readme for customization and more information.
   * To set this locale globally:
   *
   * Sugar.Date.setLocale('nl')
   *
   */
  Sugar.Date.addLocale('nl', {
    'plural': true,
    'units': 'milliseconde:|n,seconde:|n,minu:ut|ten,uur,dag:|en,we:ek|ken,maand:|en,jaar',
    'months': 'jan:uari|,feb:ruari|,maart|mrt,apr:il|,mei,jun:i|,jul:i|,aug:ustus|,sep:tember|,okt:ober|,nov:ember|,dec:ember|',
    'weekdays': 'zondag|zo,maandag|ma,dinsdag|di,woensdag|wo|woe,donderdag|do,vrijdag|vr|vrij,zaterdag|za',
    'numerals': 'nul,een,twee,drie,vier,vijf,zes,zeven,acht,negen,tien',
    'short':  '{dd}-{MM}-{yyyy}',
    'medium': '{d} {month} {yyyy}',
    'long':   '{d} {Month} {yyyy} {time}',
    'full':   '{weekday} {d} {Month} {yyyy} {time}',
    'stamp':  '{dow} {d} {Mon} {yyyy} {time}',
    'time':   '{H}:{mm}',
    'past':   '{num} {unit} {sign}',
    'future': '{num} {unit} {sign}',
    'duration': '{num} {unit}',
    'timeMarkers': "'s,om",
    'modifiers': [
      { 'name': 'day', 'src': 'gisteren', 'value': -1 },
      { 'name': 'day', 'src': 'vandaag', 'value': 0 },
      { 'name': 'day', 'src': 'morgen', 'value': 1 },
      { 'name': 'day', 'src': 'overmorgen', 'value': 2 },
      { 'name': 'sign', 'src': 'geleden', 'value': -1 },
      { 'name': 'sign', 'src': 'vanaf nu', 'value': 1 },
      { 'name': 'shift', 'src': 'laatste|vorige|afgelopen', 'value': -1 },
      { 'name': 'shift', 'src': 'volgend:|e', 'value': 1 }
    ],
    'parse': [
      '{months} {year?}',
      '{num} {unit} {sign}',
      '{0?} {unit:5-7} {shift}',
      '{0?} {shift} {unit:5-7}'
    ],
    'timeParse': [
      '{shift?} {day|weekday}',
      '{weekday?},? {date} {months?}\\.? {year?}'
    ],
    'timeFrontParse': [
      '{shift?} {day|weekday}',
      '{weekday?},? {date} {months?}\\.? {year?}'
    ]
  });


  /*
   * Norwegian locale definition.
   * See the readme for customization and more information.
   * To set this locale globally:
   *
   * Sugar.Date.setLocale('no')
   *
   */
  Sugar.Date.addLocale('no', {
    'plural': true,
    'units': 'millisekund:|er,sekund:|er,minutt:|er,tim:e|er,dag:|er,uk:e|er|en,måned:|er|en+maaned:|er|en,år:||et+aar:||et',
    'months': 'januar,februar,mars,april,mai,juni,juli,august,september,oktober,november,desember',
    'weekdays': 'søndag|sondag,mandag,tirsdag,onsdag,torsdag,fredag,lørdag|lordag',
    'numerals': 'en|et,to,tre,fire,fem,seks,sju|syv,åtte,ni,ti',
    'tokens': 'den,for',
    'articles': 'den',
    'short':'d. {d}. {month} {yyyy}',
    'long': 'den {d}. {month} {yyyy} {H}:{mm}',
    'full': '{Weekday} den {d}. {month} {yyyy} {H}:{mm}:{ss}',
    'past': '{num} {unit} {sign}',
    'future': '{sign} {num} {unit}',
    'duration': '{num} {unit}',
    'ampm': 'am,pm',
    'modifiers': [
      { 'name': 'day', 'src': 'forgårs|i forgårs|forgaars|i forgaars', 'value': -2 },
      { 'name': 'day', 'src': 'i går|igår|i gaar|igaar', 'value': -1 },
      { 'name': 'day', 'src': 'i dag|idag', 'value': 0 },
      { 'name': 'day', 'src': 'i morgen|imorgen', 'value': 1 },
      { 'name': 'day', 'src': 'overimorgen|overmorgen|over i morgen', 'value': 2 },
      { 'name': 'sign', 'src': 'siden', 'value': -1 },
      { 'name': 'sign', 'src': 'om', 'value':  1 },
      { 'name': 'shift', 'src': 'i siste|siste', 'value': -1 },
      { 'name': 'shift', 'src': 'denne', 'value': 0 },
      { 'name': 'shift', 'src': 'neste', 'value': 1 }
    ],
    'parse': [
      '{num} {unit} {sign}',
      '{sign} {num} {unit}',
      '{1?} {num} {unit} {sign}',
      '{shift} {unit:5-7}'
    ],
    'timeParse': [
      '{date} {month}',
      '{shift} {weekday}',
      '{0?} {weekday?},? {date?} {month}\\.? {year}'
    ]
  });


  /*
   * Polish locale definition.
   * See the readme for customization and more information.
   * To set this locale globally:
   *
   * Sugar.Date.setLocale('pl')
   *
   */
  Sugar.Date.addLocale('pl', {
    'plural': true,
    'units': 'milisekund:a|y|,sekund:a|y|,minut:a|y|,godzin:a|y|,dzień|dni|dni,tydzień|tygodnie|tygodni,miesiąc|miesiące|miesięcy,rok|lata|lat',
    'months': 'sty:cznia||czeń,lut:ego||y,mar:ca||zec,kwi:etnia||ecień,maj:a|,cze:rwca||rwiec,lip:ca||iec,sie:rpnia||rpień,wrz:eśnia||esień,paź:dziernika||dziernik,lis:topada||topad,gru:dnia||dzień',
    'weekdays': 'nie:dziela||dzielę,pon:iedziałek|,wt:orek|,śr:oda||odę,czw:artek|,piątek|pt,sobota|sb|sobotę',
    'numerals': 'zero,jeden|jedną,dwa|dwie,trzy,cztery,pięć,sześć,siedem,osiem,dziewięć,dziesięć',
    'tokens': 'w|we,roku',
    'short': '{dd}.{MM}.{yyyy}',
    'medium': '{d} {month} {yyyy}',
    'long':  '{d} {month} {yyyy} {time}',
    'full' : '{weekday}, {d} {month} {yyyy} {time}',
    'stamp': '{dow} {d} {mon} {yyyy} {time}',
    'time': '{H}:{mm}',
    'timeMarkers': 'o',
    'ampm': 'am,pm',
    'modifiers': [
      { 'name': 'day', 'src': 'przedwczoraj', 'value': -2 },
      { 'name': 'day', 'src': 'wczoraj', 'value': -1 },
      { 'name': 'day', 'src': 'dzisiaj|dziś', 'value': 0 },
      { 'name': 'day', 'src': 'jutro', 'value': 1 },
      { 'name': 'day', 'src': 'pojutrze', 'value': 2 },
      { 'name': 'sign', 'src': 'temu|przed', 'value': -1 },
      { 'name': 'sign', 'src': 'za', 'value': 1 },
      { 'name': 'shift', 'src': 'zeszły|zeszła|ostatni|ostatnia', 'value': -1 },
      { 'name': 'shift', 'src': 'następny|następna|następnego|przyszły|przyszła|przyszłego', 'value': 1 }
    ],
    'relative': function (num, unit, ms, format) {
      // special cases for relative days
      var DAY = 4;
      if (unit === DAY) {
        if (num === 1 && format === 'past')   return 'wczoraj';
        if (num === 1 && format === 'future') return 'jutro';
        if (num === 2 && format === 'past')   return 'przedwczoraj';
        if (num === 2 && format === 'future') return 'pojutrze';
      }

      var mult;
      var last  = +num.toFixed(0).slice(-1);
      var last2 = +num.toFixed(0).slice(-2);
      switch (true) {
        case num === 1:                  mult = 0; break;
        case last2 >= 12 && last2 <= 14: mult = 2; break;
        case last  >=  2 && last  <=  4: mult = 1; break;
        default:                         mult = 2;
      }
      var text = this['units'][(mult * 8) + unit];
      var prefix = num + ' ';

      // changing to accusative case for 'past' and 'future' formats
      // (only singular feminine unit words are different in accusative, each of which ends with 'a')
      if ((format === 'past' || format === 'future') && num === 1) {
        text = text.replace(/a$/, 'ę');
      }

      text = prefix + text;
      switch (format) {
        case 'duration': return text;
        case 'past':     return text + ' temu';
        case 'future':   return 'za ' + text;
      }
    },
    'parse': [
      '{num} {unit} {sign}',
      '{sign} {num} {unit}',
      '{months} {year?}',
      '{shift} {unit:5-7}',
      '{0} {shift?} {weekday}'
    ],
    'timeFrontParse': [
      '{day|weekday}',
      '{date} {months} {year?} {1?}',
      '{0?} {shift?} {weekday}'
    ]
  });


  /*
   * Portuguese locale definition.
   * See the readme for customization and more information.
   * To set this locale globally:
   *
   * Sugar.Date.setLocale('pt')
   *
   */
  Sugar.Date.addLocale('pt', {
    'plural': true,
    'units': 'milisegundo:|s,segundo:|s,minuto:|s,hora:|s,dia:|s,semana:|s,mês|mêses|mes|meses,ano:|s',
    'months': 'jan:eiro|,fev:ereiro|,mar:ço|,abr:il|,mai:o|,jun:ho|,jul:ho|,ago:sto|,set:embro|,out:ubro|,nov:embro|,dez:embro|',
    'weekdays': 'dom:ingo|,seg:unda-feira|,ter:ça-feira|,qua:rta-feira|,qui:nta-feira|,sex:ta-feira|,sáb:ado||ado',
    'numerals': 'zero,um:|a,dois|duas,três|tres,quatro,cinco,seis,sete,oito,nove,dez',
    'tokens': 'a,de',
    'short':  '{dd}/{MM}/{yyyy}',
    'medium': '{d} de {Month} de {yyyy}',
    'long':   '{d} de {Month} de {yyyy} {time}',
    'full':   '{Weekday}, {d} de {Month} de {yyyy} {time}',
    'stamp':  '{Dow} {d} {Mon} {yyyy} {time}',
    'time':   '{H}:{mm}',
    'past':   '{num} {unit} {sign}',
    'future': '{sign} {num} {unit}',
    'duration': '{num} {unit}',
    'timeMarkers': 'às',
    'ampm': 'am,pm',
    'modifiers': [
      { 'name': 'day', 'src': 'anteontem', 'value': -2 },
      { 'name': 'day', 'src': 'ontem', 'value': -1 },
      { 'name': 'day', 'src': 'hoje', 'value': 0 },
      { 'name': 'day', 'src': 'amanh:ã|a', 'value': 1 },
      { 'name': 'sign', 'src': 'atrás|atras|há|ha', 'value': -1 },
      { 'name': 'sign', 'src': 'daqui a', 'value': 1 },
      { 'name': 'shift', 'src': 'passad:o|a', 'value': -1 },
      { 'name': 'shift', 'src': 'próximo|próxima|proximo|proxima', 'value': 1 }
    ],
    'parse': [
      '{months} {1?} {year?}',
      '{num} {unit} {sign}',
      '{sign} {num} {unit}',
      '{0?} {unit:5-7} {shift}',
      '{0?} {shift} {unit:5-7}'
    ],
    'timeParse': [
      '{shift?} {day|weekday}',
      '{0?} {shift} {weekday}',
      '{date} {1?} {months?} {1?} {year?}'
    ],
    'timeFrontParse': [
      '{shift?} {day|weekday}',
      '{date} {1?} {months?} {1?} {year?}'
    ]
  });


  /*
   * Russian locale definition.
   * See the readme for customization and more information.
   * To set this locale globally:
   *
   * Sugar.Date.setLocale('ru')
   *
   */
  Sugar.Date.addLocale('ru', {
    'firstDayOfWeekYear': 1,
    'units': 'миллисекунд:а|у|ы|,секунд:а|у|ы|,минут:а|у|ы|,час:||а|ов,день|день|дня|дней,недел:я|ю|и|ь|е,месяц:||а|ев|е,год|год|года|лет|году',
    'months': 'янв:аря||.|арь,фев:раля||р.|раль,мар:та||т,апр:еля||.|ель,мая|май,июн:я||ь,июл:я||ь,авг:уста||.|уст,сен:тября||т.|тябрь,окт:ября||.|ябрь,ноя:бря||брь,дек:абря||.|абрь',
    'weekdays': 'воскресенье|вс,понедельник|пн,вторник|вт,среда|ср,четверг|чт,пятница|пт,суббота|сб',
    'numerals': 'ноль,од:ин|ну,дв:а|е,три,четыре,пять,шесть,семь,восемь,девять,десять',
    'tokens': 'в|на,г\\.?(?:ода)?',
    'short':  '{dd}.{MM}.{yyyy}',
    'medium': '{d} {month} {yyyy} г.',
    'long':   '{d} {month} {yyyy} г., {time}',
    'full':   '{weekday}, {d} {month} {yyyy} г., {time}',
    'stamp':  '{dow} {d} {mon} {yyyy} {time}',
    'time':   '{H}:{mm}',
    'timeMarkers': 'в',
    'ampm': ' утра, вечера',
    'modifiers': [
      { 'name': 'day', 'src': 'позавчера', 'value': -2 },
      { 'name': 'day', 'src': 'вчера', 'value': -1 },
      { 'name': 'day', 'src': 'сегодня', 'value': 0 },
      { 'name': 'day', 'src': 'завтра', 'value': 1 },
      { 'name': 'day', 'src': 'послезавтра', 'value': 2 },
      { 'name': 'sign', 'src': 'назад', 'value': -1 },
      { 'name': 'sign', 'src': 'через', 'value': 1 },
      { 'name': 'shift', 'src': 'прошл:ый|ой|ом', 'value': -1 },
      { 'name': 'shift', 'src': 'следующ:ий|ей|ем', 'value': 1 }
    ],
    'relative': function(num, unit, ms, format) {
      var numberWithUnit, last = num.toString().slice(-1), mult;
      switch(true) {
        case num >= 11 && num <= 15: mult = 3; break;
        case last == 1: mult = 1; break;
        case last >= 2 && last <= 4: mult = 2; break;
        default: mult = 3;
      }
      numberWithUnit = num + ' ' + this['units'][(mult * 8) + unit];
      switch(format) {
        case 'duration':  return numberWithUnit;
        case 'past':      return numberWithUnit + ' назад';
        case 'future':    return 'через ' + numberWithUnit;
      }
    },
    'parse': [
      '{num} {unit} {sign}',
      '{sign} {num} {unit}',
      '{months} {year?}',
      '{0?} {shift} {unit:5-7}'
    ],
    'timeParse': [
      '{day|weekday}',
      '{0?} {shift} {weekday}',
      '{date} {months?} {year?} {1?}'
    ],
    'timeFrontParse': [
      '{0?} {shift} {weekday}',
      '{date} {months?} {year?} {1?}'
    ]
  });


  /*
   * Swedish locale definition.
   * See the readme for customization and more information.
   * To set this locale globally:
   *
   * Sugar.Date.setLocale('sv')
   *
   */
  Sugar.Date.addLocale('sv', {
    'plural': true,
    'units': 'millisekund:|er,sekund:|er,minut:|er,timm:e|ar,dag:|ar,veck:a|or|an,månad:|er|en+manad:|er|en,år:||et+ar:||et',
    'months': 'jan:uari|,feb:ruari|,mar:s|,apr:il|,maj,jun:i|,jul:i|,aug:usti|,sep:tember|,okt:ober|,nov:ember|,dec:ember|',
    'weekdays': 'sön:dag|+son:dag|,mån:dag||dagen+man:dag||dagen,tis:dag|,ons:dag|,tor:sdag|,fre:dag|,lör:dag||dag',
    'numerals': 'noll,en|ett,två|tva,tre,fyra,fem,sex,sju,åtta|atta,nio,tio',
    'tokens': 'den,för|for',
    'articles': 'den',
    'short':  '{yyyy}-{MM}-{dd}',
    'medium': '{d} {month} {yyyy}',
    'long':   '{d} {month} {yyyy} {time}',
    'full':   '{weekday} {d} {month} {yyyy} {time}',
    'stamp':  '{dow} {d} {mon} {yyyy} {time}',
    'time':   '{H}:{mm}',
    'past':   '{num} {unit} {sign}',
    'future': '{sign} {num} {unit}',
    'duration': '{num} {unit}',
    'ampm': 'am,pm',
    'modifiers': [
      { 'name': 'day', 'src': 'förrgår|i förrgår|iförrgår|forrgar|i forrgar|iforrgar', 'value': -2 },
      { 'name': 'day', 'src': 'går|i går|igår|gar|i gar|igar', 'value': -1 },
      { 'name': 'day', 'src': 'dag|i dag|idag', 'value': 0 },
      { 'name': 'day', 'src': 'morgon|i morgon|imorgon', 'value': 1 },
      { 'name': 'day', 'src': 'över morgon|övermorgon|i över morgon|i övermorgon|iövermorgon|over morgon|overmorgon|i over morgon|i overmorgon|iovermorgon', 'value': 2 },
      { 'name': 'sign', 'src': 'sedan|sen', 'value': -1 },
      { 'name': 'sign', 'src': 'om', 'value':  1 },
      { 'name': 'shift', 'src': 'i förra|förra|i forra|forra', 'value': -1 },
      { 'name': 'shift', 'src': 'denna', 'value': 0 },
      { 'name': 'shift', 'src': 'nästa|nasta', 'value': 1 }
    ],
    'parse': [
      '{months} {year?}',
      '{num} {unit} {sign}',
      '{sign} {num} {unit}',
      '{1?} {num} {unit} {sign}',
      '{shift} {unit:5-7}'
    ],
    'timeParse': [
      '{day|weekday}',
      '{shift} {weekday}',
      '{0?} {weekday?},? {date} {months?}\\.? {year?}'
    ],
    'timeFrontParse': [
      '{day|weekday}',
      '{shift} {weekday}',
      '{0?} {weekday?},? {date} {months?}\\.? {year?}'
    ]
  });


  /*
   * Simplified Chinese locale definition.
   * See the readme for customization and more information.
   * To set this locale globally:
   *
   * Sugar.Date.setLocale('zh-CN')
   *
   */
  Sugar.Date.addLocale('zh-CN', {
    'ampmFront': true,
    'numeralUnits': true,
    'allowsFullWidth': true,
    'timeMarkerOptional': true,
    'units': '毫秒,秒钟,分钟,小时,天,个星期|周,个月,年',
    'weekdays': '星期日|日|周日|星期天,星期一|一|周一,星期二|二|周二,星期三|三|周三,星期四|四|周四,星期五|五|周五,星期六|六|周六',
    'numerals': '〇,一,二,三,四,五,六,七,八,九',
    'placeholders': '十,百,千,万',
    'short':  '{yyyy}-{MM}-{dd}',
    'medium': '{yyyy}年{M}月{d}日',
    'long':   '{yyyy}年{M}月{d}日{time}',
    'full':   '{yyyy}年{M}月{d}日{weekday}{time}',
    'stamp':  '{yyyy}年{M}月{d}日{H}:{mm}{dow}',
    'time':   '{tt}{h}点{mm}分',
    'past':   '{num}{unit}{sign}',
    'future': '{num}{unit}{sign}',
    'duration': '{num}{unit}',
    'timeSuffixes': ',秒,分钟?,点|时,日|号,,月,年',
    'ampm': '上午,下午',
    'modifiers': [
      { 'name': 'day', 'src': '大前天', 'value': -3 },
      { 'name': 'day', 'src': '前天', 'value': -2 },
      { 'name': 'day', 'src': '昨天', 'value': -1 },
      { 'name': 'day', 'src': '今天', 'value': 0 },
      { 'name': 'day', 'src': '明天', 'value': 1 },
      { 'name': 'day', 'src': '后天', 'value': 2 },
      { 'name': 'day', 'src': '大后天', 'value': 3 },
      { 'name': 'sign', 'src': '前', 'value': -1 },
      { 'name': 'sign', 'src': '后', 'value':  1 },
      { 'name': 'shift', 'src': '上|去', 'value': -1 },
      { 'name': 'shift', 'src': '这', 'value':  0 },
      { 'name': 'shift', 'src': '下|明', 'value':  1 }
    ],
    'parse': [
      '{num}{unit}{sign}',
      '{shift}{unit:5-7}',
      '{year?}{month}',
      '{year}'
    ],
    'timeParse': [
      '{day|weekday}',
      '{shift}{weekday}',
      '{year?}{month?}{date}'
    ]
  });


  /*
   * Traditional Chinese locale definition.
   * See the readme for customization and more information.
   * To set this locale globally:
   *
   * Sugar.Date.setLocale('zh-TW')
   *
   */
  Sugar.Date.addLocale('zh-TW', {
    'ampmFront': true,
    'numeralUnits': true,
    'allowsFullWidth': true,
    'timeMarkerOptional': true,
    'units': '毫秒,秒鐘,分鐘,小時,天,個星期|週,個月,年',
    'weekdays': '星期日|日|週日|星期天,星期一|一|週一,星期二|二|週二,星期三|三|週三,星期四|四|週四,星期五|五|週五,星期六|六|週六',
    'numerals': '〇,一,二,三,四,五,六,七,八,九',
    'placeholders': '十,百,千,万',
    'short':  '{yyyy}/{MM}/{dd}',
    'medium': '{yyyy}年{M}月{d}日',
    'long':   '{yyyy}年{M}月{d}日{time}',
    'full':   '{yyyy}年{M}月{d}日{weekday}{time}',
    'stamp':  '{yyyy}年{M}月{d}日{H}:{mm}{dow}',
    'time':   '{tt}{h}點{mm}分',
    'past':   '{num}{unit}{sign}',
    'future': '{num}{unit}{sign}',
    'duration': '{num}{unit}',
    'timeSuffixes': ',秒,分鐘?,點|時,日|號,,月,年',
    'ampm': '上午,下午',
    'modifiers': [
      { 'name': 'day', 'src': '大前天', 'value': -3 },
      { 'name': 'day', 'src': '前天', 'value': -2 },
      { 'name': 'day', 'src': '昨天', 'value': -1 },
      { 'name': 'day', 'src': '今天', 'value': 0 },
      { 'name': 'day', 'src': '明天', 'value': 1 },
      { 'name': 'day', 'src': '後天', 'value': 2 },
      { 'name': 'day', 'src': '大後天', 'value': 3 },
      { 'name': 'sign', 'src': '前', 'value': -1 },
      { 'name': 'sign', 'src': '後', 'value': 1 },
      { 'name': 'shift', 'src': '上|去', 'value': -1 },
      { 'name': 'shift', 'src': '這', 'value':  0 },
      { 'name': 'shift', 'src': '下|明', 'value':  1 }
    ],
    'parse': [
      '{num}{unit}{sign}',
      '{shift}{unit:5-7}',
      '{year?}{month}',
      '{year}'
    ],
    'timeParse': [
      '{day|weekday}',
      '{shift}{weekday}',
      '{year?}{month?}{date}'
    ]
  });


}).call(this);
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/es6/sugar',_ion_es6_sugar_);
    else
      _ion_es6_sugar_.call(this, module, exports, require);
  }
  else {
    _ion_es6_sugar_.call(this);
  }
}).call(this)
void (function(){var _ion_index_ = function(module,exports,require){'use strict';
var ion = module.exports;
var noop = function () {
};
require('./es6');
var valueTypes = {
        string: true,
        number: true,
        boolean: true
    }, isValueType = function (object) {
        return (!(object != null) || valueTypes[typeof object]) != null ? !(object != null) || valueTypes[typeof object] : false;
    }, primitive = {
        string: true,
        number: true,
        boolean: true,
        function: true
    }, isPrimitive = function (object) {
        return !(object != null) || primitive[typeof object] || false;
    }, normalizeProperty = function (property, name) {
        if (typeof property === 'function') {
            property = {
                writable: false,
                value: property
            };
        } else if (isPrimitive(property) || Array.isArray(property)) {
            property = { value: property };
        }
        if (!(property.get != null) && !(property.set != null) && !property.hasOwnProperty('value')) {
            property.value = void 0;
        }
        if (property.hasOwnProperty('value')) {
            property.writable = property.writable != null ? property.writable : true;
        }
        property.name = name;
        return property;
    }, normalizeProperties = function (properties) {
        if (properties == null)
            properties = {};
        for (var name in properties) {
            var property = properties[name];
            properties[name] = normalizeProperty(property, name);
        }
        return properties;
    }, variableArgConstructs = [
        function (type, a) {
            return new type();
        },
        function (type, a) {
            return new type(a[0]);
        },
        function (type, a) {
            return new type(a[0], a[1]);
        },
        function (type, a) {
            return new type(a[0], a[1], a[2]);
        },
        function (type, a) {
            return new type(a[0], a[1], a[2], a[3]);
        },
        function (type, a) {
            return new type(a[0], a[1], a[2], a[3], a[4]);
        },
        function (type, a) {
            return new type(a[0], a[1], a[2], a[3], a[4], a[5]);
        },
        function (type, a) {
            return new type(a[0], a[1], a[2], a[3], a[4], a[5], a[6]);
        },
        function (type, a) {
            return new type(a[0], a[1], a[2], a[3], a[4], a[5], a[6], a[7]);
        },
        function (type, a) {
            return new type(a[0], a[1], a[2], a[3], a[4], a[5], a[6], a[7], a[8]);
        },
        function (type, a) {
            return new type(a[0], a[1], a[2], a[3], a[4], a[5], a[6], a[7], a[8], a[9]);
        }
    ], observeShim = require('./es6/Object.observe'), isObjectObservable = function () {
        var Node = global.Node != null ? global.Node : function () {
            };
        var NodeList = global.NodeList != null ? global.NodeList : function () {
            };
        var Location = global.Location != null ? global.Location : function () {
            };
        return function (a) {
            if (a instanceof Node || a instanceof NodeList || a instanceof Location) {
                return false;
            }
            return true;
        };
    }();
var freeze = exports.freeze = function (object, deep) {
        if (deep == null)
            deep = true;
        if (Object.isFrozen(object)) {
            return object;
        }
        Object.freeze(object);
        if (deep) {
            for (var key in object) {
                var value = object[key];
                if (value != null && typeof value === 'object') {
                    freeze(value, deep);
                }
            }
        }
        return object;
    }, createSortFunction = exports.createSortFunction = function (sorts) {
        if (!Array.isArray(sorts)) {
            sorts = [sorts];
        }
        return function (a, b) {
            if (a === b) {
                return 0;
            }
            if (!(a != null)) {
                return +1;
            }
            if (!(b != null)) {
                return -1;
            }
            for (var _i = 0; _i < sorts.length; _i++) {
                var sort = sorts[_i];
                for (var name in sort) {
                    var ascending = sort[name];
                    var aValue = a[name] != null ? a[name] : null;
                    var bValue = b[name] != null ? b[name] : null;
                    if (aValue === bValue) {
                        continue;
                    }
                    if (aValue != null && !(bValue != null)) {
                        return -1;
                    }
                    if (!(aValue != null) && bValue != null) {
                        return +1;
                    }
                    if (aValue > bValue) {
                        return ascending ? +1 : -1;
                    }
                    if (aValue < bValue) {
                        return ascending ? -1 : +1;
                    }
                }
            }
            return 0;
        };
    }, runFile = exports.runFile = function (file) {
        return require('./builder').runFile(file);
    }, patch = exports.patch = function () {
        var mergePatch = require('./mergePatch');
        var patchFunction = function (object, patch, schema) {
            return mergePatch.merge(object, patch, null, schema);
        };
        for (var key in mergePatch) {
            var value = mergePatch[key];
            patchFunction[key] = value;
        }
        return patchFunction;
    }(), create = exports.create = function (type, args) {
        return variableArgConstructs[args.length](type, args);
    }, setImmediate = exports.setImmediate = function (callback) {
        if (global.setImmediate != null) {
            var id = global.setImmediate(callback);
            return function () {
                return global.clearImmediate(id);
            };
        } else {
            var id = setTimeout(callback, 50);
            return function () {
                return clearTimeout(id);
            };
        }
    }, requestAnimationFrame = exports.requestAnimationFrame = function (callback) {
        if (global.requestAnimationFrame != null) {
            return global.requestAnimationFrame(callback);
        } else if ((global != null ? global.nextTick : void 0) != null) {
            global.process.nextTick(callback);
        } else {
            setImmediate(callback);
        }
    }, throttleAnimation = exports.throttleAnimation = function (callback) {
        var awaitingCallbackArgs = null;
        var animationFrameCallback = function () {
            callback.apply(null, awaitingCallbackArgs);
            awaitingCallbackArgs = null;
        };
        return function () {
            if (!(awaitingCallbackArgs != null)) {
                requestAnimationFrame(animationFrameCallback);
            }
            awaitingCallbackArgs = Array.prototype.slice.call(arguments, 0);
        };
    }, template = exports.template = function (fn, template) {
        fn.template = template != null ? template : true;
        return fn;
    }, createRuntime = exports.createRuntime = function (ast, args, parent) {
        var Context = require('./runtime/Context');
        var context = new Context(parent);
        if (args != null) {
            for (var name in args) {
                var value = args[name];
                context.setVariableLiteral(name, value);
            }
        }
        return context.createRuntime(ast);
    }, clone = exports.clone = function (object, _deep, depth) {
        if (_deep == null)
            _deep = false;
        if (depth == null)
            depth = 0;
        if (object === null || typeof object !== 'object') {
            return object;
        }
        if (depth >= 50) {
            console.log('this is too deep, debug it');
            debugger;
        }
        var copy = Array.isArray(object) ? [] : {};
        if (_deep) {
            for (var k in object) {
                var v = object[k];
                copy[k] = clone(v, true, depth + 1);
            }
        } else {
            for (var k in object) {
                var v = object[k];
                copy[k] = v;
            }
        }
        return copy;
    }, observe = exports.observe = function (object, observer, options) {
        if (object === global || object === console || isValueType(object)) {
            return noop;
        }
        var property = options != null ? options.property : void 0;
        var priority = options != null ? options.priority : void 0;
        var removed = false;
        var observable = isObjectObservable(object);
        if (!observable) {
            if (!(property != null)) {
                return noop;
            }
            observeShim.observe(object, observer, property, priority);
        } else if (object != null && observer != null && typeof object === 'object') {
            observeShim.observe(object, observer, null, priority);
            object.addEventListener != null ? object.addEventListener('change', observer) : void 0;
        }
        object != null ? object.onObserved != null ? object.onObserved(observer, property) : void 0 : void 0;
        observe.count = (observe.count != null ? observe.count : 0) + 1;
        return function () {
            if (!removed) {
                observe.count--;
                removed = true;
                if (!observable) {
                    observeShim.unobserve(object, observer, property);
                } else if (object != null && observer != null && typeof object === 'object') {
                    observeShim.unobserve(object, observer, property);
                    object.removeEventListener != null ? object.removeEventListener('change', observer) : void 0;
                }
                object != null ? object.unObserved != null ? object.unObserved(observer, property) : void 0 : void 0;
            } else {
                console.warn('unobserve should not be called multiple times!');
            }
        };
    }, checkForChanges = exports.checkForChanges = observeShim.checkForChanges, sync = exports.sync = observeShim.checkForChanges, nextCheck = exports.nextCheck = function (callback) {
        observeShim.nextCheck(callback);
    }, bind = exports.bind = function (fn, thisArg) {
        var newFn = fn.bind(thisArg);
        if ((fn.name != null ? fn.name.length : void 0) > 0) {
            newFn.id = fn.id != null ? fn.id : fn.name;
        }
        return newFn;
    }, add = exports.add = function (container, item, sourceNode) {
        var originalItem = item;
        var remove;
        if (typeof item === 'function' && ((item.name != null ? item.name.length : void 0) > 0 || item.id != null) && typeof container.addEventListener === 'function') {
            var name = item.id != null ? item.id : item.name;
            var capture = false;
            var captureSuffix = '_capture';
            if (name.endsWith(captureSuffix)) {
                capture = true;
                name = name.substring(0, name.length - captureSuffix.length);
            }
            item = function () {
                originalItem.apply(this, arguments);
                sync(name);
            };
            container.addEventListener(name, item, capture);
            remove = function () {
                container.removeEventListener(name, item);
            };
        } else {
            if (container.nodeType === 1) {
                if (typeof item !== 'string' && !((item != null ? item.nodeType : void 0) != null)) {
                    item = JSON.stringify(item);
                }
                if (typeof item === 'string') {
                    item = document.createTextNode(item);
                }
                container.appendChild(item);
            } else if (container.push != null) {
                container.push(item);
            } else {
                container.add(item);
            }
            remove = function () {
                if ((item != null ? item.removeSelf : void 0) != null) {
                    item.removeSelf();
                } else if ((item != null ? item.parentNode : void 0) != null) {
                    item.parentNode.removeChild(item);
                } else if (container.lastIndexOf != null && container.removeAt != null) {
                    var index = container.lastIndexOf(item);
                    if (index >= 0) {
                        container.removeAt(index);
                    }
                } else if (typeof container.remove === 'function') {
                    container.remove(item);
                } else if (Array.isArray(container)) {
                    var index = container.lastIndexOf(item);
                    if (index >= 0) {
                        container.splice(index, 1);
                    }
                }
            };
        }
        item != null ? item.onAdded != null ? item.onAdded(container) : void 0 : void 0;
        return function () {
            remove();
            item != null ? item.onRemoved != null ? item.onRemoved(container) : void 0 : void 0;
        };
    }, defineProperties = exports.defineProperties = function (object, properties) {
        return Object.defineProperties(object, normalizeProperties(properties));
    }, defineClass = exports.defineClass = function (___definitions) {
        var definitions = Array.prototype.slice.call(arguments, 0);
        var classDefinition = definitions[0];
        if (definitions[1] === void 0) {
            definitions[1] = require('./Object');
        }
        classDefinition.super = definitions[1];
        var name = classDefinition.name != null ? classDefinition.name : classDefinition.id != null ? classDefinition.id.match(/([a-z_0-9\$]+)(\.js)?$/i) != null ? classDefinition.id.match(/([a-z_0-9\$]+)(\.js)?$/i)[1] : void 0 : void 0;
        if (!(name != null)) {
            throw new Error('missing name property');
        }
        var classFunction;
        if (classDefinition.hasOwnProperty('constructor')) {
            classFunction = classDefinition.constructor;
        } else if (classDefinition.super != null) {
            classFunction = eval('(function ' + name + '() { ' + name + '.super.apply(this, arguments); })');
        } else {
            classFunction = eval('(function ' + name + '() {})');
        }
        var canSetClassProperty = function (key) {
            if (key === 'name') {
                return false;
            }
            var descriptor = Object.getOwnPropertyDescriptor(classFunction, key);
            return !(descriptor != null) || descriptor.writable || !(descriptor.get != null);
        };
        var types = new Set();
        types.add(classFunction);
        for (var i = definitions.length - 1; i >= 0; i--) {
            var definition = definitions[i];
            if (definition != null) {
                types.add(definition);
                for (var key in definition) {
                    var value = definition[key];
                    if (key !== 'test' || i === 0) {
                        if (canSetClassProperty(key)) {
                            classFunction[key] = patch(classFunction[key], value);
                        }
                    }
                }
            }
        }
        classFunction.types = types;
        if (classFunction.properties != null) {
            defineProperties(classFunction.prototype, classFunction.properties);
        }
        return classFunction;
    }, is = exports.is = function (instance, type) {
        if (!(instance != null)) {
            return false;
        }
        if (!(type != null)) {
            return true;
        }
        if (typeof type === 'function') {
            if (typeof instance.is === 'function') {
                return instance.is(type);
            }
            return instance instanceof type;
        } else {
            return instance === type;
        }
    }, makeReactive = exports.makeReactive = function (object, activate) {
        var observeCount = 0;
        var deactivate = null;
        return Object.defineProperties(object, {
            onObserved: {
                value: function () {
                    observeCount++;
                    if (observeCount === 1) {
                        deactivate = activate.call(object);
                    }
                }
            },
            unObserved: {
                value: function () {
                    observeCount--;
                    if (observeCount === 0) {
                        deactivate != null ? deactivate() : void 0;
                    }
                }
            }
        });
    }, serialize = exports.serialize = function (object) {
        return JSON.stringify(object);
    }, typeKey = exports.typeKey = '$', deserialize = exports.deserialize = function () {
        var extractType = function (object, namespace) {
            if (!(object != null)) {
                return null;
            }
            var typeName = object[typeKey];
            if (!(typeName != null)) {
                return null;
            }
            typeName = typeName.split(/\//g).pop();
            var type = namespace[typeName];
            if (!(type != null)) {
                throw new Error('Type not found: ' + typeName);
            }
            if (!type.serializable) {
                throw new Error('Type is not serializable: ' + typeName);
            }
            return type;
        };
        var convertType = function (object, namespace) {
            var type = extractType(object, namespace);
            if (type != null) {
                var values = object;
                object = new type();
                for (var k in values) {
                    var v = values[k];
                    var property = type.properties != null ? type.properties[k] : void 0;
                    if (!((property != null ? property.get : void 0) != null) || (property != null ? property.set : void 0) != null) {
                        object[k] = v;
                    }
                }
            }
            for (var key in object) {
                var value = object[key];
                if ((value != null ? value.constructor : void 0) === Object) {
                    object[key] = convertType(value, namespace);
                }
            }
            return object;
        };
        var deserialize = function (object, namespace) {
            if (typeof object === 'string') {
                object = JSON.parse(object);
            }
            return convertType(object, namespace);
        };
        deserialize.extractType = extractType;
        deserialize.convertType = convertType;
        return deserialize;
    }(), reactive = exports.reactive = function (fn) {
        var state = {};
        var patchResult = function (intermediateResult) {
            var diff = ion.patch.diff(state.result, intermediateResult);
            if (diff !== void 0) {
                state.result = ion.patch(state.result, diff);
            }
        };
        return ion.template(function (arg) {
            return ion.createRuntime({
                type: 'Template',
                id: null,
                body: [
                    {
                        type: 'VariableDeclaration',
                        declarations: [{
                                type: 'VariableDeclarator',
                                id: {
                                    type: 'Identifier',
                                    name: 'intermediateResult',
                                    loc: {
                                        start: {
                                            line: 372,
                                            column: 16,
                                            fixed: true,
                                            source: 'ion/index.ion'
                                        },
                                        end: {
                                            line: 372,
                                            column: 34,
                                            fixed: true,
                                            source: 'ion/index.ion'
                                        }
                                    }
                                },
                                init: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'Identifier',
                                        name: 'fn',
                                        loc: {
                                            start: {
                                                line: 372,
                                                column: 37,
                                                fixed: true,
                                                source: 'ion/index.ion'
                                            },
                                            end: {
                                                line: 372,
                                                column: 39,
                                                fixed: true,
                                                source: 'ion/index.ion'
                                            }
                                        }
                                    },
                                    arguments: [{
                                            type: 'Identifier',
                                            name: 'arg',
                                            loc: {
                                                start: {
                                                    line: 372,
                                                    column: 45,
                                                    fixed: true,
                                                    source: 'ion/index.ion'
                                                },
                                                end: {
                                                    line: 372,
                                                    column: 48,
                                                    fixed: true,
                                                    source: 'ion/index.ion'
                                                }
                                            },
                                            deep: true
                                        }],
                                    loc: {
                                        start: {
                                            line: 372,
                                            column: 37,
                                            fixed: true,
                                            source: 'ion/index.ion'
                                        },
                                        end: {
                                            line: 372,
                                            column: 49,
                                            fixed: true,
                                            source: 'ion/index.ion'
                                        }
                                    }
                                }
                            }],
                        kind: 'let',
                        order: '0'
                    },
                    {
                        type: 'ExpressionStatement',
                        expression: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'patchResult',
                                loc: {
                                    start: {
                                        line: 373,
                                        column: 12,
                                        fixed: true,
                                        source: 'ion/index.ion'
                                    },
                                    end: {
                                        line: 373,
                                        column: 23,
                                        fixed: true,
                                        source: 'ion/index.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'Identifier',
                                    name: 'intermediateResult',
                                    loc: {
                                        start: {
                                            line: 373,
                                            column: 29,
                                            fixed: true,
                                            source: 'ion/index.ion'
                                        },
                                        end: {
                                            line: 373,
                                            column: 47,
                                            fixed: true,
                                            source: 'ion/index.ion'
                                        }
                                    },
                                    deep: true
                                }],
                            loc: {
                                start: {
                                    line: 373,
                                    column: 12,
                                    fixed: true,
                                    source: 'ion/index.ion'
                                },
                                end: {
                                    line: 373,
                                    column: 48,
                                    fixed: true,
                                    source: 'ion/index.ion'
                                }
                            }
                        },
                        loc: {
                            start: {
                                line: 373,
                                column: 12,
                                fixed: true,
                                source: 'ion/index.ion'
                            },
                            end: {
                                line: 373,
                                column: 48,
                                fixed: true,
                                source: 'ion/index.ion'
                            }
                        },
                        order: '1'
                    },
                    {
                        type: 'ReturnStatement',
                        argument: {
                            type: 'MemberExpression',
                            computed: false,
                            object: {
                                type: 'Identifier',
                                name: 'state',
                                loc: {
                                    start: {
                                        line: 374,
                                        column: 19,
                                        fixed: true,
                                        source: 'ion/index.ion'
                                    },
                                    end: {
                                        line: 374,
                                        column: 24,
                                        fixed: true,
                                        source: 'ion/index.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'result',
                                loc: {
                                    start: {
                                        line: 374,
                                        column: 25,
                                        fixed: true,
                                        source: 'ion/index.ion'
                                    },
                                    end: {
                                        line: 374,
                                        column: 31,
                                        fixed: true,
                                        source: 'ion/index.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 374,
                                    column: 19,
                                    fixed: true,
                                    source: 'ion/index.ion'
                                },
                                end: {
                                    line: 374,
                                    column: 31,
                                    fixed: true,
                                    source: 'ion/index.ion'
                                }
                            }
                        },
                        order: '2'
                    }
                ],
                bound: false
            }, {
                this: this,
                arg: arg,
                state: state,
                patchResult: patchResult,
                fn: fn,
                ion: ion,
                noop: noop,
                valueTypes: valueTypes,
                isValueType: isValueType,
                primitive: primitive,
                isPrimitive: isPrimitive,
                normalizeProperty: normalizeProperty,
                normalizeProperties: normalizeProperties,
                variableArgConstructs: variableArgConstructs,
                observeShim: observeShim,
                isObjectObservable: isObjectObservable,
                freeze: freeze,
                createSortFunction: createSortFunction,
                runFile: runFile,
                patch: patch,
                create: create,
                setImmediate: setImmediate,
                requestAnimationFrame: requestAnimationFrame,
                throttleAnimation: throttleAnimation,
                template: template,
                createRuntime: createRuntime,
                clone: clone,
                observe: observe,
                checkForChanges: checkForChanges,
                sync: sync,
                nextCheck: nextCheck,
                bind: bind,
                add: add,
                defineProperties: defineProperties,
                defineClass: defineClass,
                is: is,
                makeReactive: makeReactive,
                serialize: serialize,
                typeKey: typeKey,
                deserialize: deserialize,
                reactive: reactive,
                test: test
            }, null);
        });
    }, test = exports.test = {
        defineClass: function () {
            var Foo = defineClass({
                    id: 'Foo',
                    constructor: function (number) {
                        this.number = number;
                    },
                    properties: {
                        getValue: function () {
                            return this.number;
                        }
                    }
                });
            if (!(new Foo(2).getValue() === 2))
                throw new Error('Assertion Failed: (new Foo(2).getValue() is 2)');
        },
        sortFunction: function () {
            var records = [
                    {
                        name: 'a',
                        order: 1
                    },
                    {
                        name: 'b',
                        order: 2
                    },
                    {
                        name: 'q',
                        order: null
                    },
                    {
                        name: 'd',
                        order: 4
                    },
                    {
                        name: 'c',
                        order: void 0
                    }
                ];
            records.sort(ion.createSortFunction([{ order: true }]));
            if (!(records.map(function (x) {
                    return x.name;
                }).join('') === 'abdqc'))
                throw new Error('Assertion Failed: (records.map((x) -> x.name).join(\'\') is \'abdqc\')');
            records = [
                {
                    name: 'a',
                    order: 1
                },
                {
                    name: 'b',
                    order: 2
                },
                {
                    name: 'q',
                    order: null
                },
                {
                    name: 'd',
                    order: 4
                },
                {
                    name: 'c',
                    order: void 0
                }
            ];
            records.sort(ion.createSortFunction([{ order: false }]));
            if (!(records.map(function (x) {
                    return x.name;
                }).join('') === 'dbaqc'))
                throw new Error('Assertion Failed: (records.map((x) -> x.name).join(\'\') is \'dbaqc\')');
        },
        defineProperties: {
            'should allow primitive values': function () {
                var object = {};
                var result = defineProperties(object, {
                        f: function () {
                            return 'function';
                        },
                        i: 2,
                        b: true,
                        a: [],
                        s: 'hello'
                    });
                if (!(object === result))
                    throw new Error('Assertion Failed: (object is result)');
                if (!(typeof object.f === 'function'))
                    throw new Error('Assertion Failed: (typeof object.f is \'function\')');
                if (!(object.f() === 'function'))
                    throw new Error('Assertion Failed: (object.f() is \'function\')');
                if (!(object.i === 2))
                    throw new Error('Assertion Failed: (object.i is 2)');
                if (!(object.b === true))
                    throw new Error('Assertion Failed: (object.b is true)');
                if (!Array.isArray(object.a))
                    throw new Error('Assertion Failed: (Array.isArray(object.a))');
                if (!(object.s === 'hello'))
                    throw new Error('Assertion Failed: (object.s is \'hello\')');
            }
        }
    };
{
    var _ref = [
            'runtime',
            'compiler',
            'builder',
            'browser'
        ];
    for (var _i2 = 0; _i2 < _ref.length; _i2++) {
        var name = _ref[_i2];
        (function (name) {
            Object.defineProperty(exports, name, {
                enumerable: true,
                get: function () {
                    return require('./' + name);
                }
            });
        }(name));
    }
}
if (global.window != null) {
    global.window.addEventListener('resize', sync);
}
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/index',_ion_index_);
    else
      _ion_index_.call(this, module, exports, require);
  }
  else {
    _ion_index_.call(this);
  }
}).call(this)
void (function(){var _ion_mergePatch_ = function(module,exports,require){'use strict';
var ion = require('./'), isObject = function (a) {
        var type = typeof a;
        return a != null && type === 'object' || type === 'function';
    }, deleteValue = null, isPrivate = function (name) {
        return name[0] === '_';
    }, watchImmediate = function (object, handler, edge) {
        if (!isObject(object)) {
            throw new Error('Cannot watch: #{object}');
        }
        var watching = true;
        var propertyWatchers = {};
        var watchProperties = function (changes) {
            var properties = Object.keys(changes != null ? changes : object);
            for (var _i = 0; _i < properties.length; _i++) {
                var name = properties[_i];
                (function (name) {
                    if (watching) {
                        propertyWatchers[name] != null ? propertyWatchers[name]() : void 0;
                        delete propertyWatchers[name];
                        var value = object[name];
                        if (isObject(value)) {
                            propertyWatchers[name] = watchInternal(value, function (patch) {
                                if (watching) {
                                    var _ref = {};
                                    _ref[name] = patch;
                                    handler(_ref);
                                }
                            }, edge);
                        }
                    }
                }(name));
            }
        };
        watchProperties(null);
        var unobserve = ion.observe(object, function (changes) {
                if (watching) {
                    var patch = null;
                    var changedProperties = {};
                    for (var _i2 = 0; _i2 < changes.length; _i2++) {
                        var _ref2 = changes[_i2];
                        var name = _ref2.name;
                        var oldValue = _ref2.oldValue;
                        changedProperties[name] = true;
                        if (!isPrivate(name)) {
                            patch = patch != null ? patch : {};
                            var newValue = object[name];
                            var newDiff = diff(oldValue, newValue);
                            if (newDiff !== void 0) {
                                patch[name] = newDiff;
                            }
                        }
                    }
                    watchProperties(changedProperties);
                    if (patch != null) {
                        handler(patch);
                    }
                }
            }, null, edge);
        return function () {
            watching = false;
            for (var key in propertyWatchers) {
                var unwatch = propertyWatchers[key];
                unwatch();
            }
            unobserve();
            unobserve = null;
        };
    }, increment = /[+-]\d+/, watchInternal = function (object, handler, edge) {
        global.watchInternalCount = global.watchInternalCount != null ? global.watchInternalCount : 0;
        global.watchInternalCount++;
        var active = false;
        var combinedPatch = void 0;
        var finalCallback = function () {
            handler(combinedPatch);
            active = false;
            combinedPatch = void 0;
        };
        var delayedHandler = function (patch) {
            combinedPatch = combine(combinedPatch, patch);
            if (!active) {
                ion.nextCheck(finalCallback);
                active = true;
            }
        };
        var unwatch = watchImmediate(object, delayedHandler, edge);
        return function () {
            unwatch();
            global.watchInternalCount--;
        };
    };
var canSetProperty = exports.canSetProperty = function (object, key) {
        return !(typeof object === 'function' && key === 'name');
    }, merge = exports.merge = function (_target, _values, options, schema) {
        var values = _values;
        var target = _target;
        var deleteNull = (options != null ? options.deleteNull : void 0) != null ? options.deleteNull : true;
        var _delete = (options != null ? options.delete : void 0) != null ? options.delete : true;
        if ((schema != null ? schema.type : void 0) === 'integer' && increment.test(values)) {
            if (!deleteNull || typeof target === 'string' && increment.test(target)) {
                var total = parseInt(target != null ? target : 0) + parseInt(values.substring(1));
                values = '' + (total > 0 ? '+' : '-') + Math.abs(total);
            } else {
                values = (typeof target === 'number' ? target : 0) + parseInt(values.substring(1));
            }
        }
        if (Array.isArray(target) && (values != null ? values.length : void 0) === null) {
            target = {};
            values = ion.clone(values, false);
            delete values.length;
        }
        if ((values != null ? values.constructor : void 0) !== Object) {
            if (Array.isArray(values)) {
                return values.slice(0);
            } else {
                return values;
            }
        }
        if (!isObject(target)) {
            if ((options != null ? options.factory : void 0) != null) {
                target = options.factory(values);
            } else {
                target = {};
            }
        }
        var deletedValues = false;
        for (var key in values) {
            var value = values[key];
            if (deleteNull && value === deleteValue) {
                deletedValues = true;
                if (_delete) {
                    delete target[key];
                } else {
                    target[key] = void 0;
                }
            } else {
                var itemSchema = (schema != null ? schema.items : void 0) != null ? schema.items : schema != null ? schema.properties != null ? schema.properties[key] : void 0 : void 0;
                var newValue = merge(target[key], value, options, itemSchema);
                if (canSetProperty(target, key)) {
                    target[key] = newValue;
                }
            }
        }
        if (deletedValues && Array.isArray(target)) {
            for (var i = target.length; i > 0; i--) {
                if (!(target[i - 1] != null)) {
                    target.length = i - 1;
                }
            }
        }
        return target;
    }, patchNoDelete = exports.patchNoDelete = function (object, patch) {
        return merge(object, patch, { delete: false });
    }, combine = exports.combine = function (patch1, patch2, schema) {
        return merge(patch1, patch2, { deleteNull: false }, schema);
    }, watch = exports.watch = function (object, handler, edge) {
        global.watchCount = global.watchCount != null ? global.watchCount : 0;
        global.watchCount++;
        var unwatch = watchInternal(object, handler, edge);
        return function () {
            unwatch();
            global.watchCount--;
        };
    }, diff = exports.diff = function (oldValue, newValue) {
        if (oldValue === newValue) {
            return void 0;
        }
        if (!(oldValue != null && newValue != null && typeof newValue === 'object' && typeof oldValue === 'object')) {
            return newValue != null ? newValue : null;
        }
        if (!Array.isArray(oldValue) && Array.isArray(newValue)) {
            return newValue;
        }
        if (Array.isArray(oldValue) && !Array.isArray(newValue)) {
            return ion.patch.combine(JSON.parse(JSON.stringify(newValue)), { length: null });
        }
        var patch = void 0;
        for (var name in oldValue) {
            if (oldValue.hasOwnProperty(name)) {
                if (!newValue.hasOwnProperty(name)) {
                    patch = patch != null ? patch : {};
                    patch[name] = null;
                } else {
                    var propertyDiff = diff(oldValue[name], newValue[name]);
                    if (propertyDiff !== void 0) {
                        patch = patch != null ? patch : {};
                        patch[name] = propertyDiff;
                    }
                }
            }
        }
        for (var name in newValue) {
            if (newValue.hasOwnProperty(name) && !oldValue.hasOwnProperty(name)) {
                patch = patch != null ? patch : {};
                patch[name] = newValue[name];
            }
        }
        if (Array.isArray(oldValue) && Array.isArray(newValue) && newValue.length < oldValue.length) {
            patch.length = newValue.length;
            for (var i = newValue.length; i < oldValue.length; i++) {
                delete patch[i];
            }
        }
        return patch;
    }, isChange = exports.isChange = function (oldValue, newValue) {
        if (oldValue === newValue) {
            return false;
        }
        if (!(oldValue != null && newValue != null && typeof newValue === 'object' && typeof oldValue === 'object')) {
            return true;
        }
        if (Array.isArray(newValue) && JSON.stringify(oldValue) !== JSON.stringify(newValue)) {
            return true;
        }
        for (var name in newValue) {
            if (!oldValue.hasOwnProperty(name)) {
                if (!(newValue[name] != null)) {
                    continue;
                } else {
                    return true;
                }
            }
            if (isChange(oldValue[name], newValue[name])) {
                return true;
            }
        }
        return false;
    }, test = exports.test = function () {
        var equal = function (a, b) {
            return JSON.stringify(a) === JSON.stringify(b);
        };
        return {
            merge: function () {
                if (!equal({
                        a: {
                            b: 2,
                            c: 3
                        },
                        d: 4
                    }, merge({ a: { b: 2 } }, {
                        a: { c: 3 },
                        d: 4
                    })))
                    throw new Error('Assertion Failed: (equal({a:{b:2,c:3},d:4}, merge({a:{b:2}}, {a:{c:3},d:4})))');
                if (!equal({ b: 2 }, merge(null, { b: 2 })))
                    throw new Error('Assertion Failed: (equal({b:2}, merge(null, {b:2})))');
                if (!equal({
                        a: 1,
                        b: 2
                    }, merge({
                        a: 1,
                        b: 2,
                        c: 3
                    }, { c: void 0 })))
                    throw new Error('Assertion Failed: (equal({a:1,b:2}, merge({a:1,b:2,c:3}, {c:undefined})))');
                var double = function (x) {
                    return x * 2;
                };
                if (!equal({ a: double }, merge({}, { a: double })))
                    throw new Error('Assertion Failed: (equal({a:double}, merge({},{a:double})))');
                if (!equal({ a: [] }, merge({
                        a: [
                            1,
                            2
                        ]
                    }, { a: [] })))
                    throw new Error('Assertion Failed: (equal({a:[]}, merge({a:[1,2]}, {a:[]})))');
                if (!('+2' === merge('+1', '+1', null, { type: 'integer' })))
                    throw new Error('Assertion Failed: ("+2" is merge("+1", "+1", null, {type:\'integer\'}))');
                if (!equal([1], merge([
                        1,
                        2
                    ], { 1: null })))
                    throw new Error('Assertion Failed: (equal([1], merge([1,2], {1:null})))');
                if (!(merge([
                        1,
                        2
                    ], { 1: null }).length === 1))
                    throw new Error('Assertion Failed: (merge([1,2], {1:null}).length is 1)');
                if (!(merge({
                        foo: [
                            1,
                            2
                        ]
                    }, { foo: { 1: null } }).foo.length === 1))
                    throw new Error('Assertion Failed: (merge({foo:[1,2]}, {foo:{1:null}}).foo.length is 1)');
                if (!equal([
                        1,
                        void 0
                    ], merge([
                        1,
                        2
                    ], { 1: void 0 })))
                    throw new Error('Assertion Failed: (equal([1, undefined], merge([1,2], {1:undefined})))');
            },
            isChange: function () {
                if (!isChange({ a: 1 }, null))
                    throw new Error('Assertion Failed: (isChange({a:1}, null))');
                if (!!isChange(null, null))
                    throw new Error('Assertion Failed: (not isChange(null, null))');
                if (!isChange(void 0, null))
                    throw new Error('Assertion Failed: (isChange(undefined, null))');
                if (!isChange(null, void 0))
                    throw new Error('Assertion Failed: (isChange(null, undefined))');
                if (!!isChange({ a: 1 }, { a: 1 }))
                    throw new Error('Assertion Failed: (not isChange({a:1}, {a:1}))');
                if (!!isChange({
                        a: {
                            b: 2,
                            c: 3
                        }
                    }, { a: { b: 2 } }))
                    throw new Error('Assertion Failed: (not isChange({a:{b:2,c:3}}, {a:{b:2}}))');
                if (!isChange({ a: { b: 2 } }, { a: { b: 3 } }))
                    throw new Error('Assertion Failed: (isChange({a:{b:2}}, {a:{b:3}}))');
                if (!!isChange({ a: 1 }, { b: null }))
                    throw new Error('Assertion Failed: (not isChange({a:1}, {b:null}))');
                if (!isChange({
                        a: [
                            1,
                            2
                        ]
                    }, { a: [] }))
                    throw new Error('Assertion Failed: (isChange({a:[1,2]}, {a:[]}))');
            },
            diff: function () {
                if (!equal({ b: 2 }, diff({ a: 1 }, {
                        a: 1,
                        b: 2
                    })))
                    throw new Error('Assertion Failed: (equal({b:2}, diff({a:1}, {a:1,b:2})))');
                if (!equal({
                        a: {
                            b: 3,
                            c: null
                        }
                    }, diff({
                        a: {
                            b: 2,
                            c: 4
                        }
                    }, { a: { b: 3 } })))
                    throw new Error('Assertion Failed: (equal({a:{b:3,c:null}}, diff({a:{b:2,c:4}}, {a:{b:3}})))');
                if (!equal({ a: 1 }, diff(null, { a: 1 })))
                    throw new Error('Assertion Failed: (equal({a:1}, diff(null, {a:1})))');
                if (!equal({ c: { d: { f: 4 } } }, diff({
                        a: 1,
                        b: 2,
                        c: {
                            d: {
                                e: 1,
                                f: 2
                            }
                        }
                    }, {
                        a: 1,
                        b: 2,
                        c: {
                            d: {
                                e: 1,
                                f: 4
                            }
                        }
                    })))
                    throw new Error('Assertion Failed: (equal({c:{d:{f:4}}}, diff({a:1,b:2,c:{d:{e:1,f:2}}}, {a:1,b:2,c:{d:{e:1,f:4}}})))');
                if (!equal(null, diff({ a: 1 }, void 0)))
                    throw new Error('Assertion Failed: (equal(null, diff({a:1}, undefined)))');
                if (!equal(null, diff({ a: 1 }, null)))
                    throw new Error('Assertion Failed: (equal(null, diff({a:1}, null)))');
                if (!equal(void 0, diff({ a: { b: 2 } }, { a: { b: 2 } })))
                    throw new Error('Assertion Failed: (equal(undefined, diff({a:{b:2}}, {a:{b:2}})))');
                if (!equal(diff([
                        1,
                        2,
                        3
                    ], [
                        3,
                        2
                    ]), {
                        '0': 3,
                        length: 2
                    }))
                    throw new Error('Assertion Failed: ((equal(diff([1,2,3], [3,2]), { \'0\': 3, length: 2 })))');
                if (!equal(diff([], {}), { length: null }))
                    throw new Error('Assertion Failed: (equal(diff([], {}), {length:null}))');
                if (!equal(diff({}, []), []))
                    throw new Error('Assertion Failed: (equal(diff({}, []), []))');
                var start = [
                        1,
                        2,
                        3
                    ];
                var delta = diff(start, { foo: 'a' });
                var result = merge(start, delta);
                if (!equal(result, { foo: 'a' }))
                    throw new Error('Assertion Failed: (equal(result, {foo:"a"}))');
            },
            mergeActuallySetsValuesEvenWhenValueIsntChanged: function () {
                var Point = ion.defineClass({
                        name: 'Point',
                        properties: {
                            x: 0,
                            y: 0
                        }
                    });
                var Point = Point;
                var a = new Point({});
                if (!!a.hasOwnProperty('x'))
                    throw new Error('Assertion Failed: (not a.hasOwnProperty(\'x\'))');
                merge(a, { x: 0 });
                if (!a.hasOwnProperty('x'))
                    throw new Error('Assertion Failed: (a.hasOwnProperty(\'x\'))');
            },
            observe: function (done) {
                var before = global.watchCount != null ? global.watchCount : 0;
                var source = {
                        name: 'Kris',
                        age: 41,
                        children: {
                            Sadera: {
                                grandchildren: {
                                    One: 1,
                                    Two: 2
                                }
                            },
                            Orion: [],
                            Third: {},
                            Fifth: { alpha: 1 }
                        }
                    };
                var target = ion.clone(source, true);
                var unwatch = watch(source, function (patch) {
                        target = merge(target, patch);
                        if (equal(source, target)) {
                            unwatch();
                            var after = global.watchCount;
                            if (before !== after) {
                                done('Memory leak in watch: before = ' + before + ', after = ' + after);
                            } else {
                                done();
                            }
                        }
                    });
                ion.patch.combine(source, {
                    name: 'Fred',
                    children: {
                        Orion: {
                            a: 1,
                            b: 2,
                            c: 12
                        },
                        Sadera: { grandchildren: { three: 3 } },
                        Fourth: {
                            Something: {
                                One: 1,
                                Two: 2
                            }
                        }
                    }
                });
                source.children.Fifth = { beta: 2 };
                delete source.children.Third;
                ion.sync();
            }
        };
    }();
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/mergePatch',_ion_mergePatch_);
    else
      _ion_mergePatch_.call(this, module, exports, require);
  }
  else {
    _ion_mergePatch_.call(this);
  }
}).call(this)
void (function(){var _ion_runtime_ArrayExpression_ = function(module,exports,require){'use strict';
var ion = require('../'), DynamicExpression = require('./DynamicExpression');
var ArrayExpression = ion.defineClass({
        name: 'ArrayExpression',
        constructor: function ArrayExpression() {
            ArrayExpression.super.apply(this, arguments);
            if (!(this.elements != null)) {
                throw new Error('elements is required');
            }
            if (!(this.context != null)) {
                throw new Error('context is required');
            }
        },
        properties: {
            observeElements: false,
            notifyIfActive: function () {
                if (this.isActive) {
                    this.notify();
                }
            },
            setArgumentValue: function (key, expression, value) {
                if (this.argumentValues[key] !== value) {
                    this.unobserveExpressionValues[key] != null ? this.unobserveExpressionValues[key]() : void 0;
                    this.unobserveExpressionValues[key] = null;
                    this.argumentValues[key] = value;
                    if (this.observeElements && expression.mutable) {
                        if (value != null) {
                            this.itemObserver = this.itemObserver != null ? this.itemObserver : ion.bind(function () {
                                this.notifyIfActive();
                            }, this);
                            this.unobserveExpressionValues[key] = expression.deep ? ion.patch.watch(value, this.itemObserver) : ion.observe(value, this.itemObserver, null, [
                                expression,
                                this
                            ]);
                        }
                    }
                    this.notifyIfActive();
                }
            },
            activate: function () {
                var _ref = [];
                {
                    var _ref2 = this.elements;
                    for (var _i = 0; _i < _ref2.length; _i++) {
                        var item = _ref2[_i];
                        _ref.push(this.context.createRuntime(item));
                    }
                }
                this.expressions = _ref;
                this.argumentValues = [];
                this.unobserveExpressionValues = [];
                this.unobserveExpressions = [];
                {
                    var _ref3 = this.expressions;
                    for (var _i2 = 0; _i2 < _ref3.length; _i2++) {
                        var key = _i2;
                        var expression = _ref3[_i2];
                        this.unobserveExpressions.push(expression.observe(this.setArgumentValue.bind(this, key, expression), this));
                    }
                }
                ArrayExpression.super.prototype.activate.apply(this, arguments);
                this.setValue(this.argumentValues);
            },
            deactivate: function () {
                {
                    var _ref4 = this.expressions;
                    for (var _i3 = 0; _i3 < _ref4.length; _i3++) {
                        var key = _i3;
                        var expression = _ref4[_i3];
                        this.unobserveExpressionValues[key] != null ? this.unobserveExpressionValues[key]() : void 0;
                    }
                }
                {
                    var _ref5 = this.unobserveExpressions;
                    for (var _i4 = 0; _i4 < _ref5.length; _i4++) {
                        var unobserve = _ref5[_i4];
                        unobserve();
                    }
                }
                ArrayExpression.super.prototype.deactivate.apply(this, arguments);
            }
        },
        test: function () {
            var Context = require('./Context');
            var e = new ArrayExpression({
                    context: new Context(),
                    elements: [
                        {
                            type: 'Literal',
                            value: 1
                        },
                        {
                            type: 'Literal',
                            value: 2
                        }
                    ]
                });
            var result = void 0;
            function watcher(value) {
                result = value;
            }
            var unobserve = e.observe(watcher);
            if (!(JSON.stringify(result) === '[1,2]'))
                throw new Error('Assertion Failed: (JSON.stringify(result) is "[1,2]")');
            unobserve();
        }
    }, DynamicExpression);
module.exports = exports = ArrayExpression;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/runtime/ArrayExpression',_ion_runtime_ArrayExpression_);
    else
      _ion_runtime_ArrayExpression_.call(this, module, exports, require);
  }
  else {
    _ion_runtime_ArrayExpression_.call(this);
  }
}).call(this)
void (function(){var _ion_runtime_BlockStatement_ = function(module,exports,require){'use strict';
var ion = require('../'), Statement = require('./Statement');
var BlockStatement = ion.defineClass({
        name: 'BlockStatement',
        properties: {
            activate: function () {
                BlockStatement.super.prototype.activate.apply(this, arguments);
                if (!(this.statements != null)) {
                    var _ref = [];
                    {
                        var _ref2 = this.body;
                        for (var _i = 0; _i < _ref2.length; _i++) {
                            var s = _ref2[_i];
                            _ref.push(this.context.createRuntime(s));
                        }
                    }
                    this.statements = _ref;
                }
                {
                    var _ref3 = this.statements;
                    for (var _i2 = 0; _i2 < _ref3.length; _i2++) {
                        var statement = _ref3[_i2];
                        statement.activate();
                    }
                }
            },
            deactivate: function () {
                BlockStatement.super.prototype.deactivate.apply(this, arguments);
                for (var i = this.statements.length - 1; i >= 0; i--) {
                    var statement = this.statements[i];
                    statement.deactivate();
                }
            }
        }
    }, Statement);
module.exports = exports = BlockStatement;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/runtime/BlockStatement',_ion_runtime_BlockStatement_);
    else
      _ion_runtime_BlockStatement_.call(this, module, exports, require);
  }
  else {
    _ion_runtime_BlockStatement_.call(this);
  }
}).call(this)
void (function(){var _ion_runtime_CallExpression_ = function(module,exports,require){'use strict';
var ion = require('../'), _ref;
_ref = require('./');
var DynamicExpression = _ref.DynamicExpression;
var ArrayExpression = _ref.ArrayExpression;
var Factory = _ref.Factory;
var lastLogInfo = null;
var CallExpression = ion.defineClass({
        name: 'CallExpression',
        properties: {
            args: null,
            activate: function () {
                CallExpression.super.prototype.activate.apply(this, arguments);
                if (this.callee.type === 'Function' && this.arguments.length === 0 && !(this.callee.objectExpression != null)) {
                    var callee = this.callee.value;
                    var value;
                    if (this.callee.context) {
                        callee = callee(this.context);
                    }
                    if (this.type === 'NewExpression') {
                        value = new callee();
                    } else {
                        value = callee();
                    }
                    this.setValue(value);
                    return;
                }
                this.calleeExpression = this.calleeExpression != null ? this.calleeExpression : this.context.createRuntime(this.callee);
                this.unobserveCallee = this.calleeExpression.observe(this.calleeWatcher = this.calleeWatcher != null ? this.calleeWatcher : ion.bind(function (value) {
                    if (this.isActive && !(value != null) && !this.existential && (this.loc != null ? this.loc.start.source : void 0) != null) {
                        console.warn('Function is ' + value + ' (' + Factory.toCode(this.callee) + ') (' + this.loc.start.source + ':' + this.loc.start.line + ':' + (this.loc.start.column + 1) + ')');
                    }
                    if (this.calleeValue !== value) {
                        this.calleeValue = value;
                        this.queueEvaluate();
                    }
                }, this));
                this.unobserveCalleeObject = this.calleeExpression.objectExpression != null ? this.calleeExpression.objectExpression.observe(this.thisWatcher = this.thisWatcher != null ? this.thisWatcher : ion.bind(function (thisArg) {
                    if (thisArg !== this.thisArg) {
                        this.unobserveThis != null ? this.unobserveThis() : void 0;
                        this.unobserveThis = null;
                        this.thisArg = thisArg;
                        if (this.calleeExpression.mutable && !(this.calleeValue != null ? this.calleeValue.template : void 0)) {
                            if (this.calleeExpression.objectExpression.deep) {
                                this.unobserveThis = ion.patch.watch(thisArg, this.thisObserver = this.thisObserver != null ? this.thisObserver : ion.bind(function (patch) {
                                    this.queueEvaluate();
                                }, this));
                            } else {
                                this.unobserveThis = ion.observe(thisArg, this.thisObserver = this.thisObserver != null ? this.thisObserver : ion.bind(function () {
                                    this.queueEvaluate();
                                }, this));
                            }
                        }
                        this.queueEvaluate();
                    }
                }, this)) : void 0;
                if (this.arguments.length === 0) {
                    this.argumentsValue = [];
                    this.queueEvaluate();
                } else {
                    this.argumentExpressions = this.argumentExpressions != null ? this.argumentExpressions : this.context.createRuntime({
                        type: 'ArrayExpression',
                        elements: this.arguments,
                        observeElements: !(this.calleeValue != null ? this.calleeValue.template : void 0)
                    });
                    this.unobserveArguments = this.argumentExpressions.observe(this.argumentWatcher = this.argumentWatcher != null ? this.argumentWatcher : ion.bind(function (value) {
                        this.argumentsValue = value;
                        this.queueEvaluate();
                    }, this));
                }
            },
            deactivate: function () {
                CallExpression.super.prototype.deactivate.apply(this, arguments);
                this.cancelQueuedEvaluate != null ? this.cancelQueuedEvaluate() : void 0;
                this.unobserveCallee != null ? this.unobserveCallee() : void 0;
                this.unobserveArguments != null ? this.unobserveArguments() : void 0;
                this.unobserveCalleeObject != null ? this.unobserveCalleeObject() : void 0;
                this.unobserveThis != null ? this.unobserveThis() : void 0;
                this.unobserveTemplate != null ? this.unobserveTemplate() : void 0;
            },
            queueEvaluate: function () {
                if (!(this.hasEvaluated != null)) {
                    this.evaluate();
                } else if (!(this.cancelQueuedEvaluate != null)) {
                    this.cancelQueuedEvaluate = ion.nextCheck(this.boundEvaluate = this.boundEvaluate != null ? this.boundEvaluate : this.evaluate.bind(this));
                }
            },
            evaluate: function () {
                this.cancelQueuedEvaluate = null;
                if (!(this.isActive && this.calleeValue != null && this.argumentsValue != null && (this.thisArg != null || !(this.calleeExpression.objectExpression != null)))) {
                    return;
                }
                this.hasEvaluated = true;
                var value = void 0;
                if (this.unobserveTemplate != null && this.lastCalleeValue === this.calleeValue && this.lastThisArg === this.thisArg) {
                    console.warn('Changing a template parameter directly, this hurts performance, should be fixed in ion: ' + this.ast.callee.name);
                }
                this.lastCalleeValue = this.calleeValue;
                this.lastArgumentsValue = this.argumentsValue;
                this.lastThisArg = this.thisArg;
                this.unobserveTemplate != null ? this.unobserveTemplate() : void 0;
                this.unobserveTemplate = null;
                if (this.calleeValue.template) {
                    this.template = this.calleeValue.apply(this.thisArg, this.argumentsValue);
                    this.unobserveTemplate = this.template.observe(this.templateWatcher = this.templateWatcher != null ? this.templateWatcher : this.setValue.bind(this));
                } else {
                    try {
                        if (this.type === 'NewExpression') {
                            value = ion.create(this.calleeValue, this.argumentsValue);
                        } else {
                            if (this.thisArg === console) {
                                var start = this.loc.start;
                                var logInfo = '' + start.source + ':' + start.line;
                                if (logInfo !== lastLogInfo) {
                                    lastLogInfo = logInfo;
                                    console.info(logInfo);
                                }
                            }
                            value = this.calleeValue.apply(this.thisArg, this.argumentsValue);
                        }
                        this.setValue(value);
                    } catch (e) {
                        if (this.loc != null) {
                            var start = this.loc.start;
                            console.error('Call Error at ' + start.source + ' (line:' + start.line + ',column:' + start.column + ')');
                        }
                        throw e;
                    }
                }
            }
        }
    }, DynamicExpression);
module.exports = CallExpression;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/runtime/CallExpression',_ion_runtime_CallExpression_);
    else
      _ion_runtime_CallExpression_.call(this, module, exports, require);
  }
  else {
    _ion_runtime_CallExpression_.call(this);
  }
}).call(this)
void (function(){var _ion_runtime_ConditionalExpression_ = function(module,exports,require){'use strict';
var ion = require('../'), DynamicExpression = require('./DynamicExpression');
var ConditionalExpression = ion.defineClass({
        name: 'ConditionalExpression',
        properties: {
            activate: function () {
                ConditionalExpression.super.prototype.activate.apply(this, arguments);
                this.testExpression = this.testExpression != null ? this.testExpression : this.context.createRuntime(this.test);
                this.unobserveTest = this.testExpression.observe(this.testObserver = this.testObserver != null ? this.testObserver : ion.bind(function (value) {
                    if (!this.hasOwnProperty('testValue') || Boolean(value) !== Boolean(this.testValue)) {
                        this.testValue = value;
                        this.unobserveExpression != null ? this.unobserveExpression() : void 0;
                        if (value) {
                            this.unobserveExpression = this.context.createRuntime(this.consequent).observe(this.consequentObserver = this.consequentObserver != null ? this.consequentObserver : ion.bind(function (value) {
                                if (this.testValue) {
                                    this.setValue(value);
                                }
                            }, this));
                        } else {
                            this.unobserveExpression = this.context.createRuntime(this.alternate).observe(this.alternateObserver = this.alternateObserver != null ? this.alternateObserver : ion.bind(function (value) {
                                if (!this.testValue) {
                                    this.setValue(value);
                                }
                            }, this));
                        }
                    }
                }, this));
            },
            deactivate: function () {
                ConditionalExpression.super.prototype.deactivate.apply(this, arguments);
                this.unobserveTest();
                this.unobserveExpression != null ? this.unobserveExpression() : void 0;
            }
        }
    }, DynamicExpression);
module.exports = ConditionalExpression;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/runtime/ConditionalExpression',_ion_runtime_ConditionalExpression_);
    else
      _ion_runtime_ConditionalExpression_.call(this, module, exports, require);
  }
  else {
    _ion_runtime_ConditionalExpression_.call(this);
  }
}).call(this)
void (function(){var _ion_runtime_Context_ = function(module,exports,require){'use strict';
var ion = require('../'), Factory = require('./Factory'), Literal = require('./Literal'), noop = function () {
    };
var createObjectInserter = function (container) {
    return {
        isOrdered: function (value) {
            return false;
        },
        convert: function (value) {
            return value;
        },
        getLength: function () {
            return 0;
        },
        add: function (value, index) {
            var current = container[value];
            var insert = (current != null ? current : 0) + 1;
            container[value] = insert;
        },
        remove: function (index, value, moving) {
            var current = container[value];
            if (!(current != null)) {
                throw new Error('Removing value \'' + value + '\' that was not present in container: ' + container);
            }
            var insert = current - 1;
            if (insert === 0) {
                delete container[value];
            } else {
                container[value] = insert;
            }
        }
    };
};
var createMapInserter = function (container) {
    var touch = function () {
        container.touch = container.touch != null ? container.touch : 0;
        container.touch += 1;
    };
    return {
        isOrdered: function (value) {
            return false;
        },
        convert: function (value) {
            return value;
        },
        getLength: function () {
            return container.size;
        },
        add: function (value, index) {
            var current = container.get(value);
            var insert = (current != null ? current : 0) + 1;
            container.set(value, insert);
            touch();
        },
        remove: function (index, value, moving) {
            var current = container.get(value);
            if (!(current != null)) {
                throw new Error('Removing value \'' + value + '\' that was not present in container: ' + container);
            }
            var insert = current - 1;
            if (insert === 0) {
                container.delete(value);
            } else {
                container.set(value, insert);
            }
            touch();
        }
    };
};
var createArrayInserter = function (container) {
    return {
        isOrdered: function (value) {
            if (container.sortCompareFunction != null) {
                return false;
            }
            return container.unordered !== true;
        },
        convert: function (value) {
            return value;
        },
        getLength: function () {
            return container.length;
        },
        add: function (value, index) {
            if (index != null) {
                container.splice(index, 0, value);
            } else {
                container.push(value);
            }
        },
        remove: function (index, value, moving) {
            index = index != null ? index : container.indexOf(value);
            container.splice(index, 1);
        }
    };
};
var isNode = function (value) {
    return typeof (value != null ? value.nodeType : void 0) === 'number';
};
var isWebComponent = function (value) {
    return (value != null ? value.nodeName != null ? value.nodeName.indexOf('-') : void 0 : void 0) > 0;
};
var createHtmlInserter = function (container) {
    return {
        isOrdered: function (value) {
            if (typeof value === 'function') {
                return false;
            }
            if (container.unordered) {
                return false;
            }
            return true;
        },
        convert: function (value) {
            if (typeof value === 'function') {
                var name = value.id != null ? value.id : value.name;
                if (!(name != null)) {
                    throw new Error('Functions added to an Element must be named');
                }
                var capture = false;
                var captureSuffix = '_capture';
                if (name.endsWith(captureSuffix)) {
                    capture = true;
                    name = name.substring(0, name.length - captureSuffix.length);
                }
                value.id = name;
                value.capture = capture;
            } else if (!isNode(value)) {
                value = document.createTextNode(value);
            }
            return value;
        },
        getLength: function () {
            return container.childNodes.length;
        },
        add: function (value, index, sourceNode) {
            if (typeof value === 'function') {
                if (value.toString().indexOf('ion.sync') < 0) {
                    value.wrapper = value.wrapper != null ? value.wrapper : function () {
                        value.apply(this, arguments);
                        ion.sync(value.id != null ? value.id : value.name);
                    };
                }
                container.addEventListener(value.id, value.wrapper != null ? value.wrapper : value, value.capture);
            } else {
                if (global.Polymer) {
                    var polymerContainer = Polymer.dom(container);
                    if (index != null) {
                        var after = polymerContainer.childNodes[index];
                        if (after != null) {
                            polymerContainer.insertBefore(value, after);
                            return;
                        }
                    }
                    polymerContainer.appendChild(value);
                } else {
                    if (index != null) {
                        var after = container.childNodes[index];
                        if (after != null) {
                            container.insertBefore(value, after);
                            return;
                        }
                    }
                    container.appendChild(value);
                }
            }
        },
        remove: function (index, value, moving) {
            if (typeof value === 'function') {
                container.removeEventListener(value.id, value.wrapper != null ? value.wrapper : value);
            } else if (!moving) {
                if (global.Polymer) {
                    var polymerContainer = Polymer.dom(container);
                    try {
                        polymerContainer.removeChild(value);
                    } catch (e) {
                        if (!warnedOfRemovalBug) {
                            warnedOfRemovalBug = true;
                            console.log('TODO: FIX!!! Polymer error: Cannot remove child. It may not exist anymore/yet.');
                        }
                    }
                } else {
                    if (value.parentElement === container) {
                        container.removeChild(value);
                    } else {
                        console.log('Context is trying to remove an element from a container that it is not in.');
                    }
                }
            }
        }
    };
};
var warnedOfRemovalBug = false;
function isDomAncestor(ancestor, child, debug) {
    var realAncestor = child;
    while (realAncestor.parentElement != null) {
        realAncestor = realAncestor.parentElement;
        if (realAncestor === ancestor) {
            return true;
        }
    }
    return false;
}
var createOrderManager = function (container) {
    var inserter;
    if (Array.isArray(container)) {
        inserter = createArrayInserter(container);
    } else if ((container != null ? container.constructor : void 0) === Map) {
        inserter = createMapInserter(container);
    } else if (isNode(container)) {
        inserter = createHtmlInserter(container);
    } else if ((container != null ? container.constructor : void 0) === Object) {
        inserter = createObjectInserter(container);
    } else {
        return {
            insert: function (value, order, fastInsert, sourceNode) {
                return ion.add(container, value, sourceNode);
            },
            update: function (oldOrder, newOrder) {
            }
        };
    }
    var baseLength = inserter.getLength();
    var insertionOrders = [];
    var insertionValues = {};
    var pendingOrderChanges = {};
    var insertInternal = function (value, order, fastInsert, sourceNode) {
        if (insertionValues[order] != null) {
            throw new Error('Cannot add a new item with the same order as an existing item: ' + JSON.stringify({
                order: order,
                previousValue: insertionValues[order],
                newValue: value
            }));
        }
        if (inserter.isOrdered(value)) {
            insertionValues[order] = value;
            insertionOrders.push(order);
        } else {
            fastInsert = true;
        }
        if (fastInsert) {
            inserter.add(value, null, sourceNode);
        } else {
            insertionOrders.sort();
            var index = insertionOrders.indexOf(order);
            inserter.add(value, baseLength + index, sourceNode);
        }
    };
    var removeInternal = function (value, order, moving) {
        if (!inserter.isOrdered(value)) {
            inserter.remove(null, value);
        } else {
            if (insertionValues[order] !== value) {
                order = null;
                for (var key in insertionValues) {
                    var insertedValue = insertionValues[key];
                    if (insertedValue === value) {
                        order = key;
                        break;
                    }
                }
                if (order === null) {
                    throw new Error('Could not find value in insertionValues ' + value);
                }
            }
            var index = insertionOrders.indexOf(order);
            if (index < 0) {
                throw new Error('Insertion order ' + JSON.stringify(order) + ' not found ' + JSON.stringify(insertionOrders));
            }
            insertionOrders.splice(index, 1);
            inserter.remove(baseLength + index, value, moving);
            delete insertionValues[order];
        }
    };
    return {
        insert: function (value, order, fastInsert, sourceNode) {
            value = inserter.convert(value);
            insertInternal(value, order, fastInsert, sourceNode);
            return function () {
                return removeInternal(value, order);
            };
        },
        update: function (oldOrder, newOrder) {
            if (oldOrder != null && newOrder != null) {
                pendingOrderChanges[oldOrder] = newOrder;
            } else {
                var reinsertValues = {};
                for (var i = insertionOrders.length - 1; i >= 0; i--) {
                    var order = insertionOrders[i];
                    for (var oldOrderValue in pendingOrderChanges) {
                        var newOrderValue = pendingOrderChanges[oldOrderValue];
                        if (order.startsWith(oldOrderValue)) {
                            var insertedValue = insertionValues[order];
                            reinsertValues[newOrderValue + order.substring(oldOrderValue.length)] = insertedValue;
                            removeInternal(insertedValue, order, true);
                        }
                    }
                }
                for (var order in reinsertValues) {
                    var value = reinsertValues[order];
                    insertInternal(value, order);
                }
                pendingOrderChanges = {};
            }
        }
    };
};
var Context = ion.defineClass({
        name: 'Context',
        constructor: function Context(parent, output, order) {
            this.output = output;
            this.parent = parent;
            this.depth = parent != null ? parent.depth + 1 : 0;
            this.variables = {};
            this.root = (parent != null ? parent.root : void 0) != null ? parent.root : this;
            this._runtimes = {};
            this.returnExpression = parent != null ? parent.returnExpression : void 0;
            this.inserter = output === (parent != null ? parent.output : void 0) ? parent != null ? parent.inserter : void 0 : createOrderManager(output);
            this.order = order;
        },
        properties: {
            newContext: function (output, order) {
                if (output == null)
                    output = this.output;
                return new Context(this, output, order);
            },
            createRuntime: function (node) {
                return Factory.createRuntime(this, node);
            },
            setFastInsert: function (value) {
                if (this.inserter != null) {
                    this.inserter.fastInsert = value;
                }
            },
            order: {
                get: function () {
                    var value = this._order != null ? this._order : '';
                    if (this.output != null && this.output === (this.parent != null ? this.parent.output : void 0)) {
                        value = this.parent.order + value;
                    }
                    return value;
                },
                set: function (value) {
                    var _order = this._order;
                    var oldValue = this.order;
                    this._order = value != null ? value : '';
                    var newValue = this.order;
                    if (_order != null && newValue !== oldValue) {
                        this.inserter != null ? this.inserter.update(oldValue, newValue) : void 0;
                    }
                }
            },
            insert: function (value, order, sourceNode) {
                order = this.order + (order != null ? order : '');
                return this.inserter.insert(value, order, this.inserter.fastInsert, sourceNode);
            },
            get: function (name) {
                var variable = this.getVariable(name);
                if (!(variable != null)) {
                    throw new Error('Variable not found: \'' + name + '\'');
                }
                return variable.value;
            },
            getVariable: function (ast) {
                var name = typeof ast === 'string' ? ast : ast.name;
                var context = this, value;
                while (context != null) {
                    var variable = context.variables[name];
                    if (variable != null) {
                        return variable;
                    }
                    context = context.parent;
                }
                value = global[name];
                if (value === void 0) {
                    var message = 'Variable not found: \'' + name + '\'';
                    if (typeof ast === 'object') {
                        message += ' at (' + ast.loc.start.source + ':' + ast.loc.start.line + ':' + (ast.loc.start.column + 1) + ')';
                    }
                    throw new Error(message);
                }
                var cachedGlobals = this.root.globals = this.root.globals != null ? this.root.globals : {};
                return cachedGlobals[name] = cachedGlobals[name] != null ? cachedGlobals[name] : new Literal({
                    value: value,
                    mutable: true
                });
            },
            setVariableFromAst: function (name, node) {
                if (name != null) {
                    return this.setVariableExpression(name, this.createRuntime(node));
                }
            },
            setVariableLiteral: function (name, value) {
                if (name != null) {
                    return this.setVariableExpression(name, new Literal({
                        value: value,
                        mutable: true
                    }));
                }
            },
            setVariableExpression: function (name, expression) {
                if (name != null) {
                    if (this.variables[name] != null) {
                        throw new Error('Variable ' + name + ' is already defined');
                    }
                    this.variables[name] = expression;
                    return expression;
                }
            }
        }
    });
module.exports = exports = Context;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/runtime/Context',_ion_runtime_Context_);
    else
      _ion_runtime_Context_.call(this, module, exports, require);
  }
  else {
    _ion_runtime_Context_.call(this);
  }
}).call(this)
void (function(){var _ion_runtime_DynamicExpression_ = function(module,exports,require){'use strict';
var ion = require('../');
var DynamicExpression = ion.defineClass({
        name: 'DynamicExpression',
        properties: {
            isActive: false,
            activate: function () {
                this.isActive = true;
            },
            deactivate: function () {
                this.isActive = false;
            },
            observe: function (observer, options) {
                var originalObserver = observer;
                var removed = false;
                var watchers = this._watchers = this._watchers != null ? this._watchers : [];
                if (watchers.length === 0) {
                    this.activate();
                }
                watchers.push(observer);
                if (this.hasValue()) {
                    var value = this.getValue();
                    this._notifyWatcher(originalObserver, value);
                }
                return ion.bind(function () {
                    if (!removed) {
                        removed = true;
                        this._watchers.remove(observer);
                        if (this._watchers.length === 0) {
                            this.deactivate();
                        }
                    }
                }, this);
            },
            _notifyWatcher: function (observer, value) {
                return observer.call(this, value);
            },
            notify: function () {
                if (this._watchers != null) {
                    var value = this.getValue();
                    {
                        var _ref = this._watchers;
                        for (var _i = 0; _i < _ref.length; _i++) {
                            var observer = _ref[_i];
                            this._notifyWatcher(observer, value);
                        }
                    }
                }
                return;
            },
            hasValue: function () {
                return this.hasOwnProperty('value');
            },
            getValue: function () {
                return this.value;
            },
            setValue: function (value) {
                if (value !== this.value || !this.hasValue()) {
                    this.value = value;
                    this.notify();
                }
                return;
            }
        },
        test: function () {
            var d = new DynamicExpression();
            if (d.getValue() !== void 0) {
                throw 'd.getValue() != undefined';
            }
            var total = 10;
            var observer = function (value) {
                if (value !== void 0) {
                    total += value;
                }
            };
            var unobserve = d.observe(observer);
            if (!(total === 10))
                throw new Error('Assertion Failed: (total is 10)');
            d.setValue(10);
            if (!(d.getValue() === 10))
                throw new Error('Assertion Failed: (d.getValue() is 10)');
            if (!(total === 20))
                throw new Error('Assertion Failed: (total is 20)');
            d.setValue(20);
            if (!(total === 40))
                throw new Error('Assertion Failed: (total is 40)');
            unobserve();
            if (!(total === 40))
                throw new Error('Assertion Failed: (total is 40)');
            d.setValue(50);
            if (!(total === 40))
                throw new Error('Assertion Failed: (total is 40)');
        }
    }, require('./Expression'));
module.exports = exports = DynamicExpression;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/runtime/DynamicExpression',_ion_runtime_DynamicExpression_);
    else
      _ion_runtime_DynamicExpression_.call(this, module, exports, require);
  }
  else {
    _ion_runtime_DynamicExpression_.call(this);
  }
}).call(this)
void (function(){var _ion_runtime_Expression_ = function(module,exports,require){'use strict';
var ion = require('../');
var Expression = ion.defineClass({
        name: 'Expression',
        properties: {
            mutable: true,
            observe: function (callback, dependentExpression) {
            }
        }
    }, require('./Node'));
module.exports = exports = Expression;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/runtime/Expression',_ion_runtime_Expression_);
    else
      _ion_runtime_Expression_.call(this, module, exports, require);
  }
  else {
    _ion_runtime_Expression_.call(this);
  }
}).call(this)
void (function(){var _ion_runtime_ExpressionStatement_ = function(module,exports,require){'use strict';
var ion = require('../'), _ref;
_ref = require('./');
var Factory = _ref.Factory;
var Statement = _ref.Statement;
var ExpressionStatement = ion.defineClass({
        name: 'ExpressionStatement',
        properties: {
            activate: function () {
                ExpressionStatement.super.prototype.activate.apply(this, arguments);
                this.runtimeExpression = this.runtimeExpression != null ? this.runtimeExpression : this.context.createRuntime(this.expression);
                this.unobserve = this.runtimeExpression.observe(this.runtimeExpressionObserver = this.runtimeExpressionObserver != null ? this.runtimeExpressionObserver : ion.bind(function (value) {
                    if (this.expressionValue !== value) {
                        this.expressionValue = value;
                        this._remove != null ? this._remove() : void 0;
                        this._remove = null;
                        if (this.context.output != null && value !== void 0) {
                            this._remove = this.context.insert(value, this.order, this);
                        }
                    }
                }, this));
            },
            deactivate: function () {
                ExpressionStatement.super.prototype.deactivate.apply(this, arguments);
                this.runtimeExpressionObserver != null ? this.runtimeExpressionObserver(void 0) : void 0;
                this.unobserve != null ? this.unobserve() : void 0;
                this.unobserve = null;
                this._remove != null ? this._remove() : void 0;
                this._remove = null;
            }
        }
    }, Statement);
module.exports = exports = ExpressionStatement;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/runtime/ExpressionStatement',_ion_runtime_ExpressionStatement_);
    else
      _ion_runtime_ExpressionStatement_.call(this, module, exports, require);
  }
  else {
    _ion_runtime_ExpressionStatement_.call(this);
  }
}).call(this)
void (function(){var _ion_runtime_Factory_ = function(module,exports,require){'use strict';
var ion = require('../');
var Literal = require('./Literal');
var Expression = require('./Expression');
var Factory = ion.defineClass({
        name: 'Factory',
        properties: {
            runtime: './OperationExpression',
            createRuntime: {
                writable: true,
                value: function (context, ast) {
                    var properties = ion.clone(ast);
                    properties.context = context;
                    properties.factory = this;
                    var type = require(this.runtime);
                    return ion.patch.combine(new type(properties), { ast: ast });
                }
            },
            canCache: {
                writable: true,
                value: function (ast) {
                    return false;
                }
            },
            toCode: {
                writable: true,
                value: function (ast) {
                    if (ast.type === 'BinaryExpression') {
                        return toCode(ast.left) + ast.operator + toCode(ast.right);
                    }
                    return '(' + JSON.stringify(ast) + ')';
                }
            }
        }
    });
Factory;
var lookup = {
        type: {
            UndoStatement: ion.patch.combine(new Factory(), { runtime: './UndoStatement' }),
            VariableDeclaration: ion.patch.combine(new Factory(), { runtime: './VariableDeclaration' }),
            ThisExpression: ion.patch.combine(new Factory(), {
                createRuntime: function (context, ast) {
                    var expression = context.getVariable('this');
                    if (ast.deep) {
                        expression.deep = true;
                    }
                    return expression;
                },
                toCode: function (ast) {
                    return 'this';
                }
            }),
            Identifier: ion.patch.combine(new Factory(), {
                createRuntime: function (context, ast) {
                    var expression = context.getVariable(ast);
                    if (ast.deep) {
                        expression.deep = true;
                    }
                    return expression;
                },
                canCache: function (ast) {
                    return true;
                },
                toCode: function (ast) {
                    return ast.name;
                }
            }),
            Function: ion.patch.combine(new Factory(), {
                createRuntime: function (context, ast) {
                    var value = ast.value;
                    if (ast.context) {
                        value = value(context);
                    }
                    return new Literal({ value: value });
                }
            }),
            Template: ion.patch.combine(new Factory(), { runtime: './Template' }),
            Literal: ion.patch.combine(new Factory(), {
                runtime: './Literal',
                canCache: function (ast) {
                    return true;
                },
                toCode: function (ast) {
                    return JSON.stringify(ast.value);
                }
            }),
            Property: ion.patch.combine(new Factory(), { runtime: './Property' }),
            IfStatement: ion.patch.combine(new Factory(), { runtime: './IfStatement' }),
            BlockStatement: ion.patch.combine(new Factory(), { runtime: './BlockStatement' }),
            ReturnStatement: ion.patch.combine(new Factory(), { runtime: './ReturnStatement' }),
            ObjectExpression: ion.patch.combine(new Factory(), { runtime: './ObjectExpression' }),
            ArrayExpression: ion.patch.combine(new Factory(), { runtime: './ArrayExpression' }),
            ExpressionStatement: ion.patch.combine(new Factory(), { runtime: './ExpressionStatement' }),
            ForOfStatement: ion.patch.combine(new Factory(), { runtime: './ForInOfStatement' }),
            ForInStatement: ion.patch.combine(new Factory(), { runtime: './ForInOfStatement' }),
            MemberExpression: ion.patch.combine(new Factory(), {
                runtime: './MemberExpression',
                canCache: function (ast) {
                    return canCache(ast.object) && canCache(ast.property);
                },
                toCode: function (ast) {
                    if (ast.computed) {
                        return '' + toCode(ast.object) + '[' + toCode(ast.property) + ']';
                    } else {
                        return '' + toCode(ast.object) + '.' + toCode(ast.property);
                    }
                }
            }),
            CallExpression: ion.patch.combine(new Factory(), { runtime: './CallExpression' }),
            NewExpression: ion.patch.combine(new Factory(), { runtime: './CallExpression' }),
            UnaryExpression: {
                operator: {
                    '!': ion.patch.combine(new Factory(), {
                        evaluate: function (a) {
                            return !a;
                        }
                    }),
                    'typeof': ion.patch.combine(new Factory(), {
                        evaluate: function (a) {
                            return typeof a;
                        }
                    }),
                    'void': ion.patch.combine(new Factory(), {
                        evaluate: function (a) {
                            return void a;
                        }
                    }),
                    '-': ion.patch.combine(new Factory(), {
                        evaluate: function (a) {
                            return -a;
                        }
                    }),
                    '+': ion.patch.combine(new Factory(), {
                        evaluate: function (a) {
                            return +a;
                        }
                    }),
                    '~': ion.patch.combine(new Factory(), {
                        evaluate: function (a) {
                            return ~a;
                        }
                    }),
                    '?': ion.patch.combine(new Factory(), {
                        evaluate: function (a) {
                            return a != null;
                        }
                    })
                }
            },
            ConditionalExpression: ion.patch.combine(new Factory(), { runtime: './ConditionalExpression' }),
            BinaryExpression: {
                operator: {
                    '*': ion.patch.combine(new Factory(), {
                        evaluate: function (left, right) {
                            return left * right;
                        }
                    }),
                    '/': ion.patch.combine(new Factory(), {
                        evaluate: function (left, right) {
                            return left / right;
                        }
                    }),
                    '%': ion.patch.combine(new Factory(), {
                        evaluate: function (left, right) {
                            return left % right;
                        }
                    }),
                    '+': ion.patch.combine(new Factory(), {
                        evaluate: function (left, right) {
                            return left + right;
                        }
                    }),
                    '-': ion.patch.combine(new Factory(), {
                        evaluate: function (left, right) {
                            return left - right;
                        }
                    }),
                    '&&': ion.patch.combine(new Factory(), {
                        evaluate: function (left, right) {
                            return left && right;
                        }
                    }),
                    '||': ion.patch.combine(new Factory(), {
                        evaluate: function (left, right) {
                            return left || right;
                        }
                    }),
                    '&': ion.patch.combine(new Factory(), {
                        evaluate: function (left, right) {
                            return left & right;
                        }
                    }),
                    '|': ion.patch.combine(new Factory(), {
                        evaluate: function (left, right) {
                            return left | right;
                        }
                    }),
                    '==': ion.patch.combine(new Factory(), {
                        evaluate: function (left, right) {
                            return left == right;
                        }
                    }),
                    '!=': ion.patch.combine(new Factory(), {
                        evaluate: function (left, right) {
                            return left != right;
                        }
                    }),
                    '===': ion.patch.combine(new Factory(), {
                        evaluate: function (left, right) {
                            return left === right;
                        }
                    }),
                    '!==': ion.patch.combine(new Factory(), {
                        evaluate: function (left, right) {
                            return left !== right;
                        }
                    }),
                    '<': ion.patch.combine(new Factory(), {
                        evaluate: function (left, right) {
                            return left < right;
                        }
                    }),
                    '>': ion.patch.combine(new Factory(), {
                        evaluate: function (left, right) {
                            return left > right;
                        }
                    }),
                    '<=': ion.patch.combine(new Factory(), {
                        evaluate: function (left, right) {
                            return left <= right;
                        }
                    }),
                    '>=': ion.patch.combine(new Factory(), {
                        evaluate: function (left, right) {
                            return left >= right;
                        }
                    })
                }
            }
        }
    };
function getFactory(ast, step) {
    if (step == null)
        step = lookup;
    for (var key in step) {
        var values = step[key];
        var nodeValue = ast[key];
        var next = values[nodeValue];
        if (next != null) {
            if (next.constructor === Factory) {
                return next;
            }
            return getFactory(ast, next);
        }
    }
    return null;
}
var canCache = exports.canCache = function (ast) {
        if (ast != null) {
            var factory = getFactory(ast);
            if (factory != null) {
                return factory.canCache(ast);
            }
        }
        return false;
    }, toCode = exports.toCode = function (ast) {
        if (ast != null) {
            var code = ast._toCode;
            if (!(code != null)) {
                var factory = getFactory(ast);
                if (factory != null) {
                    code = factory.toCode(ast);
                }
                if (code != null && typeof ast === 'object') {
                    Object.defineProperty(ast, '_toCode', { value: code });
                }
            }
            return code;
        }
        return JSON.stringify(ast);
    }, createRuntime = exports.createRuntime = function (context, ast) {
        if (typeof (ast != null ? ast.type : void 0) !== 'string') {
            ast = {
                type: 'Literal',
                value: ast
            };
        }
        var factory = getFactory(ast);
        if (!(factory != null)) {
            throw new Error('Factory not found for ast:\n' + JSON.stringify(ast, null, '  '));
        }
        return factory.createRuntime(context, ast);
    }, test = exports.test = function () {
        var factory = getFactory({
                type: 'BinaryExpression',
                operator: '>',
                left: {
                    type: 'Literal',
                    value: 1
                },
                right: {
                    type: 'Literal',
                    value: 2
                }
            });
        if (!(factory === lookup.type.BinaryExpression.operator['>']))
            throw new Error('Assertion Failed: (factory is lookup.type.BinaryExpression.operator[">"])');
        if (!(lookup.type.BinaryExpression.operator['>'] != null))
            throw new Error('Assertion Failed: (lookup.type.BinaryExpression.operator[">"]?)');
    };
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/runtime/Factory',_ion_runtime_Factory_);
    else
      _ion_runtime_Factory_.call(this, module, exports, require);
  }
  else {
    _ion_runtime_Factory_.call(this);
  }
}).call(this)
void (function(){var _ion_runtime_ForInOfStatement_ = function(module,exports,require){'use strict';
var ion = require('../'), Statement = require('./Statement'), DynamicExpression = require('./DynamicExpression');
var ForInOfStatement = ion.defineClass({
        name: 'ForInOfStatement',
        properties: {
            toKey: function (name) {
                if (this.type === 'ForOfStatement') {
                    return parseInt(name);
                } else {
                    return name;
                }
            },
            forEach: function (collection, callback) {
                if (this.type === 'ForOfStatement') {
                    for (var key = 0; key < collection.length; key++) {
                        var value = collection[key];
                        callback(key, value);
                    }
                } else {
                    for (var key in collection) {
                        var value = collection[key];
                        callback(key, value);
                    }
                }
            },
            activate: function () {
                ForInOfStatement.super.prototype.activate.apply(this, arguments);
                if (!(this.statements != null)) {
                    this.statements = {};
                    this.valueName = this.left.declarations[this.type === 'ForOfStatement' ? 0 : 1] != null ? this.left.declarations[this.type === 'ForOfStatement' ? 0 : 1].id.name : void 0;
                    this.keyName = this.left.declarations[this.type === 'ForOfStatement' ? 1 : 0] != null ? this.left.declarations[this.type === 'ForOfStatement' ? 1 : 0].id.name : void 0;
                }
                this.collectionExpression = this.collectionExpression != null ? this.collectionExpression : this.context.createRuntime(this.right);
                this.unobserveExpression = this.collectionExpression.observe(this.collectionWatcher = this.collectionWatcher != null ? this.collectionWatcher : ion.bind(function (collection) {
                    if (this.collection !== collection) {
                        this.unobserveCollection != null ? this.unobserveCollection() : void 0;
                        if (this.collection != null) {
                            for (var key in this.statements) {
                                this.removeItem(key);
                            }
                        }
                        this.unobserveCollection = null;
                        this.collection = collection;
                        if (this.collection != null) {
                            this.forEach(this.collection, ion.bind(function (key, value) {
                                this.addItem(key, value);
                            }, this));
                            if (this.collectionExpression.mutable) {
                                this.unobserveCollection = ion.observe(this.collection, this.collectionObserver = this.collectionObserver != null ? this.collectionObserver : this.applyChanges.bind(this));
                            }
                        }
                    }
                }, this));
            },
            deactivate: function () {
                ForInOfStatement.super.prototype.deactivate.apply(this, arguments);
                this.collectionWatcher != null ? this.collectionWatcher(void 0) : void 0;
                this.unobserveExpression();
                this.unobserveCollection != null ? this.unobserveCollection() : void 0;
            },
            keyToUnicodeChar: function (key) {
                if (typeof key === 'number') {
                    return String.fromCharCode(48 + key);
                } else {
                    this.keyCache = this.keyCache != null ? this.keyCache : {};
                    this.keyCacheCount = this.keyCacheCount != null ? this.keyCacheCount : 0;
                    return this.keyCache[key] = this.keyCache[key] != null ? this.keyCache[key] : String.fromCharCode(48 + this.keyCacheCount++);
                }
            },
            getOrderForKey: function (key) {
                return this.order + this.keyToUnicodeChar(key);
            },
            addItem: function (key, value, activate) {
                if (activate == null)
                    activate = true;
                if (this.statements.hasOwnProperty(key)) {
                    throw new Error('There should not be a current statement for this key: ' + key);
                }
                if (value !== void 0) {
                    var order = this.getOrderForKey(key);
                    var context = this.context.newContext(void 0, order);
                    if (this.valueName != null) {
                        context.setVariableExpression(this.valueName, new DynamicExpression({ value: value }));
                    }
                    if (this.keyName != null) {
                        context.setVariableExpression(this.keyName, new DynamicExpression({ value: key }));
                    }
                    var statement = context.createRuntime(this.body);
                    this.statements[key] = statement;
                    if (activate) {
                        statement.activate();
                    }
                    return statement;
                }
            },
            removeItem: function (key, value) {
                var statement = this.statements[key];
                if (statement != null) {
                    this.disposeStatement(statement);
                }
                delete this.statements[key];
                return statement;
            },
            disposeStatement: function (statement) {
                if (this.remove != null) {
                    var removeStatement = statement.context.createRuntime(this.remove);
                    removeStatement.activate();
                    removeStatement.deactivate();
                }
                statement.deactivate();
            },
            summarize: function (changes) {
                var ignoreProperty = ion.bind(function (name) {
                        if (!(name != null)) {
                            return true;
                        }
                        if (name[0] === '_') {
                            return true;
                        }
                        if (name === 'length' && this.type === 'ForOfStatement') {
                            return true;
                        }
                        return false;
                    }, this);
                var map = new Map();
                for (var _i = 0; _i < changes.length; _i++) {
                    var _ref = changes[_i];
                    var type = _ref.type;
                    var object = _ref.object;
                    var name = _ref.name;
                    var oldValue = _ref.oldValue;
                    if (object === this.collection) {
                        if (!ignoreProperty(name)) {
                            if (!map.has(name)) {
                                map.set(name, {
                                    type: type,
                                    object: object,
                                    name: name,
                                    oldValue: oldValue
                                });
                            } else {
                                var change = map.get(name);
                                change.type = type;
                            }
                        }
                    }
                }
                var array = [];
                map.forEach(function (change, name, object) {
                    var newValue = change.object[name];
                    if (newValue !== change.oldValue) {
                        delete change.object;
                        array.push(change);
                    }
                });
                return array;
            },
            applyChanges: function (changes) {
                var originalChanges = changes;
                changes = this.summarize(changes);
                if (changes.length === 0) {
                    return;
                }
                var getRecycleKey = ion.bind(function (key, value) {
                        return this.type === 'ForOfStatement' ? value : key;
                    }, this);
                var canRecycle = true;
                if (!canRecycle) {
                    for (var _i2 = 0; _i2 < changes.length; _i2++) {
                        var _ref2 = changes[_i2];
                        var name = _ref2.name;
                        var type = _ref2.type;
                        var oldValue = _ref2.oldValue;
                        var newValue = this.collection != null ? this.collection[name] : void 0;
                        var key = this.toKey(name);
                        if (oldValue !== void 0) {
                            this.removeItem(key, oldValue);
                        }
                        if (newValue !== void 0) {
                            this.addItem(key, newValue);
                        }
                    }
                } else {
                    var recyclableStatements = new Map();
                    var activateStatements = [];
                    for (var _i3 = 0; _i3 < changes.length; _i3++) {
                        var _ref3 = changes[_i3];
                        var name = _ref3.name;
                        var oldValue = _ref3.oldValue;
                        var key = this.toKey(name);
                        if (oldValue !== void 0) {
                            var rkey = getRecycleKey(key, oldValue);
                            var statement = this.statements[key];
                            if (statement != null) {
                                delete this.statements[key];
                                recyclableStatements.set(rkey, statement);
                            }
                        }
                    }
                    var contextsToUpdateOrder = [];
                    for (var _i4 = 0; _i4 < changes.length; _i4++) {
                        var _ref4 = changes[_i4];
                        var name = _ref4.name;
                        var oldValue = _ref4.oldValue;
                        var newValue = this.collection != null ? this.collection[name] : void 0;
                        var key = this.toKey(name);
                        if (newValue !== void 0) {
                            var rkey = getRecycleKey(key, newValue);
                            var statement = recyclableStatements.get(rkey);
                            if (statement != null) {
                                var context = statement.context;
                                if (this.type === 'ForOfStatement') {
                                    if (this.keyName != null) {
                                        context.variables[this.keyName].setValue(key);
                                    }
                                    contextsToUpdateOrder.push([
                                        key,
                                        context
                                    ]);
                                } else {
                                    if (this.valueName != null) {
                                        context.variables[this.valueName].setValue(newValue);
                                    }
                                }
                                this.statements[key] = statement;
                                recyclableStatements.delete(rkey);
                            } else {
                                statement = this.addItem(key, newValue, false);
                                if (statement != null) {
                                    activateStatements.push(statement);
                                }
                            }
                        }
                    }
                    recyclableStatements.forEach(ion.bind(function (statement) {
                        this.disposeStatement(statement);
                    }, this));
                    for (var _i5 = 0; _i5 < contextsToUpdateOrder.length; _i5++) {
                        var _ref5 = contextsToUpdateOrder[_i5];
                        var key = _ref5[0];
                        var context = _ref5[1];
                        var oldOrder = context.order;
                        var newOrder = this.getOrderForKey(key);
                        context.order = this.getOrderForKey(key);
                    }
                    this.context.inserter != null ? this.context.inserter.update() : void 0;
                    for (var _i6 = 0; _i6 < activateStatements.length; _i6++) {
                        var statement = activateStatements[_i6];
                        statement.activate();
                    }
                }
            }
        }
    }, Statement);
module.exports = exports = ForInOfStatement;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/runtime/ForInOfStatement',_ion_runtime_ForInOfStatement_);
    else
      _ion_runtime_ForInOfStatement_.call(this, module, exports, require);
  }
  else {
    _ion_runtime_ForInOfStatement_.call(this);
  }
}).call(this)
void (function(){var _ion_runtime_IfStatement_ = function(module,exports,require){'use strict';
var ion = require('../'), _ref;
_ref = require('./');
var Statement = _ref.Statement;
var Factory = _ref.Factory;
var counter = 0;
var getCounter = function () {
    return counter++;
};
var IfStatement = ion.defineClass({
        name: 'IfStatement',
        constructor: function IfStatement() {
            IfStatement.super.apply(this, arguments);
            this.id = getCounter();
        },
        properties: {
            activate: function () {
                IfStatement.super.prototype.activate.apply(this, arguments);
                this.testExpression = this.testExpression != null ? this.testExpression : this.context.createRuntime(this.test);
                this.unobserve = this.testExpression.observe(this.testExpressionObserver = this.testExpressionObserver != null ? this.testExpressionObserver : ion.bind(function (value) {
                    if (value) {
                        if (!(this.consequentStatement != null ? this.consequentStatement.isActive : void 0)) {
                            if (this.alternateStatement != null ? this.alternateStatement.isActive : void 0) {
                                this.alternateStatement.deactivate();
                                this.alternateStatement = null;
                            }
                            var context = this.context.newContext(null, this.order);
                            this.consequentStatement = context.createRuntime(this.consequent);
                            this.consequentStatement.activate();
                        }
                    } else {
                        if (!(this.alternateStatement != null ? this.alternateStatement.isActive : void 0)) {
                            if (this.consequentStatement != null ? this.consequentStatement.isActive : void 0) {
                                this.consequentStatement.deactivate();
                                this.consequentStatement = null;
                            }
                            if (this.alternate != null) {
                                var context = this.context.newContext(null, this.order);
                                this.alternateStatement = context.createRuntime(this.alternate);
                                this.alternateStatement.activate();
                            }
                        }
                    }
                }, this));
            },
            deactivate: function () {
                IfStatement.super.prototype.deactivate.apply(this, arguments);
                this.unobserve != null ? this.unobserve() : void 0;
                if (this.alternateStatement != null ? this.alternateStatement.isActive : void 0) {
                    this.alternateStatement != null ? this.alternateStatement.deactivate() : void 0;
                    this.alternateStatement = null;
                }
                if (this.consequentStatement != null ? this.consequentStatement.isActive : void 0) {
                    this.consequentStatement != null ? this.consequentStatement.deactivate() : void 0;
                    this.consequentStatement = null;
                }
            }
        }
    }, Statement);
module.exports = exports = IfStatement;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/runtime/IfStatement',_ion_runtime_IfStatement_);
    else
      _ion_runtime_IfStatement_.call(this, module, exports, require);
  }
  else {
    _ion_runtime_IfStatement_.call(this);
  }
}).call(this)
void (function(){var _ion_runtime_Literal_ = function(module,exports,require){'use strict';
var ion = require('../');
var noop = function () {
};
var Literal = ion.defineClass({
        name: 'Literal',
        properties: {
            mutable: false,
            observe: function (observer) {
                observer(this.value);
                return noop;
            }
        }
    }, require('./Expression'));
module.exports = exports = Literal;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/runtime/Literal',_ion_runtime_Literal_);
    else
      _ion_runtime_Literal_.call(this, module, exports, require);
  }
  else {
    _ion_runtime_Literal_.call(this);
  }
}).call(this)
void (function(){var _ion_runtime_MemberExpression_ = function(module,exports,require){'use strict';
var ion = require('../'), _ref;
_ref = require('./');
var DynamicExpression = _ref.DynamicExpression;
var Factory = _ref.Factory;
var MemberExpression = ion.defineClass({
        name: 'MemberExpression',
        properties: {
            activate: function () {
                MemberExpression.super.prototype.activate.apply(this, arguments);
                this.objectExpression = this.objectExpression != null ? this.objectExpression : this.context.createRuntime(this.object);
                this.propertyExpression = this.propertyExpression != null ? this.propertyExpression : this.context.createRuntime(this.computed ? this.property : this.property.name);
                this.unobserveProperty = this.propertyExpression.observe(this.propertyWatcher = this.propertyWatcher != null ? this.propertyWatcher : ion.bind(function (propertyValue) {
                    propertyValue = propertyValue != null ? propertyValue.toString() : void 0;
                    if (this.propertyValue !== propertyValue) {
                        this.propertyValue = propertyValue;
                        this.queueUpdate('propertyChanged');
                    }
                }, this));
                this.unobserveObject = this.objectExpression.observe(this.objectWatcher = this.objectWatcher != null ? this.objectWatcher : ion.bind(function (objectValue) {
                    if (this.objectValue !== objectValue) {
                        this.objectValue = objectValue;
                        this.queueUpdate('objectChanged');
                    }
                }, this));
                this.updateValue();
            },
            deactivate: function () {
                MemberExpression.super.prototype.deactivate.apply(this, arguments);
                this.unobserveObject != null ? this.unobserveObject() : void 0;
                this.unobserveObject = null;
                this.unobserveProperty != null ? this.unobserveProperty() : void 0;
                this.unobserveProperty = null;
                this.unobserveObjectValue != null ? this.unobserveObjectValue() : void 0;
                this.unobserveObjectValue = null;
            },
            queueUpdate: function (reason) {
                ion.nextCheck(this.boundUpdate = this.boundUpdate != null ? this.boundUpdate : this.updateValue.bind(this));
            },
            updateValue: function () {
                var value = void 0;
                if (this.objectValue != null) {
                    if (this.propertyValue != null) {
                        value = this.objectValue[this.propertyValue];
                    }
                } else if (this.isActive && !this.existential && (this.loc != null ? this.loc.start != null ? this.loc.start.source : void 0 : void 0) != null && this.hasOwnProperty('objectValue') && this.hasOwnProperty('propertyValue')) {
                    console.warn('Cannot read ' + Factory.toCode(this.property) + ' property of ' + this.objectValue + ' (' + Factory.toCode(this.object) + ') (' + this.loc.start.source + ':' + this.loc.start.line + ':' + (this.loc.start.column + 1) + ')');
                }
                this.setValue(value);
                if (this.objectExpression.mutable && (this.observedObject !== this.objectValue || this.observedProperty !== this.propertyValue)) {
                    this.observedObject = this.objectValue;
                    this.observedProperty = this.propertyValue;
                    var oldUnobserveObjectValue = this.unobserveObjectValue;
                    this.unobserveObjectValue = null;
                    if (this.objectValue != null) {
                        this.unobserveObjectValue = ion.observe(this.objectValue, ion.bind(function (changes) {
                            this.queueUpdate('objectValueChanged');
                        }, this), { property: this.propertyValue });
                    }
                    oldUnobserveObjectValue != null ? oldUnobserveObjectValue() : void 0;
                }
            }
        },
        test: function () {
        }
    }, DynamicExpression);
module.exports = exports = MemberExpression;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/runtime/MemberExpression',_ion_runtime_MemberExpression_);
    else
      _ion_runtime_MemberExpression_.call(this, module, exports, require);
  }
  else {
    _ion_runtime_MemberExpression_.call(this);
  }
}).call(this)
void (function(){var _ion_runtime_Node_ = function(module,exports,require){'use strict';
var ion = require('../');
var Node = ion.defineClass({
        name: 'Node',
        properties: {
            toCode: function () {
                return require('./Factory').toCode(this.ast);
            }
        }
    });
module.exports = exports = Node;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/runtime/Node',_ion_runtime_Node_);
    else
      _ion_runtime_Node_.call(this, module, exports, require);
  }
  else {
    _ion_runtime_Node_.call(this);
  }
}).call(this)
void (function(){var _ion_runtime_ObjectExpression_ = function(module,exports,require){'use strict';
var ion = require('../'), DynamicExpression = require('./DynamicExpression');
var ObjectExpression = ion.defineClass({
        name: 'ObjectExpression',
        properties: {
            setLeftValue: function (value) {
                this.value = value;
            },
            activate: function () {
                ObjectExpression.super.prototype.activate.apply(this, arguments);
                this.typeExpression = this.typeExpression != null ? this.typeExpression : this.context.createRuntime(this.objectType != null ? this.objectType : null);
                this.unobserve = this.typeExpression.observe(this.typeWatcher = this.typeWatcher != null ? this.typeWatcher : ion.bind(function (value) {
                    if (!this.value || value != null) {
                        this.statements != null ? this.statements.deactivate() : void 0;
                        this.statements = null;
                        value = value != null ? value : {};
                    } else {
                        value = this.value;
                    }
                    if (!(this.statements != null)) {
                        var context = this.context.newContext(value);
                        context.setFastInsert(true);
                        this.statements = context.createRuntime({
                            type: 'BlockStatement',
                            body: this.properties
                        });
                        this.statements.activate();
                        context.setFastInsert(false);
                    }
                    this.setValue(value);
                }, this));
            },
            deactivate: function () {
                ObjectExpression.super.prototype.deactivate.apply(this, arguments);
                this.statements != null ? this.statements.deactivate() : void 0;
                this.unobserve();
            }
        }
    }, DynamicExpression);
module.exports = exports = ObjectExpression;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/runtime/ObjectExpression',_ion_runtime_ObjectExpression_);
    else
      _ion_runtime_ObjectExpression_.call(this, module, exports, require);
  }
  else {
    _ion_runtime_ObjectExpression_.call(this);
  }
}).call(this)
void (function(){var _ion_runtime_OperationExpression_ = function(module,exports,require){'use strict';
var ion = require('../'), DynamicExpression = require('./DynamicExpression');
var OperationExpression = ion.defineClass({
        name: 'OperationExpression',
        constructor: function OperationExpression(properties) {
            OperationExpression.super.apply(this, arguments);
            if (!(this.args != null)) {
                if (this.type === 'BinaryExpression') {
                    this.args = [
                        this.left,
                        this.right
                    ];
                } else if (this.type === 'UnaryExpression') {
                    this.args = [this.argument];
                } else if (this.type === 'ConditionalExpression') {
                    this.args = [
                        this.test,
                        this.consequent,
                        this.alternate
                    ];
                }
            }
        },
        properties: {
            args: null,
            activate: function () {
                OperationExpression.super.prototype.activate.apply(this, arguments);
                this.argumentExpressions = this.argumentExpressions != null ? this.argumentExpressions : this.context.createRuntime({
                    type: 'ArrayExpression',
                    elements: this.args,
                    observeElements: this.factory.observe
                });
                this.unobserve = this.argumentExpressions.observe(this.observer = this.observer != null ? this.observer : ion.bind(function (value) {
                    this.argumentValues = value;
                    this.evaluate();
                }, this));
            },
            deactivate: function () {
                OperationExpression.super.prototype.deactivate.apply(this, arguments);
                this.unobserve();
            },
            evaluate: function () {
                if (!(this.factory.evaluate != null)) {
                    throw new Error('evaluate method not defined for operation: ' + this.factory);
                }
                var value = this.factory.evaluate.apply(this.context, this.argumentValues);
                this.setValue(value);
            }
        }
    }, DynamicExpression);
module.exports = OperationExpression;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/runtime/OperationExpression',_ion_runtime_OperationExpression_);
    else
      _ion_runtime_OperationExpression_.call(this, module, exports, require);
  }
  else {
    _ion_runtime_OperationExpression_.call(this);
  }
}).call(this)
void (function(){var _ion_runtime_Property_ = function(module,exports,require){'use strict';
var ion = require('../'), Statement = require('./Statement');
var Property = ion.defineClass({
        name: 'Property',
        properties: {
            activate: function () {
                Property.super.prototype.activate.apply(this, arguments);
                this.keyExpression = this.keyExpression != null ? this.keyExpression : this.context.createRuntime(this.computed ? this.key : this.key.name != null ? this.key.name : this.key.value);
                this.valueExpression = this.valueExpression != null ? this.valueExpression : this.context.createRuntime(this.value);
                this.unobserveKey = this.keyExpression.observe(this.keyWatcher = this.keyWatcher != null ? this.keyWatcher : ion.bind(function (key) {
                    if (key != null && this.valueExpression.setLeftValue != null) {
                        var currentValue = this.context.output ? this.context.output != null ? this.context.output[key] : void 0 : this.context.get(key);
                        if (currentValue != null) {
                            this.valueExpression.setLeftValue(currentValue);
                        }
                    }
                    this.keyValue = key;
                    this.setProperty();
                }, this));
                this.unobserveValue = this.valueExpression.observe(this.valueWatcher = this.valueWatcher != null ? this.valueWatcher : ion.bind(function (value) {
                    this.valueValue = value;
                    this.setProperty();
                }, this));
            },
            deactivate: function () {
                Property.super.prototype.deactivate.apply(this, arguments);
                this.unobserveKey != null ? this.unobserveKey() : void 0;
                this.unobserveKey = null;
                this.unobserveValue != null ? this.unobserveValue() : void 0;
                this.unobserveValue = null;
                this.restoreInitialPropertyValue != null ? this.restoreInitialPropertyValue() : void 0;
                this.restoreInitialPropertyValue = null;
            },
            setOutputValue: function (key, value) {
                this.context.output[key] = this.lastAssignedValue = value;
            },
            setProperty: function (key, value) {
                if (key == null)
                    key = this.keyValue;
                if (value == null)
                    value = this.valueValue;
                if (this.hasOwnProperty('keyValue') && this.hasOwnProperty('valueValue')) {
                    if (key != null && this.context.output != null) {
                        var initialValue = this.context.output[key];
                        if (!(this.restoreInitialPropertyValue != null)) {
                            var initialHasProperty = this.context.output.hasOwnProperty(key);
                            var descriptor = Object.getOwnPropertyDescriptor(this.context.output, key);
                            this.restoreInitialPropertyValue = function () {
                                if (this.context.output[key] === this.lastAssignedValue) {
                                    if ((descriptor != null ? descriptor.configurable : void 0) !== false) {
                                        delete this.context.output[key];
                                    } else {
                                        this.context.output[key] = initialValue;
                                    }
                                }
                            };
                        }
                        if (initialValue !== value) {
                            this.setOutputValue(key, value);
                        }
                    }
                }
            }
        }
    }, Statement);
module.exports = exports = Property;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/runtime/Property',_ion_runtime_Property_);
    else
      _ion_runtime_Property_.call(this, module, exports, require);
  }
  else {
    _ion_runtime_Property_.call(this);
  }
}).call(this)
void (function(){var _ion_runtime_ReturnStatement_ = function(module,exports,require){'use strict';
var ion = require('../'), Statement = require('./Statement');
var ReturnStatement = ion.defineClass({
        name: 'ReturnStatement',
        properties: {
            activate: function () {
                ReturnStatement.super.prototype.activate.apply(this, arguments);
                this.argumentExpression = this.argumentExpression != null ? this.argumentExpression : this.context.createRuntime(this.argument);
                this.unobserve = this.argumentExpression.observe(this.argumentWatcher = this.argumentWatcher != null ? this.argumentWatcher : ion.bind(function (value) {
                    return this.context.returnExpression.setValue(value);
                }, this));
            },
            deactivate: function () {
                ReturnStatement.super.prototype.deactivate.apply(this, arguments);
                this.argumentWatcher != null ? this.argumentWatcher(void 0) : void 0;
                this.argumentWatcher = null;
                this.unobserve != null ? this.unobserve() : void 0;
                this.unobserve = null;
            }
        }
    }, Statement);
module.exports = exports = ReturnStatement;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/runtime/ReturnStatement',_ion_runtime_ReturnStatement_);
    else
      _ion_runtime_ReturnStatement_.call(this, module, exports, require);
  }
  else {
    _ion_runtime_ReturnStatement_.call(this);
  }
}).call(this)
void (function(){var _ion_runtime_Statement_ = function(module,exports,require){'use strict';
var ion = require('../');
var Statement = ion.defineClass({
        name: 'Statement',
        properties: {
            isActive: false,
            activate: function () {
                this.isActive = true;
            },
            deactivate: function () {
                this.isActive = false;
            }
        }
    }, require('./Node'));
module.exports = exports = Statement;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/runtime/Statement',_ion_runtime_Statement_);
    else
      _ion_runtime_Statement_.call(this, module, exports, require);
  }
  else {
    _ion_runtime_Statement_.call(this);
  }
}).call(this)
void (function(){var _ion_runtime_Template_ = function(module,exports,require){'use strict';
var ion = require('../'), BlockStatement = require('./BlockStatement'), DynamicExpression = require('./DynamicExpression'), noop = function () {
    };
var count = 0;
var Template = ion.defineClass({
        name: 'Template',
        constructor: function Template() {
            Template.super.apply(this, arguments);
            this.context.returnExpression = new DynamicExpression();
        },
        properties: {
            observe: function (watcher) {
                if (watcher == null)
                    watcher = noop;
                if (!this.isActive) {
                    this.activate();
                }
                var unobserve = this.context.returnExpression.observe(watcher);
                return ion.bind(function () {
                    unobserve();
                    if (!this.context.returnExpression.isActive) {
                        this.deactivate();
                    }
                }, this);
            },
            activate: function () {
                Template.super.prototype.activate.apply(this, arguments);
                count++;
            },
            deactivate: function () {
                Template.super.prototype.deactivate.apply(this, arguments);
                count--;
            },
            toString: function () {
                return this.id != null ? 'Template ' + this.id.name : 'Template';
            }
        }
    }, BlockStatement);
module.exports = exports = Template;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/runtime/Template',_ion_runtime_Template_);
    else
      _ion_runtime_Template_.call(this, module, exports, require);
  }
  else {
    _ion_runtime_Template_.call(this);
  }
}).call(this)
void (function(){var _ion_runtime_UndoStatement_ = function(module,exports,require){'use strict';
var ion = require('../'), _ref;
_ref = require('./');
var Factory = _ref.Factory;
var Statement = _ref.Statement;
var UndoStatement = ion.defineClass({
        name: 'UndoStatement',
        properties: {
            activate: function () {
                UndoStatement.super.prototype.activate.apply(this, arguments);
                this.calleeExpression = this.calleeExpression != null ? this.calleeExpression : this.context.createRuntime(this.callee);
                this.unobserveCallee = this.calleeExpression.observe(this.calleeWatcher = this.calleeWatcher != null ? this.calleeWatcher : ion.bind(function (value) {
                    return this.calleeValue = value;
                }, this));
            },
            deactivate: function () {
                UndoStatement.super.prototype.deactivate.apply(this, arguments);
                this.calleeValue != null ? this.calleeValue() : void 0;
                this.unobserveCallee != null ? this.unobserveCallee() : void 0;
            }
        }
    }, Statement);
module.exports = exports = UndoStatement;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/runtime/UndoStatement',_ion_runtime_UndoStatement_);
    else
      _ion_runtime_UndoStatement_.call(this, module, exports, require);
  }
  else {
    _ion_runtime_UndoStatement_.call(this);
  }
}).call(this)
void (function(){var _ion_runtime_VariableDeclaration_ = function(module,exports,require){'use strict';
var ion = require('../');
var Statement = require('./Statement');
var noop = function () {
};
var VariableDeclaration = ion.defineClass({
        name: 'VariableDeclaration',
        constructor: function VariableDeclaration() {
            VariableDeclaration.super.apply(this, arguments);
            var _ref4 = [];
            {
                var _ref = this.declarations;
                for (var _i = 0; _i < _ref.length; _i++) {
                    var _ref6 = _ref[_i];
                    var name = _ref6.id.name;
                    var init = _ref6.init;
                    _ref4.push(this.context.setVariableFromAst(name, init));
                }
            }
            this.expressions = _ref4;
        },
        properties: {
            activate: function () {
                var _ref5 = [];
                {
                    var _ref2 = this.expressions;
                    for (var _i2 = 0; _i2 < _ref2.length; _i2++) {
                        var expression = _ref2[_i2];
                        _ref5.push(expression.observe(noop));
                    }
                }
                this.unobserves = _ref5;
            },
            deactivate: function () {
                {
                    var _ref3 = this.unobserves;
                    for (var _i3 = 0; _i3 < _ref3.length; _i3++) {
                        var unobserve = _ref3[_i3];
                        unobserve();
                    }
                }
                this.unobserves = null;
            }
        }
    }, Statement);
module.exports = exports = VariableDeclaration;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/runtime/VariableDeclaration',_ion_runtime_VariableDeclaration_);
    else
      _ion_runtime_VariableDeclaration_.call(this, module, exports, require);
  }
  else {
    _ion_runtime_VariableDeclaration_.call(this);
  }
}).call(this)
void (function(){var _ion_runtime_index_ = function(module,exports,require){Object.defineProperty(exports, 'ArrayExpression', {get:function(){ return require('./ArrayExpression') }, enumerable: true}) 
Object.defineProperty(exports, 'BlockStatement', {get:function(){ return require('./BlockStatement') }, enumerable: true}) 
Object.defineProperty(exports, 'CallExpression', {get:function(){ return require('./CallExpression') }, enumerable: true}) 
Object.defineProperty(exports, 'ConditionalExpression', {get:function(){ return require('./ConditionalExpression') }, enumerable: true}) 
Object.defineProperty(exports, 'Context', {get:function(){ return require('./Context') }, enumerable: true}) 
Object.defineProperty(exports, 'DynamicExpression', {get:function(){ return require('./DynamicExpression') }, enumerable: true}) 
Object.defineProperty(exports, 'Expression', {get:function(){ return require('./Expression') }, enumerable: true}) 
Object.defineProperty(exports, 'ExpressionStatement', {get:function(){ return require('./ExpressionStatement') }, enumerable: true}) 
Object.defineProperty(exports, 'Factory', {get:function(){ return require('./Factory') }, enumerable: true}) 
Object.defineProperty(exports, 'ForInOfStatement', {get:function(){ return require('./ForInOfStatement') }, enumerable: true}) 
Object.defineProperty(exports, 'IfStatement', {get:function(){ return require('./IfStatement') }, enumerable: true}) 
Object.defineProperty(exports, 'Literal', {get:function(){ return require('./Literal') }, enumerable: true}) 
Object.defineProperty(exports, 'MemberExpression', {get:function(){ return require('./MemberExpression') }, enumerable: true}) 
Object.defineProperty(exports, 'Node', {get:function(){ return require('./Node') }, enumerable: true}) 
Object.defineProperty(exports, 'ObjectExpression', {get:function(){ return require('./ObjectExpression') }, enumerable: true}) 
Object.defineProperty(exports, 'OperationExpression', {get:function(){ return require('./OperationExpression') }, enumerable: true}) 
Object.defineProperty(exports, 'Property', {get:function(){ return require('./Property') }, enumerable: true}) 
Object.defineProperty(exports, 'ReturnStatement', {get:function(){ return require('./ReturnStatement') }, enumerable: true}) 
Object.defineProperty(exports, 'Statement', {get:function(){ return require('./Statement') }, enumerable: true}) 
Object.defineProperty(exports, 'Template', {get:function(){ return require('./Template') }, enumerable: true}) 
Object.defineProperty(exports, 'UndoStatement', {get:function(){ return require('./UndoStatement') }, enumerable: true}) 
Object.defineProperty(exports, 'VariableDeclaration', {get:function(){ return require('./VariableDeclaration') }, enumerable: true}) 
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/runtime/index',_ion_runtime_index_);
    else
      _ion_runtime_index_.call(this, module, exports, require);
  }
  else {
    _ion_runtime_index_.call(this);
  }
}).call(this)
void (function(){var _ion_test_duplicateDeclares_ = function(module,exports,require){'use strict';
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/test/duplicateDeclares',_ion_test_duplicateDeclares_);
    else
      _ion_test_duplicateDeclares_.call(this, module, exports, require);
  }
  else {
    _ion_test_duplicateDeclares_.call(this);
  }
}).call(this)
void (function(){var _ion_test_es6Scoping_ = function(module,exports,require){'use strict';
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/test/es6Scoping',_ion_test_es6Scoping_);
    else
      _ion_test_es6Scoping_.call(this, module, exports, require);
  }
  else {
    _ion_test_es6Scoping_.call(this);
  }
}).call(this)
void (function(){var _ion_test_immediateTemplates_ = function(module,exports,require){'use strict';
var ion = require('../');
var templates = [
        [
            ion.template(function () {
                return ion.createRuntime({
                    type: 'Template',
                    id: null,
                    body: [
                        {
                            type: 'VariableDeclaration',
                            declarations: [
                                {
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'a',
                                        loc: {
                                            start: {
                                                line: 7,
                                                column: 16,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            },
                                            end: {
                                                line: 7,
                                                column: 17,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'Literal',
                                        value: 1
                                    }
                                },
                                {
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'b',
                                        loc: {
                                            start: {
                                                line: 8,
                                                column: 16,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            },
                                            end: {
                                                line: 8,
                                                column: 17,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'Literal',
                                        value: 2
                                    }
                                },
                                {
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'c',
                                        loc: {
                                            start: {
                                                line: 9,
                                                column: 16,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            },
                                            end: {
                                                line: 9,
                                                column: 17,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'BinaryExpression',
                                        operator: '+',
                                        left: {
                                            type: 'Identifier',
                                            name: 'a',
                                            loc: {
                                                start: {
                                                    line: 9,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'ion/test/immediateTemplates.ion'
                                                },
                                                end: {
                                                    line: 9,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'ion/test/immediateTemplates.ion'
                                                }
                                            }
                                        },
                                        right: {
                                            type: 'Identifier',
                                            name: 'b',
                                            loc: {
                                                start: {
                                                    line: 9,
                                                    column: 24,
                                                    fixed: true,
                                                    source: 'ion/test/immediateTemplates.ion'
                                                },
                                                end: {
                                                    line: 9,
                                                    column: 25,
                                                    fixed: true,
                                                    source: 'ion/test/immediateTemplates.ion'
                                                }
                                            }
                                        }
                                    }
                                }
                            ],
                            kind: 'const',
                            order: '0'
                        },
                        {
                            type: 'ReturnStatement',
                            argument: {
                                type: 'Identifier',
                                name: 'c',
                                loc: {
                                    start: {
                                        line: 10,
                                        column: 19,
                                        fixed: true,
                                        source: 'ion/test/immediateTemplates.ion'
                                    },
                                    end: {
                                        line: 10,
                                        column: 20,
                                        fixed: true,
                                        source: 'ion/test/immediateTemplates.ion'
                                    }
                                }
                            },
                            order: '1'
                        }
                    ],
                    bound: false
                }, {
                    this: this,
                    ion: ion,
                    templates: templates,
                    test: test
                }, null);
            }),
            [],
            3
        ],
        [
            ion.template(function (rows) {
                return ion.createRuntime({
                    type: 'Template',
                    id: null,
                    body: [{
                            type: 'ReturnStatement',
                            argument: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'ArrayExpression',
                                    elements: []
                                },
                                properties: [{
                                        type: 'ForOfStatement',
                                        left: {
                                            type: 'VariableDeclaration',
                                            declarations: [{
                                                    type: 'VariableDeclarator',
                                                    id: {
                                                        type: 'Identifier',
                                                        name: 'item',
                                                        loc: {
                                                            start: {
                                                                line: 16,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'ion/test/immediateTemplates.ion'
                                                            },
                                                            end: {
                                                                line: 16,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'ion/test/immediateTemplates.ion'
                                                            }
                                                        }
                                                    },
                                                    init: null
                                                }],
                                            kind: 'let'
                                        },
                                        right: {
                                            type: 'Identifier',
                                            name: 'rows',
                                            loc: {
                                                start: {
                                                    line: 16,
                                                    column: 28,
                                                    fixed: true,
                                                    source: 'ion/test/immediateTemplates.ion'
                                                },
                                                end: {
                                                    line: 16,
                                                    column: 32,
                                                    fixed: true,
                                                    source: 'ion/test/immediateTemplates.ion'
                                                }
                                            }
                                        },
                                        body: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'IfStatement',
                                                    test: {
                                                        type: 'UnaryExpression',
                                                        operator: '?',
                                                        argument: {
                                                            type: 'Identifier',
                                                            name: 'item',
                                                            loc: {
                                                                start: {
                                                                    line: 17,
                                                                    column: 23,
                                                                    fixed: true,
                                                                    source: 'ion/test/immediateTemplates.ion'
                                                                },
                                                                end: {
                                                                    line: 17,
                                                                    column: 27,
                                                                    fixed: true,
                                                                    source: 'ion/test/immediateTemplates.ion'
                                                                }
                                                            }
                                                        }
                                                    },
                                                    consequent: {
                                                        type: 'BlockStatement',
                                                        body: [{
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'item',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 18,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'ion/test/immediateTemplates.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 18,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'ion/test/immediateTemplates.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'toString',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 18,
                                                                                    column: 29,
                                                                                    fixed: true,
                                                                                    source: 'ion/test/immediateTemplates.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 18,
                                                                                    column: 37,
                                                                                    fixed: true,
                                                                                    source: 'ion/test/immediateTemplates.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 18,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'ion/test/immediateTemplates.ion'
                                                                            },
                                                                            end: {
                                                                                line: 18,
                                                                                column: 37,
                                                                                fixed: true,
                                                                                source: 'ion/test/immediateTemplates.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [],
                                                                    loc: {
                                                                        start: {
                                                                            line: 18,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'ion/test/immediateTemplates.ion'
                                                                        },
                                                                        end: {
                                                                            line: 18,
                                                                            column: 39,
                                                                            fixed: true,
                                                                            source: 'ion/test/immediateTemplates.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 18,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'ion/test/immediateTemplates.ion'
                                                                    },
                                                                    end: {
                                                                        line: 18,
                                                                        column: 39,
                                                                        fixed: true,
                                                                        source: 'ion/test/immediateTemplates.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    alternate: {
                                                        type: 'BlockStatement',
                                                        body: [{
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'Literal',
                                                                    value: '<null>'
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 20,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'ion/test/immediateTemplates.ion'
                                                                    },
                                                                    end: {
                                                                        line: 20,
                                                                        column: 32,
                                                                        fixed: true,
                                                                        source: 'ion/test/immediateTemplates.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        remove: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'UnaryExpression',
                                                        operator: 'void',
                                                        argument: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'rows',
                                                                loc: {
                                                                    start: {
                                                                        line: 23,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'ion/test/immediateTemplates.ion'
                                                                    },
                                                                    end: {
                                                                        line: 23,
                                                                        column: 29,
                                                                        fixed: true,
                                                                        source: 'ion/test/immediateTemplates.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'length',
                                                                loc: {
                                                                    start: {
                                                                        line: 23,
                                                                        column: 30,
                                                                        fixed: true,
                                                                        source: 'ion/test/immediateTemplates.ion'
                                                                    },
                                                                    end: {
                                                                        line: 23,
                                                                        column: 36,
                                                                        fixed: true,
                                                                        source: 'ion/test/immediateTemplates.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 23,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'ion/test/immediateTemplates.ion'
                                                                },
                                                                end: {
                                                                    line: 23,
                                                                    column: 36,
                                                                    fixed: true,
                                                                    source: 'ion/test/immediateTemplates.ion'
                                                                }
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 23,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'ion/test/immediateTemplates.ion'
                                                        },
                                                        end: {
                                                            line: 23,
                                                            column: 36,
                                                            fixed: true,
                                                            source: 'ion/test/immediateTemplates.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        order: '0'
                                    }]
                            },
                            order: '0'
                        }],
                    bound: false
                }, {
                    this: this,
                    rows: rows,
                    ion: ion,
                    templates: templates,
                    test: test
                }, null);
            }),
            [[
                    1,
                    null,
                    2,
                    3,
                    null,
                    4
                ]],
            [
                '1',
                '<null>',
                '2',
                '3',
                '<null>',
                '4'
            ]
        ],
        [
            ion.template(function () {
                return ion.createRuntime({
                    type: 'Template',
                    id: null,
                    body: [{
                            type: 'ReturnStatement',
                            argument: {
                                type: 'ObjectExpression',
                                properties: [
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'a',
                                            loc: {
                                                start: {
                                                    line: 34,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'ion/test/immediateTemplates.ion'
                                                },
                                                end: {
                                                    line: 34,
                                                    column: 22,
                                                    fixed: true,
                                                    source: 'ion/test/immediateTemplates.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: 1
                                        },
                                        kind: 'init',
                                        order: '0'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'b',
                                            loc: {
                                                start: {
                                                    line: 34,
                                                    column: 25,
                                                    fixed: true,
                                                    source: 'ion/test/immediateTemplates.ion'
                                                },
                                                end: {
                                                    line: 34,
                                                    column: 26,
                                                    fixed: true,
                                                    source: 'ion/test/immediateTemplates.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: 2
                                        },
                                        kind: 'init',
                                        order: '1'
                                    }
                                ]
                            },
                            order: '0'
                        }],
                    bound: false
                }, {
                    this: this,
                    ion: ion,
                    templates: templates,
                    test: test
                }, null);
            }),
            [],
            {
                a: 1,
                b: 2
            }
        ],
        [
            ion.template(function () {
                return ion.createRuntime({
                    type: 'Template',
                    id: null,
                    body: [{
                            type: 'ReturnStatement',
                            argument: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'ArrayExpression',
                                    elements: []
                                },
                                properties: [
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'Literal',
                                            value: 1
                                        },
                                        loc: {
                                            start: {
                                                line: 40,
                                                column: 16,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            },
                                            end: {
                                                line: 40,
                                                column: 17,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            }
                                        },
                                        order: '0'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'Literal',
                                            value: 2
                                        },
                                        loc: {
                                            start: {
                                                line: 41,
                                                column: 16,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            },
                                            end: {
                                                line: 41,
                                                column: 17,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            }
                                        },
                                        order: '1'
                                    }
                                ]
                            },
                            order: '0'
                        }],
                    bound: false
                }, {
                    this: this,
                    ion: ion,
                    templates: templates,
                    test: test
                }, null);
            }),
            [],
            [
                1,
                2
            ]
        ],
        [
            ion.template(function () {
                return ion.createRuntime({
                    type: 'Template',
                    id: null,
                    body: [
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'a',
                                        loc: {
                                            start: {
                                                line: 46,
                                                column: 16,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            },
                                            end: {
                                                line: 46,
                                                column: 17,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'Literal',
                                        value: 1
                                    }
                                }],
                            kind: 'let',
                            order: '0'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'b',
                                        loc: {
                                            start: {
                                                line: 47,
                                                column: 16,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            },
                                            end: {
                                                line: 47,
                                                column: 17,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'Literal',
                                        value: 2
                                    }
                                }],
                            kind: 'let',
                            order: '1'
                        },
                        {
                            type: 'ReturnStatement',
                            argument: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'ArrayExpression',
                                    elements: []
                                },
                                properties: [
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'Identifier',
                                            name: 'a',
                                            loc: {
                                                start: {
                                                    line: 49,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'ion/test/immediateTemplates.ion'
                                                },
                                                end: {
                                                    line: 49,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'ion/test/immediateTemplates.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 49,
                                                column: 16,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            },
                                            end: {
                                                line: 49,
                                                column: 17,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            }
                                        },
                                        order: '0'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'Identifier',
                                            name: 'b',
                                            loc: {
                                                start: {
                                                    line: 50,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'ion/test/immediateTemplates.ion'
                                                },
                                                end: {
                                                    line: 50,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'ion/test/immediateTemplates.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 50,
                                                column: 16,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            },
                                            end: {
                                                line: 50,
                                                column: 17,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            }
                                        },
                                        order: '1'
                                    },
                                    {
                                        type: 'IfStatement',
                                        test: {
                                            type: 'BinaryExpression',
                                            operator: '>',
                                            left: {
                                                type: 'Identifier',
                                                name: 'a',
                                                loc: {
                                                    start: {
                                                        line: 51,
                                                        column: 19,
                                                        fixed: true,
                                                        source: 'ion/test/immediateTemplates.ion'
                                                    },
                                                    end: {
                                                        line: 51,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'ion/test/immediateTemplates.ion'
                                                    }
                                                }
                                            },
                                            right: {
                                                type: 'Identifier',
                                                name: 'b',
                                                loc: {
                                                    start: {
                                                        line: 51,
                                                        column: 23,
                                                        fixed: true,
                                                        source: 'ion/test/immediateTemplates.ion'
                                                    },
                                                    end: {
                                                        line: 51,
                                                        column: 24,
                                                        fixed: true,
                                                        source: 'ion/test/immediateTemplates.ion'
                                                    }
                                                }
                                            }
                                        },
                                        consequent: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'Literal',
                                                        value: 10
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 52,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'ion/test/immediateTemplates.ion'
                                                        },
                                                        end: {
                                                            line: 52,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'ion/test/immediateTemplates.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        alternate: {
                                            type: 'IfStatement',
                                            test: {
                                                type: 'BinaryExpression',
                                                operator: '>',
                                                left: {
                                                    type: 'Identifier',
                                                    name: 'b',
                                                    loc: {
                                                        start: {
                                                            line: 53,
                                                            column: 24,
                                                            fixed: true,
                                                            source: 'ion/test/immediateTemplates.ion'
                                                        },
                                                        end: {
                                                            line: 53,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'ion/test/immediateTemplates.ion'
                                                        }
                                                    }
                                                },
                                                right: {
                                                    type: 'Identifier',
                                                    name: 'a',
                                                    loc: {
                                                        start: {
                                                            line: 53,
                                                            column: 28,
                                                            fixed: true,
                                                            source: 'ion/test/immediateTemplates.ion'
                                                        },
                                                        end: {
                                                            line: 53,
                                                            column: 29,
                                                            fixed: true,
                                                            source: 'ion/test/immediateTemplates.ion'
                                                        }
                                                    }
                                                }
                                            },
                                            consequent: {
                                                type: 'BlockStatement',
                                                body: [{
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'Literal',
                                                            value: 20
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 54,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'ion/test/immediateTemplates.ion'
                                                            },
                                                            end: {
                                                                line: 54,
                                                                column: 22,
                                                                fixed: true,
                                                                source: 'ion/test/immediateTemplates.ion'
                                                            }
                                                        },
                                                        order: '0'
                                                    }]
                                            },
                                            alternate: null
                                        },
                                        order: '2'
                                    }
                                ]
                            },
                            order: '2'
                        }
                    ],
                    bound: false
                }, {
                    this: this,
                    ion: ion,
                    templates: templates,
                    test: test
                }, null);
            }),
            [],
            [
                1,
                2,
                20
            ]
        ],
        [
            ion.template(function () {
                return ion.createRuntime({
                    type: 'Template',
                    id: null,
                    body: [
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'items',
                                        loc: {
                                            start: {
                                                line: 59,
                                                column: 16,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            },
                                            end: {
                                                line: 59,
                                                column: 21,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'ArrayExpression',
                                        elements: [
                                            {
                                                type: 'Literal',
                                                value: 1
                                            },
                                            {
                                                type: 'Literal',
                                                value: 2
                                            },
                                            {
                                                type: 'Literal',
                                                value: 3
                                            }
                                        ]
                                    }
                                }],
                            kind: 'let',
                            order: '0'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'x',
                                        loc: {
                                            start: {
                                                line: 60,
                                                column: 16,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            },
                                            end: {
                                                line: 60,
                                                column: 17,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'ObjectExpression',
                                        objectType: {
                                            type: 'ArrayExpression',
                                            elements: []
                                        },
                                        properties: [{
                                                type: 'ForOfStatement',
                                                left: {
                                                    type: 'VariableDeclaration',
                                                    declarations: [
                                                        {
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'item',
                                                                loc: {
                                                                    start: {
                                                                        line: 60,
                                                                        column: 38,
                                                                        fixed: true,
                                                                        source: 'ion/test/immediateTemplates.ion'
                                                                    },
                                                                    end: {
                                                                        line: 60,
                                                                        column: 42,
                                                                        fixed: true,
                                                                        source: 'ion/test/immediateTemplates.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: null
                                                        },
                                                        {
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'index',
                                                                loc: {
                                                                    start: {
                                                                        line: 60,
                                                                        column: 44,
                                                                        fixed: true,
                                                                        source: 'ion/test/immediateTemplates.ion'
                                                                    },
                                                                    end: {
                                                                        line: 60,
                                                                        column: 49,
                                                                        fixed: true,
                                                                        source: 'ion/test/immediateTemplates.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: null
                                                        }
                                                    ],
                                                    kind: 'let'
                                                },
                                                right: {
                                                    type: 'Identifier',
                                                    name: 'items',
                                                    loc: {
                                                        start: {
                                                            line: 60,
                                                            column: 53,
                                                            fixed: true,
                                                            source: 'ion/test/immediateTemplates.ion'
                                                        },
                                                        end: {
                                                            line: 60,
                                                            column: 58,
                                                            fixed: true,
                                                            source: 'ion/test/immediateTemplates.ion'
                                                        }
                                                    }
                                                },
                                                body: {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'BinaryExpression',
                                                        operator: '+',
                                                        left: {
                                                            type: 'Identifier',
                                                            name: 'item',
                                                            loc: {
                                                                start: {
                                                                    line: 60,
                                                                    column: 21,
                                                                    fixed: true,
                                                                    source: 'ion/test/immediateTemplates.ion'
                                                                },
                                                                end: {
                                                                    line: 60,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'ion/test/immediateTemplates.ion'
                                                                }
                                                            }
                                                        },
                                                        right: {
                                                            type: 'Identifier',
                                                            name: 'index',
                                                            loc: {
                                                                start: {
                                                                    line: 60,
                                                                    column: 28,
                                                                    fixed: true,
                                                                    source: 'ion/test/immediateTemplates.ion'
                                                                },
                                                                end: {
                                                                    line: 60,
                                                                    column: 33,
                                                                    fixed: true,
                                                                    source: 'ion/test/immediateTemplates.ion'
                                                                }
                                                            }
                                                        }
                                                    }
                                                },
                                                order: '0'
                                            }]
                                    }
                                }],
                            kind: 'let',
                            order: '1'
                        },
                        {
                            type: 'ReturnStatement',
                            argument: {
                                type: 'Identifier',
                                name: 'x',
                                loc: {
                                    start: {
                                        line: 61,
                                        column: 19,
                                        fixed: true,
                                        source: 'ion/test/immediateTemplates.ion'
                                    },
                                    end: {
                                        line: 61,
                                        column: 20,
                                        fixed: true,
                                        source: 'ion/test/immediateTemplates.ion'
                                    }
                                }
                            },
                            order: '2'
                        }
                    ],
                    bound: false
                }, {
                    this: this,
                    ion: ion,
                    templates: templates,
                    test: test
                }, null);
            }),
            [],
            [
                1,
                3,
                5
            ]
        ],
        [
            ion.template(function () {
                return ion.createRuntime({
                    type: 'Template',
                    id: null,
                    body: [
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'items',
                                        loc: {
                                            start: {
                                                line: 66,
                                                column: 16,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            },
                                            end: {
                                                line: 66,
                                                column: 21,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'a',
                                                    loc: {
                                                        start: {
                                                            line: 66,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'ion/test/immediateTemplates.ion'
                                                        },
                                                        end: {
                                                            line: 66,
                                                            column: 26,
                                                            fixed: true,
                                                            source: 'ion/test/immediateTemplates.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: 1
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'b',
                                                    loc: {
                                                        start: {
                                                            line: 66,
                                                            column: 29,
                                                            fixed: true,
                                                            source: 'ion/test/immediateTemplates.ion'
                                                        },
                                                        end: {
                                                            line: 66,
                                                            column: 30,
                                                            fixed: true,
                                                            source: 'ion/test/immediateTemplates.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: 2
                                                },
                                                kind: 'init',
                                                order: '1'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'c',
                                                    loc: {
                                                        start: {
                                                            line: 66,
                                                            column: 33,
                                                            fixed: true,
                                                            source: 'ion/test/immediateTemplates.ion'
                                                        },
                                                        end: {
                                                            line: 66,
                                                            column: 34,
                                                            fixed: true,
                                                            source: 'ion/test/immediateTemplates.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: 3
                                                },
                                                kind: 'init',
                                                order: '2'
                                            }
                                        ]
                                    }
                                }],
                            kind: 'let',
                            order: '0'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'x',
                                        loc: {
                                            start: {
                                                line: 67,
                                                column: 16,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            },
                                            end: {
                                                line: 67,
                                                column: 17,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'ObjectExpression',
                                        objectType: {
                                            type: 'ArrayExpression',
                                            elements: []
                                        },
                                        properties: [{
                                                type: 'ForInStatement',
                                                left: {
                                                    type: 'VariableDeclaration',
                                                    declarations: [
                                                        {
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'key',
                                                                loc: {
                                                                    start: {
                                                                        line: 67,
                                                                        column: 37,
                                                                        fixed: true,
                                                                        source: 'ion/test/immediateTemplates.ion'
                                                                    },
                                                                    end: {
                                                                        line: 67,
                                                                        column: 40,
                                                                        fixed: true,
                                                                        source: 'ion/test/immediateTemplates.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: null
                                                        },
                                                        {
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'value',
                                                                loc: {
                                                                    start: {
                                                                        line: 67,
                                                                        column: 42,
                                                                        fixed: true,
                                                                        source: 'ion/test/immediateTemplates.ion'
                                                                    },
                                                                    end: {
                                                                        line: 67,
                                                                        column: 47,
                                                                        fixed: true,
                                                                        source: 'ion/test/immediateTemplates.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: null
                                                        }
                                                    ],
                                                    kind: 'let'
                                                },
                                                right: {
                                                    type: 'Identifier',
                                                    name: 'items',
                                                    loc: {
                                                        start: {
                                                            line: 67,
                                                            column: 51,
                                                            fixed: true,
                                                            source: 'ion/test/immediateTemplates.ion'
                                                        },
                                                        end: {
                                                            line: 67,
                                                            column: 56,
                                                            fixed: true,
                                                            source: 'ion/test/immediateTemplates.ion'
                                                        }
                                                    }
                                                },
                                                body: {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'BinaryExpression',
                                                        operator: '+',
                                                        left: {
                                                            type: 'Identifier',
                                                            name: 'key',
                                                            loc: {
                                                                start: {
                                                                    line: 67,
                                                                    column: 21,
                                                                    fixed: true,
                                                                    source: 'ion/test/immediateTemplates.ion'
                                                                },
                                                                end: {
                                                                    line: 67,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'ion/test/immediateTemplates.ion'
                                                                }
                                                            }
                                                        },
                                                        right: {
                                                            type: 'Identifier',
                                                            name: 'value',
                                                            loc: {
                                                                start: {
                                                                    line: 67,
                                                                    column: 27,
                                                                    fixed: true,
                                                                    source: 'ion/test/immediateTemplates.ion'
                                                                },
                                                                end: {
                                                                    line: 67,
                                                                    column: 32,
                                                                    fixed: true,
                                                                    source: 'ion/test/immediateTemplates.ion'
                                                                }
                                                            }
                                                        }
                                                    }
                                                },
                                                order: '0'
                                            }]
                                    }
                                }],
                            kind: 'let',
                            order: '1'
                        },
                        {
                            type: 'ReturnStatement',
                            argument: {
                                type: 'Identifier',
                                name: 'x',
                                loc: {
                                    start: {
                                        line: 68,
                                        column: 19,
                                        fixed: true,
                                        source: 'ion/test/immediateTemplates.ion'
                                    },
                                    end: {
                                        line: 68,
                                        column: 20,
                                        fixed: true,
                                        source: 'ion/test/immediateTemplates.ion'
                                    }
                                }
                            },
                            order: '2'
                        }
                    ],
                    bound: false
                }, {
                    this: this,
                    ion: ion,
                    templates: templates,
                    test: test
                }, null);
            }),
            [],
            [
                'a1',
                'b2',
                'c3'
            ]
        ],
        [
            ion.template(function () {
                return ion.createRuntime({
                    type: 'Template',
                    id: null,
                    body: [
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'object',
                                        loc: {
                                            start: {
                                                line: 73,
                                                column: 16,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            },
                                            end: {
                                                line: 73,
                                                column: 22,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'a',
                                                    loc: {
                                                        start: {
                                                            line: 73,
                                                            column: 26,
                                                            fixed: true,
                                                            source: 'ion/test/immediateTemplates.ion'
                                                        },
                                                        end: {
                                                            line: 73,
                                                            column: 27,
                                                            fixed: true,
                                                            source: 'ion/test/immediateTemplates.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'ObjectExpression',
                                                    properties: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'b',
                                                                loc: {
                                                                    start: {
                                                                        line: 73,
                                                                        column: 29,
                                                                        fixed: true,
                                                                        source: 'ion/test/immediateTemplates.ion'
                                                                    },
                                                                    end: {
                                                                        line: 73,
                                                                        column: 30,
                                                                        fixed: true,
                                                                        source: 'ion/test/immediateTemplates.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Literal',
                                                                value: 1
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    }
                                }],
                            kind: 'let',
                            order: '0'
                        },
                        {
                            type: 'ReturnStatement',
                            argument: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'object',
                                        loc: {
                                            start: {
                                                line: 74,
                                                column: 19,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            },
                                            end: {
                                                line: 74,
                                                column: 25,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'a',
                                        loc: {
                                            start: {
                                                line: 74,
                                                column: 27,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            },
                                            end: {
                                                line: 74,
                                                column: 28,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            }
                                        }
                                    },
                                    existential: true,
                                    loc: {
                                        start: {
                                            line: 74,
                                            column: 19,
                                            fixed: true,
                                            source: 'ion/test/immediateTemplates.ion'
                                        },
                                        end: {
                                            line: 74,
                                            column: 28,
                                            fixed: true,
                                            source: 'ion/test/immediateTemplates.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'b',
                                    loc: {
                                        start: {
                                            line: 74,
                                            column: 30,
                                            fixed: true,
                                            source: 'ion/test/immediateTemplates.ion'
                                        },
                                        end: {
                                            line: 74,
                                            column: 31,
                                            fixed: true,
                                            source: 'ion/test/immediateTemplates.ion'
                                        }
                                    }
                                },
                                existential: true,
                                loc: {
                                    start: {
                                        line: 74,
                                        column: 19,
                                        fixed: true,
                                        source: 'ion/test/immediateTemplates.ion'
                                    },
                                    end: {
                                        line: 74,
                                        column: 31,
                                        fixed: true,
                                        source: 'ion/test/immediateTemplates.ion'
                                    }
                                }
                            },
                            order: '1'
                        }
                    ],
                    bound: false
                }, {
                    this: this,
                    ion: ion,
                    templates: templates,
                    test: test
                }, null);
            }),
            [],
            1
        ],
        [
            ion.template(function () {
                return ion.createRuntime({
                    type: 'Template',
                    id: null,
                    body: [{
                            type: 'ReturnStatement',
                            argument: {
                                type: 'ConditionalExpression',
                                test: {
                                    type: 'Literal',
                                    value: false
                                },
                                consequent: {
                                    type: 'Literal',
                                    value: 1
                                },
                                alternate: {
                                    type: 'Literal',
                                    value: 2
                                }
                            },
                            order: '0'
                        }],
                    bound: false
                }, {
                    this: this,
                    ion: ion,
                    templates: templates,
                    test: test
                }, null);
            }),
            [],
            2
        ],
        [
            ion.template(function () {
                return ion.createRuntime({
                    type: 'Template',
                    id: null,
                    body: [{
                            type: 'ReturnStatement',
                            argument: {
                                type: 'ConditionalExpression',
                                test: {
                                    type: 'BinaryExpression',
                                    operator: '!=',
                                    left: {
                                        type: 'Literal',
                                        value: null
                                    },
                                    right: {
                                        type: 'Literal',
                                        value: null
                                    }
                                },
                                consequent: {
                                    type: 'Literal',
                                    value: null
                                },
                                alternate: {
                                    type: 'Literal',
                                    value: 2
                                }
                            },
                            order: '0'
                        }],
                    bound: false
                }, {
                    this: this,
                    ion: ion,
                    templates: templates,
                    test: test
                }, null);
            }),
            [],
            2
        ],
        [
            ion.template(function () {
                return ion.createRuntime({
                    type: 'Template',
                    id: null,
                    body: [
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'a',
                                        loc: {
                                            start: {
                                                line: 87,
                                                column: 16,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            },
                                            end: {
                                                line: 87,
                                                column: 17,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'Literal',
                                        value: null
                                    }
                                }],
                            kind: 'let',
                            order: '0'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'b',
                                        loc: {
                                            start: {
                                                line: 88,
                                                column: 16,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            },
                                            end: {
                                                line: 88,
                                                column: 17,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'Literal',
                                        value: 2
                                    }
                                }],
                            kind: 'let',
                            order: '1'
                        },
                        {
                            type: 'ReturnStatement',
                            argument: {
                                type: 'ArrayExpression',
                                elements: [
                                    {
                                        type: 'UnaryExpression',
                                        operator: '?',
                                        argument: {
                                            type: 'Identifier',
                                            name: 'a',
                                            loc: {
                                                start: {
                                                    line: 89,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'ion/test/immediateTemplates.ion'
                                                },
                                                end: {
                                                    line: 89,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'ion/test/immediateTemplates.ion'
                                                }
                                            }
                                        }
                                    },
                                    {
                                        type: 'UnaryExpression',
                                        operator: '?',
                                        argument: {
                                            type: 'Identifier',
                                            name: 'b',
                                            loc: {
                                                start: {
                                                    line: 89,
                                                    column: 24,
                                                    fixed: true,
                                                    source: 'ion/test/immediateTemplates.ion'
                                                },
                                                end: {
                                                    line: 89,
                                                    column: 25,
                                                    fixed: true,
                                                    source: 'ion/test/immediateTemplates.ion'
                                                }
                                            }
                                        }
                                    }
                                ]
                            },
                            order: '2'
                        }
                    ],
                    bound: false
                }, {
                    this: this,
                    ion: ion,
                    templates: templates,
                    test: test
                }, null);
            }),
            [],
            [
                false,
                true
            ]
        ],
        [
            ion.template(function () {
                return ion.createRuntime({
                    type: 'Template',
                    id: null,
                    body: [{
                            type: 'ReturnStatement',
                            argument: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'Math',
                                        loc: {
                                            start: {
                                                line: 93,
                                                column: 20,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            },
                                            end: {
                                                line: 93,
                                                column: 24,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'min',
                                        loc: {
                                            start: {
                                                line: 93,
                                                column: 25,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            },
                                            end: {
                                                line: 93,
                                                column: 28,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 93,
                                            column: 20,
                                            fixed: true,
                                            source: 'ion/test/immediateTemplates.ion'
                                        },
                                        end: {
                                            line: 93,
                                            column: 28,
                                            fixed: true,
                                            source: 'ion/test/immediateTemplates.ion'
                                        }
                                    }
                                },
                                arguments: [
                                    {
                                        type: 'Literal',
                                        value: 1
                                    },
                                    {
                                        type: 'Literal',
                                        value: 2
                                    }
                                ],
                                loc: {
                                    start: {
                                        line: 93,
                                        column: 20,
                                        fixed: true,
                                        source: 'ion/test/immediateTemplates.ion'
                                    },
                                    end: {
                                        line: 93,
                                        column: 34,
                                        fixed: true,
                                        source: 'ion/test/immediateTemplates.ion'
                                    }
                                }
                            },
                            order: '0'
                        }],
                    bound: false
                }, {
                    this: this,
                    ion: ion,
                    templates: templates,
                    test: test
                }, null);
            }),
            [],
            1
        ],
        [
            ion.template(function () {
                return ion.createRuntime({
                    type: 'Template',
                    id: null,
                    body: [{
                            type: 'ReturnStatement',
                            argument: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'Math',
                                            loc: {
                                                start: {
                                                    line: 97,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'ion/test/immediateTemplates.ion'
                                                },
                                                end: {
                                                    line: 97,
                                                    column: 24,
                                                    fixed: true,
                                                    source: 'ion/test/immediateTemplates.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'min',
                                            loc: {
                                                start: {
                                                    line: 97,
                                                    column: 25,
                                                    fixed: true,
                                                    source: 'ion/test/immediateTemplates.ion'
                                                },
                                                end: {
                                                    line: 97,
                                                    column: 28,
                                                    fixed: true,
                                                    source: 'ion/test/immediateTemplates.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 97,
                                                column: 20,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            },
                                            end: {
                                                line: 97,
                                                column: 28,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'call',
                                        loc: {
                                            start: {
                                                line: 97,
                                                column: 29,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            },
                                            end: {
                                                line: 97,
                                                column: 33,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 97,
                                            column: 20,
                                            fixed: true,
                                            source: 'ion/test/immediateTemplates.ion'
                                        },
                                        end: {
                                            line: 97,
                                            column: 33,
                                            fixed: true,
                                            source: 'ion/test/immediateTemplates.ion'
                                        }
                                    }
                                },
                                arguments: [
                                    {
                                        type: 'Literal',
                                        value: null
                                    },
                                    {
                                        type: 'Literal',
                                        value: 1
                                    },
                                    {
                                        type: 'Literal',
                                        value: 2
                                    }
                                ],
                                loc: {
                                    start: {
                                        line: 97,
                                        column: 20,
                                        fixed: true,
                                        source: 'ion/test/immediateTemplates.ion'
                                    },
                                    end: {
                                        line: 97,
                                        column: 45,
                                        fixed: true,
                                        source: 'ion/test/immediateTemplates.ion'
                                    }
                                }
                            },
                            order: '0'
                        }],
                    bound: false
                }, {
                    this: this,
                    ion: ion,
                    templates: templates,
                    test: test
                }, null);
            }),
            [],
            1
        ],
        [
            ion.template(function () {
                return ion.createRuntime({
                    type: 'Template',
                    id: null,
                    body: [{
                            type: 'ReturnStatement',
                            argument: {
                                type: 'NewExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Date',
                                    loc: {
                                        start: {
                                            line: 101,
                                            column: 24,
                                            fixed: true,
                                            source: 'ion/test/immediateTemplates.ion'
                                        },
                                        end: {
                                            line: 101,
                                            column: 28,
                                            fixed: true,
                                            source: 'ion/test/immediateTemplates.ion'
                                        }
                                    }
                                },
                                arguments: [
                                    {
                                        type: 'Literal',
                                        value: 2011
                                    },
                                    {
                                        type: 'Literal',
                                        value: 10
                                    },
                                    {
                                        type: 'Literal',
                                        value: 5
                                    }
                                ],
                                loc: {
                                    start: {
                                        line: 101,
                                        column: 20,
                                        fixed: true,
                                        source: 'ion/test/immediateTemplates.ion'
                                    },
                                    end: {
                                        line: 101,
                                        column: 41,
                                        fixed: true,
                                        source: 'ion/test/immediateTemplates.ion'
                                    }
                                }
                            },
                            order: '0'
                        }],
                    bound: false
                }, {
                    this: this,
                    ion: ion,
                    templates: templates,
                    test: test
                }, null);
            }),
            [],
            new Date(2011, 10, 5)
        ],
        [
            ion.template(function () {
                return ion.createRuntime({
                    type: 'Template',
                    id: null,
                    body: [{
                            type: 'ReturnStatement',
                            argument: {
                                type: 'Literal',
                                value: /foo/
                            },
                            order: '0'
                        }],
                    bound: false
                }, {
                    this: this,
                    ion: ion,
                    templates: templates,
                    test: test
                }, null);
            }),
            [],
            /foo/
        ],
        [
            ion.template(function () {
                return ion.createRuntime({
                    type: 'Template',
                    id: null,
                    body: [{
                            type: 'ReturnStatement',
                            argument: {
                                type: 'ObjectExpression',
                                properties: [
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'x',
                                            loc: {
                                                start: {
                                                    line: 111,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'ion/test/immediateTemplates.ion'
                                                },
                                                end: {
                                                    line: 111,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'ion/test/immediateTemplates.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: 1
                                        },
                                        kind: 'init',
                                        order: '0'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'y',
                                            loc: {
                                                start: {
                                                    line: 112,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'ion/test/immediateTemplates.ion'
                                                },
                                                end: {
                                                    line: 112,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'ion/test/immediateTemplates.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: 2
                                        },
                                        kind: 'init',
                                        order: '1'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'z',
                                            loc: {
                                                start: {
                                                    line: 113,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'ion/test/immediateTemplates.ion'
                                                },
                                                end: {
                                                    line: 113,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'ion/test/immediateTemplates.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'ObjectExpression',
                                            objectType: {
                                                type: 'ArrayExpression',
                                                elements: []
                                            },
                                            properties: [
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'items',
                                                                loc: {
                                                                    start: {
                                                                        line: 114,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'ion/test/immediateTemplates.ion'
                                                                    },
                                                                    end: {
                                                                        line: 114,
                                                                        column: 29,
                                                                        fixed: true,
                                                                        source: 'ion/test/immediateTemplates.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'ArrayExpression',
                                                                elements: [
                                                                    {
                                                                        type: 'Literal',
                                                                        value: 3
                                                                    },
                                                                    {
                                                                        type: 'Literal',
                                                                        value: 2
                                                                    },
                                                                    {
                                                                        type: 'Literal',
                                                                        value: 1
                                                                    }
                                                                ]
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'ForOfStatement',
                                                    left: {
                                                        type: 'VariableDeclaration',
                                                        declarations: [{
                                                                type: 'VariableDeclarator',
                                                                id: {
                                                                    type: 'Identifier',
                                                                    name: 'item',
                                                                    loc: {
                                                                        start: {
                                                                            line: 115,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'ion/test/immediateTemplates.ion'
                                                                        },
                                                                        end: {
                                                                            line: 115,
                                                                            column: 28,
                                                                            fixed: true,
                                                                            source: 'ion/test/immediateTemplates.ion'
                                                                        }
                                                                    }
                                                                },
                                                                init: null
                                                            }],
                                                        kind: 'let'
                                                    },
                                                    right: {
                                                        type: 'Identifier',
                                                        name: 'items',
                                                        loc: {
                                                            start: {
                                                                line: 115,
                                                                column: 32,
                                                                fixed: true,
                                                                source: 'ion/test/immediateTemplates.ion'
                                                            },
                                                            end: {
                                                                line: 115,
                                                                column: 37,
                                                                fixed: true,
                                                                source: 'ion/test/immediateTemplates.ion'
                                                            }
                                                        }
                                                    },
                                                    body: {
                                                        type: 'BlockStatement',
                                                        body: [{
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '*',
                                                                    left: {
                                                                        type: 'Identifier',
                                                                        name: 'item',
                                                                        loc: {
                                                                            start: {
                                                                                line: 116,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'ion/test/immediateTemplates.ion'
                                                                            },
                                                                            end: {
                                                                                line: 116,
                                                                                column: 28,
                                                                                fixed: true,
                                                                                source: 'ion/test/immediateTemplates.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    right: {
                                                                        type: 'Literal',
                                                                        value: 2
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 116,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'ion/test/immediateTemplates.ion'
                                                                    },
                                                                    end: {
                                                                        line: 116,
                                                                        column: 32,
                                                                        fixed: true,
                                                                        source: 'ion/test/immediateTemplates.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    remove: null,
                                                    order: '1'
                                                }
                                            ]
                                        },
                                        kind: 'init',
                                        order: '2'
                                    }
                                ]
                            },
                            order: '0'
                        }],
                    bound: false
                }, {
                    this: this,
                    ion: ion,
                    templates: templates,
                    test: test
                }, null);
            }),
            [],
            {
                x: 1,
                y: 2,
                z: [
                    6,
                    4,
                    2
                ]
            }
        ],
        [
            ion.template(function () {
                return ion.createRuntime({
                    type: 'Template',
                    id: null,
                    body: [{
                            type: 'ReturnStatement',
                            argument: {
                                type: 'ArrayExpression',
                                elements: [
                                    {
                                        type: 'ConditionalExpression',
                                        test: {
                                            type: 'BinaryExpression',
                                            operator: '!=',
                                            left: {
                                                type: 'Literal',
                                                value: null
                                            },
                                            right: {
                                                type: 'Literal',
                                                value: null
                                            }
                                        },
                                        consequent: {
                                            type: 'Literal',
                                            value: null
                                        },
                                        alternate: {
                                            type: 'Literal',
                                            value: 1
                                        }
                                    },
                                    {
                                        type: 'ConditionalExpression',
                                        test: {
                                            type: 'BinaryExpression',
                                            operator: '!=',
                                            left: {
                                                type: 'UnaryExpression',
                                                operator: 'void',
                                                prefix: true,
                                                argument: {
                                                    type: 'Literal',
                                                    value: 0
                                                }
                                            },
                                            right: {
                                                type: 'Literal',
                                                value: null
                                            }
                                        },
                                        consequent: {
                                            type: 'UnaryExpression',
                                            operator: 'void',
                                            prefix: true,
                                            argument: {
                                                type: 'Literal',
                                                value: 0
                                            }
                                        },
                                        alternate: {
                                            type: 'Literal',
                                            value: 2
                                        }
                                    }
                                ]
                            },
                            order: '0'
                        }],
                    bound: false
                }, {
                    this: this,
                    ion: ion,
                    templates: templates,
                    test: test
                }, null);
            }),
            [],
            [
                1,
                2
            ]
        ],
        [
            ion.template(function (_ref) {
                return ion.createRuntime({
                    type: 'Template',
                    id: null,
                    body: [
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'a',
                                        loc: {
                                            start: {
                                                line: 124,
                                                column: 19,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            },
                                            end: {
                                                line: 124,
                                                column: 20,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'MemberExpression',
                                        object: {
                                            type: 'Identifier',
                                            name: '_ref'
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'a',
                                            loc: {
                                                start: {
                                                    line: 124,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'ion/test/immediateTemplates.ion'
                                                },
                                                end: {
                                                    line: 124,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'ion/test/immediateTemplates.ion'
                                                }
                                            }
                                        },
                                        computed: false
                                    }
                                }],
                            kind: 'let',
                            order: '0'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'b',
                                        loc: {
                                            start: {
                                                line: 124,
                                                column: 21,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            },
                                            end: {
                                                line: 124,
                                                column: 22,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'MemberExpression',
                                        object: {
                                            type: 'Identifier',
                                            name: '_ref'
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'b',
                                            loc: {
                                                start: {
                                                    line: 124,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'ion/test/immediateTemplates.ion'
                                                },
                                                end: {
                                                    line: 124,
                                                    column: 22,
                                                    fixed: true,
                                                    source: 'ion/test/immediateTemplates.ion'
                                                }
                                            }
                                        },
                                        computed: false
                                    }
                                }],
                            kind: 'let',
                            order: '1'
                        },
                        {
                            type: 'ReturnStatement',
                            argument: {
                                type: 'BinaryExpression',
                                operator: '+',
                                left: {
                                    type: 'Identifier',
                                    name: 'a',
                                    loc: {
                                        start: {
                                            line: 124,
                                            column: 28,
                                            fixed: true,
                                            source: 'ion/test/immediateTemplates.ion'
                                        },
                                        end: {
                                            line: 124,
                                            column: 29,
                                            fixed: true,
                                            source: 'ion/test/immediateTemplates.ion'
                                        }
                                    }
                                },
                                right: {
                                    type: 'Identifier',
                                    name: 'b',
                                    loc: {
                                        start: {
                                            line: 124,
                                            column: 32,
                                            fixed: true,
                                            source: 'ion/test/immediateTemplates.ion'
                                        },
                                        end: {
                                            line: 124,
                                            column: 33,
                                            fixed: true,
                                            source: 'ion/test/immediateTemplates.ion'
                                        }
                                    }
                                }
                            },
                            order: '2'
                        }
                    ],
                    bound: false
                }, {
                    this: this,
                    _ref: _ref,
                    ion: ion,
                    templates: templates,
                    test: test
                }, null);
            }),
            [{
                    a: 1,
                    b: 2
                }],
            3
        ],
        [
            ion.template(function (type) {
                return ion.createRuntime({
                    type: 'Template',
                    id: null,
                    body: [{
                            type: 'ReturnStatement',
                            argument: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'NewExpression',
                                    callee: {
                                        type: 'Identifier',
                                        name: 'type',
                                        loc: {
                                            start: {
                                                line: 129,
                                                column: 23,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            },
                                            end: {
                                                line: 129,
                                                column: 27,
                                                fixed: true,
                                                source: 'ion/test/immediateTemplates.ion'
                                            }
                                        }
                                    },
                                    arguments: [],
                                    loc: {
                                        start: {
                                            line: 129,
                                            column: 19,
                                            fixed: true,
                                            source: 'ion/test/immediateTemplates.ion'
                                        },
                                        end: {
                                            line: 129,
                                            column: 27,
                                            fixed: true,
                                            source: 'ion/test/immediateTemplates.ion'
                                        }
                                    }
                                },
                                properties: [{
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'position',
                                            loc: {
                                                start: {
                                                    line: 130,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'ion/test/immediateTemplates.ion'
                                                },
                                                end: {
                                                    line: 130,
                                                    column: 24,
                                                    fixed: true,
                                                    source: 'ion/test/immediateTemplates.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'ObjectExpression',
                                            properties: [{
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'x',
                                                        loc: {
                                                            start: {
                                                                line: 131,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'ion/test/immediateTemplates.ion'
                                                            },
                                                            end: {
                                                                line: 131,
                                                                column: 21,
                                                                fixed: true,
                                                                source: 'ion/test/immediateTemplates.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 10
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                }]
                                        },
                                        kind: 'init',
                                        order: '0'
                                    }]
                            },
                            order: '0'
                        }],
                    bound: false
                }, {
                    this: this,
                    type: type,
                    ion: ion,
                    templates: templates,
                    test: test
                }, null);
            }),
            [function () {
                    this.position = {
                        x: 1,
                        y: 2
                    };
                }],
            {
                position: {
                    x: 10,
                    y: 2
                }
            }
        ],
        [
            ion.template(function (input, output) {
                return ion.createRuntime({
                    type: 'Template',
                    id: null,
                    body: [
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'output',
                                loc: {
                                    start: {
                                        line: 138,
                                        column: 12,
                                        fixed: true,
                                        source: 'ion/test/immediateTemplates.ion'
                                    },
                                    end: {
                                        line: 138,
                                        column: 18,
                                        fixed: true,
                                        source: 'ion/test/immediateTemplates.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'ObjectExpression',
                                properties: [{
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'e',
                                            loc: {
                                                start: {
                                                    line: 139,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'ion/test/immediateTemplates.ion'
                                                },
                                                end: {
                                                    line: 139,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'ion/test/immediateTemplates.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'BinaryExpression',
                                            operator: '+',
                                            left: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'input',
                                                    loc: {
                                                        start: {
                                                            line: 139,
                                                            column: 19,
                                                            fixed: true,
                                                            source: 'ion/test/immediateTemplates.ion'
                                                        },
                                                        end: {
                                                            line: 139,
                                                            column: 24,
                                                            fixed: true,
                                                            source: 'ion/test/immediateTemplates.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'a',
                                                    loc: {
                                                        start: {
                                                            line: 139,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'ion/test/immediateTemplates.ion'
                                                        },
                                                        end: {
                                                            line: 139,
                                                            column: 26,
                                                            fixed: true,
                                                            source: 'ion/test/immediateTemplates.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 139,
                                                        column: 19,
                                                        fixed: true,
                                                        source: 'ion/test/immediateTemplates.ion'
                                                    },
                                                    end: {
                                                        line: 139,
                                                        column: 26,
                                                        fixed: true,
                                                        source: 'ion/test/immediateTemplates.ion'
                                                    }
                                                }
                                            },
                                            right: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'input',
                                                    loc: {
                                                        start: {
                                                            line: 139,
                                                            column: 29,
                                                            fixed: true,
                                                            source: 'ion/test/immediateTemplates.ion'
                                                        },
                                                        end: {
                                                            line: 139,
                                                            column: 34,
                                                            fixed: true,
                                                            source: 'ion/test/immediateTemplates.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'b',
                                                    loc: {
                                                        start: {
                                                            line: 139,
                                                            column: 35,
                                                            fixed: true,
                                                            source: 'ion/test/immediateTemplates.ion'
                                                        },
                                                        end: {
                                                            line: 139,
                                                            column: 36,
                                                            fixed: true,
                                                            source: 'ion/test/immediateTemplates.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 139,
                                                        column: 29,
                                                        fixed: true,
                                                        source: 'ion/test/immediateTemplates.ion'
                                                    },
                                                    end: {
                                                        line: 139,
                                                        column: 36,
                                                        fixed: true,
                                                        source: 'ion/test/immediateTemplates.ion'
                                                    }
                                                }
                                            }
                                        },
                                        kind: 'init',
                                        order: '0'
                                    }]
                            },
                            kind: 'init',
                            order: '0'
                        },
                        {
                            type: 'ReturnStatement',
                            argument: {
                                type: 'Identifier',
                                name: 'output',
                                loc: {
                                    start: {
                                        line: 140,
                                        column: 19,
                                        fixed: true,
                                        source: 'ion/test/immediateTemplates.ion'
                                    },
                                    end: {
                                        line: 140,
                                        column: 25,
                                        fixed: true,
                                        source: 'ion/test/immediateTemplates.ion'
                                    }
                                }
                            },
                            order: '1'
                        }
                    ],
                    bound: false
                }, {
                    this: this,
                    input: input,
                    output: output,
                    ion: ion,
                    templates: templates,
                    test: test
                }, null);
            }),
            [
                {
                    a: 1,
                    b: 2
                },
                {
                    c: 3,
                    d: 4
                }
            ],
            {
                c: 3,
                d: 4,
                e: 3
            }
        ],
        [
            ion.template(function () {
                return ion.createRuntime({
                    type: 'Template',
                    id: null,
                    body: [{
                            type: 'ReturnStatement',
                            argument: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'ion',
                                    loc: {
                                        start: {
                                            line: 146,
                                            column: 20,
                                            fixed: true,
                                            source: 'ion/test/immediateTemplates.ion'
                                        },
                                        end: {
                                            line: 146,
                                            column: 23,
                                            fixed: true,
                                            source: 'ion/test/immediateTemplates.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'patch',
                                    loc: {
                                        start: {
                                            line: 146,
                                            column: 24,
                                            fixed: true,
                                            source: 'ion/test/immediateTemplates.ion'
                                        },
                                        end: {
                                            line: 146,
                                            column: 29,
                                            fixed: true,
                                            source: 'ion/test/immediateTemplates.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 146,
                                        column: 20,
                                        fixed: true,
                                        source: 'ion/test/immediateTemplates.ion'
                                    },
                                    end: {
                                        line: 146,
                                        column: 29,
                                        fixed: true,
                                        source: 'ion/test/immediateTemplates.ion'
                                    }
                                }
                            },
                            order: '0'
                        }],
                    bound: false
                }, {
                    this: this,
                    ion: ion,
                    templates: templates,
                    test: test
                }, null);
            }),
            [],
            ion.patch
        ]
    ];
var test = exports.test = function () {
        for (var _i = 0; _i < templates.length; _i++) {
            var index = _i;
            var _ref2 = templates[_i];
            var templateType = _ref2[0];
            var args = _ref2[1];
            var expected = _ref2[2];
            if (expected != null) {
                var template = templateType.apply(this, args);
                var reactiveResult = null;
                var beforeCount = ion.observe.count != null ? ion.observe.count : 0;
                var unobserve = template.observe(function (value) {
                        return reactiveResult = value;
                    });
                var watchCount = ion.observe.count != null ? ion.observe.count : 0;
                try {
                    if (!(reactiveResult === expected || JSON.stringify(reactiveResult) === JSON.stringify(expected)))
                        throw new Error('Assertion Failed: (reactiveResult is expected or JSON.stringify(reactiveResult) is JSON.stringify(expected))');
                } catch (e) {
                    console.log(reactiveResult, '!==', expected);
                    throw e;
                }
                unobserve();
                var afterCount = ion.observe.count != null ? ion.observe.count : 0;
                if (afterCount !== beforeCount) {
                    throw new Error('Template observe leak in template ' + index + '.  Before: ' + beforeCount + ', After: ' + afterCount);
                }
            }
        }
    };
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/test/immediateTemplates',_ion_test_immediateTemplates_);
    else
      _ion_test_immediateTemplates_.call(this, module, exports, require);
  }
  else {
    _ion_test_immediateTemplates_.call(this);
  }
}).call(this)
void (function(){var _ion_test_index_ = function(module,exports,require){Object.defineProperty(exports, 'duplicateDeclares', {get:function(){ return require('./duplicateDeclares') }, enumerable: true}) 
Object.defineProperty(exports, 'es6Scoping', {get:function(){ return require('./es6Scoping') }, enumerable: true}) 
Object.defineProperty(exports, 'immediateTemplates', {get:function(){ return require('./immediateTemplates') }, enumerable: true}) 
Object.defineProperty(exports, 'ionCompiler', {get:function(){ return require('./ionCompiler') }, enumerable: true}) 
Object.defineProperty(exports, 'ionCompilerES5', {get:function(){ return require('./ionCompilerES5') }, enumerable: true}) 
Object.defineProperty(exports, 'reactiveTemplates', {get:function(){ return require('./reactiveTemplates') }, enumerable: true}) 
Object.defineProperty(exports, 'sourceSize', {get:function(){ return require('./sourceSize') }, enumerable: true}) 
Object.defineProperty(exports, 'syntax', {get:function(){ return require('./syntax') }, enumerable: true}) 
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/test/index',_ion_test_index_);
    else
      _ion_test_index_.call(this, module, exports, require);
  }
  else {
    _ion_test_index_.call(this);
  }
}).call(this)
void (function(){var _ion_test_ionCompiler_ = function(module,exports,require){var index, ion, tests;

ion = require('../');

index = require('../compiler');

tests = {
  "let x = 10": "'use strict';\nlet x = 10;",
  "for name, value of foo\n    console.log(name + value)": "'use strict';\nfor (let name in foo) {\n    let value = foo[name];\n    console.log(name + value);\n}",
  "for let name, value of {a:1,b:2,c:3}\n    console.log(name + value)": "'use strict';\n{\n    let _ref = {\n            a: 1,\n            b: 2,\n            c: 3\n        };\n    for (let name in _ref) {\n        let value = _ref[name];\n        console.log(name + value);\n    }\n}    ",
  "for let name in [\"a\",\"b\",\"c\"]\n    console.log(name)": "'use strict';\n{\n    let _ref = [\n            'a',\n            'b',\n            'c'\n        ];\n    for (let _i = 0; _i < _ref.length; _i++) {\n        let name = _ref[_i];\n        console.log(name);\n    }\n}",
  "for name, index in [\"a\",\"b\",\"c\"]\n    console.log(name)": "'use strict';\n{\n    let _ref = [\n            'a',\n            'b',\n            'c'\n        ];\n    for (let _i = 0; _i < _ref.length; _i++) {\n        let index = _i;\n        let name = _ref[_i];\n        console.log(name);\n    }\n}",
  "let object =\n    x: 1\n    y: 2\n    foo:\n        z: 3": "'use strict';\nlet object = {\n        x: 1,\n        y: 2,\n        foo: { z: 3 }\n    };",
  "let array = []\n    1\n    2\n    3": "'use strict';\nlet array = [\n        1,\n        2,\n        3\n    ];",
  "let kids = []\n    {}\n        name: \"Alpha\"\n        age: 10\n    {}\n        name: \"Beta\"\n        age: 8": "'use strict';\nlet kids = [\n        {\n            name: 'Alpha',\n            age: 10\n        },\n        {\n            name: 'Beta',\n            age: 8\n        }\n    ];",
  "try\n    doSomething(1)\ncatch e\n    log(e)": "'use strict';\ntry {\n    doSomething(1);\n} catch (e) {\n    log(e);\n}",
  "try\n    doSomething(1)\nfinally\n    log(e)": "'use strict';\ntry {\n    doSomething(1);\n} finally {\n    log(e);\n}",
  "try\n    doSomething(1)\ncatch e\n    console.error(e)\nfinally\n    log(e)": "'use strict';\ntry {\n    doSomething(1);\n} catch (e) {\n    console.error(e);\n} finally {\n    log(e);\n}",
  "for key, name of foo\n    if name is 'a'\n        break\n    else if name is 'b'\n        continue\n    else if name is 'c'\n        return\n    else if name is 'd'\n        throw new Error(\"D\")\n    else\n        return\n            x: 1\n            y: 2": "'use strict';\nfor (let key in foo) {\n    let name = foo[key];\n    if (name === 'a') {\n        break;\n    } else if (name === 'b') {\n        continue;\n    } else if (name === 'c') {\n        return;\n    } else if (name === 'd') {\n        throw new Error('D');\n    } else {\n        return {\n            x: 1,\n            y: 2\n        };\n    }\n}",
  "console.log(\"Hello {{name}}\")": "'use strict';\nconsole.log('Hello ' + name);",
  "console.log(\"{{name}}\")": "'use strict';\nconsole.log('' + name);",
  "console.log(\"{{ 1 }}{{ 2 }}\")": "'use strict';\nconsole.log('' + 1 + 2);",
  "return \"\"\n    <html>\n        <head><title>{{ title }}</title></head>\n        <body>\n        {{ body }}\n        </body>\n    </html>": "'use strict';\nreturn '<html>\\n    <head><title>' + title + '</title></head>\\n    <body>\\n    ' + body + '\\n    </body>\\n</html>';",
  "return ''\n    <html>\n        <head><title>{{ title }}</title></head>\n        <body>\n        {{ body }}\n        </body>\n    </html>": "'use strict';\nreturn '<html>\\n    <head><title>{{ title }}</title></head>\\n    <body>\\n    {{ body }}\\n    </body>\\n</html>';",
  "do -> x": "'use strict';\n(function () {\n    return x;\n}());",
  "do (x, y) => x + y": "'use strict';\nconst ion = require('ion');\nion.bind(function (x, y) {\n    return x + y;\n}, this)(x, y);",
  "const ion = import \"ion\"": "'use strict';\nconst ion = require('ion');",
  "export\n    secret: 97542": "'use strict';\nmodule.exports = exports = { secret: 97542 };",
  "export let x = 1, y = 2": "'use strict';\nlet x = exports.x = 1, y = exports.y = 2;",
  "export const\n    x = 1\n    y = 2\n    z = 3": "'use strict';\nconst x = exports.x = 1, y = exports.y = 2, z = exports.z = 3;",
  "let {x,y} = {x:1,y:2}": "'use strict';\nlet _ref = {\n        x: 1,\n        y: 2\n    };\nlet x = _ref.x;\nlet y = _ref.y;",
  "for key, {x:[a,b],y:{c:d}} of points\n    console.log(x, y)": "'use strict';\nfor (let key in points) {\n    let _ref = points[key];\n    let a = _ref.x[0];\n    let b = _ref.x[1];\n    let d = _ref.y.c;\n    console.log(x, y);\n}",
  "for {x:[a,b],y:{c:d}}, index in points\n    console.log(x, y)": "'use strict';\nfor (let _i = 0; _i < points.length; _i++) {\n    let index = _i;\n    let _ref = points[_i];\n    let a = _ref.x[0];\n    let b = _ref.x[1];\n    let d = _ref.y.c;\n    console.log(x, y);\n}",
  "foo ? bar": "'use strict';\nfoo != null ? foo : bar;",
  "foo ?? bar": "'use strict';\nfoo != void 0 ? foo : bar;",
  "let x\nx ?= y": "'use strict';\nlet x;\nx = x != null ? x : y;",
  "let x\nx ??= y": "'use strict';\nlet x;\nx = x != void 0 ? x : y;",
  "for const x, index in foo\n    log(x)": "'use strict';\nfor (let _i = 0; _i < foo.length; _i++) {\n    const index = _i;\n    const x = foo[_i];\n    log(x);\n}",
  "let x = 1, y = 2\n[x,y] = [y,x]": "'use strict';\nlet x = 1, y = 2;\nconst _ref = [\n        y,\n        x\n    ];\nx = _ref[0];\ny = _ref[1];",
  "a?.b": "'use strict';\na != null ? a.b : void 0;",
  "a?.b.c?.d": "'use strict';\na != null ? a.b.c != null ? a.b.c.d : void 0 : void 0;",
  "a?()": "'use strict';\na != null ? a() : void 0;",
  "a?.b?.c?()": "'use strict';\na != null ? a.b != null ? a.b.c != null ? a.b.c() : void 0 : void 0 : void 0;",
  "a?.b().c?()": "'use strict';\na != null ? a.b().c != null ? a.b().c() : void 0 : void 0;",
  "let y = (x) -> 2": "'use strict';\nlet y = function (x) {\n    return 2;\n};",
  "s?": "'use strict';\ns != null;",
  "# also test comments\nlet regex = /foo/": "'use strict';\nlet regex = /foo/;",
  "for let i = 0; i < 10; i++\n    console.log(i)": "'use strict';\nfor (let i = 0; i < 10; i++) {\n    console.log(i);\n}",
  "for key of object if key[0] isnt '_' for c in key\n    console.log(c)": "'use strict';\nfor (let key in object) {\n    if (key[0] !== '_') {\n        for (let _i = 0; _i < key.length; _i++) {\n            let c = key[_i];\n            console.log(c);\n        }\n    }\n}",
  "console.log([key for key of object if key is cool])": "'use strict';\nlet _ref = [];\nfor (let key in object) {\n    if (key === cool) {\n        _ref.push(key);\n    }\n}\nconsole.log(_ref);",
  "console.log(\n    1\n    2\n    {}\n        x: 1\n        y: 2\n)": "'use strict';\nconsole.log(1, 2, {\n    x: 1,\n    y: 2\n});",
  "let x = ->\n    try\n        foo()\n        bar()\n    catch e\n        baz()": "'use strict';\nlet x = function () {\n    try {\n        foo();\n        bar();\n    } catch (e) {\n        baz();\n    }\n};",
  "if foo\n    # bar": "'use strict';\nif (foo) {\n}",
  "let trim = (a = \"\") -> a.trim()": "'use strict';\nlet trim = function (a) {\n    if (a == null)\n        a = '';\n    return a.trim();\n};",
  "foo(\n    1\n    2\n)": "'use strict';\nfoo(1, 2);",
  "compile(\n    foo: 1\n    bar: 2\n    baz:\n        a: 1\n        b: 2\n)": "'use strict';\ncompile({\n    foo: 1,\n    bar: 2,\n    baz: {\n        a: 1,\n        b: 2\n    }\n});",
  "let array = [1,2,3]\n    4\n    5\n    6": "'use strict';\nlet array = [\n        1,\n        2,\n        3,\n        4,\n        5,\n        6\n    ];",
  "let point = new Point(10, 20)\n    z: 30": "'use strict';\nconst ion = require('ion');\nlet point = ion.patch.combine(new Point(10, 20), { z: 30 });",
  "let object = {x:1, y:2}\n    z: 3": "'use strict';\nlet object = {\n        x: 1,\n        y: 2,\n        z: 3\n    };",
  "let origin = new Point\n    x: 1\n    y: 2": "'use strict';\nconst ion = require('ion');\nlet origin = ion.patch.combine(new Point(), {\n        x: 1,\n        y: 2\n    });",
  "let origin = new Line\n    a: new Point\n        x: 0\n        y: 0\n    b: new Point\n        x: 10\n        y: 20": "'use strict';\nconst ion = require('ion');\nlet origin = ion.patch.combine(new Line(), {\n        a: ion.patch.combine(new Point(), {\n            x: 0,\n            y: 0\n        }),\n        b: ion.patch.combine(new Point(), {\n            x: 10,\n            y: 20\n        })\n    });",
  "input\n    # ignore this comment\n    x: 10\n    y: 20\n    z:\n        # also ignore this one\n        a: 1\n        b: 2\n    w: new Point\n        x: 0\n        y: 0": "'use strict';\nconst ion = require('ion');\nion.patch.combine(input, {\n    x: 10,\n    y: 20,\n    z: {\n        a: 1,\n        b: 2\n    },\n    w: ion.patch.combine(new Point(), {\n        x: 0,\n        y: 0\n    })\n});",
  "let point = new Point\n    [x]: 1\n    [y]: 2": "'use strict';\nlet point = new Point();\n{\n    point[x] = 1;\n    point[y] = 2;\n}",
  "let self = @\nlet x = @x\nlet y = @.y\nlet z = this.z": "'use strict';\nlet self = this;\nlet x = this.x;\nlet y = this.y;\nlet z = this.z;",
  "let x = {}\n    [key]: value": "'use strict';\nlet x = {};\nx[key] = value;",
  "if foo\n    return {}\n        for key, value of object\n            [key]: value": "'use strict';\nif (foo) {\n    let _ref = {};\n    for (let key in object) {\n        let value = object[key];\n        _ref[key] = value;\n    }\n    return _ref;\n}",
  "for x, y, z of foo\n    log(foo)": {
    line: 1,
    column: 11
  },
  "export let x": {
    line: 1,
    column: 12
  },
  "export const x": {
    line: 1,
    column: 14
  },
  "export const x = 1\nexport {y:2}": {
    line: 2,
    column: 1
  },
  "const x = 1\nx = 2": {
    line: 2,
    column: 1
  },
  "const double = (x) ->\n    x *= 2\n    return x": "'use strict';\nconst double = function (x) {\n    x *= 2;\n    return x;\n};",
  "x = 1": {
    line: 1,
    column: 1
  },
  "let x = 1\nlet x = 2": {
    line: 2,
    column: 5
  },
  "let x = 1\nconst double = (x) ->\n    return x": "'use strict';\nlet x = 1;\nconst double = function (x) {\n    return x;\n};",
  "console.log(x)\nif a\n    let x = 1": {
    line: 1,
    column: 13
  },
  "if typeof a is 'string' and void a and delete a.b\n    log(a)": "'use strict';\nif (typeof a === 'string' && void a && delete a.b) {\n    log(a);\n}",
  "if 1\n    # 1\n    # 2\n    x = 12": {
    line: 4,
    column: 5
  },
  "export const\n    BlockStatement =\n        isBlock: true\n        newScope: tr ue": {
    line: 4,
    column: 22
  },
  "export class Foo extends import 'Bar'\n    constructor: (x,y) ->\n        @x = x\n        @y = y\n    properties:\n        x: 1\n        y: 2\n        getXY: -> [@x,@y]\n    isThisPropertyStatic: true": "'use strict';\nconst ion = require('ion');\nconst Foo = ion.defineClass({\n        name: 'Foo',\n        constructor: function Foo(x, y) {\n            this.x = x;\n            this.y = y;\n        },\n        properties: {\n            x: 1,\n            y: 2,\n            getXY: function () {\n                return [\n                    this.x,\n                    this.y\n                ];\n            }\n        },\n        isThisPropertyStatic: true\n    }, require('Bar'));\nmodule.exports = exports = Foo;",
  "const double(a) -> a * 2": "'use strict';\nfunction double(a) {\n    return a * 2;\n}",
  "const double(a) -> a * 2\ndouble = 12": {
    line: 2,
    column: 1
  },
  "let object =\n    const double(a) -> a * 2\n    if a\n        [key]: value\n    else\n        foo: double(2)": "'use strict';\nlet object = {};\n{\n    function double(a) {\n        return a * 2;\n    }\n    if (a) {\n        object[key] = value;\n    } else {\n        object.foo = double(2);\n    }\n}",
  "let items = []\n    for key, value of window\n        value": "'use strict';\nlet items = [];\nfor (let key in window) {\n    let value = window[key];\n    items.push(value);\n}",
  "let foo = div()\n    span()\n        'Hello'": "'use strict';\nconst ion = require('ion');\nlet foo = div();\nlet _ref = span();\nion.add(_ref, 'Hello');\nion.add(foo, _ref);",
  "const ion = import './'\nlet foo = div()\n    span()\n        'Hello'": "'use strict';\nconst ion = require('./');\nlet foo = div();\nlet _ref = span();\nion.add(_ref, 'Hello');\nion.add(foo, _ref);",
  "const translate({x,y}) ->\n    x++\n    y++\n    return {x,y}": "'use strict';\nfunction translate(_ref) {\n    let x = _ref.x;\n    let y = _ref.y;\n    x++;\n    y++;\n    return {\n        x: x,\n        y: y\n    };\n}",
  "let x = foo(\n    ''\n        multiline string literal\n    \"\"\n        multiline string template\n)": "'use strict';\nlet x = foo('multiline string literal', 'multiline string template');",
  "assert x is 2": "'use strict';\nif (!(x === 2))\n    throw new Error('Assertion Failed: (x is 2)');",
  "export class Point\n    constructor: ->\n        # call super with arguments object\n        super\n        # call super again with explicit arguments\n        super(width, height)\n        # calling twice is silly, but legal\n    properties:\n        x: 0\n        y: 0\n        superIdentifier: (x, y) -> super\n        superExplicit: (a, b) -> super(a, b)": "'use strict';\nconst ion = require('ion');\nconst Point = ion.defineClass({\n        name: 'Point',\n        constructor: function Point() {\n            Point.super.apply(this, arguments);\n            Point.super.call(this, width, height);\n        },\n        properties: {\n            x: 0,\n            y: 0,\n            superIdentifier: function (x, y) {\n                return Point.super.prototype.superIdentifier.apply(this, arguments);\n            },\n            superExplicit: function (a, b) {\n                return Point.super.prototype.superExplicit.call(this, a, b);\n            }\n        }\n    });\nmodule.exports = exports = Point;",
  "const spreadFunction1(a, b, ...c) ->\n    log(1)\nconst spreadFunction2(a, b, ...c, d, e) ->\n    log(2)\nconst spreadFunction3(a,b, ...c, {d,e}) ->\n    log(3)": "'use strict';\nfunction spreadFunction1(a, b, ___c) {\n    let c = Array.prototype.slice.call(arguments, 2);\n    log(1);\n}\nfunction spreadFunction2(a, b, ___c, d, e) {\n    let c = Array.prototype.slice.call(arguments, 2, arguments.length - 2);\n    d = arguments[arguments.length - 2];\n    e = arguments[arguments.length - 1];\n    log(2);\n}\nfunction spreadFunction3(a, b, ___c, _ref) {\n    let c = Array.prototype.slice.call(arguments, 2, arguments.length - 1);\n    _ref = arguments[arguments.length - 1];\n    let d = _ref.d;\n    let e = _ref.e;\n    log(3);\n}",
  "# default value for a should be set before b\nconst foo(a = 0, b = a) -> a + b": "'use strict';\nfunction foo(a, b) {\n    if (a == null)\n        a = 0;\n    if (b == null)\n        b = a;\n    return a + b;\n}",
  "export template ->\n    # cannot define classes in templates\n    class Poo": {
    line: 3,
    column: 5
  },
  "export template ->\n    # cannot for loop in templates\n    for let i = 0; i < 10; i++\n        console.log(i)": {
    line: 3,
    column: 5
  },
  "export template ->\n    # cannot export in templates\n    export x": {
    line: 3,
    column: 5
  },
  "export template ->\n    # cannot try/catch in templates\n    try\n        return 0\n    catch e\n        return 1": {
    line: 3,
    column: 5
  },
  "export template ->\n    # cannot throw errors in templates\n    throw new Error": {
    line: 3,
    column: 5
  },
  "export template ->\n    const x = 12\n    # cannot assign to const variables, make sure enforced within template\n    x = 10\n    return x": {
    line: 4,
    column: 5
  },
  "export template ->\n    let x = 12\n    # cannot assign to let variables either.\n    x = 12\n    return x": {
    line: 4,
    column: 5
  },
  "export template ->\n    let x = {y:10}\n    # cannot assign to anything really.\n    x.y = 12\n    return x.y": {
    line: 4,
    column: 5
  },
  "export template (a) ->\n    # cannot assign to parameters either\n    a = 10\n    return a": {
    line: 3,
    column: 5
  },
  "export class Foo\n    constructor: ->\n        # there was a problem with existential operators not processing within class definitions\n        if properties?\n            log(properties)": "'use strict';\nconst ion = require('ion');\nconst Foo = ion.defineClass({\n        name: 'Foo',\n        constructor: function Foo() {\n            if (properties != null) {\n                log(properties);\n            }\n        }\n    });\nmodule.exports = exports = Foo;",
  "const ctor = @@\nconst ctorName = @@name": "'use strict';\nconst ctor = this.constructor;\nconst ctorName = this.constructor.name;",
  "const inlineThrow() -> throw new Error('inline throw')": "'use strict';\nfunction inlineThrow() {\n    throw new Error('inline throw');\n}",
  "class DynamicExpression\n    observe: ->\n        let x = @x ?= []": "'use strict';\nconst ion = require('ion');\nconst DynamicExpression = ion.defineClass({\n        name: 'DynamicExpression',\n        observe: function () {\n            let x = this.x = this.x != null ? this.x : [];\n        }\n    });\nDynamicExpression;",
  "let a = new Point(\n    1\n    2\n)": "'use strict';\nlet a = new Point(1, 2);",
  "let x = [y for y in z]": "'use strict';\nlet _ref = [];\nfor (let _i = 0; _i < z.length; _i++) {\n    let y = z[_i];\n    _ref.push(y);\n}\nlet x = _ref;",
  "return\n    z: []\n        let items = [3,2,1]\n        for item in items\n            item * 2": "'use strict';\nlet _ref = [];\n{\n    let items = [\n            3,\n            2,\n            1\n        ];\n    for (let _i = 0; _i < items.length; _i++) {\n        let item = items[_i];\n        _ref.push(item * 2);\n    }\n}\nreturn { z: _ref };",
  "let x = `y == null`": "'use strict';\nlet x = y == null;",
  "# should get accurate error locations even from inline javascript expressions\nlet x = `y := null`": {
    line: 2,
    column: 13
  },
  "let x = 0 in Array\nlet y = \"foo\" instanceof String": "'use strict';\nlet x = 0 in Array;\nlet y = 'foo' instanceof String;",
  "let output\noutput :=\n    x: 1\n    y: 2": "'use strict';\nconst ion = require('ion');\nlet output;\noutput = ion.patch.combine(output, {\n    x: 1,\n    y: 2\n});",
  "output\n    for a in b\n        [c]: d": "'use strict';\nlet _ref = output;\nfor (let _i = 0; _i < b.length; _i++) {\n    let a = b[_i];\n    _ref[c] = d;\n}\n_ref;",
  "#\n#\n\n#": "'use strict';",
  "[a for a in b]\n[a for a in c]": "'use strict';\nlet _ref = [];\nfor (let _i = 0; _i < b.length; _i++) {\n    let a = b[_i];\n    _ref.push(a);\n}\n_ref;\nlet _ref2 = [];\nfor (let _i2 = 0; _i2 < c.length; _i2++) {\n    let a = c[_i2];\n    _ref2.push(a);\n}\n_ref2;",
  "let array = []\n    1, 0, 0\n    0, 1, 0\n    0, 0, 1": "'use strict';\nlet array = [\n        1,\n        0,\n        0,\n        0,\n        1,\n        0,\n        0,\n        0,\n        1\n    ];",
  "import(foo).bar": "'use strict';\nrequire(foo).bar;",
  "let x = []\n    ->": "'use strict';\nlet x = [function () {\n        }];",
  "x\n    delete: true": "'use strict';\nconst ion = require('ion');\nion.patch.combine(x, { delete: true });",
  "return\n    style:\n        fontSize: \"0.7em\"\n    \"delete\"": "'use strict';\nconst ion = require('ion');\nlet _ref = {};\n{\n    _ref.style = ion.patch.combine(_ref.style, { fontSize: '0.7em' });\n    ion.add(_ref, 'delete');\n}\nreturn _ref;"
};

if (global.window != null) {
  return;
}

exports.test = function() {
  var e, error, expected, input, key, loc, options, output, value;
  for (input in tests) {
    expected = tests[input];
    options = {
      target: 'es6'
    };
    if (expected === null) {
      loc = false;
      console.log('---------------------------------------------------');
      console.log(JSON.stringify(index.compile(input, ion.patch({
        postprocess: false,
        loc: loc
      }, options)), null, '  '));
      console.log('-Postprocessed-------------------------------------');
      console.log(JSON.stringify(index.compile(input, ion.patch({
        generate: false,
        loc: loc
      }, options)), null, '  '));
      console.log('---------------------------------------------------');
      console.log(index.compile(input, ion.patch({
        loc: loc
      }, options)));
    } else if (typeof expected === 'object') {
      error = null;
      try {
        index.compile(input, options);
      } catch (_error) {
        e = _error;
        error = e;
        for (key in expected) {
          value = expected[key];
          if (value !== e[key]) {
            throw new Error("\n" + (JSON.stringify(e)) + "\n!=\n" + (JSON.stringify(expected)));
          }
        }
      }
      if (error == null) {
        throw new Error("Expected an error: " + (JSON.stringify(expected)));
      }
    } else {
      output = index.compile(input, options);
      if (output.trim() !== expected.trim()) {
        console.log('-Output---------------------------------------------');
        console.log(output);
        throw new Error("\n" + output + "\n!=\n" + expected);
      }
    }
  }
};

  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/test/ionCompiler',_ion_test_ionCompiler_);
    else
      _ion_test_ionCompiler_.call(this, module, exports, require);
  }
  else {
    _ion_test_ionCompiler_.call(this);
  }
}).call(this)
void (function(){var _ion_test_ionCompilerES5_ = function(module,exports,require){var index, ion, tests;

ion = require('../');

index = require('../compiler');

tests = {
  "let x = 10": "'use strict';\nvar x = 10;",
  "let x = 10\nif foo\n    let y = 20\nif bar\n    const y = 30": "'use strict';\nvar x = 10;\nif (foo) {\n    var y = 20;\n}\nif (bar) {\n    var y = 30;\n}",
  "export class StampFilter\n    stamp: (key, object) ->\n        for name, property of key.type.properties if property.stamp\n            log(name)": "'use strict';\nvar ion = require('ion');\nvar StampFilter = ion.defineClass({\n        name: 'StampFilter',\n        stamp: function (key, object) {\n            {\n                var _ref = key.type.properties;\n                for (var name in _ref) {\n                    var property = _ref[name];\n                    if (property.stamp) {\n                        log(name);\n                    }\n                }\n            }\n        }\n    });\nmodule.exports = exports = StampFilter;",
  "let foo = bar(\n    1\n    2\n)\n.toString(\n    \"12\"\n)\n.split(' ')": "'use strict';\nvar foo = bar(1, 2).toString('12').split(' ');",
  "\"\"\n    foo\n    bar #baz": "'use strict';\n'foo\\nbar #baz';",
  "let object =\n    x: 10\n    property visible:\n        get: -> true\n    y: 20": "'use strict';\nvar object = Object.defineProperties({\n        x: 10,\n        y: 20\n    }, {\n        visible: {\n            get: function () {\n                return true;\n            }\n        }\n    });",
  "return {a:b ? c}\n    d": "'use strict';\nvar ion = require('ion');\nvar _ref = { a: b != null ? b : c };\nion.add(_ref, d);\nreturn _ref;",
  "template (model) ->\n    return (e) ->\n        let {listModel} = model\n": "'use strict';\nvar ion = require('ion');\nion.template(function (model) {\n    return ion.createRuntime({\n        type: 'Template',\n        id: null,\n        body: [{\n                type: 'ReturnStatement',\n                argument: {\n                    type: 'Function',\n                    context: true,\n                    value: function (_context) {\n                        return function (e) {\n                            var model = _context.get('model');\n                            var _ref = model;\n                            var listModel = _ref.listModel;\n                        };\n                    }\n                },\n                order: '0'\n            }],\n        bound: false\n    }, {\n        this: this,\n        model: model\n    }, null);\n});",
  "foo:\n    a: 1": {
    line: 1,
    column: 1
  },
  "style.sheets:\n    [module.id]: \"\"": {
    line: 1,
    column: 1
  }
};

if (global.window != null) {
  return;
}

exports.test = function() {
  var e, error, expected, input, key, options, output, value;
  for (input in tests) {
    expected = tests[input];
    options = {
      target: 'es5'
    };
    if (expected === null) {
      index.compile(input, ion.patch({
        loc: false,
        source: 'ionCompilerES5.js',
        debug: true
      }, options));
    } else if (typeof expected === 'object') {
      error = null;
      try {
        index.compile(input, options);
      } catch (_error) {
        e = _error;
        error = e;
        for (key in expected) {
          value = expected[key];
          if (value !== e[key]) {
            throw new Error("\n" + (JSON.stringify(e)) + "\n!=\n" + (JSON.stringify(expected)));
          }
        }
      }
      if (error == null) {
        throw new Error("Expected an error: " + (JSON.stringify(expected)));
      }
    } else {
      output = index.compile(input, options);
      if (output.trim() !== expected.trim()) {
        console.log('-Output---------------------------------------------');
        console.log(output);
        throw new Error("\n" + output + "\n!=\n" + expected);
      }
    }
  }
};

  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/test/ionCompilerES5',_ion_test_ionCompilerES5_);
    else
      _ion_test_ionCompilerES5_.call(this, module, exports, require);
  }
  else {
    _ion_test_ionCompilerES5_.call(this);
  }
}).call(this)
void (function(){var _ion_test_reactiveTemplates_ = function(module,exports,require){'use strict';
var ion = require('../');
var _ref4 = [];
{
    _ref4.push('this');
    var object = {
            x: 1,
            y: 2
        };
    _ref4.push(object);
    _ref4.push(ion.template(function () {
        return ion.createRuntime({
            type: 'Template',
            id: null,
            body: [{
                    type: 'ReturnStatement',
                    argument: {
                        type: 'BinaryExpression',
                        operator: '+',
                        left: {
                            type: 'MemberExpression',
                            computed: false,
                            object: { type: 'ThisExpression' },
                            property: {
                                type: 'Identifier',
                                name: 'x',
                                loc: {
                                    start: {
                                        line: 99,
                                        column: 25,
                                        fixed: true,
                                        source: 'ion/test/reactiveTemplates.ion'
                                    },
                                    end: {
                                        line: 99,
                                        column: 26,
                                        fixed: true,
                                        source: 'ion/test/reactiveTemplates.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 99,
                                    column: 20,
                                    fixed: true,
                                    source: 'ion/test/reactiveTemplates.ion'
                                },
                                end: {
                                    line: 99,
                                    column: 26,
                                    fixed: true,
                                    source: 'ion/test/reactiveTemplates.ion'
                                }
                            }
                        },
                        right: {
                            type: 'MemberExpression',
                            computed: false,
                            object: { type: 'ThisExpression' },
                            property: {
                                type: 'Identifier',
                                name: 'y',
                                loc: {
                                    start: {
                                        line: 99,
                                        column: 34,
                                        fixed: true,
                                        source: 'ion/test/reactiveTemplates.ion'
                                    },
                                    end: {
                                        line: 99,
                                        column: 35,
                                        fixed: true,
                                        source: 'ion/test/reactiveTemplates.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 99,
                                    column: 29,
                                    fixed: true,
                                    source: 'ion/test/reactiveTemplates.ion'
                                },
                                end: {
                                    line: 99,
                                    column: 35,
                                    fixed: true,
                                    source: 'ion/test/reactiveTemplates.ion'
                                }
                            }
                        }
                    },
                    order: '0'
                }],
            bound: false
        }, {
            this: this,
            object: object,
            ion: ion,
            _ref4: _ref4,
            templates: templates,
            _ref5: _ref5
        }, null);
    }));
    _ref4.push(object);
    _ref4.push({ x: 10 });
    _ref4.push(12);
}
var templates = [
        [
            'regular expression',
            {},
            ion.template(function (properties) {
                return ion.createRuntime({
                    type: 'Template',
                    id: null,
                    body: [{
                            type: 'ReturnStatement',
                            argument: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'properties',
                                            loc: {
                                                start: {
                                                    line: 8,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'ion/test/reactiveTemplates.ion'
                                                },
                                                end: {
                                                    line: 8,
                                                    column: 29,
                                                    fixed: true,
                                                    source: 'ion/test/reactiveTemplates.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'name',
                                            loc: {
                                                start: {
                                                    line: 8,
                                                    column: 30,
                                                    fixed: true,
                                                    source: 'ion/test/reactiveTemplates.ion'
                                                },
                                                end: {
                                                    line: 8,
                                                    column: 34,
                                                    fixed: true,
                                                    source: 'ion/test/reactiveTemplates.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 8,
                                                column: 19,
                                                fixed: true,
                                                source: 'ion/test/reactiveTemplates.ion'
                                            },
                                            end: {
                                                line: 8,
                                                column: 34,
                                                fixed: true,
                                                source: 'ion/test/reactiveTemplates.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'replace',
                                        loc: {
                                            start: {
                                                line: 8,
                                                column: 35,
                                                fixed: true,
                                                source: 'ion/test/reactiveTemplates.ion'
                                            },
                                            end: {
                                                line: 8,
                                                column: 42,
                                                fixed: true,
                                                source: 'ion/test/reactiveTemplates.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 8,
                                            column: 19,
                                            fixed: true,
                                            source: 'ion/test/reactiveTemplates.ion'
                                        },
                                        end: {
                                            line: 8,
                                            column: 42,
                                            fixed: true,
                                            source: 'ion/test/reactiveTemplates.ion'
                                        }
                                    }
                                },
                                arguments: [
                                    {
                                        type: 'Literal',
                                        value: /a/g
                                    },
                                    {
                                        type: 'Literal',
                                        value: 'b'
                                    }
                                ],
                                loc: {
                                    start: {
                                        line: 8,
                                        column: 19,
                                        fixed: true,
                                        source: 'ion/test/reactiveTemplates.ion'
                                    },
                                    end: {
                                        line: 8,
                                        column: 53,
                                        fixed: true,
                                        source: 'ion/test/reactiveTemplates.ion'
                                    }
                                }
                            },
                            order: '0'
                        }],
                    bound: false
                }, {
                    this: this,
                    properties: properties,
                    ion: ion,
                    _ref4: _ref4,
                    templates: templates,
                    _ref5: _ref5
                }, null);
            }),
            { name: 'alpha' },
            {},
            'blphb'
        ],
        [
            'array comprehension for of',
            {},
            ion.template(function (properties) {
                return ion.createRuntime({
                    type: 'Template',
                    id: null,
                    body: [{
                            type: 'ReturnStatement',
                            argument: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'ArrayExpression',
                                    elements: []
                                },
                                properties: [{
                                        type: 'ForInStatement',
                                        left: {
                                            type: 'VariableDeclaration',
                                            declarations: [{
                                                    type: 'VariableDeclarator',
                                                    id: {
                                                        type: 'Identifier',
                                                        name: 'key',
                                                        loc: {
                                                            start: {
                                                                line: 16,
                                                                column: 28,
                                                                fixed: true,
                                                                source: 'ion/test/reactiveTemplates.ion'
                                                            },
                                                            end: {
                                                                line: 16,
                                                                column: 31,
                                                                fixed: true,
                                                                source: 'ion/test/reactiveTemplates.ion'
                                                            }
                                                        }
                                                    },
                                                    init: null
                                                }],
                                            kind: 'let'
                                        },
                                        right: {
                                            type: 'Identifier',
                                            name: 'properties',
                                            loc: {
                                                start: {
                                                    line: 16,
                                                    column: 35,
                                                    fixed: true,
                                                    source: 'ion/test/reactiveTemplates.ion'
                                                },
                                                end: {
                                                    line: 16,
                                                    column: 45,
                                                    fixed: true,
                                                    source: 'ion/test/reactiveTemplates.ion'
                                                }
                                            }
                                        },
                                        body: {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'Identifier',
                                                name: 'key',
                                                loc: {
                                                    start: {
                                                        line: 16,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'ion/test/reactiveTemplates.ion'
                                                    },
                                                    end: {
                                                        line: 16,
                                                        column: 23,
                                                        fixed: true,
                                                        source: 'ion/test/reactiveTemplates.ion'
                                                    }
                                                }
                                            }
                                        },
                                        order: '0'
                                    }]
                            },
                            order: '0'
                        }],
                    bound: false
                }, {
                    this: this,
                    properties: properties,
                    ion: ion,
                    _ref4: _ref4,
                    templates: templates,
                    _ref5: _ref5
                }, null);
            }),
            {
                a: 1,
                b: 2
            },
            {
                b: void 0,
                c: 3
            },
            [
                'a',
                'c'
            ]
        ],
        [
            'imperative functions',
            {},
            ion.template(function (properties) {
                return ion.createRuntime({
                    type: 'Template',
                    id: null,
                    body: [
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'double',
                                        loc: {
                                            start: {
                                                line: 24,
                                                column: 18,
                                                fixed: true,
                                                source: 'ion/test/reactiveTemplates.ion'
                                            },
                                            end: {
                                                line: 24,
                                                column: 24,
                                                fixed: true,
                                                source: 'ion/test/reactiveTemplates.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'Function',
                                        context: false,
                                        value: function double(a) {
                                            return a * 2;
                                        }
                                    }
                                }],
                            kind: 'const',
                            order: '0'
                        },
                        {
                            type: 'ReturnStatement',
                            argument: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'ObjectExpression',
                                    properties: []
                                },
                                properties: [{
                                        type: 'ForInStatement',
                                        left: {
                                            type: 'VariableDeclaration',
                                            declarations: [
                                                {
                                                    type: 'VariableDeclarator',
                                                    id: {
                                                        type: 'Identifier',
                                                        name: 'key',
                                                        loc: {
                                                            start: {
                                                                line: 26,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'ion/test/reactiveTemplates.ion'
                                                            },
                                                            end: {
                                                                line: 26,
                                                                column: 23,
                                                                fixed: true,
                                                                source: 'ion/test/reactiveTemplates.ion'
                                                            }
                                                        }
                                                    },
                                                    init: null
                                                },
                                                {
                                                    type: 'VariableDeclarator',
                                                    id: {
                                                        type: 'Identifier',
                                                        name: 'value',
                                                        loc: {
                                                            start: {
                                                                line: 26,
                                                                column: 25,
                                                                fixed: true,
                                                                source: 'ion/test/reactiveTemplates.ion'
                                                            },
                                                            end: {
                                                                line: 26,
                                                                column: 30,
                                                                fixed: true,
                                                                source: 'ion/test/reactiveTemplates.ion'
                                                            }
                                                        }
                                                    },
                                                    init: null
                                                }
                                            ],
                                            kind: 'let'
                                        },
                                        right: {
                                            type: 'Identifier',
                                            name: 'properties',
                                            loc: {
                                                start: {
                                                    line: 26,
                                                    column: 34,
                                                    fixed: true,
                                                    source: 'ion/test/reactiveTemplates.ion'
                                                },
                                                end: {
                                                    line: 26,
                                                    column: 44,
                                                    fixed: true,
                                                    source: 'ion/test/reactiveTemplates.ion'
                                                }
                                            }
                                        },
                                        body: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'key',
                                                        loc: {
                                                            start: {
                                                                line: 27,
                                                                column: 21,
                                                                fixed: true,
                                                                source: 'ion/test/reactiveTemplates.ion'
                                                            },
                                                            end: {
                                                                line: 27,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'ion/test/reactiveTemplates.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'Identifier',
                                                            name: 'double',
                                                            loc: {
                                                                start: {
                                                                    line: 27,
                                                                    column: 27,
                                                                    fixed: true,
                                                                    source: 'ion/test/reactiveTemplates.ion'
                                                                },
                                                                end: {
                                                                    line: 27,
                                                                    column: 33,
                                                                    fixed: true,
                                                                    source: 'ion/test/reactiveTemplates.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [{
                                                                type: 'Identifier',
                                                                name: 'value',
                                                                loc: {
                                                                    start: {
                                                                        line: 27,
                                                                        column: 34,
                                                                        fixed: true,
                                                                        source: 'ion/test/reactiveTemplates.ion'
                                                                    },
                                                                    end: {
                                                                        line: 27,
                                                                        column: 39,
                                                                        fixed: true,
                                                                        source: 'ion/test/reactiveTemplates.ion'
                                                                    }
                                                                }
                                                            }],
                                                        loc: {
                                                            start: {
                                                                line: 27,
                                                                column: 27,
                                                                fixed: true,
                                                                source: 'ion/test/reactiveTemplates.ion'
                                                            },
                                                            end: {
                                                                line: 27,
                                                                column: 40,
                                                                fixed: true,
                                                                source: 'ion/test/reactiveTemplates.ion'
                                                            }
                                                        }
                                                    },
                                                    kind: 'init',
                                                    computed: true,
                                                    order: '0'
                                                }]
                                        },
                                        remove: null,
                                        order: '0'
                                    }]
                            },
                            order: '1'
                        }
                    ],
                    bound: false
                }, {
                    this: this,
                    properties: properties,
                    ion: ion,
                    _ref4: _ref4,
                    templates: templates,
                    _ref5: _ref5
                }, null);
            }),
            {
                x: 1,
                y: 2
            },
            {
                x: 4,
                z: 3,
                y: void 0
            },
            {
                x: 8,
                z: 6
            }
        ],
        [
            'reactive destructured parameters',
            {},
            ion.template(function (_ref) {
                return ion.createRuntime({
                    type: 'Template',
                    id: null,
                    body: [
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'a',
                                        loc: {
                                            start: {
                                                line: 46,
                                                column: 19,
                                                fixed: true,
                                                source: 'ion/test/reactiveTemplates.ion'
                                            },
                                            end: {
                                                line: 46,
                                                column: 20,
                                                fixed: true,
                                                source: 'ion/test/reactiveTemplates.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'MemberExpression',
                                        object: {
                                            type: 'Identifier',
                                            name: '_ref'
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'a',
                                            loc: {
                                                start: {
                                                    line: 46,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'ion/test/reactiveTemplates.ion'
                                                },
                                                end: {
                                                    line: 46,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'ion/test/reactiveTemplates.ion'
                                                }
                                            }
                                        },
                                        computed: false
                                    }
                                }],
                            kind: 'let',
                            order: '0'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'b',
                                        loc: {
                                            start: {
                                                line: 46,
                                                column: 21,
                                                fixed: true,
                                                source: 'ion/test/reactiveTemplates.ion'
                                            },
                                            end: {
                                                line: 46,
                                                column: 22,
                                                fixed: true,
                                                source: 'ion/test/reactiveTemplates.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'MemberExpression',
                                        object: {
                                            type: 'Identifier',
                                            name: '_ref'
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'b',
                                            loc: {
                                                start: {
                                                    line: 46,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'ion/test/reactiveTemplates.ion'
                                                },
                                                end: {
                                                    line: 46,
                                                    column: 22,
                                                    fixed: true,
                                                    source: 'ion/test/reactiveTemplates.ion'
                                                }
                                            }
                                        },
                                        computed: false
                                    }
                                }],
                            kind: 'let',
                            order: '1'
                        },
                        {
                            type: 'ReturnStatement',
                            argument: {
                                type: 'BinaryExpression',
                                operator: '+',
                                left: {
                                    type: 'Identifier',
                                    name: 'a',
                                    loc: {
                                        start: {
                                            line: 46,
                                            column: 28,
                                            fixed: true,
                                            source: 'ion/test/reactiveTemplates.ion'
                                        },
                                        end: {
                                            line: 46,
                                            column: 29,
                                            fixed: true,
                                            source: 'ion/test/reactiveTemplates.ion'
                                        }
                                    }
                                },
                                right: {
                                    type: 'Identifier',
                                    name: 'b',
                                    loc: {
                                        start: {
                                            line: 46,
                                            column: 32,
                                            fixed: true,
                                            source: 'ion/test/reactiveTemplates.ion'
                                        },
                                        end: {
                                            line: 46,
                                            column: 33,
                                            fixed: true,
                                            source: 'ion/test/reactiveTemplates.ion'
                                        }
                                    }
                                }
                            },
                            order: '2'
                        }
                    ],
                    bound: false
                }, {
                    this: this,
                    _ref: _ref,
                    ion: ion,
                    _ref4: _ref4,
                    templates: templates,
                    _ref5: _ref5
                }, null);
            }),
            {
                a: 1,
                b: 2
            },
            { a: 5 },
            7
        ],
        [
            'array comprehension for in',
            {},
            ion.template(function (_ref2) {
                return ion.createRuntime({
                    type: 'Template',
                    id: null,
                    body: [
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'items',
                                        loc: {
                                            start: {
                                                line: 53,
                                                column: 19,
                                                fixed: true,
                                                source: 'ion/test/reactiveTemplates.ion'
                                            },
                                            end: {
                                                line: 53,
                                                column: 24,
                                                fixed: true,
                                                source: 'ion/test/reactiveTemplates.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'MemberExpression',
                                        object: {
                                            type: 'Identifier',
                                            name: '_ref2'
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'items',
                                            loc: {
                                                start: {
                                                    line: 53,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'ion/test/reactiveTemplates.ion'
                                                },
                                                end: {
                                                    line: 53,
                                                    column: 24,
                                                    fixed: true,
                                                    source: 'ion/test/reactiveTemplates.ion'
                                                }
                                            }
                                        },
                                        computed: false
                                    }
                                }],
                            kind: 'let',
                            order: '0'
                        },
                        {
                            type: 'ReturnStatement',
                            argument: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'ArrayExpression',
                                    elements: []
                                },
                                properties: [{
                                        type: 'ForOfStatement',
                                        left: {
                                            type: 'VariableDeclaration',
                                            declarations: [
                                                {
                                                    type: 'VariableDeclarator',
                                                    id: {
                                                        type: 'Identifier',
                                                        name: 'x',
                                                        loc: {
                                                            start: {
                                                                line: 53,
                                                                column: 41,
                                                                fixed: true,
                                                                source: 'ion/test/reactiveTemplates.ion'
                                                            },
                                                            end: {
                                                                line: 53,
                                                                column: 42,
                                                                fixed: true,
                                                                source: 'ion/test/reactiveTemplates.ion'
                                                            }
                                                        }
                                                    },
                                                    init: null
                                                },
                                                {
                                                    type: 'VariableDeclarator',
                                                    id: {
                                                        type: 'Identifier',
                                                        name: 'i',
                                                        loc: {
                                                            start: {
                                                                line: 53,
                                                                column: 44,
                                                                fixed: true,
                                                                source: 'ion/test/reactiveTemplates.ion'
                                                            },
                                                            end: {
                                                                line: 53,
                                                                column: 45,
                                                                fixed: true,
                                                                source: 'ion/test/reactiveTemplates.ion'
                                                            }
                                                        }
                                                    },
                                                    init: null
                                                }
                                            ],
                                            kind: 'let'
                                        },
                                        right: {
                                            type: 'Identifier',
                                            name: 'items',
                                            loc: {
                                                start: {
                                                    line: 53,
                                                    column: 49,
                                                    fixed: true,
                                                    source: 'ion/test/reactiveTemplates.ion'
                                                },
                                                end: {
                                                    line: 53,
                                                    column: 54,
                                                    fixed: true,
                                                    source: 'ion/test/reactiveTemplates.ion'
                                                }
                                            }
                                        },
                                        body: {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'BinaryExpression',
                                                operator: '+',
                                                left: {
                                                    type: 'Identifier',
                                                    name: 'x',
                                                    loc: {
                                                        start: {
                                                            line: 53,
                                                            column: 31,
                                                            fixed: true,
                                                            source: 'ion/test/reactiveTemplates.ion'
                                                        },
                                                        end: {
                                                            line: 53,
                                                            column: 32,
                                                            fixed: true,
                                                            source: 'ion/test/reactiveTemplates.ion'
                                                        }
                                                    }
                                                },
                                                right: {
                                                    type: 'Identifier',
                                                    name: 'i',
                                                    loc: {
                                                        start: {
                                                            line: 53,
                                                            column: 35,
                                                            fixed: true,
                                                            source: 'ion/test/reactiveTemplates.ion'
                                                        },
                                                        end: {
                                                            line: 53,
                                                            column: 36,
                                                            fixed: true,
                                                            source: 'ion/test/reactiveTemplates.ion'
                                                        }
                                                    }
                                                }
                                            }
                                        },
                                        order: '0'
                                    }]
                            },
                            order: '1'
                        }
                    ],
                    bound: false
                }, {
                    this: this,
                    _ref2: _ref2,
                    ion: ion,
                    _ref4: _ref4,
                    templates: templates,
                    _ref5: _ref5
                }, null);
            }),
            {
                items: [
                    1,
                    2,
                    3
                ]
            },
            { items: { 3: 4 } },
            [
                1,
                3,
                5,
                7
            ]
        ],
        [
            'changing object with function',
            {},
            ion.template(function (object) {
                return ion.createRuntime({
                    type: 'Template',
                    id: null,
                    body: [{
                            type: 'ReturnStatement',
                            argument: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'object',
                                        loc: {
                                            start: {
                                                line: 60,
                                                column: 29,
                                                fixed: true,
                                                source: 'ion/test/reactiveTemplates.ion'
                                            },
                                            end: {
                                                line: 60,
                                                column: 35,
                                                fixed: true,
                                                source: 'ion/test/reactiveTemplates.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'sum',
                                        loc: {
                                            start: {
                                                line: 60,
                                                column: 36,
                                                fixed: true,
                                                source: 'ion/test/reactiveTemplates.ion'
                                            },
                                            end: {
                                                line: 60,
                                                column: 39,
                                                fixed: true,
                                                source: 'ion/test/reactiveTemplates.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 60,
                                            column: 29,
                                            fixed: true,
                                            source: 'ion/test/reactiveTemplates.ion'
                                        },
                                        end: {
                                            line: 60,
                                            column: 39,
                                            fixed: true,
                                            source: 'ion/test/reactiveTemplates.ion'
                                        }
                                    }
                                },
                                arguments: [],
                                loc: {
                                    start: {
                                        line: 60,
                                        column: 29,
                                        fixed: true,
                                        source: 'ion/test/reactiveTemplates.ion'
                                    },
                                    end: {
                                        line: 60,
                                        column: 41,
                                        fixed: true,
                                        source: 'ion/test/reactiveTemplates.ion'
                                    }
                                }
                            },
                            order: '0'
                        }],
                    bound: false
                }, {
                    this: this,
                    object: object,
                    ion: ion,
                    _ref4: _ref4,
                    templates: templates,
                    _ref5: _ref5
                }, null);
            }),
            {
                sum: function () {
                    return this.x + this.y;
                },
                x: 1,
                y: 2
            },
            { x: 6 },
            8
        ],
        [
            'nested templates',
            {},
            function () {
                return ion.template(function (object) {
                    return ion.createRuntime({
                        type: 'Template',
                        id: null,
                        body: [
                            {
                                type: 'VariableDeclaration',
                                declarations: [{
                                        type: 'VariableDeclarator',
                                        id: {
                                            type: 'Identifier',
                                            name: 'factor',
                                            loc: {
                                                start: {
                                                    line: 73,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'ion/test/reactiveTemplates.ion'
                                                },
                                                end: {
                                                    line: 73,
                                                    column: 26,
                                                    fixed: true,
                                                    source: 'ion/test/reactiveTemplates.ion'
                                                }
                                            }
                                        },
                                        init: {
                                            type: 'Literal',
                                            value: 2
                                        }
                                    }],
                                kind: 'let',
                                order: '0'
                            },
                            {
                                type: 'VariableDeclaration',
                                declarations: [{
                                        type: 'VariableDeclarator',
                                        id: {
                                            type: 'Identifier',
                                            name: 'sum',
                                            loc: {
                                                start: {
                                                    line: 74,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'ion/test/reactiveTemplates.ion'
                                                },
                                                end: {
                                                    line: 74,
                                                    column: 23,
                                                    fixed: true,
                                                    source: 'ion/test/reactiveTemplates.ion'
                                                }
                                            }
                                        },
                                        init: {
                                            type: 'Function',
                                            context: true,
                                            value: function (_ps) {
                                                return ion.template(function (_ref3) {
                                                    return ion.createRuntime({
                                                        type: 'Template',
                                                        id: null,
                                                        body: [
                                                            {
                                                                type: 'VariableDeclaration',
                                                                declarations: [{
                                                                        type: 'VariableDeclarator',
                                                                        id: {
                                                                            type: 'Identifier',
                                                                            name: 'a',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 74,
                                                                                    column: 43,
                                                                                    fixed: true,
                                                                                    source: 'ion/test/reactiveTemplates.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 74,
                                                                                    column: 44,
                                                                                    fixed: true,
                                                                                    source: 'ion/test/reactiveTemplates.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        init: {
                                                                            type: 'MemberExpression',
                                                                            object: {
                                                                                type: 'MemberExpression',
                                                                                object: {
                                                                                    type: 'Identifier',
                                                                                    name: '_ref3'
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'deep',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 74,
                                                                                            column: 37,
                                                                                            fixed: true,
                                                                                            source: 'ion/test/reactiveTemplates.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 74,
                                                                                            column: 41,
                                                                                            fixed: true,
                                                                                            source: 'ion/test/reactiveTemplates.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                computed: false
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'a',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 74,
                                                                                        column: 43,
                                                                                        fixed: true,
                                                                                        source: 'ion/test/reactiveTemplates.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 74,
                                                                                        column: 44,
                                                                                        fixed: true,
                                                                                        source: 'ion/test/reactiveTemplates.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            computed: false
                                                                        }
                                                                    }],
                                                                kind: 'let',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'VariableDeclaration',
                                                                declarations: [{
                                                                        type: 'VariableDeclarator',
                                                                        id: {
                                                                            type: 'Identifier',
                                                                            name: 'b',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 74,
                                                                                    column: 45,
                                                                                    fixed: true,
                                                                                    source: 'ion/test/reactiveTemplates.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 74,
                                                                                    column: 46,
                                                                                    fixed: true,
                                                                                    source: 'ion/test/reactiveTemplates.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        init: {
                                                                            type: 'MemberExpression',
                                                                            object: {
                                                                                type: 'MemberExpression',
                                                                                object: {
                                                                                    type: 'Identifier',
                                                                                    name: '_ref3'
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'deep',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 74,
                                                                                            column: 37,
                                                                                            fixed: true,
                                                                                            source: 'ion/test/reactiveTemplates.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 74,
                                                                                            column: 41,
                                                                                            fixed: true,
                                                                                            source: 'ion/test/reactiveTemplates.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                computed: false
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'b',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 74,
                                                                                        column: 45,
                                                                                        fixed: true,
                                                                                        source: 'ion/test/reactiveTemplates.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 74,
                                                                                        column: 46,
                                                                                        fixed: true,
                                                                                        source: 'ion/test/reactiveTemplates.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            computed: false
                                                                        }
                                                                    }],
                                                                kind: 'let',
                                                                order: '1'
                                                            },
                                                            {
                                                                type: 'ReturnStatement',
                                                                argument: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '*',
                                                                    left: {
                                                                        type: 'BinaryExpression',
                                                                        operator: '+',
                                                                        left: {
                                                                            type: 'Identifier',
                                                                            name: 'a',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 75,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'ion/test/reactiveTemplates.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 75,
                                                                                    column: 29,
                                                                                    fixed: true,
                                                                                    source: 'ion/test/reactiveTemplates.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        right: {
                                                                            type: 'Identifier',
                                                                            name: 'b',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 75,
                                                                                    column: 32,
                                                                                    fixed: true,
                                                                                    source: 'ion/test/reactiveTemplates.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 75,
                                                                                    column: 33,
                                                                                    fixed: true,
                                                                                    source: 'ion/test/reactiveTemplates.ion'
                                                                                }
                                                                            }
                                                                        }
                                                                    },
                                                                    right: {
                                                                        type: 'Identifier',
                                                                        name: 'factor',
                                                                        loc: {
                                                                            start: {
                                                                                line: 75,
                                                                                column: 37,
                                                                                fixed: true,
                                                                                source: 'ion/test/reactiveTemplates.ion'
                                                                            },
                                                                            end: {
                                                                                line: 75,
                                                                                column: 43,
                                                                                fixed: true,
                                                                                source: 'ion/test/reactiveTemplates.ion'
                                                                            }
                                                                        }
                                                                    }
                                                                },
                                                                order: '2'
                                                            }
                                                        ],
                                                        bound: false,
                                                        name: {
                                                            type: 'Identifier',
                                                            name: 'sum',
                                                            loc: {
                                                                start: {
                                                                    line: 74,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'ion/test/reactiveTemplates.ion'
                                                                },
                                                                end: {
                                                                    line: 74,
                                                                    column: 23,
                                                                    fixed: true,
                                                                    source: 'ion/test/reactiveTemplates.ion'
                                                                }
                                                            }
                                                        },
                                                        scope: {
                                                            type: 'Identifier',
                                                            name: '_ps'
                                                        }
                                                    }, {
                                                        this: this,
                                                        _ref3: _ref3,
                                                        _ps: _ps,
                                                        object: object,
                                                        ion: ion,
                                                        _ref4: _ref4,
                                                        templates: templates,
                                                        _ref5: _ref5
                                                    }, _ps);
                                                });
                                            }
                                        }
                                    }],
                                kind: 'let',
                                order: '1'
                            },
                            {
                                type: 'ReturnStatement',
                                argument: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'Identifier',
                                        name: 'sum',
                                        loc: {
                                            start: {
                                                line: 76,
                                                column: 23,
                                                fixed: true,
                                                source: 'ion/test/reactiveTemplates.ion'
                                            },
                                            end: {
                                                line: 76,
                                                column: 26,
                                                fixed: true,
                                                source: 'ion/test/reactiveTemplates.ion'
                                            }
                                        }
                                    },
                                    arguments: [{
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'object',
                                                loc: {
                                                    start: {
                                                        line: 76,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'ion/test/reactiveTemplates.ion'
                                                    },
                                                    end: {
                                                        line: 76,
                                                        column: 33,
                                                        fixed: true,
                                                        source: 'ion/test/reactiveTemplates.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'one',
                                                loc: {
                                                    start: {
                                                        line: 76,
                                                        column: 34,
                                                        fixed: true,
                                                        source: 'ion/test/reactiveTemplates.ion'
                                                    },
                                                    end: {
                                                        line: 76,
                                                        column: 37,
                                                        fixed: true,
                                                        source: 'ion/test/reactiveTemplates.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 76,
                                                    column: 27,
                                                    fixed: true,
                                                    source: 'ion/test/reactiveTemplates.ion'
                                                },
                                                end: {
                                                    line: 76,
                                                    column: 37,
                                                    fixed: true,
                                                    source: 'ion/test/reactiveTemplates.ion'
                                                }
                                            }
                                        }],
                                    loc: {
                                        start: {
                                            line: 76,
                                            column: 23,
                                            fixed: true,
                                            source: 'ion/test/reactiveTemplates.ion'
                                        },
                                        end: {
                                            line: 76,
                                            column: 38,
                                            fixed: true,
                                            source: 'ion/test/reactiveTemplates.ion'
                                        }
                                    }
                                },
                                order: '2'
                            }
                        ],
                        bound: false
                    }, {
                        this: this,
                        ion: ion,
                        object: object,
                        _ref4: _ref4,
                        templates: templates,
                        _ref5: _ref5
                    }, null);
                });
            }(),
            {
                one: {
                    deep: {
                        a: 1,
                        b: 2
                    }
                }
            },
            { one: { deep: { a: 2 } } },
            8
        ],
        [
            'literal objects',
            {},
            ion.template(function () {
                return ion.createRuntime({
                    type: 'Template',
                    id: null,
                    body: [{
                            type: 'ReturnStatement',
                            argument: {
                                type: 'ObjectExpression',
                                properties: [
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'touch',
                                            loc: {
                                                start: {
                                                    line: 91,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'ion/test/reactiveTemplates.ion'
                                                },
                                                end: {
                                                    line: 91,
                                                    column: 25,
                                                    fixed: true,
                                                    source: 'ion/test/reactiveTemplates.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: 1
                                        },
                                        kind: 'init',
                                        order: '0'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Literal',
                                            value: 'touch-start'
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: 2
                                        },
                                        kind: 'init',
                                        order: '1'
                                    }
                                ]
                            },
                            order: '0'
                        }],
                    bound: false
                }, {
                    this: this,
                    ion: ion,
                    _ref4: _ref4,
                    templates: templates,
                    _ref5: _ref5
                }, null);
            }),
            {},
            {},
            {
                touch: 1,
                'touch-start': 2
            }
        ],
        _ref4,
        [
            'correct ordering of array items',
            {},
            ion.template(function (object) {
                return ion.createRuntime({
                    type: 'Template',
                    id: null,
                    body: [{
                            type: 'ReturnStatement',
                            argument: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'ArrayExpression',
                                    elements: [
                                        {
                                            type: 'Literal',
                                            value: 1
                                        },
                                        {
                                            type: 'Literal',
                                            value: 2
                                        }
                                    ]
                                },
                                properties: [
                                    {
                                        type: 'IfStatement',
                                        test: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'object',
                                                loc: {
                                                    start: {
                                                        line: 108,
                                                        column: 19,
                                                        fixed: true,
                                                        source: 'ion/test/reactiveTemplates.ion'
                                                    },
                                                    end: {
                                                        line: 108,
                                                        column: 25,
                                                        fixed: true,
                                                        source: 'ion/test/reactiveTemplates.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'a',
                                                loc: {
                                                    start: {
                                                        line: 108,
                                                        column: 26,
                                                        fixed: true,
                                                        source: 'ion/test/reactiveTemplates.ion'
                                                    },
                                                    end: {
                                                        line: 108,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'ion/test/reactiveTemplates.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 108,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'ion/test/reactiveTemplates.ion'
                                                },
                                                end: {
                                                    line: 108,
                                                    column: 27,
                                                    fixed: true,
                                                    source: 'ion/test/reactiveTemplates.ion'
                                                }
                                            }
                                        },
                                        consequent: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'Literal',
                                                        value: 'Alpha'
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 109,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'ion/test/reactiveTemplates.ion'
                                                        },
                                                        end: {
                                                            line: 109,
                                                            column: 27,
                                                            fixed: true,
                                                            source: 'ion/test/reactiveTemplates.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        alternate: null,
                                        order: '0'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'Literal',
                                            value: 'Beta'
                                        },
                                        loc: {
                                            start: {
                                                line: 110,
                                                column: 16,
                                                fixed: true,
                                                source: 'ion/test/reactiveTemplates.ion'
                                            },
                                            end: {
                                                line: 110,
                                                column: 22,
                                                fixed: true,
                                                source: 'ion/test/reactiveTemplates.ion'
                                            }
                                        },
                                        order: '1'
                                    },
                                    {
                                        type: 'ForInStatement',
                                        left: {
                                            type: 'VariableDeclaration',
                                            declarations: [{
                                                    type: 'VariableDeclarator',
                                                    id: {
                                                        type: 'Identifier',
                                                        name: 'key',
                                                        loc: {
                                                            start: {
                                                                line: 111,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'ion/test/reactiveTemplates.ion'
                                                            },
                                                            end: {
                                                                line: 111,
                                                                column: 23,
                                                                fixed: true,
                                                                source: 'ion/test/reactiveTemplates.ion'
                                                            }
                                                        }
                                                    },
                                                    init: null
                                                }],
                                            kind: 'let'
                                        },
                                        right: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'object',
                                                loc: {
                                                    start: {
                                                        line: 111,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'ion/test/reactiveTemplates.ion'
                                                    },
                                                    end: {
                                                        line: 111,
                                                        column: 33,
                                                        fixed: true,
                                                        source: 'ion/test/reactiveTemplates.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'keys',
                                                loc: {
                                                    start: {
                                                        line: 111,
                                                        column: 34,
                                                        fixed: true,
                                                        source: 'ion/test/reactiveTemplates.ion'
                                                    },
                                                    end: {
                                                        line: 111,
                                                        column: 38,
                                                        fixed: true,
                                                        source: 'ion/test/reactiveTemplates.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 111,
                                                    column: 27,
                                                    fixed: true,
                                                    source: 'ion/test/reactiveTemplates.ion'
                                                },
                                                end: {
                                                    line: 111,
                                                    column: 38,
                                                    fixed: true,
                                                    source: 'ion/test/reactiveTemplates.ion'
                                                }
                                            }
                                        },
                                        body: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'Identifier',
                                                        name: 'key',
                                                        loc: {
                                                            start: {
                                                                line: 112,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'ion/test/reactiveTemplates.ion'
                                                            },
                                                            end: {
                                                                line: 112,
                                                                column: 23,
                                                                fixed: true,
                                                                source: 'ion/test/reactiveTemplates.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 112,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'ion/test/reactiveTemplates.ion'
                                                        },
                                                        end: {
                                                            line: 112,
                                                            column: 23,
                                                            fixed: true,
                                                            source: 'ion/test/reactiveTemplates.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        remove: null,
                                        order: '2'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'Literal',
                                            value: 'Charlie'
                                        },
                                        loc: {
                                            start: {
                                                line: 113,
                                                column: 16,
                                                fixed: true,
                                                source: 'ion/test/reactiveTemplates.ion'
                                            },
                                            end: {
                                                line: 113,
                                                column: 25,
                                                fixed: true,
                                                source: 'ion/test/reactiveTemplates.ion'
                                            }
                                        },
                                        order: '3'
                                    },
                                    {
                                        type: 'ForOfStatement',
                                        left: {
                                            type: 'VariableDeclaration',
                                            declarations: [{
                                                    type: 'VariableDeclarator',
                                                    id: {
                                                        type: 'Identifier',
                                                        name: 'item',
                                                        loc: {
                                                            start: {
                                                                line: 114,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'ion/test/reactiveTemplates.ion'
                                                            },
                                                            end: {
                                                                line: 114,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'ion/test/reactiveTemplates.ion'
                                                            }
                                                        }
                                                    },
                                                    init: null
                                                }],
                                            kind: 'let'
                                        },
                                        right: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'object',
                                                loc: {
                                                    start: {
                                                        line: 114,
                                                        column: 28,
                                                        fixed: true,
                                                        source: 'ion/test/reactiveTemplates.ion'
                                                    },
                                                    end: {
                                                        line: 114,
                                                        column: 34,
                                                        fixed: true,
                                                        source: 'ion/test/reactiveTemplates.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'items',
                                                loc: {
                                                    start: {
                                                        line: 114,
                                                        column: 35,
                                                        fixed: true,
                                                        source: 'ion/test/reactiveTemplates.ion'
                                                    },
                                                    end: {
                                                        line: 114,
                                                        column: 40,
                                                        fixed: true,
                                                        source: 'ion/test/reactiveTemplates.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 114,
                                                    column: 28,
                                                    fixed: true,
                                                    source: 'ion/test/reactiveTemplates.ion'
                                                },
                                                end: {
                                                    line: 114,
                                                    column: 40,
                                                    fixed: true,
                                                    source: 'ion/test/reactiveTemplates.ion'
                                                }
                                            }
                                        },
                                        body: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'Identifier',
                                                        name: 'item',
                                                        loc: {
                                                            start: {
                                                                line: 115,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'ion/test/reactiveTemplates.ion'
                                                            },
                                                            end: {
                                                                line: 115,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'ion/test/reactiveTemplates.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 115,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'ion/test/reactiveTemplates.ion'
                                                        },
                                                        end: {
                                                            line: 115,
                                                            column: 24,
                                                            fixed: true,
                                                            source: 'ion/test/reactiveTemplates.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        remove: null,
                                        order: '4'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'Literal',
                                            value: 'Delta'
                                        },
                                        loc: {
                                            start: {
                                                line: 116,
                                                column: 16,
                                                fixed: true,
                                                source: 'ion/test/reactiveTemplates.ion'
                                            },
                                            end: {
                                                line: 116,
                                                column: 23,
                                                fixed: true,
                                                source: 'ion/test/reactiveTemplates.ion'
                                            }
                                        },
                                        order: '5'
                                    }
                                ]
                            },
                            order: '0'
                        }],
                    bound: false
                }, {
                    this: this,
                    object: object,
                    ion: ion,
                    _ref4: _ref4,
                    templates: templates,
                    _ref5: _ref5
                }, null);
            }),
            {
                a: false,
                keys: {
                    c: 1,
                    b: 2,
                    a: 3
                },
                items: [
                    3,
                    2,
                    1
                ]
            },
            {
                a: true,
                keys: {
                    c: void 0,
                    d: 4,
                    aa: 1
                },
                items: { 0: 4 }
            },
            [
                1,
                2,
                'Alpha',
                'Beta',
                'b',
                'a',
                'd',
                'aa',
                'Charlie',
                4,
                2,
                1,
                'Delta'
            ]
        ],
        function () {
            var alpha = 100;
            var beta = 200;
            var charlie = 300;
            var next = 0;
            var nextId = function () {
                return next++;
            };
            return [
                'for in reuse values',
                {},
                ion.template(function (items) {
                    return ion.createRuntime({
                        type: 'Template',
                        id: null,
                        body: [{
                                type: 'ReturnStatement',
                                argument: {
                                    type: 'ObjectExpression',
                                    objectType: {
                                        type: 'ArrayExpression',
                                        elements: []
                                    },
                                    properties: [{
                                            type: 'ForOfStatement',
                                            left: {
                                                type: 'VariableDeclaration',
                                                declarations: [
                                                    {
                                                        type: 'VariableDeclarator',
                                                        id: {
                                                            type: 'Identifier',
                                                            name: 'item',
                                                            loc: {
                                                                start: {
                                                                    line: 142,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'ion/test/reactiveTemplates.ion'
                                                                },
                                                                end: {
                                                                    line: 142,
                                                                    column: 28,
                                                                    fixed: true,
                                                                    source: 'ion/test/reactiveTemplates.ion'
                                                                }
                                                            }
                                                        },
                                                        init: null
                                                    },
                                                    {
                                                        type: 'VariableDeclarator',
                                                        id: {
                                                            type: 'Identifier',
                                                            name: 'index',
                                                            loc: {
                                                                start: {
                                                                    line: 142,
                                                                    column: 30,
                                                                    fixed: true,
                                                                    source: 'ion/test/reactiveTemplates.ion'
                                                                },
                                                                end: {
                                                                    line: 142,
                                                                    column: 35,
                                                                    fixed: true,
                                                                    source: 'ion/test/reactiveTemplates.ion'
                                                                }
                                                            }
                                                        },
                                                        init: null
                                                    }
                                                ],
                                                kind: 'let'
                                            },
                                            right: {
                                                type: 'Identifier',
                                                name: 'items',
                                                loc: {
                                                    start: {
                                                        line: 142,
                                                        column: 39,
                                                        fixed: true,
                                                        source: 'ion/test/reactiveTemplates.ion'
                                                    },
                                                    end: {
                                                        line: 142,
                                                        column: 44,
                                                        fixed: true,
                                                        source: 'ion/test/reactiveTemplates.ion'
                                                    }
                                                }
                                            },
                                            body: {
                                                type: 'BlockStatement',
                                                body: [{
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'ObjectExpression',
                                                            properties: [
                                                                {
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'id',
                                                                        loc: {
                                                                            start: {
                                                                                line: 143,
                                                                                column: 26,
                                                                                fixed: true,
                                                                                source: 'ion/test/reactiveTemplates.ion'
                                                                            },
                                                                            end: {
                                                                                line: 143,
                                                                                column: 28,
                                                                                fixed: true,
                                                                                source: 'ion/test/reactiveTemplates.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'Identifier',
                                                                            name: 'nextId',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 143,
                                                                                    column: 30,
                                                                                    fixed: true,
                                                                                    source: 'ion/test/reactiveTemplates.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 143,
                                                                                    column: 36,
                                                                                    fixed: true,
                                                                                    source: 'ion/test/reactiveTemplates.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [],
                                                                        loc: {
                                                                            start: {
                                                                                line: 143,
                                                                                column: 30,
                                                                                fixed: true,
                                                                                source: 'ion/test/reactiveTemplates.ion'
                                                                            },
                                                                            end: {
                                                                                line: 143,
                                                                                column: 38,
                                                                                fixed: true,
                                                                                source: 'ion/test/reactiveTemplates.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                },
                                                                {
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'number',
                                                                        loc: {
                                                                            start: {
                                                                                line: 143,
                                                                                column: 40,
                                                                                fixed: true,
                                                                                source: 'ion/test/reactiveTemplates.ion'
                                                                            },
                                                                            end: {
                                                                                line: 143,
                                                                                column: 46,
                                                                                fixed: true,
                                                                                source: 'ion/test/reactiveTemplates.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Identifier',
                                                                        name: 'item',
                                                                        loc: {
                                                                            start: {
                                                                                line: 143,
                                                                                column: 48,
                                                                                fixed: true,
                                                                                source: 'ion/test/reactiveTemplates.ion'
                                                                            },
                                                                            end: {
                                                                                line: 143,
                                                                                column: 52,
                                                                                fixed: true,
                                                                                source: 'ion/test/reactiveTemplates.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    kind: 'init',
                                                                    order: '1'
                                                                },
                                                                {
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'index',
                                                                        loc: {
                                                                            start: {
                                                                                line: 143,
                                                                                column: 54,
                                                                                fixed: true,
                                                                                source: 'ion/test/reactiveTemplates.ion'
                                                                            },
                                                                            end: {
                                                                                line: 143,
                                                                                column: 59,
                                                                                fixed: true,
                                                                                source: 'ion/test/reactiveTemplates.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Identifier',
                                                                        name: 'index',
                                                                        loc: {
                                                                            start: {
                                                                                line: 143,
                                                                                column: 61,
                                                                                fixed: true,
                                                                                source: 'ion/test/reactiveTemplates.ion'
                                                                            },
                                                                            end: {
                                                                                line: 143,
                                                                                column: 66,
                                                                                fixed: true,
                                                                                source: 'ion/test/reactiveTemplates.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    kind: 'init',
                                                                    order: '2'
                                                                }
                                                            ]
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 143,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'ion/test/reactiveTemplates.ion'
                                                            },
                                                            end: {
                                                                line: 143,
                                                                column: 68,
                                                                fixed: true,
                                                                source: 'ion/test/reactiveTemplates.ion'
                                                            }
                                                        },
                                                        order: '0'
                                                    }]
                                            },
                                            remove: null,
                                            order: '0'
                                        }]
                                },
                                order: '0'
                            }],
                        bound: false
                    }, {
                        this: this,
                        items: items,
                        alpha: alpha,
                        beta: beta,
                        charlie: charlie,
                        next: next,
                        nextId: nextId,
                        ion: ion,
                        _ref4: _ref4,
                        templates: templates,
                        _ref5: _ref5
                    }, null);
                }),
                [
                    alpha,
                    beta,
                    charlie
                ],
                {
                    0: charlie,
                    1: alpha,
                    2: void 0
                },
                [
                    {
                        id: 2,
                        number: charlie,
                        index: 0
                    },
                    {
                        id: 0,
                        number: alpha,
                        index: 1
                    }
                ]
            ];
        }(),
        function () {
            var next = 0;
            var nextId = function () {
                return next++;
            };
            return [
                'for of reuse keys',
                {},
                ion.template(function (items) {
                    return ion.createRuntime({
                        type: 'Template',
                        id: null,
                        body: [{
                                type: 'ReturnStatement',
                                argument: {
                                    type: 'ObjectExpression',
                                    objectType: {
                                        type: 'ArrayExpression',
                                        elements: []
                                    },
                                    properties: [{
                                            type: 'ForInStatement',
                                            left: {
                                                type: 'VariableDeclaration',
                                                declarations: [
                                                    {
                                                        type: 'VariableDeclarator',
                                                        id: {
                                                            type: 'Identifier',
                                                            name: 'key',
                                                            loc: {
                                                                start: {
                                                                    line: 156,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'ion/test/reactiveTemplates.ion'
                                                                },
                                                                end: {
                                                                    line: 156,
                                                                    column: 27,
                                                                    fixed: true,
                                                                    source: 'ion/test/reactiveTemplates.ion'
                                                                }
                                                            }
                                                        },
                                                        init: null
                                                    },
                                                    {
                                                        type: 'VariableDeclarator',
                                                        id: {
                                                            type: 'Identifier',
                                                            name: 'value',
                                                            loc: {
                                                                start: {
                                                                    line: 156,
                                                                    column: 29,
                                                                    fixed: true,
                                                                    source: 'ion/test/reactiveTemplates.ion'
                                                                },
                                                                end: {
                                                                    line: 156,
                                                                    column: 34,
                                                                    fixed: true,
                                                                    source: 'ion/test/reactiveTemplates.ion'
                                                                }
                                                            }
                                                        },
                                                        init: null
                                                    }
                                                ],
                                                kind: 'let'
                                            },
                                            right: {
                                                type: 'Identifier',
                                                name: 'items',
                                                loc: {
                                                    start: {
                                                        line: 156,
                                                        column: 38,
                                                        fixed: true,
                                                        source: 'ion/test/reactiveTemplates.ion'
                                                    },
                                                    end: {
                                                        line: 156,
                                                        column: 43,
                                                        fixed: true,
                                                        source: 'ion/test/reactiveTemplates.ion'
                                                    }
                                                }
                                            },
                                            body: {
                                                type: 'BlockStatement',
                                                body: [{
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'ObjectExpression',
                                                            properties: [
                                                                {
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'id',
                                                                        loc: {
                                                                            start: {
                                                                                line: 157,
                                                                                column: 26,
                                                                                fixed: true,
                                                                                source: 'ion/test/reactiveTemplates.ion'
                                                                            },
                                                                            end: {
                                                                                line: 157,
                                                                                column: 28,
                                                                                fixed: true,
                                                                                source: 'ion/test/reactiveTemplates.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'Identifier',
                                                                            name: 'nextId',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 157,
                                                                                    column: 30,
                                                                                    fixed: true,
                                                                                    source: 'ion/test/reactiveTemplates.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 157,
                                                                                    column: 36,
                                                                                    fixed: true,
                                                                                    source: 'ion/test/reactiveTemplates.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [],
                                                                        loc: {
                                                                            start: {
                                                                                line: 157,
                                                                                column: 30,
                                                                                fixed: true,
                                                                                source: 'ion/test/reactiveTemplates.ion'
                                                                            },
                                                                            end: {
                                                                                line: 157,
                                                                                column: 38,
                                                                                fixed: true,
                                                                                source: 'ion/test/reactiveTemplates.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                },
                                                                {
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'key',
                                                                        loc: {
                                                                            start: {
                                                                                line: 157,
                                                                                column: 40,
                                                                                fixed: true,
                                                                                source: 'ion/test/reactiveTemplates.ion'
                                                                            },
                                                                            end: {
                                                                                line: 157,
                                                                                column: 43,
                                                                                fixed: true,
                                                                                source: 'ion/test/reactiveTemplates.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Identifier',
                                                                        name: 'key',
                                                                        loc: {
                                                                            start: {
                                                                                line: 157,
                                                                                column: 45,
                                                                                fixed: true,
                                                                                source: 'ion/test/reactiveTemplates.ion'
                                                                            },
                                                                            end: {
                                                                                line: 157,
                                                                                column: 48,
                                                                                fixed: true,
                                                                                source: 'ion/test/reactiveTemplates.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    kind: 'init',
                                                                    order: '1'
                                                                },
                                                                {
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'value',
                                                                        loc: {
                                                                            start: {
                                                                                line: 157,
                                                                                column: 50,
                                                                                fixed: true,
                                                                                source: 'ion/test/reactiveTemplates.ion'
                                                                            },
                                                                            end: {
                                                                                line: 157,
                                                                                column: 55,
                                                                                fixed: true,
                                                                                source: 'ion/test/reactiveTemplates.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Identifier',
                                                                        name: 'value',
                                                                        loc: {
                                                                            start: {
                                                                                line: 157,
                                                                                column: 57,
                                                                                fixed: true,
                                                                                source: 'ion/test/reactiveTemplates.ion'
                                                                            },
                                                                            end: {
                                                                                line: 157,
                                                                                column: 62,
                                                                                fixed: true,
                                                                                source: 'ion/test/reactiveTemplates.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    kind: 'init',
                                                                    order: '2'
                                                                }
                                                            ]
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 157,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'ion/test/reactiveTemplates.ion'
                                                            },
                                                            end: {
                                                                line: 157,
                                                                column: 64,
                                                                fixed: true,
                                                                source: 'ion/test/reactiveTemplates.ion'
                                                            }
                                                        },
                                                        order: '0'
                                                    }]
                                            },
                                            remove: null,
                                            order: '0'
                                        }]
                                },
                                order: '0'
                            }],
                        bound: false
                    }, {
                        this: this,
                        items: items,
                        next: next,
                        nextId: nextId,
                        ion: ion,
                        _ref4: _ref4,
                        templates: templates,
                        _ref5: _ref5
                    }, null);
                }),
                {
                    alpha: 1,
                    beta: 2,
                    charlie: 3
                },
                {
                    beta: 3,
                    charlie: void 0
                },
                [
                    {
                        id: 0,
                        key: 'alpha',
                        value: 1
                    },
                    {
                        id: 1,
                        key: 'beta',
                        value: 3
                    }
                ]
            ];
        }(),
        [
            'undo statement',
            {},
            ion.template(function (object) {
                return ion.createRuntime({
                    type: 'Template',
                    id: null,
                    body: [
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Function',
                                    context: true,
                                    value: function (_context) {
                                        return function () {
                                            var object = _context.get('object');
                                            return object.total = object.total != null ? object.total : 0;
                                        };
                                    }
                                },
                                arguments: [],
                                loc: {
                                    start: {
                                        line: 200,
                                        column: 12,
                                        fixed: true,
                                        source: 'ion/test/reactiveTemplates.ion'
                                    },
                                    end: {
                                        line: 200,
                                        column: 35,
                                        fixed: true,
                                        source: 'ion/test/reactiveTemplates.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 200,
                                    column: 12,
                                    fixed: true,
                                    source: 'ion/test/reactiveTemplates.ion'
                                },
                                end: {
                                    line: 200,
                                    column: 35,
                                    fixed: true,
                                    source: 'ion/test/reactiveTemplates.ion'
                                }
                            },
                            order: '0'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'items',
                                        loc: {
                                            start: {
                                                line: 201,
                                                column: 16,
                                                fixed: true,
                                                source: 'ion/test/reactiveTemplates.ion'
                                            },
                                            end: {
                                                line: 201,
                                                column: 21,
                                                fixed: true,
                                                source: 'ion/test/reactiveTemplates.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'object',
                                            loc: {
                                                start: {
                                                    line: 201,
                                                    column: 24,
                                                    fixed: true,
                                                    source: 'ion/test/reactiveTemplates.ion'
                                                },
                                                end: {
                                                    line: 201,
                                                    column: 30,
                                                    fixed: true,
                                                    source: 'ion/test/reactiveTemplates.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'items',
                                            loc: {
                                                start: {
                                                    line: 201,
                                                    column: 31,
                                                    fixed: true,
                                                    source: 'ion/test/reactiveTemplates.ion'
                                                },
                                                end: {
                                                    line: 201,
                                                    column: 36,
                                                    fixed: true,
                                                    source: 'ion/test/reactiveTemplates.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 201,
                                                column: 24,
                                                fixed: true,
                                                source: 'ion/test/reactiveTemplates.ion'
                                            },
                                            end: {
                                                line: 201,
                                                column: 36,
                                                fixed: true,
                                                source: 'ion/test/reactiveTemplates.ion'
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '1'
                        },
                        {
                            type: 'ForOfStatement',
                            left: {
                                type: 'VariableDeclaration',
                                declarations: [{
                                        type: 'VariableDeclarator',
                                        id: {
                                            type: 'Identifier',
                                            name: 'item',
                                            loc: {
                                                start: {
                                                    line: 202,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'ion/test/reactiveTemplates.ion'
                                                },
                                                end: {
                                                    line: 202,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'ion/test/reactiveTemplates.ion'
                                                }
                                            }
                                        },
                                        init: null
                                    }],
                                kind: 'let'
                            },
                            right: {
                                type: 'Identifier',
                                name: 'items',
                                loc: {
                                    start: {
                                        line: 202,
                                        column: 24,
                                        fixed: true,
                                        source: 'ion/test/reactiveTemplates.ion'
                                    },
                                    end: {
                                        line: 202,
                                        column: 29,
                                        fixed: true,
                                        source: 'ion/test/reactiveTemplates.ion'
                                    }
                                }
                            },
                            body: {
                                type: 'BlockStatement',
                                body: [
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'MemberExpression',
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'ion'
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'bind'
                                                    }
                                                },
                                                arguments: [
                                                    {
                                                        type: 'Function',
                                                        context: true,
                                                        value: function (_context2) {
                                                            return function () {
                                                                var object = _context2.get('object'), item = _context2.get('item');
                                                                object.total += item;
                                                            };
                                                        }
                                                    },
                                                    { type: 'ThisExpression' }
                                                ]
                                            },
                                            arguments: [],
                                            loc: {
                                                start: {
                                                    line: 203,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'ion/test/reactiveTemplates.ion'
                                                },
                                                end: {
                                                    line: 205,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'ion/test/reactiveTemplates.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 203,
                                                column: 16,
                                                fixed: true,
                                                source: 'ion/test/reactiveTemplates.ion'
                                            },
                                            end: {
                                                line: 205,
                                                column: 20,
                                                fixed: true,
                                                source: 'ion/test/reactiveTemplates.ion'
                                            }
                                        },
                                        order: '0'
                                    },
                                    {
                                        type: 'UndoStatement',
                                        callee: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'MemberExpression',
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'ion'
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'bind'
                                                }
                                            },
                                            arguments: [
                                                {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context3) {
                                                        return function () {
                                                            var object = _context3.get('object'), item = _context3.get('item');
                                                            object.total -= item;
                                                        };
                                                    }
                                                },
                                                { type: 'ThisExpression' }
                                            ]
                                        },
                                        order: '1'
                                    }
                                ]
                            },
                            remove: null,
                            order: '2'
                        },
                        {
                            type: 'ReturnStatement',
                            argument: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'object',
                                    loc: {
                                        start: {
                                            line: 207,
                                            column: 19,
                                            fixed: true,
                                            source: 'ion/test/reactiveTemplates.ion'
                                        },
                                        end: {
                                            line: 207,
                                            column: 25,
                                            fixed: true,
                                            source: 'ion/test/reactiveTemplates.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'total',
                                    loc: {
                                        start: {
                                            line: 207,
                                            column: 26,
                                            fixed: true,
                                            source: 'ion/test/reactiveTemplates.ion'
                                        },
                                        end: {
                                            line: 207,
                                            column: 31,
                                            fixed: true,
                                            source: 'ion/test/reactiveTemplates.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 207,
                                        column: 19,
                                        fixed: true,
                                        source: 'ion/test/reactiveTemplates.ion'
                                    },
                                    end: {
                                        line: 207,
                                        column: 31,
                                        fixed: true,
                                        source: 'ion/test/reactiveTemplates.ion'
                                    }
                                }
                            },
                            order: '3'
                        }
                    ],
                    bound: false
                }, {
                    this: this,
                    ion: ion,
                    object: object,
                    _ref4: _ref4,
                    templates: templates,
                    _ref5: _ref5
                }, null);
            }),
            {
                items: [
                    1,
                    2,
                    3
                ]
            },
            { items: { 2: 4 } },
            7
        ]
    ];
var _ref5 = {};
{
    var lowestBefore = Number.MAX_SAFE_INTEGER;
    var totalComplete = 0;
    for (var _i = 0; _i < templates.length; _i++) {
        var _ref6 = templates[_i];
        var name = _ref6[0];
        var thisArg = _ref6[1];
        var templateType = _ref6[2];
        var argument = _ref6[3];
        var patch = _ref6[4];
        var expected = _ref6[5];
        if (expected != null) {
            _ref5[name] = function (thisArg, templateType, argument, patch, expected, name) {
                return function (done) {
                    var beforeCount = ion.observe.count != null ? ion.observe.count : 0;
                    var template = templateType.call(thisArg, argument);
                    var finished = function () {
                        unobserveValue != null ? unobserveValue() : void 0;
                        unobserveValue = null;
                        unobserve();
                        var afterCount = ion.observe.count != null ? ion.observe.count : 0;
                        totalComplete++;
                        lowestBefore = Math.min(beforeCount, lowestBefore);
                        if (totalComplete === templates.length && afterCount > lowestBefore) {
                            done('ion.observe memory leak detected, beforeCount: ' + lowestBefore + ', afterCount: ' + afterCount);
                        } else {
                            done();
                        }
                    };
                    function checkIfDone(check) {
                        if (JSON.stringify(check) === JSON.stringify(expected)) {
                            if (unobserve != null) {
                                finished();
                            } else {
                                setTimeout(finished, 0);
                            }
                        }
                    }
                    template.activate();
                    var unobserveValue;
                    var unobserve = template.observe(function (value) {
                            unobserveValue != null ? unobserveValue() : void 0;
                            unobserveValue = ion.observe(value, function (changes) {
                                checkIfDone(value);
                            });
                            checkIfDone(value);
                        });
                    ion.patch(argument, patch);
                    ion.sync();
                };
            }(thisArg, templateType, argument, patch, expected, name);
        }
    }
}
module.exports = exports = { test: _ref5 };
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/test/reactiveTemplates',_ion_test_reactiveTemplates_);
    else
      _ion_test_reactiveTemplates_.call(this, module, exports, require);
  }
  else {
    _ion_test_reactiveTemplates_.call(this);
  }
}).call(this)
void (function(){var _ion_test_sourceSize_ = function(module,exports,require){'use strict';
if (global.window) {
    return;
}
var fs = require('fs');
var np = require('path');
var total = 0;
var files = 0;
var printSize = function (fileOrDirectory) {
    var stats = fs.statSync(fileOrDirectory);
    if (stats.isDirectory()) {
        {
            var _ref = fs.readdirSync(fileOrDirectory);
            for (var _i = 0; _i < _ref.length; _i++) {
                var file = _ref[_i];
                printSize(np.join(fileOrDirectory, file));
            }
        }
    } else {
        if (fileOrDirectory.match(/\.css$/)) {
            return;
        }
        var content = fs.readFileSync(fileOrDirectory, 'utf8');
        var size = 0;
        {
            var _ref2 = content.split(/[\r\n]+/g);
            for (var _i2 = 0; _i2 < _ref2.length; _i2++) {
                var line = _ref2[_i2];
                var chars = line.trim();
                var comment = chars.match(/^(#|(\/\/))/);
                if (!comment) {
                    size += chars.length;
                }
            }
        }
        total += size;
        files++;
        console.log(fileOrDirectory + ' : ' + size);
    }
};
if (require.main === module) {
    var args = process.argv.slice(2);
    for (var _i3 = 0; _i3 < args.length; _i3++) {
        var arg = args[_i3];
        printSize(arg);
    }
    console.log('---------------------------------------');
    console.log('Total Files : ' + files);
    console.log('Total Bytes : ' + total);
}
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/test/sourceSize',_ion_test_sourceSize_);
    else
      _ion_test_sourceSize_.call(this, module, exports, require);
  }
  else {
    _ion_test_sourceSize_.call(this);
  }
}).call(this)
void (function(){var _ion_test_syntax_ = function(module,exports,require){'use strict';
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/test/syntax',_ion_test_syntax_);
    else
      _ion_test_syntax_.call(this, module, exports, require);
  }
  else {
    _ion_test_syntax_.call(this);
  }
}).call(this)
void (function(){var _ion_test_ = function(module,exports,require){'use strict';
var a, b;
var _ref = [];
if (a) {
    _ref.push(b);
}
var foo = [
        _ref,
        function () {
            for (var k in obj) {
                var v = obj[k];
                var v = obj[k];
                var baz = k + v;
            }
        }
    ];
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/test',_ion_test_);
    else
      _ion_test_.call(this, module, exports, require);
  }
  else {
    _ion_test_.call(this);
  }
}).call(this)
void (function(){var _ion_toposort_ = function(module,exports,require){module.exports = exports = function toposort(edges) {
  let nodes = new Set()
  let parents = new Map()

  for (edge of edges)
      for (node of edge)
          nodes.add(node)

  for (node of nodes)
      parents.set(node, [])

  for (edge of edges)
      parents.get(edge[1]).push(edge[0])

  let sorted = []
  let visited = new Set()

  function visit(node, path = new Set()) {
      if (path.has(node))
          throw new Error("Graph is cyclic: " + node + ' -> ' + Array.from(path).reverse().join(' -> '))
      if (visited.has(node))
          return
      visited.add(node)
      path.add(node)
      for(let parent of parents.get(node))
          visit(parent, path)
      sorted.push(node)
  }

  for(let node of nodes)
      visit(node)
  
  return sorted
}

// function test() {
//   let a = 'a'
//   let b = 'b'
//   let c = 'c'
//   let d = 'd'

//   let edges = [[a,b], [a,c], [b,d], [c,d]]
//   // edges.reverse()

//   let sorted = toposort(edges)
  
//   console.log(sorted)
// } 
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('ion/toposort',_ion_toposort_);
    else
      _ion_toposort_.call(this, module, exports, require);
  }
  else {
    _ion_toposort_.call(this);
  }
}).call(this)
void (function(){var _glass_Component_ = function(module,exports,require){'use strict';
var ion = require('ion');
var Component = ion.defineClass({
        name: 'Component',
        id: module.id,
        properties: {
            createId: function (child) {
                this._nextChildId = this._nextChildId != null ? this._nextChildId : 0;
                return this._nextChildId++;
            },
            add: function (child) {
                child.id = child.id != null ? child.id : this.createId(child);
                child.parent = this;
                this.components = this.components != null ? this.components : {};
                this.components[child.id] = child;
            },
            remove: function (child) {
                delete this.components[child.id];
                child.parent = null;
            },
            dispose: function () {
                var components = this.components;
                if (components != null) {
                    for (var id in components) {
                        var child = components[id];
                        child.dispose != null ? child.dispose(c) : void 0;
                    }
                }
                if (this.parent != null) {
                    this.parent.remove(this);
                }
            }
        },
        test: {
            'should have an id': function () {
                if (!(typeof Component.id === 'string'))
                    throw new Error('Assertion Failed: (typeof Component.id is \'string\')');
            }
        }
    });
module.exports = exports = Component;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/Component',_glass_Component_);
    else
      _glass_Component_.call(this, module, exports, require);
  }
  else {
    _glass_Component_.call(this);
  }
}).call(this)
void (function(){var _glass_async_ = function(module,exports,require){'use strict';
var parallel = exports.parallel = function (funcs, callback) {
        var results = [];
        var count = 0;
        var maybeFinish = function () {
            if (count === funcs.length) {
                callback(results);
            }
        };
        maybeFinish();
        for (var _i = 0; _i < funcs.length; _i++) {
            var index = _i;
            var func = funcs[_i];
            (function (func, index) {
                func(function () {
                    results[index] = Array.prototype.slice.call(arguments, 0);
                    count += 1;
                    maybeFinish();
                });
            }(func, index));
        }
    };
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/async',_glass_async_);
    else
      _glass_async_.call(this, module, exports, require);
  }
  else {
    _glass_async_.call(this);
  }
}).call(this)
void (function(){var _glass_constraintengine_Constraint_ = function(module,exports,require){'use strict';
var ion = require('ion');
var Constraint = ion.defineClass({
        name: 'Constraint',
        constructor: function Constraint() {
            if (typeof arguments[0] === 'object') {
                this.variables = arguments[0];
            } else {
                this.variables = Array.from(arguments);
            }
        },
        properties: {
            name: { type: 'string' },
            setName: function (name) {
                this.name = name;
                return this;
            },
            toString: function () {
                var str = this.constructor.name + '( ' + this.variables.join(', ') + ' )';
                if (this.name != null) {
                    str = this.name + ': ' + str;
                }
                return str;
            },
            variables: { type: 'object' },
            reduction: function (domains) {
                return null;
            }
        }
    });
module.exports = exports = Constraint;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/constraintengine/Constraint',_glass_constraintengine_Constraint_);
    else
      _glass_constraintengine_Constraint_.call(this, module, exports, require);
  }
  else {
    _glass_constraintengine_Constraint_.call(this);
  }
}).call(this)
void (function(){var _glass_constraintengine_constraints_ = function(module,exports,require){'use strict';
var ion = require('ion');
var Constraint = require('./Constraint');
var LessThan = ion.defineClass({
        name: 'LessThan',
        properties: {
            reduction: function (domains) {
                var low = this.variables[0];
                var high = this.variables[1];
                var min = Math.min.apply(null, Array.from(domains[low]));
                var max = Math.max.apply(null, Array.from(domains[high]));
                var reduction = {};
                {
                    reduction[low] = Array.from(domains[low]).filter(function (x) {
                        return x >= max;
                    });
                    reduction[high] = Array.from(domains[high]).filter(function (x) {
                        return x <= min;
                    });
                }
                if (reduction[low].length === domains[low].size || reduction[high].length === domains[high].size) {
                    return null;
                }
                return reduction;
            }
        }
    }, Constraint);
var LessThan = exports.LessThan = LessThan;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/constraintengine/constraints',_glass_constraintengine_constraints_);
    else
      _glass_constraintengine_constraints_.call(this, module, exports, require);
  }
  else {
    _glass_constraintengine_constraints_.call(this);
  }
}).call(this)
void (function(){var _glass_constraintengine_index_ = function(module,exports,require){Object.defineProperty(exports, 'Constraint', {get:function(){ return require('./Constraint') }, enumerable: true}) 
Object.defineProperty(exports, 'constraints', {get:function(){ return require('./constraints') }, enumerable: true}) 
Object.defineProperty(exports, 'solve', {get:function(){ return require('./solve') }, enumerable: true}) 
Object.freeze(exports)
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/constraintengine/index',_glass_constraintengine_index_);
    else
      _glass_constraintengine_index_.call(this, module, exports, require);
  }
  else {
    _glass_constraintengine_index_.call(this);
  }
}).call(this)
void (function(){var _glass_constraintengine_solve_ = function(module,exports,require){'use strict';
var ion = require('ion');
var getVars = function getVars(domains) {
        var result = [];
        for (var name in domains) {
            var domain = domains[name];
            result.push(name);
        }
        return result;
    }, doReduction = function doReduction(domains, reduction) {
        for (var name in reduction) {
            var domain = reduction[name];
            for (var _i = 0; _i < domain.length; _i++) {
                var value = domain[_i];
                domains[name].delete(value);
            }
        }
    }, undoReduction = function undoReduction(domains, reduction) {
        for (var name in reduction) {
            var domain = reduction[name];
            for (var _i2 = 0; _i2 < domain.length; _i2++) {
                var value = domain[_i2];
                domains[name].add(value);
            }
        }
    }, solutionStatus = function solutionStatus(domains) {
        for (var name in domains) {
            var domain = domains[name];
            if (domain.size === 0) {
                return false;
            }
            if (domain.size !== 1) {
                return null;
            }
        }
        return true;
    }, isEmpty = function isEmpty(reduction) {
        for (var name in reduction) {
            var domain = reduction[name];
            if (domain.size !== 0) {
                return false;
            }
        }
        return true;
    }, constraintGraph = function constraintGraph(variables, constraints) {
        var graph = {};
        for (var _i3 = 0; _i3 < variables.length; _i3++) {
            var v = variables[_i3];
            graph[v] = new Set();
        }
        for (var _i4 = 0; _i4 < constraints.length; _i4++) {
            var constraint = constraints[_i4];
            {
                var _ref5 = constraint.variables;
                for (var _i5 = 0; _i5 < _ref5.length; _i5++) {
                    var v = _ref5[_i5];
                    graph[v].add(constraint);
                }
            }
        }
        return graph;
    }, propagateConstraints = function propagateConstraints(args) {
        var _ref = args;
        var domains = _ref.domains;
        var cgraph = _ref.cgraph;
        var netReduction = {};
        var changed = new Set(args.variable);
        while (changed.size > 0) {
            var variable = changed.values().next().value;
            changed.delete(variable);
            {
                var _ref6 = cgraph[variable];
                for (var _i6 = 0; _i6 < _ref6.length; _i6++) {
                    var constraint = _ref6[_i6];
                    var reduction = constraint.reduction(domains);
                    if (!(reduction != null)) {
                        return {
                            netReduction: netReduction,
                            satisfiable: false
                        };
                    }
                    if (reduction != null) {
                        for (var _i7 = 0; _i7 < reduction.length; _i7++) {
                            var d = _i7;
                            var v = reduction[_i7];
                            changed.add(v);
                            {
                                var _ref7 = d.values();
                                for (var _i8 = 0; _i8 < _ref7.length; _i8++) {
                                    var value = _ref7[_i8];
                                    netReduction[v].add(value);
                                }
                            }
                        }
                    }
                    doReduction(domains);
                }
            }
        }
        return {
            netReduction: netReduction,
            satisfiable: true
        };
    }, solve = function solve(_ref2) {
        var domains = _ref2.domains;
        var constraints = _ref2.constraints;
        var variables = getVars(domains);
        var cgraph = constraintGraph(variables, constraints);
        var result = solveInternal({
                variables: variables,
                domain: domain,
                cgraph: cgraph,
                depth: 0
            });
    }, solveInternal = function solveInternal(_ref3) {
        var variables = _ref3.variables;
        var domains = _ref3.domains;
        var cgraph = _ref3.cgraph;
        var depth = _ref3.depth;
        var variable = variables[depth];
        var domain = domains[variable];
        var newDomain = new Set();
        {
            var _ref8 = domain.values();
            for (var _i9 = 0; _i9 < _ref8.length; _i9++) {
                var value = _ref8[_i9];
                newDomain.add(value);
                var _ref4 = propagateConstraints({
                        domains: domains,
                        cgraph: cgraph,
                        variable: variable
                    });
                var netReduction = _ref4.netReduction;
                var satisfiable = _ref4.satisfiable;
                if (satisfiable) {
                    if (depth === variables.length - 1) {
                        var status = solutionStatus(domains);
                        if (status === true) {
                            return domains;
                        }
                        if (status === false) {
                            return null;
                        }
                    } else {
                        var result = solveInternal({
                                variables: variables,
                                domains: domains,
                                cgraph: cgraph,
                                depth: depth + 1
                            });
                        if (result != null) {
                            return result;
                        }
                    }
                }
                undoReduction(netReduction);
                newDomain.delete(variable);
            }
        }
        domains[variable] = domain;
    }, test = function test() {
        var values = [
                1,
                2,
                3,
                4,
                5,
                6,
                7,
                8,
                9
            ];
        var domains = { a: new Set(values) };
        var reduction = {
                a: [
                    1,
                    2,
                    3
                ]
            };
        doReduction(domains, reduction);
        if (!!domains.a.has(1))
            throw new Error('Assertion Failed: (not domains.a.has(1))');
        if (!!domains.a.has(2))
            throw new Error('Assertion Failed: (not domains.a.has(2))');
        if (!!domains.a.has(3))
            throw new Error('Assertion Failed: (not domains.a.has(3))');
        undoReduction(domains, reduction);
        if (!domains.a.has(1))
            throw new Error('Assertion Failed: (domains.a.has(1))');
        if (!domains.a.has(2))
            throw new Error('Assertion Failed: (domains.a.has(2))');
        if (!domains.a.has(3))
            throw new Error('Assertion Failed: (domains.a.has(3))');
    };
module.exports = exports = ion.patch.combine(solve, { test: test });
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/constraintengine/solve',_glass_constraintengine_solve_);
    else
      _glass_constraintengine_solve_.call(this, module, exports, require);
  }
  else {
    _glass_constraintengine_solve_.call(this);
  }
}).call(this)
void (function(){var _glass_convert_ = function(module,exports,require){'use strict';
var localToUtc = exports.localToUtc = function (date) {
        return new Date(date.getTime() + date.getTimezoneOffset() * 60000);
    }, utcToLocal = exports.utcToLocal = function (date) {
        return new Date(date.getTime() - date.getTimezoneOffset() * 60000);
    }, timeToLocalIfUtc = exports.timeToLocalIfUtc = function (property, value) {
        if (value != null && !((property != null ? property.local : void 0) != null)) {
            var date = new Date(value);
            value = utcToLocal(date).toISOString();
        }
        return value;
    }, jsonValueToDisplayValue = exports.jsonValueToDisplayValue = function (property, value) {
        if (value != null) {
            if (value === void 0) {
                value = property.value;
            }
            if (property.values) {
                var item = property.values[value];
                var label = (item != null ? item.label : void 0) != null ? item.label : item != null ? item.name : void 0;
                if (label) {
                    return label;
                }
            }
            if (value === property.value) {
                value = '';
            }
            if (property.foreign != null && property.type === 'object') {
                value = Object.keys(value).toString();
            } else if (typeof value === 'object') {
                value = value.toString();
            }
            if (property.format === 'date-time') {
                var _ref = require('./time');
                var DateTime = _ref.DateTime;
                var dateTime = DateTime.parse(value);
                value = dateTime != null ? dateTime.format() : void 0;
            }
            if (property.format === 'duration') {
                var _ref2 = require('./time');
                var Duration = _ref2.Duration;
                var duration = Duration.parse(value);
                value = duration != null ? duration.format() : void 0;
            }
        }
        return value != null ? value : '';
    }, jsonValueToInputValue = exports.jsonValueToInputValue = function (property, value) {
        if (value != null && property.format === 'key') {
            return value.substring(value.lastIndexOf('/') + 1);
        }
        return value != null ? value : null;
    }, inputValueToJsonValue = exports.inputValueToJsonValue = function (property, value) {
        if (value != null) {
            if (property.format === 'date-time') {
                if (value.length === 0) {
                    value = null;
                } else {
                    value = new Date(value).toISOString();
                    if (property.local) {
                        value = value.substring(0, value.indexOf('Z'));
                    }
                }
            } else if (property.type === 'number') {
                value = Number(value);
            } else if (property.type === 'integer') {
                value = Math.round(Number(value));
            } else if (property.type === 'boolean') {
                value = Boolean(value);
            }
        }
        return value;
    };
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/convert',_glass_convert_);
    else
      _glass_convert_.call(this, module, exports, require);
  }
  else {
    _glass_convert_.call(this);
  }
}).call(this)
void (function(){var _glass_crypt_ = function(module,exports,require){'use strict';
var ion = require('ion');
var s = require('./sjcl'), sign = function (text, key) {
        return s.codec.base64.fromBits(new s.misc.hmac(s.codec.utf8String.toBits(key)).encrypt(text), true, true);
    }, verify = function (text, key, signature) {
        return signature === sign(text, key);
    }, hexChars = [
        '0',
        '1',
        '2',
        '3',
        '4',
        '5',
        '6',
        '7',
        '8',
        '9',
        'A',
        'B',
        'C',
        'D',
        'E',
        'F'
    ], guidFormat = '00000000-0000-0000-0000-000000000000';
var jwtSign = exports.jwtSign = function (message, secret, expirationSeconds) {
        if (expirationSeconds != null) {
            message = ion.patch.combine(JSON.parse(JSON.stringify(message)), { exp: new Date().getTime() / 1000 + expirationSeconds });
        }
        var header = {
                alg: 'HS256',
                typ: 'JWT'
            };
        var headerBody = base64Encode(JSON.stringify(header)) + '.' + base64Encode(JSON.stringify(message));
        var signature = sign(headerBody, secret);
        var headerBodySignature = headerBody + '.' + signature;
        return headerBodySignature;
    }, jwtRead = exports.jwtRead = function (token) {
        return JSON.parse(base64Decode(token.split('.')[1]));
    }, jwtVerify = exports.jwtVerify = function (token, secret) {
        var _ref = token.split('.');
        var head = _ref[0];
        var body = _ref[1];
        var signature = _ref[2];
        var headerBody = head + '.' + body;
        if (!verify(headerBody, secret, signature)) {
            return void 0;
        }
        var message = JSON.parse(base64Decode(body));
        if (message.exp != null) {
            if (Date.now() > message.exp * 1000) {
                return null;
            }
        }
        return message;
    }, base64Encode = exports.base64Encode = function (plainText) {
        return s.codec.base64.fromBits(s.codec.utf8String.toBits(plainText), true, true);
    }, base64Decode = exports.base64Decode = function (base64EncodedText) {
        return s.codec.utf8String.fromBits(s.codec.base64.toBits(base64EncodedText, true, true));
    }, encrypt = exports.encrypt = function (object, password) {
        return base64Encode(s.encrypt(password, JSON.stringify(object)));
    }, decrypt = exports.decrypt = function (text, password) {
        return JSON.parse(s.decrypt(password, base64Decode(text)));
    }, hash = exports.hash = function (data) {
        return s.codec.base64.fromBits(s.hash.sha256.hash(data), true, true);
    }, guid = exports.guid = function (string) {
        if (!(string != null)) {
            return guidFormat;
        }
        string = hash(string);
        var array = guidFormat.split('');
        var index = 0;
        for (var i = 0; i < string.length; i++) {
            var code = string.charCodeAt(i) + array[index].charCodeAt(0);
            array[index] = hexChars[code % hexChars.length];
            index += 1;
            if (index >= array.length) {
                index = 0;
            } else if (array[index] === '-') {
                index += 1;
            }
        }
        return array.join('');
    }, test = exports.test = {
        guid: function () {
            if (!(guid(null) === guidFormat))
                throw new Error('Assertion Failed: (guid(null) is guidFormat)');
            if (!(guid('foo') !== guidFormat))
                throw new Error('Assertion Failed: (guid("foo") isnt guidFormat)');
            if (!(guid('foo') !== guid('bar')))
                throw new Error('Assertion Failed: (guid("foo") isnt guid("bar"))');
            if (!(guid('bar').length === guidFormat.length))
                throw new Error('Assertion Failed: (guid("bar").length is guidFormat.length)');
        },
        jwt_encode: function () {
            var jwt = jwtSign({
                    sub: 1234567890,
                    name: 'John Doe',
                    admin: true
                }, 'secret');
            if (!(jwt === 'eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJzdWIiOjEyMzQ1Njc4OTAsIm5hbWUiOiJKb2huIERvZSIsImFkbWluIjp0cnVlfQ.eoaDVGTClRdfxUZXiPs3f8FmJDkDE_VCQFXqKxpLsts'))
                throw new Error('Assertion Failed: (jwt is \'eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJzdWIiOjEyMzQ1Njc4OTAsIm5hbWUiOiJKb2huIERvZSIsImFkbWluIjp0cnVlfQ.eoaDVGTClRdfxUZXiPs3f8FmJDkDE_VCQFXqKxpLsts\')');
        },
        jwt_decode: function () {
            var send = {
                    a: 'alpha',
                    b: 'beta'
                };
            var jwt = jwtSign(send, 'foo');
            var received = jwtVerify(jwt, 'foo');
            if (!(JSON.stringify(send) === JSON.stringify(received)))
                throw new Error('Assertion Failed: (JSON.stringify(send) is JSON.stringify(received))');
        },
        jwt_decode_not_expired: function () {
            var expires = Math.floor(Date.now() / 1000) + 10;
            var send = {
                    a: 'alpha',
                    b: 'beta',
                    exp: expires
                };
            var jwt = jwtSign(send, 'foo');
            var received = jwtVerify(jwt, 'foo');
            if (!(JSON.stringify(send) === JSON.stringify(received)))
                throw new Error('Assertion Failed: (JSON.stringify(send) is JSON.stringify(received))');
        },
        jwt_decode_expired: function () {
            var expires = Math.floor(Date.now() / 1000);
            var send = {
                    a: 'alpha',
                    b: 'beta',
                    exp: expires
                };
            var jwt = jwtSign(send, 'foo');
            var received = jwtVerify(jwt, 'foo');
            if (!(received === null))
                throw new Error('Assertion Failed: (received is null)');
        },
        jwt_decode_fail_verify: function () {
            var send = {
                    a: 'alpha',
                    b: 'beta'
                };
            var jwt = jwtSign(send, 'foo');
            var received = jwtVerify(jwt, 'wrong secret');
            if (!(received === void 0))
                throw new Error('Assertion Failed: (received is undefined)');
        },
        hash: function () {
            if (!(typeof hash(1) === 'string'))
                throw new Error('Assertion Failed: (typeof hash(1) is \'string\')');
            if (!(hash(1).length > 10))
                throw new Error('Assertion Failed: (hash(1).length > 10)');
            if (!(hash(1) === hash(1)))
                throw new Error('Assertion Failed: (hash(1) is hash(1))');
            if (!(hash(1) !== hash(2)))
                throw new Error('Assertion Failed: (hash(1) isnt hash(2))');
        },
        base64Encoding: function () {
            var a = 'hello world';
            var encoded = base64Encode(a);
            if (!(encoded === 'aGVsbG8gd29ybGQ'))
                throw new Error('Assertion Failed: (encoded is "aGVsbG8gd29ybGQ")');
            var b = base64Decode(encoded);
            if (!(a === b))
                throw new Error('Assertion Failed: (a is b)');
        },
        encryption: function () {
            var testValues = [
                    'hello',
                    null,
                    12,
                    true,
                    false,
                    45.8,
                    { a: 1 },
                    {
                        a: {
                            b: [
                                1,
                                3,
                                5
                            ]
                        },
                        z: false
                    }
                ];
            var secret = 'secret';
            for (var _i = 0; _i < testValues.length; _i++) {
                var value = testValues[_i];
                var encrypted = encrypt(value, secret);
                var decrypted = decrypt(encrypted, secret);
                if (!(JSON.stringify(value) === JSON.stringify(decrypted)))
                    throw new Error('Assertion Failed: (JSON.stringify(value) is JSON.stringify(decrypted))');
            }
        }
    };
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/crypt',_glass_crypt_);
    else
      _glass_crypt_.call(this, module, exports, require);
  }
  else {
    _glass_crypt_.call(this);
  }
}).call(this)
void (function(){var _glass_data_Http_ = function(module,exports,require){'use strict';
var ion = require('ion');
var getUrl = exports.getUrl = function (url, parameters) {
        if (parameters) {
            var encodedParameters = [];
            for (var key in parameters) {
                var value = parameters[key];
                encodedParameters.push('' + encodeURIComponent(key) + '=' + encodeURIComponent(value != null ? value : ''));
            }
            url += '?' + encodedParameters.join('&');
        }
        return url;
    }, get = exports.get = function (_ref) {
        var url = _ref.url;
        var parameters = _ref.parameters;
        var callback = _ref.callback;
        var error = _ref.error;
        url = getUrl(url, parameters);
        var request = new XMLHttpRequest();
        request.open('GET', url);
        request.onreadystatechange = ion.bind(function () {
            if (request.readyState === 4) {
                var _ref2 = request;
                var status = _ref2.status;
                var responseText = _ref2.responseText;
                if (status < 300) {
                    callback != null ? callback(responseText) : void 0;
                } else {
                    error != null ? error(status, responseText) : void 0;
                }
            }
        }, this);
        request.send();
    };
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/data/Http',_glass_data_Http_);
    else
      _glass_data_Http_.call(this, module, exports, require);
  }
  else {
    _glass_data_Http_.call(this);
  }
}).call(this)
void (function(){var _glass_data_Key_ = function(module,exports,require){'use strict';
var ion = require('ion'), query = require('./query'), match = function (regex, map, string) {
        var result = regex.exec(string);
        if (!(result != null)) {
            return null;
        }
        var object = {};
        for (var key in map) {
            var value = map[key];
            if (result[value] != null) {
                object[key] = result[value];
            }
        }
        return object;
    }, getProperty = function (object, properties) {
        for (var _i = 0; _i < properties.length; _i++) {
            var name = properties[_i];
            if (!(object != null)) {
                return void 0;
            }
            object = object[name];
        }
        return object;
    }, keyRegex = /^((([^\/\?#]+\/[^\/\?#]+\/?)+)\/)?(([^\/\?#]+)(\/([^\/\?#]+))?)?(#([a-z0-9]+(\.[a-z0-9]+)*))?(\?(\{.*\}))?$/i, keyMap = {
        parent: 2,
        type: 5,
        id: 7,
        properties: 9,
        query: 12
    }, parse = function (key) {
        var result = match(keyRegex, keyMap, key);
        if (!(result != null)) {
            throw new Error('400 invalid key: ' + key);
        }
        if (result.query != null) {
            try {
                result.query = JSON.parse(result.query);
            } catch (e) {
                throw new Error('400 invalid key query: ' + key + ', ' + e);
            }
        }
        if (result.properties != null) {
            result.properties = result.properties.split('.');
        }
        return result;
    }, join = function (steps) {
        steps = steps.filter(function (x) {
            return x != null && x !== '';
        });
        var path = '';
        var query = null;
        var properties = null;
        for (var _i2 = 0; _i2 < steps.length; _i2++) {
            var i = _i2;
            var step = steps[_i2];
            var last = i + 1 === steps.length;
            if (step.constructor === Key && !last) {
                step = step.path;
            }
            if (step.constructor === Object && i > 0) {
                query = ion.patch.combine(query, step);
            } else if (Array.isArray(step)) {
                if (step.length > 0) {
                    properties = step;
                }
            } else {
                if (typeof step === 'function') {
                    step = step.name;
                }
                if (path.length > 0) {
                    path += '/';
                }
                path += step;
            }
        }
        path = path.replace(/\/\/+/g, '/');
        if (properties != null) {
            path += '#' + properties.join('.');
        }
        if (query != null) {
            query = JSON.stringify(query);
            if (query !== '{}') {
                path += '?' + query;
            }
        }
        return path;
    }, stringify = function (properties) {
        var buffer = [];
        if (properties.parent != null) {
            buffer.push(properties.parent, '/');
        }
        if (properties.type != null) {
            buffer.push(properties.type.name != null ? properties.type.name : properties.type);
            if (properties.id) {
                buffer.push('/', properties.id);
            }
        }
        if (properties.properties != null) {
            buffer.push('#', properties.properties.join('.'));
        }
        if (properties.query != null) {
            buffer.push('?', JSON.stringify(properties.query));
        }
        return buffer.join('');
    }, testNamespace = {
        Project: function Project() {
        },
        Task: function Task() {
        },
        User: function User() {
        }
    };
var Key = ion.defineClass({
        name: 'Key',
        id: module.id,
        constructor: function Key(ns, path1, path2, path3, etc) {
            var steps = Array.prototype.slice.call(arguments, 0).filter(function (x) {
                    return x != null;
                });
            var first = steps[0];
            var namespace = Key.getNamespaceFromTypeOrKey(first);
            if (!(namespace != null)) {
                namespace = first;
                steps = steps.slice(1);
            }
            var path = join(steps);
            var properties = parse(path);
            if (properties.parent != null) {
                properties.parent = new Key(namespace, properties.parent);
            }
            ion.freeze(properties);
            if (namespace != null) {
                this.namespace = namespace;
            }
            for (var key in properties) {
                var value = properties[key];
                this[key] = value;
            }
            if (this.namespace != null && this.type != null) {
                var type = this.namespace[this.type];
                if (type != null) {
                    this.type = type;
                } else {
                    throw new Error('Type ' + this.type + ' not found in namespace.');
                }
            }
            var s = stringify(this);
            Object.defineProperty(this, 'toString', {
                value: function () {
                    return s;
                }
            });
            this.path = this.query ? s.substring(0, s.indexOf('?')) : this.properties ? s.substring(0, s.indexOf('#')) : s;
            ion.freeze(this, false);
        },
        properties: {
            root: {
                get: function () {
                    return (this.parent != null ? this.parent.root : void 0) != null ? this.parent.root : this;
                }
            },
            isAncestor: function (key) {
                return key != null && this.path.startsWith(key);
            },
            isMatch: function (key, object, defaultResult) {
                if (defaultResult == null)
                    defaultResult = false;
                if (this.parent != null && !key.toString().startsWith(this.path)) {
                    return false;
                }
                if ((this.query != null ? this.query.where : void 0) != null) {
                    if (!(object != null)) {
                        return defaultResult;
                    }
                    return query.matches(this.query.where, object);
                }
                return true;
            },
            get: function (key) {
                var steps = Array.prototype.slice.call(arguments);
                return new Key(this.namespace, join(steps));
            },
            getSortFunction: function () {
                if (this.query.sort != null) {
                    return ion.createSortFunction(this.query.sort);
                } else {
                    return null;
                }
            },
            filter: function (objects) {
                if ((this.query != null ? this.query.where : void 0) != null) {
                    return query.filter((this.query != null ? this.query.where : void 0) != null ? this.query.where : {}, objects);
                } else {
                    return objects;
                }
            },
            sort: function (objects) {
                var valueToName = new Map();
                var values = [];
                for (var name in objects) {
                    var value = objects[name];
                    valueToName.set(value, name);
                    values.push(value);
                }
                values.sort(this.getSortFunction());
                var sorted = {};
                for (var _i3 = 0; _i3 < values.length; _i3++) {
                    var value = values[_i3];
                    var name = valueToName.get(value);
                    sorted[name] = value;
                }
                return sorted;
            },
            filterAndSort: function (objects) {
                return this.sort(this.filter(objects));
            },
            getRelativePathTo: function (otherKey) {
                otherKey = otherKey.toString();
                if (otherKey.startsWith(this.path)) {
                    return otherKey.substring(this.path.length + 1);
                } else {
                    return otherKey;
                }
            },
            valueOf: function () {
                return this.toString();
            },
            toJSON: function () {
                return this.toString();
            }
        },
        parse: parse,
        join: function (___steps) {
            var steps = Array.prototype.slice.call(arguments, 0);
            return join(steps);
        },
        getNamespaceFromTypeOrKey: function (object) {
            if (object.namespace != null) {
                return object.namespace;
            } else if (object.id != null) {
                return require(/^([\/\\]?([^\/\\]+[\/\\])*)/.exec(object.id)[1]);
            }
            return null;
        },
        test: {
            filterAndSort: function () {
                var key = new Key(testNamespace, 'Project/2?{"where":{"alpha":2},"sort":[{"beta":true}]}');
                var objects = {
                        a: {
                            alpha: 2,
                            beta: 5
                        },
                        b: {
                            alpha: 1,
                            beta: 4
                        },
                        c: {
                            alpha: 2,
                            beta: 2
                        },
                        d: {
                            alpha: 2,
                            beta: 3
                        }
                    };
                var sortedAndFiltered = key.filterAndSort(objects);
                if (!(JSON.stringify(sortedAndFiltered) === '{"c":{"alpha":2,"beta":2},"d":{"alpha":2,"beta":3},"a":{"alpha":2,"beta":5}}'))
                    throw new Error('Assertion Failed: (JSON.stringify(sortedAndFiltered) is \'{"c":{"alpha":2,"beta":2},"d":{"alpha":2,"beta":3},"a":{"alpha":2,"beta":5}}\')');
            },
            toString: function () {
                var key = new Key(testNamespace, 'Project/2/Task/2?{"where":{"alpha":2}}');
                if (!(key.parent instanceof Key))
                    throw new Error('Assertion Failed: (key.parent instanceof Key)');
                if (!(key.parent.toString() === 'Project/2'))
                    throw new Error('Assertion Failed: (key.parent.toString() is \'Project/2\')');
                if (!(key.query.where.alpha === 2))
                    throw new Error('Assertion Failed: (key.query.where.alpha is 2)');
                key = new Key(testNamespace, 'Project', 12, ['tags'], { where: { task: true } });
            },
            nulls: function () {
                var key = new Key(null, testNamespace, null, 'Project/2/Task/2?{"where":{"alpha":2}}', null);
                if (!(key.parent instanceof Key))
                    throw new Error('Assertion Failed: (key.parent instanceof Key)');
            },
            frozen: function () {
                var key = new Key(testNamespace, 'Project/2/Task/2?{"where":{"alpha":2}}');
                try {
                    key.query.beta = 3;
                    throw new Error('assigning to beta should throw an error');
                } catch (e) {
                    return;
                }
            },
            getRelativePathTo: function () {
                var key1 = new Key(testNamespace, 'User/3/Project/2');
                var key2 = new Key(testNamespace, 'User/3/Project/2/Task/2');
                if (!(key1.getRelativePathTo(key2) === 'Task/2'))
                    throw new Error('Assertion Failed: (key1.getRelativePathTo(key2) is "Task/2")');
                var key3 = new Key(testNamespace, 'User/3/Project/2/Task?{"where":{"alpha":2}}');
                var key4 = new Key(testNamespace, 'User/3/Project/2/Task/2');
                if (!(key3.getRelativePathTo(key4) === '2'))
                    throw new Error('Assertion Failed: (key3.getRelativePathTo(key4) is "2")');
            },
            isAncestor: function () {
                var key1 = new Key(testNamespace, 'User/3/Project/2/Task/2?{"where":{"alpha":2}}');
                if (!key1.isAncestor(new Key(testNamespace, 'User/3')))
                    throw new Error('Assertion Failed: (key1.isAncestor(new Key(testNamespace, "User/3")))');
                if (!key1.isAncestor('User/3/Project/2'))
                    throw new Error('Assertion Failed: (key1.isAncestor("User/3/Project/2"))');
                if (!!key1.isAncestor('Project/2'))
                    throw new Error('Assertion Failed: (not key1.isAncestor("Project/2"))');
                if (!!key1.isAncestor('Task/2'))
                    throw new Error('Assertion Failed: (not key1.isAncestor("Task/2"))');
            },
            empty: function () {
                if (!(new Key(testNamespace).toString() === ''))
                    throw new Error('Assertion Failed: (new Key(testNamespace).toString() is "")');
                if (!(new Key(testNamespace, '').toString() === ''))
                    throw new Error('Assertion Failed: (new Key(testNamespace, "").toString() is "")');
                if (!!(new Key(testNamespace).type != null))
                    throw new Error('Assertion Failed: (not new Key(testNamespace).type?)');
            },
            creation: function () {
                var key1 = new Key(testNamespace, 'Project/2/Task/2?{"where":{"alpha":2}}');
                var key2 = new Key(testNamespace, 'Project', '2', 'Task', '2', { 'where': { 'alpha': 2 } });
                if (!(JSON.stringify(ion.clone(key1)) === JSON.stringify(ion.clone(key2))))
                    throw new Error('Assertion Failed: (JSON.stringify(ion.clone(key1)) is JSON.stringify(ion.clone(key2)))');
                var key3 = new Key(testNamespace, null, 'Project', 'me');
                if (!('Project/me' === key3.toString()))
                    throw new Error('Assertion Failed: (\'Project/me\' is key3.toString())');
            },
            root: function () {
                var key1 = new Key(testNamespace, 'Project/3/Project/2/Task/2?{"where":{"alpha":2}}');
                if (!(key1.root.toString() === 'Project/3'))
                    throw new Error('Assertion Failed: (key1.root.toString() is \'Project/3\')');
                var key2 = new Key(testNamespace, 'Project/2/Task/2');
                if (!(key2.root.toString() === 'Project/2'))
                    throw new Error('Assertion Failed: (key2.root.toString() is \'Project/2\')');
                var key3 = new Key(testNamespace, 'Task/2');
                if (!(key3.root.toString() === 'Task/2'))
                    throw new Error('Assertion Failed: (key3.root.toString() is \'Task/2\')');
            },
            path: function () {
                var key1 = new Key(testNamespace, 'Project/2/Task/2?{"where":{"alpha":2}}');
                var key2 = new Key(testNamespace, 'Project/2/Task/2');
                var key3 = new Key(testNamespace, 'Project/2/Task/2#foo.bar');
                if (!(key1.path === 'Project/2/Task/2'))
                    throw new Error('Assertion Failed: (key1.path is \'Project/2/Task/2\')');
                if (!(key2.path === 'Project/2/Task/2'))
                    throw new Error('Assertion Failed: (key2.path is \'Project/2/Task/2\')');
                if (!(key3.path === 'Project/2/Task/2'))
                    throw new Error('Assertion Failed: (key3.path is \'Project/2/Task/2\')');
            },
            isMatch: function () {
                var key1 = new Key(testNamespace, 'Project/2/Task/2?{"where":{"alpha":2}}');
                var key2 = new Key(testNamespace, 'Project/2/Task/2/Task/3');
                if (!key1.isMatch(key2, { alpha: 2 }))
                    throw new Error('Assertion Failed: (key1.isMatch(key2, {alpha:2}))');
                if (!!key1.isMatch(key2, { alpha: 3 }))
                    throw new Error('Assertion Failed: (not key1.isMatch(key2, {alpha:3}))');
                var key3 = new Key(testNamespace, 'Project/2/Task/3/Task/3');
                if (!!key1.isMatch(key3, { alpha: 2 }))
                    throw new Error('Assertion Failed: (not key1.isMatch(key3, {alpha:2}))');
            },
            multipleQuery: function () {
                var key1 = new Key(testNamespace, 'Project/2/Task/2?{"where":{"alpha":2}}');
                var key2 = new Key(key1, key1.query, { where: { beta: 3 } });
                if (!(key2.toString() === 'Project/2/Task/2?{"where":{"alpha":2,"beta":3}}'))
                    throw new Error('Assertion Failed: (key2.toString() is \'Project/2/Task/2?{"where":{"alpha":2,"beta":3}}\')');
            },
            join: function () {
                var path = Key.join('Foo', '', null, '/12314123');
                if (!('Foo/12314123' === path))
                    throw new Error('Assertion Failed: ("Foo/12314123" is path)');
                path = Key.join('Foo', '', null, '/12314123', [
                    'foo',
                    'bar'
                ]);
                if (!('Foo/12314123#foo.bar' === path))
                    throw new Error('Assertion Failed: ("Foo/12314123#foo.bar" is path)');
            },
            keyInConstructor: function () {
                var key1 = new Key(testNamespace, 'Project/2/Task?{"where":{"alpha":2}}');
                var childKey = new Key(key1, '22');
                if (!(childKey.toString() === 'Project/2/Task/22'))
                    throw new Error('Assertion Failed: (childKey.toString() is "Project/2/Task/22")');
            },
            parse: function () {
                var tests = {
                        'a/2/b/2?{"alpha":2}': {
                            'parent': 'a/2',
                            'type': 'b',
                            'id': '2',
                            'query': { 'alpha': 2 }
                        },
                        'a/2/b/2': {
                            'parent': 'a/2',
                            'type': 'b',
                            'id': '2'
                        },
                        'a/2/b': {
                            'parent': 'a/2',
                            'type': 'b'
                        },
                        'a/2': {
                            'type': 'a',
                            'id': '2'
                        },
                        'a': { 'type': 'a' },
                        'a?{"alpha":2}': {
                            'type': 'a',
                            'query': { 'alpha': 2 }
                        },
                        'a/2/?{"alpha":2}': {
                            'parent': 'a/2',
                            'query': { 'alpha': 2 }
                        },
                        'a/2/': { 'parent': 'a/2' },
                        '?{"alpha":2}': { 'query': { 'alpha': 2 } },
                        'a/2#foo.bar': {
                            'type': 'a',
                            'id': '2',
                            'properties': [
                                'foo',
                                'bar'
                            ]
                        },
                        'a#foo.bar?{"alpha":2}': {
                            'type': 'a',
                            'properties': [
                                'foo',
                                'bar'
                            ],
                            'query': { 'alpha': 2 }
                        }
                    };
                for (var string in tests) {
                    var result = tests[string];
                    var parsed = parse(string);
                    if (!(JSON.stringify(result) === JSON.stringify(parsed)))
                        throw new Error('Assertion Failed: (JSON.stringify(result) is JSON.stringify(parsed))');
                    var string2 = stringify(parsed);
                    if (!(string === string2))
                        throw new Error('Assertion Failed: (string is string2)');
                }
                var errors = [
                        'a/',
                        'a/1/b/',
                        '?{a:1}',
                        '/a',
                        'a#/1',
                        'a/1#',
                        'a/1/b/#'
                    ];
                for (var _i4 = 0; _i4 < errors.length; _i4++) {
                    var string = errors[_i4];
                    try {
                        parse(string);
                        throw new Error('parsing \'' + string + '\' should have thrown an error');
                    } catch (e) {
                        continue;
                    }
                }
                return;
            }
        }
    });
module.exports = exports = Key;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/data/Key',_glass_data_Key_);
    else
      _glass_data_Key_.call(this, module, exports, require);
  }
  else {
    _glass_data_Key_.call(this);
  }
}).call(this)
void (function(){var _glass_data_Schema_ = function(module,exports,require){'use strict';
var ion = require('ion'), _ref, forEachInternal = function (_ref2) {
        var root = _ref2.root;
        var path = _ref2.path;
        var parent = _ref2.parent;
        var name = _ref2.name;
        var object = _ref2.object;
        var schema = _ref2.schema;
        var callback = _ref2.callback;
        root = root != null ? root : object;
        path = path != null ? path : [];
        if (object === void 0 || parent != null && false === callback({
                root: root,
                path: path,
                parent: parent,
                name: name,
                object: object,
                schema: schema
            })) {
            return;
        }
        if (Array.isArray(object)) {
            if (schema.items != null) {
                for (var _i = 0; _i < object.length; _i++) {
                    var index = _i;
                    var item = object[_i];
                    path.push(index);
                    forEachInternal({
                        root: root,
                        path: path,
                        parent: object,
                        name: index,
                        object: item,
                        schema: schema.items,
                        callback: callback
                    });
                    path.pop();
                }
            }
        } else if (typeof object === 'object' && object !== null) {
            if (schema.properties != null) {
                {
                    var _ref15 = schema.properties;
                    for (var propertyName in _ref15) {
                        var property = _ref15[propertyName];
                        path.push(propertyName);
                        forEachInternal({
                            root: root,
                            path: path,
                            parent: object,
                            name: propertyName,
                            object: object[propertyName],
                            schema: property,
                            callback: callback
                        });
                        path.pop();
                    }
                }
            }
            if (schema.additionalProperties != null) {
                for (var propertyName in object) {
                    var value = object[propertyName];
                    if (!((schema.properties != null ? schema.properties[propertyName] : void 0) != null)) {
                        path.push(propertyName);
                        forEachInternal({
                            root: root,
                            path: path,
                            parent: object,
                            name: propertyName,
                            object: value,
                            schema: schema.additionalProperties,
                            callback: callback
                        });
                        path.pop();
                    }
                }
            }
        }
    }, equal = function (a, b) {
        return JSON.stringify(a) === JSON.stringify(b);
    };
_ref = require('../');
var language = _ref.language;
var typeCheckers = {
        null: function (value) {
            return value === null;
        },
        string: function (value) {
            return typeof value === 'string';
        },
        boolean: function (value) {
            return typeof value === 'boolean';
        },
        number: function (value) {
            return typeof value === 'number';
        },
        integer: function (value) {
            return typeof value === 'number' && Math.floor(value) === value;
        },
        object: function (value) {
            return typeof value === 'object' && !Array.isArray(value);
        },
        array: function (value) {
            return Array.isArray(value);
        }
    };
var formatPatterns = {
        date: /\d{4}-(0[1-9]|10|11|12)-(0[1-9]|[1-2][0-9]|30|31)/,
        time: /(([0-1][0-9]|2[0-3]):[0-5][0-9])|24:00/,
        email: /[^@]+@[^@\.]+(\.[^@\.]+)+/,
        duration: /P(\d+Y)?(\d+M)?(\d+W)?(\d+D)?(T(\d+H)?(\d+M)?(\d+S)?)?/
    };
var typeConverters = {};
{
    typeConverters.string = function (value) {
        return '' + value;
    };
    var falseStrings = {
            FALSE: true,
            false: true,
            0: true,
            no: true
        };
    typeConverters.boolean = function (value) {
        if (falseStrings[value]) {
            return false;
        }
        return value ? true : false;
    };
    typeConverters.number = function (value) {
        return typeof value === 'number' ? value : parseFloat(value);
    };
    typeConverters.integer = function (value) {
        return typeof value === 'number' ? value : parseInt(value);
    };
    typeConverters.object = function (value) {
        if (typeof value === 'string' && value[0] === '{') {
            value = JSON.parse(value);
        }
        return value;
    };
    typeConverters.array = function (value) {
        if (typeof value === 'string' && value[0] === '[') {
            value = JSON.parse(value);
        }
        return value;
    };
}
var checkType = function (value, type, errors, path) {
    if (Array.isArray(type)) {
        var valid = false;
        for (var _i2 = 0; _i2 < type.length; _i2++) {
            var subtype = type[_i2];
            if (checkType(value, subtype, errors, path)) {
                valid = true;
                break;
            }
        }
        if (!valid) {
            errors != null ? errors.push('' + path.join('.') + ' must be one of type ' + type.join(',')) : void 0;
            return false;
        }
    } else {
        var typeChecker = typeCheckers[type];
        if (!(typeChecker != null)) {
            errors != null ? errors.push('' + path.join('.') + ' unrecognized type: ' + type) : void 0;
            return false;
        }
        if (type && !typeCheckers[type](value)) {
            errors != null ? errors.push('' + path.join('.') + ' must be type ' + type + ', actual: ' + JSON.stringify(value)) : void 0;
            return false;
        }
    }
    return true;
};
var convertType = function (value, type) {
    if (type != null && !checkType(value, type)) {
        var firstType = Array.isArray(type) ? type[0] : type;
        var converter = typeConverters[firstType];
        if (converter != null) {
            value = converter(value);
        }
    }
    return value;
};
var exampleString = 'This is an example string. I hope that it has close to the standard distribution of characters.';
var getLabel = exports.getLabel = function (property) {
        return property.label != null ? property.label : language.capitalizeWords(language.separateIdentifier(property.name));
    }, isVisible = exports.isVisible = function (property) {
        return property != null && property.name[0] !== '_' && property.visible === true && typeof property.value !== 'function';
    }, getDisplayName = exports.getDisplayName = function (property) {
        if (property != null) {
            return property.label != null ? property.label : language.capitalizeWords(language.separateIdentifier(property.name));
        }
        return null;
    }, getDefaultValue = exports.getDefaultValue = function (property) {
        if (property != null) {
            if (property.hasOwnProperty('value')) {
                return property.value;
            }
            if (property.required) {
                if (property.type === 'string') {
                    return '';
                }
                if (property.type === 'number' || property.type === 'integer') {
                    return property.minimum != null ? property.minimum : 0;
                }
                if (property.type === 'boolean') {
                    return false;
                }
            }
        }
        return void 0;
    }, canSet = exports.canSet = function (property) {
        return property.editable !== false && (property.set != null || property.value != null);
    }, get = exports.get = function (object, schemaOrPath) {
        if (Array.isArray(schemaOrPath)) {
            var path = schemaOrPath;
            for (var _i3 = 0; _i3 < path.length; _i3++) {
                var property = path[_i3];
                object = object != null ? object[property] : void 0;
            }
            return object;
        } else {
            var schema = schemaOrPath;
            if (!(object != null) || !(schema != null)) {
                return void 0;
            }
            if (schema.get) {
                return schema.get.call(object);
            } else {
                if (!(schema.name != null)) {
                    debugger;
                    throw new Error('schema name is missing');
                }
                return object[schema.name];
            }
        }
    }, set = exports.set = function (object, schemaOrPath, value, options) {
        var deleteNull = (options != null ? options.deleteNull : void 0) != null ? options.deleteNull : true;
        var original = object;
        if (Array.isArray(schemaOrPath)) {
            var path = schemaOrPath;
            for (var _i4 = 0; _i4 < path.length; _i4++) {
                var index = _i4;
                var property = path[_i4];
                if (index + 1 === path.length) {
                    if (!deleteNull || value != null) {
                        object[property] = ion.patch.merge(object[property], value, { deleteNull: deleteNull });
                    } else {
                        delete object[property];
                    }
                } else {
                    object = object[property] = object[property] != null ? object[property] : {};
                }
            }
            return original;
        } else {
            var schema = schemaOrPath;
            if (Array.isArray(object)) {
                for (var _i5 = 0; _i5 < object.length; _i5++) {
                    var item = object[_i5];
                    set(item, schema, value);
                }
                return original;
            }
            value = coerce(value, schema);
            if (schema.set) {
                schema.set.call(object, value);
            } else {
                if (deleteNull && !(value != null)) {
                    delete object[schema.name];
                } else if (!(schema.name != null)) {
                    throw new Error('schema name is missing');
                } else {
                    object[schema.name] = value;
                }
            }
        }
        return original;
    }, hasValue = exports.hasValue = function (object, schema) {
        return object != null ? object.hasOwnProperty(schema.name) : void 0;
    }, coerce = exports.coerce = function (value, schema) {
        if (schema.filter != null) {
            value = schema.filter(value);
        }
        if (schema.type !== 'string' && typeof value === 'string' && value.length === 0) {
            value = null;
        } else if (!(value != null) || schema.minLength > 0 && (value != null ? value.length : void 0) === 0) {
            value = null;
        } else if (schema.enum) {
            if (!schema.enum.contains(value)) {
                value = null;
            }
        } else {
            value = convertType(value, schema.type);
            if ((value != null ? value.length : void 0) > schema.maxLength) {
                if (typeof value === 'string') {
                    value = value.substring(0, schema.maxLength);
                } else if (Array.isArray(value)) {
                    value.length = schema.maxLength;
                }
            }
            if (schema.minimum != null && value < schema.minimum) {
                value = schema.minimum;
            }
            if (schema.maximum != null && value > schema.maximum) {
                value = schema.maximum;
            }
            if (schema.properties != null) {
                for (var key in schema.properties) {
                    var propertySchema = schema.properties[key];
                    if (!(propertySchema.get != null || propertySchema.set != null)) {
                        var coercedValue = coerce(value[key], propertySchema);
                        if (coercedValue !== value[key] && propertySchema.writable !== false && propertySchema.hasOwnProperty('value')) {
                            value[key] = coercedValue;
                        }
                    }
                }
            }
            if (schema.additionalProperties != null && schema.additionalProperties !== true) {
                for (var key in value) {
                    if (!(schema.properties != null ? schema.properties[key] : void 0)) {
                        if (schema.additionalProperties === false) {
                            delete value[key];
                        } else {
                            if (schema.additionalProperties.pattern != null && !checkPattern(key, schema.additionalProperties.pattern)) {
                                console.log('Deleting invalid property named: ' + key);
                                delete value[key];
                            } else {
                                value[key] = coerce(value[key], schema.additionalProperties);
                            }
                        }
                    }
                }
            }
        }
        if (!(value != null) && schema.required) {
            value = schema.value != null ? schema.value : null;
        }
        return value;
    }, checkPattern = exports.checkPattern = function (text, pattern, errors, path) {
        if (typeof pattern === 'string') {
            pattern = new RegExp(pattern);
        }
        var result = pattern.exec(text);
        if (!(result != null) || result[0] !== text) {
            if (errors != null) {
                errors.push('' + text + ' at ' + path.join('.') + ' did not match ' + pattern);
            }
            return false;
        }
        return true;
    }, validate = exports.validate = function (object, schema, errors, path) {
        if (errors == null)
            errors = [];
        if (!(path != null)) {
            path = [];
            if (schema.name != null) {
                path.push(schema.name);
            }
        }
        if (schema != null) {
            if (object != null) {
                if (schema.hasOwnProperty('const') && schema.const !== object) {
                    errors.push('' + path.join('.') + ' was not ' + JSON.stringify(schema.const));
                }
                if (schema.enum) {
                    if (!schema.enum.contains(object)) {
                        errors.push('' + path.join('.') + ' was not one of ' + JSON.stringify(schema.enum));
                    }
                }
                if (schema.anyOf) {
                    var suberrors = [];
                    {
                        var _ref16 = schema.anyOf;
                        for (var _i6 = 0; _i6 < _ref16.length; _i6++) {
                            var subschema = _ref16[_i6];
                            suberrors.length = 0;
                            validate(object, subschema, suberrors, path);
                            if (suberrors.length === 0) {
                                break;
                            }
                        }
                    }
                    if (suberrors.length > 0) {
                        {
                            var _ref17 = schema.anyOf;
                            for (var _i7 = 0; _i7 < _ref17.length; _i7++) {
                                var subschema = _ref17[_i7];
                                validate(object, subschema, errors, path);
                                break;
                            }
                        }
                    }
                }
            }
            if (schema.required && !(object != null)) {
                errors.push('' + path.join('.') + ' is required');
            }
            if (object != null) {
                var pattern = schema.pattern != null ? schema.pattern : formatPatterns[schema.format];
                if (pattern != null && typeof object === 'string') {
                    checkPattern(object, pattern, errors, path);
                }
                if (schema.type != null) {
                    checkType(object, schema.type, errors, path);
                }
                if (schema.minimum != null && object < schema.minimum) {
                    errors.push('' + path.join('.') + ' must be >= ' + schema.minimum);
                }
                if (schema.maximum != null && object > schema.maximum) {
                    errors.push('' + path.join('.') + ' must be <= ' + schema.maximum);
                }
                if (schema.minLength != null && object.length < schema.minLength) {
                    errors.push('' + path.join('.') + '.length must be >= ' + schema.minLength);
                }
                if (schema.maxLength != null && object.length > schema.maxLength) {
                    errors.push('' + path.join('.') + '.length must be <= ' + schema.maxLength);
                }
                if (schema.properties != null) {
                    {
                        var _ref18 = schema.properties;
                        for (var key in _ref18) {
                            var value = _ref18[key];
                            path.push(key);
                            validate(object[key], value, errors, path);
                            path.pop();
                        }
                    }
                }
                if (schema.additionalProperties != null && schema.additionalProperties !== true) {
                    for (var key in object) {
                        var value = object[key];
                        if (!(schema.properties != null ? schema.properties[key] : void 0)) {
                            path.push(key);
                            if (schema.patternProperties) {
                                checkPattern(key, schema.patternProperties, errors, path);
                            }
                            if (schema.additionalProperties === false) {
                                errors.push('' + path.join('.') + ' is not an allowed property');
                            } else {
                                validate(value, schema.additionalProperties, errors, path);
                            }
                            path.pop(key);
                        }
                    }
                }
            }
        }
        return errors;
    }, forEach = exports.forEach = function (object, schema, callback) {
        forEachInternal({
            parent: null,
            name: null,
            object: object,
            schema: schema,
            callback: callback
        });
    }, prune = exports.prune = function (object, schema, callback) {
        var rootObject = object;
        forEach(object, schema, function (_ref3) {
            var root = _ref3.root;
            var path = _ref3.path;
            var parent = _ref3.parent;
            var name = _ref3.name;
            var object = _ref3.object;
            var schema = _ref3.schema;
            if (callback({
                    root: root,
                    path: path,
                    parent: parent,
                    name: name,
                    object: object,
                    schema: schema
                }) === false) {
                if (object === rootObject) {
                    rootObject = null;
                }
                delete parent[name];
            }
        });
        return rootObject;
    }, retain = exports.retain = function (object, schema, callback, options) {
        var retained = {};
        var rootObject = object;
        forEach(object, schema, function (_ref4) {
            var root = _ref4.root;
            var path = _ref4.path;
            var object = _ref4.object;
            var schema = _ref4.schema;
            if (callback({
                    root: root,
                    path: path,
                    object: object,
                    schema: schema
                }) === true) {
                set(retained, path, object, options);
                return false;
            }
        });
        return retained;
    }, stamps = exports.stamps = {
        'id': function (_ref5) {
            var key = _ref5.key;
            var object = _ref5.object;
            return key.id;
        },
        'key': function (_ref6) {
            var key = _ref6.key;
            var object = _ref6.object;
            return key.toString();
        },
        'date-time': function () {
            return new Date().toISOString();
        },
        'user': function (_ref7) {
            var key = _ref7.key;
            var object = _ref7.object;
            var name = _ref7.name;
            var user = _ref7.user;
            return user.key;
        },
        'email': function (_ref8) {
            var key = _ref8.key;
            var object = _ref8.object;
            var name = _ref8.name;
            var user = _ref8.user;
            return user.email;
        },
        'custom': function (args) {
            var _ref9 = args;
            var property = _ref9.property;
            return property.stamp.custom(args);
        },
        'increment': function (_ref10) {
            var key = _ref10.key;
            var name = _ref10.name;
            var property = _ref10.property;
            var securityObjects = _ref10.securityObjects;
            var ancestorProperty = property.stamp.ancestorProperty;
            if (!(ancestorProperty != null)) {
                throw new Error('\'ancestorProperty\' missing on ' + key.type.name + '.' + name + '.stamp');
            }
            var ancestorKey = key.parent;
            if (!(ancestorKey != null)) {
                throw new Error('' + name + ' property of ' + key.type + ' does not have an ancestor key so cannot be used with an increment stamp.');
            }
            var ancestor = securityObjects[ancestorKey];
            if (!(ancestor != null)) {
                throw new Error('Ancestor is not present in security objects: ' + ancestorKey);
            }
            var value = ancestor[ancestorProperty];
            if (!(value != null)) {
                throw new Error('' + key.type.name + '.' + ancestorProperty + ' is not defined.');
            }
            ancestor[ancestorProperty] = Number(value) + 1;
            return value;
        }
    }, stamp = exports.stamp = function (key, object, user, securityObjects) {
        if (object != null && (key.type != null ? key.type.properties : void 0) != null) {
            {
                var _ref19 = key.type.properties;
                for (var name in _ref19) {
                    var property = _ref19[name];
                    if (property.stamp) {
                        if (!(object[name] != null) || property.stamp.overwrite) {
                            var stampType = property.stamp.type != null ? property.stamp.type : property.format;
                            var fn = stamps[stampType];
                            if (!(fn != null)) {
                                throw ion.patch.combine(new Error('stamp \'' + stampType + '\' not found for property: ' + type + '.' + name), { code: 500 });
                            }
                            object[name] = coerce(fn({
                                key: key,
                                object: object,
                                property: property,
                                name: name,
                                user: user,
                                securityObjects: securityObjects
                            }), property);
                        }
                    }
                }
            }
        }
        return object;
    }, test = exports.test = {
        get: function () {
            if (!(get({ a: { b: 3 } }, [
                    'a',
                    'b'
                ]) === 3))
                throw new Error('Assertion Failed: (get({a:{b:3}}, [\'a\',\'b\']) is 3)');
        },
        set: function () {
            if (!(JSON.stringify(set({ a: { b: { c: 2 } } }, [
                    'a',
                    'b'
                ], true)) === '{"a":{"b":true}}'))
                throw new Error('Assertion Failed: (JSON.stringify(set({a:{b:{c:2}}}, [\'a\', \'b\'], true)) is \'{"a":{"b":true}}\')');
            if (!(JSON.stringify(set({ a: { b: { c: 2 } } }, [
                    'a',
                    'b'
                ], { d: 4 })) === '{"a":{"b":{"c":2,"d":4}}}'))
                throw new Error('Assertion Failed: (JSON.stringify(set({a:{b:{c:2}}}, [\'a\', \'b\'], {d:4})) is \'{"a":{"b":{"c":2,"d":4}}}\')');
            if (!(Object.keys(set({ a: { b: true } }, [
                    'a',
                    'b'
                ], null).a).length === 0))
                throw new Error('Assertion Failed: (Object.keys(set({a:{b:true}}, [\'a\', \'b\'], null).a).length is 0)');
        },
        coerce: function () {
            if (!(coerce('Kris', { maxLength: 2 }) === 'Kr'))
                throw new Error('Assertion Failed: (coerce("Kris", {maxLength:2}) is "Kr")');
            if (!(JSON.stringify(coerce([
                    1,
                    2,
                    3
                ], { maxLength: 2 })) === '[1,2]'))
                throw new Error('Assertion Failed: (JSON.stringify(coerce([1,2,3], {maxLength:2})) is "[1,2]")');
        },
        forEach: function () {
            var Person = {
                    properties: {
                        name: {
                            type: 'string',
                            required: true,
                            minLength: 2,
                            maxLength: 100
                        },
                        age: {
                            type: 'integer',
                            minimum: 0,
                            maximum: 130
                        },
                        recurse: {
                            properties: {
                                alpha: { type: 'string' },
                                beta: { type: 'string' }
                            }
                        }
                    },
                    additionalProperties: { type: 'integer' }
                };
            var person = {
                    name: 'good',
                    age: 112,
                    recurse: {
                        alpha: 'a',
                        beta: 'b'
                    },
                    additional: 4
                };
            var results = [];
            forEach(person, Person, function (_ref11) {
                var parent = _ref11.parent;
                var name = _ref11.name;
                var object = _ref11.object;
                var schema = _ref11.schema;
                results.push(parent, name, object, schema);
            });
            if (!equal(results, [
                    person,
                    'name',
                    person.name,
                    Person.properties.name,
                    person,
                    'age',
                    person.age,
                    Person.properties.age,
                    person,
                    'recurse',
                    person.recurse,
                    Person.properties.recurse,
                    person.recurse,
                    'alpha',
                    person.recurse.alpha,
                    Person.properties.recurse.properties.alpha,
                    person.recurse,
                    'beta',
                    person.recurse.beta,
                    Person.properties.recurse.properties.beta,
                    person,
                    'additional',
                    person.additional,
                    Person.additionalProperties
                ]))
                throw new Error('Assertion Failed: (equal(\n            {{{{\n                results\n                []\n                {{{{\n                    person, \'name\', person.name, Person.properties.name\n                    person, \'age\', person.age, Person.properties.age\n                    person, \'recurse\', person.recurse, Person.properties.recurse\n                    person.recurse, \'alpha\', person.recurse.alpha, Person.properties.recurse.properties.alpha\n                    person.recurse, \'beta\', person.recurse.beta, Person.properties.recurse.properties.beta\n                    person, \'additional\', person.additional, Person.additionalProperties\n                }}}}\n            }}}}\n            ))');
            results = [];
            exports.forEach(person, Person, function (_ref12) {
                var parent = _ref12.parent;
                var name = _ref12.name;
                var object = _ref12.object;
                var schema = _ref12.schema;
                results.push(parent, name, object, schema);
                if (name === 'recurse') {
                    return false;
                }
            });
            if (!equal(results, [
                    person,
                    'name',
                    person.name,
                    Person.properties.name,
                    person,
                    'age',
                    person.age,
                    Person.properties.age,
                    person,
                    'recurse',
                    person.recurse,
                    Person.properties.recurse,
                    person,
                    'additional',
                    person.additional,
                    Person.additionalProperties
                ]))
                throw new Error('Assertion Failed: (equal(\n            {{{{\n                results\n                []\n                {{{{\n                    person, \'name\', person.name, Person.properties.name\n                    person, \'age\', person.age, Person.properties.age\n                    person, \'recurse\', person.recurse, Person.properties.recurse\n                    person, \'additional\', person.additional, Person.additionalProperties\n                }}}}\n            }}}}\n            ))');
        },
        format: function () {
            var Person = {
                    properties: {
                        email: { format: 'email' },
                        date: { format: 'date' },
                        time: { format: 'time' },
                        two: { pattern: '\\d\\d' },
                        twoRegex: { pattern: /\d\d/ }
                    }
                };
            var invalid = {
                    email: 'foo@@',
                    date: '22',
                    time: '45',
                    two: '5',
                    twoRegex: '555'
                };
            var errors = validate(invalid, Person);
            if (!(errors.length === 5))
                throw new Error('Assertion Failed: (errors.length is 5)');
            var valid = {
                    email: 'foo@bar.com',
                    date: '2245-12-22',
                    time: '22:22',
                    two: '52',
                    twoRegex: '97'
                };
            errors = validate(valid, Person);
            if (!(errors.length === 0))
                throw new Error('Assertion Failed: (errors.length is 0)');
            if (!(validate('2012-00-20', { format: 'date' }).length === 1))
                throw new Error('Assertion Failed: (validate("2012-00-20", {format:\'date\'}).length is 1)');
            if (!(validate('2012-13-20', { format: 'date' }).length === 1))
                throw new Error('Assertion Failed: (validate("2012-13-20", {format:\'date\'}).length is 1)');
            if (!(validate('2012-01-00', { format: 'date' }).length === 1))
                throw new Error('Assertion Failed: (validate("2012-01-00", {format:\'date\'}).length is 1)');
            if (!(validate('2012-01-32', { format: 'date' }).length === 1))
                throw new Error('Assertion Failed: (validate("2012-01-32", {format:\'date\'}).length is 1)');
            if (!(validate('00:30', { format: 'time' }).length === 0))
                throw new Error('Assertion Failed: (validate("00:30", {format:\'time\'}).length is 0)');
            if (!(validate('00:00', { format: 'time' }).length === 0))
                throw new Error('Assertion Failed: (validate("00:00", {format:\'time\'}).length is 0)');
            if (!(validate('24:00', { format: 'time' }).length === 0))
                throw new Error('Assertion Failed: (validate("24:00", {format:\'time\'}).length is 0)');
            if (!(validate('24:30', { format: 'time' }).length === 1))
                throw new Error('Assertion Failed: (validate("24:30", {format:\'time\'}).length is 1)');
            if (!(validate('25:00', { format: 'time' }).length === 1))
                throw new Error('Assertion Failed: (validate("25:00", {format:\'time\'}).length is 1)');
            if (!(validate('22:60', { format: 'time' }).length === 1))
                throw new Error('Assertion Failed: (validate("22:60", {format:\'time\'}).length is 1)');
        },
        validate: function () {
            var Person = {
                    name: 'Person',
                    additionalProperties: false,
                    properties: {
                        name: {
                            type: 'string',
                            required: true,
                            minLength: 2,
                            maxLength: 100
                        },
                        age: {
                            type: 'integer',
                            minimum: 0,
                            maximum: 130,
                            value: 0
                        },
                        key: { type: 'string' },
                        number: {
                            type: 'integer',
                            value: 0
                        },
                        type: {
                            enum: [
                                'a',
                                true,
                                12
                            ]
                        },
                        foo: {
                            anyOf: [
                                { type: 'string' },
                                { type: 'boolean' }
                            ]
                        },
                        subscribed: {
                            type: 'object',
                            additionalProperties: {
                                type: 'object',
                                additionalProperties: false,
                                properties: {
                                    readCommentId: {
                                        type: 'integer',
                                        minimum: 0
                                    }
                                }
                            }
                        }
                    }
                };
            var invalid = {
                    name: 'a',
                    age: -2,
                    number: 'not a number',
                    type: 8,
                    foo: 45,
                    subscribed: { foo: { fuck: 2 } }
                };
            var errors = validate(invalid, Person);
            if (!((errors != null ? errors.length : void 0) === 6))
                throw new Error('Assertion Failed: (errors?.length is 6)');
            var valid = {
                    name: 'good',
                    age: 112,
                    subscribed: { foo: { readCommentId: 2 } }
                };
            errors = validate(valid, Person);
            if (!(errors.length === 0))
                throw new Error('Assertion Failed: (errors.length is 0)');
            var extraProperty = {
                    name: 'Foo',
                    extra: 12
                };
            errors = validate(extraProperty, Person);
            if (!(errors.length === 1))
                throw new Error('Assertion Failed: (errors.length is 1)');
        },
        pruneAndRetain: function () {
            var Person = {
                    properties: {
                        name: {
                            type: 'string',
                            required: true,
                            minLength: 2,
                            maxLength: 100
                        },
                        age: {
                            type: 'integer',
                            minimum: 0,
                            maximum: 130
                        },
                        recurse: {
                            properties: {
                                alpha: { type: 'string' },
                                beta: { type: 'string' }
                            }
                        }
                    }
                };
            var person = {
                    name: 'good',
                    age: 112,
                    recurse: {
                        alpha: 'a',
                        beta: 'b'
                    }
                };
            var retained = retain(person, Person, function (_ref13) {
                    var root = _ref13.root;
                    var path = _ref13.path;
                    var object = _ref13.object;
                    var schema = _ref13.schema;
                    var name = path[path.length - 1];
                    if (name === 'age' || name === 'alpha') {
                        return true;
                    }
                });
            if (!(JSON.stringify(retained) === '{"age":112,"recurse":{"alpha":"a"}}'))
                throw new Error('Assertion Failed: (JSON.stringify(retained) is \'{"age":112,"recurse":{"alpha":"a"}}\')');
            if (!(JSON.stringify(retain(person, Person, function () {
                    return false;
                })) === '{}'))
                throw new Error('Assertion Failed: (JSON.stringify(retain(person, Person, () -> false)) is "{}")');
            var results = [];
            prune(person, Person, function (_ref14) {
                var root = _ref14.root;
                var path = _ref14.path;
                var object = _ref14.object;
                var schema = _ref14.schema;
                var name = path[path.length - 1];
                if (name === 'age' || name === 'alpha') {
                    return false;
                }
            });
            if (!equal(person, {
                    name: 'good',
                    recurse: { beta: 'b' }
                }))
                throw new Error('Assertion Failed: (equal(person, {name:\'good\',recurse:{beta:\'b\'}}))');
        }
    };
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/data/Schema',_glass_data_Schema_);
    else
      _glass_data_Schema_.call(this, module, exports, require);
  }
  else {
    _glass_data_Schema_.call(this);
  }
}).call(this)
void (function(){var _glass_data_SecurityContext_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('./'), doAncestorsAllowThisTypeAsDescendant = function (key) {
        var parent = key.parent;
        if (!parent) {
            return true;
        }
        if (!((parent.type.descendantTypes != null ? parent.type.descendantTypes[key.type.name] : void 0) != null)) {
            return false;
        }
        return doAncestorsAllowThisTypeAsDescendant(parent);
    };
var Schema = _ref.Schema;
var Key = _ref.Key;
var SecurityContext = ion.defineClass({
        name: 'SecurityContext',
        checkPropertyRead: function (_ref2) {
            var user = _ref2.user;
            var related = _ref2.related;
            var record = _ref2.record;
            var property = _ref2.property;
            return SecurityContext.checkPropertyAccess({
                user: user,
                related: related,
                record: record,
                property: property,
                access: 'read'
            });
        },
        checkPropertyWrite: function (_ref3) {
            var user = _ref3.user;
            var related = _ref3.related;
            var record = _ref3.record;
            var property = _ref3.property;
            var access = _ref3.access;
            return SecurityContext.checkPropertyAccess({
                user: user,
                related: related,
                record: record,
                property: property,
                access: 'write'
            });
        },
        checkPropertyAccess: function (_ref4) {
            var user = _ref4.user;
            var related = _ref4.related;
            var record = _ref4.record;
            var property = _ref4.property;
            var access = _ref4.access;
            var context = new SecurityContext({
                    user: user,
                    related: related,
                    record: record,
                    access: access
                });
            var path = [property];
            var type = record.constructor;
            var schema = type.properties[property];
            if (!(schema != null)) {
                throw new Error('Property not found: ' + property);
            }
            var rootResult = context.checkAccess({
                    object: record,
                    schema: type
                });
            if (rootResult === false || rootResult !== true && access === 'delete') {
                return false;
            }
            var propertyResult = context.checkAccess({
                    object: record[property],
                    schema: schema
                });
            return (propertyResult != null ? propertyResult : rootResult) === true;
        },
        pruneChanges: function (_ref5) {
            var namespace = _ref5.namespace;
            var user = _ref5.user;
            var related = _ref5.related;
            var oldRecords = _ref5.oldRecords;
            var changes = _ref5.changes;
            var newRecords = _ref5.newRecords;
            if (!(namespace != null)) {
                throw new Error('namespace is required');
            }
            if (!(user != null)) {
                throw new Error('user required');
            }
            if (!(related != null)) {
                throw new Error('related required');
            }
            if (!(oldRecords != null)) {
                throw new Error('oldRecords required');
            }
            if (!(changes != null)) {
                throw new Error('changes required');
            }
            if (!(newRecords != null)) {
                throw new Error('newRecords required');
            }
            var context = new SecurityContext({
                    user: user,
                    related: related,
                    oldRecords: oldRecords,
                    newRecords: newRecords
                });
            var pruneRecordChanges = function (keyString, change) {
                var record = oldRecords[keyString];
                var access = change === null ? 'delete' : 'write';
                var key = new Key(namespace, keyString);
                var type = key.type;
                if (!(record != null)) {
                    if (!doAncestorsAllowThisTypeAsDescendant(key)) {
                        return null;
                    }
                    record = new type(change);
                    Schema.stamp(key, record, user, related);
                }
                context.record = record;
                context.access = access;
                var rootResult = context.checkAccess({
                        object: record,
                        schema: type
                    });
                if (rootResult === false || rootResult !== true && access === 'delete') {
                    return void 0;
                }
                if (access === 'delete') {
                    return rootResult ? change : void 0;
                }
                if (access === 'write' && rootResult !== true) {
                    return Schema.retain(change, type, context.checkAccess, { deleteNull: false });
                }
                return Schema.prune(change, type, context.checkAccess);
            };
            for (var keyString in changes) {
                var change = changes[keyString];
                var result = pruneRecordChanges(keyString, change);
                if (result === void 0) {
                    delete changes[keyString];
                } else {
                    changes[keyString] = result;
                }
            }
            return changes;
        },
        pruneResults: function (_ref6) {
            var namespace = _ref6.namespace;
            var key = _ref6.key;
            var user = _ref6.user;
            var related = _ref6.related;
            var results = _ref6.results;
            if (!(results != null)) {
                return results;
            }
            if (!(namespace != null)) {
                throw new Error('namespace is required');
            }
            if (!(user != null)) {
                throw new Error('user required');
            }
            if (!(related != null)) {
                throw new Error('related required');
            }
            if (!(results != null)) {
                throw new Error('results required');
            }
            if (user.superuser && (key != null ? key.query != null ? key.query.superuser : void 0 : void 0)) {
                return results;
            }
            var context = new SecurityContext({
                    key: key,
                    user: user,
                    related: related
                });
            var pruneRecord = function (record) {
                if (!(record != null)) {
                    return null;
                }
                var type = record.constructor;
                context.record = record;
                context.access = 'read';
                var rootResult = context.checkAccess({
                        object: record,
                        schema: type
                    });
                if (rootResult === false) {
                    return null;
                } else if (rootResult === true) {
                    return Schema.prune(record, type, context.checkAccess);
                } else {
                    return Schema.retain(record, type, context.checkAccess);
                }
            };
            var pruneRecords = function (records) {
                for (var path in records) {
                    var record = records[path];
                    var result = pruneRecord(record);
                    if (!(result != null)) {
                        delete records[path];
                    } else {
                        records[path] = result;
                    }
                }
                return records;
            };
            if (results.constructor === Object) {
                return pruneRecords(results);
            } else {
                return pruneRecord(results);
            }
        },
        constructor: function SecurityContext() {
            SecurityContext.super.apply(this, arguments);
            this.checkAccess = ion.bind(function (_ref7) {
                var path = _ref7.path;
                var object = _ref7.object;
                var schema = _ref7.schema;
                if (schema.access != null) {
                    var fn = schema.access[this.access] != null ? schema.access[this.access] : schema.access;
                    if (typeof fn === 'boolean') {
                        return fn;
                    } else if (typeof fn === 'function') {
                        this.path = path != null ? path : [];
                        this.name = this.path[this.path.length - 1];
                        this.object = object;
                        this.schema = schema;
                        return fn.call(this.record, this);
                    }
                }
            }, this);
        },
        properties: {
            key: { type: 'object' },
            user: { type: 'object' },
            related: { type: 'object' },
            record: { type: 'object' },
            schema: { type: 'object' },
            path: { type: 'array' },
            name: { type: 'array' },
            object: { type: 'any' },
            oldRecords: { type: 'object' },
            newRecords: { type: 'object' },
            access: {
                type: 'string',
                value: 'read'
            }
        }
    });
module.exports = exports = SecurityContext;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/data/SecurityContext',_glass_data_SecurityContext_);
    else
      _glass_data_SecurityContext_.call(this, module, exports, require);
  }
  else {
    _glass_data_SecurityContext_.call(this);
  }
}).call(this)
void (function(){var _glass_data_Source_ = function(module,exports,require){'use strict';
var ion = require('ion');
var Source = ion.defineClass({
        name: 'Source',
        id: module.id,
        properties: {
            open: function (key, options, handler) {
                throw new Error('not implemented');
            },
            peek: function (key, options) {
                options = options != null ? options : {};
                options.read = options.read != null ? options.read : true;
                options.write = options.write != null ? options.write : false;
                options.async = options.async != null ? options.async : false;
                options.cached = options.cached != null ? options.cached : true;
                var value = void 0;
                var connection = this.open(key, options, function (object) {
                        return value = object;
                    });
                connection();
                return value;
            },
            read: function (key, options, callback) {
                options = options != null ? options : {};
                options.read = options.read != null ? options.read : true;
                options.write = options.write != null ? options.write : false;
                options.async = options.async != null ? options.async : true;
                options.cached = options.cached != null ? options.cached : true;
                var value = void 0;
                var connection = this.open(key, options, function (object) {
                        callback != null ? callback(object) : void 0;
                        connection();
                    });
            },
            refresh: function (key, callback) {
                this.read(key, {
                    read: true,
                    write: false,
                    cached: false
                }, callback);
            },
            patch: function (key, object, options, handler) {
                if (typeof options === 'function') {
                    handler = options;
                    options = null;
                }
                options = ion.patch.combine(options, {
                    read: false,
                    write: true
                });
                handler = handler != null ? handler : function () {
                };
                var lastResult = void 0;
                var connection = this.open(key, options, function (result) {
                        lastResult = result;
                        handler != null ? handler(result) : void 0;
                    });
                connection(object);
                connection();
                return lastResult;
            },
            peek: function (key, options) {
                options = ion.patch.combine(options, {
                    read: true,
                    write: false,
                    async: false
                });
                var value = void 0;
                var connection = this.open(key, options, function (object) {
                        return value = object;
                    });
                connection();
                return value;
            },
            dispose: function () {
            }
        }
    }, require('../Component'));
module.exports = exports = Source;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/data/Source',_glass_data_Source_);
    else
      _glass_data_Source_.call(this, module, exports, require);
  }
  else {
    _glass_data_Source_.call(this);
  }
}).call(this)
void (function(){var _glass_data_filters_AjaxSource_ = function(module,exports,require){'use strict';
var ion = require('ion');
var AjaxSource = ion.defineClass({
        name: 'AjaxSource',
        id: module.id,
        properties: {
            error: {
                writable: true,
                value: function (e) {
                    return console.error(e);
                }
            },
            url: '/data/',
            token: null,
            headers: {},
            logging: false,
            ajax: function (url, object, callback) {
                var request = new XMLHttpRequest();
                var method = object !== void 0 ? 'POST' : 'GET';
                request.open(method, url, true);
                {
                    var _ref = this.headers;
                    for (var name in _ref) {
                        var value = _ref[name];
                        request.setRequestHeader(name, value);
                    }
                }
                var content = void 0;
                if (this.token != null) {
                    request.setRequestHeader('Authorization', 'Bearer ' + this.token);
                }
                if (object !== void 0) {
                    request.setRequestHeader('Content-Type', 'application/json');
                    content = JSON.stringify(object);
                }
                request.onreadystatechange = ion.bind(function () {
                    if (request.readyState === 4) {
                        if (request.status < 300) {
                            var responseText = request.responseText;
                            if (global.model != null) {
                                global.model.online = request.status !== 0;
                            }
                            if (request.status !== 0 && responseText.length > 0) {
                                var responseObject = JSON.parse(responseText);
                                if (this.logging) {
                                    console.log('');
                                    console.log('=URL=========================================================================');
                                    console.log(url);
                                    if (method === 'POST') {
                                        console.log('=SENT========================================================================');
                                        console.log(JSON.stringify(object, null, 2));
                                    }
                                    console.log('=RECIEVED====================================================================');
                                    console.log(JSON.stringify(responseObject, null, 2));
                                    console.log('=============================================================================');
                                    console.log('');
                                }
                                ion.freeze(responseObject, true);
                                callback(responseObject);
                            } else {
                                console.warn('Empty JSON Response, we probably got disconnected from the server.');
                                callback(void 0);
                            }
                        } else {
                            this.error('' + request.status + ' ' + request.responseText, request);
                            callback(void 0);
                        }
                        ion.sync();
                    }
                }, this);
                if (this.logging) {
                    console.log('');
                    console.log('=URL=========================================================================');
                    console.log(url);
                    if (method === 'POST') {
                        console.log('=SENT========================================================================');
                        console.log(JSON.stringify(object, null, 2));
                    }
                    console.log('=============================================================================');
                    console.log('');
                }
                request.send(content);
            },
            send: function (key, object, callback) {
                this.ajax(this.url + key, object, callback);
            },
            open: function (key, options, handler) {
                if ((options != null ? options.async : void 0) === false) {
                    return function () {
                    };
                }
                if (options.read) {
                    this.send(key, void 0, handler);
                }
                return ion.bind(function (object) {
                    if (object !== void 0) {
                        this.send(key, object, handler);
                    }
                }, this);
            }
        }
    }, require('../Source'));
module.exports = exports = AjaxSource;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/data/filters/AjaxSource',_glass_data_filters_AjaxSource_);
    else
      _glass_data_filters_AjaxSource_.call(this, module, exports, require);
  }
  else {
    _glass_data_filters_AjaxSource_.call(this);
  }
}).call(this)
void (function(){var _glass_data_filters_CacheFilter_ = function(module,exports,require){'use strict';
var _ref = require('../'), ion = require('ion'), copy = function (object) {
        return object != null ? JSON.parse(JSON.stringify(object)) : object;
    };
var Key = _ref.Key;
var query = _ref.query;
var count = 0;
var CacheFilter = ion.defineClass({
        name: 'CacheFilter',
        id: module.id,
        constructor: function CacheFilter() {
            CacheFilter.super.apply(this, arguments);
            this.count = ++count;
            this.handlers = {};
        },
        properties: {
            propagateChanges: global.window != null,
            incomingPatch: function (key, patch, sourceHandler, notifyServer) {
                var keyHandler = this.handlers[key];
                this.applyPatch(keyHandler, patch, sourceHandler, notifyServer);
                if (key.id != null) {
                    var entity = keyHandler.value;
                    {
                        var _ref3 = this.handlers;
                        for (var otherKeyString in _ref3) {
                            var otherKeyHandler = _ref3[otherKeyString];
                            var otherKey = otherKeyHandler.key;
                            if (!(otherKey.id != null) && key.path.startsWith(otherKey.path)) {
                                if (query.matches(otherKey.query != null ? otherKey.query.where : void 0, entity)) {
                                    var otherEntity = otherKeyHandler.value != null ? otherKeyHandler.value[key] : void 0;
                                    if (otherEntity != null) {
                                        var _ref7 = {};
                                        _ref7[key] = patch;
                                        this.applyPatch(otherKeyHandler, _ref7, sourceHandler, false);
                                    }
                                }
                            }
                        }
                    }
                } else {
                    if (patch != null) {
                        for (var id in patch) {
                            var entityPatch = patch[id];
                            var entityKey = key.get(id);
                            var entityKeyHandler = this.getKeyHandler(entityKey);
                            this.applyPatch(entityKeyHandler, entityPatch, null, false);
                        }
                    }
                    if (this.propagateChanges) {
                        var entityValues = {};
                        {
                            var _ref4 = keyHandler.value;
                            for (var id in _ref4) {
                                var entity = _ref4[id];
                                entityValues[id] = copy(entity);
                            }
                        }
                        {
                            var _ref5 = this.handlers;
                            for (var otherKeyString in _ref5) {
                                var otherKeyHandler = _ref5[otherKeyString];
                                var otherKey = otherKeyHandler.key;
                                if (!(otherKey.id != null) && key.path === otherKey.path) {
                                    var otherPatch = null;
                                    for (var id in patch) {
                                        var entityPatch = patch[id];
                                        var otherEntityValue = otherKeyHandler.value != null ? otherKeyHandler.value[id] : void 0;
                                        var entity = ion.patch(entityValues[id] != null ? entityValues[id] : copy(otherEntityValue), entityPatch);
                                        var canAdd = (entity != null ? entity.$ : void 0) != null;
                                        var canRemove = true;
                                        if (query.matches(otherKey.query != null ? otherKey.query.where : void 0, new key.type(entity))) {
                                            if (canAdd || otherEntityValue != null) {
                                                otherPatch = otherPatch != null ? otherPatch : {};
                                                otherPatch[id] = otherEntityValue != null ? entityPatch : entity;
                                            }
                                        } else {
                                            if (canRemove && otherEntityValue != null) {
                                                otherPatch = otherPatch != null ? otherPatch : {};
                                                otherPatch[id] = null;
                                            }
                                        }
                                    }
                                    if (otherPatch != null) {
                                        this.applyPatch(otherKeyHandler, otherPatch, null, false);
                                    }
                                }
                            }
                        }
                    }
                }
            },
            breakIfUntypedObject: function (key, value) {
                if (!(key != null) || key.id != null) {
                    if (value != null && !(value.$ != null)) {
                        debugger;
                    }
                } else {
                    for (var name in value) {
                        var object = value[name];
                        this.breakIfUntypedObject(null, value[name]);
                    }
                }
            },
            applyPatch: function (keyHandler, patch, excludeHandler, notifyServer) {
                var _ref2 = keyHandler;
                var key = _ref2.key;
                if (ion.patch.isChange(keyHandler.value, patch)) {
                    if (key.id) {
                        keyHandler.value = ion.patch(keyHandler.value, patch);
                    } else {
                        keyHandler.value = keyHandler.value != null ? keyHandler.value : {};
                        for (var name in patch) {
                            var value = patch[name];
                            var typeKey = '$';
                            if (keyHandler.value[name] != null || (value != null ? value[typeKey] : void 0) != null) {
                                keyHandler.value[name] = ion.patch(keyHandler.value[name], value);
                            }
                        }
                        this.breakIfUntypedObject(keyHandler.key, keyHandler.value, patch);
                    }
                    {
                        var _ref6 = keyHandler.handlers;
                        for (var _i = 0; _i < _ref6.length; _i++) {
                            var callback = _ref6[_i];
                            if (callback !== excludeHandler) {
                                callback(patch);
                            }
                        }
                    }
                    if (notifyServer) {
                        this.openInner(keyHandler, {
                            read: false,
                            write: true,
                            async: true
                        })(patch);
                    }
                }
            },
            openInner: function (keyHandler, options) {
                if (!(keyHandler.inner != null)) {
                    var key = keyHandler.key;
                    keyHandler.inner != null ? keyHandler.inner() : void 0;
                    keyHandler.inner = this.inner.open(key, options, ion.bind(function (object) {
                        this.incomingPatch(key, object, null, false);
                    }, this));
                }
                return keyHandler.inner;
            },
            getKeyHandler: function (key) {
                return this.handlers[key] = this.handlers[key] != null ? this.handlers[key] : {
                    key: key,
                    value: void 0,
                    handlers: [],
                    deleted: {}
                };
            },
            open: function (key, options, handler) {
                if (!options.read) {
                    return this.inner.open(key, options, handler);
                }
                var keyHandler = this.getKeyHandler(key);
                keyHandler.handlers.push(handler);
                if (keyHandler.value !== void 0) {
                    handler(JSON.parse(JSON.stringify(keyHandler.value)));
                } else {
                    this.openInner(keyHandler, options);
                }
                return ion.bind(function (object) {
                    if (object !== void 0) {
                        this.incomingPatch(key, object, handler, true);
                    } else {
                        if (keyHandler.handlers.length === 1) {
                            keyHandler.inner != null ? keyHandler.inner() : void 0;
                            delete keyHandler.inner;
                        }
                        var index = keyHandler.handlers.lastIndexOf(handler);
                        if (index >= 0) {
                            keyHandler.handlers.splice(index, 1);
                        }
                    }
                }, this);
            }
        }
    }, require('./Filter'));
module.exports = exports = CacheFilter;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/data/filters/CacheFilter',_glass_data_filters_CacheFilter_);
    else
      _glass_data_filters_CacheFilter_.call(this, module, exports, require);
  }
  else {
    _glass_data_filters_CacheFilter_.call(this);
  }
}).call(this)
void (function(){var _glass_data_filters_ClientDatabase_ = function(module,exports,require){"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const ion = require("ion");
const { crypt } = require('../../');
const { Key, Source } = require("../");
function clone(object) {
    if (object != null)
        object = JSON.parse(JSON.stringify(object));
    return object;
}
function patchAndDiff(object = null, patch) {
    let original = clone(object);
    let patched = ion.patch.patchNoDelete(object, patch);
    let diff = ion.patch.diff(original, clone(patched));
    return [patched, diff];
}
class ClientDatabase {
    constructor({ inner, token, namespace }) {
        this.flushChangesConnection = null;
        window.addEventListener("beforeunload", (e) => {
            this.saveChanges();
            this.saveValues();
        });
        let { userKey, userHash } = crypt.jwtRead(token);
        this.rootKey = new Key(namespace);
        this.saveValuesKey = "ClientDatabase.values:" + userKey;
        this.saveChangesKey = "ClientDatabase.changes:" + userKey;
        this.saveHash = userHash;
        this.savedValues = {};
        this.inner = inner;
        this.token = token;
        this.values = this.loadCrypt(this.saveValuesKey, {});
        this.changes = this.loadCrypt(this.saveChangesKey, {});
        this.handlers = {};
        global.dbvalues = this.values;
        global.dbchanges = this.changes;
    }
    ;
    dispose() {
        this.inner.dispose();
    }
    saveCrypt(name, object) {
        let value = JSON.stringify(object);
        if (this.savedValues[name] !== value) {
            this.savedValues[name] = value;
            localStorage.setItem(name, crypt.encrypt(value, this.saveHash));
        }
    }
    loadCrypt(name, defaultValue) {
        let item = localStorage.getItem(name);
        if (item != null) {
            try {
                let decrypted = crypt.decrypt(item, this.saveHash);
                if (decrypted != null) {
                    return JSON.parse(decrypted);
                }
            }
            catch (e) {
                console.warn('Error decrypting client database', e);
                localStorage.removeItem(name);
            }
        }
        return defaultValue;
    }
    queueSaveValues() {
        if (this.saveTimeoutId != null) {
            clearTimeout(this.saveTimeoutId);
        }
        this.saveTimeoutId = setTimeout(() => {
            this.saveTimeoutId = null;
            this.saveValues();
        }, 2000);
    }
    queueFlushChanges(time) {
        if (time == null)
            time = 50;
        if (this.flushChangesConnection == null && this.flushChangesTimeoutId == null && Object.keys(this.changes).length > 0) {
            this.flushChangesTimeoutId = setTimeout(() => {
                this.flushChangesTimeoutId = null;
                this.flushChanges();
            }, time);
        }
    }
    flushChanges() {
        let changes = clone(this.changes);
        this.flushChangesConnection = this.inner.open(this.rootKey, { read: false, write: true }, (object) => {
            let nextFlushTime = null;
            if (object === undefined) {
                nextFlushTime = 10 * 1000;
            }
            else {
                window.dispatchEvent(new CustomEvent("flushed"));
                for (let keystring in changes) {
                    if (JSON.stringify(changes[keystring]) == JSON.stringify(this.changes[keystring]))
                        delete this.changes[keystring];
                }
                this.saveChanges();
                let combinedChanges = ion.patch.combine(changes, object);
                this.patchValues(this.rootKey, combinedChanges, false, null);
            }
            if (this.flushChangesConnection) {
                this.flushChangesConnection();
                this.flushChangesConnection = null;
            }
            this.queueFlushChanges(nextFlushTime);
        });
        if (this.flushChangesConnection) {
            this.flushChangesConnection(changes);
        }
    }
    saveValues() {
        this.saveCrypt(this.saveValuesKey, this.values);
    }
    saveChanges() {
        this.saveCrypt(this.saveChangesKey, this.changes);
        this.queueFlushChanges();
    }
    openSubquery(parentQueryKey, key, options, handler) {
        let count = 0;
        let parentHandler = this.open(parentQueryKey, options, (object) => {
            if (object != null) {
                object = object[key.toString()];
                if (count == 0 && object == undefined)
                    object = null;
                if (object !== undefined)
                    handler(object);
                count++;
            }
        });
        return (object) => {
            if (object !== undefined) {
                object = { [key.toString()]: object };
            }
            parentHandler(object);
        };
    }
    open(key, options, handler) {
        if (key.id && key.parent && options.cached != false) {
            let parentQueryKey = key.get(key.parent, key.type);
            if (this.handlers[parentQueryKey.toString()])
                return this.openSubquery(parentQueryKey, key, options, handler);
        }
        let keyValue = this.values[key.toString()];
        if (keyValue == null) {
            keyValue = this.values[key.toString()] = { created: new Date().toISOString() };
        }
        if (keyValue.value !== undefined && options.cached !== false) {
            handler(clone(keyValue.value));
        }
        let keyHandler = this.handlers[key.toString()];
        if (keyHandler == null) {
            keyHandler = this.handlers[key.toString()] = { key, handlers: [handler], innerHandler: null };
        }
        if (keyHandler.innerHandler == null || options.cached === false) {
            if (keyHandler.innerHandler != null) {
                keyHandler.innerHandler();
            }
            let count = 0;
            keyHandler.innerHandler = this.inner.open(key, { read: true, write: true }, (object) => {
                if (object !== undefined) {
                    let isCompleteValue = count == 0;
                    count++;
                    if (isCompleteValue && options.cached === false) {
                        handler(clone(object));
                    }
                    this.patchValues(key, object, isCompleteValue, null);
                }
            });
        }
        return (object) => {
            if (object === undefined) {
                keyHandler.handlers.remove(handler);
            }
            else {
                this.patchValues(key, object, false, handler);
            }
        };
    }
    patchChanges(key, patch) {
        if (key.type && key.id == null && patch != null) {
            for (let keystring in patch) {
                let childKey = key.get(keystring);
                let childPatch = patch[keystring];
                this.patchChanges(childKey, childPatch);
            }
        }
        if (key.id) {
            this.changes[key.toString()] = ion.patch.combine(this.changes[key.toString()], patch);
        }
    }
    patchValues(key, patch, isCompleteValue, sourceHandler, root = true, completeTypedEntity) {
        if (root) {
            patch = clone(patch);
        }
        let keyValue = this.values[key.toString()];
        let cameFromServer = sourceHandler == null;
        let cameFromClient = !cameFromServer;
        if (root && !key.id && patch != null) {
            let isRootKey = key.toString().length === 0;
            for (let keystring in patch) {
                let childKey = key.get(keystring);
                let childPatch = patch[keystring];
                if (isRootKey || childPatch === null && !isRootKey) {
                    continue;
                }
                let completeTypedEntity = undefined;
                if (keyValue && keyValue.value) {
                    let completeEntity = keyValue.value[keystring];
                    if (completeEntity) {
                        completeTypedEntity = ion.deserialize(ion.patch(clone(completeEntity), childPatch), key.namespace);
                    }
                }
                this.patchValues(childKey, childPatch, isCompleteValue, sourceHandler, false, completeTypedEntity);
            }
        }
        if (key.id) {
            for (let keystring in this.handlers) {
                let otherKeyHandler = this.handlers[keystring];
                if (otherKeyHandler.key.id == null && otherKeyHandler.key.type == key.type) {
                    let otherKeyValue = this.values[keystring];
                    if (otherKeyValue != null && otherKeyValue.value != null && otherKeyValue.value.hasOwnProperty(key.toString())) {
                        this.patchValues(otherKeyHandler.key, { [key.toString()]: patch }, false, sourceHandler, false);
                    }
                    else if (otherKeyHandler.key.query != null && otherKeyHandler.key.query.watch && completeTypedEntity && sourceHandler) {
                        if (otherKeyHandler.key.isMatch(key, completeTypedEntity)) {
                            this.patchValues(otherKeyHandler.key, { [key.toString()]: JSON.parse(JSON.stringify(completeTypedEntity)) }, false, null, false);
                        }
                    }
                }
            }
        }
        if (key.id || key.type) {
            if (keyValue) {
                let patched, diff;
                if (isCompleteValue) {
                    patched = clone(patch);
                    diff = ion.patch.diff(keyValue.value, patched);
                }
                else {
                    [patched, diff] = patchAndDiff(keyValue.value, patch);
                }
                keyValue.value = patched;
                if (diff !== undefined) {
                    let keyHandler = this.handlers[key.toString()];
                    if (keyHandler) {
                        for (let handler of keyHandler.handlers) {
                            if (handler !== sourceHandler) {
                                handler(clone(diff));
                            }
                        }
                    }
                    if (cameFromClient) {
                        this.patchChanges(key, diff);
                    }
                }
            }
        }
        if (root) {
            if (cameFromClient) {
                this.saveChanges();
            }
            this.queueSaveValues();
        }
    }
    peek(key, options) {
        let keyValue = this.values[key.toString()];
        if (keyValue != null)
            return clone(keyValue.value);
    }
}
exports.default = ClientDatabase;
//# sourceMappingURL=ClientDatabase.js.map
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/data/filters/ClientDatabase',_glass_data_filters_ClientDatabase_);
    else
      _glass_data_filters_ClientDatabase_.call(this, module, exports, require);
  }
  else {
    _glass_data_filters_ClientDatabase_.call(this);
  }
}).call(this)
void (function(){var _glass_data_filters_DebugFilter_ = function(module,exports,require){'use strict';
var ion = require('ion');
var DebugFilter = ion.defineClass({
        name: 'DebugFilter',
        id: module.id,
        properties: {
            name: 'DebugFilter',
            key: null,
            open: function (key, options, handler) {
                if (!(key != null)) {
                    throw new Error('key is required');
                }
                if (!(this.key != null) || this.key === key.toString()) {
                    console.log('');
                    console.log('======================= ' + this.name + ' OPEN  ========================');
                    console.log('key:', key.toString());
                    console.log(JSON.stringify({
                        read: options.read,
                        write: options.write
                    }));
                    console.log(('======================= ' + this.name + ' OPEN  ========================').replace(/./g, '='));
                    console.log('');
                }
                var inner = this.inner.open(key, options, ion.bind(function (object) {
                        if (!(this.key != null) || this.key === key.toString()) {
                            console.log('');
                            console.log('======================= ' + this.name + ' REPLY ========================');
                            console.log('key:', key.toString());
                            console.log(JSON.stringify({
                                read: options.read,
                                write: options.write
                            }));
                            console.log('object:', object != null ? JSON.stringify(object, null, 2) : 'undefined');
                            console.log(('======================= ' + this.name + ' REPLY ========================').replace(/./g, '='));
                            console.log('');
                        }
                        return handler(object);
                    }, this));
                return ion.bind(function (object) {
                    if (!(this.key != null) || this.key === key.toString()) {
                        console.log('');
                        console.log('======================= ' + this.name + ' SEND ========================');
                        console.log('key:', key.toString());
                        console.log(JSON.stringify({
                            read: options.read,
                            write: options.write
                        }));
                        console.log('object:', object != null ? JSON.stringify(object, null, 2) : 'undefined');
                        console.log(('======================= ' + this.name + ' SEND ========================').replace(/./g, '='));
                        console.log('');
                    }
                    return inner(object);
                }, this);
            }
        }
    }, require('./Filter'));
module.exports = exports = DebugFilter;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/data/filters/DebugFilter',_glass_data_filters_DebugFilter_);
    else
      _glass_data_filters_DebugFilter_.call(this, module, exports, require);
  }
  else {
    _glass_data_filters_DebugFilter_.call(this);
  }
}).call(this)
void (function(){var _glass_data_filters_EmptyFilter_ = function(module,exports,require){'use strict';
var ion = require('ion');
var EmptyFilter = ion.defineClass({
        name: 'EmptyFilter',
        id: module.id,
        properties: { merge: false }
    }, require('./MergeFilter'));
module.exports = exports = EmptyFilter;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/data/filters/EmptyFilter',_glass_data_filters_EmptyFilter_);
    else
      _glass_data_filters_EmptyFilter_.call(this, module, exports, require);
  }
  else {
    _glass_data_filters_EmptyFilter_.call(this);
  }
}).call(this)
void (function(){var _glass_data_filters_Filter_ = function(module,exports,require){'use strict';
var ion = require('ion');
var Filter = ion.defineClass({
        name: 'Filter',
        id: module.id,
        properties: {
            inner: null,
            open: function (key, options, handler) {
                return this.inner.open(key, options, handler);
            },
            dispose: function () {
                this.inner != null ? this.inner.dispose != null ? this.inner.dispose() : void 0 : void 0;
            }
        }
    }, require('../Source'));
module.exports = exports = Filter;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/data/filters/Filter',_glass_data_filters_Filter_);
    else
      _glass_data_filters_Filter_.call(this, module, exports, require);
  }
  else {
    _glass_data_filters_Filter_.call(this);
  }
}).call(this)
void (function(){var _glass_data_filters_KeyParseFilter_ = function(module,exports,require){'use strict';
var ion = require('ion');
var Key = require('../Key');
var KeyParseFilter = ion.defineClass({
        name: 'KeyParseFilter',
        id: module.id,
        properties: {
            namespace: null,
            typeRequired: false,
            parseKey: function (keystring) {
                var key = new Key(this.model != null ? this.model : this.namespace, keystring);
                if (this.typeRequired && !(key.type != null)) {
                    throw new Error('400 missing typeName: \'' + keystring + '\'');
                }
                return key;
            },
            open: function (key, options, handler) {
                if (!(key != null)) {
                    throw new Error('key is required');
                }
                if (typeof options === 'function') {
                    handler = options;
                    options = {
                        read: true,
                        write: true
                    };
                }
                return this.inner.open(this.parseKey(key), options, handler);
            }
        }
    }, require('./Filter'));
module.exports = exports = KeyParseFilter;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/data/filters/KeyParseFilter',_glass_data_filters_KeyParseFilter_);
    else
      _glass_data_filters_KeyParseFilter_.call(this, module, exports, require);
  }
  else {
    _glass_data_filters_KeyParseFilter_.call(this);
  }
}).call(this)
void (function(){var _glass_data_filters_MergeFilter_ = function(module,exports,require){'use strict';
var ion = require('ion');
var MergeFilter = ion.defineClass({
        name: 'MergeFilter',
        id: module.id,
        properties: {
            merge: true,
            open: function (key, options, handler) {
                if (!options.write) {
                    return this.inner.open(key, options, handler);
                }
                if (!(key != null)) {
                    throw new Error('key is required');
                }
                var current = this.inner.peek(key);
                var inner = this.inner.open(key, options, ion.bind(function (object) {
                        var diff = ion.patch.diff(current, object);
                        current = ion.patch(current, object);
                        handler(object);
                    }, this));
                return ion.bind(function (object) {
                    if (object !== void 0) {
                        if (!ion.patch.isChange(current, object)) {
                            return;
                        }
                        object = JSON.parse(JSON.stringify(object));
                        current = ion.patch(current, object);
                        if (this.merge) {
                            object = current;
                        }
                    }
                    return inner(object);
                }, this);
            }
        }
    }, require('./Filter'));
module.exports = exports = MergeFilter;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/data/filters/MergeFilter',_glass_data_filters_MergeFilter_);
    else
      _glass_data_filters_MergeFilter_.call(this, module, exports, require);
  }
  else {
    _glass_data_filters_MergeFilter_.call(this);
  }
}).call(this)
void (function(){var _glass_data_filters_PropertiesFilter_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('../');
var Key = _ref.Key;
var getProperty = function (object, properties) {
    for (var _i = 0; _i < properties.length; _i++) {
        var name = properties[_i];
        if (!(object != null)) {
            return void 0;
        }
        object = object[name];
    }
    return object;
};
var setProperty = function (object, properties, value) {
    if (object != null) {
        for (var _i2 = 0; _i2 < properties.length; _i2++) {
            var index = _i2;
            var name = properties[_i2];
            object = object[name] = object[name] != null ? object[name] : index + 1 === properties.length ? value : {};
        }
    }
    return object;
};
var getPatch = function (properties, value) {
    var root = {};
    setProperty(root, properties, value);
    return root;
};
var PropertiesFilter = ion.defineClass({
        name: 'PropertiesFilter',
        id: module.id,
        properties: {
            name: 'PropertiesFilter',
            key: null,
            open: function (key, options, handler) {
                if (!(key.properties != null) || key.query != null) {
                    return this.inner.open(key, options, handler);
                }
                var baseKey = new Key(key.namespace, key.path);
                var baseObject = null;
                var inner = this.inner.open(baseKey, options, ion.bind(function (object) {
                        baseObject = object;
                        var fragment = getProperty(baseObject, key.properties);
                        if (!(fragment != null)) {
                            var patch = getPatch(key.properties, {});
                            this.inner.patch(baseKey, patch);
                            fragment = getProperty(baseObject, key.properties);
                        }
                        return handler(fragment);
                    }, this));
                return ion.bind(function (fragment) {
                    if (fragment === void 0) {
                        return inner(void 0);
                    }
                    var patch = getPatch(key.properties, fragment);
                    inner(patch);
                    return;
                }, this);
            }
        }
    }, require('./Filter'));
module.exports = exports = PropertiesFilter;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/data/filters/PropertiesFilter',_glass_data_filters_PropertiesFilter_);
    else
      _glass_data_filters_PropertiesFilter_.call(this, module, exports, require);
  }
  else {
    _glass_data_filters_PropertiesFilter_.call(this);
  }
}).call(this)
void (function(){var _glass_data_filters_UpdateCombineFilter_ = function(module,exports,require){'use strict';
var ion = require('ion'), _ref;
_ref = require('../');
var Key = _ref.Key;
var UpdateCombineFilter = ion.defineClass({
        name: 'UpdateCombineFilter',
        id: module.id,
        constructor: function UpdateCombineFilter() {
            UpdateCombineFilter.super.apply(this, arguments);
            this.connections = [];
            this.pendingUpdates = {};
            this.updateInProgress = false;
            this.processUpdates = ion.bind(function () {
                this.clearTimeout = null;
                if (this.updateInProgress) {
                    return;
                }
                var pendingUpdates = this.pendingUpdates;
                this.pendingUpdates = {};
                if (Object.keys(pendingUpdates).length === 0) {
                    return;
                }
                this.updateInProgress = true;
                var combinedPatch = {};
                for (var keyString in pendingUpdates) {
                    var update = pendingUpdates[keyString];
                    var _ref2 = update;
                    var key = _ref2.key;
                    var patch = _ref2.patch;
                    update.individualKeys = {};
                    var add = function (entityKey, entityPatch) {
                        update.individualKeys[entityKey] = true;
                        combinedPatch[entityKey] = ion.patch.combine(combinedPatch[entityKey], entityPatch);
                    };
                    if (key.id != null) {
                        add(key, patch);
                    } else if (patch != null) {
                        for (var path in patch) {
                            var entityPatch = patch[path];
                            add(new Key(key.namespace, path), entityPatch);
                        }
                    }
                }
                var batchConnection = this.inner.open('', {
                        read: false,
                        write: true,
                        async: true
                    }, ion.bind(function (object) {
                        batchConnection();
                        for (var entityKey in object) {
                            var entityPatch = object[entityKey];
                            for (var originalKeyString in pendingUpdates) {
                                var update = pendingUpdates[originalKeyString];
                                var originalKey = update.key;
                                if (update.individualKeys[entityKey]) {
                                    update.responsePatch = update.responsePatch != null ? update.responsePatch : {};
                                    if (originalKey.id != null) {
                                        update.responsePatch = ion.patch.combine(update.responsePatch, entityPatch);
                                    } else {
                                        update.responsePatch[entityKey] = ion.patch.combine(update.responsePatch != null ? update.responsePatch[entityKey] : void 0, entityPatch);
                                    }
                                }
                            }
                        }
                        for (var originalKeyString in pendingUpdates) {
                            var update = pendingUpdates[originalKeyString];
                            if (update.hasOwnProperty('responsePatch')) {
                                update.handlers.forEach(function (x) {
                                    return x(update.responsePatch);
                                });
                            }
                        }
                        {
                            var _ref3 = this.connections;
                            for (var _i = 0; _i < _ref3.length; _i++) {
                                var connection = _ref3[_i];
                                var patch = void 0;
                                for (var entityKey in object) {
                                    var entityPatch = object[entityKey];
                                    if (connection.entityKeys[entityKey] != null) {
                                        patch = patch != null ? patch : {};
                                        if (connection.key.id != null) {
                                            patch = ion.patch.combine(patch, entityPatch);
                                        } else {
                                            patch[entityKey] = ion.patch.combine(patch[entityKey], entityPatch);
                                        }
                                    }
                                }
                                if (patch != null) {
                                    connection.handler(patch);
                                }
                            }
                        }
                        this.updateInProgress = false;
                        this.queueUpdates();
                    }, this));
                batchConnection(combinedPatch);
            }, this);
        },
        properties: {
            queueUpdates: function () {
                if (this.clearTimeout != null) {
                    global.clearTimeout(this.clearTimeout);
                }
                this.clearTimeout = global.setTimeout(this.processUpdates, 1000);
            },
            open: function (key, options, handler) {
                if ((options != null ? options.async : void 0) === false) {
                    return function () {
                    };
                }
                var connection = {
                        key: key,
                        options: options,
                        handler: handler,
                        entityKeys: {}
                    };
                if (key.id) {
                    connection.entityKeys[key.id] = true;
                }
                this.connections.push(connection);
                var inner = this.inner.open(key, options, function (object) {
                        if (!key.id) {
                            if (object != null) {
                                for (var entityKey in object) {
                                    var value = object[entityKey];
                                    connection.entityKeys[entityKey] = value != null;
                                }
                            }
                        }
                        handler(object);
                    });
                return ion.bind(function (object) {
                    if (object !== void 0) {
                        var update = this.pendingUpdates[key] = this.pendingUpdates[key] != null ? this.pendingUpdates[key] : {
                                key: key,
                                handlers: new Set(),
                                patch: {}
                            };
                        update.handlers.add(handler);
                        update.current = ion.patch.combine(update.patch, object);
                        this.queueUpdates();
                    } else {
                        inner(object);
                        this.connections.remove(connection);
                    }
                }, this);
            }
        }
    }, require('./Filter'));
module.exports = exports = UpdateCombineFilter;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/data/filters/UpdateCombineFilter',_glass_data_filters_UpdateCombineFilter_);
    else
      _glass_data_filters_UpdateCombineFilter_.call(this, module, exports, require);
  }
  else {
    _glass_data_filters_UpdateCombineFilter_.call(this);
  }
}).call(this)
void (function(){var _glass_data_filters_ZeroLimitFilter_ = function(module,exports,require){'use strict';
var ion = require('ion');
var ZeroLimitFilter = ion.defineClass({
        name: 'ZeroLimitFilter',
        id: module.id,
        properties: {
            open: function (key, options, handler) {
                options = options != null ? options : {};
                var isZero = (key.query != null ? key.query.limit : void 0) === 0;
                if (isZero) {
                    options.read = false;
                    handler({});
                }
                var inner = this.inner.open(key, options, ion.bind(function (object) {
                        return handler(object);
                    }, this));
                return ion.bind(function (object) {
                    return inner(object);
                }, this);
            }
        }
    }, require('./Filter'));
module.exports = exports = ZeroLimitFilter;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/data/filters/ZeroLimitFilter',_glass_data_filters_ZeroLimitFilter_);
    else
      _glass_data_filters_ZeroLimitFilter_.call(this, module, exports, require);
  }
  else {
    _glass_data_filters_ZeroLimitFilter_.call(this);
  }
}).call(this)
void (function(){var _glass_data_filters_index_ = function(module,exports,require){Object.defineProperty(exports, 'AjaxSource', {get:function(){ return require('./AjaxSource') }, enumerable: true}) 
Object.defineProperty(exports, 'CacheFilter', {get:function(){ return require('./CacheFilter') }, enumerable: true}) 
Object.defineProperty(exports, 'ClientDatabase', {get:function(){ return require('./ClientDatabase') }, enumerable: true}) 
Object.defineProperty(exports, 'DebugFilter', {get:function(){ return require('./DebugFilter') }, enumerable: true}) 
Object.defineProperty(exports, 'EmptyFilter', {get:function(){ return require('./EmptyFilter') }, enumerable: true}) 
Object.defineProperty(exports, 'Filter', {get:function(){ return require('./Filter') }, enumerable: true}) 
Object.defineProperty(exports, 'KeyParseFilter', {get:function(){ return require('./KeyParseFilter') }, enumerable: true}) 
Object.defineProperty(exports, 'MergeFilter', {get:function(){ return require('./MergeFilter') }, enumerable: true}) 
Object.defineProperty(exports, 'PropertiesFilter', {get:function(){ return require('./PropertiesFilter') }, enumerable: true}) 
Object.defineProperty(exports, 'UpdateCombineFilter', {get:function(){ return require('./UpdateCombineFilter') }, enumerable: true}) 
Object.defineProperty(exports, 'ZeroLimitFilter', {get:function(){ return require('./ZeroLimitFilter') }, enumerable: true}) 
Object.freeze(exports)
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/data/filters/index',_glass_data_filters_index_);
    else
      _glass_data_filters_index_.call(this, module, exports, require);
  }
  else {
    _glass_data_filters_index_.call(this);
  }
}).call(this)
void (function(){var _glass_data_index_ = function(module,exports,require){'use strict';
{
    var _ref6 = [
            'Key',
            'query',
            'Schema',
            'Source',
            'filters',
            'Http',
            'SecurityContext'
        ];
    for (var _i = 0; _i < _ref6.length; _i++) {
        var name = _ref6[_i];
        (function (name) {
            Object.defineProperty(exports, name, {
                enumerable: true,
                get: function () {
                    return require('./' + name);
                }
            });
        }(name));
    }
}
var ion = require('ion'), _ref, _ref2, ClientDatabase = require('./filters/ClientDatabase').default;
_ref = require('./filters');
var KeyParseFilter = _ref.KeyParseFilter;
var EmptyFilter = _ref.EmptyFilter;
var PropertiesFilter = _ref.PropertiesFilter;
var CacheFilter = _ref.CacheFilter;
var AjaxSource = _ref.AjaxSource;
var DebugFilter = _ref.DebugFilter;
var UpdateCombineFilter = _ref.UpdateCombineFilter;
var ZeroLimitFilter = _ref.ZeroLimitFilter;
_ref2 = require('./');
var Key = _ref2.Key;
var getProperty = function (object, properties) {
    for (var _i2 = 0; _i2 < properties.length; _i2++) {
        var name = properties[_i2];
        if (!(object != null)) {
            return void 0;
        }
        object = object[name];
    }
    return object;
};
var setProperty = function (object, properties, value) {
    if (object != null) {
        for (var _i3 = 0; _i3 < properties.length; _i3++) {
            var index = _i3;
            var name = properties[_i3];
            object = object[name] = object[name] != null ? object[name] : index + 1 === properties.length ? value : {};
        }
    }
    return object;
};
var createClientDataSource = exports.createClientDataSource = function (_ref3) {
        var namespace = _ref3.namespace;
        var url = _ref3.url;
        var token = _ref3.token;
        var error = _ref3.error;
        if (!(url != null)) {
            throw new Error('url is required');
        }
        if (!(namespace != null)) {
            throw new Error('namespace is required');
        }
        var ajaxSource = ion.patch.combine(new AjaxSource(), {
                url: url,
                token: token,
                error: error
            });
        return ion.patch.combine(new KeyParseFilter(), {
            namespace: namespace,
            ajaxSource: ajaxSource,
            inner: new ClientDatabase({
                token: token,
                inner: ajaxSource,
                namespace: namespace
            })
        });
    }, createNewReactiveDataObject = exports.createNewReactiveDataObject = function (source) {
        var _ref4 = exports;
        var Key = _ref4.Key;
        var _ref5 = source;
        var namespace = _ref5.namespace;
        var model = _ref5.model;
        if ((source != null ? source.constructor : void 0) === Object) {
            source = createClientDataSource(source);
        }
        var factory = function (object) {
            var type = ion.deserialize.extractType(object, namespace) != null ? ion.deserialize.extractType(object, namespace) : Object;
            return new type();
        };
        var observed = {};
        var reactiveDataObject = Object.defineProperties({
                isObserved: function (property) {
                    return observed[property] != null;
                },
                onObserved: function (observer, property) {
                    if (property != null) {
                        var index = property.indexOf('#');
                        if (index >= 0) {
                            var key = new Key(namespace, property);
                            var watchProperty = property.toString().substring(0, index);
                            var retainedValue = {};
                            var callback = ion.bind(function () {
                                    var object = this[watchProperty];
                                    if (object !== void 0) {
                                        var filteredAndSorted = getProperty(object, key.properties);
                                        if (key.query != null) {
                                            filteredAndSorted = key.filterAndSort(filteredAndSorted);
                                        }
                                        filteredAndSorted = ion.deserialize(ion.serialize(filteredAndSorted), namespace);
                                        var diff = ion.patch.diff(retainedValue, filteredAndSorted);
                                        if (diff !== void 0) {
                                            ion.patch(retainedValue, diff);
                                        }
                                        this[property] = retainedValue;
                                    }
                                }, this);
                            if (this[watchProperty] !== void 0) {
                                callback();
                            }
                            observed[property] = ion.observe(this, callback, { property: watchProperty });
                        } else {
                            var waiters = [];
                            var meta = observed[property] = observed[property] != null ? observed[property] : {
                                    count: 0,
                                    connection: source.open(property, ion.bind(function (object) {
                                        var value = reactiveDataObject[property] = ion.patch.merge(reactiveDataObject[property], object, { factory: factory });
                                        if ((value != null ? value.constructor != null ? value.constructor.name : void 0 : void 0) === 'Task' && property.endsWith('/Task')) {
                                            debugger;
                                        }
                                        for (var _i4 = 0; _i4 < waiters.length; _i4++) {
                                            var waiter = waiters[_i4];
                                            waiter(value);
                                        }
                                        waiters.length = 0;
                                    }, this)),
                                    waiters: waiters
                                };
                            meta.count++;
                        }
                    }
                },
                unObserved: function (observer, property) {
                    if (property != null) {
                        if (property.indexOf('#') > 0) {
                            observed[property]();
                            delete observed[property];
                        } else {
                            var meta = observed[property];
                            meta.count--;
                        }
                    }
                }
            }, {
                source: {
                    value: source,
                    enumerable: false
                },
                getNewKeyAndObject: {
                    enumerable: false,
                    value: function (queryKey, properties, callback) {
                        if (!(queryKey != null)) {
                            throw new Error('queryKey is required');
                        }
                        reactiveDataObject.getNewKey(queryKey, function (newKey) {
                            var newObject = new newKey.type(properties);
                            var valuesImpliedByKeyQuery = require('./query').getEqualsOps(queryKey.query != null ? queryKey.query.where : void 0);
                            for (var name in valuesImpliedByKeyQuery) {
                                var value = valuesImpliedByKeyQuery[name];
                                var descriptor = Object.getOwnPropertyDescriptor(newKey.type.prototype, name);
                                if (!(descriptor != null) || (descriptor.set != null || descriptor.writable === true)) {
                                    newObject[name] = value;
                                }
                            }
                            if (newKey.type.properties != null) {
                                {
                                    var _ref7 = newKey.type.properties;
                                    for (var name in _ref7) {
                                        var property = _ref7[name];
                                        if ((property.stamp != null ? property.stamp.type : void 0) === 'key') {
                                            newObject[name] = newKey.toString();
                                        }
                                    }
                                }
                            }
                            callback(newKey, newObject);
                        });
                    }
                },
                waitForLoad: {
                    enumerable: false,
                    value: function (key, callback) {
                        if (key instanceof Set) {
                            var source = this;
                            var keySet = key;
                            var resultMap = new Map();
                            var count = keySet.size;
                            if (count === 0) {
                                callback(resultMap);
                            } else {
                                keySet.forEach(function (key) {
                                    if (!source.isObserved(key)) {
                                        source.onObserved(function () {
                                        }, key.toString());
                                    }
                                    source.waitForLoad(key, function (object) {
                                        resultMap.set(key.toString(), object);
                                        if (resultMap.size === keySet.size) {
                                            callback(resultMap);
                                        }
                                    });
                                });
                            }
                        } else {
                            if (!observed[key]) {
                                throw new Error('Key is not observed so it will never load: ' + key);
                            }
                            if (reactiveDataObject[key] !== void 0) {
                                callback(reactiveDataObject[key]);
                                return;
                            } else {
                                observed[key].waiters.push(callback);
                            }
                        }
                    }
                },
                getNewKey: {
                    enumerable: false,
                    value: function (queryKey, callback) {
                        return reactiveDataObject.getNewKeys(queryKey, 1, function (ids) {
                            return callback(ids[0]);
                        });
                    }
                },
                getNewKeys: {
                    enumerable: false,
                    value: function (queryKey, number, callback) {
                        var type = queryKey.type;
                        if (!(type != null)) {
                            throw new Error('queryKey must have a type');
                        }
                        if (!(model != null)) {
                            throw new Error('model must be specified in createNewReactiveDataObject constructor to use getNewKeys');
                        }
                        var idsToKeys = function (ids) {
                            return ids.map(function (id) {
                                return new Key(queryKey, id);
                            });
                        };
                        var ids = [];
                        for (var i = 0; i < number; i++) {
                            ids.push(model.guid());
                        }
                        callback(idsToKeys(ids));
                    }
                }
            });
        ion.patch.watch(reactiveDataObject, function (patch) {
            for (var key in patch) {
                var object = patch[key];
                var meta = observed[key];
                if (meta != null) {
                    meta.connection != null ? meta.connection(object) : void 0;
                }
            }
        });
        if (source != null && source.ajaxSource != null) {
            source.ajaxSource.reactiveDataObject = reactiveDataObject;
        }
        return reactiveDataObject;
    }, test = exports.test = function (done) {
        if (!(ClientDatabase.name === 'ClientDatabase'))
            throw new Error('Assertion Failed: ((ClientDatabase.name is \'ClientDatabase\'))');
        if (!(global.window != null)) {
            return done();
        }
        var object = createSessionStorageObject();
        object.alpha = {
            x: 1,
            y: 2
        };
        setTimeout(function () {
            var newObject = createSessionStorageObject();
            if (!(JSON.stringify(object.alpha) === JSON.stringify(newObject.alpha)))
                throw new Error('Assertion Failed: (JSON.stringify(object.alpha) is JSON.stringify(newObject.alpha))');
            delete object.alpha;
            setTimeout(function () {
                if (!!sessionStorage.hasOwnProperty('alpha'))
                    throw new Error('Assertion Failed: (not sessionStorage.hasOwnProperty(\'alpha\'))');
                done();
            }, 100);
        }, 100);
    };
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/data/index',_glass_data_index_);
    else
      _glass_data_index_.call(this, module, exports, require);
  }
  else {
    _glass_data_index_.call(this);
  }
}).call(this)
void (function(){var _glass_data_query_ = function(module,exports,require){'use strict';
var ops = {
        '=': {
            test: function (a, b) {
                if (!(a != null) && !(b != null)) {
                    return true;
                }
                return a === b;
            },
            getValue: function (value) {
                return value;
            }
        },
        '>': {
            test: function (a, b) {
                return a > b;
            },
            getValue: function (value) {
                return 1 + value;
            }
        },
        '<': {
            test: function (a, b) {
                return a < b;
            },
            getValue: function (value) {
                return 1 - value;
            }
        },
        '>=': {
            test: function (a, b) {
                return a >= b;
            },
            getValue: function (value) {
                return value;
            }
        },
        '<=': {
            test: function (a, b) {
                return a <= b;
            },
            getValue: function (value) {
                return value;
            }
        },
        'contains': {
            test: function (a, b) {
                return a.indexOf(b) >= 0;
            }
        },
        '!=': {
            test: function (a, b) {
                return a !== b;
            }
        }
    }, testOp = function (op, value, testValue) {
        if (Array.isArray(testValue)) {
            for (var _i = 0; _i < testValue.length; _i++) {
                var testItem = testValue[_i];
                if (testOp(op, value, testItem)) {
                    return true;
                }
            }
            return false;
        }
        var operation = ops[op];
        if (!(operation != null)) {
            throw new Error('Unsupported operation: ' + op);
        }
        var result = operation.test(testValue, value);
        return result;
    };
var getEqualsOps = exports.getEqualsOps = function (query) {
        var result = {};
        if (query != null) {
            for (var name in query) {
                var value = query[name];
                if ((value != null ? value.constructor : void 0) === Object) {
                    for (var op in value) {
                        var opValue = value[op];
                        if (op === '=') {
                            result[name] = opValue;
                        }
                    }
                } else {
                    result[name] = value;
                }
            }
        }
        return result;
    }, filter = exports.filter = function (query, object) {
        var result = {};
        for (var name in object) {
            var value = object[name];
            if (matches(query, value)) {
                result[name] = value;
            }
        }
        return result;
    }, matches = exports.matches = function (query, object) {
        if (!(object != null)) {
            return false;
        }
        if (query != null) {
            if (Array.isArray(query)) {
                for (var _i2 = 0; _i2 < query.length; _i2++) {
                    var q = query[_i2];
                    if (!matches(q, object)) {
                        return false;
                    }
                }
                return true;
            } else {
                for (var name in query) {
                    var value = query[name];
                    if (Array.isArray(value)) {
                        var objectValue = object[name];
                        var matchedOne = false;
                        for (var _i3 = 0; _i3 < value.length; _i3++) {
                            var item = value[_i3];
                            if (testOp('=', item, objectValue)) {
                                matchedOne = true;
                                break;
                            }
                        }
                        if (!matchedOne) {
                            return false;
                        }
                    } else if ((value != null ? value.constructor : void 0) === Object) {
                        for (var op in value) {
                            var opValue = value[op];
                            if (!testOp(op, opValue, object[name])) {
                                return false;
                            }
                        }
                    } else {
                        if (!testOp('=', value, object[name])) {
                            return false;
                        }
                    }
                }
            }
        }
        return true;
    }, test = exports.test = function () {
        if (!(JSON.stringify(getEqualsOps({
                a: 1,
                b: { '=': 10 },
                c: { '>=': 20 }
            })) === JSON.stringify({
                a: 1,
                b: 10
            })))
            throw new Error('Assertion Failed: (JSON.stringify(getEqualsOps({a:1,b:{"=":10},c:{">=":20}})) is JSON.stringify({a:1,b:10}))');
        if (!matches({
                one: [
                    'c',
                    'a'
                ],
                two: 'b'
            }, {
                one: 'a',
                two: 'b'
            }))
            throw new Error('Assertion Failed: (matches({one:["c","a"],two:"b"}, {one:"a",two:"b"}))');
        if (!!matches({
                one: [
                    'c',
                    'a'
                ],
                two: 'b'
            }, {
                one: 'b',
                two: 'b'
            }))
            throw new Error('Assertion Failed: (not matches({one:["c","a"],two:"b"}, {one:"b",two:"b"}))');
        if (!matches(null, { blah: 2 }))
            throw new Error('Assertion Failed: (matches(null, {blah:2}))');
        if (!matches({ a: null }, { a: void 0 }))
            throw new Error('Assertion Failed: (matches({a:null},{a:undefined}))');
        if (!matches({}, {}))
            throw new Error('Assertion Failed: (matches({}, {}))');
        if (!!matches({ a: 1 }, {}))
            throw new Error('Assertion Failed: (not matches({a:1}, {}))');
        if (!matches({ a: 1 }, {
                a: 1,
                b: 2
            }))
            throw new Error('Assertion Failed: (matches({a:1}, {a:1,b:2}))');
        if (!matches({ a: 1 }, {
                a: 1,
                b: 2
            }))
            throw new Error('Assertion Failed: (matches({a:1}, {a:1,b:2}))');
        if (!matches({ a: { '!=': 1 } }, {
                a: 2,
                b: 2
            }))
            throw new Error('Assertion Failed: (matches({a:{"!=":1}}, {a:2,b:2}))');
        if (!!matches({ a: { '!=': 1 } }, { a: 1 }))
            throw new Error('Assertion Failed: (not matches({a:{"!=":1}}, {a:1}))');
        if (!matches({ a: { '>=': 1 } }, {
                a: 1,
                b: 2
            }))
            throw new Error('Assertion Failed: (matches({a:{">=":1}}, {a:1,b:2}))');
        if (!!matches({ a: { '>=': 1 } }, { a: 0 }))
            throw new Error('Assertion Failed: (not matches({a:{">=":1}}, {a:0}))');
        if (!matches({ a: { '<=': 1 } }, {
                a: 1,
                b: 2
            }))
            throw new Error('Assertion Failed: (matches({a:{"<=":1}}, {a:1,b:2}))');
        if (!!matches({ a: { '<=': 1 } }, { a: 2 }))
            throw new Error('Assertion Failed: (not matches({a:{"<=":1}}, {a:2}))');
        if (!matches({ a: { '<': 1 } }, {
                a: 0,
                b: 2
            }))
            throw new Error('Assertion Failed: (matches({a:{"<":1}}, {a:0,b:2}))');
        if (!!matches({ a: { '<': 1 } }, {
                a: 1,
                b: 2
            }))
            throw new Error('Assertion Failed: (not matches({a:{"<":1}}, {a:1,b:2}))');
        if (!matches({ a: { '>': 1 } }, {
                a: 2,
                b: 2
            }))
            throw new Error('Assertion Failed: (matches({a:{">":1}}, {a:2,b:2}))');
        if (!!matches({ a: { '>': 1 } }, {
                a: 1,
                b: 2
            }))
            throw new Error('Assertion Failed: (not matches({a:{">":1}}, {a:1,b:2}))');
        if (!matches({ a: { 'contains': 'foo' } }, { a: 'foo' }))
            throw new Error('Assertion Failed: (matches({a:{"contains":"foo"}}, {a:"foo"}))');
        if (!matches({ a: { 'contains': 'foo' } }, { a: 'afoo' }))
            throw new Error('Assertion Failed: (matches({a:{"contains":"foo"}}, {a:"afoo"}))');
        if (!matches({ a: { 'contains': 'foo' } }, { a: 'foos' }))
            throw new Error('Assertion Failed: (matches({a:{"contains":"foo"}}, {a:"foos"}))');
        if (!!matches({ a: { 'contains': 'foo' } }, { a: 'fo' }))
            throw new Error('Assertion Failed: (not matches({a:{"contains":"foo"}}, {a:"fo"}))');
    };
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/data/query',_glass_data_query_);
    else
      _glass_data_query_.call(this, module, exports, require);
  }
  else {
    _glass_data_query_.call(this);
  }
}).call(this)
void (function(){var _glass_english_ = function(module,exports,require){'use strict';
module.exports = exports = require('./language');
var pluralize = exports.pluralize = function (word) {
        if (word.endsWith('ch') || word.endsWith('x') || word.endsWith('s') || word.endsWith('sh')) {
            return word + 'es';
        }
        if (word.endsWith('o')) {
            return word + 'es';
        }
        if (word.endsWith('z')) {
            return word + 'zes';
        }
        if (word.endsWith('y')) {
            return word.substring(0, word.length - 1) + 'ies';
        }
        if (word.endsWith('is')) {
            return word.substring(0, word.length - 2) + 'es';
        }
        if (word.endsWith('f')) {
            return word.substring(0, word.length - 1) + 'ves';
        }
        if (word.endsWith('fe')) {
            return word.substring(0, word.length - 2) + 'ves';
        }
        return word + 's';
    };
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/english',_glass_english_);
    else
      _glass_english_.call(this, module, exports, require);
  }
  else {
    _glass_english_.call(this);
  }
}).call(this)
void (function(){var _glass_googlecloud_Authentication_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('../data'), _ref2, userType = 'User';
var Key = _ref.Key;
_ref2 = require('../');
var crypt = _ref2.crypt;
var isManualRequest = exports.isManualRequest = function (request) {
        return !(request.headers.referer != null);
    }, fail = exports.fail = function (options, message, status) {
        if (message == null)
            message = 'Authentication required';
        if (status == null)
            status = 401;
        var type = options.type != null ? options.type : isManualRequest(options.request) ? 'Basic' : 'Bearer';
        options.response.setHeader('WWW-Authenticate', type + ' realm="data api"');
        return ion.patch.combine(new Error('' + status + ' ' + message), { code: status });
    }, getUserKeyAndFinishFunction = exports.getUserKeyAndFinishFunction = function (options) {
        var _ref3 = options;
        var namespace = _ref3.namespace;
        var request = _ref3.request;
        var response = _ref3.response;
        var required = _ref3.required;
        var auth = _ref3.auth;
        var headers = request.headers;
        auth = auth != null ? auth : headers.authorization;
        if (!(auth != null)) {
            if (required) {
                throw fail(options);
            } else {
                return [
                    null,
                    null
                ];
            }
        }
        var _ref4 = auth.split(' ');
        var type = _ref4[0];
        var token = _ref4[1];
        if (options.type != null && options.type !== type) {
            fail(options, 'Authentication ' + options.type + ' is required, ' + type + ' was provided.');
        }
        var user;
        if (type === 'Basic') {
            console.log('Basic');
            var _ref5 = crypt.base64Decode(token).split(':');
            var userKeyString = _ref5[0];
            var password = _ref5[1];
            userKeyString = userKeyString.trim();
            if (userKeyString.indexOf('/') < 0) {
                userKeyString = userType + '/' + userKeyString;
            }
            password = password.trim();
            if (userKeyString === '' || password === '') {
                throw fail(options);
            }
            var passwordHash = crypt.hash(password);
            var userKey = new Key(namespace, userKeyString);
            return [
                userKey,
                function (user) {
                    if (!(user != null)) {
                        throw fail(options, 'User not found');
                    }
                    if (user.passwordHash !== passwordHash) {
                        throw fail(options, 'Invalid Password');
                    }
                }
            ];
        } else if (type === 'Bearer') {
            var body = crypt.jwtRead(token);
            console.log('Bearer ' + JSON.stringify(body));
            if (!(body.userKey != null)) {
                return fail(options, 'Missing userKey');
            }
            var userKey = new Key(namespace, body.userKey);
            return [
                userKey,
                function (user) {
                    if (!(user != null)) {
                        throw fail(options, 'User not found', 404);
                    }
                    if (user.passwordHash != null) {
                        var result = crypt.jwtVerify(token, user.passwordHash);
                        if (result === void 0) {
                            throw fail(options, 'Invalid Password');
                        } else if (result === null) {
                            throw fail(options, 'Token is expired', 419);
                        }
                    } else {
                        throw fail(options, 'User passwordHash not found', 500);
                    }
                }
            ];
        } else {
            throw fail(options, 'Unknown Authentication Type: ' + type);
        }
    };
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/googlecloud/Authentication',_glass_googlecloud_Authentication_);
    else
      _glass_googlecloud_Authentication_.call(this, module, exports, require);
  }
  else {
    _glass_googlecloud_Authentication_.call(this);
  }
}).call(this)
void (function(){var _glass_googlecloud_ConvertToRootRequest_ = function(module,exports,require){'use strict';
module.exports = exports = function (req, res, next) {
    if (req.method === 'POST' || req.method === 'PUT' || req.method === 'DELETE') {
        var key = req.url.substring(1);
        if (key.length > 0) {
            var _ref = {};
            _ref[key] = req.method === 'DELETE' ? null : req.body;
            req.body = _ref;
            req.url = '/';
        }
    }
    next();
};
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/googlecloud/ConvertToRootRequest',_glass_googlecloud_ConvertToRootRequest_);
    else
      _glass_googlecloud_ConvertToRootRequest_.call(this, module, exports, require);
  }
  else {
    _glass_googlecloud_ConvertToRootRequest_.call(this);
  }
}).call(this)
void (function(){var _glass_googlecloud_Dataset_ = function(module,exports,require){'use strict';
var Datastore = require('@google-cloud/datastore'), ion = require('ion'), _ref, entityStoreJSONKey = '_', entityDeletedKey = '_deleted', isInteger = function (object) {
        return typeof object === 'number' && Math.floor(object) === object;
    }, convertGlassKeyToDatastoreKey = function (dataset, key) {
        var value = dataset.key({ path: (key.path != null ? key.path : key).toString().split('/') });
        return value;
    }, convertDatastoreKeyToGlassKeyString = function (dsKey) {
        return dsKey.path.join('/');
    }, convertDatastoreKeyToGlassKey = function (dsKey, namespace) {
        return new Key(namespace, convertDatastoreKeyToGlassKeyString(dsKey));
    }, convertEntityToObject = function (entity, namespace, dataset) {
        if (entity != null) {
            var value = ion.deserialize(entity[entityStoreJSONKey], namespace);
            if ((value != null ? value.constructor : void 0) === Object) {
                var key = convertDatastoreKeyToGlassKey(entity[dataset.KEY], namespace);
                for (var k in value) {
                    var v = value[k];
                    if (!(v != null)) {
                        delete value[k];
                    }
                }
                value = new key.type(value);
            }
            return value;
        } else {
            return null;
        }
    }, convertEntitiesToObjects = function (dataset, entities, namespace) {
        if (Array.isArray(entities)) {
            var objects = {};
            for (var _i = 0; _i < entities.length; _i++) {
                var entity = entities[_i];
                var key = convertDatastoreKeyToGlassKeyString(entity[dataset.KEY]);
                var object = convertEntityToObject(entity, namespace, dataset);
                objects[key] = object;
            }
            return objects;
        } else if (entities != null) {
            return convertEntityToObject(entities, namespace, dataset);
        } else {
            return {};
        }
    }, getKeysOfObjectsToDelete = function (_ref2, objects) {
        var dataset = _ref2.dataset;
        var namespace = _ref2.namespace;
        var keys = [];
        for (var path in objects) {
            var object = objects[path];
            if (!(object != null)) {
                var glassKey = new Key(namespace, path);
                keys.push(glassKey);
            }
        }
        return keys;
    }, convertObjectsToEntities = function (_ref3, objects) {
        var dataset = _ref3.dataset;
        var namespace = _ref3.namespace;
        var entities = [];
        for (var path in objects) {
            var object = objects[path];
            if (object != null) {
                var glassKey = new Key(namespace, path);
                var dsKey = convertGlassKeyToDatastoreKey(dataset, glassKey);
                entities.push(convertObjectToEntity({
                    dataset: dataset,
                    glassKey: glassKey,
                    dsKey: dsKey,
                    object: object
                }));
            }
        }
        return entities;
    }, convertObjectToEntity = function (_ref4) {
        var dataset = _ref4.dataset;
        var glassKey = _ref4.glassKey;
        var dsKey = _ref4.dsKey;
        var object = _ref4.object;
        var deleted = _ref4.deleted;
        var indexes = _ref4.indexes;
        var data;
        if (deleted === true) {
            data = [{
                    name: entityStoreJSONKey,
                    value: 'null',
                    excludeFromIndexes: true
                }];
        } else {
            data = [{
                    name: entityStoreJSONKey,
                    value: ion.serialize(object),
                    excludeFromIndexes: true
                }];
        }
        var type = glassKey.type;
        if (deleted && indexes != null) {
            data.push({
                name: entityDeletedKey,
                value: true
            });
        }
        {
            var _ref19 = type.properties;
            for (var name in _ref19) {
                var property = _ref19[name];
                if (property.index) {
                    if (deleted && indexes != null && indexes.indexOf(name) < 0) {
                        continue;
                    }
                    var indexValue = typeof property.index === 'function' ? property.index.call(object) : object[name];
                    data.push({
                        name: name,
                        value: toDatastoreValue({
                            value: indexValue,
                            property: property,
                            dataset: dataset
                        })
                    });
                }
            }
        }
        return {
            key: dsKey,
            data: data
        };
    }, toDatastoreValue = function (_ref5) {
        var value = _ref5.value;
        var property = _ref5.property;
        var dataset = _ref5.dataset;
        if (Array.isArray(value)) {
            if (property.items != null) {
                for (var _i2 = 0; _i2 < value.length; _i2++) {
                    var index = _i2;
                    var item = value[_i2];
                    value[index] = toDatastoreValue({
                        value: item,
                        property: property.items,
                        dataset: dataset
                    });
                }
            }
        }
        return value != null ? value : null;
    }, datastoreQueryOperators = {
        '=': '=',
        '<': '<',
        '>': '>',
        '>=': '>=',
        '<=': '<='
    }, createQueryFromGlassKey = function (dataset, key) {
        var type = key.type;
        if (!(type != null)) {
            throw ion.patch.combine(new Error('Type is required: ' + key), { code: 400 });
        }
        var dsQuery = dataset.createQuery(key.type.name);
        var parent = key.parent;
        if (parent) {
            dsQuery.hasAncestor(convertGlassKeyToDatastoreKey(dataset, parent.path));
        }
        if (key.query) {
            var limit = key.query.limit;
            if (limit != null) {
                if (isInteger(limit) && limit > 0) {
                    dsQuery.limit(limit);
                } else {
                    throw ion.patch.combine(new Error('Invalid limit'), { code: 400 });
                }
            }
            var offset = key.query.offset;
            if (offset != null) {
                if (isInteger(offset) && offset >= 0) {
                    dsQuery.offset(offset);
                } else {
                    throw ion.patch.combine(new Error('Invalid offset'), { code: 400 });
                }
            }
            if (key.query.sort != null) {
                {
                    var _ref20 = key.query.sort;
                    for (var _i3 = 0; _i3 < _ref20.length; _i3++) {
                        var sort = _ref20[_i3];
                        for (var name in sort) {
                            var ascending = sort[name];
                            dsQuery.order(name, { descending: !ascending });
                        }
                    }
                }
            }
            var addWhereFilters = function (where) {
                for (var propertyName in where) {
                    var rawValue = where[propertyName];
                    var property = key.type.properties[propertyName];
                    if (!(property != null)) {
                        throw ion.patch.combine(new Error('Property \'' + propertyName + '\' does not exist'), { code: 403 });
                    }
                    if (Array.isArray(rawValue)) {
                        if (rawValue.length === 0) {
                            throw ion.patch.combine(new Error('Query array value length cannot be zero'), { code: 403 });
                        } else {
                            throw ion.patch.combine(new Error('Array IN operators not supported yet.'), { code: 400 });
                        }
                    } else if (rawValue != null && typeof rawValue === 'object') {
                        for (var op in rawValue) {
                            var value = rawValue[op];
                            var dsOp = datastoreQueryOperators[op];
                            if (!(dsOp != null)) {
                                throw ion.patch.combine(new Error('Where clause used unsupported operator: ' + op), { code: 400 });
                            }
                            dsQuery.filter(propertyName, dsOp, toDatastoreValue({
                                value: value,
                                property: property,
                                dataset: dataset
                            }));
                        }
                    } else {
                        dsQuery.filter(propertyName, '=', toDatastoreValue({
                            value: rawValue,
                            property: property,
                            dataset: dataset
                        }));
                    }
                }
            };
            if (key.query.where != null) {
                if (Array.isArray(key.query.where)) {
                    {
                        var _ref21 = key.query.where;
                        for (var _i4 = 0; _i4 < _ref21.length; _i4++) {
                            var where = _ref21[_i4];
                            addWhereFilters(where);
                        }
                    }
                } else {
                    addWhereFilters(key.query.where);
                }
            }
        }
        return dsQuery;
    }, getForeignCacheChange = function (key, object, property, foreignIdOrKey, newValues) {
        if (!(foreignIdOrKey != null)) {
            return {};
        }
        var foreign = property.foreign;
        if (object != null && foreign.cache.predicate != null && foreign.cache.predicate(object) === false) {
            object = null;
        }
        var foreignKey = foreignIdOrKey.path != null ? foreignIdOrKey : new Key(key.namespace, foreign.type, foreignIdOrKey);
        if (newValues[foreignKey] === null) {
            return null;
        }
        var cacheValues;
        if (object != null) {
            cacheValues = {};
            {
                var _ref22 = foreign.cache.properties;
                for (var _i5 = 0; _i5 < _ref22.length; _i5++) {
                    var cacheProperty = _ref22[_i5];
                    cacheValues[cacheProperty] = object[cacheProperty];
                }
            }
        } else {
            cacheValues = null;
        }
        var result = {};
        var _ref25 = {};
        var _ref26 = {};
        _ref26[key.id] = cacheValues;
        _ref25[foreign.cache.property] = ion.patch.combine(_ref25[foreign.cache.property], _ref26);
        result[foreignKey] = ion.patch.combine(result[foreignKey], _ref25);
        return result;
    }, getForeignCacheChanges = function (key, oldValue, newValue, property, newValues) {
        var oldForeignIdOrKey = oldValue != null ? oldValue[property.name] : void 0;
        var newForeignIdOrKey = newValue != null ? newValue[property.name] : void 0;
        var foreignKeyChanged = (oldForeignIdOrKey != null ? oldForeignIdOrKey.toString() : void 0) !== (newForeignIdOrKey != null ? newForeignIdOrKey.toString() : void 0);
        var oldChange = getForeignCacheChange(key, foreignKeyChanged ? null : oldValue, property, oldForeignIdOrKey, newValues);
        var newChange = getForeignCacheChange(key, newValue, property, newForeignIdOrKey, newValues);
        if (newChange === null || JSON.stringify(oldChange) === JSON.stringify(newChange)) {
            return null;
        } else {
            return ion.patch.combine(oldChange, newChange);
        }
    }, combine = function (object, patch, schema) {
        return ion.patch.combine(object, patch, schema);
    }, getTriggerChanges = function (_ref6) {
        var key = _ref6.key;
        var oldEntity = _ref6.oldEntity;
        var newEntity = _ref6.newEntity;
        var changes = _ref6.changes;
        var related = _ref6.related;
        var newValues = _ref6.newValues;
        var oldValues = _ref6.oldValues;
        var parentKey = key.parent != null ? key.parent : (newEntity != null ? newEntity : oldEntity) != null ? (newEntity != null ? newEntity : oldEntity).parentKey : void 0;
        var parentProperties = parentKey != null ? parentKey.type != null ? parentKey.type.properties : void 0 : void 0;
        key.type.trigger != null ? key.type.trigger({
            key: key,
            oldEntity: oldEntity,
            newEntity: newEntity,
            oldValues: oldValues,
            newValues: newValues,
            changes: changes,
            related: related
        }) : void 0;
        if (!(oldEntity != null) && newEntity != null) {
            if (parentKey != null) {
                var createdCountName = 'createdCount' + key.type.name;
                if (parentProperties[createdCountName]) {
                    var _ref27 = {};
                    var _ref28 = {};
                    _ref28[createdCountName] = '+1';
                    _ref27[parentKey] = ion.patch.combine(_ref27[parentKey], _ref28);
                    combine(changes, _ref27, { items: parentKey.type });
                }
            }
        } else if (oldEntity && !(newEntity != null)) {
            if (parentKey != null) {
                var deletedCountName = 'deletedCount' + key.type.name;
                if (parentProperties[deletedCountName]) {
                    var _ref29 = {};
                    var _ref30 = {};
                    _ref30[deletedCountName] = '+1';
                    _ref29[parentKey] = ion.patch.combine(_ref29[parentKey], _ref30);
                    combine(changes, _ref29, { items: parentKey.type });
                }
            }
        }
    }, getAllDependentChangesRecursive = function (args, callback) {
        var _ref7 = args;
        var dataset = _ref7.dataset;
        var namespace = _ref7.namespace;
        var oldValues = _ref7.oldValues;
        var newValues = _ref7.newValues;
        var changes = _ref7.changes;
        var config = _ref7.config;
        var related = _ref7.related;
        var resolvedKeys = args.resolvedKeys = args.resolvedKeys != null ? args.resolvedKeys : {};
        args.depth = args.depth != null ? args.depth : 0;
        args.depth += 1;
        if (config.trigger != null) {
            var triggerPatch = config.trigger({
                    oldValues: oldValues,
                    newValues: newValues,
                    changes: changes
                });
            if (triggerPatch != null && Object.keys(triggerPatch).length > 0) {
                ion.patch.combine(changes, triggerPatch);
            }
        }
        for (var key in changes) {
            if (!resolvedKeys[key]) {
                resolvedKeys[key] = true;
                var oldValue = oldValues[key];
                var newValue = newValues[key];
                var entityKey = new Key(namespace, key);
                var properties = entityKey.type.properties;
                getTriggerChanges({
                    key: entityKey,
                    oldEntity: oldValue,
                    newEntity: newValue,
                    oldValues: oldValues,
                    newValues: newValues,
                    changes: changes,
                    related: related
                });
                for (var name in properties) {
                    var property = properties[name];
                    var foreign = property.foreign;
                    if ((foreign != null ? foreign.cache : void 0) != null) {
                        var foreignChanges = getForeignCacheChanges(entityKey, oldValue, newValue, property, newValues);
                        if (foreignChanges != null) {
                            ion.patch.combine(changes, foreignChanges);
                        }
                    }
                }
            }
        }
        var newKeys = function () {
                var newChanges = {};
                for (var path in changes) {
                    var newValue = changes[path];
                    if (!newValues.hasOwnProperty(path)) {
                        var key = new Key(namespace, path);
                        if (key.type.merge === false && (newValue != null ? newValue.constructor : void 0) === key.type) {
                            newValues[path] = newValue;
                        } else {
                            newChanges[key] = true;
                        }
                    }
                }
                return Object.keys(newChanges);
            }();
        if (newKeys.length > 0) {
            get({
                dataset: dataset,
                namespace: namespace
            }, newKeys, function (err, oldEntities) {
                if (err) {
                    console.error('Error getting records:', err, { newKeys: newKeys });
                    return;
                }
                var newEntities = copyWithChanges(namespace, oldEntities, changes);
                for (var path in oldEntities) {
                    var oldEntity = oldEntities[path];
                    oldValues[path] = oldEntity;
                }
                for (var path in newEntities) {
                    var newEntity = newEntities[path];
                    newValues[path] = newEntity;
                }
                getAllDependentChangesRecursive(args, callback);
            });
        } else {
            callback(null, changes);
        }
    }, copy = function (namespace, entities) {
        return ion.deserialize(ion.serialize(entities), namespace);
    }, copyWithChanges = function (namespace, oldEntities, changes) {
        var newEntities = copy(namespace, oldEntities);
        return patch(namespace, newEntities, changes);
    }, patch = function (namespace, values, changes) {
        for (var path in changes) {
            var change = changes[path];
            var value = values[path];
            var key = new Key(namespace, path);
            values[path] = ion.deserialize.convertType(ion.patch(value, change, key.type), namespace);
        }
        return values;
    }, save = function (_ref8, changes, callback) {
        var dataset = _ref8.dataset;
        var namespace = _ref8.namespace;
        var user = _ref8.user;
        var securityObjects = _ref8.securityObjects;
        var config = _ref8.config;
        var keys = [];
        {
            var _ref23 = Object.keys(changes);
            for (var _i6 = 0; _i6 < _ref23.length; _i6++) {
                var keystring = _ref23[_i6];
                keys.push(new Key(namespace, keystring));
            }
        }
        var transaction = new Datastore.Transaction(dataset);
        transaction.run(function (err) {
            if (err) {
                callback(err);
                return;
            }
            get({
                dataset: dataset,
                transaction: transaction,
                namespace: namespace
            }, keys, function (err, oldValues) {
                if (err) {
                    return callback(err);
                }
                var oldSecurityObjects = copy(namespace, securityObjects);
                var newValues = copy(namespace, oldValues);
                patch(namespace, newValues, changes);
                var diff = ion.patch.diff(oldValues, newValues);
                for (var path in newValues) {
                    var object = newValues[path];
                    if ((diff != null ? diff[path] : void 0) != null) {
                        var glassKey = new Key(namespace, path);
                        Schema.stamp(glassKey, object, user, securityObjects);
                    }
                }
                coerce(namespace, newValues);
                var errors = validate(namespace, newValues);
                if ((errors != null ? errors.length : void 0) > 0) {
                    return callback(ion.patch.combine(new Error(JSON.stringify(errors)), { code: 422 }));
                }
                diff = ion.patch.diff(oldValues, newValues);
                var securityDiff = ion.patch.diff(oldSecurityObjects, securityObjects);
                if (securityDiff != null) {
                    for (var securityKey in securityDiff) {
                        newValues[securityKey] = ion.patch(newValues[securityKey], securityObjects[securityKey]);
                    }
                    diff = ion.patch.combine(diff, securityDiff);
                }
                var changedValues = {};
                for (var key in diff) {
                    changedValues[key] = newValues[key];
                }
                var entities = convertObjectsToEntities({
                        dataset: dataset,
                        namespace: namespace
                    }, changedValues);
                if (entities.length > 0) {
                    transaction.save(entities);
                }
                var deleteKeys = getKeysOfObjectsToDelete({
                        dataset: dataset,
                        namespace: namespace
                    }, newValues);
                for (var _i7 = 0; _i7 < deleteKeys.length; _i7++) {
                    var glassKey = deleteKeys[_i7];
                    var dsKey = convertGlassKeyToDatastoreKey(dataset, glassKey);
                    var object = oldValues[glassKey];
                    if (config.retain.predicate(object)) {
                        Schema.stamp(glassKey, object, user, securityObjects);
                        transaction.save(convertObjectToEntity({
                            dataset: dataset,
                            glassKey: glassKey,
                            dsKey: dsKey,
                            object: object,
                            deleted: true,
                            indexes: config.retain.indexes
                        }));
                    } else {
                        transaction.delete(dsKey);
                    }
                }
                transaction.commit(function (err) {
                    callback(err, diff);
                });
            });
        });
    }, convertToMultipleKeysIfRequired = function (key) {
        var where = key.query != null ? key.query.where : void 0;
        if (where != null) {
            for (var name in where) {
                var value = where[name];
                if (Array.isArray(value)) {
                    var newKeys = [];
                    for (var _i8 = 0; _i8 < value.length; _i8++) {
                        var item = value[_i8];
                        var newQuery = JSON.parse(JSON.stringify(key.query));
                        newQuery.where[name] = item;
                        var newKey = new Key(key.namespace, key.path, newQuery);
                        var subKeys = convertToMultipleKeysIfRequired(newKey);
                        for (var _i9 = 0; _i9 < subKeys.length; _i9++) {
                            var subKey = subKeys[_i9];
                            newKeys.push(subKey);
                        }
                    }
                    return newKeys;
                } else if (typeof value === 'object') {
                    for (var op in value) {
                        var opValue = value[op];
                        if (op === '!=') {
                            var newKeys = [];
                            var replaceOpWith = function (newOp) {
                                var newQuery = JSON.parse(JSON.stringify(key.query));
                                var _ref31 = {};
                                _ref31[newOp] = opValue;
                                newQuery.where[name] = _ref31;
                                var newKey = new Key(key.namespace, key.path, newQuery);
                                var subKeys = convertToMultipleKeysIfRequired(newKey);
                                for (var _i10 = 0; _i10 < subKeys.length; _i10++) {
                                    var subKey = subKeys[_i10];
                                    newKeys.push(subKey);
                                }
                            };
                            replaceOpWith('>');
                            if (opValue !== null) {
                                replaceOpWith('<');
                            }
                            return newKeys;
                        }
                    }
                }
            }
        }
        return [key];
    }, allKeysHaveId = function (keys) {
        for (var _i11 = 0; _i11 < keys.length; _i11++) {
            var key = keys[_i11];
            if (!(key.id != null)) {
                return false;
            }
        }
        return true;
    }, getParallel = function (_ref9, keys, callback) {
        var dataset = _ref9.dataset;
        var transaction = _ref9.transaction;
        var namespace = _ref9.namespace;
        var mergeChildEntities = _ref9.mergeChildEntities;
        var _ref32 = [];
        for (var _i13 = 0; _i13 < keys.length; _i13++) {
            var singleKey = keys[_i13];
            _ref32.push(get.bind(null, {
                dataset: dataset,
                transaction: transaction,
                namespace: namespace
            }, singleKey));
        }
        parallel(_ref32, function (error, results) {
            if (error != null) {
                return callback(error);
            }
            var merged = {};
            for (var _i12 = 0; _i12 < results.length; _i12++) {
                var index = _i12;
                var result = results[_i12];
                var resultKey = keys[index];
                if (resultKey.id || !mergeChildEntities) {
                    merged[resultKey] = result;
                } else {
                    for (var name in result) {
                        var value = result[name];
                        merged[name] = value;
                    }
                }
            }
            callback(null, merged);
        });
    }, get = function (_ref10, key, callback) {
        var dataset = _ref10.dataset;
        var transaction = _ref10.transaction;
        var namespace = _ref10.namespace;
        transaction = transaction != null ? transaction : dataset;
        if (Array.isArray(key)) {
            var glassKeys = key;
            if (glassKeys.length === 0) {
                callback(null, {});
            } else {
                if (allKeysHaveId(glassKeys)) {
                    var _ref15 = [];
                    for (var _i14 = 0; _i14 < glassKeys.length; _i14++) {
                        var k = glassKeys[_i14];
                        _ref15.push(convertGlassKeyToDatastoreKey(dataset, k));
                    }
                    var dsKeys = _ref15;
                    transaction.get(dsKeys, function (err, entities) {
                        if (err != null) {
                            return callback(err);
                        }
                        callback(null, convertEntitiesToObjects(dataset, entities, namespace));
                    });
                } else {
                    getParallel({
                        dataset: dataset,
                        transaction: transaction,
                        namespace: namespace,
                        mergeChildEntities: false
                    }, glassKeys, callback);
                }
            }
        } else {
            if (typeof key === 'string') {
                key = new Key(namespace, key);
            }
            if (key.id != null) {
                var dsKey = convertGlassKeyToDatastoreKey(dataset, key.path);
                transaction.get(dsKey, function (err, entity) {
                    if (err != null) {
                        return callback(err);
                    }
                    callback(null, convertEntityToObject(entity, namespace, dataset));
                });
            } else {
                var multipleKeys = convertToMultipleKeysIfRequired(key);
                if (multipleKeys.length === 0) {
                    callback(null, {});
                } else if (multipleKeys.length === 1) {
                    var query = createQueryFromGlassKey(dataset, multipleKeys[0]);
                    transaction.runQuery(query, function (err, entities) {
                        if (err != null) {
                            return callback(err);
                        }
                        callback(null, convertEntitiesToObjects(dataset, entities, namespace));
                    });
                } else {
                    getParallel({
                        dataset: dataset,
                        transaction: transaction,
                        namespace: namespace,
                        mergeChildEntities: true
                    }, multipleKeys, callback);
                }
            }
        }
    }, parallel = function (funcs, callback) {
        require('../async').parallel(funcs, function (results) {
            var _ref16 = [];
            for (var _i15 = 0; _i15 < results.length; _i15++) {
                var result = results[_i15];
                if (result[0] != null) {
                    _ref16.push(result[0]);
                }
            }
            var errors = _ref16;
            var _ref17 = [];
            for (var _i16 = 0; _i16 < results.length; _i16++) {
                var result = results[_i16];
                _ref17.push(result[1]);
            }
            var values = _ref17;
            callback(errors.length > 0 ? errors : null, values);
        });
    }, coerce = function (namespace, objects) {
        for (var path in objects) {
            var newObject = objects[path];
            var key = new Key(namespace, path);
            Schema.coerce(newObject, key.type);
        }
    }, validate = function (namespace, objects) {
        for (var path in objects) {
            var newObject = objects[path];
            var key = new Key(namespace, path);
            var errors = Schema.validate(newObject, key.type);
            if ((errors != null ? errors.length : void 0) > 0) {
                return errors;
            }
        }
    }, getDescendantCheckKeys = function (key) {
        var descendantTypes = key.type.descendantTypes;
        if (!(descendantTypes != null)) {
            return null;
        }
        var descendantKeys = [];
        {
            var _ref24 = Object.keys(descendantTypes);
            for (var _i17 = 0; _i17 < _ref24.length; _i17++) {
                var dkeyTypeName = _ref24[_i17];
                var dkey = new Key(key.namespace, key, key.namespace[dkeyTypeName], { limit: 1 });
                descendantKeys.push(dkey);
            }
        }
        return descendantKeys;
    }, hasDescendants = function (key, securityObjects) {
        var descendantKeys = getDescendantCheckKeys(key);
        if (descendantKeys != null) {
            for (var _i18 = 0; _i18 < descendantKeys.length; _i18++) {
                var checkDescendantsKey = descendantKeys[_i18];
                var checkDescendants = securityObjects[checkDescendantsKey];
                if (typeof checkDescendants !== 'object') {
                    throw new Error('descendant results were not present: ' + JSON.stringify(checkDescendants));
                }
                for (var descendantKey in checkDescendants) {
                    var descendantValue = checkDescendants[descendantKey];
                    if (descendantValue != null) {
                        return true;
                    }
                }
            }
        }
        return false;
    }, getSecurityKeys = function (key, securityKeys, change) {
        var ancestorKey = key.parent;
        while (ancestorKey != null) {
            securityKeys.push(ancestorKey);
            ancestorKey = ancestorKey.parent;
        }
        if (change === null) {
            var descendantKeys = getDescendantCheckKeys(key);
            if (descendantKeys != null) {
                for (var _i19 = 0; _i19 < descendantKeys.length; _i19++) {
                    var k = descendantKeys[_i19];
                    securityKeys.push(k);
                }
            }
        }
    };
_ref = require('../data');
var Schema = _ref.Schema;
var Key = _ref.Key;
var SecurityContext = _ref.SecurityContext;
module.exports = exports = function Dataset(args) {
    var _ref11 = args;
    var projectId = _ref11.projectId;
    var namespace = _ref11.namespace;
    var datastore = new Datastore({ projectId: projectId });
    var dataset = datastore;
    var config = args.config;
    return {
        get: function (_ref12, key, callback) {
            var userKey = _ref12.userKey;
            var userFinish = _ref12.userFinish;
            var optionsUser = _ref12.user;
            var security = _ref12.security;
            var changes = _ref12.changes;
            var securityKeys = [];
            if (userKey != null) {
                securityKeys.push(userKey);
            }
            var keys = Array.isArray(key) ? key : [key];
            for (var _i20 = 0; _i20 < keys.length; _i20++) {
                var k = keys[_i20];
                getSecurityKeys(k, securityKeys, changes != null ? changes[k] : void 0);
            }
            securityKeys = Array.from(new Set(securityKeys));
            parallel([
                get.bind(null, {
                    dataset: dataset,
                    namespace: namespace
                }, securityKeys),
                get.bind(null, {
                    dataset: dataset,
                    namespace: namespace
                }, key)
            ], function (err, result) {
                if (err) {
                    return callback(err);
                }
                var _ref13 = result;
                var securityObjects = _ref13[0];
                var object = _ref13[1];
                var user = securityObjects[userKey] != null ? securityObjects[userKey] : optionsUser;
                try {
                    userFinish != null ? userFinish(user) : void 0;
                } catch (e) {
                    return callback(e);
                }
                if (object != null) {
                    var _ref33 = {};
                    _ref33[key] = object;
                    coerce(namespace, key.id ? _ref33 : object);
                }
                if (security !== false) {
                    object = SecurityContext.pruneResults({
                        namespace: namespace,
                        key: key,
                        user: user,
                        related: securityObjects,
                        results: object
                    });
                }
                callback(null, object, user, securityObjects);
            });
        },
        set: function (_ref14, proposedChanges, callback) {
            var userKey = _ref14.userKey;
            var userFinish = _ref14.userFinish;
            var optionsUser = _ref14.user;
            var security = _ref14.security;
            var _ref18 = [];
            for (var path in proposedChanges)
                _ref18.push(new Key(namespace, path));
            var keys = _ref18;
            this.get({
                userKey: userKey,
                userFinish: userFinish,
                security: false,
                changes: proposedChanges
            }, keys, function (err, oldValues, user, securityObjects) {
                if (err) {
                    return callback(err);
                }
                user = user != null ? user : optionsUser;
                var changes;
                var newValues;
                var restorationDiff = {};
                if (security !== false) {
                    var proposedNewValues = copyWithChanges(namespace, oldValues, proposedChanges);
                    changes = SecurityContext.pruneChanges({
                        namespace: namespace,
                        user: user,
                        related: securityObjects,
                        oldRecords: oldValues,
                        changes: proposedChanges,
                        newRecords: proposedNewValues
                    });
                    changes = ion.deserialize(ion.serialize(changes), namespace);
                    var securityObjectsWithChanges = copyWithChanges(namespace, securityObjects, proposedChanges);
                    var afterChanges = SecurityContext.pruneChanges({
                            namespace: namespace,
                            user: user,
                            related: securityObjectsWithChanges,
                            oldRecords: proposedNewValues,
                            changes: proposedChanges,
                            newRecords: proposedNewValues
                        });
                    changes = ion.patch.combine(changes, afterChanges);
                    newValues = copyWithChanges(namespace, oldValues, changes);
                    var newValuesCopy = ion.deserialize(ion.serialize(newValues), namespace);
                    var proposedNewValuesCopy = ion.deserialize(ion.serialize(proposedNewValues), namespace);
                    var prunedProposedNewValues = SecurityContext.pruneResults({
                            namespace: namespace,
                            key: keys,
                            user: user,
                            related: securityObjects,
                            results: prunedProposedNewValues
                        });
                    var prunedNewValues = SecurityContext.pruneResults({
                            namespace: namespace,
                            key: keys,
                            user: user,
                            related: securityObjects,
                            results: newValuesCopy
                        });
                    restorationDiff = ion.patch.diff(prunedProposedNewValues, prunedNewValues) != null ? ion.patch.diff(prunedProposedNewValues, prunedNewValues) : {};
                } else {
                    changes = proposedChanges;
                    newValues = copyWithChanges(namespace, oldValues, changes);
                }
                for (var changeKeyString in changes) {
                    var changeValue = changes[changeKeyString];
                    if (changeValue === null) {
                        var changeKey = new Key(namespace, changeKeyString);
                        if (hasDescendants(changeKey, securityObjects)) {
                            console.log('DELETE blocked because of descendants: ' + changeKeyString);
                            delete changes[changeKeyString];
                        }
                    }
                }
                coerce(namespace, newValues);
                var diff = ion.patch.diff(oldValues, newValues);
                if (!(diff != null)) {
                    console.log('QUICK EXIT, NO CHANGES!!!!!!!');
                    return callback(null, restorationDiff);
                } else {
                    for (var path in changes) {
                        if (!diff.hasOwnProperty(path)) {
                            delete oldValues[path];
                            delete newValues[path];
                        }
                    }
                }
                getAllDependentChangesRecursive({
                    dataset: dataset,
                    namespace: namespace,
                    oldValues: oldValues,
                    newValues: newValues,
                    changes: changes,
                    config: config,
                    related: securityObjects
                }, function (err, allChanges) {
                    save({
                        dataset: dataset,
                        namespace: namespace,
                        user: user,
                        securityObjects: securityObjects,
                        config: config
                    }, allChanges, function (err, finalChanges) {
                        if (err) {
                            return callback(err);
                        }
                        finalChanges = finalChanges != null ? finalChanges : {};
                        var response = ion.patch.merge(restorationDiff, finalChanges, { deleteNull: false });
                        console.log('FINAL CHANGES', JSON.stringify(finalChanges, null, 2));
                        callback(null, response, user, securityObjects);
                    });
                });
            });
        }
    };
};
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/googlecloud/Dataset',_glass_googlecloud_Dataset_);
    else
      _glass_googlecloud_Dataset_.call(this, module, exports, require);
  }
  else {
    _glass_googlecloud_Dataset_.call(this);
  }
}).call(this)
void (function(){var _glass_googlecloud_PostSimulator_ = function(module,exports,require){'use strict';
var methods = [
        'PUT',
        'POST',
        'DELETE',
        'OPTIONS'
    ];
module.exports = exports = function (req, res, next) {
    if (req.method === 'GET') {
        for (var _i = 0; _i < methods.length; _i++) {
            var method = methods[_i];
            var value = req.query[method];
            if (value != null) {
                req.url = req.url.substring(0, req.url.indexOf('?'));
                req.method = method;
                req.body = JSON.parse(value);
            }
        }
    }
    next();
};
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/googlecloud/PostSimulator',_glass_googlecloud_PostSimulator_);
    else
      _glass_googlecloud_PostSimulator_.call(this, module, exports, require);
  }
  else {
    _glass_googlecloud_PostSimulator_.call(this);
  }
}).call(this)
void (function(){var _glass_googlecloud_RequestLog_ = function(module,exports,require){'use strict';
module.exports = exports = function (req, res, next) {
    var logs = '';
    res.log = function (___args) {
        var args = Array.prototype.slice.call(arguments, 0);
        var message = args.map(function (x) {
                return typeof x === 'string' ? x : JSON.stringify(x);
            }).join(', ');
        console.log(message);
        logs += message + '\n';
        res.set('logs', logs);
    };
    next();
};
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/googlecloud/RequestLog',_glass_googlecloud_RequestLog_);
    else
      _glass_googlecloud_RequestLog_.call(this, module, exports, require);
  }
  else {
    _glass_googlecloud_RequestLog_.call(this);
  }
}).call(this)
void (function(){var _glass_googlecloud_index_ = function(module,exports,require){Object.defineProperty(exports, 'Authentication', {get:function(){ return require('./Authentication') }, enumerable: true}) 
Object.defineProperty(exports, 'ConvertToRootRequest', {get:function(){ return require('./ConvertToRootRequest') }, enumerable: true}) 
Object.defineProperty(exports, 'Dataset', {get:function(){ return require('./Dataset') }, enumerable: true}) 
Object.defineProperty(exports, 'PostSimulator', {get:function(){ return require('./PostSimulator') }, enumerable: true}) 
Object.defineProperty(exports, 'RequestLog', {get:function(){ return require('./RequestLog') }, enumerable: true}) 
Object.defineProperty(exports, 'restHandler', {get:function(){ return require('./restHandler') }, enumerable: true}) 
Object.freeze(exports)
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/googlecloud/index',_glass_googlecloud_index_);
    else
      _glass_googlecloud_index_.call(this, module, exports, require);
  }
  else {
    _glass_googlecloud_index_.call(this);
  }
}).call(this)
void (function(){var _glass_googlecloud_restHandler_ = function(module,exports,require){'use strict';
var ion = require('ion'), _ref, _ref2, _ref3, removeDuplicateFields = function removeDuplicateFields(from, whenIn) {
        if (from != null && whenIn != null && typeof from === 'object' && typeof whenIn === 'object') {
            for (var key in from) {
                var value = from[key];
                if (value === whenIn[key]) {
                    delete from[key];
                } else {
                    removeDuplicateFields(from[key], whenIn[key]);
                }
            }
        }
    }, removeEcho = function (from, whenIn) {
        var result = ion.clone(from, true);
        removeDuplicateFields(result, whenIn);
        return result;
    }, maybeFlatten = function (object, key) {
        if (!(key.query != null ? key.query.flat : void 0)) {
            return object;
        }
        if (key.id) {
            return convertToFlat(object);
        } else {
            for (var name in object) {
                var value = object[name];
                object[name] = convertToFlat(value);
            }
        }
        return object;
    }, convertToFlat = function (object) {
        var type = object != null ? object.constructor : void 0;
        var properties = type != null ? type.properties : void 0;
        if (!(properties != null)) {
            return object;
        }
        var clone = object.toJSON();
        for (var name in properties) {
            var property = properties[name];
            if (property.flat) {
                clone[name] = object[name];
            }
            if (property.type === 'object' || property.type === 'array') {
                delete clone[name];
            }
        }
        return clone;
    };
_ref = require('../data');
var Key = _ref.Key;
_ref2 = require('./');
var Dataset = _ref2.Dataset;
_ref3 = require('./Authentication');
var getUserKeyAndFinishFunction = _ref3.getUserKeyAndFinishFunction;
var create = exports.create = function (_ref4) {
        var projectId = _ref4.projectId;
        var namespace = _ref4.namespace;
        var config = _ref4.config;
        var dataset = Dataset({
                projectId: projectId,
                namespace: namespace,
                config: config
            });
        var get = function (_ref5, key, handler) {
            var request = _ref5.request;
            var response = _ref5.response;
            var security = _ref5.security;
            var _ref6 = getUserKeyAndFinishFunction({
                    namespace: namespace,
                    request: request,
                    response: response,
                    required: true
                });
            var userKey = _ref6[0];
            var userFinish = _ref6[1];
            dataset.get({
                userKey: userKey,
                userFinish: userFinish,
                security: security
            }, key, handler);
        };
        var set = function (_ref7, patch, handler) {
            var request = _ref7.request;
            var response = _ref7.response;
            var security = _ref7.security;
            var _ref8 = getUserKeyAndFinishFunction({
                    namespace: namespace,
                    request: request,
                    response: response,
                    required: true
                });
            var userKey = _ref8[0];
            var userFinish = _ref8[1];
            dataset.set({
                userKey: userKey,
                userFinish: userFinish,
                security: security
            }, patch, handler);
        };
        var handler = function (request, response, next) {
            if (request.method === 'OPTIONS') {
                return response.send('');
            }
            var read = request.method === 'GET';
            var write = !read;
            var url = decodeURIComponent(request.url);
            var key = new Key(namespace, url.substring(1));
            if (write && key.toString() !== '') {
                throw ion.patch.combine(new Error('Can only post changes to root url'), { code: 400 });
            }
            console.log('REQUEST ' + request.method + ' ' + url + ' ' + JSON.stringify(request.body));
            var security = true;
            if ((key.query != null ? key.query.security : void 0) === false && request.hostname === 'localhost') {
                security = false;
            }
            var timeLabel = ' -> ' + url;
            console.time(timeLabel);
            var body = JSON.parse(JSON.stringify(request.body));
            var handler = function (err, result) {
                console.timeEnd(timeLabel);
                if (err) {
                    console.error(err);
                    return next(err);
                }
                if (!read) {
                    result = removeEcho(result, request.body);
                }
                result = maybeFlatten(result, key);
                response.status(200);
                response.json(result);
            };
            if (read) {
                get({
                    request: request,
                    response: response,
                    security: true
                }, key, handler);
            } else {
                set({
                    request: request,
                    response: response,
                    security: true
                }, body, handler);
            }
        };
        return ion.patch.combine(handler, {
            get: get,
            set: set
        });
    };
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/googlecloud/restHandler',_glass_googlecloud_restHandler_);
    else
      _glass_googlecloud_restHandler_.call(this, module, exports, require);
  }
  else {
    _glass_googlecloud_restHandler_.call(this);
  }
}).call(this)
void (function(){var _glass_html_DragHelper_ = function(module,exports,require){'use strict';
var ion = require('ion'), _ref, maybeBeginDragInternal = function (args, onHold, onDrag) {
        if (onHold == null)
            onHold = true;
        if (onDrag == null)
            onDrag = true;
        var _ref2 = args;
        var event = _ref2.event;
        var callback = _ref2.callback;
        callback = callback != null ? callback : function () {
            return beginDrag(args);
        };
        event.preventDefault();
        event.stopPropagation();
        if (event.touches != null && event.changedTouches[0] !== event.touches[0]) {
            return;
        }
        var _ref3 = document;
        var body = _ref3.body;
        var startX = event.pageX;
        var startY = event.pageY;
        var cancel = function () {
            body.removeEventListener('mousemove', mousemove);
            body.removeEventListener('mouseup', mouseup);
            if (timeoutId != null) {
                clearTimeout(timeoutId);
            }
            args != null ? args.release != null ? args.release() : void 0 : void 0;
        };
        var timeoutId = null;
        if (onHold) {
            timeoutId = setTimeout(function () {
                cancel();
                callback();
            }, 500);
        }
        var mousemove = function mousemove(e) {
            var dragStartDistance = 10;
            if (Math.abs(startX - e.pageX) > dragStartDistance || Math.abs(startY - e.pageY) > dragStartDistance) {
                cancel();
                if (onDrag) {
                    callback();
                }
            }
        };
        var mouseup = function mouseup(e) {
            cancel();
        };
        body.addEventListener('mousemove', mousemove);
        body.addEventListener('mouseup', mouseup);
    };
_ref = require('./functions');
var getOffsetRelative = _ref.getOffsetRelative;
var maybeCaptureMouse = exports.maybeCaptureMouse = function (e, args) {
        maybeBeginDragInternal({
            event: e,
            callback: function () {
                return captureMouse(e, args);
            }
        });
    }, captureMouse = exports.captureMouse = function (e, _ref4) {
        var mousemove = _ref4.mousemove;
        var mouseup = _ref4.mouseup;
        var mouseleave = _ref4.mouseleave;
        var releaseOnLeave = _ref4.releaseOnLeave;
        var release = _ref4.release;
        releaseOnLeave = releaseOnLeave != null ? releaseOnLeave : true;
        e.preventDefault();
        var _ref5 = document;
        var body = _ref5.body;
        var removeHandlers = function () {
            body.removeEventListener('mousemove', moveWrapper);
            body.removeEventListener('mouseup', upWrapper);
            body.removeEventListener('mouseleave', leaveWrapper);
            release != null ? release() : void 0;
        };
        var moveWrapper = function (e) {
            mousemove != null ? mousemove(e) : void 0;
        };
        var upWrapper = function (e) {
            mouseup != null ? mouseup(e) : void 0;
            ion.sync();
            removeHandlers();
        };
        var leaveWrapper = function (e) {
            mouseleave != null ? mouseleave(e) : void 0;
            ion.sync();
            if (releaseOnLeave) {
                removeHandlers();
            }
        };
        body.addEventListener('mousemove', moveWrapper);
        body.addEventListener('mouseup', upWrapper);
        body.addEventListener('mouseleave', leaveWrapper);
    }, maybeBeginDrag = exports.maybeBeginDrag = function (args) {
        maybeBeginDragInternal(args, true, true);
    }, maybeBeginDragOnHold = exports.maybeBeginDragOnHold = function (args) {
        maybeBeginDragInternal(args, true, false);
    }, maybeBeginDragOnMove = exports.maybeBeginDragOnMove = function (args) {
        maybeBeginDragInternal(args, false, true);
    }, beginDrag = exports.beginDrag = function (_ref6) {
        var event = _ref6.event;
        var state = _ref6.state;
        var accuracy = _ref6.accuracy;
        var deltaX = _ref6.deltaX;
        var deltaY = _ref6.deltaY;
        var dragElement = _ref6.dragElement;
        var relativeElement = _ref6.relativeElement;
        var begin = _ref6.begin;
        var update = _ref6.update;
        var end = _ref6.end;
        var currentEvent, currentProperties;
        var start = Date.now();
        var onAnimate = function () {
            if (!ended) {
                currentProperties.time = (Date.now() - start) / 1000;
                update(currentEvent, currentProperties);
                requestAnimationFrame(onAnimate);
            }
        };
        requestAnimationFrame(onAnimate);
        var ended = false;
        accuracy = accuracy != null ? accuracy : 4;
        event.stopPropagation();
        var relative = getOffsetRelative(dragElement);
        var mouseRelative = [
                event.pageX - relative[0],
                event.pageY - relative[1]
            ];
        var position;
        var mousemove = function mousemove(e) {
            var relativeElementPosition = getOffsetRelative(relativeElement);
            position = [
                e.pageX - relativeElementPosition[0] - mouseRelative[0] + (deltaX != null ? deltaX : 0),
                e.pageY - relativeElementPosition[1] - mouseRelative[1] + (deltaY != null ? deltaY : 0)
            ];
            for (var _i = 0; _i < position.length; _i++) {
                var index = _i;
                var value = position[_i];
                position[index] = Math.round(value / accuracy) * accuracy;
            }
            currentEvent = e;
            currentProperties = {
                position: position,
                state: state
            };
            e.preventDefault();
        };
        var mouseleave = function mouseleave(e) {
            end != null ? end(e, null) : void 0;
        };
        if (event != null) {
            mousemove(event);
        }
        if (begin != null) {
            begin(currentEvent, currentProperties);
            ion.sync();
        }
        var mouseup = function mouseup(e) {
            ended = true;
            end != null ? end(e, currentProperties) : void 0;
        };
        captureMouse(event, {
            mousemove: mousemove,
            mouseup: mouseup,
            mouseleave: mouseleave
        });
    };
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/DragHelper',_glass_html_DragHelper_);
    else
      _glass_html_DragHelper_.call(this, module, exports, require);
  }
  else {
    _glass_html_DragHelper_.call(this);
  }
}).call(this)

'use strict';
if (global.window) {
    Object.defineProperties(HTMLElement.prototype, {
        valueJSON: {
            enumerable: true,
            get: function () {
                if (this.property != null) {
                    if (this.property.type === 'integer') {
                        return parseInt(this.value);
                    }
                    if (this.property.type === 'number') {
                        return parseFloat(this.value);
                    }
                }
                if (this.checked != null) {
                    return this.checked;
                } else {
                    return this.value != null ? this.value : null;
                }
            },
            set: function (value) {
                if (this.checked != null) {
                    this.checked = value === true;
                } else {
                    this.value = value;
                }
            }
        }
    });
}
void (function(){var _glass_html_Theme_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('./'), _ref2;
var style = _ref.style;
_ref2 = style;
var rgba = _ref2.toRgba;
module.exports = exports = ion.template(function (base) {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: '_ref3'
                        },
                        init: {
                            type: 'MemberExpression',
                            computed: false,
                            object: {
                                type: 'Identifier',
                                name: 'base',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 95,
                                        fixed: true,
                                        source: 'glass/html/Theme.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 99,
                                        fixed: true,
                                        source: 'glass/html/Theme.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'color',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 100,
                                        fixed: true,
                                        source: 'glass/html/Theme.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 105,
                                        fixed: true,
                                        source: 'glass/html/Theme.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 6,
                                    column: 95,
                                    fixed: true,
                                    source: 'glass/html/Theme.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 105,
                                    fixed: true,
                                    source: 'glass/html/Theme.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'white',
                            loc: {
                                start: {
                                    line: 6,
                                    column: 9,
                                    fixed: true,
                                    source: 'glass/html/Theme.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 14,
                                    fixed: true,
                                    source: 'glass/html/Theme.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'white',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 9,
                                        fixed: true,
                                        source: 'glass/html/Theme.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 14,
                                        fixed: true,
                                        source: 'glass/html/Theme.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'black',
                            loc: {
                                start: {
                                    line: 6,
                                    column: 15,
                                    fixed: true,
                                    source: 'glass/html/Theme.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 20,
                                    fixed: true,
                                    source: 'glass/html/Theme.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'black',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/Theme.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/Theme.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'primary',
                            loc: {
                                start: {
                                    line: 6,
                                    column: 21,
                                    fixed: true,
                                    source: 'glass/html/Theme.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 28,
                                    fixed: true,
                                    source: 'glass/html/Theme.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'primary',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 21,
                                        fixed: true,
                                        source: 'glass/html/Theme.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 28,
                                        fixed: true,
                                        source: 'glass/html/Theme.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '3'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'accent',
                            loc: {
                                start: {
                                    line: 6,
                                    column: 29,
                                    fixed: true,
                                    source: 'glass/html/Theme.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 35,
                                    fixed: true,
                                    source: 'glass/html/Theme.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'accent',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 29,
                                        fixed: true,
                                        source: 'glass/html/Theme.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 35,
                                        fixed: true,
                                        source: 'glass/html/Theme.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '4'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'primaryLighter',
                            loc: {
                                start: {
                                    line: 6,
                                    column: 36,
                                    fixed: true,
                                    source: 'glass/html/Theme.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 50,
                                    fixed: true,
                                    source: 'glass/html/Theme.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'primaryLighter',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 36,
                                        fixed: true,
                                        source: 'glass/html/Theme.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 50,
                                        fixed: true,
                                        source: 'glass/html/Theme.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '5'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'primaryDarker',
                            loc: {
                                start: {
                                    line: 6,
                                    column: 51,
                                    fixed: true,
                                    source: 'glass/html/Theme.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 64,
                                    fixed: true,
                                    source: 'glass/html/Theme.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'primaryDarker',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 51,
                                        fixed: true,
                                        source: 'glass/html/Theme.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 64,
                                        fixed: true,
                                        source: 'glass/html/Theme.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '6'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'accentLighter',
                            loc: {
                                start: {
                                    line: 6,
                                    column: 65,
                                    fixed: true,
                                    source: 'glass/html/Theme.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 78,
                                    fixed: true,
                                    source: 'glass/html/Theme.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'accentLighter',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 65,
                                        fixed: true,
                                        source: 'glass/html/Theme.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 78,
                                        fixed: true,
                                        source: 'glass/html/Theme.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '7'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'accentDarker',
                            loc: {
                                start: {
                                    line: 6,
                                    column: 79,
                                    fixed: true,
                                    source: 'glass/html/Theme.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 91,
                                    fixed: true,
                                    source: 'glass/html/Theme.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'accentDarker',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 79,
                                        fixed: true,
                                        source: 'glass/html/Theme.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 91,
                                        fixed: true,
                                        source: 'glass/html/Theme.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '8'
            },
            {
                type: 'VariableDeclaration',
                declarations: [
                    {
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'divider',
                            loc: {
                                start: {
                                    line: 8,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/Theme.ion'
                                },
                                end: {
                                    line: 8,
                                    column: 15,
                                    fixed: true,
                                    source: 'glass/html/Theme.ion'
                                }
                            }
                        },
                        init: {
                            type: 'Literal',
                            value: 0.12
                        }
                    },
                    {
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'hint',
                            loc: {
                                start: {
                                    line: 9,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/Theme.ion'
                                },
                                end: {
                                    line: 9,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/Theme.ion'
                                }
                            }
                        },
                        init: {
                            type: 'Literal',
                            value: 0.26
                        }
                    },
                    {
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'secondary',
                            loc: {
                                start: {
                                    line: 10,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/Theme.ion'
                                },
                                end: {
                                    line: 10,
                                    column: 17,
                                    fixed: true,
                                    source: 'glass/html/Theme.ion'
                                }
                            }
                        },
                        init: {
                            type: 'Literal',
                            value: 0.54
                        }
                    },
                    {
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'text',
                            loc: {
                                start: {
                                    line: 11,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/Theme.ion'
                                },
                                end: {
                                    line: 11,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/Theme.ion'
                                }
                            }
                        },
                        init: {
                            type: 'Literal',
                            value: 0.77
                        }
                    }
                ],
                kind: 'let',
                order: '9'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'buffer',
                            loc: {
                                start: {
                                    line: 13,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/Theme.ion'
                                },
                                end: {
                                    line: 13,
                                    column: 14,
                                    fixed: true,
                                    source: 'glass/html/Theme.ion'
                                }
                            }
                        },
                        init: {
                            type: 'Literal',
                            value: 16
                        }
                    }],
                kind: 'let',
                order: ':'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'appBarHeight',
                            loc: {
                                start: {
                                    line: 14,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/Theme.ion'
                                },
                                end: {
                                    line: 14,
                                    column: 20,
                                    fixed: true,
                                    source: 'glass/html/Theme.ion'
                                }
                            }
                        },
                        init: {
                            type: 'Literal',
                            value: 48
                        }
                    }],
                kind: 'let',
                order: ';'
            },
            {
                type: 'ExpressionStatement',
                expression: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'Identifier',
                        name: 'style',
                        loc: {
                            start: {
                                line: 16,
                                column: 4,
                                fixed: true,
                                source: 'glass/html/Theme.ion'
                            },
                            end: {
                                line: 16,
                                column: 9,
                                fixed: true,
                                source: 'glass/html/Theme.ion'
                            }
                        }
                    },
                    properties: [
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'opacity',
                                loc: {
                                    start: {
                                        line: 17,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/Theme.ion'
                                    },
                                    end: {
                                        line: 17,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/Theme.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'ObjectExpression',
                                properties: [
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'divider',
                                            loc: {
                                                start: {
                                                    line: 18,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                },
                                                end: {
                                                    line: 18,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Identifier',
                                            name: 'divider',
                                            loc: {
                                                start: {
                                                    line: 18,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                },
                                                end: {
                                                    line: 18,
                                                    column: 28,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                }
                                            }
                                        },
                                        kind: 'init',
                                        order: '0'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'hint',
                                            loc: {
                                                start: {
                                                    line: 19,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                },
                                                end: {
                                                    line: 19,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Identifier',
                                            name: 'hint',
                                            loc: {
                                                start: {
                                                    line: 19,
                                                    column: 18,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                },
                                                end: {
                                                    line: 19,
                                                    column: 22,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                }
                                            }
                                        },
                                        kind: 'init',
                                        order: '1'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'secondary',
                                            loc: {
                                                start: {
                                                    line: 20,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                },
                                                end: {
                                                    line: 20,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Identifier',
                                            name: 'secondary',
                                            loc: {
                                                start: {
                                                    line: 20,
                                                    column: 23,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                },
                                                end: {
                                                    line: 20,
                                                    column: 32,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                }
                                            }
                                        },
                                        kind: 'init',
                                        order: '2'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'text',
                                            loc: {
                                                start: {
                                                    line: 21,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                },
                                                end: {
                                                    line: 21,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Identifier',
                                            name: 'text',
                                            loc: {
                                                start: {
                                                    line: 21,
                                                    column: 18,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                },
                                                end: {
                                                    line: 21,
                                                    column: 22,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                }
                                            }
                                        },
                                        kind: 'init',
                                        order: '3'
                                    }
                                ]
                            },
                            kind: 'init',
                            order: '0'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'spacing',
                                loc: {
                                    start: {
                                        line: 22,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/Theme.ion'
                                    },
                                    end: {
                                        line: 22,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/Theme.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'ObjectExpression',
                                properties: [
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'buffer',
                                            loc: {
                                                start: {
                                                    line: 23,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                },
                                                end: {
                                                    line: 23,
                                                    column: 18,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Identifier',
                                            name: 'buffer',
                                            loc: {
                                                start: {
                                                    line: 23,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                },
                                                end: {
                                                    line: 23,
                                                    column: 26,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                }
                                            }
                                        },
                                        kind: 'init',
                                        order: '0'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'appBarHeight',
                                            loc: {
                                                start: {
                                                    line: 24,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                },
                                                end: {
                                                    line: 24,
                                                    column: 24,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Identifier',
                                            name: 'appBarHeight',
                                            loc: {
                                                start: {
                                                    line: 24,
                                                    column: 26,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                },
                                                end: {
                                                    line: 24,
                                                    column: 38,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                }
                                            }
                                        },
                                        kind: 'init',
                                        order: '1'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'rowHeight',
                                            loc: {
                                                start: {
                                                    line: 25,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                },
                                                end: {
                                                    line: 25,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: 48
                                        },
                                        kind: 'init',
                                        order: '2'
                                    }
                                ]
                            },
                            kind: 'init',
                            order: '1'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'color',
                                loc: {
                                    start: {
                                        line: 26,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/Theme.ion'
                                    },
                                    end: {
                                        line: 26,
                                        column: 13,
                                        fixed: true,
                                        source: 'glass/html/Theme.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'ObjectExpression',
                                properties: [
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'white',
                                            loc: {
                                                start: {
                                                    line: 27,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                },
                                                end: {
                                                    line: 27,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Identifier',
                                            name: 'white',
                                            loc: {
                                                start: {
                                                    line: 27,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                },
                                                end: {
                                                    line: 27,
                                                    column: 24,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                }
                                            }
                                        },
                                        kind: 'init',
                                        order: '0'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'black',
                                            loc: {
                                                start: {
                                                    line: 28,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                },
                                                end: {
                                                    line: 28,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Identifier',
                                            name: 'black',
                                            loc: {
                                                start: {
                                                    line: 28,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                },
                                                end: {
                                                    line: 28,
                                                    column: 24,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                }
                                            }
                                        },
                                        kind: 'init',
                                        order: '1'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'primary',
                                            loc: {
                                                start: {
                                                    line: 29,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                },
                                                end: {
                                                    line: 29,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Identifier',
                                            name: 'primary',
                                            loc: {
                                                start: {
                                                    line: 29,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                },
                                                end: {
                                                    line: 29,
                                                    column: 28,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                }
                                            }
                                        },
                                        kind: 'init',
                                        order: '2'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'primaryLight',
                                            loc: {
                                                start: {
                                                    line: 30,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                },
                                                end: {
                                                    line: 30,
                                                    column: 24,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Identifier',
                                            name: 'primaryLighter',
                                            loc: {
                                                start: {
                                                    line: 30,
                                                    column: 26,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                },
                                                end: {
                                                    line: 30,
                                                    column: 40,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                }
                                            }
                                        },
                                        kind: 'init',
                                        order: '3'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'primaryDark',
                                            loc: {
                                                start: {
                                                    line: 31,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                },
                                                end: {
                                                    line: 31,
                                                    column: 23,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Identifier',
                                            name: 'primaryDarker',
                                            loc: {
                                                start: {
                                                    line: 31,
                                                    column: 25,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                },
                                                end: {
                                                    line: 31,
                                                    column: 38,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                }
                                            }
                                        },
                                        kind: 'init',
                                        order: '4'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'accent',
                                            loc: {
                                                start: {
                                                    line: 32,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                },
                                                end: {
                                                    line: 32,
                                                    column: 18,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Identifier',
                                            name: 'accent',
                                            loc: {
                                                start: {
                                                    line: 32,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                },
                                                end: {
                                                    line: 32,
                                                    column: 26,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                }
                                            }
                                        },
                                        kind: 'init',
                                        order: '5'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'accentLight',
                                            loc: {
                                                start: {
                                                    line: 33,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                },
                                                end: {
                                                    line: 33,
                                                    column: 23,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Identifier',
                                            name: 'accentLighter',
                                            loc: {
                                                start: {
                                                    line: 33,
                                                    column: 25,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                },
                                                end: {
                                                    line: 33,
                                                    column: 38,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                }
                                            }
                                        },
                                        kind: 'init',
                                        order: '6'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'accentDark',
                                            loc: {
                                                start: {
                                                    line: 34,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                },
                                                end: {
                                                    line: 34,
                                                    column: 22,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Identifier',
                                            name: 'accentDarker',
                                            loc: {
                                                start: {
                                                    line: 34,
                                                    column: 24,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                },
                                                end: {
                                                    line: 34,
                                                    column: 36,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                }
                                            }
                                        },
                                        kind: 'init',
                                        order: '7'
                                    }
                                ]
                            },
                            kind: 'init',
                            order: '2'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'typography',
                                loc: {
                                    start: {
                                        line: 35,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/Theme.ion'
                                    },
                                    end: {
                                        line: 35,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/Theme.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'ObjectExpression',
                                properties: [
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'display4',
                                            loc: {
                                                start: {
                                                    line: 36,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                },
                                                end: {
                                                    line: 36,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'ObjectExpression',
                                            properties: [
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'size',
                                                        loc: {
                                                            start: {
                                                                line: 37,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/Theme.ion'
                                                            },
                                                            end: {
                                                                line: 37,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'glass/html/Theme.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 112
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'weight',
                                                        loc: {
                                                            start: {
                                                                line: 38,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/Theme.ion'
                                                            },
                                                            end: {
                                                                line: 38,
                                                                column: 22,
                                                                fixed: true,
                                                                source: 'glass/html/Theme.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 'light'
                                                    },
                                                    kind: 'init',
                                                    order: '1'
                                                }
                                            ]
                                        },
                                        kind: 'init',
                                        order: '0'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'display3',
                                            loc: {
                                                start: {
                                                    line: 39,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                },
                                                end: {
                                                    line: 39,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'ObjectExpression',
                                            properties: [
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'size',
                                                        loc: {
                                                            start: {
                                                                line: 40,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/Theme.ion'
                                                            },
                                                            end: {
                                                                line: 40,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'glass/html/Theme.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 56
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'weight',
                                                        loc: {
                                                            start: {
                                                                line: 41,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/Theme.ion'
                                                            },
                                                            end: {
                                                                line: 41,
                                                                column: 22,
                                                                fixed: true,
                                                                source: 'glass/html/Theme.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 'regular'
                                                    },
                                                    kind: 'init',
                                                    order: '1'
                                                }
                                            ]
                                        },
                                        kind: 'init',
                                        order: '1'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'display2',
                                            loc: {
                                                start: {
                                                    line: 42,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                },
                                                end: {
                                                    line: 42,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'ObjectExpression',
                                            properties: [
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'size',
                                                        loc: {
                                                            start: {
                                                                line: 43,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/Theme.ion'
                                                            },
                                                            end: {
                                                                line: 43,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'glass/html/Theme.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 45
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'weight',
                                                        loc: {
                                                            start: {
                                                                line: 44,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/Theme.ion'
                                                            },
                                                            end: {
                                                                line: 44,
                                                                column: 22,
                                                                fixed: true,
                                                                source: 'glass/html/Theme.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 'regular'
                                                    },
                                                    kind: 'init',
                                                    order: '1'
                                                }
                                            ]
                                        },
                                        kind: 'init',
                                        order: '2'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'display1',
                                            loc: {
                                                start: {
                                                    line: 45,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                },
                                                end: {
                                                    line: 45,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'ObjectExpression',
                                            properties: [
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'size',
                                                        loc: {
                                                            start: {
                                                                line: 46,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/Theme.ion'
                                                            },
                                                            end: {
                                                                line: 46,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'glass/html/Theme.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 34
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'weight',
                                                        loc: {
                                                            start: {
                                                                line: 47,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/Theme.ion'
                                                            },
                                                            end: {
                                                                line: 47,
                                                                column: 22,
                                                                fixed: true,
                                                                source: 'glass/html/Theme.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 'regular'
                                                    },
                                                    kind: 'init',
                                                    order: '1'
                                                }
                                            ]
                                        },
                                        kind: 'init',
                                        order: '3'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'headline',
                                            loc: {
                                                start: {
                                                    line: 48,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                },
                                                end: {
                                                    line: 48,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'ObjectExpression',
                                            properties: [
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'size',
                                                        loc: {
                                                            start: {
                                                                line: 49,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/Theme.ion'
                                                            },
                                                            end: {
                                                                line: 49,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'glass/html/Theme.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 24
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'weight',
                                                        loc: {
                                                            start: {
                                                                line: 50,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/Theme.ion'
                                                            },
                                                            end: {
                                                                line: 50,
                                                                column: 22,
                                                                fixed: true,
                                                                source: 'glass/html/Theme.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 'regular'
                                                    },
                                                    kind: 'init',
                                                    order: '1'
                                                }
                                            ]
                                        },
                                        kind: 'init',
                                        order: '4'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'title',
                                            loc: {
                                                start: {
                                                    line: 51,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                },
                                                end: {
                                                    line: 51,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'ObjectExpression',
                                            properties: [
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'size',
                                                        loc: {
                                                            start: {
                                                                line: 52,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/Theme.ion'
                                                            },
                                                            end: {
                                                                line: 52,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'glass/html/Theme.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 20
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'weight',
                                                        loc: {
                                                            start: {
                                                                line: 53,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/Theme.ion'
                                                            },
                                                            end: {
                                                                line: 53,
                                                                column: 22,
                                                                fixed: true,
                                                                source: 'glass/html/Theme.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 'medium'
                                                    },
                                                    kind: 'init',
                                                    order: '1'
                                                }
                                            ]
                                        },
                                        kind: 'init',
                                        order: '5'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'subheading',
                                            loc: {
                                                start: {
                                                    line: 54,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                },
                                                end: {
                                                    line: 54,
                                                    column: 22,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'ObjectExpression',
                                            properties: [
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'size',
                                                        loc: {
                                                            start: {
                                                                line: 55,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/Theme.ion'
                                                            },
                                                            end: {
                                                                line: 55,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'glass/html/Theme.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 15
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'weight',
                                                        loc: {
                                                            start: {
                                                                line: 56,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/Theme.ion'
                                                            },
                                                            end: {
                                                                line: 56,
                                                                column: 22,
                                                                fixed: true,
                                                                source: 'glass/html/Theme.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 'regular'
                                                    },
                                                    kind: 'init',
                                                    order: '1'
                                                }
                                            ]
                                        },
                                        kind: 'init',
                                        order: '6'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'body2',
                                            loc: {
                                                start: {
                                                    line: 57,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                },
                                                end: {
                                                    line: 57,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'ObjectExpression',
                                            properties: [
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'size',
                                                        loc: {
                                                            start: {
                                                                line: 58,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/Theme.ion'
                                                            },
                                                            end: {
                                                                line: 58,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'glass/html/Theme.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 13
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'weight',
                                                        loc: {
                                                            start: {
                                                                line: 59,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/Theme.ion'
                                                            },
                                                            end: {
                                                                line: 59,
                                                                column: 22,
                                                                fixed: true,
                                                                source: 'glass/html/Theme.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 'medium'
                                                    },
                                                    kind: 'init',
                                                    order: '1'
                                                }
                                            ]
                                        },
                                        kind: 'init',
                                        order: '7'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'body1',
                                            loc: {
                                                start: {
                                                    line: 60,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                },
                                                end: {
                                                    line: 60,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'ObjectExpression',
                                            properties: [
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'size',
                                                        loc: {
                                                            start: {
                                                                line: 61,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/Theme.ion'
                                                            },
                                                            end: {
                                                                line: 61,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'glass/html/Theme.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 13
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'weight',
                                                        loc: {
                                                            start: {
                                                                line: 62,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/Theme.ion'
                                                            },
                                                            end: {
                                                                line: 62,
                                                                column: 22,
                                                                fixed: true,
                                                                source: 'glass/html/Theme.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 'regular'
                                                    },
                                                    kind: 'init',
                                                    order: '1'
                                                }
                                            ]
                                        },
                                        kind: 'init',
                                        order: '8'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'caption',
                                            loc: {
                                                start: {
                                                    line: 63,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                },
                                                end: {
                                                    line: 63,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'ObjectExpression',
                                            properties: [
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'size',
                                                        loc: {
                                                            start: {
                                                                line: 64,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/Theme.ion'
                                                            },
                                                            end: {
                                                                line: 64,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'glass/html/Theme.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 12
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'weight',
                                                        loc: {
                                                            start: {
                                                                line: 65,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/Theme.ion'
                                                            },
                                                            end: {
                                                                line: 65,
                                                                column: 22,
                                                                fixed: true,
                                                                source: 'glass/html/Theme.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 'regular'
                                                    },
                                                    kind: 'init',
                                                    order: '1'
                                                }
                                            ]
                                        },
                                        kind: 'init',
                                        order: '9'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'button',
                                            loc: {
                                                start: {
                                                    line: 66,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                },
                                                end: {
                                                    line: 66,
                                                    column: 18,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'ObjectExpression',
                                            properties: [
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'size',
                                                        loc: {
                                                            start: {
                                                                line: 67,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/Theme.ion'
                                                            },
                                                            end: {
                                                                line: 67,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'glass/html/Theme.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 14
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'weight',
                                                        loc: {
                                                            start: {
                                                                line: 68,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/Theme.ion'
                                                            },
                                                            end: {
                                                                line: 68,
                                                                column: 22,
                                                                fixed: true,
                                                                source: 'glass/html/Theme.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 'medium'
                                                    },
                                                    kind: 'init',
                                                    order: '1'
                                                }
                                            ]
                                        },
                                        kind: 'init',
                                        order: ':'
                                    }
                                ]
                            },
                            kind: 'init',
                            order: '3'
                        }
                    ]
                },
                loc: {
                    start: {
                        line: 16,
                        column: 4,
                        fixed: true,
                        source: 'glass/html/Theme.ion'
                    },
                    end: {
                        line: 70,
                        column: 8,
                        fixed: true,
                        source: 'glass/html/Theme.ion'
                    }
                },
                order: '<'
            },
            {
                type: 'ExpressionStatement',
                expression: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'MemberExpression',
                        computed: false,
                        object: {
                            type: 'Identifier',
                            name: 'style',
                            loc: {
                                start: {
                                    line: 71,
                                    column: 4,
                                    fixed: true,
                                    source: 'glass/html/Theme.ion'
                                },
                                end: {
                                    line: 71,
                                    column: 9,
                                    fixed: true,
                                    source: 'glass/html/Theme.ion'
                                }
                            }
                        },
                        property: {
                            type: 'Identifier',
                            name: 'custom',
                            loc: {
                                start: {
                                    line: 71,
                                    column: 10,
                                    fixed: true,
                                    source: 'glass/html/Theme.ion'
                                },
                                end: {
                                    line: 71,
                                    column: 16,
                                    fixed: true,
                                    source: 'glass/html/Theme.ion'
                                }
                            }
                        },
                        loc: {
                            start: {
                                line: 71,
                                column: 4,
                                fixed: true,
                                source: 'glass/html/Theme.ion'
                            },
                            end: {
                                line: 71,
                                column: 16,
                                fixed: true,
                                source: 'glass/html/Theme.ion'
                            }
                        }
                    },
                    properties: [{
                            type: 'Property',
                            key: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'module',
                                    loc: {
                                        start: {
                                            line: 72,
                                            column: 9,
                                            fixed: true,
                                            source: 'glass/html/Theme.ion'
                                        },
                                        end: {
                                            line: 72,
                                            column: 15,
                                            fixed: true,
                                            source: 'glass/html/Theme.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'id',
                                    loc: {
                                        start: {
                                            line: 72,
                                            column: 16,
                                            fixed: true,
                                            source: 'glass/html/Theme.ion'
                                        },
                                        end: {
                                            line: 72,
                                            column: 18,
                                            fixed: true,
                                            source: 'glass/html/Theme.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 72,
                                        column: 9,
                                        fixed: true,
                                        source: 'glass/html/Theme.ion'
                                    },
                                    end: {
                                        line: 72,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/Theme.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'BinaryExpression',
                                operator: '+',
                                left: {
                                    type: 'BinaryExpression',
                                    operator: '+',
                                    left: {
                                        type: 'BinaryExpression',
                                        operator: '+',
                                        left: {
                                            type: 'BinaryExpression',
                                            operator: '+',
                                            left: {
                                                type: 'Literal',
                                                value: ':root {\n    /* this should really come from the style */\n    --primary-color: '
                                            },
                                            right: {
                                                type: 'Identifier',
                                                name: 'primary',
                                                loc: {
                                                    start: {
                                                        line: 75,
                                                        column: 35,
                                                        fixed: true,
                                                        source: 'glass/html/Theme.ion'
                                                    },
                                                    end: {
                                                        line: 75,
                                                        column: 42,
                                                        fixed: true,
                                                        source: 'glass/html/Theme.ion'
                                                    }
                                                }
                                            }
                                        },
                                        right: {
                                            type: 'Literal',
                                            value: ';\n    --secondary-color: '
                                        }
                                    },
                                    right: {
                                        type: 'Identifier',
                                        name: 'accent',
                                        loc: {
                                            start: {
                                                line: 76,
                                                column: 37,
                                                fixed: true,
                                                source: 'glass/html/Theme.ion'
                                            },
                                            end: {
                                                line: 76,
                                                column: 43,
                                                fixed: true,
                                                source: 'glass/html/Theme.ion'
                                            }
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: ';\n}\n\n/* paper elements */\npaper-button {\n}'
                                }
                            },
                            kind: 'init',
                            computed: true,
                            order: '0'
                        }]
                },
                loc: {
                    start: {
                        line: 71,
                        column: 4,
                        fixed: true,
                        source: 'glass/html/Theme.ion'
                    },
                    end: {
                        line: 84,
                        column: 8,
                        fixed: true,
                        source: 'glass/html/Theme.ion'
                    }
                },
                order: '='
            },
            {
                type: 'ExpressionStatement',
                expression: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'MemberExpression',
                        computed: false,
                        object: {
                            type: 'Identifier',
                            name: 'style',
                            loc: {
                                start: {
                                    line: 84,
                                    column: 4,
                                    fixed: true,
                                    source: 'glass/html/Theme.ion'
                                },
                                end: {
                                    line: 84,
                                    column: 9,
                                    fixed: true,
                                    source: 'glass/html/Theme.ion'
                                }
                            }
                        },
                        property: {
                            type: 'Identifier',
                            name: 'sheets',
                            loc: {
                                start: {
                                    line: 84,
                                    column: 10,
                                    fixed: true,
                                    source: 'glass/html/Theme.ion'
                                },
                                end: {
                                    line: 84,
                                    column: 16,
                                    fixed: true,
                                    source: 'glass/html/Theme.ion'
                                }
                            }
                        },
                        loc: {
                            start: {
                                line: 84,
                                column: 4,
                                fixed: true,
                                source: 'glass/html/Theme.ion'
                            },
                            end: {
                                line: 84,
                                column: 16,
                                fixed: true,
                                source: 'glass/html/Theme.ion'
                            }
                        }
                    },
                    properties: [{
                            type: 'Property',
                            key: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'module',
                                    loc: {
                                        start: {
                                            line: 85,
                                            column: 9,
                                            fixed: true,
                                            source: 'glass/html/Theme.ion'
                                        },
                                        end: {
                                            line: 85,
                                            column: 15,
                                            fixed: true,
                                            source: 'glass/html/Theme.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'id',
                                    loc: {
                                        start: {
                                            line: 85,
                                            column: 16,
                                            fixed: true,
                                            source: 'glass/html/Theme.ion'
                                        },
                                        end: {
                                            line: 85,
                                            column: 18,
                                            fixed: true,
                                            source: 'glass/html/Theme.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 85,
                                        column: 9,
                                        fixed: true,
                                        source: 'glass/html/Theme.ion'
                                    },
                                    end: {
                                        line: 85,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/Theme.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'BinaryExpression',
                                operator: '+',
                                left: {
                                    type: 'BinaryExpression',
                                    operator: '+',
                                    left: {
                                        type: 'BinaryExpression',
                                        operator: '+',
                                        left: {
                                            type: 'BinaryExpression',
                                            operator: '+',
                                            left: {
                                                type: 'BinaryExpression',
                                                operator: '+',
                                                left: {
                                                    type: 'BinaryExpression',
                                                    operator: '+',
                                                    left: {
                                                        type: 'BinaryExpression',
                                                        operator: '+',
                                                        left: {
                                                            type: 'BinaryExpression',
                                                            operator: '+',
                                                            left: {
                                                                type: 'BinaryExpression',
                                                                operator: '+',
                                                                left: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '+',
                                                                    left: {
                                                                        type: 'BinaryExpression',
                                                                        operator: '+',
                                                                        left: {
                                                                            type: 'BinaryExpression',
                                                                            operator: '+',
                                                                            left: {
                                                                                type: 'BinaryExpression',
                                                                                operator: '+',
                                                                                left: {
                                                                                    type: 'BinaryExpression',
                                                                                    operator: '+',
                                                                                    left: {
                                                                                        type: 'BinaryExpression',
                                                                                        operator: '+',
                                                                                        left: {
                                                                                            type: 'BinaryExpression',
                                                                                            operator: '+',
                                                                                            left: {
                                                                                                type: 'BinaryExpression',
                                                                                                operator: '+',
                                                                                                left: {
                                                                                                    type: 'BinaryExpression',
                                                                                                    operator: '+',
                                                                                                    left: {
                                                                                                        type: 'BinaryExpression',
                                                                                                        operator: '+',
                                                                                                        left: {
                                                                                                            type: 'BinaryExpression',
                                                                                                            operator: '+',
                                                                                                            left: {
                                                                                                                type: 'BinaryExpression',
                                                                                                                operator: '+',
                                                                                                                left: {
                                                                                                                    type: 'BinaryExpression',
                                                                                                                    operator: '+',
                                                                                                                    left: {
                                                                                                                        type: 'BinaryExpression',
                                                                                                                        operator: '+',
                                                                                                                        left: {
                                                                                                                            type: 'BinaryExpression',
                                                                                                                            operator: '+',
                                                                                                                            left: {
                                                                                                                                type: 'BinaryExpression',
                                                                                                                                operator: '+',
                                                                                                                                left: {
                                                                                                                                    type: 'BinaryExpression',
                                                                                                                                    operator: '+',
                                                                                                                                    left: {
                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                        operator: '+',
                                                                                                                                        left: {
                                                                                                                                            type: 'BinaryExpression',
                                                                                                                                            operator: '+',
                                                                                                                                            left: {
                                                                                                                                                type: 'BinaryExpression',
                                                                                                                                                operator: '+',
                                                                                                                                                left: {
                                                                                                                                                    type: 'BinaryExpression',
                                                                                                                                                    operator: '+',
                                                                                                                                                    left: {
                                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                                        operator: '+',
                                                                                                                                                        left: {
                                                                                                                                                            type: 'BinaryExpression',
                                                                                                                                                            operator: '+',
                                                                                                                                                            left: {
                                                                                                                                                                type: 'BinaryExpression',
                                                                                                                                                                operator: '+',
                                                                                                                                                                left: {
                                                                                                                                                                    type: 'BinaryExpression',
                                                                                                                                                                    operator: '+',
                                                                                                                                                                    left: {
                                                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                                                        operator: '+',
                                                                                                                                                                        left: {
                                                                                                                                                                            type: 'BinaryExpression',
                                                                                                                                                                            operator: '+',
                                                                                                                                                                            left: {
                                                                                                                                                                                type: 'BinaryExpression',
                                                                                                                                                                                operator: '+',
                                                                                                                                                                                left: {
                                                                                                                                                                                    type: 'BinaryExpression',
                                                                                                                                                                                    operator: '+',
                                                                                                                                                                                    left: {
                                                                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                                                                        operator: '+',
                                                                                                                                                                                        left: {
                                                                                                                                                                                            type: 'BinaryExpression',
                                                                                                                                                                                            operator: '+',
                                                                                                                                                                                            left: {
                                                                                                                                                                                                type: 'BinaryExpression',
                                                                                                                                                                                                operator: '+',
                                                                                                                                                                                                left: {
                                                                                                                                                                                                    type: 'BinaryExpression',
                                                                                                                                                                                                    operator: '+',
                                                                                                                                                                                                    left: {
                                                                                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                                                                                        operator: '+',
                                                                                                                                                                                                        left: {
                                                                                                                                                                                                            type: 'BinaryExpression',
                                                                                                                                                                                                            operator: '+',
                                                                                                                                                                                                            left: {
                                                                                                                                                                                                                type: 'BinaryExpression',
                                                                                                                                                                                                                operator: '+',
                                                                                                                                                                                                                left: {
                                                                                                                                                                                                                    type: 'BinaryExpression',
                                                                                                                                                                                                                    operator: '+',
                                                                                                                                                                                                                    left: {
                                                                                                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                                                                                                        operator: '+',
                                                                                                                                                                                                                        left: {
                                                                                                                                                                                                                            type: 'BinaryExpression',
                                                                                                                                                                                                                            operator: '+',
                                                                                                                                                                                                                            left: {
                                                                                                                                                                                                                                type: 'BinaryExpression',
                                                                                                                                                                                                                                operator: '+',
                                                                                                                                                                                                                                left: {
                                                                                                                                                                                                                                    type: 'BinaryExpression',
                                                                                                                                                                                                                                    operator: '+',
                                                                                                                                                                                                                                    left: {
                                                                                                                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                                                                                                                        operator: '+',
                                                                                                                                                                                                                                        left: {
                                                                                                                                                                                                                                            type: 'BinaryExpression',
                                                                                                                                                                                                                                            operator: '+',
                                                                                                                                                                                                                                            left: {
                                                                                                                                                                                                                                                type: 'BinaryExpression',
                                                                                                                                                                                                                                                operator: '+',
                                                                                                                                                                                                                                                left: {
                                                                                                                                                                                                                                                    type: 'BinaryExpression',
                                                                                                                                                                                                                                                    operator: '+',
                                                                                                                                                                                                                                                    left: {
                                                                                                                                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                                                                                                                                        operator: '+',
                                                                                                                                                                                                                                                        left: {
                                                                                                                                                                                                                                                            type: 'BinaryExpression',
                                                                                                                                                                                                                                                            operator: '+',
                                                                                                                                                                                                                                                            left: {
                                                                                                                                                                                                                                                                type: 'BinaryExpression',
                                                                                                                                                                                                                                                                operator: '+',
                                                                                                                                                                                                                                                                left: {
                                                                                                                                                                                                                                                                    type: 'BinaryExpression',
                                                                                                                                                                                                                                                                    operator: '+',
                                                                                                                                                                                                                                                                    left: {
                                                                                                                                                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                                                                                                                                                        operator: '+',
                                                                                                                                                                                                                                                                        left: {
                                                                                                                                                                                                                                                                            type: 'BinaryExpression',
                                                                                                                                                                                                                                                                            operator: '+',
                                                                                                                                                                                                                                                                            left: {
                                                                                                                                                                                                                                                                                type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                operator: '+',
                                                                                                                                                                                                                                                                                left: {
                                                                                                                                                                                                                                                                                    type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                    operator: '+',
                                                                                                                                                                                                                                                                                    left: {
                                                                                                                                                                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                        operator: '+',
                                                                                                                                                                                                                                                                                        left: {
                                                                                                                                                                                                                                                                                            type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                            operator: '+',
                                                                                                                                                                                                                                                                                            left: {
                                                                                                                                                                                                                                                                                                type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                operator: '+',
                                                                                                                                                                                                                                                                                                left: {
                                                                                                                                                                                                                                                                                                    type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                    operator: '+',
                                                                                                                                                                                                                                                                                                    left: {
                                                                                                                                                                                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                        operator: '+',
                                                                                                                                                                                                                                                                                                        left: {
                                                                                                                                                                                                                                                                                                            type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                            operator: '+',
                                                                                                                                                                                                                                                                                                            left: {
                                                                                                                                                                                                                                                                                                                type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                operator: '+',
                                                                                                                                                                                                                                                                                                                left: {
                                                                                                                                                                                                                                                                                                                    type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                    operator: '+',
                                                                                                                                                                                                                                                                                                                    left: {
                                                                                                                                                                                                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                        operator: '+',
                                                                                                                                                                                                                                                                                                                        left: {
                                                                                                                                                                                                                                                                                                                            type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                            operator: '+',
                                                                                                                                                                                                                                                                                                                            left: {
                                                                                                                                                                                                                                                                                                                                type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                operator: '+',
                                                                                                                                                                                                                                                                                                                                left: {
                                                                                                                                                                                                                                                                                                                                    type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                    operator: '+',
                                                                                                                                                                                                                                                                                                                                    left: {
                                                                                                                                                                                                                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                        operator: '+',
                                                                                                                                                                                                                                                                                                                                        left: {
                                                                                                                                                                                                                                                                                                                                            type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                            operator: '+',
                                                                                                                                                                                                                                                                                                                                            left: {
                                                                                                                                                                                                                                                                                                                                                type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                operator: '+',
                                                                                                                                                                                                                                                                                                                                                left: {
                                                                                                                                                                                                                                                                                                                                                    type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                    operator: '+',
                                                                                                                                                                                                                                                                                                                                                    left: {
                                                                                                                                                                                                                                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                        operator: '+',
                                                                                                                                                                                                                                                                                                                                                        left: {
                                                                                                                                                                                                                                                                                                                                                            type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                            operator: '+',
                                                                                                                                                                                                                                                                                                                                                            left: {
                                                                                                                                                                                                                                                                                                                                                                type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                operator: '+',
                                                                                                                                                                                                                                                                                                                                                                left: {
                                                                                                                                                                                                                                                                                                                                                                    type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                    operator: '+',
                                                                                                                                                                                                                                                                                                                                                                    left: {
                                                                                                                                                                                                                                                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                        operator: '+',
                                                                                                                                                                                                                                                                                                                                                                        left: {
                                                                                                                                                                                                                                                                                                                                                                            type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                            operator: '+',
                                                                                                                                                                                                                                                                                                                                                                            left: {
                                                                                                                                                                                                                                                                                                                                                                                type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                                operator: '+',
                                                                                                                                                                                                                                                                                                                                                                                left: {
                                                                                                                                                                                                                                                                                                                                                                                    type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                                    operator: '+',
                                                                                                                                                                                                                                                                                                                                                                                    left: {
                                                                                                                                                                                                                                                                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                                        operator: '+',
                                                                                                                                                                                                                                                                                                                                                                                        left: {
                                                                                                                                                                                                                                                                                                                                                                                            type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                                            operator: '+',
                                                                                                                                                                                                                                                                                                                                                                                            left: {
                                                                                                                                                                                                                                                                                                                                                                                                type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                                                operator: '+',
                                                                                                                                                                                                                                                                                                                                                                                                left: {
                                                                                                                                                                                                                                                                                                                                                                                                    type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                                                    operator: '+',
                                                                                                                                                                                                                                                                                                                                                                                                    left: {
                                                                                                                                                                                                                                                                                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                                                        operator: '+',
                                                                                                                                                                                                                                                                                                                                                                                                        left: {
                                                                                                                                                                                                                                                                                                                                                                                                            type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                                                            operator: '+',
                                                                                                                                                                                                                                                                                                                                                                                                            left: {
                                                                                                                                                                                                                                                                                                                                                                                                                type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                                                                operator: '+',
                                                                                                                                                                                                                                                                                                                                                                                                                left: {
                                                                                                                                                                                                                                                                                                                                                                                                                    type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                                                                    operator: '+',
                                                                                                                                                                                                                                                                                                                                                                                                                    left: {
                                                                                                                                                                                                                                                                                                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                                                                        operator: '+',
                                                                                                                                                                                                                                                                                                                                                                                                                        left: {
                                                                                                                                                                                                                                                                                                                                                                                                                            type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                                                                            operator: '+',
                                                                                                                                                                                                                                                                                                                                                                                                                            left: {
                                                                                                                                                                                                                                                                                                                                                                                                                                type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                                                                                operator: '+',
                                                                                                                                                                                                                                                                                                                                                                                                                                left: {
                                                                                                                                                                                                                                                                                                                                                                                                                                    type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                                                                                    operator: '+',
                                                                                                                                                                                                                                                                                                                                                                                                                                    left: {
                                                                                                                                                                                                                                                                                                                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                                                                                        operator: '+',
                                                                                                                                                                                                                                                                                                                                                                                                                                        left: {
                                                                                                                                                                                                                                                                                                                                                                                                                                            type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                                                                                            operator: '+',
                                                                                                                                                                                                                                                                                                                                                                                                                                            left: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                                                                                                operator: '+',
                                                                                                                                                                                                                                                                                                                                                                                                                                                left: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                    type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                                                                                                    operator: '+',
                                                                                                                                                                                                                                                                                                                                                                                                                                                    left: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                                                                                                        operator: '+',
                                                                                                                                                                                                                                                                                                                                                                                                                                                        left: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                            type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                                                                                                            operator: '+',
                                                                                                                                                                                                                                                                                                                                                                                                                                                            left: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                operator: '+',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                left: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                    type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                    operator: '+',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                    left: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                        operator: '+',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                        left: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            operator: '+',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            left: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                operator: '+',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                left: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    operator: '+',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    left: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        operator: '+',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        left: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            operator: '+',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            left: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                operator: '+',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                left: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    operator: '+',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    left: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        operator: '+',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        left: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            operator: '+',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            left: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                operator: '+',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                left: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    operator: '+',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    left: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        operator: '+',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        left: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            operator: '+',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            left: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                operator: '+',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                left: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    operator: '+',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    left: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        operator: '+',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        left: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            operator: '+',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            left: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                type: 'Literal',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                value: '* {\n    box-sizing: border-box;\n    /* remove annoying flicker when clicking element on iOS */\n    -webkit-tap-highlight-color: '
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            right: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                name: 'black',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                loc: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    start: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        line: 89,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        column: 47,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    end: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        line: 89,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        column: 52,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        },
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        right: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            value: ';\n    -webkit-tap-highlight-color: transparent; /* For some Androids */\n    transition:\n        box-shadow 600ms cubic-bezier(0.77, 0, 0.175, 1);\n}\nBODY {\n    font-family: "Roboto", sans-serif;\n    font-smoothing: antialiased;\n    padding: 0;\n    margin: 0;\n    color: '
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    right: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        type: 'CallExpression',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        callee: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            name: 'rgba',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            loc: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                start: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    line: 99,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    column: 25,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                },
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                end: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    line: 99,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    column: 29,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        },
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        arguments: [
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                name: 'black',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                loc: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    start: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        line: 99,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        column: 30,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    end: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        line: 99,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        column: 35,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                name: 'text',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                loc: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    start: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        line: 99,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        column: 37,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    end: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        line: 99,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        column: 41,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        ],
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        loc: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            start: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                line: 99,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                column: 25,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            end: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                line: 99,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                column: 42,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                },
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                right: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    value: ';\n}\n\n/* new layout classes, based on https://www.polymer-project.org/docs/polymer/layout-attrs.html */\n\n/* layout items */\n.flex { flex: 1 1 auto; }\n.fixed { flex: 0 0 auto; }\n.fill { flex: 1 1 0; }\ntable.block {\n    width:100%;\n}\n/* layout containers */\n.layout { display: flex; }\n.layout.inline { display: inline-flex; }\n.layout.horizontal { flex-direction: row; }\n.layout.vertical { flex-direction: column; }\n.layout.horizontal.reverse { flex-direction: row-reverse; }\n.layout.vertical.reverse { flex-direction: column-reverse; }\n.layout.wrap { flex-wrap: wrap; }\n/* alignment in cross-axis */\n.layout.stretch { align-items: flex-stretch; }\n.layout.start { align-items: flex-start; }\n.layout.center { align-items: center; }\n.layout.end { align-items: flex-end; }\n/* alignment in main-axis */\n.layout.start-justified { justify-content: flex-start; }\n.layout.center-justified { justify-content: center; }\n.layout.end-justified { justify-content: flex-end; }\n.layout.around-justified { justify-content: space-around; }\n.layout.even-justified { justify-content: space-evenly; }\n.layout.justified { justify-content: space-between; }\n/* self alignment */\n.self-start { align-self: flex-start; }\n.self-center { align-self: center; }\n.self-end { align-self: flex-end; }\n.self-stretch { align-self: flex-stretch; }\n\n/* standard margin */\n.margin { margin: '
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            right: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                name: 'buffer',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                loc: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    start: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        line: 138,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        column: 32,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    end: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        line: 138,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        column: 38,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        },
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        right: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            value: 'px; }\n.margin-half { margin: '
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    right: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        operator: '/',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        left: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            name: 'buffer',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            loc: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                start: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    line: 139,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    column: 37,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                },
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                end: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    line: 139,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    column: 43,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        },
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        right: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            value: 2
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                },
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                right: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    value: 'px; }\n.margin-quarter { margin: '
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            right: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                operator: '/',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                left: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    name: 'buffer',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    loc: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        start: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            line: 140,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            column: 40,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        },
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        end: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            line: 140,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            column: 46,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                },
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                right: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    value: 4
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        },
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        right: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            value: 'px; }\n.margin-eighth { margin: '
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    right: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        operator: '/',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        left: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            name: 'buffer',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            loc: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                start: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    line: 141,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    column: 39,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                },
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                end: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    line: 141,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    column: 45,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        },
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        right: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            value: 8
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                },
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                right: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    value: 'px; }\n\n/* standard padding */\n.padding { padding: '
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            right: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                name: 'buffer',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                loc: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    start: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        line: 144,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        column: 34,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    end: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        line: 144,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        column: 40,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        },
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        right: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            value: 'px; }\n.padding-half { padding: '
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    right: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        operator: '/',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        left: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            name: 'buffer',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            loc: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                start: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    line: 145,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    column: 39,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                },
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                end: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    line: 145,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    column: 45,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        },
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        right: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            value: 2
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                },
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                right: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    value: 'px; }\n.padding-quarter { padding: '
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            right: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                operator: '/',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                left: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    name: 'buffer',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    loc: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        start: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            line: 146,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            column: 42,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        },
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        end: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            line: 146,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            column: 48,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                },
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                right: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    value: 4
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                        },
                                                                                                                                                                                                                                                                                                                                                                                                                                                                        right: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            value: 'px; }\n.padding-eighth { padding: '
                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                                                                                                                                                                                                                    right: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                        operator: '/',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                        left: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            name: 'buffer',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            loc: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                start: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    line: 147,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    column: 41,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                },
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                end: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    line: 147,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    column: 47,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                        },
                                                                                                                                                                                                                                                                                                                                                                                                                                                                        right: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            value: 8
                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                },
                                                                                                                                                                                                                                                                                                                                                                                                                                                                right: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                    value: 'px; }\n\n/* divider */\n.divider { opacity: '
                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                                                                                                                                                                                                                            right: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                name: 'divider',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                loc: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                    start: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                        line: 150,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                        column: 34,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                                                                                                                                                                                                                    end: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                        line: 150,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                        column: 41,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                        },
                                                                                                                                                                                                                                                                                                                                                                                                                                                        right: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                                                                                                                                                                                                                                                                                                            value: '; }\n\n/* scrolling */\n.scroll {overflow: auto; overflow-x: auto; overflow-y: scroll; overflow-scrolling: touch; }\n\n/* drop shadow items */\n.z1 { box-shadow: 0 1px 3px rgba(0,0,0,0.12), 0 1px 2px rgba(0,0,0,0.24); }\n.z2 { box-shadow: 0 3px 6px rgba(0,0,0,0.16), 0 3px 6px rgba(0,0,0,0.23); }\n.z3 { box-shadow: 0 10px 20px rgba(0,0,0,0.19), 0 6px 6px rgba(0,0,0,0.23); }\n.z4 { box-shadow: 0 14px 28px rgba(0,0,0,0.25), 0 10px 10px rgba(0,0,0,0.22); }\n.z5 { box-shadow: 0 19px 38px rgba(0,0,0,0.30), 0 15px 12px rgba(0,0,0,0.22); }\n\n/* card style */\n.card, .paper {\n    border-radius: 2px;\n    background-color: '
                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                                                                                                                                                                                                    right: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                                                                                                                                                                                                                                                                                                        name: 'white',
                                                                                                                                                                                                                                                                                                                                                                                                                                                        loc: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                            start: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                line: 165,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                column: 36,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                                                                                                                                                                                                                            end: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                line: 165,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                column: 41,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                },
                                                                                                                                                                                                                                                                                                                                                                                                                                                right: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                                                                                                                                                                                                                                                                                                    value: ';\n    display: inline-flex;\n    flex-direction: column;\n    margin: '
                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                                                                                                                                                                                                            right: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                type: 'BinaryExpression',
                                                                                                                                                                                                                                                                                                                                                                                                                                                operator: '/',
                                                                                                                                                                                                                                                                                                                                                                                                                                                left: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                                                                                                                                                                                                                                                                                                    name: 'buffer',
                                                                                                                                                                                                                                                                                                                                                                                                                                                    loc: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                        start: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                            line: 168,
                                                                                                                                                                                                                                                                                                                                                                                                                                                            column: 26,
                                                                                                                                                                                                                                                                                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                                                                            source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                                                                        },
                                                                                                                                                                                                                                                                                                                                                                                                                                                        end: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                            line: 168,
                                                                                                                                                                                                                                                                                                                                                                                                                                                            column: 32,
                                                                                                                                                                                                                                                                                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                                                                            source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                },
                                                                                                                                                                                                                                                                                                                                                                                                                                                right: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                                                                                                                                                                                                                                                                                                    value: 2
                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                        },
                                                                                                                                                                                                                                                                                                                                                                                                                                        right: {
                                                                                                                                                                                                                                                                                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                                                                                                                                                                                                                                                                                            value: 'px;\n}\n\n.paper {\n    border-radius: 0px;\n}\n\n/* bar style, like app-bar, pane-bar etc */\n.app-bar {\n    white-space: nowrap;\n    text-overflow: ellipsis;\n    color: '
                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                                                                                                                                                                                    right: {
                                                                                                                                                                                                                                                                                                                                                                                                                                        type: 'CallExpression',
                                                                                                                                                                                                                                                                                                                                                                                                                                        callee: {
                                                                                                                                                                                                                                                                                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                                                                                                                                                                                                                                                                                            name: 'rgba',
                                                                                                                                                                                                                                                                                                                                                                                                                                            loc: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                start: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                    line: 179,
                                                                                                                                                                                                                                                                                                                                                                                                                                                    column: 25,
                                                                                                                                                                                                                                                                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                                                                },
                                                                                                                                                                                                                                                                                                                                                                                                                                                end: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                    line: 179,
                                                                                                                                                                                                                                                                                                                                                                                                                                                    column: 29,
                                                                                                                                                                                                                                                                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                        },
                                                                                                                                                                                                                                                                                                                                                                                                                                        arguments: [
                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                                                                                                                                                                                                                                                                                name: 'white',
                                                                                                                                                                                                                                                                                                                                                                                                                                                loc: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                    start: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                        line: 179,
                                                                                                                                                                                                                                                                                                                                                                                                                                                        column: 30,
                                                                                                                                                                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                                                                                                                                                                                                    end: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                        line: 179,
                                                                                                                                                                                                                                                                                                                                                                                                                                                        column: 35,
                                                                                                                                                                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                                                                                                                                                                                                                                                                                name: 'text',
                                                                                                                                                                                                                                                                                                                                                                                                                                                loc: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                    start: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                        line: 179,
                                                                                                                                                                                                                                                                                                                                                                                                                                                        column: 37,
                                                                                                                                                                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                                                                                                                                                                                                    end: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                        line: 179,
                                                                                                                                                                                                                                                                                                                                                                                                                                                        column: 41,
                                                                                                                                                                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                        ],
                                                                                                                                                                                                                                                                                                                                                                                                                                        loc: {
                                                                                                                                                                                                                                                                                                                                                                                                                                            start: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                line: 179,
                                                                                                                                                                                                                                                                                                                                                                                                                                                column: 25,
                                                                                                                                                                                                                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                                                                                                                                                                                                            end: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                line: 179,
                                                                                                                                                                                                                                                                                                                                                                                                                                                column: 42,
                                                                                                                                                                                                                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                },
                                                                                                                                                                                                                                                                                                                                                                                                                                right: {
                                                                                                                                                                                                                                                                                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                                                                                                                                                                                                                                                                                    value: ';\n    display: flex;\n    flex-direction: row;\n    align-items: center;\n    padding: 4px 10px;\n    background-color: '
                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                                                                                                                                                                                            right: {
                                                                                                                                                                                                                                                                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                                                                                                                                                                                                                                                                name: 'primary',
                                                                                                                                                                                                                                                                                                                                                                                                                                loc: {
                                                                                                                                                                                                                                                                                                                                                                                                                                    start: {
                                                                                                                                                                                                                                                                                                                                                                                                                                        line: 184,
                                                                                                                                                                                                                                                                                                                                                                                                                                        column: 36,
                                                                                                                                                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                                                                                                                                                                                    end: {
                                                                                                                                                                                                                                                                                                                                                                                                                                        line: 184,
                                                                                                                                                                                                                                                                                                                                                                                                                                        column: 43,
                                                                                                                                                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                        },
                                                                                                                                                                                                                                                                                                                                                                                                                        right: {
                                                                                                                                                                                                                                                                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                                                                                                                                                                                                                                                                            value: ';\n    font-size: 16px;\n    height: '
                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                                                                                                                                                                    right: {
                                                                                                                                                                                                                                                                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                                                                                                                                                                                                                                                                        name: 'appBarHeight',
                                                                                                                                                                                                                                                                                                                                                                                                                        loc: {
                                                                                                                                                                                                                                                                                                                                                                                                                            start: {
                                                                                                                                                                                                                                                                                                                                                                                                                                line: 186,
                                                                                                                                                                                                                                                                                                                                                                                                                                column: 26,
                                                                                                                                                                                                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                                                                                                                                                                                            end: {
                                                                                                                                                                                                                                                                                                                                                                                                                                line: 186,
                                                                                                                                                                                                                                                                                                                                                                                                                                column: 38,
                                                                                                                                                                                                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                },
                                                                                                                                                                                                                                                                                                                                                                                                                right: {
                                                                                                                                                                                                                                                                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                                                                                                                                                                                                                                                                    value: 'px;\n    flex-basis: '
                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                                                                                                                                                                            right: {
                                                                                                                                                                                                                                                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                                                                                                                                                                                                                                                name: 'appBarHeight',
                                                                                                                                                                                                                                                                                                                                                                                                                loc: {
                                                                                                                                                                                                                                                                                                                                                                                                                    start: {
                                                                                                                                                                                                                                                                                                                                                                                                                        line: 187,
                                                                                                                                                                                                                                                                                                                                                                                                                        column: 30,
                                                                                                                                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                                                                                                                                                                    end: {
                                                                                                                                                                                                                                                                                                                                                                                                                        line: 187,
                                                                                                                                                                                                                                                                                                                                                                                                                        column: 42,
                                                                                                                                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                        },
                                                                                                                                                                                                                                                                                                                                                                                                        right: {
                                                                                                                                                                                                                                                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                                                                                                                                                                                                                                                            value: 'px;\n    flex-grow:0;\n    flex-shrink:0;\n    max-width: 100vw;\n}\n\n/* content section with scrolling and padding */\n.content {\n    padding: '
                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                                                                                                                                                    right: {
                                                                                                                                                                                                                                                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                                                                                                                                                                                                                                                        name: 'buffer',
                                                                                                                                                                                                                                                                                                                                                                                                        loc: {
                                                                                                                                                                                                                                                                                                                                                                                                            start: {
                                                                                                                                                                                                                                                                                                                                                                                                                line: 195,
                                                                                                                                                                                                                                                                                                                                                                                                                column: 27,
                                                                                                                                                                                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                                                                                                                                                                            end: {
                                                                                                                                                                                                                                                                                                                                                                                                                line: 195,
                                                                                                                                                                                                                                                                                                                                                                                                                column: 33,
                                                                                                                                                                                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                },
                                                                                                                                                                                                                                                                                                                                                                                                right: {
                                                                                                                                                                                                                                                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                                                                                                                                                                                                                                                    value: 'px;\n    overflow: auto;\n}\n\n/* standard transitions */\n.transition {\n    transition:\n        opacity 400ms cubic-bezier(0.77, 0, 0.175, 1),\n        transform 400ms cubic-bezier(0.77, 0, 0.175, 1),\n        left 400ms cubic-bezier(0.77, 0, 0.175, 1),\n        top 400ms cubic-bezier(0.77, 0, 0.175, 1),\n        width 400ms cubic-bezier(0.77, 0, 0.175, 1),\n        height 400ms cubic-bezier(0.77, 0, 0.175, 1),\n        box-shadow 600ms cubic-bezier(0.77, 0, 0.175, 1);\n}\n\n/* grabbable */\n.grab {\n    cursor: grab;\n    cursor: -webkit-grab;\n}\n.grabbing {\n    cursor: grabbing;\n    cursor: -webkit-grabbing;\n}\n.no-drop {\n    cursor: no-drop;\n}\n\n/* background colors */\n.background-white { background-color: '
                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                                                                                                                                                            right: {
                                                                                                                                                                                                                                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                                                                                                                                                                                                                                name: 'white',
                                                                                                                                                                                                                                                                                                                                                                                                loc: {
                                                                                                                                                                                                                                                                                                                                                                                                    start: {
                                                                                                                                                                                                                                                                                                                                                                                                        line: 225,
                                                                                                                                                                                                                                                                                                                                                                                                        column: 52,
                                                                                                                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                                                                                                                                                    end: {
                                                                                                                                                                                                                                                                                                                                                                                                        line: 225,
                                                                                                                                                                                                                                                                                                                                                                                                        column: 57,
                                                                                                                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                        },
                                                                                                                                                                                                                                                                                                                                                                                        right: {
                                                                                                                                                                                                                                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                                                                                                                                                                                                                                            value: '; color: '
                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                                                                                                                                    right: {
                                                                                                                                                                                                                                                                                                                                                                                        type: 'CallExpression',
                                                                                                                                                                                                                                                                                                                                                                                        callee: {
                                                                                                                                                                                                                                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                                                                                                                                                                                                                                            name: 'rgba',
                                                                                                                                                                                                                                                                                                                                                                                            loc: {
                                                                                                                                                                                                                                                                                                                                                                                                start: {
                                                                                                                                                                                                                                                                                                                                                                                                    line: 225,
                                                                                                                                                                                                                                                                                                                                                                                                    column: 70,
                                                                                                                                                                                                                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                },
                                                                                                                                                                                                                                                                                                                                                                                                end: {
                                                                                                                                                                                                                                                                                                                                                                                                    line: 225,
                                                                                                                                                                                                                                                                                                                                                                                                    column: 74,
                                                                                                                                                                                                                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                        },
                                                                                                                                                                                                                                                                                                                                                                                        arguments: [
                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                                                                                                                                                                                                                                name: 'black',
                                                                                                                                                                                                                                                                                                                                                                                                loc: {
                                                                                                                                                                                                                                                                                                                                                                                                    start: {
                                                                                                                                                                                                                                                                                                                                                                                                        line: 225,
                                                                                                                                                                                                                                                                                                                                                                                                        column: 75,
                                                                                                                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                                                                                                                                                    end: {
                                                                                                                                                                                                                                                                                                                                                                                                        line: 225,
                                                                                                                                                                                                                                                                                                                                                                                                        column: 80,
                                                                                                                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                                                                                                                                                                                                                                name: 'text',
                                                                                                                                                                                                                                                                                                                                                                                                loc: {
                                                                                                                                                                                                                                                                                                                                                                                                    start: {
                                                                                                                                                                                                                                                                                                                                                                                                        line: 225,
                                                                                                                                                                                                                                                                                                                                                                                                        column: 82,
                                                                                                                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                                                                                                                                                    end: {
                                                                                                                                                                                                                                                                                                                                                                                                        line: 225,
                                                                                                                                                                                                                                                                                                                                                                                                        column: 86,
                                                                                                                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                        ],
                                                                                                                                                                                                                                                                                                                                                                                        loc: {
                                                                                                                                                                                                                                                                                                                                                                                            start: {
                                                                                                                                                                                                                                                                                                                                                                                                line: 225,
                                                                                                                                                                                                                                                                                                                                                                                                column: 70,
                                                                                                                                                                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                                                                                                                                                            end: {
                                                                                                                                                                                                                                                                                                                                                                                                line: 225,
                                                                                                                                                                                                                                                                                                                                                                                                column: 87,
                                                                                                                                                                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                },
                                                                                                                                                                                                                                                                                                                                                                                right: {
                                                                                                                                                                                                                                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                                                                                                                                                                                                                                    value: '; }\n.background-black { background-color: '
                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                                                                                                                                            right: {
                                                                                                                                                                                                                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                                                                                                                                                                                                                name: 'black',
                                                                                                                                                                                                                                                                                                                                                                                loc: {
                                                                                                                                                                                                                                                                                                                                                                                    start: {
                                                                                                                                                                                                                                                                                                                                                                                        line: 226,
                                                                                                                                                                                                                                                                                                                                                                                        column: 52,
                                                                                                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                                                                                                                                    end: {
                                                                                                                                                                                                                                                                                                                                                                                        line: 226,
                                                                                                                                                                                                                                                                                                                                                                                        column: 57,
                                                                                                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                        },
                                                                                                                                                                                                                                                                                                                                                                        right: {
                                                                                                                                                                                                                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                                                                                                                                                                                                                            value: '; color: '
                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                                                                                                                    right: {
                                                                                                                                                                                                                                                                                                                                                                        type: 'CallExpression',
                                                                                                                                                                                                                                                                                                                                                                        callee: {
                                                                                                                                                                                                                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                                                                                                                                                                                                                            name: 'rgba',
                                                                                                                                                                                                                                                                                                                                                                            loc: {
                                                                                                                                                                                                                                                                                                                                                                                start: {
                                                                                                                                                                                                                                                                                                                                                                                    line: 226,
                                                                                                                                                                                                                                                                                                                                                                                    column: 70,
                                                                                                                                                                                                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                },
                                                                                                                                                                                                                                                                                                                                                                                end: {
                                                                                                                                                                                                                                                                                                                                                                                    line: 226,
                                                                                                                                                                                                                                                                                                                                                                                    column: 74,
                                                                                                                                                                                                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                        },
                                                                                                                                                                                                                                                                                                                                                                        arguments: [
                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                                                                                                                                                                                                                name: 'white',
                                                                                                                                                                                                                                                                                                                                                                                loc: {
                                                                                                                                                                                                                                                                                                                                                                                    start: {
                                                                                                                                                                                                                                                                                                                                                                                        line: 226,
                                                                                                                                                                                                                                                                                                                                                                                        column: 75,
                                                                                                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                                                                                                                                    end: {
                                                                                                                                                                                                                                                                                                                                                                                        line: 226,
                                                                                                                                                                                                                                                                                                                                                                                        column: 80,
                                                                                                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                                                                                                                                                                                                                name: 'text',
                                                                                                                                                                                                                                                                                                                                                                                loc: {
                                                                                                                                                                                                                                                                                                                                                                                    start: {
                                                                                                                                                                                                                                                                                                                                                                                        line: 226,
                                                                                                                                                                                                                                                                                                                                                                                        column: 82,
                                                                                                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                                                                                                                                    end: {
                                                                                                                                                                                                                                                                                                                                                                                        line: 226,
                                                                                                                                                                                                                                                                                                                                                                                        column: 86,
                                                                                                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                        ],
                                                                                                                                                                                                                                                                                                                                                                        loc: {
                                                                                                                                                                                                                                                                                                                                                                            start: {
                                                                                                                                                                                                                                                                                                                                                                                line: 226,
                                                                                                                                                                                                                                                                                                                                                                                column: 70,
                                                                                                                                                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                                                                                                                                            end: {
                                                                                                                                                                                                                                                                                                                                                                                line: 226,
                                                                                                                                                                                                                                                                                                                                                                                column: 87,
                                                                                                                                                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                },
                                                                                                                                                                                                                                                                                                                                                                right: {
                                                                                                                                                                                                                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                                                                                                                                                                                                                    value: '; }\n.background-primary { background-color: '
                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                                                                                                                            right: {
                                                                                                                                                                                                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                                                                                                                                                                                                name: 'primary',
                                                                                                                                                                                                                                                                                                                                                                loc: {
                                                                                                                                                                                                                                                                                                                                                                    start: {
                                                                                                                                                                                                                                                                                                                                                                        line: 227,
                                                                                                                                                                                                                                                                                                                                                                        column: 54,
                                                                                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                                                                                                                    end: {
                                                                                                                                                                                                                                                                                                                                                                        line: 227,
                                                                                                                                                                                                                                                                                                                                                                        column: 61,
                                                                                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                        },
                                                                                                                                                                                                                                                                                                                                                        right: {
                                                                                                                                                                                                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                                                                                                                                                                                                            value: '; }\n.background-primary-lighter { background-color: '
                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                                                                                                    right: {
                                                                                                                                                                                                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                                                                                                                                                                                                        name: 'primaryLighter',
                                                                                                                                                                                                                                                                                                                                                        loc: {
                                                                                                                                                                                                                                                                                                                                                            start: {
                                                                                                                                                                                                                                                                                                                                                                line: 228,
                                                                                                                                                                                                                                                                                                                                                                column: 62,
                                                                                                                                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                                                                                                                            end: {
                                                                                                                                                                                                                                                                                                                                                                line: 228,
                                                                                                                                                                                                                                                                                                                                                                column: 76,
                                                                                                                                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                },
                                                                                                                                                                                                                                                                                                                                                right: {
                                                                                                                                                                                                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                                                                                                                                                                                                    value: '; }\n.background-primary-darker { background-color: '
                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                                                                                                            right: {
                                                                                                                                                                                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                                                                                                                                                                                name: 'primaryDarker',
                                                                                                                                                                                                                                                                                                                                                loc: {
                                                                                                                                                                                                                                                                                                                                                    start: {
                                                                                                                                                                                                                                                                                                                                                        line: 229,
                                                                                                                                                                                                                                                                                                                                                        column: 61,
                                                                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                                                                                                    end: {
                                                                                                                                                                                                                                                                                                                                                        line: 229,
                                                                                                                                                                                                                                                                                                                                                        column: 74,
                                                                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                        },
                                                                                                                                                                                                                                                                                                                                        right: {
                                                                                                                                                                                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                                                                                                                                                                                            value: '; }\n.background-accent { background-color: '
                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                                                                                    right: {
                                                                                                                                                                                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                                                                                                                                                                                        name: 'accent',
                                                                                                                                                                                                                                                                                                                                        loc: {
                                                                                                                                                                                                                                                                                                                                            start: {
                                                                                                                                                                                                                                                                                                                                                line: 230,
                                                                                                                                                                                                                                                                                                                                                column: 53,
                                                                                                                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                                                                                                            end: {
                                                                                                                                                                                                                                                                                                                                                line: 230,
                                                                                                                                                                                                                                                                                                                                                column: 59,
                                                                                                                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                },
                                                                                                                                                                                                                                                                                                                                right: {
                                                                                                                                                                                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                                                                                                                                                                                    value: '; }\n.background-accent-lighter- { background-color: '
                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                                                                                            right: {
                                                                                                                                                                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                                                                                                                                                                name: 'accentLighter',
                                                                                                                                                                                                                                                                                                                                loc: {
                                                                                                                                                                                                                                                                                                                                    start: {
                                                                                                                                                                                                                                                                                                                                        line: 231,
                                                                                                                                                                                                                                                                                                                                        column: 62,
                                                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                                                                                    end: {
                                                                                                                                                                                                                                                                                                                                        line: 231,
                                                                                                                                                                                                                                                                                                                                        column: 75,
                                                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                        },
                                                                                                                                                                                                                                                                                                                        right: {
                                                                                                                                                                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                                                                                                                                                                            value: '; }\n.background-accent-darker { background-color: '
                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                                                                    right: {
                                                                                                                                                                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                                                                                                                                                                        name: 'accentDarker',
                                                                                                                                                                                                                                                                                                                        loc: {
                                                                                                                                                                                                                                                                                                                            start: {
                                                                                                                                                                                                                                                                                                                                line: 232,
                                                                                                                                                                                                                                                                                                                                column: 60,
                                                                                                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                                                                                            end: {
                                                                                                                                                                                                                                                                                                                                line: 232,
                                                                                                                                                                                                                                                                                                                                column: 72,
                                                                                                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                },
                                                                                                                                                                                                                                                                                                                right: {
                                                                                                                                                                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                                                                                                                                                                    value: '; }\n.background-black-divider { background-color: '
                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                                                                            right: {
                                                                                                                                                                                                                                                                                                                type: 'CallExpression',
                                                                                                                                                                                                                                                                                                                callee: {
                                                                                                                                                                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                                                                                                                                                                    name: 'rgba',
                                                                                                                                                                                                                                                                                                                    loc: {
                                                                                                                                                                                                                                                                                                                        start: {
                                                                                                                                                                                                                                                                                                                            line: 233,
                                                                                                                                                                                                                                                                                                                            column: 60,
                                                                                                                                                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                                                                                                                                                            source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                        },
                                                                                                                                                                                                                                                                                                                        end: {
                                                                                                                                                                                                                                                                                                                            line: 233,
                                                                                                                                                                                                                                                                                                                            column: 64,
                                                                                                                                                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                                                                                                                                                            source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                },
                                                                                                                                                                                                                                                                                                                arguments: [
                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                                                                                                                                                                        name: 'black',
                                                                                                                                                                                                                                                                                                                        loc: {
                                                                                                                                                                                                                                                                                                                            start: {
                                                                                                                                                                                                                                                                                                                                line: 233,
                                                                                                                                                                                                                                                                                                                                column: 65,
                                                                                                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                                                                                            end: {
                                                                                                                                                                                                                                                                                                                                line: 233,
                                                                                                                                                                                                                                                                                                                                column: 70,
                                                                                                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                                                                                                                                                                        name: 'divider',
                                                                                                                                                                                                                                                                                                                        loc: {
                                                                                                                                                                                                                                                                                                                            start: {
                                                                                                                                                                                                                                                                                                                                line: 233,
                                                                                                                                                                                                                                                                                                                                column: 72,
                                                                                                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                                                                                            end: {
                                                                                                                                                                                                                                                                                                                                line: 233,
                                                                                                                                                                                                                                                                                                                                column: 79,
                                                                                                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                ],
                                                                                                                                                                                                                                                                                                                loc: {
                                                                                                                                                                                                                                                                                                                    start: {
                                                                                                                                                                                                                                                                                                                        line: 233,
                                                                                                                                                                                                                                                                                                                        column: 60,
                                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                                                                    end: {
                                                                                                                                                                                                                                                                                                                        line: 233,
                                                                                                                                                                                                                                                                                                                        column: 80,
                                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                        },
                                                                                                                                                                                                                                                                                                        right: {
                                                                                                                                                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                                                                                                                                                            value: '; }\n.background-white-divider { background-color: '
                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                                                    right: {
                                                                                                                                                                                                                                                                                                        type: 'CallExpression',
                                                                                                                                                                                                                                                                                                        callee: {
                                                                                                                                                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                                                                                                                                                            name: 'rgba',
                                                                                                                                                                                                                                                                                                            loc: {
                                                                                                                                                                                                                                                                                                                start: {
                                                                                                                                                                                                                                                                                                                    line: 234,
                                                                                                                                                                                                                                                                                                                    column: 60,
                                                                                                                                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                                                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                },
                                                                                                                                                                                                                                                                                                                end: {
                                                                                                                                                                                                                                                                                                                    line: 234,
                                                                                                                                                                                                                                                                                                                    column: 64,
                                                                                                                                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                                                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                        },
                                                                                                                                                                                                                                                                                                        arguments: [
                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                                                                                                                                                name: 'white',
                                                                                                                                                                                                                                                                                                                loc: {
                                                                                                                                                                                                                                                                                                                    start: {
                                                                                                                                                                                                                                                                                                                        line: 234,
                                                                                                                                                                                                                                                                                                                        column: 65,
                                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                                                                    end: {
                                                                                                                                                                                                                                                                                                                        line: 234,
                                                                                                                                                                                                                                                                                                                        column: 70,
                                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                                                                                                                                                name: 'divider',
                                                                                                                                                                                                                                                                                                                loc: {
                                                                                                                                                                                                                                                                                                                    start: {
                                                                                                                                                                                                                                                                                                                        line: 234,
                                                                                                                                                                                                                                                                                                                        column: 72,
                                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                                                                    end: {
                                                                                                                                                                                                                                                                                                                        line: 234,
                                                                                                                                                                                                                                                                                                                        column: 79,
                                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                        ],
                                                                                                                                                                                                                                                                                                        loc: {
                                                                                                                                                                                                                                                                                                            start: {
                                                                                                                                                                                                                                                                                                                line: 234,
                                                                                                                                                                                                                                                                                                                column: 60,
                                                                                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                                                                            end: {
                                                                                                                                                                                                                                                                                                                line: 234,
                                                                                                                                                                                                                                                                                                                column: 80,
                                                                                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                },
                                                                                                                                                                                                                                                                                                right: {
                                                                                                                                                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                                                                                                                                                    value: '; }\n.background-none { background-color: transparent; }\n\n/* foreground colors */\n.white { color: '
                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                                                            right: {
                                                                                                                                                                                                                                                                                                type: 'CallExpression',
                                                                                                                                                                                                                                                                                                callee: {
                                                                                                                                                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                                                                                                                                                    name: 'rgba',
                                                                                                                                                                                                                                                                                                    loc: {
                                                                                                                                                                                                                                                                                                        start: {
                                                                                                                                                                                                                                                                                                            line: 238,
                                                                                                                                                                                                                                                                                                            column: 30,
                                                                                                                                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                                                                                                                                            source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                        },
                                                                                                                                                                                                                                                                                                        end: {
                                                                                                                                                                                                                                                                                                            line: 238,
                                                                                                                                                                                                                                                                                                            column: 34,
                                                                                                                                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                                                                                                                                            source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                },
                                                                                                                                                                                                                                                                                                arguments: [
                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                                                                                                                                                        name: 'white',
                                                                                                                                                                                                                                                                                                        loc: {
                                                                                                                                                                                                                                                                                                            start: {
                                                                                                                                                                                                                                                                                                                line: 238,
                                                                                                                                                                                                                                                                                                                column: 35,
                                                                                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                                                                            end: {
                                                                                                                                                                                                                                                                                                                line: 238,
                                                                                                                                                                                                                                                                                                                column: 40,
                                                                                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                        type: 'Literal',
                                                                                                                                                                                                                                                                                                        value: 1
                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                ],
                                                                                                                                                                                                                                                                                                loc: {
                                                                                                                                                                                                                                                                                                    start: {
                                                                                                                                                                                                                                                                                                        line: 238,
                                                                                                                                                                                                                                                                                                        column: 30,
                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                                                    end: {
                                                                                                                                                                                                                                                                                                        line: 238,
                                                                                                                                                                                                                                                                                                        column: 44,
                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                        },
                                                                                                                                                                                                                                                                                        right: {
                                                                                                                                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                                                                                                                                            value: '; }\n.white.secondary { color: '
                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                                    right: {
                                                                                                                                                                                                                                                                                        type: 'CallExpression',
                                                                                                                                                                                                                                                                                        callee: {
                                                                                                                                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                                                                                                                                            name: 'rgba',
                                                                                                                                                                                                                                                                                            loc: {
                                                                                                                                                                                                                                                                                                start: {
                                                                                                                                                                                                                                                                                                    line: 239,
                                                                                                                                                                                                                                                                                                    column: 40,
                                                                                                                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                },
                                                                                                                                                                                                                                                                                                end: {
                                                                                                                                                                                                                                                                                                    line: 239,
                                                                                                                                                                                                                                                                                                    column: 44,
                                                                                                                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                        },
                                                                                                                                                                                                                                                                                        arguments: [
                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                                                                                                                                name: 'white',
                                                                                                                                                                                                                                                                                                loc: {
                                                                                                                                                                                                                                                                                                    start: {
                                                                                                                                                                                                                                                                                                        line: 239,
                                                                                                                                                                                                                                                                                                        column: 45,
                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                                                    end: {
                                                                                                                                                                                                                                                                                                        line: 239,
                                                                                                                                                                                                                                                                                                        column: 50,
                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                                                                                                                                name: 'secondary',
                                                                                                                                                                                                                                                                                                loc: {
                                                                                                                                                                                                                                                                                                    start: {
                                                                                                                                                                                                                                                                                                        line: 239,
                                                                                                                                                                                                                                                                                                        column: 52,
                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                                                    end: {
                                                                                                                                                                                                                                                                                                        line: 239,
                                                                                                                                                                                                                                                                                                        column: 61,
                                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                        ],
                                                                                                                                                                                                                                                                                        loc: {
                                                                                                                                                                                                                                                                                            start: {
                                                                                                                                                                                                                                                                                                line: 239,
                                                                                                                                                                                                                                                                                                column: 40,
                                                                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                                                            end: {
                                                                                                                                                                                                                                                                                                line: 239,
                                                                                                                                                                                                                                                                                                column: 62,
                                                                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                },
                                                                                                                                                                                                                                                                                right: {
                                                                                                                                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                                                                                                                                    value: '; }\n.white.hint { color: '
                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                                            right: {
                                                                                                                                                                                                                                                                                type: 'CallExpression',
                                                                                                                                                                                                                                                                                callee: {
                                                                                                                                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                                                                                                                                    name: 'rgba',
                                                                                                                                                                                                                                                                                    loc: {
                                                                                                                                                                                                                                                                                        start: {
                                                                                                                                                                                                                                                                                            line: 240,
                                                                                                                                                                                                                                                                                            column: 35,
                                                                                                                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                                                                                                                            source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                        },
                                                                                                                                                                                                                                                                                        end: {
                                                                                                                                                                                                                                                                                            line: 240,
                                                                                                                                                                                                                                                                                            column: 39,
                                                                                                                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                                                                                                                            source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                },
                                                                                                                                                                                                                                                                                arguments: [
                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                                                                                                                                        name: 'white',
                                                                                                                                                                                                                                                                                        loc: {
                                                                                                                                                                                                                                                                                            start: {
                                                                                                                                                                                                                                                                                                line: 240,
                                                                                                                                                                                                                                                                                                column: 40,
                                                                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                                                            end: {
                                                                                                                                                                                                                                                                                                line: 240,
                                                                                                                                                                                                                                                                                                column: 45,
                                                                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                                                                                                                                        name: 'hint',
                                                                                                                                                                                                                                                                                        loc: {
                                                                                                                                                                                                                                                                                            start: {
                                                                                                                                                                                                                                                                                                line: 240,
                                                                                                                                                                                                                                                                                                column: 47,
                                                                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                                                            end: {
                                                                                                                                                                                                                                                                                                line: 240,
                                                                                                                                                                                                                                                                                                column: 51,
                                                                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                ],
                                                                                                                                                                                                                                                                                loc: {
                                                                                                                                                                                                                                                                                    start: {
                                                                                                                                                                                                                                                                                        line: 240,
                                                                                                                                                                                                                                                                                        column: 35,
                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                                    end: {
                                                                                                                                                                                                                                                                                        line: 240,
                                                                                                                                                                                                                                                                                        column: 52,
                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                        },
                                                                                                                                                                                                                                                                        right: {
                                                                                                                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                                                                                                                            value: '; }\n\n.black { color: '
                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                    right: {
                                                                                                                                                                                                                                                                        type: 'CallExpression',
                                                                                                                                                                                                                                                                        callee: {
                                                                                                                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                                                                                                                            name: 'rgba',
                                                                                                                                                                                                                                                                            loc: {
                                                                                                                                                                                                                                                                                start: {
                                                                                                                                                                                                                                                                                    line: 242,
                                                                                                                                                                                                                                                                                    column: 30,
                                                                                                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                },
                                                                                                                                                                                                                                                                                end: {
                                                                                                                                                                                                                                                                                    line: 242,
                                                                                                                                                                                                                                                                                    column: 34,
                                                                                                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                        },
                                                                                                                                                                                                                                                                        arguments: [
                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                                                                                                                name: 'black',
                                                                                                                                                                                                                                                                                loc: {
                                                                                                                                                                                                                                                                                    start: {
                                                                                                                                                                                                                                                                                        line: 242,
                                                                                                                                                                                                                                                                                        column: 35,
                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                                    end: {
                                                                                                                                                                                                                                                                                        line: 242,
                                                                                                                                                                                                                                                                                        column: 40,
                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                                                                                                                name: 'text',
                                                                                                                                                                                                                                                                                loc: {
                                                                                                                                                                                                                                                                                    start: {
                                                                                                                                                                                                                                                                                        line: 242,
                                                                                                                                                                                                                                                                                        column: 42,
                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                                    end: {
                                                                                                                                                                                                                                                                                        line: 242,
                                                                                                                                                                                                                                                                                        column: 46,
                                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                        ],
                                                                                                                                                                                                                                                                        loc: {
                                                                                                                                                                                                                                                                            start: {
                                                                                                                                                                                                                                                                                line: 242,
                                                                                                                                                                                                                                                                                column: 30,
                                                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                                            end: {
                                                                                                                                                                                                                                                                                line: 242,
                                                                                                                                                                                                                                                                                column: 47,
                                                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                },
                                                                                                                                                                                                                                                                right: {
                                                                                                                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                                                                                                                    value: '; }\n.black.secondary, .secondary { color: '
                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                            right: {
                                                                                                                                                                                                                                                                type: 'CallExpression',
                                                                                                                                                                                                                                                                callee: {
                                                                                                                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                                                                                                                    name: 'rgba',
                                                                                                                                                                                                                                                                    loc: {
                                                                                                                                                                                                                                                                        start: {
                                                                                                                                                                                                                                                                            line: 243,
                                                                                                                                                                                                                                                                            column: 52,
                                                                                                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                                                                                                            source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                        },
                                                                                                                                                                                                                                                                        end: {
                                                                                                                                                                                                                                                                            line: 243,
                                                                                                                                                                                                                                                                            column: 56,
                                                                                                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                                                                                                            source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                },
                                                                                                                                                                                                                                                                arguments: [
                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                                                                                                                        name: 'black',
                                                                                                                                                                                                                                                                        loc: {
                                                                                                                                                                                                                                                                            start: {
                                                                                                                                                                                                                                                                                line: 243,
                                                                                                                                                                                                                                                                                column: 57,
                                                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                                            end: {
                                                                                                                                                                                                                                                                                line: 243,
                                                                                                                                                                                                                                                                                column: 62,
                                                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                                                                                                                        name: 'secondary',
                                                                                                                                                                                                                                                                        loc: {
                                                                                                                                                                                                                                                                            start: {
                                                                                                                                                                                                                                                                                line: 243,
                                                                                                                                                                                                                                                                                column: 64,
                                                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                                            end: {
                                                                                                                                                                                                                                                                                line: 243,
                                                                                                                                                                                                                                                                                column: 73,
                                                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                ],
                                                                                                                                                                                                                                                                loc: {
                                                                                                                                                                                                                                                                    start: {
                                                                                                                                                                                                                                                                        line: 243,
                                                                                                                                                                                                                                                                        column: 52,
                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                    end: {
                                                                                                                                                                                                                                                                        line: 243,
                                                                                                                                                                                                                                                                        column: 74,
                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                        },
                                                                                                                                                                                                                                                        right: {
                                                                                                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                                                                                                            value: '; }\n.black.hint, .hint { color: '
                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                    right: {
                                                                                                                                                                                                                                                        type: 'CallExpression',
                                                                                                                                                                                                                                                        callee: {
                                                                                                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                                                                                                            name: 'rgba',
                                                                                                                                                                                                                                                            loc: {
                                                                                                                                                                                                                                                                start: {
                                                                                                                                                                                                                                                                    line: 244,
                                                                                                                                                                                                                                                                    column: 42,
                                                                                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                },
                                                                                                                                                                                                                                                                end: {
                                                                                                                                                                                                                                                                    line: 244,
                                                                                                                                                                                                                                                                    column: 46,
                                                                                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                        },
                                                                                                                                                                                                                                                        arguments: [
                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                                                                                                name: 'black',
                                                                                                                                                                                                                                                                loc: {
                                                                                                                                                                                                                                                                    start: {
                                                                                                                                                                                                                                                                        line: 244,
                                                                                                                                                                                                                                                                        column: 47,
                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                    end: {
                                                                                                                                                                                                                                                                        line: 244,
                                                                                                                                                                                                                                                                        column: 52,
                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                                                                                                name: 'hint',
                                                                                                                                                                                                                                                                loc: {
                                                                                                                                                                                                                                                                    start: {
                                                                                                                                                                                                                                                                        line: 244,
                                                                                                                                                                                                                                                                        column: 54,
                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                                    end: {
                                                                                                                                                                                                                                                                        line: 244,
                                                                                                                                                                                                                                                                        column: 58,
                                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                        ],
                                                                                                                                                                                                                                                        loc: {
                                                                                                                                                                                                                                                            start: {
                                                                                                                                                                                                                                                                line: 244,
                                                                                                                                                                                                                                                                column: 42,
                                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                            end: {
                                                                                                                                                                                                                                                                line: 244,
                                                                                                                                                                                                                                                                column: 59,
                                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                },
                                                                                                                                                                                                                                                right: {
                                                                                                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                                                                                                    value: '; }\n\n.primary { color: '
                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                            right: {
                                                                                                                                                                                                                                                type: 'CallExpression',
                                                                                                                                                                                                                                                callee: {
                                                                                                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                                                                                                    name: 'rgba',
                                                                                                                                                                                                                                                    loc: {
                                                                                                                                                                                                                                                        start: {
                                                                                                                                                                                                                                                            line: 246,
                                                                                                                                                                                                                                                            column: 32,
                                                                                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                                                                                            source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                        },
                                                                                                                                                                                                                                                        end: {
                                                                                                                                                                                                                                                            line: 246,
                                                                                                                                                                                                                                                            column: 36,
                                                                                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                                                                                            source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                },
                                                                                                                                                                                                                                                arguments: [
                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                                                                                                        name: 'primary',
                                                                                                                                                                                                                                                        loc: {
                                                                                                                                                                                                                                                            start: {
                                                                                                                                                                                                                                                                line: 246,
                                                                                                                                                                                                                                                                column: 37,
                                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                            end: {
                                                                                                                                                                                                                                                                line: 246,
                                                                                                                                                                                                                                                                column: 44,
                                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                                                                                                        name: 'text',
                                                                                                                                                                                                                                                        loc: {
                                                                                                                                                                                                                                                            start: {
                                                                                                                                                                                                                                                                line: 246,
                                                                                                                                                                                                                                                                column: 46,
                                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                                            end: {
                                                                                                                                                                                                                                                                line: 246,
                                                                                                                                                                                                                                                                column: 50,
                                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                ],
                                                                                                                                                                                                                                                loc: {
                                                                                                                                                                                                                                                    start: {
                                                                                                                                                                                                                                                        line: 246,
                                                                                                                                                                                                                                                        column: 32,
                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                    end: {
                                                                                                                                                                                                                                                        line: 246,
                                                                                                                                                                                                                                                        column: 51,
                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                        },
                                                                                                                                                                                                                                        right: {
                                                                                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                                                                                            value: '; }\n.primary.secondary { color: '
                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                    right: {
                                                                                                                                                                                                                                        type: 'CallExpression',
                                                                                                                                                                                                                                        callee: {
                                                                                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                                                                                            name: 'rgba',
                                                                                                                                                                                                                                            loc: {
                                                                                                                                                                                                                                                start: {
                                                                                                                                                                                                                                                    line: 247,
                                                                                                                                                                                                                                                    column: 42,
                                                                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                },
                                                                                                                                                                                                                                                end: {
                                                                                                                                                                                                                                                    line: 247,
                                                                                                                                                                                                                                                    column: 46,
                                                                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                        },
                                                                                                                                                                                                                                        arguments: [
                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                                                                                name: 'primary',
                                                                                                                                                                                                                                                loc: {
                                                                                                                                                                                                                                                    start: {
                                                                                                                                                                                                                                                        line: 247,
                                                                                                                                                                                                                                                        column: 47,
                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                    end: {
                                                                                                                                                                                                                                                        line: 247,
                                                                                                                                                                                                                                                        column: 54,
                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                                                                                name: 'secondary',
                                                                                                                                                                                                                                                loc: {
                                                                                                                                                                                                                                                    start: {
                                                                                                                                                                                                                                                        line: 247,
                                                                                                                                                                                                                                                        column: 56,
                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                                    end: {
                                                                                                                                                                                                                                                        line: 247,
                                                                                                                                                                                                                                                        column: 65,
                                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                        ],
                                                                                                                                                                                                                                        loc: {
                                                                                                                                                                                                                                            start: {
                                                                                                                                                                                                                                                line: 247,
                                                                                                                                                                                                                                                column: 42,
                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                            end: {
                                                                                                                                                                                                                                                line: 247,
                                                                                                                                                                                                                                                column: 66,
                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                },
                                                                                                                                                                                                                                right: {
                                                                                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                                                                                    value: '; }\n.primary.hint { color: '
                                                                                                                                                                                                                                }
                                                                                                                                                                                                                            },
                                                                                                                                                                                                                            right: {
                                                                                                                                                                                                                                type: 'CallExpression',
                                                                                                                                                                                                                                callee: {
                                                                                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                                                                                    name: 'rgba',
                                                                                                                                                                                                                                    loc: {
                                                                                                                                                                                                                                        start: {
                                                                                                                                                                                                                                            line: 248,
                                                                                                                                                                                                                                            column: 37,
                                                                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                                                                            source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                        },
                                                                                                                                                                                                                                        end: {
                                                                                                                                                                                                                                            line: 248,
                                                                                                                                                                                                                                            column: 41,
                                                                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                                                                            source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                },
                                                                                                                                                                                                                                arguments: [
                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                                                                                        name: 'primary',
                                                                                                                                                                                                                                        loc: {
                                                                                                                                                                                                                                            start: {
                                                                                                                                                                                                                                                line: 248,
                                                                                                                                                                                                                                                column: 42,
                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                            end: {
                                                                                                                                                                                                                                                line: 248,
                                                                                                                                                                                                                                                column: 49,
                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                                                                                        name: 'hint',
                                                                                                                                                                                                                                        loc: {
                                                                                                                                                                                                                                            start: {
                                                                                                                                                                                                                                                line: 248,
                                                                                                                                                                                                                                                column: 51,
                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                            },
                                                                                                                                                                                                                                            end: {
                                                                                                                                                                                                                                                line: 248,
                                                                                                                                                                                                                                                column: 55,
                                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                ],
                                                                                                                                                                                                                                loc: {
                                                                                                                                                                                                                                    start: {
                                                                                                                                                                                                                                        line: 248,
                                                                                                                                                                                                                                        column: 37,
                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                    end: {
                                                                                                                                                                                                                                        line: 248,
                                                                                                                                                                                                                                        column: 56,
                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                }
                                                                                                                                                                                                                            }
                                                                                                                                                                                                                        },
                                                                                                                                                                                                                        right: {
                                                                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                                                                            value: '; }\n\n.primary.lighter { color: '
                                                                                                                                                                                                                        }
                                                                                                                                                                                                                    },
                                                                                                                                                                                                                    right: {
                                                                                                                                                                                                                        type: 'CallExpression',
                                                                                                                                                                                                                        callee: {
                                                                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                                                                            name: 'rgba',
                                                                                                                                                                                                                            loc: {
                                                                                                                                                                                                                                start: {
                                                                                                                                                                                                                                    line: 250,
                                                                                                                                                                                                                                    column: 40,
                                                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                },
                                                                                                                                                                                                                                end: {
                                                                                                                                                                                                                                    line: 250,
                                                                                                                                                                                                                                    column: 44,
                                                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                }
                                                                                                                                                                                                                            }
                                                                                                                                                                                                                        },
                                                                                                                                                                                                                        arguments: [
                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                                                                name: 'primaryLighter',
                                                                                                                                                                                                                                loc: {
                                                                                                                                                                                                                                    start: {
                                                                                                                                                                                                                                        line: 250,
                                                                                                                                                                                                                                        column: 45,
                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                    end: {
                                                                                                                                                                                                                                        line: 250,
                                                                                                                                                                                                                                        column: 59,
                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                }
                                                                                                                                                                                                                            },
                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                                                                name: 'text',
                                                                                                                                                                                                                                loc: {
                                                                                                                                                                                                                                    start: {
                                                                                                                                                                                                                                        line: 250,
                                                                                                                                                                                                                                        column: 61,
                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                    },
                                                                                                                                                                                                                                    end: {
                                                                                                                                                                                                                                        line: 250,
                                                                                                                                                                                                                                        column: 65,
                                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                }
                                                                                                                                                                                                                            }
                                                                                                                                                                                                                        ],
                                                                                                                                                                                                                        loc: {
                                                                                                                                                                                                                            start: {
                                                                                                                                                                                                                                line: 250,
                                                                                                                                                                                                                                column: 40,
                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                            },
                                                                                                                                                                                                                            end: {
                                                                                                                                                                                                                                line: 250,
                                                                                                                                                                                                                                column: 66,
                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                            }
                                                                                                                                                                                                                        }
                                                                                                                                                                                                                    }
                                                                                                                                                                                                                },
                                                                                                                                                                                                                right: {
                                                                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                                                                    value: '; }\n.primary.lighter.secondary { color: '
                                                                                                                                                                                                                }
                                                                                                                                                                                                            },
                                                                                                                                                                                                            right: {
                                                                                                                                                                                                                type: 'CallExpression',
                                                                                                                                                                                                                callee: {
                                                                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                                                                    name: 'rgba',
                                                                                                                                                                                                                    loc: {
                                                                                                                                                                                                                        start: {
                                                                                                                                                                                                                            line: 251,
                                                                                                                                                                                                                            column: 50,
                                                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                                                            source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                        },
                                                                                                                                                                                                                        end: {
                                                                                                                                                                                                                            line: 251,
                                                                                                                                                                                                                            column: 54,
                                                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                                                            source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                        }
                                                                                                                                                                                                                    }
                                                                                                                                                                                                                },
                                                                                                                                                                                                                arguments: [
                                                                                                                                                                                                                    {
                                                                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                                                                        name: 'primaryLighter',
                                                                                                                                                                                                                        loc: {
                                                                                                                                                                                                                            start: {
                                                                                                                                                                                                                                line: 251,
                                                                                                                                                                                                                                column: 55,
                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                            },
                                                                                                                                                                                                                            end: {
                                                                                                                                                                                                                                line: 251,
                                                                                                                                                                                                                                column: 69,
                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                            }
                                                                                                                                                                                                                        }
                                                                                                                                                                                                                    },
                                                                                                                                                                                                                    {
                                                                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                                                                        name: 'secondary',
                                                                                                                                                                                                                        loc: {
                                                                                                                                                                                                                            start: {
                                                                                                                                                                                                                                line: 251,
                                                                                                                                                                                                                                column: 71,
                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                            },
                                                                                                                                                                                                                            end: {
                                                                                                                                                                                                                                line: 251,
                                                                                                                                                                                                                                column: 80,
                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                            }
                                                                                                                                                                                                                        }
                                                                                                                                                                                                                    }
                                                                                                                                                                                                                ],
                                                                                                                                                                                                                loc: {
                                                                                                                                                                                                                    start: {
                                                                                                                                                                                                                        line: 251,
                                                                                                                                                                                                                        column: 50,
                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                    },
                                                                                                                                                                                                                    end: {
                                                                                                                                                                                                                        line: 251,
                                                                                                                                                                                                                        column: 81,
                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                    }
                                                                                                                                                                                                                }
                                                                                                                                                                                                            }
                                                                                                                                                                                                        },
                                                                                                                                                                                                        right: {
                                                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                                                            value: '; }\n.primary.lighter.hint { color: '
                                                                                                                                                                                                        }
                                                                                                                                                                                                    },
                                                                                                                                                                                                    right: {
                                                                                                                                                                                                        type: 'CallExpression',
                                                                                                                                                                                                        callee: {
                                                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                                                            name: 'rgba',
                                                                                                                                                                                                            loc: {
                                                                                                                                                                                                                start: {
                                                                                                                                                                                                                    line: 252,
                                                                                                                                                                                                                    column: 45,
                                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                },
                                                                                                                                                                                                                end: {
                                                                                                                                                                                                                    line: 252,
                                                                                                                                                                                                                    column: 49,
                                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                }
                                                                                                                                                                                                            }
                                                                                                                                                                                                        },
                                                                                                                                                                                                        arguments: [
                                                                                                                                                                                                            {
                                                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                                                name: 'primaryLighter',
                                                                                                                                                                                                                loc: {
                                                                                                                                                                                                                    start: {
                                                                                                                                                                                                                        line: 252,
                                                                                                                                                                                                                        column: 50,
                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                    },
                                                                                                                                                                                                                    end: {
                                                                                                                                                                                                                        line: 252,
                                                                                                                                                                                                                        column: 64,
                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                    }
                                                                                                                                                                                                                }
                                                                                                                                                                                                            },
                                                                                                                                                                                                            {
                                                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                                                name: 'hint',
                                                                                                                                                                                                                loc: {
                                                                                                                                                                                                                    start: {
                                                                                                                                                                                                                        line: 252,
                                                                                                                                                                                                                        column: 66,
                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                    },
                                                                                                                                                                                                                    end: {
                                                                                                                                                                                                                        line: 252,
                                                                                                                                                                                                                        column: 70,
                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                                    }
                                                                                                                                                                                                                }
                                                                                                                                                                                                            }
                                                                                                                                                                                                        ],
                                                                                                                                                                                                        loc: {
                                                                                                                                                                                                            start: {
                                                                                                                                                                                                                line: 252,
                                                                                                                                                                                                                column: 45,
                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                            },
                                                                                                                                                                                                            end: {
                                                                                                                                                                                                                line: 252,
                                                                                                                                                                                                                column: 71,
                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                            }
                                                                                                                                                                                                        }
                                                                                                                                                                                                    }
                                                                                                                                                                                                },
                                                                                                                                                                                                right: {
                                                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                                                    value: '; }\n\n.primary.darker { color: '
                                                                                                                                                                                                }
                                                                                                                                                                                            },
                                                                                                                                                                                            right: {
                                                                                                                                                                                                type: 'CallExpression',
                                                                                                                                                                                                callee: {
                                                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                                                    name: 'rgba',
                                                                                                                                                                                                    loc: {
                                                                                                                                                                                                        start: {
                                                                                                                                                                                                            line: 254,
                                                                                                                                                                                                            column: 39,
                                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                                            source: 'glass/html/Theme.ion'
                                                                                                                                                                                                        },
                                                                                                                                                                                                        end: {
                                                                                                                                                                                                            line: 254,
                                                                                                                                                                                                            column: 43,
                                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                                            source: 'glass/html/Theme.ion'
                                                                                                                                                                                                        }
                                                                                                                                                                                                    }
                                                                                                                                                                                                },
                                                                                                                                                                                                arguments: [
                                                                                                                                                                                                    {
                                                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                                                        name: 'primaryDarker',
                                                                                                                                                                                                        loc: {
                                                                                                                                                                                                            start: {
                                                                                                                                                                                                                line: 254,
                                                                                                                                                                                                                column: 44,
                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                            },
                                                                                                                                                                                                            end: {
                                                                                                                                                                                                                line: 254,
                                                                                                                                                                                                                column: 57,
                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                            }
                                                                                                                                                                                                        }
                                                                                                                                                                                                    },
                                                                                                                                                                                                    {
                                                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                                                        name: 'text',
                                                                                                                                                                                                        loc: {
                                                                                                                                                                                                            start: {
                                                                                                                                                                                                                line: 254,
                                                                                                                                                                                                                column: 59,
                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                            },
                                                                                                                                                                                                            end: {
                                                                                                                                                                                                                line: 254,
                                                                                                                                                                                                                column: 63,
                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                                            }
                                                                                                                                                                                                        }
                                                                                                                                                                                                    }
                                                                                                                                                                                                ],
                                                                                                                                                                                                loc: {
                                                                                                                                                                                                    start: {
                                                                                                                                                                                                        line: 254,
                                                                                                                                                                                                        column: 39,
                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                    },
                                                                                                                                                                                                    end: {
                                                                                                                                                                                                        line: 254,
                                                                                                                                                                                                        column: 64,
                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                    }
                                                                                                                                                                                                }
                                                                                                                                                                                            }
                                                                                                                                                                                        },
                                                                                                                                                                                        right: {
                                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                                            value: '; }\n.primary.darker.secondary { color: '
                                                                                                                                                                                        }
                                                                                                                                                                                    },
                                                                                                                                                                                    right: {
                                                                                                                                                                                        type: 'CallExpression',
                                                                                                                                                                                        callee: {
                                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                                            name: 'rgba',
                                                                                                                                                                                            loc: {
                                                                                                                                                                                                start: {
                                                                                                                                                                                                    line: 255,
                                                                                                                                                                                                    column: 49,
                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                                                                                                                },
                                                                                                                                                                                                end: {
                                                                                                                                                                                                    line: 255,
                                                                                                                                                                                                    column: 53,
                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                                                                                                                }
                                                                                                                                                                                            }
                                                                                                                                                                                        },
                                                                                                                                                                                        arguments: [
                                                                                                                                                                                            {
                                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                                name: 'primaryDarker',
                                                                                                                                                                                                loc: {
                                                                                                                                                                                                    start: {
                                                                                                                                                                                                        line: 255,
                                                                                                                                                                                                        column: 54,
                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                    },
                                                                                                                                                                                                    end: {
                                                                                                                                                                                                        line: 255,
                                                                                                                                                                                                        column: 67,
                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                    }
                                                                                                                                                                                                }
                                                                                                                                                                                            },
                                                                                                                                                                                            {
                                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                                name: 'secondary',
                                                                                                                                                                                                loc: {
                                                                                                                                                                                                    start: {
                                                                                                                                                                                                        line: 255,
                                                                                                                                                                                                        column: 69,
                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                    },
                                                                                                                                                                                                    end: {
                                                                                                                                                                                                        line: 255,
                                                                                                                                                                                                        column: 78,
                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                                    }
                                                                                                                                                                                                }
                                                                                                                                                                                            }
                                                                                                                                                                                        ],
                                                                                                                                                                                        loc: {
                                                                                                                                                                                            start: {
                                                                                                                                                                                                line: 255,
                                                                                                                                                                                                column: 49,
                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                            },
                                                                                                                                                                                            end: {
                                                                                                                                                                                                line: 255,
                                                                                                                                                                                                column: 79,
                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                            }
                                                                                                                                                                                        }
                                                                                                                                                                                    }
                                                                                                                                                                                },
                                                                                                                                                                                right: {
                                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                                    value: '; }\n.primary.darker.hint { color: '
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            right: {
                                                                                                                                                                                type: 'CallExpression',
                                                                                                                                                                                callee: {
                                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                                    name: 'rgba',
                                                                                                                                                                                    loc: {
                                                                                                                                                                                        start: {
                                                                                                                                                                                            line: 256,
                                                                                                                                                                                            column: 44,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'glass/html/Theme.ion'
                                                                                                                                                                                        },
                                                                                                                                                                                        end: {
                                                                                                                                                                                            line: 256,
                                                                                                                                                                                            column: 48,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'glass/html/Theme.ion'
                                                                                                                                                                                        }
                                                                                                                                                                                    }
                                                                                                                                                                                },
                                                                                                                                                                                arguments: [
                                                                                                                                                                                    {
                                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                                        name: 'primaryDarker',
                                                                                                                                                                                        loc: {
                                                                                                                                                                                            start: {
                                                                                                                                                                                                line: 256,
                                                                                                                                                                                                column: 49,
                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                            },
                                                                                                                                                                                            end: {
                                                                                                                                                                                                line: 256,
                                                                                                                                                                                                column: 62,
                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                            }
                                                                                                                                                                                        }
                                                                                                                                                                                    },
                                                                                                                                                                                    {
                                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                                        name: 'hint',
                                                                                                                                                                                        loc: {
                                                                                                                                                                                            start: {
                                                                                                                                                                                                line: 256,
                                                                                                                                                                                                column: 64,
                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                            },
                                                                                                                                                                                            end: {
                                                                                                                                                                                                line: 256,
                                                                                                                                                                                                column: 68,
                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                                            }
                                                                                                                                                                                        }
                                                                                                                                                                                    }
                                                                                                                                                                                ],
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 256,
                                                                                                                                                                                        column: 44,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 256,
                                                                                                                                                                                        column: 69,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        right: {
                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                            value: '; }\n\n.accent { color: '
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    right: {
                                                                                                                                                                        type: 'CallExpression',
                                                                                                                                                                        callee: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'rgba',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 258,
                                                                                                                                                                                    column: 31,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 258,
                                                                                                                                                                                    column: 35,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        arguments: [
                                                                                                                                                                            {
                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                name: 'accent',
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 258,
                                                                                                                                                                                        column: 36,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 258,
                                                                                                                                                                                        column: 42,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            {
                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                name: 'text',
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 258,
                                                                                                                                                                                        column: 44,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 258,
                                                                                                                                                                                        column: 48,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        ],
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 258,
                                                                                                                                                                                column: 31,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 258,
                                                                                                                                                                                column: 49,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                right: {
                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                    value: '; }\n.accent.secondary { color: '
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            right: {
                                                                                                                                                                type: 'CallExpression',
                                                                                                                                                                callee: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'rgba',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 259,
                                                                                                                                                                            column: 41,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'glass/html/Theme.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 259,
                                                                                                                                                                            column: 45,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'glass/html/Theme.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                arguments: [
                                                                                                                                                                    {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'accent',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 259,
                                                                                                                                                                                column: 46,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 259,
                                                                                                                                                                                column: 52,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'secondary',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 259,
                                                                                                                                                                                column: 54,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 259,
                                                                                                                                                                                column: 63,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                ],
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 259,
                                                                                                                                                                        column: 41,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 259,
                                                                                                                                                                        column: 64,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        right: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: '; }\n.accent.hint { color: '
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    right: {
                                                                                                                                                        type: 'CallExpression',
                                                                                                                                                        callee: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'rgba',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 260,
                                                                                                                                                                    column: 36,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 260,
                                                                                                                                                                    column: 40,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        arguments: [
                                                                                                                                                            {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'accent',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 260,
                                                                                                                                                                        column: 41,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 260,
                                                                                                                                                                        column: 47,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'hint',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 260,
                                                                                                                                                                        column: 49,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 260,
                                                                                                                                                                        column: 53,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        ],
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 260,
                                                                                                                                                                column: 36,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 260,
                                                                                                                                                                column: 54,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                right: {
                                                                                                                                                    type: 'Literal',
                                                                                                                                                    value: '; }\n\n.accent.lighter { color: '
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            right: {
                                                                                                                                                type: 'CallExpression',
                                                                                                                                                callee: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'rgba',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 262,
                                                                                                                                                            column: 39,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'glass/html/Theme.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 262,
                                                                                                                                                            column: 43,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'glass/html/Theme.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                arguments: [
                                                                                                                                                    {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'accentLighter',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 262,
                                                                                                                                                                column: 44,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 262,
                                                                                                                                                                column: 57,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'text',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 262,
                                                                                                                                                                column: 59,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 262,
                                                                                                                                                                column: 63,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                ],
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 262,
                                                                                                                                                        column: 39,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 262,
                                                                                                                                                        column: 64,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        right: {
                                                                                                                                            type: 'Literal',
                                                                                                                                            value: '; }\n.accent.lighter.secondary { color: '
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    right: {
                                                                                                                                        type: 'CallExpression',
                                                                                                                                        callee: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'rgba',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 263,
                                                                                                                                                    column: 49,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 263,
                                                                                                                                                    column: 53,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        arguments: [
                                                                                                                                            {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'accentLighter',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 263,
                                                                                                                                                        column: 54,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 263,
                                                                                                                                                        column: 67,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'secondary',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 263,
                                                                                                                                                        column: 69,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 263,
                                                                                                                                                        column: 78,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        ],
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 263,
                                                                                                                                                column: 49,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 263,
                                                                                                                                                column: 79,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                right: {
                                                                                                                                    type: 'Literal',
                                                                                                                                    value: '; }\n.accent.lighter.hint { color: '
                                                                                                                                }
                                                                                                                            },
                                                                                                                            right: {
                                                                                                                                type: 'CallExpression',
                                                                                                                                callee: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'rgba',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 264,
                                                                                                                                            column: 44,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'glass/html/Theme.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 264,
                                                                                                                                            column: 48,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'glass/html/Theme.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                arguments: [
                                                                                                                                    {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'accentLighter',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 264,
                                                                                                                                                column: 49,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 264,
                                                                                                                                                column: 62,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'hint',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 264,
                                                                                                                                                column: 64,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 264,
                                                                                                                                                column: 68,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                ],
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 264,
                                                                                                                                        column: 44,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 264,
                                                                                                                                        column: 69,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        right: {
                                                                                                                            type: 'Literal',
                                                                                                                            value: '; }\n\n.accent.darker { color: '
                                                                                                                        }
                                                                                                                    },
                                                                                                                    right: {
                                                                                                                        type: 'CallExpression',
                                                                                                                        callee: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'rgba',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 266,
                                                                                                                                    column: 38,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 266,
                                                                                                                                    column: 42,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        arguments: [
                                                                                                                            {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'accentDarker',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 266,
                                                                                                                                        column: 43,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 266,
                                                                                                                                        column: 55,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'text',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 266,
                                                                                                                                        column: 57,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 266,
                                                                                                                                        column: 61,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            }
                                                                                                                        ],
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 266,
                                                                                                                                column: 38,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 266,
                                                                                                                                column: 62,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                right: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: '; }\n.accent.darker.secondary { color: '
                                                                                                                }
                                                                                                            },
                                                                                                            right: {
                                                                                                                type: 'CallExpression',
                                                                                                                callee: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'rgba',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 267,
                                                                                                                            column: 48,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/Theme.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 267,
                                                                                                                            column: 52,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/Theme.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                arguments: [
                                                                                                                    {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'accentDarker',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 267,
                                                                                                                                column: 53,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 267,
                                                                                                                                column: 65,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'secondary',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 267,
                                                                                                                                column: 67,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 267,
                                                                                                                                column: 76,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    }
                                                                                                                ],
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 267,
                                                                                                                        column: 48,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 267,
                                                                                                                        column: 77,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        right: {
                                                                                                            type: 'Literal',
                                                                                                            value: '; }\n.accent.darker.hint { color: '
                                                                                                        }
                                                                                                    },
                                                                                                    right: {
                                                                                                        type: 'CallExpression',
                                                                                                        callee: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'rgba',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 268,
                                                                                                                    column: 43,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 268,
                                                                                                                    column: 47,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        arguments: [
                                                                                                            {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'accentDarker',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 268,
                                                                                                                        column: 48,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 268,
                                                                                                                        column: 60,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'hint',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 268,
                                                                                                                        column: 62,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 268,
                                                                                                                        column: 66,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            }
                                                                                                        ],
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 268,
                                                                                                                column: 43,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 268,
                                                                                                                column: 67,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                right: {
                                                                                                    type: 'Literal',
                                                                                                    value: '; }\n\n.error {\n    color: '
                                                                                                }
                                                                                            },
                                                                                            right: {
                                                                                                type: 'MemberExpression',
                                                                                                computed: false,
                                                                                                object: {
                                                                                                    type: 'MemberExpression',
                                                                                                    computed: false,
                                                                                                    object: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'style',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 271,
                                                                                                                column: 25,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 271,
                                                                                                                column: 30,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    property: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'color',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 271,
                                                                                                                column: 31,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 271,
                                                                                                                column: 36,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/Theme.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 271,
                                                                                                            column: 25,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/Theme.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 271,
                                                                                                            column: 36,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/Theme.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'error',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 271,
                                                                                                            column: 37,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/Theme.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 271,
                                                                                                            column: 42,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/Theme.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 271,
                                                                                                        column: 25,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 271,
                                                                                                        column: 42,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        right: {
                                                                                            type: 'Literal',
                                                                                            value: ' !important;\n}\n\n.typography.title {\n    font-size:'
                                                                                        }
                                                                                    },
                                                                                    right: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'MemberExpression',
                                                                                            computed: false,
                                                                                            object: {
                                                                                                type: 'MemberExpression',
                                                                                                computed: false,
                                                                                                object: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'style',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 275,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/Theme.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 275,
                                                                                                            column: 33,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/Theme.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'typography',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 275,
                                                                                                            column: 34,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/Theme.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 275,
                                                                                                            column: 44,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/Theme.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 275,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 275,
                                                                                                        column: 44,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            property: {
                                                                                                type: 'Identifier',
                                                                                                name: 'title',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 275,
                                                                                                        column: 45,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 275,
                                                                                                        column: 50,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/Theme.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 275,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 275,
                                                                                                    column: 50,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'size',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 275,
                                                                                                    column: 51,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 275,
                                                                                                    column: 55,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 275,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/Theme.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 275,
                                                                                                column: 55,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/Theme.ion'
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                },
                                                                                right: {
                                                                                    type: 'Literal',
                                                                                    value: 'px;\n    font-weight:'
                                                                                }
                                                                            },
                                                                            right: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'style',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 276,
                                                                                                    column: 30,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 276,
                                                                                                    column: 35,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'typography',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 276,
                                                                                                    column: 36,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 276,
                                                                                                    column: 46,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/Theme.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 276,
                                                                                                column: 30,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/Theme.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 276,
                                                                                                column: 46,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/Theme.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'title',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 276,
                                                                                                column: 47,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/Theme.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 276,
                                                                                                column: 52,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/Theme.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 276,
                                                                                            column: 30,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/Theme.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 276,
                                                                                            column: 52,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/Theme.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'weight',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 276,
                                                                                            column: 53,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/Theme.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 276,
                                                                                            column: 59,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/Theme.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 276,
                                                                                        column: 30,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/Theme.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 276,
                                                                                        column: 59,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/Theme.ion'
                                                                                    }
                                                                                }
                                                                            }
                                                                        },
                                                                        right: {
                                                                            type: 'Literal',
                                                                            value: ';\n}\n.Button {\n    text-transform: uppercase;\n    font-size: '
                                                                        }
                                                                    },
                                                                    right: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'Identifier',
                                                                                    name: 'style',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 280,
                                                                                            column: 29,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/Theme.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 280,
                                                                                            column: 34,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/Theme.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'typography',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 280,
                                                                                            column: 35,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/Theme.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 280,
                                                                                            column: 45,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/Theme.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 280,
                                                                                        column: 29,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/Theme.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 280,
                                                                                        column: 45,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/Theme.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'button',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 280,
                                                                                        column: 46,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/Theme.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 280,
                                                                                        column: 52,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/Theme.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 280,
                                                                                    column: 29,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/Theme.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 280,
                                                                                    column: 52,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/Theme.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'size',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 280,
                                                                                    column: 53,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/Theme.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 280,
                                                                                    column: 57,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/Theme.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 280,
                                                                                column: 29,
                                                                                fixed: true,
                                                                                source: 'glass/html/Theme.ion'
                                                                            },
                                                                            end: {
                                                                                line: 280,
                                                                                column: 57,
                                                                                fixed: true,
                                                                                source: 'glass/html/Theme.ion'
                                                                            }
                                                                        }
                                                                    }
                                                                },
                                                                right: {
                                                                    type: 'Literal',
                                                                    value: 'px;\n    font-weight: '
                                                                }
                                                            },
                                                            right: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'style',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 281,
                                                                                    column: 31,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/Theme.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 281,
                                                                                    column: 36,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/Theme.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'typography',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 281,
                                                                                    column: 37,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/Theme.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 281,
                                                                                    column: 47,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/Theme.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 281,
                                                                                column: 31,
                                                                                fixed: true,
                                                                                source: 'glass/html/Theme.ion'
                                                                            },
                                                                            end: {
                                                                                line: 281,
                                                                                column: 47,
                                                                                fixed: true,
                                                                                source: 'glass/html/Theme.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'button',
                                                                        loc: {
                                                                            start: {
                                                                                line: 281,
                                                                                column: 48,
                                                                                fixed: true,
                                                                                source: 'glass/html/Theme.ion'
                                                                            },
                                                                            end: {
                                                                                line: 281,
                                                                                column: 54,
                                                                                fixed: true,
                                                                                source: 'glass/html/Theme.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 281,
                                                                            column: 31,
                                                                            fixed: true,
                                                                            source: 'glass/html/Theme.ion'
                                                                        },
                                                                        end: {
                                                                            line: 281,
                                                                            column: 54,
                                                                            fixed: true,
                                                                            source: 'glass/html/Theme.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'weight',
                                                                    loc: {
                                                                        start: {
                                                                            line: 281,
                                                                            column: 55,
                                                                            fixed: true,
                                                                            source: 'glass/html/Theme.ion'
                                                                        },
                                                                        end: {
                                                                            line: 281,
                                                                            column: 61,
                                                                            fixed: true,
                                                                            source: 'glass/html/Theme.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 281,
                                                                        column: 31,
                                                                        fixed: true,
                                                                        source: 'glass/html/Theme.ion'
                                                                    },
                                                                    end: {
                                                                        line: 281,
                                                                        column: 61,
                                                                        fixed: true,
                                                                        source: 'glass/html/Theme.ion'
                                                                    }
                                                                }
                                                            }
                                                        },
                                                        right: {
                                                            type: 'Literal',
                                                            value: ';\n}\ntextarea {\n    font-size:14px;\n}\n.Button.primary {\n    color:white;\n    background-color: '
                                                        }
                                                    },
                                                    right: {
                                                        type: 'Identifier',
                                                        name: 'primary',
                                                        loc: {
                                                            start: {
                                                                line: 288,
                                                                column: 36,
                                                                fixed: true,
                                                                source: 'glass/html/Theme.ion'
                                                            },
                                                            end: {
                                                                line: 288,
                                                                column: 43,
                                                                fixed: true,
                                                                source: 'glass/html/Theme.ion'
                                                            }
                                                        }
                                                    }
                                                },
                                                right: {
                                                    type: 'Literal',
                                                    value: ';\n    padding:12px;\n}\n.Button.accent {\n    color:white;\n    background-color: '
                                                }
                                            },
                                            right: {
                                                type: 'Identifier',
                                                name: 'accent',
                                                loc: {
                                                    start: {
                                                        line: 293,
                                                        column: 36,
                                                        fixed: true,
                                                        source: 'glass/html/Theme.ion'
                                                    },
                                                    end: {
                                                        line: 293,
                                                        column: 42,
                                                        fixed: true,
                                                        source: 'glass/html/Theme.ion'
                                                    }
                                                }
                                            }
                                        },
                                        right: {
                                            type: 'Literal',
                                            value: ';\n    padding:12px;\n}\n\n.link {\n    cursor: pointer;\n    color: '
                                        }
                                    },
                                    right: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'style',
                                                loc: {
                                                    start: {
                                                        line: 299,
                                                        column: 25,
                                                        fixed: true,
                                                        source: 'glass/html/Theme.ion'
                                                    },
                                                    end: {
                                                        line: 299,
                                                        column: 30,
                                                        fixed: true,
                                                        source: 'glass/html/Theme.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'color',
                                                loc: {
                                                    start: {
                                                        line: 299,
                                                        column: 31,
                                                        fixed: true,
                                                        source: 'glass/html/Theme.ion'
                                                    },
                                                    end: {
                                                        line: 299,
                                                        column: 36,
                                                        fixed: true,
                                                        source: 'glass/html/Theme.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 299,
                                                    column: 25,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                },
                                                end: {
                                                    line: 299,
                                                    column: 36,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'accentDark',
                                            loc: {
                                                start: {
                                                    line: 299,
                                                    column: 37,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                },
                                                end: {
                                                    line: 299,
                                                    column: 47,
                                                    fixed: true,
                                                    source: 'glass/html/Theme.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 299,
                                                column: 25,
                                                fixed: true,
                                                source: 'glass/html/Theme.ion'
                                            },
                                            end: {
                                                line: 299,
                                                column: 47,
                                                fixed: true,
                                                source: 'glass/html/Theme.ion'
                                            }
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: ';\n}\n\n.pointer {\n    cursor: pointer;\n}\n\n.nowrap {\n    white-space: nowrap;\n}\n\n.hover-show {\n    display: none;\n}\n\n*:hover > .hover-show {\n    display: block;\n}'
                                }
                            },
                            kind: 'init',
                            computed: true,
                            order: '0'
                        }]
                },
                loc: {
                    start: {
                        line: 84,
                        column: 4,
                        fixed: true,
                        source: 'glass/html/Theme.ion'
                    },
                    end: {
                        line: 317,
                        column: 8,
                        fixed: true,
                        source: 'glass/html/Theme.ion'
                    }
                },
                order: '>'
            }
        ],
        bound: false
    }, {
        this: this,
        module: module,
        base: base,
        _ref: _ref,
        _ref2: _ref2,
        style: style,
        rgba: rgba
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/Theme',_glass_html_Theme_);
    else
      _glass_html_Theme_.call(this, module, exports, require);
  }
  else {
    _glass_html_Theme_.call(this);
  }
}).call(this)
void (function(){var _glass_html_device_ = function(module,exports,require){'use strict';
var ion = require('ion');
if (!global.window) {
    return global.device = { server: true };
}
ion.template(function () {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'body',
                            loc: {
                                start: {
                                    line: 6,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/device.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/device.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            computed: false,
                            object: {
                                type: 'Identifier',
                                name: 'document',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/device.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 23,
                                        fixed: true,
                                        source: 'glass/html/device.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'body',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 24,
                                        fixed: true,
                                        source: 'glass/html/device.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 28,
                                        fixed: true,
                                        source: 'glass/html/device.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 6,
                                    column: 15,
                                    fixed: true,
                                    source: 'glass/html/device.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 28,
                                    fixed: true,
                                    source: 'glass/html/device.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'width',
                            loc: {
                                start: {
                                    line: 7,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/device.ion'
                                },
                                end: {
                                    line: 7,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/html/device.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            computed: false,
                            object: {
                                type: 'Identifier',
                                name: 'body',
                                loc: {
                                    start: {
                                        line: 7,
                                        column: 16,
                                        fixed: true,
                                        source: 'glass/html/device.ion'
                                    },
                                    end: {
                                        line: 7,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/device.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'clientWidth',
                                loc: {
                                    start: {
                                        line: 7,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/device.ion'
                                    },
                                    end: {
                                        line: 7,
                                        column: 33,
                                        fixed: true,
                                        source: 'glass/html/device.ion'
                                    }
                                }
                            },
                            existential: true,
                            loc: {
                                start: {
                                    line: 7,
                                    column: 16,
                                    fixed: true,
                                    source: 'glass/html/device.ion'
                                },
                                end: {
                                    line: 7,
                                    column: 33,
                                    fixed: true,
                                    source: 'glass/html/device.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'height',
                            loc: {
                                start: {
                                    line: 8,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/device.ion'
                                },
                                end: {
                                    line: 8,
                                    column: 14,
                                    fixed: true,
                                    source: 'glass/html/device.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            computed: false,
                            object: {
                                type: 'Identifier',
                                name: 'body',
                                loc: {
                                    start: {
                                        line: 8,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/html/device.ion'
                                    },
                                    end: {
                                        line: 8,
                                        column: 21,
                                        fixed: true,
                                        source: 'glass/html/device.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'clientHeight',
                                loc: {
                                    start: {
                                        line: 8,
                                        column: 23,
                                        fixed: true,
                                        source: 'glass/html/device.ion'
                                    },
                                    end: {
                                        line: 8,
                                        column: 35,
                                        fixed: true,
                                        source: 'glass/html/device.ion'
                                    }
                                }
                            },
                            existential: true,
                            loc: {
                                start: {
                                    line: 8,
                                    column: 17,
                                    fixed: true,
                                    source: 'glass/html/device.ion'
                                },
                                end: {
                                    line: 8,
                                    column: 35,
                                    fixed: true,
                                    source: 'glass/html/device.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'average',
                            loc: {
                                start: {
                                    line: 9,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/device.ion'
                                },
                                end: {
                                    line: 9,
                                    column: 15,
                                    fixed: true,
                                    source: 'glass/html/device.ion'
                                }
                            }
                        },
                        init: {
                            type: 'BinaryExpression',
                            operator: '/',
                            left: {
                                type: 'BinaryExpression',
                                operator: '+',
                                left: {
                                    type: 'Identifier',
                                    name: 'width',
                                    loc: {
                                        start: {
                                            line: 9,
                                            column: 19,
                                            fixed: true,
                                            source: 'glass/html/device.ion'
                                        },
                                        end: {
                                            line: 9,
                                            column: 24,
                                            fixed: true,
                                            source: 'glass/html/device.ion'
                                        }
                                    }
                                },
                                right: {
                                    type: 'Identifier',
                                    name: 'height',
                                    loc: {
                                        start: {
                                            line: 9,
                                            column: 27,
                                            fixed: true,
                                            source: 'glass/html/device.ion'
                                        },
                                        end: {
                                            line: 9,
                                            column: 33,
                                            fixed: true,
                                            source: 'glass/html/device.ion'
                                        }
                                    }
                                }
                            },
                            right: {
                                type: 'Literal',
                                value: 2
                            }
                        }
                    }],
                kind: 'let',
                order: '3'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'phone',
                            loc: {
                                start: {
                                    line: 10,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/device.ion'
                                },
                                end: {
                                    line: 10,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/html/device.ion'
                                }
                            }
                        },
                        init: {
                            type: 'BinaryExpression',
                            operator: '<=',
                            left: {
                                type: 'Identifier',
                                name: 'average',
                                loc: {
                                    start: {
                                        line: 10,
                                        column: 16,
                                        fixed: true,
                                        source: 'glass/html/device.ion'
                                    },
                                    end: {
                                        line: 10,
                                        column: 23,
                                        fixed: true,
                                        source: 'glass/html/device.ion'
                                    }
                                }
                            },
                            right: {
                                type: 'Literal',
                                value: 600
                            }
                        }
                    }],
                kind: 'let',
                order: '4'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'desktop',
                            loc: {
                                start: {
                                    line: 11,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/device.ion'
                                },
                                end: {
                                    line: 11,
                                    column: 15,
                                    fixed: true,
                                    source: 'glass/html/device.ion'
                                }
                            }
                        },
                        init: {
                            type: 'BinaryExpression',
                            operator: '&&',
                            left: {
                                type: 'BinaryExpression',
                                operator: '>',
                                left: {
                                    type: 'Identifier',
                                    name: 'average',
                                    loc: {
                                        start: {
                                            line: 11,
                                            column: 18,
                                            fixed: true,
                                            source: 'glass/html/device.ion'
                                        },
                                        end: {
                                            line: 11,
                                            column: 25,
                                            fixed: true,
                                            source: 'glass/html/device.ion'
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: 800
                                }
                            },
                            right: {
                                type: 'BinaryExpression',
                                operator: '>',
                                left: {
                                    type: 'Identifier',
                                    name: 'width',
                                    loc: {
                                        start: {
                                            line: 11,
                                            column: 36,
                                            fixed: true,
                                            source: 'glass/html/device.ion'
                                        },
                                        end: {
                                            line: 11,
                                            column: 41,
                                            fixed: true,
                                            source: 'glass/html/device.ion'
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: 600
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '5'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'tablet',
                            loc: {
                                start: {
                                    line: 12,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/device.ion'
                                },
                                end: {
                                    line: 12,
                                    column: 14,
                                    fixed: true,
                                    source: 'glass/html/device.ion'
                                }
                            }
                        },
                        init: {
                            type: 'BinaryExpression',
                            operator: '&&',
                            left: {
                                type: 'UnaryExpression',
                                operator: '!',
                                argument: {
                                    type: 'Identifier',
                                    name: 'phone',
                                    loc: {
                                        start: {
                                            line: 12,
                                            column: 21,
                                            fixed: true,
                                            source: 'glass/html/device.ion'
                                        },
                                        end: {
                                            line: 12,
                                            column: 26,
                                            fixed: true,
                                            source: 'glass/html/device.ion'
                                        }
                                    }
                                }
                            },
                            right: {
                                type: 'UnaryExpression',
                                operator: '!',
                                argument: {
                                    type: 'Identifier',
                                    name: 'desktop',
                                    loc: {
                                        start: {
                                            line: 12,
                                            column: 35,
                                            fixed: true,
                                            source: 'glass/html/device.ion'
                                        },
                                        end: {
                                            line: 12,
                                            column: 42,
                                            fixed: true,
                                            source: 'glass/html/device.ion'
                                        }
                                    }
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '6'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'mobile',
                            loc: {
                                start: {
                                    line: 13,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/device.ion'
                                },
                                end: {
                                    line: 13,
                                    column: 14,
                                    fixed: true,
                                    source: 'glass/html/device.ion'
                                }
                            }
                        },
                        init: {
                            type: 'BinaryExpression',
                            operator: '||',
                            left: {
                                type: 'Identifier',
                                name: 'phone',
                                loc: {
                                    start: {
                                        line: 13,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/html/device.ion'
                                    },
                                    end: {
                                        line: 13,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/device.ion'
                                    }
                                }
                            },
                            right: {
                                type: 'Identifier',
                                name: 'tablet',
                                loc: {
                                    start: {
                                        line: 13,
                                        column: 26,
                                        fixed: true,
                                        source: 'glass/html/device.ion'
                                    },
                                    end: {
                                        line: 13,
                                        column: 32,
                                        fixed: true,
                                        source: 'glass/html/device.ion'
                                    }
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '7'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'landscape',
                            loc: {
                                start: {
                                    line: 14,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/device.ion'
                                },
                                end: {
                                    line: 14,
                                    column: 17,
                                    fixed: true,
                                    source: 'glass/html/device.ion'
                                }
                            }
                        },
                        init: {
                            type: 'BinaryExpression',
                            operator: '>',
                            left: {
                                type: 'Identifier',
                                name: 'width',
                                loc: {
                                    start: {
                                        line: 14,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/device.ion'
                                    },
                                    end: {
                                        line: 14,
                                        column: 25,
                                        fixed: true,
                                        source: 'glass/html/device.ion'
                                    }
                                }
                            },
                            right: {
                                type: 'Identifier',
                                name: 'height',
                                loc: {
                                    start: {
                                        line: 14,
                                        column: 28,
                                        fixed: true,
                                        source: 'glass/html/device.ion'
                                    },
                                    end: {
                                        line: 14,
                                        column: 34,
                                        fixed: true,
                                        source: 'glass/html/device.ion'
                                    }
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '8'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'portrait',
                            loc: {
                                start: {
                                    line: 15,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/device.ion'
                                },
                                end: {
                                    line: 15,
                                    column: 16,
                                    fixed: true,
                                    source: 'glass/html/device.ion'
                                }
                            }
                        },
                        init: {
                            type: 'UnaryExpression',
                            operator: '!',
                            argument: {
                                type: 'Identifier',
                                name: 'landscape',
                                loc: {
                                    start: {
                                        line: 15,
                                        column: 23,
                                        fixed: true,
                                        source: 'glass/html/device.ion'
                                    },
                                    end: {
                                        line: 15,
                                        column: 32,
                                        fixed: true,
                                        source: 'glass/html/device.ion'
                                    }
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '9'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'state',
                            loc: {
                                start: {
                                    line: 17,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/device.ion'
                                },
                                end: {
                                    line: 17,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/html/device.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            properties: [{
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'touched',
                                        loc: {
                                            start: {
                                                line: 17,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/device.ion'
                                            },
                                            end: {
                                                line: 17,
                                                column: 24,
                                                fixed: true,
                                                source: 'glass/html/device.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: false
                                    },
                                    kind: 'init',
                                    order: '0'
                                }]
                        }
                    }],
                kind: 'let',
                order: ':'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'touch',
                            loc: {
                                start: {
                                    line: 18,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/device.ion'
                                },
                                end: {
                                    line: 18,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/html/device.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            computed: false,
                            object: {
                                type: 'Identifier',
                                name: 'state',
                                loc: {
                                    start: {
                                        line: 18,
                                        column: 16,
                                        fixed: true,
                                        source: 'glass/html/device.ion'
                                    },
                                    end: {
                                        line: 18,
                                        column: 21,
                                        fixed: true,
                                        source: 'glass/html/device.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'touched',
                                loc: {
                                    start: {
                                        line: 18,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/device.ion'
                                    },
                                    end: {
                                        line: 18,
                                        column: 29,
                                        fixed: true,
                                        source: 'glass/html/device.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 18,
                                    column: 16,
                                    fixed: true,
                                    source: 'glass/html/device.ion'
                                },
                                end: {
                                    line: 18,
                                    column: 29,
                                    fixed: true,
                                    source: 'glass/html/device.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: ';'
            },
            {
                type: 'ExpressionStatement',
                expression: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'Identifier',
                        name: 'window',
                        loc: {
                            start: {
                                line: 21,
                                column: 4,
                                fixed: true,
                                source: 'glass/html/device.ion'
                            },
                            end: {
                                line: 21,
                                column: 10,
                                fixed: true,
                                source: 'glass/html/device.ion'
                            }
                        }
                    },
                    properties: [
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'device',
                                loc: {
                                    start: {
                                        line: 22,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/device.ion'
                                    },
                                    end: {
                                        line: 22,
                                        column: 14,
                                        fixed: true,
                                        source: 'glass/html/device.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'ObjectExpression',
                                properties: [
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'phone',
                                            loc: {
                                                start: {
                                                    line: 22,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'glass/html/device.ion'
                                                },
                                                end: {
                                                    line: 22,
                                                    column: 22,
                                                    fixed: true,
                                                    source: 'glass/html/device.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Identifier',
                                            name: 'phone',
                                            loc: {
                                                start: {
                                                    line: 22,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'glass/html/device.ion'
                                                },
                                                end: {
                                                    line: 22,
                                                    column: 22,
                                                    fixed: true,
                                                    source: 'glass/html/device.ion'
                                                }
                                            }
                                        },
                                        kind: 'init',
                                        order: '0'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'tablet',
                                            loc: {
                                                start: {
                                                    line: 22,
                                                    column: 23,
                                                    fixed: true,
                                                    source: 'glass/html/device.ion'
                                                },
                                                end: {
                                                    line: 22,
                                                    column: 29,
                                                    fixed: true,
                                                    source: 'glass/html/device.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Identifier',
                                            name: 'tablet',
                                            loc: {
                                                start: {
                                                    line: 22,
                                                    column: 23,
                                                    fixed: true,
                                                    source: 'glass/html/device.ion'
                                                },
                                                end: {
                                                    line: 22,
                                                    column: 29,
                                                    fixed: true,
                                                    source: 'glass/html/device.ion'
                                                }
                                            }
                                        },
                                        kind: 'init',
                                        order: '1'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'desktop',
                                            loc: {
                                                start: {
                                                    line: 22,
                                                    column: 30,
                                                    fixed: true,
                                                    source: 'glass/html/device.ion'
                                                },
                                                end: {
                                                    line: 22,
                                                    column: 37,
                                                    fixed: true,
                                                    source: 'glass/html/device.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Identifier',
                                            name: 'desktop',
                                            loc: {
                                                start: {
                                                    line: 22,
                                                    column: 30,
                                                    fixed: true,
                                                    source: 'glass/html/device.ion'
                                                },
                                                end: {
                                                    line: 22,
                                                    column: 37,
                                                    fixed: true,
                                                    source: 'glass/html/device.ion'
                                                }
                                            }
                                        },
                                        kind: 'init',
                                        order: '2'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'mobile',
                                            loc: {
                                                start: {
                                                    line: 22,
                                                    column: 38,
                                                    fixed: true,
                                                    source: 'glass/html/device.ion'
                                                },
                                                end: {
                                                    line: 22,
                                                    column: 44,
                                                    fixed: true,
                                                    source: 'glass/html/device.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Identifier',
                                            name: 'mobile',
                                            loc: {
                                                start: {
                                                    line: 22,
                                                    column: 38,
                                                    fixed: true,
                                                    source: 'glass/html/device.ion'
                                                },
                                                end: {
                                                    line: 22,
                                                    column: 44,
                                                    fixed: true,
                                                    source: 'glass/html/device.ion'
                                                }
                                            }
                                        },
                                        kind: 'init',
                                        order: '3'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'landscape',
                                            loc: {
                                                start: {
                                                    line: 22,
                                                    column: 45,
                                                    fixed: true,
                                                    source: 'glass/html/device.ion'
                                                },
                                                end: {
                                                    line: 22,
                                                    column: 54,
                                                    fixed: true,
                                                    source: 'glass/html/device.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Identifier',
                                            name: 'landscape',
                                            loc: {
                                                start: {
                                                    line: 22,
                                                    column: 45,
                                                    fixed: true,
                                                    source: 'glass/html/device.ion'
                                                },
                                                end: {
                                                    line: 22,
                                                    column: 54,
                                                    fixed: true,
                                                    source: 'glass/html/device.ion'
                                                }
                                            }
                                        },
                                        kind: 'init',
                                        order: '4'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'portrait',
                                            loc: {
                                                start: {
                                                    line: 22,
                                                    column: 55,
                                                    fixed: true,
                                                    source: 'glass/html/device.ion'
                                                },
                                                end: {
                                                    line: 22,
                                                    column: 63,
                                                    fixed: true,
                                                    source: 'glass/html/device.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Identifier',
                                            name: 'portrait',
                                            loc: {
                                                start: {
                                                    line: 22,
                                                    column: 55,
                                                    fixed: true,
                                                    source: 'glass/html/device.ion'
                                                },
                                                end: {
                                                    line: 22,
                                                    column: 63,
                                                    fixed: true,
                                                    source: 'glass/html/device.ion'
                                                }
                                            }
                                        },
                                        kind: 'init',
                                        order: '5'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'touch',
                                            loc: {
                                                start: {
                                                    line: 22,
                                                    column: 64,
                                                    fixed: true,
                                                    source: 'glass/html/device.ion'
                                                },
                                                end: {
                                                    line: 22,
                                                    column: 69,
                                                    fixed: true,
                                                    source: 'glass/html/device.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Identifier',
                                            name: 'touch',
                                            loc: {
                                                start: {
                                                    line: 22,
                                                    column: 64,
                                                    fixed: true,
                                                    source: 'glass/html/device.ion'
                                                },
                                                end: {
                                                    line: 22,
                                                    column: 69,
                                                    fixed: true,
                                                    source: 'glass/html/device.ion'
                                                }
                                            }
                                        },
                                        kind: 'init',
                                        order: '6'
                                    }
                                ]
                            },
                            kind: 'init',
                            order: '0'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'document',
                                loc: {
                                    start: {
                                        line: 23,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/device.ion'
                                    },
                                    end: {
                                        line: 23,
                                        column: 16,
                                        fixed: true,
                                        source: 'glass/html/device.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'ObjectExpression',
                                properties: [{
                                        type: 'IfStatement',
                                        test: {
                                            type: 'UnaryExpression',
                                            operator: '?',
                                            argument: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'document',
                                                    loc: {
                                                        start: {
                                                            line: 24,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/device.ion'
                                                        },
                                                        end: {
                                                            line: 24,
                                                            column: 23,
                                                            fixed: true,
                                                            source: 'glass/html/device.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'body',
                                                    loc: {
                                                        start: {
                                                            line: 24,
                                                            column: 24,
                                                            fixed: true,
                                                            source: 'glass/html/device.ion'
                                                        },
                                                        end: {
                                                            line: 24,
                                                            column: 28,
                                                            fixed: true,
                                                            source: 'glass/html/device.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 24,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'glass/html/device.ion'
                                                    },
                                                    end: {
                                                        line: 24,
                                                        column: 28,
                                                        fixed: true,
                                                        source: 'glass/html/device.ion'
                                                    }
                                                }
                                            }
                                        },
                                        consequent: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'body',
                                                        loc: {
                                                            start: {
                                                                line: 25,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/device.ion'
                                                            },
                                                            end: {
                                                                line: 25,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'glass/html/device.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'ObjectExpression',
                                                        properties: [
                                                            {
                                                                type: 'IfStatement',
                                                                test: {
                                                                    type: 'UnaryExpression',
                                                                    operator: '!',
                                                                    argument: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'state',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 26,
                                                                                    column: 27,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/device.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 26,
                                                                                    column: 32,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/device.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'touched',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 26,
                                                                                    column: 33,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/device.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 26,
                                                                                    column: 40,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/device.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 26,
                                                                                column: 27,
                                                                                fixed: true,
                                                                                source: 'glass/html/device.ion'
                                                                            },
                                                                            end: {
                                                                                line: 26,
                                                                                column: 40,
                                                                                fixed: true,
                                                                                source: 'glass/html/device.ion'
                                                                            }
                                                                        }
                                                                    }
                                                                },
                                                                consequent: {
                                                                    type: 'BlockStatement',
                                                                    body: [{
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'Function',
                                                                                context: true,
                                                                                value: function (_context) {
                                                                                    return function touchstart(e) {
                                                                                        var state = _context.get('state');
                                                                                        state.touched = true;
                                                                                    };
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 27,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/device.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 29,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/device.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                alternate: null,
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'classList',
                                                                    loc: {
                                                                        start: {
                                                                            line: 29,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/device.ion'
                                                                        },
                                                                        end: {
                                                                            line: 29,
                                                                            column: 29,
                                                                            fixed: true,
                                                                            source: 'glass/html/device.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'ObjectExpression',
                                                                    properties: [
                                                                        {
                                                                            type: 'IfStatement',
                                                                            test: {
                                                                                type: 'Identifier',
                                                                                name: 'phone',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 30,
                                                                                        column: 27,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/device.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 30,
                                                                                        column: 32,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/device.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            consequent: {
                                                                                type: 'BlockStatement',
                                                                                body: [{
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'Literal',
                                                                                            value: 'phone'
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 31,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/device.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 31,
                                                                                                column: 35,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/device.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            alternate: null,
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'IfStatement',
                                                                            test: {
                                                                                type: 'Identifier',
                                                                                name: 'tablet',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 32,
                                                                                        column: 27,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/device.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 32,
                                                                                        column: 33,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/device.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            consequent: {
                                                                                type: 'BlockStatement',
                                                                                body: [{
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'Literal',
                                                                                            value: 'tablet'
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 33,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/device.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 33,
                                                                                                column: 36,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/device.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            alternate: null,
                                                                            order: '1'
                                                                        },
                                                                        {
                                                                            type: 'IfStatement',
                                                                            test: {
                                                                                type: 'Identifier',
                                                                                name: 'desktop',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 34,
                                                                                        column: 27,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/device.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 34,
                                                                                        column: 34,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/device.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            consequent: {
                                                                                type: 'BlockStatement',
                                                                                body: [{
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'Literal',
                                                                                            value: 'desktop'
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 35,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/device.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 35,
                                                                                                column: 37,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/device.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            alternate: null,
                                                                            order: '2'
                                                                        },
                                                                        {
                                                                            type: 'IfStatement',
                                                                            test: {
                                                                                type: 'Identifier',
                                                                                name: 'mobile',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 36,
                                                                                        column: 27,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/device.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 36,
                                                                                        column: 33,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/device.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            consequent: {
                                                                                type: 'BlockStatement',
                                                                                body: [{
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'Literal',
                                                                                            value: 'mobile'
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 37,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/device.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 37,
                                                                                                column: 36,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/device.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            alternate: null,
                                                                            order: '3'
                                                                        },
                                                                        {
                                                                            type: 'IfStatement',
                                                                            test: {
                                                                                type: 'Identifier',
                                                                                name: 'landscape',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 38,
                                                                                        column: 27,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/device.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 38,
                                                                                        column: 36,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/device.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            consequent: {
                                                                                type: 'BlockStatement',
                                                                                body: [{
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'Literal',
                                                                                            value: 'landscape'
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 39,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/device.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 39,
                                                                                                column: 39,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/device.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            alternate: null,
                                                                            order: '4'
                                                                        },
                                                                        {
                                                                            type: 'IfStatement',
                                                                            test: {
                                                                                type: 'Identifier',
                                                                                name: 'portrait',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 40,
                                                                                        column: 27,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/device.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 40,
                                                                                        column: 35,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/device.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            consequent: {
                                                                                type: 'BlockStatement',
                                                                                body: [{
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'Literal',
                                                                                            value: 'portrait'
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 41,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/device.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 41,
                                                                                                column: 38,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/device.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            alternate: null,
                                                                            order: '5'
                                                                        },
                                                                        {
                                                                            type: 'IfStatement',
                                                                            test: {
                                                                                type: 'Identifier',
                                                                                name: 'touch',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 42,
                                                                                        column: 27,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/device.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 42,
                                                                                        column: 32,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/device.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            consequent: {
                                                                                type: 'BlockStatement',
                                                                                body: [{
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'Literal',
                                                                                            value: 'touch'
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 43,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/device.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 43,
                                                                                                column: 35,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/device.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            alternate: null,
                                                                            order: '6'
                                                                        }
                                                                    ]
                                                                },
                                                                kind: 'init',
                                                                order: '1'
                                                            }
                                                        ]
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                }]
                                        },
                                        alternate: null,
                                        order: '0'
                                    }]
                            },
                            kind: 'init',
                            order: '1'
                        }
                    ]
                },
                loc: {
                    start: {
                        line: 21,
                        column: 4,
                        fixed: true,
                        source: 'glass/html/device.ion'
                    },
                    end: {
                        line: 45,
                        column: 8,
                        fixed: true,
                        source: 'glass/html/device.ion'
                    }
                },
                order: '<'
            }
        ],
        bound: false
    }, { this: this }, null);
})().observe();
module.exports = exports = window.device;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/device',_glass_html_device_);
    else
      _glass_html_device_.call(this, module, exports, require);
  }
  else {
    _glass_html_device_.call(this);
  }
}).call(this)
void (function(){var _glass_html_forms_CancelButton_ = function(module,exports,require){'use strict';
var ion = require('ion');
module.exports = exports = ion.template(function CancelButton(attributes) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'CancelButton',
            loc: {
                start: {
                    line: 3,
                    column: 16,
                    fixed: true,
                    source: 'glass/html/forms/CancelButton.ion'
                },
                end: {
                    line: 3,
                    column: 28,
                    fixed: true,
                    source: 'glass/html/forms/CancelButton.ion'
                }
            }
        },
        body: [{
                type: 'ReturnStatement',
                argument: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'CallExpression',
                        callee: {
                            type: 'Identifier',
                            name: 'PaperButton',
                            loc: {
                                start: {
                                    line: 4,
                                    column: 11,
                                    fixed: true,
                                    source: 'glass/html/forms/CancelButton.ion'
                                },
                                end: {
                                    line: 4,
                                    column: 22,
                                    fixed: true,
                                    source: 'glass/html/forms/CancelButton.ion'
                                }
                            }
                        },
                        arguments: [{
                                type: 'Identifier',
                                name: 'attributes',
                                loc: {
                                    start: {
                                        line: 4,
                                        column: 23,
                                        fixed: true,
                                        source: 'glass/html/forms/CancelButton.ion'
                                    },
                                    end: {
                                        line: 4,
                                        column: 33,
                                        fixed: true,
                                        source: 'glass/html/forms/CancelButton.ion'
                                    }
                                }
                            }],
                        loc: {
                            start: {
                                line: 4,
                                column: 11,
                                fixed: true,
                                source: 'glass/html/forms/CancelButton.ion'
                            },
                            end: {
                                line: 4,
                                column: 34,
                                fixed: true,
                                source: 'glass/html/forms/CancelButton.ion'
                            }
                        }
                    },
                    properties: [
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'raised',
                                loc: {
                                    start: {
                                        line: 5,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/forms/CancelButton.ion'
                                    },
                                    end: {
                                        line: 5,
                                        column: 14,
                                        fixed: true,
                                        source: 'glass/html/forms/CancelButton.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Literal',
                                value: true
                            },
                            kind: 'init',
                            order: '0'
                        },
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'Identifier',
                                        name: 'Input',
                                        loc: {
                                            start: {
                                                line: 6,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/forms/CancelButton.ion'
                                            },
                                            end: {
                                                line: 6,
                                                column: 13,
                                                fixed: true,
                                                source: 'glass/html/forms/CancelButton.ion'
                                            }
                                        }
                                    },
                                    arguments: [{
                                            type: 'ObjectExpression',
                                            properties: [
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'type',
                                                        loc: {
                                                            start: {
                                                                line: 6,
                                                                column: 15,
                                                                fixed: true,
                                                                source: 'glass/html/forms/CancelButton.ion'
                                                            },
                                                            end: {
                                                                line: 6,
                                                                column: 19,
                                                                fixed: true,
                                                                source: 'glass/html/forms/CancelButton.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 'submit'
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'style',
                                                        loc: {
                                                            start: {
                                                                line: 6,
                                                                column: 29,
                                                                fixed: true,
                                                                source: 'glass/html/forms/CancelButton.ion'
                                                            },
                                                            end: {
                                                                line: 6,
                                                                column: 34,
                                                                fixed: true,
                                                                source: 'glass/html/forms/CancelButton.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 'display:none;'
                                                    },
                                                    kind: 'init',
                                                    order: '1'
                                                }
                                            ]
                                        }],
                                    loc: {
                                        start: {
                                            line: 6,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/forms/CancelButton.ion'
                                        },
                                        end: {
                                            line: 6,
                                            column: 52,
                                            fixed: true,
                                            source: 'glass/html/forms/CancelButton.ion'
                                        }
                                    }
                                },
                                properties: [{
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'Function',
                                            context: false,
                                            value: function click(e) {
                                                return e.stopPropagation();
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 7,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/forms/CancelButton.ion'
                                            },
                                            end: {
                                                line: 7,
                                                column: 43,
                                                fixed: true,
                                                source: 'glass/html/forms/CancelButton.ion'
                                            }
                                        },
                                        order: '0'
                                    }]
                            },
                            loc: {
                                start: {
                                    line: 6,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/forms/CancelButton.ion'
                                },
                                end: {
                                    line: 8,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/forms/CancelButton.ion'
                                }
                            },
                            order: '1'
                        },
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'Function',
                                context: false,
                                value: function click(e) {
                                    return this.closest('form').dispatchEvent(new CustomEvent('cancel'));
                                }
                            },
                            loc: {
                                start: {
                                    line: 8,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/forms/CancelButton.ion'
                                },
                                end: {
                                    line: 8,
                                    column: 81,
                                    fixed: true,
                                    source: 'glass/html/forms/CancelButton.ion'
                                }
                            },
                            order: '2'
                        }
                    ]
                },
                order: '0'
            }],
        bound: false
    }, {
        this: this,
        attributes: attributes
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/forms/CancelButton',_glass_html_forms_CancelButton_);
    else
      _glass_html_forms_CancelButton_.call(this, module, exports, require);
  }
  else {
    _glass_html_forms_CancelButton_.call(this);
  }
}).call(this)
void (function(){var _glass_html_forms_Checkbox_ = function(module,exports,require){'use strict';
var ion = require('ion');
module.exports = exports = ion.template(function Checkbox(attributes) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'Checkbox',
            loc: {
                start: {
                    line: 3,
                    column: 16,
                    fixed: true,
                    source: 'glass/html/forms/Checkbox.ion'
                },
                end: {
                    line: 3,
                    column: 24,
                    fixed: true,
                    source: 'glass/html/forms/Checkbox.ion'
                }
            }
        },
        body: [{
                type: 'ReturnStatement',
                argument: {
                    type: 'CallExpression',
                    callee: {
                        type: 'MemberExpression',
                        object: {
                            type: 'Identifier',
                            name: 'Object'
                        },
                        property: {
                            type: 'Identifier',
                            name: 'defineProperties'
                        }
                    },
                    arguments: [
                        {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'PaperCheckbox',
                                    loc: {
                                        start: {
                                            line: 4,
                                            column: 11,
                                            fixed: true,
                                            source: 'glass/html/forms/Checkbox.ion'
                                        },
                                        end: {
                                            line: 4,
                                            column: 24,
                                            fixed: true,
                                            source: 'glass/html/forms/Checkbox.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'Identifier',
                                        name: 'attributes',
                                        loc: {
                                            start: {
                                                line: 4,
                                                column: 25,
                                                fixed: true,
                                                source: 'glass/html/forms/Checkbox.ion'
                                            },
                                            end: {
                                                line: 4,
                                                column: 35,
                                                fixed: true,
                                                source: 'glass/html/forms/Checkbox.ion'
                                            }
                                        }
                                    }],
                                loc: {
                                    start: {
                                        line: 4,
                                        column: 11,
                                        fixed: true,
                                        source: 'glass/html/forms/Checkbox.ion'
                                    },
                                    end: {
                                        line: 4,
                                        column: 36,
                                        fixed: true,
                                        source: 'glass/html/forms/Checkbox.ion'
                                    }
                                }
                            },
                            properties: []
                        },
                        {
                            type: 'ObjectExpression',
                            properties: [{
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'valueJSON',
                                        loc: {
                                            start: {
                                                line: 5,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/forms/Checkbox.ion'
                                            },
                                            end: {
                                                line: 5,
                                                column: 26,
                                                fixed: true,
                                                source: 'glass/html/forms/Checkbox.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 6,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/forms/Checkbox.ion'
                                                        },
                                                        end: {
                                                            line: 6,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/forms/Checkbox.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: false,
                                                    value: function () {
                                                        return this.checked;
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 7,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/forms/Checkbox.ion'
                                                        },
                                                        end: {
                                                            line: 7,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/forms/Checkbox.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: false,
                                                    value: function (value) {
                                                        return this.checked = value;
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '0'
                                }]
                        }
                    ]
                },
                order: '0'
            }],
        bound: false
    }, {
        this: this,
        attributes: attributes
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/forms/Checkbox',_glass_html_forms_Checkbox_);
    else
      _glass_html_forms_Checkbox_.call(this, module, exports, require);
  }
  else {
    _glass_html_forms_Checkbox_.call(this);
  }
}).call(this)
void (function(){var _glass_html_forms_DateInput_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('../');
var style = _ref.style;
var _ref2 = style.sheets;
_ref2[module.id] = '.DateInput {\n    min-width: 400px;\n}';
_ref2;
module.exports = exports = ion.template(function DateInput(options) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'DateInput',
            loc: {
                start: {
                    line: 10,
                    column: 16,
                    fixed: true,
                    source: 'glass/html/forms/DateInput.ion'
                },
                end: {
                    line: 10,
                    column: 25,
                    fixed: true,
                    source: 'glass/html/forms/DateInput.ion'
                }
            }
        },
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'showTime',
                            loc: {
                                start: {
                                    line: 11,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/forms/DateInput.ion'
                                },
                                end: {
                                    line: 11,
                                    column: 16,
                                    fixed: true,
                                    source: 'glass/html/forms/DateInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ConditionalExpression',
                            test: {
                                type: 'BinaryExpression',
                                operator: '!=',
                                left: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'options',
                                        loc: {
                                            start: {
                                                line: 11,
                                                column: 19,
                                                fixed: true,
                                                source: 'glass/html/forms/DateInput.ion'
                                            },
                                            end: {
                                                line: 11,
                                                column: 26,
                                                fixed: true,
                                                source: 'glass/html/forms/DateInput.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'showTime',
                                        loc: {
                                            start: {
                                                line: 11,
                                                column: 28,
                                                fixed: true,
                                                source: 'glass/html/forms/DateInput.ion'
                                            },
                                            end: {
                                                line: 11,
                                                column: 36,
                                                fixed: true,
                                                source: 'glass/html/forms/DateInput.ion'
                                            }
                                        }
                                    },
                                    existential: true,
                                    loc: {
                                        start: {
                                            line: 11,
                                            column: 19,
                                            fixed: true,
                                            source: 'glass/html/forms/DateInput.ion'
                                        },
                                        end: {
                                            line: 11,
                                            column: 36,
                                            fixed: true,
                                            source: 'glass/html/forms/DateInput.ion'
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: null
                                }
                            },
                            consequent: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'options',
                                    loc: {
                                        start: {
                                            line: 11,
                                            column: 19,
                                            fixed: true,
                                            source: 'glass/html/forms/DateInput.ion'
                                        },
                                        end: {
                                            line: 11,
                                            column: 26,
                                            fixed: true,
                                            source: 'glass/html/forms/DateInput.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'showTime',
                                    loc: {
                                        start: {
                                            line: 11,
                                            column: 28,
                                            fixed: true,
                                            source: 'glass/html/forms/DateInput.ion'
                                        },
                                        end: {
                                            line: 11,
                                            column: 36,
                                            fixed: true,
                                            source: 'glass/html/forms/DateInput.ion'
                                        }
                                    }
                                },
                                existential: true,
                                loc: {
                                    start: {
                                        line: 11,
                                        column: 19,
                                        fixed: true,
                                        source: 'glass/html/forms/DateInput.ion'
                                    },
                                    end: {
                                        line: 11,
                                        column: 36,
                                        fixed: true,
                                        source: 'glass/html/forms/DateInput.ion'
                                    }
                                }
                            },
                            alternate: {
                                type: 'Literal',
                                value: true
                            }
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'state',
                            loc: {
                                start: {
                                    line: 12,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/forms/DateInput.ion'
                                },
                                end: {
                                    line: 12,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/html/forms/DateInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Function',
                                context: false,
                                value: function () {
                                    return {
                                        date: null,
                                        time: null
                                    };
                                }
                            },
                            arguments: [],
                            loc: {
                                start: {
                                    line: 12,
                                    column: 16,
                                    fixed: true,
                                    source: 'glass/html/forms/DateInput.ion'
                                },
                                end: {
                                    line: 12,
                                    column: 43,
                                    fixed: true,
                                    source: 'glass/html/forms/DateInput.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'textInput',
                            loc: {
                                start: {
                                    line: 13,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/forms/DateInput.ion'
                                },
                                end: {
                                    line: 13,
                                    column: 17,
                                    fixed: true,
                                    source: 'glass/html/forms/DateInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'PaperInput',
                                    loc: {
                                        start: {
                                            line: 13,
                                            column: 20,
                                            fixed: true,
                                            source: 'glass/html/forms/DateInput.ion'
                                        },
                                        end: {
                                            line: 13,
                                            column: 30,
                                            fixed: true,
                                            source: 'glass/html/forms/DateInput.ion'
                                        }
                                    }
                                },
                                arguments: [],
                                loc: {
                                    start: {
                                        line: 13,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/forms/DateInput.ion'
                                    },
                                    end: {
                                        line: 13,
                                        column: 32,
                                        fixed: true,
                                        source: 'glass/html/forms/DateInput.ion'
                                    }
                                }
                            },
                            properties: [{
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context) {
                                            return function input(e) {
                                                var setDateTime = _context.get('setDateTime'), setDateInputValue = _context.get('setDateInputValue'), setTimeInputValue = _context.get('setTimeInputValue'), dispatch = _context.get('dispatch');
                                                setDateTime(this.value);
                                                setDateInputValue();
                                                setTimeInputValue();
                                                dispatch();
                                            };
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 14,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/forms/DateInput.ion'
                                        },
                                        end: {
                                            line: 20,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/forms/DateInput.ion'
                                        }
                                    },
                                    order: '0'
                                }]
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'dateInput',
                            loc: {
                                start: {
                                    line: 20,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/forms/DateInput.ion'
                                },
                                end: {
                                    line: 20,
                                    column: 17,
                                    fixed: true,
                                    source: 'glass/html/forms/DateInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Input',
                                    loc: {
                                        start: {
                                            line: 20,
                                            column: 20,
                                            fixed: true,
                                            source: 'glass/html/forms/DateInput.ion'
                                        },
                                        end: {
                                            line: 20,
                                            column: 25,
                                            fixed: true,
                                            source: 'glass/html/forms/DateInput.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'type',
                                                    loc: {
                                                        start: {
                                                            line: 20,
                                                            column: 27,
                                                            fixed: true,
                                                            source: 'glass/html/forms/DateInput.ion'
                                                        },
                                                        end: {
                                                            line: 20,
                                                            column: 31,
                                                            fixed: true,
                                                            source: 'glass/html/forms/DateInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: 'date'
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    }],
                                loc: {
                                    start: {
                                        line: 20,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/forms/DateInput.ion'
                                    },
                                    end: {
                                        line: 20,
                                        column: 40,
                                        fixed: true,
                                        source: 'glass/html/forms/DateInput.ion'
                                    }
                                }
                            },
                            properties: [{
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context2) {
                                            return function input(e) {
                                                var state = _context2.get('state'), setTextInputValue = _context2.get('setTextInputValue'), setTimeInputValue = _context2.get('setTimeInputValue'), dispatch = _context2.get('dispatch');
                                                state.date = (this.value != null ? this.value.length : void 0) > 0 ? this.value : null;
                                                if (!state.date) {
                                                    state.time = null;
                                                }
                                                setTextInputValue();
                                                setTimeInputValue();
                                                dispatch();
                                                e.stopPropagation();
                                            };
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 21,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/forms/DateInput.ion'
                                        },
                                        end: {
                                            line: 30,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/forms/DateInput.ion'
                                        }
                                    },
                                    order: '0'
                                }]
                        }
                    }],
                kind: 'let',
                order: '3'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'timeInput',
                            loc: {
                                start: {
                                    line: 30,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/forms/DateInput.ion'
                                },
                                end: {
                                    line: 30,
                                    column: 17,
                                    fixed: true,
                                    source: 'glass/html/forms/DateInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Input',
                                    loc: {
                                        start: {
                                            line: 30,
                                            column: 20,
                                            fixed: true,
                                            source: 'glass/html/forms/DateInput.ion'
                                        },
                                        end: {
                                            line: 30,
                                            column: 25,
                                            fixed: true,
                                            source: 'glass/html/forms/DateInput.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'type',
                                                    loc: {
                                                        start: {
                                                            line: 30,
                                                            column: 27,
                                                            fixed: true,
                                                            source: 'glass/html/forms/DateInput.ion'
                                                        },
                                                        end: {
                                                            line: 30,
                                                            column: 31,
                                                            fixed: true,
                                                            source: 'glass/html/forms/DateInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: 'time'
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    }],
                                loc: {
                                    start: {
                                        line: 30,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/forms/DateInput.ion'
                                    },
                                    end: {
                                        line: 30,
                                        column: 40,
                                        fixed: true,
                                        source: 'glass/html/forms/DateInput.ion'
                                    }
                                }
                            },
                            properties: [{
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context3) {
                                            return function input(e) {
                                                var state = _context3.get('state'), setTextInputValue = _context3.get('setTextInputValue'), dispatch = _context3.get('dispatch');
                                                state.time = (this.value != null ? this.value.length : void 0) > 0 ? this.value : null;
                                                setTextInputValue();
                                                dispatch();
                                                e.stopPropagation();
                                            };
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 31,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/forms/DateInput.ion'
                                        },
                                        end: {
                                            line: 37,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/forms/DateInput.ion'
                                        }
                                    },
                                    order: '0'
                                }]
                        }
                    }],
                kind: 'let',
                order: '4'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'getDateTime',
                            loc: {
                                start: {
                                    line: 37,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/forms/DateInput.ion'
                                },
                                end: {
                                    line: 37,
                                    column: 19,
                                    fixed: true,
                                    source: 'glass/html/forms/DateInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'Function',
                            context: true,
                            value: function (_context4) {
                                return function () {
                                    var state = _context4.get('state');
                                    var value = state.date ? state.date + (state.time ? 'T' + state.time : '') : null;
                                    return value;
                                };
                            }
                        }
                    }],
                kind: 'let',
                order: '5'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'setDateTime',
                            loc: {
                                start: {
                                    line: 41,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/forms/DateInput.ion'
                                },
                                end: {
                                    line: 41,
                                    column: 19,
                                    fixed: true,
                                    source: 'glass/html/forms/DateInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'Function',
                            context: true,
                            value: function (_context5) {
                                return function (value, updateInputs) {
                                    var state = _context5.get('state'), textInput = _context5.get('textInput'), setTextInputValue = _context5.get('setTextInputValue'), setDateInputValue = _context5.get('setDateInputValue'), setTimeInputValue = _context5.get('setTimeInputValue');
                                    if (!value) {
                                        state.date = state.time = null;
                                    } else {
                                        if (value.length === 1) {
                                            textInput.value = value;
                                            updateInputs = false;
                                        } else {
                                            var params = {};
                                            var date = Date.create(value, { params: params });
                                            if (date != null && !isNaN(date.getTime())) {
                                                var iso = date.toISOString();
                                                if (params.week || params.weekday || params.date || params.month || params.year || params.day) {
                                                    state.date = date.format('{yyyy}-{MM}-{dd}');
                                                } else {
                                                    state.date = null;
                                                }
                                                if (state.date != null && (params.hour || params.ampm || date.getHours() !== 0 || date.getMinutes() !== 0)) {
                                                    state.time = date.format('{HH}:{mm}:{ss}');
                                                } else {
                                                    state.time = null;
                                                }
                                            }
                                        }
                                    }
                                    if (updateInputs) {
                                        setTextInputValue();
                                        setDateInputValue();
                                        setTimeInputValue();
                                    }
                                };
                            }
                        }
                    }],
                kind: 'let',
                order: '6'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'getTextInputValue',
                            loc: {
                                start: {
                                    line: 69,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/forms/DateInput.ion'
                                },
                                end: {
                                    line: 69,
                                    column: 25,
                                    fixed: true,
                                    source: 'glass/html/forms/DateInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'Function',
                            context: true,
                            value: function (_context6) {
                                return function () {
                                    var getDateTime = _context6.get('getDateTime'), state = _context6.get('state');
                                    var value = getDateTime();
                                    if (!(value != null)) {
                                        return '';
                                    }
                                    var format;
                                    if (state.date && state.time) {
                                        format = '{long}';
                                    } else if (state.date) {
                                        format = '{medium}';
                                    } else {
                                        return '';
                                    }
                                    return Date.create(value).format(format);
                                };
                            }
                        }
                    }],
                kind: 'let',
                order: '7'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'setTextInputValue',
                            loc: {
                                start: {
                                    line: 81,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/forms/DateInput.ion'
                                },
                                end: {
                                    line: 81,
                                    column: 25,
                                    fixed: true,
                                    source: 'glass/html/forms/DateInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'Function',
                            context: true,
                            value: function (_context7) {
                                return function () {
                                    var textInput = _context7.get('textInput'), getTextInputValue = _context7.get('getTextInputValue');
                                    textInput.value = getTextInputValue();
                                };
                            }
                        }
                    }],
                kind: 'let',
                order: '8'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'setDateInputValue',
                            loc: {
                                start: {
                                    line: 83,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/forms/DateInput.ion'
                                },
                                end: {
                                    line: 83,
                                    column: 25,
                                    fixed: true,
                                    source: 'glass/html/forms/DateInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'Function',
                            context: true,
                            value: function (_context8) {
                                return function () {
                                    var dateInput = _context8.get('dateInput'), state = _context8.get('state');
                                    dateInput.value = state.date != null ? state.date : '';
                                };
                            }
                        }
                    }],
                kind: 'let',
                order: '9'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'setTimeInputValue',
                            loc: {
                                start: {
                                    line: 85,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/forms/DateInput.ion'
                                },
                                end: {
                                    line: 85,
                                    column: 25,
                                    fixed: true,
                                    source: 'glass/html/forms/DateInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'Function',
                            context: true,
                            value: function (_context9) {
                                return function () {
                                    var timeInput = _context9.get('timeInput'), state = _context9.get('state');
                                    timeInput.value = state.time != null ? state.time : '';
                                };
                            }
                        }
                    }],
                kind: 'let',
                order: ':'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'element',
                            loc: {
                                start: {
                                    line: 88,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/forms/DateInput.ion'
                                },
                                end: {
                                    line: 88,
                                    column: 15,
                                    fixed: true,
                                    source: 'glass/html/forms/DateInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Div',
                                loc: {
                                    start: {
                                        line: 88,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/forms/DateInput.ion'
                                    },
                                    end: {
                                        line: 88,
                                        column: 21,
                                        fixed: true,
                                        source: 'glass/html/forms/DateInput.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ObjectExpression',
                                    properties: [{
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'class',
                                                loc: {
                                                    start: {
                                                        line: 88,
                                                        column: 23,
                                                        fixed: true,
                                                        source: 'glass/html/forms/DateInput.ion'
                                                    },
                                                    end: {
                                                        line: 88,
                                                        column: 28,
                                                        fixed: true,
                                                        source: 'glass/html/forms/DateInput.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: 'DateInput'
                                            },
                                            kind: 'init',
                                            order: '0'
                                        }]
                                }],
                            loc: {
                                start: {
                                    line: 88,
                                    column: 18,
                                    fixed: true,
                                    source: 'glass/html/forms/DateInput.ion'
                                },
                                end: {
                                    line: 88,
                                    column: 42,
                                    fixed: true,
                                    source: 'glass/html/forms/DateInput.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: ';'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'dispatch',
                            loc: {
                                start: {
                                    line: 89,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/forms/DateInput.ion'
                                },
                                end: {
                                    line: 89,
                                    column: 16,
                                    fixed: true,
                                    source: 'glass/html/forms/DateInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'Function',
                            context: true,
                            value: function (_context10) {
                                return function () {
                                    var element = _context10.get('element');
                                    return element.dispatchEvent(new CustomEvent('change'));
                                };
                            }
                        }
                    }],
                kind: 'let',
                order: '<'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'CallExpression',
                    callee: {
                        type: 'MemberExpression',
                        object: {
                            type: 'Identifier',
                            name: 'Object'
                        },
                        property: {
                            type: 'Identifier',
                            name: 'defineProperties'
                        }
                    },
                    arguments: [
                        {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'Identifier',
                                name: 'element',
                                loc: {
                                    start: {
                                        line: 90,
                                        column: 11,
                                        fixed: true,
                                        source: 'glass/html/forms/DateInput.ion'
                                    },
                                    end: {
                                        line: 90,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/forms/DateInput.ion'
                                    }
                                }
                            },
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'textInput',
                                        loc: {
                                            start: {
                                                line: 91,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/forms/DateInput.ion'
                                            },
                                            end: {
                                                line: 91,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/forms/DateInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Identifier',
                                        name: 'textInput',
                                        loc: {
                                            start: {
                                                line: 91,
                                                column: 19,
                                                fixed: true,
                                                source: 'glass/html/forms/DateInput.ion'
                                            },
                                            end: {
                                                line: 91,
                                                column: 28,
                                                fixed: true,
                                                source: 'glass/html/forms/DateInput.ion'
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'dateInput',
                                        loc: {
                                            start: {
                                                line: 92,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/forms/DateInput.ion'
                                            },
                                            end: {
                                                line: 92,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/forms/DateInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Identifier',
                                        name: 'dateInput',
                                        loc: {
                                            start: {
                                                line: 92,
                                                column: 19,
                                                fixed: true,
                                                source: 'glass/html/forms/DateInput.ion'
                                            },
                                            end: {
                                                line: 92,
                                                column: 28,
                                                fixed: true,
                                                source: 'glass/html/forms/DateInput.ion'
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '1'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'timeInput',
                                        loc: {
                                            start: {
                                                line: 93,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/forms/DateInput.ion'
                                            },
                                            end: {
                                                line: 93,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/forms/DateInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Identifier',
                                        name: 'timeInput',
                                        loc: {
                                            start: {
                                                line: 93,
                                                column: 19,
                                                fixed: true,
                                                source: 'glass/html/forms/DateInput.ion'
                                            },
                                            end: {
                                                line: 93,
                                                column: 28,
                                                fixed: true,
                                                source: 'glass/html/forms/DateInput.ion'
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '2'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'focus',
                                        loc: {
                                            start: {
                                                line: 94,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/forms/DateInput.ion'
                                            },
                                            end: {
                                                line: 94,
                                                column: 13,
                                                fixed: true,
                                                source: 'glass/html/forms/DateInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context11) {
                                            return function () {
                                                var textInput = _context11.get('textInput');
                                                textInput.focus();
                                            };
                                        }
                                    },
                                    kind: 'init',
                                    order: '3'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'ObjectExpression',
                                        objectType: {
                                            type: 'Identifier',
                                            name: 'textInput',
                                            loc: {
                                                start: {
                                                    line: 96,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'glass/html/forms/DateInput.ion'
                                                },
                                                end: {
                                                    line: 96,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'glass/html/forms/DateInput.ion'
                                                }
                                            }
                                        },
                                        properties: [{
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'ObjectExpression',
                                                    objectType: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'Identifier',
                                                            name: 'Div',
                                                            loc: {
                                                                start: {
                                                                    line: 97,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/DateInput.ion'
                                                                },
                                                                end: {
                                                                    line: 97,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/DateInput.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [{
                                                                type: 'ObjectExpression',
                                                                properties: [{
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'suffix',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 97,
                                                                                    column: 17,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/forms/DateInput.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 97,
                                                                                    column: 23,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/forms/DateInput.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Literal',
                                                                            value: true
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    }]
                                                            }],
                                                        loc: {
                                                            start: {
                                                                line: 97,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'glass/html/forms/DateInput.ion'
                                                            },
                                                            end: {
                                                                line: 97,
                                                                column: 30,
                                                                fixed: true,
                                                                source: 'glass/html/forms/DateInput.ion'
                                                            }
                                                        }
                                                    },
                                                    properties: [
                                                        {
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'ObjectExpression',
                                                                objectType: {
                                                                    type: 'Identifier',
                                                                    name: 'dateInput',
                                                                    loc: {
                                                                        start: {
                                                                            line: 98,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/forms/DateInput.ion'
                                                                        },
                                                                        end: {
                                                                            line: 98,
                                                                            column: 25,
                                                                            fixed: true,
                                                                            source: 'glass/html/forms/DateInput.ion'
                                                                        }
                                                                    }
                                                                },
                                                                properties: [{
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'style',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 99,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/forms/DateInput.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 99,
                                                                                    column: 25,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/forms/DateInput.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'ObjectExpression',
                                                                            properties: [
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'fontFamily',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 100,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/forms/DateInput.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 100,
                                                                                                column: 34,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/forms/DateInput.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Literal',
                                                                                        value: 'courier'
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'width',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 101,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/forms/DateInput.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 101,
                                                                                                column: 29,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/forms/DateInput.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Literal',
                                                                                        value: '155px'
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '1'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'color',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 102,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/forms/DateInput.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 102,
                                                                                                column: 29,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/forms/DateInput.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Literal',
                                                                                        value: '#999999'
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '2'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'marginRight',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 103,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/forms/DateInput.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 103,
                                                                                                column: 35,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/forms/DateInput.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Literal',
                                                                                        value: '10px'
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '3'
                                                                                }
                                                                            ]
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    }]
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 98,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/DateInput.ion'
                                                                },
                                                                end: {
                                                                    line: 104,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/DateInput.ion'
                                                                }
                                                            },
                                                            order: '0'
                                                        },
                                                        {
                                                            type: 'IfStatement',
                                                            test: {
                                                                type: 'Identifier',
                                                                name: 'showTime',
                                                                loc: {
                                                                    start: {
                                                                        line: 104,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/DateInput.ion'
                                                                    },
                                                                    end: {
                                                                        line: 104,
                                                                        column: 27,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/DateInput.ion'
                                                                    }
                                                                }
                                                            },
                                                            consequent: {
                                                                type: 'BlockStatement',
                                                                body: [{
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'ObjectExpression',
                                                                            objectType: {
                                                                                type: 'Identifier',
                                                                                name: 'timeInput',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 105,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/forms/DateInput.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 105,
                                                                                        column: 29,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/forms/DateInput.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            properties: [{
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'style',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 106,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/forms/DateInput.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 106,
                                                                                                column: 29,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/forms/DateInput.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'ObjectExpression',
                                                                                        properties: [
                                                                                            {
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'fontFamily',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 107,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/DateInput.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 107,
                                                                                                            column: 38,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/DateInput.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'Literal',
                                                                                                    value: 'courier'
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '0'
                                                                                            },
                                                                                            {
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'width',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 108,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/DateInput.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 108,
                                                                                                            column: 33,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/DateInput.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'Literal',
                                                                                                    value: '115px'
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '1'
                                                                                            },
                                                                                            {
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'color',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 109,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/DateInput.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 109,
                                                                                                            column: 33,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/DateInput.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'Literal',
                                                                                                    value: '#999999'
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '2'
                                                                                            }
                                                                                        ]
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                }]
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 105,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/forms/DateInput.ion'
                                                                            },
                                                                            end: {
                                                                                line: 110,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'glass/html/forms/DateInput.ion'
                                                                            }
                                                                        },
                                                                        order: '0'
                                                                    }]
                                                            },
                                                            alternate: null,
                                                            order: '1'
                                                        }
                                                    ]
                                                },
                                                loc: {
                                                    start: {
                                                        line: 97,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/forms/DateInput.ion'
                                                    },
                                                    end: {
                                                        line: 110,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'glass/html/forms/DateInput.ion'
                                                    }
                                                },
                                                order: '0'
                                            }]
                                    },
                                    loc: {
                                        start: {
                                            line: 96,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/forms/DateInput.ion'
                                        },
                                        end: {
                                            line: 110,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/forms/DateInput.ion'
                                        }
                                    },
                                    order: '4'
                                }
                            ]
                        },
                        {
                            type: 'ObjectExpression',
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'label',
                                        loc: {
                                            start: {
                                                line: 110,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/forms/DateInput.ion'
                                            },
                                            end: {
                                                line: 110,
                                                column: 22,
                                                fixed: true,
                                                source: 'glass/html/forms/DateInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 111,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/forms/DateInput.ion'
                                                        },
                                                        end: {
                                                            line: 111,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/forms/DateInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context12) {
                                                        return function () {
                                                            var textInput = _context12.get('textInput');
                                                            return textInput.label;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 112,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/forms/DateInput.ion'
                                                        },
                                                        end: {
                                                            line: 112,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/forms/DateInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context13) {
                                                        return function (value) {
                                                            var textInput = _context13.get('textInput');
                                                            return textInput.label = value;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'alwaysFloatLabel',
                                        loc: {
                                            start: {
                                                line: 113,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/forms/DateInput.ion'
                                            },
                                            end: {
                                                line: 113,
                                                column: 33,
                                                fixed: true,
                                                source: 'glass/html/forms/DateInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 114,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/forms/DateInput.ion'
                                                        },
                                                        end: {
                                                            line: 114,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/forms/DateInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context14) {
                                                        return function () {
                                                            var textInput = _context14.get('textInput');
                                                            return textInput.alwaysFloatLabel;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 115,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/forms/DateInput.ion'
                                                        },
                                                        end: {
                                                            line: 115,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/forms/DateInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context15) {
                                                        return function (value) {
                                                            var textInput = _context15.get('textInput');
                                                            return textInput.alwaysFloatLabel = value;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '1'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'value',
                                        loc: {
                                            start: {
                                                line: 116,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/forms/DateInput.ion'
                                            },
                                            end: {
                                                line: 116,
                                                column: 22,
                                                fixed: true,
                                                source: 'glass/html/forms/DateInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 117,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/forms/DateInput.ion'
                                                        },
                                                        end: {
                                                            line: 117,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/forms/DateInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Identifier',
                                                    name: 'getDateTime',
                                                    loc: {
                                                        start: {
                                                            line: 117,
                                                            column: 17,
                                                            fixed: true,
                                                            source: 'glass/html/forms/DateInput.ion'
                                                        },
                                                        end: {
                                                            line: 117,
                                                            column: 28,
                                                            fixed: true,
                                                            source: 'glass/html/forms/DateInput.ion'
                                                        }
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 118,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/forms/DateInput.ion'
                                                        },
                                                        end: {
                                                            line: 118,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/forms/DateInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context16) {
                                                        return function (value) {
                                                            var setDateTime = _context16.get('setDateTime');
                                                            return setDateTime(value, true);
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '2'
                                }
                            ]
                        }
                    ]
                },
                order: '='
            }
        ],
        bound: false
    }, {
        this: this,
        options: options,
        _ref: _ref,
        style: style,
        _ref2: _ref2
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/forms/DateInput',_glass_html_forms_DateInput_);
    else
      _glass_html_forms_DateInput_.call(this, module, exports, require);
  }
  else {
    _glass_html_forms_DateInput_.call(this);
  }
}).call(this)
void (function(){var _glass_html_forms_DurationInput_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('../../time');
var Duration = _ref.Duration;
module.exports = exports = ion.template(function DurationInput(attributes) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'DurationInput',
            loc: {
                start: {
                    line: 5,
                    column: 16,
                    fixed: true,
                    source: 'glass/html/forms/DurationInput.ion'
                },
                end: {
                    line: 5,
                    column: 29,
                    fixed: true,
                    source: 'glass/html/forms/DurationInput.ion'
                }
            }
        },
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'setUnitFromChar',
                            loc: {
                                start: {
                                    line: 6,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/forms/DurationInput.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 23,
                                    fixed: true,
                                    source: 'glass/html/forms/DurationInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'Function',
                            context: true,
                            value: function (_context) {
                                return function (key) {
                                    var unitInput = _context.get('unitInput');
                                    var _ref2 = unitInput;
                                    var options = _ref2.options;
                                    var selectedIndex = _ref2.selectedIndex;
                                    var startIndex = unitInput.selectedIndex + 1;
                                    for (var i = 1; i <= options.length; i++) {
                                        var checkIndex = (selectedIndex + i) % options.length;
                                        var option = options[checkIndex];
                                        if (option.value.toLowerCase().startsWith(key.toLowerCase())) {
                                            option.selected = true;
                                            return;
                                        }
                                    }
                                };
                            }
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'numberInput',
                            loc: {
                                start: {
                                    line: 16,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/forms/DurationInput.ion'
                                },
                                end: {
                                    line: 16,
                                    column: 19,
                                    fixed: true,
                                    source: 'glass/html/forms/DurationInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'PaperInput',
                                    loc: {
                                        start: {
                                            line: 16,
                                            column: 22,
                                            fixed: true,
                                            source: 'glass/html/forms/DurationInput.ion'
                                        },
                                        end: {
                                            line: 16,
                                            column: 32,
                                            fixed: true,
                                            source: 'glass/html/forms/DurationInput.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'type',
                                                    loc: {
                                                        start: {
                                                            line: 16,
                                                            column: 34,
                                                            fixed: true,
                                                            source: 'glass/html/forms/DurationInput.ion'
                                                        },
                                                        end: {
                                                            line: 16,
                                                            column: 38,
                                                            fixed: true,
                                                            source: 'glass/html/forms/DurationInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: 'number'
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    }],
                                loc: {
                                    start: {
                                        line: 16,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/forms/DurationInput.ion'
                                    },
                                    end: {
                                        line: 16,
                                        column: 49,
                                        fixed: true,
                                        source: 'glass/html/forms/DurationInput.ion'
                                    }
                                }
                            },
                            properties: [{
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context2) {
                                            return function keydown(e) {
                                                var setUnitFromChar = _context2.get('setUnitFromChar');
                                                setUnitFromChar(e.key);
                                            };
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 17,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/forms/DurationInput.ion'
                                        },
                                        end: {
                                            line: 19,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/forms/DurationInput.ion'
                                        }
                                    },
                                    order: '0'
                                }]
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'unitInput',
                            loc: {
                                start: {
                                    line: 19,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/forms/DurationInput.ion'
                                },
                                end: {
                                    line: 19,
                                    column: 17,
                                    fixed: true,
                                    source: 'glass/html/forms/DurationInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Select',
                                    loc: {
                                        start: {
                                            line: 19,
                                            column: 20,
                                            fixed: true,
                                            source: 'glass/html/forms/DurationInput.ion'
                                        },
                                        end: {
                                            line: 19,
                                            column: 26,
                                            fixed: true,
                                            source: 'glass/html/forms/DurationInput.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'suffix',
                                                    loc: {
                                                        start: {
                                                            line: 19,
                                                            column: 28,
                                                            fixed: true,
                                                            source: 'glass/html/forms/DurationInput.ion'
                                                        },
                                                        end: {
                                                            line: 19,
                                                            column: 34,
                                                            fixed: true,
                                                            source: 'glass/html/forms/DurationInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: true
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    }],
                                loc: {
                                    start: {
                                        line: 19,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/forms/DurationInput.ion'
                                    },
                                    end: {
                                        line: 19,
                                        column: 41,
                                        fixed: true,
                                        source: 'glass/html/forms/DurationInput.ion'
                                    }
                                }
                            },
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'style',
                                        loc: {
                                            start: {
                                                line: 20,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/forms/DurationInput.ion'
                                            },
                                            end: {
                                                line: 20,
                                                column: 13,
                                                fixed: true,
                                                source: 'glass/html/forms/DurationInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'border',
                                                    loc: {
                                                        start: {
                                                            line: 21,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/forms/DurationInput.ion'
                                                        },
                                                        end: {
                                                            line: 21,
                                                            column: 18,
                                                            fixed: true,
                                                            source: 'glass/html/forms/DurationInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: 'none'
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'background',
                                                    loc: {
                                                        start: {
                                                            line: 22,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/forms/DurationInput.ion'
                                                        },
                                                        end: {
                                                            line: 22,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'glass/html/forms/DurationInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: 'none'
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    order: '0'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'ObjectExpression',
                                        objectType: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'Identifier',
                                                name: 'Option',
                                                loc: {
                                                    start: {
                                                        line: 23,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'glass/html/forms/DurationInput.ion'
                                                    },
                                                    end: {
                                                        line: 23,
                                                        column: 14,
                                                        fixed: true,
                                                        source: 'glass/html/forms/DurationInput.ion'
                                                    }
                                                }
                                            },
                                            arguments: [{
                                                    type: 'ObjectExpression',
                                                    properties: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'value',
                                                                loc: {
                                                                    start: {
                                                                        line: 23,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/DurationInput.ion'
                                                                    },
                                                                    end: {
                                                                        line: 23,
                                                                        column: 21,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/DurationInput.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Literal',
                                                                value: 'days'
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                }],
                                            loc: {
                                                start: {
                                                    line: 23,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'glass/html/forms/DurationInput.ion'
                                                },
                                                end: {
                                                    line: 23,
                                                    column: 30,
                                                    fixed: true,
                                                    source: 'glass/html/forms/DurationInput.ion'
                                                }
                                            }
                                        },
                                        properties: [{
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'Literal',
                                                    value: 'Days'
                                                },
                                                loc: {
                                                    start: {
                                                        line: 24,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/forms/DurationInput.ion'
                                                    },
                                                    end: {
                                                        line: 24,
                                                        column: 18,
                                                        fixed: true,
                                                        source: 'glass/html/forms/DurationInput.ion'
                                                    }
                                                },
                                                order: '0'
                                            }]
                                    },
                                    loc: {
                                        start: {
                                            line: 23,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/forms/DurationInput.ion'
                                        },
                                        end: {
                                            line: 25,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/forms/DurationInput.ion'
                                        }
                                    },
                                    order: '1'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'ObjectExpression',
                                        objectType: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'Identifier',
                                                name: 'Option',
                                                loc: {
                                                    start: {
                                                        line: 25,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'glass/html/forms/DurationInput.ion'
                                                    },
                                                    end: {
                                                        line: 25,
                                                        column: 14,
                                                        fixed: true,
                                                        source: 'glass/html/forms/DurationInput.ion'
                                                    }
                                                }
                                            },
                                            arguments: [{
                                                    type: 'ObjectExpression',
                                                    properties: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'value',
                                                                loc: {
                                                                    start: {
                                                                        line: 25,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/DurationInput.ion'
                                                                    },
                                                                    end: {
                                                                        line: 25,
                                                                        column: 21,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/DurationInput.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Literal',
                                                                value: 'hours'
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                }],
                                            loc: {
                                                start: {
                                                    line: 25,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'glass/html/forms/DurationInput.ion'
                                                },
                                                end: {
                                                    line: 25,
                                                    column: 31,
                                                    fixed: true,
                                                    source: 'glass/html/forms/DurationInput.ion'
                                                }
                                            }
                                        },
                                        properties: [{
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'Literal',
                                                    value: 'Hours'
                                                },
                                                loc: {
                                                    start: {
                                                        line: 26,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/forms/DurationInput.ion'
                                                    },
                                                    end: {
                                                        line: 26,
                                                        column: 19,
                                                        fixed: true,
                                                        source: 'glass/html/forms/DurationInput.ion'
                                                    }
                                                },
                                                order: '0'
                                            }]
                                    },
                                    loc: {
                                        start: {
                                            line: 25,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/forms/DurationInput.ion'
                                        },
                                        end: {
                                            line: 27,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/forms/DurationInput.ion'
                                        }
                                    },
                                    order: '2'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'ObjectExpression',
                                        objectType: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'Identifier',
                                                name: 'Option',
                                                loc: {
                                                    start: {
                                                        line: 27,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'glass/html/forms/DurationInput.ion'
                                                    },
                                                    end: {
                                                        line: 27,
                                                        column: 14,
                                                        fixed: true,
                                                        source: 'glass/html/forms/DurationInput.ion'
                                                    }
                                                }
                                            },
                                            arguments: [{
                                                    type: 'ObjectExpression',
                                                    properties: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'value',
                                                                loc: {
                                                                    start: {
                                                                        line: 27,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/DurationInput.ion'
                                                                    },
                                                                    end: {
                                                                        line: 27,
                                                                        column: 21,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/DurationInput.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Literal',
                                                                value: 'minutes'
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                }],
                                            loc: {
                                                start: {
                                                    line: 27,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'glass/html/forms/DurationInput.ion'
                                                },
                                                end: {
                                                    line: 27,
                                                    column: 33,
                                                    fixed: true,
                                                    source: 'glass/html/forms/DurationInput.ion'
                                                }
                                            }
                                        },
                                        properties: [{
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'Literal',
                                                    value: 'Minutes'
                                                },
                                                loc: {
                                                    start: {
                                                        line: 28,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/forms/DurationInput.ion'
                                                    },
                                                    end: {
                                                        line: 28,
                                                        column: 21,
                                                        fixed: true,
                                                        source: 'glass/html/forms/DurationInput.ion'
                                                    }
                                                },
                                                order: '0'
                                            }]
                                    },
                                    loc: {
                                        start: {
                                            line: 27,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/forms/DurationInput.ion'
                                        },
                                        end: {
                                            line: 29,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/forms/DurationInput.ion'
                                        }
                                    },
                                    order: '3'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'ObjectExpression',
                                        objectType: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'Identifier',
                                                name: 'Option',
                                                loc: {
                                                    start: {
                                                        line: 29,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'glass/html/forms/DurationInput.ion'
                                                    },
                                                    end: {
                                                        line: 29,
                                                        column: 14,
                                                        fixed: true,
                                                        source: 'glass/html/forms/DurationInput.ion'
                                                    }
                                                }
                                            },
                                            arguments: [{
                                                    type: 'ObjectExpression',
                                                    properties: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'value',
                                                                loc: {
                                                                    start: {
                                                                        line: 29,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/DurationInput.ion'
                                                                    },
                                                                    end: {
                                                                        line: 29,
                                                                        column: 21,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/DurationInput.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Literal',
                                                                value: 'weeks'
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                }],
                                            loc: {
                                                start: {
                                                    line: 29,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'glass/html/forms/DurationInput.ion'
                                                },
                                                end: {
                                                    line: 29,
                                                    column: 31,
                                                    fixed: true,
                                                    source: 'glass/html/forms/DurationInput.ion'
                                                }
                                            }
                                        },
                                        properties: [{
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'Literal',
                                                    value: 'Weeks'
                                                },
                                                loc: {
                                                    start: {
                                                        line: 30,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/forms/DurationInput.ion'
                                                    },
                                                    end: {
                                                        line: 30,
                                                        column: 19,
                                                        fixed: true,
                                                        source: 'glass/html/forms/DurationInput.ion'
                                                    }
                                                },
                                                order: '0'
                                            }]
                                    },
                                    loc: {
                                        start: {
                                            line: 29,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/forms/DurationInput.ion'
                                        },
                                        end: {
                                            line: 31,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/forms/DurationInput.ion'
                                        }
                                    },
                                    order: '4'
                                }
                            ]
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'CallExpression',
                    callee: {
                        type: 'MemberExpression',
                        object: {
                            type: 'Identifier',
                            name: 'Object'
                        },
                        property: {
                            type: 'Identifier',
                            name: 'defineProperties'
                        }
                    },
                    arguments: [
                        {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Div',
                                    loc: {
                                        start: {
                                            line: 31,
                                            column: 11,
                                            fixed: true,
                                            source: 'glass/html/forms/DurationInput.ion'
                                        },
                                        end: {
                                            line: 31,
                                            column: 14,
                                            fixed: true,
                                            source: 'glass/html/forms/DurationInput.ion'
                                        }
                                    }
                                },
                                arguments: [],
                                loc: {
                                    start: {
                                        line: 31,
                                        column: 11,
                                        fixed: true,
                                        source: 'glass/html/forms/DurationInput.ion'
                                    },
                                    end: {
                                        line: 31,
                                        column: 16,
                                        fixed: true,
                                        source: 'glass/html/forms/DurationInput.ion'
                                    }
                                }
                            },
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'numberInput',
                                        loc: {
                                            start: {
                                                line: 32,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/forms/DurationInput.ion'
                                            },
                                            end: {
                                                line: 32,
                                                column: 19,
                                                fixed: true,
                                                source: 'glass/html/forms/DurationInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Identifier',
                                        name: 'numberInput',
                                        loc: {
                                            start: {
                                                line: 32,
                                                column: 21,
                                                fixed: true,
                                                source: 'glass/html/forms/DurationInput.ion'
                                            },
                                            end: {
                                                line: 32,
                                                column: 32,
                                                fixed: true,
                                                source: 'glass/html/forms/DurationInput.ion'
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'unitInput',
                                        loc: {
                                            start: {
                                                line: 33,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/forms/DurationInput.ion'
                                            },
                                            end: {
                                                line: 33,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/forms/DurationInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Identifier',
                                        name: 'unitInput',
                                        loc: {
                                            start: {
                                                line: 33,
                                                column: 19,
                                                fixed: true,
                                                source: 'glass/html/forms/DurationInput.ion'
                                            },
                                            end: {
                                                line: 33,
                                                column: 28,
                                                fixed: true,
                                                source: 'glass/html/forms/DurationInput.ion'
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '1'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'focus',
                                        loc: {
                                            start: {
                                                line: 34,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/forms/DurationInput.ion'
                                            },
                                            end: {
                                                line: 34,
                                                column: 13,
                                                fixed: true,
                                                source: 'glass/html/forms/DurationInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context3) {
                                            return function () {
                                                var numberInput = _context3.get('numberInput');
                                                numberInput.focus();
                                            };
                                        }
                                    },
                                    kind: 'init',
                                    order: '2'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'ObjectExpression',
                                        objectType: {
                                            type: 'Identifier',
                                            name: 'numberInput',
                                            loc: {
                                                start: {
                                                    line: 36,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'glass/html/forms/DurationInput.ion'
                                                },
                                                end: {
                                                    line: 36,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'glass/html/forms/DurationInput.ion'
                                                }
                                            }
                                        },
                                        properties: [{
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'Identifier',
                                                    name: 'unitInput',
                                                    loc: {
                                                        start: {
                                                            line: 37,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/forms/DurationInput.ion'
                                                        },
                                                        end: {
                                                            line: 37,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'glass/html/forms/DurationInput.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 37,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/forms/DurationInput.ion'
                                                    },
                                                    end: {
                                                        line: 37,
                                                        column: 21,
                                                        fixed: true,
                                                        source: 'glass/html/forms/DurationInput.ion'
                                                    }
                                                },
                                                order: '0'
                                            }]
                                    },
                                    loc: {
                                        start: {
                                            line: 36,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/forms/DurationInput.ion'
                                        },
                                        end: {
                                            line: 38,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/forms/DurationInput.ion'
                                        }
                                    },
                                    order: '3'
                                }
                            ]
                        },
                        {
                            type: 'ObjectExpression',
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'label',
                                        loc: {
                                            start: {
                                                line: 38,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/forms/DurationInput.ion'
                                            },
                                            end: {
                                                line: 38,
                                                column: 22,
                                                fixed: true,
                                                source: 'glass/html/forms/DurationInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 39,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/forms/DurationInput.ion'
                                                        },
                                                        end: {
                                                            line: 39,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/forms/DurationInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context4) {
                                                        return function () {
                                                            var numberInput = _context4.get('numberInput');
                                                            return numberInput.label;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 40,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/forms/DurationInput.ion'
                                                        },
                                                        end: {
                                                            line: 40,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/forms/DurationInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context5) {
                                                        return function (value) {
                                                            var numberInput = _context5.get('numberInput');
                                                            return numberInput.label = value;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'value',
                                        loc: {
                                            start: {
                                                line: 41,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/forms/DurationInput.ion'
                                            },
                                            end: {
                                                line: 41,
                                                column: 22,
                                                fixed: true,
                                                source: 'glass/html/forms/DurationInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 42,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/forms/DurationInput.ion'
                                                        },
                                                        end: {
                                                            line: 42,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/forms/DurationInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context6) {
                                                        return function () {
                                                            var numberInput = _context6.get('numberInput'), unitInput = _context6.get('unitInput'), Duration = _context6.get('Duration');
                                                            var number = numberInput.value;
                                                            if (number.length === 0) {
                                                                return null;
                                                            } else {
                                                                var _ref4 = {};
                                                                _ref4[unitInput.value] = number;
                                                                return new Duration(_ref4).toString();
                                                            }
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 48,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/forms/DurationInput.ion'
                                                        },
                                                        end: {
                                                            line: 48,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/forms/DurationInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context7) {
                                                        return function (value) {
                                                            var numberInput = _context7.get('numberInput'), Duration = _context7.get('Duration'), setUnitFromChar = _context7.get('setUnitFromChar');
                                                            if ((value != null ? value.length : void 0) === 1) {
                                                                numberInput.value = value;
                                                            } else {
                                                                var duration = Duration.parse(value);
                                                                if (duration != null) {
                                                                    for (var name in duration) {
                                                                        var unitValue = duration[name];
                                                                        if (unitValue !== 0) {
                                                                            numberInput.value = unitValue;
                                                                            var _ref3 = Duration.validProperties[name];
                                                                            var char = _ref3.char;
                                                                            setUnitFromChar(char);
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '1'
                                }
                            ]
                        }
                    ]
                },
                order: '3'
            }
        ],
        bound: false
    }, {
        this: this,
        attributes: attributes,
        _ref: _ref,
        Duration: Duration
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/forms/DurationInput',_glass_html_forms_DurationInput_);
    else
      _glass_html_forms_DurationInput_.call(this, module, exports, require);
  }
  else {
    _glass_html_forms_DurationInput_.call(this);
  }
}).call(this)
void (function(){var _glass_html_forms_EditForm_ = function(module,exports,require){'use strict';
var ion = require('ion');
var style = require('../style'), _ref, _ref2;
_ref = require('./');
var GlassForm = _ref.GlassForm;
var Field = _ref.Field;
_ref2 = require('../../data');
var Schema = _ref2.Schema;
module.exports = exports = ion.template(function (_ref3) {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'attributes',
                            loc: {
                                start: {
                                    line: 6,
                                    column: 18,
                                    fixed: true,
                                    source: 'glass/html/forms/EditForm.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 28,
                                    fixed: true,
                                    source: 'glass/html/forms/EditForm.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'attributes',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/forms/EditForm.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 28,
                                        fixed: true,
                                        source: 'glass/html/forms/EditForm.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'object',
                            loc: {
                                start: {
                                    line: 6,
                                    column: 30,
                                    fixed: true,
                                    source: 'glass/html/forms/EditForm.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 36,
                                    fixed: true,
                                    source: 'glass/html/forms/EditForm.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'object',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 30,
                                        fixed: true,
                                        source: 'glass/html/forms/EditForm.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 36,
                                        fixed: true,
                                        source: 'glass/html/forms/EditForm.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'properties',
                            loc: {
                                start: {
                                    line: 6,
                                    column: 38,
                                    fixed: true,
                                    source: 'glass/html/forms/EditForm.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 48,
                                    fixed: true,
                                    source: 'glass/html/forms/EditForm.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'properties',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 38,
                                        fixed: true,
                                        source: 'glass/html/forms/EditForm.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 48,
                                        fixed: true,
                                        source: 'glass/html/forms/EditForm.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'values',
                            loc: {
                                start: {
                                    line: 6,
                                    column: 50,
                                    fixed: true,
                                    source: 'glass/html/forms/EditForm.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 56,
                                    fixed: true,
                                    source: 'glass/html/forms/EditForm.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'values',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 50,
                                        fixed: true,
                                        source: 'glass/html/forms/EditForm.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 56,
                                        fixed: true,
                                        source: 'glass/html/forms/EditForm.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '3'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'state',
                            loc: {
                                start: {
                                    line: 7,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/forms/EditForm.ion'
                                },
                                end: {
                                    line: 7,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/html/forms/EditForm.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Function',
                                context: false,
                                value: function () {
                                    return {
                                        submitOnBlur: false,
                                        autoApplyValues: false
                                    };
                                }
                            },
                            arguments: [],
                            loc: {
                                start: {
                                    line: 7,
                                    column: 16,
                                    fixed: true,
                                    source: 'glass/html/forms/EditForm.ion'
                                },
                                end: {
                                    line: 7,
                                    column: 65,
                                    fixed: true,
                                    source: 'glass/html/forms/EditForm.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '4'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'CallExpression',
                    callee: {
                        type: 'MemberExpression',
                        object: {
                            type: 'Identifier',
                            name: 'Object'
                        },
                        property: {
                            type: 'Identifier',
                            name: 'defineProperties'
                        }
                    },
                    arguments: [
                        {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'GlassForm',
                                    loc: {
                                        start: {
                                            line: 8,
                                            column: 11,
                                            fixed: true,
                                            source: 'glass/html/forms/EditForm.ion'
                                        },
                                        end: {
                                            line: 8,
                                            column: 20,
                                            fixed: true,
                                            source: 'glass/html/forms/EditForm.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'Identifier',
                                        name: 'attributes',
                                        loc: {
                                            start: {
                                                line: 8,
                                                column: 21,
                                                fixed: true,
                                                source: 'glass/html/forms/EditForm.ion'
                                            },
                                            end: {
                                                line: 8,
                                                column: 31,
                                                fixed: true,
                                                source: 'glass/html/forms/EditForm.ion'
                                            }
                                        }
                                    }],
                                loc: {
                                    start: {
                                        line: 8,
                                        column: 11,
                                        fixed: true,
                                        source: 'glass/html/forms/EditForm.ion'
                                    },
                                    end: {
                                        line: 8,
                                        column: 32,
                                        fixed: true,
                                        source: 'glass/html/forms/EditForm.ion'
                                    }
                                }
                            },
                            properties: [
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'Function',
                                        context: false,
                                        value: function complete(e) {
                                            this.dispatchEvent(new CustomEvent('commit', { detail: this.detail }));
                                            if (this.autoApplyValues) {
                                                global.model.ops.begin();
                                                this.applyValues();
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 9,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/forms/EditForm.ion'
                                        },
                                        end: {
                                            line: 14,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/forms/EditForm.ion'
                                        }
                                    },
                                    order: '0'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'Function',
                                        context: false,
                                        value: function mousedown(e) {
                                            return e.stopPropagation();
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 20,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/forms/EditForm.ion'
                                        },
                                        end: {
                                            line: 20,
                                            column: 43,
                                            fixed: true,
                                            source: 'glass/html/forms/EditForm.ion'
                                        }
                                    },
                                    order: '1'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'Function',
                                        context: false,
                                        value: function keyup(e) {
                                            e.stopPropagation();
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 21,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/forms/EditForm.ion'
                                        },
                                        end: {
                                            line: 24,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/forms/EditForm.ion'
                                        }
                                    },
                                    order: '2'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'Function',
                                        context: false,
                                        value: function keypress(e) {
                                            e.stopPropagation();
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 24,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/forms/EditForm.ion'
                                        },
                                        end: {
                                            line: 27,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/forms/EditForm.ion'
                                        }
                                    },
                                    order: '3'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'Function',
                                        context: false,
                                        value: function keydown(e) {
                                            e.stopPropagation();
                                            if (e.keyCode === 27) {
                                                this.dispatchEvent(new CustomEvent('cancel'));
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 27,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/forms/EditForm.ion'
                                        },
                                        end: {
                                            line: 32,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/forms/EditForm.ion'
                                        }
                                    },
                                    order: '4'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'applyValues',
                                        loc: {
                                            start: {
                                                line: 32,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/forms/EditForm.ion'
                                            },
                                            end: {
                                                line: 32,
                                                column: 19,
                                                fixed: true,
                                                source: 'glass/html/forms/EditForm.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context) {
                                            return function (saveObjects) {
                                                var object = _context.get('object');
                                                if (Array.isArray(saveObjects)) {
                                                    for (var _i = 0; _i < saveObjects.length; _i++) {
                                                        var saveObject = saveObjects[_i];
                                                        this.setObjectPropertiesFromFields(saveObject);
                                                    }
                                                } else {
                                                    this.setObjectPropertiesFromFields(object);
                                                }
                                            };
                                        }
                                    },
                                    kind: 'init',
                                    order: '5'
                                },
                                {
                                    type: 'ForOfStatement',
                                    left: {
                                        type: 'VariableDeclaration',
                                        declarations: [{
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'property',
                                                    loc: {
                                                        start: {
                                                            line: 38,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/forms/EditForm.ion'
                                                        },
                                                        end: {
                                                            line: 38,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'glass/html/forms/EditForm.ion'
                                                        }
                                                    }
                                                },
                                                init: null
                                            }],
                                        kind: 'let'
                                    },
                                    right: {
                                        type: 'Identifier',
                                        name: 'properties',
                                        loc: {
                                            start: {
                                                line: 38,
                                                column: 24,
                                                fixed: true,
                                                source: 'glass/html/forms/EditForm.ion'
                                            },
                                            end: {
                                                line: 38,
                                                column: 34,
                                                fixed: true,
                                                source: 'glass/html/forms/EditForm.ion'
                                            }
                                        }
                                    },
                                    body: {
                                        type: 'BlockStatement',
                                        body: [
                                            {
                                                type: 'VariableDeclaration',
                                                declarations: [{
                                                        type: 'VariableDeclarator',
                                                        id: {
                                                            type: 'Identifier',
                                                            name: '_ref4'
                                                        },
                                                        init: {
                                                            type: 'Identifier',
                                                            name: 'property',
                                                            loc: {
                                                                start: {
                                                                    line: 39,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/EditForm.ion'
                                                                },
                                                                end: {
                                                                    line: 39,
                                                                    column: 33,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/EditForm.ion'
                                                                }
                                                            }
                                                        }
                                                    }],
                                                kind: 'let',
                                                order: '0'
                                            },
                                            {
                                                type: 'VariableDeclaration',
                                                declarations: [{
                                                        type: 'VariableDeclarator',
                                                        id: {
                                                            type: 'Identifier',
                                                            name: 'name',
                                                            loc: {
                                                                start: {
                                                                    line: 39,
                                                                    column: 17,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/EditForm.ion'
                                                                },
                                                                end: {
                                                                    line: 39,
                                                                    column: 21,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/EditForm.ion'
                                                                }
                                                            }
                                                        },
                                                        init: {
                                                            type: 'MemberExpression',
                                                            object: {
                                                                type: 'Identifier',
                                                                name: '_ref4'
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'name',
                                                                loc: {
                                                                    start: {
                                                                        line: 39,
                                                                        column: 17,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/EditForm.ion'
                                                                    },
                                                                    end: {
                                                                        line: 39,
                                                                        column: 21,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/EditForm.ion'
                                                                    }
                                                                }
                                                            },
                                                            computed: false
                                                        }
                                                    }],
                                                kind: 'let',
                                                order: '1'
                                            },
                                            {
                                                type: 'VariableDeclaration',
                                                declarations: [{
                                                        type: 'VariableDeclarator',
                                                        id: {
                                                            type: 'Identifier',
                                                            name: 'propertyValue',
                                                            loc: {
                                                                start: {
                                                                    line: 40,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/EditForm.ion'
                                                                },
                                                                end: {
                                                                    line: 40,
                                                                    column: 29,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/EditForm.ion'
                                                                }
                                                            }
                                                        },
                                                        init: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Function',
                                                                context: true,
                                                                value: function (_context2) {
                                                                    return function () {
                                                                        var values = _context2.get('values'), name = _context2.get('name'), Schema = _context2.get('Schema'), property = _context2.get('property'), object = _context2.get('object');
                                                                        return (values != null ? values.hasOwnProperty(name) : void 0) ? values[name] : Schema.get(property, object);
                                                                    };
                                                                }
                                                            },
                                                            arguments: [],
                                                            loc: {
                                                                start: {
                                                                    line: 40,
                                                                    column: 32,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/EditForm.ion'
                                                                },
                                                                end: {
                                                                    line: 40,
                                                                    column: 112,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/EditForm.ion'
                                                                }
                                                            }
                                                        }
                                                    }],
                                                kind: 'let',
                                                order: '2'
                                            },
                                            {
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'ObjectExpression',
                                                    objectType: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'Identifier',
                                                            name: 'Field',
                                                            loc: {
                                                                start: {
                                                                    line: 41,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/EditForm.ion'
                                                                },
                                                                end: {
                                                                    line: 41,
                                                                    column: 17,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/EditForm.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [{
                                                                type: 'ObjectExpression',
                                                                properties: [
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'property',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 41,
                                                                                    column: 19,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/forms/EditForm.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 41,
                                                                                    column: 27,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/forms/EditForm.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Identifier',
                                                                            name: 'property',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 41,
                                                                                    column: 19,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/forms/EditForm.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 41,
                                                                                    column: 27,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/forms/EditForm.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    },
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'object',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 41,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/forms/EditForm.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 41,
                                                                                    column: 34,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/forms/EditForm.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Identifier',
                                                                            name: 'object',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 41,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/forms/EditForm.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 41,
                                                                                    column: 34,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/forms/EditForm.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        kind: 'init',
                                                                        order: '1'
                                                                    },
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'value',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 41,
                                                                                    column: 35,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/forms/EditForm.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 41,
                                                                                    column: 40,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/forms/EditForm.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Identifier',
                                                                            name: 'propertyValue',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 41,
                                                                                    column: 41,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/forms/EditForm.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 41,
                                                                                    column: 54,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/forms/EditForm.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        kind: 'init',
                                                                        order: '2'
                                                                    }
                                                                ]
                                                            }],
                                                        loc: {
                                                            start: {
                                                                line: 41,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'glass/html/forms/EditForm.ion'
                                                            },
                                                            end: {
                                                                line: 41,
                                                                column: 56,
                                                                fixed: true,
                                                                source: 'glass/html/forms/EditForm.ion'
                                                            }
                                                        }
                                                    },
                                                    properties: [
                                                        {
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'Function',
                                                                context: true,
                                                                value: function (_context3) {
                                                                    return function blur(e) {
                                                                        var state = _context3.get('state');
                                                                        if (state.submitOnBlur) {
                                                                            this.closest('form').submit(e);
                                                                        }
                                                                    };
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 42,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/EditForm.ion'
                                                                },
                                                                end: {
                                                                    line: 45,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/EditForm.ion'
                                                                }
                                                            },
                                                            order: '0'
                                                        },
                                                        {
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'Function',
                                                                context: false,
                                                                value: function commit(e) {
                                                                    this.closest('form').submit(e);
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 45,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/EditForm.ion'
                                                                },
                                                                end: {
                                                                    line: 48,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/EditForm.ion'
                                                                }
                                                            },
                                                            order: '1'
                                                        }
                                                    ]
                                                },
                                                loc: {
                                                    start: {
                                                        line: 41,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/forms/EditForm.ion'
                                                    },
                                                    end: {
                                                        line: 48,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'glass/html/forms/EditForm.ion'
                                                    }
                                                },
                                                order: '3'
                                            }
                                        ]
                                    },
                                    remove: null,
                                    order: '6'
                                }
                            ]
                        },
                        {
                            type: 'ObjectExpression',
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'autoApplyValues',
                                        loc: {
                                            start: {
                                                line: 14,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/forms/EditForm.ion'
                                            },
                                            end: {
                                                line: 14,
                                                column: 32,
                                                fixed: true,
                                                source: 'glass/html/forms/EditForm.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 15,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/forms/EditForm.ion'
                                                        },
                                                        end: {
                                                            line: 15,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/forms/EditForm.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context4) {
                                                        return function () {
                                                            var state = _context4.get('state');
                                                            return state.autoApplyValues;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 16,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/forms/EditForm.ion'
                                                        },
                                                        end: {
                                                            line: 16,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/forms/EditForm.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context5) {
                                                        return function (value) {
                                                            var state = _context5.get('state');
                                                            return state.autoApplyValues = value;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'submitOnBlur',
                                        loc: {
                                            start: {
                                                line: 17,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/forms/EditForm.ion'
                                            },
                                            end: {
                                                line: 17,
                                                column: 29,
                                                fixed: true,
                                                source: 'glass/html/forms/EditForm.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 18,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/forms/EditForm.ion'
                                                        },
                                                        end: {
                                                            line: 18,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/forms/EditForm.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context6) {
                                                        return function () {
                                                            var state = _context6.get('state');
                                                            return state.submitOnBlur;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 19,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/forms/EditForm.ion'
                                                        },
                                                        end: {
                                                            line: 19,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/forms/EditForm.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context7) {
                                                        return function (value) {
                                                            var state = _context7.get('state');
                                                            return state.submitOnBlur = value;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '1'
                                }
                            ]
                        }
                    ]
                },
                order: '5'
            }
        ],
        bound: false
    }, {
        this: this,
        _ref3: _ref3,
        style: style,
        _ref: _ref,
        _ref2: _ref2,
        GlassForm: GlassForm,
        Field: Field,
        Schema: Schema
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/forms/EditForm',_glass_html_forms_EditForm_);
    else
      _glass_html_forms_EditForm_.call(this, module, exports, require);
  }
  else {
    _glass_html_forms_EditForm_.call(this);
  }
}).call(this)
void (function(){var _glass_html_forms_Field_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('./'), _ref2, _ref3, _ref4, _ref5, inputTypeMap = {
        uri: 'url',
        integer: 'number',
        string: 'text'
    }, FieldInternal = ion.template(function (args) {
        return ion.createRuntime({
            type: 'Template',
            id: null,
            body: [
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: '_ref6'
                            },
                            init: {
                                type: 'Identifier',
                                name: 'args',
                                loc: {
                                    start: {
                                        line: 18,
                                        column: 37,
                                        fixed: true,
                                        source: 'glass/html/forms/Field.ion'
                                    },
                                    end: {
                                        line: 18,
                                        column: 41,
                                        fixed: true,
                                        source: 'glass/html/forms/Field.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '0'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'property',
                                loc: {
                                    start: {
                                        line: 18,
                                        column: 13,
                                        fixed: true,
                                        source: 'glass/html/forms/Field.ion'
                                    },
                                    end: {
                                        line: 18,
                                        column: 21,
                                        fixed: true,
                                        source: 'glass/html/forms/Field.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref6'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'property',
                                    loc: {
                                        start: {
                                            line: 18,
                                            column: 13,
                                            fixed: true,
                                            source: 'glass/html/forms/Field.ion'
                                        },
                                        end: {
                                            line: 18,
                                            column: 21,
                                            fixed: true,
                                            source: 'glass/html/forms/Field.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '1'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'value',
                                loc: {
                                    start: {
                                        line: 18,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/forms/Field.ion'
                                    },
                                    end: {
                                        line: 18,
                                        column: 27,
                                        fixed: true,
                                        source: 'glass/html/forms/Field.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref6'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'value',
                                    loc: {
                                        start: {
                                            line: 18,
                                            column: 22,
                                            fixed: true,
                                            source: 'glass/html/forms/Field.ion'
                                        },
                                        end: {
                                            line: 18,
                                            column: 27,
                                            fixed: true,
                                            source: 'glass/html/forms/Field.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '2'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'label',
                                loc: {
                                    start: {
                                        line: 18,
                                        column: 28,
                                        fixed: true,
                                        source: 'glass/html/forms/Field.ion'
                                    },
                                    end: {
                                        line: 18,
                                        column: 33,
                                        fixed: true,
                                        source: 'glass/html/forms/Field.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref6'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'label',
                                    loc: {
                                        start: {
                                            line: 18,
                                            column: 28,
                                            fixed: true,
                                            source: 'glass/html/forms/Field.ion'
                                        },
                                        end: {
                                            line: 18,
                                            column: 33,
                                            fixed: true,
                                            source: 'glass/html/forms/Field.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '3'
                },
                {
                    type: 'IfStatement',
                    test: {
                        type: 'UnaryExpression',
                        operator: '?',
                        argument: {
                            type: 'MemberExpression',
                            computed: false,
                            object: {
                                type: 'Identifier',
                                name: 'property',
                                loc: {
                                    start: {
                                        line: 19,
                                        column: 11,
                                        fixed: true,
                                        source: 'glass/html/forms/Field.ion'
                                    },
                                    end: {
                                        line: 19,
                                        column: 19,
                                        fixed: true,
                                        source: 'glass/html/forms/Field.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'getInputType',
                                loc: {
                                    start: {
                                        line: 19,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/forms/Field.ion'
                                    },
                                    end: {
                                        line: 19,
                                        column: 32,
                                        fixed: true,
                                        source: 'glass/html/forms/Field.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 19,
                                    column: 11,
                                    fixed: true,
                                    source: 'glass/html/forms/Field.ion'
                                },
                                end: {
                                    line: 19,
                                    column: 32,
                                    fixed: true,
                                    source: 'glass/html/forms/Field.ion'
                                }
                            }
                        }
                    },
                    consequent: {
                        type: 'BlockStatement',
                        body: [{
                                type: 'ReturnStatement',
                                argument: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'property',
                                                loc: {
                                                    start: {
                                                        line: 20,
                                                        column: 19,
                                                        fixed: true,
                                                        source: 'glass/html/forms/Field.ion'
                                                    },
                                                    end: {
                                                        line: 20,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'glass/html/forms/Field.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'getInputType',
                                                loc: {
                                                    start: {
                                                        line: 20,
                                                        column: 28,
                                                        fixed: true,
                                                        source: 'glass/html/forms/Field.ion'
                                                    },
                                                    end: {
                                                        line: 20,
                                                        column: 40,
                                                        fixed: true,
                                                        source: 'glass/html/forms/Field.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 20,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                },
                                                end: {
                                                    line: 20,
                                                    column: 40,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                }
                                            }
                                        },
                                        arguments: [],
                                        loc: {
                                            start: {
                                                line: 20,
                                                column: 19,
                                                fixed: true,
                                                source: 'glass/html/forms/Field.ion'
                                            },
                                            end: {
                                                line: 20,
                                                column: 42,
                                                fixed: true,
                                                source: 'glass/html/forms/Field.ion'
                                            }
                                        }
                                    },
                                    arguments: [{
                                            type: 'Identifier',
                                            name: 'args',
                                            loc: {
                                                start: {
                                                    line: 20,
                                                    column: 43,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                },
                                                end: {
                                                    line: 20,
                                                    column: 47,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                }
                                            }
                                        }],
                                    loc: {
                                        start: {
                                            line: 20,
                                            column: 19,
                                            fixed: true,
                                            source: 'glass/html/forms/Field.ion'
                                        },
                                        end: {
                                            line: 20,
                                            column: 48,
                                            fixed: true,
                                            source: 'glass/html/forms/Field.ion'
                                        }
                                    }
                                },
                                order: '0'
                            }]
                    },
                    alternate: {
                        type: 'IfStatement',
                        test: {
                            type: 'UnaryExpression',
                            operator: '?',
                            argument: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'property',
                                    loc: {
                                        start: {
                                            line: 21,
                                            column: 16,
                                            fixed: true,
                                            source: 'glass/html/forms/Field.ion'
                                        },
                                        end: {
                                            line: 21,
                                            column: 24,
                                            fixed: true,
                                            source: 'glass/html/forms/Field.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'values',
                                    loc: {
                                        start: {
                                            line: 21,
                                            column: 25,
                                            fixed: true,
                                            source: 'glass/html/forms/Field.ion'
                                        },
                                        end: {
                                            line: 21,
                                            column: 31,
                                            fixed: true,
                                            source: 'glass/html/forms/Field.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 21,
                                        column: 16,
                                        fixed: true,
                                        source: 'glass/html/forms/Field.ion'
                                    },
                                    end: {
                                        line: 21,
                                        column: 31,
                                        fixed: true,
                                        source: 'glass/html/forms/Field.ion'
                                    }
                                }
                            }
                        },
                        consequent: {
                            type: 'BlockStatement',
                            body: [{
                                    type: 'IfStatement',
                                    test: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'property',
                                            loc: {
                                                start: {
                                                    line: 22,
                                                    column: 15,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                },
                                                end: {
                                                    line: 22,
                                                    column: 23,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'radio',
                                            loc: {
                                                start: {
                                                    line: 22,
                                                    column: 24,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                },
                                                end: {
                                                    line: 22,
                                                    column: 29,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 22,
                                                column: 15,
                                                fixed: true,
                                                source: 'glass/html/forms/Field.ion'
                                            },
                                            end: {
                                                line: 22,
                                                column: 29,
                                                fixed: true,
                                                source: 'glass/html/forms/Field.ion'
                                            }
                                        }
                                    },
                                    consequent: {
                                        type: 'BlockStatement',
                                        body: [
                                            {
                                                type: 'VariableDeclaration',
                                                declarations: [{
                                                        type: 'VariableDeclarator',
                                                        id: {
                                                            type: 'Identifier',
                                                            name: 'state',
                                                            loc: {
                                                                start: {
                                                                    line: 23,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                },
                                                                end: {
                                                                    line: 23,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                }
                                                            }
                                                        },
                                                        init: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Function',
                                                                context: true,
                                                                value: function (_context) {
                                                                    return function () {
                                                                        var value = _context.get('value'), property = _context.get('property');
                                                                        return { value: value != null ? value : property.value };
                                                                    };
                                                                }
                                                            },
                                                            arguments: [],
                                                            loc: {
                                                                start: {
                                                                    line: 23,
                                                                    column: 28,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                },
                                                                end: {
                                                                    line: 23,
                                                                    column: 64,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                }
                                                            }
                                                        }
                                                    }],
                                                kind: 'let',
                                                order: '0'
                                            },
                                            {
                                                type: 'ReturnStatement',
                                                argument: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'MemberExpression',
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'Object'
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'defineProperties'
                                                        }
                                                    },
                                                    arguments: [
                                                        {
                                                            type: 'ObjectExpression',
                                                            objectType: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Identifier',
                                                                    name: 'Div',
                                                                    loc: {
                                                                        start: {
                                                                            line: 24,
                                                                            column: 23,
                                                                            fixed: true,
                                                                            source: 'glass/html/forms/Field.ion'
                                                                        },
                                                                        end: {
                                                                            line: 24,
                                                                            column: 26,
                                                                            fixed: true,
                                                                            source: 'glass/html/forms/Field.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'ObjectExpression',
                                                                        properties: [{
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'class',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 24,
                                                                                            column: 28,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 24,
                                                                                            column: 33,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Literal',
                                                                                    value: 'layout horizontal'
                                                                                },
                                                                                kind: 'init',
                                                                                order: '0'
                                                                            }]
                                                                    }],
                                                                loc: {
                                                                    start: {
                                                                        line: 24,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/Field.ion'
                                                                    },
                                                                    end: {
                                                                        line: 24,
                                                                        column: 55,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/Field.ion'
                                                                    }
                                                                }
                                                            },
                                                            properties: [{
                                                                    type: 'ForOfStatement',
                                                                    left: {
                                                                        type: 'VariableDeclaration',
                                                                        declarations: [{
                                                                                type: 'VariableDeclarator',
                                                                                id: {
                                                                                    type: 'Identifier',
                                                                                    name: 'item',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 28,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 28,
                                                                                            column: 28,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                init: null
                                                                            }],
                                                                        kind: 'let'
                                                                    },
                                                                    right: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'property',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 28,
                                                                                    column: 32,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 28,
                                                                                    column: 40,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'values',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 28,
                                                                                    column: 41,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 28,
                                                                                    column: 47,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 28,
                                                                                column: 32,
                                                                                fixed: true,
                                                                                source: 'glass/html/forms/Field.ion'
                                                                            },
                                                                            end: {
                                                                                line: 28,
                                                                                column: 47,
                                                                                fixed: true,
                                                                                source: 'glass/html/forms/Field.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    body: {
                                                                        type: 'BlockStatement',
                                                                        body: [{
                                                                                type: 'ExpressionStatement',
                                                                                expression: {
                                                                                    type: 'ObjectExpression',
                                                                                    objectType: {
                                                                                        type: 'CallExpression',
                                                                                        callee: {
                                                                                            type: 'Identifier',
                                                                                            name: 'PaperRadioButton',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 29,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 29,
                                                                                                    column: 40,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        arguments: [{
                                                                                                type: 'ObjectExpression',
                                                                                                properties: [{
                                                                                                        type: 'Property',
                                                                                                        key: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'class',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 29,
                                                                                                                    column: 42,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 29,
                                                                                                                    column: 47,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        value: {
                                                                                                            type: 'Literal',
                                                                                                            value: 'flex'
                                                                                                        },
                                                                                                        kind: 'init',
                                                                                                        order: '0'
                                                                                                    }]
                                                                                            }],
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 29,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 29,
                                                                                                column: 56,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    properties: [
                                                                                        {
                                                                                            type: 'ExpressionStatement',
                                                                                            expression: {
                                                                                                type: 'Function',
                                                                                                context: true,
                                                                                                value: function (_context2) {
                                                                                                    return function change(e) {
                                                                                                        var state = _context2.get('state'), item = _context2.get('item');
                                                                                                        state.value = item.id;
                                                                                                    };
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 30,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 32,
                                                                                                    column: 32,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                }
                                                                                            },
                                                                                            order: '0'
                                                                                        },
                                                                                        {
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'checked',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 32,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 32,
                                                                                                        column: 35,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'BinaryExpression',
                                                                                                operator: '===',
                                                                                                left: {
                                                                                                    type: 'MemberExpression',
                                                                                                    computed: false,
                                                                                                    object: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'state',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 32,
                                                                                                                column: 37,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 32,
                                                                                                                column: 42,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    property: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'value',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 32,
                                                                                                                column: 43,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 32,
                                                                                                                column: 48,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 32,
                                                                                                            column: 37,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 32,
                                                                                                            column: 48,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                right: {
                                                                                                    type: 'MemberExpression',
                                                                                                    computed: false,
                                                                                                    object: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'item',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 32,
                                                                                                                column: 52,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 32,
                                                                                                                column: 56,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    property: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'id',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 32,
                                                                                                                column: 57,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 32,
                                                                                                                column: 59,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 32,
                                                                                                            column: 52,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 32,
                                                                                                            column: 59,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        }
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '1'
                                                                                        },
                                                                                        {
                                                                                            type: 'ExpressionStatement',
                                                                                            expression: {
                                                                                                type: 'MemberExpression',
                                                                                                computed: false,
                                                                                                object: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'item',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 33,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 33,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'name',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 33,
                                                                                                            column: 33,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 33,
                                                                                                            column: 37,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 33,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 33,
                                                                                                        column: 37,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 33,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 33,
                                                                                                    column: 37,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                }
                                                                                            },
                                                                                            order: '2'
                                                                                        }
                                                                                    ]
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 29,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 35,
                                                                                        column: 28,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                    }
                                                                                },
                                                                                order: '0'
                                                                            }]
                                                                    },
                                                                    remove: null,
                                                                    order: '0'
                                                                }]
                                                        },
                                                        {
                                                            type: 'ObjectExpression',
                                                            properties: [{
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'valueJSON',
                                                                        loc: {
                                                                            start: {
                                                                                line: 25,
                                                                                column: 29,
                                                                                fixed: true,
                                                                                source: 'glass/html/forms/Field.ion'
                                                                            },
                                                                            end: {
                                                                                line: 25,
                                                                                column: 38,
                                                                                fixed: true,
                                                                                source: 'glass/html/forms/Field.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'ObjectExpression',
                                                                        properties: [
                                                                            {
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'get',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 26,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 26,
                                                                                            column: 27,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Function',
                                                                                    context: true,
                                                                                    value: function (_context3) {
                                                                                        return function () {
                                                                                            var state = _context3.get('state');
                                                                                            return state.value;
                                                                                        };
                                                                                    }
                                                                                },
                                                                                kind: 'init',
                                                                                order: '0'
                                                                            },
                                                                            {
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'set',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 27,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 27,
                                                                                            column: 27,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Function',
                                                                                    context: true,
                                                                                    value: function (_context4) {
                                                                                        return function (value) {
                                                                                            var state = _context4.get('state');
                                                                                            return state.value = value;
                                                                                        };
                                                                                    }
                                                                                },
                                                                                kind: 'init',
                                                                                order: '1'
                                                                            }
                                                                        ]
                                                                    },
                                                                    kind: 'init',
                                                                    define: false,
                                                                    order: '0'
                                                                }]
                                                        }
                                                    ]
                                                },
                                                order: '1'
                                            }
                                        ]
                                    },
                                    alternate: {
                                        type: 'BlockStatement',
                                        body: [
                                            {
                                                type: 'VariableDeclaration',
                                                declarations: [{
                                                        type: 'VariableDeclarator',
                                                        id: {
                                                            type: 'Identifier',
                                                            name: 'val',
                                                            loc: {
                                                                start: {
                                                                    line: 36,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                },
                                                                end: {
                                                                    line: 36,
                                                                    column: 23,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                }
                                                            }
                                                        },
                                                        init: {
                                                            type: 'ConditionalExpression',
                                                            test: {
                                                                type: 'BinaryExpression',
                                                                operator: '!=',
                                                                left: {
                                                                    type: 'Identifier',
                                                                    name: 'value',
                                                                    loc: {
                                                                        start: {
                                                                            line: 36,
                                                                            column: 26,
                                                                            fixed: true,
                                                                            source: 'glass/html/forms/Field.ion'
                                                                        },
                                                                        end: {
                                                                            line: 36,
                                                                            column: 31,
                                                                            fixed: true,
                                                                            source: 'glass/html/forms/Field.ion'
                                                                        }
                                                                    }
                                                                },
                                                                right: {
                                                                    type: 'Literal',
                                                                    value: null
                                                                }
                                                            },
                                                            consequent: {
                                                                type: 'Identifier',
                                                                name: 'value',
                                                                loc: {
                                                                    start: {
                                                                        line: 36,
                                                                        column: 26,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/Field.ion'
                                                                    },
                                                                    end: {
                                                                        line: 36,
                                                                        column: 31,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/Field.ion'
                                                                    }
                                                                }
                                                            },
                                                            alternate: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'property',
                                                                    loc: {
                                                                        start: {
                                                                            line: 36,
                                                                            column: 34,
                                                                            fixed: true,
                                                                            source: 'glass/html/forms/Field.ion'
                                                                        },
                                                                        end: {
                                                                            line: 36,
                                                                            column: 42,
                                                                            fixed: true,
                                                                            source: 'glass/html/forms/Field.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'value',
                                                                    loc: {
                                                                        start: {
                                                                            line: 36,
                                                                            column: 43,
                                                                            fixed: true,
                                                                            source: 'glass/html/forms/Field.ion'
                                                                        },
                                                                        end: {
                                                                            line: 36,
                                                                            column: 48,
                                                                            fixed: true,
                                                                            source: 'glass/html/forms/Field.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 36,
                                                                        column: 34,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/Field.ion'
                                                                    },
                                                                    end: {
                                                                        line: 36,
                                                                        column: 48,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/Field.ion'
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }],
                                                kind: 'let',
                                                order: '0'
                                            },
                                            {
                                                type: 'VariableDeclaration',
                                                declarations: [{
                                                        type: 'VariableDeclarator',
                                                        id: {
                                                            type: 'Identifier',
                                                            name: 'menu',
                                                            loc: {
                                                                start: {
                                                                    line: 37,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                },
                                                                end: {
                                                                    line: 37,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                }
                                                            }
                                                        },
                                                        init: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'PaperDropdownMenu',
                                                                loc: {
                                                                    start: {
                                                                        line: 37,
                                                                        column: 27,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/Field.ion'
                                                                    },
                                                                    end: {
                                                                        line: 37,
                                                                        column: 44,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/Field.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [],
                                                            loc: {
                                                                start: {
                                                                    line: 37,
                                                                    column: 27,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                },
                                                                end: {
                                                                    line: 37,
                                                                    column: 46,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                }
                                                            }
                                                        }
                                                    }],
                                                kind: 'let',
                                                order: '1'
                                            },
                                            {
                                                type: 'ReturnStatement',
                                                argument: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'MemberExpression',
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'Object'
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'defineProperties'
                                                        }
                                                    },
                                                    arguments: [
                                                        {
                                                            type: 'ObjectExpression',
                                                            objectType: {
                                                                type: 'Identifier',
                                                                name: 'menu',
                                                                loc: {
                                                                    start: {
                                                                        line: 38,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/Field.ion'
                                                                    },
                                                                    end: {
                                                                        line: 38,
                                                                        column: 27,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/Field.ion'
                                                                    }
                                                                }
                                                            },
                                                            properties: [
                                                                {
                                                                    type: 'VariableDeclaration',
                                                                    declarations: [{
                                                                            type: 'VariableDeclarator',
                                                                            id: {
                                                                                type: 'Identifier',
                                                                                name: 'listbox',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 39,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 39,
                                                                                        column: 31,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            init: {
                                                                                type: 'ObjectExpression',
                                                                                objectType: {
                                                                                    type: 'CallExpression',
                                                                                    callee: {
                                                                                        type: 'Identifier',
                                                                                        name: 'PaperListbox',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 39,
                                                                                                column: 34,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 39,
                                                                                                column: 46,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    arguments: [{
                                                                                            type: 'ObjectExpression',
                                                                                            properties: [{
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'class',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 39,
                                                                                                                column: 48,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 39,
                                                                                                                column: 53,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'Literal',
                                                                                                        value: 'dropdown-content'
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '0'
                                                                                                }]
                                                                                        }],
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 39,
                                                                                            column: 34,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 39,
                                                                                            column: 74,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                properties: [{
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'CallExpression',
                                                                                            callee: {
                                                                                                type: 'MemberExpression',
                                                                                                object: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'Object'
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'assign'
                                                                                                }
                                                                                            },
                                                                                            arguments: [
                                                                                                {
                                                                                                    type: 'Function',
                                                                                                    context: true,
                                                                                                    value: function (_context5) {
                                                                                                        return function (e) {
                                                                                                            var menu = _context5.get('menu');
                                                                                                            menu.dispatchEvent(new CustomEvent('change'));
                                                                                                        };
                                                                                                    }
                                                                                                },
                                                                                                {
                                                                                                    type: 'ObjectExpression',
                                                                                                    properties: [{
                                                                                                            type: 'Property',
                                                                                                            key: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'id'
                                                                                                            },
                                                                                                            value: {
                                                                                                                type: 'Literal',
                                                                                                                value: 'selected-item-changed'
                                                                                                            },
                                                                                                            order: '0'
                                                                                                        }]
                                                                                                }
                                                                                            ]
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 40,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 42,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    }]
                                                                            }
                                                                        }],
                                                                    kind: 'let',
                                                                    order: '0'
                                                                },
                                                                {
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'Function',
                                                                            context: true,
                                                                            value: function (_context6) {
                                                                                return function () {
                                                                                    var listbox = _context6.get('listbox'), property = _context6.get('property'), val = _context6.get('val');
                                                                                    return listbox.selected = property.values.map(function (x) {
                                                                                        return x.id;
                                                                                    }).indexOf(val.id);
                                                                                };
                                                                            }
                                                                        },
                                                                        arguments: [],
                                                                        loc: {
                                                                            start: {
                                                                                line: 42,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/forms/Field.ion'
                                                                            },
                                                                            end: {
                                                                                line: 42,
                                                                                column: 93,
                                                                                fixed: true,
                                                                                source: 'glass/html/forms/Field.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 42,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/forms/Field.ion'
                                                                        },
                                                                        end: {
                                                                            line: 42,
                                                                            column: 93,
                                                                            fixed: true,
                                                                            source: 'glass/html/forms/Field.ion'
                                                                        }
                                                                    },
                                                                    order: '1'
                                                                },
                                                                {
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'listbox',
                                                                        loc: {
                                                                            start: {
                                                                                line: 43,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/forms/Field.ion'
                                                                            },
                                                                            end: {
                                                                                line: 43,
                                                                                column: 27,
                                                                                fixed: true,
                                                                                source: 'glass/html/forms/Field.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Identifier',
                                                                        name: 'listbox',
                                                                        loc: {
                                                                            start: {
                                                                                line: 43,
                                                                                column: 29,
                                                                                fixed: true,
                                                                                source: 'glass/html/forms/Field.ion'
                                                                            },
                                                                            end: {
                                                                                line: 43,
                                                                                column: 36,
                                                                                fixed: true,
                                                                                source: 'glass/html/forms/Field.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    kind: 'init',
                                                                    order: '2'
                                                                },
                                                                {
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'ObjectExpression',
                                                                        objectType: {
                                                                            type: 'Identifier',
                                                                            name: 'listbox',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 51,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 51,
                                                                                    column: 27,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        properties: [{
                                                                                type: 'ForOfStatement',
                                                                                left: {
                                                                                    type: 'VariableDeclaration',
                                                                                    declarations: [{
                                                                                            type: 'VariableDeclarator',
                                                                                            id: {
                                                                                                type: 'Identifier',
                                                                                                name: 'item',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 52,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 52,
                                                                                                        column: 32,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            init: null
                                                                                        }],
                                                                                    kind: 'let'
                                                                                },
                                                                                right: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'property',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 52,
                                                                                                column: 36,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 52,
                                                                                                column: 44,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'values',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 52,
                                                                                                column: 45,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 52,
                                                                                                column: 51,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 52,
                                                                                            column: 36,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 52,
                                                                                            column: 51,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                body: {
                                                                                    type: 'BlockStatement',
                                                                                    body: [{
                                                                                            type: 'ExpressionStatement',
                                                                                            expression: {
                                                                                                type: 'ObjectExpression',
                                                                                                objectType: {
                                                                                                    type: 'CallExpression',
                                                                                                    callee: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'PaperItem',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 53,
                                                                                                                column: 28,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 53,
                                                                                                                column: 37,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    arguments: [],
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 53,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 53,
                                                                                                            column: 39,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                properties: [
                                                                                                    {
                                                                                                        type: 'Property',
                                                                                                        key: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'item',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 54,
                                                                                                                    column: 32,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 54,
                                                                                                                    column: 36,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        value: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'item',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 54,
                                                                                                                    column: 38,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 54,
                                                                                                                    column: 42,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        kind: 'init',
                                                                                                        order: '0'
                                                                                                    },
                                                                                                    {
                                                                                                        type: 'ExpressionStatement',
                                                                                                        expression: {
                                                                                                            type: 'MemberExpression',
                                                                                                            computed: false,
                                                                                                            object: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'item',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 55,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 55,
                                                                                                                        column: 36,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            property: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'name',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 55,
                                                                                                                        column: 37,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 55,
                                                                                                                        column: 41,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 55,
                                                                                                                    column: 32,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 55,
                                                                                                                    column: 41,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 55,
                                                                                                                column: 32,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 55,
                                                                                                                column: 41,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                            }
                                                                                                        },
                                                                                                        order: '1'
                                                                                                    }
                                                                                                ]
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 53,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 57,
                                                                                                    column: 32,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                }
                                                                                            },
                                                                                            order: '0'
                                                                                        }]
                                                                                },
                                                                                remove: null,
                                                                                order: '0'
                                                                            }]
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 51,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/forms/Field.ion'
                                                                        },
                                                                        end: {
                                                                            line: 57,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'glass/html/forms/Field.ion'
                                                                        }
                                                                    },
                                                                    order: '3'
                                                                }
                                                            ]
                                                        },
                                                        {
                                                            type: 'ObjectExpression',
                                                            properties: [{
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'valueJSON',
                                                                        loc: {
                                                                            start: {
                                                                                line: 44,
                                                                                column: 29,
                                                                                fixed: true,
                                                                                source: 'glass/html/forms/Field.ion'
                                                                            },
                                                                            end: {
                                                                                line: 44,
                                                                                column: 38,
                                                                                fixed: true,
                                                                                source: 'glass/html/forms/Field.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'ObjectExpression',
                                                                        properties: [
                                                                            {
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'get',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 45,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 45,
                                                                                            column: 27,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Function',
                                                                                    context: true,
                                                                                    value: function (_context7) {
                                                                                        return function () {
                                                                                            var property = _context7.get('property');
                                                                                            return (property.values[this.listbox.selected] != null ? property.values[this.listbox.selected].id : void 0) != null ? property.values[this.listbox.selected].id : null;
                                                                                        };
                                                                                    }
                                                                                },
                                                                                kind: 'init',
                                                                                order: '0'
                                                                            },
                                                                            {
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'set',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 46,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 46,
                                                                                            column: 27,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Function',
                                                                                    context: true,
                                                                                    value: function (_context8) {
                                                                                        return function (value) {
                                                                                            var property = _context8.get('property');
                                                                                            {
                                                                                                var _ref8 = property.values;
                                                                                                for (var _i = 0; _i < _ref8.length; _i++) {
                                                                                                    var index = _i;
                                                                                                    var item = _ref8[_i];
                                                                                                    if (item.id === value) {
                                                                                                        this.listbox.selected = index;
                                                                                                        break;
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        };
                                                                                    }
                                                                                },
                                                                                kind: 'init',
                                                                                order: '1'
                                                                            }
                                                                        ]
                                                                    },
                                                                    kind: 'init',
                                                                    define: false,
                                                                    order: '0'
                                                                }]
                                                        }
                                                    ]
                                                },
                                                order: '2'
                                            }
                                        ]
                                    },
                                    order: '0'
                                }]
                        },
                        alternate: {
                            type: 'IfStatement',
                            test: {
                                type: 'BinaryExpression',
                                operator: '&&',
                                left: {
                                    type: 'UnaryExpression',
                                    operator: '?',
                                    argument: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'property',
                                            loc: {
                                                start: {
                                                    line: 58,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                },
                                                end: {
                                                    line: 58,
                                                    column: 24,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'foreign',
                                            loc: {
                                                start: {
                                                    line: 58,
                                                    column: 25,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                },
                                                end: {
                                                    line: 58,
                                                    column: 32,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 58,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/forms/Field.ion'
                                            },
                                            end: {
                                                line: 58,
                                                column: 32,
                                                fixed: true,
                                                source: 'glass/html/forms/Field.ion'
                                            }
                                        }
                                    }
                                },
                                right: {
                                    type: 'UnaryExpression',
                                    operator: '!',
                                    argument: {
                                        type: 'UnaryExpression',
                                        operator: '?',
                                        argument: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'property',
                                                loc: {
                                                    start: {
                                                        line: 58,
                                                        column: 42,
                                                        fixed: true,
                                                        source: 'glass/html/forms/Field.ion'
                                                    },
                                                    end: {
                                                        line: 58,
                                                        column: 50,
                                                        fixed: true,
                                                        source: 'glass/html/forms/Field.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'values',
                                                loc: {
                                                    start: {
                                                        line: 58,
                                                        column: 51,
                                                        fixed: true,
                                                        source: 'glass/html/forms/Field.ion'
                                                    },
                                                    end: {
                                                        line: 58,
                                                        column: 57,
                                                        fixed: true,
                                                        source: 'glass/html/forms/Field.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 58,
                                                    column: 42,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                },
                                                end: {
                                                    line: 58,
                                                    column: 57,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                }
                                            }
                                        }
                                    }
                                }
                            },
                            consequent: {
                                type: 'BlockStatement',
                                body: [{
                                        type: 'IfStatement',
                                        test: {
                                            type: 'BinaryExpression',
                                            operator: '===',
                                            left: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'property',
                                                    loc: {
                                                        start: {
                                                            line: 59,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/forms/Field.ion'
                                                        },
                                                        end: {
                                                            line: 59,
                                                            column: 23,
                                                            fixed: true,
                                                            source: 'glass/html/forms/Field.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'type',
                                                    loc: {
                                                        start: {
                                                            line: 59,
                                                            column: 24,
                                                            fixed: true,
                                                            source: 'glass/html/forms/Field.ion'
                                                        },
                                                        end: {
                                                            line: 59,
                                                            column: 28,
                                                            fixed: true,
                                                            source: 'glass/html/forms/Field.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 59,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'glass/html/forms/Field.ion'
                                                    },
                                                    end: {
                                                        line: 59,
                                                        column: 28,
                                                        fixed: true,
                                                        source: 'glass/html/forms/Field.ion'
                                                    }
                                                }
                                            },
                                            right: {
                                                type: 'Literal',
                                                value: 'object'
                                            }
                                        },
                                        consequent: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'ReturnStatement',
                                                    argument: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'Identifier',
                                                            name: 'MultiRelationInput',
                                                            loc: {
                                                                start: {
                                                                    line: 60,
                                                                    column: 23,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                },
                                                                end: {
                                                                    line: 60,
                                                                    column: 41,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [{
                                                                type: 'Identifier',
                                                                name: 'args',
                                                                loc: {
                                                                    start: {
                                                                        line: 60,
                                                                        column: 42,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/Field.ion'
                                                                    },
                                                                    end: {
                                                                        line: 60,
                                                                        column: 46,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/Field.ion'
                                                                    }
                                                                }
                                                            }],
                                                        loc: {
                                                            start: {
                                                                line: 60,
                                                                column: 23,
                                                                fixed: true,
                                                                source: 'glass/html/forms/Field.ion'
                                                            },
                                                            end: {
                                                                line: 60,
                                                                column: 47,
                                                                fixed: true,
                                                                source: 'glass/html/forms/Field.ion'
                                                            }
                                                        }
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        alternate: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'ReturnStatement',
                                                    argument: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'Identifier',
                                                            name: 'RelationInput',
                                                            loc: {
                                                                start: {
                                                                    line: 62,
                                                                    column: 23,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                },
                                                                end: {
                                                                    line: 62,
                                                                    column: 36,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [{
                                                                type: 'Identifier',
                                                                name: 'args',
                                                                loc: {
                                                                    start: {
                                                                        line: 62,
                                                                        column: 37,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/Field.ion'
                                                                    },
                                                                    end: {
                                                                        line: 62,
                                                                        column: 41,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/Field.ion'
                                                                    }
                                                                }
                                                            }],
                                                        loc: {
                                                            start: {
                                                                line: 62,
                                                                column: 23,
                                                                fixed: true,
                                                                source: 'glass/html/forms/Field.ion'
                                                            },
                                                            end: {
                                                                line: 62,
                                                                column: 42,
                                                                fixed: true,
                                                                source: 'glass/html/forms/Field.ion'
                                                            }
                                                        }
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        order: '0'
                                    }]
                            },
                            alternate: {
                                type: 'IfStatement',
                                test: {
                                    type: 'BinaryExpression',
                                    operator: '===',
                                    left: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'property',
                                            loc: {
                                                start: {
                                                    line: 63,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                },
                                                end: {
                                                    line: 63,
                                                    column: 24,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'format',
                                            loc: {
                                                start: {
                                                    line: 63,
                                                    column: 25,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                },
                                                end: {
                                                    line: 63,
                                                    column: 31,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 63,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/forms/Field.ion'
                                            },
                                            end: {
                                                line: 63,
                                                column: 31,
                                                fixed: true,
                                                source: 'glass/html/forms/Field.ion'
                                            }
                                        }
                                    },
                                    right: {
                                        type: 'Literal',
                                        value: 'color'
                                    }
                                },
                                consequent: {
                                    type: 'BlockStatement',
                                    body: [
                                        {
                                            type: 'VariableDeclaration',
                                            declarations: [{
                                                    type: 'VariableDeclarator',
                                                    id: {
                                                        type: 'Identifier',
                                                        name: 'field',
                                                        loc: {
                                                            start: {
                                                                line: 64,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/forms/Field.ion'
                                                            },
                                                            end: {
                                                                line: 64,
                                                                column: 21,
                                                                fixed: true,
                                                                source: 'glass/html/forms/Field.ion'
                                                            }
                                                        }
                                                    },
                                                    init: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'Identifier',
                                                            name: 'Div',
                                                            loc: {
                                                                start: {
                                                                    line: 64,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                },
                                                                end: {
                                                                    line: 64,
                                                                    column: 27,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [],
                                                        loc: {
                                                            start: {
                                                                line: 64,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'glass/html/forms/Field.ion'
                                                            },
                                                            end: {
                                                                line: 64,
                                                                column: 29,
                                                                fixed: true,
                                                                source: 'glass/html/forms/Field.ion'
                                                            }
                                                        }
                                                    }
                                                }],
                                            kind: 'let',
                                            order: '0'
                                        },
                                        {
                                            type: 'VariableDeclaration',
                                            declarations: [{
                                                    type: 'VariableDeclarator',
                                                    id: {
                                                        type: 'Identifier',
                                                        name: 'labelSpan',
                                                        loc: {
                                                            start: {
                                                                line: 65,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/forms/Field.ion'
                                                            },
                                                            end: {
                                                                line: 65,
                                                                column: 25,
                                                                fixed: true,
                                                                source: 'glass/html/forms/Field.ion'
                                                            }
                                                        }
                                                    },
                                                    init: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'Span',
                                                                loc: {
                                                                    start: {
                                                                        line: 65,
                                                                        column: 28,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/Field.ion'
                                                                    },
                                                                    end: {
                                                                        line: 65,
                                                                        column: 32,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/Field.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [],
                                                            loc: {
                                                                start: {
                                                                    line: 65,
                                                                    column: 28,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                },
                                                                end: {
                                                                    line: 65,
                                                                    column: 34,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [{
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'style',
                                                                    loc: {
                                                                        start: {
                                                                            line: 66,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/forms/Field.ion'
                                                                        },
                                                                        end: {
                                                                            line: 66,
                                                                            column: 21,
                                                                            fixed: true,
                                                                            source: 'glass/html/forms/Field.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'ObjectExpression',
                                                                    properties: [{
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'color',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 67,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 67,
                                                                                        column: 25,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: '#737373'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            }]
                                                    }
                                                }],
                                            kind: 'let',
                                            order: '1'
                                        },
                                        {
                                            type: 'VariableDeclaration',
                                            declarations: [{
                                                    type: 'VariableDeclarator',
                                                    id: {
                                                        type: 'Identifier',
                                                        name: 'input',
                                                        loc: {
                                                            start: {
                                                                line: 68,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/forms/Field.ion'
                                                            },
                                                            end: {
                                                                line: 68,
                                                                column: 21,
                                                                fixed: true,
                                                                source: 'glass/html/forms/Field.ion'
                                                            }
                                                        }
                                                    },
                                                    init: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'Identifier',
                                                            name: 'PaperSwatchPicker',
                                                            loc: {
                                                                start: {
                                                                    line: 68,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                },
                                                                end: {
                                                                    line: 68,
                                                                    column: 41,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [],
                                                        loc: {
                                                            start: {
                                                                line: 68,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'glass/html/forms/Field.ion'
                                                            },
                                                            end: {
                                                                line: 68,
                                                                column: 43,
                                                                fixed: true,
                                                                source: 'glass/html/forms/Field.ion'
                                                            }
                                                        }
                                                    }
                                                }],
                                            kind: 'let',
                                            order: '2'
                                        },
                                        {
                                            type: 'ReturnStatement',
                                            argument: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'MemberExpression',
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'Object'
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'defineProperties'
                                                    }
                                                },
                                                arguments: [
                                                    {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'Identifier',
                                                            name: 'field',
                                                            loc: {
                                                                start: {
                                                                    line: 69,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                },
                                                                end: {
                                                                    line: 69,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'Identifier',
                                                                    name: 'labelSpan',
                                                                    loc: {
                                                                        start: {
                                                                            line: 70,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/forms/Field.ion'
                                                                        },
                                                                        end: {
                                                                            line: 70,
                                                                            column: 25,
                                                                            fixed: true,
                                                                            source: 'glass/html/forms/Field.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 70,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/Field.ion'
                                                                    },
                                                                    end: {
                                                                        line: 70,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/Field.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'ObjectExpression',
                                                                    objectType: {
                                                                        type: 'Identifier',
                                                                        name: 'input',
                                                                        loc: {
                                                                            start: {
                                                                                line: 71,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'glass/html/forms/Field.ion'
                                                                            },
                                                                            end: {
                                                                                line: 71,
                                                                                column: 21,
                                                                                fixed: true,
                                                                                source: 'glass/html/forms/Field.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    properties: [{
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'CallExpression',
                                                                                callee: {
                                                                                    type: 'MemberExpression',
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'Object'
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'assign'
                                                                                    }
                                                                                },
                                                                                arguments: [
                                                                                    {
                                                                                        type: 'Function',
                                                                                        context: true,
                                                                                        value: function (_context9) {
                                                                                            return function (e) {
                                                                                                var field = _context9.get('field');
                                                                                                field.dispatchEvent(new CustomEvent('change'));
                                                                                            };
                                                                                        }
                                                                                    },
                                                                                    {
                                                                                        type: 'ObjectExpression',
                                                                                        properties: [{
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'id'
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'Literal',
                                                                                                    value: 'color-changed'
                                                                                                },
                                                                                                order: '0'
                                                                                            }]
                                                                                    }
                                                                                ]
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 72,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 74,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 71,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/Field.ion'
                                                                    },
                                                                    end: {
                                                                        line: 74,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/Field.ion'
                                                                    }
                                                                },
                                                                order: '1'
                                                            }
                                                        ]
                                                    },
                                                    {
                                                        type: 'ObjectExpression',
                                                        properties: [
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'label',
                                                                    loc: {
                                                                        start: {
                                                                            line: 74,
                                                                            column: 25,
                                                                            fixed: true,
                                                                            source: 'glass/html/forms/Field.ion'
                                                                        },
                                                                        end: {
                                                                            line: 74,
                                                                            column: 30,
                                                                            fixed: true,
                                                                            source: 'glass/html/forms/Field.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'ObjectExpression',
                                                                    properties: [
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'get',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 75,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 75,
                                                                                        column: 23,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Function',
                                                                                context: true,
                                                                                value: function (_context10) {
                                                                                    return function () {
                                                                                        var labelSpan = _context10.get('labelSpan');
                                                                                        return labelSpan.innerText;
                                                                                    };
                                                                                }
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'set',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 76,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 76,
                                                                                        column: 23,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Function',
                                                                                context: true,
                                                                                value: function (_context11) {
                                                                                    return function (value) {
                                                                                        var labelSpan = _context11.get('labelSpan');
                                                                                        return labelSpan.innerText = value;
                                                                                    };
                                                                                }
                                                                            },
                                                                            kind: 'init',
                                                                            order: '1'
                                                                        }
                                                                    ]
                                                                },
                                                                kind: 'init',
                                                                define: false,
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'valueJSON',
                                                                    loc: {
                                                                        start: {
                                                                            line: 77,
                                                                            column: 25,
                                                                            fixed: true,
                                                                            source: 'glass/html/forms/Field.ion'
                                                                        },
                                                                        end: {
                                                                            line: 77,
                                                                            column: 34,
                                                                            fixed: true,
                                                                            source: 'glass/html/forms/Field.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'ObjectExpression',
                                                                    properties: [
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'get',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 78,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 78,
                                                                                        column: 23,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Function',
                                                                                context: true,
                                                                                value: function (_context12) {
                                                                                    return function () {
                                                                                        var input = _context12.get('input');
                                                                                        return (input.color != null ? input.color.substring(1).toUpperCase() : void 0) != null ? input.color.substring(1).toUpperCase() : '000000';
                                                                                    };
                                                                                }
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'set',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 79,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 79,
                                                                                        column: 23,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Function',
                                                                                context: true,
                                                                                value: function (_context13) {
                                                                                    return function (value) {
                                                                                        var input = _context13.get('input');
                                                                                        return input.color = '#' + (value != null ? value : '000000');
                                                                                    };
                                                                                }
                                                                            },
                                                                            kind: 'init',
                                                                            order: '1'
                                                                        }
                                                                    ]
                                                                },
                                                                kind: 'init',
                                                                define: false,
                                                                order: '1'
                                                            }
                                                        ]
                                                    }
                                                ]
                                            },
                                            order: '3'
                                        }
                                    ]
                                },
                                alternate: {
                                    type: 'IfStatement',
                                    test: {
                                        type: 'BinaryExpression',
                                        operator: '===',
                                        left: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'property',
                                                loc: {
                                                    start: {
                                                        line: 80,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'glass/html/forms/Field.ion'
                                                    },
                                                    end: {
                                                        line: 80,
                                                        column: 24,
                                                        fixed: true,
                                                        source: 'glass/html/forms/Field.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'format',
                                                loc: {
                                                    start: {
                                                        line: 80,
                                                        column: 25,
                                                        fixed: true,
                                                        source: 'glass/html/forms/Field.ion'
                                                    },
                                                    end: {
                                                        line: 80,
                                                        column: 31,
                                                        fixed: true,
                                                        source: 'glass/html/forms/Field.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 80,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                },
                                                end: {
                                                    line: 80,
                                                    column: 31,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                }
                                            }
                                        },
                                        right: {
                                            type: 'Literal',
                                            value: 'url'
                                        }
                                    },
                                    consequent: {
                                        type: 'BlockStatement',
                                        body: [{
                                                type: 'ReturnStatement',
                                                argument: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'Identifier',
                                                        name: 'ImageUrlInput',
                                                        loc: {
                                                            start: {
                                                                line: 81,
                                                                column: 19,
                                                                fixed: true,
                                                                source: 'glass/html/forms/Field.ion'
                                                            },
                                                            end: {
                                                                line: 81,
                                                                column: 32,
                                                                fixed: true,
                                                                source: 'glass/html/forms/Field.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [{
                                                            type: 'Identifier',
                                                            name: 'args',
                                                            loc: {
                                                                start: {
                                                                    line: 81,
                                                                    column: 33,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                },
                                                                end: {
                                                                    line: 81,
                                                                    column: 37,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                }
                                                            }
                                                        }],
                                                    loc: {
                                                        start: {
                                                            line: 81,
                                                            column: 19,
                                                            fixed: true,
                                                            source: 'glass/html/forms/Field.ion'
                                                        },
                                                        end: {
                                                            line: 81,
                                                            column: 38,
                                                            fixed: true,
                                                            source: 'glass/html/forms/Field.ion'
                                                        }
                                                    }
                                                },
                                                order: '0'
                                            }]
                                    },
                                    alternate: {
                                        type: 'IfStatement',
                                        test: {
                                            type: 'BinaryExpression',
                                            operator: '===',
                                            left: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'property',
                                                    loc: {
                                                        start: {
                                                            line: 82,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/forms/Field.ion'
                                                        },
                                                        end: {
                                                            line: 82,
                                                            column: 24,
                                                            fixed: true,
                                                            source: 'glass/html/forms/Field.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'format',
                                                    loc: {
                                                        start: {
                                                            line: 82,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'glass/html/forms/Field.ion'
                                                        },
                                                        end: {
                                                            line: 82,
                                                            column: 31,
                                                            fixed: true,
                                                            source: 'glass/html/forms/Field.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 82,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'glass/html/forms/Field.ion'
                                                    },
                                                    end: {
                                                        line: 82,
                                                        column: 31,
                                                        fixed: true,
                                                        source: 'glass/html/forms/Field.ion'
                                                    }
                                                }
                                            },
                                            right: {
                                                type: 'Literal',
                                                value: 'date'
                                            }
                                        },
                                        consequent: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'ReturnStatement',
                                                    argument: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'Identifier',
                                                            name: 'DateInput',
                                                            loc: {
                                                                start: {
                                                                    line: 83,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                },
                                                                end: {
                                                                    line: 83,
                                                                    column: 28,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [{
                                                                type: 'ObjectExpression',
                                                                properties: [{
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'showTime',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 83,
                                                                                    column: 30,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 83,
                                                                                    column: 38,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Literal',
                                                                            value: false
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    }]
                                                            }],
                                                        loc: {
                                                            start: {
                                                                line: 83,
                                                                column: 19,
                                                                fixed: true,
                                                                source: 'glass/html/forms/Field.ion'
                                                            },
                                                            end: {
                                                                line: 83,
                                                                column: 46,
                                                                fixed: true,
                                                                source: 'glass/html/forms/Field.ion'
                                                            }
                                                        }
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        alternate: {
                                            type: 'IfStatement',
                                            test: {
                                                type: 'BinaryExpression',
                                                operator: '===',
                                                left: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'property',
                                                        loc: {
                                                            start: {
                                                                line: 84,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/forms/Field.ion'
                                                            },
                                                            end: {
                                                                line: 84,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'glass/html/forms/Field.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'format',
                                                        loc: {
                                                            start: {
                                                                line: 84,
                                                                column: 25,
                                                                fixed: true,
                                                                source: 'glass/html/forms/Field.ion'
                                                            },
                                                            end: {
                                                                line: 84,
                                                                column: 31,
                                                                fixed: true,
                                                                source: 'glass/html/forms/Field.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 84,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/forms/Field.ion'
                                                        },
                                                        end: {
                                                            line: 84,
                                                            column: 31,
                                                            fixed: true,
                                                            source: 'glass/html/forms/Field.ion'
                                                        }
                                                    }
                                                },
                                                right: {
                                                    type: 'Literal',
                                                    value: 'date-time'
                                                }
                                            },
                                            consequent: {
                                                type: 'BlockStatement',
                                                body: [{
                                                        type: 'ReturnStatement',
                                                        argument: {
                                                            type: 'ObjectExpression',
                                                            objectType: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Identifier',
                                                                    name: 'DateInput',
                                                                    loc: {
                                                                        start: {
                                                                            line: 85,
                                                                            column: 19,
                                                                            fixed: true,
                                                                            source: 'glass/html/forms/Field.ion'
                                                                        },
                                                                        end: {
                                                                            line: 85,
                                                                            column: 28,
                                                                            fixed: true,
                                                                            source: 'glass/html/forms/Field.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [],
                                                                loc: {
                                                                    start: {
                                                                        line: 85,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/Field.ion'
                                                                    },
                                                                    end: {
                                                                        line: 85,
                                                                        column: 30,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/Field.ion'
                                                                    }
                                                                }
                                                            },
                                                            properties: []
                                                        },
                                                        order: '0'
                                                    }]
                                            },
                                            alternate: {
                                                type: 'IfStatement',
                                                test: {
                                                    type: 'BinaryExpression',
                                                    operator: '===',
                                                    left: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'property',
                                                            loc: {
                                                                start: {
                                                                    line: 88,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                },
                                                                end: {
                                                                    line: 88,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'format',
                                                            loc: {
                                                                start: {
                                                                    line: 88,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                },
                                                                end: {
                                                                    line: 88,
                                                                    column: 31,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 88,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/forms/Field.ion'
                                                            },
                                                            end: {
                                                                line: 88,
                                                                column: 31,
                                                                fixed: true,
                                                                source: 'glass/html/forms/Field.ion'
                                                            }
                                                        }
                                                    },
                                                    right: {
                                                        type: 'Literal',
                                                        value: 'duration'
                                                    }
                                                },
                                                consequent: {
                                                    type: 'BlockStatement',
                                                    body: [{
                                                            type: 'ReturnStatement',
                                                            argument: {
                                                                type: 'ObjectExpression',
                                                                objectType: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'Identifier',
                                                                        name: 'DurationInput',
                                                                        loc: {
                                                                            start: {
                                                                                line: 89,
                                                                                column: 19,
                                                                                fixed: true,
                                                                                source: 'glass/html/forms/Field.ion'
                                                                            },
                                                                            end: {
                                                                                line: 89,
                                                                                column: 32,
                                                                                fixed: true,
                                                                                source: 'glass/html/forms/Field.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [{
                                                                            type: 'Identifier',
                                                                            name: 'property',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 89,
                                                                                    column: 33,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 89,
                                                                                    column: 41,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                }
                                                                            }
                                                                        }],
                                                                    loc: {
                                                                        start: {
                                                                            line: 89,
                                                                            column: 19,
                                                                            fixed: true,
                                                                            source: 'glass/html/forms/Field.ion'
                                                                        },
                                                                        end: {
                                                                            line: 89,
                                                                            column: 42,
                                                                            fixed: true,
                                                                            source: 'glass/html/forms/Field.ion'
                                                                        }
                                                                    }
                                                                },
                                                                properties: []
                                                            },
                                                            order: '0'
                                                        }]
                                                },
                                                alternate: {
                                                    type: 'IfStatement',
                                                    test: {
                                                        type: 'BinaryExpression',
                                                        operator: '===',
                                                        left: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'property',
                                                                loc: {
                                                                    start: {
                                                                        line: 92,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/Field.ion'
                                                                    },
                                                                    end: {
                                                                        line: 92,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/Field.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'format',
                                                                loc: {
                                                                    start: {
                                                                        line: 92,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/Field.ion'
                                                                    },
                                                                    end: {
                                                                        line: 92,
                                                                        column: 31,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/Field.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 92,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                },
                                                                end: {
                                                                    line: 92,
                                                                    column: 31,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                }
                                                            }
                                                        },
                                                        right: {
                                                            type: 'Literal',
                                                            value: 'timezone'
                                                        }
                                                    },
                                                    consequent: {
                                                        type: 'BlockStatement',
                                                        body: [
                                                            {
                                                                type: 'VariableDeclaration',
                                                                declarations: [{
                                                                        type: 'VariableDeclarator',
                                                                        id: {
                                                                            type: 'Identifier',
                                                                            name: 'dropdown',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 93,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 93,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        init: {
                                                                            type: 'CallExpression',
                                                                            callee: {
                                                                                type: 'Identifier',
                                                                                name: 'PaperDropdownMenu',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 93,
                                                                                        column: 27,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 93,
                                                                                        column: 44,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            arguments: [],
                                                                            loc: {
                                                                                start: {
                                                                                    line: 93,
                                                                                    column: 27,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 93,
                                                                                    column: 46,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                }
                                                                            }
                                                                        }
                                                                    }],
                                                                kind: 'let',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'VariableDeclaration',
                                                                declarations: [{
                                                                        type: 'VariableDeclarator',
                                                                        id: {
                                                                            type: 'Identifier',
                                                                            name: 'state',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 94,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 94,
                                                                                    column: 21,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        init: {
                                                                            type: 'CallExpression',
                                                                            callee: {
                                                                                type: 'Function',
                                                                                context: true,
                                                                                value: function (_context14) {
                                                                                    return function () {
                                                                                        var value = _context14.get('value');
                                                                                        return { value: value };
                                                                                    };
                                                                                }
                                                                            },
                                                                            arguments: [],
                                                                            loc: {
                                                                                start: {
                                                                                    line: 94,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 94,
                                                                                    column: 43,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                }
                                                                            }
                                                                        }
                                                                    }],
                                                                kind: 'let',
                                                                order: '1'
                                                            },
                                                            {
                                                                type: 'VariableDeclaration',
                                                                declarations: [{
                                                                        type: 'VariableDeclarator',
                                                                        id: {
                                                                            type: 'Identifier',
                                                                            name: 'inputElement',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 95,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 95,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        init: {
                                                                            type: 'CallExpression',
                                                                            callee: {
                                                                                type: 'Identifier',
                                                                                name: 'Div',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 95,
                                                                                        column: 31,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 95,
                                                                                        column: 34,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            arguments: [{
                                                                                    type: 'ObjectExpression',
                                                                                    properties: [{
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'class',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 95,
                                                                                                        column: 36,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 95,
                                                                                                        column: 41,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'Literal',
                                                                                                value: 'layout vertical'
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '0'
                                                                                        }]
                                                                                }],
                                                                            loc: {
                                                                                start: {
                                                                                    line: 95,
                                                                                    column: 31,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 95,
                                                                                    column: 61,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                }
                                                                            }
                                                                        }
                                                                    }],
                                                                kind: 'let',
                                                                order: '2'
                                                            },
                                                            {
                                                                type: 'ReturnStatement',
                                                                argument: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'MemberExpression',
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'Object'
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'defineProperties'
                                                                        }
                                                                    },
                                                                    arguments: [
                                                                        {
                                                                            type: 'ObjectExpression',
                                                                            objectType: {
                                                                                type: 'Identifier',
                                                                                name: 'inputElement',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 96,
                                                                                        column: 19,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 96,
                                                                                        column: 31,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            properties: [{
                                                                                    type: 'ExpressionStatement',
                                                                                    expression: {
                                                                                        type: 'ObjectExpression',
                                                                                        objectType: {
                                                                                            type: 'Identifier',
                                                                                            name: 'dropdown',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 103,
                                                                                                    column: 16,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 103,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        properties: [
                                                                                            {
                                                                                                type: 'VariableDeclaration',
                                                                                                declarations: [{
                                                                                                        type: 'VariableDeclarator',
                                                                                                        id: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'selected',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 104,
                                                                                                                    column: 24,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 104,
                                                                                                                    column: 32,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        init: {
                                                                                                            type: 'CallExpression',
                                                                                                            callee: {
                                                                                                                type: 'Function',
                                                                                                                context: true,
                                                                                                                value: function (_context15) {
                                                                                                                    return function () {
                                                                                                                        var Timezone = _context15.get('Timezone'), value = _context15.get('value');
                                                                                                                        return Timezone.values.indexOf(value) + 1;
                                                                                                                    };
                                                                                                                }
                                                                                                            },
                                                                                                            arguments: [],
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 104,
                                                                                                                    column: 35,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 104,
                                                                                                                    column: 75,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        }
                                                                                                    }],
                                                                                                kind: 'let',
                                                                                                order: '0'
                                                                                            },
                                                                                            {
                                                                                                type: 'ExpressionStatement',
                                                                                                expression: {
                                                                                                    type: 'ObjectExpression',
                                                                                                    objectType: {
                                                                                                        type: 'CallExpression',
                                                                                                        callee: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'PaperListbox',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 105,
                                                                                                                    column: 20,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 105,
                                                                                                                    column: 32,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        arguments: [{
                                                                                                                type: 'ObjectExpression',
                                                                                                                properties: [
                                                                                                                    {
                                                                                                                        type: 'Property',
                                                                                                                        key: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'class',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 105,
                                                                                                                                    column: 34,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 105,
                                                                                                                                    column: 39,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        value: {
                                                                                                                            type: 'Literal',
                                                                                                                            value: 'dropdown-content'
                                                                                                                        },
                                                                                                                        kind: 'init',
                                                                                                                        order: '0'
                                                                                                                    },
                                                                                                                    {
                                                                                                                        type: 'Property',
                                                                                                                        key: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'selected',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 105,
                                                                                                                                    column: 59,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 105,
                                                                                                                                    column: 67,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        value: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'selected',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 105,
                                                                                                                                    column: 59,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 105,
                                                                                                                                    column: 67,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        kind: 'init',
                                                                                                                        order: '1'
                                                                                                                    }
                                                                                                                ]
                                                                                                            }],
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 105,
                                                                                                                column: 20,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 105,
                                                                                                                column: 69,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    properties: [
                                                                                                        {
                                                                                                            type: 'ExpressionStatement',
                                                                                                            expression: {
                                                                                                                type: 'CallExpression',
                                                                                                                callee: {
                                                                                                                    type: 'MemberExpression',
                                                                                                                    object: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'Object'
                                                                                                                    },
                                                                                                                    property: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'assign'
                                                                                                                    }
                                                                                                                },
                                                                                                                arguments: [
                                                                                                                    {
                                                                                                                        type: 'Function',
                                                                                                                        context: true,
                                                                                                                        value: function (_context16) {
                                                                                                                            return function (e) {
                                                                                                                                var state = _context16.get('state'), inputElement = _context16.get('inputElement');
                                                                                                                                var item = this.selectedItem;
                                                                                                                                if (item != null) {
                                                                                                                                    var newValue = item.value;
                                                                                                                                    state.value = newValue;
                                                                                                                                    inputElement.dispatchEvent(new CustomEvent('change'));
                                                                                                                                }
                                                                                                                            };
                                                                                                                        }
                                                                                                                    },
                                                                                                                    {
                                                                                                                        type: 'ObjectExpression',
                                                                                                                        properties: [{
                                                                                                                                type: 'Property',
                                                                                                                                key: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'id'
                                                                                                                                },
                                                                                                                                value: {
                                                                                                                                    type: 'Literal',
                                                                                                                                    value: 'selected-item-changed'
                                                                                                                                },
                                                                                                                                order: '0'
                                                                                                                            }]
                                                                                                                    }
                                                                                                                ]
                                                                                                            },
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 106,
                                                                                                                    column: 24,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 112,
                                                                                                                    column: 28,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                }
                                                                                                            },
                                                                                                            order: '0'
                                                                                                        },
                                                                                                        {
                                                                                                            type: 'ExpressionStatement',
                                                                                                            expression: {
                                                                                                                type: 'ObjectExpression',
                                                                                                                objectType: {
                                                                                                                    type: 'CallExpression',
                                                                                                                    callee: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'PaperItem',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 112,
                                                                                                                                column: 24,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 112,
                                                                                                                                column: 33,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    arguments: [],
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 112,
                                                                                                                            column: 24,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 112,
                                                                                                                            column: 35,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                properties: [
                                                                                                                    {
                                                                                                                        type: 'ExpressionStatement',
                                                                                                                        expression: {
                                                                                                                            type: 'Literal',
                                                                                                                            value: 'Local'
                                                                                                                        },
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 113,
                                                                                                                                column: 28,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 113,
                                                                                                                                column: 35,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            }
                                                                                                                        },
                                                                                                                        order: '0'
                                                                                                                    },
                                                                                                                    {
                                                                                                                        type: 'Property',
                                                                                                                        key: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'value',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 114,
                                                                                                                                    column: 28,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 114,
                                                                                                                                    column: 33,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        value: {
                                                                                                                            type: 'Literal',
                                                                                                                            value: null
                                                                                                                        },
                                                                                                                        kind: 'init',
                                                                                                                        order: '1'
                                                                                                                    }
                                                                                                                ]
                                                                                                            },
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 112,
                                                                                                                    column: 24,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 115,
                                                                                                                    column: 28,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                }
                                                                                                            },
                                                                                                            order: '1'
                                                                                                        },
                                                                                                        {
                                                                                                            type: 'ForOfStatement',
                                                                                                            left: {
                                                                                                                type: 'VariableDeclaration',
                                                                                                                declarations: [{
                                                                                                                        type: 'VariableDeclarator',
                                                                                                                        id: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'zone',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 115,
                                                                                                                                    column: 28,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 115,
                                                                                                                                    column: 32,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        init: null
                                                                                                                    }],
                                                                                                                kind: 'let'
                                                                                                            },
                                                                                                            right: {
                                                                                                                type: 'MemberExpression',
                                                                                                                computed: false,
                                                                                                                object: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'Timezone',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 115,
                                                                                                                            column: 36,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 115,
                                                                                                                            column: 44,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                property: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'values',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 115,
                                                                                                                            column: 45,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 115,
                                                                                                                            column: 51,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 115,
                                                                                                                        column: 36,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 115,
                                                                                                                        column: 51,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            body: {
                                                                                                                type: 'BlockStatement',
                                                                                                                body: [{
                                                                                                                        type: 'ExpressionStatement',
                                                                                                                        expression: {
                                                                                                                            type: 'ObjectExpression',
                                                                                                                            objectType: {
                                                                                                                                type: 'CallExpression',
                                                                                                                                callee: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'PaperItem',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 116,
                                                                                                                                            column: 28,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 116,
                                                                                                                                            column: 37,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                arguments: [],
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 116,
                                                                                                                                        column: 28,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 116,
                                                                                                                                        column: 39,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            properties: [
                                                                                                                                {
                                                                                                                                    type: 'Property',
                                                                                                                                    key: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'value',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 117,
                                                                                                                                                column: 32,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 117,
                                                                                                                                                column: 37,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    value: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'zone',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 117,
                                                                                                                                                column: 39,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 117,
                                                                                                                                                column: 43,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    kind: 'init',
                                                                                                                                    order: '0'
                                                                                                                                },
                                                                                                                                {
                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                    expression: {
                                                                                                                                        type: 'CallExpression',
                                                                                                                                        callee: {
                                                                                                                                            type: 'Function',
                                                                                                                                            context: true,
                                                                                                                                            value: function (_context17) {
                                                                                                                                                return function () {
                                                                                                                                                    var moment = _context17.get('moment'), zone = _context17.get('zone');
                                                                                                                                                    return '(' + moment.tz(zone).format('Z') + ') ' + zone.replace(/_/g, ' ');
                                                                                                                                                };
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        arguments: [],
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 118,
                                                                                                                                                column: 32,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 118,
                                                                                                                                                column: 104,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 118,
                                                                                                                                            column: 32,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 118,
                                                                                                                                            column: 104,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    order: '1'
                                                                                                                                }
                                                                                                                            ]
                                                                                                                        },
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 116,
                                                                                                                                column: 28,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 119,
                                                                                                                                column: 32,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            }
                                                                                                                        },
                                                                                                                        order: '0'
                                                                                                                    }]
                                                                                                            },
                                                                                                            remove: null,
                                                                                                            order: '2'
                                                                                                        }
                                                                                                    ]
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 105,
                                                                                                        column: 20,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 119,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                    }
                                                                                                },
                                                                                                order: '1'
                                                                                            }
                                                                                        ]
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 103,
                                                                                            column: 16,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 119,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                        }
                                                                                    },
                                                                                    order: '0'
                                                                                }]
                                                                        },
                                                                        {
                                                                            type: 'ObjectExpression',
                                                                            properties: [
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'valueJSON',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 97,
                                                                                                column: 25,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 97,
                                                                                                column: 34,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'ObjectExpression',
                                                                                        properties: [
                                                                                            {
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'get',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 98,
                                                                                                            column: 20,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 98,
                                                                                                            column: 23,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'Function',
                                                                                                    context: true,
                                                                                                    value: function (_context18) {
                                                                                                        return function () {
                                                                                                            var state = _context18.get('state');
                                                                                                            return state.value;
                                                                                                        };
                                                                                                    }
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '0'
                                                                                            },
                                                                                            {
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'set',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 99,
                                                                                                            column: 20,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 99,
                                                                                                            column: 23,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'Function',
                                                                                                    context: true,
                                                                                                    value: function (_context19) {
                                                                                                        return function (newValue) {
                                                                                                            var state = _context19.get('state');
                                                                                                            return state.value = newValue;
                                                                                                        };
                                                                                                    }
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '1'
                                                                                            }
                                                                                        ]
                                                                                    },
                                                                                    kind: 'init',
                                                                                    define: false,
                                                                                    order: '0'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'label',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 100,
                                                                                                column: 25,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 100,
                                                                                                column: 30,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'ObjectExpression',
                                                                                        properties: [
                                                                                            {
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'get',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 101,
                                                                                                            column: 20,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 101,
                                                                                                            column: 23,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'Function',
                                                                                                    context: true,
                                                                                                    value: function (_context20) {
                                                                                                        return function () {
                                                                                                            var dropdown = _context20.get('dropdown');
                                                                                                            return dropdown.label;
                                                                                                        };
                                                                                                    }
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '0'
                                                                                            },
                                                                                            {
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'set',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 102,
                                                                                                            column: 20,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 102,
                                                                                                            column: 23,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'Function',
                                                                                                    context: true,
                                                                                                    value: function (_context21) {
                                                                                                        return function (value) {
                                                                                                            var dropdown = _context21.get('dropdown');
                                                                                                            return dropdown.label = value;
                                                                                                        };
                                                                                                    }
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '1'
                                                                                            }
                                                                                        ]
                                                                                    },
                                                                                    kind: 'init',
                                                                                    define: false,
                                                                                    order: '1'
                                                                                }
                                                                            ]
                                                                        }
                                                                    ]
                                                                },
                                                                order: '3'
                                                            }
                                                        ]
                                                    },
                                                    alternate: {
                                                        type: 'IfStatement',
                                                        test: {
                                                            type: 'BinaryExpression',
                                                            operator: '===',
                                                            left: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'property',
                                                                    loc: {
                                                                        start: {
                                                                            line: 119,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/forms/Field.ion'
                                                                        },
                                                                        end: {
                                                                            line: 119,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'glass/html/forms/Field.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'type',
                                                                    loc: {
                                                                        start: {
                                                                            line: 119,
                                                                            column: 25,
                                                                            fixed: true,
                                                                            source: 'glass/html/forms/Field.ion'
                                                                        },
                                                                        end: {
                                                                            line: 119,
                                                                            column: 29,
                                                                            fixed: true,
                                                                            source: 'glass/html/forms/Field.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 119,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/Field.ion'
                                                                    },
                                                                    end: {
                                                                        line: 119,
                                                                        column: 29,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/Field.ion'
                                                                    }
                                                                }
                                                            },
                                                            right: {
                                                                type: 'Literal',
                                                                value: 'boolean'
                                                            }
                                                        },
                                                        consequent: {
                                                            type: 'BlockStatement',
                                                            body: [{
                                                                    type: 'ReturnStatement',
                                                                    argument: {
                                                                        type: 'ObjectExpression',
                                                                        objectType: {
                                                                            type: 'CallExpression',
                                                                            callee: {
                                                                                type: 'Identifier',
                                                                                name: 'PaperToggleButton',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 120,
                                                                                        column: 19,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 120,
                                                                                        column: 36,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            arguments: [],
                                                                            loc: {
                                                                                start: {
                                                                                    line: 120,
                                                                                    column: 19,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 120,
                                                                                    column: 38,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        properties: [{
                                                                                type: 'ExpressionStatement',
                                                                                expression: {
                                                                                    type: 'Identifier',
                                                                                    name: 'label',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 121,
                                                                                            column: 16,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 121,
                                                                                            column: 21,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 121,
                                                                                        column: 16,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 121,
                                                                                        column: 21,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                    }
                                                                                },
                                                                                order: '0'
                                                                            }]
                                                                    },
                                                                    order: '0'
                                                                }]
                                                        },
                                                        alternate: {
                                                            type: 'BlockStatement',
                                                            body: [
                                                                {
                                                                    type: 'VariableDeclaration',
                                                                    declarations: [{
                                                                            type: 'VariableDeclarator',
                                                                            id: {
                                                                                type: 'Identifier',
                                                                                name: 'inputElem',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 127,
                                                                                        column: 16,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 127,
                                                                                        column: 25,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            init: {
                                                                                type: 'CallExpression',
                                                                                callee: {
                                                                                    type: 'Function',
                                                                                    context: false,
                                                                                    value: function (property) {
                                                                                        if ((property != null ? property.format : void 0) === 'email') {
                                                                                            return GoldEmailInput();
                                                                                        }
                                                                                        if ((property != null ? property.format : void 0) === 'phone') {
                                                                                            return GoldPhoneInput();
                                                                                        } else if ((property != null ? property.maxLength : void 0) >= 1000) {
                                                                                            return PaperTextarea();
                                                                                        } else {
                                                                                            return PaperInput();
                                                                                        }
                                                                                    }
                                                                                },
                                                                                arguments: [{
                                                                                        type: 'Identifier',
                                                                                        name: 'property',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 127,
                                                                                                column: 32,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 127,
                                                                                                column: 40,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                            }
                                                                                        }
                                                                                    }],
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 127,
                                                                                        column: 28,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 136,
                                                                                        column: 16,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                    }
                                                                                }
                                                                            }
                                                                        }],
                                                                    kind: 'let',
                                                                    order: '0'
                                                                },
                                                                {
                                                                    type: 'ReturnStatement',
                                                                    argument: {
                                                                        type: 'ObjectExpression',
                                                                        objectType: {
                                                                            type: 'Identifier',
                                                                            name: 'inputElem',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 136,
                                                                                    column: 19,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 136,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        properties: [
                                                                            {
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'select',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 137,
                                                                                            column: 16,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 137,
                                                                                            column: 22,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Function',
                                                                                    context: false,
                                                                                    value: function () {
                                                                                        this.inputElement.select();
                                                                                    }
                                                                                },
                                                                                kind: 'init',
                                                                                order: '0'
                                                                            },
                                                                            {
                                                                                type: 'IfStatement',
                                                                                test: {
                                                                                    type: 'UnaryExpression',
                                                                                    operator: '?',
                                                                                    argument: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'property',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 139,
                                                                                                    column: 19,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 139,
                                                                                                    column: 27,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'required',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 139,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 139,
                                                                                                    column: 36,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 139,
                                                                                                column: 19,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 139,
                                                                                                column: 36,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                },
                                                                                consequent: {
                                                                                    type: 'BlockStatement',
                                                                                    body: [{
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'required',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 140,
                                                                                                        column: 20,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 140,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'MemberExpression',
                                                                                                computed: false,
                                                                                                object: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'property',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 140,
                                                                                                            column: 30,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 140,
                                                                                                            column: 38,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'required',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 140,
                                                                                                            column: 39,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 140,
                                                                                                            column: 47,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 140,
                                                                                                        column: 30,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 140,
                                                                                                        column: 47,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '0'
                                                                                        }]
                                                                                },
                                                                                alternate: null,
                                                                                order: '1'
                                                                            },
                                                                            {
                                                                                type: 'IfStatement',
                                                                                test: {
                                                                                    type: 'UnaryExpression',
                                                                                    operator: '?',
                                                                                    argument: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'property',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 141,
                                                                                                    column: 19,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 141,
                                                                                                    column: 27,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'pattern',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 141,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 141,
                                                                                                    column: 35,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 141,
                                                                                                column: 19,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 141,
                                                                                                column: 35,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                },
                                                                                consequent: {
                                                                                    type: 'BlockStatement',
                                                                                    body: [{
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'pattern',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 142,
                                                                                                        column: 20,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 142,
                                                                                                        column: 27,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'MemberExpression',
                                                                                                computed: false,
                                                                                                object: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'property',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 142,
                                                                                                            column: 29,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 142,
                                                                                                            column: 37,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'pattern',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 142,
                                                                                                            column: 38,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 142,
                                                                                                            column: 45,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 142,
                                                                                                        column: 29,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 142,
                                                                                                        column: 45,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '0'
                                                                                        }]
                                                                                },
                                                                                alternate: null,
                                                                                order: '2'
                                                                            },
                                                                            {
                                                                                type: 'IfStatement',
                                                                                test: {
                                                                                    type: 'UnaryExpression',
                                                                                    operator: '?',
                                                                                    argument: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'property',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 143,
                                                                                                    column: 19,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 143,
                                                                                                    column: 27,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'minimum',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 143,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 143,
                                                                                                    column: 35,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 143,
                                                                                                column: 19,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 143,
                                                                                                column: 35,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                },
                                                                                consequent: {
                                                                                    type: 'BlockStatement',
                                                                                    body: [{
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'min',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 144,
                                                                                                        column: 20,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 144,
                                                                                                        column: 23,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'MemberExpression',
                                                                                                computed: false,
                                                                                                object: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'property',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 144,
                                                                                                            column: 25,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 144,
                                                                                                            column: 33,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'minimum',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 144,
                                                                                                            column: 34,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 144,
                                                                                                            column: 41,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 144,
                                                                                                        column: 25,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 144,
                                                                                                        column: 41,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '0'
                                                                                        }]
                                                                                },
                                                                                alternate: null,
                                                                                order: '3'
                                                                            },
                                                                            {
                                                                                type: 'IfStatement',
                                                                                test: {
                                                                                    type: 'UnaryExpression',
                                                                                    operator: '?',
                                                                                    argument: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'property',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 145,
                                                                                                    column: 19,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 145,
                                                                                                    column: 27,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'maximum',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 145,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 145,
                                                                                                    column: 35,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 145,
                                                                                                column: 19,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 145,
                                                                                                column: 35,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                },
                                                                                consequent: {
                                                                                    type: 'BlockStatement',
                                                                                    body: [{
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'max',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 146,
                                                                                                        column: 20,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 146,
                                                                                                        column: 23,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'MemberExpression',
                                                                                                computed: false,
                                                                                                object: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'property',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 146,
                                                                                                            column: 25,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 146,
                                                                                                            column: 33,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'maximum',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 146,
                                                                                                            column: 34,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 146,
                                                                                                            column: 41,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 146,
                                                                                                        column: 25,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 146,
                                                                                                        column: 41,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '0'
                                                                                        }]
                                                                                },
                                                                                alternate: null,
                                                                                order: '4'
                                                                            },
                                                                            {
                                                                                type: 'IfStatement',
                                                                                test: {
                                                                                    type: 'UnaryExpression',
                                                                                    operator: '?',
                                                                                    argument: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'property',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 147,
                                                                                                    column: 19,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 147,
                                                                                                    column: 27,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'maxLength',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 147,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 147,
                                                                                                    column: 37,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 147,
                                                                                                column: 19,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 147,
                                                                                                column: 37,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                },
                                                                                consequent: {
                                                                                    type: 'BlockStatement',
                                                                                    body: [
                                                                                        {
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'maxlength',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 148,
                                                                                                        column: 20,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 148,
                                                                                                        column: 29,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'MemberExpression',
                                                                                                computed: false,
                                                                                                object: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'property',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 148,
                                                                                                            column: 31,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 148,
                                                                                                            column: 39,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'maxLength',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 148,
                                                                                                            column: 40,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 148,
                                                                                                            column: 49,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 148,
                                                                                                        column: 31,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 148,
                                                                                                        column: 49,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '0'
                                                                                        },
                                                                                        {
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'charCounter',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 149,
                                                                                                        column: 20,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 149,
                                                                                                        column: 31,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'Literal',
                                                                                                value: true
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '1'
                                                                                        }
                                                                                    ]
                                                                                },
                                                                                alternate: null,
                                                                                order: '5'
                                                                            },
                                                                            {
                                                                                type: 'IfStatement',
                                                                                test: {
                                                                                    type: 'UnaryExpression',
                                                                                    operator: '?',
                                                                                    argument: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'property',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 150,
                                                                                                    column: 19,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 150,
                                                                                                    column: 27,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'minLength',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 150,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 150,
                                                                                                    column: 37,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 150,
                                                                                                column: 19,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 150,
                                                                                                column: 37,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                },
                                                                                consequent: {
                                                                                    type: 'BlockStatement',
                                                                                    body: [{
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'minlength',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 151,
                                                                                                        column: 20,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 151,
                                                                                                        column: 29,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'MemberExpression',
                                                                                                computed: false,
                                                                                                object: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'property',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 151,
                                                                                                            column: 31,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 151,
                                                                                                            column: 39,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'minLength',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 151,
                                                                                                            column: 40,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 151,
                                                                                                            column: 49,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 151,
                                                                                                        column: 31,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 151,
                                                                                                        column: 49,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '0'
                                                                                        }]
                                                                                },
                                                                                alternate: null,
                                                                                order: '6'
                                                                            },
                                                                            {
                                                                                type: 'IfStatement',
                                                                                test: {
                                                                                    type: 'UnaryExpression',
                                                                                    operator: '?',
                                                                                    argument: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'property',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 152,
                                                                                                    column: 19,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 152,
                                                                                                    column: 27,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'placeholder',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 152,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 152,
                                                                                                    column: 39,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 152,
                                                                                                column: 19,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 152,
                                                                                                column: 39,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                },
                                                                                consequent: {
                                                                                    type: 'BlockStatement',
                                                                                    body: [{
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'placeholder',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 153,
                                                                                                        column: 20,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 153,
                                                                                                        column: 31,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'MemberExpression',
                                                                                                computed: false,
                                                                                                object: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'property',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 153,
                                                                                                            column: 33,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 153,
                                                                                                            column: 41,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'placeholder',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 153,
                                                                                                            column: 42,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 153,
                                                                                                            column: 53,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 153,
                                                                                                        column: 33,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 153,
                                                                                                        column: 53,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '0'
                                                                                        }]
                                                                                },
                                                                                alternate: null,
                                                                                order: '7'
                                                                            },
                                                                            {
                                                                                type: 'VariableDeclaration',
                                                                                declarations: [{
                                                                                        type: 'VariableDeclarator',
                                                                                        id: {
                                                                                            type: 'Identifier',
                                                                                            name: 'type',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 154,
                                                                                                    column: 20,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 154,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        init: {
                                                                                            type: 'ConditionalExpression',
                                                                                            test: {
                                                                                                type: 'BinaryExpression',
                                                                                                operator: '!=',
                                                                                                left: {
                                                                                                    type: 'ConditionalExpression',
                                                                                                    test: {
                                                                                                        type: 'BinaryExpression',
                                                                                                        operator: '!=',
                                                                                                        left: {
                                                                                                            type: 'ConditionalExpression',
                                                                                                            test: {
                                                                                                                type: 'BinaryExpression',
                                                                                                                operator: '!=',
                                                                                                                left: {
                                                                                                                    type: 'ConditionalExpression',
                                                                                                                    test: {
                                                                                                                        type: 'BinaryExpression',
                                                                                                                        operator: '!=',
                                                                                                                        left: {
                                                                                                                            type: 'MemberExpression',
                                                                                                                            computed: true,
                                                                                                                            object: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'inputTypeMap',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 154,
                                                                                                                                        column: 27,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 154,
                                                                                                                                        column: 39,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            property: {
                                                                                                                                type: 'MemberExpression',
                                                                                                                                computed: false,
                                                                                                                                object: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'property',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 154,
                                                                                                                                            column: 40,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 154,
                                                                                                                                            column: 48,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                property: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'format',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 154,
                                                                                                                                            column: 49,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 154,
                                                                                                                                            column: 55,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 154,
                                                                                                                                        column: 40,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 154,
                                                                                                                                        column: 55,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 154,
                                                                                                                                    column: 27,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 154,
                                                                                                                                    column: 56,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        right: {
                                                                                                                            type: 'Literal',
                                                                                                                            value: null
                                                                                                                        }
                                                                                                                    },
                                                                                                                    consequent: {
                                                                                                                        type: 'MemberExpression',
                                                                                                                        computed: true,
                                                                                                                        object: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'inputTypeMap',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 154,
                                                                                                                                    column: 27,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 154,
                                                                                                                                    column: 39,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        property: {
                                                                                                                            type: 'MemberExpression',
                                                                                                                            computed: false,
                                                                                                                            object: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'property',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 154,
                                                                                                                                        column: 40,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 154,
                                                                                                                                        column: 48,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            property: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'format',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 154,
                                                                                                                                        column: 49,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 154,
                                                                                                                                        column: 55,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 154,
                                                                                                                                    column: 40,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 154,
                                                                                                                                    column: 55,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 154,
                                                                                                                                column: 27,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 154,
                                                                                                                                column: 56,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    alternate: {
                                                                                                                        type: 'MemberExpression',
                                                                                                                        computed: false,
                                                                                                                        object: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'property',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 154,
                                                                                                                                    column: 59,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 154,
                                                                                                                                    column: 67,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        property: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'format',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 154,
                                                                                                                                    column: 68,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 154,
                                                                                                                                    column: 74,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 154,
                                                                                                                                column: 59,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 154,
                                                                                                                                column: 74,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                right: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: null
                                                                                                                }
                                                                                                            },
                                                                                                            consequent: {
                                                                                                                type: 'ConditionalExpression',
                                                                                                                test: {
                                                                                                                    type: 'BinaryExpression',
                                                                                                                    operator: '!=',
                                                                                                                    left: {
                                                                                                                        type: 'MemberExpression',
                                                                                                                        computed: true,
                                                                                                                        object: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'inputTypeMap',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 154,
                                                                                                                                    column: 27,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 154,
                                                                                                                                    column: 39,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        property: {
                                                                                                                            type: 'MemberExpression',
                                                                                                                            computed: false,
                                                                                                                            object: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'property',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 154,
                                                                                                                                        column: 40,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 154,
                                                                                                                                        column: 48,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            property: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'format',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 154,
                                                                                                                                        column: 49,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 154,
                                                                                                                                        column: 55,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 154,
                                                                                                                                    column: 40,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 154,
                                                                                                                                    column: 55,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 154,
                                                                                                                                column: 27,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 154,
                                                                                                                                column: 56,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    right: {
                                                                                                                        type: 'Literal',
                                                                                                                        value: null
                                                                                                                    }
                                                                                                                },
                                                                                                                consequent: {
                                                                                                                    type: 'MemberExpression',
                                                                                                                    computed: true,
                                                                                                                    object: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'inputTypeMap',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 154,
                                                                                                                                column: 27,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 154,
                                                                                                                                column: 39,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    property: {
                                                                                                                        type: 'MemberExpression',
                                                                                                                        computed: false,
                                                                                                                        object: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'property',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 154,
                                                                                                                                    column: 40,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 154,
                                                                                                                                    column: 48,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        property: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'format',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 154,
                                                                                                                                    column: 49,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 154,
                                                                                                                                    column: 55,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 154,
                                                                                                                                column: 40,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 154,
                                                                                                                                column: 55,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 154,
                                                                                                                            column: 27,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 154,
                                                                                                                            column: 56,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                alternate: {
                                                                                                                    type: 'MemberExpression',
                                                                                                                    computed: false,
                                                                                                                    object: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'property',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 154,
                                                                                                                                column: 59,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 154,
                                                                                                                                column: 67,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    property: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'format',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 154,
                                                                                                                                column: 68,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 154,
                                                                                                                                column: 74,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 154,
                                                                                                                            column: 59,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 154,
                                                                                                                            column: 74,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            alternate: {
                                                                                                                type: 'MemberExpression',
                                                                                                                computed: true,
                                                                                                                object: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'inputTypeMap',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 154,
                                                                                                                            column: 77,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 154,
                                                                                                                            column: 89,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                property: {
                                                                                                                    type: 'MemberExpression',
                                                                                                                    computed: false,
                                                                                                                    object: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'property',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 154,
                                                                                                                                column: 90,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 154,
                                                                                                                                column: 98,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    property: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'type',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 154,
                                                                                                                                column: 99,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 154,
                                                                                                                                column: 103,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 154,
                                                                                                                            column: 90,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 154,
                                                                                                                            column: 103,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 154,
                                                                                                                        column: 77,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 154,
                                                                                                                        column: 104,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        right: {
                                                                                                            type: 'Literal',
                                                                                                            value: null
                                                                                                        }
                                                                                                    },
                                                                                                    consequent: {
                                                                                                        type: 'ConditionalExpression',
                                                                                                        test: {
                                                                                                            type: 'BinaryExpression',
                                                                                                            operator: '!=',
                                                                                                            left: {
                                                                                                                type: 'ConditionalExpression',
                                                                                                                test: {
                                                                                                                    type: 'BinaryExpression',
                                                                                                                    operator: '!=',
                                                                                                                    left: {
                                                                                                                        type: 'MemberExpression',
                                                                                                                        computed: true,
                                                                                                                        object: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'inputTypeMap',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 154,
                                                                                                                                    column: 27,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 154,
                                                                                                                                    column: 39,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        property: {
                                                                                                                            type: 'MemberExpression',
                                                                                                                            computed: false,
                                                                                                                            object: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'property',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 154,
                                                                                                                                        column: 40,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 154,
                                                                                                                                        column: 48,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            property: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'format',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 154,
                                                                                                                                        column: 49,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 154,
                                                                                                                                        column: 55,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 154,
                                                                                                                                    column: 40,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 154,
                                                                                                                                    column: 55,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 154,
                                                                                                                                column: 27,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 154,
                                                                                                                                column: 56,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    right: {
                                                                                                                        type: 'Literal',
                                                                                                                        value: null
                                                                                                                    }
                                                                                                                },
                                                                                                                consequent: {
                                                                                                                    type: 'MemberExpression',
                                                                                                                    computed: true,
                                                                                                                    object: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'inputTypeMap',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 154,
                                                                                                                                column: 27,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 154,
                                                                                                                                column: 39,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    property: {
                                                                                                                        type: 'MemberExpression',
                                                                                                                        computed: false,
                                                                                                                        object: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'property',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 154,
                                                                                                                                    column: 40,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 154,
                                                                                                                                    column: 48,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        property: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'format',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 154,
                                                                                                                                    column: 49,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 154,
                                                                                                                                    column: 55,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 154,
                                                                                                                                column: 40,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 154,
                                                                                                                                column: 55,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 154,
                                                                                                                            column: 27,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 154,
                                                                                                                            column: 56,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                alternate: {
                                                                                                                    type: 'MemberExpression',
                                                                                                                    computed: false,
                                                                                                                    object: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'property',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 154,
                                                                                                                                column: 59,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 154,
                                                                                                                                column: 67,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    property: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'format',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 154,
                                                                                                                                column: 68,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 154,
                                                                                                                                column: 74,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 154,
                                                                                                                            column: 59,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 154,
                                                                                                                            column: 74,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            right: {
                                                                                                                type: 'Literal',
                                                                                                                value: null
                                                                                                            }
                                                                                                        },
                                                                                                        consequent: {
                                                                                                            type: 'ConditionalExpression',
                                                                                                            test: {
                                                                                                                type: 'BinaryExpression',
                                                                                                                operator: '!=',
                                                                                                                left: {
                                                                                                                    type: 'MemberExpression',
                                                                                                                    computed: true,
                                                                                                                    object: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'inputTypeMap',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 154,
                                                                                                                                column: 27,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 154,
                                                                                                                                column: 39,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    property: {
                                                                                                                        type: 'MemberExpression',
                                                                                                                        computed: false,
                                                                                                                        object: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'property',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 154,
                                                                                                                                    column: 40,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 154,
                                                                                                                                    column: 48,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        property: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'format',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 154,
                                                                                                                                    column: 49,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 154,
                                                                                                                                    column: 55,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 154,
                                                                                                                                column: 40,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 154,
                                                                                                                                column: 55,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 154,
                                                                                                                            column: 27,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 154,
                                                                                                                            column: 56,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                right: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: null
                                                                                                                }
                                                                                                            },
                                                                                                            consequent: {
                                                                                                                type: 'MemberExpression',
                                                                                                                computed: true,
                                                                                                                object: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'inputTypeMap',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 154,
                                                                                                                            column: 27,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 154,
                                                                                                                            column: 39,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                property: {
                                                                                                                    type: 'MemberExpression',
                                                                                                                    computed: false,
                                                                                                                    object: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'property',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 154,
                                                                                                                                column: 40,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 154,
                                                                                                                                column: 48,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    property: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'format',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 154,
                                                                                                                                column: 49,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 154,
                                                                                                                                column: 55,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 154,
                                                                                                                            column: 40,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 154,
                                                                                                                            column: 55,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 154,
                                                                                                                        column: 27,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 154,
                                                                                                                        column: 56,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            alternate: {
                                                                                                                type: 'MemberExpression',
                                                                                                                computed: false,
                                                                                                                object: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'property',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 154,
                                                                                                                            column: 59,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 154,
                                                                                                                            column: 67,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                property: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'format',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 154,
                                                                                                                            column: 68,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 154,
                                                                                                                            column: 74,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 154,
                                                                                                                        column: 59,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 154,
                                                                                                                        column: 74,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        alternate: {
                                                                                                            type: 'MemberExpression',
                                                                                                            computed: true,
                                                                                                            object: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'inputTypeMap',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 154,
                                                                                                                        column: 77,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 154,
                                                                                                                        column: 89,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            property: {
                                                                                                                type: 'MemberExpression',
                                                                                                                computed: false,
                                                                                                                object: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'property',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 154,
                                                                                                                            column: 90,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 154,
                                                                                                                            column: 98,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                property: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'type',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 154,
                                                                                                                            column: 99,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 154,
                                                                                                                            column: 103,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 154,
                                                                                                                        column: 90,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 154,
                                                                                                                        column: 103,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 154,
                                                                                                                    column: 77,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 154,
                                                                                                                    column: 104,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    alternate: {
                                                                                                        type: 'MemberExpression',
                                                                                                        computed: false,
                                                                                                        object: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'property',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 154,
                                                                                                                    column: 107,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 154,
                                                                                                                    column: 115,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        property: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'type',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 154,
                                                                                                                    column: 116,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 154,
                                                                                                                    column: 120,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 154,
                                                                                                                column: 107,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 154,
                                                                                                                column: 120,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                right: {
                                                                                                    type: 'Literal',
                                                                                                    value: null
                                                                                                }
                                                                                            },
                                                                                            consequent: {
                                                                                                type: 'ConditionalExpression',
                                                                                                test: {
                                                                                                    type: 'BinaryExpression',
                                                                                                    operator: '!=',
                                                                                                    left: {
                                                                                                        type: 'ConditionalExpression',
                                                                                                        test: {
                                                                                                            type: 'BinaryExpression',
                                                                                                            operator: '!=',
                                                                                                            left: {
                                                                                                                type: 'ConditionalExpression',
                                                                                                                test: {
                                                                                                                    type: 'BinaryExpression',
                                                                                                                    operator: '!=',
                                                                                                                    left: {
                                                                                                                        type: 'MemberExpression',
                                                                                                                        computed: true,
                                                                                                                        object: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'inputTypeMap',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 154,
                                                                                                                                    column: 27,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 154,
                                                                                                                                    column: 39,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        property: {
                                                                                                                            type: 'MemberExpression',
                                                                                                                            computed: false,
                                                                                                                            object: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'property',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 154,
                                                                                                                                        column: 40,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 154,
                                                                                                                                        column: 48,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            property: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'format',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 154,
                                                                                                                                        column: 49,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 154,
                                                                                                                                        column: 55,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 154,
                                                                                                                                    column: 40,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 154,
                                                                                                                                    column: 55,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 154,
                                                                                                                                column: 27,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 154,
                                                                                                                                column: 56,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    right: {
                                                                                                                        type: 'Literal',
                                                                                                                        value: null
                                                                                                                    }
                                                                                                                },
                                                                                                                consequent: {
                                                                                                                    type: 'MemberExpression',
                                                                                                                    computed: true,
                                                                                                                    object: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'inputTypeMap',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 154,
                                                                                                                                column: 27,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 154,
                                                                                                                                column: 39,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    property: {
                                                                                                                        type: 'MemberExpression',
                                                                                                                        computed: false,
                                                                                                                        object: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'property',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 154,
                                                                                                                                    column: 40,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 154,
                                                                                                                                    column: 48,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        property: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'format',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 154,
                                                                                                                                    column: 49,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 154,
                                                                                                                                    column: 55,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 154,
                                                                                                                                column: 40,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 154,
                                                                                                                                column: 55,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 154,
                                                                                                                            column: 27,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 154,
                                                                                                                            column: 56,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                alternate: {
                                                                                                                    type: 'MemberExpression',
                                                                                                                    computed: false,
                                                                                                                    object: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'property',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 154,
                                                                                                                                column: 59,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 154,
                                                                                                                                column: 67,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    property: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'format',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 154,
                                                                                                                                column: 68,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 154,
                                                                                                                                column: 74,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 154,
                                                                                                                            column: 59,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 154,
                                                                                                                            column: 74,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            right: {
                                                                                                                type: 'Literal',
                                                                                                                value: null
                                                                                                            }
                                                                                                        },
                                                                                                        consequent: {
                                                                                                            type: 'ConditionalExpression',
                                                                                                            test: {
                                                                                                                type: 'BinaryExpression',
                                                                                                                operator: '!=',
                                                                                                                left: {
                                                                                                                    type: 'MemberExpression',
                                                                                                                    computed: true,
                                                                                                                    object: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'inputTypeMap',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 154,
                                                                                                                                column: 27,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 154,
                                                                                                                                column: 39,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    property: {
                                                                                                                        type: 'MemberExpression',
                                                                                                                        computed: false,
                                                                                                                        object: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'property',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 154,
                                                                                                                                    column: 40,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 154,
                                                                                                                                    column: 48,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        property: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'format',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 154,
                                                                                                                                    column: 49,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 154,
                                                                                                                                    column: 55,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 154,
                                                                                                                                column: 40,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 154,
                                                                                                                                column: 55,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 154,
                                                                                                                            column: 27,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 154,
                                                                                                                            column: 56,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                right: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: null
                                                                                                                }
                                                                                                            },
                                                                                                            consequent: {
                                                                                                                type: 'MemberExpression',
                                                                                                                computed: true,
                                                                                                                object: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'inputTypeMap',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 154,
                                                                                                                            column: 27,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 154,
                                                                                                                            column: 39,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                property: {
                                                                                                                    type: 'MemberExpression',
                                                                                                                    computed: false,
                                                                                                                    object: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'property',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 154,
                                                                                                                                column: 40,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 154,
                                                                                                                                column: 48,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    property: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'format',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 154,
                                                                                                                                column: 49,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 154,
                                                                                                                                column: 55,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 154,
                                                                                                                            column: 40,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 154,
                                                                                                                            column: 55,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 154,
                                                                                                                        column: 27,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 154,
                                                                                                                        column: 56,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            alternate: {
                                                                                                                type: 'MemberExpression',
                                                                                                                computed: false,
                                                                                                                object: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'property',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 154,
                                                                                                                            column: 59,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 154,
                                                                                                                            column: 67,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                property: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'format',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 154,
                                                                                                                            column: 68,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 154,
                                                                                                                            column: 74,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 154,
                                                                                                                        column: 59,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 154,
                                                                                                                        column: 74,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        alternate: {
                                                                                                            type: 'MemberExpression',
                                                                                                            computed: true,
                                                                                                            object: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'inputTypeMap',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 154,
                                                                                                                        column: 77,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 154,
                                                                                                                        column: 89,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            property: {
                                                                                                                type: 'MemberExpression',
                                                                                                                computed: false,
                                                                                                                object: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'property',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 154,
                                                                                                                            column: 90,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 154,
                                                                                                                            column: 98,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                property: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'type',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 154,
                                                                                                                            column: 99,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 154,
                                                                                                                            column: 103,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 154,
                                                                                                                        column: 90,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 154,
                                                                                                                        column: 103,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 154,
                                                                                                                    column: 77,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 154,
                                                                                                                    column: 104,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    right: {
                                                                                                        type: 'Literal',
                                                                                                        value: null
                                                                                                    }
                                                                                                },
                                                                                                consequent: {
                                                                                                    type: 'ConditionalExpression',
                                                                                                    test: {
                                                                                                        type: 'BinaryExpression',
                                                                                                        operator: '!=',
                                                                                                        left: {
                                                                                                            type: 'ConditionalExpression',
                                                                                                            test: {
                                                                                                                type: 'BinaryExpression',
                                                                                                                operator: '!=',
                                                                                                                left: {
                                                                                                                    type: 'MemberExpression',
                                                                                                                    computed: true,
                                                                                                                    object: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'inputTypeMap',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 154,
                                                                                                                                column: 27,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 154,
                                                                                                                                column: 39,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    property: {
                                                                                                                        type: 'MemberExpression',
                                                                                                                        computed: false,
                                                                                                                        object: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'property',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 154,
                                                                                                                                    column: 40,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 154,
                                                                                                                                    column: 48,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        property: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'format',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 154,
                                                                                                                                    column: 49,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 154,
                                                                                                                                    column: 55,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 154,
                                                                                                                                column: 40,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 154,
                                                                                                                                column: 55,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 154,
                                                                                                                            column: 27,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 154,
                                                                                                                            column: 56,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                right: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: null
                                                                                                                }
                                                                                                            },
                                                                                                            consequent: {
                                                                                                                type: 'MemberExpression',
                                                                                                                computed: true,
                                                                                                                object: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'inputTypeMap',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 154,
                                                                                                                            column: 27,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 154,
                                                                                                                            column: 39,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                property: {
                                                                                                                    type: 'MemberExpression',
                                                                                                                    computed: false,
                                                                                                                    object: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'property',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 154,
                                                                                                                                column: 40,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 154,
                                                                                                                                column: 48,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    property: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'format',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 154,
                                                                                                                                column: 49,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 154,
                                                                                                                                column: 55,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 154,
                                                                                                                            column: 40,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 154,
                                                                                                                            column: 55,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 154,
                                                                                                                        column: 27,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 154,
                                                                                                                        column: 56,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            alternate: {
                                                                                                                type: 'MemberExpression',
                                                                                                                computed: false,
                                                                                                                object: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'property',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 154,
                                                                                                                            column: 59,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 154,
                                                                                                                            column: 67,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                property: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'format',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 154,
                                                                                                                            column: 68,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 154,
                                                                                                                            column: 74,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 154,
                                                                                                                        column: 59,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 154,
                                                                                                                        column: 74,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        right: {
                                                                                                            type: 'Literal',
                                                                                                            value: null
                                                                                                        }
                                                                                                    },
                                                                                                    consequent: {
                                                                                                        type: 'ConditionalExpression',
                                                                                                        test: {
                                                                                                            type: 'BinaryExpression',
                                                                                                            operator: '!=',
                                                                                                            left: {
                                                                                                                type: 'MemberExpression',
                                                                                                                computed: true,
                                                                                                                object: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'inputTypeMap',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 154,
                                                                                                                            column: 27,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 154,
                                                                                                                            column: 39,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                property: {
                                                                                                                    type: 'MemberExpression',
                                                                                                                    computed: false,
                                                                                                                    object: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'property',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 154,
                                                                                                                                column: 40,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 154,
                                                                                                                                column: 48,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    property: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'format',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 154,
                                                                                                                                column: 49,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 154,
                                                                                                                                column: 55,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 154,
                                                                                                                            column: 40,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 154,
                                                                                                                            column: 55,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 154,
                                                                                                                        column: 27,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 154,
                                                                                                                        column: 56,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            right: {
                                                                                                                type: 'Literal',
                                                                                                                value: null
                                                                                                            }
                                                                                                        },
                                                                                                        consequent: {
                                                                                                            type: 'MemberExpression',
                                                                                                            computed: true,
                                                                                                            object: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'inputTypeMap',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 154,
                                                                                                                        column: 27,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 154,
                                                                                                                        column: 39,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            property: {
                                                                                                                type: 'MemberExpression',
                                                                                                                computed: false,
                                                                                                                object: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'property',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 154,
                                                                                                                            column: 40,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 154,
                                                                                                                            column: 48,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                property: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'format',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 154,
                                                                                                                            column: 49,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 154,
                                                                                                                            column: 55,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 154,
                                                                                                                        column: 40,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 154,
                                                                                                                        column: 55,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 154,
                                                                                                                    column: 27,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 154,
                                                                                                                    column: 56,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        alternate: {
                                                                                                            type: 'MemberExpression',
                                                                                                            computed: false,
                                                                                                            object: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'property',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 154,
                                                                                                                        column: 59,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 154,
                                                                                                                        column: 67,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            property: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'format',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 154,
                                                                                                                        column: 68,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 154,
                                                                                                                        column: 74,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 154,
                                                                                                                    column: 59,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 154,
                                                                                                                    column: 74,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    alternate: {
                                                                                                        type: 'MemberExpression',
                                                                                                        computed: true,
                                                                                                        object: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'inputTypeMap',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 154,
                                                                                                                    column: 77,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 154,
                                                                                                                    column: 89,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        property: {
                                                                                                            type: 'MemberExpression',
                                                                                                            computed: false,
                                                                                                            object: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'property',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 154,
                                                                                                                        column: 90,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 154,
                                                                                                                        column: 98,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            property: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'type',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 154,
                                                                                                                        column: 99,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 154,
                                                                                                                        column: 103,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 154,
                                                                                                                    column: 90,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 154,
                                                                                                                    column: 103,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 154,
                                                                                                                column: 77,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 154,
                                                                                                                column: 104,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                alternate: {
                                                                                                    type: 'MemberExpression',
                                                                                                    computed: false,
                                                                                                    object: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'property',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 154,
                                                                                                                column: 107,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 154,
                                                                                                                column: 115,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    property: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'type',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 154,
                                                                                                                column: 116,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 154,
                                                                                                                column: 120,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 154,
                                                                                                            column: 107,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 154,
                                                                                                            column: 120,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        }
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            alternate: {
                                                                                                type: 'Literal',
                                                                                                value: 'text'
                                                                                            }
                                                                                        }
                                                                                    }],
                                                                                kind: 'let',
                                                                                order: '8'
                                                                            },
                                                                            {
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'type',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 155,
                                                                                            column: 16,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 155,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Identifier',
                                                                                    name: 'type',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 155,
                                                                                            column: 22,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 155,
                                                                                            column: 26,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                kind: 'init',
                                                                                order: '9'
                                                                            },
                                                                            {
                                                                                type: 'IfStatement',
                                                                                test: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'property',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 156,
                                                                                                column: 19,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 156,
                                                                                                column: 27,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'percent',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 156,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 156,
                                                                                                column: 35,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 156,
                                                                                            column: 19,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 156,
                                                                                            column: 35,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                consequent: {
                                                                                    type: 'BlockStatement',
                                                                                    body: [{
                                                                                            type: 'ExpressionStatement',
                                                                                            expression: {
                                                                                                type: 'ObjectExpression',
                                                                                                objectType: {
                                                                                                    type: 'CallExpression',
                                                                                                    callee: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'PaperCheckbox',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 157,
                                                                                                                column: 20,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 157,
                                                                                                                column: 33,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    arguments: [{
                                                                                                            type: 'ObjectExpression',
                                                                                                            properties: [{
                                                                                                                    type: 'Property',
                                                                                                                    key: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'suffix',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 157,
                                                                                                                                column: 35,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 157,
                                                                                                                                column: 41,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    value: {
                                                                                                                        type: 'Literal',
                                                                                                                        value: true
                                                                                                                    },
                                                                                                                    kind: 'init',
                                                                                                                    order: '0'
                                                                                                                }]
                                                                                                        }],
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 157,
                                                                                                            column: 20,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 157,
                                                                                                            column: 48,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                properties: [
                                                                                                    {
                                                                                                        type: 'Property',
                                                                                                        key: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'checked',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 158,
                                                                                                                    column: 24,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 158,
                                                                                                                    column: 31,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        value: {
                                                                                                            type: 'BinaryExpression',
                                                                                                            operator: '===',
                                                                                                            left: {
                                                                                                                type: 'MemberExpression',
                                                                                                                computed: false,
                                                                                                                object: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'inputElem',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 158,
                                                                                                                            column: 33,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 158,
                                                                                                                            column: 42,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                property: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'value',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 158,
                                                                                                                            column: 43,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 158,
                                                                                                                            column: 48,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/forms/Field.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 158,
                                                                                                                        column: 33,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 158,
                                                                                                                        column: 48,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/forms/Field.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            right: {
                                                                                                                type: 'Literal',
                                                                                                                value: '100'
                                                                                                            }
                                                                                                        },
                                                                                                        kind: 'init',
                                                                                                        order: '0'
                                                                                                    },
                                                                                                    {
                                                                                                        type: 'ExpressionStatement',
                                                                                                        expression: {
                                                                                                            type: 'Function',
                                                                                                            context: true,
                                                                                                            value: function (_context22) {
                                                                                                                return function change(e) {
                                                                                                                    var inputElem = _context22.get('inputElem');
                                                                                                                    inputElem.value = this.checked ? '100' : '0';
                                                                                                                    inputElem.dispatchEvent(new CustomEvent('change'));
                                                                                                                };
                                                                                                            }
                                                                                                        },
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 159,
                                                                                                                column: 24,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 164,
                                                                                                                column: 28,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/forms/Field.ion'
                                                                                                            }
                                                                                                        },
                                                                                                        order: '1'
                                                                                                    }
                                                                                                ]
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 157,
                                                                                                    column: 20,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 164,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/forms/Field.ion'
                                                                                                }
                                                                                            },
                                                                                            order: '0'
                                                                                        }]
                                                                                },
                                                                                alternate: null,
                                                                                order: ':'
                                                                            }
                                                                        ]
                                                                    },
                                                                    order: '1'
                                                                }
                                                            ]
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    },
                    order: '4'
                }
            ],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'FieldInternal',
                loc: {
                    start: {
                        line: 17,
                        column: 4,
                        fixed: true,
                        source: 'glass/html/forms/Field.ion'
                    },
                    end: {
                        line: 17,
                        column: 17,
                        fixed: true,
                        source: 'glass/html/forms/Field.ion'
                    }
                }
            }
        }, {
            this: this,
            args: args,
            _ref: _ref,
            _ref2: _ref2,
            _ref3: _ref3,
            _ref4: _ref4,
            _ref5: _ref5,
            inputTypeMap: inputTypeMap,
            FieldInternal: FieldInternal,
            DateInput: DateInput,
            DurationInput: DurationInput,
            ImageUrlInput: ImageUrlInput,
            MultiRelationInput: MultiRelationInput,
            RelationInput: RelationInput,
            Select: Select,
            Schema: Schema,
            Timezone: Timezone,
            moment: moment,
            convert: convert
        }, null);
    });
var DateInput = _ref.DateInput;
var DurationInput = _ref.DurationInput;
var ImageUrlInput = _ref.ImageUrlInput;
_ref2 = require('../material');
var MultiRelationInput = _ref2.MultiRelationInput;
var RelationInput = _ref2.RelationInput;
var Select = _ref2.Select;
_ref3 = require('../../data');
var Schema = _ref3.Schema;
_ref4 = require('../../time');
var Timezone = _ref4.Timezone;
var moment = _ref4.moment;
_ref5 = require('../../');
var convert = _ref5.convert;
module.exports = exports = ion.template(function Field(args) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'Field',
            loc: {
                start: {
                    line: 164,
                    column: 16,
                    fixed: true,
                    source: 'glass/html/forms/Field.ion'
                },
                end: {
                    line: 164,
                    column: 21,
                    fixed: true,
                    source: 'glass/html/forms/Field.ion'
                }
            }
        },
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: '_ref7'
                        },
                        init: {
                            type: 'Identifier',
                            name: 'args',
                            loc: {
                                start: {
                                    line: 165,
                                    column: 52,
                                    fixed: true,
                                    source: 'glass/html/forms/Field.ion'
                                },
                                end: {
                                    line: 165,
                                    column: 56,
                                    fixed: true,
                                    source: 'glass/html/forms/Field.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'property',
                            loc: {
                                start: {
                                    line: 165,
                                    column: 9,
                                    fixed: true,
                                    source: 'glass/html/forms/Field.ion'
                                },
                                end: {
                                    line: 165,
                                    column: 17,
                                    fixed: true,
                                    source: 'glass/html/forms/Field.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref7'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'property',
                                loc: {
                                    start: {
                                        line: 165,
                                        column: 9,
                                        fixed: true,
                                        source: 'glass/html/forms/Field.ion'
                                    },
                                    end: {
                                        line: 165,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/html/forms/Field.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'object',
                            loc: {
                                start: {
                                    line: 165,
                                    column: 18,
                                    fixed: true,
                                    source: 'glass/html/forms/Field.ion'
                                },
                                end: {
                                    line: 165,
                                    column: 24,
                                    fixed: true,
                                    source: 'glass/html/forms/Field.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref7'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'object',
                                loc: {
                                    start: {
                                        line: 165,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/forms/Field.ion'
                                    },
                                    end: {
                                        line: 165,
                                        column: 24,
                                        fixed: true,
                                        source: 'glass/html/forms/Field.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'bind',
                            loc: {
                                start: {
                                    line: 165,
                                    column: 25,
                                    fixed: true,
                                    source: 'glass/html/forms/Field.ion'
                                },
                                end: {
                                    line: 165,
                                    column: 29,
                                    fixed: true,
                                    source: 'glass/html/forms/Field.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref7'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'bind',
                                loc: {
                                    start: {
                                        line: 165,
                                        column: 25,
                                        fixed: true,
                                        source: 'glass/html/forms/Field.ion'
                                    },
                                    end: {
                                        line: 165,
                                        column: 29,
                                        fixed: true,
                                        source: 'glass/html/forms/Field.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '3'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'initialValue',
                            loc: {
                                start: {
                                    line: 165,
                                    column: 36,
                                    fixed: true,
                                    source: 'glass/html/forms/Field.ion'
                                },
                                end: {
                                    line: 165,
                                    column: 48,
                                    fixed: true,
                                    source: 'glass/html/forms/Field.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref7'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'value',
                                loc: {
                                    start: {
                                        line: 165,
                                        column: 30,
                                        fixed: true,
                                        source: 'glass/html/forms/Field.ion'
                                    },
                                    end: {
                                        line: 165,
                                        column: 35,
                                        fixed: true,
                                        source: 'glass/html/forms/Field.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '4'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'label',
                            loc: {
                                start: {
                                    line: 166,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/forms/Field.ion'
                                },
                                end: {
                                    line: 166,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/html/forms/Field.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Function',
                                context: true,
                                value: function (_context23) {
                                    return function (args) {
                                        var Schema = _context23.get('Schema');
                                        if (typeof args.label === 'string') {
                                            return args.label;
                                        }
                                        if (args.label === false) {
                                            return void 0;
                                        }
                                        return Schema.getDisplayName(args.property);
                                    };
                                }
                            },
                            arguments: [{
                                    type: 'Identifier',
                                    name: 'args',
                                    loc: {
                                        start: {
                                            line: 166,
                                            column: 20,
                                            fixed: true,
                                            source: 'glass/html/forms/Field.ion'
                                        },
                                        end: {
                                            line: 166,
                                            column: 24,
                                            fixed: true,
                                            source: 'glass/html/forms/Field.ion'
                                        }
                                    }
                                }],
                            loc: {
                                start: {
                                    line: 166,
                                    column: 16,
                                    fixed: true,
                                    source: 'glass/html/forms/Field.ion'
                                },
                                end: {
                                    line: 172,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/forms/Field.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '5'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'objectValue',
                            loc: {
                                start: {
                                    line: 172,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/forms/Field.ion'
                                },
                                end: {
                                    line: 172,
                                    column: 19,
                                    fixed: true,
                                    source: 'glass/html/forms/Field.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Function',
                                context: true,
                                value: function (_context24) {
                                    return function (object) {
                                        var Schema = _context24.get('Schema'), property = _context24.get('property');
                                        if (object != null) {
                                            return Schema.get(object, property);
                                        }
                                    };
                                }
                            },
                            arguments: [{
                                    type: 'Identifier',
                                    name: 'object',
                                    loc: {
                                        start: {
                                            line: 172,
                                            column: 26,
                                            fixed: true,
                                            source: 'glass/html/forms/Field.ion'
                                        },
                                        end: {
                                            line: 172,
                                            column: 32,
                                            fixed: true,
                                            source: 'glass/html/forms/Field.ion'
                                        }
                                    }
                                }],
                            loc: {
                                start: {
                                    line: 172,
                                    column: 22,
                                    fixed: true,
                                    source: 'glass/html/forms/Field.ion'
                                },
                                end: {
                                    line: 176,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/forms/Field.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '6'
            },
            {
                type: 'IfStatement',
                test: {
                    type: 'BinaryExpression',
                    operator: '===',
                    left: {
                        type: 'MemberExpression',
                        computed: false,
                        object: {
                            type: 'Identifier',
                            name: 'property',
                            loc: {
                                start: {
                                    line: 176,
                                    column: 7,
                                    fixed: true,
                                    source: 'glass/html/forms/Field.ion'
                                },
                                end: {
                                    line: 176,
                                    column: 15,
                                    fixed: true,
                                    source: 'glass/html/forms/Field.ion'
                                }
                            }
                        },
                        property: {
                            type: 'Identifier',
                            name: 'editable',
                            loc: {
                                start: {
                                    line: 176,
                                    column: 17,
                                    fixed: true,
                                    source: 'glass/html/forms/Field.ion'
                                },
                                end: {
                                    line: 176,
                                    column: 25,
                                    fixed: true,
                                    source: 'glass/html/forms/Field.ion'
                                }
                            }
                        },
                        existential: true,
                        loc: {
                            start: {
                                line: 176,
                                column: 7,
                                fixed: true,
                                source: 'glass/html/forms/Field.ion'
                            },
                            end: {
                                line: 176,
                                column: 25,
                                fixed: true,
                                source: 'glass/html/forms/Field.ion'
                            }
                        }
                    },
                    right: {
                        type: 'Literal',
                        value: false
                    }
                },
                consequent: {
                    type: 'BlockStatement',
                    body: [{
                            type: 'ReturnStatement',
                            argument: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'Identifier',
                                        name: 'PaperInput',
                                        loc: {
                                            start: {
                                                line: 177,
                                                column: 15,
                                                fixed: true,
                                                source: 'glass/html/forms/Field.ion'
                                            },
                                            end: {
                                                line: 177,
                                                column: 25,
                                                fixed: true,
                                                source: 'glass/html/forms/Field.ion'
                                            }
                                        }
                                    },
                                    arguments: [],
                                    loc: {
                                        start: {
                                            line: 177,
                                            column: 15,
                                            fixed: true,
                                            source: 'glass/html/forms/Field.ion'
                                        },
                                        end: {
                                            line: 177,
                                            column: 27,
                                            fixed: true,
                                            source: 'glass/html/forms/Field.ion'
                                        }
                                    }
                                },
                                properties: [
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'name',
                                            loc: {
                                                start: {
                                                    line: 178,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                },
                                                end: {
                                                    line: 178,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'property',
                                                loc: {
                                                    start: {
                                                        line: 178,
                                                        column: 18,
                                                        fixed: true,
                                                        source: 'glass/html/forms/Field.ion'
                                                    },
                                                    end: {
                                                        line: 178,
                                                        column: 26,
                                                        fixed: true,
                                                        source: 'glass/html/forms/Field.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'name',
                                                loc: {
                                                    start: {
                                                        line: 178,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'glass/html/forms/Field.ion'
                                                    },
                                                    end: {
                                                        line: 178,
                                                        column: 31,
                                                        fixed: true,
                                                        source: 'glass/html/forms/Field.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 178,
                                                    column: 18,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                },
                                                end: {
                                                    line: 178,
                                                    column: 31,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                }
                                            }
                                        },
                                        kind: 'init',
                                        order: '0'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'property',
                                            loc: {
                                                start: {
                                                    line: 179,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                },
                                                end: {
                                                    line: 179,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Identifier',
                                            name: 'property',
                                            loc: {
                                                start: {
                                                    line: 179,
                                                    column: 22,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                },
                                                end: {
                                                    line: 179,
                                                    column: 30,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                }
                                            }
                                        },
                                        kind: 'init',
                                        order: '1'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'valid',
                                            loc: {
                                                start: {
                                                    line: 180,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                },
                                                end: {
                                                    line: 180,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: true
                                        },
                                        kind: 'init',
                                        order: '2'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'valueJSON',
                                            loc: {
                                                start: {
                                                    line: 181,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                },
                                                end: {
                                                    line: 181,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Identifier',
                                            name: 'objectValue',
                                            loc: {
                                                start: {
                                                    line: 181,
                                                    column: 23,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                },
                                                end: {
                                                    line: 181,
                                                    column: 34,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                }
                                            }
                                        },
                                        kind: 'init',
                                        order: '3'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'label',
                                            loc: {
                                                start: {
                                                    line: 182,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                },
                                                end: {
                                                    line: 182,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Identifier',
                                            name: 'label',
                                            loc: {
                                                start: {
                                                    line: 182,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                },
                                                end: {
                                                    line: 182,
                                                    column: 24,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                }
                                            }
                                        },
                                        kind: 'init',
                                        order: '4'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'readonly',
                                            loc: {
                                                start: {
                                                    line: 183,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                },
                                                end: {
                                                    line: 183,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: true
                                        },
                                        kind: 'init',
                                        order: '5'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'value',
                                            loc: {
                                                start: {
                                                    line: 184,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                },
                                                end: {
                                                    line: 184,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'convert',
                                                    loc: {
                                                        start: {
                                                            line: 184,
                                                            column: 19,
                                                            fixed: true,
                                                            source: 'glass/html/forms/Field.ion'
                                                        },
                                                        end: {
                                                            line: 184,
                                                            column: 26,
                                                            fixed: true,
                                                            source: 'glass/html/forms/Field.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'jsonValueToDisplayValue',
                                                    loc: {
                                                        start: {
                                                            line: 184,
                                                            column: 27,
                                                            fixed: true,
                                                            source: 'glass/html/forms/Field.ion'
                                                        },
                                                        end: {
                                                            line: 184,
                                                            column: 50,
                                                            fixed: true,
                                                            source: 'glass/html/forms/Field.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 184,
                                                        column: 19,
                                                        fixed: true,
                                                        source: 'glass/html/forms/Field.ion'
                                                    },
                                                    end: {
                                                        line: 184,
                                                        column: 50,
                                                        fixed: true,
                                                        source: 'glass/html/forms/Field.ion'
                                                    }
                                                }
                                            },
                                            arguments: [
                                                {
                                                    type: 'Identifier',
                                                    name: 'property',
                                                    loc: {
                                                        start: {
                                                            line: 184,
                                                            column: 51,
                                                            fixed: true,
                                                            source: 'glass/html/forms/Field.ion'
                                                        },
                                                        end: {
                                                            line: 184,
                                                            column: 59,
                                                            fixed: true,
                                                            source: 'glass/html/forms/Field.ion'
                                                        }
                                                    }
                                                },
                                                {
                                                    type: 'Identifier',
                                                    name: 'objectValue',
                                                    loc: {
                                                        start: {
                                                            line: 184,
                                                            column: 61,
                                                            fixed: true,
                                                            source: 'glass/html/forms/Field.ion'
                                                        },
                                                        end: {
                                                            line: 184,
                                                            column: 72,
                                                            fixed: true,
                                                            source: 'glass/html/forms/Field.ion'
                                                        }
                                                    }
                                                }
                                            ],
                                            loc: {
                                                start: {
                                                    line: 184,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                },
                                                end: {
                                                    line: 184,
                                                    column: 73,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                }
                                            }
                                        },
                                        kind: 'init',
                                        order: '6'
                                    }
                                ]
                            },
                            order: '0'
                        }]
                },
                alternate: {
                    type: 'BlockStatement',
                    body: [
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: '_args',
                                        loc: {
                                            start: {
                                                line: 187,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/forms/Field.ion'
                                            },
                                            end: {
                                                line: 187,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/forms/Field.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'Object',
                                                loc: {
                                                    start: {
                                                        line: 187,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'glass/html/forms/Field.ion'
                                                    },
                                                    end: {
                                                        line: 187,
                                                        column: 26,
                                                        fixed: true,
                                                        source: 'glass/html/forms/Field.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'assign',
                                                loc: {
                                                    start: {
                                                        line: 187,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'glass/html/forms/Field.ion'
                                                    },
                                                    end: {
                                                        line: 187,
                                                        column: 33,
                                                        fixed: true,
                                                        source: 'glass/html/forms/Field.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 187,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                },
                                                end: {
                                                    line: 187,
                                                    column: 33,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                }
                                            }
                                        },
                                        arguments: [
                                            {
                                                type: 'ObjectExpression',
                                                properties: []
                                            },
                                            {
                                                type: 'Identifier',
                                                name: 'args',
                                                loc: {
                                                    start: {
                                                        line: 187,
                                                        column: 38,
                                                        fixed: true,
                                                        source: 'glass/html/forms/Field.ion'
                                                    },
                                                    end: {
                                                        line: 187,
                                                        column: 42,
                                                        fixed: true,
                                                        source: 'glass/html/forms/Field.ion'
                                                    }
                                                }
                                            },
                                            {
                                                type: 'ObjectExpression',
                                                properties: [
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'property',
                                                            loc: {
                                                                start: {
                                                                    line: 187,
                                                                    column: 45,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                },
                                                                end: {
                                                                    line: 187,
                                                                    column: 53,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Identifier',
                                                            name: 'property',
                                                            loc: {
                                                                start: {
                                                                    line: 187,
                                                                    column: 45,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                },
                                                                end: {
                                                                    line: 187,
                                                                    column: 53,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                }
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'label',
                                                            loc: {
                                                                start: {
                                                                    line: 187,
                                                                    column: 54,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                },
                                                                end: {
                                                                    line: 187,
                                                                    column: 59,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Identifier',
                                                            name: 'label',
                                                            loc: {
                                                                start: {
                                                                    line: 187,
                                                                    column: 54,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                },
                                                                end: {
                                                                    line: 187,
                                                                    column: 59,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                }
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '1'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'object',
                                                            loc: {
                                                                start: {
                                                                    line: 187,
                                                                    column: 60,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                },
                                                                end: {
                                                                    line: 187,
                                                                    column: 66,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Identifier',
                                                            name: 'object',
                                                            loc: {
                                                                start: {
                                                                    line: 187,
                                                                    column: 60,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                },
                                                                end: {
                                                                    line: 187,
                                                                    column: 66,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                }
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '2'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'value',
                                                            loc: {
                                                                start: {
                                                                    line: 187,
                                                                    column: 67,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                },
                                                                end: {
                                                                    line: 187,
                                                                    column: 72,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'ConditionalExpression',
                                                            test: {
                                                                type: 'BinaryExpression',
                                                                operator: '!=',
                                                                left: {
                                                                    type: 'Identifier',
                                                                    name: 'objectValue',
                                                                    loc: {
                                                                        start: {
                                                                            line: 187,
                                                                            column: 73,
                                                                            fixed: true,
                                                                            source: 'glass/html/forms/Field.ion'
                                                                        },
                                                                        end: {
                                                                            line: 187,
                                                                            column: 84,
                                                                            fixed: true,
                                                                            source: 'glass/html/forms/Field.ion'
                                                                        }
                                                                    }
                                                                },
                                                                right: {
                                                                    type: 'Literal',
                                                                    value: null
                                                                }
                                                            },
                                                            consequent: {
                                                                type: 'Identifier',
                                                                name: 'objectValue',
                                                                loc: {
                                                                    start: {
                                                                        line: 187,
                                                                        column: 73,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/Field.ion'
                                                                    },
                                                                    end: {
                                                                        line: 187,
                                                                        column: 84,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/Field.ion'
                                                                    }
                                                                }
                                                            },
                                                            alternate: {
                                                                type: 'Identifier',
                                                                name: 'initialValue',
                                                                loc: {
                                                                    start: {
                                                                        line: 187,
                                                                        column: 87,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/Field.ion'
                                                                    },
                                                                    end: {
                                                                        line: 187,
                                                                        column: 99,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/Field.ion'
                                                                    }
                                                                }
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '3'
                                                    }
                                                ]
                                            }
                                        ],
                                        loc: {
                                            start: {
                                                line: 187,
                                                column: 20,
                                                fixed: true,
                                                source: 'glass/html/forms/Field.ion'
                                            },
                                            end: {
                                                line: 187,
                                                column: 101,
                                                fixed: true,
                                                source: 'glass/html/forms/Field.ion'
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '0'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'field',
                                        loc: {
                                            start: {
                                                line: 188,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/forms/Field.ion'
                                            },
                                            end: {
                                                line: 188,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/forms/Field.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'Identifier',
                                            name: 'FieldInternal',
                                            loc: {
                                                start: {
                                                    line: 188,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                },
                                                end: {
                                                    line: 188,
                                                    column: 33,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                }
                                            }
                                        },
                                        arguments: [{
                                                type: 'Identifier',
                                                name: '_args',
                                                loc: {
                                                    start: {
                                                        line: 188,
                                                        column: 34,
                                                        fixed: true,
                                                        source: 'glass/html/forms/Field.ion'
                                                    },
                                                    end: {
                                                        line: 188,
                                                        column: 39,
                                                        fixed: true,
                                                        source: 'glass/html/forms/Field.ion'
                                                    }
                                                }
                                            }],
                                        loc: {
                                            start: {
                                                line: 188,
                                                column: 20,
                                                fixed: true,
                                                source: 'glass/html/forms/Field.ion'
                                            },
                                            end: {
                                                line: 188,
                                                column: 40,
                                                fixed: true,
                                                source: 'glass/html/forms/Field.ion'
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '1'
                        },
                        {
                            type: 'ReturnStatement',
                            argument: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'MemberExpression',
                                    object: {
                                        type: 'Identifier',
                                        name: 'Object'
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'defineProperties'
                                    }
                                },
                                arguments: [
                                    {
                                        type: 'ObjectExpression',
                                        objectType: {
                                            type: 'Identifier',
                                            name: 'field',
                                            loc: {
                                                start: {
                                                    line: 191,
                                                    column: 15,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                },
                                                end: {
                                                    line: 191,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'glass/html/forms/Field.ion'
                                                }
                                            }
                                        },
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'name',
                                                    loc: {
                                                        start: {
                                                            line: 193,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/forms/Field.ion'
                                                        },
                                                        end: {
                                                            line: 193,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/forms/Field.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'property',
                                                        loc: {
                                                            start: {
                                                                line: 193,
                                                                column: 18,
                                                                fixed: true,
                                                                source: 'glass/html/forms/Field.ion'
                                                            },
                                                            end: {
                                                                line: 193,
                                                                column: 26,
                                                                fixed: true,
                                                                source: 'glass/html/forms/Field.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'name',
                                                        loc: {
                                                            start: {
                                                                line: 193,
                                                                column: 27,
                                                                fixed: true,
                                                                source: 'glass/html/forms/Field.ion'
                                                            },
                                                            end: {
                                                                line: 193,
                                                                column: 31,
                                                                fixed: true,
                                                                source: 'glass/html/forms/Field.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 193,
                                                            column: 18,
                                                            fixed: true,
                                                            source: 'glass/html/forms/Field.ion'
                                                        },
                                                        end: {
                                                            line: 193,
                                                            column: 31,
                                                            fixed: true,
                                                            source: 'glass/html/forms/Field.ion'
                                                        }
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'property',
                                                    loc: {
                                                        start: {
                                                            line: 194,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/forms/Field.ion'
                                                        },
                                                        end: {
                                                            line: 194,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'glass/html/forms/Field.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Identifier',
                                                    name: 'property',
                                                    loc: {
                                                        start: {
                                                            line: 194,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'glass/html/forms/Field.ion'
                                                        },
                                                        end: {
                                                            line: 194,
                                                            column: 30,
                                                            fixed: true,
                                                            source: 'glass/html/forms/Field.ion'
                                                        }
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            },
                                            {
                                                type: 'IfStatement',
                                                test: {
                                                    type: 'BinaryExpression',
                                                    operator: '!==',
                                                    left: {
                                                        type: 'Identifier',
                                                        name: 'objectValue',
                                                        loc: {
                                                            start: {
                                                                line: 199,
                                                                column: 15,
                                                                fixed: true,
                                                                source: 'glass/html/forms/Field.ion'
                                                            },
                                                            end: {
                                                                line: 199,
                                                                column: 26,
                                                                fixed: true,
                                                                source: 'glass/html/forms/Field.ion'
                                                            }
                                                        }
                                                    },
                                                    right: {
                                                        type: 'UnaryExpression',
                                                        operator: 'void',
                                                        prefix: true,
                                                        argument: {
                                                            type: 'Literal',
                                                            value: 0
                                                        }
                                                    }
                                                },
                                                consequent: {
                                                    type: 'BlockStatement',
                                                    body: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'valueJSON',
                                                                loc: {
                                                                    start: {
                                                                        line: 200,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/Field.ion'
                                                                    },
                                                                    end: {
                                                                        line: 200,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/Field.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Identifier',
                                                                name: 'objectValue',
                                                                loc: {
                                                                    start: {
                                                                        line: 200,
                                                                        column: 27,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/Field.ion'
                                                                    },
                                                                    end: {
                                                                        line: 200,
                                                                        column: 38,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/Field.ion'
                                                                    }
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                },
                                                alternate: null,
                                                order: '2'
                                            },
                                            {
                                                type: 'IfStatement',
                                                test: {
                                                    type: 'BinaryExpression',
                                                    operator: '!==',
                                                    left: {
                                                        type: 'Identifier',
                                                        name: 'initialValue',
                                                        loc: {
                                                            start: {
                                                                line: 202,
                                                                column: 15,
                                                                fixed: true,
                                                                source: 'glass/html/forms/Field.ion'
                                                            },
                                                            end: {
                                                                line: 202,
                                                                column: 27,
                                                                fixed: true,
                                                                source: 'glass/html/forms/Field.ion'
                                                            }
                                                        }
                                                    },
                                                    right: {
                                                        type: 'UnaryExpression',
                                                        operator: 'void',
                                                        prefix: true,
                                                        argument: {
                                                            type: 'Literal',
                                                            value: 0
                                                        }
                                                    }
                                                },
                                                consequent: {
                                                    type: 'BlockStatement',
                                                    body: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'valueJSON',
                                                                loc: {
                                                                    start: {
                                                                        line: 203,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/Field.ion'
                                                                    },
                                                                    end: {
                                                                        line: 203,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/Field.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Identifier',
                                                                name: 'initialValue',
                                                                loc: {
                                                                    start: {
                                                                        line: 203,
                                                                        column: 27,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/Field.ion'
                                                                    },
                                                                    end: {
                                                                        line: 203,
                                                                        column: 39,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/Field.ion'
                                                                    }
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                },
                                                alternate: null,
                                                order: '3'
                                            },
                                            {
                                                type: 'IfStatement',
                                                test: {
                                                    type: 'Identifier',
                                                    name: 'label',
                                                    loc: {
                                                        start: {
                                                            line: 205,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/forms/Field.ion'
                                                        },
                                                        end: {
                                                            line: 205,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'glass/html/forms/Field.ion'
                                                        }
                                                    }
                                                },
                                                consequent: {
                                                    type: 'BlockStatement',
                                                    body: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'label',
                                                                loc: {
                                                                    start: {
                                                                        line: 206,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/Field.ion'
                                                                    },
                                                                    end: {
                                                                        line: 206,
                                                                        column: 21,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/Field.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Identifier',
                                                                name: 'label',
                                                                loc: {
                                                                    start: {
                                                                        line: 206,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/Field.ion'
                                                                    },
                                                                    end: {
                                                                        line: 206,
                                                                        column: 28,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/Field.ion'
                                                                    }
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                },
                                                alternate: null,
                                                order: '4'
                                            },
                                            {
                                                type: 'IfStatement',
                                                test: {
                                                    type: 'BinaryExpression',
                                                    operator: '&&',
                                                    left: {
                                                        type: 'Identifier',
                                                        name: 'bind',
                                                        loc: {
                                                            start: {
                                                                line: 207,
                                                                column: 15,
                                                                fixed: true,
                                                                source: 'glass/html/forms/Field.ion'
                                                            },
                                                            end: {
                                                                line: 207,
                                                                column: 19,
                                                                fixed: true,
                                                                source: 'glass/html/forms/Field.ion'
                                                            }
                                                        }
                                                    },
                                                    right: {
                                                        type: 'UnaryExpression',
                                                        operator: '?',
                                                        argument: {
                                                            type: 'Identifier',
                                                            name: 'object',
                                                            loc: {
                                                                start: {
                                                                    line: 207,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                },
                                                                end: {
                                                                    line: 207,
                                                                    column: 30,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                }
                                                            }
                                                        }
                                                    }
                                                },
                                                consequent: {
                                                    type: 'BlockStatement',
                                                    body: [{
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'Function',
                                                                context: true,
                                                                value: function (_context25) {
                                                                    return function change(e) {
                                                                        var Schema = _context25.get('Schema'), object = _context25.get('object'), property = _context25.get('property');
                                                                        global.model.ops.begin();
                                                                        Schema.set(object, property, this.valueJSON);
                                                                    };
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 208,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                },
                                                                end: {
                                                                    line: 212,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/Field.ion'
                                                                }
                                                            },
                                                            order: '0'
                                                        }]
                                                },
                                                alternate: null,
                                                order: '5'
                                            }
                                        ]
                                    },
                                    {
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'valid',
                                                    loc: {
                                                        start: {
                                                            line: 195,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'glass/html/forms/Field.ion'
                                                        },
                                                        end: {
                                                            line: 195,
                                                            column: 26,
                                                            fixed: true,
                                                            source: 'glass/html/forms/Field.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'ObjectExpression',
                                                    properties: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'get',
                                                                loc: {
                                                                    start: {
                                                                        line: 196,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/Field.ion'
                                                                    },
                                                                    end: {
                                                                        line: 196,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/Field.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Function',
                                                                context: true,
                                                                value: function (_context26) {
                                                                    return function () {
                                                                        var Schema = _context26.get('Schema'), property = _context26.get('property');
                                                                        return Schema.validate(this.valueJSON, property).length === 0;
                                                                    };
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                },
                                                kind: 'init',
                                                define: false,
                                                order: '0'
                                            }]
                                    }
                                ]
                            },
                            order: '2'
                        }
                    ]
                },
                order: '7'
            }
        ],
        bound: false
    }, {
        this: this,
        args: args,
        _ref: _ref,
        _ref2: _ref2,
        _ref3: _ref3,
        _ref4: _ref4,
        _ref5: _ref5,
        inputTypeMap: inputTypeMap,
        FieldInternal: FieldInternal,
        DateInput: DateInput,
        DurationInput: DurationInput,
        ImageUrlInput: ImageUrlInput,
        MultiRelationInput: MultiRelationInput,
        RelationInput: RelationInput,
        Select: Select,
        Schema: Schema,
        Timezone: Timezone,
        moment: moment,
        convert: convert
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/forms/Field',_glass_html_forms_Field_);
    else
      _glass_html_forms_Field_.call(this, module, exports, require);
  }
  else {
    _glass_html_forms_Field_.call(this);
  }
}).call(this)
void (function(){var _glass_html_forms_GlassForm_ = function(module,exports,require){'use strict';
var ion = require('ion');
var style = require('../style'), _ref;
_ref = require('../../data');
var Schema = _ref.Schema;
var _ref6 = style.sheets;
_ref6[module.id] = 'Form {\n    max-width: 100%;\n    padding: 8px 12px;\n    overflow: auto;\n}\nForm Footer {\n    padding-top: 24px;\n    padding-bottom: 8px;\n    margin-right: -4px;\n    margin-left: -4px;\n    display: flex;\n    flex-direction: row;\n}';
_ref6;
var getNamedElementsRecursive = function (field) {
    var result = [];
    var addNamedElements = function (nodeList) {
        for (var _i = 0; _i < nodeList.length; _i++) {
            var node = nodeList[_i];
            if ((node.name != null ? node.name.length : void 0) > 0) {
                result.push(node);
            } else {
                addNamedElements(node.childNodes);
            }
        }
    };
    addNamedElements(field.childNodes);
    return result;
};
var getValuesFromFields = function (fields) {
    var result = {};
    for (var _i2 = 0; _i2 < fields.length; _i2++) {
        var field = fields[_i2];
        var value = field.valueJSON;
        result[field.name] = value;
    }
    return result;
};
var setValuesFromFields = function (fields, object) {
    for (var _i3 = 0; _i3 < fields.length; _i3++) {
        var field = fields[_i3];
        var _ref2 = field;
        var name = _ref2.name;
        var value = field.valueJSON;
        var property = (field.property != null ? field.property : object.constructor.properties != null ? object.constructor.properties[name] : void 0) != null ? field.property != null ? field.property : object.constructor.properties[name] : { name: name };
        Schema.set(object, property, value);
    }
};
var setFieldsFromObject = function (fields, object) {
    for (var _i4 = 0; _i4 < fields.length; _i4++) {
        var field = fields[_i4];
        var _ref3 = field;
        var name = _ref3.name;
        var property = (field.property != null ? field.property : object.constructor.properties != null ? object.constructor.properties[name] : void 0) != null ? field.property != null ? field.property : object.constructor.properties[name] : { name: name };
        var value = Schema.get(object, property);
        field.setValue(value);
    }
};
module.exports = exports = ion.template(function GlassForm(attributes) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'GlassForm',
            loc: {
                start: {
                    line: 53,
                    column: 16,
                    fixed: true,
                    source: 'glass/html/forms/GlassForm.ion'
                },
                end: {
                    line: 53,
                    column: 25,
                    fixed: true,
                    source: 'glass/html/forms/GlassForm.ion'
                }
            }
        },
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'form',
                            loc: {
                                start: {
                                    line: 54,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/forms/GlassForm.ion'
                                },
                                end: {
                                    line: 54,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/forms/GlassForm.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Form',
                                loc: {
                                    start: {
                                        line: 54,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/forms/GlassForm.ion'
                                    },
                                    end: {
                                        line: 54,
                                        column: 19,
                                        fixed: true,
                                        source: 'glass/html/forms/GlassForm.ion'
                                    }
                                }
                            },
                            arguments: [
                                {
                                    type: 'ObjectExpression',
                                    properties: [{
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'is',
                                                loc: {
                                                    start: {
                                                        line: 54,
                                                        column: 21,
                                                        fixed: true,
                                                        source: 'glass/html/forms/GlassForm.ion'
                                                    },
                                                    end: {
                                                        line: 54,
                                                        column: 23,
                                                        fixed: true,
                                                        source: 'glass/html/forms/GlassForm.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: 'iron-form'
                                            },
                                            kind: 'init',
                                            order: '0'
                                        }]
                                },
                                {
                                    type: 'Identifier',
                                    name: 'attributes',
                                    loc: {
                                        start: {
                                            line: 54,
                                            column: 38,
                                            fixed: true,
                                            source: 'glass/html/forms/GlassForm.ion'
                                        },
                                        end: {
                                            line: 54,
                                            column: 48,
                                            fixed: true,
                                            source: 'glass/html/forms/GlassForm.ion'
                                        }
                                    }
                                }
                            ],
                            loc: {
                                start: {
                                    line: 54,
                                    column: 15,
                                    fixed: true,
                                    source: 'glass/html/forms/GlassForm.ion'
                                },
                                end: {
                                    line: 54,
                                    column: 49,
                                    fixed: true,
                                    source: 'glass/html/forms/GlassForm.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'baseSubmit',
                            loc: {
                                start: {
                                    line: 55,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/forms/GlassForm.ion'
                                },
                                end: {
                                    line: 55,
                                    column: 18,
                                    fixed: true,
                                    source: 'glass/html/forms/GlassForm.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Function',
                                context: true,
                                value: function (_context) {
                                    return function () {
                                        var form = _context.get('form');
                                        return form.submit;
                                    };
                                }
                            },
                            arguments: [],
                            loc: {
                                start: {
                                    line: 55,
                                    column: 21,
                                    fixed: true,
                                    source: 'glass/html/forms/GlassForm.ion'
                                },
                                end: {
                                    line: 55,
                                    column: 38,
                                    fixed: true,
                                    source: 'glass/html/forms/GlassForm.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'CallExpression',
                    callee: {
                        type: 'MemberExpression',
                        object: {
                            type: 'Identifier',
                            name: 'Object'
                        },
                        property: {
                            type: 'Identifier',
                            name: 'defineProperties'
                        }
                    },
                    arguments: [
                        {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'Identifier',
                                name: 'form',
                                loc: {
                                    start: {
                                        line: 56,
                                        column: 11,
                                        fixed: true,
                                        source: 'glass/html/forms/GlassForm.ion'
                                    },
                                    end: {
                                        line: 56,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/forms/GlassForm.ion'
                                    }
                                }
                            },
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'focus',
                                        loc: {
                                            start: {
                                                line: 63,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/forms/GlassForm.ion'
                                            },
                                            end: {
                                                line: 63,
                                                column: 13,
                                                fixed: true,
                                                source: 'glass/html/forms/GlassForm.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: false,
                                        value: function () {
                                            {
                                                var _ref4 = this.fields;
                                                for (var name in _ref4) {
                                                    var field = _ref4[name];
                                                    if (field.focus != null) {
                                                        field.focus();
                                                        return;
                                                    }
                                                }
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'select',
                                        loc: {
                                            start: {
                                                line: 68,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/forms/GlassForm.ion'
                                            },
                                            end: {
                                                line: 68,
                                                column: 14,
                                                fixed: true,
                                                source: 'glass/html/forms/GlassForm.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: false,
                                        value: function () {
                                            {
                                                var _ref5 = this.fields;
                                                for (var name in _ref5) {
                                                    var field = _ref5[name];
                                                    if (field.select != null) {
                                                        field.select();
                                                        return;
                                                    }
                                                }
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '1'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'submit',
                                        loc: {
                                            start: {
                                                line: 73,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/forms/GlassForm.ion'
                                            },
                                            end: {
                                                line: 73,
                                                column: 14,
                                                fixed: true,
                                                source: 'glass/html/forms/GlassForm.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context2) {
                                            return function (e) {
                                                var baseSubmit = _context2.get('baseSubmit');
                                                this.detail = (e.detail != null ? e.detail.srcEvent : void 0) != null ? e.detail : { srcEvent: e };
                                                baseSubmit.call(this);
                                            };
                                        }
                                    },
                                    kind: 'init',
                                    order: '2'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'MemberExpression',
                                            object: {
                                                type: 'Identifier',
                                                name: 'Object'
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'assign'
                                            }
                                        },
                                        arguments: [
                                            {
                                                type: 'Function',
                                                context: false,
                                                value: function (e) {
                                                    this.dispatchEvent(new CustomEvent('complete', { detail: this.detail }));
                                                    e.preventDefault();
                                                }
                                            },
                                            {
                                                type: 'ObjectExpression',
                                                properties: [{
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'id'
                                                        },
                                                        value: {
                                                            type: 'Literal',
                                                            value: 'iron-form-presubmit'
                                                        },
                                                        order: '0'
                                                    }]
                                            }
                                        ]
                                    },
                                    loc: {
                                        start: {
                                            line: 76,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/forms/GlassForm.ion'
                                        },
                                        end: {
                                            line: 80,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/forms/GlassForm.ion'
                                        }
                                    },
                                    order: '3'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'setFieldsFromObjectProperties',
                                        loc: {
                                            start: {
                                                line: 84,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/forms/GlassForm.ion'
                                            },
                                            end: {
                                                line: 84,
                                                column: 37,
                                                fixed: true,
                                                source: 'glass/html/forms/GlassForm.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context3) {
                                            return function (object) {
                                                var setFieldsFromObject = _context3.get('setFieldsFromObject');
                                                setFieldsFromObject(this.fields, object);
                                            };
                                        }
                                    },
                                    kind: 'init',
                                    order: '4'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'setObjectPropertiesFromFields',
                                        loc: {
                                            start: {
                                                line: 86,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/forms/GlassForm.ion'
                                            },
                                            end: {
                                                line: 86,
                                                column: 37,
                                                fixed: true,
                                                source: 'glass/html/forms/GlassForm.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context4) {
                                            return function (object) {
                                                var setValuesFromFields = _context4.get('setValuesFromFields');
                                                setValuesFromFields(this.fields, object);
                                            };
                                        }
                                    },
                                    kind: 'init',
                                    order: '5'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'Function',
                                        context: false,
                                        value: function keydown(e) {
                                            if (e.keyCode === 13) {
                                                this.submit(e);
                                                e.stopPropagation();
                                                e.preventDefault();
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 88,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/forms/GlassForm.ion'
                                        },
                                        end: {
                                            line: 94,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/forms/GlassForm.ion'
                                        }
                                    },
                                    order: '6'
                                }
                            ]
                        },
                        {
                            type: 'ObjectExpression',
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'fields',
                                        loc: {
                                            start: {
                                                line: 80,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/forms/GlassForm.ion'
                                            },
                                            end: {
                                                line: 80,
                                                column: 23,
                                                fixed: true,
                                                source: 'glass/html/forms/GlassForm.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 81,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/forms/GlassForm.ion'
                                                        },
                                                        end: {
                                                            line: 81,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/forms/GlassForm.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context5) {
                                                        return function () {
                                                            var getNamedElementsRecursive = _context5.get('getNamedElementsRecursive');
                                                            return getNamedElementsRecursive(this);
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'values',
                                        loc: {
                                            start: {
                                                line: 82,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/forms/GlassForm.ion'
                                            },
                                            end: {
                                                line: 82,
                                                column: 23,
                                                fixed: true,
                                                source: 'glass/html/forms/GlassForm.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 83,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/forms/GlassForm.ion'
                                                        },
                                                        end: {
                                                            line: 83,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/forms/GlassForm.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context6) {
                                                        return function () {
                                                            var getValuesFromFields = _context6.get('getValuesFromFields');
                                                            return getValuesFromFields(this.fields);
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '1'
                                }
                            ]
                        }
                    ]
                },
                order: '2'
            }
        ],
        bound: false
    }, {
        this: this,
        attributes: attributes,
        style: style,
        _ref: _ref,
        Schema: Schema,
        _ref6: _ref6,
        getNamedElementsRecursive: getNamedElementsRecursive,
        getValuesFromFields: getValuesFromFields,
        setValuesFromFields: setValuesFromFields,
        setFieldsFromObject: setFieldsFromObject
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/forms/GlassForm',_glass_html_forms_GlassForm_);
    else
      _glass_html_forms_GlassForm_.call(this, module, exports, require);
  }
  else {
    _glass_html_forms_GlassForm_.call(this);
  }
}).call(this)
void (function(){var _glass_html_forms_GlassPrompt_ = function(module,exports,require){'use strict';
var ion = require('ion');
var glass = require('../../'), _ref, _ref2;
_ref = glass.html.material;
var Dialog = _ref.Dialog;
_ref2 = glass.html.forms;
var GlassForm = _ref2.GlassForm;
var CancelButton = _ref2.CancelButton;
var SubmitButton = _ref2.SubmitButton;
var Field = _ref2.Field;
var prompt = ion.template(function prompt(_ref3) {
        return ion.createRuntime({
            type: 'Template',
            id: {
                type: 'Identifier',
                name: 'prompt',
                loc: {
                    start: {
                        line: 6,
                        column: 15,
                        fixed: true,
                        source: 'glass/html/forms/GlassPrompt.ion'
                    },
                    end: {
                        line: 6,
                        column: 21,
                        fixed: true,
                        source: 'glass/html/forms/GlassPrompt.ion'
                    }
                }
            },
            body: [
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'properties',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 23,
                                        fixed: true,
                                        source: 'glass/html/forms/GlassPrompt.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 33,
                                        fixed: true,
                                        source: 'glass/html/forms/GlassPrompt.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref3'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'properties',
                                    loc: {
                                        start: {
                                            line: 6,
                                            column: 23,
                                            fixed: true,
                                            source: 'glass/html/forms/GlassPrompt.ion'
                                        },
                                        end: {
                                            line: 6,
                                            column: 33,
                                            fixed: true,
                                            source: 'glass/html/forms/GlassPrompt.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '0'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'values',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 35,
                                        fixed: true,
                                        source: 'glass/html/forms/GlassPrompt.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 41,
                                        fixed: true,
                                        source: 'glass/html/forms/GlassPrompt.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref3'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'values',
                                    loc: {
                                        start: {
                                            line: 6,
                                            column: 35,
                                            fixed: true,
                                            source: 'glass/html/forms/GlassPrompt.ion'
                                        },
                                        end: {
                                            line: 6,
                                            column: 41,
                                            fixed: true,
                                            source: 'glass/html/forms/GlassPrompt.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '1'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'title',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 43,
                                        fixed: true,
                                        source: 'glass/html/forms/GlassPrompt.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 48,
                                        fixed: true,
                                        source: 'glass/html/forms/GlassPrompt.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref3'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'title',
                                    loc: {
                                        start: {
                                            line: 6,
                                            column: 43,
                                            fixed: true,
                                            source: 'glass/html/forms/GlassPrompt.ion'
                                        },
                                        end: {
                                            line: 6,
                                            column: 48,
                                            fixed: true,
                                            source: 'glass/html/forms/GlassPrompt.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '2'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'callback',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 50,
                                        fixed: true,
                                        source: 'glass/html/forms/GlassPrompt.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 58,
                                        fixed: true,
                                        source: 'glass/html/forms/GlassPrompt.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref3'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'callback',
                                    loc: {
                                        start: {
                                            line: 6,
                                            column: 50,
                                            fixed: true,
                                            source: 'glass/html/forms/GlassPrompt.ion'
                                        },
                                        end: {
                                            line: 6,
                                            column: 58,
                                            fixed: true,
                                            source: 'glass/html/forms/GlassPrompt.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '3'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'submitText',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 60,
                                        fixed: true,
                                        source: 'glass/html/forms/GlassPrompt.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 70,
                                        fixed: true,
                                        source: 'glass/html/forms/GlassPrompt.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref3'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'submitText',
                                    loc: {
                                        start: {
                                            line: 6,
                                            column: 60,
                                            fixed: true,
                                            source: 'glass/html/forms/GlassPrompt.ion'
                                        },
                                        end: {
                                            line: 6,
                                            column: 70,
                                            fixed: true,
                                            source: 'glass/html/forms/GlassPrompt.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '4'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'cancelText',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 72,
                                        fixed: true,
                                        source: 'glass/html/forms/GlassPrompt.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 82,
                                        fixed: true,
                                        source: 'glass/html/forms/GlassPrompt.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref3'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'cancelText',
                                    loc: {
                                        start: {
                                            line: 6,
                                            column: 72,
                                            fixed: true,
                                            source: 'glass/html/forms/GlassPrompt.ion'
                                        },
                                        end: {
                                            line: 6,
                                            column: 82,
                                            fixed: true,
                                            source: 'glass/html/forms/GlassPrompt.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '5'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'text',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 84,
                                        fixed: true,
                                        source: 'glass/html/forms/GlassPrompt.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 88,
                                        fixed: true,
                                        source: 'glass/html/forms/GlassPrompt.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref3'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'text',
                                    loc: {
                                        start: {
                                            line: 6,
                                            column: 84,
                                            fixed: true,
                                            source: 'glass/html/forms/GlassPrompt.ion'
                                        },
                                        end: {
                                            line: 6,
                                            column: 88,
                                            fixed: true,
                                            source: 'glass/html/forms/GlassPrompt.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '6'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'style',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 90,
                                        fixed: true,
                                        source: 'glass/html/forms/GlassPrompt.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 95,
                                        fixed: true,
                                        source: 'glass/html/forms/GlassPrompt.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref3'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'style',
                                    loc: {
                                        start: {
                                            line: 6,
                                            column: 90,
                                            fixed: true,
                                            source: 'glass/html/forms/GlassPrompt.ion'
                                        },
                                        end: {
                                            line: 6,
                                            column: 95,
                                            fixed: true,
                                            source: 'glass/html/forms/GlassPrompt.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '7'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'dialog',
                                loc: {
                                    start: {
                                        line: 7,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/forms/GlassPrompt.ion'
                                    },
                                    end: {
                                        line: 7,
                                        column: 14,
                                        fixed: true,
                                        source: 'glass/html/forms/GlassPrompt.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Dialog',
                                    loc: {
                                        start: {
                                            line: 7,
                                            column: 17,
                                            fixed: true,
                                            source: 'glass/html/forms/GlassPrompt.ion'
                                        },
                                        end: {
                                            line: 7,
                                            column: 23,
                                            fixed: true,
                                            source: 'glass/html/forms/GlassPrompt.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'class',
                                                    loc: {
                                                        start: {
                                                            line: 7,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                        },
                                                        end: {
                                                            line: 7,
                                                            column: 30,
                                                            fixed: true,
                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: 'layout vertical'
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    }],
                                loc: {
                                    start: {
                                        line: 7,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/html/forms/GlassPrompt.ion'
                                    },
                                    end: {
                                        line: 7,
                                        column: 50,
                                        fixed: true,
                                        source: 'glass/html/forms/GlassPrompt.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '8'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'form',
                                loc: {
                                    start: {
                                        line: 8,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/forms/GlassPrompt.ion'
                                    },
                                    end: {
                                        line: 8,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/forms/GlassPrompt.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'Identifier',
                                        name: 'GlassForm',
                                        loc: {
                                            start: {
                                                line: 8,
                                                column: 15,
                                                fixed: true,
                                                source: 'glass/html/forms/GlassPrompt.ion'
                                            },
                                            end: {
                                                line: 8,
                                                column: 24,
                                                fixed: true,
                                                source: 'glass/html/forms/GlassPrompt.ion'
                                            }
                                        }
                                    },
                                    arguments: [{
                                            type: 'ObjectExpression',
                                            properties: [{
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'class',
                                                        loc: {
                                                            start: {
                                                                line: 8,
                                                                column: 26,
                                                                fixed: true,
                                                                source: 'glass/html/forms/GlassPrompt.ion'
                                                            },
                                                            end: {
                                                                line: 8,
                                                                column: 31,
                                                                fixed: true,
                                                                source: 'glass/html/forms/GlassPrompt.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 'layout vertical flex'
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                }]
                                        }],
                                    loc: {
                                        start: {
                                            line: 8,
                                            column: 15,
                                            fixed: true,
                                            source: 'glass/html/forms/GlassPrompt.ion'
                                        },
                                        end: {
                                            line: 8,
                                            column: 56,
                                            fixed: true,
                                            source: 'glass/html/forms/GlassPrompt.ion'
                                        }
                                    }
                                },
                                properties: [
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'Function',
                                            context: true,
                                            value: function (_context) {
                                                return function cancel() {
                                                    var dialog = _context.get('dialog');
                                                    dialog.open = false;
                                                };
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 9,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/forms/GlassPrompt.ion'
                                            },
                                            end: {
                                                line: 11,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/forms/GlassPrompt.ion'
                                            }
                                        },
                                        order: '0'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'Function',
                                            context: true,
                                            value: function (_context2) {
                                                return function complete() {
                                                    var callback = _context2.get('callback'), dialog = _context2.get('dialog');
                                                    callback(this.values);
                                                    dialog.open = false;
                                                };
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 11,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/forms/GlassPrompt.ion'
                                            },
                                            end: {
                                                line: 14,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/forms/GlassPrompt.ion'
                                            }
                                        },
                                        order: '1'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'Function',
                                            context: false,
                                            value: function mousedown(e) {
                                                return e.stopPropagation();
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 14,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/forms/GlassPrompt.ion'
                                            },
                                            end: {
                                                line: 14,
                                                column: 43,
                                                fixed: true,
                                                source: 'glass/html/forms/GlassPrompt.ion'
                                            }
                                        },
                                        order: '2'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'Function',
                                            context: false,
                                            value: function keyup(e) {
                                                return e.stopPropagation();
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 15,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/forms/GlassPrompt.ion'
                                            },
                                            end: {
                                                line: 15,
                                                column: 39,
                                                fixed: true,
                                                source: 'glass/html/forms/GlassPrompt.ion'
                                            }
                                        },
                                        order: '3'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'Function',
                                            context: false,
                                            value: function keypress(e) {
                                                return e.stopPropagation();
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 16,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/forms/GlassPrompt.ion'
                                            },
                                            end: {
                                                line: 16,
                                                column: 42,
                                                fixed: true,
                                                source: 'glass/html/forms/GlassPrompt.ion'
                                            }
                                        },
                                        order: '4'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'Function',
                                            context: false,
                                            value: function keydown(e) {
                                                e.stopPropagation();
                                                if (e.keyCode === 27) {
                                                    this.dispatchEvent(new CustomEvent('cancel'));
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 17,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/forms/GlassPrompt.ion'
                                            },
                                            end: {
                                                line: 21,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/forms/GlassPrompt.ion'
                                            }
                                        },
                                        order: '5'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'ObjectExpression',
                                            objectType: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'Div',
                                                    loc: {
                                                        start: {
                                                            line: 21,
                                                            column: 8,
                                                            fixed: true,
                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                        },
                                                        end: {
                                                            line: 21,
                                                            column: 11,
                                                            fixed: true,
                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [],
                                                loc: {
                                                    start: {
                                                        line: 21,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'glass/html/forms/GlassPrompt.ion'
                                                    },
                                                    end: {
                                                        line: 21,
                                                        column: 13,
                                                        fixed: true,
                                                        source: 'glass/html/forms/GlassPrompt.ion'
                                                    }
                                                }
                                            },
                                            properties: [
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'style',
                                                        loc: {
                                                            start: {
                                                                line: 22,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'glass/html/forms/GlassPrompt.ion'
                                                            },
                                                            end: {
                                                                line: 22,
                                                                column: 17,
                                                                fixed: true,
                                                                source: 'glass/html/forms/GlassPrompt.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'ObjectExpression',
                                                        properties: [{
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Literal',
                                                                    value: 'overflow-y'
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: 'auto'
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            }]
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'ForOfStatement',
                                                    left: {
                                                        type: 'VariableDeclaration',
                                                        declarations: [{
                                                                type: 'VariableDeclarator',
                                                                id: {
                                                                    type: 'Identifier',
                                                                    name: 'property',
                                                                    loc: {
                                                                        start: {
                                                                            line: 23,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                                        },
                                                                        end: {
                                                                            line: 23,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                                        }
                                                                    }
                                                                },
                                                                init: null
                                                            }],
                                                        kind: 'let'
                                                    },
                                                    right: {
                                                        type: 'Identifier',
                                                        name: 'properties',
                                                        loc: {
                                                            start: {
                                                                line: 23,
                                                                column: 28,
                                                                fixed: true,
                                                                source: 'glass/html/forms/GlassPrompt.ion'
                                                            },
                                                            end: {
                                                                line: 23,
                                                                column: 38,
                                                                fixed: true,
                                                                source: 'glass/html/forms/GlassPrompt.ion'
                                                            }
                                                        }
                                                    },
                                                    body: {
                                                        type: 'BlockStatement',
                                                        body: [{
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'Identifier',
                                                                        name: 'Field',
                                                                        loc: {
                                                                            start: {
                                                                                line: 24,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'glass/html/forms/GlassPrompt.ion'
                                                                            },
                                                                            end: {
                                                                                line: 24,
                                                                                column: 21,
                                                                                fixed: true,
                                                                                source: 'glass/html/forms/GlassPrompt.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [{
                                                                            type: 'ObjectExpression',
                                                                            objectType: {
                                                                                type: 'ObjectExpression',
                                                                                properties: [{
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'property',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 25,
                                                                                                    column: 21,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/forms/GlassPrompt.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 25,
                                                                                                    column: 29,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/forms/GlassPrompt.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Identifier',
                                                                                            name: 'property',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 25,
                                                                                                    column: 21,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/forms/GlassPrompt.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 25,
                                                                                                    column: 29,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/forms/GlassPrompt.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            properties: [{
                                                                                    type: 'IfStatement',
                                                                                    test: {
                                                                                        type: 'BinaryExpression',
                                                                                        operator: '&&',
                                                                                        left: {
                                                                                            type: 'UnaryExpression',
                                                                                            operator: '?',
                                                                                            argument: {
                                                                                                type: 'Identifier',
                                                                                                name: 'values',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 26,
                                                                                                        column: 27,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/forms/GlassPrompt.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 26,
                                                                                                        column: 33,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/forms/GlassPrompt.ion'
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        right: {
                                                                                            type: 'UnaryExpression',
                                                                                            operator: '?',
                                                                                            argument: {
                                                                                                type: 'MemberExpression',
                                                                                                computed: true,
                                                                                                object: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'values',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 26,
                                                                                                            column: 39,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 26,
                                                                                                            column: 45,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'MemberExpression',
                                                                                                    computed: false,
                                                                                                    object: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'property',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 26,
                                                                                                                column: 46,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/forms/GlassPrompt.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 26,
                                                                                                                column: 54,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/forms/GlassPrompt.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    property: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'name',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 26,
                                                                                                                column: 55,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/forms/GlassPrompt.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 26,
                                                                                                                column: 59,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/forms/GlassPrompt.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 26,
                                                                                                            column: 46,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 26,
                                                                                                            column: 59,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 26,
                                                                                                        column: 39,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/forms/GlassPrompt.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 26,
                                                                                                        column: 60,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/forms/GlassPrompt.ion'
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    consequent: {
                                                                                        type: 'BlockStatement',
                                                                                        body: [{
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'value',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 27,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 27,
                                                                                                            column: 33,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'MemberExpression',
                                                                                                    computed: true,
                                                                                                    object: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'values',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 27,
                                                                                                                column: 35,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/forms/GlassPrompt.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 27,
                                                                                                                column: 41,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/forms/GlassPrompt.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    property: {
                                                                                                        type: 'MemberExpression',
                                                                                                        computed: false,
                                                                                                        object: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'property',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 27,
                                                                                                                    column: 42,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/forms/GlassPrompt.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 27,
                                                                                                                    column: 50,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/forms/GlassPrompt.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        property: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'name',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 27,
                                                                                                                    column: 51,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/forms/GlassPrompt.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 27,
                                                                                                                    column: 55,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/forms/GlassPrompt.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 27,
                                                                                                                column: 42,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/forms/GlassPrompt.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 27,
                                                                                                                column: 55,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/forms/GlassPrompt.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 27,
                                                                                                            column: 35,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 27,
                                                                                                            column: 56,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '0'
                                                                                            }]
                                                                                    },
                                                                                    alternate: null,
                                                                                    order: '0'
                                                                                }]
                                                                        }],
                                                                    loc: {
                                                                        start: {
                                                                            line: 24,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                                        },
                                                                        end: {
                                                                            line: 28,
                                                                            column: 17,
                                                                            fixed: true,
                                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 24,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/GlassPrompt.ion'
                                                                    },
                                                                    end: {
                                                                        line: 28,
                                                                        column: 17,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/GlassPrompt.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    remove: null,
                                                    order: '1'
                                                }
                                            ]
                                        },
                                        loc: {
                                            start: {
                                                line: 21,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/forms/GlassPrompt.ion'
                                            },
                                            end: {
                                                line: 29,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/forms/GlassPrompt.ion'
                                            }
                                        },
                                        order: '6'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'Identifier',
                                                name: 'Div',
                                                loc: {
                                                    start: {
                                                        line: 29,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'glass/html/forms/GlassPrompt.ion'
                                                    },
                                                    end: {
                                                        line: 29,
                                                        column: 11,
                                                        fixed: true,
                                                        source: 'glass/html/forms/GlassPrompt.ion'
                                                    }
                                                }
                                            },
                                            arguments: [{
                                                    type: 'ObjectExpression',
                                                    properties: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'class',
                                                                loc: {
                                                                    start: {
                                                                        line: 29,
                                                                        column: 13,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/GlassPrompt.ion'
                                                                    },
                                                                    end: {
                                                                        line: 29,
                                                                        column: 18,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/GlassPrompt.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Literal',
                                                                value: 'fill'
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                }],
                                            loc: {
                                                start: {
                                                    line: 29,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'glass/html/forms/GlassPrompt.ion'
                                                },
                                                end: {
                                                    line: 29,
                                                    column: 27,
                                                    fixed: true,
                                                    source: 'glass/html/forms/GlassPrompt.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 29,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/forms/GlassPrompt.ion'
                                            },
                                            end: {
                                                line: 29,
                                                column: 27,
                                                fixed: true,
                                                source: 'glass/html/forms/GlassPrompt.ion'
                                            }
                                        },
                                        order: '7'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'ObjectExpression',
                                            objectType: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'Footer',
                                                    loc: {
                                                        start: {
                                                            line: 30,
                                                            column: 8,
                                                            fixed: true,
                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                        },
                                                        end: {
                                                            line: 30,
                                                            column: 14,
                                                            fixed: true,
                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [],
                                                loc: {
                                                    start: {
                                                        line: 30,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'glass/html/forms/GlassPrompt.ion'
                                                    },
                                                    end: {
                                                        line: 30,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'glass/html/forms/GlassPrompt.ion'
                                                    }
                                                }
                                            },
                                            properties: [
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'CancelButton',
                                                                loc: {
                                                                    start: {
                                                                        line: 31,
                                                                        column: 12,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/GlassPrompt.ion'
                                                                    },
                                                                    end: {
                                                                        line: 31,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/GlassPrompt.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [],
                                                            loc: {
                                                                start: {
                                                                    line: 31,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/GlassPrompt.ion'
                                                                },
                                                                end: {
                                                                    line: 31,
                                                                    column: 26,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/GlassPrompt.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'raised',
                                                                    loc: {
                                                                        start: {
                                                                            line: 32,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                                        },
                                                                        end: {
                                                                            line: 32,
                                                                            column: 22,
                                                                            fixed: true,
                                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: false
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'ConditionalExpression',
                                                                    test: {
                                                                        type: 'BinaryExpression',
                                                                        operator: '!=',
                                                                        left: {
                                                                            type: 'Identifier',
                                                                            name: 'cancelText',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 33,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/forms/GlassPrompt.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 33,
                                                                                    column: 26,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/forms/GlassPrompt.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        right: {
                                                                            type: 'Literal',
                                                                            value: null
                                                                        }
                                                                    },
                                                                    consequent: {
                                                                        type: 'Identifier',
                                                                        name: 'cancelText',
                                                                        loc: {
                                                                            start: {
                                                                                line: 33,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'glass/html/forms/GlassPrompt.ion'
                                                                            },
                                                                            end: {
                                                                                line: 33,
                                                                                column: 26,
                                                                                fixed: true,
                                                                                source: 'glass/html/forms/GlassPrompt.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    alternate: {
                                                                        type: 'Literal',
                                                                        value: 'Cancel'
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 33,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/GlassPrompt.ion'
                                                                    },
                                                                    end: {
                                                                        line: 33,
                                                                        column: 37,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/GlassPrompt.ion'
                                                                    }
                                                                },
                                                                order: '1'
                                                            }
                                                        ]
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 31,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                        },
                                                        end: {
                                                            line: 34,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                },
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'SubmitButton',
                                                                loc: {
                                                                    start: {
                                                                        line: 34,
                                                                        column: 12,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/GlassPrompt.ion'
                                                                    },
                                                                    end: {
                                                                        line: 34,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/GlassPrompt.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [],
                                                            loc: {
                                                                start: {
                                                                    line: 34,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/GlassPrompt.ion'
                                                                },
                                                                end: {
                                                                    line: 34,
                                                                    column: 26,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/GlassPrompt.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [{
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'ConditionalExpression',
                                                                    test: {
                                                                        type: 'BinaryExpression',
                                                                        operator: '!=',
                                                                        left: {
                                                                            type: 'Identifier',
                                                                            name: 'submitText',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 35,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/forms/GlassPrompt.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 35,
                                                                                    column: 26,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/forms/GlassPrompt.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        right: {
                                                                            type: 'Literal',
                                                                            value: null
                                                                        }
                                                                    },
                                                                    consequent: {
                                                                        type: 'Identifier',
                                                                        name: 'submitText',
                                                                        loc: {
                                                                            start: {
                                                                                line: 35,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'glass/html/forms/GlassPrompt.ion'
                                                                            },
                                                                            end: {
                                                                                line: 35,
                                                                                column: 26,
                                                                                fixed: true,
                                                                                source: 'glass/html/forms/GlassPrompt.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    alternate: {
                                                                        type: 'Literal',
                                                                        value: 'Submit'
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 35,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/GlassPrompt.ion'
                                                                    },
                                                                    end: {
                                                                        line: 35,
                                                                        column: 37,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/GlassPrompt.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 34,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                        },
                                                        end: {
                                                            line: 36,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                        }
                                                    },
                                                    order: '1'
                                                }
                                            ]
                                        },
                                        loc: {
                                            start: {
                                                line: 30,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/forms/GlassPrompt.ion'
                                            },
                                            end: {
                                                line: 36,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/forms/GlassPrompt.ion'
                                            }
                                        },
                                        order: '8'
                                    }
                                ]
                            }
                        }],
                    kind: 'let',
                    order: '9'
                },
                {
                    type: 'ReturnStatement',
                    argument: {
                        type: 'ObjectExpression',
                        objectType: {
                            type: 'Identifier',
                            name: 'dialog',
                            loc: {
                                start: {
                                    line: 36,
                                    column: 11,
                                    fixed: true,
                                    source: 'glass/html/forms/GlassPrompt.ion'
                                },
                                end: {
                                    line: 36,
                                    column: 17,
                                    fixed: true,
                                    source: 'glass/html/forms/GlassPrompt.ion'
                                }
                            }
                        },
                        properties: [
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'focus',
                                    loc: {
                                        start: {
                                            line: 37,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/forms/GlassPrompt.ion'
                                        },
                                        end: {
                                            line: 37,
                                            column: 13,
                                            fixed: true,
                                            source: 'glass/html/forms/GlassPrompt.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'Function',
                                    context: true,
                                    value: function (_context3) {
                                        return function () {
                                            var form = _context3.get('form');
                                            form.focus();
                                        };
                                    }
                                },
                                kind: 'init',
                                order: '0'
                            },
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'frame',
                                    loc: {
                                        start: {
                                            line: 39,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/forms/GlassPrompt.ion'
                                        },
                                        end: {
                                            line: 39,
                                            column: 13,
                                            fixed: true,
                                            source: 'glass/html/forms/GlassPrompt.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'ObjectExpression',
                                    properties: [
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'style',
                                                loc: {
                                                    start: {
                                                        line: 40,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/forms/GlassPrompt.ion'
                                                    },
                                                    end: {
                                                        line: 40,
                                                        column: 17,
                                                        fixed: true,
                                                        source: 'glass/html/forms/GlassPrompt.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'ObjectExpression',
                                                properties: [
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'width',
                                                            loc: {
                                                                start: {
                                                                    line: 41,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/GlassPrompt.ion'
                                                                },
                                                                end: {
                                                                    line: 41,
                                                                    column: 21,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/GlassPrompt.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Literal',
                                                            value: '400px'
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'IfStatement',
                                                        test: {
                                                            type: 'UnaryExpression',
                                                            operator: '?',
                                                            argument: {
                                                                type: 'Identifier',
                                                                name: 'style',
                                                                loc: {
                                                                    start: {
                                                                        line: 42,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/GlassPrompt.ion'
                                                                    },
                                                                    end: {
                                                                        line: 42,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/GlassPrompt.ion'
                                                                    }
                                                                }
                                                            }
                                                        },
                                                        consequent: {
                                                            type: 'BlockStatement',
                                                            body: [{
                                                                    type: 'ForInStatement',
                                                                    left: {
                                                                        type: 'VariableDeclaration',
                                                                        declarations: [
                                                                            {
                                                                                type: 'VariableDeclarator',
                                                                                id: {
                                                                                    type: 'Identifier',
                                                                                    name: 'key',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 43,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 43,
                                                                                            column: 27,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                init: null
                                                                            },
                                                                            {
                                                                                type: 'VariableDeclarator',
                                                                                id: {
                                                                                    type: 'Identifier',
                                                                                    name: 'value',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 43,
                                                                                            column: 29,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 43,
                                                                                            column: 34,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                init: null
                                                                            }
                                                                        ],
                                                                        kind: 'let'
                                                                    },
                                                                    right: {
                                                                        type: 'Identifier',
                                                                        name: 'style',
                                                                        loc: {
                                                                            start: {
                                                                                line: 43,
                                                                                column: 38,
                                                                                fixed: true,
                                                                                source: 'glass/html/forms/GlassPrompt.ion'
                                                                            },
                                                                            end: {
                                                                                line: 43,
                                                                                column: 43,
                                                                                fixed: true,
                                                                                source: 'glass/html/forms/GlassPrompt.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    body: {
                                                                        type: 'BlockStatement',
                                                                        body: [{
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'key',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 44,
                                                                                            column: 25,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 44,
                                                                                            column: 28,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Identifier',
                                                                                    name: 'value',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 44,
                                                                                            column: 31,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 44,
                                                                                            column: 36,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                kind: 'init',
                                                                                computed: true,
                                                                                order: '0'
                                                                            }]
                                                                    },
                                                                    remove: null,
                                                                    order: '0'
                                                                }]
                                                        },
                                                        alternate: null,
                                                        order: '1'
                                                    }
                                                ]
                                            },
                                            kind: 'init',
                                            order: '0'
                                        },
                                        {
                                            type: 'IfStatement',
                                            test: {
                                                type: 'UnaryExpression',
                                                operator: '?',
                                                argument: {
                                                    type: 'Identifier',
                                                    name: 'title',
                                                    loc: {
                                                        start: {
                                                            line: 45,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                        },
                                                        end: {
                                                            line: 45,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                        }
                                                    }
                                                }
                                            },
                                            consequent: {
                                                type: 'BlockStatement',
                                                body: [{
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'ObjectExpression',
                                                            objectType: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Identifier',
                                                                    name: 'Div',
                                                                    loc: {
                                                                        start: {
                                                                            line: 46,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                                        },
                                                                        end: {
                                                                            line: 46,
                                                                            column: 19,
                                                                            fixed: true,
                                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'ObjectExpression',
                                                                        properties: [{
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'class',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 46,
                                                                                            column: 21,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 46,
                                                                                            column: 26,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Literal',
                                                                                    value: 'title'
                                                                                },
                                                                                kind: 'init',
                                                                                order: '0'
                                                                            }]
                                                                    }],
                                                                loc: {
                                                                    start: {
                                                                        line: 46,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/GlassPrompt.ion'
                                                                    },
                                                                    end: {
                                                                        line: 46,
                                                                        column: 37,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/GlassPrompt.ion'
                                                                    }
                                                                }
                                                            },
                                                            properties: [{
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'Identifier',
                                                                        name: 'title',
                                                                        loc: {
                                                                            start: {
                                                                                line: 47,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/forms/GlassPrompt.ion'
                                                                            },
                                                                            end: {
                                                                                line: 47,
                                                                                column: 25,
                                                                                fixed: true,
                                                                                source: 'glass/html/forms/GlassPrompt.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 47,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                                        },
                                                                        end: {
                                                                            line: 47,
                                                                            column: 25,
                                                                            fixed: true,
                                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                                        }
                                                                    },
                                                                    order: '0'
                                                                }]
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 46,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/forms/GlassPrompt.ion'
                                                            },
                                                            end: {
                                                                line: 48,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'glass/html/forms/GlassPrompt.ion'
                                                            }
                                                        },
                                                        order: '0'
                                                    }]
                                            },
                                            alternate: null,
                                            order: '1'
                                        },
                                        {
                                            type: 'IfStatement',
                                            test: {
                                                type: 'UnaryExpression',
                                                operator: '?',
                                                argument: {
                                                    type: 'Identifier',
                                                    name: 'text',
                                                    loc: {
                                                        start: {
                                                            line: 48,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                        },
                                                        end: {
                                                            line: 48,
                                                            column: 19,
                                                            fixed: true,
                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                        }
                                                    }
                                                }
                                            },
                                            consequent: {
                                                type: 'BlockStatement',
                                                body: [{
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'ObjectExpression',
                                                            objectType: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Identifier',
                                                                    name: 'Div',
                                                                    loc: {
                                                                        start: {
                                                                            line: 49,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                                        },
                                                                        end: {
                                                                            line: 49,
                                                                            column: 19,
                                                                            fixed: true,
                                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'ObjectExpression',
                                                                        properties: [{
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'style',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 49,
                                                                                            column: 21,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 49,
                                                                                            column: 26,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Literal',
                                                                                    value: 'font-size:14px'
                                                                                },
                                                                                kind: 'init',
                                                                                order: '0'
                                                                            }]
                                                                    }],
                                                                loc: {
                                                                    start: {
                                                                        line: 49,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/GlassPrompt.ion'
                                                                    },
                                                                    end: {
                                                                        line: 49,
                                                                        column: 45,
                                                                        fixed: true,
                                                                        source: 'glass/html/forms/GlassPrompt.ion'
                                                                    }
                                                                }
                                                            },
                                                            properties: [{
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'Identifier',
                                                                        name: 'text',
                                                                        loc: {
                                                                            start: {
                                                                                line: 50,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/forms/GlassPrompt.ion'
                                                                            },
                                                                            end: {
                                                                                line: 50,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'glass/html/forms/GlassPrompt.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 50,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                                        },
                                                                        end: {
                                                                            line: 50,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                                        }
                                                                    },
                                                                    order: '0'
                                                                }]
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 49,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/forms/GlassPrompt.ion'
                                                            },
                                                            end: {
                                                                line: 51,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'glass/html/forms/GlassPrompt.ion'
                                                            }
                                                        },
                                                        order: '0'
                                                    }]
                                            },
                                            alternate: null,
                                            order: '2'
                                        },
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'ObjectExpression',
                                                objectType: {
                                                    type: 'Identifier',
                                                    name: 'form',
                                                    loc: {
                                                        start: {
                                                            line: 51,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                        },
                                                        end: {
                                                            line: 51,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/forms/GlassPrompt.ion'
                                                        }
                                                    }
                                                },
                                                properties: [{
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'style',
                                                            loc: {
                                                                start: {
                                                                    line: 52,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/GlassPrompt.ion'
                                                                },
                                                                end: {
                                                                    line: 52,
                                                                    column: 21,
                                                                    fixed: true,
                                                                    source: 'glass/html/forms/GlassPrompt.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'ObjectExpression',
                                                            properties: [{
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'overflow',
                                                                        loc: {
                                                                            start: {
                                                                                line: 53,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/forms/GlassPrompt.ion'
                                                                            },
                                                                            end: {
                                                                                line: 53,
                                                                                column: 28,
                                                                                fixed: true,
                                                                                source: 'glass/html/forms/GlassPrompt.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Literal',
                                                                        value: 'visible'
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                }]
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    }]
                                            },
                                            loc: {
                                                start: {
                                                    line: 51,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/forms/GlassPrompt.ion'
                                                },
                                                end: {
                                                    line: 55,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/html/forms/GlassPrompt.ion'
                                                }
                                            },
                                            order: '3'
                                        }
                                    ]
                                },
                                kind: 'init',
                                order: '1'
                            }
                        ]
                    },
                    order: ':'
                }
            ],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'prompt',
                loc: {
                    start: {
                        line: 6,
                        column: 15,
                        fixed: true,
                        source: 'glass/html/forms/GlassPrompt.ion'
                    },
                    end: {
                        line: 6,
                        column: 21,
                        fixed: true,
                        source: 'glass/html/forms/GlassPrompt.ion'
                    }
                }
            }
        }, {
            this: this,
            _ref3: _ref3,
            glass: glass,
            _ref: _ref,
            _ref2: _ref2,
            Dialog: Dialog,
            GlassForm: GlassForm,
            CancelButton: CancelButton,
            SubmitButton: SubmitButton,
            Field: Field,
            prompt: prompt
        }, null);
    });
module.exports = exports = function (args) {
    Dialog.show(prompt, args);
};
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/forms/GlassPrompt',_glass_html_forms_GlassPrompt_);
    else
      _glass_html_forms_GlassPrompt_.call(this, module, exports, require);
  }
  else {
    _glass_html_forms_GlassPrompt_.call(this);
  }
}).call(this)
void (function(){var _glass_html_forms_ImageUrlInput_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('../');
var style = _ref.style;
var _ref3 = style.sheets;
_ref3[module.id] = '.ImageUrlInput {\n    /*max-width: 200px;*/\n}\n\n.ImagePreview {\n    position: absolute;\n    z-index: 10;\n    background-color: rgb(240,240,240);\n}';
_ref3;
module.exports = exports = ion.template(function (args) {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: '_ref2'
                        },
                        init: {
                            type: 'Identifier',
                            name: 'args',
                            loc: {
                                start: {
                                    line: 17,
                                    column: 40,
                                    fixed: true,
                                    source: 'glass/html/forms/ImageUrlInput.ion'
                                },
                                end: {
                                    line: 17,
                                    column: 44,
                                    fixed: true,
                                    source: 'glass/html/forms/ImageUrlInput.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'property',
                            loc: {
                                start: {
                                    line: 17,
                                    column: 9,
                                    fixed: true,
                                    source: 'glass/html/forms/ImageUrlInput.ion'
                                },
                                end: {
                                    line: 17,
                                    column: 17,
                                    fixed: true,
                                    source: 'glass/html/forms/ImageUrlInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref2'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'property',
                                loc: {
                                    start: {
                                        line: 17,
                                        column: 9,
                                        fixed: true,
                                        source: 'glass/html/forms/ImageUrlInput.ion'
                                    },
                                    end: {
                                        line: 17,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/html/forms/ImageUrlInput.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'initialValue',
                            loc: {
                                start: {
                                    line: 17,
                                    column: 24,
                                    fixed: true,
                                    source: 'glass/html/forms/ImageUrlInput.ion'
                                },
                                end: {
                                    line: 17,
                                    column: 36,
                                    fixed: true,
                                    source: 'glass/html/forms/ImageUrlInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref2'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'value',
                                loc: {
                                    start: {
                                        line: 17,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/forms/ImageUrlInput.ion'
                                    },
                                    end: {
                                        line: 17,
                                        column: 23,
                                        fixed: true,
                                        source: 'glass/html/forms/ImageUrlInput.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'state',
                            loc: {
                                start: {
                                    line: 18,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/forms/ImageUrlInput.ion'
                                },
                                end: {
                                    line: 18,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/html/forms/ImageUrlInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            properties: [{
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'focused',
                                        loc: {
                                            start: {
                                                line: 18,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                            },
                                            end: {
                                                line: 18,
                                                column: 24,
                                                fixed: true,
                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: false
                                    },
                                    kind: 'init',
                                    order: '0'
                                }]
                        }
                    }],
                kind: 'let',
                order: '3'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'inputElement',
                            loc: {
                                start: {
                                    line: 20,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/forms/ImageUrlInput.ion'
                                },
                                end: {
                                    line: 20,
                                    column: 20,
                                    fixed: true,
                                    source: 'glass/html/forms/ImageUrlInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'PaperInput',
                                    loc: {
                                        start: {
                                            line: 20,
                                            column: 23,
                                            fixed: true,
                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                        },
                                        end: {
                                            line: 20,
                                            column: 33,
                                            fixed: true,
                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                        }
                                    }
                                },
                                arguments: [],
                                loc: {
                                    start: {
                                        line: 20,
                                        column: 23,
                                        fixed: true,
                                        source: 'glass/html/forms/ImageUrlInput.ion'
                                    },
                                    end: {
                                        line: 20,
                                        column: 35,
                                        fixed: true,
                                        source: 'glass/html/forms/ImageUrlInput.ion'
                                    }
                                }
                            },
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'type',
                                        loc: {
                                            start: {
                                                line: 21,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                            },
                                            end: {
                                                line: 21,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: 'url'
                                    },
                                    kind: 'init',
                                    order: '0'
                                },
                                {
                                    type: 'IfStatement',
                                    test: {
                                        type: 'UnaryExpression',
                                        operator: '?',
                                        argument: {
                                            type: 'Identifier',
                                            name: 'initialValue',
                                            loc: {
                                                start: {
                                                    line: 22,
                                                    column: 11,
                                                    fixed: true,
                                                    source: 'glass/html/forms/ImageUrlInput.ion'
                                                },
                                                end: {
                                                    line: 22,
                                                    column: 23,
                                                    fixed: true,
                                                    source: 'glass/html/forms/ImageUrlInput.ion'
                                                }
                                            }
                                        }
                                    },
                                    consequent: {
                                        type: 'BlockStatement',
                                        body: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'value',
                                                    loc: {
                                                        start: {
                                                            line: 23,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        },
                                                        end: {
                                                            line: 23,
                                                            column: 17,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Identifier',
                                                    name: 'initialValue',
                                                    loc: {
                                                        start: {
                                                            line: 23,
                                                            column: 19,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        },
                                                        end: {
                                                            line: 23,
                                                            column: 31,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        }
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    },
                                    alternate: null,
                                    order: '1'
                                },
                                {
                                    type: 'IfStatement',
                                    test: {
                                        type: 'UnaryExpression',
                                        operator: '?',
                                        argument: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'property',
                                                loc: {
                                                    start: {
                                                        line: 24,
                                                        column: 11,
                                                        fixed: true,
                                                        source: 'glass/html/forms/ImageUrlInput.ion'
                                                    },
                                                    end: {
                                                        line: 24,
                                                        column: 19,
                                                        fixed: true,
                                                        source: 'glass/html/forms/ImageUrlInput.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'required',
                                                loc: {
                                                    start: {
                                                        line: 24,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'glass/html/forms/ImageUrlInput.ion'
                                                    },
                                                    end: {
                                                        line: 24,
                                                        column: 28,
                                                        fixed: true,
                                                        source: 'glass/html/forms/ImageUrlInput.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 24,
                                                    column: 11,
                                                    fixed: true,
                                                    source: 'glass/html/forms/ImageUrlInput.ion'
                                                },
                                                end: {
                                                    line: 24,
                                                    column: 28,
                                                    fixed: true,
                                                    source: 'glass/html/forms/ImageUrlInput.ion'
                                                }
                                            }
                                        }
                                    },
                                    consequent: {
                                        type: 'BlockStatement',
                                        body: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'required',
                                                    loc: {
                                                        start: {
                                                            line: 25,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        },
                                                        end: {
                                                            line: 25,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'property',
                                                        loc: {
                                                            start: {
                                                                line: 25,
                                                                column: 22,
                                                                fixed: true,
                                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                                            },
                                                            end: {
                                                                line: 25,
                                                                column: 30,
                                                                fixed: true,
                                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'required',
                                                        loc: {
                                                            start: {
                                                                line: 25,
                                                                column: 31,
                                                                fixed: true,
                                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                                            },
                                                            end: {
                                                                line: 25,
                                                                column: 39,
                                                                fixed: true,
                                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 25,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        },
                                                        end: {
                                                            line: 25,
                                                            column: 39,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        }
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    },
                                    alternate: null,
                                    order: '2'
                                },
                                {
                                    type: 'IfStatement',
                                    test: {
                                        type: 'UnaryExpression',
                                        operator: '?',
                                        argument: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'property',
                                                loc: {
                                                    start: {
                                                        line: 26,
                                                        column: 11,
                                                        fixed: true,
                                                        source: 'glass/html/forms/ImageUrlInput.ion'
                                                    },
                                                    end: {
                                                        line: 26,
                                                        column: 19,
                                                        fixed: true,
                                                        source: 'glass/html/forms/ImageUrlInput.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'pattern',
                                                loc: {
                                                    start: {
                                                        line: 26,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'glass/html/forms/ImageUrlInput.ion'
                                                    },
                                                    end: {
                                                        line: 26,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'glass/html/forms/ImageUrlInput.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 26,
                                                    column: 11,
                                                    fixed: true,
                                                    source: 'glass/html/forms/ImageUrlInput.ion'
                                                },
                                                end: {
                                                    line: 26,
                                                    column: 27,
                                                    fixed: true,
                                                    source: 'glass/html/forms/ImageUrlInput.ion'
                                                }
                                            }
                                        }
                                    },
                                    consequent: {
                                        type: 'BlockStatement',
                                        body: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'pattern',
                                                    loc: {
                                                        start: {
                                                            line: 27,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        },
                                                        end: {
                                                            line: 27,
                                                            column: 19,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'property',
                                                        loc: {
                                                            start: {
                                                                line: 27,
                                                                column: 21,
                                                                fixed: true,
                                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                                            },
                                                            end: {
                                                                line: 27,
                                                                column: 29,
                                                                fixed: true,
                                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'pattern',
                                                        loc: {
                                                            start: {
                                                                line: 27,
                                                                column: 30,
                                                                fixed: true,
                                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                                            },
                                                            end: {
                                                                line: 27,
                                                                column: 37,
                                                                fixed: true,
                                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 27,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        },
                                                        end: {
                                                            line: 27,
                                                            column: 37,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        }
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    },
                                    alternate: null,
                                    order: '3'
                                },
                                {
                                    type: 'IfStatement',
                                    test: {
                                        type: 'UnaryExpression',
                                        operator: '?',
                                        argument: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'property',
                                                loc: {
                                                    start: {
                                                        line: 28,
                                                        column: 11,
                                                        fixed: true,
                                                        source: 'glass/html/forms/ImageUrlInput.ion'
                                                    },
                                                    end: {
                                                        line: 28,
                                                        column: 19,
                                                        fixed: true,
                                                        source: 'glass/html/forms/ImageUrlInput.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'minimum',
                                                loc: {
                                                    start: {
                                                        line: 28,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'glass/html/forms/ImageUrlInput.ion'
                                                    },
                                                    end: {
                                                        line: 28,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'glass/html/forms/ImageUrlInput.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 28,
                                                    column: 11,
                                                    fixed: true,
                                                    source: 'glass/html/forms/ImageUrlInput.ion'
                                                },
                                                end: {
                                                    line: 28,
                                                    column: 27,
                                                    fixed: true,
                                                    source: 'glass/html/forms/ImageUrlInput.ion'
                                                }
                                            }
                                        }
                                    },
                                    consequent: {
                                        type: 'BlockStatement',
                                        body: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'min',
                                                    loc: {
                                                        start: {
                                                            line: 29,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        },
                                                        end: {
                                                            line: 29,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'property',
                                                        loc: {
                                                            start: {
                                                                line: 29,
                                                                column: 17,
                                                                fixed: true,
                                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                                            },
                                                            end: {
                                                                line: 29,
                                                                column: 25,
                                                                fixed: true,
                                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'minimum',
                                                        loc: {
                                                            start: {
                                                                line: 29,
                                                                column: 26,
                                                                fixed: true,
                                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                                            },
                                                            end: {
                                                                line: 29,
                                                                column: 33,
                                                                fixed: true,
                                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 29,
                                                            column: 17,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        },
                                                        end: {
                                                            line: 29,
                                                            column: 33,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        }
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    },
                                    alternate: null,
                                    order: '4'
                                },
                                {
                                    type: 'IfStatement',
                                    test: {
                                        type: 'UnaryExpression',
                                        operator: '?',
                                        argument: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'property',
                                                loc: {
                                                    start: {
                                                        line: 30,
                                                        column: 11,
                                                        fixed: true,
                                                        source: 'glass/html/forms/ImageUrlInput.ion'
                                                    },
                                                    end: {
                                                        line: 30,
                                                        column: 19,
                                                        fixed: true,
                                                        source: 'glass/html/forms/ImageUrlInput.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'maximum',
                                                loc: {
                                                    start: {
                                                        line: 30,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'glass/html/forms/ImageUrlInput.ion'
                                                    },
                                                    end: {
                                                        line: 30,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'glass/html/forms/ImageUrlInput.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 30,
                                                    column: 11,
                                                    fixed: true,
                                                    source: 'glass/html/forms/ImageUrlInput.ion'
                                                },
                                                end: {
                                                    line: 30,
                                                    column: 27,
                                                    fixed: true,
                                                    source: 'glass/html/forms/ImageUrlInput.ion'
                                                }
                                            }
                                        }
                                    },
                                    consequent: {
                                        type: 'BlockStatement',
                                        body: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'max',
                                                    loc: {
                                                        start: {
                                                            line: 31,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        },
                                                        end: {
                                                            line: 31,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'property',
                                                        loc: {
                                                            start: {
                                                                line: 31,
                                                                column: 17,
                                                                fixed: true,
                                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                                            },
                                                            end: {
                                                                line: 31,
                                                                column: 25,
                                                                fixed: true,
                                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'maximum',
                                                        loc: {
                                                            start: {
                                                                line: 31,
                                                                column: 26,
                                                                fixed: true,
                                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                                            },
                                                            end: {
                                                                line: 31,
                                                                column: 33,
                                                                fixed: true,
                                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 31,
                                                            column: 17,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        },
                                                        end: {
                                                            line: 31,
                                                            column: 33,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        }
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    },
                                    alternate: null,
                                    order: '5'
                                },
                                {
                                    type: 'IfStatement',
                                    test: {
                                        type: 'UnaryExpression',
                                        operator: '?',
                                        argument: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'property',
                                                loc: {
                                                    start: {
                                                        line: 32,
                                                        column: 11,
                                                        fixed: true,
                                                        source: 'glass/html/forms/ImageUrlInput.ion'
                                                    },
                                                    end: {
                                                        line: 32,
                                                        column: 19,
                                                        fixed: true,
                                                        source: 'glass/html/forms/ImageUrlInput.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'maxLength',
                                                loc: {
                                                    start: {
                                                        line: 32,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'glass/html/forms/ImageUrlInput.ion'
                                                    },
                                                    end: {
                                                        line: 32,
                                                        column: 29,
                                                        fixed: true,
                                                        source: 'glass/html/forms/ImageUrlInput.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 32,
                                                    column: 11,
                                                    fixed: true,
                                                    source: 'glass/html/forms/ImageUrlInput.ion'
                                                },
                                                end: {
                                                    line: 32,
                                                    column: 29,
                                                    fixed: true,
                                                    source: 'glass/html/forms/ImageUrlInput.ion'
                                                }
                                            }
                                        }
                                    },
                                    consequent: {
                                        type: 'BlockStatement',
                                        body: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'maxlength',
                                                    loc: {
                                                        start: {
                                                            line: 33,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        },
                                                        end: {
                                                            line: 33,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'property',
                                                        loc: {
                                                            start: {
                                                                line: 33,
                                                                column: 23,
                                                                fixed: true,
                                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                                            },
                                                            end: {
                                                                line: 33,
                                                                column: 31,
                                                                fixed: true,
                                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'maxLength',
                                                        loc: {
                                                            start: {
                                                                line: 33,
                                                                column: 32,
                                                                fixed: true,
                                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                                            },
                                                            end: {
                                                                line: 33,
                                                                column: 41,
                                                                fixed: true,
                                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 33,
                                                            column: 23,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        },
                                                        end: {
                                                            line: 33,
                                                            column: 41,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        }
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'charCounter',
                                                    loc: {
                                                        start: {
                                                            line: 34,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        },
                                                        end: {
                                                            line: 34,
                                                            column: 23,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: true
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    alternate: null,
                                    order: '6'
                                },
                                {
                                    type: 'IfStatement',
                                    test: {
                                        type: 'UnaryExpression',
                                        operator: '?',
                                        argument: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'property',
                                                loc: {
                                                    start: {
                                                        line: 35,
                                                        column: 11,
                                                        fixed: true,
                                                        source: 'glass/html/forms/ImageUrlInput.ion'
                                                    },
                                                    end: {
                                                        line: 35,
                                                        column: 19,
                                                        fixed: true,
                                                        source: 'glass/html/forms/ImageUrlInput.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'minLength',
                                                loc: {
                                                    start: {
                                                        line: 35,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'glass/html/forms/ImageUrlInput.ion'
                                                    },
                                                    end: {
                                                        line: 35,
                                                        column: 29,
                                                        fixed: true,
                                                        source: 'glass/html/forms/ImageUrlInput.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 35,
                                                    column: 11,
                                                    fixed: true,
                                                    source: 'glass/html/forms/ImageUrlInput.ion'
                                                },
                                                end: {
                                                    line: 35,
                                                    column: 29,
                                                    fixed: true,
                                                    source: 'glass/html/forms/ImageUrlInput.ion'
                                                }
                                            }
                                        }
                                    },
                                    consequent: {
                                        type: 'BlockStatement',
                                        body: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'minlength',
                                                    loc: {
                                                        start: {
                                                            line: 36,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        },
                                                        end: {
                                                            line: 36,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'property',
                                                        loc: {
                                                            start: {
                                                                line: 36,
                                                                column: 23,
                                                                fixed: true,
                                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                                            },
                                                            end: {
                                                                line: 36,
                                                                column: 31,
                                                                fixed: true,
                                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'minLength',
                                                        loc: {
                                                            start: {
                                                                line: 36,
                                                                column: 32,
                                                                fixed: true,
                                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                                            },
                                                            end: {
                                                                line: 36,
                                                                column: 41,
                                                                fixed: true,
                                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 36,
                                                            column: 23,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        },
                                                        end: {
                                                            line: 36,
                                                            column: 41,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        }
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    },
                                    alternate: null,
                                    order: '7'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context) {
                                            return function focus() {
                                                var state = _context.get('state');
                                                state.focused = true;
                                            };
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 38,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                        },
                                        end: {
                                            line: 40,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                        }
                                    },
                                    order: '8'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context2) {
                                            return function blur() {
                                                var state = _context2.get('state');
                                                state.focused = false;
                                            };
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 40,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                        },
                                        end: {
                                            line: 43,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                        }
                                    },
                                    order: '9'
                                }
                            ]
                        }
                    }],
                kind: 'let',
                order: '4'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'imgElement',
                            loc: {
                                start: {
                                    line: 43,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/forms/ImageUrlInput.ion'
                                },
                                end: {
                                    line: 43,
                                    column: 18,
                                    fixed: true,
                                    source: 'glass/html/forms/ImageUrlInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Img',
                                    loc: {
                                        start: {
                                            line: 43,
                                            column: 21,
                                            fixed: true,
                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                        },
                                        end: {
                                            line: 43,
                                            column: 24,
                                            fixed: true,
                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                        }
                                    }
                                },
                                arguments: [],
                                loc: {
                                    start: {
                                        line: 43,
                                        column: 21,
                                        fixed: true,
                                        source: 'glass/html/forms/ImageUrlInput.ion'
                                    },
                                    end: {
                                        line: 43,
                                        column: 26,
                                        fixed: true,
                                        source: 'glass/html/forms/ImageUrlInput.ion'
                                    }
                                }
                            },
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'style',
                                        loc: {
                                            start: {
                                                line: 44,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                            },
                                            end: {
                                                line: 44,
                                                column: 13,
                                                fixed: true,
                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'padding',
                                                    loc: {
                                                        start: {
                                                            line: 45,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        },
                                                        end: {
                                                            line: 45,
                                                            column: 19,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: '8px'
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Literal',
                                                    value: 'max-width'
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: '200px'
                                                },
                                                kind: 'init',
                                                order: '1'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Literal',
                                                    value: 'max-height'
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: '200px'
                                                },
                                                kind: 'init',
                                                order: '2'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'margin',
                                                    loc: {
                                                        start: {
                                                            line: 48,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        },
                                                        end: {
                                                            line: 48,
                                                            column: 18,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: 'auto'
                                                },
                                                kind: 'init',
                                                order: '3'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'display',
                                                    loc: {
                                                        start: {
                                                            line: 49,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        },
                                                        end: {
                                                            line: 49,
                                                            column: 19,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: 'block'
                                                },
                                                kind: 'init',
                                                order: '4'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'src',
                                        loc: {
                                            start: {
                                                line: 50,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                            },
                                            end: {
                                                line: 50,
                                                column: 11,
                                                fixed: true,
                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'inputElement',
                                            loc: {
                                                start: {
                                                    line: 50,
                                                    column: 13,
                                                    fixed: true,
                                                    source: 'glass/html/forms/ImageUrlInput.ion'
                                                },
                                                end: {
                                                    line: 50,
                                                    column: 25,
                                                    fixed: true,
                                                    source: 'glass/html/forms/ImageUrlInput.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'value',
                                            loc: {
                                                start: {
                                                    line: 50,
                                                    column: 26,
                                                    fixed: true,
                                                    source: 'glass/html/forms/ImageUrlInput.ion'
                                                },
                                                end: {
                                                    line: 50,
                                                    column: 31,
                                                    fixed: true,
                                                    source: 'glass/html/forms/ImageUrlInput.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 50,
                                                column: 13,
                                                fixed: true,
                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                            },
                                            end: {
                                                line: 50,
                                                column: 31,
                                                fixed: true,
                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '1'
                                }
                            ]
                        }
                    }],
                kind: 'let',
                order: '5'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'imgContainer',
                            loc: {
                                start: {
                                    line: 52,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/forms/ImageUrlInput.ion'
                                },
                                end: {
                                    line: 52,
                                    column: 20,
                                    fixed: true,
                                    source: 'glass/html/forms/ImageUrlInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Div',
                                    loc: {
                                        start: {
                                            line: 52,
                                            column: 23,
                                            fixed: true,
                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                        },
                                        end: {
                                            line: 52,
                                            column: 26,
                                            fixed: true,
                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                        }
                                    }
                                },
                                arguments: [],
                                loc: {
                                    start: {
                                        line: 52,
                                        column: 23,
                                        fixed: true,
                                        source: 'glass/html/forms/ImageUrlInput.ion'
                                    },
                                    end: {
                                        line: 52,
                                        column: 28,
                                        fixed: true,
                                        source: 'glass/html/forms/ImageUrlInput.ion'
                                    }
                                }
                            },
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'classList',
                                        loc: {
                                            start: {
                                                line: 53,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                            },
                                            end: {
                                                line: 53,
                                                column: 21,
                                                fixed: true,
                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'Literal',
                                                    value: 'ImagePreview'
                                                },
                                                loc: {
                                                    start: {
                                                        line: 54,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'glass/html/forms/ImageUrlInput.ion'
                                                    },
                                                    end: {
                                                        line: 54,
                                                        column: 30,
                                                        fixed: true,
                                                        source: 'glass/html/forms/ImageUrlInput.ion'
                                                    }
                                                },
                                                order: '0'
                                            },
                                            {
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'Literal',
                                                    value: 'z1'
                                                },
                                                loc: {
                                                    start: {
                                                        line: 55,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'glass/html/forms/ImageUrlInput.ion'
                                                    },
                                                    end: {
                                                        line: 55,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'glass/html/forms/ImageUrlInput.ion'
                                                    }
                                                },
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    order: '0'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'Identifier',
                                        name: 'imgElement',
                                        loc: {
                                            start: {
                                                line: 56,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                            },
                                            end: {
                                                line: 56,
                                                column: 22,
                                                fixed: true,
                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 56,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                        },
                                        end: {
                                            line: 56,
                                            column: 22,
                                            fixed: true,
                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                        }
                                    },
                                    order: '1'
                                }
                            ]
                        }
                    }],
                kind: 'let',
                order: '6'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'CallExpression',
                    callee: {
                        type: 'MemberExpression',
                        object: {
                            type: 'Identifier',
                            name: 'Object'
                        },
                        property: {
                            type: 'Identifier',
                            name: 'defineProperties'
                        }
                    },
                    arguments: [
                        {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Div',
                                    loc: {
                                        start: {
                                            line: 58,
                                            column: 11,
                                            fixed: true,
                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                        },
                                        end: {
                                            line: 58,
                                            column: 14,
                                            fixed: true,
                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'class',
                                                    loc: {
                                                        start: {
                                                            line: 58,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        },
                                                        end: {
                                                            line: 58,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: 'ImageUrlInput'
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    }],
                                loc: {
                                    start: {
                                        line: 58,
                                        column: 11,
                                        fixed: true,
                                        source: 'glass/html/forms/ImageUrlInput.ion'
                                    },
                                    end: {
                                        line: 58,
                                        column: 40,
                                        fixed: true,
                                        source: 'glass/html/forms/ImageUrlInput.ion'
                                    }
                                }
                            },
                            properties: [
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'Identifier',
                                        name: 'inputElement',
                                        loc: {
                                            start: {
                                                line: 59,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                            },
                                            end: {
                                                line: 59,
                                                column: 20,
                                                fixed: true,
                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 59,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                        },
                                        end: {
                                            line: 59,
                                            column: 20,
                                            fixed: true,
                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                        }
                                    },
                                    order: '0'
                                },
                                {
                                    type: 'IfStatement',
                                    test: {
                                        type: 'BinaryExpression',
                                        operator: '&&',
                                        left: {
                                            type: 'BinaryExpression',
                                            operator: '&&',
                                            left: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'imgElement',
                                                    loc: {
                                                        start: {
                                                            line: 60,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        },
                                                        end: {
                                                            line: 60,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'complete',
                                                    loc: {
                                                        start: {
                                                            line: 60,
                                                            column: 23,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        },
                                                        end: {
                                                            line: 60,
                                                            column: 31,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 60,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/forms/ImageUrlInput.ion'
                                                    },
                                                    end: {
                                                        line: 60,
                                                        column: 31,
                                                        fixed: true,
                                                        source: 'glass/html/forms/ImageUrlInput.ion'
                                                    }
                                                }
                                            },
                                            right: {
                                                type: 'BinaryExpression',
                                                operator: '>',
                                                left: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'imgElement',
                                                        loc: {
                                                            start: {
                                                                line: 60,
                                                                column: 36,
                                                                fixed: true,
                                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                                            },
                                                            end: {
                                                                line: 60,
                                                                column: 46,
                                                                fixed: true,
                                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'width',
                                                        loc: {
                                                            start: {
                                                                line: 60,
                                                                column: 47,
                                                                fixed: true,
                                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                                            },
                                                            end: {
                                                                line: 60,
                                                                column: 52,
                                                                fixed: true,
                                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 60,
                                                            column: 36,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        },
                                                        end: {
                                                            line: 60,
                                                            column: 52,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        }
                                                    }
                                                },
                                                right: {
                                                    type: 'Literal',
                                                    value: 0
                                                }
                                            }
                                        },
                                        right: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'state',
                                                loc: {
                                                    start: {
                                                        line: 60,
                                                        column: 61,
                                                        fixed: true,
                                                        source: 'glass/html/forms/ImageUrlInput.ion'
                                                    },
                                                    end: {
                                                        line: 60,
                                                        column: 66,
                                                        fixed: true,
                                                        source: 'glass/html/forms/ImageUrlInput.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'focused',
                                                loc: {
                                                    start: {
                                                        line: 60,
                                                        column: 67,
                                                        fixed: true,
                                                        source: 'glass/html/forms/ImageUrlInput.ion'
                                                    },
                                                    end: {
                                                        line: 60,
                                                        column: 74,
                                                        fixed: true,
                                                        source: 'glass/html/forms/ImageUrlInput.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 60,
                                                    column: 61,
                                                    fixed: true,
                                                    source: 'glass/html/forms/ImageUrlInput.ion'
                                                },
                                                end: {
                                                    line: 60,
                                                    column: 74,
                                                    fixed: true,
                                                    source: 'glass/html/forms/ImageUrlInput.ion'
                                                }
                                            }
                                        }
                                    },
                                    consequent: {
                                        type: 'BlockStatement',
                                        body: [{
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'Identifier',
                                                    name: 'imgContainer',
                                                    loc: {
                                                        start: {
                                                            line: 61,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        },
                                                        end: {
                                                            line: 61,
                                                            column: 24,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 61,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/forms/ImageUrlInput.ion'
                                                    },
                                                    end: {
                                                        line: 61,
                                                        column: 24,
                                                        fixed: true,
                                                        source: 'glass/html/forms/ImageUrlInput.ion'
                                                    }
                                                },
                                                order: '0'
                                            }]
                                    },
                                    alternate: null,
                                    order: '1'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'select',
                                        loc: {
                                            start: {
                                                line: 62,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                            },
                                            end: {
                                                line: 62,
                                                column: 14,
                                                fixed: true,
                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context3) {
                                            return function () {
                                                var inputElement = _context3.get('inputElement');
                                                inputElement.inputElement.select();
                                            };
                                        }
                                    },
                                    kind: 'init',
                                    order: '2'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'name',
                                        loc: {
                                            start: {
                                                line: 65,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                            },
                                            end: {
                                                line: 65,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'property',
                                            loc: {
                                                start: {
                                                    line: 65,
                                                    column: 14,
                                                    fixed: true,
                                                    source: 'glass/html/forms/ImageUrlInput.ion'
                                                },
                                                end: {
                                                    line: 65,
                                                    column: 22,
                                                    fixed: true,
                                                    source: 'glass/html/forms/ImageUrlInput.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'name',
                                            loc: {
                                                start: {
                                                    line: 65,
                                                    column: 23,
                                                    fixed: true,
                                                    source: 'glass/html/forms/ImageUrlInput.ion'
                                                },
                                                end: {
                                                    line: 65,
                                                    column: 27,
                                                    fixed: true,
                                                    source: 'glass/html/forms/ImageUrlInput.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 65,
                                                column: 14,
                                                fixed: true,
                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                            },
                                            end: {
                                                line: 65,
                                                column: 27,
                                                fixed: true,
                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '3'
                                }
                            ]
                        },
                        {
                            type: 'ObjectExpression',
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'value',
                                        loc: {
                                            start: {
                                                line: 66,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                            },
                                            end: {
                                                line: 66,
                                                column: 22,
                                                fixed: true,
                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 67,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        },
                                                        end: {
                                                            line: 67,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context4) {
                                                        return function () {
                                                            var inputElement = _context4.get('inputElement');
                                                            return inputElement.value;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 68,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        },
                                                        end: {
                                                            line: 68,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context5) {
                                                        return function (value) {
                                                            var inputElement = _context5.get('inputElement');
                                                            inputElement.label = label;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'label',
                                        loc: {
                                            start: {
                                                line: 70,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                            },
                                            end: {
                                                line: 70,
                                                column: 22,
                                                fixed: true,
                                                source: 'glass/html/forms/ImageUrlInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 71,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        },
                                                        end: {
                                                            line: 71,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context6) {
                                                        return function () {
                                                            var inputElement = _context6.get('inputElement');
                                                            return inputElement.label;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 72,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        },
                                                        end: {
                                                            line: 72,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/forms/ImageUrlInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context7) {
                                                        return function (label) {
                                                            var inputElement = _context7.get('inputElement');
                                                            inputElement.label = label;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '1'
                                }
                            ]
                        }
                    ]
                },
                order: '7'
            }
        ],
        bound: false
    }, {
        this: this,
        args: args,
        _ref: _ref,
        style: style,
        _ref3: _ref3
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/forms/ImageUrlInput',_glass_html_forms_ImageUrlInput_);
    else
      _glass_html_forms_ImageUrlInput_.call(this, module, exports, require);
  }
  else {
    _glass_html_forms_ImageUrlInput_.call(this);
  }
}).call(this)
void (function(){var _glass_html_forms_InlineObjectInput_ = function(module,exports,require){'use strict';
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/forms/InlineObjectInput',_glass_html_forms_InlineObjectInput_);
    else
      _glass_html_forms_InlineObjectInput_.call(this, module, exports, require);
  }
  else {
    _glass_html_forms_InlineObjectInput_.call(this);
  }
}).call(this)
void (function(){var _glass_html_forms_Label_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('../');
var style = _ref.style;
var _ref2 = style.sheets;
_ref2[module.id] = '.Label {\n    font-size: 12px;\n    color: rgba(0,0,0,0.43);\n    margin: 8px 0px;\n}';
_ref2;
module.exports = exports = function Label(name) {
    var _ref3 = Div({ class: 'Label' });
    ion.add(_ref3, name);
    return _ref3;
};
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/forms/Label',_glass_html_forms_Label_);
    else
      _glass_html_forms_Label_.call(this, module, exports, require);
  }
  else {
    _glass_html_forms_Label_.call(this);
  }
}).call(this)
void (function(){var _glass_html_forms_ObjectInput_ = function(module,exports,require){'use strict';
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/forms/ObjectInput',_glass_html_forms_ObjectInput_);
    else
      _glass_html_forms_ObjectInput_.call(this, module, exports, require);
  }
  else {
    _glass_html_forms_ObjectInput_.call(this);
  }
}).call(this)
void (function(){var _glass_html_forms_ResetButton_ = function(module,exports,require){'use strict';
var ion = require('ion');
module.exports = exports = ion.template(function ResetButton(attributes) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'ResetButton',
            loc: {
                start: {
                    line: 2,
                    column: 16,
                    fixed: true,
                    source: 'glass/html/forms/ResetButton.ion'
                },
                end: {
                    line: 2,
                    column: 27,
                    fixed: true,
                    source: 'glass/html/forms/ResetButton.ion'
                }
            }
        },
        body: [{
                type: 'ReturnStatement',
                argument: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'CallExpression',
                        callee: {
                            type: 'Identifier',
                            name: 'PaperButton',
                            loc: {
                                start: {
                                    line: 3,
                                    column: 11,
                                    fixed: true,
                                    source: 'glass/html/forms/ResetButton.ion'
                                },
                                end: {
                                    line: 3,
                                    column: 22,
                                    fixed: true,
                                    source: 'glass/html/forms/ResetButton.ion'
                                }
                            }
                        },
                        arguments: [{
                                type: 'Identifier',
                                name: 'attributes',
                                loc: {
                                    start: {
                                        line: 3,
                                        column: 23,
                                        fixed: true,
                                        source: 'glass/html/forms/ResetButton.ion'
                                    },
                                    end: {
                                        line: 3,
                                        column: 33,
                                        fixed: true,
                                        source: 'glass/html/forms/ResetButton.ion'
                                    }
                                }
                            }],
                        loc: {
                            start: {
                                line: 3,
                                column: 11,
                                fixed: true,
                                source: 'glass/html/forms/ResetButton.ion'
                            },
                            end: {
                                line: 3,
                                column: 34,
                                fixed: true,
                                source: 'glass/html/forms/ResetButton.ion'
                            }
                        }
                    },
                    properties: [
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'raised',
                                loc: {
                                    start: {
                                        line: 4,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/forms/ResetButton.ion'
                                    },
                                    end: {
                                        line: 4,
                                        column: 14,
                                        fixed: true,
                                        source: 'glass/html/forms/ResetButton.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Literal',
                                value: true
                            },
                            kind: 'init',
                            order: '0'
                        },
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'Function',
                                context: false,
                                value: function click(e) {
                                    return this.closest('form').reset();
                                }
                            },
                            loc: {
                                start: {
                                    line: 5,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/forms/ResetButton.ion'
                                },
                                end: {
                                    line: 5,
                                    column: 48,
                                    fixed: true,
                                    source: 'glass/html/forms/ResetButton.ion'
                                }
                            },
                            order: '1'
                        }
                    ]
                },
                order: '0'
            }],
        bound: false
    }, {
        this: this,
        attributes: attributes
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/forms/ResetButton',_glass_html_forms_ResetButton_);
    else
      _glass_html_forms_ResetButton_.call(this, module, exports, require);
  }
  else {
    _glass_html_forms_ResetButton_.call(this);
  }
}).call(this)
void (function(){var _glass_html_forms_SubmitButton_ = function(module,exports,require){'use strict';
var ion = require('ion');
module.exports = exports = ion.template(function SubmitButton(attributes) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'SubmitButton',
            loc: {
                start: {
                    line: 3,
                    column: 16,
                    fixed: true,
                    source: 'glass/html/forms/SubmitButton.ion'
                },
                end: {
                    line: 3,
                    column: 28,
                    fixed: true,
                    source: 'glass/html/forms/SubmitButton.ion'
                }
            }
        },
        body: [{
                type: 'ReturnStatement',
                argument: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'CallExpression',
                        callee: {
                            type: 'Identifier',
                            name: 'PaperButton',
                            loc: {
                                start: {
                                    line: 4,
                                    column: 11,
                                    fixed: true,
                                    source: 'glass/html/forms/SubmitButton.ion'
                                },
                                end: {
                                    line: 4,
                                    column: 22,
                                    fixed: true,
                                    source: 'glass/html/forms/SubmitButton.ion'
                                }
                            }
                        },
                        arguments: [{
                                type: 'Identifier',
                                name: 'attributes',
                                loc: {
                                    start: {
                                        line: 4,
                                        column: 23,
                                        fixed: true,
                                        source: 'glass/html/forms/SubmitButton.ion'
                                    },
                                    end: {
                                        line: 4,
                                        column: 33,
                                        fixed: true,
                                        source: 'glass/html/forms/SubmitButton.ion'
                                    }
                                }
                            }],
                        loc: {
                            start: {
                                line: 4,
                                column: 11,
                                fixed: true,
                                source: 'glass/html/forms/SubmitButton.ion'
                            },
                            end: {
                                line: 4,
                                column: 34,
                                fixed: true,
                                source: 'glass/html/forms/SubmitButton.ion'
                            }
                        }
                    },
                    properties: [
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'raised',
                                loc: {
                                    start: {
                                        line: 5,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/forms/SubmitButton.ion'
                                    },
                                    end: {
                                        line: 5,
                                        column: 14,
                                        fixed: true,
                                        source: 'glass/html/forms/SubmitButton.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Literal',
                                value: true
                            },
                            kind: 'init',
                            order: '0'
                        },
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'Identifier',
                                        name: 'Input',
                                        loc: {
                                            start: {
                                                line: 7,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/forms/SubmitButton.ion'
                                            },
                                            end: {
                                                line: 7,
                                                column: 13,
                                                fixed: true,
                                                source: 'glass/html/forms/SubmitButton.ion'
                                            }
                                        }
                                    },
                                    arguments: [{
                                            type: 'ObjectExpression',
                                            properties: [
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'type',
                                                        loc: {
                                                            start: {
                                                                line: 7,
                                                                column: 15,
                                                                fixed: true,
                                                                source: 'glass/html/forms/SubmitButton.ion'
                                                            },
                                                            end: {
                                                                line: 7,
                                                                column: 19,
                                                                fixed: true,
                                                                source: 'glass/html/forms/SubmitButton.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 'submit'
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'style',
                                                        loc: {
                                                            start: {
                                                                line: 7,
                                                                column: 29,
                                                                fixed: true,
                                                                source: 'glass/html/forms/SubmitButton.ion'
                                                            },
                                                            end: {
                                                                line: 7,
                                                                column: 34,
                                                                fixed: true,
                                                                source: 'glass/html/forms/SubmitButton.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 'display:none;'
                                                    },
                                                    kind: 'init',
                                                    order: '1'
                                                }
                                            ]
                                        }],
                                    loc: {
                                        start: {
                                            line: 7,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/forms/SubmitButton.ion'
                                        },
                                        end: {
                                            line: 7,
                                            column: 52,
                                            fixed: true,
                                            source: 'glass/html/forms/SubmitButton.ion'
                                        }
                                    }
                                },
                                properties: [{
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'Function',
                                            context: false,
                                            value: function click(e) {
                                                e.stopPropagation();
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 8,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/forms/SubmitButton.ion'
                                            },
                                            end: {
                                                line: 10,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/forms/SubmitButton.ion'
                                            }
                                        },
                                        order: '0'
                                    }]
                            },
                            loc: {
                                start: {
                                    line: 7,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/forms/SubmitButton.ion'
                                },
                                end: {
                                    line: 10,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/forms/SubmitButton.ion'
                                }
                            },
                            order: '1'
                        },
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'Function',
                                context: false,
                                value: function click(e) {
                                    this.closest('form').submit(e);
                                }
                            },
                            loc: {
                                start: {
                                    line: 10,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/forms/SubmitButton.ion'
                                },
                                end: {
                                    line: 13,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/forms/SubmitButton.ion'
                                }
                            },
                            order: '2'
                        }
                    ]
                },
                order: '0'
            }],
        bound: false
    }, {
        this: this,
        attributes: attributes
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/forms/SubmitButton',_glass_html_forms_SubmitButton_);
    else
      _glass_html_forms_SubmitButton_.call(this, module, exports, require);
  }
  else {
    _glass_html_forms_SubmitButton_.call(this);
  }
}).call(this)
void (function(){var _glass_html_forms_index_ = function(module,exports,require){Object.defineProperty(exports, 'CancelButton', {get:function(){ return require('./CancelButton') }, enumerable: true}) 
Object.defineProperty(exports, 'Checkbox', {get:function(){ return require('./Checkbox') }, enumerable: true}) 
Object.defineProperty(exports, 'DateInput', {get:function(){ return require('./DateInput') }, enumerable: true}) 
Object.defineProperty(exports, 'DurationInput', {get:function(){ return require('./DurationInput') }, enumerable: true}) 
Object.defineProperty(exports, 'EditForm', {get:function(){ return require('./EditForm') }, enumerable: true}) 
Object.defineProperty(exports, 'Field', {get:function(){ return require('./Field') }, enumerable: true}) 
Object.defineProperty(exports, 'GlassForm', {get:function(){ return require('./GlassForm') }, enumerable: true}) 
Object.defineProperty(exports, 'GlassPrompt', {get:function(){ return require('./GlassPrompt') }, enumerable: true}) 
Object.defineProperty(exports, 'ImageUrlInput', {get:function(){ return require('./ImageUrlInput') }, enumerable: true}) 
Object.defineProperty(exports, 'InlineObjectInput', {get:function(){ return require('./InlineObjectInput') }, enumerable: true}) 
Object.defineProperty(exports, 'Label', {get:function(){ return require('./Label') }, enumerable: true}) 
Object.defineProperty(exports, 'ObjectInput', {get:function(){ return require('./ObjectInput') }, enumerable: true}) 
Object.defineProperty(exports, 'ResetButton', {get:function(){ return require('./ResetButton') }, enumerable: true}) 
Object.defineProperty(exports, 'SubmitButton', {get:function(){ return require('./SubmitButton') }, enumerable: true}) 
Object.freeze(exports)
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/forms/index',_glass_html_forms_index_);
    else
      _glass_html_forms_index_.call(this, module, exports, require);
  }
  else {
    _glass_html_forms_index_.call(this);
  }
}).call(this)
void (function(){var _glass_html_functions_ = function(module,exports,require){'use strict';
var ion = require('ion'), style = require('./style');
var makeElementAutoEdgeScroll = exports.makeElementAutoEdgeScroll = function (element) {
        var defaultScrollEdge = 10;
        var scrollIncrement = 20;
        var scrollInterval = 100;
        var lastEvent = null;
        var maybeScroll = function (e) {
            var _ref = getOffsetRelative(element);
            var elementPageX = _ref[0];
            var elementPageY = _ref[1];
            var x = e.pageX - elementPageX;
            var y = e.pageY - elementPageY;
            var width = element.offsetWidth;
            var height = element.offsetHeight;
            var horizontalEdge = Math.min(defaultScrollEdge, width / 3);
            var verticalEdge = Math.min(defaultScrollEdge, height / 3);
            var scrollX = x < horizontalEdge ? -scrollIncrement : width - x < horizontalEdge ? +scrollIncrement : 0;
            var scrollY = y < verticalEdge ? -scrollIncrement : height - y < verticalEdge ? +scrollIncrement : 0;
            element.scrollLeft += scrollX;
            element.scrollTop += scrollY;
        };
        var scrollCallback = function () {
            if (lastEvent) {
                maybeScroll(lastEvent);
            }
        };
        var dragging = false;
        var mousedown = function (e) {
            lastEvent = e;
            dragging = true;
            var intervalId = setInterval(scrollCallback, scrollInterval);
            require('./DragHelper').captureMouse(e, {
                mousemove: mousemove,
                mouseup: mouseup,
                mouseleave: mouseleave,
                releaseOnLeave: false,
                release: function () {
                    return clearInterval(intervalId);
                }
            });
        };
        var mousemove = function (e) {
            lastEvent = e;
            if (dragging) {
                maybeScroll(e);
            }
        };
        var mouseleave = function (e) {
            lastEvent = e;
        };
        var mouseup = function (e) {
            dragging = false;
        };
        element.addEventListener('mousedown', mousedown);
        return element;
    }, focusDescendant = exports.focusDescendant = function (element) {
        if (element == null)
            element = document.body;
        var autofocus = element.querySelector('[autofocus]');
        autofocus != null ? autofocus.focus() : void 0;
    }, isAncestor = exports.isAncestor = function (element, possibleAncestor) {
        while ((element = element != null ? element.parentElement : void 0) != null) {
            if (element === possibleAncestor) {
                return true;
            }
        }
        return false;
    }, isDescendant = exports.isDescendant = function (element, possibleDescendant) {
        return isAncestor(possibleDescendant, element);
    }, getAncestorByClass = exports.getAncestorByClass = function (element, clas) {
        while ((element = element != null ? element.parentElement : void 0) != null) {
            if (element.classList.contains(clas)) {
                return element;
            }
        }
        return null;
    }, getOffsetRelative = exports.getOffsetRelative = function (element, ancestor) {
        var from = ancestor ? ancestor.getBoundingClientRect() : {
                left: 0,
                top: 0
            };
        var to = element.getBoundingClientRect();
        return [
            to.left - from.left,
            to.top - from.top
        ];
    }, linkScrollPositions = exports.linkScrollPositions = function (elements, horizontal, vertical) {
        if (horizontal == null)
            horizontal = true;
        if (vertical == null)
            vertical = false;
        var handler = function scroll(e) {
            for (var _i = 0; _i < elements.length; _i++) {
                var element = elements[_i];
                if (element !== this) {
                    if (horizontal) {
                        element.scrollLeft = this.scrollLeft;
                    }
                    if (vertical) {
                        element.scrollTop = this.scrollTop;
                    }
                }
            }
        };
        for (var _i2 = 0; _i2 < elements.length; _i2++) {
            var element = elements[_i2];
            var _ref7 = element;
            ion.add(_ref7, handler);
            _ref7;
        }
    }, scrollIntoView = exports.scrollIntoView = function (element, container, margin) {
        if (margin == null)
            margin = 100;
        var _ref2 = getOffsetRelative(element, container);
        var offsetX = _ref2[0];
        var offsetY = _ref2[1];
        var _ref3 = container;
        var offsetHeight = _ref3.offsetHeight;
        var offsetWidth = _ref3.offsetWidth;
        throw new Error('not implemented yet');
    }, ensureOnScreenTemplate = exports.ensureOnScreenTemplate = ion.template(function (_ref4) {
        return ion.createRuntime({
            type: 'Template',
            id: null,
            body: [
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'element',
                                loc: {
                                    start: {
                                        line: 78,
                                        column: 40,
                                        fixed: true,
                                        source: 'glass/html/functions.ion'
                                    },
                                    end: {
                                        line: 78,
                                        column: 47,
                                        fixed: true,
                                        source: 'glass/html/functions.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref4'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'element',
                                    loc: {
                                        start: {
                                            line: 78,
                                            column: 40,
                                            fixed: true,
                                            source: 'glass/html/functions.ion'
                                        },
                                        end: {
                                            line: 78,
                                            column: 47,
                                            fixed: true,
                                            source: 'glass/html/functions.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '0'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'x',
                                loc: {
                                    start: {
                                        line: 78,
                                        column: 49,
                                        fixed: true,
                                        source: 'glass/html/functions.ion'
                                    },
                                    end: {
                                        line: 78,
                                        column: 50,
                                        fixed: true,
                                        source: 'glass/html/functions.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref4'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'x',
                                    loc: {
                                        start: {
                                            line: 78,
                                            column: 49,
                                            fixed: true,
                                            source: 'glass/html/functions.ion'
                                        },
                                        end: {
                                            line: 78,
                                            column: 50,
                                            fixed: true,
                                            source: 'glass/html/functions.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '1'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'y',
                                loc: {
                                    start: {
                                        line: 78,
                                        column: 52,
                                        fixed: true,
                                        source: 'glass/html/functions.ion'
                                    },
                                    end: {
                                        line: 78,
                                        column: 53,
                                        fixed: true,
                                        source: 'glass/html/functions.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref4'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'y',
                                    loc: {
                                        start: {
                                            line: 78,
                                            column: 52,
                                            fixed: true,
                                            source: 'glass/html/functions.ion'
                                        },
                                        end: {
                                            line: 78,
                                            column: 53,
                                            fixed: true,
                                            source: 'glass/html/functions.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '2'
                },
                {
                    type: 'ExpressionStatement',
                    expression: {
                        type: 'CallExpression',
                        callee: {
                            type: 'MemberExpression',
                            computed: false,
                            object: {
                                type: 'Identifier',
                                name: 'console',
                                loc: {
                                    start: {
                                        line: 79,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/functions.ion'
                                    },
                                    end: {
                                        line: 79,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/functions.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'log',
                                loc: {
                                    start: {
                                        line: 79,
                                        column: 16,
                                        fixed: true,
                                        source: 'glass/html/functions.ion'
                                    },
                                    end: {
                                        line: 79,
                                        column: 19,
                                        fixed: true,
                                        source: 'glass/html/functions.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 79,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/functions.ion'
                                },
                                end: {
                                    line: 79,
                                    column: 19,
                                    fixed: true,
                                    source: 'glass/html/functions.ion'
                                }
                            }
                        },
                        arguments: [{
                                type: 'Literal',
                                value: 'keep me on screen.'
                            }],
                        loc: {
                            start: {
                                line: 79,
                                column: 8,
                                fixed: true,
                                source: 'glass/html/functions.ion'
                            },
                            end: {
                                line: 79,
                                column: 41,
                                fixed: true,
                                source: 'glass/html/functions.ion'
                            }
                        }
                    },
                    loc: {
                        start: {
                            line: 79,
                            column: 8,
                            fixed: true,
                            source: 'glass/html/functions.ion'
                        },
                        end: {
                            line: 79,
                            column: 41,
                            fixed: true,
                            source: 'glass/html/functions.ion'
                        }
                    },
                    order: '3'
                }
            ],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'ensureOnScreenTemplate',
                loc: {
                    start: {
                        line: 78,
                        column: 4,
                        fixed: true,
                        source: 'glass/html/functions.ion'
                    },
                    end: {
                        line: 78,
                        column: 26,
                        fixed: true,
                        source: 'glass/html/functions.ion'
                    }
                }
            }
        }, {
            this: this,
            _ref4: _ref4,
            ion: ion,
            style: style,
            makeElementAutoEdgeScroll: makeElementAutoEdgeScroll,
            focusDescendant: focusDescendant,
            isAncestor: isAncestor,
            isDescendant: isDescendant,
            getAncestorByClass: getAncestorByClass,
            getOffsetRelative: getOffsetRelative,
            linkScrollPositions: linkScrollPositions,
            scrollIntoView: scrollIntoView,
            ensureOnScreenTemplate: ensureOnScreenTemplate,
            ensureOnScreen: ensureOnScreen,
            show: show
        }, null);
    }), ensureOnScreen = exports.ensureOnScreen = function (element, x, y, margin) {
        if (margin == null)
            margin = style.page.margin;
        var bodyWidth = document.body.clientWidth;
        var bodyHeight = document.body.clientHeight;
        var width = element.offsetWidth;
        var height = element.offsetHeight;
        x = x != null ? x : 0;
        if (x + width > bodyWidth) {
            x = Math.max(0, bodyWidth - width - margin);
        }
        if (x < 0) {
            x = Math.min(margin, bodyWidth - width);
        }
        y = y != null ? y : 0;
        if (y + height > bodyHeight) {
            y = Math.max(0, bodyHeight - height - margin);
        }
        if (y < 0) {
            y = Math.min(margin, bodyHeight - height);
        }
        element.style.left = '' + x + 'px';
        element.style.top = '' + y + 'px';
        element.style.maxWidth = '100vw';
        element.style.maxHeight = '100vh';
        return [
            x,
            y
        ];
    }, show = exports.show = function (_ref5) {
        var template = _ref5.template;
        var sourceElement = _ref5.sourceElement;
        var position = _ref5.position;
        var modal = _ref5.modal;
        var select = _ref5.select;
        var onAdd = _ref5.onAdd;
        var onRemove = _ref5.onRemove;
        var element;
        var removeElement;
        var remove;
        var unobserveClientWidth;
        var unobserveClientHeight;
        var bestX = position != null ? position[0] : void 0, bestY = position != null ? position[1] : void 0;
        var reposition = ion.bind(function () {
                var x, y;
                if (bestX != null && bestY != null) {
                    x = bestX;
                    y = bestY;
                } else if (sourceElement != null) {
                    var bounds = sourceElement.getBoundingClientRect();
                    x = bounds.left;
                    y = bounds.top;
                }
                var _ref6 = ensureOnScreen(element, x, y);
                bestX = _ref6[0];
                bestY = _ref6[1];
            }, this);
        var bodyMousedown = function mousedown(e) {
            remove != null ? remove(e) : void 0;
        };
        document.body.addEventListener('mousedown', bodyMousedown);
        var unobserveBodyMousedown = function () {
            return document.body.removeEventListener('mousedown', bodyMousedown);
        };
        var unobserve = template.observe(ion.bind(function (elementValue) {
                element = elementValue;
                removeElement != null ? removeElement() : void 0;
                removeElement = null;
                if (element != null) {
                    ion.patch.combine(element.style, {
                        position: 'absolute',
                        left: '0px',
                        top: '0px',
                        zIndex: 10
                    });
                    var _ref8 = element;
                    ion.add(_ref8, function mousedown(e) {
                        return e.stopPropagation();
                    });
                    _ref8;
                    var _ref9 = element;
                    ion.add(_ref9, function close(e) {
                        remove();
                    });
                    _ref9;
                    onAdd != null ? onAdd(element) : void 0;
                    document.body.appendChild(element);
                    removeElement = function () {
                        return document.body.removeChild(element);
                    };
                    if (select) {
                        element.select != null ? element.select() : void 0;
                    }
                    element.focus != null ? element.focus() : void 0;
                    reposition();
                    unobserveClientWidth = ion.observe(element, reposition, { property: 'clientWidth' });
                    unobserveClientHeight = ion.observe(element, reposition, { property: 'clientHeight' });
                }
            }, this));
        window.addEventListener('resize', reposition);
        var unobserveResize = function () {
            return window.removeEventListener('resize', reposition);
        };
        remove = ion.bind(function (e) {
            removeElement != null ? removeElement() : void 0;
            removeElement = null;
            unobserve != null ? unobserve() : void 0;
            unobserve = null;
            unobserveResize != null ? unobserveResize() : void 0;
            unobserveResize = null;
            unobserveClientWidth != null ? unobserveClientWidth() : void 0;
            unobserveClientWidth = null;
            unobserveClientHeight != null ? unobserveClientHeight() : void 0;
            unobserveClientHeight = null;
            unobserveBodyMousedown != null ? unobserveBodyMousedown() : void 0;
            unobserveBodyMousedown = null;
            sourceElement != null ? sourceElement.focus != null ? sourceElement.focus() : void 0 : void 0;
            onRemove != null ? onRemove(e) : void 0;
            onRemove = null;
        }, this);
        return remove;
    };
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/functions',_glass_html_functions_);
    else
      _glass_html_functions_.call(this, module, exports, require);
  }
  else {
    _glass_html_functions_.call(this);
  }
}).call(this)
void (function(){var _glass_html_index_ = function(module,exports,require){Object.defineProperty(exports, 'DragHelper', {get:function(){ return require('./DragHelper') }, enumerable: true}) 
Object.defineProperty(exports, 'HTMLElement', {get:function(){ return require('./HTMLElement') }, enumerable: true}) 
Object.defineProperty(exports, 'Theme', {get:function(){ return require('./Theme') }, enumerable: true}) 
Object.defineProperty(exports, 'device', {get:function(){ return require('./device') }, enumerable: true}) 
Object.defineProperty(exports, 'forms', {get:function(){ return require('./forms') }, enumerable: true}) 
Object.defineProperty(exports, 'functions', {get:function(){ return require('./functions') }, enumerable: true}) 
Object.defineProperty(exports, 'marked', {get:function(){ return require('./marked') }, enumerable: true}) 
Object.defineProperty(exports, 'material', {get:function(){ return require('./material') }, enumerable: true}) 
Object.defineProperty(exports, 'paper', {get:function(){ return require('./paper') }, enumerable: true}) 
Object.defineProperty(exports, 'prefixfree', {get:function(){ return require('./prefixfree') }, enumerable: true}) 
Object.defineProperty(exports, 'style', {get:function(){ return require('./style') }, enumerable: true}) 
Object.defineProperty(exports, 'virtual', {get:function(){ return require('./virtual') }, enumerable: true}) 
Object.freeze(exports)
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/index',_glass_html_index_);
    else
      _glass_html_index_.call(this, module, exports, require);
  }
  else {
    _glass_html_index_.call(this);
  }
}).call(this)
void (function(){var _glass_html_marked_ = function(module,exports,require){/**
 * marked - a markdown parser
 * Copyright (c) 2011-2014, Christopher Jeffrey. (MIT Licensed)
 * https://github.com/chjj/marked
 */

;(function() {

/**
 * Block-Level Grammar
 */

var block = {
  newline: /^\n+/,
  code: /^( {4}[^\n]+\n*)+/,
  fences: noop,
  hr: /^( *[-*_]){3,} *(?:\n+|$)/,
  heading: /^ *(#{1,6}) *([^\n]+?) *#* *(?:\n+|$)/,
  nptable: noop,
  lheading: /^([^\n]+)\n *(=|-){2,} *(?:\n+|$)/,
  blockquote: /^( *>[^\n]+(\n(?!def)[^\n]+)*\n*)+/,
  list: /^( *)(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?!\1bull )\n*|\s*$)/,
  html: /^ *(?:comment *(?:\n|\s*$)|closed *(?:\n{2,}|\s*$)|closing *(?:\n{2,}|\s*$))/,
  def: /^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +["(]([^\n]+)[")])? *(?:\n+|$)/,
  table: noop,
  paragraph: /^((?:[^\n]+\n?(?!hr|heading|lheading|blockquote|tag|def))+)\n*/,
  text: /^[^\n]+/
};

block.bullet = /(?:[*+-]|\d+\.)/;
block.item = /^( *)(bull) [^\n]*(?:\n(?!\1bull )[^\n]*)*/;
block.item = replace(block.item, 'gm')
  (/bull/g, block.bullet)
  ();

block.list = replace(block.list)
  (/bull/g, block.bullet)
  ('hr', '\\n+(?=\\1?(?:[-*_] *){3,}(?:\\n+|$))')
  ('def', '\\n+(?=' + block.def.source + ')')
  ();

block.blockquote = replace(block.blockquote)
  ('def', block.def)
  ();

block._tag = '(?!(?:'
  + 'a|em|strong|small|s|cite|q|dfn|abbr|data|time|code'
  + '|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo'
  + '|span|br|wbr|ins|del|img)\\b)\\w+(?!:/|[^\\w\\s@]*@)\\b';

block.html = replace(block.html)
  ('comment', /<!--[\s\S]*?-->/)
  ('closed', /<(tag)[\s\S]+?<\/\1>/)
  ('closing', /<tag(?:"[^"]*"|'[^']*'|[^'">])*?>/)
  (/tag/g, block._tag)
  ();

block.paragraph = replace(block.paragraph)
  ('hr', block.hr)
  ('heading', block.heading)
  ('lheading', block.lheading)
  ('blockquote', block.blockquote)
  ('tag', '<' + block._tag)
  ('def', block.def)
  ();

/**
 * Normal Block Grammar
 */

block.normal = merge({}, block);

/**
 * GFM Block Grammar
 */

block.gfm = merge({}, block.normal, {
  fences: /^ *(`{3,}|~{3,})[ \.]*(\S+)? *\n([\s\S]+?)\s*\1 *(?:\n+|$)/,
  paragraph: /^/,
  heading: /^ *(#{1,6}) +([^\n]+?) *#* *(?:\n+|$)/
});

block.gfm.paragraph = replace(block.paragraph)
  ('(?!', '(?!'
    + block.gfm.fences.source.replace('\\1', '\\2') + '|'
    + block.list.source.replace('\\1', '\\3') + '|')
  ();

/**
 * GFM + Tables Block Grammar
 */

block.tables = merge({}, block.gfm, {
  nptable: /^ *(\S.*\|.*)\n *([-:]+ *\|[-| :]*)\n((?:.*\|.*(?:\n|$))*)\n*/,
  table: /^ *\|(.+)\n *\|( *[-:]+[-| :]*)\n((?: *\|.*(?:\n|$))*)\n*/
});

/**
 * Block Lexer
 */

function Lexer(options) {
  this.tokens = [];
  this.tokens.links = {};
  this.options = options || marked.defaults;
  this.rules = block.normal;

  if (this.options.gfm) {
    if (this.options.tables) {
      this.rules = block.tables;
    } else {
      this.rules = block.gfm;
    }
  }
}

/**
 * Expose Block Rules
 */

Lexer.rules = block;

/**
 * Static Lex Method
 */

Lexer.lex = function(src, options) {
  var lexer = new Lexer(options);
  return lexer.lex(src);
};

/**
 * Preprocessing
 */

Lexer.prototype.lex = function(src) {
  src = src
    .replace(/\r\n|\r/g, '\n')
    .replace(/\t/g, '    ')
    .replace(/\u00a0/g, ' ')
    .replace(/\u2424/g, '\n');

  return this.token(src, true);
};

/**
 * Lexing
 */

Lexer.prototype.token = function(src, top, bq) {
  var src = src.replace(/^ +$/gm, '')
    , next
    , loose
    , cap
    , bull
    , b
    , item
    , space
    , i
    , l;

  while (src) {
    // newline
    if (cap = this.rules.newline.exec(src)) {
      src = src.substring(cap[0].length);
      if (cap[0].length > 1) {
        this.tokens.push({
          type: 'space'
        });
      }
    }

    // code
    if (cap = this.rules.code.exec(src)) {
      src = src.substring(cap[0].length);
      cap = cap[0].replace(/^ {4}/gm, '');
      this.tokens.push({
        type: 'code',
        text: !this.options.pedantic
          ? cap.replace(/\n+$/, '')
          : cap
      });
      continue;
    }

    // fences (gfm)
    if (cap = this.rules.fences.exec(src)) {
      src = src.substring(cap[0].length);
      this.tokens.push({
        type: 'code',
        lang: cap[2],
        text: cap[3]
      });
      continue;
    }

    // heading
    if (cap = this.rules.heading.exec(src)) {
      src = src.substring(cap[0].length);
      this.tokens.push({
        type: 'heading',
        depth: cap[1].length,
        text: cap[2]
      });
      continue;
    }

    // table no leading pipe (gfm)
    if (top && (cap = this.rules.nptable.exec(src))) {
      src = src.substring(cap[0].length);

      item = {
        type: 'table',
        header: cap[1].replace(/^ *| *\| *$/g, '').split(/ *\| */),
        align: cap[2].replace(/^ *|\| *$/g, '').split(/ *\| */),
        cells: cap[3].replace(/\n$/, '').split('\n')
      };

      for (i = 0; i < item.align.length; i++) {
        if (/^ *-+: *$/.test(item.align[i])) {
          item.align[i] = 'right';
        } else if (/^ *:-+: *$/.test(item.align[i])) {
          item.align[i] = 'center';
        } else if (/^ *:-+ *$/.test(item.align[i])) {
          item.align[i] = 'left';
        } else {
          item.align[i] = null;
        }
      }

      for (i = 0; i < item.cells.length; i++) {
        item.cells[i] = item.cells[i].split(/ *\| */);
      }

      this.tokens.push(item);

      continue;
    }

    // lheading
    if (cap = this.rules.lheading.exec(src)) {
      src = src.substring(cap[0].length);
      this.tokens.push({
        type: 'heading',
        depth: cap[2] === '=' ? 1 : 2,
        text: cap[1]
      });
      continue;
    }

    // hr
    if (cap = this.rules.hr.exec(src)) {
      src = src.substring(cap[0].length);
      this.tokens.push({
        type: 'hr'
      });
      continue;
    }

    // blockquote
    if (cap = this.rules.blockquote.exec(src)) {
      src = src.substring(cap[0].length);

      this.tokens.push({
        type: 'blockquote_start'
      });

      cap = cap[0].replace(/^ *> ?/gm, '');

      // Pass `top` to keep the current
      // "toplevel" state. This is exactly
      // how markdown.pl works.
      this.token(cap, top, true);

      this.tokens.push({
        type: 'blockquote_end'
      });

      continue;
    }

    // list
    if (cap = this.rules.list.exec(src)) {
      src = src.substring(cap[0].length);
      bull = cap[2];

      this.tokens.push({
        type: 'list_start',
        ordered: bull.length > 1
      });

      // Get each top-level item.
      cap = cap[0].match(this.rules.item);

      next = false;
      l = cap.length;
      i = 0;

      for (; i < l; i++) {
        item = cap[i];

        // Remove the list item's bullet
        // so it is seen as the next token.
        space = item.length;
        item = item.replace(/^ *([*+-]|\d+\.) +/, '');

        // Outdent whatever the
        // list item contains. Hacky.
        if (~item.indexOf('\n ')) {
          space -= item.length;
          item = !this.options.pedantic
            ? item.replace(new RegExp('^ {1,' + space + '}', 'gm'), '')
            : item.replace(/^ {1,4}/gm, '');
        }

        // Determine whether the next list item belongs here.
        // Backpedal if it does not belong in this list.
        if (this.options.smartLists && i !== l - 1) {
          b = block.bullet.exec(cap[i + 1])[0];
          if (bull !== b && !(bull.length > 1 && b.length > 1)) {
            src = cap.slice(i + 1).join('\n') + src;
            i = l - 1;
          }
        }

        // Determine whether item is loose or not.
        // Use: /(^|\n)(?! )[^\n]+\n\n(?!\s*$)/
        // for discount behavior.
        loose = next || /\n\n(?!\s*$)/.test(item);
        if (i !== l - 1) {
          next = item.charAt(item.length - 1) === '\n';
          if (!loose) loose = next;
        }

        this.tokens.push({
          type: loose
            ? 'loose_item_start'
            : 'list_item_start'
        });

        // Recurse.
        this.token(item, false, bq);

        this.tokens.push({
          type: 'list_item_end'
        });
      }

      this.tokens.push({
        type: 'list_end'
      });

      continue;
    }

    // html
    if (cap = this.rules.html.exec(src)) {
      src = src.substring(cap[0].length);
      this.tokens.push({
        type: this.options.sanitize
          ? 'paragraph'
          : 'html',
        pre: !this.options.sanitizer
          && (cap[1] === 'pre' || cap[1] === 'script' || cap[1] === 'style'),
        text: cap[0]
      });
      continue;
    }

    // def
    if ((!bq && top) && (cap = this.rules.def.exec(src))) {
      src = src.substring(cap[0].length);
      this.tokens.links[cap[1].toLowerCase()] = {
        href: cap[2],
        title: cap[3]
      };
      continue;
    }

    // table (gfm)
    if (top && (cap = this.rules.table.exec(src))) {
      src = src.substring(cap[0].length);

      item = {
        type: 'table',
        header: cap[1].replace(/^ *| *\| *$/g, '').split(/ *\| */),
        align: cap[2].replace(/^ *|\| *$/g, '').split(/ *\| */),
        cells: cap[3].replace(/(?: *\| *)?\n$/, '').split('\n')
      };

      for (i = 0; i < item.align.length; i++) {
        if (/^ *-+: *$/.test(item.align[i])) {
          item.align[i] = 'right';
        } else if (/^ *:-+: *$/.test(item.align[i])) {
          item.align[i] = 'center';
        } else if (/^ *:-+ *$/.test(item.align[i])) {
          item.align[i] = 'left';
        } else {
          item.align[i] = null;
        }
      }

      for (i = 0; i < item.cells.length; i++) {
        item.cells[i] = item.cells[i]
          .replace(/^ *\| *| *\| *$/g, '')
          .split(/ *\| */);
      }

      this.tokens.push(item);

      continue;
    }

    // top-level paragraph
    if (top && (cap = this.rules.paragraph.exec(src))) {
      src = src.substring(cap[0].length);
      this.tokens.push({
        type: 'paragraph',
        text: cap[1].charAt(cap[1].length - 1) === '\n'
          ? cap[1].slice(0, -1)
          : cap[1]
      });
      continue;
    }

    // text
    if (cap = this.rules.text.exec(src)) {
      // Top-level should never reach here.
      src = src.substring(cap[0].length);
      this.tokens.push({
        type: 'text',
        text: cap[0]
      });
      continue;
    }

    if (src) {
      throw new
        Error('Infinite loop on byte: ' + src.charCodeAt(0));
    }
  }

  return this.tokens;
};

/**
 * Inline-Level Grammar
 */

var inline = {
  escape: /^\\([\\`*{}\[\]()#+\-.!_>])/,
  autolink: /^<([^ >]+(@|:\/)[^ >]+)>/,
  url: noop,
  tag: /^<!--[\s\S]*?-->|^<\/?\w+(?:"[^"]*"|'[^']*'|[^'">])*?>/,
  link: /^!?\[(inside)\]\(href\)/,
  reflink: /^!?\[(inside)\]\s*\[([^\]]*)\]/,
  nolink: /^!?\[((?:\[[^\]]*\]|[^\[\]])*)\]/,
  strong: /^__([\s\S]+?)__(?!_)|^\*\*([\s\S]+?)\*\*(?!\*)/,
  em: /^\b_((?:__|[\s\S])+?)_\b|^\*((?:\*\*|[\s\S])+?)\*(?!\*)/,
  code: /^(`+)\s*([\s\S]*?[^`])\s*\1(?!`)/,
  br: /^ {2,}\n(?!\s*$)/,
  del: noop,
  text: /^[\s\S]+?(?=[\\<!\[_*`]| {2,}\n|$)/
};

inline._inside = /(?:\[[^\]]*\]|[^\[\]]|\](?=[^\[]*\]))*/;
inline._href = /\s*<?([\s\S]*?)>?(?:\s+['"]([\s\S]*?)['"])?\s*/;

inline.link = replace(inline.link)
  ('inside', inline._inside)
  ('href', inline._href)
  ();

inline.reflink = replace(inline.reflink)
  ('inside', inline._inside)
  ();

/**
 * Normal Inline Grammar
 */

inline.normal = merge({}, inline);

/**
 * Pedantic Inline Grammar
 */

inline.pedantic = merge({}, inline.normal, {
  strong: /^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,
  em: /^_(?=\S)([\s\S]*?\S)_(?!_)|^\*(?=\S)([\s\S]*?\S)\*(?!\*)/
});

/**
 * GFM Inline Grammar
 */

inline.gfm = merge({}, inline.normal, {
  escape: replace(inline.escape)('])', '~|])')(),
  url: /^(https?:\/\/[^\s<]+[^<.,:;"')\]\s])/,
  del: /^~~(?=\S)([\s\S]*?\S)~~/,
  text: replace(inline.text)
    (']|', '~]|')
    ('|', '|https?://|')
    ()
});

/**
 * GFM + Line Breaks Inline Grammar
 */

inline.breaks = merge({}, inline.gfm, {
  br: replace(inline.br)('{2,}', '*')(),
  text: replace(inline.gfm.text)('{2,}', '*')()
});

/**
 * Inline Lexer & Compiler
 */

function InlineLexer(links, options) {
  this.options = options || marked.defaults;
  this.links = links;
  this.rules = inline.normal;
  this.renderer = this.options.renderer || new Renderer;
  this.renderer.options = this.options;

  if (!this.links) {
    throw new
      Error('Tokens array requires a `links` property.');
  }

  if (this.options.gfm) {
    if (this.options.breaks) {
      this.rules = inline.breaks;
    } else {
      this.rules = inline.gfm;
    }
  } else if (this.options.pedantic) {
    this.rules = inline.pedantic;
  }
}

/**
 * Expose Inline Rules
 */

InlineLexer.rules = inline;

/**
 * Static Lexing/Compiling Method
 */

InlineLexer.output = function(src, links, options) {
  var inline = new InlineLexer(links, options);
  return inline.output(src);
};

/**
 * Lexing/Compiling
 */

InlineLexer.prototype.output = function(src) {
  var out = ''
    , link
    , text
    , href
    , cap;

  while (src) {
    // escape
    if (cap = this.rules.escape.exec(src)) {
      src = src.substring(cap[0].length);
      out += cap[1];
      continue;
    }

    // autolink
    if (cap = this.rules.autolink.exec(src)) {
      src = src.substring(cap[0].length);
      if (cap[2] === '@') {
        text = cap[1].charAt(6) === ':'
          ? this.mangle(cap[1].substring(7))
          : this.mangle(cap[1]);
        href = this.mangle('mailto:') + text;
      } else {
        text = escape(cap[1]);
        href = text;
      }
      out += this.renderer.link(href, null, text);
      continue;
    }

    // url (gfm)
    if (!this.inLink && (cap = this.rules.url.exec(src))) {
      src = src.substring(cap[0].length);
      text = escape(cap[1]);
      href = text;
      out += this.renderer.link(href, null, text);
      continue;
    }

    // tag
    if (cap = this.rules.tag.exec(src)) {
      if (!this.inLink && /^<a /i.test(cap[0])) {
        this.inLink = true;
      } else if (this.inLink && /^<\/a>/i.test(cap[0])) {
        this.inLink = false;
      }
      src = src.substring(cap[0].length);
      out += this.options.sanitize
        ? this.options.sanitizer
          ? this.options.sanitizer(cap[0])
          : escape(cap[0])
        : cap[0]
      continue;
    }

    // link
    if (cap = this.rules.link.exec(src)) {
      src = src.substring(cap[0].length);
      this.inLink = true;
      out += this.outputLink(cap, {
        href: cap[2],
        title: cap[3]
      });
      this.inLink = false;
      continue;
    }

    // reflink, nolink
    if ((cap = this.rules.reflink.exec(src))
        || (cap = this.rules.nolink.exec(src))) {
      src = src.substring(cap[0].length);
      link = (cap[2] || cap[1]).replace(/\s+/g, ' ');
      link = this.links[link.toLowerCase()];
      if (!link || !link.href) {
        out += cap[0].charAt(0);
        src = cap[0].substring(1) + src;
        continue;
      }
      this.inLink = true;
      out += this.outputLink(cap, link);
      this.inLink = false;
      continue;
    }

    // strong
    if (cap = this.rules.strong.exec(src)) {
      src = src.substring(cap[0].length);
      out += this.renderer.strong(this.output(cap[2] || cap[1]));
      continue;
    }

    // em
    if (cap = this.rules.em.exec(src)) {
      src = src.substring(cap[0].length);
      out += this.renderer.em(this.output(cap[2] || cap[1]));
      continue;
    }

    // code
    if (cap = this.rules.code.exec(src)) {
      src = src.substring(cap[0].length);
      out += this.renderer.codespan(escape(cap[2], true));
      continue;
    }

    // br
    if (cap = this.rules.br.exec(src)) {
      src = src.substring(cap[0].length);
      out += this.renderer.br();
      continue;
    }

    // del (gfm)
    if (cap = this.rules.del.exec(src)) {
      src = src.substring(cap[0].length);
      out += this.renderer.del(this.output(cap[1]));
      continue;
    }

    // text
    if (cap = this.rules.text.exec(src)) {
      src = src.substring(cap[0].length);
      out += this.renderer.text(escape(this.smartypants(cap[0])));
      continue;
    }

    if (src) {
      throw new
        Error('Infinite loop on byte: ' + src.charCodeAt(0));
    }
  }

  return out;
};

/**
 * Compile Link
 */

InlineLexer.prototype.outputLink = function(cap, link) {
  var href = escape(link.href)
    , title = link.title ? escape(link.title) : null;

  return cap[0].charAt(0) !== '!'
    ? this.renderer.link(href, title, this.output(cap[1]))
    : this.renderer.image(href, title, escape(cap[1]));
};

/**
 * Smartypants Transformations
 */

InlineLexer.prototype.smartypants = function(text) {
  if (!this.options.smartypants) return text;
  return text
    // em-dashes
    .replace(/---/g, '\u2014')
    // en-dashes
    .replace(/--/g, '\u2013')
    // opening singles
    .replace(/(^|[-\u2014/(\[{"\s])'/g, '$1\u2018')
    // closing singles & apostrophes
    .replace(/'/g, '\u2019')
    // opening doubles
    .replace(/(^|[-\u2014/(\[{\u2018\s])"/g, '$1\u201c')
    // closing doubles
    .replace(/"/g, '\u201d')
    // ellipses
    .replace(/\.{3}/g, '\u2026');
};

/**
 * Mangle Links
 */

InlineLexer.prototype.mangle = function(text) {
  if (!this.options.mangle) return text;
  var out = ''
    , l = text.length
    , i = 0
    , ch;

  for (; i < l; i++) {
    ch = text.charCodeAt(i);
    if (Math.random() > 0.5) {
      ch = 'x' + ch.toString(16);
    }
    out += '&#' + ch + ';';
  }

  return out;
};

/**
 * Renderer
 */

function Renderer(options) {
  this.options = options || {};
}

Renderer.prototype.code = function(code, lang, escaped) {
  if (this.options.highlight) {
    var out = this.options.highlight(code, lang);
    if (out != null && out !== code) {
      escaped = true;
      code = out;
    }
  }

  if (!lang) {
    return '<pre><code>'
      + (escaped ? code : escape(code, true))
      + '\n</code></pre>';
  }

  return '<pre><code class="'
    + this.options.langPrefix
    + escape(lang, true)
    + '">'
    + (escaped ? code : escape(code, true))
    + '\n</code></pre>\n';
};

Renderer.prototype.blockquote = function(quote) {
  return '<blockquote>\n' + quote + '</blockquote>\n';
};

Renderer.prototype.html = function(html) {
  return html;
};

Renderer.prototype.heading = function(text, level, raw) {
  return '<h'
    + level
    + ' id="'
    + this.options.headerPrefix
    + raw.toLowerCase().replace(/[^\w]+/g, '-')
    + '">'
    + text
    + '</h'
    + level
    + '>\n';
};

Renderer.prototype.hr = function() {
  return this.options.xhtml ? '<hr/>\n' : '<hr>\n';
};

Renderer.prototype.list = function(body, ordered) {
  var type = ordered ? 'ol' : 'ul';
  return '<' + type + '>\n' + body + '</' + type + '>\n';
};

Renderer.prototype.listitem = function(text) {
  return '<li>' + text + '</li>\n';
};

Renderer.prototype.paragraph = function(text) {
  return '<p>' + text + '</p>\n';
};

Renderer.prototype.table = function(header, body) {
  return '<table>\n'
    + '<thead>\n'
    + header
    + '</thead>\n'
    + '<tbody>\n'
    + body
    + '</tbody>\n'
    + '</table>\n';
};

Renderer.prototype.tablerow = function(content) {
  return '<tr>\n' + content + '</tr>\n';
};

Renderer.prototype.tablecell = function(content, flags) {
  var type = flags.header ? 'th' : 'td';
  var tag = flags.align
    ? '<' + type + ' style="text-align:' + flags.align + '">'
    : '<' + type + '>';
  return tag + content + '</' + type + '>\n';
};

// span level renderer
Renderer.prototype.strong = function(text) {
  return '<strong>' + text + '</strong>';
};

Renderer.prototype.em = function(text) {
  return '<em>' + text + '</em>';
};

Renderer.prototype.codespan = function(text) {
  return '<code>' + text + '</code>';
};

Renderer.prototype.br = function() {
  return this.options.xhtml ? '<br/>' : '<br>';
};

Renderer.prototype.del = function(text) {
  return '<del>' + text + '</del>';
};

Renderer.prototype.link = function(href, title, text) {
  if (this.options.sanitize) {
    try {
      var prot = decodeURIComponent(unescape(href))
        .replace(/[^\w:]/g, '')
        .toLowerCase();
    } catch (e) {
      return '';
    }
    if (prot.indexOf('javascript:') === 0 || prot.indexOf('vbscript:') === 0) {
      return '';
    }
  }
  var out = '<a href="' + href + '"';
  if (title) {
    out += ' title="' + title + '"';
  }
  out += '>' + text + '</a>';
  return out;
};

Renderer.prototype.image = function(href, title, text) {
  var out = '<img src="' + href + '" alt="' + text + '"';
  if (title) {
    out += ' title="' + title + '"';
  }
  out += this.options.xhtml ? '/>' : '>';
  return out;
};

Renderer.prototype.text = function(text) {
  return text;
};

/**
 * Parsing & Compiling
 */

function Parser(options) {
  this.tokens = [];
  this.token = null;
  this.options = options || marked.defaults;
  this.options.renderer = this.options.renderer || new Renderer;
  this.renderer = this.options.renderer;
  this.renderer.options = this.options;
}

/**
 * Static Parse Method
 */

Parser.parse = function(src, options, renderer) {
  var parser = new Parser(options, renderer);
  return parser.parse(src);
};

/**
 * Parse Loop
 */

Parser.prototype.parse = function(src) {
  this.inline = new InlineLexer(src.links, this.options, this.renderer);
  this.tokens = src.reverse();

  var out = '';
  while (this.next()) {
    out += this.tok();
  }

  return out;
};

/**
 * Next Token
 */

Parser.prototype.next = function() {
  return this.token = this.tokens.pop();
};

/**
 * Preview Next Token
 */

Parser.prototype.peek = function() {
  return this.tokens[this.tokens.length - 1] || 0;
};

/**
 * Parse Text Tokens
 */

Parser.prototype.parseText = function() {
  var body = this.token.text;

  while (this.peek().type === 'text') {
    body += '\n' + this.next().text;
  }

  return this.inline.output(body);
};

/**
 * Parse Current Token
 */

Parser.prototype.tok = function() {
  switch (this.token.type) {
    case 'space': {
      return '';
    }
    case 'hr': {
      return this.renderer.hr();
    }
    case 'heading': {
      return this.renderer.heading(
        this.inline.output(this.token.text),
        this.token.depth,
        this.token.text);
    }
    case 'code': {
      return this.renderer.code(this.token.text,
        this.token.lang,
        this.token.escaped);
    }
    case 'table': {
      var header = ''
        , body = ''
        , i
        , row
        , cell
        , flags
        , j;

      // header
      cell = '';
      for (i = 0; i < this.token.header.length; i++) {
        flags = { header: true, align: this.token.align[i] };
        cell += this.renderer.tablecell(
          this.inline.output(this.token.header[i]),
          { header: true, align: this.token.align[i] }
        );
      }
      header += this.renderer.tablerow(cell);

      for (i = 0; i < this.token.cells.length; i++) {
        row = this.token.cells[i];

        cell = '';
        for (j = 0; j < row.length; j++) {
          cell += this.renderer.tablecell(
            this.inline.output(row[j]),
            { header: false, align: this.token.align[j] }
          );
        }

        body += this.renderer.tablerow(cell);
      }
      return this.renderer.table(header, body);
    }
    case 'blockquote_start': {
      var body = '';

      while (this.next().type !== 'blockquote_end') {
        body += this.tok();
      }

      return this.renderer.blockquote(body);
    }
    case 'list_start': {
      var body = ''
        , ordered = this.token.ordered;

      while (this.next().type !== 'list_end') {
        body += this.tok();
      }

      return this.renderer.list(body, ordered);
    }
    case 'list_item_start': {
      var body = '';

      while (this.next().type !== 'list_item_end') {
        body += this.token.type === 'text'
          ? this.parseText()
          : this.tok();
      }

      return this.renderer.listitem(body);
    }
    case 'loose_item_start': {
      var body = '';

      while (this.next().type !== 'list_item_end') {
        body += this.tok();
      }

      return this.renderer.listitem(body);
    }
    case 'html': {
      var html = !this.token.pre && !this.options.pedantic
        ? this.inline.output(this.token.text)
        : this.token.text;
      return this.renderer.html(html);
    }
    case 'paragraph': {
      return this.renderer.paragraph(this.inline.output(this.token.text));
    }
    case 'text': {
      return this.renderer.paragraph(this.parseText());
    }
  }
};

/**
 * Helpers
 */

function escape(html, encode) {
  return html
    .replace(!encode ? /&(?!#?\w+;)/g : /&/g, '&amp;')
    .replace(/</g, '&lt;')
    .replace(/>/g, '&gt;')
    .replace(/"/g, '&quot;')
    .replace(/'/g, '&#39;');
}

function unescape(html) {
  return html.replace(/&([#\w]+);/g, function(_, n) {
    n = n.toLowerCase();
    if (n === 'colon') return ':';
    if (n.charAt(0) === '#') {
      return n.charAt(1) === 'x'
        ? String.fromCharCode(parseInt(n.substring(2), 16))
        : String.fromCharCode(+n.substring(1));
    }
    return '';
  });
}

function replace(regex, opt) {
  regex = regex.source;
  opt = opt || '';
  return function self(name, val) {
    if (!name) return new RegExp(regex, opt);
    val = val.source || val;
    val = val.replace(/(^|[^\[])\^/g, '$1');
    regex = regex.replace(name, val);
    return self;
  };
}

function noop() {}
noop.exec = noop;

function merge(obj) {
  var i = 1
    , target
    , key;

  for (; i < arguments.length; i++) {
    target = arguments[i];
    for (key in target) {
      if (Object.prototype.hasOwnProperty.call(target, key)) {
        obj[key] = target[key];
      }
    }
  }

  return obj;
}


/**
 * Marked
 */

function marked(src, opt, callback) {
  if (callback || typeof opt === 'function') {
    if (!callback) {
      callback = opt;
      opt = null;
    }

    opt = merge({}, marked.defaults, opt || {});

    var highlight = opt.highlight
      , tokens
      , pending
      , i = 0;

    try {
      tokens = Lexer.lex(src, opt)
    } catch (e) {
      return callback(e);
    }

    pending = tokens.length;

    var done = function(err) {
      if (err) {
        opt.highlight = highlight;
        return callback(err);
      }

      var out;

      try {
        out = Parser.parse(tokens, opt);
      } catch (e) {
        err = e;
      }

      opt.highlight = highlight;

      return err
        ? callback(err)
        : callback(null, out);
    };

    if (!highlight || highlight.length < 3) {
      return done();
    }

    delete opt.highlight;

    if (!pending) return done();

    for (; i < tokens.length; i++) {
      (function(token) {
        if (token.type !== 'code') {
          return --pending || done();
        }
        return highlight(token.text, token.lang, function(err, code) {
          if (err) return done(err);
          if (code == null || code === token.text) {
            return --pending || done();
          }
          token.text = code;
          token.escaped = true;
          --pending || done();
        });
      })(tokens[i]);
    }

    return;
  }
  try {
    if (opt) opt = merge({}, marked.defaults, opt);
    return Parser.parse(Lexer.lex(src, opt), opt);
  } catch (e) {
    e.message += '\nPlease report this to https://github.com/chjj/marked.';
    if ((opt || marked.defaults).silent) {
      return '<p>An error occured:</p><pre>'
        + escape(e.message + '', true)
        + '</pre>';
    }
    throw e;
  }
}

/**
 * Options
 */

marked.options =
marked.setOptions = function(opt) {
  merge(marked.defaults, opt);
  return marked;
};

marked.defaults = {
  gfm: true,
  tables: true,
  breaks: false,
  pedantic: false,
  sanitize: false,
  sanitizer: null,
  mangle: true,
  smartLists: false,
  silent: false,
  highlight: null,
  langPrefix: 'lang-',
  smartypants: false,
  headerPrefix: '',
  renderer: new Renderer,
  xhtml: false
};

/**
 * Expose
 */

marked.Parser = Parser;
marked.parser = Parser.parse;

marked.Renderer = Renderer;

marked.Lexer = Lexer;
marked.lexer = Lexer.lex;

marked.InlineLexer = InlineLexer;
marked.inlineLexer = InlineLexer.output;

marked.parse = marked;

if (typeof module !== 'undefined' && typeof exports === 'object') {
  module.exports = marked;
} else if (typeof define === 'function' && define.amd) {
  define(function() { return marked; });
} else {
  this.marked = marked;
}

}).call(function() {
  return this || (typeof window !== 'undefined' ? window : global);
}());
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/marked',_glass_html_marked_);
    else
      _glass_html_marked_.call(this, module, exports, require);
  }
  else {
    _glass_html_marked_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_AlertDialog_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('./');
var Dialog = _ref.Dialog;
var Button = _ref.Button;
var AlertDialog = ion.template(function AlertDialog(_ref2) {
        return ion.createRuntime({
            type: 'Template',
            id: {
                type: 'Identifier',
                name: 'AlertDialog',
                loc: {
                    start: {
                        line: 3,
                        column: 15,
                        fixed: true,
                        source: 'glass/html/material/AlertDialog.ion'
                    },
                    end: {
                        line: 3,
                        column: 26,
                        fixed: true,
                        source: 'glass/html/material/AlertDialog.ion'
                    }
                }
            },
            body: [
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'title',
                                loc: {
                                    start: {
                                        line: 3,
                                        column: 28,
                                        fixed: true,
                                        source: 'glass/html/material/AlertDialog.ion'
                                    },
                                    end: {
                                        line: 3,
                                        column: 33,
                                        fixed: true,
                                        source: 'glass/html/material/AlertDialog.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref2'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'title',
                                    loc: {
                                        start: {
                                            line: 3,
                                            column: 28,
                                            fixed: true,
                                            source: 'glass/html/material/AlertDialog.ion'
                                        },
                                        end: {
                                            line: 3,
                                            column: 33,
                                            fixed: true,
                                            source: 'glass/html/material/AlertDialog.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '0'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'callback',
                                loc: {
                                    start: {
                                        line: 3,
                                        column: 35,
                                        fixed: true,
                                        source: 'glass/html/material/AlertDialog.ion'
                                    },
                                    end: {
                                        line: 3,
                                        column: 43,
                                        fixed: true,
                                        source: 'glass/html/material/AlertDialog.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref2'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'callback',
                                    loc: {
                                        start: {
                                            line: 3,
                                            column: 35,
                                            fixed: true,
                                            source: 'glass/html/material/AlertDialog.ion'
                                        },
                                        end: {
                                            line: 3,
                                            column: 43,
                                            fixed: true,
                                            source: 'glass/html/material/AlertDialog.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '1'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'text',
                                loc: {
                                    start: {
                                        line: 3,
                                        column: 45,
                                        fixed: true,
                                        source: 'glass/html/material/AlertDialog.ion'
                                    },
                                    end: {
                                        line: 3,
                                        column: 49,
                                        fixed: true,
                                        source: 'glass/html/material/AlertDialog.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref2'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'text',
                                    loc: {
                                        start: {
                                            line: 3,
                                            column: 45,
                                            fixed: true,
                                            source: 'glass/html/material/AlertDialog.ion'
                                        },
                                        end: {
                                            line: 3,
                                            column: 49,
                                            fixed: true,
                                            source: 'glass/html/material/AlertDialog.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '2'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'style',
                                loc: {
                                    start: {
                                        line: 3,
                                        column: 51,
                                        fixed: true,
                                        source: 'glass/html/material/AlertDialog.ion'
                                    },
                                    end: {
                                        line: 3,
                                        column: 56,
                                        fixed: true,
                                        source: 'glass/html/material/AlertDialog.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref2'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'style',
                                    loc: {
                                        start: {
                                            line: 3,
                                            column: 51,
                                            fixed: true,
                                            source: 'glass/html/material/AlertDialog.ion'
                                        },
                                        end: {
                                            line: 3,
                                            column: 56,
                                            fixed: true,
                                            source: 'glass/html/material/AlertDialog.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '3'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'dialog',
                                loc: {
                                    start: {
                                        line: 4,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/AlertDialog.ion'
                                    },
                                    end: {
                                        line: 4,
                                        column: 14,
                                        fixed: true,
                                        source: 'glass/html/material/AlertDialog.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Dialog',
                                    loc: {
                                        start: {
                                            line: 4,
                                            column: 17,
                                            fixed: true,
                                            source: 'glass/html/material/AlertDialog.ion'
                                        },
                                        end: {
                                            line: 4,
                                            column: 23,
                                            fixed: true,
                                            source: 'glass/html/material/AlertDialog.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'class',
                                                    loc: {
                                                        start: {
                                                            line: 4,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'glass/html/material/AlertDialog.ion'
                                                        },
                                                        end: {
                                                            line: 4,
                                                            column: 30,
                                                            fixed: true,
                                                            source: 'glass/html/material/AlertDialog.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: 'layout vertical'
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    }],
                                loc: {
                                    start: {
                                        line: 4,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/html/material/AlertDialog.ion'
                                    },
                                    end: {
                                        line: 4,
                                        column: 50,
                                        fixed: true,
                                        source: 'glass/html/material/AlertDialog.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '4'
                },
                {
                    type: 'ReturnStatement',
                    argument: {
                        type: 'ObjectExpression',
                        objectType: {
                            type: 'Identifier',
                            name: 'dialog',
                            loc: {
                                start: {
                                    line: 5,
                                    column: 11,
                                    fixed: true,
                                    source: 'glass/html/material/AlertDialog.ion'
                                },
                                end: {
                                    line: 5,
                                    column: 17,
                                    fixed: true,
                                    source: 'glass/html/material/AlertDialog.ion'
                                }
                            }
                        },
                        properties: [{
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'frame',
                                    loc: {
                                        start: {
                                            line: 6,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/AlertDialog.ion'
                                        },
                                        end: {
                                            line: 6,
                                            column: 13,
                                            fixed: true,
                                            source: 'glass/html/material/AlertDialog.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'ObjectExpression',
                                    properties: [
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'style',
                                                loc: {
                                                    start: {
                                                        line: 7,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/AlertDialog.ion'
                                                    },
                                                    end: {
                                                        line: 7,
                                                        column: 17,
                                                        fixed: true,
                                                        source: 'glass/html/material/AlertDialog.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'ObjectExpression',
                                                properties: [
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'padding',
                                                            loc: {
                                                                start: {
                                                                    line: 8,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/AlertDialog.ion'
                                                                },
                                                                end: {
                                                                    line: 8,
                                                                    column: 23,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/AlertDialog.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Literal',
                                                            value: '0px'
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'width',
                                                            loc: {
                                                                start: {
                                                                    line: 9,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/AlertDialog.ion'
                                                                },
                                                                end: {
                                                                    line: 9,
                                                                    column: 21,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/AlertDialog.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Literal',
                                                            value: '400px'
                                                        },
                                                        kind: 'init',
                                                        order: '1'
                                                    },
                                                    {
                                                        type: 'IfStatement',
                                                        test: {
                                                            type: 'UnaryExpression',
                                                            operator: '?',
                                                            argument: {
                                                                type: 'Identifier',
                                                                name: 'style',
                                                                loc: {
                                                                    start: {
                                                                        line: 10,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/AlertDialog.ion'
                                                                    },
                                                                    end: {
                                                                        line: 10,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/AlertDialog.ion'
                                                                    }
                                                                }
                                                            }
                                                        },
                                                        consequent: {
                                                            type: 'BlockStatement',
                                                            body: [{
                                                                    type: 'ForInStatement',
                                                                    left: {
                                                                        type: 'VariableDeclaration',
                                                                        declarations: [
                                                                            {
                                                                                type: 'VariableDeclarator',
                                                                                id: {
                                                                                    type: 'Identifier',
                                                                                    name: 'key',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 11,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/AlertDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 11,
                                                                                            column: 27,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/AlertDialog.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                init: null
                                                                            },
                                                                            {
                                                                                type: 'VariableDeclarator',
                                                                                id: {
                                                                                    type: 'Identifier',
                                                                                    name: 'value',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 11,
                                                                                            column: 29,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/AlertDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 11,
                                                                                            column: 34,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/AlertDialog.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                init: null
                                                                            }
                                                                        ],
                                                                        kind: 'let'
                                                                    },
                                                                    right: {
                                                                        type: 'Identifier',
                                                                        name: 'style',
                                                                        loc: {
                                                                            start: {
                                                                                line: 11,
                                                                                column: 38,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/AlertDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 11,
                                                                                column: 43,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/AlertDialog.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    body: {
                                                                        type: 'BlockStatement',
                                                                        body: [{
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'key',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 12,
                                                                                            column: 25,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/AlertDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 12,
                                                                                            column: 28,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/AlertDialog.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Identifier',
                                                                                    name: 'value',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 12,
                                                                                            column: 31,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/AlertDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 12,
                                                                                            column: 36,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/AlertDialog.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                kind: 'init',
                                                                                computed: true,
                                                                                order: '0'
                                                                            }]
                                                                    },
                                                                    remove: null,
                                                                    order: '0'
                                                                }]
                                                        },
                                                        alternate: null,
                                                        order: '2'
                                                    }
                                                ]
                                            },
                                            kind: 'init',
                                            order: '0'
                                        },
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'ObjectExpression',
                                                objectType: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'Identifier',
                                                        name: 'Div',
                                                        loc: {
                                                            start: {
                                                                line: 13,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'glass/html/material/AlertDialog.ion'
                                                            },
                                                            end: {
                                                                line: 13,
                                                                column: 15,
                                                                fixed: true,
                                                                source: 'glass/html/material/AlertDialog.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [{
                                                            type: 'ObjectExpression',
                                                            properties: [{
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'class',
                                                                        loc: {
                                                                            start: {
                                                                                line: 13,
                                                                                column: 17,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/AlertDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 13,
                                                                                column: 22,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/AlertDialog.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Literal',
                                                                        value: 'content'
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                }]
                                                        }],
                                                    loc: {
                                                        start: {
                                                            line: 13,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/AlertDialog.ion'
                                                        },
                                                        end: {
                                                            line: 13,
                                                            column: 34,
                                                            fixed: true,
                                                            source: 'glass/html/material/AlertDialog.ion'
                                                        }
                                                    }
                                                },
                                                properties: [
                                                    {
                                                        type: 'IfStatement',
                                                        test: {
                                                            type: 'UnaryExpression',
                                                            operator: '?',
                                                            argument: {
                                                                type: 'Identifier',
                                                                name: 'title',
                                                                loc: {
                                                                    start: {
                                                                        line: 14,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/AlertDialog.ion'
                                                                    },
                                                                    end: {
                                                                        line: 14,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/AlertDialog.ion'
                                                                    }
                                                                }
                                                            }
                                                        },
                                                        consequent: {
                                                            type: 'BlockStatement',
                                                            body: [{
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'ObjectExpression',
                                                                        objectType: {
                                                                            type: 'CallExpression',
                                                                            callee: {
                                                                                type: 'Identifier',
                                                                                name: 'Div',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 15,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/AlertDialog.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 15,
                                                                                        column: 23,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/AlertDialog.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            arguments: [{
                                                                                    type: 'ObjectExpression',
                                                                                    properties: [{
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'class',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 15,
                                                                                                        column: 25,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/AlertDialog.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 15,
                                                                                                        column: 30,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/AlertDialog.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'Literal',
                                                                                                value: 'title'
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '0'
                                                                                        }]
                                                                                }],
                                                                            loc: {
                                                                                start: {
                                                                                    line: 15,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/AlertDialog.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 15,
                                                                                    column: 41,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/AlertDialog.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        properties: [{
                                                                                type: 'ExpressionStatement',
                                                                                expression: {
                                                                                    type: 'Identifier',
                                                                                    name: 'title',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 16,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/AlertDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 16,
                                                                                            column: 29,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/AlertDialog.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 16,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/AlertDialog.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 16,
                                                                                        column: 29,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/AlertDialog.ion'
                                                                                    }
                                                                                },
                                                                                order: '0'
                                                                            }]
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 15,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/AlertDialog.ion'
                                                                        },
                                                                        end: {
                                                                            line: 17,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/AlertDialog.ion'
                                                                        }
                                                                    },
                                                                    order: '0'
                                                                }]
                                                        },
                                                        alternate: null,
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'IfStatement',
                                                        test: {
                                                            type: 'UnaryExpression',
                                                            operator: '?',
                                                            argument: {
                                                                type: 'Identifier',
                                                                name: 'text',
                                                                loc: {
                                                                    start: {
                                                                        line: 17,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/AlertDialog.ion'
                                                                    },
                                                                    end: {
                                                                        line: 17,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/AlertDialog.ion'
                                                                    }
                                                                }
                                                            }
                                                        },
                                                        consequent: {
                                                            type: 'BlockStatement',
                                                            body: [{
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'ObjectExpression',
                                                                        objectType: {
                                                                            type: 'CallExpression',
                                                                            callee: {
                                                                                type: 'Identifier',
                                                                                name: 'Div',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 18,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/AlertDialog.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 18,
                                                                                        column: 23,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/AlertDialog.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            arguments: [{
                                                                                    type: 'ObjectExpression',
                                                                                    properties: [{
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'style',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 18,
                                                                                                        column: 25,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/AlertDialog.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 18,
                                                                                                        column: 30,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/AlertDialog.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'Literal',
                                                                                                value: 'font-size:14px'
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '0'
                                                                                        }]
                                                                                }],
                                                                            loc: {
                                                                                start: {
                                                                                    line: 18,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/AlertDialog.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 18,
                                                                                    column: 49,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/AlertDialog.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        properties: [{
                                                                                type: 'ExpressionStatement',
                                                                                expression: {
                                                                                    type: 'Identifier',
                                                                                    name: 'text',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 19,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/AlertDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 19,
                                                                                            column: 28,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/AlertDialog.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 19,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/AlertDialog.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 19,
                                                                                        column: 28,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/AlertDialog.ion'
                                                                                    }
                                                                                },
                                                                                order: '0'
                                                                            }]
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 18,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/AlertDialog.ion'
                                                                        },
                                                                        end: {
                                                                            line: 20,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/AlertDialog.ion'
                                                                        }
                                                                    },
                                                                    order: '0'
                                                                }]
                                                        },
                                                        alternate: null,
                                                        order: '1'
                                                    }
                                                ]
                                            },
                                            loc: {
                                                start: {
                                                    line: 13,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/AlertDialog.ion'
                                                },
                                                end: {
                                                    line: 20,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/html/material/AlertDialog.ion'
                                                }
                                            },
                                            order: '1'
                                        },
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'ObjectExpression',
                                                objectType: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'Identifier',
                                                        name: 'Footer',
                                                        loc: {
                                                            start: {
                                                                line: 20,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'glass/html/material/AlertDialog.ion'
                                                            },
                                                            end: {
                                                                line: 20,
                                                                column: 18,
                                                                fixed: true,
                                                                source: 'glass/html/material/AlertDialog.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [{
                                                            type: 'ObjectExpression',
                                                            properties: [{
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'class',
                                                                        loc: {
                                                                            start: {
                                                                                line: 20,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/AlertDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 20,
                                                                                column: 25,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/AlertDialog.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Literal',
                                                                        value: 'layout horizontal reverse'
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                }]
                                                        }],
                                                    loc: {
                                                        start: {
                                                            line: 20,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/AlertDialog.ion'
                                                        },
                                                        end: {
                                                            line: 20,
                                                            column: 55,
                                                            fixed: true,
                                                            source: 'glass/html/material/AlertDialog.ion'
                                                        }
                                                    }
                                                },
                                                properties: [
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'style',
                                                            loc: {
                                                                start: {
                                                                    line: 21,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/AlertDialog.ion'
                                                                },
                                                                end: {
                                                                    line: 21,
                                                                    column: 21,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/AlertDialog.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'ObjectExpression',
                                                            properties: [{
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'margin',
                                                                        loc: {
                                                                            start: {
                                                                                line: 22,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/AlertDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 22,
                                                                                column: 26,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/AlertDialog.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Literal',
                                                                        value: '8px 4px'
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                }]
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'ObjectExpression',
                                                            objectType: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Identifier',
                                                                    name: 'PaperButton',
                                                                    loc: {
                                                                        start: {
                                                                            line: 23,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/AlertDialog.ion'
                                                                        },
                                                                        end: {
                                                                            line: 23,
                                                                            column: 27,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/AlertDialog.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [],
                                                                loc: {
                                                                    start: {
                                                                        line: 23,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/AlertDialog.ion'
                                                                    },
                                                                    end: {
                                                                        line: 23,
                                                                        column: 29,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/AlertDialog.ion'
                                                                    }
                                                                }
                                                            },
                                                            properties: [
                                                                {
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'Function',
                                                                        context: true,
                                                                        value: function (_context) {
                                                                            return function click() {
                                                                                var dialog = _context.get('dialog'), callback = _context.get('callback');
                                                                                dialog.open = false;
                                                                                callback != null ? callback() : void 0;
                                                                            };
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 24,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/AlertDialog.ion'
                                                                        },
                                                                        end: {
                                                                            line: 27,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/AlertDialog.ion'
                                                                        }
                                                                    },
                                                                    order: '0'
                                                                },
                                                                {
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'Literal',
                                                                        value: 'OK'
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 27,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/AlertDialog.ion'
                                                                        },
                                                                        end: {
                                                                            line: 27,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/AlertDialog.ion'
                                                                        }
                                                                    },
                                                                    order: '1'
                                                                }
                                                            ]
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 23,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/AlertDialog.ion'
                                                            },
                                                            end: {
                                                                line: 29,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'glass/html/material/AlertDialog.ion'
                                                            }
                                                        },
                                                        order: '1'
                                                    }
                                                ]
                                            },
                                            loc: {
                                                start: {
                                                    line: 20,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/AlertDialog.ion'
                                                },
                                                end: {
                                                    line: 29,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/html/material/AlertDialog.ion'
                                                }
                                            },
                                            order: '2'
                                        }
                                    ]
                                },
                                kind: 'init',
                                order: '0'
                            }]
                    },
                    order: '5'
                }
            ],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'AlertDialog',
                loc: {
                    start: {
                        line: 3,
                        column: 15,
                        fixed: true,
                        source: 'glass/html/material/AlertDialog.ion'
                    },
                    end: {
                        line: 3,
                        column: 26,
                        fixed: true,
                        source: 'glass/html/material/AlertDialog.ion'
                    }
                }
            }
        }, {
            this: this,
            _ref2: _ref2,
            _ref: _ref,
            Dialog: Dialog,
            Button: Button,
            AlertDialog: AlertDialog,
            show: show
        }, null);
    });
var show = exports.show = function (args) {
        Dialog.show(AlertDialog, args);
    };
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/AlertDialog',_glass_html_material_AlertDialog_);
    else
      _glass_html_material_AlertDialog_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_AlertDialog_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_AutoCompleteInput_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('./');
var Menu = _ref.NewMenu;
var Shadow = _ref.Shadow;
var RecordItem = _ref.RecordItem;
module.exports = exports = ion.template(function AutoCompleteInput(_ref2) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'AutoCompleteInput',
            loc: {
                start: {
                    line: 5,
                    column: 16,
                    fixed: true,
                    source: 'glass/html/material/AutoCompleteInput.ion'
                },
                end: {
                    line: 5,
                    column: 33,
                    fixed: true,
                    source: 'glass/html/material/AutoCompleteInput.ion'
                }
            }
        },
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'notFoundMessage',
                            loc: {
                                start: {
                                    line: 5,
                                    column: 35,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                },
                                end: {
                                    line: 5,
                                    column: 50,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref2'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'notFoundMessage',
                                loc: {
                                    start: {
                                        line: 5,
                                        column: 35,
                                        fixed: true,
                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                    },
                                    end: {
                                        line: 5,
                                        column: 50,
                                        fixed: true,
                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'suggestionTemplate',
                            loc: {
                                start: {
                                    line: 5,
                                    column: 52,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                },
                                end: {
                                    line: 5,
                                    column: 70,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref2'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'suggestionTemplate',
                                loc: {
                                    start: {
                                        line: 5,
                                        column: 52,
                                        fixed: true,
                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                    },
                                    end: {
                                        line: 5,
                                        column: 70,
                                        fixed: true,
                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'label',
                            loc: {
                                start: {
                                    line: 5,
                                    column: 72,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                },
                                end: {
                                    line: 5,
                                    column: 77,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref2'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'label',
                                loc: {
                                    start: {
                                        line: 5,
                                        column: 72,
                                        fixed: true,
                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                    },
                                    end: {
                                        line: 5,
                                        column: 77,
                                        fixed: true,
                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'initialValue',
                            loc: {
                                start: {
                                    line: 5,
                                    column: 85,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                },
                                end: {
                                    line: 5,
                                    column: 97,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref2'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'value',
                                loc: {
                                    start: {
                                        line: 5,
                                        column: 79,
                                        fixed: true,
                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                    },
                                    end: {
                                        line: 5,
                                        column: 84,
                                        fixed: true,
                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '3'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'multiline',
                            loc: {
                                start: {
                                    line: 5,
                                    column: 99,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                },
                                end: {
                                    line: 5,
                                    column: 108,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref2'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'multiline',
                                loc: {
                                    start: {
                                        line: 5,
                                        column: 99,
                                        fixed: true,
                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                    },
                                    end: {
                                        line: 5,
                                        column: 108,
                                        fixed: true,
                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '4'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: '_inline',
                            loc: {
                                start: {
                                    line: 5,
                                    column: 117,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                },
                                end: {
                                    line: 5,
                                    column: 124,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref2'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'inline',
                                loc: {
                                    start: {
                                        line: 5,
                                        column: 110,
                                        fixed: true,
                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                    },
                                    end: {
                                        line: 5,
                                        column: 116,
                                        fixed: true,
                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '5'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'inline',
                            loc: {
                                start: {
                                    line: 6,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 14,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ConditionalExpression',
                            test: {
                                type: 'BinaryExpression',
                                operator: '!=',
                                left: {
                                    type: 'Identifier',
                                    name: '_inline',
                                    loc: {
                                        start: {
                                            line: 6,
                                            column: 17,
                                            fixed: true,
                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                        },
                                        end: {
                                            line: 6,
                                            column: 24,
                                            fixed: true,
                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: null
                                }
                            },
                            consequent: {
                                type: 'Identifier',
                                name: '_inline',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 24,
                                        fixed: true,
                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                    }
                                }
                            },
                            alternate: {
                                type: 'Literal',
                                value: true
                            }
                        }
                    }],
                kind: 'let',
                order: '6'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'constrainSelected',
                            loc: {
                                start: {
                                    line: 7,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                },
                                end: {
                                    line: 7,
                                    column: 25,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'Function',
                            context: true,
                            value: function (_context) {
                                return function (value) {
                                    var list = _context.get('list'), items = _context.get('items');
                                    if (value < 0) {
                                        value += list.items.length;
                                    }
                                    if (value >= list.items.length) {
                                        value -= list.items.length;
                                    }
                                    list.selected = value;
                                    var item = items[value];
                                    item != null ? item.scrollIntoView({ behavior: 'smooth' }) : void 0;
                                };
                            }
                        }
                    }],
                kind: 'let',
                order: '7'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'selectMatched',
                            loc: {
                                start: {
                                    line: 15,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                },
                                end: {
                                    line: 15,
                                    column: 21,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'Function',
                            context: false,
                            value: function (items, text) {
                                if (!(text != null) || text === '') {
                                    return -1;
                                }
                                for (var i = 0; i < items.length; i++) {
                                    if (items[i].doesMatch(text)) {
                                        return i;
                                    }
                                }
                                return 0;
                            }
                        }
                    }],
                kind: 'let',
                order: '8'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'move',
                            loc: {
                                start: {
                                    line: 22,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                },
                                end: {
                                    line: 22,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'Function',
                            context: true,
                            value: function (_context2) {
                                return function (e, direction) {
                                    var constrainSelected = _context2.get('constrainSelected'), list = _context2.get('list');
                                    e.preventDefault();
                                    constrainSelected((list.selected != null ? list.selected : -1) + direction);
                                };
                            }
                        }
                    }],
                kind: 'let',
                order: '9'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'container',
                            loc: {
                                start: {
                                    line: 26,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                },
                                end: {
                                    line: 26,
                                    column: 17,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Div',
                                loc: {
                                    start: {
                                        line: 26,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                    },
                                    end: {
                                        line: 26,
                                        column: 23,
                                        fixed: true,
                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                    }
                                }
                            },
                            arguments: [],
                            loc: {
                                start: {
                                    line: 26,
                                    column: 20,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                },
                                end: {
                                    line: 26,
                                    column: 25,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: ':'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'input',
                            loc: {
                                start: {
                                    line: 28,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                },
                                end: {
                                    line: 28,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'ConditionalExpression',
                                test: {
                                    type: 'Identifier',
                                    name: 'multiline',
                                    loc: {
                                        start: {
                                            line: 28,
                                            column: 16,
                                            fixed: true,
                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                        },
                                        end: {
                                            line: 28,
                                            column: 25,
                                            fixed: true,
                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                        }
                                    }
                                },
                                consequent: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'Identifier',
                                        name: 'PaperTextarea',
                                        loc: {
                                            start: {
                                                line: 28,
                                                column: 28,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            },
                                            end: {
                                                line: 28,
                                                column: 41,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            }
                                        }
                                    },
                                    arguments: [],
                                    loc: {
                                        start: {
                                            line: 28,
                                            column: 28,
                                            fixed: true,
                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                        },
                                        end: {
                                            line: 28,
                                            column: 43,
                                            fixed: true,
                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                        }
                                    }
                                },
                                alternate: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'Identifier',
                                        name: 'PaperInput',
                                        loc: {
                                            start: {
                                                line: 28,
                                                column: 46,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            },
                                            end: {
                                                line: 28,
                                                column: 56,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            }
                                        }
                                    },
                                    arguments: [],
                                    loc: {
                                        start: {
                                            line: 28,
                                            column: 46,
                                            fixed: true,
                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                        },
                                        end: {
                                            line: 28,
                                            column: 58,
                                            fixed: true,
                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                        }
                                    }
                                }
                            },
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'label',
                                        loc: {
                                            start: {
                                                line: 29,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            },
                                            end: {
                                                line: 29,
                                                column: 13,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Identifier',
                                        name: 'label',
                                        loc: {
                                            start: {
                                                line: 29,
                                                column: 15,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            },
                                            end: {
                                                line: 29,
                                                column: 20,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '0'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'Function',
                                        context: false,
                                        value: function input(e) {
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 30,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                        },
                                        end: {
                                            line: 30,
                                            column: 20,
                                            fixed: true,
                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                        }
                                    },
                                    order: '1'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'select',
                                        loc: {
                                            start: {
                                                line: 31,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            },
                                            end: {
                                                line: 31,
                                                column: 14,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: false,
                                        value: function () {
                                            this.$.input.select != null ? this.$.input.select() : void 0;
                                        }
                                    },
                                    kind: 'init',
                                    order: '2'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context3) {
                                            return function keydown(e) {
                                                var move = _context3.get('move'), commit = _context3.get('commit');
                                                if (e.keyCode === 38) {
                                                    move(e, -1);
                                                } else if (e.keyCode === 40) {
                                                    move(e, +1);
                                                } else if (e.keyCode === 13) {
                                                    commit(e);
                                                }
                                            };
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 34,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                        },
                                        end: {
                                            line: 41,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                        }
                                    },
                                    order: '3'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'ObjectExpression',
                                        objectType: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'Identifier',
                                                name: 'IronIcon',
                                                loc: {
                                                    start: {
                                                        line: 41,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                                    },
                                                    end: {
                                                        line: 41,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                                    }
                                                }
                                            },
                                            arguments: [{
                                                    type: 'ObjectExpression',
                                                    properties: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'suffix',
                                                                loc: {
                                                                    start: {
                                                                        line: 41,
                                                                        column: 18,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                                                    },
                                                                    end: {
                                                                        line: 41,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Literal',
                                                                value: true
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                }],
                                            loc: {
                                                start: {
                                                    line: 41,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                                },
                                                end: {
                                                    line: 41,
                                                    column: 31,
                                                    fixed: true,
                                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                                }
                                            }
                                        },
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'style',
                                                    loc: {
                                                        start: {
                                                            line: 42,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        },
                                                        end: {
                                                            line: 42,
                                                            column: 17,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'ObjectExpression',
                                                    properties: [
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'opacity',
                                                                loc: {
                                                                    start: {
                                                                        line: 42,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                                                    },
                                                                    end: {
                                                                        line: 42,
                                                                        column: 27,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Literal',
                                                                value: 0.3
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        },
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'marginRight',
                                                                loc: {
                                                                    start: {
                                                                        line: 42,
                                                                        column: 34,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                                                    },
                                                                    end: {
                                                                        line: 42,
                                                                        column: 45,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Literal',
                                                                value: '4px'
                                                            },
                                                            kind: 'init',
                                                            order: '1'
                                                        }
                                                    ]
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'icon',
                                                    loc: {
                                                        start: {
                                                            line: 43,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        },
                                                        end: {
                                                            line: 43,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: 'search'
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    loc: {
                                        start: {
                                            line: 41,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                        },
                                        end: {
                                            line: 45,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                        }
                                    },
                                    order: '4'
                                }
                            ]
                        }
                    }],
                kind: 'let',
                order: ';'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'commit',
                            loc: {
                                start: {
                                    line: 45,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                },
                                end: {
                                    line: 45,
                                    column: 14,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'Function',
                            context: true,
                            value: function (_context4) {
                                return function (e) {
                                    var container = _context4.get('container'), input = _context4.get('input');
                                    container.dispatchEvent(new CustomEvent('commit', { detail: { srcEvent: e } }));
                                    input.focus();
                                };
                            }
                        }
                    }],
                kind: 'let',
                order: '<'
            },
            {
                type: 'IfStatement',
                test: {
                    type: 'UnaryExpression',
                    operator: '?',
                    argument: {
                        type: 'Identifier',
                        name: 'initialValue',
                        loc: {
                            start: {
                                line: 49,
                                column: 7,
                                fixed: true,
                                source: 'glass/html/material/AutoCompleteInput.ion'
                            },
                            end: {
                                line: 49,
                                column: 19,
                                fixed: true,
                                source: 'glass/html/material/AutoCompleteInput.ion'
                            }
                        }
                    }
                },
                consequent: {
                    type: 'BlockStatement',
                    body: [{
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Function',
                                    context: true,
                                    value: function (_context5) {
                                        return function () {
                                            var initialValue = _context5.get('initialValue'), input = _context5.get('input');
                                            if (typeof initialValue === 'string') {
                                                input.value = initialValue;
                                            }
                                        };
                                    }
                                },
                                arguments: [],
                                loc: {
                                    start: {
                                        line: 50,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                    },
                                    end: {
                                        line: 54,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 50,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                },
                                end: {
                                    line: 54,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                }
                            },
                            order: '0'
                        }]
                },
                alternate: null,
                order: '='
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'text',
                            loc: {
                                start: {
                                    line: 54,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                },
                                end: {
                                    line: 54,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'ConditionalExpression',
                                            test: {
                                                type: 'BinaryExpression',
                                                operator: '!=',
                                                left: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'input',
                                                        loc: {
                                                            start: {
                                                                line: 54,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                                            },
                                                            end: {
                                                                line: 54,
                                                                column: 21,
                                                                fixed: true,
                                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'value',
                                                        loc: {
                                                            start: {
                                                                line: 54,
                                                                column: 22,
                                                                fixed: true,
                                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                                            },
                                                            end: {
                                                                line: 54,
                                                                column: 27,
                                                                fixed: true,
                                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 54,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        },
                                                        end: {
                                                            line: 54,
                                                            column: 27,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        }
                                                    }
                                                },
                                                right: {
                                                    type: 'Literal',
                                                    value: null
                                                }
                                            },
                                            consequent: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'input',
                                                    loc: {
                                                        start: {
                                                            line: 54,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        },
                                                        end: {
                                                            line: 54,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'value',
                                                    loc: {
                                                        start: {
                                                            line: 54,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        },
                                                        end: {
                                                            line: 54,
                                                            column: 27,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 54,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                                    },
                                                    end: {
                                                        line: 54,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                                    }
                                                }
                                            },
                                            alternate: {
                                                type: 'Literal',
                                                value: ''
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'trim',
                                            loc: {
                                                start: {
                                                    line: 54,
                                                    column: 34,
                                                    fixed: true,
                                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                                },
                                                end: {
                                                    line: 54,
                                                    column: 38,
                                                    fixed: true,
                                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 54,
                                                column: 15,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            },
                                            end: {
                                                line: 54,
                                                column: 38,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            }
                                        }
                                    },
                                    arguments: [],
                                    loc: {
                                        start: {
                                            line: 54,
                                            column: 15,
                                            fixed: true,
                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                        },
                                        end: {
                                            line: 54,
                                            column: 40,
                                            fixed: true,
                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'toLowerCase',
                                    loc: {
                                        start: {
                                            line: 54,
                                            column: 41,
                                            fixed: true,
                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                        },
                                        end: {
                                            line: 54,
                                            column: 52,
                                            fixed: true,
                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 54,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                    },
                                    end: {
                                        line: 54,
                                        column: 52,
                                        fixed: true,
                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                    }
                                }
                            },
                            arguments: [],
                            loc: {
                                start: {
                                    line: 54,
                                    column: 15,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                },
                                end: {
                                    line: 54,
                                    column: 54,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '>'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'suggestions',
                            loc: {
                                start: {
                                    line: 55,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                },
                                end: {
                                    line: 55,
                                    column: 19,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'suggestionTemplate',
                                loc: {
                                    start: {
                                        line: 55,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                    },
                                    end: {
                                        line: 55,
                                        column: 40,
                                        fixed: true,
                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ObjectExpression',
                                    properties: [{
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'text',
                                                loc: {
                                                    start: {
                                                        line: 55,
                                                        column: 43,
                                                        fixed: true,
                                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                                    },
                                                    end: {
                                                        line: 55,
                                                        column: 47,
                                                        fixed: true,
                                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Identifier',
                                                name: 'text',
                                                loc: {
                                                    start: {
                                                        line: 55,
                                                        column: 43,
                                                        fixed: true,
                                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                                    },
                                                    end: {
                                                        line: 55,
                                                        column: 47,
                                                        fixed: true,
                                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                                    }
                                                }
                                            },
                                            kind: 'init',
                                            order: '0'
                                        }]
                                }],
                            existential: true,
                            loc: {
                                start: {
                                    line: 55,
                                    column: 22,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                },
                                end: {
                                    line: 55,
                                    column: 49,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '?'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'items',
                            loc: {
                                start: {
                                    line: 56,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                },
                                end: {
                                    line: 56,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'ArrayExpression',
                                elements: []
                            },
                            properties: [{
                                    type: 'IfStatement',
                                    test: {
                                        type: 'UnaryExpression',
                                        operator: '?',
                                        argument: {
                                            type: 'Identifier',
                                            name: 'suggestions',
                                            loc: {
                                                start: {
                                                    line: 57,
                                                    column: 11,
                                                    fixed: true,
                                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                                },
                                                end: {
                                                    line: 57,
                                                    column: 22,
                                                    fixed: true,
                                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                                }
                                            }
                                        }
                                    },
                                    consequent: {
                                        type: 'BlockStatement',
                                        body: [{
                                                type: 'ForOfStatement',
                                                left: {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: '_ref3'
                                                            },
                                                            init: null
                                                        }],
                                                    kind: 'let'
                                                },
                                                right: {
                                                    type: 'Identifier',
                                                    name: 'suggestions',
                                                    loc: {
                                                        start: {
                                                            line: 58,
                                                            column: 32,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        },
                                                        end: {
                                                            line: 58,
                                                            column: 43,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        }
                                                    }
                                                },
                                                body: {
                                                    type: 'BlockStatement',
                                                    body: [
                                                        {
                                                            type: 'VariableDeclaration',
                                                            declarations: [{
                                                                    type: 'VariableDeclarator',
                                                                    id: {
                                                                        type: 'Identifier',
                                                                        name: '_ref4'
                                                                    },
                                                                    init: {
                                                                        type: 'Identifier',
                                                                        name: '_ref3'
                                                                    }
                                                                }],
                                                            order: '0'
                                                        },
                                                        {
                                                            type: 'VariableDeclaration',
                                                            declarations: [{
                                                                    type: 'VariableDeclarator',
                                                                    id: {
                                                                        type: 'Identifier',
                                                                        name: 'key',
                                                                        loc: {
                                                                            start: {
                                                                                line: 58,
                                                                                column: 17,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                                                            },
                                                                            end: {
                                                                                line: 58,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    init: {
                                                                        type: 'MemberExpression',
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: '_ref4'
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'key',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 58,
                                                                                    column: 17,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 58,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        computed: false
                                                                    }
                                                                }],
                                                            kind: 'let',
                                                            order: '1'
                                                        },
                                                        {
                                                            type: 'VariableDeclaration',
                                                            declarations: [{
                                                                    type: 'VariableDeclarator',
                                                                    id: {
                                                                        type: 'Identifier',
                                                                        name: 'record',
                                                                        loc: {
                                                                            start: {
                                                                                line: 58,
                                                                                column: 21,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                                                            },
                                                                            end: {
                                                                                line: 58,
                                                                                column: 27,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    init: {
                                                                        type: 'MemberExpression',
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: '_ref4'
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'record',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 58,
                                                                                    column: 21,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 58,
                                                                                    column: 27,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        computed: false
                                                                    }
                                                                }],
                                                            kind: 'let',
                                                            order: '2'
                                                        },
                                                        {
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'ObjectExpression',
                                                                objectType: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'Identifier',
                                                                        name: 'RecordItem',
                                                                        loc: {
                                                                            start: {
                                                                                line: 59,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                                                            },
                                                                            end: {
                                                                                line: 59,
                                                                                column: 26,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [{
                                                                            type: 'ObjectExpression',
                                                                            properties: [
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'key',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 59,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 59,
                                                                                                column: 31,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Identifier',
                                                                                        name: 'key',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 59,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 59,
                                                                                                column: 31,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'record',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 59,
                                                                                                column: 33,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 59,
                                                                                                column: 39,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Identifier',
                                                                                        name: 'record',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 59,
                                                                                                column: 33,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 59,
                                                                                                column: 39,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '1'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'match',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 59,
                                                                                                column: 41,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 59,
                                                                                                column: 46,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Identifier',
                                                                                        name: 'text',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 59,
                                                                                                column: 47,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 59,
                                                                                                column: 51,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '2'
                                                                                }
                                                                            ]
                                                                        }],
                                                                    loc: {
                                                                        start: {
                                                                            line: 59,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                                        },
                                                                        end: {
                                                                            line: 59,
                                                                            column: 53,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                                        }
                                                                    }
                                                                },
                                                                properties: [{
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'Function',
                                                                            context: true,
                                                                            value: function (_context6) {
                                                                                return function click(e) {
                                                                                    var commit = _context6.get('commit');
                                                                                    commit();
                                                                                };
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 60,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                                                            },
                                                                            end: {
                                                                                line: 63,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                                                            }
                                                                        },
                                                                        order: '0'
                                                                    }]
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 59,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                                                },
                                                                end: {
                                                                    line: 63,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                                                }
                                                            },
                                                            order: '3'
                                                        }
                                                    ]
                                                },
                                                remove: null,
                                                order: '0'
                                            }]
                                    },
                                    alternate: null,
                                    order: '0'
                                }]
                        }
                    }],
                kind: 'let',
                order: '@'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'showResults',
                            loc: {
                                start: {
                                    line: 63,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                },
                                end: {
                                    line: 63,
                                    column: 19,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'BinaryExpression',
                            operator: '||',
                            left: {
                                type: 'BinaryExpression',
                                operator: '>',
                                left: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'items',
                                        loc: {
                                            start: {
                                                line: 63,
                                                column: 22,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            },
                                            end: {
                                                line: 63,
                                                column: 27,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'length',
                                        loc: {
                                            start: {
                                                line: 63,
                                                column: 28,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            },
                                            end: {
                                                line: 63,
                                                column: 34,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 63,
                                            column: 22,
                                            fixed: true,
                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                        },
                                        end: {
                                            line: 63,
                                            column: 34,
                                            fixed: true,
                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: 0
                                }
                            },
                            right: {
                                type: 'BinaryExpression',
                                operator: '>',
                                left: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'text',
                                        loc: {
                                            start: {
                                                line: 63,
                                                column: 42,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            },
                                            end: {
                                                line: 63,
                                                column: 46,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'length',
                                        loc: {
                                            start: {
                                                line: 63,
                                                column: 47,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            },
                                            end: {
                                                line: 63,
                                                column: 53,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 63,
                                            column: 42,
                                            fixed: true,
                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                        },
                                        end: {
                                            line: 63,
                                            column: 53,
                                            fixed: true,
                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: 0
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: 'A'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'list',
                            loc: {
                                start: {
                                    line: 65,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                },
                                end: {
                                    line: 65,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'PaperListbox',
                                    loc: {
                                        start: {
                                            line: 65,
                                            column: 15,
                                            fixed: true,
                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                        },
                                        end: {
                                            line: 65,
                                            column: 27,
                                            fixed: true,
                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                        }
                                    }
                                },
                                arguments: [],
                                loc: {
                                    start: {
                                        line: 65,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                    },
                                    end: {
                                        line: 65,
                                        column: 29,
                                        fixed: true,
                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                    }
                                }
                            },
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'style',
                                        loc: {
                                            start: {
                                                line: 66,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            },
                                            end: {
                                                line: 66,
                                                column: 13,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'background',
                                                    loc: {
                                                        start: {
                                                            line: 67,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        },
                                                        end: {
                                                            line: 67,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: 'transparent'
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    },
                                    kind: 'init',
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'selected',
                                        loc: {
                                            start: {
                                                line: 70,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            },
                                            end: {
                                                line: 70,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'Identifier',
                                            name: 'selectMatched',
                                            loc: {
                                                start: {
                                                    line: 70,
                                                    column: 18,
                                                    fixed: true,
                                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                                },
                                                end: {
                                                    line: 70,
                                                    column: 31,
                                                    fixed: true,
                                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                                }
                                            }
                                        },
                                        arguments: [
                                            {
                                                type: 'Identifier',
                                                name: 'items',
                                                loc: {
                                                    start: {
                                                        line: 70,
                                                        column: 32,
                                                        fixed: true,
                                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                                    },
                                                    end: {
                                                        line: 70,
                                                        column: 37,
                                                        fixed: true,
                                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                                    }
                                                }
                                            },
                                            {
                                                type: 'Identifier',
                                                name: 'text',
                                                loc: {
                                                    start: {
                                                        line: 70,
                                                        column: 39,
                                                        fixed: true,
                                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                                    },
                                                    end: {
                                                        line: 70,
                                                        column: 43,
                                                        fixed: true,
                                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                                    }
                                                }
                                            }
                                        ],
                                        loc: {
                                            start: {
                                                line: 70,
                                                column: 18,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            },
                                            end: {
                                                line: 70,
                                                column: 44,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '1'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'selectedClass',
                                        loc: {
                                            start: {
                                                line: 71,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            },
                                            end: {
                                                line: 71,
                                                column: 21,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: 'background-black-divider'
                                    },
                                    kind: 'init',
                                    order: '2'
                                },
                                {
                                    type: 'ForOfStatement',
                                    left: {
                                        type: 'VariableDeclaration',
                                        declarations: [{
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'item',
                                                    loc: {
                                                        start: {
                                                            line: 72,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        },
                                                        end: {
                                                            line: 72,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        }
                                                    }
                                                },
                                                init: null
                                            }],
                                        kind: 'let'
                                    },
                                    right: {
                                        type: 'Identifier',
                                        name: 'items',
                                        loc: {
                                            start: {
                                                line: 72,
                                                column: 20,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            },
                                            end: {
                                                line: 72,
                                                column: 25,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            }
                                        }
                                    },
                                    body: {
                                        type: 'BlockStatement',
                                        body: [{
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'Identifier',
                                                    name: 'item',
                                                    loc: {
                                                        start: {
                                                            line: 73,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        },
                                                        end: {
                                                            line: 73,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 73,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                                    },
                                                    end: {
                                                        line: 73,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                                    }
                                                },
                                                order: '0'
                                            }]
                                    },
                                    remove: null,
                                    order: '3'
                                }
                            ]
                        }
                    }],
                kind: 'let',
                order: 'B'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'getNotFoundMessage',
                            loc: {
                                start: {
                                    line: 75,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                },
                                end: {
                                    line: 75,
                                    column: 26,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'Function',
                            context: true,
                            value: function (_context7) {
                                return function (text) {
                                    var notFoundMessage = _context7.get('notFoundMessage');
                                    if (typeof notFoundMessage === 'function') {
                                        return notFoundMessage(text);
                                    }
                                    if (notFoundMessage != null) {
                                        return notFoundMessage;
                                    }
                                    return 'No search results for: ' + text;
                                };
                            }
                        }
                    }],
                kind: 'let',
                order: 'C'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'searchResults',
                            loc: {
                                start: {
                                    line: 82,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                },
                                end: {
                                    line: 82,
                                    column: 21,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Div',
                                    loc: {
                                        start: {
                                            line: 82,
                                            column: 24,
                                            fixed: true,
                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                        },
                                        end: {
                                            line: 82,
                                            column: 27,
                                            fixed: true,
                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'class',
                                                    loc: {
                                                        start: {
                                                            line: 82,
                                                            column: 29,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        },
                                                        end: {
                                                            line: 82,
                                                            column: 34,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: 'flex'
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    }],
                                loc: {
                                    start: {
                                        line: 82,
                                        column: 24,
                                        fixed: true,
                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                    },
                                    end: {
                                        line: 82,
                                        column: 43,
                                        fixed: true,
                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                    }
                                }
                            },
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'style',
                                        loc: {
                                            start: {
                                                line: 83,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            },
                                            end: {
                                                line: 83,
                                                column: 13,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Literal',
                                                    value: 'overflow-y'
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: 'scroll'
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Literal',
                                                    value: 'overflow-x'
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: 'auto'
                                                },
                                                kind: 'init',
                                                order: '1'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'maxHeight',
                                                    loc: {
                                                        start: {
                                                            line: 86,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        },
                                                        end: {
                                                            line: 86,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: '50vh'
                                                },
                                                kind: 'init',
                                                order: '2'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    order: '0'
                                },
                                {
                                    type: 'IfStatement',
                                    test: {
                                        type: 'BinaryExpression',
                                        operator: '===',
                                        left: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'items',
                                                loc: {
                                                    start: {
                                                        line: 87,
                                                        column: 11,
                                                        fixed: true,
                                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                                    },
                                                    end: {
                                                        line: 87,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'length',
                                                loc: {
                                                    start: {
                                                        line: 87,
                                                        column: 17,
                                                        fixed: true,
                                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                                    },
                                                    end: {
                                                        line: 87,
                                                        column: 23,
                                                        fixed: true,
                                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 87,
                                                    column: 11,
                                                    fixed: true,
                                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                                },
                                                end: {
                                                    line: 87,
                                                    column: 23,
                                                    fixed: true,
                                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                                }
                                            }
                                        },
                                        right: {
                                            type: 'Literal',
                                            value: 0
                                        }
                                    },
                                    consequent: {
                                        type: 'BlockStatement',
                                        body: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'style',
                                                    loc: {
                                                        start: {
                                                            line: 88,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        },
                                                        end: {
                                                            line: 88,
                                                            column: 17,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'ObjectExpression',
                                                    properties: [
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Literal',
                                                                value: 'overflow-y'
                                                            },
                                                            value: {
                                                                type: 'Literal',
                                                                value: 'auto'
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        },
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'color',
                                                                loc: {
                                                                    start: {
                                                                        line: 90,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                                                    },
                                                                    end: {
                                                                        line: 90,
                                                                        column: 21,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Literal',
                                                                value: 'rgba(0,0,0,0.7)'
                                                            },
                                                            kind: 'init',
                                                            order: '1'
                                                        }
                                                    ]
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'Identifier',
                                                        name: 'getNotFoundMessage',
                                                        loc: {
                                                            start: {
                                                                line: 91,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                                            },
                                                            end: {
                                                                line: 91,
                                                                column: 30,
                                                                fixed: true,
                                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [{
                                                            type: 'Identifier',
                                                            name: 'text',
                                                            loc: {
                                                                start: {
                                                                    line: 91,
                                                                    column: 31,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                                                },
                                                                end: {
                                                                    line: 91,
                                                                    column: 35,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                                                }
                                                            }
                                                        }],
                                                    loc: {
                                                        start: {
                                                            line: 91,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        },
                                                        end: {
                                                            line: 91,
                                                            column: 36,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 91,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                                    },
                                                    end: {
                                                        line: 91,
                                                        column: 36,
                                                        fixed: true,
                                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                                    }
                                                },
                                                order: '1'
                                            }
                                        ]
                                    },
                                    alternate: {
                                        type: 'IfStatement',
                                        test: {
                                            type: 'BinaryExpression',
                                            operator: '>',
                                            left: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'items',
                                                    loc: {
                                                        start: {
                                                            line: 92,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        },
                                                        end: {
                                                            line: 92,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'length',
                                                    loc: {
                                                        start: {
                                                            line: 92,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        },
                                                        end: {
                                                            line: 92,
                                                            column: 28,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 92,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                                    },
                                                    end: {
                                                        line: 92,
                                                        column: 28,
                                                        fixed: true,
                                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                                    }
                                                }
                                            },
                                            right: {
                                                type: 'Literal',
                                                value: 0
                                            }
                                        },
                                        consequent: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'Identifier',
                                                        name: 'list',
                                                        loc: {
                                                            start: {
                                                                line: 93,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                                            },
                                                            end: {
                                                                line: 93,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 93,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        },
                                                        end: {
                                                            line: 93,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        alternate: null
                                    },
                                    order: '1'
                                }
                            ]
                        }
                    }],
                kind: 'let',
                order: 'D'
            },
            {
                type: 'IfStatement',
                test: {
                    type: 'BinaryExpression',
                    operator: '&&',
                    left: {
                        type: 'UnaryExpression',
                        operator: '!',
                        argument: {
                            type: 'Identifier',
                            name: 'inline',
                            loc: {
                                start: {
                                    line: 95,
                                    column: 11,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                },
                                end: {
                                    line: 95,
                                    column: 17,
                                    fixed: true,
                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                }
                            }
                        }
                    },
                    right: {
                        type: 'Identifier',
                        name: 'showResults',
                        loc: {
                            start: {
                                line: 95,
                                column: 22,
                                fixed: true,
                                source: 'glass/html/material/AutoCompleteInput.ion'
                            },
                            end: {
                                line: 95,
                                column: 33,
                                fixed: true,
                                source: 'glass/html/material/AutoCompleteInput.ion'
                            }
                        }
                    }
                },
                consequent: {
                    type: 'BlockStatement',
                    body: [{
                            type: 'IfStatement',
                            test: {
                                type: 'UnaryExpression',
                                operator: '?',
                                argument: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'input',
                                        loc: {
                                            start: {
                                                line: 96,
                                                column: 11,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            },
                                            end: {
                                                line: 96,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'offsetParent',
                                        loc: {
                                            start: {
                                                line: 96,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            },
                                            end: {
                                                line: 96,
                                                column: 29,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 96,
                                            column: 11,
                                            fixed: true,
                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                        },
                                        end: {
                                            line: 96,
                                            column: 29,
                                            fixed: true,
                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                        }
                                    }
                                }
                            },
                            consequent: {
                                type: 'BlockStatement',
                                body: [
                                    {
                                        type: 'VariableDeclaration',
                                        declarations: [{
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'top',
                                                    loc: {
                                                        start: {
                                                            line: 97,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        },
                                                        end: {
                                                            line: 97,
                                                            column: 19,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        }
                                                    }
                                                },
                                                init: {
                                                    type: 'BinaryExpression',
                                                    operator: '+',
                                                    left: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'input',
                                                            loc: {
                                                                start: {
                                                                    line: 97,
                                                                    column: 22,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                                                },
                                                                end: {
                                                                    line: 97,
                                                                    column: 27,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'offsetTop',
                                                            loc: {
                                                                start: {
                                                                    line: 97,
                                                                    column: 28,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                                                },
                                                                end: {
                                                                    line: 97,
                                                                    column: 37,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 97,
                                                                column: 22,
                                                                fixed: true,
                                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                                            },
                                                            end: {
                                                                line: 97,
                                                                column: 37,
                                                                fixed: true,
                                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                                            }
                                                        }
                                                    },
                                                    right: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'input',
                                                            loc: {
                                                                start: {
                                                                    line: 97,
                                                                    column: 40,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                                                },
                                                                end: {
                                                                    line: 97,
                                                                    column: 45,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'offsetHeight',
                                                            loc: {
                                                                start: {
                                                                    line: 97,
                                                                    column: 46,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                                                },
                                                                end: {
                                                                    line: 97,
                                                                    column: 58,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 97,
                                                                column: 40,
                                                                fixed: true,
                                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                                            },
                                                            end: {
                                                                line: 97,
                                                                column: 58,
                                                                fixed: true,
                                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                                            }
                                                        }
                                                    }
                                                }
                                            }],
                                        kind: 'let',
                                        order: '0'
                                    },
                                    {
                                        type: 'VariableDeclaration',
                                        declarations: [{
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'left',
                                                    loc: {
                                                        start: {
                                                            line: 98,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        },
                                                        end: {
                                                            line: 98,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        }
                                                    }
                                                },
                                                init: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'input',
                                                        loc: {
                                                            start: {
                                                                line: 98,
                                                                column: 23,
                                                                fixed: true,
                                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                                            },
                                                            end: {
                                                                line: 98,
                                                                column: 28,
                                                                fixed: true,
                                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'offsetLeft',
                                                        loc: {
                                                            start: {
                                                                line: 98,
                                                                column: 29,
                                                                fixed: true,
                                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                                            },
                                                            end: {
                                                                line: 98,
                                                                column: 39,
                                                                fixed: true,
                                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 98,
                                                            column: 23,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        },
                                                        end: {
                                                            line: 98,
                                                            column: 39,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        }
                                                    }
                                                }
                                            }],
                                        kind: 'let',
                                        order: '1'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'ObjectExpression',
                                            objectType: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'input',
                                                    loc: {
                                                        start: {
                                                            line: 99,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        },
                                                        end: {
                                                            line: 99,
                                                            column: 17,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'offsetParent',
                                                    loc: {
                                                        start: {
                                                            line: 99,
                                                            column: 18,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        },
                                                        end: {
                                                            line: 99,
                                                            column: 30,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 99,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                                    },
                                                    end: {
                                                        line: 99,
                                                        column: 30,
                                                        fixed: true,
                                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                                    }
                                                }
                                            },
                                            properties: [{
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'PaperMaterial',
                                                                loc: {
                                                                    start: {
                                                                        line: 100,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                                                    },
                                                                    end: {
                                                                        line: 100,
                                                                        column: 29,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [],
                                                            loc: {
                                                                start: {
                                                                    line: 100,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                                                },
                                                                end: {
                                                                    line: 100,
                                                                    column: 31,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'style',
                                                                    loc: {
                                                                        start: {
                                                                            line: 101,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                                        },
                                                                        end: {
                                                                            line: 101,
                                                                            column: 25,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'ObjectExpression',
                                                                    properties: [
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'position',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 102,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 102,
                                                                                        column: 32,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'absolute'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'left',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 103,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 103,
                                                                                        column: 28,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'BinaryExpression',
                                                                                operator: '+',
                                                                                left: {
                                                                                    type: 'BinaryExpression',
                                                                                    operator: '+',
                                                                                    left: {
                                                                                        type: 'Literal',
                                                                                        value: ''
                                                                                    },
                                                                                    right: {
                                                                                        type: 'Identifier',
                                                                                        name: 'left',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 103,
                                                                                                column: 33,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 103,
                                                                                                column: 37,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                },
                                                                                right: {
                                                                                    type: 'Literal',
                                                                                    value: 'px'
                                                                                }
                                                                            },
                                                                            kind: 'init',
                                                                            order: '1'
                                                                        },
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'top',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 104,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 104,
                                                                                        column: 27,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'BinaryExpression',
                                                                                operator: '+',
                                                                                left: {
                                                                                    type: 'BinaryExpression',
                                                                                    operator: '+',
                                                                                    left: {
                                                                                        type: 'Literal',
                                                                                        value: ''
                                                                                    },
                                                                                    right: {
                                                                                        type: 'Identifier',
                                                                                        name: 'top',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 104,
                                                                                                column: 32,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 104,
                                                                                                column: 35,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                },
                                                                                right: {
                                                                                    type: 'Literal',
                                                                                    value: 'px'
                                                                                }
                                                                            },
                                                                            kind: 'init',
                                                                            order: '2'
                                                                        },
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'background',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 105,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 105,
                                                                                        column: 34,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'white'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '3'
                                                                        }
                                                                    ]
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'elevation',
                                                                    loc: {
                                                                        start: {
                                                                            line: 106,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                                        },
                                                                        end: {
                                                                            line: 106,
                                                                            column: 29,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: 2
                                                                },
                                                                kind: 'init',
                                                                order: '1'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'Identifier',
                                                                    name: 'searchResults',
                                                                    loc: {
                                                                        start: {
                                                                            line: 107,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                                        },
                                                                        end: {
                                                                            line: 107,
                                                                            column: 33,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 107,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                                                    },
                                                                    end: {
                                                                        line: 107,
                                                                        column: 33,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                                                    }
                                                                },
                                                                order: '2'
                                                            }
                                                        ]
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 100,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        },
                                                        end: {
                                                            line: 108,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        loc: {
                                            start: {
                                                line: 99,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            },
                                            end: {
                                                line: 108,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            }
                                        },
                                        order: '2'
                                    }
                                ]
                            },
                            alternate: null,
                            order: '0'
                        }]
                },
                alternate: null,
                order: 'E'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'CallExpression',
                    callee: {
                        type: 'MemberExpression',
                        object: {
                            type: 'Identifier',
                            name: 'Object'
                        },
                        property: {
                            type: 'Identifier',
                            name: 'defineProperties'
                        }
                    },
                    arguments: [
                        {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'Identifier',
                                name: 'container',
                                loc: {
                                    start: {
                                        line: 108,
                                        column: 11,
                                        fixed: true,
                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                    },
                                    end: {
                                        line: 108,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                    }
                                }
                            },
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'select',
                                        loc: {
                                            start: {
                                                line: 109,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            },
                                            end: {
                                                line: 109,
                                                column: 14,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context8) {
                                            return function () {
                                                var input = _context8.get('input');
                                                return input.select();
                                            };
                                        }
                                    },
                                    kind: 'init',
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'focus',
                                        loc: {
                                            start: {
                                                line: 110,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            },
                                            end: {
                                                line: 110,
                                                column: 13,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context9) {
                                            return function () {
                                                var input = _context9.get('input');
                                                return input.focus();
                                            };
                                        }
                                    },
                                    kind: 'init',
                                    order: '1'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'classList',
                                        loc: {
                                            start: {
                                                line: 123,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            },
                                            end: {
                                                line: 123,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'Literal',
                                                    value: 'validate'
                                                },
                                                loc: {
                                                    start: {
                                                        line: 124,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                                    },
                                                    end: {
                                                        line: 124,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                                    }
                                                },
                                                order: '0'
                                            }]
                                    },
                                    kind: 'init',
                                    order: '2'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'input',
                                        loc: {
                                            start: {
                                                line: 125,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            },
                                            end: {
                                                line: 125,
                                                column: 13,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Identifier',
                                        name: 'input',
                                        loc: {
                                            start: {
                                                line: 125,
                                                column: 15,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            },
                                            end: {
                                                line: 125,
                                                column: 20,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '3'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'Identifier',
                                        name: 'input',
                                        loc: {
                                            start: {
                                                line: 126,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            },
                                            end: {
                                                line: 126,
                                                column: 13,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 126,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                        },
                                        end: {
                                            line: 126,
                                            column: 13,
                                            fixed: true,
                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                        }
                                    },
                                    order: '4'
                                },
                                {
                                    type: 'IfStatement',
                                    test: {
                                        type: 'BinaryExpression',
                                        operator: '&&',
                                        left: {
                                            type: 'Identifier',
                                            name: 'inline',
                                            loc: {
                                                start: {
                                                    line: 127,
                                                    column: 11,
                                                    fixed: true,
                                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                                },
                                                end: {
                                                    line: 127,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                                }
                                            }
                                        },
                                        right: {
                                            type: 'Identifier',
                                            name: 'showResults',
                                            loc: {
                                                start: {
                                                    line: 127,
                                                    column: 22,
                                                    fixed: true,
                                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                                },
                                                end: {
                                                    line: 127,
                                                    column: 33,
                                                    fixed: true,
                                                    source: 'glass/html/material/AutoCompleteInput.ion'
                                                }
                                            }
                                        }
                                    },
                                    consequent: {
                                        type: 'BlockStatement',
                                        body: [{
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'Identifier',
                                                    name: 'searchResults',
                                                    loc: {
                                                        start: {
                                                            line: 128,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        },
                                                        end: {
                                                            line: 128,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 128,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                                    },
                                                    end: {
                                                        line: 128,
                                                        column: 25,
                                                        fixed: true,
                                                        source: 'glass/html/material/AutoCompleteInput.ion'
                                                    }
                                                },
                                                order: '0'
                                            }]
                                    },
                                    alternate: null,
                                    order: '5'
                                }
                            ]
                        },
                        {
                            type: 'ObjectExpression',
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'value',
                                        loc: {
                                            start: {
                                                line: 111,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            },
                                            end: {
                                                line: 111,
                                                column: 22,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 112,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        },
                                                        end: {
                                                            line: 112,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context10) {
                                                        return function () {
                                                            var input = _context10.get('input');
                                                            return input.value;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 113,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        },
                                                        end: {
                                                            line: 113,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context11) {
                                                        return function (value) {
                                                            var input = _context11.get('input'), list = _context11.get('list');
                                                            input.value = value;
                                                            if (!(value != null) || value === '') {
                                                                list.selected = -1;
                                                            }
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'selectedItem',
                                        loc: {
                                            start: {
                                                line: 117,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            },
                                            end: {
                                                line: 117,
                                                column: 29,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 118,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        },
                                                        end: {
                                                            line: 118,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context12) {
                                                        return function () {
                                                            var list = _context12.get('list');
                                                            return list.selectedItem;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '1'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'label',
                                        loc: {
                                            start: {
                                                line: 119,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            },
                                            end: {
                                                line: 119,
                                                column: 22,
                                                fixed: true,
                                                source: 'glass/html/material/AutoCompleteInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 120,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        },
                                                        end: {
                                                            line: 120,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context13) {
                                                        return function () {
                                                            var input = _context13.get('input');
                                                            return input.label;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 121,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        },
                                                        end: {
                                                            line: 121,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/AutoCompleteInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context14) {
                                                        return function (value) {
                                                            var input = _context14.get('input');
                                                            return input.label = value;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '2'
                                }
                            ]
                        }
                    ]
                },
                order: 'F'
            }
        ],
        bound: false
    }, {
        this: this,
        _ref2: _ref2,
        _ref: _ref,
        Menu: Menu,
        Shadow: Shadow,
        RecordItem: RecordItem
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/AutoCompleteInput',_glass_html_material_AutoCompleteInput_);
    else
      _glass_html_material_AutoCompleteInput_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_AutoCompleteInput_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_BaseInput_ = function(module,exports,require){'use strict';
var ion = require('ion');
module.exports = exports = ion.template(function (element) {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [{
                type: 'ReturnStatement',
                argument: {
                    type: 'CallExpression',
                    callee: {
                        type: 'MemberExpression',
                        object: {
                            type: 'Identifier',
                            name: 'Object'
                        },
                        property: {
                            type: 'Identifier',
                            name: 'defineProperties'
                        }
                    },
                    arguments: [
                        {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'ConditionalExpression',
                                test: {
                                    type: 'BinaryExpression',
                                    operator: '!=',
                                    left: {
                                        type: 'Identifier',
                                        name: 'element',
                                        loc: {
                                            start: {
                                                line: 5,
                                                column: 11,
                                                fixed: true,
                                                source: 'glass/html/material/BaseInput.ion'
                                            },
                                            end: {
                                                line: 5,
                                                column: 18,
                                                fixed: true,
                                                source: 'glass/html/material/BaseInput.ion'
                                            }
                                        }
                                    },
                                    right: {
                                        type: 'Literal',
                                        value: null
                                    }
                                },
                                consequent: {
                                    type: 'Identifier',
                                    name: 'element',
                                    loc: {
                                        start: {
                                            line: 5,
                                            column: 11,
                                            fixed: true,
                                            source: 'glass/html/material/BaseInput.ion'
                                        },
                                        end: {
                                            line: 5,
                                            column: 18,
                                            fixed: true,
                                            source: 'glass/html/material/BaseInput.ion'
                                        }
                                    }
                                },
                                alternate: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'Identifier',
                                        name: 'Input',
                                        loc: {
                                            start: {
                                                line: 5,
                                                column: 21,
                                                fixed: true,
                                                source: 'glass/html/material/BaseInput.ion'
                                            },
                                            end: {
                                                line: 5,
                                                column: 26,
                                                fixed: true,
                                                source: 'glass/html/material/BaseInput.ion'
                                            }
                                        }
                                    },
                                    arguments: [],
                                    loc: {
                                        start: {
                                            line: 5,
                                            column: 21,
                                            fixed: true,
                                            source: 'glass/html/material/BaseInput.ion'
                                        },
                                        end: {
                                            line: 5,
                                            column: 28,
                                            fixed: true,
                                            source: 'glass/html/material/BaseInput.ion'
                                        }
                                    }
                                }
                            },
                            properties: [{
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'Function',
                                        context: false,
                                        value: function keydown(e) {
                                            if (e.keyCode === 27) {
                                                this.dispatchEvent(new CustomEvent('cancel'));
                                            }
                                            if (e.keyCode === 13) {
                                                this.dispatchEvent(new CustomEvent('commit'));
                                            }
                                            if (e.keyCode >= 37 && e.keyCode <= 40) {
                                                e.stopPropagation();
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 6,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/BaseInput.ion'
                                        },
                                        end: {
                                            line: 14,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/material/BaseInput.ion'
                                        }
                                    },
                                    order: '0'
                                }]
                        },
                        {
                            type: 'ObjectExpression',
                            properties: [{
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'valueJSON',
                                        loc: {
                                            start: {
                                                line: 15,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/BaseInput.ion'
                                            },
                                            end: {
                                                line: 15,
                                                column: 26,
                                                fixed: true,
                                                source: 'glass/html/material/BaseInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 16,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/BaseInput.ion'
                                                        },
                                                        end: {
                                                            line: 16,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/BaseInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: false,
                                                    value: function () {
                                                        var value = this.value;
                                                        if (typeof value === 'string') {
                                                            value = value.trim();
                                                            if (value === '') {
                                                                value = null;
                                                            }
                                                        }
                                                        return value;
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 23,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/BaseInput.ion'
                                                        },
                                                        end: {
                                                            line: 23,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/BaseInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: false,
                                                    value: function (value) {
                                                        return this.value = value != null ? value : '';
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'configurable',
                                                    loc: {
                                                        start: {
                                                            line: 24,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/BaseInput.ion'
                                                        },
                                                        end: {
                                                            line: 24,
                                                            column: 24,
                                                            fixed: true,
                                                            source: 'glass/html/material/BaseInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: true
                                                },
                                                kind: 'init',
                                                order: '2'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '0'
                                }]
                        }
                    ]
                },
                order: '0'
            }],
        bound: false
    }, {
        this: this,
        element: element
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/BaseInput',_glass_html_material_BaseInput_);
    else
      _glass_html_material_BaseInput_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_BaseInput_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_Bubble_ = function(module,exports,require){'use strict';
var ion = require('ion');
var style = require('../style');
var _ref = style.sheets;
_ref[module.id] = '.bubble-arrow {\n    width: 0;\n    height: 0;\n    border-left: 10px solid transparent;\n    border-right: 10px solid transparent;\n    border-bottom: 10px solid #404040;\n\n    z-index: 1000;\n\n    position: absolute;\n    left: 0;\n    top: 0;\n}\n\n.bubble-box {\n    z-index: 1001;\n\n    padding: 4px;\n\n    position: absolute;\n    top: 10;\n\n    background-color: #404040;\n    color: white;\n}\n\n.bubble {\n    position: relative;\n}';
_ref;
module.exports = exports = ion.template(function () {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [{
                type: 'ReturnStatement',
                argument: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'CallExpression',
                        callee: {
                            type: 'Identifier',
                            name: 'Span',
                            loc: {
                                start: {
                                    line: 38,
                                    column: 11,
                                    fixed: true,
                                    source: 'glass/html/material/Bubble.ion'
                                },
                                end: {
                                    line: 38,
                                    column: 15,
                                    fixed: true,
                                    source: 'glass/html/material/Bubble.ion'
                                }
                            }
                        },
                        arguments: [{
                                type: 'ObjectExpression',
                                properties: [{
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'class',
                                            loc: {
                                                start: {
                                                    line: 38,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'glass/html/material/Bubble.ion'
                                                },
                                                end: {
                                                    line: 38,
                                                    column: 22,
                                                    fixed: true,
                                                    source: 'glass/html/material/Bubble.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: 'bubble'
                                        },
                                        kind: 'init',
                                        order: '0'
                                    }]
                            }],
                        loc: {
                            start: {
                                line: 38,
                                column: 11,
                                fixed: true,
                                source: 'glass/html/material/Bubble.ion'
                            },
                            end: {
                                line: 38,
                                column: 34,
                                fixed: true,
                                source: 'glass/html/material/Bubble.ion'
                            }
                        }
                    },
                    properties: [
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Span',
                                    loc: {
                                        start: {
                                            line: 39,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/material/Bubble.ion'
                                        },
                                        end: {
                                            line: 39,
                                            column: 16,
                                            fixed: true,
                                            source: 'glass/html/material/Bubble.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'class',
                                                    loc: {
                                                        start: {
                                                            line: 39,
                                                            column: 18,
                                                            fixed: true,
                                                            source: 'glass/html/material/Bubble.ion'
                                                        },
                                                        end: {
                                                            line: 39,
                                                            column: 23,
                                                            fixed: true,
                                                            source: 'glass/html/material/Bubble.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: 'bubble-arrow'
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    }],
                                loc: {
                                    start: {
                                        line: 39,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/Bubble.ion'
                                    },
                                    end: {
                                        line: 39,
                                        column: 40,
                                        fixed: true,
                                        source: 'glass/html/material/Bubble.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 39,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/Bubble.ion'
                                },
                                end: {
                                    line: 39,
                                    column: 40,
                                    fixed: true,
                                    source: 'glass/html/material/Bubble.ion'
                                }
                            },
                            order: '0'
                        },
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'Identifier',
                                        name: 'Span',
                                        loc: {
                                            start: {
                                                line: 40,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/Bubble.ion'
                                            },
                                            end: {
                                                line: 40,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/Bubble.ion'
                                            }
                                        }
                                    },
                                    arguments: [{
                                            type: 'ObjectExpression',
                                            properties: [{
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'class',
                                                        loc: {
                                                            start: {
                                                                line: 40,
                                                                column: 18,
                                                                fixed: true,
                                                                source: 'glass/html/material/Bubble.ion'
                                                            },
                                                            end: {
                                                                line: 40,
                                                                column: 23,
                                                                fixed: true,
                                                                source: 'glass/html/material/Bubble.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 'bubble-box'
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                }]
                                        }],
                                    loc: {
                                        start: {
                                            line: 40,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/material/Bubble.ion'
                                        },
                                        end: {
                                            line: 40,
                                            column: 39,
                                            fixed: true,
                                            source: 'glass/html/material/Bubble.ion'
                                        }
                                    }
                                },
                                properties: [{
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'Literal',
                                            value: 'Foo Bar'
                                        },
                                        loc: {
                                            start: {
                                                line: 41,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/Bubble.ion'
                                            },
                                            end: {
                                                line: 41,
                                                column: 25,
                                                fixed: true,
                                                source: 'glass/html/material/Bubble.ion'
                                            }
                                        },
                                        order: '0'
                                    }]
                            },
                            loc: {
                                start: {
                                    line: 40,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/Bubble.ion'
                                },
                                end: {
                                    line: 42,
                                    column: 16,
                                    fixed: true,
                                    source: 'glass/html/material/Bubble.ion'
                                }
                            },
                            order: '1'
                        }
                    ]
                },
                order: '0'
            }],
        bound: false
    }, {
        this: this,
        style: style,
        _ref: _ref
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/Bubble',_glass_html_material_Bubble_);
    else
      _glass_html_material_Bubble_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_Bubble_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_Button_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('./'), style = require('../style');
var Shadow = _ref.Shadow;
ion.template(function () {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [{
                type: 'ExpressionStatement',
                expression: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'MemberExpression',
                        computed: false,
                        object: {
                            type: 'Identifier',
                            name: 'style',
                            loc: {
                                start: {
                                    line: 6,
                                    column: 4,
                                    fixed: true,
                                    source: 'glass/html/material/Button.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 9,
                                    fixed: true,
                                    source: 'glass/html/material/Button.ion'
                                }
                            }
                        },
                        property: {
                            type: 'Identifier',
                            name: 'sheets',
                            loc: {
                                start: {
                                    line: 6,
                                    column: 10,
                                    fixed: true,
                                    source: 'glass/html/material/Button.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 16,
                                    fixed: true,
                                    source: 'glass/html/material/Button.ion'
                                }
                            }
                        },
                        loc: {
                            start: {
                                line: 6,
                                column: 4,
                                fixed: true,
                                source: 'glass/html/material/Button.ion'
                            },
                            end: {
                                line: 6,
                                column: 16,
                                fixed: true,
                                source: 'glass/html/material/Button.ion'
                            }
                        }
                    },
                    properties: [{
                            type: 'Property',
                            key: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'module',
                                    loc: {
                                        start: {
                                            line: 7,
                                            column: 9,
                                            fixed: true,
                                            source: 'glass/html/material/Button.ion'
                                        },
                                        end: {
                                            line: 7,
                                            column: 15,
                                            fixed: true,
                                            source: 'glass/html/material/Button.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'id',
                                    loc: {
                                        start: {
                                            line: 7,
                                            column: 16,
                                            fixed: true,
                                            source: 'glass/html/material/Button.ion'
                                        },
                                        end: {
                                            line: 7,
                                            column: 18,
                                            fixed: true,
                                            source: 'glass/html/material/Button.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 7,
                                        column: 9,
                                        fixed: true,
                                        source: 'glass/html/material/Button.ion'
                                    },
                                    end: {
                                        line: 7,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/material/Button.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'BinaryExpression',
                                operator: '+',
                                left: {
                                    type: 'BinaryExpression',
                                    operator: '+',
                                    left: {
                                        type: 'BinaryExpression',
                                        operator: '+',
                                        left: {
                                            type: 'BinaryExpression',
                                            operator: '+',
                                            left: {
                                                type: 'Literal',
                                                value: '.Button {\n    text-transform: uppercase;\n    background: transparent;\n    border: none;\n    border-radius: 2px;\n    transition: background 0.2s linear, opacity 0.5s;\n    padding: 8px;\n    margin: 4px;\n    color: rgba(0,0,0,.54);\n}\n.Button:not(.disabled) {\n    color: '
                                            },
                                            right: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'style',
                                                        loc: {
                                                            start: {
                                                                line: 19,
                                                                column: 25,
                                                                fixed: true,
                                                                source: 'glass/html/material/Button.ion'
                                                            },
                                                            end: {
                                                                line: 19,
                                                                column: 30,
                                                                fixed: true,
                                                                source: 'glass/html/material/Button.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'color',
                                                        loc: {
                                                            start: {
                                                                line: 19,
                                                                column: 31,
                                                                fixed: true,
                                                                source: 'glass/html/material/Button.ion'
                                                            },
                                                            end: {
                                                                line: 19,
                                                                column: 36,
                                                                fixed: true,
                                                                source: 'glass/html/material/Button.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 19,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'glass/html/material/Button.ion'
                                                        },
                                                        end: {
                                                            line: 19,
                                                            column: 36,
                                                            fixed: true,
                                                            source: 'glass/html/material/Button.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'accentDark',
                                                    loc: {
                                                        start: {
                                                            line: 19,
                                                            column: 37,
                                                            fixed: true,
                                                            source: 'glass/html/material/Button.ion'
                                                        },
                                                        end: {
                                                            line: 19,
                                                            column: 47,
                                                            fixed: true,
                                                            source: 'glass/html/material/Button.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 19,
                                                        column: 25,
                                                        fixed: true,
                                                        source: 'glass/html/material/Button.ion'
                                                    },
                                                    end: {
                                                        line: 19,
                                                        column: 47,
                                                        fixed: true,
                                                        source: 'glass/html/material/Button.ion'
                                                    }
                                                }
                                            }
                                        },
                                        right: {
                                            type: 'Literal',
                                            value: ';\n    cursor: pointer;\n}\n.Button:focus {\n    outline: none;\n}\n.Button.disabled {\n    opacity: 0.3;\n}\n.Button.standard {\n    border: solid 1px rgba(0,0,0, '
                                        }
                                    },
                                    right: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'style',
                                                loc: {
                                                    start: {
                                                        line: 29,
                                                        column: 48,
                                                        fixed: true,
                                                        source: 'glass/html/material/Button.ion'
                                                    },
                                                    end: {
                                                        line: 29,
                                                        column: 53,
                                                        fixed: true,
                                                        source: 'glass/html/material/Button.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'opacity',
                                                loc: {
                                                    start: {
                                                        line: 29,
                                                        column: 54,
                                                        fixed: true,
                                                        source: 'glass/html/material/Button.ion'
                                                    },
                                                    end: {
                                                        line: 29,
                                                        column: 61,
                                                        fixed: true,
                                                        source: 'glass/html/material/Button.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 29,
                                                    column: 48,
                                                    fixed: true,
                                                    source: 'glass/html/material/Button.ion'
                                                },
                                                end: {
                                                    line: 29,
                                                    column: 61,
                                                    fixed: true,
                                                    source: 'glass/html/material/Button.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'divider',
                                            loc: {
                                                start: {
                                                    line: 29,
                                                    column: 62,
                                                    fixed: true,
                                                    source: 'glass/html/material/Button.ion'
                                                },
                                                end: {
                                                    line: 29,
                                                    column: 69,
                                                    fixed: true,
                                                    source: 'glass/html/material/Button.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 29,
                                                column: 48,
                                                fixed: true,
                                                source: 'glass/html/material/Button.ion'
                                            },
                                            end: {
                                                line: 29,
                                                column: 69,
                                                fixed: true,
                                                source: 'glass/html/material/Button.ion'
                                            }
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: ');\n    padding: 4px;\n}'
                                }
                            },
                            kind: 'init',
                            computed: true,
                            order: '0'
                        }]
                },
                loc: {
                    start: {
                        line: 6,
                        column: 4,
                        fixed: true,
                        source: 'glass/html/material/Button.ion'
                    },
                    end: {
                        line: 33,
                        column: 8,
                        fixed: true,
                        source: 'glass/html/material/Button.ion'
                    }
                },
                order: '0'
            }],
        bound: false
    }, {
        this: this,
        module: module,
        _ref: _ref,
        style: style,
        Shadow: Shadow
    }, null);
})().observe();
module.exports = exports = ion.template(function (attributes) {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [{
                type: 'ReturnStatement',
                argument: {
                    type: 'CallExpression',
                    callee: {
                        type: 'MemberExpression',
                        object: {
                            type: 'Identifier',
                            name: 'Object'
                        },
                        property: {
                            type: 'Identifier',
                            name: 'defineProperties'
                        }
                    },
                    arguments: [
                        {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Button',
                                    loc: {
                                        start: {
                                            line: 35,
                                            column: 11,
                                            fixed: true,
                                            source: 'glass/html/material/Button.ion'
                                        },
                                        end: {
                                            line: 35,
                                            column: 17,
                                            fixed: true,
                                            source: 'glass/html/material/Button.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'Identifier',
                                        name: 'attributes',
                                        loc: {
                                            start: {
                                                line: 35,
                                                column: 18,
                                                fixed: true,
                                                source: 'glass/html/material/Button.ion'
                                            },
                                            end: {
                                                line: 35,
                                                column: 28,
                                                fixed: true,
                                                source: 'glass/html/material/Button.ion'
                                            }
                                        }
                                    }],
                                loc: {
                                    start: {
                                        line: 35,
                                        column: 11,
                                        fixed: true,
                                        source: 'glass/html/material/Button.ion'
                                    },
                                    end: {
                                        line: 35,
                                        column: 29,
                                        fixed: true,
                                        source: 'glass/html/material/Button.ion'
                                    }
                                }
                            },
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'classList',
                                        loc: {
                                            start: {
                                                line: 36,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Button.ion'
                                            },
                                            end: {
                                                line: 36,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/Button.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'Literal',
                                                    value: 'Button'
                                                },
                                                loc: {
                                                    start: {
                                                        line: 37,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/Button.ion'
                                                    },
                                                    end: {
                                                        line: 37,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'glass/html/material/Button.ion'
                                                    }
                                                },
                                                order: '0'
                                            },
                                            {
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'Literal',
                                                    value: 'center'
                                                },
                                                loc: {
                                                    start: {
                                                        line: 38,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/Button.ion'
                                                    },
                                                    end: {
                                                        line: 38,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'glass/html/material/Button.ion'
                                                    }
                                                },
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    order: '0'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'Function',
                                        context: false,
                                        value: function click(e) {
                                            if (this.disabled) {
                                                e.stopImmediatePropagation();
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 39,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/Button.ion'
                                        },
                                        end: {
                                            line: 42,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/material/Button.ion'
                                        }
                                    },
                                    order: '1'
                                }
                            ]
                        },
                        {
                            type: 'ObjectExpression',
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'enabled',
                                        loc: {
                                            start: {
                                                line: 42,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/Button.ion'
                                            },
                                            end: {
                                                line: 42,
                                                column: 24,
                                                fixed: true,
                                                source: 'glass/html/material/Button.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 43,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Button.ion'
                                                        },
                                                        end: {
                                                            line: 43,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Button.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: false,
                                                    value: function () {
                                                        return !this.disabled;
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 44,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Button.ion'
                                                        },
                                                        end: {
                                                            line: 44,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Button.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: false,
                                                    value: function (value) {
                                                        return this.disabled = !value;
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'disabled',
                                        loc: {
                                            start: {
                                                line: 45,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/Button.ion'
                                            },
                                            end: {
                                                line: 45,
                                                column: 25,
                                                fixed: true,
                                                source: 'glass/html/material/Button.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 46,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Button.ion'
                                                        },
                                                        end: {
                                                            line: 46,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Button.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: false,
                                                    value: function () {
                                                        return this.classList.contains('disabled');
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 47,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Button.ion'
                                                        },
                                                        end: {
                                                            line: 47,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Button.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: false,
                                                    value: function (value) {
                                                        return this.classList.toggle('disabled', value);
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '1'
                                }
                            ]
                        }
                    ]
                },
                order: '0'
            }],
        bound: false
    }, {
        this: this,
        attributes: attributes,
        _ref: _ref,
        style: style,
        Shadow: Shadow
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/Button',_glass_html_material_Button_);
    else
      _glass_html_material_Button_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_Button_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_ButtonGroup_ = function(module,exports,require){'use strict';
var ion = require('ion');
var style = require('../style');
ion.template(function () {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [{
                type: 'ExpressionStatement',
                expression: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'MemberExpression',
                        computed: false,
                        object: {
                            type: 'Identifier',
                            name: 'style',
                            loc: {
                                start: {
                                    line: 7,
                                    column: 4,
                                    fixed: true,
                                    source: 'glass/html/material/ButtonGroup.ion'
                                },
                                end: {
                                    line: 7,
                                    column: 9,
                                    fixed: true,
                                    source: 'glass/html/material/ButtonGroup.ion'
                                }
                            }
                        },
                        property: {
                            type: 'Identifier',
                            name: 'sheets',
                            loc: {
                                start: {
                                    line: 7,
                                    column: 10,
                                    fixed: true,
                                    source: 'glass/html/material/ButtonGroup.ion'
                                },
                                end: {
                                    line: 7,
                                    column: 16,
                                    fixed: true,
                                    source: 'glass/html/material/ButtonGroup.ion'
                                }
                            }
                        },
                        loc: {
                            start: {
                                line: 7,
                                column: 4,
                                fixed: true,
                                source: 'glass/html/material/ButtonGroup.ion'
                            },
                            end: {
                                line: 7,
                                column: 16,
                                fixed: true,
                                source: 'glass/html/material/ButtonGroup.ion'
                            }
                        }
                    },
                    properties: [{
                            type: 'Property',
                            key: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'module',
                                    loc: {
                                        start: {
                                            line: 8,
                                            column: 9,
                                            fixed: true,
                                            source: 'glass/html/material/ButtonGroup.ion'
                                        },
                                        end: {
                                            line: 8,
                                            column: 15,
                                            fixed: true,
                                            source: 'glass/html/material/ButtonGroup.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'id',
                                    loc: {
                                        start: {
                                            line: 8,
                                            column: 16,
                                            fixed: true,
                                            source: 'glass/html/material/ButtonGroup.ion'
                                        },
                                        end: {
                                            line: 8,
                                            column: 18,
                                            fixed: true,
                                            source: 'glass/html/material/ButtonGroup.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 8,
                                        column: 9,
                                        fixed: true,
                                        source: 'glass/html/material/ButtonGroup.ion'
                                    },
                                    end: {
                                        line: 8,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/material/ButtonGroup.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Literal',
                                value: '.button-group .Button {\n    margin-right:0;\n    border-right-width:0;\n    border-radius:0;\n}\n.button-group .Button:not(:first-child) {\n    margin-left:0;\n}\n.button-group .Button:last-child {\n    border-right-width:1px;\n}'
                            },
                            kind: 'init',
                            computed: true,
                            order: '0'
                        }]
                },
                loc: {
                    start: {
                        line: 7,
                        column: 4,
                        fixed: true,
                        source: 'glass/html/material/ButtonGroup.ion'
                    },
                    end: {
                        line: 21,
                        column: 8,
                        fixed: true,
                        source: 'glass/html/material/ButtonGroup.ion'
                    }
                },
                order: '0'
            }],
        bound: false
    }, {
        this: this,
        module: module,
        style: style
    }, null);
})().observe();
module.exports = exports = ion.template(function (attributes) {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [{
                type: 'ReturnStatement',
                argument: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'CallExpression',
                        callee: {
                            type: 'Identifier',
                            name: 'Div',
                            loc: {
                                start: {
                                    line: 22,
                                    column: 11,
                                    fixed: true,
                                    source: 'glass/html/material/ButtonGroup.ion'
                                },
                                end: {
                                    line: 22,
                                    column: 14,
                                    fixed: true,
                                    source: 'glass/html/material/ButtonGroup.ion'
                                }
                            }
                        },
                        arguments: [{
                                type: 'Identifier',
                                name: 'attributes',
                                loc: {
                                    start: {
                                        line: 22,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/ButtonGroup.ion'
                                    },
                                    end: {
                                        line: 22,
                                        column: 25,
                                        fixed: true,
                                        source: 'glass/html/material/ButtonGroup.ion'
                                    }
                                }
                            }],
                        loc: {
                            start: {
                                line: 22,
                                column: 11,
                                fixed: true,
                                source: 'glass/html/material/ButtonGroup.ion'
                            },
                            end: {
                                line: 22,
                                column: 26,
                                fixed: true,
                                source: 'glass/html/material/ButtonGroup.ion'
                            }
                        }
                    },
                    properties: [{
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'classList',
                                loc: {
                                    start: {
                                        line: 23,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/ButtonGroup.ion'
                                    },
                                    end: {
                                        line: 23,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/html/material/ButtonGroup.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'ObjectExpression',
                                properties: [{
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'Literal',
                                            value: 'button-group'
                                        },
                                        loc: {
                                            start: {
                                                line: 24,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/ButtonGroup.ion'
                                            },
                                            end: {
                                                line: 24,
                                                column: 26,
                                                fixed: true,
                                                source: 'glass/html/material/ButtonGroup.ion'
                                            }
                                        },
                                        order: '0'
                                    }]
                            },
                            kind: 'init',
                            order: '0'
                        }]
                },
                order: '0'
            }],
        bound: false
    }, {
        this: this,
        attributes: attributes,
        style: style
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/ButtonGroup',_glass_html_material_ButtonGroup_);
    else
      _glass_html_material_ButtonGroup_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_ButtonGroup_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_Calendar_ = function(module,exports,require){'use strict';
var ion = require('ion'), _ref, _ref2;
_ref = require('../');
var style = _ref.style;
_ref2 = require('./');
var Button = _ref2.Button;
var Icon = _ref2.Icon;
ion.template(function () {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [{
                type: 'ExpressionStatement',
                expression: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'MemberExpression',
                        computed: false,
                        object: {
                            type: 'Identifier',
                            name: 'style',
                            loc: {
                                start: {
                                    line: 7,
                                    column: 4,
                                    fixed: true,
                                    source: 'glass/html/material/Calendar.ion'
                                },
                                end: {
                                    line: 7,
                                    column: 9,
                                    fixed: true,
                                    source: 'glass/html/material/Calendar.ion'
                                }
                            }
                        },
                        property: {
                            type: 'Identifier',
                            name: 'sheets',
                            loc: {
                                start: {
                                    line: 7,
                                    column: 10,
                                    fixed: true,
                                    source: 'glass/html/material/Calendar.ion'
                                },
                                end: {
                                    line: 7,
                                    column: 16,
                                    fixed: true,
                                    source: 'glass/html/material/Calendar.ion'
                                }
                            }
                        },
                        loc: {
                            start: {
                                line: 7,
                                column: 4,
                                fixed: true,
                                source: 'glass/html/material/Calendar.ion'
                            },
                            end: {
                                line: 7,
                                column: 16,
                                fixed: true,
                                source: 'glass/html/material/Calendar.ion'
                            }
                        }
                    },
                    properties: [{
                            type: 'Property',
                            key: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'module',
                                    loc: {
                                        start: {
                                            line: 8,
                                            column: 9,
                                            fixed: true,
                                            source: 'glass/html/material/Calendar.ion'
                                        },
                                        end: {
                                            line: 8,
                                            column: 15,
                                            fixed: true,
                                            source: 'glass/html/material/Calendar.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'id',
                                    loc: {
                                        start: {
                                            line: 8,
                                            column: 16,
                                            fixed: true,
                                            source: 'glass/html/material/Calendar.ion'
                                        },
                                        end: {
                                            line: 8,
                                            column: 18,
                                            fixed: true,
                                            source: 'glass/html/material/Calendar.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 8,
                                        column: 9,
                                        fixed: true,
                                        source: 'glass/html/material/Calendar.ion'
                                    },
                                    end: {
                                        line: 8,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/material/Calendar.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'BinaryExpression',
                                operator: '+',
                                left: {
                                    type: 'BinaryExpression',
                                    operator: '+',
                                    left: {
                                        type: 'BinaryExpression',
                                        operator: '+',
                                        left: {
                                            type: 'BinaryExpression',
                                            operator: '+',
                                            left: {
                                                type: 'BinaryExpression',
                                                operator: '+',
                                                left: {
                                                    type: 'BinaryExpression',
                                                    operator: '+',
                                                    left: {
                                                        type: 'BinaryExpression',
                                                        operator: '+',
                                                        left: {
                                                            type: 'BinaryExpression',
                                                            operator: '+',
                                                            left: {
                                                                type: 'Literal',
                                                                value: '.Calendar {\n    # display:flex;\n    # flex-direction:column;\n    background-color:white;\n    font-size:12px;\n    min-width:300px;\n}\n\n.Calendar > tr {\n    flex:1;\n    display:flex;\n}\n.Calendar tr td {\n    flex:1;\n    text-align: center;\n    padding:9px;\n    position:relative;\n}\n.Calendar td.current-month {\n    background-color:#eaeaea;\n}\n.Calendar tr.day-header {\n    font-weight:500;\n    color:#666;\n}\n.Calendar .inactive {\n    color:#777;\n}\n.Calendar td.today {\n    background-color:#dadada;\n}\n.Calendar td:not(.th):hover {\n    # color:white;\n    background-color:'
                                                            },
                                                            right: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'style',
                                                                        loc: {
                                                                            start: {
                                                                                line: 42,
                                                                                column: 35,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Calendar.ion'
                                                                            },
                                                                            end: {
                                                                                line: 42,
                                                                                column: 40,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Calendar.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'toRgba',
                                                                        loc: {
                                                                            start: {
                                                                                line: 42,
                                                                                column: 41,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Calendar.ion'
                                                                            },
                                                                            end: {
                                                                                line: 42,
                                                                                column: 47,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Calendar.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 42,
                                                                            column: 35,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Calendar.ion'
                                                                        },
                                                                        end: {
                                                                            line: 42,
                                                                            column: 47,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Calendar.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [
                                                                    {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'style',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 42,
                                                                                        column: 48,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 42,
                                                                                        column: 53,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'color',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 42,
                                                                                        column: 54,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 42,
                                                                                        column: 59,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 42,
                                                                                    column: 48,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 42,
                                                                                    column: 59,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'accent',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 42,
                                                                                    column: 60,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 42,
                                                                                    column: 66,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 42,
                                                                                column: 48,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Calendar.ion'
                                                                            },
                                                                            end: {
                                                                                line: 42,
                                                                                column: 66,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Calendar.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    {
                                                                        type: 'Literal',
                                                                        value: 0.24
                                                                    }
                                                                ],
                                                                loc: {
                                                                    start: {
                                                                        line: 42,
                                                                        column: 35,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Calendar.ion'
                                                                    },
                                                                    end: {
                                                                        line: 42,
                                                                        column: 71,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Calendar.ion'
                                                                    }
                                                                }
                                                            }
                                                        },
                                                        right: {
                                                            type: 'Literal',
                                                            value: ';\n}\n.Calendar td.selected, .Calendar td.selected.today {\n    color:white;\n    background-color:'
                                                        }
                                                    },
                                                    right: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'style',
                                                                loc: {
                                                                    start: {
                                                                        line: 46,
                                                                        column: 35,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Calendar.ion'
                                                                    },
                                                                    end: {
                                                                        line: 46,
                                                                        column: 40,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Calendar.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'color',
                                                                loc: {
                                                                    start: {
                                                                        line: 46,
                                                                        column: 41,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Calendar.ion'
                                                                    },
                                                                    end: {
                                                                        line: 46,
                                                                        column: 46,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Calendar.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 46,
                                                                    column: 35,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                },
                                                                end: {
                                                                    line: 46,
                                                                    column: 46,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'accent',
                                                            loc: {
                                                                start: {
                                                                    line: 46,
                                                                    column: 47,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                },
                                                                end: {
                                                                    line: 46,
                                                                    column: 53,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 46,
                                                                column: 35,
                                                                fixed: true,
                                                                source: 'glass/html/material/Calendar.ion'
                                                            },
                                                            end: {
                                                                line: 46,
                                                                column: 53,
                                                                fixed: true,
                                                                source: 'glass/html/material/Calendar.ion'
                                                            }
                                                        }
                                                    }
                                                },
                                                right: {
                                                    type: 'Literal',
                                                    value: ';\n}\n\n.Calendar header {\n    background-color:'
                                                }
                                            },
                                            right: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'style',
                                                        loc: {
                                                            start: {
                                                                line: 50,
                                                                column: 35,
                                                                fixed: true,
                                                                source: 'glass/html/material/Calendar.ion'
                                                            },
                                                            end: {
                                                                line: 50,
                                                                column: 40,
                                                                fixed: true,
                                                                source: 'glass/html/material/Calendar.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'color',
                                                        loc: {
                                                            start: {
                                                                line: 50,
                                                                column: 41,
                                                                fixed: true,
                                                                source: 'glass/html/material/Calendar.ion'
                                                            },
                                                            end: {
                                                                line: 50,
                                                                column: 46,
                                                                fixed: true,
                                                                source: 'glass/html/material/Calendar.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 50,
                                                            column: 35,
                                                            fixed: true,
                                                            source: 'glass/html/material/Calendar.ion'
                                                        },
                                                        end: {
                                                            line: 50,
                                                            column: 46,
                                                            fixed: true,
                                                            source: 'glass/html/material/Calendar.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'primary',
                                                    loc: {
                                                        start: {
                                                            line: 50,
                                                            column: 47,
                                                            fixed: true,
                                                            source: 'glass/html/material/Calendar.ion'
                                                        },
                                                        end: {
                                                            line: 50,
                                                            column: 54,
                                                            fixed: true,
                                                            source: 'glass/html/material/Calendar.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 50,
                                                        column: 35,
                                                        fixed: true,
                                                        source: 'glass/html/material/Calendar.ion'
                                                    },
                                                    end: {
                                                        line: 50,
                                                        column: 54,
                                                        fixed: true,
                                                        source: 'glass/html/material/Calendar.ion'
                                                    }
                                                }
                                            }
                                        },
                                        right: {
                                            type: 'Literal',
                                            value: ';\n    # margin-bottom:10px;\n    padding:'
                                        }
                                    },
                                    right: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'style',
                                                loc: {
                                                    start: {
                                                        line: 52,
                                                        column: 26,
                                                        fixed: true,
                                                        source: 'glass/html/material/Calendar.ion'
                                                    },
                                                    end: {
                                                        line: 52,
                                                        column: 31,
                                                        fixed: true,
                                                        source: 'glass/html/material/Calendar.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'spacing',
                                                loc: {
                                                    start: {
                                                        line: 52,
                                                        column: 32,
                                                        fixed: true,
                                                        source: 'glass/html/material/Calendar.ion'
                                                    },
                                                    end: {
                                                        line: 52,
                                                        column: 39,
                                                        fixed: true,
                                                        source: 'glass/html/material/Calendar.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 52,
                                                    column: 26,
                                                    fixed: true,
                                                    source: 'glass/html/material/Calendar.ion'
                                                },
                                                end: {
                                                    line: 52,
                                                    column: 39,
                                                    fixed: true,
                                                    source: 'glass/html/material/Calendar.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'buffer',
                                            loc: {
                                                start: {
                                                    line: 52,
                                                    column: 40,
                                                    fixed: true,
                                                    source: 'glass/html/material/Calendar.ion'
                                                },
                                                end: {
                                                    line: 52,
                                                    column: 46,
                                                    fixed: true,
                                                    source: 'glass/html/material/Calendar.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 52,
                                                column: 26,
                                                fixed: true,
                                                source: 'glass/html/material/Calendar.ion'
                                            },
                                            end: {
                                                line: 52,
                                                column: 46,
                                                fixed: true,
                                                source: 'glass/html/material/Calendar.ion'
                                            }
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: 'px;\n}\n.Calendar header h1, .Calendar header h3{\n    margin:0;\n}\n.Calendar > header > h1.date-header {\n    font-size:30px;\n    line-height:40px;\n    font-weight:500;\n    margin:0;\n}\n.Calendar > header > h3{\n    font-size:15px;\n}\n.Calendar footer button{\n    font-size:13px;\n}'
                                }
                            },
                            kind: 'init',
                            computed: true,
                            order: '0'
                        }]
                },
                loc: {
                    start: {
                        line: 7,
                        column: 4,
                        fixed: true,
                        source: 'glass/html/material/Calendar.ion'
                    },
                    end: {
                        line: 71,
                        column: 8,
                        fixed: true,
                        source: 'glass/html/material/Calendar.ion'
                    }
                },
                order: '0'
            }],
        bound: false
    }, {
        this: this,
        module: module,
        ion: ion,
        _ref: _ref,
        _ref2: _ref2,
        style: style,
        Button: Button,
        Icon: Icon
    }, null);
})().observe();
module.exports = exports = ion.template(function (_ref3) {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'config',
                            loc: {
                                start: {
                                    line: 71,
                                    column: 18,
                                    fixed: true,
                                    source: 'glass/html/material/Calendar.ion'
                                },
                                end: {
                                    line: 71,
                                    column: 24,
                                    fixed: true,
                                    source: 'glass/html/material/Calendar.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'config',
                                loc: {
                                    start: {
                                        line: 71,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/material/Calendar.ion'
                                    },
                                    end: {
                                        line: 71,
                                        column: 24,
                                        fixed: true,
                                        source: 'glass/html/material/Calendar.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: '_value',
                            loc: {
                                start: {
                                    line: 71,
                                    column: 32,
                                    fixed: true,
                                    source: 'glass/html/material/Calendar.ion'
                                },
                                end: {
                                    line: 71,
                                    column: 38,
                                    fixed: true,
                                    source: 'glass/html/material/Calendar.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'value',
                                loc: {
                                    start: {
                                        line: 71,
                                        column: 26,
                                        fixed: true,
                                        source: 'glass/html/material/Calendar.ion'
                                    },
                                    end: {
                                        line: 71,
                                        column: 31,
                                        fixed: true,
                                        source: 'glass/html/material/Calendar.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'daysInMonth',
                            loc: {
                                start: {
                                    line: 73,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/Calendar.ion'
                                },
                                end: {
                                    line: 73,
                                    column: 19,
                                    fixed: true,
                                    source: 'glass/html/material/Calendar.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ArrayExpression',
                            elements: [
                                {
                                    type: 'Literal',
                                    value: 31
                                },
                                {
                                    type: 'Literal',
                                    value: 28
                                },
                                {
                                    type: 'Literal',
                                    value: 31
                                },
                                {
                                    type: 'Literal',
                                    value: 30
                                },
                                {
                                    type: 'Literal',
                                    value: 31
                                },
                                {
                                    type: 'Literal',
                                    value: 30
                                },
                                {
                                    type: 'Literal',
                                    value: 31
                                },
                                {
                                    type: 'Literal',
                                    value: 31
                                },
                                {
                                    type: 'Literal',
                                    value: 30
                                },
                                {
                                    type: 'Literal',
                                    value: 31
                                },
                                {
                                    type: 'Literal',
                                    value: 30
                                },
                                {
                                    type: 'Literal',
                                    value: 31
                                }
                            ]
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'daysOfWeek',
                            loc: {
                                start: {
                                    line: 74,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/Calendar.ion'
                                },
                                end: {
                                    line: 74,
                                    column: 18,
                                    fixed: true,
                                    source: 'glass/html/material/Calendar.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ArrayExpression',
                            elements: [
                                {
                                    type: 'Literal',
                                    value: 'Sunday'
                                },
                                {
                                    type: 'Literal',
                                    value: 'Monday'
                                },
                                {
                                    type: 'Literal',
                                    value: 'Tuesday'
                                },
                                {
                                    type: 'Literal',
                                    value: 'Wednesday'
                                },
                                {
                                    type: 'Literal',
                                    value: 'Thursday'
                                },
                                {
                                    type: 'Literal',
                                    value: 'Friday'
                                },
                                {
                                    type: 'Literal',
                                    value: 'Saturday'
                                }
                            ]
                        }
                    }],
                kind: 'let',
                order: '3'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'selection',
                            loc: {
                                start: {
                                    line: 76,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/Calendar.ion'
                                },
                                end: {
                                    line: 76,
                                    column: 17,
                                    fixed: true,
                                    source: 'glass/html/material/Calendar.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'Date',
                                    loc: {
                                        start: {
                                            line: 76,
                                            column: 20,
                                            fixed: true,
                                            source: 'glass/html/material/Calendar.ion'
                                        },
                                        end: {
                                            line: 76,
                                            column: 24,
                                            fixed: true,
                                            source: 'glass/html/material/Calendar.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'create',
                                    loc: {
                                        start: {
                                            line: 76,
                                            column: 25,
                                            fixed: true,
                                            source: 'glass/html/material/Calendar.ion'
                                        },
                                        end: {
                                            line: 76,
                                            column: 31,
                                            fixed: true,
                                            source: 'glass/html/material/Calendar.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 76,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/Calendar.ion'
                                    },
                                    end: {
                                        line: 76,
                                        column: 31,
                                        fixed: true,
                                        source: 'glass/html/material/Calendar.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ConditionalExpression',
                                    test: {
                                        type: 'BinaryExpression',
                                        operator: '!=',
                                        left: {
                                            type: 'Identifier',
                                            name: '_value',
                                            loc: {
                                                start: {
                                                    line: 76,
                                                    column: 32,
                                                    fixed: true,
                                                    source: 'glass/html/material/Calendar.ion'
                                                },
                                                end: {
                                                    line: 76,
                                                    column: 38,
                                                    fixed: true,
                                                    source: 'glass/html/material/Calendar.ion'
                                                }
                                            }
                                        },
                                        right: {
                                            type: 'Literal',
                                            value: null
                                        }
                                    },
                                    consequent: {
                                        type: 'Identifier',
                                        name: '_value',
                                        loc: {
                                            start: {
                                                line: 76,
                                                column: 32,
                                                fixed: true,
                                                source: 'glass/html/material/Calendar.ion'
                                            },
                                            end: {
                                                line: 76,
                                                column: 38,
                                                fixed: true,
                                                source: 'glass/html/material/Calendar.ion'
                                            }
                                        }
                                    },
                                    alternate: {
                                        type: 'Literal',
                                        value: 'today'
                                    }
                                }],
                            loc: {
                                start: {
                                    line: 76,
                                    column: 20,
                                    fixed: true,
                                    source: 'glass/html/material/Calendar.ion'
                                },
                                end: {
                                    line: 76,
                                    column: 49,
                                    fixed: true,
                                    source: 'glass/html/material/Calendar.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '4'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'state',
                            loc: {
                                start: {
                                    line: 77,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/Calendar.ion'
                                },
                                end: {
                                    line: 77,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/html/material/Calendar.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'ObjectExpression',
                                properties: []
                            },
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'selectedDate',
                                        loc: {
                                            start: {
                                                line: 78,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Calendar.ion'
                                            },
                                            end: {
                                                line: 78,
                                                column: 20,
                                                fixed: true,
                                                source: 'glass/html/material/Calendar.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Identifier',
                                        name: 'selection',
                                        loc: {
                                            start: {
                                                line: 78,
                                                column: 22,
                                                fixed: true,
                                                source: 'glass/html/material/Calendar.ion'
                                            },
                                            end: {
                                                line: 78,
                                                column: 31,
                                                fixed: true,
                                                source: 'glass/html/material/Calendar.ion'
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'date',
                                        loc: {
                                            start: {
                                                line: 79,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Calendar.ion'
                                            },
                                            end: {
                                                line: 79,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/Calendar.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Identifier',
                                        name: 'selection',
                                        loc: {
                                            start: {
                                                line: 79,
                                                column: 14,
                                                fixed: true,
                                                source: 'glass/html/material/Calendar.ion'
                                            },
                                            end: {
                                                line: 79,
                                                column: 23,
                                                fixed: true,
                                                source: 'glass/html/material/Calendar.ion'
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '1'
                                }
                            ]
                        }
                    }],
                kind: 'let',
                order: '5'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'view',
                            loc: {
                                start: {
                                    line: 82,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/Calendar.ion'
                                },
                                end: {
                                    line: 82,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/Calendar.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'getStart',
                                        loc: {
                                            start: {
                                                line: 83,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Calendar.ion'
                                            },
                                            end: {
                                                line: 83,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/Calendar.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: false,
                                        value: function (_ref4) {
                                            var date = _ref4.date;
                                            return date.clone().beginningOfMonth();
                                        }
                                    },
                                    kind: 'init',
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'getFinish',
                                        loc: {
                                            start: {
                                                line: 85,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Calendar.ion'
                                            },
                                            end: {
                                                line: 85,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/Calendar.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: false,
                                        value: function (_ref5) {
                                            var date = _ref5.date;
                                            return date.clone().endOfMonth();
                                        }
                                    },
                                    kind: 'init',
                                    order: '1'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'getTitle',
                                        loc: {
                                            start: {
                                                line: 87,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Calendar.ion'
                                            },
                                            end: {
                                                line: 87,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/Calendar.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: false,
                                        value: function (_ref6) {
                                            var start = _ref6.start;
                                            var finish = _ref6.finish;
                                            return start.format('{Month} {yyyy}');
                                        }
                                    },
                                    kind: 'init',
                                    order: '2'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'getUnitTitle',
                                        loc: {
                                            start: {
                                                line: 89,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Calendar.ion'
                                            },
                                            end: {
                                                line: 89,
                                                column: 20,
                                                fixed: true,
                                                source: 'glass/html/material/Calendar.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: false,
                                        value: function (_ref7) {
                                            var start = _ref7.start;
                                            var finish = _ref7.finish;
                                            return start.format('{Dow}').substring(0, 1) + ' ' + start.format('{dd}');
                                        }
                                    },
                                    kind: 'init',
                                    order: '3'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'incrementUnit',
                                        loc: {
                                            start: {
                                                line: 91,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Calendar.ion'
                                            },
                                            end: {
                                                line: 91,
                                                column: 21,
                                                fixed: true,
                                                source: 'glass/html/material/Calendar.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context) {
                                            return function (date) {
                                                var state = _context.get('state');
                                                return state.indexDate = date.clone().addDays(1);
                                            };
                                        }
                                    },
                                    kind: 'init',
                                    order: '4'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'getCalendarStart',
                                        loc: {
                                            start: {
                                                line: 93,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Calendar.ion'
                                            },
                                            end: {
                                                line: 93,
                                                column: 24,
                                                fixed: true,
                                                source: 'glass/html/material/Calendar.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context2) {
                                            return function (_ref8) {
                                                var daysOfWeek = _context2.get('daysOfWeek');
                                                var start = _ref8.start;
                                                var dow = daysOfWeek.indexOf(start.format('{Weekday}'));
                                                if (dow === 0) {
                                                    return start;
                                                }
                                                return start.clone().addDays(-1 * dow);
                                            };
                                        }
                                    },
                                    kind: 'init',
                                    order: '5'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'getCalendarFinish',
                                        loc: {
                                            start: {
                                                line: 98,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Calendar.ion'
                                            },
                                            end: {
                                                line: 98,
                                                column: 25,
                                                fixed: true,
                                                source: 'glass/html/material/Calendar.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context3) {
                                            return function (_ref9) {
                                                var daysOfWeek = _context3.get('daysOfWeek');
                                                var finish = _ref9.finish;
                                                var dow = daysOfWeek.indexOf(finish.format('{Weekday}'));
                                                if (dow === 6) {
                                                    return finish;
                                                } else {
                                                    return finish.clone().addDays(6 - dow);
                                                }
                                            };
                                        }
                                    },
                                    kind: 'init',
                                    order: '6'
                                }
                            ]
                        }
                    }],
                kind: 'let',
                order: '6'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'getCalendarRowCells',
                            loc: {
                                start: {
                                    line: 105,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/Calendar.ion'
                                },
                                end: {
                                    line: 105,
                                    column: 27,
                                    fixed: true,
                                    source: 'glass/html/material/Calendar.ion'
                                }
                            }
                        },
                        init: {
                            type: 'Function',
                            context: true,
                            value: function (_context4) {
                                return function (_ref10) {
                                    var view = _context4.get('view'), ion = _context4.get('ion');
                                    var calStart = _ref10.calStart;
                                    var calFinish = _ref10.calFinish;
                                    var cache = _ref10.cache;
                                    var rows = [];
                                    var cells = [];
                                    var date = calStart;
                                    var rowIndex = 0;
                                    var colIndex = 0;
                                    while (date < calFinish) {
                                        cells[rowIndex] = cells[rowIndex] != null ? cells[rowIndex] : [];
                                        cells[rowIndex][colIndex] = { date: date.iso() };
                                        date = view.incrementUnit(date);
                                        if (colIndex === 6) {
                                            colIndex = 0;
                                            rowIndex++;
                                        } else {
                                            colIndex++;
                                        }
                                    }
                                    var diff = ion.patch.diff(cache, cells);
                                    ion.patch(cache, diff);
                                    return cache;
                                };
                            }
                        }
                    }],
                kind: 'let',
                order: '7'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'element',
                            loc: {
                                start: {
                                    line: 125,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/Calendar.ion'
                                },
                                end: {
                                    line: 125,
                                    column: 15,
                                    fixed: true,
                                    source: 'glass/html/material/Calendar.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Div',
                                loc: {
                                    start: {
                                        line: 125,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/material/Calendar.ion'
                                    },
                                    end: {
                                        line: 125,
                                        column: 21,
                                        fixed: true,
                                        source: 'glass/html/material/Calendar.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ObjectExpression',
                                    properties: [{
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'class',
                                                loc: {
                                                    start: {
                                                        line: 125,
                                                        column: 23,
                                                        fixed: true,
                                                        source: 'glass/html/material/Calendar.ion'
                                                    },
                                                    end: {
                                                        line: 125,
                                                        column: 28,
                                                        fixed: true,
                                                        source: 'glass/html/material/Calendar.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: 'Calendar flex layout vertical'
                                            },
                                            kind: 'init',
                                            order: '0'
                                        }]
                                }],
                            loc: {
                                start: {
                                    line: 125,
                                    column: 18,
                                    fixed: true,
                                    source: 'glass/html/material/Calendar.ion'
                                },
                                end: {
                                    line: 125,
                                    column: 62,
                                    fixed: true,
                                    source: 'glass/html/material/Calendar.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '8'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'CallExpression',
                    callee: {
                        type: 'MemberExpression',
                        object: {
                            type: 'Identifier',
                            name: 'Object'
                        },
                        property: {
                            type: 'Identifier',
                            name: 'defineProperties'
                        }
                    },
                    arguments: [
                        {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'Identifier',
                                name: 'element',
                                loc: {
                                    start: {
                                        line: 127,
                                        column: 11,
                                        fixed: true,
                                        source: 'glass/html/material/Calendar.ion'
                                    },
                                    end: {
                                        line: 127,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/material/Calendar.ion'
                                    }
                                }
                            },
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'highlightDate',
                                        loc: {
                                            start: {
                                                line: 128,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Calendar.ion'
                                            },
                                            end: {
                                                line: 128,
                                                column: 21,
                                                fixed: true,
                                                source: 'glass/html/material/Calendar.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context5) {
                                            return function (date) {
                                                var state = _context5.get('state');
                                                console.log('HIGHLIGHT');
                                                console.dir(date);
                                                state.date = date;
                                            };
                                        }
                                    },
                                    kind: 'init',
                                    order: '0'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'ObjectExpression',
                                        objectType: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'Identifier',
                                                name: 'Header',
                                                loc: {
                                                    start: {
                                                        line: 142,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'glass/html/material/Calendar.ion'
                                                    },
                                                    end: {
                                                        line: 142,
                                                        column: 14,
                                                        fixed: true,
                                                        source: 'glass/html/material/Calendar.ion'
                                                    }
                                                }
                                            },
                                            arguments: [{
                                                    type: 'ObjectExpression',
                                                    properties: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'class',
                                                                loc: {
                                                                    start: {
                                                                        line: 142,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Calendar.ion'
                                                                    },
                                                                    end: {
                                                                        line: 142,
                                                                        column: 21,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Calendar.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Literal',
                                                                value: 'fixed background-primary white calendar-header'
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                }],
                                            loc: {
                                                start: {
                                                    line: 142,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'glass/html/material/Calendar.ion'
                                                },
                                                end: {
                                                    line: 142,
                                                    column: 72,
                                                    fixed: true,
                                                    source: 'glass/html/material/Calendar.ion'
                                                }
                                            }
                                        },
                                        properties: [
                                            {
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'ObjectExpression',
                                                    objectType: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'Identifier',
                                                            name: 'H3',
                                                            loc: {
                                                                start: {
                                                                    line: 143,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                },
                                                                end: {
                                                                    line: 143,
                                                                    column: 14,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [{
                                                                type: 'ObjectExpression',
                                                                properties: [{
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'class',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 143,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 143,
                                                                                    column: 21,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Literal',
                                                                            value: 'white secondary'
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    }]
                                                            }],
                                                        loc: {
                                                            start: {
                                                                line: 143,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'glass/html/material/Calendar.ion'
                                                            },
                                                            end: {
                                                                line: 143,
                                                                column: 41,
                                                                fixed: true,
                                                                source: 'glass/html/material/Calendar.ion'
                                                            }
                                                        }
                                                    },
                                                    properties: [{
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'state',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 144,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 144,
                                                                                    column: 21,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'date',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 144,
                                                                                    column: 22,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 144,
                                                                                    column: 26,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 144,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Calendar.ion'
                                                                            },
                                                                            end: {
                                                                                line: 144,
                                                                                column: 26,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Calendar.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'format',
                                                                        loc: {
                                                                            start: {
                                                                                line: 144,
                                                                                column: 27,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Calendar.ion'
                                                                            },
                                                                            end: {
                                                                                line: 144,
                                                                                column: 33,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Calendar.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 144,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Calendar.ion'
                                                                        },
                                                                        end: {
                                                                            line: 144,
                                                                            column: 33,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Calendar.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'Literal',
                                                                        value: '{year}'
                                                                    }],
                                                                loc: {
                                                                    start: {
                                                                        line: 144,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Calendar.ion'
                                                                    },
                                                                    end: {
                                                                        line: 144,
                                                                        column: 43,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Calendar.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 144,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                },
                                                                end: {
                                                                    line: 144,
                                                                    column: 43,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                }
                                                            },
                                                            order: '0'
                                                        }]
                                                },
                                                loc: {
                                                    start: {
                                                        line: 143,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/Calendar.ion'
                                                    },
                                                    end: {
                                                        line: 145,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'glass/html/material/Calendar.ion'
                                                    }
                                                },
                                                order: '0'
                                            },
                                            {
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'ObjectExpression',
                                                    objectType: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'Identifier',
                                                            name: 'H1',
                                                            loc: {
                                                                start: {
                                                                    line: 145,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                },
                                                                end: {
                                                                    line: 145,
                                                                    column: 14,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [{
                                                                type: 'ObjectExpression',
                                                                properties: [{
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'class',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 145,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 145,
                                                                                    column: 21,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Literal',
                                                                            value: 'date-header white'
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    }]
                                                            }],
                                                        loc: {
                                                            start: {
                                                                line: 145,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'glass/html/material/Calendar.ion'
                                                            },
                                                            end: {
                                                                line: 145,
                                                                column: 43,
                                                                fixed: true,
                                                                source: 'glass/html/material/Calendar.ion'
                                                            }
                                                        }
                                                    },
                                                    properties: [{
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'state',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 146,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 146,
                                                                                    column: 21,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'date',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 146,
                                                                                    column: 22,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 146,
                                                                                    column: 26,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 146,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Calendar.ion'
                                                                            },
                                                                            end: {
                                                                                line: 146,
                                                                                column: 26,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Calendar.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'format',
                                                                        loc: {
                                                                            start: {
                                                                                line: 146,
                                                                                column: 27,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Calendar.ion'
                                                                            },
                                                                            end: {
                                                                                line: 146,
                                                                                column: 33,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Calendar.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 146,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Calendar.ion'
                                                                        },
                                                                        end: {
                                                                            line: 146,
                                                                            column: 33,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Calendar.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'Literal',
                                                                        value: '{Dow}, {Mon} {d}'
                                                                    }],
                                                                loc: {
                                                                    start: {
                                                                        line: 146,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Calendar.ion'
                                                                    },
                                                                    end: {
                                                                        line: 146,
                                                                        column: 53,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Calendar.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 146,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                },
                                                                end: {
                                                                    line: 146,
                                                                    column: 53,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                }
                                                            },
                                                            order: '0'
                                                        }]
                                                },
                                                loc: {
                                                    start: {
                                                        line: 145,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/Calendar.ion'
                                                    },
                                                    end: {
                                                        line: 148,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'glass/html/material/Calendar.ion'
                                                    }
                                                },
                                                order: '1'
                                            }
                                        ]
                                    },
                                    loc: {
                                        start: {
                                            line: 142,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/Calendar.ion'
                                        },
                                        end: {
                                            line: 148,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/material/Calendar.ion'
                                        }
                                    },
                                    order: '1'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'ObjectExpression',
                                        objectType: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'Identifier',
                                                name: 'Div',
                                                loc: {
                                                    start: {
                                                        line: 148,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'glass/html/material/Calendar.ion'
                                                    },
                                                    end: {
                                                        line: 148,
                                                        column: 11,
                                                        fixed: true,
                                                        source: 'glass/html/material/Calendar.ion'
                                                    }
                                                }
                                            },
                                            arguments: [{
                                                    type: 'ObjectExpression',
                                                    properties: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'class',
                                                                loc: {
                                                                    start: {
                                                                        line: 148,
                                                                        column: 13,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Calendar.ion'
                                                                    },
                                                                    end: {
                                                                        line: 148,
                                                                        column: 18,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Calendar.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Literal',
                                                                value: 'fixed layout horizontal center center-justified'
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                }],
                                            loc: {
                                                start: {
                                                    line: 148,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'glass/html/material/Calendar.ion'
                                                },
                                                end: {
                                                    line: 148,
                                                    column: 70,
                                                    fixed: true,
                                                    source: 'glass/html/material/Calendar.ion'
                                                }
                                            }
                                        },
                                        properties: [
                                            {
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'ObjectExpression',
                                                    objectType: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'Identifier',
                                                            name: 'Button',
                                                            loc: {
                                                                start: {
                                                                    line: 149,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                },
                                                                end: {
                                                                    line: 149,
                                                                    column: 18,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [],
                                                        loc: {
                                                            start: {
                                                                line: 149,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'glass/html/material/Calendar.ion'
                                                            },
                                                            end: {
                                                                line: 149,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'glass/html/material/Calendar.ion'
                                                            }
                                                        }
                                                    },
                                                    properties: [
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'classList',
                                                                loc: {
                                                                    start: {
                                                                        line: 150,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Calendar.ion'
                                                                    },
                                                                    end: {
                                                                        line: 150,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Calendar.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'ObjectExpression',
                                                                properties: [{
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'Literal',
                                                                            value: 'flex'
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 151,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Calendar.ion'
                                                                            },
                                                                            end: {
                                                                                line: 151,
                                                                                column: 26,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Calendar.ion'
                                                                            }
                                                                        },
                                                                        order: '0'
                                                                    }]
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        },
                                                        {
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'Function',
                                                                context: true,
                                                                value: function (_context6) {
                                                                    return function click(e) {
                                                                        var state = _context6.get('state');
                                                                        state.date = state.date.clone().addMonths(-1);
                                                                    };
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 152,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                },
                                                                end: {
                                                                    line: 154,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                }
                                                            },
                                                            order: '1'
                                                        },
                                                        {
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Identifier',
                                                                    name: 'Icon',
                                                                    loc: {
                                                                        start: {
                                                                            line: 154,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Calendar.ion'
                                                                        },
                                                                        end: {
                                                                            line: 154,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Calendar.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'ObjectExpression',
                                                                        properties: [{
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'name',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 154,
                                                                                            column: 22,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Calendar.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 154,
                                                                                            column: 26,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Calendar.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Literal',
                                                                                    value: 'keyboard arrow left'
                                                                                },
                                                                                kind: 'init',
                                                                                order: '0'
                                                                            }]
                                                                    }],
                                                                loc: {
                                                                    start: {
                                                                        line: 154,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Calendar.ion'
                                                                    },
                                                                    end: {
                                                                        line: 154,
                                                                        column: 50,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Calendar.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 154,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                },
                                                                end: {
                                                                    line: 154,
                                                                    column: 50,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                }
                                                            },
                                                            order: '2'
                                                        }
                                                    ]
                                                },
                                                loc: {
                                                    start: {
                                                        line: 149,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/Calendar.ion'
                                                    },
                                                    end: {
                                                        line: 155,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'glass/html/material/Calendar.ion'
                                                    }
                                                },
                                                order: '0'
                                            },
                                            {
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'ObjectExpression',
                                                    objectType: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'Identifier',
                                                            name: 'Span',
                                                            loc: {
                                                                start: {
                                                                    line: 155,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                },
                                                                end: {
                                                                    line: 155,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [{
                                                                type: 'ObjectExpression',
                                                                properties: [{
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'class',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 155,
                                                                                    column: 18,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 155,
                                                                                    column: 23,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Literal',
                                                                            value: 'flex'
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    }]
                                                            }],
                                                        loc: {
                                                            start: {
                                                                line: 155,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'glass/html/material/Calendar.ion'
                                                            },
                                                            end: {
                                                                line: 155,
                                                                column: 32,
                                                                fixed: true,
                                                                source: 'glass/html/material/Calendar.ion'
                                                            }
                                                        }
                                                    },
                                                    properties: [
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'style',
                                                                loc: {
                                                                    start: {
                                                                        line: 156,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Calendar.ion'
                                                                    },
                                                                    end: {
                                                                        line: 156,
                                                                        column: 21,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Calendar.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'ObjectExpression',
                                                                properties: [{
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Literal',
                                                                            value: 'text-align'
                                                                        },
                                                                        value: {
                                                                            type: 'Literal',
                                                                            value: 'center'
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    }]
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        },
                                                        {
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'state',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 158,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 158,
                                                                                    column: 21,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'date',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 158,
                                                                                    column: 22,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 158,
                                                                                    column: 26,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 158,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Calendar.ion'
                                                                            },
                                                                            end: {
                                                                                line: 158,
                                                                                column: 26,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Calendar.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'format',
                                                                        loc: {
                                                                            start: {
                                                                                line: 158,
                                                                                column: 27,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Calendar.ion'
                                                                            },
                                                                            end: {
                                                                                line: 158,
                                                                                column: 33,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Calendar.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 158,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Calendar.ion'
                                                                        },
                                                                        end: {
                                                                            line: 158,
                                                                            column: 33,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Calendar.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'Literal',
                                                                        value: '{Month}'
                                                                    }],
                                                                loc: {
                                                                    start: {
                                                                        line: 158,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Calendar.ion'
                                                                    },
                                                                    end: {
                                                                        line: 158,
                                                                        column: 44,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Calendar.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 158,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                },
                                                                end: {
                                                                    line: 158,
                                                                    column: 44,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                }
                                                            },
                                                            order: '1'
                                                        }
                                                    ]
                                                },
                                                loc: {
                                                    start: {
                                                        line: 155,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/Calendar.ion'
                                                    },
                                                    end: {
                                                        line: 159,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'glass/html/material/Calendar.ion'
                                                    }
                                                },
                                                order: '1'
                                            },
                                            {
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'ObjectExpression',
                                                    objectType: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'Identifier',
                                                            name: 'Button',
                                                            loc: {
                                                                start: {
                                                                    line: 159,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                },
                                                                end: {
                                                                    line: 159,
                                                                    column: 18,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [],
                                                        loc: {
                                                            start: {
                                                                line: 159,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'glass/html/material/Calendar.ion'
                                                            },
                                                            end: {
                                                                line: 159,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'glass/html/material/Calendar.ion'
                                                            }
                                                        }
                                                    },
                                                    properties: [
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'classList',
                                                                loc: {
                                                                    start: {
                                                                        line: 160,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Calendar.ion'
                                                                    },
                                                                    end: {
                                                                        line: 160,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Calendar.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'ObjectExpression',
                                                                properties: [{
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'Literal',
                                                                            value: 'flex'
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 161,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Calendar.ion'
                                                                            },
                                                                            end: {
                                                                                line: 161,
                                                                                column: 26,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Calendar.ion'
                                                                            }
                                                                        },
                                                                        order: '0'
                                                                    }]
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        },
                                                        {
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'Function',
                                                                context: true,
                                                                value: function (_context7) {
                                                                    return function click(e) {
                                                                        var state = _context7.get('state');
                                                                        state.date = state.date.clone().addMonths(1);
                                                                    };
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 162,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                },
                                                                end: {
                                                                    line: 164,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                }
                                                            },
                                                            order: '1'
                                                        },
                                                        {
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Identifier',
                                                                    name: 'Icon',
                                                                    loc: {
                                                                        start: {
                                                                            line: 164,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Calendar.ion'
                                                                        },
                                                                        end: {
                                                                            line: 164,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Calendar.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'ObjectExpression',
                                                                        properties: [{
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'name',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 164,
                                                                                            column: 22,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Calendar.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 164,
                                                                                            column: 26,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Calendar.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Literal',
                                                                                    value: 'keyboard arrow right'
                                                                                },
                                                                                kind: 'init',
                                                                                order: '0'
                                                                            }]
                                                                    }],
                                                                loc: {
                                                                    start: {
                                                                        line: 164,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Calendar.ion'
                                                                    },
                                                                    end: {
                                                                        line: 164,
                                                                        column: 51,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Calendar.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 164,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                },
                                                                end: {
                                                                    line: 164,
                                                                    column: 51,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                }
                                                            },
                                                            order: '2'
                                                        }
                                                    ]
                                                },
                                                loc: {
                                                    start: {
                                                        line: 159,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/Calendar.ion'
                                                    },
                                                    end: {
                                                        line: 166,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'glass/html/material/Calendar.ion'
                                                    }
                                                },
                                                order: '2'
                                            }
                                        ]
                                    },
                                    loc: {
                                        start: {
                                            line: 148,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/Calendar.ion'
                                        },
                                        end: {
                                            line: 166,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/material/Calendar.ion'
                                        }
                                    },
                                    order: '2'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'ObjectExpression',
                                        objectType: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'Identifier',
                                                name: 'Table',
                                                loc: {
                                                    start: {
                                                        line: 166,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'glass/html/material/Calendar.ion'
                                                    },
                                                    end: {
                                                        line: 166,
                                                        column: 13,
                                                        fixed: true,
                                                        source: 'glass/html/material/Calendar.ion'
                                                    }
                                                }
                                            },
                                            arguments: [{
                                                    type: 'ObjectExpression',
                                                    properties: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'class',
                                                                loc: {
                                                                    start: {
                                                                        line: 166,
                                                                        column: 15,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Calendar.ion'
                                                                    },
                                                                    end: {
                                                                        line: 166,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Calendar.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Literal',
                                                                value: 'flex layout vertical'
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                }],
                                            loc: {
                                                start: {
                                                    line: 166,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'glass/html/material/Calendar.ion'
                                                },
                                                end: {
                                                    line: 166,
                                                    column: 45,
                                                    fixed: true,
                                                    source: 'glass/html/material/Calendar.ion'
                                                }
                                            }
                                        },
                                        properties: [
                                            {
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'ObjectExpression',
                                                    objectType: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'Identifier',
                                                            name: 'Tr',
                                                            loc: {
                                                                start: {
                                                                    line: 167,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                },
                                                                end: {
                                                                    line: 167,
                                                                    column: 14,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [{
                                                                type: 'ObjectExpression',
                                                                properties: [{
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'class',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 167,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 167,
                                                                                    column: 21,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Literal',
                                                                            value: 'day-header layout flex'
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    }]
                                                            }],
                                                        loc: {
                                                            start: {
                                                                line: 167,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'glass/html/material/Calendar.ion'
                                                            },
                                                            end: {
                                                                line: 167,
                                                                column: 48,
                                                                fixed: true,
                                                                source: 'glass/html/material/Calendar.ion'
                                                            }
                                                        }
                                                    },
                                                    properties: [{
                                                            type: 'ForOfStatement',
                                                            left: {
                                                                type: 'VariableDeclaration',
                                                                declarations: [{
                                                                        type: 'VariableDeclarator',
                                                                        id: {
                                                                            type: 'Identifier',
                                                                            name: 'd',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 168,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 168,
                                                                                    column: 21,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        init: null
                                                                    }],
                                                                kind: 'let'
                                                            },
                                                            right: {
                                                                type: 'Identifier',
                                                                name: 'daysOfWeek',
                                                                loc: {
                                                                    start: {
                                                                        line: 168,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Calendar.ion'
                                                                    },
                                                                    end: {
                                                                        line: 168,
                                                                        column: 35,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Calendar.ion'
                                                                    }
                                                                }
                                                            },
                                                            body: {
                                                                type: 'BlockStatement',
                                                                body: [{
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'ObjectExpression',
                                                                            objectType: {
                                                                                type: 'CallExpression',
                                                                                callee: {
                                                                                    type: 'Identifier',
                                                                                    name: 'Td',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 169,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Calendar.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 169,
                                                                                            column: 22,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Calendar.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                arguments: [{
                                                                                        type: 'ObjectExpression',
                                                                                        properties: [{
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'class',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 169,
                                                                                                            column: 24,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/Calendar.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 169,
                                                                                                            column: 29,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/Calendar.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'Literal',
                                                                                                    value: 'flex layout center center-justified th'
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '0'
                                                                                            }]
                                                                                    }],
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 169,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 169,
                                                                                        column: 72,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            properties: [{
                                                                                    type: 'ExpressionStatement',
                                                                                    expression: {
                                                                                        type: 'CallExpression',
                                                                                        callee: {
                                                                                            type: 'MemberExpression',
                                                                                            computed: false,
                                                                                            object: {
                                                                                                type: 'Identifier',
                                                                                                name: 'd',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 170,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 170,
                                                                                                        column: 25,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            property: {
                                                                                                type: 'Identifier',
                                                                                                name: 'substr',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 170,
                                                                                                        column: 26,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 170,
                                                                                                        column: 32,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 170,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 170,
                                                                                                    column: 32,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        arguments: [
                                                                                            {
                                                                                                type: 'Literal',
                                                                                                value: 0
                                                                                            },
                                                                                            {
                                                                                                type: 'Literal',
                                                                                                value: 1
                                                                                            }
                                                                                        ],
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 170,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Calendar.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 170,
                                                                                                column: 37,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Calendar.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 170,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Calendar.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 170,
                                                                                            column: 37,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Calendar.ion'
                                                                                        }
                                                                                    },
                                                                                    order: '0'
                                                                                }]
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 169,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Calendar.ion'
                                                                            },
                                                                            end: {
                                                                                line: 172,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Calendar.ion'
                                                                            }
                                                                        },
                                                                        order: '0'
                                                                    }]
                                                            },
                                                            remove: null,
                                                            order: '0'
                                                        }]
                                                },
                                                loc: {
                                                    start: {
                                                        line: 167,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/Calendar.ion'
                                                    },
                                                    end: {
                                                        line: 172,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'glass/html/material/Calendar.ion'
                                                    }
                                                },
                                                order: '0'
                                            },
                                            {
                                                type: 'VariableDeclaration',
                                                declarations: [{
                                                        type: 'VariableDeclarator',
                                                        id: {
                                                            type: 'Identifier',
                                                            name: 'date',
                                                            loc: {
                                                                start: {
                                                                    line: 172,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                },
                                                                end: {
                                                                    line: 172,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                }
                                                            }
                                                        },
                                                        init: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'state',
                                                                loc: {
                                                                    start: {
                                                                        line: 172,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Calendar.ion'
                                                                    },
                                                                    end: {
                                                                        line: 172,
                                                                        column: 28,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Calendar.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'date',
                                                                loc: {
                                                                    start: {
                                                                        line: 172,
                                                                        column: 29,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Calendar.ion'
                                                                    },
                                                                    end: {
                                                                        line: 172,
                                                                        column: 33,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Calendar.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 172,
                                                                    column: 23,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                },
                                                                end: {
                                                                    line: 172,
                                                                    column: 33,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                }
                                                            }
                                                        }
                                                    }],
                                                kind: 'let',
                                                order: '1'
                                            },
                                            {
                                                type: 'VariableDeclaration',
                                                declarations: [{
                                                        type: 'VariableDeclarator',
                                                        id: {
                                                            type: 'Identifier',
                                                            name: 'start',
                                                            loc: {
                                                                start: {
                                                                    line: 173,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                },
                                                                end: {
                                                                    line: 173,
                                                                    column: 21,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                }
                                                            }
                                                        },
                                                        init: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'view',
                                                                    loc: {
                                                                        start: {
                                                                            line: 173,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Calendar.ion'
                                                                        },
                                                                        end: {
                                                                            line: 173,
                                                                            column: 28,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Calendar.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'getStart',
                                                                    loc: {
                                                                        start: {
                                                                            line: 173,
                                                                            column: 29,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Calendar.ion'
                                                                        },
                                                                        end: {
                                                                            line: 173,
                                                                            column: 37,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Calendar.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 173,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Calendar.ion'
                                                                    },
                                                                    end: {
                                                                        line: 173,
                                                                        column: 37,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Calendar.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [{
                                                                    type: 'ObjectExpression',
                                                                    properties: [{
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'date',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 173,
                                                                                        column: 39,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 173,
                                                                                        column: 43,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Identifier',
                                                                                name: 'date',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 173,
                                                                                        column: 39,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 173,
                                                                                        column: 43,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        }]
                                                                }],
                                                            loc: {
                                                                start: {
                                                                    line: 173,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                },
                                                                end: {
                                                                    line: 173,
                                                                    column: 45,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                }
                                                            }
                                                        }
                                                    }],
                                                kind: 'let',
                                                order: '2'
                                            },
                                            {
                                                type: 'VariableDeclaration',
                                                declarations: [{
                                                        type: 'VariableDeclarator',
                                                        id: {
                                                            type: 'Identifier',
                                                            name: 'finish',
                                                            loc: {
                                                                start: {
                                                                    line: 174,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                },
                                                                end: {
                                                                    line: 174,
                                                                    column: 22,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                }
                                                            }
                                                        },
                                                        init: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'view',
                                                                    loc: {
                                                                        start: {
                                                                            line: 174,
                                                                            column: 25,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Calendar.ion'
                                                                        },
                                                                        end: {
                                                                            line: 174,
                                                                            column: 29,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Calendar.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'getFinish',
                                                                    loc: {
                                                                        start: {
                                                                            line: 174,
                                                                            column: 30,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Calendar.ion'
                                                                        },
                                                                        end: {
                                                                            line: 174,
                                                                            column: 39,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Calendar.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 174,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Calendar.ion'
                                                                    },
                                                                    end: {
                                                                        line: 174,
                                                                        column: 39,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Calendar.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [{
                                                                    type: 'ObjectExpression',
                                                                    properties: [{
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'date',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 174,
                                                                                        column: 41,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 174,
                                                                                        column: 45,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Identifier',
                                                                                name: 'date',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 174,
                                                                                        column: 41,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 174,
                                                                                        column: 45,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        }]
                                                                }],
                                                            loc: {
                                                                start: {
                                                                    line: 174,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                },
                                                                end: {
                                                                    line: 174,
                                                                    column: 47,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                }
                                                            }
                                                        }
                                                    }],
                                                kind: 'let',
                                                order: '3'
                                            },
                                            {
                                                type: 'VariableDeclaration',
                                                declarations: [{
                                                        type: 'VariableDeclarator',
                                                        id: {
                                                            type: 'Identifier',
                                                            name: 'calStart',
                                                            loc: {
                                                                start: {
                                                                    line: 175,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                },
                                                                end: {
                                                                    line: 175,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                }
                                                            }
                                                        },
                                                        init: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'view',
                                                                    loc: {
                                                                        start: {
                                                                            line: 175,
                                                                            column: 27,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Calendar.ion'
                                                                        },
                                                                        end: {
                                                                            line: 175,
                                                                            column: 31,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Calendar.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'getCalendarStart',
                                                                    loc: {
                                                                        start: {
                                                                            line: 175,
                                                                            column: 32,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Calendar.ion'
                                                                        },
                                                                        end: {
                                                                            line: 175,
                                                                            column: 48,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Calendar.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 175,
                                                                        column: 27,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Calendar.ion'
                                                                    },
                                                                    end: {
                                                                        line: 175,
                                                                        column: 48,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Calendar.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [{
                                                                    type: 'ObjectExpression',
                                                                    properties: [{
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'start',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 175,
                                                                                        column: 50,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 175,
                                                                                        column: 55,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Identifier',
                                                                                name: 'start',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 175,
                                                                                        column: 50,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 175,
                                                                                        column: 55,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        }]
                                                                }],
                                                            loc: {
                                                                start: {
                                                                    line: 175,
                                                                    column: 27,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                },
                                                                end: {
                                                                    line: 175,
                                                                    column: 57,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                }
                                                            }
                                                        }
                                                    }],
                                                kind: 'let',
                                                order: '4'
                                            },
                                            {
                                                type: 'VariableDeclaration',
                                                declarations: [{
                                                        type: 'VariableDeclarator',
                                                        id: {
                                                            type: 'Identifier',
                                                            name: 'calFinish',
                                                            loc: {
                                                                start: {
                                                                    line: 176,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                },
                                                                end: {
                                                                    line: 176,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                }
                                                            }
                                                        },
                                                        init: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'view',
                                                                    loc: {
                                                                        start: {
                                                                            line: 176,
                                                                            column: 28,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Calendar.ion'
                                                                        },
                                                                        end: {
                                                                            line: 176,
                                                                            column: 32,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Calendar.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'getCalendarFinish',
                                                                    loc: {
                                                                        start: {
                                                                            line: 176,
                                                                            column: 33,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Calendar.ion'
                                                                        },
                                                                        end: {
                                                                            line: 176,
                                                                            column: 50,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Calendar.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 176,
                                                                        column: 28,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Calendar.ion'
                                                                    },
                                                                    end: {
                                                                        line: 176,
                                                                        column: 50,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Calendar.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [{
                                                                    type: 'ObjectExpression',
                                                                    properties: [{
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'finish',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 176,
                                                                                        column: 52,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 176,
                                                                                        column: 58,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Identifier',
                                                                                name: 'finish',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 176,
                                                                                        column: 52,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 176,
                                                                                        column: 58,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        }]
                                                                }],
                                                            loc: {
                                                                start: {
                                                                    line: 176,
                                                                    column: 28,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                },
                                                                end: {
                                                                    line: 176,
                                                                    column: 60,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                }
                                                            }
                                                        }
                                                    }],
                                                kind: 'let',
                                                order: '5'
                                            },
                                            {
                                                type: 'VariableDeclaration',
                                                declarations: [{
                                                        type: 'VariableDeclarator',
                                                        id: {
                                                            type: 'Identifier',
                                                            name: 'cache',
                                                            loc: {
                                                                start: {
                                                                    line: 177,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                },
                                                                end: {
                                                                    line: 177,
                                                                    column: 21,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                }
                                                            }
                                                        },
                                                        init: {
                                                            type: 'ArrayExpression',
                                                            elements: []
                                                        }
                                                    }],
                                                kind: 'let',
                                                order: '6'
                                            },
                                            {
                                                type: 'VariableDeclaration',
                                                declarations: [{
                                                        type: 'VariableDeclarator',
                                                        id: {
                                                            type: 'Identifier',
                                                            name: 'calendarRowCells',
                                                            loc: {
                                                                start: {
                                                                    line: 178,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                },
                                                                end: {
                                                                    line: 178,
                                                                    column: 32,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                }
                                                            }
                                                        },
                                                        init: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'getCalendarRowCells',
                                                                loc: {
                                                                    start: {
                                                                        line: 178,
                                                                        column: 35,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Calendar.ion'
                                                                    },
                                                                    end: {
                                                                        line: 178,
                                                                        column: 54,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Calendar.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [{
                                                                    type: 'ObjectExpression',
                                                                    properties: [
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'calStart',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 178,
                                                                                        column: 56,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 178,
                                                                                        column: 64,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Identifier',
                                                                                name: 'calStart',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 178,
                                                                                        column: 56,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 178,
                                                                                        column: 64,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'calFinish',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 178,
                                                                                        column: 65,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 178,
                                                                                        column: 74,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Identifier',
                                                                                name: 'calFinish',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 178,
                                                                                        column: 65,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 178,
                                                                                        column: 74,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            kind: 'init',
                                                                            order: '1'
                                                                        },
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'cache',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 178,
                                                                                        column: 75,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 178,
                                                                                        column: 80,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Identifier',
                                                                                name: 'cache',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 178,
                                                                                        column: 75,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 178,
                                                                                        column: 80,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            kind: 'init',
                                                                            order: '2'
                                                                        }
                                                                    ]
                                                                }],
                                                            loc: {
                                                                start: {
                                                                    line: 178,
                                                                    column: 35,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                },
                                                                end: {
                                                                    line: 178,
                                                                    column: 82,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                }
                                                            }
                                                        }
                                                    }],
                                                kind: 'let',
                                                order: '7'
                                            },
                                            {
                                                type: 'ForOfStatement',
                                                left: {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'row',
                                                                loc: {
                                                                    start: {
                                                                        line: 180,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Calendar.ion'
                                                                    },
                                                                    end: {
                                                                        line: 180,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Calendar.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: null
                                                        }],
                                                    kind: 'let'
                                                },
                                                right: {
                                                    type: 'Identifier',
                                                    name: 'calendarRowCells',
                                                    loc: {
                                                        start: {
                                                            line: 180,
                                                            column: 23,
                                                            fixed: true,
                                                            source: 'glass/html/material/Calendar.ion'
                                                        },
                                                        end: {
                                                            line: 180,
                                                            column: 39,
                                                            fixed: true,
                                                            source: 'glass/html/material/Calendar.ion'
                                                        }
                                                    }
                                                },
                                                body: {
                                                    type: 'BlockStatement',
                                                    body: [{
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'ObjectExpression',
                                                                objectType: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'Identifier',
                                                                        name: 'Tr',
                                                                        loc: {
                                                                            start: {
                                                                                line: 181,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Calendar.ion'
                                                                            },
                                                                            end: {
                                                                                line: 181,
                                                                                column: 18,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Calendar.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [{
                                                                            type: 'ObjectExpression',
                                                                            properties: [{
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'class',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 181,
                                                                                                column: 20,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Calendar.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 181,
                                                                                                column: 25,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Calendar.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Literal',
                                                                                        value: 'flex layout'
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                }]
                                                                        }],
                                                                    loc: {
                                                                        start: {
                                                                            line: 181,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Calendar.ion'
                                                                        },
                                                                        end: {
                                                                            line: 181,
                                                                            column: 41,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Calendar.ion'
                                                                        }
                                                                    }
                                                                },
                                                                properties: [{
                                                                        type: 'ForOfStatement',
                                                                        left: {
                                                                            type: 'VariableDeclaration',
                                                                            declarations: [{
                                                                                    type: 'VariableDeclarator',
                                                                                    id: {
                                                                                        type: 'Identifier',
                                                                                        name: 'cellConfig',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 182,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Calendar.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 182,
                                                                                                column: 34,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Calendar.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    init: null
                                                                                }],
                                                                            kind: 'let'
                                                                        },
                                                                        right: {
                                                                            type: 'Identifier',
                                                                            name: 'row',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 182,
                                                                                    column: 38,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 182,
                                                                                    column: 41,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        body: {
                                                                            type: 'BlockStatement',
                                                                            body: [
                                                                                {
                                                                                    type: 'VariableDeclaration',
                                                                                    declarations: [{
                                                                                            type: 'VariableDeclarator',
                                                                                            id: {
                                                                                                type: 'Identifier',
                                                                                                name: 'cellDate',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 183,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 183,
                                                                                                        column: 36,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            init: {
                                                                                                type: 'NewExpression',
                                                                                                callee: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'Date',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 183,
                                                                                                            column: 43,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/Calendar.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 183,
                                                                                                            column: 47,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/Calendar.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                arguments: [{
                                                                                                        type: 'MemberExpression',
                                                                                                        computed: false,
                                                                                                        object: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'cellConfig',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 183,
                                                                                                                    column: 48,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 183,
                                                                                                                    column: 58,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        property: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'date',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 183,
                                                                                                                    column: 59,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 183,
                                                                                                                    column: 63,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 183,
                                                                                                                column: 48,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/Calendar.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 183,
                                                                                                                column: 63,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/Calendar.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    }],
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 183,
                                                                                                        column: 39,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 183,
                                                                                                        column: 64,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        }],
                                                                                    kind: 'let',
                                                                                    order: '0'
                                                                                },
                                                                                {
                                                                                    type: 'ExpressionStatement',
                                                                                    expression: {
                                                                                        type: 'ObjectExpression',
                                                                                        objectType: {
                                                                                            type: 'CallExpression',
                                                                                            callee: {
                                                                                                type: 'Identifier',
                                                                                                name: 'Td',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 184,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 184,
                                                                                                        column: 26,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            arguments: [{
                                                                                                    type: 'ObjectExpression',
                                                                                                    properties: [{
                                                                                                            type: 'Property',
                                                                                                            key: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'class',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 184,
                                                                                                                        column: 28,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 184,
                                                                                                                        column: 33,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            value: {
                                                                                                                type: 'Literal',
                                                                                                                value: 'flex layout center center-justified'
                                                                                                            },
                                                                                                            kind: 'init',
                                                                                                            order: '0'
                                                                                                        }]
                                                                                                }],
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 184,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 184,
                                                                                                    column: 73,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        properties: [
                                                                                            {
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'classList',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 185,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/Calendar.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 185,
                                                                                                            column: 37,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/Calendar.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'ObjectExpression',
                                                                                                    properties: [
                                                                                                        {
                                                                                                            type: 'IfStatement',
                                                                                                            test: {
                                                                                                                type: 'BinaryExpression',
                                                                                                                operator: '!==',
                                                                                                                left: {
                                                                                                                    type: 'CallExpression',
                                                                                                                    callee: {
                                                                                                                        type: 'MemberExpression',
                                                                                                                        computed: false,
                                                                                                                        object: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'date',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 186,
                                                                                                                                    column: 35,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 186,
                                                                                                                                    column: 39,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        property: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'format',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 186,
                                                                                                                                    column: 40,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 186,
                                                                                                                                    column: 46,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 186,
                                                                                                                                column: 35,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/Calendar.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 186,
                                                                                                                                column: 46,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/Calendar.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    arguments: [{
                                                                                                                            type: 'Literal',
                                                                                                                            value: '{month}'
                                                                                                                        }],
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 186,
                                                                                                                            column: 35,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/material/Calendar.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 186,
                                                                                                                            column: 57,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/material/Calendar.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                right: {
                                                                                                                    type: 'CallExpression',
                                                                                                                    callee: {
                                                                                                                        type: 'MemberExpression',
                                                                                                                        computed: false,
                                                                                                                        object: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'cellDate',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 186,
                                                                                                                                    column: 63,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 186,
                                                                                                                                    column: 71,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        property: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'format',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 186,
                                                                                                                                    column: 72,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 186,
                                                                                                                                    column: 78,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 186,
                                                                                                                                column: 63,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/Calendar.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 186,
                                                                                                                                column: 78,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/Calendar.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    arguments: [{
                                                                                                                            type: 'Literal',
                                                                                                                            value: '{month}'
                                                                                                                        }],
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 186,
                                                                                                                            column: 63,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/material/Calendar.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 186,
                                                                                                                            column: 89,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/material/Calendar.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            consequent: {
                                                                                                                type: 'BlockStatement',
                                                                                                                body: [{
                                                                                                                        type: 'ExpressionStatement',
                                                                                                                        expression: {
                                                                                                                            type: 'Literal',
                                                                                                                            value: 'inactive'
                                                                                                                        },
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 187,
                                                                                                                                column: 36,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/Calendar.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 187,
                                                                                                                                column: 46,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/Calendar.ion'
                                                                                                                            }
                                                                                                                        },
                                                                                                                        order: '0'
                                                                                                                    }]
                                                                                                            },
                                                                                                            alternate: null,
                                                                                                            order: '0'
                                                                                                        },
                                                                                                        {
                                                                                                            type: 'IfStatement',
                                                                                                            test: {
                                                                                                                type: 'BinaryExpression',
                                                                                                                operator: '===',
                                                                                                                left: {
                                                                                                                    type: 'CallExpression',
                                                                                                                    callee: {
                                                                                                                        type: 'MemberExpression',
                                                                                                                        computed: false,
                                                                                                                        object: {
                                                                                                                            type: 'MemberExpression',
                                                                                                                            computed: false,
                                                                                                                            object: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'state',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 188,
                                                                                                                                        column: 35,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 188,
                                                                                                                                        column: 40,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            property: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'selectedDate',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 188,
                                                                                                                                        column: 41,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 188,
                                                                                                                                        column: 53,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 188,
                                                                                                                                    column: 35,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 188,
                                                                                                                                    column: 53,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        property: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'iso',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 188,
                                                                                                                                    column: 55,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 188,
                                                                                                                                    column: 58,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        existential: true,
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 188,
                                                                                                                                column: 35,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/Calendar.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 188,
                                                                                                                                column: 58,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/Calendar.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    arguments: [],
                                                                                                                    existential: true,
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 188,
                                                                                                                            column: 35,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/material/Calendar.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 188,
                                                                                                                            column: 61,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/material/Calendar.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                right: {
                                                                                                                    type: 'MemberExpression',
                                                                                                                    computed: false,
                                                                                                                    object: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'cellConfig',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 188,
                                                                                                                                column: 65,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/Calendar.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 188,
                                                                                                                                column: 75,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/Calendar.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    property: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'date',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 188,
                                                                                                                                column: 76,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/Calendar.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 188,
                                                                                                                                column: 80,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/Calendar.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 188,
                                                                                                                            column: 65,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/material/Calendar.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 188,
                                                                                                                            column: 80,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/material/Calendar.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            consequent: {
                                                                                                                type: 'BlockStatement',
                                                                                                                body: [{
                                                                                                                        type: 'ExpressionStatement',
                                                                                                                        expression: {
                                                                                                                            type: 'Literal',
                                                                                                                            value: 'selected'
                                                                                                                        },
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 189,
                                                                                                                                column: 36,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/Calendar.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 189,
                                                                                                                                column: 46,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/Calendar.ion'
                                                                                                                            }
                                                                                                                        },
                                                                                                                        order: '0'
                                                                                                                    }]
                                                                                                            },
                                                                                                            alternate: null,
                                                                                                            order: '1'
                                                                                                        },
                                                                                                        {
                                                                                                            type: 'IfStatement',
                                                                                                            test: {
                                                                                                                type: 'CallExpression',
                                                                                                                callee: {
                                                                                                                    type: 'MemberExpression',
                                                                                                                    computed: false,
                                                                                                                    object: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'cellDate',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 190,
                                                                                                                                column: 35,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/Calendar.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 190,
                                                                                                                                column: 43,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/Calendar.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    property: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'isToday',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 190,
                                                                                                                                column: 44,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/Calendar.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 190,
                                                                                                                                column: 51,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/Calendar.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 190,
                                                                                                                            column: 35,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/material/Calendar.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 190,
                                                                                                                            column: 51,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/material/Calendar.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                arguments: [],
                                                                                                                existential: true,
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 190,
                                                                                                                        column: 35,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 190,
                                                                                                                        column: 54,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            consequent: {
                                                                                                                type: 'BlockStatement',
                                                                                                                body: [{
                                                                                                                        type: 'ExpressionStatement',
                                                                                                                        expression: {
                                                                                                                            type: 'Literal',
                                                                                                                            value: 'today'
                                                                                                                        },
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 191,
                                                                                                                                column: 36,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/Calendar.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 191,
                                                                                                                                column: 43,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/Calendar.ion'
                                                                                                                            }
                                                                                                                        },
                                                                                                                        order: '0'
                                                                                                                    }]
                                                                                                            },
                                                                                                            alternate: null,
                                                                                                            order: '2'
                                                                                                        }
                                                                                                    ]
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '0'
                                                                                            },
                                                                                            {
                                                                                                type: 'ExpressionStatement',
                                                                                                expression: {
                                                                                                    type: 'Function',
                                                                                                    context: true,
                                                                                                    value: function (_context8) {
                                                                                                        return function click(e) {
                                                                                                            var state = _context8.get('state'), cellDate = _context8.get('cellDate'), element = _context8.get('element');
                                                                                                            e.stopPropagation();
                                                                                                            console.log('dispatching the  event....');
                                                                                                            state.selectedDate = state.date = cellDate;
                                                                                                            element.dispatchEvent(new CustomEvent('change'));
                                                                                                            console.log('event dispatched');
                                                                                                        };
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 192,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 199,
                                                                                                        column: 32,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                                    }
                                                                                                },
                                                                                                order: '1'
                                                                                            },
                                                                                            {
                                                                                                type: 'ExpressionStatement',
                                                                                                expression: {
                                                                                                    type: 'CallExpression',
                                                                                                    callee: {
                                                                                                        type: 'MemberExpression',
                                                                                                        computed: false,
                                                                                                        object: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'cellDate',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 199,
                                                                                                                    column: 28,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 199,
                                                                                                                    column: 36,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        property: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'format',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 199,
                                                                                                                    column: 37,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 199,
                                                                                                                    column: 43,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/Calendar.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 199,
                                                                                                                column: 28,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/Calendar.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 199,
                                                                                                                column: 43,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/Calendar.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    arguments: [{
                                                                                                            type: 'Literal',
                                                                                                            value: '{dd}'
                                                                                                        }],
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 199,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/Calendar.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 199,
                                                                                                            column: 51,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/Calendar.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 199,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 199,
                                                                                                        column: 51,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Calendar.ion'
                                                                                                    }
                                                                                                },
                                                                                                order: '2'
                                                                                            }
                                                                                        ]
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 184,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Calendar.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 200,
                                                                                            column: 28,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Calendar.ion'
                                                                                        }
                                                                                    },
                                                                                    order: '1'
                                                                                }
                                                                            ]
                                                                        },
                                                                        remove: null,
                                                                        order: '0'
                                                                    }]
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 181,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                },
                                                                end: {
                                                                    line: 200,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Calendar.ion'
                                                                }
                                                            },
                                                            order: '0'
                                                        }]
                                                },
                                                remove: null,
                                                order: '8'
                                            }
                                        ]
                                    },
                                    loc: {
                                        start: {
                                            line: 166,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/Calendar.ion'
                                        },
                                        end: {
                                            line: 208,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/material/Calendar.ion'
                                        }
                                    },
                                    order: '3'
                                }
                            ]
                        },
                        {
                            type: 'ObjectExpression',
                            properties: [{
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'value',
                                        loc: {
                                            start: {
                                                line: 132,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/Calendar.ion'
                                            },
                                            end: {
                                                line: 132,
                                                column: 22,
                                                fixed: true,
                                                source: 'glass/html/material/Calendar.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 133,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Calendar.ion'
                                                        },
                                                        end: {
                                                            line: 133,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Calendar.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context9) {
                                                        return function () {
                                                            var state = _context9.get('state');
                                                            var iso = (state.selectedDate != null ? state.selectedDate.iso() : void 0) != null ? state.selectedDate.iso() : null;
                                                            if (iso != null && iso.indexOf('T') > 0) {
                                                                iso = iso.substring(0, iso.indexOf('T'));
                                                            }
                                                            return iso;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 139,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Calendar.ion'
                                                        },
                                                        end: {
                                                            line: 139,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Calendar.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context10) {
                                                        return function (value) {
                                                            var state = _context10.get('state');
                                                            state.selectedDate = state.date = Date.create(value);
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '0'
                                }]
                        }
                    ]
                },
                order: '9'
            }
        ],
        bound: false
    }, {
        this: this,
        ion: ion,
        _ref3: _ref3,
        _ref: _ref,
        _ref2: _ref2,
        style: style,
        Button: Button,
        Icon: Icon
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/Calendar',_glass_html_material_Calendar_);
    else
      _glass_html_material_Calendar_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_Calendar_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_Card_ = function(module,exports,require){'use strict';
var ion = require('ion');
var style = require('../style'), _ref;
_ref = require('./');
var Shadow = _ref.Shadow;
style.define(module.id, '.Card {\n    background: white;\n    display: inline-block;\n}');
module.exports = exports = ion.template(function Card(attributes) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'Card',
            loc: {
                start: {
                    line: 14,
                    column: 16,
                    fixed: true,
                    source: 'glass/html/material/Card.ion'
                },
                end: {
                    line: 14,
                    column: 20,
                    fixed: true,
                    source: 'glass/html/material/Card.ion'
                }
            }
        },
        body: [{
                type: 'ReturnStatement',
                argument: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'CallExpression',
                        callee: {
                            type: 'Identifier',
                            name: 'Article',
                            loc: {
                                start: {
                                    line: 15,
                                    column: 11,
                                    fixed: true,
                                    source: 'glass/html/material/Card.ion'
                                },
                                end: {
                                    line: 15,
                                    column: 18,
                                    fixed: true,
                                    source: 'glass/html/material/Card.ion'
                                }
                            }
                        },
                        arguments: [{
                                type: 'Identifier',
                                name: 'attributes',
                                loc: {
                                    start: {
                                        line: 15,
                                        column: 19,
                                        fixed: true,
                                        source: 'glass/html/material/Card.ion'
                                    },
                                    end: {
                                        line: 15,
                                        column: 29,
                                        fixed: true,
                                        source: 'glass/html/material/Card.ion'
                                    }
                                }
                            }],
                        loc: {
                            start: {
                                line: 15,
                                column: 11,
                                fixed: true,
                                source: 'glass/html/material/Card.ion'
                            },
                            end: {
                                line: 15,
                                column: 30,
                                fixed: true,
                                source: 'glass/html/material/Card.ion'
                            }
                        }
                    },
                    properties: [{
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'classList',
                                loc: {
                                    start: {
                                        line: 17,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/Card.ion'
                                    },
                                    end: {
                                        line: 17,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/html/material/Card.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'ObjectExpression',
                                properties: [
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'Literal',
                                            value: 'Card'
                                        },
                                        loc: {
                                            start: {
                                                line: 18,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/Card.ion'
                                            },
                                            end: {
                                                line: 18,
                                                column: 18,
                                                fixed: true,
                                                source: 'glass/html/material/Card.ion'
                                            }
                                        },
                                        order: '0'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'Literal',
                                            value: 'z1'
                                        },
                                        loc: {
                                            start: {
                                                line: 19,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/Card.ion'
                                            },
                                            end: {
                                                line: 19,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/Card.ion'
                                            }
                                        },
                                        order: '1'
                                    }
                                ]
                            },
                            kind: 'init',
                            order: '0'
                        }]
                },
                order: '0'
            }],
        bound: false
    }, {
        this: this,
        attributes: attributes,
        style: style,
        _ref: _ref,
        Shadow: Shadow
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/Card',_glass_html_material_Card_);
    else
      _glass_html_material_Card_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_Card_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_Checkbox_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('./'), _ref2;
var Icon = _ref.Icon;
_ref2 = require('../');
var style = _ref2.style;
ion.template(function () {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [{
                type: 'ExpressionStatement',
                expression: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'MemberExpression',
                        computed: false,
                        object: {
                            type: 'Identifier',
                            name: 'style',
                            loc: {
                                start: {
                                    line: 6,
                                    column: 4,
                                    fixed: true,
                                    source: 'glass/html/material/Checkbox.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 9,
                                    fixed: true,
                                    source: 'glass/html/material/Checkbox.ion'
                                }
                            }
                        },
                        property: {
                            type: 'Identifier',
                            name: 'sheets',
                            loc: {
                                start: {
                                    line: 6,
                                    column: 10,
                                    fixed: true,
                                    source: 'glass/html/material/Checkbox.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 16,
                                    fixed: true,
                                    source: 'glass/html/material/Checkbox.ion'
                                }
                            }
                        },
                        loc: {
                            start: {
                                line: 6,
                                column: 4,
                                fixed: true,
                                source: 'glass/html/material/Checkbox.ion'
                            },
                            end: {
                                line: 6,
                                column: 16,
                                fixed: true,
                                source: 'glass/html/material/Checkbox.ion'
                            }
                        }
                    },
                    properties: [{
                            type: 'Property',
                            key: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'module',
                                    loc: {
                                        start: {
                                            line: 7,
                                            column: 9,
                                            fixed: true,
                                            source: 'glass/html/material/Checkbox.ion'
                                        },
                                        end: {
                                            line: 7,
                                            column: 15,
                                            fixed: true,
                                            source: 'glass/html/material/Checkbox.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'id',
                                    loc: {
                                        start: {
                                            line: 7,
                                            column: 16,
                                            fixed: true,
                                            source: 'glass/html/material/Checkbox.ion'
                                        },
                                        end: {
                                            line: 7,
                                            column: 18,
                                            fixed: true,
                                            source: 'glass/html/material/Checkbox.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 7,
                                        column: 9,
                                        fixed: true,
                                        source: 'glass/html/material/Checkbox.ion'
                                    },
                                    end: {
                                        line: 7,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/material/Checkbox.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Literal',
                                value: '.Checkbox {\n    color: #666;\n}'
                            },
                            kind: 'init',
                            computed: true,
                            order: '0'
                        }]
                },
                loc: {
                    start: {
                        line: 6,
                        column: 4,
                        fixed: true,
                        source: 'glass/html/material/Checkbox.ion'
                    },
                    end: {
                        line: 12,
                        column: 8,
                        fixed: true,
                        source: 'glass/html/material/Checkbox.ion'
                    }
                },
                order: '0'
            }],
        bound: false
    }, {
        this: this,
        module: module,
        _ref: _ref,
        _ref2: _ref2,
        Icon: Icon,
        style: style
    }, null);
})().observe();
module.exports = exports = ion.template(function Checkbox() {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'Checkbox',
            loc: {
                start: {
                    line: 12,
                    column: 16,
                    fixed: true,
                    source: 'glass/html/material/Checkbox.ion'
                },
                end: {
                    line: 12,
                    column: 24,
                    fixed: true,
                    source: 'glass/html/material/Checkbox.ion'
                }
            }
        },
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'state',
                            loc: {
                                start: {
                                    line: 13,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/Checkbox.ion'
                                },
                                end: {
                                    line: 13,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/html/material/Checkbox.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            properties: [{
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'checked',
                                        loc: {
                                            start: {
                                                line: 13,
                                                column: 18,
                                                fixed: true,
                                                source: 'glass/html/material/Checkbox.ion'
                                            },
                                            end: {
                                                line: 13,
                                                column: 25,
                                                fixed: true,
                                                source: 'glass/html/material/Checkbox.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: false
                                    },
                                    kind: 'init',
                                    order: '0'
                                }]
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'icon',
                            loc: {
                                start: {
                                    line: 14,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/Checkbox.ion'
                                },
                                end: {
                                    line: 14,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/Checkbox.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Icon',
                                loc: {
                                    start: {
                                        line: 14,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/Checkbox.ion'
                                    },
                                    end: {
                                        line: 14,
                                        column: 19,
                                        fixed: true,
                                        source: 'glass/html/material/Checkbox.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ObjectExpression',
                                    properties: [
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'name',
                                                loc: {
                                                    start: {
                                                        line: 14,
                                                        column: 21,
                                                        fixed: true,
                                                        source: 'glass/html/material/Checkbox.ion'
                                                    },
                                                    end: {
                                                        line: 14,
                                                        column: 25,
                                                        fixed: true,
                                                        source: 'glass/html/material/Checkbox.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'ConditionalExpression',
                                                test: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'state',
                                                        loc: {
                                                            start: {
                                                                line: 14,
                                                                column: 27,
                                                                fixed: true,
                                                                source: 'glass/html/material/Checkbox.ion'
                                                            },
                                                            end: {
                                                                line: 14,
                                                                column: 32,
                                                                fixed: true,
                                                                source: 'glass/html/material/Checkbox.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'checked',
                                                        loc: {
                                                            start: {
                                                                line: 14,
                                                                column: 33,
                                                                fixed: true,
                                                                source: 'glass/html/material/Checkbox.ion'
                                                            },
                                                            end: {
                                                                line: 14,
                                                                column: 40,
                                                                fixed: true,
                                                                source: 'glass/html/material/Checkbox.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 14,
                                                            column: 27,
                                                            fixed: true,
                                                            source: 'glass/html/material/Checkbox.ion'
                                                        },
                                                        end: {
                                                            line: 14,
                                                            column: 40,
                                                            fixed: true,
                                                            source: 'glass/html/material/Checkbox.ion'
                                                        }
                                                    }
                                                },
                                                consequent: {
                                                    type: 'Literal',
                                                    value: 'check box'
                                                },
                                                alternate: {
                                                    type: 'Literal',
                                                    value: 'check box outline blank'
                                                }
                                            },
                                            kind: 'init',
                                            order: '0'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'size',
                                                loc: {
                                                    start: {
                                                        line: 14,
                                                        column: 84,
                                                        fixed: true,
                                                        source: 'glass/html/material/Checkbox.ion'
                                                    },
                                                    end: {
                                                        line: 14,
                                                        column: 88,
                                                        fixed: true,
                                                        source: 'glass/html/material/Checkbox.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: 18
                                            },
                                            kind: 'init',
                                            order: '1'
                                        }
                                    ]
                                }],
                            loc: {
                                start: {
                                    line: 14,
                                    column: 15,
                                    fixed: true,
                                    source: 'glass/html/material/Checkbox.ion'
                                },
                                end: {
                                    line: 14,
                                    column: 93,
                                    fixed: true,
                                    source: 'glass/html/material/Checkbox.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'CallExpression',
                    callee: {
                        type: 'MemberExpression',
                        object: {
                            type: 'Identifier',
                            name: 'Object'
                        },
                        property: {
                            type: 'Identifier',
                            name: 'defineProperties'
                        }
                    },
                    arguments: [
                        {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'Identifier',
                                name: 'icon',
                                loc: {
                                    start: {
                                        line: 15,
                                        column: 11,
                                        fixed: true,
                                        source: 'glass/html/material/Checkbox.ion'
                                    },
                                    end: {
                                        line: 15,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/Checkbox.ion'
                                    }
                                }
                            },
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'classList',
                                        loc: {
                                            start: {
                                                line: 16,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Checkbox.ion'
                                            },
                                            end: {
                                                line: 16,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/Checkbox.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'Literal',
                                                    value: 'Checkbox'
                                                },
                                                loc: {
                                                    start: {
                                                        line: 17,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/Checkbox.ion'
                                                    },
                                                    end: {
                                                        line: 17,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'glass/html/material/Checkbox.ion'
                                                    }
                                                },
                                                order: '0'
                                            },
                                            {
                                                type: 'IfStatement',
                                                test: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'state',
                                                        loc: {
                                                            start: {
                                                                line: 18,
                                                                column: 15,
                                                                fixed: true,
                                                                source: 'glass/html/material/Checkbox.ion'
                                                            },
                                                            end: {
                                                                line: 18,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'glass/html/material/Checkbox.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'checked',
                                                        loc: {
                                                            start: {
                                                                line: 18,
                                                                column: 21,
                                                                fixed: true,
                                                                source: 'glass/html/material/Checkbox.ion'
                                                            },
                                                            end: {
                                                                line: 18,
                                                                column: 28,
                                                                fixed: true,
                                                                source: 'glass/html/material/Checkbox.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 18,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Checkbox.ion'
                                                        },
                                                        end: {
                                                            line: 18,
                                                            column: 28,
                                                            fixed: true,
                                                            source: 'glass/html/material/Checkbox.ion'
                                                        }
                                                    }
                                                },
                                                consequent: {
                                                    type: 'BlockStatement',
                                                    body: [{
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'Literal',
                                                                value: 'checked'
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 19,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Checkbox.ion'
                                                                },
                                                                end: {
                                                                    line: 19,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Checkbox.ion'
                                                                }
                                                            },
                                                            order: '0'
                                                        }]
                                                },
                                                alternate: null,
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    order: '0'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'Function',
                                        context: false,
                                        value: function click(e) {
                                            this.value = !this.value;
                                            this.dispatchEvent(new CustomEvent('change', { detail: this.value }));
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 20,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/Checkbox.ion'
                                        },
                                        end: {
                                            line: 23,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/material/Checkbox.ion'
                                        }
                                    },
                                    order: '1'
                                }
                            ]
                        },
                        {
                            type: 'ObjectExpression',
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'value',
                                        loc: {
                                            start: {
                                                line: 23,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/Checkbox.ion'
                                            },
                                            end: {
                                                line: 23,
                                                column: 22,
                                                fixed: true,
                                                source: 'glass/html/material/Checkbox.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 24,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Checkbox.ion'
                                                        },
                                                        end: {
                                                            line: 24,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Checkbox.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context) {
                                                        return function () {
                                                            var state = _context.get('state');
                                                            return state.checked;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 25,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Checkbox.ion'
                                                        },
                                                        end: {
                                                            line: 25,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Checkbox.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context2) {
                                                        return function (value) {
                                                            var state = _context2.get('state');
                                                            state.checked = value === true;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'valueJSON',
                                        loc: {
                                            start: {
                                                line: 27,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/Checkbox.ion'
                                            },
                                            end: {
                                                line: 27,
                                                column: 26,
                                                fixed: true,
                                                source: 'glass/html/material/Checkbox.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 28,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Checkbox.ion'
                                                        },
                                                        end: {
                                                            line: 28,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Checkbox.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: false,
                                                    value: function () {
                                                        return this.value;
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 29,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Checkbox.ion'
                                                        },
                                                        end: {
                                                            line: 29,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Checkbox.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: false,
                                                    value: function (value) {
                                                        return this.value = value;
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '1'
                                }
                            ]
                        }
                    ]
                },
                order: '2'
            }
        ],
        bound: false
    }, {
        this: this,
        _ref: _ref,
        _ref2: _ref2,
        Icon: Icon,
        style: style
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/Checkbox',_glass_html_material_Checkbox_);
    else
      _glass_html_material_Checkbox_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_Checkbox_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_CheckboxField_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('./'), style = require('../style');
var Checkbox = _ref.Checkbox;
style.define(module.id, '.CheckboxField {\n    margin: 0.5em 0em;\n}\n.CheckboxField SPAN {\n}');
module.exports = exports = ion.template(function CheckboxField(_ref2) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'CheckboxField',
            loc: {
                start: {
                    line: 15,
                    column: 16,
                    fixed: true,
                    source: 'glass/html/material/CheckboxField.ion'
                },
                end: {
                    line: 15,
                    column: 29,
                    fixed: true,
                    source: 'glass/html/material/CheckboxField.ion'
                }
            }
        },
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'label',
                            loc: {
                                start: {
                                    line: 15,
                                    column: 31,
                                    fixed: true,
                                    source: 'glass/html/material/CheckboxField.ion'
                                },
                                end: {
                                    line: 15,
                                    column: 36,
                                    fixed: true,
                                    source: 'glass/html/material/CheckboxField.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref2'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'label',
                                loc: {
                                    start: {
                                        line: 15,
                                        column: 31,
                                        fixed: true,
                                        source: 'glass/html/material/CheckboxField.ion'
                                    },
                                    end: {
                                        line: 15,
                                        column: 36,
                                        fixed: true,
                                        source: 'glass/html/material/CheckboxField.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'name',
                            loc: {
                                start: {
                                    line: 15,
                                    column: 37,
                                    fixed: true,
                                    source: 'glass/html/material/CheckboxField.ion'
                                },
                                end: {
                                    line: 15,
                                    column: 41,
                                    fixed: true,
                                    source: 'glass/html/material/CheckboxField.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref2'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'name',
                                loc: {
                                    start: {
                                        line: 15,
                                        column: 37,
                                        fixed: true,
                                        source: 'glass/html/material/CheckboxField.ion'
                                    },
                                    end: {
                                        line: 15,
                                        column: 41,
                                        fixed: true,
                                        source: 'glass/html/material/CheckboxField.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'required',
                            loc: {
                                start: {
                                    line: 15,
                                    column: 42,
                                    fixed: true,
                                    source: 'glass/html/material/CheckboxField.ion'
                                },
                                end: {
                                    line: 15,
                                    column: 50,
                                    fixed: true,
                                    source: 'glass/html/material/CheckboxField.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref2'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'required',
                                loc: {
                                    start: {
                                        line: 15,
                                        column: 42,
                                        fixed: true,
                                        source: 'glass/html/material/CheckboxField.ion'
                                    },
                                    end: {
                                        line: 15,
                                        column: 50,
                                        fixed: true,
                                        source: 'glass/html/material/CheckboxField.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'value',
                            loc: {
                                start: {
                                    line: 15,
                                    column: 51,
                                    fixed: true,
                                    source: 'glass/html/material/CheckboxField.ion'
                                },
                                end: {
                                    line: 15,
                                    column: 56,
                                    fixed: true,
                                    source: 'glass/html/material/CheckboxField.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref2'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'value',
                                loc: {
                                    start: {
                                        line: 15,
                                        column: 51,
                                        fixed: true,
                                        source: 'glass/html/material/CheckboxField.ion'
                                    },
                                    end: {
                                        line: 15,
                                        column: 56,
                                        fixed: true,
                                        source: 'glass/html/material/CheckboxField.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '3'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'field',
                            loc: {
                                start: {
                                    line: 16,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/CheckboxField.ion'
                                },
                                end: {
                                    line: 16,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/html/material/CheckboxField.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Label',
                                loc: {
                                    start: {
                                        line: 16,
                                        column: 16,
                                        fixed: true,
                                        source: 'glass/html/material/CheckboxField.ion'
                                    },
                                    end: {
                                        line: 16,
                                        column: 21,
                                        fixed: true,
                                        source: 'glass/html/material/CheckboxField.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ObjectExpression',
                                    properties: [{
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'class',
                                                loc: {
                                                    start: {
                                                        line: 16,
                                                        column: 23,
                                                        fixed: true,
                                                        source: 'glass/html/material/CheckboxField.ion'
                                                    },
                                                    end: {
                                                        line: 16,
                                                        column: 28,
                                                        fixed: true,
                                                        source: 'glass/html/material/CheckboxField.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: 'CheckboxField layout horizontal center validate'
                                            },
                                            kind: 'init',
                                            order: '0'
                                        }]
                                }],
                            loc: {
                                start: {
                                    line: 16,
                                    column: 16,
                                    fixed: true,
                                    source: 'glass/html/material/CheckboxField.ion'
                                },
                                end: {
                                    line: 16,
                                    column: 80,
                                    fixed: true,
                                    source: 'glass/html/material/CheckboxField.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '4'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'checkbox',
                            loc: {
                                start: {
                                    line: 17,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/CheckboxField.ion'
                                },
                                end: {
                                    line: 17,
                                    column: 16,
                                    fixed: true,
                                    source: 'glass/html/material/CheckboxField.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Checkbox',
                                    loc: {
                                        start: {
                                            line: 17,
                                            column: 19,
                                            fixed: true,
                                            source: 'glass/html/material/CheckboxField.ion'
                                        },
                                        end: {
                                            line: 17,
                                            column: 27,
                                            fixed: true,
                                            source: 'glass/html/material/CheckboxField.ion'
                                        }
                                    }
                                },
                                arguments: [],
                                loc: {
                                    start: {
                                        line: 17,
                                        column: 19,
                                        fixed: true,
                                        source: 'glass/html/material/CheckboxField.ion'
                                    },
                                    end: {
                                        line: 17,
                                        column: 29,
                                        fixed: true,
                                        source: 'glass/html/material/CheckboxField.ion'
                                    }
                                }
                            },
                            properties: [{
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context) {
                                            return function change(e) {
                                                var field = _context.get('field');
                                                field.dispatchEvent(new CustomEvent('change', { detail: e.detail }));
                                            };
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 18,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/CheckboxField.ion'
                                        },
                                        end: {
                                            line: 20,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/material/CheckboxField.ion'
                                        }
                                    },
                                    order: '0'
                                }]
                        }
                    }],
                kind: 'let',
                order: '5'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'CallExpression',
                    callee: {
                        type: 'MemberExpression',
                        object: {
                            type: 'Identifier',
                            name: 'Object'
                        },
                        property: {
                            type: 'Identifier',
                            name: 'defineProperties'
                        }
                    },
                    arguments: [
                        {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'Identifier',
                                name: 'field',
                                loc: {
                                    start: {
                                        line: 20,
                                        column: 11,
                                        fixed: true,
                                        source: 'glass/html/material/CheckboxField.ion'
                                    },
                                    end: {
                                        line: 20,
                                        column: 16,
                                        fixed: true,
                                        source: 'glass/html/material/CheckboxField.ion'
                                    }
                                }
                            },
                            properties: [
                                {
                                    type: 'IfStatement',
                                    test: {
                                        type: 'UnaryExpression',
                                        operator: '?',
                                        argument: {
                                            type: 'Identifier',
                                            name: 'name',
                                            loc: {
                                                start: {
                                                    line: 21,
                                                    column: 11,
                                                    fixed: true,
                                                    source: 'glass/html/material/CheckboxField.ion'
                                                },
                                                end: {
                                                    line: 21,
                                                    column: 15,
                                                    fixed: true,
                                                    source: 'glass/html/material/CheckboxField.ion'
                                                }
                                            }
                                        }
                                    },
                                    consequent: {
                                        type: 'BlockStatement',
                                        body: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'name',
                                                    loc: {
                                                        start: {
                                                            line: 22,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/CheckboxField.ion'
                                                        },
                                                        end: {
                                                            line: 22,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/CheckboxField.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Identifier',
                                                    name: 'name',
                                                    loc: {
                                                        start: {
                                                            line: 22,
                                                            column: 18,
                                                            fixed: true,
                                                            source: 'glass/html/material/CheckboxField.ion'
                                                        },
                                                        end: {
                                                            line: 22,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'glass/html/material/CheckboxField.ion'
                                                        }
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    },
                                    alternate: null,
                                    order: '0'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'Identifier',
                                        name: 'checkbox',
                                        loc: {
                                            start: {
                                                line: 29,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/CheckboxField.ion'
                                            },
                                            end: {
                                                line: 29,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/CheckboxField.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 29,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/CheckboxField.ion'
                                        },
                                        end: {
                                            line: 29,
                                            column: 16,
                                            fixed: true,
                                            source: 'glass/html/material/CheckboxField.ion'
                                        }
                                    },
                                    order: '1'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'validate',
                                        loc: {
                                            start: {
                                                line: 30,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/CheckboxField.ion'
                                            },
                                            end: {
                                                line: 30,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/CheckboxField.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context2) {
                                            return function () {
                                                var required = _context2.get('required');
                                                if (required && !this.value) {
                                                    return false;
                                                }
                                                return true;
                                            };
                                        }
                                    },
                                    kind: 'init',
                                    order: '2'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'ObjectExpression',
                                        objectType: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'Identifier',
                                                name: 'Span',
                                                loc: {
                                                    start: {
                                                        line: 34,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'glass/html/material/CheckboxField.ion'
                                                    },
                                                    end: {
                                                        line: 34,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/CheckboxField.ion'
                                                    }
                                                }
                                            },
                                            arguments: [],
                                            loc: {
                                                start: {
                                                    line: 34,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'glass/html/material/CheckboxField.ion'
                                                },
                                                end: {
                                                    line: 34,
                                                    column: 14,
                                                    fixed: true,
                                                    source: 'glass/html/material/CheckboxField.ion'
                                                }
                                            }
                                        },
                                        properties: [
                                            {
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context3) {
                                                        return function click() {
                                                            var checkbox = _context3.get('checkbox');
                                                            return checkbox.value = !checkbox.value;
                                                        };
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 35,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/CheckboxField.ion'
                                                    },
                                                    end: {
                                                        line: 35,
                                                        column: 56,
                                                        fixed: true,
                                                        source: 'glass/html/material/CheckboxField.ion'
                                                    }
                                                },
                                                order: '0'
                                            },
                                            {
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'Identifier',
                                                    name: 'label',
                                                    loc: {
                                                        start: {
                                                            line: 36,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/CheckboxField.ion'
                                                        },
                                                        end: {
                                                            line: 36,
                                                            column: 17,
                                                            fixed: true,
                                                            source: 'glass/html/material/CheckboxField.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 36,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/CheckboxField.ion'
                                                    },
                                                    end: {
                                                        line: 36,
                                                        column: 17,
                                                        fixed: true,
                                                        source: 'glass/html/material/CheckboxField.ion'
                                                    }
                                                },
                                                order: '1'
                                            }
                                        ]
                                    },
                                    loc: {
                                        start: {
                                            line: 34,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/CheckboxField.ion'
                                        },
                                        end: {
                                            line: 38,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/material/CheckboxField.ion'
                                        }
                                    },
                                    order: '3'
                                }
                            ]
                        },
                        {
                            type: 'ObjectExpression',
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'value',
                                        loc: {
                                            start: {
                                                line: 23,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/CheckboxField.ion'
                                            },
                                            end: {
                                                line: 23,
                                                column: 22,
                                                fixed: true,
                                                source: 'glass/html/material/CheckboxField.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 24,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/CheckboxField.ion'
                                                        },
                                                        end: {
                                                            line: 24,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/CheckboxField.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context4) {
                                                        return function () {
                                                            var checkbox = _context4.get('checkbox');
                                                            return checkbox.value;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 25,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/CheckboxField.ion'
                                                        },
                                                        end: {
                                                            line: 25,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/CheckboxField.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context5) {
                                                        return function (value) {
                                                            var checkbox = _context5.get('checkbox');
                                                            return checkbox.value = value;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'valueJSON',
                                        loc: {
                                            start: {
                                                line: 26,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/CheckboxField.ion'
                                            },
                                            end: {
                                                line: 26,
                                                column: 26,
                                                fixed: true,
                                                source: 'glass/html/material/CheckboxField.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 27,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/CheckboxField.ion'
                                                        },
                                                        end: {
                                                            line: 27,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/CheckboxField.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: false,
                                                    value: function () {
                                                        return this.value;
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 28,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/CheckboxField.ion'
                                                        },
                                                        end: {
                                                            line: 28,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/CheckboxField.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: false,
                                                    value: function (value) {
                                                        return this.value = value;
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '1'
                                }
                            ]
                        }
                    ]
                },
                order: '6'
            }
        ],
        bound: false
    }, {
        this: this,
        _ref2: _ref2,
        _ref: _ref,
        style: style,
        Checkbox: Checkbox
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/CheckboxField',_glass_html_material_CheckboxField_);
    else
      _glass_html_material_CheckboxField_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_CheckboxField_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_Chip_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('./'), _ref2;
var Icon = _ref.Icon;
_ref2 = require('../');
var style = _ref2.style;
var _ref3 = style.sheets;
_ref3[module.id] = '.Chip {\n    overflow: hidden;\n    white-space: nowrap;\n    user-select:none;\n    transition: all 300ms;\n    background: ' + style.rgba(style.color.black, style.opacity.divider) + ';\n    height: 24px;\n    min-width: 24px;\n    border-radius: 16px;\n    font-size: 13px;\n    margin: 1px;\n}\n.Chip.small {\n    background: none;\n}\n.Chip DIV:nth-child(2) {\n    margin-left: 12px;\n    margin-right: 12px;\n}\n.Chip.hasIcon DIV:nth-child(2) {\n    margin-left: 8px;\n}';
_ref3;
module.exports = exports = ion.template(function Chip() {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'Chip',
            loc: {
                start: {
                    line: 30,
                    column: 16,
                    fixed: true,
                    source: 'glass/html/material/Chip.ion'
                },
                end: {
                    line: 30,
                    column: 20,
                    fixed: true,
                    source: 'glass/html/material/Chip.ion'
                }
            }
        },
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'state',
                            loc: {
                                start: {
                                    line: 31,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/Chip.ion'
                                },
                                end: {
                                    line: 31,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/html/material/Chip.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Function',
                                context: false,
                                value: function () {
                                    return {
                                        height: 30,
                                        content: null,
                                        contentShort: null
                                    };
                                }
                            },
                            arguments: [],
                            loc: {
                                start: {
                                    line: 31,
                                    column: 16,
                                    fixed: true,
                                    source: 'glass/html/material/Chip.ion'
                                },
                                end: {
                                    line: 35,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/Chip.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'fontSize',
                            loc: {
                                start: {
                                    line: 35,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/Chip.ion'
                                },
                                end: {
                                    line: 35,
                                    column: 16,
                                    fixed: true,
                                    source: 'glass/html/material/Chip.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'Math',
                                    loc: {
                                        start: {
                                            line: 35,
                                            column: 19,
                                            fixed: true,
                                            source: 'glass/html/material/Chip.ion'
                                        },
                                        end: {
                                            line: 35,
                                            column: 23,
                                            fixed: true,
                                            source: 'glass/html/material/Chip.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'floor',
                                    loc: {
                                        start: {
                                            line: 35,
                                            column: 24,
                                            fixed: true,
                                            source: 'glass/html/material/Chip.ion'
                                        },
                                        end: {
                                            line: 35,
                                            column: 29,
                                            fixed: true,
                                            source: 'glass/html/material/Chip.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 35,
                                        column: 19,
                                        fixed: true,
                                        source: 'glass/html/material/Chip.ion'
                                    },
                                    end: {
                                        line: 35,
                                        column: 29,
                                        fixed: true,
                                        source: 'glass/html/material/Chip.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'BinaryExpression',
                                    operator: '/',
                                    left: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'state',
                                            loc: {
                                                start: {
                                                    line: 35,
                                                    column: 30,
                                                    fixed: true,
                                                    source: 'glass/html/material/Chip.ion'
                                                },
                                                end: {
                                                    line: 35,
                                                    column: 35,
                                                    fixed: true,
                                                    source: 'glass/html/material/Chip.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'height',
                                            loc: {
                                                start: {
                                                    line: 35,
                                                    column: 36,
                                                    fixed: true,
                                                    source: 'glass/html/material/Chip.ion'
                                                },
                                                end: {
                                                    line: 35,
                                                    column: 42,
                                                    fixed: true,
                                                    source: 'glass/html/material/Chip.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 35,
                                                column: 30,
                                                fixed: true,
                                                source: 'glass/html/material/Chip.ion'
                                            },
                                            end: {
                                                line: 35,
                                                column: 42,
                                                fixed: true,
                                                source: 'glass/html/material/Chip.ion'
                                            }
                                        }
                                    },
                                    right: {
                                        type: 'Literal',
                                        value: 3
                                    }
                                }],
                            loc: {
                                start: {
                                    line: 35,
                                    column: 19,
                                    fixed: true,
                                    source: 'glass/html/material/Chip.ion'
                                },
                                end: {
                                    line: 35,
                                    column: 47,
                                    fixed: true,
                                    source: 'glass/html/material/Chip.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'height',
                            loc: {
                                start: {
                                    line: 36,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/Chip.ion'
                                },
                                end: {
                                    line: 36,
                                    column: 14,
                                    fixed: true,
                                    source: 'glass/html/material/Chip.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            computed: false,
                            object: {
                                type: 'Identifier',
                                name: 'state',
                                loc: {
                                    start: {
                                        line: 36,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/html/material/Chip.ion'
                                    },
                                    end: {
                                        line: 36,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/material/Chip.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'height',
                                loc: {
                                    start: {
                                        line: 36,
                                        column: 23,
                                        fixed: true,
                                        source: 'glass/html/material/Chip.ion'
                                    },
                                    end: {
                                        line: 36,
                                        column: 29,
                                        fixed: true,
                                        source: 'glass/html/material/Chip.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 36,
                                    column: 17,
                                    fixed: true,
                                    source: 'glass/html/material/Chip.ion'
                                },
                                end: {
                                    line: 36,
                                    column: 29,
                                    fixed: true,
                                    source: 'glass/html/material/Chip.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'chip',
                            loc: {
                                start: {
                                    line: 38,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/Chip.ion'
                                },
                                end: {
                                    line: 38,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/Chip.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: 'Object'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'defineProperties'
                                }
                            },
                            arguments: [
                                {
                                    type: 'ObjectExpression',
                                    objectType: {
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'Identifier',
                                            name: 'Span',
                                            loc: {
                                                start: {
                                                    line: 38,
                                                    column: 15,
                                                    fixed: true,
                                                    source: 'glass/html/material/Chip.ion'
                                                },
                                                end: {
                                                    line: 38,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'glass/html/material/Chip.ion'
                                                }
                                            }
                                        },
                                        arguments: [{
                                                type: 'ObjectExpression',
                                                properties: [{
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'class',
                                                            loc: {
                                                                start: {
                                                                    line: 38,
                                                                    column: 21,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Chip.ion'
                                                                },
                                                                end: {
                                                                    line: 38,
                                                                    column: 26,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Chip.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Literal',
                                                            value: 'Chip layout horizontal inline center'
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    }]
                                            }],
                                        loc: {
                                            start: {
                                                line: 38,
                                                column: 15,
                                                fixed: true,
                                                source: 'glass/html/material/Chip.ion'
                                            },
                                            end: {
                                                line: 38,
                                                column: 67,
                                                fixed: true,
                                                source: 'glass/html/material/Chip.ion'
                                            }
                                        }
                                    },
                                    properties: []
                                },
                                {
                                    type: 'ObjectExpression',
                                    properties: [{
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'height',
                                                loc: {
                                                    start: {
                                                        line: 39,
                                                        column: 17,
                                                        fixed: true,
                                                        source: 'glass/html/material/Chip.ion'
                                                    },
                                                    end: {
                                                        line: 39,
                                                        column: 23,
                                                        fixed: true,
                                                        source: 'glass/html/material/Chip.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'ObjectExpression',
                                                properties: [
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'get',
                                                            loc: {
                                                                start: {
                                                                    line: 40,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Chip.ion'
                                                                },
                                                                end: {
                                                                    line: 40,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Chip.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Function',
                                                            context: true,
                                                            value: function (_context) {
                                                                return function () {
                                                                    var state = _context.get('state');
                                                                    return state.height;
                                                                };
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'set',
                                                            loc: {
                                                                start: {
                                                                    line: 41,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Chip.ion'
                                                                },
                                                                end: {
                                                                    line: 41,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Chip.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Function',
                                                            context: true,
                                                            value: function (_context2) {
                                                                return function (value) {
                                                                    var state = _context2.get('state');
                                                                    return state.height = value;
                                                                };
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '1'
                                                    }
                                                ]
                                            },
                                            kind: 'init',
                                            define: false,
                                            order: '0'
                                        }]
                                }
                            ]
                        }
                    }],
                kind: 'let',
                order: '3'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'small',
                            loc: {
                                start: {
                                    line: 43,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/Chip.ion'
                                },
                                end: {
                                    line: 43,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/html/material/Chip.ion'
                                }
                            }
                        },
                        init: {
                            type: 'BinaryExpression',
                            operator: '<',
                            left: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'chip',
                                    loc: {
                                        start: {
                                            line: 43,
                                            column: 16,
                                            fixed: true,
                                            source: 'glass/html/material/Chip.ion'
                                        },
                                        end: {
                                            line: 43,
                                            column: 20,
                                            fixed: true,
                                            source: 'glass/html/material/Chip.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'clientWidth',
                                    loc: {
                                        start: {
                                            line: 43,
                                            column: 21,
                                            fixed: true,
                                            source: 'glass/html/material/Chip.ion'
                                        },
                                        end: {
                                            line: 43,
                                            column: 32,
                                            fixed: true,
                                            source: 'glass/html/material/Chip.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 43,
                                        column: 16,
                                        fixed: true,
                                        source: 'glass/html/material/Chip.ion'
                                    },
                                    end: {
                                        line: 43,
                                        column: 32,
                                        fixed: true,
                                        source: 'glass/html/material/Chip.ion'
                                    }
                                }
                            },
                            right: {
                                type: 'Literal',
                                value: 50
                            }
                        }
                    }],
                kind: 'let',
                order: '4'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'CallExpression',
                    callee: {
                        type: 'MemberExpression',
                        object: {
                            type: 'Identifier',
                            name: 'Object'
                        },
                        property: {
                            type: 'Identifier',
                            name: 'defineProperties'
                        }
                    },
                    arguments: [
                        {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'Identifier',
                                name: 'chip',
                                loc: {
                                    start: {
                                        line: 45,
                                        column: 11,
                                        fixed: true,
                                        source: 'glass/html/material/Chip.ion'
                                    },
                                    end: {
                                        line: 45,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/Chip.ion'
                                    }
                                }
                            },
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'classList',
                                        loc: {
                                            start: {
                                                line: 56,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Chip.ion'
                                            },
                                            end: {
                                                line: 56,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/Chip.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'IfStatement',
                                                test: {
                                                    type: 'Identifier',
                                                    name: 'small',
                                                    loc: {
                                                        start: {
                                                            line: 57,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Chip.ion'
                                                        },
                                                        end: {
                                                            line: 57,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'glass/html/material/Chip.ion'
                                                        }
                                                    }
                                                },
                                                consequent: {
                                                    type: 'BlockStatement',
                                                    body: [{
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'Literal',
                                                                value: 'small'
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 58,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Chip.ion'
                                                                },
                                                                end: {
                                                                    line: 58,
                                                                    column: 23,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Chip.ion'
                                                                }
                                                            },
                                                            order: '0'
                                                        }]
                                                },
                                                alternate: null,
                                                order: '0'
                                            }]
                                    },
                                    kind: 'init',
                                    order: '0'
                                },
                                {
                                    type: 'VariableDeclaration',
                                    declarations: [{
                                            type: 'VariableDeclarator',
                                            id: {
                                                type: 'Identifier',
                                                name: 'left',
                                                loc: {
                                                    start: {
                                                        line: 59,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/Chip.ion'
                                                    },
                                                    end: {
                                                        line: 59,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'glass/html/material/Chip.ion'
                                                    }
                                                }
                                            },
                                            init: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'Div',
                                                    loc: {
                                                        start: {
                                                            line: 59,
                                                            column: 19,
                                                            fixed: true,
                                                            source: 'glass/html/material/Chip.ion'
                                                        },
                                                        end: {
                                                            line: 59,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'glass/html/material/Chip.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [{
                                                        type: 'ObjectExpression',
                                                        properties: [{
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'class',
                                                                    loc: {
                                                                        start: {
                                                                            line: 59,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Chip.ion'
                                                                        },
                                                                        end: {
                                                                            line: 59,
                                                                            column: 29,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Chip.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: 'fixed'
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            }]
                                                    }],
                                                loc: {
                                                    start: {
                                                        line: 59,
                                                        column: 19,
                                                        fixed: true,
                                                        source: 'glass/html/material/Chip.ion'
                                                    },
                                                    end: {
                                                        line: 59,
                                                        column: 39,
                                                        fixed: true,
                                                        source: 'glass/html/material/Chip.ion'
                                                    }
                                                }
                                            }
                                        }],
                                    kind: 'let',
                                    order: '1'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'left',
                                        loc: {
                                            start: {
                                                line: 60,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Chip.ion'
                                            },
                                            end: {
                                                line: 60,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/Chip.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Identifier',
                                        name: 'left',
                                        loc: {
                                            start: {
                                                line: 60,
                                                column: 14,
                                                fixed: true,
                                                source: 'glass/html/material/Chip.ion'
                                            },
                                            end: {
                                                line: 60,
                                                column: 18,
                                                fixed: true,
                                                source: 'glass/html/material/Chip.ion'
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '2'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'Identifier',
                                        name: 'left',
                                        loc: {
                                            start: {
                                                line: 61,
                                                column: 9,
                                                fixed: true,
                                                source: 'glass/html/material/Chip.ion'
                                            },
                                            end: {
                                                line: 61,
                                                column: 13,
                                                fixed: true,
                                                source: 'glass/html/material/Chip.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 61,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/Chip.ion'
                                        },
                                        end: {
                                            line: 61,
                                            column: 14,
                                            fixed: true,
                                            source: 'glass/html/material/Chip.ion'
                                        }
                                    },
                                    order: '3'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'classList',
                                        loc: {
                                            start: {
                                                line: 62,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Chip.ion'
                                            },
                                            end: {
                                                line: 62,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/Chip.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'IfStatement',
                                                test: {
                                                    type: 'UnaryExpression',
                                                    operator: '?',
                                                    argument: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'left',
                                                            loc: {
                                                                start: {
                                                                    line: 63,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Chip.ion'
                                                                },
                                                                end: {
                                                                    line: 63,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Chip.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'firstChild',
                                                            loc: {
                                                                start: {
                                                                    line: 63,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Chip.ion'
                                                                },
                                                                end: {
                                                                    line: 63,
                                                                    column: 30,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Chip.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 63,
                                                                column: 15,
                                                                fixed: true,
                                                                source: 'glass/html/material/Chip.ion'
                                                            },
                                                            end: {
                                                                line: 63,
                                                                column: 30,
                                                                fixed: true,
                                                                source: 'glass/html/material/Chip.ion'
                                                            }
                                                        }
                                                    }
                                                },
                                                consequent: {
                                                    type: 'BlockStatement',
                                                    body: [{
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'Literal',
                                                                value: 'hasIcon'
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 64,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Chip.ion'
                                                                },
                                                                end: {
                                                                    line: 64,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Chip.ion'
                                                                }
                                                            },
                                                            order: '0'
                                                        }]
                                                },
                                                alternate: null,
                                                order: '0'
                                            }]
                                    },
                                    kind: 'init',
                                    order: '4'
                                },
                                {
                                    type: 'VariableDeclaration',
                                    declarations: [{
                                            type: 'VariableDeclarator',
                                            id: {
                                                type: 'Identifier',
                                                name: 'container',
                                                loc: {
                                                    start: {
                                                        line: 65,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/Chip.ion'
                                                    },
                                                    end: {
                                                        line: 65,
                                                        column: 21,
                                                        fixed: true,
                                                        source: 'glass/html/material/Chip.ion'
                                                    }
                                                }
                                            },
                                            init: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context3) {
                                                        return function () {
                                                            var ion = _context3.get('ion');
                                                            return ion.patch.combine(Div({ class: 'fill container' }), {
                                                                style: {
                                                                    marginRight: '10px',
                                                                    overflow: 'hidden',
                                                                    textOverflow: 'ellipsis'
                                                                }
                                                            });
                                                        };
                                                    }
                                                },
                                                arguments: [],
                                                loc: {
                                                    start: {
                                                        line: 65,
                                                        column: 24,
                                                        fixed: true,
                                                        source: 'glass/html/material/Chip.ion'
                                                    },
                                                    end: {
                                                        line: 71,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/Chip.ion'
                                                    }
                                                }
                                            }
                                        }],
                                    kind: 'let',
                                    order: '5'
                                },
                                {
                                    type: 'VariableDeclaration',
                                    declarations: [{
                                            type: 'VariableDeclarator',
                                            id: {
                                                type: 'Identifier',
                                                name: 'truncated',
                                                loc: {
                                                    start: {
                                                        line: 71,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/Chip.ion'
                                                    },
                                                    end: {
                                                        line: 71,
                                                        column: 21,
                                                        fixed: true,
                                                        source: 'glass/html/material/Chip.ion'
                                                    }
                                                }
                                            },
                                            init: {
                                                type: 'BinaryExpression',
                                                operator: '>',
                                                left: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'container',
                                                        loc: {
                                                            start: {
                                                                line: 71,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'glass/html/material/Chip.ion'
                                                            },
                                                            end: {
                                                                line: 71,
                                                                column: 33,
                                                                fixed: true,
                                                                source: 'glass/html/material/Chip.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'scrollWidth',
                                                        loc: {
                                                            start: {
                                                                line: 71,
                                                                column: 34,
                                                                fixed: true,
                                                                source: 'glass/html/material/Chip.ion'
                                                            },
                                                            end: {
                                                                line: 71,
                                                                column: 45,
                                                                fixed: true,
                                                                source: 'glass/html/material/Chip.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 71,
                                                            column: 24,
                                                            fixed: true,
                                                            source: 'glass/html/material/Chip.ion'
                                                        },
                                                        end: {
                                                            line: 71,
                                                            column: 45,
                                                            fixed: true,
                                                            source: 'glass/html/material/Chip.ion'
                                                        }
                                                    }
                                                },
                                                right: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'container',
                                                        loc: {
                                                            start: {
                                                                line: 71,
                                                                column: 48,
                                                                fixed: true,
                                                                source: 'glass/html/material/Chip.ion'
                                                            },
                                                            end: {
                                                                line: 71,
                                                                column: 57,
                                                                fixed: true,
                                                                source: 'glass/html/material/Chip.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'clientWidth',
                                                        loc: {
                                                            start: {
                                                                line: 71,
                                                                column: 58,
                                                                fixed: true,
                                                                source: 'glass/html/material/Chip.ion'
                                                            },
                                                            end: {
                                                                line: 71,
                                                                column: 69,
                                                                fixed: true,
                                                                source: 'glass/html/material/Chip.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 71,
                                                            column: 48,
                                                            fixed: true,
                                                            source: 'glass/html/material/Chip.ion'
                                                        },
                                                        end: {
                                                            line: 71,
                                                            column: 69,
                                                            fixed: true,
                                                            source: 'glass/html/material/Chip.ion'
                                                        }
                                                    }
                                                }
                                            }
                                        }],
                                    kind: 'let',
                                    order: '6'
                                },
                                {
                                    type: 'VariableDeclaration',
                                    declarations: [{
                                            type: 'VariableDeclarator',
                                            id: {
                                                type: 'Identifier',
                                                name: 'right',
                                                loc: {
                                                    start: {
                                                        line: 72,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/Chip.ion'
                                                    },
                                                    end: {
                                                        line: 72,
                                                        column: 17,
                                                        fixed: true,
                                                        source: 'glass/html/material/Chip.ion'
                                                    }
                                                }
                                            },
                                            init: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'Div',
                                                    loc: {
                                                        start: {
                                                            line: 72,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'glass/html/material/Chip.ion'
                                                        },
                                                        end: {
                                                            line: 72,
                                                            column: 23,
                                                            fixed: true,
                                                            source: 'glass/html/material/Chip.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [{
                                                        type: 'ObjectExpression',
                                                        properties: [{
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'class',
                                                                    loc: {
                                                                        start: {
                                                                            line: 72,
                                                                            column: 25,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Chip.ion'
                                                                        },
                                                                        end: {
                                                                            line: 72,
                                                                            column: 30,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Chip.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: 'fixed'
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            }]
                                                    }],
                                                loc: {
                                                    start: {
                                                        line: 72,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'glass/html/material/Chip.ion'
                                                    },
                                                    end: {
                                                        line: 72,
                                                        column: 40,
                                                        fixed: true,
                                                        source: 'glass/html/material/Chip.ion'
                                                    }
                                                }
                                            }
                                        }],
                                    kind: 'let',
                                    order: '7'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'ObjectExpression',
                                        objectType: {
                                            type: 'Identifier',
                                            name: 'container',
                                            loc: {
                                                start: {
                                                    line: 73,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'glass/html/material/Chip.ion'
                                                },
                                                end: {
                                                    line: 73,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'glass/html/material/Chip.ion'
                                                }
                                            }
                                        },
                                        properties: [
                                            {
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'ObjectExpression',
                                                    objectType: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'Identifier',
                                                            name: 'Div',
                                                            loc: {
                                                                start: {
                                                                    line: 74,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Chip.ion'
                                                                },
                                                                end: {
                                                                    line: 74,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Chip.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [{
                                                                type: 'ObjectExpression',
                                                                properties: [{
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'class',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 74,
                                                                                    column: 17,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Chip.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 74,
                                                                                    column: 22,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Chip.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Literal',
                                                                            value: 'fill'
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    }]
                                                            }],
                                                        loc: {
                                                            start: {
                                                                line: 74,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'glass/html/material/Chip.ion'
                                                            },
                                                            end: {
                                                                line: 74,
                                                                column: 31,
                                                                fixed: true,
                                                                source: 'glass/html/material/Chip.ion'
                                                            }
                                                        }
                                                    },
                                                    properties: [
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'style',
                                                                loc: {
                                                                    start: {
                                                                        line: 75,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Chip.ion'
                                                                    },
                                                                    end: {
                                                                        line: 75,
                                                                        column: 21,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Chip.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'ObjectExpression',
                                                                properties: [{
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'position',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 76,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Chip.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 76,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Chip.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Literal',
                                                                            value: 'relative'
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    }]
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        },
                                                        {
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'ObjectExpression',
                                                                objectType: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'Identifier',
                                                                        name: 'Span',
                                                                        loc: {
                                                                            start: {
                                                                                line: 77,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Chip.ion'
                                                                            },
                                                                            end: {
                                                                                line: 77,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Chip.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [{
                                                                            type: 'ObjectExpression',
                                                                            properties: [{
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'class',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 77,
                                                                                                column: 22,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Chip.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 77,
                                                                                                column: 27,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Chip.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Literal',
                                                                                        value: 'long'
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                }]
                                                                        }],
                                                                    loc: {
                                                                        start: {
                                                                            line: 77,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Chip.ion'
                                                                        },
                                                                        end: {
                                                                            line: 77,
                                                                            column: 36,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Chip.ion'
                                                                        }
                                                                    }
                                                                },
                                                                properties: [
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'style',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 78,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Chip.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 78,
                                                                                    column: 25,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Chip.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'ObjectExpression',
                                                                            properties: [{
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'visibility',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 79,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Chip.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 79,
                                                                                                column: 34,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Chip.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'ConditionalExpression',
                                                                                        test: {
                                                                                            type: 'BinaryExpression',
                                                                                            operator: '&&',
                                                                                            left: {
                                                                                                type: 'BinaryExpression',
                                                                                                operator: '&&',
                                                                                                left: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'truncated',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 79,
                                                                                                            column: 37,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/Chip.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 79,
                                                                                                            column: 46,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/Chip.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                right: {
                                                                                                    type: 'UnaryExpression',
                                                                                                    operator: '?',
                                                                                                    argument: {
                                                                                                        type: 'MemberExpression',
                                                                                                        computed: false,
                                                                                                        object: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'state',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 79,
                                                                                                                    column: 51,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/Chip.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 79,
                                                                                                                    column: 56,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/Chip.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        property: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'contentShort',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 79,
                                                                                                                    column: 57,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/Chip.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 79,
                                                                                                                    column: 69,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/Chip.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 79,
                                                                                                                column: 51,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/Chip.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 79,
                                                                                                                column: 69,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/Chip.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            right: {
                                                                                                type: 'UnaryExpression',
                                                                                                operator: '?',
                                                                                                argument: {
                                                                                                    type: 'MemberExpression',
                                                                                                    computed: false,
                                                                                                    object: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'left',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 79,
                                                                                                                column: 75,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/Chip.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 79,
                                                                                                                column: 79,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/Chip.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    property: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'firstChild',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 79,
                                                                                                                column: 80,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/Chip.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 79,
                                                                                                                column: 90,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/Chip.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 79,
                                                                                                            column: 75,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/Chip.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 79,
                                                                                                            column: 90,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/Chip.ion'
                                                                                                        }
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        consequent: {
                                                                                            type: 'Literal',
                                                                                            value: 'hidden'
                                                                                        },
                                                                                        alternate: {
                                                                                            type: 'Literal',
                                                                                            value: 'visible'
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                }]
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    },
                                                                    {
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'chip',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 80,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Chip.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 80,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Chip.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'content',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 80,
                                                                                        column: 25,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Chip.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 80,
                                                                                        column: 32,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Chip.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 80,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Chip.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 80,
                                                                                    column: 32,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Chip.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 80,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Chip.ion'
                                                                            },
                                                                            end: {
                                                                                line: 80,
                                                                                column: 32,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Chip.ion'
                                                                            }
                                                                        },
                                                                        order: '1'
                                                                    }
                                                                ]
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 77,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Chip.ion'
                                                                },
                                                                end: {
                                                                    line: 81,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Chip.ion'
                                                                }
                                                            },
                                                            order: '1'
                                                        },
                                                        {
                                                            type: 'IfStatement',
                                                            test: {
                                                                type: 'UnaryExpression',
                                                                operator: '?',
                                                                argument: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'state',
                                                                        loc: {
                                                                            start: {
                                                                                line: 81,
                                                                                column: 19,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Chip.ion'
                                                                            },
                                                                            end: {
                                                                                line: 81,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Chip.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'contentShort',
                                                                        loc: {
                                                                            start: {
                                                                                line: 81,
                                                                                column: 25,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Chip.ion'
                                                                            },
                                                                            end: {
                                                                                line: 81,
                                                                                column: 37,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Chip.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 81,
                                                                            column: 19,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Chip.ion'
                                                                        },
                                                                        end: {
                                                                            line: 81,
                                                                            column: 37,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Chip.ion'
                                                                        }
                                                                    }
                                                                }
                                                            },
                                                            consequent: {
                                                                type: 'BlockStatement',
                                                                body: [{
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'ObjectExpression',
                                                                            objectType: {
                                                                                type: 'CallExpression',
                                                                                callee: {
                                                                                    type: 'Identifier',
                                                                                    name: 'Span',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 82,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Chip.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 82,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Chip.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                arguments: [{
                                                                                        type: 'ObjectExpression',
                                                                                        properties: [{
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'class',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 82,
                                                                                                            column: 26,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/Chip.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 82,
                                                                                                            column: 31,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/Chip.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'Literal',
                                                                                                    value: 'short'
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '0'
                                                                                            }]
                                                                                    }],
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 82,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Chip.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 82,
                                                                                        column: 41,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Chip.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            properties: [
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'style',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 83,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Chip.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 83,
                                                                                                column: 29,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Chip.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'ObjectExpression',
                                                                                        properties: [
                                                                                            {
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'position',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 84,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/Chip.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 84,
                                                                                                            column: 36,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/Chip.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'Literal',
                                                                                                    value: 'absolute'
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '0'
                                                                                            },
                                                                                            {
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'left',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 85,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/Chip.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 85,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/Chip.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'Literal',
                                                                                                    value: '0px'
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '1'
                                                                                            },
                                                                                            {
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'visibility',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 86,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/Chip.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 86,
                                                                                                            column: 38,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/Chip.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'ConditionalExpression',
                                                                                                    test: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'truncated',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 86,
                                                                                                                column: 40,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/Chip.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 86,
                                                                                                                column: 49,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/Chip.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    consequent: {
                                                                                                        type: 'Literal',
                                                                                                        value: 'visible'
                                                                                                    },
                                                                                                    alternate: {
                                                                                                        type: 'Literal',
                                                                                                        value: 'hidden'
                                                                                                    }
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '2'
                                                                                            }
                                                                                        ]
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                },
                                                                                {
                                                                                    type: 'ExpressionStatement',
                                                                                    expression: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'chip',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 87,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Chip.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 87,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Chip.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'contentShort',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 87,
                                                                                                    column: 29,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Chip.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 87,
                                                                                                    column: 41,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Chip.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 87,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Chip.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 87,
                                                                                                column: 41,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Chip.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 87,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Chip.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 87,
                                                                                            column: 41,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Chip.ion'
                                                                                        }
                                                                                    },
                                                                                    order: '1'
                                                                                }
                                                                            ]
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 82,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Chip.ion'
                                                                            },
                                                                            end: {
                                                                                line: 88,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Chip.ion'
                                                                            }
                                                                        },
                                                                        order: '0'
                                                                    }]
                                                            },
                                                            alternate: null,
                                                            order: '2'
                                                        }
                                                    ]
                                                },
                                                loc: {
                                                    start: {
                                                        line: 74,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/Chip.ion'
                                                    },
                                                    end: {
                                                        line: 88,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'glass/html/material/Chip.ion'
                                                    }
                                                },
                                                order: '0'
                                            },
                                            {
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'Identifier',
                                                    name: 'right',
                                                    loc: {
                                                        start: {
                                                            line: 88,
                                                            column: 13,
                                                            fixed: true,
                                                            source: 'glass/html/material/Chip.ion'
                                                        },
                                                        end: {
                                                            line: 88,
                                                            column: 18,
                                                            fixed: true,
                                                            source: 'glass/html/material/Chip.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 88,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/Chip.ion'
                                                    },
                                                    end: {
                                                        line: 88,
                                                        column: 19,
                                                        fixed: true,
                                                        source: 'glass/html/material/Chip.ion'
                                                    }
                                                },
                                                order: '1'
                                            }
                                        ]
                                    },
                                    loc: {
                                        start: {
                                            line: 73,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/Chip.ion'
                                        },
                                        end: {
                                            line: 89,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/material/Chip.ion'
                                        }
                                    },
                                    order: '8'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'right',
                                        loc: {
                                            start: {
                                                line: 89,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Chip.ion'
                                            },
                                            end: {
                                                line: 89,
                                                column: 13,
                                                fixed: true,
                                                source: 'glass/html/material/Chip.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Identifier',
                                        name: 'right',
                                        loc: {
                                            start: {
                                                line: 89,
                                                column: 15,
                                                fixed: true,
                                                source: 'glass/html/material/Chip.ion'
                                            },
                                            end: {
                                                line: 89,
                                                column: 20,
                                                fixed: true,
                                                source: 'glass/html/material/Chip.ion'
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '9'
                                }
                            ]
                        },
                        {
                            type: 'ObjectExpression',
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'content',
                                        loc: {
                                            start: {
                                                line: 46,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/Chip.ion'
                                            },
                                            end: {
                                                line: 46,
                                                column: 24,
                                                fixed: true,
                                                source: 'glass/html/material/Chip.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 47,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Chip.ion'
                                                        },
                                                        end: {
                                                            line: 47,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Chip.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context4) {
                                                        return function () {
                                                            var state = _context4.get('state');
                                                            return state.content;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 48,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Chip.ion'
                                                        },
                                                        end: {
                                                            line: 48,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Chip.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context5) {
                                                        return function (value) {
                                                            var state = _context5.get('state');
                                                            return state.content = value;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'contentShort',
                                        loc: {
                                            start: {
                                                line: 49,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/Chip.ion'
                                            },
                                            end: {
                                                line: 49,
                                                column: 29,
                                                fixed: true,
                                                source: 'glass/html/material/Chip.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 50,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Chip.ion'
                                                        },
                                                        end: {
                                                            line: 50,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Chip.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context6) {
                                                        return function () {
                                                            var state = _context6.get('state');
                                                            return state.contentShort;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 51,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Chip.ion'
                                                        },
                                                        end: {
                                                            line: 51,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Chip.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context7) {
                                                        return function (value) {
                                                            var state = _context7.get('state');
                                                            return state.contentShort = value;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '1'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'contentShort',
                                        loc: {
                                            start: {
                                                line: 52,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/Chip.ion'
                                            },
                                            end: {
                                                line: 52,
                                                column: 29,
                                                fixed: true,
                                                source: 'glass/html/material/Chip.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 53,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Chip.ion'
                                                        },
                                                        end: {
                                                            line: 53,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Chip.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context8) {
                                                        return function () {
                                                            var state = _context8.get('state');
                                                            return state.contentShort;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 54,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Chip.ion'
                                                        },
                                                        end: {
                                                            line: 54,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Chip.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context9) {
                                                        return function (value) {
                                                            var state = _context9.get('state');
                                                            return state.contentShort = value;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '2'
                                }
                            ]
                        }
                    ]
                },
                order: '5'
            }
        ],
        bound: false
    }, {
        this: this,
        ion: ion,
        _ref: _ref,
        _ref2: _ref2,
        Icon: Icon,
        style: style,
        _ref3: _ref3
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/Chip',_glass_html_material_Chip_);
    else
      _glass_html_material_Chip_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_Chip_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_ConfirmDialog_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('./');
var Dialog = _ref.Dialog;
var Button = _ref.Button;
var prompt = ion.template(function prompt(_ref2) {
        return ion.createRuntime({
            type: 'Template',
            id: {
                type: 'Identifier',
                name: 'prompt',
                loc: {
                    start: {
                        line: 3,
                        column: 15,
                        fixed: true,
                        source: 'glass/html/material/ConfirmDialog.ion'
                    },
                    end: {
                        line: 3,
                        column: 21,
                        fixed: true,
                        source: 'glass/html/material/ConfirmDialog.ion'
                    }
                }
            },
            body: [
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'title',
                                loc: {
                                    start: {
                                        line: 3,
                                        column: 23,
                                        fixed: true,
                                        source: 'glass/html/material/ConfirmDialog.ion'
                                    },
                                    end: {
                                        line: 3,
                                        column: 28,
                                        fixed: true,
                                        source: 'glass/html/material/ConfirmDialog.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref2'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'title',
                                    loc: {
                                        start: {
                                            line: 3,
                                            column: 23,
                                            fixed: true,
                                            source: 'glass/html/material/ConfirmDialog.ion'
                                        },
                                        end: {
                                            line: 3,
                                            column: 28,
                                            fixed: true,
                                            source: 'glass/html/material/ConfirmDialog.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '0'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'callback',
                                loc: {
                                    start: {
                                        line: 3,
                                        column: 30,
                                        fixed: true,
                                        source: 'glass/html/material/ConfirmDialog.ion'
                                    },
                                    end: {
                                        line: 3,
                                        column: 38,
                                        fixed: true,
                                        source: 'glass/html/material/ConfirmDialog.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref2'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'callback',
                                    loc: {
                                        start: {
                                            line: 3,
                                            column: 30,
                                            fixed: true,
                                            source: 'glass/html/material/ConfirmDialog.ion'
                                        },
                                        end: {
                                            line: 3,
                                            column: 38,
                                            fixed: true,
                                            source: 'glass/html/material/ConfirmDialog.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '1'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'text',
                                loc: {
                                    start: {
                                        line: 3,
                                        column: 40,
                                        fixed: true,
                                        source: 'glass/html/material/ConfirmDialog.ion'
                                    },
                                    end: {
                                        line: 3,
                                        column: 44,
                                        fixed: true,
                                        source: 'glass/html/material/ConfirmDialog.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref2'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'text',
                                    loc: {
                                        start: {
                                            line: 3,
                                            column: 40,
                                            fixed: true,
                                            source: 'glass/html/material/ConfirmDialog.ion'
                                        },
                                        end: {
                                            line: 3,
                                            column: 44,
                                            fixed: true,
                                            source: 'glass/html/material/ConfirmDialog.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '2'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'style',
                                loc: {
                                    start: {
                                        line: 3,
                                        column: 46,
                                        fixed: true,
                                        source: 'glass/html/material/ConfirmDialog.ion'
                                    },
                                    end: {
                                        line: 3,
                                        column: 51,
                                        fixed: true,
                                        source: 'glass/html/material/ConfirmDialog.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref2'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'style',
                                    loc: {
                                        start: {
                                            line: 3,
                                            column: 46,
                                            fixed: true,
                                            source: 'glass/html/material/ConfirmDialog.ion'
                                        },
                                        end: {
                                            line: 3,
                                            column: 51,
                                            fixed: true,
                                            source: 'glass/html/material/ConfirmDialog.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '3'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'confirmText',
                                loc: {
                                    start: {
                                        line: 3,
                                        column: 53,
                                        fixed: true,
                                        source: 'glass/html/material/ConfirmDialog.ion'
                                    },
                                    end: {
                                        line: 3,
                                        column: 64,
                                        fixed: true,
                                        source: 'glass/html/material/ConfirmDialog.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref2'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'confirmText',
                                    loc: {
                                        start: {
                                            line: 3,
                                            column: 53,
                                            fixed: true,
                                            source: 'glass/html/material/ConfirmDialog.ion'
                                        },
                                        end: {
                                            line: 3,
                                            column: 64,
                                            fixed: true,
                                            source: 'glass/html/material/ConfirmDialog.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '4'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'cancelText',
                                loc: {
                                    start: {
                                        line: 3,
                                        column: 66,
                                        fixed: true,
                                        source: 'glass/html/material/ConfirmDialog.ion'
                                    },
                                    end: {
                                        line: 3,
                                        column: 76,
                                        fixed: true,
                                        source: 'glass/html/material/ConfirmDialog.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref2'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'cancelText',
                                    loc: {
                                        start: {
                                            line: 3,
                                            column: 66,
                                            fixed: true,
                                            source: 'glass/html/material/ConfirmDialog.ion'
                                        },
                                        end: {
                                            line: 3,
                                            column: 76,
                                            fixed: true,
                                            source: 'glass/html/material/ConfirmDialog.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '5'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'dialog',
                                loc: {
                                    start: {
                                        line: 4,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/ConfirmDialog.ion'
                                    },
                                    end: {
                                        line: 4,
                                        column: 14,
                                        fixed: true,
                                        source: 'glass/html/material/ConfirmDialog.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Dialog',
                                    loc: {
                                        start: {
                                            line: 4,
                                            column: 17,
                                            fixed: true,
                                            source: 'glass/html/material/ConfirmDialog.ion'
                                        },
                                        end: {
                                            line: 4,
                                            column: 23,
                                            fixed: true,
                                            source: 'glass/html/material/ConfirmDialog.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'class',
                                                    loc: {
                                                        start: {
                                                            line: 4,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'glass/html/material/ConfirmDialog.ion'
                                                        },
                                                        end: {
                                                            line: 4,
                                                            column: 30,
                                                            fixed: true,
                                                            source: 'glass/html/material/ConfirmDialog.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: 'layout vertical'
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    }],
                                loc: {
                                    start: {
                                        line: 4,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/html/material/ConfirmDialog.ion'
                                    },
                                    end: {
                                        line: 4,
                                        column: 50,
                                        fixed: true,
                                        source: 'glass/html/material/ConfirmDialog.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '6'
                },
                {
                    type: 'ReturnStatement',
                    argument: {
                        type: 'ObjectExpression',
                        objectType: {
                            type: 'Identifier',
                            name: 'dialog',
                            loc: {
                                start: {
                                    line: 5,
                                    column: 11,
                                    fixed: true,
                                    source: 'glass/html/material/ConfirmDialog.ion'
                                },
                                end: {
                                    line: 5,
                                    column: 17,
                                    fixed: true,
                                    source: 'glass/html/material/ConfirmDialog.ion'
                                }
                            }
                        },
                        properties: [{
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'frame',
                                    loc: {
                                        start: {
                                            line: 6,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/ConfirmDialog.ion'
                                        },
                                        end: {
                                            line: 6,
                                            column: 13,
                                            fixed: true,
                                            source: 'glass/html/material/ConfirmDialog.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'ObjectExpression',
                                    properties: [
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'style',
                                                loc: {
                                                    start: {
                                                        line: 7,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/ConfirmDialog.ion'
                                                    },
                                                    end: {
                                                        line: 7,
                                                        column: 17,
                                                        fixed: true,
                                                        source: 'glass/html/material/ConfirmDialog.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'ObjectExpression',
                                                properties: [
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'padding',
                                                            loc: {
                                                                start: {
                                                                    line: 8,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/ConfirmDialog.ion'
                                                                },
                                                                end: {
                                                                    line: 8,
                                                                    column: 23,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/ConfirmDialog.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Literal',
                                                            value: '0px'
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'width',
                                                            loc: {
                                                                start: {
                                                                    line: 9,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/ConfirmDialog.ion'
                                                                },
                                                                end: {
                                                                    line: 9,
                                                                    column: 21,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/ConfirmDialog.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Literal',
                                                            value: '340px'
                                                        },
                                                        kind: 'init',
                                                        order: '1'
                                                    },
                                                    {
                                                        type: 'IfStatement',
                                                        test: {
                                                            type: 'UnaryExpression',
                                                            operator: '?',
                                                            argument: {
                                                                type: 'Identifier',
                                                                name: 'style',
                                                                loc: {
                                                                    start: {
                                                                        line: 10,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/ConfirmDialog.ion'
                                                                    },
                                                                    end: {
                                                                        line: 10,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/ConfirmDialog.ion'
                                                                    }
                                                                }
                                                            }
                                                        },
                                                        consequent: {
                                                            type: 'BlockStatement',
                                                            body: [{
                                                                    type: 'ForInStatement',
                                                                    left: {
                                                                        type: 'VariableDeclaration',
                                                                        declarations: [
                                                                            {
                                                                                type: 'VariableDeclarator',
                                                                                id: {
                                                                                    type: 'Identifier',
                                                                                    name: 'key',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 11,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/ConfirmDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 11,
                                                                                            column: 27,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/ConfirmDialog.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                init: null
                                                                            },
                                                                            {
                                                                                type: 'VariableDeclarator',
                                                                                id: {
                                                                                    type: 'Identifier',
                                                                                    name: 'value',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 11,
                                                                                            column: 29,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/ConfirmDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 11,
                                                                                            column: 34,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/ConfirmDialog.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                init: null
                                                                            }
                                                                        ],
                                                                        kind: 'let'
                                                                    },
                                                                    right: {
                                                                        type: 'Identifier',
                                                                        name: 'style',
                                                                        loc: {
                                                                            start: {
                                                                                line: 11,
                                                                                column: 38,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/ConfirmDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 11,
                                                                                column: 43,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/ConfirmDialog.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    body: {
                                                                        type: 'BlockStatement',
                                                                        body: [{
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'key',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 12,
                                                                                            column: 25,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/ConfirmDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 12,
                                                                                            column: 28,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/ConfirmDialog.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Identifier',
                                                                                    name: 'value',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 12,
                                                                                            column: 31,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/ConfirmDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 12,
                                                                                            column: 36,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/ConfirmDialog.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                kind: 'init',
                                                                                computed: true,
                                                                                order: '0'
                                                                            }]
                                                                    },
                                                                    remove: null,
                                                                    order: '0'
                                                                }]
                                                        },
                                                        alternate: null,
                                                        order: '2'
                                                    }
                                                ]
                                            },
                                            kind: 'init',
                                            order: '0'
                                        },
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'ObjectExpression',
                                                objectType: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'Identifier',
                                                        name: 'Div',
                                                        loc: {
                                                            start: {
                                                                line: 13,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'glass/html/material/ConfirmDialog.ion'
                                                            },
                                                            end: {
                                                                line: 13,
                                                                column: 15,
                                                                fixed: true,
                                                                source: 'glass/html/material/ConfirmDialog.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [{
                                                            type: 'ObjectExpression',
                                                            properties: [{
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'class',
                                                                        loc: {
                                                                            start: {
                                                                                line: 13,
                                                                                column: 17,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/ConfirmDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 13,
                                                                                column: 22,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/ConfirmDialog.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Literal',
                                                                        value: 'content'
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                }]
                                                        }],
                                                    loc: {
                                                        start: {
                                                            line: 13,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/ConfirmDialog.ion'
                                                        },
                                                        end: {
                                                            line: 13,
                                                            column: 34,
                                                            fixed: true,
                                                            source: 'glass/html/material/ConfirmDialog.ion'
                                                        }
                                                    }
                                                },
                                                properties: [
                                                    {
                                                        type: 'IfStatement',
                                                        test: {
                                                            type: 'UnaryExpression',
                                                            operator: '?',
                                                            argument: {
                                                                type: 'Identifier',
                                                                name: 'title',
                                                                loc: {
                                                                    start: {
                                                                        line: 14,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/ConfirmDialog.ion'
                                                                    },
                                                                    end: {
                                                                        line: 14,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/ConfirmDialog.ion'
                                                                    }
                                                                }
                                                            }
                                                        },
                                                        consequent: {
                                                            type: 'BlockStatement',
                                                            body: [{
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'ObjectExpression',
                                                                        objectType: {
                                                                            type: 'CallExpression',
                                                                            callee: {
                                                                                type: 'Identifier',
                                                                                name: 'Div',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 15,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/ConfirmDialog.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 15,
                                                                                        column: 23,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/ConfirmDialog.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            arguments: [{
                                                                                    type: 'ObjectExpression',
                                                                                    properties: [{
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'class',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 15,
                                                                                                        column: 25,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/ConfirmDialog.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 15,
                                                                                                        column: 30,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/ConfirmDialog.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'Literal',
                                                                                                value: 'title'
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '0'
                                                                                        }]
                                                                                }],
                                                                            loc: {
                                                                                start: {
                                                                                    line: 15,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/ConfirmDialog.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 15,
                                                                                    column: 41,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/ConfirmDialog.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        properties: [{
                                                                                type: 'ExpressionStatement',
                                                                                expression: {
                                                                                    type: 'Identifier',
                                                                                    name: 'title',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 16,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/ConfirmDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 16,
                                                                                            column: 29,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/ConfirmDialog.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 16,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/ConfirmDialog.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 16,
                                                                                        column: 29,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/ConfirmDialog.ion'
                                                                                    }
                                                                                },
                                                                                order: '0'
                                                                            }]
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 15,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/ConfirmDialog.ion'
                                                                        },
                                                                        end: {
                                                                            line: 17,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/ConfirmDialog.ion'
                                                                        }
                                                                    },
                                                                    order: '0'
                                                                }]
                                                        },
                                                        alternate: null,
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'IfStatement',
                                                        test: {
                                                            type: 'UnaryExpression',
                                                            operator: '?',
                                                            argument: {
                                                                type: 'Identifier',
                                                                name: 'text',
                                                                loc: {
                                                                    start: {
                                                                        line: 17,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/ConfirmDialog.ion'
                                                                    },
                                                                    end: {
                                                                        line: 17,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/ConfirmDialog.ion'
                                                                    }
                                                                }
                                                            }
                                                        },
                                                        consequent: {
                                                            type: 'BlockStatement',
                                                            body: [{
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'ObjectExpression',
                                                                        objectType: {
                                                                            type: 'CallExpression',
                                                                            callee: {
                                                                                type: 'Identifier',
                                                                                name: 'Div',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 18,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/ConfirmDialog.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 18,
                                                                                        column: 23,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/ConfirmDialog.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            arguments: [{
                                                                                    type: 'ObjectExpression',
                                                                                    properties: [
                                                                                        {
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'style',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 18,
                                                                                                        column: 25,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/ConfirmDialog.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 18,
                                                                                                        column: 30,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/ConfirmDialog.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'Literal',
                                                                                                value: 'font-size:16px'
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '0'
                                                                                        },
                                                                                        {
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'class',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 18,
                                                                                                        column: 48,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/ConfirmDialog.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 18,
                                                                                                        column: 53,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/ConfirmDialog.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'Literal',
                                                                                                value: 'text secondary'
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '1'
                                                                                        }
                                                                                    ]
                                                                                }],
                                                                            loc: {
                                                                                start: {
                                                                                    line: 18,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/ConfirmDialog.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 18,
                                                                                    column: 72,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/ConfirmDialog.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        properties: [{
                                                                                type: 'ExpressionStatement',
                                                                                expression: {
                                                                                    type: 'Identifier',
                                                                                    name: 'text',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 19,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/ConfirmDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 19,
                                                                                            column: 28,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/ConfirmDialog.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 19,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/ConfirmDialog.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 19,
                                                                                        column: 28,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/ConfirmDialog.ion'
                                                                                    }
                                                                                },
                                                                                order: '0'
                                                                            }]
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 18,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/ConfirmDialog.ion'
                                                                        },
                                                                        end: {
                                                                            line: 20,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/ConfirmDialog.ion'
                                                                        }
                                                                    },
                                                                    order: '0'
                                                                }]
                                                        },
                                                        alternate: null,
                                                        order: '1'
                                                    }
                                                ]
                                            },
                                            loc: {
                                                start: {
                                                    line: 13,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/ConfirmDialog.ion'
                                                },
                                                end: {
                                                    line: 20,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/html/material/ConfirmDialog.ion'
                                                }
                                            },
                                            order: '1'
                                        },
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'ObjectExpression',
                                                objectType: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'Identifier',
                                                        name: 'Footer',
                                                        loc: {
                                                            start: {
                                                                line: 20,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'glass/html/material/ConfirmDialog.ion'
                                                            },
                                                            end: {
                                                                line: 20,
                                                                column: 18,
                                                                fixed: true,
                                                                source: 'glass/html/material/ConfirmDialog.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [{
                                                            type: 'ObjectExpression',
                                                            properties: [{
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'class',
                                                                        loc: {
                                                                            start: {
                                                                                line: 20,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/ConfirmDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 20,
                                                                                column: 25,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/ConfirmDialog.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Literal',
                                                                        value: 'layout horizontal reverse'
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                }]
                                                        }],
                                                    loc: {
                                                        start: {
                                                            line: 20,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/ConfirmDialog.ion'
                                                        },
                                                        end: {
                                                            line: 20,
                                                            column: 55,
                                                            fixed: true,
                                                            source: 'glass/html/material/ConfirmDialog.ion'
                                                        }
                                                    }
                                                },
                                                properties: [
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'style',
                                                            loc: {
                                                                start: {
                                                                    line: 21,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/ConfirmDialog.ion'
                                                                },
                                                                end: {
                                                                    line: 21,
                                                                    column: 21,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/ConfirmDialog.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'ObjectExpression',
                                                            properties: [{
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'margin',
                                                                        loc: {
                                                                            start: {
                                                                                line: 22,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/ConfirmDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 22,
                                                                                column: 26,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/ConfirmDialog.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Literal',
                                                                        value: '8px 4px'
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                }]
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'ObjectExpression',
                                                            objectType: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Identifier',
                                                                    name: 'PaperButton',
                                                                    loc: {
                                                                        start: {
                                                                            line: 23,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/ConfirmDialog.ion'
                                                                        },
                                                                        end: {
                                                                            line: 23,
                                                                            column: 27,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/ConfirmDialog.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [],
                                                                loc: {
                                                                    start: {
                                                                        line: 23,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/ConfirmDialog.ion'
                                                                    },
                                                                    end: {
                                                                        line: 23,
                                                                        column: 29,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/ConfirmDialog.ion'
                                                                    }
                                                                }
                                                            },
                                                            properties: [
                                                                {
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'Function',
                                                                        context: true,
                                                                        value: function (_context) {
                                                                            return function click() {
                                                                                var dialog = _context.get('dialog'), callback = _context.get('callback');
                                                                                dialog.open = false;
                                                                                callback(true);
                                                                            };
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 24,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/ConfirmDialog.ion'
                                                                        },
                                                                        end: {
                                                                            line: 27,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/ConfirmDialog.ion'
                                                                        }
                                                                    },
                                                                    order: '0'
                                                                },
                                                                {
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'ConditionalExpression',
                                                                        test: {
                                                                            type: 'BinaryExpression',
                                                                            operator: '!=',
                                                                            left: {
                                                                                type: 'Identifier',
                                                                                name: 'confirmText',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 27,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/ConfirmDialog.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 27,
                                                                                        column: 31,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/ConfirmDialog.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            right: {
                                                                                type: 'Literal',
                                                                                value: null
                                                                            }
                                                                        },
                                                                        consequent: {
                                                                            type: 'Identifier',
                                                                            name: 'confirmText',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 27,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/ConfirmDialog.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 27,
                                                                                    column: 31,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/ConfirmDialog.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        alternate: {
                                                                            type: 'Literal',
                                                                            value: 'OK'
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 27,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/ConfirmDialog.ion'
                                                                        },
                                                                        end: {
                                                                            line: 27,
                                                                            column: 38,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/ConfirmDialog.ion'
                                                                        }
                                                                    },
                                                                    order: '1'
                                                                }
                                                            ]
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 23,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/ConfirmDialog.ion'
                                                            },
                                                            end: {
                                                                line: 28,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'glass/html/material/ConfirmDialog.ion'
                                                            }
                                                        },
                                                        order: '1'
                                                    },
                                                    {
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'ObjectExpression',
                                                            objectType: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Identifier',
                                                                    name: 'PaperButton',
                                                                    loc: {
                                                                        start: {
                                                                            line: 28,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/ConfirmDialog.ion'
                                                                        },
                                                                        end: {
                                                                            line: 28,
                                                                            column: 27,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/ConfirmDialog.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [],
                                                                loc: {
                                                                    start: {
                                                                        line: 28,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/ConfirmDialog.ion'
                                                                    },
                                                                    end: {
                                                                        line: 28,
                                                                        column: 29,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/ConfirmDialog.ion'
                                                                    }
                                                                }
                                                            },
                                                            properties: [
                                                                {
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'Function',
                                                                        context: true,
                                                                        value: function (_context2) {
                                                                            return function click() {
                                                                                var dialog = _context2.get('dialog'), callback = _context2.get('callback');
                                                                                dialog.open = false;
                                                                                callback(false);
                                                                            };
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 29,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/ConfirmDialog.ion'
                                                                        },
                                                                        end: {
                                                                            line: 32,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/ConfirmDialog.ion'
                                                                        }
                                                                    },
                                                                    order: '0'
                                                                },
                                                                {
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'ConditionalExpression',
                                                                        test: {
                                                                            type: 'BinaryExpression',
                                                                            operator: '!=',
                                                                            left: {
                                                                                type: 'Identifier',
                                                                                name: 'cancelText',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 32,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/ConfirmDialog.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 32,
                                                                                        column: 30,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/ConfirmDialog.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            right: {
                                                                                type: 'Literal',
                                                                                value: null
                                                                            }
                                                                        },
                                                                        consequent: {
                                                                            type: 'Identifier',
                                                                            name: 'cancelText',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 32,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/ConfirmDialog.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 32,
                                                                                    column: 30,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/ConfirmDialog.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        alternate: {
                                                                            type: 'Literal',
                                                                            value: 'Cancel'
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 32,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/ConfirmDialog.ion'
                                                                        },
                                                                        end: {
                                                                            line: 32,
                                                                            column: 41,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/ConfirmDialog.ion'
                                                                        }
                                                                    },
                                                                    order: '1'
                                                                }
                                                            ]
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 28,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/ConfirmDialog.ion'
                                                            },
                                                            end: {
                                                                line: 34,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'glass/html/material/ConfirmDialog.ion'
                                                            }
                                                        },
                                                        order: '2'
                                                    }
                                                ]
                                            },
                                            loc: {
                                                start: {
                                                    line: 20,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/ConfirmDialog.ion'
                                                },
                                                end: {
                                                    line: 34,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/html/material/ConfirmDialog.ion'
                                                }
                                            },
                                            order: '2'
                                        }
                                    ]
                                },
                                kind: 'init',
                                order: '0'
                            }]
                    },
                    order: '7'
                }
            ],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'prompt',
                loc: {
                    start: {
                        line: 3,
                        column: 15,
                        fixed: true,
                        source: 'glass/html/material/ConfirmDialog.ion'
                    },
                    end: {
                        line: 3,
                        column: 21,
                        fixed: true,
                        source: 'glass/html/material/ConfirmDialog.ion'
                    }
                }
            }
        }, {
            this: this,
            _ref2: _ref2,
            _ref: _ref,
            Dialog: Dialog,
            Button: Button,
            prompt: prompt
        }, null);
    });
module.exports = exports = function (args) {
    Dialog.show(prompt, args);
};
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/ConfirmDialog',_glass_html_material_ConfirmDialog_);
    else
      _glass_html_material_ConfirmDialog_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_ConfirmDialog_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_DataTable2_BooleanColumn_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('../../../data'), DefaultColumn = require('./DefaultColumn'), _ref2;
var Schema = _ref.Schema;
_ref2 = require('../../');
var style = _ref2.style;
var _ref3 = style.sheets;
_ref3[module.id] = '.BooleanColumnCell {\n    color: green;\n    display: flex;\n    justify-content: center;\n}';
_ref3;
module.exports = exports = ion.template(function PrimaryColumn(property) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'PrimaryColumn',
            loc: {
                start: {
                    line: 14,
                    column: 16,
                    fixed: true,
                    source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                },
                end: {
                    line: 14,
                    column: 29,
                    fixed: true,
                    source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                }
            }
        },
        body: [{
                type: 'ReturnStatement',
                argument: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'CallExpression',
                        callee: {
                            type: 'Identifier',
                            name: 'DefaultColumn',
                            loc: {
                                start: {
                                    line: 15,
                                    column: 11,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                },
                                end: {
                                    line: 15,
                                    column: 24,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                }
                            }
                        },
                        arguments: [{
                                type: 'Identifier',
                                name: 'property',
                                loc: {
                                    start: {
                                        line: 15,
                                        column: 25,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                    },
                                    end: {
                                        line: 15,
                                        column: 33,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                    }
                                }
                            }],
                        loc: {
                            start: {
                                line: 15,
                                column: 11,
                                fixed: true,
                                source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                            },
                            end: {
                                line: 15,
                                column: 34,
                                fixed: true,
                                source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                            }
                        }
                    },
                    properties: [
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'defaultWidth',
                                loc: {
                                    start: {
                                        line: 16,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                    },
                                    end: {
                                        line: 16,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Literal',
                                value: 80
                            },
                            kind: 'init',
                            order: '0'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'createBodyCell',
                                loc: {
                                    start: {
                                        line: 17,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                    },
                                    end: {
                                        line: 17,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_ps) {
                                    return ion.template(function (row) {
                                        return ion.createRuntime({
                                            type: 'Template',
                                            id: null,
                                            body: [
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'getDisplayValue',
                                                                loc: {
                                                                    start: {
                                                                        line: 18,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 18,
                                                                        column: 31,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'MemberExpression',
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'ion'
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'bind'
                                                                    }
                                                                },
                                                                arguments: [
                                                                    {
                                                                        type: 'Function',
                                                                        context: true,
                                                                        value: function (_context) {
                                                                            return function (record) {
                                                                                var Schema = _context.get('Schema'), property = _context.get('property');
                                                                                return Schema.get(record, property);
                                                                            };
                                                                        }
                                                                    },
                                                                    { type: 'ThisExpression' }
                                                                ]
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'displayValue',
                                                                loc: {
                                                                    start: {
                                                                        line: 19,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 19,
                                                                        column: 28,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Identifier',
                                                                    name: 'getDisplayValue',
                                                                    loc: {
                                                                        start: {
                                                                            line: 19,
                                                                            column: 31,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 19,
                                                                            column: 46,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'row',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 19,
                                                                                    column: 52,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 19,
                                                                                    column: 55,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'record',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 19,
                                                                                    column: 56,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 19,
                                                                                    column: 62,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 19,
                                                                                column: 52,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 19,
                                                                                column: 62,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                            }
                                                                        },
                                                                        deep: true
                                                                    }],
                                                                loc: {
                                                                    start: {
                                                                        line: 19,
                                                                        column: 31,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 19,
                                                                        column: 63,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '1'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'toggle',
                                                                loc: {
                                                                    start: {
                                                                        line: 20,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 20,
                                                                        column: 22,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'MemberExpression',
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'ion'
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'bind'
                                                                    }
                                                                },
                                                                arguments: [
                                                                    {
                                                                        type: 'Function',
                                                                        context: true,
                                                                        value: function (_context2) {
                                                                            return function () {
                                                                                var Schema = _context2.get('Schema'), row = _context2.get('row'), property = _context2.get('property');
                                                                                var value = !Schema.get(row.record, property);
                                                                                global.model.ops.begin();
                                                                                Schema.set(row.record, property, value);
                                                                            };
                                                                        }
                                                                    },
                                                                    { type: 'ThisExpression' }
                                                                ]
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '2'
                                                },
                                                {
                                                    type: 'ReturnStatement',
                                                    argument: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'Span',
                                                                loc: {
                                                                    start: {
                                                                        line: 24,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 24,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [{
                                                                    type: 'ObjectExpression',
                                                                    properties: [{
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'class',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 24,
                                                                                        column: 25,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 24,
                                                                                        column: 30,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'BooleanColumnCell'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        }]
                                                                }],
                                                            loc: {
                                                                start: {
                                                                    line: 24,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                },
                                                                end: {
                                                                    line: 24,
                                                                    column: 52,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [
                                                            {
                                                                type: 'IfStatement',
                                                                test: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'row',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 25,
                                                                                    column: 19,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 25,
                                                                                    column: 22,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'dataTableModel',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 25,
                                                                                    column: 23,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 25,
                                                                                    column: 37,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 25,
                                                                                column: 19,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 25,
                                                                                column: 37,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'editable',
                                                                        loc: {
                                                                            start: {
                                                                                line: 25,
                                                                                column: 38,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 25,
                                                                                column: 46,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 25,
                                                                            column: 19,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 25,
                                                                            column: 46,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                consequent: {
                                                                    type: 'BlockStatement',
                                                                    body: [
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'style',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 26,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 26,
                                                                                        column: 25,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'ObjectExpression',
                                                                                properties: [{
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'cursor',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 27,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 27,
                                                                                                    column: 30,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 'pointer'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'Function',
                                                                                context: true,
                                                                                value: function (_context3) {
                                                                                    return function mousedown(e) {
                                                                                        var toggle = _context3.get('toggle');
                                                                                        if (e.button === 0) {
                                                                                            toggle();
                                                                                            e.preventDefault();
                                                                                            e.stopPropagation();
                                                                                        }
                                                                                    };
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 28,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 33,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                                }
                                                                            },
                                                                            order: '1'
                                                                        },
                                                                        {
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'Function',
                                                                                context: false,
                                                                                value: function mouseup(e) {
                                                                                    if (e.button === 0) {
                                                                                        e.preventDefault();
                                                                                        e.stopPropagation();
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 33,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 37,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                                }
                                                                            },
                                                                            order: '2'
                                                                        },
                                                                        {
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'Function',
                                                                                context: true,
                                                                                value: function (_context4) {
                                                                                    return function keypress(e) {
                                                                                        var toggle = _context4.get('toggle');
                                                                                        if (e.keyCode === 32) {
                                                                                            toggle();
                                                                                            e.preventDefault();
                                                                                        }
                                                                                    };
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 37,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 41,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                                }
                                                                            },
                                                                            order: '3'
                                                                        }
                                                                    ]
                                                                },
                                                                alternate: null,
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'IfStatement',
                                                                test: {
                                                                    type: 'Identifier',
                                                                    name: 'displayValue',
                                                                    loc: {
                                                                        start: {
                                                                            line: 41,
                                                                            column: 19,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 41,
                                                                            column: 31,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                consequent: {
                                                                    type: 'BlockStatement',
                                                                    body: [{
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'ObjectExpression',
                                                                                objectType: {
                                                                                    type: 'CallExpression',
                                                                                    callee: {
                                                                                        type: 'Identifier',
                                                                                        name: 'IronIcon',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 42,
                                                                                                column: 20,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 42,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    arguments: [],
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 42,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 42,
                                                                                            column: 30,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                properties: [{
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'icon',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 43,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 43,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 'done'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 42,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 45,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                alternate: null,
                                                                order: '1'
                                                            }
                                                        ]
                                                    },
                                                    order: '3'
                                                }
                                            ],
                                            bound: false,
                                            name: {
                                                type: 'Identifier',
                                                name: 'createBodyCell',
                                                loc: {
                                                    start: {
                                                        line: 17,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                    },
                                                    end: {
                                                        line: 17,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/BooleanColumn.ion'
                                                    }
                                                }
                                            },
                                            scope: {
                                                type: 'Identifier',
                                                name: '_ps'
                                            }
                                        }, {
                                            this: this,
                                            ion: ion,
                                            row: row,
                                            _ps: _ps,
                                            property: property,
                                            _ref: _ref,
                                            DefaultColumn: DefaultColumn,
                                            _ref2: _ref2,
                                            Schema: Schema,
                                            style: style,
                                            _ref3: _ref3
                                        }, _ps);
                                    });
                                }
                            },
                            kind: 'init',
                            order: '1'
                        }
                    ]
                },
                order: '0'
            }],
        bound: false
    }, {
        this: this,
        ion: ion,
        property: property,
        _ref: _ref,
        DefaultColumn: DefaultColumn,
        _ref2: _ref2,
        Schema: Schema,
        style: style,
        _ref3: _ref3
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/DataTable2/BooleanColumn',_glass_html_material_DataTable2_BooleanColumn_);
    else
      _glass_html_material_DataTable2_BooleanColumn_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_DataTable2_BooleanColumn_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_DataTable2_ColorColumn_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('../../../data'), DefaultColumn = require('./DefaultColumn'), _ref2;
var Schema = _ref.Schema;
_ref2 = require('../../');
var style = _ref2.style;
module.exports = exports = ion.template(function PrimaryColumn(property) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'PrimaryColumn',
            loc: {
                start: {
                    line: 6,
                    column: 16,
                    fixed: true,
                    source: 'glass/html/material/DataTable2/ColorColumn.ion'
                },
                end: {
                    line: 6,
                    column: 29,
                    fixed: true,
                    source: 'glass/html/material/DataTable2/ColorColumn.ion'
                }
            }
        },
        body: [{
                type: 'ReturnStatement',
                argument: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'CallExpression',
                        callee: {
                            type: 'Identifier',
                            name: 'DefaultColumn',
                            loc: {
                                start: {
                                    line: 7,
                                    column: 11,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                },
                                end: {
                                    line: 7,
                                    column: 24,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                }
                            }
                        },
                        arguments: [{
                                type: 'Identifier',
                                name: 'property',
                                loc: {
                                    start: {
                                        line: 7,
                                        column: 25,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                    },
                                    end: {
                                        line: 7,
                                        column: 33,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                    }
                                }
                            }],
                        loc: {
                            start: {
                                line: 7,
                                column: 11,
                                fixed: true,
                                source: 'glass/html/material/DataTable2/ColorColumn.ion'
                            },
                            end: {
                                line: 7,
                                column: 34,
                                fixed: true,
                                source: 'glass/html/material/DataTable2/ColorColumn.ion'
                            }
                        }
                    },
                    properties: [
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'defaultWidth',
                                loc: {
                                    start: {
                                        line: 8,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                    },
                                    end: {
                                        line: 8,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Literal',
                                value: 80
                            },
                            kind: 'init',
                            order: '0'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'createCssRules',
                                loc: {
                                    start: {
                                        line: 9,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                    },
                                    end: {
                                        line: 9,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: false,
                                value: function (dataTableModel) {
                                    return { '': 'justify-content: center' };
                                }
                            },
                            kind: 'init',
                            order: '1'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'createBodyCell',
                                loc: {
                                    start: {
                                        line: 13,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                    },
                                    end: {
                                        line: 13,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_ps) {
                                    return ion.template(function (row) {
                                        return ion.createRuntime({
                                            type: 'Template',
                                            id: null,
                                            body: [
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'getValue',
                                                                loc: {
                                                                    start: {
                                                                        line: 14,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 14,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'MemberExpression',
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'ion'
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'bind'
                                                                    }
                                                                },
                                                                arguments: [
                                                                    {
                                                                        type: 'Function',
                                                                        context: true,
                                                                        value: function (_context) {
                                                                            return function (record) {
                                                                                var Schema = _context.get('Schema'), property = _context.get('property');
                                                                                return Schema.get(record, property);
                                                                            };
                                                                        }
                                                                    },
                                                                    { type: 'ThisExpression' }
                                                                ]
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'value',
                                                                loc: {
                                                                    start: {
                                                                        line: 15,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 15,
                                                                        column: 21,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Identifier',
                                                                    name: 'getValue',
                                                                    loc: {
                                                                        start: {
                                                                            line: 15,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 15,
                                                                            column: 32,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'row',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 15,
                                                                                    column: 38,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 15,
                                                                                    column: 41,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'record',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 15,
                                                                                    column: 42,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 15,
                                                                                    column: 48,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 15,
                                                                                column: 38,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 15,
                                                                                column: 48,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                            }
                                                                        },
                                                                        deep: true
                                                                    }],
                                                                loc: {
                                                                    start: {
                                                                        line: 15,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 15,
                                                                        column: 49,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '1'
                                                },
                                                {
                                                    type: 'ReturnStatement',
                                                    argument: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'Span',
                                                                loc: {
                                                                    start: {
                                                                        line: 16,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 16,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [],
                                                            loc: {
                                                                start: {
                                                                    line: 16,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                },
                                                                end: {
                                                                    line: 16,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [{
                                                                type: 'IfStatement',
                                                                test: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'row',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 17,
                                                                                    column: 19,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 17,
                                                                                    column: 22,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'dataTableModel',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 17,
                                                                                    column: 23,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 17,
                                                                                    column: 37,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 17,
                                                                                column: 19,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 17,
                                                                                column: 37,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'editable',
                                                                        loc: {
                                                                            start: {
                                                                                line: 17,
                                                                                column: 38,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 17,
                                                                                column: 46,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 17,
                                                                            column: 19,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 17,
                                                                            column: 46,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                consequent: {
                                                                    type: 'BlockStatement',
                                                                    body: [
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'style',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 18,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 18,
                                                                                        column: 25,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'ObjectExpression',
                                                                                properties: [{
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'cursor',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 19,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 19,
                                                                                                    column: 30,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 'pointer'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'ObjectExpression',
                                                                                objectType: {
                                                                                    type: 'CallExpression',
                                                                                    callee: {
                                                                                        type: 'Identifier',
                                                                                        name: 'PaperSwatchPicker',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 20,
                                                                                                column: 20,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 20,
                                                                                                column: 37,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    arguments: [],
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 20,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 20,
                                                                                            column: 39,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                properties: [
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'color',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 21,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 21,
                                                                                                    column: 29,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'BinaryExpression',
                                                                                            operator: '+',
                                                                                            left: {
                                                                                                type: 'Literal',
                                                                                                value: '#'
                                                                                            },
                                                                                            right: {
                                                                                                type: 'ConditionalExpression',
                                                                                                test: {
                                                                                                    type: 'BinaryExpression',
                                                                                                    operator: '!=',
                                                                                                    left: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'value',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 21,
                                                                                                                column: 38,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 21,
                                                                                                                column: 43,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    right: {
                                                                                                        type: 'Literal',
                                                                                                        value: null
                                                                                                    }
                                                                                                },
                                                                                                consequent: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'value',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 21,
                                                                                                            column: 38,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 21,
                                                                                                            column: 43,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                alternate: {
                                                                                                    type: 'Literal',
                                                                                                    value: '000000'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'CallExpression',
                                                                                            callee: {
                                                                                                type: 'MemberExpression',
                                                                                                object: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'Object'
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'assign'
                                                                                                }
                                                                                            },
                                                                                            arguments: [
                                                                                                {
                                                                                                    type: 'Function',
                                                                                                    context: true,
                                                                                                    value: function (_context2) {
                                                                                                        return function (e) {
                                                                                                            var row = _context2.get('row'), Schema = _context2.get('Schema'), property = _context2.get('property');
                                                                                                            row.dataTableModel.beginOp();
                                                                                                            Schema.set(row.record, property, this.color.substring(1).toUpperCase());
                                                                                                        };
                                                                                                    }
                                                                                                },
                                                                                                {
                                                                                                    type: 'ObjectExpression',
                                                                                                    properties: [{
                                                                                                            type: 'Property',
                                                                                                            key: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'id'
                                                                                                            },
                                                                                                            value: {
                                                                                                                type: 'Literal',
                                                                                                                value: 'color-picker-selected'
                                                                                                            },
                                                                                                            order: '0'
                                                                                                        }]
                                                                                                }
                                                                                            ]
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 22,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 25,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '1'
                                                                                    }
                                                                                ]
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 20,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 25,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                                }
                                                                            },
                                                                            order: '1'
                                                                        }
                                                                    ]
                                                                },
                                                                alternate: {
                                                                    type: 'BlockStatement',
                                                                    body: [{
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'ObjectExpression',
                                                                                objectType: {
                                                                                    type: 'CallExpression',
                                                                                    callee: {
                                                                                        type: 'Identifier',
                                                                                        name: 'Div',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 26,
                                                                                                column: 20,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 26,
                                                                                                column: 23,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    arguments: [],
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 26,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 26,
                                                                                            column: 25,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                properties: [{
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'style',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 27,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 27,
                                                                                                    column: 29,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'ObjectExpression',
                                                                                            properties: [
                                                                                                {
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'width',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 28,
                                                                                                                column: 28,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 28,
                                                                                                                column: 33,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'Literal',
                                                                                                        value: '20px'
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '0'
                                                                                                },
                                                                                                {
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'height',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 29,
                                                                                                                column: 28,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 29,
                                                                                                                column: 34,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'Literal',
                                                                                                        value: '20px'
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '1'
                                                                                                },
                                                                                                {
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'background',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 30,
                                                                                                                column: 28,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 30,
                                                                                                                column: 38,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'BinaryExpression',
                                                                                                        operator: '+',
                                                                                                        left: {
                                                                                                            type: 'Literal',
                                                                                                            value: '#'
                                                                                                        },
                                                                                                        right: {
                                                                                                            type: 'ConditionalExpression',
                                                                                                            test: {
                                                                                                                type: 'BinaryExpression',
                                                                                                                operator: '!=',
                                                                                                                left: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'value',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 30,
                                                                                                                            column: 47,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 30,
                                                                                                                            column: 52,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                right: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: null
                                                                                                                }
                                                                                                            },
                                                                                                            consequent: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'value',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 30,
                                                                                                                        column: 47,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 30,
                                                                                                                        column: 52,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            alternate: {
                                                                                                                type: 'Literal',
                                                                                                                value: '000000'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '2'
                                                                                                }
                                                                                            ]
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 26,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 32,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    order: '2'
                                                }
                                            ],
                                            bound: false,
                                            name: {
                                                type: 'Identifier',
                                                name: 'createBodyCell',
                                                loc: {
                                                    start: {
                                                        line: 13,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                    },
                                                    end: {
                                                        line: 13,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/ColorColumn.ion'
                                                    }
                                                }
                                            },
                                            scope: {
                                                type: 'Identifier',
                                                name: '_ps'
                                            }
                                        }, {
                                            this: this,
                                            ion: ion,
                                            row: row,
                                            _ps: _ps,
                                            property: property,
                                            _ref: _ref,
                                            DefaultColumn: DefaultColumn,
                                            _ref2: _ref2,
                                            Schema: Schema,
                                            style: style
                                        }, _ps);
                                    });
                                }
                            },
                            kind: 'init',
                            order: '2'
                        }
                    ]
                },
                order: '0'
            }],
        bound: false
    }, {
        this: this,
        ion: ion,
        property: property,
        _ref: _ref,
        DefaultColumn: DefaultColumn,
        _ref2: _ref2,
        Schema: Schema,
        style: style
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/DataTable2/ColorColumn',_glass_html_material_DataTable2_ColorColumn_);
    else
      _glass_html_material_DataTable2_ColorColumn_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_DataTable2_ColorColumn_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_DataTable2_Column_ = function(module,exports,require){'use strict';
var ion = require('ion');
module.exports = exports = ion.template(function Column() {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'Column',
            loc: {
                start: {
                    line: 2,
                    column: 16,
                    fixed: true,
                    source: 'glass/html/material/DataTable2/Column.ion'
                },
                end: {
                    line: 2,
                    column: 22,
                    fixed: true,
                    source: 'glass/html/material/DataTable2/Column.ion'
                }
            }
        },
        body: [{
                type: 'ReturnStatement',
                argument: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'ObjectExpression',
                        properties: []
                    },
                    properties: [
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'defaultWidth',
                                loc: {
                                    start: {
                                        line: 4,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/Column.ion'
                                    },
                                    end: {
                                        line: 4,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/Column.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Literal',
                                value: 100
                            },
                            kind: 'init',
                            order: '0'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'getMimeValueFromRow',
                                loc: {
                                    start: {
                                        line: 5,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/Column.ion'
                                    },
                                    end: {
                                        line: 5,
                                        column: 27,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/Column.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: false,
                                value: function (row, mimeType) {
                                }
                            },
                            kind: 'init',
                            order: '1'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'createCssRules',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/Column.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/Column.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: false,
                                value: function () {
                                }
                            },
                            kind: 'init',
                            order: '2'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'createHeaderCell',
                                loc: {
                                    start: {
                                        line: 7,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/Column.ion'
                                    },
                                    end: {
                                        line: 7,
                                        column: 24,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/Column.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_ps) {
                                    return ion.template(function () {
                                        return ion.createRuntime({
                                            type: 'Template',
                                            id: null,
                                            body: [],
                                            bound: false,
                                            name: {
                                                type: 'Identifier',
                                                name: 'createHeaderCell',
                                                loc: {
                                                    start: {
                                                        line: 7,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/Column.ion'
                                                    },
                                                    end: {
                                                        line: 7,
                                                        column: 24,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/Column.ion'
                                                    }
                                                }
                                            },
                                            scope: {
                                                type: 'Identifier',
                                                name: '_ps'
                                            }
                                        }, {
                                            this: this,
                                            _ps: _ps
                                        }, _ps);
                                    });
                                }
                            },
                            kind: 'init',
                            order: '3'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'createBodyCell',
                                loc: {
                                    start: {
                                        line: 8,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/Column.ion'
                                    },
                                    end: {
                                        line: 8,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/Column.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_ps2) {
                                    return ion.template(function () {
                                        return ion.createRuntime({
                                            type: 'Template',
                                            id: null,
                                            body: [],
                                            bound: false,
                                            name: {
                                                type: 'Identifier',
                                                name: 'createBodyCell',
                                                loc: {
                                                    start: {
                                                        line: 8,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/Column.ion'
                                                    },
                                                    end: {
                                                        line: 8,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/Column.ion'
                                                    }
                                                }
                                            },
                                            scope: {
                                                type: 'Identifier',
                                                name: '_ps2'
                                            }
                                        }, {
                                            this: this,
                                            _ps2: _ps2
                                        }, _ps2);
                                    });
                                }
                            },
                            kind: 'init',
                            order: '4'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'createFooterCell',
                                loc: {
                                    start: {
                                        line: 9,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/Column.ion'
                                    },
                                    end: {
                                        line: 9,
                                        column: 24,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/Column.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_ps3) {
                                    return ion.template(function () {
                                        return ion.createRuntime({
                                            type: 'Template',
                                            id: null,
                                            body: [],
                                            bound: false,
                                            name: {
                                                type: 'Identifier',
                                                name: 'createFooterCell',
                                                loc: {
                                                    start: {
                                                        line: 9,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/Column.ion'
                                                    },
                                                    end: {
                                                        line: 9,
                                                        column: 24,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/Column.ion'
                                                    }
                                                }
                                            },
                                            scope: {
                                                type: 'Identifier',
                                                name: '_ps3'
                                            }
                                        }, {
                                            this: this,
                                            _ps3: _ps3
                                        }, _ps3);
                                    });
                                }
                            },
                            kind: 'init',
                            order: '5'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'createUnderlay',
                                loc: {
                                    start: {
                                        line: 10,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/Column.ion'
                                    },
                                    end: {
                                        line: 10,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/Column.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_ps4) {
                                    return ion.template(function Column_createUnderlay() {
                                        return ion.createRuntime({
                                            type: 'Template',
                                            id: {
                                                type: 'Identifier',
                                                name: 'Column_createUnderlay',
                                                loc: {
                                                    start: {
                                                        line: 10,
                                                        column: 33,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/Column.ion'
                                                    },
                                                    end: {
                                                        line: 10,
                                                        column: 54,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/Column.ion'
                                                    }
                                                }
                                            },
                                            body: [],
                                            bound: false,
                                            name: {
                                                type: 'Identifier',
                                                name: 'createUnderlay',
                                                loc: {
                                                    start: {
                                                        line: 10,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/Column.ion'
                                                    },
                                                    end: {
                                                        line: 10,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/Column.ion'
                                                    }
                                                }
                                            },
                                            scope: {
                                                type: 'Identifier',
                                                name: '_ps4'
                                            }
                                        }, {
                                            this: this,
                                            _ps4: _ps4
                                        }, _ps4);
                                    });
                                }
                            },
                            kind: 'init',
                            order: '6'
                        }
                    ]
                },
                order: '0'
            }],
        bound: false
    }, {
        this: this,
        ion: ion
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/DataTable2/Column',_glass_html_material_DataTable2_Column_);
    else
      _glass_html_material_DataTable2_Column_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_DataTable2_Column_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_DataTable2_ColumnChooser_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('../../../data');
var Schema = _ref.Schema;
module.exports = exports = ion.template(function ColumnChooser(_ref2) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'ColumnChooser',
            loc: {
                start: {
                    line: 4,
                    column: 16,
                    fixed: true,
                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                },
                end: {
                    line: 4,
                    column: 29,
                    fixed: true,
                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                }
            }
        },
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'column',
                            loc: {
                                start: {
                                    line: 4,
                                    column: 31,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                },
                                end: {
                                    line: 4,
                                    column: 37,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref2'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'column',
                                loc: {
                                    start: {
                                        line: 4,
                                        column: 31,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                    },
                                    end: {
                                        line: 4,
                                        column: 37,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'cell',
                            loc: {
                                start: {
                                    line: 4,
                                    column: 39,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                },
                                end: {
                                    line: 4,
                                    column: 43,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref2'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'cell',
                                loc: {
                                    start: {
                                        line: 4,
                                        column: 39,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                    },
                                    end: {
                                        line: 4,
                                        column: 43,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: '_ref3'
                        },
                        init: {
                            type: 'Identifier',
                            name: 'column',
                            loc: {
                                start: {
                                    line: 5,
                                    column: 27,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                },
                                end: {
                                    line: 5,
                                    column: 33,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'dataTableModel',
                            loc: {
                                start: {
                                    line: 5,
                                    column: 9,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                },
                                end: {
                                    line: 5,
                                    column: 23,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'dataTableModel',
                                loc: {
                                    start: {
                                        line: 5,
                                        column: 9,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                    },
                                    end: {
                                        line: 5,
                                        column: 23,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '3'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: '_ref4'
                        },
                        init: {
                            type: 'MemberExpression',
                            computed: false,
                            object: {
                                type: 'Identifier',
                                name: 'dataTableModel',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 31,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 45,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'columnSource',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 46,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 58,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 6,
                                    column: 31,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 58,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '4'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'visibleColumnNames',
                            loc: {
                                start: {
                                    line: 6,
                                    column: 9,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 27,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref4'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'visibleColumnNames',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 9,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 27,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '5'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'selectedColumns',
                            loc: {
                                start: {
                                    line: 7,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                },
                                end: {
                                    line: 7,
                                    column: 23,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            computed: false,
                            object: {
                                type: 'Identifier',
                                name: 'dataTableModel',
                                loc: {
                                    start: {
                                        line: 7,
                                        column: 26,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                    },
                                    end: {
                                        line: 7,
                                        column: 40,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'selectedColumns',
                                loc: {
                                    start: {
                                        line: 7,
                                        column: 41,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                    },
                                    end: {
                                        line: 7,
                                        column: 56,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 7,
                                    column: 26,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                },
                                end: {
                                    line: 7,
                                    column: 56,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '6'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'properties',
                            loc: {
                                start: {
                                    line: 8,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                },
                                end: {
                                    line: 8,
                                    column: 18,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'dataTableModel',
                                    loc: {
                                        start: {
                                            line: 8,
                                            column: 21,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                        },
                                        end: {
                                            line: 8,
                                            column: 35,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'getAvailableColumnProperties',
                                    loc: {
                                        start: {
                                            line: 8,
                                            column: 36,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                        },
                                        end: {
                                            line: 8,
                                            column: 64,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 8,
                                        column: 21,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                    },
                                    end: {
                                        line: 8,
                                        column: 64,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                    }
                                }
                            },
                            arguments: [],
                            loc: {
                                start: {
                                    line: 8,
                                    column: 21,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                },
                                end: {
                                    line: 8,
                                    column: 66,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '7'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'chooser',
                            loc: {
                                start: {
                                    line: 9,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                },
                                end: {
                                    line: 9,
                                    column: 15,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'PaperMenuButton',
                                loc: {
                                    start: {
                                        line: 9,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                    },
                                    end: {
                                        line: 9,
                                        column: 33,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ObjectExpression',
                                    properties: [{
                                            type: 'Property',
                                            key: {
                                                type: 'Literal',
                                                value: 'ignore-select'
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: false
                                            },
                                            kind: 'init',
                                            order: '0'
                                        }]
                                }],
                            loc: {
                                start: {
                                    line: 9,
                                    column: 18,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                },
                                end: {
                                    line: 9,
                                    column: 58,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '8'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'Identifier',
                        name: 'chooser',
                        loc: {
                            start: {
                                line: 10,
                                column: 11,
                                fixed: true,
                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                            },
                            end: {
                                line: 10,
                                column: 18,
                                fixed: true,
                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                            }
                        }
                    },
                    properties: [
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'Function',
                                context: false,
                                value: function mousedown(e) {
                                    e.stopPropagation();
                                }
                            },
                            loc: {
                                start: {
                                    line: 11,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                },
                                end: {
                                    line: 13,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                }
                            },
                            order: '0'
                        },
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'Function',
                                context: false,
                                value: function mouseup(e) {
                                    e.stopPropagation();
                                }
                            },
                            loc: {
                                start: {
                                    line: 13,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                },
                                end: {
                                    line: 15,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                }
                            },
                            order: '1'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'verticalOffset',
                                loc: {
                                    start: {
                                        line: 15,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                    },
                                    end: {
                                        line: 15,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Literal',
                                value: 30
                            },
                            kind: 'init',
                            order: '2'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'style',
                                loc: {
                                    start: {
                                        line: 16,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                    },
                                    end: {
                                        line: 16,
                                        column: 13,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'ObjectExpression',
                                properties: [{
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'padding',
                                            loc: {
                                                start: {
                                                    line: 17,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                },
                                                end: {
                                                    line: 17,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: '4px'
                                        },
                                        kind: 'init',
                                        order: '0'
                                    }]
                            },
                            kind: 'init',
                            order: '3'
                        },
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'Identifier',
                                        name: 'PaperIconButton',
                                        loc: {
                                            start: {
                                                line: 18,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                            },
                                            end: {
                                                line: 18,
                                                column: 23,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                            }
                                        }
                                    },
                                    arguments: [{
                                            type: 'ObjectExpression',
                                            properties: [{
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'class',
                                                        loc: {
                                                            start: {
                                                                line: 18,
                                                                column: 25,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                            },
                                                            end: {
                                                                line: 18,
                                                                column: 30,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 'dropdown-trigger'
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                }]
                                        }],
                                    loc: {
                                        start: {
                                            line: 18,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                        },
                                        end: {
                                            line: 18,
                                            column: 51,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                        }
                                    }
                                },
                                properties: [
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'style',
                                            loc: {
                                                start: {
                                                    line: 19,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                },
                                                end: {
                                                    line: 19,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'ObjectExpression',
                                            properties: [
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'width',
                                                        loc: {
                                                            start: {
                                                                line: 20,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                            },
                                                            end: {
                                                                line: 20,
                                                                column: 21,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: '20px'
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'height',
                                                        loc: {
                                                            start: {
                                                                line: 21,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                            },
                                                            end: {
                                                                line: 21,
                                                                column: 22,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: '20px'
                                                    },
                                                    kind: 'init',
                                                    order: '1'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'padding',
                                                        loc: {
                                                            start: {
                                                                line: 22,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                            },
                                                            end: {
                                                                line: 22,
                                                                column: 23,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: '0px'
                                                    },
                                                    kind: 'init',
                                                    order: '2'
                                                }
                                            ]
                                        },
                                        kind: 'init',
                                        order: '0'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'icon',
                                            loc: {
                                                start: {
                                                    line: 23,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                },
                                                end: {
                                                    line: 23,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: 'menu'
                                        },
                                        kind: 'init',
                                        order: '1'
                                    }
                                ]
                            },
                            loc: {
                                start: {
                                    line: 18,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                },
                                end: {
                                    line: 24,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                }
                            },
                            order: '4'
                        },
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'Identifier',
                                        name: 'PaperMenu',
                                        loc: {
                                            start: {
                                                line: 24,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                            },
                                            end: {
                                                line: 24,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                            }
                                        }
                                    },
                                    arguments: [{
                                            type: 'ObjectExpression',
                                            properties: [{
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'class',
                                                        loc: {
                                                            start: {
                                                                line: 24,
                                                                column: 19,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                            },
                                                            end: {
                                                                line: 24,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 'dropdown-content'
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                }]
                                        }],
                                    loc: {
                                        start: {
                                            line: 24,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                        },
                                        end: {
                                            line: 24,
                                            column: 45,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                        }
                                    }
                                },
                                properties: [
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'ObjectExpression',
                                            objectType: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'PaperIconItem',
                                                    loc: {
                                                        start: {
                                                            line: 25,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                        },
                                                        end: {
                                                            line: 25,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [],
                                                loc: {
                                                    start: {
                                                        line: 25,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                    },
                                                    end: {
                                                        line: 25,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                    }
                                                }
                                            },
                                            properties: [
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'Identifier',
                                                            name: 'IronIcon',
                                                            loc: {
                                                                start: {
                                                                    line: 26,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                },
                                                                end: {
                                                                    line: 26,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [{
                                                                type: 'ObjectExpression',
                                                                properties: [
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'icon',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 26,
                                                                                    column: 26,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 26,
                                                                                    column: 30,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Literal',
                                                                            value: 'av:replay'
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    },
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Literal',
                                                                            value: 'item-icon'
                                                                        },
                                                                        value: {
                                                                            type: 'Literal',
                                                                            value: true
                                                                        },
                                                                        kind: 'init',
                                                                        order: '1'
                                                                    }
                                                                ]
                                                            }],
                                                        loc: {
                                                            start: {
                                                                line: 26,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                            },
                                                            end: {
                                                                line: 26,
                                                                column: 61,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 26,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                        },
                                                        end: {
                                                            line: 26,
                                                            column: 61,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                },
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'Function',
                                                        context: true,
                                                        value: function (_context) {
                                                            return function click(e) {
                                                                var dataTableModel = _context.get('dataTableModel'), chooser = _context.get('chooser');
                                                                dataTableModel.resetColumns();
                                                                chooser.close();
                                                            };
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 27,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                        },
                                                        end: {
                                                            line: 30,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                        }
                                                    },
                                                    order: '1'
                                                },
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'Literal',
                                                        value: 'Reset Columns'
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 30,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                        },
                                                        end: {
                                                            line: 30,
                                                            column: 31,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                        }
                                                    },
                                                    order: '2'
                                                }
                                            ]
                                        },
                                        loc: {
                                            start: {
                                                line: 25,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                            },
                                            end: {
                                                line: 31,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                            }
                                        },
                                        order: '0'
                                    },
                                    {
                                        type: 'IfStatement',
                                        test: {
                                            type: 'BinaryExpression',
                                            operator: '!==',
                                            left: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'column',
                                                    loc: {
                                                        start: {
                                                            line: 31,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                        },
                                                        end: {
                                                            line: 31,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'fixed',
                                                    loc: {
                                                        start: {
                                                            line: 31,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                        },
                                                        end: {
                                                            line: 31,
                                                            column: 27,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 31,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                    },
                                                    end: {
                                                        line: 31,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                    }
                                                }
                                            },
                                            right: {
                                                type: 'Literal',
                                                value: true
                                            }
                                        },
                                        consequent: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'PaperIconItem',
                                                                loc: {
                                                                    start: {
                                                                        line: 32,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                    },
                                                                    end: {
                                                                        line: 32,
                                                                        column: 29,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [],
                                                            loc: {
                                                                start: {
                                                                    line: 32,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                },
                                                                end: {
                                                                    line: 32,
                                                                    column: 31,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'Identifier',
                                                                        name: 'IronIcon',
                                                                        loc: {
                                                                            start: {
                                                                                line: 33,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                            },
                                                                            end: {
                                                                                line: 33,
                                                                                column: 28,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [{
                                                                            type: 'ObjectExpression',
                                                                            properties: [
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'icon',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 33,
                                                                                                column: 30,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 33,
                                                                                                column: 34,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Literal',
                                                                                        value: 'clear'
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Literal',
                                                                                        value: 'item-icon'
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Literal',
                                                                                        value: true
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '1'
                                                                                }
                                                                            ]
                                                                        }],
                                                                    loc: {
                                                                        start: {
                                                                            line: 33,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                        },
                                                                        end: {
                                                                            line: 33,
                                                                            column: 61,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 33,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                    },
                                                                    end: {
                                                                        line: 33,
                                                                        column: 61,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'Function',
                                                                    context: true,
                                                                    value: function (_context2) {
                                                                        return function click(e) {
                                                                            var selectedColumns = _context2.get('selectedColumns'), dataTableModel = _context2.get('dataTableModel'), chooser = _context2.get('chooser');
                                                                            {
                                                                                var _ref7 = selectedColumns.slice(0);
                                                                                for (var _i = 0; _i < _ref7.length; _i++) {
                                                                                    var column = _ref7[_i];
                                                                                    dataTableModel.deleteColumn(column.name);
                                                                                }
                                                                            }
                                                                            chooser.close();
                                                                        };
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 34,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                    },
                                                                    end: {
                                                                        line: 38,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                    }
                                                                },
                                                                order: '1'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '+',
                                                                    left: {
                                                                        type: 'Literal',
                                                                        value: 'Remove '
                                                                    },
                                                                    right: {
                                                                        type: 'ConditionalExpression',
                                                                        test: {
                                                                            type: 'BinaryExpression',
                                                                            operator: '===',
                                                                            left: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'Identifier',
                                                                                    name: 'selectedColumns',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 38,
                                                                                            column: 30,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 38,
                                                                                            column: 45,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'length',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 38,
                                                                                            column: 46,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 38,
                                                                                            column: 52,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 38,
                                                                                        column: 30,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 38,
                                                                                        column: 52,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            right: {
                                                                                type: 'Literal',
                                                                                value: 1
                                                                            }
                                                                        },
                                                                        consequent: {
                                                                            type: 'CallExpression',
                                                                            callee: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'Identifier',
                                                                                    name: 'Schema',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 38,
                                                                                            column: 60,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 38,
                                                                                            column: 66,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'getDisplayName',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 38,
                                                                                            column: 67,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 38,
                                                                                            column: 81,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 38,
                                                                                        column: 60,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 38,
                                                                                        column: 81,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            arguments: [{
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'column',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 38,
                                                                                                column: 82,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 38,
                                                                                                column: 88,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'property',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 38,
                                                                                                column: 89,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 38,
                                                                                                column: 97,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 38,
                                                                                            column: 82,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 38,
                                                                                            column: 97,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                        }
                                                                                    }
                                                                                }],
                                                                            loc: {
                                                                                start: {
                                                                                    line: 38,
                                                                                    column: 60,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 38,
                                                                                    column: 98,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        alternate: {
                                                                            type: 'Literal',
                                                                            value: ' Selected Columns'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 38,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                    },
                                                                    end: {
                                                                        line: 38,
                                                                        column: 122,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                    }
                                                                },
                                                                order: '2'
                                                            }
                                                        ]
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 32,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                        },
                                                        end: {
                                                            line: 39,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        alternate: null,
                                        order: '1'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'Identifier',
                                                name: 'Hr',
                                                loc: {
                                                    start: {
                                                        line: 39,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                    },
                                                    end: {
                                                        line: 39,
                                                        column: 14,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                    }
                                                }
                                            },
                                            arguments: [],
                                            loc: {
                                                start: {
                                                    line: 39,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                },
                                                end: {
                                                    line: 39,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 39,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                            },
                                            end: {
                                                line: 39,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                            }
                                        },
                                        order: '2'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'ObjectExpression',
                                            objectType: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'PaperIconItem',
                                                    loc: {
                                                        start: {
                                                            line: 40,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                        },
                                                        end: {
                                                            line: 40,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [],
                                                loc: {
                                                    start: {
                                                        line: 40,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                    },
                                                    end: {
                                                        line: 40,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                    }
                                                }
                                            },
                                            properties: [
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'Identifier',
                                                            name: 'IronIcon',
                                                            loc: {
                                                                start: {
                                                                    line: 41,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                },
                                                                end: {
                                                                    line: 41,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [{
                                                                type: 'ObjectExpression',
                                                                properties: [
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'icon',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 41,
                                                                                    column: 26,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 41,
                                                                                    column: 30,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Literal',
                                                                            value: 'arrow-back'
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    },
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Literal',
                                                                            value: 'item-icon'
                                                                        },
                                                                        value: {
                                                                            type: 'Literal',
                                                                            value: true
                                                                        },
                                                                        kind: 'init',
                                                                        order: '1'
                                                                    }
                                                                ]
                                                            }],
                                                        loc: {
                                                            start: {
                                                                line: 41,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                            },
                                                            end: {
                                                                line: 41,
                                                                column: 62,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 41,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                        },
                                                        end: {
                                                            line: 41,
                                                            column: 62,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                },
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'Function',
                                                        context: true,
                                                        value: function (_context3) {
                                                            return function click(e) {
                                                                var dataTableModel = _context3.get('dataTableModel');
                                                                return dataTableModel.moveSelectedColumnsLeft();
                                                            };
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 42,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                        },
                                                        end: {
                                                            line: 42,
                                                            column: 68,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                        }
                                                    },
                                                    order: '1'
                                                },
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'Literal',
                                                        value: 'Move Left'
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 43,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                        },
                                                        end: {
                                                            line: 43,
                                                            column: 27,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                        }
                                                    },
                                                    order: '2'
                                                }
                                            ]
                                        },
                                        loc: {
                                            start: {
                                                line: 40,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                            },
                                            end: {
                                                line: 44,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                            }
                                        },
                                        order: '3'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'ObjectExpression',
                                            objectType: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'PaperIconItem',
                                                    loc: {
                                                        start: {
                                                            line: 44,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                        },
                                                        end: {
                                                            line: 44,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [],
                                                loc: {
                                                    start: {
                                                        line: 44,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                    },
                                                    end: {
                                                        line: 44,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                    }
                                                }
                                            },
                                            properties: [
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'Identifier',
                                                            name: 'IronIcon',
                                                            loc: {
                                                                start: {
                                                                    line: 45,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                },
                                                                end: {
                                                                    line: 45,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [{
                                                                type: 'ObjectExpression',
                                                                properties: [
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'icon',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 45,
                                                                                    column: 26,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 45,
                                                                                    column: 30,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Literal',
                                                                            value: 'arrow-forward'
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    },
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Literal',
                                                                            value: 'item-icon'
                                                                        },
                                                                        value: {
                                                                            type: 'Literal',
                                                                            value: true
                                                                        },
                                                                        kind: 'init',
                                                                        order: '1'
                                                                    }
                                                                ]
                                                            }],
                                                        loc: {
                                                            start: {
                                                                line: 45,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                            },
                                                            end: {
                                                                line: 45,
                                                                column: 65,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 45,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                        },
                                                        end: {
                                                            line: 45,
                                                            column: 65,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                },
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'Function',
                                                        context: true,
                                                        value: function (_context4) {
                                                            return function click(e) {
                                                                var dataTableModel = _context4.get('dataTableModel');
                                                                return dataTableModel.moveSelectedColumnsRight();
                                                            };
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 46,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                        },
                                                        end: {
                                                            line: 46,
                                                            column: 69,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                        }
                                                    },
                                                    order: '1'
                                                },
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'Literal',
                                                        value: 'Move Right'
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 47,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                        },
                                                        end: {
                                                            line: 47,
                                                            column: 28,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                        }
                                                    },
                                                    order: '2'
                                                }
                                            ]
                                        },
                                        loc: {
                                            start: {
                                                line: 44,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                            },
                                            end: {
                                                line: 48,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                            }
                                        },
                                        order: '4'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'Identifier',
                                                name: 'Hr',
                                                loc: {
                                                    start: {
                                                        line: 56,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                    },
                                                    end: {
                                                        line: 56,
                                                        column: 14,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                    }
                                                }
                                            },
                                            arguments: [],
                                            loc: {
                                                start: {
                                                    line: 56,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                },
                                                end: {
                                                    line: 56,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 56,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                            },
                                            end: {
                                                line: 56,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                            }
                                        },
                                        order: '5'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'ObjectExpression',
                                            objectType: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'PaperSubmenu',
                                                    loc: {
                                                        start: {
                                                            line: 57,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                        },
                                                        end: {
                                                            line: 57,
                                                            column: 24,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [],
                                                loc: {
                                                    start: {
                                                        line: 57,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                    },
                                                    end: {
                                                        line: 57,
                                                        column: 26,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                    }
                                                }
                                            },
                                            properties: [
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'PaperIconItem',
                                                                loc: {
                                                                    start: {
                                                                        line: 58,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                    },
                                                                    end: {
                                                                        line: 58,
                                                                        column: 29,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [{
                                                                    type: 'ObjectExpression',
                                                                    properties: [{
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'class',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 58,
                                                                                        column: 31,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 58,
                                                                                        column: 36,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'menu-trigger'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        }]
                                                                }],
                                                            loc: {
                                                                start: {
                                                                    line: 58,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                },
                                                                end: {
                                                                    line: 58,
                                                                    column: 53,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'Identifier',
                                                                        name: 'IronIcon',
                                                                        loc: {
                                                                            start: {
                                                                                line: 59,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                            },
                                                                            end: {
                                                                                line: 59,
                                                                                column: 28,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [{
                                                                            type: 'ObjectExpression',
                                                                            properties: [
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'icon',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 59,
                                                                                                column: 30,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 59,
                                                                                                column: 34,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Literal',
                                                                                        value: 'more-vert'
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Literal',
                                                                                        value: 'item-icon'
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Literal',
                                                                                        value: true
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '1'
                                                                                }
                                                                            ]
                                                                        }],
                                                                    loc: {
                                                                        start: {
                                                                            line: 59,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                        },
                                                                        end: {
                                                                            line: 59,
                                                                            column: 65,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 59,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                    },
                                                                    end: {
                                                                        line: 59,
                                                                        column: 65,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'Literal',
                                                                    value: 'Select Columns'
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 60,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                    },
                                                                    end: {
                                                                        line: 60,
                                                                        column: 36,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                    }
                                                                },
                                                                order: '1'
                                                            }
                                                        ]
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 58,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                        },
                                                        end: {
                                                            line: 61,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                },
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'PaperMenu',
                                                                loc: {
                                                                    start: {
                                                                        line: 61,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                    },
                                                                    end: {
                                                                        line: 61,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [{
                                                                    type: 'ObjectExpression',
                                                                    properties: [
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'class',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 61,
                                                                                        column: 27,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 61,
                                                                                        column: 32,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'menu-content'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'multi',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 61,
                                                                                        column: 49,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 61,
                                                                                        column: 54,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: true
                                                                            },
                                                                            kind: 'init',
                                                                            order: '1'
                                                                        }
                                                                    ]
                                                                }],
                                                            loc: {
                                                                start: {
                                                                    line: 61,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                },
                                                                end: {
                                                                    line: 61,
                                                                    column: 61,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'attrForSelected',
                                                                    loc: {
                                                                        start: {
                                                                            line: 62,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                        },
                                                                        end: {
                                                                            line: 62,
                                                                            column: 35,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: 'name'
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'selectedValues',
                                                                    loc: {
                                                                        start: {
                                                                            line: 63,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                        },
                                                                        end: {
                                                                            line: 63,
                                                                            column: 34,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'ArrayExpression',
                                                                            elements: [{
                                                                                    type: 'Literal',
                                                                                    value: '_reset'
                                                                                }]
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'concat',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 63,
                                                                                    column: 47,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 63,
                                                                                    column: 53,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 63,
                                                                                column: 36,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                            },
                                                                            end: {
                                                                                line: 63,
                                                                                column: 53,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [{
                                                                            type: 'CallExpression',
                                                                            callee: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'Identifier',
                                                                                    name: 'visibleColumnNames',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 63,
                                                                                            column: 54,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 63,
                                                                                            column: 72,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'slice',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 63,
                                                                                            column: 73,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 63,
                                                                                            column: 78,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 63,
                                                                                        column: 54,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 63,
                                                                                        column: 78,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            arguments: [{
                                                                                    type: 'Literal',
                                                                                    value: 0
                                                                                }],
                                                                            loc: {
                                                                                start: {
                                                                                    line: 63,
                                                                                    column: 54,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 63,
                                                                                    column: 81,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                }
                                                                            }
                                                                        }],
                                                                    loc: {
                                                                        start: {
                                                                            line: 63,
                                                                            column: 36,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                        },
                                                                        end: {
                                                                            line: 63,
                                                                            column: 82,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                        }
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '1'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'MemberExpression',
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'Object'
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'assign'
                                                                        }
                                                                    },
                                                                    arguments: [
                                                                        {
                                                                            type: 'Function',
                                                                            context: true,
                                                                            value: function (_context5) {
                                                                                return function (e) {
                                                                                    var visibleColumnNames = _context5.get('visibleColumnNames'), selectedColumns = _context5.get('selectedColumns'), dataTableModel = _context5.get('dataTableModel');
                                                                                    var _ref5 = e.detail.item;
                                                                                    var name = _ref5.name;
                                                                                    if (!visibleColumnNames.contains(name)) {
                                                                                        var lastColumn = selectedColumns[selectedColumns.length - 1];
                                                                                        dataTableModel.insertColumn(name, lastColumn != null ? lastColumn.name : void 0);
                                                                                    }
                                                                                };
                                                                            }
                                                                        },
                                                                        {
                                                                            type: 'ObjectExpression',
                                                                            properties: [{
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'id'
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Literal',
                                                                                        value: 'iron-select'
                                                                                    },
                                                                                    order: '0'
                                                                                }]
                                                                        }
                                                                    ]
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 64,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                    },
                                                                    end: {
                                                                        line: 69,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                    }
                                                                },
                                                                order: '2'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'MemberExpression',
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'Object'
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'assign'
                                                                        }
                                                                    },
                                                                    arguments: [
                                                                        {
                                                                            type: 'Function',
                                                                            context: true,
                                                                            value: function (_context6) {
                                                                                return function (e) {
                                                                                    var visibleColumnNames = _context6.get('visibleColumnNames'), dataTableModel = _context6.get('dataTableModel');
                                                                                    var _ref6 = e.detail.item;
                                                                                    var name = _ref6.name;
                                                                                    if (visibleColumnNames.contains(name)) {
                                                                                        dataTableModel.deleteColumn(name);
                                                                                    }
                                                                                };
                                                                            }
                                                                        },
                                                                        {
                                                                            type: 'ObjectExpression',
                                                                            properties: [{
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'id'
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Literal',
                                                                                        value: 'iron-deselect'
                                                                                    },
                                                                                    order: '0'
                                                                                }]
                                                                        }
                                                                    ]
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 69,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                    },
                                                                    end: {
                                                                        line: 73,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                    }
                                                                },
                                                                order: '3'
                                                            },
                                                            {
                                                                type: 'ForOfStatement',
                                                                left: {
                                                                    type: 'VariableDeclaration',
                                                                    declarations: [{
                                                                            type: 'VariableDeclarator',
                                                                            id: {
                                                                                type: 'Identifier',
                                                                                name: 'property',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 73,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 73,
                                                                                        column: 32,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            init: null
                                                                        }],
                                                                    kind: 'let'
                                                                },
                                                                right: {
                                                                    type: 'Identifier',
                                                                    name: 'properties',
                                                                    loc: {
                                                                        start: {
                                                                            line: 73,
                                                                            column: 36,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                        },
                                                                        end: {
                                                                            line: 73,
                                                                            column: 46,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                        }
                                                                    }
                                                                },
                                                                body: {
                                                                    type: 'BlockStatement',
                                                                    body: [{
                                                                            type: 'IfStatement',
                                                                            test: {
                                                                                type: 'BinaryExpression',
                                                                                operator: '!==',
                                                                                left: {
                                                                                    type: 'Identifier',
                                                                                    name: 'property',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 73,
                                                                                            column: 50,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 73,
                                                                                            column: 58,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                right: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'column',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 73,
                                                                                                column: 64,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 73,
                                                                                                column: 70,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'property',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 73,
                                                                                                column: 71,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 73,
                                                                                                column: 79,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 73,
                                                                                            column: 64,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 73,
                                                                                            column: 79,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                        }
                                                                                    }
                                                                                }
                                                                            },
                                                                            consequent: {
                                                                                type: 'BlockStatement',
                                                                                body: [
                                                                                    {
                                                                                        type: 'VariableDeclaration',
                                                                                        declarations: [{
                                                                                                type: 'VariableDeclarator',
                                                                                                id: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'displayName',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 74,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 74,
                                                                                                            column: 39,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                init: {
                                                                                                    type: 'CallExpression',
                                                                                                    callee: {
                                                                                                        type: 'MemberExpression',
                                                                                                        computed: false,
                                                                                                        object: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'Schema',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 74,
                                                                                                                    column: 42,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 74,
                                                                                                                    column: 48,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        property: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'getDisplayName',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 74,
                                                                                                                    column: 49,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 74,
                                                                                                                    column: 63,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 74,
                                                                                                                column: 42,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 74,
                                                                                                                column: 63,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    arguments: [{
                                                                                                            type: 'Identifier',
                                                                                                            name: 'property',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 74,
                                                                                                                    column: 64,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 74,
                                                                                                                    column: 72,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        }],
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 74,
                                                                                                            column: 42,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 74,
                                                                                                            column: 73,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                        }
                                                                                                    }
                                                                                                }
                                                                                            }],
                                                                                        kind: 'let',
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'ObjectExpression',
                                                                                            objectType: {
                                                                                                type: 'CallExpression',
                                                                                                callee: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'PaperIconItem',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 75,
                                                                                                            column: 24,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 75,
                                                                                                            column: 37,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                arguments: [],
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 75,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 75,
                                                                                                        column: 39,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            properties: [
                                                                                                {
                                                                                                    type: 'IfStatement',
                                                                                                    test: {
                                                                                                        type: 'CallExpression',
                                                                                                        callee: {
                                                                                                            type: 'MemberExpression',
                                                                                                            computed: false,
                                                                                                            object: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'visibleColumnNames',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 76,
                                                                                                                        column: 31,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 76,
                                                                                                                        column: 49,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            property: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'contains',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 76,
                                                                                                                        column: 50,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 76,
                                                                                                                        column: 58,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 76,
                                                                                                                    column: 31,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 76,
                                                                                                                    column: 58,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        arguments: [{
                                                                                                                type: 'MemberExpression',
                                                                                                                computed: false,
                                                                                                                object: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'property',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 76,
                                                                                                                            column: 59,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 76,
                                                                                                                            column: 67,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                property: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'name',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 76,
                                                                                                                            column: 68,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 76,
                                                                                                                            column: 72,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 76,
                                                                                                                        column: 59,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 76,
                                                                                                                        column: 72,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            }],
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 76,
                                                                                                                column: 31,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 76,
                                                                                                                column: 73,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    consequent: {
                                                                                                        type: 'BlockStatement',
                                                                                                        body: [{
                                                                                                                type: 'ExpressionStatement',
                                                                                                                expression: {
                                                                                                                    type: 'ObjectExpression',
                                                                                                                    objectType: {
                                                                                                                        type: 'CallExpression',
                                                                                                                        callee: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'IronIcon',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 77,
                                                                                                                                    column: 32,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 77,
                                                                                                                                    column: 40,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        arguments: [{
                                                                                                                                type: 'ObjectExpression',
                                                                                                                                properties: [
                                                                                                                                    {
                                                                                                                                        type: 'Property',
                                                                                                                                        key: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'icon',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 77,
                                                                                                                                                    column: 42,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 77,
                                                                                                                                                    column: 46,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        value: {
                                                                                                                                            type: 'Literal',
                                                                                                                                            value: 'done'
                                                                                                                                        },
                                                                                                                                        kind: 'init',
                                                                                                                                        order: '0'
                                                                                                                                    },
                                                                                                                                    {
                                                                                                                                        type: 'Property',
                                                                                                                                        key: {
                                                                                                                                            type: 'Literal',
                                                                                                                                            value: 'item-icon'
                                                                                                                                        },
                                                                                                                                        value: {
                                                                                                                                            type: 'Literal',
                                                                                                                                            value: true
                                                                                                                                        },
                                                                                                                                        kind: 'init',
                                                                                                                                        order: '1'
                                                                                                                                    }
                                                                                                                                ]
                                                                                                                            }],
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 77,
                                                                                                                                column: 32,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 77,
                                                                                                                                column: 72,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    properties: [{
                                                                                                                            type: 'Property',
                                                                                                                            key: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'style',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 78,
                                                                                                                                        column: 36,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 78,
                                                                                                                                        column: 41,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            value: {
                                                                                                                                type: 'ObjectExpression',
                                                                                                                                properties: [{
                                                                                                                                        type: 'Property',
                                                                                                                                        key: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'color',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 79,
                                                                                                                                                    column: 40,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 79,
                                                                                                                                                    column: 45,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        value: {
                                                                                                                                            type: 'Literal',
                                                                                                                                            value: 'green'
                                                                                                                                        },
                                                                                                                                        kind: 'init',
                                                                                                                                        order: '0'
                                                                                                                                    }]
                                                                                                                            },
                                                                                                                            kind: 'init',
                                                                                                                            order: '0'
                                                                                                                        }]
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 77,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 80,
                                                                                                                        column: 36,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                                    }
                                                                                                                },
                                                                                                                order: '0'
                                                                                                            }]
                                                                                                    },
                                                                                                    alternate: null,
                                                                                                    order: '0'
                                                                                                },
                                                                                                {
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'name',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 80,
                                                                                                                column: 28,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 80,
                                                                                                                column: 32,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'MemberExpression',
                                                                                                        computed: false,
                                                                                                        object: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'property',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 80,
                                                                                                                    column: 34,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 80,
                                                                                                                    column: 42,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        property: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'name',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 80,
                                                                                                                    column: 43,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 80,
                                                                                                                    column: 47,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 80,
                                                                                                                column: 34,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 80,
                                                                                                                column: 47,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '1'
                                                                                                },
                                                                                                {
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'toggles',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 81,
                                                                                                                column: 28,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 81,
                                                                                                                column: 35,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'Literal',
                                                                                                        value: true
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '2'
                                                                                                },
                                                                                                {
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'active',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 82,
                                                                                                                column: 28,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 82,
                                                                                                                column: 34,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'Literal',
                                                                                                        value: true
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '3'
                                                                                                },
                                                                                                {
                                                                                                    type: 'ExpressionStatement',
                                                                                                    expression: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'displayName',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 83,
                                                                                                                column: 28,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 83,
                                                                                                                column: 39,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 83,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 83,
                                                                                                            column: 39,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                                        }
                                                                                                    },
                                                                                                    order: '4'
                                                                                                }
                                                                                            ]
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 75,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 85,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '1'
                                                                                    }
                                                                                ]
                                                                            },
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                remove: null,
                                                                order: '4'
                                                            }
                                                        ]
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 61,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                        },
                                                        end: {
                                                            line: 85,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                                        }
                                                    },
                                                    order: '1'
                                                }
                                            ]
                                        },
                                        loc: {
                                            start: {
                                                line: 57,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                            },
                                            end: {
                                                line: 85,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                            }
                                        },
                                        order: '6'
                                    }
                                ]
                            },
                            loc: {
                                start: {
                                    line: 24,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                },
                                end: {
                                    line: 85,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ColumnChooser.ion'
                                }
                            },
                            order: '5'
                        }
                    ]
                },
                order: '9'
            }
        ],
        bound: false
    }, {
        this: this,
        _ref2: _ref2,
        _ref: _ref,
        Schema: Schema
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/DataTable2/ColumnChooser',_glass_html_material_DataTable2_ColumnChooser_);
    else
      _glass_html_material_DataTable2_ColumnChooser_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_DataTable2_ColumnChooser_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_DataTable2_ColumnSource_ = function(module,exports,require){'use strict';
var ion = require('ion');
module.exports = exports = ion.template(function ColumnSource(args) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'ColumnSource',
            loc: {
                start: {
                    line: 3,
                    column: 16,
                    fixed: true,
                    source: 'glass/html/material/DataTable2/ColumnSource.ion'
                },
                end: {
                    line: 3,
                    column: 28,
                    fixed: true,
                    source: 'glass/html/material/DataTable2/ColumnSource.ion'
                }
            }
        },
        body: [{
                type: 'ReturnStatement',
                argument: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'ObjectExpression',
                        properties: []
                    },
                    properties: [
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'columns',
                                loc: {
                                    start: {
                                        line: 5,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ColumnSource.ion'
                                    },
                                    end: {
                                        line: 5,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ColumnSource.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'ArrayExpression',
                                elements: []
                            },
                            kind: 'init',
                            order: '0'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'properties',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ColumnSource.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ColumnSource.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'ObjectExpression',
                                properties: []
                            },
                            kind: 'init',
                            order: '1'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'availableColumnNames',
                                loc: {
                                    start: {
                                        line: 7,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ColumnSource.ion'
                                    },
                                    end: {
                                        line: 7,
                                        column: 28,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ColumnSource.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'ArrayExpression',
                                elements: []
                            },
                            kind: 'init',
                            order: '2'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'insertColumn',
                                loc: {
                                    start: {
                                        line: 8,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ColumnSource.ion'
                                    },
                                    end: {
                                        line: 8,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ColumnSource.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: false,
                                value: function (name, insertBeforeName) {
                                }
                            },
                            kind: 'init',
                            order: '3'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'deleteColumn',
                                loc: {
                                    start: {
                                        line: 9,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ColumnSource.ion'
                                    },
                                    end: {
                                        line: 9,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ColumnSource.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: false,
                                value: function (name) {
                                }
                            },
                            kind: 'init',
                            order: '4'
                        }
                    ]
                },
                order: '0'
            }],
        bound: false
    }, {
        this: this,
        args: args
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/DataTable2/ColumnSource',_glass_html_material_DataTable2_ColumnSource_);
    else
      _glass_html_material_DataTable2_ColumnSource_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_DataTable2_ColumnSource_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_DataTable2_CustomColumnSource_ = function(module,exports,require){'use strict';
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/DataTable2/CustomColumnSource',_glass_html_material_DataTable2_CustomColumnSource_);
    else
      _glass_html_material_DataTable2_CustomColumnSource_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_DataTable2_CustomColumnSource_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_DataTable2_CutCopyPasteSupport_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('../../functions');
var getAncestorByClass = _ref.getAncestorByClass;
var getOffsetRelative = _ref.getOffsetRelative;
var isAncestor = _ref.isAncestor;
module.exports = exports = ion.template(function CutCopyPasteSupport(dataTable) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'CutCopyPasteSupport',
            loc: {
                start: {
                    line: 4,
                    column: 16,
                    fixed: true,
                    source: 'glass/html/material/DataTable2/CutCopyPasteSupport.ion'
                },
                end: {
                    line: 4,
                    column: 35,
                    fixed: true,
                    source: 'glass/html/material/DataTable2/CutCopyPasteSupport.ion'
                }
            }
        },
        body: [{
                type: 'ExpressionStatement',
                expression: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'Identifier',
                        name: 'window',
                        loc: {
                            start: {
                                line: 6,
                                column: 4,
                                fixed: true,
                                source: 'glass/html/material/DataTable2/CutCopyPasteSupport.ion'
                            },
                            end: {
                                line: 6,
                                column: 10,
                                fixed: true,
                                source: 'glass/html/material/DataTable2/CutCopyPasteSupport.ion'
                            }
                        }
                    },
                    properties: [
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'hasFocus',
                                        loc: {
                                            start: {
                                                line: 7,
                                                column: 14,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/CutCopyPasteSupport.ion'
                                            },
                                            end: {
                                                line: 7,
                                                column: 22,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/CutCopyPasteSupport.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context) {
                                            return function () {
                                                var isAncestor = _context.get('isAncestor'), dataTable = _context.get('dataTable');
                                                return isAncestor(document.activeElement, dataTable);
                                            };
                                        }
                                    }
                                }],
                            kind: 'const',
                            order: '0'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'enable',
                                        loc: {
                                            start: {
                                                line: 8,
                                                column: 14,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/CutCopyPasteSupport.ion'
                                            },
                                            end: {
                                                line: 8,
                                                column: 20,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/CutCopyPasteSupport.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context2) {
                                            return function (e) {
                                                var isAncestor = _context2.get('isAncestor'), dataTable = _context2.get('dataTable');
                                                if (isAncestor(document.activeElement, dataTable)) {
                                                    e.preventDefault();
                                                }
                                            };
                                        }
                                    }
                                }],
                            kind: 'const',
                            order: '1'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'copyTypes',
                                        loc: {
                                            start: {
                                                line: 11,
                                                column: 14,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/CutCopyPasteSupport.ion'
                                            },
                                            end: {
                                                line: 11,
                                                column: 23,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/CutCopyPasteSupport.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'ArrayExpression',
                                        elements: [
                                            {
                                                type: 'Literal',
                                                value: 'application/json'
                                            },
                                            {
                                                type: 'Literal',
                                                value: 'text/plain'
                                            }
                                        ]
                                    }
                                }],
                            kind: 'const',
                            order: '2'
                        },
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'Function',
                                context: true,
                                value: function (_context3) {
                                    return function beforecut(e) {
                                        var enable = _context3.get('enable');
                                        return enable(e);
                                    };
                                }
                            },
                            loc: {
                                start: {
                                    line: 13,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/CutCopyPasteSupport.ion'
                                },
                                end: {
                                    line: 13,
                                    column: 33,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/CutCopyPasteSupport.ion'
                                }
                            },
                            order: '3'
                        },
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'Function',
                                context: true,
                                value: function (_context4) {
                                    return function beforecopy(e) {
                                        var enable = _context4.get('enable');
                                        return enable(e);
                                    };
                                }
                            },
                            loc: {
                                start: {
                                    line: 14,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/CutCopyPasteSupport.ion'
                                },
                                end: {
                                    line: 14,
                                    column: 34,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/CutCopyPasteSupport.ion'
                                }
                            },
                            order: '4'
                        },
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'Function',
                                context: true,
                                value: function (_context5) {
                                    return function beforepaste(e) {
                                        var enable = _context5.get('enable');
                                        return enable(e);
                                    };
                                }
                            },
                            loc: {
                                start: {
                                    line: 15,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/CutCopyPasteSupport.ion'
                                },
                                end: {
                                    line: 15,
                                    column: 35,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/CutCopyPasteSupport.ion'
                                }
                            },
                            order: '5'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'copy',
                                        loc: {
                                            start: {
                                                line: 16,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/CutCopyPasteSupport.ion'
                                            },
                                            end: {
                                                line: 16,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/CutCopyPasteSupport.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context6) {
                                            return function copy(e) {
                                                var hasFocus = _context6.get('hasFocus'), copyTypes = _context6.get('copyTypes'), dataTable = _context6.get('dataTable');
                                                if (hasFocus()) {
                                                    for (var _i = 0; _i < copyTypes.length; _i++) {
                                                        var type = copyTypes[_i];
                                                        var data = dataTable.model.getSelectionAsMime(type);
                                                        e.clipboardData.setData(type, data);
                                                    }
                                                    e.preventDefault();
                                                }
                                            };
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '6'
                        },
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'Identifier',
                                name: 'copy',
                                loc: {
                                    start: {
                                        line: 22,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/CutCopyPasteSupport.ion'
                                    },
                                    end: {
                                        line: 22,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/CutCopyPasteSupport.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 22,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/CutCopyPasteSupport.ion'
                                },
                                end: {
                                    line: 22,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/CutCopyPasteSupport.ion'
                                }
                            },
                            order: '7'
                        },
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'Function',
                                context: true,
                                value: function (_context7) {
                                    return function cut(e) {
                                        var copy = _context7.get('copy'), dataTable = _context7.get('dataTable');
                                        copy(e);
                                        dataTable.model.deleteSelection();
                                    };
                                }
                            },
                            loc: {
                                start: {
                                    line: 23,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/CutCopyPasteSupport.ion'
                                },
                                end: {
                                    line: 26,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/CutCopyPasteSupport.ion'
                                }
                            },
                            order: '8'
                        },
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'Function',
                                context: true,
                                value: function (_context8) {
                                    return function paste(e) {
                                        var hasFocus = _context8.get('hasFocus'), copyTypes = _context8.get('copyTypes'), dataTable = _context8.get('dataTable');
                                        if (hasFocus()) {
                                            for (var _i2 = 0; _i2 < copyTypes.length; _i2++) {
                                                var type = copyTypes[_i2];
                                                if (e.clipboardData.types.includes(type)) {
                                                    var data = e.clipboardData.getData(type);
                                                    dataTable.model.setSelectionFromMime(data, type);
                                                    break;
                                                }
                                            }
                                        }
                                    };
                                }
                            },
                            loc: {
                                start: {
                                    line: 26,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/CutCopyPasteSupport.ion'
                                },
                                end: {
                                    line: 34,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/CutCopyPasteSupport.ion'
                                }
                            },
                            order: '9'
                        }
                    ]
                },
                loc: {
                    start: {
                        line: 6,
                        column: 4,
                        fixed: true,
                        source: 'glass/html/material/DataTable2/CutCopyPasteSupport.ion'
                    },
                    end: {
                        line: 34,
                        column: 8,
                        fixed: true,
                        source: 'glass/html/material/DataTable2/CutCopyPasteSupport.ion'
                    }
                },
                order: '0'
            }],
        bound: false
    }, {
        this: this,
        dataTable: dataTable,
        _ref: _ref,
        getAncestorByClass: getAncestorByClass,
        getOffsetRelative: getOffsetRelative,
        isAncestor: isAncestor
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/DataTable2/CutCopyPasteSupport',_glass_html_material_DataTable2_CutCopyPasteSupport_);
    else
      _glass_html_material_DataTable2_CutCopyPasteSupport_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_DataTable2_CutCopyPasteSupport_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_DataTable2_DataTable_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('../../'), _ref2, _ref3, CutCopyPasteSupport = require('./CutCopyPasteSupport'), NavigateAndEditSupport = require('./NavigateAndEditSupport');
var style = _ref.style;
_ref2 = require('./DataTableStyle');
var selectOpacity = _ref2.selectOpacity;
_ref3 = require('../../functions');
var makeElementAutoEdgeScroll = _ref3.makeElementAutoEdgeScroll;
var DataRow = ion.template(function (_ref4) {
        return ion.createRuntime({
            type: 'Template',
            id: null,
            body: [
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'dataTable',
                                loc: {
                                    start: {
                                        line: 9,
                                        column: 27,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    },
                                    end: {
                                        line: 9,
                                        column: 36,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref4'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'dataTable',
                                    loc: {
                                        start: {
                                            line: 9,
                                            column: 27,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                        },
                                        end: {
                                            line: 9,
                                            column: 36,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '0'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'rowModel',
                                loc: {
                                    start: {
                                        line: 9,
                                        column: 38,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    },
                                    end: {
                                        line: 9,
                                        column: 46,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref4'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'rowModel',
                                    loc: {
                                        start: {
                                            line: 9,
                                            column: 38,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                        },
                                        end: {
                                            line: 9,
                                            column: 46,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '1'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'index',
                                loc: {
                                    start: {
                                        line: 9,
                                        column: 48,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    },
                                    end: {
                                        line: 9,
                                        column: 53,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref4'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'index',
                                    loc: {
                                        start: {
                                            line: 9,
                                            column: 48,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                        },
                                        end: {
                                            line: 9,
                                            column: 53,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '2'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'rowContent',
                                loc: {
                                    start: {
                                        line: 9,
                                        column: 55,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    },
                                    end: {
                                        line: 9,
                                        column: 65,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref4'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'rowContent',
                                    loc: {
                                        start: {
                                            line: 9,
                                            column: 55,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                        },
                                        end: {
                                            line: 9,
                                            column: 65,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '3'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: '_ref5'
                            },
                            init: {
                                type: 'Identifier',
                                name: 'rowModel',
                                loc: {
                                    start: {
                                        line: 10,
                                        column: 54,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    },
                                    end: {
                                        line: 10,
                                        column: 62,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '4'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'key',
                                loc: {
                                    start: {
                                        line: 10,
                                        column: 9,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    },
                                    end: {
                                        line: 10,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref5'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'key',
                                    loc: {
                                        start: {
                                            line: 10,
                                            column: 9,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                        },
                                        end: {
                                            line: 10,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '5'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'children',
                                loc: {
                                    start: {
                                        line: 10,
                                        column: 13,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    },
                                    end: {
                                        line: 10,
                                        column: 21,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref5'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'children',
                                    loc: {
                                        start: {
                                            line: 10,
                                            column: 13,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                        },
                                        end: {
                                            line: 10,
                                            column: 21,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '6'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'open',
                                loc: {
                                    start: {
                                        line: 10,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    },
                                    end: {
                                        line: 10,
                                        column: 26,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref5'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'open',
                                    loc: {
                                        start: {
                                            line: 10,
                                            column: 22,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                        },
                                        end: {
                                            line: 10,
                                            column: 26,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '7'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'selected',
                                loc: {
                                    start: {
                                        line: 10,
                                        column: 27,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    },
                                    end: {
                                        line: 10,
                                        column: 35,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref5'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'selected',
                                    loc: {
                                        start: {
                                            line: 10,
                                            column: 27,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                        },
                                        end: {
                                            line: 10,
                                            column: 35,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '8'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'dataTableModel',
                                loc: {
                                    start: {
                                        line: 10,
                                        column: 36,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    },
                                    end: {
                                        line: 10,
                                        column: 50,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref5'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'dataTableModel',
                                    loc: {
                                        start: {
                                            line: 10,
                                            column: 36,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                        },
                                        end: {
                                            line: 10,
                                            column: 50,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '9'
                },
                {
                    type: 'ReturnStatement',
                    argument: {
                        type: 'ObjectExpression',
                        objectType: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Div',
                                loc: {
                                    start: {
                                        line: 12,
                                        column: 11,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    },
                                    end: {
                                        line: 12,
                                        column: 14,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ObjectExpression',
                                    properties: [{
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'class',
                                                loc: {
                                                    start: {
                                                        line: 12,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                    },
                                                    end: {
                                                        line: 12,
                                                        column: 21,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: 'row'
                                            },
                                            kind: 'init',
                                            order: '0'
                                        }]
                                }],
                            loc: {
                                start: {
                                    line: 12,
                                    column: 11,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                },
                                end: {
                                    line: 12,
                                    column: 29,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                }
                            }
                        },
                        properties: [
                            {
                                type: 'VariableDeclaration',
                                declarations: [{
                                        type: 'VariableDeclarator',
                                        id: {
                                            type: 'Identifier',
                                            name: 'parent',
                                            loc: {
                                                start: {
                                                    line: 13,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                },
                                                end: {
                                                    line: 13,
                                                    column: 18,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                }
                                            }
                                        },
                                        init: {
                                            type: 'BinaryExpression',
                                            operator: '&&',
                                            left: {
                                                type: 'UnaryExpression',
                                                operator: '?',
                                                argument: {
                                                    type: 'Identifier',
                                                    name: 'children',
                                                    loc: {
                                                        start: {
                                                            line: 13,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        },
                                                        end: {
                                                            line: 13,
                                                            column: 29,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        }
                                                    }
                                                }
                                            },
                                            right: {
                                                type: 'BinaryExpression',
                                                operator: '>',
                                                left: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'children',
                                                        loc: {
                                                            start: {
                                                                line: 13,
                                                                column: 35,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                            },
                                                            end: {
                                                                line: 13,
                                                                column: 43,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'length',
                                                        loc: {
                                                            start: {
                                                                line: 13,
                                                                column: 45,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                            },
                                                            end: {
                                                                line: 13,
                                                                column: 51,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                            }
                                                        }
                                                    },
                                                    existential: true,
                                                    loc: {
                                                        start: {
                                                            line: 13,
                                                            column: 35,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        },
                                                        end: {
                                                            line: 13,
                                                            column: 51,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        }
                                                    }
                                                },
                                                right: {
                                                    type: 'Literal',
                                                    value: 0
                                                }
                                            }
                                        }
                                    }],
                                kind: 'let',
                                order: '0'
                            },
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'model',
                                    loc: {
                                        start: {
                                            line: 14,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                        },
                                        end: {
                                            line: 14,
                                            column: 13,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'Identifier',
                                    name: 'rowModel',
                                    loc: {
                                        start: {
                                            line: 14,
                                            column: 15,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                        },
                                        end: {
                                            line: 14,
                                            column: 23,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                        }
                                    }
                                },
                                kind: 'init',
                                order: '1'
                            },
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'classList',
                                    loc: {
                                        start: {
                                            line: 15,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                        },
                                        end: {
                                            line: 15,
                                            column: 17,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'ObjectExpression',
                                    properties: [
                                        {
                                            type: 'IfStatement',
                                            test: {
                                                type: 'Identifier',
                                                name: 'parent',
                                                loc: {
                                                    start: {
                                                        line: 16,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                    },
                                                    end: {
                                                        line: 16,
                                                        column: 21,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                    }
                                                }
                                            },
                                            consequent: {
                                                type: 'BlockStatement',
                                                body: [{
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'Literal',
                                                            value: 'parent'
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 17,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                            },
                                                            end: {
                                                                line: 17,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                            }
                                                        },
                                                        order: '0'
                                                    }]
                                            },
                                            alternate: null,
                                            order: '0'
                                        },
                                        {
                                            type: 'IfStatement',
                                            test: {
                                                type: 'Identifier',
                                                name: 'selected',
                                                loc: {
                                                    start: {
                                                        line: 18,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                    },
                                                    end: {
                                                        line: 18,
                                                        column: 23,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                    }
                                                }
                                            },
                                            consequent: {
                                                type: 'BlockStatement',
                                                body: [{
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'Literal',
                                                            value: 'selected'
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 19,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                            },
                                                            end: {
                                                                line: 19,
                                                                column: 26,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                            }
                                                        },
                                                        order: '0'
                                                    }]
                                            },
                                            alternate: null,
                                            order: '1'
                                        }
                                    ]
                                },
                                kind: 'init',
                                order: '2'
                            },
                            {
                                type: 'ExpressionStatement',
                                expression: {
                                    type: 'ObjectExpression',
                                    objectType: {
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'Identifier',
                                            name: 'Div',
                                            loc: {
                                                start: {
                                                    line: 20,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                },
                                                end: {
                                                    line: 20,
                                                    column: 11,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                }
                                            }
                                        },
                                        arguments: [{
                                                type: 'ObjectExpression',
                                                properties: [{
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'class',
                                                            loc: {
                                                                start: {
                                                                    line: 20,
                                                                    column: 13,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                },
                                                                end: {
                                                                    line: 20,
                                                                    column: 18,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Literal',
                                                            value: 'cells'
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    }]
                                            }],
                                        loc: {
                                            start: {
                                                line: 20,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                            },
                                            end: {
                                                line: 20,
                                                column: 28,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                            }
                                        }
                                    },
                                    properties: [{
                                            type: 'ForOfStatement',
                                            left: {
                                                type: 'VariableDeclaration',
                                                declarations: [{
                                                        type: 'VariableDeclarator',
                                                        id: {
                                                            type: 'Identifier',
                                                            name: 'column',
                                                            loc: {
                                                                start: {
                                                                    line: 21,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                },
                                                                end: {
                                                                    line: 21,
                                                                    column: 22,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                }
                                                            }
                                                        },
                                                        init: null
                                                    }],
                                                kind: 'let'
                                            },
                                            right: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'dataTableModel',
                                                    loc: {
                                                        start: {
                                                            line: 21,
                                                            column: 26,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        },
                                                        end: {
                                                            line: 21,
                                                            column: 40,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'columns',
                                                    loc: {
                                                        start: {
                                                            line: 21,
                                                            column: 41,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        },
                                                        end: {
                                                            line: 21,
                                                            column: 48,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 21,
                                                        column: 26,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                    },
                                                    end: {
                                                        line: 21,
                                                        column: 48,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                    }
                                                }
                                            },
                                            body: {
                                                type: 'BlockStatement',
                                                body: [
                                                    {
                                                        type: 'VariableDeclaration',
                                                        declarations: [{
                                                                type: 'VariableDeclarator',
                                                                id: {
                                                                    type: 'Identifier',
                                                                    name: 'cell',
                                                                    loc: {
                                                                        start: {
                                                                            line: 22,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                        },
                                                                        end: {
                                                                            line: 22,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                        }
                                                                    }
                                                                },
                                                                init: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'column',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 22,
                                                                                    column: 27,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 22,
                                                                                    column: 33,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'createBodyCell',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 22,
                                                                                    column: 34,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 22,
                                                                                    column: 48,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 22,
                                                                                column: 27,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                            },
                                                                            end: {
                                                                                line: 22,
                                                                                column: 48,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [{
                                                                            type: 'Identifier',
                                                                            name: 'rowModel',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 22,
                                                                                    column: 49,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 22,
                                                                                    column: 57,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                }
                                                                            }
                                                                        }],
                                                                    loc: {
                                                                        start: {
                                                                            line: 22,
                                                                            column: 27,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                        },
                                                                        end: {
                                                                            line: 22,
                                                                            column: 58,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                        }
                                                                    }
                                                                }
                                                            }],
                                                        kind: 'let',
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'Identifier',
                                                            name: 'cell',
                                                            loc: {
                                                                start: {
                                                                    line: 23,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                },
                                                                end: {
                                                                    line: 23,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 23,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                            },
                                                            end: {
                                                                line: 23,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                            }
                                                        },
                                                        order: '1'
                                                    },
                                                    {
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Function',
                                                                context: true,
                                                                value: function (_context) {
                                                                    return function () {
                                                                        var cell = _context.get('cell'), column = _context.get('column'), rowModel = _context.get('rowModel'), dataTable = _context.get('dataTable');
                                                                        cell.column = column;
                                                                        cell.rowModel = rowModel;
                                                                        cell.dataTable = dataTable;
                                                                    };
                                                                }
                                                            },
                                                            arguments: [],
                                                            loc: {
                                                                start: {
                                                                    line: 24,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                },
                                                                end: {
                                                                    line: 28,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 24,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                            },
                                                            end: {
                                                                line: 28,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                            }
                                                        },
                                                        order: '2'
                                                    }
                                                ]
                                            },
                                            remove: null,
                                            order: '0'
                                        }]
                                },
                                loc: {
                                    start: {
                                        line: 20,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    },
                                    end: {
                                        line: 28,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    }
                                },
                                order: '3'
                            },
                            {
                                type: 'IfStatement',
                                test: {
                                    type: 'UnaryExpression',
                                    operator: '?',
                                    argument: {
                                        type: 'Identifier',
                                        name: 'rowContent',
                                        loc: {
                                            start: {
                                                line: 28,
                                                column: 11,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                            },
                                            end: {
                                                line: 28,
                                                column: 21,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                            }
                                        }
                                    }
                                },
                                consequent: {
                                    type: 'BlockStatement',
                                    body: [{
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'rowContent',
                                                    loc: {
                                                        start: {
                                                            line: 29,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        },
                                                        end: {
                                                            line: 29,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [{
                                                        type: 'ObjectExpression',
                                                        properties: [
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'dataTable',
                                                                    loc: {
                                                                        start: {
                                                                            line: 29,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                        },
                                                                        end: {
                                                                            line: 29,
                                                                            column: 33,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Identifier',
                                                                    name: 'dataTable',
                                                                    loc: {
                                                                        start: {
                                                                            line: 29,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                        },
                                                                        end: {
                                                                            line: 29,
                                                                            column: 33,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                        }
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'rowModel',
                                                                    loc: {
                                                                        start: {
                                                                            line: 29,
                                                                            column: 35,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                        },
                                                                        end: {
                                                                            line: 29,
                                                                            column: 43,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Identifier',
                                                                    name: 'rowModel',
                                                                    loc: {
                                                                        start: {
                                                                            line: 29,
                                                                            column: 35,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                        },
                                                                        end: {
                                                                            line: 29,
                                                                            column: 43,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                        }
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '1'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'index',
                                                                    loc: {
                                                                        start: {
                                                                            line: 29,
                                                                            column: 45,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                        },
                                                                        end: {
                                                                            line: 29,
                                                                            column: 50,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Identifier',
                                                                    name: 'index',
                                                                    loc: {
                                                                        start: {
                                                                            line: 29,
                                                                            column: 45,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                        },
                                                                        end: {
                                                                            line: 29,
                                                                            column: 50,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                        }
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '2'
                                                            }
                                                        ]
                                                    }],
                                                loc: {
                                                    start: {
                                                        line: 29,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                    },
                                                    end: {
                                                        line: 29,
                                                        column: 52,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 29,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                },
                                                end: {
                                                    line: 29,
                                                    column: 52,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                }
                                            },
                                            order: '0'
                                        }]
                                },
                                alternate: null,
                                order: '4'
                            },
                            {
                                type: 'IfStatement',
                                test: {
                                    type: 'BinaryExpression',
                                    operator: '&&',
                                    left: {
                                        type: 'Identifier',
                                        name: 'parent',
                                        loc: {
                                            start: {
                                                line: 30,
                                                column: 11,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                            },
                                            end: {
                                                line: 30,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                            }
                                        }
                                    },
                                    right: {
                                        type: 'Identifier',
                                        name: 'open',
                                        loc: {
                                            start: {
                                                line: 30,
                                                column: 22,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                            },
                                            end: {
                                                line: 30,
                                                column: 26,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                            }
                                        }
                                    }
                                },
                                consequent: {
                                    type: 'BlockStatement',
                                    body: [{
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'ObjectExpression',
                                                objectType: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'Identifier',
                                                        name: 'Div',
                                                        loc: {
                                                            start: {
                                                                line: 31,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                            },
                                                            end: {
                                                                line: 31,
                                                                column: 15,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [{
                                                            type: 'ObjectExpression',
                                                            properties: [{
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'class',
                                                                        loc: {
                                                                            start: {
                                                                                line: 31,
                                                                                column: 17,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                            },
                                                                            end: {
                                                                                line: 31,
                                                                                column: 22,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Literal',
                                                                        value: 'children'
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                }]
                                                        }],
                                                    loc: {
                                                        start: {
                                                            line: 31,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        },
                                                        end: {
                                                            line: 31,
                                                            column: 35,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        }
                                                    }
                                                },
                                                properties: [{
                                                        type: 'ForOfStatement',
                                                        left: {
                                                            type: 'VariableDeclaration',
                                                            declarations: [
                                                                {
                                                                    type: 'VariableDeclarator',
                                                                    id: {
                                                                        type: 'Identifier',
                                                                        name: 'childRow',
                                                                        loc: {
                                                                            start: {
                                                                                line: 32,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                            },
                                                                            end: {
                                                                                line: 32,
                                                                                column: 28,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    init: null
                                                                },
                                                                {
                                                                    type: 'VariableDeclarator',
                                                                    id: {
                                                                        type: 'Identifier',
                                                                        name: 'childIndex',
                                                                        loc: {
                                                                            start: {
                                                                                line: 32,
                                                                                column: 30,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                            },
                                                                            end: {
                                                                                line: 32,
                                                                                column: 40,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    init: null
                                                                }
                                                            ],
                                                            kind: 'let'
                                                        },
                                                        right: {
                                                            type: 'Identifier',
                                                            name: 'children',
                                                            loc: {
                                                                start: {
                                                                    line: 32,
                                                                    column: 44,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                },
                                                                end: {
                                                                    line: 32,
                                                                    column: 52,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                }
                                                            }
                                                        },
                                                        body: {
                                                            type: 'BlockStatement',
                                                            body: [{
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'Identifier',
                                                                            name: 'DataRow',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 33,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 33,
                                                                                    column: 27,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [{
                                                                                type: 'ObjectExpression',
                                                                                properties: [
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'dataTable',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 33,
                                                                                                    column: 29,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 33,
                                                                                                    column: 38,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Identifier',
                                                                                            name: 'dataTable',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 33,
                                                                                                    column: 29,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 33,
                                                                                                    column: 38,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'rowModel',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 33,
                                                                                                    column: 40,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 33,
                                                                                                    column: 48,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Identifier',
                                                                                            name: 'childRow',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 33,
                                                                                                    column: 49,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 33,
                                                                                                    column: 57,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '1'
                                                                                    },
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'index',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 33,
                                                                                                    column: 59,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 33,
                                                                                                    column: 64,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Identifier',
                                                                                            name: 'childIndex',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 33,
                                                                                                    column: 65,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 33,
                                                                                                    column: 75,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '2'
                                                                                    },
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'rowContent',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 33,
                                                                                                    column: 77,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 33,
                                                                                                    column: 87,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Identifier',
                                                                                            name: 'rowContent',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 33,
                                                                                                    column: 77,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 33,
                                                                                                    column: 87,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '3'
                                                                                    }
                                                                                ]
                                                                            }],
                                                                        loc: {
                                                                            start: {
                                                                                line: 33,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                            },
                                                                            end: {
                                                                                line: 33,
                                                                                column: 89,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 33,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                        },
                                                                        end: {
                                                                            line: 33,
                                                                            column: 89,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                        }
                                                                    },
                                                                    order: '0'
                                                                }]
                                                        },
                                                        remove: null,
                                                        order: '0'
                                                    }]
                                            },
                                            loc: {
                                                start: {
                                                    line: 31,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                },
                                                end: {
                                                    line: 35,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                }
                                            },
                                            order: '0'
                                        }]
                                },
                                alternate: null,
                                order: '5'
                            }
                        ]
                    },
                    order: ':'
                }
            ],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'DataRow',
                loc: {
                    start: {
                        line: 9,
                        column: 6,
                        fixed: true,
                        source: 'glass/html/material/DataTable2/DataTable.ion'
                    },
                    end: {
                        line: 9,
                        column: 13,
                        fixed: true,
                        source: 'glass/html/material/DataTable2/DataTable.ion'
                    }
                }
            }
        }, {
            this: this,
            _ref4: _ref4,
            _ref: _ref,
            _ref2: _ref2,
            _ref3: _ref3,
            CutCopyPasteSupport: CutCopyPasteSupport,
            NavigateAndEditSupport: NavigateAndEditSupport,
            style: style,
            selectOpacity: selectOpacity,
            makeElementAutoEdgeScroll: makeElementAutoEdgeScroll,
            DataRow: DataRow
        }, null);
    });
module.exports = exports = ion.template(function DataTable(_ref6) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'DataTable',
            loc: {
                start: {
                    line: 35,
                    column: 16,
                    fixed: true,
                    source: 'glass/html/material/DataTable2/DataTable.ion'
                },
                end: {
                    line: 35,
                    column: 25,
                    fixed: true,
                    source: 'glass/html/material/DataTable2/DataTable.ion'
                }
            }
        },
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'dataTableModel',
                            loc: {
                                start: {
                                    line: 35,
                                    column: 33,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                },
                                end: {
                                    line: 35,
                                    column: 47,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref6'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'model',
                                loc: {
                                    start: {
                                        line: 35,
                                        column: 27,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    },
                                    end: {
                                        line: 35,
                                        column: 32,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'rowContent',
                            loc: {
                                start: {
                                    line: 35,
                                    column: 48,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                },
                                end: {
                                    line: 35,
                                    column: 58,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref6'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'rowContent',
                                loc: {
                                    start: {
                                        line: 35,
                                        column: 48,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    },
                                    end: {
                                        line: 35,
                                        column: 58,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: '_ref7'
                        },
                        init: {
                            type: 'Identifier',
                            name: 'dataTableModel',
                            loc: {
                                start: {
                                    line: 36,
                                    column: 77,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                },
                                end: {
                                    line: 36,
                                    column: 91,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'id',
                            loc: {
                                start: {
                                    line: 36,
                                    column: 9,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                },
                                end: {
                                    line: 36,
                                    column: 11,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref7'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'id',
                                loc: {
                                    start: {
                                        line: 36,
                                        column: 9,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    },
                                    end: {
                                        line: 36,
                                        column: 11,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '3'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'rowSource',
                            loc: {
                                start: {
                                    line: 36,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                },
                                end: {
                                    line: 36,
                                    column: 22,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref7'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'rowSource',
                                loc: {
                                    start: {
                                        line: 36,
                                        column: 13,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    },
                                    end: {
                                        line: 36,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '4'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'columnSource',
                            loc: {
                                start: {
                                    line: 36,
                                    column: 24,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                },
                                end: {
                                    line: 36,
                                    column: 36,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref7'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'columnSource',
                                loc: {
                                    start: {
                                        line: 36,
                                        column: 24,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    },
                                    end: {
                                        line: 36,
                                        column: 36,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '5'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'columnStateId',
                            loc: {
                                start: {
                                    line: 36,
                                    column: 38,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                },
                                end: {
                                    line: 36,
                                    column: 51,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref7'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'columnStateId',
                                loc: {
                                    start: {
                                        line: 36,
                                        column: 38,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    },
                                    end: {
                                        line: 36,
                                        column: 51,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '6'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'columnState',
                            loc: {
                                start: {
                                    line: 36,
                                    column: 53,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                },
                                end: {
                                    line: 36,
                                    column: 64,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref7'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'columnState',
                                loc: {
                                    start: {
                                        line: 36,
                                        column: 53,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    },
                                    end: {
                                        line: 36,
                                        column: 64,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '7'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'columns',
                            loc: {
                                start: {
                                    line: 36,
                                    column: 66,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                },
                                end: {
                                    line: 36,
                                    column: 73,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref7'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'columns',
                                loc: {
                                    start: {
                                        line: 36,
                                        column: 66,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    },
                                    end: {
                                        line: 36,
                                        column: 73,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '8'
            },
            {
                type: 'ExpressionStatement',
                expression: {
                    type: 'CallExpression',
                    callee: {
                        type: 'Function',
                        context: true,
                        value: function (_context2) {
                            return function () {
                                var dataTableModel = _context2.get('dataTableModel');
                                return dataTableModel.refresh();
                            };
                        }
                    },
                    arguments: [],
                    loc: {
                        start: {
                            line: 39,
                            column: 4,
                            fixed: true,
                            source: 'glass/html/material/DataTable2/DataTable.ion'
                        },
                        end: {
                            line: 39,
                            column: 34,
                            fixed: true,
                            source: 'glass/html/material/DataTable2/DataTable.ion'
                        }
                    }
                },
                loc: {
                    start: {
                        line: 39,
                        column: 4,
                        fixed: true,
                        source: 'glass/html/material/DataTable2/DataTable.ion'
                    },
                    end: {
                        line: 39,
                        column: 34,
                        fixed: true,
                        source: 'glass/html/material/DataTable2/DataTable.ion'
                    }
                },
                order: '9'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'createAllColumnsCss',
                            loc: {
                                start: {
                                    line: 41,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                },
                                end: {
                                    line: 41,
                                    column: 27,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                }
                            }
                        },
                        init: {
                            type: 'Function',
                            context: true,
                            value: function (_context3) {
                                return function (state, columns) {
                                    var dataTableModel = _context3.get('dataTableModel'), id = _context3.get('id'), columnStateId = _context3.get('columnStateId'), selectOpacity = _context3.get('selectOpacity');
                                    var sheets = [];
                                    {
                                        var _ref8 = dataTableModel.columns;
                                        for (var _i = 0; _i < _ref8.length; _i++) {
                                            var index = _i;
                                            var column = _ref8[_i];
                                            var rules = column.createCssRules(dataTableModel);
                                            var width = column.width;
                                            sheets.push('.DataTable2[id=' + id + '].' + columnStateId + ' .cells > Span:nth-of-type(' + (index + 1) + ') {\n    ' + (typeof rules === 'string' ? rules : '') + '\n    min-width:' + (width + 'px') + ';\n    width:' + (width + 'px') + ';\n}');
                                            for (var path in rules) {
                                                var rule = rules[path];
                                                sheets.push('.DataTable2[id=' + id + '].' + columnStateId + ' .cells > Span:nth-of-type(' + (index + 1) + ') ' + path + ' {\n    ' + rule + '\n}');
                                            }
                                            if (column.selected) {
                                                sheets.push('.DataTable2[id=' + id + '].' + columnStateId + '.colmode .cells > Span:nth-of-type(' + (index + 1) + '),\n.DataTable2[id=' + id + '].' + columnStateId + ' .row.selected > .cells > Span:nth-of-type(' + (index + 1) + ') {\n    background: rgba(0,0,0,' + selectOpacity * 1 + ');\n}');
                                            }
                                        }
                                    }
                                    return sheets.join('\n');
                                };
                            }
                        }
                    }],
                kind: 'let',
                order: ':'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'allColumnsCss',
                            loc: {
                                start: {
                                    line: 72,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                },
                                end: {
                                    line: 72,
                                    column: 21,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'createAllColumnsCss',
                                loc: {
                                    start: {
                                        line: 72,
                                        column: 24,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    },
                                    end: {
                                        line: 72,
                                        column: 43,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    }
                                }
                            },
                            arguments: [
                                {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'dataTableModel',
                                        loc: {
                                            start: {
                                                line: 72,
                                                column: 49,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                            },
                                            end: {
                                                line: 72,
                                                column: 63,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'state',
                                        loc: {
                                            start: {
                                                line: 72,
                                                column: 64,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                            },
                                            end: {
                                                line: 72,
                                                column: 69,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 72,
                                            column: 49,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                        },
                                        end: {
                                            line: 72,
                                            column: 69,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                        }
                                    },
                                    deep: true
                                },
                                {
                                    type: 'Identifier',
                                    name: 'columns',
                                    loc: {
                                        start: {
                                            line: 72,
                                            column: 71,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                        },
                                        end: {
                                            line: 72,
                                            column: 78,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                        }
                                    }
                                }
                            ],
                            loc: {
                                start: {
                                    line: 72,
                                    column: 24,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                },
                                end: {
                                    line: 72,
                                    column: 79,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: ';'
            },
            {
                type: 'ExpressionStatement',
                expression: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'MemberExpression',
                        computed: false,
                        object: {
                            type: 'Identifier',
                            name: 'style',
                            loc: {
                                start: {
                                    line: 73,
                                    column: 4,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                },
                                end: {
                                    line: 73,
                                    column: 9,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                }
                            }
                        },
                        property: {
                            type: 'Identifier',
                            name: 'sheets',
                            loc: {
                                start: {
                                    line: 73,
                                    column: 10,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                },
                                end: {
                                    line: 73,
                                    column: 16,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                }
                            }
                        },
                        loc: {
                            start: {
                                line: 73,
                                column: 4,
                                fixed: true,
                                source: 'glass/html/material/DataTable2/DataTable.ion'
                            },
                            end: {
                                line: 73,
                                column: 16,
                                fixed: true,
                                source: 'glass/html/material/DataTable2/DataTable.ion'
                            }
                        }
                    },
                    properties: [{
                            type: 'Property',
                            key: {
                                type: 'BinaryExpression',
                                operator: '+',
                                left: {
                                    type: 'BinaryExpression',
                                    operator: '+',
                                    left: {
                                        type: 'BinaryExpression',
                                        operator: '+',
                                        left: {
                                            type: 'Literal',
                                            value: ''
                                        },
                                        right: {
                                            type: 'Identifier',
                                            name: 'id',
                                            loc: {
                                                start: {
                                                    line: 74,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                },
                                                end: {
                                                    line: 74,
                                                    column: 14,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                }
                                            }
                                        }
                                    },
                                    right: {
                                        type: 'Literal',
                                        value: '_'
                                    }
                                },
                                right: {
                                    type: 'Identifier',
                                    name: 'columnStateId',
                                    loc: {
                                        start: {
                                            line: 74,
                                            column: 19,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                        },
                                        end: {
                                            line: 74,
                                            column: 32,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                        }
                                    }
                                }
                            },
                            value: {
                                type: 'Identifier',
                                name: 'allColumnsCss',
                                loc: {
                                    start: {
                                        line: 74,
                                        column: 38,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    },
                                    end: {
                                        line: 74,
                                        column: 51,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    }
                                }
                            },
                            kind: 'init',
                            computed: true,
                            order: '0'
                        }]
                },
                loc: {
                    start: {
                        line: 73,
                        column: 4,
                        fixed: true,
                        source: 'glass/html/material/DataTable2/DataTable.ion'
                    },
                    end: {
                        line: 76,
                        column: 8,
                        fixed: true,
                        source: 'glass/html/material/DataTable2/DataTable.ion'
                    }
                },
                order: '<'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'header',
                            loc: {
                                start: {
                                    line: 76,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                },
                                end: {
                                    line: 76,
                                    column: 14,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Div',
                                loc: {
                                    start: {
                                        line: 76,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    },
                                    end: {
                                        line: 76,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ObjectExpression',
                                    properties: [{
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'class',
                                                loc: {
                                                    start: {
                                                        line: 76,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                    },
                                                    end: {
                                                        line: 76,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: 'header'
                                            },
                                            kind: 'init',
                                            order: '0'
                                        }]
                                }],
                            loc: {
                                start: {
                                    line: 76,
                                    column: 17,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                },
                                end: {
                                    line: 76,
                                    column: 38,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '='
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'body',
                            loc: {
                                start: {
                                    line: 77,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                },
                                end: {
                                    line: 77,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Div',
                                loc: {
                                    start: {
                                        line: 77,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    },
                                    end: {
                                        line: 77,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ObjectExpression',
                                    properties: [{
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'class',
                                                loc: {
                                                    start: {
                                                        line: 77,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                    },
                                                    end: {
                                                        line: 77,
                                                        column: 25,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: 'body'
                                            },
                                            kind: 'init',
                                            order: '0'
                                        }]
                                }],
                            loc: {
                                start: {
                                    line: 77,
                                    column: 15,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                },
                                end: {
                                    line: 77,
                                    column: 34,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '>'
            },
            {
                type: 'ExpressionStatement',
                expression: {
                    type: 'CallExpression',
                    callee: {
                        type: 'Function',
                        context: true,
                        value: function (_context4) {
                            return function () {
                                var makeElementAutoEdgeScroll = _context4.get('makeElementAutoEdgeScroll'), body = _context4.get('body');
                                makeElementAutoEdgeScroll(body);
                            };
                        }
                    },
                    arguments: [],
                    loc: {
                        start: {
                            line: 78,
                            column: 4,
                            fixed: true,
                            source: 'glass/html/material/DataTable2/DataTable.ion'
                        },
                        end: {
                            line: 80,
                            column: 8,
                            fixed: true,
                            source: 'glass/html/material/DataTable2/DataTable.ion'
                        }
                    }
                },
                loc: {
                    start: {
                        line: 78,
                        column: 4,
                        fixed: true,
                        source: 'glass/html/material/DataTable2/DataTable.ion'
                    },
                    end: {
                        line: 80,
                        column: 8,
                        fixed: true,
                        source: 'glass/html/material/DataTable2/DataTable.ion'
                    }
                },
                order: '?'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'footer',
                            loc: {
                                start: {
                                    line: 80,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                },
                                end: {
                                    line: 80,
                                    column: 14,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Div',
                                loc: {
                                    start: {
                                        line: 80,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    },
                                    end: {
                                        line: 80,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ObjectExpression',
                                    properties: [{
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'class',
                                                loc: {
                                                    start: {
                                                        line: 80,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                    },
                                                    end: {
                                                        line: 80,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: 'footer'
                                            },
                                            kind: 'init',
                                            order: '0'
                                        }]
                                }],
                            loc: {
                                start: {
                                    line: 80,
                                    column: 17,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                },
                                end: {
                                    line: 80,
                                    column: 38,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '@'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'dataTable',
                            loc: {
                                start: {
                                    line: 81,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                },
                                end: {
                                    line: 81,
                                    column: 17,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Div',
                                loc: {
                                    start: {
                                        line: 81,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    },
                                    end: {
                                        line: 81,
                                        column: 23,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ObjectExpression',
                                    properties: [{
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'class',
                                                loc: {
                                                    start: {
                                                        line: 81,
                                                        column: 25,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                    },
                                                    end: {
                                                        line: 81,
                                                        column: 30,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: 'DataTable2'
                                            },
                                            kind: 'init',
                                            order: '0'
                                        }]
                                }],
                            loc: {
                                start: {
                                    line: 81,
                                    column: 20,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                },
                                end: {
                                    line: 81,
                                    column: 45,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: 'A'
            },
            {
                type: 'ExpressionStatement',
                expression: {
                    type: 'CallExpression',
                    callee: {
                        type: 'Identifier',
                        name: 'CutCopyPasteSupport',
                        loc: {
                            start: {
                                line: 84,
                                column: 4,
                                fixed: true,
                                source: 'glass/html/material/DataTable2/DataTable.ion'
                            },
                            end: {
                                line: 84,
                                column: 23,
                                fixed: true,
                                source: 'glass/html/material/DataTable2/DataTable.ion'
                            }
                        }
                    },
                    arguments: [{
                            type: 'Identifier',
                            name: 'dataTable',
                            loc: {
                                start: {
                                    line: 84,
                                    column: 24,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                },
                                end: {
                                    line: 84,
                                    column: 33,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                }
                            }
                        }],
                    loc: {
                        start: {
                            line: 84,
                            column: 4,
                            fixed: true,
                            source: 'glass/html/material/DataTable2/DataTable.ion'
                        },
                        end: {
                            line: 84,
                            column: 34,
                            fixed: true,
                            source: 'glass/html/material/DataTable2/DataTable.ion'
                        }
                    }
                },
                loc: {
                    start: {
                        line: 84,
                        column: 4,
                        fixed: true,
                        source: 'glass/html/material/DataTable2/DataTable.ion'
                    },
                    end: {
                        line: 84,
                        column: 34,
                        fixed: true,
                        source: 'glass/html/material/DataTable2/DataTable.ion'
                    }
                },
                order: 'B'
            },
            {
                type: 'ExpressionStatement',
                expression: {
                    type: 'CallExpression',
                    callee: {
                        type: 'Identifier',
                        name: 'NavigateAndEditSupport',
                        loc: {
                            start: {
                                line: 86,
                                column: 4,
                                fixed: true,
                                source: 'glass/html/material/DataTable2/DataTable.ion'
                            },
                            end: {
                                line: 86,
                                column: 26,
                                fixed: true,
                                source: 'glass/html/material/DataTable2/DataTable.ion'
                            }
                        }
                    },
                    arguments: [{
                            type: 'Identifier',
                            name: 'dataTable',
                            loc: {
                                start: {
                                    line: 86,
                                    column: 27,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                },
                                end: {
                                    line: 86,
                                    column: 36,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                }
                            }
                        }],
                    loc: {
                        start: {
                            line: 86,
                            column: 4,
                            fixed: true,
                            source: 'glass/html/material/DataTable2/DataTable.ion'
                        },
                        end: {
                            line: 86,
                            column: 37,
                            fixed: true,
                            source: 'glass/html/material/DataTable2/DataTable.ion'
                        }
                    }
                },
                loc: {
                    start: {
                        line: 86,
                        column: 4,
                        fixed: true,
                        source: 'glass/html/material/DataTable2/DataTable.ion'
                    },
                    end: {
                        line: 86,
                        column: 37,
                        fixed: true,
                        source: 'glass/html/material/DataTable2/DataTable.ion'
                    }
                },
                order: 'C'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'Identifier',
                        name: 'dataTable',
                        loc: {
                            start: {
                                line: 88,
                                column: 11,
                                fixed: true,
                                source: 'glass/html/material/DataTable2/DataTable.ion'
                            },
                            end: {
                                line: 88,
                                column: 20,
                                fixed: true,
                                source: 'glass/html/material/DataTable2/DataTable.ion'
                            }
                        }
                    },
                    properties: [
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'id',
                                loc: {
                                    start: {
                                        line: 89,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    },
                                    end: {
                                        line: 89,
                                        column: 10,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Identifier',
                                name: 'id',
                                loc: {
                                    start: {
                                        line: 89,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    },
                                    end: {
                                        line: 89,
                                        column: 14,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    }
                                }
                            },
                            kind: 'init',
                            order: '0'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'model',
                                loc: {
                                    start: {
                                        line: 90,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    },
                                    end: {
                                        line: 90,
                                        column: 13,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Identifier',
                                name: 'dataTableModel',
                                loc: {
                                    start: {
                                        line: 90,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    },
                                    end: {
                                        line: 90,
                                        column: 29,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    }
                                }
                            },
                            kind: 'init',
                            order: '1'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'classList',
                                loc: {
                                    start: {
                                        line: 91,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    },
                                    end: {
                                        line: 91,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'ObjectExpression',
                                properties: [
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'dataTableModel',
                                                loc: {
                                                    start: {
                                                        line: 92,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                    },
                                                    end: {
                                                        line: 92,
                                                        column: 26,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'columnStateId',
                                                loc: {
                                                    start: {
                                                        line: 92,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                    },
                                                    end: {
                                                        line: 92,
                                                        column: 40,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 92,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                },
                                                end: {
                                                    line: 92,
                                                    column: 40,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 92,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                            },
                                            end: {
                                                line: 92,
                                                column: 40,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                            }
                                        },
                                        order: '0'
                                    },
                                    {
                                        type: 'IfStatement',
                                        test: {
                                            type: 'BinaryExpression',
                                            operator: '>',
                                            left: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'body',
                                                    loc: {
                                                        start: {
                                                            line: 93,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        },
                                                        end: {
                                                            line: 93,
                                                            column: 19,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'scrollHeight',
                                                    loc: {
                                                        start: {
                                                            line: 93,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        },
                                                        end: {
                                                            line: 93,
                                                            column: 32,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 93,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                    },
                                                    end: {
                                                        line: 93,
                                                        column: 32,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                    }
                                                }
                                            },
                                            right: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'body',
                                                    loc: {
                                                        start: {
                                                            line: 93,
                                                            column: 35,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        },
                                                        end: {
                                                            line: 93,
                                                            column: 39,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'clientHeight',
                                                    loc: {
                                                        start: {
                                                            line: 93,
                                                            column: 40,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        },
                                                        end: {
                                                            line: 93,
                                                            column: 52,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 93,
                                                        column: 35,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                    },
                                                    end: {
                                                        line: 93,
                                                        column: 52,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                    }
                                                }
                                            }
                                        },
                                        consequent: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'Literal',
                                                        value: 'scroll-vertical'
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 94,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        },
                                                        end: {
                                                            line: 94,
                                                            column: 33,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        alternate: null,
                                        order: '1'
                                    },
                                    {
                                        type: 'IfStatement',
                                        test: {
                                            type: 'BinaryExpression',
                                            operator: '>',
                                            left: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'body',
                                                    loc: {
                                                        start: {
                                                            line: 95,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        },
                                                        end: {
                                                            line: 95,
                                                            column: 19,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'scrollWidth',
                                                    loc: {
                                                        start: {
                                                            line: 95,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        },
                                                        end: {
                                                            line: 95,
                                                            column: 31,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 95,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                    },
                                                    end: {
                                                        line: 95,
                                                        column: 31,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                    }
                                                }
                                            },
                                            right: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'body',
                                                    loc: {
                                                        start: {
                                                            line: 95,
                                                            column: 34,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        },
                                                        end: {
                                                            line: 95,
                                                            column: 38,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'clientWidth',
                                                    loc: {
                                                        start: {
                                                            line: 95,
                                                            column: 39,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        },
                                                        end: {
                                                            line: 95,
                                                            column: 50,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 95,
                                                        column: 34,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                    },
                                                    end: {
                                                        line: 95,
                                                        column: 50,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                    }
                                                }
                                            }
                                        },
                                        consequent: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'Literal',
                                                        value: 'scroll-horizontal'
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 96,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        },
                                                        end: {
                                                            line: 96,
                                                            column: 35,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        alternate: null,
                                        order: '2'
                                    },
                                    {
                                        type: 'IfStatement',
                                        test: {
                                            type: 'BinaryExpression',
                                            operator: '===',
                                            left: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'body',
                                                    loc: {
                                                        start: {
                                                            line: 97,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        },
                                                        end: {
                                                            line: 97,
                                                            column: 19,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'scrollTop',
                                                    loc: {
                                                        start: {
                                                            line: 97,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        },
                                                        end: {
                                                            line: 97,
                                                            column: 29,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 97,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                    },
                                                    end: {
                                                        line: 97,
                                                        column: 29,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                    }
                                                }
                                            },
                                            right: {
                                                type: 'Literal',
                                                value: 0
                                            }
                                        },
                                        consequent: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'Literal',
                                                        value: 'top-visible'
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 98,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        },
                                                        end: {
                                                            line: 98,
                                                            column: 29,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        alternate: null,
                                        order: '3'
                                    },
                                    {
                                        type: 'IfStatement',
                                        test: {
                                            type: 'BinaryExpression',
                                            operator: '===',
                                            left: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'body',
                                                    loc: {
                                                        start: {
                                                            line: 99,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        },
                                                        end: {
                                                            line: 99,
                                                            column: 19,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'scrollTop',
                                                    loc: {
                                                        start: {
                                                            line: 99,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        },
                                                        end: {
                                                            line: 99,
                                                            column: 29,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 99,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                    },
                                                    end: {
                                                        line: 99,
                                                        column: 29,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                    }
                                                }
                                            },
                                            right: {
                                                type: 'BinaryExpression',
                                                operator: '-',
                                                left: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'body',
                                                        loc: {
                                                            start: {
                                                                line: 99,
                                                                column: 34,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                            },
                                                            end: {
                                                                line: 99,
                                                                column: 38,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'scrollHeight',
                                                        loc: {
                                                            start: {
                                                                line: 99,
                                                                column: 39,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                            },
                                                            end: {
                                                                line: 99,
                                                                column: 51,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 99,
                                                            column: 34,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        },
                                                        end: {
                                                            line: 99,
                                                            column: 51,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        }
                                                    }
                                                },
                                                right: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'body',
                                                        loc: {
                                                            start: {
                                                                line: 99,
                                                                column: 54,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                            },
                                                            end: {
                                                                line: 99,
                                                                column: 58,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'offsetHeight',
                                                        loc: {
                                                            start: {
                                                                line: 99,
                                                                column: 59,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                            },
                                                            end: {
                                                                line: 99,
                                                                column: 71,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 99,
                                                            column: 54,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        },
                                                        end: {
                                                            line: 99,
                                                            column: 71,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        }
                                                    }
                                                }
                                            }
                                        },
                                        consequent: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'Literal',
                                                        value: 'bottom-visible'
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 100,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        },
                                                        end: {
                                                            line: 100,
                                                            column: 32,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        alternate: null,
                                        order: '4'
                                    },
                                    {
                                        type: 'IfStatement',
                                        test: {
                                            type: 'BinaryExpression',
                                            operator: '===',
                                            left: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'dataTableModel',
                                                        loc: {
                                                            start: {
                                                                line: 101,
                                                                column: 15,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                            },
                                                            end: {
                                                                line: 101,
                                                                column: 29,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'selectedColumns',
                                                        loc: {
                                                            start: {
                                                                line: 101,
                                                                column: 30,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                            },
                                                            end: {
                                                                line: 101,
                                                                column: 45,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 101,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        },
                                                        end: {
                                                            line: 101,
                                                            column: 45,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'length',
                                                    loc: {
                                                        start: {
                                                            line: 101,
                                                            column: 46,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        },
                                                        end: {
                                                            line: 101,
                                                            column: 52,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 101,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                    },
                                                    end: {
                                                        line: 101,
                                                        column: 52,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                    }
                                                }
                                            },
                                            right: {
                                                type: 'Literal',
                                                value: 0
                                            }
                                        },
                                        consequent: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'Literal',
                                                        value: 'rowmode'
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 102,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        },
                                                        end: {
                                                            line: 102,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        alternate: null,
                                        order: '5'
                                    },
                                    {
                                        type: 'IfStatement',
                                        test: {
                                            type: 'BinaryExpression',
                                            operator: '===',
                                            left: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'dataTableModel',
                                                        loc: {
                                                            start: {
                                                                line: 103,
                                                                column: 15,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                            },
                                                            end: {
                                                                line: 103,
                                                                column: 29,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'selectedRows',
                                                        loc: {
                                                            start: {
                                                                line: 103,
                                                                column: 30,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                            },
                                                            end: {
                                                                line: 103,
                                                                column: 42,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 103,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        },
                                                        end: {
                                                            line: 103,
                                                            column: 42,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'length',
                                                    loc: {
                                                        start: {
                                                            line: 103,
                                                            column: 43,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        },
                                                        end: {
                                                            line: 103,
                                                            column: 49,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 103,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                    },
                                                    end: {
                                                        line: 103,
                                                        column: 49,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                    }
                                                }
                                            },
                                            right: {
                                                type: 'Literal',
                                                value: 0
                                            }
                                        },
                                        consequent: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'Literal',
                                                        value: 'colmode'
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 104,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        },
                                                        end: {
                                                            line: 104,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        alternate: null,
                                        order: '6'
                                    }
                                ]
                            },
                            kind: 'init',
                            order: '2'
                        },
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'Identifier',
                                    name: 'header',
                                    loc: {
                                        start: {
                                            line: 105,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                        },
                                        end: {
                                            line: 105,
                                            column: 14,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                        }
                                    }
                                },
                                properties: [
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'Function',
                                            context: true,
                                            value: function (_context5) {
                                                return function scroll(e) {
                                                    var body = _context5.get('body'), footer = _context5.get('footer');
                                                    body.scrollLeft = footer.scrollLeft = this.scrollLeft;
                                                };
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 106,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                            },
                                            end: {
                                                line: 108,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                            }
                                        },
                                        order: '0'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'ObjectExpression',
                                            objectType: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'Div',
                                                    loc: {
                                                        start: {
                                                            line: 108,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        },
                                                        end: {
                                                            line: 108,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [{
                                                        type: 'ObjectExpression',
                                                        properties: [{
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'class',
                                                                    loc: {
                                                                        start: {
                                                                            line: 108,
                                                                            column: 17,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                        },
                                                                        end: {
                                                                            line: 108,
                                                                            column: 22,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: 'row'
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            }]
                                                    }],
                                                loc: {
                                                    start: {
                                                        line: 108,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                    },
                                                    end: {
                                                        line: 108,
                                                        column: 30,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                    }
                                                }
                                            },
                                            properties: [{
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'Div',
                                                                loc: {
                                                                    start: {
                                                                        line: 109,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                    },
                                                                    end: {
                                                                        line: 109,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [{
                                                                    type: 'ObjectExpression',
                                                                    properties: [{
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'class',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 109,
                                                                                        column: 21,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 109,
                                                                                        column: 26,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'cells'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        }]
                                                                }],
                                                            loc: {
                                                                start: {
                                                                    line: 109,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                },
                                                                end: {
                                                                    line: 109,
                                                                    column: 36,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [{
                                                                type: 'ForOfStatement',
                                                                left: {
                                                                    type: 'VariableDeclaration',
                                                                    declarations: [{
                                                                            type: 'VariableDeclarator',
                                                                            id: {
                                                                                type: 'Identifier',
                                                                                name: 'column',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 110,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 110,
                                                                                        column: 30,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            init: null
                                                                        }],
                                                                    kind: 'let'
                                                                },
                                                                right: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'dataTableModel',
                                                                        loc: {
                                                                            start: {
                                                                                line: 110,
                                                                                column: 34,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                            },
                                                                            end: {
                                                                                line: 110,
                                                                                column: 48,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'columns',
                                                                        loc: {
                                                                            start: {
                                                                                line: 110,
                                                                                column: 49,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                            },
                                                                            end: {
                                                                                line: 110,
                                                                                column: 56,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 110,
                                                                            column: 34,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                        },
                                                                        end: {
                                                                            line: 110,
                                                                            column: 56,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                        }
                                                                    }
                                                                },
                                                                body: {
                                                                    type: 'BlockStatement',
                                                                    body: [{
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'CallExpression',
                                                                                callee: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'column',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 111,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 111,
                                                                                                column: 30,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'createHeaderCell',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 111,
                                                                                                column: 31,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 111,
                                                                                                column: 47,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 111,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 111,
                                                                                            column: 47,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                arguments: [{
                                                                                        type: 'Identifier',
                                                                                        name: 'dataTableModel',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 111,
                                                                                                column: 48,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 111,
                                                                                                column: 62,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                            }
                                                                                        }
                                                                                    }],
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 111,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 111,
                                                                                        column: 63,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 111,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 111,
                                                                                    column: 63,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                remove: null,
                                                                order: '0'
                                                            }]
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 109,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        },
                                                        end: {
                                                            line: 112,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        loc: {
                                            start: {
                                                line: 108,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                            },
                                            end: {
                                                line: 112,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                            }
                                        },
                                        order: '1'
                                    }
                                ]
                            },
                            loc: {
                                start: {
                                    line: 105,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                },
                                end: {
                                    line: 112,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                }
                            },
                            order: '3'
                        },
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'Identifier',
                                    name: 'body',
                                    loc: {
                                        start: {
                                            line: 112,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                        },
                                        end: {
                                            line: 112,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                        }
                                    }
                                },
                                properties: [
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'Function',
                                            context: true,
                                            value: function (_context6) {
                                                return function scroll(e) {
                                                    var header = _context6.get('header'), footer = _context6.get('footer');
                                                    header.scrollLeft = footer.scrollLeft = this.scrollLeft;
                                                };
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 113,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                            },
                                            end: {
                                                line: 115,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                            }
                                        },
                                        order: '0'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'ObjectExpression',
                                            objectType: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'Div',
                                                    loc: {
                                                        start: {
                                                            line: 116,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        },
                                                        end: {
                                                            line: 116,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [{
                                                        type: 'ObjectExpression',
                                                        properties: [{
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'class',
                                                                    loc: {
                                                                        start: {
                                                                            line: 116,
                                                                            column: 17,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                        },
                                                                        end: {
                                                                            line: 116,
                                                                            column: 22,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: 'underlay row'
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            }]
                                                    }],
                                                loc: {
                                                    start: {
                                                        line: 116,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                    },
                                                    end: {
                                                        line: 116,
                                                        column: 39,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                    }
                                                }
                                            },
                                            properties: [{
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'Div',
                                                                loc: {
                                                                    start: {
                                                                        line: 117,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                    },
                                                                    end: {
                                                                        line: 117,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [{
                                                                    type: 'ObjectExpression',
                                                                    properties: [{
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'class',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 117,
                                                                                        column: 21,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 117,
                                                                                        column: 26,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'cells'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        }]
                                                                }],
                                                            loc: {
                                                                start: {
                                                                    line: 117,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                },
                                                                end: {
                                                                    line: 117,
                                                                    column: 36,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [{
                                                                type: 'ForOfStatement',
                                                                left: {
                                                                    type: 'VariableDeclaration',
                                                                    declarations: [{
                                                                            type: 'VariableDeclarator',
                                                                            id: {
                                                                                type: 'Identifier',
                                                                                name: 'column',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 118,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 118,
                                                                                        column: 30,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            init: null
                                                                        }],
                                                                    kind: 'let'
                                                                },
                                                                right: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'dataTableModel',
                                                                        loc: {
                                                                            start: {
                                                                                line: 118,
                                                                                column: 34,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                            },
                                                                            end: {
                                                                                line: 118,
                                                                                column: 48,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'columns',
                                                                        loc: {
                                                                            start: {
                                                                                line: 118,
                                                                                column: 49,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                            },
                                                                            end: {
                                                                                line: 118,
                                                                                column: 56,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 118,
                                                                            column: 34,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                        },
                                                                        end: {
                                                                            line: 118,
                                                                            column: 56,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                        }
                                                                    }
                                                                },
                                                                body: {
                                                                    type: 'BlockStatement',
                                                                    body: [{
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'CallExpression',
                                                                                callee: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'column',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 119,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 119,
                                                                                                column: 30,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'createUnderlay',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 119,
                                                                                                column: 31,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 119,
                                                                                                column: 45,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 119,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 119,
                                                                                            column: 45,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                arguments: [
                                                                                    {
                                                                                        type: 'Identifier',
                                                                                        name: 'dataTableModel',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 119,
                                                                                                column: 46,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 119,
                                                                                                column: 60,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    {
                                                                                        type: 'ObjectExpression',
                                                                                        properties: [{
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'body',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 119,
                                                                                                            column: 63,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 119,
                                                                                                            column: 67,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'body',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 119,
                                                                                                            column: 63,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 119,
                                                                                                            column: 67,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '0'
                                                                                            }]
                                                                                    }
                                                                                ],
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 119,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 119,
                                                                                        column: 69,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 119,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 119,
                                                                                    column: 69,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                remove: null,
                                                                order: '0'
                                                            }]
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 117,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        },
                                                        end: {
                                                            line: 120,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        loc: {
                                            start: {
                                                line: 116,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                            },
                                            end: {
                                                line: 120,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                            }
                                        },
                                        order: '1'
                                    },
                                    {
                                        type: 'IfStatement',
                                        test: {
                                            type: 'UnaryExpression',
                                            operator: '?',
                                            argument: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'rowSource',
                                                    loc: {
                                                        start: {
                                                            line: 121,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        },
                                                        end: {
                                                            line: 121,
                                                            column: 24,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'rows',
                                                    loc: {
                                                        start: {
                                                            line: 121,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        },
                                                        end: {
                                                            line: 121,
                                                            column: 29,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 121,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                    },
                                                    end: {
                                                        line: 121,
                                                        column: 29,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                    }
                                                }
                                            }
                                        },
                                        consequent: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'ForOfStatement',
                                                    left: {
                                                        type: 'VariableDeclaration',
                                                        declarations: [
                                                            {
                                                                type: 'VariableDeclarator',
                                                                id: {
                                                                    type: 'Identifier',
                                                                    name: 'rowModel',
                                                                    loc: {
                                                                        start: {
                                                                            line: 122,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                        },
                                                                        end: {
                                                                            line: 122,
                                                                            column: 28,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                        }
                                                                    }
                                                                },
                                                                init: null
                                                            },
                                                            {
                                                                type: 'VariableDeclarator',
                                                                id: {
                                                                    type: 'Identifier',
                                                                    name: 'index',
                                                                    loc: {
                                                                        start: {
                                                                            line: 122,
                                                                            column: 30,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                        },
                                                                        end: {
                                                                            line: 122,
                                                                            column: 35,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                        }
                                                                    }
                                                                },
                                                                init: null
                                                            }
                                                        ],
                                                        kind: 'let'
                                                    },
                                                    right: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'dataTableModel',
                                                            loc: {
                                                                start: {
                                                                    line: 122,
                                                                    column: 39,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                },
                                                                end: {
                                                                    line: 122,
                                                                    column: 53,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'rows',
                                                            loc: {
                                                                start: {
                                                                    line: 122,
                                                                    column: 54,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                },
                                                                end: {
                                                                    line: 122,
                                                                    column: 58,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 122,
                                                                column: 39,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                            },
                                                            end: {
                                                                line: 122,
                                                                column: 58,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                            }
                                                        }
                                                    },
                                                    body: {
                                                        type: 'BlockStatement',
                                                        body: [{
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'Identifier',
                                                                        name: 'DataRow',
                                                                        loc: {
                                                                            start: {
                                                                                line: 123,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                            },
                                                                            end: {
                                                                                line: 123,
                                                                                column: 27,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [{
                                                                            type: 'ObjectExpression',
                                                                            properties: [
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'dataTable',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 123,
                                                                                                column: 29,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 123,
                                                                                                column: 38,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Identifier',
                                                                                        name: 'dataTable',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 123,
                                                                                                column: 29,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 123,
                                                                                                column: 38,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'rowModel',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 123,
                                                                                                column: 40,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 123,
                                                                                                column: 48,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Identifier',
                                                                                        name: 'rowModel',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 123,
                                                                                                column: 40,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 123,
                                                                                                column: 48,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '1'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'index',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 123,
                                                                                                column: 50,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 123,
                                                                                                column: 55,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Identifier',
                                                                                        name: 'index',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 123,
                                                                                                column: 50,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 123,
                                                                                                column: 55,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '2'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'rowContent',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 123,
                                                                                                column: 57,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 123,
                                                                                                column: 67,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Identifier',
                                                                                        name: 'rowContent',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 123,
                                                                                                column: 57,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 123,
                                                                                                column: 67,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '3'
                                                                                }
                                                                            ]
                                                                        }],
                                                                    loc: {
                                                                        start: {
                                                                            line: 123,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                        },
                                                                        end: {
                                                                            line: 123,
                                                                            column: 69,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 123,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                    },
                                                                    end: {
                                                                        line: 123,
                                                                        column: 69,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/DataTable.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    remove: null,
                                                    order: '0'
                                                }]
                                        },
                                        alternate: null,
                                        order: '2'
                                    }
                                ]
                            },
                            loc: {
                                start: {
                                    line: 112,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                },
                                end: {
                                    line: 124,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                }
                            },
                            order: '4'
                        },
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'Identifier',
                                    name: 'footer',
                                    loc: {
                                        start: {
                                            line: 124,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                        },
                                        end: {
                                            line: 124,
                                            column: 14,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTable.ion'
                                        }
                                    }
                                },
                                properties: []
                            },
                            loc: {
                                start: {
                                    line: 124,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                },
                                end: {
                                    line: 131,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTable.ion'
                                }
                            },
                            order: '5'
                        }
                    ]
                },
                order: 'D'
            }
        ],
        bound: false
    }, {
        this: this,
        _ref6: _ref6,
        _ref: _ref,
        _ref2: _ref2,
        _ref3: _ref3,
        CutCopyPasteSupport: CutCopyPasteSupport,
        NavigateAndEditSupport: NavigateAndEditSupport,
        style: style,
        selectOpacity: selectOpacity,
        makeElementAutoEdgeScroll: makeElementAutoEdgeScroll,
        DataRow: DataRow
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/DataTable2/DataTable',_glass_html_material_DataTable2_DataTable_);
    else
      _glass_html_material_DataTable2_DataTable_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_DataTable2_DataTable_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_DataTable2_DataTableModel_ = function(module,exports,require){'use strict';
var ion = require('ion'), _ref, getColumnType = require('./getColumnType');
_ref = require('../../../data');
var Schema = _ref.Schema;
var CustomColumnSource = ion.template(function (args) {
        return ion.createRuntime({
            type: 'Template',
            id: null,
            body: [
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: '_ref2'
                            },
                            init: {
                                type: 'Identifier',
                                name: 'args',
                                loc: {
                                    start: {
                                        line: 7,
                                        column: 68,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 7,
                                        column: 72,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '0'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'fixedColumnNames',
                                loc: {
                                    start: {
                                        line: 7,
                                        column: 9,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 7,
                                        column: 25,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref2'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'fixedColumnNames',
                                    loc: {
                                        start: {
                                            line: 7,
                                            column: 9,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 7,
                                            column: 25,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '1'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'defaultColumnNames',
                                loc: {
                                    start: {
                                        line: 7,
                                        column: 27,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 7,
                                        column: 45,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref2'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'defaultColumnNames',
                                    loc: {
                                        start: {
                                            line: 7,
                                            column: 27,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 7,
                                            column: 45,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '2'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'properties',
                                loc: {
                                    start: {
                                        line: 7,
                                        column: 47,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 7,
                                        column: 57,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref2'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'properties',
                                    loc: {
                                        start: {
                                            line: 7,
                                            column: 47,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 7,
                                            column: 57,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '3'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'state',
                                loc: {
                                    start: {
                                        line: 7,
                                        column: 59,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 7,
                                        column: 64,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref2'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'state',
                                    loc: {
                                        start: {
                                            line: 7,
                                            column: 59,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 7,
                                            column: 64,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '4'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'customColumnConfigs',
                                loc: {
                                    start: {
                                        line: 9,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 9,
                                        column: 27,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Function',
                                    context: true,
                                    value: function (_context) {
                                        return function () {
                                            var defaultColumnNames = _context.get('defaultColumnNames'), args = _context.get('args');
                                            var _ref45 = {};
                                            {
                                                for (var _i = 0; _i < defaultColumnNames.length; _i++) {
                                                    var nameOrObject = defaultColumnNames[_i];
                                                    if (typeof nameOrObject === 'object') {
                                                        _ref45[nameOrObject.name] = nameOrObject;
                                                    }
                                                }
                                                if (args.availableColumnNames != null) {
                                                    {
                                                        var _ref28 = args.availableColumnNames;
                                                        for (var _i2 = 0; _i2 < _ref28.length; _i2++) {
                                                            var nameOrObject = _ref28[_i2];
                                                            if (typeof nameOrObject === 'object') {
                                                                _ref45[nameOrObject.name] = nameOrObject;
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                            return _ref45;
                                        };
                                    }
                                },
                                arguments: [],
                                loc: {
                                    start: {
                                        line: 9,
                                        column: 30,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 19,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '5'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'availablePropertyNames',
                                loc: {
                                    start: {
                                        line: 19,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 19,
                                        column: 30,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Function',
                                    context: true,
                                    value: function (_context2) {
                                        return function (properties) {
                                            var fixedColumnNames = _context2.get('fixedColumnNames');
                                            var _ref19 = [];
                                            {
                                                var _ref29 = Object.keys(properties);
                                                for (var _i3 = 0; _i3 < _ref29.length; _i3++) {
                                                    var name = _ref29[_i3];
                                                    if (!fixedColumnNames.contains(name)) {
                                                        _ref19.push(name);
                                                    }
                                                }
                                            }
                                            return _ref19;
                                        };
                                    }
                                },
                                arguments: [{
                                        type: 'Identifier',
                                        name: 'properties',
                                        loc: {
                                            start: {
                                                line: 19,
                                                column: 37,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                            },
                                            end: {
                                                line: 19,
                                                column: 47,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                            }
                                        }
                                    }],
                                loc: {
                                    start: {
                                        line: 19,
                                        column: 33,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 19,
                                        column: 133,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '6'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'columnNameComparer',
                                loc: {
                                    start: {
                                        line: 20,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 20,
                                        column: 26,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'Function',
                                context: false,
                                value: function (a, b) {
                                    var getName = function (object) {
                                        return (object.name != null ? object.name.toLowerCase() : void 0) != null ? object.name.toLowerCase() : '';
                                    };
                                    return getName(a).localeCompare(getName(b));
                                }
                            }
                        }],
                    kind: 'let',
                    order: '7'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'availableColumnNames',
                                loc: {
                                    start: {
                                        line: 23,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 23,
                                        column: 28,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Function',
                                    context: true,
                                    value: function (_context3) {
                                        return function () {
                                            var args = _context3.get('args'), availablePropertyNames = _context3.get('availablePropertyNames'), defaultColumnNames = _context3.get('defaultColumnNames'), columnNameComparer = _context3.get('columnNameComparer');
                                            return Array.from(new Set((args.availableColumnNames != null ? args.availableColumnNames : []).concat(availablePropertyNames, defaultColumnNames)).values()).sort(columnNameComparer);
                                        };
                                    }
                                },
                                arguments: [],
                                loc: {
                                    start: {
                                        line: 23,
                                        column: 31,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 23,
                                        column: 175,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '8'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'insertColumn',
                                loc: {
                                    start: {
                                        line: 25,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 25,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'Function',
                                context: true,
                                value: function (_context4) {
                                    return function (name, insertAfterName) {
                                        var state = _context4.get('state'), defaultColumnNames = _context4.get('defaultColumnNames');
                                        state.customColumnNames = state.customColumnNames != null ? state.customColumnNames : defaultColumnNames.slice(0);
                                        if (!state.customColumnNames.contains(name)) {
                                            var index = state.customColumnNames.indexOf(insertAfterName);
                                            if (index < 0) {
                                                index = state.customColumnNames.length - 1;
                                            }
                                            state.customColumnNames.splice(index + 1, 0, name);
                                        }
                                    };
                                }
                            }
                        }],
                    kind: 'let',
                    order: '9'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'deleteColumn',
                                loc: {
                                    start: {
                                        line: 32,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 32,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'Function',
                                context: true,
                                value: function (_context5) {
                                    return function (name) {
                                        var state = _context5.get('state'), defaultColumnNames = _context5.get('defaultColumnNames');
                                        state.customColumnNames = state.customColumnNames != null ? state.customColumnNames : defaultColumnNames.slice(0);
                                        state.customColumnNames.remove(name);
                                    };
                                }
                            }
                        }],
                    kind: 'let',
                    order: ':'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'resetColumns',
                                loc: {
                                    start: {
                                        line: 35,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 35,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'Function',
                                context: true,
                                value: function (_context6) {
                                    return function () {
                                        var state = _context6.get('state');
                                        delete state.customColumnNames;
                                        delete state.customColumnWidths;
                                    };
                                }
                            }
                        }],
                    kind: 'let',
                    order: ';'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'moveColumns',
                                loc: {
                                    start: {
                                        line: 38,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 38,
                                        column: 19,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'Function',
                                context: true,
                                value: function (_context7) {
                                    return function (names, offset) {
                                        var state = _context7.get('state'), defaultColumnNames = _context7.get('defaultColumnNames');
                                        state.customColumnNames = state.customColumnNames != null ? state.customColumnNames : defaultColumnNames.slice(0);
                                        var index = state.customColumnNames.indexOf(names[0]);
                                        if (index >= 0 && (index + names.length < state.customColumnNames.length || offset < 0)) {
                                            state.customColumnNames.splice(index, names.length);
                                            index = Math.max(index + offset, 0);
                                            names.reverse();
                                            for (var _i4 = 0; _i4 < names.length; _i4++) {
                                                var name = names[_i4];
                                                state.customColumnNames.splice(index, 0, name);
                                            }
                                        }
                                    };
                                }
                            }
                        }],
                    kind: 'let',
                    order: '<'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'resizeColumn',
                                loc: {
                                    start: {
                                        line: 49,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 49,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'Function',
                                context: true,
                                value: function (_context8) {
                                    return function (name, width, offset) {
                                        var getColumnByName = _context8.get('getColumnByName'), state = _context8.get('state');
                                        width = width != null ? width : getColumnByName(name) != null ? getColumnByName(name).width : void 0;
                                        if (width != null) {
                                            width += offset != null ? offset : 0;
                                            state.customColumnWidths = state.customColumnWidths != null ? state.customColumnWidths : {};
                                            state.customColumnWidths[name] = width;
                                        }
                                    };
                                }
                            }
                        }],
                    kind: 'let',
                    order: '='
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'visibleColumnNames',
                                loc: {
                                    start: {
                                        line: 55,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 55,
                                        column: 26,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'ArrayExpression',
                                    elements: []
                                },
                                properties: [
                                    {
                                        type: 'IfStatement',
                                        test: {
                                            type: 'UnaryExpression',
                                            operator: '?',
                                            argument: {
                                                type: 'Identifier',
                                                name: 'fixedColumnNames',
                                                loc: {
                                                    start: {
                                                        line: 56,
                                                        column: 11,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    },
                                                    end: {
                                                        line: 56,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    }
                                                }
                                            }
                                        },
                                        consequent: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'ForOfStatement',
                                                    left: {
                                                        type: 'VariableDeclaration',
                                                        declarations: [{
                                                                type: 'VariableDeclarator',
                                                                id: {
                                                                    type: 'Identifier',
                                                                    name: 'name',
                                                                    loc: {
                                                                        start: {
                                                                            line: 57,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                        },
                                                                        end: {
                                                                            line: 57,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                        }
                                                                    }
                                                                },
                                                                init: null
                                                            }],
                                                        kind: 'let'
                                                    },
                                                    right: {
                                                        type: 'Identifier',
                                                        name: 'fixedColumnNames',
                                                        loc: {
                                                            start: {
                                                                line: 57,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                            },
                                                            end: {
                                                                line: 57,
                                                                column: 40,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                            }
                                                        }
                                                    },
                                                    body: {
                                                        type: 'BlockStatement',
                                                        body: [{
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'Identifier',
                                                                    name: 'name',
                                                                    loc: {
                                                                        start: {
                                                                            line: 58,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                        },
                                                                        end: {
                                                                            line: 58,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 58,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                    },
                                                                    end: {
                                                                        line: 58,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    remove: null,
                                                    order: '0'
                                                }]
                                        },
                                        alternate: null,
                                        order: '0'
                                    },
                                    {
                                        type: 'ForOfStatement',
                                        left: {
                                            type: 'VariableDeclaration',
                                            declarations: [{
                                                    type: 'VariableDeclarator',
                                                    id: {
                                                        type: 'Identifier',
                                                        name: 'name',
                                                        loc: {
                                                            start: {
                                                                line: 59,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                            },
                                                            end: {
                                                                line: 59,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                            }
                                                        }
                                                    },
                                                    init: null
                                                }],
                                            kind: 'let'
                                        },
                                        right: {
                                            type: 'ConditionalExpression',
                                            test: {
                                                type: 'BinaryExpression',
                                                operator: '!=',
                                                left: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'state',
                                                        loc: {
                                                            start: {
                                                                line: 59,
                                                                column: 21,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                            },
                                                            end: {
                                                                line: 59,
                                                                column: 26,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'customColumnNames',
                                                        loc: {
                                                            start: {
                                                                line: 59,
                                                                column: 27,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                            },
                                                            end: {
                                                                line: 59,
                                                                column: 44,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 59,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                        },
                                                        end: {
                                                            line: 59,
                                                            column: 44,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                        }
                                                    }
                                                },
                                                right: {
                                                    type: 'Literal',
                                                    value: null
                                                }
                                            },
                                            consequent: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'state',
                                                    loc: {
                                                        start: {
                                                            line: 59,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                        },
                                                        end: {
                                                            line: 59,
                                                            column: 26,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'customColumnNames',
                                                    loc: {
                                                        start: {
                                                            line: 59,
                                                            column: 27,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                        },
                                                        end: {
                                                            line: 59,
                                                            column: 44,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 59,
                                                        column: 21,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    },
                                                    end: {
                                                        line: 59,
                                                        column: 44,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    }
                                                }
                                            },
                                            alternate: {
                                                type: 'Identifier',
                                                name: 'defaultColumnNames',
                                                loc: {
                                                    start: {
                                                        line: 59,
                                                        column: 47,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    },
                                                    end: {
                                                        line: 59,
                                                        column: 65,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    }
                                                }
                                            }
                                        },
                                        body: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'Identifier',
                                                        name: 'name',
                                                        loc: {
                                                            start: {
                                                                line: 60,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                            },
                                                            end: {
                                                                line: 60,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 60,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                        },
                                                        end: {
                                                            line: 60,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        remove: null,
                                        order: '1'
                                    }
                                ]
                            }
                        }],
                    kind: 'let',
                    order: '>'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'columns',
                                loc: {
                                    start: {
                                        line: 61,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 61,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'ArrayExpression',
                                    elements: []
                                },
                                properties: [{
                                        type: 'ForOfStatement',
                                        left: {
                                            type: 'VariableDeclaration',
                                            declarations: [{
                                                    type: 'VariableDeclarator',
                                                    id: {
                                                        type: 'Identifier',
                                                        name: 'nameOrConfig',
                                                        loc: {
                                                            start: {
                                                                line: 62,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                            },
                                                            end: {
                                                                line: 62,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                            }
                                                        }
                                                    },
                                                    init: null
                                                }],
                                            kind: 'let'
                                        },
                                        right: {
                                            type: 'Identifier',
                                            name: 'visibleColumnNames',
                                            loc: {
                                                start: {
                                                    line: 62,
                                                    column: 28,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                },
                                                end: {
                                                    line: 62,
                                                    column: 46,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                }
                                            }
                                        },
                                        body: {
                                            type: 'BlockStatement',
                                            body: [
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'property',
                                                                loc: {
                                                                    start: {
                                                                        line: 63,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                    },
                                                                    end: {
                                                                        line: 63,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'ConditionalExpression',
                                                                test: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '===',
                                                                    left: {
                                                                        type: 'UnaryExpression',
                                                                        operator: 'typeof',
                                                                        argument: {
                                                                            type: 'Identifier',
                                                                            name: 'nameOrConfig',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 63,
                                                                                    column: 34,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 63,
                                                                                    column: 46,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                }
                                                                            }
                                                                        }
                                                                    },
                                                                    right: {
                                                                        type: 'Literal',
                                                                        value: 'object'
                                                                    }
                                                                },
                                                                consequent: {
                                                                    type: 'Identifier',
                                                                    name: 'nameOrConfig',
                                                                    loc: {
                                                                        start: {
                                                                            line: 63,
                                                                            column: 61,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                        },
                                                                        end: {
                                                                            line: 63,
                                                                            column: 73,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                        }
                                                                    }
                                                                },
                                                                alternate: {
                                                                    type: 'ConditionalExpression',
                                                                    test: {
                                                                        type: 'BinaryExpression',
                                                                        operator: '!=',
                                                                        left: {
                                                                            type: 'MemberExpression',
                                                                            computed: true,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'customColumnConfigs',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 63,
                                                                                        column: 76,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 63,
                                                                                        column: 95,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'nameOrConfig',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 63,
                                                                                        column: 96,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 63,
                                                                                        column: 108,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 63,
                                                                                    column: 76,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 63,
                                                                                    column: 109,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        right: {
                                                                            type: 'Literal',
                                                                            value: null
                                                                        }
                                                                    },
                                                                    consequent: {
                                                                        type: 'MemberExpression',
                                                                        computed: true,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'customColumnConfigs',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 63,
                                                                                    column: 76,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 63,
                                                                                    column: 95,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'nameOrConfig',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 63,
                                                                                    column: 96,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 63,
                                                                                    column: 108,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 63,
                                                                                column: 76,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                            },
                                                                            end: {
                                                                                line: 63,
                                                                                column: 109,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    alternate: {
                                                                        type: 'MemberExpression',
                                                                        computed: true,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'properties',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 63,
                                                                                    column: 112,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 63,
                                                                                    column: 122,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'nameOrConfig',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 63,
                                                                                    column: 123,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 63,
                                                                                    column: 135,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 63,
                                                                                column: 112,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                            },
                                                                            end: {
                                                                                line: 63,
                                                                                column: 136,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'IfStatement',
                                                    test: {
                                                        type: 'UnaryExpression',
                                                        operator: '?',
                                                        argument: {
                                                            type: 'Identifier',
                                                            name: 'property',
                                                            loc: {
                                                                start: {
                                                                    line: 64,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                },
                                                                end: {
                                                                    line: 64,
                                                                    column: 23,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                }
                                                            }
                                                        }
                                                    },
                                                    consequent: {
                                                        type: 'BlockStatement',
                                                        body: [
                                                            {
                                                                type: 'VariableDeclaration',
                                                                declarations: [{
                                                                        type: 'VariableDeclarator',
                                                                        id: {
                                                                            type: 'Identifier',
                                                                            name: 'name',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 65,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 65,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        init: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'property',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 65,
                                                                                        column: 27,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 65,
                                                                                        column: 35,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'name',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 65,
                                                                                        column: 36,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 65,
                                                                                        column: 40,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 65,
                                                                                    column: 27,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 65,
                                                                                    column: 40,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                }
                                                                            }
                                                                        }
                                                                    }],
                                                                kind: 'let',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'VariableDeclaration',
                                                                declarations: [{
                                                                        type: 'VariableDeclarator',
                                                                        id: {
                                                                            type: 'Identifier',
                                                                            name: 'ColumnType',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 66,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 66,
                                                                                    column: 30,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        init: {
                                                                            type: 'CallExpression',
                                                                            callee: {
                                                                                type: 'Identifier',
                                                                                name: 'getColumnType',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 66,
                                                                                        column: 33,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 66,
                                                                                        column: 46,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            arguments: [{
                                                                                    type: 'Identifier',
                                                                                    name: 'property',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 66,
                                                                                            column: 47,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 66,
                                                                                            column: 55,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                        }
                                                                                    }
                                                                                }],
                                                                            loc: {
                                                                                start: {
                                                                                    line: 66,
                                                                                    column: 33,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 66,
                                                                                    column: 56,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                }
                                                                            }
                                                                        }
                                                                    }],
                                                                kind: 'let',
                                                                order: '1'
                                                            },
                                                            {
                                                                type: 'VariableDeclaration',
                                                                declarations: [{
                                                                        type: 'VariableDeclarator',
                                                                        id: {
                                                                            type: 'Identifier',
                                                                            name: 'column',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 67,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 67,
                                                                                    column: 26,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        init: {
                                                                            type: 'CallExpression',
                                                                            callee: {
                                                                                type: 'Identifier',
                                                                                name: 'ColumnType',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 67,
                                                                                        column: 29,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 67,
                                                                                        column: 39,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            arguments: [
                                                                                {
                                                                                    type: 'Identifier',
                                                                                    name: 'property',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 67,
                                                                                            column: 40,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 67,
                                                                                            column: 48,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                {
                                                                                    type: 'ObjectExpression',
                                                                                    properties: [{
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'state',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 67,
                                                                                                        column: 51,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 67,
                                                                                                        column: 56,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'Identifier',
                                                                                                name: 'state',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 67,
                                                                                                        column: 51,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 67,
                                                                                                        column: 56,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '0'
                                                                                        }]
                                                                                }
                                                                            ],
                                                                            loc: {
                                                                                start: {
                                                                                    line: 67,
                                                                                    column: 29,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 67,
                                                                                    column: 58,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                }
                                                                            }
                                                                        }
                                                                    }],
                                                                kind: 'let',
                                                                order: '2'
                                                            },
                                                            {
                                                                type: 'IfStatement',
                                                                test: {
                                                                    type: 'UnaryExpression',
                                                                    operator: '?',
                                                                    argument: {
                                                                        type: 'Identifier',
                                                                        name: 'column',
                                                                        loc: {
                                                                            start: {
                                                                                line: 68,
                                                                                column: 19,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                            },
                                                                            end: {
                                                                                line: 68,
                                                                                column: 25,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                            }
                                                                        }
                                                                    }
                                                                },
                                                                consequent: {
                                                                    type: 'BlockStatement',
                                                                    body: [{
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'ObjectExpression',
                                                                                objectType: {
                                                                                    type: 'Identifier',
                                                                                    name: 'column',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 69,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 69,
                                                                                            column: 26,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                properties: [
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'fixed',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 70,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 70,
                                                                                                    column: 29,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'CallExpression',
                                                                                            callee: {
                                                                                                type: 'MemberExpression',
                                                                                                computed: false,
                                                                                                object: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'fixedColumnNames',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 70,
                                                                                                            column: 31,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 70,
                                                                                                            column: 47,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'contains',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 70,
                                                                                                            column: 48,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 70,
                                                                                                            column: 56,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 70,
                                                                                                        column: 31,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 70,
                                                                                                        column: 56,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            arguments: [{
                                                                                                    type: 'Identifier',
                                                                                                    name: 'nameOrConfig',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 70,
                                                                                                            column: 57,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 70,
                                                                                                            column: 69,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                                        }
                                                                                                    }
                                                                                                }],
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 70,
                                                                                                    column: 31,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 70,
                                                                                                    column: 70,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'width',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 71,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 71,
                                                                                                    column: 29,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'ConditionalExpression',
                                                                                            test: {
                                                                                                type: 'BinaryExpression',
                                                                                                operator: '!=',
                                                                                                left: {
                                                                                                    type: 'MemberExpression',
                                                                                                    computed: true,
                                                                                                    object: {
                                                                                                        type: 'MemberExpression',
                                                                                                        computed: false,
                                                                                                        object: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'state',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 71,
                                                                                                                    column: 31,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 71,
                                                                                                                    column: 36,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        property: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'customColumnWidths',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 71,
                                                                                                                    column: 37,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 71,
                                                                                                                    column: 55,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 71,
                                                                                                                column: 31,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 71,
                                                                                                                column: 55,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    property: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'name',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 71,
                                                                                                                column: 57,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 71,
                                                                                                                column: 61,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    existential: true,
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 71,
                                                                                                            column: 31,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 71,
                                                                                                            column: 62,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                right: {
                                                                                                    type: 'Literal',
                                                                                                    value: null
                                                                                                }
                                                                                            },
                                                                                            consequent: {
                                                                                                type: 'MemberExpression',
                                                                                                computed: true,
                                                                                                object: {
                                                                                                    type: 'MemberExpression',
                                                                                                    computed: false,
                                                                                                    object: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'state',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 71,
                                                                                                                column: 31,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 71,
                                                                                                                column: 36,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    property: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'customColumnWidths',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 71,
                                                                                                                column: 37,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 71,
                                                                                                                column: 55,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 71,
                                                                                                            column: 31,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 71,
                                                                                                            column: 55,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'name',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 71,
                                                                                                            column: 57,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 71,
                                                                                                            column: 61,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                existential: true,
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 71,
                                                                                                        column: 31,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 71,
                                                                                                        column: 62,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            alternate: {
                                                                                                type: 'MemberExpression',
                                                                                                computed: false,
                                                                                                object: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'column',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 71,
                                                                                                            column: 65,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 71,
                                                                                                            column: 71,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'defaultWidth',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 71,
                                                                                                            column: 72,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 71,
                                                                                                            column: 84,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 71,
                                                                                                        column: 65,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 71,
                                                                                                        column: 84,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '1'
                                                                                    }
                                                                                ]
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 69,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 72,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                alternate: null,
                                                                order: '3'
                                                            }
                                                        ]
                                                    },
                                                    alternate: null,
                                                    order: '1'
                                                }
                                            ]
                                        },
                                        remove: null,
                                        order: '0'
                                    }]
                            }
                        }],
                    kind: 'let',
                    order: '?'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'getColumnByName',
                                loc: {
                                    start: {
                                        line: 72,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 72,
                                        column: 23,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'Function',
                                context: true,
                                value: function (_context9) {
                                    return function (name) {
                                        var columns = _context9.get('columns');
                                        for (var _i5 = 0; _i5 < columns.length; _i5++) {
                                            var column = columns[_i5];
                                            if (column.name === name) {
                                                return column;
                                            }
                                        }
                                        return null;
                                    };
                                }
                            }
                        }],
                    kind: 'let',
                    order: '@'
                },
                {
                    type: 'ReturnStatement',
                    argument: {
                        type: 'ObjectExpression',
                        properties: [
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'columns',
                                    loc: {
                                        start: {
                                            line: 81,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 81,
                                            column: 19,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'Identifier',
                                    name: 'columns',
                                    loc: {
                                        start: {
                                            line: 81,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 81,
                                            column: 19,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                kind: 'init',
                                order: '0'
                            },
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'properties',
                                    loc: {
                                        start: {
                                            line: 81,
                                            column: 21,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 81,
                                            column: 31,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'Identifier',
                                    name: 'properties',
                                    loc: {
                                        start: {
                                            line: 81,
                                            column: 21,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 81,
                                            column: 31,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                kind: 'init',
                                order: '1'
                            },
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'availableColumnNames',
                                    loc: {
                                        start: {
                                            line: 81,
                                            column: 33,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 81,
                                            column: 53,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'Identifier',
                                    name: 'availableColumnNames',
                                    loc: {
                                        start: {
                                            line: 81,
                                            column: 33,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 81,
                                            column: 53,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                kind: 'init',
                                order: '2'
                            },
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'visibleColumnNames',
                                    loc: {
                                        start: {
                                            line: 81,
                                            column: 55,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 81,
                                            column: 73,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'Identifier',
                                    name: 'visibleColumnNames',
                                    loc: {
                                        start: {
                                            line: 81,
                                            column: 55,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 81,
                                            column: 73,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                kind: 'init',
                                order: '3'
                            },
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'insertColumn',
                                    loc: {
                                        start: {
                                            line: 81,
                                            column: 75,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 81,
                                            column: 87,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'Identifier',
                                    name: 'insertColumn',
                                    loc: {
                                        start: {
                                            line: 81,
                                            column: 75,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 81,
                                            column: 87,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                kind: 'init',
                                order: '4'
                            },
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'deleteColumn',
                                    loc: {
                                        start: {
                                            line: 81,
                                            column: 89,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 81,
                                            column: 101,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'Identifier',
                                    name: 'deleteColumn',
                                    loc: {
                                        start: {
                                            line: 81,
                                            column: 89,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 81,
                                            column: 101,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                kind: 'init',
                                order: '5'
                            },
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'resetColumns',
                                    loc: {
                                        start: {
                                            line: 81,
                                            column: 103,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 81,
                                            column: 115,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'Identifier',
                                    name: 'resetColumns',
                                    loc: {
                                        start: {
                                            line: 81,
                                            column: 103,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 81,
                                            column: 115,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                kind: 'init',
                                order: '6'
                            },
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'moveColumns',
                                    loc: {
                                        start: {
                                            line: 81,
                                            column: 117,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 81,
                                            column: 128,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'Identifier',
                                    name: 'moveColumns',
                                    loc: {
                                        start: {
                                            line: 81,
                                            column: 117,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 81,
                                            column: 128,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                kind: 'init',
                                order: '7'
                            },
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'resizeColumn',
                                    loc: {
                                        start: {
                                            line: 81,
                                            column: 130,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 81,
                                            column: 142,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'Identifier',
                                    name: 'resizeColumn',
                                    loc: {
                                        start: {
                                            line: 81,
                                            column: 130,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 81,
                                            column: 142,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                kind: 'init',
                                order: '8'
                            }
                        ]
                    },
                    order: 'A'
                }
            ],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'CustomColumnSource',
                loc: {
                    start: {
                        line: 6,
                        column: 6,
                        fixed: true,
                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                    },
                    end: {
                        line: 6,
                        column: 24,
                        fixed: true,
                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                    }
                }
            }
        }, {
            this: this,
            args: args,
            ion: ion,
            _ref: _ref,
            getColumnType: getColumnType,
            Schema: Schema,
            CustomColumnSource: CustomColumnSource,
            getSortPropertySchemaForMove: getSortPropertySchemaForMove,
            hasSelectedAncestor: hasSelectedAncestor,
            getMoveRowsAndAllRows: getMoveRowsAndAllRows,
            indent: indent,
            outdent: outdent,
            moveUp: moveUp,
            moveDown: moveDown,
            decorateRow: decorateRow,
            decorateColumn: decorateColumn
        }, null);
    });
var getSortPropertySchemaForMove = function (dataTableModel) {
        var sort = dataTableModel.rowSource.sort;
        if ((sort != null ? sort.length : void 0) !== 1) {
            throw new Error('Cannot move withot sort column');
        }
        var property = Object.keys(sort[0])[0];
        var schema = dataTableModel.columnSource.properties[property];
        if ((schema != null ? schema.unique : void 0) !== true) {
            throw new Error('Sorted property \'' + property + '\' is not unique.\' ');
        }
        return schema;
    }, hasSelectedAncestor = function (row) {
        var parent = row.parent;
        if (parent) {
            return parent.selected || hasSelectedAncestor(parent);
        }
        return false;
    }, getMoveRowsAndAllRows = function (dataTableModel) {
        dataTableModel.beginOp();
        var selectedRows = dataTableModel.selectedRows;
        for (var _i6 = 0; _i6 < selectedRows.length; _i6++) {
            var row = selectedRows[_i6];
            if (row.open) {
                row.setSelected(true, true);
            }
        }
        var _ref20 = [];
        for (var _i7 = 0; _i7 < selectedRows.length; _i7++) {
            var row = selectedRows[_i7];
            if (!hasSelectedAncestor(row)) {
                _ref20.push(row);
            }
        }
        var moveRows = _ref20;
        var _ref21 = [];
        {
            var _ref30 = dataTableModel.allRows;
            for (var _i8 = 0; _i8 < _ref30.length; _i8++) {
                var row = _ref30[_i8];
                if (!hasSelectedAncestor(row)) {
                    _ref21.push(row);
                }
            }
        }
        var allRows = _ref21;
        return [
            moveRows,
            allRows
        ];
    }, indent = function (dataTableModel) {
        var _ref3 = getMoveRowsAndAllRows(dataTableModel);
        var moveRows = _ref3[0];
        var allRows = _ref3[1];
        for (var i = 0; i < moveRows.length; i++) {
            var row = moveRows[i];
            var _ref4 = row;
            var record = _ref4.record;
            var siblingRecords = row.getSiblingRecords();
            var previousRecord = siblingRecords[siblingRecords.indexOf(record) - 1];
            if (previousRecord != null) {
                dataTableModel.rowSource.moveToLastChildOf(record, previousRecord);
                dataTableModel.setRowOpen(previousRecord, true);
            }
        }
    }, outdent = function (dataTableModel) {
        var _ref5 = getMoveRowsAndAllRows(dataTableModel);
        var moveRows = _ref5[0];
        var allRows = _ref5[1];
        for (var i = moveRows.length - 1; i >= 0; i--) {
            var row = moveRows[i];
            var _ref6 = row;
            var record = _ref6.record;
            var parent = row.parent != null ? row.parent.record : void 0;
            if (!(parent != null)) {
                continue;
            }
            var siblingRecords = row.getSiblingRecords();
            var index = siblingRecords.indexOf(record);
            for (var k = index + 1; k < siblingRecords.length; k++) {
                dataTableModel.setRowOpen(record, true);
                dataTableModel.rowSource.moveToLastChildOf(siblingRecords[k], record);
            }
            dataTableModel.rowSource.moveToAfter(record, parent);
        }
    }, moveUp = function (dataTableModel) {
        var _ref7 = getMoveRowsAndAllRows(dataTableModel);
        var moveRows = _ref7[0];
        var allRows = _ref7[1];
        for (var i = 0; i < moveRows.length; i++) {
            var row = moveRows[i];
            var _ref8 = row;
            var record = _ref8.record;
            var index = allRows.indexOf(row);
            if (index > 0) {
                var peer = allRows[index - 1];
                var swap = true;
                if (peer.getDepth() > row.getDepth()) {
                    dataTableModel.rowSource.moveToAfter(record, peer.record);
                    swap = false;
                } else {
                    if (peer.selected) {
                        continue;
                    }
                    dataTableModel.rowSource.moveToBefore(record, peer.record);
                }
                if (swap) {
                    allRows[index] = peer;
                    allRows[index - 1] = row;
                }
            }
        }
    }, moveDown = function (dataTableModel) {
        var _ref9 = getMoveRowsAndAllRows(dataTableModel);
        var moveRows = _ref9[0];
        var allRows = _ref9[1];
        for (var i = moveRows.length - 1; i >= 0; i--) {
            var row = moveRows[i];
            var _ref10 = row;
            var record = _ref10.record;
            var index = allRows.indexOf(row);
            if (index + 1 < allRows.length) {
                var peer = allRows[index + 1];
                var swap = true;
                var moveBefore = null;
                if (peer.getDepth() < row.getDepth()) {
                    moveBefore = peer;
                    swap = false;
                } else {
                    if (peer.selected) {
                        continue;
                    }
                    if (index + 2 < allRows.length) {
                        var next = allRows[index + 2];
                        if (next.getDepth() > peer.getDepth()) {
                            moveBefore = next;
                        }
                    }
                }
                if (moveBefore != null) {
                    dataTableModel.rowSource.moveToBefore(record, moveBefore.record);
                } else {
                    dataTableModel.rowSource.moveToAfter(record, peer.record);
                }
                if (swap) {
                    allRows[index] = peer;
                    allRows[index + 1] = row;
                }
            }
        }
    };
var decorateRow = ion.template(function decorateRow(_ref11) {
        return ion.createRuntime({
            type: 'Template',
            id: {
                type: 'Identifier',
                name: 'decorateRow',
                loc: {
                    start: {
                        line: 202,
                        column: 29,
                        fixed: true,
                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                    },
                    end: {
                        line: 202,
                        column: 40,
                        fixed: true,
                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                    }
                }
            },
            body: [
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'row',
                                loc: {
                                    start: {
                                        line: 202,
                                        column: 42,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 202,
                                        column: 45,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref11'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'row',
                                    loc: {
                                        start: {
                                            line: 202,
                                            column: 42,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 202,
                                            column: 45,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '0'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'parentRow',
                                loc: {
                                    start: {
                                        line: 202,
                                        column: 47,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 202,
                                        column: 56,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref11'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'parentRow',
                                    loc: {
                                        start: {
                                            line: 202,
                                            column: 47,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 202,
                                            column: 56,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '1'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'dataTableModel',
                                loc: {
                                    start: {
                                        line: 202,
                                        column: 58,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 202,
                                        column: 72,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref11'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'dataTableModel',
                                    loc: {
                                        start: {
                                            line: 202,
                                            column: 58,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 202,
                                            column: 72,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '2'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: '_ref12'
                            },
                            init: {
                                type: 'Identifier',
                                name: 'row',
                                loc: {
                                    start: {
                                        line: 203,
                                        column: 25,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 203,
                                        column: 28,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '3'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'children',
                                loc: {
                                    start: {
                                        line: 203,
                                        column: 9,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 203,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref12'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'children',
                                    loc: {
                                        start: {
                                            line: 203,
                                            column: 9,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 203,
                                            column: 17,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '4'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'key',
                                loc: {
                                    start: {
                                        line: 203,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 203,
                                        column: 21,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref12'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'key',
                                    loc: {
                                        start: {
                                            line: 203,
                                            column: 18,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 203,
                                            column: 21,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '5'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: '_ref13'
                            },
                            init: {
                                type: 'Identifier',
                                name: 'dataTableModel',
                                loc: {
                                    start: {
                                        line: 204,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 204,
                                        column: 32,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '6'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'state',
                                loc: {
                                    start: {
                                        line: 204,
                                        column: 9,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 204,
                                        column: 14,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref13'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'state',
                                    loc: {
                                        start: {
                                            line: 204,
                                            column: 9,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 204,
                                            column: 14,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '7'
                },
                {
                    type: 'ExpressionStatement',
                    expression: {
                        type: 'ObjectExpression',
                        objectType: {
                            type: 'Identifier',
                            name: 'row',
                            loc: {
                                start: {
                                    line: 205,
                                    column: 4,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                },
                                end: {
                                    line: 205,
                                    column: 7,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                }
                            }
                        },
                        properties: [
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'parentRow',
                                    loc: {
                                        start: {
                                            line: 206,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 206,
                                            column: 17,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'Identifier',
                                    name: 'parentRow',
                                    loc: {
                                        start: {
                                            line: 206,
                                            column: 19,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 206,
                                            column: 28,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                kind: 'init',
                                order: '0'
                            },
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'dataTableModel',
                                    loc: {
                                        start: {
                                            line: 207,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 207,
                                            column: 22,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'Identifier',
                                    name: 'dataTableModel',
                                    loc: {
                                        start: {
                                            line: 207,
                                            column: 24,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 207,
                                            column: 38,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                kind: 'init',
                                order: '1'
                            },
                            {
                                type: 'VariableDeclaration',
                                declarations: [{
                                        type: 'VariableDeclarator',
                                        id: {
                                            type: 'Identifier',
                                            name: 'open',
                                            loc: {
                                                start: {
                                                    line: 208,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                },
                                                end: {
                                                    line: 208,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                }
                                            }
                                        },
                                        init: {
                                            type: 'UnaryExpression',
                                            operator: '!',
                                            argument: {
                                                type: 'MemberExpression',
                                                computed: true,
                                                object: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'state',
                                                        loc: {
                                                            start: {
                                                                line: 208,
                                                                column: 23,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                            },
                                                            end: {
                                                                line: 208,
                                                                column: 28,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'closedRowKeys',
                                                        loc: {
                                                            start: {
                                                                line: 208,
                                                                column: 29,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                            },
                                                            end: {
                                                                line: 208,
                                                                column: 42,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 208,
                                                            column: 23,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                        },
                                                        end: {
                                                            line: 208,
                                                            column: 42,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'key',
                                                    loc: {
                                                        start: {
                                                            line: 208,
                                                            column: 43,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                        },
                                                        end: {
                                                            line: 208,
                                                            column: 46,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 208,
                                                        column: 23,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    },
                                                    end: {
                                                        line: 208,
                                                        column: 47,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    }
                                                }
                                            }
                                        }
                                    }],
                                kind: 'let',
                                order: '2'
                            },
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'open',
                                    loc: {
                                        start: {
                                            line: 209,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 209,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'Identifier',
                                    name: 'open',
                                    loc: {
                                        start: {
                                            line: 209,
                                            column: 14,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 209,
                                            column: 18,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                kind: 'init',
                                order: '3'
                            },
                            {
                                type: 'VariableDeclaration',
                                declarations: [{
                                        type: 'VariableDeclarator',
                                        id: {
                                            type: 'Identifier',
                                            name: 'selected',
                                            loc: {
                                                start: {
                                                    line: 210,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                },
                                                end: {
                                                    line: 210,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                }
                                            }
                                        },
                                        init: {
                                            type: 'MemberExpression',
                                            computed: true,
                                            object: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'state',
                                                    loc: {
                                                        start: {
                                                            line: 210,
                                                            column: 23,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                        },
                                                        end: {
                                                            line: 210,
                                                            column: 28,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'selectedRowKeys',
                                                    loc: {
                                                        start: {
                                                            line: 210,
                                                            column: 29,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                        },
                                                        end: {
                                                            line: 210,
                                                            column: 44,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 210,
                                                        column: 23,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    },
                                                    end: {
                                                        line: 210,
                                                        column: 44,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'key',
                                                loc: {
                                                    start: {
                                                        line: 210,
                                                        column: 45,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    },
                                                    end: {
                                                        line: 210,
                                                        column: 48,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 210,
                                                    column: 23,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                },
                                                end: {
                                                    line: 210,
                                                    column: 49,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                }
                                            }
                                        }
                                    }],
                                kind: 'let',
                                order: '4'
                            },
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'selected',
                                    loc: {
                                        start: {
                                            line: 211,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 211,
                                            column: 16,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'Identifier',
                                    name: 'selected',
                                    loc: {
                                        start: {
                                            line: 211,
                                            column: 18,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 211,
                                            column: 26,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                kind: 'init',
                                order: '5'
                            },
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'selfAndChildren',
                                    loc: {
                                        start: {
                                            line: 212,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 212,
                                            column: 23,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'ObjectExpression',
                                    objectType: {
                                        type: 'ArrayExpression',
                                        elements: []
                                    },
                                    properties: [
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'Identifier',
                                                name: 'row',
                                                loc: {
                                                    start: {
                                                        line: 213,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    },
                                                    end: {
                                                        line: 213,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 213,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                },
                                                end: {
                                                    line: 213,
                                                    column: 15,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                }
                                            },
                                            order: '0'
                                        },
                                        {
                                            type: 'IfStatement',
                                            test: {
                                                type: 'BinaryExpression',
                                                operator: '&&',
                                                left: {
                                                    type: 'UnaryExpression',
                                                    operator: '?',
                                                    argument: {
                                                        type: 'Identifier',
                                                        name: 'children',
                                                        loc: {
                                                            start: {
                                                                line: 214,
                                                                column: 15,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                            },
                                                            end: {
                                                                line: 214,
                                                                column: 23,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                            }
                                                        }
                                                    }
                                                },
                                                right: {
                                                    type: 'Identifier',
                                                    name: 'open',
                                                    loc: {
                                                        start: {
                                                            line: 214,
                                                            column: 29,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                        },
                                                        end: {
                                                            line: 214,
                                                            column: 33,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                        }
                                                    }
                                                }
                                            },
                                            consequent: {
                                                type: 'BlockStatement',
                                                body: [{
                                                        type: 'ForOfStatement',
                                                        left: {
                                                            type: 'VariableDeclaration',
                                                            declarations: [{
                                                                    type: 'VariableDeclarator',
                                                                    id: {
                                                                        type: 'Identifier',
                                                                        name: 'child',
                                                                        loc: {
                                                                            start: {
                                                                                line: 215,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                            },
                                                                            end: {
                                                                                line: 215,
                                                                                column: 25,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    init: null
                                                                }],
                                                            kind: 'let'
                                                        },
                                                        right: {
                                                            type: 'Identifier',
                                                            name: 'children',
                                                            loc: {
                                                                start: {
                                                                    line: 215,
                                                                    column: 29,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                },
                                                                end: {
                                                                    line: 215,
                                                                    column: 37,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                }
                                                            }
                                                        },
                                                        body: {
                                                            type: 'BlockStatement',
                                                            body: [{
                                                                    type: 'ForOfStatement',
                                                                    left: {
                                                                        type: 'VariableDeclaration',
                                                                        declarations: [{
                                                                                type: 'VariableDeclarator',
                                                                                id: {
                                                                                    type: 'Identifier',
                                                                                    name: 'gchild',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 216,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 216,
                                                                                            column: 30,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                init: null
                                                                            }],
                                                                        kind: 'let'
                                                                    },
                                                                    right: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'child',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 216,
                                                                                    column: 34,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 216,
                                                                                    column: 39,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'selfAndChildren',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 216,
                                                                                    column: 40,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 216,
                                                                                    column: 55,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 216,
                                                                                column: 34,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                            },
                                                                            end: {
                                                                                line: 216,
                                                                                column: 55,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    body: {
                                                                        type: 'BlockStatement',
                                                                        body: [{
                                                                                type: 'ExpressionStatement',
                                                                                expression: {
                                                                                    type: 'Identifier',
                                                                                    name: 'gchild',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 217,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 217,
                                                                                            column: 30,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 217,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 217,
                                                                                        column: 30,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                    }
                                                                                },
                                                                                order: '0'
                                                                            }]
                                                                    },
                                                                    remove: null,
                                                                    order: '0'
                                                                }]
                                                        },
                                                        remove: null,
                                                        order: '0'
                                                    }]
                                            },
                                            alternate: null,
                                            order: '1'
                                        }
                                    ]
                                },
                                kind: 'init',
                                order: '6'
                            },
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'getRecordAndAncestors',
                                    loc: {
                                        start: {
                                            line: 218,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 218,
                                            column: 29,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'Function',
                                    context: true,
                                    value: function (_context10) {
                                        return function () {
                                            var row = _context10.get('row');
                                            var records = [];
                                            var currentRow = row;
                                            while (currentRow != null) {
                                                records.push(currentRow.record);
                                                currentRow = currentRow.parentRow;
                                            }
                                            return records;
                                        };
                                    }
                                },
                                kind: 'init',
                                order: '7'
                            },
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'setSelected',
                                    loc: {
                                        start: {
                                            line: 225,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 225,
                                            column: 19,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'Function',
                                    context: true,
                                    value: function (_context11) {
                                        return function (value, recursive) {
                                            if (value == null)
                                                value = true;
                                            var state = _context11.get('state'), key = _context11.get('key'), children = _context11.get('children');
                                            if (value) {
                                                state.selectedRowKeys[key] = true;
                                            } else {
                                                delete state.selectedRowKeys[key];
                                            }
                                            if (recursive && children != null) {
                                                for (var _i9 = 0; _i9 < children.length; _i9++) {
                                                    var child = children[_i9];
                                                    child.setSelected(value, recursive);
                                                }
                                            }
                                        };
                                    }
                                },
                                kind: 'init',
                                order: '8'
                            },
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'setOpen',
                                    loc: {
                                        start: {
                                            line: 234,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 234,
                                            column: 15,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'Function',
                                    context: true,
                                    value: function (_context12) {
                                        return function (value, recursive) {
                                            if (value == null)
                                                value = true;
                                            var dataTableModel = _context12.get('dataTableModel'), children = _context12.get('children');
                                            dataTableModel.setRowOpen(this.record, value);
                                            if (recursive && children != null) {
                                                for (var _i10 = 0; _i10 < children.length; _i10++) {
                                                    var child = children[_i10];
                                                    child.setOpen(value, recursive);
                                                }
                                            }
                                        };
                                    }
                                },
                                kind: 'init',
                                order: '9'
                            }
                        ]
                    },
                    loc: {
                        start: {
                            line: 205,
                            column: 4,
                            fixed: true,
                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                        },
                        end: {
                            line: 240,
                            column: 8,
                            fixed: true,
                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                        }
                    },
                    order: '8'
                },
                {
                    type: 'IfStatement',
                    test: {
                        type: 'UnaryExpression',
                        operator: '?',
                        argument: {
                            type: 'Identifier',
                            name: 'children',
                            loc: {
                                start: {
                                    line: 240,
                                    column: 7,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                },
                                end: {
                                    line: 240,
                                    column: 15,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                }
                            }
                        }
                    },
                    consequent: {
                        type: 'BlockStatement',
                        body: [{
                                type: 'ForOfStatement',
                                left: {
                                    type: 'VariableDeclaration',
                                    declarations: [{
                                            type: 'VariableDeclarator',
                                            id: {
                                                type: 'Identifier',
                                                name: 'child',
                                                loc: {
                                                    start: {
                                                        line: 241,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    },
                                                    end: {
                                                        line: 241,
                                                        column: 17,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    }
                                                }
                                            },
                                            init: null
                                        }],
                                    kind: 'let'
                                },
                                right: {
                                    type: 'Identifier',
                                    name: 'children',
                                    loc: {
                                        start: {
                                            line: 241,
                                            column: 21,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 241,
                                            column: 29,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                body: {
                                    type: 'BlockStatement',
                                    body: [
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'ObjectExpression',
                                                objectType: {
                                                    type: 'Identifier',
                                                    name: 'child',
                                                    loc: {
                                                        start: {
                                                            line: 242,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                        },
                                                        end: {
                                                            line: 242,
                                                            column: 17,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                        }
                                                    }
                                                },
                                                properties: [{
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'parent',
                                                            loc: {
                                                                start: {
                                                                    line: 243,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                },
                                                                end: {
                                                                    line: 243,
                                                                    column: 22,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Identifier',
                                                            name: 'row',
                                                            loc: {
                                                                start: {
                                                                    line: 243,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                },
                                                                end: {
                                                                    line: 243,
                                                                    column: 27,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                }
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    }]
                                            },
                                            loc: {
                                                start: {
                                                    line: 242,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                },
                                                end: {
                                                    line: 244,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                }
                                            },
                                            order: '0'
                                        },
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'decorateRow',
                                                    loc: {
                                                        start: {
                                                            line: 244,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                        },
                                                        end: {
                                                            line: 244,
                                                            column: 23,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [{
                                                        type: 'ObjectExpression',
                                                        properties: [
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'row',
                                                                    loc: {
                                                                        start: {
                                                                            line: 244,
                                                                            column: 25,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                        },
                                                                        end: {
                                                                            line: 244,
                                                                            column: 28,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Identifier',
                                                                    name: 'child',
                                                                    loc: {
                                                                        start: {
                                                                            line: 244,
                                                                            column: 29,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                        },
                                                                        end: {
                                                                            line: 244,
                                                                            column: 34,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                        }
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'parentRow',
                                                                    loc: {
                                                                        start: {
                                                                            line: 244,
                                                                            column: 36,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                        },
                                                                        end: {
                                                                            line: 244,
                                                                            column: 45,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Identifier',
                                                                    name: 'row',
                                                                    loc: {
                                                                        start: {
                                                                            line: 244,
                                                                            column: 46,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                        },
                                                                        end: {
                                                                            line: 244,
                                                                            column: 49,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                        }
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '1'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'dataTableModel',
                                                                    loc: {
                                                                        start: {
                                                                            line: 244,
                                                                            column: 51,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                        },
                                                                        end: {
                                                                            line: 244,
                                                                            column: 65,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Identifier',
                                                                    name: 'dataTableModel',
                                                                    loc: {
                                                                        start: {
                                                                            line: 244,
                                                                            column: 51,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                        },
                                                                        end: {
                                                                            line: 244,
                                                                            column: 65,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                        }
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '2'
                                                            }
                                                        ]
                                                    }],
                                                loc: {
                                                    start: {
                                                        line: 244,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    },
                                                    end: {
                                                        line: 244,
                                                        column: 67,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 244,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                },
                                                end: {
                                                    line: 244,
                                                    column: 67,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                }
                                            },
                                            order: '1'
                                        }
                                    ]
                                },
                                remove: null,
                                order: '0'
                            }]
                    },
                    alternate: null,
                    order: '9'
                }
            ],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'decorateRow',
                loc: {
                    start: {
                        line: 202,
                        column: 6,
                        fixed: true,
                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                    },
                    end: {
                        line: 202,
                        column: 17,
                        fixed: true,
                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                    }
                }
            }
        }, {
            this: this,
            _ref11: _ref11,
            ion: ion,
            _ref: _ref,
            getColumnType: getColumnType,
            Schema: Schema,
            CustomColumnSource: CustomColumnSource,
            getSortPropertySchemaForMove: getSortPropertySchemaForMove,
            hasSelectedAncestor: hasSelectedAncestor,
            getMoveRowsAndAllRows: getMoveRowsAndAllRows,
            indent: indent,
            outdent: outdent,
            moveUp: moveUp,
            moveDown: moveDown,
            decorateRow: decorateRow,
            decorateColumn: decorateColumn
        }, null);
    });
var decorateColumn = ion.template(function decorateColumn(column, dataTableModel) {
        return ion.createRuntime({
            type: 'Template',
            id: {
                type: 'Identifier',
                name: 'decorateColumn',
                loc: {
                    start: {
                        line: 246,
                        column: 32,
                        fixed: true,
                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                    },
                    end: {
                        line: 246,
                        column: 46,
                        fixed: true,
                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                    }
                }
            },
            body: [
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: '_ref14'
                            },
                            init: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'column',
                                    loc: {
                                        start: {
                                            line: 247,
                                            column: 17,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 247,
                                            column: 23,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'property',
                                    loc: {
                                        start: {
                                            line: 247,
                                            column: 24,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 247,
                                            column: 32,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 247,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 247,
                                        column: 32,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '0'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'name',
                                loc: {
                                    start: {
                                        line: 247,
                                        column: 9,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 247,
                                        column: 13,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref14'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'name',
                                    loc: {
                                        start: {
                                            line: 247,
                                            column: 9,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 247,
                                            column: 13,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '1'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: '_ref15'
                            },
                            init: {
                                type: 'Identifier',
                                name: 'dataTableModel',
                                loc: {
                                    start: {
                                        line: 248,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 248,
                                        column: 32,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '2'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'state',
                                loc: {
                                    start: {
                                        line: 248,
                                        column: 9,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 248,
                                        column: 14,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref15'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'state',
                                    loc: {
                                        start: {
                                            line: 248,
                                            column: 9,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 248,
                                            column: 14,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '3'
                },
                {
                    type: 'ExpressionStatement',
                    expression: {
                        type: 'ObjectExpression',
                        objectType: {
                            type: 'Identifier',
                            name: 'column',
                            loc: {
                                start: {
                                    line: 249,
                                    column: 4,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                },
                                end: {
                                    line: 249,
                                    column: 10,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                }
                            }
                        },
                        properties: [
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'dataTableModel',
                                    loc: {
                                        start: {
                                            line: 250,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 250,
                                            column: 22,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'Identifier',
                                    name: 'dataTableModel',
                                    loc: {
                                        start: {
                                            line: 250,
                                            column: 24,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 250,
                                            column: 38,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                kind: 'init',
                                order: '0'
                            },
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'selected',
                                    loc: {
                                        start: {
                                            line: 251,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 251,
                                            column: 16,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'MemberExpression',
                                    computed: true,
                                    object: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'state',
                                            loc: {
                                                start: {
                                                    line: 251,
                                                    column: 18,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                },
                                                end: {
                                                    line: 251,
                                                    column: 23,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'selectedColumnNames',
                                            loc: {
                                                start: {
                                                    line: 251,
                                                    column: 24,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                },
                                                end: {
                                                    line: 251,
                                                    column: 43,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 251,
                                                column: 18,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                            },
                                            end: {
                                                line: 251,
                                                column: 43,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'name',
                                        loc: {
                                            start: {
                                                line: 251,
                                                column: 44,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                            },
                                            end: {
                                                line: 251,
                                                column: 48,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 251,
                                            column: 18,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 251,
                                            column: 49,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                kind: 'init',
                                order: '1'
                            },
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'toggleSelected',
                                    loc: {
                                        start: {
                                            line: 252,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 252,
                                            column: 22,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'Function',
                                    context: false,
                                    value: function () {
                                        return this.setSelected(!this.selected);
                                    }
                                },
                                kind: 'init',
                                order: '2'
                            },
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'setSelected',
                                    loc: {
                                        start: {
                                            line: 253,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 253,
                                            column: 19,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'Function',
                                    context: true,
                                    value: function (_context13) {
                                        return function (value) {
                                            if (value == null)
                                                value = true;
                                            var state = _context13.get('state'), name = _context13.get('name');
                                            if (value) {
                                                state.selectedColumnNames[name] = true;
                                            } else {
                                                delete state.selectedColumnNames[name];
                                            }
                                        };
                                    }
                                },
                                kind: 'init',
                                order: '3'
                            }
                        ]
                    },
                    loc: {
                        start: {
                            line: 249,
                            column: 4,
                            fixed: true,
                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                        },
                        end: {
                            line: 259,
                            column: 8,
                            fixed: true,
                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                        }
                    },
                    order: '4'
                }
            ],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'decorateColumn',
                loc: {
                    start: {
                        line: 246,
                        column: 6,
                        fixed: true,
                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                    },
                    end: {
                        line: 246,
                        column: 20,
                        fixed: true,
                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                    }
                }
            }
        }, {
            this: this,
            column: column,
            dataTableModel: dataTableModel,
            ion: ion,
            _ref: _ref,
            getColumnType: getColumnType,
            Schema: Schema,
            CustomColumnSource: CustomColumnSource,
            getSortPropertySchemaForMove: getSortPropertySchemaForMove,
            hasSelectedAncestor: hasSelectedAncestor,
            getMoveRowsAndAllRows: getMoveRowsAndAllRows,
            indent: indent,
            outdent: outdent,
            moveUp: moveUp,
            moveDown: moveDown,
            decorateRow: decorateRow,
            decorateColumn: decorateColumn
        }, null);
    });
module.exports = exports = ion.template(function DataTableModel(args) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'DataTableModel',
            loc: {
                start: {
                    line: 259,
                    column: 16,
                    fixed: true,
                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                },
                end: {
                    line: 259,
                    column: 30,
                    fixed: true,
                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                }
            }
        },
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: '_ref16'
                        },
                        init: {
                            type: 'Identifier',
                            name: 'args',
                            loc: {
                                start: {
                                    line: 260,
                                    column: 90,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                },
                                end: {
                                    line: 260,
                                    column: 94,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: '_state',
                            loc: {
                                start: {
                                    line: 260,
                                    column: 15,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                },
                                end: {
                                    line: 260,
                                    column: 21,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref16'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'state',
                                loc: {
                                    start: {
                                        line: 260,
                                        column: 9,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 260,
                                        column: 14,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'id',
                            loc: {
                                start: {
                                    line: 260,
                                    column: 23,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                },
                                end: {
                                    line: 260,
                                    column: 25,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref16'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'id',
                                loc: {
                                    start: {
                                        line: 260,
                                        column: 23,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 260,
                                        column: 25,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'rowSource',
                            loc: {
                                start: {
                                    line: 260,
                                    column: 27,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                },
                                end: {
                                    line: 260,
                                    column: 36,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref16'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'rowSource',
                                loc: {
                                    start: {
                                        line: 260,
                                        column: 27,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 260,
                                        column: 36,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '3'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'properties',
                            loc: {
                                start: {
                                    line: 260,
                                    column: 38,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                },
                                end: {
                                    line: 260,
                                    column: 48,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref16'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'properties',
                                loc: {
                                    start: {
                                        line: 260,
                                        column: 38,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 260,
                                        column: 48,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '4'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'fixedColumnNames',
                            loc: {
                                start: {
                                    line: 260,
                                    column: 50,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                },
                                end: {
                                    line: 260,
                                    column: 66,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref16'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'fixedColumnNames',
                                loc: {
                                    start: {
                                        line: 260,
                                        column: 50,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 260,
                                        column: 66,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '5'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'defaultColumnNames',
                            loc: {
                                start: {
                                    line: 260,
                                    column: 68,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                },
                                end: {
                                    line: 260,
                                    column: 86,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref16'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'defaultColumnNames',
                                loc: {
                                    start: {
                                        line: 260,
                                        column: 68,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 260,
                                        column: 86,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '6'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'columnStateId',
                            loc: {
                                start: {
                                    line: 261,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                },
                                end: {
                                    line: 261,
                                    column: 21,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ConditionalExpression',
                            test: {
                                type: 'BinaryExpression',
                                operator: '!=',
                                left: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'args',
                                        loc: {
                                            start: {
                                                line: 261,
                                                column: 24,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                            },
                                            end: {
                                                line: 261,
                                                column: 28,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'columnStateId',
                                        loc: {
                                            start: {
                                                line: 261,
                                                column: 29,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                            },
                                            end: {
                                                line: 261,
                                                column: 42,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 261,
                                            column: 24,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 261,
                                            column: 42,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: null
                                }
                            },
                            consequent: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'args',
                                    loc: {
                                        start: {
                                            line: 261,
                                            column: 24,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 261,
                                            column: 28,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'columnStateId',
                                    loc: {
                                        start: {
                                            line: 261,
                                            column: 29,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 261,
                                            column: 42,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 261,
                                        column: 24,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 261,
                                        column: 42,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            alternate: {
                                type: 'Literal',
                                value: 'columnState'
                            }
                        }
                    }],
                kind: 'let',
                order: '7'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'state',
                            loc: {
                                start: {
                                    line: 262,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                },
                                end: {
                                    line: 262,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ConditionalExpression',
                            test: {
                                type: 'BinaryExpression',
                                operator: '!=',
                                left: {
                                    type: 'Identifier',
                                    name: '_state',
                                    loc: {
                                        start: {
                                            line: 262,
                                            column: 16,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 262,
                                            column: 22,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: null
                                }
                            },
                            consequent: {
                                type: 'Identifier',
                                name: '_state',
                                loc: {
                                    start: {
                                        line: 262,
                                        column: 16,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 262,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            alternate: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Function',
                                    context: false,
                                    value: function (id) {
                                        return global.model.local[id] = global.model.local[id] != null ? global.model.local[id] : {};
                                    }
                                },
                                arguments: [{
                                        type: 'Identifier',
                                        name: 'id',
                                        loc: {
                                            start: {
                                                line: 262,
                                                column: 29,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                            },
                                            end: {
                                                line: 262,
                                                column: 31,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                            }
                                        }
                                    }],
                                loc: {
                                    start: {
                                        line: 262,
                                        column: 25,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 262,
                                        column: 64,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '8'
            },
            {
                type: 'ExpressionStatement',
                expression: {
                    type: 'CallExpression',
                    callee: {
                        type: 'Function',
                        context: true,
                        value: function (_context14) {
                            return function () {
                                var state = _context14.get('state');
                                state.closedRowKeys = state.closedRowKeys != null ? state.closedRowKeys : {};
                                state.selectedRowKeys = state.selectedRowKeys != null ? state.selectedRowKeys : {};
                                state.selectedColumnNames = state.selectedColumnNames != null ? state.selectedColumnNames : {};
                            };
                        }
                    },
                    arguments: [],
                    loc: {
                        start: {
                            line: 263,
                            column: 4,
                            fixed: true,
                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                        },
                        end: {
                            line: 268,
                            column: 8,
                            fixed: true,
                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                        }
                    }
                },
                loc: {
                    start: {
                        line: 263,
                        column: 4,
                        fixed: true,
                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                    },
                    end: {
                        line: 268,
                        column: 8,
                        fixed: true,
                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                    }
                },
                order: '9'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'columnState',
                            loc: {
                                start: {
                                    line: 268,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                },
                                end: {
                                    line: 268,
                                    column: 19,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Function',
                                context: true,
                                value: function (_context15) {
                                    return function (columnStateId) {
                                        var state = _context15.get('state');
                                        return state[columnStateId] = state[columnStateId] != null ? state[columnStateId] : {};
                                    };
                                }
                            },
                            arguments: [{
                                    type: 'Identifier',
                                    name: 'columnStateId',
                                    loc: {
                                        start: {
                                            line: 268,
                                            column: 26,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 268,
                                            column: 39,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                }],
                            loc: {
                                start: {
                                    line: 268,
                                    column: 22,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                },
                                end: {
                                    line: 268,
                                    column: 70,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: ':'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'columnSource',
                            loc: {
                                start: {
                                    line: 270,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                },
                                end: {
                                    line: 270,
                                    column: 20,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                }
                            }
                        },
                        init: {
                            type: 'NewExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'CustomColumnSource',
                                loc: {
                                    start: {
                                        line: 270,
                                        column: 27,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 270,
                                        column: 45,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ObjectExpression',
                                    properties: [
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'state',
                                                loc: {
                                                    start: {
                                                        line: 270,
                                                        column: 47,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    },
                                                    end: {
                                                        line: 270,
                                                        column: 52,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Identifier',
                                                name: 'columnState',
                                                loc: {
                                                    start: {
                                                        line: 270,
                                                        column: 53,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    },
                                                    end: {
                                                        line: 270,
                                                        column: 64,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    }
                                                }
                                            },
                                            kind: 'init',
                                            order: '0'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'properties',
                                                loc: {
                                                    start: {
                                                        line: 270,
                                                        column: 66,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    },
                                                    end: {
                                                        line: 270,
                                                        column: 76,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Identifier',
                                                name: 'properties',
                                                loc: {
                                                    start: {
                                                        line: 270,
                                                        column: 66,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    },
                                                    end: {
                                                        line: 270,
                                                        column: 76,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    }
                                                }
                                            },
                                            kind: 'init',
                                            order: '1'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'fixedColumnNames',
                                                loc: {
                                                    start: {
                                                        line: 270,
                                                        column: 78,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    },
                                                    end: {
                                                        line: 270,
                                                        column: 94,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Identifier',
                                                name: 'fixedColumnNames',
                                                loc: {
                                                    start: {
                                                        line: 270,
                                                        column: 78,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    },
                                                    end: {
                                                        line: 270,
                                                        column: 94,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    }
                                                }
                                            },
                                            kind: 'init',
                                            order: '2'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'defaultColumnNames',
                                                loc: {
                                                    start: {
                                                        line: 270,
                                                        column: 96,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    },
                                                    end: {
                                                        line: 270,
                                                        column: 114,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Identifier',
                                                name: 'defaultColumnNames',
                                                loc: {
                                                    start: {
                                                        line: 270,
                                                        column: 96,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    },
                                                    end: {
                                                        line: 270,
                                                        column: 114,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    }
                                                }
                                            },
                                            kind: 'init',
                                            order: '3'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'availableColumnNames',
                                                loc: {
                                                    start: {
                                                        line: 270,
                                                        column: 116,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    },
                                                    end: {
                                                        line: 270,
                                                        column: 136,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'args',
                                                    loc: {
                                                        start: {
                                                            line: 270,
                                                            column: 137,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                        },
                                                        end: {
                                                            line: 270,
                                                            column: 141,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'availableColumnNames',
                                                    loc: {
                                                        start: {
                                                            line: 270,
                                                            column: 142,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                        },
                                                        end: {
                                                            line: 270,
                                                            column: 162,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 270,
                                                        column: 137,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    },
                                                    end: {
                                                        line: 270,
                                                        column: 162,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    }
                                                }
                                            },
                                            kind: 'init',
                                            order: '4'
                                        }
                                    ]
                                }],
                            loc: {
                                start: {
                                    line: 270,
                                    column: 23,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                },
                                end: {
                                    line: 270,
                                    column: 164,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: ';'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'dataTableModel',
                            loc: {
                                start: {
                                    line: 272,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                },
                                end: {
                                    line: 272,
                                    column: 22,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'id',
                                        loc: {
                                            start: {
                                                line: 272,
                                                column: 26,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                            },
                                            end: {
                                                line: 272,
                                                column: 28,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Identifier',
                                        name: 'id',
                                        loc: {
                                            start: {
                                                line: 272,
                                                column: 26,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                            },
                                            end: {
                                                line: 272,
                                                column: 28,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'state',
                                        loc: {
                                            start: {
                                                line: 272,
                                                column: 30,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                            },
                                            end: {
                                                line: 272,
                                                column: 35,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Identifier',
                                        name: 'state',
                                        loc: {
                                            start: {
                                                line: 272,
                                                column: 30,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                            },
                                            end: {
                                                line: 272,
                                                column: 35,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '1'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'rowSource',
                                        loc: {
                                            start: {
                                                line: 272,
                                                column: 37,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                            },
                                            end: {
                                                line: 272,
                                                column: 46,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Identifier',
                                        name: 'rowSource',
                                        loc: {
                                            start: {
                                                line: 272,
                                                column: 37,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                            },
                                            end: {
                                                line: 272,
                                                column: 46,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '2'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'columnSource',
                                        loc: {
                                            start: {
                                                line: 272,
                                                column: 48,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                            },
                                            end: {
                                                line: 272,
                                                column: 60,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Identifier',
                                        name: 'columnSource',
                                        loc: {
                                            start: {
                                                line: 272,
                                                column: 48,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                            },
                                            end: {
                                                line: 272,
                                                column: 60,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '3'
                                }
                            ]
                        }
                    }],
                kind: 'let',
                order: '<'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'rows',
                            loc: {
                                start: {
                                    line: 273,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                },
                                end: {
                                    line: 273,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            computed: false,
                            object: {
                                type: 'Identifier',
                                name: 'rowSource',
                                loc: {
                                    start: {
                                        line: 273,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 273,
                                        column: 24,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'rows',
                                loc: {
                                    start: {
                                        line: 273,
                                        column: 25,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 273,
                                        column: 29,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 273,
                                    column: 15,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                },
                                end: {
                                    line: 273,
                                    column: 29,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '='
            },
            {
                type: 'IfStatement',
                test: {
                    type: 'UnaryExpression',
                    operator: '?',
                    argument: {
                        type: 'Identifier',
                        name: 'rows',
                        loc: {
                            start: {
                                line: 274,
                                column: 7,
                                fixed: true,
                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                            },
                            end: {
                                line: 274,
                                column: 11,
                                fixed: true,
                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                            }
                        }
                    }
                },
                consequent: {
                    type: 'BlockStatement',
                    body: [{
                            type: 'ForOfStatement',
                            left: {
                                type: 'VariableDeclaration',
                                declarations: [{
                                        type: 'VariableDeclarator',
                                        id: {
                                            type: 'Identifier',
                                            name: 'row',
                                            loc: {
                                                start: {
                                                    line: 275,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                },
                                                end: {
                                                    line: 275,
                                                    column: 15,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                }
                                            }
                                        },
                                        init: null
                                    }],
                                kind: 'let'
                            },
                            right: {
                                type: 'Identifier',
                                name: 'rows',
                                loc: {
                                    start: {
                                        line: 275,
                                        column: 19,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 275,
                                        column: 23,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            body: {
                                type: 'BlockStatement',
                                body: [{
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'Identifier',
                                                name: 'decorateRow',
                                                loc: {
                                                    start: {
                                                        line: 276,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    },
                                                    end: {
                                                        line: 276,
                                                        column: 23,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    }
                                                }
                                            },
                                            arguments: [{
                                                    type: 'ObjectExpression',
                                                    properties: [
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'row',
                                                                loc: {
                                                                    start: {
                                                                        line: 276,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                    },
                                                                    end: {
                                                                        line: 276,
                                                                        column: 28,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Identifier',
                                                                name: 'row',
                                                                loc: {
                                                                    start: {
                                                                        line: 276,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                    },
                                                                    end: {
                                                                        line: 276,
                                                                        column: 28,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                    }
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        },
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'dataTableModel',
                                                                loc: {
                                                                    start: {
                                                                        line: 276,
                                                                        column: 30,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                    },
                                                                    end: {
                                                                        line: 276,
                                                                        column: 44,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Identifier',
                                                                name: 'dataTableModel',
                                                                loc: {
                                                                    start: {
                                                                        line: 276,
                                                                        column: 30,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                    },
                                                                    end: {
                                                                        line: 276,
                                                                        column: 44,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                    }
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '1'
                                                        },
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'parentRow',
                                                                loc: {
                                                                    start: {
                                                                        line: 276,
                                                                        column: 46,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                    },
                                                                    end: {
                                                                        line: 276,
                                                                        column: 55,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Literal',
                                                                value: null
                                                            },
                                                            kind: 'init',
                                                            order: '2'
                                                        }
                                                    ]
                                                }],
                                            loc: {
                                                start: {
                                                    line: 276,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                },
                                                end: {
                                                    line: 276,
                                                    column: 63,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 276,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                            },
                                            end: {
                                                line: 276,
                                                column: 63,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                            }
                                        },
                                        order: '0'
                                    }]
                            },
                            remove: null,
                            order: '0'
                        }]
                },
                alternate: null,
                order: '>'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'columns',
                            loc: {
                                start: {
                                    line: 277,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                },
                                end: {
                                    line: 277,
                                    column: 15,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            computed: false,
                            object: {
                                type: 'Identifier',
                                name: 'columnSource',
                                loc: {
                                    start: {
                                        line: 277,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 277,
                                        column: 30,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'columns',
                                loc: {
                                    start: {
                                        line: 277,
                                        column: 31,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 277,
                                        column: 38,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 277,
                                    column: 18,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                },
                                end: {
                                    line: 277,
                                    column: 38,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '?'
            },
            {
                type: 'IfStatement',
                test: {
                    type: 'UnaryExpression',
                    operator: '?',
                    argument: {
                        type: 'Identifier',
                        name: 'columns',
                        loc: {
                            start: {
                                line: 278,
                                column: 7,
                                fixed: true,
                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                            },
                            end: {
                                line: 278,
                                column: 14,
                                fixed: true,
                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                            }
                        }
                    }
                },
                consequent: {
                    type: 'BlockStatement',
                    body: [{
                            type: 'ForOfStatement',
                            left: {
                                type: 'VariableDeclaration',
                                declarations: [{
                                        type: 'VariableDeclarator',
                                        id: {
                                            type: 'Identifier',
                                            name: 'column',
                                            loc: {
                                                start: {
                                                    line: 279,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                },
                                                end: {
                                                    line: 279,
                                                    column: 18,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                }
                                            }
                                        },
                                        init: null
                                    }],
                                kind: 'let'
                            },
                            right: {
                                type: 'Identifier',
                                name: 'columns',
                                loc: {
                                    start: {
                                        line: 279,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 279,
                                        column: 29,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            body: {
                                type: 'BlockStatement',
                                body: [{
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'Identifier',
                                                name: 'decorateColumn',
                                                loc: {
                                                    start: {
                                                        line: 280,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    },
                                                    end: {
                                                        line: 280,
                                                        column: 26,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    }
                                                }
                                            },
                                            arguments: [
                                                {
                                                    type: 'Identifier',
                                                    name: 'column',
                                                    loc: {
                                                        start: {
                                                            line: 280,
                                                            column: 27,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                        },
                                                        end: {
                                                            line: 280,
                                                            column: 33,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                        }
                                                    }
                                                },
                                                {
                                                    type: 'Identifier',
                                                    name: 'dataTableModel',
                                                    loc: {
                                                        start: {
                                                            line: 280,
                                                            column: 35,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                        },
                                                        end: {
                                                            line: 280,
                                                            column: 49,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                        }
                                                    }
                                                }
                                            ],
                                            loc: {
                                                start: {
                                                    line: 280,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                },
                                                end: {
                                                    line: 280,
                                                    column: 50,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 280,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                            },
                                            end: {
                                                line: 280,
                                                column: 50,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                            }
                                        },
                                        order: '0'
                                    }]
                            },
                            remove: null,
                            order: '0'
                        }]
                },
                alternate: null,
                order: '@'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'Identifier',
                        name: 'dataTableModel',
                        loc: {
                            start: {
                                line: 282,
                                column: 11,
                                fixed: true,
                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                            },
                            end: {
                                line: 282,
                                column: 25,
                                fixed: true,
                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                            }
                        }
                    },
                    properties: [
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'editable',
                                loc: {
                                    start: {
                                        line: 283,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 283,
                                        column: 16,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'ConditionalExpression',
                                test: {
                                    type: 'BinaryExpression',
                                    operator: '!=',
                                    left: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'args',
                                            loc: {
                                                start: {
                                                    line: 283,
                                                    column: 18,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                },
                                                end: {
                                                    line: 283,
                                                    column: 22,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'editable',
                                            loc: {
                                                start: {
                                                    line: 283,
                                                    column: 23,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                },
                                                end: {
                                                    line: 283,
                                                    column: 31,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 283,
                                                column: 18,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                            },
                                            end: {
                                                line: 283,
                                                column: 31,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                            }
                                        }
                                    },
                                    right: {
                                        type: 'Literal',
                                        value: null
                                    }
                                },
                                consequent: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'args',
                                        loc: {
                                            start: {
                                                line: 283,
                                                column: 18,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                            },
                                            end: {
                                                line: 283,
                                                column: 22,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'editable',
                                        loc: {
                                            start: {
                                                line: 283,
                                                column: 23,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                            },
                                            end: {
                                                line: 283,
                                                column: 31,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 283,
                                            column: 18,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 283,
                                            column: 31,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                alternate: {
                                    type: 'Literal',
                                    value: true
                                }
                            },
                            kind: 'init',
                            order: '0'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'refresh',
                                loc: {
                                    start: {
                                        line: 284,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 284,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context16) {
                                    return function () {
                                        var ion = _context16.get('ion'), rowSource = _context16.get('rowSource');
                                        ion.sync();
                                        rowSource.refresh != null ? rowSource.refresh() : void 0;
                                    };
                                }
                            },
                            kind: 'init',
                            order: '1'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'temp',
                                loc: {
                                    start: {
                                        line: 288,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 288,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'ObjectExpression',
                                properties: []
                            },
                            kind: 'init',
                            order: '2'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'columnStateId',
                                loc: {
                                    start: {
                                        line: 289,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 289,
                                        column: 21,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Identifier',
                                name: 'columnStateId',
                                loc: {
                                    start: {
                                        line: 289,
                                        column: 23,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 289,
                                        column: 36,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            kind: 'init',
                            order: '3'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'columnState',
                                loc: {
                                    start: {
                                        line: 290,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 290,
                                        column: 19,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Identifier',
                                name: 'columnState',
                                loc: {
                                    start: {
                                        line: 290,
                                        column: 21,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 290,
                                        column: 32,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            kind: 'init',
                            order: '4'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'setRowOpen',
                                loc: {
                                    start: {
                                        line: 291,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 291,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context17) {
                                    return function (record, value) {
                                        var state = _context17.get('state');
                                        var _ref17 = record;
                                        var key = _ref17.key;
                                        if (value) {
                                            delete state.closedRowKeys[key];
                                        } else {
                                            state.closedRowKeys[key] = true;
                                        }
                                    };
                                }
                            },
                            kind: 'init',
                            order: '5'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'beginOp',
                                loc: {
                                    start: {
                                        line: 297,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 297,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context18) {
                                    return function () {
                                        var rowSource = _context18.get('rowSource');
                                        return rowSource.beginOp();
                                    };
                                }
                            },
                            kind: 'init',
                            order: '6'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'columns',
                                loc: {
                                    start: {
                                        line: 298,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 298,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Identifier',
                                name: 'columns',
                                loc: {
                                    start: {
                                        line: 298,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 298,
                                        column: 24,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            kind: 'init',
                            order: '7'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'getColumn',
                                loc: {
                                    start: {
                                        line: 299,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 299,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: false,
                                value: function (name) {
                                    {
                                        var _ref31 = this.columns;
                                        for (var _i11 = 0; _i11 < _ref31.length; _i11++) {
                                            var column = _ref31[_i11];
                                            if (column.name === name) {
                                                return column;
                                            }
                                        }
                                    }
                                    return null;
                                }
                            },
                            kind: 'init',
                            order: '8'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'rows',
                                loc: {
                                    start: {
                                        line: 304,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 304,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Identifier',
                                name: 'rows',
                                loc: {
                                    start: {
                                        line: 304,
                                        column: 14,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 304,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            kind: 'init',
                            order: '9'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'selectedColumns',
                                loc: {
                                    start: {
                                        line: 305,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 305,
                                        column: 23,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'ArrayExpression',
                                    elements: []
                                },
                                properties: [{
                                        type: 'ForOfStatement',
                                        left: {
                                            type: 'VariableDeclaration',
                                            declarations: [{
                                                    type: 'VariableDeclarator',
                                                    id: {
                                                        type: 'Identifier',
                                                        name: 'column',
                                                        loc: {
                                                            start: {
                                                                line: 305,
                                                                column: 37,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                            },
                                                            end: {
                                                                line: 305,
                                                                column: 43,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                            }
                                                        }
                                                    },
                                                    init: null
                                                }],
                                            kind: 'let'
                                        },
                                        right: {
                                            type: 'Identifier',
                                            name: 'columns',
                                            loc: {
                                                start: {
                                                    line: 305,
                                                    column: 47,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                },
                                                end: {
                                                    line: 305,
                                                    column: 54,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                }
                                            }
                                        },
                                        body: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'IfStatement',
                                                    test: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'column',
                                                            loc: {
                                                                start: {
                                                                    line: 305,
                                                                    column: 58,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                },
                                                                end: {
                                                                    line: 305,
                                                                    column: 64,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'selected',
                                                            loc: {
                                                                start: {
                                                                    line: 305,
                                                                    column: 65,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                },
                                                                end: {
                                                                    line: 305,
                                                                    column: 73,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 305,
                                                                column: 58,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                            },
                                                            end: {
                                                                line: 305,
                                                                column: 73,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                            }
                                                        }
                                                    },
                                                    consequent: {
                                                        type: 'BlockStatement',
                                                        body: [{
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'Identifier',
                                                                    name: 'column',
                                                                    loc: {
                                                                        start: {
                                                                            line: 305,
                                                                            column: 26,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                        },
                                                                        end: {
                                                                            line: 305,
                                                                            column: 32,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                        }
                                                                    }
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        order: '0'
                                    }]
                            },
                            kind: 'init',
                            order: ':'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'allRows',
                                        loc: {
                                            start: {
                                                line: 306,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                            },
                                            end: {
                                                line: 306,
                                                column: 19,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'ObjectExpression',
                                        objectType: {
                                            type: 'ArrayExpression',
                                            elements: []
                                        },
                                        properties: [{
                                                type: 'ForOfStatement',
                                                left: {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'child',
                                                                loc: {
                                                                    start: {
                                                                        line: 307,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                    },
                                                                    end: {
                                                                        line: 307,
                                                                        column: 21,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: null
                                                        }],
                                                    kind: 'let'
                                                },
                                                right: {
                                                    type: 'Identifier',
                                                    name: 'rows',
                                                    loc: {
                                                        start: {
                                                            line: 307,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                        },
                                                        end: {
                                                            line: 307,
                                                            column: 29,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                        }
                                                    }
                                                },
                                                body: {
                                                    type: 'BlockStatement',
                                                    body: [{
                                                            type: 'ForOfStatement',
                                                            left: {
                                                                type: 'VariableDeclaration',
                                                                declarations: [{
                                                                        type: 'VariableDeclarator',
                                                                        id: {
                                                                            type: 'Identifier',
                                                                            name: 'gchild',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 308,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 308,
                                                                                    column: 26,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        init: null
                                                                    }],
                                                                kind: 'let'
                                                            },
                                                            right: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'child',
                                                                    loc: {
                                                                        start: {
                                                                            line: 308,
                                                                            column: 30,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                        },
                                                                        end: {
                                                                            line: 308,
                                                                            column: 35,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'selfAndChildren',
                                                                    loc: {
                                                                        start: {
                                                                            line: 308,
                                                                            column: 36,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                        },
                                                                        end: {
                                                                            line: 308,
                                                                            column: 51,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 308,
                                                                        column: 30,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                    },
                                                                    end: {
                                                                        line: 308,
                                                                        column: 51,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                    }
                                                                }
                                                            },
                                                            body: {
                                                                type: 'BlockStatement',
                                                                body: [{
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'Identifier',
                                                                            name: 'gchild',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 309,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 309,
                                                                                    column: 26,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 309,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                            },
                                                                            end: {
                                                                                line: 309,
                                                                                column: 26,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                            }
                                                                        },
                                                                        order: '0'
                                                                    }]
                                                            },
                                                            remove: null,
                                                            order: '0'
                                                        }]
                                                },
                                                remove: null,
                                                order: '0'
                                            }]
                                    }
                                }],
                            kind: 'let',
                            order: ';'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'allRows',
                                loc: {
                                    start: {
                                        line: 310,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 310,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Identifier',
                                name: 'allRows',
                                loc: {
                                    start: {
                                        line: 310,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 310,
                                        column: 24,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            kind: 'init',
                            order: '<'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'selectedRows',
                                loc: {
                                    start: {
                                        line: 311,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 311,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'ArrayExpression',
                                    elements: []
                                },
                                properties: [{
                                        type: 'ForOfStatement',
                                        left: {
                                            type: 'VariableDeclaration',
                                            declarations: [{
                                                    type: 'VariableDeclarator',
                                                    id: {
                                                        type: 'Identifier',
                                                        name: 'row',
                                                        loc: {
                                                            start: {
                                                                line: 311,
                                                                column: 31,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                            },
                                                            end: {
                                                                line: 311,
                                                                column: 34,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                            }
                                                        }
                                                    },
                                                    init: null
                                                }],
                                            kind: 'let'
                                        },
                                        right: {
                                            type: 'Identifier',
                                            name: 'allRows',
                                            loc: {
                                                start: {
                                                    line: 311,
                                                    column: 38,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                },
                                                end: {
                                                    line: 311,
                                                    column: 45,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                }
                                            }
                                        },
                                        body: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'IfStatement',
                                                    test: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'row',
                                                            loc: {
                                                                start: {
                                                                    line: 311,
                                                                    column: 49,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                },
                                                                end: {
                                                                    line: 311,
                                                                    column: 52,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'selected',
                                                            loc: {
                                                                start: {
                                                                    line: 311,
                                                                    column: 53,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                },
                                                                end: {
                                                                    line: 311,
                                                                    column: 61,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 311,
                                                                column: 49,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                            },
                                                            end: {
                                                                line: 311,
                                                                column: 61,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                            }
                                                        }
                                                    },
                                                    consequent: {
                                                        type: 'BlockStatement',
                                                        body: [{
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'Identifier',
                                                                    name: 'row',
                                                                    loc: {
                                                                        start: {
                                                                            line: 311,
                                                                            column: 23,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                        },
                                                                        end: {
                                                                            line: 311,
                                                                            column: 26,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                                        }
                                                                    }
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        order: '0'
                                    }]
                            },
                            kind: 'init',
                            order: '='
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'hasRowSelection',
                                        loc: {
                                            start: {
                                                line: 312,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                            },
                                            end: {
                                                line: 312,
                                                column: 27,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'BinaryExpression',
                                        operator: '>',
                                        left: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'dataTableModel',
                                                    loc: {
                                                        start: {
                                                            line: 312,
                                                            column: 30,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                        },
                                                        end: {
                                                            line: 312,
                                                            column: 44,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'selectedRows',
                                                    loc: {
                                                        start: {
                                                            line: 312,
                                                            column: 45,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                        },
                                                        end: {
                                                            line: 312,
                                                            column: 57,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 312,
                                                        column: 30,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    },
                                                    end: {
                                                        line: 312,
                                                        column: 57,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'length',
                                                loc: {
                                                    start: {
                                                        line: 312,
                                                        column: 58,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    },
                                                    end: {
                                                        line: 312,
                                                        column: 64,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 312,
                                                    column: 30,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                },
                                                end: {
                                                    line: 312,
                                                    column: 64,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                }
                                            }
                                        },
                                        right: {
                                            type: 'Literal',
                                            value: 0
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '>'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'hasColumnSelection',
                                        loc: {
                                            start: {
                                                line: 313,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                            },
                                            end: {
                                                line: 313,
                                                column: 30,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'BinaryExpression',
                                        operator: '>',
                                        left: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'dataTableModel',
                                                    loc: {
                                                        start: {
                                                            line: 313,
                                                            column: 33,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                        },
                                                        end: {
                                                            line: 313,
                                                            column: 47,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'selectedColumns',
                                                    loc: {
                                                        start: {
                                                            line: 313,
                                                            column: 48,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                        },
                                                        end: {
                                                            line: 313,
                                                            column: 63,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 313,
                                                        column: 33,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    },
                                                    end: {
                                                        line: 313,
                                                        column: 63,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'length',
                                                loc: {
                                                    start: {
                                                        line: 313,
                                                        column: 64,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    },
                                                    end: {
                                                        line: 313,
                                                        column: 70,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 313,
                                                    column: 33,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                },
                                                end: {
                                                    line: 313,
                                                    column: 70,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                                }
                                            }
                                        },
                                        right: {
                                            type: 'Literal',
                                            value: 0
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '?'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'hasRowSelection',
                                loc: {
                                    start: {
                                        line: 314,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 314,
                                        column: 23,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Identifier',
                                name: 'hasRowSelection',
                                loc: {
                                    start: {
                                        line: 314,
                                        column: 25,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 314,
                                        column: 40,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            kind: 'init',
                            order: '@'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'hasColumnSelection',
                                loc: {
                                    start: {
                                        line: 315,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 315,
                                        column: 26,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Identifier',
                                name: 'hasColumnSelection',
                                loc: {
                                    start: {
                                        line: 315,
                                        column: 28,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 315,
                                        column: 46,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            kind: 'init',
                            order: 'A'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'hasSelection',
                                loc: {
                                    start: {
                                        line: 316,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 316,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'BinaryExpression',
                                operator: '||',
                                left: {
                                    type: 'Identifier',
                                    name: 'hasRowSelection',
                                    loc: {
                                        start: {
                                            line: 316,
                                            column: 22,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 316,
                                            column: 37,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                },
                                right: {
                                    type: 'Identifier',
                                    name: 'hasColumnSelection',
                                    loc: {
                                        start: {
                                            line: 316,
                                            column: 41,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        },
                                        end: {
                                            line: 316,
                                            column: 59,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                        }
                                    }
                                }
                            },
                            kind: 'init',
                            order: 'B'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'clearSelection',
                                loc: {
                                    start: {
                                        line: 317,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 317,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: false,
                                value: function () {
                                    this.select(null, null);
                                }
                            },
                            kind: 'init',
                            order: 'C'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'selectAll',
                                loc: {
                                    start: {
                                        line: 319,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 319,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: false,
                                value: function () {
                                    this.selectAllColumns();
                                    this.selectAllRows();
                                }
                            },
                            kind: 'init',
                            order: 'D'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'selectAllColumns',
                                loc: {
                                    start: {
                                        line: 322,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 322,
                                        column: 24,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: false,
                                value: function (value) {
                                    {
                                        var _ref32 = this.columns;
                                        for (var _i12 = 0; _i12 < _ref32.length; _i12++) {
                                            var column = _ref32[_i12];
                                            column.setSelected(value);
                                        }
                                    }
                                }
                            },
                            kind: 'init',
                            order: 'E'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'selectAllRows',
                                loc: {
                                    start: {
                                        line: 325,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 325,
                                        column: 21,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: false,
                                value: function (value) {
                                    {
                                        var _ref33 = this.allRows;
                                        for (var _i13 = 0; _i13 < _ref33.length; _i13++) {
                                            var row = _ref33[_i13];
                                            row.setSelected(value);
                                        }
                                    }
                                }
                            },
                            kind: 'init',
                            order: 'F'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'select',
                                loc: {
                                    start: {
                                        line: 328,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 328,
                                        column: 14,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: false,
                                value: function (column, row, add) {
                                    if (!add) {
                                        this.selectAllRows(false);
                                        this.selectAllColumns(false);
                                    }
                                    column != null ? column.setSelected() : void 0;
                                    row != null ? row.setSelected() : void 0;
                                }
                            },
                            kind: 'init',
                            order: 'G'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'selectColumn',
                                loc: {
                                    start: {
                                        line: 334,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 334,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: false,
                                value: function (name, value) {
                                    if (value == null)
                                        value = true;
                                    {
                                        var _ref34 = this.columns;
                                        for (var _i14 = 0; _i14 < _ref34.length; _i14++) {
                                            var column = _ref34[_i14];
                                            if (column.name === name) {
                                                column.setSelected(value);
                                            }
                                        }
                                    }
                                }
                            },
                            kind: 'init',
                            order: 'H'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'getAvailableColumnProperties',
                                loc: {
                                    start: {
                                        line: 338,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 338,
                                        column: 36,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context19) {
                                    return function () {
                                        var columnSource = _context19.get('columnSource'), Schema = _context19.get('Schema');
                                        var properties = [];
                                        {
                                            var _ref35 = columnSource.availableColumnNames;
                                            for (var _i15 = 0; _i15 < _ref35.length; _i15++) {
                                                var name = _ref35[_i15];
                                                if (typeof name === 'object') {
                                                    properties.push(name);
                                                } else {
                                                    var property = columnSource.properties[name];
                                                    if (Schema.isVisible(property)) {
                                                        properties.push(property);
                                                    }
                                                }
                                            }
                                        }
                                        properties.sort(function (a, b) {
                                            var aName = Schema.getDisplayName(a);
                                            var bName = Schema.getDisplayName(b);
                                            return aName.localeCompare(bName);
                                        });
                                        return properties;
                                    };
                                }
                            },
                            kind: 'init',
                            order: 'I'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'insertColumn',
                                loc: {
                                    start: {
                                        line: 357,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 357,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context20) {
                                    return function (name, insertAfterName) {
                                        var columnSource = _context20.get('columnSource'), ion = _context20.get('ion');
                                        columnSource.insertColumn(name, insertAfterName);
                                        ion.sync();
                                        this.selectColumn(name, true);
                                    };
                                }
                            },
                            kind: 'init',
                            order: 'J'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'deleteColumn',
                                loc: {
                                    start: {
                                        line: 361,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 361,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context21) {
                                    return function (name) {
                                        var columnSource = _context21.get('columnSource');
                                        this.selectColumn(name, false);
                                        columnSource.deleteColumn(name);
                                    };
                                }
                            },
                            kind: 'init',
                            order: 'K'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'resetColumns',
                                loc: {
                                    start: {
                                        line: 364,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 364,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context22) {
                                    return function () {
                                        var columnSource = _context22.get('columnSource');
                                        columnSource.resetColumns();
                                        this.clearSelection();
                                    };
                                }
                            },
                            kind: 'init',
                            order: 'L'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'moveSelectedColumns',
                                        loc: {
                                            start: {
                                                line: 367,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                            },
                                            end: {
                                                line: 367,
                                                column: 31,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context23) {
                                            return function (offset) {
                                                var dataTableModel = _context23.get('dataTableModel'), columnSource = _context23.get('columnSource');
                                                var _ref22 = [];
                                                {
                                                    var _ref36 = dataTableModel.selectedColumns;
                                                    for (var _i16 = 0; _i16 < _ref36.length; _i16++) {
                                                        var c = _ref36[_i16];
                                                        if (!c.fixed) {
                                                            _ref22.push(c.name);
                                                        }
                                                    }
                                                }
                                                var names = _ref22;
                                                columnSource.moveColumns(names, offset);
                                            };
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: 'M'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'resizeSelectedColumns',
                                loc: {
                                    start: {
                                        line: 370,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 370,
                                        column: 29,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context24) {
                                    return function (offset) {
                                        var dataTableModel = _context24.get('dataTableModel'), columnSource = _context24.get('columnSource');
                                        var _ref23 = [];
                                        {
                                            var _ref37 = dataTableModel.selectedColumns;
                                            for (var _i17 = 0; _i17 < _ref37.length; _i17++) {
                                                var c = _ref37[_i17];
                                                _ref23.push(c.name);
                                            }
                                        }
                                        var names = _ref23;
                                        for (var _i18 = 0; _i18 < names.length; _i18++) {
                                            var name = names[_i18];
                                            columnSource.resizeColumn(name, null, offset);
                                        }
                                    };
                                }
                            },
                            kind: 'init',
                            order: 'N'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'moveSelectedColumns',
                                loc: {
                                    start: {
                                        line: 374,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 374,
                                        column: 27,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Identifier',
                                name: 'moveSelectedColumns',
                                loc: {
                                    start: {
                                        line: 374,
                                        column: 29,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 374,
                                        column: 48,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            kind: 'init',
                            order: 'O'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'moveSelectedColumnsRight',
                                loc: {
                                    start: {
                                        line: 375,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 375,
                                        column: 32,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context25) {
                                    return function () {
                                        var moveSelectedColumns = _context25.get('moveSelectedColumns');
                                        moveSelectedColumns(+1);
                                    };
                                }
                            },
                            kind: 'init',
                            order: 'P'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'moveSelectedColumnsLeft',
                                loc: {
                                    start: {
                                        line: 377,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 377,
                                        column: 31,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context26) {
                                    return function () {
                                        var moveSelectedColumns = _context26.get('moveSelectedColumns');
                                        moveSelectedColumns(-1);
                                    };
                                }
                            },
                            kind: 'init',
                            order: 'Q'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'moveRowsUp',
                                loc: {
                                    start: {
                                        line: 381,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 381,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context27) {
                                    return function () {
                                        var moveUp = _context27.get('moveUp'), dataTableModel = _context27.get('dataTableModel');
                                        return moveUp(dataTableModel);
                                    };
                                }
                            },
                            kind: 'init',
                            order: 'R'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'moveRowsDown',
                                loc: {
                                    start: {
                                        line: 382,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 382,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context28) {
                                    return function () {
                                        var moveDown = _context28.get('moveDown'), dataTableModel = _context28.get('dataTableModel');
                                        return moveDown(dataTableModel);
                                    };
                                }
                            },
                            kind: 'init',
                            order: 'S'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'indentRows',
                                loc: {
                                    start: {
                                        line: 383,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 383,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context29) {
                                    return function () {
                                        var indent = _context29.get('indent'), dataTableModel = _context29.get('dataTableModel');
                                        return indent(dataTableModel);
                                    };
                                }
                            },
                            kind: 'init',
                            order: 'T'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'outdentRows',
                                loc: {
                                    start: {
                                        line: 384,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 384,
                                        column: 19,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context30) {
                                    return function () {
                                        var outdent = _context30.get('outdent'), dataTableModel = _context30.get('dataTableModel');
                                        return outdent(dataTableModel);
                                    };
                                }
                            },
                            kind: 'init',
                            order: 'U'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'getSelectionAsMime',
                                loc: {
                                    start: {
                                        line: 387,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 387,
                                        column: 26,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context31) {
                                    return function (mimeType) {
                                        if (mimeType == null)
                                            mimeType = 'application/json';
                                        var Schema = _context31.get('Schema');
                                        var columns = this.selectedColumns;
                                        if (columns.length === 0) {
                                            var _ref24 = [];
                                            {
                                                var _ref38 = this.columns;
                                                for (var _i19 = 0; _i19 < _ref38.length; _i19++) {
                                                    var column = _ref38[_i19];
                                                    if (!column.isRowSelect) {
                                                        _ref24.push(column);
                                                    }
                                                }
                                            }
                                            columns = _ref24;
                                        }
                                        var rows = this.selectedRows;
                                        if (rows.length === 0) {
                                            rows = [null].concat(this.allRows);
                                        }
                                        var jsonValue = [];
                                        for (var _i20 = 0; _i20 < rows.length; _i20++) {
                                            var row = rows[_i20];
                                            var _ref46 = [];
                                            for (var _i21 = 0; _i21 < columns.length; _i21++) {
                                                var column = columns[_i21];
                                                if (row != null) {
                                                    _ref46.push(column.getMimeValueFromRow(row, mimeType));
                                                } else {
                                                    _ref46.push(Schema.getLabel(column));
                                                }
                                            }
                                            jsonValue.push(_ref46);
                                        }
                                        if (mimeType === 'text/plain') {
                                            var _ref25 = [];
                                            for (var _i22 = 0; _i22 < jsonValue.length; _i22++) {
                                                var row = jsonValue[_i22];
                                                _ref25.push(row.join('\t'));
                                            }
                                            return _ref25.join('\n');
                                        } else if (mimeType === 'application/json') {
                                            return JSON.stringify(jsonValue);
                                        } else {
                                            throw new Error('Unsupported mimetype: ' + mimeType);
                                        }
                                    };
                                }
                            },
                            kind: 'init',
                            order: 'V'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'copySelection',
                                loc: {
                                    start: {
                                        line: 409,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 409,
                                        column: 21,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: false,
                                value: function () {
                                    global.internalClipboardData = this.getSelectionAsMime();
                                    console.log(global.internalClipboardData);
                                }
                            },
                            kind: 'init',
                            order: 'W'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'cutSelection',
                                loc: {
                                    start: {
                                        line: 412,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 412,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: false,
                                value: function () {
                                    this.copySelection();
                                    this.deleteSelection();
                                }
                            },
                            kind: 'init',
                            order: 'X'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'pasteSelection',
                                loc: {
                                    start: {
                                        line: 415,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 415,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: false,
                                value: function () {
                                    if (global.internalClipboardData != null) {
                                        this.setSelectionFromMime(global.internalClipboardData);
                                    }
                                }
                            },
                            kind: 'init',
                            order: 'Y'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'deleteSelection',
                                loc: {
                                    start: {
                                        line: 418,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 418,
                                        column: 23,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context32) {
                                    return function () {
                                        var rowSource = _context32.get('rowSource'), Schema = _context32.get('Schema');
                                        rowSource.beginOp();
                                        if (this.selectedColumns.length === 0) {
                                            {
                                                var _ref39 = this.selectedRows;
                                                for (var _i23 = 0; _i23 < _ref39.length; _i23++) {
                                                    var row = _ref39[_i23];
                                                    row.delete();
                                                }
                                            }
                                        } else {
                                            {
                                                var _ref40 = this.selectedRows;
                                                for (var _i24 = 0; _i24 < _ref40.length; _i24++) {
                                                    var _ref47 = _ref40[_i24];
                                                    var record = _ref47.record;
                                                    {
                                                        var _ref41 = this.selectedColumns;
                                                        for (var _i25 = 0; _i25 < _ref41.length; _i25++) {
                                                            var column = _ref41[_i25];
                                                            Schema.set(record, column, void 0);
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    };
                                }
                            },
                            kind: 'init',
                            order: 'Z'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'deleteSelectedRows',
                                loc: {
                                    start: {
                                        line: 427,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 427,
                                        column: 26,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context33) {
                                    return function () {
                                        var rowSource = _context33.get('rowSource');
                                        rowSource.beginOp();
                                        {
                                            var _ref42 = this.selectedRows;
                                            for (var _i26 = 0; _i26 < _ref42.length; _i26++) {
                                                var row = _ref42[_i26];
                                                row.delete();
                                            }
                                        }
                                    };
                                }
                            },
                            kind: 'init',
                            order: '['
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'setSelectionFromMime',
                                loc: {
                                    start: {
                                        line: 431,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    },
                                    end: {
                                        line: 431,
                                        column: 28,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DataTableModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context34) {
                                    return function (data, mimeType) {
                                        if (mimeType == null)
                                            mimeType = 'application/json';
                                        var rowSource = _context34.get('rowSource'), Schema = _context34.get('Schema');
                                        rowSource.beginOp();
                                        var inputRows = null;
                                        if (mimeType === 'application/json') {
                                            inputRows = JSON.parse(data);
                                        } else if (mimeType === 'text/plain') {
                                            var _ref26 = [];
                                            {
                                                var _ref43 = data.split('\n');
                                                for (var _i27 = 0; _i27 < _ref43.length; _i27++) {
                                                    var row = _ref43[_i27];
                                                    _ref26.push(row.split('\t'));
                                                }
                                            }
                                            inputRows = _ref26;
                                        } else {
                                            throw new Error('Unsupported mimetype: ' + mimeType);
                                        }
                                        var rows = this.selectedRows;
                                        if (rows.length === 0) {
                                            rows = [null].concat(this.allRows);
                                        }
                                        var columns = this.selectedColumns;
                                        if (columns.length === 0) {
                                            var _ref27 = [];
                                            {
                                                var _ref44 = this.columns;
                                                for (var _i28 = 0; _i28 < _ref44.length; _i28++) {
                                                    var column = _ref44[_i28];
                                                    if (!column.isRowSelect) {
                                                        _ref27.push(column);
                                                    }
                                                }
                                            }
                                            columns = _ref27;
                                        }
                                        for (var _i29 = 0; _i29 < rows.length; _i29++) {
                                            var relativeRowIndex = _i29;
                                            var row = rows[_i29];
                                            if (row != null) {
                                                var _ref18 = row;
                                                var record = _ref18.record;
                                                for (var _i30 = 0; _i30 < columns.length; _i30++) {
                                                    var relativeColumnIndex = _i30;
                                                    var column = columns[_i30];
                                                    var copyRowIndex = relativeRowIndex % inputRows.length;
                                                    var cells = inputRows[copyRowIndex];
                                                    var copyColumnIndex = relativeColumnIndex % cells.length;
                                                    var value = cells[copyColumnIndex];
                                                    Schema.set(record, column, value);
                                                }
                                            }
                                        }
                                    };
                                }
                            },
                            kind: 'init',
                            order: '\\'
                        }
                    ]
                },
                order: 'A'
            }
        ],
        bound: false
    }, {
        this: this,
        ion: ion,
        args: args,
        _ref: _ref,
        getColumnType: getColumnType,
        Schema: Schema,
        CustomColumnSource: CustomColumnSource,
        getSortPropertySchemaForMove: getSortPropertySchemaForMove,
        hasSelectedAncestor: hasSelectedAncestor,
        getMoveRowsAndAllRows: getMoveRowsAndAllRows,
        indent: indent,
        outdent: outdent,
        moveUp: moveUp,
        moveDown: moveDown,
        decorateRow: decorateRow,
        decorateColumn: decorateColumn
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/DataTable2/DataTableModel',_glass_html_material_DataTable2_DataTableModel_);
    else
      _glass_html_material_DataTable2_DataTableModel_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_DataTable2_DataTableModel_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_DataTable2_DataTableStyle_ = function(module,exports,require){'use strict';
var _ref = require('../../'), selectOpacity = 0.08;
var style = _ref.style;
module.exports = exports = { selectOpacity: selectOpacity };
var _ref2 = style.sheets;
_ref2[module.id] = '.DataTable2 {\n    position: relative; /* so min-width % will be relative to datatable */\n    overflow: hidden; /* prevent header scrolling dropshadow from drawing above */\n    user-select: none;\n    cursor: default;\n    font-family: "Roboto", sans-serif;\n    display: flex;\n    flex-direction: column;\n    flex: 1 1 auto;\n}\n.DataTable2 * {\n    box-sizing: border-box;\n}\n.DataTable2 .header, .DataTable2 .footer {\n    min-height: 10px;\n    flex: 0 0 auto;\n    font-size: 12px;\n    color: rgba(0,0,0,0.54);\n    font-weight: 500;\n    overflow: hidden;\n}\n.DataTable2.scroll-vertical .header, .DataTable2.scroll-vertical .footer {\n    /* header scrollbar only if body needs auto scrollbar */\n    overflow-y: scroll;\n}\n.DataTable2 .header::-webkit-scrollbar, .DataTable2 .footer::-webkit-scrollbar {\n    visibility: hidden;\n}\n.DataTable2 .body {\n    flex: 1 1 auto;\n\n    /* needed for underlay to show up behind */\n    position: relative;\n    z-index: 0;\n    overflow: auto;\n    /*\n    overflow-x: auto;\n    overflow-y: scroll;\n    */\n    font-size: 13px;\n    color: rgba(0,0,0,0.87);\n    font-weight: 400;\n}\n.DataTable2 .row {\n    display: inline-block;\n    min-width: 100%;\n}\n.DataTable2.rowmode .row.selected > .cells {\n    background: rgba(0,0,0,' + selectOpacity * 1 + ');\n}\n.DataTable2 .row.parent > .cells {\n    font-weight: 500;\n}\n.DataTable2 .cells {\n    display: inline-flex;\n    width: 100%;\n    flex-direction: row;\n    border-bottom: solid 1px rgba(0,0,0,0.12);\n}\n.DataTable2 .footer .cells {\n    border-top: solid 1px rgba(0,0,0,0.12);\n    border-bottom: none;\n}\n.DataTable2.bottom-visible:not(.top-visible) .footer .cells {\n    /* scrolled to the bottom, remove the border because the last row has bottom border */\n    border-top: none;\n}\n.DataTable2 .header .cells > SPAN, .DataTable2 .footer .cells > SPAN {\n    min-height: 54px;\n}\n.DataTable2 .body .cells > SPAN {\n    /* min-height: 48px; */\n    min-height: 36px;\n}\n.DataTable2 .cells > SPAN:focus {\n    background: rgba(0,0,0,' + selectOpacity * 2 + ') !important;\n}\n.DataTable2 .underlay.row {\n    position: absolute; /* remove from the html flow */\n    z-index: -1;\n}\n.DataTable2 .underlay.row > .cells {\n    border: none;\n}\n.DataTable2 .underlay.row > .cells > SPAN {\n    overflow: visible !important;\n    padding: 0px !important;\n    margin: 0px !important;\n    background: none !important;\n}\n.DataTable2 .cells > SPAN {\n    white-space: nowrap;\n    outline: none;\n    overflow: hidden;\n    display: flex;\n    align-items: center;\n}\n.DataTable2 .body .cells > SPAN:focus {\n    white-space: normal;\n}\n.DataTable2 .cells > SPAN:last-of-type {\n    flex: 1 1 auto;\n}\n.DataTable2 .cells > SPAN > SPAN {\n    overflow: hidden;\n    text-overflow: ellipsis;\n    margin-top: 6px;\n    margin-bottom: 6px;\n}\n.DataTable2:not(.top-visible) > .header {\n    box-shadow: 0 2px 6px rgba(0,0,0,0.12), 0 2px 4px rgba(0,0,0,0.24);\n}\n.DataTable2:not(.bottom-visible) > .footer {\n    box-shadow: 0 -1px 5px rgba(0,0,0,0.12), 0 -1px 4px rgba(0,0,0,0.24);\n}';
_ref2;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/DataTable2/DataTableStyle',_glass_html_material_DataTable2_DataTableStyle_);
    else
      _glass_html_material_DataTable2_DataTableStyle_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_DataTable2_DataTableStyle_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_DataTable2_DefaultColumn_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('../../../data'), _ref2, ColumnChooser = require('./ColumnChooser'), _ref3, getDefaultWidth = function (property) {
        if (property.defaultWidth != null) {
            return property.defaultWidth;
        }
        if (property.type === 'number' || property.type === 'integer') {
            return 80;
        }
        if (property.type === 'boolean') {
            return 80;
        }
        if (property.format === 'date-time') {
            return 160;
        }
        if (property.type === 'string') {
            return 150;
        }
        return 100;
    };
var Schema = _ref.Schema;
_ref2 = require('../../../convert');
var jsonValueToDisplayValue = _ref2.jsonValueToDisplayValue;
_ref3 = require('../');
var Resizer = _ref3.Resizer;
var DragMover = _ref3.DragMover;
module.exports = exports = ion.template(function DefaultColumn(property) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'DefaultColumn',
            loc: {
                start: {
                    line: 20,
                    column: 16,
                    fixed: true,
                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                },
                end: {
                    line: 20,
                    column: 29,
                    fixed: true,
                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                }
            }
        },
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'column',
                            loc: {
                                start: {
                                    line: 21,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                },
                                end: {
                                    line: 21,
                                    column: 14,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            properties: [{
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'property',
                                        loc: {
                                            start: {
                                                line: 21,
                                                column: 18,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                            },
                                            end: {
                                                line: 21,
                                                column: 26,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Identifier',
                                        name: 'property',
                                        loc: {
                                            start: {
                                                line: 21,
                                                column: 18,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                            },
                                            end: {
                                                line: 21,
                                                column: 26,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '0'
                                }]
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'Identifier',
                        name: 'column',
                        loc: {
                            start: {
                                line: 24,
                                column: 11,
                                fixed: true,
                                source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                            },
                            end: {
                                line: 24,
                                column: 17,
                                fixed: true,
                                source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                            }
                        }
                    },
                    properties: [
                        {
                            type: 'ForInStatement',
                            left: {
                                type: 'VariableDeclaration',
                                declarations: [
                                    {
                                        type: 'VariableDeclarator',
                                        id: {
                                            type: 'Identifier',
                                            name: 'k',
                                            loc: {
                                                start: {
                                                    line: 25,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                },
                                                end: {
                                                    line: 25,
                                                    column: 13,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                }
                                            }
                                        },
                                        init: null
                                    },
                                    {
                                        type: 'VariableDeclarator',
                                        id: {
                                            type: 'Identifier',
                                            name: 'v',
                                            loc: {
                                                start: {
                                                    line: 25,
                                                    column: 15,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                },
                                                end: {
                                                    line: 25,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                }
                                            }
                                        },
                                        init: null
                                    }
                                ],
                                kind: 'let'
                            },
                            right: {
                                type: 'Identifier',
                                name: 'property',
                                loc: {
                                    start: {
                                        line: 25,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                    },
                                    end: {
                                        line: 25,
                                        column: 28,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                    }
                                }
                            },
                            body: {
                                type: 'BlockStatement',
                                body: [{
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'k',
                                            loc: {
                                                start: {
                                                    line: 26,
                                                    column: 13,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                },
                                                end: {
                                                    line: 26,
                                                    column: 14,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Identifier',
                                            name: 'v',
                                            loc: {
                                                start: {
                                                    line: 26,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                },
                                                end: {
                                                    line: 26,
                                                    column: 18,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                }
                                            }
                                        },
                                        kind: 'init',
                                        computed: true,
                                        order: '0'
                                    }]
                            },
                            remove: null,
                            order: '0'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'clicksToEdit',
                                loc: {
                                    start: {
                                        line: 27,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                    },
                                    end: {
                                        line: 27,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Literal',
                                value: 2
                            },
                            kind: 'init',
                            order: '1'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'canEdit',
                                loc: {
                                    start: {
                                        line: 28,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                    },
                                    end: {
                                        line: 28,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context) {
                                    return function (dataTableModel, object) {
                                        var property = _context.get('property'), Schema = _context.get('Schema');
                                        return property != null ? Schema.canSet(property) : true;
                                    };
                                }
                            },
                            kind: 'init',
                            order: '2'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'defaultWidth',
                                loc: {
                                    start: {
                                        line: 29,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                    },
                                    end: {
                                        line: 29,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'getDefaultWidth',
                                    loc: {
                                        start: {
                                            line: 29,
                                            column: 22,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                        },
                                        end: {
                                            line: 29,
                                            column: 37,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'Identifier',
                                        name: 'property',
                                        loc: {
                                            start: {
                                                line: 29,
                                                column: 38,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                            },
                                            end: {
                                                line: 29,
                                                column: 46,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                            }
                                        }
                                    }],
                                loc: {
                                    start: {
                                        line: 29,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                    },
                                    end: {
                                        line: 29,
                                        column: 47,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                    }
                                }
                            },
                            kind: 'init',
                            order: '3'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'getMimeValueFromRow',
                                loc: {
                                    start: {
                                        line: 30,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                    },
                                    end: {
                                        line: 30,
                                        column: 27,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context2) {
                                    return function (row, mimeType) {
                                        var jsonValueToDisplayValue = _context2.get('jsonValueToDisplayValue'), property = _context2.get('property'), Schema = _context2.get('Schema');
                                        if (mimeType === 'text/plain') {
                                            return jsonValueToDisplayValue(property, Schema.get(row.record, property));
                                        } else {
                                            return Schema.get(row.record, property);
                                        }
                                    };
                                }
                            },
                            kind: 'init',
                            order: '4'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'createCssRules',
                                loc: {
                                    start: {
                                        line: 36,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                    },
                                    end: {
                                        line: 36,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context3) {
                                    return function (dataTableModel) {
                                        var column = _context3.get('column');
                                        return {
                                            '': 'padding-left: 12px;\npadding-right: 12px;\nborder-left: none;\nposition: relative;',
                                            ' .Resizer': 'position: absolute;\nleft: ' + (column.width - 18) + 'px;\nwidth: 18px;\nheight: 100%;'
                                        };
                                    };
                                }
                            },
                            kind: 'init',
                            order: '5'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'createHeaderCell',
                                loc: {
                                    start: {
                                        line: 48,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                    },
                                    end: {
                                        line: 48,
                                        column: 24,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_ps) {
                                    return ion.template(function (dataTableModel) {
                                        return ion.createRuntime({
                                            type: 'Template',
                                            id: null,
                                            body: [
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: '_ref4'
                                                            },
                                                            init: {
                                                                type: 'Identifier',
                                                                name: 'dataTableModel',
                                                                loc: {
                                                                    start: {
                                                                        line: 49,
                                                                        column: 28,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 49,
                                                                        column: 42,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'columns',
                                                                loc: {
                                                                    start: {
                                                                        line: 49,
                                                                        column: 17,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 49,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'MemberExpression',
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: '_ref4'
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'columns',
                                                                    loc: {
                                                                        start: {
                                                                            line: 49,
                                                                            column: 17,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 49,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                computed: false
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '1'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'cell',
                                                                loc: {
                                                                    start: {
                                                                        line: 50,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 50,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Identifier',
                                                                    name: 'Span',
                                                                    loc: {
                                                                        start: {
                                                                            line: 50,
                                                                            column: 23,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 50,
                                                                            column: 27,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [],
                                                                loc: {
                                                                    start: {
                                                                        line: 50,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 50,
                                                                        column: 29,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '2'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'index',
                                                                loc: {
                                                                    start: {
                                                                        line: 51,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 51,
                                                                        column: 21,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'columns',
                                                                        loc: {
                                                                            start: {
                                                                                line: 51,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 51,
                                                                                column: 31,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'indexOf',
                                                                        loc: {
                                                                            start: {
                                                                                line: 51,
                                                                                column: 32,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 51,
                                                                                column: 39,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 51,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 51,
                                                                            column: 39,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'Identifier',
                                                                        name: 'column',
                                                                        loc: {
                                                                            start: {
                                                                                line: 51,
                                                                                column: 40,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 51,
                                                                                column: 46,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                            }
                                                                        }
                                                                    }],
                                                                loc: {
                                                                    start: {
                                                                        line: 51,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 51,
                                                                        column: 47,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '3'
                                                },
                                                {
                                                    type: 'ReturnStatement',
                                                    argument: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'Identifier',
                                                            name: 'cell',
                                                            loc: {
                                                                start: {
                                                                    line: 52,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                },
                                                                end: {
                                                                    line: 52,
                                                                    column: 23,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'ObjectExpression',
                                                                    objectType: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'Identifier',
                                                                            name: 'Span',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 53,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 53,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [{
                                                                                type: 'ObjectExpression',
                                                                                properties: [{
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'class',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 53,
                                                                                                    column: 22,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 53,
                                                                                                    column: 27,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'ConditionalExpression',
                                                                                            test: {
                                                                                                type: 'MemberExpression',
                                                                                                computed: false,
                                                                                                object: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'column',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 53,
                                                                                                            column: 29,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 53,
                                                                                                            column: 35,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'fixed',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 53,
                                                                                                            column: 36,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 53,
                                                                                                            column: 41,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 53,
                                                                                                        column: 29,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 53,
                                                                                                        column: 41,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            consequent: {
                                                                                                type: 'Literal',
                                                                                                value: ''
                                                                                            },
                                                                                            alternate: {
                                                                                                type: 'Literal',
                                                                                                value: 'grab'
                                                                                            }
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    }]
                                                                            }],
                                                                        loc: {
                                                                            start: {
                                                                                line: 53,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 53,
                                                                                column: 57,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    properties: [
                                                                        {
                                                                            type: 'IfStatement',
                                                                            test: {
                                                                                type: 'BinaryExpression',
                                                                                operator: '&&',
                                                                                left: {
                                                                                    type: 'BinaryExpression',
                                                                                    operator: '&&',
                                                                                    left: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'column',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 54,
                                                                                                    column: 23,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 54,
                                                                                                    column: 29,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'selected',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 54,
                                                                                                    column: 30,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 54,
                                                                                                    column: 38,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 54,
                                                                                                column: 23,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 54,
                                                                                                column: 38,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    right: {
                                                                                        type: 'BinaryExpression',
                                                                                        operator: '!==',
                                                                                        left: {
                                                                                            type: 'MemberExpression',
                                                                                            computed: false,
                                                                                            object: {
                                                                                                type: 'MemberExpression',
                                                                                                computed: true,
                                                                                                object: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'columns',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 54,
                                                                                                            column: 43,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 54,
                                                                                                            column: 50,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'BinaryExpression',
                                                                                                    operator: '-',
                                                                                                    left: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'index',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 54,
                                                                                                                column: 51,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 54,
                                                                                                                column: 56,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    right: {
                                                                                                        type: 'Literal',
                                                                                                        value: 1
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 54,
                                                                                                        column: 43,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 54,
                                                                                                        column: 61,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            property: {
                                                                                                type: 'Identifier',
                                                                                                name: 'selected',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 54,
                                                                                                        column: 63,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 54,
                                                                                                        column: 71,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            existential: true,
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 54,
                                                                                                    column: 43,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 54,
                                                                                                    column: 71,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        right: {
                                                                                            type: 'Literal',
                                                                                            value: true
                                                                                        }
                                                                                    }
                                                                                },
                                                                                right: {
                                                                                    type: 'BinaryExpression',
                                                                                    operator: '===',
                                                                                    left: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'MemberExpression',
                                                                                            computed: false,
                                                                                            object: {
                                                                                                type: 'Identifier',
                                                                                                name: 'dataTableModel',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 54,
                                                                                                        column: 86,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 54,
                                                                                                        column: 100,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            property: {
                                                                                                type: 'Identifier',
                                                                                                name: 'selectedRows',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 54,
                                                                                                        column: 101,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 54,
                                                                                                        column: 113,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 54,
                                                                                                    column: 86,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 54,
                                                                                                    column: 113,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'length',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 54,
                                                                                                    column: 114,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 54,
                                                                                                    column: 120,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 54,
                                                                                                column: 86,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 54,
                                                                                                column: 120,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    right: {
                                                                                        type: 'Literal',
                                                                                        value: 0
                                                                                    }
                                                                                }
                                                                            },
                                                                            consequent: {
                                                                                type: 'BlockStatement',
                                                                                body: [{
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'CallExpression',
                                                                                            callee: {
                                                                                                type: 'Identifier',
                                                                                                name: 'ColumnChooser',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 55,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 55,
                                                                                                        column: 37,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            arguments: [{
                                                                                                    type: 'ObjectExpression',
                                                                                                    properties: [
                                                                                                        {
                                                                                                            type: 'Property',
                                                                                                            key: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'column',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 55,
                                                                                                                        column: 39,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 55,
                                                                                                                        column: 45,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            value: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'column',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 55,
                                                                                                                        column: 39,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 55,
                                                                                                                        column: 45,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            kind: 'init',
                                                                                                            order: '0'
                                                                                                        },
                                                                                                        {
                                                                                                            type: 'Property',
                                                                                                            key: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'cell',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 55,
                                                                                                                        column: 47,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 55,
                                                                                                                        column: 51,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            value: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'cell',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 55,
                                                                                                                        column: 47,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 55,
                                                                                                                        column: 51,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            kind: 'init',
                                                                                                            order: '1'
                                                                                                        }
                                                                                                    ]
                                                                                                }],
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 55,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 55,
                                                                                                    column: 53,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 55,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 55,
                                                                                                column: 53,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            alternate: null,
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'CallExpression',
                                                                                callee: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'Schema',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 56,
                                                                                                column: 20,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 56,
                                                                                                column: 26,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'getLabel',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 56,
                                                                                                column: 27,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 56,
                                                                                                column: 35,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 56,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 56,
                                                                                            column: 35,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                arguments: [{
                                                                                        type: 'Identifier',
                                                                                        name: 'property',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 56,
                                                                                                column: 36,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 56,
                                                                                                column: 44,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                            }
                                                                                        }
                                                                                    }],
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 56,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 56,
                                                                                        column: 45,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 56,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 56,
                                                                                    column: 45,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                }
                                                                            },
                                                                            order: '1'
                                                                        },
                                                                        {
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'Function',
                                                                                context: true,
                                                                                value: function (_context4) {
                                                                                    return function mousedown(e) {
                                                                                        var column = _context4.get('column'), dataTableModel = _context4.get('dataTableModel'), ion = _context4.get('ion'), DragMover = _context4.get('DragMover'), cell = _context4.get('cell'), columns = _context4.get('columns');
                                                                                        if (column.fixed) {
                                                                                            return;
                                                                                        }
                                                                                        if (!column.selected) {
                                                                                            dataTableModel.select(column);
                                                                                            ion.sync();
                                                                                        }
                                                                                        var moveSelectedColumns = ion.bind(function (newIndex) {
                                                                                                var firstSelectedIndex = dataTableModel.columns.indexOf(dataTableModel.selectedColumns[0]);
                                                                                                var offset = newIndex - firstSelectedIndex;
                                                                                                if (offset > 0) {
                                                                                                    offset -= dataTableModel.selectedColumns.length;
                                                                                                }
                                                                                                dataTableModel.moveSelectedColumns(offset);
                                                                                            }, this);
                                                                                        var _ref6 = Span();
                                                                                        ion.add(_ref6, 'Drag Element');
                                                                                        DragMover.dragMove({
                                                                                            event: e,
                                                                                            dragElement: _ref6,
                                                                                            dropTargets: ion.bind(function () {
                                                                                                var targets = [];
                                                                                                var headerCells = cell.parentElement.childNodes;
                                                                                                for (var _i = 0; _i < headerCells.length; _i++) {
                                                                                                    var index = _i;
                                                                                                    var headerCell = headerCells[_i];
                                                                                                    var headerColumn = columns[index];
                                                                                                    var previousColumn = columns[index - 1] != null ? columns[index - 1] : headerColumn;
                                                                                                    var nextColumn = columns[index + 1];
                                                                                                    if (!headerColumn.fixed && !headerColumn.selected) {
                                                                                                        var previousRect = headerCells[index - 1].getBoundingClientRect();
                                                                                                        var currentRect = headerCell.getBoundingClientRect();
                                                                                                        var extraBuffer = 50;
                                                                                                        if (!previousColumn.selected) {
                                                                                                            targets.push({
                                                                                                                name: index,
                                                                                                                rect: {
                                                                                                                    x: previousRect.x + Math.round(previousRect.width / 2),
                                                                                                                    y: currentRect.y - extraBuffer,
                                                                                                                    width: (previousRect.width + currentRect.width) / 2,
                                                                                                                    height: currentRect.height + extraBuffer * 2
                                                                                                                },
                                                                                                                pointerX: currentRect.x,
                                                                                                                pointerY: currentRect.y + Math.round(currentRect.height / 2),
                                                                                                                pointerRotation: 90,
                                                                                                                handler: moveSelectedColumns.bind(null, index)
                                                                                                            });
                                                                                                        }
                                                                                                        if (!(nextColumn != null)) {
                                                                                                            targets.push({
                                                                                                                name: index + 1,
                                                                                                                rect: {
                                                                                                                    x: currentRect.x,
                                                                                                                    y: currentRect.y - extraBuffer,
                                                                                                                    width: currentRect.width,
                                                                                                                    height: currentRect.height + extraBuffer * 2
                                                                                                                },
                                                                                                                pointerX: currentRect.x + currentRect.width - 5,
                                                                                                                pointerY: currentRect.y + Math.round(currentRect.height / 2) - 5,
                                                                                                                pointerRotation: 45,
                                                                                                                handler: moveSelectedColumns.bind(null, index + 1)
                                                                                                            });
                                                                                                        }
                                                                                                    }
                                                                                                }
                                                                                                return targets;
                                                                                            }, this)()
                                                                                        });
                                                                                    };
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 57,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 122,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                }
                                                                            },
                                                                            order: '2'
                                                                        }
                                                                    ]
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 53,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 122,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'ObjectExpression',
                                                                    objectType: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'Identifier',
                                                                            name: 'Resizer',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 122,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 122,
                                                                                    column: 23,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [{
                                                                                type: 'ObjectExpression',
                                                                                properties: [
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'element',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 122,
                                                                                                    column: 25,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 122,
                                                                                                    column: 32,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Identifier',
                                                                                            name: 'cell',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 122,
                                                                                                    column: 33,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 122,
                                                                                                    column: 37,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'horizontal',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 122,
                                                                                                    column: 38,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 122,
                                                                                                    column: 48,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: true
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '1'
                                                                                    },
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'minWidth',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 122,
                                                                                                    column: 54,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 122,
                                                                                                    column: 62,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 50
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '2'
                                                                                    }
                                                                                ]
                                                                            }],
                                                                        loc: {
                                                                            start: {
                                                                                line: 122,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 122,
                                                                                column: 67,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    properties: [
                                                                        {
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'Function',
                                                                                context: true,
                                                                                value: function (_context5) {
                                                                                    return function resizestart() {
                                                                                        var dataTableModel = _context5.get('dataTableModel'), column = _context5.get('column');
                                                                                        dataTableModel.select(column);
                                                                                    };
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 123,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 125,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'Function',
                                                                                context: true,
                                                                                value: function (_context6) {
                                                                                    return function resizestop(_ref5) {
                                                                                        var dataTableModel = _context6.get('dataTableModel'), column = _context6.get('column');
                                                                                        var dx = _ref5.detail.dx;
                                                                                        var dy = _ref5.detail.dy;
                                                                                        dataTableModel.columnSource.resizeColumn(column.name, null, dx);
                                                                                    };
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 125,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 127,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                }
                                                                            },
                                                                            order: '1'
                                                                        }
                                                                    ]
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 122,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 127,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                    }
                                                                },
                                                                order: '1'
                                                            }
                                                        ]
                                                    },
                                                    order: '4'
                                                }
                                            ],
                                            bound: false,
                                            name: {
                                                type: 'Identifier',
                                                name: 'createHeaderCell',
                                                loc: {
                                                    start: {
                                                        line: 48,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                    },
                                                    end: {
                                                        line: 48,
                                                        column: 24,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                    }
                                                }
                                            },
                                            scope: {
                                                type: 'Identifier',
                                                name: '_ps'
                                            }
                                        }, {
                                            this: this,
                                            ion: ion,
                                            dataTableModel: dataTableModel,
                                            _ps: _ps,
                                            property: property,
                                            _ref: _ref,
                                            _ref2: _ref2,
                                            ColumnChooser: ColumnChooser,
                                            _ref3: _ref3,
                                            getDefaultWidth: getDefaultWidth,
                                            Schema: Schema,
                                            jsonValueToDisplayValue: jsonValueToDisplayValue,
                                            Resizer: Resizer,
                                            DragMover: DragMover
                                        }, _ps);
                                    });
                                }
                            },
                            kind: 'init',
                            order: '6'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'createBodyCell',
                                loc: {
                                    start: {
                                        line: 127,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                    },
                                    end: {
                                        line: 127,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_ps2) {
                                    return ion.template(function (row) {
                                        return ion.createRuntime({
                                            type: 'Template',
                                            id: null,
                                            body: [
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'getDisplayValue',
                                                                loc: {
                                                                    start: {
                                                                        line: 128,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 128,
                                                                        column: 31,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'MemberExpression',
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'ion'
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'bind'
                                                                    }
                                                                },
                                                                arguments: [
                                                                    {
                                                                        type: 'Function',
                                                                        context: true,
                                                                        value: function (_context7) {
                                                                            return function (record) {
                                                                                var jsonValueToDisplayValue = _context7.get('jsonValueToDisplayValue'), property = _context7.get('property'), Schema = _context7.get('Schema');
                                                                                var displayValue = jsonValueToDisplayValue(property, Schema.get(record, property));
                                                                                return displayValue;
                                                                            };
                                                                        }
                                                                    },
                                                                    { type: 'ThisExpression' }
                                                                ]
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'ReturnStatement',
                                                    argument: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'Span',
                                                                loc: {
                                                                    start: {
                                                                        line: 131,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 131,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [],
                                                            loc: {
                                                                start: {
                                                                    line: 131,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                },
                                                                end: {
                                                                    line: 131,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [{
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'ObjectExpression',
                                                                    objectType: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'Identifier',
                                                                            name: 'Span',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 132,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 132,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [],
                                                                        loc: {
                                                                            start: {
                                                                                line: 132,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 132,
                                                                                column: 22,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    properties: [{
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'CallExpression',
                                                                                callee: {
                                                                                    type: 'Identifier',
                                                                                    name: 'getDisplayValue',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 133,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 133,
                                                                                            column: 35,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                arguments: [{
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'row',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 133,
                                                                                                    column: 41,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 133,
                                                                                                    column: 44,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'record',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 133,
                                                                                                    column: 45,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 133,
                                                                                                    column: 51,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 133,
                                                                                                column: 41,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 133,
                                                                                                column: 51,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                            }
                                                                                        },
                                                                                        deep: true
                                                                                    }],
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 133,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 133,
                                                                                        column: 52,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 133,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 133,
                                                                                    column: 52,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 132,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 134,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    order: '1'
                                                }
                                            ],
                                            bound: false,
                                            name: {
                                                type: 'Identifier',
                                                name: 'createBodyCell',
                                                loc: {
                                                    start: {
                                                        line: 127,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                    },
                                                    end: {
                                                        line: 127,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                    }
                                                }
                                            },
                                            scope: {
                                                type: 'Identifier',
                                                name: '_ps2'
                                            }
                                        }, {
                                            this: this,
                                            ion: ion,
                                            row: row,
                                            _ps2: _ps2,
                                            property: property,
                                            _ref: _ref,
                                            _ref2: _ref2,
                                            ColumnChooser: ColumnChooser,
                                            _ref3: _ref3,
                                            getDefaultWidth: getDefaultWidth,
                                            Schema: Schema,
                                            jsonValueToDisplayValue: jsonValueToDisplayValue,
                                            Resizer: Resizer,
                                            DragMover: DragMover
                                        }, _ps2);
                                    });
                                }
                            },
                            kind: 'init',
                            order: '7'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'createFooterCell',
                                loc: {
                                    start: {
                                        line: 134,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                    },
                                    end: {
                                        line: 134,
                                        column: 24,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_ps3) {
                                    return ion.template(function (dataTableModel) {
                                        return ion.createRuntime({
                                            type: 'Template',
                                            id: null,
                                            body: [{
                                                    type: 'ReturnStatement',
                                                    argument: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'Identifier',
                                                            name: 'Span',
                                                            loc: {
                                                                start: {
                                                                    line: 135,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                },
                                                                end: {
                                                                    line: 135,
                                                                    column: 23,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [],
                                                        loc: {
                                                            start: {
                                                                line: 135,
                                                                column: 19,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                            },
                                                            end: {
                                                                line: 135,
                                                                column: 25,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                            }
                                                        }
                                                    },
                                                    order: '0'
                                                }],
                                            bound: false,
                                            name: {
                                                type: 'Identifier',
                                                name: 'createFooterCell',
                                                loc: {
                                                    start: {
                                                        line: 134,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                    },
                                                    end: {
                                                        line: 134,
                                                        column: 24,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                    }
                                                }
                                            },
                                            scope: {
                                                type: 'Identifier',
                                                name: '_ps3'
                                            }
                                        }, {
                                            this: this,
                                            dataTableModel: dataTableModel,
                                            _ps3: _ps3,
                                            property: property,
                                            _ref: _ref,
                                            _ref2: _ref2,
                                            ColumnChooser: ColumnChooser,
                                            _ref3: _ref3,
                                            getDefaultWidth: getDefaultWidth,
                                            Schema: Schema,
                                            jsonValueToDisplayValue: jsonValueToDisplayValue,
                                            Resizer: Resizer,
                                            DragMover: DragMover
                                        }, _ps3);
                                    });
                                }
                            },
                            kind: 'init',
                            order: '8'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'createUnderlay',
                                loc: {
                                    start: {
                                        line: 136,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                    },
                                    end: {
                                        line: 136,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_ps4) {
                                    return ion.template(function DefaultColumn_createUnderlay(dataTableModel) {
                                        return ion.createRuntime({
                                            type: 'Template',
                                            id: {
                                                type: 'Identifier',
                                                name: 'DefaultColumn_createUnderlay',
                                                loc: {
                                                    start: {
                                                        line: 136,
                                                        column: 33,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                    },
                                                    end: {
                                                        line: 136,
                                                        column: 61,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                    }
                                                }
                                            },
                                            body: [{
                                                    type: 'ReturnStatement',
                                                    argument: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'Identifier',
                                                            name: 'Span',
                                                            loc: {
                                                                start: {
                                                                    line: 137,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                },
                                                                end: {
                                                                    line: 137,
                                                                    column: 23,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [],
                                                        loc: {
                                                            start: {
                                                                line: 137,
                                                                column: 19,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                            },
                                                            end: {
                                                                line: 137,
                                                                column: 25,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                            }
                                                        }
                                                    },
                                                    order: '0'
                                                }],
                                            bound: false,
                                            name: {
                                                type: 'Identifier',
                                                name: 'createUnderlay',
                                                loc: {
                                                    start: {
                                                        line: 136,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                    },
                                                    end: {
                                                        line: 136,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/DefaultColumn.ion'
                                                    }
                                                }
                                            },
                                            scope: {
                                                type: 'Identifier',
                                                name: '_ps4'
                                            }
                                        }, {
                                            this: this,
                                            dataTableModel: dataTableModel,
                                            _ps4: _ps4,
                                            property: property,
                                            _ref: _ref,
                                            _ref2: _ref2,
                                            ColumnChooser: ColumnChooser,
                                            _ref3: _ref3,
                                            getDefaultWidth: getDefaultWidth,
                                            Schema: Schema,
                                            jsonValueToDisplayValue: jsonValueToDisplayValue,
                                            Resizer: Resizer,
                                            DragMover: DragMover
                                        }, _ps4);
                                    });
                                }
                            },
                            kind: 'init',
                            order: '9'
                        }
                    ]
                },
                order: '1'
            }
        ],
        bound: false
    }, {
        this: this,
        ion: ion,
        property: property,
        _ref: _ref,
        _ref2: _ref2,
        ColumnChooser: ColumnChooser,
        _ref3: _ref3,
        getDefaultWidth: getDefaultWidth,
        Schema: Schema,
        jsonValueToDisplayValue: jsonValueToDisplayValue,
        Resizer: Resizer,
        DragMover: DragMover
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/DataTable2/DefaultColumn',_glass_html_material_DataTable2_DefaultColumn_);
    else
      _glass_html_material_DataTable2_DefaultColumn_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_DataTable2_DefaultColumn_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_DataTable2_FullRowSource_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('../../../data');
var Key = _ref.Key;
var sortProperty = 'order';
var orderRecords = function (records) {
    for (var _i = 0; _i < records.length; _i++) {
        var index = _i;
        var record = records[_i];
        record.order = index;
    }
};
var getSortedSiblingRecords = function (records, parentId) {
    if (!(records != null)) {
        return [];
    }
    var _ref6 = [];
    for (var key in records) {
        var record = records[key];
        if (record.parentId === parentId) {
            _ref6.push(record);
        }
    }
    var siblings = _ref6;
    siblings.sort(ion.createSortFunction([{ order: true }]));
    return siblings;
};
var moveRecordToSibling = function (sourceRecord, targetRecord, records, offset) {
    if (offset == null)
        offset = 0;
    var siblingRecords = getSortedSiblingRecords(records, targetRecord.parentId);
    siblingRecords.remove(sourceRecord);
    var index = siblingRecords.indexOf(targetRecord);
    if (index < 0) {
        throw new Error('targetRecord not found in siblingRecords');
    }
    siblingRecords.splice(index + offset, 0, sourceRecord);
    orderRecords(siblingRecords);
    setParentId(sourceRecord, targetRecord.parentId);
};
var moveRecordToLastChild = function (sourceRecord, targetRecord, records) {
    var siblingRecords = getSortedSiblingRecords(records, targetRecord != null ? targetRecord.id : void 0);
    siblingRecords.remove(sourceRecord);
    siblingRecords.push(sourceRecord);
    orderRecords(siblingRecords);
    setParentId(sourceRecord, targetRecord != null ? targetRecord.id : void 0);
};
var getRows = ion.template(function getRows(_ref2) {
        return ion.createRuntime({
            type: 'Template',
            id: {
                type: 'Identifier',
                name: 'getRows',
                loc: {
                    start: {
                        line: 31,
                        column: 25,
                        fixed: true,
                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                    },
                    end: {
                        line: 31,
                        column: 32,
                        fixed: true,
                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                    }
                }
            },
            body: [
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'records',
                                loc: {
                                    start: {
                                        line: 31,
                                        column: 34,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    },
                                    end: {
                                        line: 31,
                                        column: 41,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref2'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'records',
                                    loc: {
                                        start: {
                                            line: 31,
                                            column: 34,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                        },
                                        end: {
                                            line: 31,
                                            column: 41,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '0'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'childrenLookup',
                                loc: {
                                    start: {
                                        line: 31,
                                        column: 43,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    },
                                    end: {
                                        line: 31,
                                        column: 57,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref2'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'childrenLookup',
                                    loc: {
                                        start: {
                                            line: 31,
                                            column: 43,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                        },
                                        end: {
                                            line: 31,
                                            column: 57,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '1'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'parent',
                                loc: {
                                    start: {
                                        line: 31,
                                        column: 59,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    },
                                    end: {
                                        line: 31,
                                        column: 65,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref2'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'parent',
                                    loc: {
                                        start: {
                                            line: 31,
                                            column: 59,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                        },
                                        end: {
                                            line: 31,
                                            column: 65,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '2'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'sortFunction',
                                loc: {
                                    start: {
                                        line: 31,
                                        column: 67,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    },
                                    end: {
                                        line: 31,
                                        column: 79,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref2'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'sortFunction',
                                    loc: {
                                        start: {
                                            line: 31,
                                            column: 67,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                        },
                                        end: {
                                            line: 31,
                                            column: 79,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '3'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'path',
                                loc: {
                                    start: {
                                        line: 31,
                                        column: 81,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    },
                                    end: {
                                        line: 31,
                                        column: 85,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref2'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'path',
                                    loc: {
                                        start: {
                                            line: 31,
                                            column: 81,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                        },
                                        end: {
                                            line: 31,
                                            column: 85,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '4'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'parentId',
                                loc: {
                                    start: {
                                        line: 32,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    },
                                    end: {
                                        line: 32,
                                        column: 16,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'ConditionalExpression',
                                test: {
                                    type: 'BinaryExpression',
                                    operator: '!=',
                                    left: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'parent',
                                            loc: {
                                                start: {
                                                    line: 32,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                },
                                                end: {
                                                    line: 32,
                                                    column: 25,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'id',
                                            loc: {
                                                start: {
                                                    line: 32,
                                                    column: 27,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                },
                                                end: {
                                                    line: 32,
                                                    column: 29,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                }
                                            }
                                        },
                                        existential: true,
                                        loc: {
                                            start: {
                                                line: 32,
                                                column: 19,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                            },
                                            end: {
                                                line: 32,
                                                column: 29,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                            }
                                        }
                                    },
                                    right: {
                                        type: 'Literal',
                                        value: null
                                    }
                                },
                                consequent: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'parent',
                                        loc: {
                                            start: {
                                                line: 32,
                                                column: 19,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                            },
                                            end: {
                                                line: 32,
                                                column: 25,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'id',
                                        loc: {
                                            start: {
                                                line: 32,
                                                column: 27,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                            },
                                            end: {
                                                line: 32,
                                                column: 29,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                            }
                                        }
                                    },
                                    existential: true,
                                    loc: {
                                        start: {
                                            line: 32,
                                            column: 19,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                        },
                                        end: {
                                            line: 32,
                                            column: 29,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                        }
                                    }
                                },
                                alternate: {
                                    type: 'Literal',
                                    value: 'null'
                                }
                            }
                        }],
                    kind: 'let',
                    order: '5'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'temp',
                                loc: {
                                    start: {
                                        line: 34,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    },
                                    end: {
                                        line: 34,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'ObjectExpression',
                                properties: []
                            }
                        }],
                    kind: 'let',
                    order: '6'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'getSortedKeys',
                                loc: {
                                    start: {
                                        line: 36,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    },
                                    end: {
                                        line: 36,
                                        column: 21,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'Function',
                                context: true,
                                value: function (_context) {
                                    return function (_ref3) {
                                        var sortFunction = _context.get('sortFunction');
                                        var siblingKeys = _ref3.siblingKeys;
                                        var records = _ref3.records;
                                        if (records != null) {
                                            var sortedSiblings = [];
                                            for (var key in siblingKeys) {
                                                sortedSiblings.push(records[key]);
                                            }
                                            if (sortFunction != null) {
                                                sortedSiblings.sort(sortFunction);
                                            }
                                            var _ref7 = [];
                                            for (var _i2 = 0; _i2 < sortedSiblings.length; _i2++) {
                                                var record = sortedSiblings[_i2];
                                                _ref7.push(record.key);
                                            }
                                            return _ref7;
                                        }
                                    };
                                }
                            }
                        }],
                    kind: 'let',
                    order: '7'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'siblingKeys',
                                loc: {
                                    start: {
                                        line: 45,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    },
                                    end: {
                                        line: 45,
                                        column: 19,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                computed: true,
                                object: {
                                    type: 'Identifier',
                                    name: 'childrenLookup',
                                    loc: {
                                        start: {
                                            line: 45,
                                            column: 22,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                        },
                                        end: {
                                            line: 45,
                                            column: 36,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'parentId',
                                    loc: {
                                        start: {
                                            line: 45,
                                            column: 37,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                        },
                                        end: {
                                            line: 45,
                                            column: 45,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 45,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    },
                                    end: {
                                        line: 45,
                                        column: 46,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '8'
                },
                {
                    type: 'IfStatement',
                    test: {
                        type: 'UnaryExpression',
                        operator: '?',
                        argument: {
                            type: 'Identifier',
                            name: 'siblingKeys',
                            loc: {
                                start: {
                                    line: 46,
                                    column: 7,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                },
                                end: {
                                    line: 46,
                                    column: 18,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                }
                            }
                        }
                    },
                    consequent: {
                        type: 'BlockStatement',
                        body: [
                            {
                                type: 'VariableDeclaration',
                                declarations: [{
                                        type: 'VariableDeclarator',
                                        id: {
                                            type: 'Identifier',
                                            name: 'sortedKeys',
                                            loc: {
                                                start: {
                                                    line: 47,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                },
                                                end: {
                                                    line: 47,
                                                    column: 22,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                }
                                            }
                                        },
                                        init: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'ion',
                                                        loc: {
                                                            start: {
                                                                line: 47,
                                                                column: 25,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                            },
                                                            end: {
                                                                line: 47,
                                                                column: 28,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'reactive',
                                                        loc: {
                                                            start: {
                                                                line: 47,
                                                                column: 29,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                            },
                                                            end: {
                                                                line: 47,
                                                                column: 37,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 47,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                        },
                                                        end: {
                                                            line: 47,
                                                            column: 37,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [{
                                                        type: 'Identifier',
                                                        name: 'getSortedKeys',
                                                        loc: {
                                                            start: {
                                                                line: 47,
                                                                column: 38,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                            },
                                                            end: {
                                                                line: 47,
                                                                column: 51,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                            }
                                                        }
                                                    }],
                                                loc: {
                                                    start: {
                                                        line: 47,
                                                        column: 25,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                    },
                                                    end: {
                                                        line: 47,
                                                        column: 52,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                    }
                                                }
                                            },
                                            arguments: [{
                                                    type: 'ObjectExpression',
                                                    properties: [
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'siblingKeys',
                                                                loc: {
                                                                    start: {
                                                                        line: 47,
                                                                        column: 54,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                    },
                                                                    end: {
                                                                        line: 47,
                                                                        column: 65,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Identifier',
                                                                name: 'siblingKeys',
                                                                loc: {
                                                                    start: {
                                                                        line: 47,
                                                                        column: 54,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                    },
                                                                    end: {
                                                                        line: 47,
                                                                        column: 65,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                    }
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        },
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'records',
                                                                loc: {
                                                                    start: {
                                                                        line: 47,
                                                                        column: 67,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                    },
                                                                    end: {
                                                                        line: 47,
                                                                        column: 74,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Identifier',
                                                                name: 'records',
                                                                loc: {
                                                                    start: {
                                                                        line: 47,
                                                                        column: 67,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                    },
                                                                    end: {
                                                                        line: 47,
                                                                        column: 74,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                    }
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '1'
                                                        }
                                                    ]
                                                }],
                                            loc: {
                                                start: {
                                                    line: 47,
                                                    column: 25,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                },
                                                end: {
                                                    line: 47,
                                                    column: 76,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                }
                                            }
                                        }
                                    }],
                                kind: 'let',
                                order: '0'
                            },
                            {
                                type: 'ReturnStatement',
                                argument: {
                                    type: 'ObjectExpression',
                                    objectType: {
                                        type: 'ArrayExpression',
                                        elements: []
                                    },
                                    properties: [{
                                            type: 'ForOfStatement',
                                            left: {
                                                type: 'VariableDeclaration',
                                                declarations: [
                                                    {
                                                        type: 'VariableDeclarator',
                                                        id: {
                                                            type: 'Identifier',
                                                            name: 'key',
                                                            loc: {
                                                                start: {
                                                                    line: 50,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                },
                                                                end: {
                                                                    line: 50,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                }
                                                            }
                                                        },
                                                        init: null
                                                    },
                                                    {
                                                        type: 'VariableDeclarator',
                                                        id: {
                                                            type: 'Identifier',
                                                            name: 'index',
                                                            loc: {
                                                                start: {
                                                                    line: 50,
                                                                    column: 21,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                },
                                                                end: {
                                                                    line: 50,
                                                                    column: 26,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                }
                                                            }
                                                        },
                                                        init: null
                                                    }
                                                ],
                                                kind: 'let'
                                            },
                                            right: {
                                                type: 'Identifier',
                                                name: 'sortedKeys',
                                                loc: {
                                                    start: {
                                                        line: 50,
                                                        column: 30,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                    },
                                                    end: {
                                                        line: 50,
                                                        column: 40,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                    }
                                                }
                                            },
                                            body: {
                                                type: 'BlockStatement',
                                                body: [
                                                    {
                                                        type: 'VariableDeclaration',
                                                        declarations: [{
                                                                type: 'VariableDeclarator',
                                                                id: {
                                                                    type: 'Identifier',
                                                                    name: 'record',
                                                                    loc: {
                                                                        start: {
                                                                            line: 51,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                        },
                                                                        end: {
                                                                            line: 51,
                                                                            column: 26,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                        }
                                                                    }
                                                                },
                                                                init: {
                                                                    type: 'MemberExpression',
                                                                    computed: true,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'records',
                                                                        loc: {
                                                                            start: {
                                                                                line: 51,
                                                                                column: 29,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                            },
                                                                            end: {
                                                                                line: 51,
                                                                                column: 36,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'key',
                                                                        loc: {
                                                                            start: {
                                                                                line: 51,
                                                                                column: 37,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                            },
                                                                            end: {
                                                                                line: 51,
                                                                                column: 40,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 51,
                                                                            column: 29,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                        },
                                                                        end: {
                                                                            line: 51,
                                                                            column: 41,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                        }
                                                                    }
                                                                }
                                                            }],
                                                        kind: 'let',
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'VariableDeclaration',
                                                        declarations: [{
                                                                type: 'VariableDeclarator',
                                                                id: {
                                                                    type: 'Identifier',
                                                                    name: 'childPath',
                                                                    loc: {
                                                                        start: {
                                                                            line: 52,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                        },
                                                                        end: {
                                                                            line: 52,
                                                                            column: 29,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                        }
                                                                    }
                                                                },
                                                                init: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'path',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 52,
                                                                                    column: 32,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 52,
                                                                                    column: 36,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'concat',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 52,
                                                                                    column: 37,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 52,
                                                                                    column: 43,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 52,
                                                                                column: 32,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                            },
                                                                            end: {
                                                                                line: 52,
                                                                                column: 43,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [{
                                                                            type: 'Identifier',
                                                                            name: 'index',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 52,
                                                                                    column: 44,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 52,
                                                                                    column: 49,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                                }
                                                                            }
                                                                        }],
                                                                    loc: {
                                                                        start: {
                                                                            line: 52,
                                                                            column: 32,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                        },
                                                                        end: {
                                                                            line: 52,
                                                                            column: 50,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                        }
                                                                    }
                                                                }
                                                            }],
                                                        kind: 'let',
                                                        order: '1'
                                                    },
                                                    {
                                                        type: 'VariableDeclaration',
                                                        declarations: [{
                                                                type: 'VariableDeclarator',
                                                                id: {
                                                                    type: 'Identifier',
                                                                    name: 'row',
                                                                    loc: {
                                                                        start: {
                                                                            line: 53,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                        },
                                                                        end: {
                                                                            line: 53,
                                                                            column: 23,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                        }
                                                                    }
                                                                },
                                                                init: {
                                                                    type: 'ObjectExpression',
                                                                    properties: [
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'record',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 53,
                                                                                        column: 27,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 53,
                                                                                        column: 33,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Identifier',
                                                                                name: 'record',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 53,
                                                                                        column: 27,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 53,
                                                                                        column: 33,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'recordParent',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 53,
                                                                                        column: 35,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 53,
                                                                                        column: 47,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Identifier',
                                                                                name: 'parent',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 53,
                                                                                        column: 48,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 53,
                                                                                        column: 54,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            kind: 'init',
                                                                            order: '1'
                                                                        }
                                                                    ]
                                                                }
                                                            }],
                                                        kind: 'let',
                                                        order: '2'
                                                    },
                                                    {
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'ObjectExpression',
                                                            objectType: {
                                                                type: 'Identifier',
                                                                name: 'row',
                                                                loc: {
                                                                    start: {
                                                                        line: 54,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                    },
                                                                    end: {
                                                                        line: 54,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                    }
                                                                }
                                                            },
                                                            properties: [
                                                                {
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'key',
                                                                        loc: {
                                                                            start: {
                                                                                line: 55,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                            },
                                                                            end: {
                                                                                line: 55,
                                                                                column: 23,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'record',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 55,
                                                                                    column: 25,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 55,
                                                                                    column: 31,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'key',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 55,
                                                                                    column: 33,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 55,
                                                                                    column: 36,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        existential: true,
                                                                        loc: {
                                                                            start: {
                                                                                line: 55,
                                                                                column: 25,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                            },
                                                                            end: {
                                                                                line: 55,
                                                                                column: 36,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                },
                                                                {
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'path',
                                                                        loc: {
                                                                            start: {
                                                                                line: 56,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                            },
                                                                            end: {
                                                                                line: 56,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Identifier',
                                                                        name: 'childPath',
                                                                        loc: {
                                                                            start: {
                                                                                line: 56,
                                                                                column: 26,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                            },
                                                                            end: {
                                                                                line: 56,
                                                                                column: 35,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    kind: 'init',
                                                                    order: '1'
                                                                },
                                                                {
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'delete',
                                                                        loc: {
                                                                            start: {
                                                                                line: 57,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                            },
                                                                            end: {
                                                                                line: 57,
                                                                                column: 26,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Function',
                                                                        context: true,
                                                                        value: function (_context2) {
                                                                            return function () {
                                                                                var row = _context2.get('row'), records = _context2.get('records'), record = _context2.get('record');
                                                                                if (row.children != null) {
                                                                                    {
                                                                                        var _ref8 = row.children;
                                                                                        for (var _i3 = 0; _i3 < _ref8.length; _i3++) {
                                                                                            var childRow = _ref8[_i3];
                                                                                            childRow.delete();
                                                                                        }
                                                                                    }
                                                                                }
                                                                                delete records[record.key];
                                                                            };
                                                                        }
                                                                    },
                                                                    kind: 'init',
                                                                    order: '2'
                                                                },
                                                                {
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'getSiblingRecords',
                                                                        loc: {
                                                                            start: {
                                                                                line: 69,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                            },
                                                                            end: {
                                                                                line: 69,
                                                                                column: 37,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Function',
                                                                        context: true,
                                                                        value: function (_context3) {
                                                                            return function () {
                                                                                var getSortedSiblingRecords = _context3.get('getSortedSiblingRecords'), records = _context3.get('records'), record = _context3.get('record');
                                                                                return getSortedSiblingRecords(records, record.parentId);
                                                                            };
                                                                        }
                                                                    },
                                                                    kind: 'init',
                                                                    order: '3'
                                                                },
                                                                {
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'getDepth',
                                                                        loc: {
                                                                            start: {
                                                                                line: 70,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                            },
                                                                            end: {
                                                                                line: 70,
                                                                                column: 28,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Function',
                                                                        context: true,
                                                                        value: function (_context4) {
                                                                            return function () {
                                                                                var records = _context4.get('records');
                                                                                var record = this.record;
                                                                                var depth = 0;
                                                                                while ((record != null ? record.parentId : void 0) != null) {
                                                                                    depth += 1;
                                                                                    record = records[record.parentId];
                                                                                }
                                                                                return depth;
                                                                            };
                                                                        }
                                                                    },
                                                                    kind: 'init',
                                                                    order: '4'
                                                                },
                                                                {
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'children',
                                                                        loc: {
                                                                            start: {
                                                                                line: 77,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                            },
                                                                            end: {
                                                                                line: 77,
                                                                                column: 28,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'Identifier',
                                                                            name: 'getRows',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 77,
                                                                                    column: 30,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 77,
                                                                                    column: 37,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [{
                                                                                type: 'ObjectExpression',
                                                                                properties: [
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'records',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 77,
                                                                                                    column: 39,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 77,
                                                                                                    column: 46,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Identifier',
                                                                                            name: 'records',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 77,
                                                                                                    column: 39,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 77,
                                                                                                    column: 46,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'childrenLookup',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 77,
                                                                                                    column: 48,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 77,
                                                                                                    column: 62,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Identifier',
                                                                                            name: 'childrenLookup',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 77,
                                                                                                    column: 48,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 77,
                                                                                                    column: 62,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '1'
                                                                                    },
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'parent',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 77,
                                                                                                    column: 64,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 77,
                                                                                                    column: 70,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Identifier',
                                                                                            name: 'record',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 77,
                                                                                                    column: 71,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 77,
                                                                                                    column: 77,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '2'
                                                                                    },
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'sortFunction',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 77,
                                                                                                    column: 79,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 77,
                                                                                                    column: 91,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Identifier',
                                                                                            name: 'sortFunction',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 77,
                                                                                                    column: 79,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 77,
                                                                                                    column: 91,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '3'
                                                                                    },
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'path',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 77,
                                                                                                    column: 93,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 77,
                                                                                                    column: 97,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Identifier',
                                                                                            name: 'childPath',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 77,
                                                                                                    column: 98,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 77,
                                                                                                    column: 107,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '4'
                                                                                    }
                                                                                ]
                                                                            }],
                                                                        loc: {
                                                                            start: {
                                                                                line: 77,
                                                                                column: 30,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                            },
                                                                            end: {
                                                                                line: 77,
                                                                                column: 109,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    kind: 'init',
                                                                    order: '5'
                                                                }
                                                            ]
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 54,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                            },
                                                            end: {
                                                                line: 79,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                            }
                                                        },
                                                        order: '3'
                                                    }
                                                ]
                                            },
                                            remove: null,
                                            order: '0'
                                        }]
                                },
                                order: '1'
                            }
                        ]
                    },
                    alternate: null,
                    order: '9'
                }
            ],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'getRows',
                loc: {
                    start: {
                        line: 31,
                        column: 6,
                        fixed: true,
                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                    },
                    end: {
                        line: 31,
                        column: 13,
                        fixed: true,
                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                    }
                }
            }
        }, {
            this: this,
            ion: ion,
            _ref2: _ref2,
            _ref: _ref,
            Key: Key,
            sortProperty: sortProperty,
            orderRecords: orderRecords,
            getSortedSiblingRecords: getSortedSiblingRecords,
            moveRecordToSibling: moveRecordToSibling,
            moveRecordToLastChild: moveRecordToLastChild,
            getRows: getRows,
            setParentId: setParentId,
            getParentId: getParentId
        }, null);
    });
var setParentId = function (record, parentId) {
    if (parentId != null) {
        record.parentId = parentId;
    } else {
        delete record.parentId;
    }
};
var getParentId = function (record) {
    return (record != null ? record.parentId : void 0) != null ? record.parentId : 'null';
};
module.exports = exports = ion.template(function FullRowSource(args) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'FullRowSource',
            loc: {
                start: {
                    line: 87,
                    column: 16,
                    fixed: true,
                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                },
                end: {
                    line: 87,
                    column: 29,
                    fixed: true,
                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                }
            }
        },
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: '_ref4'
                        },
                        init: {
                            type: 'Identifier',
                            name: 'args',
                            loc: {
                                start: {
                                    line: 88,
                                    column: 22,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                },
                                end: {
                                    line: 88,
                                    column: 26,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'key',
                            loc: {
                                start: {
                                    line: 88,
                                    column: 9,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                },
                                end: {
                                    line: 88,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref4'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'key',
                                loc: {
                                    start: {
                                        line: 88,
                                        column: 9,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    },
                                    end: {
                                        line: 88,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'sort',
                            loc: {
                                start: {
                                    line: 88,
                                    column: 14,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                },
                                end: {
                                    line: 88,
                                    column: 18,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref4'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'sort',
                                loc: {
                                    start: {
                                        line: 88,
                                        column: 14,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    },
                                    end: {
                                        line: 88,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: '_ref5'
                        },
                        init: {
                            type: 'Identifier',
                            name: 'key',
                            loc: {
                                start: {
                                    line: 89,
                                    column: 17,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                },
                                end: {
                                    line: 89,
                                    column: 20,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '3'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'type',
                            loc: {
                                start: {
                                    line: 89,
                                    column: 9,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                },
                                end: {
                                    line: 89,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref5'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'type',
                                loc: {
                                    start: {
                                        line: 89,
                                        column: 9,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    },
                                    end: {
                                        line: 89,
                                        column: 13,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '4'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'records',
                            loc: {
                                start: {
                                    line: 90,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                },
                                end: {
                                    line: 90,
                                    column: 15,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            computed: true,
                            object: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'model',
                                    loc: {
                                        start: {
                                            line: 90,
                                            column: 18,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                        },
                                        end: {
                                            line: 90,
                                            column: 23,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'server',
                                    loc: {
                                        start: {
                                            line: 90,
                                            column: 24,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                        },
                                        end: {
                                            line: 90,
                                            column: 30,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 90,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    },
                                    end: {
                                        line: 90,
                                        column: 30,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'key',
                                loc: {
                                    start: {
                                        line: 90,
                                        column: 31,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    },
                                    end: {
                                        line: 90,
                                        column: 34,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 90,
                                    column: 18,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                },
                                end: {
                                    line: 90,
                                    column: 35,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '5'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'sortFunction',
                            loc: {
                                start: {
                                    line: 92,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                },
                                end: {
                                    line: 92,
                                    column: 20,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ConditionalExpression',
                            test: {
                                type: 'Identifier',
                                name: 'sort',
                                loc: {
                                    start: {
                                        line: 92,
                                        column: 23,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    },
                                    end: {
                                        line: 92,
                                        column: 27,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    }
                                }
                            },
                            consequent: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'ion',
                                        loc: {
                                            start: {
                                                line: 92,
                                                column: 30,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                            },
                                            end: {
                                                line: 92,
                                                column: 33,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'createSortFunction',
                                        loc: {
                                            start: {
                                                line: 92,
                                                column: 34,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                            },
                                            end: {
                                                line: 92,
                                                column: 52,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 92,
                                            column: 30,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                        },
                                        end: {
                                            line: 92,
                                            column: 52,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'Identifier',
                                        name: 'sort',
                                        loc: {
                                            start: {
                                                line: 92,
                                                column: 53,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                            },
                                            end: {
                                                line: 92,
                                                column: 57,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                            }
                                        }
                                    }],
                                loc: {
                                    start: {
                                        line: 92,
                                        column: 30,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    },
                                    end: {
                                        line: 92,
                                        column: 58,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    }
                                }
                            },
                            alternate: {
                                type: 'Literal',
                                value: null
                            }
                        }
                    }],
                kind: 'let',
                order: '6'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'childrenLookup',
                            loc: {
                                start: {
                                    line: 95,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                },
                                end: {
                                    line: 95,
                                    column: 22,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            properties: []
                        }
                    }],
                kind: 'let',
                order: '7'
            },
            {
                type: 'ForInStatement',
                left: {
                    type: 'VariableDeclaration',
                    declarations: [
                        {
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'k',
                                loc: {
                                    start: {
                                        line: 96,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    },
                                    end: {
                                        line: 96,
                                        column: 9,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    }
                                }
                            },
                            init: null
                        },
                        {
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'record',
                                loc: {
                                    start: {
                                        line: 96,
                                        column: 11,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    },
                                    end: {
                                        line: 96,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    }
                                }
                            },
                            init: null
                        }
                    ],
                    kind: 'let'
                },
                right: {
                    type: 'Identifier',
                    name: 'records',
                    loc: {
                        start: {
                            line: 96,
                            column: 21,
                            fixed: true,
                            source: 'glass/html/material/DataTable2/FullRowSource.ion'
                        },
                        end: {
                            line: 96,
                            column: 28,
                            fixed: true,
                            source: 'glass/html/material/DataTable2/FullRowSource.ion'
                        }
                    }
                },
                body: {
                    type: 'BlockStatement',
                    body: [
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'parentId',
                                        loc: {
                                            start: {
                                                line: 97,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                            },
                                            end: {
                                                line: 97,
                                                column: 20,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'Identifier',
                                            name: 'getParentId',
                                            loc: {
                                                start: {
                                                    line: 97,
                                                    column: 23,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                },
                                                end: {
                                                    line: 97,
                                                    column: 34,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                }
                                            }
                                        },
                                        arguments: [{
                                                type: 'Identifier',
                                                name: 'record',
                                                loc: {
                                                    start: {
                                                        line: 97,
                                                        column: 35,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                    },
                                                    end: {
                                                        line: 97,
                                                        column: 41,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                    }
                                                }
                                            }],
                                        loc: {
                                            start: {
                                                line: 97,
                                                column: 23,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                            },
                                            end: {
                                                line: 97,
                                                column: 42,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '0'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'siblings',
                                        loc: {
                                            start: {
                                                line: 98,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                            },
                                            end: {
                                                line: 98,
                                                column: 20,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'Function',
                                            context: true,
                                            value: function (_context5) {
                                                return function (parentId) {
                                                    var childrenLookup = _context5.get('childrenLookup');
                                                    return childrenLookup[parentId] = childrenLookup[parentId] != null ? childrenLookup[parentId] : {};
                                                };
                                            }
                                        },
                                        arguments: [{
                                                type: 'Identifier',
                                                name: 'parentId',
                                                loc: {
                                                    start: {
                                                        line: 98,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                    },
                                                    end: {
                                                        line: 98,
                                                        column: 35,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                    }
                                                }
                                            }],
                                        loc: {
                                            start: {
                                                line: 98,
                                                column: 23,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                            },
                                            end: {
                                                line: 98,
                                                column: 70,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '1'
                        },
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'Identifier',
                                    name: 'siblings',
                                    loc: {
                                        start: {
                                            line: 99,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                        },
                                        end: {
                                            line: 99,
                                            column: 16,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                        }
                                    }
                                },
                                properties: [{
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'k',
                                            loc: {
                                                start: {
                                                    line: 100,
                                                    column: 13,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                },
                                                end: {
                                                    line: 100,
                                                    column: 14,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: true
                                        },
                                        kind: 'init',
                                        computed: true,
                                        order: '0'
                                    }]
                            },
                            loc: {
                                start: {
                                    line: 99,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                },
                                end: {
                                    line: 102,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                }
                            },
                            order: '2'
                        }
                    ]
                },
                remove: null,
                order: '8'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'rows',
                            loc: {
                                start: {
                                    line: 103,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                },
                                end: {
                                    line: 103,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'getRows',
                                loc: {
                                    start: {
                                        line: 103,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    },
                                    end: {
                                        line: 103,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ObjectExpression',
                                    properties: [
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'records',
                                                loc: {
                                                    start: {
                                                        line: 103,
                                                        column: 24,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                    },
                                                    end: {
                                                        line: 103,
                                                        column: 31,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Identifier',
                                                name: 'records',
                                                loc: {
                                                    start: {
                                                        line: 103,
                                                        column: 24,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                    },
                                                    end: {
                                                        line: 103,
                                                        column: 31,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                    }
                                                }
                                            },
                                            kind: 'init',
                                            order: '0'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'childrenLookup',
                                                loc: {
                                                    start: {
                                                        line: 103,
                                                        column: 33,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                    },
                                                    end: {
                                                        line: 103,
                                                        column: 47,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Identifier',
                                                name: 'childrenLookup',
                                                loc: {
                                                    start: {
                                                        line: 103,
                                                        column: 33,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                    },
                                                    end: {
                                                        line: 103,
                                                        column: 47,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                    }
                                                }
                                            },
                                            kind: 'init',
                                            order: '1'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'parent',
                                                loc: {
                                                    start: {
                                                        line: 103,
                                                        column: 49,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                    },
                                                    end: {
                                                        line: 103,
                                                        column: 55,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: null
                                            },
                                            kind: 'init',
                                            order: '2'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'sortFunction',
                                                loc: {
                                                    start: {
                                                        line: 103,
                                                        column: 62,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                    },
                                                    end: {
                                                        line: 103,
                                                        column: 74,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Identifier',
                                                name: 'sortFunction',
                                                loc: {
                                                    start: {
                                                        line: 103,
                                                        column: 62,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                    },
                                                    end: {
                                                        line: 103,
                                                        column: 74,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                    }
                                                }
                                            },
                                            kind: 'init',
                                            order: '3'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'path',
                                                loc: {
                                                    start: {
                                                        line: 103,
                                                        column: 76,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                    },
                                                    end: {
                                                        line: 103,
                                                        column: 80,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'ArrayExpression',
                                                elements: []
                                            },
                                            kind: 'init',
                                            order: '4'
                                        }
                                    ]
                                }],
                            loc: {
                                start: {
                                    line: 103,
                                    column: 15,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                },
                                end: {
                                    line: 103,
                                    column: 85,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '9'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'ObjectExpression',
                        properties: []
                    },
                    properties: [
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'key',
                                loc: {
                                    start: {
                                        line: 106,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    },
                                    end: {
                                        line: 106,
                                        column: 11,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Identifier',
                                name: 'key',
                                loc: {
                                    start: {
                                        line: 106,
                                        column: 13,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    },
                                    end: {
                                        line: 106,
                                        column: 16,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    }
                                }
                            },
                            kind: 'init',
                            order: '0'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'tree',
                                loc: {
                                    start: {
                                        line: 107,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    },
                                    end: {
                                        line: 107,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Literal',
                                value: true
                            },
                            kind: 'init',
                            order: '1'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'sort',
                                loc: {
                                    start: {
                                        line: 108,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    },
                                    end: {
                                        line: 108,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Identifier',
                                name: 'sort',
                                loc: {
                                    start: {
                                        line: 108,
                                        column: 14,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    },
                                    end: {
                                        line: 108,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    }
                                }
                            },
                            kind: 'init',
                            order: '2'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'rows',
                                loc: {
                                    start: {
                                        line: 109,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    },
                                    end: {
                                        line: 109,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Identifier',
                                name: 'rows',
                                loc: {
                                    start: {
                                        line: 109,
                                        column: 14,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    },
                                    end: {
                                        line: 109,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    }
                                }
                            },
                            kind: 'init',
                            order: '3'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'records',
                                loc: {
                                    start: {
                                        line: 110,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    },
                                    end: {
                                        line: 110,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Identifier',
                                name: 'records',
                                loc: {
                                    start: {
                                        line: 110,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    },
                                    end: {
                                        line: 110,
                                        column: 24,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    }
                                }
                            },
                            kind: 'init',
                            order: '4'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'loading',
                                loc: {
                                    start: {
                                        line: 111,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    },
                                    end: {
                                        line: 111,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'BinaryExpression',
                                operator: '===',
                                left: {
                                    type: 'Identifier',
                                    name: 'records',
                                    loc: {
                                        start: {
                                            line: 111,
                                            column: 17,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                        },
                                        end: {
                                            line: 111,
                                            column: 24,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                        }
                                    }
                                },
                                right: {
                                    type: 'UnaryExpression',
                                    operator: 'void',
                                    prefix: true,
                                    argument: {
                                        type: 'Literal',
                                        value: 0
                                    }
                                }
                            },
                            kind: 'init',
                            order: '5'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'refresh',
                                loc: {
                                    start: {
                                        line: 112,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    },
                                    end: {
                                        line: 112,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context6) {
                                    return function () {
                                        var key = _context6.get('key');
                                        global.model.server.source.refresh(key, function (result) {
                                        });
                                    };
                                }
                            },
                            kind: 'init',
                            order: '6'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'beginOp',
                                loc: {
                                    start: {
                                        line: 117,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    },
                                    end: {
                                        line: 117,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: false,
                                value: function () {
                                    return global.model.ops.begin();
                                }
                            },
                            kind: 'init',
                            order: '7'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'moveToBefore',
                                loc: {
                                    start: {
                                        line: 118,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    },
                                    end: {
                                        line: 118,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context7) {
                                    return function (record, target) {
                                        var moveRecordToSibling = _context7.get('moveRecordToSibling'), records = _context7.get('records');
                                        return moveRecordToSibling(record, target, records, 0);
                                    };
                                }
                            },
                            kind: 'init',
                            order: '8'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'moveToAfter',
                                loc: {
                                    start: {
                                        line: 119,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    },
                                    end: {
                                        line: 119,
                                        column: 19,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context8) {
                                    return function (record, target) {
                                        var moveRecordToSibling = _context8.get('moveRecordToSibling'), records = _context8.get('records');
                                        return moveRecordToSibling(record, target, records, +1);
                                    };
                                }
                            },
                            kind: 'init',
                            order: '9'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'moveToLastChildOf',
                                loc: {
                                    start: {
                                        line: 120,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    },
                                    end: {
                                        line: 120,
                                        column: 25,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context9) {
                                    return function (record, parent) {
                                        var moveRecordToLastChild = _context9.get('moveRecordToLastChild'), records = _context9.get('records');
                                        return moveRecordToLastChild(record, parent, records);
                                    };
                                }
                            },
                            kind: 'init',
                            order: ':'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'insertRecord',
                                loc: {
                                    start: {
                                        line: 121,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    },
                                    end: {
                                        line: 121,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/FullRowSource.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context10) {
                                    return function (properties, parent, insertBefore) {
                                        var Key = _context10.get('Key'), key = _context10.get('key'), type = _context10.get('type'), setParentId = _context10.get('setParentId'), records = _context10.get('records'), moveRecordToSibling = _context10.get('moveRecordToSibling'), moveRecordToLastChild = _context10.get('moveRecordToLastChild');
                                        if (!(properties.key != null)) {
                                            properties.key = new Key(key, model.guid()).toString();
                                        }
                                        var record = new type(properties);
                                        setParentId(record, parent != null ? parent.id : void 0);
                                        records[record.key] = record;
                                        if (insertBefore != null) {
                                            moveRecordToSibling(record, insertBefore, records);
                                        } else {
                                            moveRecordToLastChild(record, parent, records);
                                        }
                                        return record;
                                    };
                                }
                            },
                            kind: 'init',
                            order: ';'
                        }
                    ]
                },
                order: ':'
            }
        ],
        bound: false
    }, {
        this: this,
        ion: ion,
        args: args,
        _ref: _ref,
        Key: Key,
        sortProperty: sortProperty,
        orderRecords: orderRecords,
        getSortedSiblingRecords: getSortedSiblingRecords,
        moveRecordToSibling: moveRecordToSibling,
        moveRecordToLastChild: moveRecordToLastChild,
        getRows: getRows,
        setParentId: setParentId,
        getParentId: getParentId
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/DataTable2/FullRowSource',_glass_html_material_DataTable2_FullRowSource_);
    else
      _glass_html_material_DataTable2_FullRowSource_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_DataTable2_FullRowSource_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_DataTable2_NavigateAndEditSupport_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('../../functions'), _ref2;
var getAncestorByClass = _ref.getAncestorByClass;
var getOffsetRelative = _ref.getOffsetRelative;
var isAncestor = _ref.isAncestor;
_ref2 = require('./editing');
var beginEdit = _ref2.beginEdit;
var toArray = function (nodeList) {
        return Array.prototype.slice.call(nodeList);
    }, isRow = function (element) {
        return element != null && element.classList.contains('row');
    }, isCells = function (element) {
        return element != null && element.classList.contains('cells');
    }, isCell = function (element) {
        return element != null && isCells(element.parentElement);
    }, getRow = function (element) {
        while (element != null) {
            if (isRow(element)) {
                return element;
            }
            element = element.parentElement;
        }
        return null;
    }, getCell = function (element) {
        while (element != null && !isRow(element)) {
            if (isCell(element)) {
                if (isFooterCell(element)) {
                    return null;
                }
                return element;
            }
            element = element.parentElement;
        }
        return null;
    }, indexOf = function (element) {
        var index = -1;
        while (element != null) {
            index++;
            element = element.previousSibling;
        }
        return index;
    }, focus = function (target) {
        var cell = getCell(target);
        if (cell != null) {
            cell.setAttribute('tabindex', -1);
            cell.focus();
        }
    }, select = function (target, shift) {
        var cell = getCell(target);
        if (cell != null) {
            var dataTable = getDataTable(cell);
            var row = getRow(cell);
            var column = dataTable.model.columns[getCellX(cell)];
            if (isHeaderCell(cell)) {
                row = null;
            }
            if (isRowSelectCell(cell)) {
                column = null;
            }
            dataTable.model.select(column, row != null ? row.model : void 0, shift);
        }
    }, getAdjacentCell = function (element, dx, dy) {
        var cell = getCell(element);
        var x = getCellX(cell);
        var y = getCellY(cell);
        var dataTable = getDataTable(element);
        var adjacentCell = getCellByXY(dataTable, x + dx, y + dy);
        return adjacentCell;
    }, getDataTable = function (element) {
        return getAncestorByClass(element, 'DataTable2');
    }, getBody = function (element) {
        return getAncestorByClass(element, 'body');
    }, getCells = function (row) {
        return toArray(row.querySelector('.cells').childNodes);
    }, getCellFromRecordAndColumn = function (dataTable, record, column) {
        var x = dataTable.model.columns.indexOf(column);
        var y = dataTable.model.allRows.findIndex(function (row) {
                return row.record === record;
            });
        if (x >= 0 && y >= 0) {
            return getCellByXY(dataTable, x, y);
        }
    }, getCellX = function (cell) {
        return indexOf(cell);
    }, getCellY = function (cell) {
        return getRowY(getRow(cell));
    }, isHeaderCell = function (cell) {
        return isCell(cell) && isHeaderRow(getRow(cell));
    }, isFooterCell = function (cell) {
        return isCell(cell) && isFooterRow(getRow(cell));
    }, isRowSelectCell = function (cell) {
        return getDataTable(cell).model.columns[getCellX(cell)].isRowSelect === true;
    }, isHeaderRow = function (row) {
        return isRow(row) && row.parentElement.classList.contains('header');
    }, isFooterRow = function (row) {
        return isRow(row) && row.parentElement.classList.contains('footer');
    }, getRows = function (bodyOrDatatable) {
        return toArray(bodyOrDatatable.querySelectorAll('.row:not(.underlay)'));
    }, getRowModels = function (bodyOrDatatable) {
        var _ref10 = [];
        {
            var _ref11 = getRows(bodyOrDatatable);
            for (var _i = 0; _i < _ref11.length; _i++) {
                var row = _ref11[_i];
                if (row.model != null) {
                    _ref10.push(row.model);
                }
            }
        }
        return _ref10;
    }, getRowY = function (row) {
        if (isHeaderRow(row)) {
            return -1;
        }
        var body = getBody(row);
        return getRows(body).indexOf(row);
    }, getRowByY = function (dataTable, y) {
        return getRows(dataTable)[y + 1];
    }, getCellByXY = function (dataTable, x, y) {
        var row = getRowByY(dataTable, y);
        if (row != null) {
            var cells = getCells(row);
            var cell = cells[x];
            return cell;
        }
        return null;
    }, selectRange = function (a, b, shift) {
        a = getCell(a);
        b = getCell(b);
        if (a != null && b != null) {
            var aRowModel = getRow(a).model;
            var bRowModel = getRow(b).model;
            var dataTable = getDataTable(a);
            var aColumn = dataTable.model.columns[getCellX(a)];
            var bColumn = dataTable.model.columns[getCellX(b)];
            var all = (!aRowModel || !bRowModel) && (aColumn.isRowSelect || bColumn.isRowSelect);
            var columnMatch = 0;
            {
                var _ref12 = dataTable.model.columns;
                for (var _i2 = 0; _i2 < _ref12.length; _i2++) {
                    var column = _ref12[_i2];
                    if (column === aColumn) {
                        columnMatch++;
                    }
                    if (column === bColumn) {
                        columnMatch++;
                    }
                    column.setSelected(all || !aColumn.isRowSelect && !bColumn.isRowSelect && (column === aColumn || column === bColumn || columnMatch === 1));
                    var rowMatch = 0;
                    {
                        var _ref13 = getRowModels(dataTable);
                        for (var _i3 = 0; _i3 < _ref13.length; _i3++) {
                            var row = _ref13[_i3];
                            if (row === aRowModel) {
                                rowMatch++;
                            }
                            if (row === bRowModel) {
                                rowMatch++;
                            }
                            row.setSelected(all || aRowModel != null && bRowModel != null && (row === aRowModel || row === bRowModel || rowMatch === 1));
                        }
                    }
                }
            }
        }
    }, getSingleSelectedCell = function (dataTable) {
        var cell = getCell(document.activeElement);
        if (!(cell != null)) {
            if (dataTable.model.selectedColumns.length === 1 && dataTable.model.selectedRows.length === 1) {
                var column = dataTable.model.selectedColumns[0];
                var row = dataTable.model.selectedRows[0];
                var x = dataTable.model.columns.indexOf(column);
                var y = dataTable.model.allRows.indexOf(row);
                cell = getCellByXY(dataTable, x, y);
            }
        }
        return cell;
    }, getPrimaryColumnIndex = function (dataTableModel) {
        {
            var _ref14 = dataTableModel.columns;
            for (var _i4 = 0; _i4 < _ref14.length; _i4++) {
                var index = _i4;
                var column = _ref14[_i4];
                if (column.primary) {
                    return index;
                }
            }
        }
        return 1;
    };
module.exports = exports = ion.template(function SelectAndNavigateSupport(dataTable) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'SelectAndNavigateSupport',
            loc: {
                start: {
                    line: 127,
                    column: 16,
                    fixed: true,
                    source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                },
                end: {
                    line: 127,
                    column: 40,
                    fixed: true,
                    source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                }
            }
        },
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'dataTableModel',
                            loc: {
                                start: {
                                    line: 128,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                },
                                end: {
                                    line: 128,
                                    column: 22,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            computed: false,
                            object: {
                                type: 'Identifier',
                                name: 'dataTable',
                                loc: {
                                    start: {
                                        line: 128,
                                        column: 25,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                    },
                                    end: {
                                        line: 128,
                                        column: 34,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'model',
                                loc: {
                                    start: {
                                        line: 128,
                                        column: 35,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                    },
                                    end: {
                                        line: 128,
                                        column: 40,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 128,
                                    column: 25,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                },
                                end: {
                                    line: 128,
                                    column: 40,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: '_ref3'
                        },
                        init: {
                            type: 'Identifier',
                            name: 'dataTableModel',
                            loc: {
                                start: {
                                    line: 129,
                                    column: 40,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                },
                                end: {
                                    line: 129,
                                    column: 54,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'id',
                            loc: {
                                start: {
                                    line: 129,
                                    column: 9,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                },
                                end: {
                                    line: 129,
                                    column: 11,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'id',
                                loc: {
                                    start: {
                                        line: 129,
                                        column: 9,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                    },
                                    end: {
                                        line: 129,
                                        column: 11,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'rowSource',
                            loc: {
                                start: {
                                    line: 129,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                },
                                end: {
                                    line: 129,
                                    column: 22,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'rowSource',
                                loc: {
                                    start: {
                                        line: 129,
                                        column: 13,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                    },
                                    end: {
                                        line: 129,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '3'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'columnSource',
                            loc: {
                                start: {
                                    line: 129,
                                    column: 24,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                },
                                end: {
                                    line: 129,
                                    column: 36,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'columnSource',
                                loc: {
                                    start: {
                                        line: 129,
                                        column: 24,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                    },
                                    end: {
                                        line: 129,
                                        column: 36,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '4'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: '_ref4'
                        },
                        init: {
                            type: 'Identifier',
                            name: 'columnSource',
                            loc: {
                                start: {
                                    line: 130,
                                    column: 20,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                },
                                end: {
                                    line: 130,
                                    column: 32,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '5'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'columns',
                            loc: {
                                start: {
                                    line: 130,
                                    column: 9,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                },
                                end: {
                                    line: 130,
                                    column: 16,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref4'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'columns',
                                loc: {
                                    start: {
                                        line: 130,
                                        column: 9,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                    },
                                    end: {
                                        line: 130,
                                        column: 16,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '6'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'temp',
                            loc: {
                                start: {
                                    line: 131,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                },
                                end: {
                                    line: 131,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            properties: []
                        }
                    }],
                kind: 'let',
                order: '7'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'activeElement',
                            loc: {
                                start: {
                                    line: 133,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                },
                                end: {
                                    line: 133,
                                    column: 21,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            computed: false,
                            object: {
                                type: 'Identifier',
                                name: 'document',
                                loc: {
                                    start: {
                                        line: 133,
                                        column: 24,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                    },
                                    end: {
                                        line: 133,
                                        column: 32,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'activeElement',
                                loc: {
                                    start: {
                                        line: 133,
                                        column: 33,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                    },
                                    end: {
                                        line: 133,
                                        column: 46,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 133,
                                    column: 24,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                },
                                end: {
                                    line: 133,
                                    column: 46,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '8'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'cell',
                            loc: {
                                start: {
                                    line: 134,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                },
                                end: {
                                    line: 134,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'getCell',
                                loc: {
                                    start: {
                                        line: 134,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                    },
                                    end: {
                                        line: 134,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'Identifier',
                                    name: 'activeElement',
                                    loc: {
                                        start: {
                                            line: 134,
                                            column: 23,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                        },
                                        end: {
                                            line: 134,
                                            column: 36,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                        }
                                    }
                                }],
                            loc: {
                                start: {
                                    line: 134,
                                    column: 15,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                },
                                end: {
                                    line: 134,
                                    column: 37,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '9'
            },
            {
                type: 'ExpressionStatement',
                expression: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'Identifier',
                        name: 'dataTable',
                        loc: {
                            start: {
                                line: 136,
                                column: 4,
                                fixed: true,
                                source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                            },
                            end: {
                                line: 136,
                                column: 13,
                                fixed: true,
                                source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                            }
                        }
                    },
                    properties: [
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'focusCell',
                                loc: {
                                    start: {
                                        line: 137,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                    },
                                    end: {
                                        line: 137,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Identifier',
                                name: 'cell',
                                loc: {
                                    start: {
                                        line: 137,
                                        column: 19,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                    },
                                    end: {
                                        line: 137,
                                        column: 23,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                    }
                                }
                            },
                            kind: 'init',
                            order: '0'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'focus',
                                loc: {
                                    start: {
                                        line: 138,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                    },
                                    end: {
                                        line: 138,
                                        column: 13,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context) {
                                    return function () {
                                        var ion = _context.get('ion'), dataTableModel = _context.get('dataTableModel'), getCellByXY = _context.get('getCellByXY'), dataTable = _context.get('dataTable');
                                        ion.sync();
                                        var x = dataTableModel.columns.indexOf(dataTableModel.selectedColumns[0]);
                                        var y = dataTableModel.allRows.indexOf(dataTableModel.selectedRows[0]);
                                        if (x != null && y != null) {
                                            var cell = getCellByXY(dataTable, x, y);
                                            cell != null ? cell.focus() : void 0;
                                        }
                                    };
                                }
                            },
                            kind: 'init',
                            order: '1'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'insertNewRow',
                                loc: {
                                    start: {
                                        line: 145,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                    },
                                    end: {
                                        line: 145,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: false,
                                value: function (_ref5) {
                                    if (_ref5 == null)
                                        _ref5 = {};
                                    var e = _ref5.e;
                                    return this.addNewRow({
                                        e: e,
                                        insert: true
                                    });
                                }
                            },
                            kind: 'init',
                            order: '2'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'addNewRow',
                                loc: {
                                    start: {
                                        line: 146,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                    },
                                    end: {
                                        line: 146,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context2) {
                                    return function (_ref6) {
                                        if (_ref6 == null)
                                            _ref6 = {};
                                        var getSingleSelectedCell = _context2.get('getSingleSelectedCell'), dataTable = _context2.get('dataTable'), getRow = _context2.get('getRow'), dataTableModel = _context2.get('dataTableModel'), ion = _context2.get('ion'), getAdjacentCell = _context2.get('getAdjacentCell'), getCellByXY = _context2.get('getCellByXY'), getPrimaryColumnIndex = _context2.get('getPrimaryColumnIndex'), focus = _context2.get('focus'), select = _context2.get('select');
                                        var e = _ref6.e;
                                        var insert = _ref6.insert;
                                        var properties = _ref6.properties;
                                        var callback = _ref6.callback;
                                        var cell = null, parent = null, insertBefore = null;
                                        if (insert) {
                                            cell = getSingleSelectedCell(dataTable);
                                            if (cell != null) {
                                                var row = getRow(cell).model;
                                                var _ref7 = row;
                                                var record = _ref7.record;
                                                if (row.open && (row.children != null ? row.children.length : void 0) > 0 || (e != null ? e.ctrlKey : void 0) || (e != null ? e.metaKey : void 0)) {
                                                    row.setOpen(true);
                                                    parent = record;
                                                    insertBefore = (row.children != null ? row.children[0] != null ? row.children[0].record : void 0 : void 0) != null ? row.children[0].record : null;
                                                } else {
                                                    parent = row.recordParent;
                                                    var siblings = row.getSiblingRecords();
                                                    if (siblings != null) {
                                                        insertBefore = siblings[siblings.indexOf(record) + 1];
                                                    }
                                                }
                                            }
                                        }
                                        dataTableModel.rowSource.beginOp();
                                        var newRecord = dataTableModel.rowSource.insertRecord(properties != null ? properties : {}, parent, insertBefore);
                                        ion.sync();
                                        var newCell = cell ? getAdjacentCell(cell, 0, +1) : getCellByXY(dataTable, getPrimaryColumnIndex(dataTableModel), dataTableModel.allRows.length - 1);
                                        focus(newCell);
                                        select(newCell);
                                        return newRecord;
                                    };
                                }
                            },
                            kind: 'init',
                            order: '3'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'beginEdit',
                                loc: {
                                    start: {
                                        line: 174,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                    },
                                    end: {
                                        line: 174,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context3) {
                                    return function (_ref8) {
                                        var getCellFromRecordAndColumn = _context3.get('getCellFromRecordAndColumn'), dataTable = _context3.get('dataTable'), getCellX = _context3.get('getCellX'), getCellY = _context3.get('getCellY'), getRow = _context3.get('getRow'), columns = _context3.get('columns'), dataTableModel = _context3.get('dataTableModel'), beginEdit = _context3.get('beginEdit'), columnSource = _context3.get('columnSource'), getAdjacentCell = _context3.get('getAdjacentCell'), focus = _context3.get('focus'), select = _context3.get('select');
                                        var record = _ref8.record;
                                        var column = _ref8.column;
                                        var cell = _ref8.cell;
                                        var value = _ref8.value;
                                        var selectInput = _ref8.select;
                                        var commit = _ref8.commit;
                                        var cancel = _ref8.cancel;
                                        cell = cell != null ? cell : getCellFromRecordAndColumn(dataTable, record, column);
                                        if (cell != null) {
                                            var x = getCellX(cell);
                                            var y = getCellY(cell);
                                            var row = getRow(cell);
                                            if (row.model != null) {
                                                record = record != null ? record : row.model.record;
                                                column = column != null ? column : columns[x];
                                                var property = column.property;
                                                if (dataTableModel.editable && (column.canEdit != null ? column.canEdit(dataTable.model, record) : void 0) !== false) {
                                                    var saveObjects = dataTableModel.selectedRows.map(function (_ref9) {
                                                            var record = _ref9.record;
                                                            return record;
                                                        });
                                                    beginEdit({
                                                        element: cell,
                                                        saveObjects: saveObjects,
                                                        object: record,
                                                        value: value,
                                                        select: selectInput,
                                                        property: property,
                                                        properties: columnSource.properties,
                                                        commit: function (e) {
                                                            var se = e.detail != null ? e.detail.srcEvent : void 0;
                                                            if ((se != null ? se.keyCode : void 0) === 13) {
                                                                if (se.shiftKey) {
                                                                    dataTable.insertNewRow({ e: se });
                                                                } else {
                                                                    var down = getAdjacentCell(cell, 0, +1);
                                                                    focus(down);
                                                                    select(down);
                                                                }
                                                            }
                                                        }
                                                    });
                                                }
                                            }
                                        }
                                    };
                                }
                            },
                            kind: 'init',
                            order: '4'
                        },
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'Function',
                                context: true,
                                value: function (_context4) {
                                    return function click(e) {
                                        var getCell = _context4.get('getCell'), getCellX = _context4.get('getCellX'), columns = _context4.get('columns'), dataTable = _context4.get('dataTable');
                                        var cell = getCell(e.target);
                                        if (cell != null) {
                                            var x = getCellX(cell);
                                            var column = columns[x];
                                            if (column.clicksToEdit === e.detail) {
                                                dataTable.beginEdit({
                                                    cell: cell,
                                                    select: false
                                                });
                                            }
                                        }
                                    };
                                }
                            },
                            loc: {
                                start: {
                                    line: 198,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                },
                                end: {
                                    line: 205,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                }
                            },
                            order: '5'
                        },
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'Function',
                                context: true,
                                value: function (_context5) {
                                    return function mousedown(e) {
                                        var getCell = _context5.get('getCell'), getRow = _context5.get('getRow'), dataTable = _context5.get('dataTable'), selectRange = _context5.get('selectRange'), temp = _context5.get('temp'), select = _context5.get('select'), focus = _context5.get('focus');
                                        if (e.button === 0) {
                                            var activeCell = getCell(document.activeElement);
                                            var cell = getCell(e.target);
                                            if (e.ctrlKey || e.metaKey) {
                                                var row = getRow(cell);
                                                if (row != null) {
                                                    dataTable.model.selectAllColumns(false);
                                                    row.model.setSelected(!row.model.selected);
                                                    e.preventDefault();
                                                }
                                            } else {
                                                if (e.shiftKey && activeCell != null) {
                                                    selectRange(activeCell, cell, e.shiftKey);
                                                } else {
                                                    temp.dragging = true;
                                                    select(cell, e.shiftKey);
                                                    selectRange(cell, cell, e.shiftKey);
                                                }
                                            }
                                            focus(cell);
                                        }
                                    };
                                }
                            },
                            loc: {
                                start: {
                                    line: 210,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                },
                                end: {
                                    line: 228,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                }
                            },
                            order: '6'
                        },
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'Function',
                                context: true,
                                value: function (_context6) {
                                    return function mousemove(e) {
                                        var temp = _context6.get('temp'), selectRange = _context6.get('selectRange'), ion = _context6.get('ion');
                                        if (temp.dragging) {
                                            selectRange(document.activeElement, e.target, e.shiftKey);
                                            ion.sync();
                                        }
                                    };
                                }
                            },
                            loc: {
                                start: {
                                    line: 228,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                },
                                end: {
                                    line: 232,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                }
                            },
                            order: '7'
                        },
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'Function',
                                context: true,
                                value: function (_context7) {
                                    return function mouseup(e) {
                                        var temp = _context7.get('temp');
                                        if (e.button === 0) {
                                            temp.dragging = false;
                                        }
                                    };
                                }
                            },
                            loc: {
                                start: {
                                    line: 232,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                },
                                end: {
                                    line: 235,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                }
                            },
                            order: '8'
                        },
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'Function',
                                context: true,
                                value: function (_context8) {
                                    return function keypress(e) {
                                        var getCell = _context8.get('getCell'), dataTable = _context8.get('dataTable');
                                        var cell = getCell(e.target);
                                        if (cell != null) {
                                            var char = String.fromCharCode(e.charCode);
                                            if (char.trim().length > 0) {
                                                dataTable.beginEdit({
                                                    cell: cell,
                                                    value: char,
                                                    select: false
                                                });
                                                e.preventDefault();
                                            }
                                        }
                                    };
                                }
                            },
                            loc: {
                                start: {
                                    line: 235,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                },
                                end: {
                                    line: 242,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                }
                            },
                            order: '9'
                        },
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'Function',
                                context: true,
                                value: function (_context9) {
                                    return function keydown(e) {
                                        var dataTable = _context9.get('dataTable'), getCell = _context9.get('getCell'), temp = _context9.get('temp'), getCellX = _context9.get('getCellX'), getCellY = _context9.get('getCellY'), getAdjacentCell = _context9.get('getAdjacentCell'), getCellByXY = _context9.get('getCellByXY'), focus = _context9.get('focus'), selectRange = _context9.get('selectRange'), select = _context9.get('select');
                                        if (e.keyCode === 46) {
                                            dataTable.model.deleteSelection();
                                        }
                                        var cell = getCell(e.target);
                                        if (cell != null) {
                                            var shift = e.shiftKey;
                                            if (e.keyCode === 16) {
                                                temp.shiftStartX = getCellX(cell);
                                                temp.shiftStartY = getCellY(cell);
                                            }
                                            if (e.keyCode === 13) {
                                                if (shift) {
                                                    dataTable.insertNewRow({ e: e });
                                                } else {
                                                    dataTable.beginEdit({
                                                        cell: cell,
                                                        select: true
                                                    });
                                                    e.preventDefault();
                                                }
                                                return;
                                            }
                                            var next = null;
                                            if (e.keyCode === 39) {
                                                next = getAdjacentCell(cell, +1, 0);
                                            }
                                            if (e.keyCode === 37) {
                                                next = getAdjacentCell(cell, -1, 0);
                                            }
                                            if (e.keyCode === 40) {
                                                next = getAdjacentCell(cell, 0, +1);
                                            }
                                            if (e.keyCode === 38) {
                                                next = getAdjacentCell(cell, 0, -1);
                                            } else if (e.keyCode === 9) {
                                                if (shift) {
                                                    shift = false;
                                                    next = getAdjacentCell(cell, -1, 0) != null ? getAdjacentCell(cell, -1, 0) : getCellByXY(dataTable, dataTable.model.columns.length - 1, getCellY(cell) - 1);
                                                } else {
                                                    next = getAdjacentCell(cell, +1, 0) != null ? getAdjacentCell(cell, +1, 0) : getCellByXY(dataTable, 0, getCellY(cell) + 1);
                                                }
                                            }
                                            if (next != null) {
                                                focus(next);
                                                if (shift) {
                                                    selectRange(getCellByXY(dataTable, temp.shiftStartX, temp.shiftStartY), next, shift);
                                                } else {
                                                    select(next, shift);
                                                    if (!e.ctrlKey) {
                                                        selectRange(next, next);
                                                    }
                                                }
                                                e.preventDefault();
                                            }
                                        }
                                    };
                                }
                            },
                            loc: {
                                start: {
                                    line: 242,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                },
                                end: {
                                    line: 291,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                                }
                            },
                            order: ':'
                        }
                    ]
                },
                loc: {
                    start: {
                        line: 136,
                        column: 4,
                        fixed: true,
                        source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                    },
                    end: {
                        line: 291,
                        column: 8,
                        fixed: true,
                        source: 'glass/html/material/DataTable2/NavigateAndEditSupport.ion'
                    }
                },
                order: ':'
            }
        ],
        bound: false
    }, {
        this: this,
        ion: ion,
        dataTable: dataTable,
        _ref: _ref,
        _ref2: _ref2,
        getAncestorByClass: getAncestorByClass,
        getOffsetRelative: getOffsetRelative,
        isAncestor: isAncestor,
        beginEdit: beginEdit,
        toArray: toArray,
        isRow: isRow,
        isCells: isCells,
        isCell: isCell,
        getRow: getRow,
        getCell: getCell,
        indexOf: indexOf,
        focus: focus,
        select: select,
        getAdjacentCell: getAdjacentCell,
        getDataTable: getDataTable,
        getBody: getBody,
        getCells: getCells,
        getCellFromRecordAndColumn: getCellFromRecordAndColumn,
        getCellX: getCellX,
        getCellY: getCellY,
        isHeaderCell: isHeaderCell,
        isFooterCell: isFooterCell,
        isRowSelectCell: isRowSelectCell,
        isHeaderRow: isHeaderRow,
        isFooterRow: isFooterRow,
        getRows: getRows,
        getRowModels: getRowModels,
        getRowY: getRowY,
        getRowByY: getRowByY,
        getCellByXY: getCellByXY,
        selectRange: selectRange,
        getSingleSelectedCell: getSingleSelectedCell,
        getPrimaryColumnIndex: getPrimaryColumnIndex
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/DataTable2/NavigateAndEditSupport',_glass_html_material_DataTable2_NavigateAndEditSupport_);
    else
      _glass_html_material_DataTable2_NavigateAndEditSupport_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_DataTable2_NavigateAndEditSupport_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_DataTable2_ObjectRowSource_ = function(module,exports,require){'use strict';
var ion = require('ion');
var Row = {
        key: 'string',
        record: 'object',
        delete: function () {
        }
    };
module.exports = exports = ion.template(function ObjectRowSource(_ref) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'ObjectRowSource',
            loc: {
                start: {
                    line: 7,
                    column: 16,
                    fixed: true,
                    source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                },
                end: {
                    line: 7,
                    column: 31,
                    fixed: true,
                    source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                }
            }
        },
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'object',
                            loc: {
                                start: {
                                    line: 7,
                                    column: 33,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                },
                                end: {
                                    line: 7,
                                    column: 39,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'object',
                                loc: {
                                    start: {
                                        line: 7,
                                        column: 33,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                    },
                                    end: {
                                        line: 7,
                                        column: 39,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'property',
                            loc: {
                                start: {
                                    line: 7,
                                    column: 41,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                },
                                end: {
                                    line: 7,
                                    column: 49,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'property',
                                loc: {
                                    start: {
                                        line: 7,
                                        column: 41,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                    },
                                    end: {
                                        line: 7,
                                        column: 49,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'type',
                            loc: {
                                start: {
                                    line: 7,
                                    column: 51,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                },
                                end: {
                                    line: 7,
                                    column: 55,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'type',
                                loc: {
                                    start: {
                                        line: 7,
                                        column: 51,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                    },
                                    end: {
                                        line: 7,
                                        column: 55,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'getKey',
                            loc: {
                                start: {
                                    line: 7,
                                    column: 57,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                },
                                end: {
                                    line: 7,
                                    column: 63,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'getKey',
                                loc: {
                                    start: {
                                        line: 7,
                                        column: 57,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                    },
                                    end: {
                                        line: 7,
                                        column: 63,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '3'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'sort',
                            loc: {
                                start: {
                                    line: 7,
                                    column: 65,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                },
                                end: {
                                    line: 7,
                                    column: 69,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'sort',
                                loc: {
                                    start: {
                                        line: 7,
                                        column: 65,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                    },
                                    end: {
                                        line: 7,
                                        column: 69,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '4'
            },
            {
                type: 'ExpressionStatement',
                expression: {
                    type: 'CallExpression',
                    callee: {
                        type: 'Function',
                        context: false,
                        value: function (object, property) {
                            if (object != null) {
                                object[property] = object[property] != null ? object[property] : {};
                            }
                        }
                    },
                    arguments: [
                        {
                            type: 'Identifier',
                            name: 'object',
                            loc: {
                                start: {
                                    line: 9,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                },
                                end: {
                                    line: 9,
                                    column: 14,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                }
                            }
                        },
                        {
                            type: 'Identifier',
                            name: 'property',
                            loc: {
                                start: {
                                    line: 9,
                                    column: 16,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                },
                                end: {
                                    line: 9,
                                    column: 24,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                }
                            }
                        }
                    ],
                    loc: {
                        start: {
                            line: 9,
                            column: 4,
                            fixed: true,
                            source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                        },
                        end: {
                            line: 13,
                            column: 8,
                            fixed: true,
                            source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                        }
                    }
                },
                loc: {
                    start: {
                        line: 9,
                        column: 4,
                        fixed: true,
                        source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                    },
                    end: {
                        line: 13,
                        column: 8,
                        fixed: true,
                        source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                    }
                },
                order: '5'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'rawRecords',
                            loc: {
                                start: {
                                    line: 13,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                },
                                end: {
                                    line: 13,
                                    column: 18,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            computed: true,
                            object: {
                                type: 'Identifier',
                                name: 'object',
                                loc: {
                                    start: {
                                        line: 13,
                                        column: 21,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                    },
                                    end: {
                                        line: 13,
                                        column: 27,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'property',
                                loc: {
                                    start: {
                                        line: 13,
                                        column: 29,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                    },
                                    end: {
                                        line: 13,
                                        column: 37,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                    }
                                }
                            },
                            existential: true,
                            loc: {
                                start: {
                                    line: 13,
                                    column: 21,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                },
                                end: {
                                    line: 13,
                                    column: 38,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '6'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'records',
                            loc: {
                                start: {
                                    line: 15,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                },
                                end: {
                                    line: 15,
                                    column: 15,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Function',
                                context: true,
                                value: function (_context) {
                                    return function (rawRecords) {
                                        var sort = _context.get('sort'), ion = _context.get('ion');
                                        if (!(sort != null)) {
                                            return rawRecords;
                                        }
                                        var keyMap = new Map();
                                        for (var recordKey in rawRecords) {
                                            var record = rawRecords[recordKey];
                                            keyMap.set(record, recordKey);
                                        }
                                        var sortedRecords = {};
                                        var sortedRecordArray = Object.values(rawRecords);
                                        sortedRecordArray.sort(ion.createSortFunction(sort));
                                        for (var _i = 0; _i < sortedRecordArray.length; _i++) {
                                            var record = sortedRecordArray[_i];
                                            sortedRecords[keyMap.get(record)] = record;
                                        }
                                        return sortedRecords;
                                    };
                                }
                            },
                            arguments: [{
                                    type: 'Identifier',
                                    name: 'rawRecords',
                                    loc: {
                                        start: {
                                            line: 15,
                                            column: 22,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                        },
                                        end: {
                                            line: 15,
                                            column: 32,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                        }
                                    }
                                }],
                            loc: {
                                start: {
                                    line: 15,
                                    column: 18,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                },
                                end: {
                                    line: 28,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '7'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'rows',
                            loc: {
                                start: {
                                    line: 28,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                },
                                end: {
                                    line: 28,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'ArrayExpression',
                                elements: []
                            },
                            properties: [{
                                    type: 'IfStatement',
                                    test: {
                                        type: 'UnaryExpression',
                                        operator: '?',
                                        argument: {
                                            type: 'Identifier',
                                            name: 'records',
                                            loc: {
                                                start: {
                                                    line: 29,
                                                    column: 11,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                                },
                                                end: {
                                                    line: 29,
                                                    column: 18,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                                }
                                            }
                                        }
                                    },
                                    consequent: {
                                        type: 'BlockStatement',
                                        body: [{
                                                type: 'ForInStatement',
                                                left: {
                                                    type: 'VariableDeclaration',
                                                    declarations: [
                                                        {
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'recordKey',
                                                                loc: {
                                                                    start: {
                                                                        line: 30,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                                                    },
                                                                    end: {
                                                                        line: 30,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: null
                                                        },
                                                        {
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'record',
                                                                loc: {
                                                                    start: {
                                                                        line: 30,
                                                                        column: 27,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                                                    },
                                                                    end: {
                                                                        line: 30,
                                                                        column: 33,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: null
                                                        }
                                                    ],
                                                    kind: 'let'
                                                },
                                                right: {
                                                    type: 'Identifier',
                                                    name: 'records',
                                                    loc: {
                                                        start: {
                                                            line: 30,
                                                            column: 37,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                                        },
                                                        end: {
                                                            line: 30,
                                                            column: 44,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                                        }
                                                    }
                                                },
                                                body: {
                                                    type: 'BlockStatement',
                                                    body: [{
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'ObjectExpression',
                                                                objectType: {
                                                                    type: 'ObjectExpression',
                                                                    properties: []
                                                                },
                                                                properties: [
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'key',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 32,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 32,
                                                                                    column: 23,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Identifier',
                                                                            name: 'recordKey',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 32,
                                                                                    column: 25,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 32,
                                                                                    column: 34,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    },
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'record',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 33,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 33,
                                                                                    column: 26,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Identifier',
                                                                            name: 'record',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 33,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 33,
                                                                                    column: 34,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        kind: 'init',
                                                                        order: '1'
                                                                    },
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'delete',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 34,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 34,
                                                                                    column: 26,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Function',
                                                                            context: true,
                                                                            value: function (_context2) {
                                                                                return function () {
                                                                                    var rawRecords = _context2.get('rawRecords'), recordKey = _context2.get('recordKey');
                                                                                    delete rawRecords[recordKey];
                                                                                };
                                                                            }
                                                                        },
                                                                        kind: 'init',
                                                                        order: '2'
                                                                    }
                                                                ]
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 31,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                                                },
                                                                end: {
                                                                    line: 37,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                                                }
                                                            },
                                                            order: '0'
                                                        }]
                                                },
                                                remove: null,
                                                order: '0'
                                            }]
                                    },
                                    alternate: null,
                                    order: '0'
                                }]
                        }
                    }],
                kind: 'let',
                order: '8'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'ObjectExpression',
                        properties: []
                    },
                    properties: [
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'beginOp',
                                loc: {
                                    start: {
                                        line: 38,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                    },
                                    end: {
                                        line: 38,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: false,
                                value: function () {
                                    return global.model.ops.begin();
                                }
                            },
                            kind: 'init',
                            order: '0'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'records',
                                loc: {
                                    start: {
                                        line: 39,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                    },
                                    end: {
                                        line: 39,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Identifier',
                                name: 'records',
                                loc: {
                                    start: {
                                        line: 39,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                    },
                                    end: {
                                        line: 39,
                                        column: 24,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                    }
                                }
                            },
                            kind: 'init',
                            order: '1'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'rows',
                                loc: {
                                    start: {
                                        line: 40,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                    },
                                    end: {
                                        line: 40,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Identifier',
                                name: 'rows',
                                loc: {
                                    start: {
                                        line: 40,
                                        column: 14,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                    },
                                    end: {
                                        line: 40,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                    }
                                }
                            },
                            kind: 'init',
                            order: '2'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'loading',
                                loc: {
                                    start: {
                                        line: 41,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                    },
                                    end: {
                                        line: 41,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Literal',
                                value: false
                            },
                            kind: 'init',
                            order: '3'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'insertRecord',
                                loc: {
                                    start: {
                                        line: 42,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                    },
                                    end: {
                                        line: 42,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/ObjectRowSource.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context3) {
                                    return function (record, parent, insertBefore) {
                                        var getKey = _context3.get('getKey'), type = _context3.get('type'), rawRecords = _context3.get('rawRecords');
                                        var key = (getKey != null ? getKey(record) : void 0) != null ? getKey(record) : record.key;
                                        if (!(key != null)) {
                                            throw new Error('Either key or getKey must be provided');
                                        }
                                        var recordType = new type(record);
                                        rawRecords[key] = recordType;
                                        return recordType;
                                    };
                                }
                            },
                            kind: 'init',
                            order: '4'
                        }
                    ]
                },
                order: '9'
            }
        ],
        bound: false
    }, {
        this: this,
        ion: ion,
        _ref: _ref,
        Row: Row
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/DataTable2/ObjectRowSource',_glass_html_material_DataTable2_ObjectRowSource_);
    else
      _glass_html_material_DataTable2_ObjectRowSource_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_DataTable2_ObjectRowSource_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_DataTable2_PagedRowSource_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('../../../data');
var Key = _ref.Key;
var query = _ref.query;
module.exports = exports = ion.template(function PagedRowSource(args) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'PagedRowSource',
            loc: {
                start: {
                    line: 5,
                    column: 16,
                    fixed: true,
                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                },
                end: {
                    line: 5,
                    column: 30,
                    fixed: true,
                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                }
            }
        },
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: '_ref2'
                        },
                        init: {
                            type: 'Identifier',
                            name: 'args',
                            loc: {
                                start: {
                                    line: 6,
                                    column: 39,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 43,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'state',
                            loc: {
                                start: {
                                    line: 6,
                                    column: 9,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 14,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref2'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'state',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 9,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 14,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'filter',
                            loc: {
                                start: {
                                    line: 6,
                                    column: 15,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 21,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref2'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'filter',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 21,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'ancestor',
                            loc: {
                                start: {
                                    line: 6,
                                    column: 22,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 30,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref2'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'ancestor',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 30,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '3'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'type',
                            loc: {
                                start: {
                                    line: 6,
                                    column: 31,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 35,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref2'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'type',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 31,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 35,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '4'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'limitOptions',
                            loc: {
                                start: {
                                    line: 7,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                },
                                end: {
                                    line: 7,
                                    column: 20,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ConditionalExpression',
                            test: {
                                type: 'BinaryExpression',
                                operator: '!=',
                                left: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'args',
                                        loc: {
                                            start: {
                                                line: 7,
                                                column: 23,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                            },
                                            end: {
                                                line: 7,
                                                column: 27,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'limitOptions',
                                        loc: {
                                            start: {
                                                line: 7,
                                                column: 28,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                            },
                                            end: {
                                                line: 7,
                                                column: 40,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 7,
                                            column: 23,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                        },
                                        end: {
                                            line: 7,
                                            column: 40,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: null
                                }
                            },
                            consequent: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'args',
                                    loc: {
                                        start: {
                                            line: 7,
                                            column: 23,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                        },
                                        end: {
                                            line: 7,
                                            column: 27,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'limitOptions',
                                    loc: {
                                        start: {
                                            line: 7,
                                            column: 28,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                        },
                                        end: {
                                            line: 7,
                                            column: 40,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 7,
                                        column: 23,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                    },
                                    end: {
                                        line: 7,
                                        column: 40,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                    }
                                }
                            },
                            alternate: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Function',
                                    context: false,
                                    value: function () {
                                        return Object.freeze([
                                            25,
                                            50,
                                            100,
                                            200
                                        ]);
                                    }
                                },
                                arguments: [],
                                loc: {
                                    start: {
                                        line: 7,
                                        column: 43,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                    },
                                    end: {
                                        line: 7,
                                        column: 82,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                    }
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '5'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'defaultSort',
                            loc: {
                                start: {
                                    line: 8,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                },
                                end: {
                                    line: 8,
                                    column: 19,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ConditionalExpression',
                            test: {
                                type: 'BinaryExpression',
                                operator: '!=',
                                left: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'args',
                                        loc: {
                                            start: {
                                                line: 8,
                                                column: 22,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                            },
                                            end: {
                                                line: 8,
                                                column: 26,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'defaultSort',
                                        loc: {
                                            start: {
                                                line: 8,
                                                column: 27,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                            },
                                            end: {
                                                line: 8,
                                                column: 38,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 8,
                                            column: 22,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                        },
                                        end: {
                                            line: 8,
                                            column: 38,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: null
                                }
                            },
                            consequent: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'args',
                                    loc: {
                                        start: {
                                            line: 8,
                                            column: 22,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                        },
                                        end: {
                                            line: 8,
                                            column: 26,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'defaultSort',
                                    loc: {
                                        start: {
                                            line: 8,
                                            column: 27,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                        },
                                        end: {
                                            line: 8,
                                            column: 38,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 8,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                    },
                                    end: {
                                        line: 8,
                                        column: 38,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                    }
                                }
                            },
                            alternate: {
                                type: 'ArrayExpression',
                                elements: []
                            }
                        }
                    }],
                kind: 'let',
                order: '6'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'sort',
                            loc: {
                                start: {
                                    line: 9,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                },
                                end: {
                                    line: 9,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ConditionalExpression',
                            test: {
                                type: 'BinaryExpression',
                                operator: '!=',
                                left: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'state',
                                        loc: {
                                            start: {
                                                line: 9,
                                                column: 15,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                            },
                                            end: {
                                                line: 9,
                                                column: 20,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'sort',
                                        loc: {
                                            start: {
                                                line: 9,
                                                column: 21,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                            },
                                            end: {
                                                line: 9,
                                                column: 25,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 9,
                                            column: 15,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                        },
                                        end: {
                                            line: 9,
                                            column: 25,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: null
                                }
                            },
                            consequent: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'state',
                                    loc: {
                                        start: {
                                            line: 9,
                                            column: 15,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                        },
                                        end: {
                                            line: 9,
                                            column: 20,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'sort',
                                    loc: {
                                        start: {
                                            line: 9,
                                            column: 21,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                        },
                                        end: {
                                            line: 9,
                                            column: 25,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 9,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                    },
                                    end: {
                                        line: 9,
                                        column: 25,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                    }
                                }
                            },
                            alternate: {
                                type: 'Identifier',
                                name: 'defaultSort',
                                loc: {
                                    start: {
                                        line: 9,
                                        column: 28,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                    },
                                    end: {
                                        line: 9,
                                        column: 39,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                    }
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '7'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'offset',
                            loc: {
                                start: {
                                    line: 10,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                },
                                end: {
                                    line: 10,
                                    column: 14,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ConditionalExpression',
                            test: {
                                type: 'BinaryExpression',
                                operator: '!=',
                                left: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'state',
                                        loc: {
                                            start: {
                                                line: 10,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                            },
                                            end: {
                                                line: 10,
                                                column: 22,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'offset',
                                        loc: {
                                            start: {
                                                line: 10,
                                                column: 23,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                            },
                                            end: {
                                                line: 10,
                                                column: 29,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 10,
                                            column: 17,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                        },
                                        end: {
                                            line: 10,
                                            column: 29,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: null
                                }
                            },
                            consequent: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'state',
                                    loc: {
                                        start: {
                                            line: 10,
                                            column: 17,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                        },
                                        end: {
                                            line: 10,
                                            column: 22,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'offset',
                                    loc: {
                                        start: {
                                            line: 10,
                                            column: 23,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                        },
                                        end: {
                                            line: 10,
                                            column: 29,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 10,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                    },
                                    end: {
                                        line: 10,
                                        column: 29,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                    }
                                }
                            },
                            alternate: {
                                type: 'Literal',
                                value: 0
                            }
                        }
                    }],
                kind: 'let',
                order: '8'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'limit',
                            loc: {
                                start: {
                                    line: 11,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                },
                                end: {
                                    line: 11,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ConditionalExpression',
                            test: {
                                type: 'BinaryExpression',
                                operator: '!=',
                                left: {
                                    type: 'ConditionalExpression',
                                    test: {
                                        type: 'BinaryExpression',
                                        operator: '!=',
                                        left: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'state',
                                                loc: {
                                                    start: {
                                                        line: 11,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                    },
                                                    end: {
                                                        line: 11,
                                                        column: 21,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'limit',
                                                loc: {
                                                    start: {
                                                        line: 11,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                    },
                                                    end: {
                                                        line: 11,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 11,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                },
                                                end: {
                                                    line: 11,
                                                    column: 27,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                }
                                            }
                                        },
                                        right: {
                                            type: 'Literal',
                                            value: null
                                        }
                                    },
                                    consequent: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'state',
                                            loc: {
                                                start: {
                                                    line: 11,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                },
                                                end: {
                                                    line: 11,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'limit',
                                            loc: {
                                                start: {
                                                    line: 11,
                                                    column: 22,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                },
                                                end: {
                                                    line: 11,
                                                    column: 27,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 11,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                            },
                                            end: {
                                                line: 11,
                                                column: 27,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                            }
                                        }
                                    },
                                    alternate: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'args',
                                            loc: {
                                                start: {
                                                    line: 11,
                                                    column: 30,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                },
                                                end: {
                                                    line: 11,
                                                    column: 34,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'defaultLimit',
                                            loc: {
                                                start: {
                                                    line: 11,
                                                    column: 35,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                },
                                                end: {
                                                    line: 11,
                                                    column: 47,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 11,
                                                column: 30,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                            },
                                            end: {
                                                line: 11,
                                                column: 47,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                            }
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: null
                                }
                            },
                            consequent: {
                                type: 'ConditionalExpression',
                                test: {
                                    type: 'BinaryExpression',
                                    operator: '!=',
                                    left: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'state',
                                            loc: {
                                                start: {
                                                    line: 11,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                },
                                                end: {
                                                    line: 11,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'limit',
                                            loc: {
                                                start: {
                                                    line: 11,
                                                    column: 22,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                },
                                                end: {
                                                    line: 11,
                                                    column: 27,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 11,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                            },
                                            end: {
                                                line: 11,
                                                column: 27,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                            }
                                        }
                                    },
                                    right: {
                                        type: 'Literal',
                                        value: null
                                    }
                                },
                                consequent: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'state',
                                        loc: {
                                            start: {
                                                line: 11,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                            },
                                            end: {
                                                line: 11,
                                                column: 21,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'limit',
                                        loc: {
                                            start: {
                                                line: 11,
                                                column: 22,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                            },
                                            end: {
                                                line: 11,
                                                column: 27,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 11,
                                            column: 16,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                        },
                                        end: {
                                            line: 11,
                                            column: 27,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                        }
                                    }
                                },
                                alternate: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'args',
                                        loc: {
                                            start: {
                                                line: 11,
                                                column: 30,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                            },
                                            end: {
                                                line: 11,
                                                column: 34,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'defaultLimit',
                                        loc: {
                                            start: {
                                                line: 11,
                                                column: 35,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                            },
                                            end: {
                                                line: 11,
                                                column: 47,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 11,
                                            column: 30,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                        },
                                        end: {
                                            line: 11,
                                            column: 47,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                        }
                                    }
                                }
                            },
                            alternate: {
                                type: 'MemberExpression',
                                computed: true,
                                object: {
                                    type: 'Identifier',
                                    name: 'limitOptions',
                                    loc: {
                                        start: {
                                            line: 11,
                                            column: 50,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                        },
                                        end: {
                                            line: 11,
                                            column: 62,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Literal',
                                    value: 0
                                },
                                loc: {
                                    start: {
                                        line: 11,
                                        column: 50,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                    },
                                    end: {
                                        line: 11,
                                        column: 65,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                    }
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '9'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'key',
                            loc: {
                                start: {
                                    line: 12,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                },
                                end: {
                                    line: 12,
                                    column: 11,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                }
                            }
                        },
                        init: {
                            type: 'NewExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Key',
                                loc: {
                                    start: {
                                        line: 12,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                    },
                                    end: {
                                        line: 12,
                                        column: 21,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                    }
                                }
                            },
                            arguments: [
                                {
                                    type: 'Identifier',
                                    name: 'ancestor',
                                    loc: {
                                        start: {
                                            line: 13,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                        },
                                        end: {
                                            line: 13,
                                            column: 16,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                        }
                                    }
                                },
                                {
                                    type: 'Identifier',
                                    name: 'type',
                                    loc: {
                                        start: {
                                            line: 14,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                        },
                                        end: {
                                            line: 14,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                        }
                                    }
                                },
                                {
                                    type: 'ObjectExpression',
                                    objectType: {
                                        type: 'ObjectExpression',
                                        properties: []
                                    },
                                    properties: [
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'where',
                                                loc: {
                                                    start: {
                                                        line: 16,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                    },
                                                    end: {
                                                        line: 16,
                                                        column: 17,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Identifier',
                                                name: 'filter',
                                                loc: {
                                                    start: {
                                                        line: 16,
                                                        column: 19,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                    },
                                                    end: {
                                                        line: 16,
                                                        column: 25,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                    }
                                                }
                                            },
                                            kind: 'init',
                                            order: '0'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'sort',
                                                loc: {
                                                    start: {
                                                        line: 17,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                    },
                                                    end: {
                                                        line: 17,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Identifier',
                                                name: 'sort',
                                                loc: {
                                                    start: {
                                                        line: 17,
                                                        column: 18,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                    },
                                                    end: {
                                                        line: 17,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                    }
                                                }
                                            },
                                            kind: 'init',
                                            order: '1'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'limit',
                                                loc: {
                                                    start: {
                                                        line: 18,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                    },
                                                    end: {
                                                        line: 18,
                                                        column: 17,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Identifier',
                                                name: 'limit',
                                                loc: {
                                                    start: {
                                                        line: 18,
                                                        column: 19,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                    },
                                                    end: {
                                                        line: 18,
                                                        column: 24,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                    }
                                                }
                                            },
                                            kind: 'init',
                                            order: '2'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'offset',
                                                loc: {
                                                    start: {
                                                        line: 19,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                    },
                                                    end: {
                                                        line: 19,
                                                        column: 18,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Identifier',
                                                name: 'offset',
                                                loc: {
                                                    start: {
                                                        line: 19,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                    },
                                                    end: {
                                                        line: 19,
                                                        column: 26,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                    }
                                                }
                                            },
                                            kind: 'init',
                                            order: '3'
                                        }
                                    ],
                                    deep: true
                                }
                            ],
                            loc: {
                                start: {
                                    line: 12,
                                    column: 14,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                },
                                end: {
                                    line: 20,
                                    column: 5,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: ':'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'records',
                            loc: {
                                start: {
                                    line: 21,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                },
                                end: {
                                    line: 21,
                                    column: 15,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            computed: true,
                            object: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'model',
                                    loc: {
                                        start: {
                                            line: 21,
                                            column: 18,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                        },
                                        end: {
                                            line: 21,
                                            column: 23,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'server',
                                    loc: {
                                        start: {
                                            line: 21,
                                            column: 24,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                        },
                                        end: {
                                            line: 21,
                                            column: 30,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 21,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                    },
                                    end: {
                                        line: 21,
                                        column: 30,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'key',
                                loc: {
                                    start: {
                                        line: 21,
                                        column: 31,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                    },
                                    end: {
                                        line: 21,
                                        column: 34,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 21,
                                    column: 18,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                },
                                end: {
                                    line: 21,
                                    column: 35,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: ';'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'rows',
                            loc: {
                                start: {
                                    line: 22,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                },
                                end: {
                                    line: 22,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'ArrayExpression',
                                elements: []
                            },
                            properties: [{
                                    type: 'ForInStatement',
                                    left: {
                                        type: 'VariableDeclaration',
                                        declarations: [
                                            {
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'recordKey',
                                                    loc: {
                                                        start: {
                                                            line: 23,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                        },
                                                        end: {
                                                            line: 23,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                        }
                                                    }
                                                },
                                                init: null
                                            },
                                            {
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'record',
                                                    loc: {
                                                        start: {
                                                            line: 23,
                                                            column: 23,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                        },
                                                        end: {
                                                            line: 23,
                                                            column: 29,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                        }
                                                    }
                                                },
                                                init: null
                                            }
                                        ],
                                        kind: 'let'
                                    },
                                    right: {
                                        type: 'Identifier',
                                        name: 'records',
                                        loc: {
                                            start: {
                                                line: 23,
                                                column: 33,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                            },
                                            end: {
                                                line: 23,
                                                column: 40,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                            }
                                        }
                                    },
                                    body: {
                                        type: 'BlockStatement',
                                        body: [{
                                                type: 'IfStatement',
                                                test: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'query',
                                                            loc: {
                                                                start: {
                                                                    line: 25,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                                },
                                                                end: {
                                                                    line: 25,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'matches',
                                                            loc: {
                                                                start: {
                                                                    line: 25,
                                                                    column: 21,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                                },
                                                                end: {
                                                                    line: 25,
                                                                    column: 28,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 25,
                                                                column: 15,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                            },
                                                            end: {
                                                                line: 25,
                                                                column: 28,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [
                                                        {
                                                            type: 'Identifier',
                                                            name: 'filter',
                                                            loc: {
                                                                start: {
                                                                    line: 25,
                                                                    column: 29,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                                },
                                                                end: {
                                                                    line: 25,
                                                                    column: 35,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                                }
                                                            }
                                                        },
                                                        {
                                                            type: 'Identifier',
                                                            name: 'record',
                                                            loc: {
                                                                start: {
                                                                    line: 25,
                                                                    column: 42,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                                },
                                                                end: {
                                                                    line: 25,
                                                                    column: 48,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                                }
                                                            },
                                                            deep: true
                                                        }
                                                    ],
                                                    loc: {
                                                        start: {
                                                            line: 25,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                        },
                                                        end: {
                                                            line: 25,
                                                            column: 49,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                        }
                                                    }
                                                },
                                                consequent: {
                                                    type: 'BlockStatement',
                                                    body: [{
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'ObjectExpression',
                                                                objectType: {
                                                                    type: 'ObjectExpression',
                                                                    properties: []
                                                                },
                                                                properties: [
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'key',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 27,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 27,
                                                                                    column: 23,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Identifier',
                                                                            name: 'recordKey',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 27,
                                                                                    column: 25,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 27,
                                                                                    column: 34,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    },
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'record',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 28,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 28,
                                                                                    column: 26,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Identifier',
                                                                            name: 'record',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 28,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 28,
                                                                                    column: 34,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        kind: 'init',
                                                                        order: '1'
                                                                    },
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'delete',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 29,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 29,
                                                                                    column: 26,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Function',
                                                                            context: true,
                                                                            value: function (_context) {
                                                                                return function () {
                                                                                    var records = _context.get('records'), recordKey = _context.get('recordKey');
                                                                                    delete records[recordKey];
                                                                                };
                                                                            }
                                                                        },
                                                                        kind: 'init',
                                                                        order: '2'
                                                                    }
                                                                ]
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 26,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                                },
                                                                end: {
                                                                    line: 33,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                                                }
                                                            },
                                                            order: '0'
                                                        }]
                                                },
                                                alternate: null,
                                                order: '0'
                                            }]
                                    },
                                    remove: null,
                                    order: '0'
                                }]
                        }
                    }],
                kind: 'let',
                order: '<'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'ObjectExpression',
                        properties: []
                    },
                    properties: [
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'key',
                                loc: {
                                    start: {
                                        line: 34,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                    },
                                    end: {
                                        line: 34,
                                        column: 11,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Identifier',
                                name: 'key',
                                loc: {
                                    start: {
                                        line: 34,
                                        column: 13,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                    },
                                    end: {
                                        line: 34,
                                        column: 16,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                    }
                                }
                            },
                            kind: 'init',
                            order: '0'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'beginOp',
                                loc: {
                                    start: {
                                        line: 35,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                    },
                                    end: {
                                        line: 35,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: false,
                                value: function () {
                                    return global.model.ops.begin();
                                }
                            },
                            kind: 'init',
                            order: '1'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'rows',
                                loc: {
                                    start: {
                                        line: 36,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                    },
                                    end: {
                                        line: 36,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Identifier',
                                name: 'rows',
                                loc: {
                                    start: {
                                        line: 36,
                                        column: 14,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                    },
                                    end: {
                                        line: 36,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                    }
                                }
                            },
                            kind: 'init',
                            order: '2'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'records',
                                loc: {
                                    start: {
                                        line: 37,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                    },
                                    end: {
                                        line: 37,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Identifier',
                                name: 'records',
                                loc: {
                                    start: {
                                        line: 37,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                    },
                                    end: {
                                        line: 37,
                                        column: 24,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                    }
                                }
                            },
                            kind: 'init',
                            order: '3'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'loading',
                                loc: {
                                    start: {
                                        line: 38,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                    },
                                    end: {
                                        line: 38,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'BinaryExpression',
                                operator: '===',
                                left: {
                                    type: 'Identifier',
                                    name: 'records',
                                    loc: {
                                        start: {
                                            line: 38,
                                            column: 17,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                        },
                                        end: {
                                            line: 38,
                                            column: 24,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                        }
                                    }
                                },
                                right: {
                                    type: 'UnaryExpression',
                                    operator: 'void',
                                    prefix: true,
                                    argument: {
                                        type: 'Literal',
                                        value: 0
                                    }
                                }
                            },
                            kind: 'init',
                            order: '4'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'refresh',
                                loc: {
                                    start: {
                                        line: 39,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                    },
                                    end: {
                                        line: 39,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context2) {
                                    return function () {
                                        var key = _context2.get('key');
                                        model.server.source.refresh(key, function (results) {
                                        });
                                    };
                                }
                            },
                            kind: 'init',
                            order: '5'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'insertRecord',
                                loc: {
                                    start: {
                                        line: 46,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                    },
                                    end: {
                                        line: 46,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PagedRowSource.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context3) {
                                    return function (record, parent, insertBefore) {
                                        var Key = _context3.get('Key'), ancestor = _context3.get('ancestor'), type = _context3.get('type'), records = _context3.get('records');
                                        if (!(record.key != null)) {
                                            var key = new Key(ancestor, type, model.guid());
                                            record.key = key.toString();
                                        }
                                        var recordType = new type(record);
                                        records[record.key] = recordType;
                                        return recordType;
                                    };
                                }
                            },
                            kind: 'init',
                            order: '6'
                        }
                    ]
                },
                order: '='
            }
        ],
        bound: false
    }, {
        this: this,
        args: args,
        ion: ion,
        _ref: _ref,
        Key: Key,
        query: query
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/DataTable2/PagedRowSource',_glass_html_material_DataTable2_PagedRowSource_);
    else
      _glass_html_material_DataTable2_PagedRowSource_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_DataTable2_PagedRowSource_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_DataTable2_PathColumn_ = function(module,exports,require){'use strict';
var ion = require('ion');
var DefaultColumn = require('./DefaultColumn');
function join(path) {
    return path.map(function (x) {
        return x + 1;
    }).join('.');
}
module.exports = exports = ion.template(function PathColumn(property) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'PathColumn',
            loc: {
                start: {
                    line: 5,
                    column: 16,
                    fixed: true,
                    source: 'glass/html/material/DataTable2/PathColumn.ion'
                },
                end: {
                    line: 5,
                    column: 26,
                    fixed: true,
                    source: 'glass/html/material/DataTable2/PathColumn.ion'
                }
            }
        },
        body: [{
                type: 'ReturnStatement',
                argument: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'CallExpression',
                        callee: {
                            type: 'Identifier',
                            name: 'DefaultColumn',
                            loc: {
                                start: {
                                    line: 6,
                                    column: 11,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/PathColumn.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 24,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/PathColumn.ion'
                                }
                            }
                        },
                        arguments: [{
                                type: 'Identifier',
                                name: 'property',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 25,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PathColumn.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 33,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PathColumn.ion'
                                    }
                                }
                            }],
                        loc: {
                            start: {
                                line: 6,
                                column: 11,
                                fixed: true,
                                source: 'glass/html/material/DataTable2/PathColumn.ion'
                            },
                            end: {
                                line: 6,
                                column: 34,
                                fixed: true,
                                source: 'glass/html/material/DataTable2/PathColumn.ion'
                            }
                        }
                    },
                    properties: [
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'defaultWidth',
                                loc: {
                                    start: {
                                        line: 7,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PathColumn.ion'
                                    },
                                    end: {
                                        line: 7,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PathColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Literal',
                                value: 50
                            },
                            kind: 'init',
                            order: '0'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'canEdit',
                                loc: {
                                    start: {
                                        line: 8,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PathColumn.ion'
                                    },
                                    end: {
                                        line: 8,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PathColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: false,
                                value: function (dataTableModel, object) {
                                    return false;
                                }
                            },
                            kind: 'init',
                            order: '1'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'getMimeValueFromRow',
                                loc: {
                                    start: {
                                        line: 9,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PathColumn.ion'
                                    },
                                    end: {
                                        line: 9,
                                        column: 27,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PathColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context) {
                                    return function (row, mimeType) {
                                        if (mimeType == null)
                                            mimeType = 'text/plain';
                                        var join = _context.get('join');
                                        return join(row.path);
                                    };
                                }
                            },
                            kind: 'init',
                            order: '2'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'createBodyCell',
                                loc: {
                                    start: {
                                        line: 10,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PathColumn.ion'
                                    },
                                    end: {
                                        line: 10,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PathColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_ps) {
                                    return ion.template(function (row) {
                                        return ion.createRuntime({
                                            type: 'Template',
                                            id: null,
                                            body: [{
                                                    type: 'ReturnStatement',
                                                    argument: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'Span',
                                                                loc: {
                                                                    start: {
                                                                        line: 11,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/PathColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 11,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/PathColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [],
                                                            loc: {
                                                                start: {
                                                                    line: 11,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/PathColumn.ion'
                                                                },
                                                                end: {
                                                                    line: 11,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/PathColumn.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [
                                                            {
                                                                type: 'VariableDeclaration',
                                                                declarations: [{
                                                                        type: 'VariableDeclarator',
                                                                        id: {
                                                                            type: 'Identifier',
                                                                            name: 'path',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 12,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/PathColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 12,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/PathColumn.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        init: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'row',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 12,
                                                                                        column: 27,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/PathColumn.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 12,
                                                                                        column: 30,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/PathColumn.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'path',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 12,
                                                                                        column: 31,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/PathColumn.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 12,
                                                                                        column: 35,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/PathColumn.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 12,
                                                                                    column: 27,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/PathColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 12,
                                                                                    column: 35,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/PathColumn.ion'
                                                                                }
                                                                            }
                                                                        }
                                                                    }],
                                                                kind: 'let',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'IfStatement',
                                                                test: {
                                                                    type: 'UnaryExpression',
                                                                    operator: '?',
                                                                    argument: {
                                                                        type: 'Identifier',
                                                                        name: 'path',
                                                                        loc: {
                                                                            start: {
                                                                                line: 13,
                                                                                column: 19,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/PathColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 13,
                                                                                column: 23,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/PathColumn.ion'
                                                                            }
                                                                        }
                                                                    }
                                                                },
                                                                consequent: {
                                                                    type: 'BlockStatement',
                                                                    body: [{
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'CallExpression',
                                                                                callee: {
                                                                                    type: 'Identifier',
                                                                                    name: 'join',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 14,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/PathColumn.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 14,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/PathColumn.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                arguments: [{
                                                                                        type: 'Identifier',
                                                                                        name: 'path',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 14,
                                                                                                column: 25,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/PathColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 14,
                                                                                                column: 29,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/PathColumn.ion'
                                                                                            }
                                                                                        }
                                                                                    }],
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 14,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/PathColumn.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 14,
                                                                                        column: 30,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/PathColumn.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 14,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/PathColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 14,
                                                                                    column: 30,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/PathColumn.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                alternate: null,
                                                                order: '1'
                                                            }
                                                        ]
                                                    },
                                                    order: '0'
                                                }],
                                            bound: false,
                                            name: {
                                                type: 'Identifier',
                                                name: 'createBodyCell',
                                                loc: {
                                                    start: {
                                                        line: 10,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/PathColumn.ion'
                                                    },
                                                    end: {
                                                        line: 10,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/PathColumn.ion'
                                                    }
                                                }
                                            },
                                            scope: {
                                                type: 'Identifier',
                                                name: '_ps'
                                            }
                                        }, {
                                            this: this,
                                            row: row,
                                            _ps: _ps,
                                            property: property,
                                            DefaultColumn: DefaultColumn,
                                            join: join
                                        }, _ps);
                                    });
                                }
                            },
                            kind: 'init',
                            order: '3'
                        }
                    ]
                },
                order: '0'
            }],
        bound: false
    }, {
        this: this,
        ion: ion,
        property: property,
        DefaultColumn: DefaultColumn,
        join: join
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/DataTable2/PathColumn',_glass_html_material_DataTable2_PathColumn_);
    else
      _glass_html_material_DataTable2_PathColumn_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_DataTable2_PathColumn_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_DataTable2_PrimaryColumn_ = function(module,exports,require){'use strict';
var ion = require('ion'), _ref, DefaultColumn = require('./DefaultColumn'), _ref2, _ref3;
_ref = require('../../../data');
var Schema = _ref.Schema;
_ref2 = require('../../');
var style = _ref2.style;
_ref3 = require('../');
var Menu = _ref3.NewMenu;
var _ref5 = style.sheets;
_ref5[module.id] = '.PrimaryColumnCell {\n    display: flex;\n    flex-direction: row;\n    align-items: center;\n}\n.PrimaryColumnCell IRON-ICON {\n    flex: 0 0 auto;\n    width: 20px;\n    height: 20px;\n    margin-right: 4px;\n}\n.PrimaryColumnCell IRON-ICON.toggle {\n    transition: transform 0.2s;\n    transform: rotateZ(0deg);\n    cursor: pointer;\n}\n.PrimaryColumnCell IRON-ICON.bullet {\n    transform: scale(0.5);\n    opacity: 0.3;\n}\n.PrimaryColumnCell.root IRON-ICON.bullet {\n    transform: scale(0.5);\n    opacity: 0;\n}\n.PrimaryColumnCell.open .toggle {\n    transform: rotateZ(90deg);\n}\n.PrimaryColumnCell .link {\n    cursor: pointer;\n    color: ' + style.color.accentDark + ';\n}';
_ref5;
module.exports = exports = ion.template(function PrimaryColumn(property) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'PrimaryColumn',
            loc: {
                start: {
                    line: 43,
                    column: 16,
                    fixed: true,
                    source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                },
                end: {
                    line: 43,
                    column: 29,
                    fixed: true,
                    source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                }
            }
        },
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'column',
                            loc: {
                                start: {
                                    line: 44,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                },
                                end: {
                                    line: 44,
                                    column: 14,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'DefaultColumn',
                                loc: {
                                    start: {
                                        line: 44,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                    },
                                    end: {
                                        line: 44,
                                        column: 30,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'Identifier',
                                    name: 'property',
                                    loc: {
                                        start: {
                                            line: 44,
                                            column: 31,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                        },
                                        end: {
                                            line: 44,
                                            column: 39,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                        }
                                    }
                                }],
                            loc: {
                                start: {
                                    line: 44,
                                    column: 17,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                },
                                end: {
                                    line: 44,
                                    column: 40,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'defaultCreateHeaderCell',
                            loc: {
                                start: {
                                    line: 45,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                },
                                end: {
                                    line: 45,
                                    column: 31,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Function',
                                context: true,
                                value: function (_context) {
                                    return function () {
                                        var column = _context.get('column');
                                        return column.createHeaderCell;
                                    };
                                }
                            },
                            arguments: [],
                            loc: {
                                start: {
                                    line: 45,
                                    column: 34,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                },
                                end: {
                                    line: 45,
                                    column: 63,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'Identifier',
                        name: 'column',
                        loc: {
                            start: {
                                line: 46,
                                column: 11,
                                fixed: true,
                                source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                            },
                            end: {
                                line: 46,
                                column: 17,
                                fixed: true,
                                source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                            }
                        }
                    },
                    properties: [
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'defaultWidth',
                                loc: {
                                    start: {
                                        line: 47,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                    },
                                    end: {
                                        line: 47,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Literal',
                                value: 250
                            },
                            kind: 'init',
                            order: '0'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'createHeaderCell',
                                loc: {
                                    start: {
                                        line: 48,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                    },
                                    end: {
                                        line: 48,
                                        column: 24,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_ps) {
                                    return ion.template(function (dataTableModel) {
                                        return ion.createRuntime({
                                            type: 'Template',
                                            id: null,
                                            body: [
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'nested',
                                                                loc: {
                                                                    start: {
                                                                        line: 49,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 49,
                                                                        column: 22,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'dataTableModel',
                                                                        loc: {
                                                                            start: {
                                                                                line: 49,
                                                                                column: 25,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 49,
                                                                                column: 39,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'rowSource',
                                                                        loc: {
                                                                            start: {
                                                                                line: 49,
                                                                                column: 40,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 49,
                                                                                column: 49,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 49,
                                                                            column: 25,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 49,
                                                                            column: 49,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'tree',
                                                                    loc: {
                                                                        start: {
                                                                            line: 49,
                                                                            column: 50,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 49,
                                                                            column: 54,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 49,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 49,
                                                                        column: 54,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'ReturnStatement',
                                                    argument: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'defaultCreateHeaderCell',
                                                                loc: {
                                                                    start: {
                                                                        line: 50,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 50,
                                                                        column: 42,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [{
                                                                    type: 'Identifier',
                                                                    name: 'dataTableModel',
                                                                    loc: {
                                                                        start: {
                                                                            line: 50,
                                                                            column: 43,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 50,
                                                                            column: 57,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                        }
                                                                    }
                                                                }],
                                                            loc: {
                                                                start: {
                                                                    line: 50,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                },
                                                                end: {
                                                                    line: 50,
                                                                    column: 58,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [{
                                                                type: 'IfStatement',
                                                                test: {
                                                                    type: 'Identifier',
                                                                    name: 'nested',
                                                                    loc: {
                                                                        start: {
                                                                            line: 51,
                                                                            column: 19,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 51,
                                                                            column: 25,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                consequent: {
                                                                    type: 'BlockStatement',
                                                                    body: [{
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'style',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 52,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 52,
                                                                                        column: 25,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'ObjectExpression',
                                                                                properties: [{
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'paddingLeft',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 53,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 53,
                                                                                                    column: 35,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: '24px'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                alternate: null,
                                                                order: '0'
                                                            }]
                                                    },
                                                    order: '1'
                                                }
                                            ],
                                            bound: false,
                                            name: {
                                                type: 'Identifier',
                                                name: 'createHeaderCell',
                                                loc: {
                                                    start: {
                                                        line: 48,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                    },
                                                    end: {
                                                        line: 48,
                                                        column: 24,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                    }
                                                }
                                            },
                                            scope: {
                                                type: 'Identifier',
                                                name: '_ps'
                                            }
                                        }, {
                                            this: this,
                                            dataTableModel: dataTableModel,
                                            _ps: _ps,
                                            property: property,
                                            ion: ion,
                                            _ref: _ref,
                                            DefaultColumn: DefaultColumn,
                                            _ref2: _ref2,
                                            _ref3: _ref3,
                                            Schema: Schema,
                                            style: style,
                                            Menu: Menu,
                                            _ref5: _ref5
                                        }, _ps);
                                    });
                                }
                            },
                            kind: 'init',
                            order: '1'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'createBodyCell',
                                loc: {
                                    start: {
                                        line: 54,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                    },
                                    end: {
                                        line: 54,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_ps2) {
                                    return ion.template(function (row) {
                                        return ion.createRuntime({
                                            type: 'Template',
                                            id: null,
                                            body: [
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: '_ref4'
                                                            },
                                                            init: {
                                                                type: 'Identifier',
                                                                name: 'row',
                                                                loc: {
                                                                    start: {
                                                                        line: 55,
                                                                        column: 42,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 55,
                                                                        column: 45,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'record',
                                                                loc: {
                                                                    start: {
                                                                        line: 55,
                                                                        column: 17,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 55,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'MemberExpression',
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: '_ref4'
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'record',
                                                                    loc: {
                                                                        start: {
                                                                            line: 55,
                                                                            column: 17,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 55,
                                                                            column: 23,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                computed: false
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '1'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'dataTableModel',
                                                                loc: {
                                                                    start: {
                                                                        line: 55,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 55,
                                                                        column: 38,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'MemberExpression',
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: '_ref4'
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'dataTableModel',
                                                                    loc: {
                                                                        start: {
                                                                            line: 55,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 55,
                                                                            column: 38,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                computed: false
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '2'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'nested',
                                                                loc: {
                                                                    start: {
                                                                        line: 56,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 56,
                                                                        column: 22,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'dataTableModel',
                                                                        loc: {
                                                                            start: {
                                                                                line: 56,
                                                                                column: 25,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 56,
                                                                                column: 39,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'rowSource',
                                                                        loc: {
                                                                            start: {
                                                                                line: 56,
                                                                                column: 40,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 56,
                                                                                column: 49,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 56,
                                                                            column: 25,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 56,
                                                                            column: 49,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'tree',
                                                                    loc: {
                                                                        start: {
                                                                            line: 56,
                                                                            column: 50,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 56,
                                                                            column: 54,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 56,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 56,
                                                                        column: 54,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '3'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'pathLength',
                                                                loc: {
                                                                    start: {
                                                                        line: 57,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 57,
                                                                        column: 26,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'row',
                                                                        loc: {
                                                                            start: {
                                                                                line: 57,
                                                                                column: 29,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 57,
                                                                                column: 32,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'path',
                                                                        loc: {
                                                                            start: {
                                                                                line: 57,
                                                                                column: 33,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 57,
                                                                                column: 37,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 57,
                                                                            column: 29,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 57,
                                                                            column: 37,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'length',
                                                                    loc: {
                                                                        start: {
                                                                            line: 57,
                                                                            column: 38,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 57,
                                                                            column: 44,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 57,
                                                                        column: 29,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 57,
                                                                        column: 44,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '4'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'root',
                                                                loc: {
                                                                    start: {
                                                                        line: 58,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 58,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'BinaryExpression',
                                                                operator: '===',
                                                                left: {
                                                                    type: 'Identifier',
                                                                    name: 'pathLength',
                                                                    loc: {
                                                                        start: {
                                                                            line: 58,
                                                                            column: 23,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 58,
                                                                            column: 33,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                right: {
                                                                    type: 'Literal',
                                                                    value: 1
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '5'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'hasChildren',
                                                                loc: {
                                                                    start: {
                                                                        line: 59,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 59,
                                                                        column: 27,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'BinaryExpression',
                                                                operator: '>',
                                                                left: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'row',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 59,
                                                                                    column: 30,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 59,
                                                                                    column: 33,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'children',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 59,
                                                                                    column: 34,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 59,
                                                                                    column: 42,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 59,
                                                                                column: 30,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 59,
                                                                                column: 42,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'length',
                                                                        loc: {
                                                                            start: {
                                                                                line: 59,
                                                                                column: 44,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 59,
                                                                                column: 50,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    existential: true,
                                                                    loc: {
                                                                        start: {
                                                                            line: 59,
                                                                            column: 30,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 59,
                                                                            column: 50,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                right: {
                                                                    type: 'Literal',
                                                                    value: 0
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '6'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'cell',
                                                                loc: {
                                                                    start: {
                                                                        line: 61,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 61,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Function',
                                                                    context: false,
                                                                    value: function () {
                                                                        return Span({ class: 'PrimaryColumnCell' });
                                                                    }
                                                                },
                                                                arguments: [],
                                                                loc: {
                                                                    start: {
                                                                        line: 61,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 61,
                                                                        column: 62,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '7'
                                                },
                                                {
                                                    type: 'ReturnStatement',
                                                    argument: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'Identifier',
                                                            name: 'cell',
                                                            loc: {
                                                                start: {
                                                                    line: 62,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                },
                                                                end: {
                                                                    line: 62,
                                                                    column: 23,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'classList',
                                                                    loc: {
                                                                        start: {
                                                                            line: 63,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 63,
                                                                            column: 25,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'ObjectExpression',
                                                                    properties: [
                                                                        {
                                                                            type: 'IfStatement',
                                                                            test: {
                                                                                type: 'BinaryExpression',
                                                                                operator: '&&',
                                                                                left: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'row',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 64,
                                                                                                column: 23,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 64,
                                                                                                column: 26,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'open',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 64,
                                                                                                column: 27,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 64,
                                                                                                column: 31,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 64,
                                                                                            column: 23,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 64,
                                                                                            column: 31,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                right: {
                                                                                    type: 'Identifier',
                                                                                    name: 'hasChildren',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 64,
                                                                                            column: 36,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 64,
                                                                                            column: 47,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                        }
                                                                                    }
                                                                                }
                                                                            },
                                                                            consequent: {
                                                                                type: 'BlockStatement',
                                                                                body: [{
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'Literal',
                                                                                            value: 'open'
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 65,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 65,
                                                                                                column: 30,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            alternate: null,
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'IfStatement',
                                                                            test: {
                                                                                type: 'Identifier',
                                                                                name: 'root',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 66,
                                                                                        column: 23,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 66,
                                                                                        column: 27,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            consequent: {
                                                                                type: 'BlockStatement',
                                                                                body: [{
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'Literal',
                                                                                            value: 'root'
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 67,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 67,
                                                                                                column: 30,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            alternate: null,
                                                                            order: '1'
                                                                        }
                                                                    ]
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'style',
                                                                    loc: {
                                                                        start: {
                                                                            line: 68,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 68,
                                                                            column: 21,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'ObjectExpression',
                                                                    properties: [{
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'paddingLeft',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 69,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 69,
                                                                                        column: 31,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'BinaryExpression',
                                                                                operator: '+',
                                                                                left: {
                                                                                    type: 'BinaryExpression',
                                                                                    operator: '+',
                                                                                    left: {
                                                                                        type: 'Literal',
                                                                                        value: ''
                                                                                    },
                                                                                    right: {
                                                                                        type: 'BinaryExpression',
                                                                                        operator: '*',
                                                                                        left: {
                                                                                            type: 'BinaryExpression',
                                                                                            operator: '-',
                                                                                            left: {
                                                                                                type: 'Identifier',
                                                                                                name: 'pathLength',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 69,
                                                                                                        column: 37,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 69,
                                                                                                        column: 47,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            right: {
                                                                                                type: 'Literal',
                                                                                                value: 1
                                                                                            }
                                                                                        },
                                                                                        right: {
                                                                                            type: 'Literal',
                                                                                            value: 20
                                                                                        }
                                                                                    }
                                                                                },
                                                                                right: {
                                                                                    type: 'Literal',
                                                                                    value: 'px'
                                                                                }
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                kind: 'init',
                                                                order: '1'
                                                            },
                                                            {
                                                                type: 'IfStatement',
                                                                test: {
                                                                    type: 'Identifier',
                                                                    name: 'hasChildren',
                                                                    loc: {
                                                                        start: {
                                                                            line: 70,
                                                                            column: 19,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 70,
                                                                            column: 30,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                consequent: {
                                                                    type: 'BlockStatement',
                                                                    body: [{
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'Function',
                                                                                context: true,
                                                                                value: function (_context2) {
                                                                                    return function keypress(e) {
                                                                                        var row = _context2.get('row');
                                                                                        if (e.key === ' ') {
                                                                                            row.setOpen(!row.open);
                                                                                            e.stopPropagation();
                                                                                        }
                                                                                    };
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 71,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 75,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                alternate: null,
                                                                order: '2'
                                                            },
                                                            {
                                                                type: 'IfStatement',
                                                                test: {
                                                                    type: 'Identifier',
                                                                    name: 'nested',
                                                                    loc: {
                                                                        start: {
                                                                            line: 75,
                                                                            column: 19,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 75,
                                                                            column: 25,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                consequent: {
                                                                    type: 'BlockStatement',
                                                                    body: [{
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'ObjectExpression',
                                                                                objectType: {
                                                                                    type: 'CallExpression',
                                                                                    callee: {
                                                                                        type: 'Identifier',
                                                                                        name: 'IronIcon',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 76,
                                                                                                column: 20,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 76,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    arguments: [],
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 76,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 76,
                                                                                            column: 30,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                properties: [{
                                                                                        type: 'IfStatement',
                                                                                        test: {
                                                                                            type: 'Identifier',
                                                                                            name: 'hasChildren',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 77,
                                                                                                    column: 27,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 77,
                                                                                                    column: 38,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        consequent: {
                                                                                            type: 'BlockStatement',
                                                                                            body: [
                                                                                                {
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'classList',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 78,
                                                                                                                column: 28,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 78,
                                                                                                                column: 37,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'ObjectExpression',
                                                                                                        properties: [{
                                                                                                                type: 'ExpressionStatement',
                                                                                                                expression: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: 'toggle'
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 79,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 79,
                                                                                                                        column: 40,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                                                    }
                                                                                                                },
                                                                                                                order: '0'
                                                                                                            }]
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '0'
                                                                                                },
                                                                                                {
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'icon',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 80,
                                                                                                                column: 28,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 80,
                                                                                                                column: 32,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'Literal',
                                                                                                        value: 'av:play-arrow'
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '1'
                                                                                                },
                                                                                                {
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'title',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 81,
                                                                                                                column: 28,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 81,
                                                                                                                column: 33,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'Literal',
                                                                                                        value: 'Open'
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '2'
                                                                                                },
                                                                                                {
                                                                                                    type: 'ExpressionStatement',
                                                                                                    expression: {
                                                                                                        type: 'Function',
                                                                                                        context: false,
                                                                                                        value: function click(e) {
                                                                                                            e.stopPropagation();
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 82,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 84,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                                        }
                                                                                                    },
                                                                                                    order: '3'
                                                                                                },
                                                                                                {
                                                                                                    type: 'ExpressionStatement',
                                                                                                    expression: {
                                                                                                        type: 'Function',
                                                                                                        context: true,
                                                                                                        value: function (_context3) {
                                                                                                            return function mousedown(e) {
                                                                                                                var row = _context3.get('row');
                                                                                                                row.setOpen(!row.open);
                                                                                                                e.stopPropagation();
                                                                                                                e.preventDefault();
                                                                                                            };
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 84,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 88,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                                        }
                                                                                                    },
                                                                                                    order: '4'
                                                                                                },
                                                                                                {
                                                                                                    type: 'ExpressionStatement',
                                                                                                    expression: {
                                                                                                        type: 'Function',
                                                                                                        context: false,
                                                                                                        value: function mouseup(e) {
                                                                                                            e.stopPropagation();
                                                                                                            e.preventDefault();
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 88,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 91,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                                        }
                                                                                                    },
                                                                                                    order: '5'
                                                                                                }
                                                                                            ]
                                                                                        },
                                                                                        alternate: {
                                                                                            type: 'BlockStatement',
                                                                                            body: [
                                                                                                {
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'classList',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 92,
                                                                                                                column: 28,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 92,
                                                                                                                column: 37,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'ObjectExpression',
                                                                                                        properties: [{
                                                                                                                type: 'ExpressionStatement',
                                                                                                                expression: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: 'bullet'
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 93,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 93,
                                                                                                                        column: 40,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                                                    }
                                                                                                                },
                                                                                                                order: '0'
                                                                                                            }]
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '0'
                                                                                                },
                                                                                                {
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'icon',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 94,
                                                                                                                column: 28,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 94,
                                                                                                                column: 32,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'ConditionalExpression',
                                                                                                        test: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'root',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 94,
                                                                                                                    column: 34,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 94,
                                                                                                                    column: 38,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        consequent: {
                                                                                                            type: 'Literal',
                                                                                                            value: 'av:stop'
                                                                                                        },
                                                                                                        alternate: {
                                                                                                            type: 'Literal',
                                                                                                            value: 'image:lens'
                                                                                                        }
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '1'
                                                                                                }
                                                                                            ]
                                                                                        },
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 76,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 95,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                alternate: null,
                                                                order: '3'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'ObjectExpression',
                                                                    objectType: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'Identifier',
                                                                            name: 'Span',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 95,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 95,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [],
                                                                        loc: {
                                                                            start: {
                                                                                line: 95,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 95,
                                                                                column: 22,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    properties: [
                                                                        {
                                                                            type: 'IfStatement',
                                                                            test: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'Identifier',
                                                                                    name: 'record',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 96,
                                                                                            column: 23,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 96,
                                                                                            column: 29,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'paneConfig',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 96,
                                                                                            column: 30,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 96,
                                                                                            column: 40,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 96,
                                                                                        column: 23,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 96,
                                                                                        column: 40,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            consequent: {
                                                                                type: 'BlockStatement',
                                                                                body: [
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'classList',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 97,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 97,
                                                                                                    column: 33,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'ObjectExpression',
                                                                                            properties: [{
                                                                                                    type: 'ExpressionStatement',
                                                                                                    expression: {
                                                                                                        type: 'Literal',
                                                                                                        value: 'link'
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 98,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 98,
                                                                                                            column: 34,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                                        }
                                                                                                    },
                                                                                                    order: '0'
                                                                                                }]
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'Function',
                                                                                            context: true,
                                                                                            value: function (_context4) {
                                                                                                return function contextmenu(e) {
                                                                                                    var record = _context4.get('record'), Menu = _context4.get('Menu');
                                                                                                    e.stopPropagation();
                                                                                                    e.preventDefault();
                                                                                                    var _ref6 = [];
                                                                                                    {
                                                                                                        _ref6.push({
                                                                                                            name: 'Open in New Panel',
                                                                                                            autoclose: true,
                                                                                                            action: function () {
                                                                                                                global.model.open(record.paneConfig, {
                                                                                                                    target: 'pin',
                                                                                                                    replace: false
                                                                                                                });
                                                                                                            }
                                                                                                        });
                                                                                                        _ref6.push({
                                                                                                            name: 'Open in New Browser Tab',
                                                                                                            link: record.paneConfig,
                                                                                                            target: '_blank',
                                                                                                            autoclose: true
                                                                                                        });
                                                                                                        if (document.location.hostname === 'localhost') {
                                                                                                            if (model.openInDatastore != null) {
                                                                                                                _ref6.push({
                                                                                                                    name: 'Open in Datastore',
                                                                                                                    action: function () {
                                                                                                                        model.openInDatastore(record.key);
                                                                                                                    }
                                                                                                                });
                                                                                                            }
                                                                                                            _ref6.push({
                                                                                                                name: 'Show in Console',
                                                                                                                action: function () {
                                                                                                                    console.log(record);
                                                                                                                }
                                                                                                            });
                                                                                                        }
                                                                                                    }
                                                                                                    var close = Menu.show(e, _ref6);
                                                                                                };
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 99,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 122,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '1'
                                                                                    },
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'Function',
                                                                                            context: true,
                                                                                            value: function (_context5) {
                                                                                                return function click(e) {
                                                                                                    var dataTableModel = _context5.get('dataTableModel'), record = _context5.get('record'), column = _context5.get('column');
                                                                                                    var sourceKey = dataTableModel.rowSource.key != null ? dataTableModel.rowSource.key.toString() : void 0;
                                                                                                    var paneConfig = record.paneConfig;
                                                                                                    global.model.open(paneConfig, {
                                                                                                        target: column.target,
                                                                                                        replace: true
                                                                                                    });
                                                                                                };
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 122,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 128,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '2'
                                                                                    }
                                                                                ]
                                                                            },
                                                                            alternate: null,
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'CallExpression',
                                                                                callee: {
                                                                                    type: 'Function',
                                                                                    context: true,
                                                                                    value: function (_context6) {
                                                                                        return function (record) {
                                                                                            var Schema = _context6.get('Schema'), property = _context6.get('property');
                                                                                            return Schema.get(record, property);
                                                                                        };
                                                                                    }
                                                                                },
                                                                                arguments: [{
                                                                                        type: 'Identifier',
                                                                                        name: 'record',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 128,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 128,
                                                                                                column: 30,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                            }
                                                                                        }
                                                                                    }],
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 128,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 128,
                                                                                        column: 63,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 128,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 128,
                                                                                    column: 63,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                                }
                                                                            },
                                                                            order: '1'
                                                                        }
                                                                    ]
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 95,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 129,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                    }
                                                                },
                                                                order: '4'
                                                            }
                                                        ]
                                                    },
                                                    order: '8'
                                                }
                                            ],
                                            bound: false,
                                            name: {
                                                type: 'Identifier',
                                                name: 'createBodyCell',
                                                loc: {
                                                    start: {
                                                        line: 54,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                    },
                                                    end: {
                                                        line: 54,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                    }
                                                }
                                            },
                                            scope: {
                                                type: 'Identifier',
                                                name: '_ps2'
                                            }
                                        }, {
                                            this: this,
                                            row: row,
                                            _ps2: _ps2,
                                            property: property,
                                            ion: ion,
                                            _ref: _ref,
                                            DefaultColumn: DefaultColumn,
                                            _ref2: _ref2,
                                            _ref3: _ref3,
                                            Schema: Schema,
                                            style: style,
                                            Menu: Menu,
                                            _ref5: _ref5
                                        }, _ps2);
                                    });
                                }
                            },
                            kind: 'init',
                            order: '2'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'createFooterCell',
                                loc: {
                                    start: {
                                        line: 129,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                    },
                                    end: {
                                        line: 129,
                                        column: 24,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_ps3) {
                                    return ion.template(function (dataTableModel) {
                                        return ion.createRuntime({
                                            type: 'Template',
                                            id: null,
                                            body: [{
                                                    type: 'ReturnStatement',
                                                    argument: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'Identifier',
                                                            name: 'Span',
                                                            loc: {
                                                                start: {
                                                                    line: 130,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                },
                                                                end: {
                                                                    line: 130,
                                                                    column: 23,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [],
                                                        loc: {
                                                            start: {
                                                                line: 130,
                                                                column: 19,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                            },
                                                            end: {
                                                                line: 130,
                                                                column: 25,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                            }
                                                        }
                                                    },
                                                    order: '0'
                                                }],
                                            bound: false,
                                            name: {
                                                type: 'Identifier',
                                                name: 'createFooterCell',
                                                loc: {
                                                    start: {
                                                        line: 129,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                    },
                                                    end: {
                                                        line: 129,
                                                        column: 24,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/PrimaryColumn.ion'
                                                    }
                                                }
                                            },
                                            scope: {
                                                type: 'Identifier',
                                                name: '_ps3'
                                            }
                                        }, {
                                            this: this,
                                            dataTableModel: dataTableModel,
                                            _ps3: _ps3,
                                            property: property,
                                            ion: ion,
                                            _ref: _ref,
                                            DefaultColumn: DefaultColumn,
                                            _ref2: _ref2,
                                            _ref3: _ref3,
                                            Schema: Schema,
                                            style: style,
                                            Menu: Menu,
                                            _ref5: _ref5
                                        }, _ps3);
                                    });
                                }
                            },
                            kind: 'init',
                            order: '3'
                        }
                    ]
                },
                order: '2'
            }
        ],
        bound: false
    }, {
        this: this,
        ion: ion,
        property: property,
        _ref: _ref,
        DefaultColumn: DefaultColumn,
        _ref2: _ref2,
        _ref3: _ref3,
        Schema: Schema,
        style: style,
        Menu: Menu,
        _ref5: _ref5
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/DataTable2/PrimaryColumn',_glass_html_material_DataTable2_PrimaryColumn_);
    else
      _glass_html_material_DataTable2_PrimaryColumn_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_DataTable2_PrimaryColumn_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_DataTable2_PropertyEditor_ = function(module,exports,require){'use strict';
var ion = require('ion'), _ref, _ref2, _ref3, _ref4, _ref5;
_ref = require('../../../data');
var Schema = _ref.Schema;
_ref2 = require('../../functions');
var getOffsetRelative = _ref2.getOffsetRelative;
_ref3 = require('../');
var Card = _ref3.Card;
var Menu = _ref3.NewMenu;
var DateTimeField = _ref3.DateTimeField;
_ref4 = require('../../forms');
var EditForm = _ref4.EditForm;
var CancelButton = _ref4.CancelButton;
var SubmitButton = _ref4.SubmitButton;
_ref5 = require('../../');
var style = _ref5.style;
module.exports = exports = ion.template(function (_ref6) {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'object',
                            loc: {
                                start: {
                                    line: 9,
                                    column: 18,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                },
                                end: {
                                    line: 9,
                                    column: 24,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref6'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'object',
                                loc: {
                                    start: {
                                        line: 9,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                    },
                                    end: {
                                        line: 9,
                                        column: 24,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'property',
                            loc: {
                                start: {
                                    line: 9,
                                    column: 26,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                },
                                end: {
                                    line: 9,
                                    column: 34,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref6'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'property',
                                loc: {
                                    start: {
                                        line: 9,
                                        column: 26,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                    },
                                    end: {
                                        line: 9,
                                        column: 34,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'value',
                            loc: {
                                start: {
                                    line: 9,
                                    column: 36,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                },
                                end: {
                                    line: 9,
                                    column: 41,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref6'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'value',
                                loc: {
                                    start: {
                                        line: 9,
                                        column: 36,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                    },
                                    end: {
                                        line: 9,
                                        column: 41,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'IfStatement',
                test: {
                    type: 'MemberExpression',
                    computed: false,
                    object: {
                        type: 'Identifier',
                        name: 'property',
                        loc: {
                            start: {
                                line: 10,
                                column: 7,
                                fixed: true,
                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                            },
                            end: {
                                line: 10,
                                column: 15,
                                fixed: true,
                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                            }
                        }
                    },
                    property: {
                        type: 'Identifier',
                        name: 'values',
                        loc: {
                            start: {
                                line: 10,
                                column: 16,
                                fixed: true,
                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                            },
                            end: {
                                line: 10,
                                column: 22,
                                fixed: true,
                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                            }
                        }
                    },
                    loc: {
                        start: {
                            line: 10,
                            column: 7,
                            fixed: true,
                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                        },
                        end: {
                            line: 10,
                            column: 22,
                            fixed: true,
                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                        }
                    }
                },
                consequent: {
                    type: 'BlockStatement',
                    body: [
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'state',
                                        loc: {
                                            start: {
                                                line: 11,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                            },
                                            end: {
                                                line: 11,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'value',
                                                    loc: {
                                                        start: {
                                                            line: 11,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                        },
                                                        end: {
                                                            line: 11,
                                                            column: 26,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Identifier',
                                                    name: 'value',
                                                    loc: {
                                                        start: {
                                                            line: 11,
                                                            column: 27,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                        },
                                                        end: {
                                                            line: 11,
                                                            column: 32,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                        }
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    }
                                }],
                            kind: 'let',
                            order: '0'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'card',
                                        loc: {
                                            start: {
                                                line: 12,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                            },
                                            end: {
                                                line: 12,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'Identifier',
                                            name: 'Card',
                                            loc: {
                                                start: {
                                                    line: 12,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                },
                                                end: {
                                                    line: 12,
                                                    column: 23,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                }
                                            }
                                        },
                                        arguments: [{
                                                type: 'ObjectExpression',
                                                properties: [{
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'tabindex',
                                                            loc: {
                                                                start: {
                                                                    line: 12,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                },
                                                                end: {
                                                                    line: 12,
                                                                    column: 33,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'UnaryExpression',
                                                            operator: '-',
                                                            argument: {
                                                                type: 'Literal',
                                                                value: 1
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    }]
                                            }],
                                        loc: {
                                            start: {
                                                line: 12,
                                                column: 19,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                            },
                                            end: {
                                                line: 12,
                                                column: 38,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '1'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'menu',
                                        loc: {
                                            start: {
                                                line: 13,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                            },
                                            end: {
                                                line: 13,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'Identifier',
                                            name: 'Menu',
                                            loc: {
                                                start: {
                                                    line: 13,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                },
                                                end: {
                                                    line: 13,
                                                    column: 23,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                }
                                            }
                                        },
                                        arguments: [{
                                                type: 'ObjectExpression',
                                                properties: [
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'initialValue',
                                                            loc: {
                                                                start: {
                                                                    line: 14,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                },
                                                                end: {
                                                                    line: 14,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Identifier',
                                                            name: 'value',
                                                            loc: {
                                                                start: {
                                                                    line: 14,
                                                                    column: 26,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                },
                                                                end: {
                                                                    line: 14,
                                                                    column: 31,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                }
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'items',
                                                            loc: {
                                                                start: {
                                                                    line: 15,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                },
                                                                end: {
                                                                    line: 15,
                                                                    column: 17,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'ObjectExpression',
                                                            objectType: {
                                                                type: 'ArrayExpression',
                                                                elements: []
                                                            },
                                                            properties: [{
                                                                    type: 'ForOfStatement',
                                                                    left: {
                                                                        type: 'VariableDeclaration',
                                                                        declarations: [{
                                                                                type: 'VariableDeclarator',
                                                                                id: {
                                                                                    type: 'Identifier',
                                                                                    name: '_ref7'
                                                                                },
                                                                                init: null
                                                                            }],
                                                                        kind: 'let'
                                                                    },
                                                                    right: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'property',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 16,
                                                                                    column: 33,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 16,
                                                                                    column: 41,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'values',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 16,
                                                                                    column: 42,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 16,
                                                                                    column: 48,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 16,
                                                                                column: 33,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                            },
                                                                            end: {
                                                                                line: 16,
                                                                                column: 48,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    body: {
                                                                        type: 'BlockStatement',
                                                                        body: [
                                                                            {
                                                                                type: 'VariableDeclaration',
                                                                                declarations: [{
                                                                                        type: 'VariableDeclarator',
                                                                                        id: {
                                                                                            type: 'Identifier',
                                                                                            name: '_ref8'
                                                                                        },
                                                                                        init: {
                                                                                            type: 'Identifier',
                                                                                            name: '_ref7'
                                                                                        }
                                                                                    }],
                                                                                order: '0'
                                                                            },
                                                                            {
                                                                                type: 'VariableDeclaration',
                                                                                declarations: [{
                                                                                        type: 'VariableDeclarator',
                                                                                        id: {
                                                                                            type: 'Identifier',
                                                                                            name: 'id',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 16,
                                                                                                    column: 21,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 16,
                                                                                                    column: 23,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        init: {
                                                                                            type: 'MemberExpression',
                                                                                            object: {
                                                                                                type: 'Identifier',
                                                                                                name: '_ref8'
                                                                                            },
                                                                                            property: {
                                                                                                type: 'Identifier',
                                                                                                name: 'id',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 16,
                                                                                                        column: 21,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 16,
                                                                                                        column: 23,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            computed: false
                                                                                        }
                                                                                    }],
                                                                                kind: 'let',
                                                                                order: '1'
                                                                            },
                                                                            {
                                                                                type: 'VariableDeclaration',
                                                                                declarations: [{
                                                                                        type: 'VariableDeclarator',
                                                                                        id: {
                                                                                            type: 'Identifier',
                                                                                            name: 'name',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 16,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 16,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        init: {
                                                                                            type: 'MemberExpression',
                                                                                            object: {
                                                                                                type: 'Identifier',
                                                                                                name: '_ref8'
                                                                                            },
                                                                                            property: {
                                                                                                type: 'Identifier',
                                                                                                name: 'name',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 16,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 16,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            computed: false
                                                                                        }
                                                                                    }],
                                                                                kind: 'let',
                                                                                order: '2'
                                                                            },
                                                                            {
                                                                                type: 'ExpressionStatement',
                                                                                expression: {
                                                                                    type: 'ObjectExpression',
                                                                                    objectType: {
                                                                                        type: 'ObjectExpression',
                                                                                        properties: [{
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'name',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 17,
                                                                                                            column: 21,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 17,
                                                                                                            column: 25,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'name',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 17,
                                                                                                            column: 21,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 17,
                                                                                                            column: 25,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '0'
                                                                                            }]
                                                                                    },
                                                                                    properties: [{
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'action',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 18,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 18,
                                                                                                        column: 30,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'Function',
                                                                                                context: true,
                                                                                                value: function (_context) {
                                                                                                    return function () {
                                                                                                        var card = _context.get('card'), id = _context.get('id');
                                                                                                        card.value = id;
                                                                                                        card.dispatchEvent(new CustomEvent('commit'));
                                                                                                    };
                                                                                                }
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '0'
                                                                                        }]
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 17,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 21,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                                    }
                                                                                },
                                                                                order: '3'
                                                                            }
                                                                        ]
                                                                    },
                                                                    remove: null,
                                                                    order: '0'
                                                                }]
                                                        },
                                                        kind: 'init',
                                                        order: '1'
                                                    }
                                                ]
                                            }],
                                        loc: {
                                            start: {
                                                line: 13,
                                                column: 19,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                            },
                                            end: {
                                                line: 21,
                                                column: 9,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '2'
                        },
                        {
                            type: 'ReturnStatement',
                            argument: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'MemberExpression',
                                    object: {
                                        type: 'Identifier',
                                        name: 'Object'
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'defineProperties'
                                    }
                                },
                                arguments: [
                                    {
                                        type: 'ObjectExpression',
                                        objectType: {
                                            type: 'Identifier',
                                            name: 'card',
                                            loc: {
                                                start: {
                                                    line: 22,
                                                    column: 15,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                },
                                                end: {
                                                    line: 22,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                }
                                            }
                                        },
                                        properties: [
                                            {
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context2) {
                                                        return function focus() {
                                                            var menu = _context2.get('menu');
                                                            menu.focus();
                                                        };
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 23,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                    },
                                                    end: {
                                                        line: 25,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                    }
                                                },
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'style',
                                                    loc: {
                                                        start: {
                                                            line: 25,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                        },
                                                        end: {
                                                            line: 25,
                                                            column: 17,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'ObjectExpression',
                                                    properties: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'outline',
                                                                loc: {
                                                                    start: {
                                                                        line: 26,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                    },
                                                                    end: {
                                                                        line: 26,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Literal',
                                                                value: 'none'
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                },
                                                kind: 'init',
                                                order: '1'
                                            },
                                            {
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'Identifier',
                                                    name: 'menu',
                                                    loc: {
                                                        start: {
                                                            line: 30,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                        },
                                                        end: {
                                                            line: 30,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 30,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                    },
                                                    end: {
                                                        line: 30,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                    }
                                                },
                                                order: '2'
                                            }
                                        ]
                                    },
                                    {
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'value',
                                                    loc: {
                                                        start: {
                                                            line: 27,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                        },
                                                        end: {
                                                            line: 27,
                                                            column: 26,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'ObjectExpression',
                                                    properties: [
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'get',
                                                                loc: {
                                                                    start: {
                                                                        line: 28,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                    },
                                                                    end: {
                                                                        line: 28,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Function',
                                                                context: true,
                                                                value: function (_context3) {
                                                                    return function () {
                                                                        var state = _context3.get('state');
                                                                        return state.value;
                                                                    };
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        },
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'set',
                                                                loc: {
                                                                    start: {
                                                                        line: 29,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                    },
                                                                    end: {
                                                                        line: 29,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Function',
                                                                context: true,
                                                                value: function (_context4) {
                                                                    return function (value) {
                                                                        var state = _context4.get('state');
                                                                        return state.value = value;
                                                                    };
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '1'
                                                        }
                                                    ]
                                                },
                                                kind: 'init',
                                                define: false,
                                                order: '0'
                                            }]
                                    }
                                ]
                            },
                            order: '3'
                        }
                    ]
                },
                alternate: {
                    type: 'BlockStatement',
                    body: [
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'properties',
                                        loc: {
                                            start: {
                                                line: 32,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                            },
                                            end: {
                                                line: 32,
                                                column: 22,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'ConditionalExpression',
                                        test: {
                                            type: 'BinaryExpression',
                                            operator: '!=',
                                            left: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'property',
                                                            loc: {
                                                                start: {
                                                                    line: 32,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                },
                                                                end: {
                                                                    line: 32,
                                                                    column: 33,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'getEditProperties',
                                                            loc: {
                                                                start: {
                                                                    line: 32,
                                                                    column: 34,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                },
                                                                end: {
                                                                    line: 32,
                                                                    column: 51,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 32,
                                                                column: 25,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                            },
                                                            end: {
                                                                line: 32,
                                                                column: 51,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'call',
                                                        loc: {
                                                            start: {
                                                                line: 32,
                                                                column: 53,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                            },
                                                            end: {
                                                                line: 32,
                                                                column: 57,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                            }
                                                        }
                                                    },
                                                    existential: true,
                                                    loc: {
                                                        start: {
                                                            line: 32,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                        },
                                                        end: {
                                                            line: 32,
                                                            column: 57,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [{
                                                        type: 'Identifier',
                                                        name: 'object',
                                                        loc: {
                                                            start: {
                                                                line: 32,
                                                                column: 59,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                            },
                                                            end: {
                                                                line: 32,
                                                                column: 65,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                            }
                                                        }
                                                    }],
                                                existential: true,
                                                loc: {
                                                    start: {
                                                        line: 32,
                                                        column: 25,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                    },
                                                    end: {
                                                        line: 32,
                                                        column: 66,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                    }
                                                }
                                            },
                                            right: {
                                                type: 'Literal',
                                                value: null
                                            }
                                        },
                                        consequent: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'property',
                                                        loc: {
                                                            start: {
                                                                line: 32,
                                                                column: 25,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                            },
                                                            end: {
                                                                line: 32,
                                                                column: 33,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'getEditProperties',
                                                        loc: {
                                                            start: {
                                                                line: 32,
                                                                column: 34,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                            },
                                                            end: {
                                                                line: 32,
                                                                column: 51,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 32,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                        },
                                                        end: {
                                                            line: 32,
                                                            column: 51,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'call',
                                                    loc: {
                                                        start: {
                                                            line: 32,
                                                            column: 53,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                        },
                                                        end: {
                                                            line: 32,
                                                            column: 57,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                        }
                                                    }
                                                },
                                                existential: true,
                                                loc: {
                                                    start: {
                                                        line: 32,
                                                        column: 25,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                    },
                                                    end: {
                                                        line: 32,
                                                        column: 57,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                    }
                                                }
                                            },
                                            arguments: [{
                                                    type: 'Identifier',
                                                    name: 'object',
                                                    loc: {
                                                        start: {
                                                            line: 32,
                                                            column: 59,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                        },
                                                        end: {
                                                            line: 32,
                                                            column: 65,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                        }
                                                    }
                                                }],
                                            existential: true,
                                            loc: {
                                                start: {
                                                    line: 32,
                                                    column: 25,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                },
                                                end: {
                                                    line: 32,
                                                    column: 66,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                }
                                            }
                                        },
                                        alternate: {
                                            type: 'ArrayExpression',
                                            elements: [{
                                                    type: 'Identifier',
                                                    name: 'property',
                                                    loc: {
                                                        start: {
                                                            line: 32,
                                                            column: 70,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                        },
                                                        end: {
                                                            line: 32,
                                                            column: 78,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                        }
                                                    }
                                                }]
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '0'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'values',
                                        loc: {
                                            start: {
                                                line: 33,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                            },
                                            end: {
                                                line: 33,
                                                column: 18,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'ConditionalExpression',
                                        test: {
                                            type: 'BinaryExpression',
                                            operator: '!=',
                                            left: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'property',
                                                            loc: {
                                                                start: {
                                                                    line: 33,
                                                                    column: 21,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                },
                                                                end: {
                                                                    line: 33,
                                                                    column: 29,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'getEditValues',
                                                            loc: {
                                                                start: {
                                                                    line: 33,
                                                                    column: 30,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                },
                                                                end: {
                                                                    line: 33,
                                                                    column: 43,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 33,
                                                                column: 21,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                            },
                                                            end: {
                                                                line: 33,
                                                                column: 43,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'call',
                                                        loc: {
                                                            start: {
                                                                line: 33,
                                                                column: 45,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                            },
                                                            end: {
                                                                line: 33,
                                                                column: 49,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                            }
                                                        }
                                                    },
                                                    existential: true,
                                                    loc: {
                                                        start: {
                                                            line: 33,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                        },
                                                        end: {
                                                            line: 33,
                                                            column: 49,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [
                                                    {
                                                        type: 'Identifier',
                                                        name: 'object',
                                                        loc: {
                                                            start: {
                                                                line: 33,
                                                                column: 51,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                            },
                                                            end: {
                                                                line: 33,
                                                                column: 57,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                            }
                                                        }
                                                    },
                                                    {
                                                        type: 'Identifier',
                                                        name: 'value',
                                                        loc: {
                                                            start: {
                                                                line: 33,
                                                                column: 59,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                            },
                                                            end: {
                                                                line: 33,
                                                                column: 64,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                            }
                                                        }
                                                    }
                                                ],
                                                existential: true,
                                                loc: {
                                                    start: {
                                                        line: 33,
                                                        column: 21,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                    },
                                                    end: {
                                                        line: 33,
                                                        column: 65,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                    }
                                                }
                                            },
                                            right: {
                                                type: 'Literal',
                                                value: null
                                            }
                                        },
                                        consequent: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'property',
                                                        loc: {
                                                            start: {
                                                                line: 33,
                                                                column: 21,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                            },
                                                            end: {
                                                                line: 33,
                                                                column: 29,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'getEditValues',
                                                        loc: {
                                                            start: {
                                                                line: 33,
                                                                column: 30,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                            },
                                                            end: {
                                                                line: 33,
                                                                column: 43,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 33,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                        },
                                                        end: {
                                                            line: 33,
                                                            column: 43,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'call',
                                                    loc: {
                                                        start: {
                                                            line: 33,
                                                            column: 45,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                        },
                                                        end: {
                                                            line: 33,
                                                            column: 49,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                        }
                                                    }
                                                },
                                                existential: true,
                                                loc: {
                                                    start: {
                                                        line: 33,
                                                        column: 21,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                    },
                                                    end: {
                                                        line: 33,
                                                        column: 49,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                    }
                                                }
                                            },
                                            arguments: [
                                                {
                                                    type: 'Identifier',
                                                    name: 'object',
                                                    loc: {
                                                        start: {
                                                            line: 33,
                                                            column: 51,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                        },
                                                        end: {
                                                            line: 33,
                                                            column: 57,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                        }
                                                    }
                                                },
                                                {
                                                    type: 'Identifier',
                                                    name: 'value',
                                                    loc: {
                                                        start: {
                                                            line: 33,
                                                            column: 59,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                        },
                                                        end: {
                                                            line: 33,
                                                            column: 64,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                        }
                                                    }
                                                }
                                            ],
                                            existential: true,
                                            loc: {
                                                start: {
                                                    line: 33,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                },
                                                end: {
                                                    line: 33,
                                                    column: 65,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                }
                                            }
                                        },
                                        alternate: {
                                            type: 'ArrayExpression',
                                            elements: [{
                                                    type: 'Identifier',
                                                    name: 'value',
                                                    loc: {
                                                        start: {
                                                            line: 33,
                                                            column: 69,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                        },
                                                        end: {
                                                            line: 33,
                                                            column: 74,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                        }
                                                    }
                                                }]
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '1'
                        },
                        {
                            type: 'ReturnStatement',
                            argument: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'Identifier',
                                        name: 'EditForm',
                                        loc: {
                                            start: {
                                                line: 34,
                                                column: 15,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                            },
                                            end: {
                                                line: 34,
                                                column: 23,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                            }
                                        }
                                    },
                                    arguments: [{
                                            type: 'ObjectExpression',
                                            objectType: {
                                                type: 'ObjectExpression',
                                                properties: []
                                            },
                                            properties: [
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'object',
                                                        loc: {
                                                            start: {
                                                                line: 36,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                            },
                                                            end: {
                                                                line: 36,
                                                                column: 22,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Identifier',
                                                        name: 'object',
                                                        loc: {
                                                            start: {
                                                                line: 36,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                            },
                                                            end: {
                                                                line: 36,
                                                                column: 30,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                            }
                                                        }
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'properties',
                                                        loc: {
                                                            start: {
                                                                line: 37,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                            },
                                                            end: {
                                                                line: 37,
                                                                column: 26,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Identifier',
                                                        name: 'properties',
                                                        loc: {
                                                            start: {
                                                                line: 37,
                                                                column: 28,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                            },
                                                            end: {
                                                                line: 37,
                                                                column: 38,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                            }
                                                        }
                                                    },
                                                    kind: 'init',
                                                    order: '1'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'values',
                                                        loc: {
                                                            start: {
                                                                line: 38,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                            },
                                                            end: {
                                                                line: 38,
                                                                column: 22,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'ObjectExpression',
                                                        properties: [{
                                                                type: 'ForOfStatement',
                                                                left: {
                                                                    type: 'VariableDeclaration',
                                                                    declarations: [
                                                                        {
                                                                            type: 'VariableDeclarator',
                                                                            id: {
                                                                                type: 'Identifier',
                                                                                name: 'prop',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 39,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 39,
                                                                                        column: 28,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            init: null
                                                                        },
                                                                        {
                                                                            type: 'VariableDeclarator',
                                                                            id: {
                                                                                type: 'Identifier',
                                                                                name: 'index',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 39,
                                                                                        column: 30,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 39,
                                                                                        column: 35,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            init: null
                                                                        }
                                                                    ],
                                                                    kind: 'let'
                                                                },
                                                                right: {
                                                                    type: 'Identifier',
                                                                    name: 'properties',
                                                                    loc: {
                                                                        start: {
                                                                            line: 39,
                                                                            column: 39,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                        },
                                                                        end: {
                                                                            line: 39,
                                                                            column: 49,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                        }
                                                                    }
                                                                },
                                                                body: {
                                                                    type: 'BlockStatement',
                                                                    body: [
                                                                        {
                                                                            type: 'VariableDeclaration',
                                                                            declarations: [{
                                                                                    type: 'VariableDeclarator',
                                                                                    id: {
                                                                                        type: 'Identifier',
                                                                                        name: 'val',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 40,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 40,
                                                                                                column: 31,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    init: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: true,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'values',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 40,
                                                                                                    column: 34,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 40,
                                                                                                    column: 40,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'index',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 40,
                                                                                                    column: 41,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 40,
                                                                                                    column: 46,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 40,
                                                                                                column: 34,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 40,
                                                                                                column: 47,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                }],
                                                                            kind: 'let',
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'Identifier',
                                                                                    name: 'prop',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 41,
                                                                                            column: 25,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 41,
                                                                                            column: 29,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'name',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 41,
                                                                                            column: 30,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 41,
                                                                                            column: 34,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 41,
                                                                                        column: 25,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 41,
                                                                                        column: 34,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Identifier',
                                                                                name: 'val',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 41,
                                                                                        column: 37,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 41,
                                                                                        column: 40,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            kind: 'init',
                                                                            computed: true,
                                                                            order: '1'
                                                                        }
                                                                    ]
                                                                },
                                                                remove: null,
                                                                order: '0'
                                                            }]
                                                    },
                                                    kind: 'init',
                                                    order: '2'
                                                }
                                            ]
                                        }],
                                    loc: {
                                        start: {
                                            line: 34,
                                            column: 15,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                        },
                                        end: {
                                            line: 42,
                                            column: 9,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                        }
                                    }
                                },
                                properties: [
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'style',
                                            loc: {
                                                start: {
                                                    line: 43,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                },
                                                end: {
                                                    line: 43,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'ObjectExpression',
                                            properties: [{
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'background',
                                                        loc: {
                                                            start: {
                                                                line: 44,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                            },
                                                            end: {
                                                                line: 44,
                                                                column: 26,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: '#EFEFEF'
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                }]
                                        },
                                        kind: 'init',
                                        order: '0'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'classList',
                                            loc: {
                                                start: {
                                                    line: 45,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                },
                                                end: {
                                                    line: 45,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'ObjectExpression',
                                            properties: [{
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'Literal',
                                                        value: 'z3'
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 46,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                        },
                                                        end: {
                                                            line: 46,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        kind: 'init',
                                        order: '1'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'ObjectExpression',
                                            objectType: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'Footer',
                                                    loc: {
                                                        start: {
                                                            line: 47,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                        },
                                                        end: {
                                                            line: 47,
                                                            column: 18,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [],
                                                loc: {
                                                    start: {
                                                        line: 47,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                    },
                                                    end: {
                                                        line: 47,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                    }
                                                }
                                            },
                                            properties: [
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'CancelButton',
                                                                loc: {
                                                                    start: {
                                                                        line: 48,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                    },
                                                                    end: {
                                                                        line: 48,
                                                                        column: 28,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [],
                                                            loc: {
                                                                start: {
                                                                    line: 48,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                },
                                                                end: {
                                                                    line: 48,
                                                                    column: 30,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'raised',
                                                                    loc: {
                                                                        start: {
                                                                            line: 49,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                        },
                                                                        end: {
                                                                            line: 49,
                                                                            column: 26,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: false
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'Literal',
                                                                    value: 'Cancel'
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 50,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                    },
                                                                    end: {
                                                                        line: 50,
                                                                        column: 28,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                    }
                                                                },
                                                                order: '1'
                                                            }
                                                        ]
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 48,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                        },
                                                        end: {
                                                            line: 51,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                },
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'SubmitButton',
                                                                loc: {
                                                                    start: {
                                                                        line: 51,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                    },
                                                                    end: {
                                                                        line: 51,
                                                                        column: 28,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [],
                                                            loc: {
                                                                start: {
                                                                    line: 51,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                },
                                                                end: {
                                                                    line: 51,
                                                                    column: 30,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [{
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'Literal',
                                                                    value: 'Submit'
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 52,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                    },
                                                                    end: {
                                                                        line: 52,
                                                                        column: 28,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 51,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                        },
                                                        end: {
                                                            line: 54,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                                        }
                                                    },
                                                    order: '1'
                                                }
                                            ]
                                        },
                                        loc: {
                                            start: {
                                                line: 47,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                            },
                                            end: {
                                                line: 54,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/PropertyEditor.ion'
                                            }
                                        },
                                        order: '2'
                                    }
                                ]
                            },
                            order: '2'
                        }
                    ]
                },
                order: '3'
            }
        ],
        bound: false
    }, {
        this: this,
        _ref6: _ref6,
        ion: ion,
        _ref: _ref,
        _ref2: _ref2,
        _ref3: _ref3,
        _ref4: _ref4,
        _ref5: _ref5,
        Schema: Schema,
        getOffsetRelative: getOffsetRelative,
        Card: Card,
        Menu: Menu,
        DateTimeField: DateTimeField,
        EditForm: EditForm,
        CancelButton: CancelButton,
        SubmitButton: SubmitButton,
        style: style
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/DataTable2/PropertyEditor',_glass_html_material_DataTable2_PropertyEditor_);
    else
      _glass_html_material_DataTable2_PropertyEditor_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_DataTable2_PropertyEditor_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_DataTable2_RelationColumn_ = function(module,exports,require){'use strict';
var ion = require('ion'), _ref, DefaultColumn = require('./DefaultColumn'), _ref2, _ref3, _ref4;
_ref = require('../../../data');
var Schema = _ref.Schema;
_ref2 = require('../../../convert');
var jsonValueToDisplayValue = _ref2.jsonValueToDisplayValue;
_ref3 = require('../');
var Chip = _ref3.Chip;
var RecordChip = _ref3.RecordChip;
_ref4 = require('../../');
var style = _ref4.style;
var _ref6 = style.sheets;
_ref6[module.id] = '.RelationColumn:focus:not(.empty) {\n    display: flex;\n    flex-direction: column !important;\n    align-items: stretch !important;\n}\n.RelationColumn.hide * {\n    display: none !important;\n}\n.RelationColumn .Chip > .container {\n}\n.RelationColumn:focus .Chip > .container {\n    display: initial;\n}';
_ref6;
module.exports = exports = ion.template(function RelationColumn(property) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'RelationColumn',
            loc: {
                start: {
                    line: 26,
                    column: 16,
                    fixed: true,
                    source: 'glass/html/material/DataTable2/RelationColumn.ion'
                },
                end: {
                    line: 26,
                    column: 30,
                    fixed: true,
                    source: 'glass/html/material/DataTable2/RelationColumn.ion'
                }
            }
        },
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'defaultSource',
                            loc: {
                                start: {
                                    line: 27,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                },
                                end: {
                                    line: 27,
                                    column: 21,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Function',
                                context: false,
                                value: function () {
                                    return global.model.server;
                                }
                            },
                            arguments: [],
                            loc: {
                                start: {
                                    line: 27,
                                    column: 24,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                },
                                end: {
                                    line: 27,
                                    column: 49,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'column',
                            loc: {
                                start: {
                                    line: 28,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                },
                                end: {
                                    line: 28,
                                    column: 14,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'DefaultColumn',
                                loc: {
                                    start: {
                                        line: 28,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                    },
                                    end: {
                                        line: 28,
                                        column: 30,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'Identifier',
                                    name: 'property',
                                    loc: {
                                        start: {
                                            line: 28,
                                            column: 31,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                        },
                                        end: {
                                            line: 28,
                                            column: 39,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                        }
                                    }
                                }],
                            loc: {
                                start: {
                                    line: 28,
                                    column: 17,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                },
                                end: {
                                    line: 28,
                                    column: 40,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'Identifier',
                        name: 'column',
                        loc: {
                            start: {
                                line: 29,
                                column: 11,
                                fixed: true,
                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                            },
                            end: {
                                line: 29,
                                column: 17,
                                fixed: true,
                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                            }
                        }
                    },
                    properties: [
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'canEdit',
                                loc: {
                                    start: {
                                        line: 30,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                    },
                                    end: {
                                        line: 30,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context) {
                                    return function () {
                                        var property = _context.get('property');
                                        return property.editable !== false;
                                    };
                                }
                            },
                            kind: 'init',
                            order: '0'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'createBodyCell',
                                loc: {
                                    start: {
                                        line: 31,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                    },
                                    end: {
                                        line: 31,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_ps) {
                                    return ion.template(function (row) {
                                        return ion.createRuntime({
                                            type: 'Template',
                                            id: null,
                                            body: [
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: '_ref5'
                                                            },
                                                            init: {
                                                                type: 'Identifier',
                                                                name: 'row',
                                                                loc: {
                                                                    start: {
                                                                        line: 32,
                                                                        column: 43,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 32,
                                                                        column: 46,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'dataTableModel',
                                                                loc: {
                                                                    start: {
                                                                        line: 32,
                                                                        column: 17,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 32,
                                                                        column: 31,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'MemberExpression',
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: '_ref5'
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'dataTableModel',
                                                                    loc: {
                                                                        start: {
                                                                            line: 32,
                                                                            column: 17,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 32,
                                                                            column: 31,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                computed: false
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '1'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'record',
                                                                loc: {
                                                                    start: {
                                                                        line: 32,
                                                                        column: 33,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 32,
                                                                        column: 39,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'MemberExpression',
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: '_ref5'
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'record',
                                                                    loc: {
                                                                        start: {
                                                                            line: 32,
                                                                            column: 33,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 32,
                                                                            column: 39,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                computed: false
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '2'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'value',
                                                                loc: {
                                                                    start: {
                                                                        line: 33,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 33,
                                                                        column: 21,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Function',
                                                                    context: true,
                                                                    value: function (_context2) {
                                                                        return function (record) {
                                                                            var Schema = _context2.get('Schema'), property = _context2.get('property');
                                                                            return Schema.get(record, property);
                                                                        };
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'Identifier',
                                                                        name: 'record',
                                                                        loc: {
                                                                            start: {
                                                                                line: 33,
                                                                                column: 28,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 33,
                                                                                column: 34,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                            }
                                                                        }
                                                                    }],
                                                                loc: {
                                                                    start: {
                                                                        line: 33,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 33,
                                                                        column: 67,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '3'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'customSourceFunction',
                                                                loc: {
                                                                    start: {
                                                                        line: 34,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 34,
                                                                        column: 36,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'property',
                                                                        loc: {
                                                                            start: {
                                                                                line: 34,
                                                                                column: 39,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 34,
                                                                                column: 47,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'foreign',
                                                                        loc: {
                                                                            start: {
                                                                                line: 34,
                                                                                column: 48,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 34,
                                                                                column: 55,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 34,
                                                                            column: 39,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 34,
                                                                            column: 55,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'getSource',
                                                                    loc: {
                                                                        start: {
                                                                            line: 34,
                                                                            column: 57,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 34,
                                                                            column: 66,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                existential: true,
                                                                loc: {
                                                                    start: {
                                                                        line: 34,
                                                                        column: 39,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 34,
                                                                        column: 66,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '4'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'source',
                                                                loc: {
                                                                    start: {
                                                                        line: 35,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 35,
                                                                        column: 22,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'ConditionalExpression',
                                                                test: {
                                                                    type: 'Identifier',
                                                                    name: 'customSourceFunction',
                                                                    loc: {
                                                                        start: {
                                                                            line: 35,
                                                                            column: 25,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 35,
                                                                            column: 45,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                consequent: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'property',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 35,
                                                                                        column: 48,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 35,
                                                                                        column: 56,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'foreign',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 35,
                                                                                        column: 57,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 35,
                                                                                        column: 64,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 35,
                                                                                    column: 48,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 35,
                                                                                    column: 64,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'getSource',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 35,
                                                                                    column: 65,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 35,
                                                                                    column: 74,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 35,
                                                                                column: 48,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 35,
                                                                                column: 74,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [{
                                                                            type: 'ObjectExpression',
                                                                            properties: [
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'server',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 35,
                                                                                                column: 76,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 35,
                                                                                                column: 82,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Identifier',
                                                                                        name: 'defaultSource',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 35,
                                                                                                column: 83,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 35,
                                                                                                column: 96,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'record',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 35,
                                                                                                column: 97,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 35,
                                                                                                column: 103,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Identifier',
                                                                                        name: 'record',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 35,
                                                                                                column: 97,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 35,
                                                                                                column: 103,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '1'
                                                                                }
                                                                            ]
                                                                        }],
                                                                    loc: {
                                                                        start: {
                                                                            line: 35,
                                                                            column: 48,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 35,
                                                                            column: 105,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                alternate: {
                                                                    type: 'Identifier',
                                                                    name: 'defaultSource',
                                                                    loc: {
                                                                        start: {
                                                                            line: 35,
                                                                            column: 108,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 35,
                                                                            column: 121,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '5'
                                                },
                                                {
                                                    type: 'ReturnStatement',
                                                    argument: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'Span',
                                                                loc: {
                                                                    start: {
                                                                        line: 36,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 36,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [{
                                                                    type: 'ObjectExpression',
                                                                    properties: [{
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'class',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 36,
                                                                                        column: 25,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 36,
                                                                                        column: 30,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'RelationColumn'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        }]
                                                                }],
                                                            loc: {
                                                                start: {
                                                                    line: 36,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                },
                                                                end: {
                                                                    line: 36,
                                                                    column: 49,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [{
                                                                type: 'IfStatement',
                                                                test: {
                                                                    type: 'UnaryExpression',
                                                                    operator: '?',
                                                                    argument: {
                                                                        type: 'Identifier',
                                                                        name: 'source',
                                                                        loc: {
                                                                            start: {
                                                                                line: 37,
                                                                                column: 19,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 37,
                                                                                column: 25,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                            }
                                                                        }
                                                                    }
                                                                },
                                                                consequent: {
                                                                    type: 'BlockStatement',
                                                                    body: [{
                                                                            type: 'IfStatement',
                                                                            test: {
                                                                                type: 'BinaryExpression',
                                                                                operator: '===',
                                                                                left: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'property',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 38,
                                                                                                column: 23,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 38,
                                                                                                column: 31,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'format',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 38,
                                                                                                column: 32,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 38,
                                                                                                column: 38,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 38,
                                                                                            column: 23,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 38,
                                                                                            column: 38,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                right: {
                                                                                    type: 'Literal',
                                                                                    value: 'key'
                                                                                }
                                                                            },
                                                                            consequent: {
                                                                                type: 'BlockStatement',
                                                                                body: [{
                                                                                        type: 'IfStatement',
                                                                                        test: {
                                                                                            type: 'UnaryExpression',
                                                                                            operator: '?',
                                                                                            argument: {
                                                                                                type: 'Identifier',
                                                                                                name: 'value',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 39,
                                                                                                        column: 27,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 39,
                                                                                                        column: 32,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        consequent: {
                                                                                            type: 'BlockStatement',
                                                                                            body: [
                                                                                                {
                                                                                                    type: 'VariableDeclaration',
                                                                                                    declarations: [{
                                                                                                            type: 'VariableDeclarator',
                                                                                                            id: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'foreignRecord',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 40,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 40,
                                                                                                                        column: 45,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            init: {
                                                                                                                type: 'MemberExpression',
                                                                                                                computed: true,
                                                                                                                object: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'source',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 40,
                                                                                                                            column: 48,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 40,
                                                                                                                            column: 54,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                property: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'value',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 40,
                                                                                                                            column: 55,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 40,
                                                                                                                            column: 60,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 40,
                                                                                                                        column: 48,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 40,
                                                                                                                        column: 61,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            }
                                                                                                        }],
                                                                                                    kind: 'let',
                                                                                                    order: '0'
                                                                                                },
                                                                                                {
                                                                                                    type: 'IfStatement',
                                                                                                    test: {
                                                                                                        type: 'UnaryExpression',
                                                                                                        operator: '?',
                                                                                                        argument: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'foreignRecord',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 41,
                                                                                                                    column: 31,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 41,
                                                                                                                    column: 44,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    consequent: {
                                                                                                        type: 'BlockStatement',
                                                                                                        body: [{
                                                                                                                type: 'ExpressionStatement',
                                                                                                                expression: {
                                                                                                                    type: 'CallExpression',
                                                                                                                    callee: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'RecordChip',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 42,
                                                                                                                                column: 32,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 42,
                                                                                                                                column: 42,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    arguments: [{
                                                                                                                            type: 'ObjectExpression',
                                                                                                                            properties: [{
                                                                                                                                    type: 'Property',
                                                                                                                                    key: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'record',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 42,
                                                                                                                                                column: 44,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 42,
                                                                                                                                                column: 50,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    value: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'foreignRecord',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 42,
                                                                                                                                                column: 51,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 42,
                                                                                                                                                column: 64,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    kind: 'init',
                                                                                                                                    order: '0'
                                                                                                                                }]
                                                                                                                        }],
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 42,
                                                                                                                            column: 32,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 42,
                                                                                                                            column: 66,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 42,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 42,
                                                                                                                        column: 66,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                    }
                                                                                                                },
                                                                                                                order: '0'
                                                                                                            }]
                                                                                                    },
                                                                                                    alternate: null,
                                                                                                    order: '1'
                                                                                                }
                                                                                            ]
                                                                                        },
                                                                                        alternate: null,
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            alternate: {
                                                                                type: 'IfStatement',
                                                                                test: {
                                                                                    type: 'BinaryExpression',
                                                                                    operator: '===',
                                                                                    left: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'property',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 43,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 43,
                                                                                                    column: 36,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'type',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 43,
                                                                                                    column: 37,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 43,
                                                                                                    column: 41,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 43,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 43,
                                                                                                column: 41,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    right: {
                                                                                        type: 'Literal',
                                                                                        value: 'object'
                                                                                    }
                                                                                },
                                                                                consequent: {
                                                                                    type: 'BlockStatement',
                                                                                    body: [{
                                                                                            type: 'IfStatement',
                                                                                            test: {
                                                                                                type: 'UnaryExpression',
                                                                                                operator: '?',
                                                                                                argument: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'value',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 44,
                                                                                                            column: 27,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 44,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                        }
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            consequent: {
                                                                                                type: 'BlockStatement',
                                                                                                body: [{
                                                                                                        type: 'ForInStatement',
                                                                                                        left: {
                                                                                                            type: 'VariableDeclaration',
                                                                                                            declarations: [
                                                                                                                {
                                                                                                                    type: 'VariableDeclarator',
                                                                                                                    id: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'key',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 45,
                                                                                                                                column: 32,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 45,
                                                                                                                                column: 35,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    init: null
                                                                                                                },
                                                                                                                {
                                                                                                                    type: 'VariableDeclarator',
                                                                                                                    id: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'details',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 45,
                                                                                                                                column: 37,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 45,
                                                                                                                                column: 44,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    init: null
                                                                                                                }
                                                                                                            ],
                                                                                                            kind: 'let'
                                                                                                        },
                                                                                                        right: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'value',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 45,
                                                                                                                    column: 48,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 45,
                                                                                                                    column: 53,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        body: {
                                                                                                            type: 'BlockStatement',
                                                                                                            body: [
                                                                                                                {
                                                                                                                    type: 'VariableDeclaration',
                                                                                                                    declarations: [{
                                                                                                                            type: 'VariableDeclarator',
                                                                                                                            id: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'foreignRecord',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 46,
                                                                                                                                        column: 36,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 46,
                                                                                                                                        column: 49,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            init: {
                                                                                                                                type: 'MemberExpression',
                                                                                                                                computed: true,
                                                                                                                                object: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'source',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 46,
                                                                                                                                            column: 52,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 46,
                                                                                                                                            column: 58,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                property: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'key',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 46,
                                                                                                                                            column: 59,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 46,
                                                                                                                                            column: 62,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 46,
                                                                                                                                        column: 52,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 46,
                                                                                                                                        column: 63,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            }
                                                                                                                        }],
                                                                                                                    kind: 'let',
                                                                                                                    order: '0'
                                                                                                                },
                                                                                                                {
                                                                                                                    type: 'IfStatement',
                                                                                                                    test: {
                                                                                                                        type: 'UnaryExpression',
                                                                                                                        operator: '?',
                                                                                                                        argument: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'foreignRecord',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 47,
                                                                                                                                    column: 35,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 47,
                                                                                                                                    column: 48,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    consequent: {
                                                                                                                        type: 'BlockStatement',
                                                                                                                        body: [{
                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                expression: {
                                                                                                                                    type: 'CallExpression',
                                                                                                                                    callee: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'RecordChip',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 48,
                                                                                                                                                column: 36,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 48,
                                                                                                                                                column: 46,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    arguments: [{
                                                                                                                                            type: 'ObjectExpression',
                                                                                                                                            properties: [
                                                                                                                                                {
                                                                                                                                                    type: 'Property',
                                                                                                                                                    key: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'record',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 48,
                                                                                                                                                                column: 48,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 48,
                                                                                                                                                                column: 54,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    value: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'foreignRecord',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 48,
                                                                                                                                                                column: 55,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 48,
                                                                                                                                                                column: 68,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    kind: 'init',
                                                                                                                                                    order: '0'
                                                                                                                                                },
                                                                                                                                                {
                                                                                                                                                    type: 'Property',
                                                                                                                                                    key: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'details',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 48,
                                                                                                                                                                column: 70,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 48,
                                                                                                                                                                column: 77,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    value: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'details',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 48,
                                                                                                                                                                column: 70,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 48,
                                                                                                                                                                column: 77,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    kind: 'init',
                                                                                                                                                    order: '1'
                                                                                                                                                },
                                                                                                                                                {
                                                                                                                                                    type: 'Property',
                                                                                                                                                    key: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'property',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 48,
                                                                                                                                                                column: 79,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 48,
                                                                                                                                                                column: 87,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    value: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'property',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 48,
                                                                                                                                                                column: 79,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 48,
                                                                                                                                                                column: 87,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    kind: 'init',
                                                                                                                                                    order: '2'
                                                                                                                                                }
                                                                                                                                            ]
                                                                                                                                        }],
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 48,
                                                                                                                                            column: 36,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 48,
                                                                                                                                            column: 89,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 48,
                                                                                                                                        column: 36,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 48,
                                                                                                                                        column: 89,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                order: '0'
                                                                                                                            }]
                                                                                                                    },
                                                                                                                    alternate: null,
                                                                                                                    order: '1'
                                                                                                                }
                                                                                                            ]
                                                                                                        },
                                                                                                        remove: null,
                                                                                                        order: '0'
                                                                                                    }]
                                                                                            },
                                                                                            alternate: null,
                                                                                            order: '0'
                                                                                        }]
                                                                                },
                                                                                alternate: null
                                                                            },
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                alternate: null,
                                                                order: '0'
                                                            }]
                                                    },
                                                    order: '6'
                                                }
                                            ],
                                            bound: false,
                                            name: {
                                                type: 'Identifier',
                                                name: 'createBodyCell',
                                                loc: {
                                                    start: {
                                                        line: 31,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                    },
                                                    end: {
                                                        line: 31,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/RelationColumn.ion'
                                                    }
                                                }
                                            },
                                            scope: {
                                                type: 'Identifier',
                                                name: '_ps'
                                            }
                                        }, {
                                            this: this,
                                            row: row,
                                            _ps: _ps,
                                            property: property,
                                            ion: ion,
                                            _ref: _ref,
                                            DefaultColumn: DefaultColumn,
                                            _ref2: _ref2,
                                            _ref3: _ref3,
                                            _ref4: _ref4,
                                            Schema: Schema,
                                            jsonValueToDisplayValue: jsonValueToDisplayValue,
                                            Chip: Chip,
                                            RecordChip: RecordChip,
                                            style: style,
                                            _ref6: _ref6
                                        }, _ps);
                                    });
                                }
                            },
                            kind: 'init',
                            order: '1'
                        }
                    ]
                },
                order: '2'
            }
        ],
        bound: false
    }, {
        this: this,
        ion: ion,
        property: property,
        _ref: _ref,
        DefaultColumn: DefaultColumn,
        _ref2: _ref2,
        _ref3: _ref3,
        _ref4: _ref4,
        Schema: Schema,
        jsonValueToDisplayValue: jsonValueToDisplayValue,
        Chip: Chip,
        RecordChip: RecordChip,
        style: style,
        _ref6: _ref6
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/DataTable2/RelationColumn',_glass_html_material_DataTable2_RelationColumn_);
    else
      _glass_html_material_DataTable2_RelationColumn_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_DataTable2_RelationColumn_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_DataTable2_RowSelectColumn_ = function(module,exports,require){'use strict';
var ion = require('ion');
var DefaultColumn = require('./DefaultColumn');
module.exports = exports = ion.template(function RowSelectColumn(property) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'RowSelectColumn',
            loc: {
                start: {
                    line: 4,
                    column: 16,
                    fixed: true,
                    source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                },
                end: {
                    line: 4,
                    column: 31,
                    fixed: true,
                    source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                }
            }
        },
        body: [{
                type: 'ReturnStatement',
                argument: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'CallExpression',
                        callee: {
                            type: 'Identifier',
                            name: 'DefaultColumn',
                            loc: {
                                start: {
                                    line: 5,
                                    column: 11,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                },
                                end: {
                                    line: 5,
                                    column: 24,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                }
                            }
                        },
                        arguments: [{
                                type: 'Identifier',
                                name: 'property',
                                loc: {
                                    start: {
                                        line: 5,
                                        column: 25,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                    },
                                    end: {
                                        line: 5,
                                        column: 33,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                    }
                                }
                            }],
                        loc: {
                            start: {
                                line: 5,
                                column: 11,
                                fixed: true,
                                source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                            },
                            end: {
                                line: 5,
                                column: 34,
                                fixed: true,
                                source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                            }
                        }
                    },
                    properties: [
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'isRowSelect',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 19,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Literal',
                                value: true
                            },
                            kind: 'init',
                            order: '0'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'defaultWidth',
                                loc: {
                                    start: {
                                        line: 7,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                    },
                                    end: {
                                        line: 7,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Literal',
                                value: 60
                            },
                            kind: 'init',
                            order: '1'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'canEdit',
                                loc: {
                                    start: {
                                        line: 8,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                    },
                                    end: {
                                        line: 8,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: false,
                                value: function (dataTableModel, object) {
                                    return false;
                                }
                            },
                            kind: 'init',
                            order: '2'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'createCssRules',
                                loc: {
                                    start: {
                                        line: 9,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                    },
                                    end: {
                                        line: 9,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: false,
                                value: function (dataTableModel) {
                                    return {
                                        '': 'justify-content: center;',
                                        'paper-checkbox': '--paper-checkbox-unchecked-color: rgba(0, 0, 0, 0.54);',
                                        'paper-checkbox.headerCell': 'opacity: 0;',
                                        'paper-checkbox.headerCell:hover': 'opacity: 1;'
                                    };
                                }
                            },
                            kind: 'init',
                            order: '3'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'createHeaderCell',
                                loc: {
                                    start: {
                                        line: 19,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                    },
                                    end: {
                                        line: 19,
                                        column: 24,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_ps) {
                                    return ion.template(function (dataTableModel) {
                                        return ion.createRuntime({
                                            type: 'Template',
                                            id: null,
                                            body: [{
                                                    type: 'ReturnStatement',
                                                    argument: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'Span',
                                                                loc: {
                                                                    start: {
                                                                        line: 20,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 20,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [],
                                                            loc: {
                                                                start: {
                                                                    line: 20,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                },
                                                                end: {
                                                                    line: 20,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [{
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'ObjectExpression',
                                                                    objectType: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'Identifier',
                                                                            name: 'PaperCheckbox',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 21,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 21,
                                                                                    column: 29,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [{
                                                                                type: 'ObjectExpression',
                                                                                properties: [{
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'class',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 21,
                                                                                                    column: 31,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 21,
                                                                                                    column: 36,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 'headerCell transition'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    }]
                                                                            }],
                                                                        loc: {
                                                                            start: {
                                                                                line: 21,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 21,
                                                                                column: 62,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    properties: [
                                                                        {
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'Function',
                                                                                context: false,
                                                                                value: function mousedown(e) {
                                                                                    e.stopPropagation();
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 22,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 24,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'Function',
                                                                                context: false,
                                                                                value: function mouseup(e) {
                                                                                    e.stopPropagation();
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 24,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 26,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                }
                                                                            },
                                                                            order: '1'
                                                                        },
                                                                        {
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'Function',
                                                                                context: true,
                                                                                value: function (_context) {
                                                                                    return function change(e) {
                                                                                        var dataTableModel = _context.get('dataTableModel');
                                                                                        if (dataTableModel.allRows.length === dataTableModel.selectedRows.length) {
                                                                                            dataTableModel.clearSelection();
                                                                                        } else {
                                                                                            dataTableModel.clearSelection();
                                                                                            dataTableModel.selectAllRows();
                                                                                        }
                                                                                    };
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 26,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 32,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                }
                                                                            },
                                                                            order: '2'
                                                                        },
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'checked',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 32,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 32,
                                                                                        column: 27,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'BinaryExpression',
                                                                                operator: '===',
                                                                                left: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'dataTableModel',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 32,
                                                                                                    column: 29,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 32,
                                                                                                    column: 43,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'allRows',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 32,
                                                                                                    column: 44,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 32,
                                                                                                    column: 51,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 32,
                                                                                                column: 29,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 32,
                                                                                                column: 51,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'length',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 32,
                                                                                                column: 52,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 32,
                                                                                                column: 58,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 32,
                                                                                            column: 29,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 32,
                                                                                            column: 58,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                right: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'dataTableModel',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 32,
                                                                                                    column: 62,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 32,
                                                                                                    column: 76,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'selectedRows',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 32,
                                                                                                    column: 77,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 32,
                                                                                                    column: 89,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 32,
                                                                                                column: 62,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 32,
                                                                                                column: 89,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'length',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 32,
                                                                                                column: 90,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 32,
                                                                                                column: 96,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 32,
                                                                                            column: 62,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 32,
                                                                                            column: 96,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                        }
                                                                                    }
                                                                                }
                                                                            },
                                                                            kind: 'init',
                                                                            order: '3'
                                                                        }
                                                                    ]
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 21,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 33,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    order: '0'
                                                }],
                                            bound: false,
                                            name: {
                                                type: 'Identifier',
                                                name: 'createHeaderCell',
                                                loc: {
                                                    start: {
                                                        line: 19,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                    },
                                                    end: {
                                                        line: 19,
                                                        column: 24,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                    }
                                                }
                                            },
                                            scope: {
                                                type: 'Identifier',
                                                name: '_ps'
                                            }
                                        }, {
                                            this: this,
                                            dataTableModel: dataTableModel,
                                            _ps: _ps,
                                            property: property,
                                            DefaultColumn: DefaultColumn
                                        }, _ps);
                                    });
                                }
                            },
                            kind: 'init',
                            order: '4'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'createBodyCell',
                                loc: {
                                    start: {
                                        line: 33,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                    },
                                    end: {
                                        line: 33,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_ps2) {
                                    return ion.template(function (row) {
                                        return ion.createRuntime({
                                            type: 'Template',
                                            id: null,
                                            body: [
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'checkbox',
                                                                loc: {
                                                                    start: {
                                                                        line: 34,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 34,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'ObjectExpression',
                                                                objectType: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'Identifier',
                                                                        name: 'PaperCheckbox',
                                                                        loc: {
                                                                            start: {
                                                                                line: 34,
                                                                                column: 27,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 34,
                                                                                column: 40,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [],
                                                                    loc: {
                                                                        start: {
                                                                            line: 34,
                                                                            column: 27,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 34,
                                                                            column: 42,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                properties: [
                                                                    {
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'Function',
                                                                            context: true,
                                                                            value: function (_context2) {
                                                                                return function click(e) {
                                                                                    var row = _context2.get('row');
                                                                                    row.dataTableModel.selectAllColumns(false);
                                                                                    row.setSelected(!row.selected);
                                                                                    e.stopPropagation();
                                                                                };
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 35,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 39,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                            }
                                                                        },
                                                                        order: '0'
                                                                    },
                                                                    {
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'Function',
                                                                            context: false,
                                                                            value: function mousedown(e) {
                                                                                e.stopPropagation();
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 39,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 41,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                            }
                                                                        },
                                                                        order: '1'
                                                                    },
                                                                    {
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'Function',
                                                                            context: false,
                                                                            value: function mouseup(e) {
                                                                                e.stopPropagation();
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 41,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 43,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                            }
                                                                        },
                                                                        order: '2'
                                                                    }
                                                                ]
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'ReturnStatement',
                                                    argument: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'Span',
                                                                loc: {
                                                                    start: {
                                                                        line: 43,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 43,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [],
                                                            loc: {
                                                                start: {
                                                                    line: 43,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                },
                                                                end: {
                                                                    line: 43,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [{
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'ObjectExpression',
                                                                    objectType: {
                                                                        type: 'Identifier',
                                                                        name: 'checkbox',
                                                                        loc: {
                                                                            start: {
                                                                                line: 44,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 44,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    properties: [{
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'checked',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 45,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 45,
                                                                                        column: 27,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'BinaryExpression',
                                                                                operator: '&&',
                                                                                left: {
                                                                                    type: 'BinaryExpression',
                                                                                    operator: '===',
                                                                                    left: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'row',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 45,
                                                                                                    column: 29,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 45,
                                                                                                    column: 32,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'selected',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 45,
                                                                                                    column: 33,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 45,
                                                                                                    column: 41,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 45,
                                                                                                column: 29,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 45,
                                                                                                column: 41,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    right: {
                                                                                        type: 'Literal',
                                                                                        value: true
                                                                                    }
                                                                                },
                                                                                right: {
                                                                                    type: 'UnaryExpression',
                                                                                    operator: '!',
                                                                                    argument: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'MemberExpression',
                                                                                            computed: false,
                                                                                            object: {
                                                                                                type: 'Identifier',
                                                                                                name: 'row',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 45,
                                                                                                        column: 58,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 45,
                                                                                                        column: 61,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            property: {
                                                                                                type: 'Identifier',
                                                                                                name: 'dataTableModel',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 45,
                                                                                                        column: 62,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 45,
                                                                                                        column: 76,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 45,
                                                                                                    column: 58,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 45,
                                                                                                    column: 76,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'hasColumnSelection',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 45,
                                                                                                    column: 77,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 45,
                                                                                                    column: 95,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 45,
                                                                                                column: 58,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 45,
                                                                                                column: 95,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                }
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 44,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 47,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    order: '1'
                                                }
                                            ],
                                            bound: false,
                                            name: {
                                                type: 'Identifier',
                                                name: 'createBodyCell',
                                                loc: {
                                                    start: {
                                                        line: 33,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                    },
                                                    end: {
                                                        line: 33,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/RowSelectColumn.ion'
                                                    }
                                                }
                                            },
                                            scope: {
                                                type: 'Identifier',
                                                name: '_ps2'
                                            }
                                        }, {
                                            this: this,
                                            row: row,
                                            _ps2: _ps2,
                                            property: property,
                                            DefaultColumn: DefaultColumn
                                        }, _ps2);
                                    });
                                }
                            },
                            kind: 'init',
                            order: '5'
                        }
                    ]
                },
                order: '0'
            }],
        bound: false
    }, {
        this: this,
        ion: ion,
        property: property,
        DefaultColumn: DefaultColumn
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/DataTable2/RowSelectColumn',_glass_html_material_DataTable2_RowSelectColumn_);
    else
      _glass_html_material_DataTable2_RowSelectColumn_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_DataTable2_RowSelectColumn_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_DataTable2_RowSource_ = function(module,exports,require){'use strict';
var ion = require('ion');
var Row = {
        key: 'string',
        record: 'object',
        delete: function () {
        }
    };
module.exports = exports = ion.template(function RowSource() {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'RowSource',
            loc: {
                start: {
                    line: 10,
                    column: 16,
                    fixed: true,
                    source: 'glass/html/material/DataTable2/RowSource.ion'
                },
                end: {
                    line: 10,
                    column: 25,
                    fixed: true,
                    source: 'glass/html/material/DataTable2/RowSource.ion'
                }
            }
        },
        body: [{
                type: 'ReturnStatement',
                argument: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'ObjectExpression',
                        properties: []
                    },
                    properties: [
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'refresh',
                                loc: {
                                    start: {
                                        line: 12,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/RowSource.ion'
                                    },
                                    end: {
                                        line: 12,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/RowSource.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: false,
                                value: function () {
                                }
                            },
                            kind: 'init',
                            order: '0'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'beginOp',
                                loc: {
                                    start: {
                                        line: 13,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/RowSource.ion'
                                    },
                                    end: {
                                        line: 13,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/RowSource.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: false,
                                value: function () {
                                    return global.model.ops.begin();
                                }
                            },
                            kind: 'init',
                            order: '1'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'rows',
                                loc: {
                                    start: {
                                        line: 14,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/RowSource.ion'
                                    },
                                    end: {
                                        line: 14,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/RowSource.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'ArrayExpression',
                                elements: []
                            },
                            kind: 'init',
                            order: '2'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'records',
                                loc: {
                                    start: {
                                        line: 15,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/RowSource.ion'
                                    },
                                    end: {
                                        line: 15,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/RowSource.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'ObjectExpression',
                                properties: []
                            },
                            kind: 'init',
                            order: '3'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'loading',
                                loc: {
                                    start: {
                                        line: 16,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/RowSource.ion'
                                    },
                                    end: {
                                        line: 16,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/RowSource.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Literal',
                                value: false
                            },
                            kind: 'init',
                            order: '4'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'insertRecord',
                                loc: {
                                    start: {
                                        line: 17,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/RowSource.ion'
                                    },
                                    end: {
                                        line: 17,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/RowSource.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: false,
                                value: function (record, parent, insertBefore) {
                                }
                            },
                            kind: 'init',
                            order: '5'
                        }
                    ]
                },
                order: '0'
            }],
        bound: false
    }, {
        this: this,
        Row: Row
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/DataTable2/RowSource',_glass_html_material_DataTable2_RowSource_);
    else
      _glass_html_material_DataTable2_RowSource_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_DataTable2_RowSource_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_DataTable2_SelectColumn_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('../../../convert'), _ref2, DefaultColumn = require('./DefaultColumn'), _ref3, _ref4;
var jsonValueToDisplayValue = _ref.jsonValueToDisplayValue;
_ref2 = require('../../../data');
var Schema = _ref2.Schema;
_ref3 = require('../');
var Icon = _ref3.Icon;
_ref4 = require('../../');
var style = _ref4.style;
var _ref5 = style.sheets;
_ref5[module.id] = '.SelectColumn {\n    display: flex;\n    flex-direction: row;\n}\n.SelectColumn SPAN {\n    flex: 1 1 auto;\n}\n.SelectColumn IRON-ICON {\n    opacity: 0.4;\n}';
_ref5;
module.exports = exports = ion.template(function SelectColumn(property) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'SelectColumn',
            loc: {
                start: {
                    line: 21,
                    column: 16,
                    fixed: true,
                    source: 'glass/html/material/DataTable2/SelectColumn.ion'
                },
                end: {
                    line: 21,
                    column: 28,
                    fixed: true,
                    source: 'glass/html/material/DataTable2/SelectColumn.ion'
                }
            }
        },
        body: [{
                type: 'ReturnStatement',
                argument: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'CallExpression',
                        callee: {
                            type: 'Identifier',
                            name: 'DefaultColumn',
                            loc: {
                                start: {
                                    line: 22,
                                    column: 11,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                },
                                end: {
                                    line: 22,
                                    column: 24,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                }
                            }
                        },
                        arguments: [{
                                type: 'Identifier',
                                name: 'property',
                                loc: {
                                    start: {
                                        line: 22,
                                        column: 25,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                    },
                                    end: {
                                        line: 22,
                                        column: 33,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                    }
                                }
                            }],
                        loc: {
                            start: {
                                line: 22,
                                column: 11,
                                fixed: true,
                                source: 'glass/html/material/DataTable2/SelectColumn.ion'
                            },
                            end: {
                                line: 22,
                                column: 34,
                                fixed: true,
                                source: 'glass/html/material/DataTable2/SelectColumn.ion'
                            }
                        }
                    },
                    properties: [
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'defaultWidth',
                                loc: {
                                    start: {
                                        line: 23,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                    },
                                    end: {
                                        line: 23,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Literal',
                                value: 100
                            },
                            kind: 'init',
                            order: '0'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'clicksToEdit',
                                loc: {
                                    start: {
                                        line: 24,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                    },
                                    end: {
                                        line: 24,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Literal',
                                value: 1
                            },
                            kind: 'init',
                            order: '1'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'createBodyCell',
                                loc: {
                                    start: {
                                        line: 25,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                    },
                                    end: {
                                        line: 25,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_ps) {
                                    return ion.template(function (row) {
                                        return ion.createRuntime({
                                            type: 'Template',
                                            id: null,
                                            body: [
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'getDisplayValue',
                                                                loc: {
                                                                    start: {
                                                                        line: 26,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 26,
                                                                        column: 31,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'MemberExpression',
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'ion'
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'bind'
                                                                    }
                                                                },
                                                                arguments: [
                                                                    {
                                                                        type: 'Function',
                                                                        context: true,
                                                                        value: function (_context) {
                                                                            return function (record) {
                                                                                var jsonValueToDisplayValue = _context.get('jsonValueToDisplayValue'), property = _context.get('property'), Schema = _context.get('Schema');
                                                                                return jsonValueToDisplayValue(property, Schema.get(record, property));
                                                                            };
                                                                        }
                                                                    },
                                                                    { type: 'ThisExpression' }
                                                                ]
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'displayValue',
                                                                loc: {
                                                                    start: {
                                                                        line: 27,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 27,
                                                                        column: 28,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Identifier',
                                                                    name: 'getDisplayValue',
                                                                    loc: {
                                                                        start: {
                                                                            line: 27,
                                                                            column: 31,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 27,
                                                                            column: 46,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'row',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 27,
                                                                                    column: 52,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 27,
                                                                                    column: 55,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'record',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 27,
                                                                                    column: 56,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 27,
                                                                                    column: 62,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 27,
                                                                                column: 52,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 27,
                                                                                column: 62,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                                                            }
                                                                        },
                                                                        deep: true
                                                                    }],
                                                                loc: {
                                                                    start: {
                                                                        line: 27,
                                                                        column: 31,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 27,
                                                                        column: 63,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '1'
                                                },
                                                {
                                                    type: 'ReturnStatement',
                                                    argument: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'Span',
                                                                loc: {
                                                                    start: {
                                                                        line: 28,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 28,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [{
                                                                    type: 'ObjectExpression',
                                                                    properties: [{
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'class',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 28,
                                                                                        column: 25,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 28,
                                                                                        column: 30,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'SelectColumn'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        }]
                                                                }],
                                                            loc: {
                                                                start: {
                                                                    line: 28,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                                                },
                                                                end: {
                                                                    line: 28,
                                                                    column: 47,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'ObjectExpression',
                                                                    objectType: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'Identifier',
                                                                            name: 'Span',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 29,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 29,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [],
                                                                        loc: {
                                                                            start: {
                                                                                line: 29,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 29,
                                                                                column: 22,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    properties: [{
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'Identifier',
                                                                                name: 'displayValue',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 30,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 30,
                                                                                        column: 32,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 30,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 30,
                                                                                    column: 32,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 29,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 31,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'ObjectExpression',
                                                                    objectType: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'Identifier',
                                                                            name: 'IronIcon',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 31,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 31,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [],
                                                                        loc: {
                                                                            start: {
                                                                                line: 31,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 31,
                                                                                column: 26,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    properties: [{
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'icon',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 32,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 32,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'arrow-drop-down'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 31,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 34,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                                                    }
                                                                },
                                                                order: '1'
                                                            }
                                                        ]
                                                    },
                                                    order: '2'
                                                }
                                            ],
                                            bound: false,
                                            name: {
                                                type: 'Identifier',
                                                name: 'createBodyCell',
                                                loc: {
                                                    start: {
                                                        line: 25,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                                    },
                                                    end: {
                                                        line: 25,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/SelectColumn.ion'
                                                    }
                                                }
                                            },
                                            scope: {
                                                type: 'Identifier',
                                                name: '_ps'
                                            }
                                        }, {
                                            this: this,
                                            ion: ion,
                                            row: row,
                                            _ps: _ps,
                                            property: property,
                                            _ref: _ref,
                                            _ref2: _ref2,
                                            DefaultColumn: DefaultColumn,
                                            _ref3: _ref3,
                                            _ref4: _ref4,
                                            jsonValueToDisplayValue: jsonValueToDisplayValue,
                                            Schema: Schema,
                                            Icon: Icon,
                                            style: style,
                                            _ref5: _ref5
                                        }, _ps);
                                    });
                                }
                            },
                            kind: 'init',
                            order: '2'
                        }
                    ]
                },
                order: '0'
            }],
        bound: false
    }, {
        this: this,
        ion: ion,
        property: property,
        _ref: _ref,
        _ref2: _ref2,
        DefaultColumn: DefaultColumn,
        _ref3: _ref3,
        _ref4: _ref4,
        jsonValueToDisplayValue: jsonValueToDisplayValue,
        Schema: Schema,
        Icon: Icon,
        style: style,
        _ref5: _ref5
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/DataTable2/SelectColumn',_glass_html_material_DataTable2_SelectColumn_);
    else
      _glass_html_material_DataTable2_SelectColumn_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_DataTable2_SelectColumn_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_DataTable2_TimelineColumn_ = function(module,exports,require){'use strict';
var ion = require('ion');
var glass = require('../../../'), _ref, _ref2, _ref3, _ref4, DefaultColumn = require('./DefaultColumn'), headerFont1 = '600 13px "Roboto", sans-serif', headerFont2 = '500 12px "Roboto", sans-serif', getMiddleDate = function (start, finish) {
        var s = start.getTime();
        var f = finish.getTime();
        var diff = f - s;
        return new Date(s + Math.round(diff / 2));
    };
_ref = glass.convert;
var jsonValueToDisplayValue = _ref.jsonValueToDisplayValue;
_ref2 = glass.data;
var Schema = _ref2.Schema;
_ref3 = glass.html;
var style = _ref3.style;
_ref4 = glass.html.material;
var Icon = _ref4.Icon;
var zoomUnits = {
        day: {
            name: 'Day',
            bigHours: 24,
            smallHours: 1,
            getNext: function (_ref5) {
                var date = _ref5.date;
                return date.clone().addDays(1);
            },
            getPrevious: function (_ref6) {
                var date = _ref6.date;
                return date.clone().addDays(-1);
            },
            getStart: function (_ref7) {
                var date = _ref7.date;
                return date.clone().beginningOfDay();
            },
            getFinish: function (_ref8) {
                var date = _ref8.date;
                return date.clone().endOfDay();
            },
            getTitle: function (_ref9) {
                var start = _ref9.start;
                var finish = _ref9.finish;
                return finish.format('{Dow}, {Month} {d}, {yyyy}');
            },
            getUnit: function (_ref10) {
                var start = _ref10.start;
                var finish = _ref10.finish;
                var hour = start.getHours();
                return {
                    title: start.format('{h}'),
                    scheduled: hour >= 8 && hour <= 16
                };
            },
            incrementUnit: function (date) {
                return date.clone().addHours(1);
            }
        },
        week: {
            name: 'Week',
            bigHours: 24 * 7,
            smallHours: 24,
            getNext: function (_ref11) {
                var date = _ref11.date;
                return date.clone().addDays(7);
            },
            getPrevious: function (_ref12) {
                var date = _ref12.date;
                return date.clone().addDays(-7);
            },
            getStart: function (_ref13) {
                var date = _ref13.date;
                return date.clone().beginningOfWeek();
            },
            getFinish: function (_ref14) {
                var date = _ref14.date;
                return date.clone().endOfWeek();
            },
            getTitle: function (_ref15) {
                var start = _ref15.start;
                var finish = _ref15.finish;
                return start.format('{d}') + '-' + finish.format('{d} {Month} {yyyy}');
            },
            getUnit: function (_ref16) {
                var start = _ref16.start;
                var finish = _ref16.finish;
                return {
                    title: start.format('{Dow} {d}'),
                    scheduled: !(start.isSaturday() || start.isSunday())
                };
            },
            incrementUnit: function (date) {
                return date.clone().addDays(1);
            }
        },
        month: {
            bigHours: 24 * 30,
            smallHours: 24,
            name: 'Month',
            getNext: function (_ref17) {
                var date = _ref17.date;
                return date.clone().addMonths(1);
            },
            getPrevious: function (_ref18) {
                var date = _ref18.date;
                return date.clone().addMonths(-1);
            },
            getStart: function (_ref19) {
                var date = _ref19.date;
                return date.clone().beginningOfMonth();
            },
            getFinish: function (_ref20) {
                var date = _ref20.date;
                return date.clone().endOfMonth();
            },
            getTitle: function (_ref21) {
                var start = _ref21.start;
                var finish = _ref21.finish;
                return start.format('{Month} {yyyy}');
            },
            getUnit: function (_ref22) {
                var start = _ref22.start;
                var finish = _ref22.finish;
                return {
                    title: start.format('{d}'),
                    scheduled: !(start.isSaturday() || start.isSunday())
                };
            },
            incrementUnit: function (date) {
                return date.clone().addDays(1);
            }
        },
        quarter: {
            bigHours: 24 * 30 * 4,
            smallHours: 24 * 30,
            name: 'Quarter',
            getNext: function (_ref23) {
                var date = _ref23.date;
                return date.clone().addMonths(1);
            },
            getPrevious: function (_ref24) {
                var date = _ref24.date;
                return date.clone().addMonths(-1);
            },
            getStart: function (_ref25) {
                var date = _ref25.date;
                return date.clone().addMonths(-1).beginningOfMonth();
            },
            getFinish: function (_ref26) {
                var date = _ref26.date;
                return this.getStart({ date: date }).addMinutes(1).addMonths(3);
            },
            getTitle: function (_ref27) {
                var start = _ref27.start;
                var finish = _ref27.finish;
                return getMiddleDate(start, finish).format('{yyyy}');
            },
            getUnit: function (_ref28) {
                var start = _ref28.start;
                var finish = _ref28.finish;
                return {
                    title: start.format('{Month}'),
                    scheduled: true
                };
            },
            incrementUnit: function (date) {
                return date.clone().addMonths(1);
            }
        },
        year: {
            bigHours: 24 * 365,
            smallHours: 24 * 30,
            name: 'Year',
            getNext: function (_ref29) {
                var date = _ref29.date;
                return date.clone().addYears(1);
            },
            getPrevious: function (_ref30) {
                var date = _ref30.date;
                return date.clone().addYears(-1);
            },
            getStart: function (_ref31) {
                var date = _ref31.date;
                return date.clone().beginningOfYear();
            },
            getFinish: function (_ref32) {
                var date = _ref32.date;
                return date.clone().endOfYear();
            },
            getTitle: function (_ref33) {
                var start = _ref33.start;
                var finish = _ref33.finish;
                return getMiddleDate(start, finish).format('{yyyy}');
            },
            getUnit: function (_ref34) {
                var start = _ref34.start;
                var finish = _ref34.finish;
                return {
                    title: start.format('{Mon}'),
                    scheduled: true
                };
            },
            incrementUnit: function (date) {
                return date.clone().addMonths(1);
            }
        }
    };
var zoomLevels = [
        {
            unit: 'day',
            count: 1,
            name: 'Day',
            snapToHour: true
        },
        {
            unit: 'week',
            count: 1,
            name: 'Week',
            snapToHour: false
        },
        {
            unit: 'week',
            count: 2,
            name: 'Two Weeks',
            snapToHour: false
        },
        {
            unit: 'month',
            count: 1,
            name: 'Month',
            snapToHour: false
        },
        {
            unit: 'quarter',
            count: 1,
            name: 'Quarter',
            snapToHour: false
        },
        {
            unit: 'year',
            count: 1,
            name: 'Year',
            snapToHour: false
        }
    ];
var zoomLevelNames = Object.keys(zoomLevels);
var getBigColumns = function (_ref35) {
    var date = _ref35.date;
    var zoom = _ref35.zoom;
    var unit = zoomUnits[zoom.unit];
    var count = zoom.count;
    var columns = [];
    var index = 0;
    for (var i = 0; i < count; i++) {
        var column = {};
        columns.push(column);
        date = unit.getStart({ date: date });
        column.start = date;
        date = unit.getFinish({ date: date });
        column.finish = date;
        column.title = unit.getTitle({
            start: column.start,
            finish: column.finish
        });
        column.subcolumns = getSmallColumns({
            start: column.start,
            finish: column.finish,
            zoom: zoom
        });
        date = unit.incrementUnit(date);
    }
    return columns;
};
var getSmallColumns = function (_ref36) {
    var start = _ref36.start;
    var finish = _ref36.finish;
    var zoom = _ref36.zoom;
    var unit = zoomUnits[zoom.unit];
    var columns = [];
    var date = start;
    while (date < finish) {
        var column = {};
        columns.push(column);
        column.start = date;
        date = unit.incrementUnit(date);
        column.finish = date;
        var unitDetails = unit.getUnit({
                start: column.start,
                finish: column.finish
            });
        column.title = unitDetails.title;
        column.scheduled = unitDetails.scheduled;
    }
    return columns;
};
var moveWidth = 40;
ion.template(function () {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [{
                type: 'ExpressionStatement',
                expression: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'MemberExpression',
                        computed: false,
                        object: {
                            type: 'Identifier',
                            name: 'style',
                            loc: {
                                start: {
                                    line: 142,
                                    column: 4,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                },
                                end: {
                                    line: 142,
                                    column: 9,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                }
                            }
                        },
                        property: {
                            type: 'Identifier',
                            name: 'sheets',
                            loc: {
                                start: {
                                    line: 142,
                                    column: 10,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                },
                                end: {
                                    line: 142,
                                    column: 16,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                }
                            }
                        },
                        loc: {
                            start: {
                                line: 142,
                                column: 4,
                                fixed: true,
                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                            },
                            end: {
                                line: 142,
                                column: 16,
                                fixed: true,
                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                            }
                        }
                    },
                    properties: [{
                            type: 'Property',
                            key: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'module',
                                    loc: {
                                        start: {
                                            line: 143,
                                            column: 9,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                        },
                                        end: {
                                            line: 143,
                                            column: 15,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'id',
                                    loc: {
                                        start: {
                                            line: 143,
                                            column: 16,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                        },
                                        end: {
                                            line: 143,
                                            column: 18,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 143,
                                        column: 9,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                    },
                                    end: {
                                        line: 143,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'BinaryExpression',
                                operator: '+',
                                left: {
                                    type: 'BinaryExpression',
                                    operator: '+',
                                    left: {
                                        type: 'BinaryExpression',
                                        operator: '+',
                                        left: {
                                            type: 'BinaryExpression',
                                            operator: '+',
                                            left: {
                                                type: 'BinaryExpression',
                                                operator: '+',
                                                left: {
                                                    type: 'BinaryExpression',
                                                    operator: '+',
                                                    left: {
                                                        type: 'BinaryExpression',
                                                        operator: '+',
                                                        left: {
                                                            type: 'BinaryExpression',
                                                            operator: '+',
                                                            left: {
                                                                type: 'Literal',
                                                                value: '.TimelineColumn2.header .move {\n    width: '
                                                            },
                                                            right: {
                                                                type: 'Identifier',
                                                                name: 'moveWidth',
                                                                loc: {
                                                                    start: {
                                                                        line: 145,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 145,
                                                                        column: 34,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    }
                                                                }
                                                            }
                                                        },
                                                        right: {
                                                            type: 'Literal',
                                                            value: 'px;\n    min-width: '
                                                        }
                                                    },
                                                    right: {
                                                        type: 'Identifier',
                                                        name: 'moveWidth',
                                                        loc: {
                                                            start: {
                                                                line: 146,
                                                                column: 29,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                            },
                                                            end: {
                                                                line: 146,
                                                                column: 38,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                            }
                                                        }
                                                    }
                                                },
                                                right: {
                                                    type: 'Literal',
                                                    value: 'px;\n}\n.TimelineColumn2.cell {\n    position: relative;\n}\n.TimelineColumn2.header .small.column:not(.scheduled) {\n    opacity: 0.60;\n}\n.TimelineColumn2.header .small.column {\n    border-left: solid 1px rgba(0,0,0,'
                                                }
                                            },
                                            right: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'style',
                                                        loc: {
                                                            start: {
                                                                line: 155,
                                                                column: 52,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                            },
                                                            end: {
                                                                line: 155,
                                                                column: 57,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'opacity',
                                                        loc: {
                                                            start: {
                                                                line: 155,
                                                                column: 58,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                            },
                                                            end: {
                                                                line: 155,
                                                                column: 65,
                                                                fixed: true,
                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 155,
                                                            column: 52,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                        },
                                                        end: {
                                                            line: 155,
                                                            column: 65,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'hint',
                                                    loc: {
                                                        start: {
                                                            line: 155,
                                                            column: 66,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                        },
                                                        end: {
                                                            line: 155,
                                                            column: 70,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 155,
                                                        column: 52,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                    },
                                                    end: {
                                                        line: 155,
                                                        column: 70,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                    }
                                                }
                                            }
                                        },
                                        right: {
                                            type: 'Literal',
                                            value: ');\n    flex-basis: 10px;\n    flex-grow: 1;\n}\n.TimelineColumn2.header .small.column:last-child {\n    border-right: solid 1px rgba(0,0,0,'
                                        }
                                    },
                                    right: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'style',
                                                loc: {
                                                    start: {
                                                        line: 160,
                                                        column: 53,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                    },
                                                    end: {
                                                        line: 160,
                                                        column: 58,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'opacity',
                                                loc: {
                                                    start: {
                                                        line: 160,
                                                        column: 59,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                    },
                                                    end: {
                                                        line: 160,
                                                        column: 66,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 160,
                                                    column: 53,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                },
                                                end: {
                                                    line: 160,
                                                    column: 66,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'hint',
                                            loc: {
                                                start: {
                                                    line: 160,
                                                    column: 67,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                },
                                                end: {
                                                    line: 160,
                                                    column: 71,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 160,
                                                column: 53,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                            },
                                            end: {
                                                line: 160,
                                                column: 71,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                            }
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: ');\n}'
                                }
                            },
                            kind: 'init',
                            computed: true,
                            order: '0'
                        }]
                },
                loc: {
                    start: {
                        line: 142,
                        column: 4,
                        fixed: true,
                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                    },
                    end: {
                        line: 163,
                        column: 8,
                        fixed: true,
                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                    }
                },
                order: '0'
            }],
        bound: false
    }, {
        this: this,
        module: module,
        glass: glass,
        _ref: _ref,
        _ref2: _ref2,
        _ref3: _ref3,
        _ref4: _ref4,
        DefaultColumn: DefaultColumn,
        headerFont1: headerFont1,
        headerFont2: headerFont2,
        getMiddleDate: getMiddleDate,
        jsonValueToDisplayValue: jsonValueToDisplayValue,
        Schema: Schema,
        style: style,
        Icon: Icon,
        zoomUnits: zoomUnits,
        zoomLevels: zoomLevels,
        zoomLevelNames: zoomLevelNames,
        getBigColumns: getBigColumns,
        getSmallColumns: getSmallColumns,
        moveWidth: moveWidth,
        headerPadding: headerPadding
    }, null);
})().observe();
var headerPadding = 10;
module.exports = exports = ion.template(function TimelineColumn(property, options) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'TimelineColumn',
            loc: {
                start: {
                    line: 165,
                    column: 16,
                    fixed: true,
                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                },
                end: {
                    line: 165,
                    column: 30,
                    fixed: true,
                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                }
            }
        },
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'state',
                            loc: {
                                start: {
                                    line: 166,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                },
                                end: {
                                    line: 166,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Function',
                                context: true,
                                value: function (_context) {
                                    return function () {
                                        var options = _context.get('options'), property = _context.get('property');
                                        return options.state[property.name] = options.state[property.name] != null ? options.state[property.name] : {};
                                    };
                                }
                            },
                            arguments: [],
                            loc: {
                                start: {
                                    line: 166,
                                    column: 16,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                },
                                end: {
                                    line: 166,
                                    column: 56,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'CallExpression',
                        callee: {
                            type: 'Identifier',
                            name: 'DefaultColumn',
                            loc: {
                                start: {
                                    line: 167,
                                    column: 11,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                },
                                end: {
                                    line: 167,
                                    column: 24,
                                    fixed: true,
                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                }
                            }
                        },
                        arguments: [{
                                type: 'Identifier',
                                name: 'property',
                                loc: {
                                    start: {
                                        line: 167,
                                        column: 25,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                    },
                                    end: {
                                        line: 167,
                                        column: 33,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                    }
                                }
                            }],
                        loc: {
                            start: {
                                line: 167,
                                column: 11,
                                fixed: true,
                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                            },
                            end: {
                                line: 167,
                                column: 34,
                                fixed: true,
                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                            }
                        }
                    },
                    properties: [
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'minimumWidth',
                                loc: {
                                    start: {
                                        line: 168,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                    },
                                    end: {
                                        line: 168,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Literal',
                                value: 200
                            },
                            kind: 'init',
                            order: '0'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'defaultWidth',
                                loc: {
                                    start: {
                                        line: 169,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                    },
                                    end: {
                                        line: 169,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Literal',
                                value: 400
                            },
                            kind: 'init',
                            order: '1'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'clicksToEdit',
                                loc: {
                                    start: {
                                        line: 170,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                    },
                                    end: {
                                        line: 170,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Literal',
                                value: 0
                            },
                            kind: 'init',
                            order: '2'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'canEdit',
                                loc: {
                                    start: {
                                        line: 171,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                    },
                                    end: {
                                        line: 171,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: false,
                                value: function (dataTableModel, object) {
                                    return false;
                                }
                            },
                            kind: 'init',
                            order: '3'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'currentZoomIndex',
                                        loc: {
                                            start: {
                                                line: 172,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                            },
                                            end: {
                                                line: 172,
                                                column: 28,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'Function',
                                            context: true,
                                            value: function (_context2) {
                                                return function (state) {
                                                    var zoomLevels = _context2.get('zoomLevels');
                                                    var value = state.zoom;
                                                    if (typeof value !== 'number' || value < 0 || value >= zoomLevels.length) {
                                                        value = 2;
                                                    }
                                                    return value;
                                                };
                                            }
                                        },
                                        arguments: [{
                                                type: 'Identifier',
                                                name: 'state',
                                                loc: {
                                                    start: {
                                                        line: 172,
                                                        column: 35,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                    },
                                                    end: {
                                                        line: 172,
                                                        column: 40,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                    }
                                                }
                                            }],
                                        loc: {
                                            start: {
                                                line: 172,
                                                column: 31,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                            },
                                            end: {
                                                line: 177,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '4'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'canZoomIn',
                                loc: {
                                    start: {
                                        line: 177,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                    },
                                    end: {
                                        line: 177,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'BinaryExpression',
                                operator: '>',
                                left: {
                                    type: 'Identifier',
                                    name: 'currentZoomIndex',
                                    loc: {
                                        start: {
                                            line: 177,
                                            column: 19,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                        },
                                        end: {
                                            line: 177,
                                            column: 35,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: 0
                                }
                            },
                            kind: 'init',
                            order: '5'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'canZoomOut',
                                loc: {
                                    start: {
                                        line: 178,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                    },
                                    end: {
                                        line: 178,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'BinaryExpression',
                                operator: '<',
                                left: {
                                    type: 'Identifier',
                                    name: 'currentZoomIndex',
                                    loc: {
                                        start: {
                                            line: 178,
                                            column: 20,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                        },
                                        end: {
                                            line: 178,
                                            column: 36,
                                            fixed: true,
                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                        }
                                    }
                                },
                                right: {
                                    type: 'BinaryExpression',
                                    operator: '-',
                                    left: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'zoomLevels',
                                            loc: {
                                                start: {
                                                    line: 178,
                                                    column: 39,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                },
                                                end: {
                                                    line: 178,
                                                    column: 49,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'length',
                                            loc: {
                                                start: {
                                                    line: 178,
                                                    column: 50,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                },
                                                end: {
                                                    line: 178,
                                                    column: 56,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 178,
                                                column: 39,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                            },
                                            end: {
                                                line: 178,
                                                column: 56,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                            }
                                        }
                                    },
                                    right: {
                                        type: 'Literal',
                                        value: 1
                                    }
                                }
                            },
                            kind: 'init',
                            order: '6'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'zoom',
                                        loc: {
                                            start: {
                                                line: 179,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                            },
                                            end: {
                                                line: 179,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'MemberExpression',
                                        computed: true,
                                        object: {
                                            type: 'Identifier',
                                            name: 'zoomLevels',
                                            loc: {
                                                start: {
                                                    line: 179,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                },
                                                end: {
                                                    line: 179,
                                                    column: 29,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'currentZoomIndex',
                                            loc: {
                                                start: {
                                                    line: 179,
                                                    column: 30,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                },
                                                end: {
                                                    line: 179,
                                                    column: 46,
                                                    fixed: true,
                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 179,
                                                column: 19,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                            },
                                            end: {
                                                line: 179,
                                                column: 47,
                                                fixed: true,
                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '7'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'zoom',
                                loc: {
                                    start: {
                                        line: 180,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                    },
                                    end: {
                                        line: 180,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Identifier',
                                name: 'zoom',
                                loc: {
                                    start: {
                                        line: 180,
                                        column: 14,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                    },
                                    end: {
                                        line: 180,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                    }
                                }
                            },
                            kind: 'init',
                            order: '8'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'zoomIn',
                                loc: {
                                    start: {
                                        line: 181,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                    },
                                    end: {
                                        line: 181,
                                        column: 14,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context3) {
                                    return function (offset) {
                                        if (offset == null)
                                            offset = -1;
                                        var currentZoomIndex = _context3.get('currentZoomIndex'), zoomLevels = _context3.get('zoomLevels'), state = _context3.get('state');
                                        var index = Math.min(Math.max(0, currentZoomIndex + offset), zoomLevels.length - 1);
                                        state.zoom = index;
                                    };
                                }
                            },
                            kind: 'init',
                            order: '9'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'zoomOut',
                                loc: {
                                    start: {
                                        line: 184,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                    },
                                    end: {
                                        line: 184,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: false,
                                value: function () {
                                    this.zoomIn(+1);
                                }
                            },
                            kind: 'init',
                            order: ':'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'createCssRules',
                                loc: {
                                    start: {
                                        line: 186,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                    },
                                    end: {
                                        line: 186,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context4) {
                                    return function (dataTableModel) {
                                        var headerPadding = _context4.get('headerPadding');
                                        return { '': 'box-sizing: content-box;\npadding-left: ' + headerPadding + 'px;\npadding-right: ' + headerPadding + 'px;\nborder-left: solid 1px rgba(0,0,0,0.12);' };
                                    };
                                }
                            },
                            kind: 'init',
                            order: ';'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'createHeaderCell',
                                loc: {
                                    start: {
                                        line: 194,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                    },
                                    end: {
                                        line: 194,
                                        column: 24,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_ps) {
                                    return ion.template(function (dataTableModel) {
                                        return ion.createRuntime({
                                            type: 'Template',
                                            id: null,
                                            body: [
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'column',
                                                                loc: {
                                                                    start: {
                                                                        line: 195,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 195,
                                                                        column: 22,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: { type: 'ThisExpression' }
                                                        }],
                                                    kind: 'let',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'zoomLevel',
                                                                loc: {
                                                                    start: {
                                                                        line: 196,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 196,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'MemberExpression',
                                                                computed: true,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'zoomLevels',
                                                                    loc: {
                                                                        start: {
                                                                            line: 196,
                                                                            column: 28,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 196,
                                                                            column: 38,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'currentZoomIndex',
                                                                    loc: {
                                                                        start: {
                                                                            line: 196,
                                                                            column: 39,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 196,
                                                                            column: 55,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 196,
                                                                        column: 28,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 196,
                                                                        column: 56,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '1'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'zoom',
                                                                loc: {
                                                                    start: {
                                                                        line: 197,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 197,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: { type: 'ThisExpression' },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'zoom',
                                                                    loc: {
                                                                        start: {
                                                                            line: 197,
                                                                            column: 28,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 197,
                                                                            column: 32,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 197,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 197,
                                                                        column: 32,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '2'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'unit',
                                                                loc: {
                                                                    start: {
                                                                        line: 198,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 198,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'MemberExpression',
                                                                computed: true,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'zoomUnits',
                                                                    loc: {
                                                                        start: {
                                                                            line: 198,
                                                                            column: 23,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 198,
                                                                            column: 32,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'zoom',
                                                                        loc: {
                                                                            start: {
                                                                                line: 198,
                                                                                column: 33,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 198,
                                                                                column: 37,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'unit',
                                                                        loc: {
                                                                            start: {
                                                                                line: 198,
                                                                                column: 38,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 198,
                                                                                column: 42,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 198,
                                                                            column: 33,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 198,
                                                                            column: 42,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 198,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 198,
                                                                        column: 43,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '3'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'date',
                                                                loc: {
                                                                    start: {
                                                                        line: 199,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 199,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'ConditionalExpression',
                                                                test: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'state',
                                                                        loc: {
                                                                            start: {
                                                                                line: 199,
                                                                                column: 23,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 199,
                                                                                column: 28,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'date',
                                                                        loc: {
                                                                            start: {
                                                                                line: 199,
                                                                                column: 29,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 199,
                                                                                column: 33,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 199,
                                                                            column: 23,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 199,
                                                                            column: 33,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                consequent: {
                                                                    type: 'NewExpression',
                                                                    callee: {
                                                                        type: 'Identifier',
                                                                        name: 'Date',
                                                                        loc: {
                                                                            start: {
                                                                                line: 199,
                                                                                column: 40,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 199,
                                                                                column: 44,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [{
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'state',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 199,
                                                                                        column: 45,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 199,
                                                                                        column: 50,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'date',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 199,
                                                                                        column: 51,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 199,
                                                                                        column: 55,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 199,
                                                                                    column: 45,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 199,
                                                                                    column: 55,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                }
                                                                            }
                                                                        }],
                                                                    loc: {
                                                                        start: {
                                                                            line: 199,
                                                                            column: 36,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 199,
                                                                            column: 56,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                alternate: {
                                                                    type: 'NewExpression',
                                                                    callee: {
                                                                        type: 'Identifier',
                                                                        name: 'Date',
                                                                        loc: {
                                                                            start: {
                                                                                line: 199,
                                                                                column: 63,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 199,
                                                                                column: 67,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [],
                                                                    loc: {
                                                                        start: {
                                                                            line: 199,
                                                                            column: 59,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 199,
                                                                            column: 69,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '4'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'bigColumns',
                                                                loc: {
                                                                    start: {
                                                                        line: 200,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 200,
                                                                        column: 26,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Identifier',
                                                                    name: 'getBigColumns',
                                                                    loc: {
                                                                        start: {
                                                                            line: 200,
                                                                            column: 29,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 200,
                                                                            column: 42,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'ObjectExpression',
                                                                        properties: [
                                                                            {
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'date',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 200,
                                                                                            column: 44,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 200,
                                                                                            column: 48,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Identifier',
                                                                                    name: 'date',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 200,
                                                                                            column: 44,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 200,
                                                                                            column: 48,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                kind: 'init',
                                                                                order: '0'
                                                                            },
                                                                            {
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'zoom',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 200,
                                                                                            column: 50,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 200,
                                                                                            column: 54,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Identifier',
                                                                                    name: 'zoom',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 200,
                                                                                            column: 50,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 200,
                                                                                            column: 54,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                kind: 'init',
                                                                                order: '1'
                                                                            }
                                                                        ]
                                                                    }],
                                                                loc: {
                                                                    start: {
                                                                        line: 200,
                                                                        column: 29,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 200,
                                                                        column: 56,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '5'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'start',
                                                                loc: {
                                                                    start: {
                                                                        line: 201,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 201,
                                                                        column: 21,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'MemberExpression',
                                                                    computed: true,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'bigColumns',
                                                                        loc: {
                                                                            start: {
                                                                                line: 201,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 201,
                                                                                column: 34,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Literal',
                                                                        value: 0
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 201,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 201,
                                                                            column: 37,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'start',
                                                                    loc: {
                                                                        start: {
                                                                            line: 201,
                                                                            column: 38,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 201,
                                                                            column: 43,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 201,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 201,
                                                                        column: 43,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '6'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'finish',
                                                                loc: {
                                                                    start: {
                                                                        line: 202,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 202,
                                                                        column: 22,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'MemberExpression',
                                                                    computed: true,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'bigColumns',
                                                                        loc: {
                                                                            start: {
                                                                                line: 202,
                                                                                column: 25,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 202,
                                                                                column: 35,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'BinaryExpression',
                                                                        operator: '-',
                                                                        left: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'bigColumns',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 202,
                                                                                        column: 36,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 202,
                                                                                        column: 46,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'length',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 202,
                                                                                        column: 47,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 202,
                                                                                        column: 53,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 202,
                                                                                    column: 36,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 202,
                                                                                    column: 53,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        right: {
                                                                            type: 'Literal',
                                                                            value: 1
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 202,
                                                                            column: 25,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 202,
                                                                            column: 58,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'finish',
                                                                    loc: {
                                                                        start: {
                                                                            line: 202,
                                                                            column: 59,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 202,
                                                                            column: 65,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 202,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 202,
                                                                        column: 65,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '7'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'next',
                                                                loc: {
                                                                    start: {
                                                                        line: 204,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 204,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'Function',
                                                                context: true,
                                                                value: function (_context5) {
                                                                    return function (e) {
                                                                        var state = _context5.get('state'), unit = _context5.get('unit'), date = _context5.get('date');
                                                                        e.stopPropagation();
                                                                        state.date = unit.getNext({ date: date }).toISOString();
                                                                    };
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '8'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'previous',
                                                                loc: {
                                                                    start: {
                                                                        line: 207,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 207,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'Function',
                                                                context: true,
                                                                value: function (_context6) {
                                                                    return function (e) {
                                                                        var state = _context6.get('state'), unit = _context6.get('unit'), date = _context6.get('date');
                                                                        e.stopPropagation();
                                                                        state.date = unit.getPrevious({ date: date }).toISOString();
                                                                    };
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '9'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'centerWidth',
                                                                loc: {
                                                                    start: {
                                                                        line: 210,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 210,
                                                                        column: 27,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'center',
                                                                    loc: {
                                                                        start: {
                                                                            line: 210,
                                                                            column: 30,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 210,
                                                                            column: 36,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'clientWidth',
                                                                    loc: {
                                                                        start: {
                                                                            line: 210,
                                                                            column: 37,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 210,
                                                                            column: 48,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 210,
                                                                        column: 30,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 210,
                                                                        column: 48,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: ':'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'getPositionX',
                                                                loc: {
                                                                    start: {
                                                                        line: 211,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 211,
                                                                        column: 28,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'Function',
                                                                context: true,
                                                                value: function (_context7) {
                                                                    return function (value) {
                                                                        var start = _context7.get('start'), finish = _context7.get('finish'), centerWidth = _context7.get('centerWidth');
                                                                        if (!(value != null)) {
                                                                            return -1000;
                                                                        }
                                                                        var s = start.getTime();
                                                                        var f = finish.getTime();
                                                                        var date = Date.create(value);
                                                                        value = date.getTime();
                                                                        var left = Math.floor((value - s) / (f - s) * centerWidth);
                                                                        return left;
                                                                    };
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: ';'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'header',
                                                                loc: {
                                                                    start: {
                                                                        line: 221,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 221,
                                                                        column: 22,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Identifier',
                                                                    name: 'Span',
                                                                    loc: {
                                                                        start: {
                                                                            line: 221,
                                                                            column: 25,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 221,
                                                                            column: 29,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'ObjectExpression',
                                                                        properties: [{
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'class',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 221,
                                                                                            column: 31,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 221,
                                                                                            column: 36,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Literal',
                                                                                    value: 'TimelineColumn2 header'
                                                                                },
                                                                                kind: 'init',
                                                                                order: '0'
                                                                            }]
                                                                    }],
                                                                loc: {
                                                                    start: {
                                                                        line: 221,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 221,
                                                                        column: 63,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '<'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'center',
                                                                loc: {
                                                                    start: {
                                                                        line: 222,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 222,
                                                                        column: 22,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Identifier',
                                                                    name: 'Div',
                                                                    loc: {
                                                                        start: {
                                                                            line: 222,
                                                                            column: 25,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 222,
                                                                            column: 28,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'ObjectExpression',
                                                                        properties: [{
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'class',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 222,
                                                                                            column: 30,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 222,
                                                                                            column: 35,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Literal',
                                                                                    value: 'flex layout vertical'
                                                                                },
                                                                                kind: 'init',
                                                                                order: '0'
                                                                            }]
                                                                    }],
                                                                loc: {
                                                                    start: {
                                                                        line: 222,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 222,
                                                                        column: 60,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '='
                                                },
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'Identifier',
                                                            name: 'column',
                                                            loc: {
                                                                start: {
                                                                    line: 223,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                },
                                                                end: {
                                                                    line: 223,
                                                                    column: 18,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'bigColumns',
                                                                    loc: {
                                                                        start: {
                                                                            line: 224,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 224,
                                                                            column: 26,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Identifier',
                                                                    name: 'bigColumns',
                                                                    loc: {
                                                                        start: {
                                                                            line: 224,
                                                                            column: 28,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 224,
                                                                            column: 38,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'smallColumns',
                                                                    loc: {
                                                                        start: {
                                                                            line: 225,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 225,
                                                                            column: 28,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'ObjectExpression',
                                                                    objectType: {
                                                                        type: 'ArrayExpression',
                                                                        elements: []
                                                                    },
                                                                    properties: [{
                                                                            type: 'ForOfStatement',
                                                                            left: {
                                                                                type: 'VariableDeclaration',
                                                                                declarations: [{
                                                                                        type: 'VariableDeclarator',
                                                                                        id: {
                                                                                            type: 'Identifier',
                                                                                            name: 'bigColumn',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 226,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 226,
                                                                                                    column: 33,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        init: null
                                                                                    }],
                                                                                kind: 'let'
                                                                            },
                                                                            right: {
                                                                                type: 'Identifier',
                                                                                name: 'bigColumns',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 226,
                                                                                        column: 37,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 226,
                                                                                        column: 47,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            body: {
                                                                                type: 'BlockStatement',
                                                                                body: [{
                                                                                        type: 'ForOfStatement',
                                                                                        left: {
                                                                                            type: 'VariableDeclaration',
                                                                                            declarations: [{
                                                                                                    type: 'VariableDeclarator',
                                                                                                    id: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'smallColumn',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 227,
                                                                                                                column: 28,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 227,
                                                                                                                column: 39,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    init: null
                                                                                                }],
                                                                                            kind: 'let'
                                                                                        },
                                                                                        right: {
                                                                                            type: 'MemberExpression',
                                                                                            computed: false,
                                                                                            object: {
                                                                                                type: 'Identifier',
                                                                                                name: 'bigColumn',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 227,
                                                                                                        column: 43,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 227,
                                                                                                        column: 52,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            property: {
                                                                                                type: 'Identifier',
                                                                                                name: 'subcolumns',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 227,
                                                                                                        column: 53,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 227,
                                                                                                        column: 63,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 227,
                                                                                                    column: 43,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 227,
                                                                                                    column: 63,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        body: {
                                                                                            type: 'BlockStatement',
                                                                                            body: [{
                                                                                                    type: 'ExpressionStatement',
                                                                                                    expression: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'smallColumn',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 228,
                                                                                                                column: 28,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 228,
                                                                                                                column: 39,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 228,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 228,
                                                                                                            column: 39,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                        }
                                                                                                    },
                                                                                                    order: '0'
                                                                                                }]
                                                                                        },
                                                                                        remove: null,
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            remove: null,
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                kind: 'init',
                                                                order: '1'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'start',
                                                                    loc: {
                                                                        start: {
                                                                            line: 229,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 229,
                                                                            column: 21,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'start',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 229,
                                                                                    column: 23,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 229,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'toISOString',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 229,
                                                                                    column: 29,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 229,
                                                                                    column: 40,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 229,
                                                                                column: 23,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 229,
                                                                                column: 40,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [],
                                                                    loc: {
                                                                        start: {
                                                                            line: 229,
                                                                            column: 23,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 229,
                                                                            column: 42,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '2'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'finish',
                                                                    loc: {
                                                                        start: {
                                                                            line: 230,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 230,
                                                                            column: 22,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'finish',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 230,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 230,
                                                                                    column: 30,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'toISOString',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 230,
                                                                                    column: 31,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 230,
                                                                                    column: 42,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 230,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 230,
                                                                                column: 42,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [],
                                                                    loc: {
                                                                        start: {
                                                                            line: 230,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 230,
                                                                            column: 44,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '3'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'getDate',
                                                                    loc: {
                                                                        start: {
                                                                            line: 231,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 231,
                                                                            column: 23,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Function',
                                                                    context: true,
                                                                    value: function (_context8) {
                                                                        return function (x) {
                                                                            var moveWidth = _context8.get('moveWidth'), headerPadding = _context8.get('headerPadding'), centerWidth = _context8.get('centerWidth'), start = _context8.get('start'), finish = _context8.get('finish');
                                                                            var alpha = (x - moveWidth - headerPadding) / centerWidth;
                                                                            alpha = Math.min(1, Math.max(0, alpha));
                                                                            var startTime = start.getTime();
                                                                            var finishTime = finish.getTime();
                                                                            var time = Math.round(startTime + (finishTime - startTime) * alpha);
                                                                            return new Date(time);
                                                                        };
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '4'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'getComponentLeft',
                                                                    loc: {
                                                                        start: {
                                                                            line: 238,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 238,
                                                                            column: 32,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Function',
                                                                    context: true,
                                                                    value: function (_context9) {
                                                                        return function (value) {
                                                                            var getPositionX = _context9.get('getPositionX'), centerWidth = _context9.get('centerWidth'), moveWidth = _context9.get('moveWidth');
                                                                            var x = getPositionX(value);
                                                                            if (x < 0) {
                                                                                return 0;
                                                                            }
                                                                            if (x > centerWidth) {
                                                                                return moveWidth + centerWidth;
                                                                            }
                                                                            return moveWidth + x;
                                                                        };
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '5'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'getComponentRight',
                                                                    loc: {
                                                                        start: {
                                                                            line: 245,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 245,
                                                                            column: 33,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Function',
                                                                    context: true,
                                                                    value: function (_context10) {
                                                                        return function (value) {
                                                                            var getPositionX = _context10.get('getPositionX'), moveWidth = _context10.get('moveWidth'), centerWidth = _context10.get('centerWidth');
                                                                            var x = getPositionX(value);
                                                                            if (x < 0) {
                                                                                return moveWidth - 2;
                                                                            }
                                                                            if (x > centerWidth) {
                                                                                return moveWidth + centerWidth + moveWidth;
                                                                            }
                                                                            return moveWidth + x;
                                                                        };
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '6'
                                                            }
                                                        ]
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 223,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                        },
                                                        end: {
                                                            line: 252,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                        }
                                                    },
                                                    order: '>'
                                                },
                                                {
                                                    type: 'ReturnStatement',
                                                    argument: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'Identifier',
                                                            name: 'header',
                                                            loc: {
                                                                start: {
                                                                    line: 252,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                },
                                                                end: {
                                                                    line: 252,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'ObjectExpression',
                                                                    objectType: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'Identifier',
                                                                            name: 'Div',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 258,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 258,
                                                                                    column: 19,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [{
                                                                                type: 'ObjectExpression',
                                                                                properties: [{
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'class',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 258,
                                                                                                    column: 21,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 258,
                                                                                                    column: 26,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 'move layout center center-justified'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    }]
                                                                            }],
                                                                        loc: {
                                                                            start: {
                                                                                line: 258,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 258,
                                                                                column: 66,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    properties: [{
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'ObjectExpression',
                                                                                objectType: {
                                                                                    type: 'CallExpression',
                                                                                    callee: {
                                                                                        type: 'Identifier',
                                                                                        name: 'Icon',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 259,
                                                                                                column: 20,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 259,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    arguments: [{
                                                                                            type: 'ObjectExpression',
                                                                                            properties: [
                                                                                                {
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'name',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 259,
                                                                                                                column: 26,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 259,
                                                                                                                column: 30,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'Literal',
                                                                                                        value: 'play arrow'
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '0'
                                                                                                },
                                                                                                {
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'size',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 259,
                                                                                                                column: 44,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 259,
                                                                                                                column: 48,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'Literal',
                                                                                                        value: 32
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '1'
                                                                                                }
                                                                                            ]
                                                                                        }],
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 259,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 259,
                                                                                            column: 53,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                properties: [
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'style',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 260,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 260,
                                                                                                    column: 29,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'ObjectExpression',
                                                                                            properties: [{
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'transform',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 261,
                                                                                                                column: 28,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 261,
                                                                                                                column: 37,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'Literal',
                                                                                                        value: 'rotate(180deg)'
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '0'
                                                                                                }]
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'Function',
                                                                                            context: true,
                                                                                            value: function (_context11) {
                                                                                                return function click(e) {
                                                                                                    var previous = _context11.get('previous');
                                                                                                    return previous(e);
                                                                                                };
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 262,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 262,
                                                                                                column: 47,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '1'
                                                                                    }
                                                                                ]
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 259,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 263,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 258,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 263,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'ObjectExpression',
                                                                    objectType: {
                                                                        type: 'Identifier',
                                                                        name: 'center',
                                                                        loc: {
                                                                            start: {
                                                                                line: 263,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 263,
                                                                                column: 22,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    properties: [{
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'ObjectExpression',
                                                                                objectType: {
                                                                                    type: 'CallExpression',
                                                                                    callee: {
                                                                                        type: 'Identifier',
                                                                                        name: 'Div',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 264,
                                                                                                column: 20,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 264,
                                                                                                column: 23,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    arguments: [{
                                                                                            type: 'ObjectExpression',
                                                                                            properties: [{
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'class',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 264,
                                                                                                                column: 25,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 264,
                                                                                                                column: 30,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'Literal',
                                                                                                        value: 'flex layout horizontal'
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '0'
                                                                                                }]
                                                                                        }],
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 264,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 264,
                                                                                            column: 57,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                properties: [{
                                                                                        type: 'ForOfStatement',
                                                                                        left: {
                                                                                            type: 'VariableDeclaration',
                                                                                            declarations: [{
                                                                                                    type: 'VariableDeclarator',
                                                                                                    id: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'bigColumn',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 265,
                                                                                                                column: 28,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 265,
                                                                                                                column: 37,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    init: null
                                                                                                }],
                                                                                            kind: 'let'
                                                                                        },
                                                                                        right: {
                                                                                            type: 'Identifier',
                                                                                            name: 'bigColumns',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 265,
                                                                                                    column: 41,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 265,
                                                                                                    column: 51,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        body: {
                                                                                            type: 'BlockStatement',
                                                                                            body: [{
                                                                                                    type: 'ExpressionStatement',
                                                                                                    expression: {
                                                                                                        type: 'ObjectExpression',
                                                                                                        objectType: {
                                                                                                            type: 'CallExpression',
                                                                                                            callee: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'Div',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 266,
                                                                                                                        column: 28,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 266,
                                                                                                                        column: 31,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            arguments: [{
                                                                                                                    type: 'ObjectExpression',
                                                                                                                    properties: [{
                                                                                                                            type: 'Property',
                                                                                                                            key: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'class',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 266,
                                                                                                                                        column: 33,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 266,
                                                                                                                                        column: 38,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            value: {
                                                                                                                                type: 'Literal',
                                                                                                                                value: 'column layout borderLeft vertical fill'
                                                                                                                            },
                                                                                                                            kind: 'init',
                                                                                                                            order: '0'
                                                                                                                        }]
                                                                                                                }],
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 266,
                                                                                                                    column: 28,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 266,
                                                                                                                    column: 81,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        properties: [
                                                                                                            {
                                                                                                                type: 'ExpressionStatement',
                                                                                                                expression: {
                                                                                                                    type: 'ObjectExpression',
                                                                                                                    objectType: {
                                                                                                                        type: 'CallExpression',
                                                                                                                        callee: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'Div',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 267,
                                                                                                                                    column: 32,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 267,
                                                                                                                                    column: 35,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        arguments: [{
                                                                                                                                type: 'ObjectExpression',
                                                                                                                                properties: [{
                                                                                                                                        type: 'Property',
                                                                                                                                        key: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'class',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 267,
                                                                                                                                                    column: 37,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 267,
                                                                                                                                                    column: 42,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        value: {
                                                                                                                                            type: 'Literal',
                                                                                                                                            value: 'flex layout center center-justified'
                                                                                                                                        },
                                                                                                                                        kind: 'init',
                                                                                                                                        order: '0'
                                                                                                                                    }]
                                                                                                                            }],
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 267,
                                                                                                                                column: 32,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 267,
                                                                                                                                column: 82,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    properties: [
                                                                                                                        {
                                                                                                                            type: 'Property',
                                                                                                                            key: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'style',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 268,
                                                                                                                                        column: 36,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 268,
                                                                                                                                        column: 41,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            value: {
                                                                                                                                type: 'ObjectExpression',
                                                                                                                                properties: [{
                                                                                                                                        type: 'Property',
                                                                                                                                        key: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'font',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 269,
                                                                                                                                                    column: 40,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 269,
                                                                                                                                                    column: 44,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        value: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'headerFont1',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 269,
                                                                                                                                                    column: 46,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 269,
                                                                                                                                                    column: 57,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        kind: 'init',
                                                                                                                                        order: '0'
                                                                                                                                    }]
                                                                                                                            },
                                                                                                                            kind: 'init',
                                                                                                                            order: '0'
                                                                                                                        },
                                                                                                                        {
                                                                                                                            type: 'ExpressionStatement',
                                                                                                                            expression: {
                                                                                                                                type: 'MemberExpression',
                                                                                                                                computed: false,
                                                                                                                                object: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'bigColumn',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 270,
                                                                                                                                            column: 36,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 270,
                                                                                                                                            column: 45,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                property: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'title',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 270,
                                                                                                                                            column: 46,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 270,
                                                                                                                                            column: 51,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 270,
                                                                                                                                        column: 36,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 270,
                                                                                                                                        column: 51,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 270,
                                                                                                                                    column: 36,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 270,
                                                                                                                                    column: 51,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                }
                                                                                                                            },
                                                                                                                            order: '1'
                                                                                                                        }
                                                                                                                    ]
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 267,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 271,
                                                                                                                        column: 36,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                    }
                                                                                                                },
                                                                                                                order: '0'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'ExpressionStatement',
                                                                                                                expression: {
                                                                                                                    type: 'ObjectExpression',
                                                                                                                    objectType: {
                                                                                                                        type: 'CallExpression',
                                                                                                                        callee: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'Div',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 271,
                                                                                                                                    column: 32,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 271,
                                                                                                                                    column: 35,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        arguments: [{
                                                                                                                                type: 'ObjectExpression',
                                                                                                                                properties: [{
                                                                                                                                        type: 'Property',
                                                                                                                                        key: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'class',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 271,
                                                                                                                                                    column: 37,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 271,
                                                                                                                                                    column: 42,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        value: {
                                                                                                                                            type: 'Literal',
                                                                                                                                            value: 'flex layout horizontal'
                                                                                                                                        },
                                                                                                                                        kind: 'init',
                                                                                                                                        order: '0'
                                                                                                                                    }]
                                                                                                                            }],
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 271,
                                                                                                                                column: 32,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 271,
                                                                                                                                column: 69,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    properties: [
                                                                                                                        {
                                                                                                                            type: 'Property',
                                                                                                                            key: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'style',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 272,
                                                                                                                                        column: 36,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 272,
                                                                                                                                        column: 41,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            value: {
                                                                                                                                type: 'ObjectExpression',
                                                                                                                                properties: [{
                                                                                                                                        type: 'Property',
                                                                                                                                        key: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'font',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 273,
                                                                                                                                                    column: 40,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 273,
                                                                                                                                                    column: 44,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        value: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'headerFont2',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 273,
                                                                                                                                                    column: 46,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 273,
                                                                                                                                                    column: 57,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        kind: 'init',
                                                                                                                                        order: '0'
                                                                                                                                    }]
                                                                                                                            },
                                                                                                                            kind: 'init',
                                                                                                                            order: '0'
                                                                                                                        },
                                                                                                                        {
                                                                                                                            type: 'ForOfStatement',
                                                                                                                            left: {
                                                                                                                                type: 'VariableDeclaration',
                                                                                                                                declarations: [{
                                                                                                                                        type: 'VariableDeclarator',
                                                                                                                                        id: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'subcolumn',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 274,
                                                                                                                                                    column: 40,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 274,
                                                                                                                                                    column: 49,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        init: null
                                                                                                                                    }],
                                                                                                                                kind: 'let'
                                                                                                                            },
                                                                                                                            right: {
                                                                                                                                type: 'MemberExpression',
                                                                                                                                computed: false,
                                                                                                                                object: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'bigColumn',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 274,
                                                                                                                                            column: 53,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 274,
                                                                                                                                            column: 62,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                property: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'subcolumns',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 274,
                                                                                                                                            column: 63,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 274,
                                                                                                                                            column: 73,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 274,
                                                                                                                                        column: 53,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 274,
                                                                                                                                        column: 73,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            body: {
                                                                                                                                type: 'BlockStatement',
                                                                                                                                body: [{
                                                                                                                                        type: 'ExpressionStatement',
                                                                                                                                        expression: {
                                                                                                                                            type: 'ObjectExpression',
                                                                                                                                            objectType: {
                                                                                                                                                type: 'CallExpression',
                                                                                                                                                callee: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'Div',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 275,
                                                                                                                                                            column: 40,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 275,
                                                                                                                                                            column: 43,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                arguments: [{
                                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                                        properties: [{
                                                                                                                                                                type: 'Property',
                                                                                                                                                                key: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'class',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 275,
                                                                                                                                                                            column: 45,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 275,
                                                                                                                                                                            column: 50,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                value: {
                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                    value: 'small flex column layout center center-justified'
                                                                                                                                                                },
                                                                                                                                                                kind: 'init',
                                                                                                                                                                order: '0'
                                                                                                                                                            }]
                                                                                                                                                    }],
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 275,
                                                                                                                                                        column: 40,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 275,
                                                                                                                                                        column: 103,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            properties: [
                                                                                                                                                {
                                                                                                                                                    type: 'Property',
                                                                                                                                                    key: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'classList',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 276,
                                                                                                                                                                column: 44,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 276,
                                                                                                                                                                column: 53,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    value: {
                                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                                        properties: [{
                                                                                                                                                                type: 'IfStatement',
                                                                                                                                                                test: {
                                                                                                                                                                    type: 'MemberExpression',
                                                                                                                                                                    computed: false,
                                                                                                                                                                    object: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'subcolumn',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 277,
                                                                                                                                                                                column: 51,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 277,
                                                                                                                                                                                column: 60,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    property: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'scheduled',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 277,
                                                                                                                                                                                column: 61,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 277,
                                                                                                                                                                                column: 70,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 277,
                                                                                                                                                                            column: 51,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 277,
                                                                                                                                                                            column: 70,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                consequent: {
                                                                                                                                                                    type: 'BlockStatement',
                                                                                                                                                                    body: [{
                                                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                                                            expression: {
                                                                                                                                                                                type: 'Literal',
                                                                                                                                                                                value: 'scheduled'
                                                                                                                                                                            },
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 278,
                                                                                                                                                                                    column: 52,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 278,
                                                                                                                                                                                    column: 63,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            order: '0'
                                                                                                                                                                        }]
                                                                                                                                                                },
                                                                                                                                                                alternate: null,
                                                                                                                                                                order: '0'
                                                                                                                                                            }]
                                                                                                                                                    },
                                                                                                                                                    kind: 'init',
                                                                                                                                                    order: '0'
                                                                                                                                                },
                                                                                                                                                {
                                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                                    expression: {
                                                                                                                                                        type: 'MemberExpression',
                                                                                                                                                        computed: false,
                                                                                                                                                        object: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'subcolumn',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 279,
                                                                                                                                                                    column: 44,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 279,
                                                                                                                                                                    column: 53,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        property: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'title',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 279,
                                                                                                                                                                    column: 54,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 279,
                                                                                                                                                                    column: 59,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 279,
                                                                                                                                                                column: 44,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 279,
                                                                                                                                                                column: 59,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 279,
                                                                                                                                                            column: 44,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 279,
                                                                                                                                                            column: 59,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    order: '1'
                                                                                                                                                }
                                                                                                                                            ]
                                                                                                                                        },
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 275,
                                                                                                                                                column: 40,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 280,
                                                                                                                                                column: 44,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        order: '0'
                                                                                                                                    }]
                                                                                                                            },
                                                                                                                            remove: null,
                                                                                                                            order: '1'
                                                                                                                        }
                                                                                                                    ]
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 271,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 280,
                                                                                                                        column: 36,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                    }
                                                                                                                },
                                                                                                                order: '1'
                                                                                                            }
                                                                                                        ]
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 266,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 280,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                        }
                                                                                                    },
                                                                                                    order: '0'
                                                                                                }]
                                                                                        },
                                                                                        remove: null,
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 264,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 280,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 263,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 280,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    }
                                                                },
                                                                order: '1'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'ObjectExpression',
                                                                    objectType: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'Identifier',
                                                                            name: 'Div',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 280,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 280,
                                                                                    column: 19,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [{
                                                                                type: 'ObjectExpression',
                                                                                properties: [{
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'class',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 280,
                                                                                                    column: 21,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 280,
                                                                                                    column: 26,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 'move layout center center-justified'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    }]
                                                                            }],
                                                                        loc: {
                                                                            start: {
                                                                                line: 280,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 280,
                                                                                column: 66,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    properties: [{
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'ObjectExpression',
                                                                                objectType: {
                                                                                    type: 'CallExpression',
                                                                                    callee: {
                                                                                        type: 'Identifier',
                                                                                        name: 'Icon',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 281,
                                                                                                column: 20,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 281,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    arguments: [{
                                                                                            type: 'ObjectExpression',
                                                                                            properties: [
                                                                                                {
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'name',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 281,
                                                                                                                column: 26,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 281,
                                                                                                                column: 30,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'Literal',
                                                                                                        value: 'play arrow'
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '0'
                                                                                                },
                                                                                                {
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'size',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 281,
                                                                                                                column: 44,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 281,
                                                                                                                column: 48,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'Literal',
                                                                                                        value: 32
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '1'
                                                                                                }
                                                                                            ]
                                                                                        }],
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 281,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 281,
                                                                                            column: 53,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                properties: [{
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'Function',
                                                                                            context: true,
                                                                                            value: function (_context12) {
                                                                                                return function click(e) {
                                                                                                    var next = _context12.get('next');
                                                                                                    return next(e);
                                                                                                };
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 282,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 282,
                                                                                                column: 43,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 281,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 283,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 280,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 283,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    }
                                                                },
                                                                order: '2'
                                                            }
                                                        ]
                                                    },
                                                    order: '?'
                                                }
                                            ],
                                            bound: false,
                                            name: {
                                                type: 'Identifier',
                                                name: 'createHeaderCell',
                                                loc: {
                                                    start: {
                                                        line: 194,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                    },
                                                    end: {
                                                        line: 194,
                                                        column: 24,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                    }
                                                }
                                            },
                                            scope: {
                                                type: 'Identifier',
                                                name: '_ps'
                                            }
                                        }, {
                                            this: this,
                                            dataTableModel: dataTableModel,
                                            _ps: _ps,
                                            property: property,
                                            options: options,
                                            glass: glass,
                                            _ref: _ref,
                                            _ref2: _ref2,
                                            _ref3: _ref3,
                                            _ref4: _ref4,
                                            DefaultColumn: DefaultColumn,
                                            headerFont1: headerFont1,
                                            headerFont2: headerFont2,
                                            getMiddleDate: getMiddleDate,
                                            jsonValueToDisplayValue: jsonValueToDisplayValue,
                                            Schema: Schema,
                                            style: style,
                                            Icon: Icon,
                                            zoomUnits: zoomUnits,
                                            zoomLevels: zoomLevels,
                                            zoomLevelNames: zoomLevelNames,
                                            getBigColumns: getBigColumns,
                                            getSmallColumns: getSmallColumns,
                                            moveWidth: moveWidth,
                                            headerPadding: headerPadding
                                        }, _ps);
                                    });
                                }
                            },
                            kind: 'init',
                            order: '<'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'createUnderlay',
                                loc: {
                                    start: {
                                        line: 283,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                    },
                                    end: {
                                        line: 283,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_ps2) {
                                    return ion.template(function TimelineColumn_createUnderlay(dataTableModel, _ref37) {
                                        return ion.createRuntime({
                                            type: 'Template',
                                            id: {
                                                type: 'Identifier',
                                                name: 'TimelineColumn_createUnderlay',
                                                loc: {
                                                    start: {
                                                        line: 283,
                                                        column: 33,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                    },
                                                    end: {
                                                        line: 283,
                                                        column: 62,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                    }
                                                }
                                            },
                                            body: [
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'body',
                                                                loc: {
                                                                    start: {
                                                                        line: 283,
                                                                        column: 80,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 283,
                                                                        column: 84,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'MemberExpression',
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: '_ref37'
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'body',
                                                                    loc: {
                                                                        start: {
                                                                            line: 283,
                                                                            column: 80,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 283,
                                                                            column: 84,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                computed: false
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'ReturnStatement',
                                                    argument: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'Span',
                                                                loc: {
                                                                    start: {
                                                                        line: 284,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 284,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [],
                                                            loc: {
                                                                start: {
                                                                    line: 284,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                },
                                                                end: {
                                                                    line: 284,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: []
                                                    },
                                                    order: '1'
                                                }
                                            ],
                                            bound: false,
                                            name: {
                                                type: 'Identifier',
                                                name: 'createUnderlay',
                                                loc: {
                                                    start: {
                                                        line: 283,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                    },
                                                    end: {
                                                        line: 283,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                    }
                                                }
                                            },
                                            scope: {
                                                type: 'Identifier',
                                                name: '_ps2'
                                            }
                                        }, {
                                            this: this,
                                            dataTableModel: dataTableModel,
                                            _ref37: _ref37,
                                            _ps2: _ps2,
                                            property: property,
                                            options: options,
                                            glass: glass,
                                            _ref: _ref,
                                            _ref2: _ref2,
                                            _ref3: _ref3,
                                            _ref4: _ref4,
                                            DefaultColumn: DefaultColumn,
                                            headerFont1: headerFont1,
                                            headerFont2: headerFont2,
                                            getMiddleDate: getMiddleDate,
                                            jsonValueToDisplayValue: jsonValueToDisplayValue,
                                            Schema: Schema,
                                            style: style,
                                            Icon: Icon,
                                            zoomUnits: zoomUnits,
                                            zoomLevels: zoomLevels,
                                            zoomLevelNames: zoomLevelNames,
                                            getBigColumns: getBigColumns,
                                            getSmallColumns: getSmallColumns,
                                            moveWidth: moveWidth,
                                            headerPadding: headerPadding
                                        }, _ps2);
                                    });
                                }
                            },
                            kind: 'init',
                            order: '='
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'createBodyCell',
                                loc: {
                                    start: {
                                        line: 294,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                    },
                                    end: {
                                        line: 294,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_ps3) {
                                    return ion.template(function (row) {
                                        return ion.createRuntime({
                                            type: 'Template',
                                            id: null,
                                            body: [
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: '_ref38'
                                                            },
                                                            init: {
                                                                type: 'Identifier',
                                                                name: 'row',
                                                                loc: {
                                                                    start: {
                                                                        line: 295,
                                                                        column: 43,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 295,
                                                                        column: 46,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'dataTableModel',
                                                                loc: {
                                                                    start: {
                                                                        line: 295,
                                                                        column: 17,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 295,
                                                                        column: 31,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'MemberExpression',
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: '_ref38'
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'dataTableModel',
                                                                    loc: {
                                                                        start: {
                                                                            line: 295,
                                                                            column: 17,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 295,
                                                                            column: 31,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                computed: false
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '1'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'record',
                                                                loc: {
                                                                    start: {
                                                                        line: 295,
                                                                        column: 33,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 295,
                                                                        column: 39,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'MemberExpression',
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: '_ref38'
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'record',
                                                                    loc: {
                                                                        start: {
                                                                            line: 295,
                                                                            column: 33,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 295,
                                                                            column: 39,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                computed: false
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '2'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'column',
                                                                loc: {
                                                                    start: {
                                                                        line: 296,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 296,
                                                                        column: 22,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: { type: 'ThisExpression' }
                                                        }],
                                                    kind: 'let',
                                                    order: '3'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: '_ref39'
                                                            },
                                                            init: {
                                                                type: 'Identifier',
                                                                name: 'column',
                                                                loc: {
                                                                    start: {
                                                                        line: 297,
                                                                        column: 34,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 297,
                                                                        column: 40,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '4'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'start',
                                                                loc: {
                                                                    start: {
                                                                        line: 297,
                                                                        column: 17,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 297,
                                                                        column: 22,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'MemberExpression',
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: '_ref39'
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'start',
                                                                    loc: {
                                                                        start: {
                                                                            line: 297,
                                                                            column: 17,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 297,
                                                                            column: 22,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                computed: false
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '5'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'finish',
                                                                loc: {
                                                                    start: {
                                                                        line: 297,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 297,
                                                                        column: 30,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'MemberExpression',
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: '_ref39'
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'finish',
                                                                    loc: {
                                                                        start: {
                                                                            line: 297,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 297,
                                                                            column: 30,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                computed: false
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '6'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'allComponents',
                                                                loc: {
                                                                    start: {
                                                                        line: 298,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 298,
                                                                        column: 29,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Function',
                                                                    context: true,
                                                                    value: function (_context13) {
                                                                        return function () {
                                                                            var column = _context13.get('column');
                                                                            return column.components = column.components != null ? column.components : {};
                                                                        };
                                                                    }
                                                                },
                                                                arguments: [],
                                                                loc: {
                                                                    start: {
                                                                        line: 298,
                                                                        column: 32,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 298,
                                                                        column: 61,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '7'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'cellComponents',
                                                                loc: {
                                                                    start: {
                                                                        line: 299,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 299,
                                                                        column: 30,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'record',
                                                                        loc: {
                                                                            start: {
                                                                                line: 299,
                                                                                column: 33,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 299,
                                                                                column: 39,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'getTimelineComponents',
                                                                        loc: {
                                                                            start: {
                                                                                line: 299,
                                                                                column: 40,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 299,
                                                                                column: 61,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 299,
                                                                            column: 33,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 299,
                                                                            column: 61,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'ObjectExpression',
                                                                        properties: [
                                                                            {
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'start',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 299,
                                                                                            column: 64,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 299,
                                                                                            column: 69,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Identifier',
                                                                                    name: 'start',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 299,
                                                                                            column: 64,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 299,
                                                                                            column: 69,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                kind: 'init',
                                                                                order: '0'
                                                                            },
                                                                            {
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'finish',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 299,
                                                                                            column: 70,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 299,
                                                                                            column: 76,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Identifier',
                                                                                    name: 'finish',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 299,
                                                                                            column: 70,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 299,
                                                                                            column: 76,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                kind: 'init',
                                                                                order: '1'
                                                                            },
                                                                            {
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'row',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 299,
                                                                                            column: 77,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 299,
                                                                                            column: 80,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Identifier',
                                                                                    name: 'row',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 299,
                                                                                            column: 77,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 299,
                                                                                            column: 80,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                kind: 'init',
                                                                                order: '2'
                                                                            },
                                                                            {
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'column',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 299,
                                                                                            column: 81,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 299,
                                                                                            column: 87,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Identifier',
                                                                                    name: 'column',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 299,
                                                                                            column: 81,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 299,
                                                                                            column: 87,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                kind: 'init',
                                                                                order: '3'
                                                                            }
                                                                        ]
                                                                    }],
                                                                existential: true,
                                                                loc: {
                                                                    start: {
                                                                        line: 299,
                                                                        column: 33,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 299,
                                                                        column: 89,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '8'
                                                },
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'Identifier',
                                                            name: 'allComponents',
                                                            loc: {
                                                                start: {
                                                                    line: 301,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                },
                                                                end: {
                                                                    line: 301,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [{
                                                                type: 'IfStatement',
                                                                test: {
                                                                    type: 'UnaryExpression',
                                                                    operator: '?',
                                                                    argument: {
                                                                        type: 'Identifier',
                                                                        name: 'cellComponents',
                                                                        loc: {
                                                                            start: {
                                                                                line: 302,
                                                                                column: 19,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 302,
                                                                                column: 33,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                            }
                                                                        }
                                                                    }
                                                                },
                                                                consequent: {
                                                                    type: 'BlockStatement',
                                                                    body: [{
                                                                            type: 'ForOfStatement',
                                                                            left: {
                                                                                type: 'VariableDeclaration',
                                                                                declarations: [{
                                                                                        type: 'VariableDeclarator',
                                                                                        id: {
                                                                                            type: 'Identifier',
                                                                                            name: 'component',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 303,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 303,
                                                                                                    column: 33,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        init: null
                                                                                    }],
                                                                                kind: 'let'
                                                                            },
                                                                            right: {
                                                                                type: 'Identifier',
                                                                                name: 'cellComponents',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 303,
                                                                                        column: 37,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 303,
                                                                                        column: 51,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            body: {
                                                                                type: 'BlockStatement',
                                                                                body: [{
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'MemberExpression',
                                                                                            computed: false,
                                                                                            object: {
                                                                                                type: 'Identifier',
                                                                                                name: 'component',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 304,
                                                                                                        column: 25,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 304,
                                                                                                        column: 34,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            property: {
                                                                                                type: 'Identifier',
                                                                                                name: 'key',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 304,
                                                                                                        column: 35,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 304,
                                                                                                        column: 38,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 304,
                                                                                                    column: 25,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 304,
                                                                                                    column: 38,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Identifier',
                                                                                            name: 'component',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 304,
                                                                                                    column: 41,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 304,
                                                                                                    column: 50,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        kind: 'init',
                                                                                        computed: true,
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            remove: null,
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                alternate: null,
                                                                order: '0'
                                                            }]
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 301,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                        },
                                                        end: {
                                                            line: 305,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                        }
                                                    },
                                                    order: '9'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'timeline',
                                                                loc: {
                                                                    start: {
                                                                        line: 305,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 305,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Identifier',
                                                                    name: 'Span',
                                                                    loc: {
                                                                        start: {
                                                                            line: 305,
                                                                            column: 27,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 305,
                                                                            column: 31,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [],
                                                                loc: {
                                                                    start: {
                                                                        line: 305,
                                                                        column: 27,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 305,
                                                                        column: 33,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: ':'
                                                },
                                                {
                                                    type: 'ReturnStatement',
                                                    argument: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'Identifier',
                                                            name: 'timeline',
                                                            loc: {
                                                                start: {
                                                                    line: 306,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                },
                                                                end: {
                                                                    line: 306,
                                                                    column: 27,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [{
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'ObjectExpression',
                                                                    objectType: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'Identifier',
                                                                            name: 'Div',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 311,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 311,
                                                                                    column: 19,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [{
                                                                                type: 'ObjectExpression',
                                                                                properties: [{
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'class',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 311,
                                                                                                    column: 21,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 311,
                                                                                                    column: 26,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 'TimelineColumn2 cell layout center center-justified'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    }]
                                                                            }],
                                                                        loc: {
                                                                            start: {
                                                                                line: 311,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 311,
                                                                                column: 82,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    properties: [
                                                                        {
                                                                            type: 'VariableDeclaration',
                                                                            declarations: [{
                                                                                    type: 'VariableDeclarator',
                                                                                    id: {
                                                                                        type: 'Identifier',
                                                                                        name: 'timelineWidth',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 312,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 312,
                                                                                                column: 37,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    init: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'timeline',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 312,
                                                                                                    column: 40,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 312,
                                                                                                    column: 48,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'clientWidth',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 312,
                                                                                                    column: 49,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 312,
                                                                                                    column: 60,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 312,
                                                                                                column: 40,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 312,
                                                                                                column: 60,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                }],
                                                                            kind: 'let',
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'IfStatement',
                                                                            test: {
                                                                                type: 'UnaryExpression',
                                                                                operator: '?',
                                                                                argument: {
                                                                                    type: 'Identifier',
                                                                                    name: 'cellComponents',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 313,
                                                                                            column: 23,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 313,
                                                                                            column: 37,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                        }
                                                                                    }
                                                                                }
                                                                            },
                                                                            consequent: {
                                                                                type: 'BlockStatement',
                                                                                body: [{
                                                                                        type: 'ForOfStatement',
                                                                                        left: {
                                                                                            type: 'VariableDeclaration',
                                                                                            declarations: [
                                                                                                {
                                                                                                    type: 'VariableDeclarator',
                                                                                                    id: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'component',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 314,
                                                                                                                column: 28,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 314,
                                                                                                                column: 37,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    init: null
                                                                                                },
                                                                                                {
                                                                                                    type: 'VariableDeclarator',
                                                                                                    id: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'index',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 314,
                                                                                                                column: 39,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 314,
                                                                                                                column: 44,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    init: null
                                                                                                }
                                                                                            ],
                                                                                            kind: 'let'
                                                                                        },
                                                                                        right: {
                                                                                            type: 'Identifier',
                                                                                            name: 'cellComponents',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 314,
                                                                                                    column: 48,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 314,
                                                                                                    column: 62,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        body: {
                                                                                            type: 'BlockStatement',
                                                                                            body: [
                                                                                                {
                                                                                                    type: 'VariableDeclaration',
                                                                                                    declarations: [{
                                                                                                            type: 'VariableDeclarator',
                                                                                                            id: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'left',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 315,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 315,
                                                                                                                        column: 36,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            init: {
                                                                                                                type: 'CallExpression',
                                                                                                                callee: {
                                                                                                                    type: 'MemberExpression',
                                                                                                                    computed: false,
                                                                                                                    object: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'column',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 315,
                                                                                                                                column: 39,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 315,
                                                                                                                                column: 45,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    property: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'getComponentLeft',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 315,
                                                                                                                                column: 46,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 315,
                                                                                                                                column: 62,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 315,
                                                                                                                            column: 39,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 315,
                                                                                                                            column: 62,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                arguments: [
                                                                                                                    {
                                                                                                                        type: 'MemberExpression',
                                                                                                                        computed: false,
                                                                                                                        object: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'component',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 315,
                                                                                                                                    column: 63,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 315,
                                                                                                                                    column: 72,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        property: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'start',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 315,
                                                                                                                                    column: 73,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 315,
                                                                                                                                    column: 78,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 315,
                                                                                                                                column: 63,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 315,
                                                                                                                                column: 78,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'timelineWidth',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 315,
                                                                                                                                column: 80,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 315,
                                                                                                                                column: 93,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    }
                                                                                                                ],
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 315,
                                                                                                                        column: 39,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 315,
                                                                                                                        column: 94,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            }
                                                                                                        }],
                                                                                                    kind: 'let',
                                                                                                    order: '0'
                                                                                                },
                                                                                                {
                                                                                                    type: 'VariableDeclaration',
                                                                                                    declarations: [{
                                                                                                            type: 'VariableDeclarator',
                                                                                                            id: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'right',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 316,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 316,
                                                                                                                        column: 37,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            init: {
                                                                                                                type: 'CallExpression',
                                                                                                                callee: {
                                                                                                                    type: 'MemberExpression',
                                                                                                                    computed: false,
                                                                                                                    object: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'column',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 316,
                                                                                                                                column: 40,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 316,
                                                                                                                                column: 46,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    property: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'getComponentRight',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 316,
                                                                                                                                column: 47,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 316,
                                                                                                                                column: 64,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 316,
                                                                                                                            column: 40,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 316,
                                                                                                                            column: 64,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                arguments: [
                                                                                                                    {
                                                                                                                        type: 'MemberExpression',
                                                                                                                        computed: false,
                                                                                                                        object: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'component',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 316,
                                                                                                                                    column: 65,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 316,
                                                                                                                                    column: 74,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        property: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'finish',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 316,
                                                                                                                                    column: 75,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 316,
                                                                                                                                    column: 81,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 316,
                                                                                                                                column: 65,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 316,
                                                                                                                                column: 81,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'timelineWidth',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 316,
                                                                                                                                column: 83,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 316,
                                                                                                                                column: 96,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    }
                                                                                                                ],
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 316,
                                                                                                                        column: 40,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 316,
                                                                                                                        column: 97,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            }
                                                                                                        }],
                                                                                                    kind: 'let',
                                                                                                    order: '1'
                                                                                                },
                                                                                                {
                                                                                                    type: 'ExpressionStatement',
                                                                                                    expression: {
                                                                                                        type: 'ObjectExpression',
                                                                                                        objectType: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'component',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 317,
                                                                                                                    column: 28,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 317,
                                                                                                                    column: 37,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        properties: [
                                                                                                            {
                                                                                                                type: 'ExpressionStatement',
                                                                                                                expression: {
                                                                                                                    type: 'Function',
                                                                                                                    context: true,
                                                                                                                    value: function (_context14) {
                                                                                                                        return function click(e) {
                                                                                                                            var component = _context14.get('component'), state = _context14.get('state');
                                                                                                                            if (component.start) {
                                                                                                                                state.date = component.start;
                                                                                                                            }
                                                                                                                        };
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 318,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 321,
                                                                                                                        column: 36,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                    }
                                                                                                                },
                                                                                                                order: '0'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'Property',
                                                                                                                key: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'style',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 321,
                                                                                                                            column: 32,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 321,
                                                                                                                            column: 37,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                value: {
                                                                                                                    type: 'ObjectExpression',
                                                                                                                    properties: [
                                                                                                                        {
                                                                                                                            type: 'Property',
                                                                                                                            key: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'left',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 322,
                                                                                                                                        column: 36,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 322,
                                                                                                                                        column: 40,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            value: {
                                                                                                                                type: 'BinaryExpression',
                                                                                                                                operator: '+',
                                                                                                                                left: {
                                                                                                                                    type: 'BinaryExpression',
                                                                                                                                    operator: '+',
                                                                                                                                    left: {
                                                                                                                                        type: 'Literal',
                                                                                                                                        value: ''
                                                                                                                                    },
                                                                                                                                    right: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'left',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 322,
                                                                                                                                                column: 45,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 322,
                                                                                                                                                column: 49,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                right: {
                                                                                                                                    type: 'Literal',
                                                                                                                                    value: 'px'
                                                                                                                                }
                                                                                                                            },
                                                                                                                            kind: 'init',
                                                                                                                            order: '0'
                                                                                                                        },
                                                                                                                        {
                                                                                                                            type: 'Property',
                                                                                                                            key: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'width',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 323,
                                                                                                                                        column: 36,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 323,
                                                                                                                                        column: 41,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            value: {
                                                                                                                                type: 'BinaryExpression',
                                                                                                                                operator: '+',
                                                                                                                                left: {
                                                                                                                                    type: 'BinaryExpression',
                                                                                                                                    operator: '+',
                                                                                                                                    left: {
                                                                                                                                        type: 'Literal',
                                                                                                                                        value: ''
                                                                                                                                    },
                                                                                                                                    right: {
                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                        operator: '-',
                                                                                                                                        left: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'right',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 323,
                                                                                                                                                    column: 46,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 323,
                                                                                                                                                    column: 51,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        right: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'left',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 323,
                                                                                                                                                    column: 54,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 323,
                                                                                                                                                    column: 58,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                right: {
                                                                                                                                    type: 'Literal',
                                                                                                                                    value: 'px'
                                                                                                                                }
                                                                                                                            },
                                                                                                                            kind: 'init',
                                                                                                                            order: '1'
                                                                                                                        },
                                                                                                                        {
                                                                                                                            type: 'Property',
                                                                                                                            key: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'height',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 324,
                                                                                                                                        column: 36,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 324,
                                                                                                                                        column: 42,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            value: {
                                                                                                                                type: 'Literal',
                                                                                                                                value: '16px'
                                                                                                                            },
                                                                                                                            kind: 'init',
                                                                                                                            order: '2'
                                                                                                                        }
                                                                                                                    ]
                                                                                                                },
                                                                                                                kind: 'init',
                                                                                                                order: '1'
                                                                                                            }
                                                                                                        ]
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 317,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 337,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                                                        }
                                                                                                    },
                                                                                                    order: '2'
                                                                                                }
                                                                                            ]
                                                                                        },
                                                                                        remove: null,
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            alternate: null,
                                                                            order: '1'
                                                                        }
                                                                    ]
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 311,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 337,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    order: ';'
                                                }
                                            ],
                                            bound: false,
                                            name: {
                                                type: 'Identifier',
                                                name: 'createBodyCell',
                                                loc: {
                                                    start: {
                                                        line: 294,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                    },
                                                    end: {
                                                        line: 294,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'glass/html/material/DataTable2/TimelineColumn.ion'
                                                    }
                                                }
                                            },
                                            scope: {
                                                type: 'Identifier',
                                                name: '_ps3'
                                            }
                                        }, {
                                            this: this,
                                            row: row,
                                            _ps3: _ps3,
                                            property: property,
                                            options: options,
                                            glass: glass,
                                            _ref: _ref,
                                            _ref2: _ref2,
                                            _ref3: _ref3,
                                            _ref4: _ref4,
                                            DefaultColumn: DefaultColumn,
                                            headerFont1: headerFont1,
                                            headerFont2: headerFont2,
                                            getMiddleDate: getMiddleDate,
                                            jsonValueToDisplayValue: jsonValueToDisplayValue,
                                            Schema: Schema,
                                            style: style,
                                            Icon: Icon,
                                            zoomUnits: zoomUnits,
                                            zoomLevels: zoomLevels,
                                            zoomLevelNames: zoomLevelNames,
                                            getBigColumns: getBigColumns,
                                            getSmallColumns: getSmallColumns,
                                            moveWidth: moveWidth,
                                            headerPadding: headerPadding
                                        }, _ps3);
                                    });
                                }
                            },
                            kind: 'init',
                            order: '>'
                        }
                    ]
                },
                order: '1'
            }
        ],
        bound: false
    }, {
        this: this,
        ion: ion,
        property: property,
        options: options,
        glass: glass,
        _ref: _ref,
        _ref2: _ref2,
        _ref3: _ref3,
        _ref4: _ref4,
        DefaultColumn: DefaultColumn,
        headerFont1: headerFont1,
        headerFont2: headerFont2,
        getMiddleDate: getMiddleDate,
        jsonValueToDisplayValue: jsonValueToDisplayValue,
        Schema: Schema,
        style: style,
        Icon: Icon,
        zoomUnits: zoomUnits,
        zoomLevels: zoomLevels,
        zoomLevelNames: zoomLevelNames,
        getBigColumns: getBigColumns,
        getSmallColumns: getSmallColumns,
        moveWidth: moveWidth,
        headerPadding: headerPadding
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/DataTable2/TimelineColumn',_glass_html_material_DataTable2_TimelineColumn_);
    else
      _glass_html_material_DataTable2_TimelineColumn_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_DataTable2_TimelineColumn_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_DataTable2_editing_ = function(module,exports,require){'use strict';
var ion = require('ion'), _ref, _ref2, _ref3, PropertyEditor = require('./PropertyEditor'), hasOwnValue = function (object, property) {
        if (!(object != null) || !(property != null)) {
            return false;
        }
        if (property.hasOwnValue != null) {
            return property.hasOwnValue(object);
        } else {
            return object.hasOwnProperty(property.name);
        }
    };
_ref = require('../../../data');
var Schema = _ref.Schema;
_ref2 = require('../../functions');
var getOffsetRelative = _ref2.getOffsetRelative;
var ensureOnScreen = _ref2.ensureOnScreen;
var show = _ref2.show;
_ref3 = require('../../../convert');
var jsonValueToInputValue = _ref3.jsonValueToInputValue;
var beginEdit = exports.beginEdit = function (_ref4) {
        if (_ref4 == null)
            _ref4 = {};
        var element = _ref4.element;
        var saveObjects = _ref4.saveObjects;
        var object = _ref4.object;
        var property = _ref4.property;
        var value = _ref4.value;
        var properties = _ref4.properties;
        var select = _ref4.select;
        var onCommit = _ref4.commit;
        var onCancel = _ref4.cancel;
        saveObjects = saveObjects != null ? saveObjects : [object];
        if (element.editing) {
            return false;
        }
        if (value === void 0) {
            value = jsonValueToInputValue(property, Schema.get(object, property));
        }
        element.editing = true;
        var editor;
        var remove = show({
                template: PropertyEditor({
                    object: object,
                    property: property,
                    value: value
                }),
                sourceElement: element,
                modal: false,
                select: select,
                onAdd: function (newEditor) {
                    editor = newEditor.editor != null ? newEditor.editor : newEditor;
                    var _ref5 = editor;
                    {
                        ion.add(_ref5, function mousedown(e) {
                            return e.stopPropagation();
                        });
                        ion.add(_ref5, function commit(e) {
                            global.model.endEdit(true, e.detail);
                            onCommit != null ? onCommit(e) : void 0;
                        });
                        ion.add(_ref5, function cancel(e) {
                            global.model.endEdit(false, e.detail);
                            onCancel != null ? onCancel(e) : void 0;
                        });
                    }
                    _ref5;
                },
                onRemove: function (e) {
                    global.model.endEdit(false, e != null ? e.detail : void 0);
                }
            });
        global.model.beginEdit(ion.bind(function (apply) {
            if (!element.editing) {
                return;
            }
            element.editing = false;
            if (apply && editor.valid !== false) {
                global.model.ops.begin();
                if (editor.applyValues != null) {
                    editor.applyValues(saveObjects);
                } else {
                    var value = editor.value;
                    for (var _i = 0; _i < saveObjects.length; _i++) {
                        var saveObject = saveObjects[_i];
                        Schema.set(saveObject, property, value);
                    }
                }
            }
            remove();
        }, this));
        return true;
    };
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/DataTable2/editing',_glass_html_material_DataTable2_editing_);
    else
      _glass_html_material_DataTable2_editing_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_DataTable2_editing_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_DataTable2_getColumnType_ = function(module,exports,require){'use strict';
var _ref = require('../../../data'), DefaultColumn = require('./DefaultColumn'), PrimaryColumn = require('./PrimaryColumn'), BooleanColumn = require('./BooleanColumn'), ColorColumn = require('./ColorColumn'), SelectColumn = require('./SelectColumn'), RelationColumn = require('./RelationColumn');
var Schema = _ref.Schema;
module.exports = exports = function (property) {
    if (property.columnType != null) {
        return typeof property.columnType === 'string' ? require(property.columnType) : property.columnType;
    }
    if (property.type === 'boolean') {
        return BooleanColumn;
    }
    if (property.format === 'color') {
        return ColorColumn;
    }
    if (property.values && Schema.canSet(property)) {
        return SelectColumn;
    }
    if (property.primary) {
        return PrimaryColumn;
    }
    if (property.foreign != null && (property.format === 'key' || property.type === 'object')) {
        return RelationColumn;
    }
    return DefaultColumn;
};
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/DataTable2/getColumnType',_glass_html_material_DataTable2_getColumnType_);
    else
      _glass_html_material_DataTable2_getColumnType_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_DataTable2_getColumnType_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_DataTable2_index_ = function(module,exports,require){'use strict';
var ion = require('ion');
var DataTable = require('./DataTable');
module.exports = exports = ion.patch.combine(DataTable, {
    FullRowSource: require('./FullRowSource'),
    PagedRowSource: require('./PagedRowSource'),
    ObjectRowSource: require('./ObjectRowSource'),
    DefaultColumn: require('./DefaultColumn'),
    Model: require('./DataTableModel'),
    CustomColumnSource: require('./CustomColumnSource'),
    getColumnType: require('./getColumnType'),
    Style: require('./DataTableStyle'),
    TimelineColumn: require('./TimelineColumn')
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/DataTable2/index',_glass_html_material_DataTable2_index_);
    else
      _glass_html_material_DataTable2_index_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_DataTable2_index_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_DateTimeField_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('../../data'), _ref2, _ref3;
var Schema = _ref.Schema;
_ref2 = require('./');
var Calendar = _ref2.Calendar;
var DateTimeInput = _ref2.DateTimeInput;
_ref3 = require('..');
var style = _ref3.style;
ion.template(function () {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [{
                type: 'ExpressionStatement',
                expression: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'MemberExpression',
                        computed: false,
                        object: {
                            type: 'Identifier',
                            name: 'style',
                            loc: {
                                start: {
                                    line: 7,
                                    column: 4,
                                    fixed: true,
                                    source: 'glass/html/material/DateTimeField.ion'
                                },
                                end: {
                                    line: 7,
                                    column: 9,
                                    fixed: true,
                                    source: 'glass/html/material/DateTimeField.ion'
                                }
                            }
                        },
                        property: {
                            type: 'Identifier',
                            name: 'sheets',
                            loc: {
                                start: {
                                    line: 7,
                                    column: 10,
                                    fixed: true,
                                    source: 'glass/html/material/DateTimeField.ion'
                                },
                                end: {
                                    line: 7,
                                    column: 16,
                                    fixed: true,
                                    source: 'glass/html/material/DateTimeField.ion'
                                }
                            }
                        },
                        loc: {
                            start: {
                                line: 7,
                                column: 4,
                                fixed: true,
                                source: 'glass/html/material/DateTimeField.ion'
                            },
                            end: {
                                line: 7,
                                column: 16,
                                fixed: true,
                                source: 'glass/html/material/DateTimeField.ion'
                            }
                        }
                    },
                    properties: [{
                            type: 'Property',
                            key: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'module',
                                    loc: {
                                        start: {
                                            line: 8,
                                            column: 9,
                                            fixed: true,
                                            source: 'glass/html/material/DateTimeField.ion'
                                        },
                                        end: {
                                            line: 8,
                                            column: 15,
                                            fixed: true,
                                            source: 'glass/html/material/DateTimeField.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'id',
                                    loc: {
                                        start: {
                                            line: 8,
                                            column: 16,
                                            fixed: true,
                                            source: 'glass/html/material/DateTimeField.ion'
                                        },
                                        end: {
                                            line: 8,
                                            column: 18,
                                            fixed: true,
                                            source: 'glass/html/material/DateTimeField.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 8,
                                        column: 9,
                                        fixed: true,
                                        source: 'glass/html/material/DateTimeField.ion'
                                    },
                                    end: {
                                        line: 8,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/material/DateTimeField.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Literal',
                                value: '.DateTimeField input{\n    border:none;\n    outline: none;\n    font-size: 14px;\n    background: none;\n    margin-top: 0;\n    padding: 12px 0;\n    width:100%;\n    position:relative;\n}\n\n.DateTimeField .input-wrapper {\n    padding:\'0 12px\'\n}'
                            },
                            kind: 'init',
                            computed: true,
                            order: '0'
                        }]
                },
                loc: {
                    start: {
                        line: 7,
                        column: 4,
                        fixed: true,
                        source: 'glass/html/material/DateTimeField.ion'
                    },
                    end: {
                        line: 25,
                        column: 8,
                        fixed: true,
                        source: 'glass/html/material/DateTimeField.ion'
                    }
                },
                order: '0'
            }],
        bound: false
    }, {
        this: this,
        module: module,
        _ref: _ref,
        _ref2: _ref2,
        _ref3: _ref3,
        Schema: Schema,
        Calendar: Calendar,
        DateTimeInput: DateTimeInput,
        style: style
    }, null);
})().observe();
module.exports = exports = ion.template(function (_ref4) {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'property',
                            loc: {
                                start: {
                                    line: 25,
                                    column: 18,
                                    fixed: true,
                                    source: 'glass/html/material/DateTimeField.ion'
                                },
                                end: {
                                    line: 25,
                                    column: 26,
                                    fixed: true,
                                    source: 'glass/html/material/DateTimeField.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref4'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'property',
                                loc: {
                                    start: {
                                        line: 25,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/material/DateTimeField.ion'
                                    },
                                    end: {
                                        line: 25,
                                        column: 26,
                                        fixed: true,
                                        source: 'glass/html/material/DateTimeField.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'object',
                            loc: {
                                start: {
                                    line: 25,
                                    column: 28,
                                    fixed: true,
                                    source: 'glass/html/material/DateTimeField.ion'
                                },
                                end: {
                                    line: 25,
                                    column: 34,
                                    fixed: true,
                                    source: 'glass/html/material/DateTimeField.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref4'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'object',
                                loc: {
                                    start: {
                                        line: 25,
                                        column: 28,
                                        fixed: true,
                                        source: 'glass/html/material/DateTimeField.ion'
                                    },
                                    end: {
                                        line: 25,
                                        column: 34,
                                        fixed: true,
                                        source: 'glass/html/material/DateTimeField.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: '_value',
                            loc: {
                                start: {
                                    line: 25,
                                    column: 42,
                                    fixed: true,
                                    source: 'glass/html/material/DateTimeField.ion'
                                },
                                end: {
                                    line: 25,
                                    column: 48,
                                    fixed: true,
                                    source: 'glass/html/material/DateTimeField.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref4'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'value',
                                loc: {
                                    start: {
                                        line: 25,
                                        column: 36,
                                        fixed: true,
                                        source: 'glass/html/material/DateTimeField.ion'
                                    },
                                    end: {
                                        line: 25,
                                        column: 41,
                                        fixed: true,
                                        source: 'glass/html/material/DateTimeField.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'value',
                            loc: {
                                start: {
                                    line: 26,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DateTimeField.ion'
                                },
                                end: {
                                    line: 26,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/html/material/DateTimeField.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Function',
                                context: true,
                                value: function (_context) {
                                    return function () {
                                        var _value = _context.get('_value'), Schema = _context.get('Schema'), object = _context.get('object'), property = _context.get('property');
                                        return _value != null ? _value : Schema.get(object, property);
                                    };
                                }
                            },
                            arguments: [],
                            loc: {
                                start: {
                                    line: 26,
                                    column: 16,
                                    fixed: true,
                                    source: 'glass/html/material/DateTimeField.ion'
                                },
                                end: {
                                    line: 26,
                                    column: 59,
                                    fixed: true,
                                    source: 'glass/html/material/DateTimeField.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '3'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'debounceTimer',
                            loc: {
                                start: {
                                    line: 27,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DateTimeField.ion'
                                },
                                end: {
                                    line: 27,
                                    column: 21,
                                    fixed: true,
                                    source: 'glass/html/material/DateTimeField.ion'
                                }
                            }
                        },
                        init: {
                            type: 'Literal',
                            value: null
                        }
                    }],
                kind: 'let',
                order: '4'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'state',
                            loc: {
                                start: {
                                    line: 29,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DateTimeField.ion'
                                },
                                end: {
                                    line: 29,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/html/material/DateTimeField.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'focus',
                                        loc: {
                                            start: {
                                                line: 30,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/DateTimeField.ion'
                                            },
                                            end: {
                                                line: 30,
                                                column: 13,
                                                fixed: true,
                                                source: 'glass/html/material/DateTimeField.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: false
                                    },
                                    kind: 'init',
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'value',
                                        loc: {
                                            start: {
                                                line: 31,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/DateTimeField.ion'
                                            },
                                            end: {
                                                line: 31,
                                                column: 13,
                                                fixed: true,
                                                source: 'glass/html/material/DateTimeField.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: null
                                    },
                                    kind: 'init',
                                    order: '1'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'validated',
                                        loc: {
                                            start: {
                                                line: 32,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/DateTimeField.ion'
                                            },
                                            end: {
                                                line: 32,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/DateTimeField.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: false
                                    },
                                    kind: 'init',
                                    order: '2'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'error',
                                        loc: {
                                            start: {
                                                line: 33,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/DateTimeField.ion'
                                            },
                                            end: {
                                                line: 33,
                                                column: 13,
                                                fixed: true,
                                                source: 'glass/html/material/DateTimeField.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: null
                                    },
                                    kind: 'init',
                                    order: '3'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'inline',
                                        loc: {
                                            start: {
                                                line: 34,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/DateTimeField.ion'
                                            },
                                            end: {
                                                line: 34,
                                                column: 14,
                                                fixed: true,
                                                source: 'glass/html/material/DateTimeField.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: true
                                    },
                                    kind: 'init',
                                    order: '4'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'active',
                                        loc: {
                                            start: {
                                                line: 35,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/DateTimeField.ion'
                                            },
                                            end: {
                                                line: 35,
                                                column: 14,
                                                fixed: true,
                                                source: 'glass/html/material/DateTimeField.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: false
                                    },
                                    kind: 'init',
                                    order: '5'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'placeholder',
                                        loc: {
                                            start: {
                                                line: 36,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/DateTimeField.ion'
                                            },
                                            end: {
                                                line: 36,
                                                column: 19,
                                                fixed: true,
                                                source: 'glass/html/material/DateTimeField.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: ''
                                    },
                                    kind: 'init',
                                    order: '6'
                                }
                            ]
                        }
                    }],
                kind: 'let',
                order: '5'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'input',
                            loc: {
                                start: {
                                    line: 38,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DateTimeField.ion'
                                },
                                end: {
                                    line: 38,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/html/material/DateTimeField.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'DateTimeInput',
                                loc: {
                                    start: {
                                        line: 38,
                                        column: 16,
                                        fixed: true,
                                        source: 'glass/html/material/DateTimeField.ion'
                                    },
                                    end: {
                                        line: 38,
                                        column: 29,
                                        fixed: true,
                                        source: 'glass/html/material/DateTimeField.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ObjectExpression',
                                    properties: [
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'property',
                                                loc: {
                                                    start: {
                                                        line: 38,
                                                        column: 31,
                                                        fixed: true,
                                                        source: 'glass/html/material/DateTimeField.ion'
                                                    },
                                                    end: {
                                                        line: 38,
                                                        column: 39,
                                                        fixed: true,
                                                        source: 'glass/html/material/DateTimeField.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Identifier',
                                                name: 'property',
                                                loc: {
                                                    start: {
                                                        line: 38,
                                                        column: 31,
                                                        fixed: true,
                                                        source: 'glass/html/material/DateTimeField.ion'
                                                    },
                                                    end: {
                                                        line: 38,
                                                        column: 39,
                                                        fixed: true,
                                                        source: 'glass/html/material/DateTimeField.ion'
                                                    }
                                                }
                                            },
                                            kind: 'init',
                                            order: '0'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'object',
                                                loc: {
                                                    start: {
                                                        line: 38,
                                                        column: 41,
                                                        fixed: true,
                                                        source: 'glass/html/material/DateTimeField.ion'
                                                    },
                                                    end: {
                                                        line: 38,
                                                        column: 47,
                                                        fixed: true,
                                                        source: 'glass/html/material/DateTimeField.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Identifier',
                                                name: 'object',
                                                loc: {
                                                    start: {
                                                        line: 38,
                                                        column: 41,
                                                        fixed: true,
                                                        source: 'glass/html/material/DateTimeField.ion'
                                                    },
                                                    end: {
                                                        line: 38,
                                                        column: 47,
                                                        fixed: true,
                                                        source: 'glass/html/material/DateTimeField.ion'
                                                    }
                                                }
                                            },
                                            kind: 'init',
                                            order: '1'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'value',
                                                loc: {
                                                    start: {
                                                        line: 38,
                                                        column: 49,
                                                        fixed: true,
                                                        source: 'glass/html/material/DateTimeField.ion'
                                                    },
                                                    end: {
                                                        line: 38,
                                                        column: 54,
                                                        fixed: true,
                                                        source: 'glass/html/material/DateTimeField.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Identifier',
                                                name: 'value',
                                                loc: {
                                                    start: {
                                                        line: 38,
                                                        column: 49,
                                                        fixed: true,
                                                        source: 'glass/html/material/DateTimeField.ion'
                                                    },
                                                    end: {
                                                        line: 38,
                                                        column: 54,
                                                        fixed: true,
                                                        source: 'glass/html/material/DateTimeField.ion'
                                                    }
                                                }
                                            },
                                            kind: 'init',
                                            order: '2'
                                        }
                                    ]
                                }],
                            loc: {
                                start: {
                                    line: 38,
                                    column: 16,
                                    fixed: true,
                                    source: 'glass/html/material/DateTimeField.ion'
                                },
                                end: {
                                    line: 38,
                                    column: 56,
                                    fixed: true,
                                    source: 'glass/html/material/DateTimeField.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '6'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'field',
                            loc: {
                                start: {
                                    line: 40,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DateTimeField.ion'
                                },
                                end: {
                                    line: 40,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/html/material/DateTimeField.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: 'Object'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'defineProperties'
                                }
                            },
                            arguments: [
                                {
                                    type: 'ObjectExpression',
                                    objectType: {
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'Identifier',
                                            name: 'Div',
                                            loc: {
                                                start: {
                                                    line: 40,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/html/material/DateTimeField.ion'
                                                },
                                                end: {
                                                    line: 40,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'glass/html/material/DateTimeField.ion'
                                                }
                                            }
                                        },
                                        arguments: [{
                                                type: 'ObjectExpression',
                                                properties: [{
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'class',
                                                            loc: {
                                                                start: {
                                                                    line: 40,
                                                                    column: 21,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DateTimeField.ion'
                                                                },
                                                                end: {
                                                                    line: 40,
                                                                    column: 26,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DateTimeField.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Literal',
                                                            value: 'DateTimeField validate fill'
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    }]
                                            }],
                                        loc: {
                                            start: {
                                                line: 40,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/DateTimeField.ion'
                                            },
                                            end: {
                                                line: 40,
                                                column: 58,
                                                fixed: true,
                                                source: 'glass/html/material/DateTimeField.ion'
                                            }
                                        }
                                    },
                                    properties: [
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'name',
                                                loc: {
                                                    start: {
                                                        line: 41,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'glass/html/material/DateTimeField.ion'
                                                    },
                                                    end: {
                                                        line: 41,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/DateTimeField.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'property',
                                                    loc: {
                                                        start: {
                                                            line: 41,
                                                            column: 14,
                                                            fixed: true,
                                                            source: 'glass/html/material/DateTimeField.ion'
                                                        },
                                                        end: {
                                                            line: 41,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'glass/html/material/DateTimeField.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'name',
                                                    loc: {
                                                        start: {
                                                            line: 41,
                                                            column: 23,
                                                            fixed: true,
                                                            source: 'glass/html/material/DateTimeField.ion'
                                                        },
                                                        end: {
                                                            line: 41,
                                                            column: 27,
                                                            fixed: true,
                                                            source: 'glass/html/material/DateTimeField.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 41,
                                                        column: 14,
                                                        fixed: true,
                                                        source: 'glass/html/material/DateTimeField.ion'
                                                    },
                                                    end: {
                                                        line: 41,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'glass/html/material/DateTimeField.ion'
                                                    }
                                                }
                                            },
                                            kind: 'init',
                                            order: '0'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'clear',
                                                loc: {
                                                    start: {
                                                        line: 42,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'glass/html/material/DateTimeField.ion'
                                                    },
                                                    end: {
                                                        line: 42,
                                                        column: 13,
                                                        fixed: true,
                                                        source: 'glass/html/material/DateTimeField.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Function',
                                                context: true,
                                                value: function (_context2) {
                                                    return function () {
                                                        var state = _context2.get('state');
                                                        this.value = null;
                                                        state.validated = false;
                                                    };
                                                }
                                            },
                                            kind: 'init',
                                            order: '1'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'focus',
                                                loc: {
                                                    start: {
                                                        line: 46,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'glass/html/material/DateTimeField.ion'
                                                    },
                                                    end: {
                                                        line: 46,
                                                        column: 13,
                                                        fixed: true,
                                                        source: 'glass/html/material/DateTimeField.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Function',
                                                context: true,
                                                value: function (_context3) {
                                                    return function () {
                                                        var input = _context3.get('input'), state = _context3.get('state');
                                                        console.log('focusing...');
                                                        input.focus();
                                                        state.active = true;
                                                    };
                                                }
                                            },
                                            kind: 'init',
                                            order: '2'
                                        },
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'Function',
                                                context: false,
                                                value: function click() {
                                                    return this.focus();
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 73,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'glass/html/material/DateTimeField.ion'
                                                },
                                                end: {
                                                    line: 73,
                                                    column: 25,
                                                    fixed: true,
                                                    source: 'glass/html/material/DateTimeField.ion'
                                                }
                                            },
                                            order: '3'
                                        }
                                    ]
                                },
                                {
                                    type: 'ObjectExpression',
                                    properties: [
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'value',
                                                loc: {
                                                    start: {
                                                        line: 51,
                                                        column: 17,
                                                        fixed: true,
                                                        source: 'glass/html/material/DateTimeField.ion'
                                                    },
                                                    end: {
                                                        line: 51,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'glass/html/material/DateTimeField.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'ObjectExpression',
                                                properties: [
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'get',
                                                            loc: {
                                                                start: {
                                                                    line: 52,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DateTimeField.ion'
                                                                },
                                                                end: {
                                                                    line: 52,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DateTimeField.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Function',
                                                            context: true,
                                                            value: function (_context4) {
                                                                return function () {
                                                                    var state = _context4.get('state');
                                                                    var value = state.value;
                                                                    console.log('dateField.getValue', value);
                                                                    return value;
                                                                };
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'set',
                                                            loc: {
                                                                start: {
                                                                    line: 56,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DateTimeField.ion'
                                                                },
                                                                end: {
                                                                    line: 56,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DateTimeField.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Function',
                                                            context: true,
                                                            value: function (_context5) {
                                                                return function (value) {
                                                                    var state = _context5.get('state');
                                                                    state.value = value;
                                                                };
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '1'
                                                    }
                                                ]
                                            },
                                            kind: 'init',
                                            define: false,
                                            order: '0'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'inline',
                                                loc: {
                                                    start: {
                                                        line: 59,
                                                        column: 17,
                                                        fixed: true,
                                                        source: 'glass/html/material/DateTimeField.ion'
                                                    },
                                                    end: {
                                                        line: 59,
                                                        column: 23,
                                                        fixed: true,
                                                        source: 'glass/html/material/DateTimeField.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'ObjectExpression',
                                                properties: [
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'get',
                                                            loc: {
                                                                start: {
                                                                    line: 60,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DateTimeField.ion'
                                                                },
                                                                end: {
                                                                    line: 60,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DateTimeField.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Function',
                                                            context: true,
                                                            value: function (_context6) {
                                                                return function () {
                                                                    var state = _context6.get('state');
                                                                    return state.inline;
                                                                };
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'set',
                                                            loc: {
                                                                start: {
                                                                    line: 61,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DateTimeField.ion'
                                                                },
                                                                end: {
                                                                    line: 61,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DateTimeField.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Function',
                                                            context: true,
                                                            value: function (_context7) {
                                                                return function (value) {
                                                                    var state = _context7.get('state');
                                                                    state.inline = value;
                                                                };
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '1'
                                                    }
                                                ]
                                            },
                                            kind: 'init',
                                            define: false,
                                            order: '1'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'active',
                                                loc: {
                                                    start: {
                                                        line: 64,
                                                        column: 17,
                                                        fixed: true,
                                                        source: 'glass/html/material/DateTimeField.ion'
                                                    },
                                                    end: {
                                                        line: 64,
                                                        column: 23,
                                                        fixed: true,
                                                        source: 'glass/html/material/DateTimeField.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'ObjectExpression',
                                                properties: [
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'get',
                                                            loc: {
                                                                start: {
                                                                    line: 65,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DateTimeField.ion'
                                                                },
                                                                end: {
                                                                    line: 65,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DateTimeField.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Function',
                                                            context: true,
                                                            value: function (_context8) {
                                                                return function () {
                                                                    var state = _context8.get('state');
                                                                    return state.active;
                                                                };
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'set',
                                                            loc: {
                                                                start: {
                                                                    line: 66,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DateTimeField.ion'
                                                                },
                                                                end: {
                                                                    line: 66,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DateTimeField.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Function',
                                                            context: true,
                                                            value: function (_context9) {
                                                                return function (value) {
                                                                    var state = _context9.get('state');
                                                                    state.active = value;
                                                                };
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '1'
                                                    }
                                                ]
                                            },
                                            kind: 'init',
                                            define: false,
                                            order: '2'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'placeholder',
                                                loc: {
                                                    start: {
                                                        line: 69,
                                                        column: 17,
                                                        fixed: true,
                                                        source: 'glass/html/material/DateTimeField.ion'
                                                    },
                                                    end: {
                                                        line: 69,
                                                        column: 28,
                                                        fixed: true,
                                                        source: 'glass/html/material/DateTimeField.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'ObjectExpression',
                                                properties: [
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'get',
                                                            loc: {
                                                                start: {
                                                                    line: 70,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DateTimeField.ion'
                                                                },
                                                                end: {
                                                                    line: 70,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DateTimeField.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Function',
                                                            context: true,
                                                            value: function (_context10) {
                                                                return function () {
                                                                    var state = _context10.get('state');
                                                                    return state.placeholder;
                                                                };
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'set',
                                                            loc: {
                                                                start: {
                                                                    line: 71,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DateTimeField.ion'
                                                                },
                                                                end: {
                                                                    line: 71,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DateTimeField.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Function',
                                                            context: true,
                                                            value: function (_context11) {
                                                                return function (value) {
                                                                    var state = _context11.get('state');
                                                                    return state.placeholder = value;
                                                                };
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '1'
                                                    }
                                                ]
                                            },
                                            kind: 'init',
                                            define: false,
                                            order: '3'
                                        }
                                    ]
                                }
                            ]
                        }
                    }],
                kind: 'let',
                order: '7'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'Identifier',
                        name: 'field',
                        loc: {
                            start: {
                                line: 75,
                                column: 11,
                                fixed: true,
                                source: 'glass/html/material/DateTimeField.ion'
                            },
                            end: {
                                line: 75,
                                column: 16,
                                fixed: true,
                                source: 'glass/html/material/DateTimeField.ion'
                            }
                        }
                    },
                    properties: [
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'Identifier',
                                        name: 'Div',
                                        loc: {
                                            start: {
                                                line: 76,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/DateTimeField.ion'
                                            },
                                            end: {
                                                line: 76,
                                                column: 11,
                                                fixed: true,
                                                source: 'glass/html/material/DateTimeField.ion'
                                            }
                                        }
                                    },
                                    arguments: [{
                                            type: 'ObjectExpression',
                                            properties: [{
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'class',
                                                        loc: {
                                                            start: {
                                                                line: 76,
                                                                column: 13,
                                                                fixed: true,
                                                                source: 'glass/html/material/DateTimeField.ion'
                                                            },
                                                            end: {
                                                                line: 76,
                                                                column: 18,
                                                                fixed: true,
                                                                source: 'glass/html/material/DateTimeField.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 'input-wrapper'
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                }]
                                        }],
                                    loc: {
                                        start: {
                                            line: 76,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/DateTimeField.ion'
                                        },
                                        end: {
                                            line: 76,
                                            column: 36,
                                            fixed: true,
                                            source: 'glass/html/material/DateTimeField.ion'
                                        }
                                    }
                                },
                                properties: [{
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'ObjectExpression',
                                            objectType: {
                                                type: 'Identifier',
                                                name: 'input',
                                                loc: {
                                                    start: {
                                                        line: 77,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/DateTimeField.ion'
                                                    },
                                                    end: {
                                                        line: 77,
                                                        column: 17,
                                                        fixed: true,
                                                        source: 'glass/html/material/DateTimeField.ion'
                                                    }
                                                }
                                            },
                                            properties: [
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'placeholder',
                                                        loc: {
                                                            start: {
                                                                line: 78,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/DateTimeField.ion'
                                                            },
                                                            end: {
                                                                line: 78,
                                                                column: 27,
                                                                fixed: true,
                                                                source: 'glass/html/material/DateTimeField.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'field',
                                                            loc: {
                                                                start: {
                                                                    line: 78,
                                                                    column: 29,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DateTimeField.ion'
                                                                },
                                                                end: {
                                                                    line: 78,
                                                                    column: 34,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DateTimeField.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'placeholder',
                                                            loc: {
                                                                start: {
                                                                    line: 78,
                                                                    column: 35,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DateTimeField.ion'
                                                                },
                                                                end: {
                                                                    line: 78,
                                                                    column: 46,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DateTimeField.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 78,
                                                                column: 29,
                                                                fixed: true,
                                                                source: 'glass/html/material/DateTimeField.ion'
                                                            },
                                                            end: {
                                                                line: 78,
                                                                column: 46,
                                                                fixed: true,
                                                                source: 'glass/html/material/DateTimeField.ion'
                                                            }
                                                        }
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'Function',
                                                        context: true,
                                                        value: function (_context12) {
                                                            return function commit(e) {
                                                                var input = _context12.get('input'), field = _context12.get('field');
                                                                console.log('committing and hiding da field');
                                                                input.blur();
                                                                field.dispatchEvent(new CustomEvent('change'));
                                                            };
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 79,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/DateTimeField.ion'
                                                        },
                                                        end: {
                                                            line: 84,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'glass/html/material/DateTimeField.ion'
                                                        }
                                                    },
                                                    order: '1'
                                                },
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'Function',
                                                        context: true,
                                                        value: function (_context13) {
                                                            return function blur(e) {
                                                                var field = _context13.get('field');
                                                                if (!field.inline) {
                                                                    setTimeout(function () {
                                                                        console.log('blurring');
                                                                        field.active = false;
                                                                    }, 20);
                                                                }
                                                            };
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 84,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/DateTimeField.ion'
                                                        },
                                                        end: {
                                                            line: 93,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'glass/html/material/DateTimeField.ion'
                                                        }
                                                    },
                                                    order: '2'
                                                },
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'Function',
                                                        context: true,
                                                        value: function (_context14) {
                                                            return function input(e) {
                                                                var calendar = _context14.get('calendar'), field = _context14.get('field');
                                                                var params = {};
                                                                var date = Date.create(this.value, { params: params });
                                                                if (date.isValid()) {
                                                                    calendar.value = date;
                                                                    var iso = date.iso();
                                                                    if (!(params.hour != null) && iso.indexOf('T') > 0) {
                                                                        iso = iso.substring(0, iso.indexOf('T'));
                                                                    }
                                                                    field.value = iso;
                                                                    field.active = false;
                                                                    input.dispatchEvent(new CustomEvent('commit'));
                                                                } else {
                                                                    field.value = null;
                                                                    field.active = false;
                                                                }
                                                            };
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 93,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/DateTimeField.ion'
                                                        },
                                                        end: {
                                                            line: 111,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'glass/html/material/DateTimeField.ion'
                                                        }
                                                    },
                                                    order: '3'
                                                }
                                            ]
                                        },
                                        loc: {
                                            start: {
                                                line: 77,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/DateTimeField.ion'
                                            },
                                            end: {
                                                line: 111,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/DateTimeField.ion'
                                            }
                                        },
                                        order: '0'
                                    }]
                            },
                            loc: {
                                start: {
                                    line: 76,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DateTimeField.ion'
                                },
                                end: {
                                    line: 111,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/DateTimeField.ion'
                                }
                            },
                            order: '0'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'calendar',
                                        loc: {
                                            start: {
                                                line: 111,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/DateTimeField.ion'
                                            },
                                            end: {
                                                line: 111,
                                                column: 20,
                                                fixed: true,
                                                source: 'glass/html/material/DateTimeField.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'Identifier',
                                            name: 'Calendar',
                                            loc: {
                                                start: {
                                                    line: 111,
                                                    column: 23,
                                                    fixed: true,
                                                    source: 'glass/html/material/DateTimeField.ion'
                                                },
                                                end: {
                                                    line: 111,
                                                    column: 31,
                                                    fixed: true,
                                                    source: 'glass/html/material/DateTimeField.ion'
                                                }
                                            }
                                        },
                                        arguments: [{
                                                type: 'ObjectExpression',
                                                properties: [{
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'value',
                                                            loc: {
                                                                start: {
                                                                    line: 111,
                                                                    column: 33,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DateTimeField.ion'
                                                                },
                                                                end: {
                                                                    line: 111,
                                                                    column: 38,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DateTimeField.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Identifier',
                                                            name: '_value',
                                                            loc: {
                                                                start: {
                                                                    line: 111,
                                                                    column: 39,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DateTimeField.ion'
                                                                },
                                                                end: {
                                                                    line: 111,
                                                                    column: 45,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DateTimeField.ion'
                                                                }
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    }]
                                            }],
                                        loc: {
                                            start: {
                                                line: 111,
                                                column: 23,
                                                fixed: true,
                                                source: 'glass/html/material/DateTimeField.ion'
                                            },
                                            end: {
                                                line: 111,
                                                column: 47,
                                                fixed: true,
                                                source: 'glass/html/material/DateTimeField.ion'
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '1'
                        },
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'Identifier',
                                    name: 'calendar',
                                    loc: {
                                        start: {
                                            line: 112,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/DateTimeField.ion'
                                        },
                                        end: {
                                            line: 112,
                                            column: 16,
                                            fixed: true,
                                            source: 'glass/html/material/DateTimeField.ion'
                                        }
                                    }
                                },
                                properties: [
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'classList',
                                            loc: {
                                                start: {
                                                    line: 113,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/DateTimeField.ion'
                                                },
                                                end: {
                                                    line: 113,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'glass/html/material/DateTimeField.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'ObjectExpression',
                                            properties: [{
                                                    type: 'IfStatement',
                                                    test: {
                                                        type: 'UnaryExpression',
                                                        operator: '!',
                                                        argument: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'field',
                                                                loc: {
                                                                    start: {
                                                                        line: 114,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DateTimeField.ion'
                                                                    },
                                                                    end: {
                                                                        line: 114,
                                                                        column: 28,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DateTimeField.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'inline',
                                                                loc: {
                                                                    start: {
                                                                        line: 114,
                                                                        column: 29,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DateTimeField.ion'
                                                                    },
                                                                    end: {
                                                                        line: 114,
                                                                        column: 35,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DateTimeField.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 114,
                                                                    column: 23,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DateTimeField.ion'
                                                                },
                                                                end: {
                                                                    line: 114,
                                                                    column: 35,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DateTimeField.ion'
                                                                }
                                                            }
                                                        }
                                                    },
                                                    consequent: {
                                                        type: 'BlockStatement',
                                                        body: [{
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'Literal',
                                                                    value: 'z2'
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 115,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DateTimeField.ion'
                                                                    },
                                                                    end: {
                                                                        line: 115,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DateTimeField.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    alternate: null,
                                                    order: '0'
                                                }]
                                        },
                                        kind: 'init',
                                        order: '0'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'style',
                                            loc: {
                                                start: {
                                                    line: 116,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/DateTimeField.ion'
                                                },
                                                end: {
                                                    line: 116,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'glass/html/material/DateTimeField.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'ObjectExpression',
                                            properties: [{
                                                    type: 'IfStatement',
                                                    test: {
                                                        type: 'UnaryExpression',
                                                        operator: '!',
                                                        argument: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'field',
                                                                loc: {
                                                                    start: {
                                                                        line: 117,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DateTimeField.ion'
                                                                    },
                                                                    end: {
                                                                        line: 117,
                                                                        column: 28,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DateTimeField.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'inline',
                                                                loc: {
                                                                    start: {
                                                                        line: 117,
                                                                        column: 29,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DateTimeField.ion'
                                                                    },
                                                                    end: {
                                                                        line: 117,
                                                                        column: 35,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/DateTimeField.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 117,
                                                                    column: 23,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DateTimeField.ion'
                                                                },
                                                                end: {
                                                                    line: 117,
                                                                    column: 35,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/DateTimeField.ion'
                                                                }
                                                            }
                                                        }
                                                    },
                                                    consequent: {
                                                        type: 'BlockStatement',
                                                        body: [
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Literal',
                                                                    value: 'z-index'
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: '1'
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Literal',
                                                                    value: 'position'
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: 'absolute'
                                                                },
                                                                kind: 'init',
                                                                order: '1'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Literal',
                                                                    value: 'display'
                                                                },
                                                                value: {
                                                                    type: 'ConditionalExpression',
                                                                    test: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'state',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 120,
                                                                                    column: 31,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DateTimeField.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 120,
                                                                                    column: 36,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DateTimeField.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'active',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 120,
                                                                                    column: 37,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DateTimeField.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 120,
                                                                                    column: 43,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/DateTimeField.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 120,
                                                                                column: 31,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DateTimeField.ion'
                                                                            },
                                                                            end: {
                                                                                line: 120,
                                                                                column: 43,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/DateTimeField.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    consequent: {
                                                                        type: 'Literal',
                                                                        value: 'block'
                                                                    },
                                                                    alternate: {
                                                                        type: 'Literal',
                                                                        value: 'none'
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '2'
                                                            }
                                                        ]
                                                    },
                                                    alternate: null,
                                                    order: '0'
                                                }]
                                        },
                                        kind: 'init',
                                        order: '1'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'Function',
                                            context: true,
                                            value: function (_context15) {
                                                return function change(e) {
                                                    var field = _context15.get('field'), input = _context15.get('input');
                                                    console.log('Calendar PICK');
                                                    field.value = this.value;
                                                    input.value = this.value;
                                                    input.dispatchEvent(new CustomEvent('commit'));
                                                };
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 122,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/DateTimeField.ion'
                                            },
                                            end: {
                                                line: 134,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/DateTimeField.ion'
                                            }
                                        },
                                        order: '2'
                                    }
                                ]
                            },
                            loc: {
                                start: {
                                    line: 112,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/DateTimeField.ion'
                                },
                                end: {
                                    line: 134,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/DateTimeField.ion'
                                }
                            },
                            order: '2'
                        }
                    ]
                },
                order: '8'
            }
        ],
        bound: false
    }, {
        this: this,
        _ref4: _ref4,
        _ref: _ref,
        _ref2: _ref2,
        _ref3: _ref3,
        Schema: Schema,
        Calendar: Calendar,
        DateTimeInput: DateTimeInput,
        style: style
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/DateTimeField',_glass_html_material_DateTimeField_);
    else
      _glass_html_material_DateTimeField_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_DateTimeField_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_DateTimeInput_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('./'), _ref2;
var BaseInput = _ref.BaseInput;
_ref2 = require('../../time');
var DateTime = _ref2.DateTime;
module.exports = exports = ion.template(function DateTimeInput(_ref3) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'DateTimeInput',
            loc: {
                start: {
                    line: 5,
                    column: 16,
                    fixed: true,
                    source: 'glass/html/material/DateTimeInput.ion'
                },
                end: {
                    line: 5,
                    column: 29,
                    fixed: true,
                    source: 'glass/html/material/DateTimeInput.ion'
                }
            }
        },
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'property',
                            loc: {
                                start: {
                                    line: 5,
                                    column: 31,
                                    fixed: true,
                                    source: 'glass/html/material/DateTimeInput.ion'
                                },
                                end: {
                                    line: 5,
                                    column: 39,
                                    fixed: true,
                                    source: 'glass/html/material/DateTimeInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'property',
                                loc: {
                                    start: {
                                        line: 5,
                                        column: 31,
                                        fixed: true,
                                        source: 'glass/html/material/DateTimeInput.ion'
                                    },
                                    end: {
                                        line: 5,
                                        column: 39,
                                        fixed: true,
                                        source: 'glass/html/material/DateTimeInput.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'object',
                            loc: {
                                start: {
                                    line: 5,
                                    column: 40,
                                    fixed: true,
                                    source: 'glass/html/material/DateTimeInput.ion'
                                },
                                end: {
                                    line: 5,
                                    column: 46,
                                    fixed: true,
                                    source: 'glass/html/material/DateTimeInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'object',
                                loc: {
                                    start: {
                                        line: 5,
                                        column: 40,
                                        fixed: true,
                                        source: 'glass/html/material/DateTimeInput.ion'
                                    },
                                    end: {
                                        line: 5,
                                        column: 46,
                                        fixed: true,
                                        source: 'glass/html/material/DateTimeInput.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'value',
                            loc: {
                                start: {
                                    line: 5,
                                    column: 47,
                                    fixed: true,
                                    source: 'glass/html/material/DateTimeInput.ion'
                                },
                                end: {
                                    line: 5,
                                    column: 52,
                                    fixed: true,
                                    source: 'glass/html/material/DateTimeInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'value',
                                loc: {
                                    start: {
                                        line: 5,
                                        column: 47,
                                        fixed: true,
                                        source: 'glass/html/material/DateTimeInput.ion'
                                    },
                                    end: {
                                        line: 5,
                                        column: 52,
                                        fixed: true,
                                        source: 'glass/html/material/DateTimeInput.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'CallExpression',
                    callee: {
                        type: 'MemberExpression',
                        object: {
                            type: 'Identifier',
                            name: 'Object'
                        },
                        property: {
                            type: 'Identifier',
                            name: 'defineProperties'
                        }
                    },
                    arguments: [
                        {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'BaseInput',
                                    loc: {
                                        start: {
                                            line: 6,
                                            column: 11,
                                            fixed: true,
                                            source: 'glass/html/material/DateTimeInput.ion'
                                        },
                                        end: {
                                            line: 6,
                                            column: 20,
                                            fixed: true,
                                            source: 'glass/html/material/DateTimeInput.ion'
                                        }
                                    }
                                },
                                arguments: [],
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 11,
                                        fixed: true,
                                        source: 'glass/html/material/DateTimeInput.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/material/DateTimeInput.ion'
                                    }
                                }
                            },
                            properties: [
                                {
                                    type: 'IfStatement',
                                    test: {
                                        type: 'UnaryExpression',
                                        operator: '?',
                                        argument: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'property',
                                                loc: {
                                                    start: {
                                                        line: 7,
                                                        column: 11,
                                                        fixed: true,
                                                        source: 'glass/html/material/DateTimeInput.ion'
                                                    },
                                                    end: {
                                                        line: 7,
                                                        column: 19,
                                                        fixed: true,
                                                        source: 'glass/html/material/DateTimeInput.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'required',
                                                loc: {
                                                    start: {
                                                        line: 7,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'glass/html/material/DateTimeInput.ion'
                                                    },
                                                    end: {
                                                        line: 7,
                                                        column: 28,
                                                        fixed: true,
                                                        source: 'glass/html/material/DateTimeInput.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 7,
                                                    column: 11,
                                                    fixed: true,
                                                    source: 'glass/html/material/DateTimeInput.ion'
                                                },
                                                end: {
                                                    line: 7,
                                                    column: 28,
                                                    fixed: true,
                                                    source: 'glass/html/material/DateTimeInput.ion'
                                                }
                                            }
                                        }
                                    },
                                    consequent: {
                                        type: 'BlockStatement',
                                        body: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'required',
                                                    loc: {
                                                        start: {
                                                            line: 8,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/DateTimeInput.ion'
                                                        },
                                                        end: {
                                                            line: 8,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'glass/html/material/DateTimeInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'property',
                                                        loc: {
                                                            start: {
                                                                line: 8,
                                                                column: 22,
                                                                fixed: true,
                                                                source: 'glass/html/material/DateTimeInput.ion'
                                                            },
                                                            end: {
                                                                line: 8,
                                                                column: 30,
                                                                fixed: true,
                                                                source: 'glass/html/material/DateTimeInput.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'required',
                                                        loc: {
                                                            start: {
                                                                line: 8,
                                                                column: 31,
                                                                fixed: true,
                                                                source: 'glass/html/material/DateTimeInput.ion'
                                                            },
                                                            end: {
                                                                line: 8,
                                                                column: 39,
                                                                fixed: true,
                                                                source: 'glass/html/material/DateTimeInput.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 8,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'glass/html/material/DateTimeInput.ion'
                                                        },
                                                        end: {
                                                            line: 8,
                                                            column: 39,
                                                            fixed: true,
                                                            source: 'glass/html/material/DateTimeInput.ion'
                                                        }
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    },
                                    alternate: null,
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'type',
                                        loc: {
                                            start: {
                                                line: 9,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/DateTimeInput.ion'
                                            },
                                            end: {
                                                line: 9,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/DateTimeInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: 'text'
                                    },
                                    kind: 'init',
                                    order: '1'
                                },
                                {
                                    type: 'IfStatement',
                                    test: {
                                        type: 'UnaryExpression',
                                        operator: '?',
                                        argument: {
                                            type: 'Identifier',
                                            name: 'value',
                                            loc: {
                                                start: {
                                                    line: 10,
                                                    column: 11,
                                                    fixed: true,
                                                    source: 'glass/html/material/DateTimeInput.ion'
                                                },
                                                end: {
                                                    line: 10,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/html/material/DateTimeInput.ion'
                                                }
                                            }
                                        }
                                    },
                                    consequent: {
                                        type: 'BlockStatement',
                                        body: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'value',
                                                    loc: {
                                                        start: {
                                                            line: 11,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/DateTimeInput.ion'
                                                        },
                                                        end: {
                                                            line: 11,
                                                            column: 17,
                                                            fixed: true,
                                                            source: 'glass/html/material/DateTimeInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Identifier',
                                                    name: 'value',
                                                    loc: {
                                                        start: {
                                                            line: 11,
                                                            column: 19,
                                                            fixed: true,
                                                            source: 'glass/html/material/DateTimeInput.ion'
                                                        },
                                                        end: {
                                                            line: 11,
                                                            column: 24,
                                                            fixed: true,
                                                            source: 'glass/html/material/DateTimeInput.ion'
                                                        }
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    },
                                    alternate: null,
                                    order: '2'
                                }
                            ]
                        },
                        {
                            type: 'ObjectExpression',
                            properties: [{
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'valueJSON',
                                        loc: {
                                            start: {
                                                line: 12,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/DateTimeInput.ion'
                                            },
                                            end: {
                                                line: 12,
                                                column: 26,
                                                fixed: true,
                                                source: 'glass/html/material/DateTimeInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 13,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/DateTimeInput.ion'
                                                        },
                                                        end: {
                                                            line: 13,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/DateTimeInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context) {
                                                        return function () {
                                                            var DateTime = _context.get('DateTime');
                                                            var value = this.value;
                                                            if (typeof value === 'string') {
                                                                value = value.trim();
                                                                if (value === '') {
                                                                    value = null;
                                                                } else {
                                                                    var dateTimeValue = DateTime.parse(value);
                                                                    value = (dateTimeValue != null ? dateTimeValue.iso() : void 0) != null ? dateTimeValue.iso() : '';
                                                                }
                                                            }
                                                            return value;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 23,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/DateTimeInput.ion'
                                                        },
                                                        end: {
                                                            line: 23,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/DateTimeInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context2) {
                                                        return function (value) {
                                                            var DateTime = _context2.get('DateTime');
                                                            var date = DateTime.parse(value);
                                                            value = (date != null ? date.format() : void 0) != null ? date.format() : '';
                                                            this.value = value;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'configurable',
                                                    loc: {
                                                        start: {
                                                            line: 27,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/DateTimeInput.ion'
                                                        },
                                                        end: {
                                                            line: 27,
                                                            column: 24,
                                                            fixed: true,
                                                            source: 'glass/html/material/DateTimeInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: true
                                                },
                                                kind: 'init',
                                                order: '2'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '0'
                                }]
                        }
                    ]
                },
                order: '3'
            }
        ],
        bound: false
    }, {
        this: this,
        _ref3: _ref3,
        _ref: _ref,
        _ref2: _ref2,
        BaseInput: BaseInput,
        DateTime: DateTime
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/DateTimeInput',_glass_html_material_DateTimeInput_);
    else
      _glass_html_material_DateTimeInput_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_DateTimeInput_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_Dialog_ = function(module,exports,require){'use strict';
var ion = require('ion');
if (!global.window) {
    return;
}
var style = require('../style'), _ref;
_ref = require('../functions');
var focusDescendant = _ref.focusDescendant;
style.define(module.id, '.Dialog {\n    z-index: 10;\n    position: fixed;\n    top: 0px;\n    left: 0px;\n    width: 100vw;\n    height: 100vh;\n    background: rgba(0, 0, 0, 0.1);\n}\n.Dialog:not(.open) {\n    visibility:hidden;\n}\n.Dialog .frame {\n    padding: 24px;\n    background: white;\n    max-width: 100%;\n    max-height: 100%;\n}\n.Dialog SECTION P {\n}\n.Dialog HEADER {\n}\n.Dialog footer {\n}\n.Dialog FOOTER BUTTON {\n}\n.Dialog.round .frame {\n    border-radius: 2px;\n}\n.Dialog .frame .title {\n    font-size: 20px;\n}');
var Dialog = ion.template(function (_ref2) {
        return ion.createRuntime({
            type: 'Template',
            id: null,
            body: [
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'modal',
                                loc: {
                                    start: {
                                        line: 50,
                                        column: 24,
                                        fixed: true,
                                        source: 'glass/html/material/Dialog.ion'
                                    },
                                    end: {
                                        line: 50,
                                        column: 29,
                                        fixed: true,
                                        source: 'glass/html/material/Dialog.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref2'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'modal',
                                    loc: {
                                        start: {
                                            line: 50,
                                            column: 24,
                                            fixed: true,
                                            source: 'glass/html/material/Dialog.ion'
                                        },
                                        end: {
                                            line: 50,
                                            column: 29,
                                            fixed: true,
                                            source: 'glass/html/material/Dialog.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '0'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'round',
                                loc: {
                                    start: {
                                        line: 50,
                                        column: 30,
                                        fixed: true,
                                        source: 'glass/html/material/Dialog.ion'
                                    },
                                    end: {
                                        line: 50,
                                        column: 35,
                                        fixed: true,
                                        source: 'glass/html/material/Dialog.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref2'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'round',
                                    loc: {
                                        start: {
                                            line: 50,
                                            column: 30,
                                            fixed: true,
                                            source: 'glass/html/material/Dialog.ion'
                                        },
                                        end: {
                                            line: 50,
                                            column: 35,
                                            fixed: true,
                                            source: 'glass/html/material/Dialog.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '1'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'z',
                                loc: {
                                    start: {
                                        line: 50,
                                        column: 36,
                                        fixed: true,
                                        source: 'glass/html/material/Dialog.ion'
                                    },
                                    end: {
                                        line: 50,
                                        column: 37,
                                        fixed: true,
                                        source: 'glass/html/material/Dialog.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref2'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'z',
                                    loc: {
                                        start: {
                                            line: 50,
                                            column: 36,
                                            fixed: true,
                                            source: 'glass/html/material/Dialog.ion'
                                        },
                                        end: {
                                            line: 50,
                                            column: 37,
                                            fixed: true,
                                            source: 'glass/html/material/Dialog.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '2'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'closeable',
                                loc: {
                                    start: {
                                        line: 50,
                                        column: 38,
                                        fixed: true,
                                        source: 'glass/html/material/Dialog.ion'
                                    },
                                    end: {
                                        line: 50,
                                        column: 47,
                                        fixed: true,
                                        source: 'glass/html/material/Dialog.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref2'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'closeable',
                                    loc: {
                                        start: {
                                            line: 50,
                                            column: 38,
                                            fixed: true,
                                            source: 'glass/html/material/Dialog.ion'
                                        },
                                        end: {
                                            line: 50,
                                            column: 47,
                                            fixed: true,
                                            source: 'glass/html/material/Dialog.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '3'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'state',
                                loc: {
                                    start: {
                                        line: 51,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/Dialog.ion'
                                    },
                                    end: {
                                        line: 51,
                                        column: 13,
                                        fixed: true,
                                        source: 'glass/html/material/Dialog.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'ObjectExpression',
                                    properties: []
                                },
                                properties: [
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'title',
                                            loc: {
                                                start: {
                                                    line: 52,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'glass/html/material/Dialog.ion'
                                                },
                                                end: {
                                                    line: 52,
                                                    column: 13,
                                                    fixed: true,
                                                    source: 'glass/html/material/Dialog.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: null
                                        },
                                        kind: 'init',
                                        order: '0'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'close',
                                            loc: {
                                                start: {
                                                    line: 53,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'glass/html/material/Dialog.ion'
                                                },
                                                end: {
                                                    line: 53,
                                                    column: 13,
                                                    fixed: true,
                                                    source: 'glass/html/material/Dialog.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: 'all'
                                        },
                                        kind: 'init',
                                        order: '1'
                                    }
                                ]
                            }
                        }],
                    kind: 'let',
                    order: '4'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'dialogElement',
                                loc: {
                                    start: {
                                        line: 55,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/Dialog.ion'
                                    },
                                    end: {
                                        line: 55,
                                        column: 21,
                                        fixed: true,
                                        source: 'glass/html/material/Dialog.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'MemberExpression',
                                    object: {
                                        type: 'Identifier',
                                        name: 'Object'
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'defineProperties'
                                    }
                                },
                                arguments: [
                                    {
                                        type: 'ObjectExpression',
                                        objectType: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'Identifier',
                                                name: 'Div',
                                                loc: {
                                                    start: {
                                                        line: 55,
                                                        column: 24,
                                                        fixed: true,
                                                        source: 'glass/html/material/Dialog.ion'
                                                    },
                                                    end: {
                                                        line: 55,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'glass/html/material/Dialog.ion'
                                                    }
                                                }
                                            },
                                            arguments: [{
                                                    type: 'ObjectExpression',
                                                    properties: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'class',
                                                                loc: {
                                                                    start: {
                                                                        line: 55,
                                                                        column: 29,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Dialog.ion'
                                                                    },
                                                                    end: {
                                                                        line: 55,
                                                                        column: 34,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Dialog.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Literal',
                                                                value: 'Dialog flex layout center center-justified'
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                }],
                                            loc: {
                                                start: {
                                                    line: 55,
                                                    column: 24,
                                                    fixed: true,
                                                    source: 'glass/html/material/Dialog.ion'
                                                },
                                                end: {
                                                    line: 55,
                                                    column: 81,
                                                    fixed: true,
                                                    source: 'glass/html/material/Dialog.ion'
                                                }
                                            }
                                        },
                                        properties: []
                                    },
                                    {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'close',
                                                    loc: {
                                                        start: {
                                                            line: 56,
                                                            column: 17,
                                                            fixed: true,
                                                            source: 'glass/html/material/Dialog.ion'
                                                        },
                                                        end: {
                                                            line: 56,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'glass/html/material/Dialog.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'ObjectExpression',
                                                    properties: [
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'get',
                                                                loc: {
                                                                    start: {
                                                                        line: 57,
                                                                        column: 12,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Dialog.ion'
                                                                    },
                                                                    end: {
                                                                        line: 57,
                                                                        column: 15,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Dialog.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Function',
                                                                context: true,
                                                                value: function (_context) {
                                                                    return function () {
                                                                        var state = _context.get('state');
                                                                        return state.close;
                                                                    };
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        },
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'set',
                                                                loc: {
                                                                    start: {
                                                                        line: 59,
                                                                        column: 12,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Dialog.ion'
                                                                    },
                                                                    end: {
                                                                        line: 59,
                                                                        column: 15,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Dialog.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Function',
                                                                context: true,
                                                                value: function (_context2) {
                                                                    return function (value) {
                                                                        var state = _context2.get('state');
                                                                        state.close = value;
                                                                    };
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '1'
                                                        }
                                                    ]
                                                },
                                                kind: 'init',
                                                define: false,
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'title',
                                                    loc: {
                                                        start: {
                                                            line: 62,
                                                            column: 17,
                                                            fixed: true,
                                                            source: 'glass/html/material/Dialog.ion'
                                                        },
                                                        end: {
                                                            line: 62,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'glass/html/material/Dialog.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'ObjectExpression',
                                                    properties: [
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'get',
                                                                loc: {
                                                                    start: {
                                                                        line: 63,
                                                                        column: 12,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Dialog.ion'
                                                                    },
                                                                    end: {
                                                                        line: 63,
                                                                        column: 15,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Dialog.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Function',
                                                                context: true,
                                                                value: function (_context3) {
                                                                    return function () {
                                                                        var state = _context3.get('state');
                                                                        return state.title;
                                                                    };
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        },
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'set',
                                                                loc: {
                                                                    start: {
                                                                        line: 64,
                                                                        column: 12,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Dialog.ion'
                                                                    },
                                                                    end: {
                                                                        line: 64,
                                                                        column: 15,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Dialog.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Function',
                                                                context: true,
                                                                value: function (_context4) {
                                                                    return function (value) {
                                                                        var state = _context4.get('state');
                                                                        return state.title = value;
                                                                    };
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '1'
                                                        }
                                                    ]
                                                },
                                                kind: 'init',
                                                define: false,
                                                order: '1'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'open',
                                                    loc: {
                                                        start: {
                                                            line: 66,
                                                            column: 17,
                                                            fixed: true,
                                                            source: 'glass/html/material/Dialog.ion'
                                                        },
                                                        end: {
                                                            line: 66,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'glass/html/material/Dialog.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'ObjectExpression',
                                                    properties: [
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'get',
                                                                loc: {
                                                                    start: {
                                                                        line: 67,
                                                                        column: 12,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Dialog.ion'
                                                                    },
                                                                    end: {
                                                                        line: 67,
                                                                        column: 15,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Dialog.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Function',
                                                                context: false,
                                                                value: function () {
                                                                    return this.classList.contains('open');
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        },
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'set',
                                                                loc: {
                                                                    start: {
                                                                        line: 68,
                                                                        column: 12,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Dialog.ion'
                                                                    },
                                                                    end: {
                                                                        line: 68,
                                                                        column: 15,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Dialog.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Function',
                                                                context: true,
                                                                value: function (_context5) {
                                                                    return function (value) {
                                                                        var focusDescendant = _context5.get('focusDescendant');
                                                                        if (value !== this.open) {
                                                                            if (value) {
                                                                                this.classList.add('open');
                                                                                this.dispatchEvent(new CustomEvent('open'));
                                                                                focusDescendant(this);
                                                                            } else {
                                                                                this.classList.remove('open');
                                                                                this.dispatchEvent(new CustomEvent('close'));
                                                                            }
                                                                        }
                                                                    };
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '1'
                                                        }
                                                    ]
                                                },
                                                kind: 'init',
                                                define: false,
                                                order: '2'
                                            }
                                        ]
                                    }
                                ]
                            }
                        }],
                    kind: 'let',
                    order: '5'
                },
                {
                    type: 'ReturnStatement',
                    argument: {
                        type: 'ObjectExpression',
                        objectType: {
                            type: 'Identifier',
                            name: 'dialogElement',
                            loc: {
                                start: {
                                    line: 78,
                                    column: 11,
                                    fixed: true,
                                    source: 'glass/html/material/Dialog.ion'
                                },
                                end: {
                                    line: 78,
                                    column: 24,
                                    fixed: true,
                                    source: 'glass/html/material/Dialog.ion'
                                }
                            }
                        },
                        properties: [
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'classList',
                                    loc: {
                                        start: {
                                            line: 80,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/Dialog.ion'
                                        },
                                        end: {
                                            line: 80,
                                            column: 17,
                                            fixed: true,
                                            source: 'glass/html/material/Dialog.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'ObjectExpression',
                                    properties: [{
                                            type: 'IfStatement',
                                            test: {
                                                type: 'BinaryExpression',
                                                operator: '!==',
                                                left: {
                                                    type: 'Identifier',
                                                    name: 'round',
                                                    loc: {
                                                        start: {
                                                            line: 81,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Dialog.ion'
                                                        },
                                                        end: {
                                                            line: 81,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'glass/html/material/Dialog.ion'
                                                        }
                                                    }
                                                },
                                                right: {
                                                    type: 'Literal',
                                                    value: false
                                                }
                                            },
                                            consequent: {
                                                type: 'BlockStatement',
                                                body: [{
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'Literal',
                                                            value: 'round'
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 82,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/Dialog.ion'
                                                            },
                                                            end: {
                                                                line: 82,
                                                                column: 23,
                                                                fixed: true,
                                                                source: 'glass/html/material/Dialog.ion'
                                                            }
                                                        },
                                                        order: '0'
                                                    }]
                                            },
                                            alternate: null,
                                            order: '0'
                                        }]
                                },
                                kind: 'init',
                                order: '0'
                            },
                            {
                                type: 'IfStatement',
                                test: {
                                    type: 'Identifier',
                                    name: 'closeable',
                                    loc: {
                                        start: {
                                            line: 84,
                                            column: 11,
                                            fixed: true,
                                            source: 'glass/html/material/Dialog.ion'
                                        },
                                        end: {
                                            line: 84,
                                            column: 20,
                                            fixed: true,
                                            source: 'glass/html/material/Dialog.ion'
                                        }
                                    }
                                },
                                consequent: {
                                    type: 'BlockStatement',
                                    body: [{
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'Function',
                                                context: false,
                                                value: function click(e) {
                                                    if (e.srcElement === this) {
                                                        this.open = false;
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 85,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/Dialog.ion'
                                                },
                                                end: {
                                                    line: 89,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/html/material/Dialog.ion'
                                                }
                                            },
                                            order: '0'
                                        }]
                                },
                                alternate: null,
                                order: '1'
                            },
                            {
                                type: 'IfStatement',
                                test: {
                                    type: 'BinaryExpression',
                                    operator: '||',
                                    left: {
                                        type: 'BinaryExpression',
                                        operator: '===',
                                        left: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'dialogElement',
                                                loc: {
                                                    start: {
                                                        line: 89,
                                                        column: 11,
                                                        fixed: true,
                                                        source: 'glass/html/material/Dialog.ion'
                                                    },
                                                    end: {
                                                        line: 89,
                                                        column: 24,
                                                        fixed: true,
                                                        source: 'glass/html/material/Dialog.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'close',
                                                loc: {
                                                    start: {
                                                        line: 89,
                                                        column: 25,
                                                        fixed: true,
                                                        source: 'glass/html/material/Dialog.ion'
                                                    },
                                                    end: {
                                                        line: 89,
                                                        column: 30,
                                                        fixed: true,
                                                        source: 'glass/html/material/Dialog.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 89,
                                                    column: 11,
                                                    fixed: true,
                                                    source: 'glass/html/material/Dialog.ion'
                                                },
                                                end: {
                                                    line: 89,
                                                    column: 30,
                                                    fixed: true,
                                                    source: 'glass/html/material/Dialog.ion'
                                                }
                                            }
                                        },
                                        right: {
                                            type: 'Literal',
                                            value: 'all'
                                        }
                                    },
                                    right: {
                                        type: 'BinaryExpression',
                                        operator: '===',
                                        left: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'dialogElement',
                                                loc: {
                                                    start: {
                                                        line: 89,
                                                        column: 43,
                                                        fixed: true,
                                                        source: 'glass/html/material/Dialog.ion'
                                                    },
                                                    end: {
                                                        line: 89,
                                                        column: 56,
                                                        fixed: true,
                                                        source: 'glass/html/material/Dialog.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'close',
                                                loc: {
                                                    start: {
                                                        line: 89,
                                                        column: 57,
                                                        fixed: true,
                                                        source: 'glass/html/material/Dialog.ion'
                                                    },
                                                    end: {
                                                        line: 89,
                                                        column: 62,
                                                        fixed: true,
                                                        source: 'glass/html/material/Dialog.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 89,
                                                    column: 43,
                                                    fixed: true,
                                                    source: 'glass/html/material/Dialog.ion'
                                                },
                                                end: {
                                                    line: 89,
                                                    column: 62,
                                                    fixed: true,
                                                    source: 'glass/html/material/Dialog.ion'
                                                }
                                            }
                                        },
                                        right: {
                                            type: 'Literal',
                                            value: 'key'
                                        }
                                    }
                                },
                                consequent: {
                                    type: 'BlockStatement',
                                    body: [{
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'document',
                                                            loc: {
                                                                start: {
                                                                    line: 90,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Dialog.ion'
                                                                },
                                                                end: {
                                                                    line: 90,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Dialog.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'body',
                                                            loc: {
                                                                start: {
                                                                    line: 90,
                                                                    column: 21,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Dialog.ion'
                                                                },
                                                                end: {
                                                                    line: 90,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Dialog.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 90,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'glass/html/material/Dialog.ion'
                                                            },
                                                            end: {
                                                                line: 90,
                                                                column: 25,
                                                                fixed: true,
                                                                source: 'glass/html/material/Dialog.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'addEventListener',
                                                        loc: {
                                                            start: {
                                                                line: 90,
                                                                column: 26,
                                                                fixed: true,
                                                                source: 'glass/html/material/Dialog.ion'
                                                            },
                                                            end: {
                                                                line: 90,
                                                                column: 42,
                                                                fixed: true,
                                                                source: 'glass/html/material/Dialog.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 90,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Dialog.ion'
                                                        },
                                                        end: {
                                                            line: 90,
                                                            column: 42,
                                                            fixed: true,
                                                            source: 'glass/html/material/Dialog.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [
                                                    {
                                                        type: 'Literal',
                                                        value: 'keyup'
                                                    },
                                                    {
                                                        type: 'Function',
                                                        context: true,
                                                        value: function (_context6) {
                                                            return function (e) {
                                                                var dialogElement = _context6.get('dialogElement');
                                                                if (e.keyCode === 27) {
                                                                    dialogElement.open = false;
                                                                }
                                                            };
                                                        }
                                                    }
                                                ],
                                                loc: {
                                                    start: {
                                                        line: 90,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/Dialog.ion'
                                                    },
                                                    end: {
                                                        line: 96,
                                                        column: 13,
                                                        fixed: true,
                                                        source: 'glass/html/material/Dialog.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 90,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/Dialog.ion'
                                                },
                                                end: {
                                                    line: 96,
                                                    column: 13,
                                                    fixed: true,
                                                    source: 'glass/html/material/Dialog.ion'
                                                }
                                            },
                                            order: '0'
                                        }]
                                },
                                alternate: null,
                                order: '2'
                            },
                            {
                                type: 'VariableDeclaration',
                                declarations: [{
                                        type: 'VariableDeclarator',
                                        id: {
                                            type: 'Identifier',
                                            name: 'frame',
                                            loc: {
                                                start: {
                                                    line: 106,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/Dialog.ion'
                                                },
                                                end: {
                                                    line: 106,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'glass/html/material/Dialog.ion'
                                                }
                                            }
                                        },
                                        init: {
                                            type: 'ObjectExpression',
                                            objectType: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'Div',
                                                    loc: {
                                                        start: {
                                                            line: 106,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'glass/html/material/Dialog.ion'
                                                        },
                                                        end: {
                                                            line: 106,
                                                            column: 23,
                                                            fixed: true,
                                                            source: 'glass/html/material/Dialog.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [{
                                                        type: 'ObjectExpression',
                                                        properties: [{
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'class',
                                                                    loc: {
                                                                        start: {
                                                                            line: 106,
                                                                            column: 25,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Dialog.ion'
                                                                        },
                                                                        end: {
                                                                            line: 106,
                                                                            column: 30,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Dialog.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: 'frame layout vertical'
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            }]
                                                    }],
                                                loc: {
                                                    start: {
                                                        line: 106,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'glass/html/material/Dialog.ion'
                                                    },
                                                    end: {
                                                        line: 106,
                                                        column: 56,
                                                        fixed: true,
                                                        source: 'glass/html/material/Dialog.ion'
                                                    }
                                                }
                                            },
                                            properties: [{
                                                    type: 'IfStatement',
                                                    test: {
                                                        type: 'BinaryExpression',
                                                        operator: '||',
                                                        left: {
                                                            type: 'BinaryExpression',
                                                            operator: '===',
                                                            left: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'dialogElement',
                                                                    loc: {
                                                                        start: {
                                                                            line: 108,
                                                                            column: 15,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Dialog.ion'
                                                                        },
                                                                        end: {
                                                                            line: 108,
                                                                            column: 28,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Dialog.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'close',
                                                                    loc: {
                                                                        start: {
                                                                            line: 108,
                                                                            column: 29,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Dialog.ion'
                                                                        },
                                                                        end: {
                                                                            line: 108,
                                                                            column: 34,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Dialog.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 108,
                                                                        column: 15,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Dialog.ion'
                                                                    },
                                                                    end: {
                                                                        line: 108,
                                                                        column: 34,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Dialog.ion'
                                                                    }
                                                                }
                                                            },
                                                            right: {
                                                                type: 'Literal',
                                                                value: 'all'
                                                            }
                                                        },
                                                        right: {
                                                            type: 'BinaryExpression',
                                                            operator: '===',
                                                            left: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'dialogElement',
                                                                    loc: {
                                                                        start: {
                                                                            line: 108,
                                                                            column: 47,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Dialog.ion'
                                                                        },
                                                                        end: {
                                                                            line: 108,
                                                                            column: 60,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Dialog.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'close',
                                                                    loc: {
                                                                        start: {
                                                                            line: 108,
                                                                            column: 61,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Dialog.ion'
                                                                        },
                                                                        end: {
                                                                            line: 108,
                                                                            column: 66,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Dialog.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 108,
                                                                        column: 47,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Dialog.ion'
                                                                    },
                                                                    end: {
                                                                        line: 108,
                                                                        column: 66,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Dialog.ion'
                                                                    }
                                                                }
                                                            },
                                                            right: {
                                                                type: 'Literal',
                                                                value: 'mouse'
                                                            }
                                                        }
                                                    },
                                                    consequent: {
                                                        type: 'BlockStatement',
                                                        body: [{
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'Function',
                                                                    context: false,
                                                                    value: function click(e) {
                                                                        e.stopPropagation();
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 109,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Dialog.ion'
                                                                    },
                                                                    end: {
                                                                        line: 112,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Dialog.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    alternate: null,
                                                    order: '0'
                                                }]
                                        }
                                    }],
                                kind: 'let',
                                order: '3'
                            },
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'frame',
                                    loc: {
                                        start: {
                                            line: 112,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/Dialog.ion'
                                        },
                                        end: {
                                            line: 112,
                                            column: 13,
                                            fixed: true,
                                            source: 'glass/html/material/Dialog.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'Identifier',
                                    name: 'frame',
                                    loc: {
                                        start: {
                                            line: 112,
                                            column: 15,
                                            fixed: true,
                                            source: 'glass/html/material/Dialog.ion'
                                        },
                                        end: {
                                            line: 112,
                                            column: 20,
                                            fixed: true,
                                            source: 'glass/html/material/Dialog.ion'
                                        }
                                    }
                                },
                                kind: 'init',
                                order: '4'
                            },
                            {
                                type: 'ExpressionStatement',
                                expression: {
                                    type: 'ObjectExpression',
                                    objectType: {
                                        type: 'Identifier',
                                        name: 'frame',
                                        loc: {
                                            start: {
                                                line: 113,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Dialog.ion'
                                            },
                                            end: {
                                                line: 113,
                                                column: 13,
                                                fixed: true,
                                                source: 'glass/html/material/Dialog.ion'
                                            }
                                        }
                                    },
                                    properties: [
                                        {
                                            type: 'IfStatement',
                                            test: {
                                                type: 'UnaryExpression',
                                                operator: '?',
                                                argument: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'dialogElement',
                                                        loc: {
                                                            start: {
                                                                line: 116,
                                                                column: 15,
                                                                fixed: true,
                                                                source: 'glass/html/material/Dialog.ion'
                                                            },
                                                            end: {
                                                                line: 116,
                                                                column: 28,
                                                                fixed: true,
                                                                source: 'glass/html/material/Dialog.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'title',
                                                        loc: {
                                                            start: {
                                                                line: 116,
                                                                column: 29,
                                                                fixed: true,
                                                                source: 'glass/html/material/Dialog.ion'
                                                            },
                                                            end: {
                                                                line: 116,
                                                                column: 34,
                                                                fixed: true,
                                                                source: 'glass/html/material/Dialog.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 116,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Dialog.ion'
                                                        },
                                                        end: {
                                                            line: 116,
                                                            column: 34,
                                                            fixed: true,
                                                            source: 'glass/html/material/Dialog.ion'
                                                        }
                                                    }
                                                }
                                            },
                                            consequent: {
                                                type: 'BlockStatement',
                                                body: [{
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'ObjectExpression',
                                                            objectType: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Identifier',
                                                                    name: 'H1',
                                                                    loc: {
                                                                        start: {
                                                                            line: 117,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Dialog.ion'
                                                                        },
                                                                        end: {
                                                                            line: 117,
                                                                            column: 18,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Dialog.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'ObjectExpression',
                                                                        properties: [{
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'class',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 117,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Dialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 117,
                                                                                            column: 25,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Dialog.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Literal',
                                                                                    value: 'typography title'
                                                                                },
                                                                                kind: 'init',
                                                                                order: '0'
                                                                            }]
                                                                    }],
                                                                loc: {
                                                                    start: {
                                                                        line: 117,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Dialog.ion'
                                                                    },
                                                                    end: {
                                                                        line: 117,
                                                                        column: 46,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Dialog.ion'
                                                                    }
                                                                }
                                                            },
                                                            properties: [{
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'dialogElement',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 118,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Dialog.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 118,
                                                                                    column: 33,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Dialog.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'title',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 118,
                                                                                    column: 34,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Dialog.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 118,
                                                                                    column: 39,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Dialog.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 118,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Dialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 118,
                                                                                column: 39,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Dialog.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 118,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Dialog.ion'
                                                                        },
                                                                        end: {
                                                                            line: 118,
                                                                            column: 39,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Dialog.ion'
                                                                        }
                                                                    },
                                                                    order: '0'
                                                                }]
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 117,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/Dialog.ion'
                                                            },
                                                            end: {
                                                                line: 120,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'glass/html/material/Dialog.ion'
                                                            }
                                                        },
                                                        order: '0'
                                                    }]
                                            },
                                            alternate: null,
                                            order: '0'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'classList',
                                                loc: {
                                                    start: {
                                                        line: 120,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/Dialog.ion'
                                                    },
                                                    end: {
                                                        line: 120,
                                                        column: 21,
                                                        fixed: true,
                                                        source: 'glass/html/material/Dialog.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'ObjectExpression',
                                                properties: [{
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'ConditionalExpression',
                                                            test: {
                                                                type: 'Identifier',
                                                                name: 'z',
                                                                loc: {
                                                                    start: {
                                                                        line: 121,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Dialog.ion'
                                                                    },
                                                                    end: {
                                                                        line: 121,
                                                                        column: 17,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Dialog.ion'
                                                                    }
                                                                }
                                                            },
                                                            consequent: {
                                                                type: 'BinaryExpression',
                                                                operator: '+',
                                                                left: {
                                                                    type: 'Literal',
                                                                    value: 'z'
                                                                },
                                                                right: {
                                                                    type: 'Identifier',
                                                                    name: 'z',
                                                                    loc: {
                                                                        start: {
                                                                            line: 121,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Dialog.ion'
                                                                        },
                                                                        end: {
                                                                            line: 121,
                                                                            column: 25,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Dialog.ion'
                                                                        }
                                                                    }
                                                                }
                                                            },
                                                            alternate: {
                                                                type: 'Literal',
                                                                value: 'z3'
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 121,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/Dialog.ion'
                                                            },
                                                            end: {
                                                                line: 121,
                                                                column: 35,
                                                                fixed: true,
                                                                source: 'glass/html/material/Dialog.ion'
                                                            }
                                                        },
                                                        order: '0'
                                                    }]
                                            },
                                            kind: 'init',
                                            order: '1'
                                        }
                                    ]
                                },
                                loc: {
                                    start: {
                                        line: 113,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/Dialog.ion'
                                    },
                                    end: {
                                        line: 125,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/Dialog.ion'
                                    }
                                },
                                order: '5'
                            }
                        ]
                    },
                    order: '6'
                }
            ],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'Dialog',
                loc: {
                    start: {
                        line: 50,
                        column: 4,
                        fixed: true,
                        source: 'glass/html/material/Dialog.ion'
                    },
                    end: {
                        line: 50,
                        column: 10,
                        fixed: true,
                        source: 'glass/html/material/Dialog.ion'
                    }
                }
            }
        }, {
            this: this,
            _ref2: _ref2,
            style: style,
            _ref: _ref,
            focusDescendant: focusDescendant,
            Dialog: Dialog
        }, null);
    });
module.exports = exports = ion.patch.combine(Dialog, {
    show: function (dialogTemplateFunction, properties) {
        var template = dialogTemplateFunction(properties);
        var dialog = null;
        var listener = function (value) {
            if (value != null) {
                value.open = true;
                dialog = value;
                document.body.appendChild(dialog);
                dialog.focus != null ? dialog.focus() : void 0;
                var _ref3 = dialog;
                ion.add(_ref3, function close(e) {
                    unobserve();
                });
                _ref3;
            } else if (dialog != null) {
                dialog.parentElement.removeChild(dialog);
                dialog = null;
            }
        };
        var unobserve = template.observe(listener);
    }
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/Dialog',_glass_html_material_Dialog_);
    else
      _glass_html_material_Dialog_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_Dialog_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_DragMover_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('../DragHelper'), _ref2, rectContainsPoint = function (rect, x, y) {
        return x >= rect.x && x <= rect.x + rect.width && y >= rect.y && y <= rect.y + rect.height;
    };
var captureMouse = _ref.captureMouse;
_ref2 = require('../');
var style = _ref2.style;
var _ref4 = style.sheets;
_ref4[module.id] = '.DragMover-DropTarget {\n    display: block;\n    position: absolute;\n    border: solid 2px black;\n}\n.DragMover-BlockEverything {\n    display: block;\n    position: absolute;\n    left: 0px;\n    top: 0px;\n    width: 100%;\n    height: 100%;\n    cursor: grabbing;\n    cursor: -webkit-grabbing;\n}\n.DragMover-BlockEverything.invalidDrop {\n    cursor: no-drop;\n}\n.DragMover-DropPointer {\n    left: 20px;\n    top: 20px;\n    position: absolute;\n    display: block;\n    width: 0px;\n    height: 0px;\n    transition:\n        transform 400ms cubic-bezier(0.77, 0, 0.175, 1),\n        left 200ms cubic-bezier(0.77, 0, 0.175, 1),\n        top 200ms cubic-bezier(0.77, 0, 0.175, 1)\n}\n.DragMover-DropPointer > IRON-ICON {\n    position: absolute;\n    color: ' + style.color.accent + ';\n    top: calc(50% - 20px);\n    left: calc(50% - 40px + 5px);\n    width: 40px;\n    height: 40px;\n    opacity: 1;\n    transition:\n        opacity 400ms cubic-bezier(0.77, 0, 0.175, 1)\n}\n.DragMover-BlockEverything.invalidDrop .DragMover-DropPointer > IRON-ICON {\n    opacity: 0;\n}';
_ref4;
var dragMove = exports.dragMove = function (_ref3) {
        var event = _ref3.event;
        var dragElement = _ref3.dragElement;
        var dropTargets = _ref3.dropTargets;
        event.stopPropagation();
        var debug = false;
        var debugRects = [];
        if (debug) {
            for (var _i = 0; _i < dropTargets.length; _i++) {
                var _ref5 = dropTargets[_i];
                var rect = _ref5.rect;
                var handler = _ref5.handler;
                var name = _ref5.name;
                console.log('rect', rect);
                var span = Span({ class: 'DragMover-DropTarget' });
                ion.add(span, name);
                span.style.left = rect.x + 'px';
                span.style.top = rect.y + 'px';
                span.style.width = rect.width + 'px';
                span.style.height = rect.height + 'px';
                document.body.appendChild(span);
                debugRects.push(span);
            }
        }
        var dropPointer = Span({ class: 'DragMover-DropPointer transition' });
        ion.add(dropPointer, ion.patch.combine(IronIcon(), { icon: 'av:play-arrow' }));
        var blockInput = Span({ class: 'DragMover-BlockEverything' });
        ion.add(blockInput, dropPointer);
        document.body.appendChild(blockInput);
        var currentDropTarget = null;
        var pickDropTarget = function (x, y) {
            for (var _i2 = 0; _i2 < dropTargets.length; _i2++) {
                var dropTarget = dropTargets[_i2];
                if (rectContainsPoint(dropTarget.rect, x, y)) {
                    return dropTarget;
                }
            }
        };
        var updateDropTarget = function (x, y) {
            var newDropTarget = pickDropTarget(x, y);
            if (currentDropTarget !== newDropTarget) {
                currentDropTarget = newDropTarget;
                if (debug) {
                    console.log('New Drop Target: ' + (newDropTarget != null ? newDropTarget.name : void 0));
                }
            }
            blockInput.classList.toggle('invalidDrop', !(currentDropTarget != null));
            if (currentDropTarget != null) {
                dropPointer.style.left = currentDropTarget.pointerX + 'px';
                dropPointer.style.top = currentDropTarget.pointerY + 'px';
                dropPointer.style.transform = 'rotateZ(' + currentDropTarget.pointerRotation + 'deg)';
            }
        };
        dropPointer.style.left = event.pageX + 'px';
        dropPointer.style.top = event.pageY + 'px';
        updateDropTarget(event.pageX, event.pageY);
        var cleanup = function () {
            document.body.removeChild(blockInput);
            if (debug) {
                console.log('cleanup');
            }
            for (var _i3 = 0; _i3 < debugRects.length; _i3++) {
                var rect = debugRects[_i3];
                document.body.removeChild(rect);
            }
        };
        captureMouse(event, {
            mousemove: function (e) {
                updateDropTarget(e.pageX, e.pageY);
            },
            mouseup: function (e) {
                cleanup();
                if (currentDropTarget != null) {
                    currentDropTarget.handler != null ? currentDropTarget.handler() : void 0;
                }
                if (debug) {
                    console.log('mouseup', e.pageX, e.pageY);
                }
            },
            mouseleave: function (e) {
                cleanup();
                if (debug) {
                    console.log('mouseleave', e.pageX, e.pageY);
                }
            }
        });
    };
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/DragMover',_glass_html_material_DragMover_);
    else
      _glass_html_material_DragMover_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_DragMover_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_Drawer_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('../'), _ref2, _ref3;
var style = _ref.style;
_ref2 = require('./');
var Resizable = _ref2.Resizable;
_ref3 = require('../functions');
var focusDescendant = _ref3.focusDescendant;
var _ref4 = style.sheets;
_ref4[module.id] = '.Drawer {\n    z-index: 4;\n    transition:\n        left 400ms cubic-bezier(0.77, 0, 0.175, 1),\n        box-shadow 600ms cubic-bezier(0.77, 0, 0.175, 1);\n}\n.Drawer:not(.pinned) {\n    position: absolute;\n}\n.Drawer.left, .Drawer.right {\n    height: 100%;\n}\n.Drawer.top, .Drawer.bottom {\n    width: 100%;\n}';
_ref4;
module.exports = exports = ion.template(function (attributes) {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'state',
                            loc: {
                                start: {
                                    line: 25,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/Drawer.ion'
                                },
                                end: {
                                    line: 25,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/html/material/Drawer.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'pinned',
                                        loc: {
                                            start: {
                                                line: 26,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Drawer.ion'
                                            },
                                            end: {
                                                line: 26,
                                                column: 14,
                                                fixed: true,
                                                source: 'glass/html/material/Drawer.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: false
                                    },
                                    kind: 'init',
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'open',
                                        loc: {
                                            start: {
                                                line: 27,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Drawer.ion'
                                            },
                                            end: {
                                                line: 27,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/Drawer.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: false
                                    },
                                    kind: 'init',
                                    order: '1'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'side',
                                        loc: {
                                            start: {
                                                line: 28,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Drawer.ion'
                                            },
                                            end: {
                                                line: 28,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/Drawer.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: 'left'
                                    },
                                    kind: 'init',
                                    order: '2'
                                }
                            ]
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'element',
                            loc: {
                                start: {
                                    line: 29,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/Drawer.ion'
                                },
                                end: {
                                    line: 29,
                                    column: 15,
                                    fixed: true,
                                    source: 'glass/html/material/Drawer.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Resizable',
                                loc: {
                                    start: {
                                        line: 29,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/material/Drawer.ion'
                                    },
                                    end: {
                                        line: 29,
                                        column: 27,
                                        fixed: true,
                                        source: 'glass/html/material/Drawer.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'Identifier',
                                    name: 'attributes',
                                    loc: {
                                        start: {
                                            line: 29,
                                            column: 28,
                                            fixed: true,
                                            source: 'glass/html/material/Drawer.ion'
                                        },
                                        end: {
                                            line: 29,
                                            column: 38,
                                            fixed: true,
                                            source: 'glass/html/material/Drawer.ion'
                                        }
                                    }
                                }],
                            loc: {
                                start: {
                                    line: 29,
                                    column: 18,
                                    fixed: true,
                                    source: 'glass/html/material/Drawer.ion'
                                },
                                end: {
                                    line: 29,
                                    column: 39,
                                    fixed: true,
                                    source: 'glass/html/material/Drawer.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'CallExpression',
                    callee: {
                        type: 'MemberExpression',
                        object: {
                            type: 'Identifier',
                            name: 'Object'
                        },
                        property: {
                            type: 'Identifier',
                            name: 'defineProperties'
                        }
                    },
                    arguments: [
                        {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'Identifier',
                                name: 'element',
                                loc: {
                                    start: {
                                        line: 30,
                                        column: 11,
                                        fixed: true,
                                        source: 'glass/html/material/Drawer.ion'
                                    },
                                    end: {
                                        line: 30,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/material/Drawer.ion'
                                    }
                                }
                            },
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'classList',
                                        loc: {
                                            start: {
                                                line: 31,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Drawer.ion'
                                            },
                                            end: {
                                                line: 31,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/Drawer.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'Literal',
                                                    value: 'Drawer'
                                                },
                                                loc: {
                                                    start: {
                                                        line: 32,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/Drawer.ion'
                                                    },
                                                    end: {
                                                        line: 32,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'glass/html/material/Drawer.ion'
                                                    }
                                                },
                                                order: '0'
                                            },
                                            {
                                                type: 'IfStatement',
                                                test: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'state',
                                                        loc: {
                                                            start: {
                                                                line: 33,
                                                                column: 15,
                                                                fixed: true,
                                                                source: 'glass/html/material/Drawer.ion'
                                                            },
                                                            end: {
                                                                line: 33,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'glass/html/material/Drawer.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'pinned',
                                                        loc: {
                                                            start: {
                                                                line: 33,
                                                                column: 21,
                                                                fixed: true,
                                                                source: 'glass/html/material/Drawer.ion'
                                                            },
                                                            end: {
                                                                line: 33,
                                                                column: 27,
                                                                fixed: true,
                                                                source: 'glass/html/material/Drawer.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 33,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Drawer.ion'
                                                        },
                                                        end: {
                                                            line: 33,
                                                            column: 27,
                                                            fixed: true,
                                                            source: 'glass/html/material/Drawer.ion'
                                                        }
                                                    }
                                                },
                                                consequent: {
                                                    type: 'BlockStatement',
                                                    body: [
                                                        {
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'Literal',
                                                                value: 'pinned'
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 34,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Drawer.ion'
                                                                },
                                                                end: {
                                                                    line: 34,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Drawer.ion'
                                                                }
                                                            },
                                                            order: '0'
                                                        },
                                                        {
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'Literal',
                                                                value: 'z1'
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 35,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Drawer.ion'
                                                                },
                                                                end: {
                                                                    line: 35,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Drawer.ion'
                                                                }
                                                            },
                                                            order: '1'
                                                        }
                                                    ]
                                                },
                                                alternate: {
                                                    type: 'BlockStatement',
                                                    body: [{
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'Literal',
                                                                value: 'z4'
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 37,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Drawer.ion'
                                                                },
                                                                end: {
                                                                    line: 37,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Drawer.ion'
                                                                }
                                                            },
                                                            order: '0'
                                                        }]
                                                },
                                                order: '1'
                                            },
                                            {
                                                type: 'IfStatement',
                                                test: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'state',
                                                        loc: {
                                                            start: {
                                                                line: 38,
                                                                column: 15,
                                                                fixed: true,
                                                                source: 'glass/html/material/Drawer.ion'
                                                            },
                                                            end: {
                                                                line: 38,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'glass/html/material/Drawer.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'open',
                                                        loc: {
                                                            start: {
                                                                line: 38,
                                                                column: 21,
                                                                fixed: true,
                                                                source: 'glass/html/material/Drawer.ion'
                                                            },
                                                            end: {
                                                                line: 38,
                                                                column: 25,
                                                                fixed: true,
                                                                source: 'glass/html/material/Drawer.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 38,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Drawer.ion'
                                                        },
                                                        end: {
                                                            line: 38,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'glass/html/material/Drawer.ion'
                                                        }
                                                    }
                                                },
                                                consequent: {
                                                    type: 'BlockStatement',
                                                    body: [{
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'Literal',
                                                                value: 'open'
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 39,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Drawer.ion'
                                                                },
                                                                end: {
                                                                    line: 39,
                                                                    column: 22,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Drawer.ion'
                                                                }
                                                            },
                                                            order: '0'
                                                        }]
                                                },
                                                alternate: null,
                                                order: '2'
                                            },
                                            {
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'state',
                                                        loc: {
                                                            start: {
                                                                line: 40,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'glass/html/material/Drawer.ion'
                                                            },
                                                            end: {
                                                                line: 40,
                                                                column: 17,
                                                                fixed: true,
                                                                source: 'glass/html/material/Drawer.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'side',
                                                        loc: {
                                                            start: {
                                                                line: 40,
                                                                column: 18,
                                                                fixed: true,
                                                                source: 'glass/html/material/Drawer.ion'
                                                            },
                                                            end: {
                                                                line: 40,
                                                                column: 22,
                                                                fixed: true,
                                                                source: 'glass/html/material/Drawer.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 40,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Drawer.ion'
                                                        },
                                                        end: {
                                                            line: 40,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'glass/html/material/Drawer.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 40,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/Drawer.ion'
                                                    },
                                                    end: {
                                                        line: 40,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'glass/html/material/Drawer.ion'
                                                    }
                                                },
                                                order: '3'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'style',
                                        loc: {
                                            start: {
                                                line: 41,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Drawer.ion'
                                            },
                                            end: {
                                                line: 41,
                                                column: 13,
                                                fixed: true,
                                                source: 'glass/html/material/Drawer.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'IfStatement',
                                                test: {
                                                    type: 'BinaryExpression',
                                                    operator: '===',
                                                    left: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'state',
                                                            loc: {
                                                                start: {
                                                                    line: 42,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Drawer.ion'
                                                                },
                                                                end: {
                                                                    line: 42,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Drawer.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'side',
                                                            loc: {
                                                                start: {
                                                                    line: 42,
                                                                    column: 21,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Drawer.ion'
                                                                },
                                                                end: {
                                                                    line: 42,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Drawer.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 42,
                                                                column: 15,
                                                                fixed: true,
                                                                source: 'glass/html/material/Drawer.ion'
                                                            },
                                                            end: {
                                                                line: 42,
                                                                column: 25,
                                                                fixed: true,
                                                                source: 'glass/html/material/Drawer.ion'
                                                            }
                                                        }
                                                    },
                                                    right: {
                                                        type: 'Literal',
                                                        value: 'left'
                                                    }
                                                },
                                                consequent: {
                                                    type: 'BlockStatement',
                                                    body: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'left',
                                                                loc: {
                                                                    start: {
                                                                        line: 43,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Drawer.ion'
                                                                    },
                                                                    end: {
                                                                        line: 43,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Drawer.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'BinaryExpression',
                                                                operator: '+',
                                                                left: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '+',
                                                                    left: {
                                                                        type: 'Literal',
                                                                        value: ''
                                                                    },
                                                                    right: {
                                                                        type: 'ConditionalExpression',
                                                                        test: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'state',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 43,
                                                                                        column: 25,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Drawer.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 43,
                                                                                        column: 30,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Drawer.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'open',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 43,
                                                                                        column: 31,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Drawer.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 43,
                                                                                        column: 35,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Drawer.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 43,
                                                                                    column: 25,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Drawer.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 43,
                                                                                    column: 35,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Drawer.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        consequent: {
                                                                            type: 'Literal',
                                                                            value: 0
                                                                        },
                                                                        alternate: {
                                                                            type: 'BinaryExpression',
                                                                            operator: '-',
                                                                            left: {
                                                                                type: 'UnaryExpression',
                                                                                operator: '-',
                                                                                argument: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'element',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 43,
                                                                                                column: 43,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Drawer.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 43,
                                                                                                column: 50,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Drawer.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'width',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 43,
                                                                                                column: 51,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Drawer.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 43,
                                                                                                column: 56,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Drawer.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 43,
                                                                                            column: 43,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Drawer.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 43,
                                                                                            column: 56,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Drawer.ion'
                                                                                        }
                                                                                    }
                                                                                }
                                                                            },
                                                                            right: {
                                                                                type: 'Literal',
                                                                                value: 10
                                                                            }
                                                                        }
                                                                    }
                                                                },
                                                                right: {
                                                                    type: 'Literal',
                                                                    value: 'px'
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                },
                                                alternate: null,
                                                order: '0'
                                            }]
                                    },
                                    kind: 'init',
                                    order: '1'
                                }
                            ]
                        },
                        {
                            type: 'ObjectExpression',
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'side',
                                        loc: {
                                            start: {
                                                line: 44,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/Drawer.ion'
                                            },
                                            end: {
                                                line: 44,
                                                column: 21,
                                                fixed: true,
                                                source: 'glass/html/material/Drawer.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 45,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Drawer.ion'
                                                        },
                                                        end: {
                                                            line: 45,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Drawer.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context) {
                                                        return function () {
                                                            var state = _context.get('state');
                                                            return state.side;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 46,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Drawer.ion'
                                                        },
                                                        end: {
                                                            line: 46,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Drawer.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context2) {
                                                        return function (value) {
                                                            var state = _context2.get('state');
                                                            return state.side = value;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'pinned',
                                        loc: {
                                            start: {
                                                line: 47,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/Drawer.ion'
                                            },
                                            end: {
                                                line: 47,
                                                column: 23,
                                                fixed: true,
                                                source: 'glass/html/material/Drawer.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 48,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Drawer.ion'
                                                        },
                                                        end: {
                                                            line: 48,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Drawer.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context3) {
                                                        return function () {
                                                            var state = _context3.get('state');
                                                            return state.pinned;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 49,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Drawer.ion'
                                                        },
                                                        end: {
                                                            line: 49,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Drawer.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context4) {
                                                        return function (value) {
                                                            var state = _context4.get('state');
                                                            return state.pinned = value;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '1'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'open',
                                        loc: {
                                            start: {
                                                line: 50,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/Drawer.ion'
                                            },
                                            end: {
                                                line: 50,
                                                column: 21,
                                                fixed: true,
                                                source: 'glass/html/material/Drawer.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 51,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Drawer.ion'
                                                        },
                                                        end: {
                                                            line: 51,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Drawer.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context5) {
                                                        return function () {
                                                            var state = _context5.get('state');
                                                            return state.open;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 52,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Drawer.ion'
                                                        },
                                                        end: {
                                                            line: 52,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Drawer.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context6) {
                                                        return function (value) {
                                                            var state = _context6.get('state'), focusDescendant = _context6.get('focusDescendant');
                                                            state.open = value;
                                                            if (!value) {
                                                                focusDescendant(document.body);
                                                            }
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '2'
                                }
                            ]
                        }
                    ]
                },
                order: '2'
            }
        ],
        bound: false
    }, {
        this: this,
        attributes: attributes,
        _ref: _ref,
        _ref2: _ref2,
        _ref3: _ref3,
        style: style,
        Resizable: Resizable,
        focusDescendant: focusDescendant,
        _ref4: _ref4
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/Drawer',_glass_html_material_Drawer_);
    else
      _glass_html_material_Drawer_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_Drawer_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_Field_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('./'), _ref2;
var DateTimeField = _ref.DateTimeField;
var TextField = _ref.TextField;
var RelationInput = _ref.RelationInput;
var MultiRelationInput = _ref.MultiRelationInput;
_ref2 = require('../forms');
var Field = _ref2.Field;
module.exports = exports = ion.template(function OldField(args) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'OldField',
            loc: {
                start: {
                    line: 9,
                    column: 16,
                    fixed: true,
                    source: 'glass/html/material/Field.ion'
                },
                end: {
                    line: 9,
                    column: 24,
                    fixed: true,
                    source: 'glass/html/material/Field.ion'
                }
            }
        },
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'field',
                            loc: {
                                start: {
                                    line: 10,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/Field.ion'
                                },
                                end: {
                                    line: 10,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/html/material/Field.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Field',
                                loc: {
                                    start: {
                                        line: 10,
                                        column: 16,
                                        fixed: true,
                                        source: 'glass/html/material/Field.ion'
                                    },
                                    end: {
                                        line: 10,
                                        column: 21,
                                        fixed: true,
                                        source: 'glass/html/material/Field.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'Identifier',
                                    name: 'args',
                                    loc: {
                                        start: {
                                            line: 10,
                                            column: 22,
                                            fixed: true,
                                            source: 'glass/html/material/Field.ion'
                                        },
                                        end: {
                                            line: 10,
                                            column: 26,
                                            fixed: true,
                                            source: 'glass/html/material/Field.ion'
                                        }
                                    }
                                }],
                            loc: {
                                start: {
                                    line: 10,
                                    column: 16,
                                    fixed: true,
                                    source: 'glass/html/material/Field.ion'
                                },
                                end: {
                                    line: 10,
                                    column: 27,
                                    fixed: true,
                                    source: 'glass/html/material/Field.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'IfStatement',
                test: {
                    type: 'UnaryExpression',
                    operator: '?',
                    argument: {
                        type: 'Identifier',
                        name: 'field',
                        loc: {
                            start: {
                                line: 11,
                                column: 7,
                                fixed: true,
                                source: 'glass/html/material/Field.ion'
                            },
                            end: {
                                line: 11,
                                column: 12,
                                fixed: true,
                                source: 'glass/html/material/Field.ion'
                            }
                        }
                    }
                },
                consequent: {
                    type: 'BlockStatement',
                    body: [{
                            type: 'ReturnStatement',
                            argument: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'Identifier',
                                    name: 'field',
                                    loc: {
                                        start: {
                                            line: 12,
                                            column: 15,
                                            fixed: true,
                                            source: 'glass/html/material/Field.ion'
                                        },
                                        end: {
                                            line: 12,
                                            column: 20,
                                            fixed: true,
                                            source: 'glass/html/material/Field.ion'
                                        }
                                    }
                                },
                                properties: [{
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'classList',
                                            loc: {
                                                start: {
                                                    line: 13,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/Field.ion'
                                                },
                                                end: {
                                                    line: 13,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'glass/html/material/Field.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'ObjectExpression',
                                            properties: [{
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'Literal',
                                                        value: 'Field'
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 14,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/Field.ion'
                                                        },
                                                        end: {
                                                            line: 14,
                                                            column: 23,
                                                            fixed: true,
                                                            source: 'glass/html/material/Field.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        kind: 'init',
                                        order: '0'
                                    }]
                            },
                            order: '0'
                        }]
                },
                alternate: null,
                order: '1'
            }
        ],
        bound: false
    }, {
        this: this,
        args: args,
        _ref: _ref,
        _ref2: _ref2,
        DateTimeField: DateTimeField,
        TextField: TextField,
        RelationInput: RelationInput,
        MultiRelationInput: MultiRelationInput,
        Field: Field
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/Field',_glass_html_material_Field_);
    else
      _glass_html_material_Field_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_Field_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_Form_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('../');
var style = _ref.style;
style.define(module.id, '.Form {\n    display: inline-block;\n}');
module.exports = exports = ion.template(function (attributes) {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [{
                type: 'ReturnStatement',
                argument: {
                    type: 'CallExpression',
                    callee: {
                        type: 'MemberExpression',
                        object: {
                            type: 'Identifier',
                            name: 'Object'
                        },
                        property: {
                            type: 'Identifier',
                            name: 'defineProperties'
                        }
                    },
                    arguments: [
                        {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Div',
                                    loc: {
                                        start: {
                                            line: 14,
                                            column: 11,
                                            fixed: true,
                                            source: 'glass/html/material/Form.ion'
                                        },
                                        end: {
                                            line: 14,
                                            column: 14,
                                            fixed: true,
                                            source: 'glass/html/material/Form.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'Identifier',
                                        name: 'attributes',
                                        loc: {
                                            start: {
                                                line: 14,
                                                column: 15,
                                                fixed: true,
                                                source: 'glass/html/material/Form.ion'
                                            },
                                            end: {
                                                line: 14,
                                                column: 25,
                                                fixed: true,
                                                source: 'glass/html/material/Form.ion'
                                            }
                                        }
                                    }],
                                loc: {
                                    start: {
                                        line: 14,
                                        column: 11,
                                        fixed: true,
                                        source: 'glass/html/material/Form.ion'
                                    },
                                    end: {
                                        line: 14,
                                        column: 26,
                                        fixed: true,
                                        source: 'glass/html/material/Form.ion'
                                    }
                                }
                            },
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'classList',
                                        loc: {
                                            start: {
                                                line: 17,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Form.ion'
                                            },
                                            end: {
                                                line: 17,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/Form.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'Literal',
                                                    value: 'Form'
                                                },
                                                loc: {
                                                    start: {
                                                        line: 18,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/Form.ion'
                                                    },
                                                    end: {
                                                        line: 18,
                                                        column: 18,
                                                        fixed: true,
                                                        source: 'glass/html/material/Form.ion'
                                                    }
                                                },
                                                order: '0'
                                            }]
                                    },
                                    kind: 'init',
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'focus',
                                        loc: {
                                            start: {
                                                line: 19,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Form.ion'
                                            },
                                            end: {
                                                line: 19,
                                                column: 13,
                                                fixed: true,
                                                source: 'glass/html/material/Form.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: false,
                                        value: function () {
                                            {
                                                var _ref2 = this.fields;
                                                for (var name in _ref2) {
                                                    var field = _ref2[name];
                                                    if (field.focus != null) {
                                                        field.focus();
                                                        return;
                                                    }
                                                }
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '1'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'select',
                                        loc: {
                                            start: {
                                                line: 24,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Form.ion'
                                            },
                                            end: {
                                                line: 24,
                                                column: 14,
                                                fixed: true,
                                                source: 'glass/html/material/Form.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: false,
                                        value: function () {
                                            {
                                                var _ref3 = this.fields;
                                                for (var name in _ref3) {
                                                    var field = _ref3[name];
                                                    if (field.select != null) {
                                                        field.select();
                                                        return;
                                                    }
                                                }
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '2'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'validate',
                                        loc: {
                                            start: {
                                                line: 41,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Form.ion'
                                            },
                                            end: {
                                                line: 41,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/Form.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: false,
                                        value: function () {
                                            var valid = true;
                                            {
                                                var _ref4 = this.fields;
                                                for (var name in _ref4) {
                                                    var field = _ref4[name];
                                                    if (field.validate != null && !field.validate()) {
                                                        if (valid) {
                                                            field.focus();
                                                        }
                                                        valid = false;
                                                        break;
                                                    }
                                                }
                                            }
                                            return valid;
                                        }
                                    },
                                    kind: 'init',
                                    order: '3'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'submit',
                                        loc: {
                                            start: {
                                                line: 50,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Form.ion'
                                            },
                                            end: {
                                                line: 50,
                                                column: 14,
                                                fixed: true,
                                                source: 'glass/html/material/Form.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: false,
                                        value: function (e) {
                                            if (this.validate()) {
                                                var detail = {
                                                        srcEvent: e,
                                                        fields: this.fields,
                                                        values: this.values
                                                    };
                                                this.dispatchEvent(new CustomEvent('submit', { detail: detail }));
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '4'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'Function',
                                        context: false,
                                        value: function keydown(e) {
                                            if (e.keyCode === 13) {
                                                this.submit(e);
                                                e.stopPropagation();
                                                e.preventDefault();
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 54,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/Form.ion'
                                        },
                                        end: {
                                            line: 60,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/material/Form.ion'
                                        }
                                    },
                                    order: '5'
                                }
                            ]
                        },
                        {
                            type: 'ObjectExpression',
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'fields',
                                        loc: {
                                            start: {
                                                line: 29,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/Form.ion'
                                            },
                                            end: {
                                                line: 29,
                                                column: 23,
                                                fixed: true,
                                                source: 'glass/html/material/Form.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 30,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Form.ion'
                                                        },
                                                        end: {
                                                            line: 30,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Form.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: false,
                                                    value: function () {
                                                        var _ref7 = {};
                                                        {
                                                            var _ref5 = this.querySelectorAll('.Field');
                                                            for (var _i = 0; _i < _ref5.length; _i++) {
                                                                var field = _ref5[_i];
                                                                if (field.name) {
                                                                    _ref7[field.name] = field;
                                                                }
                                                            }
                                                        }
                                                        return _ref7;
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'values',
                                        loc: {
                                            start: {
                                                line: 35,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/Form.ion'
                                            },
                                            end: {
                                                line: 35,
                                                column: 23,
                                                fixed: true,
                                                source: 'glass/html/material/Form.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 36,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Form.ion'
                                                        },
                                                        end: {
                                                            line: 36,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Form.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: false,
                                                    value: function () {
                                                        var _ref8 = {};
                                                        {
                                                            var _ref6 = this.fields;
                                                            for (var name in _ref6) {
                                                                var field = _ref6[name];
                                                                var value = field.valueJSON != null ? field.valueJSON : field.value;
                                                                _ref8[name] = value;
                                                            }
                                                        }
                                                        return _ref8;
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '1'
                                }
                            ]
                        }
                    ]
                },
                order: '0'
            }],
        bound: false
    }, {
        this: this,
        attributes: attributes,
        _ref: _ref,
        style: style
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/Form',_glass_html_material_Form_);
    else
      _glass_html_material_Form_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_Form_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_Icon_ = function(module,exports,require){'use strict';
var ion = require('ion');
var style = require('../style');
style.define(module.id, '.Icon {\n    flex: 0 0 auto;\n    display: inline-block;\n}');
var paths = {
        'none': '',
        'add': '<path d="M19 13h-6v6h-2v-6h-6v-2h6v-6h2v6h6v2z"/>',
        'add circle': '<path d="M12 2c-5.52 0-10 4.48-10 10s4.48 10 10 10 10-4.48 10-10-4.48-10-10-10zm5 11h-4v4h-2v-4h-4v-2h4v-4h2v4h4v2z"/>',
        'add circle outline': '<path d="M13 7h-2v4h-4v2h4v4h2v-4h4v-2h-4v-4zm-1-5c-5.52 0-10 4.48-10 10s4.48 10 10 10 10-4.48 10-10-4.48-10-10-10zm0 18c-4.41 0-8-3.59-8-8s3.59-8 8-8 8 3.59 8 8-3.59 8-8 8z"/>',
        'archive': '<path d="M20.54 5.23l-1.39-1.68C18.88 3.21 18.47 3 18 3H6c-.47 0-.88.21-1.16.55L3.46 5.23C3.17 5.57 3 6.02 3 6.5V19c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V6.5c0-.48-.17-.93-.46-1.27zM12 17.5L6.5 12H10v-2h4v2h3.5L12 17.5zM5.12 5l.81-1h12l.94 1H5.12z"/><path d="M0 0h24v24H0z" fill="none"/>',
        'arrow back': '<path d="M20 11h-12.17l5.59-5.59-1.42-1.41-8 8 8 8 1.41-1.41-5.58-5.59h12.17v-2z"/>',
        'arrow drop down': '<path d="M7 10l5 5 5-5z"/>',
        'arrow drop up': '<path d="M7 14l5-5 5 5z"/>',
        'arrow forward': '<path d="M12 4l-1.41 1.41 5.58 5.59h-12.17v2h12.17l-5.58 5.59 1.41 1.41 8-8z"/>',
        'attach file': '<path d="M16.5 6v11.5c0 2.21-1.79 4-4 4s-4-1.79-4-4V5c0-1.38 1.12-2.5 2.5-2.5s2.5 1.12 2.5 2.5v10.5c0 .55-.45 1-1 1s-1-.45-1-1V6H10v9.5c0 1.38 1.12 2.5 2.5 2.5s2.5-1.12 2.5-2.5V5c0-2.21-1.79-4-4-4S7 2.79 7 5v12.5c0 3.04 2.46 5.5 5.5 5.5s5.5-2.46 5.5-5.5V6h-1.5z"/>',
        'cancel': '<path d="M12 2C6.47 2 2 6.47 2 12s4.47 10 10 10 10-4.47 10-10S17.53 2 12 2zm5 13.59L15.59 17 12 13.41 8.41 17 7 15.59 10.59 12 7 8.41 8.41 7 12 10.59 15.59 7 17 8.41 13.41 12 17 15.59z"/>',
        'check box': '<path d="M19 3H5c-1.11 0-2 .9-2 2v14c0 1.1.89 2 2 2h14c1.11 0 2-.9 2-2V5c0-1.1-.89-2-2-2zm-9 14l-5-5 1.41-1.41L10 14.17l7.59-7.59L19 8l-9 9z"/>',
        'check box outline blank': '<path d="M19 5v14H5V5h14m0-2H5c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2z"/>',
        'clear': '<path d="M19 6.41l-1.41-1.41-5.59 5.59-5.59-5.59-1.41 1.41 5.59 5.59-5.59 5.59 1.41 1.41 5.59-5.59 5.59 5.59 1.41-1.41-5.59-5.59z"/>',
        'close': '<path d="M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12z"/><path d="M0 0h24v24H0z" fill="none"/>',
        'comment': '<path d="M21.99 4c0-1.1-.89-2-1.99-2h-16c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h14l4 4-.01-18zm-3.99 10h-12v-2h12v2zm0-3h-12v-2h12v2zm0-3h-12v-2h12v2z"/>',
        'content copy': '<path d="M16 1h-12c-1.1 0-2 .9-2 2v14h2v-14h12v-2zm3 4h-11c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h11c1.1 0 2-.9 2-2v-14c0-1.1-.9-2-2-2zm0 16h-11v-14h11v14z"/>',
        'content cut': '<circle cx="6" cy="18" r="2" fill="none"/>\n<circle cx="12" cy="12" r=".5" fill="none"/>\n<circle cx="6" cy="6" r="2" fill="none"/>\n<path d="M9.64 7.64c.23-.5.36-1.05.36-1.64 0-2.21-1.79-4-4-4s-4 1.79-4 4 1.79 4 4 4c.59 0 1.14-.13 1.64-.36l2.36 2.36-2.36 2.36c-.5-.23-1.05-.36-1.64-.36-2.21 0-4 1.79-4 4s1.79 4 4 4 4-1.79 4-4c0-.59-.13-1.14-.36-1.64l2.36-2.36 7 7h3v-1l-12.36-12.36zm-3.64.36c-1.1 0-2-.89-2-2s.9-2 2-2 2 .89 2 2-.9 2-2 2zm0 12c-1.1 0-2-.89-2-2s.9-2 2-2 2 .89 2 2-.9 2-2 2zm6-7.5c-.28 0-.5-.22-.5-.5s.22-.5.5-.5.5.22.5.5-.22.5-.5.5zm7-9.5l-6 6 2 2 7-7v-1z"/>',
        'content paste': '<path d="M19 2h-4.18c-.42-1.16-1.52-2-2.82-2-1.3 0-2.4.84-2.82 2h-4.18c-1.1 0-2 .9-2 2v16c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2v-16c0-1.1-.9-2-2-2zm-7 0c.55 0 1 .45 1 1s-.45 1-1 1-1-.45-1-1 .45-1 1-1zm7 18h-14v-16h2v3h10v-3h2v16z"/>',
        'date range': '<path d="M9 11H7v2h2v-2zm4 0h-2v2h2v-2zm4 0h-2v2h2v-2zm2-7h-1V2h-2v2H8V2H6v2H5c-1.11 0-1.99.9-1.99 2L3 20c0 1.1.89 2 2 2h14c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm0 16H5V9h14v11z"/>',
        'drag handle': '<defs>\n    <path id="a" d="M0 0h24v24H0V0z"/>\n</defs>\n<clipPath id="b">\n    <use xlink:href="#a" overflow="visible"/>\n</clipPath>\n<path clip-path="url(#b)" d="M20 9H4v2h16V9zM4 15h16v-2H4v2z"/>',
        'delete': '<path d="M6 19c0 1.1.9 2 2 2h8c1.1 0 2-.9 2-2V7H6v12zM19 4h-3.5l-1-1h-5l-1 1H5v2h14V4z"/><path d="M0 0h24v24H0z" fill="none"/>',
        'done': '<path d="M9 16.17l-4.17-4.17-1.42 1.41 5.59 5.59 12-12-1.41-1.41z"/>',
        'face': '<path d="M9 11.75c-.69 0-1.25.56-1.25 1.25s.56 1.25 1.25 1.25 1.25-.56 1.25-1.25-.56-1.25-1.25-1.25zm6 0c-.69 0-1.25.56-1.25 1.25s.56 1.25 1.25 1.25 1.25-.56 1.25-1.25-.56-1.25-1.25-1.25zM12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm0 18c-4.41 0-8-3.59-8-8 0-.29.02-.58.05-.86 2.36-1.05 4.23-2.98 5.21-5.37C11.07 8.33 14.05 10 17.42 10c.78 0 1.53-.09 2.25-.26.21.71.33 1.47.33 2.26 0 4.41-3.59 8-8 8z"/>',
        'filter list': '<path d="M10 18h4v-2h-4v2zM3 6v2h18V6H3zm3 7h12v-2H6v2z"/>',
        'folder': '<path d="M10 4H4c-1.1 0-1.99.9-1.99 2L2 18c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V8c0-1.1-.9-2-2-2h-8l-2-2z"/>',
        'folder open': '<path d="M20 6h-8l-2-2H4c-1.1 0-1.99.9-1.99 2L2 18c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V8c0-1.1-.9-2-2-2zm0 12H4V8h16v10z"/>',
        'grid on': '<path d="M20 2h-16c-1.1 0-2 .9-2 2v16c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2v-16c0-1.1-.9-2-2-2zm-12 18h-4v-4h4v4zm0-6h-4v-4h4v4zm0-6h-4v-4h4v4zm6 12h-4v-4h4v4zm0-6h-4v-4h4v4zm0-6h-4v-4h4v4zm6 12h-4v-4h4v4zm0-6h-4v-4h4v4zm0-6h-4v-4h4v4z"/>',
        'group add': '<path d="M8 10h-3v-3h-2v3h-3v2h3v3h2v-3h3v-2zm10 1c1.66 0 2.99-1.34 2.99-3s-1.33-3-2.99-3c-.32 0-.63.05-.91.14.57.81.9 1.79.9 2.86s-.34 2.04-.9 2.86c.28.09.59.14.91.14zm-5 0c1.66 0 2.99-1.34 2.99-3s-1.33-3-2.99-3c-1.66 0-3 1.34-3 3s1.34 3 3 3zm6.62 2.16c.83.73 1.38 1.66 1.38 2.84v2h3v-2c0-1.54-2.37-2.49-4.38-2.84zm-6.62-.16c-2 0-6 1-6 3v2h12v-2c0-2-4-3-6-3z"/>',
        'help outline': ' <path d="M11 18h2v-2h-2v2zm1-16C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm0 18c-4.41 0-8-3.59-8-8s3.59-8 8-8 8 3.59 8 8-3.59 8-8 8zm0-14c-2.21 0-4 1.79-4 4h2c0-1.1.9-2 2-2s2 .9 2 2c0 2-3 1.75-3 5h2c0-2.25 3-2.5 3-5 0-2.21-1.79-4-4-4z"/>',
        'highlight off': '<path d="M14.59 8L12 10.59 9.41 8 8 9.41 10.59 12 8 14.59 9.41 16 12 13.41 14.59 16 16 14.59 13.41 12 16 9.41 14.59 8zM12 2C6.47 2 2 6.47 2 12s4.47 10 10 10 10-4.47 10-10S17.53 2 12 2zm0 18c-4.41 0-8-3.59-8-8s3.59-8 8-8 8 3.59 8 8-3.59 8-8 8z"/>',
        'home': '<path d="M10 20v-6h4v6h5v-8h3l-10-9-10 9h3v8z"/>',
        'keyboard arrow down': '<path d="M7.41 7.84L12 12.42l4.59-4.58L18 9.25l-6 6-6-6z"/>',
        'keyboard arrow left': '<path d="M15.41 16.09l-4.58-4.59 4.58-4.59L14 5.5l-6 6 6 6z"/>',
        'keyboard arrow right': '<path d="M8.59 16.34l4.58-4.59-4.58-4.59L10 5.75l6 6-6 6z"/>',
        'keyboard arrow up': '<path d="M7.41 15.41L12 10.83l4.59 4.58L18 14l-6-6-6 6z"/>',
        'list': '<path d="M3 13h2v-2h-2v2zm0 4h2v-2h-2v2zm0-8h2v-2h-2v2zm4 4h14v-2h-14v2zm0 4h14v-2h-14v2zm0-10v2h14v-2h-14z"/>',
        'menu': '<path d="M3 18h18v-2h-18v2zm0-5h18v-2h-18v2zm0-7v2h18v-2h-18z"/>',
        'message': '<path d="M20 2h-16c-1.1 0-1.99.9-1.99 2l-.01 18 4-4h14c1.1 0 2-.9 2-2v-12c0-1.1-.9-2-2-2zm-2 12h-12v-2h12v2zm0-3h-12v-2h12v2zm0-3h-12v-2h12v2z"/>',
        'mode comment': '<path d="M21.99 4c0-1.1-.89-2-1.99-2H4c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h14l4 4-.01-18z"/>',
        'mode edit': '<path d="M3 17.25V21h3.75L17.81 9.94l-3.75-3.75L3 17.25zM20.71 7.04c.39-.39.39-1.02 0-1.41l-2.34-2.34c-.39-.39-1.02-.39-1.41 0l-1.83 1.83 3.75 3.75 1.83-1.83z"/>',
        'more vert': '<path d="M12 8c1.1 0 2-.9 2-2s-.9-2-2-2-2 .9-2 2 .9 2 2 2zm0 2c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2zm0 6c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2z"/>',
        'person': '<path d="M12 12c2.21 0 4-1.79 4-4s-1.79-4-4-4-4 1.79-4 4 1.79 4 4 4zm0 2c-2.67 0-8 1.34-8 4v2h16v-2c0-2.66-5.33-4-8-4z"/>',
        'people': '<path d="M16 11c1.66 0 2.99-1.34 2.99-3S17.66 5 16 5c-1.66 0-3 1.34-3 3s1.34 3 3 3zm-8 0c1.66 0 2.99-1.34 2.99-3S9.66 5 8 5C6.34 5 5 6.34 5 8s1.34 3 3 3zm0 2c-2.33 0-7 1.17-7 3.5V19h14v-2.5c0-2.33-4.67-3.5-7-3.5zm8 0c-.29 0-.62.02-.97.05 1.16.84 1.97 1.97 1.97 3.45V19h6v-2.5c0-2.33-4.67-3.5-7-3.5z"/>',
        'pin drop': '<path d="M18 8c0-3.31-2.69-6-6-6S6 4.69 6 8c0 4.5 6 11 6 11s6-6.5 6-11zm-8 0c0-1.1.9-2 2-2s2 .9 2 2-.89 2-2 2c-1.1 0-2-.9-2-2zM5 20v2h14v-2H5z"/>',
        'play arrow': '<path d="M8 5v14l11-7z"/>',
        'remove': '<path d="M19 13h-14v-2h14v2z"/>',
        'remove circle': '<path d="M12 2c-5.52 0-10 4.48-10 10s4.48 10 10 10 10-4.48 10-10-4.48-10-10-10zm5 11h-10v-2h10v2z"/>',
        'remove circle outline': '<path d="M7 11v2h10v-2h-10zm5-9c-5.52 0-10 4.48-10 10s4.48 10 10 10 10-4.48 10-10-4.48-10-10-10zm0 18c-4.41 0-8-3.59-8-8s3.59-8 8-8 8 3.59 8 8-3.59 8-8 8z"/>',
        'redo': '<path d="M18.4 10.6c-1.85-1.61-4.25-2.6-6.9-2.6-4.65 0-8.58 3.03-9.96 7.22l2.36.78c1.05-3.19 4.05-5.5 7.6-5.5 1.95 0 3.73.72 5.12 1.88l-3.62 3.62h9v-9l-3.6 3.6z"/>',
        'reorder': '<path d="M3 15h18v-2h-18v2zm0 4h18v-2h-18v2zm0-8h18v-2h-18v2zm0-6v2h18v-2h-18z"/>',
        'room': '<path d="M12 2C8.13 2 5 5.13 5 9c0 5.25 7 13 7 13s7-7.75 7-13c0-3.87-3.13-7-7-7zm0 9.5c-1.38 0-2.5-1.12-2.5-2.5s1.12-2.5 2.5-2.5 2.5 1.12 2.5 2.5-1.12 2.5-2.5 2.5z"/>',
        'search': '<path xmlns="http://www.w3.org/2000/svg" d="M15.5 14h-.79l-.28-.27C15.41 12.59 16 11.11 16 9.5 16 5.91 13.09 3 9.5 3S3 5.91 3 9.5 5.91 16 9.5 16c1.61 0 3.09-.59 4.23-1.57l.27.28v.79l5 4.99L20.49 19l-4.99-5zm-6 0C7.01 14 5 11.99 5 9.5S7.01 5 9.5 5 14 7.01 14 9.5 11.99 14 9.5 14z"/>',
        'settings application': '<path d="M12 10c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2zm7-7H5c-1.11 0-2 .9-2 2v14c0 1.1.89 2 2 2h14c1.11 0 2-.9 2-2V5c0-1.1-.89-2-2-2zm-1.75 9c0 .23-.02.46-.05.68l1.48 1.16c.13.11.17.3.08.45l-1.4 2.42c-.09.15-.27.21-.43.15l-1.74-.7c-.36.28-.76.51-1.18.69l-.26 1.85c-.03.17-.18.3-.35.3h-2.8c-.17 0-.32-.13-.35-.29l-.26-1.85c-.43-.18-.82-.41-1.18-.69l-1.74.7c-.16.06-.34 0-.43-.15l-1.4-2.42c-.09-.15-.05-.34.08-.45l1.48-1.16c-.03-.23-.05-.46-.05-.69 0-.23.02-.46.05-.68l-1.48-1.16c-.13-.11-.17-.3-.08-.45l1.4-2.42c.09-.15.27-.21.43-.15l1.74.7c.36-.28.76-.51 1.18-.69l.26-1.85c.03-.17.18-.3.35-.3h2.8c.17 0 .32.13.35.29l.26 1.85c.43.18.82.41 1.18.69l1.74-.7c.16-.06.34 0 .43.15l1.4 2.42c.09.15.05.34-.08.45l-1.48 1.16c.03.23.05.46.05.69z"/>',
        'schedule': '<path fill-opacity=".9" d="M11.99 2C6.47 2 2 6.48 2 12s4.47 10 9.99 10C17.52 22 22 17.52 22 12S17.52 2 11.99 2zM12 20c-4.42 0-8-3.58-8-8s3.58-8 8-8 8 3.58 8 8-3.58 8-8 8z"/><path d="M0 0h24v24H0z" fill="none"/><path fill-opacity=".9" d="M12.5 7H11v6l5.25 3.15.75-1.23-4.5-2.67z"/>',
        'stars': '<path d="M11.99 2C6.47 2 2 6.48 2 12s4.47 10 9.99 10C17.52 22 22 17.52 22 12S17.52 2 11.99 2zm4.24 16L12 15.45 7.77 18l1.12-4.81-3.73-3.23 4.92-.42L12 5l1.92 4.53 4.92.42-3.73 3.23L16.23 18z"/>',
        'timeline': '<path clip-path="url(#b)" d="M23 8c0 1.1-.9 2-2 2-.18 0-.35-.02-.51-.07l-3.56 3.55c.05.16.07.34.07.52 0 1.1-.9 2-2 2s-2-.9-2-2c0-.18.02-.36.07-.52l-2.55-2.55c-.16.05-.34.07-.52.07s-.36-.02-.52-.07l-4.55 4.56c.05.16.07.33.07.51 0 1.1-.9 2-2 2s-2-.9-2-2 .9-2 2-2c.18 0 .35.02.51.07l4.56-4.55C8.02 9.36 8 9.18 8 9c0-1.1.9-2 2-2s2 .9 2 2c0 .18-.02.36-.07.52l2.55 2.55c.16-.05.34-.07.52-.07s.36.02.52.07l3.55-3.56C19.02 8.35 19 8.18 19 8c0-1.1.9-2 2-2s2 .9 2 2z"/>',
        'toc': '<path d="M3 9h14V7H3v2zm0 4h14v-2H3v2zm0 4h14v-2H3v2zm16 0h2v-2h-2v2zm0-10v2h2V7h-2zm0 6h2v-2h-2v2z"/>',
        'undo': '<path d="M12.5 8c-2.65 0-5.05.99-6.9 2.6l-3.6-3.6v9h9l-3.62-3.62c1.39-1.16 3.16-1.88 5.12-1.88 3.54 0 6.55 2.31 7.6 5.5l2.37-.78c-1.39-4.19-5.32-7.22-9.97-7.22z"/>',
        'view list': '<path d="M4 14h4v-4H4v4zm0 5h4v-4H4v4zM4 9h4V5H4v4zm5 5h12v-4H9v4zm0 5h12v-4H9v4zM9 5v4h12V5H9z"/>',
        'view module': '<path d="M4 11h5V5H4v6zm0 7h5v-6H4v6zm6 0h5v-6h-5v6zm6 0h5v-6h-5v6zm-6-7h5V5h-5v6zm6-6v6h5V5h-5z"/>',
        'wand': '<path fill="#000000" d="M7.5,5.6L5,7L6.4,4.5L5,2L7.5,3.4L10,2L8.6,4.5L10,7L7.5,5.6M19.5,15.4L22,14L20.6,16.5L22,19L19.5,17.6L17,19L18.4,16.5L17,14L19.5,15.4M22,2L20.6,4.5L22,7L19.5,5.6L17,7L18.4,4.5L17,2L19.5,3.4L22,2M13.34,12.78L15.78,10.34L13.66,8.22L11.22,10.66L13.34,12.78M14.37,7.29L16.71,9.63C17.1,10 17.1,10.65 16.71,11.04L5.04,22.71C4.65,23.1 4,23.1 3.63,22.71L1.29,20.37C0.9,20 0.9,19.35 1.29,18.96L12.96,7.29C13.35,6.9 14,6.9 14.37,7.29Z" />'
    };
var defaultSize = 24;
var getSvg = function (_ref) {
    var name = _ref.name;
    var color = _ref.color;
    var size = _ref.size;
    size = size != null ? size : defaultSize;
    color = color != null ? color : 'currentcolor';
    return '<svg width=\'' + size + '\' height=\'' + size + '\' viewBox=\'0 0 24 24\' fill=\'' + color + '\' transform="scale(' + size / 24 + ')">\n    ' + paths[name] + '\n</svg>';
};
var Icon = ion.template(function Icon(properties) {
        return ion.createRuntime({
            type: 'Template',
            id: {
                type: 'Identifier',
                name: 'Icon',
                loc: {
                    start: {
                        line: 112,
                        column: 22,
                        fixed: true,
                        source: 'glass/html/material/Icon.ion'
                    },
                    end: {
                        line: 112,
                        column: 26,
                        fixed: true,
                        source: 'glass/html/material/Icon.ion'
                    }
                }
            },
            body: [
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'size',
                                loc: {
                                    start: {
                                        line: 113,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/Icon.ion'
                                    },
                                    end: {
                                        line: 113,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/Icon.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'ConditionalExpression',
                                test: {
                                    type: 'BinaryExpression',
                                    operator: '!=',
                                    left: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'properties',
                                            loc: {
                                                start: {
                                                    line: 113,
                                                    column: 15,
                                                    fixed: true,
                                                    source: 'glass/html/material/Icon.ion'
                                                },
                                                end: {
                                                    line: 113,
                                                    column: 25,
                                                    fixed: true,
                                                    source: 'glass/html/material/Icon.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'size',
                                            loc: {
                                                start: {
                                                    line: 113,
                                                    column: 26,
                                                    fixed: true,
                                                    source: 'glass/html/material/Icon.ion'
                                                },
                                                end: {
                                                    line: 113,
                                                    column: 30,
                                                    fixed: true,
                                                    source: 'glass/html/material/Icon.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 113,
                                                column: 15,
                                                fixed: true,
                                                source: 'glass/html/material/Icon.ion'
                                            },
                                            end: {
                                                line: 113,
                                                column: 30,
                                                fixed: true,
                                                source: 'glass/html/material/Icon.ion'
                                            }
                                        }
                                    },
                                    right: {
                                        type: 'Literal',
                                        value: null
                                    }
                                },
                                consequent: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'properties',
                                        loc: {
                                            start: {
                                                line: 113,
                                                column: 15,
                                                fixed: true,
                                                source: 'glass/html/material/Icon.ion'
                                            },
                                            end: {
                                                line: 113,
                                                column: 25,
                                                fixed: true,
                                                source: 'glass/html/material/Icon.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'size',
                                        loc: {
                                            start: {
                                                line: 113,
                                                column: 26,
                                                fixed: true,
                                                source: 'glass/html/material/Icon.ion'
                                            },
                                            end: {
                                                line: 113,
                                                column: 30,
                                                fixed: true,
                                                source: 'glass/html/material/Icon.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 113,
                                            column: 15,
                                            fixed: true,
                                            source: 'glass/html/material/Icon.ion'
                                        },
                                        end: {
                                            line: 113,
                                            column: 30,
                                            fixed: true,
                                            source: 'glass/html/material/Icon.ion'
                                        }
                                    }
                                },
                                alternate: {
                                    type: 'Identifier',
                                    name: 'defaultSize',
                                    loc: {
                                        start: {
                                            line: 113,
                                            column: 33,
                                            fixed: true,
                                            source: 'glass/html/material/Icon.ion'
                                        },
                                        end: {
                                            line: 113,
                                            column: 44,
                                            fixed: true,
                                            source: 'glass/html/material/Icon.ion'
                                        }
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '0'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'attributes',
                                loc: {
                                    start: {
                                        line: 114,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/Icon.ion'
                                    },
                                    end: {
                                        line: 114,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/material/Icon.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'Object',
                                        loc: {
                                            start: {
                                                line: 114,
                                                column: 21,
                                                fixed: true,
                                                source: 'glass/html/material/Icon.ion'
                                            },
                                            end: {
                                                line: 114,
                                                column: 27,
                                                fixed: true,
                                                source: 'glass/html/material/Icon.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'assign',
                                        loc: {
                                            start: {
                                                line: 114,
                                                column: 28,
                                                fixed: true,
                                                source: 'glass/html/material/Icon.ion'
                                            },
                                            end: {
                                                line: 114,
                                                column: 34,
                                                fixed: true,
                                                source: 'glass/html/material/Icon.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 114,
                                            column: 21,
                                            fixed: true,
                                            source: 'glass/html/material/Icon.ion'
                                        },
                                        end: {
                                            line: 114,
                                            column: 34,
                                            fixed: true,
                                            source: 'glass/html/material/Icon.ion'
                                        }
                                    }
                                },
                                arguments: [
                                    {
                                        type: 'ConditionalExpression',
                                        test: {
                                            type: 'BinaryExpression',
                                            operator: '!=',
                                            left: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'properties',
                                                    loc: {
                                                        start: {
                                                            line: 114,
                                                            column: 35,
                                                            fixed: true,
                                                            source: 'glass/html/material/Icon.ion'
                                                        },
                                                        end: {
                                                            line: 114,
                                                            column: 45,
                                                            fixed: true,
                                                            source: 'glass/html/material/Icon.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'attributes',
                                                    loc: {
                                                        start: {
                                                            line: 114,
                                                            column: 46,
                                                            fixed: true,
                                                            source: 'glass/html/material/Icon.ion'
                                                        },
                                                        end: {
                                                            line: 114,
                                                            column: 56,
                                                            fixed: true,
                                                            source: 'glass/html/material/Icon.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 114,
                                                        column: 35,
                                                        fixed: true,
                                                        source: 'glass/html/material/Icon.ion'
                                                    },
                                                    end: {
                                                        line: 114,
                                                        column: 56,
                                                        fixed: true,
                                                        source: 'glass/html/material/Icon.ion'
                                                    }
                                                }
                                            },
                                            right: {
                                                type: 'Literal',
                                                value: null
                                            }
                                        },
                                        consequent: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'properties',
                                                loc: {
                                                    start: {
                                                        line: 114,
                                                        column: 35,
                                                        fixed: true,
                                                        source: 'glass/html/material/Icon.ion'
                                                    },
                                                    end: {
                                                        line: 114,
                                                        column: 45,
                                                        fixed: true,
                                                        source: 'glass/html/material/Icon.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'attributes',
                                                loc: {
                                                    start: {
                                                        line: 114,
                                                        column: 46,
                                                        fixed: true,
                                                        source: 'glass/html/material/Icon.ion'
                                                    },
                                                    end: {
                                                        line: 114,
                                                        column: 56,
                                                        fixed: true,
                                                        source: 'glass/html/material/Icon.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 114,
                                                    column: 35,
                                                    fixed: true,
                                                    source: 'glass/html/material/Icon.ion'
                                                },
                                                end: {
                                                    line: 114,
                                                    column: 56,
                                                    fixed: true,
                                                    source: 'glass/html/material/Icon.ion'
                                                }
                                            }
                                        },
                                        alternate: {
                                            type: 'ObjectExpression',
                                            properties: []
                                        }
                                    },
                                    {
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'class',
                                                    loc: {
                                                        start: {
                                                            line: 114,
                                                            column: 64,
                                                            fixed: true,
                                                            source: 'glass/html/material/Icon.ion'
                                                        },
                                                        end: {
                                                            line: 114,
                                                            column: 69,
                                                            fixed: true,
                                                            source: 'glass/html/material/Icon.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: 'Icon'
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    }
                                ],
                                loc: {
                                    start: {
                                        line: 114,
                                        column: 21,
                                        fixed: true,
                                        source: 'glass/html/material/Icon.ion'
                                    },
                                    end: {
                                        line: 114,
                                        column: 79,
                                        fixed: true,
                                        source: 'glass/html/material/Icon.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '1'
                },
                {
                    type: 'ReturnStatement',
                    argument: {
                        type: 'ObjectExpression',
                        objectType: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Div',
                                loc: {
                                    start: {
                                        line: 115,
                                        column: 11,
                                        fixed: true,
                                        source: 'glass/html/material/Icon.ion'
                                    },
                                    end: {
                                        line: 115,
                                        column: 14,
                                        fixed: true,
                                        source: 'glass/html/material/Icon.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'Identifier',
                                    name: 'attributes',
                                    loc: {
                                        start: {
                                            line: 115,
                                            column: 15,
                                            fixed: true,
                                            source: 'glass/html/material/Icon.ion'
                                        },
                                        end: {
                                            line: 115,
                                            column: 25,
                                            fixed: true,
                                            source: 'glass/html/material/Icon.ion'
                                        }
                                    }
                                }],
                            loc: {
                                start: {
                                    line: 115,
                                    column: 11,
                                    fixed: true,
                                    source: 'glass/html/material/Icon.ion'
                                },
                                end: {
                                    line: 115,
                                    column: 26,
                                    fixed: true,
                                    source: 'glass/html/material/Icon.ion'
                                }
                            }
                        },
                        properties: [
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'style',
                                    loc: {
                                        start: {
                                            line: 116,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/Icon.ion'
                                        },
                                        end: {
                                            line: 116,
                                            column: 13,
                                            fixed: true,
                                            source: 'glass/html/material/Icon.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'ObjectExpression',
                                    properties: [
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'width',
                                                loc: {
                                                    start: {
                                                        line: 117,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/Icon.ion'
                                                    },
                                                    end: {
                                                        line: 117,
                                                        column: 17,
                                                        fixed: true,
                                                        source: 'glass/html/material/Icon.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'BinaryExpression',
                                                operator: '+',
                                                left: {
                                                    type: 'BinaryExpression',
                                                    operator: '+',
                                                    left: {
                                                        type: 'Literal',
                                                        value: ''
                                                    },
                                                    right: {
                                                        type: 'Identifier',
                                                        name: 'size',
                                                        loc: {
                                                            start: {
                                                                line: 117,
                                                                column: 22,
                                                                fixed: true,
                                                                source: 'glass/html/material/Icon.ion'
                                                            },
                                                            end: {
                                                                line: 117,
                                                                column: 26,
                                                                fixed: true,
                                                                source: 'glass/html/material/Icon.ion'
                                                            }
                                                        }
                                                    }
                                                },
                                                right: {
                                                    type: 'Literal',
                                                    value: 'px'
                                                }
                                            },
                                            kind: 'init',
                                            order: '0'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'height',
                                                loc: {
                                                    start: {
                                                        line: 118,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/Icon.ion'
                                                    },
                                                    end: {
                                                        line: 118,
                                                        column: 18,
                                                        fixed: true,
                                                        source: 'glass/html/material/Icon.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'BinaryExpression',
                                                operator: '+',
                                                left: {
                                                    type: 'BinaryExpression',
                                                    operator: '+',
                                                    left: {
                                                        type: 'Literal',
                                                        value: ''
                                                    },
                                                    right: {
                                                        type: 'Identifier',
                                                        name: 'size',
                                                        loc: {
                                                            start: {
                                                                line: 118,
                                                                column: 23,
                                                                fixed: true,
                                                                source: 'glass/html/material/Icon.ion'
                                                            },
                                                            end: {
                                                                line: 118,
                                                                column: 27,
                                                                fixed: true,
                                                                source: 'glass/html/material/Icon.ion'
                                                            }
                                                        }
                                                    }
                                                },
                                                right: {
                                                    type: 'Literal',
                                                    value: 'px'
                                                }
                                            },
                                            kind: 'init',
                                            order: '1'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'overflow',
                                                loc: {
                                                    start: {
                                                        line: 119,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/Icon.ion'
                                                    },
                                                    end: {
                                                        line: 119,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'glass/html/material/Icon.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: 'hidden'
                                            },
                                            kind: 'init',
                                            order: '2'
                                        },
                                        {
                                            type: 'IfStatement',
                                            test: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'properties',
                                                    loc: {
                                                        start: {
                                                            line: 120,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Icon.ion'
                                                        },
                                                        end: {
                                                            line: 120,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'glass/html/material/Icon.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'round',
                                                    loc: {
                                                        start: {
                                                            line: 120,
                                                            column: 26,
                                                            fixed: true,
                                                            source: 'glass/html/material/Icon.ion'
                                                        },
                                                        end: {
                                                            line: 120,
                                                            column: 31,
                                                            fixed: true,
                                                            source: 'glass/html/material/Icon.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 120,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'glass/html/material/Icon.ion'
                                                    },
                                                    end: {
                                                        line: 120,
                                                        column: 31,
                                                        fixed: true,
                                                        source: 'glass/html/material/Icon.ion'
                                                    }
                                                }
                                            },
                                            consequent: {
                                                type: 'BlockStatement',
                                                body: [{
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'borderRadius',
                                                            loc: {
                                                                start: {
                                                                    line: 121,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Icon.ion'
                                                                },
                                                                end: {
                                                                    line: 121,
                                                                    column: 28,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Icon.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'BinaryExpression',
                                                            operator: '+',
                                                            left: {
                                                                type: 'BinaryExpression',
                                                                operator: '+',
                                                                left: {
                                                                    type: 'Literal',
                                                                    value: ''
                                                                },
                                                                right: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '/',
                                                                    left: {
                                                                        type: 'Identifier',
                                                                        name: 'size',
                                                                        loc: {
                                                                            start: {
                                                                                line: 121,
                                                                                column: 33,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Icon.ion'
                                                                            },
                                                                            end: {
                                                                                line: 121,
                                                                                column: 37,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Icon.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    right: {
                                                                        type: 'Literal',
                                                                        value: 2
                                                                    }
                                                                }
                                                            },
                                                            right: {
                                                                type: 'Literal',
                                                                value: 'px'
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    }]
                                            },
                                            alternate: null,
                                            order: '3'
                                        }
                                    ]
                                },
                                kind: 'init',
                                order: '0'
                            },
                            {
                                type: 'IfStatement',
                                test: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'properties',
                                        loc: {
                                            start: {
                                                line: 122,
                                                column: 11,
                                                fixed: true,
                                                source: 'glass/html/material/Icon.ion'
                                            },
                                            end: {
                                                line: 122,
                                                column: 21,
                                                fixed: true,
                                                source: 'glass/html/material/Icon.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'url',
                                        loc: {
                                            start: {
                                                line: 122,
                                                column: 22,
                                                fixed: true,
                                                source: 'glass/html/material/Icon.ion'
                                            },
                                            end: {
                                                line: 122,
                                                column: 25,
                                                fixed: true,
                                                source: 'glass/html/material/Icon.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 122,
                                            column: 11,
                                            fixed: true,
                                            source: 'glass/html/material/Icon.ion'
                                        },
                                        end: {
                                            line: 122,
                                            column: 25,
                                            fixed: true,
                                            source: 'glass/html/material/Icon.ion'
                                        }
                                    }
                                },
                                consequent: {
                                    type: 'BlockStatement',
                                    body: [{
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'ObjectExpression',
                                                objectType: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'Identifier',
                                                        name: 'Img',
                                                        loc: {
                                                            start: {
                                                                line: 123,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'glass/html/material/Icon.ion'
                                                            },
                                                            end: {
                                                                line: 123,
                                                                column: 15,
                                                                fixed: true,
                                                                source: 'glass/html/material/Icon.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [{
                                                            type: 'ObjectExpression',
                                                            properties: [{
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'src',
                                                                        loc: {
                                                                            start: {
                                                                                line: 123,
                                                                                column: 17,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Icon.ion'
                                                                            },
                                                                            end: {
                                                                                line: 123,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Icon.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'properties',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 123,
                                                                                    column: 21,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Icon.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 123,
                                                                                    column: 31,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Icon.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'url',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 123,
                                                                                    column: 32,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Icon.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 123,
                                                                                    column: 35,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Icon.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 123,
                                                                                column: 21,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Icon.ion'
                                                                            },
                                                                            end: {
                                                                                line: 123,
                                                                                column: 35,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Icon.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                }]
                                                        }],
                                                    loc: {
                                                        start: {
                                                            line: 123,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Icon.ion'
                                                        },
                                                        end: {
                                                            line: 123,
                                                            column: 37,
                                                            fixed: true,
                                                            source: 'glass/html/material/Icon.ion'
                                                        }
                                                    }
                                                },
                                                properties: [{
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'style',
                                                            loc: {
                                                                start: {
                                                                    line: 124,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Icon.ion'
                                                                },
                                                                end: {
                                                                    line: 124,
                                                                    column: 21,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Icon.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'ObjectExpression',
                                                            properties: [
                                                                {
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'width',
                                                                        loc: {
                                                                            start: {
                                                                                line: 125,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Icon.ion'
                                                                            },
                                                                            end: {
                                                                                line: 125,
                                                                                column: 25,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Icon.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Literal',
                                                                        value: '100%'
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                },
                                                                {
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'height',
                                                                        loc: {
                                                                            start: {
                                                                                line: 126,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Icon.ion'
                                                                            },
                                                                            end: {
                                                                                line: 126,
                                                                                column: 26,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Icon.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Literal',
                                                                        value: 'auto'
                                                                    },
                                                                    kind: 'init',
                                                                    order: '1'
                                                                }
                                                            ]
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    }]
                                            },
                                            loc: {
                                                start: {
                                                    line: 123,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/Icon.ion'
                                                },
                                                end: {
                                                    line: 127,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/html/material/Icon.ion'
                                                }
                                            },
                                            order: '0'
                                        }]
                                },
                                alternate: {
                                    type: 'BlockStatement',
                                    body: [{
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'innerHTML',
                                                loc: {
                                                    start: {
                                                        line: 128,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/Icon.ion'
                                                    },
                                                    end: {
                                                        line: 128,
                                                        column: 21,
                                                        fixed: true,
                                                        source: 'glass/html/material/Icon.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'getSvg',
                                                    loc: {
                                                        start: {
                                                            line: 128,
                                                            column: 23,
                                                            fixed: true,
                                                            source: 'glass/html/material/Icon.ion'
                                                        },
                                                        end: {
                                                            line: 128,
                                                            column: 29,
                                                            fixed: true,
                                                            source: 'glass/html/material/Icon.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [{
                                                        type: 'Identifier',
                                                        name: 'properties',
                                                        loc: {
                                                            start: {
                                                                line: 128,
                                                                column: 30,
                                                                fixed: true,
                                                                source: 'glass/html/material/Icon.ion'
                                                            },
                                                            end: {
                                                                line: 128,
                                                                column: 40,
                                                                fixed: true,
                                                                source: 'glass/html/material/Icon.ion'
                                                            }
                                                        }
                                                    }],
                                                loc: {
                                                    start: {
                                                        line: 128,
                                                        column: 23,
                                                        fixed: true,
                                                        source: 'glass/html/material/Icon.ion'
                                                    },
                                                    end: {
                                                        line: 128,
                                                        column: 41,
                                                        fixed: true,
                                                        source: 'glass/html/material/Icon.ion'
                                                    }
                                                }
                                            },
                                            kind: 'init',
                                            order: '0'
                                        }]
                                },
                                order: '1'
                            }
                        ]
                    },
                    order: '2'
                }
            ],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'Icon',
                loc: {
                    start: {
                        line: 112,
                        column: 6,
                        fixed: true,
                        source: 'glass/html/material/Icon.ion'
                    },
                    end: {
                        line: 112,
                        column: 10,
                        fixed: true,
                        source: 'glass/html/material/Icon.ion'
                    }
                }
            }
        }, {
            this: this,
            properties: properties,
            style: style,
            paths: paths,
            defaultSize: defaultSize,
            getSvg: getSvg,
            Icon: Icon
        }, null);
    });
module.exports = exports = ion.patch.combine(Icon, { paths: paths });
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/Icon',_glass_html_material_Icon_);
    else
      _glass_html_material_Icon_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_Icon_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_Input_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('./'), inputTypeMap = {
        uri: 'url',
        integer: 'number',
        string: 'text',
        'date-time': 'datetime-local'
    };
var BaseInput = _ref.BaseInput;
var Select = _ref.Select;
var DateTimeInput = _ref.DateTimeInput;
module.exports = exports = ion.template(function Input(_ref2) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'Input',
            loc: {
                start: {
                    line: 9,
                    column: 16,
                    fixed: true,
                    source: 'glass/html/material/Input.ion'
                },
                end: {
                    line: 9,
                    column: 21,
                    fixed: true,
                    source: 'glass/html/material/Input.ion'
                }
            }
        },
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'property',
                            loc: {
                                start: {
                                    line: 9,
                                    column: 23,
                                    fixed: true,
                                    source: 'glass/html/material/Input.ion'
                                },
                                end: {
                                    line: 9,
                                    column: 31,
                                    fixed: true,
                                    source: 'glass/html/material/Input.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref2'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'property',
                                loc: {
                                    start: {
                                        line: 9,
                                        column: 23,
                                        fixed: true,
                                        source: 'glass/html/material/Input.ion'
                                    },
                                    end: {
                                        line: 9,
                                        column: 31,
                                        fixed: true,
                                        source: 'glass/html/material/Input.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'object',
                            loc: {
                                start: {
                                    line: 9,
                                    column: 32,
                                    fixed: true,
                                    source: 'glass/html/material/Input.ion'
                                },
                                end: {
                                    line: 9,
                                    column: 38,
                                    fixed: true,
                                    source: 'glass/html/material/Input.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref2'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'object',
                                loc: {
                                    start: {
                                        line: 9,
                                        column: 32,
                                        fixed: true,
                                        source: 'glass/html/material/Input.ion'
                                    },
                                    end: {
                                        line: 9,
                                        column: 38,
                                        fixed: true,
                                        source: 'glass/html/material/Input.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'value',
                            loc: {
                                start: {
                                    line: 9,
                                    column: 39,
                                    fixed: true,
                                    source: 'glass/html/material/Input.ion'
                                },
                                end: {
                                    line: 9,
                                    column: 44,
                                    fixed: true,
                                    source: 'glass/html/material/Input.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref2'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'value',
                                loc: {
                                    start: {
                                        line: 9,
                                        column: 39,
                                        fixed: true,
                                        source: 'glass/html/material/Input.ion'
                                    },
                                    end: {
                                        line: 9,
                                        column: 44,
                                        fixed: true,
                                        source: 'glass/html/material/Input.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'IfStatement',
                test: {
                    type: 'UnaryExpression',
                    operator: '?',
                    argument: {
                        type: 'MemberExpression',
                        computed: false,
                        object: {
                            type: 'Identifier',
                            name: 'property',
                            loc: {
                                start: {
                                    line: 10,
                                    column: 7,
                                    fixed: true,
                                    source: 'glass/html/material/Input.ion'
                                },
                                end: {
                                    line: 10,
                                    column: 15,
                                    fixed: true,
                                    source: 'glass/html/material/Input.ion'
                                }
                            }
                        },
                        property: {
                            type: 'Identifier',
                            name: 'getInputType',
                            loc: {
                                start: {
                                    line: 10,
                                    column: 16,
                                    fixed: true,
                                    source: 'glass/html/material/Input.ion'
                                },
                                end: {
                                    line: 10,
                                    column: 28,
                                    fixed: true,
                                    source: 'glass/html/material/Input.ion'
                                }
                            }
                        },
                        loc: {
                            start: {
                                line: 10,
                                column: 7,
                                fixed: true,
                                source: 'glass/html/material/Input.ion'
                            },
                            end: {
                                line: 10,
                                column: 28,
                                fixed: true,
                                source: 'glass/html/material/Input.ion'
                            }
                        }
                    }
                },
                consequent: {
                    type: 'BlockStatement',
                    body: [{
                            type: 'ReturnStatement',
                            argument: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'property',
                                            loc: {
                                                start: {
                                                    line: 11,
                                                    column: 15,
                                                    fixed: true,
                                                    source: 'glass/html/material/Input.ion'
                                                },
                                                end: {
                                                    line: 11,
                                                    column: 23,
                                                    fixed: true,
                                                    source: 'glass/html/material/Input.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'getInputType',
                                            loc: {
                                                start: {
                                                    line: 11,
                                                    column: 24,
                                                    fixed: true,
                                                    source: 'glass/html/material/Input.ion'
                                                },
                                                end: {
                                                    line: 11,
                                                    column: 36,
                                                    fixed: true,
                                                    source: 'glass/html/material/Input.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 11,
                                                column: 15,
                                                fixed: true,
                                                source: 'glass/html/material/Input.ion'
                                            },
                                            end: {
                                                line: 11,
                                                column: 36,
                                                fixed: true,
                                                source: 'glass/html/material/Input.ion'
                                            }
                                        }
                                    },
                                    arguments: [],
                                    loc: {
                                        start: {
                                            line: 11,
                                            column: 15,
                                            fixed: true,
                                            source: 'glass/html/material/Input.ion'
                                        },
                                        end: {
                                            line: 11,
                                            column: 38,
                                            fixed: true,
                                            source: 'glass/html/material/Input.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'property',
                                                    loc: {
                                                        start: {
                                                            line: 11,
                                                            column: 40,
                                                            fixed: true,
                                                            source: 'glass/html/material/Input.ion'
                                                        },
                                                        end: {
                                                            line: 11,
                                                            column: 48,
                                                            fixed: true,
                                                            source: 'glass/html/material/Input.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Identifier',
                                                    name: 'property',
                                                    loc: {
                                                        start: {
                                                            line: 11,
                                                            column: 40,
                                                            fixed: true,
                                                            source: 'glass/html/material/Input.ion'
                                                        },
                                                        end: {
                                                            line: 11,
                                                            column: 48,
                                                            fixed: true,
                                                            source: 'glass/html/material/Input.ion'
                                                        }
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'object',
                                                    loc: {
                                                        start: {
                                                            line: 11,
                                                            column: 49,
                                                            fixed: true,
                                                            source: 'glass/html/material/Input.ion'
                                                        },
                                                        end: {
                                                            line: 11,
                                                            column: 55,
                                                            fixed: true,
                                                            source: 'glass/html/material/Input.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Identifier',
                                                    name: 'object',
                                                    loc: {
                                                        start: {
                                                            line: 11,
                                                            column: 49,
                                                            fixed: true,
                                                            source: 'glass/html/material/Input.ion'
                                                        },
                                                        end: {
                                                            line: 11,
                                                            column: 55,
                                                            fixed: true,
                                                            source: 'glass/html/material/Input.ion'
                                                        }
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'value',
                                                    loc: {
                                                        start: {
                                                            line: 11,
                                                            column: 56,
                                                            fixed: true,
                                                            source: 'glass/html/material/Input.ion'
                                                        },
                                                        end: {
                                                            line: 11,
                                                            column: 61,
                                                            fixed: true,
                                                            source: 'glass/html/material/Input.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Identifier',
                                                    name: 'value',
                                                    loc: {
                                                        start: {
                                                            line: 11,
                                                            column: 56,
                                                            fixed: true,
                                                            source: 'glass/html/material/Input.ion'
                                                        },
                                                        end: {
                                                            line: 11,
                                                            column: 61,
                                                            fixed: true,
                                                            source: 'glass/html/material/Input.ion'
                                                        }
                                                    }
                                                },
                                                kind: 'init',
                                                order: '2'
                                            }
                                        ]
                                    }],
                                loc: {
                                    start: {
                                        line: 11,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/Input.ion'
                                    },
                                    end: {
                                        line: 11,
                                        column: 63,
                                        fixed: true,
                                        source: 'glass/html/material/Input.ion'
                                    }
                                }
                            },
                            order: '0'
                        }]
                },
                alternate: {
                    type: 'IfStatement',
                    test: {
                        type: 'BinaryExpression',
                        operator: '===',
                        left: {
                            type: 'MemberExpression',
                            computed: false,
                            object: {
                                type: 'Identifier',
                                name: 'property',
                                loc: {
                                    start: {
                                        line: 12,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/Input.ion'
                                    },
                                    end: {
                                        line: 12,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/Input.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'format',
                                loc: {
                                    start: {
                                        line: 12,
                                        column: 21,
                                        fixed: true,
                                        source: 'glass/html/material/Input.ion'
                                    },
                                    end: {
                                        line: 12,
                                        column: 27,
                                        fixed: true,
                                        source: 'glass/html/material/Input.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 12,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/Input.ion'
                                },
                                end: {
                                    line: 12,
                                    column: 27,
                                    fixed: true,
                                    source: 'glass/html/material/Input.ion'
                                }
                            }
                        },
                        right: {
                            type: 'Literal',
                            value: 'date-time'
                        }
                    },
                    consequent: {
                        type: 'BlockStatement',
                        body: [{
                                type: 'ReturnStatement',
                                argument: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'Identifier',
                                        name: 'DateTimeInput',
                                        loc: {
                                            start: {
                                                line: 13,
                                                column: 15,
                                                fixed: true,
                                                source: 'glass/html/material/Input.ion'
                                            },
                                            end: {
                                                line: 13,
                                                column: 28,
                                                fixed: true,
                                                source: 'glass/html/material/Input.ion'
                                            }
                                        }
                                    },
                                    arguments: [{
                                            type: 'ObjectExpression',
                                            properties: [
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'property',
                                                        loc: {
                                                            start: {
                                                                line: 13,
                                                                column: 30,
                                                                fixed: true,
                                                                source: 'glass/html/material/Input.ion'
                                                            },
                                                            end: {
                                                                line: 13,
                                                                column: 38,
                                                                fixed: true,
                                                                source: 'glass/html/material/Input.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Identifier',
                                                        name: 'property',
                                                        loc: {
                                                            start: {
                                                                line: 13,
                                                                column: 30,
                                                                fixed: true,
                                                                source: 'glass/html/material/Input.ion'
                                                            },
                                                            end: {
                                                                line: 13,
                                                                column: 38,
                                                                fixed: true,
                                                                source: 'glass/html/material/Input.ion'
                                                            }
                                                        }
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'object',
                                                        loc: {
                                                            start: {
                                                                line: 13,
                                                                column: 39,
                                                                fixed: true,
                                                                source: 'glass/html/material/Input.ion'
                                                            },
                                                            end: {
                                                                line: 13,
                                                                column: 45,
                                                                fixed: true,
                                                                source: 'glass/html/material/Input.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Identifier',
                                                        name: 'object',
                                                        loc: {
                                                            start: {
                                                                line: 13,
                                                                column: 39,
                                                                fixed: true,
                                                                source: 'glass/html/material/Input.ion'
                                                            },
                                                            end: {
                                                                line: 13,
                                                                column: 45,
                                                                fixed: true,
                                                                source: 'glass/html/material/Input.ion'
                                                            }
                                                        }
                                                    },
                                                    kind: 'init',
                                                    order: '1'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'value',
                                                        loc: {
                                                            start: {
                                                                line: 13,
                                                                column: 46,
                                                                fixed: true,
                                                                source: 'glass/html/material/Input.ion'
                                                            },
                                                            end: {
                                                                line: 13,
                                                                column: 51,
                                                                fixed: true,
                                                                source: 'glass/html/material/Input.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Identifier',
                                                        name: 'value',
                                                        loc: {
                                                            start: {
                                                                line: 13,
                                                                column: 46,
                                                                fixed: true,
                                                                source: 'glass/html/material/Input.ion'
                                                            },
                                                            end: {
                                                                line: 13,
                                                                column: 51,
                                                                fixed: true,
                                                                source: 'glass/html/material/Input.ion'
                                                            }
                                                        }
                                                    },
                                                    kind: 'init',
                                                    order: '2'
                                                }
                                            ]
                                        }],
                                    loc: {
                                        start: {
                                            line: 13,
                                            column: 15,
                                            fixed: true,
                                            source: 'glass/html/material/Input.ion'
                                        },
                                        end: {
                                            line: 13,
                                            column: 53,
                                            fixed: true,
                                            source: 'glass/html/material/Input.ion'
                                        }
                                    }
                                },
                                order: '0'
                            }]
                    },
                    alternate: {
                        type: 'IfStatement',
                        test: {
                            type: 'MemberExpression',
                            computed: false,
                            object: {
                                type: 'Identifier',
                                name: 'property',
                                loc: {
                                    start: {
                                        line: 14,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/Input.ion'
                                    },
                                    end: {
                                        line: 14,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/Input.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'values',
                                loc: {
                                    start: {
                                        line: 14,
                                        column: 21,
                                        fixed: true,
                                        source: 'glass/html/material/Input.ion'
                                    },
                                    end: {
                                        line: 14,
                                        column: 27,
                                        fixed: true,
                                        source: 'glass/html/material/Input.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 14,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/Input.ion'
                                },
                                end: {
                                    line: 14,
                                    column: 27,
                                    fixed: true,
                                    source: 'glass/html/material/Input.ion'
                                }
                            }
                        },
                        consequent: {
                            type: 'BlockStatement',
                            body: [{
                                    type: 'ReturnStatement',
                                    argument: {
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'Identifier',
                                            name: 'Select',
                                            loc: {
                                                start: {
                                                    line: 15,
                                                    column: 15,
                                                    fixed: true,
                                                    source: 'glass/html/material/Input.ion'
                                                },
                                                end: {
                                                    line: 15,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'glass/html/material/Input.ion'
                                                }
                                            }
                                        },
                                        arguments: [{
                                                type: 'ObjectExpression',
                                                properties: [
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'options',
                                                            loc: {
                                                                start: {
                                                                    line: 15,
                                                                    column: 23,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Input.ion'
                                                                },
                                                                end: {
                                                                    line: 15,
                                                                    column: 30,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Input.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'property',
                                                                loc: {
                                                                    start: {
                                                                        line: 15,
                                                                        column: 31,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Input.ion'
                                                                    },
                                                                    end: {
                                                                        line: 15,
                                                                        column: 39,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Input.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'values',
                                                                loc: {
                                                                    start: {
                                                                        line: 15,
                                                                        column: 40,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Input.ion'
                                                                    },
                                                                    end: {
                                                                        line: 15,
                                                                        column: 46,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Input.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 15,
                                                                    column: 31,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Input.ion'
                                                                },
                                                                end: {
                                                                    line: 15,
                                                                    column: 46,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Input.ion'
                                                                }
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'order',
                                                            loc: {
                                                                start: {
                                                                    line: 15,
                                                                    column: 47,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Input.ion'
                                                                },
                                                                end: {
                                                                    line: 15,
                                                                    column: 52,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Input.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'property',
                                                                loc: {
                                                                    start: {
                                                                        line: 15,
                                                                        column: 53,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Input.ion'
                                                                    },
                                                                    end: {
                                                                        line: 15,
                                                                        column: 61,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Input.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'enum',
                                                                loc: {
                                                                    start: {
                                                                        line: 15,
                                                                        column: 62,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Input.ion'
                                                                    },
                                                                    end: {
                                                                        line: 15,
                                                                        column: 66,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Input.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 15,
                                                                    column: 53,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Input.ion'
                                                                },
                                                                end: {
                                                                    line: 15,
                                                                    column: 66,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Input.ion'
                                                                }
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '1'
                                                    }
                                                ]
                                            }],
                                        loc: {
                                            start: {
                                                line: 15,
                                                column: 15,
                                                fixed: true,
                                                source: 'glass/html/material/Input.ion'
                                            },
                                            end: {
                                                line: 15,
                                                column: 68,
                                                fixed: true,
                                                source: 'glass/html/material/Input.ion'
                                            }
                                        }
                                    },
                                    order: '0'
                                }]
                        },
                        alternate: {
                            type: 'BlockStatement',
                            body: [{
                                    type: 'ReturnStatement',
                                    argument: {
                                        type: 'ObjectExpression',
                                        objectType: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'Identifier',
                                                name: 'BaseInput',
                                                loc: {
                                                    start: {
                                                        line: 17,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'glass/html/material/Input.ion'
                                                    },
                                                    end: {
                                                        line: 17,
                                                        column: 24,
                                                        fixed: true,
                                                        source: 'glass/html/material/Input.ion'
                                                    }
                                                }
                                            },
                                            arguments: [],
                                            loc: {
                                                start: {
                                                    line: 17,
                                                    column: 15,
                                                    fixed: true,
                                                    source: 'glass/html/material/Input.ion'
                                                },
                                                end: {
                                                    line: 17,
                                                    column: 26,
                                                    fixed: true,
                                                    source: 'glass/html/material/Input.ion'
                                                }
                                            }
                                        },
                                        properties: [
                                            {
                                                type: 'IfStatement',
                                                test: {
                                                    type: 'UnaryExpression',
                                                    operator: '?',
                                                    argument: {
                                                        type: 'Identifier',
                                                        name: 'value',
                                                        loc: {
                                                            start: {
                                                                line: 18,
                                                                column: 15,
                                                                fixed: true,
                                                                source: 'glass/html/material/Input.ion'
                                                            },
                                                            end: {
                                                                line: 18,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'glass/html/material/Input.ion'
                                                            }
                                                        }
                                                    }
                                                },
                                                consequent: {
                                                    type: 'BlockStatement',
                                                    body: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'value',
                                                                loc: {
                                                                    start: {
                                                                        line: 19,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Input.ion'
                                                                    },
                                                                    end: {
                                                                        line: 19,
                                                                        column: 21,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Input.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Identifier',
                                                                name: 'value',
                                                                loc: {
                                                                    start: {
                                                                        line: 19,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Input.ion'
                                                                    },
                                                                    end: {
                                                                        line: 19,
                                                                        column: 28,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Input.ion'
                                                                    }
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                },
                                                alternate: null,
                                                order: '0'
                                            },
                                            {
                                                type: 'IfStatement',
                                                test: {
                                                    type: 'UnaryExpression',
                                                    operator: '?',
                                                    argument: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'property',
                                                            loc: {
                                                                start: {
                                                                    line: 20,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Input.ion'
                                                                },
                                                                end: {
                                                                    line: 20,
                                                                    column: 23,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Input.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'required',
                                                            loc: {
                                                                start: {
                                                                    line: 20,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Input.ion'
                                                                },
                                                                end: {
                                                                    line: 20,
                                                                    column: 32,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Input.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 20,
                                                                column: 15,
                                                                fixed: true,
                                                                source: 'glass/html/material/Input.ion'
                                                            },
                                                            end: {
                                                                line: 20,
                                                                column: 32,
                                                                fixed: true,
                                                                source: 'glass/html/material/Input.ion'
                                                            }
                                                        }
                                                    }
                                                },
                                                consequent: {
                                                    type: 'BlockStatement',
                                                    body: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'required',
                                                                loc: {
                                                                    start: {
                                                                        line: 21,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Input.ion'
                                                                    },
                                                                    end: {
                                                                        line: 21,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Input.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'property',
                                                                    loc: {
                                                                        start: {
                                                                            line: 21,
                                                                            column: 26,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Input.ion'
                                                                        },
                                                                        end: {
                                                                            line: 21,
                                                                            column: 34,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Input.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'required',
                                                                    loc: {
                                                                        start: {
                                                                            line: 21,
                                                                            column: 35,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Input.ion'
                                                                        },
                                                                        end: {
                                                                            line: 21,
                                                                            column: 43,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Input.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 21,
                                                                        column: 26,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Input.ion'
                                                                    },
                                                                    end: {
                                                                        line: 21,
                                                                        column: 43,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Input.ion'
                                                                    }
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                },
                                                alternate: null,
                                                order: '1'
                                            },
                                            {
                                                type: 'IfStatement',
                                                test: {
                                                    type: 'UnaryExpression',
                                                    operator: '?',
                                                    argument: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'property',
                                                            loc: {
                                                                start: {
                                                                    line: 22,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Input.ion'
                                                                },
                                                                end: {
                                                                    line: 22,
                                                                    column: 23,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Input.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'pattern',
                                                            loc: {
                                                                start: {
                                                                    line: 22,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Input.ion'
                                                                },
                                                                end: {
                                                                    line: 22,
                                                                    column: 31,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Input.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 22,
                                                                column: 15,
                                                                fixed: true,
                                                                source: 'glass/html/material/Input.ion'
                                                            },
                                                            end: {
                                                                line: 22,
                                                                column: 31,
                                                                fixed: true,
                                                                source: 'glass/html/material/Input.ion'
                                                            }
                                                        }
                                                    }
                                                },
                                                consequent: {
                                                    type: 'BlockStatement',
                                                    body: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'pattern',
                                                                loc: {
                                                                    start: {
                                                                        line: 23,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Input.ion'
                                                                    },
                                                                    end: {
                                                                        line: 23,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Input.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'property',
                                                                    loc: {
                                                                        start: {
                                                                            line: 23,
                                                                            column: 25,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Input.ion'
                                                                        },
                                                                        end: {
                                                                            line: 23,
                                                                            column: 33,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Input.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'pattern',
                                                                    loc: {
                                                                        start: {
                                                                            line: 23,
                                                                            column: 34,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Input.ion'
                                                                        },
                                                                        end: {
                                                                            line: 23,
                                                                            column: 41,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Input.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 23,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Input.ion'
                                                                    },
                                                                    end: {
                                                                        line: 23,
                                                                        column: 41,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Input.ion'
                                                                    }
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                },
                                                alternate: null,
                                                order: '2'
                                            },
                                            {
                                                type: 'IfStatement',
                                                test: {
                                                    type: 'UnaryExpression',
                                                    operator: '?',
                                                    argument: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'property',
                                                            loc: {
                                                                start: {
                                                                    line: 24,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Input.ion'
                                                                },
                                                                end: {
                                                                    line: 24,
                                                                    column: 23,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Input.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'minimum',
                                                            loc: {
                                                                start: {
                                                                    line: 24,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Input.ion'
                                                                },
                                                                end: {
                                                                    line: 24,
                                                                    column: 31,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Input.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 24,
                                                                column: 15,
                                                                fixed: true,
                                                                source: 'glass/html/material/Input.ion'
                                                            },
                                                            end: {
                                                                line: 24,
                                                                column: 31,
                                                                fixed: true,
                                                                source: 'glass/html/material/Input.ion'
                                                            }
                                                        }
                                                    }
                                                },
                                                consequent: {
                                                    type: 'BlockStatement',
                                                    body: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'min',
                                                                loc: {
                                                                    start: {
                                                                        line: 25,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Input.ion'
                                                                    },
                                                                    end: {
                                                                        line: 25,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Input.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'property',
                                                                    loc: {
                                                                        start: {
                                                                            line: 25,
                                                                            column: 21,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Input.ion'
                                                                        },
                                                                        end: {
                                                                            line: 25,
                                                                            column: 29,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Input.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'minimum',
                                                                    loc: {
                                                                        start: {
                                                                            line: 25,
                                                                            column: 30,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Input.ion'
                                                                        },
                                                                        end: {
                                                                            line: 25,
                                                                            column: 37,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Input.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 25,
                                                                        column: 21,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Input.ion'
                                                                    },
                                                                    end: {
                                                                        line: 25,
                                                                        column: 37,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Input.ion'
                                                                    }
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                },
                                                alternate: null,
                                                order: '3'
                                            },
                                            {
                                                type: 'IfStatement',
                                                test: {
                                                    type: 'UnaryExpression',
                                                    operator: '?',
                                                    argument: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'property',
                                                            loc: {
                                                                start: {
                                                                    line: 26,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Input.ion'
                                                                },
                                                                end: {
                                                                    line: 26,
                                                                    column: 23,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Input.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'maximum',
                                                            loc: {
                                                                start: {
                                                                    line: 26,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Input.ion'
                                                                },
                                                                end: {
                                                                    line: 26,
                                                                    column: 31,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Input.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 26,
                                                                column: 15,
                                                                fixed: true,
                                                                source: 'glass/html/material/Input.ion'
                                                            },
                                                            end: {
                                                                line: 26,
                                                                column: 31,
                                                                fixed: true,
                                                                source: 'glass/html/material/Input.ion'
                                                            }
                                                        }
                                                    }
                                                },
                                                consequent: {
                                                    type: 'BlockStatement',
                                                    body: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'max',
                                                                loc: {
                                                                    start: {
                                                                        line: 27,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Input.ion'
                                                                    },
                                                                    end: {
                                                                        line: 27,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Input.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'property',
                                                                    loc: {
                                                                        start: {
                                                                            line: 27,
                                                                            column: 21,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Input.ion'
                                                                        },
                                                                        end: {
                                                                            line: 27,
                                                                            column: 29,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Input.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'maximum',
                                                                    loc: {
                                                                        start: {
                                                                            line: 27,
                                                                            column: 30,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Input.ion'
                                                                        },
                                                                        end: {
                                                                            line: 27,
                                                                            column: 37,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Input.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 27,
                                                                        column: 21,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Input.ion'
                                                                    },
                                                                    end: {
                                                                        line: 27,
                                                                        column: 37,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Input.ion'
                                                                    }
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                },
                                                alternate: null,
                                                order: '4'
                                            },
                                            {
                                                type: 'VariableDeclaration',
                                                declarations: [{
                                                        type: 'VariableDeclarator',
                                                        id: {
                                                            type: 'Identifier',
                                                            name: 'type',
                                                            loc: {
                                                                start: {
                                                                    line: 28,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Input.ion'
                                                                },
                                                                end: {
                                                                    line: 28,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Input.ion'
                                                                }
                                                            }
                                                        },
                                                        init: {
                                                            type: 'ConditionalExpression',
                                                            test: {
                                                                type: 'BinaryExpression',
                                                                operator: '!=',
                                                                left: {
                                                                    type: 'ConditionalExpression',
                                                                    test: {
                                                                        type: 'BinaryExpression',
                                                                        operator: '!=',
                                                                        left: {
                                                                            type: 'ConditionalExpression',
                                                                            test: {
                                                                                type: 'BinaryExpression',
                                                                                operator: '!=',
                                                                                left: {
                                                                                    type: 'ConditionalExpression',
                                                                                    test: {
                                                                                        type: 'BinaryExpression',
                                                                                        operator: '!=',
                                                                                        left: {
                                                                                            type: 'MemberExpression',
                                                                                            computed: true,
                                                                                            object: {
                                                                                                type: 'Identifier',
                                                                                                name: 'inputTypeMap',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 28,
                                                                                                        column: 23,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Input.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 28,
                                                                                                        column: 35,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Input.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            property: {
                                                                                                type: 'MemberExpression',
                                                                                                computed: false,
                                                                                                object: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'property',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 28,
                                                                                                            column: 36,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/Input.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 28,
                                                                                                            column: 44,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/Input.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'format',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 28,
                                                                                                            column: 45,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/Input.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 28,
                                                                                                            column: 51,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/Input.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 28,
                                                                                                        column: 36,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Input.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 28,
                                                                                                        column: 51,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Input.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 28,
                                                                                                    column: 23,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Input.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 28,
                                                                                                    column: 52,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Input.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        right: {
                                                                                            type: 'Literal',
                                                                                            value: null
                                                                                        }
                                                                                    },
                                                                                    consequent: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: true,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'inputTypeMap',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 28,
                                                                                                    column: 23,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Input.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 28,
                                                                                                    column: 35,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Input.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'MemberExpression',
                                                                                            computed: false,
                                                                                            object: {
                                                                                                type: 'Identifier',
                                                                                                name: 'property',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 28,
                                                                                                        column: 36,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Input.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 28,
                                                                                                        column: 44,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Input.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            property: {
                                                                                                type: 'Identifier',
                                                                                                name: 'format',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 28,
                                                                                                        column: 45,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Input.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 28,
                                                                                                        column: 51,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Input.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 28,
                                                                                                    column: 36,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Input.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 28,
                                                                                                    column: 51,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Input.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 28,
                                                                                                column: 23,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 28,
                                                                                                column: 52,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    alternate: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'property',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 28,
                                                                                                    column: 55,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Input.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 28,
                                                                                                    column: 63,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Input.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'format',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 28,
                                                                                                    column: 64,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Input.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 28,
                                                                                                    column: 70,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Input.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 28,
                                                                                                column: 55,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 28,
                                                                                                column: 70,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                },
                                                                                right: {
                                                                                    type: 'Literal',
                                                                                    value: null
                                                                                }
                                                                            },
                                                                            consequent: {
                                                                                type: 'ConditionalExpression',
                                                                                test: {
                                                                                    type: 'BinaryExpression',
                                                                                    operator: '!=',
                                                                                    left: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: true,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'inputTypeMap',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 28,
                                                                                                    column: 23,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Input.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 28,
                                                                                                    column: 35,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Input.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'MemberExpression',
                                                                                            computed: false,
                                                                                            object: {
                                                                                                type: 'Identifier',
                                                                                                name: 'property',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 28,
                                                                                                        column: 36,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Input.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 28,
                                                                                                        column: 44,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Input.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            property: {
                                                                                                type: 'Identifier',
                                                                                                name: 'format',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 28,
                                                                                                        column: 45,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Input.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 28,
                                                                                                        column: 51,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Input.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 28,
                                                                                                    column: 36,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Input.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 28,
                                                                                                    column: 51,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Input.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 28,
                                                                                                column: 23,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 28,
                                                                                                column: 52,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    right: {
                                                                                        type: 'Literal',
                                                                                        value: null
                                                                                    }
                                                                                },
                                                                                consequent: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: true,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'inputTypeMap',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 28,
                                                                                                column: 23,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 28,
                                                                                                column: 35,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'property',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 28,
                                                                                                    column: 36,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Input.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 28,
                                                                                                    column: 44,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Input.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'format',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 28,
                                                                                                    column: 45,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Input.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 28,
                                                                                                    column: 51,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Input.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 28,
                                                                                                column: 36,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 28,
                                                                                                column: 51,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 28,
                                                                                            column: 23,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 28,
                                                                                            column: 52,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                alternate: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'property',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 28,
                                                                                                column: 55,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 28,
                                                                                                column: 63,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'format',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 28,
                                                                                                column: 64,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 28,
                                                                                                column: 70,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 28,
                                                                                            column: 55,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 28,
                                                                                            column: 70,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        }
                                                                                    }
                                                                                }
                                                                            },
                                                                            alternate: {
                                                                                type: 'MemberExpression',
                                                                                computed: true,
                                                                                object: {
                                                                                    type: 'Identifier',
                                                                                    name: 'inputTypeMap',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 28,
                                                                                            column: 73,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 28,
                                                                                            column: 85,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'property',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 28,
                                                                                                column: 86,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 28,
                                                                                                column: 94,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'type',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 28,
                                                                                                column: 95,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 28,
                                                                                                column: 99,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 28,
                                                                                            column: 86,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 28,
                                                                                            column: 99,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 28,
                                                                                        column: 73,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Input.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 28,
                                                                                        column: 100,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Input.ion'
                                                                                    }
                                                                                }
                                                                            }
                                                                        },
                                                                        right: {
                                                                            type: 'Literal',
                                                                            value: null
                                                                        }
                                                                    },
                                                                    consequent: {
                                                                        type: 'ConditionalExpression',
                                                                        test: {
                                                                            type: 'BinaryExpression',
                                                                            operator: '!=',
                                                                            left: {
                                                                                type: 'ConditionalExpression',
                                                                                test: {
                                                                                    type: 'BinaryExpression',
                                                                                    operator: '!=',
                                                                                    left: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: true,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'inputTypeMap',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 28,
                                                                                                    column: 23,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Input.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 28,
                                                                                                    column: 35,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Input.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'MemberExpression',
                                                                                            computed: false,
                                                                                            object: {
                                                                                                type: 'Identifier',
                                                                                                name: 'property',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 28,
                                                                                                        column: 36,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Input.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 28,
                                                                                                        column: 44,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Input.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            property: {
                                                                                                type: 'Identifier',
                                                                                                name: 'format',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 28,
                                                                                                        column: 45,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Input.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 28,
                                                                                                        column: 51,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Input.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 28,
                                                                                                    column: 36,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Input.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 28,
                                                                                                    column: 51,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Input.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 28,
                                                                                                column: 23,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 28,
                                                                                                column: 52,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    right: {
                                                                                        type: 'Literal',
                                                                                        value: null
                                                                                    }
                                                                                },
                                                                                consequent: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: true,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'inputTypeMap',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 28,
                                                                                                column: 23,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 28,
                                                                                                column: 35,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'property',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 28,
                                                                                                    column: 36,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Input.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 28,
                                                                                                    column: 44,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Input.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'format',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 28,
                                                                                                    column: 45,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Input.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 28,
                                                                                                    column: 51,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Input.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 28,
                                                                                                column: 36,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 28,
                                                                                                column: 51,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 28,
                                                                                            column: 23,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 28,
                                                                                            column: 52,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                alternate: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'property',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 28,
                                                                                                column: 55,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 28,
                                                                                                column: 63,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'format',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 28,
                                                                                                column: 64,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 28,
                                                                                                column: 70,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 28,
                                                                                            column: 55,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 28,
                                                                                            column: 70,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        }
                                                                                    }
                                                                                }
                                                                            },
                                                                            right: {
                                                                                type: 'Literal',
                                                                                value: null
                                                                            }
                                                                        },
                                                                        consequent: {
                                                                            type: 'ConditionalExpression',
                                                                            test: {
                                                                                type: 'BinaryExpression',
                                                                                operator: '!=',
                                                                                left: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: true,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'inputTypeMap',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 28,
                                                                                                column: 23,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 28,
                                                                                                column: 35,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'property',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 28,
                                                                                                    column: 36,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Input.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 28,
                                                                                                    column: 44,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Input.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'format',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 28,
                                                                                                    column: 45,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Input.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 28,
                                                                                                    column: 51,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Input.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 28,
                                                                                                column: 36,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 28,
                                                                                                column: 51,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 28,
                                                                                            column: 23,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 28,
                                                                                            column: 52,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                right: {
                                                                                    type: 'Literal',
                                                                                    value: null
                                                                                }
                                                                            },
                                                                            consequent: {
                                                                                type: 'MemberExpression',
                                                                                computed: true,
                                                                                object: {
                                                                                    type: 'Identifier',
                                                                                    name: 'inputTypeMap',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 28,
                                                                                            column: 23,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 28,
                                                                                            column: 35,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'property',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 28,
                                                                                                column: 36,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 28,
                                                                                                column: 44,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'format',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 28,
                                                                                                column: 45,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 28,
                                                                                                column: 51,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 28,
                                                                                            column: 36,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 28,
                                                                                            column: 51,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 28,
                                                                                        column: 23,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Input.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 28,
                                                                                        column: 52,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Input.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            alternate: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'Identifier',
                                                                                    name: 'property',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 28,
                                                                                            column: 55,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 28,
                                                                                            column: 63,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'format',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 28,
                                                                                            column: 64,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 28,
                                                                                            column: 70,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 28,
                                                                                        column: 55,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Input.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 28,
                                                                                        column: 70,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Input.ion'
                                                                                    }
                                                                                }
                                                                            }
                                                                        },
                                                                        alternate: {
                                                                            type: 'MemberExpression',
                                                                            computed: true,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'inputTypeMap',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 28,
                                                                                        column: 73,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Input.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 28,
                                                                                        column: 85,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Input.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'Identifier',
                                                                                    name: 'property',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 28,
                                                                                            column: 86,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 28,
                                                                                            column: 94,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'type',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 28,
                                                                                            column: 95,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 28,
                                                                                            column: 99,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 28,
                                                                                        column: 86,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Input.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 28,
                                                                                        column: 99,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Input.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 28,
                                                                                    column: 73,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Input.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 28,
                                                                                    column: 100,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Input.ion'
                                                                                }
                                                                            }
                                                                        }
                                                                    },
                                                                    alternate: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'property',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 28,
                                                                                    column: 103,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Input.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 28,
                                                                                    column: 111,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Input.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'type',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 28,
                                                                                    column: 112,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Input.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 28,
                                                                                    column: 116,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Input.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 28,
                                                                                column: 103,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Input.ion'
                                                                            },
                                                                            end: {
                                                                                line: 28,
                                                                                column: 116,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Input.ion'
                                                                            }
                                                                        }
                                                                    }
                                                                },
                                                                right: {
                                                                    type: 'Literal',
                                                                    value: null
                                                                }
                                                            },
                                                            consequent: {
                                                                type: 'ConditionalExpression',
                                                                test: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '!=',
                                                                    left: {
                                                                        type: 'ConditionalExpression',
                                                                        test: {
                                                                            type: 'BinaryExpression',
                                                                            operator: '!=',
                                                                            left: {
                                                                                type: 'ConditionalExpression',
                                                                                test: {
                                                                                    type: 'BinaryExpression',
                                                                                    operator: '!=',
                                                                                    left: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: true,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'inputTypeMap',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 28,
                                                                                                    column: 23,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Input.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 28,
                                                                                                    column: 35,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Input.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'MemberExpression',
                                                                                            computed: false,
                                                                                            object: {
                                                                                                type: 'Identifier',
                                                                                                name: 'property',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 28,
                                                                                                        column: 36,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Input.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 28,
                                                                                                        column: 44,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Input.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            property: {
                                                                                                type: 'Identifier',
                                                                                                name: 'format',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 28,
                                                                                                        column: 45,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Input.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 28,
                                                                                                        column: 51,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Input.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 28,
                                                                                                    column: 36,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Input.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 28,
                                                                                                    column: 51,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Input.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 28,
                                                                                                column: 23,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 28,
                                                                                                column: 52,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    right: {
                                                                                        type: 'Literal',
                                                                                        value: null
                                                                                    }
                                                                                },
                                                                                consequent: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: true,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'inputTypeMap',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 28,
                                                                                                column: 23,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 28,
                                                                                                column: 35,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'property',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 28,
                                                                                                    column: 36,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Input.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 28,
                                                                                                    column: 44,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Input.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'format',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 28,
                                                                                                    column: 45,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Input.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 28,
                                                                                                    column: 51,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Input.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 28,
                                                                                                column: 36,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 28,
                                                                                                column: 51,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 28,
                                                                                            column: 23,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 28,
                                                                                            column: 52,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                alternate: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'property',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 28,
                                                                                                column: 55,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 28,
                                                                                                column: 63,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'format',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 28,
                                                                                                column: 64,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 28,
                                                                                                column: 70,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 28,
                                                                                            column: 55,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 28,
                                                                                            column: 70,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        }
                                                                                    }
                                                                                }
                                                                            },
                                                                            right: {
                                                                                type: 'Literal',
                                                                                value: null
                                                                            }
                                                                        },
                                                                        consequent: {
                                                                            type: 'ConditionalExpression',
                                                                            test: {
                                                                                type: 'BinaryExpression',
                                                                                operator: '!=',
                                                                                left: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: true,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'inputTypeMap',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 28,
                                                                                                column: 23,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 28,
                                                                                                column: 35,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'property',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 28,
                                                                                                    column: 36,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Input.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 28,
                                                                                                    column: 44,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Input.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'format',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 28,
                                                                                                    column: 45,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Input.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 28,
                                                                                                    column: 51,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Input.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 28,
                                                                                                column: 36,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 28,
                                                                                                column: 51,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 28,
                                                                                            column: 23,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 28,
                                                                                            column: 52,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                right: {
                                                                                    type: 'Literal',
                                                                                    value: null
                                                                                }
                                                                            },
                                                                            consequent: {
                                                                                type: 'MemberExpression',
                                                                                computed: true,
                                                                                object: {
                                                                                    type: 'Identifier',
                                                                                    name: 'inputTypeMap',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 28,
                                                                                            column: 23,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 28,
                                                                                            column: 35,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'property',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 28,
                                                                                                column: 36,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 28,
                                                                                                column: 44,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'format',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 28,
                                                                                                column: 45,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 28,
                                                                                                column: 51,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 28,
                                                                                            column: 36,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 28,
                                                                                            column: 51,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 28,
                                                                                        column: 23,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Input.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 28,
                                                                                        column: 52,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Input.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            alternate: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'Identifier',
                                                                                    name: 'property',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 28,
                                                                                            column: 55,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 28,
                                                                                            column: 63,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'format',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 28,
                                                                                            column: 64,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 28,
                                                                                            column: 70,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 28,
                                                                                        column: 55,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Input.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 28,
                                                                                        column: 70,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Input.ion'
                                                                                    }
                                                                                }
                                                                            }
                                                                        },
                                                                        alternate: {
                                                                            type: 'MemberExpression',
                                                                            computed: true,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'inputTypeMap',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 28,
                                                                                        column: 73,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Input.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 28,
                                                                                        column: 85,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Input.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'Identifier',
                                                                                    name: 'property',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 28,
                                                                                            column: 86,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 28,
                                                                                            column: 94,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'type',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 28,
                                                                                            column: 95,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 28,
                                                                                            column: 99,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 28,
                                                                                        column: 86,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Input.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 28,
                                                                                        column: 99,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Input.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 28,
                                                                                    column: 73,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Input.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 28,
                                                                                    column: 100,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Input.ion'
                                                                                }
                                                                            }
                                                                        }
                                                                    },
                                                                    right: {
                                                                        type: 'Literal',
                                                                        value: null
                                                                    }
                                                                },
                                                                consequent: {
                                                                    type: 'ConditionalExpression',
                                                                    test: {
                                                                        type: 'BinaryExpression',
                                                                        operator: '!=',
                                                                        left: {
                                                                            type: 'ConditionalExpression',
                                                                            test: {
                                                                                type: 'BinaryExpression',
                                                                                operator: '!=',
                                                                                left: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: true,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'inputTypeMap',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 28,
                                                                                                column: 23,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 28,
                                                                                                column: 35,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'property',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 28,
                                                                                                    column: 36,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Input.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 28,
                                                                                                    column: 44,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Input.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'format',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 28,
                                                                                                    column: 45,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Input.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 28,
                                                                                                    column: 51,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Input.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 28,
                                                                                                column: 36,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 28,
                                                                                                column: 51,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 28,
                                                                                            column: 23,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 28,
                                                                                            column: 52,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                right: {
                                                                                    type: 'Literal',
                                                                                    value: null
                                                                                }
                                                                            },
                                                                            consequent: {
                                                                                type: 'MemberExpression',
                                                                                computed: true,
                                                                                object: {
                                                                                    type: 'Identifier',
                                                                                    name: 'inputTypeMap',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 28,
                                                                                            column: 23,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 28,
                                                                                            column: 35,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'property',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 28,
                                                                                                column: 36,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 28,
                                                                                                column: 44,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'format',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 28,
                                                                                                column: 45,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 28,
                                                                                                column: 51,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 28,
                                                                                            column: 36,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 28,
                                                                                            column: 51,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 28,
                                                                                        column: 23,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Input.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 28,
                                                                                        column: 52,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Input.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            alternate: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'Identifier',
                                                                                    name: 'property',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 28,
                                                                                            column: 55,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 28,
                                                                                            column: 63,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'format',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 28,
                                                                                            column: 64,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 28,
                                                                                            column: 70,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 28,
                                                                                        column: 55,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Input.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 28,
                                                                                        column: 70,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Input.ion'
                                                                                    }
                                                                                }
                                                                            }
                                                                        },
                                                                        right: {
                                                                            type: 'Literal',
                                                                            value: null
                                                                        }
                                                                    },
                                                                    consequent: {
                                                                        type: 'ConditionalExpression',
                                                                        test: {
                                                                            type: 'BinaryExpression',
                                                                            operator: '!=',
                                                                            left: {
                                                                                type: 'MemberExpression',
                                                                                computed: true,
                                                                                object: {
                                                                                    type: 'Identifier',
                                                                                    name: 'inputTypeMap',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 28,
                                                                                            column: 23,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 28,
                                                                                            column: 35,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'property',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 28,
                                                                                                column: 36,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 28,
                                                                                                column: 44,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'format',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 28,
                                                                                                column: 45,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 28,
                                                                                                column: 51,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Input.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 28,
                                                                                            column: 36,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 28,
                                                                                            column: 51,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 28,
                                                                                        column: 23,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Input.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 28,
                                                                                        column: 52,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Input.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            right: {
                                                                                type: 'Literal',
                                                                                value: null
                                                                            }
                                                                        },
                                                                        consequent: {
                                                                            type: 'MemberExpression',
                                                                            computed: true,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'inputTypeMap',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 28,
                                                                                        column: 23,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Input.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 28,
                                                                                        column: 35,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Input.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'Identifier',
                                                                                    name: 'property',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 28,
                                                                                            column: 36,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 28,
                                                                                            column: 44,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'format',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 28,
                                                                                            column: 45,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 28,
                                                                                            column: 51,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Input.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 28,
                                                                                        column: 36,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Input.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 28,
                                                                                        column: 51,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Input.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 28,
                                                                                    column: 23,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Input.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 28,
                                                                                    column: 52,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Input.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        alternate: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'property',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 28,
                                                                                        column: 55,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Input.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 28,
                                                                                        column: 63,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Input.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'format',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 28,
                                                                                        column: 64,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Input.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 28,
                                                                                        column: 70,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Input.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 28,
                                                                                    column: 55,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Input.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 28,
                                                                                    column: 70,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Input.ion'
                                                                                }
                                                                            }
                                                                        }
                                                                    },
                                                                    alternate: {
                                                                        type: 'MemberExpression',
                                                                        computed: true,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'inputTypeMap',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 28,
                                                                                    column: 73,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Input.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 28,
                                                                                    column: 85,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Input.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'property',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 28,
                                                                                        column: 86,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Input.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 28,
                                                                                        column: 94,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Input.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'type',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 28,
                                                                                        column: 95,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Input.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 28,
                                                                                        column: 99,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Input.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 28,
                                                                                    column: 86,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Input.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 28,
                                                                                    column: 99,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Input.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 28,
                                                                                column: 73,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Input.ion'
                                                                            },
                                                                            end: {
                                                                                line: 28,
                                                                                column: 100,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Input.ion'
                                                                            }
                                                                        }
                                                                    }
                                                                },
                                                                alternate: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'property',
                                                                        loc: {
                                                                            start: {
                                                                                line: 28,
                                                                                column: 103,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Input.ion'
                                                                            },
                                                                            end: {
                                                                                line: 28,
                                                                                column: 111,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Input.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'type',
                                                                        loc: {
                                                                            start: {
                                                                                line: 28,
                                                                                column: 112,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Input.ion'
                                                                            },
                                                                            end: {
                                                                                line: 28,
                                                                                column: 116,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Input.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 28,
                                                                            column: 103,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Input.ion'
                                                                        },
                                                                        end: {
                                                                            line: 28,
                                                                            column: 116,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Input.ion'
                                                                        }
                                                                    }
                                                                }
                                                            },
                                                            alternate: {
                                                                type: 'Literal',
                                                                value: 'text'
                                                            }
                                                        }
                                                    }],
                                                kind: 'let',
                                                order: '5'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'type',
                                                    loc: {
                                                        start: {
                                                            line: 29,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Input.ion'
                                                        },
                                                        end: {
                                                            line: 29,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/Input.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Identifier',
                                                    name: 'type',
                                                    loc: {
                                                        start: {
                                                            line: 29,
                                                            column: 18,
                                                            fixed: true,
                                                            source: 'glass/html/material/Input.ion'
                                                        },
                                                        end: {
                                                            line: 29,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'glass/html/material/Input.ion'
                                                        }
                                                    }
                                                },
                                                kind: 'init',
                                                order: '6'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'style',
                                                    loc: {
                                                        start: {
                                                            line: 30,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Input.ion'
                                                        },
                                                        end: {
                                                            line: 30,
                                                            column: 17,
                                                            fixed: true,
                                                            source: 'glass/html/material/Input.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'ObjectExpression',
                                                    properties: [{
                                                            type: 'IfStatement',
                                                            test: {
                                                                type: 'BinaryExpression',
                                                                operator: '||',
                                                                left: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '===',
                                                                    left: {
                                                                        type: 'Identifier',
                                                                        name: 'type',
                                                                        loc: {
                                                                            start: {
                                                                                line: 31,
                                                                                column: 19,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Input.ion'
                                                                            },
                                                                            end: {
                                                                                line: 31,
                                                                                column: 23,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Input.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    right: {
                                                                        type: 'Literal',
                                                                        value: 'text'
                                                                    }
                                                                },
                                                                right: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '===',
                                                                    left: {
                                                                        type: 'Identifier',
                                                                        name: 'type',
                                                                        loc: {
                                                                            start: {
                                                                                line: 31,
                                                                                column: 37,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Input.ion'
                                                                            },
                                                                            end: {
                                                                                line: 31,
                                                                                column: 41,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Input.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    right: {
                                                                        type: 'Literal',
                                                                        value: 'email'
                                                                    }
                                                                }
                                                            },
                                                            consequent: {
                                                                type: 'BlockStatement',
                                                                body: [{
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'minWidth',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 32,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Input.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 32,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Input.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Literal',
                                                                            value: '250px'
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    }]
                                                            },
                                                            alternate: null,
                                                            order: '0'
                                                        }]
                                                },
                                                kind: 'init',
                                                order: '7'
                                            }
                                        ]
                                    },
                                    order: '0'
                                }]
                        }
                    }
                },
                order: '3'
            }
        ],
        bound: false
    }, {
        this: this,
        _ref2: _ref2,
        _ref: _ref,
        inputTypeMap: inputTypeMap,
        BaseInput: BaseInput,
        Select: Select,
        DateTimeInput: DateTimeInput
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/Input',_glass_html_material_Input_);
    else
      _glass_html_material_Input_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_Input_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_List_ = function(module,exports,require){'use strict';
var ion = require('ion');
var style = require('../style');
style.define(module.id, '.List {\n    overflow: auto;\n    overflow-scrolling: touch;\n}');
module.exports = exports = ion.template(function (attributes) {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [{
                type: 'ReturnStatement',
                argument: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'CallExpression',
                        callee: {
                            type: 'Identifier',
                            name: 'Div',
                            loc: {
                                start: {
                                    line: 16,
                                    column: 11,
                                    fixed: true,
                                    source: 'glass/html/material/List.ion'
                                },
                                end: {
                                    line: 16,
                                    column: 14,
                                    fixed: true,
                                    source: 'glass/html/material/List.ion'
                                }
                            }
                        },
                        arguments: [{
                                type: 'Identifier',
                                name: 'attributes',
                                loc: {
                                    start: {
                                        line: 16,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/List.ion'
                                    },
                                    end: {
                                        line: 16,
                                        column: 25,
                                        fixed: true,
                                        source: 'glass/html/material/List.ion'
                                    }
                                }
                            }],
                        loc: {
                            start: {
                                line: 16,
                                column: 11,
                                fixed: true,
                                source: 'glass/html/material/List.ion'
                            },
                            end: {
                                line: 16,
                                column: 26,
                                fixed: true,
                                source: 'glass/html/material/List.ion'
                            }
                        }
                    },
                    properties: [{
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'classList',
                                loc: {
                                    start: {
                                        line: 17,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/List.ion'
                                    },
                                    end: {
                                        line: 17,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/html/material/List.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'ObjectExpression',
                                properties: [
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'Literal',
                                            value: 'List'
                                        },
                                        loc: {
                                            start: {
                                                line: 18,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/List.ion'
                                            },
                                            end: {
                                                line: 18,
                                                column: 18,
                                                fixed: true,
                                                source: 'glass/html/material/List.ion'
                                            }
                                        },
                                        order: '0'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'Literal',
                                            value: 'fill'
                                        },
                                        loc: {
                                            start: {
                                                line: 19,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/List.ion'
                                            },
                                            end: {
                                                line: 19,
                                                column: 18,
                                                fixed: true,
                                                source: 'glass/html/material/List.ion'
                                            }
                                        },
                                        order: '1'
                                    }
                                ]
                            },
                            kind: 'init',
                            order: '0'
                        }]
                },
                order: '0'
            }],
        bound: false
    }, {
        this: this,
        attributes: attributes,
        style: style
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/List',_glass_html_material_List_);
    else
      _glass_html_material_List_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_List_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_LoginDialog_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('./'), _ref2, style = require('../style');
var Dialog = _ref.Dialog;
var TabContent = _ref.TabContent;
_ref2 = require('../forms');
var GlassForm = _ref2.GlassForm;
var SubmitButton = _ref2.SubmitButton;
var Checkbox = _ref2.Checkbox;
module.exports = exports = ion.template(function (_ref3) {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'title',
                            loc: {
                                start: {
                                    line: 6,
                                    column: 18,
                                    fixed: true,
                                    source: 'glass/html/material/LoginDialog.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 23,
                                    fixed: true,
                                    source: 'glass/html/material/LoginDialog.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'title',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/material/LoginDialog.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 23,
                                        fixed: true,
                                        source: 'glass/html/material/LoginDialog.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'loader',
                            loc: {
                                start: {
                                    line: 6,
                                    column: 25,
                                    fixed: true,
                                    source: 'glass/html/material/LoginDialog.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 31,
                                    fixed: true,
                                    source: 'glass/html/material/LoginDialog.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'loader',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 25,
                                        fixed: true,
                                        source: 'glass/html/material/LoginDialog.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 31,
                                        fixed: true,
                                        source: 'glass/html/material/LoginDialog.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'state',
                            loc: {
                                start: {
                                    line: 7,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/LoginDialog.ion'
                                },
                                end: {
                                    line: 7,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/html/material/LoginDialog.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            properties: []
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'ExpressionStatement',
                expression: {
                    type: 'CallExpression',
                    callee: {
                        type: 'Function',
                        context: true,
                        value: function (_context) {
                            return function () {
                                var state = _context.get('state');
                                state.tab = model.navigation.tab;
                                delete model.navigation.tab;
                                if (state.tab === 'signup') {
                                    model.logout(void 0, false);
                                }
                            };
                        }
                    },
                    arguments: [],
                    loc: {
                        start: {
                            line: 8,
                            column: 4,
                            fixed: true,
                            source: 'glass/html/material/LoginDialog.ion'
                        },
                        end: {
                            line: 14,
                            column: 8,
                            fixed: true,
                            source: 'glass/html/material/LoginDialog.ion'
                        }
                    }
                },
                loc: {
                    start: {
                        line: 8,
                        column: 4,
                        fixed: true,
                        source: 'glass/html/material/LoginDialog.ion'
                    },
                    end: {
                        line: 14,
                        column: 8,
                        fixed: true,
                        source: 'glass/html/material/LoginDialog.ion'
                    }
                },
                order: '3'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'dialog',
                            loc: {
                                start: {
                                    line: 14,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/LoginDialog.ion'
                                },
                                end: {
                                    line: 14,
                                    column: 14,
                                    fixed: true,
                                    source: 'glass/html/material/LoginDialog.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Dialog',
                                    loc: {
                                        start: {
                                            line: 14,
                                            column: 17,
                                            fixed: true,
                                            source: 'glass/html/material/LoginDialog.ion'
                                        },
                                        end: {
                                            line: 14,
                                            column: 23,
                                            fixed: true,
                                            source: 'glass/html/material/LoginDialog.ion'
                                        }
                                    }
                                },
                                arguments: [],
                                loc: {
                                    start: {
                                        line: 14,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/html/material/LoginDialog.ion'
                                    },
                                    end: {
                                        line: 14,
                                        column: 25,
                                        fixed: true,
                                        source: 'glass/html/material/LoginDialog.ion'
                                    }
                                }
                            },
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'classList',
                                        loc: {
                                            start: {
                                                line: 15,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/LoginDialog.ion'
                                            },
                                            end: {
                                                line: 15,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/LoginDialog.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'Literal',
                                                    value: 'LoginDialog'
                                                },
                                                loc: {
                                                    start: {
                                                        line: 16,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/LoginDialog.ion'
                                                    },
                                                    end: {
                                                        line: 16,
                                                        column: 25,
                                                        fixed: true,
                                                        source: 'glass/html/material/LoginDialog.ion'
                                                    }
                                                },
                                                order: '0'
                                            }]
                                    },
                                    kind: 'init',
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'open',
                                        loc: {
                                            start: {
                                                line: 17,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/LoginDialog.ion'
                                            },
                                            end: {
                                                line: 17,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/LoginDialog.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'UnaryExpression',
                                        operator: '!',
                                        argument: {
                                            type: 'UnaryExpression',
                                            operator: '?',
                                            argument: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'model',
                                                    loc: {
                                                        start: {
                                                            line: 17,
                                                            column: 18,
                                                            fixed: true,
                                                            source: 'glass/html/material/LoginDialog.ion'
                                                        },
                                                        end: {
                                                            line: 17,
                                                            column: 23,
                                                            fixed: true,
                                                            source: 'glass/html/material/LoginDialog.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'user',
                                                    loc: {
                                                        start: {
                                                            line: 17,
                                                            column: 24,
                                                            fixed: true,
                                                            source: 'glass/html/material/LoginDialog.ion'
                                                        },
                                                        end: {
                                                            line: 17,
                                                            column: 28,
                                                            fixed: true,
                                                            source: 'glass/html/material/LoginDialog.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 17,
                                                        column: 18,
                                                        fixed: true,
                                                        source: 'glass/html/material/LoginDialog.ion'
                                                    },
                                                    end: {
                                                        line: 17,
                                                        column: 28,
                                                        fixed: true,
                                                        source: 'glass/html/material/LoginDialog.ion'
                                                    }
                                                }
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '1'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'frame',
                                        loc: {
                                            start: {
                                                line: 18,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/LoginDialog.ion'
                                            },
                                            end: {
                                                line: 18,
                                                column: 13,
                                                fixed: true,
                                                source: 'glass/html/material/LoginDialog.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'classList',
                                                    loc: {
                                                        start: {
                                                            line: 19,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/LoginDialog.ion'
                                                        },
                                                        end: {
                                                            line: 19,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'glass/html/material/LoginDialog.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'ObjectExpression',
                                                    properties: [
                                                        {
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'Literal',
                                                                value: 'layout'
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 20,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                },
                                                                end: {
                                                                    line: 20,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                }
                                                            },
                                                            order: '0'
                                                        },
                                                        {
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'Literal',
                                                                value: 'vertical'
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 21,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                },
                                                                end: {
                                                                    line: 21,
                                                                    column: 26,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                }
                                                            },
                                                            order: '1'
                                                        }
                                                    ]
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'style',
                                                    loc: {
                                                        start: {
                                                            line: 22,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/LoginDialog.ion'
                                                        },
                                                        end: {
                                                            line: 22,
                                                            column: 17,
                                                            fixed: true,
                                                            source: 'glass/html/material/LoginDialog.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'ObjectExpression',
                                                    properties: [
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'width',
                                                                loc: {
                                                                    start: {
                                                                        line: 23,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                    },
                                                                    end: {
                                                                        line: 23,
                                                                        column: 21,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Literal',
                                                                value: '430px'
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        },
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'maxWidth',
                                                                loc: {
                                                                    start: {
                                                                        line: 24,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                    },
                                                                    end: {
                                                                        line: 24,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Literal',
                                                                value: '100%'
                                                            },
                                                            kind: 'init',
                                                            order: '1'
                                                        },
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'minHeight',
                                                                loc: {
                                                                    start: {
                                                                        line: 25,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                    },
                                                                    end: {
                                                                        line: 25,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Literal',
                                                                value: '420px'
                                                            },
                                                            kind: 'init',
                                                            order: '2'
                                                        }
                                                    ]
                                                },
                                                kind: 'init',
                                                order: '1'
                                            },
                                            {
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'Identifier',
                                                        name: 'TabContent',
                                                        loc: {
                                                            start: {
                                                                line: 26,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'glass/html/material/LoginDialog.ion'
                                                            },
                                                            end: {
                                                                line: 26,
                                                                column: 22,
                                                                fixed: true,
                                                                source: 'glass/html/material/LoginDialog.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [{
                                                            type: 'ObjectExpression',
                                                            properties: [
                                                                {
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'defaultTab',
                                                                        loc: {
                                                                            start: {
                                                                                line: 27,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 27,
                                                                                column: 26,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'Function',
                                                                            context: true,
                                                                            value: function (_context2) {
                                                                                return function () {
                                                                                    var state = _context2.get('state');
                                                                                    return state.tab != null ? state.tab : (global.model.local != null ? global.model.local.lastLoginTime : void 0) != null ? 'login' : 'signup';
                                                                                };
                                                                            }
                                                                        },
                                                                        arguments: [],
                                                                        loc: {
                                                                            start: {
                                                                                line: 27,
                                                                                column: 28,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 27,
                                                                                column: 103,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                },
                                                                {
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'tabs',
                                                                        loc: {
                                                                            start: {
                                                                                line: 28,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 28,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'ObjectExpression',
                                                                        objectType: {
                                                                            type: 'ArrayExpression',
                                                                            elements: []
                                                                        },
                                                                        properties: [
                                                                            {
                                                                                type: 'ExpressionStatement',
                                                                                expression: {
                                                                                    type: 'ObjectExpression',
                                                                                    objectType: {
                                                                                        type: 'ObjectExpression',
                                                                                        properties: []
                                                                                    },
                                                                                    properties: [
                                                                                        {
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'name',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 30,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 30,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'Literal',
                                                                                                value: 'login'
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '0'
                                                                                        },
                                                                                        {
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'tab',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 31,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 31,
                                                                                                        column: 27,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'Function',
                                                                                                context: false,
                                                                                                value: function () {
                                                                                                    return 'Login';
                                                                                                }
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '1'
                                                                                        },
                                                                                        {
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'content',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 32,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 32,
                                                                                                        column: 31,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'Function',
                                                                                                context: true,
                                                                                                value: function (_ps) {
                                                                                                    return ion.template(function () {
                                                                                                        return ion.createRuntime({
                                                                                                            type: 'Template',
                                                                                                            id: null,
                                                                                                            body: [
                                                                                                                {
                                                                                                                    type: 'VariableDeclaration',
                                                                                                                    declarations: [{
                                                                                                                            type: 'VariableDeclarator',
                                                                                                                            id: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'passwordInput',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 33,
                                                                                                                                        column: 32,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 33,
                                                                                                                                        column: 45,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            init: {
                                                                                                                                type: 'ObjectExpression',
                                                                                                                                objectType: {
                                                                                                                                    type: 'CallExpression',
                                                                                                                                    callee: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'PaperInput',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 33,
                                                                                                                                                column: 48,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 33,
                                                                                                                                                column: 58,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    arguments: [],
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 33,
                                                                                                                                            column: 48,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 33,
                                                                                                                                            column: 60,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                properties: [
                                                                                                                                    {
                                                                                                                                        type: 'Property',
                                                                                                                                        key: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'name',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 34,
                                                                                                                                                    column: 32,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 34,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        value: {
                                                                                                                                            type: 'Literal',
                                                                                                                                            value: 'password'
                                                                                                                                        },
                                                                                                                                        kind: 'init',
                                                                                                                                        order: '0'
                                                                                                                                    },
                                                                                                                                    {
                                                                                                                                        type: 'Property',
                                                                                                                                        key: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'label',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 35,
                                                                                                                                                    column: 32,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 35,
                                                                                                                                                    column: 37,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        value: {
                                                                                                                                            type: 'Literal',
                                                                                                                                            value: 'Password'
                                                                                                                                        },
                                                                                                                                        kind: 'init',
                                                                                                                                        order: '1'
                                                                                                                                    },
                                                                                                                                    {
                                                                                                                                        type: 'Property',
                                                                                                                                        key: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'type',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 36,
                                                                                                                                                    column: 32,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 36,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        value: {
                                                                                                                                            type: 'Literal',
                                                                                                                                            value: 'password'
                                                                                                                                        },
                                                                                                                                        kind: 'init',
                                                                                                                                        order: '2'
                                                                                                                                    },
                                                                                                                                    {
                                                                                                                                        type: 'Property',
                                                                                                                                        key: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'required',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 37,
                                                                                                                                                    column: 32,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 37,
                                                                                                                                                    column: 40,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        value: {
                                                                                                                                            type: 'Literal',
                                                                                                                                            value: true
                                                                                                                                        },
                                                                                                                                        kind: 'init',
                                                                                                                                        order: '3'
                                                                                                                                    }
                                                                                                                                ]
                                                                                                                            }
                                                                                                                        }],
                                                                                                                    kind: 'let',
                                                                                                                    order: '0'
                                                                                                                },
                                                                                                                {
                                                                                                                    type: 'ReturnStatement',
                                                                                                                    argument: {
                                                                                                                        type: 'ObjectExpression',
                                                                                                                        objectType: {
                                                                                                                            type: 'CallExpression',
                                                                                                                            callee: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'GlassForm',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 38,
                                                                                                                                        column: 35,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 38,
                                                                                                                                        column: 44,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            arguments: [{
                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                    properties: [{
                                                                                                                                            type: 'Property',
                                                                                                                                            key: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'class',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 38,
                                                                                                                                                        column: 46,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 38,
                                                                                                                                                        column: 51,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            value: {
                                                                                                                                                type: 'Literal',
                                                                                                                                                value: 'layout vertical flex'
                                                                                                                                            },
                                                                                                                                            kind: 'init',
                                                                                                                                            order: '0'
                                                                                                                                        }]
                                                                                                                                }],
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 38,
                                                                                                                                    column: 35,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 38,
                                                                                                                                    column: 76,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        properties: [
                                                                                                                            {
                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                expression: {
                                                                                                                                    type: 'Function',
                                                                                                                                    context: true,
                                                                                                                                    value: function (_context3) {
                                                                                                                                        return function complete() {
                                                                                                                                            var passwordInput = _context3.get('passwordInput');
                                                                                                                                            model.login(this.values);
                                                                                                                                            passwordInput.value = '';
                                                                                                                                        };
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 39,
                                                                                                                                        column: 32,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 42,
                                                                                                                                        column: 36,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                order: '0'
                                                                                                                            },
                                                                                                                            {
                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                expression: {
                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                    objectType: {
                                                                                                                                        type: 'CallExpression',
                                                                                                                                        callee: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'Section',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 42,
                                                                                                                                                    column: 32,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 42,
                                                                                                                                                    column: 39,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        arguments: [],
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 42,
                                                                                                                                                column: 32,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 42,
                                                                                                                                                column: 41,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    properties: [
                                                                                                                                        {
                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                            expression: {
                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                objectType: {
                                                                                                                                                    type: 'CallExpression',
                                                                                                                                                    callee: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'P',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 43,
                                                                                                                                                                column: 36,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 43,
                                                                                                                                                                column: 37,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    arguments: [],
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 43,
                                                                                                                                                            column: 36,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 43,
                                                                                                                                                            column: 39,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                properties: [{
                                                                                                                                                        type: 'IfStatement',
                                                                                                                                                        test: {
                                                                                                                                                            type: 'BinaryExpression',
                                                                                                                                                            operator: '===',
                                                                                                                                                            left: {
                                                                                                                                                                type: 'MemberExpression',
                                                                                                                                                                computed: false,
                                                                                                                                                                object: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'model',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 44,
                                                                                                                                                                            column: 43,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 44,
                                                                                                                                                                            column: 48,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                property: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'logoutStatus',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 44,
                                                                                                                                                                            column: 49,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 44,
                                                                                                                                                                            column: 61,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 44,
                                                                                                                                                                        column: 43,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 44,
                                                                                                                                                                        column: 61,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            right: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: 401
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        consequent: {
                                                                                                                                                            type: 'BlockStatement',
                                                                                                                                                            body: [{
                                                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                                                    expression: {
                                                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                                                        objectType: {
                                                                                                                                                                            type: 'CallExpression',
                                                                                                                                                                            callee: {
                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                name: 'Span',
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 45,
                                                                                                                                                                                        column: 44,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 45,
                                                                                                                                                                                        column: 48,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            arguments: [{
                                                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                                                    properties: [{
                                                                                                                                                                                            type: 'Property',
                                                                                                                                                                                            key: {
                                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                                name: 'class',
                                                                                                                                                                                                loc: {
                                                                                                                                                                                                    start: {
                                                                                                                                                                                                        line: 45,
                                                                                                                                                                                                        column: 50,
                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                                    },
                                                                                                                                                                                                    end: {
                                                                                                                                                                                                        line: 45,
                                                                                                                                                                                                        column: 55,
                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                                    }
                                                                                                                                                                                                }
                                                                                                                                                                                            },
                                                                                                                                                                                            value: {
                                                                                                                                                                                                type: 'Literal',
                                                                                                                                                                                                value: 'error'
                                                                                                                                                                                            },
                                                                                                                                                                                            kind: 'init',
                                                                                                                                                                                            order: '0'
                                                                                                                                                                                        }]
                                                                                                                                                                                }],
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 45,
                                                                                                                                                                                    column: 44,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 45,
                                                                                                                                                                                    column: 65,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        properties: [{
                                                                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                                                                expression: {
                                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                                    value: 'Invalid password, please try again.'
                                                                                                                                                                                },
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 46,
                                                                                                                                                                                        column: 48,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 46,
                                                                                                                                                                                        column: 85,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                },
                                                                                                                                                                                order: '0'
                                                                                                                                                                            }]
                                                                                                                                                                    },
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 45,
                                                                                                                                                                            column: 44,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 47,
                                                                                                                                                                            column: 48,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    order: '0'
                                                                                                                                                                }]
                                                                                                                                                        },
                                                                                                                                                        alternate: {
                                                                                                                                                            type: 'IfStatement',
                                                                                                                                                            test: {
                                                                                                                                                                type: 'BinaryExpression',
                                                                                                                                                                operator: '===',
                                                                                                                                                                left: {
                                                                                                                                                                    type: 'MemberExpression',
                                                                                                                                                                    computed: false,
                                                                                                                                                                    object: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'model',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 47,
                                                                                                                                                                                column: 48,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 47,
                                                                                                                                                                                column: 53,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    property: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'logoutStatus',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 47,
                                                                                                                                                                                column: 54,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 47,
                                                                                                                                                                                column: 66,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 47,
                                                                                                                                                                            column: 48,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 47,
                                                                                                                                                                            column: 66,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                right: {
                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                    value: 404
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            consequent: {
                                                                                                                                                                type: 'BlockStatement',
                                                                                                                                                                body: [{
                                                                                                                                                                        type: 'ExpressionStatement',
                                                                                                                                                                        expression: {
                                                                                                                                                                            type: 'ObjectExpression',
                                                                                                                                                                            objectType: {
                                                                                                                                                                                type: 'CallExpression',
                                                                                                                                                                                callee: {
                                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                                    name: 'Span',
                                                                                                                                                                                    loc: {
                                                                                                                                                                                        start: {
                                                                                                                                                                                            line: 48,
                                                                                                                                                                                            column: 44,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                        },
                                                                                                                                                                                        end: {
                                                                                                                                                                                            line: 48,
                                                                                                                                                                                            column: 48,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                        }
                                                                                                                                                                                    }
                                                                                                                                                                                },
                                                                                                                                                                                arguments: [{
                                                                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                                                                        properties: [{
                                                                                                                                                                                                type: 'Property',
                                                                                                                                                                                                key: {
                                                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                                                    name: 'class',
                                                                                                                                                                                                    loc: {
                                                                                                                                                                                                        start: {
                                                                                                                                                                                                            line: 48,
                                                                                                                                                                                                            column: 50,
                                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                                        },
                                                                                                                                                                                                        end: {
                                                                                                                                                                                                            line: 48,
                                                                                                                                                                                                            column: 55,
                                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                                        }
                                                                                                                                                                                                    }
                                                                                                                                                                                                },
                                                                                                                                                                                                value: {
                                                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                                                    value: 'error'
                                                                                                                                                                                                },
                                                                                                                                                                                                kind: 'init',
                                                                                                                                                                                                order: '0'
                                                                                                                                                                                            }]
                                                                                                                                                                                    }],
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 48,
                                                                                                                                                                                        column: 44,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 48,
                                                                                                                                                                                        column: 65,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            properties: [{
                                                                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                                                                    expression: {
                                                                                                                                                                                        type: 'Literal',
                                                                                                                                                                                        value: 'User email address not found.'
                                                                                                                                                                                    },
                                                                                                                                                                                    loc: {
                                                                                                                                                                                        start: {
                                                                                                                                                                                            line: 49,
                                                                                                                                                                                            column: 48,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                        },
                                                                                                                                                                                        end: {
                                                                                                                                                                                            line: 49,
                                                                                                                                                                                            column: 79,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                        }
                                                                                                                                                                                    },
                                                                                                                                                                                    order: '0'
                                                                                                                                                                                }]
                                                                                                                                                                        },
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 48,
                                                                                                                                                                                column: 44,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 50,
                                                                                                                                                                                column: 48,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        order: '0'
                                                                                                                                                                    }]
                                                                                                                                                            },
                                                                                                                                                            alternate: {
                                                                                                                                                                type: 'IfStatement',
                                                                                                                                                                test: {
                                                                                                                                                                    type: 'BinaryExpression',
                                                                                                                                                                    operator: '===',
                                                                                                                                                                    left: {
                                                                                                                                                                        type: 'MemberExpression',
                                                                                                                                                                        computed: false,
                                                                                                                                                                        object: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'model',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 50,
                                                                                                                                                                                    column: 48,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 50,
                                                                                                                                                                                    column: 53,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        property: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'logoutStatus',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 50,
                                                                                                                                                                                    column: 54,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 50,
                                                                                                                                                                                    column: 66,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 50,
                                                                                                                                                                                column: 48,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 50,
                                                                                                                                                                                column: 66,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    right: {
                                                                                                                                                                        type: 'Literal',
                                                                                                                                                                        value: 419
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                consequent: {
                                                                                                                                                                    type: 'BlockStatement',
                                                                                                                                                                    body: [{
                                                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                                                            expression: {
                                                                                                                                                                                type: 'Literal',
                                                                                                                                                                                value: 'Session expired, please login again.'
                                                                                                                                                                            },
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 51,
                                                                                                                                                                                    column: 44,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 51,
                                                                                                                                                                                    column: 82,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            order: '0'
                                                                                                                                                                        }]
                                                                                                                                                                },
                                                                                                                                                                alternate: {
                                                                                                                                                                    type: 'IfStatement',
                                                                                                                                                                    test: {
                                                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                                                        operator: '&&',
                                                                                                                                                                        left: {
                                                                                                                                                                            type: 'UnaryExpression',
                                                                                                                                                                            operator: '?',
                                                                                                                                                                            argument: {
                                                                                                                                                                                type: 'MemberExpression',
                                                                                                                                                                                computed: false,
                                                                                                                                                                                object: {
                                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                                    name: 'model',
                                                                                                                                                                                    loc: {
                                                                                                                                                                                        start: {
                                                                                                                                                                                            line: 52,
                                                                                                                                                                                            column: 48,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                        },
                                                                                                                                                                                        end: {
                                                                                                                                                                                            line: 52,
                                                                                                                                                                                            column: 53,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                        }
                                                                                                                                                                                    }
                                                                                                                                                                                },
                                                                                                                                                                                property: {
                                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                                    name: 'server',
                                                                                                                                                                                    loc: {
                                                                                                                                                                                        start: {
                                                                                                                                                                                            line: 52,
                                                                                                                                                                                            column: 54,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                        },
                                                                                                                                                                                        end: {
                                                                                                                                                                                            line: 52,
                                                                                                                                                                                            column: 60,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                        }
                                                                                                                                                                                    }
                                                                                                                                                                                },
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 52,
                                                                                                                                                                                        column: 48,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 52,
                                                                                                                                                                                        column: 60,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        right: {
                                                                                                                                                                            type: 'UnaryExpression',
                                                                                                                                                                            operator: '!',
                                                                                                                                                                            argument: {
                                                                                                                                                                                type: 'UnaryExpression',
                                                                                                                                                                                operator: '?',
                                                                                                                                                                                argument: {
                                                                                                                                                                                    type: 'MemberExpression',
                                                                                                                                                                                    computed: false,
                                                                                                                                                                                    object: {
                                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                                        name: 'model',
                                                                                                                                                                                        loc: {
                                                                                                                                                                                            start: {
                                                                                                                                                                                                line: 52,
                                                                                                                                                                                                column: 70,
                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                            },
                                                                                                                                                                                            end: {
                                                                                                                                                                                                line: 52,
                                                                                                                                                                                                column: 75,
                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                            }
                                                                                                                                                                                        }
                                                                                                                                                                                    },
                                                                                                                                                                                    property: {
                                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                                        name: 'user',
                                                                                                                                                                                        loc: {
                                                                                                                                                                                            start: {
                                                                                                                                                                                                line: 52,
                                                                                                                                                                                                column: 76,
                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                            },
                                                                                                                                                                                            end: {
                                                                                                                                                                                                line: 52,
                                                                                                                                                                                                column: 80,
                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                            }
                                                                                                                                                                                        }
                                                                                                                                                                                    },
                                                                                                                                                                                    loc: {
                                                                                                                                                                                        start: {
                                                                                                                                                                                            line: 52,
                                                                                                                                                                                            column: 70,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                        },
                                                                                                                                                                                        end: {
                                                                                                                                                                                            line: 52,
                                                                                                                                                                                            column: 80,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                        }
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    consequent: {
                                                                                                                                                                        type: 'BlockStatement',
                                                                                                                                                                        body: [{
                                                                                                                                                                                type: 'IfStatement',
                                                                                                                                                                                test: {
                                                                                                                                                                                    type: 'UnaryExpression',
                                                                                                                                                                                    operator: '?',
                                                                                                                                                                                    argument: {
                                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                                        name: 'loader',
                                                                                                                                                                                        loc: {
                                                                                                                                                                                            start: {
                                                                                                                                                                                                line: 53,
                                                                                                                                                                                                column: 47,
                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                            },
                                                                                                                                                                                            end: {
                                                                                                                                                                                                line: 53,
                                                                                                                                                                                                column: 53,
                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                            }
                                                                                                                                                                                        }
                                                                                                                                                                                    }
                                                                                                                                                                                },
                                                                                                                                                                                consequent: {
                                                                                                                                                                                    type: 'BlockStatement',
                                                                                                                                                                                    body: [{
                                                                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                                                                            expression: {
                                                                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                                                                objectType: {
                                                                                                                                                                                                    type: 'CallExpression',
                                                                                                                                                                                                    callee: {
                                                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                                                        name: 'Div',
                                                                                                                                                                                                        loc: {
                                                                                                                                                                                                            start: {
                                                                                                                                                                                                                line: 54,
                                                                                                                                                                                                                column: 48,
                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                                            },
                                                                                                                                                                                                            end: {
                                                                                                                                                                                                                line: 54,
                                                                                                                                                                                                                column: 51,
                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                                            }
                                                                                                                                                                                                        }
                                                                                                                                                                                                    },
                                                                                                                                                                                                    arguments: [{
                                                                                                                                                                                                            type: 'ObjectExpression',
                                                                                                                                                                                                            properties: [{
                                                                                                                                                                                                                    type: 'Property',
                                                                                                                                                                                                                    key: {
                                                                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                                                                        name: 'class',
                                                                                                                                                                                                                        loc: {
                                                                                                                                                                                                                            start: {
                                                                                                                                                                                                                                line: 54,
                                                                                                                                                                                                                                column: 53,
                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                                                            },
                                                                                                                                                                                                                            end: {
                                                                                                                                                                                                                                line: 54,
                                                                                                                                                                                                                                column: 58,
                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                                                            }
                                                                                                                                                                                                                        }
                                                                                                                                                                                                                    },
                                                                                                                                                                                                                    value: {
                                                                                                                                                                                                                        type: 'Literal',
                                                                                                                                                                                                                        value: 'layout fill center justified-center'
                                                                                                                                                                                                                    },
                                                                                                                                                                                                                    kind: 'init',
                                                                                                                                                                                                                    order: '0'
                                                                                                                                                                                                                }]
                                                                                                                                                                                                        }],
                                                                                                                                                                                                    loc: {
                                                                                                                                                                                                        start: {
                                                                                                                                                                                                            line: 54,
                                                                                                                                                                                                            column: 48,
                                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                                        },
                                                                                                                                                                                                        end: {
                                                                                                                                                                                                            line: 54,
                                                                                                                                                                                                            column: 98,
                                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                                        }
                                                                                                                                                                                                    }
                                                                                                                                                                                                },
                                                                                                                                                                                                properties: [
                                                                                                                                                                                                    {
                                                                                                                                                                                                        type: 'Property',
                                                                                                                                                                                                        key: {
                                                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                                                            name: 'style',
                                                                                                                                                                                                            loc: {
                                                                                                                                                                                                                start: {
                                                                                                                                                                                                                    line: 55,
                                                                                                                                                                                                                    column: 52,
                                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                                                },
                                                                                                                                                                                                                end: {
                                                                                                                                                                                                                    line: 55,
                                                                                                                                                                                                                    column: 57,
                                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                                                }
                                                                                                                                                                                                            }
                                                                                                                                                                                                        },
                                                                                                                                                                                                        value: {
                                                                                                                                                                                                            type: 'ObjectExpression',
                                                                                                                                                                                                            properties: [
                                                                                                                                                                                                                {
                                                                                                                                                                                                                    type: 'Property',
                                                                                                                                                                                                                    key: {
                                                                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                                                                        name: 'position',
                                                                                                                                                                                                                        loc: {
                                                                                                                                                                                                                            start: {
                                                                                                                                                                                                                                line: 56,
                                                                                                                                                                                                                                column: 56,
                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                                                            },
                                                                                                                                                                                                                            end: {
                                                                                                                                                                                                                                line: 56,
                                                                                                                                                                                                                                column: 64,
                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                                                            }
                                                                                                                                                                                                                        }
                                                                                                                                                                                                                    },
                                                                                                                                                                                                                    value: {
                                                                                                                                                                                                                        type: 'Literal',
                                                                                                                                                                                                                        value: 'fixed'
                                                                                                                                                                                                                    },
                                                                                                                                                                                                                    kind: 'init',
                                                                                                                                                                                                                    order: '0'
                                                                                                                                                                                                                },
                                                                                                                                                                                                                {
                                                                                                                                                                                                                    type: 'Property',
                                                                                                                                                                                                                    key: {
                                                                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                                                                        name: 'top',
                                                                                                                                                                                                                        loc: {
                                                                                                                                                                                                                            start: {
                                                                                                                                                                                                                                line: 57,
                                                                                                                                                                                                                                column: 56,
                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                                                            },
                                                                                                                                                                                                                            end: {
                                                                                                                                                                                                                                line: 57,
                                                                                                                                                                                                                                column: 59,
                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                                                            }
                                                                                                                                                                                                                        }
                                                                                                                                                                                                                    },
                                                                                                                                                                                                                    value: {
                                                                                                                                                                                                                        type: 'Literal',
                                                                                                                                                                                                                        value: 0
                                                                                                                                                                                                                    },
                                                                                                                                                                                                                    kind: 'init',
                                                                                                                                                                                                                    order: '1'
                                                                                                                                                                                                                },
                                                                                                                                                                                                                {
                                                                                                                                                                                                                    type: 'Property',
                                                                                                                                                                                                                    key: {
                                                                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                                                                        name: 'bottom',
                                                                                                                                                                                                                        loc: {
                                                                                                                                                                                                                            start: {
                                                                                                                                                                                                                                line: 58,
                                                                                                                                                                                                                                column: 56,
                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                                                            },
                                                                                                                                                                                                                            end: {
                                                                                                                                                                                                                                line: 58,
                                                                                                                                                                                                                                column: 62,
                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                                                            }
                                                                                                                                                                                                                        }
                                                                                                                                                                                                                    },
                                                                                                                                                                                                                    value: {
                                                                                                                                                                                                                        type: 'Literal',
                                                                                                                                                                                                                        value: 0
                                                                                                                                                                                                                    },
                                                                                                                                                                                                                    kind: 'init',
                                                                                                                                                                                                                    order: '2'
                                                                                                                                                                                                                },
                                                                                                                                                                                                                {
                                                                                                                                                                                                                    type: 'Property',
                                                                                                                                                                                                                    key: {
                                                                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                                                                        name: 'right',
                                                                                                                                                                                                                        loc: {
                                                                                                                                                                                                                            start: {
                                                                                                                                                                                                                                line: 59,
                                                                                                                                                                                                                                column: 56,
                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                                                            },
                                                                                                                                                                                                                            end: {
                                                                                                                                                                                                                                line: 59,
                                                                                                                                                                                                                                column: 61,
                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                                                            }
                                                                                                                                                                                                                        }
                                                                                                                                                                                                                    },
                                                                                                                                                                                                                    value: {
                                                                                                                                                                                                                        type: 'Literal',
                                                                                                                                                                                                                        value: 0
                                                                                                                                                                                                                    },
                                                                                                                                                                                                                    kind: 'init',
                                                                                                                                                                                                                    order: '3'
                                                                                                                                                                                                                },
                                                                                                                                                                                                                {
                                                                                                                                                                                                                    type: 'Property',
                                                                                                                                                                                                                    key: {
                                                                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                                                                        name: 'left',
                                                                                                                                                                                                                        loc: {
                                                                                                                                                                                                                            start: {
                                                                                                                                                                                                                                line: 60,
                                                                                                                                                                                                                                column: 56,
                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                                                            },
                                                                                                                                                                                                                            end: {
                                                                                                                                                                                                                                line: 60,
                                                                                                                                                                                                                                column: 60,
                                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                                                            }
                                                                                                                                                                                                                        }
                                                                                                                                                                                                                    },
                                                                                                                                                                                                                    value: {
                                                                                                                                                                                                                        type: 'Literal',
                                                                                                                                                                                                                        value: 0
                                                                                                                                                                                                                    },
                                                                                                                                                                                                                    kind: 'init',
                                                                                                                                                                                                                    order: '4'
                                                                                                                                                                                                                },
                                                                                                                                                                                                                {
                                                                                                                                                                                                                    type: 'Property',
                                                                                                                                                                                                                    key: {
                                                                                                                                                                                                                        type: 'Literal',
                                                                                                                                                                                                                        value: 'background-color'
                                                                                                                                                                                                                    },
                                                                                                                                                                                                                    value: {
                                                                                                                                                                                                                        type: 'Literal',
                                                                                                                                                                                                                        value: 'rgba(255,255,255,.85)'
                                                                                                                                                                                                                    },
                                                                                                                                                                                                                    kind: 'init',
                                                                                                                                                                                                                    order: '5'
                                                                                                                                                                                                                },
                                                                                                                                                                                                                {
                                                                                                                                                                                                                    type: 'Property',
                                                                                                                                                                                                                    key: {
                                                                                                                                                                                                                        type: 'Literal',
                                                                                                                                                                                                                        value: 'z-index'
                                                                                                                                                                                                                    },
                                                                                                                                                                                                                    value: {
                                                                                                                                                                                                                        type: 'Literal',
                                                                                                                                                                                                                        value: 200
                                                                                                                                                                                                                    },
                                                                                                                                                                                                                    kind: 'init',
                                                                                                                                                                                                                    order: '6'
                                                                                                                                                                                                                }
                                                                                                                                                                                                            ]
                                                                                                                                                                                                        },
                                                                                                                                                                                                        kind: 'init',
                                                                                                                                                                                                        order: '0'
                                                                                                                                                                                                    },
                                                                                                                                                                                                    {
                                                                                                                                                                                                        type: 'ExpressionStatement',
                                                                                                                                                                                                        expression: {
                                                                                                                                                                                                            type: 'CallExpression',
                                                                                                                                                                                                            callee: {
                                                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                                                name: 'loader',
                                                                                                                                                                                                                loc: {
                                                                                                                                                                                                                    start: {
                                                                                                                                                                                                                        line: 63,
                                                                                                                                                                                                                        column: 52,
                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                                                    },
                                                                                                                                                                                                                    end: {
                                                                                                                                                                                                                        line: 63,
                                                                                                                                                                                                                        column: 58,
                                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                                                    }
                                                                                                                                                                                                                }
                                                                                                                                                                                                            },
                                                                                                                                                                                                            arguments: [],
                                                                                                                                                                                                            loc: {
                                                                                                                                                                                                                start: {
                                                                                                                                                                                                                    line: 63,
                                                                                                                                                                                                                    column: 52,
                                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                                                },
                                                                                                                                                                                                                end: {
                                                                                                                                                                                                                    line: 63,
                                                                                                                                                                                                                    column: 60,
                                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                                                }
                                                                                                                                                                                                            }
                                                                                                                                                                                                        },
                                                                                                                                                                                                        loc: {
                                                                                                                                                                                                            start: {
                                                                                                                                                                                                                line: 63,
                                                                                                                                                                                                                column: 52,
                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                                            },
                                                                                                                                                                                                            end: {
                                                                                                                                                                                                                line: 63,
                                                                                                                                                                                                                column: 60,
                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                                            }
                                                                                                                                                                                                        },
                                                                                                                                                                                                        order: '1'
                                                                                                                                                                                                    }
                                                                                                                                                                                                ]
                                                                                                                                                                                            },
                                                                                                                                                                                            loc: {
                                                                                                                                                                                                start: {
                                                                                                                                                                                                    line: 54,
                                                                                                                                                                                                    column: 48,
                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                                },
                                                                                                                                                                                                end: {
                                                                                                                                                                                                    line: 64,
                                                                                                                                                                                                    column: 52,
                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                                }
                                                                                                                                                                                            },
                                                                                                                                                                                            order: '0'
                                                                                                                                                                                        }]
                                                                                                                                                                                },
                                                                                                                                                                                alternate: {
                                                                                                                                                                                    type: 'BlockStatement',
                                                                                                                                                                                    body: [{
                                                                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                                                                            expression: {
                                                                                                                                                                                                type: 'Literal',
                                                                                                                                                                                                value: 'Authenticating...'
                                                                                                                                                                                            },
                                                                                                                                                                                            loc: {
                                                                                                                                                                                                start: {
                                                                                                                                                                                                    line: 65,
                                                                                                                                                                                                    column: 48,
                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                                },
                                                                                                                                                                                                end: {
                                                                                                                                                                                                    line: 65,
                                                                                                                                                                                                    column: 67,
                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                                }
                                                                                                                                                                                            },
                                                                                                                                                                                            order: '0'
                                                                                                                                                                                        }]
                                                                                                                                                                                },
                                                                                                                                                                                order: '0'
                                                                                                                                                                            }]
                                                                                                                                                                    },
                                                                                                                                                                    alternate: {
                                                                                                                                                                        type: 'BlockStatement',
                                                                                                                                                                        body: [{
                                                                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                                                                expression: {
                                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                                    value: 'Enter your email and password to continue.'
                                                                                                                                                                                },
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 67,
                                                                                                                                                                                        column: 44,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 67,
                                                                                                                                                                                        column: 88,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                },
                                                                                                                                                                                order: '0'
                                                                                                                                                                            }]
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        order: '0'
                                                                                                                                                    }]
                                                                                                                                            },
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 43,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 68,
                                                                                                                                                    column: 40,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            order: '0'
                                                                                                                                        },
                                                                                                                                        {
                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                            expression: {
                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                objectType: {
                                                                                                                                                    type: 'CallExpression',
                                                                                                                                                    callee: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'GoldEmailInput',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 68,
                                                                                                                                                                column: 36,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 68,
                                                                                                                                                                column: 50,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    arguments: [],
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 68,
                                                                                                                                                            column: 36,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 68,
                                                                                                                                                            column: 52,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                properties: [
                                                                                                                                                    {
                                                                                                                                                        type: 'Property',
                                                                                                                                                        key: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'name',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 69,
                                                                                                                                                                    column: 40,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 69,
                                                                                                                                                                    column: 44,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        value: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: 'userId'
                                                                                                                                                        },
                                                                                                                                                        kind: 'init',
                                                                                                                                                        order: '0'
                                                                                                                                                    },
                                                                                                                                                    {
                                                                                                                                                        type: 'Property',
                                                                                                                                                        key: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'label',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 70,
                                                                                                                                                                    column: 40,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 70,
                                                                                                                                                                    column: 45,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        value: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: 'Email'
                                                                                                                                                        },
                                                                                                                                                        kind: 'init',
                                                                                                                                                        order: '1'
                                                                                                                                                    },
                                                                                                                                                    {
                                                                                                                                                        type: 'Property',
                                                                                                                                                        key: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'required',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 71,
                                                                                                                                                                    column: 40,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 71,
                                                                                                                                                                    column: 48,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        value: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: true
                                                                                                                                                        },
                                                                                                                                                        kind: 'init',
                                                                                                                                                        order: '2'
                                                                                                                                                    }
                                                                                                                                                ]
                                                                                                                                            },
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 68,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 75,
                                                                                                                                                    column: 40,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            order: '1'
                                                                                                                                        },
                                                                                                                                        {
                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                            expression: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'passwordInput',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 75,
                                                                                                                                                        column: 36,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 75,
                                                                                                                                                        column: 49,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 75,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 75,
                                                                                                                                                    column: 49,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            order: '2'
                                                                                                                                        }
                                                                                                                                    ]
                                                                                                                                },
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 42,
                                                                                                                                        column: 32,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 76,
                                                                                                                                        column: 36,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                order: '1'
                                                                                                                            },
                                                                                                                            {
                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                expression: {
                                                                                                                                    type: 'CallExpression',
                                                                                                                                    callee: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'Div',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 76,
                                                                                                                                                column: 32,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 76,
                                                                                                                                                column: 35,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    arguments: [{
                                                                                                                                            type: 'ObjectExpression',
                                                                                                                                            properties: [{
                                                                                                                                                    type: 'Property',
                                                                                                                                                    key: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'class',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 76,
                                                                                                                                                                column: 37,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 76,
                                                                                                                                                                column: 42,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    value: {
                                                                                                                                                        type: 'Literal',
                                                                                                                                                        value: 'flex'
                                                                                                                                                    },
                                                                                                                                                    kind: 'init',
                                                                                                                                                    order: '0'
                                                                                                                                                }]
                                                                                                                                        }],
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 76,
                                                                                                                                            column: 32,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 76,
                                                                                                                                            column: 51,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 76,
                                                                                                                                        column: 32,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 76,
                                                                                                                                        column: 51,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                order: '2'
                                                                                                                            },
                                                                                                                            {
                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                expression: {
                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                    objectType: {
                                                                                                                                        type: 'CallExpression',
                                                                                                                                        callee: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'Footer',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 77,
                                                                                                                                                    column: 32,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 77,
                                                                                                                                                    column: 38,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        arguments: [{
                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                properties: [{
                                                                                                                                                        type: 'Property',
                                                                                                                                                        key: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'class',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 77,
                                                                                                                                                                    column: 40,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 77,
                                                                                                                                                                    column: 45,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        value: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: 'layout horizontal fixed'
                                                                                                                                                        },
                                                                                                                                                        kind: 'init',
                                                                                                                                                        order: '0'
                                                                                                                                                    }]
                                                                                                                                            }],
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 77,
                                                                                                                                                column: 32,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 77,
                                                                                                                                                column: 73,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    properties: [
                                                                                                                                        {
                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                            expression: {
                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                objectType: {
                                                                                                                                                    type: 'CallExpression',
                                                                                                                                                    callee: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'Checkbox',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 78,
                                                                                                                                                                column: 36,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 78,
                                                                                                                                                                column: 44,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    arguments: [],
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 78,
                                                                                                                                                            column: 36,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 78,
                                                                                                                                                            column: 46,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                properties: [
                                                                                                                                                    {
                                                                                                                                                        type: 'Property',
                                                                                                                                                        key: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'name',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 79,
                                                                                                                                                                    column: 40,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 79,
                                                                                                                                                                    column: 44,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        value: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: 'remember'
                                                                                                                                                        },
                                                                                                                                                        kind: 'init',
                                                                                                                                                        order: '0'
                                                                                                                                                    },
                                                                                                                                                    {
                                                                                                                                                        type: 'ExpressionStatement',
                                                                                                                                                        expression: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: 'Remember me'
                                                                                                                                                        },
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 80,
                                                                                                                                                                column: 40,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 80,
                                                                                                                                                                column: 53,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        order: '1'
                                                                                                                                                    }
                                                                                                                                                ]
                                                                                                                                            },
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 78,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 81,
                                                                                                                                                    column: 40,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            order: '0'
                                                                                                                                        },
                                                                                                                                        {
                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                            expression: {
                                                                                                                                                type: 'CallExpression',
                                                                                                                                                callee: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'Div',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 81,
                                                                                                                                                            column: 36,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 81,
                                                                                                                                                            column: 39,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                arguments: [{
                                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                                        properties: [{
                                                                                                                                                                type: 'Property',
                                                                                                                                                                key: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'class',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 81,
                                                                                                                                                                            column: 41,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 81,
                                                                                                                                                                            column: 46,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                value: {
                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                    value: 'flex'
                                                                                                                                                                },
                                                                                                                                                                kind: 'init',
                                                                                                                                                                order: '0'
                                                                                                                                                            }]
                                                                                                                                                    }],
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 81,
                                                                                                                                                        column: 36,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 81,
                                                                                                                                                        column: 55,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 81,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 81,
                                                                                                                                                    column: 55,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            order: '1'
                                                                                                                                        },
                                                                                                                                        {
                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                            expression: {
                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                objectType: {
                                                                                                                                                    type: 'CallExpression',
                                                                                                                                                    callee: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'SubmitButton',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 82,
                                                                                                                                                                column: 36,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 82,
                                                                                                                                                                column: 48,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    arguments: [],
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 82,
                                                                                                                                                            column: 36,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 82,
                                                                                                                                                            column: 50,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                properties: [{
                                                                                                                                                        type: 'ExpressionStatement',
                                                                                                                                                        expression: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: 'Login'
                                                                                                                                                        },
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 83,
                                                                                                                                                                column: 40,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 83,
                                                                                                                                                                column: 47,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        order: '0'
                                                                                                                                                    }]
                                                                                                                                            },
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 82,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 84,
                                                                                                                                                    column: 40,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            order: '2'
                                                                                                                                        }
                                                                                                                                    ]
                                                                                                                                },
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 77,
                                                                                                                                        column: 32,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 84,
                                                                                                                                        column: 36,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                order: '3'
                                                                                                                            }
                                                                                                                        ]
                                                                                                                    },
                                                                                                                    order: '1'
                                                                                                                }
                                                                                                            ],
                                                                                                            bound: false,
                                                                                                            name: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'content',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 32,
                                                                                                                        column: 24,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 32,
                                                                                                                        column: 31,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            scope: {
                                                                                                                type: 'Identifier',
                                                                                                                name: '_ps'
                                                                                                            }
                                                                                                        }, {
                                                                                                            this: this,
                                                                                                            _ps: _ps,
                                                                                                            _ref3: _ref3,
                                                                                                            _ref: _ref,
                                                                                                            _ref2: _ref2,
                                                                                                            style: style,
                                                                                                            Dialog: Dialog,
                                                                                                            TabContent: TabContent,
                                                                                                            GlassForm: GlassForm,
                                                                                                            SubmitButton: SubmitButton,
                                                                                                            Checkbox: Checkbox
                                                                                                        }, _ps);
                                                                                                    });
                                                                                                }
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '2'
                                                                                        }
                                                                                    ]
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 29,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 84,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                    }
                                                                                },
                                                                                order: '0'
                                                                            },
                                                                            {
                                                                                type: 'ExpressionStatement',
                                                                                expression: {
                                                                                    type: 'ObjectExpression',
                                                                                    objectType: {
                                                                                        type: 'ObjectExpression',
                                                                                        properties: []
                                                                                    },
                                                                                    properties: [
                                                                                        {
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'name',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 85,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 85,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'Literal',
                                                                                                value: 'signup'
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '0'
                                                                                        },
                                                                                        {
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'tab',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 86,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 86,
                                                                                                        column: 27,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'Function',
                                                                                                context: false,
                                                                                                value: function () {
                                                                                                    return 'Signup';
                                                                                                }
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '1'
                                                                                        },
                                                                                        {
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'content',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 87,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 87,
                                                                                                        column: 31,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'Function',
                                                                                                context: true,
                                                                                                value: function (_ps2) {
                                                                                                    return ion.template(function () {
                                                                                                        return ion.createRuntime({
                                                                                                            type: 'Template',
                                                                                                            id: null,
                                                                                                            body: [{
                                                                                                                    type: 'ReturnStatement',
                                                                                                                    argument: {
                                                                                                                        type: 'ObjectExpression',
                                                                                                                        objectType: {
                                                                                                                            type: 'CallExpression',
                                                                                                                            callee: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'GlassForm',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 88,
                                                                                                                                        column: 35,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 88,
                                                                                                                                        column: 44,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            arguments: [{
                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                    properties: [{
                                                                                                                                            type: 'Property',
                                                                                                                                            key: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'class',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 88,
                                                                                                                                                        column: 46,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 88,
                                                                                                                                                        column: 51,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            value: {
                                                                                                                                                type: 'Literal',
                                                                                                                                                value: 'layout vertical flex'
                                                                                                                                            },
                                                                                                                                            kind: 'init',
                                                                                                                                            order: '0'
                                                                                                                                        }]
                                                                                                                                }],
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 88,
                                                                                                                                    column: 35,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 88,
                                                                                                                                    column: 76,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        properties: [
                                                                                                                            {
                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                expression: {
                                                                                                                                    type: 'Function',
                                                                                                                                    context: false,
                                                                                                                                    value: function complete() {
                                                                                                                                        model.signup(this.values);
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 89,
                                                                                                                                        column: 32,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 91,
                                                                                                                                        column: 36,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                order: '0'
                                                                                                                            },
                                                                                                                            {
                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                expression: {
                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                    objectType: {
                                                                                                                                        type: 'CallExpression',
                                                                                                                                        callee: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'Section',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 91,
                                                                                                                                                    column: 32,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 91,
                                                                                                                                                    column: 39,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        arguments: [],
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 91,
                                                                                                                                                column: 32,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 91,
                                                                                                                                                column: 41,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    properties: [
                                                                                                                                        {
                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                            expression: {
                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                objectType: {
                                                                                                                                                    type: 'CallExpression',
                                                                                                                                                    callee: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'P',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 92,
                                                                                                                                                                column: 36,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 92,
                                                                                                                                                                column: 37,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    arguments: [],
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 92,
                                                                                                                                                            column: 36,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 92,
                                                                                                                                                            column: 39,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                properties: [{
                                                                                                                                                        type: 'ExpressionStatement',
                                                                                                                                                        expression: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: 'Enter your email and choose a password.'
                                                                                                                                                        },
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 93,
                                                                                                                                                                column: 40,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 93,
                                                                                                                                                                column: 81,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        order: '0'
                                                                                                                                                    }]
                                                                                                                                            },
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 92,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 94,
                                                                                                                                                    column: 40,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            order: '0'
                                                                                                                                        },
                                                                                                                                        {
                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                            expression: {
                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                objectType: {
                                                                                                                                                    type: 'CallExpression',
                                                                                                                                                    callee: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'PaperInput',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 94,
                                                                                                                                                                column: 36,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 94,
                                                                                                                                                                column: 46,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    arguments: [],
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 94,
                                                                                                                                                            column: 36,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 94,
                                                                                                                                                            column: 48,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                properties: [
                                                                                                                                                    {
                                                                                                                                                        type: 'Property',
                                                                                                                                                        key: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'name',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 95,
                                                                                                                                                                    column: 40,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 95,
                                                                                                                                                                    column: 44,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        value: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: 'name'
                                                                                                                                                        },
                                                                                                                                                        kind: 'init',
                                                                                                                                                        order: '0'
                                                                                                                                                    },
                                                                                                                                                    {
                                                                                                                                                        type: 'Property',
                                                                                                                                                        key: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'label',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 96,
                                                                                                                                                                    column: 40,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 96,
                                                                                                                                                                    column: 45,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        value: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: 'Name'
                                                                                                                                                        },
                                                                                                                                                        kind: 'init',
                                                                                                                                                        order: '1'
                                                                                                                                                    },
                                                                                                                                                    {
                                                                                                                                                        type: 'Property',
                                                                                                                                                        key: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'required',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 97,
                                                                                                                                                                    column: 40,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 97,
                                                                                                                                                                    column: 48,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        value: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: true
                                                                                                                                                        },
                                                                                                                                                        kind: 'init',
                                                                                                                                                        order: '2'
                                                                                                                                                    }
                                                                                                                                                ]
                                                                                                                                            },
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 94,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 98,
                                                                                                                                                    column: 40,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            order: '1'
                                                                                                                                        },
                                                                                                                                        {
                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                            expression: {
                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                objectType: {
                                                                                                                                                    type: 'CallExpression',
                                                                                                                                                    callee: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'GoldEmailInput',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 98,
                                                                                                                                                                column: 36,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 98,
                                                                                                                                                                column: 50,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    arguments: [],
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 98,
                                                                                                                                                            column: 36,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 98,
                                                                                                                                                            column: 52,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                properties: [
                                                                                                                                                    {
                                                                                                                                                        type: 'Property',
                                                                                                                                                        key: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'name',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 99,
                                                                                                                                                                    column: 40,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 99,
                                                                                                                                                                    column: 44,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        value: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: 'email'
                                                                                                                                                        },
                                                                                                                                                        kind: 'init',
                                                                                                                                                        order: '0'
                                                                                                                                                    },
                                                                                                                                                    {
                                                                                                                                                        type: 'Property',
                                                                                                                                                        key: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'label',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 100,
                                                                                                                                                                    column: 40,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 100,
                                                                                                                                                                    column: 45,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        value: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: 'Email'
                                                                                                                                                        },
                                                                                                                                                        kind: 'init',
                                                                                                                                                        order: '1'
                                                                                                                                                    },
                                                                                                                                                    {
                                                                                                                                                        type: 'Property',
                                                                                                                                                        key: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'required',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 101,
                                                                                                                                                                    column: 40,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 101,
                                                                                                                                                                    column: 48,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        value: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: true
                                                                                                                                                        },
                                                                                                                                                        kind: 'init',
                                                                                                                                                        order: '2'
                                                                                                                                                    }
                                                                                                                                                ]
                                                                                                                                            },
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 98,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 102,
                                                                                                                                                    column: 40,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            order: '2'
                                                                                                                                        },
                                                                                                                                        {
                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                            expression: {
                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                objectType: {
                                                                                                                                                    type: 'CallExpression',
                                                                                                                                                    callee: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'PaperInput',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 102,
                                                                                                                                                                column: 36,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 102,
                                                                                                                                                                column: 46,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    arguments: [],
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 102,
                                                                                                                                                            column: 36,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 102,
                                                                                                                                                            column: 48,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                properties: [
                                                                                                                                                    {
                                                                                                                                                        type: 'Property',
                                                                                                                                                        key: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'name',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 103,
                                                                                                                                                                    column: 40,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 103,
                                                                                                                                                                    column: 44,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        value: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: 'password'
                                                                                                                                                        },
                                                                                                                                                        kind: 'init',
                                                                                                                                                        order: '0'
                                                                                                                                                    },
                                                                                                                                                    {
                                                                                                                                                        type: 'Property',
                                                                                                                                                        key: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'label',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 104,
                                                                                                                                                                    column: 40,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 104,
                                                                                                                                                                    column: 45,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        value: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: 'Password'
                                                                                                                                                        },
                                                                                                                                                        kind: 'init',
                                                                                                                                                        order: '1'
                                                                                                                                                    },
                                                                                                                                                    {
                                                                                                                                                        type: 'Property',
                                                                                                                                                        key: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'type',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 105,
                                                                                                                                                                    column: 40,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 105,
                                                                                                                                                                    column: 44,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        value: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: 'password'
                                                                                                                                                        },
                                                                                                                                                        kind: 'init',
                                                                                                                                                        order: '2'
                                                                                                                                                    },
                                                                                                                                                    {
                                                                                                                                                        type: 'Property',
                                                                                                                                                        key: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'minlength',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 106,
                                                                                                                                                                    column: 40,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 106,
                                                                                                                                                                    column: 49,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        value: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: 8
                                                                                                                                                        },
                                                                                                                                                        kind: 'init',
                                                                                                                                                        order: '3'
                                                                                                                                                    },
                                                                                                                                                    {
                                                                                                                                                        type: 'Property',
                                                                                                                                                        key: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'required',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 107,
                                                                                                                                                                    column: 40,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 107,
                                                                                                                                                                    column: 48,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        value: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: true
                                                                                                                                                        },
                                                                                                                                                        kind: 'init',
                                                                                                                                                        order: '4'
                                                                                                                                                    }
                                                                                                                                                ]
                                                                                                                                            },
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 102,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 108,
                                                                                                                                                    column: 40,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            order: '3'
                                                                                                                                        }
                                                                                                                                    ]
                                                                                                                                },
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 91,
                                                                                                                                        column: 32,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 108,
                                                                                                                                        column: 36,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                order: '1'
                                                                                                                            },
                                                                                                                            {
                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                expression: {
                                                                                                                                    type: 'CallExpression',
                                                                                                                                    callee: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'Div',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 108,
                                                                                                                                                column: 32,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 108,
                                                                                                                                                column: 35,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    arguments: [{
                                                                                                                                            type: 'ObjectExpression',
                                                                                                                                            properties: [{
                                                                                                                                                    type: 'Property',
                                                                                                                                                    key: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'class',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 108,
                                                                                                                                                                column: 37,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 108,
                                                                                                                                                                column: 42,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    value: {
                                                                                                                                                        type: 'Literal',
                                                                                                                                                        value: 'flex'
                                                                                                                                                    },
                                                                                                                                                    kind: 'init',
                                                                                                                                                    order: '0'
                                                                                                                                                }]
                                                                                                                                        }],
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 108,
                                                                                                                                            column: 32,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 108,
                                                                                                                                            column: 51,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 108,
                                                                                                                                        column: 32,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 108,
                                                                                                                                        column: 51,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                order: '2'
                                                                                                                            },
                                                                                                                            {
                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                expression: {
                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                    objectType: {
                                                                                                                                        type: 'CallExpression',
                                                                                                                                        callee: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'Footer',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 109,
                                                                                                                                                    column: 32,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 109,
                                                                                                                                                    column: 38,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        arguments: [{
                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                properties: [{
                                                                                                                                                        type: 'Property',
                                                                                                                                                        key: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'class',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 109,
                                                                                                                                                                    column: 40,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 109,
                                                                                                                                                                    column: 45,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        value: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: 'layout horizontal fixed'
                                                                                                                                                        },
                                                                                                                                                        kind: 'init',
                                                                                                                                                        order: '0'
                                                                                                                                                    }]
                                                                                                                                            }],
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 109,
                                                                                                                                                column: 32,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 109,
                                                                                                                                                column: 73,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    properties: [
                                                                                                                                        {
                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                            expression: {
                                                                                                                                                type: 'CallExpression',
                                                                                                                                                callee: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'Div',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 110,
                                                                                                                                                            column: 36,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 110,
                                                                                                                                                            column: 39,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                arguments: [{
                                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                                        properties: [{
                                                                                                                                                                type: 'Property',
                                                                                                                                                                key: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'class',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 110,
                                                                                                                                                                            column: 41,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 110,
                                                                                                                                                                            column: 46,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                value: {
                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                    value: 'flex'
                                                                                                                                                                },
                                                                                                                                                                kind: 'init',
                                                                                                                                                                order: '0'
                                                                                                                                                            }]
                                                                                                                                                    }],
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 110,
                                                                                                                                                        column: 36,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 110,
                                                                                                                                                        column: 55,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 110,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 110,
                                                                                                                                                    column: 55,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            order: '0'
                                                                                                                                        },
                                                                                                                                        {
                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                            expression: {
                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                objectType: {
                                                                                                                                                    type: 'CallExpression',
                                                                                                                                                    callee: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'SubmitButton',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 111,
                                                                                                                                                                column: 36,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 111,
                                                                                                                                                                column: 48,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    arguments: [],
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 111,
                                                                                                                                                            column: 36,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 111,
                                                                                                                                                            column: 50,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                properties: [{
                                                                                                                                                        type: 'ExpressionStatement',
                                                                                                                                                        expression: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: 'Signup'
                                                                                                                                                        },
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 112,
                                                                                                                                                                column: 40,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 112,
                                                                                                                                                                column: 48,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        order: '0'
                                                                                                                                                    }]
                                                                                                                                            },
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 111,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 113,
                                                                                                                                                    column: 40,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            order: '1'
                                                                                                                                        }
                                                                                                                                    ]
                                                                                                                                },
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 109,
                                                                                                                                        column: 32,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 113,
                                                                                                                                        column: 36,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                order: '3'
                                                                                                                            }
                                                                                                                        ]
                                                                                                                    },
                                                                                                                    order: '0'
                                                                                                                }],
                                                                                                            bound: false,
                                                                                                            name: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'content',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 87,
                                                                                                                        column: 24,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 87,
                                                                                                                        column: 31,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            scope: {
                                                                                                                type: 'Identifier',
                                                                                                                name: '_ps2'
                                                                                                            }
                                                                                                        }, {
                                                                                                            this: this,
                                                                                                            _ps2: _ps2,
                                                                                                            _ref3: _ref3,
                                                                                                            _ref: _ref,
                                                                                                            _ref2: _ref2,
                                                                                                            style: style,
                                                                                                            Dialog: Dialog,
                                                                                                            TabContent: TabContent,
                                                                                                            GlassForm: GlassForm,
                                                                                                            SubmitButton: SubmitButton,
                                                                                                            Checkbox: Checkbox
                                                                                                        }, _ps2);
                                                                                                    });
                                                                                                }
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '2'
                                                                                        }
                                                                                    ]
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 84,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 113,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                    }
                                                                                },
                                                                                order: '1'
                                                                            },
                                                                            {
                                                                                type: 'ExpressionStatement',
                                                                                expression: {
                                                                                    type: 'ObjectExpression',
                                                                                    objectType: {
                                                                                        type: 'ObjectExpression',
                                                                                        properties: []
                                                                                    },
                                                                                    properties: [
                                                                                        {
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'name',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 114,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 114,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'Literal',
                                                                                                value: 'forgot'
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '0'
                                                                                        },
                                                                                        {
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'tab',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 115,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 115,
                                                                                                        column: 27,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'Function',
                                                                                                context: false,
                                                                                                value: function () {
                                                                                                    return 'Forgot';
                                                                                                }
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '1'
                                                                                        },
                                                                                        {
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'content',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 116,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 116,
                                                                                                        column: 31,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'Function',
                                                                                                context: true,
                                                                                                value: function (_ps3) {
                                                                                                    return ion.template(function () {
                                                                                                        return ion.createRuntime({
                                                                                                            type: 'Template',
                                                                                                            id: null,
                                                                                                            body: [{
                                                                                                                    type: 'ReturnStatement',
                                                                                                                    argument: {
                                                                                                                        type: 'ObjectExpression',
                                                                                                                        objectType: {
                                                                                                                            type: 'CallExpression',
                                                                                                                            callee: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'GlassForm',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 117,
                                                                                                                                        column: 35,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 117,
                                                                                                                                        column: 44,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            arguments: [{
                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                    properties: [{
                                                                                                                                            type: 'Property',
                                                                                                                                            key: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'class',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 117,
                                                                                                                                                        column: 46,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 117,
                                                                                                                                                        column: 51,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            value: {
                                                                                                                                                type: 'Literal',
                                                                                                                                                value: 'layout vertical flex'
                                                                                                                                            },
                                                                                                                                            kind: 'init',
                                                                                                                                            order: '0'
                                                                                                                                        }]
                                                                                                                                }],
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 117,
                                                                                                                                    column: 35,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 117,
                                                                                                                                    column: 76,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        properties: [
                                                                                                                            {
                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                expression: {
                                                                                                                                    type: 'Function',
                                                                                                                                    context: false,
                                                                                                                                    value: function complete() {
                                                                                                                                        model.changePassword(this.values);
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 118,
                                                                                                                                        column: 32,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 120,
                                                                                                                                        column: 36,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                order: '0'
                                                                                                                            },
                                                                                                                            {
                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                expression: {
                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                    objectType: {
                                                                                                                                        type: 'CallExpression',
                                                                                                                                        callee: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'Section',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 120,
                                                                                                                                                    column: 32,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 120,
                                                                                                                                                    column: 39,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        arguments: [],
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 120,
                                                                                                                                                column: 32,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 120,
                                                                                                                                                column: 41,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    properties: [
                                                                                                                                        {
                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                            expression: {
                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                objectType: {
                                                                                                                                                    type: 'CallExpression',
                                                                                                                                                    callee: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'P',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 121,
                                                                                                                                                                column: 36,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 121,
                                                                                                                                                                column: 37,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    arguments: [],
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 121,
                                                                                                                                                            column: 36,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 121,
                                                                                                                                                            column: 39,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                properties: [{
                                                                                                                                                        type: 'ExpressionStatement',
                                                                                                                                                        expression: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: 'Enter your email and choose a new password.'
                                                                                                                                                        },
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 122,
                                                                                                                                                                column: 40,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 122,
                                                                                                                                                                column: 85,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        order: '0'
                                                                                                                                                    }]
                                                                                                                                            },
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 121,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 123,
                                                                                                                                                    column: 40,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            order: '0'
                                                                                                                                        },
                                                                                                                                        {
                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                            expression: {
                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                objectType: {
                                                                                                                                                    type: 'CallExpression',
                                                                                                                                                    callee: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'GoldEmailInput',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 123,
                                                                                                                                                                column: 36,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 123,
                                                                                                                                                                column: 50,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    arguments: [],
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 123,
                                                                                                                                                            column: 36,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 123,
                                                                                                                                                            column: 52,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                properties: [
                                                                                                                                                    {
                                                                                                                                                        type: 'Property',
                                                                                                                                                        key: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'name',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 124,
                                                                                                                                                                    column: 40,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 124,
                                                                                                                                                                    column: 44,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        value: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: 'email'
                                                                                                                                                        },
                                                                                                                                                        kind: 'init',
                                                                                                                                                        order: '0'
                                                                                                                                                    },
                                                                                                                                                    {
                                                                                                                                                        type: 'Property',
                                                                                                                                                        key: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'label',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 125,
                                                                                                                                                                    column: 40,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 125,
                                                                                                                                                                    column: 45,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        value: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: 'Email'
                                                                                                                                                        },
                                                                                                                                                        kind: 'init',
                                                                                                                                                        order: '1'
                                                                                                                                                    },
                                                                                                                                                    {
                                                                                                                                                        type: 'Property',
                                                                                                                                                        key: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'required',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 126,
                                                                                                                                                                    column: 40,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 126,
                                                                                                                                                                    column: 48,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        value: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: true
                                                                                                                                                        },
                                                                                                                                                        kind: 'init',
                                                                                                                                                        order: '2'
                                                                                                                                                    }
                                                                                                                                                ]
                                                                                                                                            },
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 123,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 127,
                                                                                                                                                    column: 40,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            order: '1'
                                                                                                                                        },
                                                                                                                                        {
                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                            expression: {
                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                objectType: {
                                                                                                                                                    type: 'CallExpression',
                                                                                                                                                    callee: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'PaperInput',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 127,
                                                                                                                                                                column: 36,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 127,
                                                                                                                                                                column: 46,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    arguments: [],
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 127,
                                                                                                                                                            column: 36,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 127,
                                                                                                                                                            column: 48,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                properties: [
                                                                                                                                                    {
                                                                                                                                                        type: 'Property',
                                                                                                                                                        key: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'name',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 128,
                                                                                                                                                                    column: 40,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 128,
                                                                                                                                                                    column: 44,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        value: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: 'password'
                                                                                                                                                        },
                                                                                                                                                        kind: 'init',
                                                                                                                                                        order: '0'
                                                                                                                                                    },
                                                                                                                                                    {
                                                                                                                                                        type: 'Property',
                                                                                                                                                        key: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'label',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 129,
                                                                                                                                                                    column: 40,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 129,
                                                                                                                                                                    column: 45,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        value: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: 'Password'
                                                                                                                                                        },
                                                                                                                                                        kind: 'init',
                                                                                                                                                        order: '1'
                                                                                                                                                    },
                                                                                                                                                    {
                                                                                                                                                        type: 'Property',
                                                                                                                                                        key: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'type',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 130,
                                                                                                                                                                    column: 40,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 130,
                                                                                                                                                                    column: 44,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        value: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: 'password'
                                                                                                                                                        },
                                                                                                                                                        kind: 'init',
                                                                                                                                                        order: '2'
                                                                                                                                                    },
                                                                                                                                                    {
                                                                                                                                                        type: 'Property',
                                                                                                                                                        key: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'minlength',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 131,
                                                                                                                                                                    column: 40,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 131,
                                                                                                                                                                    column: 49,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        value: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: 8
                                                                                                                                                        },
                                                                                                                                                        kind: 'init',
                                                                                                                                                        order: '3'
                                                                                                                                                    },
                                                                                                                                                    {
                                                                                                                                                        type: 'Property',
                                                                                                                                                        key: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'required',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 132,
                                                                                                                                                                    column: 40,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 132,
                                                                                                                                                                    column: 48,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        value: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: true
                                                                                                                                                        },
                                                                                                                                                        kind: 'init',
                                                                                                                                                        order: '4'
                                                                                                                                                    }
                                                                                                                                                ]
                                                                                                                                            },
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 127,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 133,
                                                                                                                                                    column: 40,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            order: '2'
                                                                                                                                        }
                                                                                                                                    ]
                                                                                                                                },
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 120,
                                                                                                                                        column: 32,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 133,
                                                                                                                                        column: 36,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                order: '1'
                                                                                                                            },
                                                                                                                            {
                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                expression: {
                                                                                                                                    type: 'CallExpression',
                                                                                                                                    callee: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'Div',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 133,
                                                                                                                                                column: 32,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 133,
                                                                                                                                                column: 35,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    arguments: [{
                                                                                                                                            type: 'ObjectExpression',
                                                                                                                                            properties: [{
                                                                                                                                                    type: 'Property',
                                                                                                                                                    key: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'class',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 133,
                                                                                                                                                                column: 37,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 133,
                                                                                                                                                                column: 42,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    value: {
                                                                                                                                                        type: 'Literal',
                                                                                                                                                        value: 'flex'
                                                                                                                                                    },
                                                                                                                                                    kind: 'init',
                                                                                                                                                    order: '0'
                                                                                                                                                }]
                                                                                                                                        }],
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 133,
                                                                                                                                            column: 32,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 133,
                                                                                                                                            column: 51,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 133,
                                                                                                                                        column: 32,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 133,
                                                                                                                                        column: 51,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                order: '2'
                                                                                                                            },
                                                                                                                            {
                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                expression: {
                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                    objectType: {
                                                                                                                                        type: 'CallExpression',
                                                                                                                                        callee: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'Footer',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 134,
                                                                                                                                                    column: 32,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 134,
                                                                                                                                                    column: 38,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        arguments: [{
                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                properties: [{
                                                                                                                                                        type: 'Property',
                                                                                                                                                        key: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'class',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 134,
                                                                                                                                                                    column: 40,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 134,
                                                                                                                                                                    column: 45,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        value: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: 'layout horizontal fixed'
                                                                                                                                                        },
                                                                                                                                                        kind: 'init',
                                                                                                                                                        order: '0'
                                                                                                                                                    }]
                                                                                                                                            }],
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 134,
                                                                                                                                                column: 32,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 134,
                                                                                                                                                column: 73,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    properties: [
                                                                                                                                        {
                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                            expression: {
                                                                                                                                                type: 'CallExpression',
                                                                                                                                                callee: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'Div',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 135,
                                                                                                                                                            column: 36,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 135,
                                                                                                                                                            column: 39,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                arguments: [{
                                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                                        properties: [{
                                                                                                                                                                type: 'Property',
                                                                                                                                                                key: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'class',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 135,
                                                                                                                                                                            column: 41,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 135,
                                                                                                                                                                            column: 46,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                value: {
                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                    value: 'flex'
                                                                                                                                                                },
                                                                                                                                                                kind: 'init',
                                                                                                                                                                order: '0'
                                                                                                                                                            }]
                                                                                                                                                    }],
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 135,
                                                                                                                                                        column: 36,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 135,
                                                                                                                                                        column: 55,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 135,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 135,
                                                                                                                                                    column: 55,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            order: '0'
                                                                                                                                        },
                                                                                                                                        {
                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                            expression: {
                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                objectType: {
                                                                                                                                                    type: 'CallExpression',
                                                                                                                                                    callee: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'SubmitButton',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 136,
                                                                                                                                                                column: 36,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 136,
                                                                                                                                                                column: 48,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    arguments: [],
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 136,
                                                                                                                                                            column: 36,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 136,
                                                                                                                                                            column: 50,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                properties: [{
                                                                                                                                                        type: 'ExpressionStatement',
                                                                                                                                                        expression: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: 'Change Password'
                                                                                                                                                        },
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 137,
                                                                                                                                                                column: 40,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 137,
                                                                                                                                                                column: 57,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        order: '0'
                                                                                                                                                    }]
                                                                                                                                            },
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 136,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 138,
                                                                                                                                                    column: 40,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            order: '1'
                                                                                                                                        }
                                                                                                                                    ]
                                                                                                                                },
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 134,
                                                                                                                                        column: 32,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 138,
                                                                                                                                        column: 36,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                order: '3'
                                                                                                                            }
                                                                                                                        ]
                                                                                                                    },
                                                                                                                    order: '0'
                                                                                                                }],
                                                                                                            bound: false,
                                                                                                            name: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'content',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 116,
                                                                                                                        column: 24,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 116,
                                                                                                                        column: 31,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            scope: {
                                                                                                                type: 'Identifier',
                                                                                                                name: '_ps3'
                                                                                                            }
                                                                                                        }, {
                                                                                                            this: this,
                                                                                                            _ps3: _ps3,
                                                                                                            _ref3: _ref3,
                                                                                                            _ref: _ref,
                                                                                                            _ref2: _ref2,
                                                                                                            style: style,
                                                                                                            Dialog: Dialog,
                                                                                                            TabContent: TabContent,
                                                                                                            GlassForm: GlassForm,
                                                                                                            SubmitButton: SubmitButton,
                                                                                                            Checkbox: Checkbox
                                                                                                        }, _ps3);
                                                                                                    });
                                                                                                }
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '2'
                                                                                        }
                                                                                    ]
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 113,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 138,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/LoginDialog.ion'
                                                                                    }
                                                                                },
                                                                                order: '2'
                                                                            }
                                                                        ]
                                                                    },
                                                                    kind: 'init',
                                                                    order: '1'
                                                                }
                                                            ]
                                                        }],
                                                    loc: {
                                                        start: {
                                                            line: 26,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/LoginDialog.ion'
                                                        },
                                                        end: {
                                                            line: 138,
                                                            column: 13,
                                                            fixed: true,
                                                            source: 'glass/html/material/LoginDialog.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 26,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/LoginDialog.ion'
                                                    },
                                                    end: {
                                                        line: 138,
                                                        column: 13,
                                                        fixed: true,
                                                        source: 'glass/html/material/LoginDialog.ion'
                                                    }
                                                },
                                                order: '2'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    order: '2'
                                }
                            ]
                        }
                    }],
                kind: 'let',
                order: '4'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'Identifier',
                    name: 'dialog',
                    loc: {
                        start: {
                            line: 139,
                            column: 11,
                            fixed: true,
                            source: 'glass/html/material/LoginDialog.ion'
                        },
                        end: {
                            line: 139,
                            column: 17,
                            fixed: true,
                            source: 'glass/html/material/LoginDialog.ion'
                        }
                    }
                },
                order: '5'
            }
        ],
        bound: false
    }, {
        this: this,
        ion: ion,
        _ref3: _ref3,
        _ref: _ref,
        _ref2: _ref2,
        style: style,
        Dialog: Dialog,
        TabContent: TabContent,
        GlassForm: GlassForm,
        SubmitButton: SubmitButton,
        Checkbox: Checkbox
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/LoginDialog',_glass_html_material_LoginDialog_);
    else
      _glass_html_material_LoginDialog_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_LoginDialog_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_Menu_ = function(module,exports,require){'use strict';
var ion = require('ion'), style = require('../style'), _ref, _ref2;
_ref = require('./');
var Shadow = _ref.Shadow;
var Icon = _ref.Icon;
_ref2 = require('../functions');
var ensureOnScreen = _ref2.ensureOnScreen;
var padding = 4;
style.define(module.id, '.Menu {\n    transform-origin: 0% 0%;\n    position: absolute;\n    padding-top: ' + padding + 'px;\n    padding-bottom: ' + padding + 'px;\n    background: white;\n    border-radius: 2px;\n    max-height: 90%;\n    overflow-y: auto;\n}\n.Menu:focus {\n    outline: none;\n}\n.Menu:not(.open) {\n    visibility: hidden;\n}\n.Menu .row {\n    height: 32px;\n    padding-left: 16px;\n    padding-right: 16px;\n    white-space: nowrap;\n}\n.Menu .row.action.hover {\n    background: rgba(0, 0, 0, ' + style.opacity.divider / 2 + ');\n}\n.Menu .row:focus, .Menu .row.open, .Menu .row.focus {\n    background: rgba(0, 0, 0, ' + style.opacity.divider + ');\n    outline: none;\n}\n.Menu .row > * {\n    margin-left: 5px;\n    margin-right: 5px;\n}\n.Menu .divider {\n    border-bottom: solid 1px black;\n    margin-top: ' + padding + ';\n    margin-bottom: ' + padding + ';\n    opacity: ' + style.opacity.divider + ';\n}\n.Menu .shortcut {\n    opacity: ' + style.opacity.hint + ';\n}');
var isRow = function (element) {
    if (element != null && element.parentElement != null) {
        return element.classList.contains('row') && element.parentElement.classList.contains('Menu');
    } else {
        return false;
    }
};
var getRow = function (element) {
    for (var i = 0; element != null && i < 4; i++) {
        if (isRow(element)) {
            return element;
        }
        element = element.parentElement;
    }
    return null;
};
ion.template(function () {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'touchHandler',
                            loc: {
                                start: {
                                    line: 70,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/Menu.ion'
                                },
                                end: {
                                    line: 70,
                                    column: 20,
                                    fixed: true,
                                    source: 'glass/html/material/Menu.ion'
                                }
                            }
                        },
                        init: {
                            type: 'Function',
                            context: true,
                            value: function (_context) {
                                return function (e) {
                                    var getRow = _context.get('getRow'), ion = _context.get('ion');
                                    var touch = e.changedTouches[0];
                                    var element = document.elementFromPoint(touch.pageX, touch.pageY);
                                    var row = getRow(element);
                                    if (row !== global._lastOverRow) {
                                        global._lastOverRow != null ? global._lastOverRow.dispatchEvent(new CustomEvent('mouseout')) : void 0;
                                        row != null ? row.dispatchEvent(new CustomEvent('mouseover')) : void 0;
                                    }
                                    row != null ? row.dispatchEvent(ion.patch.combine(new CustomEvent('mousemove'), {
                                        movementX: touch.screenX - (global._lastOverRowX != null ? global._lastOverRowX : touch.screenX),
                                        movementY: touch.screenY - (global._lastOverRowY != null ? global._lastOverRowY : touch.screenY)
                                    })) : void 0;
                                    global._lastOverRow = row;
                                    global._lastOverRowX = touch.screenX;
                                    global._lastOverRowY = touch.screenY;
                                };
                            }
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'IfStatement',
                test: {
                    type: 'UnaryExpression',
                    operator: '?',
                    argument: {
                        type: 'MemberExpression',
                        computed: false,
                        object: {
                            type: 'MemberExpression',
                            computed: false,
                            object: {
                                type: 'Identifier',
                                name: 'global',
                                loc: {
                                    start: {
                                        line: 86,
                                        column: 7,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    },
                                    end: {
                                        line: 86,
                                        column: 13,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'document',
                                loc: {
                                    start: {
                                        line: 86,
                                        column: 14,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    },
                                    end: {
                                        line: 86,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 86,
                                    column: 7,
                                    fixed: true,
                                    source: 'glass/html/material/Menu.ion'
                                },
                                end: {
                                    line: 86,
                                    column: 22,
                                    fixed: true,
                                    source: 'glass/html/material/Menu.ion'
                                }
                            }
                        },
                        property: {
                            type: 'Identifier',
                            name: 'body',
                            loc: {
                                start: {
                                    line: 86,
                                    column: 24,
                                    fixed: true,
                                    source: 'glass/html/material/Menu.ion'
                                },
                                end: {
                                    line: 86,
                                    column: 28,
                                    fixed: true,
                                    source: 'glass/html/material/Menu.ion'
                                }
                            }
                        },
                        existential: true,
                        loc: {
                            start: {
                                line: 86,
                                column: 7,
                                fixed: true,
                                source: 'glass/html/material/Menu.ion'
                            },
                            end: {
                                line: 86,
                                column: 28,
                                fixed: true,
                                source: 'glass/html/material/Menu.ion'
                            }
                        }
                    }
                },
                consequent: {
                    type: 'BlockStatement',
                    body: [
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'document',
                                            loc: {
                                                start: {
                                                    line: 87,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                },
                                                end: {
                                                    line: 87,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'body',
                                            loc: {
                                                start: {
                                                    line: 87,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                },
                                                end: {
                                                    line: 87,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 87,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Menu.ion'
                                            },
                                            end: {
                                                line: 87,
                                                column: 21,
                                                fixed: true,
                                                source: 'glass/html/material/Menu.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'addEventListener',
                                        loc: {
                                            start: {
                                                line: 87,
                                                column: 22,
                                                fixed: true,
                                                source: 'glass/html/material/Menu.ion'
                                            },
                                            end: {
                                                line: 87,
                                                column: 38,
                                                fixed: true,
                                                source: 'glass/html/material/Menu.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 87,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/Menu.ion'
                                        },
                                        end: {
                                            line: 87,
                                            column: 38,
                                            fixed: true,
                                            source: 'glass/html/material/Menu.ion'
                                        }
                                    }
                                },
                                arguments: [
                                    {
                                        type: 'Literal',
                                        value: 'touchstart'
                                    },
                                    {
                                        type: 'Identifier',
                                        name: 'touchHandler',
                                        loc: {
                                            start: {
                                                line: 89,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/Menu.ion'
                                            },
                                            end: {
                                                line: 89,
                                                column: 24,
                                                fixed: true,
                                                source: 'glass/html/material/Menu.ion'
                                            }
                                        }
                                    }
                                ],
                                loc: {
                                    start: {
                                        line: 87,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    },
                                    end: {
                                        line: 90,
                                        column: 9,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 87,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/Menu.ion'
                                },
                                end: {
                                    line: 90,
                                    column: 9,
                                    fixed: true,
                                    source: 'glass/html/material/Menu.ion'
                                }
                            },
                            order: '0'
                        },
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'document',
                                            loc: {
                                                start: {
                                                    line: 91,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                },
                                                end: {
                                                    line: 91,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'body',
                                            loc: {
                                                start: {
                                                    line: 91,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                },
                                                end: {
                                                    line: 91,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 91,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Menu.ion'
                                            },
                                            end: {
                                                line: 91,
                                                column: 21,
                                                fixed: true,
                                                source: 'glass/html/material/Menu.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'addEventListener',
                                        loc: {
                                            start: {
                                                line: 91,
                                                column: 22,
                                                fixed: true,
                                                source: 'glass/html/material/Menu.ion'
                                            },
                                            end: {
                                                line: 91,
                                                column: 38,
                                                fixed: true,
                                                source: 'glass/html/material/Menu.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 91,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/Menu.ion'
                                        },
                                        end: {
                                            line: 91,
                                            column: 38,
                                            fixed: true,
                                            source: 'glass/html/material/Menu.ion'
                                        }
                                    }
                                },
                                arguments: [
                                    {
                                        type: 'Literal',
                                        value: 'touchmove'
                                    },
                                    {
                                        type: 'Identifier',
                                        name: 'touchHandler',
                                        loc: {
                                            start: {
                                                line: 93,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/Menu.ion'
                                            },
                                            end: {
                                                line: 93,
                                                column: 24,
                                                fixed: true,
                                                source: 'glass/html/material/Menu.ion'
                                            }
                                        }
                                    }
                                ],
                                loc: {
                                    start: {
                                        line: 91,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    },
                                    end: {
                                        line: 94,
                                        column: 9,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 91,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/Menu.ion'
                                },
                                end: {
                                    line: 94,
                                    column: 9,
                                    fixed: true,
                                    source: 'glass/html/material/Menu.ion'
                                }
                            },
                            order: '1'
                        },
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'document',
                                            loc: {
                                                start: {
                                                    line: 95,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                },
                                                end: {
                                                    line: 95,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'body',
                                            loc: {
                                                start: {
                                                    line: 95,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                },
                                                end: {
                                                    line: 95,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 95,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Menu.ion'
                                            },
                                            end: {
                                                line: 95,
                                                column: 21,
                                                fixed: true,
                                                source: 'glass/html/material/Menu.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'addEventListener',
                                        loc: {
                                            start: {
                                                line: 95,
                                                column: 22,
                                                fixed: true,
                                                source: 'glass/html/material/Menu.ion'
                                            },
                                            end: {
                                                line: 95,
                                                column: 38,
                                                fixed: true,
                                                source: 'glass/html/material/Menu.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 95,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/Menu.ion'
                                        },
                                        end: {
                                            line: 95,
                                            column: 38,
                                            fixed: true,
                                            source: 'glass/html/material/Menu.ion'
                                        }
                                    }
                                },
                                arguments: [
                                    {
                                        type: 'Literal',
                                        value: 'touchend'
                                    },
                                    {
                                        type: 'Function',
                                        context: false,
                                        value: function (e) {
                                            var row = global._lastOverRow;
                                            if (row != null && (row.parentElement != null ? row.parentElement.open : void 0)) {
                                                row.dispatchEvent(new CustomEvent('touchstart'));
                                                row.dispatchEvent(new CustomEvent('touchend'));
                                                row.dispatchEvent(new CustomEvent('mouseout'));
                                                global._lastOverRow = null;
                                            }
                                        }
                                    }
                                ],
                                loc: {
                                    start: {
                                        line: 95,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    },
                                    end: {
                                        line: 104,
                                        column: 9,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 95,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/Menu.ion'
                                },
                                end: {
                                    line: 104,
                                    column: 9,
                                    fixed: true,
                                    source: 'glass/html/material/Menu.ion'
                                }
                            },
                            order: '2'
                        }
                    ]
                },
                alternate: null,
                order: '1'
            }
        ],
        bound: false
    }, {
        this: this,
        ion: ion,
        style: style,
        _ref: _ref,
        _ref2: _ref2,
        Shadow: Shadow,
        Icon: Icon,
        ensureOnScreen: ensureOnScreen,
        padding: padding,
        isRow: isRow,
        getRow: getRow,
        Menu: Menu,
        Space: Space,
        focusNext: focusNext,
        Row: Row,
        Divider: Divider
    }, null);
})().observe();
var Menu = ion.template(function (_ref3, parentMenu) {
        return ion.createRuntime({
            type: 'Template',
            id: null,
            body: [
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'rows',
                                loc: {
                                    start: {
                                        line: 106,
                                        column: 24,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    },
                                    end: {
                                        line: 106,
                                        column: 28,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref3'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'rows',
                                    loc: {
                                        start: {
                                            line: 106,
                                            column: 24,
                                            fixed: true,
                                            source: 'glass/html/material/Menu.ion'
                                        },
                                        end: {
                                            line: 106,
                                            column: 28,
                                            fixed: true,
                                            source: 'glass/html/material/Menu.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '0'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'autofocus',
                                loc: {
                                    start: {
                                        line: 106,
                                        column: 29,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    },
                                    end: {
                                        line: 106,
                                        column: 38,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref3'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'autofocus',
                                    loc: {
                                        start: {
                                            line: 106,
                                            column: 29,
                                            fixed: true,
                                            source: 'glass/html/material/Menu.ion'
                                        },
                                        end: {
                                            line: 106,
                                            column: 38,
                                            fixed: true,
                                            source: 'glass/html/material/Menu.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '1'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'autoclose',
                                loc: {
                                    start: {
                                        line: 106,
                                        column: 39,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    },
                                    end: {
                                        line: 106,
                                        column: 48,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref3'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'autoclose',
                                    loc: {
                                        start: {
                                            line: 106,
                                            column: 39,
                                            fixed: true,
                                            source: 'glass/html/material/Menu.ion'
                                        },
                                        end: {
                                            line: 106,
                                            column: 48,
                                            fixed: true,
                                            source: 'glass/html/material/Menu.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '2'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'menu',
                                loc: {
                                    start: {
                                        line: 107,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    },
                                    end: {
                                        line: 107,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Shadow',
                                    loc: {
                                        start: {
                                            line: 107,
                                            column: 15,
                                            fixed: true,
                                            source: 'glass/html/material/Menu.ion'
                                        },
                                        end: {
                                            line: 107,
                                            column: 21,
                                            fixed: true,
                                            source: 'glass/html/material/Menu.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'tabindex',
                                                    loc: {
                                                        start: {
                                                            line: 107,
                                                            column: 23,
                                                            fixed: true,
                                                            source: 'glass/html/material/Menu.ion'
                                                        },
                                                        end: {
                                                            line: 107,
                                                            column: 31,
                                                            fixed: true,
                                                            source: 'glass/html/material/Menu.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'UnaryExpression',
                                                    operator: '-',
                                                    argument: {
                                                        type: 'Literal',
                                                        value: 1
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    }],
                                loc: {
                                    start: {
                                        line: 107,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    },
                                    end: {
                                        line: 107,
                                        column: 37,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '3'
                },
                {
                    type: 'IfStatement',
                    test: {
                        type: 'BinaryExpression',
                        operator: '!==',
                        left: {
                            type: 'Identifier',
                            name: 'autoclose',
                            loc: {
                                start: {
                                    line: 108,
                                    column: 7,
                                    fixed: true,
                                    source: 'glass/html/material/Menu.ion'
                                },
                                end: {
                                    line: 108,
                                    column: 16,
                                    fixed: true,
                                    source: 'glass/html/material/Menu.ion'
                                }
                            }
                        },
                        right: {
                            type: 'Literal',
                            value: false
                        }
                    },
                    consequent: {
                        type: 'BlockStatement',
                        body: [
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'window',
                                    loc: {
                                        start: {
                                            line: 109,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/Menu.ion'
                                        },
                                        end: {
                                            line: 109,
                                            column: 14,
                                            fixed: true,
                                            source: 'glass/html/material/Menu.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'ObjectExpression',
                                    properties: [{
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'Function',
                                                context: true,
                                                value: function (_context2) {
                                                    return function hashchange(e) {
                                                        var menu = _context2.get('menu');
                                                        menu.close();
                                                    };
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 110,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                },
                                                end: {
                                                    line: 112,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                }
                                            },
                                            order: '0'
                                        }]
                                },
                                kind: 'init',
                                order: '0'
                            },
                            {
                                type: 'ExpressionStatement',
                                expression: {
                                    type: 'ObjectExpression',
                                    objectType: {
                                        type: 'Identifier',
                                        name: 'document',
                                        loc: {
                                            start: {
                                                line: 112,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Menu.ion'
                                            },
                                            end: {
                                                line: 112,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/Menu.ion'
                                            }
                                        }
                                    },
                                    properties: [{
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'body',
                                                loc: {
                                                    start: {
                                                        line: 113,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/Menu.ion'
                                                    },
                                                    end: {
                                                        line: 113,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'glass/html/material/Menu.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'ObjectExpression',
                                                properties: [{
                                                        type: 'IfStatement',
                                                        test: {
                                                            type: 'BinaryExpression',
                                                            operator: '&&',
                                                            left: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'menu',
                                                                    loc: {
                                                                        start: {
                                                                            line: 114,
                                                                            column: 19,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Menu.ion'
                                                                        },
                                                                        end: {
                                                                            line: 114,
                                                                            column: 23,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Menu.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'open',
                                                                    loc: {
                                                                        start: {
                                                                            line: 114,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Menu.ion'
                                                                        },
                                                                        end: {
                                                                            line: 114,
                                                                            column: 28,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Menu.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 114,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Menu.ion'
                                                                    },
                                                                    end: {
                                                                        line: 114,
                                                                        column: 28,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Menu.ion'
                                                                    }
                                                                }
                                                            },
                                                            right: {
                                                                type: 'BinaryExpression',
                                                                operator: '!==',
                                                                left: {
                                                                    type: 'Identifier',
                                                                    name: 'autoclose',
                                                                    loc: {
                                                                        start: {
                                                                            line: 114,
                                                                            column: 33,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Menu.ion'
                                                                        },
                                                                        end: {
                                                                            line: 114,
                                                                            column: 42,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Menu.ion'
                                                                        }
                                                                    }
                                                                },
                                                                right: {
                                                                    type: 'Literal',
                                                                    value: false
                                                                }
                                                            }
                                                        },
                                                        consequent: {
                                                            type: 'BlockStatement',
                                                            body: [
                                                                {
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'Function',
                                                                        context: true,
                                                                        value: function (_context3) {
                                                                            return function mousedown(e) {
                                                                                var menu = _context3.get('menu');
                                                                                if (!menu.isAncestorOrSelf(e.menu)) {
                                                                                    menu.close();
                                                                                }
                                                                            };
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 116,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Menu.ion'
                                                                        },
                                                                        end: {
                                                                            line: 119,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Menu.ion'
                                                                        }
                                                                    },
                                                                    order: '0'
                                                                },
                                                                {
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'Function',
                                                                        context: true,
                                                                        value: function (_context4) {
                                                                            return function touchstart(e) {
                                                                                var menu = _context4.get('menu');
                                                                                if (!menu.isAncestorOrSelf(e.menu)) {
                                                                                    menu.close();
                                                                                }
                                                                            };
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 119,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Menu.ion'
                                                                        },
                                                                        end: {
                                                                            line: 122,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Menu.ion'
                                                                        }
                                                                    },
                                                                    order: '1'
                                                                }
                                                            ]
                                                        },
                                                        alternate: null,
                                                        order: '0'
                                                    }]
                                            },
                                            kind: 'init',
                                            order: '0'
                                        }]
                                },
                                loc: {
                                    start: {
                                        line: 112,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    },
                                    end: {
                                        line: 122,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    }
                                },
                                order: '1'
                            }
                        ]
                    },
                    alternate: null,
                    order: '4'
                },
                {
                    type: 'ReturnStatement',
                    argument: {
                        type: 'CallExpression',
                        callee: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: 'Object'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'defineProperties'
                            }
                        },
                        arguments: [
                            {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'Identifier',
                                    name: 'menu',
                                    loc: {
                                        start: {
                                            line: 122,
                                            column: 11,
                                            fixed: true,
                                            source: 'glass/html/material/Menu.ion'
                                        },
                                        end: {
                                            line: 122,
                                            column: 15,
                                            fixed: true,
                                            source: 'glass/html/material/Menu.ion'
                                        }
                                    }
                                },
                                properties: [
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'autoclose',
                                            loc: {
                                                start: {
                                                    line: 123,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                },
                                                end: {
                                                    line: 123,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Identifier',
                                            name: 'autoclose',
                                            loc: {
                                                start: {
                                                    line: 123,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                },
                                                end: {
                                                    line: 123,
                                                    column: 28,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                }
                                            }
                                        },
                                        kind: 'init',
                                        order: '0'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'parentMenu',
                                            loc: {
                                                start: {
                                                    line: 124,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                },
                                                end: {
                                                    line: 124,
                                                    column: 18,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Identifier',
                                            name: 'parentMenu',
                                            loc: {
                                                start: {
                                                    line: 124,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                },
                                                end: {
                                                    line: 124,
                                                    column: 30,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                }
                                            }
                                        },
                                        kind: 'init',
                                        order: '1'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'isAncestorOrSelf',
                                            loc: {
                                                start: {
                                                    line: 125,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                },
                                                end: {
                                                    line: 125,
                                                    column: 24,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Function',
                                            context: false,
                                            value: function (menu) {
                                                if (this === menu) {
                                                    return true;
                                                }
                                                if (this.parentMenu != null) {
                                                    return this.parentMenu.isAncestorOrSelf(menu);
                                                }
                                                return false;
                                            }
                                        },
                                        kind: 'init',
                                        order: '2'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'depth',
                                            loc: {
                                                start: {
                                                    line: 131,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                },
                                                end: {
                                                    line: 131,
                                                    column: 13,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'BinaryExpression',
                                            operator: '+',
                                            left: {
                                                type: 'ConditionalExpression',
                                                test: {
                                                    type: 'BinaryExpression',
                                                    operator: '!=',
                                                    left: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'parentMenu',
                                                            loc: {
                                                                start: {
                                                                    line: 131,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Menu.ion'
                                                                },
                                                                end: {
                                                                    line: 131,
                                                                    column: 26,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Menu.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'depth',
                                                            loc: {
                                                                start: {
                                                                    line: 131,
                                                                    column: 28,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Menu.ion'
                                                                },
                                                                end: {
                                                                    line: 131,
                                                                    column: 33,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Menu.ion'
                                                                }
                                                            }
                                                        },
                                                        existential: true,
                                                        loc: {
                                                            start: {
                                                                line: 131,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/Menu.ion'
                                                            },
                                                            end: {
                                                                line: 131,
                                                                column: 33,
                                                                fixed: true,
                                                                source: 'glass/html/material/Menu.ion'
                                                            }
                                                        }
                                                    },
                                                    right: {
                                                        type: 'Literal',
                                                        value: null
                                                    }
                                                },
                                                consequent: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'parentMenu',
                                                        loc: {
                                                            start: {
                                                                line: 131,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/Menu.ion'
                                                            },
                                                            end: {
                                                                line: 131,
                                                                column: 26,
                                                                fixed: true,
                                                                source: 'glass/html/material/Menu.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'depth',
                                                        loc: {
                                                            start: {
                                                                line: 131,
                                                                column: 28,
                                                                fixed: true,
                                                                source: 'glass/html/material/Menu.ion'
                                                            },
                                                            end: {
                                                                line: 131,
                                                                column: 33,
                                                                fixed: true,
                                                                source: 'glass/html/material/Menu.ion'
                                                            }
                                                        }
                                                    },
                                                    existential: true,
                                                    loc: {
                                                        start: {
                                                            line: 131,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/Menu.ion'
                                                        },
                                                        end: {
                                                            line: 131,
                                                            column: 33,
                                                            fixed: true,
                                                            source: 'glass/html/material/Menu.ion'
                                                        }
                                                    }
                                                },
                                                alternate: {
                                                    type: 'Literal',
                                                    value: 0
                                                }
                                            },
                                            right: {
                                                type: 'Literal',
                                                value: 1
                                            }
                                        },
                                        kind: 'init',
                                        order: '3'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'level',
                                            loc: {
                                                start: {
                                                    line: 132,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                },
                                                end: {
                                                    line: 132,
                                                    column: 13,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: 1
                                        },
                                        kind: 'init',
                                        order: '4'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'classList',
                                            loc: {
                                                start: {
                                                    line: 133,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                },
                                                end: {
                                                    line: 133,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'ObjectExpression',
                                            properties: [
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'Literal',
                                                        value: 'Menu'
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 134,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Menu.ion'
                                                        },
                                                        end: {
                                                            line: 134,
                                                            column: 18,
                                                            fixed: true,
                                                            source: 'glass/html/material/Menu.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                },
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'Literal',
                                                        value: 'layout'
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 135,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Menu.ion'
                                                        },
                                                        end: {
                                                            line: 135,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'glass/html/material/Menu.ion'
                                                        }
                                                    },
                                                    order: '1'
                                                },
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'Literal',
                                                        value: 'vertical'
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 136,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Menu.ion'
                                                        },
                                                        end: {
                                                            line: 136,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'glass/html/material/Menu.ion'
                                                        }
                                                    },
                                                    order: '2'
                                                }
                                            ]
                                        },
                                        kind: 'init',
                                        order: '5'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'style',
                                            loc: {
                                                start: {
                                                    line: 137,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                },
                                                end: {
                                                    line: 137,
                                                    column: 13,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'ObjectExpression',
                                            properties: [{
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'zIndex',
                                                        loc: {
                                                            start: {
                                                                line: 138,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'glass/html/material/Menu.ion'
                                                            },
                                                            end: {
                                                                line: 138,
                                                                column: 18,
                                                                fixed: true,
                                                                source: 'glass/html/material/Menu.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'BinaryExpression',
                                                        operator: '+',
                                                        left: {
                                                            type: 'Literal',
                                                            value: 10
                                                        },
                                                        right: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'menu',
                                                                loc: {
                                                                    start: {
                                                                        line: 138,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Menu.ion'
                                                                    },
                                                                    end: {
                                                                        line: 138,
                                                                        column: 29,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Menu.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'depth',
                                                                loc: {
                                                                    start: {
                                                                        line: 138,
                                                                        column: 30,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Menu.ion'
                                                                    },
                                                                    end: {
                                                                        line: 138,
                                                                        column: 35,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Menu.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 138,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Menu.ion'
                                                                },
                                                                end: {
                                                                    line: 138,
                                                                    column: 35,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Menu.ion'
                                                                }
                                                            }
                                                        }
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                }]
                                        },
                                        kind: 'init',
                                        order: '6'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'focusRow',
                                            loc: {
                                                start: {
                                                    line: 139,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                },
                                                end: {
                                                    line: 139,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Function',
                                            context: false,
                                            value: function (first) {
                                                if (first == null)
                                                    first = true;
                                                var rows = this.children;
                                                var row = rows[first ? 0 : rows.length - 1];
                                                row != null ? row.focus() : void 0;
                                            }
                                        },
                                        kind: 'init',
                                        order: '7'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'Function',
                                            context: false,
                                            value: function focus(e) {
                                                var page = document.body.getBoundingClientRect();
                                                var rect = this.getBoundingClientRect();
                                                var margin = 0;
                                                if (rect.left < margin) {
                                                    this.style.left = margin;
                                                }
                                                if (rect.top < margin) {
                                                    this.style.top = margin;
                                                }
                                                if (rect.right > page.right) {
                                                    this.style.left = page.right - rect.width - margin;
                                                }
                                                if (rect.bottom > page.bottom) {
                                                    this.style.top = page.bottom - rect.height - margin;
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 143,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Menu.ion'
                                            },
                                            end: {
                                                line: 155,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/Menu.ion'
                                            }
                                        },
                                        order: '8'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'Function',
                                            context: false,
                                            value: function keydown(e) {
                                                if (e.keyCode === 40) {
                                                    this.focusRow(true);
                                                } else if (e.keyCode === 38) {
                                                    this.focusRow(false);
                                                } else if (e.keyCode === 27) {
                                                    this.close(true);
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 155,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Menu.ion'
                                            },
                                            end: {
                                                line: 162,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/Menu.ion'
                                            }
                                        },
                                        order: '9'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'Function',
                                            context: true,
                                            value: function (_context5) {
                                                return function touchstart(e) {
                                                    var menu = _context5.get('menu');
                                                    e.menu = menu;
                                                    e.stopPropagation();
                                                };
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 162,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Menu.ion'
                                            },
                                            end: {
                                                line: 165,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/Menu.ion'
                                            }
                                        },
                                        order: ':'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'show',
                                            loc: {
                                                start: {
                                                    line: 177,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                },
                                                end: {
                                                    line: 177,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Function',
                                            context: true,
                                            value: function (_context6) {
                                                return function (pointOrElement, transform, parent) {
                                                    var ensureOnScreen = _context6.get('ensureOnScreen');
                                                    if (!this.open) {
                                                        this.scrollTop = 0;
                                                        var x, y;
                                                        if (Array.isArray(pointOrElement)) {
                                                            var _ref4 = pointOrElement;
                                                            x = _ref4[0];
                                                            y = _ref4[1];
                                                        } else {
                                                            var rect = pointOrElement.getBoundingClientRect();
                                                            x = rect.left;
                                                            y = rect.bottom;
                                                        }
                                                        var _ref5 = [
                                                                x,
                                                                y
                                                            ];
                                                        var originalX = _ref5[0];
                                                        var originalY = _ref5[1];
                                                        var _ref6 = ensureOnScreen(this, x, y);
                                                        x = _ref6[0];
                                                        y = _ref6[1];
                                                        if (parent != null) {
                                                            var parentRect = parent.getBoundingClientRect();
                                                            if (x < parentRect.right) {
                                                                originalX = parentRect.left;
                                                                this.style.left = x = Math.max(0, parentRect.left - this.offsetWidth);
                                                            }
                                                        }
                                                        this.open = true;
                                                        return [
                                                            x,
                                                            y
                                                        ];
                                                    }
                                                };
                                            }
                                        },
                                        kind: 'init',
                                        order: ';'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'close',
                                            loc: {
                                                start: {
                                                    line: 203,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                },
                                                end: {
                                                    line: 203,
                                                    column: 13,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Function',
                                            context: true,
                                            value: function (_context7) {
                                                return function (closeAncestors) {
                                                    var parentMenu = _context7.get('parentMenu');
                                                    if (this.open) {
                                                        this.open = false;
                                                        if (closeAncestors) {
                                                            parentMenu != null ? parentMenu.close(closeAncestors) : void 0;
                                                        }
                                                        {
                                                            var _ref9 = this.children;
                                                            for (var _i = 0; _i < _ref9.length; _i++) {
                                                                var row = _ref9[_i];
                                                                row.classList.remove('hover');
                                                            }
                                                        }
                                                    }
                                                };
                                            }
                                        },
                                        kind: 'init',
                                        order: '<'
                                    },
                                    {
                                        type: 'IfStatement',
                                        test: {
                                            type: 'UnaryExpression',
                                            operator: '?',
                                            argument: {
                                                type: 'Identifier',
                                                name: 'rows',
                                                loc: {
                                                    start: {
                                                        line: 210,
                                                        column: 11,
                                                        fixed: true,
                                                        source: 'glass/html/material/Menu.ion'
                                                    },
                                                    end: {
                                                        line: 210,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'glass/html/material/Menu.ion'
                                                    }
                                                }
                                            }
                                        },
                                        consequent: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'ForOfStatement',
                                                    left: {
                                                        type: 'VariableDeclaration',
                                                        declarations: [{
                                                                type: 'VariableDeclarator',
                                                                id: {
                                                                    type: 'Identifier',
                                                                    name: 'row',
                                                                    loc: {
                                                                        start: {
                                                                            line: 211,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Menu.ion'
                                                                        },
                                                                        end: {
                                                                            line: 211,
                                                                            column: 19,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Menu.ion'
                                                                        }
                                                                    }
                                                                },
                                                                init: null
                                                            }],
                                                        kind: 'let'
                                                    },
                                                    right: {
                                                        type: 'Identifier',
                                                        name: 'rows',
                                                        loc: {
                                                            start: {
                                                                line: 211,
                                                                column: 23,
                                                                fixed: true,
                                                                source: 'glass/html/material/Menu.ion'
                                                            },
                                                            end: {
                                                                line: 211,
                                                                column: 27,
                                                                fixed: true,
                                                                source: 'glass/html/material/Menu.ion'
                                                            }
                                                        }
                                                    },
                                                    body: {
                                                        type: 'BlockStatement',
                                                        body: [{
                                                                type: 'IfStatement',
                                                                test: {
                                                                    type: 'UnaryExpression',
                                                                    operator: '?',
                                                                    argument: {
                                                                        type: 'Identifier',
                                                                        name: 'row',
                                                                        loc: {
                                                                            start: {
                                                                                line: 212,
                                                                                column: 19,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Menu.ion'
                                                                            },
                                                                            end: {
                                                                                line: 212,
                                                                                column: 22,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Menu.ion'
                                                                            }
                                                                        }
                                                                    }
                                                                },
                                                                consequent: {
                                                                    type: 'BlockStatement',
                                                                    body: [{
                                                                            type: 'IfStatement',
                                                                            test: {
                                                                                type: 'UnaryExpression',
                                                                                operator: '?',
                                                                                argument: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'row',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 213,
                                                                                                column: 23,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Menu.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 213,
                                                                                                column: 26,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Menu.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'nodeType',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 213,
                                                                                                column: 27,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Menu.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 213,
                                                                                                column: 35,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Menu.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 213,
                                                                                            column: 23,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Menu.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 213,
                                                                                            column: 35,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Menu.ion'
                                                                                        }
                                                                                    }
                                                                                }
                                                                            },
                                                                            consequent: {
                                                                                type: 'BlockStatement',
                                                                                body: [{
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'Identifier',
                                                                                            name: 'row',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 214,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Menu.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 214,
                                                                                                    column: 27,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Menu.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 214,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Menu.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 214,
                                                                                                column: 27,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Menu.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            alternate: {
                                                                                type: 'BlockStatement',
                                                                                body: [{
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'CallExpression',
                                                                                            callee: {
                                                                                                type: 'Identifier',
                                                                                                name: 'Row',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 216,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Menu.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 216,
                                                                                                        column: 27,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Menu.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            arguments: [
                                                                                                {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'row',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 216,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/Menu.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 216,
                                                                                                            column: 31,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/Menu.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'menu',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 216,
                                                                                                            column: 33,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/Menu.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 216,
                                                                                                            column: 37,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/Menu.ion'
                                                                                                        }
                                                                                                    }
                                                                                                }
                                                                                            ],
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 216,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Menu.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 216,
                                                                                                    column: 38,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Menu.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 216,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Menu.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 216,
                                                                                                column: 38,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Menu.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                alternate: {
                                                                    type: 'BlockStatement',
                                                                    body: [{
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'CallExpression',
                                                                                callee: {
                                                                                    type: 'Identifier',
                                                                                    name: 'Divider',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 218,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Menu.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 218,
                                                                                            column: 27,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Menu.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                arguments: [],
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 218,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Menu.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 218,
                                                                                        column: 29,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Menu.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 218,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Menu.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 218,
                                                                                    column: 29,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Menu.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    remove: null,
                                                    order: '0'
                                                }]
                                        },
                                        alternate: null,
                                        order: '='
                                    }
                                ]
                            },
                            {
                                type: 'ObjectExpression',
                                properties: [{
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'open',
                                            loc: {
                                                start: {
                                                    line: 165,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                },
                                                end: {
                                                    line: 165,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'ObjectExpression',
                                            properties: [
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'get',
                                                        loc: {
                                                            start: {
                                                                line: 166,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'glass/html/material/Menu.ion'
                                                            },
                                                            end: {
                                                                line: 166,
                                                                column: 15,
                                                                fixed: true,
                                                                source: 'glass/html/material/Menu.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Function',
                                                        context: false,
                                                        value: function () {
                                                            return this.classList.contains('open');
                                                        }
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'set',
                                                        loc: {
                                                            start: {
                                                                line: 167,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'glass/html/material/Menu.ion'
                                                            },
                                                            end: {
                                                                line: 167,
                                                                column: 15,
                                                                fixed: true,
                                                                source: 'glass/html/material/Menu.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Function',
                                                        context: true,
                                                        value: function (_context8) {
                                                            return function (value) {
                                                                var autofocus = _context8.get('autofocus'), ion = _context8.get('ion');
                                                                if (value !== this.open) {
                                                                    if (value) {
                                                                        this.classList.add('open');
                                                                        if (autofocus !== false) {
                                                                            this.focus();
                                                                        }
                                                                    } else {
                                                                        this.classList.remove('open');
                                                                        this.dispatchEvent(new CustomEvent('close'));
                                                                    }
                                                                    ion.sync();
                                                                }
                                                            };
                                                        }
                                                    },
                                                    kind: 'init',
                                                    order: '1'
                                                }
                                            ]
                                        },
                                        kind: 'init',
                                        define: false,
                                        order: '0'
                                    }]
                            }
                        ]
                    },
                    order: '5'
                }
            ],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'Menu',
                loc: {
                    start: {
                        line: 106,
                        column: 6,
                        fixed: true,
                        source: 'glass/html/material/Menu.ion'
                    },
                    end: {
                        line: 106,
                        column: 10,
                        fixed: true,
                        source: 'glass/html/material/Menu.ion'
                    }
                }
            }
        }, {
            this: this,
            ion: ion,
            _ref3: _ref3,
            parentMenu: parentMenu,
            style: style,
            _ref: _ref,
            _ref2: _ref2,
            Shadow: Shadow,
            Icon: Icon,
            ensureOnScreen: ensureOnScreen,
            padding: padding,
            isRow: isRow,
            getRow: getRow,
            Menu: Menu,
            Space: Space,
            focusNext: focusNext,
            Row: Row,
            Divider: Divider
        }, null);
    });
var Space = ion.template(function () {
        return ion.createRuntime({
            type: 'Template',
            id: null,
            body: [{
                    type: 'ReturnStatement',
                    argument: {
                        type: 'CallExpression',
                        callee: {
                            type: 'Identifier',
                            name: 'Icon',
                            loc: {
                                start: {
                                    line: 221,
                                    column: 11,
                                    fixed: true,
                                    source: 'glass/html/material/Menu.ion'
                                },
                                end: {
                                    line: 221,
                                    column: 15,
                                    fixed: true,
                                    source: 'glass/html/material/Menu.ion'
                                }
                            }
                        },
                        arguments: [{
                                type: 'ObjectExpression',
                                properties: [{
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'name',
                                            loc: {
                                                start: {
                                                    line: 221,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                },
                                                end: {
                                                    line: 221,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: 'none'
                                        },
                                        kind: 'init',
                                        order: '0'
                                    }]
                            }],
                        loc: {
                            start: {
                                line: 221,
                                column: 11,
                                fixed: true,
                                source: 'glass/html/material/Menu.ion'
                            },
                            end: {
                                line: 221,
                                column: 30,
                                fixed: true,
                                source: 'glass/html/material/Menu.ion'
                            }
                        }
                    },
                    order: '0'
                }],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'Space',
                loc: {
                    start: {
                        line: 220,
                        column: 4,
                        fixed: true,
                        source: 'glass/html/material/Menu.ion'
                    },
                    end: {
                        line: 220,
                        column: 9,
                        fixed: true,
                        source: 'glass/html/material/Menu.ion'
                    }
                }
            }
        }, {
            this: this,
            ion: ion,
            style: style,
            _ref: _ref,
            _ref2: _ref2,
            Shadow: Shadow,
            Icon: Icon,
            ensureOnScreen: ensureOnScreen,
            padding: padding,
            isRow: isRow,
            getRow: getRow,
            Menu: Menu,
            Space: Space,
            focusNext: focusNext,
            Row: Row,
            Divider: Divider
        }, null);
    });
var focusNext = function (current, nextProperty) {
    var next = current[nextProperty];
    if (next != null) {
        if (next.classList.contains('row')) {
            next.focus();
        } else {
            focusNext(next, nextProperty);
        }
    }
};
var Row = ion.template(function (_ref7, menu) {
        return ion.createRuntime({
            type: 'Template',
            id: null,
            body: [
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'image',
                                loc: {
                                    start: {
                                        line: 231,
                                        column: 21,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    },
                                    end: {
                                        line: 231,
                                        column: 26,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref7'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'image',
                                    loc: {
                                        start: {
                                            line: 231,
                                            column: 21,
                                            fixed: true,
                                            source: 'glass/html/material/Menu.ion'
                                        },
                                        end: {
                                            line: 231,
                                            column: 26,
                                            fixed: true,
                                            source: 'glass/html/material/Menu.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '0'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'icon',
                                loc: {
                                    start: {
                                        line: 231,
                                        column: 27,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    },
                                    end: {
                                        line: 231,
                                        column: 31,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref7'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'icon',
                                    loc: {
                                        start: {
                                            line: 231,
                                            column: 27,
                                            fixed: true,
                                            source: 'glass/html/material/Menu.ion'
                                        },
                                        end: {
                                            line: 231,
                                            column: 31,
                                            fixed: true,
                                            source: 'glass/html/material/Menu.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '1'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'selected',
                                loc: {
                                    start: {
                                        line: 231,
                                        column: 32,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    },
                                    end: {
                                        line: 231,
                                        column: 40,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref7'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'selected',
                                    loc: {
                                        start: {
                                            line: 231,
                                            column: 32,
                                            fixed: true,
                                            source: 'glass/html/material/Menu.ion'
                                        },
                                        end: {
                                            line: 231,
                                            column: 40,
                                            fixed: true,
                                            source: 'glass/html/material/Menu.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '2'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'content',
                                loc: {
                                    start: {
                                        line: 231,
                                        column: 41,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    },
                                    end: {
                                        line: 231,
                                        column: 48,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref7'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'content',
                                    loc: {
                                        start: {
                                            line: 231,
                                            column: 41,
                                            fixed: true,
                                            source: 'glass/html/material/Menu.ion'
                                        },
                                        end: {
                                            line: 231,
                                            column: 48,
                                            fixed: true,
                                            source: 'glass/html/material/Menu.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '3'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'action',
                                loc: {
                                    start: {
                                        line: 231,
                                        column: 49,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    },
                                    end: {
                                        line: 231,
                                        column: 55,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref7'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'action',
                                    loc: {
                                        start: {
                                            line: 231,
                                            column: 49,
                                            fixed: true,
                                            source: 'glass/html/material/Menu.ion'
                                        },
                                        end: {
                                            line: 231,
                                            column: 55,
                                            fixed: true,
                                            source: 'glass/html/material/Menu.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '4'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'submenuInit',
                                loc: {
                                    start: {
                                        line: 231,
                                        column: 64,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    },
                                    end: {
                                        line: 231,
                                        column: 75,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref7'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'submenu',
                                    loc: {
                                        start: {
                                            line: 231,
                                            column: 56,
                                            fixed: true,
                                            source: 'glass/html/material/Menu.ion'
                                        },
                                        end: {
                                            line: 231,
                                            column: 63,
                                            fixed: true,
                                            source: 'glass/html/material/Menu.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '5'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'shortcut',
                                loc: {
                                    start: {
                                        line: 231,
                                        column: 76,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    },
                                    end: {
                                        line: 231,
                                        column: 84,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref7'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'shortcut',
                                    loc: {
                                        start: {
                                            line: 231,
                                            column: 76,
                                            fixed: true,
                                            source: 'glass/html/material/Menu.ion'
                                        },
                                        end: {
                                            line: 231,
                                            column: 84,
                                            fixed: true,
                                            source: 'glass/html/material/Menu.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '6'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'autoclose',
                                loc: {
                                    start: {
                                        line: 231,
                                        column: 85,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    },
                                    end: {
                                        line: 231,
                                        column: 94,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref7'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'autoclose',
                                    loc: {
                                        start: {
                                            line: 231,
                                            column: 85,
                                            fixed: true,
                                            source: 'glass/html/material/Menu.ion'
                                        },
                                        end: {
                                            line: 231,
                                            column: 94,
                                            fixed: true,
                                            source: 'glass/html/material/Menu.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '7'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'focus',
                                loc: {
                                    start: {
                                        line: 231,
                                        column: 95,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    },
                                    end: {
                                        line: 231,
                                        column: 100,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref7'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'focus',
                                    loc: {
                                        start: {
                                            line: 231,
                                            column: 95,
                                            fixed: true,
                                            source: 'glass/html/material/Menu.ion'
                                        },
                                        end: {
                                            line: 231,
                                            column: 100,
                                            fixed: true,
                                            source: 'glass/html/material/Menu.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '8'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'submenu',
                                loc: {
                                    start: {
                                        line: 232,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    },
                                    end: {
                                        line: 232,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'ConditionalExpression',
                                test: {
                                    type: 'Identifier',
                                    name: 'submenuInit',
                                    loc: {
                                        start: {
                                            line: 232,
                                            column: 18,
                                            fixed: true,
                                            source: 'glass/html/material/Menu.ion'
                                        },
                                        end: {
                                            line: 232,
                                            column: 29,
                                            fixed: true,
                                            source: 'glass/html/material/Menu.ion'
                                        }
                                    }
                                },
                                consequent: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'Identifier',
                                        name: 'Menu',
                                        loc: {
                                            start: {
                                                line: 232,
                                                column: 32,
                                                fixed: true,
                                                source: 'glass/html/material/Menu.ion'
                                            },
                                            end: {
                                                line: 232,
                                                column: 36,
                                                fixed: true,
                                                source: 'glass/html/material/Menu.ion'
                                            }
                                        }
                                    },
                                    arguments: [
                                        {
                                            type: 'Identifier',
                                            name: 'submenuInit',
                                            loc: {
                                                start: {
                                                    line: 232,
                                                    column: 37,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                },
                                                end: {
                                                    line: 232,
                                                    column: 48,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                }
                                            }
                                        },
                                        {
                                            type: 'Identifier',
                                            name: 'menu',
                                            loc: {
                                                start: {
                                                    line: 232,
                                                    column: 50,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                },
                                                end: {
                                                    line: 232,
                                                    column: 54,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                }
                                            }
                                        }
                                    ],
                                    loc: {
                                        start: {
                                            line: 232,
                                            column: 32,
                                            fixed: true,
                                            source: 'glass/html/material/Menu.ion'
                                        },
                                        end: {
                                            line: 232,
                                            column: 55,
                                            fixed: true,
                                            source: 'glass/html/material/Menu.ion'
                                        }
                                    }
                                },
                                alternate: {
                                    type: 'UnaryExpression',
                                    operator: 'void',
                                    prefix: true,
                                    argument: {
                                        type: 'Literal',
                                        value: 0
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '9'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'row',
                                loc: {
                                    start: {
                                        line: 233,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    },
                                    end: {
                                        line: 233,
                                        column: 11,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Div',
                                    loc: {
                                        start: {
                                            line: 233,
                                            column: 14,
                                            fixed: true,
                                            source: 'glass/html/material/Menu.ion'
                                        },
                                        end: {
                                            line: 233,
                                            column: 17,
                                            fixed: true,
                                            source: 'glass/html/material/Menu.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'class',
                                                    loc: {
                                                        start: {
                                                            line: 233,
                                                            column: 19,
                                                            fixed: true,
                                                            source: 'glass/html/material/Menu.ion'
                                                        },
                                                        end: {
                                                            line: 233,
                                                            column: 24,
                                                            fixed: true,
                                                            source: 'glass/html/material/Menu.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: 'row layout horizontal center'
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'tabindex',
                                                    loc: {
                                                        start: {
                                                            line: 233,
                                                            column: 57,
                                                            fixed: true,
                                                            source: 'glass/html/material/Menu.ion'
                                                        },
                                                        end: {
                                                            line: 233,
                                                            column: 65,
                                                            fixed: true,
                                                            source: 'glass/html/material/Menu.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'UnaryExpression',
                                                    operator: '-',
                                                    argument: {
                                                        type: 'Literal',
                                                        value: 1
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    }],
                                loc: {
                                    start: {
                                        line: 233,
                                        column: 14,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    },
                                    end: {
                                        line: 233,
                                        column: 71,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: ':'
                },
                {
                    type: 'ExpressionStatement',
                    expression: {
                        type: 'ObjectExpression',
                        objectType: {
                            type: 'Identifier',
                            name: 'menu',
                            loc: {
                                start: {
                                    line: 234,
                                    column: 4,
                                    fixed: true,
                                    source: 'glass/html/material/Menu.ion'
                                },
                                end: {
                                    line: 234,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/Menu.ion'
                                }
                            }
                        },
                        properties: [{
                                type: 'IfStatement',
                                test: {
                                    type: 'Identifier',
                                    name: 'submenu',
                                    loc: {
                                        start: {
                                            line: 235,
                                            column: 11,
                                            fixed: true,
                                            source: 'glass/html/material/Menu.ion'
                                        },
                                        end: {
                                            line: 235,
                                            column: 18,
                                            fixed: true,
                                            source: 'glass/html/material/Menu.ion'
                                        }
                                    }
                                },
                                consequent: {
                                    type: 'BlockStatement',
                                    body: [
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'Function',
                                                context: true,
                                                value: function (_context9) {
                                                    return function close(e) {
                                                        var submenu = _context9.get('submenu');
                                                        submenu.close();
                                                    };
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 236,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                },
                                                end: {
                                                    line: 238,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                }
                                            },
                                            order: '0'
                                        },
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'Function',
                                                context: true,
                                                value: function (_context10) {
                                                    return function show(e) {
                                                        var row = _context10.get('row'), submenu = _context10.get('submenu');
                                                        if (e.row !== row) {
                                                            submenu.close();
                                                        }
                                                    };
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 238,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                },
                                                end: {
                                                    line: 242,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                }
                                            },
                                            order: '1'
                                        }
                                    ]
                                },
                                alternate: null,
                                order: '0'
                            }]
                    },
                    loc: {
                        start: {
                            line: 234,
                            column: 4,
                            fixed: true,
                            source: 'glass/html/material/Menu.ion'
                        },
                        end: {
                            line: 242,
                            column: 8,
                            fixed: true,
                            source: 'glass/html/material/Menu.ion'
                        }
                    },
                    order: ';'
                },
                {
                    type: 'ExpressionStatement',
                    expression: {
                        type: 'ObjectExpression',
                        objectType: {
                            type: 'Identifier',
                            name: 'document',
                            loc: {
                                start: {
                                    line: 242,
                                    column: 4,
                                    fixed: true,
                                    source: 'glass/html/material/Menu.ion'
                                },
                                end: {
                                    line: 242,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/Menu.ion'
                                }
                            }
                        },
                        properties: [{
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'body',
                                    loc: {
                                        start: {
                                            line: 243,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/Menu.ion'
                                        },
                                        end: {
                                            line: 243,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/material/Menu.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'ObjectExpression',
                                    properties: [{
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'Identifier',
                                                name: 'submenu',
                                                loc: {
                                                    start: {
                                                        line: 244,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/Menu.ion'
                                                    },
                                                    end: {
                                                        line: 244,
                                                        column: 19,
                                                        fixed: true,
                                                        source: 'glass/html/material/Menu.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 244,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                },
                                                end: {
                                                    line: 244,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                }
                                            },
                                            order: '0'
                                        }]
                                },
                                kind: 'init',
                                order: '0'
                            }]
                    },
                    loc: {
                        start: {
                            line: 242,
                            column: 4,
                            fixed: true,
                            source: 'glass/html/material/Menu.ion'
                        },
                        end: {
                            line: 245,
                            column: 8,
                            fixed: true,
                            source: 'glass/html/material/Menu.ion'
                        }
                    },
                    order: '<'
                },
                {
                    type: 'ReturnStatement',
                    argument: {
                        type: 'ObjectExpression',
                        objectType: {
                            type: 'Identifier',
                            name: 'row',
                            loc: {
                                start: {
                                    line: 245,
                                    column: 11,
                                    fixed: true,
                                    source: 'glass/html/material/Menu.ion'
                                },
                                end: {
                                    line: 245,
                                    column: 14,
                                    fixed: true,
                                    source: 'glass/html/material/Menu.ion'
                                }
                            }
                        },
                        properties: [
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'classList',
                                    loc: {
                                        start: {
                                            line: 246,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/Menu.ion'
                                        },
                                        end: {
                                            line: 246,
                                            column: 17,
                                            fixed: true,
                                            source: 'glass/html/material/Menu.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'ObjectExpression',
                                    properties: [
                                        {
                                            type: 'IfStatement',
                                            test: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'submenu',
                                                    loc: {
                                                        start: {
                                                            line: 247,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Menu.ion'
                                                        },
                                                        end: {
                                                            line: 247,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'glass/html/material/Menu.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'open',
                                                    loc: {
                                                        start: {
                                                            line: 247,
                                                            column: 24,
                                                            fixed: true,
                                                            source: 'glass/html/material/Menu.ion'
                                                        },
                                                        end: {
                                                            line: 247,
                                                            column: 28,
                                                            fixed: true,
                                                            source: 'glass/html/material/Menu.ion'
                                                        }
                                                    }
                                                },
                                                existential: true,
                                                loc: {
                                                    start: {
                                                        line: 247,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'glass/html/material/Menu.ion'
                                                    },
                                                    end: {
                                                        line: 247,
                                                        column: 28,
                                                        fixed: true,
                                                        source: 'glass/html/material/Menu.ion'
                                                    }
                                                }
                                            },
                                            consequent: {
                                                type: 'BlockStatement',
                                                body: [{
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'Literal',
                                                            value: 'open'
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 248,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/Menu.ion'
                                                            },
                                                            end: {
                                                                line: 248,
                                                                column: 22,
                                                                fixed: true,
                                                                source: 'glass/html/material/Menu.ion'
                                                            }
                                                        },
                                                        order: '0'
                                                    }]
                                            },
                                            alternate: null,
                                            order: '0'
                                        },
                                        {
                                            type: 'IfStatement',
                                            test: {
                                                type: 'Identifier',
                                                name: 'action',
                                                loc: {
                                                    start: {
                                                        line: 249,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'glass/html/material/Menu.ion'
                                                    },
                                                    end: {
                                                        line: 249,
                                                        column: 21,
                                                        fixed: true,
                                                        source: 'glass/html/material/Menu.ion'
                                                    }
                                                }
                                            },
                                            consequent: {
                                                type: 'BlockStatement',
                                                body: [{
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'Literal',
                                                            value: 'action'
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 250,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/Menu.ion'
                                                            },
                                                            end: {
                                                                line: 250,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'glass/html/material/Menu.ion'
                                                            }
                                                        },
                                                        order: '0'
                                                    }]
                                            },
                                            alternate: null,
                                            order: '1'
                                        },
                                        {
                                            type: 'IfStatement',
                                            test: {
                                                type: 'Identifier',
                                                name: 'focus',
                                                loc: {
                                                    start: {
                                                        line: 251,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'glass/html/material/Menu.ion'
                                                    },
                                                    end: {
                                                        line: 251,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'glass/html/material/Menu.ion'
                                                    }
                                                }
                                            },
                                            consequent: {
                                                type: 'BlockStatement',
                                                body: [{
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'Literal',
                                                            value: 'focus'
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 252,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/Menu.ion'
                                                            },
                                                            end: {
                                                                line: 252,
                                                                column: 23,
                                                                fixed: true,
                                                                source: 'glass/html/material/Menu.ion'
                                                            }
                                                        },
                                                        order: '0'
                                                    }]
                                            },
                                            alternate: null,
                                            order: '2'
                                        }
                                    ]
                                },
                                kind: 'init',
                                order: '0'
                            },
                            {
                                type: 'VariableDeclaration',
                                declarations: [{
                                        type: 'VariableDeclarator',
                                        id: {
                                            type: 'Identifier',
                                            name: 'showSubmenu',
                                            loc: {
                                                start: {
                                                    line: 253,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                },
                                                end: {
                                                    line: 253,
                                                    column: 23,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                }
                                            }
                                        },
                                        init: {
                                            type: 'Function',
                                            context: true,
                                            value: function (_context11) {
                                                return function (e) {
                                                    var submenu = _context11.get('submenu'), row = _context11.get('row'), padding = _context11.get('padding'), menu = _context11.get('menu'), ion = _context11.get('ion');
                                                    if (submenu && !submenu.open) {
                                                        var rect = row.getBoundingClientRect();
                                                        var x = rect.right + 1;
                                                        var y = rect.top - padding;
                                                        var _ref8 = submenu.show([
                                                                x,
                                                                y
                                                            ], null, row);
                                                        x = _ref8[0];
                                                        y = _ref8[1];
                                                    }
                                                    menu.dispatchEvent(ion.patch.combine(new CustomEvent('show'), { row: row }));
                                                };
                                            }
                                        }
                                    }],
                                kind: 'let',
                                order: '1'
                            },
                            {
                                type: 'VariableDeclaration',
                                declarations: [{
                                        type: 'VariableDeclarator',
                                        id: {
                                            type: 'Identifier',
                                            name: 'doAction',
                                            loc: {
                                                start: {
                                                    line: 269,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                },
                                                end: {
                                                    line: 269,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                }
                                            }
                                        },
                                        init: {
                                            type: 'Function',
                                            context: true,
                                            value: function (_context12) {
                                                return function (e) {
                                                    var submenu = _context12.get('submenu'), showSubmenu = _context12.get('showSubmenu'), action = _context12.get('action'), autoclose = _context12.get('autoclose'), menu = _context12.get('menu');
                                                    if (submenu) {
                                                        showSubmenu(e);
                                                    } else {
                                                        action(e) != null ? action(e)() : void 0;
                                                        if (autoclose || !(autoclose != null) && menu.autoclose !== false) {
                                                            menu.close(true);
                                                        }
                                                    }
                                                    e.preventDefault();
                                                };
                                            }
                                        }
                                    }],
                                kind: 'let',
                                order: '2'
                            },
                            {
                                type: 'ExpressionStatement',
                                expression: {
                                    type: 'Function',
                                    context: true,
                                    value: function (_context13) {
                                        return function mousemove(e) {
                                            var showSubmenu = _context13.get('showSubmenu');
                                            if (e.movementX != null && e.movementY != null) {
                                                if (Math.abs(e.movementY / 2) > Math.abs(e.movementX)) {
                                                    showSubmenu(e);
                                                }
                                            } else {
                                                showSubmenu(e);
                                            }
                                        };
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 277,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    },
                                    end: {
                                        line: 283,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    }
                                },
                                order: '3'
                            },
                            {
                                type: 'ExpressionStatement',
                                expression: {
                                    type: 'Function',
                                    context: false,
                                    value: function mouseover(e) {
                                        this.classList.add('hover');
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 283,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    },
                                    end: {
                                        line: 285,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    }
                                },
                                order: '4'
                            },
                            {
                                type: 'ExpressionStatement',
                                expression: {
                                    type: 'Function',
                                    context: false,
                                    value: function mouseout(e) {
                                        this.classList.remove('hover');
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 285,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    },
                                    end: {
                                        line: 287,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    }
                                },
                                order: '5'
                            },
                            {
                                type: 'ExpressionStatement',
                                expression: {
                                    type: 'Function',
                                    context: true,
                                    value: function (_context14) {
                                        return function mousedown(e) {
                                            var doAction = _context14.get('doAction');
                                            doAction(e);
                                            e.stopPropagation();
                                        };
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 287,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    },
                                    end: {
                                        line: 290,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    }
                                },
                                order: '6'
                            },
                            {
                                type: 'ExpressionStatement',
                                expression: {
                                    type: 'Function',
                                    context: false,
                                    value: function mouseup(e) {
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 290,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    },
                                    end: {
                                        line: 290,
                                        column: 21,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    }
                                },
                                order: '7'
                            },
                            {
                                type: 'ExpressionStatement',
                                expression: {
                                    type: 'Function',
                                    context: true,
                                    value: function (_context15) {
                                        return function touchstart(e) {
                                            var menu = _context15.get('menu'), showSubmenu = _context15.get('showSubmenu');
                                            e.menu = menu;
                                            showSubmenu(e);
                                        };
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 291,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    },
                                    end: {
                                        line: 295,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    }
                                },
                                order: '8'
                            },
                            {
                                type: 'ExpressionStatement',
                                expression: {
                                    type: 'Function',
                                    context: true,
                                    value: function (_context16) {
                                        return function touchend(e) {
                                            var doAction = _context16.get('doAction');
                                            doAction(e);
                                            e.stopPropagation();
                                        };
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 295,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    },
                                    end: {
                                        line: 298,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    }
                                },
                                order: '9'
                            },
                            {
                                type: 'ExpressionStatement',
                                expression: {
                                    type: 'Function',
                                    context: false,
                                    value: function touchmove(e) {
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 298,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    },
                                    end: {
                                        line: 300,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    }
                                },
                                order: ':'
                            },
                            {
                                type: 'ExpressionStatement',
                                expression: {
                                    type: 'Function',
                                    context: true,
                                    value: function (_context17) {
                                        return function keydown(e) {
                                            var focusNext = _context17.get('focusNext'), doAction = _context17.get('doAction');
                                            if (e.keyCode === 38) {
                                                focusNext(this, 'previousSibling');
                                                e.stopPropagation();
                                            } else if (e.keyCode === 40) {
                                                focusNext(this, 'nextSibling');
                                                e.stopPropagation();
                                            } else if (e.keyCode === 13) {
                                                doAction(e);
                                                e.stopPropagation();
                                            }
                                        };
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 300,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    },
                                    end: {
                                        line: 310,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    }
                                },
                                order: ';'
                            },
                            {
                                type: 'IfStatement',
                                test: {
                                    type: 'BinaryExpression',
                                    operator: '||',
                                    left: {
                                        type: 'BinaryExpression',
                                        operator: '===',
                                        left: {
                                            type: 'UnaryExpression',
                                            operator: 'typeof',
                                            argument: {
                                                type: 'Identifier',
                                                name: 'image',
                                                loc: {
                                                    start: {
                                                        line: 310,
                                                        column: 18,
                                                        fixed: true,
                                                        source: 'glass/html/material/Menu.ion'
                                                    },
                                                    end: {
                                                        line: 310,
                                                        column: 23,
                                                        fixed: true,
                                                        source: 'glass/html/material/Menu.ion'
                                                    }
                                                }
                                            }
                                        },
                                        right: {
                                            type: 'Literal',
                                            value: 'string'
                                        }
                                    },
                                    right: {
                                        type: 'BinaryExpression',
                                        operator: '===',
                                        left: {
                                            type: 'UnaryExpression',
                                            operator: 'typeof',
                                            argument: {
                                                type: 'Identifier',
                                                name: 'icon',
                                                loc: {
                                                    start: {
                                                        line: 310,
                                                        column: 46,
                                                        fixed: true,
                                                        source: 'glass/html/material/Menu.ion'
                                                    },
                                                    end: {
                                                        line: 310,
                                                        column: 50,
                                                        fixed: true,
                                                        source: 'glass/html/material/Menu.ion'
                                                    }
                                                }
                                            }
                                        },
                                        right: {
                                            type: 'Literal',
                                            value: 'string'
                                        }
                                    }
                                },
                                consequent: {
                                    type: 'BlockStatement',
                                    body: [{
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'Icon',
                                                    loc: {
                                                        start: {
                                                            line: 311,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Menu.ion'
                                                        },
                                                        end: {
                                                            line: 311,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/Menu.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [{
                                                        type: 'ObjectExpression',
                                                        properties: [
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'url',
                                                                    loc: {
                                                                        start: {
                                                                            line: 311,
                                                                            column: 18,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Menu.ion'
                                                                        },
                                                                        end: {
                                                                            line: 311,
                                                                            column: 21,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Menu.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Identifier',
                                                                    name: 'image',
                                                                    loc: {
                                                                        start: {
                                                                            line: 311,
                                                                            column: 22,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Menu.ion'
                                                                        },
                                                                        end: {
                                                                            line: 311,
                                                                            column: 27,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Menu.ion'
                                                                        }
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'name',
                                                                    loc: {
                                                                        start: {
                                                                            line: 311,
                                                                            column: 28,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Menu.ion'
                                                                        },
                                                                        end: {
                                                                            line: 311,
                                                                            column: 32,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Menu.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Identifier',
                                                                    name: 'icon',
                                                                    loc: {
                                                                        start: {
                                                                            line: 311,
                                                                            column: 33,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Menu.ion'
                                                                        },
                                                                        end: {
                                                                            line: 311,
                                                                            column: 37,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Menu.ion'
                                                                        }
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '1'
                                                            }
                                                        ]
                                                    }],
                                                loc: {
                                                    start: {
                                                        line: 311,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/Menu.ion'
                                                    },
                                                    end: {
                                                        line: 311,
                                                        column: 39,
                                                        fixed: true,
                                                        source: 'glass/html/material/Menu.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 311,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                },
                                                end: {
                                                    line: 311,
                                                    column: 39,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                }
                                            },
                                            order: '0'
                                        }]
                                },
                                alternate: {
                                    type: 'IfStatement',
                                    test: {
                                        type: 'BinaryExpression',
                                        operator: '||',
                                        left: {
                                            type: 'UnaryExpression',
                                            operator: '?',
                                            argument: {
                                                type: 'Identifier',
                                                name: 'selected',
                                                loc: {
                                                    start: {
                                                        line: 312,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'glass/html/material/Menu.ion'
                                                    },
                                                    end: {
                                                        line: 312,
                                                        column: 24,
                                                        fixed: true,
                                                        source: 'glass/html/material/Menu.ion'
                                                    }
                                                }
                                            }
                                        },
                                        right: {
                                            type: 'BinaryExpression',
                                            operator: '===',
                                            left: {
                                                type: 'Identifier',
                                                name: 'icon',
                                                loc: {
                                                    start: {
                                                        line: 312,
                                                        column: 29,
                                                        fixed: true,
                                                        source: 'glass/html/material/Menu.ion'
                                                    },
                                                    end: {
                                                        line: 312,
                                                        column: 33,
                                                        fixed: true,
                                                        source: 'glass/html/material/Menu.ion'
                                                    }
                                                }
                                            },
                                            right: {
                                                type: 'Literal',
                                                value: null
                                            }
                                        }
                                    },
                                    consequent: {
                                        type: 'BlockStatement',
                                        body: [{
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'Identifier',
                                                        name: 'Icon',
                                                        loc: {
                                                            start: {
                                                                line: 313,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'glass/html/material/Menu.ion'
                                                            },
                                                            end: {
                                                                line: 313,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/Menu.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [{
                                                            type: 'ObjectExpression',
                                                            properties: [
                                                                {
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'name',
                                                                        loc: {
                                                                            start: {
                                                                                line: 313,
                                                                                column: 18,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Menu.ion'
                                                                            },
                                                                            end: {
                                                                                line: 313,
                                                                                column: 22,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Menu.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'ConditionalExpression',
                                                                        test: {
                                                                            type: 'Identifier',
                                                                            name: 'selected',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 313,
                                                                                    column: 23,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Menu.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 313,
                                                                                    column: 31,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Menu.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        consequent: {
                                                                            type: 'Literal',
                                                                            value: 'done'
                                                                        },
                                                                        alternate: {
                                                                            type: 'Literal',
                                                                            value: 'none'
                                                                        }
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                },
                                                                {
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'color',
                                                                        loc: {
                                                                            start: {
                                                                                line: 313,
                                                                                column: 51,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Menu.ion'
                                                                            },
                                                                            end: {
                                                                                line: 313,
                                                                                column: 56,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Menu.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Literal',
                                                                        value: 'green'
                                                                    },
                                                                    kind: 'init',
                                                                    order: '1'
                                                                }
                                                            ]
                                                        }],
                                                    loc: {
                                                        start: {
                                                            line: 313,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Menu.ion'
                                                        },
                                                        end: {
                                                            line: 313,
                                                            column: 66,
                                                            fixed: true,
                                                            source: 'glass/html/material/Menu.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 313,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/Menu.ion'
                                                    },
                                                    end: {
                                                        line: 313,
                                                        column: 66,
                                                        fixed: true,
                                                        source: 'glass/html/material/Menu.ion'
                                                    }
                                                },
                                                order: '0'
                                            }]
                                    },
                                    alternate: null
                                },
                                order: '<'
                            },
                            {
                                type: 'ExpressionStatement',
                                expression: {
                                    type: 'ObjectExpression',
                                    objectType: {
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'Identifier',
                                            name: 'Span',
                                            loc: {
                                                start: {
                                                    line: 315,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                },
                                                end: {
                                                    line: 315,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                }
                                            }
                                        },
                                        arguments: [{
                                                type: 'ObjectExpression',
                                                properties: [{
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'class',
                                                            loc: {
                                                                start: {
                                                                    line: 315,
                                                                    column: 14,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Menu.ion'
                                                                },
                                                                end: {
                                                                    line: 315,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Menu.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Literal',
                                                            value: 'flex'
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    }]
                                            }],
                                        loc: {
                                            start: {
                                                line: 315,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Menu.ion'
                                            },
                                            end: {
                                                line: 315,
                                                column: 28,
                                                fixed: true,
                                                source: 'glass/html/material/Menu.ion'
                                            }
                                        }
                                    },
                                    properties: [{
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'Identifier',
                                                name: 'content',
                                                loc: {
                                                    start: {
                                                        line: 316,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/Menu.ion'
                                                    },
                                                    end: {
                                                        line: 316,
                                                        column: 19,
                                                        fixed: true,
                                                        source: 'glass/html/material/Menu.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 316,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                },
                                                end: {
                                                    line: 316,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                }
                                            },
                                            order: '0'
                                        }]
                                },
                                loc: {
                                    start: {
                                        line: 315,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    },
                                    end: {
                                        line: 318,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/Menu.ion'
                                    }
                                },
                                order: '='
                            },
                            {
                                type: 'IfStatement',
                                test: {
                                    type: 'UnaryExpression',
                                    operator: '?',
                                    argument: {
                                        type: 'Identifier',
                                        name: 'submenu',
                                        loc: {
                                            start: {
                                                line: 318,
                                                column: 11,
                                                fixed: true,
                                                source: 'glass/html/material/Menu.ion'
                                            },
                                            end: {
                                                line: 318,
                                                column: 18,
                                                fixed: true,
                                                source: 'glass/html/material/Menu.ion'
                                            }
                                        }
                                    }
                                },
                                consequent: {
                                    type: 'BlockStatement',
                                    body: [{
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'ObjectExpression',
                                                objectType: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'Identifier',
                                                        name: 'Icon',
                                                        loc: {
                                                            start: {
                                                                line: 319,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'glass/html/material/Menu.ion'
                                                            },
                                                            end: {
                                                                line: 319,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/Menu.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [{
                                                            type: 'ObjectExpression',
                                                            properties: [
                                                                {
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'name',
                                                                        loc: {
                                                                            start: {
                                                                                line: 319,
                                                                                column: 18,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Menu.ion'
                                                                            },
                                                                            end: {
                                                                                line: 319,
                                                                                column: 22,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Menu.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Literal',
                                                                        value: 'play arrow'
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                },
                                                                {
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'size',
                                                                        loc: {
                                                                            start: {
                                                                                line: 319,
                                                                                column: 36,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Menu.ion'
                                                                            },
                                                                            end: {
                                                                                line: 319,
                                                                                column: 40,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Menu.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Literal',
                                                                        value: 14
                                                                    },
                                                                    kind: 'init',
                                                                    order: '1'
                                                                }
                                                            ]
                                                        }],
                                                    loc: {
                                                        start: {
                                                            line: 319,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Menu.ion'
                                                        },
                                                        end: {
                                                            line: 319,
                                                            column: 45,
                                                            fixed: true,
                                                            source: 'glass/html/material/Menu.ion'
                                                        }
                                                    }
                                                },
                                                properties: [{
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'style',
                                                            loc: {
                                                                start: {
                                                                    line: 320,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Menu.ion'
                                                                },
                                                                end: {
                                                                    line: 320,
                                                                    column: 21,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Menu.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'ObjectExpression',
                                                            properties: [{
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'opacity',
                                                                        loc: {
                                                                            start: {
                                                                                line: 321,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Menu.ion'
                                                                            },
                                                                            end: {
                                                                                line: 321,
                                                                                column: 27,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Menu.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'style',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 321,
                                                                                        column: 29,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Menu.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 321,
                                                                                        column: 34,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Menu.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'opacity',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 321,
                                                                                        column: 35,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Menu.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 321,
                                                                                        column: 42,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Menu.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 321,
                                                                                    column: 29,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Menu.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 321,
                                                                                    column: 42,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Menu.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'secondary',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 321,
                                                                                    column: 43,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Menu.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 321,
                                                                                    column: 52,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Menu.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 321,
                                                                                column: 29,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Menu.ion'
                                                                            },
                                                                            end: {
                                                                                line: 321,
                                                                                column: 52,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Menu.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                }]
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    }]
                                            },
                                            loc: {
                                                start: {
                                                    line: 319,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                },
                                                end: {
                                                    line: 322,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                }
                                            },
                                            order: '0'
                                        }]
                                },
                                alternate: {
                                    type: 'IfStatement',
                                    test: {
                                        type: 'UnaryExpression',
                                        operator: '?',
                                        argument: {
                                            type: 'Identifier',
                                            name: 'shortcut',
                                            loc: {
                                                start: {
                                                    line: 322,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                },
                                                end: {
                                                    line: 322,
                                                    column: 24,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                }
                                            }
                                        }
                                    },
                                    consequent: {
                                        type: 'BlockStatement',
                                        body: [{
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'ObjectExpression',
                                                    objectType: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'Identifier',
                                                            name: 'Span',
                                                            loc: {
                                                                start: {
                                                                    line: 323,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Menu.ion'
                                                                },
                                                                end: {
                                                                    line: 323,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Menu.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [{
                                                                type: 'ObjectExpression',
                                                                properties: [{
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'class',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 323,
                                                                                    column: 18,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Menu.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 323,
                                                                                    column: 23,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Menu.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Literal',
                                                                            value: 'shortcut'
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    }]
                                                            }],
                                                        loc: {
                                                            start: {
                                                                line: 323,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'glass/html/material/Menu.ion'
                                                            },
                                                            end: {
                                                                line: 323,
                                                                column: 36,
                                                                fixed: true,
                                                                source: 'glass/html/material/Menu.ion'
                                                            }
                                                        }
                                                    },
                                                    properties: [{
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'Identifier',
                                                                name: 'shortcut',
                                                                loc: {
                                                                    start: {
                                                                        line: 324,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Menu.ion'
                                                                    },
                                                                    end: {
                                                                        line: 324,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Menu.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 324,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Menu.ion'
                                                                },
                                                                end: {
                                                                    line: 324,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Menu.ion'
                                                                }
                                                            },
                                                            order: '0'
                                                        }]
                                                },
                                                loc: {
                                                    start: {
                                                        line: 323,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/Menu.ion'
                                                    },
                                                    end: {
                                                        line: 326,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'glass/html/material/Menu.ion'
                                                    }
                                                },
                                                order: '0'
                                            }]
                                    },
                                    alternate: null
                                },
                                order: '>'
                            }
                        ]
                    },
                    order: '='
                }
            ],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'Row',
                loc: {
                    start: {
                        line: 231,
                        column: 4,
                        fixed: true,
                        source: 'glass/html/material/Menu.ion'
                    },
                    end: {
                        line: 231,
                        column: 7,
                        fixed: true,
                        source: 'glass/html/material/Menu.ion'
                    }
                }
            }
        }, {
            this: this,
            ion: ion,
            _ref7: _ref7,
            menu: menu,
            style: style,
            _ref: _ref,
            _ref2: _ref2,
            Shadow: Shadow,
            Icon: Icon,
            ensureOnScreen: ensureOnScreen,
            padding: padding,
            isRow: isRow,
            getRow: getRow,
            Menu: Menu,
            Space: Space,
            focusNext: focusNext,
            Row: Row,
            Divider: Divider
        }, null);
    });
var Divider = ion.template(function () {
        return ion.createRuntime({
            type: 'Template',
            id: null,
            body: [{
                    type: 'ReturnStatement',
                    argument: {
                        type: 'CallExpression',
                        callee: {
                            type: 'Identifier',
                            name: 'Div',
                            loc: {
                                start: {
                                    line: 326,
                                    column: 29,
                                    fixed: true,
                                    source: 'glass/html/material/Menu.ion'
                                },
                                end: {
                                    line: 326,
                                    column: 32,
                                    fixed: true,
                                    source: 'glass/html/material/Menu.ion'
                                }
                            }
                        },
                        arguments: [{
                                type: 'ObjectExpression',
                                properties: [{
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'class',
                                            loc: {
                                                start: {
                                                    line: 326,
                                                    column: 34,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                },
                                                end: {
                                                    line: 326,
                                                    column: 39,
                                                    fixed: true,
                                                    source: 'glass/html/material/Menu.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: 'divider'
                                        },
                                        kind: 'init',
                                        order: '0'
                                    }]
                            }],
                        loc: {
                            start: {
                                line: 326,
                                column: 29,
                                fixed: true,
                                source: 'glass/html/material/Menu.ion'
                            },
                            end: {
                                line: 326,
                                column: 51,
                                fixed: true,
                                source: 'glass/html/material/Menu.ion'
                            }
                        }
                    },
                    order: '0'
                }],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'Divider',
                loc: {
                    start: {
                        line: 326,
                        column: 4,
                        fixed: true,
                        source: 'glass/html/material/Menu.ion'
                    },
                    end: {
                        line: 326,
                        column: 11,
                        fixed: true,
                        source: 'glass/html/material/Menu.ion'
                    }
                }
            }
        }, {
            this: this,
            ion: ion,
            style: style,
            _ref: _ref,
            _ref2: _ref2,
            Shadow: Shadow,
            Icon: Icon,
            ensureOnScreen: ensureOnScreen,
            padding: padding,
            isRow: isRow,
            getRow: getRow,
            Menu: Menu,
            Space: Space,
            focusNext: focusNext,
            Row: Row,
            Divider: Divider
        }, null);
    });
module.exports = exports = ion.patch.combine(Menu, {
    Space: Space,
    Row: Row,
    Divider: Divider
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/Menu',_glass_html_material_Menu_);
    else
      _glass_html_material_Menu_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_Menu_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_MultiRelationInput_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('./'), _ref2, missingEntity = function (keyString) {
        var key = new Key(global.model.namespace, keyString);
        return {
            key: keyString,
            name: key.id,
            abbreviation: key.id,
            description: 'Does not exist yet.'
        };
    };
var RelationInput = _ref.RelationInput;
var RecordChip = _ref.RecordChip;
_ref2 = require('../../data');
var Schema = _ref2.Schema;
var Key = _ref2.Key;
module.exports = exports = ion.template(function MultiRelationInput(args) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'MultiRelationInput',
            loc: {
                start: {
                    line: 15,
                    column: 16,
                    fixed: true,
                    source: 'glass/html/material/MultiRelationInput.ion'
                },
                end: {
                    line: 15,
                    column: 34,
                    fixed: true,
                    source: 'glass/html/material/MultiRelationInput.ion'
                }
            }
        },
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: '_ref3'
                        },
                        init: {
                            type: 'Identifier',
                            name: 'args',
                            loc: {
                                start: {
                                    line: 16,
                                    column: 49,
                                    fixed: true,
                                    source: 'glass/html/material/MultiRelationInput.ion'
                                },
                                end: {
                                    line: 16,
                                    column: 53,
                                    fixed: true,
                                    source: 'glass/html/material/MultiRelationInput.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'object',
                            loc: {
                                start: {
                                    line: 16,
                                    column: 9,
                                    fixed: true,
                                    source: 'glass/html/material/MultiRelationInput.ion'
                                },
                                end: {
                                    line: 16,
                                    column: 15,
                                    fixed: true,
                                    source: 'glass/html/material/MultiRelationInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'object',
                                loc: {
                                    start: {
                                        line: 16,
                                        column: 9,
                                        fixed: true,
                                        source: 'glass/html/material/MultiRelationInput.ion'
                                    },
                                    end: {
                                        line: 16,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/MultiRelationInput.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'property',
                            loc: {
                                start: {
                                    line: 16,
                                    column: 17,
                                    fixed: true,
                                    source: 'glass/html/material/MultiRelationInput.ion'
                                },
                                end: {
                                    line: 16,
                                    column: 25,
                                    fixed: true,
                                    source: 'glass/html/material/MultiRelationInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'property',
                                loc: {
                                    start: {
                                        line: 16,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/html/material/MultiRelationInput.ion'
                                    },
                                    end: {
                                        line: 16,
                                        column: 25,
                                        fixed: true,
                                        source: 'glass/html/material/MultiRelationInput.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'initialValue',
                            loc: {
                                start: {
                                    line: 16,
                                    column: 33,
                                    fixed: true,
                                    source: 'glass/html/material/MultiRelationInput.ion'
                                },
                                end: {
                                    line: 16,
                                    column: 45,
                                    fixed: true,
                                    source: 'glass/html/material/MultiRelationInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'value',
                                loc: {
                                    start: {
                                        line: 16,
                                        column: 27,
                                        fixed: true,
                                        source: 'glass/html/material/MultiRelationInput.ion'
                                    },
                                    end: {
                                        line: 16,
                                        column: 32,
                                        fixed: true,
                                        source: 'glass/html/material/MultiRelationInput.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '3'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'label',
                            loc: {
                                start: {
                                    line: 17,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/MultiRelationInput.ion'
                                },
                                end: {
                                    line: 17,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/html/material/MultiRelationInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ConditionalExpression',
                            test: {
                                type: 'BinaryExpression',
                                operator: '!=',
                                left: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'args',
                                        loc: {
                                            start: {
                                                line: 17,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/MultiRelationInput.ion'
                                            },
                                            end: {
                                                line: 17,
                                                column: 20,
                                                fixed: true,
                                                source: 'glass/html/material/MultiRelationInput.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'label',
                                        loc: {
                                            start: {
                                                line: 17,
                                                column: 21,
                                                fixed: true,
                                                source: 'glass/html/material/MultiRelationInput.ion'
                                            },
                                            end: {
                                                line: 17,
                                                column: 26,
                                                fixed: true,
                                                source: 'glass/html/material/MultiRelationInput.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 17,
                                            column: 16,
                                            fixed: true,
                                            source: 'glass/html/material/MultiRelationInput.ion'
                                        },
                                        end: {
                                            line: 17,
                                            column: 26,
                                            fixed: true,
                                            source: 'glass/html/material/MultiRelationInput.ion'
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: null
                                }
                            },
                            consequent: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'args',
                                    loc: {
                                        start: {
                                            line: 17,
                                            column: 16,
                                            fixed: true,
                                            source: 'glass/html/material/MultiRelationInput.ion'
                                        },
                                        end: {
                                            line: 17,
                                            column: 20,
                                            fixed: true,
                                            source: 'glass/html/material/MultiRelationInput.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'label',
                                    loc: {
                                        start: {
                                            line: 17,
                                            column: 21,
                                            fixed: true,
                                            source: 'glass/html/material/MultiRelationInput.ion'
                                        },
                                        end: {
                                            line: 17,
                                            column: 26,
                                            fixed: true,
                                            source: 'glass/html/material/MultiRelationInput.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 17,
                                        column: 16,
                                        fixed: true,
                                        source: 'glass/html/material/MultiRelationInput.ion'
                                    },
                                    end: {
                                        line: 17,
                                        column: 26,
                                        fixed: true,
                                        source: 'glass/html/material/MultiRelationInput.ion'
                                    }
                                }
                            },
                            alternate: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'Schema',
                                        loc: {
                                            start: {
                                                line: 17,
                                                column: 29,
                                                fixed: true,
                                                source: 'glass/html/material/MultiRelationInput.ion'
                                            },
                                            end: {
                                                line: 17,
                                                column: 35,
                                                fixed: true,
                                                source: 'glass/html/material/MultiRelationInput.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'getDisplayName',
                                        loc: {
                                            start: {
                                                line: 17,
                                                column: 36,
                                                fixed: true,
                                                source: 'glass/html/material/MultiRelationInput.ion'
                                            },
                                            end: {
                                                line: 17,
                                                column: 50,
                                                fixed: true,
                                                source: 'glass/html/material/MultiRelationInput.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 17,
                                            column: 29,
                                            fixed: true,
                                            source: 'glass/html/material/MultiRelationInput.ion'
                                        },
                                        end: {
                                            line: 17,
                                            column: 50,
                                            fixed: true,
                                            source: 'glass/html/material/MultiRelationInput.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'Identifier',
                                        name: 'property',
                                        loc: {
                                            start: {
                                                line: 17,
                                                column: 51,
                                                fixed: true,
                                                source: 'glass/html/material/MultiRelationInput.ion'
                                            },
                                            end: {
                                                line: 17,
                                                column: 59,
                                                fixed: true,
                                                source: 'glass/html/material/MultiRelationInput.ion'
                                            }
                                        }
                                    }],
                                loc: {
                                    start: {
                                        line: 17,
                                        column: 29,
                                        fixed: true,
                                        source: 'glass/html/material/MultiRelationInput.ion'
                                    },
                                    end: {
                                        line: 17,
                                        column: 60,
                                        fixed: true,
                                        source: 'glass/html/material/MultiRelationInput.ion'
                                    }
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '4'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'showMissingEntities',
                            loc: {
                                start: {
                                    line: 18,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/MultiRelationInput.ion'
                                },
                                end: {
                                    line: 18,
                                    column: 27,
                                    fixed: true,
                                    source: 'glass/html/material/MultiRelationInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ConditionalExpression',
                            test: {
                                type: 'BinaryExpression',
                                operator: '!=',
                                left: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'property',
                                            loc: {
                                                start: {
                                                    line: 18,
                                                    column: 30,
                                                    fixed: true,
                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                },
                                                end: {
                                                    line: 18,
                                                    column: 38,
                                                    fixed: true,
                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'foreign',
                                            loc: {
                                                start: {
                                                    line: 18,
                                                    column: 39,
                                                    fixed: true,
                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                },
                                                end: {
                                                    line: 18,
                                                    column: 46,
                                                    fixed: true,
                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 18,
                                                column: 30,
                                                fixed: true,
                                                source: 'glass/html/material/MultiRelationInput.ion'
                                            },
                                            end: {
                                                line: 18,
                                                column: 46,
                                                fixed: true,
                                                source: 'glass/html/material/MultiRelationInput.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'showMissingEntities',
                                        loc: {
                                            start: {
                                                line: 18,
                                                column: 47,
                                                fixed: true,
                                                source: 'glass/html/material/MultiRelationInput.ion'
                                            },
                                            end: {
                                                line: 18,
                                                column: 66,
                                                fixed: true,
                                                source: 'glass/html/material/MultiRelationInput.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 18,
                                            column: 30,
                                            fixed: true,
                                            source: 'glass/html/material/MultiRelationInput.ion'
                                        },
                                        end: {
                                            line: 18,
                                            column: 66,
                                            fixed: true,
                                            source: 'glass/html/material/MultiRelationInput.ion'
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: null
                                }
                            },
                            consequent: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'property',
                                        loc: {
                                            start: {
                                                line: 18,
                                                column: 30,
                                                fixed: true,
                                                source: 'glass/html/material/MultiRelationInput.ion'
                                            },
                                            end: {
                                                line: 18,
                                                column: 38,
                                                fixed: true,
                                                source: 'glass/html/material/MultiRelationInput.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'foreign',
                                        loc: {
                                            start: {
                                                line: 18,
                                                column: 39,
                                                fixed: true,
                                                source: 'glass/html/material/MultiRelationInput.ion'
                                            },
                                            end: {
                                                line: 18,
                                                column: 46,
                                                fixed: true,
                                                source: 'glass/html/material/MultiRelationInput.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 18,
                                            column: 30,
                                            fixed: true,
                                            source: 'glass/html/material/MultiRelationInput.ion'
                                        },
                                        end: {
                                            line: 18,
                                            column: 46,
                                            fixed: true,
                                            source: 'glass/html/material/MultiRelationInput.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'showMissingEntities',
                                    loc: {
                                        start: {
                                            line: 18,
                                            column: 47,
                                            fixed: true,
                                            source: 'glass/html/material/MultiRelationInput.ion'
                                        },
                                        end: {
                                            line: 18,
                                            column: 66,
                                            fixed: true,
                                            source: 'glass/html/material/MultiRelationInput.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 18,
                                        column: 30,
                                        fixed: true,
                                        source: 'glass/html/material/MultiRelationInput.ion'
                                    },
                                    end: {
                                        line: 18,
                                        column: 66,
                                        fixed: true,
                                        source: 'glass/html/material/MultiRelationInput.ion'
                                    }
                                }
                            },
                            alternate: {
                                type: 'Literal',
                                value: false
                            }
                        }
                    }],
                kind: 'let',
                order: '5'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'mainElement',
                            loc: {
                                start: {
                                    line: 20,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/MultiRelationInput.ion'
                                },
                                end: {
                                    line: 20,
                                    column: 19,
                                    fixed: true,
                                    source: 'glass/html/material/MultiRelationInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Div',
                                loc: {
                                    start: {
                                        line: 20,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/material/MultiRelationInput.ion'
                                    },
                                    end: {
                                        line: 20,
                                        column: 25,
                                        fixed: true,
                                        source: 'glass/html/material/MultiRelationInput.ion'
                                    }
                                }
                            },
                            arguments: [],
                            loc: {
                                start: {
                                    line: 20,
                                    column: 22,
                                    fixed: true,
                                    source: 'glass/html/material/MultiRelationInput.ion'
                                },
                                end: {
                                    line: 20,
                                    column: 27,
                                    fixed: true,
                                    source: 'glass/html/material/MultiRelationInput.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '6'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'dispatchChange',
                            loc: {
                                start: {
                                    line: 21,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/MultiRelationInput.ion'
                                },
                                end: {
                                    line: 21,
                                    column: 22,
                                    fixed: true,
                                    source: 'glass/html/material/MultiRelationInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'Function',
                            context: true,
                            value: function (_context) {
                                return function () {
                                    var mainElement = _context.get('mainElement');
                                    mainElement.dispatchEvent(new CustomEvent('change'));
                                };
                            }
                        }
                    }],
                kind: 'let',
                order: '7'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'input',
                            loc: {
                                start: {
                                    line: 23,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/MultiRelationInput.ion'
                                },
                                end: {
                                    line: 23,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/html/material/MultiRelationInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'RelationInput',
                                    loc: {
                                        start: {
                                            line: 23,
                                            column: 16,
                                            fixed: true,
                                            source: 'glass/html/material/MultiRelationInput.ion'
                                        },
                                        end: {
                                            line: 23,
                                            column: 29,
                                            fixed: true,
                                            source: 'glass/html/material/MultiRelationInput.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'Identifier',
                                        name: 'args',
                                        loc: {
                                            start: {
                                                line: 23,
                                                column: 30,
                                                fixed: true,
                                                source: 'glass/html/material/MultiRelationInput.ion'
                                            },
                                            end: {
                                                line: 23,
                                                column: 34,
                                                fixed: true,
                                                source: 'glass/html/material/MultiRelationInput.ion'
                                            }
                                        }
                                    }],
                                loc: {
                                    start: {
                                        line: 23,
                                        column: 16,
                                        fixed: true,
                                        source: 'glass/html/material/MultiRelationInput.ion'
                                    },
                                    end: {
                                        line: 23,
                                        column: 35,
                                        fixed: true,
                                        source: 'glass/html/material/MultiRelationInput.ion'
                                    }
                                }
                            },
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'label',
                                        loc: {
                                            start: {
                                                line: 24,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/MultiRelationInput.ion'
                                            },
                                            end: {
                                                line: 24,
                                                column: 13,
                                                fixed: true,
                                                source: 'glass/html/material/MultiRelationInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Identifier',
                                        name: 'label',
                                        loc: {
                                            start: {
                                                line: 24,
                                                column: 15,
                                                fixed: true,
                                                source: 'glass/html/material/MultiRelationInput.ion'
                                            },
                                            end: {
                                                line: 24,
                                                column: 20,
                                                fixed: true,
                                                source: 'glass/html/material/MultiRelationInput.ion'
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '0'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context2) {
                                            return function keydown(e) {
                                                var input = _context2.get('input'), state = _context2.get('state');
                                                if (e.keyCode === 8) {
                                                    if (input.value === '') {
                                                        state.relations.pop();
                                                    }
                                                }
                                                if (e.keyCode === 13) {
                                                    e.preventDefault();
                                                    e.stopPropagation();
                                                }
                                            };
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 25,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/MultiRelationInput.ion'
                                        },
                                        end: {
                                            line: 34,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/material/MultiRelationInput.ion'
                                        }
                                    },
                                    order: '1'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context3) {
                                            return function commit(e) {
                                                var getRelationIndex = _context3.get('getRelationIndex'), addRelation = _context3.get('addRelation'), dispatchChange = _context3.get('dispatchChange'), mainElement = _context3.get('mainElement');
                                                var value = this.valueJSON;
                                                if (value != null && getRelationIndex(value) < 0) {
                                                    addRelation(value, {});
                                                    dispatchChange();
                                                    this.value = '';
                                                    return;
                                                }
                                                if (this.value.trim().length === 0) {
                                                    mainElement.dispatchEvent(new CustomEvent('commit', { detail: e.detail }));
                                                }
                                            };
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 34,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/MultiRelationInput.ion'
                                        },
                                        end: {
                                            line: 46,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/material/MultiRelationInput.ion'
                                        }
                                    },
                                    order: '2'
                                }
                            ]
                        }
                    }],
                kind: 'let',
                order: '8'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'state',
                            loc: {
                                start: {
                                    line: 46,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/MultiRelationInput.ion'
                                },
                                end: {
                                    line: 46,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/html/material/MultiRelationInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            properties: [{
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'relations',
                                        loc: {
                                            start: {
                                                line: 46,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/MultiRelationInput.ion'
                                            },
                                            end: {
                                                line: 46,
                                                column: 26,
                                                fixed: true,
                                                source: 'glass/html/material/MultiRelationInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ArrayExpression',
                                        elements: []
                                    },
                                    kind: 'init',
                                    order: '0'
                                }]
                        }
                    }],
                kind: 'let',
                order: '9'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'getRelationIndex',
                            loc: {
                                start: {
                                    line: 47,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/MultiRelationInput.ion'
                                },
                                end: {
                                    line: 47,
                                    column: 24,
                                    fixed: true,
                                    source: 'glass/html/material/MultiRelationInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'Function',
                            context: true,
                            value: function (_context4) {
                                return function (key) {
                                    var state = _context4.get('state');
                                    return state.relations.findIndex(function (value) {
                                        return value.key === key;
                                    });
                                };
                            }
                        }
                    }],
                kind: 'let',
                order: ':'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'addRelation',
                            loc: {
                                start: {
                                    line: 48,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/MultiRelationInput.ion'
                                },
                                end: {
                                    line: 48,
                                    column: 19,
                                    fixed: true,
                                    source: 'glass/html/material/MultiRelationInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'Function',
                            context: true,
                            value: function (_context5) {
                                return function (key, detail) {
                                    var getRelationIndex = _context5.get('getRelationIndex'), state = _context5.get('state'), input = _context5.get('input');
                                    if (getRelationIndex(key) < 0) {
                                        state.relations.push({
                                            key: key,
                                            detail: detail
                                        });
                                        input.value = '';
                                    }
                                };
                            }
                        }
                    }],
                kind: 'let',
                order: ';'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'removeRelation',
                            loc: {
                                start: {
                                    line: 53,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/MultiRelationInput.ion'
                                },
                                end: {
                                    line: 53,
                                    column: 22,
                                    fixed: true,
                                    source: 'glass/html/material/MultiRelationInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'Function',
                            context: true,
                            value: function (_context6) {
                                return function (key) {
                                    var getRelationIndex = _context6.get('getRelationIndex'), state = _context6.get('state');
                                    var index = getRelationIndex(key);
                                    if (index >= 0) {
                                        state.relations.splice(index, 1);
                                    }
                                };
                            }
                        }
                    }],
                kind: 'let',
                order: '<'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'setRelations',
                            loc: {
                                start: {
                                    line: 57,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/MultiRelationInput.ion'
                                },
                                end: {
                                    line: 57,
                                    column: 20,
                                    fixed: true,
                                    source: 'glass/html/material/MultiRelationInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'Function',
                            context: true,
                            value: function (_context7) {
                                return function (value) {
                                    var state = _context7.get('state'), addRelation = _context7.get('addRelation');
                                    state.relations.length = 0;
                                    if (value != null) {
                                        if (typeof value === 'object') {
                                            for (var key in value) {
                                                var detail = value[key];
                                                addRelation(key, detail);
                                            }
                                        }
                                    }
                                };
                            }
                        }
                    }],
                kind: 'let',
                order: '='
            },
            {
                type: 'ExpressionStatement',
                expression: {
                    type: 'CallExpression',
                    callee: {
                        type: 'Function',
                        context: true,
                        value: function (_context8) {
                            return function () {
                                var setRelations = _context8.get('setRelations'), initialValue = _context8.get('initialValue');
                                setRelations(initialValue);
                            };
                        }
                    },
                    arguments: [],
                    loc: {
                        start: {
                            line: 63,
                            column: 4,
                            fixed: true,
                            source: 'glass/html/material/MultiRelationInput.ion'
                        },
                        end: {
                            line: 66,
                            column: 8,
                            fixed: true,
                            source: 'glass/html/material/MultiRelationInput.ion'
                        }
                    }
                },
                loc: {
                    start: {
                        line: 63,
                        column: 4,
                        fixed: true,
                        source: 'glass/html/material/MultiRelationInput.ion'
                    },
                    end: {
                        line: 66,
                        column: 8,
                        fixed: true,
                        source: 'glass/html/material/MultiRelationInput.ion'
                    }
                },
                order: '>'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'source',
                            loc: {
                                start: {
                                    line: 66,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/MultiRelationInput.ion'
                                },
                                end: {
                                    line: 66,
                                    column: 14,
                                    fixed: true,
                                    source: 'glass/html/material/MultiRelationInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ConditionalExpression',
                            test: {
                                type: 'BinaryExpression',
                                operator: '!=',
                                left: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'property',
                                                loc: {
                                                    start: {
                                                        line: 66,
                                                        column: 17,
                                                        fixed: true,
                                                        source: 'glass/html/material/MultiRelationInput.ion'
                                                    },
                                                    end: {
                                                        line: 66,
                                                        column: 25,
                                                        fixed: true,
                                                        source: 'glass/html/material/MultiRelationInput.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'foreign',
                                                loc: {
                                                    start: {
                                                        line: 66,
                                                        column: 26,
                                                        fixed: true,
                                                        source: 'glass/html/material/MultiRelationInput.ion'
                                                    },
                                                    end: {
                                                        line: 66,
                                                        column: 33,
                                                        fixed: true,
                                                        source: 'glass/html/material/MultiRelationInput.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 66,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                },
                                                end: {
                                                    line: 66,
                                                    column: 33,
                                                    fixed: true,
                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'getSource',
                                            loc: {
                                                start: {
                                                    line: 66,
                                                    column: 35,
                                                    fixed: true,
                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                },
                                                end: {
                                                    line: 66,
                                                    column: 44,
                                                    fixed: true,
                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                }
                                            }
                                        },
                                        existential: true,
                                        loc: {
                                            start: {
                                                line: 66,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/MultiRelationInput.ion'
                                            },
                                            end: {
                                                line: 66,
                                                column: 44,
                                                fixed: true,
                                                source: 'glass/html/material/MultiRelationInput.ion'
                                            }
                                        }
                                    },
                                    arguments: [{
                                            type: 'ObjectExpression',
                                            properties: [
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'server',
                                                        loc: {
                                                            start: {
                                                                line: 66,
                                                                column: 47,
                                                                fixed: true,
                                                                source: 'glass/html/material/MultiRelationInput.ion'
                                                            },
                                                            end: {
                                                                line: 66,
                                                                column: 53,
                                                                fixed: true,
                                                                source: 'glass/html/material/MultiRelationInput.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'model',
                                                            loc: {
                                                                start: {
                                                                    line: 66,
                                                                    column: 54,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                                },
                                                                end: {
                                                                    line: 66,
                                                                    column: 59,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'server',
                                                            loc: {
                                                                start: {
                                                                    line: 66,
                                                                    column: 60,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                                },
                                                                end: {
                                                                    line: 66,
                                                                    column: 66,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 66,
                                                                column: 54,
                                                                fixed: true,
                                                                source: 'glass/html/material/MultiRelationInput.ion'
                                                            },
                                                            end: {
                                                                line: 66,
                                                                column: 66,
                                                                fixed: true,
                                                                source: 'glass/html/material/MultiRelationInput.ion'
                                                            }
                                                        }
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'record',
                                                        loc: {
                                                            start: {
                                                                line: 66,
                                                                column: 68,
                                                                fixed: true,
                                                                source: 'glass/html/material/MultiRelationInput.ion'
                                                            },
                                                            end: {
                                                                line: 66,
                                                                column: 74,
                                                                fixed: true,
                                                                source: 'glass/html/material/MultiRelationInput.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Identifier',
                                                        name: 'object',
                                                        loc: {
                                                            start: {
                                                                line: 66,
                                                                column: 75,
                                                                fixed: true,
                                                                source: 'glass/html/material/MultiRelationInput.ion'
                                                            },
                                                            end: {
                                                                line: 66,
                                                                column: 81,
                                                                fixed: true,
                                                                source: 'glass/html/material/MultiRelationInput.ion'
                                                            }
                                                        }
                                                    },
                                                    kind: 'init',
                                                    order: '1'
                                                }
                                            ]
                                        }],
                                    existential: true,
                                    loc: {
                                        start: {
                                            line: 66,
                                            column: 17,
                                            fixed: true,
                                            source: 'glass/html/material/MultiRelationInput.ion'
                                        },
                                        end: {
                                            line: 66,
                                            column: 83,
                                            fixed: true,
                                            source: 'glass/html/material/MultiRelationInput.ion'
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: null
                                }
                            },
                            consequent: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'property',
                                            loc: {
                                                start: {
                                                    line: 66,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                },
                                                end: {
                                                    line: 66,
                                                    column: 25,
                                                    fixed: true,
                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'foreign',
                                            loc: {
                                                start: {
                                                    line: 66,
                                                    column: 26,
                                                    fixed: true,
                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                },
                                                end: {
                                                    line: 66,
                                                    column: 33,
                                                    fixed: true,
                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 66,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/MultiRelationInput.ion'
                                            },
                                            end: {
                                                line: 66,
                                                column: 33,
                                                fixed: true,
                                                source: 'glass/html/material/MultiRelationInput.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'getSource',
                                        loc: {
                                            start: {
                                                line: 66,
                                                column: 35,
                                                fixed: true,
                                                source: 'glass/html/material/MultiRelationInput.ion'
                                            },
                                            end: {
                                                line: 66,
                                                column: 44,
                                                fixed: true,
                                                source: 'glass/html/material/MultiRelationInput.ion'
                                            }
                                        }
                                    },
                                    existential: true,
                                    loc: {
                                        start: {
                                            line: 66,
                                            column: 17,
                                            fixed: true,
                                            source: 'glass/html/material/MultiRelationInput.ion'
                                        },
                                        end: {
                                            line: 66,
                                            column: 44,
                                            fixed: true,
                                            source: 'glass/html/material/MultiRelationInput.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'server',
                                                    loc: {
                                                        start: {
                                                            line: 66,
                                                            column: 47,
                                                            fixed: true,
                                                            source: 'glass/html/material/MultiRelationInput.ion'
                                                        },
                                                        end: {
                                                            line: 66,
                                                            column: 53,
                                                            fixed: true,
                                                            source: 'glass/html/material/MultiRelationInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'model',
                                                        loc: {
                                                            start: {
                                                                line: 66,
                                                                column: 54,
                                                                fixed: true,
                                                                source: 'glass/html/material/MultiRelationInput.ion'
                                                            },
                                                            end: {
                                                                line: 66,
                                                                column: 59,
                                                                fixed: true,
                                                                source: 'glass/html/material/MultiRelationInput.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'server',
                                                        loc: {
                                                            start: {
                                                                line: 66,
                                                                column: 60,
                                                                fixed: true,
                                                                source: 'glass/html/material/MultiRelationInput.ion'
                                                            },
                                                            end: {
                                                                line: 66,
                                                                column: 66,
                                                                fixed: true,
                                                                source: 'glass/html/material/MultiRelationInput.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 66,
                                                            column: 54,
                                                            fixed: true,
                                                            source: 'glass/html/material/MultiRelationInput.ion'
                                                        },
                                                        end: {
                                                            line: 66,
                                                            column: 66,
                                                            fixed: true,
                                                            source: 'glass/html/material/MultiRelationInput.ion'
                                                        }
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'record',
                                                    loc: {
                                                        start: {
                                                            line: 66,
                                                            column: 68,
                                                            fixed: true,
                                                            source: 'glass/html/material/MultiRelationInput.ion'
                                                        },
                                                        end: {
                                                            line: 66,
                                                            column: 74,
                                                            fixed: true,
                                                            source: 'glass/html/material/MultiRelationInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Identifier',
                                                    name: 'object',
                                                    loc: {
                                                        start: {
                                                            line: 66,
                                                            column: 75,
                                                            fixed: true,
                                                            source: 'glass/html/material/MultiRelationInput.ion'
                                                        },
                                                        end: {
                                                            line: 66,
                                                            column: 81,
                                                            fixed: true,
                                                            source: 'glass/html/material/MultiRelationInput.ion'
                                                        }
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    }],
                                existential: true,
                                loc: {
                                    start: {
                                        line: 66,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/html/material/MultiRelationInput.ion'
                                    },
                                    end: {
                                        line: 66,
                                        column: 83,
                                        fixed: true,
                                        source: 'glass/html/material/MultiRelationInput.ion'
                                    }
                                }
                            },
                            alternate: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'model',
                                    loc: {
                                        start: {
                                            line: 66,
                                            column: 86,
                                            fixed: true,
                                            source: 'glass/html/material/MultiRelationInput.ion'
                                        },
                                        end: {
                                            line: 66,
                                            column: 91,
                                            fixed: true,
                                            source: 'glass/html/material/MultiRelationInput.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'server',
                                    loc: {
                                        start: {
                                            line: 66,
                                            column: 92,
                                            fixed: true,
                                            source: 'glass/html/material/MultiRelationInput.ion'
                                        },
                                        end: {
                                            line: 66,
                                            column: 98,
                                            fixed: true,
                                            source: 'glass/html/material/MultiRelationInput.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 66,
                                        column: 86,
                                        fixed: true,
                                        source: 'glass/html/material/MultiRelationInput.ion'
                                    },
                                    end: {
                                        line: 66,
                                        column: 98,
                                        fixed: true,
                                        source: 'glass/html/material/MultiRelationInput.ion'
                                    }
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '?'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'CallExpression',
                    callee: {
                        type: 'MemberExpression',
                        object: {
                            type: 'Identifier',
                            name: 'Object'
                        },
                        property: {
                            type: 'Identifier',
                            name: 'defineProperties'
                        }
                    },
                    arguments: [
                        {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'Identifier',
                                name: 'mainElement',
                                loc: {
                                    start: {
                                        line: 68,
                                        column: 11,
                                        fixed: true,
                                        source: 'glass/html/material/MultiRelationInput.ion'
                                    },
                                    end: {
                                        line: 68,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/material/MultiRelationInput.ion'
                                    }
                                }
                            },
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'name',
                                        loc: {
                                            start: {
                                                line: 70,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/MultiRelationInput.ion'
                                            },
                                            end: {
                                                line: 70,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/MultiRelationInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'property',
                                            loc: {
                                                start: {
                                                    line: 70,
                                                    column: 14,
                                                    fixed: true,
                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                },
                                                end: {
                                                    line: 70,
                                                    column: 22,
                                                    fixed: true,
                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'name',
                                            loc: {
                                                start: {
                                                    line: 70,
                                                    column: 23,
                                                    fixed: true,
                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                },
                                                end: {
                                                    line: 70,
                                                    column: 27,
                                                    fixed: true,
                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 70,
                                                column: 14,
                                                fixed: true,
                                                source: 'glass/html/material/MultiRelationInput.ion'
                                            },
                                            end: {
                                                line: 70,
                                                column: 27,
                                                fixed: true,
                                                source: 'glass/html/material/MultiRelationInput.ion'
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'classList',
                                        loc: {
                                            start: {
                                                line: 71,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/MultiRelationInput.ion'
                                            },
                                            end: {
                                                line: 71,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/MultiRelationInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'Literal',
                                                    value: 'validate'
                                                },
                                                loc: {
                                                    start: {
                                                        line: 72,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/MultiRelationInput.ion'
                                                    },
                                                    end: {
                                                        line: 72,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'glass/html/material/MultiRelationInput.ion'
                                                    }
                                                },
                                                order: '0'
                                            }]
                                    },
                                    kind: 'init',
                                    order: '1'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'select',
                                        loc: {
                                            start: {
                                                line: 89,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/MultiRelationInput.ion'
                                            },
                                            end: {
                                                line: 89,
                                                column: 14,
                                                fixed: true,
                                                source: 'glass/html/material/MultiRelationInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context9) {
                                            return function () {
                                                var input = _context9.get('input');
                                                input.select();
                                            };
                                        }
                                    },
                                    kind: 'init',
                                    order: '2'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'focus',
                                        loc: {
                                            start: {
                                                line: 91,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/MultiRelationInput.ion'
                                            },
                                            end: {
                                                line: 91,
                                                column: 13,
                                                fixed: true,
                                                source: 'glass/html/material/MultiRelationInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context10) {
                                            return function () {
                                                var input = _context10.get('input');
                                                input.focus();
                                            };
                                        }
                                    },
                                    kind: 'init',
                                    order: '3'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'ObjectExpression',
                                        objectType: {
                                            type: 'Identifier',
                                            name: 'input',
                                            loc: {
                                                start: {
                                                    line: 93,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                },
                                                end: {
                                                    line: 93,
                                                    column: 13,
                                                    fixed: true,
                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                }
                                            }
                                        },
                                        properties: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'input',
                                                    loc: {
                                                        start: {
                                                            line: 94,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/MultiRelationInput.ion'
                                                        },
                                                        end: {
                                                            line: 94,
                                                            column: 17,
                                                            fixed: true,
                                                            source: 'glass/html/material/MultiRelationInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'ObjectExpression',
                                                    properties: [
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'alwaysFloatLabel',
                                                                loc: {
                                                                    start: {
                                                                        line: 95,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/MultiRelationInput.ion'
                                                                    },
                                                                    end: {
                                                                        line: 95,
                                                                        column: 32,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/MultiRelationInput.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'BinaryExpression',
                                                                operator: '>',
                                                                left: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'state',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 95,
                                                                                    column: 34,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 95,
                                                                                    column: 39,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'relations',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 95,
                                                                                    column: 40,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 95,
                                                                                    column: 49,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 95,
                                                                                column: 34,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/MultiRelationInput.ion'
                                                                            },
                                                                            end: {
                                                                                line: 95,
                                                                                column: 49,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/MultiRelationInput.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'length',
                                                                        loc: {
                                                                            start: {
                                                                                line: 95,
                                                                                column: 50,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/MultiRelationInput.ion'
                                                                            },
                                                                            end: {
                                                                                line: 95,
                                                                                column: 56,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/MultiRelationInput.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 95,
                                                                            column: 34,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/MultiRelationInput.ion'
                                                                        },
                                                                        end: {
                                                                            line: 95,
                                                                            column: 56,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/MultiRelationInput.ion'
                                                                        }
                                                                    }
                                                                },
                                                                right: {
                                                                    type: 'Literal',
                                                                    value: 0
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        },
                                                        {
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'ObjectExpression',
                                                                objectType: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'Identifier',
                                                                        name: 'Div',
                                                                        loc: {
                                                                            start: {
                                                                                line: 96,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/MultiRelationInput.ion'
                                                                            },
                                                                            end: {
                                                                                line: 96,
                                                                                column: 19,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/MultiRelationInput.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [{
                                                                            type: 'ObjectExpression',
                                                                            properties: [
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'prefix',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 96,
                                                                                                column: 21,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/MultiRelationInput.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 96,
                                                                                                column: 27,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/MultiRelationInput.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Literal',
                                                                                        value: true
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'class',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 96,
                                                                                                column: 33,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/MultiRelationInput.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 96,
                                                                                                column: 38,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/MultiRelationInput.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Literal',
                                                                                        value: 'layout vertical'
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '1'
                                                                                }
                                                                            ]
                                                                        }],
                                                                    loc: {
                                                                        start: {
                                                                            line: 96,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/MultiRelationInput.ion'
                                                                        },
                                                                        end: {
                                                                            line: 96,
                                                                            column: 58,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/MultiRelationInput.ion'
                                                                        }
                                                                    }
                                                                },
                                                                properties: [
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'style',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 97,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 97,
                                                                                    column: 25,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'ObjectExpression',
                                                                            properties: [
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'marginTop',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 98,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/MultiRelationInput.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 98,
                                                                                                column: 33,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/MultiRelationInput.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Literal',
                                                                                        value: '4px'
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'maxWidth',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 99,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/MultiRelationInput.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 99,
                                                                                                column: 32,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/MultiRelationInput.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Literal',
                                                                                        value: '50%'
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '1'
                                                                                }
                                                                            ]
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    },
                                                                    {
                                                                        type: 'ForOfStatement',
                                                                        left: {
                                                                            type: 'VariableDeclaration',
                                                                            declarations: [{
                                                                                    type: 'VariableDeclarator',
                                                                                    id: {
                                                                                        type: 'Identifier',
                                                                                        name: '_ref5'
                                                                                    },
                                                                                    init: null
                                                                                }],
                                                                            kind: 'let'
                                                                        },
                                                                        right: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'state',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 100,
                                                                                        column: 40,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/MultiRelationInput.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 100,
                                                                                        column: 45,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/MultiRelationInput.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'relations',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 100,
                                                                                        column: 46,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/MultiRelationInput.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 100,
                                                                                        column: 55,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/MultiRelationInput.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 100,
                                                                                    column: 40,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 100,
                                                                                    column: 55,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        body: {
                                                                            type: 'BlockStatement',
                                                                            body: [
                                                                                {
                                                                                    type: 'VariableDeclaration',
                                                                                    declarations: [{
                                                                                            type: 'VariableDeclarator',
                                                                                            id: {
                                                                                                type: 'Identifier',
                                                                                                name: '_ref6'
                                                                                            },
                                                                                            init: {
                                                                                                type: 'Identifier',
                                                                                                name: '_ref5'
                                                                                            }
                                                                                        }],
                                                                                    order: '0'
                                                                                },
                                                                                {
                                                                                    type: 'VariableDeclaration',
                                                                                    declarations: [{
                                                                                            type: 'VariableDeclarator',
                                                                                            id: {
                                                                                                type: 'Identifier',
                                                                                                name: 'key',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 100,
                                                                                                        column: 25,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 100,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            init: {
                                                                                                type: 'MemberExpression',
                                                                                                object: {
                                                                                                    type: 'Identifier',
                                                                                                    name: '_ref6'
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'key',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 100,
                                                                                                            column: 25,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 100,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                computed: false
                                                                                            }
                                                                                        }],
                                                                                    kind: 'let',
                                                                                    order: '1'
                                                                                },
                                                                                {
                                                                                    type: 'VariableDeclaration',
                                                                                    declarations: [{
                                                                                            type: 'VariableDeclarator',
                                                                                            id: {
                                                                                                type: 'Identifier',
                                                                                                name: 'detail',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 100,
                                                                                                        column: 29,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 100,
                                                                                                        column: 35,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            init: {
                                                                                                type: 'MemberExpression',
                                                                                                object: {
                                                                                                    type: 'Identifier',
                                                                                                    name: '_ref6'
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'detail',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 100,
                                                                                                            column: 29,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 100,
                                                                                                            column: 35,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                computed: false
                                                                                            }
                                                                                        }],
                                                                                    kind: 'let',
                                                                                    order: '2'
                                                                                },
                                                                                {
                                                                                    type: 'VariableDeclaration',
                                                                                    declarations: [{
                                                                                            type: 'VariableDeclarator',
                                                                                            id: {
                                                                                                type: 'Identifier',
                                                                                                name: 'entity',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 101,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 101,
                                                                                                        column: 34,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            init: {
                                                                                                type: 'MemberExpression',
                                                                                                computed: true,
                                                                                                object: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'source',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 101,
                                                                                                            column: 37,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 101,
                                                                                                            column: 43,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'key',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 101,
                                                                                                            column: 44,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 101,
                                                                                                            column: 47,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 101,
                                                                                                        column: 37,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 101,
                                                                                                        column: 48,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        }],
                                                                                    kind: 'let',
                                                                                    order: '3'
                                                                                },
                                                                                {
                                                                                    type: 'IfStatement',
                                                                                    test: {
                                                                                        type: 'BinaryExpression',
                                                                                        operator: '||',
                                                                                        left: {
                                                                                            type: 'UnaryExpression',
                                                                                            operator: '?',
                                                                                            argument: {
                                                                                                type: 'Identifier',
                                                                                                name: 'entity',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 102,
                                                                                                        column: 27,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 102,
                                                                                                        column: 33,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        right: {
                                                                                            type: 'Identifier',
                                                                                            name: 'showMissingEntities',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 102,
                                                                                                    column: 38,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 102,
                                                                                                    column: 57,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                }
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    consequent: {
                                                                                        type: 'BlockStatement',
                                                                                        body: [
                                                                                            {
                                                                                                type: 'VariableDeclaration',
                                                                                                declarations: [{
                                                                                                        type: 'VariableDeclarator',
                                                                                                        id: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'record',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 103,
                                                                                                                    column: 32,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 103,
                                                                                                                    column: 38,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        init: {
                                                                                                            type: 'ConditionalExpression',
                                                                                                            test: {
                                                                                                                type: 'UnaryExpression',
                                                                                                                operator: '?',
                                                                                                                argument: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'entity',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 103,
                                                                                                                            column: 41,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 103,
                                                                                                                            column: 47,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            consequent: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'entity',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 103,
                                                                                                                        column: 51,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 103,
                                                                                                                        column: 57,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            alternate: {
                                                                                                                type: 'CallExpression',
                                                                                                                callee: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'missingEntity',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 103,
                                                                                                                            column: 60,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 103,
                                                                                                                            column: 73,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                arguments: [{
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'key',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 103,
                                                                                                                                column: 74,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 103,
                                                                                                                                column: 77,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    }],
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 103,
                                                                                                                        column: 60,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 103,
                                                                                                                        column: 78,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            }
                                                                                                        }
                                                                                                    }],
                                                                                                kind: 'let',
                                                                                                order: '0'
                                                                                            },
                                                                                            {
                                                                                                type: 'ExpressionStatement',
                                                                                                expression: {
                                                                                                    type: 'ObjectExpression',
                                                                                                    objectType: {
                                                                                                        type: 'CallExpression',
                                                                                                        callee: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'RecordChip',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 104,
                                                                                                                    column: 28,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 104,
                                                                                                                    column: 38,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        arguments: [{
                                                                                                                type: 'ObjectExpression',
                                                                                                                properties: [
                                                                                                                    {
                                                                                                                        type: 'Property',
                                                                                                                        key: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'record',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 104,
                                                                                                                                    column: 40,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 104,
                                                                                                                                    column: 46,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        value: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'record',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 104,
                                                                                                                                    column: 40,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 104,
                                                                                                                                    column: 46,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        kind: 'init',
                                                                                                                        order: '0'
                                                                                                                    },
                                                                                                                    {
                                                                                                                        type: 'Property',
                                                                                                                        key: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'showRemove',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 104,
                                                                                                                                    column: 48,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 104,
                                                                                                                                    column: 58,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        value: {
                                                                                                                            type: 'Literal',
                                                                                                                            value: true
                                                                                                                        },
                                                                                                                        kind: 'init',
                                                                                                                        order: '1'
                                                                                                                    }
                                                                                                                ]
                                                                                                            }],
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 104,
                                                                                                                column: 28,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 104,
                                                                                                                column: 65,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    properties: [
                                                                                                        {
                                                                                                            type: 'Property',
                                                                                                            key: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'style',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 105,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 105,
                                                                                                                        column: 37,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            value: {
                                                                                                                type: 'ObjectExpression',
                                                                                                                properties: [
                                                                                                                    {
                                                                                                                        type: 'Property',
                                                                                                                        key: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'marginRight',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 106,
                                                                                                                                    column: 36,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 106,
                                                                                                                                    column: 47,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        value: {
                                                                                                                            type: 'Literal',
                                                                                                                            value: '4px'
                                                                                                                        },
                                                                                                                        kind: 'init',
                                                                                                                        order: '0'
                                                                                                                    },
                                                                                                                    {
                                                                                                                        type: 'Property',
                                                                                                                        key: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'marginBottom',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 107,
                                                                                                                                    column: 36,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 107,
                                                                                                                                    column: 48,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        value: {
                                                                                                                            type: 'Literal',
                                                                                                                            value: '4px'
                                                                                                                        },
                                                                                                                        kind: 'init',
                                                                                                                        order: '1'
                                                                                                                    }
                                                                                                                ]
                                                                                                            },
                                                                                                            kind: 'init',
                                                                                                            order: '0'
                                                                                                        },
                                                                                                        {
                                                                                                            type: 'ExpressionStatement',
                                                                                                            expression: {
                                                                                                                type: 'Function',
                                                                                                                context: true,
                                                                                                                value: function (_context11) {
                                                                                                                    return function remove(e) {
                                                                                                                        var removeRelation = _context11.get('removeRelation'), key = _context11.get('key'), dispatchChange = _context11.get('dispatchChange');
                                                                                                                        removeRelation(key);
                                                                                                                        dispatchChange();
                                                                                                                    };
                                                                                                                }
                                                                                                            },
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 108,
                                                                                                                    column: 32,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 112,
                                                                                                                    column: 36,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                                }
                                                                                                            },
                                                                                                            order: '1'
                                                                                                        }
                                                                                                    ]
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 104,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 112,
                                                                                                        column: 32,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/MultiRelationInput.ion'
                                                                                                    }
                                                                                                },
                                                                                                order: '1'
                                                                                            }
                                                                                        ]
                                                                                    },
                                                                                    alternate: null,
                                                                                    order: '4'
                                                                                }
                                                                            ]
                                                                        },
                                                                        remove: null,
                                                                        order: '1'
                                                                    }
                                                                ]
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 96,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                                },
                                                                end: {
                                                                    line: 112,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/MultiRelationInput.ion'
                                                                }
                                                            },
                                                            order: '1'
                                                        }
                                                    ]
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    },
                                    loc: {
                                        start: {
                                            line: 93,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/MultiRelationInput.ion'
                                        },
                                        end: {
                                            line: 112,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/material/MultiRelationInput.ion'
                                        }
                                    },
                                    order: '4'
                                }
                            ]
                        },
                        {
                            type: 'ObjectExpression',
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'valueJSON',
                                        loc: {
                                            start: {
                                                line: 74,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/MultiRelationInput.ion'
                                            },
                                            end: {
                                                line: 74,
                                                column: 26,
                                                fixed: true,
                                                source: 'glass/html/material/MultiRelationInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 75,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/MultiRelationInput.ion'
                                                        },
                                                        end: {
                                                            line: 75,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/MultiRelationInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context12) {
                                                        return function () {
                                                            var state = _context12.get('state'), input = _context12.get('input');
                                                            var value = {};
                                                            var hasValues = false;
                                                            {
                                                                var _ref4 = state.relations;
                                                                for (var _i = 0; _i < _ref4.length; _i++) {
                                                                    var _ref7 = _ref4[_i];
                                                                    var key = _ref7.key;
                                                                    var detail = _ref7.detail;
                                                                    hasValues = true;
                                                                    value[key] = detail;
                                                                }
                                                            }
                                                            var currentlySelectedKey = input.selectedItem != null ? input.selectedItem.key : void 0;
                                                            if (currentlySelectedKey != null) {
                                                                value[currentlySelectedKey] = {};
                                                            }
                                                            return value;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 85,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/MultiRelationInput.ion'
                                                        },
                                                        end: {
                                                            line: 85,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/MultiRelationInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context13) {
                                                        return function (value) {
                                                            var setRelations = _context13.get('setRelations');
                                                            return setRelations(value);
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'label',
                                        loc: {
                                            start: {
                                                line: 86,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/MultiRelationInput.ion'
                                            },
                                            end: {
                                                line: 86,
                                                column: 22,
                                                fixed: true,
                                                source: 'glass/html/material/MultiRelationInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 87,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/MultiRelationInput.ion'
                                                        },
                                                        end: {
                                                            line: 87,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/MultiRelationInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context14) {
                                                        return function () {
                                                            var input = _context14.get('input');
                                                            return input.label;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 88,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/MultiRelationInput.ion'
                                                        },
                                                        end: {
                                                            line: 88,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/MultiRelationInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context15) {
                                                        return function (value) {
                                                            var input = _context15.get('input');
                                                            return input.label = value;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '1'
                                }
                            ]
                        }
                    ]
                },
                order: '@'
            }
        ],
        bound: false
    }, {
        this: this,
        args: args,
        _ref: _ref,
        _ref2: _ref2,
        missingEntity: missingEntity,
        RelationInput: RelationInput,
        RecordChip: RecordChip,
        Schema: Schema,
        Key: Key
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/MultiRelationInput',_glass_html_material_MultiRelationInput_);
    else
      _glass_html_material_MultiRelationInput_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_MultiRelationInput_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_NewMenu_ = function(module,exports,require){'use strict';
var ion = require('ion');
if (!global.window) {
    return;
}
var _ref = require('../'), _ref2, _ref3, animationTime = 400;
var style = _ref.style;
var show = _ref.functions.show;
_ref2 = style;
var rgba = _ref2.rgba;
_ref3 = require('./');
var Icon = _ref3.Icon;
ion.template(function () {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [{
                type: 'ExpressionStatement',
                expression: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'MemberExpression',
                        computed: false,
                        object: {
                            type: 'Identifier',
                            name: 'style',
                            loc: {
                                start: {
                                    line: 12,
                                    column: 4,
                                    fixed: true,
                                    source: 'glass/html/material/NewMenu.ion'
                                },
                                end: {
                                    line: 12,
                                    column: 9,
                                    fixed: true,
                                    source: 'glass/html/material/NewMenu.ion'
                                }
                            }
                        },
                        property: {
                            type: 'Identifier',
                            name: 'sheets',
                            loc: {
                                start: {
                                    line: 12,
                                    column: 10,
                                    fixed: true,
                                    source: 'glass/html/material/NewMenu.ion'
                                },
                                end: {
                                    line: 12,
                                    column: 16,
                                    fixed: true,
                                    source: 'glass/html/material/NewMenu.ion'
                                }
                            }
                        },
                        loc: {
                            start: {
                                line: 12,
                                column: 4,
                                fixed: true,
                                source: 'glass/html/material/NewMenu.ion'
                            },
                            end: {
                                line: 12,
                                column: 16,
                                fixed: true,
                                source: 'glass/html/material/NewMenu.ion'
                            }
                        }
                    },
                    properties: [{
                            type: 'Property',
                            key: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'module',
                                    loc: {
                                        start: {
                                            line: 13,
                                            column: 9,
                                            fixed: true,
                                            source: 'glass/html/material/NewMenu.ion'
                                        },
                                        end: {
                                            line: 13,
                                            column: 15,
                                            fixed: true,
                                            source: 'glass/html/material/NewMenu.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'id',
                                    loc: {
                                        start: {
                                            line: 13,
                                            column: 16,
                                            fixed: true,
                                            source: 'glass/html/material/NewMenu.ion'
                                        },
                                        end: {
                                            line: 13,
                                            column: 18,
                                            fixed: true,
                                            source: 'glass/html/material/NewMenu.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 13,
                                        column: 9,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    },
                                    end: {
                                        line: 13,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'BinaryExpression',
                                operator: '+',
                                left: {
                                    type: 'BinaryExpression',
                                    operator: '+',
                                    left: {
                                        type: 'BinaryExpression',
                                        operator: '+',
                                        left: {
                                            type: 'BinaryExpression',
                                            operator: '+',
                                            left: {
                                                type: 'BinaryExpression',
                                                operator: '+',
                                                left: {
                                                    type: 'BinaryExpression',
                                                    operator: '+',
                                                    left: {
                                                        type: 'BinaryExpression',
                                                        operator: '+',
                                                        left: {
                                                            type: 'BinaryExpression',
                                                            operator: '+',
                                                            left: {
                                                                type: 'BinaryExpression',
                                                                operator: '+',
                                                                left: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '+',
                                                                    left: {
                                                                        type: 'BinaryExpression',
                                                                        operator: '+',
                                                                        left: {
                                                                            type: 'BinaryExpression',
                                                                            operator: '+',
                                                                            left: {
                                                                                type: 'BinaryExpression',
                                                                                operator: '+',
                                                                                left: {
                                                                                    type: 'BinaryExpression',
                                                                                    operator: '+',
                                                                                    left: {
                                                                                        type: 'BinaryExpression',
                                                                                        operator: '+',
                                                                                        left: {
                                                                                            type: 'BinaryExpression',
                                                                                            operator: '+',
                                                                                            left: {
                                                                                                type: 'Literal',
                                                                                                value: '.NewMenu {\n    overflow: auto;\n    padding: 8px 0px;\n    margin: 0px;\n    background-color: '
                                                                                            },
                                                                                            right: {
                                                                                                type: 'MemberExpression',
                                                                                                computed: false,
                                                                                                object: {
                                                                                                    type: 'MemberExpression',
                                                                                                    computed: false,
                                                                                                    object: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'style',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 18,
                                                                                                                column: 36,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 18,
                                                                                                                column: 41,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    property: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'color',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 18,
                                                                                                                column: 42,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 18,
                                                                                                                column: 47,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 18,
                                                                                                            column: 36,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/NewMenu.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 18,
                                                                                                            column: 47,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/NewMenu.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'white',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 18,
                                                                                                            column: 48,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/NewMenu.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 18,
                                                                                                            column: 53,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/NewMenu.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 18,
                                                                                                        column: 36,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/NewMenu.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 18,
                                                                                                        column: 53,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/NewMenu.ion'
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        right: {
                                                                                            type: 'Literal',
                                                                                            value: ';\n    flex-direction: column;\n    min-width: 112px;\n    cursor: default;\n    transition:\n        max-height '
                                                                                        }
                                                                                    },
                                                                                    right: {
                                                                                        type: 'Identifier',
                                                                                        name: 'animationTime',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 23,
                                                                                                column: 33,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 23,
                                                                                                column: 46,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                },
                                                                                right: {
                                                                                    type: 'Literal',
                                                                                    value: 'ms cubic-bezier(0.77, 0, 0.175, 1),\n        padding '
                                                                                }
                                                                            },
                                                                            right: {
                                                                                type: 'Identifier',
                                                                                name: 'animationTime',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 24,
                                                                                        column: 30,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/NewMenu.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 24,
                                                                                        column: 43,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/NewMenu.ion'
                                                                                    }
                                                                                }
                                                                            }
                                                                        },
                                                                        right: {
                                                                            type: 'Literal',
                                                                            value: 'ms cubic-bezier(0.77, 0, 0.175, 1),\n        transform '
                                                                        }
                                                                    },
                                                                    right: {
                                                                        type: 'Identifier',
                                                                        name: 'animationTime',
                                                                        loc: {
                                                                            start: {
                                                                                line: 25,
                                                                                column: 32,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                            },
                                                                            end: {
                                                                                line: 25,
                                                                                column: 45,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                            }
                                                                        }
                                                                    }
                                                                },
                                                                right: {
                                                                    type: 'Literal',
                                                                    value: 'ms cubic-bezier(0.77, 0, 0.175, 1);\n    display: flex;\n    outline: none;\n}\n.NewMenu .NewMenu {\n    overflow: hidden;\n    max-height: initial;\n}\n.NewMenu.float {\n    position: absolute;\n    display: initial;\n    max-height: 90vh;\n}\n.NewMenu .NewMenu\n{\n    padding: 0px;\n}\n.NewMenu:not(.open) {\n    max-height: 0px;\n    padding: 0px;\n}\n.NewMenu .Icon {\n    transition:\n        transform '
                                                                }
                                                            },
                                                            right: {
                                                                type: 'Identifier',
                                                                name: 'animationTime',
                                                                loc: {
                                                                    start: {
                                                                        line: 48,
                                                                        column: 32,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/NewMenu.ion'
                                                                    },
                                                                    end: {
                                                                        line: 48,
                                                                        column: 45,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/NewMenu.ion'
                                                                    }
                                                                }
                                                            }
                                                        },
                                                        right: {
                                                            type: 'Literal',
                                                            value: 'ms cubic-bezier(0.77, 0, 0.175, 1);\n}\n.MenuItem {\n    display: flex;\n    flex-direction: column;\n    outline: none;\n}\n.MenuItem A {\n    color: inherit;\n    text-decoration: none;\n}\n.MenuItem > .content {\n    white-space: nowrap;\n    display: flex;\n    flex-direction: row;\n    align-items: center;\n    cursor: default;\n    padding: 0px 24px;\n    height: 48px;\n}\n.MenuItem > .content > .Icon.left {\n    margin: 0px 16px 0px 0px;\n}\n.MenuItem > .content:hover {\n    background-color: '
                                                        }
                                                    },
                                                    right: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'Identifier',
                                                            name: 'rgba',
                                                            loc: {
                                                                start: {
                                                                    line: 72,
                                                                    column: 37,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/NewMenu.ion'
                                                                },
                                                                end: {
                                                                    line: 72,
                                                                    column: 41,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/NewMenu.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [
                                                            {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'style',
                                                                        loc: {
                                                                            start: {
                                                                                line: 72,
                                                                                column: 42,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                            },
                                                                            end: {
                                                                                line: 72,
                                                                                column: 47,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'color',
                                                                        loc: {
                                                                            start: {
                                                                                line: 72,
                                                                                column: 48,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                            },
                                                                            end: {
                                                                                line: 72,
                                                                                column: 53,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 72,
                                                                            column: 42,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/NewMenu.ion'
                                                                        },
                                                                        end: {
                                                                            line: 72,
                                                                            column: 53,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/NewMenu.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'black',
                                                                    loc: {
                                                                        start: {
                                                                            line: 72,
                                                                            column: 54,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/NewMenu.ion'
                                                                        },
                                                                        end: {
                                                                            line: 72,
                                                                            column: 59,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/NewMenu.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 72,
                                                                        column: 42,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/NewMenu.ion'
                                                                    },
                                                                    end: {
                                                                        line: 72,
                                                                        column: 59,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/NewMenu.ion'
                                                                    }
                                                                }
                                                            },
                                                            {
                                                                type: 'BinaryExpression',
                                                                operator: '/',
                                                                left: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'style',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 72,
                                                                                    column: 61,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/NewMenu.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 72,
                                                                                    column: 66,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/NewMenu.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'opacity',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 72,
                                                                                    column: 67,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/NewMenu.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 72,
                                                                                    column: 74,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/NewMenu.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 72,
                                                                                column: 61,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                            },
                                                                            end: {
                                                                                line: 72,
                                                                                column: 74,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'divider',
                                                                        loc: {
                                                                            start: {
                                                                                line: 72,
                                                                                column: 75,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                            },
                                                                            end: {
                                                                                line: 72,
                                                                                column: 82,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 72,
                                                                            column: 61,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/NewMenu.ion'
                                                                        },
                                                                        end: {
                                                                            line: 72,
                                                                            column: 82,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/NewMenu.ion'
                                                                        }
                                                                    }
                                                                },
                                                                right: {
                                                                    type: 'Literal',
                                                                    value: 2
                                                                }
                                                            }
                                                        ],
                                                        loc: {
                                                            start: {
                                                                line: 72,
                                                                column: 37,
                                                                fixed: true,
                                                                source: 'glass/html/material/NewMenu.ion'
                                                            },
                                                            end: {
                                                                line: 72,
                                                                column: 87,
                                                                fixed: true,
                                                                source: 'glass/html/material/NewMenu.ion'
                                                            }
                                                        }
                                                    }
                                                },
                                                right: {
                                                    type: 'Literal',
                                                    value: ';\n}\n.MenuItem:focus > .content {\n    background-color: '
                                                }
                                            },
                                            right: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'rgba',
                                                    loc: {
                                                        start: {
                                                            line: 75,
                                                            column: 37,
                                                            fixed: true,
                                                            source: 'glass/html/material/NewMenu.ion'
                                                        },
                                                        end: {
                                                            line: 75,
                                                            column: 41,
                                                            fixed: true,
                                                            source: 'glass/html/material/NewMenu.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [
                                                    {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'style',
                                                                loc: {
                                                                    start: {
                                                                        line: 75,
                                                                        column: 42,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/NewMenu.ion'
                                                                    },
                                                                    end: {
                                                                        line: 75,
                                                                        column: 47,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/NewMenu.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'color',
                                                                loc: {
                                                                    start: {
                                                                        line: 75,
                                                                        column: 48,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/NewMenu.ion'
                                                                    },
                                                                    end: {
                                                                        line: 75,
                                                                        column: 53,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/NewMenu.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 75,
                                                                    column: 42,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/NewMenu.ion'
                                                                },
                                                                end: {
                                                                    line: 75,
                                                                    column: 53,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/NewMenu.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'black',
                                                            loc: {
                                                                start: {
                                                                    line: 75,
                                                                    column: 54,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/NewMenu.ion'
                                                                },
                                                                end: {
                                                                    line: 75,
                                                                    column: 59,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/NewMenu.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 75,
                                                                column: 42,
                                                                fixed: true,
                                                                source: 'glass/html/material/NewMenu.ion'
                                                            },
                                                            end: {
                                                                line: 75,
                                                                column: 59,
                                                                fixed: true,
                                                                source: 'glass/html/material/NewMenu.ion'
                                                            }
                                                        }
                                                    },
                                                    {
                                                        type: 'BinaryExpression',
                                                        operator: '/',
                                                        left: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'style',
                                                                    loc: {
                                                                        start: {
                                                                            line: 75,
                                                                            column: 61,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/NewMenu.ion'
                                                                        },
                                                                        end: {
                                                                            line: 75,
                                                                            column: 66,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/NewMenu.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'opacity',
                                                                    loc: {
                                                                        start: {
                                                                            line: 75,
                                                                            column: 67,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/NewMenu.ion'
                                                                        },
                                                                        end: {
                                                                            line: 75,
                                                                            column: 74,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/NewMenu.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 75,
                                                                        column: 61,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/NewMenu.ion'
                                                                    },
                                                                    end: {
                                                                        line: 75,
                                                                        column: 74,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/NewMenu.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'divider',
                                                                loc: {
                                                                    start: {
                                                                        line: 75,
                                                                        column: 75,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/NewMenu.ion'
                                                                    },
                                                                    end: {
                                                                        line: 75,
                                                                        column: 82,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/NewMenu.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 75,
                                                                    column: 61,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/NewMenu.ion'
                                                                },
                                                                end: {
                                                                    line: 75,
                                                                    column: 82,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/NewMenu.ion'
                                                                }
                                                            }
                                                        },
                                                        right: {
                                                            type: 'Literal',
                                                            value: 2
                                                        }
                                                    }
                                                ],
                                                loc: {
                                                    start: {
                                                        line: 75,
                                                        column: 37,
                                                        fixed: true,
                                                        source: 'glass/html/material/NewMenu.ion'
                                                    },
                                                    end: {
                                                        line: 75,
                                                        column: 87,
                                                        fixed: true,
                                                        source: 'glass/html/material/NewMenu.ion'
                                                    }
                                                }
                                            }
                                        },
                                        right: {
                                            type: 'Literal',
                                            value: ';\n}\n.MenuDivider {\n    height: 1px;\n    margin: 8px 0px;\n    background-color: '
                                        }
                                    },
                                    right: {
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'Identifier',
                                            name: 'rgba',
                                            loc: {
                                                start: {
                                                    line: 80,
                                                    column: 37,
                                                    fixed: true,
                                                    source: 'glass/html/material/NewMenu.ion'
                                                },
                                                end: {
                                                    line: 80,
                                                    column: 41,
                                                    fixed: true,
                                                    source: 'glass/html/material/NewMenu.ion'
                                                }
                                            }
                                        },
                                        arguments: [
                                            {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'style',
                                                        loc: {
                                                            start: {
                                                                line: 80,
                                                                column: 42,
                                                                fixed: true,
                                                                source: 'glass/html/material/NewMenu.ion'
                                                            },
                                                            end: {
                                                                line: 80,
                                                                column: 47,
                                                                fixed: true,
                                                                source: 'glass/html/material/NewMenu.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'color',
                                                        loc: {
                                                            start: {
                                                                line: 80,
                                                                column: 48,
                                                                fixed: true,
                                                                source: 'glass/html/material/NewMenu.ion'
                                                            },
                                                            end: {
                                                                line: 80,
                                                                column: 53,
                                                                fixed: true,
                                                                source: 'glass/html/material/NewMenu.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 80,
                                                            column: 42,
                                                            fixed: true,
                                                            source: 'glass/html/material/NewMenu.ion'
                                                        },
                                                        end: {
                                                            line: 80,
                                                            column: 53,
                                                            fixed: true,
                                                            source: 'glass/html/material/NewMenu.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'black',
                                                    loc: {
                                                        start: {
                                                            line: 80,
                                                            column: 54,
                                                            fixed: true,
                                                            source: 'glass/html/material/NewMenu.ion'
                                                        },
                                                        end: {
                                                            line: 80,
                                                            column: 59,
                                                            fixed: true,
                                                            source: 'glass/html/material/NewMenu.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 80,
                                                        column: 42,
                                                        fixed: true,
                                                        source: 'glass/html/material/NewMenu.ion'
                                                    },
                                                    end: {
                                                        line: 80,
                                                        column: 59,
                                                        fixed: true,
                                                        source: 'glass/html/material/NewMenu.ion'
                                                    }
                                                }
                                            },
                                            {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'style',
                                                        loc: {
                                                            start: {
                                                                line: 80,
                                                                column: 61,
                                                                fixed: true,
                                                                source: 'glass/html/material/NewMenu.ion'
                                                            },
                                                            end: {
                                                                line: 80,
                                                                column: 66,
                                                                fixed: true,
                                                                source: 'glass/html/material/NewMenu.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'opacity',
                                                        loc: {
                                                            start: {
                                                                line: 80,
                                                                column: 67,
                                                                fixed: true,
                                                                source: 'glass/html/material/NewMenu.ion'
                                                            },
                                                            end: {
                                                                line: 80,
                                                                column: 74,
                                                                fixed: true,
                                                                source: 'glass/html/material/NewMenu.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 80,
                                                            column: 61,
                                                            fixed: true,
                                                            source: 'glass/html/material/NewMenu.ion'
                                                        },
                                                        end: {
                                                            line: 80,
                                                            column: 74,
                                                            fixed: true,
                                                            source: 'glass/html/material/NewMenu.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'divider',
                                                    loc: {
                                                        start: {
                                                            line: 80,
                                                            column: 75,
                                                            fixed: true,
                                                            source: 'glass/html/material/NewMenu.ion'
                                                        },
                                                        end: {
                                                            line: 80,
                                                            column: 82,
                                                            fixed: true,
                                                            source: 'glass/html/material/NewMenu.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 80,
                                                        column: 61,
                                                        fixed: true,
                                                        source: 'glass/html/material/NewMenu.ion'
                                                    },
                                                    end: {
                                                        line: 80,
                                                        column: 82,
                                                        fixed: true,
                                                        source: 'glass/html/material/NewMenu.ion'
                                                    }
                                                }
                                            }
                                        ],
                                        loc: {
                                            start: {
                                                line: 80,
                                                column: 37,
                                                fixed: true,
                                                source: 'glass/html/material/NewMenu.ion'
                                            },
                                            end: {
                                                line: 80,
                                                column: 83,
                                                fixed: true,
                                                source: 'glass/html/material/NewMenu.ion'
                                            }
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: ';\n}'
                                }
                            },
                            kind: 'init',
                            computed: true,
                            order: '0'
                        }]
                },
                loc: {
                    start: {
                        line: 12,
                        column: 4,
                        fixed: true,
                        source: 'glass/html/material/NewMenu.ion'
                    },
                    end: {
                        line: 83,
                        column: 8,
                        fixed: true,
                        source: 'glass/html/material/NewMenu.ion'
                    }
                },
                order: '0'
            }],
        bound: false
    }, {
        this: this,
        module: module,
        _ref: _ref,
        _ref2: _ref2,
        _ref3: _ref3,
        animationTime: animationTime,
        style: style,
        show: show,
        rgba: rgba,
        Icon: Icon,
        MenuItem: MenuItem,
        MenuDivider: MenuDivider,
        Menu: Menu
    }, null);
})().observe();
var MenuItem = ion.template(function (args) {
        return ion.createRuntime({
            type: 'Template',
            id: null,
            body: [
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: '_ref4'
                            },
                            init: {
                                type: 'Identifier',
                                name: 'args',
                                loc: {
                                    start: {
                                        line: 84,
                                        column: 86,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    },
                                    end: {
                                        line: 84,
                                        column: 90,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '0'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'image',
                                loc: {
                                    start: {
                                        line: 84,
                                        column: 9,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    },
                                    end: {
                                        line: 84,
                                        column: 14,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref4'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'image',
                                    loc: {
                                        start: {
                                            line: 84,
                                            column: 9,
                                            fixed: true,
                                            source: 'glass/html/material/NewMenu.ion'
                                        },
                                        end: {
                                            line: 84,
                                            column: 14,
                                            fixed: true,
                                            source: 'glass/html/material/NewMenu.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '1'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'icon',
                                loc: {
                                    start: {
                                        line: 84,
                                        column: 16,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    },
                                    end: {
                                        line: 84,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref4'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'icon',
                                    loc: {
                                        start: {
                                            line: 84,
                                            column: 16,
                                            fixed: true,
                                            source: 'glass/html/material/NewMenu.ion'
                                        },
                                        end: {
                                            line: 84,
                                            column: 20,
                                            fixed: true,
                                            source: 'glass/html/material/NewMenu.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '2'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'selected',
                                loc: {
                                    start: {
                                        line: 84,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    },
                                    end: {
                                        line: 84,
                                        column: 30,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref4'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'selected',
                                    loc: {
                                        start: {
                                            line: 84,
                                            column: 22,
                                            fixed: true,
                                            source: 'glass/html/material/NewMenu.ion'
                                        },
                                        end: {
                                            line: 84,
                                            column: 30,
                                            fixed: true,
                                            source: 'glass/html/material/NewMenu.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '3'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'name',
                                loc: {
                                    start: {
                                        line: 84,
                                        column: 32,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    },
                                    end: {
                                        line: 84,
                                        column: 36,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref4'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'name',
                                    loc: {
                                        start: {
                                            line: 84,
                                            column: 32,
                                            fixed: true,
                                            source: 'glass/html/material/NewMenu.ion'
                                        },
                                        end: {
                                            line: 84,
                                            column: 36,
                                            fixed: true,
                                            source: 'glass/html/material/NewMenu.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '4'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'action',
                                loc: {
                                    start: {
                                        line: 84,
                                        column: 38,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    },
                                    end: {
                                        line: 84,
                                        column: 44,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref4'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'action',
                                    loc: {
                                        start: {
                                            line: 84,
                                            column: 38,
                                            fixed: true,
                                            source: 'glass/html/material/NewMenu.ion'
                                        },
                                        end: {
                                            line: 84,
                                            column: 44,
                                            fixed: true,
                                            source: 'glass/html/material/NewMenu.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '5'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'link',
                                loc: {
                                    start: {
                                        line: 84,
                                        column: 46,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    },
                                    end: {
                                        line: 84,
                                        column: 50,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref4'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'link',
                                    loc: {
                                        start: {
                                            line: 84,
                                            column: 46,
                                            fixed: true,
                                            source: 'glass/html/material/NewMenu.ion'
                                        },
                                        end: {
                                            line: 84,
                                            column: 50,
                                            fixed: true,
                                            source: 'glass/html/material/NewMenu.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '6'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'target',
                                loc: {
                                    start: {
                                        line: 84,
                                        column: 52,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    },
                                    end: {
                                        line: 84,
                                        column: 58,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref4'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'target',
                                    loc: {
                                        start: {
                                            line: 84,
                                            column: 52,
                                            fixed: true,
                                            source: 'glass/html/material/NewMenu.ion'
                                        },
                                        end: {
                                            line: 84,
                                            column: 58,
                                            fixed: true,
                                            source: 'glass/html/material/NewMenu.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '7'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'open',
                                loc: {
                                    start: {
                                        line: 84,
                                        column: 60,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    },
                                    end: {
                                        line: 84,
                                        column: 64,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref4'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'open',
                                    loc: {
                                        start: {
                                            line: 84,
                                            column: 60,
                                            fixed: true,
                                            source: 'glass/html/material/NewMenu.ion'
                                        },
                                        end: {
                                            line: 84,
                                            column: 64,
                                            fixed: true,
                                            source: 'glass/html/material/NewMenu.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '8'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'items',
                                loc: {
                                    start: {
                                        line: 84,
                                        column: 66,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    },
                                    end: {
                                        line: 84,
                                        column: 71,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref4'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'items',
                                    loc: {
                                        start: {
                                            line: 84,
                                            column: 66,
                                            fixed: true,
                                            source: 'glass/html/material/NewMenu.ion'
                                        },
                                        end: {
                                            line: 84,
                                            column: 71,
                                            fixed: true,
                                            source: 'glass/html/material/NewMenu.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '9'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'autoclose',
                                loc: {
                                    start: {
                                        line: 84,
                                        column: 73,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    },
                                    end: {
                                        line: 84,
                                        column: 82,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref4'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'autoclose',
                                    loc: {
                                        start: {
                                            line: 84,
                                            column: 73,
                                            fixed: true,
                                            source: 'glass/html/material/NewMenu.ion'
                                        },
                                        end: {
                                            line: 84,
                                            column: 82,
                                            fixed: true,
                                            source: 'glass/html/material/NewMenu.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: ':'
                },
                {
                    type: 'IfStatement',
                    test: {
                        type: 'UnaryExpression',
                        operator: '?',
                        argument: {
                            type: 'Identifier',
                            name: 'items',
                            loc: {
                                start: {
                                    line: 85,
                                    column: 7,
                                    fixed: true,
                                    source: 'glass/html/material/NewMenu.ion'
                                },
                                end: {
                                    line: 85,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/NewMenu.ion'
                                }
                            }
                        }
                    },
                    consequent: {
                        type: 'BlockStatement',
                        body: [{
                                type: 'ExpressionStatement',
                                expression: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context) {
                                            return function () {
                                                var args = _context.get('args');
                                                return args.open = args.open != null ? args.open : false;
                                            };
                                        }
                                    },
                                    arguments: [],
                                    loc: {
                                        start: {
                                            line: 86,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/NewMenu.ion'
                                        },
                                        end: {
                                            line: 86,
                                            column: 32,
                                            fixed: true,
                                            source: 'glass/html/material/NewMenu.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 86,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    },
                                    end: {
                                        line: 86,
                                        column: 32,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    }
                                },
                                order: '0'
                            }]
                    },
                    alternate: null,
                    order: ';'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'select',
                                loc: {
                                    start: {
                                        line: 87,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    },
                                    end: {
                                        line: 87,
                                        column: 14,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'Function',
                                context: true,
                                value: function (_context2) {
                                    return function (e) {
                                        var action = _context2.get('action'), autoclose = _context2.get('autoclose');
                                        action != null ? action(e) : void 0;
                                        if (autoclose) {
                                            this.dispatchEvent(new CustomEvent('close', { bubbles: true }));
                                        }
                                    };
                                }
                            }
                        }],
                    kind: 'let',
                    order: '<'
                },
                {
                    type: 'ReturnStatement',
                    argument: {
                        type: 'ObjectExpression',
                        objectType: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Div',
                                loc: {
                                    start: {
                                        line: 91,
                                        column: 11,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    },
                                    end: {
                                        line: 91,
                                        column: 14,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ObjectExpression',
                                    properties: [{
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'tabindex',
                                                loc: {
                                                    start: {
                                                        line: 91,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'glass/html/material/NewMenu.ion'
                                                    },
                                                    end: {
                                                        line: 91,
                                                        column: 24,
                                                        fixed: true,
                                                        source: 'glass/html/material/NewMenu.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'UnaryExpression',
                                                operator: '-',
                                                argument: {
                                                    type: 'Literal',
                                                    value: 1
                                                }
                                            },
                                            kind: 'init',
                                            order: '0'
                                        }]
                                }],
                            loc: {
                                start: {
                                    line: 91,
                                    column: 11,
                                    fixed: true,
                                    source: 'glass/html/material/NewMenu.ion'
                                },
                                end: {
                                    line: 91,
                                    column: 29,
                                    fixed: true,
                                    source: 'glass/html/material/NewMenu.ion'
                                }
                            }
                        },
                        properties: [
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'select',
                                    loc: {
                                        start: {
                                            line: 92,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/NewMenu.ion'
                                        },
                                        end: {
                                            line: 92,
                                            column: 14,
                                            fixed: true,
                                            source: 'glass/html/material/NewMenu.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'Identifier',
                                    name: 'select',
                                    loc: {
                                        start: {
                                            line: 92,
                                            column: 16,
                                            fixed: true,
                                            source: 'glass/html/material/NewMenu.ion'
                                        },
                                        end: {
                                            line: 92,
                                            column: 22,
                                            fixed: true,
                                            source: 'glass/html/material/NewMenu.ion'
                                        }
                                    }
                                },
                                kind: 'init',
                                order: '0'
                            },
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'classList',
                                    loc: {
                                        start: {
                                            line: 93,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/NewMenu.ion'
                                        },
                                        end: {
                                            line: 93,
                                            column: 17,
                                            fixed: true,
                                            source: 'glass/html/material/NewMenu.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'ObjectExpression',
                                    properties: [{
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'Literal',
                                                value: 'MenuItem'
                                            },
                                            loc: {
                                                start: {
                                                    line: 94,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/NewMenu.ion'
                                                },
                                                end: {
                                                    line: 94,
                                                    column: 22,
                                                    fixed: true,
                                                    source: 'glass/html/material/NewMenu.ion'
                                                }
                                            },
                                            order: '0'
                                        }]
                                },
                                kind: 'init',
                                order: '1'
                            },
                            {
                                type: 'ExpressionStatement',
                                expression: {
                                    type: 'ObjectExpression',
                                    objectType: {
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'Identifier',
                                            name: 'A',
                                            loc: {
                                                start: {
                                                    line: 95,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'glass/html/material/NewMenu.ion'
                                                },
                                                end: {
                                                    line: 95,
                                                    column: 9,
                                                    fixed: true,
                                                    source: 'glass/html/material/NewMenu.ion'
                                                }
                                            }
                                        },
                                        arguments: [{
                                                type: 'ObjectExpression',
                                                properties: [{
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'class',
                                                            loc: {
                                                                start: {
                                                                    line: 95,
                                                                    column: 11,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/NewMenu.ion'
                                                                },
                                                                end: {
                                                                    line: 95,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/NewMenu.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Literal',
                                                            value: 'content flex'
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    }]
                                            }],
                                        loc: {
                                            start: {
                                                line: 95,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/NewMenu.ion'
                                            },
                                            end: {
                                                line: 95,
                                                column: 33,
                                                fixed: true,
                                                source: 'glass/html/material/NewMenu.ion'
                                            }
                                        }
                                    },
                                    properties: [
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'Function',
                                                context: true,
                                                value: function (_context3) {
                                                    return function click(e) {
                                                        var select = _context3.get('select');
                                                        return select(e);
                                                    };
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 96,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/NewMenu.ion'
                                                },
                                                end: {
                                                    line: 96,
                                                    column: 33,
                                                    fixed: true,
                                                    source: 'glass/html/material/NewMenu.ion'
                                                }
                                            },
                                            order: '0'
                                        },
                                        {
                                            type: 'IfStatement',
                                            test: {
                                                type: 'UnaryExpression',
                                                operator: '?',
                                                argument: {
                                                    type: 'Identifier',
                                                    name: 'link',
                                                    loc: {
                                                        start: {
                                                            line: 97,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/NewMenu.ion'
                                                        },
                                                        end: {
                                                            line: 97,
                                                            column: 19,
                                                            fixed: true,
                                                            source: 'glass/html/material/NewMenu.ion'
                                                        }
                                                    }
                                                }
                                            },
                                            consequent: {
                                                type: 'BlockStatement',
                                                body: [
                                                    {
                                                        type: 'IfStatement',
                                                        test: {
                                                            type: 'BinaryExpression',
                                                            operator: '===',
                                                            left: {
                                                                type: 'UnaryExpression',
                                                                operator: 'typeof',
                                                                argument: {
                                                                    type: 'Identifier',
                                                                    name: 'link',
                                                                    loc: {
                                                                        start: {
                                                                            line: 98,
                                                                            column: 26,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/NewMenu.ion'
                                                                        },
                                                                        end: {
                                                                            line: 98,
                                                                            column: 30,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/NewMenu.ion'
                                                                        }
                                                                    }
                                                                }
                                                            },
                                                            right: {
                                                                type: 'Literal',
                                                                value: 'string'
                                                            }
                                                        },
                                                        consequent: {
                                                            type: 'BlockStatement',
                                                            body: [{
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'href',
                                                                        loc: {
                                                                            start: {
                                                                                line: 99,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                            },
                                                                            end: {
                                                                                line: 99,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Identifier',
                                                                        name: 'link',
                                                                        loc: {
                                                                            start: {
                                                                                line: 99,
                                                                                column: 26,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                            },
                                                                            end: {
                                                                                line: 99,
                                                                                column: 30,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                }]
                                                        },
                                                        alternate: {
                                                            type: 'BlockStatement',
                                                            body: [
                                                                {
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'href',
                                                                        loc: {
                                                                            start: {
                                                                                line: 101,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                            },
                                                                            end: {
                                                                                line: 101,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'Identifier',
                                                                                    name: 'global',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 101,
                                                                                            column: 26,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/NewMenu.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 101,
                                                                                            column: 32,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/NewMenu.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'model',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 101,
                                                                                            column: 33,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/NewMenu.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 101,
                                                                                            column: 38,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/NewMenu.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 101,
                                                                                        column: 26,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/NewMenu.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 101,
                                                                                        column: 38,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/NewMenu.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'getLinkUrl',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 101,
                                                                                        column: 39,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/NewMenu.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 101,
                                                                                        column: 49,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/NewMenu.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 101,
                                                                                    column: 26,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/NewMenu.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 101,
                                                                                    column: 49,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/NewMenu.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [{
                                                                                type: 'Identifier',
                                                                                name: 'link',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 101,
                                                                                        column: 50,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/NewMenu.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 101,
                                                                                        column: 54,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/NewMenu.ion'
                                                                                    }
                                                                                }
                                                                            }],
                                                                        loc: {
                                                                            start: {
                                                                                line: 101,
                                                                                column: 26,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                            },
                                                                            end: {
                                                                                line: 101,
                                                                                column: 55,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                },
                                                                {
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'Function',
                                                                        context: true,
                                                                        value: function (_context4) {
                                                                            return function click(e) {
                                                                                var select = _context4.get('select'), link = _context4.get('link');
                                                                                select(e);
                                                                                global.model.open(link);
                                                                            };
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 102,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/NewMenu.ion'
                                                                        },
                                                                        end: {
                                                                            line: 105,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/NewMenu.ion'
                                                                        }
                                                                    },
                                                                    order: '1'
                                                                }
                                                            ]
                                                        },
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'IfStatement',
                                                        test: {
                                                            type: 'UnaryExpression',
                                                            operator: '?',
                                                            argument: {
                                                                type: 'Identifier',
                                                                name: 'target',
                                                                loc: {
                                                                    start: {
                                                                        line: 105,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/NewMenu.ion'
                                                                    },
                                                                    end: {
                                                                        line: 105,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/NewMenu.ion'
                                                                    }
                                                                }
                                                            }
                                                        },
                                                        consequent: {
                                                            type: 'BlockStatement',
                                                            body: [{
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'target',
                                                                        loc: {
                                                                            start: {
                                                                                line: 106,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                            },
                                                                            end: {
                                                                                line: 106,
                                                                                column: 26,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Identifier',
                                                                        name: 'target',
                                                                        loc: {
                                                                            start: {
                                                                                line: 106,
                                                                                column: 28,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                            },
                                                                            end: {
                                                                                line: 106,
                                                                                column: 34,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                }]
                                                        },
                                                        alternate: null,
                                                        order: '1'
                                                    }
                                                ]
                                            },
                                            alternate: null,
                                            order: '1'
                                        },
                                        {
                                            type: 'IfStatement',
                                            test: {
                                                type: 'BinaryExpression',
                                                operator: '||',
                                                left: {
                                                    type: 'BinaryExpression',
                                                    operator: '===',
                                                    left: {
                                                        type: 'UnaryExpression',
                                                        operator: 'typeof',
                                                        argument: {
                                                            type: 'Identifier',
                                                            name: 'image',
                                                            loc: {
                                                                start: {
                                                                    line: 107,
                                                                    column: 22,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/NewMenu.ion'
                                                                },
                                                                end: {
                                                                    line: 107,
                                                                    column: 27,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/NewMenu.ion'
                                                                }
                                                            }
                                                        }
                                                    },
                                                    right: {
                                                        type: 'Literal',
                                                        value: 'string'
                                                    }
                                                },
                                                right: {
                                                    type: 'BinaryExpression',
                                                    operator: '===',
                                                    left: {
                                                        type: 'UnaryExpression',
                                                        operator: 'typeof',
                                                        argument: {
                                                            type: 'Identifier',
                                                            name: 'icon',
                                                            loc: {
                                                                start: {
                                                                    line: 107,
                                                                    column: 50,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/NewMenu.ion'
                                                                },
                                                                end: {
                                                                    line: 107,
                                                                    column: 54,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/NewMenu.ion'
                                                                }
                                                            }
                                                        }
                                                    },
                                                    right: {
                                                        type: 'Literal',
                                                        value: 'string'
                                                    }
                                                }
                                            },
                                            consequent: {
                                                type: 'BlockStatement',
                                                body: [{
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'ObjectExpression',
                                                            objectType: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Identifier',
                                                                    name: 'Icon',
                                                                    loc: {
                                                                        start: {
                                                                            line: 108,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/NewMenu.ion'
                                                                        },
                                                                        end: {
                                                                            line: 108,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/NewMenu.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'ObjectExpression',
                                                                        properties: [
                                                                            {
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'url',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 108,
                                                                                            column: 22,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/NewMenu.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 108,
                                                                                            column: 25,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/NewMenu.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Identifier',
                                                                                    name: 'image',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 108,
                                                                                            column: 26,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/NewMenu.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 108,
                                                                                            column: 31,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/NewMenu.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                kind: 'init',
                                                                                order: '0'
                                                                            },
                                                                            {
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'name',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 108,
                                                                                            column: 32,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/NewMenu.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 108,
                                                                                            column: 36,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/NewMenu.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Identifier',
                                                                                    name: 'icon',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 108,
                                                                                            column: 37,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/NewMenu.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 108,
                                                                                            column: 41,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/NewMenu.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                kind: 'init',
                                                                                order: '1'
                                                                            }
                                                                        ]
                                                                    }],
                                                                loc: {
                                                                    start: {
                                                                        line: 108,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/NewMenu.ion'
                                                                    },
                                                                    end: {
                                                                        line: 108,
                                                                        column: 43,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/NewMenu.ion'
                                                                    }
                                                                }
                                                            },
                                                            properties: [{
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'classList',
                                                                        loc: {
                                                                            start: {
                                                                                line: 109,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                            },
                                                                            end: {
                                                                                line: 109,
                                                                                column: 29,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'ObjectExpression',
                                                                        properties: [{
                                                                                type: 'ExpressionStatement',
                                                                                expression: {
                                                                                    type: 'Literal',
                                                                                    value: 'left'
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 110,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/NewMenu.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 110,
                                                                                        column: 30,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/NewMenu.ion'
                                                                                    }
                                                                                },
                                                                                order: '0'
                                                                            }]
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                }]
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 108,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/NewMenu.ion'
                                                            },
                                                            end: {
                                                                line: 111,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'glass/html/material/NewMenu.ion'
                                                            }
                                                        },
                                                        order: '0'
                                                    }]
                                            },
                                            alternate: {
                                                type: 'IfStatement',
                                                test: {
                                                    type: 'BinaryExpression',
                                                    operator: '||',
                                                    left: {
                                                        type: 'UnaryExpression',
                                                        operator: '?',
                                                        argument: {
                                                            type: 'Identifier',
                                                            name: 'selected',
                                                            loc: {
                                                                start: {
                                                                    line: 111,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/NewMenu.ion'
                                                                },
                                                                end: {
                                                                    line: 111,
                                                                    column: 28,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/NewMenu.ion'
                                                                }
                                                            }
                                                        }
                                                    },
                                                    right: {
                                                        type: 'BinaryExpression',
                                                        operator: '===',
                                                        left: {
                                                            type: 'Identifier',
                                                            name: 'icon',
                                                            loc: {
                                                                start: {
                                                                    line: 111,
                                                                    column: 33,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/NewMenu.ion'
                                                                },
                                                                end: {
                                                                    line: 111,
                                                                    column: 37,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/NewMenu.ion'
                                                                }
                                                            }
                                                        },
                                                        right: {
                                                            type: 'Literal',
                                                            value: null
                                                        }
                                                    }
                                                },
                                                consequent: {
                                                    type: 'BlockStatement',
                                                    body: [{
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'ObjectExpression',
                                                                objectType: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'Identifier',
                                                                        name: 'Icon',
                                                                        loc: {
                                                                            start: {
                                                                                line: 112,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                            },
                                                                            end: {
                                                                                line: 112,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [{
                                                                            type: 'ObjectExpression',
                                                                            properties: [{
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'name',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 112,
                                                                                                column: 22,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 112,
                                                                                                column: 26,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'ConditionalExpression',
                                                                                        test: {
                                                                                            type: 'Identifier',
                                                                                            name: 'selected',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 112,
                                                                                                    column: 27,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/NewMenu.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 112,
                                                                                                    column: 35,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/NewMenu.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        consequent: {
                                                                                            type: 'Literal',
                                                                                            value: 'done'
                                                                                        },
                                                                                        alternate: {
                                                                                            type: 'Literal',
                                                                                            value: 'none'
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                }]
                                                                        }],
                                                                    loc: {
                                                                        start: {
                                                                            line: 112,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/NewMenu.ion'
                                                                        },
                                                                        end: {
                                                                            line: 112,
                                                                            column: 55,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/NewMenu.ion'
                                                                        }
                                                                    }
                                                                },
                                                                properties: [{
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'classList',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 113,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/NewMenu.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 113,
                                                                                    column: 29,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/NewMenu.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'ObjectExpression',
                                                                            properties: [{
                                                                                    type: 'ExpressionStatement',
                                                                                    expression: {
                                                                                        type: 'Literal',
                                                                                        value: 'left'
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 114,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/NewMenu.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 114,
                                                                                            column: 30,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/NewMenu.ion'
                                                                                        }
                                                                                    },
                                                                                    order: '0'
                                                                                }]
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    }]
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 112,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/NewMenu.ion'
                                                                },
                                                                end: {
                                                                    line: 115,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/NewMenu.ion'
                                                                }
                                                            },
                                                            order: '0'
                                                        }]
                                                },
                                                alternate: null
                                            },
                                            order: '2'
                                        },
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'ObjectExpression',
                                                objectType: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'Identifier',
                                                        name: 'Div',
                                                        loc: {
                                                            start: {
                                                                line: 115,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'glass/html/material/NewMenu.ion'
                                                            },
                                                            end: {
                                                                line: 115,
                                                                column: 15,
                                                                fixed: true,
                                                                source: 'glass/html/material/NewMenu.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [{
                                                            type: 'ObjectExpression',
                                                            properties: [{
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'class',
                                                                        loc: {
                                                                            start: {
                                                                                line: 115,
                                                                                column: 17,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                            },
                                                                            end: {
                                                                                line: 115,
                                                                                column: 22,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Literal',
                                                                        value: 'flex name'
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                }]
                                                        }],
                                                    loc: {
                                                        start: {
                                                            line: 115,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/NewMenu.ion'
                                                        },
                                                        end: {
                                                            line: 115,
                                                            column: 36,
                                                            fixed: true,
                                                            source: 'glass/html/material/NewMenu.ion'
                                                        }
                                                    }
                                                },
                                                properties: [{
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'Identifier',
                                                            name: 'name',
                                                            loc: {
                                                                start: {
                                                                    line: 116,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/NewMenu.ion'
                                                                },
                                                                end: {
                                                                    line: 116,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/NewMenu.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 116,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/NewMenu.ion'
                                                            },
                                                            end: {
                                                                line: 116,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'glass/html/material/NewMenu.ion'
                                                            }
                                                        },
                                                        order: '0'
                                                    }]
                                            },
                                            loc: {
                                                start: {
                                                    line: 115,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/NewMenu.ion'
                                                },
                                                end: {
                                                    line: 117,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/html/material/NewMenu.ion'
                                                }
                                            },
                                            order: '3'
                                        },
                                        {
                                            type: 'IfStatement',
                                            test: {
                                                type: 'Identifier',
                                                name: 'items',
                                                loc: {
                                                    start: {
                                                        line: 117,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'glass/html/material/NewMenu.ion'
                                                    },
                                                    end: {
                                                        line: 117,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'glass/html/material/NewMenu.ion'
                                                    }
                                                }
                                            },
                                            consequent: {
                                                type: 'BlockStatement',
                                                body: [{
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'ObjectExpression',
                                                            objectType: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Identifier',
                                                                    name: 'Icon',
                                                                    loc: {
                                                                        start: {
                                                                            line: 118,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/NewMenu.ion'
                                                                        },
                                                                        end: {
                                                                            line: 118,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/NewMenu.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'ObjectExpression',
                                                                        properties: [{
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'name',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 118,
                                                                                            column: 22,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/NewMenu.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 118,
                                                                                            column: 26,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/NewMenu.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Literal',
                                                                                    value: 'arrow drop down'
                                                                                },
                                                                                kind: 'init',
                                                                                order: '0'
                                                                            }]
                                                                    }],
                                                                loc: {
                                                                    start: {
                                                                        line: 118,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/NewMenu.ion'
                                                                    },
                                                                    end: {
                                                                        line: 118,
                                                                        column: 46,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/NewMenu.ion'
                                                                    }
                                                                }
                                                            },
                                                            properties: [
                                                                {
                                                                    type: 'VariableDeclaration',
                                                                    declarations: [{
                                                                            type: 'VariableDeclarator',
                                                                            id: {
                                                                                type: 'Identifier',
                                                                                name: 'angle',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 119,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/NewMenu.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 119,
                                                                                        column: 29,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/NewMenu.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            init: {
                                                                                type: 'ConditionalExpression',
                                                                                test: {
                                                                                    type: 'BinaryExpression',
                                                                                    operator: '!=',
                                                                                    left: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'args',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 119,
                                                                                                    column: 32,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/NewMenu.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 119,
                                                                                                    column: 36,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/NewMenu.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'angle',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 119,
                                                                                                    column: 37,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/NewMenu.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 119,
                                                                                                    column: 42,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/NewMenu.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 119,
                                                                                                column: 32,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 119,
                                                                                                column: 42,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    right: {
                                                                                        type: 'Literal',
                                                                                        value: null
                                                                                    }
                                                                                },
                                                                                consequent: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'args',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 119,
                                                                                                column: 32,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 119,
                                                                                                column: 36,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'angle',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 119,
                                                                                                column: 37,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 119,
                                                                                                column: 42,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 119,
                                                                                            column: 32,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/NewMenu.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 119,
                                                                                            column: 42,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/NewMenu.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                alternate: {
                                                                                    type: 'ConditionalExpression',
                                                                                    test: {
                                                                                        type: 'Identifier',
                                                                                        name: 'open',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 119,
                                                                                                column: 46,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 119,
                                                                                                column: 50,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    consequent: {
                                                                                        type: 'Literal',
                                                                                        value: 0
                                                                                    },
                                                                                    alternate: {
                                                                                        type: 'Literal',
                                                                                        value: 180
                                                                                    }
                                                                                }
                                                                            }
                                                                        }],
                                                                    kind: 'let',
                                                                    order: '0'
                                                                },
                                                                {
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'style',
                                                                        loc: {
                                                                            start: {
                                                                                line: 120,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                            },
                                                                            end: {
                                                                                line: 120,
                                                                                column: 25,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'ObjectExpression',
                                                                        properties: [{
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'transform',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 121,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/NewMenu.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 121,
                                                                                            column: 33,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/NewMenu.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'BinaryExpression',
                                                                                    operator: '+',
                                                                                    left: {
                                                                                        type: 'BinaryExpression',
                                                                                        operator: '+',
                                                                                        left: {
                                                                                            type: 'Literal',
                                                                                            value: 'rotate('
                                                                                        },
                                                                                        right: {
                                                                                            type: 'Identifier',
                                                                                            name: 'angle',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 121,
                                                                                                    column: 45,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/NewMenu.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 121,
                                                                                                    column: 50,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/NewMenu.ion'
                                                                                                }
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    right: {
                                                                                        type: 'Literal',
                                                                                        value: 'deg)'
                                                                                    }
                                                                                },
                                                                                kind: 'init',
                                                                                order: '0'
                                                                            }]
                                                                    },
                                                                    kind: 'init',
                                                                    order: '1'
                                                                }
                                                            ]
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 118,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/NewMenu.ion'
                                                            },
                                                            end: {
                                                                line: 122,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'glass/html/material/NewMenu.ion'
                                                            }
                                                        },
                                                        order: '0'
                                                    }]
                                            },
                                            alternate: null,
                                            order: '4'
                                        },
                                        {
                                            type: 'IfStatement',
                                            test: {
                                                type: 'Identifier',
                                                name: 'items',
                                                loc: {
                                                    start: {
                                                        line: 122,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'glass/html/material/NewMenu.ion'
                                                    },
                                                    end: {
                                                        line: 122,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'glass/html/material/NewMenu.ion'
                                                    }
                                                }
                                            },
                                            consequent: {
                                                type: 'BlockStatement',
                                                body: [{
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'Function',
                                                            context: true,
                                                            value: function (_context5) {
                                                                return function click(e) {
                                                                    var args = _context5.get('args');
                                                                    args.angle = args.angle != null ? args.angle : 180;
                                                                    args.angle += 180;
                                                                    args.open = !args.open;
                                                                    e.stopPropagation();
                                                                };
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 123,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/NewMenu.ion'
                                                            },
                                                            end: {
                                                                line: 128,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'glass/html/material/NewMenu.ion'
                                                            }
                                                        },
                                                        order: '0'
                                                    }]
                                            },
                                            alternate: null,
                                            order: '5'
                                        }
                                    ]
                                },
                                loc: {
                                    start: {
                                        line: 95,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    },
                                    end: {
                                        line: 128,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    }
                                },
                                order: '2'
                            },
                            {
                                type: 'IfStatement',
                                test: {
                                    type: 'Identifier',
                                    name: 'items',
                                    loc: {
                                        start: {
                                            line: 128,
                                            column: 11,
                                            fixed: true,
                                            source: 'glass/html/material/NewMenu.ion'
                                        },
                                        end: {
                                            line: 128,
                                            column: 16,
                                            fixed: true,
                                            source: 'glass/html/material/NewMenu.ion'
                                        }
                                    }
                                },
                                consequent: {
                                    type: 'BlockStatement',
                                    body: [{
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'Menu',
                                                    loc: {
                                                        start: {
                                                            line: 129,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/NewMenu.ion'
                                                        },
                                                        end: {
                                                            line: 129,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/NewMenu.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [{
                                                        type: 'Identifier',
                                                        name: 'args',
                                                        loc: {
                                                            start: {
                                                                line: 129,
                                                                column: 17,
                                                                fixed: true,
                                                                source: 'glass/html/material/NewMenu.ion'
                                                            },
                                                            end: {
                                                                line: 129,
                                                                column: 21,
                                                                fixed: true,
                                                                source: 'glass/html/material/NewMenu.ion'
                                                            }
                                                        }
                                                    }],
                                                loc: {
                                                    start: {
                                                        line: 129,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/NewMenu.ion'
                                                    },
                                                    end: {
                                                        line: 129,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'glass/html/material/NewMenu.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 129,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/NewMenu.ion'
                                                },
                                                end: {
                                                    line: 129,
                                                    column: 22,
                                                    fixed: true,
                                                    source: 'glass/html/material/NewMenu.ion'
                                                }
                                            },
                                            order: '0'
                                        }]
                                },
                                alternate: null,
                                order: '3'
                            }
                        ]
                    },
                    order: '='
                }
            ],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'MenuItem',
                loc: {
                    start: {
                        line: 83,
                        column: 6,
                        fixed: true,
                        source: 'glass/html/material/NewMenu.ion'
                    },
                    end: {
                        line: 83,
                        column: 14,
                        fixed: true,
                        source: 'glass/html/material/NewMenu.ion'
                    }
                }
            }
        }, {
            this: this,
            args: args,
            _ref: _ref,
            _ref2: _ref2,
            _ref3: _ref3,
            animationTime: animationTime,
            style: style,
            show: show,
            rgba: rgba,
            Icon: Icon,
            MenuItem: MenuItem,
            MenuDivider: MenuDivider,
            Menu: Menu
        }, null);
    });
var MenuDivider = ion.template(function () {
        return ion.createRuntime({
            type: 'Template',
            id: null,
            body: [{
                    type: 'ReturnStatement',
                    argument: {
                        type: 'CallExpression',
                        callee: {
                            type: 'Identifier',
                            name: 'Div',
                            loc: {
                                start: {
                                    line: 131,
                                    column: 32,
                                    fixed: true,
                                    source: 'glass/html/material/NewMenu.ion'
                                },
                                end: {
                                    line: 131,
                                    column: 35,
                                    fixed: true,
                                    source: 'glass/html/material/NewMenu.ion'
                                }
                            }
                        },
                        arguments: [{
                                type: 'ObjectExpression',
                                properties: [{
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'class',
                                            loc: {
                                                start: {
                                                    line: 131,
                                                    column: 37,
                                                    fixed: true,
                                                    source: 'glass/html/material/NewMenu.ion'
                                                },
                                                end: {
                                                    line: 131,
                                                    column: 42,
                                                    fixed: true,
                                                    source: 'glass/html/material/NewMenu.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: 'MenuDivider'
                                        },
                                        kind: 'init',
                                        order: '0'
                                    }]
                            }],
                        loc: {
                            start: {
                                line: 131,
                                column: 32,
                                fixed: true,
                                source: 'glass/html/material/NewMenu.ion'
                            },
                            end: {
                                line: 131,
                                column: 58,
                                fixed: true,
                                source: 'glass/html/material/NewMenu.ion'
                            }
                        }
                    },
                    order: '0'
                }],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'MenuDivider',
                loc: {
                    start: {
                        line: 131,
                        column: 6,
                        fixed: true,
                        source: 'glass/html/material/NewMenu.ion'
                    },
                    end: {
                        line: 131,
                        column: 17,
                        fixed: true,
                        source: 'glass/html/material/NewMenu.ion'
                    }
                }
            }
        }, {
            this: this,
            _ref: _ref,
            _ref2: _ref2,
            _ref3: _ref3,
            animationTime: animationTime,
            style: style,
            show: show,
            rgba: rgba,
            Icon: Icon,
            MenuItem: MenuItem,
            MenuDivider: MenuDivider,
            Menu: Menu
        }, null);
    });
var Menu = ion.template(function (args) {
        return ion.createRuntime({
            type: 'Template',
            id: null,
            body: [
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: '_ref5'
                            },
                            init: {
                                type: 'ConditionalExpression',
                                test: {
                                    type: 'BinaryExpression',
                                    operator: '!=',
                                    left: {
                                        type: 'Identifier',
                                        name: 'args',
                                        loc: {
                                            start: {
                                                line: 134,
                                                column: 43,
                                                fixed: true,
                                                source: 'glass/html/material/NewMenu.ion'
                                            },
                                            end: {
                                                line: 134,
                                                column: 47,
                                                fixed: true,
                                                source: 'glass/html/material/NewMenu.ion'
                                            }
                                        }
                                    },
                                    right: {
                                        type: 'Literal',
                                        value: null
                                    }
                                },
                                consequent: {
                                    type: 'Identifier',
                                    name: 'args',
                                    loc: {
                                        start: {
                                            line: 134,
                                            column: 43,
                                            fixed: true,
                                            source: 'glass/html/material/NewMenu.ion'
                                        },
                                        end: {
                                            line: 134,
                                            column: 47,
                                            fixed: true,
                                            source: 'glass/html/material/NewMenu.ion'
                                        }
                                    }
                                },
                                alternate: {
                                    type: 'ObjectExpression',
                                    properties: []
                                }
                            }
                        }],
                    kind: 'let',
                    order: '0'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'items',
                                loc: {
                                    start: {
                                        line: 134,
                                        column: 9,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    },
                                    end: {
                                        line: 134,
                                        column: 14,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref5'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'items',
                                    loc: {
                                        start: {
                                            line: 134,
                                            column: 9,
                                            fixed: true,
                                            source: 'glass/html/material/NewMenu.ion'
                                        },
                                        end: {
                                            line: 134,
                                            column: 14,
                                            fixed: true,
                                            source: 'glass/html/material/NewMenu.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '1'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'open',
                                loc: {
                                    start: {
                                        line: 134,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    },
                                    end: {
                                        line: 134,
                                        column: 19,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref5'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'open',
                                    loc: {
                                        start: {
                                            line: 134,
                                            column: 15,
                                            fixed: true,
                                            source: 'glass/html/material/NewMenu.ion'
                                        },
                                        end: {
                                            line: 134,
                                            column: 19,
                                            fixed: true,
                                            source: 'glass/html/material/NewMenu.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '2'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'float',
                                loc: {
                                    start: {
                                        line: 134,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    },
                                    end: {
                                        line: 134,
                                        column: 25,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref5'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'float',
                                    loc: {
                                        start: {
                                            line: 134,
                                            column: 20,
                                            fixed: true,
                                            source: 'glass/html/material/NewMenu.ion'
                                        },
                                        end: {
                                            line: 134,
                                            column: 25,
                                            fixed: true,
                                            source: 'glass/html/material/NewMenu.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '3'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'initialValue',
                                loc: {
                                    start: {
                                        line: 134,
                                        column: 27,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    },
                                    end: {
                                        line: 134,
                                        column: 39,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref5'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'initialValue',
                                    loc: {
                                        start: {
                                            line: 134,
                                            column: 27,
                                            fixed: true,
                                            source: 'glass/html/material/NewMenu.ion'
                                        },
                                        end: {
                                            line: 134,
                                            column: 39,
                                            fixed: true,
                                            source: 'glass/html/material/NewMenu.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '4'
                },
                {
                    type: 'ReturnStatement',
                    argument: {
                        type: 'ObjectExpression',
                        objectType: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Div',
                                loc: {
                                    start: {
                                        line: 135,
                                        column: 11,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    },
                                    end: {
                                        line: 135,
                                        column: 14,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ObjectExpression',
                                    properties: [{
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'tabindex',
                                                loc: {
                                                    start: {
                                                        line: 135,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'glass/html/material/NewMenu.ion'
                                                    },
                                                    end: {
                                                        line: 135,
                                                        column: 24,
                                                        fixed: true,
                                                        source: 'glass/html/material/NewMenu.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'UnaryExpression',
                                                operator: '-',
                                                argument: {
                                                    type: 'Literal',
                                                    value: 1
                                                }
                                            },
                                            kind: 'init',
                                            order: '0'
                                        }]
                                }],
                            loc: {
                                start: {
                                    line: 135,
                                    column: 11,
                                    fixed: true,
                                    source: 'glass/html/material/NewMenu.ion'
                                },
                                end: {
                                    line: 135,
                                    column: 29,
                                    fixed: true,
                                    source: 'glass/html/material/NewMenu.ion'
                                }
                            }
                        },
                        properties: [
                            {
                                type: 'ExpressionStatement',
                                expression: {
                                    type: 'Function',
                                    context: true,
                                    value: function (_context6) {
                                        return function focus() {
                                            var initialValue = _context6.get('initialValue');
                                            if (initialValue != null) {
                                                this.children[initialValue].focus();
                                            } else {
                                                this.children[0].focus();
                                            }
                                        };
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 136,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    },
                                    end: {
                                        line: 141,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    }
                                },
                                order: '0'
                            },
                            {
                                type: 'ExpressionStatement',
                                expression: {
                                    type: 'Function',
                                    context: false,
                                    value: function keypress(e) {
                                        if (e.keyCode === 13) {
                                            e.target.select(e);
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 141,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    },
                                    end: {
                                        line: 144,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    }
                                },
                                order: '1'
                            },
                            {
                                type: 'ExpressionStatement',
                                expression: {
                                    type: 'Function',
                                    context: false,
                                    value: function keyup(e) {
                                        if (e.keyCode === 27) {
                                            this.dispatchEvent(new CustomEvent('close', { bubbles: true }));
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 144,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    },
                                    end: {
                                        line: 147,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    }
                                },
                                order: '2'
                            },
                            {
                                type: 'ExpressionStatement',
                                expression: {
                                    type: 'Function',
                                    context: false,
                                    value: function keydown(e) {
                                        var next = null;
                                        if (e.keyCode === 40) {
                                            next = e.target.nextElementSibling;
                                        }
                                        if (e.keyCode === 38) {
                                            next = e.target.previousElementSibling;
                                        }
                                        if (next != null) {
                                            next.focus != null ? next.focus() : void 0;
                                            e.preventDefault();
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 147,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    },
                                    end: {
                                        line: 156,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/NewMenu.ion'
                                    }
                                },
                                order: '3'
                            },
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'classList',
                                    loc: {
                                        start: {
                                            line: 156,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/NewMenu.ion'
                                        },
                                        end: {
                                            line: 156,
                                            column: 17,
                                            fixed: true,
                                            source: 'glass/html/material/NewMenu.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'ObjectExpression',
                                    properties: [
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'Literal',
                                                value: 'NewMenu'
                                            },
                                            loc: {
                                                start: {
                                                    line: 157,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/NewMenu.ion'
                                                },
                                                end: {
                                                    line: 157,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'glass/html/material/NewMenu.ion'
                                                }
                                            },
                                            order: '0'
                                        },
                                        {
                                            type: 'IfStatement',
                                            test: {
                                                type: 'BinaryExpression',
                                                operator: '!==',
                                                left: {
                                                    type: 'Identifier',
                                                    name: 'open',
                                                    loc: {
                                                        start: {
                                                            line: 158,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/NewMenu.ion'
                                                        },
                                                        end: {
                                                            line: 158,
                                                            column: 19,
                                                            fixed: true,
                                                            source: 'glass/html/material/NewMenu.ion'
                                                        }
                                                    }
                                                },
                                                right: {
                                                    type: 'Literal',
                                                    value: false
                                                }
                                            },
                                            consequent: {
                                                type: 'BlockStatement',
                                                body: [{
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'Literal',
                                                            value: 'open'
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 159,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/NewMenu.ion'
                                                            },
                                                            end: {
                                                                line: 159,
                                                                column: 22,
                                                                fixed: true,
                                                                source: 'glass/html/material/NewMenu.ion'
                                                            }
                                                        },
                                                        order: '0'
                                                    }]
                                            },
                                            alternate: null,
                                            order: '1'
                                        },
                                        {
                                            type: 'IfStatement',
                                            test: {
                                                type: 'Identifier',
                                                name: 'float',
                                                loc: {
                                                    start: {
                                                        line: 160,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'glass/html/material/NewMenu.ion'
                                                    },
                                                    end: {
                                                        line: 160,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'glass/html/material/NewMenu.ion'
                                                    }
                                                }
                                            },
                                            consequent: {
                                                type: 'BlockStatement',
                                                body: [
                                                    {
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'Literal',
                                                            value: 'float'
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 161,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/NewMenu.ion'
                                                            },
                                                            end: {
                                                                line: 161,
                                                                column: 23,
                                                                fixed: true,
                                                                source: 'glass/html/material/NewMenu.ion'
                                                            }
                                                        },
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'Literal',
                                                            value: 'z2'
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 162,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/NewMenu.ion'
                                                            },
                                                            end: {
                                                                line: 162,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'glass/html/material/NewMenu.ion'
                                                            }
                                                        },
                                                        order: '1'
                                                    }
                                                ]
                                            },
                                            alternate: null,
                                            order: '2'
                                        }
                                    ]
                                },
                                kind: 'init',
                                order: '4'
                            },
                            {
                                type: 'ForOfStatement',
                                left: {
                                    type: 'VariableDeclaration',
                                    declarations: [
                                        {
                                            type: 'VariableDeclarator',
                                            id: {
                                                type: 'Identifier',
                                                name: 'item',
                                                loc: {
                                                    start: {
                                                        line: 163,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/NewMenu.ion'
                                                    },
                                                    end: {
                                                        line: 163,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'glass/html/material/NewMenu.ion'
                                                    }
                                                }
                                            },
                                            init: null
                                        },
                                        {
                                            type: 'VariableDeclarator',
                                            id: {
                                                type: 'Identifier',
                                                name: 'index',
                                                loc: {
                                                    start: {
                                                        line: 163,
                                                        column: 18,
                                                        fixed: true,
                                                        source: 'glass/html/material/NewMenu.ion'
                                                    },
                                                    end: {
                                                        line: 163,
                                                        column: 23,
                                                        fixed: true,
                                                        source: 'glass/html/material/NewMenu.ion'
                                                    }
                                                }
                                            },
                                            init: null
                                        }
                                    ],
                                    kind: 'let'
                                },
                                right: {
                                    type: 'Identifier',
                                    name: 'items',
                                    loc: {
                                        start: {
                                            line: 163,
                                            column: 27,
                                            fixed: true,
                                            source: 'glass/html/material/NewMenu.ion'
                                        },
                                        end: {
                                            line: 163,
                                            column: 32,
                                            fixed: true,
                                            source: 'glass/html/material/NewMenu.ion'
                                        }
                                    }
                                },
                                body: {
                                    type: 'BlockStatement',
                                    body: [{
                                            type: 'IfStatement',
                                            test: {
                                                type: 'UnaryExpression',
                                                operator: '?',
                                                argument: {
                                                    type: 'Identifier',
                                                    name: 'item',
                                                    loc: {
                                                        start: {
                                                            line: 164,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/NewMenu.ion'
                                                        },
                                                        end: {
                                                            line: 164,
                                                            column: 19,
                                                            fixed: true,
                                                            source: 'glass/html/material/NewMenu.ion'
                                                        }
                                                    }
                                                }
                                            },
                                            consequent: {
                                                type: 'BlockStatement',
                                                body: [{
                                                        type: 'IfStatement',
                                                        test: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'item',
                                                                loc: {
                                                                    start: {
                                                                        line: 165,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/NewMenu.ion'
                                                                    },
                                                                    end: {
                                                                        line: 165,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/NewMenu.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'nodeType',
                                                                loc: {
                                                                    start: {
                                                                        line: 165,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/NewMenu.ion'
                                                                    },
                                                                    end: {
                                                                        line: 165,
                                                                        column: 32,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/NewMenu.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 165,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/NewMenu.ion'
                                                                },
                                                                end: {
                                                                    line: 165,
                                                                    column: 32,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/NewMenu.ion'
                                                                }
                                                            }
                                                        },
                                                        consequent: {
                                                            type: 'BlockStatement',
                                                            body: [{
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'Identifier',
                                                                        name: 'item',
                                                                        loc: {
                                                                            start: {
                                                                                line: 166,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                            },
                                                                            end: {
                                                                                line: 166,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 166,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/NewMenu.ion'
                                                                        },
                                                                        end: {
                                                                            line: 166,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/NewMenu.ion'
                                                                        }
                                                                    },
                                                                    order: '0'
                                                                }]
                                                        },
                                                        alternate: {
                                                            type: 'BlockStatement',
                                                            body: [{
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'Identifier',
                                                                            name: 'MenuItem',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 168,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/NewMenu.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 168,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/NewMenu.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [{
                                                                                type: 'Identifier',
                                                                                name: 'item',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 168,
                                                                                        column: 29,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/NewMenu.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 168,
                                                                                        column: 33,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/NewMenu.ion'
                                                                                    }
                                                                                }
                                                                            }],
                                                                        loc: {
                                                                            start: {
                                                                                line: 168,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                            },
                                                                            end: {
                                                                                line: 168,
                                                                                column: 34,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/NewMenu.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 168,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/NewMenu.ion'
                                                                        },
                                                                        end: {
                                                                            line: 168,
                                                                            column: 34,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/NewMenu.ion'
                                                                        }
                                                                    },
                                                                    order: '0'
                                                                }]
                                                        },
                                                        order: '0'
                                                    }]
                                            },
                                            alternate: {
                                                type: 'BlockStatement',
                                                body: [{
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'MenuDivider',
                                                                loc: {
                                                                    start: {
                                                                        line: 170,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/NewMenu.ion'
                                                                    },
                                                                    end: {
                                                                        line: 170,
                                                                        column: 27,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/NewMenu.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [],
                                                            loc: {
                                                                start: {
                                                                    line: 170,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/NewMenu.ion'
                                                                },
                                                                end: {
                                                                    line: 170,
                                                                    column: 29,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/NewMenu.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 170,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/NewMenu.ion'
                                                            },
                                                            end: {
                                                                line: 170,
                                                                column: 29,
                                                                fixed: true,
                                                                source: 'glass/html/material/NewMenu.ion'
                                                            }
                                                        },
                                                        order: '0'
                                                    }]
                                            },
                                            order: '0'
                                        }]
                                },
                                remove: null,
                                order: '5'
                            }
                        ]
                    },
                    order: '5'
                }
            ],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'Menu',
                loc: {
                    start: {
                        line: 133,
                        column: 6,
                        fixed: true,
                        source: 'glass/html/material/NewMenu.ion'
                    },
                    end: {
                        line: 133,
                        column: 10,
                        fixed: true,
                        source: 'glass/html/material/NewMenu.ion'
                    }
                }
            }
        }, {
            this: this,
            args: args,
            _ref: _ref,
            _ref2: _ref2,
            _ref3: _ref3,
            animationTime: animationTime,
            style: style,
            show: show,
            rgba: rgba,
            Icon: Icon,
            MenuItem: MenuItem,
            MenuDivider: MenuDivider,
            Menu: Menu
        }, null);
    });
module.exports = exports = ion.patch.combine(Menu, {
    Item: MenuItem,
    Divider: MenuDivider,
    show: function (e, items) {
        e.preventDefault();
        var remove = show({
                template: Menu({
                    items: items,
                    open: true,
                    float: true
                }),
                sourceElement: e.target,
                position: [
                    e.pageX,
                    e.pageY
                ],
                modal: false,
                select: false,
                onAdd: function (menu) {
                },
                onRemove: function (e) {
                }
            });
        return remove;
    }
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/NewMenu',_glass_html_material_NewMenu_);
    else
      _glass_html_material_NewMenu_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_NewMenu_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_PromptDialog_ = function(module,exports,require){'use strict';
var ion = require('ion');
var glass = require('../../'), _ref, _ref2;
_ref = glass.html.material;
var Dialog = _ref.Dialog;
_ref2 = glass.html.forms;
var GlassForm = _ref2.GlassForm;
var CancelButton = _ref2.CancelButton;
var SubmitButton = _ref2.SubmitButton;
var Field = _ref2.Field;
var PromptDialog = ion.template(function PromptDialog(_ref3) {
        return ion.createRuntime({
            type: 'Template',
            id: {
                type: 'Identifier',
                name: 'PromptDialog',
                loc: {
                    start: {
                        line: 6,
                        column: 15,
                        fixed: true,
                        source: 'glass/html/material/PromptDialog.ion'
                    },
                    end: {
                        line: 6,
                        column: 27,
                        fixed: true,
                        source: 'glass/html/material/PromptDialog.ion'
                    }
                }
            },
            body: [
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'properties',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 29,
                                        fixed: true,
                                        source: 'glass/html/material/PromptDialog.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 39,
                                        fixed: true,
                                        source: 'glass/html/material/PromptDialog.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref3'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'properties',
                                    loc: {
                                        start: {
                                            line: 6,
                                            column: 29,
                                            fixed: true,
                                            source: 'glass/html/material/PromptDialog.ion'
                                        },
                                        end: {
                                            line: 6,
                                            column: 39,
                                            fixed: true,
                                            source: 'glass/html/material/PromptDialog.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '0'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'values',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 41,
                                        fixed: true,
                                        source: 'glass/html/material/PromptDialog.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 47,
                                        fixed: true,
                                        source: 'glass/html/material/PromptDialog.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref3'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'values',
                                    loc: {
                                        start: {
                                            line: 6,
                                            column: 41,
                                            fixed: true,
                                            source: 'glass/html/material/PromptDialog.ion'
                                        },
                                        end: {
                                            line: 6,
                                            column: 47,
                                            fixed: true,
                                            source: 'glass/html/material/PromptDialog.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '1'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'title',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 49,
                                        fixed: true,
                                        source: 'glass/html/material/PromptDialog.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 54,
                                        fixed: true,
                                        source: 'glass/html/material/PromptDialog.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref3'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'title',
                                    loc: {
                                        start: {
                                            line: 6,
                                            column: 49,
                                            fixed: true,
                                            source: 'glass/html/material/PromptDialog.ion'
                                        },
                                        end: {
                                            line: 6,
                                            column: 54,
                                            fixed: true,
                                            source: 'glass/html/material/PromptDialog.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '2'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'callback',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 56,
                                        fixed: true,
                                        source: 'glass/html/material/PromptDialog.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 64,
                                        fixed: true,
                                        source: 'glass/html/material/PromptDialog.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref3'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'callback',
                                    loc: {
                                        start: {
                                            line: 6,
                                            column: 56,
                                            fixed: true,
                                            source: 'glass/html/material/PromptDialog.ion'
                                        },
                                        end: {
                                            line: 6,
                                            column: 64,
                                            fixed: true,
                                            source: 'glass/html/material/PromptDialog.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '3'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'submitText',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 66,
                                        fixed: true,
                                        source: 'glass/html/material/PromptDialog.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 76,
                                        fixed: true,
                                        source: 'glass/html/material/PromptDialog.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref3'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'submitText',
                                    loc: {
                                        start: {
                                            line: 6,
                                            column: 66,
                                            fixed: true,
                                            source: 'glass/html/material/PromptDialog.ion'
                                        },
                                        end: {
                                            line: 6,
                                            column: 76,
                                            fixed: true,
                                            source: 'glass/html/material/PromptDialog.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '4'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'cancelText',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 78,
                                        fixed: true,
                                        source: 'glass/html/material/PromptDialog.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 88,
                                        fixed: true,
                                        source: 'glass/html/material/PromptDialog.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref3'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'cancelText',
                                    loc: {
                                        start: {
                                            line: 6,
                                            column: 78,
                                            fixed: true,
                                            source: 'glass/html/material/PromptDialog.ion'
                                        },
                                        end: {
                                            line: 6,
                                            column: 88,
                                            fixed: true,
                                            source: 'glass/html/material/PromptDialog.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '5'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'text',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 90,
                                        fixed: true,
                                        source: 'glass/html/material/PromptDialog.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 94,
                                        fixed: true,
                                        source: 'glass/html/material/PromptDialog.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref3'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'text',
                                    loc: {
                                        start: {
                                            line: 6,
                                            column: 90,
                                            fixed: true,
                                            source: 'glass/html/material/PromptDialog.ion'
                                        },
                                        end: {
                                            line: 6,
                                            column: 94,
                                            fixed: true,
                                            source: 'glass/html/material/PromptDialog.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '6'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'style',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 96,
                                        fixed: true,
                                        source: 'glass/html/material/PromptDialog.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 101,
                                        fixed: true,
                                        source: 'glass/html/material/PromptDialog.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref3'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'style',
                                    loc: {
                                        start: {
                                            line: 6,
                                            column: 96,
                                            fixed: true,
                                            source: 'glass/html/material/PromptDialog.ion'
                                        },
                                        end: {
                                            line: 6,
                                            column: 101,
                                            fixed: true,
                                            source: 'glass/html/material/PromptDialog.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '7'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'closeOnBlur',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 103,
                                        fixed: true,
                                        source: 'glass/html/material/PromptDialog.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 114,
                                        fixed: true,
                                        source: 'glass/html/material/PromptDialog.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref3'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'closeOnBlur',
                                    loc: {
                                        start: {
                                            line: 6,
                                            column: 103,
                                            fixed: true,
                                            source: 'glass/html/material/PromptDialog.ion'
                                        },
                                        end: {
                                            line: 6,
                                            column: 114,
                                            fixed: true,
                                            source: 'glass/html/material/PromptDialog.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '8'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'dialog',
                                loc: {
                                    start: {
                                        line: 7,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/PromptDialog.ion'
                                    },
                                    end: {
                                        line: 7,
                                        column: 14,
                                        fixed: true,
                                        source: 'glass/html/material/PromptDialog.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Dialog',
                                    loc: {
                                        start: {
                                            line: 7,
                                            column: 17,
                                            fixed: true,
                                            source: 'glass/html/material/PromptDialog.ion'
                                        },
                                        end: {
                                            line: 7,
                                            column: 23,
                                            fixed: true,
                                            source: 'glass/html/material/PromptDialog.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'class',
                                                    loc: {
                                                        start: {
                                                            line: 7,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'glass/html/material/PromptDialog.ion'
                                                        },
                                                        end: {
                                                            line: 7,
                                                            column: 30,
                                                            fixed: true,
                                                            source: 'glass/html/material/PromptDialog.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: 'layout vertical'
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    }],
                                loc: {
                                    start: {
                                        line: 7,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/html/material/PromptDialog.ion'
                                    },
                                    end: {
                                        line: 7,
                                        column: 50,
                                        fixed: true,
                                        source: 'glass/html/material/PromptDialog.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '9'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'form',
                                loc: {
                                    start: {
                                        line: 8,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/PromptDialog.ion'
                                    },
                                    end: {
                                        line: 8,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/PromptDialog.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'Identifier',
                                        name: 'GlassForm',
                                        loc: {
                                            start: {
                                                line: 8,
                                                column: 15,
                                                fixed: true,
                                                source: 'glass/html/material/PromptDialog.ion'
                                            },
                                            end: {
                                                line: 8,
                                                column: 24,
                                                fixed: true,
                                                source: 'glass/html/material/PromptDialog.ion'
                                            }
                                        }
                                    },
                                    arguments: [{
                                            type: 'ObjectExpression',
                                            properties: [{
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'class',
                                                        loc: {
                                                            start: {
                                                                line: 8,
                                                                column: 26,
                                                                fixed: true,
                                                                source: 'glass/html/material/PromptDialog.ion'
                                                            },
                                                            end: {
                                                                line: 8,
                                                                column: 31,
                                                                fixed: true,
                                                                source: 'glass/html/material/PromptDialog.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 'layout vertical flex'
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                }]
                                        }],
                                    loc: {
                                        start: {
                                            line: 8,
                                            column: 15,
                                            fixed: true,
                                            source: 'glass/html/material/PromptDialog.ion'
                                        },
                                        end: {
                                            line: 8,
                                            column: 56,
                                            fixed: true,
                                            source: 'glass/html/material/PromptDialog.ion'
                                        }
                                    }
                                },
                                properties: [
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'style',
                                            loc: {
                                                start: {
                                                    line: 9,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'glass/html/material/PromptDialog.ion'
                                                },
                                                end: {
                                                    line: 9,
                                                    column: 13,
                                                    fixed: true,
                                                    source: 'glass/html/material/PromptDialog.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'ObjectExpression',
                                            properties: [{
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'padding',
                                                        loc: {
                                                            start: {
                                                                line: 10,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'glass/html/material/PromptDialog.ion'
                                                            },
                                                            end: {
                                                                line: 10,
                                                                column: 19,
                                                                fixed: true,
                                                                source: 'glass/html/material/PromptDialog.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: '0px'
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                }]
                                        },
                                        kind: 'init',
                                        order: '0'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'Function',
                                            context: true,
                                            value: function (_context) {
                                                return function cancel() {
                                                    var dialog = _context.get('dialog');
                                                    dialog.open = false;
                                                };
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 11,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/PromptDialog.ion'
                                            },
                                            end: {
                                                line: 13,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/PromptDialog.ion'
                                            }
                                        },
                                        order: '1'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'Function',
                                            context: true,
                                            value: function (_context2) {
                                                return function complete() {
                                                    var callback = _context2.get('callback'), dialog = _context2.get('dialog');
                                                    callback(this.values);
                                                    dialog.open = false;
                                                };
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 13,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/PromptDialog.ion'
                                            },
                                            end: {
                                                line: 16,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/PromptDialog.ion'
                                            }
                                        },
                                        order: '2'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'Function',
                                            context: false,
                                            value: function mousedown(e) {
                                                return e.stopPropagation();
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 16,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/PromptDialog.ion'
                                            },
                                            end: {
                                                line: 16,
                                                column: 43,
                                                fixed: true,
                                                source: 'glass/html/material/PromptDialog.ion'
                                            }
                                        },
                                        order: '3'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'Function',
                                            context: false,
                                            value: function keyup(e) {
                                                return e.stopPropagation();
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 17,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/PromptDialog.ion'
                                            },
                                            end: {
                                                line: 17,
                                                column: 39,
                                                fixed: true,
                                                source: 'glass/html/material/PromptDialog.ion'
                                            }
                                        },
                                        order: '4'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'Function',
                                            context: false,
                                            value: function keypress(e) {
                                                return e.stopPropagation();
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 18,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/PromptDialog.ion'
                                            },
                                            end: {
                                                line: 18,
                                                column: 42,
                                                fixed: true,
                                                source: 'glass/html/material/PromptDialog.ion'
                                            }
                                        },
                                        order: '5'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'Function',
                                            context: false,
                                            value: function keydown(e) {
                                                e.stopPropagation();
                                                if (e.keyCode === 27) {
                                                    this.dispatchEvent(new CustomEvent('cancel'));
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 19,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/PromptDialog.ion'
                                            },
                                            end: {
                                                line: 23,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/PromptDialog.ion'
                                            }
                                        },
                                        order: '6'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'ObjectExpression',
                                            objectType: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'Div',
                                                    loc: {
                                                        start: {
                                                            line: 23,
                                                            column: 8,
                                                            fixed: true,
                                                            source: 'glass/html/material/PromptDialog.ion'
                                                        },
                                                        end: {
                                                            line: 23,
                                                            column: 11,
                                                            fixed: true,
                                                            source: 'glass/html/material/PromptDialog.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [{
                                                        type: 'ObjectExpression',
                                                        properties: [{
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'class',
                                                                    loc: {
                                                                        start: {
                                                                            line: 23,
                                                                            column: 13,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/PromptDialog.ion'
                                                                        },
                                                                        end: {
                                                                            line: 23,
                                                                            column: 18,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/PromptDialog.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: 'content'
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            }]
                                                    }],
                                                loc: {
                                                    start: {
                                                        line: 23,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'glass/html/material/PromptDialog.ion'
                                                    },
                                                    end: {
                                                        line: 23,
                                                        column: 30,
                                                        fixed: true,
                                                        source: 'glass/html/material/PromptDialog.ion'
                                                    }
                                                }
                                            },
                                            properties: [
                                                {
                                                    type: 'IfStatement',
                                                    test: {
                                                        type: 'UnaryExpression',
                                                        operator: '?',
                                                        argument: {
                                                            type: 'Identifier',
                                                            name: 'title',
                                                            loc: {
                                                                start: {
                                                                    line: 24,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/PromptDialog.ion'
                                                                },
                                                                end: {
                                                                    line: 24,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/PromptDialog.ion'
                                                                }
                                                            }
                                                        }
                                                    },
                                                    consequent: {
                                                        type: 'BlockStatement',
                                                        body: [{
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'ObjectExpression',
                                                                    objectType: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'Identifier',
                                                                            name: 'Div',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 25,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/PromptDialog.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 25,
                                                                                    column: 19,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/PromptDialog.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [{
                                                                                type: 'ObjectExpression',
                                                                                properties: [{
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'class',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 25,
                                                                                                    column: 21,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/PromptDialog.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 25,
                                                                                                    column: 26,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/PromptDialog.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 'title'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    }]
                                                                            }],
                                                                        loc: {
                                                                            start: {
                                                                                line: 25,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/PromptDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 25,
                                                                                column: 37,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/PromptDialog.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    properties: [{
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'Identifier',
                                                                                name: 'title',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 26,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/PromptDialog.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 26,
                                                                                        column: 25,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/PromptDialog.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 26,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/PromptDialog.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 26,
                                                                                    column: 25,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/PromptDialog.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 25,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/PromptDialog.ion'
                                                                    },
                                                                    end: {
                                                                        line: 27,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/PromptDialog.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    alternate: null,
                                                    order: '0'
                                                },
                                                {
                                                    type: 'IfStatement',
                                                    test: {
                                                        type: 'UnaryExpression',
                                                        operator: '?',
                                                        argument: {
                                                            type: 'Identifier',
                                                            name: 'text',
                                                            loc: {
                                                                start: {
                                                                    line: 27,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/PromptDialog.ion'
                                                                },
                                                                end: {
                                                                    line: 27,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/PromptDialog.ion'
                                                                }
                                                            }
                                                        }
                                                    },
                                                    consequent: {
                                                        type: 'BlockStatement',
                                                        body: [{
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'ObjectExpression',
                                                                    objectType: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'Identifier',
                                                                            name: 'Div',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 28,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/PromptDialog.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 28,
                                                                                    column: 19,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/PromptDialog.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [{
                                                                                type: 'ObjectExpression',
                                                                                properties: [{
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'style',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 28,
                                                                                                    column: 21,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/PromptDialog.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 28,
                                                                                                    column: 26,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/PromptDialog.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 'font-size:14px'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    }]
                                                                            }],
                                                                        loc: {
                                                                            start: {
                                                                                line: 28,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/PromptDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 28,
                                                                                column: 45,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/PromptDialog.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    properties: [{
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'Identifier',
                                                                                name: 'text',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 29,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/PromptDialog.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 29,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/PromptDialog.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 29,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/PromptDialog.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 29,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/PromptDialog.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 28,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/PromptDialog.ion'
                                                                    },
                                                                    end: {
                                                                        line: 30,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/PromptDialog.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    alternate: null,
                                                    order: '1'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'noLabelFloat',
                                                                loc: {
                                                                    start: {
                                                                        line: 30,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/PromptDialog.ion'
                                                                    },
                                                                    end: {
                                                                        line: 30,
                                                                        column: 28,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/PromptDialog.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'BinaryExpression',
                                                                operator: '===',
                                                                left: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'properties',
                                                                        loc: {
                                                                            start: {
                                                                                line: 30,
                                                                                column: 31,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/PromptDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 30,
                                                                                column: 41,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/PromptDialog.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'length',
                                                                        loc: {
                                                                            start: {
                                                                                line: 30,
                                                                                column: 42,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/PromptDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 30,
                                                                                column: 48,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/PromptDialog.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 30,
                                                                            column: 31,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/PromptDialog.ion'
                                                                        },
                                                                        end: {
                                                                            line: 30,
                                                                            column: 48,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/PromptDialog.ion'
                                                                        }
                                                                    }
                                                                },
                                                                right: {
                                                                    type: 'Literal',
                                                                    value: 1
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '2'
                                                },
                                                {
                                                    type: 'ForOfStatement',
                                                    left: {
                                                        type: 'VariableDeclaration',
                                                        declarations: [{
                                                                type: 'VariableDeclarator',
                                                                id: {
                                                                    type: 'Identifier',
                                                                    name: 'property',
                                                                    loc: {
                                                                        start: {
                                                                            line: 31,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/PromptDialog.ion'
                                                                        },
                                                                        end: {
                                                                            line: 31,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/PromptDialog.ion'
                                                                        }
                                                                    }
                                                                },
                                                                init: null
                                                            }],
                                                        kind: 'let'
                                                    },
                                                    right: {
                                                        type: 'Identifier',
                                                        name: 'properties',
                                                        loc: {
                                                            start: {
                                                                line: 31,
                                                                column: 28,
                                                                fixed: true,
                                                                source: 'glass/html/material/PromptDialog.ion'
                                                            },
                                                            end: {
                                                                line: 31,
                                                                column: 38,
                                                                fixed: true,
                                                                source: 'glass/html/material/PromptDialog.ion'
                                                            }
                                                        }
                                                    },
                                                    body: {
                                                        type: 'BlockStatement',
                                                        body: [{
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'ObjectExpression',
                                                                    objectType: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'Identifier',
                                                                            name: 'Field',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 32,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/PromptDialog.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 32,
                                                                                    column: 21,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/PromptDialog.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [{
                                                                                type: 'ObjectExpression',
                                                                                objectType: {
                                                                                    type: 'ObjectExpression',
                                                                                    properties: [{
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'property',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 33,
                                                                                                        column: 21,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/PromptDialog.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 33,
                                                                                                        column: 29,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/PromptDialog.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'Identifier',
                                                                                                name: 'property',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 33,
                                                                                                        column: 21,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/PromptDialog.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 33,
                                                                                                        column: 29,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/PromptDialog.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '0'
                                                                                        }]
                                                                                },
                                                                                properties: [{
                                                                                        type: 'IfStatement',
                                                                                        test: {
                                                                                            type: 'BinaryExpression',
                                                                                            operator: '&&',
                                                                                            left: {
                                                                                                type: 'UnaryExpression',
                                                                                                operator: '?',
                                                                                                argument: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'values',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 34,
                                                                                                            column: 27,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/PromptDialog.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 34,
                                                                                                            column: 33,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/PromptDialog.ion'
                                                                                                        }
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            right: {
                                                                                                type: 'UnaryExpression',
                                                                                                operator: '?',
                                                                                                argument: {
                                                                                                    type: 'MemberExpression',
                                                                                                    computed: true,
                                                                                                    object: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'values',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 34,
                                                                                                                column: 39,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/PromptDialog.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 34,
                                                                                                                column: 45,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/PromptDialog.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    property: {
                                                                                                        type: 'MemberExpression',
                                                                                                        computed: false,
                                                                                                        object: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'property',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 34,
                                                                                                                    column: 46,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/PromptDialog.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 34,
                                                                                                                    column: 54,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/PromptDialog.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        property: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'name',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 34,
                                                                                                                    column: 55,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/PromptDialog.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 34,
                                                                                                                    column: 59,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/PromptDialog.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 34,
                                                                                                                column: 46,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/PromptDialog.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 34,
                                                                                                                column: 59,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/PromptDialog.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 34,
                                                                                                            column: 39,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/PromptDialog.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 34,
                                                                                                            column: 60,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/PromptDialog.ion'
                                                                                                        }
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        consequent: {
                                                                                            type: 'BlockStatement',
                                                                                            body: [{
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'value',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 35,
                                                                                                                column: 28,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/PromptDialog.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 35,
                                                                                                                column: 33,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/PromptDialog.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'MemberExpression',
                                                                                                        computed: true,
                                                                                                        object: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'values',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 35,
                                                                                                                    column: 35,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/PromptDialog.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 35,
                                                                                                                    column: 41,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/PromptDialog.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        property: {
                                                                                                            type: 'MemberExpression',
                                                                                                            computed: false,
                                                                                                            object: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'property',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 35,
                                                                                                                        column: 42,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/PromptDialog.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 35,
                                                                                                                        column: 50,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/PromptDialog.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            property: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'name',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 35,
                                                                                                                        column: 51,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/PromptDialog.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 35,
                                                                                                                        column: 55,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/PromptDialog.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 35,
                                                                                                                    column: 42,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/PromptDialog.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 35,
                                                                                                                    column: 55,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/PromptDialog.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 35,
                                                                                                                column: 35,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/PromptDialog.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 35,
                                                                                                                column: 56,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/PromptDialog.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '0'
                                                                                                }]
                                                                                        },
                                                                                        alternate: null,
                                                                                        order: '0'
                                                                                    }]
                                                                            }],
                                                                        loc: {
                                                                            start: {
                                                                                line: 32,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/PromptDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 36,
                                                                                column: 17,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/PromptDialog.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    properties: [{
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'noLabelFloat',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 37,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/PromptDialog.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 37,
                                                                                        column: 32,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/PromptDialog.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Identifier',
                                                                                name: 'noLabelFloat',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 37,
                                                                                        column: 34,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/PromptDialog.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 37,
                                                                                        column: 46,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/PromptDialog.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 32,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/PromptDialog.ion'
                                                                    },
                                                                    end: {
                                                                        line: 38,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/PromptDialog.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    remove: null,
                                                    order: '3'
                                                }
                                            ]
                                        },
                                        loc: {
                                            start: {
                                                line: 23,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/PromptDialog.ion'
                                            },
                                            end: {
                                                line: 38,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/PromptDialog.ion'
                                            }
                                        },
                                        order: '7'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'Identifier',
                                                name: 'Div',
                                                loc: {
                                                    start: {
                                                        line: 38,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'glass/html/material/PromptDialog.ion'
                                                    },
                                                    end: {
                                                        line: 38,
                                                        column: 11,
                                                        fixed: true,
                                                        source: 'glass/html/material/PromptDialog.ion'
                                                    }
                                                }
                                            },
                                            arguments: [{
                                                    type: 'ObjectExpression',
                                                    properties: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'class',
                                                                loc: {
                                                                    start: {
                                                                        line: 38,
                                                                        column: 13,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/PromptDialog.ion'
                                                                    },
                                                                    end: {
                                                                        line: 38,
                                                                        column: 18,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/PromptDialog.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Literal',
                                                                value: 'fill'
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                }],
                                            loc: {
                                                start: {
                                                    line: 38,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'glass/html/material/PromptDialog.ion'
                                                },
                                                end: {
                                                    line: 38,
                                                    column: 27,
                                                    fixed: true,
                                                    source: 'glass/html/material/PromptDialog.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 38,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/PromptDialog.ion'
                                            },
                                            end: {
                                                line: 38,
                                                column: 27,
                                                fixed: true,
                                                source: 'glass/html/material/PromptDialog.ion'
                                            }
                                        },
                                        order: '8'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'ObjectExpression',
                                            objectType: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'Footer',
                                                    loc: {
                                                        start: {
                                                            line: 39,
                                                            column: 8,
                                                            fixed: true,
                                                            source: 'glass/html/material/PromptDialog.ion'
                                                        },
                                                        end: {
                                                            line: 39,
                                                            column: 14,
                                                            fixed: true,
                                                            source: 'glass/html/material/PromptDialog.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [{
                                                        type: 'ObjectExpression',
                                                        properties: [{
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'class',
                                                                    loc: {
                                                                        start: {
                                                                            line: 39,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/PromptDialog.ion'
                                                                        },
                                                                        end: {
                                                                            line: 39,
                                                                            column: 21,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/PromptDialog.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: 'layout horizontal reverse'
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            }]
                                                    }],
                                                loc: {
                                                    start: {
                                                        line: 39,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'glass/html/material/PromptDialog.ion'
                                                    },
                                                    end: {
                                                        line: 39,
                                                        column: 51,
                                                        fixed: true,
                                                        source: 'glass/html/material/PromptDialog.ion'
                                                    }
                                                }
                                            },
                                            properties: [
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'style',
                                                        loc: {
                                                            start: {
                                                                line: 40,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'glass/html/material/PromptDialog.ion'
                                                            },
                                                            end: {
                                                                line: 40,
                                                                column: 17,
                                                                fixed: true,
                                                                source: 'glass/html/material/PromptDialog.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'ObjectExpression',
                                                        properties: [
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'padding',
                                                                    loc: {
                                                                        start: {
                                                                            line: 41,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/PromptDialog.ion'
                                                                        },
                                                                        end: {
                                                                            line: 41,
                                                                            column: 23,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/PromptDialog.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: '0px'
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'margin',
                                                                    loc: {
                                                                        start: {
                                                                            line: 42,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/PromptDialog.ion'
                                                                        },
                                                                        end: {
                                                                            line: 42,
                                                                            column: 22,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/PromptDialog.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: '8px 2px'
                                                                },
                                                                kind: 'init',
                                                                order: '1'
                                                            }
                                                        ]
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'SubmitButton',
                                                                loc: {
                                                                    start: {
                                                                        line: 43,
                                                                        column: 12,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/PromptDialog.ion'
                                                                    },
                                                                    end: {
                                                                        line: 43,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/PromptDialog.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [],
                                                            loc: {
                                                                start: {
                                                                    line: 43,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/PromptDialog.ion'
                                                                },
                                                                end: {
                                                                    line: 43,
                                                                    column: 26,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/PromptDialog.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'raised',
                                                                    loc: {
                                                                        start: {
                                                                            line: 44,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/PromptDialog.ion'
                                                                        },
                                                                        end: {
                                                                            line: 44,
                                                                            column: 22,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/PromptDialog.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: false
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'ConditionalExpression',
                                                                    test: {
                                                                        type: 'BinaryExpression',
                                                                        operator: '!=',
                                                                        left: {
                                                                            type: 'Identifier',
                                                                            name: 'submitText',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 45,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/PromptDialog.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 45,
                                                                                    column: 26,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/PromptDialog.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        right: {
                                                                            type: 'Literal',
                                                                            value: null
                                                                        }
                                                                    },
                                                                    consequent: {
                                                                        type: 'Identifier',
                                                                        name: 'submitText',
                                                                        loc: {
                                                                            start: {
                                                                                line: 45,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/PromptDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 45,
                                                                                column: 26,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/PromptDialog.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    alternate: {
                                                                        type: 'Literal',
                                                                        value: 'Submit'
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 45,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/PromptDialog.ion'
                                                                    },
                                                                    end: {
                                                                        line: 45,
                                                                        column: 37,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/PromptDialog.ion'
                                                                    }
                                                                },
                                                                order: '1'
                                                            }
                                                        ]
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 43,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/PromptDialog.ion'
                                                        },
                                                        end: {
                                                            line: 46,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/PromptDialog.ion'
                                                        }
                                                    },
                                                    order: '1'
                                                },
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'CancelButton',
                                                                loc: {
                                                                    start: {
                                                                        line: 46,
                                                                        column: 12,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/PromptDialog.ion'
                                                                    },
                                                                    end: {
                                                                        line: 46,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/PromptDialog.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [],
                                                            loc: {
                                                                start: {
                                                                    line: 46,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/PromptDialog.ion'
                                                                },
                                                                end: {
                                                                    line: 46,
                                                                    column: 26,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/PromptDialog.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'raised',
                                                                    loc: {
                                                                        start: {
                                                                            line: 47,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/PromptDialog.ion'
                                                                        },
                                                                        end: {
                                                                            line: 47,
                                                                            column: 22,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/PromptDialog.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: false
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'ConditionalExpression',
                                                                    test: {
                                                                        type: 'BinaryExpression',
                                                                        operator: '!=',
                                                                        left: {
                                                                            type: 'Identifier',
                                                                            name: 'cancelText',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 48,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/PromptDialog.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 48,
                                                                                    column: 26,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/PromptDialog.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        right: {
                                                                            type: 'Literal',
                                                                            value: null
                                                                        }
                                                                    },
                                                                    consequent: {
                                                                        type: 'Identifier',
                                                                        name: 'cancelText',
                                                                        loc: {
                                                                            start: {
                                                                                line: 48,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/PromptDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 48,
                                                                                column: 26,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/PromptDialog.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    alternate: {
                                                                        type: 'Literal',
                                                                        value: 'Cancel'
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 48,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/PromptDialog.ion'
                                                                    },
                                                                    end: {
                                                                        line: 48,
                                                                        column: 37,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/PromptDialog.ion'
                                                                    }
                                                                },
                                                                order: '1'
                                                            }
                                                        ]
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 46,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/PromptDialog.ion'
                                                        },
                                                        end: {
                                                            line: 49,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/PromptDialog.ion'
                                                        }
                                                    },
                                                    order: '2'
                                                }
                                            ]
                                        },
                                        loc: {
                                            start: {
                                                line: 39,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/PromptDialog.ion'
                                            },
                                            end: {
                                                line: 49,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/PromptDialog.ion'
                                            }
                                        },
                                        order: '9'
                                    }
                                ]
                            }
                        }],
                    kind: 'let',
                    order: ':'
                },
                {
                    type: 'ReturnStatement',
                    argument: {
                        type: 'ObjectExpression',
                        objectType: {
                            type: 'Identifier',
                            name: 'dialog',
                            loc: {
                                start: {
                                    line: 49,
                                    column: 11,
                                    fixed: true,
                                    source: 'glass/html/material/PromptDialog.ion'
                                },
                                end: {
                                    line: 49,
                                    column: 17,
                                    fixed: true,
                                    source: 'glass/html/material/PromptDialog.ion'
                                }
                            }
                        },
                        properties: [
                            {
                                type: 'IfStatement',
                                test: {
                                    type: 'Identifier',
                                    name: 'closeOnBlur',
                                    loc: {
                                        start: {
                                            line: 50,
                                            column: 11,
                                            fixed: true,
                                            source: 'glass/html/material/PromptDialog.ion'
                                        },
                                        end: {
                                            line: 50,
                                            column: 22,
                                            fixed: true,
                                            source: 'glass/html/material/PromptDialog.ion'
                                        }
                                    }
                                },
                                consequent: {
                                    type: 'BlockStatement',
                                    body: [{
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'Function',
                                                context: true,
                                                value: function (_context3) {
                                                    return function click() {
                                                        var dialog = _context3.get('dialog');
                                                        dialog.open = false;
                                                    };
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 51,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/PromptDialog.ion'
                                                },
                                                end: {
                                                    line: 53,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/html/material/PromptDialog.ion'
                                                }
                                            },
                                            order: '0'
                                        }]
                                },
                                alternate: null,
                                order: '0'
                            },
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'focus',
                                    loc: {
                                        start: {
                                            line: 53,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/PromptDialog.ion'
                                        },
                                        end: {
                                            line: 53,
                                            column: 13,
                                            fixed: true,
                                            source: 'glass/html/material/PromptDialog.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'Function',
                                    context: true,
                                    value: function (_context4) {
                                        return function () {
                                            var form = _context4.get('form');
                                            form.focus();
                                        };
                                    }
                                },
                                kind: 'init',
                                order: '1'
                            },
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'frame',
                                    loc: {
                                        start: {
                                            line: 55,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/PromptDialog.ion'
                                        },
                                        end: {
                                            line: 55,
                                            column: 13,
                                            fixed: true,
                                            source: 'glass/html/material/PromptDialog.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'ObjectExpression',
                                    properties: [
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'style',
                                                loc: {
                                                    start: {
                                                        line: 56,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/PromptDialog.ion'
                                                    },
                                                    end: {
                                                        line: 56,
                                                        column: 17,
                                                        fixed: true,
                                                        source: 'glass/html/material/PromptDialog.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'ObjectExpression',
                                                properties: [
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'padding',
                                                            loc: {
                                                                start: {
                                                                    line: 57,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/PromptDialog.ion'
                                                                },
                                                                end: {
                                                                    line: 57,
                                                                    column: 23,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/PromptDialog.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Literal',
                                                            value: '0px'
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'width',
                                                            loc: {
                                                                start: {
                                                                    line: 58,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/PromptDialog.ion'
                                                                },
                                                                end: {
                                                                    line: 58,
                                                                    column: 21,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/PromptDialog.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Literal',
                                                            value: '400px'
                                                        },
                                                        kind: 'init',
                                                        order: '1'
                                                    },
                                                    {
                                                        type: 'IfStatement',
                                                        test: {
                                                            type: 'UnaryExpression',
                                                            operator: '?',
                                                            argument: {
                                                                type: 'Identifier',
                                                                name: 'style',
                                                                loc: {
                                                                    start: {
                                                                        line: 59,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/PromptDialog.ion'
                                                                    },
                                                                    end: {
                                                                        line: 59,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/PromptDialog.ion'
                                                                    }
                                                                }
                                                            }
                                                        },
                                                        consequent: {
                                                            type: 'BlockStatement',
                                                            body: [{
                                                                    type: 'ForInStatement',
                                                                    left: {
                                                                        type: 'VariableDeclaration',
                                                                        declarations: [
                                                                            {
                                                                                type: 'VariableDeclarator',
                                                                                id: {
                                                                                    type: 'Identifier',
                                                                                    name: 'key',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 60,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/PromptDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 60,
                                                                                            column: 27,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/PromptDialog.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                init: null
                                                                            },
                                                                            {
                                                                                type: 'VariableDeclarator',
                                                                                id: {
                                                                                    type: 'Identifier',
                                                                                    name: 'value',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 60,
                                                                                            column: 29,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/PromptDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 60,
                                                                                            column: 34,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/PromptDialog.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                init: null
                                                                            }
                                                                        ],
                                                                        kind: 'let'
                                                                    },
                                                                    right: {
                                                                        type: 'Identifier',
                                                                        name: 'style',
                                                                        loc: {
                                                                            start: {
                                                                                line: 60,
                                                                                column: 38,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/PromptDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 60,
                                                                                column: 43,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/PromptDialog.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    body: {
                                                                        type: 'BlockStatement',
                                                                        body: [{
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'key',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 61,
                                                                                            column: 25,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/PromptDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 61,
                                                                                            column: 28,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/PromptDialog.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Identifier',
                                                                                    name: 'value',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 61,
                                                                                            column: 31,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/PromptDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 61,
                                                                                            column: 36,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/PromptDialog.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                kind: 'init',
                                                                                computed: true,
                                                                                order: '0'
                                                                            }]
                                                                    },
                                                                    remove: null,
                                                                    order: '0'
                                                                }]
                                                        },
                                                        alternate: null,
                                                        order: '2'
                                                    }
                                                ]
                                            },
                                            kind: 'init',
                                            order: '0'
                                        },
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'ObjectExpression',
                                                objectType: {
                                                    type: 'Identifier',
                                                    name: 'form',
                                                    loc: {
                                                        start: {
                                                            line: 62,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/PromptDialog.ion'
                                                        },
                                                        end: {
                                                            line: 62,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/PromptDialog.ion'
                                                        }
                                                    }
                                                },
                                                properties: [{
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'style',
                                                            loc: {
                                                                start: {
                                                                    line: 63,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/PromptDialog.ion'
                                                                },
                                                                end: {
                                                                    line: 63,
                                                                    column: 21,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/PromptDialog.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'ObjectExpression',
                                                            properties: [{
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'overflow',
                                                                        loc: {
                                                                            start: {
                                                                                line: 64,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/PromptDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 64,
                                                                                column: 28,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/PromptDialog.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Literal',
                                                                        value: 'visible'
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                }]
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    }]
                                            },
                                            loc: {
                                                start: {
                                                    line: 62,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/PromptDialog.ion'
                                                },
                                                end: {
                                                    line: 66,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/html/material/PromptDialog.ion'
                                                }
                                            },
                                            order: '1'
                                        }
                                    ]
                                },
                                kind: 'init',
                                order: '2'
                            }
                        ]
                    },
                    order: ';'
                }
            ],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'PromptDialog',
                loc: {
                    start: {
                        line: 6,
                        column: 15,
                        fixed: true,
                        source: 'glass/html/material/PromptDialog.ion'
                    },
                    end: {
                        line: 6,
                        column: 27,
                        fixed: true,
                        source: 'glass/html/material/PromptDialog.ion'
                    }
                }
            }
        }, {
            this: this,
            _ref3: _ref3,
            glass: glass,
            _ref: _ref,
            _ref2: _ref2,
            Dialog: Dialog,
            GlassForm: GlassForm,
            CancelButton: CancelButton,
            SubmitButton: SubmitButton,
            Field: Field,
            PromptDialog: PromptDialog,
            show: show
        }, null);
    });
var show = exports.show = function (args) {
        Dialog.show(PromptDialog, args);
    };
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/PromptDialog',_glass_html_material_PromptDialog_);
    else
      _glass_html_material_PromptDialog_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_PromptDialog_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_RecordChip_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('./');
var Chip = _ref.Chip;
var RecordIcon = _ref.RecordIcon;
module.exports = exports = ion.template(function RecordChip(args) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'RecordChip',
            loc: {
                start: {
                    line: 4,
                    column: 16,
                    fixed: true,
                    source: 'glass/html/material/RecordChip.ion'
                },
                end: {
                    line: 4,
                    column: 26,
                    fixed: true,
                    source: 'glass/html/material/RecordChip.ion'
                }
            }
        },
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: '_ref2'
                        },
                        init: {
                            type: 'Identifier',
                            name: 'args',
                            loc: {
                                start: {
                                    line: 5,
                                    column: 50,
                                    fixed: true,
                                    source: 'glass/html/material/RecordChip.ion'
                                },
                                end: {
                                    line: 5,
                                    column: 54,
                                    fixed: true,
                                    source: 'glass/html/material/RecordChip.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'record',
                            loc: {
                                start: {
                                    line: 5,
                                    column: 9,
                                    fixed: true,
                                    source: 'glass/html/material/RecordChip.ion'
                                },
                                end: {
                                    line: 5,
                                    column: 15,
                                    fixed: true,
                                    source: 'glass/html/material/RecordChip.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref2'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'record',
                                loc: {
                                    start: {
                                        line: 5,
                                        column: 9,
                                        fixed: true,
                                        source: 'glass/html/material/RecordChip.ion'
                                    },
                                    end: {
                                        line: 5,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/RecordChip.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'details',
                            loc: {
                                start: {
                                    line: 5,
                                    column: 17,
                                    fixed: true,
                                    source: 'glass/html/material/RecordChip.ion'
                                },
                                end: {
                                    line: 5,
                                    column: 24,
                                    fixed: true,
                                    source: 'glass/html/material/RecordChip.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref2'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'details',
                                loc: {
                                    start: {
                                        line: 5,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/html/material/RecordChip.ion'
                                    },
                                    end: {
                                        line: 5,
                                        column: 24,
                                        fixed: true,
                                        source: 'glass/html/material/RecordChip.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'property',
                            loc: {
                                start: {
                                    line: 5,
                                    column: 26,
                                    fixed: true,
                                    source: 'glass/html/material/RecordChip.ion'
                                },
                                end: {
                                    line: 5,
                                    column: 34,
                                    fixed: true,
                                    source: 'glass/html/material/RecordChip.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref2'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'property',
                                loc: {
                                    start: {
                                        line: 5,
                                        column: 26,
                                        fixed: true,
                                        source: 'glass/html/material/RecordChip.ion'
                                    },
                                    end: {
                                        line: 5,
                                        column: 34,
                                        fixed: true,
                                        source: 'glass/html/material/RecordChip.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '3'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'showRemove',
                            loc: {
                                start: {
                                    line: 5,
                                    column: 36,
                                    fixed: true,
                                    source: 'glass/html/material/RecordChip.ion'
                                },
                                end: {
                                    line: 5,
                                    column: 46,
                                    fixed: true,
                                    source: 'glass/html/material/RecordChip.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref2'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'showRemove',
                                loc: {
                                    start: {
                                        line: 5,
                                        column: 36,
                                        fixed: true,
                                        source: 'glass/html/material/RecordChip.ion'
                                    },
                                    end: {
                                        line: 5,
                                        column: 46,
                                        fixed: true,
                                        source: 'glass/html/material/RecordChip.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '4'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'chip',
                            loc: {
                                start: {
                                    line: 6,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/RecordChip.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/RecordChip.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Chip',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/RecordChip.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 19,
                                        fixed: true,
                                        source: 'glass/html/material/RecordChip.ion'
                                    }
                                }
                            },
                            arguments: [],
                            loc: {
                                start: {
                                    line: 6,
                                    column: 15,
                                    fixed: true,
                                    source: 'glass/html/material/RecordChip.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 21,
                                    fixed: true,
                                    source: 'glass/html/material/RecordChip.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '5'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'Identifier',
                        name: 'chip',
                        loc: {
                            start: {
                                line: 7,
                                column: 11,
                                fixed: true,
                                source: 'glass/html/material/RecordChip.ion'
                            },
                            end: {
                                line: 7,
                                column: 15,
                                fixed: true,
                                source: 'glass/html/material/RecordChip.ion'
                            }
                        }
                    },
                    properties: [
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'style',
                                loc: {
                                    start: {
                                        line: 8,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/RecordChip.ion'
                                    },
                                    end: {
                                        line: 8,
                                        column: 13,
                                        fixed: true,
                                        source: 'glass/html/material/RecordChip.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'ObjectExpression',
                                properties: [{
                                        type: 'IfStatement',
                                        test: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'record',
                                                    loc: {
                                                        start: {
                                                            line: 9,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordChip.ion'
                                                        },
                                                        end: {
                                                            line: 9,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordChip.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'constructor',
                                                    loc: {
                                                        start: {
                                                            line: 9,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordChip.ion'
                                                        },
                                                        end: {
                                                            line: 9,
                                                            column: 33,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordChip.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 9,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'glass/html/material/RecordChip.ion'
                                                    },
                                                    end: {
                                                        line: 9,
                                                        column: 33,
                                                        fixed: true,
                                                        source: 'glass/html/material/RecordChip.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'square',
                                                loc: {
                                                    start: {
                                                        line: 9,
                                                        column: 34,
                                                        fixed: true,
                                                        source: 'glass/html/material/RecordChip.ion'
                                                    },
                                                    end: {
                                                        line: 9,
                                                        column: 40,
                                                        fixed: true,
                                                        source: 'glass/html/material/RecordChip.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 9,
                                                    column: 15,
                                                    fixed: true,
                                                    source: 'glass/html/material/RecordChip.ion'
                                                },
                                                end: {
                                                    line: 9,
                                                    column: 40,
                                                    fixed: true,
                                                    source: 'glass/html/material/RecordChip.ion'
                                                }
                                            }
                                        },
                                        consequent: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'borderRadius',
                                                        loc: {
                                                            start: {
                                                                line: 10,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/RecordChip.ion'
                                                            },
                                                            end: {
                                                                line: 10,
                                                                column: 28,
                                                                fixed: true,
                                                                source: 'glass/html/material/RecordChip.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: '0%'
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                }]
                                        },
                                        alternate: null,
                                        order: '0'
                                    }]
                            },
                            kind: 'init',
                            order: '0'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'left',
                                loc: {
                                    start: {
                                        line: 11,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/RecordChip.ion'
                                    },
                                    end: {
                                        line: 11,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/RecordChip.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'ObjectExpression',
                                properties: [{
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'Identifier',
                                                name: 'RecordIcon',
                                                loc: {
                                                    start: {
                                                        line: 12,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/RecordChip.ion'
                                                    },
                                                    end: {
                                                        line: 12,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'glass/html/material/RecordChip.ion'
                                                    }
                                                }
                                            },
                                            arguments: [{
                                                    type: 'ObjectExpression',
                                                    properties: [
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'record',
                                                                loc: {
                                                                    start: {
                                                                        line: 12,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordChip.ion'
                                                                    },
                                                                    end: {
                                                                        line: 12,
                                                                        column: 30,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordChip.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Identifier',
                                                                name: 'record',
                                                                loc: {
                                                                    start: {
                                                                        line: 12,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordChip.ion'
                                                                    },
                                                                    end: {
                                                                        line: 12,
                                                                        column: 30,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordChip.ion'
                                                                    }
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        },
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'size',
                                                                loc: {
                                                                    start: {
                                                                        line: 12,
                                                                        column: 31,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordChip.ion'
                                                                    },
                                                                    end: {
                                                                        line: 12,
                                                                        column: 35,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordChip.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Literal',
                                                                value: 24
                                                            },
                                                            kind: 'init',
                                                            order: '1'
                                                        },
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'property',
                                                                loc: {
                                                                    start: {
                                                                        line: 12,
                                                                        column: 39,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordChip.ion'
                                                                    },
                                                                    end: {
                                                                        line: 12,
                                                                        column: 47,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordChip.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Identifier',
                                                                name: 'property',
                                                                loc: {
                                                                    start: {
                                                                        line: 12,
                                                                        column: 39,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordChip.ion'
                                                                    },
                                                                    end: {
                                                                        line: 12,
                                                                        column: 47,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordChip.ion'
                                                                    }
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '2'
                                                        },
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'details',
                                                                loc: {
                                                                    start: {
                                                                        line: 12,
                                                                        column: 48,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordChip.ion'
                                                                    },
                                                                    end: {
                                                                        line: 12,
                                                                        column: 55,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordChip.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Identifier',
                                                                name: 'details',
                                                                loc: {
                                                                    start: {
                                                                        line: 12,
                                                                        column: 48,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordChip.ion'
                                                                    },
                                                                    end: {
                                                                        line: 12,
                                                                        column: 55,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordChip.ion'
                                                                    }
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '3'
                                                        }
                                                    ]
                                                }],
                                            loc: {
                                                start: {
                                                    line: 12,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/RecordChip.ion'
                                                },
                                                end: {
                                                    line: 12,
                                                    column: 57,
                                                    fixed: true,
                                                    source: 'glass/html/material/RecordChip.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 12,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/RecordChip.ion'
                                            },
                                            end: {
                                                line: 12,
                                                column: 57,
                                                fixed: true,
                                                source: 'glass/html/material/RecordChip.ion'
                                            }
                                        },
                                        order: '0'
                                    }]
                            },
                            kind: 'init',
                            order: '1'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'content',
                                loc: {
                                    start: {
                                        line: 13,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/RecordChip.ion'
                                    },
                                    end: {
                                        line: 13,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/RecordChip.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'record',
                                    loc: {
                                        start: {
                                            line: 13,
                                            column: 17,
                                            fixed: true,
                                            source: 'glass/html/material/RecordChip.ion'
                                        },
                                        end: {
                                            line: 13,
                                            column: 23,
                                            fixed: true,
                                            source: 'glass/html/material/RecordChip.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'name',
                                    loc: {
                                        start: {
                                            line: 13,
                                            column: 24,
                                            fixed: true,
                                            source: 'glass/html/material/RecordChip.ion'
                                        },
                                        end: {
                                            line: 13,
                                            column: 28,
                                            fixed: true,
                                            source: 'glass/html/material/RecordChip.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 13,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/html/material/RecordChip.ion'
                                    },
                                    end: {
                                        line: 13,
                                        column: 28,
                                        fixed: true,
                                        source: 'glass/html/material/RecordChip.ion'
                                    }
                                }
                            },
                            kind: 'init',
                            order: '2'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'contentShort',
                                loc: {
                                    start: {
                                        line: 14,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/RecordChip.ion'
                                    },
                                    end: {
                                        line: 14,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/RecordChip.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'record',
                                    loc: {
                                        start: {
                                            line: 14,
                                            column: 22,
                                            fixed: true,
                                            source: 'glass/html/material/RecordChip.ion'
                                        },
                                        end: {
                                            line: 14,
                                            column: 28,
                                            fixed: true,
                                            source: 'glass/html/material/RecordChip.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'abbreviation',
                                    loc: {
                                        start: {
                                            line: 14,
                                            column: 29,
                                            fixed: true,
                                            source: 'glass/html/material/RecordChip.ion'
                                        },
                                        end: {
                                            line: 14,
                                            column: 41,
                                            fixed: true,
                                            source: 'glass/html/material/RecordChip.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 14,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/material/RecordChip.ion'
                                    },
                                    end: {
                                        line: 14,
                                        column: 41,
                                        fixed: true,
                                        source: 'glass/html/material/RecordChip.ion'
                                    }
                                }
                            },
                            kind: 'init',
                            order: '3'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'title',
                                loc: {
                                    start: {
                                        line: 15,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/RecordChip.ion'
                                    },
                                    end: {
                                        line: 15,
                                        column: 13,
                                        fixed: true,
                                        source: 'glass/html/material/RecordChip.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'ConditionalExpression',
                                test: {
                                    type: 'BinaryExpression',
                                    operator: '!=',
                                    left: {
                                        type: 'ConditionalExpression',
                                        test: {
                                            type: 'BinaryExpression',
                                            operator: '!=',
                                            left: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'record',
                                                    loc: {
                                                        start: {
                                                            line: 15,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordChip.ion'
                                                        },
                                                        end: {
                                                            line: 15,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordChip.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'email',
                                                    loc: {
                                                        start: {
                                                            line: 15,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordChip.ion'
                                                        },
                                                        end: {
                                                            line: 15,
                                                            column: 27,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordChip.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 15,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'glass/html/material/RecordChip.ion'
                                                    },
                                                    end: {
                                                        line: 15,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'glass/html/material/RecordChip.ion'
                                                    }
                                                }
                                            },
                                            right: {
                                                type: 'Literal',
                                                value: null
                                            }
                                        },
                                        consequent: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'record',
                                                loc: {
                                                    start: {
                                                        line: 15,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'glass/html/material/RecordChip.ion'
                                                    },
                                                    end: {
                                                        line: 15,
                                                        column: 21,
                                                        fixed: true,
                                                        source: 'glass/html/material/RecordChip.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'email',
                                                loc: {
                                                    start: {
                                                        line: 15,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'glass/html/material/RecordChip.ion'
                                                    },
                                                    end: {
                                                        line: 15,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'glass/html/material/RecordChip.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 15,
                                                    column: 15,
                                                    fixed: true,
                                                    source: 'glass/html/material/RecordChip.ion'
                                                },
                                                end: {
                                                    line: 15,
                                                    column: 27,
                                                    fixed: true,
                                                    source: 'glass/html/material/RecordChip.ion'
                                                }
                                            }
                                        },
                                        alternate: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'record',
                                                loc: {
                                                    start: {
                                                        line: 15,
                                                        column: 30,
                                                        fixed: true,
                                                        source: 'glass/html/material/RecordChip.ion'
                                                    },
                                                    end: {
                                                        line: 15,
                                                        column: 36,
                                                        fixed: true,
                                                        source: 'glass/html/material/RecordChip.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'description',
                                                loc: {
                                                    start: {
                                                        line: 15,
                                                        column: 37,
                                                        fixed: true,
                                                        source: 'glass/html/material/RecordChip.ion'
                                                    },
                                                    end: {
                                                        line: 15,
                                                        column: 48,
                                                        fixed: true,
                                                        source: 'glass/html/material/RecordChip.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 15,
                                                    column: 30,
                                                    fixed: true,
                                                    source: 'glass/html/material/RecordChip.ion'
                                                },
                                                end: {
                                                    line: 15,
                                                    column: 48,
                                                    fixed: true,
                                                    source: 'glass/html/material/RecordChip.ion'
                                                }
                                            }
                                        }
                                    },
                                    right: {
                                        type: 'Literal',
                                        value: null
                                    }
                                },
                                consequent: {
                                    type: 'ConditionalExpression',
                                    test: {
                                        type: 'BinaryExpression',
                                        operator: '!=',
                                        left: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'record',
                                                loc: {
                                                    start: {
                                                        line: 15,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'glass/html/material/RecordChip.ion'
                                                    },
                                                    end: {
                                                        line: 15,
                                                        column: 21,
                                                        fixed: true,
                                                        source: 'glass/html/material/RecordChip.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'email',
                                                loc: {
                                                    start: {
                                                        line: 15,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'glass/html/material/RecordChip.ion'
                                                    },
                                                    end: {
                                                        line: 15,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'glass/html/material/RecordChip.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 15,
                                                    column: 15,
                                                    fixed: true,
                                                    source: 'glass/html/material/RecordChip.ion'
                                                },
                                                end: {
                                                    line: 15,
                                                    column: 27,
                                                    fixed: true,
                                                    source: 'glass/html/material/RecordChip.ion'
                                                }
                                            }
                                        },
                                        right: {
                                            type: 'Literal',
                                            value: null
                                        }
                                    },
                                    consequent: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'record',
                                            loc: {
                                                start: {
                                                    line: 15,
                                                    column: 15,
                                                    fixed: true,
                                                    source: 'glass/html/material/RecordChip.ion'
                                                },
                                                end: {
                                                    line: 15,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'glass/html/material/RecordChip.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'email',
                                            loc: {
                                                start: {
                                                    line: 15,
                                                    column: 22,
                                                    fixed: true,
                                                    source: 'glass/html/material/RecordChip.ion'
                                                },
                                                end: {
                                                    line: 15,
                                                    column: 27,
                                                    fixed: true,
                                                    source: 'glass/html/material/RecordChip.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 15,
                                                column: 15,
                                                fixed: true,
                                                source: 'glass/html/material/RecordChip.ion'
                                            },
                                            end: {
                                                line: 15,
                                                column: 27,
                                                fixed: true,
                                                source: 'glass/html/material/RecordChip.ion'
                                            }
                                        }
                                    },
                                    alternate: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'record',
                                            loc: {
                                                start: {
                                                    line: 15,
                                                    column: 30,
                                                    fixed: true,
                                                    source: 'glass/html/material/RecordChip.ion'
                                                },
                                                end: {
                                                    line: 15,
                                                    column: 36,
                                                    fixed: true,
                                                    source: 'glass/html/material/RecordChip.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'description',
                                            loc: {
                                                start: {
                                                    line: 15,
                                                    column: 37,
                                                    fixed: true,
                                                    source: 'glass/html/material/RecordChip.ion'
                                                },
                                                end: {
                                                    line: 15,
                                                    column: 48,
                                                    fixed: true,
                                                    source: 'glass/html/material/RecordChip.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 15,
                                                column: 30,
                                                fixed: true,
                                                source: 'glass/html/material/RecordChip.ion'
                                            },
                                            end: {
                                                line: 15,
                                                column: 48,
                                                fixed: true,
                                                source: 'glass/html/material/RecordChip.ion'
                                            }
                                        }
                                    }
                                },
                                alternate: {
                                    type: 'Literal',
                                    value: ''
                                }
                            },
                            kind: 'init',
                            order: '4'
                        },
                        {
                            type: 'IfStatement',
                            test: {
                                type: 'Identifier',
                                name: 'showRemove',
                                loc: {
                                    start: {
                                        line: 16,
                                        column: 11,
                                        fixed: true,
                                        source: 'glass/html/material/RecordChip.ion'
                                    },
                                    end: {
                                        line: 16,
                                        column: 21,
                                        fixed: true,
                                        source: 'glass/html/material/RecordChip.ion'
                                    }
                                }
                            },
                            consequent: {
                                type: 'BlockStatement',
                                body: [{
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'ObjectExpression',
                                            objectType: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'IronIcon',
                                                    loc: {
                                                        start: {
                                                            line: 17,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordChip.ion'
                                                        },
                                                        end: {
                                                            line: 17,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordChip.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [],
                                                loc: {
                                                    start: {
                                                        line: 17,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/RecordChip.ion'
                                                    },
                                                    end: {
                                                        line: 17,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'glass/html/material/RecordChip.ion'
                                                    }
                                                }
                                            },
                                            properties: [
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'icon',
                                                        loc: {
                                                            start: {
                                                                line: 18,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/RecordChip.ion'
                                                            },
                                                            end: {
                                                                line: 18,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'glass/html/material/RecordChip.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 'remove-circle'
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'style',
                                                        loc: {
                                                            start: {
                                                                line: 19,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/RecordChip.ion'
                                                            },
                                                            end: {
                                                                line: 19,
                                                                column: 21,
                                                                fixed: true,
                                                                source: 'glass/html/material/RecordChip.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'ObjectExpression',
                                                        properties: [
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'marginRight',
                                                                    loc: {
                                                                        start: {
                                                                            line: 20,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RecordChip.ion'
                                                                        },
                                                                        end: {
                                                                            line: 20,
                                                                            column: 31,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RecordChip.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: '4px'
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'cursor',
                                                                    loc: {
                                                                        start: {
                                                                            line: 21,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RecordChip.ion'
                                                                        },
                                                                        end: {
                                                                            line: 21,
                                                                            column: 26,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RecordChip.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: 'pointer'
                                                                },
                                                                kind: 'init',
                                                                order: '1'
                                                            }
                                                        ]
                                                    },
                                                    kind: 'init',
                                                    order: '1'
                                                },
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'Function',
                                                        context: true,
                                                        value: function (_context) {
                                                            return function click(e) {
                                                                var chip = _context.get('chip');
                                                                chip.dispatchEvent(new CustomEvent('remove'));
                                                            };
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 22,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordChip.ion'
                                                        },
                                                        end: {
                                                            line: 24,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordChip.ion'
                                                        }
                                                    },
                                                    order: '2'
                                                },
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'Function',
                                                        context: false,
                                                        value: function mousedown(e) {
                                                            e.preventDefault();
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 24,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordChip.ion'
                                                        },
                                                        end: {
                                                            line: 27,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordChip.ion'
                                                        }
                                                    },
                                                    order: '3'
                                                }
                                            ]
                                        },
                                        loc: {
                                            start: {
                                                line: 17,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/RecordChip.ion'
                                            },
                                            end: {
                                                line: 27,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/RecordChip.ion'
                                            }
                                        },
                                        order: '0'
                                    }]
                            },
                            alternate: null,
                            order: '5'
                        }
                    ]
                },
                order: '6'
            }
        ],
        bound: false
    }, {
        this: this,
        args: args,
        _ref: _ref,
        Chip: Chip,
        RecordIcon: RecordIcon
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/RecordChip',_glass_html_material_RecordChip_);
    else
      _glass_html_material_RecordChip_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_RecordChip_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_RecordIcon_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('../');
var style = _ref.style;
module.exports = exports = ion.template(function RecordIcon(args) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'RecordIcon',
            loc: {
                start: {
                    line: 3,
                    column: 16,
                    fixed: true,
                    source: 'glass/html/material/RecordIcon.ion'
                },
                end: {
                    line: 3,
                    column: 26,
                    fixed: true,
                    source: 'glass/html/material/RecordIcon.ion'
                }
            }
        },
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: '_ref2'
                        },
                        init: {
                            type: 'Identifier',
                            name: 'args',
                            loc: {
                                start: {
                                    line: 4,
                                    column: 30,
                                    fixed: true,
                                    source: 'glass/html/material/RecordIcon.ion'
                                },
                                end: {
                                    line: 4,
                                    column: 34,
                                    fixed: true,
                                    source: 'glass/html/material/RecordIcon.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'record',
                            loc: {
                                start: {
                                    line: 4,
                                    column: 9,
                                    fixed: true,
                                    source: 'glass/html/material/RecordIcon.ion'
                                },
                                end: {
                                    line: 4,
                                    column: 15,
                                    fixed: true,
                                    source: 'glass/html/material/RecordIcon.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref2'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'record',
                                loc: {
                                    start: {
                                        line: 4,
                                        column: 9,
                                        fixed: true,
                                        source: 'glass/html/material/RecordIcon.ion'
                                    },
                                    end: {
                                        line: 4,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/RecordIcon.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: '_size',
                            loc: {
                                start: {
                                    line: 4,
                                    column: 21,
                                    fixed: true,
                                    source: 'glass/html/material/RecordIcon.ion'
                                },
                                end: {
                                    line: 4,
                                    column: 26,
                                    fixed: true,
                                    source: 'glass/html/material/RecordIcon.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref2'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'size',
                                loc: {
                                    start: {
                                        line: 4,
                                        column: 16,
                                        fixed: true,
                                        source: 'glass/html/material/RecordIcon.ion'
                                    },
                                    end: {
                                        line: 4,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/RecordIcon.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'size',
                            loc: {
                                start: {
                                    line: 5,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/RecordIcon.ion'
                                },
                                end: {
                                    line: 5,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/RecordIcon.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ConditionalExpression',
                            test: {
                                type: 'BinaryExpression',
                                operator: '!=',
                                left: {
                                    type: 'Identifier',
                                    name: '_size',
                                    loc: {
                                        start: {
                                            line: 5,
                                            column: 15,
                                            fixed: true,
                                            source: 'glass/html/material/RecordIcon.ion'
                                        },
                                        end: {
                                            line: 5,
                                            column: 20,
                                            fixed: true,
                                            source: 'glass/html/material/RecordIcon.ion'
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: null
                                }
                            },
                            consequent: {
                                type: 'Identifier',
                                name: '_size',
                                loc: {
                                    start: {
                                        line: 5,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/RecordIcon.ion'
                                    },
                                    end: {
                                        line: 5,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/RecordIcon.ion'
                                    }
                                }
                            },
                            alternate: {
                                type: 'Literal',
                                value: 40
                            }
                        }
                    }],
                kind: 'let',
                order: '3'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'img',
                            loc: {
                                start: {
                                    line: 6,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/RecordIcon.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 11,
                                    fixed: true,
                                    source: 'glass/html/material/RecordIcon.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ConditionalExpression',
                            test: {
                                type: 'UnaryExpression',
                                operator: '?',
                                argument: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'record',
                                        loc: {
                                            start: {
                                                line: 6,
                                                column: 14,
                                                fixed: true,
                                                source: 'glass/html/material/RecordIcon.ion'
                                            },
                                            end: {
                                                line: 6,
                                                column: 20,
                                                fixed: true,
                                                source: 'glass/html/material/RecordIcon.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'picture',
                                        loc: {
                                            start: {
                                                line: 6,
                                                column: 21,
                                                fixed: true,
                                                source: 'glass/html/material/RecordIcon.ion'
                                            },
                                            end: {
                                                line: 6,
                                                column: 28,
                                                fixed: true,
                                                source: 'glass/html/material/RecordIcon.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 6,
                                            column: 14,
                                            fixed: true,
                                            source: 'glass/html/material/RecordIcon.ion'
                                        },
                                        end: {
                                            line: 6,
                                            column: 28,
                                            fixed: true,
                                            source: 'glass/html/material/RecordIcon.ion'
                                        }
                                    }
                                }
                            },
                            consequent: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Img',
                                    loc: {
                                        start: {
                                            line: 6,
                                            column: 32,
                                            fixed: true,
                                            source: 'glass/html/material/RecordIcon.ion'
                                        },
                                        end: {
                                            line: 6,
                                            column: 35,
                                            fixed: true,
                                            source: 'glass/html/material/RecordIcon.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'src',
                                                    loc: {
                                                        start: {
                                                            line: 6,
                                                            column: 37,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordIcon.ion'
                                                        },
                                                        end: {
                                                            line: 6,
                                                            column: 40,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordIcon.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'record',
                                                        loc: {
                                                            start: {
                                                                line: 6,
                                                                column: 41,
                                                                fixed: true,
                                                                source: 'glass/html/material/RecordIcon.ion'
                                                            },
                                                            end: {
                                                                line: 6,
                                                                column: 47,
                                                                fixed: true,
                                                                source: 'glass/html/material/RecordIcon.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'picture',
                                                        loc: {
                                                            start: {
                                                                line: 6,
                                                                column: 48,
                                                                fixed: true,
                                                                source: 'glass/html/material/RecordIcon.ion'
                                                            },
                                                            end: {
                                                                line: 6,
                                                                column: 55,
                                                                fixed: true,
                                                                source: 'glass/html/material/RecordIcon.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 6,
                                                            column: 41,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordIcon.ion'
                                                        },
                                                        end: {
                                                            line: 6,
                                                            column: 55,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordIcon.ion'
                                                        }
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    }],
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 32,
                                        fixed: true,
                                        source: 'glass/html/material/RecordIcon.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 57,
                                        fixed: true,
                                        source: 'glass/html/material/RecordIcon.ion'
                                    }
                                }
                            },
                            alternate: {
                                type: 'ObjectExpression',
                                properties: []
                            }
                        }
                    }],
                kind: 'let',
                order: '4'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'hasImg',
                            loc: {
                                start: {
                                    line: 7,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/RecordIcon.ion'
                                },
                                end: {
                                    line: 7,
                                    column: 14,
                                    fixed: true,
                                    source: 'glass/html/material/RecordIcon.ion'
                                }
                            }
                        },
                        init: {
                            type: 'BinaryExpression',
                            operator: '&&',
                            left: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'img',
                                    loc: {
                                        start: {
                                            line: 7,
                                            column: 17,
                                            fixed: true,
                                            source: 'glass/html/material/RecordIcon.ion'
                                        },
                                        end: {
                                            line: 7,
                                            column: 20,
                                            fixed: true,
                                            source: 'glass/html/material/RecordIcon.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'complete',
                                    loc: {
                                        start: {
                                            line: 7,
                                            column: 21,
                                            fixed: true,
                                            source: 'glass/html/material/RecordIcon.ion'
                                        },
                                        end: {
                                            line: 7,
                                            column: 29,
                                            fixed: true,
                                            source: 'glass/html/material/RecordIcon.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 7,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/html/material/RecordIcon.ion'
                                    },
                                    end: {
                                        line: 7,
                                        column: 29,
                                        fixed: true,
                                        source: 'glass/html/material/RecordIcon.ion'
                                    }
                                }
                            },
                            right: {
                                type: 'BinaryExpression',
                                operator: '>',
                                left: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'img',
                                        loc: {
                                            start: {
                                                line: 7,
                                                column: 34,
                                                fixed: true,
                                                source: 'glass/html/material/RecordIcon.ion'
                                            },
                                            end: {
                                                line: 7,
                                                column: 37,
                                                fixed: true,
                                                source: 'glass/html/material/RecordIcon.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'width',
                                        loc: {
                                            start: {
                                                line: 7,
                                                column: 38,
                                                fixed: true,
                                                source: 'glass/html/material/RecordIcon.ion'
                                            },
                                            end: {
                                                line: 7,
                                                column: 43,
                                                fixed: true,
                                                source: 'glass/html/material/RecordIcon.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 7,
                                            column: 34,
                                            fixed: true,
                                            source: 'glass/html/material/RecordIcon.ion'
                                        },
                                        end: {
                                            line: 7,
                                            column: 43,
                                            fixed: true,
                                            source: 'glass/html/material/RecordIcon.ion'
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: 0
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '5'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'icon',
                            loc: {
                                start: {
                                    line: 8,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/RecordIcon.ion'
                                },
                                end: {
                                    line: 8,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/RecordIcon.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'ConditionalExpression',
                                test: {
                                    type: 'Identifier',
                                    name: 'hasImg',
                                    loc: {
                                        start: {
                                            line: 8,
                                            column: 16,
                                            fixed: true,
                                            source: 'glass/html/material/RecordIcon.ion'
                                        },
                                        end: {
                                            line: 8,
                                            column: 22,
                                            fixed: true,
                                            source: 'glass/html/material/RecordIcon.ion'
                                        }
                                    }
                                },
                                consequent: {
                                    type: 'Identifier',
                                    name: 'IronIcon',
                                    loc: {
                                        start: {
                                            line: 8,
                                            column: 25,
                                            fixed: true,
                                            source: 'glass/html/material/RecordIcon.ion'
                                        },
                                        end: {
                                            line: 8,
                                            column: 33,
                                            fixed: true,
                                            source: 'glass/html/material/RecordIcon.ion'
                                        }
                                    }
                                },
                                alternate: {
                                    type: 'Identifier',
                                    name: 'Div',
                                    loc: {
                                        start: {
                                            line: 8,
                                            column: 36,
                                            fixed: true,
                                            source: 'glass/html/material/RecordIcon.ion'
                                        },
                                        end: {
                                            line: 8,
                                            column: 39,
                                            fixed: true,
                                            source: 'glass/html/material/RecordIcon.ion'
                                        }
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ObjectExpression',
                                    properties: [{
                                            type: 'Property',
                                            key: {
                                                type: 'Literal',
                                                value: 'item-icon'
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: true
                                            },
                                            kind: 'init',
                                            order: '0'
                                        }]
                                }],
                            loc: {
                                start: {
                                    line: 8,
                                    column: 15,
                                    fixed: true,
                                    source: 'glass/html/material/RecordIcon.ion'
                                },
                                end: {
                                    line: 8,
                                    column: 60,
                                    fixed: true,
                                    source: 'glass/html/material/RecordIcon.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '6'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'Identifier',
                        name: 'icon',
                        loc: {
                            start: {
                                line: 9,
                                column: 11,
                                fixed: true,
                                source: 'glass/html/material/RecordIcon.ion'
                            },
                            end: {
                                line: 9,
                                column: 15,
                                fixed: true,
                                source: 'glass/html/material/RecordIcon.ion'
                            }
                        }
                    },
                    properties: [
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'style',
                                loc: {
                                    start: {
                                        line: 10,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/RecordIcon.ion'
                                    },
                                    end: {
                                        line: 10,
                                        column: 13,
                                        fixed: true,
                                        source: 'glass/html/material/RecordIcon.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'ObjectExpression',
                                properties: [
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'width',
                                            loc: {
                                                start: {
                                                    line: 11,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/RecordIcon.ion'
                                                },
                                                end: {
                                                    line: 11,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'glass/html/material/RecordIcon.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'BinaryExpression',
                                            operator: '+',
                                            left: {
                                                type: 'BinaryExpression',
                                                operator: '+',
                                                left: {
                                                    type: 'Literal',
                                                    value: ''
                                                },
                                                right: {
                                                    type: 'Identifier',
                                                    name: 'size',
                                                    loc: {
                                                        start: {
                                                            line: 11,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordIcon.ion'
                                                        },
                                                        end: {
                                                            line: 11,
                                                            column: 26,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordIcon.ion'
                                                        }
                                                    }
                                                }
                                            },
                                            right: {
                                                type: 'Literal',
                                                value: 'px'
                                            }
                                        },
                                        kind: 'init',
                                        order: '0'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'height',
                                            loc: {
                                                start: {
                                                    line: 12,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/RecordIcon.ion'
                                                },
                                                end: {
                                                    line: 12,
                                                    column: 18,
                                                    fixed: true,
                                                    source: 'glass/html/material/RecordIcon.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'BinaryExpression',
                                            operator: '+',
                                            left: {
                                                type: 'BinaryExpression',
                                                operator: '+',
                                                left: {
                                                    type: 'Literal',
                                                    value: ''
                                                },
                                                right: {
                                                    type: 'Identifier',
                                                    name: 'size',
                                                    loc: {
                                                        start: {
                                                            line: 12,
                                                            column: 23,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordIcon.ion'
                                                        },
                                                        end: {
                                                            line: 12,
                                                            column: 27,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordIcon.ion'
                                                        }
                                                    }
                                                }
                                            },
                                            right: {
                                                type: 'Literal',
                                                value: 'px'
                                            }
                                        },
                                        kind: 'init',
                                        order: '1'
                                    },
                                    {
                                        type: 'IfStatement',
                                        test: {
                                            type: 'UnaryExpression',
                                            operator: '!',
                                            argument: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'record',
                                                        loc: {
                                                            start: {
                                                                line: 13,
                                                                column: 19,
                                                                fixed: true,
                                                                source: 'glass/html/material/RecordIcon.ion'
                                                            },
                                                            end: {
                                                                line: 13,
                                                                column: 25,
                                                                fixed: true,
                                                                source: 'glass/html/material/RecordIcon.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'constructor',
                                                        loc: {
                                                            start: {
                                                                line: 13,
                                                                column: 26,
                                                                fixed: true,
                                                                source: 'glass/html/material/RecordIcon.ion'
                                                            },
                                                            end: {
                                                                line: 13,
                                                                column: 37,
                                                                fixed: true,
                                                                source: 'glass/html/material/RecordIcon.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 13,
                                                            column: 19,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordIcon.ion'
                                                        },
                                                        end: {
                                                            line: 13,
                                                            column: 37,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordIcon.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'square',
                                                    loc: {
                                                        start: {
                                                            line: 13,
                                                            column: 38,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordIcon.ion'
                                                        },
                                                        end: {
                                                            line: 13,
                                                            column: 44,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordIcon.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 13,
                                                        column: 19,
                                                        fixed: true,
                                                        source: 'glass/html/material/RecordIcon.ion'
                                                    },
                                                    end: {
                                                        line: 13,
                                                        column: 44,
                                                        fixed: true,
                                                        source: 'glass/html/material/RecordIcon.ion'
                                                    }
                                                }
                                            }
                                        },
                                        consequent: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'borderRadius',
                                                        loc: {
                                                            start: {
                                                                line: 14,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/RecordIcon.ion'
                                                            },
                                                            end: {
                                                                line: 14,
                                                                column: 28,
                                                                fixed: true,
                                                                source: 'glass/html/material/RecordIcon.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: '50%'
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                }]
                                        },
                                        alternate: null,
                                        order: '2'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'overflow',
                                            loc: {
                                                start: {
                                                    line: 15,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/RecordIcon.ion'
                                                },
                                                end: {
                                                    line: 15,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'glass/html/material/RecordIcon.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: 'hidden'
                                        },
                                        kind: 'init',
                                        order: '3'
                                    }
                                ]
                            },
                            kind: 'init',
                            order: '0'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'classList',
                                loc: {
                                    start: {
                                        line: 16,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/RecordIcon.ion'
                                    },
                                    end: {
                                        line: 16,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/html/material/RecordIcon.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'ObjectExpression',
                                properties: [{
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'Literal',
                                            value: 'fixed'
                                        },
                                        loc: {
                                            start: {
                                                line: 17,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/RecordIcon.ion'
                                            },
                                            end: {
                                                line: 17,
                                                column: 19,
                                                fixed: true,
                                                source: 'glass/html/material/RecordIcon.ion'
                                            }
                                        },
                                        order: '0'
                                    }]
                            },
                            kind: 'init',
                            order: '1'
                        },
                        {
                            type: 'IfStatement',
                            test: {
                                type: 'Identifier',
                                name: 'hasImg',
                                loc: {
                                    start: {
                                        line: 18,
                                        column: 11,
                                        fixed: true,
                                        source: 'glass/html/material/RecordIcon.ion'
                                    },
                                    end: {
                                        line: 18,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/html/material/RecordIcon.ion'
                                    }
                                }
                            },
                            consequent: {
                                type: 'BlockStatement',
                                body: [{
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'src',
                                            loc: {
                                                start: {
                                                    line: 19,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/RecordIcon.ion'
                                                },
                                                end: {
                                                    line: 19,
                                                    column: 15,
                                                    fixed: true,
                                                    source: 'glass/html/material/RecordIcon.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'record',
                                                loc: {
                                                    start: {
                                                        line: 19,
                                                        column: 17,
                                                        fixed: true,
                                                        source: 'glass/html/material/RecordIcon.ion'
                                                    },
                                                    end: {
                                                        line: 19,
                                                        column: 23,
                                                        fixed: true,
                                                        source: 'glass/html/material/RecordIcon.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'picture',
                                                loc: {
                                                    start: {
                                                        line: 19,
                                                        column: 24,
                                                        fixed: true,
                                                        source: 'glass/html/material/RecordIcon.ion'
                                                    },
                                                    end: {
                                                        line: 19,
                                                        column: 31,
                                                        fixed: true,
                                                        source: 'glass/html/material/RecordIcon.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 19,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'glass/html/material/RecordIcon.ion'
                                                },
                                                end: {
                                                    line: 19,
                                                    column: 31,
                                                    fixed: true,
                                                    source: 'glass/html/material/RecordIcon.ion'
                                                }
                                            }
                                        },
                                        kind: 'init',
                                        order: '0'
                                    }]
                            },
                            alternate: {
                                type: 'BlockStatement',
                                body: [
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'classList',
                                            loc: {
                                                start: {
                                                    line: 23,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/RecordIcon.ion'
                                                },
                                                end: {
                                                    line: 23,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'glass/html/material/RecordIcon.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'ObjectExpression',
                                            properties: [
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'Literal',
                                                        value: 'layout'
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 24,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordIcon.ion'
                                                        },
                                                        end: {
                                                            line: 24,
                                                            column: 24,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordIcon.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                },
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'Literal',
                                                        value: 'center'
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 25,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordIcon.ion'
                                                        },
                                                        end: {
                                                            line: 25,
                                                            column: 24,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordIcon.ion'
                                                        }
                                                    },
                                                    order: '1'
                                                },
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'Literal',
                                                        value: 'center-justified'
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 26,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordIcon.ion'
                                                        },
                                                        end: {
                                                            line: 26,
                                                            column: 34,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordIcon.ion'
                                                        }
                                                    },
                                                    order: '2'
                                                }
                                            ]
                                        },
                                        kind: 'init',
                                        order: '0'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'style',
                                            loc: {
                                                start: {
                                                    line: 27,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/RecordIcon.ion'
                                                },
                                                end: {
                                                    line: 27,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'glass/html/material/RecordIcon.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'ObjectExpression',
                                            properties: [
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'background',
                                                        loc: {
                                                            start: {
                                                                line: 28,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/RecordIcon.ion'
                                                            },
                                                            end: {
                                                                line: 28,
                                                                column: 26,
                                                                fixed: true,
                                                                source: 'glass/html/material/RecordIcon.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'ConditionalExpression',
                                                        test: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'record',
                                                                loc: {
                                                                    start: {
                                                                        line: 28,
                                                                        column: 28,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordIcon.ion'
                                                                    },
                                                                    end: {
                                                                        line: 28,
                                                                        column: 34,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordIcon.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'color',
                                                                loc: {
                                                                    start: {
                                                                        line: 28,
                                                                        column: 35,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordIcon.ion'
                                                                    },
                                                                    end: {
                                                                        line: 28,
                                                                        column: 40,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordIcon.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 28,
                                                                    column: 28,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RecordIcon.ion'
                                                                },
                                                                end: {
                                                                    line: 28,
                                                                    column: 40,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RecordIcon.ion'
                                                                }
                                                            }
                                                        },
                                                        consequent: {
                                                            type: 'BinaryExpression',
                                                            operator: '+',
                                                            left: {
                                                                type: 'Literal',
                                                                value: '#'
                                                            },
                                                            right: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'record',
                                                                    loc: {
                                                                        start: {
                                                                            line: 28,
                                                                            column: 49,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RecordIcon.ion'
                                                                        },
                                                                        end: {
                                                                            line: 28,
                                                                            column: 55,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RecordIcon.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'color',
                                                                    loc: {
                                                                        start: {
                                                                            line: 28,
                                                                            column: 56,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RecordIcon.ion'
                                                                        },
                                                                        end: {
                                                                            line: 28,
                                                                            column: 61,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RecordIcon.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 28,
                                                                        column: 49,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordIcon.ion'
                                                                    },
                                                                    end: {
                                                                        line: 28,
                                                                        column: 61,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordIcon.ion'
                                                                    }
                                                                }
                                                            }
                                                        },
                                                        alternate: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'style',
                                                                    loc: {
                                                                        start: {
                                                                            line: 28,
                                                                            column: 64,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RecordIcon.ion'
                                                                        },
                                                                        end: {
                                                                            line: 28,
                                                                            column: 69,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RecordIcon.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'color',
                                                                    loc: {
                                                                        start: {
                                                                            line: 28,
                                                                            column: 70,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RecordIcon.ion'
                                                                        },
                                                                        end: {
                                                                            line: 28,
                                                                            column: 75,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RecordIcon.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 28,
                                                                        column: 64,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordIcon.ion'
                                                                    },
                                                                    end: {
                                                                        line: 28,
                                                                        column: 75,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordIcon.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'primary',
                                                                loc: {
                                                                    start: {
                                                                        line: 28,
                                                                        column: 76,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordIcon.ion'
                                                                    },
                                                                    end: {
                                                                        line: 28,
                                                                        column: 83,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordIcon.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 28,
                                                                    column: 64,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RecordIcon.ion'
                                                                },
                                                                end: {
                                                                    line: 28,
                                                                    column: 83,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RecordIcon.ion'
                                                                }
                                                            }
                                                        }
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'fontSize',
                                                        loc: {
                                                            start: {
                                                                line: 29,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/RecordIcon.ion'
                                                            },
                                                            end: {
                                                                line: 29,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'glass/html/material/RecordIcon.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'BinaryExpression',
                                                        operator: '+',
                                                        left: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'Math',
                                                                    loc: {
                                                                        start: {
                                                                            line: 29,
                                                                            column: 26,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RecordIcon.ion'
                                                                        },
                                                                        end: {
                                                                            line: 29,
                                                                            column: 30,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RecordIcon.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'round',
                                                                    loc: {
                                                                        start: {
                                                                            line: 29,
                                                                            column: 31,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RecordIcon.ion'
                                                                        },
                                                                        end: {
                                                                            line: 29,
                                                                            column: 36,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RecordIcon.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 29,
                                                                        column: 26,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordIcon.ion'
                                                                    },
                                                                    end: {
                                                                        line: 29,
                                                                        column: 36,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordIcon.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [{
                                                                    type: 'BinaryExpression',
                                                                    operator: '/',
                                                                    left: {
                                                                        type: 'Identifier',
                                                                        name: 'size',
                                                                        loc: {
                                                                            start: {
                                                                                line: 29,
                                                                                column: 37,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/RecordIcon.ion'
                                                                            },
                                                                            end: {
                                                                                line: 29,
                                                                                column: 41,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/RecordIcon.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    right: {
                                                                        type: 'Literal',
                                                                        value: 2.3
                                                                    }
                                                                }],
                                                            loc: {
                                                                start: {
                                                                    line: 29,
                                                                    column: 26,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RecordIcon.ion'
                                                                },
                                                                end: {
                                                                    line: 29,
                                                                    column: 48,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RecordIcon.ion'
                                                                }
                                                            }
                                                        },
                                                        right: {
                                                            type: 'Literal',
                                                            value: 'px'
                                                        }
                                                    },
                                                    kind: 'init',
                                                    order: '1'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'color',
                                                        loc: {
                                                            start: {
                                                                line: 30,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/RecordIcon.ion'
                                                            },
                                                            end: {
                                                                line: 30,
                                                                column: 21,
                                                                fixed: true,
                                                                source: 'glass/html/material/RecordIcon.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'style',
                                                                loc: {
                                                                    start: {
                                                                        line: 30,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordIcon.ion'
                                                                    },
                                                                    end: {
                                                                        line: 30,
                                                                        column: 28,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordIcon.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'color',
                                                                loc: {
                                                                    start: {
                                                                        line: 30,
                                                                        column: 29,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordIcon.ion'
                                                                    },
                                                                    end: {
                                                                        line: 30,
                                                                        column: 34,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordIcon.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 30,
                                                                    column: 23,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RecordIcon.ion'
                                                                },
                                                                end: {
                                                                    line: 30,
                                                                    column: 34,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RecordIcon.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'white',
                                                            loc: {
                                                                start: {
                                                                    line: 30,
                                                                    column: 35,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RecordIcon.ion'
                                                                },
                                                                end: {
                                                                    line: 30,
                                                                    column: 40,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RecordIcon.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 30,
                                                                column: 23,
                                                                fixed: true,
                                                                source: 'glass/html/material/RecordIcon.ion'
                                                            },
                                                            end: {
                                                                line: 30,
                                                                column: 40,
                                                                fixed: true,
                                                                source: 'glass/html/material/RecordIcon.ion'
                                                            }
                                                        }
                                                    },
                                                    kind: 'init',
                                                    order: '2'
                                                }
                                            ]
                                        },
                                        kind: 'init',
                                        order: '1'
                                    },
                                    {
                                        type: 'VariableDeclaration',
                                        declarations: [{
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'ab',
                                                    loc: {
                                                        start: {
                                                            line: 31,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordIcon.ion'
                                                        },
                                                        end: {
                                                            line: 31,
                                                            column: 18,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordIcon.ion'
                                                        }
                                                    }
                                                },
                                                init: {
                                                    type: 'ConditionalExpression',
                                                    test: {
                                                        type: 'BinaryExpression',
                                                        operator: '!=',
                                                        left: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'record',
                                                                    loc: {
                                                                        start: {
                                                                            line: 31,
                                                                            column: 21,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RecordIcon.ion'
                                                                        },
                                                                        end: {
                                                                            line: 31,
                                                                            column: 27,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RecordIcon.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'getAbbreviation',
                                                                    loc: {
                                                                        start: {
                                                                            line: 31,
                                                                            column: 28,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RecordIcon.ion'
                                                                        },
                                                                        end: {
                                                                            line: 31,
                                                                            column: 43,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RecordIcon.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 31,
                                                                        column: 21,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordIcon.ion'
                                                                    },
                                                                    end: {
                                                                        line: 31,
                                                                        column: 43,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordIcon.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [{
                                                                    type: 'Identifier',
                                                                    name: 'args',
                                                                    loc: {
                                                                        start: {
                                                                            line: 31,
                                                                            column: 45,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RecordIcon.ion'
                                                                        },
                                                                        end: {
                                                                            line: 31,
                                                                            column: 49,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RecordIcon.ion'
                                                                        }
                                                                    }
                                                                }],
                                                            existential: true,
                                                            loc: {
                                                                start: {
                                                                    line: 31,
                                                                    column: 21,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RecordIcon.ion'
                                                                },
                                                                end: {
                                                                    line: 31,
                                                                    column: 50,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RecordIcon.ion'
                                                                }
                                                            }
                                                        },
                                                        right: {
                                                            type: 'Literal',
                                                            value: null
                                                        }
                                                    },
                                                    consequent: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'record',
                                                                loc: {
                                                                    start: {
                                                                        line: 31,
                                                                        column: 21,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordIcon.ion'
                                                                    },
                                                                    end: {
                                                                        line: 31,
                                                                        column: 27,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordIcon.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'getAbbreviation',
                                                                loc: {
                                                                    start: {
                                                                        line: 31,
                                                                        column: 28,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordIcon.ion'
                                                                    },
                                                                    end: {
                                                                        line: 31,
                                                                        column: 43,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordIcon.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 31,
                                                                    column: 21,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RecordIcon.ion'
                                                                },
                                                                end: {
                                                                    line: 31,
                                                                    column: 43,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RecordIcon.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [{
                                                                type: 'Identifier',
                                                                name: 'args',
                                                                loc: {
                                                                    start: {
                                                                        line: 31,
                                                                        column: 45,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordIcon.ion'
                                                                    },
                                                                    end: {
                                                                        line: 31,
                                                                        column: 49,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordIcon.ion'
                                                                    }
                                                                }
                                                            }],
                                                        existential: true,
                                                        loc: {
                                                            start: {
                                                                line: 31,
                                                                column: 21,
                                                                fixed: true,
                                                                source: 'glass/html/material/RecordIcon.ion'
                                                            },
                                                            end: {
                                                                line: 31,
                                                                column: 50,
                                                                fixed: true,
                                                                source: 'glass/html/material/RecordIcon.ion'
                                                            }
                                                        }
                                                    },
                                                    alternate: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'record',
                                                            loc: {
                                                                start: {
                                                                    line: 31,
                                                                    column: 53,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RecordIcon.ion'
                                                                },
                                                                end: {
                                                                    line: 31,
                                                                    column: 59,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RecordIcon.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'abbreviation',
                                                            loc: {
                                                                start: {
                                                                    line: 31,
                                                                    column: 60,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RecordIcon.ion'
                                                                },
                                                                end: {
                                                                    line: 31,
                                                                    column: 72,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RecordIcon.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 31,
                                                                column: 53,
                                                                fixed: true,
                                                                source: 'glass/html/material/RecordIcon.ion'
                                                            },
                                                            end: {
                                                                line: 31,
                                                                column: 72,
                                                                fixed: true,
                                                                source: 'glass/html/material/RecordIcon.ion'
                                                            }
                                                        }
                                                    }
                                                }
                                            }],
                                        kind: 'let',
                                        order: '2'
                                    },
                                    {
                                        type: 'VariableDeclaration',
                                        declarations: [{
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'name',
                                                    loc: {
                                                        start: {
                                                            line: 32,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordIcon.ion'
                                                        },
                                                        end: {
                                                            line: 32,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordIcon.ion'
                                                        }
                                                    }
                                                },
                                                init: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'Function',
                                                        context: false,
                                                        value: function (record, args) {
                                                            return (record.getInitials != null ? record.getInitials(args) : void 0) != null ? record.getInitials(args) : ((record.name != null ? record.name : record.email) != null ? record.name != null ? record.name : record.email : record.id) != null ? ((record.name != null ? record.name : record.email) != null ? record.name != null ? record.name : record.email : record.id).split(' ').map(function (x) {
                                                                return x[0];
                                                            }).join('').toUpperCase().slice(0, 2) : void 0;
                                                        }
                                                    },
                                                    arguments: [
                                                        {
                                                            type: 'Identifier',
                                                            name: 'record',
                                                            loc: {
                                                                start: {
                                                                    line: 32,
                                                                    column: 27,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RecordIcon.ion'
                                                                },
                                                                end: {
                                                                    line: 32,
                                                                    column: 33,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RecordIcon.ion'
                                                                }
                                                            }
                                                        },
                                                        {
                                                            type: 'Identifier',
                                                            name: 'args',
                                                            loc: {
                                                                start: {
                                                                    line: 32,
                                                                    column: 35,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RecordIcon.ion'
                                                                },
                                                                end: {
                                                                    line: 32,
                                                                    column: 39,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RecordIcon.ion'
                                                                }
                                                            }
                                                        }
                                                    ],
                                                    loc: {
                                                        start: {
                                                            line: 32,
                                                            column: 23,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordIcon.ion'
                                                        },
                                                        end: {
                                                            line: 32,
                                                            column: 175,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordIcon.ion'
                                                        }
                                                    }
                                                }
                                            }],
                                        kind: 'let',
                                        order: '3'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'Identifier',
                                            name: 'name',
                                            loc: {
                                                start: {
                                                    line: 33,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/RecordIcon.ion'
                                                },
                                                end: {
                                                    line: 33,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/html/material/RecordIcon.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 33,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/RecordIcon.ion'
                                            },
                                            end: {
                                                line: 33,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/RecordIcon.ion'
                                            }
                                        },
                                        order: '4'
                                    }
                                ]
                            },
                            order: '2'
                        }
                    ]
                },
                order: '7'
            }
        ],
        bound: false
    }, {
        this: this,
        args: args,
        _ref: _ref,
        style: style
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/RecordIcon',_glass_html_material_RecordIcon_);
    else
      _glass_html_material_RecordIcon_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_RecordIcon_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_RecordItem_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('../../'), _ref2;
var search = _ref.search;
_ref2 = require('./');
var RecordIcon = _ref2.RecordIcon;
var matches = function (text, match) {
    if (text == null)
        text = '';
    if (match != null) {
        var matches = text.match(search.getSearchRegExp(match));
        if (matches != null) {
            return Math.max.apply(null, matches.map(function (x) {
                return x.trim().length;
            })) > 0;
        }
    }
    return false;
};
var clean = function (text) {
    return text.replace(/</g, '&lt;').replace(/>/, '&gt;');
};
var boldMatch = function (text, match) {
    if (text == null)
        text = '';
    text = clean(text);
    if (match != null) {
        return text.replace(search.getSearchRegExp(match), function (x) {
            return '<b>' + x + '</b>';
        });
    } else {
        return text;
    }
};
module.exports = exports = ion.template(function RecordItem(_ref3) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'RecordItem',
            loc: {
                start: {
                    line: 21,
                    column: 16,
                    fixed: true,
                    source: 'glass/html/material/RecordItem.ion'
                },
                end: {
                    line: 21,
                    column: 26,
                    fixed: true,
                    source: 'glass/html/material/RecordItem.ion'
                }
            }
        },
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'key',
                            loc: {
                                start: {
                                    line: 21,
                                    column: 28,
                                    fixed: true,
                                    source: 'glass/html/material/RecordItem.ion'
                                },
                                end: {
                                    line: 21,
                                    column: 31,
                                    fixed: true,
                                    source: 'glass/html/material/RecordItem.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'key',
                                loc: {
                                    start: {
                                        line: 21,
                                        column: 28,
                                        fixed: true,
                                        source: 'glass/html/material/RecordItem.ion'
                                    },
                                    end: {
                                        line: 21,
                                        column: 31,
                                        fixed: true,
                                        source: 'glass/html/material/RecordItem.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'record',
                            loc: {
                                start: {
                                    line: 21,
                                    column: 33,
                                    fixed: true,
                                    source: 'glass/html/material/RecordItem.ion'
                                },
                                end: {
                                    line: 21,
                                    column: 39,
                                    fixed: true,
                                    source: 'glass/html/material/RecordItem.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'record',
                                loc: {
                                    start: {
                                        line: 21,
                                        column: 33,
                                        fixed: true,
                                        source: 'glass/html/material/RecordItem.ion'
                                    },
                                    end: {
                                        line: 21,
                                        column: 39,
                                        fixed: true,
                                        source: 'glass/html/material/RecordItem.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'match',
                            loc: {
                                start: {
                                    line: 21,
                                    column: 41,
                                    fixed: true,
                                    source: 'glass/html/material/RecordItem.ion'
                                },
                                end: {
                                    line: 21,
                                    column: 46,
                                    fixed: true,
                                    source: 'glass/html/material/RecordItem.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'match',
                                loc: {
                                    start: {
                                        line: 21,
                                        column: 41,
                                        fixed: true,
                                        source: 'glass/html/material/RecordItem.ion'
                                    },
                                    end: {
                                        line: 21,
                                        column: 46,
                                        fixed: true,
                                        source: 'glass/html/material/RecordItem.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'CallExpression',
                        callee: {
                            type: 'Identifier',
                            name: 'PaperIconItem',
                            loc: {
                                start: {
                                    line: 22,
                                    column: 11,
                                    fixed: true,
                                    source: 'glass/html/material/RecordItem.ion'
                                },
                                end: {
                                    line: 22,
                                    column: 24,
                                    fixed: true,
                                    source: 'glass/html/material/RecordItem.ion'
                                }
                            }
                        },
                        arguments: [],
                        loc: {
                            start: {
                                line: 22,
                                column: 11,
                                fixed: true,
                                source: 'glass/html/material/RecordItem.ion'
                            },
                            end: {
                                line: 22,
                                column: 26,
                                fixed: true,
                                source: 'glass/html/material/RecordItem.ion'
                            }
                        }
                    },
                    properties: [
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'record',
                                loc: {
                                    start: {
                                        line: 23,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/RecordItem.ion'
                                    },
                                    end: {
                                        line: 23,
                                        column: 14,
                                        fixed: true,
                                        source: 'glass/html/material/RecordItem.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Identifier',
                                name: 'record',
                                loc: {
                                    start: {
                                        line: 23,
                                        column: 16,
                                        fixed: true,
                                        source: 'glass/html/material/RecordItem.ion'
                                    },
                                    end: {
                                        line: 23,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/material/RecordItem.ion'
                                    }
                                }
                            },
                            kind: 'init',
                            order: '0'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'key',
                                loc: {
                                    start: {
                                        line: 24,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/RecordItem.ion'
                                    },
                                    end: {
                                        line: 24,
                                        column: 11,
                                        fixed: true,
                                        source: 'glass/html/material/RecordItem.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Identifier',
                                name: 'key',
                                loc: {
                                    start: {
                                        line: 24,
                                        column: 13,
                                        fixed: true,
                                        source: 'glass/html/material/RecordItem.ion'
                                    },
                                    end: {
                                        line: 24,
                                        column: 16,
                                        fixed: true,
                                        source: 'glass/html/material/RecordItem.ion'
                                    }
                                }
                            },
                            kind: 'init',
                            order: '1'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'valueJSON',
                                loc: {
                                    start: {
                                        line: 25,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/RecordItem.ion'
                                    },
                                    end: {
                                        line: 25,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/html/material/RecordItem.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Identifier',
                                name: 'record',
                                loc: {
                                    start: {
                                        line: 25,
                                        column: 19,
                                        fixed: true,
                                        source: 'glass/html/material/RecordItem.ion'
                                    },
                                    end: {
                                        line: 25,
                                        column: 25,
                                        fixed: true,
                                        source: 'glass/html/material/RecordItem.ion'
                                    }
                                }
                            },
                            kind: 'init',
                            order: '2'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'doesMatch',
                                loc: {
                                    start: {
                                        line: 26,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/RecordItem.ion'
                                    },
                                    end: {
                                        line: 26,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/html/material/RecordItem.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context) {
                                    return function (m) {
                                        var matches = _context.get('matches'), record = _context.get('record');
                                        return matches(record.name, m) || matches(record.email != null ? record.email : record.description, m);
                                    };
                                }
                            },
                            kind: 'init',
                            order: '3'
                        },
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'RecordIcon',
                                    loc: {
                                        start: {
                                            line: 27,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/RecordItem.ion'
                                        },
                                        end: {
                                            line: 27,
                                            column: 18,
                                            fixed: true,
                                            source: 'glass/html/material/RecordItem.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'record',
                                                    loc: {
                                                        start: {
                                                            line: 27,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordItem.ion'
                                                        },
                                                        end: {
                                                            line: 27,
                                                            column: 26,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordItem.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Identifier',
                                                    name: 'record',
                                                    loc: {
                                                        start: {
                                                            line: 27,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordItem.ion'
                                                        },
                                                        end: {
                                                            line: 27,
                                                            column: 26,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordItem.ion'
                                                        }
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'size',
                                                    loc: {
                                                        start: {
                                                            line: 27,
                                                            column: 27,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordItem.ion'
                                                        },
                                                        end: {
                                                            line: 27,
                                                            column: 31,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordItem.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: 40
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    }],
                                loc: {
                                    start: {
                                        line: 27,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/RecordItem.ion'
                                    },
                                    end: {
                                        line: 27,
                                        column: 36,
                                        fixed: true,
                                        source: 'glass/html/material/RecordItem.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 27,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/RecordItem.ion'
                                },
                                end: {
                                    line: 27,
                                    column: 36,
                                    fixed: true,
                                    source: 'glass/html/material/RecordItem.ion'
                                }
                            },
                            order: '4'
                        },
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'Identifier',
                                        name: 'PaperItemBody',
                                        loc: {
                                            start: {
                                                line: 28,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/RecordItem.ion'
                                            },
                                            end: {
                                                line: 28,
                                                column: 21,
                                                fixed: true,
                                                source: 'glass/html/material/RecordItem.ion'
                                            }
                                        }
                                    },
                                    arguments: [{
                                            type: 'ObjectExpression',
                                            properties: [{
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Literal',
                                                        value: 'two-line'
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: true
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                }]
                                        }],
                                    loc: {
                                        start: {
                                            line: 28,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/RecordItem.ion'
                                        },
                                        end: {
                                            line: 28,
                                            column: 40,
                                            fixed: true,
                                            source: 'glass/html/material/RecordItem.ion'
                                        }
                                    }
                                },
                                properties: [
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'ObjectExpression',
                                            objectType: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'Div',
                                                    loc: {
                                                        start: {
                                                            line: 29,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordItem.ion'
                                                        },
                                                        end: {
                                                            line: 29,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordItem.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [],
                                                loc: {
                                                    start: {
                                                        line: 29,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/RecordItem.ion'
                                                    },
                                                    end: {
                                                        line: 29,
                                                        column: 17,
                                                        fixed: true,
                                                        source: 'glass/html/material/RecordItem.ion'
                                                    }
                                                }
                                            },
                                            properties: [{
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'innerHTML',
                                                        loc: {
                                                            start: {
                                                                line: 30,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/RecordItem.ion'
                                                            },
                                                            end: {
                                                                line: 30,
                                                                column: 25,
                                                                fixed: true,
                                                                source: 'glass/html/material/RecordItem.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'Identifier',
                                                            name: 'boldMatch',
                                                            loc: {
                                                                start: {
                                                                    line: 30,
                                                                    column: 27,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RecordItem.ion'
                                                                },
                                                                end: {
                                                                    line: 30,
                                                                    column: 36,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RecordItem.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [
                                                            {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'record',
                                                                    loc: {
                                                                        start: {
                                                                            line: 30,
                                                                            column: 37,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RecordItem.ion'
                                                                        },
                                                                        end: {
                                                                            line: 30,
                                                                            column: 43,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RecordItem.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'name',
                                                                    loc: {
                                                                        start: {
                                                                            line: 30,
                                                                            column: 44,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RecordItem.ion'
                                                                        },
                                                                        end: {
                                                                            line: 30,
                                                                            column: 48,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RecordItem.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 30,
                                                                        column: 37,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordItem.ion'
                                                                    },
                                                                    end: {
                                                                        line: 30,
                                                                        column: 48,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordItem.ion'
                                                                    }
                                                                }
                                                            },
                                                            {
                                                                type: 'Identifier',
                                                                name: 'match',
                                                                loc: {
                                                                    start: {
                                                                        line: 30,
                                                                        column: 50,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordItem.ion'
                                                                    },
                                                                    end: {
                                                                        line: 30,
                                                                        column: 55,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordItem.ion'
                                                                    }
                                                                }
                                                            }
                                                        ],
                                                        loc: {
                                                            start: {
                                                                line: 30,
                                                                column: 27,
                                                                fixed: true,
                                                                source: 'glass/html/material/RecordItem.ion'
                                                            },
                                                            end: {
                                                                line: 30,
                                                                column: 56,
                                                                fixed: true,
                                                                source: 'glass/html/material/RecordItem.ion'
                                                            }
                                                        }
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                }]
                                        },
                                        loc: {
                                            start: {
                                                line: 29,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/RecordItem.ion'
                                            },
                                            end: {
                                                line: 31,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/RecordItem.ion'
                                            }
                                        },
                                        order: '0'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'ObjectExpression',
                                            objectType: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'Div',
                                                    loc: {
                                                        start: {
                                                            line: 31,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordItem.ion'
                                                        },
                                                        end: {
                                                            line: 31,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordItem.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [{
                                                        type: 'ObjectExpression',
                                                        properties: [{
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'secondary',
                                                                    loc: {
                                                                        start: {
                                                                            line: 31,
                                                                            column: 17,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RecordItem.ion'
                                                                        },
                                                                        end: {
                                                                            line: 31,
                                                                            column: 26,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RecordItem.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: true
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            }]
                                                    }],
                                                loc: {
                                                    start: {
                                                        line: 31,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/RecordItem.ion'
                                                    },
                                                    end: {
                                                        line: 31,
                                                        column: 33,
                                                        fixed: true,
                                                        source: 'glass/html/material/RecordItem.ion'
                                                    }
                                                }
                                            },
                                            properties: [{
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'innerHTML',
                                                        loc: {
                                                            start: {
                                                                line: 32,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/RecordItem.ion'
                                                            },
                                                            end: {
                                                                line: 32,
                                                                column: 25,
                                                                fixed: true,
                                                                source: 'glass/html/material/RecordItem.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'Identifier',
                                                            name: 'boldMatch',
                                                            loc: {
                                                                start: {
                                                                    line: 32,
                                                                    column: 27,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RecordItem.ion'
                                                                },
                                                                end: {
                                                                    line: 32,
                                                                    column: 36,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RecordItem.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [
                                                            {
                                                                type: 'ConditionalExpression',
                                                                test: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '!=',
                                                                    left: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'record',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 32,
                                                                                    column: 37,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/RecordItem.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 32,
                                                                                    column: 43,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/RecordItem.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'email',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 32,
                                                                                    column: 44,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/RecordItem.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 32,
                                                                                    column: 49,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/RecordItem.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 32,
                                                                                column: 37,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/RecordItem.ion'
                                                                            },
                                                                            end: {
                                                                                line: 32,
                                                                                column: 49,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/RecordItem.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    right: {
                                                                        type: 'Literal',
                                                                        value: null
                                                                    }
                                                                },
                                                                consequent: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'record',
                                                                        loc: {
                                                                            start: {
                                                                                line: 32,
                                                                                column: 37,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/RecordItem.ion'
                                                                            },
                                                                            end: {
                                                                                line: 32,
                                                                                column: 43,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/RecordItem.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'email',
                                                                        loc: {
                                                                            start: {
                                                                                line: 32,
                                                                                column: 44,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/RecordItem.ion'
                                                                            },
                                                                            end: {
                                                                                line: 32,
                                                                                column: 49,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/RecordItem.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 32,
                                                                            column: 37,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RecordItem.ion'
                                                                        },
                                                                        end: {
                                                                            line: 32,
                                                                            column: 49,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RecordItem.ion'
                                                                        }
                                                                    }
                                                                },
                                                                alternate: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'record',
                                                                        loc: {
                                                                            start: {
                                                                                line: 32,
                                                                                column: 52,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/RecordItem.ion'
                                                                            },
                                                                            end: {
                                                                                line: 32,
                                                                                column: 58,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/RecordItem.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'description',
                                                                        loc: {
                                                                            start: {
                                                                                line: 32,
                                                                                column: 59,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/RecordItem.ion'
                                                                            },
                                                                            end: {
                                                                                line: 32,
                                                                                column: 70,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/RecordItem.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 32,
                                                                            column: 52,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RecordItem.ion'
                                                                        },
                                                                        end: {
                                                                            line: 32,
                                                                            column: 70,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RecordItem.ion'
                                                                        }
                                                                    }
                                                                }
                                                            },
                                                            {
                                                                type: 'Identifier',
                                                                name: 'match',
                                                                loc: {
                                                                    start: {
                                                                        line: 32,
                                                                        column: 72,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordItem.ion'
                                                                    },
                                                                    end: {
                                                                        line: 32,
                                                                        column: 77,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordItem.ion'
                                                                    }
                                                                }
                                                            }
                                                        ],
                                                        loc: {
                                                            start: {
                                                                line: 32,
                                                                column: 27,
                                                                fixed: true,
                                                                source: 'glass/html/material/RecordItem.ion'
                                                            },
                                                            end: {
                                                                line: 32,
                                                                column: 78,
                                                                fixed: true,
                                                                source: 'glass/html/material/RecordItem.ion'
                                                            }
                                                        }
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                }]
                                        },
                                        loc: {
                                            start: {
                                                line: 31,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/RecordItem.ion'
                                            },
                                            end: {
                                                line: 35,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/RecordItem.ion'
                                            }
                                        },
                                        order: '1'
                                    }
                                ]
                            },
                            loc: {
                                start: {
                                    line: 28,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/RecordItem.ion'
                                },
                                end: {
                                    line: 35,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/RecordItem.ion'
                                }
                            },
                            order: '5'
                        }
                    ]
                },
                order: '3'
            }
        ],
        bound: false
    }, {
        this: this,
        _ref3: _ref3,
        _ref: _ref,
        _ref2: _ref2,
        search: search,
        RecordIcon: RecordIcon,
        matches: matches,
        clean: clean,
        boldMatch: boldMatch
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/RecordItem',_glass_html_material_RecordItem_);
    else
      _glass_html_material_RecordItem_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_RecordItem_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_RecordSearchSuggestions_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('../../data');
var Key = _ref.Key;
var getMaxSorted = function (suggestions, text, max) {
    text = text.trim();
    if (text.length === 0) {
        return suggestions.slice(0);
    }
    var map = new Map();
    for (var _i = 0; _i < suggestions.length; _i++) {
        var suggestion = suggestions[_i];
        map.set(suggestion.key != null ? suggestion.key : suggestion, suggestion);
    }
    suggestions = Array.from(map.values());
    var rankedSuggestions = [];
    for (var _i2 = 0; _i2 < suggestions.length; _i2++) {
        var suggestion = suggestions[_i2];
        var rank = (suggestion.record.getSearchRank != null ? suggestion.record.getSearchRank(text) : void 0) != null ? suggestion.record.getSearchRank(text) : 1;
        if (rank >= 0) {
            rankedSuggestions.push([
                suggestion,
                rank
            ]);
        }
    }
    var sorted = rankedSuggestions.slice(0).sort(function (a, b) {
            return b[1] - a[1];
        });
    var sliced = sorted.map(function (_ref2) {
            var suggestion = _ref2[0];
            return suggestion;
        }).slice(0, max);
    return sliced;
};
module.exports = exports = ion.template(function RecordSearchSuggestions(_ref3) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'RecordSearchSuggestions',
            loc: {
                start: {
                    line: 28,
                    column: 16,
                    fixed: true,
                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                },
                end: {
                    line: 28,
                    column: 39,
                    fixed: true,
                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                }
            }
        },
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'text',
                            loc: {
                                start: {
                                    line: 28,
                                    column: 41,
                                    fixed: true,
                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                },
                                end: {
                                    line: 28,
                                    column: 45,
                                    fixed: true,
                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'text',
                                loc: {
                                    start: {
                                        line: 28,
                                        column: 41,
                                        fixed: true,
                                        source: 'glass/html/material/RecordSearchSuggestions.ion'
                                    },
                                    end: {
                                        line: 28,
                                        column: 45,
                                        fixed: true,
                                        source: 'glass/html/material/RecordSearchSuggestions.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'keys',
                            loc: {
                                start: {
                                    line: 28,
                                    column: 47,
                                    fixed: true,
                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                },
                                end: {
                                    line: 28,
                                    column: 51,
                                    fixed: true,
                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'keys',
                                loc: {
                                    start: {
                                        line: 28,
                                        column: 47,
                                        fixed: true,
                                        source: 'glass/html/material/RecordSearchSuggestions.ion'
                                    },
                                    end: {
                                        line: 28,
                                        column: 51,
                                        fixed: true,
                                        source: 'glass/html/material/RecordSearchSuggestions.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'showMissingEntities',
                            loc: {
                                start: {
                                    line: 28,
                                    column: 53,
                                    fixed: true,
                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                },
                                end: {
                                    line: 28,
                                    column: 72,
                                    fixed: true,
                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'showMissingEntities',
                                loc: {
                                    start: {
                                        line: 28,
                                        column: 53,
                                        fixed: true,
                                        source: 'glass/html/material/RecordSearchSuggestions.ion'
                                    },
                                    end: {
                                        line: 28,
                                        column: 72,
                                        fixed: true,
                                        source: 'glass/html/material/RecordSearchSuggestions.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: '_max',
                            loc: {
                                start: {
                                    line: 28,
                                    column: 78,
                                    fixed: true,
                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                },
                                end: {
                                    line: 28,
                                    column: 82,
                                    fixed: true,
                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'max',
                                loc: {
                                    start: {
                                        line: 28,
                                        column: 74,
                                        fixed: true,
                                        source: 'glass/html/material/RecordSearchSuggestions.ion'
                                    },
                                    end: {
                                        line: 28,
                                        column: 77,
                                        fixed: true,
                                        source: 'glass/html/material/RecordSearchSuggestions.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '3'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'max',
                            loc: {
                                start: {
                                    line: 29,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                },
                                end: {
                                    line: 29,
                                    column: 11,
                                    fixed: true,
                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ConditionalExpression',
                            test: {
                                type: 'BinaryExpression',
                                operator: '!=',
                                left: {
                                    type: 'Identifier',
                                    name: '_max',
                                    loc: {
                                        start: {
                                            line: 29,
                                            column: 14,
                                            fixed: true,
                                            source: 'glass/html/material/RecordSearchSuggestions.ion'
                                        },
                                        end: {
                                            line: 29,
                                            column: 18,
                                            fixed: true,
                                            source: 'glass/html/material/RecordSearchSuggestions.ion'
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: null
                                }
                            },
                            consequent: {
                                type: 'Identifier',
                                name: '_max',
                                loc: {
                                    start: {
                                        line: 29,
                                        column: 14,
                                        fixed: true,
                                        source: 'glass/html/material/RecordSearchSuggestions.ion'
                                    },
                                    end: {
                                        line: 29,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/material/RecordSearchSuggestions.ion'
                                    }
                                }
                            },
                            alternate: {
                                type: 'Literal',
                                value: 40
                            }
                        }
                    }],
                kind: 'let',
                order: '4'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'suggestions',
                            loc: {
                                start: {
                                    line: 31,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                },
                                end: {
                                    line: 31,
                                    column: 19,
                                    fixed: true,
                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'ArrayExpression',
                                elements: []
                            },
                            properties: [
                                {
                                    type: 'ForOfStatement',
                                    left: {
                                        type: 'VariableDeclaration',
                                        declarations: [{
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'keyString',
                                                    loc: {
                                                        start: {
                                                            line: 32,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                        },
                                                        end: {
                                                            line: 32,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                        }
                                                    }
                                                },
                                                init: null
                                            }],
                                        kind: 'let'
                                    },
                                    right: {
                                        type: 'Identifier',
                                        name: 'keys',
                                        loc: {
                                            start: {
                                                line: 32,
                                                column: 25,
                                                fixed: true,
                                                source: 'glass/html/material/RecordSearchSuggestions.ion'
                                            },
                                            end: {
                                                line: 32,
                                                column: 29,
                                                fixed: true,
                                                source: 'glass/html/material/RecordSearchSuggestions.ion'
                                            }
                                        }
                                    },
                                    body: {
                                        type: 'BlockStatement',
                                        body: [
                                            {
                                                type: 'VariableDeclaration',
                                                declarations: [{
                                                        type: 'VariableDeclarator',
                                                        id: {
                                                            type: 'Identifier',
                                                            name: 'key',
                                                            loc: {
                                                                start: {
                                                                    line: 33,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                },
                                                                end: {
                                                                    line: 33,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                }
                                                            }
                                                        },
                                                        init: {
                                                            type: 'NewExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'Key',
                                                                loc: {
                                                                    start: {
                                                                        line: 33,
                                                                        column: 26,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                    },
                                                                    end: {
                                                                        line: 33,
                                                                        column: 29,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [
                                                                {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'global',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 33,
                                                                                    column: 30,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 33,
                                                                                    column: 36,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'model',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 33,
                                                                                    column: 37,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 33,
                                                                                    column: 42,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 33,
                                                                                column: 30,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                            },
                                                                            end: {
                                                                                line: 33,
                                                                                column: 42,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'namespace',
                                                                        loc: {
                                                                            start: {
                                                                                line: 33,
                                                                                column: 43,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                            },
                                                                            end: {
                                                                                line: 33,
                                                                                column: 52,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 33,
                                                                            column: 30,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                        },
                                                                        end: {
                                                                            line: 33,
                                                                            column: 52,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                        }
                                                                    }
                                                                },
                                                                {
                                                                    type: 'Identifier',
                                                                    name: 'keyString',
                                                                    loc: {
                                                                        start: {
                                                                            line: 33,
                                                                            column: 54,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                        },
                                                                        end: {
                                                                            line: 33,
                                                                            column: 63,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                        }
                                                                    }
                                                                }
                                                            ],
                                                            loc: {
                                                                start: {
                                                                    line: 33,
                                                                    column: 22,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                },
                                                                end: {
                                                                    line: 33,
                                                                    column: 64,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                }
                                                            }
                                                        }
                                                    }],
                                                kind: 'let',
                                                order: '0'
                                            },
                                            {
                                                type: 'VariableDeclaration',
                                                declarations: [{
                                                        type: 'VariableDeclarator',
                                                        id: {
                                                            type: 'Identifier',
                                                            name: 'result',
                                                            loc: {
                                                                start: {
                                                                    line: 34,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                },
                                                                end: {
                                                                    line: 34,
                                                                    column: 22,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                }
                                                            }
                                                        },
                                                        init: {
                                                            type: 'MemberExpression',
                                                            computed: true,
                                                            object: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'global',
                                                                        loc: {
                                                                            start: {
                                                                                line: 34,
                                                                                column: 25,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                            },
                                                                            end: {
                                                                                line: 34,
                                                                                column: 31,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'model',
                                                                        loc: {
                                                                            start: {
                                                                                line: 34,
                                                                                column: 32,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                            },
                                                                            end: {
                                                                                line: 34,
                                                                                column: 37,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 34,
                                                                            column: 25,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                        },
                                                                        end: {
                                                                            line: 34,
                                                                            column: 37,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'server',
                                                                    loc: {
                                                                        start: {
                                                                            line: 34,
                                                                            column: 38,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                        },
                                                                        end: {
                                                                            line: 34,
                                                                            column: 44,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 34,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                    },
                                                                    end: {
                                                                        line: 34,
                                                                        column: 44,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'key',
                                                                loc: {
                                                                    start: {
                                                                        line: 34,
                                                                        column: 45,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                    },
                                                                    end: {
                                                                        line: 34,
                                                                        column: 48,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 34,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                },
                                                                end: {
                                                                    line: 34,
                                                                    column: 49,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                }
                                                            }
                                                        }
                                                    }],
                                                kind: 'let',
                                                order: '1'
                                            },
                                            {
                                                type: 'IfStatement',
                                                test: {
                                                    type: 'UnaryExpression',
                                                    operator: '?',
                                                    argument: {
                                                        type: 'Identifier',
                                                        name: 'result',
                                                        loc: {
                                                            start: {
                                                                line: 35,
                                                                column: 15,
                                                                fixed: true,
                                                                source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                            },
                                                            end: {
                                                                line: 35,
                                                                column: 21,
                                                                fixed: true,
                                                                source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                            }
                                                        }
                                                    }
                                                },
                                                consequent: {
                                                    type: 'BlockStatement',
                                                    body: [{
                                                            type: 'IfStatement',
                                                            test: {
                                                                type: 'UnaryExpression',
                                                                operator: '!',
                                                                argument: {
                                                                    type: 'UnaryExpression',
                                                                    operator: '?',
                                                                    argument: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'key',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 36,
                                                                                    column: 23,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 36,
                                                                                    column: 26,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'query',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 36,
                                                                                    column: 27,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 36,
                                                                                    column: 32,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 36,
                                                                                column: 23,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                            },
                                                                            end: {
                                                                                line: 36,
                                                                                column: 32,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                            },
                                                            consequent: {
                                                                type: 'BlockStatement',
                                                                body: [{
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'CallExpression',
                                                                            callee: {
                                                                                type: 'Function',
                                                                                context: false,
                                                                                value: function (key, result) {
                                                                                    return {
                                                                                        key: key.toString(),
                                                                                        record: result
                                                                                    };
                                                                                }
                                                                            },
                                                                            arguments: [
                                                                                {
                                                                                    type: 'Identifier',
                                                                                    name: 'key',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 37,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 37,
                                                                                            column: 27,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                {
                                                                                    type: 'Identifier',
                                                                                    name: 'result',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 37,
                                                                                            column: 29,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 37,
                                                                                            column: 35,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                        }
                                                                                    }
                                                                                }
                                                                            ],
                                                                            loc: {
                                                                                start: {
                                                                                    line: 37,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 37,
                                                                                    column: 74,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 37,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                            },
                                                                            end: {
                                                                                line: 37,
                                                                                column: 74,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                            }
                                                                        },
                                                                        order: '0'
                                                                    }]
                                                            },
                                                            alternate: {
                                                                type: 'BlockStatement',
                                                                body: [{
                                                                        type: 'ForInStatement',
                                                                        left: {
                                                                            type: 'VariableDeclaration',
                                                                            declarations: [
                                                                                {
                                                                                    type: 'VariableDeclarator',
                                                                                    id: {
                                                                                        type: 'Identifier',
                                                                                        name: 'resultKey',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 39,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 39,
                                                                                                column: 33,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    init: null
                                                                                },
                                                                                {
                                                                                    type: 'VariableDeclarator',
                                                                                    id: {
                                                                                        type: 'Identifier',
                                                                                        name: 'resultValue',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 39,
                                                                                                column: 35,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 39,
                                                                                                column: 46,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    init: null
                                                                                }
                                                                            ],
                                                                            kind: 'let'
                                                                        },
                                                                        right: {
                                                                            type: 'Identifier',
                                                                            name: 'result',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 39,
                                                                                    column: 50,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 39,
                                                                                    column: 56,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        body: {
                                                                            type: 'BlockStatement',
                                                                            body: [{
                                                                                    type: 'ExpressionStatement',
                                                                                    expression: {
                                                                                        type: 'CallExpression',
                                                                                        callee: {
                                                                                            type: 'Function',
                                                                                            context: false,
                                                                                            value: function (resultKey, resultValue) {
                                                                                                return {
                                                                                                    key: resultKey,
                                                                                                    record: resultValue
                                                                                                };
                                                                                            }
                                                                                        },
                                                                                        arguments: [
                                                                                            {
                                                                                                type: 'Identifier',
                                                                                                name: 'resultKey',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 40,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 40,
                                                                                                        column: 37,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            {
                                                                                                type: 'Identifier',
                                                                                                name: 'resultValue',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 40,
                                                                                                        column: 39,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 40,
                                                                                                        column: 50,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        ],
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 40,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 40,
                                                                                                column: 89,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 40,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 40,
                                                                                            column: 89,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                        }
                                                                                    },
                                                                                    order: '0'
                                                                                }]
                                                                        },
                                                                        remove: null,
                                                                        order: '0'
                                                                    }]
                                                            },
                                                            order: '0'
                                                        }]
                                                },
                                                alternate: null,
                                                order: '2'
                                            }
                                        ]
                                    },
                                    remove: null,
                                    order: '0'
                                },
                                {
                                    type: 'IfStatement',
                                    test: {
                                        type: 'Identifier',
                                        name: 'showMissingEntities',
                                        loc: {
                                            start: {
                                                line: 42,
                                                column: 11,
                                                fixed: true,
                                                source: 'glass/html/material/RecordSearchSuggestions.ion'
                                            },
                                            end: {
                                                line: 42,
                                                column: 30,
                                                fixed: true,
                                                source: 'glass/html/material/RecordSearchSuggestions.ion'
                                            }
                                        }
                                    },
                                    consequent: {
                                        type: 'BlockStatement',
                                        body: [{
                                                type: 'ForOfStatement',
                                                left: {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'keyString',
                                                                loc: {
                                                                    start: {
                                                                        line: 43,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                    },
                                                                    end: {
                                                                        line: 43,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: null
                                                        }],
                                                    kind: 'let'
                                                },
                                                right: {
                                                    type: 'Identifier',
                                                    name: 'keys',
                                                    loc: {
                                                        start: {
                                                            line: 43,
                                                            column: 29,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                        },
                                                        end: {
                                                            line: 43,
                                                            column: 33,
                                                            fixed: true,
                                                            source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                        }
                                                    }
                                                },
                                                body: {
                                                    type: 'BlockStatement',
                                                    body: [
                                                        {
                                                            type: 'VariableDeclaration',
                                                            declarations: [{
                                                                    type: 'VariableDeclarator',
                                                                    id: {
                                                                        type: 'Identifier',
                                                                        name: 'key',
                                                                        loc: {
                                                                            start: {
                                                                                line: 44,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                            },
                                                                            end: {
                                                                                line: 44,
                                                                                column: 23,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    init: {
                                                                        type: 'NewExpression',
                                                                        callee: {
                                                                            type: 'Identifier',
                                                                            name: 'Key',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 44,
                                                                                    column: 30,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 44,
                                                                                    column: 33,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [
                                                                            {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'global',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 44,
                                                                                                column: 34,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 44,
                                                                                                column: 40,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'model',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 44,
                                                                                                column: 41,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 44,
                                                                                                column: 46,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 44,
                                                                                            column: 34,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 44,
                                                                                            column: 46,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'namespace',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 44,
                                                                                            column: 47,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 44,
                                                                                            column: 56,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 44,
                                                                                        column: 34,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 44,
                                                                                        column: 56,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            {
                                                                                type: 'Identifier',
                                                                                name: 'keyString',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 44,
                                                                                        column: 58,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 44,
                                                                                        column: 67,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                    }
                                                                                }
                                                                            }
                                                                        ],
                                                                        loc: {
                                                                            start: {
                                                                                line: 44,
                                                                                column: 26,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                            },
                                                                            end: {
                                                                                line: 44,
                                                                                column: 68,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                            }
                                                                        }
                                                                    }
                                                                }],
                                                            kind: 'let',
                                                            order: '0'
                                                        },
                                                        {
                                                            type: 'IfStatement',
                                                            test: {
                                                                type: 'BinaryExpression',
                                                                operator: '&&',
                                                                left: {
                                                                    type: 'UnaryExpression',
                                                                    operator: '!',
                                                                    argument: {
                                                                        type: 'UnaryExpression',
                                                                        operator: '?',
                                                                        argument: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'key',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 45,
                                                                                        column: 23,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 45,
                                                                                        column: 26,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'query',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 45,
                                                                                        column: 27,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 45,
                                                                                        column: 32,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 45,
                                                                                    column: 23,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 45,
                                                                                    column: 32,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                }
                                                                            }
                                                                        }
                                                                    }
                                                                },
                                                                right: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '===',
                                                                    left: {
                                                                        type: 'MemberExpression',
                                                                        computed: true,
                                                                        object: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'Identifier',
                                                                                    name: 'global',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 45,
                                                                                            column: 38,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 45,
                                                                                            column: 44,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'model',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 45,
                                                                                            column: 45,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 45,
                                                                                            column: 50,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 45,
                                                                                        column: 38,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 45,
                                                                                        column: 50,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'server',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 45,
                                                                                        column: 51,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 45,
                                                                                        column: 57,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 45,
                                                                                    column: 38,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 45,
                                                                                    column: 57,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'key',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 45,
                                                                                    column: 58,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 45,
                                                                                    column: 61,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 45,
                                                                                column: 38,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                            },
                                                                            end: {
                                                                                line: 45,
                                                                                column: 62,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    right: {
                                                                        type: 'Literal',
                                                                        value: null
                                                                    }
                                                                }
                                                            },
                                                            consequent: {
                                                                type: 'BlockStatement',
                                                                body: [{
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'ObjectExpression',
                                                                            objectType: {
                                                                                type: 'ObjectExpression',
                                                                                properties: [{
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'key',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 46,
                                                                                                    column: 21,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 46,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'CallExpression',
                                                                                            callee: {
                                                                                                type: 'MemberExpression',
                                                                                                computed: false,
                                                                                                object: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'key',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 46,
                                                                                                            column: 25,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 46,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'toString',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 46,
                                                                                                            column: 29,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 46,
                                                                                                            column: 37,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 46,
                                                                                                        column: 25,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 46,
                                                                                                        column: 37,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            arguments: [],
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 46,
                                                                                                    column: 25,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 46,
                                                                                                    column: 39,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            properties: [{
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'value',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 47,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 47,
                                                                                                column: 29,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'ObjectExpression',
                                                                                        objectType: {
                                                                                            type: 'ObjectExpression',
                                                                                            properties: []
                                                                                        },
                                                                                        properties: [
                                                                                            {
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'key',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 48,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 48,
                                                                                                            column: 31,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'CallExpression',
                                                                                                    callee: {
                                                                                                        type: 'MemberExpression',
                                                                                                        computed: false,
                                                                                                        object: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'key',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 48,
                                                                                                                    column: 33,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 48,
                                                                                                                    column: 36,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        property: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'toString',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 48,
                                                                                                                    column: 37,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 48,
                                                                                                                    column: 45,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 48,
                                                                                                                column: 33,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 48,
                                                                                                                column: 45,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    arguments: [],
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 48,
                                                                                                            column: 33,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 48,
                                                                                                            column: 47,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '0'
                                                                                            },
                                                                                            {
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'name',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 49,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 49,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'MemberExpression',
                                                                                                    computed: false,
                                                                                                    object: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'key',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 49,
                                                                                                                column: 34,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 49,
                                                                                                                column: 37,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    property: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'id',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 49,
                                                                                                                column: 38,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 49,
                                                                                                                column: 40,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 49,
                                                                                                            column: 34,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 49,
                                                                                                            column: 40,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '1'
                                                                                            },
                                                                                            {
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'description',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 50,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 50,
                                                                                                            column: 39,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'Literal',
                                                                                                    value: 'Does not exist yet.'
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '2'
                                                                                            }
                                                                                        ]
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                }]
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 46,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                            },
                                                                            end: {
                                                                                line: 52,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/RecordSearchSuggestions.ion'
                                                                            }
                                                                        },
                                                                        order: '0'
                                                                    }]
                                                            },
                                                            alternate: null,
                                                            order: '1'
                                                        }
                                                    ]
                                                },
                                                remove: null,
                                                order: '0'
                                            }]
                                    },
                                    alternate: null,
                                    order: '1'
                                }
                            ]
                        }
                    }],
                kind: 'let',
                order: '5'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'CallExpression',
                    callee: {
                        type: 'Identifier',
                        name: 'getMaxSorted',
                        loc: {
                            start: {
                                line: 54,
                                column: 11,
                                fixed: true,
                                source: 'glass/html/material/RecordSearchSuggestions.ion'
                            },
                            end: {
                                line: 54,
                                column: 23,
                                fixed: true,
                                source: 'glass/html/material/RecordSearchSuggestions.ion'
                            }
                        }
                    },
                    arguments: [
                        {
                            type: 'Identifier',
                            name: 'suggestions',
                            loc: {
                                start: {
                                    line: 54,
                                    column: 24,
                                    fixed: true,
                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                },
                                end: {
                                    line: 54,
                                    column: 35,
                                    fixed: true,
                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                }
                            }
                        },
                        {
                            type: 'Identifier',
                            name: 'text',
                            loc: {
                                start: {
                                    line: 54,
                                    column: 37,
                                    fixed: true,
                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                },
                                end: {
                                    line: 54,
                                    column: 41,
                                    fixed: true,
                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                }
                            }
                        },
                        {
                            type: 'Identifier',
                            name: 'max',
                            loc: {
                                start: {
                                    line: 54,
                                    column: 43,
                                    fixed: true,
                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                },
                                end: {
                                    line: 54,
                                    column: 46,
                                    fixed: true,
                                    source: 'glass/html/material/RecordSearchSuggestions.ion'
                                }
                            }
                        }
                    ],
                    loc: {
                        start: {
                            line: 54,
                            column: 11,
                            fixed: true,
                            source: 'glass/html/material/RecordSearchSuggestions.ion'
                        },
                        end: {
                            line: 54,
                            column: 47,
                            fixed: true,
                            source: 'glass/html/material/RecordSearchSuggestions.ion'
                        }
                    }
                },
                order: '6'
            }
        ],
        bound: false
    }, {
        this: this,
        _ref3: _ref3,
        _ref: _ref,
        Key: Key,
        getMaxSorted: getMaxSorted
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/RecordSearchSuggestions',_glass_html_material_RecordSearchSuggestions_);
    else
      _glass_html_material_RecordSearchSuggestions_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_RecordSearchSuggestions_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_RelationInput_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('./'), _ref2;
var AutoCompleteInput = _ref.AutoCompleteInput;
var RecordSearchSuggestions = _ref.RecordSearchSuggestions;
_ref2 = require('../../data');
var Key = _ref2.Key;
module.exports = exports = ion.template(function RelationInput(_ref3) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'RelationInput',
            loc: {
                start: {
                    line: 6,
                    column: 16,
                    fixed: true,
                    source: 'glass/html/material/RelationInput.ion'
                },
                end: {
                    line: 6,
                    column: 29,
                    fixed: true,
                    source: 'glass/html/material/RelationInput.ion'
                }
            }
        },
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'object',
                            loc: {
                                start: {
                                    line: 6,
                                    column: 31,
                                    fixed: true,
                                    source: 'glass/html/material/RelationInput.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 37,
                                    fixed: true,
                                    source: 'glass/html/material/RelationInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'object',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 31,
                                        fixed: true,
                                        source: 'glass/html/material/RelationInput.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 37,
                                        fixed: true,
                                        source: 'glass/html/material/RelationInput.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'property',
                            loc: {
                                start: {
                                    line: 6,
                                    column: 39,
                                    fixed: true,
                                    source: 'glass/html/material/RelationInput.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 47,
                                    fixed: true,
                                    source: 'glass/html/material/RelationInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'property',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 39,
                                        fixed: true,
                                        source: 'glass/html/material/RelationInput.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 47,
                                        fixed: true,
                                        source: 'glass/html/material/RelationInput.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'initialValue',
                            loc: {
                                start: {
                                    line: 6,
                                    column: 55,
                                    fixed: true,
                                    source: 'glass/html/material/RelationInput.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 67,
                                    fixed: true,
                                    source: 'glass/html/material/RelationInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'value',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 49,
                                        fixed: true,
                                        source: 'glass/html/material/RelationInput.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 54,
                                        fixed: true,
                                        source: 'glass/html/material/RelationInput.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'inline',
                            loc: {
                                start: {
                                    line: 6,
                                    column: 69,
                                    fixed: true,
                                    source: 'glass/html/material/RelationInput.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 75,
                                    fixed: true,
                                    source: 'glass/html/material/RelationInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'inline',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 69,
                                        fixed: true,
                                        source: 'glass/html/material/RelationInput.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 75,
                                        fixed: true,
                                        source: 'glass/html/material/RelationInput.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '3'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'suggestionTemplate',
                            loc: {
                                start: {
                                    line: 8,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/RelationInput.ion'
                                },
                                end: {
                                    line: 8,
                                    column: 26,
                                    fixed: true,
                                    source: 'glass/html/material/RelationInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'Function',
                            context: true,
                            value: function (_ps) {
                                return ion.template(function (_ref4) {
                                    return ion.createRuntime({
                                        type: 'Template',
                                        id: null,
                                        body: [
                                            {
                                                type: 'VariableDeclaration',
                                                declarations: [{
                                                        type: 'VariableDeclarator',
                                                        id: {
                                                            type: 'Identifier',
                                                            name: 'text',
                                                            loc: {
                                                                start: {
                                                                    line: 8,
                                                                    column: 40,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RelationInput.ion'
                                                                },
                                                                end: {
                                                                    line: 8,
                                                                    column: 44,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RelationInput.ion'
                                                                }
                                                            }
                                                        },
                                                        init: {
                                                            type: 'MemberExpression',
                                                            object: {
                                                                type: 'Identifier',
                                                                name: '_ref4'
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'text',
                                                                loc: {
                                                                    start: {
                                                                        line: 8,
                                                                        column: 40,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RelationInput.ion'
                                                                    },
                                                                    end: {
                                                                        line: 8,
                                                                        column: 44,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RelationInput.ion'
                                                                    }
                                                                }
                                                            },
                                                            computed: false
                                                        }
                                                    }],
                                                kind: 'let',
                                                order: '0'
                                            },
                                            {
                                                type: 'VariableDeclaration',
                                                declarations: [{
                                                        type: 'VariableDeclarator',
                                                        id: {
                                                            type: 'Identifier',
                                                            name: 'getSearchKeys',
                                                            loc: {
                                                                start: {
                                                                    line: 9,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RelationInput.ion'
                                                                },
                                                                end: {
                                                                    line: 9,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RelationInput.ion'
                                                                }
                                                            }
                                                        },
                                                        init: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'property',
                                                                    loc: {
                                                                        start: {
                                                                            line: 9,
                                                                            column: 28,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RelationInput.ion'
                                                                        },
                                                                        end: {
                                                                            line: 9,
                                                                            column: 36,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RelationInput.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'foreign',
                                                                    loc: {
                                                                        start: {
                                                                            line: 9,
                                                                            column: 37,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RelationInput.ion'
                                                                        },
                                                                        end: {
                                                                            line: 9,
                                                                            column: 44,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RelationInput.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 9,
                                                                        column: 28,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RelationInput.ion'
                                                                    },
                                                                    end: {
                                                                        line: 9,
                                                                        column: 44,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RelationInput.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'getSearchKeys',
                                                                loc: {
                                                                    start: {
                                                                        line: 9,
                                                                        column: 45,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RelationInput.ion'
                                                                    },
                                                                    end: {
                                                                        line: 9,
                                                                        column: 58,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RelationInput.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 9,
                                                                    column: 28,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RelationInput.ion'
                                                                },
                                                                end: {
                                                                    line: 9,
                                                                    column: 58,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RelationInput.ion'
                                                                }
                                                            }
                                                        }
                                                    }],
                                                kind: 'let',
                                                order: '1'
                                            },
                                            {
                                                type: 'VariableDeclaration',
                                                declarations: [{
                                                        type: 'VariableDeclarator',
                                                        id: {
                                                            type: 'Identifier',
                                                            name: 'showMissingEntities',
                                                            loc: {
                                                                start: {
                                                                    line: 10,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RelationInput.ion'
                                                                },
                                                                end: {
                                                                    line: 10,
                                                                    column: 31,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RelationInput.ion'
                                                                }
                                                            }
                                                        },
                                                        init: {
                                                            type: 'ConditionalExpression',
                                                            test: {
                                                                type: 'BinaryExpression',
                                                                operator: '!=',
                                                                left: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'property',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 10,
                                                                                    column: 34,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/RelationInput.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 10,
                                                                                    column: 42,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/RelationInput.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'foreign',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 10,
                                                                                    column: 43,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/RelationInput.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 10,
                                                                                    column: 50,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/RelationInput.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 10,
                                                                                column: 34,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/RelationInput.ion'
                                                                            },
                                                                            end: {
                                                                                line: 10,
                                                                                column: 50,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/RelationInput.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'showMissingEntities',
                                                                        loc: {
                                                                            start: {
                                                                                line: 10,
                                                                                column: 51,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/RelationInput.ion'
                                                                            },
                                                                            end: {
                                                                                line: 10,
                                                                                column: 70,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/RelationInput.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 10,
                                                                            column: 34,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RelationInput.ion'
                                                                        },
                                                                        end: {
                                                                            line: 10,
                                                                            column: 70,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RelationInput.ion'
                                                                        }
                                                                    }
                                                                },
                                                                right: {
                                                                    type: 'Literal',
                                                                    value: null
                                                                }
                                                            },
                                                            consequent: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'property',
                                                                        loc: {
                                                                            start: {
                                                                                line: 10,
                                                                                column: 34,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/RelationInput.ion'
                                                                            },
                                                                            end: {
                                                                                line: 10,
                                                                                column: 42,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/RelationInput.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'foreign',
                                                                        loc: {
                                                                            start: {
                                                                                line: 10,
                                                                                column: 43,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/RelationInput.ion'
                                                                            },
                                                                            end: {
                                                                                line: 10,
                                                                                column: 50,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/RelationInput.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 10,
                                                                            column: 34,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RelationInput.ion'
                                                                        },
                                                                        end: {
                                                                            line: 10,
                                                                            column: 50,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RelationInput.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'showMissingEntities',
                                                                    loc: {
                                                                        start: {
                                                                            line: 10,
                                                                            column: 51,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RelationInput.ion'
                                                                        },
                                                                        end: {
                                                                            line: 10,
                                                                            column: 70,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RelationInput.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 10,
                                                                        column: 34,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RelationInput.ion'
                                                                    },
                                                                    end: {
                                                                        line: 10,
                                                                        column: 70,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RelationInput.ion'
                                                                    }
                                                                }
                                                            },
                                                            alternate: {
                                                                type: 'Literal',
                                                                value: false
                                                            }
                                                        }
                                                    }],
                                                kind: 'let',
                                                order: '2'
                                            },
                                            {
                                                type: 'VariableDeclaration',
                                                declarations: [{
                                                        type: 'VariableDeclarator',
                                                        id: {
                                                            type: 'Identifier',
                                                            name: 'keys',
                                                            loc: {
                                                                start: {
                                                                    line: 11,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RelationInput.ion'
                                                                },
                                                                end: {
                                                                    line: 11,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RelationInput.ion'
                                                                }
                                                            }
                                                        },
                                                        init: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'getSearchKeys',
                                                                loc: {
                                                                    start: {
                                                                        line: 11,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RelationInput.ion'
                                                                    },
                                                                    end: {
                                                                        line: 11,
                                                                        column: 32,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RelationInput.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [
                                                                {
                                                                    type: 'Identifier',
                                                                    name: 'object',
                                                                    loc: {
                                                                        start: {
                                                                            line: 11,
                                                                            column: 33,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RelationInput.ion'
                                                                        },
                                                                        end: {
                                                                            line: 11,
                                                                            column: 39,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RelationInput.ion'
                                                                        }
                                                                    }
                                                                },
                                                                {
                                                                    type: 'Identifier',
                                                                    name: 'text',
                                                                    loc: {
                                                                        start: {
                                                                            line: 11,
                                                                            column: 41,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RelationInput.ion'
                                                                        },
                                                                        end: {
                                                                            line: 11,
                                                                            column: 45,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/RelationInput.ion'
                                                                        }
                                                                    }
                                                                }
                                                            ],
                                                            loc: {
                                                                start: {
                                                                    line: 11,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RelationInput.ion'
                                                                },
                                                                end: {
                                                                    line: 11,
                                                                    column: 46,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RelationInput.ion'
                                                                }
                                                            }
                                                        }
                                                    }],
                                                kind: 'let',
                                                order: '3'
                                            },
                                            {
                                                type: 'VariableDeclaration',
                                                declarations: [{
                                                        type: 'VariableDeclarator',
                                                        id: {
                                                            type: 'Identifier',
                                                            name: 'suggestions',
                                                            loc: {
                                                                start: {
                                                                    line: 12,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RelationInput.ion'
                                                                },
                                                                end: {
                                                                    line: 12,
                                                                    column: 23,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RelationInput.ion'
                                                                }
                                                            }
                                                        },
                                                        init: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'RecordSearchSuggestions',
                                                                loc: {
                                                                    start: {
                                                                        line: 12,
                                                                        column: 26,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RelationInput.ion'
                                                                    },
                                                                    end: {
                                                                        line: 12,
                                                                        column: 49,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RelationInput.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [{
                                                                    type: 'ObjectExpression',
                                                                    properties: [
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'text',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 12,
                                                                                        column: 51,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/RelationInput.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 12,
                                                                                        column: 55,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/RelationInput.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Identifier',
                                                                                name: 'text',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 12,
                                                                                        column: 51,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/RelationInput.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 12,
                                                                                        column: 55,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/RelationInput.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'keys',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 12,
                                                                                        column: 56,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/RelationInput.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 12,
                                                                                        column: 60,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/RelationInput.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Identifier',
                                                                                name: 'keys',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 12,
                                                                                        column: 56,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/RelationInput.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 12,
                                                                                        column: 60,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/RelationInput.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            kind: 'init',
                                                                            order: '1'
                                                                        },
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'showMissingEntities',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 12,
                                                                                        column: 61,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/RelationInput.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 12,
                                                                                        column: 80,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/RelationInput.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Identifier',
                                                                                name: 'showMissingEntities',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 12,
                                                                                        column: 61,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/RelationInput.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 12,
                                                                                        column: 80,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/RelationInput.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            kind: 'init',
                                                                            order: '2'
                                                                        }
                                                                    ]
                                                                }],
                                                            loc: {
                                                                start: {
                                                                    line: 12,
                                                                    column: 26,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RelationInput.ion'
                                                                },
                                                                end: {
                                                                    line: 12,
                                                                    column: 82,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RelationInput.ion'
                                                                }
                                                            }
                                                        }
                                                    }],
                                                kind: 'let',
                                                order: '4'
                                            },
                                            {
                                                type: 'ReturnStatement',
                                                argument: {
                                                    type: 'Identifier',
                                                    name: 'suggestions',
                                                    loc: {
                                                        start: {
                                                            line: 13,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/RelationInput.ion'
                                                        },
                                                        end: {
                                                            line: 13,
                                                            column: 26,
                                                            fixed: true,
                                                            source: 'glass/html/material/RelationInput.ion'
                                                        }
                                                    }
                                                },
                                                order: '5'
                                            }
                                        ],
                                        bound: false,
                                        name: {
                                            type: 'Identifier',
                                            name: 'suggestionTemplate',
                                            loc: {
                                                start: {
                                                    line: 8,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'glass/html/material/RelationInput.ion'
                                                },
                                                end: {
                                                    line: 8,
                                                    column: 26,
                                                    fixed: true,
                                                    source: 'glass/html/material/RelationInput.ion'
                                                }
                                            }
                                        },
                                        scope: {
                                            type: 'Identifier',
                                            name: '_ps'
                                        }
                                    }, {
                                        this: this,
                                        _ref4: _ref4,
                                        _ps: _ps,
                                        _ref3: _ref3,
                                        _ref: _ref,
                                        _ref2: _ref2,
                                        AutoCompleteInput: AutoCompleteInput,
                                        RecordSearchSuggestions: RecordSearchSuggestions,
                                        Key: Key
                                    }, _ps);
                                });
                            }
                        }
                    }],
                kind: 'let',
                order: '4'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'input',
                            loc: {
                                start: {
                                    line: 15,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/RelationInput.ion'
                                },
                                end: {
                                    line: 15,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/html/material/RelationInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: 'Object'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'defineProperties'
                                }
                            },
                            arguments: [
                                {
                                    type: 'ObjectExpression',
                                    objectType: {
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'Identifier',
                                            name: 'AutoCompleteInput',
                                            loc: {
                                                start: {
                                                    line: 15,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/html/material/RelationInput.ion'
                                                },
                                                end: {
                                                    line: 15,
                                                    column: 33,
                                                    fixed: true,
                                                    source: 'glass/html/material/RelationInput.ion'
                                                }
                                            }
                                        },
                                        arguments: [{
                                                type: 'ObjectExpression',
                                                properties: [
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'suggestionTemplate',
                                                            loc: {
                                                                start: {
                                                                    line: 15,
                                                                    column: 35,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RelationInput.ion'
                                                                },
                                                                end: {
                                                                    line: 15,
                                                                    column: 53,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RelationInput.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Identifier',
                                                            name: 'suggestionTemplate',
                                                            loc: {
                                                                start: {
                                                                    line: 15,
                                                                    column: 35,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RelationInput.ion'
                                                                },
                                                                end: {
                                                                    line: 15,
                                                                    column: 53,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RelationInput.ion'
                                                                }
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'notFoundMessage',
                                                            loc: {
                                                                start: {
                                                                    line: 15,
                                                                    column: 55,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RelationInput.ion'
                                                                },
                                                                end: {
                                                                    line: 15,
                                                                    column: 70,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RelationInput.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'property',
                                                                loc: {
                                                                    start: {
                                                                        line: 15,
                                                                        column: 71,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RelationInput.ion'
                                                                    },
                                                                    end: {
                                                                        line: 15,
                                                                        column: 79,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RelationInput.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'notFoundMessage',
                                                                loc: {
                                                                    start: {
                                                                        line: 15,
                                                                        column: 80,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RelationInput.ion'
                                                                    },
                                                                    end: {
                                                                        line: 15,
                                                                        column: 95,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/RelationInput.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 15,
                                                                    column: 71,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RelationInput.ion'
                                                                },
                                                                end: {
                                                                    line: 15,
                                                                    column: 95,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RelationInput.ion'
                                                                }
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '1'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'value',
                                                            loc: {
                                                                start: {
                                                                    line: 15,
                                                                    column: 97,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RelationInput.ion'
                                                                },
                                                                end: {
                                                                    line: 15,
                                                                    column: 102,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RelationInput.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Identifier',
                                                            name: 'initialValue',
                                                            loc: {
                                                                start: {
                                                                    line: 15,
                                                                    column: 103,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RelationInput.ion'
                                                                },
                                                                end: {
                                                                    line: 15,
                                                                    column: 115,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RelationInput.ion'
                                                                }
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '2'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'inline',
                                                            loc: {
                                                                start: {
                                                                    line: 15,
                                                                    column: 117,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RelationInput.ion'
                                                                },
                                                                end: {
                                                                    line: 15,
                                                                    column: 123,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RelationInput.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Identifier',
                                                            name: 'inline',
                                                            loc: {
                                                                start: {
                                                                    line: 15,
                                                                    column: 117,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RelationInput.ion'
                                                                },
                                                                end: {
                                                                    line: 15,
                                                                    column: 123,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RelationInput.ion'
                                                                }
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '3'
                                                    }
                                                ]
                                            }],
                                        loc: {
                                            start: {
                                                line: 15,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/RelationInput.ion'
                                            },
                                            end: {
                                                line: 15,
                                                column: 125,
                                                fixed: true,
                                                source: 'glass/html/material/RelationInput.ion'
                                            }
                                        }
                                    },
                                    properties: [{
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'name',
                                                loc: {
                                                    start: {
                                                        line: 16,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'glass/html/material/RelationInput.ion'
                                                    },
                                                    end: {
                                                        line: 16,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/RelationInput.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'property',
                                                    loc: {
                                                        start: {
                                                            line: 16,
                                                            column: 14,
                                                            fixed: true,
                                                            source: 'glass/html/material/RelationInput.ion'
                                                        },
                                                        end: {
                                                            line: 16,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'glass/html/material/RelationInput.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'name',
                                                    loc: {
                                                        start: {
                                                            line: 16,
                                                            column: 23,
                                                            fixed: true,
                                                            source: 'glass/html/material/RelationInput.ion'
                                                        },
                                                        end: {
                                                            line: 16,
                                                            column: 27,
                                                            fixed: true,
                                                            source: 'glass/html/material/RelationInput.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 16,
                                                        column: 14,
                                                        fixed: true,
                                                        source: 'glass/html/material/RelationInput.ion'
                                                    },
                                                    end: {
                                                        line: 16,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'glass/html/material/RelationInput.ion'
                                                    }
                                                }
                                            },
                                            kind: 'init',
                                            order: '0'
                                        }]
                                },
                                {
                                    type: 'ObjectExpression',
                                    properties: [{
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'valueJSON',
                                                loc: {
                                                    start: {
                                                        line: 17,
                                                        column: 17,
                                                        fixed: true,
                                                        source: 'glass/html/material/RelationInput.ion'
                                                    },
                                                    end: {
                                                        line: 17,
                                                        column: 26,
                                                        fixed: true,
                                                        source: 'glass/html/material/RelationInput.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'ObjectExpression',
                                                properties: [{
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'get',
                                                            loc: {
                                                                start: {
                                                                    line: 18,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RelationInput.ion'
                                                                },
                                                                end: {
                                                                    line: 18,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/RelationInput.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Function',
                                                            context: true,
                                                            value: function (_context) {
                                                                return function () {
                                                                    var input = _context.get('input');
                                                                    var item = input.selectedItem;
                                                                    var value = (item != null ? item.key : void 0) != null ? item.key : null;
                                                                    return value;
                                                                };
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    }]
                                            },
                                            kind: 'init',
                                            define: false,
                                            order: '0'
                                        }]
                                }
                            ]
                        }
                    }],
                kind: 'let',
                order: '5'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'Identifier',
                    name: 'input',
                    loc: {
                        start: {
                            line: 23,
                            column: 11,
                            fixed: true,
                            source: 'glass/html/material/RelationInput.ion'
                        },
                        end: {
                            line: 23,
                            column: 16,
                            fixed: true,
                            source: 'glass/html/material/RelationInput.ion'
                        }
                    }
                },
                order: '6'
            }
        ],
        bound: false
    }, {
        this: this,
        ion: ion,
        _ref3: _ref3,
        _ref: _ref,
        _ref2: _ref2,
        AutoCompleteInput: AutoCompleteInput,
        RecordSearchSuggestions: RecordSearchSuggestions,
        Key: Key
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/RelationInput',_glass_html_material_RelationInput_);
    else
      _glass_html_material_RelationInput_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_RelationInput_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_Renamer_ = function(module,exports,require){'use strict';
var ion = require('ion');
var glass = require('../../');
var _ref = glass.data, _ref2;
var Schema = _ref.Schema;
_ref2 = glass.html.material;
var PromptDialog = _ref2.PromptDialog;
module.exports = exports = ion.template(function Renamer(_ref3) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'Renamer',
            loc: {
                start: {
                    line: 7,
                    column: 16,
                    fixed: true,
                    source: 'glass/html/material/Renamer.ion'
                },
                end: {
                    line: 7,
                    column: 23,
                    fixed: true,
                    source: 'glass/html/material/Renamer.ion'
                }
            }
        },
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'prompt',
                            loc: {
                                start: {
                                    line: 7,
                                    column: 25,
                                    fixed: true,
                                    source: 'glass/html/material/Renamer.ion'
                                },
                                end: {
                                    line: 7,
                                    column: 31,
                                    fixed: true,
                                    source: 'glass/html/material/Renamer.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'prompt',
                                loc: {
                                    start: {
                                        line: 7,
                                        column: 25,
                                        fixed: true,
                                        source: 'glass/html/material/Renamer.ion'
                                    },
                                    end: {
                                        line: 7,
                                        column: 31,
                                        fixed: true,
                                        source: 'glass/html/material/Renamer.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'object',
                            loc: {
                                start: {
                                    line: 7,
                                    column: 33,
                                    fixed: true,
                                    source: 'glass/html/material/Renamer.ion'
                                },
                                end: {
                                    line: 7,
                                    column: 39,
                                    fixed: true,
                                    source: 'glass/html/material/Renamer.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'object',
                                loc: {
                                    start: {
                                        line: 7,
                                        column: 33,
                                        fixed: true,
                                        source: 'glass/html/material/Renamer.ion'
                                    },
                                    end: {
                                        line: 7,
                                        column: 39,
                                        fixed: true,
                                        source: 'glass/html/material/Renamer.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'property',
                            loc: {
                                start: {
                                    line: 7,
                                    column: 41,
                                    fixed: true,
                                    source: 'glass/html/material/Renamer.ion'
                                },
                                end: {
                                    line: 7,
                                    column: 49,
                                    fixed: true,
                                    source: 'glass/html/material/Renamer.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'property',
                                loc: {
                                    start: {
                                        line: 7,
                                        column: 41,
                                        fixed: true,
                                        source: 'glass/html/material/Renamer.ion'
                                    },
                                    end: {
                                        line: 7,
                                        column: 49,
                                        fixed: true,
                                        source: 'glass/html/material/Renamer.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'renameProperty',
                            loc: {
                                start: {
                                    line: 8,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/Renamer.ion'
                                },
                                end: {
                                    line: 8,
                                    column: 22,
                                    fixed: true,
                                    source: 'glass/html/material/Renamer.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ConditionalExpression',
                            test: {
                                type: 'BinaryExpression',
                                operator: '!=',
                                left: {
                                    type: 'ConditionalExpression',
                                    test: {
                                        type: 'BinaryExpression',
                                        operator: '!=',
                                        left: {
                                            type: 'Identifier',
                                            name: 'property',
                                            loc: {
                                                start: {
                                                    line: 8,
                                                    column: 25,
                                                    fixed: true,
                                                    source: 'glass/html/material/Renamer.ion'
                                                },
                                                end: {
                                                    line: 8,
                                                    column: 33,
                                                    fixed: true,
                                                    source: 'glass/html/material/Renamer.ion'
                                                }
                                            }
                                        },
                                        right: {
                                            type: 'Literal',
                                            value: null
                                        }
                                    },
                                    consequent: {
                                        type: 'Identifier',
                                        name: 'property',
                                        loc: {
                                            start: {
                                                line: 8,
                                                column: 25,
                                                fixed: true,
                                                source: 'glass/html/material/Renamer.ion'
                                            },
                                            end: {
                                                line: 8,
                                                column: 33,
                                                fixed: true,
                                                source: 'glass/html/material/Renamer.ion'
                                            }
                                        }
                                    },
                                    alternate: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'object',
                                                    loc: {
                                                        start: {
                                                            line: 8,
                                                            column: 36,
                                                            fixed: true,
                                                            source: 'glass/html/material/Renamer.ion'
                                                        },
                                                        end: {
                                                            line: 8,
                                                            column: 42,
                                                            fixed: true,
                                                            source: 'glass/html/material/Renamer.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'constructor',
                                                    loc: {
                                                        start: {
                                                            line: 8,
                                                            column: 43,
                                                            fixed: true,
                                                            source: 'glass/html/material/Renamer.ion'
                                                        },
                                                        end: {
                                                            line: 8,
                                                            column: 54,
                                                            fixed: true,
                                                            source: 'glass/html/material/Renamer.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 8,
                                                        column: 36,
                                                        fixed: true,
                                                        source: 'glass/html/material/Renamer.ion'
                                                    },
                                                    end: {
                                                        line: 8,
                                                        column: 54,
                                                        fixed: true,
                                                        source: 'glass/html/material/Renamer.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'properties',
                                                loc: {
                                                    start: {
                                                        line: 8,
                                                        column: 55,
                                                        fixed: true,
                                                        source: 'glass/html/material/Renamer.ion'
                                                    },
                                                    end: {
                                                        line: 8,
                                                        column: 65,
                                                        fixed: true,
                                                        source: 'glass/html/material/Renamer.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 8,
                                                    column: 36,
                                                    fixed: true,
                                                    source: 'glass/html/material/Renamer.ion'
                                                },
                                                end: {
                                                    line: 8,
                                                    column: 65,
                                                    fixed: true,
                                                    source: 'glass/html/material/Renamer.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'name',
                                            loc: {
                                                start: {
                                                    line: 8,
                                                    column: 67,
                                                    fixed: true,
                                                    source: 'glass/html/material/Renamer.ion'
                                                },
                                                end: {
                                                    line: 8,
                                                    column: 71,
                                                    fixed: true,
                                                    source: 'glass/html/material/Renamer.ion'
                                                }
                                            }
                                        },
                                        existential: true,
                                        loc: {
                                            start: {
                                                line: 8,
                                                column: 36,
                                                fixed: true,
                                                source: 'glass/html/material/Renamer.ion'
                                            },
                                            end: {
                                                line: 8,
                                                column: 71,
                                                fixed: true,
                                                source: 'glass/html/material/Renamer.ion'
                                            }
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: null
                                }
                            },
                            consequent: {
                                type: 'ConditionalExpression',
                                test: {
                                    type: 'BinaryExpression',
                                    operator: '!=',
                                    left: {
                                        type: 'Identifier',
                                        name: 'property',
                                        loc: {
                                            start: {
                                                line: 8,
                                                column: 25,
                                                fixed: true,
                                                source: 'glass/html/material/Renamer.ion'
                                            },
                                            end: {
                                                line: 8,
                                                column: 33,
                                                fixed: true,
                                                source: 'glass/html/material/Renamer.ion'
                                            }
                                        }
                                    },
                                    right: {
                                        type: 'Literal',
                                        value: null
                                    }
                                },
                                consequent: {
                                    type: 'Identifier',
                                    name: 'property',
                                    loc: {
                                        start: {
                                            line: 8,
                                            column: 25,
                                            fixed: true,
                                            source: 'glass/html/material/Renamer.ion'
                                        },
                                        end: {
                                            line: 8,
                                            column: 33,
                                            fixed: true,
                                            source: 'glass/html/material/Renamer.ion'
                                        }
                                    }
                                },
                                alternate: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'object',
                                                loc: {
                                                    start: {
                                                        line: 8,
                                                        column: 36,
                                                        fixed: true,
                                                        source: 'glass/html/material/Renamer.ion'
                                                    },
                                                    end: {
                                                        line: 8,
                                                        column: 42,
                                                        fixed: true,
                                                        source: 'glass/html/material/Renamer.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'constructor',
                                                loc: {
                                                    start: {
                                                        line: 8,
                                                        column: 43,
                                                        fixed: true,
                                                        source: 'glass/html/material/Renamer.ion'
                                                    },
                                                    end: {
                                                        line: 8,
                                                        column: 54,
                                                        fixed: true,
                                                        source: 'glass/html/material/Renamer.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 8,
                                                    column: 36,
                                                    fixed: true,
                                                    source: 'glass/html/material/Renamer.ion'
                                                },
                                                end: {
                                                    line: 8,
                                                    column: 54,
                                                    fixed: true,
                                                    source: 'glass/html/material/Renamer.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'properties',
                                            loc: {
                                                start: {
                                                    line: 8,
                                                    column: 55,
                                                    fixed: true,
                                                    source: 'glass/html/material/Renamer.ion'
                                                },
                                                end: {
                                                    line: 8,
                                                    column: 65,
                                                    fixed: true,
                                                    source: 'glass/html/material/Renamer.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 8,
                                                column: 36,
                                                fixed: true,
                                                source: 'glass/html/material/Renamer.ion'
                                            },
                                            end: {
                                                line: 8,
                                                column: 65,
                                                fixed: true,
                                                source: 'glass/html/material/Renamer.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'name',
                                        loc: {
                                            start: {
                                                line: 8,
                                                column: 67,
                                                fixed: true,
                                                source: 'glass/html/material/Renamer.ion'
                                            },
                                            end: {
                                                line: 8,
                                                column: 71,
                                                fixed: true,
                                                source: 'glass/html/material/Renamer.ion'
                                            }
                                        }
                                    },
                                    existential: true,
                                    loc: {
                                        start: {
                                            line: 8,
                                            column: 36,
                                            fixed: true,
                                            source: 'glass/html/material/Renamer.ion'
                                        },
                                        end: {
                                            line: 8,
                                            column: 71,
                                            fixed: true,
                                            source: 'glass/html/material/Renamer.ion'
                                        }
                                    }
                                }
                            },
                            alternate: {
                                type: 'ObjectExpression',
                                properties: [{
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'name',
                                            loc: {
                                                start: {
                                                    line: 8,
                                                    column: 75,
                                                    fixed: true,
                                                    source: 'glass/html/material/Renamer.ion'
                                                },
                                                end: {
                                                    line: 8,
                                                    column: 79,
                                                    fixed: true,
                                                    source: 'glass/html/material/Renamer.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: 'name'
                                        },
                                        kind: 'init',
                                        order: '0'
                                    }]
                            }
                        }
                    }],
                kind: 'let',
                order: '3'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'name',
                            loc: {
                                start: {
                                    line: 9,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/Renamer.ion'
                                },
                                end: {
                                    line: 9,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/Renamer.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            computed: true,
                            object: {
                                type: 'Identifier',
                                name: 'object',
                                loc: {
                                    start: {
                                        line: 9,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/Renamer.ion'
                                    },
                                    end: {
                                        line: 9,
                                        column: 21,
                                        fixed: true,
                                        source: 'glass/html/material/Renamer.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'renameProperty',
                                loc: {
                                    start: {
                                        line: 9,
                                        column: 23,
                                        fixed: true,
                                        source: 'glass/html/material/Renamer.ion'
                                    },
                                    end: {
                                        line: 9,
                                        column: 37,
                                        fixed: true,
                                        source: 'glass/html/material/Renamer.ion'
                                    }
                                }
                            },
                            existential: true,
                            loc: {
                                start: {
                                    line: 9,
                                    column: 15,
                                    fixed: true,
                                    source: 'glass/html/material/Renamer.ion'
                                },
                                end: {
                                    line: 9,
                                    column: 38,
                                    fixed: true,
                                    source: 'glass/html/material/Renamer.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '4'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'CallExpression',
                        callee: {
                            type: 'Identifier',
                            name: 'Span',
                            loc: {
                                start: {
                                    line: 10,
                                    column: 11,
                                    fixed: true,
                                    source: 'glass/html/material/Renamer.ion'
                                },
                                end: {
                                    line: 10,
                                    column: 15,
                                    fixed: true,
                                    source: 'glass/html/material/Renamer.ion'
                                }
                            }
                        },
                        arguments: [],
                        loc: {
                            start: {
                                line: 10,
                                column: 11,
                                fixed: true,
                                source: 'glass/html/material/Renamer.ion'
                            },
                            end: {
                                line: 10,
                                column: 17,
                                fixed: true,
                                source: 'glass/html/material/Renamer.ion'
                            }
                        }
                    },
                    properties: [
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'style',
                                loc: {
                                    start: {
                                        line: 11,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/Renamer.ion'
                                    },
                                    end: {
                                        line: 11,
                                        column: 13,
                                        fixed: true,
                                        source: 'glass/html/material/Renamer.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'ObjectExpression',
                                properties: [{
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'cursor',
                                            loc: {
                                                start: {
                                                    line: 12,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/Renamer.ion'
                                                },
                                                end: {
                                                    line: 12,
                                                    column: 18,
                                                    fixed: true,
                                                    source: 'glass/html/material/Renamer.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: 'pointer'
                                        },
                                        kind: 'init',
                                        order: '0'
                                    }]
                            },
                            kind: 'init',
                            order: '0'
                        },
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'Function',
                                context: true,
                                value: function (_context) {
                                    return function click(e) {
                                        var PromptDialog = _context.get('PromptDialog'), renameProperty = _context.get('renameProperty'), prompt = _context.get('prompt'), object = _context.get('object'), Schema = _context.get('Schema');
                                        PromptDialog.show({
                                            properties: [renameProperty],
                                            title: prompt,
                                            values: object,
                                            closeOnBlur: true,
                                            submitText: 'Rename',
                                            callback: function (values) {
                                                if (values != null) {
                                                    global.model.ops.begin();
                                                    Schema.set(object, renameProperty, values[renameProperty.name]);
                                                }
                                            }
                                        });
                                    };
                                }
                            },
                            loc: {
                                start: {
                                    line: 13,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/Renamer.ion'
                                },
                                end: {
                                    line: 23,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/Renamer.ion'
                                }
                            },
                            order: '1'
                        },
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'Schema',
                                        loc: {
                                            start: {
                                                line: 23,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Renamer.ion'
                                            },
                                            end: {
                                                line: 23,
                                                column: 14,
                                                fixed: true,
                                                source: 'glass/html/material/Renamer.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'get',
                                        loc: {
                                            start: {
                                                line: 23,
                                                column: 15,
                                                fixed: true,
                                                source: 'glass/html/material/Renamer.ion'
                                            },
                                            end: {
                                                line: 23,
                                                column: 18,
                                                fixed: true,
                                                source: 'glass/html/material/Renamer.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 23,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/Renamer.ion'
                                        },
                                        end: {
                                            line: 23,
                                            column: 18,
                                            fixed: true,
                                            source: 'glass/html/material/Renamer.ion'
                                        }
                                    }
                                },
                                arguments: [
                                    {
                                        type: 'Identifier',
                                        name: 'object',
                                        loc: {
                                            start: {
                                                line: 23,
                                                column: 19,
                                                fixed: true,
                                                source: 'glass/html/material/Renamer.ion'
                                            },
                                            end: {
                                                line: 23,
                                                column: 25,
                                                fixed: true,
                                                source: 'glass/html/material/Renamer.ion'
                                            }
                                        }
                                    },
                                    {
                                        type: 'Identifier',
                                        name: 'renameProperty',
                                        loc: {
                                            start: {
                                                line: 23,
                                                column: 27,
                                                fixed: true,
                                                source: 'glass/html/material/Renamer.ion'
                                            },
                                            end: {
                                                line: 23,
                                                column: 41,
                                                fixed: true,
                                                source: 'glass/html/material/Renamer.ion'
                                            }
                                        }
                                    }
                                ],
                                loc: {
                                    start: {
                                        line: 23,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/Renamer.ion'
                                    },
                                    end: {
                                        line: 23,
                                        column: 42,
                                        fixed: true,
                                        source: 'glass/html/material/Renamer.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 23,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/Renamer.ion'
                                },
                                end: {
                                    line: 23,
                                    column: 42,
                                    fixed: true,
                                    source: 'glass/html/material/Renamer.ion'
                                }
                            },
                            order: '2'
                        }
                    ]
                },
                order: '5'
            }
        ],
        bound: false
    }, {
        this: this,
        _ref3: _ref3,
        glass: glass,
        _ref: _ref,
        _ref2: _ref2,
        Schema: Schema,
        PromptDialog: PromptDialog
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/Renamer',_glass_html_material_Renamer_);
    else
      _glass_html_material_Renamer_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_Renamer_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_Resizable_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('../'), clamp = function (value, min, max) {
        if (min != null && value < min) {
            return min;
        }
        if (max != null && value > max) {
            return max;
        }
        return value;
    };
var style = _ref.style;
module.exports = exports = ion.template(function Resizable(attributes) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'Resizable',
            loc: {
                start: {
                    line: 10,
                    column: 16,
                    fixed: true,
                    source: 'glass/html/material/Resizable.ion'
                },
                end: {
                    line: 10,
                    column: 25,
                    fixed: true,
                    source: 'glass/html/material/Resizable.ion'
                }
            }
        },
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'state',
                            loc: {
                                start: {
                                    line: 12,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/Resizable.ion'
                                },
                                end: {
                                    line: 12,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/html/material/Resizable.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'width',
                                        loc: {
                                            start: {
                                                line: 13,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Resizable.ion'
                                            },
                                            end: {
                                                line: 13,
                                                column: 13,
                                                fixed: true,
                                                source: 'glass/html/material/Resizable.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: null
                                    },
                                    kind: 'init',
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'height',
                                        loc: {
                                            start: {
                                                line: 14,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Resizable.ion'
                                            },
                                            end: {
                                                line: 14,
                                                column: 14,
                                                fixed: true,
                                                source: 'glass/html/material/Resizable.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: null
                                    },
                                    kind: 'init',
                                    order: '1'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'defaultWidth',
                                        loc: {
                                            start: {
                                                line: 15,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Resizable.ion'
                                            },
                                            end: {
                                                line: 15,
                                                column: 20,
                                                fixed: true,
                                                source: 'glass/html/material/Resizable.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: null
                                    },
                                    kind: 'init',
                                    order: '2'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'defaultHeight',
                                        loc: {
                                            start: {
                                                line: 16,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Resizable.ion'
                                            },
                                            end: {
                                                line: 16,
                                                column: 21,
                                                fixed: true,
                                                source: 'glass/html/material/Resizable.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: null
                                    },
                                    kind: 'init',
                                    order: '3'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'minWidth',
                                        loc: {
                                            start: {
                                                line: 17,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Resizable.ion'
                                            },
                                            end: {
                                                line: 17,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/Resizable.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: 10
                                    },
                                    kind: 'init',
                                    order: '4'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'minHeight',
                                        loc: {
                                            start: {
                                                line: 18,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Resizable.ion'
                                            },
                                            end: {
                                                line: 18,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/Resizable.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: 10
                                    },
                                    kind: 'init',
                                    order: '5'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'maxWidth',
                                        loc: {
                                            start: {
                                                line: 19,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Resizable.ion'
                                            },
                                            end: {
                                                line: 19,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/Resizable.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: null
                                    },
                                    kind: 'init',
                                    order: '6'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'maxHeight',
                                        loc: {
                                            start: {
                                                line: 20,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Resizable.ion'
                                            },
                                            end: {
                                                line: 20,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/Resizable.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: null
                                    },
                                    kind: 'init',
                                    order: '7'
                                }
                            ]
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'CallExpression',
                    callee: {
                        type: 'MemberExpression',
                        object: {
                            type: 'Identifier',
                            name: 'Object'
                        },
                        property: {
                            type: 'Identifier',
                            name: 'defineProperties'
                        }
                    },
                    arguments: [
                        {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Div',
                                    loc: {
                                        start: {
                                            line: 21,
                                            column: 11,
                                            fixed: true,
                                            source: 'glass/html/material/Resizable.ion'
                                        },
                                        end: {
                                            line: 21,
                                            column: 14,
                                            fixed: true,
                                            source: 'glass/html/material/Resizable.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'Identifier',
                                        name: 'attributes',
                                        loc: {
                                            start: {
                                                line: 21,
                                                column: 15,
                                                fixed: true,
                                                source: 'glass/html/material/Resizable.ion'
                                            },
                                            end: {
                                                line: 21,
                                                column: 25,
                                                fixed: true,
                                                source: 'glass/html/material/Resizable.ion'
                                            }
                                        }
                                    }],
                                loc: {
                                    start: {
                                        line: 21,
                                        column: 11,
                                        fixed: true,
                                        source: 'glass/html/material/Resizable.ion'
                                    },
                                    end: {
                                        line: 21,
                                        column: 26,
                                        fixed: true,
                                        source: 'glass/html/material/Resizable.ion'
                                    }
                                }
                            },
                            properties: [{
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'style',
                                        loc: {
                                            start: {
                                                line: 22,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Resizable.ion'
                                            },
                                            end: {
                                                line: 22,
                                                column: 13,
                                                fixed: true,
                                                source: 'glass/html/material/Resizable.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'IfStatement',
                                                test: {
                                                    type: 'BinaryExpression',
                                                    operator: '||',
                                                    left: {
                                                        type: 'UnaryExpression',
                                                        operator: '?',
                                                        argument: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'state',
                                                                loc: {
                                                                    start: {
                                                                        line: 23,
                                                                        column: 15,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Resizable.ion'
                                                                    },
                                                                    end: {
                                                                        line: 23,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Resizable.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'width',
                                                                loc: {
                                                                    start: {
                                                                        line: 23,
                                                                        column: 21,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Resizable.ion'
                                                                    },
                                                                    end: {
                                                                        line: 23,
                                                                        column: 26,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Resizable.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 23,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Resizable.ion'
                                                                },
                                                                end: {
                                                                    line: 23,
                                                                    column: 26,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Resizable.ion'
                                                                }
                                                            }
                                                        }
                                                    },
                                                    right: {
                                                        type: 'UnaryExpression',
                                                        operator: '?',
                                                        argument: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'state',
                                                                loc: {
                                                                    start: {
                                                                        line: 23,
                                                                        column: 31,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Resizable.ion'
                                                                    },
                                                                    end: {
                                                                        line: 23,
                                                                        column: 36,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Resizable.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'defaultWidth',
                                                                loc: {
                                                                    start: {
                                                                        line: 23,
                                                                        column: 37,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Resizable.ion'
                                                                    },
                                                                    end: {
                                                                        line: 23,
                                                                        column: 49,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Resizable.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 23,
                                                                    column: 31,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Resizable.ion'
                                                                },
                                                                end: {
                                                                    line: 23,
                                                                    column: 49,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Resizable.ion'
                                                                }
                                                            }
                                                        }
                                                    }
                                                },
                                                consequent: {
                                                    type: 'BlockStatement',
                                                    body: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'width',
                                                                loc: {
                                                                    start: {
                                                                        line: 24,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Resizable.ion'
                                                                    },
                                                                    end: {
                                                                        line: 24,
                                                                        column: 21,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Resizable.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'BinaryExpression',
                                                                operator: '+',
                                                                left: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '+',
                                                                    left: {
                                                                        type: 'Literal',
                                                                        value: ''
                                                                    },
                                                                    right: {
                                                                        type: 'ConditionalExpression',
                                                                        test: {
                                                                            type: 'BinaryExpression',
                                                                            operator: '!=',
                                                                            left: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'Identifier',
                                                                                    name: 'state',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 24,
                                                                                            column: 26,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Resizable.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 24,
                                                                                            column: 31,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Resizable.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'width',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 24,
                                                                                            column: 32,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Resizable.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 24,
                                                                                            column: 37,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Resizable.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 24,
                                                                                        column: 26,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Resizable.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 24,
                                                                                        column: 37,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Resizable.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            right: {
                                                                                type: 'Literal',
                                                                                value: null
                                                                            }
                                                                        },
                                                                        consequent: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'state',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 24,
                                                                                        column: 26,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Resizable.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 24,
                                                                                        column: 31,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Resizable.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'width',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 24,
                                                                                        column: 32,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Resizable.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 24,
                                                                                        column: 37,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Resizable.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 24,
                                                                                    column: 26,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Resizable.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 24,
                                                                                    column: 37,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Resizable.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        alternate: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'state',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 24,
                                                                                        column: 40,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Resizable.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 24,
                                                                                        column: 45,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Resizable.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'defaultWidth',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 24,
                                                                                        column: 46,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Resizable.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 24,
                                                                                        column: 58,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Resizable.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 24,
                                                                                    column: 40,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Resizable.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 24,
                                                                                    column: 58,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Resizable.ion'
                                                                                }
                                                                            }
                                                                        }
                                                                    }
                                                                },
                                                                right: {
                                                                    type: 'Literal',
                                                                    value: 'px'
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                },
                                                alternate: null,
                                                order: '0'
                                            },
                                            {
                                                type: 'IfStatement',
                                                test: {
                                                    type: 'BinaryExpression',
                                                    operator: '||',
                                                    left: {
                                                        type: 'UnaryExpression',
                                                        operator: '?',
                                                        argument: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'state',
                                                                loc: {
                                                                    start: {
                                                                        line: 25,
                                                                        column: 15,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Resizable.ion'
                                                                    },
                                                                    end: {
                                                                        line: 25,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Resizable.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'height',
                                                                loc: {
                                                                    start: {
                                                                        line: 25,
                                                                        column: 21,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Resizable.ion'
                                                                    },
                                                                    end: {
                                                                        line: 25,
                                                                        column: 27,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Resizable.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 25,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Resizable.ion'
                                                                },
                                                                end: {
                                                                    line: 25,
                                                                    column: 27,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Resizable.ion'
                                                                }
                                                            }
                                                        }
                                                    },
                                                    right: {
                                                        type: 'UnaryExpression',
                                                        operator: '?',
                                                        argument: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'state',
                                                                loc: {
                                                                    start: {
                                                                        line: 25,
                                                                        column: 32,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Resizable.ion'
                                                                    },
                                                                    end: {
                                                                        line: 25,
                                                                        column: 37,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Resizable.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'defaultHeight',
                                                                loc: {
                                                                    start: {
                                                                        line: 25,
                                                                        column: 38,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Resizable.ion'
                                                                    },
                                                                    end: {
                                                                        line: 25,
                                                                        column: 51,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Resizable.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 25,
                                                                    column: 32,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Resizable.ion'
                                                                },
                                                                end: {
                                                                    line: 25,
                                                                    column: 51,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Resizable.ion'
                                                                }
                                                            }
                                                        }
                                                    }
                                                },
                                                consequent: {
                                                    type: 'BlockStatement',
                                                    body: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'height',
                                                                loc: {
                                                                    start: {
                                                                        line: 26,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Resizable.ion'
                                                                    },
                                                                    end: {
                                                                        line: 26,
                                                                        column: 22,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Resizable.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'BinaryExpression',
                                                                operator: '+',
                                                                left: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '+',
                                                                    left: {
                                                                        type: 'Literal',
                                                                        value: ''
                                                                    },
                                                                    right: {
                                                                        type: 'ConditionalExpression',
                                                                        test: {
                                                                            type: 'BinaryExpression',
                                                                            operator: '!=',
                                                                            left: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'Identifier',
                                                                                    name: 'state',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 26,
                                                                                            column: 27,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Resizable.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 26,
                                                                                            column: 32,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Resizable.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'height',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 26,
                                                                                            column: 33,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Resizable.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 26,
                                                                                            column: 39,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Resizable.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 26,
                                                                                        column: 27,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Resizable.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 26,
                                                                                        column: 39,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Resizable.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            right: {
                                                                                type: 'Literal',
                                                                                value: null
                                                                            }
                                                                        },
                                                                        consequent: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'state',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 26,
                                                                                        column: 27,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Resizable.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 26,
                                                                                        column: 32,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Resizable.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'height',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 26,
                                                                                        column: 33,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Resizable.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 26,
                                                                                        column: 39,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Resizable.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 26,
                                                                                    column: 27,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Resizable.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 26,
                                                                                    column: 39,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Resizable.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        alternate: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'state',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 26,
                                                                                        column: 42,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Resizable.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 26,
                                                                                        column: 47,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Resizable.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'defaultHeight',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 26,
                                                                                        column: 48,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Resizable.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 26,
                                                                                        column: 61,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Resizable.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 26,
                                                                                    column: 42,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Resizable.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 26,
                                                                                    column: 61,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Resizable.ion'
                                                                                }
                                                                            }
                                                                        }
                                                                    }
                                                                },
                                                                right: {
                                                                    type: 'Literal',
                                                                    value: 'px'
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                },
                                                alternate: null,
                                                order: '1'
                                            },
                                            {
                                                type: 'IfStatement',
                                                test: {
                                                    type: 'UnaryExpression',
                                                    operator: '?',
                                                    argument: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'state',
                                                            loc: {
                                                                start: {
                                                                    line: 27,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Resizable.ion'
                                                                },
                                                                end: {
                                                                    line: 27,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Resizable.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'minWidth',
                                                            loc: {
                                                                start: {
                                                                    line: 27,
                                                                    column: 21,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Resizable.ion'
                                                                },
                                                                end: {
                                                                    line: 27,
                                                                    column: 29,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Resizable.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 27,
                                                                column: 15,
                                                                fixed: true,
                                                                source: 'glass/html/material/Resizable.ion'
                                                            },
                                                            end: {
                                                                line: 27,
                                                                column: 29,
                                                                fixed: true,
                                                                source: 'glass/html/material/Resizable.ion'
                                                            }
                                                        }
                                                    }
                                                },
                                                consequent: {
                                                    type: 'BlockStatement',
                                                    body: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'minWidth',
                                                                loc: {
                                                                    start: {
                                                                        line: 28,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Resizable.ion'
                                                                    },
                                                                    end: {
                                                                        line: 28,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Resizable.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'BinaryExpression',
                                                                operator: '+',
                                                                left: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '+',
                                                                    left: {
                                                                        type: 'Literal',
                                                                        value: ''
                                                                    },
                                                                    right: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'state',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 28,
                                                                                    column: 29,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Resizable.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 28,
                                                                                    column: 34,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Resizable.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'minWidth',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 28,
                                                                                    column: 35,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Resizable.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 28,
                                                                                    column: 43,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Resizable.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 28,
                                                                                column: 29,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Resizable.ion'
                                                                            },
                                                                            end: {
                                                                                line: 28,
                                                                                column: 43,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Resizable.ion'
                                                                            }
                                                                        }
                                                                    }
                                                                },
                                                                right: {
                                                                    type: 'Literal',
                                                                    value: 'px'
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                },
                                                alternate: null,
                                                order: '2'
                                            },
                                            {
                                                type: 'IfStatement',
                                                test: {
                                                    type: 'UnaryExpression',
                                                    operator: '?',
                                                    argument: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'state',
                                                            loc: {
                                                                start: {
                                                                    line: 29,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Resizable.ion'
                                                                },
                                                                end: {
                                                                    line: 29,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Resizable.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'minHeight',
                                                            loc: {
                                                                start: {
                                                                    line: 29,
                                                                    column: 21,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Resizable.ion'
                                                                },
                                                                end: {
                                                                    line: 29,
                                                                    column: 30,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Resizable.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 29,
                                                                column: 15,
                                                                fixed: true,
                                                                source: 'glass/html/material/Resizable.ion'
                                                            },
                                                            end: {
                                                                line: 29,
                                                                column: 30,
                                                                fixed: true,
                                                                source: 'glass/html/material/Resizable.ion'
                                                            }
                                                        }
                                                    }
                                                },
                                                consequent: {
                                                    type: 'BlockStatement',
                                                    body: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'minHeight',
                                                                loc: {
                                                                    start: {
                                                                        line: 30,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Resizable.ion'
                                                                    },
                                                                    end: {
                                                                        line: 30,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Resizable.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'BinaryExpression',
                                                                operator: '+',
                                                                left: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '+',
                                                                    left: {
                                                                        type: 'Literal',
                                                                        value: ''
                                                                    },
                                                                    right: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'state',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 30,
                                                                                    column: 30,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Resizable.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 30,
                                                                                    column: 35,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Resizable.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'minHeight',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 30,
                                                                                    column: 36,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Resizable.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 30,
                                                                                    column: 45,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Resizable.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 30,
                                                                                column: 30,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Resizable.ion'
                                                                            },
                                                                            end: {
                                                                                line: 30,
                                                                                column: 45,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Resizable.ion'
                                                                            }
                                                                        }
                                                                    }
                                                                },
                                                                right: {
                                                                    type: 'Literal',
                                                                    value: 'px'
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                },
                                                alternate: null,
                                                order: '3'
                                            },
                                            {
                                                type: 'IfStatement',
                                                test: {
                                                    type: 'UnaryExpression',
                                                    operator: '?',
                                                    argument: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'state',
                                                            loc: {
                                                                start: {
                                                                    line: 31,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Resizable.ion'
                                                                },
                                                                end: {
                                                                    line: 31,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Resizable.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'maxWidth',
                                                            loc: {
                                                                start: {
                                                                    line: 31,
                                                                    column: 21,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Resizable.ion'
                                                                },
                                                                end: {
                                                                    line: 31,
                                                                    column: 29,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Resizable.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 31,
                                                                column: 15,
                                                                fixed: true,
                                                                source: 'glass/html/material/Resizable.ion'
                                                            },
                                                            end: {
                                                                line: 31,
                                                                column: 29,
                                                                fixed: true,
                                                                source: 'glass/html/material/Resizable.ion'
                                                            }
                                                        }
                                                    }
                                                },
                                                consequent: {
                                                    type: 'BlockStatement',
                                                    body: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'maxWidth',
                                                                loc: {
                                                                    start: {
                                                                        line: 32,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Resizable.ion'
                                                                    },
                                                                    end: {
                                                                        line: 32,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Resizable.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'BinaryExpression',
                                                                operator: '+',
                                                                left: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '+',
                                                                    left: {
                                                                        type: 'Literal',
                                                                        value: ''
                                                                    },
                                                                    right: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'state',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 32,
                                                                                    column: 29,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Resizable.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 32,
                                                                                    column: 34,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Resizable.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'maxWidth',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 32,
                                                                                    column: 35,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Resizable.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 32,
                                                                                    column: 43,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Resizable.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 32,
                                                                                column: 29,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Resizable.ion'
                                                                            },
                                                                            end: {
                                                                                line: 32,
                                                                                column: 43,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Resizable.ion'
                                                                            }
                                                                        }
                                                                    }
                                                                },
                                                                right: {
                                                                    type: 'Literal',
                                                                    value: 'px'
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                },
                                                alternate: null,
                                                order: '4'
                                            },
                                            {
                                                type: 'IfStatement',
                                                test: {
                                                    type: 'UnaryExpression',
                                                    operator: '?',
                                                    argument: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'state',
                                                            loc: {
                                                                start: {
                                                                    line: 33,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Resizable.ion'
                                                                },
                                                                end: {
                                                                    line: 33,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Resizable.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'maxHeight',
                                                            loc: {
                                                                start: {
                                                                    line: 33,
                                                                    column: 21,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Resizable.ion'
                                                                },
                                                                end: {
                                                                    line: 33,
                                                                    column: 30,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Resizable.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 33,
                                                                column: 15,
                                                                fixed: true,
                                                                source: 'glass/html/material/Resizable.ion'
                                                            },
                                                            end: {
                                                                line: 33,
                                                                column: 30,
                                                                fixed: true,
                                                                source: 'glass/html/material/Resizable.ion'
                                                            }
                                                        }
                                                    }
                                                },
                                                consequent: {
                                                    type: 'BlockStatement',
                                                    body: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'maxHeight',
                                                                loc: {
                                                                    start: {
                                                                        line: 34,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Resizable.ion'
                                                                    },
                                                                    end: {
                                                                        line: 34,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Resizable.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'BinaryExpression',
                                                                operator: '+',
                                                                left: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '+',
                                                                    left: {
                                                                        type: 'Literal',
                                                                        value: ''
                                                                    },
                                                                    right: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'state',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 34,
                                                                                    column: 30,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Resizable.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 34,
                                                                                    column: 35,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Resizable.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'maxHeight',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 34,
                                                                                    column: 36,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Resizable.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 34,
                                                                                    column: 45,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Resizable.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 34,
                                                                                column: 30,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Resizable.ion'
                                                                            },
                                                                            end: {
                                                                                line: 34,
                                                                                column: 45,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Resizable.ion'
                                                                            }
                                                                        }
                                                                    }
                                                                },
                                                                right: {
                                                                    type: 'Literal',
                                                                    value: 'px'
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                },
                                                alternate: null,
                                                order: '5'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    order: '0'
                                }]
                        },
                        {
                            type: 'ObjectExpression',
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'width',
                                        loc: {
                                            start: {
                                                line: 35,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/Resizable.ion'
                                            },
                                            end: {
                                                line: 35,
                                                column: 22,
                                                fixed: true,
                                                source: 'glass/html/material/Resizable.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 36,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Resizable.ion'
                                                        },
                                                        end: {
                                                            line: 36,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Resizable.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context) {
                                                        return function () {
                                                            var state = _context.get('state');
                                                            return state.width != null ? state.width : state.defaultWidth;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 37,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Resizable.ion'
                                                        },
                                                        end: {
                                                            line: 37,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Resizable.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context2) {
                                                        return function (value) {
                                                            var state = _context2.get('state'), clamp = _context2.get('clamp');
                                                            return state.width = clamp(value, this.minWidth, this.maxWidth);
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'height',
                                        loc: {
                                            start: {
                                                line: 38,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/Resizable.ion'
                                            },
                                            end: {
                                                line: 38,
                                                column: 23,
                                                fixed: true,
                                                source: 'glass/html/material/Resizable.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 39,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Resizable.ion'
                                                        },
                                                        end: {
                                                            line: 39,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Resizable.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context3) {
                                                        return function () {
                                                            var state = _context3.get('state');
                                                            return state.height != null ? state.height : state.defaultHeight;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 40,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Resizable.ion'
                                                        },
                                                        end: {
                                                            line: 40,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Resizable.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context4) {
                                                        return function (value) {
                                                            var state = _context4.get('state'), clamp = _context4.get('clamp');
                                                            return state.height = clamp(value, this.minHeight, this.maxHeight);
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '1'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'defaultWidth',
                                        loc: {
                                            start: {
                                                line: 41,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/Resizable.ion'
                                            },
                                            end: {
                                                line: 41,
                                                column: 29,
                                                fixed: true,
                                                source: 'glass/html/material/Resizable.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 42,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Resizable.ion'
                                                        },
                                                        end: {
                                                            line: 42,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Resizable.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context5) {
                                                        return function () {
                                                            var state = _context5.get('state');
                                                            return state.defaultWidth;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 43,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Resizable.ion'
                                                        },
                                                        end: {
                                                            line: 43,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Resizable.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context6) {
                                                        return function (value) {
                                                            var state = _context6.get('state');
                                                            return state.defaultWidth = value;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '2'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'defaultHeight',
                                        loc: {
                                            start: {
                                                line: 44,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/Resizable.ion'
                                            },
                                            end: {
                                                line: 44,
                                                column: 30,
                                                fixed: true,
                                                source: 'glass/html/material/Resizable.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 45,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Resizable.ion'
                                                        },
                                                        end: {
                                                            line: 45,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Resizable.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context7) {
                                                        return function () {
                                                            var state = _context7.get('state');
                                                            return state.defaultHeight;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 46,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Resizable.ion'
                                                        },
                                                        end: {
                                                            line: 46,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Resizable.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context8) {
                                                        return function (value) {
                                                            var state = _context8.get('state');
                                                            return state.defaultHeight = value;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '3'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'minWidth',
                                        loc: {
                                            start: {
                                                line: 47,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/Resizable.ion'
                                            },
                                            end: {
                                                line: 47,
                                                column: 25,
                                                fixed: true,
                                                source: 'glass/html/material/Resizable.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 48,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Resizable.ion'
                                                        },
                                                        end: {
                                                            line: 48,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Resizable.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context9) {
                                                        return function () {
                                                            var state = _context9.get('state');
                                                            return state.minWidth;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 49,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Resizable.ion'
                                                        },
                                                        end: {
                                                            line: 49,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Resizable.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context10) {
                                                        return function (value) {
                                                            var state = _context10.get('state');
                                                            return state.minWidth = value;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '4'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'minHeight',
                                        loc: {
                                            start: {
                                                line: 50,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/Resizable.ion'
                                            },
                                            end: {
                                                line: 50,
                                                column: 26,
                                                fixed: true,
                                                source: 'glass/html/material/Resizable.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 51,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Resizable.ion'
                                                        },
                                                        end: {
                                                            line: 51,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Resizable.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context11) {
                                                        return function () {
                                                            var state = _context11.get('state');
                                                            return state.minHeight;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 52,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Resizable.ion'
                                                        },
                                                        end: {
                                                            line: 52,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Resizable.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context12) {
                                                        return function (value) {
                                                            var state = _context12.get('state');
                                                            return state.minHeight = value;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '5'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'maxWidth',
                                        loc: {
                                            start: {
                                                line: 53,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/Resizable.ion'
                                            },
                                            end: {
                                                line: 53,
                                                column: 25,
                                                fixed: true,
                                                source: 'glass/html/material/Resizable.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 54,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Resizable.ion'
                                                        },
                                                        end: {
                                                            line: 54,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Resizable.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context13) {
                                                        return function () {
                                                            var state = _context13.get('state');
                                                            return state.maxWidth;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 55,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Resizable.ion'
                                                        },
                                                        end: {
                                                            line: 55,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Resizable.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context14) {
                                                        return function (value) {
                                                            var state = _context14.get('state');
                                                            return state.maxWidth = value;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '6'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'maxHeight',
                                        loc: {
                                            start: {
                                                line: 56,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/Resizable.ion'
                                            },
                                            end: {
                                                line: 56,
                                                column: 26,
                                                fixed: true,
                                                source: 'glass/html/material/Resizable.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 57,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Resizable.ion'
                                                        },
                                                        end: {
                                                            line: 57,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Resizable.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context15) {
                                                        return function () {
                                                            var state = _context15.get('state');
                                                            return state.maxHeight;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 58,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Resizable.ion'
                                                        },
                                                        end: {
                                                            line: 58,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Resizable.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context16) {
                                                        return function (value) {
                                                            var state = _context16.get('state');
                                                            return state.maxHeight = value;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '7'
                                }
                            ]
                        }
                    ]
                },
                order: '1'
            }
        ],
        bound: false
    }, {
        this: this,
        attributes: attributes,
        _ref: _ref,
        clamp: clamp,
        style: style
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/Resizable',_glass_html_material_Resizable_);
    else
      _glass_html_material_Resizable_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_Resizable_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_Resizer_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('../DragHelper'), _ref2, clamp = function (value, min, max) {
        if (min != null && value < min) {
            return min;
        }
        if (max != null && value > max) {
            return max;
        }
        return value;
    };
var captureMouse = _ref.captureMouse;
_ref2 = require('../');
var style = _ref2.style;
ion.template(function () {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [{
                type: 'ExpressionStatement',
                expression: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'MemberExpression',
                        computed: false,
                        object: {
                            type: 'Identifier',
                            name: 'style',
                            loc: {
                                start: {
                                    line: 12,
                                    column: 4,
                                    fixed: true,
                                    source: 'glass/html/material/Resizer.ion'
                                },
                                end: {
                                    line: 12,
                                    column: 9,
                                    fixed: true,
                                    source: 'glass/html/material/Resizer.ion'
                                }
                            }
                        },
                        property: {
                            type: 'Identifier',
                            name: 'sheets',
                            loc: {
                                start: {
                                    line: 12,
                                    column: 10,
                                    fixed: true,
                                    source: 'glass/html/material/Resizer.ion'
                                },
                                end: {
                                    line: 12,
                                    column: 16,
                                    fixed: true,
                                    source: 'glass/html/material/Resizer.ion'
                                }
                            }
                        },
                        loc: {
                            start: {
                                line: 12,
                                column: 4,
                                fixed: true,
                                source: 'glass/html/material/Resizer.ion'
                            },
                            end: {
                                line: 12,
                                column: 16,
                                fixed: true,
                                source: 'glass/html/material/Resizer.ion'
                            }
                        }
                    },
                    properties: [{
                            type: 'Property',
                            key: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'module',
                                    loc: {
                                        start: {
                                            line: 13,
                                            column: 9,
                                            fixed: true,
                                            source: 'glass/html/material/Resizer.ion'
                                        },
                                        end: {
                                            line: 13,
                                            column: 15,
                                            fixed: true,
                                            source: 'glass/html/material/Resizer.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'id',
                                    loc: {
                                        start: {
                                            line: 13,
                                            column: 16,
                                            fixed: true,
                                            source: 'glass/html/material/Resizer.ion'
                                        },
                                        end: {
                                            line: 13,
                                            column: 18,
                                            fixed: true,
                                            source: 'glass/html/material/Resizer.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 13,
                                        column: 9,
                                        fixed: true,
                                        source: 'glass/html/material/Resizer.ion'
                                    },
                                    end: {
                                        line: 13,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/material/Resizer.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'BinaryExpression',
                                operator: '+',
                                left: {
                                    type: 'BinaryExpression',
                                    operator: '+',
                                    left: {
                                        type: 'Literal',
                                        value: '.Resizer-dragbox {\n    width: 100px;\n    height: 100px;\n    opacity: 0.2;\n    background: '
                                    },
                                    right: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'style',
                                                loc: {
                                                    start: {
                                                        line: 18,
                                                        column: 30,
                                                        fixed: true,
                                                        source: 'glass/html/material/Resizer.ion'
                                                    },
                                                    end: {
                                                        line: 18,
                                                        column: 35,
                                                        fixed: true,
                                                        source: 'glass/html/material/Resizer.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'color',
                                                loc: {
                                                    start: {
                                                        line: 18,
                                                        column: 36,
                                                        fixed: true,
                                                        source: 'glass/html/material/Resizer.ion'
                                                    },
                                                    end: {
                                                        line: 18,
                                                        column: 41,
                                                        fixed: true,
                                                        source: 'glass/html/material/Resizer.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 18,
                                                    column: 30,
                                                    fixed: true,
                                                    source: 'glass/html/material/Resizer.ion'
                                                },
                                                end: {
                                                    line: 18,
                                                    column: 41,
                                                    fixed: true,
                                                    source: 'glass/html/material/Resizer.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'accent',
                                            loc: {
                                                start: {
                                                    line: 18,
                                                    column: 42,
                                                    fixed: true,
                                                    source: 'glass/html/material/Resizer.ion'
                                                },
                                                end: {
                                                    line: 18,
                                                    column: 48,
                                                    fixed: true,
                                                    source: 'glass/html/material/Resizer.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 18,
                                                column: 30,
                                                fixed: true,
                                                source: 'glass/html/material/Resizer.ion'
                                            },
                                            end: {
                                                line: 18,
                                                column: 48,
                                                fixed: true,
                                                source: 'glass/html/material/Resizer.ion'
                                            }
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: ';\n    position: absolute;\n    background: blue;\n}'
                                }
                            },
                            kind: 'init',
                            computed: true,
                            order: '0'
                        }]
                },
                loc: {
                    start: {
                        line: 12,
                        column: 4,
                        fixed: true,
                        source: 'glass/html/material/Resizer.ion'
                    },
                    end: {
                        line: 23,
                        column: 8,
                        fixed: true,
                        source: 'glass/html/material/Resizer.ion'
                    }
                },
                order: '0'
            }],
        bound: false
    }, {
        this: this,
        module: module,
        _ref: _ref,
        _ref2: _ref2,
        clamp: clamp,
        captureMouse: captureMouse,
        style: style
    }, null);
})().observe();
module.exports = exports = ion.template(function Resizer(_ref3) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'Resizer',
            loc: {
                start: {
                    line: 23,
                    column: 16,
                    fixed: true,
                    source: 'glass/html/material/Resizer.ion'
                },
                end: {
                    line: 23,
                    column: 23,
                    fixed: true,
                    source: 'glass/html/material/Resizer.ion'
                }
            }
        },
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'element',
                            loc: {
                                start: {
                                    line: 23,
                                    column: 25,
                                    fixed: true,
                                    source: 'glass/html/material/Resizer.ion'
                                },
                                end: {
                                    line: 23,
                                    column: 32,
                                    fixed: true,
                                    source: 'glass/html/material/Resizer.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'element',
                                loc: {
                                    start: {
                                        line: 23,
                                        column: 25,
                                        fixed: true,
                                        source: 'glass/html/material/Resizer.ion'
                                    },
                                    end: {
                                        line: 23,
                                        column: 32,
                                        fixed: true,
                                        source: 'glass/html/material/Resizer.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'horizontal',
                            loc: {
                                start: {
                                    line: 23,
                                    column: 33,
                                    fixed: true,
                                    source: 'glass/html/material/Resizer.ion'
                                },
                                end: {
                                    line: 23,
                                    column: 43,
                                    fixed: true,
                                    source: 'glass/html/material/Resizer.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'horizontal',
                                loc: {
                                    start: {
                                        line: 23,
                                        column: 33,
                                        fixed: true,
                                        source: 'glass/html/material/Resizer.ion'
                                    },
                                    end: {
                                        line: 23,
                                        column: 43,
                                        fixed: true,
                                        source: 'glass/html/material/Resizer.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'vertical',
                            loc: {
                                start: {
                                    line: 23,
                                    column: 44,
                                    fixed: true,
                                    source: 'glass/html/material/Resizer.ion'
                                },
                                end: {
                                    line: 23,
                                    column: 52,
                                    fixed: true,
                                    source: 'glass/html/material/Resizer.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'vertical',
                                loc: {
                                    start: {
                                        line: 23,
                                        column: 44,
                                        fixed: true,
                                        source: 'glass/html/material/Resizer.ion'
                                    },
                                    end: {
                                        line: 23,
                                        column: 52,
                                        fixed: true,
                                        source: 'glass/html/material/Resizer.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'minWidth',
                            loc: {
                                start: {
                                    line: 23,
                                    column: 53,
                                    fixed: true,
                                    source: 'glass/html/material/Resizer.ion'
                                },
                                end: {
                                    line: 23,
                                    column: 61,
                                    fixed: true,
                                    source: 'glass/html/material/Resizer.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'minWidth',
                                loc: {
                                    start: {
                                        line: 23,
                                        column: 53,
                                        fixed: true,
                                        source: 'glass/html/material/Resizer.ion'
                                    },
                                    end: {
                                        line: 23,
                                        column: 61,
                                        fixed: true,
                                        source: 'glass/html/material/Resizer.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '3'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'minHeight',
                            loc: {
                                start: {
                                    line: 23,
                                    column: 62,
                                    fixed: true,
                                    source: 'glass/html/material/Resizer.ion'
                                },
                                end: {
                                    line: 23,
                                    column: 71,
                                    fixed: true,
                                    source: 'glass/html/material/Resizer.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'minHeight',
                                loc: {
                                    start: {
                                        line: 23,
                                        column: 62,
                                        fixed: true,
                                        source: 'glass/html/material/Resizer.ion'
                                    },
                                    end: {
                                        line: 23,
                                        column: 71,
                                        fixed: true,
                                        source: 'glass/html/material/Resizer.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '4'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'state',
                            loc: {
                                start: {
                                    line: 24,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/Resizer.ion'
                                },
                                end: {
                                    line: 24,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/html/material/Resizer.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            properties: [{
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'resizing',
                                        loc: {
                                            start: {
                                                line: 24,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/Resizer.ion'
                                            },
                                            end: {
                                                line: 24,
                                                column: 25,
                                                fixed: true,
                                                source: 'glass/html/material/Resizer.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: false
                                    },
                                    kind: 'init',
                                    order: '0'
                                }]
                        }
                    }],
                kind: 'let',
                order: '5'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'cursor',
                            loc: {
                                start: {
                                    line: 25,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/Resizer.ion'
                                },
                                end: {
                                    line: 25,
                                    column: 14,
                                    fixed: true,
                                    source: 'glass/html/material/Resizer.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Function',
                                context: true,
                                value: function (_context) {
                                    return function () {
                                        var horizontal = _context.get('horizontal'), vertical = _context.get('vertical');
                                        if (horizontal && vertical) {
                                            return 'nwse-resize';
                                        }
                                        if (horizontal) {
                                            return 'ew-resize';
                                        } else if (vertical) {
                                            return 'ns-resize';
                                        }
                                    };
                                }
                            },
                            arguments: [],
                            loc: {
                                start: {
                                    line: 25,
                                    column: 17,
                                    fixed: true,
                                    source: 'glass/html/material/Resizer.ion'
                                },
                                end: {
                                    line: 32,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/Resizer.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '6'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'CallExpression',
                    callee: {
                        type: 'MemberExpression',
                        object: {
                            type: 'Identifier',
                            name: 'Object'
                        },
                        property: {
                            type: 'Identifier',
                            name: 'defineProperties'
                        }
                    },
                    arguments: [
                        {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Div',
                                    loc: {
                                        start: {
                                            line: 32,
                                            column: 11,
                                            fixed: true,
                                            source: 'glass/html/material/Resizer.ion'
                                        },
                                        end: {
                                            line: 32,
                                            column: 14,
                                            fixed: true,
                                            source: 'glass/html/material/Resizer.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'class',
                                                    loc: {
                                                        start: {
                                                            line: 32,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/Resizer.ion'
                                                        },
                                                        end: {
                                                            line: 32,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'glass/html/material/Resizer.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: 'Resizer'
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    }],
                                loc: {
                                    start: {
                                        line: 32,
                                        column: 11,
                                        fixed: true,
                                        source: 'glass/html/material/Resizer.ion'
                                    },
                                    end: {
                                        line: 32,
                                        column: 33,
                                        fixed: true,
                                        source: 'glass/html/material/Resizer.ion'
                                    }
                                }
                            },
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'style',
                                        loc: {
                                            start: {
                                                line: 33,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Resizer.ion'
                                            },
                                            end: {
                                                line: 33,
                                                column: 13,
                                                fixed: true,
                                                source: 'glass/html/material/Resizer.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'cursor',
                                                    loc: {
                                                        start: {
                                                            line: 34,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Resizer.ion'
                                                        },
                                                        end: {
                                                            line: 34,
                                                            column: 18,
                                                            fixed: true,
                                                            source: 'glass/html/material/Resizer.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Identifier',
                                                    name: 'cursor',
                                                    loc: {
                                                        start: {
                                                            line: 34,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'glass/html/material/Resizer.ion'
                                                        },
                                                        end: {
                                                            line: 34,
                                                            column: 26,
                                                            fixed: true,
                                                            source: 'glass/html/material/Resizer.ion'
                                                        }
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    },
                                    kind: 'init',
                                    order: '0'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context2) {
                                            return function mousedown(e) {
                                                var state = _context2.get('state'), element = _context2.get('element'), ion = _context2.get('ion'), cursor = _context2.get('cursor'), horizontal = _context2.get('horizontal'), vertical = _context2.get('vertical'), minWidth = _context2.get('minWidth'), minHeight = _context2.get('minHeight'), captureMouse = _context2.get('captureMouse');
                                                state.resizing = true;
                                                var startX = e.pageX;
                                                var startY = e.pageY;
                                                var startElementBounds = null;
                                                var dragbox;
                                                if (element != null) {
                                                    dragbox = ion.patch.combine(Div({ class: 'Resizer-dragbox' }), { style: { cursor: cursor } });
                                                    document.body.appendChild(dragbox);
                                                    startElementBounds = element.getBoundingClientRect();
                                                }
                                                this.dispatchEvent(new CustomEvent('resizestart', { detail: true }));
                                                var updateDragboxAndGetDetail = ion.bind(function (e) {
                                                        var x = e.pageX;
                                                        var y = e.pageY;
                                                        var dx = horizontal ? x - startX : 0;
                                                        var dy = vertical ? y - startY : 0;
                                                        if (startElementBounds != null) {
                                                            if (startElementBounds.width + dx < minWidth) {
                                                                dx = minWidth - startElementBounds.width;
                                                            }
                                                            if (startElementBounds.height + dy < minHeight) {
                                                                dy = minHeight - startElementBounds.height;
                                                            }
                                                        }
                                                        if (dragbox) {
                                                            dragbox.style.left = startElementBounds.left + 'px';
                                                            dragbox.style.top = startElementBounds.top + 'px';
                                                            dragbox.style.width = startElementBounds.width + dx + 'px';
                                                            dragbox.style.height = startElementBounds.height + dy + 'px';
                                                        }
                                                        return {
                                                            dx: dx,
                                                            dy: dy
                                                        };
                                                    }, this);
                                                updateDragboxAndGetDetail(e);
                                                var mousemove = ion.bind(function (e) {
                                                        this.dispatchEvent(new CustomEvent('resize', { detail: updateDragboxAndGetDetail(e) }));
                                                    }, this);
                                                var mouseup = ion.bind(function (e) {
                                                        state.resizing = false;
                                                        document.body.removeChild(dragbox);
                                                        this.dispatchEvent(new CustomEvent('resizestop', { detail: updateDragboxAndGetDetail(e) }));
                                                    }, this);
                                                captureMouse(e, {
                                                    mousemove: mousemove,
                                                    mouseup: mouseup
                                                });
                                                e.stopPropagation();
                                            };
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 37,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/Resizer.ion'
                                        },
                                        end: {
                                            line: 80,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/material/Resizer.ion'
                                        }
                                    },
                                    order: '1'
                                }
                            ]
                        },
                        {
                            type: 'ObjectExpression',
                            properties: [{
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'resizing',
                                        loc: {
                                            start: {
                                                line: 35,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/Resizer.ion'
                                            },
                                            end: {
                                                line: 35,
                                                column: 25,
                                                fixed: true,
                                                source: 'glass/html/material/Resizer.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 36,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Resizer.ion'
                                                        },
                                                        end: {
                                                            line: 36,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Resizer.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context3) {
                                                        return function () {
                                                            var state = _context3.get('state');
                                                            return state.resizing;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '0'
                                }]
                        }
                    ]
                },
                order: '7'
            }
        ],
        bound: false
    }, {
        this: this,
        ion: ion,
        _ref3: _ref3,
        _ref: _ref,
        _ref2: _ref2,
        clamp: clamp,
        captureMouse: captureMouse,
        style: style
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/Resizer',_glass_html_material_Resizer_);
    else
      _glass_html_material_Resizer_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_Resizer_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_SearchButton_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('./'), _ref2;
var Icon = _ref.Icon;
var AutoCompleteInput = _ref.AutoCompleteInput;
_ref2 = require('../');
var style = _ref2.style;
var _ref4 = style.custom;
_ref4[module.id] = '.SearchButton paper-input {\n    --paper-input-container-color: rgba(255, 255, 255, 0.77);\n    --paper-input-container-focus-color: rgba(255, 255, 255, 0.77);\n    --paper-input-container-input-color: rgba(255, 255, 255, 0.77);\n    margin-left: -4px;\n}';
_ref4;
module.exports = exports = ion.template(function SearchButton(attributes, _ref3) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'SearchButton',
            loc: {
                start: {
                    line: 15,
                    column: 16,
                    fixed: true,
                    source: 'glass/html/material/SearchButton.ion'
                },
                end: {
                    line: 15,
                    column: 28,
                    fixed: true,
                    source: 'glass/html/material/SearchButton.ion'
                }
            }
        },
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'suggestionTemplate',
                            loc: {
                                start: {
                                    line: 15,
                                    column: 42,
                                    fixed: true,
                                    source: 'glass/html/material/SearchButton.ion'
                                },
                                end: {
                                    line: 15,
                                    column: 60,
                                    fixed: true,
                                    source: 'glass/html/material/SearchButton.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'suggestionTemplate',
                                loc: {
                                    start: {
                                        line: 15,
                                        column: 42,
                                        fixed: true,
                                        source: 'glass/html/material/SearchButton.ion'
                                    },
                                    end: {
                                        line: 15,
                                        column: 60,
                                        fixed: true,
                                        source: 'glass/html/material/SearchButton.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'state',
                            loc: {
                                start: {
                                    line: 16,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/SearchButton.ion'
                                },
                                end: {
                                    line: 16,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/html/material/SearchButton.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Function',
                                context: false,
                                value: function () {
                                    return { open: false };
                                }
                            },
                            arguments: [],
                            loc: {
                                start: {
                                    line: 16,
                                    column: 16,
                                    fixed: true,
                                    source: 'glass/html/material/SearchButton.ion'
                                },
                                end: {
                                    line: 16,
                                    column: 34,
                                    fixed: true,
                                    source: 'glass/html/material/SearchButton.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'search',
                            loc: {
                                start: {
                                    line: 17,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/SearchButton.ion'
                                },
                                end: {
                                    line: 17,
                                    column: 14,
                                    fixed: true,
                                    source: 'glass/html/material/SearchButton.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Div',
                                loc: {
                                    start: {
                                        line: 17,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/html/material/SearchButton.ion'
                                    },
                                    end: {
                                        line: 17,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/SearchButton.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'Identifier',
                                    name: 'attributes',
                                    loc: {
                                        start: {
                                            line: 17,
                                            column: 21,
                                            fixed: true,
                                            source: 'glass/html/material/SearchButton.ion'
                                        },
                                        end: {
                                            line: 17,
                                            column: 31,
                                            fixed: true,
                                            source: 'glass/html/material/SearchButton.ion'
                                        }
                                    }
                                }],
                            loc: {
                                start: {
                                    line: 17,
                                    column: 17,
                                    fixed: true,
                                    source: 'glass/html/material/SearchButton.ion'
                                },
                                end: {
                                    line: 17,
                                    column: 32,
                                    fixed: true,
                                    source: 'glass/html/material/SearchButton.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'CallExpression',
                    callee: {
                        type: 'MemberExpression',
                        object: {
                            type: 'Identifier',
                            name: 'Object'
                        },
                        property: {
                            type: 'Identifier',
                            name: 'defineProperties'
                        }
                    },
                    arguments: [
                        {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'Identifier',
                                name: 'search',
                                loc: {
                                    start: {
                                        line: 18,
                                        column: 11,
                                        fixed: true,
                                        source: 'glass/html/material/SearchButton.ion'
                                    },
                                    end: {
                                        line: 18,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/html/material/SearchButton.ion'
                                    }
                                }
                            },
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'classList',
                                        loc: {
                                            start: {
                                                line: 19,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/SearchButton.ion'
                                            },
                                            end: {
                                                line: 19,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/SearchButton.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'Literal',
                                                    value: 'SearchButton'
                                                },
                                                loc: {
                                                    start: {
                                                        line: 20,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/SearchButton.ion'
                                                    },
                                                    end: {
                                                        line: 20,
                                                        column: 26,
                                                        fixed: true,
                                                        source: 'glass/html/material/SearchButton.ion'
                                                    }
                                                },
                                                order: '0'
                                            },
                                            {
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'Literal',
                                                    value: 'layout'
                                                },
                                                loc: {
                                                    start: {
                                                        line: 21,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/SearchButton.ion'
                                                    },
                                                    end: {
                                                        line: 21,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'glass/html/material/SearchButton.ion'
                                                    }
                                                },
                                                order: '1'
                                            },
                                            {
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'Literal',
                                                    value: 'horizontal'
                                                },
                                                loc: {
                                                    start: {
                                                        line: 22,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/SearchButton.ion'
                                                    },
                                                    end: {
                                                        line: 22,
                                                        column: 24,
                                                        fixed: true,
                                                        source: 'glass/html/material/SearchButton.ion'
                                                    }
                                                },
                                                order: '2'
                                            },
                                            {
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'Literal',
                                                    value: 'center'
                                                },
                                                loc: {
                                                    start: {
                                                        line: 23,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/SearchButton.ion'
                                                    },
                                                    end: {
                                                        line: 23,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'glass/html/material/SearchButton.ion'
                                                    }
                                                },
                                                order: '3'
                                            },
                                            {
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'Literal',
                                                    value: 'center-justified'
                                                },
                                                loc: {
                                                    start: {
                                                        line: 24,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/SearchButton.ion'
                                                    },
                                                    end: {
                                                        line: 24,
                                                        column: 30,
                                                        fixed: true,
                                                        source: 'glass/html/material/SearchButton.ion'
                                                    }
                                                },
                                                order: '4'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    order: '0'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'ObjectExpression',
                                        objectType: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'Identifier',
                                                name: 'PaperIconButton',
                                                loc: {
                                                    start: {
                                                        line: 25,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'glass/html/material/SearchButton.ion'
                                                    },
                                                    end: {
                                                        line: 25,
                                                        column: 23,
                                                        fixed: true,
                                                        source: 'glass/html/material/SearchButton.ion'
                                                    }
                                                }
                                            },
                                            arguments: [],
                                            loc: {
                                                start: {
                                                    line: 25,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'glass/html/material/SearchButton.ion'
                                                },
                                                end: {
                                                    line: 25,
                                                    column: 25,
                                                    fixed: true,
                                                    source: 'glass/html/material/SearchButton.ion'
                                                }
                                            }
                                        },
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'icon',
                                                    loc: {
                                                        start: {
                                                            line: 26,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/SearchButton.ion'
                                                        },
                                                        end: {
                                                            line: 26,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/SearchButton.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: 'search'
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context) {
                                                        return function click(e) {
                                                            var state = _context.get('state'), input = _context.get('input');
                                                            state.open = !state.open;
                                                            input.focus();
                                                            input.select();
                                                        };
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 27,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/SearchButton.ion'
                                                    },
                                                    end: {
                                                        line: 31,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'glass/html/material/SearchButton.ion'
                                                    }
                                                },
                                                order: '1'
                                            }
                                        ]
                                    },
                                    loc: {
                                        start: {
                                            line: 25,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/SearchButton.ion'
                                        },
                                        end: {
                                            line: 31,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/material/SearchButton.ion'
                                        }
                                    },
                                    order: '1'
                                },
                                {
                                    type: 'VariableDeclaration',
                                    declarations: [{
                                            type: 'VariableDeclarator',
                                            id: {
                                                type: 'Identifier',
                                                name: 'input',
                                                loc: {
                                                    start: {
                                                        line: 34,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/SearchButton.ion'
                                                    },
                                                    end: {
                                                        line: 34,
                                                        column: 17,
                                                        fixed: true,
                                                        source: 'glass/html/material/SearchButton.ion'
                                                    }
                                                }
                                            },
                                            init: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'AutoCompleteInput',
                                                    loc: {
                                                        start: {
                                                            line: 34,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'glass/html/material/SearchButton.ion'
                                                        },
                                                        end: {
                                                            line: 34,
                                                            column: 37,
                                                            fixed: true,
                                                            source: 'glass/html/material/SearchButton.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [{
                                                        type: 'ObjectExpression',
                                                        properties: [
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'suggestionTemplate',
                                                                    loc: {
                                                                        start: {
                                                                            line: 34,
                                                                            column: 39,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/SearchButton.ion'
                                                                        },
                                                                        end: {
                                                                            line: 34,
                                                                            column: 57,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/SearchButton.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Identifier',
                                                                    name: 'suggestionTemplate',
                                                                    loc: {
                                                                        start: {
                                                                            line: 34,
                                                                            column: 39,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/SearchButton.ion'
                                                                        },
                                                                        end: {
                                                                            line: 34,
                                                                            column: 57,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/SearchButton.ion'
                                                                        }
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'inline',
                                                                    loc: {
                                                                        start: {
                                                                            line: 34,
                                                                            column: 59,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/SearchButton.ion'
                                                                        },
                                                                        end: {
                                                                            line: 34,
                                                                            column: 65,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/SearchButton.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: false
                                                                },
                                                                kind: 'init',
                                                                order: '1'
                                                            }
                                                        ]
                                                    }],
                                                loc: {
                                                    start: {
                                                        line: 34,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'glass/html/material/SearchButton.ion'
                                                    },
                                                    end: {
                                                        line: 34,
                                                        column: 73,
                                                        fixed: true,
                                                        source: 'glass/html/material/SearchButton.ion'
                                                    }
                                                }
                                            }
                                        }],
                                    kind: 'let',
                                    order: '2'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'input',
                                        loc: {
                                            start: {
                                                line: 35,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/SearchButton.ion'
                                            },
                                            end: {
                                                line: 35,
                                                column: 13,
                                                fixed: true,
                                                source: 'glass/html/material/SearchButton.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Identifier',
                                        name: 'input',
                                        loc: {
                                            start: {
                                                line: 35,
                                                column: 15,
                                                fixed: true,
                                                source: 'glass/html/material/SearchButton.ion'
                                            },
                                            end: {
                                                line: 35,
                                                column: 20,
                                                fixed: true,
                                                source: 'glass/html/material/SearchButton.ion'
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '3'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'ObjectExpression',
                                        objectType: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'input',
                                                loc: {
                                                    start: {
                                                        line: 36,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'glass/html/material/SearchButton.ion'
                                                    },
                                                    end: {
                                                        line: 36,
                                                        column: 13,
                                                        fixed: true,
                                                        source: 'glass/html/material/SearchButton.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'input',
                                                loc: {
                                                    start: {
                                                        line: 36,
                                                        column: 14,
                                                        fixed: true,
                                                        source: 'glass/html/material/SearchButton.ion'
                                                    },
                                                    end: {
                                                        line: 36,
                                                        column: 19,
                                                        fixed: true,
                                                        source: 'glass/html/material/SearchButton.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 36,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'glass/html/material/SearchButton.ion'
                                                },
                                                end: {
                                                    line: 36,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'glass/html/material/SearchButton.ion'
                                                }
                                            }
                                        },
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'classList',
                                                    loc: {
                                                        start: {
                                                            line: 37,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/SearchButton.ion'
                                                        },
                                                        end: {
                                                            line: 37,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'glass/html/material/SearchButton.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'ObjectExpression',
                                                    properties: [{
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'Literal',
                                                                value: 'transition'
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 38,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/SearchButton.ion'
                                                                },
                                                                end: {
                                                                    line: 38,
                                                                    column: 28,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/SearchButton.ion'
                                                                }
                                                            },
                                                            order: '0'
                                                        }]
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'style',
                                                    loc: {
                                                        start: {
                                                            line: 39,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/SearchButton.ion'
                                                        },
                                                        end: {
                                                            line: 39,
                                                            column: 17,
                                                            fixed: true,
                                                            source: 'glass/html/material/SearchButton.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'ObjectExpression',
                                                    properties: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'width',
                                                                loc: {
                                                                    start: {
                                                                        line: 40,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/SearchButton.ion'
                                                                    },
                                                                    end: {
                                                                        line: 40,
                                                                        column: 21,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/SearchButton.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'BinaryExpression',
                                                                operator: '+',
                                                                left: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '+',
                                                                    left: {
                                                                        type: 'Literal',
                                                                        value: ''
                                                                    },
                                                                    right: {
                                                                        type: 'ConditionalExpression',
                                                                        test: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'state',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 40,
                                                                                        column: 26,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/SearchButton.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 40,
                                                                                        column: 31,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/SearchButton.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'open',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 40,
                                                                                        column: 32,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/SearchButton.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 40,
                                                                                        column: 36,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/SearchButton.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 40,
                                                                                    column: 26,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/SearchButton.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 40,
                                                                                    column: 36,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/SearchButton.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        consequent: {
                                                                            type: 'Literal',
                                                                            value: 220
                                                                        },
                                                                        alternate: {
                                                                            type: 'Literal',
                                                                            value: 0
                                                                        }
                                                                    }
                                                                },
                                                                right: {
                                                                    type: 'Literal',
                                                                    value: 'px'
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                },
                                                kind: 'init',
                                                order: '1'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'noLabelFloat',
                                                    loc: {
                                                        start: {
                                                            line: 41,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/SearchButton.ion'
                                                        },
                                                        end: {
                                                            line: 41,
                                                            column: 24,
                                                            fixed: true,
                                                            source: 'glass/html/material/SearchButton.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: true
                                                },
                                                kind: 'init',
                                                order: '2'
                                            },
                                            {
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'ObjectExpression',
                                                    objectType: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'Identifier',
                                                            name: 'IronIcon',
                                                            loc: {
                                                                start: {
                                                                    line: 42,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/SearchButton.ion'
                                                                },
                                                                end: {
                                                                    line: 42,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/SearchButton.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [{
                                                                type: 'ObjectExpression',
                                                                properties: [{
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'suffix',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 42,
                                                                                    column: 22,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/SearchButton.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 42,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/SearchButton.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Literal',
                                                                            value: true
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    }]
                                                            }],
                                                        loc: {
                                                            start: {
                                                                line: 42,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'glass/html/material/SearchButton.ion'
                                                            },
                                                            end: {
                                                                line: 42,
                                                                column: 35,
                                                                fixed: true,
                                                                source: 'glass/html/material/SearchButton.ion'
                                                            }
                                                        }
                                                    },
                                                    properties: [
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'icon',
                                                                loc: {
                                                                    start: {
                                                                        line: 43,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/SearchButton.ion'
                                                                    },
                                                                    end: {
                                                                        line: 43,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/SearchButton.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Literal',
                                                                value: 'close'
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        },
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'classList',
                                                                loc: {
                                                                    start: {
                                                                        line: 44,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/SearchButton.ion'
                                                                    },
                                                                    end: {
                                                                        line: 44,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/SearchButton.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'ObjectExpression',
                                                                properties: [{
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'Literal',
                                                                            value: 'transition'
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 45,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/SearchButton.ion'
                                                                            },
                                                                            end: {
                                                                                line: 45,
                                                                                column: 32,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/SearchButton.ion'
                                                                            }
                                                                        },
                                                                        order: '0'
                                                                    }]
                                                            },
                                                            kind: 'init',
                                                            order: '1'
                                                        },
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'style',
                                                                loc: {
                                                                    start: {
                                                                        line: 46,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/SearchButton.ion'
                                                                    },
                                                                    end: {
                                                                        line: 46,
                                                                        column: 21,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/SearchButton.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'ObjectExpression',
                                                                properties: [
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'opacity',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 47,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/SearchButton.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 47,
                                                                                    column: 27,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/SearchButton.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'ConditionalExpression',
                                                                            test: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'Identifier',
                                                                                    name: 'state',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 47,
                                                                                            column: 29,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/SearchButton.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 47,
                                                                                            column: 34,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/SearchButton.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'open',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 47,
                                                                                            column: 35,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/SearchButton.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 47,
                                                                                            column: 39,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/SearchButton.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 47,
                                                                                        column: 29,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/SearchButton.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 47,
                                                                                        column: 39,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/SearchButton.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            consequent: {
                                                                                type: 'Literal',
                                                                                value: 1
                                                                            },
                                                                            alternate: {
                                                                                type: 'Literal',
                                                                                value: 0
                                                                            }
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    },
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'marginRight',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 48,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/SearchButton.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 48,
                                                                                    column: 31,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/SearchButton.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Literal',
                                                                            value: '-4px'
                                                                        },
                                                                        kind: 'init',
                                                                        order: '1'
                                                                    }
                                                                ]
                                                            },
                                                            kind: 'init',
                                                            order: '2'
                                                        },
                                                        {
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'Function',
                                                                context: true,
                                                                value: function (_context2) {
                                                                    return function click(e) {
                                                                        var state = _context2.get('state');
                                                                        state.open = false;
                                                                    };
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 49,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/SearchButton.ion'
                                                                },
                                                                end: {
                                                                    line: 51,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/SearchButton.ion'
                                                                }
                                                            },
                                                            order: '3'
                                                        }
                                                    ]
                                                },
                                                loc: {
                                                    start: {
                                                        line: 42,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/SearchButton.ion'
                                                    },
                                                    end: {
                                                        line: 51,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'glass/html/material/SearchButton.ion'
                                                    }
                                                },
                                                order: '3'
                                            }
                                        ]
                                    },
                                    loc: {
                                        start: {
                                            line: 36,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/SearchButton.ion'
                                        },
                                        end: {
                                            line: 51,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/material/SearchButton.ion'
                                        }
                                    },
                                    order: '4'
                                }
                            ]
                        },
                        {
                            type: 'ObjectExpression',
                            properties: [{
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'open',
                                        loc: {
                                            start: {
                                                line: 31,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/SearchButton.ion'
                                            },
                                            end: {
                                                line: 31,
                                                column: 21,
                                                fixed: true,
                                                source: 'glass/html/material/SearchButton.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 32,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/SearchButton.ion'
                                                        },
                                                        end: {
                                                            line: 32,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/SearchButton.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context3) {
                                                        return function () {
                                                            var state = _context3.get('state');
                                                            return state.open;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 33,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/SearchButton.ion'
                                                        },
                                                        end: {
                                                            line: 33,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/SearchButton.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context4) {
                                                        return function (value) {
                                                            var state = _context4.get('state');
                                                            return state.open = value;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '0'
                                }]
                        }
                    ]
                },
                order: '3'
            }
        ],
        bound: false
    }, {
        this: this,
        attributes: attributes,
        _ref3: _ref3,
        _ref: _ref,
        _ref2: _ref2,
        Icon: Icon,
        AutoCompleteInput: AutoCompleteInput,
        style: style,
        _ref4: _ref4
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/SearchButton',_glass_html_material_SearchButton_);
    else
      _glass_html_material_SearchButton_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_SearchButton_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_Select_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('../material'), _ref2;
var SuggestMenu = _ref.SuggestMenu;
_ref2 = require('../../language');
var getMatch = _ref2.getMatch;
module.exports = exports = ion.template(function (_ref3) {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'options',
                            loc: {
                                start: {
                                    line: 5,
                                    column: 18,
                                    fixed: true,
                                    source: 'glass/html/material/Select.ion'
                                },
                                end: {
                                    line: 5,
                                    column: 25,
                                    fixed: true,
                                    source: 'glass/html/material/Select.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'options',
                                loc: {
                                    start: {
                                        line: 5,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/material/Select.ion'
                                    },
                                    end: {
                                        line: 5,
                                        column: 25,
                                        fixed: true,
                                        source: 'glass/html/material/Select.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'required',
                            loc: {
                                start: {
                                    line: 5,
                                    column: 27,
                                    fixed: true,
                                    source: 'glass/html/material/Select.ion'
                                },
                                end: {
                                    line: 5,
                                    column: 35,
                                    fixed: true,
                                    source: 'glass/html/material/Select.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'required',
                                loc: {
                                    start: {
                                        line: 5,
                                        column: 27,
                                        fixed: true,
                                        source: 'glass/html/material/Select.ion'
                                    },
                                    end: {
                                        line: 5,
                                        column: 35,
                                        fixed: true,
                                        source: 'glass/html/material/Select.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'indexToValue',
                            loc: {
                                start: {
                                    line: 6,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/Select.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 20,
                                    fixed: true,
                                    source: 'glass/html/material/Select.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'ObjectExpression',
                                properties: []
                            },
                            properties: [{
                                    type: 'ForOfStatement',
                                    left: {
                                        type: 'VariableDeclaration',
                                        declarations: [
                                            {
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'option',
                                                    loc: {
                                                        start: {
                                                            line: 7,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Select.ion'
                                                        },
                                                        end: {
                                                            line: 7,
                                                            column: 18,
                                                            fixed: true,
                                                            source: 'glass/html/material/Select.ion'
                                                        }
                                                    }
                                                },
                                                init: null
                                            },
                                            {
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'index',
                                                    loc: {
                                                        start: {
                                                            line: 7,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'glass/html/material/Select.ion'
                                                        },
                                                        end: {
                                                            line: 7,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'glass/html/material/Select.ion'
                                                        }
                                                    }
                                                },
                                                init: null
                                            }
                                        ],
                                        kind: 'let'
                                    },
                                    right: {
                                        type: 'Identifier',
                                        name: 'options',
                                        loc: {
                                            start: {
                                                line: 7,
                                                column: 29,
                                                fixed: true,
                                                source: 'glass/html/material/Select.ion'
                                            },
                                            end: {
                                                line: 7,
                                                column: 36,
                                                fixed: true,
                                                source: 'glass/html/material/Select.ion'
                                            }
                                        }
                                    },
                                    body: {
                                        type: 'BlockStatement',
                                        body: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'index',
                                                    loc: {
                                                        start: {
                                                            line: 8,
                                                            column: 13,
                                                            fixed: true,
                                                            source: 'glass/html/material/Select.ion'
                                                        },
                                                        end: {
                                                            line: 8,
                                                            column: 18,
                                                            fixed: true,
                                                            source: 'glass/html/material/Select.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'ConditionalExpression',
                                                    test: {
                                                        type: 'BinaryExpression',
                                                        operator: '!=',
                                                        left: {
                                                            type: 'ConditionalExpression',
                                                            test: {
                                                                type: 'BinaryExpression',
                                                                operator: '!=',
                                                                left: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'option',
                                                                        loc: {
                                                                            start: {
                                                                                line: 8,
                                                                                column: 21,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Select.ion'
                                                                            },
                                                                            end: {
                                                                                line: 8,
                                                                                column: 27,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Select.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'value',
                                                                        loc: {
                                                                            start: {
                                                                                line: 8,
                                                                                column: 28,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Select.ion'
                                                                            },
                                                                            end: {
                                                                                line: 8,
                                                                                column: 33,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Select.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 8,
                                                                            column: 21,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Select.ion'
                                                                        },
                                                                        end: {
                                                                            line: 8,
                                                                            column: 33,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Select.ion'
                                                                        }
                                                                    }
                                                                },
                                                                right: {
                                                                    type: 'Literal',
                                                                    value: null
                                                                }
                                                            },
                                                            consequent: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'option',
                                                                    loc: {
                                                                        start: {
                                                                            line: 8,
                                                                            column: 21,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Select.ion'
                                                                        },
                                                                        end: {
                                                                            line: 8,
                                                                            column: 27,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Select.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'value',
                                                                    loc: {
                                                                        start: {
                                                                            line: 8,
                                                                            column: 28,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Select.ion'
                                                                        },
                                                                        end: {
                                                                            line: 8,
                                                                            column: 33,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Select.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 8,
                                                                        column: 21,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Select.ion'
                                                                    },
                                                                    end: {
                                                                        line: 8,
                                                                        column: 33,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Select.ion'
                                                                    }
                                                                }
                                                            },
                                                            alternate: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'option',
                                                                    loc: {
                                                                        start: {
                                                                            line: 8,
                                                                            column: 36,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Select.ion'
                                                                        },
                                                                        end: {
                                                                            line: 8,
                                                                            column: 42,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Select.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'id',
                                                                    loc: {
                                                                        start: {
                                                                            line: 8,
                                                                            column: 43,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Select.ion'
                                                                        },
                                                                        end: {
                                                                            line: 8,
                                                                            column: 45,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Select.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 8,
                                                                        column: 36,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Select.ion'
                                                                    },
                                                                    end: {
                                                                        line: 8,
                                                                        column: 45,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Select.ion'
                                                                    }
                                                                }
                                                            }
                                                        },
                                                        right: {
                                                            type: 'Literal',
                                                            value: null
                                                        }
                                                    },
                                                    consequent: {
                                                        type: 'ConditionalExpression',
                                                        test: {
                                                            type: 'BinaryExpression',
                                                            operator: '!=',
                                                            left: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'option',
                                                                    loc: {
                                                                        start: {
                                                                            line: 8,
                                                                            column: 21,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Select.ion'
                                                                        },
                                                                        end: {
                                                                            line: 8,
                                                                            column: 27,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Select.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'value',
                                                                    loc: {
                                                                        start: {
                                                                            line: 8,
                                                                            column: 28,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Select.ion'
                                                                        },
                                                                        end: {
                                                                            line: 8,
                                                                            column: 33,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Select.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 8,
                                                                        column: 21,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Select.ion'
                                                                    },
                                                                    end: {
                                                                        line: 8,
                                                                        column: 33,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Select.ion'
                                                                    }
                                                                }
                                                            },
                                                            right: {
                                                                type: 'Literal',
                                                                value: null
                                                            }
                                                        },
                                                        consequent: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'option',
                                                                loc: {
                                                                    start: {
                                                                        line: 8,
                                                                        column: 21,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Select.ion'
                                                                    },
                                                                    end: {
                                                                        line: 8,
                                                                        column: 27,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Select.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'value',
                                                                loc: {
                                                                    start: {
                                                                        line: 8,
                                                                        column: 28,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Select.ion'
                                                                    },
                                                                    end: {
                                                                        line: 8,
                                                                        column: 33,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Select.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 8,
                                                                    column: 21,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Select.ion'
                                                                },
                                                                end: {
                                                                    line: 8,
                                                                    column: 33,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Select.ion'
                                                                }
                                                            }
                                                        },
                                                        alternate: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'option',
                                                                loc: {
                                                                    start: {
                                                                        line: 8,
                                                                        column: 36,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Select.ion'
                                                                    },
                                                                    end: {
                                                                        line: 8,
                                                                        column: 42,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Select.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'id',
                                                                loc: {
                                                                    start: {
                                                                        line: 8,
                                                                        column: 43,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Select.ion'
                                                                    },
                                                                    end: {
                                                                        line: 8,
                                                                        column: 45,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Select.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 8,
                                                                    column: 36,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Select.ion'
                                                                },
                                                                end: {
                                                                    line: 8,
                                                                    column: 45,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Select.ion'
                                                                }
                                                            }
                                                        }
                                                    },
                                                    alternate: {
                                                        type: 'Identifier',
                                                        name: 'index',
                                                        loc: {
                                                            start: {
                                                                line: 8,
                                                                column: 48,
                                                                fixed: true,
                                                                source: 'glass/html/material/Select.ion'
                                                            },
                                                            end: {
                                                                line: 8,
                                                                column: 53,
                                                                fixed: true,
                                                                source: 'glass/html/material/Select.ion'
                                                            }
                                                        }
                                                    }
                                                },
                                                kind: 'init',
                                                computed: true,
                                                order: '0'
                                            }]
                                    },
                                    remove: null,
                                    order: '0'
                                }]
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'state',
                            loc: {
                                start: {
                                    line: 9,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/Select.ion'
                                },
                                end: {
                                    line: 9,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/html/material/Select.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            properties: [{
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'value',
                                        loc: {
                                            start: {
                                                line: 9,
                                                column: 18,
                                                fixed: true,
                                                source: 'glass/html/material/Select.ion'
                                            },
                                            end: {
                                                line: 9,
                                                column: 23,
                                                fixed: true,
                                                source: 'glass/html/material/Select.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'MemberExpression',
                                        computed: true,
                                        object: {
                                            type: 'Identifier',
                                            name: 'indexToValue',
                                            loc: {
                                                start: {
                                                    line: 9,
                                                    column: 25,
                                                    fixed: true,
                                                    source: 'glass/html/material/Select.ion'
                                                },
                                                end: {
                                                    line: 9,
                                                    column: 37,
                                                    fixed: true,
                                                    source: 'glass/html/material/Select.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Literal',
                                            value: 0
                                        },
                                        loc: {
                                            start: {
                                                line: 9,
                                                column: 25,
                                                fixed: true,
                                                source: 'glass/html/material/Select.ion'
                                            },
                                            end: {
                                                line: 9,
                                                column: 40,
                                                fixed: true,
                                                source: 'glass/html/material/Select.ion'
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '0'
                                }]
                        }
                    }],
                kind: 'let',
                order: '3'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'CallExpression',
                    callee: {
                        type: 'MemberExpression',
                        object: {
                            type: 'Identifier',
                            name: 'Object'
                        },
                        property: {
                            type: 'Identifier',
                            name: 'defineProperties'
                        }
                    },
                    arguments: [
                        {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Select',
                                    loc: {
                                        start: {
                                            line: 10,
                                            column: 11,
                                            fixed: true,
                                            source: 'glass/html/material/Select.ion'
                                        },
                                        end: {
                                            line: 10,
                                            column: 17,
                                            fixed: true,
                                            source: 'glass/html/material/Select.ion'
                                        }
                                    }
                                },
                                arguments: [],
                                loc: {
                                    start: {
                                        line: 10,
                                        column: 11,
                                        fixed: true,
                                        source: 'glass/html/material/Select.ion'
                                    },
                                    end: {
                                        line: 10,
                                        column: 19,
                                        fixed: true,
                                        source: 'glass/html/material/Select.ion'
                                    }
                                }
                            },
                            properties: [
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context) {
                                            return function change(e) {
                                                var state = _context.get('state'), indexToValue = _context.get('indexToValue');
                                                state.value = indexToValue[this.selectedIndex];
                                            };
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 14,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/Select.ion'
                                        },
                                        end: {
                                            line: 16,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/material/Select.ion'
                                        }
                                    },
                                    order: '0'
                                },
                                {
                                    type: 'ForInStatement',
                                    left: {
                                        type: 'VariableDeclaration',
                                        declarations: [
                                            {
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'index',
                                                    loc: {
                                                        start: {
                                                            line: 16,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Select.ion'
                                                        },
                                                        end: {
                                                            line: 16,
                                                            column: 17,
                                                            fixed: true,
                                                            source: 'glass/html/material/Select.ion'
                                                        }
                                                    }
                                                },
                                                init: null
                                            },
                                            {
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'option',
                                                    loc: {
                                                        start: {
                                                            line: 16,
                                                            column: 19,
                                                            fixed: true,
                                                            source: 'glass/html/material/Select.ion'
                                                        },
                                                        end: {
                                                            line: 16,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'glass/html/material/Select.ion'
                                                        }
                                                    }
                                                },
                                                init: null
                                            }
                                        ],
                                        kind: 'let'
                                    },
                                    right: {
                                        type: 'Identifier',
                                        name: 'options',
                                        loc: {
                                            start: {
                                                line: 16,
                                                column: 29,
                                                fixed: true,
                                                source: 'glass/html/material/Select.ion'
                                            },
                                            end: {
                                                line: 16,
                                                column: 36,
                                                fixed: true,
                                                source: 'glass/html/material/Select.ion'
                                            }
                                        }
                                    },
                                    body: {
                                        type: 'BlockStatement',
                                        body: [
                                            {
                                                type: 'VariableDeclaration',
                                                declarations: [{
                                                        type: 'VariableDeclarator',
                                                        id: {
                                                            type: 'Identifier',
                                                            name: 'value',
                                                            loc: {
                                                                start: {
                                                                    line: 17,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Select.ion'
                                                                },
                                                                end: {
                                                                    line: 17,
                                                                    column: 21,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Select.ion'
                                                                }
                                                            }
                                                        },
                                                        init: {
                                                            type: 'MemberExpression',
                                                            computed: true,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'indexToValue',
                                                                loc: {
                                                                    start: {
                                                                        line: 17,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Select.ion'
                                                                    },
                                                                    end: {
                                                                        line: 17,
                                                                        column: 36,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Select.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'index',
                                                                loc: {
                                                                    start: {
                                                                        line: 17,
                                                                        column: 37,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Select.ion'
                                                                    },
                                                                    end: {
                                                                        line: 17,
                                                                        column: 42,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Select.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 17,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Select.ion'
                                                                },
                                                                end: {
                                                                    line: 17,
                                                                    column: 43,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Select.ion'
                                                                }
                                                            }
                                                        }
                                                    }],
                                                kind: 'let',
                                                order: '0'
                                            },
                                            {
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'ObjectExpression',
                                                    objectType: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'Identifier',
                                                            name: 'Option',
                                                            loc: {
                                                                start: {
                                                                    line: 18,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Select.ion'
                                                                },
                                                                end: {
                                                                    line: 18,
                                                                    column: 18,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Select.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [{
                                                                type: 'ObjectExpression',
                                                                properties: [{
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'value',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 18,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Select.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 18,
                                                                                    column: 25,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Select.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Identifier',
                                                                            name: 'index',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 18,
                                                                                    column: 26,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Select.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 18,
                                                                                    column: 31,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Select.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    }]
                                                            }],
                                                        loc: {
                                                            start: {
                                                                line: 18,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'glass/html/material/Select.ion'
                                                            },
                                                            end: {
                                                                line: 18,
                                                                column: 33,
                                                                fixed: true,
                                                                source: 'glass/html/material/Select.ion'
                                                            }
                                                        }
                                                    },
                                                    properties: [
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'selected',
                                                                loc: {
                                                                    start: {
                                                                        line: 19,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Select.ion'
                                                                    },
                                                                    end: {
                                                                        line: 19,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Select.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'BinaryExpression',
                                                                operator: '===',
                                                                left: {
                                                                    type: 'Identifier',
                                                                    name: 'value',
                                                                    loc: {
                                                                        start: {
                                                                            line: 19,
                                                                            column: 26,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Select.ion'
                                                                        },
                                                                        end: {
                                                                            line: 19,
                                                                            column: 31,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Select.ion'
                                                                        }
                                                                    }
                                                                },
                                                                right: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'state',
                                                                        loc: {
                                                                            start: {
                                                                                line: 19,
                                                                                column: 35,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Select.ion'
                                                                            },
                                                                            end: {
                                                                                line: 19,
                                                                                column: 40,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Select.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'value',
                                                                        loc: {
                                                                            start: {
                                                                                line: 19,
                                                                                column: 41,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Select.ion'
                                                                            },
                                                                            end: {
                                                                                line: 19,
                                                                                column: 46,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Select.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 19,
                                                                            column: 35,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Select.ion'
                                                                        },
                                                                        end: {
                                                                            line: 19,
                                                                            column: 46,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Select.ion'
                                                                        }
                                                                    }
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        },
                                                        {
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'option',
                                                                    loc: {
                                                                        start: {
                                                                            line: 20,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Select.ion'
                                                                        },
                                                                        end: {
                                                                            line: 20,
                                                                            column: 22,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Select.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'name',
                                                                    loc: {
                                                                        start: {
                                                                            line: 20,
                                                                            column: 23,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Select.ion'
                                                                        },
                                                                        end: {
                                                                            line: 20,
                                                                            column: 27,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Select.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 20,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Select.ion'
                                                                    },
                                                                    end: {
                                                                        line: 20,
                                                                        column: 27,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Select.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 20,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Select.ion'
                                                                },
                                                                end: {
                                                                    line: 20,
                                                                    column: 27,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Select.ion'
                                                                }
                                                            },
                                                            order: '1'
                                                        }
                                                    ]
                                                },
                                                loc: {
                                                    start: {
                                                        line: 18,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/Select.ion'
                                                    },
                                                    end: {
                                                        line: 23,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'glass/html/material/Select.ion'
                                                    }
                                                },
                                                order: '1'
                                            }
                                        ]
                                    },
                                    remove: null,
                                    order: '1'
                                }
                            ]
                        },
                        {
                            type: 'ObjectExpression',
                            properties: [{
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'valueJSON',
                                        loc: {
                                            start: {
                                                line: 11,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/Select.ion'
                                            },
                                            end: {
                                                line: 11,
                                                column: 26,
                                                fixed: true,
                                                source: 'glass/html/material/Select.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 12,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Select.ion'
                                                        },
                                                        end: {
                                                            line: 12,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Select.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context2) {
                                                        return function () {
                                                            var state = _context2.get('state');
                                                            return state.value;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 13,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Select.ion'
                                                        },
                                                        end: {
                                                            line: 13,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Select.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context3) {
                                                        return function (value) {
                                                            var state = _context3.get('state');
                                                            return state.value = value;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '0'
                                }]
                        }
                    ]
                },
                order: '4'
            }
        ],
        bound: false
    }, {
        this: this,
        _ref3: _ref3,
        _ref: _ref,
        _ref2: _ref2,
        SuggestMenu: SuggestMenu,
        getMatch: getMatch
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/Select',_glass_html_material_Select_);
    else
      _glass_html_material_Select_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_Select_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_Shadow_ = function(module,exports,require){'use strict';
var ion = require('ion');
var style = require('../style');
style.define(module.id, '.Shadow {\n    transition: box-shadow 0.5s;\n}\n.Shadow[level="0"] { box-shadow: 0 0px 0px rgba(0,0,0,0.12) -1, 0 1px 1px rgba(0,0,0,0.24) -1; }\n.Shadow[level="1"] { box-shadow: 0 1px 3px rgba(0,0,0,0.12), 0 1px 2px rgba(0,0,0,0.24); }\n.Shadow[level="2"] { box-shadow: 0 3px 6px rgba(0,0,0,0.16), 0 3px 6px rgba(0,0,0,0.23); }\n.Shadow[level="3"] { box-shadow: 0 10px 20px rgba(0,0,0,0.19), 0 6px 6px rgba(0,0,0,0.23); }\n.Shadow[level="4"] { box-shadow: 0 14px 28px rgba(0,0,0,0.25), 0 10px 10px rgba(0,0,0,0.22); }\n.Shadow[level="5"] { box-shadow: 0 19px 38px rgba(0,0,0,0.30), 0 15px 12px rgba(0,0,0,0.22); }');
module.exports = exports = ion.template(function (attributes) {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [{
                type: 'ReturnStatement',
                argument: {
                    type: 'CallExpression',
                    callee: {
                        type: 'MemberExpression',
                        object: {
                            type: 'Identifier',
                            name: 'Object'
                        },
                        property: {
                            type: 'Identifier',
                            name: 'defineProperties'
                        }
                    },
                    arguments: [
                        {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Span',
                                    loc: {
                                        start: {
                                            line: 21,
                                            column: 11,
                                            fixed: true,
                                            source: 'glass/html/material/Shadow.ion'
                                        },
                                        end: {
                                            line: 21,
                                            column: 15,
                                            fixed: true,
                                            source: 'glass/html/material/Shadow.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'Identifier',
                                        name: 'attributes',
                                        loc: {
                                            start: {
                                                line: 21,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/Shadow.ion'
                                            },
                                            end: {
                                                line: 21,
                                                column: 26,
                                                fixed: true,
                                                source: 'glass/html/material/Shadow.ion'
                                            }
                                        }
                                    }],
                                loc: {
                                    start: {
                                        line: 21,
                                        column: 11,
                                        fixed: true,
                                        source: 'glass/html/material/Shadow.ion'
                                    },
                                    end: {
                                        line: 21,
                                        column: 27,
                                        fixed: true,
                                        source: 'glass/html/material/Shadow.ion'
                                    }
                                }
                            },
                            properties: [{
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'classList',
                                        loc: {
                                            start: {
                                                line: 27,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Shadow.ion'
                                            },
                                            end: {
                                                line: 27,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/Shadow.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'Literal',
                                                    value: 'Shadow'
                                                },
                                                loc: {
                                                    start: {
                                                        line: 28,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/Shadow.ion'
                                                    },
                                                    end: {
                                                        line: 28,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'glass/html/material/Shadow.ion'
                                                    }
                                                },
                                                order: '0'
                                            }]
                                    },
                                    kind: 'init',
                                    order: '0'
                                }]
                        },
                        {
                            type: 'ObjectExpression',
                            properties: [{
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'level',
                                        loc: {
                                            start: {
                                                line: 22,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/Shadow.ion'
                                            },
                                            end: {
                                                line: 22,
                                                column: 22,
                                                fixed: true,
                                                source: 'glass/html/material/Shadow.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 23,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Shadow.ion'
                                                        },
                                                        end: {
                                                            line: 23,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Shadow.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: false,
                                                    value: function () {
                                                        return this._level;
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 24,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Shadow.ion'
                                                        },
                                                        end: {
                                                            line: 24,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Shadow.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: false,
                                                    value: function (value) {
                                                        this._level = value;
                                                        this.setAttribute('level', value);
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '0'
                                }]
                        }
                    ]
                },
                order: '0'
            }],
        bound: false
    }, {
        this: this,
        attributes: attributes,
        style: style
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/Shadow',_glass_html_material_Shadow_);
    else
      _glass_html_material_Shadow_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_Shadow_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_Stepper_ = function(module,exports,require){'use strict';
var ion = require('ion');
var style = require('../style');
ion.template(function () {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [{
                type: 'ExpressionStatement',
                expression: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'MemberExpression',
                        computed: false,
                        object: {
                            type: 'Identifier',
                            name: 'style',
                            loc: {
                                start: {
                                    line: 5,
                                    column: 4,
                                    fixed: true,
                                    source: 'glass/html/material/Stepper.ion'
                                },
                                end: {
                                    line: 5,
                                    column: 9,
                                    fixed: true,
                                    source: 'glass/html/material/Stepper.ion'
                                }
                            }
                        },
                        property: {
                            type: 'Identifier',
                            name: 'sheets',
                            loc: {
                                start: {
                                    line: 5,
                                    column: 10,
                                    fixed: true,
                                    source: 'glass/html/material/Stepper.ion'
                                },
                                end: {
                                    line: 5,
                                    column: 16,
                                    fixed: true,
                                    source: 'glass/html/material/Stepper.ion'
                                }
                            }
                        },
                        loc: {
                            start: {
                                line: 5,
                                column: 4,
                                fixed: true,
                                source: 'glass/html/material/Stepper.ion'
                            },
                            end: {
                                line: 5,
                                column: 16,
                                fixed: true,
                                source: 'glass/html/material/Stepper.ion'
                            }
                        }
                    },
                    properties: [{
                            type: 'Property',
                            key: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'module',
                                    loc: {
                                        start: {
                                            line: 6,
                                            column: 9,
                                            fixed: true,
                                            source: 'glass/html/material/Stepper.ion'
                                        },
                                        end: {
                                            line: 6,
                                            column: 15,
                                            fixed: true,
                                            source: 'glass/html/material/Stepper.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'id',
                                    loc: {
                                        start: {
                                            line: 6,
                                            column: 16,
                                            fixed: true,
                                            source: 'glass/html/material/Stepper.ion'
                                        },
                                        end: {
                                            line: 6,
                                            column: 18,
                                            fixed: true,
                                            source: 'glass/html/material/Stepper.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 9,
                                        fixed: true,
                                        source: 'glass/html/material/Stepper.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/material/Stepper.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'BinaryExpression',
                                operator: '+',
                                left: {
                                    type: 'BinaryExpression',
                                    operator: '+',
                                    left: {
                                        type: 'BinaryExpression',
                                        operator: '+',
                                        left: {
                                            type: 'BinaryExpression',
                                            operator: '+',
                                            left: {
                                                type: 'BinaryExpression',
                                                operator: '+',
                                                left: {
                                                    type: 'BinaryExpression',
                                                    operator: '+',
                                                    left: {
                                                        type: 'BinaryExpression',
                                                        operator: '+',
                                                        left: {
                                                            type: 'BinaryExpression',
                                                            operator: '+',
                                                            left: {
                                                                type: 'BinaryExpression',
                                                                operator: '+',
                                                                left: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '+',
                                                                    left: {
                                                                        type: 'BinaryExpression',
                                                                        operator: '+',
                                                                        left: {
                                                                            type: 'BinaryExpression',
                                                                            operator: '+',
                                                                            left: {
                                                                                type: 'Literal',
                                                                                value: '.Stepper {\n    background-color: white;\n}\n\n.StepperTabs {\n    height: 48px;\n    # padding: 24px;\n    padding: 0px 12px;\n}\n\n.StepperTab {\n    user-select: none;\n    color: '
                                                                            },
                                                                            right: {
                                                                                type: 'CallExpression',
                                                                                callee: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'style',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 19,
                                                                                                column: 25,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Stepper.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 19,
                                                                                                column: 30,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Stepper.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'black',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 19,
                                                                                                column: 31,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Stepper.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 19,
                                                                                                column: 36,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Stepper.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 19,
                                                                                            column: 25,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Stepper.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 19,
                                                                                            column: 36,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Stepper.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                arguments: [{
                                                                                        type: 'Literal',
                                                                                        value: 0.38
                                                                                    }],
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 19,
                                                                                        column: 25,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Stepper.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 19,
                                                                                        column: 42,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Stepper.ion'
                                                                                    }
                                                                                }
                                                                            }
                                                                        },
                                                                        right: {
                                                                            type: 'Literal',
                                                                            value: ';\n}\n\n.StepperTab.selectable {\n    cursor: pointer;\n}\n\n.StepperTab.selected {\n    color: '
                                                                        }
                                                                    },
                                                                    right: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'style',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 27,
                                                                                        column: 25,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Stepper.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 27,
                                                                                        column: 30,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Stepper.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'black',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 27,
                                                                                        column: 31,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Stepper.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 27,
                                                                                        column: 36,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Stepper.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 27,
                                                                                    column: 25,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Stepper.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 27,
                                                                                    column: 36,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Stepper.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [{
                                                                                type: 'Literal',
                                                                                value: 0.87
                                                                            }],
                                                                        loc: {
                                                                            start: {
                                                                                line: 27,
                                                                                column: 25,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Stepper.ion'
                                                                            },
                                                                            end: {
                                                                                line: 27,
                                                                                column: 42,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Stepper.ion'
                                                                            }
                                                                        }
                                                                    }
                                                                },
                                                                right: {
                                                                    type: 'Literal',
                                                                    value: ';\n}\n\n.StepperCircle {\n    height: 24px;\n    width: 24px;\n    border-radius: 50%;\n    background-color: '
                                                                }
                                                            },
                                                            right: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'style',
                                                                        loc: {
                                                                            start: {
                                                                                line: 34,
                                                                                column: 36,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Stepper.ion'
                                                                            },
                                                                            end: {
                                                                                line: 34,
                                                                                column: 41,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Stepper.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'black',
                                                                        loc: {
                                                                            start: {
                                                                                line: 34,
                                                                                column: 42,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Stepper.ion'
                                                                            },
                                                                            end: {
                                                                                line: 34,
                                                                                column: 47,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Stepper.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 34,
                                                                            column: 36,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Stepper.ion'
                                                                        },
                                                                        end: {
                                                                            line: 34,
                                                                            column: 47,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Stepper.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'Literal',
                                                                        value: 0.38
                                                                    }],
                                                                loc: {
                                                                    start: {
                                                                        line: 34,
                                                                        column: 36,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Stepper.ion'
                                                                    },
                                                                    end: {
                                                                        line: 34,
                                                                        column: 53,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Stepper.ion'
                                                                    }
                                                                }
                                                            }
                                                        },
                                                        right: {
                                                            type: 'Literal',
                                                            value: ';\n    color: white;\n}\n\n.selected .StepperCircle {\n    background-color: '
                                                        }
                                                    },
                                                    right: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'style',
                                                                loc: {
                                                                    start: {
                                                                        line: 39,
                                                                        column: 36,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Stepper.ion'
                                                                    },
                                                                    end: {
                                                                        line: 39,
                                                                        column: 41,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Stepper.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'color',
                                                                loc: {
                                                                    start: {
                                                                        line: 39,
                                                                        column: 42,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Stepper.ion'
                                                                    },
                                                                    end: {
                                                                        line: 39,
                                                                        column: 47,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Stepper.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 39,
                                                                    column: 36,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Stepper.ion'
                                                                },
                                                                end: {
                                                                    line: 39,
                                                                    column: 47,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Stepper.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'primary',
                                                            loc: {
                                                                start: {
                                                                    line: 39,
                                                                    column: 48,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Stepper.ion'
                                                                },
                                                                end: {
                                                                    line: 39,
                                                                    column: 55,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Stepper.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 39,
                                                                column: 36,
                                                                fixed: true,
                                                                source: 'glass/html/material/Stepper.ion'
                                                            },
                                                            end: {
                                                                line: 39,
                                                                column: 55,
                                                                fixed: true,
                                                                source: 'glass/html/material/Stepper.ion'
                                                            }
                                                        }
                                                    }
                                                },
                                                right: {
                                                    type: 'Literal',
                                                    value: ';\n}\n\n.completed .StepperCircle {\n    background-color: '
                                                }
                                            },
                                            right: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'style',
                                                        loc: {
                                                            start: {
                                                                line: 43,
                                                                column: 36,
                                                                fixed: true,
                                                                source: 'glass/html/material/Stepper.ion'
                                                            },
                                                            end: {
                                                                line: 43,
                                                                column: 41,
                                                                fixed: true,
                                                                source: 'glass/html/material/Stepper.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'color',
                                                        loc: {
                                                            start: {
                                                                line: 43,
                                                                column: 42,
                                                                fixed: true,
                                                                source: 'glass/html/material/Stepper.ion'
                                                            },
                                                            end: {
                                                                line: 43,
                                                                column: 47,
                                                                fixed: true,
                                                                source: 'glass/html/material/Stepper.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 43,
                                                            column: 36,
                                                            fixed: true,
                                                            source: 'glass/html/material/Stepper.ion'
                                                        },
                                                        end: {
                                                            line: 43,
                                                            column: 47,
                                                            fixed: true,
                                                            source: 'glass/html/material/Stepper.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'primary',
                                                    loc: {
                                                        start: {
                                                            line: 43,
                                                            column: 48,
                                                            fixed: true,
                                                            source: 'glass/html/material/Stepper.ion'
                                                        },
                                                        end: {
                                                            line: 43,
                                                            column: 55,
                                                            fixed: true,
                                                            source: 'glass/html/material/Stepper.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 43,
                                                        column: 36,
                                                        fixed: true,
                                                        source: 'glass/html/material/Stepper.ion'
                                                    },
                                                    end: {
                                                        line: 43,
                                                        column: 55,
                                                        fixed: true,
                                                        source: 'glass/html/material/Stepper.ion'
                                                    }
                                                }
                                            }
                                        },
                                        right: {
                                            type: 'Literal',
                                            value: ';\n}\n\n.StepIcon {\n    height: 75%;\n    width: 75%;\n}\n\n.StepperLine {\n    height: 1px;\n    background-color: '
                                        }
                                    },
                                    right: {
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'style',
                                                loc: {
                                                    start: {
                                                        line: 53,
                                                        column: 36,
                                                        fixed: true,
                                                        source: 'glass/html/material/Stepper.ion'
                                                    },
                                                    end: {
                                                        line: 53,
                                                        column: 41,
                                                        fixed: true,
                                                        source: 'glass/html/material/Stepper.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'black',
                                                loc: {
                                                    start: {
                                                        line: 53,
                                                        column: 42,
                                                        fixed: true,
                                                        source: 'glass/html/material/Stepper.ion'
                                                    },
                                                    end: {
                                                        line: 53,
                                                        column: 47,
                                                        fixed: true,
                                                        source: 'glass/html/material/Stepper.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 53,
                                                    column: 36,
                                                    fixed: true,
                                                    source: 'glass/html/material/Stepper.ion'
                                                },
                                                end: {
                                                    line: 53,
                                                    column: 47,
                                                    fixed: true,
                                                    source: 'glass/html/material/Stepper.ion'
                                                }
                                            }
                                        },
                                        arguments: [{
                                                type: 'Literal',
                                                value: 0.26
                                            }],
                                        loc: {
                                            start: {
                                                line: 53,
                                                column: 36,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            },
                                            end: {
                                                line: 53,
                                                column: 53,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            }
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: ';\n}'
                                }
                            },
                            kind: 'init',
                            computed: true,
                            order: '0'
                        }]
                },
                loc: {
                    start: {
                        line: 5,
                        column: 4,
                        fixed: true,
                        source: 'glass/html/material/Stepper.ion'
                    },
                    end: {
                        line: 56,
                        column: 8,
                        fixed: true,
                        source: 'glass/html/material/Stepper.ion'
                    }
                },
                order: '0'
            }],
        bound: false
    }, {
        this: this,
        module: module,
        style: style,
        StepperTabs: StepperTabs,
        Line: Line,
        StepperTab: StepperTab
    }, null);
})().observe();
var StepperTabs = ion.template(function () {
        return ion.createRuntime({
            type: 'Template',
            id: null,
            body: [{
                    type: 'ReturnStatement',
                    argument: {
                        type: 'CallExpression',
                        callee: {
                            type: 'Identifier',
                            name: 'Div',
                            loc: {
                                start: {
                                    line: 58,
                                    column: 30,
                                    fixed: true,
                                    source: 'glass/html/material/Stepper.ion'
                                },
                                end: {
                                    line: 58,
                                    column: 33,
                                    fixed: true,
                                    source: 'glass/html/material/Stepper.ion'
                                }
                            }
                        },
                        arguments: [{
                                type: 'ObjectExpression',
                                properties: [{
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'class',
                                            loc: {
                                                start: {
                                                    line: 58,
                                                    column: 35,
                                                    fixed: true,
                                                    source: 'glass/html/material/Stepper.ion'
                                                },
                                                end: {
                                                    line: 58,
                                                    column: 40,
                                                    fixed: true,
                                                    source: 'glass/html/material/Stepper.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: 'StepperTabs layout horizontal fixed center justified'
                                        },
                                        kind: 'init',
                                        order: '0'
                                    }]
                            }],
                        loc: {
                            start: {
                                line: 58,
                                column: 30,
                                fixed: true,
                                source: 'glass/html/material/Stepper.ion'
                            },
                            end: {
                                line: 58,
                                column: 98,
                                fixed: true,
                                source: 'glass/html/material/Stepper.ion'
                            }
                        }
                    },
                    order: '0'
                }],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'StepperTabs',
                loc: {
                    start: {
                        line: 58,
                        column: 4,
                        fixed: true,
                        source: 'glass/html/material/Stepper.ion'
                    },
                    end: {
                        line: 58,
                        column: 15,
                        fixed: true,
                        source: 'glass/html/material/Stepper.ion'
                    }
                }
            }
        }, {
            this: this,
            style: style,
            StepperTabs: StepperTabs,
            Line: Line,
            StepperTab: StepperTab
        }, null);
    }), Line = ion.template(function () {
        return ion.createRuntime({
            type: 'Template',
            id: null,
            body: [{
                    type: 'ReturnStatement',
                    argument: {
                        type: 'ObjectExpression',
                        objectType: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Div',
                                loc: {
                                    start: {
                                        line: 61,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/Stepper.ion'
                                    },
                                    end: {
                                        line: 61,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/material/Stepper.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ObjectExpression',
                                    properties: [
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'class',
                                                loc: {
                                                    start: {
                                                        line: 61,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'glass/html/material/Stepper.ion'
                                                    },
                                                    end: {
                                                        line: 61,
                                                        column: 25,
                                                        fixed: true,
                                                        source: 'glass/html/material/Stepper.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: 'flex'
                                            },
                                            kind: 'init',
                                            order: '0'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'style',
                                                loc: {
                                                    start: {
                                                        line: 61,
                                                        column: 34,
                                                        fixed: true,
                                                        source: 'glass/html/material/Stepper.ion'
                                                    },
                                                    end: {
                                                        line: 61,
                                                        column: 39,
                                                        fixed: true,
                                                        source: 'glass/html/material/Stepper.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: 'padding:8px'
                                            },
                                            kind: 'init',
                                            order: '1'
                                        }
                                    ]
                                }],
                            loc: {
                                start: {
                                    line: 61,
                                    column: 15,
                                    fixed: true,
                                    source: 'glass/html/material/Stepper.ion'
                                },
                                end: {
                                    line: 61,
                                    column: 55,
                                    fixed: true,
                                    source: 'glass/html/material/Stepper.ion'
                                }
                            }
                        },
                        properties: [{
                                type: 'ExpressionStatement',
                                expression: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'Identifier',
                                        name: 'Div',
                                        loc: {
                                            start: {
                                                line: 62,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            },
                                            end: {
                                                line: 62,
                                                column: 15,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            }
                                        }
                                    },
                                    arguments: [{
                                            type: 'ObjectExpression',
                                            properties: [{
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'class',
                                                        loc: {
                                                            start: {
                                                                line: 62,
                                                                column: 17,
                                                                fixed: true,
                                                                source: 'glass/html/material/Stepper.ion'
                                                            },
                                                            end: {
                                                                line: 62,
                                                                column: 22,
                                                                fixed: true,
                                                                source: 'glass/html/material/Stepper.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 'StepperLine flex'
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                }]
                                        }],
                                    loc: {
                                        start: {
                                            line: 62,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/material/Stepper.ion'
                                        },
                                        end: {
                                            line: 62,
                                            column: 43,
                                            fixed: true,
                                            source: 'glass/html/material/Stepper.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 62,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/Stepper.ion'
                                    },
                                    end: {
                                        line: 62,
                                        column: 43,
                                        fixed: true,
                                        source: 'glass/html/material/Stepper.ion'
                                    }
                                },
                                order: '0'
                            }]
                    },
                    order: '0'
                }],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'Line',
                loc: {
                    start: {
                        line: 60,
                        column: 4,
                        fixed: true,
                        source: 'glass/html/material/Stepper.ion'
                    },
                    end: {
                        line: 60,
                        column: 8,
                        fixed: true,
                        source: 'glass/html/material/Stepper.ion'
                    }
                }
            }
        }, {
            this: this,
            style: style,
            StepperTabs: StepperTabs,
            Line: Line,
            StepperTab: StepperTab
        }, null);
    }), StepperTab = ion.template(function (tab, index, stepper) {
        return ion.createRuntime({
            type: 'Template',
            id: null,
            body: [
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'selected',
                                loc: {
                                    start: {
                                        line: 65,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/Stepper.ion'
                                    },
                                    end: {
                                        line: 65,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/Stepper.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'stepper',
                                        loc: {
                                            start: {
                                                line: 65,
                                                column: 23,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            },
                                            end: {
                                                line: 65,
                                                column: 30,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'isSelected',
                                        loc: {
                                            start: {
                                                line: 65,
                                                column: 31,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            },
                                            end: {
                                                line: 65,
                                                column: 41,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 65,
                                            column: 23,
                                            fixed: true,
                                            source: 'glass/html/material/Stepper.ion'
                                        },
                                        end: {
                                            line: 65,
                                            column: 41,
                                            fixed: true,
                                            source: 'glass/html/material/Stepper.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'Identifier',
                                        name: 'index',
                                        loc: {
                                            start: {
                                                line: 65,
                                                column: 42,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            },
                                            end: {
                                                line: 65,
                                                column: 47,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            }
                                        }
                                    }],
                                loc: {
                                    start: {
                                        line: 65,
                                        column: 23,
                                        fixed: true,
                                        source: 'glass/html/material/Stepper.ion'
                                    },
                                    end: {
                                        line: 65,
                                        column: 48,
                                        fixed: true,
                                        source: 'glass/html/material/Stepper.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '0'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'completed',
                                loc: {
                                    start: {
                                        line: 66,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/Stepper.ion'
                                    },
                                    end: {
                                        line: 66,
                                        column: 21,
                                        fixed: true,
                                        source: 'glass/html/material/Stepper.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'stepper',
                                        loc: {
                                            start: {
                                                line: 66,
                                                column: 24,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            },
                                            end: {
                                                line: 66,
                                                column: 31,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'isCompleted',
                                        loc: {
                                            start: {
                                                line: 66,
                                                column: 32,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            },
                                            end: {
                                                line: 66,
                                                column: 43,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 66,
                                            column: 24,
                                            fixed: true,
                                            source: 'glass/html/material/Stepper.ion'
                                        },
                                        end: {
                                            line: 66,
                                            column: 43,
                                            fixed: true,
                                            source: 'glass/html/material/Stepper.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'Identifier',
                                        name: 'index',
                                        loc: {
                                            start: {
                                                line: 66,
                                                column: 44,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            },
                                            end: {
                                                line: 66,
                                                column: 49,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            }
                                        }
                                    }],
                                loc: {
                                    start: {
                                        line: 66,
                                        column: 24,
                                        fixed: true,
                                        source: 'glass/html/material/Stepper.ion'
                                    },
                                    end: {
                                        line: 66,
                                        column: 50,
                                        fixed: true,
                                        source: 'glass/html/material/Stepper.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '1'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'selectable',
                                loc: {
                                    start: {
                                        line: 67,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/Stepper.ion'
                                    },
                                    end: {
                                        line: 67,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/material/Stepper.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'stepper',
                                        loc: {
                                            start: {
                                                line: 67,
                                                column: 25,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            },
                                            end: {
                                                line: 67,
                                                column: 32,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'canSelect',
                                        loc: {
                                            start: {
                                                line: 67,
                                                column: 33,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            },
                                            end: {
                                                line: 67,
                                                column: 42,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 67,
                                            column: 25,
                                            fixed: true,
                                            source: 'glass/html/material/Stepper.ion'
                                        },
                                        end: {
                                            line: 67,
                                            column: 42,
                                            fixed: true,
                                            source: 'glass/html/material/Stepper.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'Identifier',
                                        name: 'index',
                                        loc: {
                                            start: {
                                                line: 67,
                                                column: 43,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            },
                                            end: {
                                                line: 67,
                                                column: 48,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            }
                                        }
                                    }],
                                loc: {
                                    start: {
                                        line: 67,
                                        column: 25,
                                        fixed: true,
                                        source: 'glass/html/material/Stepper.ion'
                                    },
                                    end: {
                                        line: 67,
                                        column: 49,
                                        fixed: true,
                                        source: 'glass/html/material/Stepper.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '2'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'classes',
                                loc: {
                                    start: {
                                        line: 69,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/Stepper.ion'
                                    },
                                    end: {
                                        line: 69,
                                        column: 19,
                                        fixed: true,
                                        source: 'glass/html/material/Stepper.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'ArrayExpression',
                                    elements: []
                                },
                                properties: [
                                    {
                                        type: 'IfStatement',
                                        test: {
                                            type: 'Identifier',
                                            name: 'selected',
                                            loc: {
                                                start: {
                                                    line: 70,
                                                    column: 15,
                                                    fixed: true,
                                                    source: 'glass/html/material/Stepper.ion'
                                                },
                                                end: {
                                                    line: 70,
                                                    column: 23,
                                                    fixed: true,
                                                    source: 'glass/html/material/Stepper.ion'
                                                }
                                            }
                                        },
                                        consequent: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'Literal',
                                                        value: 'selected'
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 71,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/Stepper.ion'
                                                        },
                                                        end: {
                                                            line: 71,
                                                            column: 26,
                                                            fixed: true,
                                                            source: 'glass/html/material/Stepper.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        alternate: null,
                                        order: '0'
                                    },
                                    {
                                        type: 'IfStatement',
                                        test: {
                                            type: 'Identifier',
                                            name: 'completed',
                                            loc: {
                                                start: {
                                                    line: 72,
                                                    column: 15,
                                                    fixed: true,
                                                    source: 'glass/html/material/Stepper.ion'
                                                },
                                                end: {
                                                    line: 72,
                                                    column: 24,
                                                    fixed: true,
                                                    source: 'glass/html/material/Stepper.ion'
                                                }
                                            }
                                        },
                                        consequent: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'Literal',
                                                        value: 'completed'
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 73,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/Stepper.ion'
                                                        },
                                                        end: {
                                                            line: 73,
                                                            column: 27,
                                                            fixed: true,
                                                            source: 'glass/html/material/Stepper.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        alternate: null,
                                        order: '1'
                                    },
                                    {
                                        type: 'IfStatement',
                                        test: {
                                            type: 'Identifier',
                                            name: 'selectable',
                                            loc: {
                                                start: {
                                                    line: 74,
                                                    column: 15,
                                                    fixed: true,
                                                    source: 'glass/html/material/Stepper.ion'
                                                },
                                                end: {
                                                    line: 74,
                                                    column: 25,
                                                    fixed: true,
                                                    source: 'glass/html/material/Stepper.ion'
                                                }
                                            }
                                        },
                                        consequent: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'Literal',
                                                        value: 'selectable'
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 75,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/Stepper.ion'
                                                        },
                                                        end: {
                                                            line: 75,
                                                            column: 28,
                                                            fixed: true,
                                                            source: 'glass/html/material/Stepper.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        alternate: null,
                                        order: '2'
                                    }
                                ]
                            }
                        }],
                    kind: 'let',
                    order: '3'
                },
                {
                    type: 'ReturnStatement',
                    argument: {
                        type: 'ObjectExpression',
                        objectType: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Div',
                                loc: {
                                    start: {
                                        line: 77,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/Stepper.ion'
                                    },
                                    end: {
                                        line: 77,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/material/Stepper.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ObjectExpression',
                                    properties: [{
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'class',
                                                loc: {
                                                    start: {
                                                        line: 77,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'glass/html/material/Stepper.ion'
                                                    },
                                                    end: {
                                                        line: 77,
                                                        column: 25,
                                                        fixed: true,
                                                        source: 'glass/html/material/Stepper.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'BinaryExpression',
                                                operator: '+',
                                                left: {
                                                    type: 'Literal',
                                                    value: 'StepperTab layout center fixed '
                                                },
                                                right: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'classes',
                                                            loc: {
                                                                start: {
                                                                    line: 77,
                                                                    column: 60,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Stepper.ion'
                                                                },
                                                                end: {
                                                                    line: 77,
                                                                    column: 67,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Stepper.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'join',
                                                            loc: {
                                                                start: {
                                                                    line: 77,
                                                                    column: 68,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Stepper.ion'
                                                                },
                                                                end: {
                                                                    line: 77,
                                                                    column: 72,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Stepper.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 77,
                                                                column: 60,
                                                                fixed: true,
                                                                source: 'glass/html/material/Stepper.ion'
                                                            },
                                                            end: {
                                                                line: 77,
                                                                column: 72,
                                                                fixed: true,
                                                                source: 'glass/html/material/Stepper.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [{
                                                            type: 'Literal',
                                                            value: ' '
                                                        }],
                                                    loc: {
                                                        start: {
                                                            line: 77,
                                                            column: 60,
                                                            fixed: true,
                                                            source: 'glass/html/material/Stepper.ion'
                                                        },
                                                        end: {
                                                            line: 77,
                                                            column: 77,
                                                            fixed: true,
                                                            source: 'glass/html/material/Stepper.ion'
                                                        }
                                                    }
                                                }
                                            },
                                            kind: 'init',
                                            order: '0'
                                        }]
                                }],
                            loc: {
                                start: {
                                    line: 77,
                                    column: 15,
                                    fixed: true,
                                    source: 'glass/html/material/Stepper.ion'
                                },
                                end: {
                                    line: 77,
                                    column: 82,
                                    fixed: true,
                                    source: 'glass/html/material/Stepper.ion'
                                }
                            }
                        },
                        properties: [
                            {
                                type: 'ExpressionStatement',
                                expression: {
                                    type: 'ObjectExpression',
                                    objectType: {
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'Identifier',
                                            name: 'Div',
                                            loc: {
                                                start: {
                                                    line: 78,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/Stepper.ion'
                                                },
                                                end: {
                                                    line: 78,
                                                    column: 15,
                                                    fixed: true,
                                                    source: 'glass/html/material/Stepper.ion'
                                                }
                                            }
                                        },
                                        arguments: [{
                                                type: 'ObjectExpression',
                                                properties: [{
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'class',
                                                            loc: {
                                                                start: {
                                                                    line: 78,
                                                                    column: 17,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Stepper.ion'
                                                                },
                                                                end: {
                                                                    line: 78,
                                                                    column: 22,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Stepper.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Literal',
                                                            value: 'StepperCircle layout center center-justified'
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    }]
                                            }],
                                        loc: {
                                            start: {
                                                line: 78,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            },
                                            end: {
                                                line: 78,
                                                column: 71,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            }
                                        }
                                    },
                                    properties: [{
                                            type: 'IfStatement',
                                            test: {
                                                type: 'Identifier',
                                                name: 'selected',
                                                loc: {
                                                    start: {
                                                        line: 79,
                                                        column: 19,
                                                        fixed: true,
                                                        source: 'glass/html/material/Stepper.ion'
                                                    },
                                                    end: {
                                                        line: 79,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'glass/html/material/Stepper.ion'
                                                    }
                                                }
                                            },
                                            consequent: {
                                                type: 'BlockStatement',
                                                body: [{
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'IronIcon',
                                                                loc: {
                                                                    start: {
                                                                        line: 80,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Stepper.ion'
                                                                    },
                                                                    end: {
                                                                        line: 80,
                                                                        column: 28,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Stepper.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [{
                                                                    type: 'ObjectExpression',
                                                                    properties: [
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'class',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 80,
                                                                                        column: 30,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Stepper.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 80,
                                                                                        column: 35,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Stepper.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'StepIcon'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'icon',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 80,
                                                                                        column: 48,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Stepper.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 80,
                                                                                        column: 52,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Stepper.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'create'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '1'
                                                                        }
                                                                    ]
                                                                }],
                                                            loc: {
                                                                start: {
                                                                    line: 80,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Stepper.ion'
                                                                },
                                                                end: {
                                                                    line: 80,
                                                                    column: 64,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Stepper.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 80,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'glass/html/material/Stepper.ion'
                                                            },
                                                            end: {
                                                                line: 80,
                                                                column: 64,
                                                                fixed: true,
                                                                source: 'glass/html/material/Stepper.ion'
                                                            }
                                                        },
                                                        order: '0'
                                                    }]
                                            },
                                            alternate: {
                                                type: 'IfStatement',
                                                test: {
                                                    type: 'Identifier',
                                                    name: 'completed',
                                                    loc: {
                                                        start: {
                                                            line: 81,
                                                            column: 24,
                                                            fixed: true,
                                                            source: 'glass/html/material/Stepper.ion'
                                                        },
                                                        end: {
                                                            line: 81,
                                                            column: 33,
                                                            fixed: true,
                                                            source: 'glass/html/material/Stepper.ion'
                                                        }
                                                    }
                                                },
                                                consequent: {
                                                    type: 'BlockStatement',
                                                    body: [{
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Identifier',
                                                                    name: 'IronIcon',
                                                                    loc: {
                                                                        start: {
                                                                            line: 82,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Stepper.ion'
                                                                        },
                                                                        end: {
                                                                            line: 82,
                                                                            column: 28,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Stepper.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'ObjectExpression',
                                                                        properties: [
                                                                            {
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'class',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 82,
                                                                                            column: 30,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Stepper.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 82,
                                                                                            column: 35,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Stepper.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Literal',
                                                                                    value: 'StepIcon'
                                                                                },
                                                                                kind: 'init',
                                                                                order: '0'
                                                                            },
                                                                            {
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'icon',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 82,
                                                                                            column: 48,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Stepper.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 82,
                                                                                            column: 52,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Stepper.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Literal',
                                                                                    value: 'done'
                                                                                },
                                                                                kind: 'init',
                                                                                order: '1'
                                                                            }
                                                                        ]
                                                                    }],
                                                                loc: {
                                                                    start: {
                                                                        line: 82,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Stepper.ion'
                                                                    },
                                                                    end: {
                                                                        line: 82,
                                                                        column: 62,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Stepper.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 82,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Stepper.ion'
                                                                },
                                                                end: {
                                                                    line: 82,
                                                                    column: 62,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Stepper.ion'
                                                                }
                                                            },
                                                            order: '0'
                                                        }]
                                                },
                                                alternate: {
                                                    type: 'BlockStatement',
                                                    body: [{
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'ObjectExpression',
                                                                objectType: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'Identifier',
                                                                        name: 'Div',
                                                                        loc: {
                                                                            start: {
                                                                                line: 84,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Stepper.ion'
                                                                            },
                                                                            end: {
                                                                                line: 84,
                                                                                column: 23,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Stepper.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [],
                                                                    loc: {
                                                                        start: {
                                                                            line: 84,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Stepper.ion'
                                                                        },
                                                                        end: {
                                                                            line: 84,
                                                                            column: 25,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Stepper.ion'
                                                                        }
                                                                    }
                                                                },
                                                                properties: [{
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'BinaryExpression',
                                                                            operator: '+',
                                                                            left: {
                                                                                type: 'Identifier',
                                                                                name: 'index',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 85,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Stepper.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 85,
                                                                                        column: 29,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Stepper.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            right: {
                                                                                type: 'Literal',
                                                                                value: 1
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 85,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Stepper.ion'
                                                                            },
                                                                            end: {
                                                                                line: 85,
                                                                                column: 33,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Stepper.ion'
                                                                            }
                                                                        },
                                                                        order: '0'
                                                                    }]
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 84,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Stepper.ion'
                                                                },
                                                                end: {
                                                                    line: 86,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Stepper.ion'
                                                                }
                                                            },
                                                            order: '0'
                                                        }]
                                                }
                                            },
                                            order: '0'
                                        }]
                                },
                                loc: {
                                    start: {
                                        line: 78,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/Stepper.ion'
                                    },
                                    end: {
                                        line: 86,
                                        column: 16,
                                        fixed: true,
                                        source: 'glass/html/material/Stepper.ion'
                                    }
                                },
                                order: '0'
                            },
                            {
                                type: 'ExpressionStatement',
                                expression: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'Identifier',
                                        name: 'Div',
                                        loc: {
                                            start: {
                                                line: 86,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            },
                                            end: {
                                                line: 86,
                                                column: 15,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            }
                                        }
                                    },
                                    arguments: [{
                                            type: 'ObjectExpression',
                                            properties: [{
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'style',
                                                        loc: {
                                                            start: {
                                                                line: 86,
                                                                column: 17,
                                                                fixed: true,
                                                                source: 'glass/html/material/Stepper.ion'
                                                            },
                                                            end: {
                                                                line: 86,
                                                                column: 22,
                                                                fixed: true,
                                                                source: 'glass/html/material/Stepper.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 'padding: 4px'
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                }]
                                        }],
                                    loc: {
                                        start: {
                                            line: 86,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/material/Stepper.ion'
                                        },
                                        end: {
                                            line: 86,
                                            column: 39,
                                            fixed: true,
                                            source: 'glass/html/material/Stepper.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 86,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/Stepper.ion'
                                    },
                                    end: {
                                        line: 86,
                                        column: 39,
                                        fixed: true,
                                        source: 'glass/html/material/Stepper.ion'
                                    }
                                },
                                order: '1'
                            },
                            {
                                type: 'ExpressionStatement',
                                expression: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'tab',
                                        loc: {
                                            start: {
                                                line: 87,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            },
                                            end: {
                                                line: 87,
                                                column: 15,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'name',
                                        loc: {
                                            start: {
                                                line: 87,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            },
                                            end: {
                                                line: 87,
                                                column: 20,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 87,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/material/Stepper.ion'
                                        },
                                        end: {
                                            line: 87,
                                            column: 20,
                                            fixed: true,
                                            source: 'glass/html/material/Stepper.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 87,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/Stepper.ion'
                                    },
                                    end: {
                                        line: 87,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/Stepper.ion'
                                    }
                                },
                                order: '2'
                            },
                            {
                                type: 'ExpressionStatement',
                                expression: {
                                    type: 'Function',
                                    context: true,
                                    value: function (_context) {
                                        return function touchstart(e) {
                                            var stepper = _context.get('stepper'), index = _context.get('index');
                                            stepper.select(index);
                                            e.preventDefault();
                                        };
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 89,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/Stepper.ion'
                                    },
                                    end: {
                                        line: 92,
                                        column: 16,
                                        fixed: true,
                                        source: 'glass/html/material/Stepper.ion'
                                    }
                                },
                                order: '3'
                            },
                            {
                                type: 'ExpressionStatement',
                                expression: {
                                    type: 'Function',
                                    context: true,
                                    value: function (_context2) {
                                        return function click(e) {
                                            var stepper = _context2.get('stepper'), index = _context2.get('index');
                                            stepper.select(index);
                                        };
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 92,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/material/Stepper.ion'
                                    },
                                    end: {
                                        line: 95,
                                        column: 16,
                                        fixed: true,
                                        source: 'glass/html/material/Stepper.ion'
                                    }
                                },
                                order: '4'
                            }
                        ]
                    },
                    order: '4'
                }
            ],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'StepperTab',
                loc: {
                    start: {
                        line: 64,
                        column: 4,
                        fixed: true,
                        source: 'glass/html/material/Stepper.ion'
                    },
                    end: {
                        line: 64,
                        column: 14,
                        fixed: true,
                        source: 'glass/html/material/Stepper.ion'
                    }
                }
            }
        }, {
            this: this,
            tab: tab,
            index: index,
            stepper: stepper,
            style: style,
            StepperTabs: StepperTabs,
            Line: Line,
            StepperTab: StepperTab
        }, null);
    });
module.exports = exports = ion.template(function Stepper(args) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'Stepper',
            loc: {
                start: {
                    line: 95,
                    column: 16,
                    fixed: true,
                    source: 'glass/html/material/Stepper.ion'
                },
                end: {
                    line: 95,
                    column: 23,
                    fixed: true,
                    source: 'glass/html/material/Stepper.ion'
                }
            }
        },
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: '_ref'
                        },
                        init: {
                            type: 'Identifier',
                            name: 'args',
                            loc: {
                                start: {
                                    line: 96,
                                    column: 17,
                                    fixed: true,
                                    source: 'glass/html/material/Stepper.ion'
                                },
                                end: {
                                    line: 96,
                                    column: 21,
                                    fixed: true,
                                    source: 'glass/html/material/Stepper.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'tabs',
                            loc: {
                                start: {
                                    line: 96,
                                    column: 9,
                                    fixed: true,
                                    source: 'glass/html/material/Stepper.ion'
                                },
                                end: {
                                    line: 96,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/html/material/Stepper.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'tabs',
                                loc: {
                                    start: {
                                        line: 96,
                                        column: 9,
                                        fixed: true,
                                        source: 'glass/html/material/Stepper.ion'
                                    },
                                    end: {
                                        line: 96,
                                        column: 13,
                                        fixed: true,
                                        source: 'glass/html/material/Stepper.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'stepper',
                            loc: {
                                start: {
                                    line: 98,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/Stepper.ion'
                                },
                                end: {
                                    line: 98,
                                    column: 15,
                                    fixed: true,
                                    source: 'glass/html/material/Stepper.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'ObjectExpression',
                                properties: []
                            },
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'selected',
                                        loc: {
                                            start: {
                                                line: 99,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            },
                                            end: {
                                                line: 99,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: 0
                                    },
                                    kind: 'init',
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'focusDirty',
                                        loc: {
                                            start: {
                                                line: 100,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            },
                                            end: {
                                                line: 100,
                                                column: 18,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: false
                                    },
                                    kind: 'init',
                                    order: '1'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'isSelected',
                                        loc: {
                                            start: {
                                                line: 101,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            },
                                            end: {
                                                line: 101,
                                                column: 18,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: false,
                                        value: function (index) {
                                            return this.selected === index;
                                        }
                                    },
                                    kind: 'init',
                                    order: '2'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'select',
                                        loc: {
                                            start: {
                                                line: 102,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            },
                                            end: {
                                                line: 102,
                                                column: 14,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context3) {
                                            return function (index) {
                                                var stepper = _context3.get('stepper');
                                                if (this.canSelect(index)) {
                                                    this.focusDirty = true;
                                                    this.selected = index;
                                                    setTimeout(function () {
                                                        return stepper.focus();
                                                    }, 450);
                                                    return true;
                                                }
                                                return false;
                                            };
                                        }
                                    },
                                    kind: 'init',
                                    order: '3'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'focus',
                                        loc: {
                                            start: {
                                                line: 109,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            },
                                            end: {
                                                line: 109,
                                                column: 13,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context4) {
                                            return function () {
                                                var contents = _context4.get('contents');
                                                if (this.focusDirty) {
                                                    this.focusDirty = false;
                                                    contents[this.selected].focus();
                                                }
                                            };
                                        }
                                    },
                                    kind: 'init',
                                    order: '4'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'canSelect',
                                        loc: {
                                            start: {
                                                line: 113,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            },
                                            end: {
                                                line: 113,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context5) {
                                            return function (index) {
                                                var tabs = _context5.get('tabs');
                                                if (index === this.selected || index >= tabs.length) {
                                                    return false;
                                                }
                                                var tab = tabs[index];
                                                if (this.isCompleted(index) && tab.editable !== true) {
                                                    return false;
                                                }
                                                for (var i = 0; i < index; i++) {
                                                    if (!this.isCompleted(i) && tabs[i].optional !== true) {
                                                        return false;
                                                    }
                                                }
                                                return true;
                                            };
                                        }
                                    },
                                    kind: 'init',
                                    order: '5'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'completed',
                                        loc: {
                                            start: {
                                                line: 123,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            },
                                            end: {
                                                line: 123,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: []
                                    },
                                    kind: 'init',
                                    order: '6'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'isCompleted',
                                        loc: {
                                            start: {
                                                line: 124,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            },
                                            end: {
                                                line: 124,
                                                column: 19,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: false,
                                        value: function (index) {
                                            return this.completed[index] === true;
                                        }
                                    },
                                    kind: 'init',
                                    order: '7'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'complete',
                                        loc: {
                                            start: {
                                                line: 125,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            },
                                            end: {
                                                line: 125,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: false,
                                        value: function () {
                                            this.completed[this.selected] = true;
                                            this.select(this.selected + 1);
                                        }
                                    },
                                    kind: 'init',
                                    order: '8'
                                }
                            ]
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'contents',
                            loc: {
                                start: {
                                    line: 129,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/Stepper.ion'
                                },
                                end: {
                                    line: 129,
                                    column: 16,
                                    fixed: true,
                                    source: 'glass/html/material/Stepper.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'ArrayExpression',
                                elements: []
                            },
                            properties: [{
                                    type: 'ForOfStatement',
                                    left: {
                                        type: 'VariableDeclaration',
                                        declarations: [{
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'tab',
                                                    loc: {
                                                        start: {
                                                            line: 129,
                                                            column: 45,
                                                            fixed: true,
                                                            source: 'glass/html/material/Stepper.ion'
                                                        },
                                                        end: {
                                                            line: 129,
                                                            column: 48,
                                                            fixed: true,
                                                            source: 'glass/html/material/Stepper.ion'
                                                        }
                                                    }
                                                },
                                                init: null
                                            }],
                                        kind: 'let'
                                    },
                                    right: {
                                        type: 'Identifier',
                                        name: 'tabs',
                                        loc: {
                                            start: {
                                                line: 129,
                                                column: 52,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            },
                                            end: {
                                                line: 129,
                                                column: 56,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            }
                                        }
                                    },
                                    body: {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'tab',
                                                    loc: {
                                                        start: {
                                                            line: 129,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'glass/html/material/Stepper.ion'
                                                        },
                                                        end: {
                                                            line: 129,
                                                            column: 23,
                                                            fixed: true,
                                                            source: 'glass/html/material/Stepper.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'content',
                                                    loc: {
                                                        start: {
                                                            line: 129,
                                                            column: 24,
                                                            fixed: true,
                                                            source: 'glass/html/material/Stepper.ion'
                                                        },
                                                        end: {
                                                            line: 129,
                                                            column: 31,
                                                            fixed: true,
                                                            source: 'glass/html/material/Stepper.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 129,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'glass/html/material/Stepper.ion'
                                                    },
                                                    end: {
                                                        line: 129,
                                                        column: 31,
                                                        fixed: true,
                                                        source: 'glass/html/material/Stepper.ion'
                                                    }
                                                }
                                            },
                                            arguments: [{
                                                    type: 'Identifier',
                                                    name: 'stepper',
                                                    loc: {
                                                        start: {
                                                            line: 129,
                                                            column: 32,
                                                            fixed: true,
                                                            source: 'glass/html/material/Stepper.ion'
                                                        },
                                                        end: {
                                                            line: 129,
                                                            column: 39,
                                                            fixed: true,
                                                            source: 'glass/html/material/Stepper.ion'
                                                        }
                                                    }
                                                }],
                                            loc: {
                                                start: {
                                                    line: 129,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'glass/html/material/Stepper.ion'
                                                },
                                                end: {
                                                    line: 129,
                                                    column: 40,
                                                    fixed: true,
                                                    source: 'glass/html/material/Stepper.ion'
                                                }
                                            }
                                        }
                                    },
                                    order: '0'
                                }]
                        }
                    }],
                kind: 'let',
                order: '3'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'CallExpression',
                        callee: {
                            type: 'Identifier',
                            name: 'Div',
                            loc: {
                                start: {
                                    line: 131,
                                    column: 11,
                                    fixed: true,
                                    source: 'glass/html/material/Stepper.ion'
                                },
                                end: {
                                    line: 131,
                                    column: 14,
                                    fixed: true,
                                    source: 'glass/html/material/Stepper.ion'
                                }
                            }
                        },
                        arguments: [{
                                type: 'ObjectExpression',
                                properties: [{
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'class',
                                            loc: {
                                                start: {
                                                    line: 131,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/html/material/Stepper.ion'
                                                },
                                                end: {
                                                    line: 131,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'glass/html/material/Stepper.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: 'Stepper layout vertical flex'
                                        },
                                        kind: 'init',
                                        order: '0'
                                    }]
                            }],
                        loc: {
                            start: {
                                line: 131,
                                column: 11,
                                fixed: true,
                                source: 'glass/html/material/Stepper.ion'
                            },
                            end: {
                                line: 131,
                                column: 55,
                                fixed: true,
                                source: 'glass/html/material/Stepper.ion'
                            }
                        }
                    },
                    properties: [
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'Identifier',
                                        name: 'StepperTabs',
                                        loc: {
                                            start: {
                                                line: 132,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            },
                                            end: {
                                                line: 132,
                                                column: 19,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            }
                                        }
                                    },
                                    arguments: [],
                                    loc: {
                                        start: {
                                            line: 132,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/Stepper.ion'
                                        },
                                        end: {
                                            line: 132,
                                            column: 21,
                                            fixed: true,
                                            source: 'glass/html/material/Stepper.ion'
                                        }
                                    }
                                },
                                properties: [{
                                        type: 'ForOfStatement',
                                        left: {
                                            type: 'VariableDeclaration',
                                            declarations: [
                                                {
                                                    type: 'VariableDeclarator',
                                                    id: {
                                                        type: 'Identifier',
                                                        name: 'tab',
                                                        loc: {
                                                            start: {
                                                                line: 133,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'glass/html/material/Stepper.ion'
                                                            },
                                                            end: {
                                                                line: 133,
                                                                column: 23,
                                                                fixed: true,
                                                                source: 'glass/html/material/Stepper.ion'
                                                            }
                                                        }
                                                    },
                                                    init: null
                                                },
                                                {
                                                    type: 'VariableDeclarator',
                                                    id: {
                                                        type: 'Identifier',
                                                        name: 'index',
                                                        loc: {
                                                            start: {
                                                                line: 133,
                                                                column: 25,
                                                                fixed: true,
                                                                source: 'glass/html/material/Stepper.ion'
                                                            },
                                                            end: {
                                                                line: 133,
                                                                column: 30,
                                                                fixed: true,
                                                                source: 'glass/html/material/Stepper.ion'
                                                            }
                                                        }
                                                    },
                                                    init: null
                                                }
                                            ],
                                            kind: 'let'
                                        },
                                        right: {
                                            type: 'Identifier',
                                            name: 'tabs',
                                            loc: {
                                                start: {
                                                    line: 133,
                                                    column: 34,
                                                    fixed: true,
                                                    source: 'glass/html/material/Stepper.ion'
                                                },
                                                end: {
                                                    line: 133,
                                                    column: 38,
                                                    fixed: true,
                                                    source: 'glass/html/material/Stepper.ion'
                                                }
                                            }
                                        },
                                        body: {
                                            type: 'BlockStatement',
                                            body: [
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'Identifier',
                                                            name: 'StepperTab',
                                                            loc: {
                                                                start: {
                                                                    line: 134,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Stepper.ion'
                                                                },
                                                                end: {
                                                                    line: 134,
                                                                    column: 26,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Stepper.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [
                                                            {
                                                                type: 'Identifier',
                                                                name: 'tab',
                                                                loc: {
                                                                    start: {
                                                                        line: 134,
                                                                        column: 27,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Stepper.ion'
                                                                    },
                                                                    end: {
                                                                        line: 134,
                                                                        column: 30,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Stepper.ion'
                                                                    }
                                                                }
                                                            },
                                                            {
                                                                type: 'Identifier',
                                                                name: 'index',
                                                                loc: {
                                                                    start: {
                                                                        line: 134,
                                                                        column: 32,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Stepper.ion'
                                                                    },
                                                                    end: {
                                                                        line: 134,
                                                                        column: 37,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Stepper.ion'
                                                                    }
                                                                }
                                                            },
                                                            {
                                                                type: 'Identifier',
                                                                name: 'stepper',
                                                                loc: {
                                                                    start: {
                                                                        line: 134,
                                                                        column: 39,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Stepper.ion'
                                                                    },
                                                                    end: {
                                                                        line: 134,
                                                                        column: 46,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Stepper.ion'
                                                                    }
                                                                }
                                                            }
                                                        ],
                                                        loc: {
                                                            start: {
                                                                line: 134,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/Stepper.ion'
                                                            },
                                                            end: {
                                                                line: 134,
                                                                column: 47,
                                                                fixed: true,
                                                                source: 'glass/html/material/Stepper.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 134,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/Stepper.ion'
                                                        },
                                                        end: {
                                                            line: 134,
                                                            column: 47,
                                                            fixed: true,
                                                            source: 'glass/html/material/Stepper.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                },
                                                {
                                                    type: 'IfStatement',
                                                    test: {
                                                        type: 'BinaryExpression',
                                                        operator: '!==',
                                                        left: {
                                                            type: 'Identifier',
                                                            name: 'index',
                                                            loc: {
                                                                start: {
                                                                    line: 135,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Stepper.ion'
                                                                },
                                                                end: {
                                                                    line: 135,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Stepper.ion'
                                                                }
                                                            }
                                                        },
                                                        right: {
                                                            type: 'BinaryExpression',
                                                            operator: '-',
                                                            left: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'tabs',
                                                                    loc: {
                                                                        start: {
                                                                            line: 135,
                                                                            column: 30,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Stepper.ion'
                                                                        },
                                                                        end: {
                                                                            line: 135,
                                                                            column: 34,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Stepper.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'length',
                                                                    loc: {
                                                                        start: {
                                                                            line: 135,
                                                                            column: 35,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Stepper.ion'
                                                                        },
                                                                        end: {
                                                                            line: 135,
                                                                            column: 41,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Stepper.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 135,
                                                                        column: 30,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Stepper.ion'
                                                                    },
                                                                    end: {
                                                                        line: 135,
                                                                        column: 41,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Stepper.ion'
                                                                    }
                                                                }
                                                            },
                                                            right: {
                                                                type: 'Literal',
                                                                value: 1
                                                            }
                                                        }
                                                    },
                                                    consequent: {
                                                        type: 'BlockStatement',
                                                        body: [{
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'Identifier',
                                                                        name: 'Line',
                                                                        loc: {
                                                                            start: {
                                                                                line: 136,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Stepper.ion'
                                                                            },
                                                                            end: {
                                                                                line: 136,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Stepper.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [],
                                                                    loc: {
                                                                        start: {
                                                                            line: 136,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Stepper.ion'
                                                                        },
                                                                        end: {
                                                                            line: 136,
                                                                            column: 26,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Stepper.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 136,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Stepper.ion'
                                                                    },
                                                                    end: {
                                                                        line: 136,
                                                                        column: 26,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Stepper.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    alternate: null,
                                                    order: '1'
                                                }
                                            ]
                                        },
                                        remove: null,
                                        order: '0'
                                    }]
                            },
                            loc: {
                                start: {
                                    line: 132,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/Stepper.ion'
                                },
                                end: {
                                    line: 138,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/Stepper.ion'
                                }
                            },
                            order: '0'
                        },
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'Identifier',
                                        name: 'Div',
                                        loc: {
                                            start: {
                                                line: 138,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            },
                                            end: {
                                                line: 138,
                                                column: 11,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            }
                                        }
                                    },
                                    arguments: [{
                                            type: 'ObjectExpression',
                                            properties: [{
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'class',
                                                        loc: {
                                                            start: {
                                                                line: 138,
                                                                column: 13,
                                                                fixed: true,
                                                                source: 'glass/html/material/Stepper.ion'
                                                            },
                                                            end: {
                                                                line: 138,
                                                                column: 18,
                                                                fixed: true,
                                                                source: 'glass/html/material/Stepper.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 'fill'
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                }]
                                        }],
                                    loc: {
                                        start: {
                                            line: 138,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/Stepper.ion'
                                        },
                                        end: {
                                            line: 138,
                                            column: 27,
                                            fixed: true,
                                            source: 'glass/html/material/Stepper.ion'
                                        }
                                    }
                                },
                                properties: [
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'style',
                                            loc: {
                                                start: {
                                                    line: 139,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/Stepper.ion'
                                                },
                                                end: {
                                                    line: 139,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'glass/html/material/Stepper.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'ObjectExpression',
                                            properties: [
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'position',
                                                        loc: {
                                                            start: {
                                                                line: 140,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/Stepper.ion'
                                                            },
                                                            end: {
                                                                line: 140,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'glass/html/material/Stepper.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 'relative'
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'overflow',
                                                        loc: {
                                                            start: {
                                                                line: 141,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/Stepper.ion'
                                                            },
                                                            end: {
                                                                line: 141,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'glass/html/material/Stepper.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 'hidden'
                                                    },
                                                    kind: 'init',
                                                    order: '1'
                                                }
                                            ]
                                        },
                                        kind: 'init',
                                        order: '0'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'ObjectExpression',
                                            objectType: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'Div',
                                                    loc: {
                                                        start: {
                                                            line: 142,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Stepper.ion'
                                                        },
                                                        end: {
                                                            line: 142,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Stepper.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [{
                                                        type: 'ObjectExpression',
                                                        properties: [{
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'class',
                                                                    loc: {
                                                                        start: {
                                                                            line: 142,
                                                                            column: 17,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Stepper.ion'
                                                                        },
                                                                        end: {
                                                                            line: 142,
                                                                            column: 22,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Stepper.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: 'transition'
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            }]
                                                    }],
                                                loc: {
                                                    start: {
                                                        line: 142,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/Stepper.ion'
                                                    },
                                                    end: {
                                                        line: 142,
                                                        column: 37,
                                                        fixed: true,
                                                        source: 'glass/html/material/Stepper.ion'
                                                    }
                                                }
                                            },
                                            properties: [
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'style',
                                                        loc: {
                                                            start: {
                                                                line: 144,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/Stepper.ion'
                                                            },
                                                            end: {
                                                                line: 144,
                                                                column: 21,
                                                                fixed: true,
                                                                source: 'glass/html/material/Stepper.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'ObjectExpression',
                                                        properties: [
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'position',
                                                                    loc: {
                                                                        start: {
                                                                            line: 145,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Stepper.ion'
                                                                        },
                                                                        end: {
                                                                            line: 145,
                                                                            column: 28,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Stepper.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: 'absolute'
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'left',
                                                                    loc: {
                                                                        start: {
                                                                            line: 146,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Stepper.ion'
                                                                        },
                                                                        end: {
                                                                            line: 146,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Stepper.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '+',
                                                                    left: {
                                                                        type: 'BinaryExpression',
                                                                        operator: '+',
                                                                        left: {
                                                                            type: 'Literal',
                                                                            value: ''
                                                                        },
                                                                        right: {
                                                                            type: 'BinaryExpression',
                                                                            operator: '*',
                                                                            left: {
                                                                                type: 'UnaryExpression',
                                                                                operator: '-',
                                                                                argument: {
                                                                                    type: 'Literal',
                                                                                    value: 100
                                                                                }
                                                                            },
                                                                            right: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'Identifier',
                                                                                    name: 'stepper',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 146,
                                                                                            column: 36,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Stepper.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 146,
                                                                                            column: 43,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Stepper.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'selected',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 146,
                                                                                            column: 44,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Stepper.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 146,
                                                                                            column: 52,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Stepper.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 146,
                                                                                        column: 36,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Stepper.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 146,
                                                                                        column: 52,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Stepper.ion'
                                                                                    }
                                                                                }
                                                                            }
                                                                        }
                                                                    },
                                                                    right: {
                                                                        type: 'Literal',
                                                                        value: '%'
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '1'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'width',
                                                                    loc: {
                                                                        start: {
                                                                            line: 147,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Stepper.ion'
                                                                        },
                                                                        end: {
                                                                            line: 147,
                                                                            column: 25,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Stepper.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: '100%'
                                                                },
                                                                kind: 'init',
                                                                order: '2'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'height',
                                                                    loc: {
                                                                        start: {
                                                                            line: 148,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Stepper.ion'
                                                                        },
                                                                        end: {
                                                                            line: 148,
                                                                            column: 26,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Stepper.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: '100%'
                                                                },
                                                                kind: 'init',
                                                                order: '3'
                                                            }
                                                        ]
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'ForOfStatement',
                                                    left: {
                                                        type: 'VariableDeclaration',
                                                        declarations: [
                                                            {
                                                                type: 'VariableDeclarator',
                                                                id: {
                                                                    type: 'Identifier',
                                                                    name: 'content',
                                                                    loc: {
                                                                        start: {
                                                                            line: 149,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Stepper.ion'
                                                                        },
                                                                        end: {
                                                                            line: 149,
                                                                            column: 31,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Stepper.ion'
                                                                        }
                                                                    }
                                                                },
                                                                init: null
                                                            },
                                                            {
                                                                type: 'VariableDeclarator',
                                                                id: {
                                                                    type: 'Identifier',
                                                                    name: 'index',
                                                                    loc: {
                                                                        start: {
                                                                            line: 149,
                                                                            column: 33,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Stepper.ion'
                                                                        },
                                                                        end: {
                                                                            line: 149,
                                                                            column: 38,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/Stepper.ion'
                                                                        }
                                                                    }
                                                                },
                                                                init: null
                                                            }
                                                        ],
                                                        kind: 'let'
                                                    },
                                                    right: {
                                                        type: 'Identifier',
                                                        name: 'contents',
                                                        loc: {
                                                            start: {
                                                                line: 149,
                                                                column: 42,
                                                                fixed: true,
                                                                source: 'glass/html/material/Stepper.ion'
                                                            },
                                                            end: {
                                                                line: 149,
                                                                column: 50,
                                                                fixed: true,
                                                                source: 'glass/html/material/Stepper.ion'
                                                            }
                                                        }
                                                    },
                                                    body: {
                                                        type: 'BlockStatement',
                                                        body: [{
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'ObjectExpression',
                                                                    objectType: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'Identifier',
                                                                            name: 'Div',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 150,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Stepper.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 150,
                                                                                    column: 23,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Stepper.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [{
                                                                                type: 'ObjectExpression',
                                                                                properties: [{
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'class',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 150,
                                                                                                    column: 25,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Stepper.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 150,
                                                                                                    column: 30,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Stepper.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 'layout vertical flex'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    }]
                                                                            }],
                                                                        loc: {
                                                                            start: {
                                                                                line: 150,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Stepper.ion'
                                                                            },
                                                                            end: {
                                                                                line: 150,
                                                                                column: 55,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Stepper.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    properties: [
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'style',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 151,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Stepper.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 151,
                                                                                        column: 29,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Stepper.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'ObjectExpression',
                                                                                properties: [
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'position',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 152,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Stepper.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 152,
                                                                                                    column: 36,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Stepper.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 'absolute'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'width',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 153,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Stepper.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 153,
                                                                                                    column: 33,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Stepper.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: '100%'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '1'
                                                                                    },
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'height',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 154,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Stepper.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 154,
                                                                                                    column: 34,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Stepper.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: '100%'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '2'
                                                                                    },
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'left',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 155,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Stepper.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 155,
                                                                                                    column: 32,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Stepper.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'BinaryExpression',
                                                                                            operator: '+',
                                                                                            left: {
                                                                                                type: 'BinaryExpression',
                                                                                                operator: '+',
                                                                                                left: {
                                                                                                    type: 'Literal',
                                                                                                    value: ''
                                                                                                },
                                                                                                right: {
                                                                                                    type: 'BinaryExpression',
                                                                                                    operator: '*',
                                                                                                    left: {
                                                                                                        type: 'Literal',
                                                                                                        value: 100
                                                                                                    },
                                                                                                    right: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'index',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 155,
                                                                                                                column: 43,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/Stepper.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 155,
                                                                                                                column: 48,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/Stepper.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            right: {
                                                                                                type: 'Literal',
                                                                                                value: '%'
                                                                                            }
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '3'
                                                                                    }
                                                                                ]
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'Identifier',
                                                                                name: 'content',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 156,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Stepper.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 156,
                                                                                        column: 31,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Stepper.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 156,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Stepper.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 156,
                                                                                    column: 31,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Stepper.ion'
                                                                                }
                                                                            },
                                                                            order: '1'
                                                                        }
                                                                    ]
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 150,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Stepper.ion'
                                                                    },
                                                                    end: {
                                                                        line: 158,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Stepper.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    remove: null,
                                                    order: '1'
                                                }
                                            ]
                                        },
                                        loc: {
                                            start: {
                                                line: 142,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            },
                                            end: {
                                                line: 158,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/Stepper.ion'
                                            }
                                        },
                                        order: '1'
                                    }
                                ]
                            },
                            loc: {
                                start: {
                                    line: 138,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/Stepper.ion'
                                },
                                end: {
                                    line: 158,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/Stepper.ion'
                                }
                            },
                            order: '1'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'focus',
                                loc: {
                                    start: {
                                        line: 158,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/Stepper.ion'
                                    },
                                    end: {
                                        line: 158,
                                        column: 13,
                                        fixed: true,
                                        source: 'glass/html/material/Stepper.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context6) {
                                    return function () {
                                        var contents = _context6.get('contents'), stepper = _context6.get('stepper');
                                        contents[stepper.selected].focus();
                                    };
                                }
                            },
                            kind: 'init',
                            order: '2'
                        }
                    ]
                },
                order: '4'
            }
        ],
        bound: false
    }, {
        this: this,
        args: args,
        style: style,
        StepperTabs: StepperTabs,
        Line: Line,
        StepperTab: StepperTab
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/Stepper',_glass_html_material_Stepper_);
    else
      _glass_html_material_Stepper_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_Stepper_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_SuggestMenu_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('./'), _ref2, navigation = {
        38: -1,
        40: +1
    };
var Menu = _ref.Menu;
_ref2 = require('../../language');
var getMatch = _ref2.getMatch;
module.exports = exports = ion.template(function (_ref3) {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'control',
                            loc: {
                                start: {
                                    line: 7,
                                    column: 18,
                                    fixed: true,
                                    source: 'glass/html/material/SuggestMenu.ion'
                                },
                                end: {
                                    line: 7,
                                    column: 25,
                                    fixed: true,
                                    source: 'glass/html/material/SuggestMenu.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'control',
                                loc: {
                                    start: {
                                        line: 7,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/material/SuggestMenu.ion'
                                    },
                                    end: {
                                        line: 7,
                                        column: 25,
                                        fixed: true,
                                        source: 'glass/html/material/SuggestMenu.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'suggestText',
                            loc: {
                                start: {
                                    line: 7,
                                    column: 27,
                                    fixed: true,
                                    source: 'glass/html/material/SuggestMenu.ion'
                                },
                                end: {
                                    line: 7,
                                    column: 38,
                                    fixed: true,
                                    source: 'glass/html/material/SuggestMenu.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'suggestText',
                                loc: {
                                    start: {
                                        line: 7,
                                        column: 27,
                                        fixed: true,
                                        source: 'glass/html/material/SuggestMenu.ion'
                                    },
                                    end: {
                                        line: 7,
                                        column: 38,
                                        fixed: true,
                                        source: 'glass/html/material/SuggestMenu.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'suggestFunction',
                            loc: {
                                start: {
                                    line: 7,
                                    column: 40,
                                    fixed: true,
                                    source: 'glass/html/material/SuggestMenu.ion'
                                },
                                end: {
                                    line: 7,
                                    column: 55,
                                    fixed: true,
                                    source: 'glass/html/material/SuggestMenu.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'suggestFunction',
                                loc: {
                                    start: {
                                        line: 7,
                                        column: 40,
                                        fixed: true,
                                        source: 'glass/html/material/SuggestMenu.ion'
                                    },
                                    end: {
                                        line: 7,
                                        column: 55,
                                        fixed: true,
                                        source: 'glass/html/material/SuggestMenu.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'required',
                            loc: {
                                start: {
                                    line: 7,
                                    column: 57,
                                    fixed: true,
                                    source: 'glass/html/material/SuggestMenu.ion'
                                },
                                end: {
                                    line: 7,
                                    column: 65,
                                    fixed: true,
                                    source: 'glass/html/material/SuggestMenu.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'required',
                                loc: {
                                    start: {
                                        line: 7,
                                        column: 57,
                                        fixed: true,
                                        source: 'glass/html/material/SuggestMenu.ion'
                                    },
                                    end: {
                                        line: 7,
                                        column: 65,
                                        fixed: true,
                                        source: 'glass/html/material/SuggestMenu.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '3'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'visible',
                            loc: {
                                start: {
                                    line: 7,
                                    column: 67,
                                    fixed: true,
                                    source: 'glass/html/material/SuggestMenu.ion'
                                },
                                end: {
                                    line: 7,
                                    column: 74,
                                    fixed: true,
                                    source: 'glass/html/material/SuggestMenu.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'visible',
                                loc: {
                                    start: {
                                        line: 7,
                                        column: 67,
                                        fixed: true,
                                        source: 'glass/html/material/SuggestMenu.ion'
                                    },
                                    end: {
                                        line: 7,
                                        column: 74,
                                        fixed: true,
                                        source: 'glass/html/material/SuggestMenu.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '4'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'callback',
                            loc: {
                                start: {
                                    line: 7,
                                    column: 76,
                                    fixed: true,
                                    source: 'glass/html/material/SuggestMenu.ion'
                                },
                                end: {
                                    line: 7,
                                    column: 84,
                                    fixed: true,
                                    source: 'glass/html/material/SuggestMenu.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'callback',
                                loc: {
                                    start: {
                                        line: 7,
                                        column: 76,
                                        fixed: true,
                                        source: 'glass/html/material/SuggestMenu.ion'
                                    },
                                    end: {
                                        line: 7,
                                        column: 84,
                                        fixed: true,
                                        source: 'glass/html/material/SuggestMenu.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '5'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'matchText',
                            loc: {
                                start: {
                                    line: 8,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/SuggestMenu.ion'
                                },
                                end: {
                                    line: 8,
                                    column: 17,
                                    fixed: true,
                                    source: 'glass/html/material/SuggestMenu.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ConditionalExpression',
                            test: {
                                type: 'BinaryExpression',
                                operator: '!=',
                                left: {
                                    type: 'Identifier',
                                    name: 'suggestText',
                                    loc: {
                                        start: {
                                            line: 8,
                                            column: 20,
                                            fixed: true,
                                            source: 'glass/html/material/SuggestMenu.ion'
                                        },
                                        end: {
                                            line: 8,
                                            column: 31,
                                            fixed: true,
                                            source: 'glass/html/material/SuggestMenu.ion'
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: null
                                }
                            },
                            consequent: {
                                type: 'Identifier',
                                name: 'suggestText',
                                loc: {
                                    start: {
                                        line: 8,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/SuggestMenu.ion'
                                    },
                                    end: {
                                        line: 8,
                                        column: 31,
                                        fixed: true,
                                        source: 'glass/html/material/SuggestMenu.ion'
                                    }
                                }
                            },
                            alternate: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'control',
                                    loc: {
                                        start: {
                                            line: 8,
                                            column: 34,
                                            fixed: true,
                                            source: 'glass/html/material/SuggestMenu.ion'
                                        },
                                        end: {
                                            line: 8,
                                            column: 41,
                                            fixed: true,
                                            source: 'glass/html/material/SuggestMenu.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'value',
                                    loc: {
                                        start: {
                                            line: 8,
                                            column: 43,
                                            fixed: true,
                                            source: 'glass/html/material/SuggestMenu.ion'
                                        },
                                        end: {
                                            line: 8,
                                            column: 48,
                                            fixed: true,
                                            source: 'glass/html/material/SuggestMenu.ion'
                                        }
                                    }
                                },
                                existential: true,
                                loc: {
                                    start: {
                                        line: 8,
                                        column: 34,
                                        fixed: true,
                                        source: 'glass/html/material/SuggestMenu.ion'
                                    },
                                    end: {
                                        line: 8,
                                        column: 48,
                                        fixed: true,
                                        source: 'glass/html/material/SuggestMenu.ion'
                                    }
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '6'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'suggestions',
                            loc: {
                                start: {
                                    line: 9,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/SuggestMenu.ion'
                                },
                                end: {
                                    line: 9,
                                    column: 19,
                                    fixed: true,
                                    source: 'glass/html/material/SuggestMenu.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ConditionalExpression',
                            test: {
                                type: 'BinaryExpression',
                                operator: '!=',
                                left: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'Identifier',
                                        name: 'suggestFunction',
                                        loc: {
                                            start: {
                                                line: 9,
                                                column: 22,
                                                fixed: true,
                                                source: 'glass/html/material/SuggestMenu.ion'
                                            },
                                            end: {
                                                line: 9,
                                                column: 37,
                                                fixed: true,
                                                source: 'glass/html/material/SuggestMenu.ion'
                                            }
                                        }
                                    },
                                    arguments: [{
                                            type: 'Identifier',
                                            name: 'matchText',
                                            loc: {
                                                start: {
                                                    line: 9,
                                                    column: 39,
                                                    fixed: true,
                                                    source: 'glass/html/material/SuggestMenu.ion'
                                                },
                                                end: {
                                                    line: 9,
                                                    column: 48,
                                                    fixed: true,
                                                    source: 'glass/html/material/SuggestMenu.ion'
                                                }
                                            }
                                        }],
                                    existential: true,
                                    loc: {
                                        start: {
                                            line: 9,
                                            column: 22,
                                            fixed: true,
                                            source: 'glass/html/material/SuggestMenu.ion'
                                        },
                                        end: {
                                            line: 9,
                                            column: 49,
                                            fixed: true,
                                            source: 'glass/html/material/SuggestMenu.ion'
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: null
                                }
                            },
                            consequent: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'suggestFunction',
                                    loc: {
                                        start: {
                                            line: 9,
                                            column: 22,
                                            fixed: true,
                                            source: 'glass/html/material/SuggestMenu.ion'
                                        },
                                        end: {
                                            line: 9,
                                            column: 37,
                                            fixed: true,
                                            source: 'glass/html/material/SuggestMenu.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'Identifier',
                                        name: 'matchText',
                                        loc: {
                                            start: {
                                                line: 9,
                                                column: 39,
                                                fixed: true,
                                                source: 'glass/html/material/SuggestMenu.ion'
                                            },
                                            end: {
                                                line: 9,
                                                column: 48,
                                                fixed: true,
                                                source: 'glass/html/material/SuggestMenu.ion'
                                            }
                                        }
                                    }],
                                existential: true,
                                loc: {
                                    start: {
                                        line: 9,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/material/SuggestMenu.ion'
                                    },
                                    end: {
                                        line: 9,
                                        column: 49,
                                        fixed: true,
                                        source: 'glass/html/material/SuggestMenu.ion'
                                    }
                                }
                            },
                            alternate: {
                                type: 'ArrayExpression',
                                elements: []
                            }
                        }
                    }],
                kind: 'let',
                order: '7'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'currentMatch',
                            loc: {
                                start: {
                                    line: 10,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/SuggestMenu.ion'
                                },
                                end: {
                                    line: 10,
                                    column: 20,
                                    fixed: true,
                                    source: 'glass/html/material/SuggestMenu.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'getMatch',
                                loc: {
                                    start: {
                                        line: 10,
                                        column: 23,
                                        fixed: true,
                                        source: 'glass/html/material/SuggestMenu.ion'
                                    },
                                    end: {
                                        line: 10,
                                        column: 31,
                                        fixed: true,
                                        source: 'glass/html/material/SuggestMenu.ion'
                                    }
                                }
                            },
                            arguments: [
                                {
                                    type: 'Identifier',
                                    name: 'suggestions',
                                    loc: {
                                        start: {
                                            line: 10,
                                            column: 32,
                                            fixed: true,
                                            source: 'glass/html/material/SuggestMenu.ion'
                                        },
                                        end: {
                                            line: 10,
                                            column: 43,
                                            fixed: true,
                                            source: 'glass/html/material/SuggestMenu.ion'
                                        }
                                    }
                                },
                                {
                                    type: 'Identifier',
                                    name: 'matchText',
                                    loc: {
                                        start: {
                                            line: 10,
                                            column: 45,
                                            fixed: true,
                                            source: 'glass/html/material/SuggestMenu.ion'
                                        },
                                        end: {
                                            line: 10,
                                            column: 54,
                                            fixed: true,
                                            source: 'glass/html/material/SuggestMenu.ion'
                                        }
                                    }
                                },
                                {
                                    type: 'ArrayExpression',
                                    elements: [{
                                            type: 'Literal',
                                            value: 'content'
                                        }]
                                },
                                {
                                    type: 'Identifier',
                                    name: 'required',
                                    loc: {
                                        start: {
                                            line: 10,
                                            column: 69,
                                            fixed: true,
                                            source: 'glass/html/material/SuggestMenu.ion'
                                        },
                                        end: {
                                            line: 10,
                                            column: 77,
                                            fixed: true,
                                            source: 'glass/html/material/SuggestMenu.ion'
                                        }
                                    }
                                }
                            ],
                            loc: {
                                start: {
                                    line: 10,
                                    column: 23,
                                    fixed: true,
                                    source: 'glass/html/material/SuggestMenu.ion'
                                },
                                end: {
                                    line: 10,
                                    column: 78,
                                    fixed: true,
                                    source: 'glass/html/material/SuggestMenu.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '8'
            },
            {
                type: 'ExpressionStatement',
                expression: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'Identifier',
                        name: 'control',
                        loc: {
                            start: {
                                line: 11,
                                column: 4,
                                fixed: true,
                                source: 'glass/html/material/SuggestMenu.ion'
                            },
                            end: {
                                line: 11,
                                column: 11,
                                fixed: true,
                                source: 'glass/html/material/SuggestMenu.ion'
                            }
                        }
                    },
                    properties: [{
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'Function',
                                context: true,
                                value: function (_context) {
                                    return function keydown(e) {
                                        var navigation = _context.get('navigation'), currentMatch = _context.get('currentMatch'), suggestions = _context.get('suggestions'), control = _context.get('control');
                                        var nav = navigation[e.keyCode];
                                        if (nav != null) {
                                            var newIndex = currentMatch + nav;
                                            var newSuggestion = suggestions[newIndex];
                                            if (newSuggestion != null) {
                                                control.valueJSON = newIndex;
                                                control.select();
                                                control.dispatchEvent(new CustomEvent('input'));
                                            }
                                            e.preventDefault();
                                        }
                                    };
                                }
                            },
                            loc: {
                                start: {
                                    line: 12,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/SuggestMenu.ion'
                                },
                                end: {
                                    line: 22,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/SuggestMenu.ion'
                                }
                            },
                            order: '0'
                        }]
                },
                loc: {
                    start: {
                        line: 11,
                        column: 4,
                        fixed: true,
                        source: 'glass/html/material/SuggestMenu.ion'
                    },
                    end: {
                        line: 22,
                        column: 8,
                        fixed: true,
                        source: 'glass/html/material/SuggestMenu.ion'
                    }
                },
                order: '9'
            },
            {
                type: 'ExpressionStatement',
                expression: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'MemberExpression',
                        computed: false,
                        object: {
                            type: 'Identifier',
                            name: 'document',
                            loc: {
                                start: {
                                    line: 22,
                                    column: 4,
                                    fixed: true,
                                    source: 'glass/html/material/SuggestMenu.ion'
                                },
                                end: {
                                    line: 22,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/SuggestMenu.ion'
                                }
                            }
                        },
                        property: {
                            type: 'Identifier',
                            name: 'body',
                            loc: {
                                start: {
                                    line: 22,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/html/material/SuggestMenu.ion'
                                },
                                end: {
                                    line: 22,
                                    column: 17,
                                    fixed: true,
                                    source: 'glass/html/material/SuggestMenu.ion'
                                }
                            }
                        },
                        loc: {
                            start: {
                                line: 22,
                                column: 4,
                                fixed: true,
                                source: 'glass/html/material/SuggestMenu.ion'
                            },
                            end: {
                                line: 22,
                                column: 17,
                                fixed: true,
                                source: 'glass/html/material/SuggestMenu.ion'
                            }
                        }
                    },
                    properties: [
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'rows',
                                        loc: {
                                            start: {
                                                line: 23,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/SuggestMenu.ion'
                                            },
                                            end: {
                                                line: 23,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/SuggestMenu.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'ObjectExpression',
                                        objectType: {
                                            type: 'ArrayExpression',
                                            elements: []
                                        },
                                        properties: [{
                                                type: 'ForOfStatement',
                                                left: {
                                                    type: 'VariableDeclaration',
                                                    declarations: [
                                                        {
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'suggestion',
                                                                loc: {
                                                                    start: {
                                                                        line: 24,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/SuggestMenu.ion'
                                                                    },
                                                                    end: {
                                                                        line: 24,
                                                                        column: 26,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/SuggestMenu.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: null
                                                        },
                                                        {
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'index',
                                                                loc: {
                                                                    start: {
                                                                        line: 24,
                                                                        column: 28,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/SuggestMenu.ion'
                                                                    },
                                                                    end: {
                                                                        line: 24,
                                                                        column: 33,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/SuggestMenu.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: null
                                                        }
                                                    ],
                                                    kind: 'let'
                                                },
                                                right: {
                                                    type: 'Identifier',
                                                    name: 'suggestions',
                                                    loc: {
                                                        start: {
                                                            line: 24,
                                                            column: 37,
                                                            fixed: true,
                                                            source: 'glass/html/material/SuggestMenu.ion'
                                                        },
                                                        end: {
                                                            line: 24,
                                                            column: 48,
                                                            fixed: true,
                                                            source: 'glass/html/material/SuggestMenu.ion'
                                                        }
                                                    }
                                                },
                                                body: {
                                                    type: 'BlockStatement',
                                                    body: [{
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'ObjectExpression',
                                                                objectType: {
                                                                    type: 'ObjectExpression',
                                                                    properties: []
                                                                },
                                                                properties: [
                                                                    {
                                                                        type: 'ForInStatement',
                                                                        left: {
                                                                            type: 'VariableDeclaration',
                                                                            declarations: [
                                                                                {
                                                                                    type: 'VariableDeclarator',
                                                                                    id: {
                                                                                        type: 'Identifier',
                                                                                        name: 'key',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 26,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/SuggestMenu.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 26,
                                                                                                column: 27,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/SuggestMenu.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    init: null
                                                                                },
                                                                                {
                                                                                    type: 'VariableDeclarator',
                                                                                    id: {
                                                                                        type: 'Identifier',
                                                                                        name: 'value',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 26,
                                                                                                column: 29,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/SuggestMenu.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 26,
                                                                                                column: 34,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/SuggestMenu.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    init: null
                                                                                }
                                                                            ],
                                                                            kind: 'let'
                                                                        },
                                                                        right: {
                                                                            type: 'Identifier',
                                                                            name: 'suggestion',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 26,
                                                                                    column: 38,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/SuggestMenu.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 26,
                                                                                    column: 48,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/SuggestMenu.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        body: {
                                                                            type: 'BlockStatement',
                                                                            body: [{
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'key',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 27,
                                                                                                column: 25,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/SuggestMenu.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 27,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/SuggestMenu.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Identifier',
                                                                                        name: 'value',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 27,
                                                                                                column: 31,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/SuggestMenu.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 27,
                                                                                                column: 36,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/SuggestMenu.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    computed: true,
                                                                                    order: '0'
                                                                                }]
                                                                        },
                                                                        remove: null,
                                                                        order: '0'
                                                                    },
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'focus',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 28,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/SuggestMenu.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 28,
                                                                                    column: 25,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/SuggestMenu.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'BinaryExpression',
                                                                            operator: '===',
                                                                            left: {
                                                                                type: 'Identifier',
                                                                                name: 'currentMatch',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 28,
                                                                                        column: 27,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/SuggestMenu.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 28,
                                                                                        column: 39,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/SuggestMenu.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            right: {
                                                                                type: 'Identifier',
                                                                                name: 'index',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 28,
                                                                                        column: 43,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/SuggestMenu.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 28,
                                                                                        column: 48,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/SuggestMenu.ion'
                                                                                    }
                                                                                }
                                                                            }
                                                                        },
                                                                        kind: 'init',
                                                                        order: '1'
                                                                    },
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'action',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 29,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/SuggestMenu.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 29,
                                                                                    column: 26,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/SuggestMenu.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Function',
                                                                            context: true,
                                                                            value: function (_context2) {
                                                                                return function () {
                                                                                    var callback = _context2.get('callback'), suggestion = _context2.get('suggestion');
                                                                                    callback != null ? callback(suggestion) : void 0;
                                                                                };
                                                                            }
                                                                        },
                                                                        kind: 'init',
                                                                        order: '2'
                                                                    }
                                                                ]
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 25,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/SuggestMenu.ion'
                                                                },
                                                                end: {
                                                                    line: 31,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/SuggestMenu.ion'
                                                                }
                                                            },
                                                            order: '0'
                                                        }]
                                                },
                                                remove: null,
                                                order: '0'
                                            }]
                                    }
                                }],
                            kind: 'let',
                            order: '0'
                        },
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'Identifier',
                                        name: 'Menu',
                                        loc: {
                                            start: {
                                                line: 31,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/SuggestMenu.ion'
                                            },
                                            end: {
                                                line: 31,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/SuggestMenu.ion'
                                            }
                                        }
                                    },
                                    arguments: [{
                                            type: 'ObjectExpression',
                                            properties: [
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'autoclose',
                                                        loc: {
                                                            start: {
                                                                line: 32,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'glass/html/material/SuggestMenu.ion'
                                                            },
                                                            end: {
                                                                line: 32,
                                                                column: 21,
                                                                fixed: true,
                                                                source: 'glass/html/material/SuggestMenu.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: false
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'autofocus',
                                                        loc: {
                                                            start: {
                                                                line: 33,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'glass/html/material/SuggestMenu.ion'
                                                            },
                                                            end: {
                                                                line: 33,
                                                                column: 21,
                                                                fixed: true,
                                                                source: 'glass/html/material/SuggestMenu.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: false
                                                    },
                                                    kind: 'init',
                                                    order: '1'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'rows',
                                                        loc: {
                                                            start: {
                                                                line: 34,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'glass/html/material/SuggestMenu.ion'
                                                            },
                                                            end: {
                                                                line: 34,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/SuggestMenu.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Identifier',
                                                        name: 'rows',
                                                        loc: {
                                                            start: {
                                                                line: 34,
                                                                column: 18,
                                                                fixed: true,
                                                                source: 'glass/html/material/SuggestMenu.ion'
                                                            },
                                                            end: {
                                                                line: 34,
                                                                column: 22,
                                                                fixed: true,
                                                                source: 'glass/html/material/SuggestMenu.ion'
                                                            }
                                                        }
                                                    },
                                                    kind: 'init',
                                                    order: '2'
                                                }
                                            ]
                                        }],
                                    loc: {
                                        start: {
                                            line: 31,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/SuggestMenu.ion'
                                        },
                                        end: {
                                            line: 35,
                                            column: 9,
                                            fixed: true,
                                            source: 'glass/html/material/SuggestMenu.ion'
                                        }
                                    }
                                },
                                properties: [
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'open',
                                            loc: {
                                                start: {
                                                    line: 36,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/SuggestMenu.ion'
                                                },
                                                end: {
                                                    line: 36,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/html/material/SuggestMenu.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'BinaryExpression',
                                            operator: '>',
                                            left: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'rows',
                                                    loc: {
                                                        start: {
                                                            line: 36,
                                                            column: 18,
                                                            fixed: true,
                                                            source: 'glass/html/material/SuggestMenu.ion'
                                                        },
                                                        end: {
                                                            line: 36,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'glass/html/material/SuggestMenu.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'length',
                                                    loc: {
                                                        start: {
                                                            line: 36,
                                                            column: 23,
                                                            fixed: true,
                                                            source: 'glass/html/material/SuggestMenu.ion'
                                                        },
                                                        end: {
                                                            line: 36,
                                                            column: 29,
                                                            fixed: true,
                                                            source: 'glass/html/material/SuggestMenu.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 36,
                                                        column: 18,
                                                        fixed: true,
                                                        source: 'glass/html/material/SuggestMenu.ion'
                                                    },
                                                    end: {
                                                        line: 36,
                                                        column: 29,
                                                        fixed: true,
                                                        source: 'glass/html/material/SuggestMenu.ion'
                                                    }
                                                }
                                            },
                                            right: {
                                                type: 'Literal',
                                                value: 0
                                            }
                                        },
                                        kind: 'init',
                                        order: '0'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'style',
                                            loc: {
                                                start: {
                                                    line: 37,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/SuggestMenu.ion'
                                                },
                                                end: {
                                                    line: 37,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'glass/html/material/SuggestMenu.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'ObjectExpression',
                                            properties: [
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'visibility',
                                                        loc: {
                                                            start: {
                                                                line: 38,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/SuggestMenu.ion'
                                                            },
                                                            end: {
                                                                line: 38,
                                                                column: 26,
                                                                fixed: true,
                                                                source: 'glass/html/material/SuggestMenu.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'ConditionalExpression',
                                                        test: {
                                                            type: 'BinaryExpression',
                                                            operator: '!==',
                                                            left: {
                                                                type: 'Identifier',
                                                                name: 'visible',
                                                                loc: {
                                                                    start: {
                                                                        line: 38,
                                                                        column: 28,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/SuggestMenu.ion'
                                                                    },
                                                                    end: {
                                                                        line: 38,
                                                                        column: 35,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/SuggestMenu.ion'
                                                                    }
                                                                }
                                                            },
                                                            right: {
                                                                type: 'Literal',
                                                                value: false
                                                            }
                                                        },
                                                        consequent: {
                                                            type: 'Literal',
                                                            value: 'inherit'
                                                        },
                                                        alternate: {
                                                            type: 'Literal',
                                                            value: 'hidden'
                                                        }
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'getRect',
                                                                loc: {
                                                                    start: {
                                                                        line: 40,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/SuggestMenu.ion'
                                                                    },
                                                                    end: {
                                                                        line: 40,
                                                                        column: 27,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/SuggestMenu.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'Function',
                                                                context: true,
                                                                value: function (_context3) {
                                                                    return function () {
                                                                        var control = _context3.get('control');
                                                                        return control.getBoundingClientRect(control.parentElement);
                                                                    };
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '1'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'rect',
                                                                loc: {
                                                                    start: {
                                                                        line: 43,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/SuggestMenu.ion'
                                                                    },
                                                                    end: {
                                                                        line: 43,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/SuggestMenu.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Identifier',
                                                                    name: 'getRect',
                                                                    loc: {
                                                                        start: {
                                                                            line: 43,
                                                                            column: 27,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/SuggestMenu.ion'
                                                                        },
                                                                        end: {
                                                                            line: 43,
                                                                            column: 34,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/SuggestMenu.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [
                                                                    {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'control',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 43,
                                                                                    column: 35,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/SuggestMenu.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 43,
                                                                                    column: 42,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/SuggestMenu.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'offsetLeft',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 43,
                                                                                    column: 43,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/SuggestMenu.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 43,
                                                                                    column: 53,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/SuggestMenu.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 43,
                                                                                column: 35,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/SuggestMenu.ion'
                                                                            },
                                                                            end: {
                                                                                line: 43,
                                                                                column: 53,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/SuggestMenu.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'control',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 43,
                                                                                    column: 55,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/SuggestMenu.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 43,
                                                                                    column: 62,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/SuggestMenu.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'offsetTop',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 43,
                                                                                    column: 63,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/SuggestMenu.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 43,
                                                                                    column: 72,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/SuggestMenu.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 43,
                                                                                column: 55,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/SuggestMenu.ion'
                                                                            },
                                                                            end: {
                                                                                line: 43,
                                                                                column: 72,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/SuggestMenu.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'control',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 43,
                                                                                    column: 74,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/SuggestMenu.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 43,
                                                                                    column: 81,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/SuggestMenu.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'parentElement',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 43,
                                                                                    column: 82,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/SuggestMenu.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 43,
                                                                                    column: 95,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/SuggestMenu.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 43,
                                                                                column: 74,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/SuggestMenu.ion'
                                                                            },
                                                                            end: {
                                                                                line: 43,
                                                                                column: 95,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/SuggestMenu.ion'
                                                                            }
                                                                        }
                                                                    }
                                                                ],
                                                                loc: {
                                                                    start: {
                                                                        line: 43,
                                                                        column: 27,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/SuggestMenu.ion'
                                                                    },
                                                                    end: {
                                                                        line: 43,
                                                                        column: 96,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/SuggestMenu.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '2'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'left',
                                                        loc: {
                                                            start: {
                                                                line: 44,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/SuggestMenu.ion'
                                                            },
                                                            end: {
                                                                line: 44,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'glass/html/material/SuggestMenu.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'BinaryExpression',
                                                        operator: '+',
                                                        left: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'rect',
                                                                loc: {
                                                                    start: {
                                                                        line: 44,
                                                                        column: 22,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/SuggestMenu.ion'
                                                                    },
                                                                    end: {
                                                                        line: 44,
                                                                        column: 26,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/SuggestMenu.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'left',
                                                                loc: {
                                                                    start: {
                                                                        line: 44,
                                                                        column: 27,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/SuggestMenu.ion'
                                                                    },
                                                                    end: {
                                                                        line: 44,
                                                                        column: 31,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/SuggestMenu.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 44,
                                                                    column: 22,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/SuggestMenu.ion'
                                                                },
                                                                end: {
                                                                    line: 44,
                                                                    column: 31,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/SuggestMenu.ion'
                                                                }
                                                            }
                                                        },
                                                        right: {
                                                            type: 'Literal',
                                                            value: 'px'
                                                        }
                                                    },
                                                    kind: 'init',
                                                    order: '3'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'top',
                                                        loc: {
                                                            start: {
                                                                line: 45,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/SuggestMenu.ion'
                                                            },
                                                            end: {
                                                                line: 45,
                                                                column: 19,
                                                                fixed: true,
                                                                source: 'glass/html/material/SuggestMenu.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'BinaryExpression',
                                                        operator: '+',
                                                        left: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'rect',
                                                                loc: {
                                                                    start: {
                                                                        line: 45,
                                                                        column: 21,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/SuggestMenu.ion'
                                                                    },
                                                                    end: {
                                                                        line: 45,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/SuggestMenu.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'bottom',
                                                                loc: {
                                                                    start: {
                                                                        line: 45,
                                                                        column: 26,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/SuggestMenu.ion'
                                                                    },
                                                                    end: {
                                                                        line: 45,
                                                                        column: 32,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/SuggestMenu.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 45,
                                                                    column: 21,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/SuggestMenu.ion'
                                                                },
                                                                end: {
                                                                    line: 45,
                                                                    column: 32,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/SuggestMenu.ion'
                                                                }
                                                            }
                                                        },
                                                        right: {
                                                            type: 'Literal',
                                                            value: 'px'
                                                        }
                                                    },
                                                    kind: 'init',
                                                    order: '4'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'display',
                                                        loc: {
                                                            start: {
                                                                line: 46,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/SuggestMenu.ion'
                                                            },
                                                            end: {
                                                                line: 46,
                                                                column: 23,
                                                                fixed: true,
                                                                source: 'glass/html/material/SuggestMenu.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'ConditionalExpression',
                                                        test: {
                                                            type: 'BinaryExpression',
                                                            operator: '&&',
                                                            left: {
                                                                type: 'UnaryExpression',
                                                                operator: '?',
                                                                argument: {
                                                                    type: 'Identifier',
                                                                    name: 'rect',
                                                                    loc: {
                                                                        start: {
                                                                            line: 46,
                                                                            column: 25,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/SuggestMenu.ion'
                                                                        },
                                                                        end: {
                                                                            line: 46,
                                                                            column: 29,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/SuggestMenu.ion'
                                                                        }
                                                                    }
                                                                }
                                                            },
                                                            right: {
                                                                type: 'BinaryExpression',
                                                                operator: '||',
                                                                left: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '>',
                                                                    left: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'rect',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 46,
                                                                                    column: 36,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/SuggestMenu.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 46,
                                                                                    column: 40,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/SuggestMenu.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'left',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 46,
                                                                                    column: 41,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/SuggestMenu.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 46,
                                                                                    column: 45,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/SuggestMenu.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 46,
                                                                                column: 36,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/SuggestMenu.ion'
                                                                            },
                                                                            end: {
                                                                                line: 46,
                                                                                column: 45,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/SuggestMenu.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    right: {
                                                                        type: 'Literal',
                                                                        value: 0
                                                                    }
                                                                },
                                                                right: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '>',
                                                                    left: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'rect',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 46,
                                                                                    column: 53,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/SuggestMenu.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 46,
                                                                                    column: 57,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/SuggestMenu.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'top',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 46,
                                                                                    column: 58,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/SuggestMenu.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 46,
                                                                                    column: 61,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/SuggestMenu.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 46,
                                                                                column: 53,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/SuggestMenu.ion'
                                                                            },
                                                                            end: {
                                                                                line: 46,
                                                                                column: 61,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/SuggestMenu.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    right: {
                                                                        type: 'Literal',
                                                                        value: 0
                                                                    }
                                                                }
                                                            }
                                                        },
                                                        consequent: {
                                                            type: 'Literal',
                                                            value: 'initial'
                                                        },
                                                        alternate: {
                                                            type: 'Literal',
                                                            value: 'none'
                                                        }
                                                    },
                                                    kind: 'init',
                                                    order: '5'
                                                }
                                            ]
                                        },
                                        kind: 'init',
                                        order: '1'
                                    }
                                ]
                            },
                            loc: {
                                start: {
                                    line: 31,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/SuggestMenu.ion'
                                },
                                end: {
                                    line: 47,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/SuggestMenu.ion'
                                }
                            },
                            order: '1'
                        }
                    ]
                },
                loc: {
                    start: {
                        line: 22,
                        column: 4,
                        fixed: true,
                        source: 'glass/html/material/SuggestMenu.ion'
                    },
                    end: {
                        line: 47,
                        column: 8,
                        fixed: true,
                        source: 'glass/html/material/SuggestMenu.ion'
                    }
                },
                order: ':'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'MemberExpression',
                    computed: true,
                    object: {
                        type: 'Identifier',
                        name: 'suggestions',
                        loc: {
                            start: {
                                line: 47,
                                column: 11,
                                fixed: true,
                                source: 'glass/html/material/SuggestMenu.ion'
                            },
                            end: {
                                line: 47,
                                column: 22,
                                fixed: true,
                                source: 'glass/html/material/SuggestMenu.ion'
                            }
                        }
                    },
                    property: {
                        type: 'Identifier',
                        name: 'currentMatch',
                        loc: {
                            start: {
                                line: 47,
                                column: 23,
                                fixed: true,
                                source: 'glass/html/material/SuggestMenu.ion'
                            },
                            end: {
                                line: 47,
                                column: 35,
                                fixed: true,
                                source: 'glass/html/material/SuggestMenu.ion'
                            }
                        }
                    },
                    loc: {
                        start: {
                            line: 47,
                            column: 11,
                            fixed: true,
                            source: 'glass/html/material/SuggestMenu.ion'
                        },
                        end: {
                            line: 47,
                            column: 36,
                            fixed: true,
                            source: 'glass/html/material/SuggestMenu.ion'
                        }
                    }
                },
                order: ';'
            }
        ],
        bound: false
    }, {
        this: this,
        _ref3: _ref3,
        _ref: _ref,
        _ref2: _ref2,
        navigation: navigation,
        Menu: Menu,
        getMatch: getMatch
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/SuggestMenu',_glass_html_material_SuggestMenu_);
    else
      _glass_html_material_SuggestMenu_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_SuggestMenu_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_Tab_ = function(module,exports,require){'use strict';
var ion = require('ion');
var style = require('../style');
ion.template(function () {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'activeBorderSize',
                            loc: {
                                start: {
                                    line: 5,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/Tab.ion'
                                },
                                end: {
                                    line: 5,
                                    column: 24,
                                    fixed: true,
                                    source: 'glass/html/material/Tab.ion'
                                }
                            }
                        },
                        init: {
                            type: 'Literal',
                            value: 4
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'ExpressionStatement',
                expression: {
                    type: 'CallExpression',
                    callee: {
                        type: 'MemberExpression',
                        computed: false,
                        object: {
                            type: 'Identifier',
                            name: 'style',
                            loc: {
                                start: {
                                    line: 6,
                                    column: 4,
                                    fixed: true,
                                    source: 'glass/html/material/Tab.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 9,
                                    fixed: true,
                                    source: 'glass/html/material/Tab.ion'
                                }
                            }
                        },
                        property: {
                            type: 'Identifier',
                            name: 'define',
                            loc: {
                                start: {
                                    line: 6,
                                    column: 10,
                                    fixed: true,
                                    source: 'glass/html/material/Tab.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 16,
                                    fixed: true,
                                    source: 'glass/html/material/Tab.ion'
                                }
                            }
                        },
                        loc: {
                            start: {
                                line: 6,
                                column: 4,
                                fixed: true,
                                source: 'glass/html/material/Tab.ion'
                            },
                            end: {
                                line: 6,
                                column: 16,
                                fixed: true,
                                source: 'glass/html/material/Tab.ion'
                            }
                        }
                    },
                    arguments: [
                        {
                            type: 'MemberExpression',
                            computed: false,
                            object: {
                                type: 'Identifier',
                                name: 'module',
                                loc: {
                                    start: {
                                        line: 7,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/Tab.ion'
                                    },
                                    end: {
                                        line: 7,
                                        column: 14,
                                        fixed: true,
                                        source: 'glass/html/material/Tab.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'id',
                                loc: {
                                    start: {
                                        line: 7,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/Tab.ion'
                                    },
                                    end: {
                                        line: 7,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/html/material/Tab.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 7,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/Tab.ion'
                                },
                                end: {
                                    line: 7,
                                    column: 17,
                                    fixed: true,
                                    source: 'glass/html/material/Tab.ion'
                                }
                            }
                        },
                        {
                            type: 'BinaryExpression',
                            operator: '+',
                            left: {
                                type: 'BinaryExpression',
                                operator: '+',
                                left: {
                                    type: 'BinaryExpression',
                                    operator: '+',
                                    left: {
                                        type: 'BinaryExpression',
                                        operator: '+',
                                        left: {
                                            type: 'BinaryExpression',
                                            operator: '+',
                                            left: {
                                                type: 'BinaryExpression',
                                                operator: '+',
                                                left: {
                                                    type: 'BinaryExpression',
                                                    operator: '+',
                                                    left: {
                                                        type: 'BinaryExpression',
                                                        operator: '+',
                                                        left: {
                                                            type: 'Literal',
                                                            value: '.Tab {\n    min-height: 48px;\n    text-align: center;\n    transition: opacity 0.5s;\n    cursor: pointer;\n    user-select: none;\n}\n.Tab.selected {\n    border-bottom: '
                                                        },
                                                        right: {
                                                            type: 'Identifier',
                                                            name: 'activeBorderSize',
                                                            loc: {
                                                                start: {
                                                                    line: 17,
                                                                    column: 33,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Tab.ion'
                                                                },
                                                                end: {
                                                                    line: 17,
                                                                    column: 49,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Tab.ion'
                                                                }
                                                            }
                                                        }
                                                    },
                                                    right: {
                                                        type: 'Literal',
                                                        value: 'px solid '
                                                    }
                                                },
                                                right: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'style',
                                                            loc: {
                                                                start: {
                                                                    line: 17,
                                                                    column: 63,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Tab.ion'
                                                                },
                                                                end: {
                                                                    line: 17,
                                                                    column: 68,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Tab.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'color',
                                                            loc: {
                                                                start: {
                                                                    line: 17,
                                                                    column: 69,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Tab.ion'
                                                                },
                                                                end: {
                                                                    line: 17,
                                                                    column: 74,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Tab.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 17,
                                                                column: 63,
                                                                fixed: true,
                                                                source: 'glass/html/material/Tab.ion'
                                                            },
                                                            end: {
                                                                line: 17,
                                                                column: 74,
                                                                fixed: true,
                                                                source: 'glass/html/material/Tab.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'accentDark',
                                                        loc: {
                                                            start: {
                                                                line: 17,
                                                                column: 75,
                                                                fixed: true,
                                                                source: 'glass/html/material/Tab.ion'
                                                            },
                                                            end: {
                                                                line: 17,
                                                                column: 85,
                                                                fixed: true,
                                                                source: 'glass/html/material/Tab.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 17,
                                                            column: 63,
                                                            fixed: true,
                                                            source: 'glass/html/material/Tab.ion'
                                                        },
                                                        end: {
                                                            line: 17,
                                                            column: 85,
                                                            fixed: true,
                                                            source: 'glass/html/material/Tab.ion'
                                                        }
                                                    }
                                                }
                                            },
                                            right: {
                                                type: 'Literal',
                                                value: ';\n}\n.Tab:not(.selected) {\n    opacity: '
                                            }
                                        },
                                        right: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'style',
                                                    loc: {
                                                        start: {
                                                            line: 20,
                                                            column: 27,
                                                            fixed: true,
                                                            source: 'glass/html/material/Tab.ion'
                                                        },
                                                        end: {
                                                            line: 20,
                                                            column: 32,
                                                            fixed: true,
                                                            source: 'glass/html/material/Tab.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'opacity',
                                                    loc: {
                                                        start: {
                                                            line: 20,
                                                            column: 33,
                                                            fixed: true,
                                                            source: 'glass/html/material/Tab.ion'
                                                        },
                                                        end: {
                                                            line: 20,
                                                            column: 40,
                                                            fixed: true,
                                                            source: 'glass/html/material/Tab.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 20,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'glass/html/material/Tab.ion'
                                                    },
                                                    end: {
                                                        line: 20,
                                                        column: 40,
                                                        fixed: true,
                                                        source: 'glass/html/material/Tab.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'secondary',
                                                loc: {
                                                    start: {
                                                        line: 20,
                                                        column: 41,
                                                        fixed: true,
                                                        source: 'glass/html/material/Tab.ion'
                                                    },
                                                    end: {
                                                        line: 20,
                                                        column: 50,
                                                        fixed: true,
                                                        source: 'glass/html/material/Tab.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 20,
                                                    column: 27,
                                                    fixed: true,
                                                    source: 'glass/html/material/Tab.ion'
                                                },
                                                end: {
                                                    line: 20,
                                                    column: 50,
                                                    fixed: true,
                                                    source: 'glass/html/material/Tab.ion'
                                                }
                                            }
                                        }
                                    },
                                    right: {
                                        type: 'Literal',
                                        value: ';\n    border-bottom: '
                                    }
                                },
                                right: {
                                    type: 'Identifier',
                                    name: 'activeBorderSize',
                                    loc: {
                                        start: {
                                            line: 21,
                                            column: 33,
                                            fixed: true,
                                            source: 'glass/html/material/Tab.ion'
                                        },
                                        end: {
                                            line: 21,
                                            column: 49,
                                            fixed: true,
                                            source: 'glass/html/material/Tab.ion'
                                        }
                                    }
                                }
                            },
                            right: {
                                type: 'Literal',
                                value: 'px solid transparent;\n}'
                            }
                        }
                    ],
                    loc: {
                        start: {
                            line: 6,
                            column: 4,
                            fixed: true,
                            source: 'glass/html/material/Tab.ion'
                        },
                        end: {
                            line: 23,
                            column: 5,
                            fixed: true,
                            source: 'glass/html/material/Tab.ion'
                        }
                    }
                },
                loc: {
                    start: {
                        line: 6,
                        column: 4,
                        fixed: true,
                        source: 'glass/html/material/Tab.ion'
                    },
                    end: {
                        line: 23,
                        column: 5,
                        fixed: true,
                        source: 'glass/html/material/Tab.ion'
                    }
                },
                order: '1'
            }
        ],
        bound: false
    }, {
        this: this,
        module: module,
        style: style
    }, null);
})().observe();
module.exports = exports = ion.template(function (attributes) {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [{
                type: 'ReturnStatement',
                argument: {
                    type: 'CallExpression',
                    callee: {
                        type: 'MemberExpression',
                        object: {
                            type: 'Identifier',
                            name: 'Object'
                        },
                        property: {
                            type: 'Identifier',
                            name: 'defineProperties'
                        }
                    },
                    arguments: [
                        {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Li',
                                    loc: {
                                        start: {
                                            line: 26,
                                            column: 11,
                                            fixed: true,
                                            source: 'glass/html/material/Tab.ion'
                                        },
                                        end: {
                                            line: 26,
                                            column: 13,
                                            fixed: true,
                                            source: 'glass/html/material/Tab.ion'
                                        }
                                    }
                                },
                                arguments: [
                                    {
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'class',
                                                    loc: {
                                                        start: {
                                                            line: 26,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Tab.ion'
                                                        },
                                                        end: {
                                                            line: 26,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'glass/html/material/Tab.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: 'Tab layout center center-justified flex'
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    },
                                    {
                                        type: 'Identifier',
                                        name: 'attributes',
                                        loc: {
                                            start: {
                                                line: 26,
                                                column: 65,
                                                fixed: true,
                                                source: 'glass/html/material/Tab.ion'
                                            },
                                            end: {
                                                line: 26,
                                                column: 75,
                                                fixed: true,
                                                source: 'glass/html/material/Tab.ion'
                                            }
                                        }
                                    }
                                ],
                                loc: {
                                    start: {
                                        line: 26,
                                        column: 11,
                                        fixed: true,
                                        source: 'glass/html/material/Tab.ion'
                                    },
                                    end: {
                                        line: 26,
                                        column: 76,
                                        fixed: true,
                                        source: 'glass/html/material/Tab.ion'
                                    }
                                }
                            },
                            properties: [
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'Function',
                                        context: false,
                                        value: function touchstart(e) {
                                            this.selected = true;
                                            e.preventDefault();
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 44,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/Tab.ion'
                                        },
                                        end: {
                                            line: 47,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/material/Tab.ion'
                                        }
                                    },
                                    order: '0'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'Function',
                                        context: false,
                                        value: function click(e) {
                                            this.selected = true;
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 47,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/Tab.ion'
                                        },
                                        end: {
                                            line: 50,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/material/Tab.ion'
                                        }
                                    },
                                    order: '1'
                                }
                            ]
                        },
                        {
                            type: 'ObjectExpression',
                            properties: [{
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'selected',
                                        loc: {
                                            start: {
                                                line: 27,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/Tab.ion'
                                            },
                                            end: {
                                                line: 27,
                                                column: 25,
                                                fixed: true,
                                                source: 'glass/html/material/Tab.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 28,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Tab.ion'
                                                        },
                                                        end: {
                                                            line: 28,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Tab.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: false,
                                                    value: function () {
                                                        return this.classList.contains('selected');
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 29,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/Tab.ion'
                                                        },
                                                        end: {
                                                            line: 29,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/Tab.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: false,
                                                    value: function (value) {
                                                        var selected = this.selected;
                                                        if (value !== selected) {
                                                            if (value) {
                                                                this.classList.add('selected');
                                                                var parent = this.parentElement;
                                                                if (parent != null) {
                                                                    {
                                                                        var _ref = parent.children;
                                                                        for (var _i = 0; _i < _ref.length; _i++) {
                                                                            var sibling = _ref[_i];
                                                                            if (sibling !== this) {
                                                                                sibling.selected = false;
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                                this.dispatchEvent(new CustomEvent('selected'));
                                                            } else {
                                                                this.classList.remove('selected');
                                                                this.dispatchEvent(new CustomEvent('deselected'));
                                                            }
                                                        }
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '0'
                                }]
                        }
                    ]
                },
                order: '0'
            }],
        bound: false
    }, {
        this: this,
        attributes: attributes,
        style: style
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/Tab',_glass_html_material_Tab_);
    else
      _glass_html_material_Tab_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_Tab_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_TabContent_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('./'), _ref2;
var Tabs = _ref.Tabs;
var Tab = _ref.Tab;
_ref2 = require('../');
var style = _ref2.style;
module.exports = exports = ion.template(function TabContent(args) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'TabContent',
            loc: {
                start: {
                    line: 5,
                    column: 16,
                    fixed: true,
                    source: 'glass/html/material/TabContent.ion'
                },
                end: {
                    line: 5,
                    column: 26,
                    fixed: true,
                    source: 'glass/html/material/TabContent.ion'
                }
            }
        },
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'state',
                            loc: {
                                start: {
                                    line: 6,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/TabContent.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/html/material/TabContent.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ConditionalExpression',
                            test: {
                                type: 'BinaryExpression',
                                operator: '!=',
                                left: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'args',
                                        loc: {
                                            start: {
                                                line: 6,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/TabContent.ion'
                                            },
                                            end: {
                                                line: 6,
                                                column: 20,
                                                fixed: true,
                                                source: 'glass/html/material/TabContent.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'state',
                                        loc: {
                                            start: {
                                                line: 6,
                                                column: 21,
                                                fixed: true,
                                                source: 'glass/html/material/TabContent.ion'
                                            },
                                            end: {
                                                line: 6,
                                                column: 26,
                                                fixed: true,
                                                source: 'glass/html/material/TabContent.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 6,
                                            column: 16,
                                            fixed: true,
                                            source: 'glass/html/material/TabContent.ion'
                                        },
                                        end: {
                                            line: 6,
                                            column: 26,
                                            fixed: true,
                                            source: 'glass/html/material/TabContent.ion'
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: null
                                }
                            },
                            consequent: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'args',
                                    loc: {
                                        start: {
                                            line: 6,
                                            column: 16,
                                            fixed: true,
                                            source: 'glass/html/material/TabContent.ion'
                                        },
                                        end: {
                                            line: 6,
                                            column: 20,
                                            fixed: true,
                                            source: 'glass/html/material/TabContent.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'state',
                                    loc: {
                                        start: {
                                            line: 6,
                                            column: 21,
                                            fixed: true,
                                            source: 'glass/html/material/TabContent.ion'
                                        },
                                        end: {
                                            line: 6,
                                            column: 26,
                                            fixed: true,
                                            source: 'glass/html/material/TabContent.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 16,
                                        fixed: true,
                                        source: 'glass/html/material/TabContent.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 26,
                                        fixed: true,
                                        source: 'glass/html/material/TabContent.ion'
                                    }
                                }
                            },
                            alternate: {
                                type: 'ObjectExpression',
                                properties: []
                            }
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: '_ref3'
                        },
                        init: {
                            type: 'Identifier',
                            name: 'args',
                            loc: {
                                start: {
                                    line: 7,
                                    column: 17,
                                    fixed: true,
                                    source: 'glass/html/material/TabContent.ion'
                                },
                                end: {
                                    line: 7,
                                    column: 21,
                                    fixed: true,
                                    source: 'glass/html/material/TabContent.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'tabs',
                            loc: {
                                start: {
                                    line: 7,
                                    column: 9,
                                    fixed: true,
                                    source: 'glass/html/material/TabContent.ion'
                                },
                                end: {
                                    line: 7,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/html/material/TabContent.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'tabs',
                                loc: {
                                    start: {
                                        line: 7,
                                        column: 9,
                                        fixed: true,
                                        source: 'glass/html/material/TabContent.ion'
                                    },
                                    end: {
                                        line: 7,
                                        column: 13,
                                        fixed: true,
                                        source: 'glass/html/material/TabContent.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'names',
                            loc: {
                                start: {
                                    line: 8,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/TabContent.ion'
                                },
                                end: {
                                    line: 8,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/html/material/TabContent.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'ArrayExpression',
                                elements: []
                            },
                            properties: [{
                                    type: 'ForOfStatement',
                                    left: {
                                        type: 'VariableDeclaration',
                                        declarations: [{
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'tab',
                                                    loc: {
                                                        start: {
                                                            line: 8,
                                                            column: 30,
                                                            fixed: true,
                                                            source: 'glass/html/material/TabContent.ion'
                                                        },
                                                        end: {
                                                            line: 8,
                                                            column: 33,
                                                            fixed: true,
                                                            source: 'glass/html/material/TabContent.ion'
                                                        }
                                                    }
                                                },
                                                init: null
                                            }],
                                        kind: 'let'
                                    },
                                    right: {
                                        type: 'Identifier',
                                        name: 'tabs',
                                        loc: {
                                            start: {
                                                line: 8,
                                                column: 37,
                                                fixed: true,
                                                source: 'glass/html/material/TabContent.ion'
                                            },
                                            end: {
                                                line: 8,
                                                column: 41,
                                                fixed: true,
                                                source: 'glass/html/material/TabContent.ion'
                                            }
                                        }
                                    },
                                    body: {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'tab',
                                                loc: {
                                                    start: {
                                                        line: 8,
                                                        column: 17,
                                                        fixed: true,
                                                        source: 'glass/html/material/TabContent.ion'
                                                    },
                                                    end: {
                                                        line: 8,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'glass/html/material/TabContent.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'name',
                                                loc: {
                                                    start: {
                                                        line: 8,
                                                        column: 21,
                                                        fixed: true,
                                                        source: 'glass/html/material/TabContent.ion'
                                                    },
                                                    end: {
                                                        line: 8,
                                                        column: 25,
                                                        fixed: true,
                                                        source: 'glass/html/material/TabContent.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 8,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'glass/html/material/TabContent.ion'
                                                },
                                                end: {
                                                    line: 8,
                                                    column: 25,
                                                    fixed: true,
                                                    source: 'glass/html/material/TabContent.ion'
                                                }
                                            }
                                        }
                                    },
                                    order: '0'
                                }]
                        }
                    }],
                kind: 'let',
                order: '3'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'selectedTabName',
                            loc: {
                                start: {
                                    line: 9,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/TabContent.ion'
                                },
                                end: {
                                    line: 9,
                                    column: 23,
                                    fixed: true,
                                    source: 'glass/html/material/TabContent.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ConditionalExpression',
                            test: {
                                type: 'BinaryExpression',
                                operator: '!=',
                                left: {
                                    type: 'ConditionalExpression',
                                    test: {
                                        type: 'BinaryExpression',
                                        operator: '!=',
                                        left: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'state',
                                                loc: {
                                                    start: {
                                                        line: 9,
                                                        column: 26,
                                                        fixed: true,
                                                        source: 'glass/html/material/TabContent.ion'
                                                    },
                                                    end: {
                                                        line: 9,
                                                        column: 31,
                                                        fixed: true,
                                                        source: 'glass/html/material/TabContent.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'tab',
                                                loc: {
                                                    start: {
                                                        line: 9,
                                                        column: 32,
                                                        fixed: true,
                                                        source: 'glass/html/material/TabContent.ion'
                                                    },
                                                    end: {
                                                        line: 9,
                                                        column: 35,
                                                        fixed: true,
                                                        source: 'glass/html/material/TabContent.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 9,
                                                    column: 26,
                                                    fixed: true,
                                                    source: 'glass/html/material/TabContent.ion'
                                                },
                                                end: {
                                                    line: 9,
                                                    column: 35,
                                                    fixed: true,
                                                    source: 'glass/html/material/TabContent.ion'
                                                }
                                            }
                                        },
                                        right: {
                                            type: 'Literal',
                                            value: null
                                        }
                                    },
                                    consequent: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'state',
                                            loc: {
                                                start: {
                                                    line: 9,
                                                    column: 26,
                                                    fixed: true,
                                                    source: 'glass/html/material/TabContent.ion'
                                                },
                                                end: {
                                                    line: 9,
                                                    column: 31,
                                                    fixed: true,
                                                    source: 'glass/html/material/TabContent.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'tab',
                                            loc: {
                                                start: {
                                                    line: 9,
                                                    column: 32,
                                                    fixed: true,
                                                    source: 'glass/html/material/TabContent.ion'
                                                },
                                                end: {
                                                    line: 9,
                                                    column: 35,
                                                    fixed: true,
                                                    source: 'glass/html/material/TabContent.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 9,
                                                column: 26,
                                                fixed: true,
                                                source: 'glass/html/material/TabContent.ion'
                                            },
                                            end: {
                                                line: 9,
                                                column: 35,
                                                fixed: true,
                                                source: 'glass/html/material/TabContent.ion'
                                            }
                                        }
                                    },
                                    alternate: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'args',
                                            loc: {
                                                start: {
                                                    line: 9,
                                                    column: 38,
                                                    fixed: true,
                                                    source: 'glass/html/material/TabContent.ion'
                                                },
                                                end: {
                                                    line: 9,
                                                    column: 42,
                                                    fixed: true,
                                                    source: 'glass/html/material/TabContent.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'defaultTab',
                                            loc: {
                                                start: {
                                                    line: 9,
                                                    column: 43,
                                                    fixed: true,
                                                    source: 'glass/html/material/TabContent.ion'
                                                },
                                                end: {
                                                    line: 9,
                                                    column: 53,
                                                    fixed: true,
                                                    source: 'glass/html/material/TabContent.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 9,
                                                column: 38,
                                                fixed: true,
                                                source: 'glass/html/material/TabContent.ion'
                                            },
                                            end: {
                                                line: 9,
                                                column: 53,
                                                fixed: true,
                                                source: 'glass/html/material/TabContent.ion'
                                            }
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: null
                                }
                            },
                            consequent: {
                                type: 'ConditionalExpression',
                                test: {
                                    type: 'BinaryExpression',
                                    operator: '!=',
                                    left: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'state',
                                            loc: {
                                                start: {
                                                    line: 9,
                                                    column: 26,
                                                    fixed: true,
                                                    source: 'glass/html/material/TabContent.ion'
                                                },
                                                end: {
                                                    line: 9,
                                                    column: 31,
                                                    fixed: true,
                                                    source: 'glass/html/material/TabContent.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'tab',
                                            loc: {
                                                start: {
                                                    line: 9,
                                                    column: 32,
                                                    fixed: true,
                                                    source: 'glass/html/material/TabContent.ion'
                                                },
                                                end: {
                                                    line: 9,
                                                    column: 35,
                                                    fixed: true,
                                                    source: 'glass/html/material/TabContent.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 9,
                                                column: 26,
                                                fixed: true,
                                                source: 'glass/html/material/TabContent.ion'
                                            },
                                            end: {
                                                line: 9,
                                                column: 35,
                                                fixed: true,
                                                source: 'glass/html/material/TabContent.ion'
                                            }
                                        }
                                    },
                                    right: {
                                        type: 'Literal',
                                        value: null
                                    }
                                },
                                consequent: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'state',
                                        loc: {
                                            start: {
                                                line: 9,
                                                column: 26,
                                                fixed: true,
                                                source: 'glass/html/material/TabContent.ion'
                                            },
                                            end: {
                                                line: 9,
                                                column: 31,
                                                fixed: true,
                                                source: 'glass/html/material/TabContent.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'tab',
                                        loc: {
                                            start: {
                                                line: 9,
                                                column: 32,
                                                fixed: true,
                                                source: 'glass/html/material/TabContent.ion'
                                            },
                                            end: {
                                                line: 9,
                                                column: 35,
                                                fixed: true,
                                                source: 'glass/html/material/TabContent.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 9,
                                            column: 26,
                                            fixed: true,
                                            source: 'glass/html/material/TabContent.ion'
                                        },
                                        end: {
                                            line: 9,
                                            column: 35,
                                            fixed: true,
                                            source: 'glass/html/material/TabContent.ion'
                                        }
                                    }
                                },
                                alternate: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'args',
                                        loc: {
                                            start: {
                                                line: 9,
                                                column: 38,
                                                fixed: true,
                                                source: 'glass/html/material/TabContent.ion'
                                            },
                                            end: {
                                                line: 9,
                                                column: 42,
                                                fixed: true,
                                                source: 'glass/html/material/TabContent.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'defaultTab',
                                        loc: {
                                            start: {
                                                line: 9,
                                                column: 43,
                                                fixed: true,
                                                source: 'glass/html/material/TabContent.ion'
                                            },
                                            end: {
                                                line: 9,
                                                column: 53,
                                                fixed: true,
                                                source: 'glass/html/material/TabContent.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 9,
                                            column: 38,
                                            fixed: true,
                                            source: 'glass/html/material/TabContent.ion'
                                        },
                                        end: {
                                            line: 9,
                                            column: 53,
                                            fixed: true,
                                            source: 'glass/html/material/TabContent.ion'
                                        }
                                    }
                                }
                            },
                            alternate: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'MemberExpression',
                                    computed: true,
                                    object: {
                                        type: 'Identifier',
                                        name: 'tabs',
                                        loc: {
                                            start: {
                                                line: 9,
                                                column: 56,
                                                fixed: true,
                                                source: 'glass/html/material/TabContent.ion'
                                            },
                                            end: {
                                                line: 9,
                                                column: 60,
                                                fixed: true,
                                                source: 'glass/html/material/TabContent.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Literal',
                                        value: 0
                                    },
                                    loc: {
                                        start: {
                                            line: 9,
                                            column: 56,
                                            fixed: true,
                                            source: 'glass/html/material/TabContent.ion'
                                        },
                                        end: {
                                            line: 9,
                                            column: 63,
                                            fixed: true,
                                            source: 'glass/html/material/TabContent.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'name',
                                    loc: {
                                        start: {
                                            line: 9,
                                            column: 64,
                                            fixed: true,
                                            source: 'glass/html/material/TabContent.ion'
                                        },
                                        end: {
                                            line: 9,
                                            column: 68,
                                            fixed: true,
                                            source: 'glass/html/material/TabContent.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 9,
                                        column: 56,
                                        fixed: true,
                                        source: 'glass/html/material/TabContent.ion'
                                    },
                                    end: {
                                        line: 9,
                                        column: 68,
                                        fixed: true,
                                        source: 'glass/html/material/TabContent.ion'
                                    }
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '4'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'cache',
                            loc: {
                                start: {
                                    line: 12,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/TabContent.ion'
                                },
                                end: {
                                    line: 12,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/html/material/TabContent.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'ObjectExpression',
                                properties: []
                            },
                            properties: [{
                                    type: 'ForOfStatement',
                                    left: {
                                        type: 'VariableDeclaration',
                                        declarations: [{
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'config',
                                                    loc: {
                                                        start: {
                                                            line: 13,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/TabContent.ion'
                                                        },
                                                        end: {
                                                            line: 13,
                                                            column: 18,
                                                            fixed: true,
                                                            source: 'glass/html/material/TabContent.ion'
                                                        }
                                                    }
                                                },
                                                init: null
                                            }],
                                        kind: 'let'
                                    },
                                    right: {
                                        type: 'Identifier',
                                        name: 'tabs',
                                        loc: {
                                            start: {
                                                line: 13,
                                                column: 22,
                                                fixed: true,
                                                source: 'glass/html/material/TabContent.ion'
                                            },
                                            end: {
                                                line: 13,
                                                column: 26,
                                                fixed: true,
                                                source: 'glass/html/material/TabContent.ion'
                                            }
                                        }
                                    },
                                    body: {
                                        type: 'BlockStatement',
                                        body: [{
                                                type: 'IfStatement',
                                                test: {
                                                    type: 'BinaryExpression',
                                                    operator: '||',
                                                    left: {
                                                        type: 'BinaryExpression',
                                                        operator: '===',
                                                        left: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'config',
                                                                loc: {
                                                                    start: {
                                                                        line: 13,
                                                                        column: 30,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/TabContent.ion'
                                                                    },
                                                                    end: {
                                                                        line: 13,
                                                                        column: 36,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/TabContent.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'name',
                                                                loc: {
                                                                    start: {
                                                                        line: 13,
                                                                        column: 37,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/TabContent.ion'
                                                                    },
                                                                    end: {
                                                                        line: 13,
                                                                        column: 41,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/TabContent.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 13,
                                                                    column: 30,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TabContent.ion'
                                                                },
                                                                end: {
                                                                    line: 13,
                                                                    column: 41,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TabContent.ion'
                                                                }
                                                            }
                                                        },
                                                        right: {
                                                            type: 'Identifier',
                                                            name: 'selectedTabName',
                                                            loc: {
                                                                start: {
                                                                    line: 13,
                                                                    column: 45,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TabContent.ion'
                                                                },
                                                                end: {
                                                                    line: 13,
                                                                    column: 60,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TabContent.ion'
                                                                }
                                                            }
                                                        }
                                                    },
                                                    right: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'config',
                                                            loc: {
                                                                start: {
                                                                    line: 13,
                                                                    column: 64,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TabContent.ion'
                                                                },
                                                                end: {
                                                                    line: 13,
                                                                    column: 70,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TabContent.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'cache',
                                                            loc: {
                                                                start: {
                                                                    line: 13,
                                                                    column: 71,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TabContent.ion'
                                                                },
                                                                end: {
                                                                    line: 13,
                                                                    column: 76,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TabContent.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 13,
                                                                column: 64,
                                                                fixed: true,
                                                                source: 'glass/html/material/TabContent.ion'
                                                            },
                                                            end: {
                                                                line: 13,
                                                                column: 76,
                                                                fixed: true,
                                                                source: 'glass/html/material/TabContent.ion'
                                                            }
                                                        }
                                                    }
                                                },
                                                consequent: {
                                                    type: 'BlockStatement',
                                                    body: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'config',
                                                                    loc: {
                                                                        start: {
                                                                            line: 14,
                                                                            column: 13,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TabContent.ion'
                                                                        },
                                                                        end: {
                                                                            line: 14,
                                                                            column: 19,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TabContent.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'name',
                                                                    loc: {
                                                                        start: {
                                                                            line: 14,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TabContent.ion'
                                                                        },
                                                                        end: {
                                                                            line: 14,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TabContent.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 14,
                                                                        column: 13,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/TabContent.ion'
                                                                    },
                                                                    end: {
                                                                        line: 14,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/TabContent.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'config',
                                                                        loc: {
                                                                            start: {
                                                                                line: 14,
                                                                                column: 27,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/TabContent.ion'
                                                                            },
                                                                            end: {
                                                                                line: 14,
                                                                                column: 33,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/TabContent.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'content',
                                                                        loc: {
                                                                            start: {
                                                                                line: 14,
                                                                                column: 34,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/TabContent.ion'
                                                                            },
                                                                            end: {
                                                                                line: 14,
                                                                                column: 41,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/TabContent.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 14,
                                                                            column: 27,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TabContent.ion'
                                                                        },
                                                                        end: {
                                                                            line: 14,
                                                                            column: 41,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TabContent.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [],
                                                                loc: {
                                                                    start: {
                                                                        line: 14,
                                                                        column: 27,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/TabContent.ion'
                                                                    },
                                                                    end: {
                                                                        line: 14,
                                                                        column: 43,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/TabContent.ion'
                                                                    }
                                                                }
                                                            },
                                                            kind: 'init',
                                                            computed: true,
                                                            order: '0'
                                                        }]
                                                },
                                                order: '0'
                                            }]
                                    },
                                    remove: null,
                                    order: '0'
                                }]
                        }
                    }],
                kind: 'let',
                order: '5'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'CallExpression',
                        callee: {
                            type: 'Identifier',
                            name: 'Div',
                            loc: {
                                start: {
                                    line: 16,
                                    column: 11,
                                    fixed: true,
                                    source: 'glass/html/material/TabContent.ion'
                                },
                                end: {
                                    line: 16,
                                    column: 14,
                                    fixed: true,
                                    source: 'glass/html/material/TabContent.ion'
                                }
                            }
                        },
                        arguments: [{
                                type: 'ObjectExpression',
                                properties: [{
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'class',
                                            loc: {
                                                start: {
                                                    line: 16,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/html/material/TabContent.ion'
                                                },
                                                end: {
                                                    line: 16,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'glass/html/material/TabContent.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: 'TabContent layout vertical reverse flex'
                                        },
                                        kind: 'init',
                                        order: '0'
                                    }]
                            }],
                        loc: {
                            start: {
                                line: 16,
                                column: 11,
                                fixed: true,
                                source: 'glass/html/material/TabContent.ion'
                            },
                            end: {
                                line: 16,
                                column: 65,
                                fixed: true,
                                source: 'glass/html/material/TabContent.ion'
                            }
                        }
                    },
                    properties: [
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'Identifier',
                                        name: 'Div',
                                        loc: {
                                            start: {
                                                line: 17,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/TabContent.ion'
                                            },
                                            end: {
                                                line: 17,
                                                column: 11,
                                                fixed: true,
                                                source: 'glass/html/material/TabContent.ion'
                                            }
                                        }
                                    },
                                    arguments: [{
                                            type: 'ObjectExpression',
                                            properties: [{
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'class',
                                                        loc: {
                                                            start: {
                                                                line: 17,
                                                                column: 13,
                                                                fixed: true,
                                                                source: 'glass/html/material/TabContent.ion'
                                                            },
                                                            end: {
                                                                line: 17,
                                                                column: 18,
                                                                fixed: true,
                                                                source: 'glass/html/material/TabContent.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 'fill'
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                }]
                                        }],
                                    loc: {
                                        start: {
                                            line: 17,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/TabContent.ion'
                                        },
                                        end: {
                                            line: 17,
                                            column: 27,
                                            fixed: true,
                                            source: 'glass/html/material/TabContent.ion'
                                        }
                                    }
                                },
                                properties: [
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'style',
                                            loc: {
                                                start: {
                                                    line: 18,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/TabContent.ion'
                                                },
                                                end: {
                                                    line: 18,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'glass/html/material/TabContent.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'ObjectExpression',
                                            properties: [
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'position',
                                                        loc: {
                                                            start: {
                                                                line: 19,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/TabContent.ion'
                                                            },
                                                            end: {
                                                                line: 19,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'glass/html/material/TabContent.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 'relative'
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'overflow',
                                                        loc: {
                                                            start: {
                                                                line: 20,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/TabContent.ion'
                                                            },
                                                            end: {
                                                                line: 20,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'glass/html/material/TabContent.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 'hidden'
                                                    },
                                                    kind: 'init',
                                                    order: '1'
                                                }
                                            ]
                                        },
                                        kind: 'init',
                                        order: '0'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'ObjectExpression',
                                            objectType: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'Div',
                                                    loc: {
                                                        start: {
                                                            line: 21,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/html/material/TabContent.ion'
                                                        },
                                                        end: {
                                                            line: 21,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/html/material/TabContent.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [{
                                                        type: 'ObjectExpression',
                                                        properties: [{
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'class',
                                                                    loc: {
                                                                        start: {
                                                                            line: 21,
                                                                            column: 17,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TabContent.ion'
                                                                        },
                                                                        end: {
                                                                            line: 21,
                                                                            column: 22,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TabContent.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: 'transition'
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            }]
                                                    }],
                                                loc: {
                                                    start: {
                                                        line: 21,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/TabContent.ion'
                                                    },
                                                    end: {
                                                        line: 21,
                                                        column: 37,
                                                        fixed: true,
                                                        source: 'glass/html/material/TabContent.ion'
                                                    }
                                                }
                                            },
                                            properties: [
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'selectedIndex',
                                                                loc: {
                                                                    start: {
                                                                        line: 22,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/TabContent.ion'
                                                                    },
                                                                    end: {
                                                                        line: 22,
                                                                        column: 33,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/TabContent.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'names',
                                                                        loc: {
                                                                            start: {
                                                                                line: 22,
                                                                                column: 36,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/TabContent.ion'
                                                                            },
                                                                            end: {
                                                                                line: 22,
                                                                                column: 41,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/TabContent.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'indexOf',
                                                                        loc: {
                                                                            start: {
                                                                                line: 22,
                                                                                column: 42,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/TabContent.ion'
                                                                            },
                                                                            end: {
                                                                                line: 22,
                                                                                column: 49,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/TabContent.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 22,
                                                                            column: 36,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TabContent.ion'
                                                                        },
                                                                        end: {
                                                                            line: 22,
                                                                            column: 49,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TabContent.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'Identifier',
                                                                        name: 'selectedTabName',
                                                                        loc: {
                                                                            start: {
                                                                                line: 22,
                                                                                column: 50,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/TabContent.ion'
                                                                            },
                                                                            end: {
                                                                                line: 22,
                                                                                column: 65,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/TabContent.ion'
                                                                            }
                                                                        }
                                                                    }],
                                                                loc: {
                                                                    start: {
                                                                        line: 22,
                                                                        column: 36,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/TabContent.ion'
                                                                    },
                                                                    end: {
                                                                        line: 22,
                                                                        column: 66,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/TabContent.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'style',
                                                        loc: {
                                                            start: {
                                                                line: 23,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/TabContent.ion'
                                                            },
                                                            end: {
                                                                line: 23,
                                                                column: 21,
                                                                fixed: true,
                                                                source: 'glass/html/material/TabContent.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'ObjectExpression',
                                                        properties: [
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'position',
                                                                    loc: {
                                                                        start: {
                                                                            line: 24,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TabContent.ion'
                                                                        },
                                                                        end: {
                                                                            line: 24,
                                                                            column: 28,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TabContent.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: 'absolute'
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'left',
                                                                    loc: {
                                                                        start: {
                                                                            line: 25,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TabContent.ion'
                                                                        },
                                                                        end: {
                                                                            line: 25,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TabContent.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '+',
                                                                    left: {
                                                                        type: 'BinaryExpression',
                                                                        operator: '+',
                                                                        left: {
                                                                            type: 'Literal',
                                                                            value: ''
                                                                        },
                                                                        right: {
                                                                            type: 'BinaryExpression',
                                                                            operator: '*',
                                                                            left: {
                                                                                type: 'UnaryExpression',
                                                                                operator: '-',
                                                                                argument: {
                                                                                    type: 'Literal',
                                                                                    value: 100
                                                                                }
                                                                            },
                                                                            right: {
                                                                                type: 'Identifier',
                                                                                name: 'selectedIndex',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 25,
                                                                                        column: 36,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/TabContent.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 25,
                                                                                        column: 49,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/TabContent.ion'
                                                                                    }
                                                                                }
                                                                            }
                                                                        }
                                                                    },
                                                                    right: {
                                                                        type: 'Literal',
                                                                        value: '%'
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '1'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'width',
                                                                    loc: {
                                                                        start: {
                                                                            line: 26,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TabContent.ion'
                                                                        },
                                                                        end: {
                                                                            line: 26,
                                                                            column: 25,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TabContent.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: '100%'
                                                                },
                                                                kind: 'init',
                                                                order: '2'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'height',
                                                                    loc: {
                                                                        start: {
                                                                            line: 27,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TabContent.ion'
                                                                        },
                                                                        end: {
                                                                            line: 27,
                                                                            column: 26,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TabContent.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: '100%'
                                                                },
                                                                kind: 'init',
                                                                order: '3'
                                                            }
                                                        ]
                                                    },
                                                    kind: 'init',
                                                    order: '1'
                                                },
                                                {
                                                    type: 'ForOfStatement',
                                                    left: {
                                                        type: 'VariableDeclaration',
                                                        declarations: [{
                                                                type: 'VariableDeclarator',
                                                                id: {
                                                                    type: 'Identifier',
                                                                    name: 'config',
                                                                    loc: {
                                                                        start: {
                                                                            line: 28,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TabContent.ion'
                                                                        },
                                                                        end: {
                                                                            line: 28,
                                                                            column: 26,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TabContent.ion'
                                                                        }
                                                                    }
                                                                },
                                                                init: null
                                                            }],
                                                        kind: 'let'
                                                    },
                                                    right: {
                                                        type: 'Identifier',
                                                        name: 'tabs',
                                                        loc: {
                                                            start: {
                                                                line: 28,
                                                                column: 30,
                                                                fixed: true,
                                                                source: 'glass/html/material/TabContent.ion'
                                                            },
                                                            end: {
                                                                line: 28,
                                                                column: 34,
                                                                fixed: true,
                                                                source: 'glass/html/material/TabContent.ion'
                                                            }
                                                        }
                                                    },
                                                    body: {
                                                        type: 'BlockStatement',
                                                        body: [
                                                            {
                                                                type: 'VariableDeclaration',
                                                                declarations: [{
                                                                        type: 'VariableDeclarator',
                                                                        id: {
                                                                            type: 'Identifier',
                                                                            name: 'name',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 29,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/TabContent.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 29,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/TabContent.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        init: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'config',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 29,
                                                                                        column: 31,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/TabContent.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 29,
                                                                                        column: 37,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/TabContent.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'name',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 29,
                                                                                        column: 38,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/TabContent.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 29,
                                                                                        column: 42,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/TabContent.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 29,
                                                                                    column: 31,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/TabContent.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 29,
                                                                                    column: 42,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/TabContent.ion'
                                                                                }
                                                                            }
                                                                        }
                                                                    }],
                                                                kind: 'let',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'VariableDeclaration',
                                                                declarations: [{
                                                                        type: 'VariableDeclarator',
                                                                        id: {
                                                                            type: 'Identifier',
                                                                            name: 'content',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 30,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/TabContent.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 30,
                                                                                    column: 31,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/TabContent.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        init: {
                                                                            type: 'MemberExpression',
                                                                            computed: true,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'cache',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 30,
                                                                                        column: 34,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/TabContent.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 30,
                                                                                        column: 39,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/TabContent.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'name',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 30,
                                                                                        column: 40,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/TabContent.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 30,
                                                                                        column: 44,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/TabContent.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 30,
                                                                                    column: 34,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/TabContent.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 30,
                                                                                    column: 45,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/TabContent.ion'
                                                                                }
                                                                            }
                                                                        }
                                                                    }],
                                                                kind: 'let',
                                                                order: '1'
                                                            },
                                                            {
                                                                type: 'IfStatement',
                                                                test: {
                                                                    type: 'Identifier',
                                                                    name: 'content',
                                                                    loc: {
                                                                        start: {
                                                                            line: 31,
                                                                            column: 23,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TabContent.ion'
                                                                        },
                                                                        end: {
                                                                            line: 31,
                                                                            column: 30,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TabContent.ion'
                                                                        }
                                                                    }
                                                                },
                                                                consequent: {
                                                                    type: 'BlockStatement',
                                                                    body: [
                                                                        {
                                                                            type: 'VariableDeclaration',
                                                                            declarations: [{
                                                                                    type: 'VariableDeclarator',
                                                                                    id: {
                                                                                        type: 'Identifier',
                                                                                        name: 'index',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 32,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/TabContent.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 32,
                                                                                                column: 33,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/TabContent.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    init: {
                                                                                        type: 'CallExpression',
                                                                                        callee: {
                                                                                            type: 'MemberExpression',
                                                                                            computed: false,
                                                                                            object: {
                                                                                                type: 'Identifier',
                                                                                                name: 'names',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 32,
                                                                                                        column: 36,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/TabContent.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 32,
                                                                                                        column: 41,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/TabContent.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            property: {
                                                                                                type: 'Identifier',
                                                                                                name: 'indexOf',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 32,
                                                                                                        column: 42,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/TabContent.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 32,
                                                                                                        column: 49,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/TabContent.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 32,
                                                                                                    column: 36,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/TabContent.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 32,
                                                                                                    column: 49,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/TabContent.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        arguments: [{
                                                                                                type: 'Identifier',
                                                                                                name: 'name',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 32,
                                                                                                        column: 50,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/TabContent.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 32,
                                                                                                        column: 54,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/TabContent.ion'
                                                                                                    }
                                                                                                }
                                                                                            }],
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 32,
                                                                                                column: 36,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/TabContent.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 32,
                                                                                                column: 55,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/TabContent.ion'
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                }],
                                                                            kind: 'let',
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'ObjectExpression',
                                                                                objectType: {
                                                                                    type: 'Identifier',
                                                                                    name: 'content',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 33,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/TabContent.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 33,
                                                                                            column: 31,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/TabContent.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                properties: [{
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'style',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 34,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/TabContent.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 34,
                                                                                                    column: 33,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/TabContent.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'ObjectExpression',
                                                                                            properties: [
                                                                                                {
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'position',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 35,
                                                                                                                column: 32,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/TabContent.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 35,
                                                                                                                column: 40,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/TabContent.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'Literal',
                                                                                                        value: 'absolute'
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '0'
                                                                                                },
                                                                                                {
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'width',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 36,
                                                                                                                column: 32,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/TabContent.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 36,
                                                                                                                column: 37,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/TabContent.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'Literal',
                                                                                                        value: '100%'
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '1'
                                                                                                },
                                                                                                {
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'height',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 37,
                                                                                                                column: 32,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/TabContent.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 37,
                                                                                                                column: 38,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/TabContent.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'Literal',
                                                                                                        value: '100%'
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '2'
                                                                                                },
                                                                                                {
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'left',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 38,
                                                                                                                column: 32,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/TabContent.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 38,
                                                                                                                column: 36,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/TabContent.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'BinaryExpression',
                                                                                                        operator: '+',
                                                                                                        left: {
                                                                                                            type: 'BinaryExpression',
                                                                                                            operator: '+',
                                                                                                            left: {
                                                                                                                type: 'Literal',
                                                                                                                value: ''
                                                                                                            },
                                                                                                            right: {
                                                                                                                type: 'BinaryExpression',
                                                                                                                operator: '*',
                                                                                                                left: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: 100
                                                                                                                },
                                                                                                                right: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'index',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 38,
                                                                                                                            column: 47,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/material/TabContent.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 38,
                                                                                                                            column: 52,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/material/TabContent.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        right: {
                                                                                                            type: 'Literal',
                                                                                                            value: '%'
                                                                                                        }
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '3'
                                                                                                }
                                                                                            ]
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 33,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/TabContent.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 39,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/TabContent.ion'
                                                                                }
                                                                            },
                                                                            order: '1'
                                                                        }
                                                                    ]
                                                                },
                                                                alternate: null,
                                                                order: '2'
                                                            }
                                                        ]
                                                    },
                                                    remove: null,
                                                    order: '2'
                                                }
                                            ]
                                        },
                                        loc: {
                                            start: {
                                                line: 21,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/TabContent.ion'
                                            },
                                            end: {
                                                line: 39,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/TabContent.ion'
                                            }
                                        },
                                        order: '1'
                                    }
                                ]
                            },
                            loc: {
                                start: {
                                    line: 17,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/TabContent.ion'
                                },
                                end: {
                                    line: 39,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/TabContent.ion'
                                }
                            },
                            order: '0'
                        },
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'Identifier',
                                        name: 'Tabs',
                                        loc: {
                                            start: {
                                                line: 39,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/TabContent.ion'
                                            },
                                            end: {
                                                line: 39,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/TabContent.ion'
                                            }
                                        }
                                    },
                                    arguments: [],
                                    loc: {
                                        start: {
                                            line: 39,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/TabContent.ion'
                                        },
                                        end: {
                                            line: 39,
                                            column: 14,
                                            fixed: true,
                                            source: 'glass/html/material/TabContent.ion'
                                        }
                                    }
                                },
                                properties: [{
                                        type: 'ForOfStatement',
                                        left: {
                                            type: 'VariableDeclaration',
                                            declarations: [{
                                                    type: 'VariableDeclarator',
                                                    id: {
                                                        type: 'Identifier',
                                                        name: 'config',
                                                        loc: {
                                                            start: {
                                                                line: 40,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/TabContent.ion'
                                                            },
                                                            end: {
                                                                line: 40,
                                                                column: 22,
                                                                fixed: true,
                                                                source: 'glass/html/material/TabContent.ion'
                                                            }
                                                        }
                                                    },
                                                    init: null
                                                }],
                                            kind: 'let'
                                        },
                                        right: {
                                            type: 'Identifier',
                                            name: 'tabs',
                                            loc: {
                                                start: {
                                                    line: 40,
                                                    column: 26,
                                                    fixed: true,
                                                    source: 'glass/html/material/TabContent.ion'
                                                },
                                                end: {
                                                    line: 40,
                                                    column: 30,
                                                    fixed: true,
                                                    source: 'glass/html/material/TabContent.ion'
                                                }
                                            }
                                        },
                                        body: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'Tab',
                                                                loc: {
                                                                    start: {
                                                                        line: 41,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/TabContent.ion'
                                                                    },
                                                                    end: {
                                                                        line: 41,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/TabContent.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [],
                                                            loc: {
                                                                start: {
                                                                    line: 41,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TabContent.ion'
                                                                },
                                                                end: {
                                                                    line: 41,
                                                                    column: 21,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TabContent.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'selected',
                                                                    loc: {
                                                                        start: {
                                                                            line: 42,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TabContent.ion'
                                                                        },
                                                                        end: {
                                                                            line: 42,
                                                                            column: 28,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TabContent.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '===',
                                                                    left: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'config',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 42,
                                                                                    column: 30,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/TabContent.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 42,
                                                                                    column: 36,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/TabContent.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'name',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 42,
                                                                                    column: 37,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/TabContent.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 42,
                                                                                    column: 41,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/TabContent.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 42,
                                                                                column: 30,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/TabContent.ion'
                                                                            },
                                                                            end: {
                                                                                line: 42,
                                                                                column: 41,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/TabContent.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    right: {
                                                                        type: 'Identifier',
                                                                        name: 'selectedTabName',
                                                                        loc: {
                                                                            start: {
                                                                                line: 42,
                                                                                column: 45,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/TabContent.ion'
                                                                            },
                                                                            end: {
                                                                                line: 42,
                                                                                column: 60,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/TabContent.ion'
                                                                            }
                                                                        }
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'Function',
                                                                    context: true,
                                                                    value: function (_context) {
                                                                        return function selected(e) {
                                                                            var state = _context.get('state'), config = _context.get('config');
                                                                            state.tab = config.name;
                                                                            config.cache = true;
                                                                        };
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 43,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/TabContent.ion'
                                                                    },
                                                                    end: {
                                                                        line: 46,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/TabContent.ion'
                                                                    }
                                                                },
                                                                order: '1'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'config',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 46,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/TabContent.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 46,
                                                                                    column: 26,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/TabContent.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'tab',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 46,
                                                                                    column: 27,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/TabContent.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 46,
                                                                                    column: 30,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/TabContent.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 46,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/TabContent.ion'
                                                                            },
                                                                            end: {
                                                                                line: 46,
                                                                                column: 30,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/TabContent.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [],
                                                                    loc: {
                                                                        start: {
                                                                            line: 46,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TabContent.ion'
                                                                        },
                                                                        end: {
                                                                            line: 46,
                                                                            column: 32,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TabContent.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 46,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/TabContent.ion'
                                                                    },
                                                                    end: {
                                                                        line: 46,
                                                                        column: 32,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/TabContent.ion'
                                                                    }
                                                                },
                                                                order: '2'
                                                            }
                                                        ]
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 41,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/TabContent.ion'
                                                        },
                                                        end: {
                                                            line: 48,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'glass/html/material/TabContent.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        remove: null,
                                        order: '0'
                                    }]
                            },
                            loc: {
                                start: {
                                    line: 39,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/TabContent.ion'
                                },
                                end: {
                                    line: 48,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/material/TabContent.ion'
                                }
                            },
                            order: '1'
                        }
                    ]
                },
                order: '6'
            }
        ],
        bound: false
    }, {
        this: this,
        args: args,
        _ref: _ref,
        _ref2: _ref2,
        Tabs: Tabs,
        Tab: Tab,
        style: style
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/TabContent',_glass_html_material_TabContent_);
    else
      _glass_html_material_TabContent_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_TabContent_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_Tabs_ = function(module,exports,require){'use strict';
var ion = require('ion');
var style = require('../style');
ion.template(function () {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [{
                type: 'ExpressionStatement',
                expression: {
                    type: 'CallExpression',
                    callee: {
                        type: 'MemberExpression',
                        computed: false,
                        object: {
                            type: 'Identifier',
                            name: 'style',
                            loc: {
                                start: {
                                    line: 5,
                                    column: 4,
                                    fixed: true,
                                    source: 'glass/html/material/Tabs.ion'
                                },
                                end: {
                                    line: 5,
                                    column: 9,
                                    fixed: true,
                                    source: 'glass/html/material/Tabs.ion'
                                }
                            }
                        },
                        property: {
                            type: 'Identifier',
                            name: 'define',
                            loc: {
                                start: {
                                    line: 5,
                                    column: 10,
                                    fixed: true,
                                    source: 'glass/html/material/Tabs.ion'
                                },
                                end: {
                                    line: 5,
                                    column: 16,
                                    fixed: true,
                                    source: 'glass/html/material/Tabs.ion'
                                }
                            }
                        },
                        loc: {
                            start: {
                                line: 5,
                                column: 4,
                                fixed: true,
                                source: 'glass/html/material/Tabs.ion'
                            },
                            end: {
                                line: 5,
                                column: 16,
                                fixed: true,
                                source: 'glass/html/material/Tabs.ion'
                            }
                        }
                    },
                    arguments: [
                        {
                            type: 'MemberExpression',
                            computed: false,
                            object: {
                                type: 'Identifier',
                                name: 'module',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/Tabs.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 14,
                                        fixed: true,
                                        source: 'glass/html/material/Tabs.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'id',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/Tabs.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/html/material/Tabs.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 6,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/Tabs.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 17,
                                    fixed: true,
                                    source: 'glass/html/material/Tabs.ion'
                                }
                            }
                        },
                        {
                            type: 'BinaryExpression',
                            operator: '+',
                            left: {
                                type: 'BinaryExpression',
                                operator: '+',
                                left: {
                                    type: 'Literal',
                                    value: '.Tabs {\n    /*background: white;*/\n    color: rgba(0, 0, 0, '
                                },
                                right: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'style',
                                            loc: {
                                                start: {
                                                    line: 10,
                                                    column: 39,
                                                    fixed: true,
                                                    source: 'glass/html/material/Tabs.ion'
                                                },
                                                end: {
                                                    line: 10,
                                                    column: 44,
                                                    fixed: true,
                                                    source: 'glass/html/material/Tabs.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'opacity',
                                            loc: {
                                                start: {
                                                    line: 10,
                                                    column: 45,
                                                    fixed: true,
                                                    source: 'glass/html/material/Tabs.ion'
                                                },
                                                end: {
                                                    line: 10,
                                                    column: 52,
                                                    fixed: true,
                                                    source: 'glass/html/material/Tabs.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 10,
                                                column: 39,
                                                fixed: true,
                                                source: 'glass/html/material/Tabs.ion'
                                            },
                                            end: {
                                                line: 10,
                                                column: 52,
                                                fixed: true,
                                                source: 'glass/html/material/Tabs.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'text',
                                        loc: {
                                            start: {
                                                line: 10,
                                                column: 53,
                                                fixed: true,
                                                source: 'glass/html/material/Tabs.ion'
                                            },
                                            end: {
                                                line: 10,
                                                column: 57,
                                                fixed: true,
                                                source: 'glass/html/material/Tabs.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 10,
                                            column: 39,
                                            fixed: true,
                                            source: 'glass/html/material/Tabs.ion'
                                        },
                                        end: {
                                            line: 10,
                                            column: 57,
                                            fixed: true,
                                            source: 'glass/html/material/Tabs.ion'
                                        }
                                    }
                                }
                            },
                            right: {
                                type: 'Literal',
                                value: ');\n    list-style:none;\n    margin:0;\n    padding:0;\n    position:relative;\n}'
                            }
                        }
                    ],
                    loc: {
                        start: {
                            line: 5,
                            column: 4,
                            fixed: true,
                            source: 'glass/html/material/Tabs.ion'
                        },
                        end: {
                            line: 16,
                            column: 5,
                            fixed: true,
                            source: 'glass/html/material/Tabs.ion'
                        }
                    }
                },
                loc: {
                    start: {
                        line: 5,
                        column: 4,
                        fixed: true,
                        source: 'glass/html/material/Tabs.ion'
                    },
                    end: {
                        line: 16,
                        column: 5,
                        fixed: true,
                        source: 'glass/html/material/Tabs.ion'
                    }
                },
                order: '0'
            }],
        bound: false
    }, {
        this: this,
        module: module,
        style: style
    }, null);
})().observe();
module.exports = exports = ion.template(function () {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [{
                type: 'ReturnStatement',
                argument: {
                    type: 'CallExpression',
                    callee: {
                        type: 'Identifier',
                        name: 'Ul',
                        loc: {
                            start: {
                                line: 18,
                                column: 22,
                                fixed: true,
                                source: 'glass/html/material/Tabs.ion'
                            },
                            end: {
                                line: 18,
                                column: 24,
                                fixed: true,
                                source: 'glass/html/material/Tabs.ion'
                            }
                        }
                    },
                    arguments: [{
                            type: 'ObjectExpression',
                            properties: [{
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'class',
                                        loc: {
                                            start: {
                                                line: 18,
                                                column: 26,
                                                fixed: true,
                                                source: 'glass/html/material/Tabs.ion'
                                            },
                                            end: {
                                                line: 18,
                                                column: 31,
                                                fixed: true,
                                                source: 'glass/html/material/Tabs.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: 'Tabs layout horizontal fixed z1'
                                    },
                                    kind: 'init',
                                    order: '0'
                                }]
                        }],
                    loc: {
                        start: {
                            line: 18,
                            column: 22,
                            fixed: true,
                            source: 'glass/html/material/Tabs.ion'
                        },
                        end: {
                            line: 18,
                            column: 67,
                            fixed: true,
                            source: 'glass/html/material/Tabs.ion'
                        }
                    }
                },
                order: '0'
            }],
        bound: false
    }, {
        this: this,
        style: style
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/Tabs',_glass_html_material_Tabs_);
    else
      _glass_html_material_Tabs_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_Tabs_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_TextField_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('../../data'), _ref2, _ref3;
var Schema = _ref.Schema;
_ref2 = require('./');
var Input = _ref2.Input;
_ref3 = require('..');
var style = _ref3.style;
ion.template(function () {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [{
                type: 'ExpressionStatement',
                expression: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'MemberExpression',
                        computed: false,
                        object: {
                            type: 'Identifier',
                            name: 'style',
                            loc: {
                                start: {
                                    line: 7,
                                    column: 4,
                                    fixed: true,
                                    source: 'glass/html/material/TextField.ion'
                                },
                                end: {
                                    line: 7,
                                    column: 9,
                                    fixed: true,
                                    source: 'glass/html/material/TextField.ion'
                                }
                            }
                        },
                        property: {
                            type: 'Identifier',
                            name: 'sheets',
                            loc: {
                                start: {
                                    line: 7,
                                    column: 10,
                                    fixed: true,
                                    source: 'glass/html/material/TextField.ion'
                                },
                                end: {
                                    line: 7,
                                    column: 16,
                                    fixed: true,
                                    source: 'glass/html/material/TextField.ion'
                                }
                            }
                        },
                        loc: {
                            start: {
                                line: 7,
                                column: 4,
                                fixed: true,
                                source: 'glass/html/material/TextField.ion'
                            },
                            end: {
                                line: 7,
                                column: 16,
                                fixed: true,
                                source: 'glass/html/material/TextField.ion'
                            }
                        }
                    },
                    properties: [{
                            type: 'Property',
                            key: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'module',
                                    loc: {
                                        start: {
                                            line: 8,
                                            column: 9,
                                            fixed: true,
                                            source: 'glass/html/material/TextField.ion'
                                        },
                                        end: {
                                            line: 8,
                                            column: 15,
                                            fixed: true,
                                            source: 'glass/html/material/TextField.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'id',
                                    loc: {
                                        start: {
                                            line: 8,
                                            column: 16,
                                            fixed: true,
                                            source: 'glass/html/material/TextField.ion'
                                        },
                                        end: {
                                            line: 8,
                                            column: 18,
                                            fixed: true,
                                            source: 'glass/html/material/TextField.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 8,
                                        column: 9,
                                        fixed: true,
                                        source: 'glass/html/material/TextField.ion'
                                    },
                                    end: {
                                        line: 8,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/material/TextField.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'BinaryExpression',
                                operator: '+',
                                left: {
                                    type: 'BinaryExpression',
                                    operator: '+',
                                    left: {
                                        type: 'BinaryExpression',
                                        operator: '+',
                                        left: {
                                            type: 'BinaryExpression',
                                            operator: '+',
                                            left: {
                                                type: 'BinaryExpression',
                                                operator: '+',
                                                left: {
                                                    type: 'BinaryExpression',
                                                    operator: '+',
                                                    left: {
                                                        type: 'BinaryExpression',
                                                        operator: '+',
                                                        left: {
                                                            type: 'BinaryExpression',
                                                            operator: '+',
                                                            left: {
                                                                type: 'BinaryExpression',
                                                                operator: '+',
                                                                left: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '+',
                                                                    left: {
                                                                        type: 'BinaryExpression',
                                                                        operator: '+',
                                                                        left: {
                                                                            type: 'BinaryExpression',
                                                                            operator: '+',
                                                                            left: {
                                                                                type: 'BinaryExpression',
                                                                                operator: '+',
                                                                                left: {
                                                                                    type: 'BinaryExpression',
                                                                                    operator: '+',
                                                                                    left: {
                                                                                        type: 'BinaryExpression',
                                                                                        operator: '+',
                                                                                        left: {
                                                                                            type: 'BinaryExpression',
                                                                                            operator: '+',
                                                                                            left: {
                                                                                                type: 'BinaryExpression',
                                                                                                operator: '+',
                                                                                                left: {
                                                                                                    type: 'BinaryExpression',
                                                                                                    operator: '+',
                                                                                                    left: {
                                                                                                        type: 'Literal',
                                                                                                        value: '.TextField {\n    padding-top: 8px;\n    padding-bottom: 8px;\n}\n\n.TextField .label {\n    font-size: 12px;\n    color: '
                                                                                                    },
                                                                                                    right: {
                                                                                                        type: 'CallExpression',
                                                                                                        callee: {
                                                                                                            type: 'MemberExpression',
                                                                                                            computed: false,
                                                                                                            object: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'style',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 16,
                                                                                                                        column: 25,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 16,
                                                                                                                        column: 30,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            property: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'toRgba',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 16,
                                                                                                                        column: 31,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 16,
                                                                                                                        column: 37,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 16,
                                                                                                                    column: 25,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/TextField.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 16,
                                                                                                                    column: 37,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/TextField.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        arguments: [
                                                                                                            {
                                                                                                                type: 'MemberExpression',
                                                                                                                computed: false,
                                                                                                                object: {
                                                                                                                    type: 'MemberExpression',
                                                                                                                    computed: false,
                                                                                                                    object: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'style',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 16,
                                                                                                                                column: 38,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/TextField.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 16,
                                                                                                                                column: 43,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/TextField.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    property: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'color',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 16,
                                                                                                                                column: 44,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/TextField.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 16,
                                                                                                                                column: 49,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/TextField.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 16,
                                                                                                                            column: 38,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 16,
                                                                                                                            column: 49,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                property: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'accent',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 16,
                                                                                                                            column: 50,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 16,
                                                                                                                            column: 56,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 16,
                                                                                                                        column: 38,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 16,
                                                                                                                        column: 56,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'MemberExpression',
                                                                                                                computed: false,
                                                                                                                object: {
                                                                                                                    type: 'MemberExpression',
                                                                                                                    computed: false,
                                                                                                                    object: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'style',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 16,
                                                                                                                                column: 57,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/TextField.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 16,
                                                                                                                                column: 62,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/TextField.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    property: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'opacity',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 16,
                                                                                                                                column: 63,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/TextField.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 16,
                                                                                                                                column: 70,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/TextField.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 16,
                                                                                                                            column: 57,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 16,
                                                                                                                            column: 70,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                property: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'text',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 16,
                                                                                                                            column: 71,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 16,
                                                                                                                            column: 75,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 16,
                                                                                                                        column: 57,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 16,
                                                                                                                        column: 75,
                                                                                                                        fixed: true,
                                                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            }
                                                                                                        ],
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 16,
                                                                                                                column: 25,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/TextField.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 16,
                                                                                                                column: 76,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/TextField.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                right: {
                                                                                                    type: 'Literal',
                                                                                                    value: ';\n    margin-top: 8px;\n}\n\n.TextField .input {\n    border:none;\n    outline: none;\n    font-size: 14px;\n    background: none;\n    margin-top: 8px;\n    padding: 12px 0;\n    # border-bottom: solid '
                                                                                                }
                                                                                            },
                                                                                            right: {
                                                                                                type: 'MemberExpression',
                                                                                                computed: false,
                                                                                                object: {
                                                                                                    type: 'MemberExpression',
                                                                                                    computed: false,
                                                                                                    object: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'style',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 27,
                                                                                                                column: 41,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/TextField.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 27,
                                                                                                                column: 46,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/TextField.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    property: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'color',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 27,
                                                                                                                column: 47,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/TextField.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 27,
                                                                                                                column: 52,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/TextField.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 27,
                                                                                                            column: 41,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 27,
                                                                                                            column: 52,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'accent',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 27,
                                                                                                            column: 53,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 27,
                                                                                                            column: 59,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 27,
                                                                                                        column: 41,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 27,
                                                                                                        column: 59,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        right: {
                                                                                            type: 'Literal',
                                                                                            value: ' 2px;\n    width:100%;\n    position:relative;\n}\n.TextField.inline .input {\n    margin-top: 0;\n}\n\n.errorMessageContainer {\n    position:relative;\n}\n\n.TextField .input + .errorMessageContainer::before {\n    content:\' \';\n    display:block;\n    width:100%;\n    height:2px;\n    transition: width 0.2s linear;\n    background-color:'
                                                                                        }
                                                                                    },
                                                                                    right: {
                                                                                        type: 'CallExpression',
                                                                                        callee: {
                                                                                            type: 'MemberExpression',
                                                                                            computed: false,
                                                                                            object: {
                                                                                                type: 'Identifier',
                                                                                                name: 'style',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 46,
                                                                                                        column: 35,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 46,
                                                                                                        column: 40,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            property: {
                                                                                                type: 'Identifier',
                                                                                                name: 'toRgba',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 46,
                                                                                                        column: 41,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 46,
                                                                                                        column: 47,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 46,
                                                                                                    column: 35,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/TextField.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 46,
                                                                                                    column: 47,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/TextField.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        arguments: [
                                                                                            {
                                                                                                type: 'MemberExpression',
                                                                                                computed: false,
                                                                                                object: {
                                                                                                    type: 'MemberExpression',
                                                                                                    computed: false,
                                                                                                    object: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'style',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 46,
                                                                                                                column: 48,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/TextField.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 46,
                                                                                                                column: 53,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/TextField.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    property: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'color',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 46,
                                                                                                                column: 54,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/TextField.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 46,
                                                                                                                column: 59,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/TextField.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 46,
                                                                                                            column: 48,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 46,
                                                                                                            column: 59,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'black',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 46,
                                                                                                            column: 60,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 46,
                                                                                                            column: 65,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 46,
                                                                                                        column: 48,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 46,
                                                                                                        column: 65,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            {
                                                                                                type: 'MemberExpression',
                                                                                                computed: false,
                                                                                                object: {
                                                                                                    type: 'MemberExpression',
                                                                                                    computed: false,
                                                                                                    object: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'style',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 46,
                                                                                                                column: 67,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/TextField.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 46,
                                                                                                                column: 72,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/TextField.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    property: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'opacity',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 46,
                                                                                                                column: 73,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/TextField.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 46,
                                                                                                                column: 80,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/TextField.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 46,
                                                                                                            column: 67,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 46,
                                                                                                            column: 80,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'hint',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 46,
                                                                                                            column: 81,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 46,
                                                                                                            column: 85,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 46,
                                                                                                        column: 67,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 46,
                                                                                                        column: 85,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        ],
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 46,
                                                                                                column: 35,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/TextField.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 46,
                                                                                                column: 86,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/TextField.ion'
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                },
                                                                                right: {
                                                                                    type: 'Literal',
                                                                                    value: ';\n    position:absolute;\n    left:0;\n    top:-2px;\n}\n\n.TextField .input:focus + .errorMessageContainer::before {\n    background-color:'
                                                                                }
                                                                            },
                                                                            right: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'style',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 53,
                                                                                                column: 35,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/TextField.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 53,
                                                                                                column: 40,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/TextField.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'color',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 53,
                                                                                                column: 41,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/TextField.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 53,
                                                                                                column: 46,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/TextField.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 53,
                                                                                            column: 35,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 53,
                                                                                            column: 46,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'primary',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 53,
                                                                                            column: 47,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 53,
                                                                                            column: 54,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 53,
                                                                                        column: 35,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 53,
                                                                                        column: 54,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                    }
                                                                                }
                                                                            }
                                                                        },
                                                                        right: {
                                                                            type: 'Literal',
                                                                            value: ';\n}\n\n.TextField.inline .input:not(:focus) + .errorMessageContainer::before {\n    background-color:transparent;\n}\n\n.TextField .input:focus + .overline + .underline, .TextField .input:focus + .overline {\n    border-bottom: solid '
                                                                        }
                                                                    },
                                                                    right: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'style',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 61,
                                                                                        column: 39,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 61,
                                                                                        column: 44,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'color',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 61,
                                                                                        column: 45,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 61,
                                                                                        column: 50,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 61,
                                                                                    column: 39,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/TextField.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 61,
                                                                                    column: 50,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/TextField.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'accent',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 61,
                                                                                    column: 51,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/TextField.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 61,
                                                                                    column: 57,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/TextField.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 61,
                                                                                column: 39,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/TextField.ion'
                                                                            },
                                                                            end: {
                                                                                line: 61,
                                                                                column: 57,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/TextField.ion'
                                                                            }
                                                                        }
                                                                    }
                                                                },
                                                                right: {
                                                                    type: 'Literal',
                                                                    value: ' 1px;\n    width: 100%;\n}\n\n.TextField .underline {\n    margin-bottom: 8px;\n    width: 0%;\n    border-bottom: solid transparent 1px;\n    transition: width 0.2s linear;\n}\n\n.TextField.error .input {\n    border-bottom-color: '
                                                                }
                                                            },
                                                            right: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'style',
                                                                        loc: {
                                                                            start: {
                                                                                line: 73,
                                                                                column: 39,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/TextField.ion'
                                                                            },
                                                                            end: {
                                                                                line: 73,
                                                                                column: 44,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/TextField.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'color',
                                                                        loc: {
                                                                            start: {
                                                                                line: 73,
                                                                                column: 45,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/TextField.ion'
                                                                            },
                                                                            end: {
                                                                                line: 73,
                                                                                column: 50,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/TextField.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 73,
                                                                            column: 39,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TextField.ion'
                                                                        },
                                                                        end: {
                                                                            line: 73,
                                                                            column: 50,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TextField.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'error',
                                                                    loc: {
                                                                        start: {
                                                                            line: 73,
                                                                            column: 51,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TextField.ion'
                                                                        },
                                                                        end: {
                                                                            line: 73,
                                                                            column: 56,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TextField.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 73,
                                                                        column: 39,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/TextField.ion'
                                                                    },
                                                                    end: {
                                                                        line: 73,
                                                                        column: 56,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/TextField.ion'
                                                                    }
                                                                }
                                                            }
                                                        },
                                                        right: {
                                                            type: 'Literal',
                                                            value: ' !important;\n}\n\n.TextField .bottom {\n    font-size: 12px;\n}\n\n.TextField .errorMessage {\n    color: '
                                                        }
                                                    },
                                                    right: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'style',
                                                                loc: {
                                                                    start: {
                                                                        line: 81,
                                                                        column: 26,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/TextField.ion'
                                                                    },
                                                                    end: {
                                                                        line: 81,
                                                                        column: 31,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/TextField.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'color',
                                                                loc: {
                                                                    start: {
                                                                        line: 81,
                                                                        column: 32,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/TextField.ion'
                                                                    },
                                                                    end: {
                                                                        line: 81,
                                                                        column: 37,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/TextField.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 81,
                                                                    column: 26,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TextField.ion'
                                                                },
                                                                end: {
                                                                    line: 81,
                                                                    column: 37,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TextField.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'error',
                                                            loc: {
                                                                start: {
                                                                    line: 81,
                                                                    column: 38,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TextField.ion'
                                                                },
                                                                end: {
                                                                    line: 81,
                                                                    column: 43,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TextField.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 81,
                                                                column: 26,
                                                                fixed: true,
                                                                source: 'glass/html/material/TextField.ion'
                                                            },
                                                            end: {
                                                                line: 81,
                                                                column: 43,
                                                                fixed: true,
                                                                source: 'glass/html/material/TextField.ion'
                                                            }
                                                        }
                                                    }
                                                },
                                                right: {
                                                    type: 'Literal',
                                                    value: ';\n}\n\n.TextField:not(.error) .errorMessage {\n    visibility: hidden;\n}\n\n.TextField .characterCounter {\n    opacity: '
                                                }
                                            },
                                            right: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'style',
                                                        loc: {
                                                            start: {
                                                                line: 89,
                                                                column: 28,
                                                                fixed: true,
                                                                source: 'glass/html/material/TextField.ion'
                                                            },
                                                            end: {
                                                                line: 89,
                                                                column: 33,
                                                                fixed: true,
                                                                source: 'glass/html/material/TextField.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'opacity',
                                                        loc: {
                                                            start: {
                                                                line: 89,
                                                                column: 34,
                                                                fixed: true,
                                                                source: 'glass/html/material/TextField.ion'
                                                            },
                                                            end: {
                                                                line: 89,
                                                                column: 41,
                                                                fixed: true,
                                                                source: 'glass/html/material/TextField.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 89,
                                                            column: 28,
                                                            fixed: true,
                                                            source: 'glass/html/material/TextField.ion'
                                                        },
                                                        end: {
                                                            line: 89,
                                                            column: 41,
                                                            fixed: true,
                                                            source: 'glass/html/material/TextField.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'secondary',
                                                    loc: {
                                                        start: {
                                                            line: 89,
                                                            column: 42,
                                                            fixed: true,
                                                            source: 'glass/html/material/TextField.ion'
                                                        },
                                                        end: {
                                                            line: 89,
                                                            column: 51,
                                                            fixed: true,
                                                            source: 'glass/html/material/TextField.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 89,
                                                        column: 28,
                                                        fixed: true,
                                                        source: 'glass/html/material/TextField.ion'
                                                    },
                                                    end: {
                                                        line: 89,
                                                        column: 51,
                                                        fixed: true,
                                                        source: 'glass/html/material/TextField.ion'
                                                    }
                                                }
                                            }
                                        },
                                        right: {
                                            type: 'Literal',
                                            value: ';\n}\n\n.TextField .characterCounter.error {\n    color: '
                                        }
                                    },
                                    right: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'style',
                                                loc: {
                                                    start: {
                                                        line: 93,
                                                        column: 26,
                                                        fixed: true,
                                                        source: 'glass/html/material/TextField.ion'
                                                    },
                                                    end: {
                                                        line: 93,
                                                        column: 31,
                                                        fixed: true,
                                                        source: 'glass/html/material/TextField.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'color',
                                                loc: {
                                                    start: {
                                                        line: 93,
                                                        column: 32,
                                                        fixed: true,
                                                        source: 'glass/html/material/TextField.ion'
                                                    },
                                                    end: {
                                                        line: 93,
                                                        column: 37,
                                                        fixed: true,
                                                        source: 'glass/html/material/TextField.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 93,
                                                    column: 26,
                                                    fixed: true,
                                                    source: 'glass/html/material/TextField.ion'
                                                },
                                                end: {
                                                    line: 93,
                                                    column: 37,
                                                    fixed: true,
                                                    source: 'glass/html/material/TextField.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'error',
                                            loc: {
                                                start: {
                                                    line: 93,
                                                    column: 38,
                                                    fixed: true,
                                                    source: 'glass/html/material/TextField.ion'
                                                },
                                                end: {
                                                    line: 93,
                                                    column: 43,
                                                    fixed: true,
                                                    source: 'glass/html/material/TextField.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 93,
                                                column: 26,
                                                fixed: true,
                                                source: 'glass/html/material/TextField.ion'
                                            },
                                            end: {
                                                line: 93,
                                                column: 43,
                                                fixed: true,
                                                source: 'glass/html/material/TextField.ion'
                                            }
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: ';\n    opacity: 1;\n}\n\n.TextField.inline .characterCounter {\n    display:none;\n}\n\n.TextField.inline input{\n    padding-left:0;\n    padding-right:0;\n}\n\n.TextField.inline input:focus ~ .errorMessageContainer .characterCounter{\n    display:inline;\n}'
                                }
                            },
                            kind: 'init',
                            computed: true,
                            order: '0'
                        }]
                },
                loc: {
                    start: {
                        line: 7,
                        column: 4,
                        fixed: true,
                        source: 'glass/html/material/TextField.ion'
                    },
                    end: {
                        line: 110,
                        column: 8,
                        fixed: true,
                        source: 'glass/html/material/TextField.ion'
                    }
                },
                order: '0'
            }],
        bound: false
    }, {
        this: this,
        module: module,
        _ref: _ref,
        _ref2: _ref2,
        _ref3: _ref3,
        Schema: Schema,
        Input: Input,
        style: style
    }, null);
})().observe();
module.exports = exports = ion.template(function (_ref4) {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'property',
                            loc: {
                                start: {
                                    line: 110,
                                    column: 18,
                                    fixed: true,
                                    source: 'glass/html/material/TextField.ion'
                                },
                                end: {
                                    line: 110,
                                    column: 26,
                                    fixed: true,
                                    source: 'glass/html/material/TextField.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref4'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'property',
                                loc: {
                                    start: {
                                        line: 110,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/material/TextField.ion'
                                    },
                                    end: {
                                        line: 110,
                                        column: 26,
                                        fixed: true,
                                        source: 'glass/html/material/TextField.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'object',
                            loc: {
                                start: {
                                    line: 110,
                                    column: 27,
                                    fixed: true,
                                    source: 'glass/html/material/TextField.ion'
                                },
                                end: {
                                    line: 110,
                                    column: 33,
                                    fixed: true,
                                    source: 'glass/html/material/TextField.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref4'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'object',
                                loc: {
                                    start: {
                                        line: 110,
                                        column: 27,
                                        fixed: true,
                                        source: 'glass/html/material/TextField.ion'
                                    },
                                    end: {
                                        line: 110,
                                        column: 33,
                                        fixed: true,
                                        source: 'glass/html/material/TextField.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: '_value',
                            loc: {
                                start: {
                                    line: 110,
                                    column: 40,
                                    fixed: true,
                                    source: 'glass/html/material/TextField.ion'
                                },
                                end: {
                                    line: 110,
                                    column: 46,
                                    fixed: true,
                                    source: 'glass/html/material/TextField.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref4'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'value',
                                loc: {
                                    start: {
                                        line: 110,
                                        column: 34,
                                        fixed: true,
                                        source: 'glass/html/material/TextField.ion'
                                    },
                                    end: {
                                        line: 110,
                                        column: 39,
                                        fixed: true,
                                        source: 'glass/html/material/TextField.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'value',
                            loc: {
                                start: {
                                    line: 111,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/TextField.ion'
                                },
                                end: {
                                    line: 111,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/html/material/TextField.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Function',
                                context: true,
                                value: function (_context) {
                                    return function () {
                                        var _value = _context.get('_value'), Schema = _context.get('Schema'), object = _context.get('object'), property = _context.get('property');
                                        return _value != null ? _value : Schema.get(object, property);
                                    };
                                }
                            },
                            arguments: [],
                            loc: {
                                start: {
                                    line: 111,
                                    column: 16,
                                    fixed: true,
                                    source: 'glass/html/material/TextField.ion'
                                },
                                end: {
                                    line: 111,
                                    column: 59,
                                    fixed: true,
                                    source: 'glass/html/material/TextField.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '3'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'state',
                            loc: {
                                start: {
                                    line: 113,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/TextField.ion'
                                },
                                end: {
                                    line: 113,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/html/material/TextField.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'focus',
                                        loc: {
                                            start: {
                                                line: 114,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/TextField.ion'
                                            },
                                            end: {
                                                line: 114,
                                                column: 13,
                                                fixed: true,
                                                source: 'glass/html/material/TextField.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: false
                                    },
                                    kind: 'init',
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'floatingLabel',
                                        loc: {
                                            start: {
                                                line: 115,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/TextField.ion'
                                            },
                                            end: {
                                                line: 115,
                                                column: 21,
                                                fixed: true,
                                                source: 'glass/html/material/TextField.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: true
                                    },
                                    kind: 'init',
                                    order: '1'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'placeholder',
                                        loc: {
                                            start: {
                                                line: 116,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/TextField.ion'
                                            },
                                            end: {
                                                line: 116,
                                                column: 19,
                                                fixed: true,
                                                source: 'glass/html/material/TextField.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: true
                                    },
                                    kind: 'init',
                                    order: '2'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'value',
                                        loc: {
                                            start: {
                                                line: 117,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/TextField.ion'
                                            },
                                            end: {
                                                line: 117,
                                                column: 13,
                                                fixed: true,
                                                source: 'glass/html/material/TextField.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Identifier',
                                        name: 'value',
                                        loc: {
                                            start: {
                                                line: 117,
                                                column: 15,
                                                fixed: true,
                                                source: 'glass/html/material/TextField.ion'
                                            },
                                            end: {
                                                line: 117,
                                                column: 20,
                                                fixed: true,
                                                source: 'glass/html/material/TextField.ion'
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '3'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'validated',
                                        loc: {
                                            start: {
                                                line: 118,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/TextField.ion'
                                            },
                                            end: {
                                                line: 118,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/material/TextField.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: false
                                    },
                                    kind: 'init',
                                    order: '4'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'error',
                                        loc: {
                                            start: {
                                                line: 119,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/TextField.ion'
                                            },
                                            end: {
                                                line: 119,
                                                column: 13,
                                                fixed: true,
                                                source: 'glass/html/material/TextField.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: null
                                    },
                                    kind: 'init',
                                    order: '5'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'inline',
                                        loc: {
                                            start: {
                                                line: 120,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/material/TextField.ion'
                                            },
                                            end: {
                                                line: 120,
                                                column: 14,
                                                fixed: true,
                                                source: 'glass/html/material/TextField.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: false
                                    },
                                    kind: 'init',
                                    order: '6'
                                }
                            ]
                        }
                    }],
                kind: 'let',
                order: '4'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'inputElement',
                            loc: {
                                start: {
                                    line: 122,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/TextField.ion'
                                },
                                end: {
                                    line: 122,
                                    column: 20,
                                    fixed: true,
                                    source: 'glass/html/material/TextField.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Input',
                                    loc: {
                                        start: {
                                            line: 122,
                                            column: 23,
                                            fixed: true,
                                            source: 'glass/html/material/TextField.ion'
                                        },
                                        end: {
                                            line: 122,
                                            column: 28,
                                            fixed: true,
                                            source: 'glass/html/material/TextField.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'property',
                                                    loc: {
                                                        start: {
                                                            line: 122,
                                                            column: 30,
                                                            fixed: true,
                                                            source: 'glass/html/material/TextField.ion'
                                                        },
                                                        end: {
                                                            line: 122,
                                                            column: 38,
                                                            fixed: true,
                                                            source: 'glass/html/material/TextField.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Identifier',
                                                    name: 'property',
                                                    loc: {
                                                        start: {
                                                            line: 122,
                                                            column: 30,
                                                            fixed: true,
                                                            source: 'glass/html/material/TextField.ion'
                                                        },
                                                        end: {
                                                            line: 122,
                                                            column: 38,
                                                            fixed: true,
                                                            source: 'glass/html/material/TextField.ion'
                                                        }
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'object',
                                                    loc: {
                                                        start: {
                                                            line: 122,
                                                            column: 39,
                                                            fixed: true,
                                                            source: 'glass/html/material/TextField.ion'
                                                        },
                                                        end: {
                                                            line: 122,
                                                            column: 45,
                                                            fixed: true,
                                                            source: 'glass/html/material/TextField.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Identifier',
                                                    name: 'object',
                                                    loc: {
                                                        start: {
                                                            line: 122,
                                                            column: 39,
                                                            fixed: true,
                                                            source: 'glass/html/material/TextField.ion'
                                                        },
                                                        end: {
                                                            line: 122,
                                                            column: 45,
                                                            fixed: true,
                                                            source: 'glass/html/material/TextField.ion'
                                                        }
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'value',
                                                    loc: {
                                                        start: {
                                                            line: 122,
                                                            column: 46,
                                                            fixed: true,
                                                            source: 'glass/html/material/TextField.ion'
                                                        },
                                                        end: {
                                                            line: 122,
                                                            column: 51,
                                                            fixed: true,
                                                            source: 'glass/html/material/TextField.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Identifier',
                                                    name: 'value',
                                                    loc: {
                                                        start: {
                                                            line: 122,
                                                            column: 46,
                                                            fixed: true,
                                                            source: 'glass/html/material/TextField.ion'
                                                        },
                                                        end: {
                                                            line: 122,
                                                            column: 51,
                                                            fixed: true,
                                                            source: 'glass/html/material/TextField.ion'
                                                        }
                                                    }
                                                },
                                                kind: 'init',
                                                order: '2'
                                            }
                                        ]
                                    }],
                                loc: {
                                    start: {
                                        line: 122,
                                        column: 23,
                                        fixed: true,
                                        source: 'glass/html/material/TextField.ion'
                                    },
                                    end: {
                                        line: 122,
                                        column: 53,
                                        fixed: true,
                                        source: 'glass/html/material/TextField.ion'
                                    }
                                }
                            },
                            properties: [
                                {
                                    type: 'VariableDeclaration',
                                    declarations: [{
                                            type: 'VariableDeclarator',
                                            id: {
                                                type: 'Identifier',
                                                name: 'updateValue',
                                                loc: {
                                                    start: {
                                                        line: 123,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/TextField.ion'
                                                    },
                                                    end: {
                                                        line: 123,
                                                        column: 23,
                                                        fixed: true,
                                                        source: 'glass/html/material/TextField.ion'
                                                    }
                                                }
                                            },
                                            init: {
                                                type: 'Function',
                                                context: true,
                                                value: function (_context2) {
                                                    return function (e) {
                                                        var state = _context2.get('state'), Schema = _context2.get('Schema'), inputElement = _context2.get('inputElement'), property = _context2.get('property'), field = _context2.get('field');
                                                        state.value = Schema.coerce(inputElement.valueJSON, property);
                                                        if (field.validated) {
                                                            field.validate();
                                                        }
                                                    };
                                                }
                                            }
                                        }],
                                    kind: 'let',
                                    order: '0'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context3) {
                                            return function input(e) {
                                                var updateValue = _context3.get('updateValue');
                                                return updateValue(e);
                                            };
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 127,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/TextField.ion'
                                        },
                                        end: {
                                            line: 127,
                                            column: 34,
                                            fixed: true,
                                            source: 'glass/html/material/TextField.ion'
                                        }
                                    },
                                    order: '1'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context4) {
                                            return function change(e) {
                                                var updateValue = _context4.get('updateValue');
                                                return updateValue(e);
                                            };
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 128,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/TextField.ion'
                                        },
                                        end: {
                                            line: 128,
                                            column: 35,
                                            fixed: true,
                                            source: 'glass/html/material/TextField.ion'
                                        }
                                    },
                                    order: '2'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context5) {
                                            return function commit(e) {
                                                var updateValue = _context5.get('updateValue');
                                                return updateValue(e);
                                            };
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 129,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/TextField.ion'
                                        },
                                        end: {
                                            line: 129,
                                            column: 35,
                                            fixed: true,
                                            source: 'glass/html/material/TextField.ion'
                                        }
                                    },
                                    order: '3'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context6) {
                                            return function blur(e) {
                                                var field = _context6.get('field');
                                                field.validate();
                                            };
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 130,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/material/TextField.ion'
                                        },
                                        end: {
                                            line: 132,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/html/material/TextField.ion'
                                        }
                                    },
                                    order: '4'
                                }
                            ]
                        }
                    }],
                kind: 'let',
                order: '5'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'labelText',
                            loc: {
                                start: {
                                    line: 132,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/TextField.ion'
                                },
                                end: {
                                    line: 132,
                                    column: 17,
                                    fixed: true,
                                    source: 'glass/html/material/TextField.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'ConditionalExpression',
                                    test: {
                                        type: 'BinaryExpression',
                                        operator: '!=',
                                        left: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'property',
                                                loc: {
                                                    start: {
                                                        line: 132,
                                                        column: 21,
                                                        fixed: true,
                                                        source: 'glass/html/material/TextField.ion'
                                                    },
                                                    end: {
                                                        line: 132,
                                                        column: 29,
                                                        fixed: true,
                                                        source: 'glass/html/material/TextField.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'title',
                                                loc: {
                                                    start: {
                                                        line: 132,
                                                        column: 30,
                                                        fixed: true,
                                                        source: 'glass/html/material/TextField.ion'
                                                    },
                                                    end: {
                                                        line: 132,
                                                        column: 35,
                                                        fixed: true,
                                                        source: 'glass/html/material/TextField.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 132,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'glass/html/material/TextField.ion'
                                                },
                                                end: {
                                                    line: 132,
                                                    column: 35,
                                                    fixed: true,
                                                    source: 'glass/html/material/TextField.ion'
                                                }
                                            }
                                        },
                                        right: {
                                            type: 'Literal',
                                            value: null
                                        }
                                    },
                                    consequent: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'property',
                                            loc: {
                                                start: {
                                                    line: 132,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'glass/html/material/TextField.ion'
                                                },
                                                end: {
                                                    line: 132,
                                                    column: 29,
                                                    fixed: true,
                                                    source: 'glass/html/material/TextField.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'title',
                                            loc: {
                                                start: {
                                                    line: 132,
                                                    column: 30,
                                                    fixed: true,
                                                    source: 'glass/html/material/TextField.ion'
                                                },
                                                end: {
                                                    line: 132,
                                                    column: 35,
                                                    fixed: true,
                                                    source: 'glass/html/material/TextField.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 132,
                                                column: 21,
                                                fixed: true,
                                                source: 'glass/html/material/TextField.ion'
                                            },
                                            end: {
                                                line: 132,
                                                column: 35,
                                                fixed: true,
                                                source: 'glass/html/material/TextField.ion'
                                            }
                                        }
                                    },
                                    alternate: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'property',
                                            loc: {
                                                start: {
                                                    line: 132,
                                                    column: 38,
                                                    fixed: true,
                                                    source: 'glass/html/material/TextField.ion'
                                                },
                                                end: {
                                                    line: 132,
                                                    column: 46,
                                                    fixed: true,
                                                    source: 'glass/html/material/TextField.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'name',
                                            loc: {
                                                start: {
                                                    line: 132,
                                                    column: 47,
                                                    fixed: true,
                                                    source: 'glass/html/material/TextField.ion'
                                                },
                                                end: {
                                                    line: 132,
                                                    column: 51,
                                                    fixed: true,
                                                    source: 'glass/html/material/TextField.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 132,
                                                column: 38,
                                                fixed: true,
                                                source: 'glass/html/material/TextField.ion'
                                            },
                                            end: {
                                                line: 132,
                                                column: 51,
                                                fixed: true,
                                                source: 'glass/html/material/TextField.ion'
                                            }
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'capitalize',
                                    loc: {
                                        start: {
                                            line: 132,
                                            column: 53,
                                            fixed: true,
                                            source: 'glass/html/material/TextField.ion'
                                        },
                                        end: {
                                            line: 132,
                                            column: 63,
                                            fixed: true,
                                            source: 'glass/html/material/TextField.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 132,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/material/TextField.ion'
                                    },
                                    end: {
                                        line: 132,
                                        column: 63,
                                        fixed: true,
                                        source: 'glass/html/material/TextField.ion'
                                    }
                                }
                            },
                            arguments: [],
                            loc: {
                                start: {
                                    line: 132,
                                    column: 20,
                                    fixed: true,
                                    source: 'glass/html/material/TextField.ion'
                                },
                                end: {
                                    line: 132,
                                    column: 65,
                                    fixed: true,
                                    source: 'glass/html/material/TextField.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '6'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'field',
                            loc: {
                                start: {
                                    line: 133,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/TextField.ion'
                                },
                                end: {
                                    line: 133,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/html/material/TextField.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: 'Object'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'defineProperties'
                                }
                            },
                            arguments: [
                                {
                                    type: 'ObjectExpression',
                                    objectType: {
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'Identifier',
                                            name: 'Div',
                                            loc: {
                                                start: {
                                                    line: 133,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/html/material/TextField.ion'
                                                },
                                                end: {
                                                    line: 133,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'glass/html/material/TextField.ion'
                                                }
                                            }
                                        },
                                        arguments: [{
                                                type: 'ObjectExpression',
                                                properties: [{
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'class',
                                                            loc: {
                                                                start: {
                                                                    line: 133,
                                                                    column: 21,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TextField.ion'
                                                                },
                                                                end: {
                                                                    line: 133,
                                                                    column: 26,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TextField.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Literal',
                                                            value: 'TextField validate'
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    }]
                                            }],
                                        loc: {
                                            start: {
                                                line: 133,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/html/material/TextField.ion'
                                            },
                                            end: {
                                                line: 133,
                                                column: 49,
                                                fixed: true,
                                                source: 'glass/html/material/TextField.ion'
                                            }
                                        }
                                    },
                                    properties: [
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'Function',
                                                context: false,
                                                value: function click() {
                                                    return this.focus();
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 134,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'glass/html/material/TextField.ion'
                                                },
                                                end: {
                                                    line: 134,
                                                    column: 25,
                                                    fixed: true,
                                                    source: 'glass/html/material/TextField.ion'
                                                }
                                            },
                                            order: '0'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'name',
                                                loc: {
                                                    start: {
                                                        line: 135,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'glass/html/material/TextField.ion'
                                                    },
                                                    end: {
                                                        line: 135,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/TextField.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'property',
                                                    loc: {
                                                        start: {
                                                            line: 135,
                                                            column: 14,
                                                            fixed: true,
                                                            source: 'glass/html/material/TextField.ion'
                                                        },
                                                        end: {
                                                            line: 135,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'glass/html/material/TextField.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'name',
                                                    loc: {
                                                        start: {
                                                            line: 135,
                                                            column: 23,
                                                            fixed: true,
                                                            source: 'glass/html/material/TextField.ion'
                                                        },
                                                        end: {
                                                            line: 135,
                                                            column: 27,
                                                            fixed: true,
                                                            source: 'glass/html/material/TextField.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 135,
                                                        column: 14,
                                                        fixed: true,
                                                        source: 'glass/html/material/TextField.ion'
                                                    },
                                                    end: {
                                                        line: 135,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'glass/html/material/TextField.ion'
                                                    }
                                                }
                                            },
                                            kind: 'init',
                                            order: '1'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'classList',
                                                loc: {
                                                    start: {
                                                        line: 136,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'glass/html/material/TextField.ion'
                                                    },
                                                    end: {
                                                        line: 136,
                                                        column: 17,
                                                        fixed: true,
                                                        source: 'glass/html/material/TextField.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'ObjectExpression',
                                                properties: [
                                                    {
                                                        type: 'IfStatement',
                                                        test: {
                                                            type: 'BinaryExpression',
                                                            operator: '&&',
                                                            left: {
                                                                type: 'UnaryExpression',
                                                                operator: '?',
                                                                argument: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'state',
                                                                        loc: {
                                                                            start: {
                                                                                line: 137,
                                                                                column: 15,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/TextField.ion'
                                                                            },
                                                                            end: {
                                                                                line: 137,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/TextField.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'error',
                                                                        loc: {
                                                                            start: {
                                                                                line: 137,
                                                                                column: 21,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/TextField.ion'
                                                                            },
                                                                            end: {
                                                                                line: 137,
                                                                                column: 26,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/TextField.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 137,
                                                                            column: 15,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TextField.ion'
                                                                        },
                                                                        end: {
                                                                            line: 137,
                                                                            column: 26,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TextField.ion'
                                                                        }
                                                                    }
                                                                }
                                                            },
                                                            right: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'state',
                                                                    loc: {
                                                                        start: {
                                                                            line: 137,
                                                                            column: 32,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TextField.ion'
                                                                        },
                                                                        end: {
                                                                            line: 137,
                                                                            column: 37,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TextField.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'validated',
                                                                    loc: {
                                                                        start: {
                                                                            line: 137,
                                                                            column: 38,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TextField.ion'
                                                                        },
                                                                        end: {
                                                                            line: 137,
                                                                            column: 47,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TextField.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 137,
                                                                        column: 32,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/TextField.ion'
                                                                    },
                                                                    end: {
                                                                        line: 137,
                                                                        column: 47,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/TextField.ion'
                                                                    }
                                                                }
                                                            }
                                                        },
                                                        consequent: {
                                                            type: 'BlockStatement',
                                                            body: [{
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'Literal',
                                                                        value: 'error'
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 138,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TextField.ion'
                                                                        },
                                                                        end: {
                                                                            line: 138,
                                                                            column: 23,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TextField.ion'
                                                                        }
                                                                    },
                                                                    order: '0'
                                                                }]
                                                        },
                                                        alternate: null,
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'IfStatement',
                                                        test: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'state',
                                                                loc: {
                                                                    start: {
                                                                        line: 139,
                                                                        column: 15,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/TextField.ion'
                                                                    },
                                                                    end: {
                                                                        line: 139,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/TextField.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'inline',
                                                                loc: {
                                                                    start: {
                                                                        line: 139,
                                                                        column: 21,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/TextField.ion'
                                                                    },
                                                                    end: {
                                                                        line: 139,
                                                                        column: 27,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/TextField.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 139,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TextField.ion'
                                                                },
                                                                end: {
                                                                    line: 139,
                                                                    column: 27,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TextField.ion'
                                                                }
                                                            }
                                                        },
                                                        consequent: {
                                                            type: 'BlockStatement',
                                                            body: [{
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'Literal',
                                                                        value: 'inline'
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 140,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TextField.ion'
                                                                        },
                                                                        end: {
                                                                            line: 140,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TextField.ion'
                                                                        }
                                                                    },
                                                                    order: '0'
                                                                }]
                                                        },
                                                        alternate: null,
                                                        order: '1'
                                                    }
                                                ]
                                            },
                                            kind: 'init',
                                            order: '2'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'clear',
                                                loc: {
                                                    start: {
                                                        line: 141,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'glass/html/material/TextField.ion'
                                                    },
                                                    end: {
                                                        line: 141,
                                                        column: 13,
                                                        fixed: true,
                                                        source: 'glass/html/material/TextField.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Function',
                                                context: true,
                                                value: function (_context7) {
                                                    return function () {
                                                        var state = _context7.get('state');
                                                        this.value = null;
                                                        state.validated = false;
                                                    };
                                                }
                                            },
                                            kind: 'init',
                                            order: '3'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'focus',
                                                loc: {
                                                    start: {
                                                        line: 144,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'glass/html/material/TextField.ion'
                                                    },
                                                    end: {
                                                        line: 144,
                                                        column: 13,
                                                        fixed: true,
                                                        source: 'glass/html/material/TextField.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Function',
                                                context: true,
                                                value: function (_context8) {
                                                    return function () {
                                                        var inputElement = _context8.get('inputElement');
                                                        inputElement.focus();
                                                    };
                                                }
                                            },
                                            kind: 'init',
                                            order: '4'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'select',
                                                loc: {
                                                    start: {
                                                        line: 146,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'glass/html/material/TextField.ion'
                                                    },
                                                    end: {
                                                        line: 146,
                                                        column: 14,
                                                        fixed: true,
                                                        source: 'glass/html/material/TextField.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Function',
                                                context: true,
                                                value: function (_context9) {
                                                    return function () {
                                                        var inputElement = _context9.get('inputElement');
                                                        inputElement.select != null ? inputElement.select() : void 0;
                                                    };
                                                }
                                            },
                                            kind: 'init',
                                            order: '5'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'validate',
                                                loc: {
                                                    start: {
                                                        line: 172,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'glass/html/material/TextField.ion'
                                                    },
                                                    end: {
                                                        line: 172,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'glass/html/material/TextField.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Function',
                                                context: true,
                                                value: function (_context10) {
                                                    return function () {
                                                        var state = _context10.get('state');
                                                        state.validated = true;
                                                        return this.valid;
                                                    };
                                                }
                                            },
                                            kind: 'init',
                                            order: '6'
                                        },
                                        {
                                            type: 'IfStatement',
                                            test: {
                                                type: 'BinaryExpression',
                                                operator: '&&',
                                                left: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'state',
                                                        loc: {
                                                            start: {
                                                                line: 175,
                                                                column: 11,
                                                                fixed: true,
                                                                source: 'glass/html/material/TextField.ion'
                                                            },
                                                            end: {
                                                                line: 175,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/TextField.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'floatingLabel',
                                                        loc: {
                                                            start: {
                                                                line: 175,
                                                                column: 17,
                                                                fixed: true,
                                                                source: 'glass/html/material/TextField.ion'
                                                            },
                                                            end: {
                                                                line: 175,
                                                                column: 30,
                                                                fixed: true,
                                                                source: 'glass/html/material/TextField.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 175,
                                                            column: 11,
                                                            fixed: true,
                                                            source: 'glass/html/material/TextField.ion'
                                                        },
                                                        end: {
                                                            line: 175,
                                                            column: 30,
                                                            fixed: true,
                                                            source: 'glass/html/material/TextField.ion'
                                                        }
                                                    }
                                                },
                                                right: {
                                                    type: 'UnaryExpression',
                                                    operator: '!',
                                                    argument: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'state',
                                                            loc: {
                                                                start: {
                                                                    line: 175,
                                                                    column: 39,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TextField.ion'
                                                                },
                                                                end: {
                                                                    line: 175,
                                                                    column: 44,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TextField.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'inline',
                                                            loc: {
                                                                start: {
                                                                    line: 175,
                                                                    column: 45,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TextField.ion'
                                                                },
                                                                end: {
                                                                    line: 175,
                                                                    column: 51,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TextField.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 175,
                                                                column: 39,
                                                                fixed: true,
                                                                source: 'glass/html/material/TextField.ion'
                                                            },
                                                            end: {
                                                                line: 175,
                                                                column: 51,
                                                                fixed: true,
                                                                source: 'glass/html/material/TextField.ion'
                                                            }
                                                        }
                                                    }
                                                }
                                            },
                                            consequent: {
                                                type: 'BlockStatement',
                                                body: [{
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'ObjectExpression',
                                                            objectType: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Identifier',
                                                                    name: 'Div',
                                                                    loc: {
                                                                        start: {
                                                                            line: 176,
                                                                            column: 12,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TextField.ion'
                                                                        },
                                                                        end: {
                                                                            line: 176,
                                                                            column: 15,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TextField.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'ObjectExpression',
                                                                        properties: [{
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'class',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 176,
                                                                                            column: 17,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 176,
                                                                                            column: 22,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Literal',
                                                                                    value: 'label'
                                                                                },
                                                                                kind: 'init',
                                                                                order: '0'
                                                                            }]
                                                                    }],
                                                                loc: {
                                                                    start: {
                                                                        line: 176,
                                                                        column: 12,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/TextField.ion'
                                                                    },
                                                                    end: {
                                                                        line: 176,
                                                                        column: 32,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/TextField.ion'
                                                                    }
                                                                }
                                                            },
                                                            properties: [
                                                                {
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'style',
                                                                        loc: {
                                                                            start: {
                                                                                line: 177,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/TextField.ion'
                                                                            },
                                                                            end: {
                                                                                line: 177,
                                                                                column: 21,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/TextField.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'ObjectExpression',
                                                                        properties: [{
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'visibility',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 178,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 178,
                                                                                            column: 30,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'ConditionalExpression',
                                                                                    test: {
                                                                                        type: 'BinaryExpression',
                                                                                        operator: '||',
                                                                                        left: {
                                                                                            type: 'MemberExpression',
                                                                                            computed: false,
                                                                                            object: {
                                                                                                type: 'Identifier',
                                                                                                name: 'state',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 178,
                                                                                                        column: 32,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 178,
                                                                                                        column: 37,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            property: {
                                                                                                type: 'Identifier',
                                                                                                name: 'focus',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 178,
                                                                                                        column: 38,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 178,
                                                                                                        column: 43,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 178,
                                                                                                    column: 32,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/TextField.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 178,
                                                                                                    column: 43,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/TextField.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        right: {
                                                                                            type: 'UnaryExpression',
                                                                                            operator: '?',
                                                                                            argument: {
                                                                                                type: 'MemberExpression',
                                                                                                computed: false,
                                                                                                object: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'state',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 178,
                                                                                                            column: 47,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 178,
                                                                                                            column: 52,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'value',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 178,
                                                                                                            column: 53,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 178,
                                                                                                            column: 58,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 178,
                                                                                                        column: 47,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 178,
                                                                                                        column: 58,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    consequent: {
                                                                                        type: 'Literal',
                                                                                        value: ''
                                                                                    },
                                                                                    alternate: {
                                                                                        type: 'Literal',
                                                                                        value: 'hidden'
                                                                                    }
                                                                                },
                                                                                kind: 'init',
                                                                                order: '0'
                                                                            }]
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                },
                                                                {
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'Identifier',
                                                                        name: 'labelText',
                                                                        loc: {
                                                                            start: {
                                                                                line: 179,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/TextField.ion'
                                                                            },
                                                                            end: {
                                                                                line: 179,
                                                                                column: 25,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/TextField.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 179,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TextField.ion'
                                                                        },
                                                                        end: {
                                                                            line: 179,
                                                                            column: 25,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TextField.ion'
                                                                        }
                                                                    },
                                                                    order: '1'
                                                                }
                                                            ]
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 176,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'glass/html/material/TextField.ion'
                                                            },
                                                            end: {
                                                                line: 180,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/TextField.ion'
                                                            }
                                                        },
                                                        order: '0'
                                                    }]
                                            },
                                            alternate: null,
                                            order: '7'
                                        },
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'ObjectExpression',
                                                objectType: {
                                                    type: 'Identifier',
                                                    name: 'inputElement',
                                                    loc: {
                                                        start: {
                                                            line: 180,
                                                            column: 8,
                                                            fixed: true,
                                                            source: 'glass/html/material/TextField.ion'
                                                        },
                                                        end: {
                                                            line: 180,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'glass/html/material/TextField.ion'
                                                        }
                                                    }
                                                },
                                                properties: [
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'classList',
                                                            loc: {
                                                                start: {
                                                                    line: 181,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TextField.ion'
                                                                },
                                                                end: {
                                                                    line: 181,
                                                                    column: 21,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TextField.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'ObjectExpression',
                                                            properties: [{
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'Literal',
                                                                        value: 'input'
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 182,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TextField.ion'
                                                                        },
                                                                        end: {
                                                                            line: 182,
                                                                            column: 23,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TextField.ion'
                                                                        }
                                                                    },
                                                                    order: '0'
                                                                }]
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'IfStatement',
                                                        test: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'state',
                                                                loc: {
                                                                    start: {
                                                                        line: 183,
                                                                        column: 15,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/TextField.ion'
                                                                    },
                                                                    end: {
                                                                        line: 183,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/TextField.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'placeholder',
                                                                loc: {
                                                                    start: {
                                                                        line: 183,
                                                                        column: 21,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/TextField.ion'
                                                                    },
                                                                    end: {
                                                                        line: 183,
                                                                        column: 32,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/TextField.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 183,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TextField.ion'
                                                                },
                                                                end: {
                                                                    line: 183,
                                                                    column: 32,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TextField.ion'
                                                                }
                                                            }
                                                        },
                                                        consequent: {
                                                            type: 'BlockStatement',
                                                            body: [{
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'placeholder',
                                                                        loc: {
                                                                            start: {
                                                                                line: 184,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/TextField.ion'
                                                                            },
                                                                            end: {
                                                                                line: 184,
                                                                                column: 27,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/TextField.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'ConditionalExpression',
                                                                        test: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'state',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 184,
                                                                                        column: 29,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 184,
                                                                                        column: 34,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'focus',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 184,
                                                                                        column: 35,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 184,
                                                                                        column: 40,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 184,
                                                                                    column: 29,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/TextField.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 184,
                                                                                    column: 40,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/TextField.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        consequent: {
                                                                            type: 'Literal',
                                                                            value: ''
                                                                        },
                                                                        alternate: {
                                                                            type: 'Identifier',
                                                                            name: 'labelText',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 184,
                                                                                    column: 48,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/TextField.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 184,
                                                                                    column: 57,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/TextField.ion'
                                                                                }
                                                                            }
                                                                        }
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                }]
                                                        },
                                                        alternate: null,
                                                        order: '1'
                                                    },
                                                    {
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'Function',
                                                            context: true,
                                                            value: function (_context11) {
                                                                return function focus() {
                                                                    var state = _context11.get('state');
                                                                    return state.focus = true;
                                                                };
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 185,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'glass/html/material/TextField.ion'
                                                            },
                                                            end: {
                                                                line: 185,
                                                                column: 39,
                                                                fixed: true,
                                                                source: 'glass/html/material/TextField.ion'
                                                            }
                                                        },
                                                        order: '2'
                                                    },
                                                    {
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'Function',
                                                            context: true,
                                                            value: function (_context12) {
                                                                return function blur() {
                                                                    var state = _context12.get('state');
                                                                    return state.focus = false;
                                                                };
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 186,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'glass/html/material/TextField.ion'
                                                            },
                                                            end: {
                                                                line: 186,
                                                                column: 39,
                                                                fixed: true,
                                                                source: 'glass/html/material/TextField.ion'
                                                            }
                                                        },
                                                        order: '3'
                                                    }
                                                ]
                                            },
                                            loc: {
                                                start: {
                                                    line: 180,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'glass/html/material/TextField.ion'
                                                },
                                                end: {
                                                    line: 187,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/TextField.ion'
                                                }
                                            },
                                            order: '8'
                                        },
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'ObjectExpression',
                                                objectType: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'Identifier',
                                                        name: 'Div',
                                                        loc: {
                                                            start: {
                                                                line: 187,
                                                                column: 8,
                                                                fixed: true,
                                                                source: 'glass/html/material/TextField.ion'
                                                            },
                                                            end: {
                                                                line: 187,
                                                                column: 11,
                                                                fixed: true,
                                                                source: 'glass/html/material/TextField.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [{
                                                            type: 'ObjectExpression',
                                                            properties: [{
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'class',
                                                                        loc: {
                                                                            start: {
                                                                                line: 187,
                                                                                column: 13,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/TextField.ion'
                                                                            },
                                                                            end: {
                                                                                line: 187,
                                                                                column: 18,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/TextField.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Literal',
                                                                        value: 'layout horizontal bottom errorMessageContainer'
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                }]
                                                        }],
                                                    loc: {
                                                        start: {
                                                            line: 187,
                                                            column: 8,
                                                            fixed: true,
                                                            source: 'glass/html/material/TextField.ion'
                                                        },
                                                        end: {
                                                            line: 187,
                                                            column: 69,
                                                            fixed: true,
                                                            source: 'glass/html/material/TextField.ion'
                                                        }
                                                    }
                                                },
                                                properties: [
                                                    {
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'ObjectExpression',
                                                            objectType: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Identifier',
                                                                    name: 'Span',
                                                                    loc: {
                                                                        start: {
                                                                            line: 188,
                                                                            column: 12,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TextField.ion'
                                                                        },
                                                                        end: {
                                                                            line: 188,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TextField.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'ObjectExpression',
                                                                        properties: [{
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'class',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 188,
                                                                                            column: 18,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 188,
                                                                                            column: 23,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Literal',
                                                                                    value: 'flex errorMessage'
                                                                                },
                                                                                kind: 'init',
                                                                                order: '0'
                                                                            }]
                                                                    }],
                                                                loc: {
                                                                    start: {
                                                                        line: 188,
                                                                        column: 12,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/TextField.ion'
                                                                    },
                                                                    end: {
                                                                        line: 188,
                                                                        column: 45,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/TextField.ion'
                                                                    }
                                                                }
                                                            },
                                                            properties: [{
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'ConditionalExpression',
                                                                        test: {
                                                                            type: 'BinaryExpression',
                                                                            operator: '!=',
                                                                            left: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'Identifier',
                                                                                    name: 'property',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 189,
                                                                                            column: 16,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 189,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'errorMessage',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 189,
                                                                                            column: 25,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 189,
                                                                                            column: 37,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 189,
                                                                                        column: 16,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 189,
                                                                                        column: 37,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            right: {
                                                                                type: 'Literal',
                                                                                value: null
                                                                            }
                                                                        },
                                                                        consequent: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'property',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 189,
                                                                                        column: 16,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 189,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'errorMessage',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 189,
                                                                                        column: 25,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 189,
                                                                                        column: 37,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 189,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/TextField.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 189,
                                                                                    column: 37,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/TextField.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        alternate: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'state',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 189,
                                                                                        column: 40,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 189,
                                                                                        column: 45,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'error',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 189,
                                                                                        column: 46,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 189,
                                                                                        column: 51,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 189,
                                                                                    column: 40,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/TextField.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 189,
                                                                                    column: 51,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/TextField.ion'
                                                                                }
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 189,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TextField.ion'
                                                                        },
                                                                        end: {
                                                                            line: 189,
                                                                            column: 51,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TextField.ion'
                                                                        }
                                                                    },
                                                                    order: '0'
                                                                }]
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 188,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'glass/html/material/TextField.ion'
                                                            },
                                                            end: {
                                                                line: 190,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/TextField.ion'
                                                            }
                                                        },
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'IfStatement',
                                                        test: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'property',
                                                                loc: {
                                                                    start: {
                                                                        line: 190,
                                                                        column: 15,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/TextField.ion'
                                                                    },
                                                                    end: {
                                                                        line: 190,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/TextField.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'maxLength',
                                                                loc: {
                                                                    start: {
                                                                        line: 190,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/TextField.ion'
                                                                    },
                                                                    end: {
                                                                        line: 190,
                                                                        column: 33,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/TextField.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 190,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TextField.ion'
                                                                },
                                                                end: {
                                                                    line: 190,
                                                                    column: 33,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TextField.ion'
                                                                }
                                                            }
                                                        },
                                                        consequent: {
                                                            type: 'BlockStatement',
                                                            body: [{
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'ObjectExpression',
                                                                        objectType: {
                                                                            type: 'CallExpression',
                                                                            callee: {
                                                                                type: 'Identifier',
                                                                                name: 'Span',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 191,
                                                                                        column: 16,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 191,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            arguments: [{
                                                                                    type: 'ObjectExpression',
                                                                                    properties: [{
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'class',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 191,
                                                                                                        column: 22,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 191,
                                                                                                        column: 27,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'Literal',
                                                                                                value: 'characterCounter fixed'
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '0'
                                                                                        }]
                                                                                }],
                                                                            loc: {
                                                                                start: {
                                                                                    line: 191,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/TextField.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 191,
                                                                                    column: 54,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/TextField.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        properties: [
                                                                            {
                                                                                type: 'VariableDeclaration',
                                                                                declarations: [{
                                                                                        type: 'VariableDeclarator',
                                                                                        id: {
                                                                                            type: 'Identifier',
                                                                                            name: 'length',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 192,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/TextField.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 192,
                                                                                                    column: 30,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/TextField.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        init: {
                                                                                            type: 'ConditionalExpression',
                                                                                            test: {
                                                                                                type: 'BinaryExpression',
                                                                                                operator: '!=',
                                                                                                left: {
                                                                                                    type: 'MemberExpression',
                                                                                                    computed: false,
                                                                                                    object: {
                                                                                                        type: 'MemberExpression',
                                                                                                        computed: false,
                                                                                                        object: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'state',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 192,
                                                                                                                    column: 33,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/TextField.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 192,
                                                                                                                    column: 38,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/TextField.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        property: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'value',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 192,
                                                                                                                    column: 39,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/TextField.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 192,
                                                                                                                    column: 44,
                                                                                                                    fixed: true,
                                                                                                                    source: 'glass/html/material/TextField.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 192,
                                                                                                                column: 33,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/TextField.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 192,
                                                                                                                column: 44,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/TextField.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    property: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'length',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 192,
                                                                                                                column: 46,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/TextField.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 192,
                                                                                                                column: 52,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/TextField.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    existential: true,
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 192,
                                                                                                            column: 33,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 192,
                                                                                                            column: 52,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                right: {
                                                                                                    type: 'Literal',
                                                                                                    value: null
                                                                                                }
                                                                                            },
                                                                                            consequent: {
                                                                                                type: 'MemberExpression',
                                                                                                computed: false,
                                                                                                object: {
                                                                                                    type: 'MemberExpression',
                                                                                                    computed: false,
                                                                                                    object: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'state',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 192,
                                                                                                                column: 33,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/TextField.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 192,
                                                                                                                column: 38,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/TextField.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    property: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'value',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 192,
                                                                                                                column: 39,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/TextField.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 192,
                                                                                                                column: 44,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/TextField.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 192,
                                                                                                            column: 33,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 192,
                                                                                                            column: 44,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'length',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 192,
                                                                                                            column: 46,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 192,
                                                                                                            column: 52,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                existential: true,
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 192,
                                                                                                        column: 33,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 192,
                                                                                                        column: 52,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            alternate: {
                                                                                                type: 'Literal',
                                                                                                value: 0
                                                                                            }
                                                                                        }
                                                                                    }],
                                                                                kind: 'let',
                                                                                order: '0'
                                                                            },
                                                                            {
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'classList',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 193,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 193,
                                                                                            column: 29,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'ObjectExpression',
                                                                                    properties: [{
                                                                                            type: 'IfStatement',
                                                                                            test: {
                                                                                                type: 'BinaryExpression',
                                                                                                operator: '>',
                                                                                                left: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'length',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 194,
                                                                                                            column: 27,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 194,
                                                                                                            column: 33,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                right: {
                                                                                                    type: 'MemberExpression',
                                                                                                    computed: false,
                                                                                                    object: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'property',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 194,
                                                                                                                column: 36,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/TextField.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 194,
                                                                                                                column: 44,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/TextField.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    property: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'maxLength',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 194,
                                                                                                                column: 45,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/TextField.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 194,
                                                                                                                column: 54,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/TextField.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 194,
                                                                                                            column: 36,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 194,
                                                                                                            column: 54,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                                        }
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            consequent: {
                                                                                                type: 'BlockStatement',
                                                                                                body: [{
                                                                                                        type: 'ExpressionStatement',
                                                                                                        expression: {
                                                                                                            type: 'Literal',
                                                                                                            value: 'error'
                                                                                                        },
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 195,
                                                                                                                column: 28,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/TextField.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 195,
                                                                                                                column: 35,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/TextField.ion'
                                                                                                            }
                                                                                                        },
                                                                                                        order: '0'
                                                                                                    }]
                                                                                            },
                                                                                            alternate: null,
                                                                                            order: '0'
                                                                                        }]
                                                                                },
                                                                                kind: 'init',
                                                                                order: '1'
                                                                            },
                                                                            {
                                                                                type: 'ExpressionStatement',
                                                                                expression: {
                                                                                    type: 'BinaryExpression',
                                                                                    operator: '+',
                                                                                    left: {
                                                                                        type: 'BinaryExpression',
                                                                                        operator: '+',
                                                                                        left: {
                                                                                            type: 'BinaryExpression',
                                                                                            operator: '+',
                                                                                            left: {
                                                                                                type: 'Literal',
                                                                                                value: ''
                                                                                            },
                                                                                            right: {
                                                                                                type: 'ConditionalExpression',
                                                                                                test: {
                                                                                                    type: 'BinaryExpression',
                                                                                                    operator: '!=',
                                                                                                    left: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'length',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 196,
                                                                                                                column: 23,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/TextField.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 196,
                                                                                                                column: 29,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/TextField.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    right: {
                                                                                                        type: 'Literal',
                                                                                                        value: null
                                                                                                    }
                                                                                                },
                                                                                                consequent: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'length',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 196,
                                                                                                            column: 23,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 196,
                                                                                                            column: 29,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/TextField.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                alternate: {
                                                                                                    type: 'Literal',
                                                                                                    value: 0
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        right: {
                                                                                            type: 'Literal',
                                                                                            value: ' / '
                                                                                        }
                                                                                    },
                                                                                    right: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'property',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 196,
                                                                                                    column: 40,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/TextField.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 196,
                                                                                                    column: 48,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/TextField.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'maxLength',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 196,
                                                                                                    column: 49,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/TextField.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 196,
                                                                                                    column: 58,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/TextField.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 196,
                                                                                                column: 40,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/TextField.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 196,
                                                                                                column: 58,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/TextField.ion'
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 196,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 196,
                                                                                        column: 61,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/TextField.ion'
                                                                                    }
                                                                                },
                                                                                order: '2'
                                                                            }
                                                                        ]
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 191,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TextField.ion'
                                                                        },
                                                                        end: {
                                                                            line: 197,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/material/TextField.ion'
                                                                        }
                                                                    },
                                                                    order: '0'
                                                                }]
                                                        },
                                                        alternate: null,
                                                        order: '1'
                                                    }
                                                ]
                                            },
                                            loc: {
                                                start: {
                                                    line: 187,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'glass/html/material/TextField.ion'
                                                },
                                                end: {
                                                    line: 197,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/TextField.ion'
                                                }
                                            },
                                            order: '9'
                                        }
                                    ]
                                },
                                {
                                    type: 'ObjectExpression',
                                    properties: [
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'property',
                                                loc: {
                                                    start: {
                                                        line: 148,
                                                        column: 17,
                                                        fixed: true,
                                                        source: 'glass/html/material/TextField.ion'
                                                    },
                                                    end: {
                                                        line: 148,
                                                        column: 25,
                                                        fixed: true,
                                                        source: 'glass/html/material/TextField.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'ObjectExpression',
                                                properties: [{
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'get',
                                                            loc: {
                                                                start: {
                                                                    line: 149,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TextField.ion'
                                                                },
                                                                end: {
                                                                    line: 149,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TextField.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Function',
                                                            context: true,
                                                            value: function (_context13) {
                                                                return function () {
                                                                    var property = _context13.get('property');
                                                                    return property;
                                                                };
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    }]
                                            },
                                            kind: 'init',
                                            define: false,
                                            order: '0'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'value',
                                                loc: {
                                                    start: {
                                                        line: 150,
                                                        column: 17,
                                                        fixed: true,
                                                        source: 'glass/html/material/TextField.ion'
                                                    },
                                                    end: {
                                                        line: 150,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'glass/html/material/TextField.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'ObjectExpression',
                                                properties: [
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'get',
                                                            loc: {
                                                                start: {
                                                                    line: 151,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TextField.ion'
                                                                },
                                                                end: {
                                                                    line: 151,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TextField.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Function',
                                                            context: true,
                                                            value: function (_context14) {
                                                                return function () {
                                                                    var state = _context14.get('state');
                                                                    return state.value;
                                                                };
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'set',
                                                            loc: {
                                                                start: {
                                                                    line: 152,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TextField.ion'
                                                                },
                                                                end: {
                                                                    line: 152,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TextField.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Function',
                                                            context: true,
                                                            value: function (_context15) {
                                                                return function (value) {
                                                                    var inputElement = _context15.get('inputElement'), state = _context15.get('state');
                                                                    return inputElement.valueJSON = state.value = value;
                                                                };
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '1'
                                                    }
                                                ]
                                            },
                                            kind: 'init',
                                            define: false,
                                            order: '1'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'floatingLabel',
                                                loc: {
                                                    start: {
                                                        line: 153,
                                                        column: 17,
                                                        fixed: true,
                                                        source: 'glass/html/material/TextField.ion'
                                                    },
                                                    end: {
                                                        line: 153,
                                                        column: 30,
                                                        fixed: true,
                                                        source: 'glass/html/material/TextField.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'ObjectExpression',
                                                properties: [
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'get',
                                                            loc: {
                                                                start: {
                                                                    line: 154,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TextField.ion'
                                                                },
                                                                end: {
                                                                    line: 154,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TextField.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Function',
                                                            context: true,
                                                            value: function (_context16) {
                                                                return function () {
                                                                    var state = _context16.get('state');
                                                                    return state.floatingLabel;
                                                                };
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'set',
                                                            loc: {
                                                                start: {
                                                                    line: 155,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TextField.ion'
                                                                },
                                                                end: {
                                                                    line: 155,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TextField.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Function',
                                                            context: true,
                                                            value: function (_context17) {
                                                                return function (value) {
                                                                    var state = _context17.get('state');
                                                                    return state.floatingLabel = value === true;
                                                                };
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '1'
                                                    }
                                                ]
                                            },
                                            kind: 'init',
                                            define: false,
                                            order: '2'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'inline',
                                                loc: {
                                                    start: {
                                                        line: 156,
                                                        column: 17,
                                                        fixed: true,
                                                        source: 'glass/html/material/TextField.ion'
                                                    },
                                                    end: {
                                                        line: 156,
                                                        column: 23,
                                                        fixed: true,
                                                        source: 'glass/html/material/TextField.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'ObjectExpression',
                                                properties: [
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'get',
                                                            loc: {
                                                                start: {
                                                                    line: 157,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TextField.ion'
                                                                },
                                                                end: {
                                                                    line: 157,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TextField.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Function',
                                                            context: true,
                                                            value: function (_context18) {
                                                                return function () {
                                                                    var state = _context18.get('state');
                                                                    return state.inline;
                                                                };
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'set',
                                                            loc: {
                                                                start: {
                                                                    line: 158,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TextField.ion'
                                                                },
                                                                end: {
                                                                    line: 158,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TextField.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Function',
                                                            context: true,
                                                            value: function (_context19) {
                                                                return function (value) {
                                                                    var state = _context19.get('state');
                                                                    return state.inline = value === true;
                                                                };
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '1'
                                                    }
                                                ]
                                            },
                                            kind: 'init',
                                            define: false,
                                            order: '3'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'placeholder',
                                                loc: {
                                                    start: {
                                                        line: 159,
                                                        column: 17,
                                                        fixed: true,
                                                        source: 'glass/html/material/TextField.ion'
                                                    },
                                                    end: {
                                                        line: 159,
                                                        column: 28,
                                                        fixed: true,
                                                        source: 'glass/html/material/TextField.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'ObjectExpression',
                                                properties: [
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'get',
                                                            loc: {
                                                                start: {
                                                                    line: 160,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TextField.ion'
                                                                },
                                                                end: {
                                                                    line: 160,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TextField.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Function',
                                                            context: true,
                                                            value: function (_context20) {
                                                                return function () {
                                                                    var state = _context20.get('state');
                                                                    return state.placeholder;
                                                                };
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'set',
                                                            loc: {
                                                                start: {
                                                                    line: 161,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TextField.ion'
                                                                },
                                                                end: {
                                                                    line: 161,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TextField.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Function',
                                                            context: true,
                                                            value: function (_context21) {
                                                                return function (value) {
                                                                    var state = _context21.get('state');
                                                                    return state.placeholder = value === true;
                                                                };
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '1'
                                                    }
                                                ]
                                            },
                                            kind: 'init',
                                            define: false,
                                            order: '4'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'validated',
                                                loc: {
                                                    start: {
                                                        line: 162,
                                                        column: 17,
                                                        fixed: true,
                                                        source: 'glass/html/material/TextField.ion'
                                                    },
                                                    end: {
                                                        line: 162,
                                                        column: 26,
                                                        fixed: true,
                                                        source: 'glass/html/material/TextField.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'ObjectExpression',
                                                properties: [{
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'get',
                                                            loc: {
                                                                start: {
                                                                    line: 163,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TextField.ion'
                                                                },
                                                                end: {
                                                                    line: 163,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TextField.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Function',
                                                            context: true,
                                                            value: function (_context22) {
                                                                return function () {
                                                                    var state = _context22.get('state');
                                                                    return state.validated;
                                                                };
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    }]
                                            },
                                            kind: 'init',
                                            define: false,
                                            order: '5'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'valid',
                                                loc: {
                                                    start: {
                                                        line: 164,
                                                        column: 17,
                                                        fixed: true,
                                                        source: 'glass/html/material/TextField.ion'
                                                    },
                                                    end: {
                                                        line: 164,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'glass/html/material/TextField.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'ObjectExpression',
                                                properties: [{
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'get',
                                                            loc: {
                                                                start: {
                                                                    line: 165,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TextField.ion'
                                                                },
                                                                end: {
                                                                    line: 165,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TextField.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Function',
                                                            context: true,
                                                            value: function (_context23) {
                                                                return function () {
                                                                    var Schema = _context23.get('Schema'), state = _context23.get('state'), property = _context23.get('property');
                                                                    var errors = Schema.validate(state.value, property);
                                                                    state.error = (errors != null ? errors[0] : void 0) != null ? errors[0] : null;
                                                                    return !(state.error != null);
                                                                };
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    }]
                                            },
                                            kind: 'init',
                                            define: false,
                                            order: '6'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'error',
                                                loc: {
                                                    start: {
                                                        line: 169,
                                                        column: 17,
                                                        fixed: true,
                                                        source: 'glass/html/material/TextField.ion'
                                                    },
                                                    end: {
                                                        line: 169,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'glass/html/material/TextField.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'ObjectExpression',
                                                properties: [
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'get',
                                                            loc: {
                                                                start: {
                                                                    line: 170,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TextField.ion'
                                                                },
                                                                end: {
                                                                    line: 170,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TextField.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Function',
                                                            context: true,
                                                            value: function (_context24) {
                                                                return function () {
                                                                    var state = _context24.get('state');
                                                                    return state.error;
                                                                };
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'set',
                                                            loc: {
                                                                start: {
                                                                    line: 171,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TextField.ion'
                                                                },
                                                                end: {
                                                                    line: 171,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/TextField.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Function',
                                                            context: true,
                                                            value: function (_context25) {
                                                                return function (value) {
                                                                    var state = _context25.get('state');
                                                                    return state.error = value;
                                                                };
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '1'
                                                    }
                                                ]
                                            },
                                            kind: 'init',
                                            define: false,
                                            order: '7'
                                        }
                                    ]
                                }
                            ]
                        }
                    }],
                kind: 'let',
                order: '7'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'Identifier',
                    name: 'field',
                    loc: {
                        start: {
                            line: 197,
                            column: 11,
                            fixed: true,
                            source: 'glass/html/material/TextField.ion'
                        },
                        end: {
                            line: 197,
                            column: 16,
                            fixed: true,
                            source: 'glass/html/material/TextField.ion'
                        }
                    }
                },
                order: '8'
            }
        ],
        bound: false
    }, {
        this: this,
        _ref4: _ref4,
        _ref: _ref,
        _ref2: _ref2,
        _ref3: _ref3,
        Schema: Schema,
        Input: Input,
        style: style
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/TextField',_glass_html_material_TextField_);
    else
      _glass_html_material_TextField_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_TextField_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_Toaster_ = function(module,exports,require){'use strict';
var style = require('../style'), ion = require('ion');
var _ref2 = style.sheets;
_ref2[module.id] = '.Toaster {\n    background-color: rgb(240,240,240);\n    color: black;\n    border-radius: 2px;            \n    position: absolute;\n    bottom: 5px;\n    right: 5px;\n    z-index: 100;\n}\n\n.Toast {\n    z-index: 101;            \n    position: relative;\n    padding: 16px;\n    padding-top: 22px;\n    padding-bottom: 0px;\n}\n\n.Toast:hover > .CloseToast {\n    display: block;\n}\n\n.CloseToast {\n    color: rgb(200,200,200);\n    display: none;            \n    position: absolute;\n    left: 0;\n    top: 0;\n}';
_ref2;
module.exports = exports = ion.template(function () {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'touched',
                            loc: {
                                start: {
                                    line: 40,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/Toaster.ion'
                                },
                                end: {
                                    line: 40,
                                    column: 15,
                                    fixed: true,
                                    source: 'glass/html/material/Toaster.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            computed: false,
                            object: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'model',
                                    loc: {
                                        start: {
                                            line: 40,
                                            column: 18,
                                            fixed: true,
                                            source: 'glass/html/material/Toaster.ion'
                                        },
                                        end: {
                                            line: 40,
                                            column: 23,
                                            fixed: true,
                                            source: 'glass/html/material/Toaster.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'toast',
                                    loc: {
                                        start: {
                                            line: 40,
                                            column: 24,
                                            fixed: true,
                                            source: 'glass/html/material/Toaster.ion'
                                        },
                                        end: {
                                            line: 40,
                                            column: 29,
                                            fixed: true,
                                            source: 'glass/html/material/Toaster.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 40,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/material/Toaster.ion'
                                    },
                                    end: {
                                        line: 40,
                                        column: 29,
                                        fixed: true,
                                        source: 'glass/html/material/Toaster.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'touched',
                                loc: {
                                    start: {
                                        line: 40,
                                        column: 30,
                                        fixed: true,
                                        source: 'glass/html/material/Toaster.ion'
                                    },
                                    end: {
                                        line: 40,
                                        column: 37,
                                        fixed: true,
                                        source: 'glass/html/material/Toaster.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 40,
                                    column: 18,
                                    fixed: true,
                                    source: 'glass/html/material/Toaster.ion'
                                },
                                end: {
                                    line: 40,
                                    column: 37,
                                    fixed: true,
                                    source: 'glass/html/material/Toaster.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'toasts',
                            loc: {
                                start: {
                                    line: 41,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/Toaster.ion'
                                },
                                end: {
                                    line: 41,
                                    column: 14,
                                    fixed: true,
                                    source: 'glass/html/material/Toaster.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Function',
                                context: false,
                                value: function (touched) {
                                    var _ref3 = [];
                                    {
                                        var _ref = model.toast.toasts;
                                        for (var k in _ref) {
                                            var v = _ref[k];
                                            _ref3.push(v);
                                        }
                                    }
                                    return _ref3;
                                }
                            },
                            arguments: [{
                                    type: 'Identifier',
                                    name: 'touched',
                                    loc: {
                                        start: {
                                            line: 41,
                                            column: 21,
                                            fixed: true,
                                            source: 'glass/html/material/Toaster.ion'
                                        },
                                        end: {
                                            line: 41,
                                            column: 28,
                                            fixed: true,
                                            source: 'glass/html/material/Toaster.ion'
                                        }
                                    }
                                }],
                            loc: {
                                start: {
                                    line: 41,
                                    column: 17,
                                    fixed: true,
                                    source: 'glass/html/material/Toaster.ion'
                                },
                                end: {
                                    line: 45,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/Toaster.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'IfStatement',
                test: {
                    type: 'BinaryExpression',
                    operator: '===',
                    left: {
                        type: 'MemberExpression',
                        computed: false,
                        object: {
                            type: 'Identifier',
                            name: 'toasts',
                            loc: {
                                start: {
                                    line: 45,
                                    column: 7,
                                    fixed: true,
                                    source: 'glass/html/material/Toaster.ion'
                                },
                                end: {
                                    line: 45,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/html/material/Toaster.ion'
                                }
                            }
                        },
                        property: {
                            type: 'Identifier',
                            name: 'length',
                            loc: {
                                start: {
                                    line: 45,
                                    column: 14,
                                    fixed: true,
                                    source: 'glass/html/material/Toaster.ion'
                                },
                                end: {
                                    line: 45,
                                    column: 20,
                                    fixed: true,
                                    source: 'glass/html/material/Toaster.ion'
                                }
                            }
                        },
                        loc: {
                            start: {
                                line: 45,
                                column: 7,
                                fixed: true,
                                source: 'glass/html/material/Toaster.ion'
                            },
                            end: {
                                line: 45,
                                column: 20,
                                fixed: true,
                                source: 'glass/html/material/Toaster.ion'
                            }
                        }
                    },
                    right: {
                        type: 'Literal',
                        value: 0
                    }
                },
                consequent: {
                    type: 'BlockStatement',
                    body: [{
                            type: 'ReturnStatement',
                            argument: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Div',
                                    loc: {
                                        start: {
                                            line: 46,
                                            column: 15,
                                            fixed: true,
                                            source: 'glass/html/material/Toaster.ion'
                                        },
                                        end: {
                                            line: 46,
                                            column: 18,
                                            fixed: true,
                                            source: 'glass/html/material/Toaster.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'style',
                                                    loc: {
                                                        start: {
                                                            line: 46,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'glass/html/material/Toaster.ion'
                                                        },
                                                        end: {
                                                            line: 46,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'glass/html/material/Toaster.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: 'display: none '
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    }],
                                loc: {
                                    start: {
                                        line: 46,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/Toaster.ion'
                                    },
                                    end: {
                                        line: 46,
                                        column: 44,
                                        fixed: true,
                                        source: 'glass/html/material/Toaster.ion'
                                    }
                                }
                            },
                            order: '0'
                        }]
                },
                alternate: {
                    type: 'BlockStatement',
                    body: [{
                            type: 'ReturnStatement',
                            argument: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'Identifier',
                                        name: 'Div',
                                        loc: {
                                            start: {
                                                line: 48,
                                                column: 15,
                                                fixed: true,
                                                source: 'glass/html/material/Toaster.ion'
                                            },
                                            end: {
                                                line: 48,
                                                column: 18,
                                                fixed: true,
                                                source: 'glass/html/material/Toaster.ion'
                                            }
                                        }
                                    },
                                    arguments: [{
                                            type: 'ObjectExpression',
                                            properties: [{
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'class',
                                                        loc: {
                                                            start: {
                                                                line: 48,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'glass/html/material/Toaster.ion'
                                                            },
                                                            end: {
                                                                line: 48,
                                                                column: 25,
                                                                fixed: true,
                                                                source: 'glass/html/material/Toaster.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 'Toaster z3'
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                }]
                                        }],
                                    loc: {
                                        start: {
                                            line: 48,
                                            column: 15,
                                            fixed: true,
                                            source: 'glass/html/material/Toaster.ion'
                                        },
                                        end: {
                                            line: 48,
                                            column: 40,
                                            fixed: true,
                                            source: 'glass/html/material/Toaster.ion'
                                        }
                                    }
                                },
                                properties: [
                                    {
                                        type: 'ForOfStatement',
                                        left: {
                                            type: 'VariableDeclaration',
                                            declarations: [{
                                                    type: 'VariableDeclarator',
                                                    id: {
                                                        type: 'Identifier',
                                                        name: 'properties',
                                                        loc: {
                                                            start: {
                                                                line: 49,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/material/Toaster.ion'
                                                            },
                                                            end: {
                                                                line: 49,
                                                                column: 26,
                                                                fixed: true,
                                                                source: 'glass/html/material/Toaster.ion'
                                                            }
                                                        }
                                                    },
                                                    init: null
                                                }],
                                            kind: 'let'
                                        },
                                        right: {
                                            type: 'Identifier',
                                            name: 'toasts',
                                            loc: {
                                                start: {
                                                    line: 49,
                                                    column: 30,
                                                    fixed: true,
                                                    source: 'glass/html/material/Toaster.ion'
                                                },
                                                end: {
                                                    line: 49,
                                                    column: 36,
                                                    fixed: true,
                                                    source: 'glass/html/material/Toaster.ion'
                                                }
                                            }
                                        },
                                        body: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'Div',
                                                                loc: {
                                                                    start: {
                                                                        line: 50,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Toaster.ion'
                                                                    },
                                                                    end: {
                                                                        line: 50,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Toaster.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [{
                                                                    type: 'ObjectExpression',
                                                                    properties: [{
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'class',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 50,
                                                                                        column: 21,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Toaster.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 50,
                                                                                        column: 26,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Toaster.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'Toast layout horizontal justified center'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        }]
                                                                }],
                                                            loc: {
                                                                start: {
                                                                    line: 50,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Toaster.ion'
                                                                },
                                                                end: {
                                                                    line: 50,
                                                                    column: 71,
                                                                    fixed: true,
                                                                    source: 'glass/html/material/Toaster.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'ObjectExpression',
                                                                    objectType: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'Identifier',
                                                                            name: 'PaperIconButton',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 52,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Toaster.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 52,
                                                                                    column: 35,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Toaster.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [{
                                                                                type: 'ObjectExpression',
                                                                                properties: [{
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'class',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 52,
                                                                                                    column: 37,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Toaster.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 52,
                                                                                                    column: 42,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Toaster.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 'CloseToast'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    }]
                                                                            }],
                                                                        loc: {
                                                                            start: {
                                                                                line: 52,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Toaster.ion'
                                                                            },
                                                                            end: {
                                                                                line: 52,
                                                                                column: 58,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Toaster.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    properties: [
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'icon',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 53,
                                                                                        column: 28,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Toaster.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 53,
                                                                                        column: 32,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Toaster.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'close'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'Function',
                                                                                context: true,
                                                                                value: function (_context) {
                                                                                    return function click() {
                                                                                        var properties = _context.get('properties');
                                                                                        properties.remove();
                                                                                    };
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 54,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Toaster.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 57,
                                                                                    column: 32,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Toaster.ion'
                                                                                }
                                                                            },
                                                                            order: '1'
                                                                        }
                                                                    ]
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 52,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Toaster.ion'
                                                                    },
                                                                    end: {
                                                                        line: 57,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Toaster.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'ObjectExpression',
                                                                    objectType: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'Identifier',
                                                                            name: 'Div',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 57,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Toaster.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 57,
                                                                                    column: 23,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Toaster.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [],
                                                                        loc: {
                                                                            start: {
                                                                                line: 57,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Toaster.ion'
                                                                            },
                                                                            end: {
                                                                                line: 57,
                                                                                column: 25,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Toaster.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    properties: [
                                                                        {
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'Identifier',
                                                                                    name: 'properties',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 58,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Toaster.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 58,
                                                                                            column: 34,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Toaster.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'text',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 58,
                                                                                            column: 35,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Toaster.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 58,
                                                                                            column: 39,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Toaster.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 58,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Toaster.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 58,
                                                                                        column: 39,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Toaster.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 58,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Toaster.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 58,
                                                                                    column: 39,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Toaster.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'VariableDeclaration',
                                                                            declarations: [{
                                                                                    type: 'VariableDeclarator',
                                                                                    id: {
                                                                                        type: 'Identifier',
                                                                                        name: 'done',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 59,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Toaster.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 59,
                                                                                                column: 32,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Toaster.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    init: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'properties',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 59,
                                                                                                    column: 35,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Toaster.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 59,
                                                                                                    column: 45,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Toaster.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'done',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 59,
                                                                                                    column: 46,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Toaster.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 59,
                                                                                                    column: 50,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Toaster.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 59,
                                                                                                column: 35,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Toaster.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 59,
                                                                                                column: 50,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Toaster.ion'
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                }],
                                                                            kind: 'let',
                                                                            order: '1'
                                                                        },
                                                                        {
                                                                            type: 'VariableDeclaration',
                                                                            declarations: [{
                                                                                    type: 'VariableDeclarator',
                                                                                    id: {
                                                                                        type: 'Identifier',
                                                                                        name: 'doneMessage',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 60,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Toaster.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 60,
                                                                                                column: 39,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Toaster.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    init: {
                                                                                        type: 'CallExpression',
                                                                                        callee: {
                                                                                            type: 'Function',
                                                                                            context: true,
                                                                                            value: function (_context2) {
                                                                                                return function (done) {
                                                                                                    var ion = _context2.get('ion');
                                                                                                    if (done) {
                                                                                                        if (document.location.hostname === 'localhost' && false) {
                                                                                                            return 'Done (' + Math.floor(performance.now() / 100) / 10 + ' sec, ' + ion.observe.count + ' observers)';
                                                                                                        } else {
                                                                                                            return 'Done';
                                                                                                        }
                                                                                                    }
                                                                                                };
                                                                                            }
                                                                                        },
                                                                                        arguments: [{
                                                                                                type: 'Identifier',
                                                                                                name: 'done',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 60,
                                                                                                        column: 46,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Toaster.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 60,
                                                                                                        column: 50,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Toaster.ion'
                                                                                                    }
                                                                                                }
                                                                                            }],
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 60,
                                                                                                column: 42,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Toaster.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 66,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Toaster.ion'
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                }],
                                                                            kind: 'let',
                                                                            order: '2'
                                                                        },
                                                                        {
                                                                            type: 'VariableDeclaration',
                                                                            declarations: [{
                                                                                    type: 'VariableDeclarator',
                                                                                    id: {
                                                                                        type: 'Identifier',
                                                                                        name: 'text',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 66,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Toaster.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 66,
                                                                                                column: 32,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Toaster.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    init: {
                                                                                        type: 'ConditionalExpression',
                                                                                        test: {
                                                                                            type: 'BinaryExpression',
                                                                                            operator: '!=',
                                                                                            left: {
                                                                                                type: 'Identifier',
                                                                                                name: 'doneMessage',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 66,
                                                                                                        column: 35,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Toaster.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 66,
                                                                                                        column: 46,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Toaster.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            right: {
                                                                                                type: 'Literal',
                                                                                                value: null
                                                                                            }
                                                                                        },
                                                                                        consequent: {
                                                                                            type: 'Identifier',
                                                                                            name: 'doneMessage',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 66,
                                                                                                    column: 35,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Toaster.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 66,
                                                                                                    column: 46,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Toaster.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        alternate: {
                                                                                            type: 'MemberExpression',
                                                                                            computed: false,
                                                                                            object: {
                                                                                                type: 'Identifier',
                                                                                                name: 'properties',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 66,
                                                                                                        column: 49,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Toaster.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 66,
                                                                                                        column: 59,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Toaster.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            property: {
                                                                                                type: 'Identifier',
                                                                                                name: 'subtext',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 66,
                                                                                                        column: 60,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Toaster.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 66,
                                                                                                        column: 67,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Toaster.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 66,
                                                                                                    column: 49,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Toaster.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 66,
                                                                                                    column: 67,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Toaster.ion'
                                                                                                }
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                }],
                                                                            kind: 'let',
                                                                            order: '3'
                                                                        },
                                                                        {
                                                                            type: 'IfStatement',
                                                                            test: {
                                                                                type: 'UnaryExpression',
                                                                                operator: '?',
                                                                                argument: {
                                                                                    type: 'Identifier',
                                                                                    name: 'text',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 67,
                                                                                            column: 27,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Toaster.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 67,
                                                                                            column: 31,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Toaster.ion'
                                                                                        }
                                                                                    }
                                                                                }
                                                                            },
                                                                            consequent: {
                                                                                type: 'BlockStatement',
                                                                                body: [
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'CallExpression',
                                                                                            callee: {
                                                                                                type: 'Identifier',
                                                                                                name: 'Br',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 68,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Toaster.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 68,
                                                                                                        column: 30,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Toaster.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            arguments: [],
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 68,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Toaster.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 68,
                                                                                                    column: 32,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Toaster.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 68,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Toaster.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 68,
                                                                                                column: 32,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Toaster.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'ObjectExpression',
                                                                                            objectType: {
                                                                                                type: 'CallExpression',
                                                                                                callee: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'Span',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 69,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/Toaster.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 69,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/Toaster.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                arguments: [],
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 69,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Toaster.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 69,
                                                                                                        column: 34,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Toaster.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            properties: [
                                                                                                {
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'style',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 70,
                                                                                                                column: 32,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/Toaster.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 70,
                                                                                                                column: 37,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/Toaster.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'ObjectExpression',
                                                                                                        properties: [
                                                                                                            {
                                                                                                                type: 'Property',
                                                                                                                key: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'color',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 71,
                                                                                                                            column: 36,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/material/Toaster.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 71,
                                                                                                                            column: 41,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/material/Toaster.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                value: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: 'rgb(150, 150, 150)'
                                                                                                                },
                                                                                                                kind: 'init',
                                                                                                                order: '0'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'Property',
                                                                                                                key: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: 'font-size'
                                                                                                                },
                                                                                                                value: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: '12px'
                                                                                                                },
                                                                                                                kind: 'init',
                                                                                                                order: '1'
                                                                                                            }
                                                                                                        ]
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '0'
                                                                                                },
                                                                                                {
                                                                                                    type: 'ExpressionStatement',
                                                                                                    expression: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'text',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 73,
                                                                                                                column: 32,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/Toaster.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 73,
                                                                                                                column: 36,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/Toaster.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 73,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/Toaster.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 73,
                                                                                                            column: 36,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/Toaster.ion'
                                                                                                        }
                                                                                                    },
                                                                                                    order: '1'
                                                                                                }
                                                                                            ]
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 69,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Toaster.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 75,
                                                                                                column: 32,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Toaster.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '1'
                                                                                    }
                                                                                ]
                                                                            },
                                                                            alternate: null,
                                                                            order: '4'
                                                                        }
                                                                    ]
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 57,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Toaster.ion'
                                                                    },
                                                                    end: {
                                                                        line: 75,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Toaster.ion'
                                                                    }
                                                                },
                                                                order: '1'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'ObjectExpression',
                                                                    objectType: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'Identifier',
                                                                            name: 'Div',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 75,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Toaster.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 75,
                                                                                    column: 23,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Toaster.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [],
                                                                        loc: {
                                                                            start: {
                                                                                line: 75,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Toaster.ion'
                                                                            },
                                                                            end: {
                                                                                line: 75,
                                                                                column: 25,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Toaster.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    properties: [{
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'style',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 76,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Toaster.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 76,
                                                                                        column: 29,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Toaster.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'ObjectExpression',
                                                                                properties: [{
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'padding',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 77,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Toaster.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 77,
                                                                                                    column: 35,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Toaster.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: '16px'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 75,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Toaster.ion'
                                                                    },
                                                                    end: {
                                                                        line: 79,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Toaster.ion'
                                                                    }
                                                                },
                                                                order: '2'
                                                            },
                                                            {
                                                                type: 'IfStatement',
                                                                test: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '&&',
                                                                    left: {
                                                                        type: 'UnaryExpression',
                                                                        operator: '?',
                                                                        argument: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'properties',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 79,
                                                                                        column: 23,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Toaster.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 79,
                                                                                        column: 33,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Toaster.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'spinner',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 79,
                                                                                        column: 34,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Toaster.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 79,
                                                                                        column: 41,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Toaster.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 79,
                                                                                    column: 23,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Toaster.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 79,
                                                                                    column: 41,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Toaster.ion'
                                                                                }
                                                                            }
                                                                        }
                                                                    },
                                                                    right: {
                                                                        type: 'UnaryExpression',
                                                                        operator: '!',
                                                                        argument: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'properties',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 79,
                                                                                        column: 51,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Toaster.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 79,
                                                                                        column: 61,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Toaster.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'done',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 79,
                                                                                        column: 62,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Toaster.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 79,
                                                                                        column: 66,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Toaster.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 79,
                                                                                    column: 51,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Toaster.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 79,
                                                                                    column: 66,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Toaster.ion'
                                                                                }
                                                                            }
                                                                        }
                                                                    }
                                                                },
                                                                consequent: {
                                                                    type: 'BlockStatement',
                                                                    body: [{
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'CallExpression',
                                                                                callee: {
                                                                                    type: 'Identifier',
                                                                                    name: 'PaperSpinnerLite',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 80,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Toaster.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 80,
                                                                                            column: 40,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Toaster.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                arguments: [{
                                                                                        type: 'ObjectExpression',
                                                                                        properties: [{
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'active',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 80,
                                                                                                            column: 42,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/Toaster.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 80,
                                                                                                            column: 48,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/Toaster.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'Literal',
                                                                                                    value: true
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '0'
                                                                                            }]
                                                                                    }],
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 80,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Toaster.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 80,
                                                                                        column: 56,
                                                                                        fixed: true,
                                                                                        source: 'glass/html/material/Toaster.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 80,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Toaster.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 80,
                                                                                    column: 56,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Toaster.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                alternate: null,
                                                                order: '3'
                                                            },
                                                            {
                                                                type: 'IfStatement',
                                                                test: {
                                                                    type: 'UnaryExpression',
                                                                    operator: '?',
                                                                    argument: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'properties',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 82,
                                                                                    column: 23,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Toaster.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 82,
                                                                                    column: 33,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Toaster.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'icon',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 82,
                                                                                    column: 34,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Toaster.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 82,
                                                                                    column: 38,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Toaster.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 82,
                                                                                column: 23,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Toaster.ion'
                                                                            },
                                                                            end: {
                                                                                line: 82,
                                                                                column: 38,
                                                                                fixed: true,
                                                                                source: 'glass/html/material/Toaster.ion'
                                                                            }
                                                                        }
                                                                    }
                                                                },
                                                                consequent: {
                                                                    type: 'BlockStatement',
                                                                    body: [{
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'ObjectExpression',
                                                                                objectType: {
                                                                                    type: 'CallExpression',
                                                                                    callee: {
                                                                                        type: 'Identifier',
                                                                                        name: 'IronIcon',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 83,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Toaster.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 83,
                                                                                                column: 32,
                                                                                                fixed: true,
                                                                                                source: 'glass/html/material/Toaster.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    arguments: [],
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 83,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Toaster.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 83,
                                                                                            column: 34,
                                                                                            fixed: true,
                                                                                            source: 'glass/html/material/Toaster.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                properties: [
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'icon',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 84,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Toaster.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 84,
                                                                                                    column: 32,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Toaster.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'MemberExpression',
                                                                                            computed: false,
                                                                                            object: {
                                                                                                type: 'Identifier',
                                                                                                name: 'properties',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 84,
                                                                                                        column: 34,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Toaster.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 84,
                                                                                                        column: 44,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Toaster.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            property: {
                                                                                                type: 'Identifier',
                                                                                                name: 'icon',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 84,
                                                                                                        column: 45,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Toaster.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 84,
                                                                                                        column: 49,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Toaster.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 84,
                                                                                                    column: 34,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Toaster.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 84,
                                                                                                    column: 49,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/html/material/Toaster.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'IfStatement',
                                                                                        test: {
                                                                                            type: 'UnaryExpression',
                                                                                            operator: '?',
                                                                                            argument: {
                                                                                                type: 'MemberExpression',
                                                                                                computed: false,
                                                                                                object: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'properties',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 85,
                                                                                                            column: 31,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/Toaster.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 85,
                                                                                                            column: 41,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/Toaster.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'color',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 85,
                                                                                                            column: 42,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/Toaster.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 85,
                                                                                                            column: 47,
                                                                                                            fixed: true,
                                                                                                            source: 'glass/html/material/Toaster.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 85,
                                                                                                        column: 31,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Toaster.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 85,
                                                                                                        column: 47,
                                                                                                        fixed: true,
                                                                                                        source: 'glass/html/material/Toaster.ion'
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        consequent: {
                                                                                            type: 'BlockStatement',
                                                                                            body: [{
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'style',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 86,
                                                                                                                column: 32,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/Toaster.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 86,
                                                                                                                column: 37,
                                                                                                                fixed: true,
                                                                                                                source: 'glass/html/material/Toaster.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'ObjectExpression',
                                                                                                        properties: [{
                                                                                                                type: 'Property',
                                                                                                                key: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'color',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 87,
                                                                                                                            column: 36,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/material/Toaster.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 87,
                                                                                                                            column: 41,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/material/Toaster.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                value: {
                                                                                                                    type: 'MemberExpression',
                                                                                                                    computed: false,
                                                                                                                    object: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'properties',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 87,
                                                                                                                                column: 43,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/Toaster.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 87,
                                                                                                                                column: 53,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/Toaster.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    property: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'color',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 87,
                                                                                                                                column: 54,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/Toaster.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 87,
                                                                                                                                column: 59,
                                                                                                                                fixed: true,
                                                                                                                                source: 'glass/html/material/Toaster.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 87,
                                                                                                                            column: 43,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/material/Toaster.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 87,
                                                                                                                            column: 59,
                                                                                                                            fixed: true,
                                                                                                                            source: 'glass/html/material/Toaster.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                kind: 'init',
                                                                                                                order: '0'
                                                                                                            }]
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '0'
                                                                                                }]
                                                                                        },
                                                                                        alternate: null,
                                                                                        order: '1'
                                                                                    }
                                                                                ]
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 83,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Toaster.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 89,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'glass/html/material/Toaster.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                alternate: null,
                                                                order: '4'
                                                            }
                                                        ]
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 50,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/material/Toaster.ion'
                                                        },
                                                        end: {
                                                            line: 89,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'glass/html/material/Toaster.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        remove: null,
                                        order: '0'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'Identifier',
                                                name: 'Div',
                                                loc: {
                                                    start: {
                                                        line: 89,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/html/material/Toaster.ion'
                                                    },
                                                    end: {
                                                        line: 89,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'glass/html/material/Toaster.ion'
                                                    }
                                                }
                                            },
                                            arguments: [{
                                                    type: 'ObjectExpression',
                                                    properties: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'style',
                                                                loc: {
                                                                    start: {
                                                                        line: 89,
                                                                        column: 17,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Toaster.ion'
                                                                    },
                                                                    end: {
                                                                        line: 89,
                                                                        column: 22,
                                                                        fixed: true,
                                                                        source: 'glass/html/material/Toaster.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Literal',
                                                                value: 'padding:11px'
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                }],
                                            loc: {
                                                start: {
                                                    line: 89,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/material/Toaster.ion'
                                                },
                                                end: {
                                                    line: 89,
                                                    column: 39,
                                                    fixed: true,
                                                    source: 'glass/html/material/Toaster.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 89,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/material/Toaster.ion'
                                            },
                                            end: {
                                                line: 89,
                                                column: 39,
                                                fixed: true,
                                                source: 'glass/html/material/Toaster.ion'
                                            }
                                        },
                                        order: '1'
                                    }
                                ]
                            },
                            order: '0'
                        }]
                },
                order: '2'
            }
        ],
        bound: false
    }, {
        this: this,
        ion: ion,
        style: style,
        _ref2: _ref2
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/Toaster',_glass_html_material_Toaster_);
    else
      _glass_html_material_Toaster_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_Toaster_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_Toolbar_ = function(module,exports,require){'use strict';
var ion = require('ion');
var style = require('../style');
ion.template(function () {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [{
                type: 'ExpressionStatement',
                expression: {
                    type: 'CallExpression',
                    callee: {
                        type: 'MemberExpression',
                        computed: false,
                        object: {
                            type: 'Identifier',
                            name: 'style',
                            loc: {
                                start: {
                                    line: 5,
                                    column: 4,
                                    fixed: true,
                                    source: 'glass/html/material/Toolbar.ion'
                                },
                                end: {
                                    line: 5,
                                    column: 9,
                                    fixed: true,
                                    source: 'glass/html/material/Toolbar.ion'
                                }
                            }
                        },
                        property: {
                            type: 'Identifier',
                            name: 'define',
                            loc: {
                                start: {
                                    line: 5,
                                    column: 10,
                                    fixed: true,
                                    source: 'glass/html/material/Toolbar.ion'
                                },
                                end: {
                                    line: 5,
                                    column: 16,
                                    fixed: true,
                                    source: 'glass/html/material/Toolbar.ion'
                                }
                            }
                        },
                        loc: {
                            start: {
                                line: 5,
                                column: 4,
                                fixed: true,
                                source: 'glass/html/material/Toolbar.ion'
                            },
                            end: {
                                line: 5,
                                column: 16,
                                fixed: true,
                                source: 'glass/html/material/Toolbar.ion'
                            }
                        }
                    },
                    arguments: [
                        {
                            type: 'MemberExpression',
                            computed: false,
                            object: {
                                type: 'Identifier',
                                name: 'module',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/material/Toolbar.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 14,
                                        fixed: true,
                                        source: 'glass/html/material/Toolbar.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'id',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/material/Toolbar.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/html/material/Toolbar.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 6,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/material/Toolbar.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 17,
                                    fixed: true,
                                    source: 'glass/html/material/Toolbar.ion'
                                }
                            }
                        },
                        {
                            type: 'BinaryExpression',
                            operator: '+',
                            left: {
                                type: 'BinaryExpression',
                                operator: '+',
                                left: {
                                    type: 'BinaryExpression',
                                    operator: '+',
                                    left: {
                                        type: 'BinaryExpression',
                                        operator: '+',
                                        left: {
                                            type: 'Literal',
                                            value: '.Toolbar {\n    height: 48px;\n    padding-left: 4px;\n    padding-right: 4px;\n    color: rgba(0,0,0,'
                                        },
                                        right: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'style',
                                                    loc: {
                                                        start: {
                                                            line: 12,
                                                            column: 36,
                                                            fixed: true,
                                                            source: 'glass/html/material/Toolbar.ion'
                                                        },
                                                        end: {
                                                            line: 12,
                                                            column: 41,
                                                            fixed: true,
                                                            source: 'glass/html/material/Toolbar.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'opacity',
                                                    loc: {
                                                        start: {
                                                            line: 12,
                                                            column: 42,
                                                            fixed: true,
                                                            source: 'glass/html/material/Toolbar.ion'
                                                        },
                                                        end: {
                                                            line: 12,
                                                            column: 49,
                                                            fixed: true,
                                                            source: 'glass/html/material/Toolbar.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 12,
                                                        column: 36,
                                                        fixed: true,
                                                        source: 'glass/html/material/Toolbar.ion'
                                                    },
                                                    end: {
                                                        line: 12,
                                                        column: 49,
                                                        fixed: true,
                                                        source: 'glass/html/material/Toolbar.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'text',
                                                loc: {
                                                    start: {
                                                        line: 12,
                                                        column: 50,
                                                        fixed: true,
                                                        source: 'glass/html/material/Toolbar.ion'
                                                    },
                                                    end: {
                                                        line: 12,
                                                        column: 54,
                                                        fixed: true,
                                                        source: 'glass/html/material/Toolbar.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 12,
                                                    column: 36,
                                                    fixed: true,
                                                    source: 'glass/html/material/Toolbar.ion'
                                                },
                                                end: {
                                                    line: 12,
                                                    column: 54,
                                                    fixed: true,
                                                    source: 'glass/html/material/Toolbar.ion'
                                                }
                                            }
                                        }
                                    },
                                    right: {
                                        type: 'Literal',
                                        value: ');\n    max-width: 100vw;\n}\n.Toolbar .Button {\n    color: rgba(0,0,0,'
                                    }
                                },
                                right: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'style',
                                            loc: {
                                                start: {
                                                    line: 16,
                                                    column: 36,
                                                    fixed: true,
                                                    source: 'glass/html/material/Toolbar.ion'
                                                },
                                                end: {
                                                    line: 16,
                                                    column: 41,
                                                    fixed: true,
                                                    source: 'glass/html/material/Toolbar.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'opacity',
                                            loc: {
                                                start: {
                                                    line: 16,
                                                    column: 42,
                                                    fixed: true,
                                                    source: 'glass/html/material/Toolbar.ion'
                                                },
                                                end: {
                                                    line: 16,
                                                    column: 49,
                                                    fixed: true,
                                                    source: 'glass/html/material/Toolbar.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 16,
                                                column: 36,
                                                fixed: true,
                                                source: 'glass/html/material/Toolbar.ion'
                                            },
                                            end: {
                                                line: 16,
                                                column: 49,
                                                fixed: true,
                                                source: 'glass/html/material/Toolbar.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'text',
                                        loc: {
                                            start: {
                                                line: 16,
                                                column: 50,
                                                fixed: true,
                                                source: 'glass/html/material/Toolbar.ion'
                                            },
                                            end: {
                                                line: 16,
                                                column: 54,
                                                fixed: true,
                                                source: 'glass/html/material/Toolbar.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 16,
                                            column: 36,
                                            fixed: true,
                                            source: 'glass/html/material/Toolbar.ion'
                                        },
                                        end: {
                                            line: 16,
                                            column: 54,
                                            fixed: true,
                                            source: 'glass/html/material/Toolbar.ion'
                                        }
                                    }
                                }
                            },
                            right: {
                                type: 'Literal',
                                value: ');\n}'
                            }
                        }
                    ],
                    loc: {
                        start: {
                            line: 5,
                            column: 4,
                            fixed: true,
                            source: 'glass/html/material/Toolbar.ion'
                        },
                        end: {
                            line: 18,
                            column: 5,
                            fixed: true,
                            source: 'glass/html/material/Toolbar.ion'
                        }
                    }
                },
                loc: {
                    start: {
                        line: 5,
                        column: 4,
                        fixed: true,
                        source: 'glass/html/material/Toolbar.ion'
                    },
                    end: {
                        line: 18,
                        column: 5,
                        fixed: true,
                        source: 'glass/html/material/Toolbar.ion'
                    }
                },
                order: '0'
            }],
        bound: false
    }, {
        this: this,
        module: module,
        style: style
    }, null);
})().observe();
module.exports = exports = ion.template(function () {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [{
                type: 'ReturnStatement',
                argument: {
                    type: 'CallExpression',
                    callee: {
                        type: 'Identifier',
                        name: 'Div',
                        loc: {
                            start: {
                                line: 20,
                                column: 22,
                                fixed: true,
                                source: 'glass/html/material/Toolbar.ion'
                            },
                            end: {
                                line: 20,
                                column: 25,
                                fixed: true,
                                source: 'glass/html/material/Toolbar.ion'
                            }
                        }
                    },
                    arguments: [{
                            type: 'ObjectExpression',
                            properties: [{
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'class',
                                        loc: {
                                            start: {
                                                line: 20,
                                                column: 27,
                                                fixed: true,
                                                source: 'glass/html/material/Toolbar.ion'
                                            },
                                            end: {
                                                line: 20,
                                                column: 32,
                                                fixed: true,
                                                source: 'glass/html/material/Toolbar.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: 'Toolbar layout horizontal center fixed background-white'
                                    },
                                    kind: 'init',
                                    order: '0'
                                }]
                        }],
                    loc: {
                        start: {
                            line: 20,
                            column: 22,
                            fixed: true,
                            source: 'glass/html/material/Toolbar.ion'
                        },
                        end: {
                            line: 20,
                            column: 92,
                            fixed: true,
                            source: 'glass/html/material/Toolbar.ion'
                        }
                    }
                },
                order: '0'
            }],
        bound: false
    }, {
        this: this,
        style: style
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/Toolbar',_glass_html_material_Toolbar_);
    else
      _glass_html_material_Toolbar_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_Toolbar_.call(this);
  }
}).call(this)
void (function(){var _glass_html_material_index_ = function(module,exports,require){Object.defineProperty(exports, 'AlertDialog', {get:function(){ return require('./AlertDialog') }, enumerable: true}) 
Object.defineProperty(exports, 'AutoCompleteInput', {get:function(){ return require('./AutoCompleteInput') }, enumerable: true}) 
Object.defineProperty(exports, 'BaseInput', {get:function(){ return require('./BaseInput') }, enumerable: true}) 
Object.defineProperty(exports, 'Bubble', {get:function(){ return require('./Bubble') }, enumerable: true}) 
Object.defineProperty(exports, 'Button', {get:function(){ return require('./Button') }, enumerable: true}) 
Object.defineProperty(exports, 'ButtonGroup', {get:function(){ return require('./ButtonGroup') }, enumerable: true}) 
Object.defineProperty(exports, 'Calendar', {get:function(){ return require('./Calendar') }, enumerable: true}) 
Object.defineProperty(exports, 'Card', {get:function(){ return require('./Card') }, enumerable: true}) 
Object.defineProperty(exports, 'Checkbox', {get:function(){ return require('./Checkbox') }, enumerable: true}) 
Object.defineProperty(exports, 'CheckboxField', {get:function(){ return require('./CheckboxField') }, enumerable: true}) 
Object.defineProperty(exports, 'Chip', {get:function(){ return require('./Chip') }, enumerable: true}) 
Object.defineProperty(exports, 'ConfirmDialog', {get:function(){ return require('./ConfirmDialog') }, enumerable: true}) 
Object.defineProperty(exports, 'DataTable2', {get:function(){ return require('./DataTable2') }, enumerable: true}) 
Object.defineProperty(exports, 'DateTimeField', {get:function(){ return require('./DateTimeField') }, enumerable: true}) 
Object.defineProperty(exports, 'DateTimeInput', {get:function(){ return require('./DateTimeInput') }, enumerable: true}) 
Object.defineProperty(exports, 'Dialog', {get:function(){ return require('./Dialog') }, enumerable: true}) 
Object.defineProperty(exports, 'DragMover', {get:function(){ return require('./DragMover') }, enumerable: true}) 
Object.defineProperty(exports, 'Drawer', {get:function(){ return require('./Drawer') }, enumerable: true}) 
Object.defineProperty(exports, 'Field', {get:function(){ return require('./Field') }, enumerable: true}) 
Object.defineProperty(exports, 'Form', {get:function(){ return require('./Form') }, enumerable: true}) 
Object.defineProperty(exports, 'Icon', {get:function(){ return require('./Icon') }, enumerable: true}) 
Object.defineProperty(exports, 'Input', {get:function(){ return require('./Input') }, enumerable: true}) 
Object.defineProperty(exports, 'List', {get:function(){ return require('./List') }, enumerable: true}) 
Object.defineProperty(exports, 'LoginDialog', {get:function(){ return require('./LoginDialog') }, enumerable: true}) 
Object.defineProperty(exports, 'Menu', {get:function(){ return require('./Menu') }, enumerable: true}) 
Object.defineProperty(exports, 'MultiRelationInput', {get:function(){ return require('./MultiRelationInput') }, enumerable: true}) 
Object.defineProperty(exports, 'NewMenu', {get:function(){ return require('./NewMenu') }, enumerable: true}) 
Object.defineProperty(exports, 'PromptDialog', {get:function(){ return require('./PromptDialog') }, enumerable: true}) 
Object.defineProperty(exports, 'RecordChip', {get:function(){ return require('./RecordChip') }, enumerable: true}) 
Object.defineProperty(exports, 'RecordIcon', {get:function(){ return require('./RecordIcon') }, enumerable: true}) 
Object.defineProperty(exports, 'RecordItem', {get:function(){ return require('./RecordItem') }, enumerable: true}) 
Object.defineProperty(exports, 'RecordSearchSuggestions', {get:function(){ return require('./RecordSearchSuggestions') }, enumerable: true}) 
Object.defineProperty(exports, 'RelationInput', {get:function(){ return require('./RelationInput') }, enumerable: true}) 
Object.defineProperty(exports, 'Renamer', {get:function(){ return require('./Renamer') }, enumerable: true}) 
Object.defineProperty(exports, 'Resizable', {get:function(){ return require('./Resizable') }, enumerable: true}) 
Object.defineProperty(exports, 'Resizer', {get:function(){ return require('./Resizer') }, enumerable: true}) 
Object.defineProperty(exports, 'SearchButton', {get:function(){ return require('./SearchButton') }, enumerable: true}) 
Object.defineProperty(exports, 'Select', {get:function(){ return require('./Select') }, enumerable: true}) 
Object.defineProperty(exports, 'Shadow', {get:function(){ return require('./Shadow') }, enumerable: true}) 
Object.defineProperty(exports, 'Stepper', {get:function(){ return require('./Stepper') }, enumerable: true}) 
Object.defineProperty(exports, 'SuggestMenu', {get:function(){ return require('./SuggestMenu') }, enumerable: true}) 
Object.defineProperty(exports, 'Tab', {get:function(){ return require('./Tab') }, enumerable: true}) 
Object.defineProperty(exports, 'TabContent', {get:function(){ return require('./TabContent') }, enumerable: true}) 
Object.defineProperty(exports, 'Tabs', {get:function(){ return require('./Tabs') }, enumerable: true}) 
Object.defineProperty(exports, 'TextField', {get:function(){ return require('./TextField') }, enumerable: true}) 
Object.defineProperty(exports, 'Toaster', {get:function(){ return require('./Toaster') }, enumerable: true}) 
Object.defineProperty(exports, 'Toolbar', {get:function(){ return require('./Toolbar') }, enumerable: true}) 
Object.freeze(exports)
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/material/index',_glass_html_material_index_);
    else
      _glass_html_material_index_.call(this, module, exports, require);
  }
  else {
    _glass_html_material_index_.call(this);
  }
}).call(this)

'use strict';
if (global.window != null) {
    window != null ? window.registerElements([
        'badge',
        'behaviors',
        'button',
        'card',
        'checkbox',
        'dialog',
        'dialog-behavior',
        'dialog-scrollable',
        'drawer-panel',
        'dropdown-menu',
        'fab',
        'header-panel',
        'icon-button',
        'input',
        'item',
        'item-body',
        'icon-item',
        'listbox',
        'material',
        'menu',
        'submenu',
        'menu-button',
        'progress',
        'radio-button',
        'radio-group',
        'ripple',
        'scroll-header-panel',
        'slider',
        'spinner-lite',
        'styles',
        'tabs',
        'textarea',
        'toast',
        'toggle-button',
        'toolbar',
        'tooltip',
        'swatch-picker',
        'chip',
        'date-picker',
        'input-char-counter',
        'input-container',
        'input-error',
        'timezone'
    ].map(function (x) {
        return 'paper-' + x;
    })) : void 0;
    window != null ? window.registerElements([
        'icon',
        'form'
    ].map(function (x) {
        return 'iron-' + x;
    })) : void 0;
    window != null ? window.registerElements([
        'cc-cvc-input',
        'cc-expiration-input',
        'cc-input',
        'email-input',
        'phone-input',
        'zip-input'
    ].map(function (x) {
        return 'gold-' + x;
    })) : void 0;
}
void (function(){var _glass_html_prefixfree_ = function(module,exports,require){/**
 * StyleFix 1.0.3 & PrefixFree 1.0.7
 * @author Lea Verou
 * MIT license
 */

//  added by Kris so file doesn't throw error on server
if (!global.window)
    return;

(function(){


if(!window.addEventListener) {
    return;
}

var self = window.StyleFix = {
    link: function(link) {
        try {
            // Ignore stylesheets with data-noprefix attribute as well as alternate stylesheets
            if(link.rel !== 'stylesheet' || link.hasAttribute('data-noprefix')) {
                return;
            }
        }
        catch(e) {
            return;
        }

        var url = link.href || link.getAttribute('data-href'),
            base = url.replace(/[^\/]+$/, ''),
            base_scheme = (/^[a-z]{3,10}:/.exec(base) || [''])[0],
            base_domain = (/^[a-z]{3,10}:\/\/[^\/]+/.exec(base) || [''])[0],
            base_query = /^([^?]*)\??/.exec(url)[1],
            parent = link.parentNode,
            xhr = new XMLHttpRequest(),
            process;
        
        xhr.onreadystatechange = function() {
            if(xhr.readyState === 4) {
                process();
            }
        };

        process = function() {
                var css = xhr.responseText;
                
                if(css && link.parentNode && (!xhr.status || xhr.status < 400 || xhr.status > 600)) {
                    css = self.fix(css, true, link);
                    
                    // Convert relative URLs to absolute, if needed
                    if(base) {
                        css = css.replace(/url\(\s*?((?:"|')?)(.+?)\1\s*?\)/gi, function($0, quote, url) {
                            if(/^([a-z]{3,10}:|#)/i.test(url)) { // Absolute & or hash-relative
                                return $0;
                            }
                            else if(/^\/\//.test(url)) { // Scheme-relative
                                // May contain sequences like /../ and /./ but those DO work
                                return 'url("' + base_scheme + url + '")';
                            }
                            else if(/^\//.test(url)) { // Domain-relative
                                return 'url("' + base_domain + url + '")';
                            }
                            else if(/^\?/.test(url)) { // Query-relative
                                return 'url("' + base_query + url + '")';
                            }
                            else {
                                // Path-relative
                                return 'url("' + base + url + '")';
                            }
                        });

                        // behavior URLs shoudn’t be converted (Issue #19)
                        // base should be escaped before added to RegExp (Issue #81)
                        var escaped_base = base.replace(/([\\\^\$*+[\]?{}.=!:(|)])/g,"\\$1");
                        css = css.replace(RegExp('\\b(behavior:\\s*?url\\(\'?"?)' + escaped_base, 'gi'), '$1');
                        }
                    
                    var style = document.createElement('style');
                    style.textContent = css;
                    style.media = link.media;
                    style.disabled = link.disabled;
                    style.setAttribute('data-href', link.getAttribute('href'));
                    
                    parent.insertBefore(style, link);
                    parent.removeChild(link);
                    
                    style.media = link.media; // Duplicate is intentional. See issue #31
                }
        };

        try {
            xhr.open('GET', url);
            xhr.send(null);
        } catch (e) {
            // Fallback to XDomainRequest if available
            if (typeof XDomainRequest != "undefined") {
                xhr = new XDomainRequest();
                xhr.onerror = xhr.onprogress = function() {};
                xhr.onload = process;
                xhr.open("GET", url);
                xhr.send(null);
            }
        }
        
        link.setAttribute('data-inprogress', '');
    },

    styleElement: function(style) {
        if (style.hasAttribute('data-noprefix')) {
            return;
        }
        var disabled = style.disabled;
        
        style.textContent = self.fix(style.textContent, true, style);
        
        style.disabled = disabled;
    },

    styleAttribute: function(element) {
        var css = element.getAttribute('style');
        
        css = self.fix(css, false, element);
        
        element.setAttribute('style', css);
    },
    
    process: function() {
        // Linked stylesheets
        $('link[rel="stylesheet"]:not([data-inprogress])').forEach(StyleFix.link);
        
        // Inline stylesheets
        $('style').forEach(StyleFix.styleElement);
        
        // Inline styles
        $('[style]').forEach(StyleFix.styleAttribute);
    },
    
    register: function(fixer, index) {
        (self.fixers = self.fixers || [])
            .splice(index === undefined? self.fixers.length : index, 0, fixer);
    },
    
    fix: function(css, raw, element) {
        for(var i=0; i<self.fixers.length; i++) {
            css = self.fixers[i](css, raw, element) || css;
        }
        
        return css;
    },
    
    camelCase: function(str) {
        return str.replace(/-([a-z])/g, function($0, $1) { return $1.toUpperCase(); }).replace('-','');
    },
    
    deCamelCase: function(str) {
        return str.replace(/[A-Z]/g, function($0) { return '-' + $0.toLowerCase() });
    }
};

/**************************************
 * Process styles
 **************************************/
(function(){
    setTimeout(function(){
        $('link[rel="stylesheet"]').forEach(StyleFix.link);
    }, 10);
    
    document.addEventListener('DOMContentLoaded', StyleFix.process, false);
})();

function $(expr, con) {
    return [].slice.call((con || document).querySelectorAll(expr));
}

})();

/**
 * PrefixFree
 */
(function(root){

if(!window.StyleFix || !window.getComputedStyle) {
    return;
}

// Private helper
function fix(what, before, after, replacement, css) {
    what = self[what];
    
    if(what.length) {
        var regex = RegExp(before + '(' + what.join('|') + ')' + after, 'gi');

        css = css.replace(regex, replacement);
    }
    
    return css;
}

var self = window.PrefixFree = {
    prefixCSS: function(css, raw, element) {
        var prefix = self.prefix;
        
        // Gradient angles hotfix
        if(self.functions.indexOf('linear-gradient') > -1) {
            // Gradients are supported with a prefix, convert angles to legacy
            css = css.replace(/(\s|:|,)(repeating-)?linear-gradient\(\s*(-?\d*\.?\d*)deg/ig, function ($0, delim, repeating, deg) {
                return delim + (repeating || '') + 'linear-gradient(' + (90-deg) + 'deg';
            });
        }
        
        css = fix('functions', '(\\s|:|,)', '\\s*\\(', '$1' + prefix + '$2(', css);
        css = fix('keywords', '(\\s|:)', '(\\s|;|\\}|$)', '$1' + prefix + '$2$3', css);
        css = fix('properties', '(^|\\{|\\s|;)', '\\s*:', '$1' + prefix + '$2:', css);
        
        // Prefix properties *inside* values (issue #8)
        if (self.properties.length) {
            var regex = RegExp('\\b(' + self.properties.join('|') + ')(?!:)', 'gi');
            
            css = fix('valueProperties', '\\b', ':(.+?);', function($0) {
                return $0.replace(regex, prefix + "$1")
            }, css);
        }
        
        if(raw) {
            css = fix('selectors', '', '\\b', self.prefixSelector, css);
            css = fix('atrules', '@', '\\b', '@' + prefix + '$1', css);
        }
        
        // Fix double prefixing
        css = css.replace(RegExp('-' + prefix, 'g'), '-');
        
        // Prefix wildcard
        css = css.replace(/-\*-(?=[a-z]+)/gi, self.prefix);
        
        return css;
    },
    
    property: function(property) {
        return (self.properties.indexOf(property) >=0 ? self.prefix : '') + property;
    },
    
    value: function(value, property) {
        value = fix('functions', '(^|\\s|,)', '\\s*\\(', '$1' + self.prefix + '$2(', value);
        value = fix('keywords', '(^|\\s)', '(\\s|$)', '$1' + self.prefix + '$2$3', value);

        if(self.valueProperties.indexOf(property) >= 0) {
            value = fix('properties', '(^|\\s|,)', '($|\\s|,)', '$1'+self.prefix+'$2$3', value);
        }

        return value;
    },
    
    // Warning: Prefixes no matter what, even if the selector is supported prefix-less
    prefixSelector: function(selector) {
        return selector.replace(/^:{1,2}/, function($0) { return $0 + self.prefix })
    },
    
    // Warning: Prefixes no matter what, even if the property is supported prefix-less
    prefixProperty: function(property, camelCase) {
        var prefixed = self.prefix + property;
        
        return camelCase? StyleFix.camelCase(prefixed) : prefixed;
    }
};

/**************************************
 * Properties
 **************************************/
(function() {
    var prefixes = {},
        properties = [],
        shorthands = {},
        style = getComputedStyle(document.documentElement, null),
        dummy = document.createElement('div').style;
    
    // Why are we doing this instead of iterating over properties in a .style object? Cause Webkit won't iterate over those.
    var iterate = function(property) {
        if(property.charAt(0) === '-') {
            properties.push(property);
            
            var parts = property.split('-'),
                prefix = parts[1];
                
            // Count prefix uses
            prefixes[prefix] = ++prefixes[prefix] || 1;
            
            // This helps determining shorthands
            while(parts.length > 3) {
                parts.pop();
                
                var shorthand = parts.join('-');

                if(supported(shorthand) && properties.indexOf(shorthand) === -1) {
                    properties.push(shorthand);
                }
            }
        }
    },
    supported = function(property) {
        return StyleFix.camelCase(property) in dummy;
    }
    
    // Some browsers have numerical indices for the properties, some don't
    if(style.length > 0) {
        for(var i=0; i<style.length; i++) {
            iterate(style[i])
        }
    }
    else {
        for(var property in style) {
            iterate(StyleFix.deCamelCase(property));
        }
    }

    // Find most frequently used prefix
    var highest = {uses:0};
    for(var prefix in prefixes) {
        var uses = prefixes[prefix];

        if(highest.uses < uses) {
            highest = {prefix: prefix, uses: uses};
        }
    }
    
    self.prefix = '-' + highest.prefix + '-';
    self.Prefix = StyleFix.camelCase(self.prefix);
    
    self.properties = [];

    // Get properties ONLY supported with a prefix
    for(var i=0; i<properties.length; i++) {
        var property = properties[i];
        
        if(property.indexOf(self.prefix) === 0) { // we might have multiple prefixes, like Opera
            var unprefixed = property.slice(self.prefix.length);
            
            if(!supported(unprefixed)) {
                self.properties.push(unprefixed);
            }
        }
    }
    
    // IE fix
    if(self.Prefix == 'Ms' 
      && !('transform' in dummy) 
      && !('MsTransform' in dummy) 
      && ('msTransform' in dummy)) {
        self.properties.push('transform', 'transform-origin');  
    }
    
    self.properties.sort();
})();

/**************************************
 * Values
 **************************************/
(function() {
// Values that might need prefixing
var functions = {
    'linear-gradient': {
        property: 'backgroundImage',
        params: 'red, teal'
    },
    'calc': {
        property: 'width',
        params: '1px + 5%'
    },
    'element': {
        property: 'backgroundImage',
        params: '#foo'
    },
    'cross-fade': {
        property: 'backgroundImage',
        params: 'url(a.png), url(b.png), 50%'
    }
};


functions['repeating-linear-gradient'] =
functions['repeating-radial-gradient'] =
functions['radial-gradient'] =
functions['linear-gradient'];

// Note: The properties assigned are just to *test* support. 
// The keywords will be prefixed everywhere.
var keywords = {
    'initial': 'color',
    'zoom-in': 'cursor',
    'zoom-out': 'cursor',
    'box': 'display',
    'flexbox': 'display',
    'inline-flexbox': 'display',
    'flex': 'display',
    'inline-flex': 'display',
    'grid': 'display',
    'inline-grid': 'display',
    'min-content': 'width'
};

self.functions = [];
self.keywords = [];

var style = document.createElement('div').style;

function supported(value, property) {
    style[property] = '';
    style[property] = value;

    return !!style[property];
}

for (var func in functions) {
    var test = functions[func],
        property = test.property,
        value = func + '(' + test.params + ')';
    
    if (!supported(value, property)
      && supported(self.prefix + value, property)) {
        // It's supported, but with a prefix
        self.functions.push(func);
    }
}

for (var keyword in keywords) {
    var property = keywords[keyword];

    if (!supported(keyword, property)
      && supported(self.prefix + keyword, property)) {
        // It's supported, but with a prefix
        self.keywords.push(keyword);
    }
}

})();

/**************************************
 * Selectors and @-rules
 **************************************/
(function() {

var 
selectors = {
    ':read-only': null,
    ':read-write': null,
    ':any-link': null,
    '::selection': null
},

atrules = {
    'keyframes': 'name',
    'viewport': null,
    'document': 'regexp(".")'
};

self.selectors = [];
self.atrules = [];

var style = root.appendChild(document.createElement('style'));

function supported(selector) {
    style.textContent = selector + '{}';  // Safari 4 has issues with style.innerHTML
    
    return !!style.sheet.cssRules.length;
}

for(var selector in selectors) {
    var test = selector + (selectors[selector]? '(' + selectors[selector] + ')' : '');
        
    if(!supported(test) && supported(self.prefixSelector(test))) {
        self.selectors.push(selector);
    }
}

for(var atrule in atrules) {
    var test = atrule + ' ' + (atrules[atrule] || '');
    
    if(!supported('@' + test) && supported('@' + self.prefix + test)) {
        self.atrules.push(atrule);
    }
}

root.removeChild(style);

})();

// Properties that accept properties as their value
self.valueProperties = [
    'transition',
    'transition-property'
]

// Add class for current prefix
root.className += ' ' + self.prefix;

StyleFix.register(self.prefixCSS);
//  removed by kris, instead we export as a module
module.exports = self;

})(document.documentElement);
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/prefixfree',_glass_html_prefixfree_);
    else
      _glass_html_prefixfree_.call(this, module, exports, require);
  }
  else {
    _glass_html_prefixfree_.call(this);
  }
}).call(this)
void (function(){var _glass_html_style_ = function(module,exports,require){'use strict';
var ion = require('ion'), styleElements = {}, _ref, addStyleElement = function (name) {
        var s = styleElements[name];
        if (!(s != null)) {
            s = styleElements[name] = document.createElement('style', 'custom-style');
            s.setAttribute('id', name);
            document.head.appendChild(s);
        }
        return s;
    }, removeStyleElement = function (name) {
        var s = styleElements[name];
        if (s != null) {
            document.head.removeChild(s);
            delete styleElements[name];
        }
    }, toRgbArray = function (color) {
        if (color[0] === '#') {
            return [
                color.slice(1, 3),
                color.slice(3, 5),
                color.slice(5, 7)
            ].map(function (c) {
                return parseInt(c, 16) / 255;
            });
        } else if (color.startsWith('rgb(')) {
            return color.slice(4, -1).split(',').map(function (c) {
                return parseFloat(c.trim()) / 255;
            });
        } else if (color.startsWith('rgba(')) {
            return color.slice(5, -1).split(',').map(function (c, i) {
                return parseFloat(c.trim()) / (i === 3 ? 1 : 255);
            });
        } else {
            throw new Error('Unrecognized color format: ' + color);
        }
    }, fromRgbToCss = function (array) {
        return 'rgb' + (array.length === 4 ? 'a' : '') + '(' + array.map(function (c, i) {
            return i === 3 ? c : Math.round(c * 255);
        }).join(',') + ')';
    }, scaleColor = function (color, scale) {
        var array = toRgbArray(color);
        for (var i = 0; i <= 3; i++) {
            array[i] = Math.max(0, Math.min(255, Math.round(array[i] * scale)));
        }
        return fromRgbToCss(array);
    }, interpolate = function (a, b, alpha) {
        a = toRgbArray(a);
        b = toRgbArray(b);
        var c = [];
        for (var i = 0; i < Math.min(a.length, b.length); i++) {
            c[i] = a[i] * (1 - alpha) + b[i] * alpha;
        }
        return fromRgbToCss(c);
    }, toRgba = function (color, opacity) {
        var array = toRgbArray(color);
        array[3] = opacity;
        return fromRgbToCss(array);
    }, style = {};
_ref = require('./');
var device = _ref.device;
ion.template(function () {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [
            {
                type: 'ExpressionStatement',
                expression: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'Identifier',
                        name: 'style',
                        loc: {
                            start: {
                                line: 48,
                                column: 4,
                                fixed: true,
                                source: 'glass/html/style.ion'
                            },
                            end: {
                                line: 48,
                                column: 9,
                                fixed: true,
                                source: 'glass/html/style.ion'
                            }
                        }
                    },
                    properties: [
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'black',
                                loc: {
                                    start: {
                                        line: 49,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    },
                                    end: {
                                        line: 49,
                                        column: 13,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context) {
                                    return function (percent) {
                                        var interpolate = _context.get('interpolate'), style = _context.get('style');
                                        return interpolate(style.color.white, style.color.black, percent);
                                    };
                                }
                            },
                            kind: 'init',
                            order: '0'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'white',
                                loc: {
                                    start: {
                                        line: 50,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    },
                                    end: {
                                        line: 50,
                                        column: 13,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context2) {
                                    return function (percent) {
                                        var interpolate = _context2.get('interpolate'), style = _context2.get('style');
                                        return interpolate(style.color.black, style.color.white, percent);
                                    };
                                }
                            },
                            kind: 'init',
                            order: '1'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'color',
                                        loc: {
                                            start: {
                                                line: 52,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/html/style.ion'
                                            },
                                            end: {
                                                line: 52,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/html/style.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'ObjectExpression',
                                        properties: []
                                    }
                                }],
                            kind: 'let',
                            order: '2'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'color',
                                loc: {
                                    start: {
                                        line: 53,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    },
                                    end: {
                                        line: 53,
                                        column: 13,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'Identifier',
                                    name: 'color',
                                    loc: {
                                        start: {
                                            line: 53,
                                            column: 15,
                                            fixed: true,
                                            source: 'glass/html/style.ion'
                                        },
                                        end: {
                                            line: 53,
                                            column: 20,
                                            fixed: true,
                                            source: 'glass/html/style.ion'
                                        }
                                    }
                                },
                                properties: [
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'black',
                                            loc: {
                                                start: {
                                                    line: 54,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                },
                                                end: {
                                                    line: 54,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: '#000000'
                                        },
                                        kind: 'init',
                                        order: '0'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'white',
                                            loc: {
                                                start: {
                                                    line: 55,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                },
                                                end: {
                                                    line: 55,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: '#FFFFFF'
                                        },
                                        kind: 'init',
                                        order: '1'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'primary',
                                            loc: {
                                                start: {
                                                    line: 57,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                },
                                                end: {
                                                    line: 57,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: '#3F51B5'
                                        },
                                        kind: 'init',
                                        order: '2'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'primaryLight',
                                            loc: {
                                                start: {
                                                    line: 58,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                },
                                                end: {
                                                    line: 58,
                                                    column: 24,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: '#C5CAE9'
                                        },
                                        kind: 'init',
                                        order: '3'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'primaryDark',
                                            loc: {
                                                start: {
                                                    line: 59,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                },
                                                end: {
                                                    line: 59,
                                                    column: 23,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: '#283593'
                                        },
                                        kind: 'init',
                                        order: '4'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'accent',
                                            loc: {
                                                start: {
                                                    line: 61,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                },
                                                end: {
                                                    line: 61,
                                                    column: 18,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: '#FFCC80'
                                        },
                                        kind: 'init',
                                        order: '5'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'accentLight',
                                            loc: {
                                                start: {
                                                    line: 62,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                },
                                                end: {
                                                    line: 62,
                                                    column: 23,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: '#FFE0B2'
                                        },
                                        kind: 'init',
                                        order: '6'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'accentDark',
                                            loc: {
                                                start: {
                                                    line: 63,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                },
                                                end: {
                                                    line: 63,
                                                    column: 22,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: '#00ACC1'
                                        },
                                        kind: 'init',
                                        order: '7'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'control',
                                            loc: {
                                                start: {
                                                    line: 65,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                },
                                                end: {
                                                    line: 65,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: 'rgba(241,241,241,0.7)'
                                        },
                                        kind: 'init',
                                        order: '8'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'error',
                                            loc: {
                                                start: {
                                                    line: 66,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                },
                                                end: {
                                                    line: 66,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: 'rgb(211,67,54)'
                                        },
                                        kind: 'init',
                                        order: '9'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'selection',
                                            loc: {
                                                start: {
                                                    line: 68,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                },
                                                end: {
                                                    line: 68,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'Identifier',
                                                name: 'toRgba',
                                                loc: {
                                                    start: {
                                                        line: 68,
                                                        column: 23,
                                                        fixed: true,
                                                        source: 'glass/html/style.ion'
                                                    },
                                                    end: {
                                                        line: 68,
                                                        column: 29,
                                                        fixed: true,
                                                        source: 'glass/html/style.ion'
                                                    }
                                                }
                                            },
                                            arguments: [
                                                {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'color',
                                                        loc: {
                                                            start: {
                                                                line: 68,
                                                                column: 30,
                                                                fixed: true,
                                                                source: 'glass/html/style.ion'
                                                            },
                                                            end: {
                                                                line: 68,
                                                                column: 35,
                                                                fixed: true,
                                                                source: 'glass/html/style.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'accent',
                                                        loc: {
                                                            start: {
                                                                line: 68,
                                                                column: 36,
                                                                fixed: true,
                                                                source: 'glass/html/style.ion'
                                                            },
                                                            end: {
                                                                line: 68,
                                                                column: 42,
                                                                fixed: true,
                                                                source: 'glass/html/style.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 68,
                                                            column: 30,
                                                            fixed: true,
                                                            source: 'glass/html/style.ion'
                                                        },
                                                        end: {
                                                            line: 68,
                                                            column: 42,
                                                            fixed: true,
                                                            source: 'glass/html/style.ion'
                                                        }
                                                    }
                                                },
                                                {
                                                    type: 'Literal',
                                                    value: 0.5
                                                }
                                            ],
                                            loc: {
                                                start: {
                                                    line: 68,
                                                    column: 23,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                },
                                                end: {
                                                    line: 68,
                                                    column: 48,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                }
                                            }
                                        },
                                        kind: 'init',
                                        order: ':'
                                    }
                                ]
                            },
                            kind: 'init',
                            order: '3'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'opacity',
                                loc: {
                                    start: {
                                        line: 69,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    },
                                    end: {
                                        line: 69,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'ObjectExpression',
                                properties: [
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'divider',
                                            loc: {
                                                start: {
                                                    line: 70,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                },
                                                end: {
                                                    line: 70,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: 0.12
                                        },
                                        kind: 'init',
                                        order: '0'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'hint',
                                            loc: {
                                                start: {
                                                    line: 71,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                },
                                                end: {
                                                    line: 71,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: 0.26
                                        },
                                        kind: 'init',
                                        order: '1'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'secondary',
                                            loc: {
                                                start: {
                                                    line: 72,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                },
                                                end: {
                                                    line: 72,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: 0.45
                                        },
                                        kind: 'init',
                                        order: '2'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'text',
                                            loc: {
                                                start: {
                                                    line: 73,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                },
                                                end: {
                                                    line: 73,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: 0.77
                                        },
                                        kind: 'init',
                                        order: '3'
                                    }
                                ]
                            },
                            kind: 'init',
                            order: '4'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'spacing',
                                loc: {
                                    start: {
                                        line: 74,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    },
                                    end: {
                                        line: 74,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'ObjectExpression',
                                properties: [
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'buffer',
                                            loc: {
                                                start: {
                                                    line: 75,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                },
                                                end: {
                                                    line: 75,
                                                    column: 18,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: 16
                                        },
                                        kind: 'init',
                                        order: '0'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'appBarHeight',
                                            loc: {
                                                start: {
                                                    line: 76,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                },
                                                end: {
                                                    line: 76,
                                                    column: 24,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: 48
                                        },
                                        kind: 'init',
                                        order: '1'
                                    }
                                ]
                            },
                            kind: 'init',
                            order: '5'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'page',
                                loc: {
                                    start: {
                                        line: 79,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    },
                                    end: {
                                        line: 79,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'ObjectExpression',
                                properties: [{
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'margin',
                                            loc: {
                                                start: {
                                                    line: 80,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                },
                                                end: {
                                                    line: 80,
                                                    column: 18,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: 8
                                        },
                                        kind: 'init',
                                        order: '0'
                                    }]
                            },
                            kind: 'init',
                            order: '6'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'contentPadding',
                                loc: {
                                    start: {
                                        line: 82,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    },
                                    end: {
                                        line: 82,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Literal',
                                value: 20
                            },
                            kind: 'init',
                            order: '7'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'appBarHeight',
                                loc: {
                                    start: {
                                        line: 84,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    },
                                    end: {
                                        line: 84,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Literal',
                                value: 70
                            },
                            kind: 'init',
                            order: '8'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'navWidth',
                                loc: {
                                    start: {
                                        line: 86,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    },
                                    end: {
                                        line: 86,
                                        column: 16,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Literal',
                                value: 270
                            },
                            kind: 'init',
                            order: '9'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'card',
                                loc: {
                                    start: {
                                        line: 87,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    },
                                    end: {
                                        line: 87,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'ObjectExpression',
                                properties: [{
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'borderRadius',
                                            loc: {
                                                start: {
                                                    line: 89,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                },
                                                end: {
                                                    line: 89,
                                                    column: 24,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: 2
                                        },
                                        kind: 'init',
                                        order: '0'
                                    }]
                            },
                            kind: 'init',
                            order: ':'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'mobile',
                                loc: {
                                    start: {
                                        line: 90,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    },
                                    end: {
                                        line: 90,
                                        column: 14,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'ObjectExpression',
                                properties: [{
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'appBarHeight',
                                            loc: {
                                                start: {
                                                    line: 91,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                },
                                                end: {
                                                    line: 91,
                                                    column: 24,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: '60px'
                                        },
                                        kind: 'init',
                                        order: '0'
                                    }]
                            },
                            kind: 'init',
                            order: ';'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'prefix',
                                loc: {
                                    start: {
                                        line: 93,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    },
                                    end: {
                                        line: 93,
                                        column: 14,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: false,
                                value: function (content) {
                                    return require('glass/html/prefixfree').prefixCSS(content);
                                }
                            },
                            kind: 'init',
                            order: '<'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'blend',
                                loc: {
                                    start: {
                                        line: 94,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    },
                                    end: {
                                        line: 94,
                                        column: 13,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: false,
                                value: function (bottom, top) {
                                    var b = this.toRgbArray(bottom);
                                    var a = this.toRgbArray(top);
                                    var alpha = a[3] != null ? a[3] : 1;
                                    var beta = 1 - alpha;
                                    return this.fromRgbToCss([
                                        b[0] * beta + a[0] * alpha,
                                        b[1] * beta + a[1] * alpha,
                                        b[2] * beta + a[2] * alpha,
                                        (b[3] != null ? b[3] : 1) * beta + (a[3] != null ? a[3] : 1)
                                    ]);
                                }
                            },
                            kind: 'init',
                            order: '='
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'fromRgbToCss',
                                loc: {
                                    start: {
                                        line: 107,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    },
                                    end: {
                                        line: 107,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Identifier',
                                name: 'fromRgbToCss',
                                loc: {
                                    start: {
                                        line: 107,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    },
                                    end: {
                                        line: 107,
                                        column: 34,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    }
                                }
                            },
                            kind: 'init',
                            order: '>'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'scaleColor',
                                loc: {
                                    start: {
                                        line: 108,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    },
                                    end: {
                                        line: 108,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Identifier',
                                name: 'scaleColor',
                                loc: {
                                    start: {
                                        line: 108,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    },
                                    end: {
                                        line: 108,
                                        column: 30,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    }
                                }
                            },
                            kind: 'init',
                            order: '?'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'toRgbArray',
                                loc: {
                                    start: {
                                        line: 109,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    },
                                    end: {
                                        line: 109,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Identifier',
                                name: 'toRgbArray',
                                loc: {
                                    start: {
                                        line: 109,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    },
                                    end: {
                                        line: 109,
                                        column: 30,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    }
                                }
                            },
                            kind: 'init',
                            order: '@'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'toRgba',
                                loc: {
                                    start: {
                                        line: 110,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    },
                                    end: {
                                        line: 110,
                                        column: 14,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Identifier',
                                name: 'toRgba',
                                loc: {
                                    start: {
                                        line: 110,
                                        column: 16,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    },
                                    end: {
                                        line: 110,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    }
                                }
                            },
                            kind: 'init',
                            order: 'A'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'rgba',
                                loc: {
                                    start: {
                                        line: 111,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    },
                                    end: {
                                        line: 111,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Identifier',
                                name: 'toRgba',
                                loc: {
                                    start: {
                                        line: 111,
                                        column: 14,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    },
                                    end: {
                                        line: 111,
                                        column: 20,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    }
                                }
                            },
                            kind: 'init',
                            order: 'B'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'interpolate',
                                loc: {
                                    start: {
                                        line: 112,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    },
                                    end: {
                                        line: 112,
                                        column: 19,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Identifier',
                                name: 'interpolate',
                                loc: {
                                    start: {
                                        line: 112,
                                        column: 21,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    },
                                    end: {
                                        line: 112,
                                        column: 32,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    }
                                }
                            },
                            kind: 'init',
                            order: 'C'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'define',
                                loc: {
                                    start: {
                                        line: 113,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    },
                                    end: {
                                        line: 113,
                                        column: 14,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context3) {
                                    return function (name, content) {
                                        var addStyleElement = _context3.get('addStyleElement');
                                        if (!(global.document != null)) {
                                            return;
                                        }
                                        if (!(name != null)) {
                                            throw new Error('name is required');
                                        }
                                        if (content != null) {
                                            content = this.prefix(content);
                                        }
                                        addStyleElement(name).innerHTML = content;
                                    };
                                }
                            },
                            kind: 'init',
                            order: 'D'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'sheets',
                                loc: {
                                    start: {
                                        line: 124,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    },
                                    end: {
                                        line: 124,
                                        column: 14,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'ObjectExpression',
                                properties: []
                            },
                            kind: 'init',
                            order: 'E'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'custom',
                                loc: {
                                    start: {
                                        line: 125,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    },
                                    end: {
                                        line: 125,
                                        column: 14,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'ObjectExpression',
                                properties: []
                            },
                            kind: 'init',
                            order: 'F'
                        }
                    ]
                },
                loc: {
                    start: {
                        line: 48,
                        column: 4,
                        fixed: true,
                        source: 'glass/html/style.ion'
                    },
                    end: {
                        line: 129,
                        column: 8,
                        fixed: true,
                        source: 'glass/html/style.ion'
                    }
                },
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'Style',
                            loc: {
                                start: {
                                    line: 131,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/style.ion'
                                },
                                end: {
                                    line: 131,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/html/style.ion'
                                }
                            }
                        },
                        init: {
                            type: 'Function',
                            context: false,
                            value: function () {
                                return document.createElement('style');
                            }
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'CustomSytle',
                            loc: {
                                start: {
                                    line: 132,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/style.ion'
                                },
                                end: {
                                    line: 132,
                                    column: 19,
                                    fixed: true,
                                    source: 'glass/html/style.ion'
                                }
                            }
                        },
                        init: {
                            type: 'Function',
                            context: false,
                            value: function () {
                                return document.createElement('style', 'custom-style');
                            }
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'IfStatement',
                test: {
                    type: 'UnaryExpression',
                    operator: '?',
                    argument: {
                        type: 'MemberExpression',
                        computed: false,
                        object: {
                            type: 'MemberExpression',
                            computed: false,
                            object: {
                                type: 'Identifier',
                                name: 'global',
                                loc: {
                                    start: {
                                        line: 134,
                                        column: 7,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    },
                                    end: {
                                        line: 134,
                                        column: 13,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'document',
                                loc: {
                                    start: {
                                        line: 134,
                                        column: 14,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    },
                                    end: {
                                        line: 134,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/style.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 134,
                                    column: 7,
                                    fixed: true,
                                    source: 'glass/html/style.ion'
                                },
                                end: {
                                    line: 134,
                                    column: 22,
                                    fixed: true,
                                    source: 'glass/html/style.ion'
                                }
                            }
                        },
                        property: {
                            type: 'Identifier',
                            name: 'head',
                            loc: {
                                start: {
                                    line: 134,
                                    column: 24,
                                    fixed: true,
                                    source: 'glass/html/style.ion'
                                },
                                end: {
                                    line: 134,
                                    column: 28,
                                    fixed: true,
                                    source: 'glass/html/style.ion'
                                }
                            }
                        },
                        existential: true,
                        loc: {
                            start: {
                                line: 134,
                                column: 7,
                                fixed: true,
                                source: 'glass/html/style.ion'
                            },
                            end: {
                                line: 134,
                                column: 28,
                                fixed: true,
                                source: 'glass/html/style.ion'
                            }
                        }
                    }
                },
                consequent: {
                    type: 'BlockStatement',
                    body: [{
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'global',
                                            loc: {
                                                start: {
                                                    line: 135,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                },
                                                end: {
                                                    line: 135,
                                                    column: 14,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'document',
                                            loc: {
                                                start: {
                                                    line: 135,
                                                    column: 15,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                },
                                                end: {
                                                    line: 135,
                                                    column: 23,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 135,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/html/style.ion'
                                            },
                                            end: {
                                                line: 135,
                                                column: 23,
                                                fixed: true,
                                                source: 'glass/html/style.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'head',
                                        loc: {
                                            start: {
                                                line: 135,
                                                column: 24,
                                                fixed: true,
                                                source: 'glass/html/style.ion'
                                            },
                                            end: {
                                                line: 135,
                                                column: 28,
                                                fixed: true,
                                                source: 'glass/html/style.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 135,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/html/style.ion'
                                        },
                                        end: {
                                            line: 135,
                                            column: 28,
                                            fixed: true,
                                            source: 'glass/html/style.ion'
                                        }
                                    }
                                },
                                properties: [
                                    {
                                        type: 'ForInStatement',
                                        left: {
                                            type: 'VariableDeclaration',
                                            declarations: [
                                                {
                                                    type: 'VariableDeclarator',
                                                    id: {
                                                        type: 'Identifier',
                                                        name: 'name',
                                                        loc: {
                                                            start: {
                                                                line: 136,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/style.ion'
                                                            },
                                                            end: {
                                                                line: 136,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'glass/html/style.ion'
                                                            }
                                                        }
                                                    },
                                                    init: null
                                                },
                                                {
                                                    type: 'VariableDeclarator',
                                                    id: {
                                                        type: 'Identifier',
                                                        name: 'css',
                                                        loc: {
                                                            start: {
                                                                line: 136,
                                                                column: 22,
                                                                fixed: true,
                                                                source: 'glass/html/style.ion'
                                                            },
                                                            end: {
                                                                line: 136,
                                                                column: 25,
                                                                fixed: true,
                                                                source: 'glass/html/style.ion'
                                                            }
                                                        }
                                                    },
                                                    init: null
                                                }
                                            ],
                                            kind: 'let'
                                        },
                                        right: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'style',
                                                loc: {
                                                    start: {
                                                        line: 136,
                                                        column: 29,
                                                        fixed: true,
                                                        source: 'glass/html/style.ion'
                                                    },
                                                    end: {
                                                        line: 136,
                                                        column: 34,
                                                        fixed: true,
                                                        source: 'glass/html/style.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'sheets',
                                                loc: {
                                                    start: {
                                                        line: 136,
                                                        column: 35,
                                                        fixed: true,
                                                        source: 'glass/html/style.ion'
                                                    },
                                                    end: {
                                                        line: 136,
                                                        column: 41,
                                                        fixed: true,
                                                        source: 'glass/html/style.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 136,
                                                    column: 29,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                },
                                                end: {
                                                    line: 136,
                                                    column: 41,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                }
                                            }
                                        },
                                        body: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'Style',
                                                                loc: {
                                                                    start: {
                                                                        line: 137,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/style.ion'
                                                                    },
                                                                    end: {
                                                                        line: 137,
                                                                        column: 21,
                                                                        fixed: true,
                                                                        source: 'glass/html/style.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [],
                                                            loc: {
                                                                start: {
                                                                    line: 137,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/style.ion'
                                                                },
                                                                end: {
                                                                    line: 137,
                                                                    column: 23,
                                                                    fixed: true,
                                                                    source: 'glass/html/style.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'id',
                                                                    loc: {
                                                                        start: {
                                                                            line: 138,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/style.ion'
                                                                        },
                                                                        end: {
                                                                            line: 138,
                                                                            column: 22,
                                                                            fixed: true,
                                                                            source: 'glass/html/style.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Identifier',
                                                                    name: 'name',
                                                                    loc: {
                                                                        start: {
                                                                            line: 138,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'glass/html/style.ion'
                                                                        },
                                                                        end: {
                                                                            line: 138,
                                                                            column: 28,
                                                                            fixed: true,
                                                                            source: 'glass/html/style.ion'
                                                                        }
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'innerHTML',
                                                                    loc: {
                                                                        start: {
                                                                            line: 139,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/style.ion'
                                                                        },
                                                                        end: {
                                                                            line: 139,
                                                                            column: 29,
                                                                            fixed: true,
                                                                            source: 'glass/html/style.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Identifier',
                                                                    name: 'css',
                                                                    loc: {
                                                                        start: {
                                                                            line: 139,
                                                                            column: 31,
                                                                            fixed: true,
                                                                            source: 'glass/html/style.ion'
                                                                        },
                                                                        end: {
                                                                            line: 139,
                                                                            column: 34,
                                                                            fixed: true,
                                                                            source: 'glass/html/style.ion'
                                                                        }
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '1'
                                                            }
                                                        ]
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 137,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/style.ion'
                                                        },
                                                        end: {
                                                            line: 140,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'glass/html/style.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        remove: null,
                                        order: '0'
                                    },
                                    {
                                        type: 'ForInStatement',
                                        left: {
                                            type: 'VariableDeclaration',
                                            declarations: [
                                                {
                                                    type: 'VariableDeclarator',
                                                    id: {
                                                        type: 'Identifier',
                                                        name: 'name',
                                                        loc: {
                                                            start: {
                                                                line: 140,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'glass/html/style.ion'
                                                            },
                                                            end: {
                                                                line: 140,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'glass/html/style.ion'
                                                            }
                                                        }
                                                    },
                                                    init: null
                                                },
                                                {
                                                    type: 'VariableDeclarator',
                                                    id: {
                                                        type: 'Identifier',
                                                        name: 'css',
                                                        loc: {
                                                            start: {
                                                                line: 140,
                                                                column: 22,
                                                                fixed: true,
                                                                source: 'glass/html/style.ion'
                                                            },
                                                            end: {
                                                                line: 140,
                                                                column: 25,
                                                                fixed: true,
                                                                source: 'glass/html/style.ion'
                                                            }
                                                        }
                                                    },
                                                    init: null
                                                }
                                            ],
                                            kind: 'let'
                                        },
                                        right: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'style',
                                                loc: {
                                                    start: {
                                                        line: 140,
                                                        column: 29,
                                                        fixed: true,
                                                        source: 'glass/html/style.ion'
                                                    },
                                                    end: {
                                                        line: 140,
                                                        column: 34,
                                                        fixed: true,
                                                        source: 'glass/html/style.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'custom',
                                                loc: {
                                                    start: {
                                                        line: 140,
                                                        column: 35,
                                                        fixed: true,
                                                        source: 'glass/html/style.ion'
                                                    },
                                                    end: {
                                                        line: 140,
                                                        column: 41,
                                                        fixed: true,
                                                        source: 'glass/html/style.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 140,
                                                    column: 29,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                },
                                                end: {
                                                    line: 140,
                                                    column: 41,
                                                    fixed: true,
                                                    source: 'glass/html/style.ion'
                                                }
                                            }
                                        },
                                        body: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'CustomSytle',
                                                                loc: {
                                                                    start: {
                                                                        line: 141,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/html/style.ion'
                                                                    },
                                                                    end: {
                                                                        line: 141,
                                                                        column: 27,
                                                                        fixed: true,
                                                                        source: 'glass/html/style.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [],
                                                            loc: {
                                                                start: {
                                                                    line: 141,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/html/style.ion'
                                                                },
                                                                end: {
                                                                    line: 141,
                                                                    column: 29,
                                                                    fixed: true,
                                                                    source: 'glass/html/style.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'id',
                                                                    loc: {
                                                                        start: {
                                                                            line: 142,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/style.ion'
                                                                        },
                                                                        end: {
                                                                            line: 142,
                                                                            column: 22,
                                                                            fixed: true,
                                                                            source: 'glass/html/style.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Identifier',
                                                                    name: 'name',
                                                                    loc: {
                                                                        start: {
                                                                            line: 142,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'glass/html/style.ion'
                                                                        },
                                                                        end: {
                                                                            line: 142,
                                                                            column: 28,
                                                                            fixed: true,
                                                                            source: 'glass/html/style.ion'
                                                                        }
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'innerHTML',
                                                                    loc: {
                                                                        start: {
                                                                            line: 143,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'glass/html/style.ion'
                                                                        },
                                                                        end: {
                                                                            line: 143,
                                                                            column: 29,
                                                                            fixed: true,
                                                                            source: 'glass/html/style.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Identifier',
                                                                    name: 'css',
                                                                    loc: {
                                                                        start: {
                                                                            line: 143,
                                                                            column: 31,
                                                                            fixed: true,
                                                                            source: 'glass/html/style.ion'
                                                                        },
                                                                        end: {
                                                                            line: 143,
                                                                            column: 34,
                                                                            fixed: true,
                                                                            source: 'glass/html/style.ion'
                                                                        }
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '1'
                                                            }
                                                        ]
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 141,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/html/style.ion'
                                                        },
                                                        end: {
                                                            line: 145,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'glass/html/style.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        remove: null,
                                        order: '1'
                                    }
                                ]
                            },
                            loc: {
                                start: {
                                    line: 135,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/html/style.ion'
                                },
                                end: {
                                    line: 145,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/style.ion'
                                }
                            },
                            order: '0'
                        }]
                },
                alternate: null,
                order: '3'
            }
        ],
        bound: false
    }, {
        this: this,
        require: require,
        ion: ion,
        styleElements: styleElements,
        _ref: _ref,
        addStyleElement: addStyleElement,
        removeStyleElement: removeStyleElement,
        toRgbArray: toRgbArray,
        fromRgbToCss: fromRgbToCss,
        scaleColor: scaleColor,
        interpolate: interpolate,
        toRgba: toRgba,
        style: style,
        device: device
    }, null);
})().observe();
module.exports = exports = style;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/style',_glass_html_style_);
    else
      _glass_html_style_.call(this, module, exports, require);
  }
  else {
    _glass_html_style_.call(this);
  }
}).call(this)
void (function(){var _glass_html_virtual_ = function(module,exports,require){'use strict';
var ion = require('ion');
var standardElements = [
        'div',
        'span',
        'input',
        'textarea',
        'a',
        'br',
        'img',
        'p',
        'button',
        'caption',
        'fieldset',
        'form',
        'frame',
        'frameset',
        'h1',
        'h2',
        'h3',
        'h4',
        'h5',
        'h6',
        'hr',
        'legend',
        'menu',
        'option',
        'select',
        'script',
        'pre',
        'table',
        'tbody',
        'td',
        'tr',
        'thead',
        'canvas',
        'head',
        'meta',
        'body',
        'script',
        'section',
        'header',
        'footer',
        'article',
        'ul',
        'ol',
        'li',
        'label',
        'strong',
        'datalist',
        'svg',
        'path',
        'circle',
        'text'
    ];
var Element = ion.defineClass({
        name: 'Element',
        constructor: function Element(vnodeSelector, properties) {
            if (properties == null)
                properties = {};
            this.vnodeSelector = vnodeSelector;
            this.properties = properties;
            this.children = void 0;
            this.text = void 0;
        },
        properties: {
            pushChild: function (value) {
                var node;
                if (typeof value === 'string') {
                    node = ion.patch.combine(new Element(''), { text: value });
                } else {
                    node = value;
                }
                node.properties.key = this.children.length;
                this.children.push(node);
            },
            add: function (value) {
                if (typeof value === 'function') {
                    this.properties.handlers = this.properties.handlers != null ? this.properties.handlers : {};
                    this.properties.handlers[value.name] = this.properties.handlers[value.name] != null ? this.properties.handlers[value.name] : [];
                    this.properties.handlers[value.name].push(value);
                    this.properties['on' + value.name] = genericHandler;
                } else {
                    if (!(this.text != null) && !(this.children != null) && typeof value === 'string') {
                        this.text = value;
                    } else {
                        this.children = this.children != null ? this.children : [];
                        if (this.text != null) {
                            this.pushChild(this.text);
                            this.text = void 0;
                        }
                        this.pushChild(value);
                    }
                }
            }
        }
    });
var capitalize = function (x) {
        return x[0].toUpperCase() + x.substring(1);
    }, genericHandler = function (e) {
        if (e.target.handlers != null && e.target.handlers[e.type] != null) {
            {
                var _ref = e.target.handlers[e.type];
                for (var _i = 0; _i < _ref.length; _i++) {
                    var handler = _ref[_i];
                    handler(e);
                }
            }
        }
    }, Element = Element, Container = ion.template(function (render) {
        return ion.createRuntime({
            type: 'Template',
            id: null,
            body: [
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'projector',
                                loc: {
                                    start: {
                                        line: 53,
                                        column: 16,
                                        fixed: true,
                                        source: 'glass/html/virtual.ion'
                                    },
                                    end: {
                                        line: 53,
                                        column: 25,
                                        fixed: true,
                                        source: 'glass/html/virtual.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'maquette',
                                        loc: {
                                            start: {
                                                line: 53,
                                                column: 28,
                                                fixed: true,
                                                source: 'glass/html/virtual.ion'
                                            },
                                            end: {
                                                line: 53,
                                                column: 36,
                                                fixed: true,
                                                source: 'glass/html/virtual.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'createProjector',
                                        loc: {
                                            start: {
                                                line: 53,
                                                column: 37,
                                                fixed: true,
                                                source: 'glass/html/virtual.ion'
                                            },
                                            end: {
                                                line: 53,
                                                column: 52,
                                                fixed: true,
                                                source: 'glass/html/virtual.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 53,
                                            column: 28,
                                            fixed: true,
                                            source: 'glass/html/virtual.ion'
                                        },
                                        end: {
                                            line: 53,
                                            column: 52,
                                            fixed: true,
                                            source: 'glass/html/virtual.ion'
                                        }
                                    }
                                },
                                arguments: [],
                                loc: {
                                    start: {
                                        line: 53,
                                        column: 28,
                                        fixed: true,
                                        source: 'glass/html/virtual.ion'
                                    },
                                    end: {
                                        line: 53,
                                        column: 54,
                                        fixed: true,
                                        source: 'glass/html/virtual.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '0'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'container',
                                loc: {
                                    start: {
                                        line: 54,
                                        column: 16,
                                        fixed: true,
                                        source: 'glass/html/virtual.ion'
                                    },
                                    end: {
                                        line: 54,
                                        column: 25,
                                        fixed: true,
                                        source: 'glass/html/virtual.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Div',
                                    loc: {
                                        start: {
                                            line: 54,
                                            column: 28,
                                            fixed: true,
                                            source: 'glass/html/virtual.ion'
                                        },
                                        end: {
                                            line: 54,
                                            column: 31,
                                            fixed: true,
                                            source: 'glass/html/virtual.ion'
                                        }
                                    }
                                },
                                arguments: [],
                                loc: {
                                    start: {
                                        line: 54,
                                        column: 28,
                                        fixed: true,
                                        source: 'glass/html/virtual.ion'
                                    },
                                    end: {
                                        line: 54,
                                        column: 33,
                                        fixed: true,
                                        source: 'glass/html/virtual.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '1'
                },
                {
                    type: 'ExpressionStatement',
                    expression: {
                        type: 'CallExpression',
                        callee: {
                            type: 'MemberExpression',
                            computed: false,
                            object: {
                                type: 'Identifier',
                                name: 'projector',
                                loc: {
                                    start: {
                                        line: 55,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/html/virtual.ion'
                                    },
                                    end: {
                                        line: 55,
                                        column: 21,
                                        fixed: true,
                                        source: 'glass/html/virtual.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'append',
                                loc: {
                                    start: {
                                        line: 55,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/html/virtual.ion'
                                    },
                                    end: {
                                        line: 55,
                                        column: 28,
                                        fixed: true,
                                        source: 'glass/html/virtual.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 55,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/html/virtual.ion'
                                },
                                end: {
                                    line: 55,
                                    column: 28,
                                    fixed: true,
                                    source: 'glass/html/virtual.ion'
                                }
                            }
                        },
                        arguments: [
                            {
                                type: 'Identifier',
                                name: 'container',
                                loc: {
                                    start: {
                                        line: 55,
                                        column: 29,
                                        fixed: true,
                                        source: 'glass/html/virtual.ion'
                                    },
                                    end: {
                                        line: 55,
                                        column: 38,
                                        fixed: true,
                                        source: 'glass/html/virtual.ion'
                                    }
                                }
                            },
                            {
                                type: 'Identifier',
                                name: 'render',
                                loc: {
                                    start: {
                                        line: 55,
                                        column: 40,
                                        fixed: true,
                                        source: 'glass/html/virtual.ion'
                                    },
                                    end: {
                                        line: 55,
                                        column: 46,
                                        fixed: true,
                                        source: 'glass/html/virtual.ion'
                                    }
                                }
                            }
                        ],
                        loc: {
                            start: {
                                line: 55,
                                column: 12,
                                fixed: true,
                                source: 'glass/html/virtual.ion'
                            },
                            end: {
                                line: 55,
                                column: 47,
                                fixed: true,
                                source: 'glass/html/virtual.ion'
                            }
                        }
                    },
                    loc: {
                        start: {
                            line: 55,
                            column: 12,
                            fixed: true,
                            source: 'glass/html/virtual.ion'
                        },
                        end: {
                            line: 55,
                            column: 47,
                            fixed: true,
                            source: 'glass/html/virtual.ion'
                        }
                    },
                    order: '2'
                },
                {
                    type: 'ReturnStatement',
                    argument: {
                        type: 'Identifier',
                        name: 'container',
                        loc: {
                            start: {
                                line: 56,
                                column: 19,
                                fixed: true,
                                source: 'glass/html/virtual.ion'
                            },
                            end: {
                                line: 56,
                                column: 28,
                                fixed: true,
                                source: 'glass/html/virtual.ion'
                            }
                        }
                    },
                    order: '3'
                }
            ],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'Container',
                loc: {
                    start: {
                        line: 52,
                        column: 4,
                        fixed: true,
                        source: 'glass/html/virtual.ion'
                    },
                    end: {
                        line: 52,
                        column: 13,
                        fixed: true,
                        source: 'glass/html/virtual.ion'
                    }
                }
            }
        }, {
            this: this,
            render: render,
            standardElements: standardElements,
            Element: Element,
            capitalize: capitalize,
            genericHandler: genericHandler,
            Container: Container,
            _ref2: _ref2
        }, null);
    });
var _ref2 = exports;
{
    _ref2.Element = Element;
    _ref2.Container = Container;
    for (var _i2 = 0; _i2 < standardElements.length; _i2++) {
        var name = standardElements[_i2];
        var jsName = name.split('-').map(capitalize).join('');
        _ref2[jsName] = function (name) {
            return function (properties) {
                if (properties == null)
                    properties = {};
                return new Element(name, properties);
            };
        }(name);
    }
}
_ref2;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/html/virtual',_glass_html_virtual_);
    else
      _glass_html_virtual_.call(this, module, exports, require);
  }
  else {
    _glass_html_virtual_.call(this);
  }
}).call(this)
void (function(){var _glass_index_ = function(module,exports,require){Object.defineProperty(exports, 'Component', {get:function(){ return require('./Component') }, enumerable: true}) 
Object.defineProperty(exports, 'async', {get:function(){ return require('./async') }, enumerable: true}) 
Object.defineProperty(exports, 'constraintengine', {get:function(){ return require('./constraintengine') }, enumerable: true}) 
Object.defineProperty(exports, 'convert', {get:function(){ return require('./convert') }, enumerable: true}) 
Object.defineProperty(exports, 'crypt', {get:function(){ return require('./crypt') }, enumerable: true}) 
Object.defineProperty(exports, 'data', {get:function(){ return require('./data') }, enumerable: true}) 
Object.defineProperty(exports, 'english', {get:function(){ return require('./english') }, enumerable: true}) 
Object.defineProperty(exports, 'googlecloud', {get:function(){ return require('./googlecloud') }, enumerable: true}) 
Object.defineProperty(exports, 'html', {get:function(){ return require('./html') }, enumerable: true}) 
Object.defineProperty(exports, 'language', {get:function(){ return require('./language') }, enumerable: true}) 
Object.defineProperty(exports, 'model', {get:function(){ return require('./model') }, enumerable: true}) 
Object.defineProperty(exports, 'prettyprint', {get:function(){ return require('./prettyprint') }, enumerable: true}) 
Object.defineProperty(exports, 'root', {get:function(){ return require('./root') }, enumerable: true}) 
Object.defineProperty(exports, 'search', {get:function(){ return require('./search') }, enumerable: true}) 
Object.defineProperty(exports, 'sjcl', {get:function(){ return require('./sjcl') }, enumerable: true}) 
Object.defineProperty(exports, 'state', {get:function(){ return require('./state') }, enumerable: true}) 
Object.defineProperty(exports, 'time', {get:function(){ return require('./time') }, enumerable: true}) 
Object.defineProperty(exports, 'toposort', {get:function(){ return require('./toposort') }, enumerable: true}) 
Object.defineProperty(exports, 'webgl', {get:function(){ return require('./webgl') }, enumerable: true}) 
Object.freeze(exports)
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/index',_glass_index_);
    else
      _glass_index_.call(this, module, exports, require);
  }
  else {
    _glass_index_.call(this);
  }
}).call(this)
void (function(){var _glass_language_ = function(module,exports,require){'use strict';
var getMatch = exports.getMatch = function (options, value, properties, required) {
        if (!(value != null)) {
            return -1;
        }
        value = value.toLowerCase();
        while (value.length > 0) {
            for (var _i = 0; _i < options.length; _i++) {
                var index = _i;
                var option = options[_i];
                {
                    var _ref = properties != null ? properties : Object.keys(option);
                    for (var _i2 = 0; _i2 < _ref.length; _i2++) {
                        var property = _ref[_i2];
                        var propertyValue = option[property];
                        if (typeof propertyValue === 'string' && propertyValue.toLowerCase().startsWith(value)) {
                            return index;
                        }
                    }
                }
            }
            value = value.slice(0, -1);
        }
        return required ? 0 : -1;
    }, separateIdentifier = exports.separateIdentifier = function (name) {
        if (!(name != null)) {
            return name;
        }
        return name.replace(/([a-z])([A-Z])/g, function (match, a, b) {
            return '' + a + ' ' + b.toLowerCase();
        });
    }, capitalizeWords = exports.capitalizeWords = function (name) {
        if (!(name != null)) {
            return name;
        }
        return name.replace(/(\b|\s)([a-z])/g, function (match, a, b) {
            return '' + a + b.toUpperCase();
        });
    }, test = exports.test = function () {
        if (!(separateIdentifier('fooBarBaz') === 'foo bar baz'))
            throw new Error('Assertion Failed: (separateIdentifier("fooBarBaz") is "foo bar baz")');
        if (!(separateIdentifier('fooBar') === 'foo bar'))
            throw new Error('Assertion Failed: (separateIdentifier("fooBar") is "foo bar")');
        if (!(separateIdentifier('foo') === 'foo'))
            throw new Error('Assertion Failed: (separateIdentifier("foo") is "foo")');
    };
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/language',_glass_language_);
    else
      _glass_language_.call(this, module, exports, require);
  }
  else {
    _glass_language_.call(this);
  }
}).call(this)
void (function(){var _glass_model_ApplicationModel_ = function(module,exports,require){'use strict';
var ion = require('ion'), gdata = require('../data'), crypt = require('../crypt'), _ref, _ref2, Authentication = require('./Authentication'), Toast = require('./Toast');
_ref = require('../state');
var WebStorageState = _ref.WebStorageState;
var HashState = _ref.HashState;
_ref2 = require('../html/functions');
var getAncestorByClass = _ref2.getAncestorByClass;
module.exports = exports = ion.template(function (_ref3) {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'serverUrl',
                            loc: {
                                start: {
                                    line: 10,
                                    column: 18,
                                    fixed: true,
                                    source: 'glass/model/ApplicationModel.ion'
                                },
                                end: {
                                    line: 10,
                                    column: 27,
                                    fixed: true,
                                    source: 'glass/model/ApplicationModel.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'serverUrl',
                                loc: {
                                    start: {
                                        line: 10,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/model/ApplicationModel.ion'
                                    },
                                    end: {
                                        line: 10,
                                        column: 27,
                                        fixed: true,
                                        source: 'glass/model/ApplicationModel.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'namespace',
                            loc: {
                                start: {
                                    line: 10,
                                    column: 28,
                                    fixed: true,
                                    source: 'glass/model/ApplicationModel.ion'
                                },
                                end: {
                                    line: 10,
                                    column: 37,
                                    fixed: true,
                                    source: 'glass/model/ApplicationModel.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'namespace',
                                loc: {
                                    start: {
                                        line: 10,
                                        column: 28,
                                        fixed: true,
                                        source: 'glass/model/ApplicationModel.ion'
                                    },
                                    end: {
                                        line: 10,
                                        column: 37,
                                        fixed: true,
                                        source: 'glass/model/ApplicationModel.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: '_navigationDefaultState',
                            loc: {
                                start: {
                                    line: 10,
                                    column: 61,
                                    fixed: true,
                                    source: 'glass/model/ApplicationModel.ion'
                                },
                                end: {
                                    line: 10,
                                    column: 84,
                                    fixed: true,
                                    source: 'glass/model/ApplicationModel.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'navigationDefaultState',
                                loc: {
                                    start: {
                                        line: 10,
                                        column: 38,
                                        fixed: true,
                                        source: 'glass/model/ApplicationModel.ion'
                                    },
                                    end: {
                                        line: 10,
                                        column: 60,
                                        fixed: true,
                                        source: 'glass/model/ApplicationModel.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'keepHashInSession',
                            loc: {
                                start: {
                                    line: 10,
                                    column: 85,
                                    fixed: true,
                                    source: 'glass/model/ApplicationModel.ion'
                                },
                                end: {
                                    line: 10,
                                    column: 102,
                                    fixed: true,
                                    source: 'glass/model/ApplicationModel.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'keepHashInSession',
                                loc: {
                                    start: {
                                        line: 10,
                                        column: 85,
                                        fixed: true,
                                        source: 'glass/model/ApplicationModel.ion'
                                    },
                                    end: {
                                        line: 10,
                                        column: 102,
                                        fixed: true,
                                        source: 'glass/model/ApplicationModel.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '3'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'model',
                            loc: {
                                start: {
                                    line: 12,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/model/ApplicationModel.ion'
                                },
                                end: {
                                    line: 12,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/model/ApplicationModel.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'session',
                                        loc: {
                                            start: {
                                                line: 13,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 13,
                                                column: 15,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'Identifier',
                                            name: 'WebStorageState',
                                            loc: {
                                                start: {
                                                    line: 13,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'glass/model/ApplicationModel.ion'
                                                },
                                                end: {
                                                    line: 13,
                                                    column: 32,
                                                    fixed: true,
                                                    source: 'glass/model/ApplicationModel.ion'
                                                }
                                            }
                                        },
                                        arguments: [{
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'window',
                                                    loc: {
                                                        start: {
                                                            line: 13,
                                                            column: 33,
                                                            fixed: true,
                                                            source: 'glass/model/ApplicationModel.ion'
                                                        },
                                                        end: {
                                                            line: 13,
                                                            column: 39,
                                                            fixed: true,
                                                            source: 'glass/model/ApplicationModel.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'sessionStorage',
                                                    loc: {
                                                        start: {
                                                            line: 13,
                                                            column: 40,
                                                            fixed: true,
                                                            source: 'glass/model/ApplicationModel.ion'
                                                        },
                                                        end: {
                                                            line: 13,
                                                            column: 54,
                                                            fixed: true,
                                                            source: 'glass/model/ApplicationModel.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 13,
                                                        column: 33,
                                                        fixed: true,
                                                        source: 'glass/model/ApplicationModel.ion'
                                                    },
                                                    end: {
                                                        line: 13,
                                                        column: 54,
                                                        fixed: true,
                                                        source: 'glass/model/ApplicationModel.ion'
                                                    }
                                                }
                                            }],
                                        loc: {
                                            start: {
                                                line: 13,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 13,
                                                column: 55,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'local',
                                        loc: {
                                            start: {
                                                line: 14,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 14,
                                                column: 13,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'Identifier',
                                            name: 'WebStorageState',
                                            loc: {
                                                start: {
                                                    line: 14,
                                                    column: 15,
                                                    fixed: true,
                                                    source: 'glass/model/ApplicationModel.ion'
                                                },
                                                end: {
                                                    line: 14,
                                                    column: 30,
                                                    fixed: true,
                                                    source: 'glass/model/ApplicationModel.ion'
                                                }
                                            }
                                        },
                                        arguments: [{
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'window',
                                                    loc: {
                                                        start: {
                                                            line: 14,
                                                            column: 31,
                                                            fixed: true,
                                                            source: 'glass/model/ApplicationModel.ion'
                                                        },
                                                        end: {
                                                            line: 14,
                                                            column: 37,
                                                            fixed: true,
                                                            source: 'glass/model/ApplicationModel.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'localStorage',
                                                    loc: {
                                                        start: {
                                                            line: 14,
                                                            column: 38,
                                                            fixed: true,
                                                            source: 'glass/model/ApplicationModel.ion'
                                                        },
                                                        end: {
                                                            line: 14,
                                                            column: 50,
                                                            fixed: true,
                                                            source: 'glass/model/ApplicationModel.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 14,
                                                        column: 31,
                                                        fixed: true,
                                                        source: 'glass/model/ApplicationModel.ion'
                                                    },
                                                    end: {
                                                        line: 14,
                                                        column: 50,
                                                        fixed: true,
                                                        source: 'glass/model/ApplicationModel.ion'
                                                    }
                                                }
                                            }],
                                        loc: {
                                            start: {
                                                line: 14,
                                                column: 15,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 14,
                                                column: 51,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '1'
                                }
                            ]
                        }
                    }],
                kind: 'let',
                order: '4'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'errorHandler',
                            loc: {
                                start: {
                                    line: 15,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/model/ApplicationModel.ion'
                                },
                                end: {
                                    line: 15,
                                    column: 20,
                                    fixed: true,
                                    source: 'glass/model/ApplicationModel.ion'
                                }
                            }
                        },
                        init: {
                            type: 'Function',
                            context: true,
                            value: function (_context) {
                                return function errorHandler(e, request) {
                                    var user = _context.get('user'), model = _context.get('model'), ion = _context.get('ion');
                                    console.error(e);
                                    var status = request.status;
                                    if (status === 401 || status === 419 || status === 404 && !(user != null)) {
                                        model.logout(status, false);
                                    }
                                    ion.sync();
                                };
                            }
                        }
                    }],
                kind: 'let',
                order: '5'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'token',
                            loc: {
                                start: {
                                    line: 21,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/model/ApplicationModel.ion'
                                },
                                end: {
                                    line: 21,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/model/ApplicationModel.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ConditionalExpression',
                            test: {
                                type: 'BinaryExpression',
                                operator: '!=',
                                left: {
                                    type: 'ConditionalExpression',
                                    test: {
                                        type: 'BinaryExpression',
                                        operator: '!=',
                                        left: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'model',
                                                    loc: {
                                                        start: {
                                                            line: 21,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'glass/model/ApplicationModel.ion'
                                                        },
                                                        end: {
                                                            line: 21,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'glass/model/ApplicationModel.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'session',
                                                    loc: {
                                                        start: {
                                                            line: 21,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'glass/model/ApplicationModel.ion'
                                                        },
                                                        end: {
                                                            line: 21,
                                                            column: 29,
                                                            fixed: true,
                                                            source: 'glass/model/ApplicationModel.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 21,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'glass/model/ApplicationModel.ion'
                                                    },
                                                    end: {
                                                        line: 21,
                                                        column: 29,
                                                        fixed: true,
                                                        source: 'glass/model/ApplicationModel.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'token',
                                                loc: {
                                                    start: {
                                                        line: 21,
                                                        column: 30,
                                                        fixed: true,
                                                        source: 'glass/model/ApplicationModel.ion'
                                                    },
                                                    end: {
                                                        line: 21,
                                                        column: 35,
                                                        fixed: true,
                                                        source: 'glass/model/ApplicationModel.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 21,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/model/ApplicationModel.ion'
                                                },
                                                end: {
                                                    line: 21,
                                                    column: 35,
                                                    fixed: true,
                                                    source: 'glass/model/ApplicationModel.ion'
                                                }
                                            }
                                        },
                                        right: {
                                            type: 'Literal',
                                            value: null
                                        }
                                    },
                                    consequent: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'model',
                                                loc: {
                                                    start: {
                                                        line: 21,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'glass/model/ApplicationModel.ion'
                                                    },
                                                    end: {
                                                        line: 21,
                                                        column: 21,
                                                        fixed: true,
                                                        source: 'glass/model/ApplicationModel.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'session',
                                                loc: {
                                                    start: {
                                                        line: 21,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'glass/model/ApplicationModel.ion'
                                                    },
                                                    end: {
                                                        line: 21,
                                                        column: 29,
                                                        fixed: true,
                                                        source: 'glass/model/ApplicationModel.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 21,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/model/ApplicationModel.ion'
                                                },
                                                end: {
                                                    line: 21,
                                                    column: 29,
                                                    fixed: true,
                                                    source: 'glass/model/ApplicationModel.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'token',
                                            loc: {
                                                start: {
                                                    line: 21,
                                                    column: 30,
                                                    fixed: true,
                                                    source: 'glass/model/ApplicationModel.ion'
                                                },
                                                end: {
                                                    line: 21,
                                                    column: 35,
                                                    fixed: true,
                                                    source: 'glass/model/ApplicationModel.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 21,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 21,
                                                column: 35,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    alternate: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'model',
                                                loc: {
                                                    start: {
                                                        line: 21,
                                                        column: 38,
                                                        fixed: true,
                                                        source: 'glass/model/ApplicationModel.ion'
                                                    },
                                                    end: {
                                                        line: 21,
                                                        column: 43,
                                                        fixed: true,
                                                        source: 'glass/model/ApplicationModel.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'local',
                                                loc: {
                                                    start: {
                                                        line: 21,
                                                        column: 44,
                                                        fixed: true,
                                                        source: 'glass/model/ApplicationModel.ion'
                                                    },
                                                    end: {
                                                        line: 21,
                                                        column: 49,
                                                        fixed: true,
                                                        source: 'glass/model/ApplicationModel.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 21,
                                                    column: 38,
                                                    fixed: true,
                                                    source: 'glass/model/ApplicationModel.ion'
                                                },
                                                end: {
                                                    line: 21,
                                                    column: 49,
                                                    fixed: true,
                                                    source: 'glass/model/ApplicationModel.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'token',
                                            loc: {
                                                start: {
                                                    line: 21,
                                                    column: 50,
                                                    fixed: true,
                                                    source: 'glass/model/ApplicationModel.ion'
                                                },
                                                end: {
                                                    line: 21,
                                                    column: 55,
                                                    fixed: true,
                                                    source: 'glass/model/ApplicationModel.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 21,
                                                column: 38,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 21,
                                                column: 55,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: null
                                }
                            },
                            consequent: {
                                type: 'ConditionalExpression',
                                test: {
                                    type: 'BinaryExpression',
                                    operator: '!=',
                                    left: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'model',
                                                loc: {
                                                    start: {
                                                        line: 21,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'glass/model/ApplicationModel.ion'
                                                    },
                                                    end: {
                                                        line: 21,
                                                        column: 21,
                                                        fixed: true,
                                                        source: 'glass/model/ApplicationModel.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'session',
                                                loc: {
                                                    start: {
                                                        line: 21,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'glass/model/ApplicationModel.ion'
                                                    },
                                                    end: {
                                                        line: 21,
                                                        column: 29,
                                                        fixed: true,
                                                        source: 'glass/model/ApplicationModel.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 21,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/model/ApplicationModel.ion'
                                                },
                                                end: {
                                                    line: 21,
                                                    column: 29,
                                                    fixed: true,
                                                    source: 'glass/model/ApplicationModel.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'token',
                                            loc: {
                                                start: {
                                                    line: 21,
                                                    column: 30,
                                                    fixed: true,
                                                    source: 'glass/model/ApplicationModel.ion'
                                                },
                                                end: {
                                                    line: 21,
                                                    column: 35,
                                                    fixed: true,
                                                    source: 'glass/model/ApplicationModel.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 21,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 21,
                                                column: 35,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    right: {
                                        type: 'Literal',
                                        value: null
                                    }
                                },
                                consequent: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'model',
                                            loc: {
                                                start: {
                                                    line: 21,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'glass/model/ApplicationModel.ion'
                                                },
                                                end: {
                                                    line: 21,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'glass/model/ApplicationModel.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'session',
                                            loc: {
                                                start: {
                                                    line: 21,
                                                    column: 22,
                                                    fixed: true,
                                                    source: 'glass/model/ApplicationModel.ion'
                                                },
                                                end: {
                                                    line: 21,
                                                    column: 29,
                                                    fixed: true,
                                                    source: 'glass/model/ApplicationModel.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 21,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 21,
                                                column: 29,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'token',
                                        loc: {
                                            start: {
                                                line: 21,
                                                column: 30,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 21,
                                                column: 35,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 21,
                                            column: 16,
                                            fixed: true,
                                            source: 'glass/model/ApplicationModel.ion'
                                        },
                                        end: {
                                            line: 21,
                                            column: 35,
                                            fixed: true,
                                            source: 'glass/model/ApplicationModel.ion'
                                        }
                                    }
                                },
                                alternate: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'model',
                                            loc: {
                                                start: {
                                                    line: 21,
                                                    column: 38,
                                                    fixed: true,
                                                    source: 'glass/model/ApplicationModel.ion'
                                                },
                                                end: {
                                                    line: 21,
                                                    column: 43,
                                                    fixed: true,
                                                    source: 'glass/model/ApplicationModel.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'local',
                                            loc: {
                                                start: {
                                                    line: 21,
                                                    column: 44,
                                                    fixed: true,
                                                    source: 'glass/model/ApplicationModel.ion'
                                                },
                                                end: {
                                                    line: 21,
                                                    column: 49,
                                                    fixed: true,
                                                    source: 'glass/model/ApplicationModel.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 21,
                                                column: 38,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 21,
                                                column: 49,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'token',
                                        loc: {
                                            start: {
                                                line: 21,
                                                column: 50,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 21,
                                                column: 55,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 21,
                                            column: 38,
                                            fixed: true,
                                            source: 'glass/model/ApplicationModel.ion'
                                        },
                                        end: {
                                            line: 21,
                                            column: 55,
                                            fixed: true,
                                            source: 'glass/model/ApplicationModel.ion'
                                        }
                                    }
                                }
                            },
                            alternate: {
                                type: 'Literal',
                                value: null
                            }
                        }
                    }],
                kind: 'let',
                order: '6'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'tokenBody',
                            loc: {
                                start: {
                                    line: 22,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/model/ApplicationModel.ion'
                                },
                                end: {
                                    line: 22,
                                    column: 17,
                                    fixed: true,
                                    source: 'glass/model/ApplicationModel.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ConditionalExpression',
                            test: {
                                type: 'UnaryExpression',
                                operator: '?',
                                argument: {
                                    type: 'Identifier',
                                    name: 'token',
                                    loc: {
                                        start: {
                                            line: 22,
                                            column: 20,
                                            fixed: true,
                                            source: 'glass/model/ApplicationModel.ion'
                                        },
                                        end: {
                                            line: 22,
                                            column: 25,
                                            fixed: true,
                                            source: 'glass/model/ApplicationModel.ion'
                                        }
                                    }
                                }
                            },
                            consequent: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'JSON',
                                        loc: {
                                            start: {
                                                line: 22,
                                                column: 29,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 22,
                                                column: 33,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'parse',
                                        loc: {
                                            start: {
                                                line: 22,
                                                column: 34,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 22,
                                                column: 39,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 22,
                                            column: 29,
                                            fixed: true,
                                            source: 'glass/model/ApplicationModel.ion'
                                        },
                                        end: {
                                            line: 22,
                                            column: 39,
                                            fixed: true,
                                            source: 'glass/model/ApplicationModel.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'crypt',
                                                loc: {
                                                    start: {
                                                        line: 22,
                                                        column: 40,
                                                        fixed: true,
                                                        source: 'glass/model/ApplicationModel.ion'
                                                    },
                                                    end: {
                                                        line: 22,
                                                        column: 45,
                                                        fixed: true,
                                                        source: 'glass/model/ApplicationModel.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'base64Decode',
                                                loc: {
                                                    start: {
                                                        line: 22,
                                                        column: 46,
                                                        fixed: true,
                                                        source: 'glass/model/ApplicationModel.ion'
                                                    },
                                                    end: {
                                                        line: 22,
                                                        column: 58,
                                                        fixed: true,
                                                        source: 'glass/model/ApplicationModel.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 22,
                                                    column: 40,
                                                    fixed: true,
                                                    source: 'glass/model/ApplicationModel.ion'
                                                },
                                                end: {
                                                    line: 22,
                                                    column: 58,
                                                    fixed: true,
                                                    source: 'glass/model/ApplicationModel.ion'
                                                }
                                            }
                                        },
                                        arguments: [{
                                                type: 'MemberExpression',
                                                computed: true,
                                                object: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'token',
                                                            loc: {
                                                                start: {
                                                                    line: 22,
                                                                    column: 59,
                                                                    fixed: true,
                                                                    source: 'glass/model/ApplicationModel.ion'
                                                                },
                                                                end: {
                                                                    line: 22,
                                                                    column: 64,
                                                                    fixed: true,
                                                                    source: 'glass/model/ApplicationModel.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'split',
                                                            loc: {
                                                                start: {
                                                                    line: 22,
                                                                    column: 66,
                                                                    fixed: true,
                                                                    source: 'glass/model/ApplicationModel.ion'
                                                                },
                                                                end: {
                                                                    line: 22,
                                                                    column: 71,
                                                                    fixed: true,
                                                                    source: 'glass/model/ApplicationModel.ion'
                                                                }
                                                            }
                                                        },
                                                        existential: true,
                                                        loc: {
                                                            start: {
                                                                line: 22,
                                                                column: 59,
                                                                fixed: true,
                                                                source: 'glass/model/ApplicationModel.ion'
                                                            },
                                                            end: {
                                                                line: 22,
                                                                column: 71,
                                                                fixed: true,
                                                                source: 'glass/model/ApplicationModel.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [{
                                                            type: 'Literal',
                                                            value: '.'
                                                        }],
                                                    existential: true,
                                                    loc: {
                                                        start: {
                                                            line: 22,
                                                            column: 59,
                                                            fixed: true,
                                                            source: 'glass/model/ApplicationModel.ion'
                                                        },
                                                        end: {
                                                            line: 22,
                                                            column: 77,
                                                            fixed: true,
                                                            source: 'glass/model/ApplicationModel.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Literal',
                                                    value: 1
                                                },
                                                loc: {
                                                    start: {
                                                        line: 22,
                                                        column: 59,
                                                        fixed: true,
                                                        source: 'glass/model/ApplicationModel.ion'
                                                    },
                                                    end: {
                                                        line: 22,
                                                        column: 80,
                                                        fixed: true,
                                                        source: 'glass/model/ApplicationModel.ion'
                                                    }
                                                }
                                            }],
                                        loc: {
                                            start: {
                                                line: 22,
                                                column: 40,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 22,
                                                column: 81,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    }],
                                loc: {
                                    start: {
                                        line: 22,
                                        column: 29,
                                        fixed: true,
                                        source: 'glass/model/ApplicationModel.ion'
                                    },
                                    end: {
                                        line: 22,
                                        column: 82,
                                        fixed: true,
                                        source: 'glass/model/ApplicationModel.ion'
                                    }
                                }
                            },
                            alternate: {
                                type: 'Literal',
                                value: null
                            }
                        }
                    }],
                kind: 'let',
                order: '7'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'userKey',
                            loc: {
                                start: {
                                    line: 23,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/model/ApplicationModel.ion'
                                },
                                end: {
                                    line: 23,
                                    column: 15,
                                    fixed: true,
                                    source: 'glass/model/ApplicationModel.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ConditionalExpression',
                            test: {
                                type: 'BinaryExpression',
                                operator: '!=',
                                left: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'tokenBody',
                                        loc: {
                                            start: {
                                                line: 23,
                                                column: 18,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 23,
                                                column: 27,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'userKey',
                                        loc: {
                                            start: {
                                                line: 23,
                                                column: 29,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 23,
                                                column: 36,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    existential: true,
                                    loc: {
                                        start: {
                                            line: 23,
                                            column: 18,
                                            fixed: true,
                                            source: 'glass/model/ApplicationModel.ion'
                                        },
                                        end: {
                                            line: 23,
                                            column: 36,
                                            fixed: true,
                                            source: 'glass/model/ApplicationModel.ion'
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: null
                                }
                            },
                            consequent: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'tokenBody',
                                    loc: {
                                        start: {
                                            line: 23,
                                            column: 18,
                                            fixed: true,
                                            source: 'glass/model/ApplicationModel.ion'
                                        },
                                        end: {
                                            line: 23,
                                            column: 27,
                                            fixed: true,
                                            source: 'glass/model/ApplicationModel.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'userKey',
                                    loc: {
                                        start: {
                                            line: 23,
                                            column: 29,
                                            fixed: true,
                                            source: 'glass/model/ApplicationModel.ion'
                                        },
                                        end: {
                                            line: 23,
                                            column: 36,
                                            fixed: true,
                                            source: 'glass/model/ApplicationModel.ion'
                                        }
                                    }
                                },
                                existential: true,
                                loc: {
                                    start: {
                                        line: 23,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/model/ApplicationModel.ion'
                                    },
                                    end: {
                                        line: 23,
                                        column: 36,
                                        fixed: true,
                                        source: 'glass/model/ApplicationModel.ion'
                                    }
                                }
                            },
                            alternate: {
                                type: 'Literal',
                                value: null
                            }
                        }
                    }],
                kind: 'let',
                order: '8'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'user',
                            loc: {
                                start: {
                                    line: 24,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/model/ApplicationModel.ion'
                                },
                                end: {
                                    line: 24,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/model/ApplicationModel.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ConditionalExpression',
                            test: {
                                type: 'Identifier',
                                name: 'userKey',
                                loc: {
                                    start: {
                                        line: 24,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/model/ApplicationModel.ion'
                                    },
                                    end: {
                                        line: 24,
                                        column: 22,
                                        fixed: true,
                                        source: 'glass/model/ApplicationModel.ion'
                                    }
                                }
                            },
                            consequent: {
                                type: 'MemberExpression',
                                computed: true,
                                object: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'model',
                                        loc: {
                                            start: {
                                                line: 24,
                                                column: 25,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 24,
                                                column: 30,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'server',
                                        loc: {
                                            start: {
                                                line: 24,
                                                column: 31,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 24,
                                                column: 37,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 24,
                                            column: 25,
                                            fixed: true,
                                            source: 'glass/model/ApplicationModel.ion'
                                        },
                                        end: {
                                            line: 24,
                                            column: 37,
                                            fixed: true,
                                            source: 'glass/model/ApplicationModel.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'userKey',
                                    loc: {
                                        start: {
                                            line: 24,
                                            column: 39,
                                            fixed: true,
                                            source: 'glass/model/ApplicationModel.ion'
                                        },
                                        end: {
                                            line: 24,
                                            column: 46,
                                            fixed: true,
                                            source: 'glass/model/ApplicationModel.ion'
                                        }
                                    }
                                },
                                existential: true,
                                loc: {
                                    start: {
                                        line: 24,
                                        column: 25,
                                        fixed: true,
                                        source: 'glass/model/ApplicationModel.ion'
                                    },
                                    end: {
                                        line: 24,
                                        column: 47,
                                        fixed: true,
                                        source: 'glass/model/ApplicationModel.ion'
                                    }
                                }
                            },
                            alternate: {
                                type: 'UnaryExpression',
                                operator: 'void',
                                prefix: true,
                                argument: {
                                    type: 'Literal',
                                    value: 0
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '9'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'setLastLoginTimeNow',
                            loc: {
                                start: {
                                    line: 26,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/model/ApplicationModel.ion'
                                },
                                end: {
                                    line: 26,
                                    column: 27,
                                    fixed: true,
                                    source: 'glass/model/ApplicationModel.ion'
                                }
                            }
                        },
                        init: {
                            type: 'Function',
                            context: true,
                            value: function (_context2) {
                                return function () {
                                    var model = _context2.get('model'), ion = _context2.get('ion');
                                    model.local.lastLoginTime = new Date().toISOString();
                                    ion.sync();
                                };
                            }
                        }
                    }],
                kind: 'let',
                order: ':'
            },
            {
                type: 'IfStatement',
                test: {
                    type: 'BinaryExpression',
                    operator: '===',
                    left: {
                        type: 'Identifier',
                        name: 'user',
                        loc: {
                            start: {
                                line: 30,
                                column: 7,
                                fixed: true,
                                source: 'glass/model/ApplicationModel.ion'
                            },
                            end: {
                                line: 30,
                                column: 11,
                                fixed: true,
                                source: 'glass/model/ApplicationModel.ion'
                            }
                        }
                    },
                    right: {
                        type: 'Literal',
                        value: null
                    }
                },
                consequent: {
                    type: 'BlockStatement',
                    body: [{
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Function',
                                    context: true,
                                    value: function (_context3) {
                                        return function () {
                                            var model = _context3.get('model');
                                            model.logout(404, false);
                                        };
                                    }
                                },
                                arguments: [],
                                loc: {
                                    start: {
                                        line: 31,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/model/ApplicationModel.ion'
                                    },
                                    end: {
                                        line: 33,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/model/ApplicationModel.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 31,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/model/ApplicationModel.ion'
                                },
                                end: {
                                    line: 33,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/model/ApplicationModel.ion'
                                }
                            },
                            order: '0'
                        }]
                },
                alternate: null,
                order: ';'
            },
            {
                type: 'IfStatement',
                test: {
                    type: 'UnaryExpression',
                    operator: '?',
                    argument: {
                        type: 'Identifier',
                        name: 'user',
                        loc: {
                            start: {
                                line: 33,
                                column: 7,
                                fixed: true,
                                source: 'glass/model/ApplicationModel.ion'
                            },
                            end: {
                                line: 33,
                                column: 11,
                                fixed: true,
                                source: 'glass/model/ApplicationModel.ion'
                            }
                        }
                    }
                },
                consequent: {
                    type: 'BlockStatement',
                    body: [{
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'setLastLoginTimeNow',
                                    loc: {
                                        start: {
                                            line: 34,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/model/ApplicationModel.ion'
                                        },
                                        end: {
                                            line: 34,
                                            column: 27,
                                            fixed: true,
                                            source: 'glass/model/ApplicationModel.ion'
                                        }
                                    }
                                },
                                arguments: [],
                                loc: {
                                    start: {
                                        line: 34,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/model/ApplicationModel.ion'
                                    },
                                    end: {
                                        line: 34,
                                        column: 29,
                                        fixed: true,
                                        source: 'glass/model/ApplicationModel.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 34,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/model/ApplicationModel.ion'
                                },
                                end: {
                                    line: 34,
                                    column: 29,
                                    fixed: true,
                                    source: 'glass/model/ApplicationModel.ion'
                                }
                            },
                            order: '0'
                        }]
                },
                alternate: null,
                order: '<'
            },
            {
                type: 'ExpressionStatement',
                expression: {
                    type: 'CallExpression',
                    callee: {
                        type: 'Function',
                        context: true,
                        value: function (_context4) {
                            return function () {
                                var keepHashInSession = _context4.get('keepHashInSession'), model = _context4.get('model'), ion = _context4.get('ion');
                                if (keepHashInSession === true) {
                                    var storage = model.session;
                                    if (storage.lastHash != null) {
                                        console.log('Loading last hash.', storage.lastHash);
                                        document.location.hash = storage.lastHash;
                                    }
                                    window.addEventListener('beforeunload', function () {
                                        console.log('Saving last hash.', document.location.hash);
                                        storage.lastHash = document.location.hash;
                                        ion.sync();
                                    });
                                }
                            };
                        }
                    },
                    arguments: [],
                    loc: {
                        start: {
                            line: 36,
                            column: 4,
                            fixed: true,
                            source: 'glass/model/ApplicationModel.ion'
                        },
                        end: {
                            line: 51,
                            column: 8,
                            fixed: true,
                            source: 'glass/model/ApplicationModel.ion'
                        }
                    }
                },
                loc: {
                    start: {
                        line: 36,
                        column: 4,
                        fixed: true,
                        source: 'glass/model/ApplicationModel.ion'
                    },
                    end: {
                        line: 51,
                        column: 8,
                        fixed: true,
                        source: 'glass/model/ApplicationModel.ion'
                    }
                },
                order: '='
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'CallExpression',
                    callee: {
                        type: 'MemberExpression',
                        object: {
                            type: 'Identifier',
                            name: 'Object'
                        },
                        property: {
                            type: 'Identifier',
                            name: 'defineProperties'
                        }
                    },
                    arguments: [
                        {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'Identifier',
                                name: 'model',
                                loc: {
                                    start: {
                                        line: 51,
                                        column: 11,
                                        fixed: true,
                                        source: 'glass/model/ApplicationModel.ion'
                                    },
                                    end: {
                                        line: 51,
                                        column: 16,
                                        fixed: true,
                                        source: 'glass/model/ApplicationModel.ion'
                                    }
                                }
                            },
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'online',
                                        loc: {
                                            start: {
                                                line: 52,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 52,
                                                column: 14,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: true
                                    },
                                    kind: 'init',
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'namespace',
                                        loc: {
                                            start: {
                                                line: 53,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 53,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Identifier',
                                        name: 'namespace',
                                        loc: {
                                            start: {
                                                line: 53,
                                                column: 19,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 53,
                                                column: 28,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '1'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'server',
                                        loc: {
                                            start: {
                                                line: 54,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 54,
                                                column: 14,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ConditionalExpression',
                                        test: {
                                            type: 'UnaryExpression',
                                            operator: '?',
                                            argument: {
                                                type: 'Identifier',
                                                name: 'token',
                                                loc: {
                                                    start: {
                                                        line: 54,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'glass/model/ApplicationModel.ion'
                                                    },
                                                    end: {
                                                        line: 54,
                                                        column: 21,
                                                        fixed: true,
                                                        source: 'glass/model/ApplicationModel.ion'
                                                    }
                                                }
                                            }
                                        },
                                        consequent: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'gdata',
                                                    loc: {
                                                        start: {
                                                            line: 54,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'glass/model/ApplicationModel.ion'
                                                        },
                                                        end: {
                                                            line: 54,
                                                            column: 30,
                                                            fixed: true,
                                                            source: 'glass/model/ApplicationModel.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'createNewReactiveDataObject',
                                                    loc: {
                                                        start: {
                                                            line: 54,
                                                            column: 31,
                                                            fixed: true,
                                                            source: 'glass/model/ApplicationModel.ion'
                                                        },
                                                        end: {
                                                            line: 54,
                                                            column: 58,
                                                            fixed: true,
                                                            source: 'glass/model/ApplicationModel.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 54,
                                                        column: 25,
                                                        fixed: true,
                                                        source: 'glass/model/ApplicationModel.ion'
                                                    },
                                                    end: {
                                                        line: 54,
                                                        column: 58,
                                                        fixed: true,
                                                        source: 'glass/model/ApplicationModel.ion'
                                                    }
                                                }
                                            },
                                            arguments: [{
                                                    type: 'ObjectExpression',
                                                    properties: [
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'url',
                                                                loc: {
                                                                    start: {
                                                                        line: 54,
                                                                        column: 60,
                                                                        fixed: true,
                                                                        source: 'glass/model/ApplicationModel.ion'
                                                                    },
                                                                    end: {
                                                                        line: 54,
                                                                        column: 63,
                                                                        fixed: true,
                                                                        source: 'glass/model/ApplicationModel.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Identifier',
                                                                name: 'serverUrl',
                                                                loc: {
                                                                    start: {
                                                                        line: 54,
                                                                        column: 65,
                                                                        fixed: true,
                                                                        source: 'glass/model/ApplicationModel.ion'
                                                                    },
                                                                    end: {
                                                                        line: 54,
                                                                        column: 74,
                                                                        fixed: true,
                                                                        source: 'glass/model/ApplicationModel.ion'
                                                                    }
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        },
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'namespace',
                                                                loc: {
                                                                    start: {
                                                                        line: 54,
                                                                        column: 76,
                                                                        fixed: true,
                                                                        source: 'glass/model/ApplicationModel.ion'
                                                                    },
                                                                    end: {
                                                                        line: 54,
                                                                        column: 85,
                                                                        fixed: true,
                                                                        source: 'glass/model/ApplicationModel.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Identifier',
                                                                name: 'namespace',
                                                                loc: {
                                                                    start: {
                                                                        line: 54,
                                                                        column: 76,
                                                                        fixed: true,
                                                                        source: 'glass/model/ApplicationModel.ion'
                                                                    },
                                                                    end: {
                                                                        line: 54,
                                                                        column: 85,
                                                                        fixed: true,
                                                                        source: 'glass/model/ApplicationModel.ion'
                                                                    }
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '1'
                                                        },
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'token',
                                                                loc: {
                                                                    start: {
                                                                        line: 54,
                                                                        column: 87,
                                                                        fixed: true,
                                                                        source: 'glass/model/ApplicationModel.ion'
                                                                    },
                                                                    end: {
                                                                        line: 54,
                                                                        column: 92,
                                                                        fixed: true,
                                                                        source: 'glass/model/ApplicationModel.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Identifier',
                                                                name: 'token',
                                                                loc: {
                                                                    start: {
                                                                        line: 54,
                                                                        column: 87,
                                                                        fixed: true,
                                                                        source: 'glass/model/ApplicationModel.ion'
                                                                    },
                                                                    end: {
                                                                        line: 54,
                                                                        column: 92,
                                                                        fixed: true,
                                                                        source: 'glass/model/ApplicationModel.ion'
                                                                    }
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '2'
                                                        },
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'error',
                                                                loc: {
                                                                    start: {
                                                                        line: 54,
                                                                        column: 94,
                                                                        fixed: true,
                                                                        source: 'glass/model/ApplicationModel.ion'
                                                                    },
                                                                    end: {
                                                                        line: 54,
                                                                        column: 99,
                                                                        fixed: true,
                                                                        source: 'glass/model/ApplicationModel.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Identifier',
                                                                name: 'errorHandler',
                                                                loc: {
                                                                    start: {
                                                                        line: 54,
                                                                        column: 101,
                                                                        fixed: true,
                                                                        source: 'glass/model/ApplicationModel.ion'
                                                                    },
                                                                    end: {
                                                                        line: 54,
                                                                        column: 113,
                                                                        fixed: true,
                                                                        source: 'glass/model/ApplicationModel.ion'
                                                                    }
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '3'
                                                        },
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'model',
                                                                loc: {
                                                                    start: {
                                                                        line: 54,
                                                                        column: 115,
                                                                        fixed: true,
                                                                        source: 'glass/model/ApplicationModel.ion'
                                                                    },
                                                                    end: {
                                                                        line: 54,
                                                                        column: 120,
                                                                        fixed: true,
                                                                        source: 'glass/model/ApplicationModel.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Identifier',
                                                                name: 'model',
                                                                loc: {
                                                                    start: {
                                                                        line: 54,
                                                                        column: 115,
                                                                        fixed: true,
                                                                        source: 'glass/model/ApplicationModel.ion'
                                                                    },
                                                                    end: {
                                                                        line: 54,
                                                                        column: 120,
                                                                        fixed: true,
                                                                        source: 'glass/model/ApplicationModel.ion'
                                                                    }
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '4'
                                                        },
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'token',
                                                                loc: {
                                                                    start: {
                                                                        line: 54,
                                                                        column: 122,
                                                                        fixed: true,
                                                                        source: 'glass/model/ApplicationModel.ion'
                                                                    },
                                                                    end: {
                                                                        line: 54,
                                                                        column: 127,
                                                                        fixed: true,
                                                                        source: 'glass/model/ApplicationModel.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Identifier',
                                                                name: 'token',
                                                                loc: {
                                                                    start: {
                                                                        line: 54,
                                                                        column: 122,
                                                                        fixed: true,
                                                                        source: 'glass/model/ApplicationModel.ion'
                                                                    },
                                                                    end: {
                                                                        line: 54,
                                                                        column: 127,
                                                                        fixed: true,
                                                                        source: 'glass/model/ApplicationModel.ion'
                                                                    }
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '5'
                                                        }
                                                    ]
                                                }],
                                            loc: {
                                                start: {
                                                    line: 54,
                                                    column: 25,
                                                    fixed: true,
                                                    source: 'glass/model/ApplicationModel.ion'
                                                },
                                                end: {
                                                    line: 54,
                                                    column: 129,
                                                    fixed: true,
                                                    source: 'glass/model/ApplicationModel.ion'
                                                }
                                            }
                                        },
                                        alternate: {
                                            type: 'Literal',
                                            value: null
                                        }
                                    },
                                    kind: 'init',
                                    order: '2'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'user',
                                        loc: {
                                            start: {
                                                line: 55,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 55,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Identifier',
                                        name: 'user',
                                        loc: {
                                            start: {
                                                line: 55,
                                                column: 14,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 55,
                                                column: 18,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '3'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'userKey',
                                        loc: {
                                            start: {
                                                line: 56,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 56,
                                                column: 15,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Identifier',
                                        name: 'userKey',
                                        loc: {
                                            start: {
                                                line: 56,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 56,
                                                column: 24,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '4'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'setLastLoginTimeNow',
                                        loc: {
                                            start: {
                                                line: 57,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 57,
                                                column: 27,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Identifier',
                                        name: 'setLastLoginTimeNow',
                                        loc: {
                                            start: {
                                                line: 57,
                                                column: 29,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 57,
                                                column: 48,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '5'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'login',
                                        loc: {
                                            start: {
                                                line: 58,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 58,
                                                column: 13,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context5) {
                                            return function (_ref4) {
                                                var crypt = _context5.get('crypt'), Authentication = _context5.get('Authentication');
                                                var userId = _ref4.userId;
                                                var password = _ref4.password;
                                                var remember = _ref4.remember;
                                                var passwordHash = crypt.hash(password);
                                                var token = Authentication.createToken({
                                                        userKey: 'User/' + userId.toLowerCase(),
                                                        passwordHash: passwordHash
                                                    });
                                                this.setToken(token, remember);
                                                this.logoutStatus = null;
                                            };
                                        }
                                    },
                                    kind: 'init',
                                    order: '6'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'logout',
                                        loc: {
                                            start: {
                                                line: 64,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 64,
                                                column: 14,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: false,
                                        value: function (errorStatus, reload) {
                                            if (reload == null)
                                                reload = true;
                                            this.logoutStatus = errorStatus;
                                            this.setToken(null);
                                            this.home();
                                            if (reload) {
                                                document.location.reload();
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '7'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'setToken',
                                        loc: {
                                            start: {
                                                line: 72,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 72,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context6) {
                                            return function (token, remember) {
                                                if (remember == null)
                                                    remember = true;
                                                var model = _context6.get('model');
                                                if (token != null) {
                                                    var storage = remember ? model.local : model.session;
                                                    storage.token = token;
                                                } else {
                                                    delete model.session.token;
                                                    delete model.local.token;
                                                }
                                            };
                                        }
                                    },
                                    kind: 'init',
                                    order: '8'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'logoutStatus',
                                        loc: {
                                            start: {
                                                line: 79,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 79,
                                                column: 20,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: null
                                    },
                                    kind: 'init',
                                    order: '9'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'changed',
                                        loc: {
                                            start: {
                                                line: 80,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 80,
                                                column: 15,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: 0
                                    },
                                    kind: 'init',
                                    order: ':'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'guid',
                                        loc: {
                                            start: {
                                                line: 90,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 90,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context7) {
                                            return function () {
                                                var userKey = _context7.get('userKey'), crypt = _context7.get('crypt');
                                                if (!(userKey != null)) {
                                                    throw new Error('Cannot create guids unless user is logged in.');
                                                }
                                                this._count = this._count != null ? this._count : 0;
                                                var time = Date.now();
                                                if (time === this._lastTime) {
                                                    this._count++;
                                                } else {
                                                    this._lastTime = time;
                                                    this._count = 0;
                                                }
                                                var count = this._count;
                                                return crypt.guid(userKey + ':' + time + ':' + count);
                                            };
                                        }
                                    },
                                    kind: 'init',
                                    order: ';'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'alert',
                                        loc: {
                                            start: {
                                                line: 103,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 103,
                                                column: 13,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: false,
                                        value: function (text) {
                                            glass.html.material.AlertDialog.show({ text: text });
                                        }
                                    },
                                    kind: 'init',
                                    order: '<'
                                },
                                {
                                    type: 'VariableDeclaration',
                                    declarations: [{
                                            type: 'VariableDeclarator',
                                            id: {
                                                type: 'Identifier',
                                                name: 'navigationDefaultState',
                                                loc: {
                                                    start: {
                                                        line: 107,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/model/ApplicationModel.ion'
                                                    },
                                                    end: {
                                                        line: 107,
                                                        column: 34,
                                                        fixed: true,
                                                        source: 'glass/model/ApplicationModel.ion'
                                                    }
                                                }
                                            },
                                            init: {
                                                type: 'ConditionalExpression',
                                                test: {
                                                    type: 'BinaryExpression',
                                                    operator: '!=',
                                                    left: {
                                                        type: 'Identifier',
                                                        name: '_navigationDefaultState',
                                                        loc: {
                                                            start: {
                                                                line: 107,
                                                                column: 37,
                                                                fixed: true,
                                                                source: 'glass/model/ApplicationModel.ion'
                                                            },
                                                            end: {
                                                                line: 107,
                                                                column: 60,
                                                                fixed: true,
                                                                source: 'glass/model/ApplicationModel.ion'
                                                            }
                                                        }
                                                    },
                                                    right: {
                                                        type: 'Literal',
                                                        value: null
                                                    }
                                                },
                                                consequent: {
                                                    type: 'Identifier',
                                                    name: '_navigationDefaultState',
                                                    loc: {
                                                        start: {
                                                            line: 107,
                                                            column: 37,
                                                            fixed: true,
                                                            source: 'glass/model/ApplicationModel.ion'
                                                        },
                                                        end: {
                                                            line: 107,
                                                            column: 60,
                                                            fixed: true,
                                                            source: 'glass/model/ApplicationModel.ion'
                                                        }
                                                    }
                                                },
                                                alternate: {
                                                    type: 'ObjectExpression',
                                                    properties: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'panes',
                                                                loc: {
                                                                    start: {
                                                                        line: 107,
                                                                        column: 64,
                                                                        fixed: true,
                                                                        source: 'glass/model/ApplicationModel.ion'
                                                                    },
                                                                    end: {
                                                                        line: 107,
                                                                        column: 69,
                                                                        fixed: true,
                                                                        source: 'glass/model/ApplicationModel.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'ArrayExpression',
                                                                elements: [{
                                                                        type: 'ObjectExpression',
                                                                        properties: [{
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'id',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 107,
                                                                                            column: 72,
                                                                                            fixed: true,
                                                                                            source: 'glass/model/ApplicationModel.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 107,
                                                                                            column: 74,
                                                                                            fixed: true,
                                                                                            source: 'glass/model/ApplicationModel.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Literal',
                                                                                    value: 'Home'
                                                                                },
                                                                                kind: 'init',
                                                                                order: '0'
                                                                            }]
                                                                    }]
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                }
                                            }
                                        }],
                                    kind: 'let',
                                    order: '='
                                },
                                {
                                    type: 'VariableDeclaration',
                                    declarations: [{
                                            type: 'VariableDeclarator',
                                            id: {
                                                type: 'Identifier',
                                                name: 'navigation',
                                                loc: {
                                                    start: {
                                                        line: 108,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'glass/model/ApplicationModel.ion'
                                                    },
                                                    end: {
                                                        line: 108,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'glass/model/ApplicationModel.ion'
                                                    }
                                                }
                                            },
                                            init: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'HashState',
                                                    loc: {
                                                        start: {
                                                            line: 108,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'glass/model/ApplicationModel.ion'
                                                        },
                                                        end: {
                                                            line: 108,
                                                            column: 34,
                                                            fixed: true,
                                                            source: 'glass/model/ApplicationModel.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [{
                                                        type: 'Identifier',
                                                        name: 'navigationDefaultState',
                                                        loc: {
                                                            start: {
                                                                line: 108,
                                                                column: 35,
                                                                fixed: true,
                                                                source: 'glass/model/ApplicationModel.ion'
                                                            },
                                                            end: {
                                                                line: 108,
                                                                column: 57,
                                                                fixed: true,
                                                                source: 'glass/model/ApplicationModel.ion'
                                                            }
                                                        }
                                                    }],
                                                loc: {
                                                    start: {
                                                        line: 108,
                                                        column: 25,
                                                        fixed: true,
                                                        source: 'glass/model/ApplicationModel.ion'
                                                    },
                                                    end: {
                                                        line: 108,
                                                        column: 58,
                                                        fixed: true,
                                                        source: 'glass/model/ApplicationModel.ion'
                                                    }
                                                }
                                            }
                                        }],
                                    kind: 'let',
                                    order: '>'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'Function',
                                            context: true,
                                            value: function (_context8) {
                                                return function () {
                                                    var navigation = _context8.get('navigation'), navigationDefaultState = _context8.get('navigationDefaultState');
                                                    if (!(navigation.panes != null)) {
                                                        navigation.panes = JSON.parse(JSON.stringify(navigationDefaultState.panes));
                                                    }
                                                };
                                            }
                                        },
                                        arguments: [],
                                        loc: {
                                            start: {
                                                line: 109,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 112,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 109,
                                            column: 8,
                                            fixed: true,
                                            source: 'glass/model/ApplicationModel.ion'
                                        },
                                        end: {
                                            line: 112,
                                            column: 12,
                                            fixed: true,
                                            source: 'glass/model/ApplicationModel.ion'
                                        }
                                    },
                                    order: '?'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'navigation',
                                        loc: {
                                            start: {
                                                line: 112,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 112,
                                                column: 18,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Identifier',
                                        name: 'navigation',
                                        loc: {
                                            start: {
                                                line: 112,
                                                column: 20,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 112,
                                                column: 30,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '@'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'getLinkUrl',
                                        loc: {
                                            start: {
                                                line: 114,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 114,
                                                column: 18,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context9) {
                                            return function (targetPaneConfig, options) {
                                                var navigation = _context9.get('navigation');
                                                var hash = this.getNewNavigationState(targetPaneConfig, options, JSON.parse(JSON.stringify(navigation)));
                                                return '#' + JSON.stringify(hash);
                                            };
                                        }
                                    },
                                    kind: 'init',
                                    order: 'A'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'getNewNavigationState',
                                        loc: {
                                            start: {
                                                line: 117,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 117,
                                                column: 29,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context10) {
                                            return function (targetPaneConfig, options, state) {
                                                var navigation = _context10.get('navigation'), ion = _context10.get('ion');
                                                state = state != null ? state : navigation;
                                                var target;
                                                var replace;
                                                if (typeof options === 'string') {
                                                    target = options;
                                                } else if (options != null) {
                                                    var _ref5 = options;
                                                    target = _ref5.target;
                                                    replace = _ref5.replace;
                                                }
                                                var configTarget = (target === 'pin' ? void 0 : target) != null ? target === 'pin' ? void 0 : target : targetPaneConfig.target;
                                                targetPaneConfig.target = configTarget;
                                                var sameIdConfig = state.panes.find(function (config) {
                                                        return config.id === targetPaneConfig.id;
                                                    });
                                                if (replace && sameIdConfig != null) {
                                                    ion.patch(sameIdConfig, targetPaneConfig);
                                                } else if (configTarget === 'float' || configTarget === 'dialog') {
                                                    if ((state.panes[state.panes.length - 1] != null ? state.panes[state.panes.length - 1].target : void 0) === configTarget) {
                                                        state.panes.pop();
                                                    }
                                                    state.panes.push(targetPaneConfig);
                                                } else if (target === 'pin') {
                                                    delete targetPaneConfig.float;
                                                    state.panes.push(targetPaneConfig);
                                                } else {
                                                    delete targetPaneConfig.float;
                                                    state.panes.splice(0, state.panes.length, targetPaneConfig);
                                                }
                                                return state;
                                            };
                                        }
                                    },
                                    kind: 'init',
                                    order: 'B'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'open',
                                        loc: {
                                            start: {
                                                line: 148,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 148,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context11) {
                                            return function (targetPaneConfig, options) {
                                                var navigation = _context11.get('navigation');
                                                this.getNewNavigationState(targetPaneConfig, options, navigation);
                                            };
                                        }
                                    },
                                    kind: 'init',
                                    order: 'C'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'close',
                                        loc: {
                                            start: {
                                                line: 150,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 150,
                                                column: 13,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context12) {
                                            return function (paneConfig) {
                                                var navigation = _context12.get('navigation');
                                                navigation.panes.remove(paneConfig);
                                            };
                                        }
                                    },
                                    kind: 'init',
                                    order: 'D'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'home',
                                        loc: {
                                            start: {
                                                line: 152,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 152,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context13) {
                                            return function () {
                                                var ion = _context13.get('ion'), navigation = _context13.get('navigation'), navigationDefaultState = _context13.get('navigationDefaultState');
                                                ion.patch(navigation, navigationDefaultState);
                                                navigation.panes.length = 1;
                                            };
                                        }
                                    },
                                    kind: 'init',
                                    order: 'E'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'isEditing',
                                        loc: {
                                            start: {
                                                line: 156,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 156,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: false,
                                        value: function () {
                                            return this._endEditCallback != null;
                                        }
                                    },
                                    kind: 'init',
                                    order: 'F'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'beginEdit',
                                        loc: {
                                            start: {
                                                line: 157,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 157,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: false,
                                        value: function (endEditCallback) {
                                            this.endEdit();
                                            this._endEditCallback = endEditCallback;
                                        }
                                    },
                                    kind: 'init',
                                    order: 'G'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'endEdit',
                                        loc: {
                                            start: {
                                                line: 160,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 160,
                                                column: 15,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: false,
                                        value: function (commit, detail) {
                                            var callback = this._endEditCallback;
                                            this._endEditCallback = null;
                                            callback != null ? callback(commit, detail) : void 0;
                                        }
                                    },
                                    kind: 'init',
                                    order: 'H'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'selectedObjects',
                                        loc: {
                                            start: {
                                                line: 166,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 166,
                                                column: 23,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: null
                                    },
                                    kind: 'init',
                                    order: 'I'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'selectedObjectKeys',
                                        loc: {
                                            start: {
                                                line: 167,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 167,
                                                column: 26,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        objectType: {
                                            type: 'ObjectExpression',
                                            properties: []
                                        },
                                        properties: [{
                                                type: 'IfStatement',
                                                test: {
                                                    type: 'UnaryExpression',
                                                    operator: '?',
                                                    argument: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'model',
                                                            loc: {
                                                                start: {
                                                                    line: 168,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'glass/model/ApplicationModel.ion'
                                                                },
                                                                end: {
                                                                    line: 168,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'glass/model/ApplicationModel.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'selectedObjects',
                                                            loc: {
                                                                start: {
                                                                    line: 168,
                                                                    column: 21,
                                                                    fixed: true,
                                                                    source: 'glass/model/ApplicationModel.ion'
                                                                },
                                                                end: {
                                                                    line: 168,
                                                                    column: 36,
                                                                    fixed: true,
                                                                    source: 'glass/model/ApplicationModel.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 168,
                                                                column: 15,
                                                                fixed: true,
                                                                source: 'glass/model/ApplicationModel.ion'
                                                            },
                                                            end: {
                                                                line: 168,
                                                                column: 36,
                                                                fixed: true,
                                                                source: 'glass/model/ApplicationModel.ion'
                                                            }
                                                        }
                                                    }
                                                },
                                                consequent: {
                                                    type: 'BlockStatement',
                                                    body: [{
                                                            type: 'ForOfStatement',
                                                            left: {
                                                                type: 'VariableDeclaration',
                                                                declarations: [{
                                                                        type: 'VariableDeclarator',
                                                                        id: {
                                                                            type: 'Identifier',
                                                                            name: 'object',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 169,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/model/ApplicationModel.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 169,
                                                                                    column: 26,
                                                                                    fixed: true,
                                                                                    source: 'glass/model/ApplicationModel.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        init: null
                                                                    }],
                                                                kind: 'let'
                                                            },
                                                            right: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'model',
                                                                    loc: {
                                                                        start: {
                                                                            line: 169,
                                                                            column: 30,
                                                                            fixed: true,
                                                                            source: 'glass/model/ApplicationModel.ion'
                                                                        },
                                                                        end: {
                                                                            line: 169,
                                                                            column: 35,
                                                                            fixed: true,
                                                                            source: 'glass/model/ApplicationModel.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'selectedObjects',
                                                                    loc: {
                                                                        start: {
                                                                            line: 169,
                                                                            column: 36,
                                                                            fixed: true,
                                                                            source: 'glass/model/ApplicationModel.ion'
                                                                        },
                                                                        end: {
                                                                            line: 169,
                                                                            column: 51,
                                                                            fixed: true,
                                                                            source: 'glass/model/ApplicationModel.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 169,
                                                                        column: 30,
                                                                        fixed: true,
                                                                        source: 'glass/model/ApplicationModel.ion'
                                                                    },
                                                                    end: {
                                                                        line: 169,
                                                                        column: 51,
                                                                        fixed: true,
                                                                        source: 'glass/model/ApplicationModel.ion'
                                                                    }
                                                                }
                                                            },
                                                            body: {
                                                                type: 'BlockStatement',
                                                                body: [{
                                                                        type: 'IfStatement',
                                                                        test: {
                                                                            type: 'UnaryExpression',
                                                                            operator: '?',
                                                                            argument: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'Identifier',
                                                                                    name: 'object',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 169,
                                                                                            column: 55,
                                                                                            fixed: true,
                                                                                            source: 'glass/model/ApplicationModel.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 169,
                                                                                            column: 61,
                                                                                            fixed: true,
                                                                                            source: 'glass/model/ApplicationModel.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'key',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 169,
                                                                                            column: 62,
                                                                                            fixed: true,
                                                                                            source: 'glass/model/ApplicationModel.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 169,
                                                                                            column: 65,
                                                                                            fixed: true,
                                                                                            source: 'glass/model/ApplicationModel.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 169,
                                                                                        column: 55,
                                                                                        fixed: true,
                                                                                        source: 'glass/model/ApplicationModel.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 169,
                                                                                        column: 65,
                                                                                        fixed: true,
                                                                                        source: 'glass/model/ApplicationModel.ion'
                                                                                    }
                                                                                }
                                                                            }
                                                                        },
                                                                        consequent: {
                                                                            type: 'BlockStatement',
                                                                            body: [{
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'object',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 170,
                                                                                                    column: 21,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/model/ApplicationModel.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 170,
                                                                                                    column: 27,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/model/ApplicationModel.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'key',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 170,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/model/ApplicationModel.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 170,
                                                                                                    column: 31,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/model/ApplicationModel.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 170,
                                                                                                column: 21,
                                                                                                fixed: true,
                                                                                                source: 'glass/model/ApplicationModel.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 170,
                                                                                                column: 31,
                                                                                                fixed: true,
                                                                                                source: 'glass/model/ApplicationModel.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Identifier',
                                                                                        name: 'object',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 170,
                                                                                                column: 34,
                                                                                                fixed: true,
                                                                                                source: 'glass/model/ApplicationModel.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 170,
                                                                                                column: 40,
                                                                                                fixed: true,
                                                                                                source: 'glass/model/ApplicationModel.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    computed: true,
                                                                                    order: '0'
                                                                                }]
                                                                        },
                                                                        order: '0'
                                                                    }]
                                                            },
                                                            remove: null,
                                                            order: '0'
                                                        }]
                                                },
                                                alternate: null,
                                                order: '0'
                                            }]
                                    },
                                    kind: 'init',
                                    order: 'J'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'selectedProperties',
                                        loc: {
                                            start: {
                                                line: 171,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 171,
                                                column: 26,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: null
                                    },
                                    kind: 'init',
                                    order: 'K'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'selectedPropertyNames',
                                        loc: {
                                            start: {
                                                line: 172,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 172,
                                                column: 29,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        objectType: {
                                            type: 'ObjectExpression',
                                            properties: []
                                        },
                                        properties: [{
                                                type: 'IfStatement',
                                                test: {
                                                    type: 'UnaryExpression',
                                                    operator: '?',
                                                    argument: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'model',
                                                            loc: {
                                                                start: {
                                                                    line: 173,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'glass/model/ApplicationModel.ion'
                                                                },
                                                                end: {
                                                                    line: 173,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'glass/model/ApplicationModel.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'selectedProperties',
                                                            loc: {
                                                                start: {
                                                                    line: 173,
                                                                    column: 21,
                                                                    fixed: true,
                                                                    source: 'glass/model/ApplicationModel.ion'
                                                                },
                                                                end: {
                                                                    line: 173,
                                                                    column: 39,
                                                                    fixed: true,
                                                                    source: 'glass/model/ApplicationModel.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 173,
                                                                column: 15,
                                                                fixed: true,
                                                                source: 'glass/model/ApplicationModel.ion'
                                                            },
                                                            end: {
                                                                line: 173,
                                                                column: 39,
                                                                fixed: true,
                                                                source: 'glass/model/ApplicationModel.ion'
                                                            }
                                                        }
                                                    }
                                                },
                                                consequent: {
                                                    type: 'BlockStatement',
                                                    body: [{
                                                            type: 'ForOfStatement',
                                                            left: {
                                                                type: 'VariableDeclaration',
                                                                declarations: [{
                                                                        type: 'VariableDeclarator',
                                                                        id: {
                                                                            type: 'Identifier',
                                                                            name: 'property',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 174,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/model/ApplicationModel.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 174,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'glass/model/ApplicationModel.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        init: null
                                                                    }],
                                                                kind: 'let'
                                                            },
                                                            right: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'model',
                                                                    loc: {
                                                                        start: {
                                                                            line: 174,
                                                                            column: 32,
                                                                            fixed: true,
                                                                            source: 'glass/model/ApplicationModel.ion'
                                                                        },
                                                                        end: {
                                                                            line: 174,
                                                                            column: 37,
                                                                            fixed: true,
                                                                            source: 'glass/model/ApplicationModel.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'selectedProperties',
                                                                    loc: {
                                                                        start: {
                                                                            line: 174,
                                                                            column: 38,
                                                                            fixed: true,
                                                                            source: 'glass/model/ApplicationModel.ion'
                                                                        },
                                                                        end: {
                                                                            line: 174,
                                                                            column: 56,
                                                                            fixed: true,
                                                                            source: 'glass/model/ApplicationModel.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 174,
                                                                        column: 32,
                                                                        fixed: true,
                                                                        source: 'glass/model/ApplicationModel.ion'
                                                                    },
                                                                    end: {
                                                                        line: 174,
                                                                        column: 56,
                                                                        fixed: true,
                                                                        source: 'glass/model/ApplicationModel.ion'
                                                                    }
                                                                }
                                                            },
                                                            body: {
                                                                type: 'BlockStatement',
                                                                body: [{
                                                                        type: 'IfStatement',
                                                                        test: {
                                                                            type: 'UnaryExpression',
                                                                            operator: '?',
                                                                            argument: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'Identifier',
                                                                                    name: 'property',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 174,
                                                                                            column: 60,
                                                                                            fixed: true,
                                                                                            source: 'glass/model/ApplicationModel.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 174,
                                                                                            column: 68,
                                                                                            fixed: true,
                                                                                            source: 'glass/model/ApplicationModel.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'name',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 174,
                                                                                            column: 69,
                                                                                            fixed: true,
                                                                                            source: 'glass/model/ApplicationModel.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 174,
                                                                                            column: 73,
                                                                                            fixed: true,
                                                                                            source: 'glass/model/ApplicationModel.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 174,
                                                                                        column: 60,
                                                                                        fixed: true,
                                                                                        source: 'glass/model/ApplicationModel.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 174,
                                                                                        column: 73,
                                                                                        fixed: true,
                                                                                        source: 'glass/model/ApplicationModel.ion'
                                                                                    }
                                                                                }
                                                                            }
                                                                        },
                                                                        consequent: {
                                                                            type: 'BlockStatement',
                                                                            body: [{
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'property',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 175,
                                                                                                    column: 21,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/model/ApplicationModel.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 175,
                                                                                                    column: 29,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/model/ApplicationModel.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'name',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 175,
                                                                                                    column: 30,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/model/ApplicationModel.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 175,
                                                                                                    column: 34,
                                                                                                    fixed: true,
                                                                                                    source: 'glass/model/ApplicationModel.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 175,
                                                                                                column: 21,
                                                                                                fixed: true,
                                                                                                source: 'glass/model/ApplicationModel.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 175,
                                                                                                column: 34,
                                                                                                fixed: true,
                                                                                                source: 'glass/model/ApplicationModel.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Identifier',
                                                                                        name: 'property',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 175,
                                                                                                column: 37,
                                                                                                fixed: true,
                                                                                                source: 'glass/model/ApplicationModel.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 175,
                                                                                                column: 45,
                                                                                                fixed: true,
                                                                                                source: 'glass/model/ApplicationModel.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    computed: true,
                                                                                    order: '0'
                                                                                }]
                                                                        },
                                                                        order: '0'
                                                                    }]
                                                            },
                                                            remove: null,
                                                            order: '0'
                                                        }]
                                                },
                                                alternate: null,
                                                order: '0'
                                            }]
                                    },
                                    kind: 'init',
                                    order: 'L'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'ajax',
                                        loc: {
                                            start: {
                                                line: 177,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 177,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: false,
                                        value: function (url, object, callback) {
                                            return this.server.source.ajaxSource.ajax(url, object, callback);
                                        }
                                    },
                                    kind: 'init',
                                    order: 'M'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'request',
                                        loc: {
                                            start: {
                                                line: 178,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 178,
                                                column: 15,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: false,
                                        value: function (key, object, callback) {
                                            return this.server.source.ajaxSource.send(key, object, callback);
                                        }
                                    },
                                    kind: 'init',
                                    order: 'N'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'toggleDataLog',
                                        loc: {
                                            start: {
                                                line: 179,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 179,
                                                column: 21,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: false,
                                        value: function () {
                                            this.server.source.ajaxSource.logging = !this.server.source.ajaxSource.logging;
                                        }
                                    },
                                    kind: 'init',
                                    order: 'O'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'onNextFlushed',
                                        loc: {
                                            start: {
                                                line: 182,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 182,
                                                column: 21,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: false,
                                        value: function (callback) {
                                            var handler = function (e) {
                                                window.removeEventListener('flushed', handler);
                                                callback(e);
                                            };
                                            window.addEventListener('flushed', handler);
                                        }
                                    },
                                    kind: 'init',
                                    order: 'P'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'toast',
                                        loc: {
                                            start: {
                                                line: 188,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 188,
                                                column: 13,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Identifier',
                                        name: 'Toast',
                                        loc: {
                                            start: {
                                                line: 188,
                                                column: 15,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 188,
                                                column: 20,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: 'Q'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'busy',
                                        loc: {
                                            start: {
                                                line: 189,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 189,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: false,
                                        value: function (properties) {
                                            return this.toast.busy(properties);
                                        }
                                    },
                                    kind: 'init',
                                    order: 'R'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'info',
                                        loc: {
                                            start: {
                                                line: 190,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 190,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: false,
                                        value: function (properties) {
                                            return this.toast.info(properties);
                                        }
                                    },
                                    kind: 'init',
                                    order: 'S'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'warn',
                                        loc: {
                                            start: {
                                                line: 191,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 191,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: false,
                                        value: function (properties) {
                                            return this.toast.warn(properties);
                                        }
                                    },
                                    kind: 'init',
                                    order: 'T'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'error',
                                        loc: {
                                            start: {
                                                line: 192,
                                                column: 8,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 192,
                                                column: 13,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: false,
                                        value: function (properties) {
                                            return this.toast.error(properties);
                                        }
                                    },
                                    kind: 'init',
                                    order: 'U'
                                }
                            ]
                        },
                        {
                            type: 'ObjectExpression',
                            properties: [{
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'mobile',
                                        loc: {
                                            start: {
                                                line: 81,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 81,
                                                column: 23,
                                                fixed: true,
                                                source: 'glass/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 82,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/model/ApplicationModel.ion'
                                                        },
                                                        end: {
                                                            line: 82,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/model/ApplicationModel.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: false,
                                                    value: function () {
                                                        return this.local.mobile != null ? this.local.mobile : false;
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 83,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'glass/model/ApplicationModel.ion'
                                                        },
                                                        end: {
                                                            line: 83,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'glass/model/ApplicationModel.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: false,
                                                    value: function (value) {
                                                        if (value !== this.local.mobile) {
                                                            if (value != null) {
                                                                this.local.mobile = value;
                                                            } else {
                                                                delete this.local.mobile;
                                                            }
                                                            this.changed++;
                                                        }
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '0'
                                }]
                        }
                    ]
                },
                order: '>'
            }
        ],
        bound: false
    }, {
        this: this,
        ion: ion,
        _ref3: _ref3,
        gdata: gdata,
        crypt: crypt,
        _ref: _ref,
        _ref2: _ref2,
        Authentication: Authentication,
        Toast: Toast,
        WebStorageState: WebStorageState,
        HashState: HashState,
        getAncestorByClass: getAncestorByClass
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/model/ApplicationModel',_glass_model_ApplicationModel_);
    else
      _glass_model_ApplicationModel_.call(this, module, exports, require);
  }
  else {
    _glass_model_ApplicationModel_.call(this);
  }
}).call(this)
void (function(){var _glass_model_Authentication_ = function(module,exports,require){'use strict';
var crypt = require('../crypt');
var createToken = exports.createToken = function (_ref) {
        var userKey = _ref.userKey;
        var passwordHash = _ref.passwordHash;
        var timeout = _ref.timeout;
        var userHash = crypt.hash(passwordHash);
        var token = crypt.jwtSign({
                userKey: userKey,
                userHash: userHash
            }, passwordHash, timeout);
        return token;
    };
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/model/Authentication',_glass_model_Authentication_);
    else
      _glass_model_Authentication_.call(this, module, exports, require);
  }
  else {
    _glass_model_Authentication_.call(this);
  }
}).call(this)
void (function(){var _glass_model_Channel_ = function(module,exports,require){'use strict';
var ion = require('ion');
var Channel = ion.defineClass({
        name: 'Channel',
        id: module.id,
        search: false,
        properties: { token: { type: 'string' } }
    }, require('./Entity'));
module.exports = exports = Channel;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/model/Channel',_glass_model_Channel_);
    else
      _glass_model_Channel_.call(this, module, exports, require);
  }
  else {
    _glass_model_Channel_.call(this);
  }
}).call(this)
void (function(){var _glass_model_DataModel_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('../data');
var Key = _ref.Key;
module.exports = exports = ion.template(function (model) {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [{
                type: 'ReturnStatement',
                argument: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'ObjectExpression',
                        properties: []
                    },
                    properties: [
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'records',
                                        loc: {
                                            start: {
                                                line: 14,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/model/DataModel.ion'
                                            },
                                            end: {
                                                line: 14,
                                                column: 19,
                                                fixed: true,
                                                source: 'glass/model/DataModel.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'ConditionalExpression',
                                        test: {
                                            type: 'BinaryExpression',
                                            operator: '!=',
                                            left: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'model',
                                                    loc: {
                                                        start: {
                                                            line: 14,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'glass/model/DataModel.ion'
                                                        },
                                                        end: {
                                                            line: 14,
                                                            column: 27,
                                                            fixed: true,
                                                            source: 'glass/model/DataModel.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'records',
                                                    loc: {
                                                        start: {
                                                            line: 14,
                                                            column: 28,
                                                            fixed: true,
                                                            source: 'glass/model/DataModel.ion'
                                                        },
                                                        end: {
                                                            line: 14,
                                                            column: 35,
                                                            fixed: true,
                                                            source: 'glass/model/DataModel.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 14,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'glass/model/DataModel.ion'
                                                    },
                                                    end: {
                                                        line: 14,
                                                        column: 35,
                                                        fixed: true,
                                                        source: 'glass/model/DataModel.ion'
                                                    }
                                                }
                                            },
                                            right: {
                                                type: 'Literal',
                                                value: null
                                            }
                                        },
                                        consequent: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'model',
                                                loc: {
                                                    start: {
                                                        line: 14,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'glass/model/DataModel.ion'
                                                    },
                                                    end: {
                                                        line: 14,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'glass/model/DataModel.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'records',
                                                loc: {
                                                    start: {
                                                        line: 14,
                                                        column: 28,
                                                        fixed: true,
                                                        source: 'glass/model/DataModel.ion'
                                                    },
                                                    end: {
                                                        line: 14,
                                                        column: 35,
                                                        fixed: true,
                                                        source: 'glass/model/DataModel.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 14,
                                                    column: 22,
                                                    fixed: true,
                                                    source: 'glass/model/DataModel.ion'
                                                },
                                                end: {
                                                    line: 14,
                                                    column: 35,
                                                    fixed: true,
                                                    source: 'glass/model/DataModel.ion'
                                                }
                                            }
                                        },
                                        alternate: {
                                            type: 'MemberExpression',
                                            computed: true,
                                            object: {
                                                type: 'ConditionalExpression',
                                                test: {
                                                    type: 'BinaryExpression',
                                                    operator: '!=',
                                                    left: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'model',
                                                            loc: {
                                                                start: {
                                                                    line: 14,
                                                                    column: 39,
                                                                    fixed: true,
                                                                    source: 'glass/model/DataModel.ion'
                                                                },
                                                                end: {
                                                                    line: 14,
                                                                    column: 44,
                                                                    fixed: true,
                                                                    source: 'glass/model/DataModel.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'server',
                                                            loc: {
                                                                start: {
                                                                    line: 14,
                                                                    column: 45,
                                                                    fixed: true,
                                                                    source: 'glass/model/DataModel.ion'
                                                                },
                                                                end: {
                                                                    line: 14,
                                                                    column: 51,
                                                                    fixed: true,
                                                                    source: 'glass/model/DataModel.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 14,
                                                                column: 39,
                                                                fixed: true,
                                                                source: 'glass/model/DataModel.ion'
                                                            },
                                                            end: {
                                                                line: 14,
                                                                column: 51,
                                                                fixed: true,
                                                                source: 'glass/model/DataModel.ion'
                                                            }
                                                        }
                                                    },
                                                    right: {
                                                        type: 'Literal',
                                                        value: null
                                                    }
                                                },
                                                consequent: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'model',
                                                        loc: {
                                                            start: {
                                                                line: 14,
                                                                column: 39,
                                                                fixed: true,
                                                                source: 'glass/model/DataModel.ion'
                                                            },
                                                            end: {
                                                                line: 14,
                                                                column: 44,
                                                                fixed: true,
                                                                source: 'glass/model/DataModel.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'server',
                                                        loc: {
                                                            start: {
                                                                line: 14,
                                                                column: 45,
                                                                fixed: true,
                                                                source: 'glass/model/DataModel.ion'
                                                            },
                                                            end: {
                                                                line: 14,
                                                                column: 51,
                                                                fixed: true,
                                                                source: 'glass/model/DataModel.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 14,
                                                            column: 39,
                                                            fixed: true,
                                                            source: 'glass/model/DataModel.ion'
                                                        },
                                                        end: {
                                                            line: 14,
                                                            column: 51,
                                                            fixed: true,
                                                            source: 'glass/model/DataModel.ion'
                                                        }
                                                    }
                                                },
                                                alternate: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'global',
                                                            loc: {
                                                                start: {
                                                                    line: 14,
                                                                    column: 54,
                                                                    fixed: true,
                                                                    source: 'glass/model/DataModel.ion'
                                                                },
                                                                end: {
                                                                    line: 14,
                                                                    column: 60,
                                                                    fixed: true,
                                                                    source: 'glass/model/DataModel.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'model',
                                                            loc: {
                                                                start: {
                                                                    line: 14,
                                                                    column: 61,
                                                                    fixed: true,
                                                                    source: 'glass/model/DataModel.ion'
                                                                },
                                                                end: {
                                                                    line: 14,
                                                                    column: 66,
                                                                    fixed: true,
                                                                    source: 'glass/model/DataModel.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 14,
                                                                column: 54,
                                                                fixed: true,
                                                                source: 'glass/model/DataModel.ion'
                                                            },
                                                            end: {
                                                                line: 14,
                                                                column: 66,
                                                                fixed: true,
                                                                source: 'glass/model/DataModel.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'server',
                                                        loc: {
                                                            start: {
                                                                line: 14,
                                                                column: 68,
                                                                fixed: true,
                                                                source: 'glass/model/DataModel.ion'
                                                            },
                                                            end: {
                                                                line: 14,
                                                                column: 74,
                                                                fixed: true,
                                                                source: 'glass/model/DataModel.ion'
                                                            }
                                                        }
                                                    },
                                                    existential: true,
                                                    loc: {
                                                        start: {
                                                            line: 14,
                                                            column: 54,
                                                            fixed: true,
                                                            source: 'glass/model/DataModel.ion'
                                                        },
                                                        end: {
                                                            line: 14,
                                                            column: 74,
                                                            fixed: true,
                                                            source: 'glass/model/DataModel.ion'
                                                        }
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'NewExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'Key',
                                                    loc: {
                                                        start: {
                                                            line: 14,
                                                            column: 80,
                                                            fixed: true,
                                                            source: 'glass/model/DataModel.ion'
                                                        },
                                                        end: {
                                                            line: 14,
                                                            column: 83,
                                                            fixed: true,
                                                            source: 'glass/model/DataModel.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [
                                                    {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'model',
                                                            loc: {
                                                                start: {
                                                                    line: 14,
                                                                    column: 84,
                                                                    fixed: true,
                                                                    source: 'glass/model/DataModel.ion'
                                                                },
                                                                end: {
                                                                    line: 14,
                                                                    column: 89,
                                                                    fixed: true,
                                                                    source: 'glass/model/DataModel.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'type',
                                                            loc: {
                                                                start: {
                                                                    line: 14,
                                                                    column: 90,
                                                                    fixed: true,
                                                                    source: 'glass/model/DataModel.ion'
                                                                },
                                                                end: {
                                                                    line: 14,
                                                                    column: 94,
                                                                    fixed: true,
                                                                    source: 'glass/model/DataModel.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 14,
                                                                column: 84,
                                                                fixed: true,
                                                                source: 'glass/model/DataModel.ion'
                                                            },
                                                            end: {
                                                                line: 14,
                                                                column: 94,
                                                                fixed: true,
                                                                source: 'glass/model/DataModel.ion'
                                                            }
                                                        }
                                                    },
                                                    {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'model',
                                                            loc: {
                                                                start: {
                                                                    line: 14,
                                                                    column: 96,
                                                                    fixed: true,
                                                                    source: 'glass/model/DataModel.ion'
                                                                },
                                                                end: {
                                                                    line: 14,
                                                                    column: 101,
                                                                    fixed: true,
                                                                    source: 'glass/model/DataModel.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'query',
                                                            loc: {
                                                                start: {
                                                                    line: 14,
                                                                    column: 102,
                                                                    fixed: true,
                                                                    source: 'glass/model/DataModel.ion'
                                                                },
                                                                end: {
                                                                    line: 14,
                                                                    column: 107,
                                                                    fixed: true,
                                                                    source: 'glass/model/DataModel.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 14,
                                                                column: 96,
                                                                fixed: true,
                                                                source: 'glass/model/DataModel.ion'
                                                            },
                                                            end: {
                                                                line: 14,
                                                                column: 107,
                                                                fixed: true,
                                                                source: 'glass/model/DataModel.ion'
                                                            }
                                                        }
                                                    }
                                                ],
                                                loc: {
                                                    start: {
                                                        line: 14,
                                                        column: 76,
                                                        fixed: true,
                                                        source: 'glass/model/DataModel.ion'
                                                    },
                                                    end: {
                                                        line: 14,
                                                        column: 108,
                                                        fixed: true,
                                                        source: 'glass/model/DataModel.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 14,
                                                    column: 38,
                                                    fixed: true,
                                                    source: 'glass/model/DataModel.ion'
                                                },
                                                end: {
                                                    line: 14,
                                                    column: 109,
                                                    fixed: true,
                                                    source: 'glass/model/DataModel.ion'
                                                }
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '0'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'records',
                                loc: {
                                    start: {
                                        line: 15,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/model/DataModel.ion'
                                    },
                                    end: {
                                        line: 15,
                                        column: 15,
                                        fixed: true,
                                        source: 'glass/model/DataModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Identifier',
                                name: 'records',
                                loc: {
                                    start: {
                                        line: 15,
                                        column: 17,
                                        fixed: true,
                                        source: 'glass/model/DataModel.ion'
                                    },
                                    end: {
                                        line: 15,
                                        column: 24,
                                        fixed: true,
                                        source: 'glass/model/DataModel.ion'
                                    }
                                }
                            },
                            kind: 'init',
                            order: '1'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'properties',
                                        loc: {
                                            start: {
                                                line: 17,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/model/DataModel.ion'
                                            },
                                            end: {
                                                line: 17,
                                                column: 22,
                                                fixed: true,
                                                source: 'glass/model/DataModel.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'ConditionalExpression',
                                        test: {
                                            type: 'BinaryExpression',
                                            operator: '!=',
                                            left: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'model',
                                                    loc: {
                                                        start: {
                                                            line: 17,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'glass/model/DataModel.ion'
                                                        },
                                                        end: {
                                                            line: 17,
                                                            column: 30,
                                                            fixed: true,
                                                            source: 'glass/model/DataModel.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'properties',
                                                    loc: {
                                                        start: {
                                                            line: 17,
                                                            column: 31,
                                                            fixed: true,
                                                            source: 'glass/model/DataModel.ion'
                                                        },
                                                        end: {
                                                            line: 17,
                                                            column: 41,
                                                            fixed: true,
                                                            source: 'glass/model/DataModel.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 17,
                                                        column: 25,
                                                        fixed: true,
                                                        source: 'glass/model/DataModel.ion'
                                                    },
                                                    end: {
                                                        line: 17,
                                                        column: 41,
                                                        fixed: true,
                                                        source: 'glass/model/DataModel.ion'
                                                    }
                                                }
                                            },
                                            right: {
                                                type: 'Literal',
                                                value: null
                                            }
                                        },
                                        consequent: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'model',
                                                loc: {
                                                    start: {
                                                        line: 17,
                                                        column: 25,
                                                        fixed: true,
                                                        source: 'glass/model/DataModel.ion'
                                                    },
                                                    end: {
                                                        line: 17,
                                                        column: 30,
                                                        fixed: true,
                                                        source: 'glass/model/DataModel.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'properties',
                                                loc: {
                                                    start: {
                                                        line: 17,
                                                        column: 31,
                                                        fixed: true,
                                                        source: 'glass/model/DataModel.ion'
                                                    },
                                                    end: {
                                                        line: 17,
                                                        column: 41,
                                                        fixed: true,
                                                        source: 'glass/model/DataModel.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 17,
                                                    column: 25,
                                                    fixed: true,
                                                    source: 'glass/model/DataModel.ion'
                                                },
                                                end: {
                                                    line: 17,
                                                    column: 41,
                                                    fixed: true,
                                                    source: 'glass/model/DataModel.ion'
                                                }
                                            }
                                        },
                                        alternate: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'type',
                                                loc: {
                                                    start: {
                                                        line: 17,
                                                        column: 44,
                                                        fixed: true,
                                                        source: 'glass/model/DataModel.ion'
                                                    },
                                                    end: {
                                                        line: 17,
                                                        column: 48,
                                                        fixed: true,
                                                        source: 'glass/model/DataModel.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'properties',
                                                loc: {
                                                    start: {
                                                        line: 17,
                                                        column: 49,
                                                        fixed: true,
                                                        source: 'glass/model/DataModel.ion'
                                                    },
                                                    end: {
                                                        line: 17,
                                                        column: 59,
                                                        fixed: true,
                                                        source: 'glass/model/DataModel.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 17,
                                                    column: 44,
                                                    fixed: true,
                                                    source: 'glass/model/DataModel.ion'
                                                },
                                                end: {
                                                    line: 17,
                                                    column: 59,
                                                    fixed: true,
                                                    source: 'glass/model/DataModel.ion'
                                                }
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '2'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'rows',
                                        loc: {
                                            start: {
                                                line: 19,
                                                column: 12,
                                                fixed: true,
                                                source: 'glass/model/DataModel.ion'
                                            },
                                            end: {
                                                line: 19,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/model/DataModel.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'ObjectExpression',
                                        objectType: {
                                            type: 'ArrayExpression',
                                            elements: []
                                        },
                                        properties: [{
                                                type: 'ForInStatement',
                                                left: {
                                                    type: 'VariableDeclaration',
                                                    declarations: [
                                                        {
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'id',
                                                                loc: {
                                                                    start: {
                                                                        line: 20,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'glass/model/DataModel.ion'
                                                                    },
                                                                    end: {
                                                                        line: 20,
                                                                        column: 18,
                                                                        fixed: true,
                                                                        source: 'glass/model/DataModel.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: null
                                                        },
                                                        {
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'record',
                                                                loc: {
                                                                    start: {
                                                                        line: 20,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'glass/model/DataModel.ion'
                                                                    },
                                                                    end: {
                                                                        line: 20,
                                                                        column: 26,
                                                                        fixed: true,
                                                                        source: 'glass/model/DataModel.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: null
                                                        }
                                                    ],
                                                    kind: 'let'
                                                },
                                                right: {
                                                    type: 'Identifier',
                                                    name: 'records',
                                                    loc: {
                                                        start: {
                                                            line: 20,
                                                            column: 30,
                                                            fixed: true,
                                                            source: 'glass/model/DataModel.ion'
                                                        },
                                                        end: {
                                                            line: 20,
                                                            column: 37,
                                                            fixed: true,
                                                            source: 'glass/model/DataModel.ion'
                                                        }
                                                    }
                                                },
                                                body: {
                                                    type: 'BlockStatement',
                                                    body: [{
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'ObjectExpression',
                                                                properties: [
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'id',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 21,
                                                                                    column: 18,
                                                                                    fixed: true,
                                                                                    source: 'glass/model/DataModel.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 21,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'glass/model/DataModel.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Identifier',
                                                                            name: 'id',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 21,
                                                                                    column: 22,
                                                                                    fixed: true,
                                                                                    source: 'glass/model/DataModel.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 21,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'glass/model/DataModel.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    },
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'record',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 21,
                                                                                    column: 26,
                                                                                    fixed: true,
                                                                                    source: 'glass/model/DataModel.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 21,
                                                                                    column: 32,
                                                                                    fixed: true,
                                                                                    source: 'glass/model/DataModel.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Identifier',
                                                                            name: 'record',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 21,
                                                                                    column: 34,
                                                                                    fixed: true,
                                                                                    source: 'glass/model/DataModel.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 21,
                                                                                    column: 40,
                                                                                    fixed: true,
                                                                                    source: 'glass/model/DataModel.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        kind: 'init',
                                                                        order: '1'
                                                                    },
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'selected',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 21,
                                                                                    column: 42,
                                                                                    fixed: true,
                                                                                    source: 'glass/model/DataModel.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 21,
                                                                                    column: 50,
                                                                                    fixed: true,
                                                                                    source: 'glass/model/DataModel.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Literal',
                                                                            value: false
                                                                        },
                                                                        kind: 'init',
                                                                        order: '2'
                                                                    }
                                                                ]
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 21,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'glass/model/DataModel.ion'
                                                                },
                                                                end: {
                                                                    line: 21,
                                                                    column: 59,
                                                                    fixed: true,
                                                                    source: 'glass/model/DataModel.ion'
                                                                }
                                                            },
                                                            order: '0'
                                                        }]
                                                },
                                                remove: null,
                                                order: '0'
                                            }]
                                    }
                                }],
                            kind: 'let',
                            order: '3'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'rows',
                                loc: {
                                    start: {
                                        line: 22,
                                        column: 8,
                                        fixed: true,
                                        source: 'glass/model/DataModel.ion'
                                    },
                                    end: {
                                        line: 22,
                                        column: 12,
                                        fixed: true,
                                        source: 'glass/model/DataModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Identifier',
                                name: 'rows',
                                loc: {
                                    start: {
                                        line: 22,
                                        column: 14,
                                        fixed: true,
                                        source: 'glass/model/DataModel.ion'
                                    },
                                    end: {
                                        line: 22,
                                        column: 18,
                                        fixed: true,
                                        source: 'glass/model/DataModel.ion'
                                    }
                                }
                            },
                            kind: 'init',
                            order: '4'
                        },
                        {
                            type: 'IfStatement',
                            test: {
                                type: 'BinaryExpression',
                                operator: '!==',
                                left: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'model',
                                        loc: {
                                            start: {
                                                line: 24,
                                                column: 11,
                                                fixed: true,
                                                source: 'glass/model/DataModel.ion'
                                            },
                                            end: {
                                                line: 24,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/model/DataModel.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'selectable',
                                        loc: {
                                            start: {
                                                line: 24,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/model/DataModel.ion'
                                            },
                                            end: {
                                                line: 24,
                                                column: 27,
                                                fixed: true,
                                                source: 'glass/model/DataModel.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 24,
                                            column: 11,
                                            fixed: true,
                                            source: 'glass/model/DataModel.ion'
                                        },
                                        end: {
                                            line: 24,
                                            column: 27,
                                            fixed: true,
                                            source: 'glass/model/DataModel.ion'
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: false
                                }
                            },
                            consequent: {
                                type: 'BlockStatement',
                                body: [
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'selectedRows',
                                            loc: {
                                                start: {
                                                    line: 25,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/model/DataModel.ion'
                                                },
                                                end: {
                                                    line: 25,
                                                    column: 24,
                                                    fixed: true,
                                                    source: 'glass/model/DataModel.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'ObjectExpression',
                                            objectType: {
                                                type: 'ArrayExpression',
                                                elements: []
                                            },
                                            properties: [{
                                                    type: 'ForOfStatement',
                                                    left: {
                                                        type: 'VariableDeclaration',
                                                        declarations: [{
                                                                type: 'VariableDeclarator',
                                                                id: {
                                                                    type: 'Identifier',
                                                                    name: 'row',
                                                                    loc: {
                                                                        start: {
                                                                            line: 25,
                                                                            column: 35,
                                                                            fixed: true,
                                                                            source: 'glass/model/DataModel.ion'
                                                                        },
                                                                        end: {
                                                                            line: 25,
                                                                            column: 38,
                                                                            fixed: true,
                                                                            source: 'glass/model/DataModel.ion'
                                                                        }
                                                                    }
                                                                },
                                                                init: null
                                                            }],
                                                        kind: 'let'
                                                    },
                                                    right: {
                                                        type: 'Identifier',
                                                        name: 'rows',
                                                        loc: {
                                                            start: {
                                                                line: 25,
                                                                column: 42,
                                                                fixed: true,
                                                                source: 'glass/model/DataModel.ion'
                                                            },
                                                            end: {
                                                                line: 25,
                                                                column: 46,
                                                                fixed: true,
                                                                source: 'glass/model/DataModel.ion'
                                                            }
                                                        }
                                                    },
                                                    body: {
                                                        type: 'BlockStatement',
                                                        body: [{
                                                                type: 'IfStatement',
                                                                test: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'row',
                                                                        loc: {
                                                                            start: {
                                                                                line: 25,
                                                                                column: 50,
                                                                                fixed: true,
                                                                                source: 'glass/model/DataModel.ion'
                                                                            },
                                                                            end: {
                                                                                line: 25,
                                                                                column: 53,
                                                                                fixed: true,
                                                                                source: 'glass/model/DataModel.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'selected',
                                                                        loc: {
                                                                            start: {
                                                                                line: 25,
                                                                                column: 54,
                                                                                fixed: true,
                                                                                source: 'glass/model/DataModel.ion'
                                                                            },
                                                                            end: {
                                                                                line: 25,
                                                                                column: 62,
                                                                                fixed: true,
                                                                                source: 'glass/model/DataModel.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 25,
                                                                            column: 50,
                                                                            fixed: true,
                                                                            source: 'glass/model/DataModel.ion'
                                                                        },
                                                                        end: {
                                                                            line: 25,
                                                                            column: 62,
                                                                            fixed: true,
                                                                            source: 'glass/model/DataModel.ion'
                                                                        }
                                                                    }
                                                                },
                                                                consequent: {
                                                                    type: 'BlockStatement',
                                                                    body: [{
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'Identifier',
                                                                                name: 'row',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 25,
                                                                                        column: 27,
                                                                                        fixed: true,
                                                                                        source: 'glass/model/DataModel.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 25,
                                                                                        column: 30,
                                                                                        fixed: true,
                                                                                        source: 'glass/model/DataModel.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        kind: 'init',
                                        order: '0'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'selectRow',
                                            loc: {
                                                start: {
                                                    line: 26,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/model/DataModel.ion'
                                                },
                                                end: {
                                                    line: 26,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'glass/model/DataModel.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Function',
                                            context: true,
                                            value: function (_context) {
                                                return function (idOrRecord, select) {
                                                    if (select == null)
                                                        select = true;
                                                    var rows = _context.get('rows');
                                                    for (var _i = 0; _i < rows.length; _i++) {
                                                        var row = rows[_i];
                                                        if (row.id === idOrRecord || row.record === idOrRecord) {
                                                            row.selected = select;
                                                        }
                                                    }
                                                };
                                            }
                                        },
                                        kind: 'init',
                                        order: '1'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'selectAllRows',
                                            loc: {
                                                start: {
                                                    line: 30,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/model/DataModel.ion'
                                                },
                                                end: {
                                                    line: 30,
                                                    column: 25,
                                                    fixed: true,
                                                    source: 'glass/model/DataModel.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Function',
                                            context: true,
                                            value: function (_context2) {
                                                return function (select) {
                                                    if (select == null)
                                                        select = true;
                                                    var rows = _context2.get('rows');
                                                    for (var _i2 = 0; _i2 < rows.length; _i2++) {
                                                        var row = rows[_i2];
                                                        row.selected = select;
                                                    }
                                                };
                                            }
                                        },
                                        kind: 'init',
                                        order: '2'
                                    }
                                ]
                            },
                            alternate: null,
                            order: '5'
                        },
                        {
                            type: 'IfStatement',
                            test: {
                                type: 'BinaryExpression',
                                operator: '!==',
                                left: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'model',
                                        loc: {
                                            start: {
                                                line: 34,
                                                column: 11,
                                                fixed: true,
                                                source: 'glass/model/DataModel.ion'
                                            },
                                            end: {
                                                line: 34,
                                                column: 16,
                                                fixed: true,
                                                source: 'glass/model/DataModel.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'editable',
                                        loc: {
                                            start: {
                                                line: 34,
                                                column: 17,
                                                fixed: true,
                                                source: 'glass/model/DataModel.ion'
                                            },
                                            end: {
                                                line: 34,
                                                column: 25,
                                                fixed: true,
                                                source: 'glass/model/DataModel.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 34,
                                            column: 11,
                                            fixed: true,
                                            source: 'glass/model/DataModel.ion'
                                        },
                                        end: {
                                            line: 34,
                                            column: 25,
                                            fixed: true,
                                            source: 'glass/model/DataModel.ion'
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: false
                                }
                            },
                            consequent: {
                                type: 'BlockStatement',
                                body: [{
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'insert',
                                            loc: {
                                                start: {
                                                    line: 35,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'glass/model/DataModel.ion'
                                                },
                                                end: {
                                                    line: 35,
                                                    column: 18,
                                                    fixed: true,
                                                    source: 'glass/model/DataModel.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Function',
                                            context: false,
                                            value: function (properties, index) {
                                                if (index == null)
                                                    index = sortedRecords.length;
                                                console.log('insert record');
                                            }
                                        },
                                        kind: 'init',
                                        order: '0'
                                    }]
                            },
                            alternate: null,
                            order: '6'
                        }
                    ]
                },
                order: '0'
            }],
        bound: false
    }, {
        this: this,
        model: model,
        _ref: _ref,
        Key: Key
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/model/DataModel',_glass_model_DataModel_);
    else
      _glass_model_DataModel_.call(this, module, exports, require);
  }
  else {
    _glass_model_DataModel_.call(this);
  }
}).call(this)
void (function(){var _glass_model_Entity_ = function(module,exports,require){'use strict';
var ion = require('ion');
var glass = require('../'), Key = require('../data/Key'), _ref;
_ref = require('../time');
var DateTime = _ref.DateTime;
var Entity = ion.defineClass({
        name: 'Entity',
        id: module.id,
        serializable: true,
        getNamespace: function () {
            var parentId = this.parentId = this.parentId != null ? this.parentId : this.id.split(/[\/\\]/g).slice(0, -1).join('/');
            return require(parentId);
        },
        getKey: function (key) {
            return key != null ? new Key(this.getNamespace(), key) : null;
        },
        additionalProperties: false,
        properties: {
            $: {
                access: { read: true },
                maxLength: 100,
                persistent: false
            },
            id: {
                get: function () {
                    var key = this.key;
                    return key != null ? Key.parse(key).id : void 0;
                },
                hasOwnValue: function (object) {
                    return (object != null ? object.key : void 0) != null;
                }
            },
            key: {
                access: {
                    read: true,
                    write: false
                },
                visible: true,
                editable: false,
                type: 'string',
                stamp: { type: 'key' }
            },
            getKey: function (string) {
                return new Key(this.constructor.getNamespace(), string != null ? string : this.key);
            },
            getInitials: function () {
                return ((this.name != null ? this.name : this.email) != null ? this.name != null ? this.name : this.email : this.id) != null ? ((this.name != null ? this.name : this.email) != null ? this.name != null ? this.name : this.email : this.id).split(' ').map(function (x) {
                    return x[0];
                }).join('').toUpperCase().slice(0, 2) : void 0;
            },
            stems: {
                serializable: false,
                index: false,
                type: 'array',
                maxLength: 20,
                items: {
                    type: 'string',
                    minLength: 3,
                    maxLength: 3
                },
                get: function () {
                    var phrases = this.getSearchPhrases();
                    var options = {};
                    var stemProperty = this.constructor.properties.stems;
                    options.maxWordCount = stemProperty.maxLength != null ? stemProperty.maxLength : 20;
                    options.minWordLength = stemProperty.items.minLength != null ? stemProperty.items.minLength : 1;
                    options.maxWordLength = stemProperty.items.maxLength != null ? stemProperty.items.maxLength : 3;
                    return glass.search.getWordsToIndex(phrases, options);
                }
            },
            getSearchPhrases: function () {
                var phrases = [];
                {
                    var _ref2 = this.constructor.properties;
                    for (var name in _ref2) {
                        var property = _ref2[name];
                        if (property.search) {
                            var value = this[name];
                            if (value != null) {
                                phrases.push([
                                    value,
                                    property.search.weight != null ? property.search.weight : 1
                                ]);
                            }
                        }
                    }
                }
                return phrases;
            },
            getSearchRank: function (text) {
                return glass.search.getSearchRank(this.getSearchPhrases(), text);
            },
            touched: {
                serializable: false,
                writable: true,
                enumerable: false,
                value: 0
            },
            touch: function () {
                this.touched++;
            },
            created: {
                editable: false,
                visible: true,
                index: true,
                type: 'string',
                format: 'date-time',
                stamp: { overwrite: false }
            },
            Created: {
                description: 'Returns created as a glass.time.DateTime object or null',
                get: function () {
                    return DateTime.parse(this.created);
                }
            },
            createdBy: {
                editable: false,
                type: 'string',
                format: 'key',
                visible: true,
                index: true,
                stamp: {
                    type: 'user',
                    overwrite: false
                },
                foreign: { type: 'User' }
            },
            updated: {
                editable: false,
                visible: true,
                index: true,
                type: 'string',
                format: 'date-time',
                stamp: { overwrite: true }
            },
            Updated: {
                description: 'Returns updated as a glass.time.DateTime object or null',
                get: function () {
                    return DateTime.parse(this.created);
                }
            },
            updatedBy: {
                editable: false,
                type: 'string',
                format: 'key',
                visible: true,
                index: true,
                maxLength: 100,
                stamp: {
                    type: 'user',
                    overwrite: true
                },
                foreign: { type: 'User' }
            }
        }
    });
module.exports = exports = Entity;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/model/Entity',_glass_model_Entity_);
    else
      _glass_model_Entity_.call(this, module, exports, require);
  }
  else {
    _glass_model_Entity_.call(this);
  }
}).call(this)
void (function(){var _glass_model_OperationManager_ = function(module,exports,require){'use strict';
var ion = require('ion');
module.exports = exports = function (_ref) {
    var model = _ref.model;
    var getObjectFromPath = function (path) {
        var object = model;
        for (var _i = 0; _i < path.length; _i++) {
            var step = path[_i];
            var next = object[step];
            if (!(next != null)) {
                throw new Error('Step ' + step + ' not found in object:', object);
            }
            object = next;
        }
        return object;
    };
    var apply = function (fromStack, toStack, property) {
        if (fromStack.length > 0) {
            var ops = fromStack.pop();
            for (var _i2 = 0; _i2 < ops.length; _i2++) {
                var op = ops[_i2];
                var object = getObjectFromPath(op.path);
                var change = ion.deserialize(ion.serialize(op[property]), model.namespace);
                ion.patch(object, change);
            }
            toStack.push(ops);
            ion.sync();
        }
    };
    return {
        undoStack: [],
        redoStack: [],
        do: function (ops) {
            this.undoStack.push(ops);
            this.redoStack.length = 0;
        },
        undo: function () {
            return apply(this.undoStack, this.redoStack, 'undo');
        },
        redo: function () {
            return apply(this.redoStack, this.undoStack, 'redo');
        },
        begin: function (path1, path2, path3) {
            var paths = Array.prototype.slice.call(arguments, 0);
            if (paths.length === 0) {
                paths.push(['server'], ['navigation'], ['local']);
            }
            var _ref2 = [];
            for (var _i3 = 0; _i3 < paths.length; _i3++) {
                var path = paths[_i3];
                _ref2.push(getObjectFromPath(path));
            }
            var objects = _ref2;
            var _ref3 = [];
            for (var _i4 = 0; _i4 < objects.length; _i4++) {
                var object = objects[_i4];
                _ref3.push(ion.deserialize(ion.serialize(object), model.namespace));
            }
            var befores = _ref3;
            ion.setImmediate(ion.bind(function () {
                var _ref4 = [];
                for (var _i5 = 0; _i5 < objects.length; _i5++) {
                    var object = objects[_i5];
                    _ref4.push(ion.deserialize(ion.serialize(object), model.namespace));
                }
                var afters = _ref4;
                var ops = [];
                for (var _i6 = 0; _i6 < objects.length; _i6++) {
                    var index = _i6;
                    var object = objects[_i6];
                    var path = paths[index];
                    var before = befores[index];
                    var after = afters[index];
                    var redo = ion.patch.diff(before, after);
                    var undo = ion.patch.diff(after, before);
                    if (undo != null && redo != null && JSON.stringify(undo) !== '{}') {
                        ops.push({
                            path: path,
                            undo: undo,
                            redo: redo
                        });
                    }
                }
                if (ops.length > 0) {
                    this.do(ops);
                }
            }, this));
        }
    };
};
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/model/OperationManager',_glass_model_OperationManager_);
    else
      _glass_model_OperationManager_.call(this, module, exports, require);
  }
  else {
    _glass_model_OperationManager_.call(this);
  }
}).call(this)
void (function(){var _glass_model_Toast_ = function(module,exports,require){'use strict';
var ion = require('ion');
module.exports = exports = {
    touched: 0,
    touch: function () {
        this.touched++;
    },
    toasts: {},
    namedToasts: {},
    toastCount: 0,
    byName: function (name) {
        return this.namedToasts[name];
    },
    byId: function (id) {
        return this.toasts[id];
    },
    closeAll: function () {
        {
            var _ref = this.toasts;
            for (var _i = 0; _i < _ref.length; _i++) {
                var properties = _ref[_i];
                properties.remove != null ? properties.remove() : void 0;
            }
        }
    },
    toast: function (properties) {
        properties.id = this.toastCount++;
        if (properties.name != null) {
            if (this.namedToasts[properties.name] != null) {
                this.namedToasts[properties.name].remove != null ? this.namedToasts[properties.name].remove() : void 0;
            }
            this.namedToasts[properties.name] = properties;
        }
        this.toasts[properties.id] = properties;
        properties.remove = function () {
            delete model.toast.toasts[properties.id];
            delete properties.remove;
            model.toast.touch();
            ion.sync();
        };
        if (properties.duration != null) {
            setTimeout(function () {
                properties.remove != null ? properties.remove() : void 0;
            }, properties.duration);
        }
        model.toast.touch();
        return properties;
    },
    busy: function (properties) {
        ion.patch.combine(properties, { spinner: true });
        this.toast(properties);
        properties.finish = function () {
            properties.done = true;
            model.toast.touch();
            setTimeout(function () {
                properties.remove != null ? properties.remove() : void 0;
            }, 1000);
        };
        ion.patch.watch(model.navigation, function () {
            return properties.remove != null ? properties.remove() : void 0;
        });
        return properties;
    },
    info: function (properties) {
        ion.patch.combine(properties, {
            icon: 'info',
            color: 'rgb(24,211,225)',
            duration: 30000
        });
        return this.toast(properties);
    },
    warn: function (properties) {
        ion.patch.combine(properties, {
            icon: 'warning',
            color: 'orange',
            duration: 30000
        });
        return this.toast(properties);
    },
    error: function (properties) {
        ion.patch.combine(properties, {
            icon: 'error',
            color: 'red',
            duration: 30000
        });
        return this.toast(properties);
    }
};
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/model/Toast',_glass_model_Toast_);
    else
      _glass_model_Toast_.call(this, module, exports, require);
  }
  else {
    _glass_model_Toast_.call(this);
  }
}).call(this)
void (function(){var _glass_model_User_ = function(module,exports,require){'use strict';
var ion = require('ion');
var User = ion.defineClass({
        name: 'User',
        id: module.id,
        persistent: true,
        description: 'Represents a Viewpath User and their settings',
        properties: {
            id: {
                index: true,
                type: 'string',
                maxLength: 200
            },
            email: {
                type: 'string',
                format: 'email',
                maxLength: 256,
                required: true,
                averageLength: 20,
                index: function () {
                    return this.email.toLowerCase();
                },
                unique: true
            },
            name: {
                type: 'string',
                required: true,
                minLength: 1,
                maxLength: 100,
                averageLength: 20,
                index: true
            },
            abbreviation: {
                get: function () {
                    return (this.name != null ? this.name : '').split(/\s/g).map(function (x) {
                        return x[0];
                    }).join('');
                }
            },
            passwordHash: {
                access: false,
                type: 'string',
                maxLength: 200
            },
            validated: {
                type: 'boolean',
                required: true,
                value: false
            },
            picture: {
                access: { read: true },
                type: 'string',
                format: 'url'
            },
            toString: function () {
                return this.name != null ? this.name : this.email;
            }
        }
    }, require('./Entity'));
module.exports = exports = User;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/model/User',_glass_model_User_);
    else
      _glass_model_User_.call(this, module, exports, require);
  }
  else {
    _glass_model_User_.call(this);
  }
}).call(this)
void (function(){var _glass_model_index_ = function(module,exports,require){Object.defineProperty(exports, 'ApplicationModel', {get:function(){ return require('./ApplicationModel') }, enumerable: true}) 
Object.defineProperty(exports, 'Authentication', {get:function(){ return require('./Authentication') }, enumerable: true}) 
Object.defineProperty(exports, 'Channel', {get:function(){ return require('./Channel') }, enumerable: true}) 
Object.defineProperty(exports, 'DataModel', {get:function(){ return require('./DataModel') }, enumerable: true}) 
Object.defineProperty(exports, 'Entity', {get:function(){ return require('./Entity') }, enumerable: true}) 
Object.defineProperty(exports, 'OperationManager', {get:function(){ return require('./OperationManager') }, enumerable: true}) 
Object.defineProperty(exports, 'Toast', {get:function(){ return require('./Toast') }, enumerable: true}) 
Object.defineProperty(exports, 'User', {get:function(){ return require('./User') }, enumerable: true}) 
Object.freeze(exports)
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/model/index',_glass_model_index_);
    else
      _glass_model_index_.call(this, module, exports, require);
  }
  else {
    _glass_model_index_.call(this);
  }
}).call(this)
void (function(){var _glass_prettyprint_ = function(module,exports,require){'use strict';
function ionstringify(obj, indentString, maxinline) {
    if (indentString == null)
        indentString = '  ';
    if (maxinline == null)
        maxinline = 80;
    var parts = [];
    var indentLevel = 0;
    var part = function (str) {
        return parts.push(str);
    };
    var outdent = function () {
        return indentLevel++;
    };
    var indent = function () {
        return indentLevel--;
    };
    var dent = function () {
        for (var i = 0; i < indentLevel; i++) {
            part(indentString);
        }
    };
    var separator = function (str) {
        var i = 0;
        return function () {
            if (i++ > 0) {
                part(str);
            }
        };
    };
    var internal = function (obj) {
        if (typeof obj !== 'object' || obj === null) {
            part(JSON.stringify(obj));
        } else {
            var inline = JSON.stringify(obj).length < maxinline;
            var isArray = Array.isArray(obj);
            var separate = separator(inline ? ', ' : ',\n');
            if (inline) {
                part(isArray ? '[ ' : '{ ');
            } else {
                part(isArray ? '[]' : '{}');
                part('\n');
                outdent();
            }
            for (var key in obj) {
                var value = obj[key];
                separate();
                if (!inline) {
                    dent();
                }
                if (!isArray) {
                    part(key + ': ');
                }
                internal(value);
            }
            if (inline) {
                part(isArray ? ' ]' : ' }');
            } else {
                indent();
            }
        }
    };
    internal(obj);
    return parts.join('');
}
var print = function () {
    var parts = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        var obj = arguments[_i];
        if (typeof obj === 'object' && obj !== null) {
            parts.push(ionstringify(obj));
        } else {
            parts.push(obj);
        }
    }
    console.log(parts.join(' '));
};
module.exports = exports = {
    ionstringify: ionstringify,
    print: print
};
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/prettyprint',_glass_prettyprint_);
    else
      _glass_prettyprint_.call(this, module, exports, require);
  }
  else {
    _glass_prettyprint_.call(this);
  }
}).call(this)
void (function(){var _glass_root_ = function(module,exports,require){"use strict";
//# sourceMappingURL=root.js.map
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/root',_glass_root_);
    else
      _glass_root_.call(this, module, exports, require);
  }
  else {
    _glass_root_.call(this);
  }
}).call(this)
void (function(){var _glass_search_commonWords_ = function(module,exports,require){'use strict';
module.exports = exports = [
    'the',
    'of',
    'and',
    'to',
    'a',
    'in',
    'for',
    'is',
    'on',
    'that',
    'by',
    'this',
    'with',
    'i',
    'you',
    'it',
    'not',
    'or',
    'be',
    'are',
    'from',
    'at',
    'as',
    'your',
    'all',
    'have',
    'new',
    'more',
    'an',
    'was',
    'we',
    'will',
    'home',
    'can',
    'us',
    'about',
    'if',
    'page',
    'my',
    'has',
    'search',
    'free',
    'but',
    'our',
    'one',
    'other',
    'do',
    'no',
    'information',
    'time',
    'they',
    'site',
    'he',
    'up',
    'may',
    'what',
    'which',
    'their',
    'news',
    'out',
    'use',
    'any',
    'there',
    'see',
    'only',
    'so',
    'his',
    'when',
    'contact',
    'here',
    'business',
    'who',
    'web',
    'also',
    'now',
    'help',
    'get',
    'pm',
    'view',
    'online',
    'c',
    'e',
    'first',
    'am',
    'been',
    'would',
    'how',
    'were',
    'me',
    's',
    'services',
    'some',
    'these',
    'click',
    'its',
    'like',
    'service',
    'x',
    'than',
    'find',
    'price',
    'date',
    'back',
    'top',
    'people',
    'had',
    'list',
    'name',
    'just',
    'over',
    'state',
    'year',
    'day',
    'into',
    'email',
    'two',
    'health',
    'n',
    'world',
    're',
    'next',
    'used',
    'go',
    'b',
    'work',
    'last',
    'most',
    'products',
    'music',
    'buy',
    'data',
    'make',
    'them',
    'should',
    'product',
    'system',
    'post',
    'her',
    'city',
    't',
    'add',
    'policy',
    'number',
    'such',
    'please',
    'available',
    'copyright',
    'support',
    'message',
    'after',
    'best',
    'software',
    'then',
    'jan',
    'good',
    'video',
    'well',
    'd',
    'where',
    'info',
    'rights',
    'public',
    'books',
    'high',
    'school',
    'through',
    'm',
    'each',
    'links',
    'she',
    'review',
    'years',
    'order',
    'very',
    'privacy',
    'book',
    'items',
    'company',
    'r',
    'read',
    'group',
    'sex',
    'need',
    'many',
    'user',
    'said',
    'de',
    'does',
    'set',
    'under',
    'general',
    'research',
    'university',
    'january',
    'mail',
    'full',
    'map',
    'reviews',
    'program',
    'life',
    'know',
    'games',
    'way',
    'days',
    'management',
    'p',
    'part',
    'could',
    'great',
    'united',
    'hotel',
    'real',
    'f',
    'item',
    'international',
    'center',
    'ebay',
    'must',
    'store',
    'travel',
    'comments',
    'made',
    'development',
    'report',
    'off',
    'member',
    'details',
    'line',
    'terms',
    'before',
    'hotels',
    'did',
    'send',
    'right',
    'type',
    'because',
    'local',
    'those',
    'using',
    'results',
    'office',
    'education',
    'national',
    'car',
    'design',
    'take',
    'posted',
    'internet',
    'address',
    'community',
    'within',
    'states',
    'area',
    'want',
    'phone',
    'dvd',
    'shipping',
    'reserved',
    'subject',
    'between',
    'forum',
    'family',
    'l',
    'long',
    'based',
    'w',
    'code',
    'show',
    'o',
    'even',
    'black',
    'check',
    'special',
    'prices',
    'website',
    'index',
    'being',
    'women',
    'much',
    'sign',
    'file',
    'link',
    'open',
    'today',
    'technology',
    'south',
    'case',
    'project',
    'same',
    'pages',
    'uk',
    'version',
    'section',
    'own',
    'found',
    'sports',
    'house',
    'related',
    'security',
    'both'
];
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/search/commonWords',_glass_search_commonWords_);
    else
      _glass_search_commonWords_.call(this, module, exports, require);
  }
  else {
    _glass_search_commonWords_.call(this);
  }
}).call(this)
void (function(){var _glass_search_index_ = function(module,exports,require){'use strict';
var commonWords = require('./commonWords');
var lookup = {};
for (var _i = 0; _i < commonWords.length; _i++) {
    var index = _i;
    var word = commonWords[_i];
    lookup[word] = index;
}
var frequencyMinimum = 50;
var defaultMaxWordCount = 20;
var defaultMaxWordLength = 3;
var defaultMinWordLength = 3;
var getFrequency = exports.getFrequency = function (word) {
        return lookup[word] != null ? lookup[word] : 100000;
    }, getAllWords = exports.getAllWords = function (phrase, minWordLength) {
        if (minWordLength == null)
            minWordLength = 2;
        if (!(phrase != null)) {
            return [];
        }
        if (typeof phrase !== 'string') {
            console.log('phrase is not a string: ', phrase);
        }
        var words = {};
        {
            var _ref = phrase.toLowerCase().split(getSearchRegExp(''));
            for (var _i2 = 0; _i2 < _ref.length; _i2++) {
                var word = _ref[_i2];
                var trimmed = word.trim();
                if (trimmed.length >= minWordLength) {
                    words[trimmed] = true;
                }
            }
        }
        return Object.keys(words);
    }, getWordsToIndex = exports.getWordsToIndex = function (phrasesAndWeights, options) {
        var indexAll = (options != null ? options.all : void 0) != null ? options.all : false;
        var maxWordCount = (options != null ? options.maxWordCount : void 0) != null ? options.maxWordCount : defaultMaxWordCount;
        var maxWordLength = (options != null ? options.maxWordLength : void 0) != null ? options.maxWordLength : defaultMaxWordLength;
        var minWordLength = (options != null ? options.minWordLength : void 0) != null ? options.minWordLength : defaultMinWordLength;
        var wordFrequencyLookup = {};
        for (var _i3 = 0; _i3 < phrasesAndWeights.length; _i3++) {
            var _ref2 = phrasesAndWeights[_i3];
            var phrase = _ref2[0];
            var weight = _ref2[1];
            var words = getAllWords(phrase);
            for (var _i4 = 0; _i4 < words.length; _i4++) {
                var word = words[_i4];
                var frequency = (indexAll ? 1 : getFrequency(word)) * weight;
                if (frequency >= frequencyMinimum) {
                    wordFrequencyLookup[word] = Math.max(wordFrequencyLookup[word] != null ? wordFrequencyLookup[word] : 0, frequency);
                }
            }
        }
        var wordsWithFrequency = [];
        for (var word in wordFrequencyLookup) {
            var frequency = wordFrequencyLookup[word];
            wordsWithFrequency.push({
                word: word,
                frequency: frequency
            });
        }
        wordsWithFrequency.sort(function (a, b) {
            return Math.sign(b.frequency - a.frequency);
        });
        var sortedWords = [];
        for (var _i5 = 0; _i5 < wordsWithFrequency.length; _i5++) {
            var _ref3 = wordsWithFrequency[_i5];
            var word = _ref3.word;
            sortedWords.push(word);
        }
        var finalWords = {};
        for (var length = maxWordLength; length >= minWordLength; length--) {
            for (var _i6 = 0; _i6 < sortedWords.length; _i6++) {
                var word = sortedWords[_i6];
                var trimmedWord = word.substring(0, length);
                if (trimmedWord.length >= minWordLength) {
                    finalWords[trimmedWord] = true;
                }
            }
        }
        return Object.keys(finalWords).slice(0, maxWordCount);
    }, getWordsToIndexFromName = exports.getWordsToIndexFromName = function (name, options) {
        var maxWordCount = (options != null ? options.maxWordCount : void 0) != null ? options.maxWordCount : defaultMaxWordCount;
        var maxWordLength = (options != null ? options.maxWordLength : void 0) != null ? options.maxWordLength : defaultMaxWordLength;
        var allWords = getAllWords(name, 0);
        var words = {};
        for (var i = maxWordLength; i >= 1; i--) {
            for (var _i7 = 0; _i7 < allWords.length; _i7++) {
                var word = allWords[_i7];
                words[word.substring(0, i)] = true;
            }
        }
        return Object.keys(words).slice(0, maxWordCount);
    }, getSearchRegExp = exports.getSearchRegExp = function (match) {
        return new RegExp('(^|\\s|\\d|[^\\.\\w@])' + match, 'gi');
    }, getSearchRank = exports.getSearchRank = function (phrases, match) {
        var best = -1;
        if ((match != null ? match.length : void 0) === 0) {
            return 0;
        }
        var regex = getSearchRegExp(match);
        for (var _i8 = 0; _i8 < phrases.length; _i8++) {
            var _ref4 = phrases[_i8];
            var text = _ref4[0];
            var weight = _ref4[1];
            var index = text.search(regex);
            if (index >= 0) {
                best = Math.max(best, weight);
            }
        }
        return best;
    }, test = exports.test = function () {
        if (!(getAllWords('39 does this work or does this not').join(' ') === 'does this work or not'))
            throw new Error('Assertion Failed: (getAllWords("39 does this work or does this not").join(\' \') is \'does this work or not\')');
        if (!('mar,fle,sup,lit,lam,whi' === getWordsToIndex([
                [
                    'Mary had a 43 little lamb, little lamb, little lamb, Mary had a little lamb it\'s fleece was white as snow',
                    1
                ],
                [
                    'Marines Fledgling Superman',
                    20
                ]
            ], { maxWordCount: 6 }).join(',')))
            throw new Error('Assertion Failed: (\'mar,fle,sup,lit,lam,whi\' is getWordsToIndex([["Mary had a 43 little lamb, little lamb, little lamb, Mary had a little lamb it\'s fleece was white as snow",1], ["Marines Fledgling Superman",20]],{maxWordCount:6}).join(\',\'))');
    };
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/search/index',_glass_search_index_);
    else
      _glass_search_index_.call(this, module, exports, require);
  }
  else {
    _glass_search_index_.call(this);
  }
}).call(this)
void (function(){var _glass_sjcl_ = function(module,exports,require){"use strict";function q(a){throw a;}var t=void 0,u=!1;var sjcl={cipher:{},hash:{},keyexchange:{},mode:{},misc:{},codec:{},exception:{corrupt:function(a){this.toString=function(){return"CORRUPT: "+this.message};this.message=a},invalid:function(a){this.toString=function(){return"INVALID: "+this.message};this.message=a},bug:function(a){this.toString=function(){return"BUG: "+this.message};this.message=a},notReady:function(a){this.toString=function(){return"NOT READY: "+this.message};this.message=a}}};
"undefined"!==typeof module&&module.exports&&(module.exports=sjcl);
sjcl.cipher.aes=function(a){this.k[0][0][0]||this.D();var b,c,d,e,f=this.k[0][4],g=this.k[1];b=a.length;var h=1;4!==b&&(6!==b&&8!==b)&&q(new sjcl.exception.invalid("invalid aes key size"));this.b=[d=a.slice(0),e=[]];for(a=b;a<4*b+28;a++){c=d[a-1];if(0===a%b||8===b&&4===a%b)c=f[c>>>24]<<24^f[c>>16&255]<<16^f[c>>8&255]<<8^f[c&255],0===a%b&&(c=c<<8^c>>>24^h<<24,h=h<<1^283*(h>>7));d[a]=d[a-b]^c}for(b=0;a;b++,a--)c=d[b&3?a:a-4],e[b]=4>=a||4>b?c:g[0][f[c>>>24]]^g[1][f[c>>16&255]]^g[2][f[c>>8&255]]^g[3][f[c&
255]]};
sjcl.cipher.aes.prototype={encrypt:function(a){return y(this,a,0)},decrypt:function(a){return y(this,a,1)},k:[[[],[],[],[],[]],[[],[],[],[],[]]],D:function(){var a=this.k[0],b=this.k[1],c=a[4],d=b[4],e,f,g,h=[],l=[],k,n,m,p;for(e=0;0x100>e;e++)l[(h[e]=e<<1^283*(e>>7))^e]=e;for(f=g=0;!c[f];f^=k||1,g=l[g]||1){m=g^g<<1^g<<2^g<<3^g<<4;m=m>>8^m&255^99;c[f]=m;d[m]=f;n=h[e=h[k=h[f]]];p=0x1010101*n^0x10001*e^0x101*k^0x1010100*f;n=0x101*h[m]^0x1010100*m;for(e=0;4>e;e++)a[e][f]=n=n<<24^n>>>8,b[e][m]=p=p<<24^p>>>8}for(e=
0;5>e;e++)a[e]=a[e].slice(0),b[e]=b[e].slice(0)}};
function y(a,b,c){4!==b.length&&q(new sjcl.exception.invalid("invalid aes block size"));var d=a.b[c],e=b[0]^d[0],f=b[c?3:1]^d[1],g=b[2]^d[2];b=b[c?1:3]^d[3];var h,l,k,n=d.length/4-2,m,p=4,s=[0,0,0,0];h=a.k[c];a=h[0];var r=h[1],v=h[2],w=h[3],x=h[4];for(m=0;m<n;m++)h=a[e>>>24]^r[f>>16&255]^v[g>>8&255]^w[b&255]^d[p],l=a[f>>>24]^r[g>>16&255]^v[b>>8&255]^w[e&255]^d[p+1],k=a[g>>>24]^r[b>>16&255]^v[e>>8&255]^w[f&255]^d[p+2],b=a[b>>>24]^r[e>>16&255]^v[f>>8&255]^w[g&255]^d[p+3],p+=4,e=h,f=l,g=k;for(m=0;4>
m;m++)s[c?3&-m:m]=x[e>>>24]<<24^x[f>>16&255]<<16^x[g>>8&255]<<8^x[b&255]^d[p++],h=e,e=f,f=g,g=b,b=h;return s}
sjcl.bitArray={bitSlice:function(a,b,c){a=sjcl.bitArray.P(a.slice(b/32),32-(b&31)).slice(1);return c===t?a:sjcl.bitArray.clamp(a,c-b)},extract:function(a,b,c){var d=Math.floor(-b-c&31);return((b+c-1^b)&-32?a[b/32|0]<<32-d^a[b/32+1|0]>>>d:a[b/32|0]>>>d)&(1<<c)-1},concat:function(a,b){if(0===a.length||0===b.length)return a.concat(b);var c=a[a.length-1],d=sjcl.bitArray.getPartial(c);return 32===d?a.concat(b):sjcl.bitArray.P(b,d,c|0,a.slice(0,a.length-1))},bitLength:function(a){var b=a.length;return 0===
b?0:32*(b-1)+sjcl.bitArray.getPartial(a[b-1])},clamp:function(a,b){if(32*a.length<b)return a;a=a.slice(0,Math.ceil(b/32));var c=a.length;b&=31;0<c&&b&&(a[c-1]=sjcl.bitArray.partial(b,a[c-1]&2147483648>>b-1,1));return a},partial:function(a,b,c){return 32===a?b:(c?b|0:b<<32-a)+0x10000000000*a},getPartial:function(a){return Math.round(a/0x10000000000)||32},equal:function(a,b){if(sjcl.bitArray.bitLength(a)!==sjcl.bitArray.bitLength(b))return u;var c=0,d;for(d=0;d<a.length;d++)c|=a[d]^b[d];return 0===
c},P:function(a,b,c,d){var e;e=0;for(d===t&&(d=[]);32<=b;b-=32)d.push(c),c=0;if(0===b)return d.concat(a);for(e=0;e<a.length;e++)d.push(c|a[e]>>>b),c=a[e]<<32-b;e=a.length?a[a.length-1]:0;a=sjcl.bitArray.getPartial(e);d.push(sjcl.bitArray.partial(b+a&31,32<b+a?c:d.pop(),1));return d},l:function(a,b){return[a[0]^b[0],a[1]^b[1],a[2]^b[2],a[3]^b[3]]}};
sjcl.codec.utf8String={fromBits:function(a){var b="",c=sjcl.bitArray.bitLength(a),d,e;for(d=0;d<c/8;d++)0===(d&3)&&(e=a[d/4]),b+=String.fromCharCode(e>>>24),e<<=8;return decodeURIComponent(escape(b))},toBits:function(a){a=unescape(encodeURIComponent(a));var b=[],c,d=0;for(c=0;c<a.length;c++)d=d<<8|a.charCodeAt(c),3===(c&3)&&(b.push(d),d=0);c&3&&b.push(sjcl.bitArray.partial(8*(c&3),d));return b}};
sjcl.codec.hex={fromBits:function(a){var b="",c;for(c=0;c<a.length;c++)b+=((a[c]|0)+0xf00000000000).toString(16).substr(4);return b.substr(0,sjcl.bitArray.bitLength(a)/4)},toBits:function(a){var b,c=[],d;a=a.replace(/\s|0x/g,"");d=a.length;a+="00000000";for(b=0;b<a.length;b+=8)c.push(parseInt(a.substr(b,8),16)^0);return sjcl.bitArray.clamp(c,4*d)}};
sjcl.codec.base64={J:"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",fromBits:function(a,b,c){var d="",e=0,f=sjcl.codec.base64.J,g=0,h=sjcl.bitArray.bitLength(a);c&&(f=f.substr(0,62)+"-_");for(c=0;6*d.length<h;)d+=f.charAt((g^a[c]>>>e)>>>26),6>e?(g=a[c]<<6-e,e+=26,c++):(g<<=6,e-=6);for(;d.length&3&&!b;)d+="=";return d},toBits:function(a,b){a=a.replace(/\s|=/g,"");var c=[],d,e=0,f=sjcl.codec.base64.J,g=0,h;b&&(f=f.substr(0,62)+"-_");for(d=0;d<a.length;d++)h=f.indexOf(a.charAt(d)),
0>h&&q(new sjcl.exception.invalid("this isn't base64!")),26<e?(e-=26,c.push(g^h>>>e),g=h<<32-e):(e+=6,g^=h<<32-e);e&56&&c.push(sjcl.bitArray.partial(e&56,g,1));return c}};sjcl.codec.base64url={fromBits:function(a){return sjcl.codec.base64.fromBits(a,1,1)},toBits:function(a){return sjcl.codec.base64.toBits(a,1)}};sjcl.hash.sha256=function(a){this.b[0]||this.D();a?(this.r=a.r.slice(0),this.o=a.o.slice(0),this.h=a.h):this.reset()};sjcl.hash.sha256.hash=function(a){return(new sjcl.hash.sha256).update(a).finalize()};
sjcl.hash.sha256.prototype={blockSize:512,reset:function(){this.r=this.N.slice(0);this.o=[];this.h=0;return this},update:function(a){"string"===typeof a&&(a=sjcl.codec.utf8String.toBits(a));var b,c=this.o=sjcl.bitArray.concat(this.o,a);b=this.h;a=this.h=b+sjcl.bitArray.bitLength(a);for(b=512+b&-512;b<=a;b+=512)z(this,c.splice(0,16));return this},finalize:function(){var a,b=this.o,c=this.r,b=sjcl.bitArray.concat(b,[sjcl.bitArray.partial(1,1)]);for(a=b.length+2;a&15;a++)b.push(0);b.push(Math.floor(this.h/
4294967296));for(b.push(this.h|0);b.length;)z(this,b.splice(0,16));this.reset();return c},N:[],b:[],D:function(){function a(a){return 0x100000000*(a-Math.floor(a))|0}var b=0,c=2,d;a:for(;64>b;c++){for(d=2;d*d<=c;d++)if(0===c%d)continue a;8>b&&(this.N[b]=a(Math.pow(c,0.5)));this.b[b]=a(Math.pow(c,1/3));b++}}};
function z(a,b){var c,d,e,f=b.slice(0),g=a.r,h=a.b,l=g[0],k=g[1],n=g[2],m=g[3],p=g[4],s=g[5],r=g[6],v=g[7];for(c=0;64>c;c++)16>c?d=f[c]:(d=f[c+1&15],e=f[c+14&15],d=f[c&15]=(d>>>7^d>>>18^d>>>3^d<<25^d<<14)+(e>>>17^e>>>19^e>>>10^e<<15^e<<13)+f[c&15]+f[c+9&15]|0),d=d+v+(p>>>6^p>>>11^p>>>25^p<<26^p<<21^p<<7)+(r^p&(s^r))+h[c],v=r,r=s,s=p,p=m+d|0,m=n,n=k,k=l,l=d+(k&n^m&(k^n))+(k>>>2^k>>>13^k>>>22^k<<30^k<<19^k<<10)|0;g[0]=g[0]+l|0;g[1]=g[1]+k|0;g[2]=g[2]+n|0;g[3]=g[3]+m|0;g[4]=g[4]+p|0;g[5]=g[5]+s|0;g[6]=
g[6]+r|0;g[7]=g[7]+v|0}
sjcl.mode.ccm={name:"ccm",encrypt:function(a,b,c,d,e){var f,g=b.slice(0),h=sjcl.bitArray,l=h.bitLength(c)/8,k=h.bitLength(g)/8;e=e||64;d=d||[];7>l&&q(new sjcl.exception.invalid("ccm: iv must be at least 7 bytes"));for(f=2;4>f&&k>>>8*f;f++);f<15-l&&(f=15-l);c=h.clamp(c,8*(15-f));b=sjcl.mode.ccm.L(a,b,c,d,e,f);g=sjcl.mode.ccm.p(a,g,c,b,e,f);return h.concat(g.data,g.tag)},decrypt:function(a,b,c,d,e){e=e||64;d=d||[];var f=sjcl.bitArray,g=f.bitLength(c)/8,h=f.bitLength(b),l=f.clamp(b,h-e),k=f.bitSlice(b,
h-e),h=(h-e)/8;7>g&&q(new sjcl.exception.invalid("ccm: iv must be at least 7 bytes"));for(b=2;4>b&&h>>>8*b;b++);b<15-g&&(b=15-g);c=f.clamp(c,8*(15-b));l=sjcl.mode.ccm.p(a,l,c,k,e,b);a=sjcl.mode.ccm.L(a,l.data,c,d,e,b);f.equal(l.tag,a)||q(new sjcl.exception.corrupt("ccm: tag doesn't match"));return l.data},L:function(a,b,c,d,e,f){var g=[],h=sjcl.bitArray,l=h.l;e/=8;(e%2||4>e||16<e)&&q(new sjcl.exception.invalid("ccm: invalid tag length"));(0xffffffff<d.length||0xffffffff<b.length)&&q(new sjcl.exception.bug("ccm: can't deal with 4GiB or more data"));
f=[h.partial(8,(d.length?64:0)|e-2<<2|f-1)];f=h.concat(f,c);f[3]|=h.bitLength(b)/8;f=a.encrypt(f);if(d.length){c=h.bitLength(d)/8;65279>=c?g=[h.partial(16,c)]:0xffffffff>=c&&(g=h.concat([h.partial(16,65534)],[c]));g=h.concat(g,d);for(d=0;d<g.length;d+=4)f=a.encrypt(l(f,g.slice(d,d+4).concat([0,0,0])))}for(d=0;d<b.length;d+=4)f=a.encrypt(l(f,b.slice(d,d+4).concat([0,0,0])));return h.clamp(f,8*e)},p:function(a,b,c,d,e,f){var g,h=sjcl.bitArray;g=h.l;var l=b.length,k=h.bitLength(b);c=h.concat([h.partial(8,
f-1)],c).concat([0,0,0]).slice(0,4);d=h.bitSlice(g(d,a.encrypt(c)),0,e);if(!l)return{tag:d,data:[]};for(g=0;g<l;g+=4)c[3]++,e=a.encrypt(c),b[g]^=e[0],b[g+1]^=e[1],b[g+2]^=e[2],b[g+3]^=e[3];return{tag:d,data:h.clamp(b,k)}}};
sjcl.mode.ocb2={name:"ocb2",encrypt:function(a,b,c,d,e,f){128!==sjcl.bitArray.bitLength(c)&&q(new sjcl.exception.invalid("ocb iv must be 128 bits"));var g,h=sjcl.mode.ocb2.H,l=sjcl.bitArray,k=l.l,n=[0,0,0,0];c=h(a.encrypt(c));var m,p=[];d=d||[];e=e||64;for(g=0;g+4<b.length;g+=4)m=b.slice(g,g+4),n=k(n,m),p=p.concat(k(c,a.encrypt(k(c,m)))),c=h(c);m=b.slice(g);b=l.bitLength(m);g=a.encrypt(k(c,[0,0,0,b]));m=l.clamp(k(m.concat([0,0,0]),g),b);n=k(n,k(m.concat([0,0,0]),g));n=a.encrypt(k(n,k(c,h(c))));d.length&&
(n=k(n,f?d:sjcl.mode.ocb2.pmac(a,d)));return p.concat(l.concat(m,l.clamp(n,e)))},decrypt:function(a,b,c,d,e,f){128!==sjcl.bitArray.bitLength(c)&&q(new sjcl.exception.invalid("ocb iv must be 128 bits"));e=e||64;var g=sjcl.mode.ocb2.H,h=sjcl.bitArray,l=h.l,k=[0,0,0,0],n=g(a.encrypt(c)),m,p,s=sjcl.bitArray.bitLength(b)-e,r=[];d=d||[];for(c=0;c+4<s/32;c+=4)m=l(n,a.decrypt(l(n,b.slice(c,c+4)))),k=l(k,m),r=r.concat(m),n=g(n);p=s-32*c;m=a.encrypt(l(n,[0,0,0,p]));m=l(m,h.clamp(b.slice(c),p).concat([0,0,0]));
k=l(k,m);k=a.encrypt(l(k,l(n,g(n))));d.length&&(k=l(k,f?d:sjcl.mode.ocb2.pmac(a,d)));h.equal(h.clamp(k,e),h.bitSlice(b,s))||q(new sjcl.exception.corrupt("ocb: tag doesn't match"));return r.concat(h.clamp(m,p))},pmac:function(a,b){var c,d=sjcl.mode.ocb2.H,e=sjcl.bitArray,f=e.l,g=[0,0,0,0],h=a.encrypt([0,0,0,0]),h=f(h,d(d(h)));for(c=0;c+4<b.length;c+=4)h=d(h),g=f(g,a.encrypt(f(h,b.slice(c,c+4))));c=b.slice(c);128>e.bitLength(c)&&(h=f(h,d(h)),c=e.concat(c,[-2147483648,0,0,0]));g=f(g,c);return a.encrypt(f(d(f(h,
d(h))),g))},H:function(a){return[a[0]<<1^a[1]>>>31,a[1]<<1^a[2]>>>31,a[2]<<1^a[3]>>>31,a[3]<<1^135*(a[0]>>>31)]}};
sjcl.mode.gcm={name:"gcm",encrypt:function(a,b,c,d,e){var f=b.slice(0);b=sjcl.bitArray;d=d||[];a=sjcl.mode.gcm.p(!0,a,f,d,c,e||128);return b.concat(a.data,a.tag)},decrypt:function(a,b,c,d,e){var f=b.slice(0),g=sjcl.bitArray,h=g.bitLength(f);e=e||128;d=d||[];e<=h?(b=g.bitSlice(f,h-e),f=g.bitSlice(f,0,h-e)):(b=f,f=[]);a=sjcl.mode.gcm.p(u,a,f,d,c,e);g.equal(a.tag,b)||q(new sjcl.exception.corrupt("gcm: tag doesn't match"));return a.data},Z:function(a,b){var c,d,e,f,g,h=sjcl.bitArray.l;e=[0,0,0,0];f=b.slice(0);
for(c=0;128>c;c++){(d=0!==(a[Math.floor(c/32)]&1<<31-c%32))&&(e=h(e,f));g=0!==(f[3]&1);for(d=3;0<d;d--)f[d]=f[d]>>>1|(f[d-1]&1)<<31;f[0]>>>=1;g&&(f[0]^=-0x1f000000)}return e},g:function(a,b,c){var d,e=c.length;b=b.slice(0);for(d=0;d<e;d+=4)b[0]^=0xffffffff&c[d],b[1]^=0xffffffff&c[d+1],b[2]^=0xffffffff&c[d+2],b[3]^=0xffffffff&c[d+3],b=sjcl.mode.gcm.Z(b,a);return b},p:function(a,b,c,d,e,f){var g,h,l,k,n,m,p,s,r=sjcl.bitArray;m=c.length;p=r.bitLength(c);s=r.bitLength(d);h=r.bitLength(e);g=b.encrypt([0,
0,0,0]);96===h?(e=e.slice(0),e=r.concat(e,[1])):(e=sjcl.mode.gcm.g(g,[0,0,0,0],e),e=sjcl.mode.gcm.g(g,e,[0,0,Math.floor(h/0x100000000),h&0xffffffff]));h=sjcl.mode.gcm.g(g,[0,0,0,0],d);n=e.slice(0);d=h.slice(0);a||(d=sjcl.mode.gcm.g(g,h,c));for(k=0;k<m;k+=4)n[3]++,l=b.encrypt(n),c[k]^=l[0],c[k+1]^=l[1],c[k+2]^=l[2],c[k+3]^=l[3];c=r.clamp(c,p);a&&(d=sjcl.mode.gcm.g(g,h,c));a=[Math.floor(s/0x100000000),s&0xffffffff,Math.floor(p/0x100000000),p&0xffffffff];d=sjcl.mode.gcm.g(g,d,a);l=b.encrypt(e);d[0]^=l[0];
d[1]^=l[1];d[2]^=l[2];d[3]^=l[3];return{tag:r.bitSlice(d,0,f),data:c}}};sjcl.misc.hmac=function(a,b){this.M=b=b||sjcl.hash.sha256;var c=[[],[]],d,e=b.prototype.blockSize/32;this.n=[new b,new b];a.length>e&&(a=b.hash(a));for(d=0;d<e;d++)c[0][d]=a[d]^909522486,c[1][d]=a[d]^1549556828;this.n[0].update(c[0]);this.n[1].update(c[1]);this.G=new b(this.n[0])};
sjcl.misc.hmac.prototype.encrypt=sjcl.misc.hmac.prototype.mac=function(a){this.Q&&q(new sjcl.exception.invalid("encrypt on already updated hmac called!"));this.update(a);return this.digest(a)};sjcl.misc.hmac.prototype.reset=function(){this.G=new this.M(this.n[0]);this.Q=u};sjcl.misc.hmac.prototype.update=function(a){this.Q=!0;this.G.update(a)};sjcl.misc.hmac.prototype.digest=function(){var a=this.G.finalize(),a=(new this.M(this.n[1])).update(a).finalize();this.reset();return a};
sjcl.misc.pbkdf2=function(a,b,c,d,e){c=c||1E3;(0>d||0>c)&&q(sjcl.exception.invalid("invalid params to pbkdf2"));"string"===typeof a&&(a=sjcl.codec.utf8String.toBits(a));"string"===typeof b&&(b=sjcl.codec.utf8String.toBits(b));e=e||sjcl.misc.hmac;a=new e(a);var f,g,h,l,k=[],n=sjcl.bitArray;for(l=1;32*k.length<(d||1);l++){e=f=a.encrypt(n.concat(b,[l]));for(g=1;g<c;g++){f=a.encrypt(f);for(h=0;h<f.length;h++)e[h]^=f[h]}k=k.concat(e)}d&&(k=n.clamp(k,d));return k};
sjcl.prng=function(a){this.c=[new sjcl.hash.sha256];this.i=[0];this.F=0;this.s={};this.C=0;this.K={};this.O=this.d=this.j=this.W=0;this.b=[0,0,0,0,0,0,0,0];this.f=[0,0,0,0];this.A=t;this.B=a;this.q=u;this.w={progress:{},seeded:{}};this.m=this.V=0;this.t=1;this.u=2;this.S=0x10000;this.I=[0,48,64,96,128,192,0x100,384,512,768,1024];this.T=3E4;this.R=80};
sjcl.prng.prototype={randomWords:function(a,b){var c=[],d;d=this.isReady(b);var e;d===this.m&&q(new sjcl.exception.notReady("generator isn't seeded"));if(d&this.u){d=!(d&this.t);e=[];var f=0,g;this.O=e[0]=(new Date).valueOf()+this.T;for(g=0;16>g;g++)e.push(0x100000000*Math.random()|0);for(g=0;g<this.c.length&&!(e=e.concat(this.c[g].finalize()),f+=this.i[g],this.i[g]=0,!d&&this.F&1<<g);g++);this.F>=1<<this.c.length&&(this.c.push(new sjcl.hash.sha256),this.i.push(0));this.d-=f;f>this.j&&(this.j=f);this.F++;
this.b=sjcl.hash.sha256.hash(this.b.concat(e));this.A=new sjcl.cipher.aes(this.b);for(d=0;4>d&&!(this.f[d]=this.f[d]+1|0,this.f[d]);d++);}for(d=0;d<a;d+=4)0===(d+1)%this.S&&A(this),e=B(this),c.push(e[0],e[1],e[2],e[3]);A(this);return c.slice(0,a)},setDefaultParanoia:function(a,b){0===a&&"Setting paranoia=0 will ruin your security; use it only for testing"!==b&&q("Setting paranoia=0 will ruin your security; use it only for testing");this.B=a},addEntropy:function(a,b,c){c=c||"user";var d,e,f=(new Date).valueOf(),
g=this.s[c],h=this.isReady(),l=0;d=this.K[c];d===t&&(d=this.K[c]=this.W++);g===t&&(g=this.s[c]=0);this.s[c]=(this.s[c]+1)%this.c.length;switch(typeof a){case "number":b===t&&(b=1);this.c[g].update([d,this.C++,1,b,f,1,a|0]);break;case "object":c=Object.prototype.toString.call(a);if("[object Uint32Array]"===c){e=[];for(c=0;c<a.length;c++)e.push(a[c]);a=e}else{"[object Array]"!==c&&(l=1);for(c=0;c<a.length&&!l;c++)"number"!==typeof a[c]&&(l=1)}if(!l){if(b===t)for(c=b=0;c<a.length;c++)for(e=a[c];0<e;)b++,
e>>>=1;this.c[g].update([d,this.C++,2,b,f,a.length].concat(a))}break;case "string":b===t&&(b=a.length);this.c[g].update([d,this.C++,3,b,f,a.length]);this.c[g].update(a);break;default:l=1}l&&q(new sjcl.exception.bug("random: addEntropy only supports number, array of numbers or string"));this.i[g]+=b;this.d+=b;h===this.m&&(this.isReady()!==this.m&&C("seeded",Math.max(this.j,this.d)),C("progress",this.getProgress()))},isReady:function(a){a=this.I[a!==t?a:this.B];return this.j&&this.j>=a?this.i[0]>this.R&&
(new Date).valueOf()>this.O?this.u|this.t:this.t:this.d>=a?this.u|this.m:this.m},getProgress:function(a){a=this.I[a?a:this.B];return this.j>=a?1:this.d>a?1:this.d/a},startCollectors:function(){this.q||(this.a={loadTimeCollector:D(this,this.aa),mouseCollector:D(this,this.ba),keyboardCollector:D(this,this.$),accelerometerCollector:D(this,this.U)},window.addEventListener?(window.addEventListener("load",this.a.loadTimeCollector,u),window.addEventListener("mousemove",this.a.mouseCollector,u),window.addEventListener("keypress",
this.a.keyboardCollector,u),window.addEventListener("devicemotion",this.a.accelerometerCollector,u)):document.attachEvent?(document.attachEvent("onload",this.a.loadTimeCollector),document.attachEvent("onmousemove",this.a.mouseCollector),document.attachEvent("keypress",this.a.keyboardCollector)):q(new sjcl.exception.bug("can't attach event")),this.q=!0)},stopCollectors:function(){this.q&&(window.removeEventListener?(window.removeEventListener("load",this.a.loadTimeCollector,u),window.removeEventListener("mousemove",
this.a.mouseCollector,u),window.removeEventListener("keypress",this.a.keyboardCollector,u),window.removeEventListener("devicemotion",this.a.accelerometerCollector,u)):document.detachEvent&&(document.detachEvent("onload",this.a.loadTimeCollector),document.detachEvent("onmousemove",this.a.mouseCollector),document.detachEvent("keypress",this.a.keyboardCollector)),this.q=u)},addEventListener:function(a,b){this.w[a][this.V++]=b},removeEventListener:function(a,b){var c,d,e=this.w[a],f=[];for(d in e)e.hasOwnProperty(d)&&
e[d]===b&&f.push(d);for(c=0;c<f.length;c++)d=f[c],delete e[d]},$:function(){E(1)},ba:function(a){sjcl.random.addEntropy([a.x||a.clientX||a.offsetX||0,a.y||a.clientY||a.offsetY||0],2,"mouse");E(0)},aa:function(){E(2)},U:function(a){a=a.accelerationIncludingGravity.x||a.accelerationIncludingGravity.y||a.accelerationIncludingGravity.z;if(window.orientation){var b=window.orientation;"number"===typeof b&&sjcl.random.addEntropy(b,1,"accelerometer")}a&&sjcl.random.addEntropy(a,2,"accelerometer");E(0)}};
function C(a,b){var c,d=sjcl.random.w[a],e=[];for(c in d)d.hasOwnProperty(c)&&e.push(d[c]);for(c=0;c<e.length;c++)e[c](b)}function E(a){window&&window.performance&&"function"===typeof window.performance.now?sjcl.random.addEntropy(window.performance.now(),a,"loadtime"):sjcl.random.addEntropy((new Date).valueOf(),a,"loadtime")}function A(a){a.b=B(a).concat(B(a));a.A=new sjcl.cipher.aes(a.b)}function B(a){for(var b=0;4>b&&!(a.f[b]=a.f[b]+1|0,a.f[b]);b++);return a.A.encrypt(a.f)}
function D(a,b){return function(){b.apply(a,arguments)}}sjcl.random=new sjcl.prng(6);
a:try{var F,G,H,I;if(I="undefined"!==typeof module){var J;if(J=module.exports){var K;try{K=require("crypto")}catch(L){K=null}J=(G=K)&&G.randomBytes}I=J}if(I)F=G.randomBytes(128),F=new Uint32Array((new Uint8Array(F)).buffer),sjcl.random.addEntropy(F,1024,"crypto['randomBytes']");else if(window&&Uint32Array){H=new Uint32Array(32);if(window.crypto&&window.crypto.getRandomValues)window.crypto.getRandomValues(H);else if(window.msCrypto&&window.msCrypto.getRandomValues)window.msCrypto.getRandomValues(H);
else break a;sjcl.random.addEntropy(H,1024,"crypto['getRandomValues']")}}catch(M){"undefined"!==typeof window&&window.console&&(console.log("There was an error collecting entropy from the browser:"),console.log(M))}
sjcl.json={defaults:{v:1,iter:1E3,ks:128,ts:64,mode:"ccm",adata:"",cipher:"aes"},Y:function(a,b,c,d){c=c||{};d=d||{};var e=sjcl.json,f=e.e({iv:sjcl.random.randomWords(4,0)},e.defaults),g;e.e(f,c);c=f.adata;"string"===typeof f.salt&&(f.salt=sjcl.codec.base64.toBits(f.salt));"string"===typeof f.iv&&(f.iv=sjcl.codec.base64.toBits(f.iv));(!sjcl.mode[f.mode]||!sjcl.cipher[f.cipher]||"string"===typeof a&&100>=f.iter||64!==f.ts&&96!==f.ts&&128!==f.ts||128!==f.ks&&192!==f.ks&&0x100!==f.ks||2>f.iv.length||4<
f.iv.length)&&q(new sjcl.exception.invalid("json encrypt: invalid parameters"));"string"===typeof a?(g=sjcl.misc.cachedPbkdf2(a,f),a=g.key.slice(0,f.ks/32),f.salt=g.salt):sjcl.ecc&&a instanceof sjcl.ecc.elGamal.publicKey&&(g=a.kem(),f.kemtag=g.tag,a=g.key.slice(0,f.ks/32));"string"===typeof b&&(b=sjcl.codec.utf8String.toBits(b));"string"===typeof c&&(c=sjcl.codec.utf8String.toBits(c));g=new sjcl.cipher[f.cipher](a);e.e(d,f);d.key=a;f.ct=sjcl.mode[f.mode].encrypt(g,b,f.iv,c,f.ts);return f},encrypt:function(a,
b,c,d){var e=sjcl.json,f=e.Y.apply(e,arguments);return e.encode(f)},X:function(a,b,c,d){c=c||{};d=d||{};var e=sjcl.json;b=e.e(e.e(e.e({},e.defaults),b),c,!0);var f;c=b.adata;"string"===typeof b.salt&&(b.salt=sjcl.codec.base64.toBits(b.salt));"string"===typeof b.iv&&(b.iv=sjcl.codec.base64.toBits(b.iv));(!sjcl.mode[b.mode]||!sjcl.cipher[b.cipher]||"string"===typeof a&&100>=b.iter||64!==b.ts&&96!==b.ts&&128!==b.ts||128!==b.ks&&192!==b.ks&&0x100!==b.ks||!b.iv||2>b.iv.length||4<b.iv.length)&&q(new sjcl.exception.invalid("json decrypt: invalid parameters"));
"string"===typeof a?(f=sjcl.misc.cachedPbkdf2(a,b),a=f.key.slice(0,b.ks/32),b.salt=f.salt):sjcl.ecc&&a instanceof sjcl.ecc.elGamal.secretKey&&(a=a.unkem(sjcl.codec.base64.toBits(b.kemtag)).slice(0,b.ks/32));"string"===typeof c&&(c=sjcl.codec.utf8String.toBits(c));f=new sjcl.cipher[b.cipher](a);c=sjcl.mode[b.mode].decrypt(f,b.ct,b.iv,c,b.ts);e.e(d,b);d.key=a;return sjcl.codec.utf8String.fromBits(c)},decrypt:function(a,b,c,d){var e=sjcl.json;return e.X(a,e.decode(b),c,d)},encode:function(a){var b,c=
"{",d="";for(b in a)if(a.hasOwnProperty(b))switch(b.match(/^[a-z0-9]+$/i)||q(new sjcl.exception.invalid("json encode: invalid property name")),c+=d+'"'+b+'":',d=",",typeof a[b]){case "number":case "boolean":c+=a[b];break;case "string":c+='"'+escape(a[b])+'"';break;case "object":c+='"'+sjcl.codec.base64.fromBits(a[b],0)+'"';break;default:q(new sjcl.exception.bug("json encode: unsupported type"))}return c+"}"},decode:function(a){a=a.replace(/\s/g,"");a.match(/^\{.*\}$/)||q(new sjcl.exception.invalid("json decode: this isn't json!"));
a=a.replace(/^\{|\}$/g,"").split(/,/);var b={},c,d;for(c=0;c<a.length;c++)(d=a[c].match(/^(?:(["']?)([a-z][a-z0-9]*)\1):(?:(\d+)|"([a-z0-9+\/%*_.@=\-]*)")$/i))||q(new sjcl.exception.invalid("json decode: this isn't json!")),b[d[2]]=d[3]?parseInt(d[3],10):d[2].match(/^(ct|salt|iv)$/)?sjcl.codec.base64.toBits(d[4]):unescape(d[4]);return b},e:function(a,b,c){a===t&&(a={});if(b===t)return a;for(var d in b)b.hasOwnProperty(d)&&(c&&(a[d]!==t&&a[d]!==b[d])&&q(new sjcl.exception.invalid("required parameter overridden")),
a[d]=b[d]);return a},ea:function(a,b){var c={},d;for(d in a)a.hasOwnProperty(d)&&a[d]!==b[d]&&(c[d]=a[d]);return c},da:function(a,b){var c={},d;for(d=0;d<b.length;d++)a[b[d]]!==t&&(c[b[d]]=a[b[d]]);return c}};sjcl.encrypt=sjcl.json.encrypt;sjcl.decrypt=sjcl.json.decrypt;sjcl.misc.ca={};
sjcl.misc.cachedPbkdf2=function(a,b){var c=sjcl.misc.ca,d;b=b||{};d=b.iter||1E3;c=c[a]=c[a]||{};d=c[d]=c[d]||{firstSalt:b.salt&&b.salt.length?b.salt.slice(0):sjcl.random.randomWords(2,0)};c=b.salt===t?d.firstSalt:b.salt;d[c]=d[c]||sjcl.misc.pbkdf2(a,c,b.iter);return{key:d[c].slice(0),salt:c.slice(0)}};
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/sjcl',_glass_sjcl_);
    else
      _glass_sjcl_.call(this, module, exports, require);
  }
  else {
    _glass_sjcl_.call(this);
  }
}).call(this)
void (function(){var _glass_state_HashState_ = function(module,exports,require){'use strict';
var ion = require('ion');
module.exports = exports = ion.template(function (defaultValue) {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'internal',
                            loc: {
                                start: {
                                    line: 6,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/state/HashState.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 16,
                                    fixed: true,
                                    source: 'glass/state/HashState.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            properties: [{
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'paused',
                                        loc: {
                                            start: {
                                                line: 6,
                                                column: 20,
                                                fixed: true,
                                                source: 'glass/state/HashState.ion'
                                            },
                                            end: {
                                                line: 6,
                                                column: 26,
                                                fixed: true,
                                                source: 'glass/state/HashState.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: false
                                    },
                                    kind: 'init',
                                    order: '0'
                                }]
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'state',
                            loc: {
                                start: {
                                    line: 8,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/state/HashState.ion'
                                },
                                end: {
                                    line: 8,
                                    column: 13,
                                    fixed: true,
                                    source: 'glass/state/HashState.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: 'Object'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'defineProperties'
                                }
                            },
                            arguments: [
                                {
                                    type: 'ObjectExpression',
                                    objectType: {
                                        type: 'ObjectExpression',
                                        properties: []
                                    },
                                    properties: []
                                },
                                {
                                    type: 'ObjectExpression',
                                    properties: [
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'pauseSync',
                                                loc: {
                                                    start: {
                                                        line: 9,
                                                        column: 17,
                                                        fixed: true,
                                                        source: 'glass/state/HashState.ion'
                                                    },
                                                    end: {
                                                        line: 9,
                                                        column: 26,
                                                        fixed: true,
                                                        source: 'glass/state/HashState.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'ObjectExpression',
                                                properties: [{
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'value',
                                                            loc: {
                                                                start: {
                                                                    line: 10,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/state/HashState.ion'
                                                                },
                                                                end: {
                                                                    line: 10,
                                                                    column: 17,
                                                                    fixed: true,
                                                                    source: 'glass/state/HashState.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Function',
                                                            context: true,
                                                            value: function (_context) {
                                                                return function () {
                                                                    var internal = _context.get('internal');
                                                                    return internal.paused = true;
                                                                };
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    }]
                                            },
                                            kind: 'init',
                                            define: false,
                                            order: '0'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'resumeSync',
                                                loc: {
                                                    start: {
                                                        line: 11,
                                                        column: 17,
                                                        fixed: true,
                                                        source: 'glass/state/HashState.ion'
                                                    },
                                                    end: {
                                                        line: 11,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'glass/state/HashState.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'ObjectExpression',
                                                properties: [{
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'value',
                                                            loc: {
                                                                start: {
                                                                    line: 12,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'glass/state/HashState.ion'
                                                                },
                                                                end: {
                                                                    line: 12,
                                                                    column: 17,
                                                                    fixed: true,
                                                                    source: 'glass/state/HashState.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Function',
                                                            context: true,
                                                            value: function (_context2) {
                                                                return function () {
                                                                    var internal = _context2.get('internal'), copyStateToHash = _context2.get('copyStateToHash');
                                                                    if (internal.paused) {
                                                                        internal.paused = false;
                                                                        copyStateToHash();
                                                                    }
                                                                };
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    }]
                                            },
                                            kind: 'init',
                                            define: false,
                                            order: '1'
                                        }
                                    ]
                                }
                            ]
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'copyHashToState',
                            loc: {
                                start: {
                                    line: 17,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/state/HashState.ion'
                                },
                                end: {
                                    line: 17,
                                    column: 23,
                                    fixed: true,
                                    source: 'glass/state/HashState.ion'
                                }
                            }
                        },
                        init: {
                            type: 'Function',
                            context: true,
                            value: function (_context3) {
                                return function copyHashToState() {
                                    var defaultValue = _context3.get('defaultValue'), ion = _context3.get('ion'), state = _context3.get('state');
                                    var hash = document.location.hash.substring(1);
                                    if (hash.length === 0) {
                                        hash = JSON.stringify(defaultValue);
                                    }
                                    var newState;
                                    try {
                                        newState = JSON.parse(hash);
                                    } catch (e) {
                                        try {
                                            newState = JSON.parse(decodeURIComponent(hash));
                                        } catch (e) {
                                            newState = defaultValue;
                                        }
                                    }
                                    var diff = ion.patch.diff(state, newState);
                                    if (diff != null) {
                                        ion.patch(state, diff);
                                    }
                                };
                            }
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'copyStateToHash',
                            loc: {
                                start: {
                                    line: 35,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/state/HashState.ion'
                                },
                                end: {
                                    line: 35,
                                    column: 23,
                                    fixed: true,
                                    source: 'glass/state/HashState.ion'
                                }
                            }
                        },
                        init: {
                            type: 'Function',
                            context: true,
                            value: function (_context4) {
                                return function copyStateToHash() {
                                    var internal = _context4.get('internal'), state = _context4.get('state');
                                    if (!internal.paused) {
                                        var hash = '#' + JSON.stringify(state);
                                        if (document.location.hash !== hash) {
                                            document.location.hash = hash;
                                        }
                                    }
                                };
                            }
                        }
                    }],
                kind: 'let',
                order: '3'
            },
            {
                type: 'ExpressionStatement',
                expression: {
                    type: 'CallExpression',
                    callee: {
                        type: 'Function',
                        context: true,
                        value: function (_context5) {
                            return function () {
                                var copyHashToState = _context5.get('copyHashToState');
                                return copyHashToState();
                            };
                        }
                    },
                    arguments: [],
                    loc: {
                        start: {
                            line: 41,
                            column: 4,
                            fixed: true,
                            source: 'glass/state/HashState.ion'
                        },
                        end: {
                            line: 41,
                            column: 27,
                            fixed: true,
                            source: 'glass/state/HashState.ion'
                        }
                    }
                },
                loc: {
                    start: {
                        line: 41,
                        column: 4,
                        fixed: true,
                        source: 'glass/state/HashState.ion'
                    },
                    end: {
                        line: 41,
                        column: 27,
                        fixed: true,
                        source: 'glass/state/HashState.ion'
                    }
                },
                order: '4'
            },
            {
                type: 'ExpressionStatement',
                expression: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'Identifier',
                        name: 'window',
                        loc: {
                            start: {
                                line: 43,
                                column: 4,
                                fixed: true,
                                source: 'glass/state/HashState.ion'
                            },
                            end: {
                                line: 43,
                                column: 10,
                                fixed: true,
                                source: 'glass/state/HashState.ion'
                            }
                        }
                    },
                    properties: [
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'Function',
                                context: true,
                                value: function (_context6) {
                                    return function hashchange(e) {
                                        var copyHashToState = _context6.get('copyHashToState');
                                        copyHashToState();
                                    };
                                }
                            },
                            loc: {
                                start: {
                                    line: 44,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/state/HashState.ion'
                                },
                                end: {
                                    line: 46,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/state/HashState.ion'
                                }
                            },
                            order: '0'
                        },
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'Function',
                                context: true,
                                value: function (_context7) {
                                    return function popstate(e) {
                                        var copyHashToState = _context7.get('copyHashToState');
                                        copyHashToState();
                                    };
                                }
                            },
                            loc: {
                                start: {
                                    line: 46,
                                    column: 8,
                                    fixed: true,
                                    source: 'glass/state/HashState.ion'
                                },
                                end: {
                                    line: 48,
                                    column: 12,
                                    fixed: true,
                                    source: 'glass/state/HashState.ion'
                                }
                            },
                            order: '1'
                        }
                    ]
                },
                loc: {
                    start: {
                        line: 43,
                        column: 4,
                        fixed: true,
                        source: 'glass/state/HashState.ion'
                    },
                    end: {
                        line: 48,
                        column: 8,
                        fixed: true,
                        source: 'glass/state/HashState.ion'
                    }
                },
                order: '5'
            },
            {
                type: 'ExpressionStatement',
                expression: {
                    type: 'CallExpression',
                    callee: {
                        type: 'Identifier',
                        name: 'copyStateToHash',
                        loc: {
                            start: {
                                line: 49,
                                column: 4,
                                fixed: true,
                                source: 'glass/state/HashState.ion'
                            },
                            end: {
                                line: 49,
                                column: 19,
                                fixed: true,
                                source: 'glass/state/HashState.ion'
                            }
                        }
                    },
                    arguments: [{
                            type: 'Identifier',
                            name: 'state',
                            loc: {
                                start: {
                                    line: 49,
                                    column: 25,
                                    fixed: true,
                                    source: 'glass/state/HashState.ion'
                                },
                                end: {
                                    line: 49,
                                    column: 30,
                                    fixed: true,
                                    source: 'glass/state/HashState.ion'
                                }
                            },
                            deep: true
                        }],
                    loc: {
                        start: {
                            line: 49,
                            column: 4,
                            fixed: true,
                            source: 'glass/state/HashState.ion'
                        },
                        end: {
                            line: 49,
                            column: 31,
                            fixed: true,
                            source: 'glass/state/HashState.ion'
                        }
                    }
                },
                loc: {
                    start: {
                        line: 49,
                        column: 4,
                        fixed: true,
                        source: 'glass/state/HashState.ion'
                    },
                    end: {
                        line: 49,
                        column: 31,
                        fixed: true,
                        source: 'glass/state/HashState.ion'
                    }
                },
                order: '6'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'Identifier',
                    name: 'state',
                    loc: {
                        start: {
                            line: 51,
                            column: 11,
                            fixed: true,
                            source: 'glass/state/HashState.ion'
                        },
                        end: {
                            line: 51,
                            column: 16,
                            fixed: true,
                            source: 'glass/state/HashState.ion'
                        }
                    }
                },
                order: '7'
            }
        ],
        bound: false
    }, {
        this: this,
        ion: ion,
        defaultValue: defaultValue
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/state/HashState',_glass_state_HashState_);
    else
      _glass_state_HashState_.call(this, module, exports, require);
  }
  else {
    _glass_state_HashState_.call(this);
  }
}).call(this)
void (function(){var _glass_state_WebStorageState_ = function(module,exports,require){'use strict';
var ion = require('ion'), map = new Map();
module.exports = exports = function WebStorageState(storage) {
    var object = map.get(storage);
    if (!(object != null)) {
        map.set(storage, object = {});
        for (var key in storage) {
            var value = storage[key];
            try {
                object[key] = JSON.parse(value);
            } catch (e) {
                'suppress error';
            }
        }
        ion.patch.watch(object, function (patch) {
            for (var name in patch) {
                var value = object[name];
                if (value != null) {
                    storage.setItem(name, JSON.stringify(value));
                } else {
                    storage.removeItem(name);
                }
            }
        });
    }
    return object;
};
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/state/WebStorageState',_glass_state_WebStorageState_);
    else
      _glass_state_WebStorageState_.call(this, module, exports, require);
  }
  else {
    _glass_state_WebStorageState_.call(this);
  }
}).call(this)
void (function(){var _glass_state_index_ = function(module,exports,require){Object.defineProperty(exports, 'HashState', {get:function(){ return require('./HashState') }, enumerable: true}) 
Object.defineProperty(exports, 'WebStorageState', {get:function(){ return require('./WebStorageState') }, enumerable: true}) 
Object.freeze(exports)
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/state/index',_glass_state_index_);
    else
      _glass_state_index_.call(this, module, exports, require);
  }
  else {
    _glass_state_index_.call(this);
  }
}).call(this)
void (function(){var _glass_time_DateTime_ = function(module,exports,require){'use strict';
var ion = require('ion');
var pads = [
        '',
        '0',
        '00',
        '000'
    ];
var pad = function (value, length) {
        var result = value.toString();
        return pads[length - result.length] + result;
    }, getDate = function (year, month, date) {
        return pad(year, 4) + '-' + pad(month, 2) + '-' + pad(date, 2);
    }, getTime = function (hours, minutes, seconds) {
        return 'T' + pad(hours, 2) + ':' + pad(minutes, 2) + ':' + pad(seconds, 2);
    }, toIso = function (_ref) {
        var year = _ref.year;
        var month = _ref.month;
        var date = _ref.date;
        var time = _ref.time;
        var hours = _ref.hours;
        var minutes = _ref.minutes;
        var seconds = _ref.seconds;
        var text = getDate(year, month, date);
        if (time) {
            text += getTime(hours, minutes, seconds);
        }
        return text;
    }, isProbablyIso = function (string) {
        return string != null && string[4] === '-' && string[7] === '-';
    }, parseDigits = function (s) {
        return s.length === 0 ? 0 : parseInt(s);
    }, parseIso = function (s) {
        var year = parseDigits(s.substring(0, 4));
        var month = parseDigits(s.substring(5, 7));
        var date = parseDigits(s.substring(8, 10));
        var hours = parseDigits(s.substring(11, 13));
        var minutes = parseDigits(s.substring(14, 16));
        var seconds = parseDigits(s.substring(17, 19));
        var time = hours + minutes + seconds > 0;
        return {
            year: year,
            month: month,
            date: date,
            time: time,
            hours: hours,
            minutes: minutes,
            seconds: seconds
        };
    }, parseLegacy = function (string) {
        var date = Date.create(string);
        if (isNaN(date.getTime())) {
            throw new Error('Invalid Date format ' + string);
        }
        var time = date.getHours() + date.getMinutes() + date.getSeconds() > 0;
        return {
            year: date.getYear() + 1900,
            month: date.getMonth() + 1,
            date: date.getDate(),
            time: time,
            hours: date.getHours(),
            minutes: date.getMinutes(),
            seconds: date.getSeconds()
        };
    }, parse = function (string) {
        if (isProbablyIso(string)) {
            return parseIso(string);
        }
        return parseLegacy(string);
    };
var currentYear = new Date().getYear() + 1900;
var DateTime = ion.defineClass({
        name: 'DateTime',
        constructor: function DateTime(properties) {
            if (!(properties != null)) {
                properties = new Date();
            }
            if (typeof properties === 'string') {
                properties = parse(properties);
            } else if (properties.constructor === Date) {
                properties = parse(properties.iso());
            }
            {
                var _ref5 = DateTime.properties;
                for (var name in _ref5) {
                    var property = _ref5[name];
                    if (property.writable) {
                        if (properties.hasOwnProperty(name)) {
                            this[name] = properties[name];
                        }
                    }
                }
            }
            Object.freeze(this);
        },
        parse: function (string) {
            if (!(string != null)) {
                return null;
            }
            return new DateTime(string);
        },
        properties: {
            year: {
                type: 'integer',
                writable: true
            },
            month: {
                type: 'integer',
                writable: true
            },
            date: {
                type: 'integer',
                writable: true
            },
            time: {
                type: 'boolean',
                writable: true,
                value: false
            },
            hours: {
                type: 'integer',
                writable: true,
                value: 0
            },
            minutes: {
                type: 'integer',
                writable: true,
                value: 0
            },
            seconds: {
                type: 'integer',
                writable: true,
                value: 0
            },
            add: function (duration) {
                var date = this.toDate();
                duration.addToDate(date);
                return DateTime.parse(date.iso());
            },
            subtract: function (durationOrDate) {
                var _ref2 = require('./');
                var Duration = _ref2.Duration;
                if (durationOrDate.constructor === Duration) {
                    return this.add(durationOrDate.negate());
                } else {
                    var thisDate = this.toDate();
                    var subtractDate = durationOrDate.toDate();
                    var years = thisDate.yearsSince(subtractDate);
                    subtractDate.addYears(years);
                    var months = thisDate.monthsSince(subtractDate);
                    subtractDate.addMonths(months);
                    var days = thisDate.daysSince(subtractDate);
                    subtractDate.addDays(days);
                    var hours = thisDate.hoursSince(subtractDate);
                    subtractDate.addHours(hours);
                    var minutes = thisDate.minutesSince(subtractDate);
                    return new Duration({
                        years: years,
                        months: months,
                        days: days,
                        hours: hours,
                        minutes: minutes
                    });
                }
            },
            iso: function () {
                return toIso(this);
            },
            valueOf: function () {
                return this.iso();
            },
            toString: function () {
                return toIso(this);
            },
            toDate: function () {
                var date = new Date(Date.UTC(this.year, this.month - 1, this.date, this.hours, this.minutes, this.seconds));
                date.setUTC(true);
                return date;
            },
            withoutTime: function () {
                return this.time ? new DateTime({
                    year: this.year,
                    month: this.month,
                    date: this.date
                }) : this;
            },
            getIsoDateWithoutTime: function () {
                return getDate(this.year, this.month, this.date);
            },
            getIsoTime: function () {
                return this.time ? getTime(this.hours, this.minutes, this.seconds) : '';
            },
            getIsoTimeAsDuration: function () {
                var _ref3 = require('./');
                var Duration = _ref3.Duration;
                return new Duration({
                    hours: this.hours,
                    minutes: this.minutes,
                    seconds: this.seconds
                });
            },
            format: function () {
                var date = this.toDate();
                var format = '{Dow} {Mon} {d}';
                var addYear = this.year !== currentYear;
                if (addYear) {
                    format += ', {yyyy}';
                }
                if (this.time) {
                    if (!addYear) {
                        format += ',';
                    }
                    format += ' {12hr}:{mm}{tt}';
                }
                return date.format(format);
            }
        },
        test: function () {
            var _ref4 = require('./');
            var Duration = _ref4.Duration;
            if (!(pad(3, 2) === '03'))
                throw new Error('Assertion Failed: (pad(3, 2) is "03")');
            if (!(pad(24, 4) === '0024'))
                throw new Error('Assertion Failed: (pad(24, 4) is "0024")');
            if (!(new DateTime('Dec 9, 1971').toString() === '1971-12-09'))
                throw new Error('Assertion Failed: (new DateTime("Dec 9, 1971").toString() is "1971-12-09")');
            if (!(new DateTime('Dec 11, 1975 4:30 PM').toString() === '1975-12-11T16:30:00'))
                throw new Error('Assertion Failed: (new DateTime("Dec 11, 1975 4:30 PM").toString() is "1975-12-11T16:30:00")');
            if (!(new DateTime('Dec 9, 1971').format() === 'Thu Dec 9, 1971'))
                throw new Error('Assertion Failed: (new DateTime("Dec 9, 1971").format() is "Thu Dec 9, 1971")');
            if (!(new DateTime('Dec 9, ' + currentYear).format().substring(4) === 'Dec 9'))
                throw new Error('Assertion Failed: (new DateTime("Dec 9, {{currentYear}}").format().substring(4) is "Dec 9")');
            if (!(new DateTime('Dec 9, 1971 4:30pm').format() === 'Thu Dec 9, 1971 4:30pm'))
                throw new Error('Assertion Failed: (new DateTime("Dec 9, 1971 4:30pm").format() is "Thu Dec 9, 1971 4:30pm")');
            if (!(new DateTime('Dec 9, ' + currentYear + ' 4:30pm').format().substring(4) === 'Dec 9, 4:30pm'))
                throw new Error('Assertion Failed: (new DateTime("Dec 9, {{currentYear}} 4:30pm").format().substring(4) is "Dec 9, 4:30pm")');
            if (!(new DateTime('Dec 11, 1975 6:45 PM').subtract(new DateTime('Dec 9, 1971 4:30 PM')).toString() === 'P4Y2DT2H15M'))
                throw new Error('Assertion Failed: (new DateTime("Dec 11, 1975 6:45 PM").subtract(new DateTime("Dec 9, 1971 4:30 PM")).toString() is "P4Y2DT2H15M")');
            if (!(new DateTime('Dec 9, 1971 4:30 PM').subtract(new DateTime('Dec 11, 1975 6:45 PM')).toString() === 'P-4Y-2DT-2H-15M'))
                throw new Error('Assertion Failed: (new DateTime("Dec 9, 1971 4:30 PM").subtract(new DateTime("Dec 11, 1975 6:45 PM")).toString() is "P-4Y-2DT-2H-15M")');
            if (!(new DateTime('Dec 9, 1971 4:30 PM').add(new Duration('P4Y2DT2H15M')).iso() === new DateTime('Dec 11, 1975 6:45 PM').iso()))
                throw new Error('Assertion Failed: (new DateTime("Dec 9, 1971 4:30 PM").add(new Duration("P4Y2DT2H15M")).iso() is new DateTime("Dec 11, 1975 6:45 PM").iso())');
        }
    });
module.exports = exports = DateTime;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/time/DateTime',_glass_time_DateTime_);
    else
      _glass_time_DateTime_.call(this, module, exports, require);
  }
  else {
    _glass_time_DateTime_.call(this);
  }
}).call(this)
void (function(){var _glass_time_Duration_ = function(module,exports,require){'use strict';
var ion = require('ion');
var validProperties = {
        years: {
            char: 'Y',
            time: false,
            seconds: 60 * 60 * 24 * 365,
            name: 'years',
            nameSingular: 'year'
        },
        months: {
            char: 'M',
            time: false,
            seconds: 60 * 60 * 24 * 30,
            name: 'months',
            nameSingular: 'month'
        },
        weeks: {
            char: 'W',
            time: false,
            seconds: 60 * 60 * 24 * 7,
            name: 'weeks',
            nameSingular: 'week'
        },
        days: {
            char: 'D',
            time: false,
            seconds: 60 * 60 * 24,
            name: 'days',
            nameSingular: 'day'
        },
        hours: {
            char: 'H',
            time: true,
            seconds: 60 * 60,
            name: 'hours',
            nameSingular: 'hour'
        },
        minutes: {
            char: 'M',
            time: true,
            seconds: 60,
            name: 'minutes',
            nameSingular: 'minute'
        },
        seconds: {
            char: 'S',
            time: true,
            seconds: 1,
            name: 'seconds',
            nameSingular: 'second'
        }
    };
var parseExpression = /^P((-?\d+)Y)?((-?\d+)M)?((-?\d+)W)?((-?\d+)D)?(T((-?\d+)H)?((-?\d+)M)?((-?\d+)S)?)?$/;
var parseLocations = {
        years: 2,
        months: 4,
        weeks: 6,
        days: 8,
        hours: 11,
        minutes: 13,
        seconds: 15
    };
var parse = function (string, throwException) {
    if (throwException == null)
        throwException = true;
    if (string === 'P') {
        return { days: 0 };
    }
    if (!(string != null)) {
        return null;
    }
    var result = parseExpression.exec(string);
    if (!(result != null)) {
        if (throwException) {
            throw new Error('Invalid Duration string: \'' + string + '\'');
        } else {
            return null;
        }
    }
    var properties = {};
    for (var name in parseLocations) {
        var index = parseLocations[name];
        var value = result[index];
        if (value != null) {
            var floatValue = parseFloat(value);
            if (floatValue !== 0) {
                properties[name] = floatValue;
            }
        }
    }
    if (Object.keys(properties).length === 0) {
        return { days: 0 };
    }
    return properties;
};
var _ref2 = {};
{
    for (var property in validProperties) {
        _ref2[property] = ion.patch.combine(_ref2[property], {
            type: 'integer',
            value: 0,
            writable: true,
            enumerable: true
        });
    }
    _ref2.hasNegativeUnits = ion.patch.combine(_ref2.hasNegativeUnits, {
        get: function () {
            {
                var _ref = this;
                for (var name in _ref) {
                    var value = _ref[name];
                    if (value < 0) {
                        return true;
                    }
                }
            }
            return false;
        }
    });
    _ref2.totalSeconds = function () {
        var total = 0;
        for (var property in validProperties) {
            var _ref3 = validProperties[property];
            var seconds = _ref3.seconds;
            var value = this[property];
            if (value != null) {
                total += value * seconds;
            }
        }
        return total;
    };
    _ref2.multiply = function (factor) {
        var properties = {};
        for (var property in validProperties) {
            properties[property] = this[property] * factor;
        }
        return new Duration(properties);
    };
    _ref2.negate = function () {
        return this.multiply(-1);
    };
    _ref2.add = function (durationOrDate) {
        if (durationOrDate.constructor === Duration) {
            var properties = {};
            for (var property in validProperties) {
                properties[property] = this[property] + durationOrDate[property];
            }
            return new Duration(properties);
        }
    };
    _ref2.addToDate = function (date) {
        if (this.years) {
            date.addYears(this.years);
        }
        if (this.months) {
            date.addMonths(this.months);
        }
        if (this.weeks) {
            date.addWeeks(this.weeks);
        }
        if (this.days) {
            date.addDays(this.days);
        }
        if (this.hours) {
            date.addHours(this.hours);
        }
        if (this.minutes) {
            date.addMinutes(this.minutes);
        }
        return date;
    };
    _ref2.subtract = function (duration) {
        return this.add(duration.negate());
    };
    _ref2.iso = function () {
        var buffer = ['P'];
        var timeWritten = false;
        for (var property in validProperties) {
            var _ref4 = validProperties[property];
            var char = _ref4.char;
            var time = _ref4.time;
            var value = this[property];
            if (value !== 0) {
                if (time && !timeWritten) {
                    buffer.push('T');
                    timeWritten = true;
                }
                buffer.push(value, char);
            }
        }
        return buffer.join('');
    };
    _ref2.toString = function () {
        return this.iso();
    };
    _ref2.toSimpleDuration = function () {
        var days = this.years * 365 + this.months * 30 + this.weeks * 7 + this.days;
        if (days === 0) {
            if (this.hours > 0) {
                return new Duration({ hours: this.hours });
            }
            if (this.minutes > 0) {
                return new Duration({ minutes: this.minutes });
            }
        }
        if (days >= 90) {
            return new Duration({ months: Math.round(days / 30) });
        }
        if (days >= 30) {
            return new Duration({ weeks: Math.round(days / 7) });
        }
        return new Duration({ days: days });
    };
    _ref2.toValueUnit = function () {
        for (var unit in validProperties) {
            var value = this[unit];
            if (value > 0) {
                return {
                    value: value,
                    unit: unit
                };
            }
        }
        return {
            value: 0,
            unit: 'days'
        };
    };
    _ref2.format = function () {
        var buffer = [];
        for (var property in validProperties) {
            var _ref5 = validProperties[property];
            var name = _ref5.name;
            var nameSingular = _ref5.nameSingular;
            var value = this[property];
            if (value !== 0) {
                buffer.push(value, ' ', value === 1 ? nameSingular : name);
            }
        }
        return buffer.join('');
    };
}
var Duration = ion.defineClass({
        name: 'Duration',
        constructor: function Duration(properties) {
            if (typeof properties === 'string') {
                properties = parse(properties);
            }
            var count = 0;
            for (var property in validProperties) {
                if (properties.hasOwnProperty(property)) {
                    count++;
                    this[property] = Math.round(Number(properties[property] != null ? properties[property] : 0));
                }
            }
            if (count === 0) {
                throw new Error('At least one valid property must be specified: ' + Object.keys(properties));
            }
            Object.freeze(this);
        },
        parse: function (string) {
            if (!(string != null)) {
                return null;
            }
            var properties = parse(string, false);
            if (properties != null) {
                return new Duration(properties);
            } else {
                return null;
            }
        },
        validProperties: validProperties,
        properties: _ref2,
        test: {
            roundtrip: function () {
                var roundtrip = function (text) {
                    var duration = Duration.parse(text);
                    return duration.toString() === text;
                };
                if (!roundtrip('P2Y'))
                    throw new Error('Assertion Failed: (roundtrip("P2Y"))');
                if (!roundtrip('P2M'))
                    throw new Error('Assertion Failed: (roundtrip("P2M"))');
                if (!roundtrip('P2Y3M'))
                    throw new Error('Assertion Failed: (roundtrip("P2Y3M"))');
                if (!roundtrip('P3M2D'))
                    throw new Error('Assertion Failed: (roundtrip("P3M2D"))');
                if (!roundtrip('P3M2W2DT3H'))
                    throw new Error('Assertion Failed: (roundtrip("P3M2W2DT3H"))');
                if (!roundtrip('PT2H'))
                    throw new Error('Assertion Failed: (roundtrip("PT2H"))');
                if (!roundtrip('P4Y4M22DT13H44M50S'))
                    throw new Error('Assertion Failed: (roundtrip("P4Y4M22DT13H44M50S"))');
            },
            parsing: function () {
                if (!(Duration.parse('P4YT20M').negate().toString() === 'P-4YT-20M'))
                    throw new Error('Assertion Failed: (Duration.parse("P4YT20M").negate().toString() is "P-4YT-20M")');
                if (!(Duration.parse('P-4YT-20M').negate().toString() === 'P4YT20M'))
                    throw new Error('Assertion Failed: (Duration.parse("P-4YT-20M").negate().toString() is "P4YT20M")');
                if (!(Duration.parse('P2Y4MT12M').add(Duration.parse('P3YT2M15S')).toString() === 'P5Y4MT14M15S'))
                    throw new Error('Assertion Failed: (Duration.parse("P2Y4MT12M").add(Duration.parse("P3YT2M15S")).toString() is "P5Y4MT14M15S")');
                if (!(Duration.parse('P2Y4M').multiply(2).toString() === 'P4Y8M'))
                    throw new Error('Assertion Failed: (Duration.parse("P2Y4M").multiply(2).toString() is "P4Y8M")');
                if (!Duration.parse('P-4YT-20M').hasNegativeUnits)
                    throw new Error('Assertion Failed: (Duration.parse("P-4YT-20M").hasNegativeUnits)');
                if (!(Duration.parse('P4Y2M').hasNegativeUnits === false))
                    throw new Error('Assertion Failed: (Duration.parse("P4Y2M").hasNegativeUnits is false)');
            },
            totalSeconds: function () {
                if (!(Duration.parse('PT12M').totalSeconds() === 12 * 60))
                    throw new Error('Assertion Failed: (Duration.parse("PT12M").totalSeconds() is 12 * 60)');
                if (!(Duration.parse('PT12M45S').totalSeconds() === 12 * 60 + 45))
                    throw new Error('Assertion Failed: (Duration.parse("PT12M45S").totalSeconds() is 12 * 60 + 45)');
            }
        }
    });
module.exports = exports = Duration;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/time/Duration',_glass_time_Duration_);
    else
      _glass_time_Duration_.call(this, module, exports, require);
  }
  else {
    _glass_time_Duration_.call(this);
  }
}).call(this)
void (function(){var _glass_time_Timezone_ = function(module,exports,require){'use strict';
require('./moment-timezone');
var values = exports.values = [
        'America/Los_Angeles',
        'America/Phoenix',
        'America/Denver',
        'America/Chicago',
        'America/New_York',
        'Europe/Lisbon',
        'Europe/Madrid',
        'Europe/London',
        'Europe/Paris',
        'Asia/Hong_Kong',
        'Asia/Shanghai',
        'Asia/Seoul',
        'Asia/Tokyo',
        'Australia/Sydney'
    ];
var toLocal = exports.toLocal = function (time, timezone) {
        if (!(time != null)) {
            return null;
        }
        if (time.indexOf('T') < 0) {
            return time;
        }
        timezone = timezone != null ? timezone : moment.tz.guess();
        return moment(time).tz(timezone).format().substring(0, 19);
    };
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/time/Timezone',_glass_time_Timezone_);
    else
      _glass_time_Timezone_.call(this, module, exports, require);
  }
  else {
    _glass_time_Timezone_.call(this);
  }
}).call(this)
void (function(){var _glass_time_index_ = function(module,exports,require){Object.defineProperty(exports, 'DateTime', {get:function(){ return require('./DateTime') }, enumerable: true}) 
Object.defineProperty(exports, 'Duration', {get:function(){ return require('./Duration') }, enumerable: true}) 
Object.defineProperty(exports, 'Timezone', {get:function(){ return require('./Timezone') }, enumerable: true}) 
Object.defineProperty(exports, 'moment-timezone', {get:function(){ return require('./moment-timezone') }, enumerable: true}) 
Object.defineProperty(exports, 'moment', {get:function(){ return require('./moment') }, enumerable: true}) 
Object.freeze(exports)
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/time/index',_glass_time_index_);
    else
      _glass_time_index_.call(this, module, exports, require);
  }
  else {
    _glass_time_index_.call(this);
  }
}).call(this)
void (function(){var _glass_time_moment_timezone_ = function(module,exports,require){//! moment-timezone.js
//! version : 0.5.13
//! Copyright (c) JS Foundation and other contributors
//! license : MIT
//! github.com/moment/moment-timezone

// I changed how this is packaged and exported to work with ion. - Kody
(function () {
    "use strict";

    let moment = require('./moment')

    // Do not load moment-timezone a second time.
    // if (moment.tz !== undefined) {
    //  logError('Moment Timezone ' + moment.tz.version + ' was already loaded ' + (moment.tz.dataVersion ? 'with data from ' : 'without any data') + moment.tz.dataVersion);
    //  return moment;
    // }

    var VERSION = "0.5.13",
        zones = {},
        links = {},
        names = {},
        guesses = {},
        cachedGuess,

        momentVersion = moment.version.split('.'),
        major = +momentVersion[0],
        minor = +momentVersion[1];

    // Moment.js version check
    if (major < 2 || (major === 2 && minor < 6)) {
        logError('Moment Timezone requires Moment.js >= 2.6.0. You are using Moment.js ' + moment.version + '. See momentjs.com');
    }

    /************************************
        Unpacking
    ************************************/

    function charCodeToInt(charCode) {
        if (charCode > 96) {
            return charCode - 87;
        } else if (charCode > 64) {
            return charCode - 29;
        }
        return charCode - 48;
    }

    function unpackBase60(string) {
        var i = 0,
            parts = string.split('.'),
            whole = parts[0],
            fractional = parts[1] || '',
            multiplier = 1,
            num,
            out = 0,
            sign = 1;

        // handle negative numbers
        if (string.charCodeAt(0) === 45) {
            i = 1;
            sign = -1;
        }

        // handle digits before the decimal
        for (i; i < whole.length; i++) {
            num = charCodeToInt(whole.charCodeAt(i));
            out = 60 * out + num;
        }

        // handle digits after the decimal
        for (i = 0; i < fractional.length; i++) {
            multiplier = multiplier / 60;
            num = charCodeToInt(fractional.charCodeAt(i));
            out += num * multiplier;
        }

        return out * sign;
    }

    function arrayToInt (array) {
        for (var i = 0; i < array.length; i++) {
            array[i] = unpackBase60(array[i]);
        }
    }

    function intToUntil (array, length) {
        for (var i = 0; i < length; i++) {
            array[i] = Math.round((array[i - 1] || 0) + (array[i] * 60000)); // minutes to milliseconds
        }

        array[length - 1] = Infinity;
    }

    function mapIndices (source, indices) {
        var out = [], i;

        for (i = 0; i < indices.length; i++) {
            out[i] = source[indices[i]];
        }

        return out;
    }

    function unpack (string) {
        var data = string.split('|'),
            offsets = data[2].split(' '),
            indices = data[3].split(''),
            untils  = data[4].split(' ');

        arrayToInt(offsets);
        arrayToInt(indices);
        arrayToInt(untils);

        intToUntil(untils, indices.length);

        return {
            name       : data[0],
            abbrs      : mapIndices(data[1].split(' '), indices),
            offsets    : mapIndices(offsets, indices),
            untils     : untils,
            population : data[5] | 0
        };
    }

    /************************************
        Zone object
    ************************************/

    function Zone (packedString) {
        if (packedString) {
            this._set(unpack(packedString));
        }
    }

    Zone.prototype = {
        _set : function (unpacked) {
            this.name       = unpacked.name;
            this.abbrs      = unpacked.abbrs;
            this.untils     = unpacked.untils;
            this.offsets    = unpacked.offsets;
            this.population = unpacked.population;
        },

        _index : function (timestamp) {
            var target = +timestamp,
                untils = this.untils,
                i;

            for (i = 0; i < untils.length; i++) {
                if (target < untils[i]) {
                    return i;
                }
            }
        },

        parse : function (timestamp) {
            var target  = +timestamp,
                offsets = this.offsets,
                untils  = this.untils,
                max     = untils.length - 1,
                offset, offsetNext, offsetPrev, i;

            for (i = 0; i < max; i++) {
                offset     = offsets[i];
                offsetNext = offsets[i + 1];
                offsetPrev = offsets[i ? i - 1 : i];

                if (offset < offsetNext && tz.moveAmbiguousForward) {
                    offset = offsetNext;
                } else if (offset > offsetPrev && tz.moveInvalidForward) {
                    offset = offsetPrev;
                }

                if (target < untils[i] - (offset * 60000)) {
                    return offsets[i];
                }
            }

            return offsets[max];
        },

        abbr : function (mom) {
            return this.abbrs[this._index(mom)];
        },

        offset : function (mom) {
            return this.offsets[this._index(mom)];
        }
    };

    /************************************
        Current Timezone
    ************************************/

    function OffsetAt(at) {
        var timeString = at.toTimeString();
        var abbr = timeString.match(/\([a-z ]+\)/i);
        if (abbr && abbr[0]) {
            // 17:56:31 GMT-0600 (CST)
            // 17:56:31 GMT-0600 (Central Standard Time)
            abbr = abbr[0].match(/[A-Z]/g);
            abbr = abbr ? abbr.join('') : undefined;
        } else {
            // 17:56:31 CST
            // 17:56:31 GMT+0800 (台北標準時間)
            abbr = timeString.match(/[A-Z]{3,5}/g);
            abbr = abbr ? abbr[0] : undefined;
        }

        if (abbr === 'GMT') {
            abbr = undefined;
        }

        this.at = +at;
        this.abbr = abbr;
        this.offset = at.getTimezoneOffset();
    }

    function ZoneScore(zone) {
        this.zone = zone;
        this.offsetScore = 0;
        this.abbrScore = 0;
    }

    ZoneScore.prototype.scoreOffsetAt = function (offsetAt) {
        this.offsetScore += Math.abs(this.zone.offset(offsetAt.at) - offsetAt.offset);
        if (this.zone.abbr(offsetAt.at).replace(/[^A-Z]/g, '') !== offsetAt.abbr) {
            this.abbrScore++;
        }
    };

    function findChange(low, high) {
        var mid, diff;

        while ((diff = ((high.at - low.at) / 12e4 | 0) * 6e4)) {
            mid = new OffsetAt(new Date(low.at + diff));
            if (mid.offset === low.offset) {
                low = mid;
            } else {
                high = mid;
            }
        }

        return low;
    }

    function userOffsets() {
        var startYear = new Date().getFullYear() - 2,
            last = new OffsetAt(new Date(startYear, 0, 1)),
            offsets = [last],
            change, next, i;

        for (i = 1; i < 48; i++) {
            next = new OffsetAt(new Date(startYear, i, 1));
            if (next.offset !== last.offset) {
                change = findChange(last, next);
                offsets.push(change);
                offsets.push(new OffsetAt(new Date(change.at + 6e4)));
            }
            last = next;
        }

        for (i = 0; i < 4; i++) {
            offsets.push(new OffsetAt(new Date(startYear + i, 0, 1)));
            offsets.push(new OffsetAt(new Date(startYear + i, 6, 1)));
        }

        return offsets;
    }

    function sortZoneScores (a, b) {
        if (a.offsetScore !== b.offsetScore) {
            return a.offsetScore - b.offsetScore;
        }
        if (a.abbrScore !== b.abbrScore) {
            return a.abbrScore - b.abbrScore;
        }
        return b.zone.population - a.zone.population;
    }

    function addToGuesses (name, offsets) {
        var i, offset;
        arrayToInt(offsets);
        for (i = 0; i < offsets.length; i++) {
            offset = offsets[i];
            guesses[offset] = guesses[offset] || {};
            guesses[offset][name] = true;
        }
    }

    function guessesForUserOffsets (offsets) {
        var offsetsLength = offsets.length,
            filteredGuesses = {},
            out = [],
            i, j, guessesOffset;

        for (i = 0; i < offsetsLength; i++) {
            guessesOffset = guesses[offsets[i].offset] || {};
            for (j in guessesOffset) {
                if (guessesOffset.hasOwnProperty(j)) {
                    filteredGuesses[j] = true;
                }
            }
        }

        for (i in filteredGuesses) {
            if (filteredGuesses.hasOwnProperty(i)) {
                out.push(names[i]);
            }
        }

        return out;
    }

    function rebuildGuess () {

        // use Intl API when available and returning valid time zone
        try {
            var intlName = Intl.DateTimeFormat().resolvedOptions().timeZone;
            if (intlName){
                var name = names[normalizeName(intlName)];
                if (name) {
                    return name;
                }
                logError("Moment Timezone found " + intlName + " from the Intl api, but did not have that data loaded.");
            }
        } catch (e) {
            // Intl unavailable, fall back to manual guessing.
        }

        var offsets = userOffsets(),
            offsetsLength = offsets.length,
            guesses = guessesForUserOffsets(offsets),
            zoneScores = [],
            zoneScore, i, j;

        for (i = 0; i < guesses.length; i++) {
            zoneScore = new ZoneScore(getZone(guesses[i]), offsetsLength);
            for (j = 0; j < offsetsLength; j++) {
                zoneScore.scoreOffsetAt(offsets[j]);
            }
            zoneScores.push(zoneScore);
        }

        zoneScores.sort(sortZoneScores);

        return zoneScores.length > 0 ? zoneScores[0].zone.name : undefined;
    }

    function guess (ignoreCache) {
        if (!cachedGuess || ignoreCache) {
            cachedGuess = rebuildGuess();
        }
        return cachedGuess;
    }

    /************************************
        Global Methods
    ************************************/

    function normalizeName (name) {
        return (name || '').toLowerCase().replace(/\//g, '_');
    }

    function addZone (packed) {
        var i, name, split, normalized;

        if (typeof packed === "string") {
            packed = [packed];
        }

        for (i = 0; i < packed.length; i++) {
            split = packed[i].split('|');
            name = split[0];
            normalized = normalizeName(name);
            zones[normalized] = packed[i];
            names[normalized] = name;
            if (split[5]) {
                addToGuesses(normalized, split[2].split(' '));
            }
        }
    }

    function getZone (name, caller) {
        name = normalizeName(name);

        var zone = zones[name];
        var link;

        if (zone instanceof Zone) {
            return zone;
        }

        if (typeof zone === 'string') {
            zone = new Zone(zone);
            zones[name] = zone;
            return zone;
        }

        // Pass getZone to prevent recursion more than 1 level deep
        if (links[name] && caller !== getZone && (link = getZone(links[name], getZone))) {
            zone = zones[name] = new Zone();
            zone._set(link);
            zone.name = names[name];
            return zone;
        }

        return null;
    }

    function getNames () {
        var i, out = [];

        for (i in names) {
            if (names.hasOwnProperty(i) && (zones[i] || zones[links[i]]) && names[i]) {
                out.push(names[i]);
            }
        }

        return out.sort();
    }

    function addLink (aliases) {
        var i, alias, normal0, normal1;

        if (typeof aliases === "string") {
            aliases = [aliases];
        }

        for (i = 0; i < aliases.length; i++) {
            alias = aliases[i].split('|');

            normal0 = normalizeName(alias[0]);
            normal1 = normalizeName(alias[1]);

            links[normal0] = normal1;
            names[normal0] = alias[0];

            links[normal1] = normal0;
            names[normal1] = alias[1];
        }
    }

    function loadData (data) {
        addZone(data.zones);
        addLink(data.links);
        tz.dataVersion = data.version;
    }

    function zoneExists (name) {
        if (!zoneExists.didShowError) {
            zoneExists.didShowError = true;
                logError("moment.tz.zoneExists('" + name + "') has been deprecated in favor of !moment.tz.zone('" + name + "')");
        }
        return !!getZone(name);
    }

    function needsOffset (m) {
        return !!(m._a && (m._tzm === undefined));
    }

    function logError (message) {
        if (typeof console !== 'undefined' && typeof console.error === 'function') {
            console.error(message);
        }
    }

    /************************************
        moment.tz namespace
    ************************************/

    function tz (input) {
        var args = Array.prototype.slice.call(arguments, 0, -1),
            name = arguments[arguments.length - 1],
            zone = getZone(name),
            out  = moment.utc.apply(null, args);

        if (zone && !moment.isMoment(input) && needsOffset(out)) {
            out.add(zone.parse(out), 'minutes');
        }

        out.tz(name);

        return out;
    }

    tz.version      = VERSION;
    tz.dataVersion  = '';
    tz._zones       = zones;
    tz._links       = links;
    tz._names       = names;
    tz.add          = addZone;
    tz.link         = addLink;
    tz.load         = loadData;
    tz.zone         = getZone;
    tz.zoneExists   = zoneExists; // deprecated in 0.1.0
    tz.guess        = guess;
    tz.names        = getNames;
    tz.Zone         = Zone;
    tz.unpack       = unpack;
    tz.unpackBase60 = unpackBase60;
    tz.needsOffset  = needsOffset;
    tz.moveInvalidForward   = true;
    tz.moveAmbiguousForward = false;

    /************************************
        Interface with Moment.js
    ************************************/

    var fn = moment.fn;

    moment.tz = tz;

    moment.defaultZone = null;

    moment.updateOffset = function (mom, keepTime) {
        var zone = moment.defaultZone,
            offset;

        if (mom._z === undefined) {
            if (zone && needsOffset(mom) && !mom._isUTC) {
                mom._d = moment.utc(mom._a)._d;
                mom.utc().add(zone.parse(mom), 'minutes');
            }
            mom._z = zone;
        }
        if (mom._z) {
            offset = mom._z.offset(mom);
            if (Math.abs(offset) < 16) {
                offset = offset / 60;
            }
            if (mom.utcOffset !== undefined) {
                mom.utcOffset(-offset, keepTime);
            } else {
                mom.zone(offset, keepTime);
            }
        }
    };

    fn.tz = function (name) {
        if (name) {
            this._z = getZone(name);
            if (this._z) {
                moment.updateOffset(this);
            } else {
                logError("Moment Timezone has no data for " + name + ". See http://momentjs.com/timezone/docs/#/data-loading/.");
            }
            return this;
        }
        if (this._z) { return this._z.name; }
    };

    function abbrWrap (old) {
        return function () {
            if (this._z) { return this._z.abbr(this); }
            return old.call(this);
        };
    }

    function resetZoneWrap (old) {
        return function () {
            this._z = null;
            return old.apply(this, arguments);
        };
    }

    fn.zoneName = abbrWrap(fn.zoneName);
    fn.zoneAbbr = abbrWrap(fn.zoneAbbr);
    fn.utc      = resetZoneWrap(fn.utc);

    moment.tz.setDefault = function(name) {
        if (major < 2 || (major === 2 && minor < 9)) {
            logError('Moment Timezone setDefault() requires Moment.js >= 2.9.0. You are using Moment.js ' + moment.version + '.');
        }
        moment.defaultZone = name ? getZone(name) : null;
        return moment;
    };

    // Cloning a moment should include the _z property.
    var momentProperties = moment.momentProperties;
    if (Object.prototype.toString.call(momentProperties) === '[object Array]') {
        // moment 2.8.1+
        momentProperties.push('_z');
        momentProperties.push('_a');
    } else if (momentProperties) {
        // moment 2.7.0
        momentProperties._z = null;
    }

    loadData({
        "version": "2017b",
        "zones": [
            "Africa/Abidjan|GMT|0|0||48e5",
            "Africa/Khartoum|EAT|-30|0||51e5",
            "Africa/Algiers|CET|-10|0||26e5",
            "Africa/Lagos|WAT|-10|0||17e6",
            "Africa/Maputo|CAT|-20|0||26e5",
            "Africa/Cairo|EET EEST|-20 -30|01010|1M2m0 gL0 e10 mn0|15e6",
            "Africa/Casablanca|WET WEST|0 -10|0101010101010101010101010101010101010101010|1H3C0 wM0 co0 go0 1o00 s00 dA0 vc0 11A0 A00 e00 y00 11A0 uM0 e00 Dc0 11A0 s00 e00 IM0 WM0 mo0 gM0 LA0 WM0 jA0 e00 Rc0 11A0 e00 e00 U00 11A0 8o0 e00 11A0 11A0 5A0 e00 17c0 1fA0 1a00|32e5",
            "Europe/Paris|CET CEST|-10 -20|01010101010101010101010|1GNB0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0|11e6",
            "Africa/Johannesburg|SAST|-20|0||84e5",
            "Africa/Tripoli|EET CET CEST|-20 -10 -20|0120|1IlA0 TA0 1o00|11e5",
            "Africa/Windhoek|WAST WAT|-20 -10|01010101010101010101010|1GQo0 11B0 1qL0 WN0 1qL0 11B0 1nX0 11B0 1nX0 11B0 1nX0 11B0 1nX0 11B0 1qL0 WN0 1qL0 11B0 1nX0 11B0 1nX0 11B0|32e4",
            "America/Adak|HST HDT|a0 90|01010101010101010101010|1GIc0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0|326",
            "America/Anchorage|AKST AKDT|90 80|01010101010101010101010|1GIb0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0|30e4",
            "America/Santo_Domingo|AST|40|0||29e5",
            "America/Araguaina|-03 -02|30 20|010|1IdD0 Lz0|14e4",
            "America/Fortaleza|-03|30|0||34e5",
            "America/Asuncion|-03 -04|30 40|01010101010101010101010|1GTf0 1cN0 17b0 1ip0 17b0 1ip0 17b0 1ip0 19X0 1fB0 19X0 1fB0 19X0 1ip0 17b0 1ip0 17b0 1ip0 19X0 1fB0 19X0 1fB0|28e5",
            "America/Panama|EST|50|0||15e5",
            "America/Bahia|-02 -03|20 30|01|1GCq0|27e5",
            "America/Mexico_City|CST CDT|60 50|01010101010101010101010|1GQw0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0|20e6",
            "America/Managua|CST|60|0||22e5",
            "America/La_Paz|-04|40|0||19e5",
            "America/Lima|-05|50|0||11e6",
            "America/Denver|MST MDT|70 60|01010101010101010101010|1GI90 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0|26e5",
            "America/Campo_Grande|-03 -04|30 40|01010101010101010101010|1GCr0 1zd0 Lz0 1C10 Lz0 1C10 On0 1zd0 On0 1zd0 On0 1zd0 On0 1C10 Lz0 1C10 Lz0 1C10 On0 1zd0 On0 1zd0|77e4",
            "America/Cancun|CST CDT EST|60 50 50|01010102|1GQw0 1nX0 14p0 1lb0 14p0 1lb0 Dd0|63e4",
            "America/Caracas|-0430 -04|4u 40|01|1QMT0|29e5",
            "America/Chicago|CST CDT|60 50|01010101010101010101010|1GI80 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0|92e5",
            "America/Chihuahua|MST MDT|70 60|01010101010101010101010|1GQx0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0 11B0 1nX0 14p0 1lb0 14p0 1lb0 14p0 1nX0 11B0 1nX0|81e4",
            "America/Phoenix|MST|70|0||42e5",
            "America/Los_Angeles|PST PDT|80 70|01010101010101010101010|1GIa0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0|15e6",
            "America/New_York|EST EDT|50 40|01010101010101010101010|1GI70 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0|21e6",
            "America/Rio_Branco|-04 -05|40 50|01|1KLE0|31e4",
            "America/Fort_Nelson|PST PDT MST|80 70 70|01010102|1GIa0 1zb0 Op0 1zb0 Op0 1zb0 Op0|39e2",
            "America/Halifax|AST ADT|40 30|01010101010101010101010|1GI60 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0|39e4",
            "America/Godthab|-03 -02|30 20|01010101010101010101010|1GNB0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0|17e3",
            "America/Grand_Turk|EST EDT AST|50 40 40|010101012|1GI70 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0|37e2",
            "America/Havana|CST CDT|50 40|01010101010101010101010|1GQt0 1qM0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Rc0 1zc0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Oo0 1zc0 Rc0 1zc0 Oo0 1zc0|21e5",
            "America/Metlakatla|PST AKST AKDT|80 90 80|0121212121212121|1PAa0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0|14e2",
            "America/Miquelon|-03 -02|30 20|01010101010101010101010|1GI50 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0|61e2",
            "America/Montevideo|-02 -03|20 30|01010101|1GI40 1o10 11z0 1o10 11z0 1o10 11z0|17e5",
            "America/Noronha|-02|20|0||30e2",
            "America/Port-au-Prince|EST EDT|50 40|010101010101010101010|1GI70 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 3iN0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0|23e5",
            "Antarctica/Palmer|-03 -04|30 40|010101010|1H3D0 Op0 1zb0 Rd0 1wn0 Rd0 46n0 Ap0|40",
            "America/Santiago|-03 -04|30 40|010101010101010101010|1H3D0 Op0 1zb0 Rd0 1wn0 Rd0 46n0 Ap0 1Nb0 Ap0 1Nb0 Ap0 1Nb0 Ap0 1Nb0 Ap0 1Nb0 Dd0 1Nb0 Ap0|62e5",
            "America/Sao_Paulo|-02 -03|20 30|01010101010101010101010|1GCq0 1zd0 Lz0 1C10 Lz0 1C10 On0 1zd0 On0 1zd0 On0 1zd0 On0 1C10 Lz0 1C10 Lz0 1C10 On0 1zd0 On0 1zd0|20e6",
            "Atlantic/Azores|-01 +00|10 0|01010101010101010101010|1GNB0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0|25e4",
            "America/St_Johns|NST NDT|3u 2u|01010101010101010101010|1GI5u 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Op0 1zb0 Rd0 1zb0 Op0 1zb0|11e4",
            "Antarctica/Casey|+11 +08|-b0 -80|010|1GAF0 blz0|10",
            "Antarctica/Davis|+05 +07|-50 -70|01|1GAI0|70",
            "Pacific/Port_Moresby|+10|-a0|0||25e4",
            "Pacific/Guadalcanal|+11|-b0|0||11e4",
            "Asia/Tashkent|+05|-50|0||23e5",
            "Pacific/Auckland|NZDT NZST|-d0 -c0|01010101010101010101010|1GQe0 1cM0 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1cM0 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1a00|14e5",
            "Asia/Baghdad|+03|-30|0||66e5",
            "Antarctica/Troll|+00 +02|0 -20|01010101010101010101010|1GNB0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0|40",
            "Asia/Dhaka|+06|-60|0||16e6",
            "Asia/Amman|EET EEST|-20 -30|010101010101010101010|1GPy0 4bX0 Dd0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 11A0 1o00|25e5",
            "Asia/Kamchatka|+12|-c0|0||18e4",
            "Asia/Baku|+04 +05|-40 -50|010101010|1GNA0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00|27e5",
            "Asia/Bangkok|+07|-70|0||15e6",
            "Asia/Barnaul|+07 +06|-70 -60|010|1N7v0 3rd0",
            "Asia/Beirut|EET EEST|-20 -30|01010101010101010101010|1GNy0 1qL0 11B0 1nX0 11B0 1nX0 11B0 1nX0 11B0 1qL0 WN0 1qL0 WN0 1qL0 11B0 1nX0 11B0 1nX0 11B0 1qL0 WN0 1qL0|22e5",
            "Asia/Manila|+08|-80|0||24e6",
            "Asia/Kolkata|IST|-5u|0||15e6",
            "Asia/Chita|+10 +08 +09|-a0 -80 -90|012|1N7s0 3re0|33e4",
            "Asia/Ulaanbaatar|+08 +09|-80 -90|01010|1O8G0 1cJ0 1cP0 1cJ0|12e5",
            "Asia/Shanghai|CST|-80|0||23e6",
            "Asia/Colombo|+0530|-5u|0||22e5",
            "Asia/Damascus|EET EEST|-20 -30|01010101010101010101010|1GPy0 1nX0 11B0 1nX0 11B0 1qL0 WN0 1qL0 WN0 1qL0 11B0 1nX0 11B0 1nX0 11B0 1nX0 11B0 1qL0 WN0 1qL0 WN0 1qL0|26e5",
            "Asia/Dili|+09|-90|0||19e4",
            "Asia/Dubai|+04|-40|0||39e5",
            "Asia/Famagusta|EET EEST +03|-20 -30 -30|01010101012|1GNB0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 15U0",
            "Asia/Gaza|EET EEST|-20 -30|01010101010101010101010|1GPy0 1a00 1fA0 1cL0 1cN0 1nX0 1210 1nz0 1220 1qL0 WN0 1qL0 11B0 1nX0 11B0 1nX0 11B0 1qL0 WN0 1qL0 WN0 1qL0|18e5",
            "Asia/Hong_Kong|HKT|-80|0||73e5",
            "Asia/Hovd|+07 +08|-70 -80|01010|1O8H0 1cJ0 1cP0 1cJ0|81e3",
            "Asia/Irkutsk|+09 +08|-90 -80|01|1N7t0|60e4",
            "Europe/Istanbul|EET EEST +03|-20 -30 -30|01010101012|1GNB0 1qM0 11A0 1o00 1200 1nA0 11A0 1tA0 U00 15w0|13e6",
            "Asia/Jakarta|WIB|-70|0||31e6",
            "Asia/Jayapura|WIT|-90|0||26e4",
            "Asia/Jerusalem|IST IDT|-20 -30|01010101010101010101010|1GPA0 1aL0 1eN0 1oL0 10N0 1oL0 10N0 1oL0 10N0 1rz0 W10 1rz0 W10 1rz0 10N0 1oL0 10N0 1oL0 10N0 1rz0 W10 1rz0|81e4",
            "Asia/Kabul|+0430|-4u|0||46e5",
            "Asia/Karachi|PKT|-50|0||24e6",
            "Asia/Kathmandu|+0545|-5J|0||12e5",
            "Asia/Yakutsk|+10 +09|-a0 -90|01|1N7s0|28e4",
            "Asia/Krasnoyarsk|+08 +07|-80 -70|01|1N7u0|10e5",
            "Asia/Magadan|+12 +10 +11|-c0 -a0 -b0|012|1N7q0 3Cq0|95e3",
            "Asia/Makassar|WITA|-80|0||15e5",
            "Europe/Athens|EET EEST|-20 -30|01010101010101010101010|1GNB0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0|35e5",
            "Asia/Novosibirsk|+07 +06|-70 -60|010|1N7v0 4eN0|15e5",
            "Asia/Omsk|+07 +06|-70 -60|01|1N7v0|12e5",
            "Asia/Pyongyang|KST KST|-90 -8u|01|1P4D0|29e5",
            "Asia/Rangoon|+0630|-6u|0||48e5",
            "Asia/Sakhalin|+11 +10|-b0 -a0|010|1N7r0 3rd0|58e4",
            "Asia/Seoul|KST|-90|0||23e6",
            "Asia/Srednekolymsk|+12 +11|-c0 -b0|01|1N7q0|35e2",
            "Asia/Tehran|+0330 +0430|-3u -4u|01010101010101010101010|1GLUu 1dz0 1cN0 1dz0 1cp0 1dz0 1cp0 1dz0 1cp0 1dz0 1cN0 1dz0 1cp0 1dz0 1cp0 1dz0 1cp0 1dz0 1cN0 1dz0 1cp0 1dz0|14e6",
            "Asia/Tokyo|JST|-90|0||38e6",
            "Asia/Tomsk|+07 +06|-70 -60|010|1N7v0 3Qp0|10e5",
            "Asia/Vladivostok|+11 +10|-b0 -a0|01|1N7r0|60e4",
            "Asia/Yekaterinburg|+06 +05|-60 -50|01|1N7w0|14e5",
            "Europe/Lisbon|WET WEST|0 -10|01010101010101010101010|1GNB0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0|27e5",
            "Atlantic/Cape_Verde|-01|10|0||50e4",
            "Australia/Sydney|AEDT AEST|-b0 -a0|01010101010101010101010|1GQg0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0|40e5",
            "Australia/Adelaide|ACDT ACST|-au -9u|01010101010101010101010|1GQgu 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1fA0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0 1cM0|11e5",
            "Australia/Brisbane|AEST|-a0|0||20e5",
            "Australia/Darwin|ACST|-9u|0||12e4",
            "Australia/Eucla|+0845|-8J|0||368",
            "Australia/Lord_Howe|+11 +1030|-b0 -au|01010101010101010101010|1GQf0 1fAu 1cLu 1cMu 1cLu 1cMu 1cLu 1cMu 1cLu 1cMu 1cLu 1cMu 1cLu 1fAu 1cLu 1cMu 1cLu 1cMu 1cLu 1cMu 1cLu 1cMu|347",
            "Australia/Perth|AWST|-80|0||18e5",
            "Pacific/Easter|-05 -06|50 60|010101010101010101010|1H3D0 Op0 1zb0 Rd0 1wn0 Rd0 46n0 Ap0 1Nb0 Ap0 1Nb0 Ap0 1Nb0 Ap0 1Nb0 Ap0 1Nb0 Dd0 1Nb0 Ap0|30e2",
            "Europe/Dublin|GMT IST|0 -10|01010101010101010101010|1GNB0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0|12e5",
            "Pacific/Tahiti|-10|a0|0||18e4",
            "Pacific/Niue|-11|b0|0||12e2",
            "Etc/GMT+12|-12|c0|0|",
            "Pacific/Galapagos|-06|60|0||25e3",
            "Etc/GMT+7|-07|70|0|",
            "Pacific/Pitcairn|-08|80|0||56",
            "Pacific/Gambier|-09|90|0||125",
            "Etc/GMT-1|+01|-10|0|",
            "Pacific/Fakaofo|+13|-d0|0||483",
            "Pacific/Kiritimati|+14|-e0|0||51e2",
            "Etc/GMT-2|+02|-20|0|",
            "Etc/UCT|UCT|0|0|",
            "Etc/UTC|UTC|0|0|",
            "Europe/Astrakhan|+04 +03|-40 -30|010|1N7y0 3rd0",
            "Europe/London|GMT BST|0 -10|01010101010101010101010|1GNB0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0|10e6",
            "Europe/Chisinau|EET EEST|-20 -30|01010101010101010101010|1GNA0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0|67e4",
            "Europe/Kaliningrad|+03 EET|-30 -20|01|1N7z0|44e4",
            "Europe/Volgograd|+04 +03|-40 -30|01|1N7y0|10e5",
            "Europe/Moscow|MSK MSK|-40 -30|01|1N7y0|16e6",
            "Europe/Saratov|+04 +03|-40 -30|010|1N7y0 5810",
            "Europe/Simferopol|EET EEST MSK MSK|-20 -30 -40 -30|0101023|1GNB0 1qM0 11A0 1o00 11z0 1nW0|33e4",
            "Pacific/Honolulu|HST|a0|0||37e4",
            "MET|MET MEST|-10 -20|01010101010101010101010|1GNB0 1qM0 11A0 1o00 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0 WM0 1qM0 11A0 1o00 11A0 1o00 11A0 1qM0 WM0 1qM0",
            "Pacific/Chatham|+1345 +1245|-dJ -cJ|01010101010101010101010|1GQe0 1cM0 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1cM0 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1a00|600",
            "Pacific/Apia|+14 +13|-e0 -d0|01010101010101010101010|1GQe0 1cM0 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1cM0 1fA0 1a00 1fA0 1a00 1fA0 1a00 1fA0 1a00|37e3",
            "Pacific/Bougainville|+10 +11|-a0 -b0|01|1NwE0|18e4",
            "Pacific/Fiji|+13 +12|-d0 -c0|01010101010101010101010|1Goe0 1Nc0 Ao0 1Q00 xz0 1SN0 uM0 1SM0 uM0 1VA0 s00 1VA0 uM0 1SM0 uM0 1SM0 uM0 1SM0 uM0 1VA0 s00 1VA0|88e4",
            "Pacific/Guam|ChST|-a0|0||17e4",
            "Pacific/Marquesas|-0930|9u|0||86e2",
            "Pacific/Pago_Pago|SST|b0|0||37e2",
            "Pacific/Norfolk|+1130 +11|-bu -b0|01|1PoCu|25e4",
            "Pacific/Tongatapu|+13 +14|-d0 -e0|01010101010101|1S4d0 s00 1VA0 uM0 1SM0 uM0 1SM0 uM0 1SM0 uM0 1VA0 s00 1VA0|75e3"
        ],
        "links": [
            "Africa/Abidjan|Africa/Accra",
            "Africa/Abidjan|Africa/Bamako",
            "Africa/Abidjan|Africa/Banjul",
            "Africa/Abidjan|Africa/Bissau",
            "Africa/Abidjan|Africa/Conakry",
            "Africa/Abidjan|Africa/Dakar",
            "Africa/Abidjan|Africa/Freetown",
            "Africa/Abidjan|Africa/Lome",
            "Africa/Abidjan|Africa/Monrovia",
            "Africa/Abidjan|Africa/Nouakchott",
            "Africa/Abidjan|Africa/Ouagadougou",
            "Africa/Abidjan|Africa/Sao_Tome",
            "Africa/Abidjan|Africa/Timbuktu",
            "Africa/Abidjan|America/Danmarkshavn",
            "Africa/Abidjan|Atlantic/Reykjavik",
            "Africa/Abidjan|Atlantic/St_Helena",
            "Africa/Abidjan|Etc/GMT",
            "Africa/Abidjan|Etc/GMT+0",
            "Africa/Abidjan|Etc/GMT-0",
            "Africa/Abidjan|Etc/GMT0",
            "Africa/Abidjan|Etc/Greenwich",
            "Africa/Abidjan|GMT",
            "Africa/Abidjan|GMT+0",
            "Africa/Abidjan|GMT-0",
            "Africa/Abidjan|GMT0",
            "Africa/Abidjan|Greenwich",
            "Africa/Abidjan|Iceland",
            "Africa/Algiers|Africa/Tunis",
            "Africa/Cairo|Egypt",
            "Africa/Casablanca|Africa/El_Aaiun",
            "Africa/Johannesburg|Africa/Maseru",
            "Africa/Johannesburg|Africa/Mbabane",
            "Africa/Khartoum|Africa/Addis_Ababa",
            "Africa/Khartoum|Africa/Asmara",
            "Africa/Khartoum|Africa/Asmera",
            "Africa/Khartoum|Africa/Dar_es_Salaam",
            "Africa/Khartoum|Africa/Djibouti",
            "Africa/Khartoum|Africa/Juba",
            "Africa/Khartoum|Africa/Kampala",
            "Africa/Khartoum|Africa/Mogadishu",
            "Africa/Khartoum|Africa/Nairobi",
            "Africa/Khartoum|Indian/Antananarivo",
            "Africa/Khartoum|Indian/Comoro",
            "Africa/Khartoum|Indian/Mayotte",
            "Africa/Lagos|Africa/Bangui",
            "Africa/Lagos|Africa/Brazzaville",
            "Africa/Lagos|Africa/Douala",
            "Africa/Lagos|Africa/Kinshasa",
            "Africa/Lagos|Africa/Libreville",
            "Africa/Lagos|Africa/Luanda",
            "Africa/Lagos|Africa/Malabo",
            "Africa/Lagos|Africa/Ndjamena",
            "Africa/Lagos|Africa/Niamey",
            "Africa/Lagos|Africa/Porto-Novo",
            "Africa/Maputo|Africa/Blantyre",
            "Africa/Maputo|Africa/Bujumbura",
            "Africa/Maputo|Africa/Gaborone",
            "Africa/Maputo|Africa/Harare",
            "Africa/Maputo|Africa/Kigali",
            "Africa/Maputo|Africa/Lubumbashi",
            "Africa/Maputo|Africa/Lusaka",
            "Africa/Tripoli|Libya",
            "America/Adak|America/Atka",
            "America/Adak|US/Aleutian",
            "America/Anchorage|America/Juneau",
            "America/Anchorage|America/Nome",
            "America/Anchorage|America/Sitka",
            "America/Anchorage|America/Yakutat",
            "America/Anchorage|US/Alaska",
            "America/Campo_Grande|America/Cuiaba",
            "America/Chicago|America/Indiana/Knox",
            "America/Chicago|America/Indiana/Tell_City",
            "America/Chicago|America/Knox_IN",
            "America/Chicago|America/Matamoros",
            "America/Chicago|America/Menominee",
            "America/Chicago|America/North_Dakota/Beulah",
            "America/Chicago|America/North_Dakota/Center",
            "America/Chicago|America/North_Dakota/New_Salem",
            "America/Chicago|America/Rainy_River",
            "America/Chicago|America/Rankin_Inlet",
            "America/Chicago|America/Resolute",
            "America/Chicago|America/Winnipeg",
            "America/Chicago|CST6CDT",
            "America/Chicago|Canada/Central",
            "America/Chicago|US/Central",
            "America/Chicago|US/Indiana-Starke",
            "America/Chihuahua|America/Mazatlan",
            "America/Chihuahua|Mexico/BajaSur",
            "America/Denver|America/Boise",
            "America/Denver|America/Cambridge_Bay",
            "America/Denver|America/Edmonton",
            "America/Denver|America/Inuvik",
            "America/Denver|America/Ojinaga",
            "America/Denver|America/Shiprock",
            "America/Denver|America/Yellowknife",
            "America/Denver|Canada/Mountain",
            "America/Denver|MST7MDT",
            "America/Denver|Navajo",
            "America/Denver|US/Mountain",
            "America/Fortaleza|America/Argentina/Buenos_Aires",
            "America/Fortaleza|America/Argentina/Catamarca",
            "America/Fortaleza|America/Argentina/ComodRivadavia",
            "America/Fortaleza|America/Argentina/Cordoba",
            "America/Fortaleza|America/Argentina/Jujuy",
            "America/Fortaleza|America/Argentina/La_Rioja",
            "America/Fortaleza|America/Argentina/Mendoza",
            "America/Fortaleza|America/Argentina/Rio_Gallegos",
            "America/Fortaleza|America/Argentina/Salta",
            "America/Fortaleza|America/Argentina/San_Juan",
            "America/Fortaleza|America/Argentina/San_Luis",
            "America/Fortaleza|America/Argentina/Tucuman",
            "America/Fortaleza|America/Argentina/Ushuaia",
            "America/Fortaleza|America/Belem",
            "America/Fortaleza|America/Buenos_Aires",
            "America/Fortaleza|America/Catamarca",
            "America/Fortaleza|America/Cayenne",
            "America/Fortaleza|America/Cordoba",
            "America/Fortaleza|America/Jujuy",
            "America/Fortaleza|America/Maceio",
            "America/Fortaleza|America/Mendoza",
            "America/Fortaleza|America/Paramaribo",
            "America/Fortaleza|America/Recife",
            "America/Fortaleza|America/Rosario",
            "America/Fortaleza|America/Santarem",
            "America/Fortaleza|Antarctica/Rothera",
            "America/Fortaleza|Atlantic/Stanley",
            "America/Fortaleza|Etc/GMT+3",
            "America/Halifax|America/Glace_Bay",
            "America/Halifax|America/Goose_Bay",
            "America/Halifax|America/Moncton",
            "America/Halifax|America/Thule",
            "America/Halifax|Atlantic/Bermuda",
            "America/Halifax|Canada/Atlantic",
            "America/Havana|Cuba",
            "America/La_Paz|America/Boa_Vista",
            "America/La_Paz|America/Guyana",
            "America/La_Paz|America/Manaus",
            "America/La_Paz|America/Porto_Velho",
            "America/La_Paz|Brazil/West",
            "America/La_Paz|Etc/GMT+4",
            "America/Lima|America/Bogota",
            "America/Lima|America/Guayaquil",
            "America/Lima|Etc/GMT+5",
            "America/Los_Angeles|America/Dawson",
            "America/Los_Angeles|America/Ensenada",
            "America/Los_Angeles|America/Santa_Isabel",
            "America/Los_Angeles|America/Tijuana",
            "America/Los_Angeles|America/Vancouver",
            "America/Los_Angeles|America/Whitehorse",
            "America/Los_Angeles|Canada/Pacific",
            "America/Los_Angeles|Canada/Yukon",
            "America/Los_Angeles|Mexico/BajaNorte",
            "America/Los_Angeles|PST8PDT",
            "America/Los_Angeles|US/Pacific",
            "America/Los_Angeles|US/Pacific-New",
            "America/Managua|America/Belize",
            "America/Managua|America/Costa_Rica",
            "America/Managua|America/El_Salvador",
            "America/Managua|America/Guatemala",
            "America/Managua|America/Regina",
            "America/Managua|America/Swift_Current",
            "America/Managua|America/Tegucigalpa",
            "America/Managua|Canada/East-Saskatchewan",
            "America/Managua|Canada/Saskatchewan",
            "America/Mexico_City|America/Bahia_Banderas",
            "America/Mexico_City|America/Merida",
            "America/Mexico_City|America/Monterrey",
            "America/Mexico_City|Mexico/General",
            "America/New_York|America/Detroit",
            "America/New_York|America/Fort_Wayne",
            "America/New_York|America/Indiana/Indianapolis",
            "America/New_York|America/Indiana/Marengo",
            "America/New_York|America/Indiana/Petersburg",
            "America/New_York|America/Indiana/Vevay",
            "America/New_York|America/Indiana/Vincennes",
            "America/New_York|America/Indiana/Winamac",
            "America/New_York|America/Indianapolis",
            "America/New_York|America/Iqaluit",
            "America/New_York|America/Kentucky/Louisville",
            "America/New_York|America/Kentucky/Monticello",
            "America/New_York|America/Louisville",
            "America/New_York|America/Montreal",
            "America/New_York|America/Nassau",
            "America/New_York|America/Nipigon",
            "America/New_York|America/Pangnirtung",
            "America/New_York|America/Thunder_Bay",
            "America/New_York|America/Toronto",
            "America/New_York|Canada/Eastern",
            "America/New_York|EST5EDT",
            "America/New_York|US/East-Indiana",
            "America/New_York|US/Eastern",
            "America/New_York|US/Michigan",
            "America/Noronha|Atlantic/South_Georgia",
            "America/Noronha|Brazil/DeNoronha",
            "America/Noronha|Etc/GMT+2",
            "America/Panama|America/Atikokan",
            "America/Panama|America/Cayman",
            "America/Panama|America/Coral_Harbour",
            "America/Panama|America/Jamaica",
            "America/Panama|EST",
            "America/Panama|Jamaica",
            "America/Phoenix|America/Creston",
            "America/Phoenix|America/Dawson_Creek",
            "America/Phoenix|America/Hermosillo",
            "America/Phoenix|MST",
            "America/Phoenix|US/Arizona",
            "America/Rio_Branco|America/Eirunepe",
            "America/Rio_Branco|America/Porto_Acre",
            "America/Rio_Branco|Brazil/Acre",
            "America/Santiago|Chile/Continental",
            "America/Santo_Domingo|America/Anguilla",
            "America/Santo_Domingo|America/Antigua",
            "America/Santo_Domingo|America/Aruba",
            "America/Santo_Domingo|America/Barbados",
            "America/Santo_Domingo|America/Blanc-Sablon",
            "America/Santo_Domingo|America/Curacao",
            "America/Santo_Domingo|America/Dominica",
            "America/Santo_Domingo|America/Grenada",
            "America/Santo_Domingo|America/Guadeloupe",
            "America/Santo_Domingo|America/Kralendijk",
            "America/Santo_Domingo|America/Lower_Princes",
            "America/Santo_Domingo|America/Marigot",
            "America/Santo_Domingo|America/Martinique",
            "America/Santo_Domingo|America/Montserrat",
            "America/Santo_Domingo|America/Port_of_Spain",
            "America/Santo_Domingo|America/Puerto_Rico",
            "America/Santo_Domingo|America/St_Barthelemy",
            "America/Santo_Domingo|America/St_Kitts",
            "America/Santo_Domingo|America/St_Lucia",
            "America/Santo_Domingo|America/St_Thomas",
            "America/Santo_Domingo|America/St_Vincent",
            "America/Santo_Domingo|America/Tortola",
            "America/Santo_Domingo|America/Virgin",
            "America/Sao_Paulo|Brazil/East",
            "America/St_Johns|Canada/Newfoundland",
            "Antarctica/Palmer|America/Punta_Arenas",
            "Asia/Baghdad|Antarctica/Syowa",
            "Asia/Baghdad|Asia/Aden",
            "Asia/Baghdad|Asia/Bahrain",
            "Asia/Baghdad|Asia/Kuwait",
            "Asia/Baghdad|Asia/Qatar",
            "Asia/Baghdad|Asia/Riyadh",
            "Asia/Baghdad|Etc/GMT-3",
            "Asia/Baghdad|Europe/Minsk",
            "Asia/Bangkok|Asia/Ho_Chi_Minh",
            "Asia/Bangkok|Asia/Novokuznetsk",
            "Asia/Bangkok|Asia/Phnom_Penh",
            "Asia/Bangkok|Asia/Saigon",
            "Asia/Bangkok|Asia/Vientiane",
            "Asia/Bangkok|Etc/GMT-7",
            "Asia/Bangkok|Indian/Christmas",
            "Asia/Dhaka|Antarctica/Vostok",
            "Asia/Dhaka|Asia/Almaty",
            "Asia/Dhaka|Asia/Bishkek",
            "Asia/Dhaka|Asia/Dacca",
            "Asia/Dhaka|Asia/Kashgar",
            "Asia/Dhaka|Asia/Qyzylorda",
            "Asia/Dhaka|Asia/Thimbu",
            "Asia/Dhaka|Asia/Thimphu",
            "Asia/Dhaka|Asia/Urumqi",
            "Asia/Dhaka|Etc/GMT-6",
            "Asia/Dhaka|Indian/Chagos",
            "Asia/Dili|Etc/GMT-9",
            "Asia/Dili|Pacific/Palau",
            "Asia/Dubai|Asia/Muscat",
            "Asia/Dubai|Asia/Tbilisi",
            "Asia/Dubai|Asia/Yerevan",
            "Asia/Dubai|Etc/GMT-4",
            "Asia/Dubai|Europe/Samara",
            "Asia/Dubai|Indian/Mahe",
            "Asia/Dubai|Indian/Mauritius",
            "Asia/Dubai|Indian/Reunion",
            "Asia/Gaza|Asia/Hebron",
            "Asia/Hong_Kong|Hongkong",
            "Asia/Jakarta|Asia/Pontianak",
            "Asia/Jerusalem|Asia/Tel_Aviv",
            "Asia/Jerusalem|Israel",
            "Asia/Kamchatka|Asia/Anadyr",
            "Asia/Kamchatka|Etc/GMT-12",
            "Asia/Kamchatka|Kwajalein",
            "Asia/Kamchatka|Pacific/Funafuti",
            "Asia/Kamchatka|Pacific/Kwajalein",
            "Asia/Kamchatka|Pacific/Majuro",
            "Asia/Kamchatka|Pacific/Nauru",
            "Asia/Kamchatka|Pacific/Tarawa",
            "Asia/Kamchatka|Pacific/Wake",
            "Asia/Kamchatka|Pacific/Wallis",
            "Asia/Kathmandu|Asia/Katmandu",
            "Asia/Kolkata|Asia/Calcutta",
            "Asia/Makassar|Asia/Ujung_Pandang",
            "Asia/Manila|Asia/Brunei",
            "Asia/Manila|Asia/Kuala_Lumpur",
            "Asia/Manila|Asia/Kuching",
            "Asia/Manila|Asia/Singapore",
            "Asia/Manila|Etc/GMT-8",
            "Asia/Manila|Singapore",
            "Asia/Rangoon|Asia/Yangon",
            "Asia/Rangoon|Indian/Cocos",
            "Asia/Seoul|ROK",
            "Asia/Shanghai|Asia/Chongqing",
            "Asia/Shanghai|Asia/Chungking",
            "Asia/Shanghai|Asia/Harbin",
            "Asia/Shanghai|Asia/Macao",
            "Asia/Shanghai|Asia/Macau",
            "Asia/Shanghai|Asia/Taipei",
            "Asia/Shanghai|PRC",
            "Asia/Shanghai|ROC",
            "Asia/Tashkent|Antarctica/Mawson",
            "Asia/Tashkent|Asia/Aqtau",
            "Asia/Tashkent|Asia/Aqtobe",
            "Asia/Tashkent|Asia/Ashgabat",
            "Asia/Tashkent|Asia/Ashkhabad",
            "Asia/Tashkent|Asia/Atyrau",
            "Asia/Tashkent|Asia/Dushanbe",
            "Asia/Tashkent|Asia/Oral",
            "Asia/Tashkent|Asia/Samarkand",
            "Asia/Tashkent|Etc/GMT-5",
            "Asia/Tashkent|Indian/Kerguelen",
            "Asia/Tashkent|Indian/Maldives",
            "Asia/Tehran|Iran",
            "Asia/Tokyo|Japan",
            "Asia/Ulaanbaatar|Asia/Choibalsan",
            "Asia/Ulaanbaatar|Asia/Ulan_Bator",
            "Asia/Vladivostok|Asia/Ust-Nera",
            "Asia/Yakutsk|Asia/Khandyga",
            "Atlantic/Azores|America/Scoresbysund",
            "Atlantic/Cape_Verde|Etc/GMT+1",
            "Australia/Adelaide|Australia/Broken_Hill",
            "Australia/Adelaide|Australia/South",
            "Australia/Adelaide|Australia/Yancowinna",
            "Australia/Brisbane|Australia/Lindeman",
            "Australia/Brisbane|Australia/Queensland",
            "Australia/Darwin|Australia/North",
            "Australia/Lord_Howe|Australia/LHI",
            "Australia/Perth|Australia/West",
            "Australia/Sydney|Australia/ACT",
            "Australia/Sydney|Australia/Canberra",
            "Australia/Sydney|Australia/Currie",
            "Australia/Sydney|Australia/Hobart",
            "Australia/Sydney|Australia/Melbourne",
            "Australia/Sydney|Australia/NSW",
            "Australia/Sydney|Australia/Tasmania",
            "Australia/Sydney|Australia/Victoria",
            "Etc/UCT|UCT",
            "Etc/UTC|Etc/Universal",
            "Etc/UTC|Etc/Zulu",
            "Etc/UTC|UTC",
            "Etc/UTC|Universal",
            "Etc/UTC|Zulu",
            "Europe/Astrakhan|Europe/Ulyanovsk",
            "Europe/Athens|Asia/Nicosia",
            "Europe/Athens|EET",
            "Europe/Athens|Europe/Bucharest",
            "Europe/Athens|Europe/Helsinki",
            "Europe/Athens|Europe/Kiev",
            "Europe/Athens|Europe/Mariehamn",
            "Europe/Athens|Europe/Nicosia",
            "Europe/Athens|Europe/Riga",
            "Europe/Athens|Europe/Sofia",
            "Europe/Athens|Europe/Tallinn",
            "Europe/Athens|Europe/Uzhgorod",
            "Europe/Athens|Europe/Vilnius",
            "Europe/Athens|Europe/Zaporozhye",
            "Europe/Chisinau|Europe/Tiraspol",
            "Europe/Dublin|Eire",
            "Europe/Istanbul|Asia/Istanbul",
            "Europe/Istanbul|Turkey",
            "Europe/Lisbon|Atlantic/Canary",
            "Europe/Lisbon|Atlantic/Faeroe",
            "Europe/Lisbon|Atlantic/Faroe",
            "Europe/Lisbon|Atlantic/Madeira",
            "Europe/Lisbon|Portugal",
            "Europe/Lisbon|WET",
            "Europe/London|Europe/Belfast",
            "Europe/London|Europe/Guernsey",
            "Europe/London|Europe/Isle_of_Man",
            "Europe/London|Europe/Jersey",
            "Europe/London|GB",
            "Europe/London|GB-Eire",
            "Europe/Moscow|W-SU",
            "Europe/Paris|Africa/Ceuta",
            "Europe/Paris|Arctic/Longyearbyen",
            "Europe/Paris|Atlantic/Jan_Mayen",
            "Europe/Paris|CET",
            "Europe/Paris|Europe/Amsterdam",
            "Europe/Paris|Europe/Andorra",
            "Europe/Paris|Europe/Belgrade",
            "Europe/Paris|Europe/Berlin",
            "Europe/Paris|Europe/Bratislava",
            "Europe/Paris|Europe/Brussels",
            "Europe/Paris|Europe/Budapest",
            "Europe/Paris|Europe/Busingen",
            "Europe/Paris|Europe/Copenhagen",
            "Europe/Paris|Europe/Gibraltar",
            "Europe/Paris|Europe/Ljubljana",
            "Europe/Paris|Europe/Luxembourg",
            "Europe/Paris|Europe/Madrid",
            "Europe/Paris|Europe/Malta",
            "Europe/Paris|Europe/Monaco",
            "Europe/Paris|Europe/Oslo",
            "Europe/Paris|Europe/Podgorica",
            "Europe/Paris|Europe/Prague",
            "Europe/Paris|Europe/Rome",
            "Europe/Paris|Europe/San_Marino",
            "Europe/Paris|Europe/Sarajevo",
            "Europe/Paris|Europe/Skopje",
            "Europe/Paris|Europe/Stockholm",
            "Europe/Paris|Europe/Tirane",
            "Europe/Paris|Europe/Vaduz",
            "Europe/Paris|Europe/Vatican",
            "Europe/Paris|Europe/Vienna",
            "Europe/Paris|Europe/Warsaw",
            "Europe/Paris|Europe/Zagreb",
            "Europe/Paris|Europe/Zurich",
            "Europe/Paris|Poland",
            "Europe/Volgograd|Europe/Kirov",
            "Pacific/Auckland|Antarctica/McMurdo",
            "Pacific/Auckland|Antarctica/South_Pole",
            "Pacific/Auckland|NZ",
            "Pacific/Chatham|NZ-CHAT",
            "Pacific/Easter|Chile/EasterIsland",
            "Pacific/Fakaofo|Etc/GMT-13",
            "Pacific/Fakaofo|Pacific/Enderbury",
            "Pacific/Galapagos|Etc/GMT+6",
            "Pacific/Gambier|Etc/GMT+9",
            "Pacific/Guadalcanal|Antarctica/Macquarie",
            "Pacific/Guadalcanal|Etc/GMT-11",
            "Pacific/Guadalcanal|Pacific/Efate",
            "Pacific/Guadalcanal|Pacific/Kosrae",
            "Pacific/Guadalcanal|Pacific/Noumea",
            "Pacific/Guadalcanal|Pacific/Pohnpei",
            "Pacific/Guadalcanal|Pacific/Ponape",
            "Pacific/Guam|Pacific/Saipan",
            "Pacific/Honolulu|HST",
            "Pacific/Honolulu|Pacific/Johnston",
            "Pacific/Honolulu|US/Hawaii",
            "Pacific/Kiritimati|Etc/GMT-14",
            "Pacific/Niue|Etc/GMT+11",
            "Pacific/Pago_Pago|Pacific/Midway",
            "Pacific/Pago_Pago|Pacific/Samoa",
            "Pacific/Pago_Pago|US/Samoa",
            "Pacific/Pitcairn|Etc/GMT+8",
            "Pacific/Port_Moresby|Antarctica/DumontDUrville",
            "Pacific/Port_Moresby|Etc/GMT-10",
            "Pacific/Port_Moresby|Pacific/Chuuk",
            "Pacific/Port_Moresby|Pacific/Truk",
            "Pacific/Port_Moresby|Pacific/Yap",
            "Pacific/Tahiti|Etc/GMT+10",
            "Pacific/Tahiti|Pacific/Rarotonga"
        ]
    });


    module.exports = moment;
})();
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/time/moment-timezone',_glass_time_moment_timezone_);
    else
      _glass_time_moment_timezone_.call(this, module, exports, require);
  }
  else {
    _glass_time_moment_timezone_.call(this);
  }
}).call(this)
void (function(){var _glass_time_moment_ = function(module,exports,require){//! moment.js
//! version : 2.18.1
//! authors : Tim Wood, Iskren Chernev, Moment.js contributors
//! license : MIT
//! momentjs.com

// I changed how this is packaged and exported to work with ion. - Kody
(function() {

    'use strict';

    var hookCallback;

    function hooks() {
        return hookCallback.apply(null, arguments);
    }

    // This is done to register the method called with moment()
    // without creating circular dependencies.
    function setHookCallback(callback) {
        hookCallback = callback;
    }

    function isArray(input) {
        return input instanceof Array || Object.prototype.toString.call(input) === '[object Array]';
    }

    function isObject(input) {
        // IE8 will treat undefined and null as object if it wasn't for
        // input != null
        return input != null && Object.prototype.toString.call(input) === '[object Object]';
    }

    function isObjectEmpty(obj) {
        var k;
        for (k in obj) {
            // even if its not own property I'd still call it non-empty
            return false;
        }
        return true;
    }

    function isUndefined(input) {
        return input === void 0;
    }

    function isNumber(input) {
        return typeof input === 'number' || Object.prototype.toString.call(input) === '[object Number]';
    }

    function isDate(input) {
        return input instanceof Date || Object.prototype.toString.call(input) === '[object Date]';
    }

    function map(arr, fn) {
        var res = [],
            i;
        for (i = 0; i < arr.length; ++i) {
            res.push(fn(arr[i], i));
        }
        return res;
    }

    function hasOwnProp(a, b) {
        return Object.prototype.hasOwnProperty.call(a, b);
    }

    function extend(a, b) {
        for (var i in b) {
            if (hasOwnProp(b, i)) {
                a[i] = b[i];
            }
        }

        if (hasOwnProp(b, 'toString')) {
            a.toString = b.toString;
        }

        if (hasOwnProp(b, 'valueOf')) {
            a.valueOf = b.valueOf;
        }

        return a;
    }

    function createUTC(input, format, locale, strict) {
        return createLocalOrUTC(input, format, locale, strict, true).utc();
    }

    function defaultParsingFlags() {
        // We need to deep clone this object.
        return {
            empty: false,
            unusedTokens: [],
            unusedInput: [],
            overflow: -2,
            charsLeftOver: 0,
            nullInput: false,
            invalidMonth: null,
            invalidFormat: false,
            userInvalidated: false,
            iso: false,
            parsedDateParts: [],
            meridiem: null,
            rfc2822: false,
            weekdayMismatch: false
        };
    }

    function getParsingFlags(m) {
        if (m._pf == null) {
            m._pf = defaultParsingFlags();
        }
        return m._pf;
    }

    var some;
    if (Array.prototype.some) {
        some = Array.prototype.some;
    } else {
        some = function(fun) {
            var t = Object(this);
            var len = t.length >>> 0;

            for (var i = 0; i < len; i++) {
                if (i in t && fun.call(this, t[i], i, t)) {
                    return true;
                }
            }

            return false;
        };
    }

    var some$1 = some;

    function isValid(m) {
        if (m._isValid == null) {
            var flags = getParsingFlags(m);
            var parsedParts = some$1.call(flags.parsedDateParts, function(i) {
                return i != null;
            });
            var isNowValid = !isNaN(m._d.getTime()) &&
                flags.overflow < 0 &&
                !flags.empty &&
                !flags.invalidMonth &&
                !flags.invalidWeekday &&
                !flags.nullInput &&
                !flags.invalidFormat &&
                !flags.userInvalidated &&
                (!flags.meridiem || (flags.meridiem && parsedParts));

            if (m._strict) {
                isNowValid = isNowValid &&
                    flags.charsLeftOver === 0 &&
                    flags.unusedTokens.length === 0 &&
                    flags.bigHour === undefined;
            }

            if (Object.isFrozen == null || !Object.isFrozen(m)) {
                m._isValid = isNowValid;
            } else {
                return isNowValid;
            }
        }
        return m._isValid;
    }

    function createInvalid(flags) {
        var m = createUTC(NaN);
        if (flags != null) {
            extend(getParsingFlags(m), flags);
        } else {
            getParsingFlags(m).userInvalidated = true;
        }

        return m;
    }

    // Plugins that add properties should also add the key here (null value),
    // so we can properly clone ourselves.
    var momentProperties = hooks.momentProperties = [];

    function copyConfig(to, from) {
        var i, prop, val;

        if (!isUndefined(from._isAMomentObject)) {
            to._isAMomentObject = from._isAMomentObject;
        }
        if (!isUndefined(from._i)) {
            to._i = from._i;
        }
        if (!isUndefined(from._f)) {
            to._f = from._f;
        }
        if (!isUndefined(from._l)) {
            to._l = from._l;
        }
        if (!isUndefined(from._strict)) {
            to._strict = from._strict;
        }
        if (!isUndefined(from._tzm)) {
            to._tzm = from._tzm;
        }
        if (!isUndefined(from._isUTC)) {
            to._isUTC = from._isUTC;
        }
        if (!isUndefined(from._offset)) {
            to._offset = from._offset;
        }
        if (!isUndefined(from._pf)) {
            to._pf = getParsingFlags(from);
        }
        if (!isUndefined(from._locale)) {
            to._locale = from._locale;
        }

        if (momentProperties.length > 0) {
            for (i = 0; i < momentProperties.length; i++) {
                prop = momentProperties[i];
                val = from[prop];
                if (!isUndefined(val)) {
                    to[prop] = val;
                }
            }
        }

        return to;
    }

    var updateInProgress = false;

    // Moment prototype object
    function Moment(config) {
        copyConfig(this, config);
        this._d = new Date(config._d != null ? config._d.getTime() : NaN);
        if (!this.isValid()) {
            this._d = new Date(NaN);
        }
        // Prevent infinite loop in case updateOffset creates new moment
        // objects.
        if (updateInProgress === false) {
            updateInProgress = true;
            hooks.updateOffset(this);
            updateInProgress = false;
        }
    }

    function isMoment(obj) {
        return obj instanceof Moment || (obj != null && obj._isAMomentObject != null);
    }

    function absFloor(number) {
        if (number < 0) {
            // -0 -> 0
            return Math.ceil(number) || 0;
        } else {
            return Math.floor(number);
        }
    }

    function toInt(argumentForCoercion) {
        var coercedNumber = +argumentForCoercion,
            value = 0;

        if (coercedNumber !== 0 && isFinite(coercedNumber)) {
            value = absFloor(coercedNumber);
        }

        return value;
    }

    // compare two arrays, return the number of differences
    function compareArrays(array1, array2, dontConvert) {
        var len = Math.min(array1.length, array2.length),
            lengthDiff = Math.abs(array1.length - array2.length),
            diffs = 0,
            i;
        for (i = 0; i < len; i++) {
            if ((dontConvert && array1[i] !== array2[i]) ||
                (!dontConvert && toInt(array1[i]) !== toInt(array2[i]))) {
                diffs++;
            }
        }
        return diffs + lengthDiff;
    }

    function warn(msg) {
        if (hooks.suppressDeprecationWarnings === false &&
            (typeof console !== 'undefined') && console.warn) {
            console.warn('Deprecation warning: ' + msg);
        }
    }

    function deprecate(msg, fn) {
        var firstTime = true;

        return extend(function() {
            if (hooks.deprecationHandler != null) {
                hooks.deprecationHandler(null, msg);
            }
            if (firstTime) {
                var args = [];
                var arg;
                for (var i = 0; i < arguments.length; i++) {
                    arg = '';
                    if (typeof arguments[i] === 'object') {
                        arg += '\n[' + i + '] ';
                        for (var key in arguments[0]) {
                            arg += key + ': ' + arguments[0][key] + ', ';
                        }
                        arg = arg.slice(0, -2); // Remove trailing comma and space
                    } else {
                        arg = arguments[i];
                    }
                    args.push(arg);
                }
                warn(msg + '\nArguments: ' + Array.prototype.slice.call(args).join('') + '\n' + (new Error()).stack);
                firstTime = false;
            }
            return fn.apply(this, arguments);
        }, fn);
    }

    var deprecations = {};

    function deprecateSimple(name, msg) {
        if (hooks.deprecationHandler != null) {
            hooks.deprecationHandler(name, msg);
        }
        if (!deprecations[name]) {
            warn(msg);
            deprecations[name] = true;
        }
    }

    hooks.suppressDeprecationWarnings = false;
    hooks.deprecationHandler = null;

    function isFunction(input) {
        return input instanceof Function || Object.prototype.toString.call(input) === '[object Function]';
    }

    function set(config) {
        var prop, i;
        for (i in config) {
            prop = config[i];
            if (isFunction(prop)) {
                this[i] = prop;
            } else {
                this['_' + i] = prop;
            }
        }
        this._config = config;
        // Lenient ordinal parsing accepts just a number in addition to
        // number + (possibly) stuff coming from _dayOfMonthOrdinalParse.
        // TODO: Remove "ordinalParse" fallback in next major release.
        this._dayOfMonthOrdinalParseLenient = new RegExp(
            (this._dayOfMonthOrdinalParse.source || this._ordinalParse.source) +
            '|' + (/\d{1,2}/).source);
    }

    function mergeConfigs(parentConfig, childConfig) {
        var res = extend({}, parentConfig),
            prop;
        for (prop in childConfig) {
            if (hasOwnProp(childConfig, prop)) {
                if (isObject(parentConfig[prop]) && isObject(childConfig[prop])) {
                    res[prop] = {};
                    extend(res[prop], parentConfig[prop]);
                    extend(res[prop], childConfig[prop]);
                } else if (childConfig[prop] != null) {
                    res[prop] = childConfig[prop];
                } else {
                    delete res[prop];
                }
            }
        }
        for (prop in parentConfig) {
            if (hasOwnProp(parentConfig, prop) &&
                !hasOwnProp(childConfig, prop) &&
                isObject(parentConfig[prop])) {
                // make sure changes to properties don't modify parent config
                res[prop] = extend({}, res[prop]);
            }
        }
        return res;
    }

    function Locale(config) {
        if (config != null) {
            this.set(config);
        }
    }

    var keys;

    if (Object.keys) {
        keys = Object.keys;
    } else {
        keys = function(obj) {
            var i, res = [];
            for (i in obj) {
                if (hasOwnProp(obj, i)) {
                    res.push(i);
                }
            }
            return res;
        };
    }

    var keys$1 = keys;

    var defaultCalendar = {
        sameDay: '[Today at] LT',
        nextDay: '[Tomorrow at] LT',
        nextWeek: 'dddd [at] LT',
        lastDay: '[Yesterday at] LT',
        lastWeek: '[Last] dddd [at] LT',
        sameElse: 'L'
    };

    function calendar(key, mom, now) {
        var output = this._calendar[key] || this._calendar['sameElse'];
        return isFunction(output) ? output.call(mom, now) : output;
    }

    var defaultLongDateFormat = {
        LTS: 'h:mm:ss A',
        LT: 'h:mm A',
        L: 'MM/DD/YYYY',
        LL: 'MMMM D, YYYY',
        LLL: 'MMMM D, YYYY h:mm A',
        LLLL: 'dddd, MMMM D, YYYY h:mm A'
    };

    function longDateFormat(key) {
        var format = this._longDateFormat[key],
            formatUpper = this._longDateFormat[key.toUpperCase()];

        if (format || !formatUpper) {
            return format;
        }

        this._longDateFormat[key] = formatUpper.replace(/MMMM|MM|DD|dddd/g, function(val) {
            return val.slice(1);
        });

        return this._longDateFormat[key];
    }

    var defaultInvalidDate = 'Invalid date';

    function invalidDate() {
        return this._invalidDate;
    }

    var defaultOrdinal = '%d';
    var defaultDayOfMonthOrdinalParse = /\d{1,2}/;

    function ordinal(number) {
        return this._ordinal.replace('%d', number);
    }

    var defaultRelativeTime = {
        future: 'in %s',
        past: '%s ago',
        s: 'a few seconds',
        ss: '%d seconds',
        m: 'a minute',
        mm: '%d minutes',
        h: 'an hour',
        hh: '%d hours',
        d: 'a day',
        dd: '%d days',
        M: 'a month',
        MM: '%d months',
        y: 'a year',
        yy: '%d years'
    };

    function relativeTime(number, withoutSuffix, string, isFuture) {
        var output = this._relativeTime[string];
        return (isFunction(output)) ?
            output(number, withoutSuffix, string, isFuture) :
            output.replace(/%d/i, number);
    }

    function pastFuture(diff, output) {
        var format = this._relativeTime[diff > 0 ? 'future' : 'past'];
        return isFunction(format) ? format(output) : format.replace(/%s/i, output);
    }

    var aliases = {};

    function addUnitAlias(unit, shorthand) {
        var lowerCase = unit.toLowerCase();
        aliases[lowerCase] = aliases[lowerCase + 's'] = aliases[shorthand] = unit;
    }

    function normalizeUnits(units) {
        return typeof units === 'string' ? aliases[units] || aliases[units.toLowerCase()] : undefined;
    }

    function normalizeObjectUnits(inputObject) {
        var normalizedInput = {},
            normalizedProp,
            prop;

        for (prop in inputObject) {
            if (hasOwnProp(inputObject, prop)) {
                normalizedProp = normalizeUnits(prop);
                if (normalizedProp) {
                    normalizedInput[normalizedProp] = inputObject[prop];
                }
            }
        }

        return normalizedInput;
    }

    var priorities = {};

    function addUnitPriority(unit, priority) {
        priorities[unit] = priority;
    }

    function getPrioritizedUnits(unitsObj) {
        var units = [];
        for (var u in unitsObj) {
            units.push({
                unit: u,
                priority: priorities[u]
            });
        }
        units.sort(function(a, b) {
            return a.priority - b.priority;
        });
        return units;
    }

    function makeGetSet(unit, keepTime) {
        return function(value) {
            if (value != null) {
                set$1(this, unit, value);
                hooks.updateOffset(this, keepTime);
                return this;
            } else {
                return get(this, unit);
            }
        };
    }

    function get(mom, unit) {
        return mom.isValid() ?
            mom._d['get' + (mom._isUTC ? 'UTC' : '') + unit]() : NaN;
    }

    function set$1(mom, unit, value) {
        if (mom.isValid()) {
            mom._d['set' + (mom._isUTC ? 'UTC' : '') + unit](value);
        }
    }

    // MOMENTS

    function stringGet(units) {
        units = normalizeUnits(units);
        if (isFunction(this[units])) {
            return this[units]();
        }
        return this;
    }


    function stringSet(units, value) {
        if (typeof units === 'object') {
            units = normalizeObjectUnits(units);
            var prioritized = getPrioritizedUnits(units);
            for (var i = 0; i < prioritized.length; i++) {
                this[prioritized[i].unit](units[prioritized[i].unit]);
            }
        } else {
            units = normalizeUnits(units);
            if (isFunction(this[units])) {
                return this[units](value);
            }
        }
        return this;
    }

    function zeroFill(number, targetLength, forceSign) {
        var absNumber = '' + Math.abs(number),
            zerosToFill = targetLength - absNumber.length,
            sign = number >= 0;
        return (sign ? (forceSign ? '+' : '') : '-') +
            Math.pow(10, Math.max(0, zerosToFill)).toString().substr(1) + absNumber;
    }

    var formattingTokens = /(\[[^\[]*\])|(\\)?([Hh]mm(ss)?|Mo|MM?M?M?|Do|DDDo|DD?D?D?|ddd?d?|do?|w[o|w]?|W[o|W]?|Qo?|YYYYYY|YYYYY|YYYY|YY|gg(ggg?)?|GG(GGG?)?|e|E|a|A|hh?|HH?|kk?|mm?|ss?|S{1,9}|x|X|zz?|ZZ?|.)/g;

    var localFormattingTokens = /(\[[^\[]*\])|(\\)?(LTS|LT|LL?L?L?|l{1,4})/g;

    var formatFunctions = {};

    var formatTokenFunctions = {};

    // token:    'M'
    // padded:   ['MM', 2]
    // ordinal:  'Mo'
    // callback: function () { this.month() + 1 }
    function addFormatToken(token, padded, ordinal, callback) {
        var func = callback;
        if (typeof callback === 'string') {
            func = function() {
                return this[callback]();
            };
        }
        if (token) {
            formatTokenFunctions[token] = func;
        }
        if (padded) {
            formatTokenFunctions[padded[0]] = function() {
                return zeroFill(func.apply(this, arguments), padded[1], padded[2]);
            };
        }
        if (ordinal) {
            formatTokenFunctions[ordinal] = function() {
                return this.localeData().ordinal(func.apply(this, arguments), token);
            };
        }
    }

    function removeFormattingTokens(input) {
        if (input.match(/\[[\s\S]/)) {
            return input.replace(/^\[|\]$/g, '');
        }
        return input.replace(/\\/g, '');
    }

    function makeFormatFunction(format) {
        var array = format.match(formattingTokens),
            i, length;

        for (i = 0, length = array.length; i < length; i++) {
            if (formatTokenFunctions[array[i]]) {
                array[i] = formatTokenFunctions[array[i]];
            } else {
                array[i] = removeFormattingTokens(array[i]);
            }
        }

        return function(mom) {
            var output = '',
                i;
            for (i = 0; i < length; i++) {
                output += isFunction(array[i]) ? array[i].call(mom, format) : array[i];
            }
            return output;
        };
    }

    // format date using native date object
    function formatMoment(m, format) {
        if (!m.isValid()) {
            return m.localeData().invalidDate();
        }

        format = expandFormat(format, m.localeData());
        formatFunctions[format] = formatFunctions[format] || makeFormatFunction(format);

        return formatFunctions[format](m);
    }

    function expandFormat(format, locale) {
        var i = 5;

        function replaceLongDateFormatTokens(input) {
            return locale.longDateFormat(input) || input;
        }

        localFormattingTokens.lastIndex = 0;
        while (i >= 0 && localFormattingTokens.test(format)) {
            format = format.replace(localFormattingTokens, replaceLongDateFormatTokens);
            localFormattingTokens.lastIndex = 0;
            i -= 1;
        }

        return format;
    }

    var match1 = /\d/; //       0 - 9
    var match2 = /\d\d/; //      00 - 99
    var match3 = /\d{3}/; //     000 - 999
    var match4 = /\d{4}/; //    0000 - 9999
    var match6 = /[+-]?\d{6}/; // -999999 - 999999
    var match1to2 = /\d\d?/; //       0 - 99
    var match3to4 = /\d\d\d\d?/; //     999 - 9999
    var match5to6 = /\d\d\d\d\d\d?/; //   99999 - 999999
    var match1to3 = /\d{1,3}/; //       0 - 999
    var match1to4 = /\d{1,4}/; //       0 - 9999
    var match1to6 = /[+-]?\d{1,6}/; // -999999 - 999999

    var matchUnsigned = /\d+/; //       0 - inf
    var matchSigned = /[+-]?\d+/; //    -inf - inf

    var matchOffset = /Z|[+-]\d\d:?\d\d/gi; // +00:00 -00:00 +0000 -0000 or Z
    var matchShortOffset = /Z|[+-]\d\d(?::?\d\d)?/gi; // +00 -00 +00:00 -00:00 +0000 -0000 or Z

    var matchTimestamp = /[+-]?\d+(\.\d{1,3})?/; // 123456789 123456789.123

    // any word (or two) characters or numbers including two/three word month in arabic.
    // includes scottish gaelic two word and hyphenated months
    var matchWord = /[0-9]*['a-z\u00A0-\u05FF\u0700-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+|[\u0600-\u06FF\/]+(\s*?[\u0600-\u06FF]+){1,2}/i;


    var regexes = {};

    function addRegexToken(token, regex, strictRegex) {
        regexes[token] = isFunction(regex) ? regex : function(isStrict, localeData) {
            return (isStrict && strictRegex) ? strictRegex : regex;
        };
    }

    function getParseRegexForToken(token, config) {
        if (!hasOwnProp(regexes, token)) {
            return new RegExp(unescapeFormat(token));
        }

        return regexes[token](config._strict, config._locale);
    }

    // Code from http://stackoverflow.com/questions/3561493/is-there-a-regexp-escape-function-in-javascript
    function unescapeFormat(s) {
        return regexEscape(s.replace('\\', '').replace(/\\(\[)|\\(\])|\[([^\]\[]*)\]|\\(.)/g, function(matched, p1, p2, p3, p4) {
            return p1 || p2 || p3 || p4;
        }));
    }

    function regexEscape(s) {
        return s.replace(/[-\/\\^$*+?.()|[\]{}]/g, '\\$&');
    }

    var tokens = {};

    function addParseToken(token, callback) {
        var i, func = callback;
        if (typeof token === 'string') {
            token = [token];
        }
        if (isNumber(callback)) {
            func = function(input, array) {
                array[callback] = toInt(input);
            };
        }
        for (i = 0; i < token.length; i++) {
            tokens[token[i]] = func;
        }
    }

    function addWeekParseToken(token, callback) {
        addParseToken(token, function(input, array, config, token) {
            config._w = config._w || {};
            callback(input, config._w, config, token);
        });
    }

    function addTimeToArrayFromToken(token, input, config) {
        if (input != null && hasOwnProp(tokens, token)) {
            tokens[token](input, config._a, config, token);
        }
    }

    var YEAR = 0;
    var MONTH = 1;
    var DATE = 2;
    var HOUR = 3;
    var MINUTE = 4;
    var SECOND = 5;
    var MILLISECOND = 6;
    var WEEK = 7;
    var WEEKDAY = 8;

    var indexOf;

    if (Array.prototype.indexOf) {
        indexOf = Array.prototype.indexOf;
    } else {
        indexOf = function(o) {
            // I know
            var i;
            for (i = 0; i < this.length; ++i) {
                if (this[i] === o) {
                    return i;
                }
            }
            return -1;
        };
    }

    var indexOf$1 = indexOf;

    function daysInMonth(year, month) {
        return new Date(Date.UTC(year, month + 1, 0)).getUTCDate();
    }

    // FORMATTING

    addFormatToken('M', ['MM', 2], 'Mo', function() {
        return this.month() + 1;
    });

    addFormatToken('MMM', 0, 0, function(format) {
        return this.localeData().monthsShort(this, format);
    });

    addFormatToken('MMMM', 0, 0, function(format) {
        return this.localeData().months(this, format);
    });

    // ALIASES

    addUnitAlias('month', 'M');

    // PRIORITY

    addUnitPriority('month', 8);

    // PARSING

    addRegexToken('M', match1to2);
    addRegexToken('MM', match1to2, match2);
    addRegexToken('MMM', function(isStrict, locale) {
        return locale.monthsShortRegex(isStrict);
    });
    addRegexToken('MMMM', function(isStrict, locale) {
        return locale.monthsRegex(isStrict);
    });

    addParseToken(['M', 'MM'], function(input, array) {
        array[MONTH] = toInt(input) - 1;
    });

    addParseToken(['MMM', 'MMMM'], function(input, array, config, token) {
        var month = config._locale.monthsParse(input, token, config._strict);
        // if we didn't find a month name, mark the date as invalid.
        if (month != null) {
            array[MONTH] = month;
        } else {
            getParsingFlags(config).invalidMonth = input;
        }
    });

    // LOCALES

    var MONTHS_IN_FORMAT = /D[oD]?(\[[^\[\]]*\]|\s)+MMMM?/;
    var defaultLocaleMonths = 'January_February_March_April_May_June_July_August_September_October_November_December'.split('_');

    function localeMonths(m, format) {
        if (!m) {
            return isArray(this._months) ? this._months :
                this._months['standalone'];
        }
        return isArray(this._months) ? this._months[m.month()] :
            this._months[(this._months.isFormat || MONTHS_IN_FORMAT).test(format) ? 'format' : 'standalone'][m.month()];
    }

    var defaultLocaleMonthsShort = 'Jan_Feb_Mar_Apr_May_Jun_Jul_Aug_Sep_Oct_Nov_Dec'.split('_');

    function localeMonthsShort(m, format) {
        if (!m) {
            return isArray(this._monthsShort) ? this._monthsShort :
                this._monthsShort['standalone'];
        }
        return isArray(this._monthsShort) ? this._monthsShort[m.month()] :
            this._monthsShort[MONTHS_IN_FORMAT.test(format) ? 'format' : 'standalone'][m.month()];
    }

    function handleStrictParse(monthName, format, strict) {
        var i, ii, mom, llc = monthName.toLocaleLowerCase();
        if (!this._monthsParse) {
            // this is not used
            this._monthsParse = [];
            this._longMonthsParse = [];
            this._shortMonthsParse = [];
            for (i = 0; i < 12; ++i) {
                mom = createUTC([2000, i]);
                this._shortMonthsParse[i] = this.monthsShort(mom, '').toLocaleLowerCase();
                this._longMonthsParse[i] = this.months(mom, '').toLocaleLowerCase();
            }
        }

        if (strict) {
            if (format === 'MMM') {
                ii = indexOf$1.call(this._shortMonthsParse, llc);
                return ii !== -1 ? ii : null;
            } else {
                ii = indexOf$1.call(this._longMonthsParse, llc);
                return ii !== -1 ? ii : null;
            }
        } else {
            if (format === 'MMM') {
                ii = indexOf$1.call(this._shortMonthsParse, llc);
                if (ii !== -1) {
                    return ii;
                }
                ii = indexOf$1.call(this._longMonthsParse, llc);
                return ii !== -1 ? ii : null;
            } else {
                ii = indexOf$1.call(this._longMonthsParse, llc);
                if (ii !== -1) {
                    return ii;
                }
                ii = indexOf$1.call(this._shortMonthsParse, llc);
                return ii !== -1 ? ii : null;
            }
        }
    }

    function localeMonthsParse(monthName, format, strict) {
        var i, mom, regex;

        if (this._monthsParseExact) {
            return handleStrictParse.call(this, monthName, format, strict);
        }

        if (!this._monthsParse) {
            this._monthsParse = [];
            this._longMonthsParse = [];
            this._shortMonthsParse = [];
        }

        // TODO: add sorting
        // Sorting makes sure if one month (or abbr) is a prefix of another
        // see sorting in computeMonthsParse
        for (i = 0; i < 12; i++) {
            // make the regex if we don't have it already
            mom = createUTC([2000, i]);
            if (strict && !this._longMonthsParse[i]) {
                this._longMonthsParse[i] = new RegExp('^' + this.months(mom, '').replace('.', '') + '$', 'i');
                this._shortMonthsParse[i] = new RegExp('^' + this.monthsShort(mom, '').replace('.', '') + '$', 'i');
            }
            if (!strict && !this._monthsParse[i]) {
                regex = '^' + this.months(mom, '') + '|^' + this.monthsShort(mom, '');
                this._monthsParse[i] = new RegExp(regex.replace('.', ''), 'i');
            }
            // test the regex
            if (strict && format === 'MMMM' && this._longMonthsParse[i].test(monthName)) {
                return i;
            } else if (strict && format === 'MMM' && this._shortMonthsParse[i].test(monthName)) {
                return i;
            } else if (!strict && this._monthsParse[i].test(monthName)) {
                return i;
            }
        }
    }

    // MOMENTS

    function setMonth(mom, value) {
        var dayOfMonth;

        if (!mom.isValid()) {
            // No op
            return mom;
        }

        if (typeof value === 'string') {
            if (/^\d+$/.test(value)) {
                value = toInt(value);
            } else {
                value = mom.localeData().monthsParse(value);
                // TODO: Another silent failure?
                if (!isNumber(value)) {
                    return mom;
                }
            }
        }

        dayOfMonth = Math.min(mom.date(), daysInMonth(mom.year(), value));
        mom._d['set' + (mom._isUTC ? 'UTC' : '') + 'Month'](value, dayOfMonth);
        return mom;
    }

    function getSetMonth(value) {
        if (value != null) {
            setMonth(this, value);
            hooks.updateOffset(this, true);
            return this;
        } else {
            return get(this, 'Month');
        }
    }

    function getDaysInMonth() {
        return daysInMonth(this.year(), this.month());
    }

    var defaultMonthsShortRegex = matchWord;

    function monthsShortRegex(isStrict) {
        if (this._monthsParseExact) {
            if (!hasOwnProp(this, '_monthsRegex')) {
                computeMonthsParse.call(this);
            }
            if (isStrict) {
                return this._monthsShortStrictRegex;
            } else {
                return this._monthsShortRegex;
            }
        } else {
            if (!hasOwnProp(this, '_monthsShortRegex')) {
                this._monthsShortRegex = defaultMonthsShortRegex;
            }
            return this._monthsShortStrictRegex && isStrict ?
                this._monthsShortStrictRegex : this._monthsShortRegex;
        }
    }

    var defaultMonthsRegex = matchWord;

    function monthsRegex(isStrict) {
        if (this._monthsParseExact) {
            if (!hasOwnProp(this, '_monthsRegex')) {
                computeMonthsParse.call(this);
            }
            if (isStrict) {
                return this._monthsStrictRegex;
            } else {
                return this._monthsRegex;
            }
        } else {
            if (!hasOwnProp(this, '_monthsRegex')) {
                this._monthsRegex = defaultMonthsRegex;
            }
            return this._monthsStrictRegex && isStrict ?
                this._monthsStrictRegex : this._monthsRegex;
        }
    }

    function computeMonthsParse() {
        function cmpLenRev(a, b) {
            return b.length - a.length;
        }

        var shortPieces = [],
            longPieces = [],
            mixedPieces = [],
            i, mom;
        for (i = 0; i < 12; i++) {
            // make the regex if we don't have it already
            mom = createUTC([2000, i]);
            shortPieces.push(this.monthsShort(mom, ''));
            longPieces.push(this.months(mom, ''));
            mixedPieces.push(this.months(mom, ''));
            mixedPieces.push(this.monthsShort(mom, ''));
        }
        // Sorting makes sure if one month (or abbr) is a prefix of another it
        // will match the longer piece.
        shortPieces.sort(cmpLenRev);
        longPieces.sort(cmpLenRev);
        mixedPieces.sort(cmpLenRev);
        for (i = 0; i < 12; i++) {
            shortPieces[i] = regexEscape(shortPieces[i]);
            longPieces[i] = regexEscape(longPieces[i]);
        }
        for (i = 0; i < 24; i++) {
            mixedPieces[i] = regexEscape(mixedPieces[i]);
        }

        this._monthsRegex = new RegExp('^(' + mixedPieces.join('|') + ')', 'i');
        this._monthsShortRegex = this._monthsRegex;
        this._monthsStrictRegex = new RegExp('^(' + longPieces.join('|') + ')', 'i');
        this._monthsShortStrictRegex = new RegExp('^(' + shortPieces.join('|') + ')', 'i');
    }

    // FORMATTING

    addFormatToken('Y', 0, 0, function() {
        var y = this.year();
        return y <= 9999 ? '' + y : '+' + y;
    });

    addFormatToken(0, ['YY', 2], 0, function() {
        return this.year() % 100;
    });

    addFormatToken(0, ['YYYY', 4], 0, 'year');
    addFormatToken(0, ['YYYYY', 5], 0, 'year');
    addFormatToken(0, ['YYYYYY', 6, true], 0, 'year');

    // ALIASES

    addUnitAlias('year', 'y');

    // PRIORITIES

    addUnitPriority('year', 1);

    // PARSING

    addRegexToken('Y', matchSigned);
    addRegexToken('YY', match1to2, match2);
    addRegexToken('YYYY', match1to4, match4);
    addRegexToken('YYYYY', match1to6, match6);
    addRegexToken('YYYYYY', match1to6, match6);

    addParseToken(['YYYYY', 'YYYYYY'], YEAR);
    addParseToken('YYYY', function(input, array) {
        array[YEAR] = input.length === 2 ? hooks.parseTwoDigitYear(input) : toInt(input);
    });
    addParseToken('YY', function(input, array) {
        array[YEAR] = hooks.parseTwoDigitYear(input);
    });
    addParseToken('Y', function(input, array) {
        array[YEAR] = parseInt(input, 10);
    });

    // HELPERS

    function daysInYear(year) {
        return isLeapYear(year) ? 366 : 365;
    }

    function isLeapYear(year) {
        return (year % 4 === 0 && year % 100 !== 0) || year % 400 === 0;
    }

    // HOOKS

    hooks.parseTwoDigitYear = function(input) {
        return toInt(input) + (toInt(input) > 68 ? 1900 : 2000);
    };

    // MOMENTS

    var getSetYear = makeGetSet('FullYear', true);

    function getIsLeapYear() {
        return isLeapYear(this.year());
    }

    function createDate(y, m, d, h, M, s, ms) {
        // can't just apply() to create a date:
        // https://stackoverflow.com/q/181348
        var date = new Date(y, m, d, h, M, s, ms);

        // the date constructor remaps years 0-99 to 1900-1999
        if (y < 100 && y >= 0 && isFinite(date.getFullYear())) {
            date.setFullYear(y);
        }
        return date;
    }

    function createUTCDate(y) {
        var date = new Date(Date.UTC.apply(null, arguments));

        // the Date.UTC function remaps years 0-99 to 1900-1999
        if (y < 100 && y >= 0 && isFinite(date.getUTCFullYear())) {
            date.setUTCFullYear(y);
        }
        return date;
    }

    // start-of-first-week - start-of-year
    function firstWeekOffset(year, dow, doy) {
        var // first-week day -- which january is always in the first week (4 for iso, 1 for other)
            fwd = 7 + dow - doy,
            // first-week day local weekday -- which local weekday is fwd
            fwdlw = (7 + createUTCDate(year, 0, fwd).getUTCDay() - dow) % 7;

        return -fwdlw + fwd - 1;
    }

    // https://en.wikipedia.org/wiki/ISO_week_date#Calculating_a_date_given_the_year.2C_week_number_and_weekday
    function dayOfYearFromWeeks(year, week, weekday, dow, doy) {
        var localWeekday = (7 + weekday - dow) % 7,
            weekOffset = firstWeekOffset(year, dow, doy),
            dayOfYear = 1 + 7 * (week - 1) + localWeekday + weekOffset,
            resYear, resDayOfYear;

        if (dayOfYear <= 0) {
            resYear = year - 1;
            resDayOfYear = daysInYear(resYear) + dayOfYear;
        } else if (dayOfYear > daysInYear(year)) {
            resYear = year + 1;
            resDayOfYear = dayOfYear - daysInYear(year);
        } else {
            resYear = year;
            resDayOfYear = dayOfYear;
        }

        return {
            year: resYear,
            dayOfYear: resDayOfYear
        };
    }

    function weekOfYear(mom, dow, doy) {
        var weekOffset = firstWeekOffset(mom.year(), dow, doy),
            week = Math.floor((mom.dayOfYear() - weekOffset - 1) / 7) + 1,
            resWeek, resYear;

        if (week < 1) {
            resYear = mom.year() - 1;
            resWeek = week + weeksInYear(resYear, dow, doy);
        } else if (week > weeksInYear(mom.year(), dow, doy)) {
            resWeek = week - weeksInYear(mom.year(), dow, doy);
            resYear = mom.year() + 1;
        } else {
            resYear = mom.year();
            resWeek = week;
        }

        return {
            week: resWeek,
            year: resYear
        };
    }

    function weeksInYear(year, dow, doy) {
        var weekOffset = firstWeekOffset(year, dow, doy),
            weekOffsetNext = firstWeekOffset(year + 1, dow, doy);
        return (daysInYear(year) - weekOffset + weekOffsetNext) / 7;
    }

    // FORMATTING

    addFormatToken('w', ['ww', 2], 'wo', 'week');
    addFormatToken('W', ['WW', 2], 'Wo', 'isoWeek');

    // ALIASES

    addUnitAlias('week', 'w');
    addUnitAlias('isoWeek', 'W');

    // PRIORITIES

    addUnitPriority('week', 5);
    addUnitPriority('isoWeek', 5);

    // PARSING

    addRegexToken('w', match1to2);
    addRegexToken('ww', match1to2, match2);
    addRegexToken('W', match1to2);
    addRegexToken('WW', match1to2, match2);

    addWeekParseToken(['w', 'ww', 'W', 'WW'], function(input, week, config, token) {
        week[token.substr(0, 1)] = toInt(input);
    });

    // HELPERS

    // LOCALES

    function localeWeek(mom) {
        return weekOfYear(mom, this._week.dow, this._week.doy).week;
    }

    var defaultLocaleWeek = {
        dow: 0, // Sunday is the first day of the week.
        doy: 6 // The week that contains Jan 1st is the first week of the year.
    };

    function localeFirstDayOfWeek() {
        return this._week.dow;
    }

    function localeFirstDayOfYear() {
        return this._week.doy;
    }

    // MOMENTS

    function getSetWeek(input) {
        var week = this.localeData().week(this);
        return input == null ? week : this.add((input - week) * 7, 'd');
    }

    function getSetISOWeek(input) {
        var week = weekOfYear(this, 1, 4).week;
        return input == null ? week : this.add((input - week) * 7, 'd');
    }

    // FORMATTING

    addFormatToken('d', 0, 'do', 'day');

    addFormatToken('dd', 0, 0, function(format) {
        return this.localeData().weekdaysMin(this, format);
    });

    addFormatToken('ddd', 0, 0, function(format) {
        return this.localeData().weekdaysShort(this, format);
    });

    addFormatToken('dddd', 0, 0, function(format) {
        return this.localeData().weekdays(this, format);
    });

    addFormatToken('e', 0, 0, 'weekday');
    addFormatToken('E', 0, 0, 'isoWeekday');

    // ALIASES

    addUnitAlias('day', 'd');
    addUnitAlias('weekday', 'e');
    addUnitAlias('isoWeekday', 'E');

    // PRIORITY
    addUnitPriority('day', 11);
    addUnitPriority('weekday', 11);
    addUnitPriority('isoWeekday', 11);

    // PARSING

    addRegexToken('d', match1to2);
    addRegexToken('e', match1to2);
    addRegexToken('E', match1to2);
    addRegexToken('dd', function(isStrict, locale) {
        return locale.weekdaysMinRegex(isStrict);
    });
    addRegexToken('ddd', function(isStrict, locale) {
        return locale.weekdaysShortRegex(isStrict);
    });
    addRegexToken('dddd', function(isStrict, locale) {
        return locale.weekdaysRegex(isStrict);
    });

    addWeekParseToken(['dd', 'ddd', 'dddd'], function(input, week, config, token) {
        var weekday = config._locale.weekdaysParse(input, token, config._strict);
        // if we didn't get a weekday name, mark the date as invalid
        if (weekday != null) {
            week.d = weekday;
        } else {
            getParsingFlags(config).invalidWeekday = input;
        }
    });

    addWeekParseToken(['d', 'e', 'E'], function(input, week, config, token) {
        week[token] = toInt(input);
    });

    // HELPERS

    function parseWeekday(input, locale) {
        if (typeof input !== 'string') {
            return input;
        }

        if (!isNaN(input)) {
            return parseInt(input, 10);
        }

        input = locale.weekdaysParse(input);
        if (typeof input === 'number') {
            return input;
        }

        return null;
    }

    function parseIsoWeekday(input, locale) {
        if (typeof input === 'string') {
            return locale.weekdaysParse(input) % 7 || 7;
        }
        return isNaN(input) ? null : input;
    }

    // LOCALES

    var defaultLocaleWeekdays = 'Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday'.split('_');

    function localeWeekdays(m, format) {
        if (!m) {
            return isArray(this._weekdays) ? this._weekdays :
                this._weekdays['standalone'];
        }
        return isArray(this._weekdays) ? this._weekdays[m.day()] :
            this._weekdays[this._weekdays.isFormat.test(format) ? 'format' : 'standalone'][m.day()];
    }

    var defaultLocaleWeekdaysShort = 'Sun_Mon_Tue_Wed_Thu_Fri_Sat'.split('_');

    function localeWeekdaysShort(m) {
        return (m) ? this._weekdaysShort[m.day()] : this._weekdaysShort;
    }

    var defaultLocaleWeekdaysMin = 'Su_Mo_Tu_We_Th_Fr_Sa'.split('_');

    function localeWeekdaysMin(m) {
        return (m) ? this._weekdaysMin[m.day()] : this._weekdaysMin;
    }

    function handleStrictParse$1(weekdayName, format, strict) {
        var i, ii, mom, llc = weekdayName.toLocaleLowerCase();
        if (!this._weekdaysParse) {
            this._weekdaysParse = [];
            this._shortWeekdaysParse = [];
            this._minWeekdaysParse = [];

            for (i = 0; i < 7; ++i) {
                mom = createUTC([2000, 1]).day(i);
                this._minWeekdaysParse[i] = this.weekdaysMin(mom, '').toLocaleLowerCase();
                this._shortWeekdaysParse[i] = this.weekdaysShort(mom, '').toLocaleLowerCase();
                this._weekdaysParse[i] = this.weekdays(mom, '').toLocaleLowerCase();
            }
        }

        if (strict) {
            if (format === 'dddd') {
                ii = indexOf$1.call(this._weekdaysParse, llc);
                return ii !== -1 ? ii : null;
            } else if (format === 'ddd') {
                ii = indexOf$1.call(this._shortWeekdaysParse, llc);
                return ii !== -1 ? ii : null;
            } else {
                ii = indexOf$1.call(this._minWeekdaysParse, llc);
                return ii !== -1 ? ii : null;
            }
        } else {
            if (format === 'dddd') {
                ii = indexOf$1.call(this._weekdaysParse, llc);
                if (ii !== -1) {
                    return ii;
                }
                ii = indexOf$1.call(this._shortWeekdaysParse, llc);
                if (ii !== -1) {
                    return ii;
                }
                ii = indexOf$1.call(this._minWeekdaysParse, llc);
                return ii !== -1 ? ii : null;
            } else if (format === 'ddd') {
                ii = indexOf$1.call(this._shortWeekdaysParse, llc);
                if (ii !== -1) {
                    return ii;
                }
                ii = indexOf$1.call(this._weekdaysParse, llc);
                if (ii !== -1) {
                    return ii;
                }
                ii = indexOf$1.call(this._minWeekdaysParse, llc);
                return ii !== -1 ? ii : null;
            } else {
                ii = indexOf$1.call(this._minWeekdaysParse, llc);
                if (ii !== -1) {
                    return ii;
                }
                ii = indexOf$1.call(this._weekdaysParse, llc);
                if (ii !== -1) {
                    return ii;
                }
                ii = indexOf$1.call(this._shortWeekdaysParse, llc);
                return ii !== -1 ? ii : null;
            }
        }
    }

    function localeWeekdaysParse(weekdayName, format, strict) {
        var i, mom, regex;

        if (this._weekdaysParseExact) {
            return handleStrictParse$1.call(this, weekdayName, format, strict);
        }

        if (!this._weekdaysParse) {
            this._weekdaysParse = [];
            this._minWeekdaysParse = [];
            this._shortWeekdaysParse = [];
            this._fullWeekdaysParse = [];
        }

        for (i = 0; i < 7; i++) {
            // make the regex if we don't have it already

            mom = createUTC([2000, 1]).day(i);
            if (strict && !this._fullWeekdaysParse[i]) {
                this._fullWeekdaysParse[i] = new RegExp('^' + this.weekdays(mom, '').replace('.', '\.?') + '$', 'i');
                this._shortWeekdaysParse[i] = new RegExp('^' + this.weekdaysShort(mom, '').replace('.', '\.?') + '$', 'i');
                this._minWeekdaysParse[i] = new RegExp('^' + this.weekdaysMin(mom, '').replace('.', '\.?') + '$', 'i');
            }
            if (!this._weekdaysParse[i]) {
                regex = '^' + this.weekdays(mom, '') + '|^' + this.weekdaysShort(mom, '') + '|^' + this.weekdaysMin(mom, '');
                this._weekdaysParse[i] = new RegExp(regex.replace('.', ''), 'i');
            }
            // test the regex
            if (strict && format === 'dddd' && this._fullWeekdaysParse[i].test(weekdayName)) {
                return i;
            } else if (strict && format === 'ddd' && this._shortWeekdaysParse[i].test(weekdayName)) {
                return i;
            } else if (strict && format === 'dd' && this._minWeekdaysParse[i].test(weekdayName)) {
                return i;
            } else if (!strict && this._weekdaysParse[i].test(weekdayName)) {
                return i;
            }
        }
    }

    // MOMENTS

    function getSetDayOfWeek(input) {
        if (!this.isValid()) {
            return input != null ? this : NaN;
        }
        var day = this._isUTC ? this._d.getUTCDay() : this._d.getDay();
        if (input != null) {
            input = parseWeekday(input, this.localeData());
            return this.add(input - day, 'd');
        } else {
            return day;
        }
    }

    function getSetLocaleDayOfWeek(input) {
        if (!this.isValid()) {
            return input != null ? this : NaN;
        }
        var weekday = (this.day() + 7 - this.localeData()._week.dow) % 7;
        return input == null ? weekday : this.add(input - weekday, 'd');
    }

    function getSetISODayOfWeek(input) {
        if (!this.isValid()) {
            return input != null ? this : NaN;
        }

        // behaves the same as moment#day except
        // as a getter, returns 7 instead of 0 (1-7 range instead of 0-6)
        // as a setter, sunday should belong to the previous week.

        if (input != null) {
            var weekday = parseIsoWeekday(input, this.localeData());
            return this.day(this.day() % 7 ? weekday : weekday - 7);
        } else {
            return this.day() || 7;
        }
    }

    var defaultWeekdaysRegex = matchWord;

    function weekdaysRegex(isStrict) {
        if (this._weekdaysParseExact) {
            if (!hasOwnProp(this, '_weekdaysRegex')) {
                computeWeekdaysParse.call(this);
            }
            if (isStrict) {
                return this._weekdaysStrictRegex;
            } else {
                return this._weekdaysRegex;
            }
        } else {
            if (!hasOwnProp(this, '_weekdaysRegex')) {
                this._weekdaysRegex = defaultWeekdaysRegex;
            }
            return this._weekdaysStrictRegex && isStrict ?
                this._weekdaysStrictRegex : this._weekdaysRegex;
        }
    }

    var defaultWeekdaysShortRegex = matchWord;

    function weekdaysShortRegex(isStrict) {
        if (this._weekdaysParseExact) {
            if (!hasOwnProp(this, '_weekdaysRegex')) {
                computeWeekdaysParse.call(this);
            }
            if (isStrict) {
                return this._weekdaysShortStrictRegex;
            } else {
                return this._weekdaysShortRegex;
            }
        } else {
            if (!hasOwnProp(this, '_weekdaysShortRegex')) {
                this._weekdaysShortRegex = defaultWeekdaysShortRegex;
            }
            return this._weekdaysShortStrictRegex && isStrict ?
                this._weekdaysShortStrictRegex : this._weekdaysShortRegex;
        }
    }

    var defaultWeekdaysMinRegex = matchWord;

    function weekdaysMinRegex(isStrict) {
        if (this._weekdaysParseExact) {
            if (!hasOwnProp(this, '_weekdaysRegex')) {
                computeWeekdaysParse.call(this);
            }
            if (isStrict) {
                return this._weekdaysMinStrictRegex;
            } else {
                return this._weekdaysMinRegex;
            }
        } else {
            if (!hasOwnProp(this, '_weekdaysMinRegex')) {
                this._weekdaysMinRegex = defaultWeekdaysMinRegex;
            }
            return this._weekdaysMinStrictRegex && isStrict ?
                this._weekdaysMinStrictRegex : this._weekdaysMinRegex;
        }
    }


    function computeWeekdaysParse() {
        function cmpLenRev(a, b) {
            return b.length - a.length;
        }

        var minPieces = [],
            shortPieces = [],
            longPieces = [],
            mixedPieces = [],
            i, mom, minp, shortp, longp;
        for (i = 0; i < 7; i++) {
            // make the regex if we don't have it already
            mom = createUTC([2000, 1]).day(i);
            minp = this.weekdaysMin(mom, '');
            shortp = this.weekdaysShort(mom, '');
            longp = this.weekdays(mom, '');
            minPieces.push(minp);
            shortPieces.push(shortp);
            longPieces.push(longp);
            mixedPieces.push(minp);
            mixedPieces.push(shortp);
            mixedPieces.push(longp);
        }
        // Sorting makes sure if one weekday (or abbr) is a prefix of another it
        // will match the longer piece.
        minPieces.sort(cmpLenRev);
        shortPieces.sort(cmpLenRev);
        longPieces.sort(cmpLenRev);
        mixedPieces.sort(cmpLenRev);
        for (i = 0; i < 7; i++) {
            shortPieces[i] = regexEscape(shortPieces[i]);
            longPieces[i] = regexEscape(longPieces[i]);
            mixedPieces[i] = regexEscape(mixedPieces[i]);
        }

        this._weekdaysRegex = new RegExp('^(' + mixedPieces.join('|') + ')', 'i');
        this._weekdaysShortRegex = this._weekdaysRegex;
        this._weekdaysMinRegex = this._weekdaysRegex;

        this._weekdaysStrictRegex = new RegExp('^(' + longPieces.join('|') + ')', 'i');
        this._weekdaysShortStrictRegex = new RegExp('^(' + shortPieces.join('|') + ')', 'i');
        this._weekdaysMinStrictRegex = new RegExp('^(' + minPieces.join('|') + ')', 'i');
    }

    // FORMATTING

    function hFormat() {
        return this.hours() % 12 || 12;
    }

    function kFormat() {
        return this.hours() || 24;
    }

    addFormatToken('H', ['HH', 2], 0, 'hour');
    addFormatToken('h', ['hh', 2], 0, hFormat);
    addFormatToken('k', ['kk', 2], 0, kFormat);

    addFormatToken('hmm', 0, 0, function() {
        return '' + hFormat.apply(this) + zeroFill(this.minutes(), 2);
    });

    addFormatToken('hmmss', 0, 0, function() {
        return '' + hFormat.apply(this) + zeroFill(this.minutes(), 2) +
            zeroFill(this.seconds(), 2);
    });

    addFormatToken('Hmm', 0, 0, function() {
        return '' + this.hours() + zeroFill(this.minutes(), 2);
    });

    addFormatToken('Hmmss', 0, 0, function() {
        return '' + this.hours() + zeroFill(this.minutes(), 2) +
            zeroFill(this.seconds(), 2);
    });

    function meridiem(token, lowercase) {
        addFormatToken(token, 0, 0, function() {
            return this.localeData().meridiem(this.hours(), this.minutes(), lowercase);
        });
    }

    meridiem('a', true);
    meridiem('A', false);

    // ALIASES

    addUnitAlias('hour', 'h');

    // PRIORITY
    addUnitPriority('hour', 13);

    // PARSING

    function matchMeridiem(isStrict, locale) {
        return locale._meridiemParse;
    }

    addRegexToken('a', matchMeridiem);
    addRegexToken('A', matchMeridiem);
    addRegexToken('H', match1to2);
    addRegexToken('h', match1to2);
    addRegexToken('k', match1to2);
    addRegexToken('HH', match1to2, match2);
    addRegexToken('hh', match1to2, match2);
    addRegexToken('kk', match1to2, match2);

    addRegexToken('hmm', match3to4);
    addRegexToken('hmmss', match5to6);
    addRegexToken('Hmm', match3to4);
    addRegexToken('Hmmss', match5to6);

    addParseToken(['H', 'HH'], HOUR);
    addParseToken(['k', 'kk'], function(input, array, config) {
        var kInput = toInt(input);
        array[HOUR] = kInput === 24 ? 0 : kInput;
    });
    addParseToken(['a', 'A'], function(input, array, config) {
        config._isPm = config._locale.isPM(input);
        config._meridiem = input;
    });
    addParseToken(['h', 'hh'], function(input, array, config) {
        array[HOUR] = toInt(input);
        getParsingFlags(config).bigHour = true;
    });
    addParseToken('hmm', function(input, array, config) {
        var pos = input.length - 2;
        array[HOUR] = toInt(input.substr(0, pos));
        array[MINUTE] = toInt(input.substr(pos));
        getParsingFlags(config).bigHour = true;
    });
    addParseToken('hmmss', function(input, array, config) {
        var pos1 = input.length - 4;
        var pos2 = input.length - 2;
        array[HOUR] = toInt(input.substr(0, pos1));
        array[MINUTE] = toInt(input.substr(pos1, 2));
        array[SECOND] = toInt(input.substr(pos2));
        getParsingFlags(config).bigHour = true;
    });
    addParseToken('Hmm', function(input, array, config) {
        var pos = input.length - 2;
        array[HOUR] = toInt(input.substr(0, pos));
        array[MINUTE] = toInt(input.substr(pos));
    });
    addParseToken('Hmmss', function(input, array, config) {
        var pos1 = input.length - 4;
        var pos2 = input.length - 2;
        array[HOUR] = toInt(input.substr(0, pos1));
        array[MINUTE] = toInt(input.substr(pos1, 2));
        array[SECOND] = toInt(input.substr(pos2));
    });

    // LOCALES

    function localeIsPM(input) {
        // IE8 Quirks Mode & IE7 Standards Mode do not allow accessing strings like arrays
        // Using charAt should be more compatible.
        return ((input + '').toLowerCase().charAt(0) === 'p');
    }

    var defaultLocaleMeridiemParse = /[ap]\.?m?\.?/i;

    function localeMeridiem(hours, minutes, isLower) {
        if (hours > 11) {
            return isLower ? 'pm' : 'PM';
        } else {
            return isLower ? 'am' : 'AM';
        }
    }


    // MOMENTS

    // Setting the hour should keep the time, because the user explicitly
    // specified which hour he wants. So trying to maintain the same hour (in
    // a new timezone) makes sense. Adding/subtracting hours does not follow
    // this rule.
    var getSetHour = makeGetSet('Hours', true);

    // months
    // week
    // weekdays
    // meridiem
    var baseConfig = {
        calendar: defaultCalendar,
        longDateFormat: defaultLongDateFormat,
        invalidDate: defaultInvalidDate,
        ordinal: defaultOrdinal,
        dayOfMonthOrdinalParse: defaultDayOfMonthOrdinalParse,
        relativeTime: defaultRelativeTime,

        months: defaultLocaleMonths,
        monthsShort: defaultLocaleMonthsShort,

        week: defaultLocaleWeek,

        weekdays: defaultLocaleWeekdays,
        weekdaysMin: defaultLocaleWeekdaysMin,
        weekdaysShort: defaultLocaleWeekdaysShort,

        meridiemParse: defaultLocaleMeridiemParse
    };

    // internal storage for locale config files
    var locales = {};
    var localeFamilies = {};
    var globalLocale;

    function normalizeLocale(key) {
        return key ? key.toLowerCase().replace('_', '-') : key;
    }

    // pick the locale from the array
    // try ['en-au', 'en-gb'] as 'en-au', 'en-gb', 'en', as in move through the list trying each
    // substring from most specific to least, but move to the next array item if it's a more specific variant than the current root
    function chooseLocale(names) {
        var i = 0,
            j, next, locale, split;

        while (i < names.length) {
            split = normalizeLocale(names[i]).split('-');
            j = split.length;
            next = normalizeLocale(names[i + 1]);
            next = next ? next.split('-') : null;
            while (j > 0) {
                locale = loadLocale(split.slice(0, j).join('-'));
                if (locale) {
                    return locale;
                }
                if (next && next.length >= j && compareArrays(split, next, true) >= j - 1) {
                    //the next array item is better than a shallower substring of this one
                    break;
                }
                j--;
            }
            i++;
        }
        return null;
    }

    function loadLocale(name) {
        var oldLocale = null;
        // TODO: Find a better way to register and load all the locales in Node
        if (!locales[name] && (typeof module !== 'undefined') &&
            module && module.exports) {
            try {
                oldLocale = globalLocale._abbr;
                require('./locale/' + name);
                // because defineLocale currently also sets the global locale, we
                // want to undo that for lazy loaded locales
                getSetGlobalLocale(oldLocale);
            } catch (e) {}
        }
        return locales[name];
    }

    // This function will load locale and then set the global locale.  If
    // no arguments are passed in, it will simply return the current global
    // locale key.
    function getSetGlobalLocale(key, values) {
        var data;
        if (key) {
            if (isUndefined(values)) {
                data = getLocale(key);
            } else {
                data = defineLocale(key, values);
            }

            if (data) {
                // moment.duration._locale = moment._locale = data;
                globalLocale = data;
            }
        }

        return globalLocale._abbr;
    }

    function defineLocale(name, config) {
        if (config !== null) {
            var parentConfig = baseConfig;
            config.abbr = name;
            if (locales[name] != null) {
                deprecateSimple('defineLocaleOverride',
                    'use moment.updateLocale(localeName, config) to change ' +
                    'an existing locale. moment.defineLocale(localeName, ' +
                    'config) should only be used for creating a new locale ' +
                    'See http://momentjs.com/guides/#/warnings/define-locale/ for more info.');
                parentConfig = locales[name]._config;
            } else if (config.parentLocale != null) {
                if (locales[config.parentLocale] != null) {
                    parentConfig = locales[config.parentLocale]._config;
                } else {
                    if (!localeFamilies[config.parentLocale]) {
                        localeFamilies[config.parentLocale] = [];
                    }
                    localeFamilies[config.parentLocale].push({
                        name: name,
                        config: config
                    });
                    return null;
                }
            }
            locales[name] = new Locale(mergeConfigs(parentConfig, config));

            if (localeFamilies[name]) {
                localeFamilies[name].forEach(function(x) {
                    defineLocale(x.name, x.config);
                });
            }

            // backwards compat for now: also set the locale
            // make sure we set the locale AFTER all child locales have been
            // created, so we won't end up with the child locale set.
            getSetGlobalLocale(name);


            return locales[name];
        } else {
            // useful for testing
            delete locales[name];
            return null;
        }
    }

    function updateLocale(name, config) {
        if (config != null) {
            var locale, parentConfig = baseConfig;
            // MERGE
            if (locales[name] != null) {
                parentConfig = locales[name]._config;
            }
            config = mergeConfigs(parentConfig, config);
            locale = new Locale(config);
            locale.parentLocale = locales[name];
            locales[name] = locale;

            // backwards compat for now: also set the locale
            getSetGlobalLocale(name);
        } else {
            // pass null for config to unupdate, useful for tests
            if (locales[name] != null) {
                if (locales[name].parentLocale != null) {
                    locales[name] = locales[name].parentLocale;
                } else if (locales[name] != null) {
                    delete locales[name];
                }
            }
        }
        return locales[name];
    }

    // returns locale data
    function getLocale(key) {
        var locale;

        if (key && key._locale && key._locale._abbr) {
            key = key._locale._abbr;
        }

        if (!key) {
            return globalLocale;
        }

        if (!isArray(key)) {
            //short-circuit everything else
            locale = loadLocale(key);
            if (locale) {
                return locale;
            }
            key = [key];
        }

        return chooseLocale(key);
    }

    function listLocales() {
        return keys$1(locales);
    }

    function checkOverflow(m) {
        var overflow;
        var a = m._a;

        if (a && getParsingFlags(m).overflow === -2) {
            overflow =
                a[MONTH] < 0 || a[MONTH] > 11 ? MONTH :
                a[DATE] < 1 || a[DATE] > daysInMonth(a[YEAR], a[MONTH]) ? DATE :
                a[HOUR] < 0 || a[HOUR] > 24 || (a[HOUR] === 24 && (a[MINUTE] !== 0 || a[SECOND] !== 0 || a[MILLISECOND] !== 0)) ? HOUR :
                a[MINUTE] < 0 || a[MINUTE] > 59 ? MINUTE :
                a[SECOND] < 0 || a[SECOND] > 59 ? SECOND :
                a[MILLISECOND] < 0 || a[MILLISECOND] > 999 ? MILLISECOND :
                -1;

            if (getParsingFlags(m)._overflowDayOfYear && (overflow < YEAR || overflow > DATE)) {
                overflow = DATE;
            }
            if (getParsingFlags(m)._overflowWeeks && overflow === -1) {
                overflow = WEEK;
            }
            if (getParsingFlags(m)._overflowWeekday && overflow === -1) {
                overflow = WEEKDAY;
            }

            getParsingFlags(m).overflow = overflow;
        }

        return m;
    }

    // iso 8601 regex
    // 0000-00-00 0000-W00 or 0000-W00-0 + T + 00 or 00:00 or 00:00:00 or 00:00:00.000 + +00:00 or +0000 or +00)
    var extendedIsoRegex = /^\s*((?:[+-]\d{6}|\d{4})-(?:\d\d-\d\d|W\d\d-\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?::\d\d(?::\d\d(?:[.,]\d+)?)?)?)([\+\-]\d\d(?::?\d\d)?|\s*Z)?)?$/;
    var basicIsoRegex = /^\s*((?:[+-]\d{6}|\d{4})(?:\d\d\d\d|W\d\d\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?:\d\d(?:\d\d(?:[.,]\d+)?)?)?)([\+\-]\d\d(?::?\d\d)?|\s*Z)?)?$/;

    var tzRegex = /Z|[+-]\d\d(?::?\d\d)?/;

    var isoDates = [
        ['YYYYYY-MM-DD', /[+-]\d{6}-\d\d-\d\d/],
        ['YYYY-MM-DD', /\d{4}-\d\d-\d\d/],
        ['GGGG-[W]WW-E', /\d{4}-W\d\d-\d/],
        ['GGGG-[W]WW', /\d{4}-W\d\d/, false],
        ['YYYY-DDD', /\d{4}-\d{3}/],
        ['YYYY-MM', /\d{4}-\d\d/, false],
        ['YYYYYYMMDD', /[+-]\d{10}/],
        ['YYYYMMDD', /\d{8}/],
        // YYYYMM is NOT allowed by the standard
        ['GGGG[W]WWE', /\d{4}W\d{3}/],
        ['GGGG[W]WW', /\d{4}W\d{2}/, false],
        ['YYYYDDD', /\d{7}/]
    ];

    // iso time formats and regexes
    var isoTimes = [
        ['HH:mm:ss.SSSS', /\d\d:\d\d:\d\d\.\d+/],
        ['HH:mm:ss,SSSS', /\d\d:\d\d:\d\d,\d+/],
        ['HH:mm:ss', /\d\d:\d\d:\d\d/],
        ['HH:mm', /\d\d:\d\d/],
        ['HHmmss.SSSS', /\d\d\d\d\d\d\.\d+/],
        ['HHmmss,SSSS', /\d\d\d\d\d\d,\d+/],
        ['HHmmss', /\d\d\d\d\d\d/],
        ['HHmm', /\d\d\d\d/],
        ['HH', /\d\d/]
    ];

    var aspNetJsonRegex = /^\/?Date\((\-?\d+)/i;

    // date from iso format
    function configFromISO(config) {
        var i, l,
            string = config._i,
            match = extendedIsoRegex.exec(string) || basicIsoRegex.exec(string),
            allowTime, dateFormat, timeFormat, tzFormat;

        if (match) {
            getParsingFlags(config).iso = true;

            for (i = 0, l = isoDates.length; i < l; i++) {
                if (isoDates[i][1].exec(match[1])) {
                    dateFormat = isoDates[i][0];
                    allowTime = isoDates[i][2] !== false;
                    break;
                }
            }
            if (dateFormat == null) {
                config._isValid = false;
                return;
            }
            if (match[3]) {
                for (i = 0, l = isoTimes.length; i < l; i++) {
                    if (isoTimes[i][1].exec(match[3])) {
                        // match[2] should be 'T' or space
                        timeFormat = (match[2] || ' ') + isoTimes[i][0];
                        break;
                    }
                }
                if (timeFormat == null) {
                    config._isValid = false;
                    return;
                }
            }
            if (!allowTime && timeFormat != null) {
                config._isValid = false;
                return;
            }
            if (match[4]) {
                if (tzRegex.exec(match[4])) {
                    tzFormat = 'Z';
                } else {
                    config._isValid = false;
                    return;
                }
            }
            config._f = dateFormat + (timeFormat || '') + (tzFormat || '');
            configFromStringAndFormat(config);
        } else {
            config._isValid = false;
        }
    }

    // RFC 2822 regex: For details see https://tools.ietf.org/html/rfc2822#section-3.3
    var basicRfcRegex = /^((?:Mon|Tue|Wed|Thu|Fri|Sat|Sun),?\s)?(\d?\d\s(?:Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)\s(?:\d\d)?\d\d\s)(\d\d:\d\d)(\:\d\d)?(\s(?:UT|GMT|[ECMP][SD]T|[A-IK-Za-ik-z]|[+-]\d{4}))$/;

    // date and time from ref 2822 format
    function configFromRFC2822(config) {
        var string, match, dayFormat,
            dateFormat, timeFormat, tzFormat;
        var timezones = {
            ' GMT': ' +0000',
            ' EDT': ' -0400',
            ' EST': ' -0500',
            ' CDT': ' -0500',
            ' CST': ' -0600',
            ' MDT': ' -0600',
            ' MST': ' -0700',
            ' PDT': ' -0700',
            ' PST': ' -0800'
        };
        var military = 'YXWVUTSRQPONZABCDEFGHIKLM';
        var timezone, timezoneIndex;

        string = config._i
            .replace(/\([^\)]*\)|[\n\t]/g, ' ') // Remove comments and folding whitespace
            .replace(/(\s\s+)/g, ' ') // Replace multiple-spaces with a single space
            .replace(/^\s|\s$/g, ''); // Remove leading and trailing spaces
        match = basicRfcRegex.exec(string);

        if (match) {
            dayFormat = match[1] ? 'ddd' + ((match[1].length === 5) ? ', ' : ' ') : '';
            dateFormat = 'D MMM ' + ((match[2].length > 10) ? 'YYYY ' : 'YY ');
            timeFormat = 'HH:mm' + (match[4] ? ':ss' : '');

            // TODO: Replace the vanilla JS Date object with an indepentent day-of-week check.
            if (match[1]) { // day of week given
                var momentDate = new Date(match[2]);
                var momentDay = ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat'][momentDate.getDay()];

                if (match[1].substr(0, 3) !== momentDay) {
                    getParsingFlags(config).weekdayMismatch = true;
                    config._isValid = false;
                    return;
                }
            }

            switch (match[5].length) {
                case 2: // military
                    if (timezoneIndex === 0) {
                        timezone = ' +0000';
                    } else {
                        timezoneIndex = military.indexOf(match[5][1].toUpperCase()) - 12;
                        timezone = ((timezoneIndex < 0) ? ' -' : ' +') +
                            (('' + timezoneIndex).replace(/^-?/, '0')).match(/..$/)[0] + '00';
                    }
                    break;
                case 4: // Zone
                    timezone = timezones[match[5]];
                    break;
                default: // UT or +/-9999
                    timezone = timezones[' GMT'];
            }
            match[5] = timezone;
            config._i = match.splice(1).join('');
            tzFormat = ' ZZ';
            config._f = dayFormat + dateFormat + timeFormat + tzFormat;
            configFromStringAndFormat(config);
            getParsingFlags(config).rfc2822 = true;
        } else {
            config._isValid = false;
        }
    }

    // date from iso format or fallback
    function configFromString(config) {
        var matched = aspNetJsonRegex.exec(config._i);

        if (matched !== null) {
            config._d = new Date(+matched[1]);
            return;
        }

        configFromISO(config);
        if (config._isValid === false) {
            delete config._isValid;
        } else {
            return;
        }

        configFromRFC2822(config);
        if (config._isValid === false) {
            delete config._isValid;
        } else {
            return;
        }

        // Final attempt, use Input Fallback
        hooks.createFromInputFallback(config);
    }

    hooks.createFromInputFallback = deprecate(
        'value provided is not in a recognized RFC2822 or ISO format. moment construction falls back to js Date(), ' +
        'which is not reliable across all browsers and versions. Non RFC2822/ISO date formats are ' +
        'discouraged and will be removed in an upcoming major release. Please refer to ' +
        'http://momentjs.com/guides/#/warnings/js-date/ for more info.',
        function(config) {
            config._d = new Date(config._i + (config._useUTC ? ' UTC' : ''));
        }
    );

    // Pick the first defined of two or three arguments.
    function defaults(a, b, c) {
        if (a != null) {
            return a;
        }
        if (b != null) {
            return b;
        }
        return c;
    }

    function currentDateArray(config) {
        // hooks is actually the exported moment object
        var nowValue = new Date(hooks.now());
        if (config._useUTC) {
            return [nowValue.getUTCFullYear(), nowValue.getUTCMonth(), nowValue.getUTCDate()];
        }
        return [nowValue.getFullYear(), nowValue.getMonth(), nowValue.getDate()];
    }

    // convert an array to a date.
    // the array should mirror the parameters below
    // note: all values past the year are optional and will default to the lowest possible value.
    // [year, month, day , hour, minute, second, millisecond]
    function configFromArray(config) {
        var i, date, input = [],
            currentDate, yearToUse;

        if (config._d) {
            return;
        }

        currentDate = currentDateArray(config);

        //compute day of the year from weeks and weekdays
        if (config._w && config._a[DATE] == null && config._a[MONTH] == null) {
            dayOfYearFromWeekInfo(config);
        }

        //if the day of the year is set, figure out what it is
        if (config._dayOfYear != null) {
            yearToUse = defaults(config._a[YEAR], currentDate[YEAR]);

            if (config._dayOfYear > daysInYear(yearToUse) || config._dayOfYear === 0) {
                getParsingFlags(config)._overflowDayOfYear = true;
            }

            date = createUTCDate(yearToUse, 0, config._dayOfYear);
            config._a[MONTH] = date.getUTCMonth();
            config._a[DATE] = date.getUTCDate();
        }

        // Default to current date.
        // * if no year, month, day of month are given, default to today
        // * if day of month is given, default month and year
        // * if month is given, default only year
        // * if year is given, don't default anything
        for (i = 0; i < 3 && config._a[i] == null; ++i) {
            config._a[i] = input[i] = currentDate[i];
        }

        // Zero out whatever was not defaulted, including time
        for (; i < 7; i++) {
            config._a[i] = input[i] = (config._a[i] == null) ? (i === 2 ? 1 : 0) : config._a[i];
        }

        // Check for 24:00:00.000
        if (config._a[HOUR] === 24 &&
            config._a[MINUTE] === 0 &&
            config._a[SECOND] === 0 &&
            config._a[MILLISECOND] === 0) {
            config._nextDay = true;
            config._a[HOUR] = 0;
        }

        config._d = (config._useUTC ? createUTCDate : createDate).apply(null, input);
        // Apply timezone offset from input. The actual utcOffset can be changed
        // with parseZone.
        if (config._tzm != null) {
            config._d.setUTCMinutes(config._d.getUTCMinutes() - config._tzm);
        }

        if (config._nextDay) {
            config._a[HOUR] = 24;
        }
    }

    function dayOfYearFromWeekInfo(config) {
        var w, weekYear, week, weekday, dow, doy, temp, weekdayOverflow;

        w = config._w;
        if (w.GG != null || w.W != null || w.E != null) {
            dow = 1;
            doy = 4;

            // TODO: We need to take the current isoWeekYear, but that depends on
            // how we interpret now (local, utc, fixed offset). So create
            // a now version of current config (take local/utc/offset flags, and
            // create now).
            weekYear = defaults(w.GG, config._a[YEAR], weekOfYear(createLocal(), 1, 4).year);
            week = defaults(w.W, 1);
            weekday = defaults(w.E, 1);
            if (weekday < 1 || weekday > 7) {
                weekdayOverflow = true;
            }
        } else {
            dow = config._locale._week.dow;
            doy = config._locale._week.doy;

            var curWeek = weekOfYear(createLocal(), dow, doy);

            weekYear = defaults(w.gg, config._a[YEAR], curWeek.year);

            // Default to current week.
            week = defaults(w.w, curWeek.week);

            if (w.d != null) {
                // weekday -- low day numbers are considered next week
                weekday = w.d;
                if (weekday < 0 || weekday > 6) {
                    weekdayOverflow = true;
                }
            } else if (w.e != null) {
                // local weekday -- counting starts from begining of week
                weekday = w.e + dow;
                if (w.e < 0 || w.e > 6) {
                    weekdayOverflow = true;
                }
            } else {
                // default to begining of week
                weekday = dow;
            }
        }
        if (week < 1 || week > weeksInYear(weekYear, dow, doy)) {
            getParsingFlags(config)._overflowWeeks = true;
        } else if (weekdayOverflow != null) {
            getParsingFlags(config)._overflowWeekday = true;
        } else {
            temp = dayOfYearFromWeeks(weekYear, week, weekday, dow, doy);
            config._a[YEAR] = temp.year;
            config._dayOfYear = temp.dayOfYear;
        }
    }

    // constant that refers to the ISO standard
    hooks.ISO_8601 = function() {};

    // constant that refers to the RFC 2822 form
    hooks.RFC_2822 = function() {};

    // date from string and format string
    function configFromStringAndFormat(config) {
        // TODO: Move this to another part of the creation flow to prevent circular deps
        if (config._f === hooks.ISO_8601) {
            configFromISO(config);
            return;
        }
        if (config._f === hooks.RFC_2822) {
            configFromRFC2822(config);
            return;
        }
        config._a = [];
        getParsingFlags(config).empty = true;

        // This array is used to make a Date, either with `new Date` or `Date.UTC`
        var string = '' + config._i,
            i, parsedInput, tokens, token, skipped,
            stringLength = string.length,
            totalParsedInputLength = 0;

        tokens = expandFormat(config._f, config._locale).match(formattingTokens) || [];

        for (i = 0; i < tokens.length; i++) {
            token = tokens[i];
            parsedInput = (string.match(getParseRegexForToken(token, config)) || [])[0];
            // console.log('token', token, 'parsedInput', parsedInput,
            //         'regex', getParseRegexForToken(token, config));
            if (parsedInput) {
                skipped = string.substr(0, string.indexOf(parsedInput));
                if (skipped.length > 0) {
                    getParsingFlags(config).unusedInput.push(skipped);
                }
                string = string.slice(string.indexOf(parsedInput) + parsedInput.length);
                totalParsedInputLength += parsedInput.length;
            }
            // don't parse if it's not a known token
            if (formatTokenFunctions[token]) {
                if (parsedInput) {
                    getParsingFlags(config).empty = false;
                } else {
                    getParsingFlags(config).unusedTokens.push(token);
                }
                addTimeToArrayFromToken(token, parsedInput, config);
            } else if (config._strict && !parsedInput) {
                getParsingFlags(config).unusedTokens.push(token);
            }
        }

        // add remaining unparsed input length to the string
        getParsingFlags(config).charsLeftOver = stringLength - totalParsedInputLength;
        if (string.length > 0) {
            getParsingFlags(config).unusedInput.push(string);
        }

        // clear _12h flag if hour is <= 12
        if (config._a[HOUR] <= 12 &&
            getParsingFlags(config).bigHour === true &&
            config._a[HOUR] > 0) {
            getParsingFlags(config).bigHour = undefined;
        }

        getParsingFlags(config).parsedDateParts = config._a.slice(0);
        getParsingFlags(config).meridiem = config._meridiem;
        // handle meridiem
        config._a[HOUR] = meridiemFixWrap(config._locale, config._a[HOUR], config._meridiem);

        configFromArray(config);
        checkOverflow(config);
    }


    function meridiemFixWrap(locale, hour, meridiem) {
        var isPm;

        if (meridiem == null) {
            // nothing to do
            return hour;
        }
        if (locale.meridiemHour != null) {
            return locale.meridiemHour(hour, meridiem);
        } else if (locale.isPM != null) {
            // Fallback
            isPm = locale.isPM(meridiem);
            if (isPm && hour < 12) {
                hour += 12;
            }
            if (!isPm && hour === 12) {
                hour = 0;
            }
            return hour;
        } else {
            // this is not supposed to happen
            return hour;
        }
    }

    // date from string and array of format strings
    function configFromStringAndArray(config) {
        var tempConfig,
            bestMoment,

            scoreToBeat,
            i,
            currentScore;

        if (config._f.length === 0) {
            getParsingFlags(config).invalidFormat = true;
            config._d = new Date(NaN);
            return;
        }

        for (i = 0; i < config._f.length; i++) {
            currentScore = 0;
            tempConfig = copyConfig({}, config);
            if (config._useUTC != null) {
                tempConfig._useUTC = config._useUTC;
            }
            tempConfig._f = config._f[i];
            configFromStringAndFormat(tempConfig);

            if (!isValid(tempConfig)) {
                continue;
            }

            // if there is any input that was not parsed add a penalty for that format
            currentScore += getParsingFlags(tempConfig).charsLeftOver;

            //or tokens
            currentScore += getParsingFlags(tempConfig).unusedTokens.length * 10;

            getParsingFlags(tempConfig).score = currentScore;

            if (scoreToBeat == null || currentScore < scoreToBeat) {
                scoreToBeat = currentScore;
                bestMoment = tempConfig;
            }
        }

        extend(config, bestMoment || tempConfig);
    }

    function configFromObject(config) {
        if (config._d) {
            return;
        }

        var i = normalizeObjectUnits(config._i);
        config._a = map([i.year, i.month, i.day || i.date, i.hour, i.minute, i.second, i.millisecond], function(obj) {
            return obj && parseInt(obj, 10);
        });

        configFromArray(config);
    }

    function createFromConfig(config) {
        var res = new Moment(checkOverflow(prepareConfig(config)));
        if (res._nextDay) {
            // Adding is smart enough around DST
            res.add(1, 'd');
            res._nextDay = undefined;
        }

        return res;
    }

    function prepareConfig(config) {
        var input = config._i,
            format = config._f;

        config._locale = config._locale || getLocale(config._l);

        if (input === null || (format === undefined && input === '')) {
            return createInvalid({
                nullInput: true
            });
        }

        if (typeof input === 'string') {
            config._i = input = config._locale.preparse(input);
        }

        if (isMoment(input)) {
            return new Moment(checkOverflow(input));
        } else if (isDate(input)) {
            config._d = input;
        } else if (isArray(format)) {
            configFromStringAndArray(config);
        } else if (format) {
            configFromStringAndFormat(config);
        } else {
            configFromInput(config);
        }

        if (!isValid(config)) {
            config._d = null;
        }

        return config;
    }

    function configFromInput(config) {
        var input = config._i;
        if (isUndefined(input)) {
            config._d = new Date(hooks.now());
        } else if (isDate(input)) {
            config._d = new Date(input.valueOf());
        } else if (typeof input === 'string') {
            configFromString(config);
        } else if (isArray(input)) {
            config._a = map(input.slice(0), function(obj) {
                return parseInt(obj, 10);
            });
            configFromArray(config);
        } else if (isObject(input)) {
            configFromObject(config);
        } else if (isNumber(input)) {
            // from milliseconds
            config._d = new Date(input);
        } else {
            hooks.createFromInputFallback(config);
        }
    }

    function createLocalOrUTC(input, format, locale, strict, isUTC) {
        var c = {};

        if (locale === true || locale === false) {
            strict = locale;
            locale = undefined;
        }

        if ((isObject(input) && isObjectEmpty(input)) ||
            (isArray(input) && input.length === 0)) {
            input = undefined;
        }
        // object construction must be done this way.
        // https://github.com/moment/moment/issues/1423
        c._isAMomentObject = true;
        c._useUTC = c._isUTC = isUTC;
        c._l = locale;
        c._i = input;
        c._f = format;
        c._strict = strict;

        return createFromConfig(c);
    }

    function createLocal(input, format, locale, strict) {
        return createLocalOrUTC(input, format, locale, strict, false);
    }

    var prototypeMin = deprecate(
        'moment().min is deprecated, use moment.max instead. http://momentjs.com/guides/#/warnings/min-max/',
        function() {
            var other = createLocal.apply(null, arguments);
            if (this.isValid() && other.isValid()) {
                return other < this ? this : other;
            } else {
                return createInvalid();
            }
        }
    );

    var prototypeMax = deprecate(
        'moment().max is deprecated, use moment.min instead. http://momentjs.com/guides/#/warnings/min-max/',
        function() {
            var other = createLocal.apply(null, arguments);
            if (this.isValid() && other.isValid()) {
                return other > this ? this : other;
            } else {
                return createInvalid();
            }
        }
    );

    // Pick a moment m from moments so that m[fn](other) is true for all
    // other. This relies on the function fn to be transitive.
    //
    // moments should either be an array of moment objects or an array, whose
    // first element is an array of moment objects.
    function pickBy(fn, moments) {
        var res, i;
        if (moments.length === 1 && isArray(moments[0])) {
            moments = moments[0];
        }
        if (!moments.length) {
            return createLocal();
        }
        res = moments[0];
        for (i = 1; i < moments.length; ++i) {
            if (!moments[i].isValid() || moments[i][fn](res)) {
                res = moments[i];
            }
        }
        return res;
    }

    // TODO: Use [].sort instead?
    function min() {
        var args = [].slice.call(arguments, 0);

        return pickBy('isBefore', args);
    }

    function max() {
        var args = [].slice.call(arguments, 0);

        return pickBy('isAfter', args);
    }

    var now = function() {
        return Date.now ? Date.now() : +(new Date());
    };

    var ordering = ['year', 'quarter', 'month', 'week', 'day', 'hour', 'minute', 'second', 'millisecond'];

    function isDurationValid(m) {
        for (var key in m) {
            if (!(ordering.indexOf(key) !== -1 && (m[key] == null || !isNaN(m[key])))) {
                return false;
            }
        }

        var unitHasDecimal = false;
        for (var i = 0; i < ordering.length; ++i) {
            if (m[ordering[i]]) {
                if (unitHasDecimal) {
                    return false; // only allow non-integers for smallest unit
                }
                if (parseFloat(m[ordering[i]]) !== toInt(m[ordering[i]])) {
                    unitHasDecimal = true;
                }
            }
        }

        return true;
    }

    function isValid$1() {
        return this._isValid;
    }

    function createInvalid$1() {
        return createDuration(NaN);
    }

    function Duration(duration) {
        var normalizedInput = normalizeObjectUnits(duration),
            years = normalizedInput.year || 0,
            quarters = normalizedInput.quarter || 0,
            months = normalizedInput.month || 0,
            weeks = normalizedInput.week || 0,
            days = normalizedInput.day || 0,
            hours = normalizedInput.hour || 0,
            minutes = normalizedInput.minute || 0,
            seconds = normalizedInput.second || 0,
            milliseconds = normalizedInput.millisecond || 0;

        this._isValid = isDurationValid(normalizedInput);

        // representation for dateAddRemove
        this._milliseconds = +milliseconds +
            seconds * 1e3 + // 1000
            minutes * 6e4 + // 1000 * 60
            hours * 1000 * 60 * 60; //using 1000 * 60 * 60 instead of 36e5 to avoid floating point rounding errors https://github.com/moment/moment/issues/2978
        // Because of dateAddRemove treats 24 hours as different from a
        // day when working around DST, we need to store them separately
        this._days = +days +
            weeks * 7;
        // It is impossible translate months into days without knowing
        // which months you are are talking about, so we have to store
        // it separately.
        this._months = +months +
            quarters * 3 +
            years * 12;

        this._data = {};

        this._locale = getLocale();

        this._bubble();
    }

    function isDuration(obj) {
        return obj instanceof Duration;
    }

    function absRound(number) {
        if (number < 0) {
            return Math.round(-1 * number) * -1;
        } else {
            return Math.round(number);
        }
    }

    // FORMATTING

    function offset(token, separator) {
        addFormatToken(token, 0, 0, function() {
            var offset = this.utcOffset();
            var sign = '+';
            if (offset < 0) {
                offset = -offset;
                sign = '-';
            }
            return sign + zeroFill(~~(offset / 60), 2) + separator + zeroFill(~~(offset) % 60, 2);
        });
    }

    offset('Z', ':');
    offset('ZZ', '');

    // PARSING

    addRegexToken('Z', matchShortOffset);
    addRegexToken('ZZ', matchShortOffset);
    addParseToken(['Z', 'ZZ'], function(input, array, config) {
        config._useUTC = true;
        config._tzm = offsetFromString(matchShortOffset, input);
    });

    // HELPERS

    // timezone chunker
    // '+10:00' > ['10',  '00']
    // '-1530'  > ['-15', '30']
    var chunkOffset = /([\+\-]|\d\d)/gi;

    function offsetFromString(matcher, string) {
        var matches = (string || '').match(matcher);

        if (matches === null) {
            return null;
        }

        var chunk = matches[matches.length - 1] || [];
        var parts = (chunk + '').match(chunkOffset) || ['-', 0, 0];
        var minutes = +(parts[1] * 60) + toInt(parts[2]);

        return minutes === 0 ?
            0 :
            parts[0] === '+' ? minutes : -minutes;
    }

    // Return a moment from input, that is local/utc/zone equivalent to model.
    function cloneWithOffset(input, model) {
        var res, diff;
        if (model._isUTC) {
            res = model.clone();
            diff = (isMoment(input) || isDate(input) ? input.valueOf() : createLocal(input).valueOf()) - res.valueOf();
            // Use low-level api, because this fn is low-level api.
            res._d.setTime(res._d.valueOf() + diff);
            hooks.updateOffset(res, false);
            return res;
        } else {
            return createLocal(input).local();
        }
    }

    function getDateOffset(m) {
        // On Firefox.24 Date#getTimezoneOffset returns a floating point.
        // https://github.com/moment/moment/pull/1871
        return -Math.round(m._d.getTimezoneOffset() / 15) * 15;
    }

    // HOOKS

    // This function will be called whenever a moment is mutated.
    // It is intended to keep the offset in sync with the timezone.
    hooks.updateOffset = function() {};

    // MOMENTS

    // keepLocalTime = true means only change the timezone, without
    // affecting the local hour. So 5:31:26 +0300 --[utcOffset(2, true)]-->
    // 5:31:26 +0200 It is possible that 5:31:26 doesn't exist with offset
    // +0200, so we adjust the time as needed, to be valid.
    //
    // Keeping the time actually adds/subtracts (one hour)
    // from the actual represented time. That is why we call updateOffset
    // a second time. In case it wants us to change the offset again
    // _changeInProgress == true case, then we have to adjust, because
    // there is no such time in the given timezone.
    function getSetOffset(input, keepLocalTime, keepMinutes) {
        var offset = this._offset || 0,
            localAdjust;
        if (!this.isValid()) {
            return input != null ? this : NaN;
        }
        if (input != null) {
            if (typeof input === 'string') {
                input = offsetFromString(matchShortOffset, input);
                if (input === null) {
                    return this;
                }
            } else if (Math.abs(input) < 16 && !keepMinutes) {
                input = input * 60;
            }
            if (!this._isUTC && keepLocalTime) {
                localAdjust = getDateOffset(this);
            }
            this._offset = input;
            this._isUTC = true;
            if (localAdjust != null) {
                this.add(localAdjust, 'm');
            }
            if (offset !== input) {
                if (!keepLocalTime || this._changeInProgress) {
                    addSubtract(this, createDuration(input - offset, 'm'), 1, false);
                } else if (!this._changeInProgress) {
                    this._changeInProgress = true;
                    hooks.updateOffset(this, true);
                    this._changeInProgress = null;
                }
            }
            return this;
        } else {
            return this._isUTC ? offset : getDateOffset(this);
        }
    }

    function getSetZone(input, keepLocalTime) {
        if (input != null) {
            if (typeof input !== 'string') {
                input = -input;
            }

            this.utcOffset(input, keepLocalTime);

            return this;
        } else {
            return -this.utcOffset();
        }
    }

    function setOffsetToUTC(keepLocalTime) {
        return this.utcOffset(0, keepLocalTime);
    }

    function setOffsetToLocal(keepLocalTime) {
        if (this._isUTC) {
            this.utcOffset(0, keepLocalTime);
            this._isUTC = false;

            if (keepLocalTime) {
                this.subtract(getDateOffset(this), 'm');
            }
        }
        return this;
    }

    function setOffsetToParsedOffset() {
        if (this._tzm != null) {
            this.utcOffset(this._tzm, false, true);
        } else if (typeof this._i === 'string') {
            var tZone = offsetFromString(matchOffset, this._i);
            if (tZone != null) {
                this.utcOffset(tZone);
            } else {
                this.utcOffset(0, true);
            }
        }
        return this;
    }

    function hasAlignedHourOffset(input) {
        if (!this.isValid()) {
            return false;
        }
        input = input ? createLocal(input).utcOffset() : 0;

        return (this.utcOffset() - input) % 60 === 0;
    }

    function isDaylightSavingTime() {
        return (
            this.utcOffset() > this.clone().month(0).utcOffset() ||
            this.utcOffset() > this.clone().month(5).utcOffset()
        );
    }

    function isDaylightSavingTimeShifted() {
        if (!isUndefined(this._isDSTShifted)) {
            return this._isDSTShifted;
        }

        var c = {};

        copyConfig(c, this);
        c = prepareConfig(c);

        if (c._a) {
            var other = c._isUTC ? createUTC(c._a) : createLocal(c._a);
            this._isDSTShifted = this.isValid() &&
                compareArrays(c._a, other.toArray()) > 0;
        } else {
            this._isDSTShifted = false;
        }

        return this._isDSTShifted;
    }

    function isLocal() {
        return this.isValid() ? !this._isUTC : false;
    }

    function isUtcOffset() {
        return this.isValid() ? this._isUTC : false;
    }

    function isUtc() {
        return this.isValid() ? this._isUTC && this._offset === 0 : false;
    }

    // ASP.NET json date format regex
    var aspNetRegex = /^(\-)?(?:(\d*)[. ])?(\d+)\:(\d+)(?:\:(\d+)(\.\d*)?)?$/;

    // from http://docs.closure-library.googlecode.com/git/closure_goog_date_date.js.source.html
    // somewhat more in line with 4.4.3.2 2004 spec, but allows decimal anywhere
    // and further modified to allow for strings containing both week and day
    var isoRegex = /^(-)?P(?:(-?[0-9,.]*)Y)?(?:(-?[0-9,.]*)M)?(?:(-?[0-9,.]*)W)?(?:(-?[0-9,.]*)D)?(?:T(?:(-?[0-9,.]*)H)?(?:(-?[0-9,.]*)M)?(?:(-?[0-9,.]*)S)?)?$/;

    function createDuration(input, key) {
        var duration = input,
            // matching against regexp is expensive, do it on demand
            match = null,
            sign,
            ret,
            diffRes;

        if (isDuration(input)) {
            duration = {
                ms: input._milliseconds,
                d: input._days,
                M: input._months
            };
        } else if (isNumber(input)) {
            duration = {};
            if (key) {
                duration[key] = input;
            } else {
                duration.milliseconds = input;
            }
        } else if (!!(match = aspNetRegex.exec(input))) {
            sign = (match[1] === '-') ? -1 : 1;
            duration = {
                y: 0,
                d: toInt(match[DATE]) * sign,
                h: toInt(match[HOUR]) * sign,
                m: toInt(match[MINUTE]) * sign,
                s: toInt(match[SECOND]) * sign,
                ms: toInt(absRound(match[MILLISECOND] * 1000)) * sign // the millisecond decimal point is included in the match
            };
        } else if (!!(match = isoRegex.exec(input))) {
            sign = (match[1] === '-') ? -1 : 1;
            duration = {
                y: parseIso(match[2], sign),
                M: parseIso(match[3], sign),
                w: parseIso(match[4], sign),
                d: parseIso(match[5], sign),
                h: parseIso(match[6], sign),
                m: parseIso(match[7], sign),
                s: parseIso(match[8], sign)
            };
        } else if (duration == null) { // checks for null or undefined
            duration = {};
        } else if (typeof duration === 'object' && ('from' in duration || 'to' in duration)) {
            diffRes = momentsDifference(createLocal(duration.from), createLocal(duration.to));

            duration = {};
            duration.ms = diffRes.milliseconds;
            duration.M = diffRes.months;
        }

        ret = new Duration(duration);

        if (isDuration(input) && hasOwnProp(input, '_locale')) {
            ret._locale = input._locale;
        }

        return ret;
    }

    createDuration.fn = Duration.prototype;
    createDuration.invalid = createInvalid$1;

    function parseIso(inp, sign) {
        // We'd normally use ~~inp for this, but unfortunately it also
        // converts floats to ints.
        // inp may be undefined, so careful calling replace on it.
        var res = inp && parseFloat(inp.replace(',', '.'));
        // apply sign while we're at it
        return (isNaN(res) ? 0 : res) * sign;
    }

    function positiveMomentsDifference(base, other) {
        var res = {
            milliseconds: 0,
            months: 0
        };

        res.months = other.month() - base.month() +
            (other.year() - base.year()) * 12;
        if (base.clone().add(res.months, 'M').isAfter(other)) {
            --res.months;
        }

        res.milliseconds = +other - +(base.clone().add(res.months, 'M'));

        return res;
    }

    function momentsDifference(base, other) {
        var res;
        if (!(base.isValid() && other.isValid())) {
            return {
                milliseconds: 0,
                months: 0
            };
        }

        other = cloneWithOffset(other, base);
        if (base.isBefore(other)) {
            res = positiveMomentsDifference(base, other);
        } else {
            res = positiveMomentsDifference(other, base);
            res.milliseconds = -res.milliseconds;
            res.months = -res.months;
        }

        return res;
    }

    // TODO: remove 'name' arg after deprecation is removed
    function createAdder(direction, name) {
        return function(val, period) {
            var dur, tmp;
            //invert the arguments, but complain about it
            if (period !== null && !isNaN(+period)) {
                deprecateSimple(name, 'moment().' + name + '(period, number) is deprecated. Please use moment().' + name + '(number, period). ' +
                    'See http://momentjs.com/guides/#/warnings/add-inverted-param/ for more info.');
                tmp = val;
                val = period;
                period = tmp;
            }

            val = typeof val === 'string' ? +val : val;
            dur = createDuration(val, period);
            addSubtract(this, dur, direction);
            return this;
        };
    }

    function addSubtract(mom, duration, isAdding, updateOffset) {
        var milliseconds = duration._milliseconds,
            days = absRound(duration._days),
            months = absRound(duration._months);

        if (!mom.isValid()) {
            // No op
            return;
        }

        updateOffset = updateOffset == null ? true : updateOffset;

        if (milliseconds) {
            mom._d.setTime(mom._d.valueOf() + milliseconds * isAdding);
        }
        if (days) {
            set$1(mom, 'Date', get(mom, 'Date') + days * isAdding);
        }
        if (months) {
            setMonth(mom, get(mom, 'Month') + months * isAdding);
        }
        if (updateOffset) {
            hooks.updateOffset(mom, days || months);
        }
    }

    var add = createAdder(1, 'add');
    var subtract = createAdder(-1, 'subtract');

    function getCalendarFormat(myMoment, now) {
        var diff = myMoment.diff(now, 'days', true);
        return diff < -6 ? 'sameElse' :
            diff < -1 ? 'lastWeek' :
            diff < 0 ? 'lastDay' :
            diff < 1 ? 'sameDay' :
            diff < 2 ? 'nextDay' :
            diff < 7 ? 'nextWeek' : 'sameElse';
    }

    function calendar$1(time, formats) {
        // We want to compare the start of today, vs this.
        // Getting start-of-today depends on whether we're local/utc/offset or not.
        var now = time || createLocal(),
            sod = cloneWithOffset(now, this).startOf('day'),
            format = hooks.calendarFormat(this, sod) || 'sameElse';

        var output = formats && (isFunction(formats[format]) ? formats[format].call(this, now) : formats[format]);

        return this.format(output || this.localeData().calendar(format, this, createLocal(now)));
    }

    function clone() {
        return new Moment(this);
    }

    function isAfter(input, units) {
        var localInput = isMoment(input) ? input : createLocal(input);
        if (!(this.isValid() && localInput.isValid())) {
            return false;
        }
        units = normalizeUnits(!isUndefined(units) ? units : 'millisecond');
        if (units === 'millisecond') {
            return this.valueOf() > localInput.valueOf();
        } else {
            return localInput.valueOf() < this.clone().startOf(units).valueOf();
        }
    }

    function isBefore(input, units) {
        var localInput = isMoment(input) ? input : createLocal(input);
        if (!(this.isValid() && localInput.isValid())) {
            return false;
        }
        units = normalizeUnits(!isUndefined(units) ? units : 'millisecond');
        if (units === 'millisecond') {
            return this.valueOf() < localInput.valueOf();
        } else {
            return this.clone().endOf(units).valueOf() < localInput.valueOf();
        }
    }

    function isBetween(from, to, units, inclusivity) {
        inclusivity = inclusivity || '()';
        return (inclusivity[0] === '(' ? this.isAfter(from, units) : !this.isBefore(from, units)) &&
            (inclusivity[1] === ')' ? this.isBefore(to, units) : !this.isAfter(to, units));
    }

    function isSame(input, units) {
        var localInput = isMoment(input) ? input : createLocal(input),
            inputMs;
        if (!(this.isValid() && localInput.isValid())) {
            return false;
        }
        units = normalizeUnits(units || 'millisecond');
        if (units === 'millisecond') {
            return this.valueOf() === localInput.valueOf();
        } else {
            inputMs = localInput.valueOf();
            return this.clone().startOf(units).valueOf() <= inputMs && inputMs <= this.clone().endOf(units).valueOf();
        }
    }

    function isSameOrAfter(input, units) {
        return this.isSame(input, units) || this.isAfter(input, units);
    }

    function isSameOrBefore(input, units) {
        return this.isSame(input, units) || this.isBefore(input, units);
    }

    function diff(input, units, asFloat) {
        var that,
            zoneDelta,
            delta, output;

        if (!this.isValid()) {
            return NaN;
        }

        that = cloneWithOffset(input, this);

        if (!that.isValid()) {
            return NaN;
        }

        zoneDelta = (that.utcOffset() - this.utcOffset()) * 6e4;

        units = normalizeUnits(units);

        if (units === 'year' || units === 'month' || units === 'quarter') {
            output = monthDiff(this, that);
            if (units === 'quarter') {
                output = output / 3;
            } else if (units === 'year') {
                output = output / 12;
            }
        } else {
            delta = this - that;
            output = units === 'second' ? delta / 1e3 : // 1000
                units === 'minute' ? delta / 6e4 : // 1000 * 60
                units === 'hour' ? delta / 36e5 : // 1000 * 60 * 60
                units === 'day' ? (delta - zoneDelta) / 864e5 : // 1000 * 60 * 60 * 24, negate dst
                units === 'week' ? (delta - zoneDelta) / 6048e5 : // 1000 * 60 * 60 * 24 * 7, negate dst
                delta;
        }
        return asFloat ? output : absFloor(output);
    }

    function monthDiff(a, b) {
        // difference in months
        var wholeMonthDiff = ((b.year() - a.year()) * 12) + (b.month() - a.month()),
            // b is in (anchor - 1 month, anchor + 1 month)
            anchor = a.clone().add(wholeMonthDiff, 'months'),
            anchor2, adjust;

        if (b - anchor < 0) {
            anchor2 = a.clone().add(wholeMonthDiff - 1, 'months');
            // linear across the month
            adjust = (b - anchor) / (anchor - anchor2);
        } else {
            anchor2 = a.clone().add(wholeMonthDiff + 1, 'months');
            // linear across the month
            adjust = (b - anchor) / (anchor2 - anchor);
        }

        //check for negative zero, return zero if negative zero
        return -(wholeMonthDiff + adjust) || 0;
    }

    hooks.defaultFormat = 'YYYY-MM-DDTHH:mm:ssZ';
    hooks.defaultFormatUtc = 'YYYY-MM-DDTHH:mm:ss[Z]';

    function toString() {
        return this.clone().locale('en').format('ddd MMM DD YYYY HH:mm:ss [GMT]ZZ');
    }

    function toISOString() {
        if (!this.isValid()) {
            return null;
        }
        var m = this.clone().utc();
        if (m.year() < 0 || m.year() > 9999) {
            return formatMoment(m, 'YYYYYY-MM-DD[T]HH:mm:ss.SSS[Z]');
        }
        if (isFunction(Date.prototype.toISOString)) {
            // native implementation is ~50x faster, use it when we can
            return this.toDate().toISOString();
        }
        return formatMoment(m, 'YYYY-MM-DD[T]HH:mm:ss.SSS[Z]');
    }

    /**
    * Return a human readable representation of a moment that can
    * also be evaluated to get a new moment which is the same
    *
    * @link https://nodejs.org/dist/latest/docs/api/util.html#util_custom_inspect_function_on_objects
    */
    function inspect() {
        if (!this.isValid()) {
            return 'moment.invalid(/* ' + this._i + ' */)';
        }
        var func = 'moment';
        var zone = '';
        if (!this.isLocal()) {
            func = this.utcOffset() === 0 ? 'moment.utc' : 'moment.parseZone';
            zone = 'Z';
        }
        var prefix = '[' + func + '("]';
        var year = (0 <= this.year() && this.year() <= 9999) ? 'YYYY' : 'YYYYYY';
        var datetime = '-MM-DD[T]HH:mm:ss.SSS';
        var suffix = zone + '[")]';

        return this.format(prefix + year + datetime + suffix);
    }

    function format(inputString) {
        if (!inputString) {
            inputString = this.isUtc() ? hooks.defaultFormatUtc : hooks.defaultFormat;
        }
        var output = formatMoment(this, inputString);
        return this.localeData().postformat(output);
    }

    function from(time, withoutSuffix) {
        if (this.isValid() &&
            ((isMoment(time) && time.isValid()) ||
                createLocal(time).isValid())) {
            return createDuration({
                to: this,
                from: time
            }).locale(this.locale()).humanize(!withoutSuffix);
        } else {
            return this.localeData().invalidDate();
        }
    }

    function fromNow(withoutSuffix) {
        return this.from(createLocal(), withoutSuffix);
    }

    function to(time, withoutSuffix) {
        if (this.isValid() &&
            ((isMoment(time) && time.isValid()) ||
                createLocal(time).isValid())) {
            return createDuration({
                from: this,
                to: time
            }).locale(this.locale()).humanize(!withoutSuffix);
        } else {
            return this.localeData().invalidDate();
        }
    }

    function toNow(withoutSuffix) {
        return this.to(createLocal(), withoutSuffix);
    }

    // If passed a locale key, it will set the locale for this
    // instance.  Otherwise, it will return the locale configuration
    // variables for this instance.
    function locale(key) {
        var newLocaleData;

        if (key === undefined) {
            return this._locale._abbr;
        } else {
            newLocaleData = getLocale(key);
            if (newLocaleData != null) {
                this._locale = newLocaleData;
            }
            return this;
        }
    }

    var lang = deprecate(
        'moment().lang() is deprecated. Instead, use moment().localeData() to get the language configuration. Use moment().locale() to change languages.',
        function(key) {
            if (key === undefined) {
                return this.localeData();
            } else {
                return this.locale(key);
            }
        }
    );

    function localeData() {
        return this._locale;
    }

    function startOf(units) {
        units = normalizeUnits(units);
        // the following switch intentionally omits break keywords
        // to utilize falling through the cases.
        switch (units) {
            case 'year':
                this.month(0);
                /* falls through */
            case 'quarter':
            case 'month':
                this.date(1);
                /* falls through */
            case 'week':
            case 'isoWeek':
            case 'day':
            case 'date':
                this.hours(0);
                /* falls through */
            case 'hour':
                this.minutes(0);
                /* falls through */
            case 'minute':
                this.seconds(0);
                /* falls through */
            case 'second':
                this.milliseconds(0);
        }

        // weeks are a special case
        if (units === 'week') {
            this.weekday(0);
        }
        if (units === 'isoWeek') {
            this.isoWeekday(1);
        }

        // quarters are also special
        if (units === 'quarter') {
            this.month(Math.floor(this.month() / 3) * 3);
        }

        return this;
    }

    function endOf(units) {
        units = normalizeUnits(units);
        if (units === undefined || units === 'millisecond') {
            return this;
        }

        // 'date' is an alias for 'day', so it should be considered as such.
        if (units === 'date') {
            units = 'day';
        }

        return this.startOf(units).add(1, (units === 'isoWeek' ? 'week' : units)).subtract(1, 'ms');
    }

    function valueOf() {
        return this._d.valueOf() - ((this._offset || 0) * 60000);
    }

    function unix() {
        return Math.floor(this.valueOf() / 1000);
    }

    function toDate() {
        return new Date(this.valueOf());
    }

    function toArray() {
        var m = this;
        return [m.year(), m.month(), m.date(), m.hour(), m.minute(), m.second(), m.millisecond()];
    }

    function toObject() {
        var m = this;
        return {
            years: m.year(),
            months: m.month(),
            date: m.date(),
            hours: m.hours(),
            minutes: m.minutes(),
            seconds: m.seconds(),
            milliseconds: m.milliseconds()
        };
    }

    function toJSON() {
        // new Date(NaN).toJSON() === null
        return this.isValid() ? this.toISOString() : null;
    }

    function isValid$2() {
        return isValid(this);
    }

    function parsingFlags() {
        return extend({}, getParsingFlags(this));
    }

    function invalidAt() {
        return getParsingFlags(this).overflow;
    }

    function creationData() {
        return {
            input: this._i,
            format: this._f,
            locale: this._locale,
            isUTC: this._isUTC,
            strict: this._strict
        };
    }

    // FORMATTING

    addFormatToken(0, ['gg', 2], 0, function() {
        return this.weekYear() % 100;
    });

    addFormatToken(0, ['GG', 2], 0, function() {
        return this.isoWeekYear() % 100;
    });

    function addWeekYearFormatToken(token, getter) {
        addFormatToken(0, [token, token.length], 0, getter);
    }

    addWeekYearFormatToken('gggg', 'weekYear');
    addWeekYearFormatToken('ggggg', 'weekYear');
    addWeekYearFormatToken('GGGG', 'isoWeekYear');
    addWeekYearFormatToken('GGGGG', 'isoWeekYear');

    // ALIASES

    addUnitAlias('weekYear', 'gg');
    addUnitAlias('isoWeekYear', 'GG');

    // PRIORITY

    addUnitPriority('weekYear', 1);
    addUnitPriority('isoWeekYear', 1);


    // PARSING

    addRegexToken('G', matchSigned);
    addRegexToken('g', matchSigned);
    addRegexToken('GG', match1to2, match2);
    addRegexToken('gg', match1to2, match2);
    addRegexToken('GGGG', match1to4, match4);
    addRegexToken('gggg', match1to4, match4);
    addRegexToken('GGGGG', match1to6, match6);
    addRegexToken('ggggg', match1to6, match6);

    addWeekParseToken(['gggg', 'ggggg', 'GGGG', 'GGGGG'], function(input, week, config, token) {
        week[token.substr(0, 2)] = toInt(input);
    });

    addWeekParseToken(['gg', 'GG'], function(input, week, config, token) {
        week[token] = hooks.parseTwoDigitYear(input);
    });

    // MOMENTS

    function getSetWeekYear(input) {
        return getSetWeekYearHelper.call(this,
            input,
            this.week(),
            this.weekday(),
            this.localeData()._week.dow,
            this.localeData()._week.doy);
    }

    function getSetISOWeekYear(input) {
        return getSetWeekYearHelper.call(this,
            input, this.isoWeek(), this.isoWeekday(), 1, 4);
    }

    function getISOWeeksInYear() {
        return weeksInYear(this.year(), 1, 4);
    }

    function getWeeksInYear() {
        var weekInfo = this.localeData()._week;
        return weeksInYear(this.year(), weekInfo.dow, weekInfo.doy);
    }

    function getSetWeekYearHelper(input, week, weekday, dow, doy) {
        var weeksTarget;
        if (input == null) {
            return weekOfYear(this, dow, doy).year;
        } else {
            weeksTarget = weeksInYear(input, dow, doy);
            if (week > weeksTarget) {
                week = weeksTarget;
            }
            return setWeekAll.call(this, input, week, weekday, dow, doy);
        }
    }

    function setWeekAll(weekYear, week, weekday, dow, doy) {
        var dayOfYearData = dayOfYearFromWeeks(weekYear, week, weekday, dow, doy),
            date = createUTCDate(dayOfYearData.year, 0, dayOfYearData.dayOfYear);

        this.year(date.getUTCFullYear());
        this.month(date.getUTCMonth());
        this.date(date.getUTCDate());
        return this;
    }

    // FORMATTING

    addFormatToken('Q', 0, 'Qo', 'quarter');

    // ALIASES

    addUnitAlias('quarter', 'Q');

    // PRIORITY

    addUnitPriority('quarter', 7);

    // PARSING

    addRegexToken('Q', match1);
    addParseToken('Q', function(input, array) {
        array[MONTH] = (toInt(input) - 1) * 3;
    });

    // MOMENTS

    function getSetQuarter(input) {
        return input == null ? Math.ceil((this.month() + 1) / 3) : this.month((input - 1) * 3 + this.month() % 3);
    }

    // FORMATTING

    addFormatToken('D', ['DD', 2], 'Do', 'date');

    // ALIASES

    addUnitAlias('date', 'D');

    // PRIOROITY
    addUnitPriority('date', 9);

    // PARSING

    addRegexToken('D', match1to2);
    addRegexToken('DD', match1to2, match2);
    addRegexToken('Do', function(isStrict, locale) {
        // TODO: Remove "ordinalParse" fallback in next major release.
        return isStrict ?
            (locale._dayOfMonthOrdinalParse || locale._ordinalParse) :
            locale._dayOfMonthOrdinalParseLenient;
    });

    addParseToken(['D', 'DD'], DATE);
    addParseToken('Do', function(input, array) {
        array[DATE] = toInt(input.match(match1to2)[0], 10);
    });

    // MOMENTS

    var getSetDayOfMonth = makeGetSet('Date', true);

    // FORMATTING

    addFormatToken('DDD', ['DDDD', 3], 'DDDo', 'dayOfYear');

    // ALIASES

    addUnitAlias('dayOfYear', 'DDD');

    // PRIORITY
    addUnitPriority('dayOfYear', 4);

    // PARSING

    addRegexToken('DDD', match1to3);
    addRegexToken('DDDD', match3);
    addParseToken(['DDD', 'DDDD'], function(input, array, config) {
        config._dayOfYear = toInt(input);
    });

    // HELPERS

    // MOMENTS

    function getSetDayOfYear(input) {
        var dayOfYear = Math.round((this.clone().startOf('day') - this.clone().startOf('year')) / 864e5) + 1;
        return input == null ? dayOfYear : this.add((input - dayOfYear), 'd');
    }

    // FORMATTING

    addFormatToken('m', ['mm', 2], 0, 'minute');

    // ALIASES

    addUnitAlias('minute', 'm');

    // PRIORITY

    addUnitPriority('minute', 14);

    // PARSING

    addRegexToken('m', match1to2);
    addRegexToken('mm', match1to2, match2);
    addParseToken(['m', 'mm'], MINUTE);

    // MOMENTS

    var getSetMinute = makeGetSet('Minutes', false);

    // FORMATTING

    addFormatToken('s', ['ss', 2], 0, 'second');

    // ALIASES

    addUnitAlias('second', 's');

    // PRIORITY

    addUnitPriority('second', 15);

    // PARSING

    addRegexToken('s', match1to2);
    addRegexToken('ss', match1to2, match2);
    addParseToken(['s', 'ss'], SECOND);

    // MOMENTS

    var getSetSecond = makeGetSet('Seconds', false);

    // FORMATTING

    addFormatToken('S', 0, 0, function() {
        return ~~(this.millisecond() / 100);
    });

    addFormatToken(0, ['SS', 2], 0, function() {
        return ~~(this.millisecond() / 10);
    });

    addFormatToken(0, ['SSS', 3], 0, 'millisecond');
    addFormatToken(0, ['SSSS', 4], 0, function() {
        return this.millisecond() * 10;
    });
    addFormatToken(0, ['SSSSS', 5], 0, function() {
        return this.millisecond() * 100;
    });
    addFormatToken(0, ['SSSSSS', 6], 0, function() {
        return this.millisecond() * 1000;
    });
    addFormatToken(0, ['SSSSSSS', 7], 0, function() {
        return this.millisecond() * 10000;
    });
    addFormatToken(0, ['SSSSSSSS', 8], 0, function() {
        return this.millisecond() * 100000;
    });
    addFormatToken(0, ['SSSSSSSSS', 9], 0, function() {
        return this.millisecond() * 1000000;
    });


    // ALIASES

    addUnitAlias('millisecond', 'ms');

    // PRIORITY

    addUnitPriority('millisecond', 16);

    // PARSING

    addRegexToken('S', match1to3, match1);
    addRegexToken('SS', match1to3, match2);
    addRegexToken('SSS', match1to3, match3);

    var token;
    for (token = 'SSSS'; token.length <= 9; token += 'S') {
        addRegexToken(token, matchUnsigned);
    }

    function parseMs(input, array) {
        array[MILLISECOND] = toInt(('0.' + input) * 1000);
    }

    for (token = 'S'; token.length <= 9; token += 'S') {
        addParseToken(token, parseMs);
    }
    // MOMENTS

    var getSetMillisecond = makeGetSet('Milliseconds', false);

    // FORMATTING

    addFormatToken('z', 0, 0, 'zoneAbbr');
    addFormatToken('zz', 0, 0, 'zoneName');

    // MOMENTS

    function getZoneAbbr() {
        return this._isUTC ? 'UTC' : '';
    }

    function getZoneName() {
        return this._isUTC ? 'Coordinated Universal Time' : '';
    }

    var proto = Moment.prototype;

    proto.add = add;
    proto.calendar = calendar$1;
    proto.clone = clone;
    proto.diff = diff;
    proto.endOf = endOf;
    proto.format = format;
    proto.from = from;
    proto.fromNow = fromNow;
    proto.to = to;
    proto.toNow = toNow;
    proto.get = stringGet;
    proto.invalidAt = invalidAt;
    proto.isAfter = isAfter;
    proto.isBefore = isBefore;
    proto.isBetween = isBetween;
    proto.isSame = isSame;
    proto.isSameOrAfter = isSameOrAfter;
    proto.isSameOrBefore = isSameOrBefore;
    proto.isValid = isValid$2;
    proto.lang = lang;
    proto.locale = locale;
    proto.localeData = localeData;
    proto.max = prototypeMax;
    proto.min = prototypeMin;
    proto.parsingFlags = parsingFlags;
    proto.set = stringSet;
    proto.startOf = startOf;
    proto.subtract = subtract;
    proto.toArray = toArray;
    proto.toObject = toObject;
    proto.toDate = toDate;
    proto.toISOString = toISOString;
    proto.inspect = inspect;
    proto.toJSON = toJSON;
    proto.toString = toString;
    proto.unix = unix;
    proto.valueOf = valueOf;
    proto.creationData = creationData;

    // Year
    proto.year = getSetYear;
    proto.isLeapYear = getIsLeapYear;

    // Week Year
    proto.weekYear = getSetWeekYear;
    proto.isoWeekYear = getSetISOWeekYear;

    // Quarter
    proto.quarter = proto.quarters = getSetQuarter;

    // Month
    proto.month = getSetMonth;
    proto.daysInMonth = getDaysInMonth;

    // Week
    proto.week = proto.weeks = getSetWeek;
    proto.isoWeek = proto.isoWeeks = getSetISOWeek;
    proto.weeksInYear = getWeeksInYear;
    proto.isoWeeksInYear = getISOWeeksInYear;

    // Day
    proto.date = getSetDayOfMonth;
    proto.day = proto.days = getSetDayOfWeek;
    proto.weekday = getSetLocaleDayOfWeek;
    proto.isoWeekday = getSetISODayOfWeek;
    proto.dayOfYear = getSetDayOfYear;

    // Hour
    proto.hour = proto.hours = getSetHour;

    // Minute
    proto.minute = proto.minutes = getSetMinute;

    // Second
    proto.second = proto.seconds = getSetSecond;

    // Millisecond
    proto.millisecond = proto.milliseconds = getSetMillisecond;

    // Offset
    proto.utcOffset = getSetOffset;
    proto.utc = setOffsetToUTC;
    proto.local = setOffsetToLocal;
    proto.parseZone = setOffsetToParsedOffset;
    proto.hasAlignedHourOffset = hasAlignedHourOffset;
    proto.isDST = isDaylightSavingTime;
    proto.isLocal = isLocal;
    proto.isUtcOffset = isUtcOffset;
    proto.isUtc = isUtc;
    proto.isUTC = isUtc;

    // Timezone
    proto.zoneAbbr = getZoneAbbr;
    proto.zoneName = getZoneName;

    // Deprecations
    proto.dates = deprecate('dates accessor is deprecated. Use date instead.', getSetDayOfMonth);
    proto.months = deprecate('months accessor is deprecated. Use month instead', getSetMonth);
    proto.years = deprecate('years accessor is deprecated. Use year instead', getSetYear);
    proto.zone = deprecate('moment().zone is deprecated, use moment().utcOffset instead. http://momentjs.com/guides/#/warnings/zone/', getSetZone);
    proto.isDSTShifted = deprecate('isDSTShifted is deprecated. See http://momentjs.com/guides/#/warnings/dst-shifted/ for more information', isDaylightSavingTimeShifted);

    function createUnix(input) {
        return createLocal(input * 1000);
    }

    function createInZone() {
        return createLocal.apply(null, arguments).parseZone();
    }

    function preParsePostFormat(string) {
        return string;
    }

    var proto$1 = Locale.prototype;

    proto$1.calendar = calendar;
    proto$1.longDateFormat = longDateFormat;
    proto$1.invalidDate = invalidDate;
    proto$1.ordinal = ordinal;
    proto$1.preparse = preParsePostFormat;
    proto$1.postformat = preParsePostFormat;
    proto$1.relativeTime = relativeTime;
    proto$1.pastFuture = pastFuture;
    proto$1.set = set;

    // Month
    proto$1.months = localeMonths;
    proto$1.monthsShort = localeMonthsShort;
    proto$1.monthsParse = localeMonthsParse;
    proto$1.monthsRegex = monthsRegex;
    proto$1.monthsShortRegex = monthsShortRegex;

    // Week
    proto$1.week = localeWeek;
    proto$1.firstDayOfYear = localeFirstDayOfYear;
    proto$1.firstDayOfWeek = localeFirstDayOfWeek;

    // Day of Week
    proto$1.weekdays = localeWeekdays;
    proto$1.weekdaysMin = localeWeekdaysMin;
    proto$1.weekdaysShort = localeWeekdaysShort;
    proto$1.weekdaysParse = localeWeekdaysParse;

    proto$1.weekdaysRegex = weekdaysRegex;
    proto$1.weekdaysShortRegex = weekdaysShortRegex;
    proto$1.weekdaysMinRegex = weekdaysMinRegex;

    // Hours
    proto$1.isPM = localeIsPM;
    proto$1.meridiem = localeMeridiem;

    function get$1(format, index, field, setter) {
        var locale = getLocale();
        var utc = createUTC().set(setter, index);
        return locale[field](utc, format);
    }

    function listMonthsImpl(format, index, field) {
        if (isNumber(format)) {
            index = format;
            format = undefined;
        }

        format = format || '';

        if (index != null) {
            return get$1(format, index, field, 'month');
        }

        var i;
        var out = [];
        for (i = 0; i < 12; i++) {
            out[i] = get$1(format, i, field, 'month');
        }
        return out;
    }

    // ()
    // (5)
    // (fmt, 5)
    // (fmt)
    // (true)
    // (true, 5)
    // (true, fmt, 5)
    // (true, fmt)
    function listWeekdaysImpl(localeSorted, format, index, field) {
        if (typeof localeSorted === 'boolean') {
            if (isNumber(format)) {
                index = format;
                format = undefined;
            }

            format = format || '';
        } else {
            format = localeSorted;
            index = format;
            localeSorted = false;

            if (isNumber(format)) {
                index = format;
                format = undefined;
            }

            format = format || '';
        }

        var locale = getLocale(),
            shift = localeSorted ? locale._week.dow : 0;

        if (index != null) {
            return get$1(format, (index + shift) % 7, field, 'day');
        }

        var i;
        var out = [];
        for (i = 0; i < 7; i++) {
            out[i] = get$1(format, (i + shift) % 7, field, 'day');
        }
        return out;
    }

    function listMonths(format, index) {
        return listMonthsImpl(format, index, 'months');
    }

    function listMonthsShort(format, index) {
        return listMonthsImpl(format, index, 'monthsShort');
    }

    function listWeekdays(localeSorted, format, index) {
        return listWeekdaysImpl(localeSorted, format, index, 'weekdays');
    }

    function listWeekdaysShort(localeSorted, format, index) {
        return listWeekdaysImpl(localeSorted, format, index, 'weekdaysShort');
    }

    function listWeekdaysMin(localeSorted, format, index) {
        return listWeekdaysImpl(localeSorted, format, index, 'weekdaysMin');
    }

    getSetGlobalLocale('en', {
        dayOfMonthOrdinalParse: /\d{1,2}(th|st|nd|rd)/,
        ordinal: function(number) {
            var b = number % 10,
                output = (toInt(number % 100 / 10) === 1) ? 'th' :
                (b === 1) ? 'st' :
                (b === 2) ? 'nd' :
                (b === 3) ? 'rd' : 'th';
            return number + output;
        }
    });

    // Side effect imports
    hooks.lang = deprecate('moment.lang is deprecated. Use moment.locale instead.', getSetGlobalLocale);
    hooks.langData = deprecate('moment.langData is deprecated. Use moment.localeData instead.', getLocale);

    var mathAbs = Math.abs;

    function abs() {
        var data = this._data;

        this._milliseconds = mathAbs(this._milliseconds);
        this._days = mathAbs(this._days);
        this._months = mathAbs(this._months);

        data.milliseconds = mathAbs(data.milliseconds);
        data.seconds = mathAbs(data.seconds);
        data.minutes = mathAbs(data.minutes);
        data.hours = mathAbs(data.hours);
        data.months = mathAbs(data.months);
        data.years = mathAbs(data.years);

        return this;
    }

    function addSubtract$1(duration, input, value, direction) {
        var other = createDuration(input, value);

        duration._milliseconds += direction * other._milliseconds;
        duration._days += direction * other._days;
        duration._months += direction * other._months;

        return duration._bubble();
    }

    // supports only 2.0-style add(1, 's') or add(duration)
    function add$1(input, value) {
        return addSubtract$1(this, input, value, 1);
    }

    // supports only 2.0-style subtract(1, 's') or subtract(duration)
    function subtract$1(input, value) {
        return addSubtract$1(this, input, value, -1);
    }

    function absCeil(number) {
        if (number < 0) {
            return Math.floor(number);
        } else {
            return Math.ceil(number);
        }
    }

    function bubble() {
        var milliseconds = this._milliseconds;
        var days = this._days;
        var months = this._months;
        var data = this._data;
        var seconds, minutes, hours, years, monthsFromDays;

        // if we have a mix of positive and negative values, bubble down first
        // check: https://github.com/moment/moment/issues/2166
        if (!((milliseconds >= 0 && days >= 0 && months >= 0) ||
                (milliseconds <= 0 && days <= 0 && months <= 0))) {
            milliseconds += absCeil(monthsToDays(months) + days) * 864e5;
            days = 0;
            months = 0;
        }

        // The following code bubbles up values, see the tests for
        // examples of what that means.
        data.milliseconds = milliseconds % 1000;

        seconds = absFloor(milliseconds / 1000);
        data.seconds = seconds % 60;

        minutes = absFloor(seconds / 60);
        data.minutes = minutes % 60;

        hours = absFloor(minutes / 60);
        data.hours = hours % 24;

        days += absFloor(hours / 24);

        // convert days to months
        monthsFromDays = absFloor(daysToMonths(days));
        months += monthsFromDays;
        days -= absCeil(monthsToDays(monthsFromDays));

        // 12 months -> 1 year
        years = absFloor(months / 12);
        months %= 12;

        data.days = days;
        data.months = months;
        data.years = years;

        return this;
    }

    function daysToMonths(days) {
        // 400 years have 146097 days (taking into account leap year rules)
        // 400 years have 12 months === 4800
        return days * 4800 / 146097;
    }

    function monthsToDays(months) {
        // the reverse of daysToMonths
        return months * 146097 / 4800;
    }

    function as(units) {
        if (!this.isValid()) {
            return NaN;
        }
        var days;
        var months;
        var milliseconds = this._milliseconds;

        units = normalizeUnits(units);

        if (units === 'month' || units === 'year') {
            days = this._days + milliseconds / 864e5;
            months = this._months + daysToMonths(days);
            return units === 'month' ? months : months / 12;
        } else {
            // handle milliseconds separately because of floating point math errors (issue #1867)
            days = this._days + Math.round(monthsToDays(this._months));
            switch (units) {
                case 'week':
                    return days / 7 + milliseconds / 6048e5;
                case 'day':
                    return days + milliseconds / 864e5;
                case 'hour':
                    return days * 24 + milliseconds / 36e5;
                case 'minute':
                    return days * 1440 + milliseconds / 6e4;
                case 'second':
                    return days * 86400 + milliseconds / 1000;
                    // Math.floor prevents floating point math errors here
                case 'millisecond':
                    return Math.floor(days * 864e5) + milliseconds;
                default:
                    throw new Error('Unknown unit ' + units);
            }
        }
    }

    // TODO: Use this.as('ms')?
    function valueOf$1() {
        if (!this.isValid()) {
            return NaN;
        }
        return (
            this._milliseconds +
            this._days * 864e5 +
            (this._months % 12) * 2592e6 +
            toInt(this._months / 12) * 31536e6
        );
    }

    function makeAs(alias) {
        return function() {
            return this.as(alias);
        };
    }

    var asMilliseconds = makeAs('ms');
    var asSeconds = makeAs('s');
    var asMinutes = makeAs('m');
    var asHours = makeAs('h');
    var asDays = makeAs('d');
    var asWeeks = makeAs('w');
    var asMonths = makeAs('M');
    var asYears = makeAs('y');

    function get$2(units) {
        units = normalizeUnits(units);
        return this.isValid() ? this[units + 's']() : NaN;
    }

    function makeGetter(name) {
        return function() {
            return this.isValid() ? this._data[name] : NaN;
        };
    }

    var milliseconds = makeGetter('milliseconds');
    var seconds = makeGetter('seconds');
    var minutes = makeGetter('minutes');
    var hours = makeGetter('hours');
    var days = makeGetter('days');
    var months = makeGetter('months');
    var years = makeGetter('years');

    function weeks() {
        return absFloor(this.days() / 7);
    }

    var round = Math.round;
    var thresholds = {
        ss: 44, // a few seconds to seconds
        s: 45, // seconds to minute
        m: 45, // minutes to hour
        h: 22, // hours to day
        d: 26, // days to month
        M: 11 // months to year
    };

    // helper function for moment.fn.from, moment.fn.fromNow, and moment.duration.fn.humanize
    function substituteTimeAgo(string, number, withoutSuffix, isFuture, locale) {
        return locale.relativeTime(number || 1, !!withoutSuffix, string, isFuture);
    }

    function relativeTime$1(posNegDuration, withoutSuffix, locale) {
        var duration = createDuration(posNegDuration).abs();
        var seconds = round(duration.as('s'));
        var minutes = round(duration.as('m'));
        var hours = round(duration.as('h'));
        var days = round(duration.as('d'));
        var months = round(duration.as('M'));
        var years = round(duration.as('y'));

        var a = seconds <= thresholds.ss && ['s', seconds] ||
            seconds < thresholds.s && ['ss', seconds] ||
            minutes <= 1 && ['m'] ||
            minutes < thresholds.m && ['mm', minutes] ||
            hours <= 1 && ['h'] ||
            hours < thresholds.h && ['hh', hours] ||
            days <= 1 && ['d'] ||
            days < thresholds.d && ['dd', days] ||
            months <= 1 && ['M'] ||
            months < thresholds.M && ['MM', months] ||
            years <= 1 && ['y'] || ['yy', years];

        a[2] = withoutSuffix;
        a[3] = +posNegDuration > 0;
        a[4] = locale;
        return substituteTimeAgo.apply(null, a);
    }

    // This function allows you to set the rounding function for relative time strings
    function getSetRelativeTimeRounding(roundingFunction) {
        if (roundingFunction === undefined) {
            return round;
        }
        if (typeof(roundingFunction) === 'function') {
            round = roundingFunction;
            return true;
        }
        return false;
    }

    // This function allows you to set a threshold for relative time strings
    function getSetRelativeTimeThreshold(threshold, limit) {
        if (thresholds[threshold] === undefined) {
            return false;
        }
        if (limit === undefined) {
            return thresholds[threshold];
        }
        thresholds[threshold] = limit;
        if (threshold === 's') {
            thresholds.ss = limit - 1;
        }
        return true;
    }

    function humanize(withSuffix) {
        if (!this.isValid()) {
            return this.localeData().invalidDate();
        }

        var locale = this.localeData();
        var output = relativeTime$1(this, !withSuffix, locale);

        if (withSuffix) {
            output = locale.pastFuture(+this, output);
        }

        return locale.postformat(output);
    }

    var abs$1 = Math.abs;

    function toISOString$1() {
        // for ISO strings we do not use the normal bubbling rules:
        //  * milliseconds bubble up until they become hours
        //  * days do not bubble at all
        //  * months bubble up until they become years
        // This is because there is no context-free conversion between hours and days
        // (think of clock changes)
        // and also not between days and months (28-31 days per month)
        if (!this.isValid()) {
            return this.localeData().invalidDate();
        }

        var seconds = abs$1(this._milliseconds) / 1000;
        var days = abs$1(this._days);
        var months = abs$1(this._months);
        var minutes, hours, years;

        // 3600 seconds -> 60 minutes -> 1 hour
        minutes = absFloor(seconds / 60);
        hours = absFloor(minutes / 60);
        seconds %= 60;
        minutes %= 60;

        // 12 months -> 1 year
        years = absFloor(months / 12);
        months %= 12;


        // inspired by https://github.com/dordille/moment-isoduration/blob/master/moment.isoduration.js
        var Y = years;
        var M = months;
        var D = days;
        var h = hours;
        var m = minutes;
        var s = seconds;
        var total = this.asSeconds();

        if (!total) {
            // this is the same as C#'s (Noda) and python (isodate)...
            // but not other JS (goog.date)
            return 'P0D';
        }

        return (total < 0 ? '-' : '') +
            'P' +
            (Y ? Y + 'Y' : '') +
            (M ? M + 'M' : '') +
            (D ? D + 'D' : '') +
            ((h || m || s) ? 'T' : '') +
            (h ? h + 'H' : '') +
            (m ? m + 'M' : '') +
            (s ? s + 'S' : '');
    }

    var proto$2 = Duration.prototype;

    proto$2.isValid = isValid$1;
    proto$2.abs = abs;
    proto$2.add = add$1;
    proto$2.subtract = subtract$1;
    proto$2.as = as;
    proto$2.asMilliseconds = asMilliseconds;
    proto$2.asSeconds = asSeconds;
    proto$2.asMinutes = asMinutes;
    proto$2.asHours = asHours;
    proto$2.asDays = asDays;
    proto$2.asWeeks = asWeeks;
    proto$2.asMonths = asMonths;
    proto$2.asYears = asYears;
    proto$2.valueOf = valueOf$1;
    proto$2._bubble = bubble;
    proto$2.get = get$2;
    proto$2.milliseconds = milliseconds;
    proto$2.seconds = seconds;
    proto$2.minutes = minutes;
    proto$2.hours = hours;
    proto$2.days = days;
    proto$2.weeks = weeks;
    proto$2.months = months;
    proto$2.years = years;
    proto$2.humanize = humanize;
    proto$2.toISOString = toISOString$1;
    proto$2.toString = toISOString$1;
    proto$2.toJSON = toISOString$1;
    proto$2.locale = locale;
    proto$2.localeData = localeData;

    // Deprecations
    proto$2.toIsoString = deprecate('toIsoString() is deprecated. Please use toISOString() instead (notice the capitals)', toISOString$1);
    proto$2.lang = lang;

    // Side effect imports

    // FORMATTING

    addFormatToken('X', 0, 0, 'unix');
    addFormatToken('x', 0, 0, 'valueOf');

    // PARSING

    addRegexToken('x', matchSigned);
    addRegexToken('X', matchTimestamp);
    addParseToken('X', function(input, array, config) {
        config._d = new Date(parseFloat(input, 10) * 1000);
    });
    addParseToken('x', function(input, array, config) {
        config._d = new Date(toInt(input));
    });

    // Side effect imports


    hooks.version = '2.18.1';

    setHookCallback(createLocal);

    hooks.fn = proto;
    hooks.min = min;
    hooks.max = max;
    hooks.now = now;
    hooks.utc = createUTC;
    hooks.unix = createUnix;
    hooks.months = listMonths;
    hooks.isDate = isDate;
    hooks.locale = getSetGlobalLocale;
    hooks.invalid = createInvalid;
    hooks.duration = createDuration;
    hooks.isMoment = isMoment;
    hooks.weekdays = listWeekdays;
    hooks.parseZone = createInZone;
    hooks.localeData = getLocale;
    hooks.isDuration = isDuration;
    hooks.monthsShort = listMonthsShort;
    hooks.weekdaysMin = listWeekdaysMin;
    hooks.defineLocale = defineLocale;
    hooks.updateLocale = updateLocale;
    hooks.locales = listLocales;
    hooks.weekdaysShort = listWeekdaysShort;
    hooks.normalizeUnits = normalizeUnits;
    hooks.relativeTimeRounding = getSetRelativeTimeRounding;
    hooks.relativeTimeThreshold = getSetRelativeTimeThreshold;
    hooks.calendarFormat = getCalendarFormat;
    hooks.prototype = proto;

    module.exports = hooks;

})()
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/time/moment',_glass_time_moment_);
    else
      _glass_time_moment_.call(this, module, exports, require);
  }
  else {
    _glass_time_moment_.call(this);
  }
}).call(this)
void (function(){var _glass_toposort_ = function(module,exports,require){
// copied from https://github.com/marcelklehr/toposort/blob/master/index.js
/**
 * Topological sorting function
 *
 * @param {Array} edges
 * @returns {Array}
 */

module.exports = exports = function(edges){
  return toposort(uniqueNodes(edges), edges)
}

exports.array = toposort

function toposort(nodes, edges) {
  var cursor = nodes.length
    , sorted = new Array(cursor)
    , visited = {}
    , i = cursor

  while (i--) {
    if (!visited[i]) visit(nodes[i], i, [])
  }

  return sorted

  function visit(node, i, predecessors) {
    if(predecessors.indexOf(node) >= 0) {
      throw new Error('Cyclic dependency: '+JSON.stringify(node))
    }

    if (visited[i]) return;
    visited[i] = true

    // outgoing edges
    var outgoing = edges.filter(function(edge){
      return edge[0] === node
    })
    if (i = outgoing.length) {
      var preds = predecessors.concat(node)
      do {
        var child = outgoing[--i][1]
        visit(child, nodes.indexOf(child), preds)
      } while (i)
    }

    sorted[--cursor] = node
  }
}

function uniqueNodes(arr){
  var res = []
  for (var i = 0, len = arr.length; i < len; i++) {
    var edge = arr[i]
    if (res.indexOf(edge[0]) < 0) res.push(edge[0])
    if (res.indexOf(edge[1]) < 0) res.push(edge[1])
  }
  return res
}
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/toposort',_glass_toposort_);
    else
      _glass_toposort_.call(this, module, exports, require);
  }
  else {
    _glass_toposort_.call(this);
  }
}).call(this)
void (function(){var _glass_webgl_Context_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('./');
var VertexBuffer = _ref.VertexBuffer;
var VertexFormat = _ref.VertexFormat;
var vec3 = _ref.math.vec3;
var mat4 = _ref.math.mat4;
var Context = ion.defineClass({
        name: 'Context',
        constructor: function Context(properties) {
            Context.super.apply(this, arguments);
            this.gl = this.canvas.getContext('webgl');
            this.gl.viewportWidth = canvas.offsetWidth;
            this.gl.viewportHeight = canvas.offsetHeight;
            this.attributes = this.attributes != null ? this.attributes : {};
            this.model = mat4.identity(mat4.create());
            this.view = mat4.identity(mat4.create());
            this.projection = mat4.identity(mat4.create());
            this.program = 'identity_vs:identity_fs';
            this.dynamicBuffers = {};
        },
        shaders: {
            identity_vs: 'attribute vec3 position;\nattribute vec4 color;\nuniform mat4 modelView;\nuniform mat4 projection;\nvarying vec4 vColor;\nvoid main(void) {\n    gl_Position = projection * modelView * vec4(position, 1.0);\n    vColor = color;\n}',
            identity_fs: 'precision mediump float;\nvarying vec4 vColor;\nvoid main(void) {\n    gl_FragColor = vColor;\n}'
        },
        properties: {
            createShader: function (id) {
                var gl = this.gl;
                var source = this.constructor.shaders[id];
                if (!(source != null)) {
                    var shaderScript = document.getElementById(id);
                    if (!shaderScript) {
                        throw new Error('Shader ' + id + ' not found in Context.shaders or script declaration');
                    }
                    source = shaderScript.innerHTML;
                }
                var shaderType = source.indexOf('gl_Position') > 0 ? gl.VERTEX_SHADER : gl.FRAGMENT_SHADER;
                var shader = gl.createShader(shaderType);
                gl.shaderSource(shader, source);
                gl.compileShader(shader);
                if (!gl.getShaderParameter(shader, gl.COMPILE_STATUS)) {
                    throw new Error(gl.getShaderInfoLog(shader));
                }
                return shader;
            },
            getShader: function (id) {
                var shaders = this.shaders = this.shaders != null ? this.shaders : {};
                var shader = shaders[id] = shaders[id] != null ? shaders[id] : this.createShader(id);
                return shader;
            },
            createProgram: function (shaderIds) {
                var gl = this.gl;
                var program = gl.createProgram();
                {
                    var _ref3 = shaderIds.split(':');
                    for (var _i = 0; _i < _ref3.length; _i++) {
                        var shaderId = _ref3[_i];
                        var shader = this.getShader(shaderId);
                        gl.attachShader(program, shader);
                    }
                }
                gl.linkProgram(program);
                if (!gl.getProgramParameter(program, gl.LINK_STATUS)) {
                    throw new Error('Could not initialise shaders');
                }
                var uniformCount = gl.getProgramParameter(program, gl.ACTIVE_UNIFORMS);
                var _ref7 = [];
                for (var i = 0; i < uniformCount; i++) {
                    var uniform = gl.getActiveUniform(program, i);
                    _ref7.push(ion.patch.combine(uniform, { location: gl.getUniformLocation(program, uniform.name) }));
                }
                program.uniforms = _ref7;
                var attributeCount = gl.getProgramParameter(program, gl.ACTIVE_ATTRIBUTES);
                var _ref8 = [];
                for (var i = 0; i < attributeCount; i++) {
                    var attribute = gl.getActiveAttrib(program, i);
                    _ref8.push(ion.patch.combine(attribute, { location: gl.getAttribLocation(program, attribute.name) }));
                }
                program.attributes = _ref8;
                return program;
            },
            getProgram: function (vs_fs) {
                var programs = this.programs = this.programs != null ? this.programs : {};
                var program = programs[vs_fs] = programs[vs_fs] != null ? programs[vs_fs] : this.createProgram(vs_fs);
                return program;
            },
            program: {
                set: function (value) {
                    if (typeof value === 'string') {
                        value = this.getProgram(value);
                    }
                    if (this._program !== value) {
                        this.flush();
                        this._program = value;
                        this.gl.useProgram(value);
                    }
                },
                get: function () {
                    return this._program;
                }
            },
            setUniform: function (uniform, value) {
                this.gl.uniformMatrix4fv(uniform.location, false, value);
            },
            setUniforms: function () {
                var gl = this.gl;
                {
                    var _ref4 = this._program.uniforms;
                    for (var _i2 = 0; _i2 < _ref4.length; _i2++) {
                        var uniform = _ref4[_i2];
                        var value = this[uniform.name];
                        if (!(value != null)) {
                            throw new Error('Uniform not found: ' + uniform.name);
                        }
                        this.setUniform(uniform, value);
                    }
                }
            },
            setAttribute: function (name, _ref2) {
                var buffer = _ref2.buffer;
                var size = _ref2.size;
                var stride = _ref2.stride;
                var offset = _ref2.offset;
                if (!(buffer != null)) {
                    throw new Error('buffer property required');
                }
                if (!(size != null)) {
                    throw new Error('size property required');
                }
                this.attributes[name] = {
                    buffer: buffer,
                    size: size,
                    stride: stride != null ? stride : 0,
                    offset: offset != null ? offset : 0
                };
            },
            bindAttributes: function () {
                var gl = this.gl;
                {
                    var _ref5 = this._program.attributes;
                    for (var _i3 = 0; _i3 < _ref5.length; _i3++) {
                        var attribute = _ref5[_i3];
                        var value = this.attributes[attribute.name];
                        if (!(value != null)) {
                            throw new Error('Attribute not found: ' + attribute.name);
                        }
                        gl.bindBuffer(gl.ARRAY_BUFFER, value.buffer);
                        gl.vertexAttribPointer(attribute.location, value.size, gl.FLOAT, false, value.stride, value.offset);
                        gl.enableVertexAttribArray(attribute.location);
                    }
                }
            },
            createVertexBuffer: function (format, usage) {
                return VertexBuffer(this, format, usage);
            },
            vertexFormat: {
                description: 'The vertex format to use for dynamic draw methods',
                writable: true,
                value: VertexFormat.positionColor
            },
            draw: function (vertices) {
                var vertexBuffer = this.dynamicBuffers[this.vertexFormat] = this.dynamicBuffers[this.vertexFormat] != null ? this.dynamicBuffers[this.vertexFormat] : this.createVertexBuffer(this.vertexFormat);
                if (!Array.isArray(vertices)) {
                    vertices = arguments;
                }
                vertexBuffer.stream.draw(vertices);
            },
            beginFrame: function () {
            },
            endFrame: function () {
                this.flush();
            },
            flush: function () {
                {
                    var _ref6 = this.dynamicBuffers;
                    for (var id in _ref6) {
                        var vertexBuffer = _ref6[id];
                        vertexBuffer.flush();
                    }
                }
            },
            _vertexBuffer: null,
            vertexBuffer: {
                get: function () {
                    return this._vertexBuffer;
                },
                set: function (value) {
                    if (this._vertexBuffer !== value) {
                        this._vertexBuffer != null ? this._vertexBuffer.flush() : void 0;
                        this._vertexBuffer = value;
                        this._vertexBuffer.setAttributes();
                        this.bindAttributes();
                    }
                }
            },
            width: {
                get: function () {
                    return this.gl.viewportWidth;
                }
            },
            height: {
                get: function () {
                    return this.gl.viewportHeight;
                }
            },
            _model: null,
            model: {
                get: function () {
                    return this._model;
                },
                set: function (value) {
                    this.flush();
                    this._model = value;
                }
            },
            _view: null,
            view: {
                get: function () {
                    return this._view;
                },
                set: function (value) {
                    this.flush();
                    this._view = value;
                }
            },
            _projection: null,
            projection: {
                get: function () {
                    return this._projection;
                },
                set: function (value) {
                    this.flush();
                    this._projection = value;
                }
            },
            modelView: {
                get: function () {
                    return mat4.multiply(mat4.create(), this.model, this.view);
                }
            },
            modelViewProjection: {
                get: function () {
                    return mat4.multiply(mat4.create(), this.modelView, this.projection);
                }
            }
        }
    });
module.exports = exports = Context;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/webgl/Context',_glass_webgl_Context_);
    else
      _glass_webgl_Context_.call(this, module, exports, require);
  }
  else {
    _glass_webgl_Context_.call(this);
  }
}).call(this)
void (function(){var _glass_webgl_Fps_ = function(module,exports,require){'use strict';
var ion = require('ion');
var Fps = ion.defineClass({
        name: 'Fps',
        properties: {
            frameInterval: 30,
            update: function (c) {
                this.start = this.start != null ? this.start : Date.now();
                this.count = this.count != null ? this.count : 0;
                if (!(this.element != null)) {
                    this.element = ion.patch.combine(document.createElement('span'), {
                        style: {
                            color: 'beige',
                            position: 'absolute',
                            top: 10,
                            left: 10
                        }
                    });
                    document.body.appendChild(this.element);
                }
                this.count++;
                if (this.count % this.frameInterval === 0) {
                    var now = Date.now();
                    var time = (now - this.start) / 1000;
                    var fps = this.frameInterval / time;
                    this.element.innerText = Math.round(fps) + ' FPS';
                    this.start = now;
                }
            },
            dispose: function () {
                Fps.super.prototype.dispose.apply(this, arguments);
                if (this.element != null) {
                    this.element.parentElement.removeChild(this.element);
                    this.element = null;
                }
            }
        }
    }, require('./Node'));
module.exports = exports = Fps;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/webgl/Fps',_glass_webgl_Fps_);
    else
      _glass_webgl_Fps_.call(this, module, exports, require);
  }
  else {
    _glass_webgl_Fps_.call(this);
  }
}).call(this)
void (function(){var _glass_webgl_Node_ = function(module,exports,require){'use strict';
var ion = require('ion');
var Node = ion.defineClass({
        name: 'Node',
        properties: {
            update: {
                writable: true,
                value: function (c) {
                    var components = this.components;
                    if (components != null) {
                        for (var id in components) {
                            var node = components[id];
                            node.update != null ? node.update(c) : void 0;
                        }
                    }
                }
            },
            render: {
                writable: true,
                value: function (c) {
                    var components = this.components;
                    if (components != null) {
                        for (var id in components) {
                            var node = components[id];
                            node.render != null ? node.render(c) : void 0;
                        }
                    }
                }
            }
        }
    }, require('../Component'));
module.exports = exports = Node;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/webgl/Node',_glass_webgl_Node_);
    else
      _glass_webgl_Node_.call(this, module, exports, require);
  }
  else {
    _glass_webgl_Node_.call(this);
  }
}).call(this)
void (function(){var _glass_webgl_SceneGraph_ = function(module,exports,require){'use strict';
var ion = require('ion');
var SceneGraph = ion.defineClass({
        name: 'SceneGraph',
        constructor: function SceneGraph(properties) {
            SceneGraph.super.apply(this, arguments);
            this.animateFrame = ion.bind(function (time) {
                if (this.running) {
                    this.update();
                    this.context.beginFrame();
                    this.render(this.context);
                    this.context.endFrame();
                    requestAnimationFrame(this.animateFrame);
                }
            }, this);
        },
        properties: {
            context: {
                get: function () {
                    return this._context;
                },
                set: function (value) {
                    this._context = value;
                    this.running = this.running != null ? this.running : true;
                }
            },
            running: {
                get: function () {
                    return this._running;
                },
                set: function (value) {
                    if (!(this.context != null)) {
                        throw new Error('context property must be set before you can run a scene graph.');
                    }
                    if (this._running !== value) {
                        this._running = value;
                        if (value) {
                            requestAnimationFrame(this.animateFrame);
                        }
                    }
                }
            }
        }
    }, require('./Node'));
module.exports = exports = SceneGraph;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/webgl/SceneGraph',_glass_webgl_SceneGraph_);
    else
      _glass_webgl_SceneGraph_.call(this, module, exports, require);
  }
  else {
    _glass_webgl_SceneGraph_.call(this);
  }
}).call(this)
void (function(){var _glass_webgl_Screen_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('./');
var Node = _ref.Node;
var vec3 = _ref.math.vec3;
var mat4 = _ref.math.mat4;
var Screen = ion.defineClass({
        name: 'Screen',
        properties: {
            color: {
                value: new Float32Array([
                    0.5,
                    0.5,
                    0.5,
                    1
                ])
            },
            render: function (c) {
                var gl = c.gl;
                gl.clearColor(this.color.r, this.color.g, this.color.b, this.color.a);
                gl.clear(gl.COLOR_BUFFER_BIT | gl.DEPTH_BUFFER_BIT);
                gl.viewport(0, 0, gl.viewportWidth, gl.viewportHeight);
                c.projection = mat4.ortho(c.projection, 0, gl.viewportWidth, gl.viewportHeight, 0, 0, 1);
                Screen.super.prototype.render.apply(this, arguments);
            }
        }
    }, Node);
module.exports = exports = Screen;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/webgl/Screen',_glass_webgl_Screen_);
    else
      _glass_webgl_Screen_.call(this, module, exports, require);
  }
  else {
    _glass_webgl_Screen_.call(this);
  }
}).call(this)
void (function(){var _glass_webgl_VertexBuffer_ = function(module,exports,require){'use strict';
var ion = require('ion');
var VertexStream = require('./VertexStream');
module.exports = exports = function VertexBuffer(context, format, usage) {
    var gl = context.gl;
    var buffer = Object.defineProperties(ion.patch.combine(gl.createBuffer(), {
            format: format,
            setData: function (data) {
                if (Array.isArray(data)) {
                    data = new Float32Array(data);
                }
                gl.bindBuffer(gl.ARRAY_BUFFER, buffer);
                gl.bufferData(gl.ARRAY_BUFFER, data, usage != null ? usage : gl.DYNAMIC_DRAW);
                buffer.elementCount = data.byteLength / format.size;
                return buffer;
            },
            setAttributes: function () {
                {
                    var _ref = format.attributes;
                    for (var name in _ref) {
                        var value = _ref[name];
                        context.setAttribute(name, {
                            buffer: buffer,
                            size: value.elements,
                            offset: value.offset,
                            stride: format.size
                        });
                    }
                }
            },
            draw: function (mode, offset, count) {
                if (mode == null)
                    mode = gl.TRIANGLES;
                if (offset == null)
                    offset = 0;
                if (count == null)
                    count = this.elementCount != null ? this.elementCount : 0;
                if (count > 0) {
                    context.vertexBuffer = this;
                    context.setUniforms();
                    gl.drawArrays(mode, offset, count);
                }
            },
            createVertexStream: function () {
                return new VertexStream(this);
            },
            flush: function () {
                this._stream != null ? this._stream.flush() : void 0;
            }
        }), {
            stream: {
                get: function () {
                    return this._stream = this._stream != null ? this._stream : this.createVertexStream();
                },
                set: function (value) {
                    return this._stream = value;
                }
            }
        });
    return buffer;
};
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/webgl/VertexBuffer',_glass_webgl_VertexBuffer_);
    else
      _glass_webgl_VertexBuffer_.call(this, module, exports, require);
  }
  else {
    _glass_webgl_VertexBuffer_.call(this);
  }
}).call(this)
void (function(){var _glass_webgl_VertexFormat_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('./'), _cache = {};
var glTypes = _ref.glTypes;
var VertexFormat = ion.defineClass({
        name: 'VertexFormat',
        constructor: function VertexFormat(attributes) {
            var id = JSON.stringify(attributes);
            var cached = _cache[id];
            if (cached != null) {
                return cached;
            }
            _cache[id] = this;
            this.id = id;
            this.attributes = attributes;
            var offset = 0;
            for (var name in attributes) {
                var attribute = attributes[name];
                var glType = glTypes[attribute.type];
                if (!(attribute.elements != null)) {
                    throw new Error('elements is required for attribute: ' + JSON.stringify(attribute));
                }
                if (!(glType != null)) {
                    throw new Error('glType not found for attribute: ' + JSON.stringify(attribute));
                }
                attribute.offset = offset;
                var size = glType.size * attribute.elements;
                var pad = size % 4;
                offset += size + pad;
                Object.freeze(attribute);
            }
            this.size = offset;
            Object.freeze(this);
        },
        properties: {
            toString: function () {
                return this.id;
            }
        }
    });
module.exports = exports = VertexFormat;
ion.patch.combine(VertexFormat, {
    positionColor: new VertexFormat({
        position: {
            type: 'FLOAT',
            elements: 3
        },
        color: {
            type: 'FLOAT',
            elements: 4
        }
    })
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/webgl/VertexFormat',_glass_webgl_VertexFormat_);
    else
      _glass_webgl_VertexFormat_.call(this, module, exports, require);
  }
  else {
    _glass_webgl_VertexFormat_.call(this);
  }
}).call(this)
void (function(){var _glass_webgl_VertexStream_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('./');
var gl = _ref.gl;
var glTypes = _ref.glTypes;
var VertexStream = ion.defineClass({
        name: 'VertexStream',
        constructor: function VertexStream(vertexBuffer, maxVertices, mode) {
            if (maxVertices == null)
                maxVertices = 1024;
            if (mode == null)
                mode = gl.TRIANGLES;
            this.vertexBuffer = vertexBuffer;
            this.maxVertices = maxVertices;
            this.mode = mode;
            this.format = vertexBuffer.format;
            this.arrayBuffer = new ArrayBuffer(maxVertices * this.format.size);
            var _ref4 = {};
            {
                var _ref2 = this.format.attributes;
                for (var name in _ref2) {
                    var attribute = _ref2[name];
                    var glType = glTypes[attribute.type];
                    _ref4[name] = ion.patch.combine(new glType.arrayBufferViewType(this.arrayBuffer, attribute.offset), { stride: this.format.size / glType.size });
                }
            }
            this.views = _ref4;
            this.count = 0;
        },
        properties: {
            flush: function () {
                if (this.count > 0) {
                    this.vertexBuffer.setData(new Uint8Array(this.arrayBuffer, 0, this.count * this.format.size));
                    this.vertexBuffer.draw(this.mode);
                    this.count = 0;
                }
            },
            draw: function (vertices) {
                if (this.count + vertices.length > this.maxVertices) {
                    this.flush();
                }
                for (var _i = 0; _i < vertices.length; _i++) {
                    var vertex = vertices[_i];
                    {
                        var _ref3 = this.views;
                        for (var name in _ref3) {
                            var view = _ref3[name];
                            var values = vertex[name];
                            if (values.length != null) {
                                view.set(values, this.count * view.stride);
                            } else {
                                view[this.count * view.stride] = values;
                            }
                        }
                    }
                    this.count++;
                }
            }
        }
    });
module.exports = exports = VertexStream;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/webgl/VertexStream',_glass_webgl_VertexStream_);
    else
      _glass_webgl_VertexStream_.call(this, module, exports, require);
  }
  else {
    _glass_webgl_VertexStream_.call(this);
  }
}).call(this)
void (function(){var _glass_webgl_View_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('./');
var Node = _ref.Node;
var vec3 = _ref.math.vec3;
var mat4 = _ref.math.mat4;
var View = ion.defineClass({
        name: 'View',
        properties: {
            model: { value: null },
            view: { value: null },
            projection: { value: null },
            render: function (c) {
                var model, view, projection;
                if (this.model != null) {
                    model = c.model;
                    c.model = this.model;
                }
                if (this.view != null) {
                    view = c.view;
                    c.view = this.view;
                }
                if (this.projection != null) {
                    projection = c.projection;
                    c.projection = this.projection;
                }
                View.super.prototype.render.apply(this, arguments);
                if (model != null) {
                    c.model = model;
                }
                if (view != null) {
                    c.view = view;
                }
                if (projection != null) {
                    c.projection = projection;
                }
            }
        }
    }, Node);
module.exports = exports = View;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/webgl/View',_glass_webgl_View_);
    else
      _glass_webgl_View_.call(this, module, exports, require);
  }
  else {
    _glass_webgl_View_.call(this);
  }
}).call(this)
void (function(){var _glass_webgl_gl_ = function(module,exports,require){'use strict';
var constants = {
        ACTIVE_ATTRIBUTES: 35721,
        ACTIVE_ATTRIBUTE_MAX_LENGTH: 35722,
        ACTIVE_TEXTURE: 34016,
        ACTIVE_UNIFORMS: 35718,
        ACTIVE_UNIFORM_MAX_LENGTH: 35719,
        ALIASED_LINE_WIDTH_RANGE: 33902,
        ALIASED_POINT_SIZE_RANGE: 33901,
        ALPHA: 6406,
        ALPHA_BITS: 3413,
        ALWAYS: 519,
        ARRAY_BUFFER: 34962,
        ARRAY_BUFFER_BINDING: 34964,
        ATTACHED_SHADERS: 35717,
        BACK: 1029,
        BLEND: 3042,
        BLEND_COLOR: 32773,
        BLEND_DST_ALPHA: 32970,
        BLEND_DST_RGB: 32968,
        BLEND_EQUATION: 32777,
        BLEND_EQUATION_ALPHA: 34877,
        BLEND_EQUATION_RGB: 32777,
        BLEND_SRC_ALPHA: 32971,
        BLEND_SRC_RGB: 32969,
        BLUE_BITS: 3412,
        BOOL: 35670,
        BOOL_VEC2: 35671,
        BOOL_VEC3: 35672,
        BOOL_VEC4: 35673,
        BROWSER_DEFAULT_WEBGL: 37444,
        BUFFER_SIZE: 34660,
        BUFFER_USAGE: 34661,
        BYTE: 5120,
        CCW: 2305,
        CLAMP_TO_EDGE: 33071,
        COLOR_ATTACHMENT0: 36064,
        COLOR_BUFFER_BIT: 16384,
        COLOR_CLEAR_VALUE: 3106,
        COLOR_WRITEMASK: 3107,
        COMPILE_STATUS: 35713,
        COMPRESSED_TEXTURE_FORMATS: 34467,
        CONSTANT_ALPHA: 32771,
        CONSTANT_COLOR: 32769,
        CONTEXT_LOST_WEBGL: 37442,
        CULL_FACE: 2884,
        CULL_FACE_MODE: 2885,
        CURRENT_PROGRAM: 35725,
        CURRENT_VERTEX_ATTRIB: 34342,
        CW: 2304,
        DECR: 7683,
        DECR_WRAP: 34056,
        DELETE_STATUS: 35712,
        DEPTH_ATTACHMENT: 36096,
        DEPTH_BITS: 3414,
        DEPTH_BUFFER_BIT: 256,
        DEPTH_CLEAR_VALUE: 2931,
        DEPTH_COMPONENT: 6402,
        DEPTH_COMPONENT16: 33189,
        DEPTH_FUNC: 2932,
        DEPTH_RANGE: 2928,
        DEPTH_STENCIL: 34041,
        DEPTH_STENCIL_ATTACHMENT: 33306,
        DEPTH_TEST: 2929,
        DEPTH_WRITEMASK: 2930,
        DITHER: 3024,
        DONT_CARE: 4352,
        DST_ALPHA: 772,
        DST_COLOR: 774,
        DYNAMIC_DRAW: 35048,
        ELEMENT_ARRAY_BUFFER: 34963,
        ELEMENT_ARRAY_BUFFER_BINDING: 34965,
        EQUAL: 514,
        FASTEST: 4353,
        FLOAT: 5126,
        FLOAT_MAT2: 35674,
        FLOAT_MAT3: 35675,
        FLOAT_MAT4: 35676,
        FLOAT_VEC2: 35664,
        FLOAT_VEC3: 35665,
        FLOAT_VEC4: 35666,
        FRAGMENT_SHADER: 35632,
        FRAMEBUFFER: 36160,
        FRAMEBUFFER_ATTACHMENT_OBJECT_NAME: 36049,
        FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE: 36048,
        FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE: 36051,
        FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL: 36050,
        FRAMEBUFFER_BINDING: 36006,
        FRAMEBUFFER_COMPLETE: 36053,
        FRAMEBUFFER_INCOMPLETE_ATTACHMENT: 36054,
        FRAMEBUFFER_INCOMPLETE_DIMENSIONS: 36057,
        FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT: 36055,
        FRAMEBUFFER_UNSUPPORTED: 36061,
        FRONT: 1028,
        FRONT_AND_BACK: 1032,
        FRONT_FACE: 2886,
        FUNC_ADD: 32774,
        FUNC_REVERSE_SUBTRACT: 32779,
        FUNC_SUBTRACT: 32778,
        GENERATE_MIPMAP_HINT: 33170,
        GEQUAL: 518,
        GREATER: 516,
        GREEN_BITS: 3411,
        HIGH_FLOAT: 36338,
        HIGH_INT: 36341,
        INCR: 7682,
        INCR_WRAP: 34055,
        INFO_LOG_LENGTH: 35716,
        INT: 5124,
        INT_VEC2: 35667,
        INT_VEC3: 35668,
        INT_VEC4: 35669,
        INVALID_ENUM: 1280,
        INVALID_FRAMEBUFFER_OPERATION: 1286,
        INVALID_OPERATION: 1282,
        INVALID_VALUE: 1281,
        INVERT: 5386,
        KEEP: 7680,
        LEQUAL: 515,
        LESS: 513,
        LINEAR: 9729,
        LINEAR_MIPMAP_LINEAR: 9987,
        LINEAR_MIPMAP_NEAREST: 9985,
        LINES: 1,
        LINE_LOOP: 2,
        LINE_STRIP: 3,
        LINE_WIDTH: 2849,
        LINK_STATUS: 35714,
        LOW_FLOAT: 36336,
        LOW_INT: 36339,
        LUMINANCE: 6409,
        LUMINANCE_ALPHA: 6410,
        MAX_COMBINED_TEXTURE_IMAGE_UNITS: 35661,
        MAX_CUBE_MAP_TEXTURE_SIZE: 34076,
        MAX_FRAGMENT_UNIFORM_VECTORS: 36349,
        MAX_RENDERBUFFER_SIZE: 34024,
        MAX_TEXTURE_IMAGE_UNITS: 34930,
        MAX_TEXTURE_SIZE: 3379,
        MAX_VARYING_VECTORS: 36348,
        MAX_VERTEX_ATTRIBS: 34921,
        MAX_VERTEX_TEXTURE_IMAGE_UNITS: 35660,
        MAX_VERTEX_UNIFORM_VECTORS: 36347,
        MAX_VIEWPORT_DIMS: 3386,
        MEDIUM_FLOAT: 36337,
        MEDIUM_INT: 36340,
        MIRRORED_REPEAT: 33648,
        NEAREST: 9728,
        NEAREST_MIPMAP_LINEAR: 9986,
        NEAREST_MIPMAP_NEAREST: 9984,
        NEVER: 512,
        NICEST: 4354,
        NONE: 0,
        NOTEQUAL: 517,
        NO_ERROR: 0,
        NUM_COMPRESSED_TEXTURE_FORMATS: 34466,
        ONE: 1,
        ONE_MINUS_CONSTANT_ALPHA: 32772,
        ONE_MINUS_CONSTANT_COLOR: 32770,
        ONE_MINUS_DST_ALPHA: 773,
        ONE_MINUS_DST_COLOR: 775,
        ONE_MINUS_SRC_ALPHA: 771,
        ONE_MINUS_SRC_COLOR: 769,
        OUT_OF_MEMORY: 1285,
        PACK_ALIGNMENT: 3333,
        POINTS: 0,
        POLYGON_OFFSET_FACTOR: 32824,
        POLYGON_OFFSET_FILL: 32823,
        POLYGON_OFFSET_UNITS: 10752,
        RED_BITS: 3410,
        RENDERBUFFER: 36161,
        RENDERBUFFER_ALPHA_SIZE: 36179,
        RENDERBUFFER_BINDING: 36007,
        RENDERBUFFER_BLUE_SIZE: 36178,
        RENDERBUFFER_DEPTH_SIZE: 36180,
        RENDERBUFFER_GREEN_SIZE: 36177,
        RENDERBUFFER_HEIGHT: 36163,
        RENDERBUFFER_INTERNAL_FORMAT: 36164,
        RENDERBUFFER_RED_SIZE: 36176,
        RENDERBUFFER_STENCIL_SIZE: 36181,
        RENDERBUFFER_WIDTH: 36162,
        RENDERER: 7937,
        REPEAT: 10497,
        REPLACE: 7681,
        RGB: 6407,
        RGB5_A1: 32855,
        RGB565: 36194,
        RGBA: 6408,
        RGBA4: 32854,
        SAMPLER_2D: 35678,
        SAMPLER_CUBE: 35680,
        SAMPLES: 32937,
        SAMPLE_ALPHA_TO_COVERAGE: 32926,
        SAMPLE_BUFFERS: 32936,
        SAMPLE_COVERAGE: 32928,
        SAMPLE_COVERAGE_INVERT: 32939,
        SAMPLE_COVERAGE_VALUE: 32938,
        SCISSOR_BOX: 3088,
        SCISSOR_TEST: 3089,
        SHADER_COMPILER: 36346,
        SHADER_SOURCE_LENGTH: 35720,
        SHADER_TYPE: 35663,
        SHADING_LANGUAGE_VERSION: 35724,
        SHORT: 5122,
        SRC_ALPHA: 770,
        SRC_ALPHA_SATURATE: 776,
        SRC_COLOR: 768,
        STATIC_DRAW: 35044,
        STENCIL_ATTACHMENT: 36128,
        STENCIL_BACK_FAIL: 34817,
        STENCIL_BACK_FUNC: 34816,
        STENCIL_BACK_PASS_DEPTH_FAIL: 34818,
        STENCIL_BACK_PASS_DEPTH_PASS: 34819,
        STENCIL_BACK_REF: 36003,
        STENCIL_BACK_VALUE_MASK: 36004,
        STENCIL_BACK_WRITEMASK: 36005,
        STENCIL_BITS: 3415,
        STENCIL_BUFFER_BIT: 1024,
        STENCIL_CLEAR_VALUE: 2961,
        STENCIL_FAIL: 2964,
        STENCIL_FUNC: 2962,
        STENCIL_INDEX: 6401,
        STENCIL_INDEX8: 36168,
        STENCIL_PASS_DEPTH_FAIL: 2965,
        STENCIL_PASS_DEPTH_PASS: 2966,
        STENCIL_REF: 2967,
        STENCIL_TEST: 2960,
        STENCIL_VALUE_MASK: 2963,
        STENCIL_WRITEMASK: 2968,
        STREAM_DRAW: 35040,
        SUBPIXEL_BITS: 3408,
        TEXTURE: 5890,
        TEXTURE0: 33984,
        TEXTURE1: 33985,
        TEXTURE2: 33986,
        TEXTURE3: 33987,
        TEXTURE4: 33988,
        TEXTURE5: 33989,
        TEXTURE6: 33990,
        TEXTURE7: 33991,
        TEXTURE8: 33992,
        TEXTURE9: 33993,
        TEXTURE10: 33994,
        TEXTURE11: 33995,
        TEXTURE12: 33996,
        TEXTURE13: 33997,
        TEXTURE14: 33998,
        TEXTURE15: 33999,
        TEXTURE16: 34000,
        TEXTURE17: 34001,
        TEXTURE18: 34002,
        TEXTURE19: 34003,
        TEXTURE20: 34004,
        TEXTURE21: 34005,
        TEXTURE22: 34006,
        TEXTURE23: 34007,
        TEXTURE24: 34008,
        TEXTURE25: 34009,
        TEXTURE26: 34010,
        TEXTURE27: 34011,
        TEXTURE28: 34012,
        TEXTURE29: 34013,
        TEXTURE30: 34014,
        TEXTURE31: 34015,
        TEXTURE_2D: 3553,
        TEXTURE_BINDING_2D: 32873,
        TEXTURE_BINDING_CUBE_MAP: 34068,
        TEXTURE_CUBE_MAP: 34067,
        TEXTURE_CUBE_MAP_NEGATIVE_X: 34070,
        TEXTURE_CUBE_MAP_NEGATIVE_Y: 34072,
        TEXTURE_CUBE_MAP_NEGATIVE_Z: 34074,
        TEXTURE_CUBE_MAP_POSITIVE_X: 34069,
        TEXTURE_CUBE_MAP_POSITIVE_Y: 34071,
        TEXTURE_CUBE_MAP_POSITIVE_Z: 34073,
        TEXTURE_MAG_FILTER: 10240,
        TEXTURE_MIN_FILTER: 10241,
        TEXTURE_WRAP_S: 10242,
        TEXTURE_WRAP_T: 10243,
        TRIANGLES: 4,
        TRIANGLE_FAN: 6,
        TRIANGLE_STRIP: 5,
        UNPACK_ALIGNMENT: 3317,
        UNPACK_COLORSPACE_CONVERSION_WEBGL: 37443,
        UNPACK_FLIP_Y_WEBGL: 37440,
        UNPACK_PREMULTIPLY_ALPHA_WEBGL: 37441,
        UNSIGNED_BYTE: 5121,
        UNSIGNED_INT: 5125,
        UNSIGNED_SHORT: 5123,
        UNSIGNED_SHORT_4_4_4_4: 32819,
        UNSIGNED_SHORT_5_5_5_1: 32820,
        UNSIGNED_SHORT_5_6_5: 33635,
        VALIDATE_STATUS: 35715,
        VENDOR: 7936,
        VERSION: 7938,
        VERTEX_ATTRIB_ARRAY_BUFFER_BINDING: 34975,
        VERTEX_ATTRIB_ARRAY_ENABLED: 34338,
        VERTEX_ATTRIB_ARRAY_NORMALIZED: 34922,
        VERTEX_ATTRIB_ARRAY_POINTER: 34373,
        VERTEX_ATTRIB_ARRAY_SIZE: 34339,
        VERTEX_ATTRIB_ARRAY_STRIDE: 34340,
        VERTEX_ATTRIB_ARRAY_TYPE: 34341,
        VERTEX_SHADER: 35633,
        VIEWPORT: 2978,
        ZERO: 0
    };
var _ref = {};
for (var name in constants) {
    var value = constants[name];
    _ref[name] = value;
    _ref[value] = name;
}
module.exports = exports = _ref;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/webgl/gl',_glass_webgl_gl_);
    else
      _glass_webgl_gl_.call(this, module, exports, require);
  }
  else {
    _glass_webgl_gl_.call(this);
  }
}).call(this)
void (function(){var _glass_webgl_glTypes_ = function(module,exports,require){'use strict';
var _ref = require('./');
var gl = _ref.gl;
var types = {
        BYTE: {
            size: 1,
            arrayBufferViewType: Int8Array
        },
        UNSIGNED_BYTE: {
            size: 1,
            arrayBufferViewType: Uint8Array
        },
        BOOL: {
            size: 1,
            arrayBufferViewType: Uint8Array
        },
        SHORT: {
            size: 2,
            arrayBufferViewType: Int16Array
        },
        UNSIGNED_SHORT: {
            size: 2,
            arrayBufferViewType: Uint16Array
        },
        INT: {
            size: 4,
            arrayBufferViewType: Int32Array
        },
        UNSIGNED_INT: {
            size: 4,
            arrayBufferViewType: Uint32Array
        },
        FLOAT: {
            size: 4,
            arrayBufferViewType: Float32Array
        }
    };
for (var name in types) {
    var type = types[name];
    type.value = gl[name];
}
module.exports = exports = types;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/webgl/glTypes',_glass_webgl_glTypes_);
    else
      _glass_webgl_glTypes_.call(this, module, exports, require);
  }
  else {
    _glass_webgl_glTypes_.call(this);
  }
}).call(this)
void (function(){var _glass_webgl_index_ = function(module,exports,require){Object.defineProperty(exports, 'Context', {get:function(){ return require('./Context') }, enumerable: true}) 
Object.defineProperty(exports, 'Fps', {get:function(){ return require('./Fps') }, enumerable: true}) 
Object.defineProperty(exports, 'Node', {get:function(){ return require('./Node') }, enumerable: true}) 
Object.defineProperty(exports, 'SceneGraph', {get:function(){ return require('./SceneGraph') }, enumerable: true}) 
Object.defineProperty(exports, 'Screen', {get:function(){ return require('./Screen') }, enumerable: true}) 
Object.defineProperty(exports, 'VertexBuffer', {get:function(){ return require('./VertexBuffer') }, enumerable: true}) 
Object.defineProperty(exports, 'VertexFormat', {get:function(){ return require('./VertexFormat') }, enumerable: true}) 
Object.defineProperty(exports, 'VertexStream', {get:function(){ return require('./VertexStream') }, enumerable: true}) 
Object.defineProperty(exports, 'View', {get:function(){ return require('./View') }, enumerable: true}) 
Object.defineProperty(exports, 'gl', {get:function(){ return require('./gl') }, enumerable: true}) 
Object.defineProperty(exports, 'glTypes', {get:function(){ return require('./glTypes') }, enumerable: true}) 
Object.defineProperty(exports, 'math', {get:function(){ return require('./math') }, enumerable: true}) 
Object.freeze(exports)
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/webgl/index',_glass_webgl_index_);
    else
      _glass_webgl_index_.call(this, module, exports, require);
  }
  else {
    _glass_webgl_index_.call(this);
  }
}).call(this)
void (function(){var _glass_webgl_math_gl_matrix_ = function(module,exports,require){/**
 * @fileoverview gl-matrix - High performance matrix and vector operations
 * @author Brandon Jones
 * @author Colin MacKenzie IV
 * @version 2.2.1
 */

/* Copyright (c) 2013, Brandon Jones, Colin MacKenzie IV. All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

  * Redistributions of source code must retain the above copyright notice, this
    list of conditions and the following disclaimer.
  * Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation
    and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. */


(function(_global) {
  "use strict";

  var shim = {};
  if (typeof(exports) === 'undefined') {
    if(typeof define == 'function' && typeof define.amd == 'object' && define.amd) {
      shim.exports = {};
      define(function() {
        return shim.exports;
      });
    } else {
      // gl-matrix lives in a browser, define its namespaces in global
      shim.exports = typeof(window) !== 'undefined' ? window : _global;
    }
  }
  else {
    // gl-matrix lives in commonjs, define its namespaces in exports
    shim.exports = exports;
  }

  (function(exports) {
    /* Copyright (c) 2013, Brandon Jones, Colin MacKenzie IV. All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

  * Redistributions of source code must retain the above copyright notice, this
    list of conditions and the following disclaimer.
  * Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation 
    and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE 
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. */


if(!GLMAT_EPSILON) {
    var GLMAT_EPSILON = 0.000001;
}

if(!GLMAT_ARRAY_TYPE) {
    var GLMAT_ARRAY_TYPE = (typeof Float32Array !== 'undefined') ? Float32Array : Array;
}

if(!GLMAT_RANDOM) {
    var GLMAT_RANDOM = Math.random;
}

/**
 * @class Common utilities
 * @name glMatrix
 */
var glMatrix = {};

/**
 * Sets the type of array used when creating new vectors and matricies
 *
 * @param {Type} type Array type, such as Float32Array or Array
 */
glMatrix.setMatrixArrayType = function(type) {
    GLMAT_ARRAY_TYPE = type;
}

if(typeof(exports) !== 'undefined') {
    exports.glMatrix = glMatrix;
}

var degree = Math.PI / 180;

/**
* Convert Degree To Radian
*
* @param {Number} Angle in Degrees
*/
glMatrix.toRadian = function(a){
     return a * degree;
}
;
/* Copyright (c) 2013, Brandon Jones, Colin MacKenzie IV. All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

  * Redistributions of source code must retain the above copyright notice, this
    list of conditions and the following disclaimer.
  * Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation 
    and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE 
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. */

/**
 * @class 2 Dimensional Vector
 * @name vec2
 */

var vec2 = {};

/**
 * Creates a new, empty vec2
 *
 * @returns {vec2} a new 2D vector
 */
vec2.create = function() {
    var out = new GLMAT_ARRAY_TYPE(2);
    out[0] = 0;
    out[1] = 0;
    return out;
};

/**
 * Creates a new vec2 initialized with values from an existing vector
 *
 * @param {vec2} a vector to clone
 * @returns {vec2} a new 2D vector
 */
vec2.clone = function(a) {
    var out = new GLMAT_ARRAY_TYPE(2);
    out[0] = a[0];
    out[1] = a[1];
    return out;
};

/**
 * Creates a new vec2 initialized with the given values
 *
 * @param {Number} x X component
 * @param {Number} y Y component
 * @returns {vec2} a new 2D vector
 */
vec2.fromValues = function(x, y) {
    var out = new GLMAT_ARRAY_TYPE(2);
    out[0] = x;
    out[1] = y;
    return out;
};

/**
 * Copy the values from one vec2 to another
 *
 * @param {vec2} out the receiving vector
 * @param {vec2} a the source vector
 * @returns {vec2} out
 */
vec2.copy = function(out, a) {
    out[0] = a[0];
    out[1] = a[1];
    return out;
};

/**
 * Set the components of a vec2 to the given values
 *
 * @param {vec2} out the receiving vector
 * @param {Number} x X component
 * @param {Number} y Y component
 * @returns {vec2} out
 */
vec2.set = function(out, x, y) {
    out[0] = x;
    out[1] = y;
    return out;
};

/**
 * Adds two vec2's
 *
 * @param {vec2} out the receiving vector
 * @param {vec2} a the first operand
 * @param {vec2} b the second operand
 * @returns {vec2} out
 */
vec2.add = function(out, a, b) {
    out[0] = a[0] + b[0];
    out[1] = a[1] + b[1];
    return out;
};

/**
 * Subtracts vector b from vector a
 *
 * @param {vec2} out the receiving vector
 * @param {vec2} a the first operand
 * @param {vec2} b the second operand
 * @returns {vec2} out
 */
vec2.subtract = function(out, a, b) {
    out[0] = a[0] - b[0];
    out[1] = a[1] - b[1];
    return out;
};

/**
 * Alias for {@link vec2.subtract}
 * @function
 */
vec2.sub = vec2.subtract;

/**
 * Multiplies two vec2's
 *
 * @param {vec2} out the receiving vector
 * @param {vec2} a the first operand
 * @param {vec2} b the second operand
 * @returns {vec2} out
 */
vec2.multiply = function(out, a, b) {
    out[0] = a[0] * b[0];
    out[1] = a[1] * b[1];
    return out;
};

/**
 * Alias for {@link vec2.multiply}
 * @function
 */
vec2.mul = vec2.multiply;

/**
 * Divides two vec2's
 *
 * @param {vec2} out the receiving vector
 * @param {vec2} a the first operand
 * @param {vec2} b the second operand
 * @returns {vec2} out
 */
vec2.divide = function(out, a, b) {
    out[0] = a[0] / b[0];
    out[1] = a[1] / b[1];
    return out;
};

/**
 * Alias for {@link vec2.divide}
 * @function
 */
vec2.div = vec2.divide;

/**
 * Returns the minimum of two vec2's
 *
 * @param {vec2} out the receiving vector
 * @param {vec2} a the first operand
 * @param {vec2} b the second operand
 * @returns {vec2} out
 */
vec2.min = function(out, a, b) {
    out[0] = Math.min(a[0], b[0]);
    out[1] = Math.min(a[1], b[1]);
    return out;
};

/**
 * Returns the maximum of two vec2's
 *
 * @param {vec2} out the receiving vector
 * @param {vec2} a the first operand
 * @param {vec2} b the second operand
 * @returns {vec2} out
 */
vec2.max = function(out, a, b) {
    out[0] = Math.max(a[0], b[0]);
    out[1] = Math.max(a[1], b[1]);
    return out;
};

/**
 * Scales a vec2 by a scalar number
 *
 * @param {vec2} out the receiving vector
 * @param {vec2} a the vector to scale
 * @param {Number} b amount to scale the vector by
 * @returns {vec2} out
 */
vec2.scale = function(out, a, b) {
    out[0] = a[0] * b;
    out[1] = a[1] * b;
    return out;
};

/**
 * Adds two vec2's after scaling the second operand by a scalar value
 *
 * @param {vec2} out the receiving vector
 * @param {vec2} a the first operand
 * @param {vec2} b the second operand
 * @param {Number} scale the amount to scale b by before adding
 * @returns {vec2} out
 */
vec2.scaleAndAdd = function(out, a, b, scale) {
    out[0] = a[0] + (b[0] * scale);
    out[1] = a[1] + (b[1] * scale);
    return out;
};

/**
 * Calculates the euclidian distance between two vec2's
 *
 * @param {vec2} a the first operand
 * @param {vec2} b the second operand
 * @returns {Number} distance between a and b
 */
vec2.distance = function(a, b) {
    var x = b[0] - a[0],
        y = b[1] - a[1];
    return Math.sqrt(x*x + y*y);
};

/**
 * Alias for {@link vec2.distance}
 * @function
 */
vec2.dist = vec2.distance;

/**
 * Calculates the squared euclidian distance between two vec2's
 *
 * @param {vec2} a the first operand
 * @param {vec2} b the second operand
 * @returns {Number} squared distance between a and b
 */
vec2.squaredDistance = function(a, b) {
    var x = b[0] - a[0],
        y = b[1] - a[1];
    return x*x + y*y;
};

/**
 * Alias for {@link vec2.squaredDistance}
 * @function
 */
vec2.sqrDist = vec2.squaredDistance;

/**
 * Calculates the length of a vec2
 *
 * @param {vec2} a vector to calculate length of
 * @returns {Number} length of a
 */
vec2.length = function (a) {
    var x = a[0],
        y = a[1];
    return Math.sqrt(x*x + y*y);
};

/**
 * Alias for {@link vec2.length}
 * @function
 */
vec2.len = vec2.length;

/**
 * Calculates the squared length of a vec2
 *
 * @param {vec2} a vector to calculate squared length of
 * @returns {Number} squared length of a
 */
vec2.squaredLength = function (a) {
    var x = a[0],
        y = a[1];
    return x*x + y*y;
};

/**
 * Alias for {@link vec2.squaredLength}
 * @function
 */
vec2.sqrLen = vec2.squaredLength;

/**
 * Negates the components of a vec2
 *
 * @param {vec2} out the receiving vector
 * @param {vec2} a vector to negate
 * @returns {vec2} out
 */
vec2.negate = function(out, a) {
    out[0] = -a[0];
    out[1] = -a[1];
    return out;
};

/**
 * Normalize a vec2
 *
 * @param {vec2} out the receiving vector
 * @param {vec2} a vector to normalize
 * @returns {vec2} out
 */
vec2.normalize = function(out, a) {
    var x = a[0],
        y = a[1];
    var len = x*x + y*y;
    if (len > 0) {
        //TODO: evaluate use of glm_invsqrt here?
        len = 1 / Math.sqrt(len);
        out[0] = a[0] * len;
        out[1] = a[1] * len;
    }
    return out;
};

/**
 * Calculates the dot product of two vec2's
 *
 * @param {vec2} a the first operand
 * @param {vec2} b the second operand
 * @returns {Number} dot product of a and b
 */
vec2.dot = function (a, b) {
    return a[0] * b[0] + a[1] * b[1];
};

/**
 * Computes the cross product of two vec2's
 * Note that the cross product must by definition produce a 3D vector
 *
 * @param {vec3} out the receiving vector
 * @param {vec2} a the first operand
 * @param {vec2} b the second operand
 * @returns {vec3} out
 */
vec2.cross = function(out, a, b) {
    var z = a[0] * b[1] - a[1] * b[0];
    out[0] = out[1] = 0;
    out[2] = z;
    return out;
};

/**
 * Performs a linear interpolation between two vec2's
 *
 * @param {vec2} out the receiving vector
 * @param {vec2} a the first operand
 * @param {vec2} b the second operand
 * @param {Number} t interpolation amount between the two inputs
 * @returns {vec2} out
 */
vec2.lerp = function (out, a, b, t) {
    var ax = a[0],
        ay = a[1];
    out[0] = ax + t * (b[0] - ax);
    out[1] = ay + t * (b[1] - ay);
    return out;
};

/**
 * Generates a random vector with the given scale
 *
 * @param {vec2} out the receiving vector
 * @param {Number} [scale] Length of the resulting vector. If ommitted, a unit vector will be returned
 * @returns {vec2} out
 */
vec2.random = function (out, scale) {
    scale = scale || 1.0;
    var r = GLMAT_RANDOM() * 2.0 * Math.PI;
    out[0] = Math.cos(r) * scale;
    out[1] = Math.sin(r) * scale;
    return out;
};

/**
 * Transforms the vec2 with a mat2
 *
 * @param {vec2} out the receiving vector
 * @param {vec2} a the vector to transform
 * @param {mat2} m matrix to transform with
 * @returns {vec2} out
 */
vec2.transformMat2 = function(out, a, m) {
    var x = a[0],
        y = a[1];
    out[0] = m[0] * x + m[2] * y;
    out[1] = m[1] * x + m[3] * y;
    return out;
};

/**
 * Transforms the vec2 with a mat2d
 *
 * @param {vec2} out the receiving vector
 * @param {vec2} a the vector to transform
 * @param {mat2d} m matrix to transform with
 * @returns {vec2} out
 */
vec2.transformMat2d = function(out, a, m) {
    var x = a[0],
        y = a[1];
    out[0] = m[0] * x + m[2] * y + m[4];
    out[1] = m[1] * x + m[3] * y + m[5];
    return out;
};

/**
 * Transforms the vec2 with a mat3
 * 3rd vector component is implicitly '1'
 *
 * @param {vec2} out the receiving vector
 * @param {vec2} a the vector to transform
 * @param {mat3} m matrix to transform with
 * @returns {vec2} out
 */
vec2.transformMat3 = function(out, a, m) {
    var x = a[0],
        y = a[1];
    out[0] = m[0] * x + m[3] * y + m[6];
    out[1] = m[1] * x + m[4] * y + m[7];
    return out;
};

/**
 * Transforms the vec2 with a mat4
 * 3rd vector component is implicitly '0'
 * 4th vector component is implicitly '1'
 *
 * @param {vec2} out the receiving vector
 * @param {vec2} a the vector to transform
 * @param {mat4} m matrix to transform with
 * @returns {vec2} out
 */
vec2.transformMat4 = function(out, a, m) {
    var x = a[0], 
        y = a[1];
    out[0] = m[0] * x + m[4] * y + m[12];
    out[1] = m[1] * x + m[5] * y + m[13];
    return out;
};

/**
 * Perform some operation over an array of vec2s.
 *
 * @param {Array} a the array of vectors to iterate over
 * @param {Number} stride Number of elements between the start of each vec2. If 0 assumes tightly packed
 * @param {Number} offset Number of elements to skip at the beginning of the array
 * @param {Number} count Number of vec2s to iterate over. If 0 iterates over entire array
 * @param {Function} fn Function to call for each vector in the array
 * @param {Object} [arg] additional argument to pass to fn
 * @returns {Array} a
 * @function
 */
vec2.forEach = (function() {
    var vec = vec2.create();

    return function(a, stride, offset, count, fn, arg) {
        var i, l;
        if(!stride) {
            stride = 2;
        }

        if(!offset) {
            offset = 0;
        }
        
        if(count) {
            l = Math.min((count * stride) + offset, a.length);
        } else {
            l = a.length;
        }

        for(i = offset; i < l; i += stride) {
            vec[0] = a[i]; vec[1] = a[i+1];
            fn(vec, vec, arg);
            a[i] = vec[0]; a[i+1] = vec[1];
        }
        
        return a;
    };
})();

/**
 * Returns a string representation of a vector
 *
 * @param {vec2} vec vector to represent as a string
 * @returns {String} string representation of the vector
 */
vec2.str = function (a) {
    return 'vec2(' + a[0] + ', ' + a[1] + ')';
};

if(typeof(exports) !== 'undefined') {
    exports.vec2 = vec2;
}
;
/* Copyright (c) 2013, Brandon Jones, Colin MacKenzie IV. All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

  * Redistributions of source code must retain the above copyright notice, this
    list of conditions and the following disclaimer.
  * Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation 
    and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE 
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. */

/**
 * @class 3 Dimensional Vector
 * @name vec3
 */

var vec3 = {};

/**
 * Creates a new, empty vec3
 *
 * @returns {vec3} a new 3D vector
 */
vec3.create = function() {
    var out = new GLMAT_ARRAY_TYPE(3);
    out[0] = 0;
    out[1] = 0;
    out[2] = 0;
    return out;
};

/**
 * Creates a new vec3 initialized with values from an existing vector
 *
 * @param {vec3} a vector to clone
 * @returns {vec3} a new 3D vector
 */
vec3.clone = function(a) {
    var out = new GLMAT_ARRAY_TYPE(3);
    out[0] = a[0];
    out[1] = a[1];
    out[2] = a[2];
    return out;
};

/**
 * Creates a new vec3 initialized with the given values
 *
 * @param {Number} x X component
 * @param {Number} y Y component
 * @param {Number} z Z component
 * @returns {vec3} a new 3D vector
 */
vec3.fromValues = function(x, y, z) {
    var out = new GLMAT_ARRAY_TYPE(3);
    out[0] = x;
    out[1] = y;
    out[2] = z;
    return out;
};

/**
 * Copy the values from one vec3 to another
 *
 * @param {vec3} out the receiving vector
 * @param {vec3} a the source vector
 * @returns {vec3} out
 */
vec3.copy = function(out, a) {
    out[0] = a[0];
    out[1] = a[1];
    out[2] = a[2];
    return out;
};

/**
 * Set the components of a vec3 to the given values
 *
 * @param {vec3} out the receiving vector
 * @param {Number} x X component
 * @param {Number} y Y component
 * @param {Number} z Z component
 * @returns {vec3} out
 */
vec3.set = function(out, x, y, z) {
    out[0] = x;
    out[1] = y;
    out[2] = z;
    return out;
};

/**
 * Adds two vec3's
 *
 * @param {vec3} out the receiving vector
 * @param {vec3} a the first operand
 * @param {vec3} b the second operand
 * @returns {vec3} out
 */
vec3.add = function(out, a, b) {
    out[0] = a[0] + b[0];
    out[1] = a[1] + b[1];
    out[2] = a[2] + b[2];
    return out;
};

/**
 * Subtracts vector b from vector a
 *
 * @param {vec3} out the receiving vector
 * @param {vec3} a the first operand
 * @param {vec3} b the second operand
 * @returns {vec3} out
 */
vec3.subtract = function(out, a, b) {
    out[0] = a[0] - b[0];
    out[1] = a[1] - b[1];
    out[2] = a[2] - b[2];
    return out;
};

/**
 * Alias for {@link vec3.subtract}
 * @function
 */
vec3.sub = vec3.subtract;

/**
 * Multiplies two vec3's
 *
 * @param {vec3} out the receiving vector
 * @param {vec3} a the first operand
 * @param {vec3} b the second operand
 * @returns {vec3} out
 */
vec3.multiply = function(out, a, b) {
    out[0] = a[0] * b[0];
    out[1] = a[1] * b[1];
    out[2] = a[2] * b[2];
    return out;
};

/**
 * Alias for {@link vec3.multiply}
 * @function
 */
vec3.mul = vec3.multiply;

/**
 * Divides two vec3's
 *
 * @param {vec3} out the receiving vector
 * @param {vec3} a the first operand
 * @param {vec3} b the second operand
 * @returns {vec3} out
 */
vec3.divide = function(out, a, b) {
    out[0] = a[0] / b[0];
    out[1] = a[1] / b[1];
    out[2] = a[2] / b[2];
    return out;
};

/**
 * Alias for {@link vec3.divide}
 * @function
 */
vec3.div = vec3.divide;

/**
 * Returns the minimum of two vec3's
 *
 * @param {vec3} out the receiving vector
 * @param {vec3} a the first operand
 * @param {vec3} b the second operand
 * @returns {vec3} out
 */
vec3.min = function(out, a, b) {
    out[0] = Math.min(a[0], b[0]);
    out[1] = Math.min(a[1], b[1]);
    out[2] = Math.min(a[2], b[2]);
    return out;
};

/**
 * Returns the maximum of two vec3's
 *
 * @param {vec3} out the receiving vector
 * @param {vec3} a the first operand
 * @param {vec3} b the second operand
 * @returns {vec3} out
 */
vec3.max = function(out, a, b) {
    out[0] = Math.max(a[0], b[0]);
    out[1] = Math.max(a[1], b[1]);
    out[2] = Math.max(a[2], b[2]);
    return out;
};

/**
 * Scales a vec3 by a scalar number
 *
 * @param {vec3} out the receiving vector
 * @param {vec3} a the vector to scale
 * @param {Number} b amount to scale the vector by
 * @returns {vec3} out
 */
vec3.scale = function(out, a, b) {
    out[0] = a[0] * b;
    out[1] = a[1] * b;
    out[2] = a[2] * b;
    return out;
};

/**
 * Adds two vec3's after scaling the second operand by a scalar value
 *
 * @param {vec3} out the receiving vector
 * @param {vec3} a the first operand
 * @param {vec3} b the second operand
 * @param {Number} scale the amount to scale b by before adding
 * @returns {vec3} out
 */
vec3.scaleAndAdd = function(out, a, b, scale) {
    out[0] = a[0] + (b[0] * scale);
    out[1] = a[1] + (b[1] * scale);
    out[2] = a[2] + (b[2] * scale);
    return out;
};

/**
 * Calculates the euclidian distance between two vec3's
 *
 * @param {vec3} a the first operand
 * @param {vec3} b the second operand
 * @returns {Number} distance between a and b
 */
vec3.distance = function(a, b) {
    var x = b[0] - a[0],
        y = b[1] - a[1],
        z = b[2] - a[2];
    return Math.sqrt(x*x + y*y + z*z);
};

/**
 * Alias for {@link vec3.distance}
 * @function
 */
vec3.dist = vec3.distance;

/**
 * Calculates the squared euclidian distance between two vec3's
 *
 * @param {vec3} a the first operand
 * @param {vec3} b the second operand
 * @returns {Number} squared distance between a and b
 */
vec3.squaredDistance = function(a, b) {
    var x = b[0] - a[0],
        y = b[1] - a[1],
        z = b[2] - a[2];
    return x*x + y*y + z*z;
};

/**
 * Alias for {@link vec3.squaredDistance}
 * @function
 */
vec3.sqrDist = vec3.squaredDistance;

/**
 * Calculates the length of a vec3
 *
 * @param {vec3} a vector to calculate length of
 * @returns {Number} length of a
 */
vec3.length = function (a) {
    var x = a[0],
        y = a[1],
        z = a[2];
    return Math.sqrt(x*x + y*y + z*z);
};

/**
 * Alias for {@link vec3.length}
 * @function
 */
vec3.len = vec3.length;

/**
 * Calculates the squared length of a vec3
 *
 * @param {vec3} a vector to calculate squared length of
 * @returns {Number} squared length of a
 */
vec3.squaredLength = function (a) {
    var x = a[0],
        y = a[1],
        z = a[2];
    return x*x + y*y + z*z;
};

/**
 * Alias for {@link vec3.squaredLength}
 * @function
 */
vec3.sqrLen = vec3.squaredLength;

/**
 * Negates the components of a vec3
 *
 * @param {vec3} out the receiving vector
 * @param {vec3} a vector to negate
 * @returns {vec3} out
 */
vec3.negate = function(out, a) {
    out[0] = -a[0];
    out[1] = -a[1];
    out[2] = -a[2];
    return out;
};

/**
 * Normalize a vec3
 *
 * @param {vec3} out the receiving vector
 * @param {vec3} a vector to normalize
 * @returns {vec3} out
 */
vec3.normalize = function(out, a) {
    var x = a[0],
        y = a[1],
        z = a[2];
    var len = x*x + y*y + z*z;
    if (len > 0) {
        //TODO: evaluate use of glm_invsqrt here?
        len = 1 / Math.sqrt(len);
        out[0] = a[0] * len;
        out[1] = a[1] * len;
        out[2] = a[2] * len;
    }
    return out;
};

/**
 * Calculates the dot product of two vec3's
 *
 * @param {vec3} a the first operand
 * @param {vec3} b the second operand
 * @returns {Number} dot product of a and b
 */
vec3.dot = function (a, b) {
    return a[0] * b[0] + a[1] * b[1] + a[2] * b[2];
};

/**
 * Computes the cross product of two vec3's
 *
 * @param {vec3} out the receiving vector
 * @param {vec3} a the first operand
 * @param {vec3} b the second operand
 * @returns {vec3} out
 */
vec3.cross = function(out, a, b) {
    var ax = a[0], ay = a[1], az = a[2],
        bx = b[0], by = b[1], bz = b[2];

    out[0] = ay * bz - az * by;
    out[1] = az * bx - ax * bz;
    out[2] = ax * by - ay * bx;
    return out;
};

/**
 * Performs a linear interpolation between two vec3's
 *
 * @param {vec3} out the receiving vector
 * @param {vec3} a the first operand
 * @param {vec3} b the second operand
 * @param {Number} t interpolation amount between the two inputs
 * @returns {vec3} out
 */
vec3.lerp = function (out, a, b, t) {
    var ax = a[0],
        ay = a[1],
        az = a[2];
    out[0] = ax + t * (b[0] - ax);
    out[1] = ay + t * (b[1] - ay);
    out[2] = az + t * (b[2] - az);
    return out;
};

/**
 * Generates a random vector with the given scale
 *
 * @param {vec3} out the receiving vector
 * @param {Number} [scale] Length of the resulting vector. If ommitted, a unit vector will be returned
 * @returns {vec3} out
 */
vec3.random = function (out, scale) {
    scale = scale || 1.0;

    var r = GLMAT_RANDOM() * 2.0 * Math.PI;
    var z = (GLMAT_RANDOM() * 2.0) - 1.0;
    var zScale = Math.sqrt(1.0-z*z) * scale;

    out[0] = Math.cos(r) * zScale;
    out[1] = Math.sin(r) * zScale;
    out[2] = z * scale;
    return out;
};

/**
 * Transforms the vec3 with a mat4.
 * 4th vector component is implicitly '1'
 *
 * @param {vec3} out the receiving vector
 * @param {vec3} a the vector to transform
 * @param {mat4} m matrix to transform with
 * @returns {vec3} out
 */
vec3.transformMat4 = function(out, a, m) {
    var x = a[0], y = a[1], z = a[2];
    out[0] = m[0] * x + m[4] * y + m[8] * z + m[12];
    out[1] = m[1] * x + m[5] * y + m[9] * z + m[13];
    out[2] = m[2] * x + m[6] * y + m[10] * z + m[14];
    return out;
};

/**
 * Transforms the vec3 with a mat3.
 *
 * @param {vec3} out the receiving vector
 * @param {vec3} a the vector to transform
 * @param {mat4} m the 3x3 matrix to transform with
 * @returns {vec3} out
 */
vec3.transformMat3 = function(out, a, m) {
    var x = a[0], y = a[1], z = a[2];
    out[0] = x * m[0] + y * m[3] + z * m[6];
    out[1] = x * m[1] + y * m[4] + z * m[7];
    out[2] = x * m[2] + y * m[5] + z * m[8];
    return out;
};

/**
 * Transforms the vec3 with a quat
 *
 * @param {vec3} out the receiving vector
 * @param {vec3} a the vector to transform
 * @param {quat} q quaternion to transform with
 * @returns {vec3} out
 */
vec3.transformQuat = function(out, a, q) {
    // benchmarks: http://jsperf.com/quaternion-transform-vec3-implementations

    var x = a[0], y = a[1], z = a[2],
        qx = q[0], qy = q[1], qz = q[2], qw = q[3],

        // calculate quat * vec
        ix = qw * x + qy * z - qz * y,
        iy = qw * y + qz * x - qx * z,
        iz = qw * z + qx * y - qy * x,
        iw = -qx * x - qy * y - qz * z;

    // calculate result * inverse quat
    out[0] = ix * qw + iw * -qx + iy * -qz - iz * -qy;
    out[1] = iy * qw + iw * -qy + iz * -qx - ix * -qz;
    out[2] = iz * qw + iw * -qz + ix * -qy - iy * -qx;
    return out;
};

/*
* Rotate a 3D vector around the x-axis
* @param {vec3} out The receiving vec3
* @param {vec3} a The vec3 point to rotate
* @param {vec3} b The origin of the rotation
* @param {Number} c The angle of rotation
* @returns {vec3} out
*/
vec3.rotateX = function(out, a, b, c){
   var p = [], r=[];
	  //Translate point to the origin
	  p[0] = a[0] - b[0];
	  p[1] = a[1] - b[1];
  	p[2] = a[2] - b[2];

	  //perform rotation
	  r[0] = p[0];
	  r[1] = p[1]*Math.cos(c) - p[2]*Math.sin(c);
	  r[2] = p[1]*Math.sin(c) + p[2]*Math.cos(c);

	  //translate to correct position
	  out[0] = r[0] + b[0];
	  out[1] = r[1] + b[1];
	  out[2] = r[2] + b[2];

  	return out;
};

/*
* Rotate a 3D vector around the y-axis
* @param {vec3} out The receiving vec3
* @param {vec3} a The vec3 point to rotate
* @param {vec3} b The origin of the rotation
* @param {Number} c The angle of rotation
* @returns {vec3} out
*/
vec3.rotateY = function(out, a, b, c){
  	var p = [], r=[];
  	//Translate point to the origin
  	p[0] = a[0] - b[0];
  	p[1] = a[1] - b[1];
  	p[2] = a[2] - b[2];
  
  	//perform rotation
  	r[0] = p[2]*Math.sin(c) + p[0]*Math.cos(c);
  	r[1] = p[1];
  	r[2] = p[2]*Math.cos(c) - p[0]*Math.sin(c);
  
  	//translate to correct position
  	out[0] = r[0] + b[0];
  	out[1] = r[1] + b[1];
  	out[2] = r[2] + b[2];
  
  	return out;
};

/*
* Rotate a 3D vector around the z-axis
* @param {vec3} out The receiving vec3
* @param {vec3} a The vec3 point to rotate
* @param {vec3} b The origin of the rotation
* @param {Number} c The angle of rotation
* @returns {vec3} out
*/
vec3.rotateZ = function(out, a, b, c){
  	var p = [], r=[];
  	//Translate point to the origin
  	p[0] = a[0] - b[0];
  	p[1] = a[1] - b[1];
  	p[2] = a[2] - b[2];
  
  	//perform rotation
  	r[0] = p[0]*Math.cos(c) - p[1]*Math.sin(c);
  	r[1] = p[0]*Math.sin(c) + p[1]*Math.cos(c);
  	r[2] = p[2];
  
  	//translate to correct position
  	out[0] = r[0] + b[0];
  	out[1] = r[1] + b[1];
  	out[2] = r[2] + b[2];
  
  	return out;
};

/**
 * Perform some operation over an array of vec3s.
 *
 * @param {Array} a the array of vectors to iterate over
 * @param {Number} stride Number of elements between the start of each vec3. If 0 assumes tightly packed
 * @param {Number} offset Number of elements to skip at the beginning of the array
 * @param {Number} count Number of vec3s to iterate over. If 0 iterates over entire array
 * @param {Function} fn Function to call for each vector in the array
 * @param {Object} [arg] additional argument to pass to fn
 * @returns {Array} a
 * @function
 */
vec3.forEach = (function() {
    var vec = vec3.create();

    return function(a, stride, offset, count, fn, arg) {
        var i, l;
        if(!stride) {
            stride = 3;
        }

        if(!offset) {
            offset = 0;
        }
        
        if(count) {
            l = Math.min((count * stride) + offset, a.length);
        } else {
            l = a.length;
        }

        for(i = offset; i < l; i += stride) {
            vec[0] = a[i]; vec[1] = a[i+1]; vec[2] = a[i+2];
            fn(vec, vec, arg);
            a[i] = vec[0]; a[i+1] = vec[1]; a[i+2] = vec[2];
        }
        
        return a;
    };
})();

/**
 * Returns a string representation of a vector
 *
 * @param {vec3} vec vector to represent as a string
 * @returns {String} string representation of the vector
 */
vec3.str = function (a) {
    return 'vec3(' + a[0] + ', ' + a[1] + ', ' + a[2] + ')';
};

if(typeof(exports) !== 'undefined') {
    exports.vec3 = vec3;
}
;
/* Copyright (c) 2013, Brandon Jones, Colin MacKenzie IV. All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

  * Redistributions of source code must retain the above copyright notice, this
    list of conditions and the following disclaimer.
  * Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation 
    and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE 
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. */

/**
 * @class 4 Dimensional Vector
 * @name vec4
 */

var vec4 = {};

/**
 * Creates a new, empty vec4
 *
 * @returns {vec4} a new 4D vector
 */
vec4.create = function() {
    var out = new GLMAT_ARRAY_TYPE(4);
    out[0] = 0;
    out[1] = 0;
    out[2] = 0;
    out[3] = 0;
    return out;
};

/**
 * Creates a new vec4 initialized with values from an existing vector
 *
 * @param {vec4} a vector to clone
 * @returns {vec4} a new 4D vector
 */
vec4.clone = function(a) {
    var out = new GLMAT_ARRAY_TYPE(4);
    out[0] = a[0];
    out[1] = a[1];
    out[2] = a[2];
    out[3] = a[3];
    return out;
};

/**
 * Creates a new vec4 initialized with the given values
 *
 * @param {Number} x X component
 * @param {Number} y Y component
 * @param {Number} z Z component
 * @param {Number} w W component
 * @returns {vec4} a new 4D vector
 */
vec4.fromValues = function(x, y, z, w) {
    var out = new GLMAT_ARRAY_TYPE(4);
    out[0] = x;
    out[1] = y;
    out[2] = z;
    out[3] = w;
    return out;
};

/**
 * Copy the values from one vec4 to another
 *
 * @param {vec4} out the receiving vector
 * @param {vec4} a the source vector
 * @returns {vec4} out
 */
vec4.copy = function(out, a) {
    out[0] = a[0];
    out[1] = a[1];
    out[2] = a[2];
    out[3] = a[3];
    return out;
};

/**
 * Set the components of a vec4 to the given values
 *
 * @param {vec4} out the receiving vector
 * @param {Number} x X component
 * @param {Number} y Y component
 * @param {Number} z Z component
 * @param {Number} w W component
 * @returns {vec4} out
 */
vec4.set = function(out, x, y, z, w) {
    out[0] = x;
    out[1] = y;
    out[2] = z;
    out[3] = w;
    return out;
};

/**
 * Adds two vec4's
 *
 * @param {vec4} out the receiving vector
 * @param {vec4} a the first operand
 * @param {vec4} b the second operand
 * @returns {vec4} out
 */
vec4.add = function(out, a, b) {
    out[0] = a[0] + b[0];
    out[1] = a[1] + b[1];
    out[2] = a[2] + b[2];
    out[3] = a[3] + b[3];
    return out;
};

/**
 * Subtracts vector b from vector a
 *
 * @param {vec4} out the receiving vector
 * @param {vec4} a the first operand
 * @param {vec4} b the second operand
 * @returns {vec4} out
 */
vec4.subtract = function(out, a, b) {
    out[0] = a[0] - b[0];
    out[1] = a[1] - b[1];
    out[2] = a[2] - b[2];
    out[3] = a[3] - b[3];
    return out;
};

/**
 * Alias for {@link vec4.subtract}
 * @function
 */
vec4.sub = vec4.subtract;

/**
 * Multiplies two vec4's
 *
 * @param {vec4} out the receiving vector
 * @param {vec4} a the first operand
 * @param {vec4} b the second operand
 * @returns {vec4} out
 */
vec4.multiply = function(out, a, b) {
    out[0] = a[0] * b[0];
    out[1] = a[1] * b[1];
    out[2] = a[2] * b[2];
    out[3] = a[3] * b[3];
    return out;
};

/**
 * Alias for {@link vec4.multiply}
 * @function
 */
vec4.mul = vec4.multiply;

/**
 * Divides two vec4's
 *
 * @param {vec4} out the receiving vector
 * @param {vec4} a the first operand
 * @param {vec4} b the second operand
 * @returns {vec4} out
 */
vec4.divide = function(out, a, b) {
    out[0] = a[0] / b[0];
    out[1] = a[1] / b[1];
    out[2] = a[2] / b[2];
    out[3] = a[3] / b[3];
    return out;
};

/**
 * Alias for {@link vec4.divide}
 * @function
 */
vec4.div = vec4.divide;

/**
 * Returns the minimum of two vec4's
 *
 * @param {vec4} out the receiving vector
 * @param {vec4} a the first operand
 * @param {vec4} b the second operand
 * @returns {vec4} out
 */
vec4.min = function(out, a, b) {
    out[0] = Math.min(a[0], b[0]);
    out[1] = Math.min(a[1], b[1]);
    out[2] = Math.min(a[2], b[2]);
    out[3] = Math.min(a[3], b[3]);
    return out;
};

/**
 * Returns the maximum of two vec4's
 *
 * @param {vec4} out the receiving vector
 * @param {vec4} a the first operand
 * @param {vec4} b the second operand
 * @returns {vec4} out
 */
vec4.max = function(out, a, b) {
    out[0] = Math.max(a[0], b[0]);
    out[1] = Math.max(a[1], b[1]);
    out[2] = Math.max(a[2], b[2]);
    out[3] = Math.max(a[3], b[3]);
    return out;
};

/**
 * Scales a vec4 by a scalar number
 *
 * @param {vec4} out the receiving vector
 * @param {vec4} a the vector to scale
 * @param {Number} b amount to scale the vector by
 * @returns {vec4} out
 */
vec4.scale = function(out, a, b) {
    out[0] = a[0] * b;
    out[1] = a[1] * b;
    out[2] = a[2] * b;
    out[3] = a[3] * b;
    return out;
};

/**
 * Adds two vec4's after scaling the second operand by a scalar value
 *
 * @param {vec4} out the receiving vector
 * @param {vec4} a the first operand
 * @param {vec4} b the second operand
 * @param {Number} scale the amount to scale b by before adding
 * @returns {vec4} out
 */
vec4.scaleAndAdd = function(out, a, b, scale) {
    out[0] = a[0] + (b[0] * scale);
    out[1] = a[1] + (b[1] * scale);
    out[2] = a[2] + (b[2] * scale);
    out[3] = a[3] + (b[3] * scale);
    return out;
};

/**
 * Calculates the euclidian distance between two vec4's
 *
 * @param {vec4} a the first operand
 * @param {vec4} b the second operand
 * @returns {Number} distance between a and b
 */
vec4.distance = function(a, b) {
    var x = b[0] - a[0],
        y = b[1] - a[1],
        z = b[2] - a[2],
        w = b[3] - a[3];
    return Math.sqrt(x*x + y*y + z*z + w*w);
};

/**
 * Alias for {@link vec4.distance}
 * @function
 */
vec4.dist = vec4.distance;

/**
 * Calculates the squared euclidian distance between two vec4's
 *
 * @param {vec4} a the first operand
 * @param {vec4} b the second operand
 * @returns {Number} squared distance between a and b
 */
vec4.squaredDistance = function(a, b) {
    var x = b[0] - a[0],
        y = b[1] - a[1],
        z = b[2] - a[2],
        w = b[3] - a[3];
    return x*x + y*y + z*z + w*w;
};

/**
 * Alias for {@link vec4.squaredDistance}
 * @function
 */
vec4.sqrDist = vec4.squaredDistance;

/**
 * Calculates the length of a vec4
 *
 * @param {vec4} a vector to calculate length of
 * @returns {Number} length of a
 */
vec4.length = function (a) {
    var x = a[0],
        y = a[1],
        z = a[2],
        w = a[3];
    return Math.sqrt(x*x + y*y + z*z + w*w);
};

/**
 * Alias for {@link vec4.length}
 * @function
 */
vec4.len = vec4.length;

/**
 * Calculates the squared length of a vec4
 *
 * @param {vec4} a vector to calculate squared length of
 * @returns {Number} squared length of a
 */
vec4.squaredLength = function (a) {
    var x = a[0],
        y = a[1],
        z = a[2],
        w = a[3];
    return x*x + y*y + z*z + w*w;
};

/**
 * Alias for {@link vec4.squaredLength}
 * @function
 */
vec4.sqrLen = vec4.squaredLength;

/**
 * Negates the components of a vec4
 *
 * @param {vec4} out the receiving vector
 * @param {vec4} a vector to negate
 * @returns {vec4} out
 */
vec4.negate = function(out, a) {
    out[0] = -a[0];
    out[1] = -a[1];
    out[2] = -a[2];
    out[3] = -a[3];
    return out;
};

/**
 * Normalize a vec4
 *
 * @param {vec4} out the receiving vector
 * @param {vec4} a vector to normalize
 * @returns {vec4} out
 */
vec4.normalize = function(out, a) {
    var x = a[0],
        y = a[1],
        z = a[2],
        w = a[3];
    var len = x*x + y*y + z*z + w*w;
    if (len > 0) {
        len = 1 / Math.sqrt(len);
        out[0] = a[0] * len;
        out[1] = a[1] * len;
        out[2] = a[2] * len;
        out[3] = a[3] * len;
    }
    return out;
};

/**
 * Calculates the dot product of two vec4's
 *
 * @param {vec4} a the first operand
 * @param {vec4} b the second operand
 * @returns {Number} dot product of a and b
 */
vec4.dot = function (a, b) {
    return a[0] * b[0] + a[1] * b[1] + a[2] * b[2] + a[3] * b[3];
};

/**
 * Performs a linear interpolation between two vec4's
 *
 * @param {vec4} out the receiving vector
 * @param {vec4} a the first operand
 * @param {vec4} b the second operand
 * @param {Number} t interpolation amount between the two inputs
 * @returns {vec4} out
 */
vec4.lerp = function (out, a, b, t) {
    var ax = a[0],
        ay = a[1],
        az = a[2],
        aw = a[3];
    out[0] = ax + t * (b[0] - ax);
    out[1] = ay + t * (b[1] - ay);
    out[2] = az + t * (b[2] - az);
    out[3] = aw + t * (b[3] - aw);
    return out;
};

/**
 * Generates a random vector with the given scale
 *
 * @param {vec4} out the receiving vector
 * @param {Number} [scale] Length of the resulting vector. If ommitted, a unit vector will be returned
 * @returns {vec4} out
 */
vec4.random = function (out, scale) {
    scale = scale || 1.0;

    //TODO: This is a pretty awful way of doing this. Find something better.
    out[0] = GLMAT_RANDOM();
    out[1] = GLMAT_RANDOM();
    out[2] = GLMAT_RANDOM();
    out[3] = GLMAT_RANDOM();
    vec4.normalize(out, out);
    vec4.scale(out, out, scale);
    return out;
};

/**
 * Transforms the vec4 with a mat4.
 *
 * @param {vec4} out the receiving vector
 * @param {vec4} a the vector to transform
 * @param {mat4} m matrix to transform with
 * @returns {vec4} out
 */
vec4.transformMat4 = function(out, a, m) {
    var x = a[0], y = a[1], z = a[2], w = a[3];
    out[0] = m[0] * x + m[4] * y + m[8] * z + m[12] * w;
    out[1] = m[1] * x + m[5] * y + m[9] * z + m[13] * w;
    out[2] = m[2] * x + m[6] * y + m[10] * z + m[14] * w;
    out[3] = m[3] * x + m[7] * y + m[11] * z + m[15] * w;
    return out;
};

/**
 * Transforms the vec4 with a quat
 *
 * @param {vec4} out the receiving vector
 * @param {vec4} a the vector to transform
 * @param {quat} q quaternion to transform with
 * @returns {vec4} out
 */
vec4.transformQuat = function(out, a, q) {
    var x = a[0], y = a[1], z = a[2],
        qx = q[0], qy = q[1], qz = q[2], qw = q[3],

        // calculate quat * vec
        ix = qw * x + qy * z - qz * y,
        iy = qw * y + qz * x - qx * z,
        iz = qw * z + qx * y - qy * x,
        iw = -qx * x - qy * y - qz * z;

    // calculate result * inverse quat
    out[0] = ix * qw + iw * -qx + iy * -qz - iz * -qy;
    out[1] = iy * qw + iw * -qy + iz * -qx - ix * -qz;
    out[2] = iz * qw + iw * -qz + ix * -qy - iy * -qx;
    return out;
};

/**
 * Perform some operation over an array of vec4s.
 *
 * @param {Array} a the array of vectors to iterate over
 * @param {Number} stride Number of elements between the start of each vec4. If 0 assumes tightly packed
 * @param {Number} offset Number of elements to skip at the beginning of the array
 * @param {Number} count Number of vec2s to iterate over. If 0 iterates over entire array
 * @param {Function} fn Function to call for each vector in the array
 * @param {Object} [arg] additional argument to pass to fn
 * @returns {Array} a
 * @function
 */
vec4.forEach = (function() {
    var vec = vec4.create();

    return function(a, stride, offset, count, fn, arg) {
        var i, l;
        if(!stride) {
            stride = 4;
        }

        if(!offset) {
            offset = 0;
        }
        
        if(count) {
            l = Math.min((count * stride) + offset, a.length);
        } else {
            l = a.length;
        }

        for(i = offset; i < l; i += stride) {
            vec[0] = a[i]; vec[1] = a[i+1]; vec[2] = a[i+2]; vec[3] = a[i+3];
            fn(vec, vec, arg);
            a[i] = vec[0]; a[i+1] = vec[1]; a[i+2] = vec[2]; a[i+3] = vec[3];
        }
        
        return a;
    };
})();

/**
 * Returns a string representation of a vector
 *
 * @param {vec4} vec vector to represent as a string
 * @returns {String} string representation of the vector
 */
vec4.str = function (a) {
    return 'vec4(' + a[0] + ', ' + a[1] + ', ' + a[2] + ', ' + a[3] + ')';
};

if(typeof(exports) !== 'undefined') {
    exports.vec4 = vec4;
}
;
/* Copyright (c) 2013, Brandon Jones, Colin MacKenzie IV. All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

  * Redistributions of source code must retain the above copyright notice, this
    list of conditions and the following disclaimer.
  * Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation 
    and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE 
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. */

/**
 * @class 2x2 Matrix
 * @name mat2
 */

var mat2 = {};

/**
 * Creates a new identity mat2
 *
 * @returns {mat2} a new 2x2 matrix
 */
mat2.create = function() {
    var out = new GLMAT_ARRAY_TYPE(4);
    out[0] = 1;
    out[1] = 0;
    out[2] = 0;
    out[3] = 1;
    return out;
};

/**
 * Creates a new mat2 initialized with values from an existing matrix
 *
 * @param {mat2} a matrix to clone
 * @returns {mat2} a new 2x2 matrix
 */
mat2.clone = function(a) {
    var out = new GLMAT_ARRAY_TYPE(4);
    out[0] = a[0];
    out[1] = a[1];
    out[2] = a[2];
    out[3] = a[3];
    return out;
};

/**
 * Copy the values from one mat2 to another
 *
 * @param {mat2} out the receiving matrix
 * @param {mat2} a the source matrix
 * @returns {mat2} out
 */
mat2.copy = function(out, a) {
    out[0] = a[0];
    out[1] = a[1];
    out[2] = a[2];
    out[3] = a[3];
    return out;
};

/**
 * Set a mat2 to the identity matrix
 *
 * @param {mat2} out the receiving matrix
 * @returns {mat2} out
 */
mat2.identity = function(out) {
    out[0] = 1;
    out[1] = 0;
    out[2] = 0;
    out[3] = 1;
    return out;
};

/**
 * Transpose the values of a mat2
 *
 * @param {mat2} out the receiving matrix
 * @param {mat2} a the source matrix
 * @returns {mat2} out
 */
mat2.transpose = function(out, a) {
    // If we are transposing ourselves we can skip a few steps but have to cache some values
    if (out === a) {
        var a1 = a[1];
        out[1] = a[2];
        out[2] = a1;
    } else {
        out[0] = a[0];
        out[1] = a[2];
        out[2] = a[1];
        out[3] = a[3];
    }
    
    return out;
};

/**
 * Inverts a mat2
 *
 * @param {mat2} out the receiving matrix
 * @param {mat2} a the source matrix
 * @returns {mat2} out
 */
mat2.invert = function(out, a) {
    var a0 = a[0], a1 = a[1], a2 = a[2], a3 = a[3],

        // Calculate the determinant
        det = a0 * a3 - a2 * a1;

    if (!det) {
        return null;
    }
    det = 1.0 / det;
    
    out[0] =  a3 * det;
    out[1] = -a1 * det;
    out[2] = -a2 * det;
    out[3] =  a0 * det;

    return out;
};

/**
 * Calculates the adjugate of a mat2
 *
 * @param {mat2} out the receiving matrix
 * @param {mat2} a the source matrix
 * @returns {mat2} out
 */
mat2.adjoint = function(out, a) {
    // Caching this value is nessecary if out == a
    var a0 = a[0];
    out[0] =  a[3];
    out[1] = -a[1];
    out[2] = -a[2];
    out[3] =  a0;

    return out;
};

/**
 * Calculates the determinant of a mat2
 *
 * @param {mat2} a the source matrix
 * @returns {Number} determinant of a
 */
mat2.determinant = function (a) {
    return a[0] * a[3] - a[2] * a[1];
};

/**
 * Multiplies two mat2's
 *
 * @param {mat2} out the receiving matrix
 * @param {mat2} a the first operand
 * @param {mat2} b the second operand
 * @returns {mat2} out
 */
mat2.multiply = function (out, a, b) {
    var a0 = a[0], a1 = a[1], a2 = a[2], a3 = a[3];
    var b0 = b[0], b1 = b[1], b2 = b[2], b3 = b[3];
    out[0] = a0 * b0 + a2 * b1;
    out[1] = a1 * b0 + a3 * b1;
    out[2] = a0 * b2 + a2 * b3;
    out[3] = a1 * b2 + a3 * b3;
    return out;
};

/**
 * Alias for {@link mat2.multiply}
 * @function
 */
mat2.mul = mat2.multiply;

/**
 * Rotates a mat2 by the given angle
 *
 * @param {mat2} out the receiving matrix
 * @param {mat2} a the matrix to rotate
 * @param {Number} rad the angle to rotate the matrix by
 * @returns {mat2} out
 */
mat2.rotate = function (out, a, rad) {
    var a0 = a[0], a1 = a[1], a2 = a[2], a3 = a[3],
        s = Math.sin(rad),
        c = Math.cos(rad);
    out[0] = a0 *  c + a2 * s;
    out[1] = a1 *  c + a3 * s;
    out[2] = a0 * -s + a2 * c;
    out[3] = a1 * -s + a3 * c;
    return out;
};

/**
 * Scales the mat2 by the dimensions in the given vec2
 *
 * @param {mat2} out the receiving matrix
 * @param {mat2} a the matrix to rotate
 * @param {vec2} v the vec2 to scale the matrix by
 * @returns {mat2} out
 **/
mat2.scale = function(out, a, v) {
    var a0 = a[0], a1 = a[1], a2 = a[2], a3 = a[3],
        v0 = v[0], v1 = v[1];
    out[0] = a0 * v0;
    out[1] = a1 * v0;
    out[2] = a2 * v1;
    out[3] = a3 * v1;
    return out;
};

/**
 * Returns a string representation of a mat2
 *
 * @param {mat2} mat matrix to represent as a string
 * @returns {String} string representation of the matrix
 */
mat2.str = function (a) {
    return 'mat2(' + a[0] + ', ' + a[1] + ', ' + a[2] + ', ' + a[3] + ')';
};

/**
 * Returns Frobenius norm of a mat2
 *
 * @param {mat2} a the matrix to calculate Frobenius norm of
 * @returns {Number} Frobenius norm
 */
mat2.frob = function (a) {
    return(Math.sqrt(Math.pow(a[0], 2) + Math.pow(a[1], 2) + Math.pow(a[2], 2) + Math.pow(a[3], 2)))
};

/**
 * Returns L, D and U matrices (Lower triangular, Diagonal and Upper triangular) by factorizing the input matrix
 * @param {mat2} L the lower triangular matrix 
 * @param {mat2} D the diagonal matrix 
 * @param {mat2} U the upper triangular matrix 
 * @param {mat2} a the input matrix to factorize
 */

mat2.LDU = function (L, D, U, a) { 
    L[2] = a[2]/a[0]; 
    U[0] = a[0]; 
    U[1] = a[1]; 
    U[3] = a[3] - L[2] * U[1]; 
    return [L, D, U];       
}; 

if(typeof(exports) !== 'undefined') {
    exports.mat2 = mat2;
}
;
/* Copyright (c) 2013, Brandon Jones, Colin MacKenzie IV. All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

  * Redistributions of source code must retain the above copyright notice, this
    list of conditions and the following disclaimer.
  * Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation 
    and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE 
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. */

/**
 * @class 2x3 Matrix
 * @name mat2d
 * 
 * @description 
 * A mat2d contains six elements defined as:
 * <pre>
 * [a, c, tx,
 *  b, d, ty]
 * </pre>
 * This is a short form for the 3x3 matrix:
 * <pre>
 * [a, c, tx,
 *  b, d, ty,
 *  0, 0, 1]
 * </pre>
 * The last row is ignored so the array is shorter and operations are faster.
 */

var mat2d = {};

/**
 * Creates a new identity mat2d
 *
 * @returns {mat2d} a new 2x3 matrix
 */
mat2d.create = function() {
    var out = new GLMAT_ARRAY_TYPE(6);
    out[0] = 1;
    out[1] = 0;
    out[2] = 0;
    out[3] = 1;
    out[4] = 0;
    out[5] = 0;
    return out;
};

/**
 * Creates a new mat2d initialized with values from an existing matrix
 *
 * @param {mat2d} a matrix to clone
 * @returns {mat2d} a new 2x3 matrix
 */
mat2d.clone = function(a) {
    var out = new GLMAT_ARRAY_TYPE(6);
    out[0] = a[0];
    out[1] = a[1];
    out[2] = a[2];
    out[3] = a[3];
    out[4] = a[4];
    out[5] = a[5];
    return out;
};

/**
 * Copy the values from one mat2d to another
 *
 * @param {mat2d} out the receiving matrix
 * @param {mat2d} a the source matrix
 * @returns {mat2d} out
 */
mat2d.copy = function(out, a) {
    out[0] = a[0];
    out[1] = a[1];
    out[2] = a[2];
    out[3] = a[3];
    out[4] = a[4];
    out[5] = a[5];
    return out;
};

/**
 * Set a mat2d to the identity matrix
 *
 * @param {mat2d} out the receiving matrix
 * @returns {mat2d} out
 */
mat2d.identity = function(out) {
    out[0] = 1;
    out[1] = 0;
    out[2] = 0;
    out[3] = 1;
    out[4] = 0;
    out[5] = 0;
    return out;
};

/**
 * Inverts a mat2d
 *
 * @param {mat2d} out the receiving matrix
 * @param {mat2d} a the source matrix
 * @returns {mat2d} out
 */
mat2d.invert = function(out, a) {
    var aa = a[0], ab = a[1], ac = a[2], ad = a[3],
        atx = a[4], aty = a[5];

    var det = aa * ad - ab * ac;
    if(!det){
        return null;
    }
    det = 1.0 / det;

    out[0] = ad * det;
    out[1] = -ab * det;
    out[2] = -ac * det;
    out[3] = aa * det;
    out[4] = (ac * aty - ad * atx) * det;
    out[5] = (ab * atx - aa * aty) * det;
    return out;
};

/**
 * Calculates the determinant of a mat2d
 *
 * @param {mat2d} a the source matrix
 * @returns {Number} determinant of a
 */
mat2d.determinant = function (a) {
    return a[0] * a[3] - a[1] * a[2];
};

/**
 * Multiplies two mat2d's
 *
 * @param {mat2d} out the receiving matrix
 * @param {mat2d} a the first operand
 * @param {mat2d} b the second operand
 * @returns {mat2d} out
 */
mat2d.multiply = function (out, a, b) {
    var a0 = a[0], a1 = a[1], a2 = a[2], a3 = a[3], a4 = a[4], a5 = a[5],
        b0 = b[0], b1 = b[1], b2 = b[2], b3 = b[3], b4 = b[4], b5 = b[5];
    out[0] = a0 * b0 + a2 * b1;
    out[1] = a1 * b0 + a3 * b1;
    out[2] = a0 * b2 + a2 * b3;
    out[3] = a1 * b2 + a3 * b3;
    out[4] = a0 * b4 + a2 * b5 + a4;
    out[5] = a1 * b4 + a3 * b5 + a5;
    return out;
};

/**
 * Alias for {@link mat2d.multiply}
 * @function
 */
mat2d.mul = mat2d.multiply;


/**
 * Rotates a mat2d by the given angle
 *
 * @param {mat2d} out the receiving matrix
 * @param {mat2d} a the matrix to rotate
 * @param {Number} rad the angle to rotate the matrix by
 * @returns {mat2d} out
 */
mat2d.rotate = function (out, a, rad) {
    var a0 = a[0], a1 = a[1], a2 = a[2], a3 = a[3], a4 = a[4], a5 = a[5],
        s = Math.sin(rad),
        c = Math.cos(rad);
    out[0] = a0 *  c + a2 * s;
    out[1] = a1 *  c + a3 * s;
    out[2] = a0 * -s + a2 * c;
    out[3] = a1 * -s + a3 * c;
    out[4] = a4;
    out[5] = a5;
    return out;
};

/**
 * Scales the mat2d by the dimensions in the given vec2
 *
 * @param {mat2d} out the receiving matrix
 * @param {mat2d} a the matrix to translate
 * @param {vec2} v the vec2 to scale the matrix by
 * @returns {mat2d} out
 **/
mat2d.scale = function(out, a, v) {
    var a0 = a[0], a1 = a[1], a2 = a[2], a3 = a[3], a4 = a[4], a5 = a[5],
        v0 = v[0], v1 = v[1];
    out[0] = a0 * v0;
    out[1] = a1 * v0;
    out[2] = a2 * v1;
    out[3] = a3 * v1;
    out[4] = a4;
    out[5] = a5;
    return out;
};

/**
 * Translates the mat2d by the dimensions in the given vec2
 *
 * @param {mat2d} out the receiving matrix
 * @param {mat2d} a the matrix to translate
 * @param {vec2} v the vec2 to translate the matrix by
 * @returns {mat2d} out
 **/
mat2d.translate = function(out, a, v) {
    var a0 = a[0], a1 = a[1], a2 = a[2], a3 = a[3], a4 = a[4], a5 = a[5],
        v0 = v[0], v1 = v[1];
    out[0] = a0;
    out[1] = a1;
    out[2] = a2;
    out[3] = a3;
    out[4] = a0 * v0 + a2 * v1 + a4;
    out[5] = a1 * v0 + a3 * v1 + a5;
    return out;
};

/**
 * Returns a string representation of a mat2d
 *
 * @param {mat2d} a matrix to represent as a string
 * @returns {String} string representation of the matrix
 */
mat2d.str = function (a) {
    return 'mat2d(' + a[0] + ', ' + a[1] + ', ' + a[2] + ', ' + 
                    a[3] + ', ' + a[4] + ', ' + a[5] + ')';
};

/**
 * Returns Frobenius norm of a mat2d
 *
 * @param {mat2d} a the matrix to calculate Frobenius norm of
 * @returns {Number} Frobenius norm
 */
mat2d.frob = function (a) { 
    return(Math.sqrt(Math.pow(a[0], 2) + Math.pow(a[1], 2) + Math.pow(a[2], 2) + Math.pow(a[3], 2) + Math.pow(a[4], 2) + Math.pow(a[5], 2) + 1))
}; 

if(typeof(exports) !== 'undefined') {
    exports.mat2d = mat2d;
}
;
/* Copyright (c) 2013, Brandon Jones, Colin MacKenzie IV. All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

  * Redistributions of source code must retain the above copyright notice, this
    list of conditions and the following disclaimer.
  * Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation 
    and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE 
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. */

/**
 * @class 3x3 Matrix
 * @name mat3
 */

var mat3 = {};

/**
 * Creates a new identity mat3
 *
 * @returns {mat3} a new 3x3 matrix
 */
mat3.create = function() {
    var out = new GLMAT_ARRAY_TYPE(9);
    out[0] = 1;
    out[1] = 0;
    out[2] = 0;
    out[3] = 0;
    out[4] = 1;
    out[5] = 0;
    out[6] = 0;
    out[7] = 0;
    out[8] = 1;
    return out;
};

/**
 * Copies the upper-left 3x3 values into the given mat3.
 *
 * @param {mat3} out the receiving 3x3 matrix
 * @param {mat4} a   the source 4x4 matrix
 * @returns {mat3} out
 */
mat3.fromMat4 = function(out, a) {
    out[0] = a[0];
    out[1] = a[1];
    out[2] = a[2];
    out[3] = a[4];
    out[4] = a[5];
    out[5] = a[6];
    out[6] = a[8];
    out[7] = a[9];
    out[8] = a[10];
    return out;
};

/**
 * Creates a new mat3 initialized with values from an existing matrix
 *
 * @param {mat3} a matrix to clone
 * @returns {mat3} a new 3x3 matrix
 */
mat3.clone = function(a) {
    var out = new GLMAT_ARRAY_TYPE(9);
    out[0] = a[0];
    out[1] = a[1];
    out[2] = a[2];
    out[3] = a[3];
    out[4] = a[4];
    out[5] = a[5];
    out[6] = a[6];
    out[7] = a[7];
    out[8] = a[8];
    return out;
};

/**
 * Copy the values from one mat3 to another
 *
 * @param {mat3} out the receiving matrix
 * @param {mat3} a the source matrix
 * @returns {mat3} out
 */
mat3.copy = function(out, a) {
    out[0] = a[0];
    out[1] = a[1];
    out[2] = a[2];
    out[3] = a[3];
    out[4] = a[4];
    out[5] = a[5];
    out[6] = a[6];
    out[7] = a[7];
    out[8] = a[8];
    return out;
};

/**
 * Set a mat3 to the identity matrix
 *
 * @param {mat3} out the receiving matrix
 * @returns {mat3} out
 */
mat3.identity = function(out) {
    out[0] = 1;
    out[1] = 0;
    out[2] = 0;
    out[3] = 0;
    out[4] = 1;
    out[5] = 0;
    out[6] = 0;
    out[7] = 0;
    out[8] = 1;
    return out;
};

/**
 * Transpose the values of a mat3
 *
 * @param {mat3} out the receiving matrix
 * @param {mat3} a the source matrix
 * @returns {mat3} out
 */
mat3.transpose = function(out, a) {
    // If we are transposing ourselves we can skip a few steps but have to cache some values
    if (out === a) {
        var a01 = a[1], a02 = a[2], a12 = a[5];
        out[1] = a[3];
        out[2] = a[6];
        out[3] = a01;
        out[5] = a[7];
        out[6] = a02;
        out[7] = a12;
    } else {
        out[0] = a[0];
        out[1] = a[3];
        out[2] = a[6];
        out[3] = a[1];
        out[4] = a[4];
        out[5] = a[7];
        out[6] = a[2];
        out[7] = a[5];
        out[8] = a[8];
    }
    
    return out;
};

/**
 * Inverts a mat3
 *
 * @param {mat3} out the receiving matrix
 * @param {mat3} a the source matrix
 * @returns {mat3} out
 */
mat3.invert = function(out, a) {
    var a00 = a[0], a01 = a[1], a02 = a[2],
        a10 = a[3], a11 = a[4], a12 = a[5],
        a20 = a[6], a21 = a[7], a22 = a[8],

        b01 = a22 * a11 - a12 * a21,
        b11 = -a22 * a10 + a12 * a20,
        b21 = a21 * a10 - a11 * a20,

        // Calculate the determinant
        det = a00 * b01 + a01 * b11 + a02 * b21;

    if (!det) { 
        return null; 
    }
    det = 1.0 / det;

    out[0] = b01 * det;
    out[1] = (-a22 * a01 + a02 * a21) * det;
    out[2] = (a12 * a01 - a02 * a11) * det;
    out[3] = b11 * det;
    out[4] = (a22 * a00 - a02 * a20) * det;
    out[5] = (-a12 * a00 + a02 * a10) * det;
    out[6] = b21 * det;
    out[7] = (-a21 * a00 + a01 * a20) * det;
    out[8] = (a11 * a00 - a01 * a10) * det;
    return out;
};

/**
 * Calculates the adjugate of a mat3
 *
 * @param {mat3} out the receiving matrix
 * @param {mat3} a the source matrix
 * @returns {mat3} out
 */
mat3.adjoint = function(out, a) {
    var a00 = a[0], a01 = a[1], a02 = a[2],
        a10 = a[3], a11 = a[4], a12 = a[5],
        a20 = a[6], a21 = a[7], a22 = a[8];

    out[0] = (a11 * a22 - a12 * a21);
    out[1] = (a02 * a21 - a01 * a22);
    out[2] = (a01 * a12 - a02 * a11);
    out[3] = (a12 * a20 - a10 * a22);
    out[4] = (a00 * a22 - a02 * a20);
    out[5] = (a02 * a10 - a00 * a12);
    out[6] = (a10 * a21 - a11 * a20);
    out[7] = (a01 * a20 - a00 * a21);
    out[8] = (a00 * a11 - a01 * a10);
    return out;
};

/**
 * Calculates the determinant of a mat3
 *
 * @param {mat3} a the source matrix
 * @returns {Number} determinant of a
 */
mat3.determinant = function (a) {
    var a00 = a[0], a01 = a[1], a02 = a[2],
        a10 = a[3], a11 = a[4], a12 = a[5],
        a20 = a[6], a21 = a[7], a22 = a[8];

    return a00 * (a22 * a11 - a12 * a21) + a01 * (-a22 * a10 + a12 * a20) + a02 * (a21 * a10 - a11 * a20);
};

/**
 * Multiplies two mat3's
 *
 * @param {mat3} out the receiving matrix
 * @param {mat3} a the first operand
 * @param {mat3} b the second operand
 * @returns {mat3} out
 */
mat3.multiply = function (out, a, b) {
    var a00 = a[0], a01 = a[1], a02 = a[2],
        a10 = a[3], a11 = a[4], a12 = a[5],
        a20 = a[6], a21 = a[7], a22 = a[8],

        b00 = b[0], b01 = b[1], b02 = b[2],
        b10 = b[3], b11 = b[4], b12 = b[5],
        b20 = b[6], b21 = b[7], b22 = b[8];

    out[0] = b00 * a00 + b01 * a10 + b02 * a20;
    out[1] = b00 * a01 + b01 * a11 + b02 * a21;
    out[2] = b00 * a02 + b01 * a12 + b02 * a22;

    out[3] = b10 * a00 + b11 * a10 + b12 * a20;
    out[4] = b10 * a01 + b11 * a11 + b12 * a21;
    out[5] = b10 * a02 + b11 * a12 + b12 * a22;

    out[6] = b20 * a00 + b21 * a10 + b22 * a20;
    out[7] = b20 * a01 + b21 * a11 + b22 * a21;
    out[8] = b20 * a02 + b21 * a12 + b22 * a22;
    return out;
};

/**
 * Alias for {@link mat3.multiply}
 * @function
 */
mat3.mul = mat3.multiply;

/**
 * Translate a mat3 by the given vector
 *
 * @param {mat3} out the receiving matrix
 * @param {mat3} a the matrix to translate
 * @param {vec2} v vector to translate by
 * @returns {mat3} out
 */
mat3.translate = function(out, a, v) {
    var a00 = a[0], a01 = a[1], a02 = a[2],
        a10 = a[3], a11 = a[4], a12 = a[5],
        a20 = a[6], a21 = a[7], a22 = a[8],
        x = v[0], y = v[1];

    out[0] = a00;
    out[1] = a01;
    out[2] = a02;

    out[3] = a10;
    out[4] = a11;
    out[5] = a12;

    out[6] = x * a00 + y * a10 + a20;
    out[7] = x * a01 + y * a11 + a21;
    out[8] = x * a02 + y * a12 + a22;
    return out;
};

/**
 * Rotates a mat3 by the given angle
 *
 * @param {mat3} out the receiving matrix
 * @param {mat3} a the matrix to rotate
 * @param {Number} rad the angle to rotate the matrix by
 * @returns {mat3} out
 */
mat3.rotate = function (out, a, rad) {
    var a00 = a[0], a01 = a[1], a02 = a[2],
        a10 = a[3], a11 = a[4], a12 = a[5],
        a20 = a[6], a21 = a[7], a22 = a[8],

        s = Math.sin(rad),
        c = Math.cos(rad);

    out[0] = c * a00 + s * a10;
    out[1] = c * a01 + s * a11;
    out[2] = c * a02 + s * a12;

    out[3] = c * a10 - s * a00;
    out[4] = c * a11 - s * a01;
    out[5] = c * a12 - s * a02;

    out[6] = a20;
    out[7] = a21;
    out[8] = a22;
    return out;
};

/**
 * Scales the mat3 by the dimensions in the given vec2
 *
 * @param {mat3} out the receiving matrix
 * @param {mat3} a the matrix to rotate
 * @param {vec2} v the vec2 to scale the matrix by
 * @returns {mat3} out
 **/
mat3.scale = function(out, a, v) {
    var x = v[0], y = v[1];

    out[0] = x * a[0];
    out[1] = x * a[1];
    out[2] = x * a[2];

    out[3] = y * a[3];
    out[4] = y * a[4];
    out[5] = y * a[5];

    out[6] = a[6];
    out[7] = a[7];
    out[8] = a[8];
    return out;
};

/**
 * Copies the values from a mat2d into a mat3
 *
 * @param {mat3} out the receiving matrix
 * @param {mat2d} a the matrix to copy
 * @returns {mat3} out
 **/
mat3.fromMat2d = function(out, a) {
    out[0] = a[0];
    out[1] = a[1];
    out[2] = 0;

    out[3] = a[2];
    out[4] = a[3];
    out[5] = 0;

    out[6] = a[4];
    out[7] = a[5];
    out[8] = 1;
    return out;
};

/**
* Calculates a 3x3 matrix from the given quaternion
*
* @param {mat3} out mat3 receiving operation result
* @param {quat} q Quaternion to create matrix from
*
* @returns {mat3} out
*/
mat3.fromQuat = function (out, q) {
    var x = q[0], y = q[1], z = q[2], w = q[3],
        x2 = x + x,
        y2 = y + y,
        z2 = z + z,

        xx = x * x2,
        yx = y * x2,
        yy = y * y2,
        zx = z * x2,
        zy = z * y2,
        zz = z * z2,
        wx = w * x2,
        wy = w * y2,
        wz = w * z2;

    out[0] = 1 - yy - zz;
    out[3] = yx - wz;
    out[6] = zx + wy;

    out[1] = yx + wz;
    out[4] = 1 - xx - zz;
    out[7] = zy - wx;

    out[2] = zx - wy;
    out[5] = zy + wx;
    out[8] = 1 - xx - yy;

    return out;
};

/**
* Calculates a 3x3 normal matrix (transpose inverse) from the 4x4 matrix
*
* @param {mat3} out mat3 receiving operation result
* @param {mat4} a Mat4 to derive the normal matrix from
*
* @returns {mat3} out
*/
mat3.normalFromMat4 = function (out, a) {
    var a00 = a[0], a01 = a[1], a02 = a[2], a03 = a[3],
        a10 = a[4], a11 = a[5], a12 = a[6], a13 = a[7],
        a20 = a[8], a21 = a[9], a22 = a[10], a23 = a[11],
        a30 = a[12], a31 = a[13], a32 = a[14], a33 = a[15],

        b00 = a00 * a11 - a01 * a10,
        b01 = a00 * a12 - a02 * a10,
        b02 = a00 * a13 - a03 * a10,
        b03 = a01 * a12 - a02 * a11,
        b04 = a01 * a13 - a03 * a11,
        b05 = a02 * a13 - a03 * a12,
        b06 = a20 * a31 - a21 * a30,
        b07 = a20 * a32 - a22 * a30,
        b08 = a20 * a33 - a23 * a30,
        b09 = a21 * a32 - a22 * a31,
        b10 = a21 * a33 - a23 * a31,
        b11 = a22 * a33 - a23 * a32,

        // Calculate the determinant
        det = b00 * b11 - b01 * b10 + b02 * b09 + b03 * b08 - b04 * b07 + b05 * b06;

    if (!det) { 
        return null; 
    }
    det = 1.0 / det;

    out[0] = (a11 * b11 - a12 * b10 + a13 * b09) * det;
    out[1] = (a12 * b08 - a10 * b11 - a13 * b07) * det;
    out[2] = (a10 * b10 - a11 * b08 + a13 * b06) * det;

    out[3] = (a02 * b10 - a01 * b11 - a03 * b09) * det;
    out[4] = (a00 * b11 - a02 * b08 + a03 * b07) * det;
    out[5] = (a01 * b08 - a00 * b10 - a03 * b06) * det;

    out[6] = (a31 * b05 - a32 * b04 + a33 * b03) * det;
    out[7] = (a32 * b02 - a30 * b05 - a33 * b01) * det;
    out[8] = (a30 * b04 - a31 * b02 + a33 * b00) * det;

    return out;
};

/**
 * Returns a string representation of a mat3
 *
 * @param {mat3} mat matrix to represent as a string
 * @returns {String} string representation of the matrix
 */
mat3.str = function (a) {
    return 'mat3(' + a[0] + ', ' + a[1] + ', ' + a[2] + ', ' + 
                    a[3] + ', ' + a[4] + ', ' + a[5] + ', ' + 
                    a[6] + ', ' + a[7] + ', ' + a[8] + ')';
};

/**
 * Returns Frobenius norm of a mat3
 *
 * @param {mat3} a the matrix to calculate Frobenius norm of
 * @returns {Number} Frobenius norm
 */
mat3.frob = function (a) {
    return(Math.sqrt(Math.pow(a[0], 2) + Math.pow(a[1], 2) + Math.pow(a[2], 2) + Math.pow(a[3], 2) + Math.pow(a[4], 2) + Math.pow(a[5], 2) + Math.pow(a[6], 2) + Math.pow(a[7], 2) + Math.pow(a[8], 2)))
};


if(typeof(exports) !== 'undefined') {
    exports.mat3 = mat3;
}
;
/* Copyright (c) 2013, Brandon Jones, Colin MacKenzie IV. All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

  * Redistributions of source code must retain the above copyright notice, this
    list of conditions and the following disclaimer.
  * Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation 
    and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE 
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. */

/**
 * @class 4x4 Matrix
 * @name mat4
 */

var mat4 = {};

/**
 * Creates a new identity mat4
 *
 * @returns {mat4} a new 4x4 matrix
 */
mat4.create = function() {
    var out = new GLMAT_ARRAY_TYPE(16);
    out[0] = 1;
    out[1] = 0;
    out[2] = 0;
    out[3] = 0;
    out[4] = 0;
    out[5] = 1;
    out[6] = 0;
    out[7] = 0;
    out[8] = 0;
    out[9] = 0;
    out[10] = 1;
    out[11] = 0;
    out[12] = 0;
    out[13] = 0;
    out[14] = 0;
    out[15] = 1;
    return out;
};

/**
 * Creates a new mat4 initialized with values from an existing matrix
 *
 * @param {mat4} a matrix to clone
 * @returns {mat4} a new 4x4 matrix
 */
mat4.clone = function(a) {
    var out = new GLMAT_ARRAY_TYPE(16);
    out[0] = a[0];
    out[1] = a[1];
    out[2] = a[2];
    out[3] = a[3];
    out[4] = a[4];
    out[5] = a[5];
    out[6] = a[6];
    out[7] = a[7];
    out[8] = a[8];
    out[9] = a[9];
    out[10] = a[10];
    out[11] = a[11];
    out[12] = a[12];
    out[13] = a[13];
    out[14] = a[14];
    out[15] = a[15];
    return out;
};

/**
 * Copy the values from one mat4 to another
 *
 * @param {mat4} out the receiving matrix
 * @param {mat4} a the source matrix
 * @returns {mat4} out
 */
mat4.copy = function(out, a) {
    out[0] = a[0];
    out[1] = a[1];
    out[2] = a[2];
    out[3] = a[3];
    out[4] = a[4];
    out[5] = a[5];
    out[6] = a[6];
    out[7] = a[7];
    out[8] = a[8];
    out[9] = a[9];
    out[10] = a[10];
    out[11] = a[11];
    out[12] = a[12];
    out[13] = a[13];
    out[14] = a[14];
    out[15] = a[15];
    return out;
};

/**
 * Set a mat4 to the identity matrix
 *
 * @param {mat4} out the receiving matrix
 * @returns {mat4} out
 */
mat4.identity = function(out) {
    out[0] = 1;
    out[1] = 0;
    out[2] = 0;
    out[3] = 0;
    out[4] = 0;
    out[5] = 1;
    out[6] = 0;
    out[7] = 0;
    out[8] = 0;
    out[9] = 0;
    out[10] = 1;
    out[11] = 0;
    out[12] = 0;
    out[13] = 0;
    out[14] = 0;
    out[15] = 1;
    return out;
};

/**
 * Transpose the values of a mat4
 *
 * @param {mat4} out the receiving matrix
 * @param {mat4} a the source matrix
 * @returns {mat4} out
 */
mat4.transpose = function(out, a) {
    // If we are transposing ourselves we can skip a few steps but have to cache some values
    if (out === a) {
        var a01 = a[1], a02 = a[2], a03 = a[3],
            a12 = a[6], a13 = a[7],
            a23 = a[11];

        out[1] = a[4];
        out[2] = a[8];
        out[3] = a[12];
        out[4] = a01;
        out[6] = a[9];
        out[7] = a[13];
        out[8] = a02;
        out[9] = a12;
        out[11] = a[14];
        out[12] = a03;
        out[13] = a13;
        out[14] = a23;
    } else {
        out[0] = a[0];
        out[1] = a[4];
        out[2] = a[8];
        out[3] = a[12];
        out[4] = a[1];
        out[5] = a[5];
        out[6] = a[9];
        out[7] = a[13];
        out[8] = a[2];
        out[9] = a[6];
        out[10] = a[10];
        out[11] = a[14];
        out[12] = a[3];
        out[13] = a[7];
        out[14] = a[11];
        out[15] = a[15];
    }
    
    return out;
};

/**
 * Inverts a mat4
 *
 * @param {mat4} out the receiving matrix
 * @param {mat4} a the source matrix
 * @returns {mat4} out
 */
mat4.invert = function(out, a) {
    var a00 = a[0], a01 = a[1], a02 = a[2], a03 = a[3],
        a10 = a[4], a11 = a[5], a12 = a[6], a13 = a[7],
        a20 = a[8], a21 = a[9], a22 = a[10], a23 = a[11],
        a30 = a[12], a31 = a[13], a32 = a[14], a33 = a[15],

        b00 = a00 * a11 - a01 * a10,
        b01 = a00 * a12 - a02 * a10,
        b02 = a00 * a13 - a03 * a10,
        b03 = a01 * a12 - a02 * a11,
        b04 = a01 * a13 - a03 * a11,
        b05 = a02 * a13 - a03 * a12,
        b06 = a20 * a31 - a21 * a30,
        b07 = a20 * a32 - a22 * a30,
        b08 = a20 * a33 - a23 * a30,
        b09 = a21 * a32 - a22 * a31,
        b10 = a21 * a33 - a23 * a31,
        b11 = a22 * a33 - a23 * a32,

        // Calculate the determinant
        det = b00 * b11 - b01 * b10 + b02 * b09 + b03 * b08 - b04 * b07 + b05 * b06;

    if (!det) { 
        return null; 
    }
    det = 1.0 / det;

    out[0] = (a11 * b11 - a12 * b10 + a13 * b09) * det;
    out[1] = (a02 * b10 - a01 * b11 - a03 * b09) * det;
    out[2] = (a31 * b05 - a32 * b04 + a33 * b03) * det;
    out[3] = (a22 * b04 - a21 * b05 - a23 * b03) * det;
    out[4] = (a12 * b08 - a10 * b11 - a13 * b07) * det;
    out[5] = (a00 * b11 - a02 * b08 + a03 * b07) * det;
    out[6] = (a32 * b02 - a30 * b05 - a33 * b01) * det;
    out[7] = (a20 * b05 - a22 * b02 + a23 * b01) * det;
    out[8] = (a10 * b10 - a11 * b08 + a13 * b06) * det;
    out[9] = (a01 * b08 - a00 * b10 - a03 * b06) * det;
    out[10] = (a30 * b04 - a31 * b02 + a33 * b00) * det;
    out[11] = (a21 * b02 - a20 * b04 - a23 * b00) * det;
    out[12] = (a11 * b07 - a10 * b09 - a12 * b06) * det;
    out[13] = (a00 * b09 - a01 * b07 + a02 * b06) * det;
    out[14] = (a31 * b01 - a30 * b03 - a32 * b00) * det;
    out[15] = (a20 * b03 - a21 * b01 + a22 * b00) * det;

    return out;
};

/**
 * Calculates the adjugate of a mat4
 *
 * @param {mat4} out the receiving matrix
 * @param {mat4} a the source matrix
 * @returns {mat4} out
 */
mat4.adjoint = function(out, a) {
    var a00 = a[0], a01 = a[1], a02 = a[2], a03 = a[3],
        a10 = a[4], a11 = a[5], a12 = a[6], a13 = a[7],
        a20 = a[8], a21 = a[9], a22 = a[10], a23 = a[11],
        a30 = a[12], a31 = a[13], a32 = a[14], a33 = a[15];

    out[0]  =  (a11 * (a22 * a33 - a23 * a32) - a21 * (a12 * a33 - a13 * a32) + a31 * (a12 * a23 - a13 * a22));
    out[1]  = -(a01 * (a22 * a33 - a23 * a32) - a21 * (a02 * a33 - a03 * a32) + a31 * (a02 * a23 - a03 * a22));
    out[2]  =  (a01 * (a12 * a33 - a13 * a32) - a11 * (a02 * a33 - a03 * a32) + a31 * (a02 * a13 - a03 * a12));
    out[3]  = -(a01 * (a12 * a23 - a13 * a22) - a11 * (a02 * a23 - a03 * a22) + a21 * (a02 * a13 - a03 * a12));
    out[4]  = -(a10 * (a22 * a33 - a23 * a32) - a20 * (a12 * a33 - a13 * a32) + a30 * (a12 * a23 - a13 * a22));
    out[5]  =  (a00 * (a22 * a33 - a23 * a32) - a20 * (a02 * a33 - a03 * a32) + a30 * (a02 * a23 - a03 * a22));
    out[6]  = -(a00 * (a12 * a33 - a13 * a32) - a10 * (a02 * a33 - a03 * a32) + a30 * (a02 * a13 - a03 * a12));
    out[7]  =  (a00 * (a12 * a23 - a13 * a22) - a10 * (a02 * a23 - a03 * a22) + a20 * (a02 * a13 - a03 * a12));
    out[8]  =  (a10 * (a21 * a33 - a23 * a31) - a20 * (a11 * a33 - a13 * a31) + a30 * (a11 * a23 - a13 * a21));
    out[9]  = -(a00 * (a21 * a33 - a23 * a31) - a20 * (a01 * a33 - a03 * a31) + a30 * (a01 * a23 - a03 * a21));
    out[10] =  (a00 * (a11 * a33 - a13 * a31) - a10 * (a01 * a33 - a03 * a31) + a30 * (a01 * a13 - a03 * a11));
    out[11] = -(a00 * (a11 * a23 - a13 * a21) - a10 * (a01 * a23 - a03 * a21) + a20 * (a01 * a13 - a03 * a11));
    out[12] = -(a10 * (a21 * a32 - a22 * a31) - a20 * (a11 * a32 - a12 * a31) + a30 * (a11 * a22 - a12 * a21));
    out[13] =  (a00 * (a21 * a32 - a22 * a31) - a20 * (a01 * a32 - a02 * a31) + a30 * (a01 * a22 - a02 * a21));
    out[14] = -(a00 * (a11 * a32 - a12 * a31) - a10 * (a01 * a32 - a02 * a31) + a30 * (a01 * a12 - a02 * a11));
    out[15] =  (a00 * (a11 * a22 - a12 * a21) - a10 * (a01 * a22 - a02 * a21) + a20 * (a01 * a12 - a02 * a11));
    return out;
};

/**
 * Calculates the determinant of a mat4
 *
 * @param {mat4} a the source matrix
 * @returns {Number} determinant of a
 */
mat4.determinant = function (a) {
    var a00 = a[0], a01 = a[1], a02 = a[2], a03 = a[3],
        a10 = a[4], a11 = a[5], a12 = a[6], a13 = a[7],
        a20 = a[8], a21 = a[9], a22 = a[10], a23 = a[11],
        a30 = a[12], a31 = a[13], a32 = a[14], a33 = a[15],

        b00 = a00 * a11 - a01 * a10,
        b01 = a00 * a12 - a02 * a10,
        b02 = a00 * a13 - a03 * a10,
        b03 = a01 * a12 - a02 * a11,
        b04 = a01 * a13 - a03 * a11,
        b05 = a02 * a13 - a03 * a12,
        b06 = a20 * a31 - a21 * a30,
        b07 = a20 * a32 - a22 * a30,
        b08 = a20 * a33 - a23 * a30,
        b09 = a21 * a32 - a22 * a31,
        b10 = a21 * a33 - a23 * a31,
        b11 = a22 * a33 - a23 * a32;

    // Calculate the determinant
    return b00 * b11 - b01 * b10 + b02 * b09 + b03 * b08 - b04 * b07 + b05 * b06;
};

/**
 * Multiplies two mat4's
 *
 * @param {mat4} out the receiving matrix
 * @param {mat4} a the first operand
 * @param {mat4} b the second operand
 * @returns {mat4} out
 */
mat4.multiply = function (out, a, b) {
    var a00 = a[0], a01 = a[1], a02 = a[2], a03 = a[3],
        a10 = a[4], a11 = a[5], a12 = a[6], a13 = a[7],
        a20 = a[8], a21 = a[9], a22 = a[10], a23 = a[11],
        a30 = a[12], a31 = a[13], a32 = a[14], a33 = a[15];

    // Cache only the current line of the second matrix
    var b0  = b[0], b1 = b[1], b2 = b[2], b3 = b[3];  
    out[0] = b0*a00 + b1*a10 + b2*a20 + b3*a30;
    out[1] = b0*a01 + b1*a11 + b2*a21 + b3*a31;
    out[2] = b0*a02 + b1*a12 + b2*a22 + b3*a32;
    out[3] = b0*a03 + b1*a13 + b2*a23 + b3*a33;

    b0 = b[4]; b1 = b[5]; b2 = b[6]; b3 = b[7];
    out[4] = b0*a00 + b1*a10 + b2*a20 + b3*a30;
    out[5] = b0*a01 + b1*a11 + b2*a21 + b3*a31;
    out[6] = b0*a02 + b1*a12 + b2*a22 + b3*a32;
    out[7] = b0*a03 + b1*a13 + b2*a23 + b3*a33;

    b0 = b[8]; b1 = b[9]; b2 = b[10]; b3 = b[11];
    out[8] = b0*a00 + b1*a10 + b2*a20 + b3*a30;
    out[9] = b0*a01 + b1*a11 + b2*a21 + b3*a31;
    out[10] = b0*a02 + b1*a12 + b2*a22 + b3*a32;
    out[11] = b0*a03 + b1*a13 + b2*a23 + b3*a33;

    b0 = b[12]; b1 = b[13]; b2 = b[14]; b3 = b[15];
    out[12] = b0*a00 + b1*a10 + b2*a20 + b3*a30;
    out[13] = b0*a01 + b1*a11 + b2*a21 + b3*a31;
    out[14] = b0*a02 + b1*a12 + b2*a22 + b3*a32;
    out[15] = b0*a03 + b1*a13 + b2*a23 + b3*a33;
    return out;
};

/**
 * Alias for {@link mat4.multiply}
 * @function
 */
mat4.mul = mat4.multiply;

/**
 * Translate a mat4 by the given vector
 *
 * @param {mat4} out the receiving matrix
 * @param {mat4} a the matrix to translate
 * @param {vec3} v vector to translate by
 * @returns {mat4} out
 */
mat4.translate = function (out, a, v) {
    var x = v[0], y = v[1], z = v[2],
        a00, a01, a02, a03,
        a10, a11, a12, a13,
        a20, a21, a22, a23;

    if (a === out) {
        out[12] = a[0] * x + a[4] * y + a[8] * z + a[12];
        out[13] = a[1] * x + a[5] * y + a[9] * z + a[13];
        out[14] = a[2] * x + a[6] * y + a[10] * z + a[14];
        out[15] = a[3] * x + a[7] * y + a[11] * z + a[15];
    } else {
        a00 = a[0]; a01 = a[1]; a02 = a[2]; a03 = a[3];
        a10 = a[4]; a11 = a[5]; a12 = a[6]; a13 = a[7];
        a20 = a[8]; a21 = a[9]; a22 = a[10]; a23 = a[11];

        out[0] = a00; out[1] = a01; out[2] = a02; out[3] = a03;
        out[4] = a10; out[5] = a11; out[6] = a12; out[7] = a13;
        out[8] = a20; out[9] = a21; out[10] = a22; out[11] = a23;

        out[12] = a00 * x + a10 * y + a20 * z + a[12];
        out[13] = a01 * x + a11 * y + a21 * z + a[13];
        out[14] = a02 * x + a12 * y + a22 * z + a[14];
        out[15] = a03 * x + a13 * y + a23 * z + a[15];
    }

    return out;
};

/**
 * Scales the mat4 by the dimensions in the given vec3
 *
 * @param {mat4} out the receiving matrix
 * @param {mat4} a the matrix to scale
 * @param {vec3} v the vec3 to scale the matrix by
 * @returns {mat4} out
 **/
mat4.scale = function(out, a, v) {
    var x = v[0], y = v[1], z = v[2];

    out[0] = a[0] * x;
    out[1] = a[1] * x;
    out[2] = a[2] * x;
    out[3] = a[3] * x;
    out[4] = a[4] * y;
    out[5] = a[5] * y;
    out[6] = a[6] * y;
    out[7] = a[7] * y;
    out[8] = a[8] * z;
    out[9] = a[9] * z;
    out[10] = a[10] * z;
    out[11] = a[11] * z;
    out[12] = a[12];
    out[13] = a[13];
    out[14] = a[14];
    out[15] = a[15];
    return out;
};

/**
 * Rotates a mat4 by the given angle
 *
 * @param {mat4} out the receiving matrix
 * @param {mat4} a the matrix to rotate
 * @param {Number} rad the angle to rotate the matrix by
 * @param {vec3} axis the axis to rotate around
 * @returns {mat4} out
 */
mat4.rotate = function (out, a, rad, axis) {
    var x = axis[0], y = axis[1], z = axis[2],
        len = Math.sqrt(x * x + y * y + z * z),
        s, c, t,
        a00, a01, a02, a03,
        a10, a11, a12, a13,
        a20, a21, a22, a23,
        b00, b01, b02,
        b10, b11, b12,
        b20, b21, b22;

    if (Math.abs(len) < GLMAT_EPSILON) { return null; }
    
    len = 1 / len;
    x *= len;
    y *= len;
    z *= len;

    s = Math.sin(rad);
    c = Math.cos(rad);
    t = 1 - c;

    a00 = a[0]; a01 = a[1]; a02 = a[2]; a03 = a[3];
    a10 = a[4]; a11 = a[5]; a12 = a[6]; a13 = a[7];
    a20 = a[8]; a21 = a[9]; a22 = a[10]; a23 = a[11];

    // Construct the elements of the rotation matrix
    b00 = x * x * t + c; b01 = y * x * t + z * s; b02 = z * x * t - y * s;
    b10 = x * y * t - z * s; b11 = y * y * t + c; b12 = z * y * t + x * s;
    b20 = x * z * t + y * s; b21 = y * z * t - x * s; b22 = z * z * t + c;

    // Perform rotation-specific matrix multiplication
    out[0] = a00 * b00 + a10 * b01 + a20 * b02;
    out[1] = a01 * b00 + a11 * b01 + a21 * b02;
    out[2] = a02 * b00 + a12 * b01 + a22 * b02;
    out[3] = a03 * b00 + a13 * b01 + a23 * b02;
    out[4] = a00 * b10 + a10 * b11 + a20 * b12;
    out[5] = a01 * b10 + a11 * b11 + a21 * b12;
    out[6] = a02 * b10 + a12 * b11 + a22 * b12;
    out[7] = a03 * b10 + a13 * b11 + a23 * b12;
    out[8] = a00 * b20 + a10 * b21 + a20 * b22;
    out[9] = a01 * b20 + a11 * b21 + a21 * b22;
    out[10] = a02 * b20 + a12 * b21 + a22 * b22;
    out[11] = a03 * b20 + a13 * b21 + a23 * b22;

    if (a !== out) { // If the source and destination differ, copy the unchanged last row
        out[12] = a[12];
        out[13] = a[13];
        out[14] = a[14];
        out[15] = a[15];
    }
    return out;
};

/**
 * Rotates a matrix by the given angle around the X axis
 *
 * @param {mat4} out the receiving matrix
 * @param {mat4} a the matrix to rotate
 * @param {Number} rad the angle to rotate the matrix by
 * @returns {mat4} out
 */
mat4.rotateX = function (out, a, rad) {
    var s = Math.sin(rad),
        c = Math.cos(rad),
        a10 = a[4],
        a11 = a[5],
        a12 = a[6],
        a13 = a[7],
        a20 = a[8],
        a21 = a[9],
        a22 = a[10],
        a23 = a[11];

    if (a !== out) { // If the source and destination differ, copy the unchanged rows
        out[0]  = a[0];
        out[1]  = a[1];
        out[2]  = a[2];
        out[3]  = a[3];
        out[12] = a[12];
        out[13] = a[13];
        out[14] = a[14];
        out[15] = a[15];
    }

    // Perform axis-specific matrix multiplication
    out[4] = a10 * c + a20 * s;
    out[5] = a11 * c + a21 * s;
    out[6] = a12 * c + a22 * s;
    out[7] = a13 * c + a23 * s;
    out[8] = a20 * c - a10 * s;
    out[9] = a21 * c - a11 * s;
    out[10] = a22 * c - a12 * s;
    out[11] = a23 * c - a13 * s;
    return out;
};

/**
 * Rotates a matrix by the given angle around the Y axis
 *
 * @param {mat4} out the receiving matrix
 * @param {mat4} a the matrix to rotate
 * @param {Number} rad the angle to rotate the matrix by
 * @returns {mat4} out
 */
mat4.rotateY = function (out, a, rad) {
    var s = Math.sin(rad),
        c = Math.cos(rad),
        a00 = a[0],
        a01 = a[1],
        a02 = a[2],
        a03 = a[3],
        a20 = a[8],
        a21 = a[9],
        a22 = a[10],
        a23 = a[11];

    if (a !== out) { // If the source and destination differ, copy the unchanged rows
        out[4]  = a[4];
        out[5]  = a[5];
        out[6]  = a[6];
        out[7]  = a[7];
        out[12] = a[12];
        out[13] = a[13];
        out[14] = a[14];
        out[15] = a[15];
    }

    // Perform axis-specific matrix multiplication
    out[0] = a00 * c - a20 * s;
    out[1] = a01 * c - a21 * s;
    out[2] = a02 * c - a22 * s;
    out[3] = a03 * c - a23 * s;
    out[8] = a00 * s + a20 * c;
    out[9] = a01 * s + a21 * c;
    out[10] = a02 * s + a22 * c;
    out[11] = a03 * s + a23 * c;
    return out;
};

/**
 * Rotates a matrix by the given angle around the Z axis
 *
 * @param {mat4} out the receiving matrix
 * @param {mat4} a the matrix to rotate
 * @param {Number} rad the angle to rotate the matrix by
 * @returns {mat4} out
 */
mat4.rotateZ = function (out, a, rad) {
    var s = Math.sin(rad),
        c = Math.cos(rad),
        a00 = a[0],
        a01 = a[1],
        a02 = a[2],
        a03 = a[3],
        a10 = a[4],
        a11 = a[5],
        a12 = a[6],
        a13 = a[7];

    if (a !== out) { // If the source and destination differ, copy the unchanged last row
        out[8]  = a[8];
        out[9]  = a[9];
        out[10] = a[10];
        out[11] = a[11];
        out[12] = a[12];
        out[13] = a[13];
        out[14] = a[14];
        out[15] = a[15];
    }

    // Perform axis-specific matrix multiplication
    out[0] = a00 * c + a10 * s;
    out[1] = a01 * c + a11 * s;
    out[2] = a02 * c + a12 * s;
    out[3] = a03 * c + a13 * s;
    out[4] = a10 * c - a00 * s;
    out[5] = a11 * c - a01 * s;
    out[6] = a12 * c - a02 * s;
    out[7] = a13 * c - a03 * s;
    return out;
};

/**
 * Creates a matrix from a quaternion rotation and vector translation
 * This is equivalent to (but much faster than):
 *
 *     mat4.identity(dest);
 *     mat4.translate(dest, vec);
 *     var quatMat = mat4.create();
 *     quat4.toMat4(quat, quatMat);
 *     mat4.multiply(dest, quatMat);
 *
 * @param {mat4} out mat4 receiving operation result
 * @param {quat4} q Rotation quaternion
 * @param {vec3} v Translation vector
 * @returns {mat4} out
 */
mat4.fromRotationTranslation = function (out, q, v) {
    // Quaternion math
    var x = q[0], y = q[1], z = q[2], w = q[3],
        x2 = x + x,
        y2 = y + y,
        z2 = z + z,

        xx = x * x2,
        xy = x * y2,
        xz = x * z2,
        yy = y * y2,
        yz = y * z2,
        zz = z * z2,
        wx = w * x2,
        wy = w * y2,
        wz = w * z2;

    out[0] = 1 - (yy + zz);
    out[1] = xy + wz;
    out[2] = xz - wy;
    out[3] = 0;
    out[4] = xy - wz;
    out[5] = 1 - (xx + zz);
    out[6] = yz + wx;
    out[7] = 0;
    out[8] = xz + wy;
    out[9] = yz - wx;
    out[10] = 1 - (xx + yy);
    out[11] = 0;
    out[12] = v[0];
    out[13] = v[1];
    out[14] = v[2];
    out[15] = 1;
    
    return out;
};

mat4.fromQuat = function (out, q) {
    var x = q[0], y = q[1], z = q[2], w = q[3],
        x2 = x + x,
        y2 = y + y,
        z2 = z + z,

        xx = x * x2,
        yx = y * x2,
        yy = y * y2,
        zx = z * x2,
        zy = z * y2,
        zz = z * z2,
        wx = w * x2,
        wy = w * y2,
        wz = w * z2;

    out[0] = 1 - yy - zz;
    out[1] = yx + wz;
    out[2] = zx - wy;
    out[3] = 0;

    out[4] = yx - wz;
    out[5] = 1 - xx - zz;
    out[6] = zy + wx;
    out[7] = 0;

    out[8] = zx + wy;
    out[9] = zy - wx;
    out[10] = 1 - xx - yy;
    out[11] = 0;

    out[12] = 0;
    out[13] = 0;
    out[14] = 0;
    out[15] = 1;

    return out;
};

/**
 * Generates a frustum matrix with the given bounds
 *
 * @param {mat4} out mat4 frustum matrix will be written into
 * @param {Number} left Left bound of the frustum
 * @param {Number} right Right bound of the frustum
 * @param {Number} bottom Bottom bound of the frustum
 * @param {Number} top Top bound of the frustum
 * @param {Number} near Near bound of the frustum
 * @param {Number} far Far bound of the frustum
 * @returns {mat4} out
 */
mat4.frustum = function (out, left, right, bottom, top, near, far) {
    var rl = 1 / (right - left),
        tb = 1 / (top - bottom),
        nf = 1 / (near - far);
    out[0] = (near * 2) * rl;
    out[1] = 0;
    out[2] = 0;
    out[3] = 0;
    out[4] = 0;
    out[5] = (near * 2) * tb;
    out[6] = 0;
    out[7] = 0;
    out[8] = (right + left) * rl;
    out[9] = (top + bottom) * tb;
    out[10] = (far + near) * nf;
    out[11] = -1;
    out[12] = 0;
    out[13] = 0;
    out[14] = (far * near * 2) * nf;
    out[15] = 0;
    return out;
};

/**
 * Generates a perspective projection matrix with the given bounds
 *
 * @param {mat4} out mat4 frustum matrix will be written into
 * @param {number} fovy Vertical field of view in radians
 * @param {number} aspect Aspect ratio. typically viewport width/height
 * @param {number} near Near bound of the frustum
 * @param {number} far Far bound of the frustum
 * @returns {mat4} out
 */
mat4.perspective = function (out, fovy, aspect, near, far) {
    var f = 1.0 / Math.tan(fovy / 2),
        nf = 1 / (near - far);
    out[0] = f / aspect;
    out[1] = 0;
    out[2] = 0;
    out[3] = 0;
    out[4] = 0;
    out[5] = f;
    out[6] = 0;
    out[7] = 0;
    out[8] = 0;
    out[9] = 0;
    out[10] = (far + near) * nf;
    out[11] = -1;
    out[12] = 0;
    out[13] = 0;
    out[14] = (2 * far * near) * nf;
    out[15] = 0;
    return out;
};

/**
 * Generates a orthogonal projection matrix with the given bounds
 *
 * @param {mat4} out mat4 frustum matrix will be written into
 * @param {number} left Left bound of the frustum
 * @param {number} right Right bound of the frustum
 * @param {number} bottom Bottom bound of the frustum
 * @param {number} top Top bound of the frustum
 * @param {number} near Near bound of the frustum
 * @param {number} far Far bound of the frustum
 * @returns {mat4} out
 */
mat4.ortho = function (out, left, right, bottom, top, near, far) {
    var lr = 1 / (left - right),
        bt = 1 / (bottom - top),
        nf = 1 / (near - far);
    out[0] = -2 * lr;
    out[1] = 0;
    out[2] = 0;
    out[3] = 0;
    out[4] = 0;
    out[5] = -2 * bt;
    out[6] = 0;
    out[7] = 0;
    out[8] = 0;
    out[9] = 0;
    out[10] = 2 * nf;
    out[11] = 0;
    out[12] = (left + right) * lr;
    out[13] = (top + bottom) * bt;
    out[14] = (far + near) * nf;
    out[15] = 1;
    return out;
};

/**
 * Generates a look-at matrix with the given eye position, focal point, and up axis
 *
 * @param {mat4} out mat4 frustum matrix will be written into
 * @param {vec3} eye Position of the viewer
 * @param {vec3} center Point the viewer is looking at
 * @param {vec3} up vec3 pointing up
 * @returns {mat4} out
 */
mat4.lookAt = function (out, eye, center, up) {
    var x0, x1, x2, y0, y1, y2, z0, z1, z2, len,
        eyex = eye[0],
        eyey = eye[1],
        eyez = eye[2],
        upx = up[0],
        upy = up[1],
        upz = up[2],
        centerx = center[0],
        centery = center[1],
        centerz = center[2];

    if (Math.abs(eyex - centerx) < GLMAT_EPSILON &&
        Math.abs(eyey - centery) < GLMAT_EPSILON &&
        Math.abs(eyez - centerz) < GLMAT_EPSILON) {
        return mat4.identity(out);
    }

    z0 = eyex - centerx;
    z1 = eyey - centery;
    z2 = eyez - centerz;

    len = 1 / Math.sqrt(z0 * z0 + z1 * z1 + z2 * z2);
    z0 *= len;
    z1 *= len;
    z2 *= len;

    x0 = upy * z2 - upz * z1;
    x1 = upz * z0 - upx * z2;
    x2 = upx * z1 - upy * z0;
    len = Math.sqrt(x0 * x0 + x1 * x1 + x2 * x2);
    if (!len) {
        x0 = 0;
        x1 = 0;
        x2 = 0;
    } else {
        len = 1 / len;
        x0 *= len;
        x1 *= len;
        x2 *= len;
    }

    y0 = z1 * x2 - z2 * x1;
    y1 = z2 * x0 - z0 * x2;
    y2 = z0 * x1 - z1 * x0;

    len = Math.sqrt(y0 * y0 + y1 * y1 + y2 * y2);
    if (!len) {
        y0 = 0;
        y1 = 0;
        y2 = 0;
    } else {
        len = 1 / len;
        y0 *= len;
        y1 *= len;
        y2 *= len;
    }

    out[0] = x0;
    out[1] = y0;
    out[2] = z0;
    out[3] = 0;
    out[4] = x1;
    out[5] = y1;
    out[6] = z1;
    out[7] = 0;
    out[8] = x2;
    out[9] = y2;
    out[10] = z2;
    out[11] = 0;
    out[12] = -(x0 * eyex + x1 * eyey + x2 * eyez);
    out[13] = -(y0 * eyex + y1 * eyey + y2 * eyez);
    out[14] = -(z0 * eyex + z1 * eyey + z2 * eyez);
    out[15] = 1;

    return out;
};

/**
 * Returns a string representation of a mat4
 *
 * @param {mat4} mat matrix to represent as a string
 * @returns {String} string representation of the matrix
 */
mat4.str = function (a) {
    return 'mat4(' + a[0] + ', ' + a[1] + ', ' + a[2] + ', ' + a[3] + ', ' +
                    a[4] + ', ' + a[5] + ', ' + a[6] + ', ' + a[7] + ', ' +
                    a[8] + ', ' + a[9] + ', ' + a[10] + ', ' + a[11] + ', ' + 
                    a[12] + ', ' + a[13] + ', ' + a[14] + ', ' + a[15] + ')';
};

/**
 * Returns Frobenius norm of a mat4
 *
 * @param {mat4} a the matrix to calculate Frobenius norm of
 * @returns {Number} Frobenius norm
 */
mat4.frob = function (a) {
    return(Math.sqrt(Math.pow(a[0], 2) + Math.pow(a[1], 2) + Math.pow(a[2], 2) + Math.pow(a[3], 2) + Math.pow(a[4], 2) + Math.pow(a[5], 2) + Math.pow(a[6], 2) + Math.pow(a[6], 2) + Math.pow(a[7], 2) + Math.pow(a[8], 2) + Math.pow(a[9], 2) + Math.pow(a[10], 2) + Math.pow(a[11], 2) + Math.pow(a[12], 2) + Math.pow(a[13], 2) + Math.pow(a[14], 2) + Math.pow(a[15], 2) ))
};


if(typeof(exports) !== 'undefined') {
    exports.mat4 = mat4;
}
;
/* Copyright (c) 2013, Brandon Jones, Colin MacKenzie IV. All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

  * Redistributions of source code must retain the above copyright notice, this
    list of conditions and the following disclaimer.
  * Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation 
    and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE 
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. */

/**
 * @class Quaternion
 * @name quat
 */

var quat = {};

/**
 * Creates a new identity quat
 *
 * @returns {quat} a new quaternion
 */
quat.create = function() {
    var out = new GLMAT_ARRAY_TYPE(4);
    out[0] = 0;
    out[1] = 0;
    out[2] = 0;
    out[3] = 1;
    return out;
};

/**
 * Sets a quaternion to represent the shortest rotation from one
 * vector to another.
 *
 * Both vectors are assumed to be unit length.
 *
 * @param {quat} out the receiving quaternion.
 * @param {vec3} a the initial vector
 * @param {vec3} b the destination vector
 * @returns {quat} out
 */
quat.rotationTo = (function() {
    var tmpvec3 = vec3.create();
    var xUnitVec3 = vec3.fromValues(1,0,0);
    var yUnitVec3 = vec3.fromValues(0,1,0);

    return function(out, a, b) {
        var dot = vec3.dot(a, b);
        if (dot < -0.999999) {
            vec3.cross(tmpvec3, xUnitVec3, a);
            if (vec3.length(tmpvec3) < 0.000001)
                vec3.cross(tmpvec3, yUnitVec3, a);
            vec3.normalize(tmpvec3, tmpvec3);
            quat.setAxisAngle(out, tmpvec3, Math.PI);
            return out;
        } else if (dot > 0.999999) {
            out[0] = 0;
            out[1] = 0;
            out[2] = 0;
            out[3] = 1;
            return out;
        } else {
            vec3.cross(tmpvec3, a, b);
            out[0] = tmpvec3[0];
            out[1] = tmpvec3[1];
            out[2] = tmpvec3[2];
            out[3] = 1 + dot;
            return quat.normalize(out, out);
        }
    };
})();

/**
 * Sets the specified quaternion with values corresponding to the given
 * axes. Each axis is a vec3 and is expected to be unit length and
 * perpendicular to all other specified axes.
 *
 * @param {vec3} view  the vector representing the viewing direction
 * @param {vec3} right the vector representing the local "right" direction
 * @param {vec3} up    the vector representing the local "up" direction
 * @returns {quat} out
 */
quat.setAxes = (function() {
    var matr = mat3.create();

    return function(out, view, right, up) {
        matr[0] = right[0];
        matr[3] = right[1];
        matr[6] = right[2];

        matr[1] = up[0];
        matr[4] = up[1];
        matr[7] = up[2];

        matr[2] = -view[0];
        matr[5] = -view[1];
        matr[8] = -view[2];

        return quat.normalize(out, quat.fromMat3(out, matr));
    };
})();

/**
 * Creates a new quat initialized with values from an existing quaternion
 *
 * @param {quat} a quaternion to clone
 * @returns {quat} a new quaternion
 * @function
 */
quat.clone = vec4.clone;

/**
 * Creates a new quat initialized with the given values
 *
 * @param {Number} x X component
 * @param {Number} y Y component
 * @param {Number} z Z component
 * @param {Number} w W component
 * @returns {quat} a new quaternion
 * @function
 */
quat.fromValues = vec4.fromValues;

/**
 * Copy the values from one quat to another
 *
 * @param {quat} out the receiving quaternion
 * @param {quat} a the source quaternion
 * @returns {quat} out
 * @function
 */
quat.copy = vec4.copy;

/**
 * Set the components of a quat to the given values
 *
 * @param {quat} out the receiving quaternion
 * @param {Number} x X component
 * @param {Number} y Y component
 * @param {Number} z Z component
 * @param {Number} w W component
 * @returns {quat} out
 * @function
 */
quat.set = vec4.set;

/**
 * Set a quat to the identity quaternion
 *
 * @param {quat} out the receiving quaternion
 * @returns {quat} out
 */
quat.identity = function(out) {
    out[0] = 0;
    out[1] = 0;
    out[2] = 0;
    out[3] = 1;
    return out;
};

/**
 * Sets a quat from the given angle and rotation axis,
 * then returns it.
 *
 * @param {quat} out the receiving quaternion
 * @param {vec3} axis the axis around which to rotate
 * @param {Number} rad the angle in radians
 * @returns {quat} out
 **/
quat.setAxisAngle = function(out, axis, rad) {
    rad = rad * 0.5;
    var s = Math.sin(rad);
    out[0] = s * axis[0];
    out[1] = s * axis[1];
    out[2] = s * axis[2];
    out[3] = Math.cos(rad);
    return out;
};

/**
 * Adds two quat's
 *
 * @param {quat} out the receiving quaternion
 * @param {quat} a the first operand
 * @param {quat} b the second operand
 * @returns {quat} out
 * @function
 */
quat.add = vec4.add;

/**
 * Multiplies two quat's
 *
 * @param {quat} out the receiving quaternion
 * @param {quat} a the first operand
 * @param {quat} b the second operand
 * @returns {quat} out
 */
quat.multiply = function(out, a, b) {
    var ax = a[0], ay = a[1], az = a[2], aw = a[3],
        bx = b[0], by = b[1], bz = b[2], bw = b[3];

    out[0] = ax * bw + aw * bx + ay * bz - az * by;
    out[1] = ay * bw + aw * by + az * bx - ax * bz;
    out[2] = az * bw + aw * bz + ax * by - ay * bx;
    out[3] = aw * bw - ax * bx - ay * by - az * bz;
    return out;
};

/**
 * Alias for {@link quat.multiply}
 * @function
 */
quat.mul = quat.multiply;

/**
 * Scales a quat by a scalar number
 *
 * @param {quat} out the receiving vector
 * @param {quat} a the vector to scale
 * @param {Number} b amount to scale the vector by
 * @returns {quat} out
 * @function
 */
quat.scale = vec4.scale;

/**
 * Rotates a quaternion by the given angle about the X axis
 *
 * @param {quat} out quat receiving operation result
 * @param {quat} a quat to rotate
 * @param {number} rad angle (in radians) to rotate
 * @returns {quat} out
 */
quat.rotateX = function (out, a, rad) {
    rad *= 0.5; 

    var ax = a[0], ay = a[1], az = a[2], aw = a[3],
        bx = Math.sin(rad), bw = Math.cos(rad);

    out[0] = ax * bw + aw * bx;
    out[1] = ay * bw + az * bx;
    out[2] = az * bw - ay * bx;
    out[3] = aw * bw - ax * bx;
    return out;
};

/**
 * Rotates a quaternion by the given angle about the Y axis
 *
 * @param {quat} out quat receiving operation result
 * @param {quat} a quat to rotate
 * @param {number} rad angle (in radians) to rotate
 * @returns {quat} out
 */
quat.rotateY = function (out, a, rad) {
    rad *= 0.5; 

    var ax = a[0], ay = a[1], az = a[2], aw = a[3],
        by = Math.sin(rad), bw = Math.cos(rad);

    out[0] = ax * bw - az * by;
    out[1] = ay * bw + aw * by;
    out[2] = az * bw + ax * by;
    out[3] = aw * bw - ay * by;
    return out;
};

/**
 * Rotates a quaternion by the given angle about the Z axis
 *
 * @param {quat} out quat receiving operation result
 * @param {quat} a quat to rotate
 * @param {number} rad angle (in radians) to rotate
 * @returns {quat} out
 */
quat.rotateZ = function (out, a, rad) {
    rad *= 0.5; 

    var ax = a[0], ay = a[1], az = a[2], aw = a[3],
        bz = Math.sin(rad), bw = Math.cos(rad);

    out[0] = ax * bw + ay * bz;
    out[1] = ay * bw - ax * bz;
    out[2] = az * bw + aw * bz;
    out[3] = aw * bw - az * bz;
    return out;
};

/**
 * Calculates the W component of a quat from the X, Y, and Z components.
 * Assumes that quaternion is 1 unit in length.
 * Any existing W component will be ignored.
 *
 * @param {quat} out the receiving quaternion
 * @param {quat} a quat to calculate W component of
 * @returns {quat} out
 */
quat.calculateW = function (out, a) {
    var x = a[0], y = a[1], z = a[2];

    out[0] = x;
    out[1] = y;
    out[2] = z;
    out[3] = -Math.sqrt(Math.abs(1.0 - x * x - y * y - z * z));
    return out;
};

/**
 * Calculates the dot product of two quat's
 *
 * @param {quat} a the first operand
 * @param {quat} b the second operand
 * @returns {Number} dot product of a and b
 * @function
 */
quat.dot = vec4.dot;

/**
 * Performs a linear interpolation between two quat's
 *
 * @param {quat} out the receiving quaternion
 * @param {quat} a the first operand
 * @param {quat} b the second operand
 * @param {Number} t interpolation amount between the two inputs
 * @returns {quat} out
 * @function
 */
quat.lerp = vec4.lerp;

/**
 * Performs a spherical linear interpolation between two quat
 *
 * @param {quat} out the receiving quaternion
 * @param {quat} a the first operand
 * @param {quat} b the second operand
 * @param {Number} t interpolation amount between the two inputs
 * @returns {quat} out
 */
quat.slerp = function (out, a, b, t) {
    // benchmarks:
    //    http://jsperf.com/quaternion-slerp-implementations

    var ax = a[0], ay = a[1], az = a[2], aw = a[3],
        bx = b[0], by = b[1], bz = b[2], bw = b[3];

    var        omega, cosom, sinom, scale0, scale1;

    // calc cosine
    cosom = ax * bx + ay * by + az * bz + aw * bw;
    // adjust signs (if necessary)
    if ( cosom < 0.0 ) {
        cosom = -cosom;
        bx = - bx;
        by = - by;
        bz = - bz;
        bw = - bw;
    }
    // calculate coefficients
    if ( (1.0 - cosom) > 0.000001 ) {
        // standard case (slerp)
        omega  = Math.acos(cosom);
        sinom  = Math.sin(omega);
        scale0 = Math.sin((1.0 - t) * omega) / sinom;
        scale1 = Math.sin(t * omega) / sinom;
    } else {        
        // "from" and "to" quaternions are very close 
        //  ... so we can do a linear interpolation
        scale0 = 1.0 - t;
        scale1 = t;
    }
    // calculate final values
    out[0] = scale0 * ax + scale1 * bx;
    out[1] = scale0 * ay + scale1 * by;
    out[2] = scale0 * az + scale1 * bz;
    out[3] = scale0 * aw + scale1 * bw;
    
    return out;
};

/**
 * Calculates the inverse of a quat
 *
 * @param {quat} out the receiving quaternion
 * @param {quat} a quat to calculate inverse of
 * @returns {quat} out
 */
quat.invert = function(out, a) {
    var a0 = a[0], a1 = a[1], a2 = a[2], a3 = a[3],
        dot = a0*a0 + a1*a1 + a2*a2 + a3*a3,
        invDot = dot ? 1.0/dot : 0;
    
    // TODO: Would be faster to return [0,0,0,0] immediately if dot == 0

    out[0] = -a0*invDot;
    out[1] = -a1*invDot;
    out[2] = -a2*invDot;
    out[3] = a3*invDot;
    return out;
};

/**
 * Calculates the conjugate of a quat
 * If the quaternion is normalized, this function is faster than quat.inverse and produces the same result.
 *
 * @param {quat} out the receiving quaternion
 * @param {quat} a quat to calculate conjugate of
 * @returns {quat} out
 */
quat.conjugate = function (out, a) {
    out[0] = -a[0];
    out[1] = -a[1];
    out[2] = -a[2];
    out[3] = a[3];
    return out;
};

/**
 * Calculates the length of a quat
 *
 * @param {quat} a vector to calculate length of
 * @returns {Number} length of a
 * @function
 */
quat.length = vec4.length;

/**
 * Alias for {@link quat.length}
 * @function
 */
quat.len = quat.length;

/**
 * Calculates the squared length of a quat
 *
 * @param {quat} a vector to calculate squared length of
 * @returns {Number} squared length of a
 * @function
 */
quat.squaredLength = vec4.squaredLength;

/**
 * Alias for {@link quat.squaredLength}
 * @function
 */
quat.sqrLen = quat.squaredLength;

/**
 * Normalize a quat
 *
 * @param {quat} out the receiving quaternion
 * @param {quat} a quaternion to normalize
 * @returns {quat} out
 * @function
 */
quat.normalize = vec4.normalize;

/**
 * Creates a quaternion from the given 3x3 rotation matrix.
 *
 * NOTE: The resultant quaternion is not normalized, so you should be sure
 * to renormalize the quaternion yourself where necessary.
 *
 * @param {quat} out the receiving quaternion
 * @param {mat3} m rotation matrix
 * @returns {quat} out
 * @function
 */
quat.fromMat3 = function(out, m) {
    // Algorithm in Ken Shoemake's article in 1987 SIGGRAPH course notes
    // article "Quaternion Calculus and Fast Animation".
    var fTrace = m[0] + m[4] + m[8];
    var fRoot;

    if ( fTrace > 0.0 ) {
        // |w| > 1/2, may as well choose w > 1/2
        fRoot = Math.sqrt(fTrace + 1.0);  // 2w
        out[3] = 0.5 * fRoot;
        fRoot = 0.5/fRoot;  // 1/(4w)
        out[0] = (m[7]-m[5])*fRoot;
        out[1] = (m[2]-m[6])*fRoot;
        out[2] = (m[3]-m[1])*fRoot;
    } else {
        // |w| <= 1/2
        var i = 0;
        if ( m[4] > m[0] )
          i = 1;
        if ( m[8] > m[i*3+i] )
          i = 2;
        var j = (i+1)%3;
        var k = (i+2)%3;
        
        fRoot = Math.sqrt(m[i*3+i]-m[j*3+j]-m[k*3+k] + 1.0);
        out[i] = 0.5 * fRoot;
        fRoot = 0.5 / fRoot;
        out[3] = (m[k*3+j] - m[j*3+k]) * fRoot;
        out[j] = (m[j*3+i] + m[i*3+j]) * fRoot;
        out[k] = (m[k*3+i] + m[i*3+k]) * fRoot;
    }
    
    return out;
};

/**
 * Returns a string representation of a quatenion
 *
 * @param {quat} vec vector to represent as a string
 * @returns {String} string representation of the vector
 */
quat.str = function (a) {
    return 'quat(' + a[0] + ', ' + a[1] + ', ' + a[2] + ', ' + a[3] + ')';
};

if(typeof(exports) !== 'undefined') {
    exports.quat = quat;
}
;













  })(shim.exports);
})(this);

  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/webgl/math/gl-matrix',_glass_webgl_math_gl_matrix_);
    else
      _glass_webgl_math_gl_matrix_.call(this, module, exports, require);
  }
  else {
    _glass_webgl_math_gl_matrix_.call(this);
  }
}).call(this)
void (function(){var _glass_webgl_math_index_ = function(module,exports,require){'use strict';
var extensionProperties = {};
{
    var _ref = {
            r: 0,
            g: 1,
            b: 2,
            a: 3,
            x: 0,
            y: 1,
            z: 2,
            w: 3
        };
    for (var propertyName in _ref) {
        var index = _ref[propertyName];
        extensionProperties[propertyName] = function (index) {
            return {
                get: function () {
                    return this[index];
                },
                set: function (value) {
                    return this[index] = value;
                },
                configurable: true
            };
        }(index);
    }
}
{
    var _ref2 = [
            Float32Array,
            Int32Array,
            Uint8Array
        ];
    for (var _i = 0; _i < _ref2.length; _i++) {
        var type = _ref2[_i];
        Object.defineProperties(type.prototype, extensionProperties);
    }
}
module.exports = exports = require('./gl-matrix');
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('glass/webgl/math/index',_glass_webgl_math_index_);
    else
      _glass_webgl_math_index_.call(this, module, exports, require);
  }
  else {
    _glass_webgl_math_index_.call(this);
  }
}).call(this)
void (function(){var _viewpath_ScheduleFunctions_ = function(module,exports,require){"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function min(a, b) {
    if (a != null && b != null)
        return a < b ? a : b;
    if (a != null)
        return a;
    if (b != null)
        return b;
    return undefined;
}
function max(a, b) {
    if (a != null && b != null)
        return a > b ? a : b;
    if (a != null)
        return a;
    if (b != null)
        return b;
    return undefined;
}
function addTimeIfMissing(date, endOfDay = false) {
    if (date != null && date.indexOf('T') < 0)
        date += endOfDay ? "T24:00:00" : "T00:00:00";
    return date;
}
const dependencyTypeCharToField = { S: "startWithTime", F: "finishWithTime" };
function getScheduleOptionsFromProject(project) {
    let asap = project.alap ? false : null;
    return new ScheduleOptions(project.plannedStart, null, null, project.plannedFinish, asap);
}
function getScheduleOptionsFromPredecessor(predecessor, dependency) {
    let type = dependency.type || "FS";
    let startMinimum = null;
    let startMaximum = null;
    let finishMinimum = null;
    let finishMaximum = null;
    let predProperty = dependencyTypeCharToField[type[0]];
    let succProperty = dependencyTypeCharToField[type[1]];
    let predDate = predecessor[predProperty];
    if (succProperty == 'startWithTime')
        startMinimum = predDate;
    else
        finishMinimum = predDate;
    return new ScheduleOptions(startMinimum, startMaximum, finishMinimum, finishMaximum);
}
function getScheduleOptionsFromSuccessor(successor, dependency) {
    let type = dependency.type || "FS";
    let startMinimum = null;
    let startMaximum = null;
    let finishMinimum = null;
    let finishMaximum = null;
    let predProperty = dependencyTypeCharToField[type[0]];
    let succProperty = dependencyTypeCharToField[type[1]];
    let succDate = successor[succProperty];
    if (predProperty == 'startWithTime')
        startMaximum = succDate;
    else
        finishMaximum = succDate;
    return new ScheduleOptions(startMinimum, startMaximum, finishMinimum, finishMaximum);
}
function getScheduleOptionsFromTaskConstraints(task) {
    let startMinimum = null;
    let startMaximum = null;
    let finishMinimum = null;
    let finishMaximum = null;
    let asap = null;
    let constraint = task.ScheduleConstraint;
    if (constraint != null) {
        if (constraint.asap || constraint.alap)
            asap = constraint.asap == true;
        if (constraint.date && task.scheduleDate) {
            let date = task.scheduleDate;
            if (constraint.start) {
                if (!constraint.earlier)
                    startMinimum = date;
                if (!constraint.later)
                    startMaximum = date;
            }
            if (constraint.finish) {
                if (!constraint.earlier)
                    finishMinimum = date;
                if (!constraint.later)
                    finishMaximum = date;
            }
        }
    }
    return new ScheduleOptions(startMinimum, startMaximum, finishMinimum, finishMaximum, asap);
}
function combine(a, b) {
    return new ScheduleOptions(max(a.startMinimum, b.startMinimum), min(a.startMaximum, b.startMaximum), max(a.finishMinimum, b.finishMinimum), min(a.finishMaximum, b.finishMaximum), a.asap != null ? a.asap : b.asap);
}
class ScheduleOptions {
    constructor(startMinimum = null, startMaximum = null, finishMinimum = null, finishMaximum = null, asap = null) {
        this.startMinimum = addTimeIfMissing(startMinimum);
        this.startMaximum = addTimeIfMissing(startMaximum, true);
        this.finishMinimum = addTimeIfMissing(finishMinimum);
        this.finishMaximum = addTimeIfMissing(finishMaximum, true);
        this.asap = asap;
    }
    static calculate(task, project, ancestors, predecessors, successors) {
        let options = getScheduleOptionsFromTaskConstraints(task);
        for (let ancestor of ancestors) {
            options = combine(options, getScheduleOptionsFromTaskConstraints(ancestor));
        }
        options = combine(options, getScheduleOptionsFromProject(project));
        if (options.asap == null)
            throw new Error("asap missing");
        if (options.asap) {
            if (task.predecessors) {
                for (let key in task.predecessors) {
                    let dependency = task.predecessors[key];
                    let predecessor = predecessors[key];
                    if (predecessor) {
                        options = combine(options, getScheduleOptionsFromPredecessor(predecessor, dependency));
                    }
                }
            }
        }
        else {
            for (let key in successors) {
                let successor = successors[key];
                if (successor && successor.predecessors) {
                    let dependency = successor.predecessors[key];
                    if (dependency) {
                        options = combine(options, getScheduleOptionsFromSuccessor(successor, dependency));
                    }
                }
            }
        }
        return options;
    }
}
exports.ScheduleOptions = ScheduleOptions;
function test() {
    function assert(name, actual, expected) {
        if (JSON.stringify(actual) !== JSON.stringify(expected)) {
            console.log({ expected, actual });
            throw new Error(name + " assertion failed");
        }
    }
    assert("predecessor type:null", getScheduleOptionsFromPredecessor({ startWithTime: "2018-12-09T00:00:00", finishWithTime: "2018-12-11T24:00:00" }, {}), { "startMinimum": "2018-12-11T24:00:00", "startMaximum": null, "finishMinimum": null, "finishMaximum": null, "asap": null });
    assert("predecessor type:FS", getScheduleOptionsFromPredecessor({ startWithTime: "2018-12-09T00:00:00", finishWithTime: "2018-12-11T24:00:00" }, { type: "FS" }), { "startMinimum": "2018-12-11T24:00:00", "startMaximum": null, "finishMinimum": null, "finishMaximum": null, "asap": null });
    assert("predecessor type:SS", getScheduleOptionsFromPredecessor({ startWithTime: "2018-12-09T00:00:00", finishWithTime: "2018-12-11T24:00:00" }, { type: "SS" }), { "startMinimum": "2018-12-09T00:00:00", "startMaximum": null, "finishMinimum": null, "finishMaximum": null, "asap": null });
    assert("predecessor type:FF", getScheduleOptionsFromPredecessor({ startWithTime: "2018-12-09T00:00:00", finishWithTime: "2018-12-11T24:00:00" }, { type: "FF" }), { "startMinimum": null, "startMaximum": null, "finishMinimum": "2018-12-11T24:00:00", "finishMaximum": null, "asap": null });
    assert("predecessor type:SF", getScheduleOptionsFromPredecessor({ startWithTime: "2018-12-09T00:00:00", finishWithTime: "2018-12-11T24:00:00" }, { type: "SF" }), { "startMinimum": null, "startMaximum": null, "finishMinimum": "2018-12-09T00:00:00", "finishMaximum": null, "asap": null });
    assert("successor type:null", getScheduleOptionsFromSuccessor({ startWithTime: "2018-12-09T00:00:00", finishWithTime: "2018-12-11T24:00:00" }, {}), { "startMinimum": null, "startMaximum": null, "finishMinimum": null, "finishMaximum": "2018-12-09T00:00:00", "asap": null });
    assert("successor type:FS", getScheduleOptionsFromSuccessor({ startWithTime: "2018-12-09T00:00:00", finishWithTime: "2018-12-11T24:00:00" }, { type: "FS" }), { "startMinimum": null, "startMaximum": null, "finishMinimum": null, "finishMaximum": "2018-12-09T00:00:00", "asap": null });
    assert("successor type:SS", getScheduleOptionsFromSuccessor({ startWithTime: "2018-12-09T00:00:00", finishWithTime: "2018-12-11T24:00:00" }, { type: "SS" }), { "startMinimum": null, "startMaximum": "2018-12-09T00:00:00", "finishMinimum": null, "finishMaximum": null, "asap": null });
    assert("successor type:FF", getScheduleOptionsFromSuccessor({ startWithTime: "2018-12-09T00:00:00", finishWithTime: "2018-12-11T24:00:00" }, { type: "FF" }), { "startMinimum": null, "startMaximum": null, "finishMinimum": null, "finishMaximum": "2018-12-11T24:00:00", "asap": null });
    assert("successor type:SF", getScheduleOptionsFromSuccessor({ startWithTime: "2018-12-09T00:00:00", finishWithTime: "2018-12-11T24:00:00" }, { type: "SF" }), { "startMinimum": null, "startMaximum": "2018-12-11T24:00:00", "finishMinimum": null, "finishMaximum": null, "asap": null });
}
exports.test = test;
//# sourceMappingURL=ScheduleFunctions.js.map
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/ScheduleFunctions',_viewpath_ScheduleFunctions_);
    else
      _viewpath_ScheduleFunctions_.call(this, module, exports, require);
  }
  else {
    _viewpath_ScheduleFunctions_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_AdminProperty_ = function(module,exports,require){'use strict';
module.exports = exports = function AdminProperty(org) {
    return {
        get: function () {
            return org.admins[this.key] != null;
        },
        set: function (value) {
            if (org.admins[this.key] != null ? org.admins[this.key].owner : void 0) {
                return;
            }
            if (!value) {
                delete org.admins[this.key];
            } else {
                org.admins[this.key] = {};
            }
            this.touch();
        },
        visible: true,
        name: 'admin',
        type: 'boolean',
        editable: false,
        required: false
    };
};
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/AdminProperty',_viewpath_html_AdminProperty_);
    else
      _viewpath_html_AdminProperty_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_AdminProperty_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_Application_ = function(module,exports,require){'use strict';
var ion = require('ion'), glass = require('glass'), viewpath = require('../'), _ref, _ref2, _ref3, _ref4, _ref5, _ref6;
_ref = glass.data;
var Key = _ref.Key;
_ref2 = viewpath.model;
var User = _ref2.User;
var Task = _ref2.Task;
var Project = _ref2.Project;
_ref3 = require('./');
var NavDrawer = _ref3.NavDrawer;
var SetupWizard = _ref3.SetupWizard;
_ref4 = glass.html.material;
var Icon = _ref4.Icon;
var Button = _ref4.Button;
var Resizer = _ref4.Resizer;
var SearchButton = _ref4.SearchButton;
var RecordSearchSuggestions = _ref4.RecordSearchSuggestions;
var Toaster = _ref4.Toaster;
var Dialog = _ref4.Dialog;
var PromptDialog = _ref4.PromptDialog;
_ref5 = glass.html;
var style = _ref5.style;
_ref6 = glass.html.functions;
var focusDescendant = _ref6.focusDescendant;
var _ref12 = style.sheets;
_ref12[module.id] = '.PaneResizer {\n    position: relative;\n    overflow: hidden;\n}\n.PaneResizer > DIV {\n    position: absolute;\n    height: 100vh;\n    margin: 0px;\n}';
_ref12;
var PaneResizer = ion.template(function PaneResizer(args) {
        return ion.createRuntime({
            type: 'Template',
            id: {
                type: 'Identifier',
                name: 'PaneResizer',
                loc: {
                    start: {
                        line: 25,
                        column: 29,
                        fixed: true,
                        source: 'viewpath/html/Application.ion'
                    },
                    end: {
                        line: 25,
                        column: 40,
                        fixed: true,
                        source: 'viewpath/html/Application.ion'
                    }
                }
            },
            body: [
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'width',
                                loc: {
                                    start: {
                                        line: 26,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/html/Application.ion'
                                    },
                                    end: {
                                        line: 26,
                                        column: 13,
                                        fixed: true,
                                        source: 'viewpath/html/Application.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'Literal',
                                value: 8
                            }
                        }],
                    kind: 'let',
                    order: '0'
                },
                {
                    type: 'ReturnStatement',
                    argument: {
                        type: 'ObjectExpression',
                        objectType: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Resizer',
                                loc: {
                                    start: {
                                        line: 27,
                                        column: 11,
                                        fixed: true,
                                        source: 'viewpath/html/Application.ion'
                                    },
                                    end: {
                                        line: 27,
                                        column: 18,
                                        fixed: true,
                                        source: 'viewpath/html/Application.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'Identifier',
                                    name: 'args',
                                    loc: {
                                        start: {
                                            line: 27,
                                            column: 19,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        },
                                        end: {
                                            line: 27,
                                            column: 23,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        }
                                    }
                                }],
                            loc: {
                                start: {
                                    line: 27,
                                    column: 11,
                                    fixed: true,
                                    source: 'viewpath/html/Application.ion'
                                },
                                end: {
                                    line: 27,
                                    column: 24,
                                    fixed: true,
                                    source: 'viewpath/html/Application.ion'
                                }
                            }
                        },
                        properties: [
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'style',
                                    loc: {
                                        start: {
                                            line: 28,
                                            column: 8,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        },
                                        end: {
                                            line: 28,
                                            column: 13,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'ObjectExpression',
                                    properties: [{
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'width',
                                                loc: {
                                                    start: {
                                                        line: 29,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/Application.ion'
                                                    },
                                                    end: {
                                                        line: 29,
                                                        column: 17,
                                                        fixed: true,
                                                        source: 'viewpath/html/Application.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'BinaryExpression',
                                                operator: '+',
                                                left: {
                                                    type: 'BinaryExpression',
                                                    operator: '+',
                                                    left: {
                                                        type: 'Literal',
                                                        value: ''
                                                    },
                                                    right: {
                                                        type: 'Identifier',
                                                        name: 'width',
                                                        loc: {
                                                            start: {
                                                                line: 29,
                                                                column: 22,
                                                                fixed: true,
                                                                source: 'viewpath/html/Application.ion'
                                                            },
                                                            end: {
                                                                line: 29,
                                                                column: 27,
                                                                fixed: true,
                                                                source: 'viewpath/html/Application.ion'
                                                            }
                                                        }
                                                    }
                                                },
                                                right: {
                                                    type: 'Literal',
                                                    value: 'px'
                                                }
                                            },
                                            kind: 'init',
                                            order: '0'
                                        }]
                                },
                                kind: 'init',
                                order: '0'
                            },
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'classList',
                                    loc: {
                                        start: {
                                            line: 30,
                                            column: 8,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        },
                                        end: {
                                            line: 30,
                                            column: 17,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'ObjectExpression',
                                    properties: [
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'Literal',
                                                value: 'fixed'
                                            },
                                            loc: {
                                                start: {
                                                    line: 31,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/Application.ion'
                                                },
                                                end: {
                                                    line: 31,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'viewpath/html/Application.ion'
                                                }
                                            },
                                            order: '0'
                                        },
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'Literal',
                                                value: 'PaneResizer'
                                            },
                                            loc: {
                                                start: {
                                                    line: 32,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/Application.ion'
                                                },
                                                end: {
                                                    line: 32,
                                                    column: 25,
                                                    fixed: true,
                                                    source: 'viewpath/html/Application.ion'
                                                }
                                            },
                                            order: '1'
                                        }
                                    ]
                                },
                                kind: 'init',
                                order: '1'
                            }
                        ]
                    },
                    order: '1'
                }
            ],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'PaneResizer',
                loc: {
                    start: {
                        line: 25,
                        column: 6,
                        fixed: true,
                        source: 'viewpath/html/Application.ion'
                    },
                    end: {
                        line: 25,
                        column: 17,
                        fixed: true,
                        source: 'viewpath/html/Application.ion'
                    }
                }
            }
        }, {
            this: this,
            args: args,
            ion: ion,
            glass: glass,
            viewpath: viewpath,
            _ref: _ref,
            _ref2: _ref2,
            _ref3: _ref3,
            _ref4: _ref4,
            _ref5: _ref5,
            _ref6: _ref6,
            Key: Key,
            User: User,
            Task: Task,
            Project: Project,
            NavDrawer: NavDrawer,
            SetupWizard: SetupWizard,
            Icon: Icon,
            Button: Button,
            Resizer: Resizer,
            SearchButton: SearchButton,
            RecordSearchSuggestions: RecordSearchSuggestions,
            Toaster: Toaster,
            Dialog: Dialog,
            PromptDialog: PromptDialog,
            style: style,
            focusDescendant: focusDescendant,
            _ref12: _ref12,
            PaneResizer: PaneResizer,
            PaneBar: PaneBar,
            PaneName: PaneName,
            PaneFrame: PaneFrame
        }, null);
    });
var PaneBar = ion.template(function PaneBar() {
        return ion.createRuntime({
            type: 'Template',
            id: {
                type: 'Identifier',
                name: 'PaneBar',
                loc: {
                    start: {
                        line: 34,
                        column: 25,
                        fixed: true,
                        source: 'viewpath/html/Application.ion'
                    },
                    end: {
                        line: 34,
                        column: 32,
                        fixed: true,
                        source: 'viewpath/html/Application.ion'
                    }
                }
            },
            body: [{
                    type: 'ReturnStatement',
                    argument: {
                        type: 'ObjectExpression',
                        objectType: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Header',
                                loc: {
                                    start: {
                                        line: 35,
                                        column: 11,
                                        fixed: true,
                                        source: 'viewpath/html/Application.ion'
                                    },
                                    end: {
                                        line: 35,
                                        column: 17,
                                        fixed: true,
                                        source: 'viewpath/html/Application.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ObjectExpression',
                                    properties: [{
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'class',
                                                loc: {
                                                    start: {
                                                        line: 35,
                                                        column: 19,
                                                        fixed: true,
                                                        source: 'viewpath/html/Application.ion'
                                                    },
                                                    end: {
                                                        line: 35,
                                                        column: 24,
                                                        fixed: true,
                                                        source: 'viewpath/html/Application.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: 'app-bar'
                                            },
                                            kind: 'init',
                                            order: '0'
                                        }]
                                }],
                            loc: {
                                start: {
                                    line: 35,
                                    column: 11,
                                    fixed: true,
                                    source: 'viewpath/html/Application.ion'
                                },
                                end: {
                                    line: 35,
                                    column: 36,
                                    fixed: true,
                                    source: 'viewpath/html/Application.ion'
                                }
                            }
                        },
                        properties: [
                            {
                                type: 'VariableDeclaration',
                                declarations: [{
                                        type: 'VariableDeclarator',
                                        id: {
                                            type: 'Identifier',
                                            name: 'left',
                                            loc: {
                                                start: {
                                                    line: 36,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/Application.ion'
                                                },
                                                end: {
                                                    line: 36,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/Application.ion'
                                                }
                                            }
                                        },
                                        init: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'Identifier',
                                                name: 'Section',
                                                loc: {
                                                    start: {
                                                        line: 36,
                                                        column: 19,
                                                        fixed: true,
                                                        source: 'viewpath/html/Application.ion'
                                                    },
                                                    end: {
                                                        line: 36,
                                                        column: 26,
                                                        fixed: true,
                                                        source: 'viewpath/html/Application.ion'
                                                    }
                                                }
                                            },
                                            arguments: [{
                                                    type: 'ObjectExpression',
                                                    properties: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'class',
                                                                loc: {
                                                                    start: {
                                                                        line: 36,
                                                                        column: 28,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/Application.ion'
                                                                    },
                                                                    end: {
                                                                        line: 36,
                                                                        column: 33,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/Application.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Literal',
                                                                value: 'fixed layout horizontal'
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                }],
                                            loc: {
                                                start: {
                                                    line: 36,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'viewpath/html/Application.ion'
                                                },
                                                end: {
                                                    line: 36,
                                                    column: 61,
                                                    fixed: true,
                                                    source: 'viewpath/html/Application.ion'
                                                }
                                            }
                                        }
                                    }],
                                kind: 'let',
                                order: '0'
                            },
                            {
                                type: 'VariableDeclaration',
                                declarations: [{
                                        type: 'VariableDeclarator',
                                        id: {
                                            type: 'Identifier',
                                            name: 'center',
                                            loc: {
                                                start: {
                                                    line: 37,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/Application.ion'
                                                },
                                                end: {
                                                    line: 37,
                                                    column: 18,
                                                    fixed: true,
                                                    source: 'viewpath/html/Application.ion'
                                                }
                                            }
                                        },
                                        init: {
                                            type: 'ObjectExpression',
                                            objectType: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'Section',
                                                    loc: {
                                                        start: {
                                                            line: 37,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'viewpath/html/Application.ion'
                                                        },
                                                        end: {
                                                            line: 37,
                                                            column: 28,
                                                            fixed: true,
                                                            source: 'viewpath/html/Application.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [{
                                                        type: 'ObjectExpression',
                                                        properties: [{
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'class',
                                                                    loc: {
                                                                        start: {
                                                                            line: 37,
                                                                            column: 30,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/Application.ion'
                                                                        },
                                                                        end: {
                                                                            line: 37,
                                                                            column: 35,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/Application.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: 'flex layout horizontal'
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            }]
                                                    }],
                                                loc: {
                                                    start: {
                                                        line: 37,
                                                        column: 21,
                                                        fixed: true,
                                                        source: 'viewpath/html/Application.ion'
                                                    },
                                                    end: {
                                                        line: 37,
                                                        column: 62,
                                                        fixed: true,
                                                        source: 'viewpath/html/Application.ion'
                                                    }
                                                }
                                            },
                                            properties: [{
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'style',
                                                        loc: {
                                                            start: {
                                                                line: 38,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'viewpath/html/Application.ion'
                                                            },
                                                            end: {
                                                                line: 38,
                                                                column: 17,
                                                                fixed: true,
                                                                source: 'viewpath/html/Application.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'ObjectExpression',
                                                        properties: [
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Literal',
                                                                    value: 'overflow'
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: 'hidden'
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'paddingLeft',
                                                                    loc: {
                                                                        start: {
                                                                            line: 40,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/Application.ion'
                                                                        },
                                                                        end: {
                                                                            line: 40,
                                                                            column: 27,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/Application.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '+',
                                                                    left: {
                                                                        type: 'BinaryExpression',
                                                                        operator: '+',
                                                                        left: {
                                                                            type: 'Literal',
                                                                            value: ''
                                                                        },
                                                                        right: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'Identifier',
                                                                                    name: 'style',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 40,
                                                                                            column: 32,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 40,
                                                                                            column: 37,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'spacing',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 40,
                                                                                            column: 38,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 40,
                                                                                            column: 45,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 40,
                                                                                        column: 32,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 40,
                                                                                        column: 45,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'buffer',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 40,
                                                                                        column: 46,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 40,
                                                                                        column: 52,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 40,
                                                                                    column: 32,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Application.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 40,
                                                                                    column: 52,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Application.ion'
                                                                                }
                                                                            }
                                                                        }
                                                                    },
                                                                    right: {
                                                                        type: 'Literal',
                                                                        value: 'px'
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '1'
                                                            }
                                                        ]
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                }]
                                        }
                                    }],
                                kind: 'let',
                                order: '1'
                            },
                            {
                                type: 'VariableDeclaration',
                                declarations: [{
                                        type: 'VariableDeclarator',
                                        id: {
                                            type: 'Identifier',
                                            name: 'right',
                                            loc: {
                                                start: {
                                                    line: 41,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/Application.ion'
                                                },
                                                end: {
                                                    line: 41,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'viewpath/html/Application.ion'
                                                }
                                            }
                                        },
                                        init: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'Identifier',
                                                name: 'Section',
                                                loc: {
                                                    start: {
                                                        line: 41,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'viewpath/html/Application.ion'
                                                    },
                                                    end: {
                                                        line: 41,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'viewpath/html/Application.ion'
                                                    }
                                                }
                                            },
                                            arguments: [{
                                                    type: 'ObjectExpression',
                                                    properties: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'class',
                                                                loc: {
                                                                    start: {
                                                                        line: 41,
                                                                        column: 29,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/Application.ion'
                                                                    },
                                                                    end: {
                                                                        line: 41,
                                                                        column: 34,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/Application.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Literal',
                                                                value: 'fixed layout horizontal'
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                }],
                                            loc: {
                                                start: {
                                                    line: 41,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'viewpath/html/Application.ion'
                                                },
                                                end: {
                                                    line: 41,
                                                    column: 62,
                                                    fixed: true,
                                                    source: 'viewpath/html/Application.ion'
                                                }
                                            }
                                        }
                                    }],
                                kind: 'let',
                                order: '2'
                            },
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'left',
                                    loc: {
                                        start: {
                                            line: 42,
                                            column: 8,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        },
                                        end: {
                                            line: 42,
                                            column: 12,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'Identifier',
                                    name: 'left',
                                    loc: {
                                        start: {
                                            line: 42,
                                            column: 14,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        },
                                        end: {
                                            line: 42,
                                            column: 18,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        }
                                    }
                                },
                                kind: 'init',
                                order: '3'
                            },
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'center',
                                    loc: {
                                        start: {
                                            line: 43,
                                            column: 8,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        },
                                        end: {
                                            line: 43,
                                            column: 14,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'Identifier',
                                    name: 'center',
                                    loc: {
                                        start: {
                                            line: 43,
                                            column: 16,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        },
                                        end: {
                                            line: 43,
                                            column: 22,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        }
                                    }
                                },
                                kind: 'init',
                                order: '4'
                            },
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'right',
                                    loc: {
                                        start: {
                                            line: 44,
                                            column: 8,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        },
                                        end: {
                                            line: 44,
                                            column: 13,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'Identifier',
                                    name: 'right',
                                    loc: {
                                        start: {
                                            line: 44,
                                            column: 15,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        },
                                        end: {
                                            line: 44,
                                            column: 20,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        }
                                    }
                                },
                                kind: 'init',
                                order: '5'
                            },
                            {
                                type: 'ExpressionStatement',
                                expression: {
                                    type: 'Identifier',
                                    name: 'left',
                                    loc: {
                                        start: {
                                            line: 45,
                                            column: 8,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        },
                                        end: {
                                            line: 45,
                                            column: 12,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 45,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/html/Application.ion'
                                    },
                                    end: {
                                        line: 45,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/Application.ion'
                                    }
                                },
                                order: '6'
                            },
                            {
                                type: 'ExpressionStatement',
                                expression: {
                                    type: 'Identifier',
                                    name: 'center',
                                    loc: {
                                        start: {
                                            line: 46,
                                            column: 8,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        },
                                        end: {
                                            line: 46,
                                            column: 14,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 46,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/html/Application.ion'
                                    },
                                    end: {
                                        line: 46,
                                        column: 14,
                                        fixed: true,
                                        source: 'viewpath/html/Application.ion'
                                    }
                                },
                                order: '7'
                            },
                            {
                                type: 'ExpressionStatement',
                                expression: {
                                    type: 'Identifier',
                                    name: 'right',
                                    loc: {
                                        start: {
                                            line: 47,
                                            column: 8,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        },
                                        end: {
                                            line: 47,
                                            column: 13,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 47,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/html/Application.ion'
                                    },
                                    end: {
                                        line: 47,
                                        column: 13,
                                        fixed: true,
                                        source: 'viewpath/html/Application.ion'
                                    }
                                },
                                order: '8'
                            }
                        ]
                    },
                    order: '0'
                }],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'PaneBar',
                loc: {
                    start: {
                        line: 34,
                        column: 6,
                        fixed: true,
                        source: 'viewpath/html/Application.ion'
                    },
                    end: {
                        line: 34,
                        column: 13,
                        fixed: true,
                        source: 'viewpath/html/Application.ion'
                    }
                }
            }
        }, {
            this: this,
            ion: ion,
            glass: glass,
            viewpath: viewpath,
            _ref: _ref,
            _ref2: _ref2,
            _ref3: _ref3,
            _ref4: _ref4,
            _ref5: _ref5,
            _ref6: _ref6,
            Key: Key,
            User: User,
            Task: Task,
            Project: Project,
            NavDrawer: NavDrawer,
            SetupWizard: SetupWizard,
            Icon: Icon,
            Button: Button,
            Resizer: Resizer,
            SearchButton: SearchButton,
            RecordSearchSuggestions: RecordSearchSuggestions,
            Toaster: Toaster,
            Dialog: Dialog,
            PromptDialog: PromptDialog,
            style: style,
            focusDescendant: focusDescendant,
            _ref12: _ref12,
            PaneResizer: PaneResizer,
            PaneBar: PaneBar,
            PaneName: PaneName,
            PaneFrame: PaneFrame
        }, null);
    });
var PaneName = ion.template(function PaneName(name) {
        return ion.createRuntime({
            type: 'Template',
            id: {
                type: 'Identifier',
                name: 'PaneName',
                loc: {
                    start: {
                        line: 49,
                        column: 26,
                        fixed: true,
                        source: 'viewpath/html/Application.ion'
                    },
                    end: {
                        line: 49,
                        column: 34,
                        fixed: true,
                        source: 'viewpath/html/Application.ion'
                    }
                }
            },
            body: [{
                    type: 'ReturnStatement',
                    argument: {
                        type: 'ObjectExpression',
                        objectType: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Span',
                                loc: {
                                    start: {
                                        line: 50,
                                        column: 11,
                                        fixed: true,
                                        source: 'viewpath/html/Application.ion'
                                    },
                                    end: {
                                        line: 50,
                                        column: 15,
                                        fixed: true,
                                        source: 'viewpath/html/Application.ion'
                                    }
                                }
                            },
                            arguments: [],
                            loc: {
                                start: {
                                    line: 50,
                                    column: 11,
                                    fixed: true,
                                    source: 'viewpath/html/Application.ion'
                                },
                                end: {
                                    line: 50,
                                    column: 17,
                                    fixed: true,
                                    source: 'viewpath/html/Application.ion'
                                }
                            }
                        },
                        properties: [
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'style',
                                    loc: {
                                        start: {
                                            line: 51,
                                            column: 8,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        },
                                        end: {
                                            line: 51,
                                            column: 13,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'ObjectExpression',
                                    properties: [
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Literal',
                                                value: 'white-space'
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: 'nowrap'
                                            },
                                            kind: 'init',
                                            order: '0'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Literal',
                                                value: 'overflow'
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: 'hidden'
                                            },
                                            kind: 'init',
                                            order: '1'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Literal',
                                                value: 'text-overflow'
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: 'ellipsis'
                                            },
                                            kind: 'init',
                                            order: '2'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'padding',
                                                loc: {
                                                    start: {
                                                        line: 55,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/Application.ion'
                                                    },
                                                    end: {
                                                        line: 55,
                                                        column: 19,
                                                        fixed: true,
                                                        source: 'viewpath/html/Application.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: '2px'
                                            },
                                            kind: 'init',
                                            order: '3'
                                        }
                                    ]
                                },
                                kind: 'init',
                                order: '0'
                            },
                            {
                                type: 'IfStatement',
                                test: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'Array',
                                            loc: {
                                                start: {
                                                    line: 56,
                                                    column: 11,
                                                    fixed: true,
                                                    source: 'viewpath/html/Application.ion'
                                                },
                                                end: {
                                                    line: 56,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/Application.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'isArray',
                                            loc: {
                                                start: {
                                                    line: 56,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'viewpath/html/Application.ion'
                                                },
                                                end: {
                                                    line: 56,
                                                    column: 24,
                                                    fixed: true,
                                                    source: 'viewpath/html/Application.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 56,
                                                column: 11,
                                                fixed: true,
                                                source: 'viewpath/html/Application.ion'
                                            },
                                            end: {
                                                line: 56,
                                                column: 24,
                                                fixed: true,
                                                source: 'viewpath/html/Application.ion'
                                            }
                                        }
                                    },
                                    arguments: [{
                                            type: 'Identifier',
                                            name: 'name',
                                            loc: {
                                                start: {
                                                    line: 56,
                                                    column: 25,
                                                    fixed: true,
                                                    source: 'viewpath/html/Application.ion'
                                                },
                                                end: {
                                                    line: 56,
                                                    column: 29,
                                                    fixed: true,
                                                    source: 'viewpath/html/Application.ion'
                                                }
                                            }
                                        }],
                                    loc: {
                                        start: {
                                            line: 56,
                                            column: 11,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        },
                                        end: {
                                            line: 56,
                                            column: 30,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        }
                                    }
                                },
                                consequent: {
                                    type: 'BlockStatement',
                                    body: [{
                                            type: 'ForOfStatement',
                                            left: {
                                                type: 'VariableDeclaration',
                                                declarations: [
                                                    {
                                                        type: 'VariableDeclarator',
                                                        id: {
                                                            type: 'Identifier',
                                                            name: 'part',
                                                            loc: {
                                                                start: {
                                                                    line: 57,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/Application.ion'
                                                                },
                                                                end: {
                                                                    line: 57,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/Application.ion'
                                                                }
                                                            }
                                                        },
                                                        init: null
                                                    },
                                                    {
                                                        type: 'VariableDeclarator',
                                                        id: {
                                                            type: 'Identifier',
                                                            name: 'index',
                                                            loc: {
                                                                start: {
                                                                    line: 57,
                                                                    column: 22,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/Application.ion'
                                                                },
                                                                end: {
                                                                    line: 57,
                                                                    column: 27,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/Application.ion'
                                                                }
                                                            }
                                                        },
                                                        init: null
                                                    }
                                                ],
                                                kind: 'let'
                                            },
                                            right: {
                                                type: 'Identifier',
                                                name: 'name',
                                                loc: {
                                                    start: {
                                                        line: 57,
                                                        column: 31,
                                                        fixed: true,
                                                        source: 'viewpath/html/Application.ion'
                                                    },
                                                    end: {
                                                        line: 57,
                                                        column: 35,
                                                        fixed: true,
                                                        source: 'viewpath/html/Application.ion'
                                                    }
                                                }
                                            },
                                            body: {
                                                type: 'BlockStatement',
                                                body: [
                                                    {
                                                        type: 'IfStatement',
                                                        test: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'part',
                                                                loc: {
                                                                    start: {
                                                                        line: 58,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/Application.ion'
                                                                    },
                                                                    end: {
                                                                        line: 58,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/Application.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'nodeType',
                                                                loc: {
                                                                    start: {
                                                                        line: 58,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/Application.ion'
                                                                    },
                                                                    end: {
                                                                        line: 58,
                                                                        column: 32,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/Application.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 58,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/Application.ion'
                                                                },
                                                                end: {
                                                                    line: 58,
                                                                    column: 32,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/Application.ion'
                                                                }
                                                            }
                                                        },
                                                        consequent: {
                                                            type: 'BlockStatement',
                                                            body: [{
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'Identifier',
                                                                        name: 'part',
                                                                        loc: {
                                                                            start: {
                                                                                line: 59,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Application.ion'
                                                                            },
                                                                            end: {
                                                                                line: 59,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Application.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 59,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/Application.ion'
                                                                        },
                                                                        end: {
                                                                            line: 59,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/Application.ion'
                                                                        }
                                                                    },
                                                                    order: '0'
                                                                }]
                                                        },
                                                        alternate: {
                                                            type: 'BlockStatement',
                                                            body: [{
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'ObjectExpression',
                                                                        objectType: {
                                                                            type: 'CallExpression',
                                                                            callee: {
                                                                                type: 'Identifier',
                                                                                name: 'Span',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 61,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 61,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            arguments: [],
                                                                            loc: {
                                                                                start: {
                                                                                    line: 61,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Application.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 61,
                                                                                    column: 26,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Application.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        properties: [{
                                                                                type: 'IfStatement',
                                                                                test: {
                                                                                    type: 'BinaryExpression',
                                                                                    operator: '===',
                                                                                    left: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'part',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 62,
                                                                                                    column: 27,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 62,
                                                                                                    column: 31,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'constructor',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 62,
                                                                                                    column: 32,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 62,
                                                                                                    column: 43,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 62,
                                                                                                column: 27,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 62,
                                                                                                column: 43,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    right: {
                                                                                        type: 'Identifier',
                                                                                        name: 'Object',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 62,
                                                                                                column: 47,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 62,
                                                                                                column: 53,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                },
                                                                                consequent: {
                                                                                    type: 'BlockStatement',
                                                                                    body: [
                                                                                        {
                                                                                            type: 'ExpressionStatement',
                                                                                            expression: {
                                                                                                type: 'Function',
                                                                                                context: true,
                                                                                                value: function (_context) {
                                                                                                    return function click() {
                                                                                                        var part = _context.get('part');
                                                                                                        return model.open(part.paneConfig, { replace: true });
                                                                                                    };
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 63,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 63,
                                                                                                    column: 82,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                }
                                                                                            },
                                                                                            order: '0'
                                                                                        },
                                                                                        {
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'style',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 64,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 64,
                                                                                                        column: 33,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'ObjectExpression',
                                                                                                properties: [
                                                                                                    {
                                                                                                        type: 'Property',
                                                                                                        key: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'borderBottom',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 65,
                                                                                                                    column: 32,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 65,
                                                                                                                    column: 44,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        value: {
                                                                                                            type: 'BinaryExpression',
                                                                                                            operator: '+',
                                                                                                            left: {
                                                                                                                type: 'Literal',
                                                                                                                value: '2px solid '
                                                                                                            },
                                                                                                            right: {
                                                                                                                type: 'CallExpression',
                                                                                                                callee: {
                                                                                                                    type: 'MemberExpression',
                                                                                                                    computed: false,
                                                                                                                    object: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'style',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 65,
                                                                                                                                column: 59,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 65,
                                                                                                                                column: 64,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    property: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'toRgba',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 65,
                                                                                                                                column: 65,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 65,
                                                                                                                                column: 71,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 65,
                                                                                                                            column: 59,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 65,
                                                                                                                            column: 71,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                arguments: [
                                                                                                                    {
                                                                                                                        type: 'MemberExpression',
                                                                                                                        computed: false,
                                                                                                                        object: {
                                                                                                                            type: 'MemberExpression',
                                                                                                                            computed: false,
                                                                                                                            object: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'style',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 65,
                                                                                                                                        column: 72,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 65,
                                                                                                                                        column: 77,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            property: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'color',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 65,
                                                                                                                                        column: 78,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 65,
                                                                                                                                        column: 83,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 65,
                                                                                                                                    column: 72,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 65,
                                                                                                                                    column: 83,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        property: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'white',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 65,
                                                                                                                                    column: 84,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 65,
                                                                                                                                    column: 89,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 65,
                                                                                                                                column: 72,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 65,
                                                                                                                                column: 89,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    {
                                                                                                                        type: 'MemberExpression',
                                                                                                                        computed: false,
                                                                                                                        object: {
                                                                                                                            type: 'MemberExpression',
                                                                                                                            computed: false,
                                                                                                                            object: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'style',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 65,
                                                                                                                                        column: 91,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 65,
                                                                                                                                        column: 96,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            property: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'opacity',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 65,
                                                                                                                                        column: 97,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 65,
                                                                                                                                        column: 104,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 65,
                                                                                                                                    column: 91,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 65,
                                                                                                                                    column: 104,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        property: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'secondary',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 65,
                                                                                                                                    column: 105,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 65,
                                                                                                                                    column: 114,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 65,
                                                                                                                                column: 91,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 65,
                                                                                                                                column: 114,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    }
                                                                                                                ],
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 65,
                                                                                                                        column: 59,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 65,
                                                                                                                        column: 115,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        kind: 'init',
                                                                                                        order: '0'
                                                                                                    },
                                                                                                    {
                                                                                                        type: 'Property',
                                                                                                        key: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'cursor',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 66,
                                                                                                                    column: 32,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 66,
                                                                                                                    column: 38,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        value: {
                                                                                                            type: 'Literal',
                                                                                                            value: 'pointer'
                                                                                                        },
                                                                                                        kind: 'init',
                                                                                                        order: '1'
                                                                                                    }
                                                                                                ]
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '1'
                                                                                        },
                                                                                        {
                                                                                            type: 'ExpressionStatement',
                                                                                            expression: {
                                                                                                type: 'MemberExpression',
                                                                                                computed: false,
                                                                                                object: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'part',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 67,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 67,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'text',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 67,
                                                                                                            column: 33,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 67,
                                                                                                            column: 37,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 67,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 67,
                                                                                                        column: 37,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 67,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 67,
                                                                                                    column: 37,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                }
                                                                                            },
                                                                                            order: '2'
                                                                                        }
                                                                                    ]
                                                                                },
                                                                                alternate: {
                                                                                    type: 'BlockStatement',
                                                                                    body: [{
                                                                                            type: 'ExpressionStatement',
                                                                                            expression: {
                                                                                                type: 'Identifier',
                                                                                                name: 'part',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 69,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 69,
                                                                                                        column: 32,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 69,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 69,
                                                                                                    column: 32,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                }
                                                                                            },
                                                                                            order: '0'
                                                                                        }]
                                                                                },
                                                                                order: '0'
                                                                            }]
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 61,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/Application.ion'
                                                                        },
                                                                        end: {
                                                                            line: 70,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/Application.ion'
                                                                        }
                                                                    },
                                                                    order: '0'
                                                                }]
                                                        },
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'IfStatement',
                                                        test: {
                                                            type: 'BinaryExpression',
                                                            operator: '!==',
                                                            left: {
                                                                type: 'Identifier',
                                                                name: 'index',
                                                                loc: {
                                                                    start: {
                                                                        line: 70,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/Application.ion'
                                                                    },
                                                                    end: {
                                                                        line: 70,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/Application.ion'
                                                                    }
                                                                }
                                                            },
                                                            right: {
                                                                type: 'BinaryExpression',
                                                                operator: '-',
                                                                left: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'name',
                                                                        loc: {
                                                                            start: {
                                                                                line: 70,
                                                                                column: 30,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Application.ion'
                                                                            },
                                                                            end: {
                                                                                line: 70,
                                                                                column: 34,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Application.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'length',
                                                                        loc: {
                                                                            start: {
                                                                                line: 70,
                                                                                column: 35,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Application.ion'
                                                                            },
                                                                            end: {
                                                                                line: 70,
                                                                                column: 41,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Application.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 70,
                                                                            column: 30,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/Application.ion'
                                                                        },
                                                                        end: {
                                                                            line: 70,
                                                                            column: 41,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/Application.ion'
                                                                        }
                                                                    }
                                                                },
                                                                right: {
                                                                    type: 'Literal',
                                                                    value: 1
                                                                }
                                                            }
                                                        },
                                                        consequent: {
                                                            type: 'BlockStatement',
                                                            body: [{
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'ObjectExpression',
                                                                        objectType: {
                                                                            type: 'CallExpression',
                                                                            callee: {
                                                                                type: 'Identifier',
                                                                                name: 'Span',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 71,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 71,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            arguments: [],
                                                                            loc: {
                                                                                start: {
                                                                                    line: 71,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Application.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 71,
                                                                                    column: 26,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Application.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        properties: [{
                                                                                type: 'ExpressionStatement',
                                                                                expression: {
                                                                                    type: 'Literal',
                                                                                    value: ' \u25B8 '
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 72,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 72,
                                                                                        column: 34,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    }
                                                                                },
                                                                                order: '0'
                                                                            }]
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 71,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/Application.ion'
                                                                        },
                                                                        end: {
                                                                            line: 73,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/Application.ion'
                                                                        }
                                                                    },
                                                                    order: '0'
                                                                }]
                                                        },
                                                        alternate: null,
                                                        order: '1'
                                                    }
                                                ]
                                            },
                                            remove: null,
                                            order: '0'
                                        }]
                                },
                                alternate: {
                                    type: 'BlockStatement',
                                    body: [{
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'Identifier',
                                                name: 'name',
                                                loc: {
                                                    start: {
                                                        line: 74,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/Application.ion'
                                                    },
                                                    end: {
                                                        line: 74,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'viewpath/html/Application.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 74,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/Application.ion'
                                                },
                                                end: {
                                                    line: 74,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/Application.ion'
                                                }
                                            },
                                            order: '0'
                                        }]
                                },
                                order: '1'
                            }
                        ]
                    },
                    order: '0'
                }],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'PaneName',
                loc: {
                    start: {
                        line: 49,
                        column: 6,
                        fixed: true,
                        source: 'viewpath/html/Application.ion'
                    },
                    end: {
                        line: 49,
                        column: 14,
                        fixed: true,
                        source: 'viewpath/html/Application.ion'
                    }
                }
            }
        }, {
            this: this,
            name: name,
            ion: ion,
            glass: glass,
            viewpath: viewpath,
            _ref: _ref,
            _ref2: _ref2,
            _ref3: _ref3,
            _ref4: _ref4,
            _ref5: _ref5,
            _ref6: _ref6,
            Key: Key,
            User: User,
            Task: Task,
            Project: Project,
            NavDrawer: NavDrawer,
            SetupWizard: SetupWizard,
            Icon: Icon,
            Button: Button,
            Resizer: Resizer,
            SearchButton: SearchButton,
            RecordSearchSuggestions: RecordSearchSuggestions,
            Toaster: Toaster,
            Dialog: Dialog,
            PromptDialog: PromptDialog,
            style: style,
            focusDescendant: focusDescendant,
            _ref12: _ref12,
            PaneResizer: PaneResizer,
            PaneBar: PaneBar,
            PaneName: PaneName,
            PaneFrame: PaneFrame
        }, null);
    });
var PaneFrame = ion.template(function PaneFrame(_ref7) {
        return ion.createRuntime({
            type: 'Template',
            id: {
                type: 'Identifier',
                name: 'PaneFrame',
                loc: {
                    start: {
                        line: 76,
                        column: 27,
                        fixed: true,
                        source: 'viewpath/html/Application.ion'
                    },
                    end: {
                        line: 76,
                        column: 36,
                        fixed: true,
                        source: 'viewpath/html/Application.ion'
                    }
                }
            },
            body: [
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'pane',
                                loc: {
                                    start: {
                                        line: 76,
                                        column: 38,
                                        fixed: true,
                                        source: 'viewpath/html/Application.ion'
                                    },
                                    end: {
                                        line: 76,
                                        column: 42,
                                        fixed: true,
                                        source: 'viewpath/html/Application.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref7'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'pane',
                                    loc: {
                                        start: {
                                            line: 76,
                                            column: 38,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        },
                                        end: {
                                            line: 76,
                                            column: 42,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '0'
                },
                {
                    type: 'ReturnStatement',
                    argument: {
                        type: 'ObjectExpression',
                        objectType: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Div',
                                loc: {
                                    start: {
                                        line: 77,
                                        column: 11,
                                        fixed: true,
                                        source: 'viewpath/html/Application.ion'
                                    },
                                    end: {
                                        line: 77,
                                        column: 14,
                                        fixed: true,
                                        source: 'viewpath/html/Application.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ObjectExpression',
                                    properties: [{
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'class',
                                                loc: {
                                                    start: {
                                                        line: 77,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'viewpath/html/Application.ion'
                                                    },
                                                    end: {
                                                        line: 77,
                                                        column: 21,
                                                        fixed: true,
                                                        source: 'viewpath/html/Application.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: 'PaneFrame layout vertical flex background-white z2'
                                            },
                                            kind: 'init',
                                            order: '0'
                                        }]
                                }],
                            loc: {
                                start: {
                                    line: 77,
                                    column: 11,
                                    fixed: true,
                                    source: 'viewpath/html/Application.ion'
                                },
                                end: {
                                    line: 77,
                                    column: 76,
                                    fixed: true,
                                    source: 'viewpath/html/Application.ion'
                                }
                            }
                        },
                        properties: [{
                                type: 'IfStatement',
                                test: {
                                    type: 'UnaryExpression',
                                    operator: '?',
                                    argument: {
                                        type: 'Identifier',
                                        name: 'pane',
                                        loc: {
                                            start: {
                                                line: 78,
                                                column: 11,
                                                fixed: true,
                                                source: 'viewpath/html/Application.ion'
                                            },
                                            end: {
                                                line: 78,
                                                column: 15,
                                                fixed: true,
                                                source: 'viewpath/html/Application.ion'
                                            }
                                        }
                                    }
                                },
                                consequent: {
                                    type: 'BlockStatement',
                                    body: [
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'config',
                                                loc: {
                                                    start: {
                                                        line: 79,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/Application.ion'
                                                    },
                                                    end: {
                                                        line: 79,
                                                        column: 18,
                                                        fixed: true,
                                                        source: 'viewpath/html/Application.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'pane',
                                                    loc: {
                                                        start: {
                                                            line: 79,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'viewpath/html/Application.ion'
                                                        },
                                                        end: {
                                                            line: 79,
                                                            column: 24,
                                                            fixed: true,
                                                            source: 'viewpath/html/Application.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'config',
                                                    loc: {
                                                        start: {
                                                            line: 79,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'viewpath/html/Application.ion'
                                                        },
                                                        end: {
                                                            line: 79,
                                                            column: 31,
                                                            fixed: true,
                                                            source: 'viewpath/html/Application.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 79,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'viewpath/html/Application.ion'
                                                    },
                                                    end: {
                                                        line: 79,
                                                        column: 31,
                                                        fixed: true,
                                                        source: 'viewpath/html/Application.ion'
                                                    }
                                                }
                                            },
                                            kind: 'init',
                                            order: '0'
                                        },
                                        {
                                            type: 'IfStatement',
                                            test: {
                                                type: 'UnaryExpression',
                                                operator: '!',
                                                argument: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'pane',
                                                        loc: {
                                                            start: {
                                                                line: 80,
                                                                column: 19,
                                                                fixed: true,
                                                                source: 'viewpath/html/Application.ion'
                                                            },
                                                            end: {
                                                                line: 80,
                                                                column: 23,
                                                                fixed: true,
                                                                source: 'viewpath/html/Application.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'noPaneBar',
                                                        loc: {
                                                            start: {
                                                                line: 80,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'viewpath/html/Application.ion'
                                                            },
                                                            end: {
                                                                line: 80,
                                                                column: 33,
                                                                fixed: true,
                                                                source: 'viewpath/html/Application.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 80,
                                                            column: 19,
                                                            fixed: true,
                                                            source: 'viewpath/html/Application.ion'
                                                        },
                                                        end: {
                                                            line: 80,
                                                            column: 33,
                                                            fixed: true,
                                                            source: 'viewpath/html/Application.ion'
                                                        }
                                                    }
                                                }
                                            },
                                            consequent: {
                                                type: 'BlockStatement',
                                                body: [
                                                    {
                                                        type: 'VariableDeclaration',
                                                        declarations: [{
                                                                type: 'VariableDeclarator',
                                                                id: {
                                                                    type: 'Identifier',
                                                                    name: 'header',
                                                                    loc: {
                                                                        start: {
                                                                            line: 81,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/Application.ion'
                                                                        },
                                                                        end: {
                                                                            line: 81,
                                                                            column: 26,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/Application.ion'
                                                                        }
                                                                    }
                                                                },
                                                                init: {
                                                                    type: 'ObjectExpression',
                                                                    objectType: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'Identifier',
                                                                            name: 'PaneBar',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 81,
                                                                                    column: 29,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Application.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 81,
                                                                                    column: 36,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Application.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [],
                                                                        loc: {
                                                                            start: {
                                                                                line: 81,
                                                                                column: 29,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Application.ion'
                                                                            },
                                                                            end: {
                                                                                line: 81,
                                                                                column: 38,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Application.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    properties: [{
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'center',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 82,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 82,
                                                                                        column: 26,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'ObjectExpression',
                                                                                properties: [{
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'CallExpression',
                                                                                            callee: {
                                                                                                type: 'Identifier',
                                                                                                name: 'PaneName',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 83,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 83,
                                                                                                        column: 32,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            arguments: [{
                                                                                                    type: 'MemberExpression',
                                                                                                    computed: false,
                                                                                                    object: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'pane',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 83,
                                                                                                                column: 33,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 83,
                                                                                                                column: 37,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    property: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'name',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 83,
                                                                                                                column: 38,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 83,
                                                                                                                column: 42,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 83,
                                                                                                            column: 33,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 83,
                                                                                                            column: 42,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                        }
                                                                                                    }
                                                                                                }],
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 83,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 83,
                                                                                                    column: 43,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 83,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 83,
                                                                                                column: 43,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        }]
                                                                }
                                                            }],
                                                        kind: 'let',
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'header',
                                                            loc: {
                                                                start: {
                                                                    line: 84,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/Application.ion'
                                                                },
                                                                end: {
                                                                    line: 84,
                                                                    column: 22,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/Application.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Identifier',
                                                            name: 'header',
                                                            loc: {
                                                                start: {
                                                                    line: 84,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/Application.ion'
                                                                },
                                                                end: {
                                                                    line: 84,
                                                                    column: 30,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/Application.ion'
                                                                }
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '1'
                                                    },
                                                    {
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'Identifier',
                                                            name: 'header',
                                                            loc: {
                                                                start: {
                                                                    line: 85,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/Application.ion'
                                                                },
                                                                end: {
                                                                    line: 85,
                                                                    column: 22,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/Application.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 85,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/Application.ion'
                                                            },
                                                            end: {
                                                                line: 85,
                                                                column: 22,
                                                                fixed: true,
                                                                source: 'viewpath/html/Application.ion'
                                                            }
                                                        },
                                                        order: '2'
                                                    }
                                                ]
                                            },
                                            alternate: null,
                                            order: '1'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'pane',
                                                loc: {
                                                    start: {
                                                        line: 86,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/Application.ion'
                                                    },
                                                    end: {
                                                        line: 86,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'viewpath/html/Application.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Identifier',
                                                name: 'pane',
                                                loc: {
                                                    start: {
                                                        line: 86,
                                                        column: 18,
                                                        fixed: true,
                                                        source: 'viewpath/html/Application.ion'
                                                    },
                                                    end: {
                                                        line: 86,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'viewpath/html/Application.ion'
                                                    }
                                                }
                                            },
                                            kind: 'init',
                                            order: '2'
                                        },
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'Identifier',
                                                name: 'pane',
                                                loc: {
                                                    start: {
                                                        line: 87,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/Application.ion'
                                                    },
                                                    end: {
                                                        line: 87,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'viewpath/html/Application.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 87,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/Application.ion'
                                                },
                                                end: {
                                                    line: 87,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/Application.ion'
                                                }
                                            },
                                            order: '3'
                                        }
                                    ]
                                },
                                alternate: null,
                                order: '0'
                            }]
                    },
                    order: '1'
                }
            ],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'PaneFrame',
                loc: {
                    start: {
                        line: 76,
                        column: 6,
                        fixed: true,
                        source: 'viewpath/html/Application.ion'
                    },
                    end: {
                        line: 76,
                        column: 15,
                        fixed: true,
                        source: 'viewpath/html/Application.ion'
                    }
                }
            }
        }, {
            this: this,
            _ref7: _ref7,
            ion: ion,
            glass: glass,
            viewpath: viewpath,
            _ref: _ref,
            _ref2: _ref2,
            _ref3: _ref3,
            _ref4: _ref4,
            _ref5: _ref5,
            _ref6: _ref6,
            Key: Key,
            User: User,
            Task: Task,
            Project: Project,
            NavDrawer: NavDrawer,
            SetupWizard: SetupWizard,
            Icon: Icon,
            Button: Button,
            Resizer: Resizer,
            SearchButton: SearchButton,
            RecordSearchSuggestions: RecordSearchSuggestions,
            Toaster: Toaster,
            Dialog: Dialog,
            PromptDialog: PromptDialog,
            style: style,
            focusDescendant: focusDescendant,
            _ref12: _ref12,
            PaneResizer: PaneResizer,
            PaneBar: PaneBar,
            PaneName: PaneName,
            PaneFrame: PaneFrame
        }, null);
    });
module.exports = exports = ion.template(function () {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'panesModule',
                            loc: {
                                start: {
                                    line: 90,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/Application.ion'
                                },
                                end: {
                                    line: 90,
                                    column: 19,
                                    fixed: true,
                                    source: 'viewpath/html/Application.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            computed: false,
                            object: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'viewpath',
                                    loc: {
                                        start: {
                                            line: 90,
                                            column: 22,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        },
                                        end: {
                                            line: 90,
                                            column: 30,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'html',
                                    loc: {
                                        start: {
                                            line: 90,
                                            column: 31,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        },
                                        end: {
                                            line: 90,
                                            column: 35,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 90,
                                        column: 22,
                                        fixed: true,
                                        source: 'viewpath/html/Application.ion'
                                    },
                                    end: {
                                        line: 90,
                                        column: 35,
                                        fixed: true,
                                        source: 'viewpath/html/Application.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'panes',
                                loc: {
                                    start: {
                                        line: 90,
                                        column: 36,
                                        fixed: true,
                                        source: 'viewpath/html/Application.ion'
                                    },
                                    end: {
                                        line: 90,
                                        column: 41,
                                        fixed: true,
                                        source: 'viewpath/html/Application.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 90,
                                    column: 22,
                                    fixed: true,
                                    source: 'viewpath/html/Application.ion'
                                },
                                end: {
                                    line: 90,
                                    column: 41,
                                    fixed: true,
                                    source: 'viewpath/html/Application.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'paneState',
                            loc: {
                                start: {
                                    line: 91,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/Application.ion'
                                },
                                end: {
                                    line: 91,
                                    column: 17,
                                    fixed: true,
                                    source: 'viewpath/html/Application.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            computed: false,
                            object: {
                                type: 'Identifier',
                                name: 'model',
                                loc: {
                                    start: {
                                        line: 91,
                                        column: 20,
                                        fixed: true,
                                        source: 'viewpath/html/Application.ion'
                                    },
                                    end: {
                                        line: 91,
                                        column: 25,
                                        fixed: true,
                                        source: 'viewpath/html/Application.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'navigation',
                                loc: {
                                    start: {
                                        line: 91,
                                        column: 26,
                                        fixed: true,
                                        source: 'viewpath/html/Application.ion'
                                    },
                                    end: {
                                        line: 91,
                                        column: 36,
                                        fixed: true,
                                        source: 'viewpath/html/Application.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 91,
                                    column: 20,
                                    fixed: true,
                                    source: 'viewpath/html/Application.ion'
                                },
                                end: {
                                    line: 91,
                                    column: 36,
                                    fixed: true,
                                    source: 'viewpath/html/Application.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'createPaneFrame',
                            loc: {
                                start: {
                                    line: 92,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/Application.ion'
                                },
                                end: {
                                    line: 92,
                                    column: 23,
                                    fixed: true,
                                    source: 'viewpath/html/Application.ion'
                                }
                            }
                        },
                        init: {
                            type: 'Function',
                            context: true,
                            value: function (_ps) {
                                return ion.template(function (config) {
                                    return ion.createRuntime({
                                        type: 'Template',
                                        id: null,
                                        body: [
                                            {
                                                type: 'VariableDeclaration',
                                                declarations: [{
                                                        type: 'VariableDeclarator',
                                                        id: {
                                                            type: 'Identifier',
                                                            name: 'paneName',
                                                            loc: {
                                                                start: {
                                                                    line: 93,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/Application.ion'
                                                                },
                                                                end: {
                                                                    line: 93,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/Application.ion'
                                                                }
                                                            }
                                                        },
                                                        init: {
                                                            type: 'BinaryExpression',
                                                            operator: '+',
                                                            left: {
                                                                type: 'BinaryExpression',
                                                                operator: '+',
                                                                left: {
                                                                    type: 'Literal',
                                                                    value: ''
                                                                },
                                                                right: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'config',
                                                                        loc: {
                                                                            start: {
                                                                                line: 93,
                                                                                column: 26,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Application.ion'
                                                                            },
                                                                            end: {
                                                                                line: 93,
                                                                                column: 32,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Application.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'id',
                                                                        loc: {
                                                                            start: {
                                                                                line: 93,
                                                                                column: 33,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Application.ion'
                                                                            },
                                                                            end: {
                                                                                line: 93,
                                                                                column: 35,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Application.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 93,
                                                                            column: 26,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/Application.ion'
                                                                        },
                                                                        end: {
                                                                            line: 93,
                                                                            column: 35,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/Application.ion'
                                                                        }
                                                                    }
                                                                }
                                                            },
                                                            right: {
                                                                type: 'Literal',
                                                                value: 'Pane'
                                                            }
                                                        }
                                                    }],
                                                kind: 'let',
                                                order: '0'
                                            },
                                            {
                                                type: 'VariableDeclaration',
                                                declarations: [{
                                                        type: 'VariableDeclarator',
                                                        id: {
                                                            type: 'Identifier',
                                                            name: 'paneTemplate',
                                                            loc: {
                                                                start: {
                                                                    line: 94,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/Application.ion'
                                                                },
                                                                end: {
                                                                    line: 94,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/Application.ion'
                                                                }
                                                            }
                                                        },
                                                        init: {
                                                            type: 'MemberExpression',
                                                            computed: true,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'panesModule',
                                                                loc: {
                                                                    start: {
                                                                        line: 94,
                                                                        column: 27,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/Application.ion'
                                                                    },
                                                                    end: {
                                                                        line: 94,
                                                                        column: 38,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/Application.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'paneName',
                                                                loc: {
                                                                    start: {
                                                                        line: 94,
                                                                        column: 39,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/Application.ion'
                                                                    },
                                                                    end: {
                                                                        line: 94,
                                                                        column: 47,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/Application.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 94,
                                                                    column: 27,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/Application.ion'
                                                                },
                                                                end: {
                                                                    line: 94,
                                                                    column: 48,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/Application.ion'
                                                                }
                                                            }
                                                        }
                                                    }],
                                                kind: 'let',
                                                order: '1'
                                            },
                                            {
                                                type: 'IfStatement',
                                                test: {
                                                    type: 'UnaryExpression',
                                                    operator: '!',
                                                    argument: {
                                                        type: 'Identifier',
                                                        name: 'paneTemplate',
                                                        loc: {
                                                            start: {
                                                                line: 95,
                                                                column: 15,
                                                                fixed: true,
                                                                source: 'viewpath/html/Application.ion'
                                                            },
                                                            end: {
                                                                line: 95,
                                                                column: 27,
                                                                fixed: true,
                                                                source: 'viewpath/html/Application.ion'
                                                            }
                                                        }
                                                    }
                                                },
                                                consequent: {
                                                    type: 'BlockStatement',
                                                    body: [
                                                        {
                                                            type: 'VariableDeclaration',
                                                            declarations: [{
                                                                    type: 'VariableDeclarator',
                                                                    id: {
                                                                        type: 'Identifier',
                                                                        name: 'pane',
                                                                        loc: {
                                                                            start: {
                                                                                line: 96,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Application.ion'
                                                                            },
                                                                            end: {
                                                                                line: 96,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Application.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    init: {
                                                                        type: 'ObjectExpression',
                                                                        objectType: {
                                                                            type: 'CallExpression',
                                                                            callee: {
                                                                                type: 'Identifier',
                                                                                name: 'Div',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 96,
                                                                                        column: 23,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 96,
                                                                                        column: 26,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            arguments: [],
                                                                            loc: {
                                                                                start: {
                                                                                    line: 96,
                                                                                    column: 23,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Application.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 96,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Application.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        properties: [
                                                                            {
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'config',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 97,
                                                                                            column: 16,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 97,
                                                                                            column: 22,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Identifier',
                                                                                    name: 'config',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 97,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 97,
                                                                                            column: 30,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                kind: 'init',
                                                                                order: '0'
                                                                            },
                                                                            {
                                                                                type: 'ExpressionStatement',
                                                                                expression: {
                                                                                    type: 'BinaryExpression',
                                                                                    operator: '+',
                                                                                    left: {
                                                                                        type: 'Literal',
                                                                                        value: 'Pane not found: '
                                                                                    },
                                                                                    right: {
                                                                                        type: 'Identifier',
                                                                                        name: 'paneName',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 98,
                                                                                                column: 35,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 98,
                                                                                                column: 43,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 98,
                                                                                        column: 16,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 98,
                                                                                        column: 46,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    }
                                                                                },
                                                                                order: '1'
                                                                            }
                                                                        ]
                                                                    }
                                                                }],
                                                            kind: 'let',
                                                            order: '0'
                                                        },
                                                        {
                                                            type: 'ReturnStatement',
                                                            argument: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Identifier',
                                                                    name: 'PaneFrame',
                                                                    loc: {
                                                                        start: {
                                                                            line: 99,
                                                                            column: 19,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/Application.ion'
                                                                        },
                                                                        end: {
                                                                            line: 99,
                                                                            column: 28,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/Application.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'ObjectExpression',
                                                                        properties: [{
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'pane',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 99,
                                                                                            column: 30,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 99,
                                                                                            column: 34,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Identifier',
                                                                                    name: 'pane',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 99,
                                                                                            column: 30,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 99,
                                                                                            column: 34,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                kind: 'init',
                                                                                order: '0'
                                                                            }]
                                                                    }],
                                                                loc: {
                                                                    start: {
                                                                        line: 99,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/Application.ion'
                                                                    },
                                                                    end: {
                                                                        line: 99,
                                                                        column: 36,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/Application.ion'
                                                                    }
                                                                }
                                                            },
                                                            order: '1'
                                                        }
                                                    ]
                                                },
                                                alternate: {
                                                    type: 'BlockStatement',
                                                    body: [
                                                        {
                                                            type: 'VariableDeclaration',
                                                            declarations: [{
                                                                    type: 'VariableDeclarator',
                                                                    id: {
                                                                        type: 'Identifier',
                                                                        name: 'pane',
                                                                        loc: {
                                                                            start: {
                                                                                line: 101,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Application.ion'
                                                                            },
                                                                            end: {
                                                                                line: 101,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Application.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    init: {
                                                                        type: 'ObjectExpression',
                                                                        objectType: {
                                                                            type: 'CallExpression',
                                                                            callee: {
                                                                                type: 'Identifier',
                                                                                name: 'paneTemplate',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 101,
                                                                                        column: 23,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 101,
                                                                                        column: 35,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            arguments: [{
                                                                                    type: 'Identifier',
                                                                                    name: 'config',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 101,
                                                                                            column: 36,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 101,
                                                                                            column: 42,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        }
                                                                                    }
                                                                                }],
                                                                            loc: {
                                                                                start: {
                                                                                    line: 101,
                                                                                    column: 23,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Application.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 101,
                                                                                    column: 43,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Application.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        properties: [{
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'config',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 102,
                                                                                            column: 16,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 102,
                                                                                            column: 22,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Identifier',
                                                                                    name: 'config',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 102,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 102,
                                                                                            column: 30,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                kind: 'init',
                                                                                order: '0'
                                                                            }]
                                                                    }
                                                                }],
                                                            kind: 'let',
                                                            order: '0'
                                                        },
                                                        {
                                                            type: 'ReturnStatement',
                                                            argument: {
                                                                type: 'ObjectExpression',
                                                                objectType: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'Identifier',
                                                                        name: 'PaneFrame',
                                                                        loc: {
                                                                            start: {
                                                                                line: 103,
                                                                                column: 19,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Application.ion'
                                                                            },
                                                                            end: {
                                                                                line: 103,
                                                                                column: 28,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Application.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [{
                                                                            type: 'ObjectExpression',
                                                                            properties: [{
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'pane',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 103,
                                                                                                column: 30,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 103,
                                                                                                column: 34,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Identifier',
                                                                                        name: 'pane',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 103,
                                                                                                column: 30,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 103,
                                                                                                column: 34,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                }]
                                                                        }],
                                                                    loc: {
                                                                        start: {
                                                                            line: 103,
                                                                            column: 19,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/Application.ion'
                                                                        },
                                                                        end: {
                                                                            line: 103,
                                                                            column: 36,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/Application.ion'
                                                                        }
                                                                    }
                                                                },
                                                                properties: [{
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'style',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 104,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Application.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 104,
                                                                                    column: 21,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Application.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'ObjectExpression',
                                                                            properties: [{
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'width',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 105,
                                                                                                column: 20,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 105,
                                                                                                column: 25,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'MemberExpression',
                                                                                            computed: false,
                                                                                            object: {
                                                                                                type: 'Identifier',
                                                                                                name: 'pane',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 105,
                                                                                                        column: 27,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 105,
                                                                                                        column: 31,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            property: {
                                                                                                type: 'Identifier',
                                                                                                name: 'style',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 105,
                                                                                                        column: 32,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 105,
                                                                                                        column: 37,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 105,
                                                                                                    column: 27,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 105,
                                                                                                    column: 37,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'width',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 105,
                                                                                                    column: 38,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 105,
                                                                                                    column: 43,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 105,
                                                                                                column: 27,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 105,
                                                                                                column: 43,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                }]
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    }]
                                                            },
                                                            order: '1'
                                                        }
                                                    ]
                                                },
                                                order: '2'
                                            }
                                        ],
                                        bound: false,
                                        name: {
                                            type: 'Identifier',
                                            name: 'createPaneFrame',
                                            loc: {
                                                start: {
                                                    line: 92,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'viewpath/html/Application.ion'
                                                },
                                                end: {
                                                    line: 92,
                                                    column: 23,
                                                    fixed: true,
                                                    source: 'viewpath/html/Application.ion'
                                                }
                                            }
                                        },
                                        scope: {
                                            type: 'Identifier',
                                            name: '_ps'
                                        }
                                    }, {
                                        this: this,
                                        config: config,
                                        _ps: _ps,
                                        ion: ion,
                                        glass: glass,
                                        viewpath: viewpath,
                                        _ref: _ref,
                                        _ref2: _ref2,
                                        _ref3: _ref3,
                                        _ref4: _ref4,
                                        _ref5: _ref5,
                                        _ref6: _ref6,
                                        Key: Key,
                                        User: User,
                                        Task: Task,
                                        Project: Project,
                                        NavDrawer: NavDrawer,
                                        SetupWizard: SetupWizard,
                                        Icon: Icon,
                                        Button: Button,
                                        Resizer: Resizer,
                                        SearchButton: SearchButton,
                                        RecordSearchSuggestions: RecordSearchSuggestions,
                                        Toaster: Toaster,
                                        Dialog: Dialog,
                                        PromptDialog: PromptDialog,
                                        style: style,
                                        focusDescendant: focusDescendant,
                                        _ref12: _ref12,
                                        PaneResizer: PaneResizer,
                                        PaneBar: PaneBar,
                                        PaneName: PaneName,
                                        PaneFrame: PaneFrame
                                    }, _ps);
                                });
                            }
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'topRightButtons',
                            loc: {
                                start: {
                                    line: 107,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/Application.ion'
                                },
                                end: {
                                    line: 107,
                                    column: 23,
                                    fixed: true,
                                    source: 'viewpath/html/Application.ion'
                                }
                            }
                        },
                        init: {
                            type: 'Function',
                            context: true,
                            value: function (_ps2) {
                                return ion.template(function () {
                                    return ion.createRuntime({
                                        type: 'Template',
                                        id: null,
                                        body: [{
                                                type: 'ReturnStatement',
                                                argument: {
                                                    type: 'ObjectExpression',
                                                    objectType: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'Identifier',
                                                            name: 'Div',
                                                            loc: {
                                                                start: {
                                                                    line: 108,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/Application.ion'
                                                                },
                                                                end: {
                                                                    line: 108,
                                                                    column: 18,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/Application.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [{
                                                                type: 'ObjectExpression',
                                                                properties: [{
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'class',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 108,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Application.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 108,
                                                                                    column: 25,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Application.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Literal',
                                                                            value: 'layout horizontal center'
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    }]
                                                            }],
                                                        loc: {
                                                            start: {
                                                                line: 108,
                                                                column: 15,
                                                                fixed: true,
                                                                source: 'viewpath/html/Application.ion'
                                                            },
                                                            end: {
                                                                line: 108,
                                                                column: 54,
                                                                fixed: true,
                                                                source: 'viewpath/html/Application.ion'
                                                            }
                                                        }
                                                    },
                                                    properties: [
                                                        {
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'ObjectExpression',
                                                                objectType: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'Identifier',
                                                                        name: 'Div',
                                                                        loc: {
                                                                            start: {
                                                                                line: 109,
                                                                                column: 12,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Application.ion'
                                                                            },
                                                                            end: {
                                                                                line: 109,
                                                                                column: 15,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Application.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [{
                                                                            type: 'ObjectExpression',
                                                                            properties: [{
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'class',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 109,
                                                                                                column: 17,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 109,
                                                                                                column: 22,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Literal',
                                                                                        value: 'error secondary'
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                }]
                                                                        }],
                                                                    loc: {
                                                                        start: {
                                                                            line: 109,
                                                                            column: 12,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/Application.ion'
                                                                        },
                                                                        end: {
                                                                            line: 109,
                                                                            column: 42,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/Application.ion'
                                                                        }
                                                                    }
                                                                },
                                                                properties: [{
                                                                        type: 'IfStatement',
                                                                        test: {
                                                                            type: 'BinaryExpression',
                                                                            operator: '===',
                                                                            left: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'Identifier',
                                                                                    name: 'model',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 110,
                                                                                            column: 19,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 110,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'online',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 110,
                                                                                            column: 25,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 110,
                                                                                            column: 31,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 110,
                                                                                        column: 19,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 110,
                                                                                        column: 31,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            right: {
                                                                                type: 'Literal',
                                                                                value: false
                                                                            }
                                                                        },
                                                                        consequent: {
                                                                            type: 'BlockStatement',
                                                                            body: [{
                                                                                    type: 'ExpressionStatement',
                                                                                    expression: {
                                                                                        type: 'Literal',
                                                                                        value: 'Offline'
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 111,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 111,
                                                                                            column: 29,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        }
                                                                                    },
                                                                                    order: '0'
                                                                                }]
                                                                        },
                                                                        alternate: null,
                                                                        order: '0'
                                                                    }]
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 109,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/Application.ion'
                                                                },
                                                                end: {
                                                                    line: 112,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/Application.ion'
                                                                }
                                                            },
                                                            order: '0'
                                                        },
                                                        {
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'ObjectExpression',
                                                                objectType: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'Identifier',
                                                                        name: 'Button',
                                                                        loc: {
                                                                            start: {
                                                                                line: 112,
                                                                                column: 12,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Application.ion'
                                                                            },
                                                                            end: {
                                                                                line: 112,
                                                                                column: 18,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Application.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [{
                                                                            type: 'ObjectExpression',
                                                                            properties: [{
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'class',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 112,
                                                                                                column: 20,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 112,
                                                                                                column: 25,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Literal',
                                                                                        value: 'white secondary'
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                }]
                                                                        }],
                                                                    loc: {
                                                                        start: {
                                                                            line: 112,
                                                                            column: 12,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/Application.ion'
                                                                        },
                                                                        end: {
                                                                            line: 112,
                                                                            column: 45,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/Application.ion'
                                                                        }
                                                                    }
                                                                },
                                                                properties: [
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'title',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 113,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Application.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 113,
                                                                                    column: 21,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Application.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Literal',
                                                                            value: 'Undo'
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    },
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'disabled',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 114,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Application.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 114,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Application.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'BinaryExpression',
                                                                            operator: '===',
                                                                            left: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'model',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 114,
                                                                                                    column: 26,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 114,
                                                                                                    column: 31,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'ops',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 114,
                                                                                                    column: 32,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 114,
                                                                                                    column: 35,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 114,
                                                                                                column: 26,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 114,
                                                                                                column: 35,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'undoStack',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 114,
                                                                                                column: 36,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 114,
                                                                                                column: 45,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 114,
                                                                                            column: 26,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 114,
                                                                                            column: 45,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'length',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 114,
                                                                                            column: 46,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 114,
                                                                                            column: 52,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 114,
                                                                                        column: 26,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 114,
                                                                                        column: 52,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            right: {
                                                                                type: 'Literal',
                                                                                value: 0
                                                                            }
                                                                        },
                                                                        kind: 'init',
                                                                        order: '1'
                                                                    },
                                                                    {
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'ObjectExpression',
                                                                            objectType: {
                                                                                type: 'CallExpression',
                                                                                callee: {
                                                                                    type: 'Identifier',
                                                                                    name: 'Icon',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 115,
                                                                                            column: 16,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 115,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                arguments: [{
                                                                                        type: 'ObjectExpression',
                                                                                        properties: [{
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'name',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 115,
                                                                                                            column: 22,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 115,
                                                                                                            column: 26,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'Literal',
                                                                                                    value: 'undo'
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '0'
                                                                                            }]
                                                                                    }],
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 115,
                                                                                        column: 16,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 115,
                                                                                        column: 35,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            properties: [{
                                                                                    type: 'ExpressionStatement',
                                                                                    expression: {
                                                                                        type: 'Function',
                                                                                        context: false,
                                                                                        value: function click(e) {
                                                                                            model.ops.undo();
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 116,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 118,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        }
                                                                                    },
                                                                                    order: '0'
                                                                                }]
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 115,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Application.ion'
                                                                            },
                                                                            end: {
                                                                                line: 118,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Application.ion'
                                                                            }
                                                                        },
                                                                        order: '2'
                                                                    }
                                                                ]
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 112,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/Application.ion'
                                                                },
                                                                end: {
                                                                    line: 118,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/Application.ion'
                                                                }
                                                            },
                                                            order: '1'
                                                        },
                                                        {
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'ObjectExpression',
                                                                objectType: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'Identifier',
                                                                        name: 'Button',
                                                                        loc: {
                                                                            start: {
                                                                                line: 118,
                                                                                column: 12,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Application.ion'
                                                                            },
                                                                            end: {
                                                                                line: 118,
                                                                                column: 18,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Application.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [{
                                                                            type: 'ObjectExpression',
                                                                            properties: [{
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'class',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 118,
                                                                                                column: 20,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 118,
                                                                                                column: 25,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Literal',
                                                                                        value: 'white secondary'
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                }]
                                                                        }],
                                                                    loc: {
                                                                        start: {
                                                                            line: 118,
                                                                            column: 12,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/Application.ion'
                                                                        },
                                                                        end: {
                                                                            line: 118,
                                                                            column: 45,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/Application.ion'
                                                                        }
                                                                    }
                                                                },
                                                                properties: [
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'title',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 119,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Application.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 119,
                                                                                    column: 21,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Application.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Literal',
                                                                            value: 'Redo'
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    },
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'disabled',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 120,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Application.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 120,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Application.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'BinaryExpression',
                                                                            operator: '===',
                                                                            left: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'model',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 120,
                                                                                                    column: 26,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 120,
                                                                                                    column: 31,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'ops',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 120,
                                                                                                    column: 32,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 120,
                                                                                                    column: 35,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 120,
                                                                                                column: 26,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 120,
                                                                                                column: 35,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'redoStack',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 120,
                                                                                                column: 36,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 120,
                                                                                                column: 45,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 120,
                                                                                            column: 26,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 120,
                                                                                            column: 45,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'length',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 120,
                                                                                            column: 46,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 120,
                                                                                            column: 52,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 120,
                                                                                        column: 26,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 120,
                                                                                        column: 52,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            right: {
                                                                                type: 'Literal',
                                                                                value: 0
                                                                            }
                                                                        },
                                                                        kind: 'init',
                                                                        order: '1'
                                                                    },
                                                                    {
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'ObjectExpression',
                                                                            objectType: {
                                                                                type: 'CallExpression',
                                                                                callee: {
                                                                                    type: 'Identifier',
                                                                                    name: 'Icon',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 121,
                                                                                            column: 16,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 121,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                arguments: [{
                                                                                        type: 'ObjectExpression',
                                                                                        properties: [{
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'name',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 121,
                                                                                                            column: 22,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 121,
                                                                                                            column: 26,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'Literal',
                                                                                                    value: 'redo'
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '0'
                                                                                            }]
                                                                                    }],
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 121,
                                                                                        column: 16,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 121,
                                                                                        column: 35,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            properties: [{
                                                                                    type: 'ExpressionStatement',
                                                                                    expression: {
                                                                                        type: 'Function',
                                                                                        context: false,
                                                                                        value: function click(e) {
                                                                                            model.ops.redo();
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 122,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 124,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        }
                                                                                    },
                                                                                    order: '0'
                                                                                }]
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 121,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Application.ion'
                                                                            },
                                                                            end: {
                                                                                line: 124,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Application.ion'
                                                                            }
                                                                        },
                                                                        order: '2'
                                                                    }
                                                                ]
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 118,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/Application.ion'
                                                                },
                                                                end: {
                                                                    line: 124,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/Application.ion'
                                                                }
                                                            },
                                                            order: '2'
                                                        },
                                                        {
                                                            type: 'VariableDeclaration',
                                                            declarations: [{
                                                                    type: 'VariableDeclarator',
                                                                    id: {
                                                                        type: 'Identifier',
                                                                        name: 'suggestionTemplate',
                                                                        loc: {
                                                                            start: {
                                                                                line: 124,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Application.ion'
                                                                            },
                                                                            end: {
                                                                                line: 124,
                                                                                column: 34,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Application.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    init: {
                                                                        type: 'Function',
                                                                        context: true,
                                                                        value: function (_ps3) {
                                                                            return ion.template(function (_ref8) {
                                                                                return ion.createRuntime({
                                                                                    type: 'Template',
                                                                                    id: null,
                                                                                    body: [
                                                                                        {
                                                                                            type: 'VariableDeclaration',
                                                                                            declarations: [{
                                                                                                    type: 'VariableDeclarator',
                                                                                                    id: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'text',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 124,
                                                                                                                column: 48,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 124,
                                                                                                                column: 52,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    init: {
                                                                                                        type: 'MemberExpression',
                                                                                                        object: {
                                                                                                            type: 'Identifier',
                                                                                                            name: '_ref8'
                                                                                                        },
                                                                                                        property: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'text',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 124,
                                                                                                                    column: 48,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 124,
                                                                                                                    column: 52,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        computed: false
                                                                                                    }
                                                                                                }],
                                                                                            kind: 'let',
                                                                                            order: '0'
                                                                                        },
                                                                                        {
                                                                                            type: 'VariableDeclaration',
                                                                                            declarations: [{
                                                                                                    type: 'VariableDeclarator',
                                                                                                    id: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'keys',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 125,
                                                                                                                column: 20,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 125,
                                                                                                                column: 24,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    init: {
                                                                                                        type: 'ObjectExpression',
                                                                                                        properties: []
                                                                                                    }
                                                                                                }],
                                                                                            kind: 'let',
                                                                                            order: '1'
                                                                                        },
                                                                                        {
                                                                                            type: 'ExpressionStatement',
                                                                                            expression: {
                                                                                                type: 'CallExpression',
                                                                                                callee: {
                                                                                                    type: 'Function',
                                                                                                    context: true,
                                                                                                    value: function (_context2) {
                                                                                                        return function (text) {
                                                                                                            var User = _context2.get('User'), keys = _context2.get('keys'), Task = _context2.get('Task'), Project = _context2.get('Project');
                                                                                                            if (text.length > 0) {
                                                                                                                {
                                                                                                                    var _ref9 = User.getSearchKeys({
                                                                                                                            text: text,
                                                                                                                            orgId: model.user.orgIds
                                                                                                                        });
                                                                                                                    for (var _i = 0; _i < _ref9.length; _i++) {
                                                                                                                        var key = _ref9[_i];
                                                                                                                        keys[key] = true;
                                                                                                                    }
                                                                                                                }
                                                                                                                {
                                                                                                                    var _ref10 = Task.getSearchKeys({
                                                                                                                            text: text,
                                                                                                                            orgId: model.user.orgIds
                                                                                                                        });
                                                                                                                    for (var _i2 = 0; _i2 < _ref10.length; _i2++) {
                                                                                                                        var key = _ref10[_i2];
                                                                                                                        keys[key] = true;
                                                                                                                    }
                                                                                                                }
                                                                                                                {
                                                                                                                    var _ref11 = Project.getSearchKeys({
                                                                                                                            text: text,
                                                                                                                            orgId: model.user.orgIds
                                                                                                                        });
                                                                                                                    for (var _i3 = 0; _i3 < _ref11.length; _i3++) {
                                                                                                                        var key = _ref11[_i3];
                                                                                                                        keys[key] = true;
                                                                                                                    }
                                                                                                                }
                                                                                                            }
                                                                                                        };
                                                                                                    }
                                                                                                },
                                                                                                arguments: [{
                                                                                                        type: 'Identifier',
                                                                                                        name: 'text',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 126,
                                                                                                                column: 20,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 126,
                                                                                                                column: 24,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    }],
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 126,
                                                                                                        column: 16,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 134,
                                                                                                        column: 20,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 126,
                                                                                                    column: 16,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 134,
                                                                                                    column: 20,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                }
                                                                                            },
                                                                                            order: '2'
                                                                                        },
                                                                                        {
                                                                                            type: 'VariableDeclaration',
                                                                                            declarations: [{
                                                                                                    type: 'VariableDeclarator',
                                                                                                    id: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'keyArray',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 134,
                                                                                                                column: 20,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 134,
                                                                                                                column: 28,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    init: {
                                                                                                        type: 'ObjectExpression',
                                                                                                        objectType: {
                                                                                                            type: 'ArrayExpression',
                                                                                                            elements: []
                                                                                                        },
                                                                                                        properties: [{
                                                                                                                type: 'ForInStatement',
                                                                                                                left: {
                                                                                                                    type: 'VariableDeclaration',
                                                                                                                    declarations: [{
                                                                                                                            type: 'VariableDeclarator',
                                                                                                                            id: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'key',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 135,
                                                                                                                                        column: 24,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 135,
                                                                                                                                        column: 27,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            init: null
                                                                                                                        }],
                                                                                                                    kind: 'let'
                                                                                                                },
                                                                                                                right: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'keys',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 135,
                                                                                                                            column: 31,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 135,
                                                                                                                            column: 35,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                body: {
                                                                                                                    type: 'BlockStatement',
                                                                                                                    body: [{
                                                                                                                            type: 'ExpressionStatement',
                                                                                                                            expression: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'key',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 136,
                                                                                                                                        column: 24,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 136,
                                                                                                                                        column: 27,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 136,
                                                                                                                                    column: 24,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 136,
                                                                                                                                    column: 27,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                }
                                                                                                                            },
                                                                                                                            order: '0'
                                                                                                                        }]
                                                                                                                },
                                                                                                                remove: null,
                                                                                                                order: '0'
                                                                                                            }]
                                                                                                    }
                                                                                                }],
                                                                                            kind: 'let',
                                                                                            order: '3'
                                                                                        },
                                                                                        {
                                                                                            type: 'ReturnStatement',
                                                                                            argument: {
                                                                                                type: 'CallExpression',
                                                                                                callee: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'RecordSearchSuggestions',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 137,
                                                                                                            column: 23,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 137,
                                                                                                            column: 46,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                arguments: [{
                                                                                                        type: 'ObjectExpression',
                                                                                                        properties: [
                                                                                                            {
                                                                                                                type: 'Property',
                                                                                                                key: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'text',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 137,
                                                                                                                            column: 48,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 137,
                                                                                                                            column: 52,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                value: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'text',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 137,
                                                                                                                            column: 48,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 137,
                                                                                                                            column: 52,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                kind: 'init',
                                                                                                                order: '0'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'Property',
                                                                                                                key: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'keys',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 137,
                                                                                                                            column: 53,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 137,
                                                                                                                            column: 57,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                value: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'keyArray',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 137,
                                                                                                                            column: 58,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 137,
                                                                                                                            column: 66,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                kind: 'init',
                                                                                                                order: '1'
                                                                                                            }
                                                                                                        ]
                                                                                                    }],
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 137,
                                                                                                        column: 23,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 137,
                                                                                                        column: 68,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            order: '4'
                                                                                        }
                                                                                    ],
                                                                                    bound: false,
                                                                                    name: {
                                                                                        type: 'Identifier',
                                                                                        name: 'suggestionTemplate',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 124,
                                                                                                column: 16,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 124,
                                                                                                column: 34,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    scope: {
                                                                                        type: 'Identifier',
                                                                                        name: '_ps3'
                                                                                    }
                                                                                }, {
                                                                                    this: this,
                                                                                    _ref8: _ref8,
                                                                                    _ps3: _ps3,
                                                                                    _ps2: _ps2,
                                                                                    ion: ion,
                                                                                    glass: glass,
                                                                                    viewpath: viewpath,
                                                                                    _ref: _ref,
                                                                                    _ref2: _ref2,
                                                                                    _ref3: _ref3,
                                                                                    _ref4: _ref4,
                                                                                    _ref5: _ref5,
                                                                                    _ref6: _ref6,
                                                                                    Key: Key,
                                                                                    User: User,
                                                                                    Task: Task,
                                                                                    Project: Project,
                                                                                    NavDrawer: NavDrawer,
                                                                                    SetupWizard: SetupWizard,
                                                                                    Icon: Icon,
                                                                                    Button: Button,
                                                                                    Resizer: Resizer,
                                                                                    SearchButton: SearchButton,
                                                                                    RecordSearchSuggestions: RecordSearchSuggestions,
                                                                                    Toaster: Toaster,
                                                                                    Dialog: Dialog,
                                                                                    PromptDialog: PromptDialog,
                                                                                    style: style,
                                                                                    focusDescendant: focusDescendant,
                                                                                    _ref12: _ref12,
                                                                                    PaneResizer: PaneResizer,
                                                                                    PaneBar: PaneBar,
                                                                                    PaneName: PaneName,
                                                                                    PaneFrame: PaneFrame
                                                                                }, _ps3);
                                                                            });
                                                                        }
                                                                    }
                                                                }],
                                                            kind: 'let',
                                                            order: '3'
                                                        },
                                                        {
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'ObjectExpression',
                                                                objectType: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'Identifier',
                                                                        name: 'PaperMenuButton',
                                                                        loc: {
                                                                            start: {
                                                                                line: 139,
                                                                                column: 12,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Application.ion'
                                                                            },
                                                                            end: {
                                                                                line: 139,
                                                                                column: 27,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Application.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [],
                                                                    loc: {
                                                                        start: {
                                                                            line: 139,
                                                                            column: 12,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/Application.ion'
                                                                        },
                                                                        end: {
                                                                            line: 139,
                                                                            column: 29,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/Application.ion'
                                                                        }
                                                                    }
                                                                },
                                                                properties: [
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'closeOnActivate',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 140,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Application.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 140,
                                                                                    column: 31,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Application.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Literal',
                                                                            value: true
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    },
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'restoreFocusOnClose',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 141,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Application.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 141,
                                                                                    column: 35,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Application.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Literal',
                                                                            value: false
                                                                        },
                                                                        kind: 'init',
                                                                        order: '1'
                                                                    },
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'horizontalAlign',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 142,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Application.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 142,
                                                                                    column: 31,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Application.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Literal',
                                                                            value: 'right'
                                                                        },
                                                                        kind: 'init',
                                                                        order: '2'
                                                                    },
                                                                    {
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'ObjectExpression',
                                                                            objectType: {
                                                                                type: 'CallExpression',
                                                                                callee: {
                                                                                    type: 'Identifier',
                                                                                    name: 'PaperIconButton',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 144,
                                                                                            column: 16,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 144,
                                                                                            column: 31,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                arguments: [{
                                                                                        type: 'ObjectExpression',
                                                                                        properties: [{
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'class',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 144,
                                                                                                            column: 33,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 144,
                                                                                                            column: 38,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'Literal',
                                                                                                    value: 'dropdown-trigger'
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '0'
                                                                                            }]
                                                                                    }],
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 144,
                                                                                        column: 16,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 144,
                                                                                        column: 59,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            properties: [{
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'icon',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 145,
                                                                                                column: 20,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 145,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Literal',
                                                                                        value: 'help'
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                }]
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 144,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Application.ion'
                                                                            },
                                                                            end: {
                                                                                line: 146,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Application.ion'
                                                                            }
                                                                        },
                                                                        order: '3'
                                                                    },
                                                                    {
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'ObjectExpression',
                                                                            objectType: {
                                                                                type: 'CallExpression',
                                                                                callee: {
                                                                                    type: 'Identifier',
                                                                                    name: 'PaperMenu',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 146,
                                                                                            column: 16,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 146,
                                                                                            column: 25,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                arguments: [{
                                                                                        type: 'ObjectExpression',
                                                                                        properties: [{
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'class',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 146,
                                                                                                            column: 27,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 146,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'Literal',
                                                                                                    value: 'dropdown-content'
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '0'
                                                                                            }]
                                                                                    }],
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 146,
                                                                                        column: 16,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 146,
                                                                                        column: 53,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            properties: [
                                                                                {
                                                                                    type: 'ExpressionStatement',
                                                                                    expression: {
                                                                                        type: 'ObjectExpression',
                                                                                        objectType: {
                                                                                            type: 'CallExpression',
                                                                                            callee: {
                                                                                                type: 'Identifier',
                                                                                                name: 'PaperIconItem',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 147,
                                                                                                        column: 20,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 147,
                                                                                                        column: 33,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            arguments: [],
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 147,
                                                                                                    column: 20,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 147,
                                                                                                    column: 35,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        properties: [
                                                                                            {
                                                                                                type: 'ExpressionStatement',
                                                                                                expression: {
                                                                                                    type: 'ObjectExpression',
                                                                                                    objectType: {
                                                                                                        type: 'CallExpression',
                                                                                                        callee: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'IronIcon',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 148,
                                                                                                                    column: 24,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 148,
                                                                                                                    column: 32,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        arguments: [{
                                                                                                                type: 'ObjectExpression',
                                                                                                                properties: [{
                                                                                                                        type: 'Property',
                                                                                                                        key: {
                                                                                                                            type: 'Literal',
                                                                                                                            value: 'item-icon'
                                                                                                                        },
                                                                                                                        value: {
                                                                                                                            type: 'Literal',
                                                                                                                            value: true
                                                                                                                        },
                                                                                                                        kind: 'init',
                                                                                                                        order: '0'
                                                                                                                    }]
                                                                                                            }],
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 148,
                                                                                                                column: 24,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 148,
                                                                                                                column: 52,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    properties: [{
                                                                                                            type: 'Property',
                                                                                                            key: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'icon',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 149,
                                                                                                                        column: 28,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 149,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            value: {
                                                                                                                type: 'Literal',
                                                                                                                value: 'help'
                                                                                                            },
                                                                                                            kind: 'init',
                                                                                                            order: '0'
                                                                                                        }]
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 148,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 150,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    }
                                                                                                },
                                                                                                order: '0'
                                                                                            },
                                                                                            {
                                                                                                type: 'ExpressionStatement',
                                                                                                expression: {
                                                                                                    type: 'ObjectExpression',
                                                                                                    objectType: {
                                                                                                        type: 'CallExpression',
                                                                                                        callee: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'Span',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 150,
                                                                                                                    column: 24,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 150,
                                                                                                                    column: 28,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        arguments: [],
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 150,
                                                                                                                column: 24,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 150,
                                                                                                                column: 30,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    properties: [{
                                                                                                            type: 'ExpressionStatement',
                                                                                                            expression: {
                                                                                                                type: 'Literal',
                                                                                                                value: 'Help Center'
                                                                                                            },
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 151,
                                                                                                                    column: 28,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 151,
                                                                                                                    column: 41,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                }
                                                                                                            },
                                                                                                            order: '0'
                                                                                                        }]
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 150,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 152,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    }
                                                                                                },
                                                                                                order: '1'
                                                                                            },
                                                                                            {
                                                                                                type: 'ExpressionStatement',
                                                                                                expression: {
                                                                                                    type: 'Function',
                                                                                                    context: false,
                                                                                                    value: function click() {
                                                                                                        window.open('https://viewpath4.zendesk.com/hc/en-us', '_blank');
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 152,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 154,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    }
                                                                                                },
                                                                                                order: '2'
                                                                                            }
                                                                                        ]
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 147,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 154,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        }
                                                                                    },
                                                                                    order: '0'
                                                                                },
                                                                                {
                                                                                    type: 'ExpressionStatement',
                                                                                    expression: {
                                                                                        type: 'ObjectExpression',
                                                                                        objectType: {
                                                                                            type: 'CallExpression',
                                                                                            callee: {
                                                                                                type: 'Identifier',
                                                                                                name: 'PaperIconItem',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 154,
                                                                                                        column: 20,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 154,
                                                                                                        column: 33,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            arguments: [],
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 154,
                                                                                                    column: 20,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 154,
                                                                                                    column: 35,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        properties: [
                                                                                            {
                                                                                                type: 'ExpressionStatement',
                                                                                                expression: {
                                                                                                    type: 'CallExpression',
                                                                                                    callee: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'Icon',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 155,
                                                                                                                column: 24,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 155,
                                                                                                                column: 28,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    arguments: [{
                                                                                                            type: 'ObjectExpression',
                                                                                                            properties: [
                                                                                                                {
                                                                                                                    type: 'Property',
                                                                                                                    key: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'name',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 156,
                                                                                                                                column: 28,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 156,
                                                                                                                                column: 32,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    value: {
                                                                                                                        type: 'Literal',
                                                                                                                        value: 'wand'
                                                                                                                    },
                                                                                                                    kind: 'init',
                                                                                                                    order: '0'
                                                                                                                },
                                                                                                                {
                                                                                                                    type: 'Property',
                                                                                                                    key: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'attributes',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 157,
                                                                                                                                column: 28,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 157,
                                                                                                                                column: 38,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    value: {
                                                                                                                        type: 'ObjectExpression',
                                                                                                                        properties: [{
                                                                                                                                type: 'Property',
                                                                                                                                key: {
                                                                                                                                    type: 'Literal',
                                                                                                                                    value: 'item-icon'
                                                                                                                                },
                                                                                                                                value: {
                                                                                                                                    type: 'Literal',
                                                                                                                                    value: true
                                                                                                                                },
                                                                                                                                kind: 'init',
                                                                                                                                order: '0'
                                                                                                                            }]
                                                                                                                    },
                                                                                                                    kind: 'init',
                                                                                                                    order: '1'
                                                                                                                }
                                                                                                            ]
                                                                                                        }],
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 155,
                                                                                                            column: 24,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 158,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 155,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 158,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    }
                                                                                                },
                                                                                                order: '0'
                                                                                            },
                                                                                            {
                                                                                                type: 'ExpressionStatement',
                                                                                                expression: {
                                                                                                    type: 'ObjectExpression',
                                                                                                    objectType: {
                                                                                                        type: 'CallExpression',
                                                                                                        callee: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'Span',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 158,
                                                                                                                    column: 24,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 158,
                                                                                                                    column: 28,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        arguments: [],
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 158,
                                                                                                                column: 24,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 158,
                                                                                                                column: 30,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    properties: [{
                                                                                                            type: 'ExpressionStatement',
                                                                                                            expression: {
                                                                                                                type: 'Literal',
                                                                                                                value: 'Organization Setup Wizard'
                                                                                                            },
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 159,
                                                                                                                    column: 28,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 159,
                                                                                                                    column: 55,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                }
                                                                                                            },
                                                                                                            order: '0'
                                                                                                        }]
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 158,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 160,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    }
                                                                                                },
                                                                                                order: '1'
                                                                                            },
                                                                                            {
                                                                                                type: 'ExpressionStatement',
                                                                                                expression: {
                                                                                                    type: 'Function',
                                                                                                    context: true,
                                                                                                    value: function (_context3) {
                                                                                                        return function click() {
                                                                                                            var SetupWizard = _context3.get('SetupWizard');
                                                                                                            return SetupWizard();
                                                                                                        };
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 160,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 160,
                                                                                                        column: 48,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    }
                                                                                                },
                                                                                                order: '2'
                                                                                            }
                                                                                        ]
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 154,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 161,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        }
                                                                                    },
                                                                                    order: '1'
                                                                                },
                                                                                {
                                                                                    type: 'ExpressionStatement',
                                                                                    expression: {
                                                                                        type: 'ObjectExpression',
                                                                                        objectType: {
                                                                                            type: 'CallExpression',
                                                                                            callee: {
                                                                                                type: 'Identifier',
                                                                                                name: 'PaperIconItem',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 161,
                                                                                                        column: 20,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 161,
                                                                                                        column: 33,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            arguments: [],
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 161,
                                                                                                    column: 20,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 161,
                                                                                                    column: 35,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        properties: [
                                                                                            {
                                                                                                type: 'ExpressionStatement',
                                                                                                expression: {
                                                                                                    type: 'ObjectExpression',
                                                                                                    objectType: {
                                                                                                        type: 'CallExpression',
                                                                                                        callee: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'IronIcon',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 162,
                                                                                                                    column: 24,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 162,
                                                                                                                    column: 32,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        arguments: [{
                                                                                                                type: 'ObjectExpression',
                                                                                                                properties: [{
                                                                                                                        type: 'Property',
                                                                                                                        key: {
                                                                                                                            type: 'Literal',
                                                                                                                            value: 'item-icon'
                                                                                                                        },
                                                                                                                        value: {
                                                                                                                            type: 'Literal',
                                                                                                                            value: true
                                                                                                                        },
                                                                                                                        kind: 'init',
                                                                                                                        order: '0'
                                                                                                                    }]
                                                                                                            }],
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 162,
                                                                                                                column: 24,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 162,
                                                                                                                column: 52,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    properties: [{
                                                                                                            type: 'Property',
                                                                                                            key: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'icon',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 163,
                                                                                                                        column: 28,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 163,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            value: {
                                                                                                                type: 'Literal',
                                                                                                                value: 'clear'
                                                                                                            },
                                                                                                            kind: 'init',
                                                                                                            order: '0'
                                                                                                        }]
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 162,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 164,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    }
                                                                                                },
                                                                                                order: '0'
                                                                                            },
                                                                                            {
                                                                                                type: 'ExpressionStatement',
                                                                                                expression: {
                                                                                                    type: 'ObjectExpression',
                                                                                                    objectType: {
                                                                                                        type: 'CallExpression',
                                                                                                        callee: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'Span',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 164,
                                                                                                                    column: 24,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 164,
                                                                                                                    column: 28,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        arguments: [],
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 164,
                                                                                                                column: 24,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 164,
                                                                                                                column: 30,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    properties: [{
                                                                                                            type: 'ExpressionStatement',
                                                                                                            expression: {
                                                                                                                type: 'Literal',
                                                                                                                value: 'Clear Local Data'
                                                                                                            },
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 165,
                                                                                                                    column: 28,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 165,
                                                                                                                    column: 46,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                }
                                                                                                            },
                                                                                                            order: '0'
                                                                                                        }]
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 164,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 166,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    }
                                                                                                },
                                                                                                order: '1'
                                                                                            },
                                                                                            {
                                                                                                type: 'ExpressionStatement',
                                                                                                expression: {
                                                                                                    type: 'Function',
                                                                                                    context: true,
                                                                                                    value: function (_context4) {
                                                                                                        return function click() {
                                                                                                            var PromptDialog = _context4.get('PromptDialog');
                                                                                                            PromptDialog.show({
                                                                                                                properties: [],
                                                                                                                title: 'Are you sure you want to clear your local data?',
                                                                                                                submitText: 'Yes',
                                                                                                                cancelText: 'No',
                                                                                                                callback: function () {
                                                                                                                    model.logout();
                                                                                                                    localStorage.clear();
                                                                                                                    window.location.reload(true);
                                                                                                                }
                                                                                                            });
                                                                                                        };
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 166,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 178,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    }
                                                                                                },
                                                                                                order: '2'
                                                                                            }
                                                                                        ]
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 161,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 178,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        }
                                                                                    },
                                                                                    order: '2'
                                                                                }
                                                                            ]
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 146,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Application.ion'
                                                                            },
                                                                            end: {
                                                                                line: 178,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Application.ion'
                                                                            }
                                                                        },
                                                                        order: '4'
                                                                    }
                                                                ]
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 139,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/Application.ion'
                                                                },
                                                                end: {
                                                                    line: 178,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/Application.ion'
                                                                }
                                                            },
                                                            order: '4'
                                                        }
                                                    ]
                                                },
                                                order: '0'
                                            }],
                                        bound: false,
                                        name: {
                                            type: 'Identifier',
                                            name: 'topRightButtons',
                                            loc: {
                                                start: {
                                                    line: 107,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'viewpath/html/Application.ion'
                                                },
                                                end: {
                                                    line: 107,
                                                    column: 23,
                                                    fixed: true,
                                                    source: 'viewpath/html/Application.ion'
                                                }
                                            }
                                        },
                                        scope: {
                                            type: 'Identifier',
                                            name: '_ps2'
                                        }
                                    }, {
                                        this: this,
                                        ion: ion,
                                        _ps2: _ps2,
                                        glass: glass,
                                        viewpath: viewpath,
                                        _ref: _ref,
                                        _ref2: _ref2,
                                        _ref3: _ref3,
                                        _ref4: _ref4,
                                        _ref5: _ref5,
                                        _ref6: _ref6,
                                        Key: Key,
                                        User: User,
                                        Task: Task,
                                        Project: Project,
                                        NavDrawer: NavDrawer,
                                        SetupWizard: SetupWizard,
                                        Icon: Icon,
                                        Button: Button,
                                        Resizer: Resizer,
                                        SearchButton: SearchButton,
                                        RecordSearchSuggestions: RecordSearchSuggestions,
                                        Toaster: Toaster,
                                        Dialog: Dialog,
                                        PromptDialog: PromptDialog,
                                        style: style,
                                        focusDescendant: focusDescendant,
                                        _ref12: _ref12,
                                        PaneResizer: PaneResizer,
                                        PaneBar: PaneBar,
                                        PaneName: PaneName,
                                        PaneFrame: PaneFrame
                                    }, _ps2);
                                });
                            }
                        }
                    }],
                kind: 'let',
                order: '3'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'clientWidth',
                            loc: {
                                start: {
                                    line: 190,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/Application.ion'
                                },
                                end: {
                                    line: 190,
                                    column: 19,
                                    fixed: true,
                                    source: 'viewpath/html/Application.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            computed: false,
                            object: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'document',
                                    loc: {
                                        start: {
                                            line: 190,
                                            column: 22,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        },
                                        end: {
                                            line: 190,
                                            column: 30,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'body',
                                    loc: {
                                        start: {
                                            line: 190,
                                            column: 31,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        },
                                        end: {
                                            line: 190,
                                            column: 35,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 190,
                                        column: 22,
                                        fixed: true,
                                        source: 'viewpath/html/Application.ion'
                                    },
                                    end: {
                                        line: 190,
                                        column: 35,
                                        fixed: true,
                                        source: 'viewpath/html/Application.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'clientWidth',
                                loc: {
                                    start: {
                                        line: 190,
                                        column: 36,
                                        fixed: true,
                                        source: 'viewpath/html/Application.ion'
                                    },
                                    end: {
                                        line: 190,
                                        column: 47,
                                        fixed: true,
                                        source: 'viewpath/html/Application.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 190,
                                    column: 22,
                                    fixed: true,
                                    source: 'viewpath/html/Application.ion'
                                },
                                end: {
                                    line: 190,
                                    column: 47,
                                    fixed: true,
                                    source: 'viewpath/html/Application.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '4'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'canPinPanes',
                            loc: {
                                start: {
                                    line: 191,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/Application.ion'
                                },
                                end: {
                                    line: 191,
                                    column: 19,
                                    fixed: true,
                                    source: 'viewpath/html/Application.ion'
                                }
                            }
                        },
                        init: {
                            type: 'BinaryExpression',
                            operator: '||',
                            left: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'device',
                                    loc: {
                                        start: {
                                            line: 191,
                                            column: 22,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        },
                                        end: {
                                            line: 191,
                                            column: 28,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'desktop',
                                    loc: {
                                        start: {
                                            line: 191,
                                            column: 29,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        },
                                        end: {
                                            line: 191,
                                            column: 36,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 191,
                                        column: 22,
                                        fixed: true,
                                        source: 'viewpath/html/Application.ion'
                                    },
                                    end: {
                                        line: 191,
                                        column: 36,
                                        fixed: true,
                                        source: 'viewpath/html/Application.ion'
                                    }
                                }
                            },
                            right: {
                                type: 'BinaryExpression',
                                operator: '&&',
                                left: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'device',
                                        loc: {
                                            start: {
                                                line: 191,
                                                column: 41,
                                                fixed: true,
                                                source: 'viewpath/html/Application.ion'
                                            },
                                            end: {
                                                line: 191,
                                                column: 47,
                                                fixed: true,
                                                source: 'viewpath/html/Application.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'mobile',
                                        loc: {
                                            start: {
                                                line: 191,
                                                column: 48,
                                                fixed: true,
                                                source: 'viewpath/html/Application.ion'
                                            },
                                            end: {
                                                line: 191,
                                                column: 54,
                                                fixed: true,
                                                source: 'viewpath/html/Application.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 191,
                                            column: 41,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        },
                                        end: {
                                            line: 191,
                                            column: 54,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        }
                                    }
                                },
                                right: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'device',
                                        loc: {
                                            start: {
                                                line: 191,
                                                column: 59,
                                                fixed: true,
                                                source: 'viewpath/html/Application.ion'
                                            },
                                            end: {
                                                line: 191,
                                                column: 65,
                                                fixed: true,
                                                source: 'viewpath/html/Application.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'landscape',
                                        loc: {
                                            start: {
                                                line: 191,
                                                column: 66,
                                                fixed: true,
                                                source: 'viewpath/html/Application.ion'
                                            },
                                            end: {
                                                line: 191,
                                                column: 75,
                                                fixed: true,
                                                source: 'viewpath/html/Application.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 191,
                                            column: 59,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        },
                                        end: {
                                            line: 191,
                                            column: 75,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        }
                                    }
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '5'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'canFloatPane',
                            loc: {
                                start: {
                                    line: 192,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/Application.ion'
                                },
                                end: {
                                    line: 192,
                                    column: 20,
                                    fixed: true,
                                    source: 'viewpath/html/Application.ion'
                                }
                            }
                        },
                        init: {
                            type: 'Identifier',
                            name: 'canPinPanes',
                            loc: {
                                start: {
                                    line: 192,
                                    column: 23,
                                    fixed: true,
                                    source: 'viewpath/html/Application.ion'
                                },
                                end: {
                                    line: 192,
                                    column: 34,
                                    fixed: true,
                                    source: 'viewpath/html/Application.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '6'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'activeElement',
                            loc: {
                                start: {
                                    line: 194,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/Application.ion'
                                },
                                end: {
                                    line: 194,
                                    column: 21,
                                    fixed: true,
                                    source: 'viewpath/html/Application.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            computed: false,
                            object: {
                                type: 'Identifier',
                                name: 'document',
                                loc: {
                                    start: {
                                        line: 194,
                                        column: 24,
                                        fixed: true,
                                        source: 'viewpath/html/Application.ion'
                                    },
                                    end: {
                                        line: 194,
                                        column: 32,
                                        fixed: true,
                                        source: 'viewpath/html/Application.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'activeElement',
                                loc: {
                                    start: {
                                        line: 194,
                                        column: 33,
                                        fixed: true,
                                        source: 'viewpath/html/Application.ion'
                                    },
                                    end: {
                                        line: 194,
                                        column: 46,
                                        fixed: true,
                                        source: 'viewpath/html/Application.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 194,
                                    column: 24,
                                    fixed: true,
                                    source: 'viewpath/html/Application.ion'
                                },
                                end: {
                                    line: 194,
                                    column: 46,
                                    fixed: true,
                                    source: 'viewpath/html/Application.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '7'
            },
            {
                type: 'ExpressionStatement',
                expression: {
                    type: 'CallExpression',
                    callee: {
                        type: 'Function',
                        context: true,
                        value: function (_context5) {
                            return function (activeElement) {
                                var focusDescendant = _context5.get('focusDescendant');
                                if (activeElement === document.body) {
                                    focusDescendant(document.body);
                                }
                            };
                        }
                    },
                    arguments: [{
                            type: 'Identifier',
                            name: 'activeElement',
                            loc: {
                                start: {
                                    line: 195,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/Application.ion'
                                },
                                end: {
                                    line: 195,
                                    column: 21,
                                    fixed: true,
                                    source: 'viewpath/html/Application.ion'
                                }
                            }
                        }],
                    loc: {
                        start: {
                            line: 195,
                            column: 4,
                            fixed: true,
                            source: 'viewpath/html/Application.ion'
                        },
                        end: {
                            line: 200,
                            column: 8,
                            fixed: true,
                            source: 'viewpath/html/Application.ion'
                        }
                    }
                },
                loc: {
                    start: {
                        line: 195,
                        column: 4,
                        fixed: true,
                        source: 'viewpath/html/Application.ion'
                    },
                    end: {
                        line: 200,
                        column: 8,
                        fixed: true,
                        source: 'viewpath/html/Application.ion'
                    }
                },
                order: '8'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'navDrawer',
                            loc: {
                                start: {
                                    line: 200,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/Application.ion'
                                },
                                end: {
                                    line: 200,
                                    column: 17,
                                    fixed: true,
                                    source: 'viewpath/html/Application.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'NavDrawer',
                                loc: {
                                    start: {
                                        line: 200,
                                        column: 20,
                                        fixed: true,
                                        source: 'viewpath/html/Application.ion'
                                    },
                                    end: {
                                        line: 200,
                                        column: 29,
                                        fixed: true,
                                        source: 'viewpath/html/Application.ion'
                                    }
                                }
                            },
                            arguments: [],
                            loc: {
                                start: {
                                    line: 200,
                                    column: 20,
                                    fixed: true,
                                    source: 'viewpath/html/Application.ion'
                                },
                                end: {
                                    line: 200,
                                    column: 31,
                                    fixed: true,
                                    source: 'viewpath/html/Application.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '9'
            },
            {
                type: 'ExpressionStatement',
                expression: {
                    type: 'CallExpression',
                    callee: {
                        type: 'Function',
                        context: true,
                        value: function (_context6) {
                            return function () {
                                var navDrawer = _context6.get('navDrawer'), paneState = _context6.get('paneState');
                                return navDrawer.pinned = paneState.navPin;
                            };
                        }
                    },
                    arguments: [],
                    loc: {
                        start: {
                            line: 201,
                            column: 4,
                            fixed: true,
                            source: 'viewpath/html/Application.ion'
                        },
                        end: {
                            line: 201,
                            column: 45,
                            fixed: true,
                            source: 'viewpath/html/Application.ion'
                        }
                    }
                },
                loc: {
                    start: {
                        line: 201,
                        column: 4,
                        fixed: true,
                        source: 'viewpath/html/Application.ion'
                    },
                    end: {
                        line: 201,
                        column: 45,
                        fixed: true,
                        source: 'viewpath/html/Application.ion'
                    }
                },
                order: ':'
            },
            {
                type: 'ExpressionStatement',
                expression: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'Identifier',
                        name: 'paneState',
                        loc: {
                            start: {
                                line: 202,
                                column: 4,
                                fixed: true,
                                source: 'viewpath/html/Application.ion'
                            },
                            end: {
                                line: 202,
                                column: 13,
                                fixed: true,
                                source: 'viewpath/html/Application.ion'
                            }
                        }
                    },
                    properties: [{
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'navPin',
                                loc: {
                                    start: {
                                        line: 203,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/html/Application.ion'
                                    },
                                    end: {
                                        line: 203,
                                        column: 14,
                                        fixed: true,
                                        source: 'viewpath/html/Application.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'navDrawer',
                                    loc: {
                                        start: {
                                            line: 203,
                                            column: 16,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        },
                                        end: {
                                            line: 203,
                                            column: 25,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'pinned',
                                    loc: {
                                        start: {
                                            line: 203,
                                            column: 26,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        },
                                        end: {
                                            line: 203,
                                            column: 32,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 203,
                                        column: 16,
                                        fixed: true,
                                        source: 'viewpath/html/Application.ion'
                                    },
                                    end: {
                                        line: 203,
                                        column: 32,
                                        fixed: true,
                                        source: 'viewpath/html/Application.ion'
                                    }
                                }
                            },
                            kind: 'init',
                            order: '0'
                        }]
                },
                loc: {
                    start: {
                        line: 202,
                        column: 4,
                        fixed: true,
                        source: 'viewpath/html/Application.ion'
                    },
                    end: {
                        line: 205,
                        column: 8,
                        fixed: true,
                        source: 'viewpath/html/Application.ion'
                    }
                },
                order: ';'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'mainElement',
                            loc: {
                                start: {
                                    line: 205,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/Application.ion'
                                },
                                end: {
                                    line: 205,
                                    column: 19,
                                    fixed: true,
                                    source: 'viewpath/html/Application.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Div',
                                loc: {
                                    start: {
                                        line: 205,
                                        column: 22,
                                        fixed: true,
                                        source: 'viewpath/html/Application.ion'
                                    },
                                    end: {
                                        line: 205,
                                        column: 25,
                                        fixed: true,
                                        source: 'viewpath/html/Application.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ObjectExpression',
                                    properties: [{
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'class',
                                                loc: {
                                                    start: {
                                                        line: 205,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'viewpath/html/Application.ion'
                                                    },
                                                    end: {
                                                        line: 205,
                                                        column: 32,
                                                        fixed: true,
                                                        source: 'viewpath/html/Application.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: 'fill layout horizontal'
                                            },
                                            kind: 'init',
                                            order: '0'
                                        }]
                                }],
                            loc: {
                                start: {
                                    line: 205,
                                    column: 22,
                                    fixed: true,
                                    source: 'viewpath/html/Application.ion'
                                },
                                end: {
                                    line: 205,
                                    column: 59,
                                    fixed: true,
                                    source: 'viewpath/html/Application.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '<'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'Identifier',
                        name: 'mainElement',
                        loc: {
                            start: {
                                line: 206,
                                column: 11,
                                fixed: true,
                                source: 'viewpath/html/Application.ion'
                            },
                            end: {
                                line: 206,
                                column: 22,
                                fixed: true,
                                source: 'viewpath/html/Application.ion'
                            }
                        }
                    },
                    properties: [
                        {
                            type: 'IfStatement',
                            test: {
                                type: 'UnaryExpression',
                                operator: '?',
                                argument: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'model',
                                        loc: {
                                            start: {
                                                line: 207,
                                                column: 11,
                                                fixed: true,
                                                source: 'viewpath/html/Application.ion'
                                            },
                                            end: {
                                                line: 207,
                                                column: 16,
                                                fixed: true,
                                                source: 'viewpath/html/Application.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'user',
                                        loc: {
                                            start: {
                                                line: 207,
                                                column: 17,
                                                fixed: true,
                                                source: 'viewpath/html/Application.ion'
                                            },
                                            end: {
                                                line: 207,
                                                column: 21,
                                                fixed: true,
                                                source: 'viewpath/html/Application.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 207,
                                            column: 11,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        },
                                        end: {
                                            line: 207,
                                            column: 21,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        }
                                    }
                                }
                            },
                            consequent: {
                                type: 'BlockStatement',
                                body: [{
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'Identifier',
                                                name: 'Toaster',
                                                loc: {
                                                    start: {
                                                        line: 208,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/Application.ion'
                                                    },
                                                    end: {
                                                        line: 208,
                                                        column: 19,
                                                        fixed: true,
                                                        source: 'viewpath/html/Application.ion'
                                                    }
                                                }
                                            },
                                            arguments: [],
                                            loc: {
                                                start: {
                                                    line: 208,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/Application.ion'
                                                },
                                                end: {
                                                    line: 208,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'viewpath/html/Application.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 208,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/Application.ion'
                                            },
                                            end: {
                                                line: 208,
                                                column: 21,
                                                fixed: true,
                                                source: 'viewpath/html/Application.ion'
                                            }
                                        },
                                        order: '0'
                                    }]
                            },
                            alternate: null,
                            order: '0'
                        },
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'Identifier',
                                    name: 'navDrawer',
                                    loc: {
                                        start: {
                                            line: 209,
                                            column: 8,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        },
                                        end: {
                                            line: 209,
                                            column: 17,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        }
                                    }
                                },
                                properties: [{
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'style',
                                            loc: {
                                                start: {
                                                    line: 210,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/Application.ion'
                                                },
                                                end: {
                                                    line: 210,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'viewpath/html/Application.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'ObjectExpression',
                                            properties: [
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Literal',
                                                        value: 'z-index'
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 30
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Literal',
                                                        value: 'height'
                                                    },
                                                    value: {
                                                        type: 'BinaryExpression',
                                                        operator: '+',
                                                        left: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'mainElement',
                                                                loc: {
                                                                    start: {
                                                                        line: 212,
                                                                        column: 26,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/Application.ion'
                                                                    },
                                                                    end: {
                                                                        line: 212,
                                                                        column: 37,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/Application.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'clientHeight',
                                                                loc: {
                                                                    start: {
                                                                        line: 212,
                                                                        column: 38,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/Application.ion'
                                                                    },
                                                                    end: {
                                                                        line: 212,
                                                                        column: 50,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/Application.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 212,
                                                                    column: 26,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/Application.ion'
                                                                },
                                                                end: {
                                                                    line: 212,
                                                                    column: 50,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/Application.ion'
                                                                }
                                                            }
                                                        },
                                                        right: {
                                                            type: 'Literal',
                                                            value: 'px'
                                                        }
                                                    },
                                                    kind: 'init',
                                                    order: '1'
                                                }
                                            ]
                                        },
                                        kind: 'init',
                                        order: '0'
                                    }]
                            },
                            loc: {
                                start: {
                                    line: 209,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/Application.ion'
                                },
                                end: {
                                    line: 213,
                                    column: 12,
                                    fixed: true,
                                    source: 'viewpath/html/Application.ion'
                                }
                            },
                            order: '1'
                        },
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'Identifier',
                                        name: 'Div',
                                        loc: {
                                            start: {
                                                line: 213,
                                                column: 8,
                                                fixed: true,
                                                source: 'viewpath/html/Application.ion'
                                            },
                                            end: {
                                                line: 213,
                                                column: 11,
                                                fixed: true,
                                                source: 'viewpath/html/Application.ion'
                                            }
                                        }
                                    },
                                    arguments: [{
                                            type: 'ObjectExpression',
                                            properties: [{
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'class',
                                                        loc: {
                                                            start: {
                                                                line: 213,
                                                                column: 13,
                                                                fixed: true,
                                                                source: 'viewpath/html/Application.ion'
                                                            },
                                                            end: {
                                                                line: 213,
                                                                column: 18,
                                                                fixed: true,
                                                                source: 'viewpath/html/Application.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 'fill layout vertical'
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                }]
                                        }],
                                    loc: {
                                        start: {
                                            line: 213,
                                            column: 8,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        },
                                        end: {
                                            line: 213,
                                            column: 43,
                                            fixed: true,
                                            source: 'viewpath/html/Application.ion'
                                        }
                                    }
                                },
                                properties: [{
                                        type: 'IfStatement',
                                        test: {
                                            type: 'UnaryExpression',
                                            operator: '?',
                                            argument: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'model',
                                                    loc: {
                                                        start: {
                                                            line: 214,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'viewpath/html/Application.ion'
                                                        },
                                                        end: {
                                                            line: 214,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'viewpath/html/Application.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'user',
                                                    loc: {
                                                        start: {
                                                            line: 214,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'viewpath/html/Application.ion'
                                                        },
                                                        end: {
                                                            line: 214,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'viewpath/html/Application.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 214,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'viewpath/html/Application.ion'
                                                    },
                                                    end: {
                                                        line: 214,
                                                        column: 25,
                                                        fixed: true,
                                                        source: 'viewpath/html/Application.ion'
                                                    }
                                                }
                                            }
                                        },
                                        consequent: {
                                            type: 'BlockStatement',
                                            body: [
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'buffer',
                                                                loc: {
                                                                    start: {
                                                                        line: 215,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/Application.ion'
                                                                    },
                                                                    end: {
                                                                        line: 215,
                                                                        column: 26,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/Application.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'Literal',
                                                                value: 8
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'panes',
                                                                loc: {
                                                                    start: {
                                                                        line: 216,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/Application.ion'
                                                                    },
                                                                    end: {
                                                                        line: 216,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/Application.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'ObjectExpression',
                                                                objectType: {
                                                                    type: 'ArrayExpression',
                                                                    elements: []
                                                                },
                                                                properties: [{
                                                                        type: 'ForOfStatement',
                                                                        left: {
                                                                            type: 'VariableDeclaration',
                                                                            declarations: [{
                                                                                    type: 'VariableDeclarator',
                                                                                    id: {
                                                                                        type: 'Identifier',
                                                                                        name: 'config',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 216,
                                                                                                column: 57,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 216,
                                                                                                column: 63,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    init: null
                                                                                }],
                                                                            kind: 'let'
                                                                        },
                                                                        right: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'paneState',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 216,
                                                                                        column: 67,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 216,
                                                                                        column: 76,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'panes',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 216,
                                                                                        column: 77,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 216,
                                                                                        column: 82,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 216,
                                                                                    column: 67,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Application.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 216,
                                                                                    column: 82,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Application.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        body: {
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'CallExpression',
                                                                                callee: {
                                                                                    type: 'Identifier',
                                                                                    name: 'createPaneFrame',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 216,
                                                                                            column: 29,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 216,
                                                                                            column: 44,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                arguments: [{
                                                                                        type: 'Identifier',
                                                                                        name: 'config',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 216,
                                                                                                column: 45,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 216,
                                                                                                column: 51,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            }
                                                                                        }
                                                                                    }],
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 216,
                                                                                        column: 29,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 216,
                                                                                        column: 52,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    }
                                                                                }
                                                                            }
                                                                        },
                                                                        order: '0'
                                                                    }]
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '1'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'fixedPanes',
                                                                loc: {
                                                                    start: {
                                                                        line: 217,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/Application.ion'
                                                                    },
                                                                    end: {
                                                                        line: 217,
                                                                        column: 30,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/Application.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'ObjectExpression',
                                                                objectType: {
                                                                    type: 'ArrayExpression',
                                                                    elements: []
                                                                },
                                                                properties: [{
                                                                        type: 'ForOfStatement',
                                                                        left: {
                                                                            type: 'VariableDeclaration',
                                                                            declarations: [{
                                                                                    type: 'VariableDeclarator',
                                                                                    id: {
                                                                                        type: 'Identifier',
                                                                                        name: 'pane',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 217,
                                                                                                column: 43,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 217,
                                                                                                column: 47,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    init: null
                                                                                }],
                                                                            kind: 'let'
                                                                        },
                                                                        right: {
                                                                            type: 'Identifier',
                                                                            name: 'panes',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 217,
                                                                                    column: 51,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Application.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 217,
                                                                                    column: 56,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Application.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        body: {
                                                                            type: 'BlockStatement',
                                                                            body: [{
                                                                                    type: 'IfStatement',
                                                                                    test: {
                                                                                        type: 'UnaryExpression',
                                                                                        operator: '!',
                                                                                        argument: {
                                                                                            type: 'UnaryExpression',
                                                                                            operator: '?',
                                                                                            argument: {
                                                                                                type: 'MemberExpression',
                                                                                                computed: false,
                                                                                                object: {
                                                                                                    type: 'MemberExpression',
                                                                                                    computed: false,
                                                                                                    object: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'pane',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 217,
                                                                                                                column: 64,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 217,
                                                                                                                column: 68,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    property: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'config',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 217,
                                                                                                                column: 70,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 217,
                                                                                                                column: 76,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    existential: true,
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 217,
                                                                                                            column: 64,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 217,
                                                                                                            column: 76,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'target',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 217,
                                                                                                            column: 78,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 217,
                                                                                                            column: 84,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                existential: true,
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 217,
                                                                                                        column: 64,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 217,
                                                                                                        column: 84,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    consequent: {
                                                                                        type: 'BlockStatement',
                                                                                        body: [{
                                                                                                type: 'ExpressionStatement',
                                                                                                expression: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'pane',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 217,
                                                                                                            column: 34,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 217,
                                                                                                            column: 38,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                order: '0'
                                                                                            }]
                                                                                    },
                                                                                    order: '0'
                                                                                }]
                                                                        },
                                                                        order: '0'
                                                                    }]
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '2'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'showAppBar',
                                                                loc: {
                                                                    start: {
                                                                        line: 218,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/Application.ion'
                                                                    },
                                                                    end: {
                                                                        line: 218,
                                                                        column: 30,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/Application.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'BinaryExpression',
                                                                operator: '&&',
                                                                left: {
                                                                    type: 'Identifier',
                                                                    name: 'canFloatPane',
                                                                    loc: {
                                                                        start: {
                                                                            line: 218,
                                                                            column: 33,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/Application.ion'
                                                                        },
                                                                        end: {
                                                                            line: 218,
                                                                            column: 45,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/Application.ion'
                                                                        }
                                                                    }
                                                                },
                                                                right: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '>',
                                                                    left: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'fixedPanes',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 218,
                                                                                    column: 50,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Application.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 218,
                                                                                    column: 60,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Application.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'length',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 218,
                                                                                    column: 61,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Application.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 218,
                                                                                    column: 67,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Application.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 218,
                                                                                column: 50,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Application.ion'
                                                                            },
                                                                            end: {
                                                                                line: 218,
                                                                                column: 67,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Application.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    right: {
                                                                        type: 'Literal',
                                                                        value: 1
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '3'
                                                },
                                                {
                                                    type: 'IfStatement',
                                                    test: {
                                                        type: 'Identifier',
                                                        name: 'showAppBar',
                                                        loc: {
                                                            start: {
                                                                line: 219,
                                                                column: 19,
                                                                fixed: true,
                                                                source: 'viewpath/html/Application.ion'
                                                            },
                                                            end: {
                                                                line: 219,
                                                                column: 29,
                                                                fixed: true,
                                                                source: 'viewpath/html/Application.ion'
                                                            }
                                                        }
                                                    },
                                                    consequent: {
                                                        type: 'BlockStatement',
                                                        body: [
                                                            {
                                                                type: 'VariableDeclaration',
                                                                declarations: [{
                                                                        type: 'VariableDeclarator',
                                                                        id: {
                                                                            type: 'Identifier',
                                                                            name: 'appBar',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 220,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Application.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 220,
                                                                                    column: 30,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Application.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        init: {
                                                                            type: 'CallExpression',
                                                                            callee: {
                                                                                type: 'Identifier',
                                                                                name: 'PaneBar',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 220,
                                                                                        column: 33,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 220,
                                                                                        column: 40,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            arguments: [],
                                                                            loc: {
                                                                                start: {
                                                                                    line: 220,
                                                                                    column: 33,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Application.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 220,
                                                                                    column: 42,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Application.ion'
                                                                                }
                                                                            }
                                                                        }
                                                                    }],
                                                                kind: 'let',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'ObjectExpression',
                                                                    objectType: {
                                                                        type: 'Identifier',
                                                                        name: 'appBar',
                                                                        loc: {
                                                                            start: {
                                                                                line: 221,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Application.ion'
                                                                            },
                                                                            end: {
                                                                                line: 221,
                                                                                column: 26,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Application.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    properties: [
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'classList',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 222,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 222,
                                                                                        column: 33,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'ObjectExpression',
                                                                                properties: [
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'Literal',
                                                                                            value: 'z2'
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 223,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 223,
                                                                                                column: 32,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'Literal',
                                                                                            value: 'background-primary-darker'
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 224,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 224,
                                                                                                column: 55,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '1'
                                                                                    }
                                                                                ]
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'style',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 225,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 225,
                                                                                        column: 29,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'ObjectExpression',
                                                                                properties: [
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'height',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 226,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 226,
                                                                                                    column: 34,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: '54px'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'paddingLeft',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 227,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 227,
                                                                                                    column: 39,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'BinaryExpression',
                                                                                            operator: '+',
                                                                                            left: {
                                                                                                type: 'BinaryExpression',
                                                                                                operator: '+',
                                                                                                left: {
                                                                                                    type: 'Literal',
                                                                                                    value: ''
                                                                                                },
                                                                                                right: {
                                                                                                    type: 'BinaryExpression',
                                                                                                    operator: '*',
                                                                                                    left: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'buffer',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 227,
                                                                                                                column: 44,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 227,
                                                                                                                column: 50,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    right: {
                                                                                                        type: 'Literal',
                                                                                                        value: 1.5
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            right: {
                                                                                                type: 'Literal',
                                                                                                value: 'px'
                                                                                            }
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '1'
                                                                                    },
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'paddingRight',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 228,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 228,
                                                                                                    column: 40,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'BinaryExpression',
                                                                                            operator: '+',
                                                                                            left: {
                                                                                                type: 'BinaryExpression',
                                                                                                operator: '+',
                                                                                                left: {
                                                                                                    type: 'Literal',
                                                                                                    value: ''
                                                                                                },
                                                                                                right: {
                                                                                                    type: 'BinaryExpression',
                                                                                                    operator: '*',
                                                                                                    left: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'buffer',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 228,
                                                                                                                column: 45,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 228,
                                                                                                                column: 51,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    right: {
                                                                                                        type: 'Literal',
                                                                                                        value: 1.5
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            right: {
                                                                                                type: 'Literal',
                                                                                                value: 'px'
                                                                                            }
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '2'
                                                                                    }
                                                                                ]
                                                                            },
                                                                            kind: 'init',
                                                                            order: '1'
                                                                        },
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'left',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 229,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 229,
                                                                                        column: 28,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'ObjectExpression',
                                                                                properties: [{
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'ObjectExpression',
                                                                                            objectType: {
                                                                                                type: 'CallExpression',
                                                                                                callee: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'Button',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 230,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 230,
                                                                                                            column: 34,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                arguments: [{
                                                                                                        type: 'ObjectExpression',
                                                                                                        properties: [{
                                                                                                                type: 'Property',
                                                                                                                key: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'class',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 230,
                                                                                                                            column: 36,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 230,
                                                                                                                            column: 41,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                value: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: 'white secondary'
                                                                                                                },
                                                                                                                kind: 'init',
                                                                                                                order: '0'
                                                                                                            }]
                                                                                                    }],
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 230,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 230,
                                                                                                        column: 61,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            properties: [
                                                                                                {
                                                                                                    type: 'ExpressionStatement',
                                                                                                    expression: {
                                                                                                        type: 'CallExpression',
                                                                                                        callee: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'Icon',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 231,
                                                                                                                    column: 32,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 231,
                                                                                                                    column: 36,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        arguments: [{
                                                                                                                type: 'ObjectExpression',
                                                                                                                properties: [{
                                                                                                                        type: 'Property',
                                                                                                                        key: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'name',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 231,
                                                                                                                                    column: 38,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 231,
                                                                                                                                    column: 42,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        value: {
                                                                                                                            type: 'Literal',
                                                                                                                            value: 'menu'
                                                                                                                        },
                                                                                                                        kind: 'init',
                                                                                                                        order: '0'
                                                                                                                    }]
                                                                                                            }],
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 231,
                                                                                                                column: 32,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 231,
                                                                                                                column: 51,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 231,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 231,
                                                                                                            column: 51,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                        }
                                                                                                    },
                                                                                                    order: '0'
                                                                                                },
                                                                                                {
                                                                                                    type: 'ExpressionStatement',
                                                                                                    expression: {
                                                                                                        type: 'Function',
                                                                                                        context: true,
                                                                                                        value: function (_context7) {
                                                                                                            return function click(e) {
                                                                                                                var navDrawer = _context7.get('navDrawer');
                                                                                                                return navDrawer.open = true;
                                                                                                            };
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 232,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 232,
                                                                                                            column: 65,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                        }
                                                                                                    },
                                                                                                    order: '1'
                                                                                                }
                                                                                            ]
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 230,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 233,
                                                                                                column: 32,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            kind: 'init',
                                                                            order: '2'
                                                                        },
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'right',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 233,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 233,
                                                                                        column: 29,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'ObjectExpression',
                                                                                properties: [{
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'CallExpression',
                                                                                            callee: {
                                                                                                type: 'Identifier',
                                                                                                name: 'topRightButtons',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 234,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 234,
                                                                                                        column: 43,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            arguments: [],
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 234,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 234,
                                                                                                    column: 45,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 234,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 234,
                                                                                                column: 45,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            kind: 'init',
                                                                            order: '3'
                                                                        },
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'center',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 235,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 235,
                                                                                        column: 30,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'ObjectExpression',
                                                                                properties: [{
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'Literal',
                                                                                            value: 'Viewpath'
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 236,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 236,
                                                                                                column: 38,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            kind: 'init',
                                                                            order: '4'
                                                                        }
                                                                    ]
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 221,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/Application.ion'
                                                                    },
                                                                    end: {
                                                                        line: 238,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/Application.ion'
                                                                    }
                                                                },
                                                                order: '1'
                                                            }
                                                        ]
                                                    },
                                                    alternate: null,
                                                    order: '4'
                                                },
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'Div',
                                                                loc: {
                                                                    start: {
                                                                        line: 238,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/Application.ion'
                                                                    },
                                                                    end: {
                                                                        line: 238,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/Application.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [{
                                                                    type: 'ObjectExpression',
                                                                    properties: [{
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'class',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 238,
                                                                                        column: 21,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 238,
                                                                                        column: 26,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'fill layout horizontal'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        }]
                                                                }],
                                                            loc: {
                                                                start: {
                                                                    line: 238,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/Application.ion'
                                                                },
                                                                end: {
                                                                    line: 238,
                                                                    column: 53,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/Application.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'style',
                                                                    loc: {
                                                                        start: {
                                                                            line: 239,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/Application.ion'
                                                                        },
                                                                        end: {
                                                                            line: 239,
                                                                            column: 25,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/Application.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'ObjectExpression',
                                                                    properties: [{
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'margin',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 240,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 240,
                                                                                        column: 30,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'ConditionalExpression',
                                                                                test: {
                                                                                    type: 'Identifier',
                                                                                    name: 'showAppBar',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 240,
                                                                                            column: 32,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 240,
                                                                                            column: 42,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                consequent: {
                                                                                    type: 'BinaryExpression',
                                                                                    operator: '+',
                                                                                    left: {
                                                                                        type: 'BinaryExpression',
                                                                                        operator: '+',
                                                                                        left: {
                                                                                            type: 'Literal',
                                                                                            value: ''
                                                                                        },
                                                                                        right: {
                                                                                            type: 'Identifier',
                                                                                            name: 'buffer',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 240,
                                                                                                    column: 48,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 240,
                                                                                                    column: 54,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                }
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    right: {
                                                                                        type: 'Literal',
                                                                                        value: 'px'
                                                                                    }
                                                                                },
                                                                                alternate: {
                                                                                    type: 'Literal',
                                                                                    value: 'initial'
                                                                                }
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'ForOfStatement',
                                                                left: {
                                                                    type: 'VariableDeclaration',
                                                                    declarations: [
                                                                        {
                                                                            type: 'VariableDeclarator',
                                                                            id: {
                                                                                type: 'Identifier',
                                                                                name: 'pane',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 241,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 241,
                                                                                        column: 28,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            init: null
                                                                        },
                                                                        {
                                                                            type: 'VariableDeclarator',
                                                                            id: {
                                                                                type: 'Identifier',
                                                                                name: 'index',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 241,
                                                                                        column: 30,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 241,
                                                                                        column: 35,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Application.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            init: null
                                                                        }
                                                                    ],
                                                                    kind: 'let'
                                                                },
                                                                right: {
                                                                    type: 'Identifier',
                                                                    name: 'panes',
                                                                    loc: {
                                                                        start: {
                                                                            line: 241,
                                                                            column: 39,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/Application.ion'
                                                                        },
                                                                        end: {
                                                                            line: 241,
                                                                            column: 44,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/Application.ion'
                                                                        }
                                                                    }
                                                                },
                                                                body: {
                                                                    type: 'BlockStatement',
                                                                    body: [{
                                                                            type: 'IfStatement',
                                                                            test: {
                                                                                type: 'BinaryExpression',
                                                                                operator: '===',
                                                                                left: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'pane',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 242,
                                                                                                    column: 27,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 242,
                                                                                                    column: 31,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'config',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 242,
                                                                                                    column: 32,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 242,
                                                                                                    column: 38,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 242,
                                                                                                column: 27,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 242,
                                                                                                column: 38,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'target',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 242,
                                                                                                column: 40,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 242,
                                                                                                column: 46,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    existential: true,
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 242,
                                                                                            column: 27,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 242,
                                                                                            column: 46,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Application.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                right: {
                                                                                    type: 'Literal',
                                                                                    value: 'float'
                                                                                }
                                                                            },
                                                                            consequent: {
                                                                                type: 'BlockStatement',
                                                                                body: [{
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'ObjectExpression',
                                                                                            objectType: {
                                                                                                type: 'Identifier',
                                                                                                name: 'pane',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 243,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 243,
                                                                                                        column: 32,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            properties: [
                                                                                                {
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'header',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 244,
                                                                                                                column: 32,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 244,
                                                                                                                column: 38,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'ObjectExpression',
                                                                                                        properties: [
                                                                                                            {
                                                                                                                type: 'Property',
                                                                                                                key: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'left',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 245,
                                                                                                                            column: 36,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 245,
                                                                                                                            column: 40,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                value: {
                                                                                                                    type: 'ObjectExpression',
                                                                                                                    properties: [{
                                                                                                                            type: 'ExpressionStatement',
                                                                                                                            expression: {
                                                                                                                                type: 'ObjectExpression',
                                                                                                                                objectType: {
                                                                                                                                    type: 'CallExpression',
                                                                                                                                    callee: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'Button',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 246,
                                                                                                                                                column: 40,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 246,
                                                                                                                                                column: 46,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    arguments: [{
                                                                                                                                            type: 'ObjectExpression',
                                                                                                                                            properties: [{
                                                                                                                                                    type: 'Property',
                                                                                                                                                    key: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'class',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 246,
                                                                                                                                                                column: 48,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 246,
                                                                                                                                                                column: 53,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    value: {
                                                                                                                                                        type: 'Literal',
                                                                                                                                                        value: 'white secondary'
                                                                                                                                                    },
                                                                                                                                                    kind: 'init',
                                                                                                                                                    order: '0'
                                                                                                                                                }]
                                                                                                                                        }],
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 246,
                                                                                                                                            column: 40,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 246,
                                                                                                                                            column: 73,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                properties: [
                                                                                                                                    {
                                                                                                                                        type: 'ExpressionStatement',
                                                                                                                                        expression: {
                                                                                                                                            type: 'CallExpression',
                                                                                                                                            callee: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'Icon',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 247,
                                                                                                                                                        column: 44,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 247,
                                                                                                                                                        column: 48,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            arguments: [{
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    properties: [{
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'name',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 247,
                                                                                                                                                                        column: 50,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 247,
                                                                                                                                                                        column: 54,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'ConditionalExpression',
                                                                                                                                                                test: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'canFloatPane',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 247,
                                                                                                                                                                            column: 56,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 247,
                                                                                                                                                                            column: 68,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                consequent: {
                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                    value: 'arrow forward'
                                                                                                                                                                },
                                                                                                                                                                alternate: {
                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                    value: 'arrow back'
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '0'
                                                                                                                                                        }]
                                                                                                                                                }],
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 247,
                                                                                                                                                    column: 44,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 247,
                                                                                                                                                    column: 103,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 247,
                                                                                                                                                column: 44,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 247,
                                                                                                                                                column: 103,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        order: '0'
                                                                                                                                    },
                                                                                                                                    {
                                                                                                                                        type: 'ExpressionStatement',
                                                                                                                                        expression: {
                                                                                                                                            type: 'Function',
                                                                                                                                            context: true,
                                                                                                                                            value: function (_context8) {
                                                                                                                                                return function click(e) {
                                                                                                                                                    var pane = _context8.get('pane');
                                                                                                                                                    model.close(pane.config);
                                                                                                                                                };
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 248,
                                                                                                                                                column: 44,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 250,
                                                                                                                                                column: 48,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        order: '1'
                                                                                                                                    }
                                                                                                                                ]
                                                                                                                            },
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 246,
                                                                                                                                    column: 40,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 250,
                                                                                                                                    column: 44,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                }
                                                                                                                            },
                                                                                                                            order: '0'
                                                                                                                        }]
                                                                                                                },
                                                                                                                kind: 'init',
                                                                                                                order: '0'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'Property',
                                                                                                                key: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'right',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 250,
                                                                                                                            column: 36,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 250,
                                                                                                                            column: 41,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                value: {
                                                                                                                    type: 'ObjectExpression',
                                                                                                                    properties: [{
                                                                                                                            type: 'IfStatement',
                                                                                                                            test: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'canFloatPane',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 251,
                                                                                                                                        column: 43,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 251,
                                                                                                                                        column: 55,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            consequent: {
                                                                                                                                type: 'BlockStatement',
                                                                                                                                body: [
                                                                                                                                    {
                                                                                                                                        type: 'ExpressionStatement',
                                                                                                                                        expression: {
                                                                                                                                            type: 'ObjectExpression',
                                                                                                                                            objectType: {
                                                                                                                                                type: 'CallExpression',
                                                                                                                                                callee: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'Button',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 252,
                                                                                                                                                            column: 44,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 252,
                                                                                                                                                            column: 50,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                arguments: [{
                                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                                        properties: [{
                                                                                                                                                                type: 'Property',
                                                                                                                                                                key: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'class',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 252,
                                                                                                                                                                            column: 52,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 252,
                                                                                                                                                                            column: 57,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                value: {
                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                    value: 'white secondary'
                                                                                                                                                                },
                                                                                                                                                                kind: 'init',
                                                                                                                                                                order: '0'
                                                                                                                                                            }]
                                                                                                                                                    }],
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 252,
                                                                                                                                                        column: 44,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 252,
                                                                                                                                                        column: 77,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            properties: [
                                                                                                                                                {
                                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                                    expression: {
                                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                                        objectType: {
                                                                                                                                                            type: 'CallExpression',
                                                                                                                                                            callee: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'Icon',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 253,
                                                                                                                                                                        column: 48,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 253,
                                                                                                                                                                        column: 52,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            arguments: [{
                                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                                    properties: [{
                                                                                                                                                                            type: 'Property',
                                                                                                                                                                            key: {
                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                name: 'name',
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 253,
                                                                                                                                                                                        column: 54,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 253,
                                                                                                                                                                                        column: 58,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            value: {
                                                                                                                                                                                type: 'Literal',
                                                                                                                                                                                value: 'arrow back'
                                                                                                                                                                            },
                                                                                                                                                                            kind: 'init',
                                                                                                                                                                            order: '0'
                                                                                                                                                                        }]
                                                                                                                                                                }],
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 253,
                                                                                                                                                                    column: 48,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 253,
                                                                                                                                                                    column: 73,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        properties: [{
                                                                                                                                                                type: 'Property',
                                                                                                                                                                key: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'style',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 254,
                                                                                                                                                                            column: 52,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 254,
                                                                                                                                                                            column: 57,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                value: {
                                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                                    properties: [{
                                                                                                                                                                            type: 'Property',
                                                                                                                                                                            key: {
                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                name: 'transform',
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 255,
                                                                                                                                                                                        column: 56,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 255,
                                                                                                                                                                                        column: 65,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            value: {
                                                                                                                                                                                type: 'Literal',
                                                                                                                                                                                value: 'rotate(135deg)'
                                                                                                                                                                            },
                                                                                                                                                                            kind: 'init',
                                                                                                                                                                            order: '0'
                                                                                                                                                                        }]
                                                                                                                                                                },
                                                                                                                                                                kind: 'init',
                                                                                                                                                                order: '0'
                                                                                                                                                            }]
                                                                                                                                                    },
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 253,
                                                                                                                                                            column: 48,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 256,
                                                                                                                                                            column: 52,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    order: '0'
                                                                                                                                                },
                                                                                                                                                {
                                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                                    expression: {
                                                                                                                                                        type: 'Function',
                                                                                                                                                        context: true,
                                                                                                                                                        value: function (_context9) {
                                                                                                                                                            return function click(e) {
                                                                                                                                                                var pane = _context9.get('pane');
                                                                                                                                                                model.open(pane.config);
                                                                                                                                                            };
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 256,
                                                                                                                                                            column: 48,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 258,
                                                                                                                                                            column: 52,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    order: '1'
                                                                                                                                                }
                                                                                                                                            ]
                                                                                                                                        },
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 252,
                                                                                                                                                column: 44,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 258,
                                                                                                                                                column: 48,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        order: '0'
                                                                                                                                    },
                                                                                                                                    {
                                                                                                                                        type: 'ExpressionStatement',
                                                                                                                                        expression: {
                                                                                                                                            type: 'ObjectExpression',
                                                                                                                                            objectType: {
                                                                                                                                                type: 'CallExpression',
                                                                                                                                                callee: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'Button',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 258,
                                                                                                                                                            column: 44,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 258,
                                                                                                                                                            column: 50,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                arguments: [{
                                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                                        properties: [{
                                                                                                                                                                type: 'Property',
                                                                                                                                                                key: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'class',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 258,
                                                                                                                                                                            column: 52,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 258,
                                                                                                                                                                            column: 57,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                value: {
                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                    value: 'white secondary'
                                                                                                                                                                },
                                                                                                                                                                kind: 'init',
                                                                                                                                                                order: '0'
                                                                                                                                                            }]
                                                                                                                                                    }],
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 258,
                                                                                                                                                        column: 44,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 258,
                                                                                                                                                        column: 77,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            properties: [
                                                                                                                                                {
                                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                                    expression: {
                                                                                                                                                        type: 'CallExpression',
                                                                                                                                                        callee: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'Icon',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 259,
                                                                                                                                                                    column: 48,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 259,
                                                                                                                                                                    column: 52,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        arguments: [{
                                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                                properties: [{
                                                                                                                                                                        type: 'Property',
                                                                                                                                                                        key: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'name',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 259,
                                                                                                                                                                                    column: 54,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 259,
                                                                                                                                                                                    column: 58,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        value: {
                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                            value: 'pin drop'
                                                                                                                                                                        },
                                                                                                                                                                        kind: 'init',
                                                                                                                                                                        order: '0'
                                                                                                                                                                    }]
                                                                                                                                                            }],
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 259,
                                                                                                                                                                column: 48,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 259,
                                                                                                                                                                column: 71,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 259,
                                                                                                                                                            column: 48,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 259,
                                                                                                                                                            column: 71,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    order: '0'
                                                                                                                                                },
                                                                                                                                                {
                                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                                    expression: {
                                                                                                                                                        type: 'Function',
                                                                                                                                                        context: true,
                                                                                                                                                        value: function (_context10) {
                                                                                                                                                            return function click(e) {
                                                                                                                                                                var pane = _context10.get('pane');
                                                                                                                                                                delete pane.config.target;
                                                                                                                                                            };
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 260,
                                                                                                                                                            column: 48,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 263,
                                                                                                                                                            column: 52,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    order: '1'
                                                                                                                                                }
                                                                                                                                            ]
                                                                                                                                        },
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 258,
                                                                                                                                                column: 44,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 263,
                                                                                                                                                column: 48,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        order: '1'
                                                                                                                                    }
                                                                                                                                ]
                                                                                                                            },
                                                                                                                            alternate: null,
                                                                                                                            order: '0'
                                                                                                                        }]
                                                                                                                },
                                                                                                                kind: 'init',
                                                                                                                order: '1'
                                                                                                            }
                                                                                                        ]
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '0'
                                                                                                },
                                                                                                {
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'style',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 263,
                                                                                                                column: 32,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 263,
                                                                                                                column: 37,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'ObjectExpression',
                                                                                                        properties: [{
                                                                                                                type: 'IfStatement',
                                                                                                                test: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'canFloatPane',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 264,
                                                                                                                            column: 39,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 264,
                                                                                                                            column: 51,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                consequent: {
                                                                                                                    type: 'BlockStatement',
                                                                                                                    body: [
                                                                                                                        {
                                                                                                                            type: 'VariableDeclaration',
                                                                                                                            declarations: [{
                                                                                                                                    type: 'VariableDeclarator',
                                                                                                                                    id: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'space',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 265,
                                                                                                                                                column: 44,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 265,
                                                                                                                                                column: 49,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    init: {
                                                                                                                                        type: 'Literal',
                                                                                                                                        value: 10
                                                                                                                                    }
                                                                                                                                }],
                                                                                                                            kind: 'let',
                                                                                                                            order: '0'
                                                                                                                        },
                                                                                                                        {
                                                                                                                            type: 'Property',
                                                                                                                            key: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'position',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 266,
                                                                                                                                        column: 40,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 266,
                                                                                                                                        column: 48,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            value: {
                                                                                                                                type: 'Literal',
                                                                                                                                value: 'absolute'
                                                                                                                            },
                                                                                                                            kind: 'init',
                                                                                                                            order: '1'
                                                                                                                        },
                                                                                                                        {
                                                                                                                            type: 'Property',
                                                                                                                            key: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'width',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 267,
                                                                                                                                        column: 40,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 267,
                                                                                                                                        column: 45,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            value: {
                                                                                                                                type: 'Literal',
                                                                                                                                value: '500px'
                                                                                                                            },
                                                                                                                            kind: 'init',
                                                                                                                            order: '2'
                                                                                                                        },
                                                                                                                        {
                                                                                                                            type: 'Property',
                                                                                                                            key: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'top',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 268,
                                                                                                                                        column: 40,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 268,
                                                                                                                                        column: 43,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            value: {
                                                                                                                                type: 'BinaryExpression',
                                                                                                                                operator: '+',
                                                                                                                                left: {
                                                                                                                                    type: 'BinaryExpression',
                                                                                                                                    operator: '+',
                                                                                                                                    left: {
                                                                                                                                        type: 'Literal',
                                                                                                                                        value: ''
                                                                                                                                    },
                                                                                                                                    right: {
                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                        operator: '+',
                                                                                                                                        left: {
                                                                                                                                            type: 'MemberExpression',
                                                                                                                                            computed: false,
                                                                                                                                            object: {
                                                                                                                                                type: 'MemberExpression',
                                                                                                                                                computed: false,
                                                                                                                                                object: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'style',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 268,
                                                                                                                                                            column: 48,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 268,
                                                                                                                                                            column: 53,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                property: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'spacing',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 268,
                                                                                                                                                            column: 54,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 268,
                                                                                                                                                            column: 61,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 268,
                                                                                                                                                        column: 48,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 268,
                                                                                                                                                        column: 61,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            property: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'appBarHeight',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 268,
                                                                                                                                                        column: 62,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 268,
                                                                                                                                                        column: 74,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 268,
                                                                                                                                                    column: 48,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 268,
                                                                                                                                                    column: 74,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        right: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'space',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 268,
                                                                                                                                                    column: 77,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 268,
                                                                                                                                                    column: 82,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                right: {
                                                                                                                                    type: 'Literal',
                                                                                                                                    value: 'px'
                                                                                                                                }
                                                                                                                            },
                                                                                                                            kind: 'init',
                                                                                                                            order: '3'
                                                                                                                        },
                                                                                                                        {
                                                                                                                            type: 'Property',
                                                                                                                            key: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'right',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 269,
                                                                                                                                        column: 40,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 269,
                                                                                                                                        column: 45,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            value: {
                                                                                                                                type: 'Literal',
                                                                                                                                value: '0%'
                                                                                                                            },
                                                                                                                            kind: 'init',
                                                                                                                            order: '4'
                                                                                                                        },
                                                                                                                        {
                                                                                                                            type: 'Property',
                                                                                                                            key: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'left',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 270,
                                                                                                                                        column: 40,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 270,
                                                                                                                                        column: 44,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            value: {
                                                                                                                                type: 'Literal',
                                                                                                                                value: 'initial'
                                                                                                                            },
                                                                                                                            kind: 'init',
                                                                                                                            order: '5'
                                                                                                                        },
                                                                                                                        {
                                                                                                                            type: 'Property',
                                                                                                                            key: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'height',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 271,
                                                                                                                                        column: 40,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 271,
                                                                                                                                        column: 46,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            value: {
                                                                                                                                type: 'BinaryExpression',
                                                                                                                                operator: '+',
                                                                                                                                left: {
                                                                                                                                    type: 'BinaryExpression',
                                                                                                                                    operator: '+',
                                                                                                                                    left: {
                                                                                                                                        type: 'Literal',
                                                                                                                                        value: ''
                                                                                                                                    },
                                                                                                                                    right: {
                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                        operator: '-',
                                                                                                                                        left: {
                                                                                                                                            type: 'MemberExpression',
                                                                                                                                            computed: false,
                                                                                                                                            object: {
                                                                                                                                                type: 'MemberExpression',
                                                                                                                                                computed: false,
                                                                                                                                                object: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'document',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 271,
                                                                                                                                                            column: 51,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 271,
                                                                                                                                                            column: 59,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                property: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'body',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 271,
                                                                                                                                                            column: 60,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 271,
                                                                                                                                                            column: 64,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 271,
                                                                                                                                                        column: 51,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 271,
                                                                                                                                                        column: 64,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            property: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'clientHeight',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 271,
                                                                                                                                                        column: 65,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 271,
                                                                                                                                                        column: 77,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 271,
                                                                                                                                                    column: 51,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 271,
                                                                                                                                                    column: 77,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        right: {
                                                                                                                                            type: 'BinaryExpression',
                                                                                                                                            operator: '+',
                                                                                                                                            left: {
                                                                                                                                                type: 'BinaryExpression',
                                                                                                                                                operator: '*',
                                                                                                                                                left: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'space',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 271,
                                                                                                                                                            column: 81,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 271,
                                                                                                                                                            column: 86,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                right: {
                                                                                                                                                    type: 'Literal',
                                                                                                                                                    value: 2
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            right: {
                                                                                                                                                type: 'MemberExpression',
                                                                                                                                                computed: false,
                                                                                                                                                object: {
                                                                                                                                                    type: 'MemberExpression',
                                                                                                                                                    computed: false,
                                                                                                                                                    object: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'style',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 271,
                                                                                                                                                                column: 93,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 271,
                                                                                                                                                                column: 98,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    property: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'spacing',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 271,
                                                                                                                                                                column: 99,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 271,
                                                                                                                                                                column: 106,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 271,
                                                                                                                                                            column: 93,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 271,
                                                                                                                                                            column: 106,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                property: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'appBarHeight',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 271,
                                                                                                                                                            column: 107,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 271,
                                                                                                                                                            column: 119,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 271,
                                                                                                                                                        column: 93,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 271,
                                                                                                                                                        column: 119,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                right: {
                                                                                                                                    type: 'Literal',
                                                                                                                                    value: 'px'
                                                                                                                                }
                                                                                                                            },
                                                                                                                            kind: 'init',
                                                                                                                            order: '6'
                                                                                                                        },
                                                                                                                        {
                                                                                                                            type: 'Property',
                                                                                                                            key: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'margin',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 272,
                                                                                                                                        column: 40,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 272,
                                                                                                                                        column: 46,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            value: {
                                                                                                                                type: 'Literal',
                                                                                                                                value: '0px'
                                                                                                                            },
                                                                                                                            kind: 'init',
                                                                                                                            order: '7'
                                                                                                                        },
                                                                                                                        {
                                                                                                                            type: 'Property',
                                                                                                                            key: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'maxWidth',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 273,
                                                                                                                                        column: 40,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 273,
                                                                                                                                        column: 48,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            value: {
                                                                                                                                type: 'Literal',
                                                                                                                                value: '50%'
                                                                                                                            },
                                                                                                                            kind: 'init',
                                                                                                                            order: '8'
                                                                                                                        }
                                                                                                                    ]
                                                                                                                },
                                                                                                                alternate: {
                                                                                                                    type: 'BlockStatement',
                                                                                                                    body: [
                                                                                                                        {
                                                                                                                            type: 'Property',
                                                                                                                            key: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'position',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 275,
                                                                                                                                        column: 40,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 275,
                                                                                                                                        column: 48,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            value: {
                                                                                                                                type: 'Literal',
                                                                                                                                value: 'absolute'
                                                                                                                            },
                                                                                                                            kind: 'init',
                                                                                                                            order: '0'
                                                                                                                        },
                                                                                                                        {
                                                                                                                            type: 'Property',
                                                                                                                            key: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'width',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 276,
                                                                                                                                        column: 40,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 276,
                                                                                                                                        column: 45,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            value: {
                                                                                                                                type: 'Literal',
                                                                                                                                value: '100%'
                                                                                                                            },
                                                                                                                            kind: 'init',
                                                                                                                            order: '1'
                                                                                                                        },
                                                                                                                        {
                                                                                                                            type: 'Property',
                                                                                                                            key: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'height',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 277,
                                                                                                                                        column: 40,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 277,
                                                                                                                                        column: 46,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            value: {
                                                                                                                                type: 'Literal',
                                                                                                                                value: '100%'
                                                                                                                            },
                                                                                                                            kind: 'init',
                                                                                                                            order: '2'
                                                                                                                        },
                                                                                                                        {
                                                                                                                            type: 'Property',
                                                                                                                            key: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'maxWidth',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 278,
                                                                                                                                        column: 40,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 278,
                                                                                                                                        column: 48,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            value: {
                                                                                                                                type: 'Literal',
                                                                                                                                value: '100vw'
                                                                                                                            },
                                                                                                                            kind: 'init',
                                                                                                                            order: '3'
                                                                                                                        },
                                                                                                                        {
                                                                                                                            type: 'Property',
                                                                                                                            key: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'right',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 279,
                                                                                                                                        column: 40,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 279,
                                                                                                                                        column: 45,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            value: {
                                                                                                                                type: 'Literal',
                                                                                                                                value: 'initial'
                                                                                                                            },
                                                                                                                            kind: 'init',
                                                                                                                            order: '4'
                                                                                                                        },
                                                                                                                        {
                                                                                                                            type: 'Property',
                                                                                                                            key: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'top',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 280,
                                                                                                                                        column: 40,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 280,
                                                                                                                                        column: 43,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            value: {
                                                                                                                                type: 'Literal',
                                                                                                                                value: '0px'
                                                                                                                            },
                                                                                                                            kind: 'init',
                                                                                                                            order: '5'
                                                                                                                        },
                                                                                                                        {
                                                                                                                            type: 'Property',
                                                                                                                            key: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'left',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 281,
                                                                                                                                        column: 40,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 281,
                                                                                                                                        column: 44,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            value: {
                                                                                                                                type: 'Literal',
                                                                                                                                value: '0px'
                                                                                                                            },
                                                                                                                            kind: 'init',
                                                                                                                            order: '6'
                                                                                                                        }
                                                                                                                    ]
                                                                                                                },
                                                                                                                order: '0'
                                                                                                            }]
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '1'
                                                                                                }
                                                                                            ]
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 243,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 282,
                                                                                                column: 32,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            alternate: {
                                                                                type: 'IfStatement',
                                                                                test: {
                                                                                    type: 'BinaryExpression',
                                                                                    operator: '===',
                                                                                    left: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'MemberExpression',
                                                                                            computed: false,
                                                                                            object: {
                                                                                                type: 'Identifier',
                                                                                                name: 'pane',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 282,
                                                                                                        column: 32,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 282,
                                                                                                        column: 36,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            property: {
                                                                                                type: 'Identifier',
                                                                                                name: 'config',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 282,
                                                                                                        column: 37,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 282,
                                                                                                        column: 43,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 282,
                                                                                                    column: 32,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 282,
                                                                                                    column: 43,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'target',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 282,
                                                                                                    column: 45,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 282,
                                                                                                    column: 51,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        existential: true,
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 282,
                                                                                                column: 32,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 282,
                                                                                                column: 51,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Application.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    right: {
                                                                                        type: 'Literal',
                                                                                        value: 'dialog'
                                                                                    }
                                                                                },
                                                                                consequent: {
                                                                                    type: 'BlockStatement',
                                                                                    body: [
                                                                                        {
                                                                                            type: 'VariableDeclaration',
                                                                                            declarations: [{
                                                                                                    type: 'VariableDeclarator',
                                                                                                    id: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'dialog',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 283,
                                                                                                                column: 32,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 283,
                                                                                                                column: 38,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    init: {
                                                                                                        type: 'ObjectExpression',
                                                                                                        objectType: {
                                                                                                            type: 'CallExpression',
                                                                                                            callee: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'Dialog',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 283,
                                                                                                                        column: 41,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 283,
                                                                                                                        column: 47,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            arguments: [],
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 283,
                                                                                                                    column: 41,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 283,
                                                                                                                    column: 49,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        properties: [{
                                                                                                                type: 'Property',
                                                                                                                key: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'open',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 284,
                                                                                                                            column: 32,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 284,
                                                                                                                            column: 36,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                value: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: true
                                                                                                                },
                                                                                                                kind: 'init',
                                                                                                                order: '0'
                                                                                                            }]
                                                                                                    }
                                                                                                }],
                                                                                            kind: 'let',
                                                                                            order: '0'
                                                                                        },
                                                                                        {
                                                                                            type: 'IfStatement',
                                                                                            test: {
                                                                                                type: 'UnaryExpression',
                                                                                                operator: '!',
                                                                                                argument: {
                                                                                                    type: 'MemberExpression',
                                                                                                    computed: false,
                                                                                                    object: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'dialog',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 285,
                                                                                                                column: 35,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 285,
                                                                                                                column: 41,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    property: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'open',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 285,
                                                                                                                column: 42,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 285,
                                                                                                                column: 46,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 285,
                                                                                                            column: 35,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 285,
                                                                                                            column: 46,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                        }
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            consequent: {
                                                                                                type: 'BlockStatement',
                                                                                                body: [{
                                                                                                        type: 'ExpressionStatement',
                                                                                                        expression: {
                                                                                                            type: 'CallExpression',
                                                                                                            callee: {
                                                                                                                type: 'Function',
                                                                                                                context: true,
                                                                                                                value: function (_context11) {
                                                                                                                    return function () {
                                                                                                                        var pane = _context11.get('pane');
                                                                                                                        return model.close(pane.config);
                                                                                                                    };
                                                                                                                }
                                                                                                            },
                                                                                                            arguments: [],
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 286,
                                                                                                                    column: 32,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 286,
                                                                                                                    column: 62,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 286,
                                                                                                                column: 32,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 286,
                                                                                                                column: 62,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            }
                                                                                                        },
                                                                                                        order: '0'
                                                                                                    }]
                                                                                            },
                                                                                            alternate: null,
                                                                                            order: '1'
                                                                                        },
                                                                                        {
                                                                                            type: 'ExpressionStatement',
                                                                                            expression: {
                                                                                                type: 'ObjectExpression',
                                                                                                objectType: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'dialog',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 287,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 287,
                                                                                                            column: 34,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                properties: [
                                                                                                    {
                                                                                                        type: 'ExpressionStatement',
                                                                                                        expression: {
                                                                                                            type: 'Function',
                                                                                                            context: true,
                                                                                                            value: function (_context12) {
                                                                                                                return function click(e) {
                                                                                                                    var dialog = _context12.get('dialog');
                                                                                                                    return dialog.open = false;
                                                                                                                };
                                                                                                            }
                                                                                                        },
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 288,
                                                                                                                column: 32,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 288,
                                                                                                                column: 63,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            }
                                                                                                        },
                                                                                                        order: '0'
                                                                                                    },
                                                                                                    {
                                                                                                        type: 'Property',
                                                                                                        key: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'frame',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 289,
                                                                                                                    column: 32,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 289,
                                                                                                                    column: 37,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        value: {
                                                                                                            type: 'ObjectExpression',
                                                                                                            properties: [
                                                                                                                {
                                                                                                                    type: 'Property',
                                                                                                                    key: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'style',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 290,
                                                                                                                                column: 36,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 290,
                                                                                                                                column: 41,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    value: {
                                                                                                                        type: 'ObjectExpression',
                                                                                                                        properties: [
                                                                                                                            {
                                                                                                                                type: 'Property',
                                                                                                                                key: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'minHeight',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 291,
                                                                                                                                            column: 40,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 291,
                                                                                                                                            column: 49,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                value: {
                                                                                                                                    type: 'Literal',
                                                                                                                                    value: '600px'
                                                                                                                                },
                                                                                                                                kind: 'init',
                                                                                                                                order: '0'
                                                                                                                            },
                                                                                                                            {
                                                                                                                                type: 'Property',
                                                                                                                                key: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'padding',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 292,
                                                                                                                                            column: 40,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 292,
                                                                                                                                            column: 47,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                value: {
                                                                                                                                    type: 'Literal',
                                                                                                                                    value: '0px'
                                                                                                                                },
                                                                                                                                kind: 'init',
                                                                                                                                order: '1'
                                                                                                                            }
                                                                                                                        ]
                                                                                                                    },
                                                                                                                    kind: 'init',
                                                                                                                    order: '0'
                                                                                                                },
                                                                                                                {
                                                                                                                    type: 'ExpressionStatement',
                                                                                                                    expression: {
                                                                                                                        type: 'ObjectExpression',
                                                                                                                        objectType: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'pane',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 293,
                                                                                                                                    column: 36,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 293,
                                                                                                                                    column: 40,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        properties: [{
                                                                                                                                type: 'Property',
                                                                                                                                key: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'header',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 294,
                                                                                                                                            column: 40,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 294,
                                                                                                                                            column: 46,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                value: {
                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                    properties: [
                                                                                                                                        {
                                                                                                                                            type: 'Property',
                                                                                                                                            key: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'left',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 295,
                                                                                                                                                        column: 44,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 295,
                                                                                                                                                        column: 48,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            value: {
                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                properties: [{
                                                                                                                                                        type: 'ExpressionStatement',
                                                                                                                                                        expression: {
                                                                                                                                                            type: 'ObjectExpression',
                                                                                                                                                            objectType: {
                                                                                                                                                                type: 'CallExpression',
                                                                                                                                                                callee: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'Button',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 296,
                                                                                                                                                                            column: 48,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 296,
                                                                                                                                                                            column: 54,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                arguments: [{
                                                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                                                        properties: [{
                                                                                                                                                                                type: 'Property',
                                                                                                                                                                                key: {
                                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                                    name: 'class',
                                                                                                                                                                                    loc: {
                                                                                                                                                                                        start: {
                                                                                                                                                                                            line: 296,
                                                                                                                                                                                            column: 56,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                                                        },
                                                                                                                                                                                        end: {
                                                                                                                                                                                            line: 296,
                                                                                                                                                                                            column: 61,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                                                        }
                                                                                                                                                                                    }
                                                                                                                                                                                },
                                                                                                                                                                                value: {
                                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                                    value: 'white secondary'
                                                                                                                                                                                },
                                                                                                                                                                                kind: 'init',
                                                                                                                                                                                order: '0'
                                                                                                                                                                            }]
                                                                                                                                                                    }],
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 296,
                                                                                                                                                                        column: 48,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 296,
                                                                                                                                                                        column: 81,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            properties: [
                                                                                                                                                                {
                                                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                                                    expression: {
                                                                                                                                                                        type: 'CallExpression',
                                                                                                                                                                        callee: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'Icon',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 297,
                                                                                                                                                                                    column: 52,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 297,
                                                                                                                                                                                    column: 56,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        arguments: [{
                                                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                                                properties: [{
                                                                                                                                                                                        type: 'Property',
                                                                                                                                                                                        key: {
                                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                                            name: 'name',
                                                                                                                                                                                            loc: {
                                                                                                                                                                                                start: {
                                                                                                                                                                                                    line: 297,
                                                                                                                                                                                                    column: 58,
                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                                                                },
                                                                                                                                                                                                end: {
                                                                                                                                                                                                    line: 297,
                                                                                                                                                                                                    column: 62,
                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                                                                }
                                                                                                                                                                                            }
                                                                                                                                                                                        },
                                                                                                                                                                                        value: {
                                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                                            value: 'close'
                                                                                                                                                                                        },
                                                                                                                                                                                        kind: 'init',
                                                                                                                                                                                        order: '0'
                                                                                                                                                                                    }]
                                                                                                                                                                            }],
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 297,
                                                                                                                                                                                column: 52,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 297,
                                                                                                                                                                                column: 73,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 297,
                                                                                                                                                                            column: 52,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 297,
                                                                                                                                                                            column: 73,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    order: '0'
                                                                                                                                                                },
                                                                                                                                                                {
                                                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                                                    expression: {
                                                                                                                                                                        type: 'Function',
                                                                                                                                                                        context: true,
                                                                                                                                                                        value: function (_context13) {
                                                                                                                                                                            return function click(e) {
                                                                                                                                                                                var dialog = _context13.get('dialog');
                                                                                                                                                                                return dialog.open = false;
                                                                                                                                                                            };
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 298,
                                                                                                                                                                            column: 52,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 298,
                                                                                                                                                                            column: 83,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    order: '1'
                                                                                                                                                                }
                                                                                                                                                            ]
                                                                                                                                                        },
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 296,
                                                                                                                                                                column: 48,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 299,
                                                                                                                                                                column: 52,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        order: '0'
                                                                                                                                                    }]
                                                                                                                                            },
                                                                                                                                            kind: 'init',
                                                                                                                                            order: '0'
                                                                                                                                        },
                                                                                                                                        {
                                                                                                                                            type: 'Property',
                                                                                                                                            key: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'right',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 299,
                                                                                                                                                        column: 44,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 299,
                                                                                                                                                        column: 49,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            value: {
                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                properties: [{
                                                                                                                                                        type: 'IfStatement',
                                                                                                                                                        test: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'canFloatPane',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 300,
                                                                                                                                                                    column: 51,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 300,
                                                                                                                                                                    column: 63,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        consequent: {
                                                                                                                                                            type: 'BlockStatement',
                                                                                                                                                            body: [
                                                                                                                                                                {
                                                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                                                    expression: {
                                                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                                                        objectType: {
                                                                                                                                                                            type: 'CallExpression',
                                                                                                                                                                            callee: {
                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                name: 'Button',
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 301,
                                                                                                                                                                                        column: 52,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 301,
                                                                                                                                                                                        column: 58,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            arguments: [{
                                                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                                                    properties: [{
                                                                                                                                                                                            type: 'Property',
                                                                                                                                                                                            key: {
                                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                                name: 'class',
                                                                                                                                                                                                loc: {
                                                                                                                                                                                                    start: {
                                                                                                                                                                                                        line: 301,
                                                                                                                                                                                                        column: 60,
                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                                                                    },
                                                                                                                                                                                                    end: {
                                                                                                                                                                                                        line: 301,
                                                                                                                                                                                                        column: 65,
                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                                                                    }
                                                                                                                                                                                                }
                                                                                                                                                                                            },
                                                                                                                                                                                            value: {
                                                                                                                                                                                                type: 'Literal',
                                                                                                                                                                                                value: 'white secondary'
                                                                                                                                                                                            },
                                                                                                                                                                                            kind: 'init',
                                                                                                                                                                                            order: '0'
                                                                                                                                                                                        }]
                                                                                                                                                                                }],
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 301,
                                                                                                                                                                                    column: 52,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 301,
                                                                                                                                                                                    column: 85,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        properties: [
                                                                                                                                                                            {
                                                                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                                                                expression: {
                                                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                                                    objectType: {
                                                                                                                                                                                        type: 'CallExpression',
                                                                                                                                                                                        callee: {
                                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                                            name: 'Icon',
                                                                                                                                                                                            loc: {
                                                                                                                                                                                                start: {
                                                                                                                                                                                                    line: 302,
                                                                                                                                                                                                    column: 56,
                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                                                                },
                                                                                                                                                                                                end: {
                                                                                                                                                                                                    line: 302,
                                                                                                                                                                                                    column: 60,
                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                                                                }
                                                                                                                                                                                            }
                                                                                                                                                                                        },
                                                                                                                                                                                        arguments: [{
                                                                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                                                                properties: [{
                                                                                                                                                                                                        type: 'Property',
                                                                                                                                                                                                        key: {
                                                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                                                            name: 'name',
                                                                                                                                                                                                            loc: {
                                                                                                                                                                                                                start: {
                                                                                                                                                                                                                    line: 302,
                                                                                                                                                                                                                    column: 62,
                                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                                                                                },
                                                                                                                                                                                                                end: {
                                                                                                                                                                                                                    line: 302,
                                                                                                                                                                                                                    column: 66,
                                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                                                                                }
                                                                                                                                                                                                            }
                                                                                                                                                                                                        },
                                                                                                                                                                                                        value: {
                                                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                                                            value: 'arrow back'
                                                                                                                                                                                                        },
                                                                                                                                                                                                        kind: 'init',
                                                                                                                                                                                                        order: '0'
                                                                                                                                                                                                    }]
                                                                                                                                                                                            }],
                                                                                                                                                                                        loc: {
                                                                                                                                                                                            start: {
                                                                                                                                                                                                line: 302,
                                                                                                                                                                                                column: 56,
                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                                                                                            },
                                                                                                                                                                                            end: {
                                                                                                                                                                                                line: 302,
                                                                                                                                                                                                column: 81,
                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                                                                                            }
                                                                                                                                                                                        }
                                                                                                                                                                                    },
                                                                                                                                                                                    properties: [{
                                                                                                                                                                                            type: 'Property',
                                                                                                                                                                                            key: {
                                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                                name: 'style',
                                                                                                                                                                                                loc: {
                                                                                                                                                                                                    start: {
                                                                                                                                                                                                        line: 303,
                                                                                                                                                                                                        column: 60,
                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                                                                    },
                                                                                                                                                                                                    end: {
                                                                                                                                                                                                        line: 303,
                                                                                                                                                                                                        column: 65,
                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                                                                    }
                                                                                                                                                                                                }
                                                                                                                                                                                            },
                                                                                                                                                                                            value: {
                                                                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                                                                properties: [{
                                                                                                                                                                                                        type: 'Property',
                                                                                                                                                                                                        key: {
                                                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                                                            name: 'transform',
                                                                                                                                                                                                            loc: {
                                                                                                                                                                                                                start: {
                                                                                                                                                                                                                    line: 304,
                                                                                                                                                                                                                    column: 64,
                                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                                                                                },
                                                                                                                                                                                                                end: {
                                                                                                                                                                                                                    line: 304,
                                                                                                                                                                                                                    column: 73,
                                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                                                                                }
                                                                                                                                                                                                            }
                                                                                                                                                                                                        },
                                                                                                                                                                                                        value: {
                                                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                                                            value: 'rotate(135deg)'
                                                                                                                                                                                                        },
                                                                                                                                                                                                        kind: 'init',
                                                                                                                                                                                                        order: '0'
                                                                                                                                                                                                    }]
                                                                                                                                                                                            },
                                                                                                                                                                                            kind: 'init',
                                                                                                                                                                                            order: '0'
                                                                                                                                                                                        }]
                                                                                                                                                                                },
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 302,
                                                                                                                                                                                        column: 56,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 305,
                                                                                                                                                                                        column: 60,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                },
                                                                                                                                                                                order: '0'
                                                                                                                                                                            },
                                                                                                                                                                            {
                                                                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                                                                expression: {
                                                                                                                                                                                    type: 'Function',
                                                                                                                                                                                    context: true,
                                                                                                                                                                                    value: function (_context14) {
                                                                                                                                                                                        return function click(e) {
                                                                                                                                                                                            var pane = _context14.get('pane');
                                                                                                                                                                                            model.open(pane.config);
                                                                                                                                                                                        };
                                                                                                                                                                                    }
                                                                                                                                                                                },
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 305,
                                                                                                                                                                                        column: 56,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 307,
                                                                                                                                                                                        column: 60,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                },
                                                                                                                                                                                order: '1'
                                                                                                                                                                            }
                                                                                                                                                                        ]
                                                                                                                                                                    },
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 301,
                                                                                                                                                                            column: 52,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 307,
                                                                                                                                                                            column: 56,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    order: '0'
                                                                                                                                                                },
                                                                                                                                                                {
                                                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                                                    expression: {
                                                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                                                        objectType: {
                                                                                                                                                                            type: 'CallExpression',
                                                                                                                                                                            callee: {
                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                name: 'Button',
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 307,
                                                                                                                                                                                        column: 52,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 307,
                                                                                                                                                                                        column: 58,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            arguments: [{
                                                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                                                    properties: [{
                                                                                                                                                                                            type: 'Property',
                                                                                                                                                                                            key: {
                                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                                name: 'class',
                                                                                                                                                                                                loc: {
                                                                                                                                                                                                    start: {
                                                                                                                                                                                                        line: 307,
                                                                                                                                                                                                        column: 60,
                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                                                                    },
                                                                                                                                                                                                    end: {
                                                                                                                                                                                                        line: 307,
                                                                                                                                                                                                        column: 65,
                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                                                                    }
                                                                                                                                                                                                }
                                                                                                                                                                                            },
                                                                                                                                                                                            value: {
                                                                                                                                                                                                type: 'Literal',
                                                                                                                                                                                                value: 'white secondary'
                                                                                                                                                                                            },
                                                                                                                                                                                            kind: 'init',
                                                                                                                                                                                            order: '0'
                                                                                                                                                                                        }]
                                                                                                                                                                                }],
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 307,
                                                                                                                                                                                    column: 52,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 307,
                                                                                                                                                                                    column: 85,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        properties: [
                                                                                                                                                                            {
                                                                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                                                                expression: {
                                                                                                                                                                                    type: 'CallExpression',
                                                                                                                                                                                    callee: {
                                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                                        name: 'Icon',
                                                                                                                                                                                        loc: {
                                                                                                                                                                                            start: {
                                                                                                                                                                                                line: 308,
                                                                                                                                                                                                column: 56,
                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                                                                                            },
                                                                                                                                                                                            end: {
                                                                                                                                                                                                line: 308,
                                                                                                                                                                                                column: 60,
                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                                                                                            }
                                                                                                                                                                                        }
                                                                                                                                                                                    },
                                                                                                                                                                                    arguments: [{
                                                                                                                                                                                            type: 'ObjectExpression',
                                                                                                                                                                                            properties: [{
                                                                                                                                                                                                    type: 'Property',
                                                                                                                                                                                                    key: {
                                                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                                                        name: 'name',
                                                                                                                                                                                                        loc: {
                                                                                                                                                                                                            start: {
                                                                                                                                                                                                                line: 308,
                                                                                                                                                                                                                column: 62,
                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                                                                                                            },
                                                                                                                                                                                                            end: {
                                                                                                                                                                                                                line: 308,
                                                                                                                                                                                                                column: 66,
                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                                                                                                            }
                                                                                                                                                                                                        }
                                                                                                                                                                                                    },
                                                                                                                                                                                                    value: {
                                                                                                                                                                                                        type: 'Literal',
                                                                                                                                                                                                        value: 'pin drop'
                                                                                                                                                                                                    },
                                                                                                                                                                                                    kind: 'init',
                                                                                                                                                                                                    order: '0'
                                                                                                                                                                                                }]
                                                                                                                                                                                        }],
                                                                                                                                                                                    loc: {
                                                                                                                                                                                        start: {
                                                                                                                                                                                            line: 308,
                                                                                                                                                                                            column: 56,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                                                        },
                                                                                                                                                                                        end: {
                                                                                                                                                                                            line: 308,
                                                                                                                                                                                            column: 79,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                                                        }
                                                                                                                                                                                    }
                                                                                                                                                                                },
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 308,
                                                                                                                                                                                        column: 56,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 308,
                                                                                                                                                                                        column: 79,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                },
                                                                                                                                                                                order: '0'
                                                                                                                                                                            },
                                                                                                                                                                            {
                                                                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                                                                expression: {
                                                                                                                                                                                    type: 'Function',
                                                                                                                                                                                    context: true,
                                                                                                                                                                                    value: function (_context15) {
                                                                                                                                                                                        return function click(e) {
                                                                                                                                                                                            var pane = _context15.get('pane');
                                                                                                                                                                                            delete pane.config.target;
                                                                                                                                                                                        };
                                                                                                                                                                                    }
                                                                                                                                                                                },
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 309,
                                                                                                                                                                                        column: 56,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 312,
                                                                                                                                                                                        column: 60,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                },
                                                                                                                                                                                order: '1'
                                                                                                                                                                            }
                                                                                                                                                                        ]
                                                                                                                                                                    },
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 307,
                                                                                                                                                                            column: 52,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 312,
                                                                                                                                                                            column: 56,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    order: '1'
                                                                                                                                                                }
                                                                                                                                                            ]
                                                                                                                                                        },
                                                                                                                                                        alternate: null,
                                                                                                                                                        order: '0'
                                                                                                                                                    }]
                                                                                                                                            },
                                                                                                                                            kind: 'init',
                                                                                                                                            order: '1'
                                                                                                                                        }
                                                                                                                                    ]
                                                                                                                                },
                                                                                                                                kind: 'init',
                                                                                                                                order: '0'
                                                                                                                            }]
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 293,
                                                                                                                            column: 36,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 312,
                                                                                                                            column: 40,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                        }
                                                                                                                    },
                                                                                                                    order: '1'
                                                                                                                }
                                                                                                            ]
                                                                                                        },
                                                                                                        kind: 'init',
                                                                                                        order: '1'
                                                                                                    }
                                                                                                ]
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 287,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 312,
                                                                                                    column: 32,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                }
                                                                                            },
                                                                                            order: '2'
                                                                                        }
                                                                                    ]
                                                                                },
                                                                                alternate: {
                                                                                    type: 'BlockStatement',
                                                                                    body: [
                                                                                        {
                                                                                            type: 'IfStatement',
                                                                                            test: {
                                                                                                type: 'BinaryExpression',
                                                                                                operator: '&&',
                                                                                                left: {
                                                                                                    type: 'BinaryExpression',
                                                                                                    operator: '>',
                                                                                                    left: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'index',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 313,
                                                                                                                column: 31,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 313,
                                                                                                                column: 36,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    right: {
                                                                                                        type: 'Literal',
                                                                                                        value: 0
                                                                                                    }
                                                                                                },
                                                                                                right: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'canPinPanes',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 313,
                                                                                                            column: 45,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 313,
                                                                                                            column: 56,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                        }
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            consequent: {
                                                                                                type: 'BlockStatement',
                                                                                                body: [{
                                                                                                        type: 'ExpressionStatement',
                                                                                                        expression: {
                                                                                                            type: 'CallExpression',
                                                                                                            callee: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'PaneResizer',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 314,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 314,
                                                                                                                        column: 43,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            arguments: [{
                                                                                                                    type: 'ObjectExpression',
                                                                                                                    properties: [{
                                                                                                                            type: 'Property',
                                                                                                                            key: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'horizontal',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 314,
                                                                                                                                        column: 45,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 314,
                                                                                                                                        column: 55,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            value: {
                                                                                                                                type: 'Literal',
                                                                                                                                value: true
                                                                                                                            },
                                                                                                                            kind: 'init',
                                                                                                                            order: '0'
                                                                                                                        }]
                                                                                                                }],
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 314,
                                                                                                                    column: 32,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 314,
                                                                                                                    column: 62,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 314,
                                                                                                                column: 32,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 314,
                                                                                                                column: 62,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                            }
                                                                                                        },
                                                                                                        order: '0'
                                                                                                    }]
                                                                                            },
                                                                                            alternate: null,
                                                                                            order: '0'
                                                                                        },
                                                                                        {
                                                                                            type: 'ExpressionStatement',
                                                                                            expression: {
                                                                                                type: 'ObjectExpression',
                                                                                                objectType: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'pane',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 315,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 315,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                properties: [
                                                                                                    {
                                                                                                        type: 'Property',
                                                                                                        key: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'style',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 316,
                                                                                                                    column: 32,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 316,
                                                                                                                    column: 37,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        value: {
                                                                                                            type: 'ObjectExpression',
                                                                                                            properties: [
                                                                                                                {
                                                                                                                    type: 'Property',
                                                                                                                    key: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'top',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 317,
                                                                                                                                column: 36,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 317,
                                                                                                                                column: 39,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    value: {
                                                                                                                        type: 'Literal',
                                                                                                                        value: 'initial'
                                                                                                                    },
                                                                                                                    kind: 'init',
                                                                                                                    order: '0'
                                                                                                                },
                                                                                                                {
                                                                                                                    type: 'Property',
                                                                                                                    key: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'maxWidth',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 318,
                                                                                                                                column: 36,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 318,
                                                                                                                                column: 44,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    value: {
                                                                                                                        type: 'Literal',
                                                                                                                        value: '100vw'
                                                                                                                    },
                                                                                                                    kind: 'init',
                                                                                                                    order: '1'
                                                                                                                },
                                                                                                                {
                                                                                                                    type: 'IfStatement',
                                                                                                                    test: {
                                                                                                                        type: 'UnaryExpression',
                                                                                                                        operator: '!',
                                                                                                                        argument: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'canPinPanes',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 319,
                                                                                                                                    column: 43,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 319,
                                                                                                                                    column: 54,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    consequent: {
                                                                                                                        type: 'BlockStatement',
                                                                                                                        body: [
                                                                                                                            {
                                                                                                                                type: 'Property',
                                                                                                                                key: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'position',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 320,
                                                                                                                                            column: 40,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 320,
                                                                                                                                            column: 48,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                value: {
                                                                                                                                    type: 'Literal',
                                                                                                                                    value: 'absolute'
                                                                                                                                },
                                                                                                                                kind: 'init',
                                                                                                                                order: '0'
                                                                                                                            },
                                                                                                                            {
                                                                                                                                type: 'Property',
                                                                                                                                key: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'width',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 321,
                                                                                                                                            column: 40,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 321,
                                                                                                                                            column: 45,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                value: {
                                                                                                                                    type: 'Literal',
                                                                                                                                    value: '100%'
                                                                                                                                },
                                                                                                                                kind: 'init',
                                                                                                                                order: '1'
                                                                                                                            },
                                                                                                                            {
                                                                                                                                type: 'Property',
                                                                                                                                key: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'height',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 322,
                                                                                                                                            column: 40,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 322,
                                                                                                                                            column: 46,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                value: {
                                                                                                                                    type: 'Literal',
                                                                                                                                    value: '100%'
                                                                                                                                },
                                                                                                                                kind: 'init',
                                                                                                                                order: '2'
                                                                                                                            }
                                                                                                                        ]
                                                                                                                    },
                                                                                                                    alternate: {
                                                                                                                        type: 'BlockStatement',
                                                                                                                        body: [
                                                                                                                            {
                                                                                                                                type: 'Property',
                                                                                                                                key: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'position',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 324,
                                                                                                                                            column: 40,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 324,
                                                                                                                                            column: 48,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                value: {
                                                                                                                                    type: 'Literal',
                                                                                                                                    value: 'initial'
                                                                                                                                },
                                                                                                                                kind: 'init',
                                                                                                                                order: '0'
                                                                                                                            },
                                                                                                                            {
                                                                                                                                type: 'Property',
                                                                                                                                key: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'width',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 325,
                                                                                                                                            column: 40,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 325,
                                                                                                                                            column: 45,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                value: {
                                                                                                                                    type: 'Literal',
                                                                                                                                    value: 'initial'
                                                                                                                                },
                                                                                                                                kind: 'init',
                                                                                                                                order: '1'
                                                                                                                            },
                                                                                                                            {
                                                                                                                                type: 'Property',
                                                                                                                                key: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'height',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 326,
                                                                                                                                            column: 40,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 326,
                                                                                                                                            column: 46,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                value: {
                                                                                                                                    type: 'Literal',
                                                                                                                                    value: 'initial'
                                                                                                                                },
                                                                                                                                kind: 'init',
                                                                                                                                order: '2'
                                                                                                                            }
                                                                                                                        ]
                                                                                                                    },
                                                                                                                    order: '2'
                                                                                                                }
                                                                                                            ]
                                                                                                        },
                                                                                                        kind: 'init',
                                                                                                        order: '0'
                                                                                                    },
                                                                                                    {
                                                                                                        type: 'Property',
                                                                                                        key: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'header',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 327,
                                                                                                                    column: 32,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 327,
                                                                                                                    column: 38,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        value: {
                                                                                                            type: 'ObjectExpression',
                                                                                                            properties: [
                                                                                                                {
                                                                                                                    type: 'Property',
                                                                                                                    key: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'left',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 328,
                                                                                                                                column: 36,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 328,
                                                                                                                                column: 40,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    value: {
                                                                                                                        type: 'ObjectExpression',
                                                                                                                        properties: [{
                                                                                                                                type: 'IfStatement',
                                                                                                                                test: {
                                                                                                                                    type: 'BinaryExpression',
                                                                                                                                    operator: '&&',
                                                                                                                                    left: {
                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                        operator: '&&',
                                                                                                                                        left: {
                                                                                                                                            type: 'BinaryExpression',
                                                                                                                                            operator: '===',
                                                                                                                                            left: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'index',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 329,
                                                                                                                                                        column: 43,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 329,
                                                                                                                                                        column: 48,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            right: {
                                                                                                                                                type: 'Literal',
                                                                                                                                                value: 0
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        right: {
                                                                                                                                            type: 'UnaryExpression',
                                                                                                                                            operator: '!',
                                                                                                                                            argument: {
                                                                                                                                                type: 'MemberExpression',
                                                                                                                                                computed: false,
                                                                                                                                                object: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'navDrawer',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 329,
                                                                                                                                                            column: 62,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 329,
                                                                                                                                                            column: 71,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                property: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'pinned',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 329,
                                                                                                                                                            column: 72,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 329,
                                                                                                                                                            column: 78,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 329,
                                                                                                                                                        column: 62,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 329,
                                                                                                                                                        column: 78,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    right: {
                                                                                                                                        type: 'UnaryExpression',
                                                                                                                                        operator: '!',
                                                                                                                                        argument: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'showAppBar',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 329,
                                                                                                                                                    column: 87,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 329,
                                                                                                                                                    column: 97,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                consequent: {
                                                                                                                                    type: 'BlockStatement',
                                                                                                                                    body: [{
                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                            expression: {
                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                objectType: {
                                                                                                                                                    type: 'CallExpression',
                                                                                                                                                    callee: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'Button',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 330,
                                                                                                                                                                column: 44,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 330,
                                                                                                                                                                column: 50,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    arguments: [{
                                                                                                                                                            type: 'ObjectExpression',
                                                                                                                                                            properties: [{
                                                                                                                                                                    type: 'Property',
                                                                                                                                                                    key: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'class',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 330,
                                                                                                                                                                                column: 52,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 330,
                                                                                                                                                                                column: 57,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    value: {
                                                                                                                                                                        type: 'Literal',
                                                                                                                                                                        value: 'white secondary'
                                                                                                                                                                    },
                                                                                                                                                                    kind: 'init',
                                                                                                                                                                    order: '0'
                                                                                                                                                                }]
                                                                                                                                                        }],
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 330,
                                                                                                                                                            column: 44,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 330,
                                                                                                                                                            column: 77,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                properties: [
                                                                                                                                                    {
                                                                                                                                                        type: 'ExpressionStatement',
                                                                                                                                                        expression: {
                                                                                                                                                            type: 'CallExpression',
                                                                                                                                                            callee: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'Icon',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 331,
                                                                                                                                                                        column: 48,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 331,
                                                                                                                                                                        column: 52,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            arguments: [{
                                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                                    properties: [{
                                                                                                                                                                            type: 'Property',
                                                                                                                                                                            key: {
                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                name: 'name',
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 331,
                                                                                                                                                                                        column: 54,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 331,
                                                                                                                                                                                        column: 58,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            value: {
                                                                                                                                                                                type: 'Literal',
                                                                                                                                                                                value: 'menu'
                                                                                                                                                                            },
                                                                                                                                                                            kind: 'init',
                                                                                                                                                                            order: '0'
                                                                                                                                                                        }]
                                                                                                                                                                }],
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 331,
                                                                                                                                                                    column: 48,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 331,
                                                                                                                                                                    column: 67,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 331,
                                                                                                                                                                column: 48,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 331,
                                                                                                                                                                column: 67,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        order: '0'
                                                                                                                                                    },
                                                                                                                                                    {
                                                                                                                                                        type: 'ExpressionStatement',
                                                                                                                                                        expression: {
                                                                                                                                                            type: 'Function',
                                                                                                                                                            context: true,
                                                                                                                                                            value: function (_context16) {
                                                                                                                                                                return function click(e) {
                                                                                                                                                                    var navDrawer = _context16.get('navDrawer');
                                                                                                                                                                    return navDrawer.open = true;
                                                                                                                                                                };
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 332,
                                                                                                                                                                column: 48,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 332,
                                                                                                                                                                column: 81,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        order: '1'
                                                                                                                                                    }
                                                                                                                                                ]
                                                                                                                                            },
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 330,
                                                                                                                                                    column: 44,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 333,
                                                                                                                                                    column: 48,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            order: '0'
                                                                                                                                        }]
                                                                                                                                },
                                                                                                                                alternate: {
                                                                                                                                    type: 'IfStatement',
                                                                                                                                    test: {
                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                        operator: '&&',
                                                                                                                                        left: {
                                                                                                                                            type: 'BinaryExpression',
                                                                                                                                            operator: '>',
                                                                                                                                            left: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'index',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 333,
                                                                                                                                                        column: 48,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 333,
                                                                                                                                                        column: 53,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            right: {
                                                                                                                                                type: 'Literal',
                                                                                                                                                value: 0
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        right: {
                                                                                                                                            type: 'UnaryExpression',
                                                                                                                                            operator: '!',
                                                                                                                                            argument: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'canPinPanes',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 333,
                                                                                                                                                        column: 66,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 333,
                                                                                                                                                        column: 77,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    consequent: {
                                                                                                                                        type: 'BlockStatement',
                                                                                                                                        body: [{
                                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                                expression: {
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    objectType: {
                                                                                                                                                        type: 'CallExpression',
                                                                                                                                                        callee: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'Button',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 334,
                                                                                                                                                                    column: 44,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 334,
                                                                                                                                                                    column: 50,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        arguments: [{
                                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                                properties: [{
                                                                                                                                                                        type: 'Property',
                                                                                                                                                                        key: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'class',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 334,
                                                                                                                                                                                    column: 52,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 334,
                                                                                                                                                                                    column: 57,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        value: {
                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                            value: 'white secondary'
                                                                                                                                                                        },
                                                                                                                                                                        kind: 'init',
                                                                                                                                                                        order: '0'
                                                                                                                                                                    }]
                                                                                                                                                            }],
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 334,
                                                                                                                                                                column: 44,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 334,
                                                                                                                                                                column: 77,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    properties: [
                                                                                                                                                        {
                                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                                            expression: {
                                                                                                                                                                type: 'CallExpression',
                                                                                                                                                                callee: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'Icon',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 335,
                                                                                                                                                                            column: 48,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 335,
                                                                                                                                                                            column: 52,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                arguments: [{
                                                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                                                        properties: [{
                                                                                                                                                                                type: 'Property',
                                                                                                                                                                                key: {
                                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                                    name: 'name',
                                                                                                                                                                                    loc: {
                                                                                                                                                                                        start: {
                                                                                                                                                                                            line: 335,
                                                                                                                                                                                            column: 54,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                                                        },
                                                                                                                                                                                        end: {
                                                                                                                                                                                            line: 335,
                                                                                                                                                                                            column: 58,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                                                        }
                                                                                                                                                                                    }
                                                                                                                                                                                },
                                                                                                                                                                                value: {
                                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                                    value: 'arrow back'
                                                                                                                                                                                },
                                                                                                                                                                                kind: 'init',
                                                                                                                                                                                order: '0'
                                                                                                                                                                            }]
                                                                                                                                                                    }],
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 335,
                                                                                                                                                                        column: 48,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 335,
                                                                                                                                                                        column: 73,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 335,
                                                                                                                                                                    column: 48,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 335,
                                                                                                                                                                    column: 73,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            order: '0'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                                            expression: {
                                                                                                                                                                type: 'Function',
                                                                                                                                                                context: true,
                                                                                                                                                                value: function (_context17) {
                                                                                                                                                                    return function click(e) {
                                                                                                                                                                        var pane = _context17.get('pane');
                                                                                                                                                                        return model.close(pane.config);
                                                                                                                                                                    };
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 336,
                                                                                                                                                                    column: 48,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 336,
                                                                                                                                                                    column: 84,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            order: '1'
                                                                                                                                                        }
                                                                                                                                                    ]
                                                                                                                                                },
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 334,
                                                                                                                                                        column: 44,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 337,
                                                                                                                                                        column: 48,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                order: '0'
                                                                                                                                            }]
                                                                                                                                    },
                                                                                                                                    alternate: null
                                                                                                                                },
                                                                                                                                order: '0'
                                                                                                                            }]
                                                                                                                    },
                                                                                                                    kind: 'init',
                                                                                                                    order: '0'
                                                                                                                },
                                                                                                                {
                                                                                                                    type: 'Property',
                                                                                                                    key: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'right',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 337,
                                                                                                                                column: 36,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 337,
                                                                                                                                column: 41,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    value: {
                                                                                                                        type: 'ObjectExpression',
                                                                                                                        properties: [{
                                                                                                                                type: 'IfStatement',
                                                                                                                                test: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'showAppBar',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 338,
                                                                                                                                            column: 43,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 338,
                                                                                                                                            column: 53,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                consequent: {
                                                                                                                                    type: 'BlockStatement',
                                                                                                                                    body: [{
                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                            expression: {
                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                objectType: {
                                                                                                                                                    type: 'CallExpression',
                                                                                                                                                    callee: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'Button',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 339,
                                                                                                                                                                column: 44,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 339,
                                                                                                                                                                column: 50,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    arguments: [{
                                                                                                                                                            type: 'ObjectExpression',
                                                                                                                                                            properties: [{
                                                                                                                                                                    type: 'Property',
                                                                                                                                                                    key: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'class',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 339,
                                                                                                                                                                                column: 52,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 339,
                                                                                                                                                                                column: 57,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    value: {
                                                                                                                                                                        type: 'Literal',
                                                                                                                                                                        value: 'white secondary'
                                                                                                                                                                    },
                                                                                                                                                                    kind: 'init',
                                                                                                                                                                    order: '0'
                                                                                                                                                                }]
                                                                                                                                                        }],
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 339,
                                                                                                                                                            column: 44,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 339,
                                                                                                                                                            column: 77,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                properties: [
                                                                                                                                                    {
                                                                                                                                                        type: 'ExpressionStatement',
                                                                                                                                                        expression: {
                                                                                                                                                            type: 'CallExpression',
                                                                                                                                                            callee: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'Icon',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 340,
                                                                                                                                                                        column: 48,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 340,
                                                                                                                                                                        column: 52,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            arguments: [{
                                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                                    properties: [{
                                                                                                                                                                            type: 'Property',
                                                                                                                                                                            key: {
                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                name: 'name',
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 340,
                                                                                                                                                                                        column: 54,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 340,
                                                                                                                                                                                        column: 58,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            value: {
                                                                                                                                                                                type: 'Literal',
                                                                                                                                                                                value: 'clear'
                                                                                                                                                                            },
                                                                                                                                                                            kind: 'init',
                                                                                                                                                                            order: '0'
                                                                                                                                                                        }]
                                                                                                                                                                }],
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 340,
                                                                                                                                                                    column: 48,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 340,
                                                                                                                                                                    column: 68,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 340,
                                                                                                                                                                column: 48,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 340,
                                                                                                                                                                column: 68,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        order: '0'
                                                                                                                                                    },
                                                                                                                                                    {
                                                                                                                                                        type: 'ExpressionStatement',
                                                                                                                                                        expression: {
                                                                                                                                                            type: 'Function',
                                                                                                                                                            context: true,
                                                                                                                                                            value: function (_context18) {
                                                                                                                                                                return function click(e) {
                                                                                                                                                                    var pane = _context18.get('pane');
                                                                                                                                                                    model.close(pane.config);
                                                                                                                                                                };
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 341,
                                                                                                                                                                column: 48,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 343,
                                                                                                                                                                column: 52,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/Application.ion'
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        order: '1'
                                                                                                                                                    }
                                                                                                                                                ]
                                                                                                                                            },
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 339,
                                                                                                                                                    column: 44,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 343,
                                                                                                                                                    column: 48,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            order: '0'
                                                                                                                                        }]
                                                                                                                                },
                                                                                                                                alternate: {
                                                                                                                                    type: 'BlockStatement',
                                                                                                                                    body: [{
                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                            expression: {
                                                                                                                                                type: 'CallExpression',
                                                                                                                                                callee: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'topRightButtons',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 344,
                                                                                                                                                            column: 44,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 344,
                                                                                                                                                            column: 59,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/Application.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                arguments: [],
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 344,
                                                                                                                                                        column: 44,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 344,
                                                                                                                                                        column: 61,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/Application.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 344,
                                                                                                                                                    column: 44,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 344,
                                                                                                                                                    column: 61,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            order: '0'
                                                                                                                                        }]
                                                                                                                                },
                                                                                                                                order: '0'
                                                                                                                            }]
                                                                                                                    },
                                                                                                                    kind: 'init',
                                                                                                                    order: '1'
                                                                                                                }
                                                                                                            ]
                                                                                                        },
                                                                                                        kind: 'init',
                                                                                                        order: '1'
                                                                                                    }
                                                                                                ]
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 315,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 347,
                                                                                                    column: 32,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Application.ion'
                                                                                                }
                                                                                            },
                                                                                            order: '1'
                                                                                        }
                                                                                    ]
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                remove: null,
                                                                order: '1'
                                                            }
                                                        ]
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 238,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/Application.ion'
                                                        },
                                                        end: {
                                                            line: 347,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'viewpath/html/Application.ion'
                                                        }
                                                    },
                                                    order: '5'
                                                }
                                            ]
                                        },
                                        alternate: null,
                                        order: '0'
                                    }]
                            },
                            loc: {
                                start: {
                                    line: 213,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/Application.ion'
                                },
                                end: {
                                    line: 347,
                                    column: 12,
                                    fixed: true,
                                    source: 'viewpath/html/Application.ion'
                                }
                            },
                            order: '2'
                        }
                    ]
                },
                order: '='
            }
        ],
        bound: false
    }, {
        this: this,
        ion: ion,
        glass: glass,
        viewpath: viewpath,
        _ref: _ref,
        _ref2: _ref2,
        _ref3: _ref3,
        _ref4: _ref4,
        _ref5: _ref5,
        _ref6: _ref6,
        Key: Key,
        User: User,
        Task: Task,
        Project: Project,
        NavDrawer: NavDrawer,
        SetupWizard: SetupWizard,
        Icon: Icon,
        Button: Button,
        Resizer: Resizer,
        SearchButton: SearchButton,
        RecordSearchSuggestions: RecordSearchSuggestions,
        Toaster: Toaster,
        Dialog: Dialog,
        PromptDialog: PromptDialog,
        style: style,
        focusDescendant: focusDescendant,
        _ref12: _ref12,
        PaneResizer: PaneResizer,
        PaneBar: PaneBar,
        PaneName: PaneName,
        PaneFrame: PaneFrame
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/Application',_viewpath_html_Application_);
    else
      _viewpath_html_Application_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_Application_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_AssignedColumn_ = function(module,exports,require){'use strict';
var ion = require('ion'), glass = require('glass'), _ref, _ref2, _ref3, _ref4, _ref5;
_ref = glass.data;
var Schema = _ref.Schema;
_ref2 = glass.html.material.DataTable2;
var DefaultColumn = _ref2.DefaultColumn;
_ref3 = glass.convert;
var jsonValueToDisplayValue = _ref3.jsonValueToDisplayValue;
_ref4 = glass.html.material;
var Chip = _ref4.Chip;
var RecordChip = _ref4.RecordChip;
_ref5 = glass.html;
var style = _ref5.style;
var _ref7 = style.sheets;
_ref7[module.id] = '.AssignedColumn.hide > *:not(.toggle) {\n    display: none !important;\n}\n.AssignedColumn > .toggle {\n    flex: 0 0 auto;\n    width: 20px;\n    height: 20px;\n    margin-right: 4px;\n}\n.AssignedColumn > .toggle {\n    transition: transform 0.2s;\n    transform: rotateZ(0deg);\n    cursor: pointer;\n}\n/*\n.AssignedColumn:focus > .toggle {\n    display: none;\n}\n*/\n.AssignedColumn.expanded > .toggle {\n    transform: rotateZ(90deg);\n}';
_ref7;
module.exports = exports = ion.template(function AssignedColumn(property) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'AssignedColumn',
            loc: {
                start: {
                    line: 35,
                    column: 16,
                    fixed: true,
                    source: 'viewpath/html/AssignedColumn.ion'
                },
                end: {
                    line: 35,
                    column: 30,
                    fixed: true,
                    source: 'viewpath/html/AssignedColumn.ion'
                }
            }
        },
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'defaultSource',
                            loc: {
                                start: {
                                    line: 36,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/AssignedColumn.ion'
                                },
                                end: {
                                    line: 36,
                                    column: 21,
                                    fixed: true,
                                    source: 'viewpath/html/AssignedColumn.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Function',
                                context: false,
                                value: function () {
                                    return global.model.server;
                                }
                            },
                            arguments: [],
                            loc: {
                                start: {
                                    line: 36,
                                    column: 24,
                                    fixed: true,
                                    source: 'viewpath/html/AssignedColumn.ion'
                                },
                                end: {
                                    line: 36,
                                    column: 49,
                                    fixed: true,
                                    source: 'viewpath/html/AssignedColumn.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'column',
                            loc: {
                                start: {
                                    line: 37,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/AssignedColumn.ion'
                                },
                                end: {
                                    line: 37,
                                    column: 14,
                                    fixed: true,
                                    source: 'viewpath/html/AssignedColumn.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'DefaultColumn',
                                loc: {
                                    start: {
                                        line: 37,
                                        column: 17,
                                        fixed: true,
                                        source: 'viewpath/html/AssignedColumn.ion'
                                    },
                                    end: {
                                        line: 37,
                                        column: 30,
                                        fixed: true,
                                        source: 'viewpath/html/AssignedColumn.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'Identifier',
                                    name: 'property',
                                    loc: {
                                        start: {
                                            line: 37,
                                            column: 31,
                                            fixed: true,
                                            source: 'viewpath/html/AssignedColumn.ion'
                                        },
                                        end: {
                                            line: 37,
                                            column: 39,
                                            fixed: true,
                                            source: 'viewpath/html/AssignedColumn.ion'
                                        }
                                    }
                                }],
                            loc: {
                                start: {
                                    line: 37,
                                    column: 17,
                                    fixed: true,
                                    source: 'viewpath/html/AssignedColumn.ion'
                                },
                                end: {
                                    line: 37,
                                    column: 40,
                                    fixed: true,
                                    source: 'viewpath/html/AssignedColumn.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'Identifier',
                        name: 'column',
                        loc: {
                            start: {
                                line: 38,
                                column: 11,
                                fixed: true,
                                source: 'viewpath/html/AssignedColumn.ion'
                            },
                            end: {
                                line: 38,
                                column: 17,
                                fixed: true,
                                source: 'viewpath/html/AssignedColumn.ion'
                            }
                        }
                    },
                    properties: [
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'canEdit',
                                loc: {
                                    start: {
                                        line: 39,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/html/AssignedColumn.ion'
                                    },
                                    end: {
                                        line: 39,
                                        column: 15,
                                        fixed: true,
                                        source: 'viewpath/html/AssignedColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context) {
                                    return function () {
                                        var property = _context.get('property');
                                        return property.editable !== false;
                                    };
                                }
                            },
                            kind: 'init',
                            order: '0'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'createBodyCell',
                                loc: {
                                    start: {
                                        line: 40,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/html/AssignedColumn.ion'
                                    },
                                    end: {
                                        line: 40,
                                        column: 22,
                                        fixed: true,
                                        source: 'viewpath/html/AssignedColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_ps) {
                                    return ion.template(function (row) {
                                        return ion.createRuntime({
                                            type: 'Template',
                                            id: null,
                                            body: [
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: '_ref6'
                                                            },
                                                            init: {
                                                                type: 'Identifier',
                                                                name: 'row',
                                                                loc: {
                                                                    start: {
                                                                        line: 41,
                                                                        column: 43,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/AssignedColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 41,
                                                                        column: 46,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/AssignedColumn.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'dataTableModel',
                                                                loc: {
                                                                    start: {
                                                                        line: 41,
                                                                        column: 17,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/AssignedColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 41,
                                                                        column: 31,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/AssignedColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'MemberExpression',
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: '_ref6'
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'dataTableModel',
                                                                    loc: {
                                                                        start: {
                                                                            line: 41,
                                                                            column: 17,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/AssignedColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 41,
                                                                            column: 31,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/AssignedColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                computed: false
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '1'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'record',
                                                                loc: {
                                                                    start: {
                                                                        line: 41,
                                                                        column: 33,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/AssignedColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 41,
                                                                        column: 39,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/AssignedColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'MemberExpression',
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: '_ref6'
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'record',
                                                                    loc: {
                                                                        start: {
                                                                            line: 41,
                                                                            column: 33,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/AssignedColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 41,
                                                                            column: 39,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/AssignedColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                computed: false
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '2'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'expanded',
                                                                loc: {
                                                                    start: {
                                                                        line: 43,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/AssignedColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 43,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/AssignedColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'MemberExpression',
                                                                computed: true,
                                                                object: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'dataTableModel',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 43,
                                                                                    column: 27,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/AssignedColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 43,
                                                                                    column: 41,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/AssignedColumn.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'state',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 43,
                                                                                    column: 42,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/AssignedColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 43,
                                                                                    column: 47,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/AssignedColumn.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 43,
                                                                                column: 27,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/AssignedColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 43,
                                                                                column: 47,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/AssignedColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'expandedAssignments',
                                                                        loc: {
                                                                            start: {
                                                                                line: 43,
                                                                                column: 48,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/AssignedColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 43,
                                                                                column: 67,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/AssignedColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 43,
                                                                            column: 27,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/AssignedColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 43,
                                                                            column: 67,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/AssignedColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'row',
                                                                        loc: {
                                                                            start: {
                                                                                line: 43,
                                                                                column: 69,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/AssignedColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 43,
                                                                                column: 72,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/AssignedColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'key',
                                                                        loc: {
                                                                            start: {
                                                                                line: 43,
                                                                                column: 73,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/AssignedColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 43,
                                                                                column: 76,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/AssignedColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 43,
                                                                            column: 69,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/AssignedColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 43,
                                                                            column: 76,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/AssignedColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                existential: true,
                                                                loc: {
                                                                    start: {
                                                                        line: 43,
                                                                        column: 27,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/AssignedColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 43,
                                                                        column: 77,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/AssignedColumn.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '3'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'toggle',
                                                                loc: {
                                                                    start: {
                                                                        line: 44,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/AssignedColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 44,
                                                                        column: 22,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/AssignedColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'Function',
                                                                context: true,
                                                                value: function (_context2) {
                                                                    return function () {
                                                                        var expanded = _context2.get('expanded'), dataTableModel = _context2.get('dataTableModel'), row = _context2.get('row');
                                                                        if (expanded) {
                                                                            delete dataTableModel.state.expandedAssignments[row.key];
                                                                        } else {
                                                                            (dataTableModel.state.expandedAssignments = dataTableModel.state.expandedAssignments != null ? dataTableModel.state.expandedAssignments : {})[row.key] = true;
                                                                        }
                                                                    };
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '4'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'value',
                                                                loc: {
                                                                    start: {
                                                                        line: 50,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/AssignedColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 50,
                                                                        column: 21,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/AssignedColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Function',
                                                                    context: true,
                                                                    value: function (_context3) {
                                                                        return function (record) {
                                                                            var Schema = _context3.get('Schema'), property = _context3.get('property');
                                                                            return Schema.get(record, property);
                                                                        };
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'Identifier',
                                                                        name: 'record',
                                                                        loc: {
                                                                            start: {
                                                                                line: 50,
                                                                                column: 28,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/AssignedColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 50,
                                                                                column: 34,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/AssignedColumn.ion'
                                                                            }
                                                                        }
                                                                    }],
                                                                loc: {
                                                                    start: {
                                                                        line: 50,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/AssignedColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 50,
                                                                        column: 67,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/AssignedColumn.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '5'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'customSource',
                                                                loc: {
                                                                    start: {
                                                                        line: 51,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/AssignedColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 51,
                                                                        column: 28,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/AssignedColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'property',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 51,
                                                                                    column: 31,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/AssignedColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 51,
                                                                                    column: 39,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/AssignedColumn.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'foreign',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 51,
                                                                                    column: 40,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/AssignedColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 51,
                                                                                    column: 47,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/AssignedColumn.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 51,
                                                                                column: 31,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/AssignedColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 51,
                                                                                column: 47,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/AssignedColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'getSource',
                                                                        loc: {
                                                                            start: {
                                                                                line: 51,
                                                                                column: 49,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/AssignedColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 51,
                                                                                column: 58,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/AssignedColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    existential: true,
                                                                    loc: {
                                                                        start: {
                                                                            line: 51,
                                                                            column: 31,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/AssignedColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 51,
                                                                            column: 58,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/AssignedColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'ObjectExpression',
                                                                        properties: [
                                                                            {
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'server',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 51,
                                                                                            column: 61,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/AssignedColumn.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 51,
                                                                                            column: 67,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/AssignedColumn.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Identifier',
                                                                                    name: 'defaultSource',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 51,
                                                                                            column: 68,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/AssignedColumn.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 51,
                                                                                            column: 81,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/AssignedColumn.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                kind: 'init',
                                                                                order: '0'
                                                                            },
                                                                            {
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'record',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 51,
                                                                                            column: 82,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/AssignedColumn.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 51,
                                                                                            column: 88,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/AssignedColumn.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Identifier',
                                                                                    name: 'record',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 51,
                                                                                            column: 82,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/AssignedColumn.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 51,
                                                                                            column: 88,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/AssignedColumn.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                kind: 'init',
                                                                                order: '1'
                                                                            }
                                                                        ]
                                                                    }],
                                                                existential: true,
                                                                loc: {
                                                                    start: {
                                                                        line: 51,
                                                                        column: 31,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/AssignedColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 51,
                                                                        column: 90,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/AssignedColumn.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '6'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'source',
                                                                loc: {
                                                                    start: {
                                                                        line: 52,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/AssignedColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 52,
                                                                        column: 22,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/AssignedColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'ConditionalExpression',
                                                                test: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '!=',
                                                                    left: {
                                                                        type: 'Identifier',
                                                                        name: 'customSource',
                                                                        loc: {
                                                                            start: {
                                                                                line: 52,
                                                                                column: 25,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/AssignedColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 52,
                                                                                column: 37,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/AssignedColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    right: {
                                                                        type: 'Literal',
                                                                        value: null
                                                                    }
                                                                },
                                                                consequent: {
                                                                    type: 'Identifier',
                                                                    name: 'customSource',
                                                                    loc: {
                                                                        start: {
                                                                            line: 52,
                                                                            column: 25,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/AssignedColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 52,
                                                                            column: 37,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/AssignedColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                alternate: {
                                                                    type: 'Identifier',
                                                                    name: 'defaultSource',
                                                                    loc: {
                                                                        start: {
                                                                            line: 52,
                                                                            column: 40,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/AssignedColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 52,
                                                                            column: 53,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/AssignedColumn.ion'
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '7'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'cell',
                                                                loc: {
                                                                    start: {
                                                                        line: 53,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/AssignedColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 53,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/AssignedColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Function',
                                                                    context: true,
                                                                    value: function (_context4) {
                                                                        return function () {
                                                                            var ion = _context4.get('ion'), toggle = _context4.get('toggle');
                                                                            var _ref8 = Span({ class: 'AssignedColumn RelationColumn' });
                                                                            {
                                                                                ion.add(_ref8, function keypress(e) {
                                                                                    if (e.keyCode === 32) {
                                                                                        toggle();
                                                                                        e.preventDefault();
                                                                                    }
                                                                                });
                                                                                var _ref9 = IronIcon({ class: 'fixed toggle' });
                                                                                {
                                                                                    _ref9.icon = 'av:play-arrow';
                                                                                    ion.add(_ref9, function click(e) {
                                                                                        e.preventDefault();
                                                                                        e.stopPropagation();
                                                                                    });
                                                                                    ion.add(_ref9, function mousedown(e) {
                                                                                        if (e.button === 0) {
                                                                                            toggle();
                                                                                            e.preventDefault();
                                                                                            e.stopPropagation();
                                                                                        }
                                                                                    });
                                                                                    ion.add(_ref9, function mouseup(e) {
                                                                                        if (e.button === 0) {
                                                                                            e.preventDefault();
                                                                                            e.stopPropagation();
                                                                                        }
                                                                                    });
                                                                                }
                                                                                ion.add(_ref8, _ref9);
                                                                            }
                                                                            return _ref8;
                                                                        };
                                                                    }
                                                                },
                                                                arguments: [],
                                                                loc: {
                                                                    start: {
                                                                        line: 53,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/AssignedColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 73,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/AssignedColumn.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '8'
                                                },
                                                {
                                                    type: 'ReturnStatement',
                                                    argument: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'Identifier',
                                                            name: 'cell',
                                                            loc: {
                                                                start: {
                                                                    line: 73,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/AssignedColumn.ion'
                                                                },
                                                                end: {
                                                                    line: 73,
                                                                    column: 23,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/AssignedColumn.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [
                                                            {
                                                                type: 'VariableDeclaration',
                                                                declarations: [{
                                                                        type: 'VariableDeclarator',
                                                                        id: {
                                                                            type: 'Identifier',
                                                                            name: 'isEmpty',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 74,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/AssignedColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 74,
                                                                                    column: 27,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/AssignedColumn.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        init: {
                                                                            type: 'CallExpression',
                                                                            callee: {
                                                                                type: 'Function',
                                                                                context: false,
                                                                                value: function (value) {
                                                                                    if (!(value != null)) {
                                                                                        return true;
                                                                                    }
                                                                                    for (var key in value) {
                                                                                        return false;
                                                                                    }
                                                                                    return true;
                                                                                }
                                                                            },
                                                                            arguments: [{
                                                                                    type: 'Identifier',
                                                                                    name: 'value',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 74,
                                                                                            column: 34,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/AssignedColumn.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 74,
                                                                                            column: 39,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/AssignedColumn.ion'
                                                                                        }
                                                                                    }
                                                                                }],
                                                                            loc: {
                                                                                start: {
                                                                                    line: 74,
                                                                                    column: 30,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/AssignedColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 80,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/AssignedColumn.ion'
                                                                                }
                                                                            }
                                                                        }
                                                                    }],
                                                                kind: 'let',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'classList',
                                                                    loc: {
                                                                        start: {
                                                                            line: 80,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/AssignedColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 80,
                                                                            column: 25,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/AssignedColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'ObjectExpression',
                                                                    properties: [
                                                                        {
                                                                            type: 'IfStatement',
                                                                            test: {
                                                                                type: 'Identifier',
                                                                                name: 'expanded',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 81,
                                                                                        column: 23,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/AssignedColumn.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 81,
                                                                                        column: 31,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/AssignedColumn.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            consequent: {
                                                                                type: 'BlockStatement',
                                                                                body: [{
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'Literal',
                                                                                            value: 'expanded'
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 82,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/AssignedColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 82,
                                                                                                column: 34,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/AssignedColumn.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            alternate: null,
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'IfStatement',
                                                                            test: {
                                                                                type: 'Identifier',
                                                                                name: 'isEmpty',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 83,
                                                                                        column: 23,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/AssignedColumn.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 83,
                                                                                        column: 30,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/AssignedColumn.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            consequent: {
                                                                                type: 'BlockStatement',
                                                                                body: [{
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'Literal',
                                                                                            value: 'empty'
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 84,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/AssignedColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 84,
                                                                                                column: 31,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/AssignedColumn.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            alternate: null,
                                                                            order: '1'
                                                                        }
                                                                    ]
                                                                },
                                                                kind: 'init',
                                                                order: '1'
                                                            },
                                                            {
                                                                type: 'IfStatement',
                                                                test: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '&&',
                                                                    left: {
                                                                        type: 'UnaryExpression',
                                                                        operator: '!',
                                                                        argument: {
                                                                            type: 'Identifier',
                                                                            name: 'expanded',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 85,
                                                                                    column: 23,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/AssignedColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 85,
                                                                                    column: 31,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/AssignedColumn.ion'
                                                                                }
                                                                            }
                                                                        }
                                                                    },
                                                                    right: {
                                                                        type: 'UnaryExpression',
                                                                        operator: '?',
                                                                        argument: {
                                                                            type: 'Identifier',
                                                                            name: 'value',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 85,
                                                                                    column: 36,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/AssignedColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 85,
                                                                                    column: 41,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/AssignedColumn.ion'
                                                                                }
                                                                            }
                                                                        }
                                                                    }
                                                                },
                                                                consequent: {
                                                                    type: 'BlockStatement',
                                                                    body: [{
                                                                            type: 'IfStatement',
                                                                            test: {
                                                                                type: 'BinaryExpression',
                                                                                operator: '===',
                                                                                left: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'property',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 86,
                                                                                                column: 23,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/AssignedColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 86,
                                                                                                column: 31,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/AssignedColumn.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'format',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 86,
                                                                                                column: 32,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/AssignedColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 86,
                                                                                                column: 38,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/AssignedColumn.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 86,
                                                                                            column: 23,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/AssignedColumn.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 86,
                                                                                            column: 38,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/AssignedColumn.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                right: {
                                                                                    type: 'Literal',
                                                                                    value: 'key'
                                                                                }
                                                                            },
                                                                            consequent: {
                                                                                type: 'BlockStatement',
                                                                                body: [
                                                                                    {
                                                                                        type: 'VariableDeclaration',
                                                                                        declarations: [{
                                                                                                type: 'VariableDeclarator',
                                                                                                id: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'foreignRecord',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 87,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/AssignedColumn.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 87,
                                                                                                            column: 41,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/AssignedColumn.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                init: {
                                                                                                    type: 'MemberExpression',
                                                                                                    computed: true,
                                                                                                    object: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'source',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 87,
                                                                                                                column: 44,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/AssignedColumn.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 87,
                                                                                                                column: 50,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/AssignedColumn.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    property: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'value',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 87,
                                                                                                                column: 51,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/AssignedColumn.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 87,
                                                                                                                column: 56,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/AssignedColumn.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 87,
                                                                                                            column: 44,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/AssignedColumn.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 87,
                                                                                                            column: 57,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/AssignedColumn.ion'
                                                                                                        }
                                                                                                    }
                                                                                                }
                                                                                            }],
                                                                                        kind: 'let',
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'IfStatement',
                                                                                        test: {
                                                                                            type: 'UnaryExpression',
                                                                                            operator: '?',
                                                                                            argument: {
                                                                                                type: 'Identifier',
                                                                                                name: 'foreignRecord',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 88,
                                                                                                        column: 27,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/AssignedColumn.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 88,
                                                                                                        column: 40,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/AssignedColumn.ion'
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        consequent: {
                                                                                            type: 'BlockStatement',
                                                                                            body: [{
                                                                                                    type: 'ExpressionStatement',
                                                                                                    expression: {
                                                                                                        type: 'CallExpression',
                                                                                                        callee: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'RecordChip',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 89,
                                                                                                                    column: 28,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/AssignedColumn.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 89,
                                                                                                                    column: 38,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/AssignedColumn.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        arguments: [{
                                                                                                                type: 'ObjectExpression',
                                                                                                                properties: [{
                                                                                                                        type: 'Property',
                                                                                                                        key: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'record',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 89,
                                                                                                                                    column: 40,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/AssignedColumn.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 89,
                                                                                                                                    column: 46,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/AssignedColumn.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        value: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'foreignRecord',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 89,
                                                                                                                                    column: 47,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/AssignedColumn.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 89,
                                                                                                                                    column: 60,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/AssignedColumn.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        kind: 'init',
                                                                                                                        order: '0'
                                                                                                                    }]
                                                                                                            }],
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 89,
                                                                                                                column: 28,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/AssignedColumn.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 89,
                                                                                                                column: 62,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/AssignedColumn.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 89,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/AssignedColumn.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 89,
                                                                                                            column: 62,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/AssignedColumn.ion'
                                                                                                        }
                                                                                                    },
                                                                                                    order: '0'
                                                                                                }]
                                                                                        },
                                                                                        alternate: null,
                                                                                        order: '1'
                                                                                    }
                                                                                ]
                                                                            },
                                                                            alternate: {
                                                                                type: 'IfStatement',
                                                                                test: {
                                                                                    type: 'BinaryExpression',
                                                                                    operator: '===',
                                                                                    left: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'property',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 90,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/AssignedColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 90,
                                                                                                    column: 36,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/AssignedColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'type',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 90,
                                                                                                    column: 37,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/AssignedColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 90,
                                                                                                    column: 41,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/AssignedColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 90,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/AssignedColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 90,
                                                                                                column: 41,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/AssignedColumn.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    right: {
                                                                                        type: 'Literal',
                                                                                        value: 'object'
                                                                                    }
                                                                                },
                                                                                consequent: {
                                                                                    type: 'BlockStatement',
                                                                                    body: [{
                                                                                            type: 'ForInStatement',
                                                                                            left: {
                                                                                                type: 'VariableDeclaration',
                                                                                                declarations: [
                                                                                                    {
                                                                                                        type: 'VariableDeclarator',
                                                                                                        id: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'key',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 91,
                                                                                                                    column: 28,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/AssignedColumn.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 91,
                                                                                                                    column: 31,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/AssignedColumn.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        init: null
                                                                                                    },
                                                                                                    {
                                                                                                        type: 'VariableDeclarator',
                                                                                                        id: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'details',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 91,
                                                                                                                    column: 33,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/AssignedColumn.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 91,
                                                                                                                    column: 40,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/AssignedColumn.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        init: null
                                                                                                    }
                                                                                                ],
                                                                                                kind: 'let'
                                                                                            },
                                                                                            right: {
                                                                                                type: 'Identifier',
                                                                                                name: 'value',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 91,
                                                                                                        column: 44,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/AssignedColumn.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 91,
                                                                                                        column: 49,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/AssignedColumn.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            body: {
                                                                                                type: 'BlockStatement',
                                                                                                body: [
                                                                                                    {
                                                                                                        type: 'VariableDeclaration',
                                                                                                        declarations: [{
                                                                                                                type: 'VariableDeclarator',
                                                                                                                id: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'foreignRecord',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 92,
                                                                                                                            column: 32,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/AssignedColumn.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 92,
                                                                                                                            column: 45,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/AssignedColumn.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                init: {
                                                                                                                    type: 'MemberExpression',
                                                                                                                    computed: true,
                                                                                                                    object: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'source',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 92,
                                                                                                                                column: 48,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/AssignedColumn.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 92,
                                                                                                                                column: 54,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/AssignedColumn.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    property: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'key',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 92,
                                                                                                                                column: 55,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/AssignedColumn.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 92,
                                                                                                                                column: 58,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/AssignedColumn.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 92,
                                                                                                                            column: 48,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/AssignedColumn.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 92,
                                                                                                                            column: 59,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/AssignedColumn.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                }
                                                                                                            }],
                                                                                                        kind: 'let',
                                                                                                        order: '0'
                                                                                                    },
                                                                                                    {
                                                                                                        type: 'IfStatement',
                                                                                                        test: {
                                                                                                            type: 'UnaryExpression',
                                                                                                            operator: '?',
                                                                                                            argument: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'foreignRecord',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 93,
                                                                                                                        column: 31,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/AssignedColumn.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 93,
                                                                                                                        column: 44,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/AssignedColumn.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        consequent: {
                                                                                                            type: 'BlockStatement',
                                                                                                            body: [{
                                                                                                                    type: 'ExpressionStatement',
                                                                                                                    expression: {
                                                                                                                        type: 'CallExpression',
                                                                                                                        callee: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'RecordChip',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 94,
                                                                                                                                    column: 32,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/AssignedColumn.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 94,
                                                                                                                                    column: 42,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/AssignedColumn.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        arguments: [{
                                                                                                                                type: 'ObjectExpression',
                                                                                                                                properties: [
                                                                                                                                    {
                                                                                                                                        type: 'Property',
                                                                                                                                        key: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'record',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 94,
                                                                                                                                                    column: 44,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/AssignedColumn.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 94,
                                                                                                                                                    column: 50,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/AssignedColumn.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        value: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'foreignRecord',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 94,
                                                                                                                                                    column: 51,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/AssignedColumn.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 94,
                                                                                                                                                    column: 64,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/AssignedColumn.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        kind: 'init',
                                                                                                                                        order: '0'
                                                                                                                                    },
                                                                                                                                    {
                                                                                                                                        type: 'Property',
                                                                                                                                        key: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'details',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 94,
                                                                                                                                                    column: 66,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/AssignedColumn.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 94,
                                                                                                                                                    column: 73,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/AssignedColumn.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        value: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'details',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 94,
                                                                                                                                                    column: 66,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/AssignedColumn.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 94,
                                                                                                                                                    column: 73,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/AssignedColumn.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        kind: 'init',
                                                                                                                                        order: '1'
                                                                                                                                    }
                                                                                                                                ]
                                                                                                                            }],
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 94,
                                                                                                                                column: 32,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/AssignedColumn.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 94,
                                                                                                                                column: 75,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/AssignedColumn.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 94,
                                                                                                                            column: 32,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/AssignedColumn.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 94,
                                                                                                                            column: 75,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/AssignedColumn.ion'
                                                                                                                        }
                                                                                                                    },
                                                                                                                    order: '0'
                                                                                                                }]
                                                                                                        },
                                                                                                        alternate: null,
                                                                                                        order: '1'
                                                                                                    }
                                                                                                ]
                                                                                            },
                                                                                            remove: null,
                                                                                            order: '0'
                                                                                        }]
                                                                                },
                                                                                alternate: null
                                                                            },
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                alternate: null,
                                                                order: '2'
                                                            }
                                                        ]
                                                    },
                                                    order: '9'
                                                }
                                            ],
                                            bound: false,
                                            name: {
                                                type: 'Identifier',
                                                name: 'createBodyCell',
                                                loc: {
                                                    start: {
                                                        line: 40,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'viewpath/html/AssignedColumn.ion'
                                                    },
                                                    end: {
                                                        line: 40,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'viewpath/html/AssignedColumn.ion'
                                                    }
                                                }
                                            },
                                            scope: {
                                                type: 'Identifier',
                                                name: '_ps'
                                            }
                                        }, {
                                            this: this,
                                            ion: ion,
                                            row: row,
                                            _ps: _ps,
                                            property: property,
                                            glass: glass,
                                            _ref: _ref,
                                            _ref2: _ref2,
                                            _ref3: _ref3,
                                            _ref4: _ref4,
                                            _ref5: _ref5,
                                            Schema: Schema,
                                            DefaultColumn: DefaultColumn,
                                            jsonValueToDisplayValue: jsonValueToDisplayValue,
                                            Chip: Chip,
                                            RecordChip: RecordChip,
                                            style: style,
                                            _ref7: _ref7
                                        }, _ps);
                                    });
                                }
                            },
                            kind: 'init',
                            order: '1'
                        }
                    ]
                },
                order: '2'
            }
        ],
        bound: false
    }, {
        this: this,
        ion: ion,
        property: property,
        glass: glass,
        _ref: _ref,
        _ref2: _ref2,
        _ref3: _ref3,
        _ref4: _ref4,
        _ref5: _ref5,
        Schema: Schema,
        DefaultColumn: DefaultColumn,
        jsonValueToDisplayValue: jsonValueToDisplayValue,
        Chip: Chip,
        RecordChip: RecordChip,
        style: style,
        _ref7: _ref7
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/AssignedColumn',_viewpath_html_AssignedColumn_);
    else
      _viewpath_html_AssignedColumn_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_AssignedColumn_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_CommentItem_ = function(module,exports,require){'use strict';
var ion = require('ion');
var glass = require('glass'), _ref, _ref2, _ref3;
_ref = glass.html;
var style = _ref.style;
_ref2 = glass.html.material;
var Checkbox = _ref2.Checkbox;
var List = _ref2.List;
var Icon = _ref2.Icon;
var Field = _ref2.Field;
var Img = _ref2.Img;
var RecordIcon = _ref2.RecordIcon;
_ref3 = require('../model');
var Project = _ref3.Project;
var Task = _ref3.Task;
var _ref5 = style.sheets;
_ref5[module.id] = '.comments li {\n    display:flex;\n    margin-bottom:0;\n    flex:none;\n}\n.items.display .comments .item:hover {\n    background-color:inherit;\n}\n.comments .comment-text {\n    margin:0;\n    font-size:13px;\n}\n.comment-header {\n    margin:0 0 3px;\n    font-size:12px;\n    font-weight:400;\n    color:' + style.color.textLight + ';\n}';
_ref5;
module.exports = exports = ion.template(function (_ref4) {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'item',
                            loc: {
                                start: {
                                    line: 28,
                                    column: 18,
                                    fixed: true,
                                    source: 'viewpath/html/CommentItem.ion'
                                },
                                end: {
                                    line: 28,
                                    column: 22,
                                    fixed: true,
                                    source: 'viewpath/html/CommentItem.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref4'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'item',
                                loc: {
                                    start: {
                                        line: 28,
                                        column: 18,
                                        fixed: true,
                                        source: 'viewpath/html/CommentItem.ion'
                                    },
                                    end: {
                                        line: 28,
                                        column: 22,
                                        fixed: true,
                                        source: 'viewpath/html/CommentItem.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'config',
                            loc: {
                                start: {
                                    line: 28,
                                    column: 24,
                                    fixed: true,
                                    source: 'viewpath/html/CommentItem.ion'
                                },
                                end: {
                                    line: 28,
                                    column: 30,
                                    fixed: true,
                                    source: 'viewpath/html/CommentItem.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref4'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'config',
                                loc: {
                                    start: {
                                        line: 28,
                                        column: 24,
                                        fixed: true,
                                        source: 'viewpath/html/CommentItem.ion'
                                    },
                                    end: {
                                        line: 28,
                                        column: 30,
                                        fixed: true,
                                        source: 'viewpath/html/CommentItem.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'comments',
                            loc: {
                                start: {
                                    line: 28,
                                    column: 32,
                                    fixed: true,
                                    source: 'viewpath/html/CommentItem.ion'
                                },
                                end: {
                                    line: 28,
                                    column: 40,
                                    fixed: true,
                                    source: 'viewpath/html/CommentItem.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref4'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'comments',
                                loc: {
                                    start: {
                                        line: 28,
                                        column: 32,
                                        fixed: true,
                                        source: 'viewpath/html/CommentItem.ion'
                                    },
                                    end: {
                                        line: 28,
                                        column: 40,
                                        fixed: true,
                                        source: 'viewpath/html/CommentItem.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'IfStatement',
                test: {
                    type: 'UnaryExpression',
                    operator: '?',
                    argument: {
                        type: 'Identifier',
                        name: 'item',
                        loc: {
                            start: {
                                line: 29,
                                column: 7,
                                fixed: true,
                                source: 'viewpath/html/CommentItem.ion'
                            },
                            end: {
                                line: 29,
                                column: 11,
                                fixed: true,
                                source: 'viewpath/html/CommentItem.ion'
                            }
                        }
                    }
                },
                consequent: {
                    type: 'BlockStatement',
                    body: [
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'commentUser',
                                        loc: {
                                            start: {
                                                line: 30,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/CommentItem.ion'
                                            },
                                            end: {
                                                line: 30,
                                                column: 23,
                                                fixed: true,
                                                source: 'viewpath/html/CommentItem.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'MemberExpression',
                                        computed: true,
                                        object: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'model',
                                                loc: {
                                                    start: {
                                                        line: 30,
                                                        column: 26,
                                                        fixed: true,
                                                        source: 'viewpath/html/CommentItem.ion'
                                                    },
                                                    end: {
                                                        line: 30,
                                                        column: 31,
                                                        fixed: true,
                                                        source: 'viewpath/html/CommentItem.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'server',
                                                loc: {
                                                    start: {
                                                        line: 30,
                                                        column: 32,
                                                        fixed: true,
                                                        source: 'viewpath/html/CommentItem.ion'
                                                    },
                                                    end: {
                                                        line: 30,
                                                        column: 38,
                                                        fixed: true,
                                                        source: 'viewpath/html/CommentItem.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 30,
                                                    column: 26,
                                                    fixed: true,
                                                    source: 'viewpath/html/CommentItem.ion'
                                                },
                                                end: {
                                                    line: 30,
                                                    column: 38,
                                                    fixed: true,
                                                    source: 'viewpath/html/CommentItem.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'item',
                                                loc: {
                                                    start: {
                                                        line: 30,
                                                        column: 39,
                                                        fixed: true,
                                                        source: 'viewpath/html/CommentItem.ion'
                                                    },
                                                    end: {
                                                        line: 30,
                                                        column: 43,
                                                        fixed: true,
                                                        source: 'viewpath/html/CommentItem.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'createdBy',
                                                loc: {
                                                    start: {
                                                        line: 30,
                                                        column: 44,
                                                        fixed: true,
                                                        source: 'viewpath/html/CommentItem.ion'
                                                    },
                                                    end: {
                                                        line: 30,
                                                        column: 53,
                                                        fixed: true,
                                                        source: 'viewpath/html/CommentItem.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 30,
                                                    column: 39,
                                                    fixed: true,
                                                    source: 'viewpath/html/CommentItem.ion'
                                                },
                                                end: {
                                                    line: 30,
                                                    column: 53,
                                                    fixed: true,
                                                    source: 'viewpath/html/CommentItem.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 30,
                                                column: 26,
                                                fixed: true,
                                                source: 'viewpath/html/CommentItem.ion'
                                            },
                                            end: {
                                                line: 30,
                                                column: 54,
                                                fixed: true,
                                                source: 'viewpath/html/CommentItem.ion'
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '0'
                        },
                        {
                            type: 'IfStatement',
                            test: {
                                type: 'Identifier',
                                name: 'commentUser',
                                loc: {
                                    start: {
                                        line: 31,
                                        column: 11,
                                        fixed: true,
                                        source: 'viewpath/html/CommentItem.ion'
                                    },
                                    end: {
                                        line: 31,
                                        column: 22,
                                        fixed: true,
                                        source: 'viewpath/html/CommentItem.ion'
                                    }
                                }
                            },
                            consequent: {
                                type: 'BlockStatement',
                                body: [{
                                        type: 'ReturnStatement',
                                        argument: {
                                            type: 'ObjectExpression',
                                            objectType: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'Li',
                                                    loc: {
                                                        start: {
                                                            line: 32,
                                                            column: 19,
                                                            fixed: true,
                                                            source: 'viewpath/html/CommentItem.ion'
                                                        },
                                                        end: {
                                                            line: 32,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'viewpath/html/CommentItem.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [{
                                                        type: 'ObjectExpression',
                                                        properties: [{
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'class',
                                                                    loc: {
                                                                        start: {
                                                                            line: 32,
                                                                            column: 23,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/CommentItem.ion'
                                                                        },
                                                                        end: {
                                                                            line: 32,
                                                                            column: 28,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/CommentItem.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: 'item comment'
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            }]
                                                    }],
                                                loc: {
                                                    start: {
                                                        line: 32,
                                                        column: 19,
                                                        fixed: true,
                                                        source: 'viewpath/html/CommentItem.ion'
                                                    },
                                                    end: {
                                                        line: 32,
                                                        column: 45,
                                                        fixed: true,
                                                        source: 'viewpath/html/CommentItem.ion'
                                                    }
                                                }
                                            },
                                            properties: [
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'style',
                                                        loc: {
                                                            start: {
                                                                line: 33,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/CommentItem.ion'
                                                            },
                                                            end: {
                                                                line: 33,
                                                                column: 21,
                                                                fixed: true,
                                                                source: 'viewpath/html/CommentItem.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'ObjectExpression',
                                                        properties: [
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'order',
                                                                    loc: {
                                                                        start: {
                                                                            line: 34,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/CommentItem.ion'
                                                                        },
                                                                        end: {
                                                                            line: 34,
                                                                            column: 25,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/CommentItem.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'item',
                                                                        loc: {
                                                                            start: {
                                                                                line: 34,
                                                                                column: 27,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/CommentItem.ion'
                                                                            },
                                                                            end: {
                                                                                line: 34,
                                                                                column: 31,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/CommentItem.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'id',
                                                                        loc: {
                                                                            start: {
                                                                                line: 34,
                                                                                column: 32,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/CommentItem.ion'
                                                                            },
                                                                            end: {
                                                                                line: 34,
                                                                                column: 34,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/CommentItem.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 34,
                                                                            column: 27,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/CommentItem.ion'
                                                                        },
                                                                        end: {
                                                                            line: 34,
                                                                            column: 34,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/CommentItem.ion'
                                                                        }
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'position',
                                                                    loc: {
                                                                        start: {
                                                                            line: 35,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/CommentItem.ion'
                                                                        },
                                                                        end: {
                                                                            line: 35,
                                                                            column: 28,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/CommentItem.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: 'relative'
                                                                },
                                                                kind: 'init',
                                                                order: '1'
                                                            }
                                                        ]
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'IfStatement',
                                                    test: {
                                                        type: 'BinaryExpression',
                                                        operator: '===',
                                                        left: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'item',
                                                                        loc: {
                                                                            start: {
                                                                                line: 36,
                                                                                column: 19,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/CommentItem.ion'
                                                                            },
                                                                            end: {
                                                                                line: 36,
                                                                                column: 23,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/CommentItem.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'createdBy',
                                                                        loc: {
                                                                            start: {
                                                                                line: 36,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/CommentItem.ion'
                                                                            },
                                                                            end: {
                                                                                line: 36,
                                                                                column: 33,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/CommentItem.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 36,
                                                                            column: 19,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/CommentItem.ion'
                                                                        },
                                                                        end: {
                                                                            line: 36,
                                                                            column: 33,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/CommentItem.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'toString',
                                                                    loc: {
                                                                        start: {
                                                                            line: 36,
                                                                            column: 34,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/CommentItem.ion'
                                                                        },
                                                                        end: {
                                                                            line: 36,
                                                                            column: 42,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/CommentItem.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 36,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/CommentItem.ion'
                                                                    },
                                                                    end: {
                                                                        line: 36,
                                                                        column: 42,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/CommentItem.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [],
                                                            loc: {
                                                                start: {
                                                                    line: 36,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/CommentItem.ion'
                                                                },
                                                                end: {
                                                                    line: 36,
                                                                    column: 44,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/CommentItem.ion'
                                                                }
                                                            }
                                                        },
                                                        right: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'model',
                                                                        loc: {
                                                                            start: {
                                                                                line: 36,
                                                                                column: 48,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/CommentItem.ion'
                                                                            },
                                                                            end: {
                                                                                line: 36,
                                                                                column: 53,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/CommentItem.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'userKey',
                                                                        loc: {
                                                                            start: {
                                                                                line: 36,
                                                                                column: 54,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/CommentItem.ion'
                                                                            },
                                                                            end: {
                                                                                line: 36,
                                                                                column: 61,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/CommentItem.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 36,
                                                                            column: 48,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/CommentItem.ion'
                                                                        },
                                                                        end: {
                                                                            line: 36,
                                                                            column: 61,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/CommentItem.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'toString',
                                                                    loc: {
                                                                        start: {
                                                                            line: 36,
                                                                            column: 62,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/CommentItem.ion'
                                                                        },
                                                                        end: {
                                                                            line: 36,
                                                                            column: 70,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/CommentItem.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 36,
                                                                        column: 48,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/CommentItem.ion'
                                                                    },
                                                                    end: {
                                                                        line: 36,
                                                                        column: 70,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/CommentItem.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [],
                                                            loc: {
                                                                start: {
                                                                    line: 36,
                                                                    column: 48,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/CommentItem.ion'
                                                                },
                                                                end: {
                                                                    line: 36,
                                                                    column: 72,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/CommentItem.ion'
                                                                }
                                                            }
                                                        }
                                                    },
                                                    consequent: {
                                                        type: 'BlockStatement',
                                                        body: [{
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'ObjectExpression',
                                                                    objectType: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'Identifier',
                                                                            name: 'PaperIconButton',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 37,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/CommentItem.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 37,
                                                                                    column: 35,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/CommentItem.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [{
                                                                                type: 'ObjectExpression',
                                                                                properties: [{
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'class',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 37,
                                                                                                    column: 37,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/CommentItem.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 37,
                                                                                                    column: 42,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/CommentItem.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 'secondary hover-show'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    }]
                                                                            }],
                                                                        loc: {
                                                                            start: {
                                                                                line: 37,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/CommentItem.ion'
                                                                            },
                                                                            end: {
                                                                                line: 37,
                                                                                column: 67,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/CommentItem.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    properties: [
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'icon',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 38,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/CommentItem.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 38,
                                                                                        column: 28,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/CommentItem.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'clear'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'style',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 39,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/CommentItem.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 39,
                                                                                        column: 29,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/CommentItem.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'ObjectExpression',
                                                                                properties: [
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'position',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 40,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/CommentItem.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 40,
                                                                                                    column: 36,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/CommentItem.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 'absolute'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'top',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 41,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/CommentItem.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 41,
                                                                                                    column: 31,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/CommentItem.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: '10px'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '1'
                                                                                    },
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'right',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 42,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/CommentItem.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 42,
                                                                                                    column: 33,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/CommentItem.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: '10px'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '2'
                                                                                    }
                                                                                ]
                                                                            },
                                                                            kind: 'init',
                                                                            order: '1'
                                                                        },
                                                                        {
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'Function',
                                                                                context: true,
                                                                                value: function (_context) {
                                                                                    return function click() {
                                                                                        var comments = _context.get('comments'), item = _context.get('item');
                                                                                        console.log('delete comment');
                                                                                        delete comments[item.key];
                                                                                    };
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 43,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/CommentItem.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 46,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/CommentItem.ion'
                                                                                }
                                                                            },
                                                                            order: '2'
                                                                        }
                                                                    ]
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 37,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/CommentItem.ion'
                                                                    },
                                                                    end: {
                                                                        line: 46,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/CommentItem.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    alternate: null,
                                                    order: '1'
                                                },
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'RecordIcon',
                                                                loc: {
                                                                    start: {
                                                                        line: 46,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/CommentItem.ion'
                                                                    },
                                                                    end: {
                                                                        line: 46,
                                                                        column: 26,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/CommentItem.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [{
                                                                    type: 'ObjectExpression',
                                                                    properties: [
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'record',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 46,
                                                                                        column: 28,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/CommentItem.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 46,
                                                                                        column: 34,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/CommentItem.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Identifier',
                                                                                name: 'commentUser',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 46,
                                                                                        column: 36,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/CommentItem.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 46,
                                                                                        column: 47,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/CommentItem.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'size',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 46,
                                                                                        column: 49,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/CommentItem.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 46,
                                                                                        column: 53,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/CommentItem.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 32
                                                                            },
                                                                            kind: 'init',
                                                                            order: '1'
                                                                        }
                                                                    ]
                                                                }],
                                                            loc: {
                                                                start: {
                                                                    line: 46,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/CommentItem.ion'
                                                                },
                                                                end: {
                                                                    line: 46,
                                                                    column: 59,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/CommentItem.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [{
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'style',
                                                                    loc: {
                                                                        start: {
                                                                            line: 47,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/CommentItem.ion'
                                                                        },
                                                                        end: {
                                                                            line: 47,
                                                                            column: 25,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/CommentItem.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'ObjectExpression',
                                                                    properties: [
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'marginRight',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 48,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/CommentItem.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 48,
                                                                                        column: 35,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/CommentItem.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: '10px'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'borderRadius',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 49,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/CommentItem.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 49,
                                                                                        column: 36,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/CommentItem.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: '2px'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '1'
                                                                        }
                                                                    ]
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            }]
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 46,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/CommentItem.ion'
                                                        },
                                                        end: {
                                                            line: 50,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'viewpath/html/CommentItem.ion'
                                                        }
                                                    },
                                                    order: '2'
                                                },
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'Div',
                                                                loc: {
                                                                    start: {
                                                                        line: 50,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/CommentItem.ion'
                                                                    },
                                                                    end: {
                                                                        line: 50,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/CommentItem.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [{
                                                                    type: 'ObjectExpression',
                                                                    properties: [{
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'class',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 50,
                                                                                        column: 21,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/CommentItem.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 50,
                                                                                        column: 26,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/CommentItem.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'comment-content'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        }]
                                                                }],
                                                            loc: {
                                                                start: {
                                                                    line: 50,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/CommentItem.ion'
                                                                },
                                                                end: {
                                                                    line: 50,
                                                                    column: 46,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/CommentItem.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'ObjectExpression',
                                                                    objectType: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'Identifier',
                                                                            name: 'H3',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 51,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/CommentItem.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 51,
                                                                                    column: 22,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/CommentItem.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [{
                                                                                type: 'ObjectExpression',
                                                                                properties: [{
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'class',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 51,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/CommentItem.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 51,
                                                                                                    column: 29,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/CommentItem.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 'comment-header'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    }]
                                                                            }],
                                                                        loc: {
                                                                            start: {
                                                                                line: 51,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/CommentItem.ion'
                                                                            },
                                                                            end: {
                                                                                line: 51,
                                                                                column: 48,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/CommentItem.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    properties: [
                                                                        {
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'ObjectExpression',
                                                                                objectType: {
                                                                                    type: 'CallExpression',
                                                                                    callee: {
                                                                                        type: 'Identifier',
                                                                                        name: 'Span',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 52,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/CommentItem.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 52,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/CommentItem.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    arguments: [{
                                                                                            type: 'ObjectExpression',
                                                                                            properties: [{
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'class',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 52,
                                                                                                                column: 30,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/CommentItem.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 52,
                                                                                                                column: 35,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/CommentItem.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'Literal',
                                                                                                        value: 'comment-author'
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '0'
                                                                                                }]
                                                                                        }],
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 52,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/CommentItem.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 52,
                                                                                            column: 54,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/CommentItem.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                properties: [{
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'BinaryExpression',
                                                                                            operator: '+',
                                                                                            left: {
                                                                                                type: 'MemberExpression',
                                                                                                computed: false,
                                                                                                object: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'commentUser',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 53,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/CommentItem.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 53,
                                                                                                            column: 39,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/CommentItem.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'name',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 53,
                                                                                                            column: 40,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/CommentItem.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 53,
                                                                                                            column: 44,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/CommentItem.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 53,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/CommentItem.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 53,
                                                                                                        column: 44,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/CommentItem.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            right: {
                                                                                                type: 'Literal',
                                                                                                value: ' - '
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 53,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/CommentItem.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 53,
                                                                                                column: 52,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/CommentItem.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 52,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/CommentItem.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 54,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/CommentItem.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'ObjectExpression',
                                                                                objectType: {
                                                                                    type: 'CallExpression',
                                                                                    callee: {
                                                                                        type: 'Identifier',
                                                                                        name: 'Span',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 54,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/CommentItem.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 54,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/CommentItem.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    arguments: [{
                                                                                            type: 'ObjectExpression',
                                                                                            properties: [{
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'class',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 54,
                                                                                                                column: 30,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/CommentItem.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 54,
                                                                                                                column: 35,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/CommentItem.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'Literal',
                                                                                                        value: 'comment-datetime'
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '0'
                                                                                                }]
                                                                                        }],
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 54,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/CommentItem.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 54,
                                                                                            column: 56,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/CommentItem.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                properties: [{
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'CallExpression',
                                                                                            callee: {
                                                                                                type: 'MemberExpression',
                                                                                                computed: false,
                                                                                                object: {
                                                                                                    type: 'NewExpression',
                                                                                                    callee: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'Date',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 55,
                                                                                                                column: 32,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/CommentItem.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 55,
                                                                                                                column: 36,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/CommentItem.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    arguments: [{
                                                                                                            type: 'MemberExpression',
                                                                                                            computed: false,
                                                                                                            object: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'item',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 55,
                                                                                                                        column: 37,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/CommentItem.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 55,
                                                                                                                        column: 41,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/CommentItem.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            property: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'created',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 55,
                                                                                                                        column: 42,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/CommentItem.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 55,
                                                                                                                        column: 49,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/CommentItem.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 55,
                                                                                                                    column: 37,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/CommentItem.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 55,
                                                                                                                    column: 49,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/CommentItem.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        }],
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 55,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/CommentItem.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 55,
                                                                                                            column: 50,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/CommentItem.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'format',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 55,
                                                                                                            column: 51,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/CommentItem.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 55,
                                                                                                            column: 57,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/CommentItem.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 55,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/CommentItem.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 55,
                                                                                                        column: 57,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/CommentItem.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            arguments: [{
                                                                                                    type: 'Literal',
                                                                                                    value: '{MM}/{dd}/{yyyy} {time}'
                                                                                                }],
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 55,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/CommentItem.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 55,
                                                                                                    column: 84,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/CommentItem.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 55,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/CommentItem.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 55,
                                                                                                column: 84,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/CommentItem.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 54,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/CommentItem.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 56,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/CommentItem.ion'
                                                                                }
                                                                            },
                                                                            order: '1'
                                                                        }
                                                                    ]
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 51,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/CommentItem.ion'
                                                                    },
                                                                    end: {
                                                                        line: 56,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/CommentItem.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'ObjectExpression',
                                                                    objectType: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'Identifier',
                                                                            name: 'P',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 56,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/CommentItem.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 56,
                                                                                    column: 21,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/CommentItem.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [{
                                                                                type: 'ObjectExpression',
                                                                                properties: [{
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'class',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 56,
                                                                                                    column: 23,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/CommentItem.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 56,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/CommentItem.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 'comment-text'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    }]
                                                                            }],
                                                                        loc: {
                                                                            start: {
                                                                                line: 56,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/CommentItem.ion'
                                                                            },
                                                                            end: {
                                                                                line: 56,
                                                                                column: 45,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/CommentItem.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    properties: [{
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'Identifier',
                                                                                    name: 'item',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 57,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/CommentItem.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 57,
                                                                                            column: 28,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/CommentItem.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'text',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 57,
                                                                                            column: 29,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/CommentItem.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 57,
                                                                                            column: 33,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/CommentItem.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 57,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/CommentItem.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 57,
                                                                                        column: 33,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/CommentItem.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 57,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/CommentItem.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 57,
                                                                                    column: 33,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/CommentItem.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 56,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/CommentItem.ion'
                                                                    },
                                                                    end: {
                                                                        line: 58,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/CommentItem.ion'
                                                                    }
                                                                },
                                                                order: '1'
                                                            }
                                                        ]
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 50,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/CommentItem.ion'
                                                        },
                                                        end: {
                                                            line: 58,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'viewpath/html/CommentItem.ion'
                                                        }
                                                    },
                                                    order: '3'
                                                }
                                            ]
                                        },
                                        order: '0'
                                    }]
                            },
                            alternate: null,
                            order: '1'
                        }
                    ]
                },
                alternate: null,
                order: '3'
            }
        ],
        bound: false
    }, {
        this: this,
        _ref4: _ref4,
        glass: glass,
        _ref: _ref,
        _ref2: _ref2,
        _ref3: _ref3,
        style: style,
        Checkbox: Checkbox,
        List: List,
        Icon: Icon,
        Field: Field,
        Img: Img,
        RecordIcon: RecordIcon,
        Project: Project,
        Task: Task,
        _ref5: _ref5
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/CommentItem',_viewpath_html_CommentItem_);
    else
      _viewpath_html_CommentItem_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_CommentItem_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_DaysOfWeekField_ = function(module,exports,require){'use strict';
var ion = require('ion');
var glass = require('glass'), viewpath = require('../');
var _ref = glass.data, _ref2, daysOfWeek = [
        'Sunday',
        'Monday',
        'Tuesday',
        'Wednesday',
        'Thursday',
        'Friday',
        'Saturday'
    ];
var Schema = _ref.Schema;
_ref2 = glass.html.forms;
var Label = _ref2.Label;
module.exports = exports = ion.template(function DaysOfWeekField(args) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'DaysOfWeekField',
            loc: {
                start: {
                    line: 10,
                    column: 16,
                    fixed: true,
                    source: 'viewpath/html/DaysOfWeekField.ion'
                },
                end: {
                    line: 10,
                    column: 31,
                    fixed: true,
                    source: 'viewpath/html/DaysOfWeekField.ion'
                }
            }
        },
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: '_ref3'
                        },
                        init: {
                            type: 'Identifier',
                            name: 'args',
                            loc: {
                                start: {
                                    line: 11,
                                    column: 33,
                                    fixed: true,
                                    source: 'viewpath/html/DaysOfWeekField.ion'
                                },
                                end: {
                                    line: 11,
                                    column: 37,
                                    fixed: true,
                                    source: 'viewpath/html/DaysOfWeekField.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'property',
                            loc: {
                                start: {
                                    line: 11,
                                    column: 9,
                                    fixed: true,
                                    source: 'viewpath/html/DaysOfWeekField.ion'
                                },
                                end: {
                                    line: 11,
                                    column: 17,
                                    fixed: true,
                                    source: 'viewpath/html/DaysOfWeekField.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'property',
                                loc: {
                                    start: {
                                        line: 11,
                                        column: 9,
                                        fixed: true,
                                        source: 'viewpath/html/DaysOfWeekField.ion'
                                    },
                                    end: {
                                        line: 11,
                                        column: 17,
                                        fixed: true,
                                        source: 'viewpath/html/DaysOfWeekField.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'value',
                            loc: {
                                start: {
                                    line: 11,
                                    column: 18,
                                    fixed: true,
                                    source: 'viewpath/html/DaysOfWeekField.ion'
                                },
                                end: {
                                    line: 11,
                                    column: 23,
                                    fixed: true,
                                    source: 'viewpath/html/DaysOfWeekField.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'value',
                                loc: {
                                    start: {
                                        line: 11,
                                        column: 18,
                                        fixed: true,
                                        source: 'viewpath/html/DaysOfWeekField.ion'
                                    },
                                    end: {
                                        line: 11,
                                        column: 23,
                                        fixed: true,
                                        source: 'viewpath/html/DaysOfWeekField.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'label',
                            loc: {
                                start: {
                                    line: 11,
                                    column: 24,
                                    fixed: true,
                                    source: 'viewpath/html/DaysOfWeekField.ion'
                                },
                                end: {
                                    line: 11,
                                    column: 29,
                                    fixed: true,
                                    source: 'viewpath/html/DaysOfWeekField.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref3'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'label',
                                loc: {
                                    start: {
                                        line: 11,
                                        column: 24,
                                        fixed: true,
                                        source: 'viewpath/html/DaysOfWeekField.ion'
                                    },
                                    end: {
                                        line: 11,
                                        column: 29,
                                        fixed: true,
                                        source: 'viewpath/html/DaysOfWeekField.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '3'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'checkboxes',
                            loc: {
                                start: {
                                    line: 12,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/DaysOfWeekField.ion'
                                },
                                end: {
                                    line: 12,
                                    column: 18,
                                    fixed: true,
                                    source: 'viewpath/html/DaysOfWeekField.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'ArrayExpression',
                                elements: []
                            },
                            properties: [{
                                    type: 'ForOfStatement',
                                    left: {
                                        type: 'VariableDeclaration',
                                        declarations: [
                                            {
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'day',
                                                    loc: {
                                                        start: {
                                                            line: 13,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/DaysOfWeekField.ion'
                                                        },
                                                        end: {
                                                            line: 13,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'viewpath/html/DaysOfWeekField.ion'
                                                        }
                                                    }
                                                },
                                                init: null
                                            },
                                            {
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'index',
                                                    loc: {
                                                        start: {
                                                            line: 13,
                                                            column: 17,
                                                            fixed: true,
                                                            source: 'viewpath/html/DaysOfWeekField.ion'
                                                        },
                                                        end: {
                                                            line: 13,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'viewpath/html/DaysOfWeekField.ion'
                                                        }
                                                    }
                                                },
                                                init: null
                                            }
                                        ],
                                        kind: 'let'
                                    },
                                    right: {
                                        type: 'Identifier',
                                        name: 'daysOfWeek',
                                        loc: {
                                            start: {
                                                line: 13,
                                                column: 26,
                                                fixed: true,
                                                source: 'viewpath/html/DaysOfWeekField.ion'
                                            },
                                            end: {
                                                line: 13,
                                                column: 36,
                                                fixed: true,
                                                source: 'viewpath/html/DaysOfWeekField.ion'
                                            }
                                        }
                                    },
                                    body: {
                                        type: 'BlockStatement',
                                        body: [{
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'ObjectExpression',
                                                    objectType: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'Identifier',
                                                            name: 'PaperCheckbox',
                                                            loc: {
                                                                start: {
                                                                    line: 14,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/DaysOfWeekField.ion'
                                                                },
                                                                end: {
                                                                    line: 14,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/DaysOfWeekField.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [],
                                                        loc: {
                                                            start: {
                                                                line: 14,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'viewpath/html/DaysOfWeekField.ion'
                                                            },
                                                            end: {
                                                                line: 14,
                                                                column: 27,
                                                                fixed: true,
                                                                source: 'viewpath/html/DaysOfWeekField.ion'
                                                            }
                                                        }
                                                    },
                                                    properties: [
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'style',
                                                                loc: {
                                                                    start: {
                                                                        line: 15,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/DaysOfWeekField.ion'
                                                                    },
                                                                    end: {
                                                                        line: 15,
                                                                        column: 21,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/DaysOfWeekField.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'ObjectExpression',
                                                                properties: [{
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'marginRight',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 16,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/DaysOfWeekField.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 16,
                                                                                    column: 31,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/DaysOfWeekField.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Literal',
                                                                            value: '16px'
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    }]
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        },
                                                        {
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Function',
                                                                    context: false,
                                                                    value: function (day) {
                                                                        return day.substring(0, 1);
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'Identifier',
                                                                        name: 'day',
                                                                        loc: {
                                                                            start: {
                                                                                line: 17,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/DaysOfWeekField.ion'
                                                                            },
                                                                            end: {
                                                                                line: 17,
                                                                                column: 23,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/DaysOfWeekField.ion'
                                                                            }
                                                                        }
                                                                    }],
                                                                loc: {
                                                                    start: {
                                                                        line: 17,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/DaysOfWeekField.ion'
                                                                    },
                                                                    end: {
                                                                        line: 17,
                                                                        column: 47,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/DaysOfWeekField.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 17,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/DaysOfWeekField.ion'
                                                                },
                                                                end: {
                                                                    line: 17,
                                                                    column: 47,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/DaysOfWeekField.ion'
                                                                }
                                                            },
                                                            order: '1'
                                                        }
                                                    ]
                                                },
                                                loc: {
                                                    start: {
                                                        line: 14,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/DaysOfWeekField.ion'
                                                    },
                                                    end: {
                                                        line: 18,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'viewpath/html/DaysOfWeekField.ion'
                                                    }
                                                },
                                                order: '0'
                                            }]
                                    },
                                    remove: null,
                                    order: '0'
                                }]
                        }
                    }],
                kind: 'let',
                order: '4'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'setValue',
                            loc: {
                                start: {
                                    line: 18,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/DaysOfWeekField.ion'
                                },
                                end: {
                                    line: 18,
                                    column: 16,
                                    fixed: true,
                                    source: 'viewpath/html/DaysOfWeekField.ion'
                                }
                            }
                        },
                        init: {
                            type: 'Function',
                            context: true,
                            value: function (_context) {
                                return function (value) {
                                    var checkboxes = _context.get('checkboxes');
                                    for (var _i = 0; _i < checkboxes.length; _i++) {
                                        var index = _i;
                                        var checkbox = checkboxes[_i];
                                        checkbox.checked = (value & 1 << index) !== 0;
                                    }
                                };
                            }
                        }
                    }],
                kind: 'let',
                order: '5'
            },
            {
                type: 'IfStatement',
                test: {
                    type: 'Identifier',
                    name: 'value',
                    loc: {
                        start: {
                            line: 22,
                            column: 7,
                            fixed: true,
                            source: 'viewpath/html/DaysOfWeekField.ion'
                        },
                        end: {
                            line: 22,
                            column: 12,
                            fixed: true,
                            source: 'viewpath/html/DaysOfWeekField.ion'
                        }
                    }
                },
                consequent: {
                    type: 'BlockStatement',
                    body: [{
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'setValue',
                                    loc: {
                                        start: {
                                            line: 23,
                                            column: 8,
                                            fixed: true,
                                            source: 'viewpath/html/DaysOfWeekField.ion'
                                        },
                                        end: {
                                            line: 23,
                                            column: 16,
                                            fixed: true,
                                            source: 'viewpath/html/DaysOfWeekField.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'Identifier',
                                        name: 'value',
                                        loc: {
                                            start: {
                                                line: 23,
                                                column: 17,
                                                fixed: true,
                                                source: 'viewpath/html/DaysOfWeekField.ion'
                                            },
                                            end: {
                                                line: 23,
                                                column: 22,
                                                fixed: true,
                                                source: 'viewpath/html/DaysOfWeekField.ion'
                                            }
                                        }
                                    }],
                                loc: {
                                    start: {
                                        line: 23,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/html/DaysOfWeekField.ion'
                                    },
                                    end: {
                                        line: 23,
                                        column: 23,
                                        fixed: true,
                                        source: 'viewpath/html/DaysOfWeekField.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 23,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/DaysOfWeekField.ion'
                                },
                                end: {
                                    line: 23,
                                    column: 23,
                                    fixed: true,
                                    source: 'viewpath/html/DaysOfWeekField.ion'
                                }
                            },
                            order: '0'
                        }]
                },
                alternate: null,
                order: '6'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'CallExpression',
                    callee: {
                        type: 'MemberExpression',
                        object: {
                            type: 'Identifier',
                            name: 'Object'
                        },
                        property: {
                            type: 'Identifier',
                            name: 'defineProperties'
                        }
                    },
                    arguments: [
                        {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Div',
                                    loc: {
                                        start: {
                                            line: 25,
                                            column: 11,
                                            fixed: true,
                                            source: 'viewpath/html/DaysOfWeekField.ion'
                                        },
                                        end: {
                                            line: 25,
                                            column: 14,
                                            fixed: true,
                                            source: 'viewpath/html/DaysOfWeekField.ion'
                                        }
                                    }
                                },
                                arguments: [],
                                loc: {
                                    start: {
                                        line: 25,
                                        column: 11,
                                        fixed: true,
                                        source: 'viewpath/html/DaysOfWeekField.ion'
                                    },
                                    end: {
                                        line: 25,
                                        column: 16,
                                        fixed: true,
                                        source: 'viewpath/html/DaysOfWeekField.ion'
                                    }
                                }
                            },
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'style',
                                        loc: {
                                            start: {
                                                line: 34,
                                                column: 8,
                                                fixed: true,
                                                source: 'viewpath/html/DaysOfWeekField.ion'
                                            },
                                            end: {
                                                line: 34,
                                                column: 13,
                                                fixed: true,
                                                source: 'viewpath/html/DaysOfWeekField.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'margin',
                                                    loc: {
                                                        start: {
                                                            line: 35,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/DaysOfWeekField.ion'
                                                        },
                                                        end: {
                                                            line: 35,
                                                            column: 18,
                                                            fixed: true,
                                                            source: 'viewpath/html/DaysOfWeekField.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: '8px 0px'
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    },
                                    kind: 'init',
                                    order: '0'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'Identifier',
                                            name: 'Label',
                                            loc: {
                                                start: {
                                                    line: 36,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'viewpath/html/DaysOfWeekField.ion'
                                                },
                                                end: {
                                                    line: 36,
                                                    column: 13,
                                                    fixed: true,
                                                    source: 'viewpath/html/DaysOfWeekField.ion'
                                                }
                                            }
                                        },
                                        arguments: [{
                                                type: 'Identifier',
                                                name: 'label',
                                                loc: {
                                                    start: {
                                                        line: 36,
                                                        column: 14,
                                                        fixed: true,
                                                        source: 'viewpath/html/DaysOfWeekField.ion'
                                                    },
                                                    end: {
                                                        line: 36,
                                                        column: 19,
                                                        fixed: true,
                                                        source: 'viewpath/html/DaysOfWeekField.ion'
                                                    }
                                                }
                                            }],
                                        loc: {
                                            start: {
                                                line: 36,
                                                column: 8,
                                                fixed: true,
                                                source: 'viewpath/html/DaysOfWeekField.ion'
                                            },
                                            end: {
                                                line: 36,
                                                column: 20,
                                                fixed: true,
                                                source: 'viewpath/html/DaysOfWeekField.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 36,
                                            column: 8,
                                            fixed: true,
                                            source: 'viewpath/html/DaysOfWeekField.ion'
                                        },
                                        end: {
                                            line: 36,
                                            column: 20,
                                            fixed: true,
                                            source: 'viewpath/html/DaysOfWeekField.ion'
                                        }
                                    },
                                    order: '1'
                                },
                                {
                                    type: 'ForOfStatement',
                                    left: {
                                        type: 'VariableDeclaration',
                                        declarations: [{
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'checkbox',
                                                    loc: {
                                                        start: {
                                                            line: 37,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/DaysOfWeekField.ion'
                                                        },
                                                        end: {
                                                            line: 37,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'viewpath/html/DaysOfWeekField.ion'
                                                        }
                                                    }
                                                },
                                                init: null
                                            }],
                                        kind: 'let'
                                    },
                                    right: {
                                        type: 'Identifier',
                                        name: 'checkboxes',
                                        loc: {
                                            start: {
                                                line: 37,
                                                column: 24,
                                                fixed: true,
                                                source: 'viewpath/html/DaysOfWeekField.ion'
                                            },
                                            end: {
                                                line: 37,
                                                column: 34,
                                                fixed: true,
                                                source: 'viewpath/html/DaysOfWeekField.ion'
                                            }
                                        }
                                    },
                                    body: {
                                        type: 'BlockStatement',
                                        body: [{
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'Identifier',
                                                    name: 'checkbox',
                                                    loc: {
                                                        start: {
                                                            line: 38,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/DaysOfWeekField.ion'
                                                        },
                                                        end: {
                                                            line: 38,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'viewpath/html/DaysOfWeekField.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 38,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/DaysOfWeekField.ion'
                                                    },
                                                    end: {
                                                        line: 38,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'viewpath/html/DaysOfWeekField.ion'
                                                    }
                                                },
                                                order: '0'
                                            }]
                                    },
                                    remove: null,
                                    order: '2'
                                }
                            ]
                        },
                        {
                            type: 'ObjectExpression',
                            properties: [{
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'valueJSON',
                                        loc: {
                                            start: {
                                                line: 26,
                                                column: 17,
                                                fixed: true,
                                                source: 'viewpath/html/DaysOfWeekField.ion'
                                            },
                                            end: {
                                                line: 26,
                                                column: 26,
                                                fixed: true,
                                                source: 'viewpath/html/DaysOfWeekField.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 27,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/DaysOfWeekField.ion'
                                                        },
                                                        end: {
                                                            line: 27,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'viewpath/html/DaysOfWeekField.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context2) {
                                                        return function () {
                                                            var checkboxes = _context2.get('checkboxes');
                                                            var value = 0;
                                                            for (var _i2 = 0; _i2 < checkboxes.length; _i2++) {
                                                                var index = _i2;
                                                                var checkbox = checkboxes[_i2];
                                                                if (checkbox.checked) {
                                                                    value += 1 << index;
                                                                }
                                                            }
                                                            return value;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 33,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/DaysOfWeekField.ion'
                                                        },
                                                        end: {
                                                            line: 33,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'viewpath/html/DaysOfWeekField.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Identifier',
                                                    name: 'setValue',
                                                    loc: {
                                                        start: {
                                                            line: 33,
                                                            column: 17,
                                                            fixed: true,
                                                            source: 'viewpath/html/DaysOfWeekField.ion'
                                                        },
                                                        end: {
                                                            line: 33,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'viewpath/html/DaysOfWeekField.ion'
                                                        }
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '0'
                                }]
                        }
                    ]
                },
                order: '7'
            }
        ],
        bound: false
    }, {
        this: this,
        args: args,
        glass: glass,
        viewpath: viewpath,
        _ref: _ref,
        _ref2: _ref2,
        daysOfWeek: daysOfWeek,
        Schema: Schema,
        Label: Label
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/DaysOfWeekField',_viewpath_html_DaysOfWeekField_);
    else
      _viewpath_html_DaysOfWeekField_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_DaysOfWeekField_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_DiscussionEditor_ = function(module,exports,require){'use strict';
var ion = require('ion');
var glass = require('glass'), _ref, _ref2, _ref3, viewpath = require('../'), _ref4;
_ref = glass.data;
var Key = _ref.Key;
_ref2 = glass.html;
var style = _ref2.style;
_ref3 = glass.html.material;
var Checkbox = _ref3.Checkbox;
var List = _ref3.List;
var Icon = _ref3.Icon;
var Field = _ref3.Field;
var Img = _ref3.Img;
var Button = _ref3.Button;
_ref4 = viewpath.model;
var User = _ref4.User;
var Task = _ref4.Task;
var Comment = _ref4.Comment;
var _ref6 = style.sheets;
_ref6[module.id] = '.DiscussionEditor {\n    # display:flex;\n    border-top:solid 1px #aaa;\n    flex:none;\n}\n\n.discussion-input {\n    flex:1;\n    flex-basis:54px;\n    flex-grow:0;\n    flex-shrink:0;\n    border:0;\n    resize:none;\n    padding:18px;\n    transition: flex-basis 200ms;\n}\n.DiscussionEditor.active .discussion-input{\n    flex-basis:250px;\n}\n.discussion-toolbar {\n    flex-basis:0px;\n    flex-grow:0;\n    flex-shrink:0;\n    transition: flex-basis 200ms;\n    overflow:hidden;\n}\n.DiscussionEditor.active .discussion-toolbar {\n    flex-basis:44px;\n}';
_ref6;
module.exports = exports = ion.template(function (_ref5) {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'comments',
                            loc: {
                                start: {
                                    line: 41,
                                    column: 18,
                                    fixed: true,
                                    source: 'viewpath/html/DiscussionEditor.ion'
                                },
                                end: {
                                    line: 41,
                                    column: 26,
                                    fixed: true,
                                    source: 'viewpath/html/DiscussionEditor.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref5'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'comments',
                                loc: {
                                    start: {
                                        line: 41,
                                        column: 18,
                                        fixed: true,
                                        source: 'viewpath/html/DiscussionEditor.ion'
                                    },
                                    end: {
                                        line: 41,
                                        column: 26,
                                        fixed: true,
                                        source: 'viewpath/html/DiscussionEditor.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'task',
                            loc: {
                                start: {
                                    line: 41,
                                    column: 28,
                                    fixed: true,
                                    source: 'viewpath/html/DiscussionEditor.ion'
                                },
                                end: {
                                    line: 41,
                                    column: 32,
                                    fixed: true,
                                    source: 'viewpath/html/DiscussionEditor.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref5'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'task',
                                loc: {
                                    start: {
                                        line: 41,
                                        column: 28,
                                        fixed: true,
                                        source: 'viewpath/html/DiscussionEditor.ion'
                                    },
                                    end: {
                                        line: 41,
                                        column: 32,
                                        fixed: true,
                                        source: 'viewpath/html/DiscussionEditor.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'editor',
                            loc: {
                                start: {
                                    line: 42,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/DiscussionEditor.ion'
                                },
                                end: {
                                    line: 42,
                                    column: 14,
                                    fixed: true,
                                    source: 'viewpath/html/DiscussionEditor.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Div',
                                loc: {
                                    start: {
                                        line: 42,
                                        column: 17,
                                        fixed: true,
                                        source: 'viewpath/html/DiscussionEditor.ion'
                                    },
                                    end: {
                                        line: 42,
                                        column: 20,
                                        fixed: true,
                                        source: 'viewpath/html/DiscussionEditor.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ObjectExpression',
                                    properties: [{
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'class',
                                                loc: {
                                                    start: {
                                                        line: 42,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'viewpath/html/DiscussionEditor.ion'
                                                    },
                                                    end: {
                                                        line: 42,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'viewpath/html/DiscussionEditor.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: 'DiscussionEditor layout vertical'
                                            },
                                            kind: 'init',
                                            order: '0'
                                        }]
                                }],
                            loc: {
                                start: {
                                    line: 42,
                                    column: 17,
                                    fixed: true,
                                    source: 'viewpath/html/DiscussionEditor.ion'
                                },
                                end: {
                                    line: 42,
                                    column: 64,
                                    fixed: true,
                                    source: 'viewpath/html/DiscussionEditor.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'state',
                            loc: {
                                start: {
                                    line: 43,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/DiscussionEditor.ion'
                                },
                                end: {
                                    line: 43,
                                    column: 13,
                                    fixed: true,
                                    source: 'viewpath/html/DiscussionEditor.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'ObjectExpression',
                                properties: []
                            },
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'active',
                                        loc: {
                                            start: {
                                                line: 44,
                                                column: 8,
                                                fixed: true,
                                                source: 'viewpath/html/DiscussionEditor.ion'
                                            },
                                            end: {
                                                line: 44,
                                                column: 14,
                                                fixed: true,
                                                source: 'viewpath/html/DiscussionEditor.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: false
                                    },
                                    kind: 'init',
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'mode',
                                        loc: {
                                            start: {
                                                line: 45,
                                                column: 8,
                                                fixed: true,
                                                source: 'viewpath/html/DiscussionEditor.ion'
                                            },
                                            end: {
                                                line: 45,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/DiscussionEditor.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: false
                                    },
                                    kind: 'init',
                                    order: '1'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'value',
                                        loc: {
                                            start: {
                                                line: 46,
                                                column: 8,
                                                fixed: true,
                                                source: 'viewpath/html/DiscussionEditor.ion'
                                            },
                                            end: {
                                                line: 46,
                                                column: 13,
                                                fixed: true,
                                                source: 'viewpath/html/DiscussionEditor.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: ''
                                    },
                                    kind: 'init',
                                    order: '2'
                                }
                            ]
                        }
                    }],
                kind: 'let',
                order: '3'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'CallExpression',
                    callee: {
                        type: 'MemberExpression',
                        object: {
                            type: 'Identifier',
                            name: 'Object'
                        },
                        property: {
                            type: 'Identifier',
                            name: 'defineProperties'
                        }
                    },
                    arguments: [
                        {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'Identifier',
                                name: 'editor',
                                loc: {
                                    start: {
                                        line: 48,
                                        column: 11,
                                        fixed: true,
                                        source: 'viewpath/html/DiscussionEditor.ion'
                                    },
                                    end: {
                                        line: 48,
                                        column: 17,
                                        fixed: true,
                                        source: 'viewpath/html/DiscussionEditor.ion'
                                    }
                                }
                            },
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'classList',
                                        loc: {
                                            start: {
                                                line: 49,
                                                column: 8,
                                                fixed: true,
                                                source: 'viewpath/html/DiscussionEditor.ion'
                                            },
                                            end: {
                                                line: 49,
                                                column: 17,
                                                fixed: true,
                                                source: 'viewpath/html/DiscussionEditor.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'IfStatement',
                                                test: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'state',
                                                        loc: {
                                                            start: {
                                                                line: 50,
                                                                column: 15,
                                                                fixed: true,
                                                                source: 'viewpath/html/DiscussionEditor.ion'
                                                            },
                                                            end: {
                                                                line: 50,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/DiscussionEditor.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'active',
                                                        loc: {
                                                            start: {
                                                                line: 50,
                                                                column: 21,
                                                                fixed: true,
                                                                source: 'viewpath/html/DiscussionEditor.ion'
                                                            },
                                                            end: {
                                                                line: 50,
                                                                column: 27,
                                                                fixed: true,
                                                                source: 'viewpath/html/DiscussionEditor.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 50,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'viewpath/html/DiscussionEditor.ion'
                                                        },
                                                        end: {
                                                            line: 50,
                                                            column: 27,
                                                            fixed: true,
                                                            source: 'viewpath/html/DiscussionEditor.ion'
                                                        }
                                                    }
                                                },
                                                consequent: {
                                                    type: 'BlockStatement',
                                                    body: [{
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'Literal',
                                                                value: 'active'
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 51,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/DiscussionEditor.ion'
                                                                },
                                                                end: {
                                                                    line: 51,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/DiscussionEditor.ion'
                                                                }
                                                            },
                                                            order: '0'
                                                        }]
                                                },
                                                alternate: null,
                                                order: '0'
                                            }]
                                    },
                                    kind: 'init',
                                    order: '0'
                                },
                                {
                                    type: 'VariableDeclaration',
                                    declarations: [{
                                            type: 'VariableDeclarator',
                                            id: {
                                                type: 'Identifier',
                                                name: 'inputArea',
                                                loc: {
                                                    start: {
                                                        line: 70,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/DiscussionEditor.ion'
                                                    },
                                                    end: {
                                                        line: 70,
                                                        column: 21,
                                                        fixed: true,
                                                        source: 'viewpath/html/DiscussionEditor.ion'
                                                    }
                                                }
                                            },
                                            init: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'Textarea',
                                                    loc: {
                                                        start: {
                                                            line: 70,
                                                            column: 24,
                                                            fixed: true,
                                                            source: 'viewpath/html/DiscussionEditor.ion'
                                                        },
                                                        end: {
                                                            line: 70,
                                                            column: 32,
                                                            fixed: true,
                                                            source: 'viewpath/html/DiscussionEditor.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [{
                                                        type: 'ObjectExpression',
                                                        properties: [
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'class',
                                                                    loc: {
                                                                        start: {
                                                                            line: 70,
                                                                            column: 34,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/DiscussionEditor.ion'
                                                                        },
                                                                        end: {
                                                                            line: 70,
                                                                            column: 39,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/DiscussionEditor.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: 'discussion-input'
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'placeholder',
                                                                    loc: {
                                                                        start: {
                                                                            line: 70,
                                                                            column: 60,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/DiscussionEditor.ion'
                                                                        },
                                                                        end: {
                                                                            line: 70,
                                                                            column: 71,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/DiscussionEditor.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: 'Add to discussion'
                                                                },
                                                                kind: 'init',
                                                                order: '1'
                                                            }
                                                        ]
                                                    }],
                                                loc: {
                                                    start: {
                                                        line: 70,
                                                        column: 24,
                                                        fixed: true,
                                                        source: 'viewpath/html/DiscussionEditor.ion'
                                                    },
                                                    end: {
                                                        line: 70,
                                                        column: 94,
                                                        fixed: true,
                                                        source: 'viewpath/html/DiscussionEditor.ion'
                                                    }
                                                }
                                            }
                                        }],
                                    kind: 'let',
                                    order: '1'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'ObjectExpression',
                                        objectType: {
                                            type: 'Identifier',
                                            name: 'inputArea',
                                            loc: {
                                                start: {
                                                    line: 72,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'viewpath/html/DiscussionEditor.ion'
                                                },
                                                end: {
                                                    line: 72,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'viewpath/html/DiscussionEditor.ion'
                                                }
                                            }
                                        },
                                        properties: [
                                            {
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'Function',
                                                    context: false,
                                                    value: function keyup(e) {
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 73,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/DiscussionEditor.ion'
                                                    },
                                                    end: {
                                                        line: 76,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'viewpath/html/DiscussionEditor.ion'
                                                    }
                                                },
                                                order: '0'
                                            },
                                            {
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context) {
                                                        return function focus(e) {
                                                            var state = _context.get('state');
                                                            state.active = true;
                                                        };
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 76,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/DiscussionEditor.ion'
                                                    },
                                                    end: {
                                                        line: 78,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'viewpath/html/DiscussionEditor.ion'
                                                    }
                                                },
                                                order: '1'
                                            },
                                            {
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context2) {
                                                        return function blur(e) {
                                                            var state = _context2.get('state');
                                                            if (this.value === '') {
                                                                state.active = false;
                                                            } else {
                                                                console.log('dont close with value plz');
                                                            }
                                                        };
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 78,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/DiscussionEditor.ion'
                                                    },
                                                    end: {
                                                        line: 84,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'viewpath/html/DiscussionEditor.ion'
                                                    }
                                                },
                                                order: '2'
                                            }
                                        ]
                                    },
                                    loc: {
                                        start: {
                                            line: 72,
                                            column: 8,
                                            fixed: true,
                                            source: 'viewpath/html/DiscussionEditor.ion'
                                        },
                                        end: {
                                            line: 84,
                                            column: 12,
                                            fixed: true,
                                            source: 'viewpath/html/DiscussionEditor.ion'
                                        }
                                    },
                                    order: '2'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'ObjectExpression',
                                        objectType: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'Identifier',
                                                name: 'Div',
                                                loc: {
                                                    start: {
                                                        line: 84,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'viewpath/html/DiscussionEditor.ion'
                                                    },
                                                    end: {
                                                        line: 84,
                                                        column: 11,
                                                        fixed: true,
                                                        source: 'viewpath/html/DiscussionEditor.ion'
                                                    }
                                                }
                                            },
                                            arguments: [{
                                                    type: 'ObjectExpression',
                                                    properties: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'class',
                                                                loc: {
                                                                    start: {
                                                                        line: 84,
                                                                        column: 13,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/DiscussionEditor.ion'
                                                                    },
                                                                    end: {
                                                                        line: 84,
                                                                        column: 18,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/DiscussionEditor.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Literal',
                                                                value: 'discussion-toolbar layout horizontal'
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                }],
                                            loc: {
                                                start: {
                                                    line: 84,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'viewpath/html/DiscussionEditor.ion'
                                                },
                                                end: {
                                                    line: 84,
                                                    column: 59,
                                                    fixed: true,
                                                    source: 'viewpath/html/DiscussionEditor.ion'
                                                }
                                            }
                                        },
                                        properties: [{
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'ObjectExpression',
                                                    objectType: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'Identifier',
                                                            name: 'Button',
                                                            loc: {
                                                                start: {
                                                                    line: 85,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/DiscussionEditor.ion'
                                                                },
                                                                end: {
                                                                    line: 85,
                                                                    column: 18,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/DiscussionEditor.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [{
                                                                type: 'ObjectExpression',
                                                                properties: [{
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'class',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 85,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/DiscussionEditor.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 85,
                                                                                    column: 25,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/DiscussionEditor.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Literal',
                                                                            value: ''
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    }]
                                                            }],
                                                        loc: {
                                                            start: {
                                                                line: 85,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'viewpath/html/DiscussionEditor.ion'
                                                            },
                                                            end: {
                                                                line: 85,
                                                                column: 30,
                                                                fixed: true,
                                                                source: 'viewpath/html/DiscussionEditor.ion'
                                                            }
                                                        }
                                                    },
                                                    properties: [
                                                        {
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'Function',
                                                                context: true,
                                                                value: function (_context3) {
                                                                    return function click(e) {
                                                                        var Key = _context3.get('Key'), task = _context3.get('task'), Comment = _context3.get('Comment'), inputArea = _context3.get('inputArea'), comments = _context3.get('comments');
                                                                        var parentKey = new Key(task.getKey(), Comment);
                                                                        var newKey = model.server.getNewKey(parentKey, function (newKey) {
                                                                                var comment = new Comment({ text: inputArea.value });
                                                                                comment.createdBy = model.userKey;
                                                                                inputArea.value = '';
                                                                                comments[newKey] = comment;
                                                                            });
                                                                    };
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 86,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/DiscussionEditor.ion'
                                                                },
                                                                end: {
                                                                    line: 109,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/DiscussionEditor.ion'
                                                                }
                                                            },
                                                            order: '0'
                                                        },
                                                        {
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'Literal',
                                                                value: 'Post'
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 109,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/DiscussionEditor.ion'
                                                                },
                                                                end: {
                                                                    line: 109,
                                                                    column: 22,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/DiscussionEditor.ion'
                                                                }
                                                            },
                                                            order: '1'
                                                        }
                                                    ]
                                                },
                                                loc: {
                                                    start: {
                                                        line: 85,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/DiscussionEditor.ion'
                                                    },
                                                    end: {
                                                        line: 111,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'viewpath/html/DiscussionEditor.ion'
                                                    }
                                                },
                                                order: '0'
                                            }]
                                    },
                                    loc: {
                                        start: {
                                            line: 84,
                                            column: 8,
                                            fixed: true,
                                            source: 'viewpath/html/DiscussionEditor.ion'
                                        },
                                        end: {
                                            line: 111,
                                            column: 12,
                                            fixed: true,
                                            source: 'viewpath/html/DiscussionEditor.ion'
                                        }
                                    },
                                    order: '3'
                                }
                            ]
                        },
                        {
                            type: 'ObjectExpression',
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'mode',
                                        loc: {
                                            start: {
                                                line: 63,
                                                column: 17,
                                                fixed: true,
                                                source: 'viewpath/html/DiscussionEditor.ion'
                                            },
                                            end: {
                                                line: 63,
                                                column: 21,
                                                fixed: true,
                                                source: 'viewpath/html/DiscussionEditor.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 64,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/DiscussionEditor.ion'
                                                        },
                                                        end: {
                                                            line: 64,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'viewpath/html/DiscussionEditor.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context4) {
                                                        return function () {
                                                            var state = _context4.get('state');
                                                            return state.mode;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 65,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/DiscussionEditor.ion'
                                                        },
                                                        end: {
                                                            line: 65,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'viewpath/html/DiscussionEditor.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context5) {
                                                        return function (value) {
                                                            var state = _context5.get('state');
                                                            return state.mode = value;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'value',
                                        loc: {
                                            start: {
                                                line: 66,
                                                column: 17,
                                                fixed: true,
                                                source: 'viewpath/html/DiscussionEditor.ion'
                                            },
                                            end: {
                                                line: 66,
                                                column: 22,
                                                fixed: true,
                                                source: 'viewpath/html/DiscussionEditor.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 67,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/DiscussionEditor.ion'
                                                        },
                                                        end: {
                                                            line: 67,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'viewpath/html/DiscussionEditor.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context6) {
                                                        return function () {
                                                            var state = _context6.get('state');
                                                            return state.value;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 68,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/DiscussionEditor.ion'
                                                        },
                                                        end: {
                                                            line: 68,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'viewpath/html/DiscussionEditor.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context7) {
                                                        return function (value) {
                                                            var state = _context7.get('state');
                                                            return state.value = value;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '1'
                                }
                            ]
                        }
                    ]
                },
                order: '4'
            }
        ],
        bound: false
    }, {
        this: this,
        _ref5: _ref5,
        glass: glass,
        _ref: _ref,
        _ref2: _ref2,
        _ref3: _ref3,
        viewpath: viewpath,
        _ref4: _ref4,
        Key: Key,
        style: style,
        Checkbox: Checkbox,
        List: List,
        Icon: Icon,
        Field: Field,
        Img: Img,
        Button: Button,
        User: User,
        Task: Task,
        Comment: Comment,
        _ref6: _ref6
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/DiscussionEditor',_viewpath_html_DiscussionEditor_);
    else
      _viewpath_html_DiscussionEditor_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_DiscussionEditor_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_DocumentColumn_ = function(module,exports,require){'use strict';
var ion = require('ion'), glass = require('glass'), _ref, _ref2, _ref3, _ref4, _ref5, count = function (object) {
        if (!(object != null)) {
            return 0;
        } else {
            return Object.keys(object).length;
        }
    };
_ref = require('./');
var DocumentDialog = _ref.DocumentDialog;
_ref2 = glass.data;
var Schema = _ref2.Schema;
_ref3 = glass.html.material.DataTable2;
var DefaultColumn = _ref3.DefaultColumn;
_ref4 = glass.convert;
var jsonValueToDisplayValue = _ref4.jsonValueToDisplayValue;
_ref5 = glass.html;
var style = _ref5.style;
var _ref7 = style.sheets;
_ref7[module.id] = '.DocumentColumnLink {\n    cursor: pointer;\n}';
_ref7;
module.exports = exports = ion.template(function DocumentColumn(property) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'DocumentColumn',
            loc: {
                start: {
                    line: 21,
                    column: 16,
                    fixed: true,
                    source: 'viewpath/html/DocumentColumn.ion'
                },
                end: {
                    line: 21,
                    column: 30,
                    fixed: true,
                    source: 'viewpath/html/DocumentColumn.ion'
                }
            }
        },
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'column',
                            loc: {
                                start: {
                                    line: 22,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/DocumentColumn.ion'
                                },
                                end: {
                                    line: 22,
                                    column: 14,
                                    fixed: true,
                                    source: 'viewpath/html/DocumentColumn.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'DefaultColumn',
                                loc: {
                                    start: {
                                        line: 22,
                                        column: 17,
                                        fixed: true,
                                        source: 'viewpath/html/DocumentColumn.ion'
                                    },
                                    end: {
                                        line: 22,
                                        column: 30,
                                        fixed: true,
                                        source: 'viewpath/html/DocumentColumn.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'Identifier',
                                    name: 'property',
                                    loc: {
                                        start: {
                                            line: 22,
                                            column: 31,
                                            fixed: true,
                                            source: 'viewpath/html/DocumentColumn.ion'
                                        },
                                        end: {
                                            line: 22,
                                            column: 39,
                                            fixed: true,
                                            source: 'viewpath/html/DocumentColumn.ion'
                                        }
                                    }
                                }],
                            loc: {
                                start: {
                                    line: 22,
                                    column: 17,
                                    fixed: true,
                                    source: 'viewpath/html/DocumentColumn.ion'
                                },
                                end: {
                                    line: 22,
                                    column: 40,
                                    fixed: true,
                                    source: 'viewpath/html/DocumentColumn.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'Identifier',
                        name: 'column',
                        loc: {
                            start: {
                                line: 23,
                                column: 11,
                                fixed: true,
                                source: 'viewpath/html/DocumentColumn.ion'
                            },
                            end: {
                                line: 23,
                                column: 17,
                                fixed: true,
                                source: 'viewpath/html/DocumentColumn.ion'
                            }
                        }
                    },
                    properties: [{
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'createBodyCell',
                                loc: {
                                    start: {
                                        line: 24,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/html/DocumentColumn.ion'
                                    },
                                    end: {
                                        line: 24,
                                        column: 22,
                                        fixed: true,
                                        source: 'viewpath/html/DocumentColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_ps) {
                                    return ion.template(function (row) {
                                        return ion.createRuntime({
                                            type: 'Template',
                                            id: null,
                                            body: [
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: '_ref6'
                                                            },
                                                            init: {
                                                                type: 'Identifier',
                                                                name: 'row',
                                                                loc: {
                                                                    start: {
                                                                        line: 25,
                                                                        column: 27,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/DocumentColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 25,
                                                                        column: 30,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/DocumentColumn.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'record',
                                                                loc: {
                                                                    start: {
                                                                        line: 25,
                                                                        column: 17,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/DocumentColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 25,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/DocumentColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'MemberExpression',
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: '_ref6'
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'record',
                                                                    loc: {
                                                                        start: {
                                                                            line: 25,
                                                                            column: 17,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/DocumentColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 25,
                                                                            column: 23,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/DocumentColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                computed: false
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '1'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'value',
                                                                loc: {
                                                                    start: {
                                                                        line: 26,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/DocumentColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 26,
                                                                        column: 21,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/DocumentColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Function',
                                                                    context: true,
                                                                    value: function (_context) {
                                                                        return function (record) {
                                                                            var count = _context.get('count'), Schema = _context.get('Schema'), property = _context.get('property');
                                                                            return '' + count(Schema.get(record, property));
                                                                        };
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'Identifier',
                                                                        name: 'record',
                                                                        loc: {
                                                                            start: {
                                                                                line: 26,
                                                                                column: 28,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/DocumentColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 26,
                                                                                column: 34,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/DocumentColumn.ion'
                                                                            }
                                                                        }
                                                                    }],
                                                                loc: {
                                                                    start: {
                                                                        line: 26,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/DocumentColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 26,
                                                                        column: 79,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/DocumentColumn.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '2'
                                                },
                                                {
                                                    type: 'ReturnStatement',
                                                    argument: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'Span',
                                                                loc: {
                                                                    start: {
                                                                        line: 27,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/DocumentColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 27,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/DocumentColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [],
                                                            loc: {
                                                                start: {
                                                                    line: 27,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/DocumentColumn.ion'
                                                                },
                                                                end: {
                                                                    line: 27,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/DocumentColumn.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [{
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'ObjectExpression',
                                                                    objectType: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'Identifier',
                                                                            name: 'Span',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 28,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/DocumentColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 28,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/DocumentColumn.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [{
                                                                                type: 'ObjectExpression',
                                                                                properties: [{
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'class',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 28,
                                                                                                    column: 22,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/DocumentColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 28,
                                                                                                    column: 27,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/DocumentColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 'DocumentColumnLink'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    }]
                                                                            }],
                                                                        loc: {
                                                                            start: {
                                                                                line: 28,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/DocumentColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 28,
                                                                                column: 50,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/DocumentColumn.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    properties: [
                                                                        {
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'Function',
                                                                                context: true,
                                                                                value: function (_context2) {
                                                                                    return function click(e) {
                                                                                        var DocumentDialog = _context2.get('DocumentDialog'), row = _context2.get('row');
                                                                                        DocumentDialog.show({
                                                                                            record: row.record,
                                                                                            e: e
                                                                                        });
                                                                                    };
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 29,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/DocumentColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 31,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/DocumentColumn.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'Identifier',
                                                                                name: 'value',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 31,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/DocumentColumn.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 31,
                                                                                        column: 25,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/DocumentColumn.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 31,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/DocumentColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 31,
                                                                                    column: 25,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/DocumentColumn.ion'
                                                                                }
                                                                            },
                                                                            order: '1'
                                                                        }
                                                                    ]
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 28,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/DocumentColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 33,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/DocumentColumn.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    order: '3'
                                                }
                                            ],
                                            bound: false,
                                            name: {
                                                type: 'Identifier',
                                                name: 'createBodyCell',
                                                loc: {
                                                    start: {
                                                        line: 24,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'viewpath/html/DocumentColumn.ion'
                                                    },
                                                    end: {
                                                        line: 24,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'viewpath/html/DocumentColumn.ion'
                                                    }
                                                }
                                            },
                                            scope: {
                                                type: 'Identifier',
                                                name: '_ps'
                                            }
                                        }, {
                                            this: this,
                                            row: row,
                                            _ps: _ps,
                                            property: property,
                                            ion: ion,
                                            glass: glass,
                                            _ref: _ref,
                                            _ref2: _ref2,
                                            _ref3: _ref3,
                                            _ref4: _ref4,
                                            _ref5: _ref5,
                                            count: count,
                                            DocumentDialog: DocumentDialog,
                                            Schema: Schema,
                                            DefaultColumn: DefaultColumn,
                                            jsonValueToDisplayValue: jsonValueToDisplayValue,
                                            style: style,
                                            _ref7: _ref7
                                        }, _ps);
                                    });
                                }
                            },
                            kind: 'init',
                            order: '0'
                        }]
                },
                order: '1'
            }
        ],
        bound: false
    }, {
        this: this,
        ion: ion,
        property: property,
        glass: glass,
        _ref: _ref,
        _ref2: _ref2,
        _ref3: _ref3,
        _ref4: _ref4,
        _ref5: _ref5,
        count: count,
        DocumentDialog: DocumentDialog,
        Schema: Schema,
        DefaultColumn: DefaultColumn,
        jsonValueToDisplayValue: jsonValueToDisplayValue,
        style: style,
        _ref7: _ref7
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/DocumentColumn',_viewpath_html_DocumentColumn_);
    else
      _viewpath_html_DocumentColumn_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_DocumentColumn_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_DocumentDialog_ = function(module,exports,require){'use strict';
var ion = require('ion');
var glass = require('glass');
var _ref = glass.html;
var style = _ref.style;
var _ref2 = glass.html.material;
var Dialog = _ref2.Dialog;
var _ref3 = glass.html.forms;
var GlassForm = _ref3.GlassForm;
var SubmitButton = _ref3.SubmitButton;
var CancelButton = _ref3.CancelButton;
var vpmodel = require('../model');
var _ref4 = vpmodel;
var Document = _ref4.Document;
var clone = function (object) {
    return ion.deserialize(ion.serialize(object), vpmodel);
};
var DocumentDialog = ion.template(function DocumentDialog(args) {
        return ion.createRuntime({
            type: 'Template',
            id: {
                type: 'Identifier',
                name: 'DocumentDialog',
                loc: {
                    start: {
                        line: 9,
                        column: 15,
                        fixed: true,
                        source: 'viewpath/html/DocumentDialog.ion'
                    },
                    end: {
                        line: 9,
                        column: 29,
                        fixed: true,
                        source: 'viewpath/html/DocumentDialog.ion'
                    }
                }
            },
            body: [
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: '_ref5'
                            },
                            init: {
                                type: 'Identifier',
                                name: 'args',
                                loc: {
                                    start: {
                                        line: 10,
                                        column: 19,
                                        fixed: true,
                                        source: 'viewpath/html/DocumentDialog.ion'
                                    },
                                    end: {
                                        line: 10,
                                        column: 23,
                                        fixed: true,
                                        source: 'viewpath/html/DocumentDialog.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '0'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'record',
                                loc: {
                                    start: {
                                        line: 10,
                                        column: 9,
                                        fixed: true,
                                        source: 'viewpath/html/DocumentDialog.ion'
                                    },
                                    end: {
                                        line: 10,
                                        column: 15,
                                        fixed: true,
                                        source: 'viewpath/html/DocumentDialog.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref5'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'record',
                                    loc: {
                                        start: {
                                            line: 10,
                                            column: 9,
                                            fixed: true,
                                            source: 'viewpath/html/DocumentDialog.ion'
                                        },
                                        end: {
                                            line: 10,
                                            column: 15,
                                            fixed: true,
                                            source: 'viewpath/html/DocumentDialog.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '1'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'property',
                                loc: {
                                    start: {
                                        line: 11,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/html/DocumentDialog.ion'
                                    },
                                    end: {
                                        line: 11,
                                        column: 16,
                                        fixed: true,
                                        source: 'viewpath/html/DocumentDialog.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'ConditionalExpression',
                                test: {
                                    type: 'BinaryExpression',
                                    operator: '!=',
                                    left: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'args',
                                            loc: {
                                                start: {
                                                    line: 11,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                },
                                                end: {
                                                    line: 11,
                                                    column: 23,
                                                    fixed: true,
                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'property',
                                            loc: {
                                                start: {
                                                    line: 11,
                                                    column: 24,
                                                    fixed: true,
                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                },
                                                end: {
                                                    line: 11,
                                                    column: 32,
                                                    fixed: true,
                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 11,
                                                column: 19,
                                                fixed: true,
                                                source: 'viewpath/html/DocumentDialog.ion'
                                            },
                                            end: {
                                                line: 11,
                                                column: 32,
                                                fixed: true,
                                                source: 'viewpath/html/DocumentDialog.ion'
                                            }
                                        }
                                    },
                                    right: {
                                        type: 'Literal',
                                        value: null
                                    }
                                },
                                consequent: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'args',
                                        loc: {
                                            start: {
                                                line: 11,
                                                column: 19,
                                                fixed: true,
                                                source: 'viewpath/html/DocumentDialog.ion'
                                            },
                                            end: {
                                                line: 11,
                                                column: 23,
                                                fixed: true,
                                                source: 'viewpath/html/DocumentDialog.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'property',
                                        loc: {
                                            start: {
                                                line: 11,
                                                column: 24,
                                                fixed: true,
                                                source: 'viewpath/html/DocumentDialog.ion'
                                            },
                                            end: {
                                                line: 11,
                                                column: 32,
                                                fixed: true,
                                                source: 'viewpath/html/DocumentDialog.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 11,
                                            column: 19,
                                            fixed: true,
                                            source: 'viewpath/html/DocumentDialog.ion'
                                        },
                                        end: {
                                            line: 11,
                                            column: 32,
                                            fixed: true,
                                            source: 'viewpath/html/DocumentDialog.ion'
                                        }
                                    }
                                },
                                alternate: {
                                    type: 'Literal',
                                    value: 'documents'
                                }
                            }
                        }],
                    kind: 'let',
                    order: '2'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'value',
                                loc: {
                                    start: {
                                        line: 12,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/html/DocumentDialog.ion'
                                    },
                                    end: {
                                        line: 12,
                                        column: 13,
                                        fixed: true,
                                        source: 'viewpath/html/DocumentDialog.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'ConditionalExpression',
                                test: {
                                    type: 'BinaryExpression',
                                    operator: '!=',
                                    left: {
                                        type: 'MemberExpression',
                                        computed: true,
                                        object: {
                                            type: 'Identifier',
                                            name: 'record',
                                            loc: {
                                                start: {
                                                    line: 12,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                },
                                                end: {
                                                    line: 12,
                                                    column: 22,
                                                    fixed: true,
                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'property',
                                            loc: {
                                                start: {
                                                    line: 12,
                                                    column: 23,
                                                    fixed: true,
                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                },
                                                end: {
                                                    line: 12,
                                                    column: 31,
                                                    fixed: true,
                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 12,
                                                column: 16,
                                                fixed: true,
                                                source: 'viewpath/html/DocumentDialog.ion'
                                            },
                                            end: {
                                                line: 12,
                                                column: 32,
                                                fixed: true,
                                                source: 'viewpath/html/DocumentDialog.ion'
                                            }
                                        }
                                    },
                                    right: {
                                        type: 'Literal',
                                        value: null
                                    }
                                },
                                consequent: {
                                    type: 'MemberExpression',
                                    computed: true,
                                    object: {
                                        type: 'Identifier',
                                        name: 'record',
                                        loc: {
                                            start: {
                                                line: 12,
                                                column: 16,
                                                fixed: true,
                                                source: 'viewpath/html/DocumentDialog.ion'
                                            },
                                            end: {
                                                line: 12,
                                                column: 22,
                                                fixed: true,
                                                source: 'viewpath/html/DocumentDialog.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'property',
                                        loc: {
                                            start: {
                                                line: 12,
                                                column: 23,
                                                fixed: true,
                                                source: 'viewpath/html/DocumentDialog.ion'
                                            },
                                            end: {
                                                line: 12,
                                                column: 31,
                                                fixed: true,
                                                source: 'viewpath/html/DocumentDialog.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 12,
                                            column: 16,
                                            fixed: true,
                                            source: 'viewpath/html/DocumentDialog.ion'
                                        },
                                        end: {
                                            line: 12,
                                            column: 32,
                                            fixed: true,
                                            source: 'viewpath/html/DocumentDialog.ion'
                                        }
                                    }
                                },
                                alternate: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'Function',
                                        context: false,
                                        value: function () {
                                            return {};
                                        }
                                    },
                                    arguments: [],
                                    loc: {
                                        start: {
                                            line: 12,
                                            column: 35,
                                            fixed: true,
                                            source: 'viewpath/html/DocumentDialog.ion'
                                        },
                                        end: {
                                            line: 12,
                                            column: 43,
                                            fixed: true,
                                            source: 'viewpath/html/DocumentDialog.ion'
                                        }
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '3'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'dialog',
                                loc: {
                                    start: {
                                        line: 15,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/html/DocumentDialog.ion'
                                    },
                                    end: {
                                        line: 15,
                                        column: 14,
                                        fixed: true,
                                        source: 'viewpath/html/DocumentDialog.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Dialog',
                                    loc: {
                                        start: {
                                            line: 15,
                                            column: 17,
                                            fixed: true,
                                            source: 'viewpath/html/DocumentDialog.ion'
                                        },
                                        end: {
                                            line: 15,
                                            column: 23,
                                            fixed: true,
                                            source: 'viewpath/html/DocumentDialog.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'class',
                                                    loc: {
                                                        start: {
                                                            line: 15,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'viewpath/html/DocumentDialog.ion'
                                                        },
                                                        end: {
                                                            line: 15,
                                                            column: 30,
                                                            fixed: true,
                                                            source: 'viewpath/html/DocumentDialog.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: 'layout vertical'
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    }],
                                loc: {
                                    start: {
                                        line: 15,
                                        column: 17,
                                        fixed: true,
                                        source: 'viewpath/html/DocumentDialog.ion'
                                    },
                                    end: {
                                        line: 15,
                                        column: 50,
                                        fixed: true,
                                        source: 'viewpath/html/DocumentDialog.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '4'
                },
                {
                    type: 'ReturnStatement',
                    argument: {
                        type: 'ObjectExpression',
                        objectType: {
                            type: 'Identifier',
                            name: 'dialog',
                            loc: {
                                start: {
                                    line: 16,
                                    column: 11,
                                    fixed: true,
                                    source: 'viewpath/html/DocumentDialog.ion'
                                },
                                end: {
                                    line: 16,
                                    column: 17,
                                    fixed: true,
                                    source: 'viewpath/html/DocumentDialog.ion'
                                }
                            }
                        },
                        properties: [
                            {
                                type: 'ExpressionStatement',
                                expression: {
                                    type: 'Function',
                                    context: true,
                                    value: function (_context) {
                                        return function click(e) {
                                            var dialog = _context.get('dialog');
                                            dialog.open = false;
                                        };
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 17,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/html/DocumentDialog.ion'
                                    },
                                    end: {
                                        line: 20,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/DocumentDialog.ion'
                                    }
                                },
                                order: '0'
                            },
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'frame',
                                    loc: {
                                        start: {
                                            line: 20,
                                            column: 8,
                                            fixed: true,
                                            source: 'viewpath/html/DocumentDialog.ion'
                                        },
                                        end: {
                                            line: 20,
                                            column: 13,
                                            fixed: true,
                                            source: 'viewpath/html/DocumentDialog.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'ObjectExpression',
                                    properties: [
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'style',
                                                loc: {
                                                    start: {
                                                        line: 21,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                    },
                                                    end: {
                                                        line: 21,
                                                        column: 17,
                                                        fixed: true,
                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'ObjectExpression',
                                                properties: [{
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'padding',
                                                            loc: {
                                                                start: {
                                                                    line: 22,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                },
                                                                end: {
                                                                    line: 22,
                                                                    column: 23,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Literal',
                                                            value: '0px'
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    }]
                                            },
                                            kind: 'init',
                                            order: '0'
                                        },
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'ObjectExpression',
                                                objectType: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'Identifier',
                                                        name: 'Div',
                                                        loc: {
                                                            start: {
                                                                line: 23,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                            },
                                                            end: {
                                                                line: 23,
                                                                column: 15,
                                                                fixed: true,
                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [{
                                                            type: 'ObjectExpression',
                                                            properties: [{
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'role',
                                                                        loc: {
                                                                            start: {
                                                                                line: 23,
                                                                                column: 17,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 23,
                                                                                column: 21,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Literal',
                                                                        value: 'listbox'
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                }]
                                                        }],
                                                    loc: {
                                                        start: {
                                                            line: 23,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/DocumentDialog.ion'
                                                        },
                                                        end: {
                                                            line: 23,
                                                            column: 33,
                                                            fixed: true,
                                                            source: 'viewpath/html/DocumentDialog.ion'
                                                        }
                                                    }
                                                },
                                                properties: [{
                                                        type: 'ForInStatement',
                                                        left: {
                                                            type: 'VariableDeclaration',
                                                            declarations: [
                                                                {
                                                                    type: 'VariableDeclarator',
                                                                    id: {
                                                                        type: 'Identifier',
                                                                        name: 'name',
                                                                        loc: {
                                                                            start: {
                                                                                line: 24,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 24,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    init: null
                                                                },
                                                                {
                                                                    type: 'VariableDeclarator',
                                                                    id: {
                                                                        type: 'Identifier',
                                                                        name: 'document',
                                                                        loc: {
                                                                            start: {
                                                                                line: 24,
                                                                                column: 26,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 24,
                                                                                column: 34,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    init: null
                                                                }
                                                            ],
                                                            kind: 'let'
                                                        },
                                                        right: {
                                                            type: 'Identifier',
                                                            name: 'value',
                                                            loc: {
                                                                start: {
                                                                    line: 24,
                                                                    column: 38,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                },
                                                                end: {
                                                                    line: 24,
                                                                    column: 43,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                }
                                                            }
                                                        },
                                                        body: {
                                                            type: 'BlockStatement',
                                                            body: [{
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'ObjectExpression',
                                                                        objectType: {
                                                                            type: 'CallExpression',
                                                                            callee: {
                                                                                type: 'Identifier',
                                                                                name: 'PaperItem',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 25,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 25,
                                                                                        column: 29,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            arguments: [],
                                                                            loc: {
                                                                                start: {
                                                                                    line: 25,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 25,
                                                                                    column: 31,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        properties: [
                                                                            {
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'style',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 26,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/DocumentDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 26,
                                                                                            column: 29,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/DocumentDialog.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'ObjectExpression',
                                                                                    properties: [{
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'borderBottom',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 27,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 27,
                                                                                                        column: 40,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'BinaryExpression',
                                                                                                operator: '+',
                                                                                                left: {
                                                                                                    type: 'BinaryExpression',
                                                                                                    operator: '+',
                                                                                                    left: {
                                                                                                        type: 'Literal',
                                                                                                        value: 'solid 1px rgba(0,0,0,'
                                                                                                    },
                                                                                                    right: {
                                                                                                        type: 'MemberExpression',
                                                                                                        computed: false,
                                                                                                        object: {
                                                                                                            type: 'MemberExpression',
                                                                                                            computed: false,
                                                                                                            object: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'style',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 27,
                                                                                                                        column: 66,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 27,
                                                                                                                        column: 71,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            property: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'opacity',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 27,
                                                                                                                        column: 72,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 27,
                                                                                                                        column: 79,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 27,
                                                                                                                    column: 66,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 27,
                                                                                                                    column: 79,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        property: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'divider',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 27,
                                                                                                                    column: 80,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 27,
                                                                                                                    column: 87,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 27,
                                                                                                                column: 66,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 27,
                                                                                                                column: 87,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                right: {
                                                                                                    type: 'Literal',
                                                                                                    value: ')'
                                                                                                }
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '0'
                                                                                        }]
                                                                                },
                                                                                kind: 'init',
                                                                                order: '0'
                                                                            },
                                                                            {
                                                                                type: 'ExpressionStatement',
                                                                                expression: {
                                                                                    type: 'ObjectExpression',
                                                                                    objectType: {
                                                                                        type: 'CallExpression',
                                                                                        callee: {
                                                                                            type: 'Identifier',
                                                                                            name: 'PaperItemBody',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 29,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 29,
                                                                                                    column: 37,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        arguments: [],
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 29,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 29,
                                                                                                column: 39,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    properties: [{
                                                                                            type: 'ExpressionStatement',
                                                                                            expression: {
                                                                                                type: 'ObjectExpression',
                                                                                                objectType: {
                                                                                                    type: 'CallExpression',
                                                                                                    callee: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'A',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 30,
                                                                                                                column: 28,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 30,
                                                                                                                column: 29,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    arguments: [{
                                                                                                            type: 'ObjectExpression',
                                                                                                            properties: [{
                                                                                                                    type: 'Property',
                                                                                                                    key: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'href',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 30,
                                                                                                                                column: 31,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 30,
                                                                                                                                column: 35,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    value: {
                                                                                                                        type: 'CallExpression',
                                                                                                                        callee: {
                                                                                                                            type: 'MemberExpression',
                                                                                                                            computed: false,
                                                                                                                            object: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'document',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 30,
                                                                                                                                        column: 36,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 30,
                                                                                                                                        column: 44,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            property: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'getUrl',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 30,
                                                                                                                                        column: 45,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 30,
                                                                                                                                        column: 51,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 30,
                                                                                                                                    column: 36,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 30,
                                                                                                                                    column: 51,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        arguments: [],
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 30,
                                                                                                                                column: 36,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 30,
                                                                                                                                column: 53,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    kind: 'init',
                                                                                                                    order: '0'
                                                                                                                }]
                                                                                                        }],
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 30,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/DocumentDialog.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 30,
                                                                                                            column: 55,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/DocumentDialog.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                properties: [{
                                                                                                        type: 'ExpressionStatement',
                                                                                                        expression: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'name',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 31,
                                                                                                                    column: 32,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 31,
                                                                                                                    column: 36,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 31,
                                                                                                                column: 32,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 31,
                                                                                                                column: 36,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                                                                            }
                                                                                                        },
                                                                                                        order: '0'
                                                                                                    }]
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 30,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 32,
                                                                                                    column: 32,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                                }
                                                                                            },
                                                                                            order: '0'
                                                                                        }]
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 29,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 32,
                                                                                        column: 28,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                                    }
                                                                                },
                                                                                order: '1'
                                                                            },
                                                                            {
                                                                                type: 'ExpressionStatement',
                                                                                expression: {
                                                                                    type: 'ObjectExpression',
                                                                                    objectType: {
                                                                                        type: 'CallExpression',
                                                                                        callee: {
                                                                                            type: 'Identifier',
                                                                                            name: 'PaperIconButton',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 32,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 32,
                                                                                                    column: 39,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        arguments: [{
                                                                                                type: 'ObjectExpression',
                                                                                                properties: [
                                                                                                    {
                                                                                                        type: 'Property',
                                                                                                        key: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'icon',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 32,
                                                                                                                    column: 41,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 32,
                                                                                                                    column: 45,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        value: {
                                                                                                            type: 'Literal',
                                                                                                            value: 'delete'
                                                                                                        },
                                                                                                        kind: 'init',
                                                                                                        order: '0'
                                                                                                    },
                                                                                                    {
                                                                                                        type: 'Property',
                                                                                                        key: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'alt',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 32,
                                                                                                                    column: 55,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 32,
                                                                                                                    column: 58,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        value: {
                                                                                                            type: 'Literal',
                                                                                                            value: 'Delete this document!'
                                                                                                        },
                                                                                                        kind: 'init',
                                                                                                        order: '1'
                                                                                                    }
                                                                                                ]
                                                                                            }],
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 32,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 32,
                                                                                                column: 84,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    properties: [{
                                                                                            type: 'ExpressionStatement',
                                                                                            expression: {
                                                                                                type: 'Function',
                                                                                                context: true,
                                                                                                value: function (_context2) {
                                                                                                    return function click(e) {
                                                                                                        var clone = _context2.get('clone'), value = _context2.get('value'), name = _context2.get('name'), record = _context2.get('record'), property = _context2.get('property');
                                                                                                        var newValue = clone(value);
                                                                                                        delete newValue[name];
                                                                                                        record[property] = newValue;
                                                                                                    };
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 33,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 38,
                                                                                                    column: 32,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                                }
                                                                                            },
                                                                                            order: '0'
                                                                                        }]
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 32,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 38,
                                                                                        column: 28,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                                    }
                                                                                },
                                                                                order: '2'
                                                                            }
                                                                        ]
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 25,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/DocumentDialog.ion'
                                                                        },
                                                                        end: {
                                                                            line: 38,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/DocumentDialog.ion'
                                                                        }
                                                                    },
                                                                    order: '0'
                                                                }]
                                                        },
                                                        remove: null,
                                                        order: '0'
                                                    }]
                                            },
                                            loc: {
                                                start: {
                                                    line: 23,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                },
                                                end: {
                                                    line: 38,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                }
                                            },
                                            order: '1'
                                        },
                                        {
                                            type: 'VariableDeclaration',
                                            declarations: [{
                                                    type: 'VariableDeclarator',
                                                    id: {
                                                        type: 'Identifier',
                                                        name: 'form',
                                                        loc: {
                                                            start: {
                                                                line: 38,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                            },
                                                            end: {
                                                                line: 38,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                            }
                                                        }
                                                    },
                                                    init: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'Identifier',
                                                            name: 'GlassForm',
                                                            loc: {
                                                                start: {
                                                                    line: 38,
                                                                    column: 23,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                },
                                                                end: {
                                                                    line: 38,
                                                                    column: 32,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [],
                                                        loc: {
                                                            start: {
                                                                line: 38,
                                                                column: 23,
                                                                fixed: true,
                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                            },
                                                            end: {
                                                                line: 38,
                                                                column: 34,
                                                                fixed: true,
                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                            }
                                                        }
                                                    }
                                                }],
                                            kind: 'let',
                                            order: '2'
                                        },
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'ObjectExpression',
                                                objectType: {
                                                    type: 'Identifier',
                                                    name: 'form',
                                                    loc: {
                                                        start: {
                                                            line: 39,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/DocumentDialog.ion'
                                                        },
                                                        end: {
                                                            line: 39,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/DocumentDialog.ion'
                                                        }
                                                    }
                                                },
                                                properties: [
                                                    {
                                                        type: 'VariableDeclaration',
                                                        declarations: [{
                                                                type: 'VariableDeclarator',
                                                                id: {
                                                                    type: 'Identifier',
                                                                    name: 'guessName',
                                                                    loc: {
                                                                        start: {
                                                                            line: 40,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/DocumentDialog.ion'
                                                                        },
                                                                        end: {
                                                                            line: 40,
                                                                            column: 29,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/DocumentDialog.ion'
                                                                        }
                                                                    }
                                                                },
                                                                init: {
                                                                    type: 'Function',
                                                                    context: true,
                                                                    value: function (_context3) {
                                                                        return function (filenameOrUrl) {
                                                                            var nameInput = _context3.get('nameInput');
                                                                            var name = filenameOrUrl.split(/\\|\//g).pop();
                                                                            if (name.length > 0 && nameInput.value.length === 0) {
                                                                                nameInput.value = name;
                                                                                nameInput.inputElement.select();
                                                                                nameInput.inputElement.focus();
                                                                            }
                                                                        };
                                                                    }
                                                                }
                                                            }],
                                                        kind: 'let',
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'VariableDeclaration',
                                                        declarations: [{
                                                                type: 'VariableDeclarator',
                                                                id: {
                                                                    type: 'Identifier',
                                                                    name: 'urlInput',
                                                                    loc: {
                                                                        start: {
                                                                            line: 46,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/DocumentDialog.ion'
                                                                        },
                                                                        end: {
                                                                            line: 46,
                                                                            column: 28,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/DocumentDialog.ion'
                                                                        }
                                                                    }
                                                                },
                                                                init: {
                                                                    type: 'ObjectExpression',
                                                                    objectType: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'Identifier',
                                                                            name: 'PaperInput',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 46,
                                                                                    column: 31,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 46,
                                                                                    column: 41,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [{
                                                                                type: 'ObjectExpression',
                                                                                properties: [
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'label',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 46,
                                                                                                    column: 43,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 46,
                                                                                                    column: 48,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 'Url'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'type',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 46,
                                                                                                    column: 57,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 46,
                                                                                                    column: 61,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 'url'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '1'
                                                                                    }
                                                                                ]
                                                                            }],
                                                                        loc: {
                                                                            start: {
                                                                                line: 46,
                                                                                column: 31,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 46,
                                                                                column: 70,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    properties: [{
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'Function',
                                                                                context: true,
                                                                                value: function (_context4) {
                                                                                    return function change(e) {
                                                                                        var guessName = _context4.get('guessName'), urlInput = _context4.get('urlInput');
                                                                                        guessName(urlInput.value);
                                                                                    };
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 47,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 49,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        }]
                                                                }
                                                            }],
                                                        kind: 'let',
                                                        order: '1'
                                                    },
                                                    {
                                                        type: 'VariableDeclaration',
                                                        declarations: [{
                                                                type: 'VariableDeclarator',
                                                                id: {
                                                                    type: 'Identifier',
                                                                    name: 'fileInput',
                                                                    loc: {
                                                                        start: {
                                                                            line: 49,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/DocumentDialog.ion'
                                                                        },
                                                                        end: {
                                                                            line: 49,
                                                                            column: 29,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/DocumentDialog.ion'
                                                                        }
                                                                    }
                                                                },
                                                                init: {
                                                                    type: 'ObjectExpression',
                                                                    objectType: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'Identifier',
                                                                            name: 'PaperInput',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 49,
                                                                                    column: 32,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 49,
                                                                                    column: 42,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [{
                                                                                type: 'ObjectExpression',
                                                                                properties: [
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'label',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 49,
                                                                                                    column: 44,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 49,
                                                                                                    column: 49,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 'File'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'type',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 49,
                                                                                                    column: 59,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 49,
                                                                                                    column: 63,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 'file'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '1'
                                                                                    }
                                                                                ]
                                                                            }],
                                                                        loc: {
                                                                            start: {
                                                                                line: 49,
                                                                                column: 32,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 49,
                                                                                column: 73,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    properties: [{
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'Function',
                                                                                context: true,
                                                                                value: function (_context5) {
                                                                                    return function change(e) {
                                                                                        var guessName = _context5.get('guessName'), fileInput = _context5.get('fileInput');
                                                                                        guessName(fileInput.inputElement.value);
                                                                                    };
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 50,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 52,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        }]
                                                                }
                                                            }],
                                                        kind: 'let',
                                                        order: '2'
                                                    },
                                                    {
                                                        type: 'VariableDeclaration',
                                                        declarations: [{
                                                                type: 'VariableDeclarator',
                                                                id: {
                                                                    type: 'Identifier',
                                                                    name: 'nameInput',
                                                                    loc: {
                                                                        start: {
                                                                            line: 52,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/DocumentDialog.ion'
                                                                        },
                                                                        end: {
                                                                            line: 52,
                                                                            column: 29,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/DocumentDialog.ion'
                                                                        }
                                                                    }
                                                                },
                                                                init: {
                                                                    type: 'ObjectExpression',
                                                                    objectType: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'Identifier',
                                                                            name: 'PaperInput',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 52,
                                                                                    column: 32,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 52,
                                                                                    column: 42,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [{
                                                                                type: 'ObjectExpression',
                                                                                properties: [
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'label',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 52,
                                                                                                    column: 44,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 52,
                                                                                                    column: 49,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 'Name'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'required',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 52,
                                                                                                    column: 59,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 52,
                                                                                                    column: 67,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: true
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '1'
                                                                                    }
                                                                                ]
                                                                            }],
                                                                        loc: {
                                                                            start: {
                                                                                line: 52,
                                                                                column: 32,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 52,
                                                                                column: 75,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    properties: [{
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'Function',
                                                                                context: true,
                                                                                value: function (_context6) {
                                                                                    return function keydown(e) {
                                                                                        var form = _context6.get('form');
                                                                                        if (e.key === 'Enter') {
                                                                                            form.submit(e);
                                                                                        }
                                                                                    };
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 53,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 56,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        }]
                                                                }
                                                            }],
                                                        kind: 'let',
                                                        order: '3'
                                                    },
                                                    {
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'ObjectExpression',
                                                            objectType: {
                                                                type: 'Identifier',
                                                                name: 'urlInput',
                                                                loc: {
                                                                    start: {
                                                                        line: 56,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                    },
                                                                    end: {
                                                                        line: 56,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                    }
                                                                }
                                                            },
                                                            properties: [{
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'disabled',
                                                                        loc: {
                                                                            start: {
                                                                                line: 57,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 57,
                                                                                column: 28,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'BinaryExpression',
                                                                        operator: '>',
                                                                        left: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'fileInput',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 57,
                                                                                                column: 30,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 57,
                                                                                                column: 39,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'inputElement',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 57,
                                                                                                column: 40,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 57,
                                                                                                column: 52,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 57,
                                                                                            column: 30,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/DocumentDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 57,
                                                                                            column: 52,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/DocumentDialog.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'value',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 57,
                                                                                            column: 53,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/DocumentDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 57,
                                                                                            column: 58,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/DocumentDialog.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 57,
                                                                                        column: 30,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 57,
                                                                                        column: 58,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'length',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 57,
                                                                                        column: 59,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 57,
                                                                                        column: 65,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 57,
                                                                                    column: 30,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 57,
                                                                                    column: 65,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        right: {
                                                                            type: 'Literal',
                                                                            value: 0
                                                                        }
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                }]
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 56,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                            },
                                                            end: {
                                                                line: 58,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                            }
                                                        },
                                                        order: '4'
                                                    },
                                                    {
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'ObjectExpression',
                                                            objectType: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Identifier',
                                                                    name: 'Span',
                                                                    loc: {
                                                                        start: {
                                                                            line: 58,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/DocumentDialog.ion'
                                                                        },
                                                                        end: {
                                                                            line: 58,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/DocumentDialog.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'ObjectExpression',
                                                                        properties: [{
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'class',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 58,
                                                                                            column: 22,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/DocumentDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 58,
                                                                                            column: 27,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/DocumentDialog.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Literal',
                                                                                    value: 'secondary'
                                                                                },
                                                                                kind: 'init',
                                                                                order: '0'
                                                                            }]
                                                                    }],
                                                                loc: {
                                                                    start: {
                                                                        line: 58,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                    },
                                                                    end: {
                                                                        line: 58,
                                                                        column: 41,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                    }
                                                                }
                                                            },
                                                            properties: [{
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'Literal',
                                                                        value: 'or'
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 59,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/DocumentDialog.ion'
                                                                        },
                                                                        end: {
                                                                            line: 59,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/DocumentDialog.ion'
                                                                        }
                                                                    },
                                                                    order: '0'
                                                                }]
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 58,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                            },
                                                            end: {
                                                                line: 60,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                            }
                                                        },
                                                        order: '5'
                                                    },
                                                    {
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'ObjectExpression',
                                                            objectType: {
                                                                type: 'Identifier',
                                                                name: 'fileInput',
                                                                loc: {
                                                                    start: {
                                                                        line: 60,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                    },
                                                                    end: {
                                                                        line: 60,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                    }
                                                                }
                                                            },
                                                            properties: [{
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'disabled',
                                                                        loc: {
                                                                            start: {
                                                                                line: 61,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 61,
                                                                                column: 28,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'BinaryExpression',
                                                                        operator: '>',
                                                                        left: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'Identifier',
                                                                                    name: 'urlInput',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 61,
                                                                                            column: 30,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/DocumentDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 61,
                                                                                            column: 38,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/DocumentDialog.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'value',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 61,
                                                                                            column: 39,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/DocumentDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 61,
                                                                                            column: 44,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/DocumentDialog.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 61,
                                                                                        column: 30,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 61,
                                                                                        column: 44,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'length',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 61,
                                                                                        column: 45,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 61,
                                                                                        column: 51,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 61,
                                                                                    column: 30,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 61,
                                                                                    column: 51,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        right: {
                                                                            type: 'Literal',
                                                                            value: 0
                                                                        }
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                }]
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 60,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                            },
                                                            end: {
                                                                line: 62,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                            }
                                                        },
                                                        order: '6'
                                                    },
                                                    {
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'Identifier',
                                                            name: 'nameInput',
                                                            loc: {
                                                                start: {
                                                                    line: 62,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                },
                                                                end: {
                                                                    line: 62,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 62,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                            },
                                                            end: {
                                                                line: 62,
                                                                column: 25,
                                                                fixed: true,
                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                            }
                                                        },
                                                        order: '7'
                                                    },
                                                    {
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'ObjectExpression',
                                                            objectType: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Identifier',
                                                                    name: 'Footer',
                                                                    loc: {
                                                                        start: {
                                                                            line: 63,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/DocumentDialog.ion'
                                                                        },
                                                                        end: {
                                                                            line: 63,
                                                                            column: 22,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/DocumentDialog.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'ObjectExpression',
                                                                        properties: [{
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'class',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 63,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/DocumentDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 63,
                                                                                            column: 29,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/DocumentDialog.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Literal',
                                                                                    value: 'layout horizontal reverse'
                                                                                },
                                                                                kind: 'init',
                                                                                order: '0'
                                                                            }]
                                                                    }],
                                                                loc: {
                                                                    start: {
                                                                        line: 63,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                    },
                                                                    end: {
                                                                        line: 63,
                                                                        column: 59,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                    }
                                                                }
                                                            },
                                                            properties: [
                                                                {
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'ObjectExpression',
                                                                        objectType: {
                                                                            type: 'CallExpression',
                                                                            callee: {
                                                                                type: 'Identifier',
                                                                                name: 'SubmitButton',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 64,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 64,
                                                                                        column: 32,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            arguments: [],
                                                                            loc: {
                                                                                start: {
                                                                                    line: 64,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 64,
                                                                                    column: 34,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        properties: [
                                                                            {
                                                                                type: 'ExpressionStatement',
                                                                                expression: {
                                                                                    type: 'Function',
                                                                                    context: true,
                                                                                    value: function (_context7) {
                                                                                        return function click(e) {
                                                                                            var nameInput = _context7.get('nameInput'), urlInput = _context7.get('urlInput'), fileInput = _context7.get('fileInput'), clone = _context7.get('clone'), value = _context7.get('value'), Document = _context7.get('Document'), record = _context7.get('record'), property = _context7.get('property'), form = _context7.get('form'), dialog = _context7.get('dialog');
                                                                                            var name = nameInput.value;
                                                                                            var url = urlInput.value;
                                                                                            var filename = fileInput.filename;
                                                                                            if (name && url) {
                                                                                                var newValue = clone(value);
                                                                                                newValue[name] = new Document({ link: url });
                                                                                                record[property] = newValue;
                                                                                                form.reset();
                                                                                                urlInput.inputElement.focus();
                                                                                            } else if (!name && !url) {
                                                                                                e.stopPropagation();
                                                                                                dialog.open = false;
                                                                                            }
                                                                                        };
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 65,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 82,
                                                                                        column: 28,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                                    }
                                                                                },
                                                                                order: '0'
                                                                            },
                                                                            {
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'disabled',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 82,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/DocumentDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 82,
                                                                                            column: 32,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/DocumentDialog.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'BinaryExpression',
                                                                                    operator: '&&',
                                                                                    left: {
                                                                                        type: 'UnaryExpression',
                                                                                        operator: '!',
                                                                                        argument: {
                                                                                            type: 'MemberExpression',
                                                                                            computed: false,
                                                                                            object: {
                                                                                                type: 'Identifier',
                                                                                                name: 'fileInput',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 82,
                                                                                                        column: 38,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 82,
                                                                                                        column: 47,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            property: {
                                                                                                type: 'Identifier',
                                                                                                name: 'filename',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 82,
                                                                                                        column: 48,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 82,
                                                                                                        column: 56,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 82,
                                                                                                    column: 38,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 82,
                                                                                                    column: 56,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                                }
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    right: {
                                                                                        type: 'UnaryExpression',
                                                                                        operator: '!',
                                                                                        argument: {
                                                                                            type: 'MemberExpression',
                                                                                            computed: false,
                                                                                            object: {
                                                                                                type: 'Identifier',
                                                                                                name: 'urlInput',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 82,
                                                                                                        column: 65,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 82,
                                                                                                        column: 73,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            property: {
                                                                                                type: 'Identifier',
                                                                                                name: 'value',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 82,
                                                                                                        column: 74,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 82,
                                                                                                        column: 79,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 82,
                                                                                                    column: 65,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 82,
                                                                                                    column: 79,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                                }
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                },
                                                                                kind: 'init',
                                                                                order: '1'
                                                                            },
                                                                            {
                                                                                type: 'ExpressionStatement',
                                                                                expression: {
                                                                                    type: 'Literal',
                                                                                    value: 'Attach'
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 83,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 83,
                                                                                        column: 32,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                                    }
                                                                                },
                                                                                order: '2'
                                                                            }
                                                                        ]
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 64,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/DocumentDialog.ion'
                                                                        },
                                                                        end: {
                                                                            line: 84,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/DocumentDialog.ion'
                                                                        }
                                                                    },
                                                                    order: '0'
                                                                },
                                                                {
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'ObjectExpression',
                                                                        objectType: {
                                                                            type: 'CallExpression',
                                                                            callee: {
                                                                                type: 'Identifier',
                                                                                name: 'PaperButton',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 84,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 84,
                                                                                        column: 31,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            arguments: [],
                                                                            loc: {
                                                                                start: {
                                                                                    line: 84,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 84,
                                                                                    column: 33,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        properties: [
                                                                            {
                                                                                type: 'ExpressionStatement',
                                                                                expression: {
                                                                                    type: 'Function',
                                                                                    context: true,
                                                                                    value: function (_context8) {
                                                                                        return function click() {
                                                                                            var dialog = _context8.get('dialog');
                                                                                            dialog.open = false;
                                                                                        };
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 85,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 87,
                                                                                        column: 28,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/DocumentDialog.ion'
                                                                                    }
                                                                                },
                                                                                order: '0'
                                                                            },
                                                                            {
                                                                                type: 'IfStatement',
                                                                                test: {
                                                                                    type: 'UnaryExpression',
                                                                                    operator: '!',
                                                                                    argument: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'nameInput',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 87,
                                                                                                    column: 31,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 87,
                                                                                                    column: 40,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'value',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 87,
                                                                                                    column: 41,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 87,
                                                                                                    column: 46,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 87,
                                                                                                column: 31,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 87,
                                                                                                column: 46,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                },
                                                                                consequent: {
                                                                                    type: 'BlockStatement',
                                                                                    body: [{
                                                                                            type: 'ExpressionStatement',
                                                                                            expression: {
                                                                                                type: 'Literal',
                                                                                                value: 'Close'
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 88,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 88,
                                                                                                    column: 35,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                                }
                                                                                            },
                                                                                            order: '0'
                                                                                        }]
                                                                                },
                                                                                alternate: {
                                                                                    type: 'BlockStatement',
                                                                                    body: [{
                                                                                            type: 'ExpressionStatement',
                                                                                            expression: {
                                                                                                type: 'Literal',
                                                                                                value: 'Cancel'
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 90,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 90,
                                                                                                    column: 36,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                                                                }
                                                                                            },
                                                                                            order: '0'
                                                                                        }]
                                                                                },
                                                                                order: '1'
                                                                            }
                                                                        ]
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 84,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/DocumentDialog.ion'
                                                                        },
                                                                        end: {
                                                                            line: 92,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/DocumentDialog.ion'
                                                                        }
                                                                    },
                                                                    order: '1'
                                                                }
                                                            ]
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 63,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                            },
                                                            end: {
                                                                line: 92,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/DocumentDialog.ion'
                                                            }
                                                        },
                                                        order: '8'
                                                    }
                                                ]
                                            },
                                            loc: {
                                                start: {
                                                    line: 39,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                },
                                                end: {
                                                    line: 92,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/DocumentDialog.ion'
                                                }
                                            },
                                            order: '3'
                                        }
                                    ]
                                },
                                kind: 'init',
                                order: '1'
                            }
                        ]
                    },
                    order: '5'
                }
            ],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'DocumentDialog',
                loc: {
                    start: {
                        line: 9,
                        column: 15,
                        fixed: true,
                        source: 'viewpath/html/DocumentDialog.ion'
                    },
                    end: {
                        line: 9,
                        column: 29,
                        fixed: true,
                        source: 'viewpath/html/DocumentDialog.ion'
                    }
                }
            }
        }, {
            this: this,
            args: args,
            glass: glass,
            _ref: _ref,
            style: style,
            _ref2: _ref2,
            Dialog: Dialog,
            _ref3: _ref3,
            GlassForm: GlassForm,
            SubmitButton: SubmitButton,
            CancelButton: CancelButton,
            vpmodel: vpmodel,
            _ref4: _ref4,
            Document: Document,
            clone: clone,
            DocumentDialog: DocumentDialog,
            show: show
        }, null);
    });
var show = exports.show = function (args) {
        Dialog.show(DocumentDialog, args);
    };
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/DocumentDialog',_viewpath_html_DocumentDialog_);
    else
      _viewpath_html_DocumentDialog_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_DocumentDialog_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_GanttColumn_ = function(module,exports,require){'use strict';
var ion = require('ion');
var glass = require('glass'), _ref, _ref2, _ref3;
_ref = glass.html;
var style = _ref.style;
_ref2 = glass.html.material;
var Icon = _ref2.Icon;
_ref3 = glass.html.material.DataTable2;
var TimelineColumn = _ref3.TimelineColumn;
var setVectorLength = function (length, x0, y0, x1, y1) {
    var dx = x1 - x0;
    var dy = y1 - y0;
    var currentLength = Math.sqrt(dx * dx + dy * dy);
    length = Math.min(length, currentLength);
    var ratio = length / currentLength;
    dx *= ratio;
    dy *= ratio;
    return [
        x0 + dx,
        y0 + dy
    ];
};
var lerp = function (x0, y0, x1, y1, alpha) {
    return [
        x0 + alpha * (x1 - x0),
        y0 + alpha * (y1 - y0)
    ];
};
var createCurvedPath = function (args, radius) {
    if (radius == null)
        radius = 16;
    var j = args.length - 2;
    while (j >= 2) {
        if (args[j] === args[j - 2] && args[j + 1] === args[j - 1]) {
            args.splice(j, 2);
        }
        j -= 2;
    }
    var path = 'M ' + args[0] + ' ' + args[1];
    for (var k = 1; k < args.length / 2 - 1; k++) {
        var i = k * 2;
        var sx = args[i + 0 - 2];
        var sy = args[i + 1 - 2];
        var ex = args[i + 0 + 2];
        var ey = args[i + 1 + 2];
        var cx = args[i + 0];
        var cy = args[i + 1];
        var _ref4 = setVectorLength(radius, cx, cy, sx, sy);
        sx = _ref4[0];
        sy = _ref4[1];
        var _ref5 = setVectorLength(radius, cx, cy, ex, ey);
        ex = _ref5[0];
        ey = _ref5[1];
        var kappa = 0.55;
        var _ref6 = lerp(sx, sy, cx, cy, kappa);
        var c1x = _ref6[0];
        var c1y = _ref6[1];
        var _ref7 = lerp(ex, ey, cx, cy, kappa);
        var c2x = _ref7[0];
        var c2y = _ref7[1];
        if (isNaN(c1x) || isNaN(c1y) || isNaN(c2x) || isNaN(c2y)) {
            return 'M 0 0';
        }
        path += 'L ' + sx + ' ' + sy + ' C ' + c1x + ' ' + c1y + ' ' + c2x + ' ' + c2y + ' ' + ex + ' ' + ey;
    }
    path += 'L ' + args[args.length - 2] + ' ' + args[args.length - 1];
    return path;
};
module.exports = exports = ion.template(function GanttColumn(property, options) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'GanttColumn',
            loc: {
                start: {
                    line: 56,
                    column: 16,
                    fixed: true,
                    source: 'viewpath/html/GanttColumn.ion'
                },
                end: {
                    line: 56,
                    column: 27,
                    fixed: true,
                    source: 'viewpath/html/GanttColumn.ion'
                }
            }
        },
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'baseColumn',
                            loc: {
                                start: {
                                    line: 57,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/GanttColumn.ion'
                                },
                                end: {
                                    line: 57,
                                    column: 18,
                                    fixed: true,
                                    source: 'viewpath/html/GanttColumn.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'TimelineColumn',
                                loc: {
                                    start: {
                                        line: 57,
                                        column: 21,
                                        fixed: true,
                                        source: 'viewpath/html/GanttColumn.ion'
                                    },
                                    end: {
                                        line: 57,
                                        column: 35,
                                        fixed: true,
                                        source: 'viewpath/html/GanttColumn.ion'
                                    }
                                }
                            },
                            arguments: [
                                {
                                    type: 'Identifier',
                                    name: 'property',
                                    loc: {
                                        start: {
                                            line: 57,
                                            column: 36,
                                            fixed: true,
                                            source: 'viewpath/html/GanttColumn.ion'
                                        },
                                        end: {
                                            line: 57,
                                            column: 44,
                                            fixed: true,
                                            source: 'viewpath/html/GanttColumn.ion'
                                        }
                                    }
                                },
                                {
                                    type: 'Identifier',
                                    name: 'options',
                                    loc: {
                                        start: {
                                            line: 57,
                                            column: 46,
                                            fixed: true,
                                            source: 'viewpath/html/GanttColumn.ion'
                                        },
                                        end: {
                                            line: 57,
                                            column: 53,
                                            fixed: true,
                                            source: 'viewpath/html/GanttColumn.ion'
                                        }
                                    }
                                }
                            ],
                            loc: {
                                start: {
                                    line: 57,
                                    column: 21,
                                    fixed: true,
                                    source: 'viewpath/html/GanttColumn.ion'
                                },
                                end: {
                                    line: 57,
                                    column: 54,
                                    fixed: true,
                                    source: 'viewpath/html/GanttColumn.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'baseColumn_createUnderlay',
                            loc: {
                                start: {
                                    line: 58,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/GanttColumn.ion'
                                },
                                end: {
                                    line: 58,
                                    column: 33,
                                    fixed: true,
                                    source: 'viewpath/html/GanttColumn.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Function',
                                context: true,
                                value: function (_context) {
                                    return function () {
                                        var baseColumn = _context.get('baseColumn');
                                        return baseColumn.createUnderlay;
                                    };
                                }
                            },
                            arguments: [],
                            loc: {
                                start: {
                                    line: 58,
                                    column: 36,
                                    fixed: true,
                                    source: 'viewpath/html/GanttColumn.ion'
                                },
                                end: {
                                    line: 58,
                                    column: 67,
                                    fixed: true,
                                    source: 'viewpath/html/GanttColumn.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'Identifier',
                        name: 'baseColumn',
                        loc: {
                            start: {
                                line: 59,
                                column: 11,
                                fixed: true,
                                source: 'viewpath/html/GanttColumn.ion'
                            },
                            end: {
                                line: 59,
                                column: 21,
                                fixed: true,
                                source: 'viewpath/html/GanttColumn.ion'
                            }
                        }
                    },
                    properties: [{
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'createUnderlay',
                                loc: {
                                    start: {
                                        line: 60,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/html/GanttColumn.ion'
                                    },
                                    end: {
                                        line: 60,
                                        column: 22,
                                        fixed: true,
                                        source: 'viewpath/html/GanttColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_ps) {
                                    return ion.template(function (dataTableModel, _ref8) {
                                        return ion.createRuntime({
                                            type: 'Template',
                                            id: null,
                                            body: [
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'body',
                                                                loc: {
                                                                    start: {
                                                                        line: 60,
                                                                        column: 51,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 60,
                                                                        column: 55,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'MemberExpression',
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: '_ref8'
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'body',
                                                                    loc: {
                                                                        start: {
                                                                            line: 60,
                                                                            column: 51,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 60,
                                                                            column: 55,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                computed: false
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'column',
                                                                loc: {
                                                                    start: {
                                                                        line: 61,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 61,
                                                                        column: 22,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: { type: 'ThisExpression' }
                                                        }],
                                                    kind: 'let',
                                                    order: '1'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: '_ref9'
                                                            },
                                                            init: {
                                                                type: 'Identifier',
                                                                name: 'column',
                                                                loc: {
                                                                    start: {
                                                                        line: 62,
                                                                        column: 31,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 62,
                                                                        column: 37,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '2'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'components',
                                                                loc: {
                                                                    start: {
                                                                        line: 62,
                                                                        column: 17,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 62,
                                                                        column: 27,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'MemberExpression',
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: '_ref9'
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'components',
                                                                    loc: {
                                                                        start: {
                                                                            line: 62,
                                                                            column: 17,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 62,
                                                                            column: 27,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                computed: false
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '3'
                                                },
                                                {
                                                    type: 'ReturnStatement',
                                                    argument: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'baseColumn_createUnderlay',
                                                                loc: {
                                                                    start: {
                                                                        line: 63,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 63,
                                                                        column: 44,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [
                                                                {
                                                                    type: 'Identifier',
                                                                    name: 'dataTableModel',
                                                                    loc: {
                                                                        start: {
                                                                            line: 63,
                                                                            column: 45,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 63,
                                                                            column: 59,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                {
                                                                    type: 'ObjectExpression',
                                                                    properties: [{
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'body',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 63,
                                                                                        column: 62,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 63,
                                                                                        column: 66,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Identifier',
                                                                                name: 'body',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 63,
                                                                                        column: 62,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 63,
                                                                                        column: 66,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        }]
                                                                }
                                                            ],
                                                            loc: {
                                                                start: {
                                                                    line: 63,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                },
                                                                end: {
                                                                    line: 63,
                                                                    column: 68,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'style',
                                                                    loc: {
                                                                        start: {
                                                                            line: 64,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 64,
                                                                            column: 21,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'ObjectExpression',
                                                                    properties: [{
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'position',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 65,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 65,
                                                                                        column: 28,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'relative'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'ForInStatement',
                                                                left: {
                                                                    type: 'VariableDeclaration',
                                                                    declarations: [
                                                                        {
                                                                            type: 'VariableDeclarator',
                                                                            id: {
                                                                                type: 'Identifier',
                                                                                name: 'skey',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 66,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 66,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            init: null
                                                                        },
                                                                        {
                                                                            type: 'VariableDeclarator',
                                                                            id: {
                                                                                type: 'Identifier',
                                                                                name: 'selement',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 66,
                                                                                        column: 26,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 66,
                                                                                        column: 34,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            init: null
                                                                        }
                                                                    ],
                                                                    kind: 'let'
                                                                },
                                                                right: {
                                                                    type: 'Identifier',
                                                                    name: 'components',
                                                                    loc: {
                                                                        start: {
                                                                            line: 66,
                                                                            column: 38,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 66,
                                                                            column: 48,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                body: {
                                                                    type: 'BlockStatement',
                                                                    body: [
                                                                        {
                                                                            type: 'VariableDeclaration',
                                                                            declarations: [{
                                                                                    type: 'VariableDeclarator',
                                                                                    id: {
                                                                                        type: 'Identifier',
                                                                                        name: 'srecord',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 67,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 67,
                                                                                                column: 31,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    init: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'selement',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 67,
                                                                                                    column: 34,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 67,
                                                                                                    column: 42,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'record',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 67,
                                                                                                    column: 43,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 67,
                                                                                                    column: 49,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 67,
                                                                                                column: 34,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 67,
                                                                                                column: 49,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                }],
                                                                            kind: 'let',
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'VariableDeclaration',
                                                                            declarations: [{
                                                                                    type: 'VariableDeclarator',
                                                                                    id: {
                                                                                        type: 'Identifier',
                                                                                        name: 'predecessors',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 68,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 68,
                                                                                                column: 36,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    init: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'srecord',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 68,
                                                                                                    column: 39,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 68,
                                                                                                    column: 46,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'predecessors',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 68,
                                                                                                    column: 48,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 68,
                                                                                                    column: 60,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        existential: true,
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 68,
                                                                                                column: 39,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 68,
                                                                                                column: 60,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                }],
                                                                            kind: 'let',
                                                                            order: '1'
                                                                        },
                                                                        {
                                                                            type: 'IfStatement',
                                                                            test: {
                                                                                type: 'UnaryExpression',
                                                                                operator: '?',
                                                                                argument: {
                                                                                    type: 'Identifier',
                                                                                    name: 'predecessors',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 69,
                                                                                            column: 23,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 69,
                                                                                            column: 35,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                        }
                                                                                    }
                                                                                }
                                                                            },
                                                                            consequent: {
                                                                                type: 'BlockStatement',
                                                                                body: [{
                                                                                        type: 'ForInStatement',
                                                                                        left: {
                                                                                            type: 'VariableDeclaration',
                                                                                            declarations: [{
                                                                                                    type: 'VariableDeclarator',
                                                                                                    id: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'pkey',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 70,
                                                                                                                column: 28,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 70,
                                                                                                                column: 32,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    init: null
                                                                                                }],
                                                                                            kind: 'let'
                                                                                        },
                                                                                        right: {
                                                                                            type: 'Identifier',
                                                                                            name: 'predecessors',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 70,
                                                                                                    column: 36,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 70,
                                                                                                    column: 48,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        body: {
                                                                                            type: 'BlockStatement',
                                                                                            body: [
                                                                                                {
                                                                                                    type: 'VariableDeclaration',
                                                                                                    declarations: [{
                                                                                                            type: 'VariableDeclarator',
                                                                                                            id: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'dependency',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 71,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 71,
                                                                                                                        column: 42,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            init: {
                                                                                                                type: 'MemberExpression',
                                                                                                                computed: true,
                                                                                                                object: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'predecessors',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 71,
                                                                                                                            column: 45,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 71,
                                                                                                                            column: 57,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                property: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'pkey',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 71,
                                                                                                                            column: 58,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 71,
                                                                                                                            column: 62,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 71,
                                                                                                                        column: 45,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 71,
                                                                                                                        column: 63,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            }
                                                                                                        }],
                                                                                                    kind: 'let',
                                                                                                    order: '0'
                                                                                                },
                                                                                                {
                                                                                                    type: 'VariableDeclaration',
                                                                                                    declarations: [{
                                                                                                            type: 'VariableDeclarator',
                                                                                                            id: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'pelement',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 72,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 72,
                                                                                                                        column: 40,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            init: {
                                                                                                                type: 'MemberExpression',
                                                                                                                computed: true,
                                                                                                                object: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'components',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 72,
                                                                                                                            column: 43,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 72,
                                                                                                                            column: 53,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                property: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'pkey',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 72,
                                                                                                                            column: 54,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 72,
                                                                                                                            column: 58,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 72,
                                                                                                                        column: 43,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 72,
                                                                                                                        column: 59,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            }
                                                                                                        }],
                                                                                                    kind: 'let',
                                                                                                    order: '1'
                                                                                                },
                                                                                                {
                                                                                                    type: 'VariableDeclaration',
                                                                                                    declarations: [{
                                                                                                            type: 'VariableDeclarator',
                                                                                                            id: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'precord',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 73,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 73,
                                                                                                                        column: 39,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            init: {
                                                                                                                type: 'MemberExpression',
                                                                                                                computed: false,
                                                                                                                object: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'pelement',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 73,
                                                                                                                            column: 42,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 73,
                                                                                                                            column: 50,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                property: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'record',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 73,
                                                                                                                            column: 51,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 73,
                                                                                                                            column: 57,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 73,
                                                                                                                        column: 42,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 73,
                                                                                                                        column: 57,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            }
                                                                                                        }],
                                                                                                    kind: 'let',
                                                                                                    order: '2'
                                                                                                },
                                                                                                {
                                                                                                    type: 'IfStatement',
                                                                                                    test: {
                                                                                                        type: 'BinaryExpression',
                                                                                                        operator: '&&',
                                                                                                        left: {
                                                                                                            type: 'MemberExpression',
                                                                                                            computed: false,
                                                                                                            object: {
                                                                                                                type: 'MemberExpression',
                                                                                                                computed: false,
                                                                                                                object: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'pelement',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 75,
                                                                                                                            column: 31,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 75,
                                                                                                                            column: 39,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                property: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'parentElement',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 75,
                                                                                                                            column: 40,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 75,
                                                                                                                            column: 53,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 75,
                                                                                                                        column: 31,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 75,
                                                                                                                        column: 53,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            property: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'parentElement',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 75,
                                                                                                                        column: 55,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 75,
                                                                                                                        column: 68,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            existential: true,
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 75,
                                                                                                                    column: 31,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 75,
                                                                                                                    column: 68,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        right: {
                                                                                                            type: 'MemberExpression',
                                                                                                            computed: false,
                                                                                                            object: {
                                                                                                                type: 'MemberExpression',
                                                                                                                computed: false,
                                                                                                                object: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'selement',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 75,
                                                                                                                            column: 73,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 75,
                                                                                                                            column: 81,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                property: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'parentElement',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 75,
                                                                                                                            column: 82,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 75,
                                                                                                                            column: 95,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 75,
                                                                                                                        column: 73,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 75,
                                                                                                                        column: 95,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            property: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'parentElement',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 75,
                                                                                                                        column: 97,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 75,
                                                                                                                        column: 110,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            existential: true,
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 75,
                                                                                                                    column: 73,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 75,
                                                                                                                    column: 110,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    consequent: {
                                                                                                        type: 'BlockStatement',
                                                                                                        body: [
                                                                                                            {
                                                                                                                type: 'VariableDeclaration',
                                                                                                                declarations: [{
                                                                                                                        type: 'VariableDeclarator',
                                                                                                                        id: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'px',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 76,
                                                                                                                                    column: 36,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 76,
                                                                                                                                    column: 38,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        init: {
                                                                                                                            type: 'MemberExpression',
                                                                                                                            computed: false,
                                                                                                                            object: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'pelement',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 76,
                                                                                                                                        column: 41,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 76,
                                                                                                                                        column: 49,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            property: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'offsetLeft',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 76,
                                                                                                                                        column: 50,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 76,
                                                                                                                                        column: 60,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 76,
                                                                                                                                    column: 41,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 76,
                                                                                                                                    column: 60,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        }
                                                                                                                    }],
                                                                                                                kind: 'let',
                                                                                                                order: '0'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'VariableDeclaration',
                                                                                                                declarations: [{
                                                                                                                        type: 'VariableDeclarator',
                                                                                                                        id: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'py',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 77,
                                                                                                                                    column: 36,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 77,
                                                                                                                                    column: 38,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        init: {
                                                                                                                            type: 'BinaryExpression',
                                                                                                                            operator: '+',
                                                                                                                            left: {
                                                                                                                                type: 'MemberExpression',
                                                                                                                                computed: false,
                                                                                                                                object: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'pelement',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 77,
                                                                                                                                            column: 41,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 77,
                                                                                                                                            column: 49,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                property: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'offsetTop',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 77,
                                                                                                                                            column: 50,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 77,
                                                                                                                                            column: 59,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 77,
                                                                                                                                        column: 41,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 77,
                                                                                                                                        column: 59,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            right: {
                                                                                                                                type: 'MemberExpression',
                                                                                                                                computed: false,
                                                                                                                                object: {
                                                                                                                                    type: 'MemberExpression',
                                                                                                                                    computed: false,
                                                                                                                                    object: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'pelement',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 77,
                                                                                                                                                column: 62,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 77,
                                                                                                                                                column: 70,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    property: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'offsetParent',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 77,
                                                                                                                                                column: 71,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 77,
                                                                                                                                                column: 83,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 77,
                                                                                                                                            column: 62,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 77,
                                                                                                                                            column: 83,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                property: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'offsetTop',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 77,
                                                                                                                                            column: 84,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 77,
                                                                                                                                            column: 93,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 77,
                                                                                                                                        column: 62,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 77,
                                                                                                                                        column: 93,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            }
                                                                                                                        }
                                                                                                                    }],
                                                                                                                kind: 'let',
                                                                                                                order: '1'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'VariableDeclaration',
                                                                                                                declarations: [{
                                                                                                                        type: 'VariableDeclarator',
                                                                                                                        id: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'pw',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 78,
                                                                                                                                    column: 36,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 78,
                                                                                                                                    column: 38,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        init: {
                                                                                                                            type: 'MemberExpression',
                                                                                                                            computed: false,
                                                                                                                            object: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'pelement',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 78,
                                                                                                                                        column: 41,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 78,
                                                                                                                                        column: 49,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            property: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'clientWidth',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 78,
                                                                                                                                        column: 50,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 78,
                                                                                                                                        column: 61,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 78,
                                                                                                                                    column: 41,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 78,
                                                                                                                                    column: 61,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        }
                                                                                                                    }],
                                                                                                                kind: 'let',
                                                                                                                order: '2'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'VariableDeclaration',
                                                                                                                declarations: [{
                                                                                                                        type: 'VariableDeclarator',
                                                                                                                        id: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'ph',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 79,
                                                                                                                                    column: 36,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 79,
                                                                                                                                    column: 38,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        init: {
                                                                                                                            type: 'MemberExpression',
                                                                                                                            computed: false,
                                                                                                                            object: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'pelement',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 79,
                                                                                                                                        column: 41,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 79,
                                                                                                                                        column: 49,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            property: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'clientHeight',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 79,
                                                                                                                                        column: 50,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 79,
                                                                                                                                        column: 62,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 79,
                                                                                                                                    column: 41,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 79,
                                                                                                                                    column: 62,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        }
                                                                                                                    }],
                                                                                                                kind: 'let',
                                                                                                                order: '3'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'VariableDeclaration',
                                                                                                                declarations: [{
                                                                                                                        type: 'VariableDeclarator',
                                                                                                                        id: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'sx',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 80,
                                                                                                                                    column: 36,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 80,
                                                                                                                                    column: 38,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        init: {
                                                                                                                            type: 'MemberExpression',
                                                                                                                            computed: false,
                                                                                                                            object: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'selement',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 80,
                                                                                                                                        column: 41,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 80,
                                                                                                                                        column: 49,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            property: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'offsetLeft',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 80,
                                                                                                                                        column: 50,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 80,
                                                                                                                                        column: 60,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 80,
                                                                                                                                    column: 41,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 80,
                                                                                                                                    column: 60,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        }
                                                                                                                    }],
                                                                                                                kind: 'let',
                                                                                                                order: '4'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'VariableDeclaration',
                                                                                                                declarations: [{
                                                                                                                        type: 'VariableDeclarator',
                                                                                                                        id: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'sy',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 81,
                                                                                                                                    column: 36,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 81,
                                                                                                                                    column: 38,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        init: {
                                                                                                                            type: 'BinaryExpression',
                                                                                                                            operator: '+',
                                                                                                                            left: {
                                                                                                                                type: 'MemberExpression',
                                                                                                                                computed: false,
                                                                                                                                object: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'selement',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 81,
                                                                                                                                            column: 41,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 81,
                                                                                                                                            column: 49,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                property: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'offsetTop',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 81,
                                                                                                                                            column: 50,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 81,
                                                                                                                                            column: 59,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 81,
                                                                                                                                        column: 41,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 81,
                                                                                                                                        column: 59,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            right: {
                                                                                                                                type: 'MemberExpression',
                                                                                                                                computed: false,
                                                                                                                                object: {
                                                                                                                                    type: 'MemberExpression',
                                                                                                                                    computed: false,
                                                                                                                                    object: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'selement',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 81,
                                                                                                                                                column: 62,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 81,
                                                                                                                                                column: 70,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    property: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'offsetParent',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 81,
                                                                                                                                                column: 71,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 81,
                                                                                                                                                column: 83,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 81,
                                                                                                                                            column: 62,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 81,
                                                                                                                                            column: 83,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                property: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'offsetTop',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 81,
                                                                                                                                            column: 84,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 81,
                                                                                                                                            column: 93,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 81,
                                                                                                                                        column: 62,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 81,
                                                                                                                                        column: 93,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            }
                                                                                                                        }
                                                                                                                    }],
                                                                                                                kind: 'let',
                                                                                                                order: '5'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'VariableDeclaration',
                                                                                                                declarations: [{
                                                                                                                        type: 'VariableDeclarator',
                                                                                                                        id: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'sw',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 82,
                                                                                                                                    column: 36,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 82,
                                                                                                                                    column: 38,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        init: {
                                                                                                                            type: 'MemberExpression',
                                                                                                                            computed: false,
                                                                                                                            object: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'selement',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 82,
                                                                                                                                        column: 41,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 82,
                                                                                                                                        column: 49,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            property: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'clientWidth',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 82,
                                                                                                                                        column: 50,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 82,
                                                                                                                                        column: 61,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 82,
                                                                                                                                    column: 41,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 82,
                                                                                                                                    column: 61,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        }
                                                                                                                    }],
                                                                                                                kind: 'let',
                                                                                                                order: '6'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'VariableDeclaration',
                                                                                                                declarations: [{
                                                                                                                        type: 'VariableDeclarator',
                                                                                                                        id: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'sh',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 83,
                                                                                                                                    column: 36,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 83,
                                                                                                                                    column: 38,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        init: {
                                                                                                                            type: 'MemberExpression',
                                                                                                                            computed: false,
                                                                                                                            object: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'selement',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 83,
                                                                                                                                        column: 41,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 83,
                                                                                                                                        column: 49,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            property: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'clientHeight',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 83,
                                                                                                                                        column: 50,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 83,
                                                                                                                                        column: 62,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 83,
                                                                                                                                    column: 41,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 83,
                                                                                                                                    column: 62,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        }
                                                                                                                    }],
                                                                                                                kind: 'let',
                                                                                                                order: '7'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'VariableDeclaration',
                                                                                                                declarations: [{
                                                                                                                        type: 'VariableDeclarator',
                                                                                                                        id: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: '_ref10'
                                                                                                                        },
                                                                                                                        init: {
                                                                                                                            type: 'CallExpression',
                                                                                                                            callee: {
                                                                                                                                type: 'Function',
                                                                                                                                context: true,
                                                                                                                                value: function (_context2) {
                                                                                                                                    return function (pelement, dependency, selement, px, py, pw, ph, sx, sy, sw, sh) {
                                                                                                                                        var createCurvedPath = _context2.get('createCurvedPath');
                                                                                                                                        var type = dependency.type != null ? dependency.type : 'FS';
                                                                                                                                        var getEndPoint = function (x, y, w, h, end, bottom) {
                                                                                                                                            return end ? [
                                                                                                                                                x + w,
                                                                                                                                                y + h / 2
                                                                                                                                            ] : [
                                                                                                                                                x,
                                                                                                                                                y + h / 2
                                                                                                                                            ];
                                                                                                                                        };
                                                                                                                                        var offsetFix = 10;
                                                                                                                                        px += offsetFix;
                                                                                                                                        sx += offsetFix;
                                                                                                                                        var _ref11 = getEndPoint(px, py, pw, ph, type[0] === 'F', sy > py);
                                                                                                                                        var startX = _ref11[0];
                                                                                                                                        var startY = _ref11[1];
                                                                                                                                        var _ref12 = getEndPoint(sx, sy, sw, sh, type[1] === 'F');
                                                                                                                                        var endX = _ref12[0];
                                                                                                                                        var endY = _ref12[1];
                                                                                                                                        var radius = 4;
                                                                                                                                        var bufferX = 12;
                                                                                                                                        var bufferY = 25;
                                                                                                                                        var ysign = Math.sign(endY - startY);
                                                                                                                                        var xsign = Math.sign(endX - startX);
                                                                                                                                        if (xsign === 0) {
                                                                                                                                            endY -= ysign * ph / 2;
                                                                                                                                        }
                                                                                                                                        var points = [];
                                                                                                                                        {
                                                                                                                                            points.push(startX);
                                                                                                                                            points.push(startY);
                                                                                                                                            if (startX !== endX) {
                                                                                                                                                points.push((endX + startX) / 2);
                                                                                                                                                points.push(startY);
                                                                                                                                                points.push((endX + startX) / 2);
                                                                                                                                                points.push(endY);
                                                                                                                                            }
                                                                                                                                            points.push(endX);
                                                                                                                                            points.push(endY);
                                                                                                                                        }
                                                                                                                                        var path = createCurvedPath(points, radius);
                                                                                                                                        var arrowX = endX;
                                                                                                                                        var arrowY = endY;
                                                                                                                                        return [
                                                                                                                                            '0px',
                                                                                                                                            '0px',
                                                                                                                                            path,
                                                                                                                                            arrowX,
                                                                                                                                            arrowY,
                                                                                                                                            xsign,
                                                                                                                                            ysign
                                                                                                                                        ];
                                                                                                                                    };
                                                                                                                                }
                                                                                                                            },
                                                                                                                            arguments: [
                                                                                                                                {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'pelement',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 85,
                                                                                                                                            column: 87,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 85,
                                                                                                                                            column: 95,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'dependency',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 85,
                                                                                                                                            column: 97,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 85,
                                                                                                                                            column: 107,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'selement',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 85,
                                                                                                                                            column: 109,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 85,
                                                                                                                                            column: 117,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'px',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 85,
                                                                                                                                            column: 119,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 85,
                                                                                                                                            column: 121,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'py',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 85,
                                                                                                                                            column: 122,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 85,
                                                                                                                                            column: 124,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'pw',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 85,
                                                                                                                                            column: 125,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 85,
                                                                                                                                            column: 127,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'ph',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 85,
                                                                                                                                            column: 128,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 85,
                                                                                                                                            column: 130,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'sx',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 85,
                                                                                                                                            column: 132,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 85,
                                                                                                                                            column: 134,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'sy',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 85,
                                                                                                                                            column: 135,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 85,
                                                                                                                                            column: 137,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'sw',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 85,
                                                                                                                                            column: 138,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 85,
                                                                                                                                            column: 140,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'sh',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 85,
                                                                                                                                            column: 141,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 85,
                                                                                                                                            column: 143,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            ],
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 85,
                                                                                                                                    column: 83,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 118,
                                                                                                                                    column: 36,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        }
                                                                                                                    }],
                                                                                                                kind: 'let',
                                                                                                                order: '8'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'VariableDeclaration',
                                                                                                                declarations: [{
                                                                                                                        type: 'VariableDeclarator',
                                                                                                                        id: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'pathx',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 85,
                                                                                                                                    column: 37,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 85,
                                                                                                                                    column: 42,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        init: {
                                                                                                                            type: 'MemberExpression',
                                                                                                                            object: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: '_ref10'
                                                                                                                            },
                                                                                                                            property: {
                                                                                                                                type: 'Literal',
                                                                                                                                value: 0
                                                                                                                            },
                                                                                                                            computed: true
                                                                                                                        }
                                                                                                                    }],
                                                                                                                kind: 'let',
                                                                                                                order: '9'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'VariableDeclaration',
                                                                                                                declarations: [{
                                                                                                                        type: 'VariableDeclarator',
                                                                                                                        id: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'pathy',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 85,
                                                                                                                                    column: 43,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 85,
                                                                                                                                    column: 48,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        init: {
                                                                                                                            type: 'MemberExpression',
                                                                                                                            object: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: '_ref10'
                                                                                                                            },
                                                                                                                            property: {
                                                                                                                                type: 'Literal',
                                                                                                                                value: 1
                                                                                                                            },
                                                                                                                            computed: true
                                                                                                                        }
                                                                                                                    }],
                                                                                                                kind: 'let',
                                                                                                                order: ':'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'VariableDeclaration',
                                                                                                                declarations: [{
                                                                                                                        type: 'VariableDeclarator',
                                                                                                                        id: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'path',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 85,
                                                                                                                                    column: 49,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 85,
                                                                                                                                    column: 53,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        init: {
                                                                                                                            type: 'MemberExpression',
                                                                                                                            object: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: '_ref10'
                                                                                                                            },
                                                                                                                            property: {
                                                                                                                                type: 'Literal',
                                                                                                                                value: 2
                                                                                                                            },
                                                                                                                            computed: true
                                                                                                                        }
                                                                                                                    }],
                                                                                                                kind: 'let',
                                                                                                                order: ';'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'VariableDeclaration',
                                                                                                                declarations: [{
                                                                                                                        type: 'VariableDeclarator',
                                                                                                                        id: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'arrowX',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 85,
                                                                                                                                    column: 54,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 85,
                                                                                                                                    column: 60,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        init: {
                                                                                                                            type: 'MemberExpression',
                                                                                                                            object: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: '_ref10'
                                                                                                                            },
                                                                                                                            property: {
                                                                                                                                type: 'Literal',
                                                                                                                                value: 3
                                                                                                                            },
                                                                                                                            computed: true
                                                                                                                        }
                                                                                                                    }],
                                                                                                                kind: 'let',
                                                                                                                order: '<'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'VariableDeclaration',
                                                                                                                declarations: [{
                                                                                                                        type: 'VariableDeclarator',
                                                                                                                        id: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'arrowY',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 85,
                                                                                                                                    column: 61,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 85,
                                                                                                                                    column: 67,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        init: {
                                                                                                                            type: 'MemberExpression',
                                                                                                                            object: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: '_ref10'
                                                                                                                            },
                                                                                                                            property: {
                                                                                                                                type: 'Literal',
                                                                                                                                value: 4
                                                                                                                            },
                                                                                                                            computed: true
                                                                                                                        }
                                                                                                                    }],
                                                                                                                kind: 'let',
                                                                                                                order: '='
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'VariableDeclaration',
                                                                                                                declarations: [{
                                                                                                                        type: 'VariableDeclarator',
                                                                                                                        id: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'xsign',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 85,
                                                                                                                                    column: 68,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 85,
                                                                                                                                    column: 73,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        init: {
                                                                                                                            type: 'MemberExpression',
                                                                                                                            object: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: '_ref10'
                                                                                                                            },
                                                                                                                            property: {
                                                                                                                                type: 'Literal',
                                                                                                                                value: 5
                                                                                                                            },
                                                                                                                            computed: true
                                                                                                                        }
                                                                                                                    }],
                                                                                                                kind: 'let',
                                                                                                                order: '>'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'VariableDeclaration',
                                                                                                                declarations: [{
                                                                                                                        type: 'VariableDeclarator',
                                                                                                                        id: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'ysign',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 85,
                                                                                                                                    column: 74,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 85,
                                                                                                                                    column: 79,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        init: {
                                                                                                                            type: 'MemberExpression',
                                                                                                                            object: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: '_ref10'
                                                                                                                            },
                                                                                                                            property: {
                                                                                                                                type: 'Literal',
                                                                                                                                value: 6
                                                                                                                            },
                                                                                                                            computed: true
                                                                                                                        }
                                                                                                                    }],
                                                                                                                kind: 'let',
                                                                                                                order: '?'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'ExpressionStatement',
                                                                                                                expression: {
                                                                                                                    type: 'ObjectExpression',
                                                                                                                    objectType: {
                                                                                                                        type: 'CallExpression',
                                                                                                                        callee: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'Svg',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 118,
                                                                                                                                    column: 32,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 118,
                                                                                                                                    column: 35,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        arguments: [],
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 118,
                                                                                                                                column: 32,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 118,
                                                                                                                                column: 37,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    properties: [
                                                                                                                        {
                                                                                                                            type: 'Property',
                                                                                                                            key: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'style',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 119,
                                                                                                                                        column: 36,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 119,
                                                                                                                                        column: 41,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            value: {
                                                                                                                                type: 'ObjectExpression',
                                                                                                                                properties: [
                                                                                                                                    {
                                                                                                                                        type: 'Property',
                                                                                                                                        key: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'left',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 120,
                                                                                                                                                    column: 40,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 120,
                                                                                                                                                    column: 44,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        value: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'pathx',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 120,
                                                                                                                                                    column: 46,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 120,
                                                                                                                                                    column: 51,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        kind: 'init',
                                                                                                                                        order: '0'
                                                                                                                                    },
                                                                                                                                    {
                                                                                                                                        type: 'Property',
                                                                                                                                        key: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'top',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 121,
                                                                                                                                                    column: 40,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 121,
                                                                                                                                                    column: 43,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        value: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'pathy',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 121,
                                                                                                                                                    column: 45,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 121,
                                                                                                                                                    column: 50,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        kind: 'init',
                                                                                                                                        order: '1'
                                                                                                                                    },
                                                                                                                                    {
                                                                                                                                        type: 'Property',
                                                                                                                                        key: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'position',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 122,
                                                                                                                                                    column: 40,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 122,
                                                                                                                                                    column: 48,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        value: {
                                                                                                                                            type: 'Literal',
                                                                                                                                            value: 'absolute'
                                                                                                                                        },
                                                                                                                                        kind: 'init',
                                                                                                                                        order: '2'
                                                                                                                                    },
                                                                                                                                    {
                                                                                                                                        type: 'Property',
                                                                                                                                        key: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'overflow',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 123,
                                                                                                                                                    column: 40,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 123,
                                                                                                                                                    column: 48,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        value: {
                                                                                                                                            type: 'Literal',
                                                                                                                                            value: 'visible'
                                                                                                                                        },
                                                                                                                                        kind: 'init',
                                                                                                                                        order: '3'
                                                                                                                                    }
                                                                                                                                ]
                                                                                                                            },
                                                                                                                            kind: 'init',
                                                                                                                            order: '0'
                                                                                                                        },
                                                                                                                        {
                                                                                                                            type: 'VariableDeclaration',
                                                                                                                            declarations: [{
                                                                                                                                    type: 'VariableDeclarator',
                                                                                                                                    id: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'baseColor',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 124,
                                                                                                                                                column: 40,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 124,
                                                                                                                                                column: 49,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    init: {
                                                                                                                                        type: 'MemberExpression',
                                                                                                                                        computed: false,
                                                                                                                                        object: {
                                                                                                                                            type: 'MemberExpression',
                                                                                                                                            computed: false,
                                                                                                                                            object: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'style',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 124,
                                                                                                                                                        column: 52,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 124,
                                                                                                                                                        column: 57,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            property: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'color',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 124,
                                                                                                                                                        column: 58,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 124,
                                                                                                                                                        column: 63,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 124,
                                                                                                                                                    column: 52,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 124,
                                                                                                                                                    column: 63,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        property: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'accent',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 124,
                                                                                                                                                    column: 64,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 124,
                                                                                                                                                    column: 70,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 124,
                                                                                                                                                column: 52,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 124,
                                                                                                                                                column: 70,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                }],
                                                                                                                            kind: 'let',
                                                                                                                            order: '1'
                                                                                                                        },
                                                                                                                        {
                                                                                                                            type: 'VariableDeclaration',
                                                                                                                            declarations: [{
                                                                                                                                    type: 'VariableDeclarator',
                                                                                                                                    id: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'lighterColor',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 125,
                                                                                                                                                column: 40,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 125,
                                                                                                                                                column: 52,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    init: {
                                                                                                                                        type: 'CallExpression',
                                                                                                                                        callee: {
                                                                                                                                            type: 'Function',
                                                                                                                                            context: true,
                                                                                                                                            value: function (_context3) {
                                                                                                                                                return function (baseColor) {
                                                                                                                                                    var style = _context3.get('style');
                                                                                                                                                    return style.interpolate('#FFFFFF', baseColor, 0.9);
                                                                                                                                                };
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        arguments: [{
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'baseColor',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 125,
                                                                                                                                                        column: 59,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 125,
                                                                                                                                                        column: 68,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            }],
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 125,
                                                                                                                                                column: 55,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 125,
                                                                                                                                                column: 117,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                }],
                                                                                                                            kind: 'let',
                                                                                                                            order: '2'
                                                                                                                        },
                                                                                                                        {
                                                                                                                            type: 'VariableDeclaration',
                                                                                                                            declarations: [{
                                                                                                                                    type: 'VariableDeclarator',
                                                                                                                                    id: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'pathElement',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 126,
                                                                                                                                                column: 40,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 126,
                                                                                                                                                column: 51,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    init: {
                                                                                                                                        type: 'CallExpression',
                                                                                                                                        callee: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'Path',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 126,
                                                                                                                                                    column: 54,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 126,
                                                                                                                                                    column: 58,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        arguments: [{
                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                properties: [
                                                                                                                                                    {
                                                                                                                                                        type: 'Property',
                                                                                                                                                        key: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'stroke',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 126,
                                                                                                                                                                    column: 60,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 126,
                                                                                                                                                                    column: 66,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        value: {
                                                                                                                                                            type: 'BinaryExpression',
                                                                                                                                                            operator: '+',
                                                                                                                                                            left: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: ''
                                                                                                                                                            },
                                                                                                                                                            right: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'lighterColor',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 126,
                                                                                                                                                                        column: 70,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 126,
                                                                                                                                                                        column: 82,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        kind: 'init',
                                                                                                                                                        order: '0'
                                                                                                                                                    },
                                                                                                                                                    {
                                                                                                                                                        type: 'Property',
                                                                                                                                                        key: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'fill',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 126,
                                                                                                                                                                    column: 86,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 126,
                                                                                                                                                                    column: 90,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        value: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: 'none'
                                                                                                                                                        },
                                                                                                                                                        kind: 'init',
                                                                                                                                                        order: '1'
                                                                                                                                                    },
                                                                                                                                                    {
                                                                                                                                                        type: 'Property',
                                                                                                                                                        key: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: 'stroke-width'
                                                                                                                                                        },
                                                                                                                                                        value: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: 2
                                                                                                                                                        },
                                                                                                                                                        kind: 'init',
                                                                                                                                                        order: '2'
                                                                                                                                                    },
                                                                                                                                                    {
                                                                                                                                                        type: 'Property',
                                                                                                                                                        key: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: 'stroke-linecap'
                                                                                                                                                        },
                                                                                                                                                        value: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: 'butt'
                                                                                                                                                        },
                                                                                                                                                        kind: 'init',
                                                                                                                                                        order: '3'
                                                                                                                                                    }
                                                                                                                                                ]
                                                                                                                                            }],
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 126,
                                                                                                                                                column: 54,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 126,
                                                                                                                                                column: 140,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                }],
                                                                                                                            kind: 'let',
                                                                                                                            order: '3'
                                                                                                                        },
                                                                                                                        {
                                                                                                                            type: 'ExpressionStatement',
                                                                                                                            expression: {
                                                                                                                                type: 'UnaryExpression',
                                                                                                                                operator: 'void',
                                                                                                                                argument: {
                                                                                                                                    type: 'CallExpression',
                                                                                                                                    callee: {
                                                                                                                                        type: 'MemberExpression',
                                                                                                                                        computed: false,
                                                                                                                                        object: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'pathElement',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 127,
                                                                                                                                                    column: 41,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 127,
                                                                                                                                                    column: 52,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        property: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'setAttribute',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 127,
                                                                                                                                                    column: 53,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 127,
                                                                                                                                                    column: 65,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 127,
                                                                                                                                                column: 41,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 127,
                                                                                                                                                column: 65,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    arguments: [
                                                                                                                                        {
                                                                                                                                            type: 'Literal',
                                                                                                                                            value: 'd'
                                                                                                                                        },
                                                                                                                                        {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'path',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 127,
                                                                                                                                                    column: 71,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 127,
                                                                                                                                                    column: 75,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    ],
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 127,
                                                                                                                                            column: 41,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 127,
                                                                                                                                            column: 76,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 127,
                                                                                                                                    column: 36,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 127,
                                                                                                                                    column: 76,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                }
                                                                                                                            },
                                                                                                                            order: '4'
                                                                                                                        },
                                                                                                                        {
                                                                                                                            type: 'ExpressionStatement',
                                                                                                                            expression: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'pathElement',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 128,
                                                                                                                                        column: 36,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 128,
                                                                                                                                        column: 47,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 128,
                                                                                                                                    column: 36,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 128,
                                                                                                                                    column: 47,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                }
                                                                                                                            },
                                                                                                                            order: '5'
                                                                                                                        }
                                                                                                                    ]
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 118,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 130,
                                                                                                                        column: 36,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                    }
                                                                                                                },
                                                                                                                order: '@'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'VariableDeclaration',
                                                                                                                declarations: [{
                                                                                                                        type: 'VariableDeclarator',
                                                                                                                        id: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'arrowSize',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 130,
                                                                                                                                    column: 36,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 130,
                                                                                                                                    column: 45,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        init: {
                                                                                                                            type: 'Literal',
                                                                                                                            value: 18
                                                                                                                        }
                                                                                                                    }],
                                                                                                                kind: 'let',
                                                                                                                order: 'A'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'ExpressionStatement',
                                                                                                                expression: {
                                                                                                                    type: 'ObjectExpression',
                                                                                                                    objectType: {
                                                                                                                        type: 'CallExpression',
                                                                                                                        callee: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'Icon',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 131,
                                                                                                                                    column: 32,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 131,
                                                                                                                                    column: 36,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        arguments: [{
                                                                                                                                type: 'ObjectExpression',
                                                                                                                                properties: [
                                                                                                                                    {
                                                                                                                                        type: 'Property',
                                                                                                                                        key: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'name',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 131,
                                                                                                                                                    column: 38,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 131,
                                                                                                                                                    column: 42,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        value: {
                                                                                                                                            type: 'Literal',
                                                                                                                                            value: 'play arrow'
                                                                                                                                        },
                                                                                                                                        kind: 'init',
                                                                                                                                        order: '0'
                                                                                                                                    },
                                                                                                                                    {
                                                                                                                                        type: 'Property',
                                                                                                                                        key: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'size',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 131,
                                                                                                                                                    column: 56,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 131,
                                                                                                                                                    column: 60,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        value: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'arrowSize',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 131,
                                                                                                                                                    column: 61,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 131,
                                                                                                                                                    column: 70,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        kind: 'init',
                                                                                                                                        order: '1'
                                                                                                                                    }
                                                                                                                                ]
                                                                                                                            }],
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 131,
                                                                                                                                column: 32,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 131,
                                                                                                                                column: 72,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    properties: [{
                                                                                                                            type: 'Property',
                                                                                                                            key: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'style',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 132,
                                                                                                                                        column: 36,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 132,
                                                                                                                                        column: 41,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            value: {
                                                                                                                                type: 'ObjectExpression',
                                                                                                                                properties: [
                                                                                                                                    {
                                                                                                                                        type: 'Property',
                                                                                                                                        key: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'position',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 133,
                                                                                                                                                    column: 40,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 133,
                                                                                                                                                    column: 48,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        value: {
                                                                                                                                            type: 'Literal',
                                                                                                                                            value: 'absolute'
                                                                                                                                        },
                                                                                                                                        kind: 'init',
                                                                                                                                        order: '0'
                                                                                                                                    },
                                                                                                                                    {
                                                                                                                                        type: 'IfStatement',
                                                                                                                                        test: {
                                                                                                                                            type: 'BinaryExpression',
                                                                                                                                            operator: '===',
                                                                                                                                            left: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'xsign',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 134,
                                                                                                                                                        column: 43,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 134,
                                                                                                                                                        column: 48,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            right: {
                                                                                                                                                type: 'Literal',
                                                                                                                                                value: 0
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        consequent: {
                                                                                                                                            type: 'BlockStatement',
                                                                                                                                            body: [
                                                                                                                                                {
                                                                                                                                                    type: 'Property',
                                                                                                                                                    key: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'left',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 135,
                                                                                                                                                                column: 44,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 135,
                                                                                                                                                                column: 48,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    value: {
                                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                                        operator: '+',
                                                                                                                                                        left: {
                                                                                                                                                            type: 'BinaryExpression',
                                                                                                                                                            operator: '+',
                                                                                                                                                            left: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: ''
                                                                                                                                                            },
                                                                                                                                                            right: {
                                                                                                                                                                type: 'BinaryExpression',
                                                                                                                                                                operator: '-',
                                                                                                                                                                left: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'arrowX',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 135,
                                                                                                                                                                            column: 53,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 135,
                                                                                                                                                                            column: 59,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                right: {
                                                                                                                                                                    type: 'BinaryExpression',
                                                                                                                                                                    operator: '/',
                                                                                                                                                                    left: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'arrowSize',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 135,
                                                                                                                                                                                column: 62,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 135,
                                                                                                                                                                                column: 71,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    right: {
                                                                                                                                                                        type: 'Literal',
                                                                                                                                                                        value: 2
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        right: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: 'px'
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    kind: 'init',
                                                                                                                                                    order: '0'
                                                                                                                                                },
                                                                                                                                                {
                                                                                                                                                    type: 'IfStatement',
                                                                                                                                                    test: {
                                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                                        operator: '<',
                                                                                                                                                        left: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'ysign',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 136,
                                                                                                                                                                    column: 47,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 136,
                                                                                                                                                                    column: 52,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        right: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: 0
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    consequent: {
                                                                                                                                                        type: 'BlockStatement',
                                                                                                                                                        body: [{
                                                                                                                                                                type: 'Property',
                                                                                                                                                                key: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'top',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 137,
                                                                                                                                                                            column: 48,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 137,
                                                                                                                                                                            column: 51,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                value: {
                                                                                                                                                                    type: 'BinaryExpression',
                                                                                                                                                                    operator: '+',
                                                                                                                                                                    left: {
                                                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                                                        operator: '+',
                                                                                                                                                                        left: {
                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                            value: ''
                                                                                                                                                                        },
                                                                                                                                                                        right: {
                                                                                                                                                                            type: 'BinaryExpression',
                                                                                                                                                                            operator: '-',
                                                                                                                                                                            left: {
                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                name: 'arrowY',
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 137,
                                                                                                                                                                                        column: 56,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 137,
                                                                                                                                                                                        column: 62,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            right: {
                                                                                                                                                                                type: 'Literal',
                                                                                                                                                                                value: 4
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    right: {
                                                                                                                                                                        type: 'Literal',
                                                                                                                                                                        value: 'px'
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                kind: 'init',
                                                                                                                                                                order: '0'
                                                                                                                                                            }]
                                                                                                                                                    },
                                                                                                                                                    alternate: {
                                                                                                                                                        type: 'BlockStatement',
                                                                                                                                                        body: [{
                                                                                                                                                                type: 'Property',
                                                                                                                                                                key: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'top',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 139,
                                                                                                                                                                            column: 48,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 139,
                                                                                                                                                                            column: 51,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                value: {
                                                                                                                                                                    type: 'BinaryExpression',
                                                                                                                                                                    operator: '+',
                                                                                                                                                                    left: {
                                                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                                                        operator: '+',
                                                                                                                                                                        left: {
                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                            value: ''
                                                                                                                                                                        },
                                                                                                                                                                        right: {
                                                                                                                                                                            type: 'BinaryExpression',
                                                                                                                                                                            operator: '+',
                                                                                                                                                                            left: {
                                                                                                                                                                                type: 'BinaryExpression',
                                                                                                                                                                                operator: '-',
                                                                                                                                                                                left: {
                                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                                    name: 'arrowY',
                                                                                                                                                                                    loc: {
                                                                                                                                                                                        start: {
                                                                                                                                                                                            line: 139,
                                                                                                                                                                                            column: 56,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                                                        },
                                                                                                                                                                                        end: {
                                                                                                                                                                                            line: 139,
                                                                                                                                                                                            column: 62,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                                                        }
                                                                                                                                                                                    }
                                                                                                                                                                                },
                                                                                                                                                                                right: {
                                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                                    name: 'arrowSize',
                                                                                                                                                                                    loc: {
                                                                                                                                                                                        start: {
                                                                                                                                                                                            line: 139,
                                                                                                                                                                                            column: 65,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                                                        },
                                                                                                                                                                                        end: {
                                                                                                                                                                                            line: 139,
                                                                                                                                                                                            column: 74,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                                                        }
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            right: {
                                                                                                                                                                                type: 'Literal',
                                                                                                                                                                                value: 4
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    right: {
                                                                                                                                                                        type: 'Literal',
                                                                                                                                                                        value: 'px'
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                kind: 'init',
                                                                                                                                                                order: '0'
                                                                                                                                                            }]
                                                                                                                                                    },
                                                                                                                                                    order: '1'
                                                                                                                                                },
                                                                                                                                                {
                                                                                                                                                    type: 'Property',
                                                                                                                                                    key: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'transform',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 140,
                                                                                                                                                                column: 44,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 140,
                                                                                                                                                                column: 53,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    value: {
                                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                                        operator: '+',
                                                                                                                                                        left: {
                                                                                                                                                            type: 'BinaryExpression',
                                                                                                                                                            operator: '+',
                                                                                                                                                            left: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: 'rotateZ('
                                                                                                                                                            },
                                                                                                                                                            right: {
                                                                                                                                                                type: 'BinaryExpression',
                                                                                                                                                                operator: '*',
                                                                                                                                                                left: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'ysign',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 140,
                                                                                                                                                                            column: 66,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 140,
                                                                                                                                                                            column: 71,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                right: {
                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                    value: 90
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        right: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: 'deg)'
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    kind: 'init',
                                                                                                                                                    order: '2'
                                                                                                                                                }
                                                                                                                                            ]
                                                                                                                                        },
                                                                                                                                        alternate: {
                                                                                                                                            type: 'BlockStatement',
                                                                                                                                            body: [
                                                                                                                                                {
                                                                                                                                                    type: 'Property',
                                                                                                                                                    key: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'left',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 142,
                                                                                                                                                                column: 44,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 142,
                                                                                                                                                                column: 48,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    value: {
                                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                                        operator: '+',
                                                                                                                                                        left: {
                                                                                                                                                            type: 'BinaryExpression',
                                                                                                                                                            operator: '+',
                                                                                                                                                            left: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: ''
                                                                                                                                                            },
                                                                                                                                                            right: {
                                                                                                                                                                type: 'BinaryExpression',
                                                                                                                                                                operator: '+',
                                                                                                                                                                left: {
                                                                                                                                                                    type: 'BinaryExpression',
                                                                                                                                                                    operator: '-',
                                                                                                                                                                    left: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'arrowX',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 142,
                                                                                                                                                                                column: 53,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 142,
                                                                                                                                                                                column: 59,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    right: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'arrowSize',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 142,
                                                                                                                                                                                column: 62,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 142,
                                                                                                                                                                                column: 71,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                right: {
                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                    value: 4
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        right: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: 'px'
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    kind: 'init',
                                                                                                                                                    order: '0'
                                                                                                                                                },
                                                                                                                                                {
                                                                                                                                                    type: 'Property',
                                                                                                                                                    key: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'top',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 143,
                                                                                                                                                                column: 44,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 143,
                                                                                                                                                                column: 47,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    value: {
                                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                                        operator: '+',
                                                                                                                                                        left: {
                                                                                                                                                            type: 'BinaryExpression',
                                                                                                                                                            operator: '+',
                                                                                                                                                            left: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: ''
                                                                                                                                                            },
                                                                                                                                                            right: {
                                                                                                                                                                type: 'BinaryExpression',
                                                                                                                                                                operator: '-',
                                                                                                                                                                left: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'arrowY',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 143,
                                                                                                                                                                            column: 52,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 143,
                                                                                                                                                                            column: 58,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                right: {
                                                                                                                                                                    type: 'BinaryExpression',
                                                                                                                                                                    operator: '/',
                                                                                                                                                                    left: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'arrowSize',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 143,
                                                                                                                                                                                column: 61,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 143,
                                                                                                                                                                                column: 70,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    right: {
                                                                                                                                                                        type: 'Literal',
                                                                                                                                                                        value: 2
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        right: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: 'px'
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    kind: 'init',
                                                                                                                                                    order: '1'
                                                                                                                                                },
                                                                                                                                                {
                                                                                                                                                    type: 'Property',
                                                                                                                                                    key: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'transform',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 144,
                                                                                                                                                                column: 44,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 144,
                                                                                                                                                                column: 53,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    value: {
                                                                                                                                                        type: 'Literal',
                                                                                                                                                        value: 'rotateZ(0deg)'
                                                                                                                                                    },
                                                                                                                                                    kind: 'init',
                                                                                                                                                    order: '2'
                                                                                                                                                }
                                                                                                                                            ]
                                                                                                                                        },
                                                                                                                                        order: '1'
                                                                                                                                    },
                                                                                                                                    {
                                                                                                                                        type: 'Property',
                                                                                                                                        key: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'color',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 145,
                                                                                                                                                    column: 40,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 145,
                                                                                                                                                    column: 45,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        value: {
                                                                                                                                            type: 'MemberExpression',
                                                                                                                                            computed: false,
                                                                                                                                            object: {
                                                                                                                                                type: 'MemberExpression',
                                                                                                                                                computed: false,
                                                                                                                                                object: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'style',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 145,
                                                                                                                                                            column: 47,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 145,
                                                                                                                                                            column: 52,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                property: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'color',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 145,
                                                                                                                                                            column: 53,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 145,
                                                                                                                                                            column: 58,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 145,
                                                                                                                                                        column: 47,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 145,
                                                                                                                                                        column: 58,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            property: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'accent',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 145,
                                                                                                                                                        column: 59,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 145,
                                                                                                                                                        column: 65,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 145,
                                                                                                                                                    column: 47,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 145,
                                                                                                                                                    column: 65,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/GanttColumn.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        kind: 'init',
                                                                                                                                        order: '2'
                                                                                                                                    }
                                                                                                                                ]
                                                                                                                            },
                                                                                                                            kind: 'init',
                                                                                                                            order: '0'
                                                                                                                        }]
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 131,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 147,
                                                                                                                        column: 36,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/GanttColumn.ion'
                                                                                                                    }
                                                                                                                },
                                                                                                                order: 'B'
                                                                                                            }
                                                                                                        ]
                                                                                                    },
                                                                                                    alternate: null,
                                                                                                    order: '3'
                                                                                                }
                                                                                            ]
                                                                                        },
                                                                                        remove: null,
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            alternate: null,
                                                                            order: '2'
                                                                        }
                                                                    ]
                                                                },
                                                                remove: null,
                                                                order: '1'
                                                            }
                                                        ]
                                                    },
                                                    order: '4'
                                                }
                                            ],
                                            bound: false,
                                            name: {
                                                type: 'Identifier',
                                                name: 'createUnderlay',
                                                loc: {
                                                    start: {
                                                        line: 60,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'viewpath/html/GanttColumn.ion'
                                                    },
                                                    end: {
                                                        line: 60,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'viewpath/html/GanttColumn.ion'
                                                    }
                                                }
                                            },
                                            scope: {
                                                type: 'Identifier',
                                                name: '_ps'
                                            }
                                        }, {
                                            this: this,
                                            dataTableModel: dataTableModel,
                                            _ref8: _ref8,
                                            _ps: _ps,
                                            property: property,
                                            options: options,
                                            glass: glass,
                                            _ref: _ref,
                                            _ref2: _ref2,
                                            _ref3: _ref3,
                                            style: style,
                                            Icon: Icon,
                                            TimelineColumn: TimelineColumn,
                                            setVectorLength: setVectorLength,
                                            lerp: lerp,
                                            createCurvedPath: createCurvedPath
                                        }, _ps);
                                    });
                                }
                            },
                            kind: 'init',
                            order: '0'
                        }]
                },
                order: '2'
            }
        ],
        bound: false
    }, {
        this: this,
        ion: ion,
        property: property,
        options: options,
        glass: glass,
        _ref: _ref,
        _ref2: _ref2,
        _ref3: _ref3,
        style: style,
        Icon: Icon,
        TimelineColumn: TimelineColumn,
        setVectorLength: setVectorLength,
        lerp: lerp,
        createCurvedPath: createCurvedPath
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/GanttColumn',_viewpath_html_GanttColumn_);
    else
      _viewpath_html_GanttColumn_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_GanttColumn_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_InviteUserDialog_ = function(module,exports,require){'use strict';
var ion = require('ion');
var glass = require('glass');
var _ref = glass.html.forms;
var GlassForm = _ref.GlassForm;
var SubmitButton = _ref.SubmitButton;
var _ref2 = glass.html.material;
var Dialog = _ref2.Dialog;
var style = glass.html.style;
var _ref3 = require('../model');
var User = _ref3.User;
var _ref4 = glass.data;
var Key = _ref4.Key;
module.exports = exports = ion.template(function (_ref5) {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'model',
                            loc: {
                                start: {
                                    line: 8,
                                    column: 18,
                                    fixed: true,
                                    source: 'viewpath/html/InviteUserDialog.ion'
                                },
                                end: {
                                    line: 8,
                                    column: 23,
                                    fixed: true,
                                    source: 'viewpath/html/InviteUserDialog.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref5'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'model',
                                loc: {
                                    start: {
                                        line: 8,
                                        column: 18,
                                        fixed: true,
                                        source: 'viewpath/html/InviteUserDialog.ion'
                                    },
                                    end: {
                                        line: 8,
                                        column: 23,
                                        fixed: true,
                                        source: 'viewpath/html/InviteUserDialog.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'org',
                            loc: {
                                start: {
                                    line: 8,
                                    column: 24,
                                    fixed: true,
                                    source: 'viewpath/html/InviteUserDialog.ion'
                                },
                                end: {
                                    line: 8,
                                    column: 27,
                                    fixed: true,
                                    source: 'viewpath/html/InviteUserDialog.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref5'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'org',
                                loc: {
                                    start: {
                                        line: 8,
                                        column: 24,
                                        fixed: true,
                                        source: 'viewpath/html/InviteUserDialog.ion'
                                    },
                                    end: {
                                        line: 8,
                                        column: 27,
                                        fixed: true,
                                        source: 'viewpath/html/InviteUserDialog.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'callback',
                            loc: {
                                start: {
                                    line: 8,
                                    column: 28,
                                    fixed: true,
                                    source: 'viewpath/html/InviteUserDialog.ion'
                                },
                                end: {
                                    line: 8,
                                    column: 36,
                                    fixed: true,
                                    source: 'viewpath/html/InviteUserDialog.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref5'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'callback',
                                loc: {
                                    start: {
                                        line: 8,
                                        column: 28,
                                        fixed: true,
                                        source: 'viewpath/html/InviteUserDialog.ion'
                                    },
                                    end: {
                                        line: 8,
                                        column: 36,
                                        fixed: true,
                                        source: 'viewpath/html/InviteUserDialog.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'dialog',
                            loc: {
                                start: {
                                    line: 9,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/InviteUserDialog.ion'
                                },
                                end: {
                                    line: 9,
                                    column: 14,
                                    fixed: true,
                                    source: 'viewpath/html/InviteUserDialog.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Dialog',
                                    loc: {
                                        start: {
                                            line: 9,
                                            column: 17,
                                            fixed: true,
                                            source: 'viewpath/html/InviteUserDialog.ion'
                                        },
                                        end: {
                                            line: 9,
                                            column: 23,
                                            fixed: true,
                                            source: 'viewpath/html/InviteUserDialog.ion'
                                        }
                                    }
                                },
                                arguments: [],
                                loc: {
                                    start: {
                                        line: 9,
                                        column: 17,
                                        fixed: true,
                                        source: 'viewpath/html/InviteUserDialog.ion'
                                    },
                                    end: {
                                        line: 9,
                                        column: 25,
                                        fixed: true,
                                        source: 'viewpath/html/InviteUserDialog.ion'
                                    }
                                }
                            },
                            properties: [
                                {
                                    type: 'VariableDeclaration',
                                    declarations: [{
                                            type: 'VariableDeclarator',
                                            id: {
                                                type: 'Identifier',
                                                name: 'form',
                                                loc: {
                                                    start: {
                                                        line: 10,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                    },
                                                    end: {
                                                        line: 10,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                    }
                                                }
                                            },
                                            init: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'GlassForm',
                                                    loc: {
                                                        start: {
                                                            line: 10,
                                                            column: 19,
                                                            fixed: true,
                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                        },
                                                        end: {
                                                            line: 10,
                                                            column: 28,
                                                            fixed: true,
                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [{
                                                        type: 'ObjectExpression',
                                                        properties: [{
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'class',
                                                                    loc: {
                                                                        start: {
                                                                            line: 10,
                                                                            column: 30,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                        },
                                                                        end: {
                                                                            line: 10,
                                                                            column: 35,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: 'layout vertical flex'
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            }]
                                                    }],
                                                loc: {
                                                    start: {
                                                        line: 10,
                                                        column: 19,
                                                        fixed: true,
                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                    },
                                                    end: {
                                                        line: 10,
                                                        column: 60,
                                                        fixed: true,
                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                    }
                                                }
                                            }
                                        }],
                                    kind: 'let',
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'open',
                                        loc: {
                                            start: {
                                                line: 11,
                                                column: 8,
                                                fixed: true,
                                                source: 'viewpath/html/InviteUserDialog.ion'
                                            },
                                            end: {
                                                line: 11,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/InviteUserDialog.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: true
                                    },
                                    kind: 'init',
                                    order: '1'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'focus',
                                        loc: {
                                            start: {
                                                line: 12,
                                                column: 8,
                                                fixed: true,
                                                source: 'viewpath/html/InviteUserDialog.ion'
                                            },
                                            end: {
                                                line: 12,
                                                column: 13,
                                                fixed: true,
                                                source: 'viewpath/html/InviteUserDialog.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context) {
                                            return function () {
                                                var form = _context.get('form');
                                                return form.focus();
                                            };
                                        }
                                    },
                                    kind: 'init',
                                    order: '2'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'frame',
                                        loc: {
                                            start: {
                                                line: 13,
                                                column: 8,
                                                fixed: true,
                                                source: 'viewpath/html/InviteUserDialog.ion'
                                            },
                                            end: {
                                                line: 13,
                                                column: 13,
                                                fixed: true,
                                                source: 'viewpath/html/InviteUserDialog.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'style',
                                                    loc: {
                                                        start: {
                                                            line: 14,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                        },
                                                        end: {
                                                            line: 14,
                                                            column: 17,
                                                            fixed: true,
                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'ObjectExpression',
                                                    properties: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'minWidth',
                                                                loc: {
                                                                    start: {
                                                                        line: 15,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                                    },
                                                                    end: {
                                                                        line: 15,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Literal',
                                                                value: '450px'
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'ObjectExpression',
                                                    objectType: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'Identifier',
                                                            name: 'Header',
                                                            loc: {
                                                                start: {
                                                                    line: 16,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/InviteUserDialog.ion'
                                                                },
                                                                end: {
                                                                    line: 16,
                                                                    column: 18,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/InviteUserDialog.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [{
                                                                type: 'ObjectExpression',
                                                                properties: [{
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'class',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 16,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/InviteUserDialog.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 16,
                                                                                    column: 25,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/InviteUserDialog.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Literal',
                                                                            value: 'fixed'
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    }]
                                                            }],
                                                        loc: {
                                                            start: {
                                                                line: 16,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                            },
                                                            end: {
                                                                line: 16,
                                                                column: 35,
                                                                fixed: true,
                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                            }
                                                        }
                                                    },
                                                    properties: [{
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'Literal',
                                                                value: 'Invite a new User'
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 17,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/InviteUserDialog.ion'
                                                                },
                                                                end: {
                                                                    line: 17,
                                                                    column: 35,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/InviteUserDialog.ion'
                                                                }
                                                            },
                                                            order: '0'
                                                        }]
                                                },
                                                loc: {
                                                    start: {
                                                        line: 16,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                    },
                                                    end: {
                                                        line: 18,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                    }
                                                },
                                                order: '1'
                                            },
                                            {
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'ObjectExpression',
                                                    objectType: {
                                                        type: 'Identifier',
                                                        name: 'form',
                                                        loc: {
                                                            start: {
                                                                line: 18,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                            },
                                                            end: {
                                                                line: 18,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                            }
                                                        }
                                                    },
                                                    properties: [
                                                        {
                                                            type: 'VariableDeclaration',
                                                            declarations: [{
                                                                    type: 'VariableDeclarator',
                                                                    id: {
                                                                        type: 'Identifier',
                                                                        name: 'id',
                                                                        loc: {
                                                                            start: {
                                                                                line: 19,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 19,
                                                                                column: 22,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    init: {
                                                                        type: 'ObjectExpression',
                                                                        objectType: {
                                                                            type: 'CallExpression',
                                                                            callee: {
                                                                                type: 'Identifier',
                                                                                name: 'GoldEmailInput',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 19,
                                                                                        column: 25,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 19,
                                                                                        column: 39,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            arguments: [],
                                                                            loc: {
                                                                                start: {
                                                                                    line: 19,
                                                                                    column: 25,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/InviteUserDialog.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 19,
                                                                                    column: 41,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/InviteUserDialog.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        properties: [
                                                                            {
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'name',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 20,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 20,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Literal',
                                                                                    value: 'email'
                                                                                },
                                                                                kind: 'init',
                                                                                order: '0'
                                                                            },
                                                                            {
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'label',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 21,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 21,
                                                                                            column: 25,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Literal',
                                                                                    value: 'Email'
                                                                                },
                                                                                kind: 'init',
                                                                                order: '1'
                                                                            },
                                                                            {
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'required',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 22,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 22,
                                                                                            column: 28,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Literal',
                                                                                    value: true
                                                                                },
                                                                                kind: 'init',
                                                                                order: '2'
                                                                            }
                                                                        ]
                                                                    }
                                                                }],
                                                            kind: 'let',
                                                            order: '0'
                                                        },
                                                        {
                                                            type: 'VariableDeclaration',
                                                            declarations: [{
                                                                    type: 'VariableDeclarator',
                                                                    id: {
                                                                        type: 'Identifier',
                                                                        name: 'name',
                                                                        loc: {
                                                                            start: {
                                                                                line: 23,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 23,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    init: {
                                                                        type: 'ObjectExpression',
                                                                        objectType: {
                                                                            type: 'CallExpression',
                                                                            callee: {
                                                                                type: 'Identifier',
                                                                                name: 'PaperInput',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 23,
                                                                                        column: 27,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 23,
                                                                                        column: 37,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            arguments: [],
                                                                            loc: {
                                                                                start: {
                                                                                    line: 23,
                                                                                    column: 27,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/InviteUserDialog.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 23,
                                                                                    column: 39,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/InviteUserDialog.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        properties: [
                                                                            {
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'name',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 24,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 24,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Literal',
                                                                                    value: 'name'
                                                                                },
                                                                                kind: 'init',
                                                                                order: '0'
                                                                            },
                                                                            {
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'label',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 25,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 25,
                                                                                            column: 25,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Literal',
                                                                                    value: 'Name'
                                                                                },
                                                                                kind: 'init',
                                                                                order: '1'
                                                                            },
                                                                            {
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'required',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 26,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 26,
                                                                                            column: 28,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Literal',
                                                                                    value: true
                                                                                },
                                                                                kind: 'init',
                                                                                order: '2'
                                                                            }
                                                                        ]
                                                                    }
                                                                }],
                                                            kind: 'let',
                                                            order: '1'
                                                        },
                                                        {
                                                            type: 'VariableDeclaration',
                                                            declarations: [{
                                                                    type: 'VariableDeclarator',
                                                                    id: {
                                                                        type: 'Identifier',
                                                                        name: 'currentUserKey',
                                                                        loc: {
                                                                            start: {
                                                                                line: 27,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 27,
                                                                                column: 34,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    init: {
                                                                        type: 'NewExpression',
                                                                        callee: {
                                                                            type: 'Identifier',
                                                                            name: 'Key',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 27,
                                                                                    column: 41,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/InviteUserDialog.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 27,
                                                                                    column: 44,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/InviteUserDialog.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [
                                                                            {
                                                                                type: 'Identifier',
                                                                                name: 'User',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 27,
                                                                                        column: 45,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 27,
                                                                                        column: 49,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            {
                                                                                type: 'CallExpression',
                                                                                callee: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'id',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 27,
                                                                                                    column: 51,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 27,
                                                                                                    column: 53,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'value',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 27,
                                                                                                    column: 54,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 27,
                                                                                                    column: 59,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 27,
                                                                                                column: 51,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 27,
                                                                                                column: 59,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'toLowerCase',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 27,
                                                                                                column: 60,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 27,
                                                                                                column: 71,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 27,
                                                                                            column: 51,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 27,
                                                                                            column: 71,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                arguments: [],
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 27,
                                                                                        column: 51,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 27,
                                                                                        column: 73,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                                                    }
                                                                                }
                                                                            }
                                                                        ],
                                                                        loc: {
                                                                            start: {
                                                                                line: 27,
                                                                                column: 37,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 27,
                                                                                column: 74,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                            }
                                                                        }
                                                                    }
                                                                }],
                                                            kind: 'let',
                                                            order: '2'
                                                        },
                                                        {
                                                            type: 'VariableDeclaration',
                                                            declarations: [{
                                                                    type: 'VariableDeclarator',
                                                                    id: {
                                                                        type: 'Identifier',
                                                                        name: 'currentUser',
                                                                        loc: {
                                                                            start: {
                                                                                line: 28,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 28,
                                                                                column: 31,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    init: {
                                                                        type: 'ConditionalExpression',
                                                                        test: {
                                                                            type: 'BinaryExpression',
                                                                            operator: '&&',
                                                                            left: {
                                                                                type: 'UnaryExpression',
                                                                                operator: '?',
                                                                                argument: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'id',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 28,
                                                                                                column: 35,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 28,
                                                                                                column: 37,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'value',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 28,
                                                                                                column: 38,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 28,
                                                                                                column: 43,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 28,
                                                                                            column: 35,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 28,
                                                                                            column: 43,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                        }
                                                                                    }
                                                                                }
                                                                            },
                                                                            right: {
                                                                                type: 'BinaryExpression',
                                                                                operator: '!==',
                                                                                left: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'id',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 28,
                                                                                                column: 49,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 28,
                                                                                                column: 51,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'value',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 28,
                                                                                                column: 52,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 28,
                                                                                                column: 57,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 28,
                                                                                            column: 49,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 28,
                                                                                            column: 57,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                right: {
                                                                                    type: 'Literal',
                                                                                    value: ''
                                                                                }
                                                                            }
                                                                        },
                                                                        consequent: {
                                                                            type: 'MemberExpression',
                                                                            computed: true,
                                                                            object: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'Identifier',
                                                                                    name: 'model',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 28,
                                                                                            column: 69,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 28,
                                                                                            column: 74,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'server',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 28,
                                                                                            column: 75,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 28,
                                                                                            column: 81,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 28,
                                                                                        column: 69,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 28,
                                                                                        column: 81,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'currentUserKey',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 28,
                                                                                        column: 82,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 28,
                                                                                        column: 96,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 28,
                                                                                    column: 69,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/InviteUserDialog.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 28,
                                                                                    column: 97,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/InviteUserDialog.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        alternate: {
                                                                            type: 'Literal',
                                                                            value: null
                                                                        }
                                                                    }
                                                                }],
                                                            kind: 'let',
                                                            order: '3'
                                                        },
                                                        {
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'Function',
                                                                context: true,
                                                                value: function (_context2) {
                                                                    return function complete() {
                                                                        var Key = _context2.get('Key'), User = _context2.get('User'), currentUser = _context2.get('currentUser'), org = _context2.get('org'), dialog = _context2.get('dialog'), model = _context2.get('model'), callback = _context2.get('callback');
                                                                        var _ref6 = this.values;
                                                                        var email = _ref6.email;
                                                                        var name = _ref6.name;
                                                                        var message = _ref6.message;
                                                                        var key = new Key(User, email.toLowerCase()).toString();
                                                                        var newUser = currentUser != null ? currentUser : new User({
                                                                                name: name,
                                                                                email: email,
                                                                                key: key
                                                                            });
                                                                        newUser.addToOrg(org.getKey());
                                                                        dialog.open = false;
                                                                        model.invite({
                                                                            name: name,
                                                                            email: email,
                                                                            orgId: org.id,
                                                                            message: message,
                                                                            callback: function () {
                                                                                return callback(newUser);
                                                                            }
                                                                        });
                                                                    };
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 29,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/InviteUserDialog.ion'
                                                                },
                                                                end: {
                                                                    line: 36,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/InviteUserDialog.ion'
                                                                }
                                                            },
                                                            order: '4'
                                                        },
                                                        {
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'ObjectExpression',
                                                                objectType: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'Identifier',
                                                                        name: 'Section',
                                                                        loc: {
                                                                            start: {
                                                                                line: 36,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 36,
                                                                                column: 23,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [{
                                                                            type: 'ObjectExpression',
                                                                            properties: [{
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'class',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 36,
                                                                                                column: 25,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 36,
                                                                                                column: 30,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Literal',
                                                                                        value: 'fill'
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                }]
                                                                        }],
                                                                    loc: {
                                                                        start: {
                                                                            line: 36,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                        },
                                                                        end: {
                                                                            line: 36,
                                                                            column: 39,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                        }
                                                                    }
                                                                },
                                                                properties: [
                                                                    {
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'ObjectExpression',
                                                                            objectType: {
                                                                                type: 'CallExpression',
                                                                                callee: {
                                                                                    type: 'Identifier',
                                                                                    name: 'P',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 37,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 37,
                                                                                            column: 21,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                arguments: [],
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 37,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 37,
                                                                                        column: 23,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            properties: [
                                                                                {
                                                                                    type: 'VariableDeclaration',
                                                                                    declarations: [{
                                                                                            type: 'VariableDeclarator',
                                                                                            id: {
                                                                                                type: 'Identifier',
                                                                                                name: 'emailPattern',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 39,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 39,
                                                                                                        column: 40,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            init: {
                                                                                                type: 'NewExpression',
                                                                                                callee: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'RegExp',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 39,
                                                                                                            column: 47,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 39,
                                                                                                            column: 53,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                arguments: [{
                                                                                                        type: 'Literal',
                                                                                                        value: '[^/@]+@[^/@]+'
                                                                                                    }],
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 39,
                                                                                                        column: 43,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 39,
                                                                                                        column: 70,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        }],
                                                                                    kind: 'let',
                                                                                    order: '0'
                                                                                },
                                                                                {
                                                                                    type: 'IfStatement',
                                                                                    test: {
                                                                                        type: 'CallExpression',
                                                                                        callee: {
                                                                                            type: 'MemberExpression',
                                                                                            computed: false,
                                                                                            object: {
                                                                                                type: 'Identifier',
                                                                                                name: 'emailPattern',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 40,
                                                                                                        column: 27,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 40,
                                                                                                        column: 39,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            property: {
                                                                                                type: 'Identifier',
                                                                                                name: 'test',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 40,
                                                                                                        column: 40,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 40,
                                                                                                        column: 44,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 40,
                                                                                                    column: 27,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 40,
                                                                                                    column: 44,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        arguments: [{
                                                                                                type: 'MemberExpression',
                                                                                                computed: false,
                                                                                                object: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'id',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 40,
                                                                                                            column: 45,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 40,
                                                                                                            column: 47,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'value',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 40,
                                                                                                            column: 48,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 40,
                                                                                                            column: 53,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 40,
                                                                                                        column: 45,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 40,
                                                                                                        column: 53,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                    }
                                                                                                }
                                                                                            }],
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 40,
                                                                                                column: 27,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 40,
                                                                                                column: 54,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    consequent: {
                                                                                        type: 'BlockStatement',
                                                                                        body: [{
                                                                                                type: 'IfStatement',
                                                                                                test: {
                                                                                                    type: 'BinaryExpression',
                                                                                                    operator: '===',
                                                                                                    left: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'currentUser',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 41,
                                                                                                                column: 31,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 41,
                                                                                                                column: 42,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    right: {
                                                                                                        type: 'Literal',
                                                                                                        value: null
                                                                                                    }
                                                                                                },
                                                                                                consequent: {
                                                                                                    type: 'BlockStatement',
                                                                                                    body: [{
                                                                                                            type: 'ExpressionStatement',
                                                                                                            expression: {
                                                                                                                type: 'ObjectExpression',
                                                                                                                objectType: {
                                                                                                                    type: 'CallExpression',
                                                                                                                    callee: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'Span',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 42,
                                                                                                                                column: 32,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 42,
                                                                                                                                column: 36,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    arguments: [],
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 42,
                                                                                                                            column: 32,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 42,
                                                                                                                            column: 38,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                properties: [{
                                                                                                                        type: 'ExpressionStatement',
                                                                                                                        expression: {
                                                                                                                            type: 'BinaryExpression',
                                                                                                                            operator: '+',
                                                                                                                            left: {
                                                                                                                                type: 'BinaryExpression',
                                                                                                                                operator: '+',
                                                                                                                                left: {
                                                                                                                                    type: 'Literal',
                                                                                                                                    value: '\''
                                                                                                                                },
                                                                                                                                right: {
                                                                                                                                    type: 'MemberExpression',
                                                                                                                                    computed: false,
                                                                                                                                    object: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'id',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 43,
                                                                                                                                                column: 40,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 43,
                                                                                                                                                column: 42,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    property: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'value',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 43,
                                                                                                                                                column: 43,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 43,
                                                                                                                                                column: 48,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 43,
                                                                                                                                            column: 40,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 43,
                                                                                                                                            column: 48,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            right: {
                                                                                                                                type: 'Literal',
                                                                                                                                value: '\' is a new user.'
                                                                                                                            }
                                                                                                                        },
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 43,
                                                                                                                                column: 36,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 43,
                                                                                                                                column: 67,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                            }
                                                                                                                        },
                                                                                                                        order: '0'
                                                                                                                    }]
                                                                                                            },
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 42,
                                                                                                                    column: 32,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 44,
                                                                                                                    column: 36,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                }
                                                                                                            },
                                                                                                            order: '0'
                                                                                                        }]
                                                                                                },
                                                                                                alternate: {
                                                                                                    type: 'IfStatement',
                                                                                                    test: {
                                                                                                        type: 'BinaryExpression',
                                                                                                        operator: '===',
                                                                                                        left: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'currentUser',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 44,
                                                                                                                    column: 36,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 44,
                                                                                                                    column: 47,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        right: {
                                                                                                            type: 'UnaryExpression',
                                                                                                            operator: 'void',
                                                                                                            prefix: true,
                                                                                                            argument: {
                                                                                                                type: 'Literal',
                                                                                                                value: 0
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    consequent: {
                                                                                                        type: 'BlockStatement',
                                                                                                        body: [{
                                                                                                                type: 'ExpressionStatement',
                                                                                                                expression: {
                                                                                                                    type: 'ObjectExpression',
                                                                                                                    objectType: {
                                                                                                                        type: 'CallExpression',
                                                                                                                        callee: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'Span',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 45,
                                                                                                                                    column: 32,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 45,
                                                                                                                                    column: 36,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        arguments: [],
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 45,
                                                                                                                                column: 32,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 45,
                                                                                                                                column: 38,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    properties: [{
                                                                                                                            type: 'ExpressionStatement',
                                                                                                                            expression: {
                                                                                                                                type: 'BinaryExpression',
                                                                                                                                operator: '+',
                                                                                                                                left: {
                                                                                                                                    type: 'BinaryExpression',
                                                                                                                                    operator: '+',
                                                                                                                                    left: {
                                                                                                                                        type: 'Literal',
                                                                                                                                        value: 'Checking if \''
                                                                                                                                    },
                                                                                                                                    right: {
                                                                                                                                        type: 'MemberExpression',
                                                                                                                                        computed: false,
                                                                                                                                        object: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'id',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 46,
                                                                                                                                                    column: 52,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 46,
                                                                                                                                                    column: 54,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        property: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'value',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 46,
                                                                                                                                                    column: 55,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 46,
                                                                                                                                                    column: 60,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 46,
                                                                                                                                                column: 52,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 46,
                                                                                                                                                column: 60,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                right: {
                                                                                                                                    type: 'Literal',
                                                                                                                                    value: '\'\' exists...'
                                                                                                                                }
                                                                                                                            },
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 46,
                                                                                                                                    column: 36,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 46,
                                                                                                                                    column: 75,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                                }
                                                                                                                            },
                                                                                                                            order: '0'
                                                                                                                        }]
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 45,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 47,
                                                                                                                        column: 36,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                    }
                                                                                                                },
                                                                                                                order: '0'
                                                                                                            }]
                                                                                                    },
                                                                                                    alternate: {
                                                                                                        type: 'IfStatement',
                                                                                                        test: {
                                                                                                            type: 'UnaryExpression',
                                                                                                            operator: '?',
                                                                                                            argument: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'currentUser',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 47,
                                                                                                                        column: 36,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 47,
                                                                                                                        column: 47,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        consequent: {
                                                                                                            type: 'BlockStatement',
                                                                                                            body: [
                                                                                                                {
                                                                                                                    type: 'ExpressionStatement',
                                                                                                                    expression: {
                                                                                                                        type: 'CallExpression',
                                                                                                                        callee: {
                                                                                                                            type: 'Function',
                                                                                                                            context: true,
                                                                                                                            value: function (_context3) {
                                                                                                                                return function () {
                                                                                                                                    var currentUser = _context3.get('currentUser'), name = _context3.get('name');
                                                                                                                                    if (currentUser.name != null) {
                                                                                                                                        name.updateValueAndPreserveCaret(currentUser.name);
                                                                                                                                    }
                                                                                                                                };
                                                                                                                            }
                                                                                                                        },
                                                                                                                        arguments: [],
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 48,
                                                                                                                                column: 32,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 52,
                                                                                                                                column: 36,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 48,
                                                                                                                            column: 32,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 52,
                                                                                                                            column: 36,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                        }
                                                                                                                    },
                                                                                                                    order: '0'
                                                                                                                },
                                                                                                                {
                                                                                                                    type: 'ExpressionStatement',
                                                                                                                    expression: {
                                                                                                                        type: 'ObjectExpression',
                                                                                                                        objectType: {
                                                                                                                            type: 'CallExpression',
                                                                                                                            callee: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'Span',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 52,
                                                                                                                                        column: 32,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 52,
                                                                                                                                        column: 36,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            arguments: [],
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 52,
                                                                                                                                    column: 32,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 52,
                                                                                                                                    column: 38,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        properties: [{
                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                expression: {
                                                                                                                                    type: 'BinaryExpression',
                                                                                                                                    operator: '+',
                                                                                                                                    left: {
                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                        operator: '+',
                                                                                                                                        left: {
                                                                                                                                            type: 'Literal',
                                                                                                                                            value: '\''
                                                                                                                                        },
                                                                                                                                        right: {
                                                                                                                                            type: 'MemberExpression',
                                                                                                                                            computed: false,
                                                                                                                                            object: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'id',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 53,
                                                                                                                                                        column: 40,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 53,
                                                                                                                                                        column: 42,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            property: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'value',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 53,
                                                                                                                                                        column: 43,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 53,
                                                                                                                                                        column: 48,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 53,
                                                                                                                                                    column: 40,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 53,
                                                                                                                                                    column: 48,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    right: {
                                                                                                                                        type: 'Literal',
                                                                                                                                        value: '\' is an existing user.'
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 53,
                                                                                                                                        column: 36,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 53,
                                                                                                                                        column: 73,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                order: '0'
                                                                                                                            }]
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 52,
                                                                                                                            column: 32,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 54,
                                                                                                                            column: 36,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                                        }
                                                                                                                    },
                                                                                                                    order: '1'
                                                                                                                }
                                                                                                            ]
                                                                                                        },
                                                                                                        alternate: null
                                                                                                    }
                                                                                                },
                                                                                                order: '0'
                                                                                            }]
                                                                                    },
                                                                                    alternate: null,
                                                                                    order: '1'
                                                                                }
                                                                            ]
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 37,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 54,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                            }
                                                                        },
                                                                        order: '0'
                                                                    },
                                                                    {
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'Identifier',
                                                                            name: 'id',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 54,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/InviteUserDialog.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 54,
                                                                                    column: 22,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/InviteUserDialog.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 54,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 54,
                                                                                column: 22,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                            }
                                                                        },
                                                                        order: '1'
                                                                    },
                                                                    {
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'Identifier',
                                                                            name: 'name',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 55,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/InviteUserDialog.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 55,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/InviteUserDialog.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 55,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 55,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                            }
                                                                        },
                                                                        order: '2'
                                                                    },
                                                                    {
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'ObjectExpression',
                                                                            objectType: {
                                                                                type: 'CallExpression',
                                                                                callee: {
                                                                                    type: 'Identifier',
                                                                                    name: 'PaperInput',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 56,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 56,
                                                                                            column: 30,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                arguments: [],
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 56,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 56,
                                                                                        column: 32,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            properties: [
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'name',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 57,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 57,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Literal',
                                                                                        value: 'message'
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'label',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 58,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 58,
                                                                                                column: 29,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Literal',
                                                                                        value: 'Message'
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '1'
                                                                                }
                                                                            ]
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 56,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 59,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                            }
                                                                        },
                                                                        order: '3'
                                                                    }
                                                                ]
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 36,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/InviteUserDialog.ion'
                                                                },
                                                                end: {
                                                                    line: 59,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/InviteUserDialog.ion'
                                                                }
                                                            },
                                                            order: '5'
                                                        },
                                                        {
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'ObjectExpression',
                                                                objectType: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'Identifier',
                                                                        name: 'Footer',
                                                                        loc: {
                                                                            start: {
                                                                                line: 59,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 59,
                                                                                column: 22,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [{
                                                                            type: 'ObjectExpression',
                                                                            properties: [{
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'class',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 59,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 59,
                                                                                                column: 29,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Literal',
                                                                                        value: 'layout horizontal'
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                }]
                                                                        }],
                                                                    loc: {
                                                                        start: {
                                                                            line: 59,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                        },
                                                                        end: {
                                                                            line: 59,
                                                                            column: 51,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                        }
                                                                    }
                                                                },
                                                                properties: [
                                                                    {
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'CallExpression',
                                                                            callee: {
                                                                                type: 'Identifier',
                                                                                name: 'Div',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 60,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 60,
                                                                                        column: 23,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            arguments: [{
                                                                                    type: 'ObjectExpression',
                                                                                    properties: [{
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'class',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 60,
                                                                                                        column: 25,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 60,
                                                                                                        column: 30,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'Literal',
                                                                                                value: 'flex'
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '0'
                                                                                        }]
                                                                                }],
                                                                            loc: {
                                                                                start: {
                                                                                    line: 60,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/InviteUserDialog.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 60,
                                                                                    column: 39,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/InviteUserDialog.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 60,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 60,
                                                                                column: 39,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                            }
                                                                        },
                                                                        order: '0'
                                                                    },
                                                                    {
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'ObjectExpression',
                                                                            objectType: {
                                                                                type: 'CallExpression',
                                                                                callee: {
                                                                                    type: 'Identifier',
                                                                                    name: 'SubmitButton',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 61,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 61,
                                                                                            column: 32,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                arguments: [],
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 61,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 61,
                                                                                        column: 34,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            properties: [{
                                                                                    type: 'ExpressionStatement',
                                                                                    expression: {
                                                                                        type: 'Literal',
                                                                                        value: 'Invite'
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 62,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 62,
                                                                                            column: 32,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                        }
                                                                                    },
                                                                                    order: '0'
                                                                                }]
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 61,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 63,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                            }
                                                                        },
                                                                        order: '1'
                                                                    },
                                                                    {
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'ObjectExpression',
                                                                            objectType: {
                                                                                type: 'CallExpression',
                                                                                callee: {
                                                                                    type: 'Identifier',
                                                                                    name: 'PaperButton',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 63,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 63,
                                                                                            column: 31,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                arguments: [{
                                                                                        type: 'ObjectExpression',
                                                                                        properties: []
                                                                                    }],
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 63,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 63,
                                                                                        column: 35,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            properties: [
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'raised',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 64,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 64,
                                                                                                column: 30,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Literal',
                                                                                        value: true
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                },
                                                                                {
                                                                                    type: 'ExpressionStatement',
                                                                                    expression: {
                                                                                        type: 'Function',
                                                                                        context: true,
                                                                                        value: function (_context4) {
                                                                                            return function click(e) {
                                                                                                var dialog = _context4.get('dialog');
                                                                                                dialog.open = false;
                                                                                            };
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 65,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 67,
                                                                                            column: 28,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                        }
                                                                                    },
                                                                                    order: '1'
                                                                                },
                                                                                {
                                                                                    type: 'ExpressionStatement',
                                                                                    expression: {
                                                                                        type: 'Literal',
                                                                                        value: 'Cancel'
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 67,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 67,
                                                                                            column: 32,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/InviteUserDialog.ion'
                                                                                        }
                                                                                    },
                                                                                    order: '2'
                                                                                }
                                                                            ]
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 63,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 68,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/InviteUserDialog.ion'
                                                                            }
                                                                        },
                                                                        order: '2'
                                                                    }
                                                                ]
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 59,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/InviteUserDialog.ion'
                                                                },
                                                                end: {
                                                                    line: 68,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/InviteUserDialog.ion'
                                                                }
                                                            },
                                                            order: '6'
                                                        }
                                                    ]
                                                },
                                                loc: {
                                                    start: {
                                                        line: 18,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                    },
                                                    end: {
                                                        line: 68,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'viewpath/html/InviteUserDialog.ion'
                                                    }
                                                },
                                                order: '2'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    order: '3'
                                }
                            ]
                        }
                    }],
                kind: 'let',
                order: '3'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'Identifier',
                    name: 'dialog',
                    loc: {
                        start: {
                            line: 68,
                            column: 11,
                            fixed: true,
                            source: 'viewpath/html/InviteUserDialog.ion'
                        },
                        end: {
                            line: 68,
                            column: 17,
                            fixed: true,
                            source: 'viewpath/html/InviteUserDialog.ion'
                        }
                    }
                },
                order: '4'
            }
        ],
        bound: false
    }, {
        this: this,
        _ref5: _ref5,
        glass: glass,
        _ref: _ref,
        GlassForm: GlassForm,
        SubmitButton: SubmitButton,
        _ref2: _ref2,
        Dialog: Dialog,
        style: style,
        _ref3: _ref3,
        User: User,
        _ref4: _ref4,
        Key: Key
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/InviteUserDialog',_viewpath_html_InviteUserDialog_);
    else
      _viewpath_html_InviteUserDialog_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_InviteUserDialog_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_Item_ = function(module,exports,require){'use strict';
var ion = require('ion');
var glass = require('glass'), _ref, _ref2, _ref3;
_ref = glass.html;
var style = _ref.style;
_ref2 = glass.html.material;
var Checkbox = _ref2.Checkbox;
var List = _ref2.List;
var Icon = _ref2.Icon;
var Field = _ref2.Field;
var Img = _ref2.Img;
_ref3 = require('../model');
var Project = _ref3.Project;
var Task = _ref3.Task;
var User = _ref3.User;
var _ref4 = style.sheets;
_ref4[module.id] = '.item {\n    position:relative;\n}\n.item .notification {\n    background-color: #E42323;\n    color: white;\n    height: 18px;\n    width: 18px;\n    border-radius: 50%;\n    text-align: center;\n    font-size: 12px;\n    line-height: 18px;\n    right: 10px;\n    flex: none;\n    position: absolute;\n    font-weight: 500;\n    top: 50%;\n    margin-top: -9px;\n}';
_ref4;
module.exports = exports = ion.template(function () {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [{
                type: 'ReturnStatement',
                argument: {
                    type: 'CallExpression',
                    callee: {
                        type: 'Identifier',
                        name: 'Div',
                        loc: {
                            start: {
                                line: 31,
                                column: 11,
                                fixed: true,
                                source: 'viewpath/html/Item.ion'
                            },
                            end: {
                                line: 31,
                                column: 14,
                                fixed: true,
                                source: 'viewpath/html/Item.ion'
                            }
                        }
                    },
                    arguments: [],
                    loc: {
                        start: {
                            line: 31,
                            column: 11,
                            fixed: true,
                            source: 'viewpath/html/Item.ion'
                        },
                        end: {
                            line: 31,
                            column: 16,
                            fixed: true,
                            source: 'viewpath/html/Item.ion'
                        }
                    }
                },
                order: '0'
            }],
        bound: false
    }, {
        this: this,
        glass: glass,
        _ref: _ref,
        _ref2: _ref2,
        _ref3: _ref3,
        style: style,
        Checkbox: Checkbox,
        List: List,
        Icon: Icon,
        Field: Field,
        Img: Img,
        Project: Project,
        Task: Task,
        User: User,
        _ref4: _ref4
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/Item',_viewpath_html_Item_);
    else
      _viewpath_html_Item_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_Item_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_Items_ = function(module,exports,require){'use strict';
var ion = require('ion');
var glass = require('glass'), _ref, _ref2, _ref3, _ref4;
_ref = glass.html;
var style = _ref.style;
_ref2 = glass.html.material;
var Checkbox = _ref2.Checkbox;
var List = _ref2.List;
var Icon = _ref2.Icon;
var Field = _ref2.Field;
var Img = _ref2.Img;
var Button = _ref2.Button;
var ButtonGroup = _ref2.ButtonGroup;
_ref3 = require('../model');
var Project = _ref3.Project;
var Task = _ref3.Task;
var Comment = _ref3.Comment;
var User = _ref3.User;
_ref4 = require('./');
var ItemsDisplayToggle = _ref4.ItemsDisplayToggle;
var TaskItem = _ref4.TaskItem;
var CommentItem = _ref4.CommentItem;
var _ref6 = style.sheets;
_ref6[module.id] = '.items.display {\n    position:relative;\n}\n\n.items.display.module ul{\n    display:flex;\n    flex-wrap:wrap;\n}\n\n.items.display.module .item{\n    flex-basis: 300px;\n    flex-shrink:20;\n    flex-grow: 50;\n    margin-right:20px;\n    margin-bottom:20px;\n    padding:24px;\n    font-size:14px;\n    font-weight:400;\n    position:relative;\n}\n\n\n.items.display.list h2.heading{\n    font-size:16px;\n    font-weight:400;\n    margin:0 0 8px 0;\n}\n\n.items.display.list .subheading{\n    font-size:14px;\n    font-weight:400;\n    margin:0;\n}\n\n.items.display.module h2.heading{\n    font-size:20px;\n    font-weight:400;\n    margin:0;\n}\n\n.items.display.module .subheading{\n    font-size:14px;\n    font-weight:400;\n    margin:0;\n    opacity:.7;\n}\n\n.items.display ul {\n    list-style:none;\n}\n\n.items.display.list ul {\n    margin:0;\n    padding:0;\n    transition:margin-right 200ms;\n}\n\n.items.display .controls {\n    display: flex;\n    margin: 10px 20px;\n}\n.controls h2 {\n    font-size:16px;\n    line-height:16px;\n    flex:1;\n}\n\n.controls > .Icon > svg {\n    padding:3px;\n}\n\n.items.display.list .item {\n    cursor:pointer;\n    padding: 20px;\n    border-radius: 2px;\n    box-shadow: 0 0 1px 2px rgba(0,0,0,.02);\n    font-size: 14px;\n    display:flex;\n}\n\n.items.display .item {\n    background-color: white;\n}\n\n.items.display .item:hover {\n    background-color: rgba(139,195,74,0.085);\n}\n\n.items.display .item.selected {\n    border-left: 4px solid rgba(139,195,74,.65);\n    padding-left: ' + (style.contentPadding - 4) + 'px;\n    background-color: rgba(139,195,74,0.05);\n}\n\n.items.display.list .item > .Icon {\n    margin-right:10px;\n}';
_ref6;
module.exports = exports = ion.template(function (_ref5) {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'items',
                            loc: {
                                start: {
                                    line: 113,
                                    column: 18,
                                    fixed: true,
                                    source: 'viewpath/html/Items.ion'
                                },
                                end: {
                                    line: 113,
                                    column: 23,
                                    fixed: true,
                                    source: 'viewpath/html/Items.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref5'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'items',
                                loc: {
                                    start: {
                                        line: 113,
                                        column: 18,
                                        fixed: true,
                                        source: 'viewpath/html/Items.ion'
                                    },
                                    end: {
                                        line: 113,
                                        column: 23,
                                        fixed: true,
                                        source: 'viewpath/html/Items.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'config',
                            loc: {
                                start: {
                                    line: 113,
                                    column: 25,
                                    fixed: true,
                                    source: 'viewpath/html/Items.ion'
                                },
                                end: {
                                    line: 113,
                                    column: 31,
                                    fixed: true,
                                    source: 'viewpath/html/Items.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref5'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'config',
                                loc: {
                                    start: {
                                        line: 113,
                                        column: 25,
                                        fixed: true,
                                        source: 'viewpath/html/Items.ion'
                                    },
                                    end: {
                                        line: 113,
                                        column: 31,
                                        fixed: true,
                                        source: 'viewpath/html/Items.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'header',
                            loc: {
                                start: {
                                    line: 113,
                                    column: 33,
                                    fixed: true,
                                    source: 'viewpath/html/Items.ion'
                                },
                                end: {
                                    line: 113,
                                    column: 39,
                                    fixed: true,
                                    source: 'viewpath/html/Items.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref5'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'header',
                                loc: {
                                    start: {
                                        line: 113,
                                        column: 33,
                                        fixed: true,
                                        source: 'viewpath/html/Items.ion'
                                    },
                                    end: {
                                        line: 113,
                                        column: 39,
                                        fixed: true,
                                        source: 'viewpath/html/Items.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'state',
                            loc: {
                                start: {
                                    line: 114,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/Items.ion'
                                },
                                end: {
                                    line: 114,
                                    column: 13,
                                    fixed: true,
                                    source: 'viewpath/html/Items.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'ObjectExpression',
                                properties: []
                            },
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'view',
                                        loc: {
                                            start: {
                                                line: 115,
                                                column: 8,
                                                fixed: true,
                                                source: 'viewpath/html/Items.ion'
                                            },
                                            end: {
                                                line: 115,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/Items.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: 'list'
                                    },
                                    kind: 'init',
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'selectedItem',
                                        loc: {
                                            start: {
                                                line: 116,
                                                column: 8,
                                                fixed: true,
                                                source: 'viewpath/html/Items.ion'
                                            },
                                            end: {
                                                line: 116,
                                                column: 20,
                                                fixed: true,
                                                source: 'viewpath/html/Items.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: null
                                    },
                                    kind: 'init',
                                    order: '1'
                                },
                                {
                                    type: 'IfStatement',
                                    test: {
                                        type: 'UnaryExpression',
                                        operator: '?',
                                        argument: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'config',
                                                loc: {
                                                    start: {
                                                        line: 117,
                                                        column: 11,
                                                        fixed: true,
                                                        source: 'viewpath/html/Items.ion'
                                                    },
                                                    end: {
                                                        line: 117,
                                                        column: 17,
                                                        fixed: true,
                                                        source: 'viewpath/html/Items.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'showToggle',
                                                loc: {
                                                    start: {
                                                        line: 117,
                                                        column: 19,
                                                        fixed: true,
                                                        source: 'viewpath/html/Items.ion'
                                                    },
                                                    end: {
                                                        line: 117,
                                                        column: 29,
                                                        fixed: true,
                                                        source: 'viewpath/html/Items.ion'
                                                    }
                                                }
                                            },
                                            existential: true,
                                            loc: {
                                                start: {
                                                    line: 117,
                                                    column: 11,
                                                    fixed: true,
                                                    source: 'viewpath/html/Items.ion'
                                                },
                                                end: {
                                                    line: 117,
                                                    column: 29,
                                                    fixed: true,
                                                    source: 'viewpath/html/Items.ion'
                                                }
                                            }
                                        }
                                    },
                                    consequent: {
                                        type: 'BlockStatement',
                                        body: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'showToggle',
                                                    loc: {
                                                        start: {
                                                            line: 118,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/Items.ion'
                                                        },
                                                        end: {
                                                            line: 118,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'viewpath/html/Items.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'config',
                                                        loc: {
                                                            start: {
                                                                line: 118,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'viewpath/html/Items.ion'
                                                            },
                                                            end: {
                                                                line: 118,
                                                                column: 30,
                                                                fixed: true,
                                                                source: 'viewpath/html/Items.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'showToggle',
                                                        loc: {
                                                            start: {
                                                                line: 118,
                                                                column: 31,
                                                                fixed: true,
                                                                source: 'viewpath/html/Items.ion'
                                                            },
                                                            end: {
                                                                line: 118,
                                                                column: 41,
                                                                fixed: true,
                                                                source: 'viewpath/html/Items.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 118,
                                                            column: 24,
                                                            fixed: true,
                                                            source: 'viewpath/html/Items.ion'
                                                        },
                                                        end: {
                                                            line: 118,
                                                            column: 41,
                                                            fixed: true,
                                                            source: 'viewpath/html/Items.ion'
                                                        }
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    },
                                    alternate: {
                                        type: 'BlockStatement',
                                        body: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'showToggle',
                                                    loc: {
                                                        start: {
                                                            line: 120,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/Items.ion'
                                                        },
                                                        end: {
                                                            line: 120,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'viewpath/html/Items.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: false
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    },
                                    order: '2'
                                },
                                {
                                    type: 'IfStatement',
                                    test: {
                                        type: 'UnaryExpression',
                                        operator: '?',
                                        argument: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'config',
                                                loc: {
                                                    start: {
                                                        line: 121,
                                                        column: 11,
                                                        fixed: true,
                                                        source: 'viewpath/html/Items.ion'
                                                    },
                                                    end: {
                                                        line: 121,
                                                        column: 17,
                                                        fixed: true,
                                                        source: 'viewpath/html/Items.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'scrollTo',
                                                loc: {
                                                    start: {
                                                        line: 121,
                                                        column: 19,
                                                        fixed: true,
                                                        source: 'viewpath/html/Items.ion'
                                                    },
                                                    end: {
                                                        line: 121,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'viewpath/html/Items.ion'
                                                    }
                                                }
                                            },
                                            existential: true,
                                            loc: {
                                                start: {
                                                    line: 121,
                                                    column: 11,
                                                    fixed: true,
                                                    source: 'viewpath/html/Items.ion'
                                                },
                                                end: {
                                                    line: 121,
                                                    column: 27,
                                                    fixed: true,
                                                    source: 'viewpath/html/Items.ion'
                                                }
                                            }
                                        }
                                    },
                                    consequent: {
                                        type: 'BlockStatement',
                                        body: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'scrollTo',
                                                    loc: {
                                                        start: {
                                                            line: 122,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/Items.ion'
                                                        },
                                                        end: {
                                                            line: 122,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'viewpath/html/Items.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'config',
                                                        loc: {
                                                            start: {
                                                                line: 122,
                                                                column: 22,
                                                                fixed: true,
                                                                source: 'viewpath/html/Items.ion'
                                                            },
                                                            end: {
                                                                line: 122,
                                                                column: 28,
                                                                fixed: true,
                                                                source: 'viewpath/html/Items.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'scrollTo',
                                                        loc: {
                                                            start: {
                                                                line: 122,
                                                                column: 29,
                                                                fixed: true,
                                                                source: 'viewpath/html/Items.ion'
                                                            },
                                                            end: {
                                                                line: 122,
                                                                column: 37,
                                                                fixed: true,
                                                                source: 'viewpath/html/Items.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 122,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'viewpath/html/Items.ion'
                                                        },
                                                        end: {
                                                            line: 122,
                                                            column: 37,
                                                            fixed: true,
                                                            source: 'viewpath/html/Items.ion'
                                                        }
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    },
                                    alternate: null,
                                    order: '3'
                                }
                            ]
                        }
                    }],
                kind: 'let',
                order: '3'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'element',
                            loc: {
                                start: {
                                    line: 123,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/Items.ion'
                                },
                                end: {
                                    line: 123,
                                    column: 15,
                                    fixed: true,
                                    source: 'viewpath/html/Items.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Div',
                                loc: {
                                    start: {
                                        line: 123,
                                        column: 18,
                                        fixed: true,
                                        source: 'viewpath/html/Items.ion'
                                    },
                                    end: {
                                        line: 123,
                                        column: 21,
                                        fixed: true,
                                        source: 'viewpath/html/Items.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ObjectExpression',
                                    properties: [{
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'class',
                                                loc: {
                                                    start: {
                                                        line: 123,
                                                        column: 23,
                                                        fixed: true,
                                                        source: 'viewpath/html/Items.ion'
                                                    },
                                                    end: {
                                                        line: 123,
                                                        column: 28,
                                                        fixed: true,
                                                        source: 'viewpath/html/Items.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: 'items display'
                                            },
                                            kind: 'init',
                                            order: '0'
                                        }]
                                }],
                            loc: {
                                start: {
                                    line: 123,
                                    column: 18,
                                    fixed: true,
                                    source: 'viewpath/html/Items.ion'
                                },
                                end: {
                                    line: 123,
                                    column: 46,
                                    fixed: true,
                                    source: 'viewpath/html/Items.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '4'
            },
            {
                type: 'IfStatement',
                test: {
                    type: 'UnaryExpression',
                    operator: '?',
                    argument: {
                        type: 'Identifier',
                        name: 'items',
                        loc: {
                            start: {
                                line: 124,
                                column: 7,
                                fixed: true,
                                source: 'viewpath/html/Items.ion'
                            },
                            end: {
                                line: 124,
                                column: 12,
                                fixed: true,
                                source: 'viewpath/html/Items.ion'
                            }
                        }
                    }
                },
                consequent: {
                    type: 'BlockStatement',
                    body: [{
                            type: 'ReturnStatement',
                            argument: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'Identifier',
                                    name: 'element',
                                    loc: {
                                        start: {
                                            line: 125,
                                            column: 15,
                                            fixed: true,
                                            source: 'viewpath/html/Items.ion'
                                        },
                                        end: {
                                            line: 125,
                                            column: 22,
                                            fixed: true,
                                            source: 'viewpath/html/Items.ion'
                                        }
                                    }
                                },
                                properties: [
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'classList',
                                            loc: {
                                                start: {
                                                    line: 126,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/Items.ion'
                                                },
                                                end: {
                                                    line: 126,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'viewpath/html/Items.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'ObjectExpression',
                                            properties: [{
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'state',
                                                            loc: {
                                                                start: {
                                                                    line: 127,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/Items.ion'
                                                                },
                                                                end: {
                                                                    line: 127,
                                                                    column: 21,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/Items.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'view',
                                                            loc: {
                                                                start: {
                                                                    line: 127,
                                                                    column: 22,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/Items.ion'
                                                                },
                                                                end: {
                                                                    line: 127,
                                                                    column: 26,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/Items.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 127,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/Items.ion'
                                                            },
                                                            end: {
                                                                line: 127,
                                                                column: 26,
                                                                fixed: true,
                                                                source: 'viewpath/html/Items.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 127,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/Items.ion'
                                                        },
                                                        end: {
                                                            line: 127,
                                                            column: 26,
                                                            fixed: true,
                                                            source: 'viewpath/html/Items.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        kind: 'init',
                                        order: '0'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'style',
                                            loc: {
                                                start: {
                                                    line: 128,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/Items.ion'
                                                },
                                                end: {
                                                    line: 128,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'viewpath/html/Items.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'ObjectExpression',
                                            properties: [{
                                                    type: 'IfStatement',
                                                    test: {
                                                        type: 'UnaryExpression',
                                                        operator: '!',
                                                        argument: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'state',
                                                                loc: {
                                                                    start: {
                                                                        line: 129,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/Items.ion'
                                                                    },
                                                                    end: {
                                                                        line: 129,
                                                                        column: 28,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/Items.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'showToggle',
                                                                loc: {
                                                                    start: {
                                                                        line: 129,
                                                                        column: 29,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/Items.ion'
                                                                    },
                                                                    end: {
                                                                        line: 129,
                                                                        column: 39,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/Items.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 129,
                                                                    column: 23,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/Items.ion'
                                                                },
                                                                end: {
                                                                    line: 129,
                                                                    column: 39,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/Items.ion'
                                                                }
                                                            }
                                                        }
                                                    },
                                                    consequent: {
                                                        type: 'BlockStatement',
                                                        body: [{
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Literal',
                                                                    value: 'padding-top'
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: 0
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            }]
                                                    },
                                                    alternate: null,
                                                    order: '0'
                                                }]
                                        },
                                        kind: 'init',
                                        order: '1'
                                    },
                                    {
                                        type: 'IfStatement',
                                        test: {
                                            type: 'BinaryExpression',
                                            operator: '||',
                                            left: {
                                                type: 'UnaryExpression',
                                                operator: '?',
                                                argument: {
                                                    type: 'Identifier',
                                                    name: 'header',
                                                    loc: {
                                                        start: {
                                                            line: 132,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'viewpath/html/Items.ion'
                                                        },
                                                        end: {
                                                            line: 132,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'viewpath/html/Items.ion'
                                                        }
                                                    }
                                                }
                                            },
                                            right: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'state',
                                                    loc: {
                                                        start: {
                                                            line: 132,
                                                            column: 26,
                                                            fixed: true,
                                                            source: 'viewpath/html/Items.ion'
                                                        },
                                                        end: {
                                                            line: 132,
                                                            column: 31,
                                                            fixed: true,
                                                            source: 'viewpath/html/Items.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'showToggle',
                                                    loc: {
                                                        start: {
                                                            line: 132,
                                                            column: 32,
                                                            fixed: true,
                                                            source: 'viewpath/html/Items.ion'
                                                        },
                                                        end: {
                                                            line: 132,
                                                            column: 42,
                                                            fixed: true,
                                                            source: 'viewpath/html/Items.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 132,
                                                        column: 26,
                                                        fixed: true,
                                                        source: 'viewpath/html/Items.ion'
                                                    },
                                                    end: {
                                                        line: 132,
                                                        column: 42,
                                                        fixed: true,
                                                        source: 'viewpath/html/Items.ion'
                                                    }
                                                }
                                            }
                                        },
                                        consequent: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'Div',
                                                                loc: {
                                                                    start: {
                                                                        line: 133,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/Items.ion'
                                                                    },
                                                                    end: {
                                                                        line: 133,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/Items.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [{
                                                                    type: 'ObjectExpression',
                                                                    properties: [{
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'class',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 133,
                                                                                        column: 21,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Items.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 133,
                                                                                        column: 26,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Items.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'controls'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        }]
                                                                }],
                                                            loc: {
                                                                start: {
                                                                    line: 133,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/Items.ion'
                                                                },
                                                                end: {
                                                                    line: 133,
                                                                    column: 39,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/Items.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [
                                                            {
                                                                type: 'IfStatement',
                                                                test: {
                                                                    type: 'UnaryExpression',
                                                                    operator: '?',
                                                                    argument: {
                                                                        type: 'Identifier',
                                                                        name: 'header',
                                                                        loc: {
                                                                            start: {
                                                                                line: 134,
                                                                                column: 23,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Items.ion'
                                                                            },
                                                                            end: {
                                                                                line: 134,
                                                                                column: 29,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Items.ion'
                                                                            }
                                                                        }
                                                                    }
                                                                },
                                                                consequent: {
                                                                    type: 'BlockStatement',
                                                                    body: [{
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'ObjectExpression',
                                                                                objectType: {
                                                                                    type: 'CallExpression',
                                                                                    callee: {
                                                                                        type: 'Identifier',
                                                                                        name: 'H2',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 135,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Items.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 135,
                                                                                                column: 26,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Items.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    arguments: [],
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 135,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Items.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 135,
                                                                                            column: 28,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Items.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                properties: [{
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'Identifier',
                                                                                            name: 'header',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 136,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Items.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 136,
                                                                                                    column: 34,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Items.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 136,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Items.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 136,
                                                                                                column: 34,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Items.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 135,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Items.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 137,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Items.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                alternate: null,
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'IfStatement',
                                                                test: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'state',
                                                                        loc: {
                                                                            start: {
                                                                                line: 137,
                                                                                column: 23,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Items.ion'
                                                                            },
                                                                            end: {
                                                                                line: 137,
                                                                                column: 28,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Items.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'showToggle',
                                                                        loc: {
                                                                            start: {
                                                                                line: 137,
                                                                                column: 29,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Items.ion'
                                                                            },
                                                                            end: {
                                                                                line: 137,
                                                                                column: 39,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Items.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 137,
                                                                            column: 23,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/Items.ion'
                                                                        },
                                                                        end: {
                                                                            line: 137,
                                                                            column: 39,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/Items.ion'
                                                                        }
                                                                    }
                                                                },
                                                                consequent: {
                                                                    type: 'BlockStatement',
                                                                    body: [{
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'ObjectExpression',
                                                                                objectType: {
                                                                                    type: 'CallExpression',
                                                                                    callee: {
                                                                                        type: 'Identifier',
                                                                                        name: 'ItemsDisplayToggle',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 138,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Items.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 138,
                                                                                                column: 42,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Items.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    arguments: [],
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 138,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Items.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 138,
                                                                                            column: 44,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Items.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                properties: [
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'mode',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 139,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Items.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 139,
                                                                                                    column: 32,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Items.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'MemberExpression',
                                                                                            computed: false,
                                                                                            object: {
                                                                                                type: 'Identifier',
                                                                                                name: 'state',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 139,
                                                                                                        column: 34,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Items.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 139,
                                                                                                        column: 39,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Items.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            property: {
                                                                                                type: 'Identifier',
                                                                                                name: 'view',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 139,
                                                                                                        column: 40,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Items.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 139,
                                                                                                        column: 44,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/Items.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 139,
                                                                                                    column: 34,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Items.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 139,
                                                                                                    column: 44,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Items.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'Function',
                                                                                            context: true,
                                                                                            value: function (_context) {
                                                                                                return function change(e) {
                                                                                                    var state = _context.get('state');
                                                                                                    state.view = this.mode;
                                                                                                };
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 140,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Items.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 143,
                                                                                                column: 32,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Items.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '1'
                                                                                    }
                                                                                ]
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 138,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Items.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 143,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Items.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                alternate: null,
                                                                order: '1'
                                                            }
                                                        ]
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 133,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/Items.ion'
                                                        },
                                                        end: {
                                                            line: 143,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'viewpath/html/Items.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        alternate: null,
                                        order: '2'
                                    },
                                    {
                                        type: 'VariableDeclaration',
                                        declarations: [{
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'list',
                                                    loc: {
                                                        start: {
                                                            line: 143,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/Items.ion'
                                                        },
                                                        end: {
                                                            line: 143,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'viewpath/html/Items.ion'
                                                        }
                                                    }
                                                },
                                                init: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'Identifier',
                                                        name: 'Ul',
                                                        loc: {
                                                            start: {
                                                                line: 143,
                                                                column: 23,
                                                                fixed: true,
                                                                source: 'viewpath/html/Items.ion'
                                                            },
                                                            end: {
                                                                line: 143,
                                                                column: 25,
                                                                fixed: true,
                                                                source: 'viewpath/html/Items.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [],
                                                    loc: {
                                                        start: {
                                                            line: 143,
                                                            column: 23,
                                                            fixed: true,
                                                            source: 'viewpath/html/Items.ion'
                                                        },
                                                        end: {
                                                            line: 143,
                                                            column: 27,
                                                            fixed: true,
                                                            source: 'viewpath/html/Items.ion'
                                                        }
                                                    }
                                                }
                                            }],
                                        kind: 'let',
                                        order: '3'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'list',
                                            loc: {
                                                start: {
                                                    line: 144,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/Items.ion'
                                                },
                                                end: {
                                                    line: 144,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/Items.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Identifier',
                                            name: 'list',
                                            loc: {
                                                start: {
                                                    line: 144,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'viewpath/html/Items.ion'
                                                },
                                                end: {
                                                    line: 144,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'viewpath/html/Items.ion'
                                                }
                                            }
                                        },
                                        kind: 'init',
                                        order: '4'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'ObjectExpression',
                                            objectType: {
                                                type: 'Identifier',
                                                name: 'list',
                                                loc: {
                                                    start: {
                                                        line: 145,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/Items.ion'
                                                    },
                                                    end: {
                                                        line: 145,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'viewpath/html/Items.ion'
                                                    }
                                                }
                                            },
                                            properties: [{
                                                    type: 'ForInStatement',
                                                    left: {
                                                        type: 'VariableDeclaration',
                                                        declarations: [
                                                            {
                                                                type: 'VariableDeclarator',
                                                                id: {
                                                                    type: 'Identifier',
                                                                    name: 'keyString',
                                                                    loc: {
                                                                        start: {
                                                                            line: 146,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/Items.ion'
                                                                        },
                                                                        end: {
                                                                            line: 146,
                                                                            column: 29,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/Items.ion'
                                                                        }
                                                                    }
                                                                },
                                                                init: null
                                                            },
                                                            {
                                                                type: 'VariableDeclarator',
                                                                id: {
                                                                    type: 'Identifier',
                                                                    name: 'item',
                                                                    loc: {
                                                                        start: {
                                                                            line: 146,
                                                                            column: 31,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/Items.ion'
                                                                        },
                                                                        end: {
                                                                            line: 146,
                                                                            column: 35,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/Items.ion'
                                                                        }
                                                                    }
                                                                },
                                                                init: null
                                                            }
                                                        ],
                                                        kind: 'let'
                                                    },
                                                    right: {
                                                        type: 'Identifier',
                                                        name: 'items',
                                                        loc: {
                                                            start: {
                                                                line: 146,
                                                                column: 39,
                                                                fixed: true,
                                                                source: 'viewpath/html/Items.ion'
                                                            },
                                                            end: {
                                                                line: 146,
                                                                column: 44,
                                                                fixed: true,
                                                                source: 'viewpath/html/Items.ion'
                                                            }
                                                        }
                                                    },
                                                    body: {
                                                        type: 'BlockStatement',
                                                        body: [
                                                            {
                                                                type: 'IfStatement',
                                                                test: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '===',
                                                                    left: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'CallExpression',
                                                                            callee: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'Identifier',
                                                                                    name: 'item',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 147,
                                                                                            column: 23,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Items.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 147,
                                                                                            column: 27,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Items.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'getKey',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 147,
                                                                                            column: 28,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Items.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 147,
                                                                                            column: 34,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Items.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 147,
                                                                                        column: 23,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Items.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 147,
                                                                                        column: 34,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Items.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            arguments: [],
                                                                            loc: {
                                                                                start: {
                                                                                    line: 147,
                                                                                    column: 23,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Items.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 147,
                                                                                    column: 36,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Items.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'type',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 147,
                                                                                    column: 37,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Items.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 147,
                                                                                    column: 41,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Items.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 147,
                                                                                column: 23,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Items.ion'
                                                                            },
                                                                            end: {
                                                                                line: 147,
                                                                                column: 41,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Items.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    right: {
                                                                        type: 'Identifier',
                                                                        name: 'Task',
                                                                        loc: {
                                                                            start: {
                                                                                line: 147,
                                                                                column: 45,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Items.ion'
                                                                            },
                                                                            end: {
                                                                                line: 147,
                                                                                column: 49,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Items.ion'
                                                                            }
                                                                        }
                                                                    }
                                                                },
                                                                consequent: {
                                                                    type: 'BlockStatement',
                                                                    body: [
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'classList',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 148,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Items.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 148,
                                                                                        column: 33,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Items.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'ObjectExpression',
                                                                                properties: [{
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'Literal',
                                                                                            value: 'tasks'
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 149,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Items.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 149,
                                                                                                column: 35,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Items.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'ObjectExpression',
                                                                                objectType: {
                                                                                    type: 'CallExpression',
                                                                                    callee: {
                                                                                        type: 'Identifier',
                                                                                        name: 'TaskItem',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 150,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Items.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 150,
                                                                                                column: 32,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Items.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    arguments: [{
                                                                                            type: 'ObjectExpression',
                                                                                            properties: [
                                                                                                {
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'item',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 150,
                                                                                                                column: 34,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Items.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 150,
                                                                                                                column: 38,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Items.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'item',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 150,
                                                                                                                column: 39,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Items.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 150,
                                                                                                                column: 43,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Items.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '0'
                                                                                                },
                                                                                                {
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'config',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 150,
                                                                                                                column: 45,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Items.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 150,
                                                                                                                column: 51,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Items.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'state',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 150,
                                                                                                                column: 52,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Items.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 150,
                                                                                                                column: 57,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Items.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '1'
                                                                                                }
                                                                                            ]
                                                                                        }],
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 150,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Items.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 150,
                                                                                            column: 59,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Items.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                properties: [
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'Function',
                                                                                            context: true,
                                                                                            value: function (_context2) {
                                                                                                return function mouseover(e) {
                                                                                                    var state = _context2.get('state');
                                                                                                    if (state.view === 'module') {
                                                                                                        this.classList.add('z2');
                                                                                                    }
                                                                                                };
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 151,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Items.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 154,
                                                                                                column: 32,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Items.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'Function',
                                                                                            context: true,
                                                                                            value: function (_context3) {
                                                                                                return function mouseout(e) {
                                                                                                    var state = _context3.get('state');
                                                                                                    if (state.view === 'module') {
                                                                                                        this.classList.remove('z2');
                                                                                                    }
                                                                                                };
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 154,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Items.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 157,
                                                                                                column: 32,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Items.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '1'
                                                                                    },
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'classList',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 157,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Items.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 157,
                                                                                                    column: 37,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Items.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'ObjectExpression',
                                                                                            properties: [
                                                                                                {
                                                                                                    type: 'IfStatement',
                                                                                                    test: {
                                                                                                        type: 'BinaryExpression',
                                                                                                        operator: '===',
                                                                                                        left: {
                                                                                                            type: 'MemberExpression',
                                                                                                            computed: false,
                                                                                                            object: {
                                                                                                                type: 'MemberExpression',
                                                                                                                computed: false,
                                                                                                                object: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'state',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 158,
                                                                                                                            column: 35,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/Items.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 158,
                                                                                                                            column: 40,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/Items.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                property: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'selectedItem',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 158,
                                                                                                                            column: 41,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/Items.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 158,
                                                                                                                            column: 53,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/Items.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 158,
                                                                                                                        column: 35,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/Items.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 158,
                                                                                                                        column: 53,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/Items.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            property: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'key',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 158,
                                                                                                                        column: 55,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/Items.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 158,
                                                                                                                        column: 58,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/Items.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            existential: true,
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 158,
                                                                                                                    column: 35,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/Items.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 158,
                                                                                                                    column: 58,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/Items.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        right: {
                                                                                                            type: 'MemberExpression',
                                                                                                            computed: false,
                                                                                                            object: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'item',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 158,
                                                                                                                        column: 62,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/Items.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 158,
                                                                                                                        column: 66,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/Items.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            property: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'key',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 158,
                                                                                                                        column: 67,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/Items.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 158,
                                                                                                                        column: 70,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/Items.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 158,
                                                                                                                    column: 62,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/Items.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 158,
                                                                                                                    column: 70,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/Items.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    consequent: {
                                                                                                        type: 'BlockStatement',
                                                                                                        body: [{
                                                                                                                type: 'ExpressionStatement',
                                                                                                                expression: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: 'selected'
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 159,
                                                                                                                        column: 36,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/Items.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 159,
                                                                                                                        column: 46,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/Items.ion'
                                                                                                                    }
                                                                                                                },
                                                                                                                order: '0'
                                                                                                            }]
                                                                                                    },
                                                                                                    alternate: null,
                                                                                                    order: '0'
                                                                                                },
                                                                                                {
                                                                                                    type: 'IfStatement',
                                                                                                    test: {
                                                                                                        type: 'BinaryExpression',
                                                                                                        operator: '===',
                                                                                                        left: {
                                                                                                            type: 'MemberExpression',
                                                                                                            computed: false,
                                                                                                            object: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'state',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 160,
                                                                                                                        column: 35,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/Items.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 160,
                                                                                                                        column: 40,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/Items.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            property: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'view',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 160,
                                                                                                                        column: 41,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/Items.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 160,
                                                                                                                        column: 45,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/Items.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 160,
                                                                                                                    column: 35,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/Items.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 160,
                                                                                                                    column: 45,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/Items.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        right: {
                                                                                                            type: 'Literal',
                                                                                                            value: 'module'
                                                                                                        }
                                                                                                    },
                                                                                                    consequent: {
                                                                                                        type: 'BlockStatement',
                                                                                                        body: [{
                                                                                                                type: 'ExpressionStatement',
                                                                                                                expression: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: 'z1'
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 161,
                                                                                                                        column: 36,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/Items.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 161,
                                                                                                                        column: 40,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/Items.ion'
                                                                                                                    }
                                                                                                                },
                                                                                                                order: '0'
                                                                                                            }]
                                                                                                    },
                                                                                                    alternate: null,
                                                                                                    order: '1'
                                                                                                }
                                                                                            ]
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '2'
                                                                                    }
                                                                                ]
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 150,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Items.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 163,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Items.ion'
                                                                                }
                                                                            },
                                                                            order: '1'
                                                                        }
                                                                    ]
                                                                },
                                                                alternate: null,
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'IfStatement',
                                                                test: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '===',
                                                                    left: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'CallExpression',
                                                                            callee: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'Identifier',
                                                                                    name: 'item',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 163,
                                                                                            column: 23,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Items.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 163,
                                                                                            column: 27,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Items.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'getKey',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 163,
                                                                                            column: 28,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Items.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 163,
                                                                                            column: 34,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Items.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 163,
                                                                                        column: 23,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Items.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 163,
                                                                                        column: 34,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Items.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            arguments: [],
                                                                            loc: {
                                                                                start: {
                                                                                    line: 163,
                                                                                    column: 23,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Items.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 163,
                                                                                    column: 36,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Items.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'type',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 163,
                                                                                    column: 37,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Items.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 163,
                                                                                    column: 41,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Items.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 163,
                                                                                column: 23,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Items.ion'
                                                                            },
                                                                            end: {
                                                                                line: 163,
                                                                                column: 41,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Items.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    right: {
                                                                        type: 'Identifier',
                                                                        name: 'Comment',
                                                                        loc: {
                                                                            start: {
                                                                                line: 163,
                                                                                column: 45,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Items.ion'
                                                                            },
                                                                            end: {
                                                                                line: 163,
                                                                                column: 52,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/Items.ion'
                                                                            }
                                                                        }
                                                                    }
                                                                },
                                                                consequent: {
                                                                    type: 'BlockStatement',
                                                                    body: [
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'classList',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 164,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Items.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 164,
                                                                                        column: 33,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/Items.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'ObjectExpression',
                                                                                properties: [{
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'Literal',
                                                                                            value: 'comments'
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 165,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Items.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 165,
                                                                                                column: 38,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Items.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'ObjectExpression',
                                                                                objectType: {
                                                                                    type: 'CallExpression',
                                                                                    callee: {
                                                                                        type: 'Identifier',
                                                                                        name: 'CommentItem',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 166,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Items.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 166,
                                                                                                column: 35,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Items.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    arguments: [{
                                                                                            type: 'ObjectExpression',
                                                                                            properties: [
                                                                                                {
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'item',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 166,
                                                                                                                column: 37,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Items.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 166,
                                                                                                                column: 41,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Items.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'item',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 166,
                                                                                                                column: 42,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Items.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 166,
                                                                                                                column: 46,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Items.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '0'
                                                                                                },
                                                                                                {
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'config',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 166,
                                                                                                                column: 48,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Items.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 166,
                                                                                                                column: 54,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Items.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'state',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 166,
                                                                                                                column: 55,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Items.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 166,
                                                                                                                column: 60,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/Items.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '1'
                                                                                                }
                                                                                            ]
                                                                                        }],
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 166,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Items.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 166,
                                                                                            column: 62,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/Items.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                properties: [
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'Function',
                                                                                            context: true,
                                                                                            value: function (_context4) {
                                                                                                return function mouseover(e) {
                                                                                                    var state = _context4.get('state');
                                                                                                    if (state.view === 'module') {
                                                                                                        this.classList.add('z2');
                                                                                                    }
                                                                                                };
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 167,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Items.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 170,
                                                                                                column: 32,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Items.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'Function',
                                                                                            context: true,
                                                                                            value: function (_context5) {
                                                                                                return function mouseout(e) {
                                                                                                    var state = _context5.get('state');
                                                                                                    if (state.view === 'module') {
                                                                                                        this.classList.remove('z2');
                                                                                                    }
                                                                                                };
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 170,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Items.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 173,
                                                                                                column: 32,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/Items.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '1'
                                                                                    },
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'classList',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 173,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Items.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 173,
                                                                                                    column: 37,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/Items.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'ObjectExpression',
                                                                                            properties: [
                                                                                                {
                                                                                                    type: 'IfStatement',
                                                                                                    test: {
                                                                                                        type: 'BinaryExpression',
                                                                                                        operator: '&&',
                                                                                                        left: {
                                                                                                            type: 'UnaryExpression',
                                                                                                            operator: '?',
                                                                                                            argument: {
                                                                                                                type: 'MemberExpression',
                                                                                                                computed: false,
                                                                                                                object: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'state',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 174,
                                                                                                                            column: 35,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/Items.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 174,
                                                                                                                            column: 40,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/Items.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                property: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'selectedItem',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 174,
                                                                                                                            column: 41,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/Items.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 174,
                                                                                                                            column: 53,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/Items.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 174,
                                                                                                                        column: 35,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/Items.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 174,
                                                                                                                        column: 53,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/Items.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        right: {
                                                                                                            type: 'BinaryExpression',
                                                                                                            operator: '===',
                                                                                                            left: {
                                                                                                                type: 'MemberExpression',
                                                                                                                computed: false,
                                                                                                                object: {
                                                                                                                    type: 'MemberExpression',
                                                                                                                    computed: false,
                                                                                                                    object: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'state',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 174,
                                                                                                                                column: 59,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/Items.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 174,
                                                                                                                                column: 64,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/Items.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    property: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'selectedItem',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 174,
                                                                                                                                column: 65,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/Items.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 174,
                                                                                                                                column: 77,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/Items.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 174,
                                                                                                                            column: 59,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/Items.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 174,
                                                                                                                            column: 77,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/Items.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                property: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'key',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 174,
                                                                                                                            column: 78,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/Items.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 174,
                                                                                                                            column: 81,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/Items.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 174,
                                                                                                                        column: 59,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/Items.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 174,
                                                                                                                        column: 81,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/Items.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            right: {
                                                                                                                type: 'MemberExpression',
                                                                                                                computed: false,
                                                                                                                object: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'item',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 174,
                                                                                                                            column: 85,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/Items.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 174,
                                                                                                                            column: 89,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/Items.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                property: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'key',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 174,
                                                                                                                            column: 90,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/Items.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 174,
                                                                                                                            column: 93,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/Items.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 174,
                                                                                                                        column: 85,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/Items.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 174,
                                                                                                                        column: 93,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/Items.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    consequent: {
                                                                                                        type: 'BlockStatement',
                                                                                                        body: [{
                                                                                                                type: 'ExpressionStatement',
                                                                                                                expression: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: 'selected'
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 175,
                                                                                                                        column: 36,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/Items.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 175,
                                                                                                                        column: 46,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/Items.ion'
                                                                                                                    }
                                                                                                                },
                                                                                                                order: '0'
                                                                                                            }]
                                                                                                    },
                                                                                                    alternate: null,
                                                                                                    order: '0'
                                                                                                },
                                                                                                {
                                                                                                    type: 'IfStatement',
                                                                                                    test: {
                                                                                                        type: 'BinaryExpression',
                                                                                                        operator: '===',
                                                                                                        left: {
                                                                                                            type: 'MemberExpression',
                                                                                                            computed: false,
                                                                                                            object: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'state',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 176,
                                                                                                                        column: 35,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/Items.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 176,
                                                                                                                        column: 40,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/Items.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            property: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'view',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 176,
                                                                                                                        column: 41,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/Items.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 176,
                                                                                                                        column: 45,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/Items.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 176,
                                                                                                                    column: 35,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/Items.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 176,
                                                                                                                    column: 45,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/Items.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        right: {
                                                                                                            type: 'Literal',
                                                                                                            value: 'module'
                                                                                                        }
                                                                                                    },
                                                                                                    consequent: {
                                                                                                        type: 'BlockStatement',
                                                                                                        body: [{
                                                                                                                type: 'ExpressionStatement',
                                                                                                                expression: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: 'z1'
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 177,
                                                                                                                        column: 36,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/Items.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 177,
                                                                                                                        column: 40,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/Items.ion'
                                                                                                                    }
                                                                                                                },
                                                                                                                order: '0'
                                                                                                            }]
                                                                                                    },
                                                                                                    alternate: null,
                                                                                                    order: '1'
                                                                                                }
                                                                                            ]
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '2'
                                                                                    }
                                                                                ]
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 166,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Items.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 178,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/Items.ion'
                                                                                }
                                                                            },
                                                                            order: '1'
                                                                        }
                                                                    ]
                                                                },
                                                                alternate: null,
                                                                order: '1'
                                                            }
                                                        ]
                                                    },
                                                    remove: null,
                                                    order: '0'
                                                }]
                                        },
                                        loc: {
                                            start: {
                                                line: 145,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/Items.ion'
                                            },
                                            end: {
                                                line: 178,
                                                column: 16,
                                                fixed: true,
                                                source: 'viewpath/html/Items.ion'
                                            }
                                        },
                                        order: '5'
                                    },
                                    {
                                        type: 'IfStatement',
                                        test: {
                                            type: 'BinaryExpression',
                                            operator: '===',
                                            left: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'state',
                                                    loc: {
                                                        start: {
                                                            line: 178,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'viewpath/html/Items.ion'
                                                        },
                                                        end: {
                                                            line: 178,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'viewpath/html/Items.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'scrollTo',
                                                    loc: {
                                                        start: {
                                                            line: 178,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'viewpath/html/Items.ion'
                                                        },
                                                        end: {
                                                            line: 178,
                                                            column: 29,
                                                            fixed: true,
                                                            source: 'viewpath/html/Items.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 178,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'viewpath/html/Items.ion'
                                                    },
                                                    end: {
                                                        line: 178,
                                                        column: 29,
                                                        fixed: true,
                                                        source: 'viewpath/html/Items.ion'
                                                    }
                                                }
                                            },
                                            right: {
                                                type: 'Literal',
                                                value: 'bottom'
                                            }
                                        },
                                        consequent: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'Function',
                                                            context: true,
                                                            value: function (_context6) {
                                                                return function () {
                                                                    var element = _context6.get('element');
                                                                    element.scrollTop = element.scrollHeight;
                                                                };
                                                            }
                                                        },
                                                        arguments: [],
                                                        loc: {
                                                            start: {
                                                                line: 179,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/Items.ion'
                                                            },
                                                            end: {
                                                                line: 183,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/Items.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 179,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/Items.ion'
                                                        },
                                                        end: {
                                                            line: 183,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'viewpath/html/Items.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        alternate: null,
                                        order: '6'
                                    }
                                ]
                            },
                            order: '0'
                        }]
                },
                alternate: null,
                order: '5'
            }
        ],
        bound: false
    }, {
        this: this,
        _ref5: _ref5,
        glass: glass,
        _ref: _ref,
        _ref2: _ref2,
        _ref3: _ref3,
        _ref4: _ref4,
        style: style,
        Checkbox: Checkbox,
        List: List,
        Icon: Icon,
        Field: Field,
        Img: Img,
        Button: Button,
        ButtonGroup: ButtonGroup,
        Project: Project,
        Task: Task,
        Comment: Comment,
        User: User,
        ItemsDisplayToggle: ItemsDisplayToggle,
        TaskItem: TaskItem,
        CommentItem: CommentItem,
        _ref6: _ref6
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/Items',_viewpath_html_Items_);
    else
      _viewpath_html_Items_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_Items_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_ItemsDisplayToggle_ = function(module,exports,require){'use strict';
var ion = require('ion');
var glass = require('glass'), _ref;
_ref = glass.html.material;
var Icon = _ref.Icon;
var Button = _ref.Button;
var ButtonGroup = _ref.ButtonGroup;
module.exports = exports = ion.template(function () {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'state',
                            loc: {
                                start: {
                                    line: 6,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/ItemsDisplayToggle.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 13,
                                    fixed: true,
                                    source: 'viewpath/html/ItemsDisplayToggle.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'ObjectExpression',
                                properties: []
                            },
                            properties: [{
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'mode',
                                        loc: {
                                            start: {
                                                line: 7,
                                                column: 8,
                                                fixed: true,
                                                source: 'viewpath/html/ItemsDisplayToggle.ion'
                                            },
                                            end: {
                                                line: 7,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/ItemsDisplayToggle.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: 'list'
                                    },
                                    kind: 'init',
                                    order: '0'
                                }]
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'element',
                            loc: {
                                start: {
                                    line: 9,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/ItemsDisplayToggle.ion'
                                },
                                end: {
                                    line: 9,
                                    column: 15,
                                    fixed: true,
                                    source: 'viewpath/html/ItemsDisplayToggle.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'ButtonGroup',
                                loc: {
                                    start: {
                                        line: 9,
                                        column: 18,
                                        fixed: true,
                                        source: 'viewpath/html/ItemsDisplayToggle.ion'
                                    },
                                    end: {
                                        line: 9,
                                        column: 29,
                                        fixed: true,
                                        source: 'viewpath/html/ItemsDisplayToggle.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ObjectExpression',
                                    properties: [{
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'class',
                                                loc: {
                                                    start: {
                                                        line: 9,
                                                        column: 31,
                                                        fixed: true,
                                                        source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                    },
                                                    end: {
                                                        line: 9,
                                                        column: 36,
                                                        fixed: true,
                                                        source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: 'toggle-controls'
                                            },
                                            kind: 'init',
                                            order: '0'
                                        }]
                                }],
                            loc: {
                                start: {
                                    line: 9,
                                    column: 18,
                                    fixed: true,
                                    source: 'viewpath/html/ItemsDisplayToggle.ion'
                                },
                                end: {
                                    line: 9,
                                    column: 56,
                                    fixed: true,
                                    source: 'viewpath/html/ItemsDisplayToggle.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'CallExpression',
                    callee: {
                        type: 'MemberExpression',
                        object: {
                            type: 'Identifier',
                            name: 'Object'
                        },
                        property: {
                            type: 'Identifier',
                            name: 'defineProperties'
                        }
                    },
                    arguments: [
                        {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'Identifier',
                                name: 'element',
                                loc: {
                                    start: {
                                        line: 11,
                                        column: 11,
                                        fixed: true,
                                        source: 'viewpath/html/ItemsDisplayToggle.ion'
                                    },
                                    end: {
                                        line: 11,
                                        column: 18,
                                        fixed: true,
                                        source: 'viewpath/html/ItemsDisplayToggle.ion'
                                    }
                                }
                            },
                            properties: [
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'ObjectExpression',
                                        objectType: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'Identifier',
                                                name: 'Button',
                                                loc: {
                                                    start: {
                                                        line: 19,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                    },
                                                    end: {
                                                        line: 19,
                                                        column: 14,
                                                        fixed: true,
                                                        source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                    }
                                                }
                                            },
                                            arguments: [{
                                                    type: 'ObjectExpression',
                                                    properties: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'class',
                                                                loc: {
                                                                    start: {
                                                                        line: 19,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                                    },
                                                                    end: {
                                                                        line: 19,
                                                                        column: 21,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Literal',
                                                                value: 'standard'
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                }],
                                            loc: {
                                                start: {
                                                    line: 19,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                },
                                                end: {
                                                    line: 19,
                                                    column: 34,
                                                    fixed: true,
                                                    source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                }
                                            }
                                        },
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'classList',
                                                    loc: {
                                                        start: {
                                                            line: 20,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                        },
                                                        end: {
                                                            line: 20,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'ObjectExpression',
                                                    properties: [{
                                                            type: 'IfStatement',
                                                            test: {
                                                                type: 'BinaryExpression',
                                                                operator: '===',
                                                                left: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'state',
                                                                        loc: {
                                                                            start: {
                                                                                line: 21,
                                                                                column: 19,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                                            },
                                                                            end: {
                                                                                line: 21,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'mode',
                                                                        loc: {
                                                                            start: {
                                                                                line: 21,
                                                                                column: 25,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                                            },
                                                                            end: {
                                                                                line: 21,
                                                                                column: 29,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 21,
                                                                            column: 19,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                                        },
                                                                        end: {
                                                                            line: 21,
                                                                            column: 29,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                                        }
                                                                    }
                                                                },
                                                                right: {
                                                                    type: 'Literal',
                                                                    value: 'list'
                                                                }
                                                            },
                                                            consequent: {
                                                                type: 'BlockStatement',
                                                                body: [{
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'Literal',
                                                                            value: 'active'
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 22,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                                            },
                                                                            end: {
                                                                                line: 22,
                                                                                column: 28,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                                            }
                                                                        },
                                                                        order: '0'
                                                                    }]
                                                            },
                                                            alternate: null,
                                                            order: '0'
                                                        }]
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'ObjectExpression',
                                                    objectType: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'Identifier',
                                                            name: 'Icon',
                                                            loc: {
                                                                start: {
                                                                    line: 23,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                                },
                                                                end: {
                                                                    line: 23,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [{
                                                                type: 'ObjectExpression',
                                                                properties: [
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'name',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 23,
                                                                                    column: 18,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 23,
                                                                                    column: 22,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Literal',
                                                                            value: 'view list'
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    },
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'size',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 23,
                                                                                    column: 36,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 23,
                                                                                    column: 40,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Literal',
                                                                            value: 24
                                                                        },
                                                                        kind: 'init',
                                                                        order: '1'
                                                                    },
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'class',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 23,
                                                                                    column: 45,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 23,
                                                                                    column: 50,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Literal',
                                                                            value: 'view list'
                                                                        },
                                                                        kind: 'init',
                                                                        order: '2'
                                                                    }
                                                                ]
                                                            }],
                                                        loc: {
                                                            start: {
                                                                line: 23,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                            },
                                                            end: {
                                                                line: 23,
                                                                column: 64,
                                                                fixed: true,
                                                                source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                            }
                                                        }
                                                    },
                                                    properties: [{
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'Function',
                                                                context: true,
                                                                value: function (_context) {
                                                                    return function click(e) {
                                                                        var element = _context.get('element');
                                                                        element.mode = 'list';
                                                                    };
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 24,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                                },
                                                                end: {
                                                                    line: 27,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                                }
                                                            },
                                                            order: '0'
                                                        }]
                                                },
                                                loc: {
                                                    start: {
                                                        line: 23,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                    },
                                                    end: {
                                                        line: 27,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                    }
                                                },
                                                order: '1'
                                            }
                                        ]
                                    },
                                    loc: {
                                        start: {
                                            line: 19,
                                            column: 8,
                                            fixed: true,
                                            source: 'viewpath/html/ItemsDisplayToggle.ion'
                                        },
                                        end: {
                                            line: 27,
                                            column: 12,
                                            fixed: true,
                                            source: 'viewpath/html/ItemsDisplayToggle.ion'
                                        }
                                    },
                                    order: '0'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'ObjectExpression',
                                        objectType: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'Identifier',
                                                name: 'Button',
                                                loc: {
                                                    start: {
                                                        line: 27,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                    },
                                                    end: {
                                                        line: 27,
                                                        column: 14,
                                                        fixed: true,
                                                        source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                    }
                                                }
                                            },
                                            arguments: [{
                                                    type: 'ObjectExpression',
                                                    properties: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'class',
                                                                loc: {
                                                                    start: {
                                                                        line: 27,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                                    },
                                                                    end: {
                                                                        line: 27,
                                                                        column: 21,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Literal',
                                                                value: 'standard'
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                }],
                                            loc: {
                                                start: {
                                                    line: 27,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                },
                                                end: {
                                                    line: 27,
                                                    column: 34,
                                                    fixed: true,
                                                    source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                }
                                            }
                                        },
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'classList',
                                                    loc: {
                                                        start: {
                                                            line: 28,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                        },
                                                        end: {
                                                            line: 28,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'ObjectExpression',
                                                    properties: [{
                                                            type: 'IfStatement',
                                                            test: {
                                                                type: 'BinaryExpression',
                                                                operator: '===',
                                                                left: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'state',
                                                                        loc: {
                                                                            start: {
                                                                                line: 29,
                                                                                column: 19,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                                            },
                                                                            end: {
                                                                                line: 29,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'mode',
                                                                        loc: {
                                                                            start: {
                                                                                line: 29,
                                                                                column: 25,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                                            },
                                                                            end: {
                                                                                line: 29,
                                                                                column: 29,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 29,
                                                                            column: 19,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                                        },
                                                                        end: {
                                                                            line: 29,
                                                                            column: 29,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                                        }
                                                                    }
                                                                },
                                                                right: {
                                                                    type: 'Literal',
                                                                    value: 'module'
                                                                }
                                                            },
                                                            consequent: {
                                                                type: 'BlockStatement',
                                                                body: [{
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'Literal',
                                                                            value: 'active'
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 30,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                                            },
                                                                            end: {
                                                                                line: 30,
                                                                                column: 28,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                                            }
                                                                        },
                                                                        order: '0'
                                                                    }]
                                                            },
                                                            alternate: null,
                                                            order: '0'
                                                        }]
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'ObjectExpression',
                                                    objectType: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'Identifier',
                                                            name: 'Icon',
                                                            loc: {
                                                                start: {
                                                                    line: 31,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                                },
                                                                end: {
                                                                    line: 31,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [{
                                                                type: 'ObjectExpression',
                                                                properties: [
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'name',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 31,
                                                                                    column: 18,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 31,
                                                                                    column: 22,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Literal',
                                                                            value: 'view module'
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    },
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'size',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 31,
                                                                                    column: 38,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 31,
                                                                                    column: 42,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Literal',
                                                                            value: 24
                                                                        },
                                                                        kind: 'init',
                                                                        order: '1'
                                                                    }
                                                                ]
                                                            }],
                                                        loc: {
                                                            start: {
                                                                line: 31,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                            },
                                                            end: {
                                                                line: 31,
                                                                column: 47,
                                                                fixed: true,
                                                                source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                            }
                                                        }
                                                    },
                                                    properties: [{
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'Function',
                                                                context: true,
                                                                value: function (_context2) {
                                                                    return function click(e) {
                                                                        var element = _context2.get('element');
                                                                        element.mode = 'module';
                                                                    };
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 32,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                                },
                                                                end: {
                                                                    line: 35,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                                }
                                                            },
                                                            order: '0'
                                                        }]
                                                },
                                                loc: {
                                                    start: {
                                                        line: 31,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                    },
                                                    end: {
                                                        line: 35,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                    }
                                                },
                                                order: '1'
                                            }
                                        ]
                                    },
                                    loc: {
                                        start: {
                                            line: 27,
                                            column: 8,
                                            fixed: true,
                                            source: 'viewpath/html/ItemsDisplayToggle.ion'
                                        },
                                        end: {
                                            line: 35,
                                            column: 12,
                                            fixed: true,
                                            source: 'viewpath/html/ItemsDisplayToggle.ion'
                                        }
                                    },
                                    order: '1'
                                }
                            ]
                        },
                        {
                            type: 'ObjectExpression',
                            properties: [{
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'mode',
                                        loc: {
                                            start: {
                                                line: 12,
                                                column: 17,
                                                fixed: true,
                                                source: 'viewpath/html/ItemsDisplayToggle.ion'
                                            },
                                            end: {
                                                line: 12,
                                                column: 21,
                                                fixed: true,
                                                source: 'viewpath/html/ItemsDisplayToggle.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 13,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                        },
                                                        end: {
                                                            line: 13,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context3) {
                                                        return function () {
                                                            var state = _context3.get('state');
                                                            return state.mode;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 14,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                        },
                                                        end: {
                                                            line: 14,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'viewpath/html/ItemsDisplayToggle.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context4) {
                                                        return function (value) {
                                                            var state = _context4.get('state');
                                                            if (state.mode !== value) {
                                                                state.mode = value;
                                                                this.dispatchEvent(new CustomEvent('change', { detail: state.mode }));
                                                            }
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '0'
                                }]
                        }
                    ]
                },
                order: '2'
            }
        ],
        bound: false
    }, {
        this: this,
        glass: glass,
        _ref: _ref,
        Icon: Icon,
        Button: Button,
        ButtonGroup: ButtonGroup
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/ItemsDisplayToggle',_viewpath_html_ItemsDisplayToggle_);
    else
      _viewpath_html_ItemsDisplayToggle_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_ItemsDisplayToggle_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_Loader_ = function(module,exports,require){'use strict';
var ion = require('ion');
var glass = require('glass'), _ref;
_ref = glass.html;
var style = _ref.style;
var _ref2 = style.sheets;
_ref2[module.id] = '.sk-folding-cube {\n  margin: 20px auto;\n  width: 40px;\n  height: 40px;\n  position: relative;\n  -webkit-transform: rotateZ(45deg);\n          transform: rotateZ(45deg);\n}\n\n.sk-folding-cube .sk-cube {\n  float: left;\n  width: 50%;\n  height: 50%;\n  position: relative;\n  -webkit-transform: scale(1.1);\n      -ms-transform: scale(1.1);\n          transform: scale(1.1);\n}\n.sk-folding-cube .sk-cube:before {\n  content: \'\';\n  position: absolute;\n  top: 0;\n  left: 0;\n  width: 100%;\n  height: 100%;\n  background-color: #aaa;\n  -webkit-animation: sk-foldCubeAngle 2.4s infinite linear both;\n          animation: sk-foldCubeAngle 2.4s infinite linear both;\n  -webkit-transform-origin: 100% 100%;\n      -ms-transform-origin: 100% 100%;\n          transform-origin: 100% 100%;\n}\n.sk-folding-cube .sk-cube2 {\n  -webkit-transform: scale(1.1) rotateZ(90deg);\n          transform: scale(1.1) rotateZ(90deg);\n}\n.sk-folding-cube .sk-cube3 {\n  -webkit-transform: scale(1.1) rotateZ(180deg);\n          transform: scale(1.1) rotateZ(180deg);\n}\n.sk-folding-cube .sk-cube4 {\n  -webkit-transform: scale(1.1) rotateZ(270deg);\n          transform: scale(1.1) rotateZ(270deg);\n}\n.sk-folding-cube .sk-cube2:before {\n  -webkit-animation-delay: 0.3s;\n          animation-delay: 0.3s;\n}\n.sk-folding-cube .sk-cube3:before {\n  -webkit-animation-delay: 0.6s;\n          animation-delay: 0.6s;\n}\n.sk-folding-cube .sk-cube4:before {\n  -webkit-animation-delay: 0.9s;\n          animation-delay: 0.9s;\n}\n@-webkit-keyframes sk-foldCubeAngle {\n  0%, 10% {\n    -webkit-transform: perspective(140px) rotateX(-180deg);\n            transform: perspective(140px) rotateX(-180deg);\n    opacity: 0;\n  } 25%, 75% {\n    -webkit-transform: perspective(140px) rotateX(0deg);\n            transform: perspective(140px) rotateX(0deg);\n    opacity: 1;\n  } 90%, 100% {\n    -webkit-transform: perspective(140px) rotateY(180deg);\n            transform: perspective(140px) rotateY(180deg);\n    opacity: 0;\n  }\n}\n\n@keyframes sk-foldCubeAngle {\n  0%, 10% {\n    -webkit-transform: perspective(140px) rotateX(-180deg);\n            transform: perspective(140px) rotateX(-180deg);\n    opacity: 0;\n  } 25%, 75% {\n    -webkit-transform: perspective(140px) rotateX(0deg);\n            transform: perspective(140px) rotateX(0deg);\n    opacity: 1;\n  } 90%, 100% {\n    -webkit-transform: perspective(140px) rotateY(180deg);\n            transform: perspective(140px) rotateY(180deg);\n    opacity: 0;\n  }\n}';
_ref2;
module.exports = exports = ion.template(function () {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [{
                type: 'ReturnStatement',
                argument: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'CallExpression',
                        callee: {
                            type: 'Identifier',
                            name: 'Div',
                            loc: {
                                start: {
                                    line: 98,
                                    column: 11,
                                    fixed: true,
                                    source: 'viewpath/html/Loader.ion'
                                },
                                end: {
                                    line: 98,
                                    column: 14,
                                    fixed: true,
                                    source: 'viewpath/html/Loader.ion'
                                }
                            }
                        },
                        arguments: [{
                                type: 'ObjectExpression',
                                properties: [{
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'class',
                                            loc: {
                                                start: {
                                                    line: 98,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/Loader.ion'
                                                },
                                                end: {
                                                    line: 98,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'viewpath/html/Loader.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: 'Loader layout fill center center-justified'
                                        },
                                        kind: 'init',
                                        order: '0'
                                    }]
                            }],
                        loc: {
                            start: {
                                line: 98,
                                column: 11,
                                fixed: true,
                                source: 'viewpath/html/Loader.ion'
                            },
                            end: {
                                line: 98,
                                column: 68,
                                fixed: true,
                                source: 'viewpath/html/Loader.ion'
                            }
                        }
                    },
                    properties: [{
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'Identifier',
                                        name: 'Div',
                                        loc: {
                                            start: {
                                                line: 99,
                                                column: 8,
                                                fixed: true,
                                                source: 'viewpath/html/Loader.ion'
                                            },
                                            end: {
                                                line: 99,
                                                column: 11,
                                                fixed: true,
                                                source: 'viewpath/html/Loader.ion'
                                            }
                                        }
                                    },
                                    arguments: [{
                                            type: 'ObjectExpression',
                                            properties: [{
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'class',
                                                        loc: {
                                                            start: {
                                                                line: 99,
                                                                column: 13,
                                                                fixed: true,
                                                                source: 'viewpath/html/Loader.ion'
                                                            },
                                                            end: {
                                                                line: 99,
                                                                column: 18,
                                                                fixed: true,
                                                                source: 'viewpath/html/Loader.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 'sk-folding-cube'
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                }]
                                        }],
                                    loc: {
                                        start: {
                                            line: 99,
                                            column: 8,
                                            fixed: true,
                                            source: 'viewpath/html/Loader.ion'
                                        },
                                        end: {
                                            line: 99,
                                            column: 38,
                                            fixed: true,
                                            source: 'viewpath/html/Loader.ion'
                                        }
                                    }
                                },
                                properties: [
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'Identifier',
                                                name: 'Div',
                                                loc: {
                                                    start: {
                                                        line: 100,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/Loader.ion'
                                                    },
                                                    end: {
                                                        line: 100,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'viewpath/html/Loader.ion'
                                                    }
                                                }
                                            },
                                            arguments: [{
                                                    type: 'ObjectExpression',
                                                    properties: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'class',
                                                                loc: {
                                                                    start: {
                                                                        line: 100,
                                                                        column: 17,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/Loader.ion'
                                                                    },
                                                                    end: {
                                                                        line: 100,
                                                                        column: 22,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/Loader.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Literal',
                                                                value: 'sk-cube sk-cube1'
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                }],
                                            loc: {
                                                start: {
                                                    line: 100,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/Loader.ion'
                                                },
                                                end: {
                                                    line: 100,
                                                    column: 43,
                                                    fixed: true,
                                                    source: 'viewpath/html/Loader.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 100,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/Loader.ion'
                                            },
                                            end: {
                                                line: 100,
                                                column: 43,
                                                fixed: true,
                                                source: 'viewpath/html/Loader.ion'
                                            }
                                        },
                                        order: '0'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'Identifier',
                                                name: 'Div',
                                                loc: {
                                                    start: {
                                                        line: 101,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/Loader.ion'
                                                    },
                                                    end: {
                                                        line: 101,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'viewpath/html/Loader.ion'
                                                    }
                                                }
                                            },
                                            arguments: [{
                                                    type: 'ObjectExpression',
                                                    properties: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'class',
                                                                loc: {
                                                                    start: {
                                                                        line: 101,
                                                                        column: 17,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/Loader.ion'
                                                                    },
                                                                    end: {
                                                                        line: 101,
                                                                        column: 22,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/Loader.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Literal',
                                                                value: 'sk-cube sk-cube2'
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                }],
                                            loc: {
                                                start: {
                                                    line: 101,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/Loader.ion'
                                                },
                                                end: {
                                                    line: 101,
                                                    column: 43,
                                                    fixed: true,
                                                    source: 'viewpath/html/Loader.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 101,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/Loader.ion'
                                            },
                                            end: {
                                                line: 101,
                                                column: 43,
                                                fixed: true,
                                                source: 'viewpath/html/Loader.ion'
                                            }
                                        },
                                        order: '1'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'Identifier',
                                                name: 'Div',
                                                loc: {
                                                    start: {
                                                        line: 102,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/Loader.ion'
                                                    },
                                                    end: {
                                                        line: 102,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'viewpath/html/Loader.ion'
                                                    }
                                                }
                                            },
                                            arguments: [{
                                                    type: 'ObjectExpression',
                                                    properties: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'class',
                                                                loc: {
                                                                    start: {
                                                                        line: 102,
                                                                        column: 17,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/Loader.ion'
                                                                    },
                                                                    end: {
                                                                        line: 102,
                                                                        column: 22,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/Loader.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Literal',
                                                                value: 'sk-cube sk-cube4'
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                }],
                                            loc: {
                                                start: {
                                                    line: 102,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/Loader.ion'
                                                },
                                                end: {
                                                    line: 102,
                                                    column: 43,
                                                    fixed: true,
                                                    source: 'viewpath/html/Loader.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 102,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/Loader.ion'
                                            },
                                            end: {
                                                line: 102,
                                                column: 43,
                                                fixed: true,
                                                source: 'viewpath/html/Loader.ion'
                                            }
                                        },
                                        order: '2'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'Identifier',
                                                name: 'Div',
                                                loc: {
                                                    start: {
                                                        line: 103,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/Loader.ion'
                                                    },
                                                    end: {
                                                        line: 103,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'viewpath/html/Loader.ion'
                                                    }
                                                }
                                            },
                                            arguments: [{
                                                    type: 'ObjectExpression',
                                                    properties: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'class',
                                                                loc: {
                                                                    start: {
                                                                        line: 103,
                                                                        column: 17,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/Loader.ion'
                                                                    },
                                                                    end: {
                                                                        line: 103,
                                                                        column: 22,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/Loader.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Literal',
                                                                value: 'sk-cube sk-cube3'
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                }],
                                            loc: {
                                                start: {
                                                    line: 103,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/Loader.ion'
                                                },
                                                end: {
                                                    line: 103,
                                                    column: 43,
                                                    fixed: true,
                                                    source: 'viewpath/html/Loader.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 103,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/Loader.ion'
                                            },
                                            end: {
                                                line: 103,
                                                column: 43,
                                                fixed: true,
                                                source: 'viewpath/html/Loader.ion'
                                            }
                                        },
                                        order: '3'
                                    }
                                ]
                            },
                            loc: {
                                start: {
                                    line: 99,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/Loader.ion'
                                },
                                end: {
                                    line: 104,
                                    column: 12,
                                    fixed: true,
                                    source: 'viewpath/html/Loader.ion'
                                }
                            },
                            order: '0'
                        }]
                },
                order: '0'
            }],
        bound: false
    }, {
        this: this,
        glass: glass,
        _ref: _ref,
        style: style,
        _ref2: _ref2
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/Loader',_viewpath_html_Loader_);
    else
      _viewpath_html_Loader_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_Loader_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_NavDrawer_ = function(module,exports,require){'use strict';
var ion = require('ion');
var glass = require('glass'), _ref, _ref2, _ref3;
_ref = glass.html.material;
var Drawer = _ref.Drawer;
var Dialog = _ref.Dialog;
var Menu = _ref.NewMenu;
var Icon = _ref.Icon;
var Button = _ref.Button;
_ref2 = glass.html;
var style = _ref2.style;
_ref3 = style;
var rgba = _ref3.rgba;
var _ref5 = style.sheets;
_ref5[module.id] = '.NavDrawer .NewMenu li.MenuItem{\n    font-size:14px;\n    font-color:rgba(0,0,0,.87);\n    font-weight:medium;\n    width: 270px;\n    min-width: 200px;\n}';
_ref5;
module.exports = exports = ion.template(function () {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: '_ref4'
                        },
                        init: {
                            type: 'Identifier',
                            name: 'model',
                            loc: {
                                start: {
                                    line: 19,
                                    column: 17,
                                    fixed: true,
                                    source: 'viewpath/html/NavDrawer.ion'
                                },
                                end: {
                                    line: 19,
                                    column: 22,
                                    fixed: true,
                                    source: 'viewpath/html/NavDrawer.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'orgs',
                            loc: {
                                start: {
                                    line: 19,
                                    column: 9,
                                    fixed: true,
                                    source: 'viewpath/html/NavDrawer.ion'
                                },
                                end: {
                                    line: 19,
                                    column: 13,
                                    fixed: true,
                                    source: 'viewpath/html/NavDrawer.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref4'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'orgs',
                                loc: {
                                    start: {
                                        line: 19,
                                        column: 9,
                                        fixed: true,
                                        source: 'viewpath/html/NavDrawer.ion'
                                    },
                                    end: {
                                        line: 19,
                                        column: 13,
                                        fixed: true,
                                        source: 'viewpath/html/NavDrawer.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'drawer',
                            loc: {
                                start: {
                                    line: 20,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/NavDrawer.ion'
                                },
                                end: {
                                    line: 20,
                                    column: 14,
                                    fixed: true,
                                    source: 'viewpath/html/NavDrawer.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Drawer',
                                    loc: {
                                        start: {
                                            line: 20,
                                            column: 17,
                                            fixed: true,
                                            source: 'viewpath/html/NavDrawer.ion'
                                        },
                                        end: {
                                            line: 20,
                                            column: 23,
                                            fixed: true,
                                            source: 'viewpath/html/NavDrawer.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'class',
                                                    loc: {
                                                        start: {
                                                            line: 20,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'viewpath/html/NavDrawer.ion'
                                                        },
                                                        end: {
                                                            line: 20,
                                                            column: 30,
                                                            fixed: true,
                                                            source: 'viewpath/html/NavDrawer.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: 'layout vertical NavDrawer'
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    }],
                                loc: {
                                    start: {
                                        line: 20,
                                        column: 17,
                                        fixed: true,
                                        source: 'viewpath/html/NavDrawer.ion'
                                    },
                                    end: {
                                        line: 20,
                                        column: 60,
                                        fixed: true,
                                        source: 'viewpath/html/NavDrawer.ion'
                                    }
                                }
                            },
                            properties: [{
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'Function',
                                        context: false,
                                        value: function mousedown(e) {
                                            return e.stopPropagation();
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 21,
                                            column: 8,
                                            fixed: true,
                                            source: 'viewpath/html/NavDrawer.ion'
                                        },
                                        end: {
                                            line: 21,
                                            column: 43,
                                            fixed: true,
                                            source: 'viewpath/html/NavDrawer.ion'
                                        }
                                    },
                                    order: '0'
                                }]
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'close',
                            loc: {
                                start: {
                                    line: 22,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/NavDrawer.ion'
                                },
                                end: {
                                    line: 22,
                                    column: 13,
                                    fixed: true,
                                    source: 'viewpath/html/NavDrawer.ion'
                                }
                            }
                        },
                        init: {
                            type: 'Function',
                            context: true,
                            value: function (_context) {
                                return function () {
                                    var drawer = _context.get('drawer');
                                    if (!drawer.pinned) {
                                        drawer.open = false;
                                    }
                                };
                            }
                        }
                    }],
                kind: 'let',
                order: '3'
            },
            {
                type: 'ExpressionStatement',
                expression: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'MemberExpression',
                        computed: false,
                        object: {
                            type: 'Identifier',
                            name: 'document',
                            loc: {
                                start: {
                                    line: 25,
                                    column: 4,
                                    fixed: true,
                                    source: 'viewpath/html/NavDrawer.ion'
                                },
                                end: {
                                    line: 25,
                                    column: 12,
                                    fixed: true,
                                    source: 'viewpath/html/NavDrawer.ion'
                                }
                            }
                        },
                        property: {
                            type: 'Identifier',
                            name: 'body',
                            loc: {
                                start: {
                                    line: 25,
                                    column: 13,
                                    fixed: true,
                                    source: 'viewpath/html/NavDrawer.ion'
                                },
                                end: {
                                    line: 25,
                                    column: 17,
                                    fixed: true,
                                    source: 'viewpath/html/NavDrawer.ion'
                                }
                            }
                        },
                        loc: {
                            start: {
                                line: 25,
                                column: 4,
                                fixed: true,
                                source: 'viewpath/html/NavDrawer.ion'
                            },
                            end: {
                                line: 25,
                                column: 17,
                                fixed: true,
                                source: 'viewpath/html/NavDrawer.ion'
                            }
                        }
                    },
                    properties: [{
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'Function',
                                context: true,
                                value: function (_context2) {
                                    return function mousedown(e) {
                                        var close = _context2.get('close');
                                        return close();
                                    };
                                }
                            },
                            loc: {
                                start: {
                                    line: 26,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/NavDrawer.ion'
                                },
                                end: {
                                    line: 26,
                                    column: 31,
                                    fixed: true,
                                    source: 'viewpath/html/NavDrawer.ion'
                                }
                            },
                            order: '0'
                        }]
                },
                loc: {
                    start: {
                        line: 25,
                        column: 4,
                        fixed: true,
                        source: 'viewpath/html/NavDrawer.ion'
                    },
                    end: {
                        line: 28,
                        column: 8,
                        fixed: true,
                        source: 'viewpath/html/NavDrawer.ion'
                    }
                },
                order: '4'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'canPin',
                            loc: {
                                start: {
                                    line: 28,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/NavDrawer.ion'
                                },
                                end: {
                                    line: 28,
                                    column: 14,
                                    fixed: true,
                                    source: 'viewpath/html/NavDrawer.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            computed: false,
                            object: {
                                type: 'Identifier',
                                name: 'device',
                                loc: {
                                    start: {
                                        line: 28,
                                        column: 17,
                                        fixed: true,
                                        source: 'viewpath/html/NavDrawer.ion'
                                    },
                                    end: {
                                        line: 28,
                                        column: 23,
                                        fixed: true,
                                        source: 'viewpath/html/NavDrawer.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'desktop',
                                loc: {
                                    start: {
                                        line: 28,
                                        column: 24,
                                        fixed: true,
                                        source: 'viewpath/html/NavDrawer.ion'
                                    },
                                    end: {
                                        line: 28,
                                        column: 31,
                                        fixed: true,
                                        source: 'viewpath/html/NavDrawer.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 28,
                                    column: 17,
                                    fixed: true,
                                    source: 'viewpath/html/NavDrawer.ion'
                                },
                                end: {
                                    line: 28,
                                    column: 31,
                                    fixed: true,
                                    source: 'viewpath/html/NavDrawer.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '5'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'Identifier',
                        name: 'drawer',
                        loc: {
                            start: {
                                line: 30,
                                column: 11,
                                fixed: true,
                                source: 'viewpath/html/NavDrawer.ion'
                            },
                            end: {
                                line: 30,
                                column: 17,
                                fixed: true,
                                source: 'viewpath/html/NavDrawer.ion'
                            }
                        }
                    },
                    properties: [
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'width',
                                loc: {
                                    start: {
                                        line: 31,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/html/NavDrawer.ion'
                                    },
                                    end: {
                                        line: 31,
                                        column: 13,
                                        fixed: true,
                                        source: 'viewpath/html/NavDrawer.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Literal',
                                value: 270
                            },
                            kind: 'init',
                            order: '0'
                        },
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'Identifier',
                                        name: 'Header',
                                        loc: {
                                            start: {
                                                line: 32,
                                                column: 8,
                                                fixed: true,
                                                source: 'viewpath/html/NavDrawer.ion'
                                            },
                                            end: {
                                                line: 32,
                                                column: 14,
                                                fixed: true,
                                                source: 'viewpath/html/NavDrawer.ion'
                                            }
                                        }
                                    },
                                    arguments: [{
                                            type: 'ObjectExpression',
                                            properties: [{
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'class',
                                                        loc: {
                                                            start: {
                                                                line: 32,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/NavDrawer.ion'
                                                            },
                                                            end: {
                                                                line: 32,
                                                                column: 21,
                                                                fixed: true,
                                                                source: 'viewpath/html/NavDrawer.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 'app-bar background-white black'
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                }]
                                        }],
                                    loc: {
                                        start: {
                                            line: 32,
                                            column: 8,
                                            fixed: true,
                                            source: 'viewpath/html/NavDrawer.ion'
                                        },
                                        end: {
                                            line: 32,
                                            column: 56,
                                            fixed: true,
                                            source: 'viewpath/html/NavDrawer.ion'
                                        }
                                    }
                                },
                                properties: [
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'style',
                                            loc: {
                                                start: {
                                                    line: 33,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/NavDrawer.ion'
                                                },
                                                end: {
                                                    line: 33,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'viewpath/html/NavDrawer.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'ObjectExpression',
                                            properties: [{
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'borderBottom',
                                                        loc: {
                                                            start: {
                                                                line: 34,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/NavDrawer.ion'
                                                            },
                                                            end: {
                                                                line: 34,
                                                                column: 28,
                                                                fixed: true,
                                                                source: 'viewpath/html/NavDrawer.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'BinaryExpression',
                                                        operator: '+',
                                                        left: {
                                                            type: 'Literal',
                                                            value: 'solid 1px '
                                                        },
                                                        right: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'rgba',
                                                                loc: {
                                                                    start: {
                                                                        line: 34,
                                                                        column: 43,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                    },
                                                                    end: {
                                                                        line: 34,
                                                                        column: 47,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [
                                                                {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'style',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 34,
                                                                                    column: 48,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/NavDrawer.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 34,
                                                                                    column: 53,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/NavDrawer.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'color',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 34,
                                                                                    column: 54,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/NavDrawer.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 34,
                                                                                    column: 59,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/NavDrawer.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 34,
                                                                                column: 48,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                            },
                                                                            end: {
                                                                                line: 34,
                                                                                column: 59,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'black',
                                                                        loc: {
                                                                            start: {
                                                                                line: 34,
                                                                                column: 60,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                            },
                                                                            end: {
                                                                                line: 34,
                                                                                column: 65,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 34,
                                                                            column: 48,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                        },
                                                                        end: {
                                                                            line: 34,
                                                                            column: 65,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                        }
                                                                    }
                                                                },
                                                                {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'style',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 34,
                                                                                    column: 67,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/NavDrawer.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 34,
                                                                                    column: 72,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/NavDrawer.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'opacity',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 34,
                                                                                    column: 73,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/NavDrawer.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 34,
                                                                                    column: 80,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/NavDrawer.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 34,
                                                                                column: 67,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                            },
                                                                            end: {
                                                                                line: 34,
                                                                                column: 80,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'divider',
                                                                        loc: {
                                                                            start: {
                                                                                line: 34,
                                                                                column: 81,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                            },
                                                                            end: {
                                                                                line: 34,
                                                                                column: 88,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 34,
                                                                            column: 67,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                        },
                                                                        end: {
                                                                            line: 34,
                                                                            column: 88,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                        }
                                                                    }
                                                                }
                                                            ],
                                                            loc: {
                                                                start: {
                                                                    line: 34,
                                                                    column: 43,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/NavDrawer.ion'
                                                                },
                                                                end: {
                                                                    line: 34,
                                                                    column: 89,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/NavDrawer.ion'
                                                                }
                                                            }
                                                        }
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                }]
                                        },
                                        kind: 'init',
                                        order: '0'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'ObjectExpression',
                                            objectType: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'Div',
                                                    loc: {
                                                        start: {
                                                            line: 35,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/NavDrawer.ion'
                                                        },
                                                        end: {
                                                            line: 35,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'viewpath/html/NavDrawer.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [{
                                                        type: 'ObjectExpression',
                                                        properties: [{
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'class',
                                                                    loc: {
                                                                        start: {
                                                                            line: 35,
                                                                            column: 17,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                        },
                                                                        end: {
                                                                            line: 35,
                                                                            column: 22,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: 'flex'
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            }]
                                                    }],
                                                loc: {
                                                    start: {
                                                        line: 35,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/NavDrawer.ion'
                                                    },
                                                    end: {
                                                        line: 35,
                                                        column: 31,
                                                        fixed: true,
                                                        source: 'viewpath/html/NavDrawer.ion'
                                                    }
                                                }
                                            },
                                            properties: [
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'style',
                                                        loc: {
                                                            start: {
                                                                line: 36,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/NavDrawer.ion'
                                                            },
                                                            end: {
                                                                line: 36,
                                                                column: 21,
                                                                fixed: true,
                                                                source: 'viewpath/html/NavDrawer.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'ObjectExpression',
                                                        properties: [
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'marginLeft',
                                                                    loc: {
                                                                        start: {
                                                                            line: 37,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                        },
                                                                        end: {
                                                                            line: 37,
                                                                            column: 30,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '+',
                                                                    left: {
                                                                        type: 'BinaryExpression',
                                                                        operator: '+',
                                                                        left: {
                                                                            type: 'Literal',
                                                                            value: ''
                                                                        },
                                                                        right: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'Identifier',
                                                                                    name: 'style',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 37,
                                                                                            column: 35,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 37,
                                                                                            column: 40,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'spacing',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 37,
                                                                                            column: 41,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 37,
                                                                                            column: 48,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 37,
                                                                                        column: 35,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 37,
                                                                                        column: 48,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'buffer',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 37,
                                                                                        column: 49,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 37,
                                                                                        column: 55,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 37,
                                                                                    column: 35,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/NavDrawer.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 37,
                                                                                    column: 55,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/NavDrawer.ion'
                                                                                }
                                                                            }
                                                                        }
                                                                    },
                                                                    right: {
                                                                        type: 'Literal',
                                                                        value: 'px'
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'fontSize',
                                                                    loc: {
                                                                        start: {
                                                                            line: 38,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                        },
                                                                        end: {
                                                                            line: 38,
                                                                            column: 28,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: '20px'
                                                                },
                                                                kind: 'init',
                                                                order: '1'
                                                            }
                                                        ]
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'Literal',
                                                        value: 'Viewpath'
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 39,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/NavDrawer.ion'
                                                        },
                                                        end: {
                                                            line: 39,
                                                            column: 26,
                                                            fixed: true,
                                                            source: 'viewpath/html/NavDrawer.ion'
                                                        }
                                                    },
                                                    order: '1'
                                                }
                                            ]
                                        },
                                        loc: {
                                            start: {
                                                line: 35,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/NavDrawer.ion'
                                            },
                                            end: {
                                                line: 40,
                                                column: 16,
                                                fixed: true,
                                                source: 'viewpath/html/NavDrawer.ion'
                                            }
                                        },
                                        order: '1'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'ObjectExpression',
                                            objectType: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'Div',
                                                    loc: {
                                                        start: {
                                                            line: 40,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/NavDrawer.ion'
                                                        },
                                                        end: {
                                                            line: 40,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'viewpath/html/NavDrawer.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [{
                                                        type: 'ObjectExpression',
                                                        properties: [{
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'class',
                                                                    loc: {
                                                                        start: {
                                                                            line: 40,
                                                                            column: 17,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                        },
                                                                        end: {
                                                                            line: 40,
                                                                            column: 22,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: 'fixed'
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            }]
                                                    }],
                                                loc: {
                                                    start: {
                                                        line: 40,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/NavDrawer.ion'
                                                    },
                                                    end: {
                                                        line: 40,
                                                        column: 32,
                                                        fixed: true,
                                                        source: 'viewpath/html/NavDrawer.ion'
                                                    }
                                                }
                                            },
                                            properties: [{
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'Button',
                                                                loc: {
                                                                    start: {
                                                                        line: 41,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                    },
                                                                    end: {
                                                                        line: 41,
                                                                        column: 22,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [],
                                                            loc: {
                                                                start: {
                                                                    line: 41,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/NavDrawer.ion'
                                                                },
                                                                end: {
                                                                    line: 41,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/NavDrawer.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'Identifier',
                                                                        name: 'Icon',
                                                                        loc: {
                                                                            start: {
                                                                                line: 42,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                            },
                                                                            end: {
                                                                                line: 42,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [{
                                                                            type: 'ObjectExpression',
                                                                            properties: [{
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'name',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 42,
                                                                                                column: 26,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 42,
                                                                                                column: 30,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'ConditionalExpression',
                                                                                        test: {
                                                                                            type: 'BinaryExpression',
                                                                                            operator: '||',
                                                                                            left: {
                                                                                                type: 'MemberExpression',
                                                                                                computed: false,
                                                                                                object: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'drawer',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 42,
                                                                                                            column: 31,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 42,
                                                                                                            column: 37,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'pinned',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 42,
                                                                                                            column: 38,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 42,
                                                                                                            column: 44,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 42,
                                                                                                        column: 31,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 42,
                                                                                                        column: 44,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            right: {
                                                                                                type: 'UnaryExpression',
                                                                                                operator: '!',
                                                                                                argument: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'canPin',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 42,
                                                                                                            column: 52,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 42,
                                                                                                            column: 58,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                                                        }
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        consequent: {
                                                                                            type: 'Literal',
                                                                                            value: 'keyboard arrow left'
                                                                                        },
                                                                                        alternate: {
                                                                                            type: 'Literal',
                                                                                            value: 'pin drop'
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                }]
                                                                        }],
                                                                    loc: {
                                                                        start: {
                                                                            line: 42,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                        },
                                                                        end: {
                                                                            line: 42,
                                                                            column: 97,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 42,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                    },
                                                                    end: {
                                                                        line: 42,
                                                                        column: 97,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'Function',
                                                                    context: true,
                                                                    value: function (_context3) {
                                                                        return function click(e) {
                                                                            var drawer = _context3.get('drawer'), canPin = _context3.get('canPin');
                                                                            if (drawer.pinned || !canPin) {
                                                                                if (canPin) {
                                                                                    drawer.pinned = false;
                                                                                }
                                                                                drawer.open = false;
                                                                            } else {
                                                                                if (canPin) {
                                                                                    drawer.pinned = true;
                                                                                }
                                                                                drawer.open = true;
                                                                            }
                                                                        };
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 43,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                    },
                                                                    end: {
                                                                        line: 52,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                    }
                                                                },
                                                                order: '1'
                                                            }
                                                        ]
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 41,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/NavDrawer.ion'
                                                        },
                                                        end: {
                                                            line: 52,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'viewpath/html/NavDrawer.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        loc: {
                                            start: {
                                                line: 40,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/NavDrawer.ion'
                                            },
                                            end: {
                                                line: 52,
                                                column: 16,
                                                fixed: true,
                                                source: 'viewpath/html/NavDrawer.ion'
                                            }
                                        },
                                        order: '2'
                                    }
                                ]
                            },
                            loc: {
                                start: {
                                    line: 32,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/NavDrawer.ion'
                                },
                                end: {
                                    line: 52,
                                    column: 12,
                                    fixed: true,
                                    source: 'viewpath/html/NavDrawer.ion'
                                }
                            },
                            order: '1'
                        },
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'Identifier',
                                        name: 'Menu',
                                        loc: {
                                            start: {
                                                line: 52,
                                                column: 8,
                                                fixed: true,
                                                source: 'viewpath/html/NavDrawer.ion'
                                            },
                                            end: {
                                                line: 52,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/NavDrawer.ion'
                                            }
                                        }
                                    },
                                    arguments: [{
                                            type: 'ObjectExpression',
                                            properties: [{
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'items',
                                                        loc: {
                                                            start: {
                                                                line: 53,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'viewpath/html/NavDrawer.ion'
                                                            },
                                                            end: {
                                                                line: 53,
                                                                column: 17,
                                                                fixed: true,
                                                                source: 'viewpath/html/NavDrawer.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'ArrayExpression',
                                                            elements: []
                                                        },
                                                        properties: [
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'ObjectExpression',
                                                                    properties: [
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'name',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 55,
                                                                                        column: 17,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 55,
                                                                                        column: 21,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'Dashboard'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'link',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 55,
                                                                                        column: 35,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 55,
                                                                                        column: 39,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'ObjectExpression',
                                                                                properties: [{
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'id',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 55,
                                                                                                    column: 41,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/NavDrawer.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 55,
                                                                                                    column: 43,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/NavDrawer.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 'Dashboard'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            kind: 'init',
                                                                            order: '1'
                                                                        }
                                                                    ]
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 55,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                    },
                                                                    end: {
                                                                        line: 55,
                                                                        column: 57,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'ObjectExpression',
                                                                    properties: [
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'name',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 56,
                                                                                        column: 17,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 56,
                                                                                        column: 21,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'Home'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'link',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 56,
                                                                                        column: 30,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 56,
                                                                                        column: 34,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'ObjectExpression',
                                                                                properties: [
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'id',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 56,
                                                                                                    column: 36,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/NavDrawer.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 56,
                                                                                                    column: 38,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/NavDrawer.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 'User'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'key',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 56,
                                                                                                    column: 47,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/NavDrawer.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 56,
                                                                                                    column: 50,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/NavDrawer.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'MemberExpression',
                                                                                            computed: false,
                                                                                            object: {
                                                                                                type: 'MemberExpression',
                                                                                                computed: false,
                                                                                                object: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'model',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 56,
                                                                                                            column: 52,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 56,
                                                                                                            column: 57,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'user',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 56,
                                                                                                            column: 58,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 56,
                                                                                                            column: 62,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 56,
                                                                                                        column: 52,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 56,
                                                                                                        column: 62,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            property: {
                                                                                                type: 'Identifier',
                                                                                                name: 'key',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 56,
                                                                                                        column: 64,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 56,
                                                                                                        column: 67,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            existential: true,
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 56,
                                                                                                    column: 52,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/NavDrawer.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 56,
                                                                                                    column: 67,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/NavDrawer.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '1'
                                                                                    }
                                                                                ]
                                                                            },
                                                                            kind: 'init',
                                                                            order: '1'
                                                                        }
                                                                    ]
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 56,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                    },
                                                                    end: {
                                                                        line: 56,
                                                                        column: 69,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                    }
                                                                },
                                                                order: '1'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'ObjectExpression',
                                                                    properties: [
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'name',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 57,
                                                                                        column: 17,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 57,
                                                                                        column: 21,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'Projects'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'link',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 57,
                                                                                        column: 34,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 57,
                                                                                        column: 38,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'ObjectExpression',
                                                                                properties: [{
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'id',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 57,
                                                                                                    column: 40,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/NavDrawer.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 57,
                                                                                                    column: 42,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/NavDrawer.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 'Projects'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            kind: 'init',
                                                                            order: '1'
                                                                        }
                                                                    ]
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 57,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                    },
                                                                    end: {
                                                                        line: 57,
                                                                        column: 55,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                    }
                                                                },
                                                                order: '2'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'Identifier',
                                                                        name: 'Div',
                                                                        loc: {
                                                                            start: {
                                                                                line: 58,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                            },
                                                                            end: {
                                                                                line: 58,
                                                                                column: 19,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [{
                                                                            type: 'ObjectExpression',
                                                                            properties: [{
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'class',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 58,
                                                                                                column: 21,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 58,
                                                                                                column: 26,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Literal',
                                                                                        value: 'flex'
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                }]
                                                                        }],
                                                                    loc: {
                                                                        start: {
                                                                            line: 58,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                        },
                                                                        end: {
                                                                            line: 58,
                                                                            column: 35,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 58,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                    },
                                                                    end: {
                                                                        line: 58,
                                                                        column: 35,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                    }
                                                                },
                                                                order: '3'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'Menu',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 59,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/NavDrawer.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 59,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/NavDrawer.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'Divider',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 59,
                                                                                    column: 21,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/NavDrawer.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 59,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/NavDrawer.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 59,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                            },
                                                                            end: {
                                                                                line: 59,
                                                                                column: 28,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [],
                                                                    loc: {
                                                                        start: {
                                                                            line: 59,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                        },
                                                                        end: {
                                                                            line: 59,
                                                                            column: 30,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 59,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                    },
                                                                    end: {
                                                                        line: 59,
                                                                        column: 30,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                    }
                                                                },
                                                                order: '4'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'ObjectExpression',
                                                                    objectType: {
                                                                        type: 'ObjectExpression',
                                                                        properties: [{
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'name',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 60,
                                                                                            column: 17,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 60,
                                                                                            column: 21,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Literal',
                                                                                    value: 'Organizations'
                                                                                },
                                                                                kind: 'init',
                                                                                order: '0'
                                                                            }]
                                                                    },
                                                                    properties: [{
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'items',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 61,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 61,
                                                                                        column: 25,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'ObjectExpression',
                                                                                objectType: {
                                                                                    type: 'ArrayExpression',
                                                                                    elements: []
                                                                                },
                                                                                properties: [
                                                                                    {
                                                                                        type: 'ForInStatement',
                                                                                        left: {
                                                                                            type: 'VariableDeclaration',
                                                                                            declarations: [
                                                                                                {
                                                                                                    type: 'VariableDeclarator',
                                                                                                    id: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'id',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 62,
                                                                                                                column: 28,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 62,
                                                                                                                column: 30,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    init: null
                                                                                                },
                                                                                                {
                                                                                                    type: 'VariableDeclarator',
                                                                                                    id: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'org',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 62,
                                                                                                                column: 32,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 62,
                                                                                                                column: 35,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    init: null
                                                                                                }
                                                                                            ],
                                                                                            kind: 'let'
                                                                                        },
                                                                                        right: {
                                                                                            type: 'Identifier',
                                                                                            name: 'orgs',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 62,
                                                                                                    column: 39,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/NavDrawer.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 62,
                                                                                                    column: 43,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/NavDrawer.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        body: {
                                                                                            type: 'BlockStatement',
                                                                                            body: [{
                                                                                                    type: 'ExpressionStatement',
                                                                                                    expression: {
                                                                                                        type: 'ObjectExpression',
                                                                                                        objectType: {
                                                                                                            type: 'ObjectExpression',
                                                                                                            properties: []
                                                                                                        },
                                                                                                        properties: [
                                                                                                            {
                                                                                                                type: 'Property',
                                                                                                                key: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'name',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 64,
                                                                                                                            column: 32,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 64,
                                                                                                                            column: 36,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                value: {
                                                                                                                    type: 'MemberExpression',
                                                                                                                    computed: false,
                                                                                                                    object: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'org',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 64,
                                                                                                                                column: 38,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 64,
                                                                                                                                column: 41,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    property: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'name',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 64,
                                                                                                                                column: 42,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 64,
                                                                                                                                column: 46,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 64,
                                                                                                                            column: 38,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 64,
                                                                                                                            column: 46,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                kind: 'init',
                                                                                                                order: '0'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'Property',
                                                                                                                key: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'link',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 65,
                                                                                                                            column: 32,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 65,
                                                                                                                            column: 36,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                value: {
                                                                                                                    type: 'ObjectExpression',
                                                                                                                    objectType: {
                                                                                                                        type: 'CallExpression',
                                                                                                                        callee: {
                                                                                                                            type: 'MemberExpression',
                                                                                                                            computed: false,
                                                                                                                            object: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'ion',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 65,
                                                                                                                                        column: 38,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 65,
                                                                                                                                        column: 41,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            property: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'clone',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 65,
                                                                                                                                        column: 42,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 65,
                                                                                                                                        column: 47,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 65,
                                                                                                                                    column: 38,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/NavDrawer.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 65,
                                                                                                                                    column: 47,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/NavDrawer.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        arguments: [{
                                                                                                                                type: 'MemberExpression',
                                                                                                                                computed: false,
                                                                                                                                object: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'org',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 65,
                                                                                                                                            column: 48,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 65,
                                                                                                                                            column: 51,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                property: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'paneConfig',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 65,
                                                                                                                                            column: 52,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 65,
                                                                                                                                            column: 62,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 65,
                                                                                                                                        column: 48,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 65,
                                                                                                                                        column: 62,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            }],
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 65,
                                                                                                                                column: 38,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 65,
                                                                                                                                column: 63,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    properties: [{
                                                                                                                            type: 'Property',
                                                                                                                            key: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'tab',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 66,
                                                                                                                                        column: 36,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 66,
                                                                                                                                        column: 39,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            value: {
                                                                                                                                type: 'Literal',
                                                                                                                                value: 'users'
                                                                                                                            },
                                                                                                                            kind: 'init',
                                                                                                                            order: '0'
                                                                                                                        }]
                                                                                                                },
                                                                                                                kind: 'init',
                                                                                                                order: '1'
                                                                                                            }
                                                                                                        ]
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 63,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 67,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                                                        }
                                                                                                    },
                                                                                                    order: '0'
                                                                                                }]
                                                                                        },
                                                                                        remove: null,
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'CallExpression',
                                                                                            callee: {
                                                                                                type: 'MemberExpression',
                                                                                                computed: false,
                                                                                                object: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'Menu',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 67,
                                                                                                            column: 24,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 67,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'Divider',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 67,
                                                                                                            column: 29,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 67,
                                                                                                            column: 36,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 67,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 67,
                                                                                                        column: 36,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            arguments: [],
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 67,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/NavDrawer.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 67,
                                                                                                    column: 38,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/NavDrawer.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 67,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 67,
                                                                                                column: 38,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '1'
                                                                                    },
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'ObjectExpression',
                                                                                            properties: [
                                                                                                {
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'name',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 68,
                                                                                                                column: 25,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 68,
                                                                                                                column: 29,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'Literal',
                                                                                                        value: 'New Organization'
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '0'
                                                                                                },
                                                                                                {
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'action',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 68,
                                                                                                                column: 51,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 68,
                                                                                                                column: 57,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'Function',
                                                                                                        context: true,
                                                                                                        value: function (_context4) {
                                                                                                            return function () {
                                                                                                                var Dialog = _context4.get('Dialog'), orgs = _context4.get('orgs');
                                                                                                                return Dialog.show(require('./NewOrgDialog'), {
                                                                                                                    model: model,
                                                                                                                    orgs: orgs
                                                                                                                });
                                                                                                            };
                                                                                                        }
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '1'
                                                                                                }
                                                                                            ]
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 68,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 68,
                                                                                                column: 114,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '2'
                                                                                    }
                                                                                ]
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 60,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                    },
                                                                    end: {
                                                                        line: 69,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                    }
                                                                },
                                                                order: '5'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'Menu',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 69,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/NavDrawer.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 69,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/NavDrawer.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'Divider',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 69,
                                                                                    column: 21,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/NavDrawer.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 69,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/NavDrawer.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 69,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                            },
                                                                            end: {
                                                                                line: 69,
                                                                                column: 28,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [],
                                                                    loc: {
                                                                        start: {
                                                                            line: 69,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                        },
                                                                        end: {
                                                                            line: 69,
                                                                            column: 30,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 69,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                    },
                                                                    end: {
                                                                        line: 69,
                                                                        column: 30,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                    }
                                                                },
                                                                order: '6'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'ObjectExpression',
                                                                    objectType: {
                                                                        type: 'ObjectExpression',
                                                                        properties: [{
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'name',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 70,
                                                                                            column: 17,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 70,
                                                                                            column: 21,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Literal',
                                                                                    value: 'Account'
                                                                                },
                                                                                kind: 'init',
                                                                                order: '0'
                                                                            }]
                                                                    },
                                                                    properties: [{
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'items',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 71,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 71,
                                                                                        column: 25,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'ObjectExpression',
                                                                                objectType: {
                                                                                    type: 'ArrayExpression',
                                                                                    elements: []
                                                                                },
                                                                                properties: [
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'ObjectExpression',
                                                                                            properties: [
                                                                                                {
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'name',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 72,
                                                                                                                column: 25,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 72,
                                                                                                                column: 29,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'Literal',
                                                                                                        value: 'Subscriptions'
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '0'
                                                                                                },
                                                                                                {
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'link',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 72,
                                                                                                                column: 48,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 72,
                                                                                                                column: 52,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'ObjectExpression',
                                                                                                        properties: [{
                                                                                                                type: 'Property',
                                                                                                                key: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'id',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 72,
                                                                                                                            column: 54,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 72,
                                                                                                                            column: 56,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                value: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: 'Subscriptions'
                                                                                                                },
                                                                                                                kind: 'init',
                                                                                                                order: '0'
                                                                                                            }]
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '1'
                                                                                                }
                                                                                            ]
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 72,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 72,
                                                                                                column: 74,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'ObjectExpression',
                                                                                            properties: [
                                                                                                {
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'name',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 73,
                                                                                                                column: 25,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 73,
                                                                                                                column: 29,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'BinaryExpression',
                                                                                                        operator: '+',
                                                                                                        left: {
                                                                                                            type: 'BinaryExpression',
                                                                                                            operator: '+',
                                                                                                            left: {
                                                                                                                type: 'Literal',
                                                                                                                value: 'Logout ('
                                                                                                            },
                                                                                                            right: {
                                                                                                                type: 'MemberExpression',
                                                                                                                computed: false,
                                                                                                                object: {
                                                                                                                    type: 'MemberExpression',
                                                                                                                    computed: false,
                                                                                                                    object: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'model',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 73,
                                                                                                                                column: 42,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 73,
                                                                                                                                column: 47,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    property: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'user',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 73,
                                                                                                                                column: 48,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 73,
                                                                                                                                column: 52,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 73,
                                                                                                                            column: 42,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 73,
                                                                                                                            column: 52,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                property: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'email',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 73,
                                                                                                                            column: 53,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 73,
                                                                                                                            column: 58,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/NavDrawer.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 73,
                                                                                                                        column: 42,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 73,
                                                                                                                        column: 58,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        right: {
                                                                                                            type: 'Literal',
                                                                                                            value: ')'
                                                                                                        }
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '0'
                                                                                                },
                                                                                                {
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'action',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 73,
                                                                                                                column: 64,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 73,
                                                                                                                column: 70,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'Function',
                                                                                                        context: false,
                                                                                                        value: function () {
                                                                                                            return model.logout();
                                                                                                        }
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '1'
                                                                                                }
                                                                                            ]
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 73,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 73,
                                                                                                column: 91,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/NavDrawer.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '1'
                                                                                    }
                                                                                ]
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 70,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                    },
                                                                    end: {
                                                                        line: 74,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/NavDrawer.ion'
                                                                    }
                                                                },
                                                                order: '7'
                                                            }
                                                        ]
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                }]
                                        }],
                                    loc: {
                                        start: {
                                            line: 52,
                                            column: 8,
                                            fixed: true,
                                            source: 'viewpath/html/NavDrawer.ion'
                                        },
                                        end: {
                                            line: 74,
                                            column: 9,
                                            fixed: true,
                                            source: 'viewpath/html/NavDrawer.ion'
                                        }
                                    }
                                },
                                properties: [
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'Function',
                                            context: true,
                                            value: function (_context5) {
                                                return function click(e) {
                                                    var close = _context5.get('close');
                                                    return close();
                                                };
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 75,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/NavDrawer.ion'
                                            },
                                            end: {
                                                line: 75,
                                                column: 31,
                                                fixed: true,
                                                source: 'viewpath/html/NavDrawer.ion'
                                            }
                                        },
                                        order: '0'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'classList',
                                            loc: {
                                                start: {
                                                    line: 76,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/NavDrawer.ion'
                                                },
                                                end: {
                                                    line: 76,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'viewpath/html/NavDrawer.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'ObjectExpression',
                                            properties: [{
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'Literal',
                                                        value: 'fill'
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 77,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/NavDrawer.ion'
                                                        },
                                                        end: {
                                                            line: 77,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'viewpath/html/NavDrawer.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        kind: 'init',
                                        order: '1'
                                    }
                                ]
                            },
                            loc: {
                                start: {
                                    line: 52,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/NavDrawer.ion'
                                },
                                end: {
                                    line: 79,
                                    column: 12,
                                    fixed: true,
                                    source: 'viewpath/html/NavDrawer.ion'
                                }
                            },
                            order: '2'
                        }
                    ]
                },
                order: '6'
            }
        ],
        bound: false
    }, {
        this: this,
        require: require,
        ion: ion,
        glass: glass,
        _ref: _ref,
        _ref2: _ref2,
        _ref3: _ref3,
        Drawer: Drawer,
        Dialog: Dialog,
        Menu: Menu,
        Icon: Icon,
        Button: Button,
        style: style,
        rgba: rgba,
        _ref5: _ref5
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/NavDrawer',_viewpath_html_NavDrawer_);
    else
      _viewpath_html_NavDrawer_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_NavDrawer_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_NewOrgDialog_ = function(module,exports,require){'use strict';
var ion = require('ion'), glass = require('glass'), _ref, _ref2, style = glass.html.style, _ref3, _ref4, _ref5;
_ref = glass.html.material;
var Dialog = _ref.Dialog;
_ref2 = glass.html.forms;
var GlassForm = _ref2.GlassForm;
var SubmitButton = _ref2.SubmitButton;
var CancelButton = _ref2.CancelButton;
var Field = _ref2.Field;
_ref3 = require('../model');
var Organization = _ref3.Organization;
_ref4 = glass.data;
var Key = _ref4.Key;
_ref5 = require('./');
var SubscriptionNotice = _ref5.SubscriptionNotice;
module.exports = exports = ion.template(function () {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'state',
                            loc: {
                                start: {
                                    line: 12,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/NewOrgDialog.ion'
                                },
                                end: {
                                    line: 12,
                                    column: 13,
                                    fixed: true,
                                    source: 'viewpath/html/NewOrgDialog.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            properties: [{
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'creatingOrg',
                                        loc: {
                                            start: {
                                                line: 12,
                                                column: 17,
                                                fixed: true,
                                                source: 'viewpath/html/NewOrgDialog.ion'
                                            },
                                            end: {
                                                line: 12,
                                                column: 28,
                                                fixed: true,
                                                source: 'viewpath/html/NewOrgDialog.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: false
                                    },
                                    kind: 'init',
                                    order: '0'
                                }]
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'nameField',
                            loc: {
                                start: {
                                    line: 13,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/NewOrgDialog.ion'
                                },
                                end: {
                                    line: 13,
                                    column: 17,
                                    fixed: true,
                                    source: 'viewpath/html/NewOrgDialog.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Field',
                                loc: {
                                    start: {
                                        line: 13,
                                        column: 20,
                                        fixed: true,
                                        source: 'viewpath/html/NewOrgDialog.ion'
                                    },
                                    end: {
                                        line: 13,
                                        column: 25,
                                        fixed: true,
                                        source: 'viewpath/html/NewOrgDialog.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ObjectExpression',
                                    properties: [{
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'property',
                                                loc: {
                                                    start: {
                                                        line: 13,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'viewpath/html/NewOrgDialog.ion'
                                                    },
                                                    end: {
                                                        line: 13,
                                                        column: 35,
                                                        fixed: true,
                                                        source: 'viewpath/html/NewOrgDialog.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'Organization',
                                                        loc: {
                                                            start: {
                                                                line: 13,
                                                                column: 36,
                                                                fixed: true,
                                                                source: 'viewpath/html/NewOrgDialog.ion'
                                                            },
                                                            end: {
                                                                line: 13,
                                                                column: 48,
                                                                fixed: true,
                                                                source: 'viewpath/html/NewOrgDialog.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'properties',
                                                        loc: {
                                                            start: {
                                                                line: 13,
                                                                column: 49,
                                                                fixed: true,
                                                                source: 'viewpath/html/NewOrgDialog.ion'
                                                            },
                                                            end: {
                                                                line: 13,
                                                                column: 59,
                                                                fixed: true,
                                                                source: 'viewpath/html/NewOrgDialog.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 13,
                                                            column: 36,
                                                            fixed: true,
                                                            source: 'viewpath/html/NewOrgDialog.ion'
                                                        },
                                                        end: {
                                                            line: 13,
                                                            column: 59,
                                                            fixed: true,
                                                            source: 'viewpath/html/NewOrgDialog.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'name',
                                                    loc: {
                                                        start: {
                                                            line: 13,
                                                            column: 60,
                                                            fixed: true,
                                                            source: 'viewpath/html/NewOrgDialog.ion'
                                                        },
                                                        end: {
                                                            line: 13,
                                                            column: 64,
                                                            fixed: true,
                                                            source: 'viewpath/html/NewOrgDialog.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 13,
                                                        column: 36,
                                                        fixed: true,
                                                        source: 'viewpath/html/NewOrgDialog.ion'
                                                    },
                                                    end: {
                                                        line: 13,
                                                        column: 64,
                                                        fixed: true,
                                                        source: 'viewpath/html/NewOrgDialog.ion'
                                                    }
                                                }
                                            },
                                            kind: 'init',
                                            order: '0'
                                        }]
                                }],
                            loc: {
                                start: {
                                    line: 13,
                                    column: 20,
                                    fixed: true,
                                    source: 'viewpath/html/NewOrgDialog.ion'
                                },
                                end: {
                                    line: 13,
                                    column: 66,
                                    fixed: true,
                                    source: 'viewpath/html/NewOrgDialog.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'valid',
                            loc: {
                                start: {
                                    line: 14,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/NewOrgDialog.ion'
                                },
                                end: {
                                    line: 14,
                                    column: 13,
                                    fixed: true,
                                    source: 'viewpath/html/NewOrgDialog.ion'
                                }
                            }
                        },
                        init: {
                            type: 'BinaryExpression',
                            operator: '>',
                            left: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'nameField',
                                        loc: {
                                            start: {
                                                line: 14,
                                                column: 16,
                                                fixed: true,
                                                source: 'viewpath/html/NewOrgDialog.ion'
                                            },
                                            end: {
                                                line: 14,
                                                column: 25,
                                                fixed: true,
                                                source: 'viewpath/html/NewOrgDialog.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'value',
                                        loc: {
                                            start: {
                                                line: 14,
                                                column: 26,
                                                fixed: true,
                                                source: 'viewpath/html/NewOrgDialog.ion'
                                            },
                                            end: {
                                                line: 14,
                                                column: 31,
                                                fixed: true,
                                                source: 'viewpath/html/NewOrgDialog.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 14,
                                            column: 16,
                                            fixed: true,
                                            source: 'viewpath/html/NewOrgDialog.ion'
                                        },
                                        end: {
                                            line: 14,
                                            column: 31,
                                            fixed: true,
                                            source: 'viewpath/html/NewOrgDialog.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'length',
                                    loc: {
                                        start: {
                                            line: 14,
                                            column: 33,
                                            fixed: true,
                                            source: 'viewpath/html/NewOrgDialog.ion'
                                        },
                                        end: {
                                            line: 14,
                                            column: 39,
                                            fixed: true,
                                            source: 'viewpath/html/NewOrgDialog.ion'
                                        }
                                    }
                                },
                                existential: true,
                                loc: {
                                    start: {
                                        line: 14,
                                        column: 16,
                                        fixed: true,
                                        source: 'viewpath/html/NewOrgDialog.ion'
                                    },
                                    end: {
                                        line: 14,
                                        column: 39,
                                        fixed: true,
                                        source: 'viewpath/html/NewOrgDialog.ion'
                                    }
                                }
                            },
                            right: {
                                type: 'Literal',
                                value: 0
                            }
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'dialog',
                            loc: {
                                start: {
                                    line: 15,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/NewOrgDialog.ion'
                                },
                                end: {
                                    line: 15,
                                    column: 14,
                                    fixed: true,
                                    source: 'viewpath/html/NewOrgDialog.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Dialog',
                                    loc: {
                                        start: {
                                            line: 15,
                                            column: 17,
                                            fixed: true,
                                            source: 'viewpath/html/NewOrgDialog.ion'
                                        },
                                        end: {
                                            line: 15,
                                            column: 23,
                                            fixed: true,
                                            source: 'viewpath/html/NewOrgDialog.ion'
                                        }
                                    }
                                },
                                arguments: [],
                                loc: {
                                    start: {
                                        line: 15,
                                        column: 17,
                                        fixed: true,
                                        source: 'viewpath/html/NewOrgDialog.ion'
                                    },
                                    end: {
                                        line: 15,
                                        column: 25,
                                        fixed: true,
                                        source: 'viewpath/html/NewOrgDialog.ion'
                                    }
                                }
                            },
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'open',
                                        loc: {
                                            start: {
                                                line: 16,
                                                column: 8,
                                                fixed: true,
                                                source: 'viewpath/html/NewOrgDialog.ion'
                                            },
                                            end: {
                                                line: 16,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/NewOrgDialog.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: true
                                    },
                                    kind: 'init',
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'frame',
                                        loc: {
                                            start: {
                                                line: 17,
                                                column: 8,
                                                fixed: true,
                                                source: 'viewpath/html/NewOrgDialog.ion'
                                            },
                                            end: {
                                                line: 17,
                                                column: 13,
                                                fixed: true,
                                                source: 'viewpath/html/NewOrgDialog.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'style',
                                                    loc: {
                                                        start: {
                                                            line: 18,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/NewOrgDialog.ion'
                                                        },
                                                        end: {
                                                            line: 18,
                                                            column: 17,
                                                            fixed: true,
                                                            source: 'viewpath/html/NewOrgDialog.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'ObjectExpression',
                                                    properties: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'minWidth',
                                                                loc: {
                                                                    start: {
                                                                        line: 19,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/NewOrgDialog.ion'
                                                                    },
                                                                    end: {
                                                                        line: 19,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/NewOrgDialog.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Literal',
                                                                value: '450px'
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'ObjectExpression',
                                                    objectType: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'Identifier',
                                                            name: 'Header',
                                                            loc: {
                                                                start: {
                                                                    line: 20,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/NewOrgDialog.ion'
                                                                },
                                                                end: {
                                                                    line: 20,
                                                                    column: 18,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/NewOrgDialog.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [{
                                                                type: 'ObjectExpression',
                                                                properties: [{
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'class',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 20,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/NewOrgDialog.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 20,
                                                                                    column: 25,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/NewOrgDialog.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Literal',
                                                                            value: 'fixed'
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    }]
                                                            }],
                                                        loc: {
                                                            start: {
                                                                line: 20,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'viewpath/html/NewOrgDialog.ion'
                                                            },
                                                            end: {
                                                                line: 20,
                                                                column: 35,
                                                                fixed: true,
                                                                source: 'viewpath/html/NewOrgDialog.ion'
                                                            }
                                                        }
                                                    },
                                                    properties: [{
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'Literal',
                                                                value: 'Create a new Organization'
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 21,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/NewOrgDialog.ion'
                                                                },
                                                                end: {
                                                                    line: 21,
                                                                    column: 43,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/NewOrgDialog.ion'
                                                                }
                                                            },
                                                            order: '0'
                                                        }]
                                                },
                                                loc: {
                                                    start: {
                                                        line: 20,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/NewOrgDialog.ion'
                                                    },
                                                    end: {
                                                        line: 22,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'viewpath/html/NewOrgDialog.ion'
                                                    }
                                                },
                                                order: '1'
                                            },
                                            {
                                                type: 'VariableDeclaration',
                                                declarations: [{
                                                        type: 'VariableDeclarator',
                                                        id: {
                                                            type: 'Identifier',
                                                            name: 'subNotice',
                                                            loc: {
                                                                start: {
                                                                    line: 22,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/NewOrgDialog.ion'
                                                                },
                                                                end: {
                                                                    line: 22,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/NewOrgDialog.ion'
                                                                }
                                                            }
                                                        },
                                                        init: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'SubscriptionNotice',
                                                                loc: {
                                                                    start: {
                                                                        line: 22,
                                                                        column: 28,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/NewOrgDialog.ion'
                                                                    },
                                                                    end: {
                                                                        line: 22,
                                                                        column: 46,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/NewOrgDialog.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [
                                                                {
                                                                    type: 'Literal',
                                                                    value: 'create and manage an organization'
                                                                },
                                                                {
                                                                    type: 'Literal',
                                                                    value: true
                                                                },
                                                                {
                                                                    type: 'Function',
                                                                    context: true,
                                                                    value: function (_context) {
                                                                        return function () {
                                                                            var dialog = _context.get('dialog');
                                                                            return dialog.open = false;
                                                                        };
                                                                    }
                                                                }
                                                            ],
                                                            loc: {
                                                                start: {
                                                                    line: 22,
                                                                    column: 28,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/NewOrgDialog.ion'
                                                                },
                                                                end: {
                                                                    line: 22,
                                                                    column: 116,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/NewOrgDialog.ion'
                                                                }
                                                            }
                                                        }
                                                    }],
                                                kind: 'let',
                                                order: '2'
                                            },
                                            {
                                                type: 'IfStatement',
                                                test: {
                                                    type: 'UnaryExpression',
                                                    operator: '?',
                                                    argument: {
                                                        type: 'Identifier',
                                                        name: 'subNotice',
                                                        loc: {
                                                            start: {
                                                                line: 23,
                                                                column: 15,
                                                                fixed: true,
                                                                source: 'viewpath/html/NewOrgDialog.ion'
                                                            },
                                                            end: {
                                                                line: 23,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'viewpath/html/NewOrgDialog.ion'
                                                            }
                                                        }
                                                    }
                                                },
                                                consequent: {
                                                    type: 'BlockStatement',
                                                    body: [{
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'ObjectExpression',
                                                                objectType: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'Identifier',
                                                                        name: 'Div',
                                                                        loc: {
                                                                            start: {
                                                                                line: 24,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/NewOrgDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 24,
                                                                                column: 19,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/NewOrgDialog.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [],
                                                                    loc: {
                                                                        start: {
                                                                            line: 24,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/NewOrgDialog.ion'
                                                                        },
                                                                        end: {
                                                                            line: 24,
                                                                            column: 21,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/NewOrgDialog.ion'
                                                                        }
                                                                    }
                                                                },
                                                                properties: [
                                                                    {
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'Identifier',
                                                                            name: 'subNotice',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 25,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/NewOrgDialog.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 25,
                                                                                    column: 29,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/NewOrgDialog.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 25,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/NewOrgDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 25,
                                                                                column: 29,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/NewOrgDialog.ion'
                                                                            }
                                                                        },
                                                                        order: '0'
                                                                    },
                                                                    {
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'CallExpression',
                                                                            callee: {
                                                                                type: 'Identifier',
                                                                                name: 'Footer',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 26,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/NewOrgDialog.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 26,
                                                                                        column: 26,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/NewOrgDialog.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            arguments: [{
                                                                                    type: 'ObjectExpression',
                                                                                    properties: [{
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'class',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 26,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 26,
                                                                                                        column: 33,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'Literal',
                                                                                                value: 'layout horizontal'
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '0'
                                                                                        }]
                                                                                }],
                                                                            loc: {
                                                                                start: {
                                                                                    line: 26,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/NewOrgDialog.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 26,
                                                                                    column: 55,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/NewOrgDialog.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 26,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/NewOrgDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 26,
                                                                                column: 55,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/NewOrgDialog.ion'
                                                                            }
                                                                        },
                                                                        order: '1'
                                                                    },
                                                                    {
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'CallExpression',
                                                                            callee: {
                                                                                type: 'Identifier',
                                                                                name: 'Div',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 27,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/NewOrgDialog.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 27,
                                                                                        column: 23,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/NewOrgDialog.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            arguments: [{
                                                                                    type: 'ObjectExpression',
                                                                                    properties: [{
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'class',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 27,
                                                                                                        column: 25,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 27,
                                                                                                        column: 30,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'Literal',
                                                                                                value: 'flex'
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '0'
                                                                                        }]
                                                                                }],
                                                                            loc: {
                                                                                start: {
                                                                                    line: 27,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/NewOrgDialog.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 27,
                                                                                    column: 39,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/NewOrgDialog.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 27,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/NewOrgDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 27,
                                                                                column: 39,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/NewOrgDialog.ion'
                                                                            }
                                                                        },
                                                                        order: '2'
                                                                    },
                                                                    {
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'ObjectExpression',
                                                                            objectType: {
                                                                                type: 'CallExpression',
                                                                                callee: {
                                                                                    type: 'Identifier',
                                                                                    name: 'PaperButton',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 28,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/NewOrgDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 28,
                                                                                            column: 31,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/NewOrgDialog.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                arguments: [{
                                                                                        type: 'ObjectExpression',
                                                                                        properties: []
                                                                                    }],
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 28,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/NewOrgDialog.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 28,
                                                                                        column: 35,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/NewOrgDialog.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            properties: [
                                                                                {
                                                                                    type: 'ExpressionStatement',
                                                                                    expression: {
                                                                                        type: 'Function',
                                                                                        context: true,
                                                                                        value: function (_context2) {
                                                                                            return function click(e) {
                                                                                                var dialog = _context2.get('dialog');
                                                                                                dialog.open = false;
                                                                                            };
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 29,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/NewOrgDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 31,
                                                                                            column: 28,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/NewOrgDialog.ion'
                                                                                        }
                                                                                    },
                                                                                    order: '0'
                                                                                },
                                                                                {
                                                                                    type: 'ExpressionStatement',
                                                                                    expression: {
                                                                                        type: 'Literal',
                                                                                        value: 'Cancel'
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 31,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/NewOrgDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 31,
                                                                                            column: 32,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/NewOrgDialog.ion'
                                                                                        }
                                                                                    },
                                                                                    order: '1'
                                                                                }
                                                                            ]
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 28,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/NewOrgDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 32,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/NewOrgDialog.ion'
                                                                            }
                                                                        },
                                                                        order: '3'
                                                                    }
                                                                ]
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 24,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/NewOrgDialog.ion'
                                                                },
                                                                end: {
                                                                    line: 32,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/NewOrgDialog.ion'
                                                                }
                                                            },
                                                            order: '0'
                                                        }]
                                                },
                                                alternate: {
                                                    type: 'BlockStatement',
                                                    body: [{
                                                            type: 'IfStatement',
                                                            test: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'state',
                                                                    loc: {
                                                                        start: {
                                                                            line: 33,
                                                                            column: 19,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/NewOrgDialog.ion'
                                                                        },
                                                                        end: {
                                                                            line: 33,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/NewOrgDialog.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'creatingOrg',
                                                                    loc: {
                                                                        start: {
                                                                            line: 33,
                                                                            column: 25,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/NewOrgDialog.ion'
                                                                        },
                                                                        end: {
                                                                            line: 33,
                                                                            column: 36,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/NewOrgDialog.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 33,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/NewOrgDialog.ion'
                                                                    },
                                                                    end: {
                                                                        line: 33,
                                                                        column: 36,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/NewOrgDialog.ion'
                                                                    }
                                                                }
                                                            },
                                                            consequent: {
                                                                type: 'BlockStatement',
                                                                body: [{
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'ObjectExpression',
                                                                            objectType: {
                                                                                type: 'CallExpression',
                                                                                callee: {
                                                                                    type: 'Identifier',
                                                                                    name: 'Div',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 34,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/NewOrgDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 34,
                                                                                            column: 23,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/NewOrgDialog.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                arguments: [{
                                                                                        type: 'ObjectExpression',
                                                                                        properties: [{
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'class',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 34,
                                                                                                            column: 25,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 34,
                                                                                                            column: 30,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'Literal',
                                                                                                    value: 'padding layout horizontal justified center'
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '0'
                                                                                            }]
                                                                                    }],
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 34,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/NewOrgDialog.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 34,
                                                                                        column: 77,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/NewOrgDialog.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            properties: [
                                                                                {
                                                                                    type: 'ExpressionStatement',
                                                                                    expression: {
                                                                                        type: 'ObjectExpression',
                                                                                        objectType: {
                                                                                            type: 'CallExpression',
                                                                                            callee: {
                                                                                                type: 'Identifier',
                                                                                                name: 'Div',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 35,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 35,
                                                                                                        column: 27,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            arguments: [],
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 35,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 35,
                                                                                                    column: 29,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        properties: [{
                                                                                                type: 'ExpressionStatement',
                                                                                                expression: {
                                                                                                    type: 'Literal',
                                                                                                    value: 'Creating new organization...'
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 36,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 36,
                                                                                                        column: 58,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                    }
                                                                                                },
                                                                                                order: '0'
                                                                                            }]
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 35,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/NewOrgDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 37,
                                                                                            column: 28,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/NewOrgDialog.ion'
                                                                                        }
                                                                                    },
                                                                                    order: '0'
                                                                                },
                                                                                {
                                                                                    type: 'ExpressionStatement',
                                                                                    expression: {
                                                                                        type: 'ObjectExpression',
                                                                                        objectType: {
                                                                                            type: 'CallExpression',
                                                                                            callee: {
                                                                                                type: 'Identifier',
                                                                                                name: 'Div',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 37,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 37,
                                                                                                        column: 27,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            arguments: [],
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 37,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 37,
                                                                                                    column: 29,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        properties: [{
                                                                                                type: 'ExpressionStatement',
                                                                                                expression: {
                                                                                                    type: 'CallExpression',
                                                                                                    callee: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'PaperSpinnerLite',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 38,
                                                                                                                column: 28,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 38,
                                                                                                                column: 44,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    arguments: [{
                                                                                                            type: 'ObjectExpression',
                                                                                                            properties: [{
                                                                                                                    type: 'Property',
                                                                                                                    key: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'active',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 38,
                                                                                                                                column: 46,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 38,
                                                                                                                                column: 52,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    value: {
                                                                                                                        type: 'Literal',
                                                                                                                        value: true
                                                                                                                    },
                                                                                                                    kind: 'init',
                                                                                                                    order: '0'
                                                                                                                }]
                                                                                                        }],
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 38,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 38,
                                                                                                            column: 60,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 38,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 38,
                                                                                                        column: 60,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                    }
                                                                                                },
                                                                                                order: '0'
                                                                                            }]
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 37,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/NewOrgDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 39,
                                                                                            column: 28,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/NewOrgDialog.ion'
                                                                                        }
                                                                                    },
                                                                                    order: '1'
                                                                                }
                                                                            ]
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 34,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/NewOrgDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 39,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/NewOrgDialog.ion'
                                                                            }
                                                                        },
                                                                        order: '0'
                                                                    }]
                                                            },
                                                            alternate: {
                                                                type: 'BlockStatement',
                                                                body: [{
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'ObjectExpression',
                                                                            objectType: {
                                                                                type: 'CallExpression',
                                                                                callee: {
                                                                                    type: 'Identifier',
                                                                                    name: 'GlassForm',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 40,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/NewOrgDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 40,
                                                                                            column: 29,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/NewOrgDialog.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                arguments: [{
                                                                                        type: 'ObjectExpression',
                                                                                        properties: [{
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'class',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 40,
                                                                                                            column: 31,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 40,
                                                                                                            column: 36,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'Literal',
                                                                                                    value: 'layout vertical flex'
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '0'
                                                                                            }]
                                                                                    }],
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 40,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/NewOrgDialog.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 40,
                                                                                        column: 61,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/NewOrgDialog.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            properties: [
                                                                                {
                                                                                    type: 'ExpressionStatement',
                                                                                    expression: {
                                                                                        type: 'Function',
                                                                                        context: true,
                                                                                        value: function (_context3) {
                                                                                            return function cancel() {
                                                                                                var dialog = _context3.get('dialog');
                                                                                                dialog.open = false;
                                                                                            };
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 41,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/NewOrgDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 43,
                                                                                            column: 28,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/NewOrgDialog.ion'
                                                                                        }
                                                                                    },
                                                                                    order: '0'
                                                                                },
                                                                                {
                                                                                    type: 'ExpressionStatement',
                                                                                    expression: {
                                                                                        type: 'Function',
                                                                                        context: true,
                                                                                        value: function (_context4) {
                                                                                            return function complete() {
                                                                                                var valid = _context4.get('valid'), state = _context4.get('state'), dialog = _context4.get('dialog');
                                                                                                if (valid) {
                                                                                                    state.creatingOrg = true;
                                                                                                    var name = this.values.name;
                                                                                                    model.createOrg({
                                                                                                        name: name,
                                                                                                        adminKey: model.user.key
                                                                                                    }, function (_ref6) {
                                                                                                        var org = _ref6.org;
                                                                                                        var orgKey = _ref6.orgKey;
                                                                                                        dialog.open = false;
                                                                                                        model.open(org.paneConfig);
                                                                                                        window.location.reload(true);
                                                                                                    });
                                                                                                }
                                                                                            };
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 43,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/NewOrgDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 53,
                                                                                            column: 28,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/NewOrgDialog.ion'
                                                                                        }
                                                                                    },
                                                                                    order: '1'
                                                                                },
                                                                                {
                                                                                    type: 'ExpressionStatement',
                                                                                    expression: {
                                                                                        type: 'Identifier',
                                                                                        name: 'nameField',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 53,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/NewOrgDialog.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 53,
                                                                                                column: 33,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/NewOrgDialog.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 53,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/NewOrgDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 53,
                                                                                            column: 33,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/NewOrgDialog.ion'
                                                                                        }
                                                                                    },
                                                                                    order: '2'
                                                                                },
                                                                                {
                                                                                    type: 'ExpressionStatement',
                                                                                    expression: {
                                                                                        type: 'CallExpression',
                                                                                        callee: {
                                                                                            type: 'Identifier',
                                                                                            name: 'Div',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 54,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 54,
                                                                                                    column: 27,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        arguments: [{
                                                                                                type: 'ObjectExpression',
                                                                                                properties: [{
                                                                                                        type: 'Property',
                                                                                                        key: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'class',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 54,
                                                                                                                    column: 29,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 54,
                                                                                                                    column: 34,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        value: {
                                                                                                            type: 'Literal',
                                                                                                            value: 'fill'
                                                                                                        },
                                                                                                        kind: 'init',
                                                                                                        order: '0'
                                                                                                    }]
                                                                                            }],
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 54,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/NewOrgDialog.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 54,
                                                                                                column: 43,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/NewOrgDialog.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 54,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/NewOrgDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 54,
                                                                                            column: 43,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/NewOrgDialog.ion'
                                                                                        }
                                                                                    },
                                                                                    order: '3'
                                                                                },
                                                                                {
                                                                                    type: 'ExpressionStatement',
                                                                                    expression: {
                                                                                        type: 'ObjectExpression',
                                                                                        objectType: {
                                                                                            type: 'CallExpression',
                                                                                            callee: {
                                                                                                type: 'Identifier',
                                                                                                name: 'Div',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 55,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 55,
                                                                                                        column: 27,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            arguments: [],
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 55,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 55,
                                                                                                    column: 29,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        properties: [
                                                                                            {
                                                                                                type: 'ExpressionStatement',
                                                                                                expression: {
                                                                                                    type: 'ObjectExpression',
                                                                                                    objectType: {
                                                                                                        type: 'CallExpression',
                                                                                                        callee: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'CancelButton',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 56,
                                                                                                                    column: 28,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 56,
                                                                                                                    column: 40,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        arguments: [],
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 56,
                                                                                                                column: 28,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 56,
                                                                                                                column: 42,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    properties: [
                                                                                                        {
                                                                                                            type: 'ExpressionStatement',
                                                                                                            expression: {
                                                                                                                type: 'Literal',
                                                                                                                value: 'Cancel'
                                                                                                            },
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 57,
                                                                                                                    column: 32,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 57,
                                                                                                                    column: 40,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                                }
                                                                                                            },
                                                                                                            order: '0'
                                                                                                        },
                                                                                                        {
                                                                                                            type: 'Property',
                                                                                                            key: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'raised',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 58,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 58,
                                                                                                                        column: 38,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            value: {
                                                                                                                type: 'Literal',
                                                                                                                value: false
                                                                                                            },
                                                                                                            kind: 'init',
                                                                                                            order: '1'
                                                                                                        }
                                                                                                    ]
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 56,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 59,
                                                                                                        column: 32,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                    }
                                                                                                },
                                                                                                order: '0'
                                                                                            },
                                                                                            {
                                                                                                type: 'ExpressionStatement',
                                                                                                expression: {
                                                                                                    type: 'ObjectExpression',
                                                                                                    objectType: {
                                                                                                        type: 'CallExpression',
                                                                                                        callee: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'SubmitButton',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 59,
                                                                                                                    column: 28,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 59,
                                                                                                                    column: 40,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        arguments: [],
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 59,
                                                                                                                column: 28,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 59,
                                                                                                                column: 42,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    properties: [
                                                                                                        {
                                                                                                            type: 'ExpressionStatement',
                                                                                                            expression: {
                                                                                                                type: 'Literal',
                                                                                                                value: 'Create'
                                                                                                            },
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 60,
                                                                                                                    column: 32,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 60,
                                                                                                                    column: 40,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                                }
                                                                                                            },
                                                                                                            order: '0'
                                                                                                        },
                                                                                                        {
                                                                                                            type: 'Property',
                                                                                                            key: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'disabled',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 61,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 61,
                                                                                                                        column: 40,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            value: {
                                                                                                                type: 'UnaryExpression',
                                                                                                                operator: '!',
                                                                                                                argument: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'valid',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 61,
                                                                                                                            column: 46,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 61,
                                                                                                                            column: 51,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            kind: 'init',
                                                                                                            order: '1'
                                                                                                        }
                                                                                                    ]
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 59,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 62,
                                                                                                        column: 32,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/NewOrgDialog.ion'
                                                                                                    }
                                                                                                },
                                                                                                order: '1'
                                                                                            }
                                                                                        ]
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 55,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/NewOrgDialog.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 62,
                                                                                            column: 28,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/NewOrgDialog.ion'
                                                                                        }
                                                                                    },
                                                                                    order: '4'
                                                                                }
                                                                            ]
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 40,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/NewOrgDialog.ion'
                                                                            },
                                                                            end: {
                                                                                line: 62,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/NewOrgDialog.ion'
                                                                            }
                                                                        },
                                                                        order: '0'
                                                                    }]
                                                            },
                                                            order: '0'
                                                        }]
                                                },
                                                order: '3'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    order: '1'
                                }
                            ]
                        }
                    }],
                kind: 'let',
                order: '3'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'Identifier',
                    name: 'dialog',
                    loc: {
                        start: {
                            line: 62,
                            column: 11,
                            fixed: true,
                            source: 'viewpath/html/NewOrgDialog.ion'
                        },
                        end: {
                            line: 62,
                            column: 17,
                            fixed: true,
                            source: 'viewpath/html/NewOrgDialog.ion'
                        }
                    }
                },
                order: '4'
            }
        ],
        bound: false
    }, {
        this: this,
        ion: ion,
        glass: glass,
        _ref: _ref,
        _ref2: _ref2,
        style: style,
        _ref3: _ref3,
        _ref4: _ref4,
        _ref5: _ref5,
        Dialog: Dialog,
        GlassForm: GlassForm,
        SubmitButton: SubmitButton,
        CancelButton: CancelButton,
        Field: Field,
        Organization: Organization,
        Key: Key,
        SubscriptionNotice: SubscriptionNotice
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/NewOrgDialog',_viewpath_html_NewOrgDialog_);
    else
      _viewpath_html_NewOrgDialog_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_NewOrgDialog_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_NewOrgField_ = function(module,exports,require){'use strict';
var ion = require('ion'), glass = require('glass'), _ref, _ref2, _ref3;
_ref = glass.html.forms;
var GlassForm = _ref.GlassForm;
var CancelButton = _ref.CancelButton;
var SubmitButton = _ref.SubmitButton;
var Field = _ref.Field;
_ref2 = glass.data;
var Key = _ref2.Key;
_ref3 = require('../model');
var Organization = _ref3.Organization;
var extractId = function (name) {
    return name.trim().split(/\s/g).join('').toLowerCase().replace(/[^a-z0-9]/g, '');
};
module.exports = exports = ion.template(function (args) {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'customProperty',
                            loc: {
                                start: {
                                    line: 11,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/NewOrgField.ion'
                                },
                                end: {
                                    line: 11,
                                    column: 22,
                                    fixed: true,
                                    source: 'viewpath/html/NewOrgField.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ConditionalExpression',
                            test: {
                                type: 'BinaryExpression',
                                operator: '!=',
                                left: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'args',
                                        loc: {
                                            start: {
                                                line: 11,
                                                column: 25,
                                                fixed: true,
                                                source: 'viewpath/html/NewOrgField.ion'
                                            },
                                            end: {
                                                line: 11,
                                                column: 29,
                                                fixed: true,
                                                source: 'viewpath/html/NewOrgField.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'property',
                                        loc: {
                                            start: {
                                                line: 11,
                                                column: 31,
                                                fixed: true,
                                                source: 'viewpath/html/NewOrgField.ion'
                                            },
                                            end: {
                                                line: 11,
                                                column: 39,
                                                fixed: true,
                                                source: 'viewpath/html/NewOrgField.ion'
                                            }
                                        }
                                    },
                                    existential: true,
                                    loc: {
                                        start: {
                                            line: 11,
                                            column: 25,
                                            fixed: true,
                                            source: 'viewpath/html/NewOrgField.ion'
                                        },
                                        end: {
                                            line: 11,
                                            column: 39,
                                            fixed: true,
                                            source: 'viewpath/html/NewOrgField.ion'
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: null
                                }
                            },
                            consequent: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'args',
                                    loc: {
                                        start: {
                                            line: 11,
                                            column: 25,
                                            fixed: true,
                                            source: 'viewpath/html/NewOrgField.ion'
                                        },
                                        end: {
                                            line: 11,
                                            column: 29,
                                            fixed: true,
                                            source: 'viewpath/html/NewOrgField.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'property',
                                    loc: {
                                        start: {
                                            line: 11,
                                            column: 31,
                                            fixed: true,
                                            source: 'viewpath/html/NewOrgField.ion'
                                        },
                                        end: {
                                            line: 11,
                                            column: 39,
                                            fixed: true,
                                            source: 'viewpath/html/NewOrgField.ion'
                                        }
                                    }
                                },
                                existential: true,
                                loc: {
                                    start: {
                                        line: 11,
                                        column: 25,
                                        fixed: true,
                                        source: 'viewpath/html/NewOrgField.ion'
                                    },
                                    end: {
                                        line: 11,
                                        column: 39,
                                        fixed: true,
                                        source: 'viewpath/html/NewOrgField.ion'
                                    }
                                }
                            },
                            alternate: {
                                type: 'ObjectExpression',
                                properties: []
                            }
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'property',
                            loc: {
                                start: {
                                    line: 12,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/NewOrgField.ion'
                                },
                                end: {
                                    line: 12,
                                    column: 16,
                                    fixed: true,
                                    source: 'viewpath/html/NewOrgField.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'ion',
                                        loc: {
                                            start: {
                                                line: 12,
                                                column: 19,
                                                fixed: true,
                                                source: 'viewpath/html/NewOrgField.ion'
                                            },
                                            end: {
                                                line: 12,
                                                column: 22,
                                                fixed: true,
                                                source: 'viewpath/html/NewOrgField.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'patch',
                                        loc: {
                                            start: {
                                                line: 12,
                                                column: 23,
                                                fixed: true,
                                                source: 'viewpath/html/NewOrgField.ion'
                                            },
                                            end: {
                                                line: 12,
                                                column: 28,
                                                fixed: true,
                                                source: 'viewpath/html/NewOrgField.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 12,
                                            column: 19,
                                            fixed: true,
                                            source: 'viewpath/html/NewOrgField.ion'
                                        },
                                        end: {
                                            line: 12,
                                            column: 28,
                                            fixed: true,
                                            source: 'viewpath/html/NewOrgField.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'combine',
                                    loc: {
                                        start: {
                                            line: 12,
                                            column: 29,
                                            fixed: true,
                                            source: 'viewpath/html/NewOrgField.ion'
                                        },
                                        end: {
                                            line: 12,
                                            column: 36,
                                            fixed: true,
                                            source: 'viewpath/html/NewOrgField.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 12,
                                        column: 19,
                                        fixed: true,
                                        source: 'viewpath/html/NewOrgField.ion'
                                    },
                                    end: {
                                        line: 12,
                                        column: 36,
                                        fixed: true,
                                        source: 'viewpath/html/NewOrgField.ion'
                                    }
                                }
                            },
                            arguments: [
                                {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'ion',
                                            loc: {
                                                start: {
                                                    line: 12,
                                                    column: 37,
                                                    fixed: true,
                                                    source: 'viewpath/html/NewOrgField.ion'
                                                },
                                                end: {
                                                    line: 12,
                                                    column: 40,
                                                    fixed: true,
                                                    source: 'viewpath/html/NewOrgField.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'clone',
                                            loc: {
                                                start: {
                                                    line: 12,
                                                    column: 41,
                                                    fixed: true,
                                                    source: 'viewpath/html/NewOrgField.ion'
                                                },
                                                end: {
                                                    line: 12,
                                                    column: 46,
                                                    fixed: true,
                                                    source: 'viewpath/html/NewOrgField.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 12,
                                                column: 37,
                                                fixed: true,
                                                source: 'viewpath/html/NewOrgField.ion'
                                            },
                                            end: {
                                                line: 12,
                                                column: 46,
                                                fixed: true,
                                                source: 'viewpath/html/NewOrgField.ion'
                                            }
                                        }
                                    },
                                    arguments: [{
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'Organization',
                                                    loc: {
                                                        start: {
                                                            line: 12,
                                                            column: 47,
                                                            fixed: true,
                                                            source: 'viewpath/html/NewOrgField.ion'
                                                        },
                                                        end: {
                                                            line: 12,
                                                            column: 59,
                                                            fixed: true,
                                                            source: 'viewpath/html/NewOrgField.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'properties',
                                                    loc: {
                                                        start: {
                                                            line: 12,
                                                            column: 60,
                                                            fixed: true,
                                                            source: 'viewpath/html/NewOrgField.ion'
                                                        },
                                                        end: {
                                                            line: 12,
                                                            column: 70,
                                                            fixed: true,
                                                            source: 'viewpath/html/NewOrgField.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 12,
                                                        column: 47,
                                                        fixed: true,
                                                        source: 'viewpath/html/NewOrgField.ion'
                                                    },
                                                    end: {
                                                        line: 12,
                                                        column: 70,
                                                        fixed: true,
                                                        source: 'viewpath/html/NewOrgField.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'name',
                                                loc: {
                                                    start: {
                                                        line: 12,
                                                        column: 71,
                                                        fixed: true,
                                                        source: 'viewpath/html/NewOrgField.ion'
                                                    },
                                                    end: {
                                                        line: 12,
                                                        column: 75,
                                                        fixed: true,
                                                        source: 'viewpath/html/NewOrgField.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 12,
                                                    column: 47,
                                                    fixed: true,
                                                    source: 'viewpath/html/NewOrgField.ion'
                                                },
                                                end: {
                                                    line: 12,
                                                    column: 75,
                                                    fixed: true,
                                                    source: 'viewpath/html/NewOrgField.ion'
                                                }
                                            }
                                        }],
                                    loc: {
                                        start: {
                                            line: 12,
                                            column: 37,
                                            fixed: true,
                                            source: 'viewpath/html/NewOrgField.ion'
                                        },
                                        end: {
                                            line: 12,
                                            column: 76,
                                            fixed: true,
                                            source: 'viewpath/html/NewOrgField.ion'
                                        }
                                    }
                                },
                                {
                                    type: 'Identifier',
                                    name: 'customProperty',
                                    loc: {
                                        start: {
                                            line: 12,
                                            column: 78,
                                            fixed: true,
                                            source: 'viewpath/html/NewOrgField.ion'
                                        },
                                        end: {
                                            line: 12,
                                            column: 92,
                                            fixed: true,
                                            source: 'viewpath/html/NewOrgField.ion'
                                        }
                                    }
                                }
                            ],
                            loc: {
                                start: {
                                    line: 12,
                                    column: 19,
                                    fixed: true,
                                    source: 'viewpath/html/NewOrgField.ion'
                                },
                                end: {
                                    line: 12,
                                    column: 93,
                                    fixed: true,
                                    source: 'viewpath/html/NewOrgField.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'nameField',
                            loc: {
                                start: {
                                    line: 13,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/NewOrgField.ion'
                                },
                                end: {
                                    line: 13,
                                    column: 17,
                                    fixed: true,
                                    source: 'viewpath/html/NewOrgField.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Field',
                                loc: {
                                    start: {
                                        line: 13,
                                        column: 20,
                                        fixed: true,
                                        source: 'viewpath/html/NewOrgField.ion'
                                    },
                                    end: {
                                        line: 13,
                                        column: 25,
                                        fixed: true,
                                        source: 'viewpath/html/NewOrgField.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ObjectExpression',
                                    properties: [{
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'property',
                                                loc: {
                                                    start: {
                                                        line: 13,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'viewpath/html/NewOrgField.ion'
                                                    },
                                                    end: {
                                                        line: 13,
                                                        column: 35,
                                                        fixed: true,
                                                        source: 'viewpath/html/NewOrgField.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Identifier',
                                                name: 'property',
                                                loc: {
                                                    start: {
                                                        line: 13,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'viewpath/html/NewOrgField.ion'
                                                    },
                                                    end: {
                                                        line: 13,
                                                        column: 35,
                                                        fixed: true,
                                                        source: 'viewpath/html/NewOrgField.ion'
                                                    }
                                                }
                                            },
                                            kind: 'init',
                                            order: '0'
                                        }]
                                }],
                            loc: {
                                start: {
                                    line: 13,
                                    column: 20,
                                    fixed: true,
                                    source: 'viewpath/html/NewOrgField.ion'
                                },
                                end: {
                                    line: 13,
                                    column: 37,
                                    fixed: true,
                                    source: 'viewpath/html/NewOrgField.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'name',
                            loc: {
                                start: {
                                    line: 14,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/NewOrgField.ion'
                                },
                                end: {
                                    line: 14,
                                    column: 12,
                                    fixed: true,
                                    source: 'viewpath/html/NewOrgField.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            computed: false,
                            object: {
                                type: 'Identifier',
                                name: 'nameField',
                                loc: {
                                    start: {
                                        line: 14,
                                        column: 15,
                                        fixed: true,
                                        source: 'viewpath/html/NewOrgField.ion'
                                    },
                                    end: {
                                        line: 14,
                                        column: 24,
                                        fixed: true,
                                        source: 'viewpath/html/NewOrgField.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'value',
                                loc: {
                                    start: {
                                        line: 14,
                                        column: 25,
                                        fixed: true,
                                        source: 'viewpath/html/NewOrgField.ion'
                                    },
                                    end: {
                                        line: 14,
                                        column: 30,
                                        fixed: true,
                                        source: 'viewpath/html/NewOrgField.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 14,
                                    column: 15,
                                    fixed: true,
                                    source: 'viewpath/html/NewOrgField.ion'
                                },
                                end: {
                                    line: 14,
                                    column: 30,
                                    fixed: true,
                                    source: 'viewpath/html/NewOrgField.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '3'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'id',
                            loc: {
                                start: {
                                    line: 15,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/NewOrgField.ion'
                                },
                                end: {
                                    line: 15,
                                    column: 10,
                                    fixed: true,
                                    source: 'viewpath/html/NewOrgField.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'extractId',
                                loc: {
                                    start: {
                                        line: 15,
                                        column: 13,
                                        fixed: true,
                                        source: 'viewpath/html/NewOrgField.ion'
                                    },
                                    end: {
                                        line: 15,
                                        column: 22,
                                        fixed: true,
                                        source: 'viewpath/html/NewOrgField.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'Identifier',
                                    name: 'name',
                                    loc: {
                                        start: {
                                            line: 15,
                                            column: 23,
                                            fixed: true,
                                            source: 'viewpath/html/NewOrgField.ion'
                                        },
                                        end: {
                                            line: 15,
                                            column: 27,
                                            fixed: true,
                                            source: 'viewpath/html/NewOrgField.ion'
                                        }
                                    }
                                }],
                            loc: {
                                start: {
                                    line: 15,
                                    column: 13,
                                    fixed: true,
                                    source: 'viewpath/html/NewOrgField.ion'
                                },
                                end: {
                                    line: 15,
                                    column: 28,
                                    fixed: true,
                                    source: 'viewpath/html/NewOrgField.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '4'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'key',
                            loc: {
                                start: {
                                    line: 16,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/NewOrgField.ion'
                                },
                                end: {
                                    line: 16,
                                    column: 11,
                                    fixed: true,
                                    source: 'viewpath/html/NewOrgField.ion'
                                }
                            }
                        },
                        init: {
                            type: 'NewExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Key',
                                loc: {
                                    start: {
                                        line: 16,
                                        column: 18,
                                        fixed: true,
                                        source: 'viewpath/html/NewOrgField.ion'
                                    },
                                    end: {
                                        line: 16,
                                        column: 21,
                                        fixed: true,
                                        source: 'viewpath/html/NewOrgField.ion'
                                    }
                                }
                            },
                            arguments: [
                                {
                                    type: 'Identifier',
                                    name: 'Organization',
                                    loc: {
                                        start: {
                                            line: 16,
                                            column: 22,
                                            fixed: true,
                                            source: 'viewpath/html/NewOrgField.ion'
                                        },
                                        end: {
                                            line: 16,
                                            column: 34,
                                            fixed: true,
                                            source: 'viewpath/html/NewOrgField.ion'
                                        }
                                    }
                                },
                                {
                                    type: 'Identifier',
                                    name: 'id',
                                    loc: {
                                        start: {
                                            line: 16,
                                            column: 36,
                                            fixed: true,
                                            source: 'viewpath/html/NewOrgField.ion'
                                        },
                                        end: {
                                            line: 16,
                                            column: 38,
                                            fixed: true,
                                            source: 'viewpath/html/NewOrgField.ion'
                                        }
                                    }
                                }
                            ],
                            loc: {
                                start: {
                                    line: 16,
                                    column: 14,
                                    fixed: true,
                                    source: 'viewpath/html/NewOrgField.ion'
                                },
                                end: {
                                    line: 16,
                                    column: 39,
                                    fixed: true,
                                    source: 'viewpath/html/NewOrgField.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '5'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'org',
                            loc: {
                                start: {
                                    line: 17,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/NewOrgField.ion'
                                },
                                end: {
                                    line: 17,
                                    column: 11,
                                    fixed: true,
                                    source: 'viewpath/html/NewOrgField.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            computed: true,
                            object: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'model',
                                    loc: {
                                        start: {
                                            line: 17,
                                            column: 14,
                                            fixed: true,
                                            source: 'viewpath/html/NewOrgField.ion'
                                        },
                                        end: {
                                            line: 17,
                                            column: 19,
                                            fixed: true,
                                            source: 'viewpath/html/NewOrgField.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'server',
                                    loc: {
                                        start: {
                                            line: 17,
                                            column: 20,
                                            fixed: true,
                                            source: 'viewpath/html/NewOrgField.ion'
                                        },
                                        end: {
                                            line: 17,
                                            column: 26,
                                            fixed: true,
                                            source: 'viewpath/html/NewOrgField.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 17,
                                        column: 14,
                                        fixed: true,
                                        source: 'viewpath/html/NewOrgField.ion'
                                    },
                                    end: {
                                        line: 17,
                                        column: 26,
                                        fixed: true,
                                        source: 'viewpath/html/NewOrgField.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'key',
                                loc: {
                                    start: {
                                        line: 17,
                                        column: 27,
                                        fixed: true,
                                        source: 'viewpath/html/NewOrgField.ion'
                                    },
                                    end: {
                                        line: 17,
                                        column: 30,
                                        fixed: true,
                                        source: 'viewpath/html/NewOrgField.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 17,
                                    column: 14,
                                    fixed: true,
                                    source: 'viewpath/html/NewOrgField.ion'
                                },
                                end: {
                                    line: 17,
                                    column: 31,
                                    fixed: true,
                                    source: 'viewpath/html/NewOrgField.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '6'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'valid',
                            loc: {
                                start: {
                                    line: 18,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/NewOrgField.ion'
                                },
                                end: {
                                    line: 18,
                                    column: 13,
                                    fixed: true,
                                    source: 'viewpath/html/NewOrgField.ion'
                                }
                            }
                        },
                        init: {
                            type: 'BinaryExpression',
                            operator: '&&',
                            left: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'nameField',
                                    loc: {
                                        start: {
                                            line: 18,
                                            column: 16,
                                            fixed: true,
                                            source: 'viewpath/html/NewOrgField.ion'
                                        },
                                        end: {
                                            line: 18,
                                            column: 25,
                                            fixed: true,
                                            source: 'viewpath/html/NewOrgField.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'valid',
                                    loc: {
                                        start: {
                                            line: 18,
                                            column: 26,
                                            fixed: true,
                                            source: 'viewpath/html/NewOrgField.ion'
                                        },
                                        end: {
                                            line: 18,
                                            column: 31,
                                            fixed: true,
                                            source: 'viewpath/html/NewOrgField.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 18,
                                        column: 16,
                                        fixed: true,
                                        source: 'viewpath/html/NewOrgField.ion'
                                    },
                                    end: {
                                        line: 18,
                                        column: 31,
                                        fixed: true,
                                        source: 'viewpath/html/NewOrgField.ion'
                                    }
                                }
                            },
                            right: {
                                type: 'BinaryExpression',
                                operator: '===',
                                left: {
                                    type: 'Identifier',
                                    name: 'org',
                                    loc: {
                                        start: {
                                            line: 18,
                                            column: 36,
                                            fixed: true,
                                            source: 'viewpath/html/NewOrgField.ion'
                                        },
                                        end: {
                                            line: 18,
                                            column: 39,
                                            fixed: true,
                                            source: 'viewpath/html/NewOrgField.ion'
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: null
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '7'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'CallExpression',
                    callee: {
                        type: 'MemberExpression',
                        object: {
                            type: 'Identifier',
                            name: 'Object'
                        },
                        property: {
                            type: 'Identifier',
                            name: 'defineProperties'
                        }
                    },
                    arguments: [
                        {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Div',
                                    loc: {
                                        start: {
                                            line: 19,
                                            column: 11,
                                            fixed: true,
                                            source: 'viewpath/html/NewOrgField.ion'
                                        },
                                        end: {
                                            line: 19,
                                            column: 14,
                                            fixed: true,
                                            source: 'viewpath/html/NewOrgField.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'class',
                                                    loc: {
                                                        start: {
                                                            line: 19,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/NewOrgField.ion'
                                                        },
                                                        end: {
                                                            line: 19,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'viewpath/html/NewOrgField.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: 'layout vertical fixed'
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    }],
                                loc: {
                                    start: {
                                        line: 19,
                                        column: 11,
                                        fixed: true,
                                        source: 'viewpath/html/NewOrgField.ion'
                                    },
                                    end: {
                                        line: 19,
                                        column: 47,
                                        fixed: true,
                                        source: 'viewpath/html/NewOrgField.ion'
                                    }
                                }
                            },
                            properties: [
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'Identifier',
                                        name: 'nameField',
                                        loc: {
                                            start: {
                                                line: 20,
                                                column: 8,
                                                fixed: true,
                                                source: 'viewpath/html/NewOrgField.ion'
                                            },
                                            end: {
                                                line: 20,
                                                column: 17,
                                                fixed: true,
                                                source: 'viewpath/html/NewOrgField.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 20,
                                            column: 8,
                                            fixed: true,
                                            source: 'viewpath/html/NewOrgField.ion'
                                        },
                                        end: {
                                            line: 20,
                                            column: 17,
                                            fixed: true,
                                            source: 'viewpath/html/NewOrgField.ion'
                                        }
                                    },
                                    order: '0'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'ObjectExpression',
                                        objectType: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'Identifier',
                                                name: 'Div',
                                                loc: {
                                                    start: {
                                                        line: 21,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'viewpath/html/NewOrgField.ion'
                                                    },
                                                    end: {
                                                        line: 21,
                                                        column: 11,
                                                        fixed: true,
                                                        source: 'viewpath/html/NewOrgField.ion'
                                                    }
                                                }
                                            },
                                            arguments: [{
                                                    type: 'ObjectExpression',
                                                    properties: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'style',
                                                                loc: {
                                                                    start: {
                                                                        line: 21,
                                                                        column: 13,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/NewOrgField.ion'
                                                                    },
                                                                    end: {
                                                                        line: 21,
                                                                        column: 18,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/NewOrgField.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Literal',
                                                                value: 'margin-top:-16px;font-size:12px;color:gray'
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                }],
                                            loc: {
                                                start: {
                                                    line: 21,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'viewpath/html/NewOrgField.ion'
                                                },
                                                end: {
                                                    line: 21,
                                                    column: 65,
                                                    fixed: true,
                                                    source: 'viewpath/html/NewOrgField.ion'
                                                }
                                            }
                                        },
                                        properties: [{
                                                type: 'IfStatement',
                                                test: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'nameField',
                                                        loc: {
                                                            start: {
                                                                line: 22,
                                                                column: 15,
                                                                fixed: true,
                                                                source: 'viewpath/html/NewOrgField.ion'
                                                            },
                                                            end: {
                                                                line: 22,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'viewpath/html/NewOrgField.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'valid',
                                                        loc: {
                                                            start: {
                                                                line: 22,
                                                                column: 25,
                                                                fixed: true,
                                                                source: 'viewpath/html/NewOrgField.ion'
                                                            },
                                                            end: {
                                                                line: 22,
                                                                column: 30,
                                                                fixed: true,
                                                                source: 'viewpath/html/NewOrgField.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 22,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'viewpath/html/NewOrgField.ion'
                                                        },
                                                        end: {
                                                            line: 22,
                                                            column: 30,
                                                            fixed: true,
                                                            source: 'viewpath/html/NewOrgField.ion'
                                                        }
                                                    }
                                                },
                                                consequent: {
                                                    type: 'BlockStatement',
                                                    body: [{
                                                            type: 'IfStatement',
                                                            test: {
                                                                type: 'BinaryExpression',
                                                                operator: '===',
                                                                left: {
                                                                    type: 'Identifier',
                                                                    name: 'org',
                                                                    loc: {
                                                                        start: {
                                                                            line: 23,
                                                                            column: 19,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/NewOrgField.ion'
                                                                        },
                                                                        end: {
                                                                            line: 23,
                                                                            column: 22,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/NewOrgField.ion'
                                                                        }
                                                                    }
                                                                },
                                                                right: {
                                                                    type: 'Literal',
                                                                    value: null
                                                                }
                                                            },
                                                            consequent: {
                                                                type: 'BlockStatement',
                                                                body: [{
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'ObjectExpression',
                                                                            objectType: {
                                                                                type: 'CallExpression',
                                                                                callee: {
                                                                                    type: 'Identifier',
                                                                                    name: 'Span',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 24,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/NewOrgField.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 24,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/NewOrgField.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                arguments: [],
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 24,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/NewOrgField.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 24,
                                                                                        column: 26,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/NewOrgField.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            properties: [{
                                                                                    type: 'ExpressionStatement',
                                                                                    expression: {
                                                                                        type: 'BinaryExpression',
                                                                                        operator: '+',
                                                                                        left: {
                                                                                            type: 'BinaryExpression',
                                                                                            operator: '+',
                                                                                            left: {
                                                                                                type: 'Literal',
                                                                                                value: '\''
                                                                                            },
                                                                                            right: {
                                                                                                type: 'Identifier',
                                                                                                name: 'name',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 25,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/NewOrgField.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 25,
                                                                                                        column: 32,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/NewOrgField.ion'
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        right: {
                                                                                            type: 'Literal',
                                                                                            value: '\' is available.'
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 25,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/NewOrgField.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 25,
                                                                                            column: 50,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/NewOrgField.ion'
                                                                                        }
                                                                                    },
                                                                                    order: '0'
                                                                                }]
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 24,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/NewOrgField.ion'
                                                                            },
                                                                            end: {
                                                                                line: 26,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/NewOrgField.ion'
                                                                            }
                                                                        },
                                                                        order: '0'
                                                                    }]
                                                            },
                                                            alternate: {
                                                                type: 'IfStatement',
                                                                test: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '===',
                                                                    left: {
                                                                        type: 'Identifier',
                                                                        name: 'org',
                                                                        loc: {
                                                                            start: {
                                                                                line: 26,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/NewOrgField.ion'
                                                                            },
                                                                            end: {
                                                                                line: 26,
                                                                                column: 27,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/NewOrgField.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    right: {
                                                                        type: 'UnaryExpression',
                                                                        operator: 'void',
                                                                        prefix: true,
                                                                        argument: {
                                                                            type: 'Literal',
                                                                            value: 0
                                                                        }
                                                                    }
                                                                },
                                                                consequent: {
                                                                    type: 'BlockStatement',
                                                                    body: [{
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'ObjectExpression',
                                                                                objectType: {
                                                                                    type: 'CallExpression',
                                                                                    callee: {
                                                                                        type: 'Identifier',
                                                                                        name: 'Span',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 27,
                                                                                                column: 20,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/NewOrgField.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 27,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/NewOrgField.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    arguments: [],
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 27,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/NewOrgField.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 27,
                                                                                            column: 26,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/NewOrgField.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                properties: [{
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'BinaryExpression',
                                                                                            operator: '+',
                                                                                            left: {
                                                                                                type: 'BinaryExpression',
                                                                                                operator: '+',
                                                                                                left: {
                                                                                                    type: 'Literal',
                                                                                                    value: 'Checking if \''
                                                                                                },
                                                                                                right: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'name',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 28,
                                                                                                            column: 40,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/NewOrgField.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 28,
                                                                                                            column: 44,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/NewOrgField.ion'
                                                                                                        }
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            right: {
                                                                                                type: 'Literal',
                                                                                                value: '\'\' is available...'
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 28,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/NewOrgField.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 28,
                                                                                                column: 65,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/NewOrgField.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 27,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/NewOrgField.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 29,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/NewOrgField.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                alternate: {
                                                                    type: 'IfStatement',
                                                                    test: {
                                                                        type: 'UnaryExpression',
                                                                        operator: '?',
                                                                        argument: {
                                                                            type: 'Identifier',
                                                                            name: 'org',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 29,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/NewOrgField.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 29,
                                                                                    column: 27,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/NewOrgField.ion'
                                                                                }
                                                                            }
                                                                        }
                                                                    },
                                                                    consequent: {
                                                                        type: 'BlockStatement',
                                                                        body: [{
                                                                                type: 'ExpressionStatement',
                                                                                expression: {
                                                                                    type: 'ObjectExpression',
                                                                                    objectType: {
                                                                                        type: 'CallExpression',
                                                                                        callee: {
                                                                                            type: 'Identifier',
                                                                                            name: 'Span',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 30,
                                                                                                    column: 20,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/NewOrgField.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 30,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/NewOrgField.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        arguments: [],
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 30,
                                                                                                column: 20,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/NewOrgField.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 30,
                                                                                                column: 26,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/NewOrgField.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    properties: [{
                                                                                            type: 'ExpressionStatement',
                                                                                            expression: {
                                                                                                type: 'BinaryExpression',
                                                                                                operator: '+',
                                                                                                left: {
                                                                                                    type: 'BinaryExpression',
                                                                                                    operator: '+',
                                                                                                    left: {
                                                                                                        type: 'Literal',
                                                                                                        value: '\''
                                                                                                    },
                                                                                                    right: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'name',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 31,
                                                                                                                column: 28,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/NewOrgField.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 31,
                                                                                                                column: 32,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/NewOrgField.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                right: {
                                                                                                    type: 'Literal',
                                                                                                    value: '\' is already in use, choose another.'
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 31,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/NewOrgField.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 31,
                                                                                                    column: 71,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/NewOrgField.ion'
                                                                                                }
                                                                                            },
                                                                                            order: '0'
                                                                                        }]
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 30,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/NewOrgField.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 32,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/NewOrgField.ion'
                                                                                    }
                                                                                },
                                                                                order: '0'
                                                                            }]
                                                                    },
                                                                    alternate: null
                                                                }
                                                            },
                                                            order: '0'
                                                        }]
                                                },
                                                alternate: null,
                                                order: '0'
                                            }]
                                    },
                                    loc: {
                                        start: {
                                            line: 21,
                                            column: 8,
                                            fixed: true,
                                            source: 'viewpath/html/NewOrgField.ion'
                                        },
                                        end: {
                                            line: 32,
                                            column: 12,
                                            fixed: true,
                                            source: 'viewpath/html/NewOrgField.ion'
                                        }
                                    },
                                    order: '1'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'valid',
                                        loc: {
                                            start: {
                                                line: 36,
                                                column: 8,
                                                fixed: true,
                                                source: 'viewpath/html/NewOrgField.ion'
                                            },
                                            end: {
                                                line: 36,
                                                column: 13,
                                                fixed: true,
                                                source: 'viewpath/html/NewOrgField.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Identifier',
                                        name: 'valid',
                                        loc: {
                                            start: {
                                                line: 36,
                                                column: 15,
                                                fixed: true,
                                                source: 'viewpath/html/NewOrgField.ion'
                                            },
                                            end: {
                                                line: 36,
                                                column: 20,
                                                fixed: true,
                                                source: 'viewpath/html/NewOrgField.ion'
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '2'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'id',
                                        loc: {
                                            start: {
                                                line: 37,
                                                column: 8,
                                                fixed: true,
                                                source: 'viewpath/html/NewOrgField.ion'
                                            },
                                            end: {
                                                line: 37,
                                                column: 10,
                                                fixed: true,
                                                source: 'viewpath/html/NewOrgField.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Identifier',
                                        name: 'id',
                                        loc: {
                                            start: {
                                                line: 37,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/NewOrgField.ion'
                                            },
                                            end: {
                                                line: 37,
                                                column: 14,
                                                fixed: true,
                                                source: 'viewpath/html/NewOrgField.ion'
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '3'
                                }
                            ]
                        },
                        {
                            type: 'ObjectExpression',
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'value',
                                        loc: {
                                            start: {
                                                line: 32,
                                                column: 17,
                                                fixed: true,
                                                source: 'viewpath/html/NewOrgField.ion'
                                            },
                                            end: {
                                                line: 32,
                                                column: 22,
                                                fixed: true,
                                                source: 'viewpath/html/NewOrgField.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 33,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/NewOrgField.ion'
                                                        },
                                                        end: {
                                                            line: 33,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'viewpath/html/NewOrgField.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context) {
                                                        return function () {
                                                            var name = _context.get('name');
                                                            return name;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'label',
                                        loc: {
                                            start: {
                                                line: 34,
                                                column: 17,
                                                fixed: true,
                                                source: 'viewpath/html/NewOrgField.ion'
                                            },
                                            end: {
                                                line: 34,
                                                column: 22,
                                                fixed: true,
                                                source: 'viewpath/html/NewOrgField.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 35,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/NewOrgField.ion'
                                                        },
                                                        end: {
                                                            line: 35,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'viewpath/html/NewOrgField.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context2) {
                                                        return function () {
                                                            var nameField = _context2.get('nameField');
                                                            return nameField.label;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '1'
                                }
                            ]
                        }
                    ]
                },
                order: '8'
            }
        ],
        bound: false
    }, {
        this: this,
        ion: ion,
        args: args,
        glass: glass,
        _ref: _ref,
        _ref2: _ref2,
        _ref3: _ref3,
        GlassForm: GlassForm,
        CancelButton: CancelButton,
        SubmitButton: SubmitButton,
        Field: Field,
        Key: Key,
        Organization: Organization,
        extractId: extractId
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/NewOrgField',_viewpath_html_NewOrgField_);
    else
      _viewpath_html_NewOrgField_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_NewOrgField_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_RepeatField_ = function(module,exports,require){'use strict';
var ion = require('ion');
var glass = require('glass'), viewpath = require('../');
var _ref = glass.data, _ref2, _ref3, daysOfWeek = [
        'Sunday',
        'Monday',
        'Tuesday',
        'Wednesday',
        'Thursday',
        'Friday',
        'Saturday'
    ];
var Schema = _ref.Schema;
_ref2 = glass.html.forms;
var DateInput = _ref2.DateInput;
var Field = _ref2.Field;
var Label = _ref2.Label;
_ref3 = viewpath.model;
var TaskRepeat = _ref3.TaskRepeat;
var RepeatUnit = _ref3.RepeatUnit;
var DaysOfWeek = ion.template(function (args) {
        return ion.createRuntime({
            type: 'Template',
            id: null,
            body: [
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: '_ref4'
                            },
                            init: {
                                type: 'Identifier',
                                name: 'args',
                                loc: {
                                    start: {
                                        line: 13,
                                        column: 31,
                                        fixed: true,
                                        source: 'viewpath/html/RepeatField.ion'
                                    },
                                    end: {
                                        line: 13,
                                        column: 35,
                                        fixed: true,
                                        source: 'viewpath/html/RepeatField.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '0'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'property',
                                loc: {
                                    start: {
                                        line: 13,
                                        column: 13,
                                        fixed: true,
                                        source: 'viewpath/html/RepeatField.ion'
                                    },
                                    end: {
                                        line: 13,
                                        column: 21,
                                        fixed: true,
                                        source: 'viewpath/html/RepeatField.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref4'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'property',
                                    loc: {
                                        start: {
                                            line: 13,
                                            column: 13,
                                            fixed: true,
                                            source: 'viewpath/html/RepeatField.ion'
                                        },
                                        end: {
                                            line: 13,
                                            column: 21,
                                            fixed: true,
                                            source: 'viewpath/html/RepeatField.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '1'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'value',
                                loc: {
                                    start: {
                                        line: 13,
                                        column: 22,
                                        fixed: true,
                                        source: 'viewpath/html/RepeatField.ion'
                                    },
                                    end: {
                                        line: 13,
                                        column: 27,
                                        fixed: true,
                                        source: 'viewpath/html/RepeatField.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref4'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'value',
                                    loc: {
                                        start: {
                                            line: 13,
                                            column: 22,
                                            fixed: true,
                                            source: 'viewpath/html/RepeatField.ion'
                                        },
                                        end: {
                                            line: 13,
                                            column: 27,
                                            fixed: true,
                                            source: 'viewpath/html/RepeatField.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '2'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'displayName',
                                loc: {
                                    start: {
                                        line: 14,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/RepeatField.ion'
                                    },
                                    end: {
                                        line: 14,
                                        column: 23,
                                        fixed: true,
                                        source: 'viewpath/html/RepeatField.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'Schema',
                                        loc: {
                                            start: {
                                                line: 14,
                                                column: 26,
                                                fixed: true,
                                                source: 'viewpath/html/RepeatField.ion'
                                            },
                                            end: {
                                                line: 14,
                                                column: 32,
                                                fixed: true,
                                                source: 'viewpath/html/RepeatField.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'getDisplayName',
                                        loc: {
                                            start: {
                                                line: 14,
                                                column: 33,
                                                fixed: true,
                                                source: 'viewpath/html/RepeatField.ion'
                                            },
                                            end: {
                                                line: 14,
                                                column: 47,
                                                fixed: true,
                                                source: 'viewpath/html/RepeatField.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 14,
                                            column: 26,
                                            fixed: true,
                                            source: 'viewpath/html/RepeatField.ion'
                                        },
                                        end: {
                                            line: 14,
                                            column: 47,
                                            fixed: true,
                                            source: 'viewpath/html/RepeatField.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'Identifier',
                                        name: 'property',
                                        loc: {
                                            start: {
                                                line: 14,
                                                column: 48,
                                                fixed: true,
                                                source: 'viewpath/html/RepeatField.ion'
                                            },
                                            end: {
                                                line: 14,
                                                column: 56,
                                                fixed: true,
                                                source: 'viewpath/html/RepeatField.ion'
                                            }
                                        }
                                    }],
                                loc: {
                                    start: {
                                        line: 14,
                                        column: 26,
                                        fixed: true,
                                        source: 'viewpath/html/RepeatField.ion'
                                    },
                                    end: {
                                        line: 14,
                                        column: 57,
                                        fixed: true,
                                        source: 'viewpath/html/RepeatField.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '3'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'checkboxes',
                                loc: {
                                    start: {
                                        line: 15,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/RepeatField.ion'
                                    },
                                    end: {
                                        line: 15,
                                        column: 22,
                                        fixed: true,
                                        source: 'viewpath/html/RepeatField.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'ArrayExpression',
                                    elements: []
                                },
                                properties: [{
                                        type: 'ForOfStatement',
                                        left: {
                                            type: 'VariableDeclaration',
                                            declarations: [
                                                {
                                                    type: 'VariableDeclarator',
                                                    id: {
                                                        type: 'Identifier',
                                                        name: 'day',
                                                        loc: {
                                                            start: {
                                                                line: 16,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            },
                                                            end: {
                                                                line: 16,
                                                                column: 19,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            }
                                                        }
                                                    },
                                                    init: null
                                                },
                                                {
                                                    type: 'VariableDeclarator',
                                                    id: {
                                                        type: 'Identifier',
                                                        name: 'index',
                                                        loc: {
                                                            start: {
                                                                line: 16,
                                                                column: 21,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            },
                                                            end: {
                                                                line: 16,
                                                                column: 26,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            }
                                                        }
                                                    },
                                                    init: null
                                                }
                                            ],
                                            kind: 'let'
                                        },
                                        right: {
                                            type: 'Identifier',
                                            name: 'daysOfWeek',
                                            loc: {
                                                start: {
                                                    line: 16,
                                                    column: 30,
                                                    fixed: true,
                                                    source: 'viewpath/html/RepeatField.ion'
                                                },
                                                end: {
                                                    line: 16,
                                                    column: 40,
                                                    fixed: true,
                                                    source: 'viewpath/html/RepeatField.ion'
                                                }
                                            }
                                        },
                                        body: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'PaperCheckbox',
                                                                loc: {
                                                                    start: {
                                                                        line: 17,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/RepeatField.ion'
                                                                    },
                                                                    end: {
                                                                        line: 17,
                                                                        column: 29,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/RepeatField.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [],
                                                            loc: {
                                                                start: {
                                                                    line: 17,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/RepeatField.ion'
                                                                },
                                                                end: {
                                                                    line: 17,
                                                                    column: 31,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/RepeatField.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'style',
                                                                    loc: {
                                                                        start: {
                                                                            line: 18,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/RepeatField.ion'
                                                                        },
                                                                        end: {
                                                                            line: 18,
                                                                            column: 25,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/RepeatField.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'ObjectExpression',
                                                                    properties: [{
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'marginRight',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 19,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/RepeatField.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 19,
                                                                                        column: 35,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/RepeatField.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: '16px'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'Function',
                                                                        context: false,
                                                                        value: function (day) {
                                                                            return day.substring(0, 1);
                                                                        }
                                                                    },
                                                                    arguments: [{
                                                                            type: 'Identifier',
                                                                            name: 'day',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 20,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/RepeatField.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 20,
                                                                                    column: 27,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/RepeatField.ion'
                                                                                }
                                                                            }
                                                                        }],
                                                                    loc: {
                                                                        start: {
                                                                            line: 20,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/RepeatField.ion'
                                                                        },
                                                                        end: {
                                                                            line: 20,
                                                                            column: 51,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/RepeatField.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 20,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/RepeatField.ion'
                                                                    },
                                                                    end: {
                                                                        line: 20,
                                                                        column: 51,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/RepeatField.ion'
                                                                    }
                                                                },
                                                                order: '1'
                                                            }
                                                        ]
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 17,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/RepeatField.ion'
                                                        },
                                                        end: {
                                                            line: 21,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'viewpath/html/RepeatField.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        remove: null,
                                        order: '0'
                                    }]
                            }
                        }],
                    kind: 'let',
                    order: '4'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'setValue',
                                loc: {
                                    start: {
                                        line: 21,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/RepeatField.ion'
                                    },
                                    end: {
                                        line: 21,
                                        column: 20,
                                        fixed: true,
                                        source: 'viewpath/html/RepeatField.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'Function',
                                context: true,
                                value: function (_context) {
                                    return function (value) {
                                        var checkboxes = _context.get('checkboxes');
                                        for (var _i = 0; _i < checkboxes.length; _i++) {
                                            var index = _i;
                                            var checkbox = checkboxes[_i];
                                            checkbox.checked = (value & 1 << index) !== 0;
                                        }
                                    };
                                }
                            }
                        }],
                    kind: 'let',
                    order: '5'
                },
                {
                    type: 'IfStatement',
                    test: {
                        type: 'Identifier',
                        name: 'value',
                        loc: {
                            start: {
                                line: 25,
                                column: 11,
                                fixed: true,
                                source: 'viewpath/html/RepeatField.ion'
                            },
                            end: {
                                line: 25,
                                column: 16,
                                fixed: true,
                                source: 'viewpath/html/RepeatField.ion'
                            }
                        }
                    },
                    consequent: {
                        type: 'BlockStatement',
                        body: [{
                                type: 'ExpressionStatement',
                                expression: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'Identifier',
                                        name: 'setValue',
                                        loc: {
                                            start: {
                                                line: 26,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/RepeatField.ion'
                                            },
                                            end: {
                                                line: 26,
                                                column: 20,
                                                fixed: true,
                                                source: 'viewpath/html/RepeatField.ion'
                                            }
                                        }
                                    },
                                    arguments: [{
                                            type: 'Identifier',
                                            name: 'value',
                                            loc: {
                                                start: {
                                                    line: 26,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'viewpath/html/RepeatField.ion'
                                                },
                                                end: {
                                                    line: 26,
                                                    column: 26,
                                                    fixed: true,
                                                    source: 'viewpath/html/RepeatField.ion'
                                                }
                                            }
                                        }],
                                    loc: {
                                        start: {
                                            line: 26,
                                            column: 12,
                                            fixed: true,
                                            source: 'viewpath/html/RepeatField.ion'
                                        },
                                        end: {
                                            line: 26,
                                            column: 27,
                                            fixed: true,
                                            source: 'viewpath/html/RepeatField.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 26,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/RepeatField.ion'
                                    },
                                    end: {
                                        line: 26,
                                        column: 27,
                                        fixed: true,
                                        source: 'viewpath/html/RepeatField.ion'
                                    }
                                },
                                order: '0'
                            }]
                    },
                    alternate: null,
                    order: '6'
                },
                {
                    type: 'ReturnStatement',
                    argument: {
                        type: 'CallExpression',
                        callee: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: 'Object'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'defineProperties'
                            }
                        },
                        arguments: [
                            {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'Identifier',
                                        name: 'Div',
                                        loc: {
                                            start: {
                                                line: 28,
                                                column: 15,
                                                fixed: true,
                                                source: 'viewpath/html/RepeatField.ion'
                                            },
                                            end: {
                                                line: 28,
                                                column: 18,
                                                fixed: true,
                                                source: 'viewpath/html/RepeatField.ion'
                                            }
                                        }
                                    },
                                    arguments: [],
                                    loc: {
                                        start: {
                                            line: 28,
                                            column: 15,
                                            fixed: true,
                                            source: 'viewpath/html/RepeatField.ion'
                                        },
                                        end: {
                                            line: 28,
                                            column: 20,
                                            fixed: true,
                                            source: 'viewpath/html/RepeatField.ion'
                                        }
                                    }
                                },
                                properties: [
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'style',
                                            loc: {
                                                start: {
                                                    line: 37,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/RepeatField.ion'
                                                },
                                                end: {
                                                    line: 37,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'viewpath/html/RepeatField.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'ObjectExpression',
                                            properties: [{
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'margin',
                                                        loc: {
                                                            start: {
                                                                line: 38,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            },
                                                            end: {
                                                                line: 38,
                                                                column: 22,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: '8px 0px'
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                }]
                                        },
                                        kind: 'init',
                                        order: '0'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'Identifier',
                                                name: 'Label',
                                                loc: {
                                                    start: {
                                                        line: 39,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/RepeatField.ion'
                                                    },
                                                    end: {
                                                        line: 39,
                                                        column: 17,
                                                        fixed: true,
                                                        source: 'viewpath/html/RepeatField.ion'
                                                    }
                                                }
                                            },
                                            arguments: [{
                                                    type: 'Identifier',
                                                    name: 'displayName',
                                                    loc: {
                                                        start: {
                                                            line: 39,
                                                            column: 18,
                                                            fixed: true,
                                                            source: 'viewpath/html/RepeatField.ion'
                                                        },
                                                        end: {
                                                            line: 39,
                                                            column: 29,
                                                            fixed: true,
                                                            source: 'viewpath/html/RepeatField.ion'
                                                        }
                                                    }
                                                }],
                                            loc: {
                                                start: {
                                                    line: 39,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/RepeatField.ion'
                                                },
                                                end: {
                                                    line: 39,
                                                    column: 30,
                                                    fixed: true,
                                                    source: 'viewpath/html/RepeatField.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 39,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/RepeatField.ion'
                                            },
                                            end: {
                                                line: 39,
                                                column: 30,
                                                fixed: true,
                                                source: 'viewpath/html/RepeatField.ion'
                                            }
                                        },
                                        order: '1'
                                    },
                                    {
                                        type: 'ForOfStatement',
                                        left: {
                                            type: 'VariableDeclaration',
                                            declarations: [{
                                                    type: 'VariableDeclarator',
                                                    id: {
                                                        type: 'Identifier',
                                                        name: 'checkbox',
                                                        loc: {
                                                            start: {
                                                                line: 40,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            },
                                                            end: {
                                                                line: 40,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            }
                                                        }
                                                    },
                                                    init: null
                                                }],
                                            kind: 'let'
                                        },
                                        right: {
                                            type: 'Identifier',
                                            name: 'checkboxes',
                                            loc: {
                                                start: {
                                                    line: 40,
                                                    column: 28,
                                                    fixed: true,
                                                    source: 'viewpath/html/RepeatField.ion'
                                                },
                                                end: {
                                                    line: 40,
                                                    column: 38,
                                                    fixed: true,
                                                    source: 'viewpath/html/RepeatField.ion'
                                                }
                                            }
                                        },
                                        body: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'Identifier',
                                                        name: 'checkbox',
                                                        loc: {
                                                            start: {
                                                                line: 41,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            },
                                                            end: {
                                                                line: 41,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 41,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/RepeatField.ion'
                                                        },
                                                        end: {
                                                            line: 41,
                                                            column: 24,
                                                            fixed: true,
                                                            source: 'viewpath/html/RepeatField.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        remove: null,
                                        order: '2'
                                    }
                                ]
                            },
                            {
                                type: 'ObjectExpression',
                                properties: [{
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'valueJSON',
                                            loc: {
                                                start: {
                                                    line: 29,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'viewpath/html/RepeatField.ion'
                                                },
                                                end: {
                                                    line: 29,
                                                    column: 30,
                                                    fixed: true,
                                                    source: 'viewpath/html/RepeatField.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'ObjectExpression',
                                            properties: [
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'get',
                                                        loc: {
                                                            start: {
                                                                line: 30,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            },
                                                            end: {
                                                                line: 30,
                                                                column: 19,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Function',
                                                        context: true,
                                                        value: function (_context2) {
                                                            return function () {
                                                                var checkboxes = _context2.get('checkboxes');
                                                                var value = 0;
                                                                for (var _i2 = 0; _i2 < checkboxes.length; _i2++) {
                                                                    var index = _i2;
                                                                    var checkbox = checkboxes[_i2];
                                                                    if (checkbox.checked) {
                                                                        value += 1 << index;
                                                                    }
                                                                }
                                                                return value;
                                                            };
                                                        }
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'set',
                                                        loc: {
                                                            start: {
                                                                line: 36,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            },
                                                            end: {
                                                                line: 36,
                                                                column: 19,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Identifier',
                                                        name: 'setValue',
                                                        loc: {
                                                            start: {
                                                                line: 36,
                                                                column: 21,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            },
                                                            end: {
                                                                line: 36,
                                                                column: 29,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            }
                                                        }
                                                    },
                                                    kind: 'init',
                                                    order: '1'
                                                }
                                            ]
                                        },
                                        kind: 'init',
                                        define: false,
                                        order: '0'
                                    }]
                            }
                        ]
                    },
                    order: '7'
                }
            ],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'DaysOfWeek',
                loc: {
                    start: {
                        line: 12,
                        column: 4,
                        fixed: true,
                        source: 'viewpath/html/RepeatField.ion'
                    },
                    end: {
                        line: 12,
                        column: 14,
                        fixed: true,
                        source: 'viewpath/html/RepeatField.ion'
                    }
                }
            }
        }, {
            this: this,
            args: args,
            glass: glass,
            viewpath: viewpath,
            _ref: _ref,
            _ref2: _ref2,
            _ref3: _ref3,
            daysOfWeek: daysOfWeek,
            Schema: Schema,
            DateInput: DateInput,
            Field: Field,
            Label: Label,
            TaskRepeat: TaskRepeat,
            RepeatUnit: RepeatUnit,
            DaysOfWeek: DaysOfWeek
        }, null);
    });
module.exports = exports = ion.template(function RepeatField(args) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'RepeatField',
            loc: {
                start: {
                    line: 43,
                    column: 16,
                    fixed: true,
                    source: 'viewpath/html/RepeatField.ion'
                },
                end: {
                    line: 43,
                    column: 27,
                    fixed: true,
                    source: 'viewpath/html/RepeatField.ion'
                }
            }
        },
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: '_ref5'
                        },
                        init: {
                            type: 'Identifier',
                            name: 'args',
                            loc: {
                                start: {
                                    line: 44,
                                    column: 34,
                                    fixed: true,
                                    source: 'viewpath/html/RepeatField.ion'
                                },
                                end: {
                                    line: 44,
                                    column: 38,
                                    fixed: true,
                                    source: 'viewpath/html/RepeatField.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'property',
                            loc: {
                                start: {
                                    line: 44,
                                    column: 9,
                                    fixed: true,
                                    source: 'viewpath/html/RepeatField.ion'
                                },
                                end: {
                                    line: 44,
                                    column: 17,
                                    fixed: true,
                                    source: 'viewpath/html/RepeatField.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref5'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'property',
                                loc: {
                                    start: {
                                        line: 44,
                                        column: 9,
                                        fixed: true,
                                        source: 'viewpath/html/RepeatField.ion'
                                    },
                                    end: {
                                        line: 44,
                                        column: 17,
                                        fixed: true,
                                        source: 'viewpath/html/RepeatField.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'object',
                            loc: {
                                start: {
                                    line: 44,
                                    column: 18,
                                    fixed: true,
                                    source: 'viewpath/html/RepeatField.ion'
                                },
                                end: {
                                    line: 44,
                                    column: 24,
                                    fixed: true,
                                    source: 'viewpath/html/RepeatField.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref5'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'object',
                                loc: {
                                    start: {
                                        line: 44,
                                        column: 18,
                                        fixed: true,
                                        source: 'viewpath/html/RepeatField.ion'
                                    },
                                    end: {
                                        line: 44,
                                        column: 24,
                                        fixed: true,
                                        source: 'viewpath/html/RepeatField.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'value',
                            loc: {
                                start: {
                                    line: 44,
                                    column: 25,
                                    fixed: true,
                                    source: 'viewpath/html/RepeatField.ion'
                                },
                                end: {
                                    line: 44,
                                    column: 30,
                                    fixed: true,
                                    source: 'viewpath/html/RepeatField.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref5'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'value',
                                loc: {
                                    start: {
                                        line: 44,
                                        column: 25,
                                        fixed: true,
                                        source: 'viewpath/html/RepeatField.ion'
                                    },
                                    end: {
                                        line: 44,
                                        column: 30,
                                        fixed: true,
                                        source: 'viewpath/html/RepeatField.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '3'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'daysInitialValue',
                            loc: {
                                start: {
                                    line: 45,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/RepeatField.ion'
                                },
                                end: {
                                    line: 45,
                                    column: 24,
                                    fixed: true,
                                    source: 'viewpath/html/RepeatField.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Function',
                                context: true,
                                value: function (_context3) {
                                    return function () {
                                        var value = _context3.get('value'), object = _context3.get('object');
                                        if (value != null) {
                                            return value.days;
                                        }
                                        var start = object != null ? object.start : void 0;
                                        if (!(start != null)) {
                                            return 2;
                                        }
                                        var dateTime = new Date(start);
                                        var days = Math.pow(2, dateTime.getDay());
                                        return days;
                                    };
                                }
                            },
                            arguments: [],
                            loc: {
                                start: {
                                    line: 45,
                                    column: 27,
                                    fixed: true,
                                    source: 'viewpath/html/RepeatField.ion'
                                },
                                end: {
                                    line: 54,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/RepeatField.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '4'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'displayName',
                            loc: {
                                start: {
                                    line: 54,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/RepeatField.ion'
                                },
                                end: {
                                    line: 54,
                                    column: 19,
                                    fixed: true,
                                    source: 'viewpath/html/RepeatField.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'Schema',
                                    loc: {
                                        start: {
                                            line: 54,
                                            column: 22,
                                            fixed: true,
                                            source: 'viewpath/html/RepeatField.ion'
                                        },
                                        end: {
                                            line: 54,
                                            column: 28,
                                            fixed: true,
                                            source: 'viewpath/html/RepeatField.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'getDisplayName',
                                    loc: {
                                        start: {
                                            line: 54,
                                            column: 29,
                                            fixed: true,
                                            source: 'viewpath/html/RepeatField.ion'
                                        },
                                        end: {
                                            line: 54,
                                            column: 43,
                                            fixed: true,
                                            source: 'viewpath/html/RepeatField.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 54,
                                        column: 22,
                                        fixed: true,
                                        source: 'viewpath/html/RepeatField.ion'
                                    },
                                    end: {
                                        line: 54,
                                        column: 43,
                                        fixed: true,
                                        source: 'viewpath/html/RepeatField.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'Identifier',
                                    name: 'property',
                                    loc: {
                                        start: {
                                            line: 54,
                                            column: 44,
                                            fixed: true,
                                            source: 'viewpath/html/RepeatField.ion'
                                        },
                                        end: {
                                            line: 54,
                                            column: 52,
                                            fixed: true,
                                            source: 'viewpath/html/RepeatField.ion'
                                        }
                                    }
                                }],
                            loc: {
                                start: {
                                    line: 54,
                                    column: 22,
                                    fixed: true,
                                    source: 'viewpath/html/RepeatField.ion'
                                },
                                end: {
                                    line: 54,
                                    column: 53,
                                    fixed: true,
                                    source: 'viewpath/html/RepeatField.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '5'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'repeat',
                            loc: {
                                start: {
                                    line: 55,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/RepeatField.ion'
                                },
                                end: {
                                    line: 55,
                                    column: 14,
                                    fixed: true,
                                    source: 'viewpath/html/RepeatField.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'PaperCheckbox',
                                loc: {
                                    start: {
                                        line: 55,
                                        column: 17,
                                        fixed: true,
                                        source: 'viewpath/html/RepeatField.ion'
                                    },
                                    end: {
                                        line: 55,
                                        column: 30,
                                        fixed: true,
                                        source: 'viewpath/html/RepeatField.ion'
                                    }
                                }
                            },
                            arguments: [],
                            loc: {
                                start: {
                                    line: 55,
                                    column: 17,
                                    fixed: true,
                                    source: 'viewpath/html/RepeatField.ion'
                                },
                                end: {
                                    line: 55,
                                    column: 32,
                                    fixed: true,
                                    source: 'viewpath/html/RepeatField.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '6'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'unit',
                            loc: {
                                start: {
                                    line: 56,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/RepeatField.ion'
                                },
                                end: {
                                    line: 56,
                                    column: 12,
                                    fixed: true,
                                    source: 'viewpath/html/RepeatField.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Field',
                                loc: {
                                    start: {
                                        line: 56,
                                        column: 15,
                                        fixed: true,
                                        source: 'viewpath/html/RepeatField.ion'
                                    },
                                    end: {
                                        line: 56,
                                        column: 20,
                                        fixed: true,
                                        source: 'viewpath/html/RepeatField.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ObjectExpression',
                                    properties: [
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'property',
                                                loc: {
                                                    start: {
                                                        line: 56,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'viewpath/html/RepeatField.ion'
                                                    },
                                                    end: {
                                                        line: 56,
                                                        column: 30,
                                                        fixed: true,
                                                        source: 'viewpath/html/RepeatField.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'TaskRepeat',
                                                        loc: {
                                                            start: {
                                                                line: 56,
                                                                column: 31,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            },
                                                            end: {
                                                                line: 56,
                                                                column: 41,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'properties',
                                                        loc: {
                                                            start: {
                                                                line: 56,
                                                                column: 42,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            },
                                                            end: {
                                                                line: 56,
                                                                column: 52,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 56,
                                                            column: 31,
                                                            fixed: true,
                                                            source: 'viewpath/html/RepeatField.ion'
                                                        },
                                                        end: {
                                                            line: 56,
                                                            column: 52,
                                                            fixed: true,
                                                            source: 'viewpath/html/RepeatField.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'unit',
                                                    loc: {
                                                        start: {
                                                            line: 56,
                                                            column: 53,
                                                            fixed: true,
                                                            source: 'viewpath/html/RepeatField.ion'
                                                        },
                                                        end: {
                                                            line: 56,
                                                            column: 57,
                                                            fixed: true,
                                                            source: 'viewpath/html/RepeatField.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 56,
                                                        column: 31,
                                                        fixed: true,
                                                        source: 'viewpath/html/RepeatField.ion'
                                                    },
                                                    end: {
                                                        line: 56,
                                                        column: 57,
                                                        fixed: true,
                                                        source: 'viewpath/html/RepeatField.ion'
                                                    }
                                                }
                                            },
                                            kind: 'init',
                                            order: '0'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'label',
                                                loc: {
                                                    start: {
                                                        line: 56,
                                                        column: 58,
                                                        fixed: true,
                                                        source: 'viewpath/html/RepeatField.ion'
                                                    },
                                                    end: {
                                                        line: 56,
                                                        column: 63,
                                                        fixed: true,
                                                        source: 'viewpath/html/RepeatField.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: ''
                                            },
                                            kind: 'init',
                                            order: '1'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'value',
                                                loc: {
                                                    start: {
                                                        line: 56,
                                                        column: 67,
                                                        fixed: true,
                                                        source: 'viewpath/html/RepeatField.ion'
                                                    },
                                                    end: {
                                                        line: 56,
                                                        column: 72,
                                                        fixed: true,
                                                        source: 'viewpath/html/RepeatField.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'ConditionalExpression',
                                                test: {
                                                    type: 'BinaryExpression',
                                                    operator: '!=',
                                                    left: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'value',
                                                            loc: {
                                                                start: {
                                                                    line: 56,
                                                                    column: 73,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/RepeatField.ion'
                                                                },
                                                                end: {
                                                                    line: 56,
                                                                    column: 78,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/RepeatField.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'unit',
                                                            loc: {
                                                                start: {
                                                                    line: 56,
                                                                    column: 80,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/RepeatField.ion'
                                                                },
                                                                end: {
                                                                    line: 56,
                                                                    column: 84,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/RepeatField.ion'
                                                                }
                                                            }
                                                        },
                                                        existential: true,
                                                        loc: {
                                                            start: {
                                                                line: 56,
                                                                column: 73,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            },
                                                            end: {
                                                                line: 56,
                                                                column: 84,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            }
                                                        }
                                                    },
                                                    right: {
                                                        type: 'Literal',
                                                        value: null
                                                    }
                                                },
                                                consequent: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'value',
                                                        loc: {
                                                            start: {
                                                                line: 56,
                                                                column: 73,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            },
                                                            end: {
                                                                line: 56,
                                                                column: 78,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'unit',
                                                        loc: {
                                                            start: {
                                                                line: 56,
                                                                column: 80,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            },
                                                            end: {
                                                                line: 56,
                                                                column: 84,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            }
                                                        }
                                                    },
                                                    existential: true,
                                                    loc: {
                                                        start: {
                                                            line: 56,
                                                            column: 73,
                                                            fixed: true,
                                                            source: 'viewpath/html/RepeatField.ion'
                                                        },
                                                        end: {
                                                            line: 56,
                                                            column: 84,
                                                            fixed: true,
                                                            source: 'viewpath/html/RepeatField.ion'
                                                        }
                                                    }
                                                },
                                                alternate: {
                                                    type: 'Literal',
                                                    value: 1
                                                }
                                            },
                                            kind: 'init',
                                            order: '2'
                                        }
                                    ]
                                }],
                            loc: {
                                start: {
                                    line: 56,
                                    column: 15,
                                    fixed: true,
                                    source: 'viewpath/html/RepeatField.ion'
                                },
                                end: {
                                    line: 56,
                                    column: 90,
                                    fixed: true,
                                    source: 'viewpath/html/RepeatField.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '7'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'count',
                            loc: {
                                start: {
                                    line: 57,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/RepeatField.ion'
                                },
                                end: {
                                    line: 57,
                                    column: 13,
                                    fixed: true,
                                    source: 'viewpath/html/RepeatField.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Field',
                                loc: {
                                    start: {
                                        line: 57,
                                        column: 16,
                                        fixed: true,
                                        source: 'viewpath/html/RepeatField.ion'
                                    },
                                    end: {
                                        line: 57,
                                        column: 21,
                                        fixed: true,
                                        source: 'viewpath/html/RepeatField.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ObjectExpression',
                                    properties: [
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'property',
                                                loc: {
                                                    start: {
                                                        line: 57,
                                                        column: 23,
                                                        fixed: true,
                                                        source: 'viewpath/html/RepeatField.ion'
                                                    },
                                                    end: {
                                                        line: 57,
                                                        column: 31,
                                                        fixed: true,
                                                        source: 'viewpath/html/RepeatField.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'TaskRepeat',
                                                        loc: {
                                                            start: {
                                                                line: 57,
                                                                column: 32,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            },
                                                            end: {
                                                                line: 57,
                                                                column: 42,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'properties',
                                                        loc: {
                                                            start: {
                                                                line: 57,
                                                                column: 43,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            },
                                                            end: {
                                                                line: 57,
                                                                column: 53,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 57,
                                                            column: 32,
                                                            fixed: true,
                                                            source: 'viewpath/html/RepeatField.ion'
                                                        },
                                                        end: {
                                                            line: 57,
                                                            column: 53,
                                                            fixed: true,
                                                            source: 'viewpath/html/RepeatField.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'count',
                                                    loc: {
                                                        start: {
                                                            line: 57,
                                                            column: 54,
                                                            fixed: true,
                                                            source: 'viewpath/html/RepeatField.ion'
                                                        },
                                                        end: {
                                                            line: 57,
                                                            column: 59,
                                                            fixed: true,
                                                            source: 'viewpath/html/RepeatField.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 57,
                                                        column: 32,
                                                        fixed: true,
                                                        source: 'viewpath/html/RepeatField.ion'
                                                    },
                                                    end: {
                                                        line: 57,
                                                        column: 59,
                                                        fixed: true,
                                                        source: 'viewpath/html/RepeatField.ion'
                                                    }
                                                }
                                            },
                                            kind: 'init',
                                            order: '0'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'label',
                                                loc: {
                                                    start: {
                                                        line: 57,
                                                        column: 60,
                                                        fixed: true,
                                                        source: 'viewpath/html/RepeatField.ion'
                                                    },
                                                    end: {
                                                        line: 57,
                                                        column: 65,
                                                        fixed: true,
                                                        source: 'viewpath/html/RepeatField.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: 'Repeat every'
                                            },
                                            kind: 'init',
                                            order: '1'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'value',
                                                loc: {
                                                    start: {
                                                        line: 57,
                                                        column: 81,
                                                        fixed: true,
                                                        source: 'viewpath/html/RepeatField.ion'
                                                    },
                                                    end: {
                                                        line: 57,
                                                        column: 86,
                                                        fixed: true,
                                                        source: 'viewpath/html/RepeatField.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'ConditionalExpression',
                                                test: {
                                                    type: 'BinaryExpression',
                                                    operator: '!=',
                                                    left: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'value',
                                                            loc: {
                                                                start: {
                                                                    line: 57,
                                                                    column: 87,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/RepeatField.ion'
                                                                },
                                                                end: {
                                                                    line: 57,
                                                                    column: 92,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/RepeatField.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'count',
                                                            loc: {
                                                                start: {
                                                                    line: 57,
                                                                    column: 94,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/RepeatField.ion'
                                                                },
                                                                end: {
                                                                    line: 57,
                                                                    column: 99,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/RepeatField.ion'
                                                                }
                                                            }
                                                        },
                                                        existential: true,
                                                        loc: {
                                                            start: {
                                                                line: 57,
                                                                column: 87,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            },
                                                            end: {
                                                                line: 57,
                                                                column: 99,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            }
                                                        }
                                                    },
                                                    right: {
                                                        type: 'Literal',
                                                        value: null
                                                    }
                                                },
                                                consequent: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'value',
                                                        loc: {
                                                            start: {
                                                                line: 57,
                                                                column: 87,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            },
                                                            end: {
                                                                line: 57,
                                                                column: 92,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'count',
                                                        loc: {
                                                            start: {
                                                                line: 57,
                                                                column: 94,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            },
                                                            end: {
                                                                line: 57,
                                                                column: 99,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            }
                                                        }
                                                    },
                                                    existential: true,
                                                    loc: {
                                                        start: {
                                                            line: 57,
                                                            column: 87,
                                                            fixed: true,
                                                            source: 'viewpath/html/RepeatField.ion'
                                                        },
                                                        end: {
                                                            line: 57,
                                                            column: 99,
                                                            fixed: true,
                                                            source: 'viewpath/html/RepeatField.ion'
                                                        }
                                                    }
                                                },
                                                alternate: {
                                                    type: 'Literal',
                                                    value: 1
                                                }
                                            },
                                            kind: 'init',
                                            order: '2'
                                        }
                                    ]
                                }],
                            loc: {
                                start: {
                                    line: 57,
                                    column: 16,
                                    fixed: true,
                                    source: 'viewpath/html/RepeatField.ion'
                                },
                                end: {
                                    line: 57,
                                    column: 105,
                                    fixed: true,
                                    source: 'viewpath/html/RepeatField.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '8'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'repeatByDayOfWeek',
                            loc: {
                                start: {
                                    line: 58,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/RepeatField.ion'
                                },
                                end: {
                                    line: 58,
                                    column: 25,
                                    fixed: true,
                                    source: 'viewpath/html/RepeatField.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Field',
                                loc: {
                                    start: {
                                        line: 58,
                                        column: 28,
                                        fixed: true,
                                        source: 'viewpath/html/RepeatField.ion'
                                    },
                                    end: {
                                        line: 58,
                                        column: 33,
                                        fixed: true,
                                        source: 'viewpath/html/RepeatField.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ObjectExpression',
                                    properties: [
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'property',
                                                loc: {
                                                    start: {
                                                        line: 58,
                                                        column: 35,
                                                        fixed: true,
                                                        source: 'viewpath/html/RepeatField.ion'
                                                    },
                                                    end: {
                                                        line: 58,
                                                        column: 43,
                                                        fixed: true,
                                                        source: 'viewpath/html/RepeatField.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'TaskRepeat',
                                                        loc: {
                                                            start: {
                                                                line: 58,
                                                                column: 44,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            },
                                                            end: {
                                                                line: 58,
                                                                column: 54,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'properties',
                                                        loc: {
                                                            start: {
                                                                line: 58,
                                                                column: 55,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            },
                                                            end: {
                                                                line: 58,
                                                                column: 65,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 58,
                                                            column: 44,
                                                            fixed: true,
                                                            source: 'viewpath/html/RepeatField.ion'
                                                        },
                                                        end: {
                                                            line: 58,
                                                            column: 65,
                                                            fixed: true,
                                                            source: 'viewpath/html/RepeatField.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'repeatByDayOfWeek',
                                                    loc: {
                                                        start: {
                                                            line: 58,
                                                            column: 66,
                                                            fixed: true,
                                                            source: 'viewpath/html/RepeatField.ion'
                                                        },
                                                        end: {
                                                            line: 58,
                                                            column: 83,
                                                            fixed: true,
                                                            source: 'viewpath/html/RepeatField.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 58,
                                                        column: 44,
                                                        fixed: true,
                                                        source: 'viewpath/html/RepeatField.ion'
                                                    },
                                                    end: {
                                                        line: 58,
                                                        column: 83,
                                                        fixed: true,
                                                        source: 'viewpath/html/RepeatField.ion'
                                                    }
                                                }
                                            },
                                            kind: 'init',
                                            order: '0'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'value',
                                                loc: {
                                                    start: {
                                                        line: 58,
                                                        column: 84,
                                                        fixed: true,
                                                        source: 'viewpath/html/RepeatField.ion'
                                                    },
                                                    end: {
                                                        line: 58,
                                                        column: 89,
                                                        fixed: true,
                                                        source: 'viewpath/html/RepeatField.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'ConditionalExpression',
                                                test: {
                                                    type: 'BinaryExpression',
                                                    operator: '!=',
                                                    left: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'value',
                                                            loc: {
                                                                start: {
                                                                    line: 58,
                                                                    column: 90,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/RepeatField.ion'
                                                                },
                                                                end: {
                                                                    line: 58,
                                                                    column: 95,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/RepeatField.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'repeatByDayOfWeek',
                                                            loc: {
                                                                start: {
                                                                    line: 58,
                                                                    column: 97,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/RepeatField.ion'
                                                                },
                                                                end: {
                                                                    line: 58,
                                                                    column: 114,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/RepeatField.ion'
                                                                }
                                                            }
                                                        },
                                                        existential: true,
                                                        loc: {
                                                            start: {
                                                                line: 58,
                                                                column: 90,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            },
                                                            end: {
                                                                line: 58,
                                                                column: 114,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            }
                                                        }
                                                    },
                                                    right: {
                                                        type: 'Literal',
                                                        value: null
                                                    }
                                                },
                                                consequent: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'value',
                                                        loc: {
                                                            start: {
                                                                line: 58,
                                                                column: 90,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            },
                                                            end: {
                                                                line: 58,
                                                                column: 95,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'repeatByDayOfWeek',
                                                        loc: {
                                                            start: {
                                                                line: 58,
                                                                column: 97,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            },
                                                            end: {
                                                                line: 58,
                                                                column: 114,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            }
                                                        }
                                                    },
                                                    existential: true,
                                                    loc: {
                                                        start: {
                                                            line: 58,
                                                            column: 90,
                                                            fixed: true,
                                                            source: 'viewpath/html/RepeatField.ion'
                                                        },
                                                        end: {
                                                            line: 58,
                                                            column: 114,
                                                            fixed: true,
                                                            source: 'viewpath/html/RepeatField.ion'
                                                        }
                                                    }
                                                },
                                                alternate: {
                                                    type: 'Literal',
                                                    value: 0
                                                }
                                            },
                                            kind: 'init',
                                            order: '1'
                                        }
                                    ]
                                }],
                            loc: {
                                start: {
                                    line: 58,
                                    column: 28,
                                    fixed: true,
                                    source: 'viewpath/html/RepeatField.ion'
                                },
                                end: {
                                    line: 58,
                                    column: 120,
                                    fixed: true,
                                    source: 'viewpath/html/RepeatField.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '9'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'days',
                            loc: {
                                start: {
                                    line: 59,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/RepeatField.ion'
                                },
                                end: {
                                    line: 59,
                                    column: 12,
                                    fixed: true,
                                    source: 'viewpath/html/RepeatField.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'DaysOfWeek',
                                loc: {
                                    start: {
                                        line: 59,
                                        column: 15,
                                        fixed: true,
                                        source: 'viewpath/html/RepeatField.ion'
                                    },
                                    end: {
                                        line: 59,
                                        column: 25,
                                        fixed: true,
                                        source: 'viewpath/html/RepeatField.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ObjectExpression',
                                    properties: [
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'property',
                                                loc: {
                                                    start: {
                                                        line: 59,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'viewpath/html/RepeatField.ion'
                                                    },
                                                    end: {
                                                        line: 59,
                                                        column: 35,
                                                        fixed: true,
                                                        source: 'viewpath/html/RepeatField.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'TaskRepeat',
                                                        loc: {
                                                            start: {
                                                                line: 59,
                                                                column: 36,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            },
                                                            end: {
                                                                line: 59,
                                                                column: 46,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'properties',
                                                        loc: {
                                                            start: {
                                                                line: 59,
                                                                column: 47,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            },
                                                            end: {
                                                                line: 59,
                                                                column: 57,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 59,
                                                            column: 36,
                                                            fixed: true,
                                                            source: 'viewpath/html/RepeatField.ion'
                                                        },
                                                        end: {
                                                            line: 59,
                                                            column: 57,
                                                            fixed: true,
                                                            source: 'viewpath/html/RepeatField.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'days',
                                                    loc: {
                                                        start: {
                                                            line: 59,
                                                            column: 58,
                                                            fixed: true,
                                                            source: 'viewpath/html/RepeatField.ion'
                                                        },
                                                        end: {
                                                            line: 59,
                                                            column: 62,
                                                            fixed: true,
                                                            source: 'viewpath/html/RepeatField.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 59,
                                                        column: 36,
                                                        fixed: true,
                                                        source: 'viewpath/html/RepeatField.ion'
                                                    },
                                                    end: {
                                                        line: 59,
                                                        column: 62,
                                                        fixed: true,
                                                        source: 'viewpath/html/RepeatField.ion'
                                                    }
                                                }
                                            },
                                            kind: 'init',
                                            order: '0'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'value',
                                                loc: {
                                                    start: {
                                                        line: 59,
                                                        column: 63,
                                                        fixed: true,
                                                        source: 'viewpath/html/RepeatField.ion'
                                                    },
                                                    end: {
                                                        line: 59,
                                                        column: 68,
                                                        fixed: true,
                                                        source: 'viewpath/html/RepeatField.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Identifier',
                                                name: 'daysInitialValue',
                                                loc: {
                                                    start: {
                                                        line: 59,
                                                        column: 69,
                                                        fixed: true,
                                                        source: 'viewpath/html/RepeatField.ion'
                                                    },
                                                    end: {
                                                        line: 59,
                                                        column: 85,
                                                        fixed: true,
                                                        source: 'viewpath/html/RepeatField.ion'
                                                    }
                                                }
                                            },
                                            kind: 'init',
                                            order: '1'
                                        }
                                    ]
                                }],
                            loc: {
                                start: {
                                    line: 59,
                                    column: 15,
                                    fixed: true,
                                    source: 'viewpath/html/RepeatField.ion'
                                },
                                end: {
                                    line: 59,
                                    column: 87,
                                    fixed: true,
                                    source: 'viewpath/html/RepeatField.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: ':'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'finish',
                            loc: {
                                start: {
                                    line: 61,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/RepeatField.ion'
                                },
                                end: {
                                    line: 61,
                                    column: 14,
                                    fixed: true,
                                    source: 'viewpath/html/RepeatField.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Field',
                                loc: {
                                    start: {
                                        line: 61,
                                        column: 17,
                                        fixed: true,
                                        source: 'viewpath/html/RepeatField.ion'
                                    },
                                    end: {
                                        line: 61,
                                        column: 22,
                                        fixed: true,
                                        source: 'viewpath/html/RepeatField.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ObjectExpression',
                                    properties: [{
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'property',
                                                loc: {
                                                    start: {
                                                        line: 61,
                                                        column: 24,
                                                        fixed: true,
                                                        source: 'viewpath/html/RepeatField.ion'
                                                    },
                                                    end: {
                                                        line: 61,
                                                        column: 32,
                                                        fixed: true,
                                                        source: 'viewpath/html/RepeatField.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'TaskRepeat',
                                                        loc: {
                                                            start: {
                                                                line: 61,
                                                                column: 33,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            },
                                                            end: {
                                                                line: 61,
                                                                column: 43,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'properties',
                                                        loc: {
                                                            start: {
                                                                line: 61,
                                                                column: 44,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            },
                                                            end: {
                                                                line: 61,
                                                                column: 54,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 61,
                                                            column: 33,
                                                            fixed: true,
                                                            source: 'viewpath/html/RepeatField.ion'
                                                        },
                                                        end: {
                                                            line: 61,
                                                            column: 54,
                                                            fixed: true,
                                                            source: 'viewpath/html/RepeatField.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'finish',
                                                    loc: {
                                                        start: {
                                                            line: 61,
                                                            column: 55,
                                                            fixed: true,
                                                            source: 'viewpath/html/RepeatField.ion'
                                                        },
                                                        end: {
                                                            line: 61,
                                                            column: 61,
                                                            fixed: true,
                                                            source: 'viewpath/html/RepeatField.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 61,
                                                        column: 33,
                                                        fixed: true,
                                                        source: 'viewpath/html/RepeatField.ion'
                                                    },
                                                    end: {
                                                        line: 61,
                                                        column: 61,
                                                        fixed: true,
                                                        source: 'viewpath/html/RepeatField.ion'
                                                    }
                                                }
                                            },
                                            kind: 'init',
                                            order: '0'
                                        }]
                                }],
                            loc: {
                                start: {
                                    line: 61,
                                    column: 17,
                                    fixed: true,
                                    source: 'viewpath/html/RepeatField.ion'
                                },
                                end: {
                                    line: 61,
                                    column: 63,
                                    fixed: true,
                                    source: 'viewpath/html/RepeatField.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: ';'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'CallExpression',
                    callee: {
                        type: 'MemberExpression',
                        object: {
                            type: 'Identifier',
                            name: 'Object'
                        },
                        property: {
                            type: 'Identifier',
                            name: 'defineProperties'
                        }
                    },
                    arguments: [
                        {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Div',
                                    loc: {
                                        start: {
                                            line: 62,
                                            column: 11,
                                            fixed: true,
                                            source: 'viewpath/html/RepeatField.ion'
                                        },
                                        end: {
                                            line: 62,
                                            column: 14,
                                            fixed: true,
                                            source: 'viewpath/html/RepeatField.ion'
                                        }
                                    }
                                },
                                arguments: [],
                                loc: {
                                    start: {
                                        line: 62,
                                        column: 11,
                                        fixed: true,
                                        source: 'viewpath/html/RepeatField.ion'
                                    },
                                    end: {
                                        line: 62,
                                        column: 16,
                                        fixed: true,
                                        source: 'viewpath/html/RepeatField.ion'
                                    }
                                }
                            },
                            properties: [
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'ObjectExpression',
                                        objectType: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'Identifier',
                                                name: 'Div',
                                                loc: {
                                                    start: {
                                                        line: 86,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'viewpath/html/RepeatField.ion'
                                                    },
                                                    end: {
                                                        line: 86,
                                                        column: 11,
                                                        fixed: true,
                                                        source: 'viewpath/html/RepeatField.ion'
                                                    }
                                                }
                                            },
                                            arguments: [],
                                            loc: {
                                                start: {
                                                    line: 86,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'viewpath/html/RepeatField.ion'
                                                },
                                                end: {
                                                    line: 86,
                                                    column: 13,
                                                    fixed: true,
                                                    source: 'viewpath/html/RepeatField.ion'
                                                }
                                            }
                                        },
                                        properties: [{
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'ObjectExpression',
                                                    objectType: {
                                                        type: 'Identifier',
                                                        name: 'repeat',
                                                        loc: {
                                                            start: {
                                                                line: 87,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            },
                                                            end: {
                                                                line: 87,
                                                                column: 18,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            }
                                                        }
                                                    },
                                                    properties: [{
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'Identifier',
                                                                name: 'displayName',
                                                                loc: {
                                                                    start: {
                                                                        line: 88,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/RepeatField.ion'
                                                                    },
                                                                    end: {
                                                                        line: 88,
                                                                        column: 27,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/RepeatField.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 88,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/RepeatField.ion'
                                                                },
                                                                end: {
                                                                    line: 88,
                                                                    column: 27,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/RepeatField.ion'
                                                                }
                                                            },
                                                            order: '0'
                                                        }]
                                                },
                                                loc: {
                                                    start: {
                                                        line: 87,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/RepeatField.ion'
                                                    },
                                                    end: {
                                                        line: 89,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'viewpath/html/RepeatField.ion'
                                                    }
                                                },
                                                order: '0'
                                            }]
                                    },
                                    loc: {
                                        start: {
                                            line: 86,
                                            column: 8,
                                            fixed: true,
                                            source: 'viewpath/html/RepeatField.ion'
                                        },
                                        end: {
                                            line: 89,
                                            column: 12,
                                            fixed: true,
                                            source: 'viewpath/html/RepeatField.ion'
                                        }
                                    },
                                    order: '0'
                                },
                                {
                                    type: 'IfStatement',
                                    test: {
                                        type: 'BinaryExpression',
                                        operator: '||',
                                        left: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'repeat',
                                                loc: {
                                                    start: {
                                                        line: 89,
                                                        column: 11,
                                                        fixed: true,
                                                        source: 'viewpath/html/RepeatField.ion'
                                                    },
                                                    end: {
                                                        line: 89,
                                                        column: 17,
                                                        fixed: true,
                                                        source: 'viewpath/html/RepeatField.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'checked',
                                                loc: {
                                                    start: {
                                                        line: 89,
                                                        column: 18,
                                                        fixed: true,
                                                        source: 'viewpath/html/RepeatField.ion'
                                                    },
                                                    end: {
                                                        line: 89,
                                                        column: 25,
                                                        fixed: true,
                                                        source: 'viewpath/html/RepeatField.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 89,
                                                    column: 11,
                                                    fixed: true,
                                                    source: 'viewpath/html/RepeatField.ion'
                                                },
                                                end: {
                                                    line: 89,
                                                    column: 25,
                                                    fixed: true,
                                                    source: 'viewpath/html/RepeatField.ion'
                                                }
                                            }
                                        },
                                        right: {
                                            type: 'Literal',
                                            value: true
                                        }
                                    },
                                    consequent: {
                                        type: 'BlockStatement',
                                        body: [{
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'ObjectExpression',
                                                    objectType: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'Identifier',
                                                            name: 'Div',
                                                            loc: {
                                                                start: {
                                                                    line: 90,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/RepeatField.ion'
                                                                },
                                                                end: {
                                                                    line: 90,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/RepeatField.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [],
                                                        loc: {
                                                            start: {
                                                                line: 90,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            },
                                                            end: {
                                                                line: 90,
                                                                column: 17,
                                                                fixed: true,
                                                                source: 'viewpath/html/RepeatField.ion'
                                                            }
                                                        }
                                                    },
                                                    properties: [
                                                        {
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'ObjectExpression',
                                                                objectType: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'Identifier',
                                                                        name: 'Div',
                                                                        loc: {
                                                                            start: {
                                                                                line: 91,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/RepeatField.ion'
                                                                            },
                                                                            end: {
                                                                                line: 91,
                                                                                column: 19,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/RepeatField.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [{
                                                                            type: 'ObjectExpression',
                                                                            properties: [{
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'class',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 91,
                                                                                                column: 21,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/RepeatField.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 91,
                                                                                                column: 26,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/RepeatField.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Literal',
                                                                                        value: 'layout horizontal'
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                }]
                                                                        }],
                                                                    loc: {
                                                                        start: {
                                                                            line: 91,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/RepeatField.ion'
                                                                        },
                                                                        end: {
                                                                            line: 91,
                                                                            column: 48,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/RepeatField.ion'
                                                                        }
                                                                    }
                                                                },
                                                                properties: [
                                                                    {
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'ObjectExpression',
                                                                            objectType: {
                                                                                type: 'Identifier',
                                                                                name: 'count',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 92,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/RepeatField.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 92,
                                                                                        column: 25,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/RepeatField.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            properties: [{
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'classList',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 93,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/RepeatField.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 93,
                                                                                                column: 33,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/RepeatField.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'ObjectExpression',
                                                                                        properties: [{
                                                                                                type: 'ExpressionStatement',
                                                                                                expression: {
                                                                                                    type: 'Literal',
                                                                                                    value: 'fill'
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 94,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/RepeatField.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 94,
                                                                                                        column: 34,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/RepeatField.ion'
                                                                                                    }
                                                                                                },
                                                                                                order: '0'
                                                                                            }]
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                }]
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 92,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/RepeatField.ion'
                                                                            },
                                                                            end: {
                                                                                line: 95,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/RepeatField.ion'
                                                                            }
                                                                        },
                                                                        order: '0'
                                                                    },
                                                                    {
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'Identifier',
                                                                            name: 'unit',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 95,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/RepeatField.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 95,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/RepeatField.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 95,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/RepeatField.ion'
                                                                            },
                                                                            end: {
                                                                                line: 95,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/RepeatField.ion'
                                                                            }
                                                                        },
                                                                        order: '1'
                                                                    }
                                                                ]
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 91,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/RepeatField.ion'
                                                                },
                                                                end: {
                                                                    line: 96,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/RepeatField.ion'
                                                                }
                                                            },
                                                            order: '0'
                                                        },
                                                        {
                                                            type: 'IfStatement',
                                                            test: {
                                                                type: 'BinaryExpression',
                                                                operator: '===',
                                                                left: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'unit',
                                                                        loc: {
                                                                            start: {
                                                                                line: 96,
                                                                                column: 19,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/RepeatField.ion'
                                                                            },
                                                                            end: {
                                                                                line: 96,
                                                                                column: 23,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/RepeatField.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'valueJSON',
                                                                        loc: {
                                                                            start: {
                                                                                line: 96,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/RepeatField.ion'
                                                                            },
                                                                            end: {
                                                                                line: 96,
                                                                                column: 33,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/RepeatField.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 96,
                                                                            column: 19,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/RepeatField.ion'
                                                                        },
                                                                        end: {
                                                                            line: 96,
                                                                            column: 33,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/RepeatField.ion'
                                                                        }
                                                                    }
                                                                },
                                                                right: {
                                                                    type: 'Literal',
                                                                    value: 1
                                                                }
                                                            },
                                                            consequent: {
                                                                type: 'BlockStatement',
                                                                body: [{
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'Identifier',
                                                                            name: 'days',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 97,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/RepeatField.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 97,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/RepeatField.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 97,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/RepeatField.ion'
                                                                            },
                                                                            end: {
                                                                                line: 97,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/RepeatField.ion'
                                                                            }
                                                                        },
                                                                        order: '0'
                                                                    }]
                                                            },
                                                            alternate: null,
                                                            order: '1'
                                                        },
                                                        {
                                                            type: 'IfStatement',
                                                            test: {
                                                                type: 'BinaryExpression',
                                                                operator: '===',
                                                                left: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'unit',
                                                                        loc: {
                                                                            start: {
                                                                                line: 98,
                                                                                column: 19,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/RepeatField.ion'
                                                                            },
                                                                            end: {
                                                                                line: 98,
                                                                                column: 23,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/RepeatField.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'valueJSON',
                                                                        loc: {
                                                                            start: {
                                                                                line: 98,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/RepeatField.ion'
                                                                            },
                                                                            end: {
                                                                                line: 98,
                                                                                column: 33,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/RepeatField.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 98,
                                                                            column: 19,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/RepeatField.ion'
                                                                        },
                                                                        end: {
                                                                            line: 98,
                                                                            column: 33,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/RepeatField.ion'
                                                                        }
                                                                    }
                                                                },
                                                                right: {
                                                                    type: 'Literal',
                                                                    value: 2
                                                                }
                                                            },
                                                            consequent: {
                                                                type: 'BlockStatement',
                                                                body: [{
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'Identifier',
                                                                            name: 'repeatByDayOfWeek',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 99,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/RepeatField.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 99,
                                                                                    column: 37,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/RepeatField.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 99,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/RepeatField.ion'
                                                                            },
                                                                            end: {
                                                                                line: 99,
                                                                                column: 37,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/RepeatField.ion'
                                                                            }
                                                                        },
                                                                        order: '0'
                                                                    }]
                                                            },
                                                            alternate: null,
                                                            order: '2'
                                                        },
                                                        {
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'Identifier',
                                                                name: 'finish',
                                                                loc: {
                                                                    start: {
                                                                        line: 101,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/RepeatField.ion'
                                                                    },
                                                                    end: {
                                                                        line: 101,
                                                                        column: 22,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/RepeatField.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 101,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/RepeatField.ion'
                                                                },
                                                                end: {
                                                                    line: 101,
                                                                    column: 22,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/RepeatField.ion'
                                                                }
                                                            },
                                                            order: '3'
                                                        }
                                                    ]
                                                },
                                                loc: {
                                                    start: {
                                                        line: 90,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/RepeatField.ion'
                                                    },
                                                    end: {
                                                        line: 103,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'viewpath/html/RepeatField.ion'
                                                    }
                                                },
                                                order: '0'
                                            }]
                                    },
                                    alternate: null,
                                    order: '1'
                                }
                            ]
                        },
                        {
                            type: 'ObjectExpression',
                            properties: [{
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'valueJSON',
                                        loc: {
                                            start: {
                                                line: 63,
                                                column: 17,
                                                fixed: true,
                                                source: 'viewpath/html/RepeatField.ion'
                                            },
                                            end: {
                                                line: 63,
                                                column: 26,
                                                fixed: true,
                                                source: 'viewpath/html/RepeatField.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 64,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/RepeatField.ion'
                                                        },
                                                        end: {
                                                            line: 64,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'viewpath/html/RepeatField.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context4) {
                                                        return function () {
                                                            var repeat = _context4.get('repeat'), TaskRepeat = _context4.get('TaskRepeat'), unit = _context4.get('unit'), count = _context4.get('count'), repeatByDayOfWeek = _context4.get('repeatByDayOfWeek'), days = _context4.get('days'), finish = _context4.get('finish');
                                                            if (!repeat.checked) {
                                                                return null;
                                                            } else {
                                                                return new TaskRepeat({
                                                                    unit: unit.valueJSON,
                                                                    count: count.valueJSON,
                                                                    repeatByDayOfWeek: repeatByDayOfWeek.valueJSON,
                                                                    days: days.valueJSON,
                                                                    finish: finish.valueJSON
                                                                });
                                                            }
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 77,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/RepeatField.ion'
                                                        },
                                                        end: {
                                                            line: 77,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'viewpath/html/RepeatField.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context5) {
                                                        return function (value) {
                                                            var repeat = _context5.get('repeat'), unit = _context5.get('unit'), count = _context5.get('count'), repeatByDayOfWeek = _context5.get('repeatByDayOfWeek'), days = _context5.get('days'), finish = _context5.get('finish');
                                                            repeat.checked = value != null;
                                                            value = value != null ? value : {};
                                                            unit.valueJSON = value.unit;
                                                            count.valueJSON = value.count;
                                                            repeatByDayOfWeek.valueJSON = value.repeatByDayOfWeek;
                                                            days.valueJSON = value.days;
                                                            finish.valueJSON = value.finish;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '0'
                                }]
                        }
                    ]
                },
                order: '<'
            }
        ],
        bound: false
    }, {
        this: this,
        args: args,
        glass: glass,
        viewpath: viewpath,
        _ref: _ref,
        _ref2: _ref2,
        _ref3: _ref3,
        daysOfWeek: daysOfWeek,
        Schema: Schema,
        DateInput: DateInput,
        Field: Field,
        Label: Label,
        TaskRepeat: TaskRepeat,
        RepeatUnit: RepeatUnit,
        DaysOfWeek: DaysOfWeek
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/RepeatField',_viewpath_html_RepeatField_);
    else
      _viewpath_html_RepeatField_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_RepeatField_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_SetupWizard_ = function(module,exports,require){'use strict';
var ion = require('ion'), glass = require('glass'), _ref, _ref2, style = glass.html.style, _ref3, _ref4;
_ref = glass.html.material;
var Dialog = _ref.Dialog;
var Stepper = _ref.Stepper;
_ref2 = glass.html.forms;
var GlassForm = _ref2.GlassForm;
var SubmitButton = _ref2.SubmitButton;
var CancelButton = _ref2.CancelButton;
var Field = _ref2.Field;
var Checkbox = _ref2.Checkbox;
_ref3 = require('../model');
var Organization = _ref3.Organization;
var Project = _ref3.Project;
var ProjectType = _ref3.ProjectType;
var PermissionLevel = _ref3.PermissionLevel;
var User = _ref3.User;
_ref4 = glass.data;
var Key = _ref4.Key;
ion.template(function () {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [{
                type: 'ExpressionStatement',
                expression: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'MemberExpression',
                        computed: false,
                        object: {
                            type: 'Identifier',
                            name: 'style',
                            loc: {
                                start: {
                                    line: 12,
                                    column: 4,
                                    fixed: true,
                                    source: 'viewpath/html/SetupWizard.ion'
                                },
                                end: {
                                    line: 12,
                                    column: 9,
                                    fixed: true,
                                    source: 'viewpath/html/SetupWizard.ion'
                                }
                            }
                        },
                        property: {
                            type: 'Identifier',
                            name: 'sheets',
                            loc: {
                                start: {
                                    line: 12,
                                    column: 10,
                                    fixed: true,
                                    source: 'viewpath/html/SetupWizard.ion'
                                },
                                end: {
                                    line: 12,
                                    column: 16,
                                    fixed: true,
                                    source: 'viewpath/html/SetupWizard.ion'
                                }
                            }
                        },
                        loc: {
                            start: {
                                line: 12,
                                column: 4,
                                fixed: true,
                                source: 'viewpath/html/SetupWizard.ion'
                            },
                            end: {
                                line: 12,
                                column: 16,
                                fixed: true,
                                source: 'viewpath/html/SetupWizard.ion'
                            }
                        }
                    },
                    properties: [{
                            type: 'Property',
                            key: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'module',
                                    loc: {
                                        start: {
                                            line: 13,
                                            column: 9,
                                            fixed: true,
                                            source: 'viewpath/html/SetupWizard.ion'
                                        },
                                        end: {
                                            line: 13,
                                            column: 15,
                                            fixed: true,
                                            source: 'viewpath/html/SetupWizard.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'id',
                                    loc: {
                                        start: {
                                            line: 13,
                                            column: 16,
                                            fixed: true,
                                            source: 'viewpath/html/SetupWizard.ion'
                                        },
                                        end: {
                                            line: 13,
                                            column: 18,
                                            fixed: true,
                                            source: 'viewpath/html/SetupWizard.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 13,
                                        column: 9,
                                        fixed: true,
                                        source: 'viewpath/html/SetupWizard.ion'
                                    },
                                    end: {
                                        line: 13,
                                        column: 18,
                                        fixed: true,
                                        source: 'viewpath/html/SetupWizard.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'BinaryExpression',
                                operator: '+',
                                left: {
                                    type: 'BinaryExpression',
                                    operator: '+',
                                    left: {
                                        type: 'BinaryExpression',
                                        operator: '+',
                                        left: {
                                            type: 'BinaryExpression',
                                            operator: '+',
                                            left: {
                                                type: 'Literal',
                                                value: '.MemberForm {\n    padding: 8px 12px;\n    outline: none;\n}\n\n.MembersList {\n    min-width: 400px;\n    border-radius: 3px;\n    background-color: '
                                            },
                                            right: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'style',
                                                        loc: {
                                                            start: {
                                                                line: 23,
                                                                column: 36,
                                                                fixed: true,
                                                                source: 'viewpath/html/SetupWizard.ion'
                                                            },
                                                            end: {
                                                                line: 23,
                                                                column: 41,
                                                                fixed: true,
                                                                source: 'viewpath/html/SetupWizard.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'black',
                                                        loc: {
                                                            start: {
                                                                line: 23,
                                                                column: 42,
                                                                fixed: true,
                                                                source: 'viewpath/html/SetupWizard.ion'
                                                            },
                                                            end: {
                                                                line: 23,
                                                                column: 47,
                                                                fixed: true,
                                                                source: 'viewpath/html/SetupWizard.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 23,
                                                            column: 36,
                                                            fixed: true,
                                                            source: 'viewpath/html/SetupWizard.ion'
                                                        },
                                                        end: {
                                                            line: 23,
                                                            column: 47,
                                                            fixed: true,
                                                            source: 'viewpath/html/SetupWizard.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [{
                                                        type: 'Literal',
                                                        value: 0.06
                                                    }],
                                                loc: {
                                                    start: {
                                                        line: 23,
                                                        column: 36,
                                                        fixed: true,
                                                        source: 'viewpath/html/SetupWizard.ion'
                                                    },
                                                    end: {
                                                        line: 23,
                                                        column: 53,
                                                        fixed: true,
                                                        source: 'viewpath/html/SetupWizard.ion'
                                                    }
                                                }
                                            }
                                        },
                                        right: {
                                            type: 'Literal',
                                            value: ';\n    padding-left: 0px;\n    padding-right: 0px;\n    overflow-y: auto;\n}\n\n.MembersList li {\n    padding-right: 8px;\n}\n\n.MembersList li:nth-child(odd) {\n    background-color: '
                                        }
                                    },
                                    right: {
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'style',
                                                loc: {
                                                    start: {
                                                        line: 34,
                                                        column: 36,
                                                        fixed: true,
                                                        source: 'viewpath/html/SetupWizard.ion'
                                                    },
                                                    end: {
                                                        line: 34,
                                                        column: 41,
                                                        fixed: true,
                                                        source: 'viewpath/html/SetupWizard.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'black',
                                                loc: {
                                                    start: {
                                                        line: 34,
                                                        column: 42,
                                                        fixed: true,
                                                        source: 'viewpath/html/SetupWizard.ion'
                                                    },
                                                    end: {
                                                        line: 34,
                                                        column: 47,
                                                        fixed: true,
                                                        source: 'viewpath/html/SetupWizard.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 34,
                                                    column: 36,
                                                    fixed: true,
                                                    source: 'viewpath/html/SetupWizard.ion'
                                                },
                                                end: {
                                                    line: 34,
                                                    column: 47,
                                                    fixed: true,
                                                    source: 'viewpath/html/SetupWizard.ion'
                                                }
                                            }
                                        },
                                        arguments: [{
                                                type: 'Literal',
                                                value: 0.08
                                            }],
                                        loc: {
                                            start: {
                                                line: 34,
                                                column: 36,
                                                fixed: true,
                                                source: 'viewpath/html/SetupWizard.ion'
                                            },
                                            end: {
                                                line: 34,
                                                column: 53,
                                                fixed: true,
                                                source: 'viewpath/html/SetupWizard.ion'
                                            }
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: ';\n}'
                                }
                            },
                            kind: 'init',
                            computed: true,
                            order: '0'
                        }]
                },
                loc: {
                    start: {
                        line: 12,
                        column: 4,
                        fixed: true,
                        source: 'viewpath/html/SetupWizard.ion'
                    },
                    end: {
                        line: 37,
                        column: 8,
                        fixed: true,
                        source: 'viewpath/html/SetupWizard.ion'
                    }
                },
                order: '0'
            }],
        bound: false
    }, {
        this: this,
        module: module,
        ion: ion,
        glass: glass,
        _ref: _ref,
        _ref2: _ref2,
        style: style,
        _ref3: _ref3,
        _ref4: _ref4,
        Dialog: Dialog,
        Stepper: Stepper,
        GlassForm: GlassForm,
        SubmitButton: SubmitButton,
        CancelButton: CancelButton,
        Field: Field,
        Checkbox: Checkbox,
        Organization: Organization,
        Project: Project,
        ProjectType: ProjectType,
        PermissionLevel: PermissionLevel,
        User: User,
        Key: Key,
        internal: internal
    }, null);
})().observe();
var internal = ion.template(function () {
        return ion.createRuntime({
            type: 'Template',
            id: null,
            body: [
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'values',
                                loc: {
                                    start: {
                                        line: 39,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/SetupWizard.ion'
                                    },
                                    end: {
                                        line: 39,
                                        column: 18,
                                        fixed: true,
                                        source: 'viewpath/html/SetupWizard.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'ObjectExpression',
                                properties: []
                            }
                        }],
                    kind: 'let',
                    order: '0'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'state',
                                loc: {
                                    start: {
                                        line: 40,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/SetupWizard.ion'
                                    },
                                    end: {
                                        line: 40,
                                        column: 17,
                                        fixed: true,
                                        source: 'viewpath/html/SetupWizard.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'ObjectExpression',
                                properties: [{
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'creating',
                                            loc: {
                                                start: {
                                                    line: 40,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'viewpath/html/SetupWizard.ion'
                                                },
                                                end: {
                                                    line: 40,
                                                    column: 29,
                                                    fixed: true,
                                                    source: 'viewpath/html/SetupWizard.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: false
                                        },
                                        kind: 'init',
                                        order: '0'
                                    }]
                            }
                        }],
                    kind: 'let',
                    order: '1'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'finalize',
                                loc: {
                                    start: {
                                        line: 42,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/SetupWizard.ion'
                                    },
                                    end: {
                                        line: 42,
                                        column: 20,
                                        fixed: true,
                                        source: 'viewpath/html/SetupWizard.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'Function',
                                context: true,
                                value: function (_context) {
                                    return function () {
                                        var state = _context.get('state'), values = _context.get('values'), ion = _context.get('ion'), PermissionLevel = _context.get('PermissionLevel'), Project = _context.get('Project'), Key = _context.get('Key'), ProjectType = _context.get('ProjectType'), dialog = _context.get('dialog');
                                        state.creating = true;
                                        var user = model.user;
                                        model.createOrg({
                                            name: values.orgName,
                                            adminKey: user.key
                                        }, function (_ref5) {
                                            var org = _ref5.org;
                                            var orgKey = _ref5.orgKey;
                                            var orgId = org.id;
                                            {
                                                var _ref6 = values.members;
                                                for (var _i = 0; _i < _ref6.length; _i++) {
                                                    var member = _ref6[_i];
                                                    model.invite({
                                                        name: member.name,
                                                        email: member.email,
                                                        orgId: orgId,
                                                        callback: function () {
                                                        }
                                                    });
                                                }
                                            }
                                            var _ref8 = {};
                                            _ref8[user.key] = ion.patch.combine(_ref8[user.key], { permission: PermissionLevel.Owner.id });
                                            var project = new Project({
                                                    key: new Key(Project, model.guid()).toString(),
                                                    type: ProjectType.Project.id,
                                                    name: values.projectName,
                                                    orgId: orgId,
                                                    sharing: _ref8
                                                });
                                            model.addEntities([project], function () {
                                                dialog.open = false;
                                                model.open(project.paneConfig);
                                                window.location.reload(true);
                                            });
                                        });
                                    };
                                }
                            }
                        }],
                    kind: 'let',
                    order: '2'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'tabs',
                                loc: {
                                    start: {
                                        line: 67,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/SetupWizard.ion'
                                    },
                                    end: {
                                        line: 67,
                                        column: 16,
                                        fixed: true,
                                        source: 'viewpath/html/SetupWizard.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'ArrayExpression',
                                    elements: []
                                },
                                properties: [
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'ObjectExpression',
                                            objectType: {
                                                type: 'ObjectExpression',
                                                properties: []
                                            },
                                            properties: [
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'name',
                                                        loc: {
                                                            start: {
                                                                line: 69,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/SetupWizard.ion'
                                                            },
                                                            end: {
                                                                line: 69,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/SetupWizard.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 'Set up an Organization'
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'editable',
                                                        loc: {
                                                            start: {
                                                                line: 70,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/SetupWizard.ion'
                                                            },
                                                            end: {
                                                                line: 70,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'viewpath/html/SetupWizard.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: true
                                                    },
                                                    kind: 'init',
                                                    order: '1'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'content',
                                                        loc: {
                                                            start: {
                                                                line: 71,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/SetupWizard.ion'
                                                            },
                                                            end: {
                                                                line: 71,
                                                                column: 23,
                                                                fixed: true,
                                                                source: 'viewpath/html/SetupWizard.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Function',
                                                        context: true,
                                                        value: function (_ps) {
                                                            return ion.template(function (stepper) {
                                                                return ion.createRuntime({
                                                                    type: 'Template',
                                                                    id: null,
                                                                    body: [
                                                                        {
                                                                            type: 'VariableDeclaration',
                                                                            declarations: [{
                                                                                    type: 'VariableDeclarator',
                                                                                    id: {
                                                                                        type: 'Identifier',
                                                                                        name: 'nameField',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 72,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 72,
                                                                                                column: 33,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    init: {
                                                                                        type: 'CallExpression',
                                                                                        callee: {
                                                                                            type: 'Identifier',
                                                                                            name: 'Field',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 72,
                                                                                                    column: 36,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 72,
                                                                                                    column: 41,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        arguments: [{
                                                                                                type: 'ObjectExpression',
                                                                                                properties: [{
                                                                                                        type: 'Property',
                                                                                                        key: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'property',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 73,
                                                                                                                    column: 24,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 73,
                                                                                                                    column: 32,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        value: {
                                                                                                            type: 'ObjectExpression',
                                                                                                            objectType: {
                                                                                                                type: 'CallExpression',
                                                                                                                callee: {
                                                                                                                    type: 'MemberExpression',
                                                                                                                    computed: false,
                                                                                                                    object: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'ion',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 73,
                                                                                                                                column: 34,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 73,
                                                                                                                                column: 37,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    property: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'clone',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 73,
                                                                                                                                column: 38,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 73,
                                                                                                                                column: 43,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 73,
                                                                                                                            column: 34,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 73,
                                                                                                                            column: 43,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                arguments: [{
                                                                                                                        type: 'MemberExpression',
                                                                                                                        computed: false,
                                                                                                                        object: {
                                                                                                                            type: 'MemberExpression',
                                                                                                                            computed: false,
                                                                                                                            object: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'Organization',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 73,
                                                                                                                                        column: 44,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 73,
                                                                                                                                        column: 56,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            property: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'properties',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 73,
                                                                                                                                        column: 57,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 73,
                                                                                                                                        column: 67,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 73,
                                                                                                                                    column: 44,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 73,
                                                                                                                                    column: 67,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        property: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'name',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 73,
                                                                                                                                    column: 68,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 73,
                                                                                                                                    column: 72,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 73,
                                                                                                                                column: 44,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 73,
                                                                                                                                column: 72,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    }],
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 73,
                                                                                                                        column: 34,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 73,
                                                                                                                        column: 73,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            properties: [{
                                                                                                                    type: 'Property',
                                                                                                                    key: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'label',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 74,
                                                                                                                                column: 28,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 74,
                                                                                                                                column: 33,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    value: {
                                                                                                                        type: 'Literal',
                                                                                                                        value: 'Name your organization.'
                                                                                                                    },
                                                                                                                    kind: 'init',
                                                                                                                    order: '0'
                                                                                                                }]
                                                                                                        },
                                                                                                        kind: 'init',
                                                                                                        order: '0'
                                                                                                    }]
                                                                                            }],
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 72,
                                                                                                column: 36,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 75,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                }],
                                                                            kind: 'let',
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'VariableDeclaration',
                                                                            declarations: [{
                                                                                    type: 'VariableDeclarator',
                                                                                    id: {
                                                                                        type: 'Identifier',
                                                                                        name: 'valid',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 75,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 75,
                                                                                                column: 29,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    init: {
                                                                                        type: 'BinaryExpression',
                                                                                        operator: '>',
                                                                                        left: {
                                                                                            type: 'MemberExpression',
                                                                                            computed: false,
                                                                                            object: {
                                                                                                type: 'MemberExpression',
                                                                                                computed: false,
                                                                                                object: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'nameField',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 75,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 75,
                                                                                                            column: 41,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'value',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 75,
                                                                                                            column: 42,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 75,
                                                                                                            column: 47,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 75,
                                                                                                        column: 32,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 75,
                                                                                                        column: 47,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            property: {
                                                                                                type: 'Identifier',
                                                                                                name: 'length',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 75,
                                                                                                        column: 49,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 75,
                                                                                                        column: 55,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            existential: true,
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 75,
                                                                                                    column: 32,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 75,
                                                                                                    column: 55,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        right: {
                                                                                            type: 'Literal',
                                                                                            value: 0
                                                                                        }
                                                                                    }
                                                                                }],
                                                                            kind: 'let',
                                                                            order: '1'
                                                                        },
                                                                        {
                                                                            type: 'ReturnStatement',
                                                                            argument: {
                                                                                type: 'ObjectExpression',
                                                                                objectType: {
                                                                                    type: 'CallExpression',
                                                                                    callee: {
                                                                                        type: 'Identifier',
                                                                                        name: 'GlassForm',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 76,
                                                                                                column: 27,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 76,
                                                                                                column: 36,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    arguments: [{
                                                                                            type: 'ObjectExpression',
                                                                                            properties: [{
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'class',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 76,
                                                                                                                column: 38,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 76,
                                                                                                                column: 43,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'Literal',
                                                                                                        value: 'layout vertical flex'
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '0'
                                                                                                }]
                                                                                        }],
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 76,
                                                                                            column: 27,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 76,
                                                                                            column: 68,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                properties: [
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'Function',
                                                                                            context: true,
                                                                                            value: function (_context2) {
                                                                                                return function complete() {
                                                                                                    var valid = _context2.get('valid'), values = _context2.get('values'), stepper = _context2.get('stepper');
                                                                                                    if (valid) {
                                                                                                        values.orgName = this.values.name;
                                                                                                        stepper.complete();
                                                                                                    }
                                                                                                };
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 77,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 82,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'ObjectExpression',
                                                                                            objectType: {
                                                                                                type: 'CallExpression',
                                                                                                callee: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'Div',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 82,
                                                                                                            column: 24,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 82,
                                                                                                            column: 27,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                arguments: [{
                                                                                                        type: 'ObjectExpression',
                                                                                                        properties: [{
                                                                                                                type: 'Property',
                                                                                                                key: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'style',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 82,
                                                                                                                            column: 29,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 82,
                                                                                                                            column: 34,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                value: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: 'font-size:25px;padding:8px 0px'
                                                                                                                },
                                                                                                                kind: 'init',
                                                                                                                order: '0'
                                                                                                            }]
                                                                                                    }],
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 82,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 82,
                                                                                                        column: 69,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            properties: [{
                                                                                                    type: 'ExpressionStatement',
                                                                                                    expression: {
                                                                                                        type: 'Literal',
                                                                                                        value: 'Welcome to Viewpath!'
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 83,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 83,
                                                                                                            column: 50,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        }
                                                                                                    },
                                                                                                    order: '0'
                                                                                                }]
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 82,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 84,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '1'
                                                                                    },
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'ObjectExpression',
                                                                                            objectType: {
                                                                                                type: 'CallExpression',
                                                                                                callee: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'Div',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 84,
                                                                                                            column: 24,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 84,
                                                                                                            column: 27,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                arguments: [{
                                                                                                        type: 'ObjectExpression',
                                                                                                        properties: [{
                                                                                                                type: 'Property',
                                                                                                                key: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'style',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 84,
                                                                                                                            column: 29,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 84,
                                                                                                                            column: 34,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                value: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: 'font-size:12px;color:gray;font-weight:bold;padding:8px 0px'
                                                                                                                },
                                                                                                                kind: 'init',
                                                                                                                order: '0'
                                                                                                            }]
                                                                                                    }],
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 84,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 84,
                                                                                                        column: 97,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            properties: [{
                                                                                                    type: 'ExpressionStatement',
                                                                                                    expression: {
                                                                                                        type: 'Literal',
                                                                                                        value: 'The following wizard will help you get started in Viewpath.'
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 85,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 85,
                                                                                                            column: 89,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        }
                                                                                                    },
                                                                                                    order: '0'
                                                                                                }]
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 84,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 87,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '2'
                                                                                    },
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'Identifier',
                                                                                            name: 'nameField',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 87,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 87,
                                                                                                    column: 33,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 87,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 87,
                                                                                                column: 33,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '3'
                                                                                    },
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'CallExpression',
                                                                                            callee: {
                                                                                                type: 'Identifier',
                                                                                                name: 'Div',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 88,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 88,
                                                                                                        column: 27,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            arguments: [{
                                                                                                    type: 'ObjectExpression',
                                                                                                    properties: [{
                                                                                                            type: 'Property',
                                                                                                            key: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'class',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 88,
                                                                                                                        column: 29,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 88,
                                                                                                                        column: 34,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            value: {
                                                                                                                type: 'Literal',
                                                                                                                value: 'fill'
                                                                                                            },
                                                                                                            kind: 'init',
                                                                                                            order: '0'
                                                                                                        }]
                                                                                                }],
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 88,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 88,
                                                                                                    column: 43,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 88,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 88,
                                                                                                column: 43,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '4'
                                                                                    },
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'ObjectExpression',
                                                                                            objectType: {
                                                                                                type: 'CallExpression',
                                                                                                callee: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'Div',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 89,
                                                                                                            column: 24,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 89,
                                                                                                            column: 27,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                arguments: [],
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 89,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 89,
                                                                                                        column: 29,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            properties: [
                                                                                                {
                                                                                                    type: 'ExpressionStatement',
                                                                                                    expression: {
                                                                                                        type: 'ObjectExpression',
                                                                                                        objectType: {
                                                                                                            type: 'CallExpression',
                                                                                                            callee: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'PaperButton',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 90,
                                                                                                                        column: 28,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 90,
                                                                                                                        column: 39,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            arguments: [],
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 90,
                                                                                                                    column: 28,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 90,
                                                                                                                    column: 41,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        properties: [
                                                                                                            {
                                                                                                                type: 'ExpressionStatement',
                                                                                                                expression: {
                                                                                                                    type: 'Function',
                                                                                                                    context: true,
                                                                                                                    value: function (_context3) {
                                                                                                                        return function click() {
                                                                                                                            var dialog = _context3.get('dialog');
                                                                                                                            return dialog.open = false;
                                                                                                                        };
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 91,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 91,
                                                                                                                        column: 62,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    }
                                                                                                                },
                                                                                                                order: '0'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'ExpressionStatement',
                                                                                                                expression: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: 'Cancel'
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 92,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 92,
                                                                                                                        column: 40,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    }
                                                                                                                },
                                                                                                                order: '1'
                                                                                                            }
                                                                                                        ]
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 90,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 93,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        }
                                                                                                    },
                                                                                                    order: '0'
                                                                                                },
                                                                                                {
                                                                                                    type: 'ExpressionStatement',
                                                                                                    expression: {
                                                                                                        type: 'ObjectExpression',
                                                                                                        objectType: {
                                                                                                            type: 'CallExpression',
                                                                                                            callee: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'SubmitButton',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 93,
                                                                                                                        column: 28,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 93,
                                                                                                                        column: 40,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            arguments: [],
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 93,
                                                                                                                    column: 28,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 93,
                                                                                                                    column: 42,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        properties: [
                                                                                                            {
                                                                                                                type: 'ExpressionStatement',
                                                                                                                expression: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: 'Next'
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 94,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 94,
                                                                                                                        column: 38,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    }
                                                                                                                },
                                                                                                                order: '0'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'Property',
                                                                                                                key: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'disabled',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 95,
                                                                                                                            column: 32,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 95,
                                                                                                                            column: 40,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                value: {
                                                                                                                    type: 'UnaryExpression',
                                                                                                                    operator: '!',
                                                                                                                    argument: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'valid',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 95,
                                                                                                                                column: 46,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 95,
                                                                                                                                column: 51,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                kind: 'init',
                                                                                                                order: '1'
                                                                                                            }
                                                                                                        ]
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 93,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 97,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        }
                                                                                                    },
                                                                                                    order: '1'
                                                                                                }
                                                                                            ]
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 89,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 97,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '5'
                                                                                    }
                                                                                ]
                                                                            },
                                                                            order: '2'
                                                                        }
                                                                    ],
                                                                    bound: false,
                                                                    name: {
                                                                        type: 'Identifier',
                                                                        name: 'content',
                                                                        loc: {
                                                                            start: {
                                                                                line: 71,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                            },
                                                                            end: {
                                                                                line: 71,
                                                                                column: 23,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    scope: {
                                                                        type: 'Identifier',
                                                                        name: '_ps'
                                                                    }
                                                                }, {
                                                                    this: this,
                                                                    ion: ion,
                                                                    stepper: stepper,
                                                                    _ps: _ps,
                                                                    glass: glass,
                                                                    _ref: _ref,
                                                                    _ref2: _ref2,
                                                                    style: style,
                                                                    _ref3: _ref3,
                                                                    _ref4: _ref4,
                                                                    Dialog: Dialog,
                                                                    Stepper: Stepper,
                                                                    GlassForm: GlassForm,
                                                                    SubmitButton: SubmitButton,
                                                                    CancelButton: CancelButton,
                                                                    Field: Field,
                                                                    Checkbox: Checkbox,
                                                                    Organization: Organization,
                                                                    Project: Project,
                                                                    ProjectType: ProjectType,
                                                                    PermissionLevel: PermissionLevel,
                                                                    User: User,
                                                                    Key: Key,
                                                                    internal: internal
                                                                }, _ps);
                                                            });
                                                        }
                                                    },
                                                    kind: 'init',
                                                    order: '2'
                                                }
                                            ]
                                        },
                                        loc: {
                                            start: {
                                                line: 68,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/SetupWizard.ion'
                                            },
                                            end: {
                                                line: 97,
                                                column: 16,
                                                fixed: true,
                                                source: 'viewpath/html/SetupWizard.ion'
                                            }
                                        },
                                        order: '0'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'ObjectExpression',
                                            objectType: {
                                                type: 'ObjectExpression',
                                                properties: []
                                            },
                                            properties: [
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'name',
                                                        loc: {
                                                            start: {
                                                                line: 98,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/SetupWizard.ion'
                                                            },
                                                            end: {
                                                                line: 98,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/SetupWizard.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 'Add Members'
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'editable',
                                                        loc: {
                                                            start: {
                                                                line: 99,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/SetupWizard.ion'
                                                            },
                                                            end: {
                                                                line: 99,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'viewpath/html/SetupWizard.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: true
                                                    },
                                                    kind: 'init',
                                                    order: '1'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'optional',
                                                        loc: {
                                                            start: {
                                                                line: 100,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/SetupWizard.ion'
                                                            },
                                                            end: {
                                                                line: 100,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'viewpath/html/SetupWizard.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: true
                                                    },
                                                    kind: 'init',
                                                    order: '2'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'content',
                                                        loc: {
                                                            start: {
                                                                line: 101,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/SetupWizard.ion'
                                                            },
                                                            end: {
                                                                line: 101,
                                                                column: 23,
                                                                fixed: true,
                                                                source: 'viewpath/html/SetupWizard.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Function',
                                                        context: true,
                                                        value: function (_ps2) {
                                                            return ion.template(function (stepper) {
                                                                return ion.createRuntime({
                                                                    type: 'Template',
                                                                    id: null,
                                                                    body: [
                                                                        {
                                                                            type: 'VariableDeclaration',
                                                                            declarations: [{
                                                                                    type: 'VariableDeclarator',
                                                                                    id: {
                                                                                        type: 'Identifier',
                                                                                        name: 'members',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 102,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 102,
                                                                                                column: 31,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    init: {
                                                                                        type: 'ArrayExpression',
                                                                                        elements: []
                                                                                    }
                                                                                }],
                                                                            kind: 'let',
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'VariableDeclaration',
                                                                            declarations: [{
                                                                                    type: 'VariableDeclarator',
                                                                                    id: {
                                                                                        type: 'Identifier',
                                                                                        name: 'emailInput',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 104,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 104,
                                                                                                column: 34,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    init: {
                                                                                        type: 'CallExpression',
                                                                                        callee: {
                                                                                            type: 'Identifier',
                                                                                            name: 'GoldEmailInput',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 104,
                                                                                                    column: 37,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 104,
                                                                                                    column: 51,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        arguments: [{
                                                                                                type: 'ObjectExpression',
                                                                                                properties: [
                                                                                                    {
                                                                                                        type: 'Property',
                                                                                                        key: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'label',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 104,
                                                                                                                    column: 53,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 104,
                                                                                                                    column: 58,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        value: {
                                                                                                            type: 'Literal',
                                                                                                            value: 'Email Address'
                                                                                                        },
                                                                                                        kind: 'init',
                                                                                                        order: '0'
                                                                                                    },
                                                                                                    {
                                                                                                        type: 'Property',
                                                                                                        key: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'name',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 104,
                                                                                                                    column: 77,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 104,
                                                                                                                    column: 81,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        value: {
                                                                                                            type: 'Literal',
                                                                                                            value: 'email'
                                                                                                        },
                                                                                                        kind: 'init',
                                                                                                        order: '1'
                                                                                                    },
                                                                                                    {
                                                                                                        type: 'Property',
                                                                                                        key: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'required',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 104,
                                                                                                                    column: 92,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 104,
                                                                                                                    column: 100,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        value: {
                                                                                                            type: 'Literal',
                                                                                                            value: true
                                                                                                        },
                                                                                                        kind: 'init',
                                                                                                        order: '2'
                                                                                                    }
                                                                                                ]
                                                                                            }],
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 104,
                                                                                                column: 37,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 104,
                                                                                                column: 108,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                }],
                                                                            kind: 'let',
                                                                            order: '1'
                                                                        },
                                                                        {
                                                                            type: 'VariableDeclaration',
                                                                            declarations: [{
                                                                                    type: 'VariableDeclarator',
                                                                                    id: {
                                                                                        type: 'Identifier',
                                                                                        name: 'nameInput',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 105,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 105,
                                                                                                column: 33,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    init: {
                                                                                        type: 'CallExpression',
                                                                                        callee: {
                                                                                            type: 'Identifier',
                                                                                            name: 'PaperInput',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 105,
                                                                                                    column: 36,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 105,
                                                                                                    column: 46,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        arguments: [{
                                                                                                type: 'ObjectExpression',
                                                                                                properties: [
                                                                                                    {
                                                                                                        type: 'Property',
                                                                                                        key: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'label',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 105,
                                                                                                                    column: 48,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 105,
                                                                                                                    column: 53,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        value: {
                                                                                                            type: 'Literal',
                                                                                                            value: 'Name'
                                                                                                        },
                                                                                                        kind: 'init',
                                                                                                        order: '0'
                                                                                                    },
                                                                                                    {
                                                                                                        type: 'Property',
                                                                                                        key: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'name',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 105,
                                                                                                                    column: 63,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 105,
                                                                                                                    column: 67,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        value: {
                                                                                                            type: 'Literal',
                                                                                                            value: 'name'
                                                                                                        },
                                                                                                        kind: 'init',
                                                                                                        order: '1'
                                                                                                    },
                                                                                                    {
                                                                                                        type: 'Property',
                                                                                                        key: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'required',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 105,
                                                                                                                    column: 77,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 105,
                                                                                                                    column: 85,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        value: {
                                                                                                            type: 'Literal',
                                                                                                            value: true
                                                                                                        },
                                                                                                        kind: 'init',
                                                                                                        order: '2'
                                                                                                    }
                                                                                                ]
                                                                                            }],
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 105,
                                                                                                column: 36,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 105,
                                                                                                column: 93,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                }],
                                                                            kind: 'let',
                                                                            order: '2'
                                                                        },
                                                                        {
                                                                            type: 'VariableDeclaration',
                                                                            declarations: [{
                                                                                    type: 'VariableDeclarator',
                                                                                    id: {
                                                                                        type: 'Identifier',
                                                                                        name: 'email',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 106,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 106,
                                                                                                column: 29,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    init: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'emailInput',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 106,
                                                                                                    column: 32,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 106,
                                                                                                    column: 42,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'value',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 106,
                                                                                                    column: 43,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 106,
                                                                                                    column: 48,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 106,
                                                                                                column: 32,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 106,
                                                                                                column: 48,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                }],
                                                                            kind: 'let',
                                                                            order: '3'
                                                                        },
                                                                        {
                                                                            type: 'VariableDeclaration',
                                                                            declarations: [{
                                                                                    type: 'VariableDeclarator',
                                                                                    id: {
                                                                                        type: 'Identifier',
                                                                                        name: 'invitedUser',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 107,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 107,
                                                                                                column: 35,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    init: {
                                                                                        type: 'ConditionalExpression',
                                                                                        test: {
                                                                                            type: 'BinaryExpression',
                                                                                            operator: '>',
                                                                                            left: {
                                                                                                type: 'MemberExpression',
                                                                                                computed: false,
                                                                                                object: {
                                                                                                    type: 'ConditionalExpression',
                                                                                                    test: {
                                                                                                        type: 'BinaryExpression',
                                                                                                        operator: '!=',
                                                                                                        left: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'email',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 107,
                                                                                                                    column: 40,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 107,
                                                                                                                    column: 45,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        right: {
                                                                                                            type: 'Literal',
                                                                                                            value: null
                                                                                                        }
                                                                                                    },
                                                                                                    consequent: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'email',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 107,
                                                                                                                column: 40,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 107,
                                                                                                                column: 45,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    alternate: {
                                                                                                        type: 'Literal',
                                                                                                        value: ''
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'length',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 107,
                                                                                                            column: 52,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 107,
                                                                                                            column: 58,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 107,
                                                                                                        column: 39,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 107,
                                                                                                        column: 58,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            right: {
                                                                                                type: 'Literal',
                                                                                                value: 0
                                                                                            }
                                                                                        },
                                                                                        consequent: {
                                                                                            type: 'MemberExpression',
                                                                                            computed: true,
                                                                                            object: {
                                                                                                type: 'MemberExpression',
                                                                                                computed: false,
                                                                                                object: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'model',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 107,
                                                                                                            column: 65,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 107,
                                                                                                            column: 70,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'server',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 107,
                                                                                                            column: 71,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 107,
                                                                                                            column: 77,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 107,
                                                                                                        column: 65,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 107,
                                                                                                        column: 77,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            property: {
                                                                                                type: 'NewExpression',
                                                                                                callee: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'Key',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 107,
                                                                                                            column: 82,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 107,
                                                                                                            column: 85,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                arguments: [
                                                                                                    {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'User',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 107,
                                                                                                                column: 86,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 107,
                                                                                                                column: 90,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    {
                                                                                                        type: 'CallExpression',
                                                                                                        callee: {
                                                                                                            type: 'MemberExpression',
                                                                                                            computed: false,
                                                                                                            object: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'email',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 107,
                                                                                                                        column: 92,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 107,
                                                                                                                        column: 97,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            property: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'toLowerCase',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 107,
                                                                                                                        column: 98,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 107,
                                                                                                                        column: 109,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 107,
                                                                                                                    column: 92,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 107,
                                                                                                                    column: 109,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        arguments: [],
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 107,
                                                                                                                column: 92,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 107,
                                                                                                                column: 111,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    }
                                                                                                ],
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 107,
                                                                                                        column: 78,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 107,
                                                                                                        column: 112,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 107,
                                                                                                    column: 65,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 107,
                                                                                                    column: 113,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        alternate: {
                                                                                            type: 'Literal',
                                                                                            value: null
                                                                                        }
                                                                                    }
                                                                                }],
                                                                            kind: 'let',
                                                                            order: '4'
                                                                        },
                                                                        {
                                                                            type: 'VariableDeclaration',
                                                                            declarations: [{
                                                                                    type: 'VariableDeclarator',
                                                                                    id: {
                                                                                        type: 'Identifier',
                                                                                        name: 'form',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 108,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 108,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    init: {
                                                                                        type: 'ObjectExpression',
                                                                                        objectType: {
                                                                                            type: 'CallExpression',
                                                                                            callee: {
                                                                                                type: 'Identifier',
                                                                                                name: 'GlassForm',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 108,
                                                                                                        column: 31,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 108,
                                                                                                        column: 40,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            arguments: [{
                                                                                                    type: 'ObjectExpression',
                                                                                                    properties: [
                                                                                                        {
                                                                                                            type: 'Property',
                                                                                                            key: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'class',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 108,
                                                                                                                        column: 42,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 108,
                                                                                                                        column: 47,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            value: {
                                                                                                                type: 'Literal',
                                                                                                                value: 'layout vertical fixed'
                                                                                                            },
                                                                                                            kind: 'init',
                                                                                                            order: '0'
                                                                                                        },
                                                                                                        {
                                                                                                            type: 'Property',
                                                                                                            key: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'style',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 108,
                                                                                                                        column: 73,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 108,
                                                                                                                        column: 78,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            value: {
                                                                                                                type: 'Literal',
                                                                                                                value: 'padding-left:0px'
                                                                                                            },
                                                                                                            kind: 'init',
                                                                                                            order: '1'
                                                                                                        }
                                                                                                    ]
                                                                                                }],
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 108,
                                                                                                    column: 31,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 108,
                                                                                                    column: 99,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        properties: [
                                                                                            {
                                                                                                type: 'ExpressionStatement',
                                                                                                expression: {
                                                                                                    type: 'Function',
                                                                                                    context: true,
                                                                                                    value: function (_context4) {
                                                                                                        return function complete() {
                                                                                                            var members = _context4.get('members');
                                                                                                            members.push(this.values);
                                                                                                            {
                                                                                                                var _ref7 = this.fields;
                                                                                                                for (var _i2 = 0; _i2 < _ref7.length; _i2++) {
                                                                                                                    var field = _ref7[_i2];
                                                                                                                    field.value = '';
                                                                                                                }
                                                                                                            }
                                                                                                        };
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 109,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 114,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                    }
                                                                                                },
                                                                                                order: '0'
                                                                                            },
                                                                                            {
                                                                                                type: 'ExpressionStatement',
                                                                                                expression: {
                                                                                                    type: 'ObjectExpression',
                                                                                                    objectType: {
                                                                                                        type: 'CallExpression',
                                                                                                        callee: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'Div',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 114,
                                                                                                                    column: 24,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 114,
                                                                                                                    column: 27,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        arguments: [{
                                                                                                                type: 'ObjectExpression',
                                                                                                                properties: [{
                                                                                                                        type: 'Property',
                                                                                                                        key: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'class',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 114,
                                                                                                                                    column: 29,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 114,
                                                                                                                                    column: 34,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        value: {
                                                                                                                            type: 'Literal',
                                                                                                                            value: 'layout horizontal fixed end'
                                                                                                                        },
                                                                                                                        kind: 'init',
                                                                                                                        order: '0'
                                                                                                                    }]
                                                                                                            }],
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 114,
                                                                                                                column: 24,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 114,
                                                                                                                column: 66,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    properties: [
                                                                                                        {
                                                                                                            type: 'ExpressionStatement',
                                                                                                            expression: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'nameInput',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 115,
                                                                                                                        column: 28,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 115,
                                                                                                                        column: 37,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 115,
                                                                                                                    column: 28,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 115,
                                                                                                                    column: 37,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                }
                                                                                                            },
                                                                                                            order: '0'
                                                                                                        },
                                                                                                        {
                                                                                                            type: 'ExpressionStatement',
                                                                                                            expression: {
                                                                                                                type: 'CallExpression',
                                                                                                                callee: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'Div',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 116,
                                                                                                                            column: 28,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 116,
                                                                                                                            column: 31,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                arguments: [{
                                                                                                                        type: 'ObjectExpression',
                                                                                                                        properties: [{
                                                                                                                                type: 'Property',
                                                                                                                                key: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'style',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 116,
                                                                                                                                            column: 33,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 116,
                                                                                                                                            column: 38,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                value: {
                                                                                                                                    type: 'Literal',
                                                                                                                                    value: 'padding:4px'
                                                                                                                                },
                                                                                                                                kind: 'init',
                                                                                                                                order: '0'
                                                                                                                            }]
                                                                                                                    }],
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 116,
                                                                                                                        column: 28,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 116,
                                                                                                                        column: 54,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 116,
                                                                                                                    column: 28,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 116,
                                                                                                                    column: 54,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                }
                                                                                                            },
                                                                                                            order: '1'
                                                                                                        },
                                                                                                        {
                                                                                                            type: 'ExpressionStatement',
                                                                                                            expression: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'emailInput',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 117,
                                                                                                                        column: 28,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 117,
                                                                                                                        column: 38,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 117,
                                                                                                                    column: 28,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 117,
                                                                                                                    column: 38,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                }
                                                                                                            },
                                                                                                            order: '2'
                                                                                                        },
                                                                                                        {
                                                                                                            type: 'ExpressionStatement',
                                                                                                            expression: {
                                                                                                                type: 'ObjectExpression',
                                                                                                                objectType: {
                                                                                                                    type: 'CallExpression',
                                                                                                                    callee: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'SubmitButton',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 118,
                                                                                                                                column: 28,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 118,
                                                                                                                                column: 40,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    arguments: [],
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 118,
                                                                                                                            column: 28,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 118,
                                                                                                                            column: 42,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                properties: [
                                                                                                                    {
                                                                                                                        type: 'Property',
                                                                                                                        key: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'raised',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 119,
                                                                                                                                    column: 32,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 119,
                                                                                                                                    column: 38,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        value: {
                                                                                                                            type: 'Literal',
                                                                                                                            value: false
                                                                                                                        },
                                                                                                                        kind: 'init',
                                                                                                                        order: '0'
                                                                                                                    },
                                                                                                                    {
                                                                                                                        type: 'ExpressionStatement',
                                                                                                                        expression: {
                                                                                                                            type: 'Literal',
                                                                                                                            value: 'Add'
                                                                                                                        },
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 120,
                                                                                                                                column: 32,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 120,
                                                                                                                                column: 37,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                                            }
                                                                                                                        },
                                                                                                                        order: '1'
                                                                                                                    }
                                                                                                                ]
                                                                                                            },
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 118,
                                                                                                                    column: 28,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 122,
                                                                                                                    column: 32,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                }
                                                                                                            },
                                                                                                            order: '3'
                                                                                                        }
                                                                                                    ]
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 114,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 122,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                    }
                                                                                                },
                                                                                                order: '1'
                                                                                            },
                                                                                            {
                                                                                                type: 'IfStatement',
                                                                                                test: {
                                                                                                    type: 'BinaryExpression',
                                                                                                    operator: '!==',
                                                                                                    left: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'email',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 122,
                                                                                                                column: 27,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 122,
                                                                                                                column: 32,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    right: {
                                                                                                        type: 'Literal',
                                                                                                        value: ''
                                                                                                    }
                                                                                                },
                                                                                                consequent: {
                                                                                                    type: 'BlockStatement',
                                                                                                    body: [{
                                                                                                            type: 'ExpressionStatement',
                                                                                                            expression: {
                                                                                                                type: 'ObjectExpression',
                                                                                                                objectType: {
                                                                                                                    type: 'CallExpression',
                                                                                                                    callee: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'Span',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 123,
                                                                                                                                column: 28,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 123,
                                                                                                                                column: 32,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    arguments: [],
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 123,
                                                                                                                            column: 28,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 123,
                                                                                                                            column: 34,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                properties: [{
                                                                                                                        type: 'IfStatement',
                                                                                                                        test: {
                                                                                                                            type: 'BinaryExpression',
                                                                                                                            operator: '===',
                                                                                                                            left: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'invitedUser',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 124,
                                                                                                                                        column: 35,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 124,
                                                                                                                                        column: 46,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            right: {
                                                                                                                                type: 'UnaryExpression',
                                                                                                                                operator: 'void',
                                                                                                                                prefix: true,
                                                                                                                                argument: {
                                                                                                                                    type: 'Literal',
                                                                                                                                    value: 0
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        consequent: {
                                                                                                                            type: 'BlockStatement',
                                                                                                                            body: [{
                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                    expression: {
                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                        operator: '+',
                                                                                                                                        left: {
                                                                                                                                            type: 'BinaryExpression',
                                                                                                                                            operator: '+',
                                                                                                                                            left: {
                                                                                                                                                type: 'Literal',
                                                                                                                                                value: 'Checking if '
                                                                                                                                            },
                                                                                                                                            right: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'email',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 125,
                                                                                                                                                        column: 51,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 125,
                                                                                                                                                        column: 56,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        right: {
                                                                                                                                            type: 'Literal',
                                                                                                                                            value: ' exists.'
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 125,
                                                                                                                                            column: 36,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 125,
                                                                                                                                            column: 67,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    order: '0'
                                                                                                                                }]
                                                                                                                        },
                                                                                                                        alternate: {
                                                                                                                            type: 'IfStatement',
                                                                                                                            test: {
                                                                                                                                type: 'BinaryExpression',
                                                                                                                                operator: '===',
                                                                                                                                left: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'invitedUser',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 126,
                                                                                                                                            column: 40,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 126,
                                                                                                                                            column: 51,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                right: {
                                                                                                                                    type: 'Literal',
                                                                                                                                    value: null
                                                                                                                                }
                                                                                                                            },
                                                                                                                            consequent: {
                                                                                                                                type: 'BlockStatement',
                                                                                                                                body: [{
                                                                                                                                        type: 'ExpressionStatement',
                                                                                                                                        expression: {
                                                                                                                                            type: 'BinaryExpression',
                                                                                                                                            operator: '+',
                                                                                                                                            left: {
                                                                                                                                                type: 'BinaryExpression',
                                                                                                                                                operator: '+',
                                                                                                                                                left: {
                                                                                                                                                    type: 'Literal',
                                                                                                                                                    value: ''
                                                                                                                                                },
                                                                                                                                                right: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'email',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 127,
                                                                                                                                                            column: 39,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 127,
                                                                                                                                                            column: 44,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            right: {
                                                                                                                                                type: 'Literal',
                                                                                                                                                value: ' is a new user.'
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 127,
                                                                                                                                                column: 36,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 127,
                                                                                                                                                column: 62,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        order: '0'
                                                                                                                                    }]
                                                                                                                            },
                                                                                                                            alternate: {
                                                                                                                                type: 'BlockStatement',
                                                                                                                                body: [
                                                                                                                                    {
                                                                                                                                        type: 'ExpressionStatement',
                                                                                                                                        expression: {
                                                                                                                                            type: 'CallExpression',
                                                                                                                                            callee: {
                                                                                                                                                type: 'Function',
                                                                                                                                                context: true,
                                                                                                                                                value: function (_context5) {
                                                                                                                                                    return function () {
                                                                                                                                                        var nameInput = _context5.get('nameInput'), invitedUser = _context5.get('invitedUser');
                                                                                                                                                        nameInput.updateValueAndPreserveCaret(invitedUser.name);
                                                                                                                                                    };
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            arguments: [],
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 129,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 131,
                                                                                                                                                    column: 40,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 129,
                                                                                                                                                column: 36,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 131,
                                                                                                                                                column: 40,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        order: '0'
                                                                                                                                    },
                                                                                                                                    {
                                                                                                                                        type: 'ExpressionStatement',
                                                                                                                                        expression: {
                                                                                                                                            type: 'BinaryExpression',
                                                                                                                                            operator: '+',
                                                                                                                                            left: {
                                                                                                                                                type: 'BinaryExpression',
                                                                                                                                                operator: '+',
                                                                                                                                                left: {
                                                                                                                                                    type: 'Literal',
                                                                                                                                                    value: ''
                                                                                                                                                },
                                                                                                                                                right: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'email',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 131,
                                                                                                                                                            column: 39,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 131,
                                                                                                                                                            column: 44,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            right: {
                                                                                                                                                type: 'Literal',
                                                                                                                                                value: ' is an existing user.'
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 131,
                                                                                                                                                column: 36,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 131,
                                                                                                                                                column: 68,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        order: '1'
                                                                                                                                    }
                                                                                                                                ]
                                                                                                                            }
                                                                                                                        },
                                                                                                                        order: '0'
                                                                                                                    }]
                                                                                                            },
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 123,
                                                                                                                    column: 28,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 133,
                                                                                                                    column: 32,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                }
                                                                                                            },
                                                                                                            order: '0'
                                                                                                        }]
                                                                                                },
                                                                                                alternate: null,
                                                                                                order: '2'
                                                                                            }
                                                                                        ]
                                                                                    }
                                                                                }],
                                                                            kind: 'let',
                                                                            order: '5'
                                                                        },
                                                                        {
                                                                            type: 'ReturnStatement',
                                                                            argument: {
                                                                                type: 'ObjectExpression',
                                                                                objectType: {
                                                                                    type: 'CallExpression',
                                                                                    callee: {
                                                                                        type: 'Identifier',
                                                                                        name: 'Div',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 133,
                                                                                                column: 27,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 133,
                                                                                                column: 30,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    arguments: [{
                                                                                            type: 'ObjectExpression',
                                                                                            properties: [{
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'class',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 133,
                                                                                                                column: 32,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 133,
                                                                                                                column: 37,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'Literal',
                                                                                                        value: 'MemberForm layout vertical flex'
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '0'
                                                                                                }]
                                                                                        }],
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 133,
                                                                                            column: 27,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 133,
                                                                                            column: 73,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                properties: [
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'focus',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 134,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 134,
                                                                                                    column: 29,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Function',
                                                                                            context: true,
                                                                                            value: function (_context6) {
                                                                                                return function () {
                                                                                                    var form = _context6.get('form');
                                                                                                    return form.focus();
                                                                                                };
                                                                                            }
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'ObjectExpression',
                                                                                            objectType: {
                                                                                                type: 'CallExpression',
                                                                                                callee: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'Div',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 135,
                                                                                                            column: 24,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 135,
                                                                                                            column: 27,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                arguments: [{
                                                                                                        type: 'ObjectExpression',
                                                                                                        properties: [{
                                                                                                                type: 'Property',
                                                                                                                key: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'style',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 135,
                                                                                                                            column: 29,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 135,
                                                                                                                            column: 34,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                value: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: 'font-size:25px;padding:8px 0px'
                                                                                                                },
                                                                                                                kind: 'init',
                                                                                                                order: '0'
                                                                                                            }]
                                                                                                    }],
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 135,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 135,
                                                                                                        column: 69,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            properties: [{
                                                                                                    type: 'ExpressionStatement',
                                                                                                    expression: {
                                                                                                        type: 'Literal',
                                                                                                        value: 'Add team members.'
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 136,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 136,
                                                                                                            column: 47,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        }
                                                                                                    },
                                                                                                    order: '0'
                                                                                                }]
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 135,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 137,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '1'
                                                                                    },
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'Identifier',
                                                                                            name: 'form',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 137,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 137,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 137,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 137,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '2'
                                                                                    },
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'ObjectExpression',
                                                                                            objectType: {
                                                                                                type: 'CallExpression',
                                                                                                callee: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'Div',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 138,
                                                                                                            column: 24,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 138,
                                                                                                            column: 27,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                arguments: [{
                                                                                                        type: 'ObjectExpression',
                                                                                                        properties: [{
                                                                                                                type: 'Property',
                                                                                                                key: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'class',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 138,
                                                                                                                            column: 29,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 138,
                                                                                                                            column: 34,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                value: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: 'layout vertical flex center fill'
                                                                                                                },
                                                                                                                kind: 'init',
                                                                                                                order: '0'
                                                                                                            }]
                                                                                                    }],
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 138,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 138,
                                                                                                        column: 71,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            properties: [{
                                                                                                    type: 'IfStatement',
                                                                                                    test: {
                                                                                                        type: 'BinaryExpression',
                                                                                                        operator: '>',
                                                                                                        left: {
                                                                                                            type: 'MemberExpression',
                                                                                                            computed: false,
                                                                                                            object: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'members',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 139,
                                                                                                                        column: 31,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 139,
                                                                                                                        column: 38,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            property: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'length',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 139,
                                                                                                                        column: 39,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 139,
                                                                                                                        column: 45,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 139,
                                                                                                                    column: 31,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 139,
                                                                                                                    column: 45,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        right: {
                                                                                                            type: 'Literal',
                                                                                                            value: 0
                                                                                                        }
                                                                                                    },
                                                                                                    consequent: {
                                                                                                        type: 'BlockStatement',
                                                                                                        body: [{
                                                                                                                type: 'ExpressionStatement',
                                                                                                                expression: {
                                                                                                                    type: 'ObjectExpression',
                                                                                                                    objectType: {
                                                                                                                        type: 'CallExpression',
                                                                                                                        callee: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'Ul',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 140,
                                                                                                                                    column: 32,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 140,
                                                                                                                                    column: 34,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        arguments: [{
                                                                                                                                type: 'ObjectExpression',
                                                                                                                                properties: [{
                                                                                                                                        type: 'Property',
                                                                                                                                        key: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'class',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 140,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 140,
                                                                                                                                                    column: 41,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        value: {
                                                                                                                                            type: 'Literal',
                                                                                                                                            value: 'MembersList'
                                                                                                                                        },
                                                                                                                                        kind: 'init',
                                                                                                                                        order: '0'
                                                                                                                                    }]
                                                                                                                            }],
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 140,
                                                                                                                                column: 32,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 140,
                                                                                                                                column: 57,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    properties: [{
                                                                                                                            type: 'ForOfStatement',
                                                                                                                            left: {
                                                                                                                                type: 'VariableDeclaration',
                                                                                                                                declarations: [{
                                                                                                                                        type: 'VariableDeclarator',
                                                                                                                                        id: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'member',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 141,
                                                                                                                                                    column: 40,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 141,
                                                                                                                                                    column: 46,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        init: null
                                                                                                                                    }],
                                                                                                                                kind: 'let'
                                                                                                                            },
                                                                                                                            right: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'members',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 141,
                                                                                                                                        column: 50,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 141,
                                                                                                                                        column: 57,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            body: {
                                                                                                                                type: 'BlockStatement',
                                                                                                                                body: [{
                                                                                                                                        type: 'ExpressionStatement',
                                                                                                                                        expression: {
                                                                                                                                            type: 'ObjectExpression',
                                                                                                                                            objectType: {
                                                                                                                                                type: 'CallExpression',
                                                                                                                                                callee: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'Li',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 142,
                                                                                                                                                            column: 40,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 142,
                                                                                                                                                            column: 42,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                arguments: [{
                                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                                        properties: [{
                                                                                                                                                                type: 'Property',
                                                                                                                                                                key: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'class',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 142,
                                                                                                                                                                            column: 44,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 142,
                                                                                                                                                                            column: 49,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                value: {
                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                    value: 'layout horizontal flex center justified'
                                                                                                                                                                },
                                                                                                                                                                kind: 'init',
                                                                                                                                                                order: '0'
                                                                                                                                                            }]
                                                                                                                                                    }],
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 142,
                                                                                                                                                        column: 40,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 142,
                                                                                                                                                        column: 93,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            properties: [
                                                                                                                                                {
                                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                                    expression: {
                                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                                        objectType: {
                                                                                                                                                            type: 'CallExpression',
                                                                                                                                                            callee: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'Div',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 143,
                                                                                                                                                                        column: 44,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 143,
                                                                                                                                                                        column: 47,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            arguments: [],
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 143,
                                                                                                                                                                    column: 44,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 143,
                                                                                                                                                                    column: 49,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        properties: [
                                                                                                                                                            {
                                                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                                                expression: {
                                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                                    objectType: {
                                                                                                                                                                        type: 'CallExpression',
                                                                                                                                                                        callee: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'PaperIconButton',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 144,
                                                                                                                                                                                    column: 48,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 144,
                                                                                                                                                                                    column: 63,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        arguments: [{
                                                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                                                properties: [{
                                                                                                                                                                                        type: 'Property',
                                                                                                                                                                                        key: {
                                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                                            name: 'class',
                                                                                                                                                                                            loc: {
                                                                                                                                                                                                start: {
                                                                                                                                                                                                    line: 144,
                                                                                                                                                                                                    column: 65,
                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                                                                },
                                                                                                                                                                                                end: {
                                                                                                                                                                                                    line: 144,
                                                                                                                                                                                                    column: 70,
                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                                                                }
                                                                                                                                                                                            }
                                                                                                                                                                                        },
                                                                                                                                                                                        value: {
                                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                                            value: 'DeleteMemberIcon'
                                                                                                                                                                                        },
                                                                                                                                                                                        kind: 'init',
                                                                                                                                                                                        order: '0'
                                                                                                                                                                                    }]
                                                                                                                                                                            }],
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 144,
                                                                                                                                                                                column: 48,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 144,
                                                                                                                                                                                column: 91,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    properties: [
                                                                                                                                                                        {
                                                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                                                            expression: {
                                                                                                                                                                                type: 'Function',
                                                                                                                                                                                context: true,
                                                                                                                                                                                value: function (_context7) {
                                                                                                                                                                                    return function click() {
                                                                                                                                                                                        var members = _context7.get('members'), member = _context7.get('member');
                                                                                                                                                                                        return members.remove(member);
                                                                                                                                                                                    };
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 145,
                                                                                                                                                                                    column: 52,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 145,
                                                                                                                                                                                    column: 85,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            order: '0'
                                                                                                                                                                        },
                                                                                                                                                                        {
                                                                                                                                                                            type: 'Property',
                                                                                                                                                                            key: {
                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                name: 'icon',
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 146,
                                                                                                                                                                                        column: 52,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 146,
                                                                                                                                                                                        column: 56,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            value: {
                                                                                                                                                                                type: 'Literal',
                                                                                                                                                                                value: 'clear'
                                                                                                                                                                            },
                                                                                                                                                                            kind: 'init',
                                                                                                                                                                            order: '1'
                                                                                                                                                                        }
                                                                                                                                                                    ]
                                                                                                                                                                },
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 144,
                                                                                                                                                                        column: 48,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 147,
                                                                                                                                                                        column: 52,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                order: '0'
                                                                                                                                                            },
                                                                                                                                                            {
                                                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                                                expression: {
                                                                                                                                                                    type: 'BinaryExpression',
                                                                                                                                                                    operator: '+',
                                                                                                                                                                    left: {
                                                                                                                                                                        type: 'MemberExpression',
                                                                                                                                                                        computed: false,
                                                                                                                                                                        object: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'member',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 147,
                                                                                                                                                                                    column: 48,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 147,
                                                                                                                                                                                    column: 54,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        property: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'name',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 147,
                                                                                                                                                                                    column: 55,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 147,
                                                                                                                                                                                    column: 59,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 147,
                                                                                                                                                                                column: 48,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 147,
                                                                                                                                                                                column: 59,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    right: {
                                                                                                                                                                        type: 'Literal',
                                                                                                                                                                        value: ': '
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 147,
                                                                                                                                                                        column: 48,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 147,
                                                                                                                                                                        column: 66,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                order: '1'
                                                                                                                                                            }
                                                                                                                                                        ]
                                                                                                                                                    },
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 143,
                                                                                                                                                            column: 44,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 148,
                                                                                                                                                            column: 48,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    order: '0'
                                                                                                                                                },
                                                                                                                                                {
                                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                                    expression: {
                                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                                        objectType: {
                                                                                                                                                            type: 'CallExpression',
                                                                                                                                                            callee: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'Div',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 148,
                                                                                                                                                                        column: 44,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 148,
                                                                                                                                                                        column: 47,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            arguments: [],
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 148,
                                                                                                                                                                    column: 44,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 148,
                                                                                                                                                                    column: 49,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        properties: [{
                                                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                                                expression: {
                                                                                                                                                                    type: 'MemberExpression',
                                                                                                                                                                    computed: false,
                                                                                                                                                                    object: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'member',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 149,
                                                                                                                                                                                column: 48,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 149,
                                                                                                                                                                                column: 54,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    property: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'email',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 149,
                                                                                                                                                                                column: 55,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 149,
                                                                                                                                                                                column: 60,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 149,
                                                                                                                                                                            column: 48,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 149,
                                                                                                                                                                            column: 60,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 149,
                                                                                                                                                                        column: 48,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 149,
                                                                                                                                                                        column: 60,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                order: '0'
                                                                                                                                                            }]
                                                                                                                                                    },
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 148,
                                                                                                                                                            column: 44,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 151,
                                                                                                                                                            column: 48,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    order: '1'
                                                                                                                                                }
                                                                                                                                            ]
                                                                                                                                        },
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 142,
                                                                                                                                                column: 40,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 151,
                                                                                                                                                column: 44,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        order: '0'
                                                                                                                                    }]
                                                                                                                            },
                                                                                                                            remove: null,
                                                                                                                            order: '0'
                                                                                                                        }]
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 140,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 151,
                                                                                                                        column: 36,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    }
                                                                                                                },
                                                                                                                order: '0'
                                                                                                            }]
                                                                                                    },
                                                                                                    alternate: null,
                                                                                                    order: '0'
                                                                                                }]
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 138,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 151,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '3'
                                                                                    },
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'ObjectExpression',
                                                                                            objectType: {
                                                                                                type: 'CallExpression',
                                                                                                callee: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'Div',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 151,
                                                                                                            column: 24,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 151,
                                                                                                            column: 27,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                arguments: [],
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 151,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 151,
                                                                                                        column: 29,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            properties: [
                                                                                                {
                                                                                                    type: 'ExpressionStatement',
                                                                                                    expression: {
                                                                                                        type: 'ObjectExpression',
                                                                                                        objectType: {
                                                                                                            type: 'CallExpression',
                                                                                                            callee: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'PaperButton',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 152,
                                                                                                                        column: 28,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 152,
                                                                                                                        column: 39,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            arguments: [],
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 152,
                                                                                                                    column: 28,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 152,
                                                                                                                    column: 41,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        properties: [
                                                                                                            {
                                                                                                                type: 'ExpressionStatement',
                                                                                                                expression: {
                                                                                                                    type: 'Function',
                                                                                                                    context: true,
                                                                                                                    value: function (_context8) {
                                                                                                                        return function click() {
                                                                                                                            var dialog = _context8.get('dialog');
                                                                                                                            return dialog.open = false;
                                                                                                                        };
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 153,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 153,
                                                                                                                        column: 62,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    }
                                                                                                                },
                                                                                                                order: '0'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'ExpressionStatement',
                                                                                                                expression: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: 'Cancel'
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 154,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 154,
                                                                                                                        column: 40,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    }
                                                                                                                },
                                                                                                                order: '1'
                                                                                                            }
                                                                                                        ]
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 152,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 155,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        }
                                                                                                    },
                                                                                                    order: '0'
                                                                                                },
                                                                                                {
                                                                                                    type: 'ExpressionStatement',
                                                                                                    expression: {
                                                                                                        type: 'ObjectExpression',
                                                                                                        objectType: {
                                                                                                            type: 'CallExpression',
                                                                                                            callee: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'PaperButton',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 155,
                                                                                                                        column: 28,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 155,
                                                                                                                        column: 39,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            arguments: [],
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 155,
                                                                                                                    column: 28,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 155,
                                                                                                                    column: 41,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        properties: [
                                                                                                            {
                                                                                                                type: 'ExpressionStatement',
                                                                                                                expression: {
                                                                                                                    type: 'Function',
                                                                                                                    context: true,
                                                                                                                    value: function (_context9) {
                                                                                                                        return function click() {
                                                                                                                            var values = _context9.get('values'), members = _context9.get('members'), stepper = _context9.get('stepper');
                                                                                                                            values.members = JSON.parse(JSON.stringify(members));
                                                                                                                            stepper.complete();
                                                                                                                        };
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 156,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 159,
                                                                                                                        column: 36,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    }
                                                                                                                },
                                                                                                                order: '0'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'Property',
                                                                                                                key: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'raised',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 159,
                                                                                                                            column: 32,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 159,
                                                                                                                            column: 38,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                value: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: true
                                                                                                                },
                                                                                                                kind: 'init',
                                                                                                                order: '1'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'ExpressionStatement',
                                                                                                                expression: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: 'Next'
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 160,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 160,
                                                                                                                        column: 38,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    }
                                                                                                                },
                                                                                                                order: '2'
                                                                                                            }
                                                                                                        ]
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 155,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 162,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        }
                                                                                                    },
                                                                                                    order: '1'
                                                                                                }
                                                                                            ]
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 151,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 162,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '4'
                                                                                    }
                                                                                ]
                                                                            },
                                                                            order: '6'
                                                                        }
                                                                    ],
                                                                    bound: false,
                                                                    name: {
                                                                        type: 'Identifier',
                                                                        name: 'content',
                                                                        loc: {
                                                                            start: {
                                                                                line: 101,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                            },
                                                                            end: {
                                                                                line: 101,
                                                                                column: 23,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    scope: {
                                                                        type: 'Identifier',
                                                                        name: '_ps2'
                                                                    }
                                                                }, {
                                                                    this: this,
                                                                    stepper: stepper,
                                                                    _ps2: _ps2,
                                                                    ion: ion,
                                                                    glass: glass,
                                                                    _ref: _ref,
                                                                    _ref2: _ref2,
                                                                    style: style,
                                                                    _ref3: _ref3,
                                                                    _ref4: _ref4,
                                                                    Dialog: Dialog,
                                                                    Stepper: Stepper,
                                                                    GlassForm: GlassForm,
                                                                    SubmitButton: SubmitButton,
                                                                    CancelButton: CancelButton,
                                                                    Field: Field,
                                                                    Checkbox: Checkbox,
                                                                    Organization: Organization,
                                                                    Project: Project,
                                                                    ProjectType: ProjectType,
                                                                    PermissionLevel: PermissionLevel,
                                                                    User: User,
                                                                    Key: Key,
                                                                    internal: internal
                                                                }, _ps2);
                                                            });
                                                        }
                                                    },
                                                    kind: 'init',
                                                    order: '3'
                                                }
                                            ]
                                        },
                                        loc: {
                                            start: {
                                                line: 97,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/SetupWizard.ion'
                                            },
                                            end: {
                                                line: 162,
                                                column: 16,
                                                fixed: true,
                                                source: 'viewpath/html/SetupWizard.ion'
                                            }
                                        },
                                        order: '1'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'ObjectExpression',
                                            objectType: {
                                                type: 'ObjectExpression',
                                                properties: []
                                            },
                                            properties: [
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'name',
                                                        loc: {
                                                            start: {
                                                                line: 163,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/SetupWizard.ion'
                                                            },
                                                            end: {
                                                                line: 163,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/SetupWizard.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 'Start a Project'
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'editable',
                                                        loc: {
                                                            start: {
                                                                line: 164,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/SetupWizard.ion'
                                                            },
                                                            end: {
                                                                line: 164,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'viewpath/html/SetupWizard.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: true
                                                    },
                                                    kind: 'init',
                                                    order: '1'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'content',
                                                        loc: {
                                                            start: {
                                                                line: 165,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/SetupWizard.ion'
                                                            },
                                                            end: {
                                                                line: 165,
                                                                column: 23,
                                                                fixed: true,
                                                                source: 'viewpath/html/SetupWizard.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Function',
                                                        context: true,
                                                        value: function (_ps3) {
                                                            return ion.template(function (stepper) {
                                                                return ion.createRuntime({
                                                                    type: 'Template',
                                                                    id: null,
                                                                    body: [{
                                                                            type: 'ReturnStatement',
                                                                            argument: {
                                                                                type: 'ObjectExpression',
                                                                                objectType: {
                                                                                    type: 'CallExpression',
                                                                                    callee: {
                                                                                        type: 'Identifier',
                                                                                        name: 'GlassForm',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 166,
                                                                                                column: 27,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 166,
                                                                                                column: 36,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    arguments: [{
                                                                                            type: 'ObjectExpression',
                                                                                            properties: [{
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'class',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 166,
                                                                                                                column: 38,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 166,
                                                                                                                column: 43,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'Literal',
                                                                                                        value: 'layout vertical flex'
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '0'
                                                                                                }]
                                                                                        }],
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 166,
                                                                                            column: 27,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 166,
                                                                                            column: 68,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                properties: [
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'Function',
                                                                                            context: true,
                                                                                            value: function (_context10) {
                                                                                                return function complete() {
                                                                                                    var values = _context10.get('values'), finalize = _context10.get('finalize');
                                                                                                    values.projectName = this.values.name;
                                                                                                    finalize();
                                                                                                };
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 167,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 171,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'ObjectExpression',
                                                                                            objectType: {
                                                                                                type: 'CallExpression',
                                                                                                callee: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'Div',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 171,
                                                                                                            column: 24,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 171,
                                                                                                            column: 27,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                arguments: [{
                                                                                                        type: 'ObjectExpression',
                                                                                                        properties: [{
                                                                                                                type: 'Property',
                                                                                                                key: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'style',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 171,
                                                                                                                            column: 29,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 171,
                                                                                                                            column: 34,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                value: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: 'font-size:25px;padding:8px 0px'
                                                                                                                },
                                                                                                                kind: 'init',
                                                                                                                order: '0'
                                                                                                            }]
                                                                                                    }],
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 171,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 171,
                                                                                                        column: 69,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            properties: [{
                                                                                                    type: 'ExpressionStatement',
                                                                                                    expression: {
                                                                                                        type: 'Literal',
                                                                                                        value: 'Let\'s create a project!'
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 172,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 172,
                                                                                                            column: 53,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        }
                                                                                                    },
                                                                                                    order: '0'
                                                                                                }]
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 171,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 173,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '1'
                                                                                    },
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'ObjectExpression',
                                                                                            objectType: {
                                                                                                type: 'CallExpression',
                                                                                                callee: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'Div',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 173,
                                                                                                            column: 24,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 173,
                                                                                                            column: 27,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                arguments: [{
                                                                                                        type: 'ObjectExpression',
                                                                                                        properties: [{
                                                                                                                type: 'Property',
                                                                                                                key: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'style',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 173,
                                                                                                                            column: 29,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 173,
                                                                                                                            column: 34,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                value: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: 'font-size:12px;color:gray;font-weight:bold;padding:8px 0px'
                                                                                                                },
                                                                                                                kind: 'init',
                                                                                                                order: '0'
                                                                                                            }]
                                                                                                    }],
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 173,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 173,
                                                                                                        column: 97,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            properties: [{
                                                                                                    type: 'ExpressionStatement',
                                                                                                    expression: {
                                                                                                        type: 'Literal',
                                                                                                        value: 'A project contains a series of tasks you can then assign to team members.'
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 174,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 174,
                                                                                                            column: 103,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        }
                                                                                                    },
                                                                                                    order: '0'
                                                                                                }]
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 173,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 176,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '2'
                                                                                    },
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'CallExpression',
                                                                                            callee: {
                                                                                                type: 'Identifier',
                                                                                                name: 'Field',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 176,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 176,
                                                                                                        column: 29,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            arguments: [{
                                                                                                    type: 'ObjectExpression',
                                                                                                    properties: [{
                                                                                                            type: 'Property',
                                                                                                            key: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'property',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 176,
                                                                                                                        column: 31,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 176,
                                                                                                                        column: 39,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            value: {
                                                                                                                type: 'MemberExpression',
                                                                                                                computed: false,
                                                                                                                object: {
                                                                                                                    type: 'MemberExpression',
                                                                                                                    computed: false,
                                                                                                                    object: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'Project',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 176,
                                                                                                                                column: 40,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 176,
                                                                                                                                column: 47,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    property: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'properties',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 176,
                                                                                                                                column: 48,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 176,
                                                                                                                                column: 58,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 176,
                                                                                                                            column: 40,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 176,
                                                                                                                            column: 58,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                property: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'name',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 176,
                                                                                                                            column: 59,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 176,
                                                                                                                            column: 63,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 176,
                                                                                                                        column: 40,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 176,
                                                                                                                        column: 63,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            kind: 'init',
                                                                                                            order: '0'
                                                                                                        }]
                                                                                                }],
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 176,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 176,
                                                                                                    column: 65,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 176,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 176,
                                                                                                column: 65,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '3'
                                                                                    },
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'CallExpression',
                                                                                            callee: {
                                                                                                type: 'Identifier',
                                                                                                name: 'Div',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 177,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 177,
                                                                                                        column: 27,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            arguments: [{
                                                                                                    type: 'ObjectExpression',
                                                                                                    properties: [{
                                                                                                            type: 'Property',
                                                                                                            key: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'class',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 177,
                                                                                                                        column: 29,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 177,
                                                                                                                        column: 34,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            value: {
                                                                                                                type: 'Literal',
                                                                                                                value: 'fill'
                                                                                                            },
                                                                                                            kind: 'init',
                                                                                                            order: '0'
                                                                                                        }]
                                                                                                }],
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 177,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 177,
                                                                                                    column: 43,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 177,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 177,
                                                                                                column: 43,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '4'
                                                                                    },
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'ObjectExpression',
                                                                                            objectType: {
                                                                                                type: 'CallExpression',
                                                                                                callee: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'Div',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 178,
                                                                                                            column: 24,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 178,
                                                                                                            column: 27,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                arguments: [],
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 178,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 178,
                                                                                                        column: 29,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            properties: [
                                                                                                {
                                                                                                    type: 'ExpressionStatement',
                                                                                                    expression: {
                                                                                                        type: 'ObjectExpression',
                                                                                                        objectType: {
                                                                                                            type: 'CallExpression',
                                                                                                            callee: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'PaperButton',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 179,
                                                                                                                        column: 28,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 179,
                                                                                                                        column: 39,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            arguments: [],
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 179,
                                                                                                                    column: 28,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 179,
                                                                                                                    column: 41,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        properties: [
                                                                                                            {
                                                                                                                type: 'ExpressionStatement',
                                                                                                                expression: {
                                                                                                                    type: 'Function',
                                                                                                                    context: true,
                                                                                                                    value: function (_context11) {
                                                                                                                        return function click() {
                                                                                                                            var dialog = _context11.get('dialog');
                                                                                                                            return dialog.open = false;
                                                                                                                        };
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 180,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 180,
                                                                                                                        column: 62,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    }
                                                                                                                },
                                                                                                                order: '0'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'ExpressionStatement',
                                                                                                                expression: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: 'Cancel'
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 181,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 181,
                                                                                                                        column: 40,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    }
                                                                                                                },
                                                                                                                order: '1'
                                                                                                            }
                                                                                                        ]
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 179,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 182,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        }
                                                                                                    },
                                                                                                    order: '0'
                                                                                                },
                                                                                                {
                                                                                                    type: 'ExpressionStatement',
                                                                                                    expression: {
                                                                                                        type: 'ObjectExpression',
                                                                                                        objectType: {
                                                                                                            type: 'CallExpression',
                                                                                                            callee: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'SubmitButton',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 182,
                                                                                                                        column: 28,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 182,
                                                                                                                        column: 40,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            arguments: [],
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 182,
                                                                                                                    column: 28,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 182,
                                                                                                                    column: 42,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        properties: [{
                                                                                                                type: 'ExpressionStatement',
                                                                                                                expression: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: 'Finish'
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 183,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 183,
                                                                                                                        column: 40,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                                                    }
                                                                                                                },
                                                                                                                order: '0'
                                                                                                            }]
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 182,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 185,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                                        }
                                                                                                    },
                                                                                                    order: '1'
                                                                                                }
                                                                                            ]
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 178,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 185,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '5'
                                                                                    }
                                                                                ]
                                                                            },
                                                                            order: '0'
                                                                        }],
                                                                    bound: false,
                                                                    name: {
                                                                        type: 'Identifier',
                                                                        name: 'content',
                                                                        loc: {
                                                                            start: {
                                                                                line: 165,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                            },
                                                                            end: {
                                                                                line: 165,
                                                                                column: 23,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    scope: {
                                                                        type: 'Identifier',
                                                                        name: '_ps3'
                                                                    }
                                                                }, {
                                                                    this: this,
                                                                    stepper: stepper,
                                                                    _ps3: _ps3,
                                                                    ion: ion,
                                                                    glass: glass,
                                                                    _ref: _ref,
                                                                    _ref2: _ref2,
                                                                    style: style,
                                                                    _ref3: _ref3,
                                                                    _ref4: _ref4,
                                                                    Dialog: Dialog,
                                                                    Stepper: Stepper,
                                                                    GlassForm: GlassForm,
                                                                    SubmitButton: SubmitButton,
                                                                    CancelButton: CancelButton,
                                                                    Field: Field,
                                                                    Checkbox: Checkbox,
                                                                    Organization: Organization,
                                                                    Project: Project,
                                                                    ProjectType: ProjectType,
                                                                    PermissionLevel: PermissionLevel,
                                                                    User: User,
                                                                    Key: Key,
                                                                    internal: internal
                                                                }, _ps3);
                                                            });
                                                        }
                                                    },
                                                    kind: 'init',
                                                    order: '2'
                                                }
                                            ]
                                        },
                                        loc: {
                                            start: {
                                                line: 162,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/SetupWizard.ion'
                                            },
                                            end: {
                                                line: 185,
                                                column: 16,
                                                fixed: true,
                                                source: 'viewpath/html/SetupWizard.ion'
                                            }
                                        },
                                        order: '2'
                                    }
                                ]
                            }
                        }],
                    kind: 'let',
                    order: '3'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'dialog',
                                loc: {
                                    start: {
                                        line: 185,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/SetupWizard.ion'
                                    },
                                    end: {
                                        line: 185,
                                        column: 18,
                                        fixed: true,
                                        source: 'viewpath/html/SetupWizard.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Dialog',
                                    loc: {
                                        start: {
                                            line: 185,
                                            column: 21,
                                            fixed: true,
                                            source: 'viewpath/html/SetupWizard.ion'
                                        },
                                        end: {
                                            line: 185,
                                            column: 27,
                                            fixed: true,
                                            source: 'viewpath/html/SetupWizard.ion'
                                        }
                                    }
                                },
                                arguments: [],
                                loc: {
                                    start: {
                                        line: 185,
                                        column: 21,
                                        fixed: true,
                                        source: 'viewpath/html/SetupWizard.ion'
                                    },
                                    end: {
                                        line: 185,
                                        column: 29,
                                        fixed: true,
                                        source: 'viewpath/html/SetupWizard.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '4'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'stepperElem',
                                loc: {
                                    start: {
                                        line: 186,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/SetupWizard.ion'
                                    },
                                    end: {
                                        line: 186,
                                        column: 23,
                                        fixed: true,
                                        source: 'viewpath/html/SetupWizard.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Stepper',
                                    loc: {
                                        start: {
                                            line: 186,
                                            column: 26,
                                            fixed: true,
                                            source: 'viewpath/html/SetupWizard.ion'
                                        },
                                        end: {
                                            line: 186,
                                            column: 33,
                                            fixed: true,
                                            source: 'viewpath/html/SetupWizard.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'tabs',
                                                    loc: {
                                                        start: {
                                                            line: 186,
                                                            column: 35,
                                                            fixed: true,
                                                            source: 'viewpath/html/SetupWizard.ion'
                                                        },
                                                        end: {
                                                            line: 186,
                                                            column: 39,
                                                            fixed: true,
                                                            source: 'viewpath/html/SetupWizard.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Identifier',
                                                    name: 'tabs',
                                                    loc: {
                                                        start: {
                                                            line: 186,
                                                            column: 35,
                                                            fixed: true,
                                                            source: 'viewpath/html/SetupWizard.ion'
                                                        },
                                                        end: {
                                                            line: 186,
                                                            column: 39,
                                                            fixed: true,
                                                            source: 'viewpath/html/SetupWizard.ion'
                                                        }
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    }],
                                loc: {
                                    start: {
                                        line: 186,
                                        column: 26,
                                        fixed: true,
                                        source: 'viewpath/html/SetupWizard.ion'
                                    },
                                    end: {
                                        line: 186,
                                        column: 41,
                                        fixed: true,
                                        source: 'viewpath/html/SetupWizard.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '5'
                },
                {
                    type: 'ReturnStatement',
                    argument: {
                        type: 'ObjectExpression',
                        objectType: {
                            type: 'Identifier',
                            name: 'dialog',
                            loc: {
                                start: {
                                    line: 187,
                                    column: 15,
                                    fixed: true,
                                    source: 'viewpath/html/SetupWizard.ion'
                                },
                                end: {
                                    line: 187,
                                    column: 21,
                                    fixed: true,
                                    source: 'viewpath/html/SetupWizard.ion'
                                }
                            }
                        },
                        properties: [
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'focus',
                                    loc: {
                                        start: {
                                            line: 188,
                                            column: 12,
                                            fixed: true,
                                            source: 'viewpath/html/SetupWizard.ion'
                                        },
                                        end: {
                                            line: 188,
                                            column: 17,
                                            fixed: true,
                                            source: 'viewpath/html/SetupWizard.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'Function',
                                    context: true,
                                    value: function (_context12) {
                                        return function () {
                                            var stepperElem = _context12.get('stepperElem');
                                            stepperElem.focus();
                                        };
                                    }
                                },
                                kind: 'init',
                                order: '0'
                            },
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'frame',
                                    loc: {
                                        start: {
                                            line: 190,
                                            column: 12,
                                            fixed: true,
                                            source: 'viewpath/html/SetupWizard.ion'
                                        },
                                        end: {
                                            line: 190,
                                            column: 17,
                                            fixed: true,
                                            source: 'viewpath/html/SetupWizard.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'ObjectExpression',
                                    properties: [{
                                            type: 'IfStatement',
                                            test: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'state',
                                                    loc: {
                                                        start: {
                                                            line: 191,
                                                            column: 19,
                                                            fixed: true,
                                                            source: 'viewpath/html/SetupWizard.ion'
                                                        },
                                                        end: {
                                                            line: 191,
                                                            column: 24,
                                                            fixed: true,
                                                            source: 'viewpath/html/SetupWizard.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'creating',
                                                    loc: {
                                                        start: {
                                                            line: 191,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'viewpath/html/SetupWizard.ion'
                                                        },
                                                        end: {
                                                            line: 191,
                                                            column: 33,
                                                            fixed: true,
                                                            source: 'viewpath/html/SetupWizard.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 191,
                                                        column: 19,
                                                        fixed: true,
                                                        source: 'viewpath/html/SetupWizard.ion'
                                                    },
                                                    end: {
                                                        line: 191,
                                                        column: 33,
                                                        fixed: true,
                                                        source: 'viewpath/html/SetupWizard.ion'
                                                    }
                                                }
                                            },
                                            consequent: {
                                                type: 'BlockStatement',
                                                body: [
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'style',
                                                            loc: {
                                                                start: {
                                                                    line: 192,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                },
                                                                end: {
                                                                    line: 192,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'ObjectExpression',
                                                            properties: [
                                                                {
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'minHeight',
                                                                        loc: {
                                                                            start: {
                                                                                line: 193,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                            },
                                                                            end: {
                                                                                line: 193,
                                                                                column: 33,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Literal',
                                                                        value: '0px'
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                },
                                                                {
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'minWidth',
                                                                        loc: {
                                                                            start: {
                                                                                line: 194,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                            },
                                                                            end: {
                                                                                line: 194,
                                                                                column: 32,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Literal',
                                                                        value: '450px'
                                                                    },
                                                                    kind: 'init',
                                                                    order: '1'
                                                                }
                                                            ]
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'ObjectExpression',
                                                            objectType: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Identifier',
                                                                    name: 'Div',
                                                                    loc: {
                                                                        start: {
                                                                            line: 195,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                        },
                                                                        end: {
                                                                            line: 195,
                                                                            column: 23,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'ObjectExpression',
                                                                        properties: [{
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'class',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 195,
                                                                                            column: 25,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 195,
                                                                                            column: 30,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Literal',
                                                                                    value: 'padding layout horizontal justified center fill'
                                                                                },
                                                                                kind: 'init',
                                                                                order: '0'
                                                                            }]
                                                                    }],
                                                                loc: {
                                                                    start: {
                                                                        line: 195,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                    },
                                                                    end: {
                                                                        line: 195,
                                                                        column: 82,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                    }
                                                                }
                                                            },
                                                            properties: [
                                                                {
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'ObjectExpression',
                                                                        objectType: {
                                                                            type: 'CallExpression',
                                                                            callee: {
                                                                                type: 'Identifier',
                                                                                name: 'Div',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 196,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 196,
                                                                                        column: 27,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            arguments: [],
                                                                            loc: {
                                                                                start: {
                                                                                    line: 196,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 196,
                                                                                    column: 29,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        properties: [{
                                                                                type: 'ExpressionStatement',
                                                                                expression: {
                                                                                    type: 'Literal',
                                                                                    value: 'Creating new organization...'
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 197,
                                                                                        column: 28,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 197,
                                                                                        column: 58,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                    }
                                                                                },
                                                                                order: '0'
                                                                            }]
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 196,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                        },
                                                                        end: {
                                                                            line: 198,
                                                                            column: 28,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                        }
                                                                    },
                                                                    order: '0'
                                                                },
                                                                {
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'ObjectExpression',
                                                                        objectType: {
                                                                            type: 'CallExpression',
                                                                            callee: {
                                                                                type: 'Identifier',
                                                                                name: 'Div',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 198,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 198,
                                                                                        column: 27,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            arguments: [],
                                                                            loc: {
                                                                                start: {
                                                                                    line: 198,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 198,
                                                                                    column: 29,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        properties: [{
                                                                                type: 'ExpressionStatement',
                                                                                expression: {
                                                                                    type: 'CallExpression',
                                                                                    callee: {
                                                                                        type: 'Identifier',
                                                                                        name: 'PaperSpinnerLite',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 199,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 199,
                                                                                                column: 44,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    arguments: [{
                                                                                            type: 'ObjectExpression',
                                                                                            properties: [{
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'active',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 199,
                                                                                                                column: 46,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 199,
                                                                                                                column: 52,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'Literal',
                                                                                                        value: true
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '0'
                                                                                                }]
                                                                                        }],
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 199,
                                                                                            column: 28,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 199,
                                                                                            column: 60,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 199,
                                                                                        column: 28,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 199,
                                                                                        column: 60,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/SetupWizard.ion'
                                                                                    }
                                                                                },
                                                                                order: '0'
                                                                            }]
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 198,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                        },
                                                                        end: {
                                                                            line: 200,
                                                                            column: 28,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/SetupWizard.ion'
                                                                        }
                                                                    },
                                                                    order: '1'
                                                                }
                                                            ]
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 195,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/SetupWizard.ion'
                                                            },
                                                            end: {
                                                                line: 200,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'viewpath/html/SetupWizard.ion'
                                                            }
                                                        },
                                                        order: '1'
                                                    }
                                                ]
                                            },
                                            alternate: {
                                                type: 'BlockStatement',
                                                body: [
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'style',
                                                            loc: {
                                                                start: {
                                                                    line: 201,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                },
                                                                end: {
                                                                    line: 201,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'ObjectExpression',
                                                            properties: [
                                                                {
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'minHeight',
                                                                        loc: {
                                                                            start: {
                                                                                line: 202,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                            },
                                                                            end: {
                                                                                line: 202,
                                                                                column: 33,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Literal',
                                                                        value: '400px'
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                },
                                                                {
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'minWidth',
                                                                        loc: {
                                                                            start: {
                                                                                line: 203,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                            },
                                                                            end: {
                                                                                line: 203,
                                                                                column: 32,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/SetupWizard.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Literal',
                                                                        value: '800px'
                                                                    },
                                                                    kind: 'init',
                                                                    order: '1'
                                                                }
                                                            ]
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'Identifier',
                                                            name: 'stepperElem',
                                                            loc: {
                                                                start: {
                                                                    line: 204,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                },
                                                                end: {
                                                                    line: 204,
                                                                    column: 31,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/SetupWizard.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 204,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/SetupWizard.ion'
                                                            },
                                                            end: {
                                                                line: 204,
                                                                column: 31,
                                                                fixed: true,
                                                                source: 'viewpath/html/SetupWizard.ion'
                                                            }
                                                        },
                                                        order: '1'
                                                    }
                                                ]
                                            },
                                            order: '0'
                                        }]
                                },
                                kind: 'init',
                                order: '1'
                            }
                        ]
                    },
                    order: '6'
                }
            ],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'internal',
                loc: {
                    start: {
                        line: 38,
                        column: 4,
                        fixed: true,
                        source: 'viewpath/html/SetupWizard.ion'
                    },
                    end: {
                        line: 38,
                        column: 12,
                        fixed: true,
                        source: 'viewpath/html/SetupWizard.ion'
                    }
                }
            }
        }, {
            this: this,
            ion: ion,
            glass: glass,
            _ref: _ref,
            _ref2: _ref2,
            style: style,
            _ref3: _ref3,
            _ref4: _ref4,
            Dialog: Dialog,
            Stepper: Stepper,
            GlassForm: GlassForm,
            SubmitButton: SubmitButton,
            CancelButton: CancelButton,
            Field: Field,
            Checkbox: Checkbox,
            Organization: Organization,
            Project: Project,
            ProjectType: ProjectType,
            PermissionLevel: PermissionLevel,
            User: User,
            Key: Key,
            internal: internal
        }, null);
    });
module.exports = exports = function () {
    Dialog.show(internal, null);
};
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/SetupWizard',_viewpath_html_SetupWizard_);
    else
      _viewpath_html_SetupWizard_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_SetupWizard_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_StatusColumn_ = function(module,exports,require){'use strict';
var ion = require('ion'), glass = require('glass'), _ref, _ref2, _ref3, _ref4, _ref5, _ref6, isLate = function (task, asOfDate) {
        if (asOfDate == null)
            asOfDate = new Date();
        var finish = task.finish;
        if (!(finish != null)) {
            return false;
        }
        var iso = asOfDate.toISOString();
        return finish < iso;
    }, isOnSchedule = function (task, asOfDate) {
        if (asOfDate == null)
            asOfDate = new Date();
        var _ref7 = task;
        var Start = _ref7.Start;
        var Finish = _ref7.Finish;
        var percent = _ref7.percent;
        if (percent === 100 || !Start || !Finish) {
            return true;
        }
        var time = asOfDate.getTime();
        var start = Start.toDate().getTime();
        var finish = Finish.toDate().getTime();
        var percentTime = 100 * (time - start) / (finish - start);
        return percent >= percentTime;
    }, getColorCode = function (task, asOfDate) {
        if (asOfDate == null)
            asOfDate = new Date();
        var _ref8 = task;
        var Start = _ref8.Start;
        var Finish = _ref8.Finish;
        if (!Start || !Finish) {
            return 'unscheduled';
        }
        if (task.percent === 100) {
            return 'complete';
        }
        if (isLate(task, asOfDate)) {
            return 'late';
        }
        if (isOnSchedule(task, asOfDate)) {
            return 'ontime';
        }
        return 'warning';
    };
_ref = require('../model');
var Task = _ref.Task;
var Project = _ref.Project;
_ref2 = require('./');
var DocumentDialog = _ref2.DocumentDialog;
_ref3 = glass.data;
var Schema = _ref3.Schema;
_ref4 = glass.html.material.DataTable2;
var DefaultColumn = _ref4.DefaultColumn;
_ref5 = glass.convert;
var jsonValueToDisplayValue = _ref5.jsonValueToDisplayValue;
_ref6 = glass.html;
var style = _ref6.style;
var _ref11 = style.sheets;
_ref11[module.id] = '.TaskStatusColumn:before {\n    font-size: 20px;\n    content: "\u25CF";\n    margin-right: 4px;\n    margin-bottom: 2px;\n}\n.TaskStatusColumn.ontime:before {\n    color: #40CC40;\n}\n.TaskStatusColumn.late:before {\n    color: red;\n}\n.TaskStatusColumn.warning:before {\n    color: #DDDD40;\n}\n.TaskStatusColumn.unscheduled:before {\n    content: "\u25CB";\n}\n.TaskStatusColumn.complete:before {\n}\n.TaskStatusColumn.Project {\n}';
_ref11;
module.exports = exports = ion.template(function StatusColumn(property) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'StatusColumn',
            loc: {
                start: {
                    line: 62,
                    column: 16,
                    fixed: true,
                    source: 'viewpath/html/StatusColumn.ion'
                },
                end: {
                    line: 62,
                    column: 28,
                    fixed: true,
                    source: 'viewpath/html/StatusColumn.ion'
                }
            }
        },
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'column',
                            loc: {
                                start: {
                                    line: 63,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/StatusColumn.ion'
                                },
                                end: {
                                    line: 63,
                                    column: 14,
                                    fixed: true,
                                    source: 'viewpath/html/StatusColumn.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'DefaultColumn',
                                loc: {
                                    start: {
                                        line: 63,
                                        column: 17,
                                        fixed: true,
                                        source: 'viewpath/html/StatusColumn.ion'
                                    },
                                    end: {
                                        line: 63,
                                        column: 30,
                                        fixed: true,
                                        source: 'viewpath/html/StatusColumn.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'Identifier',
                                    name: 'property',
                                    loc: {
                                        start: {
                                            line: 63,
                                            column: 31,
                                            fixed: true,
                                            source: 'viewpath/html/StatusColumn.ion'
                                        },
                                        end: {
                                            line: 63,
                                            column: 39,
                                            fixed: true,
                                            source: 'viewpath/html/StatusColumn.ion'
                                        }
                                    }
                                }],
                            loc: {
                                start: {
                                    line: 63,
                                    column: 17,
                                    fixed: true,
                                    source: 'viewpath/html/StatusColumn.ion'
                                },
                                end: {
                                    line: 63,
                                    column: 40,
                                    fixed: true,
                                    source: 'viewpath/html/StatusColumn.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'Identifier',
                        name: 'column',
                        loc: {
                            start: {
                                line: 64,
                                column: 11,
                                fixed: true,
                                source: 'viewpath/html/StatusColumn.ion'
                            },
                            end: {
                                line: 64,
                                column: 17,
                                fixed: true,
                                source: 'viewpath/html/StatusColumn.ion'
                            }
                        }
                    },
                    properties: [{
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'createBodyCell',
                                loc: {
                                    start: {
                                        line: 65,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/html/StatusColumn.ion'
                                    },
                                    end: {
                                        line: 65,
                                        column: 22,
                                        fixed: true,
                                        source: 'viewpath/html/StatusColumn.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_ps) {
                                    return ion.template(function (row) {
                                        return ion.createRuntime({
                                            type: 'Template',
                                            id: null,
                                            body: [
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: '_ref9'
                                                            },
                                                            init: {
                                                                type: 'Identifier',
                                                                name: 'row',
                                                                loc: {
                                                                    start: {
                                                                        line: 66,
                                                                        column: 27,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/StatusColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 66,
                                                                        column: 30,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/StatusColumn.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'record',
                                                                loc: {
                                                                    start: {
                                                                        line: 66,
                                                                        column: 17,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/StatusColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 66,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/StatusColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'MemberExpression',
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: '_ref9'
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'record',
                                                                    loc: {
                                                                        start: {
                                                                            line: 66,
                                                                            column: 17,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/StatusColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 66,
                                                                            column: 23,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/StatusColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                computed: false
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '1'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: '_ref10'
                                                            },
                                                            init: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Function',
                                                                    context: true,
                                                                    value: function (_context) {
                                                                        return function (record) {
                                                                            var Schema = _context.get('Schema'), property = _context.get('property'), jsonValueToDisplayValue = _context.get('jsonValueToDisplayValue'), Project = _context.get('Project'), getColorCode = _context.get('getColorCode');
                                                                            var status = Schema.get(record, property);
                                                                            var text = jsonValueToDisplayValue(property, status);
                                                                            if (record.constructor === Project) {
                                                                                text = '';
                                                                            }
                                                                            var color = getColorCode(record, new Date());
                                                                            return [
                                                                                text,
                                                                                color,
                                                                                record.constructor.name
                                                                            ];
                                                                        };
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'Identifier',
                                                                        name: 'record',
                                                                        loc: {
                                                                            start: {
                                                                                line: 67,
                                                                                column: 43,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/StatusColumn.ion'
                                                                            },
                                                                            end: {
                                                                                line: 67,
                                                                                column: 49,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/StatusColumn.ion'
                                                                            }
                                                                        }
                                                                    }],
                                                                loc: {
                                                                    start: {
                                                                        line: 67,
                                                                        column: 39,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/StatusColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 74,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/StatusColumn.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '2'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'value',
                                                                loc: {
                                                                    start: {
                                                                        line: 67,
                                                                        column: 17,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/StatusColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 67,
                                                                        column: 22,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/StatusColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'MemberExpression',
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: '_ref10'
                                                                },
                                                                property: {
                                                                    type: 'Literal',
                                                                    value: 0
                                                                },
                                                                computed: true
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '3'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'color',
                                                                loc: {
                                                                    start: {
                                                                        line: 67,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/StatusColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 67,
                                                                        column: 29,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/StatusColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'MemberExpression',
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: '_ref10'
                                                                },
                                                                property: {
                                                                    type: 'Literal',
                                                                    value: 1
                                                                },
                                                                computed: true
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '4'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'type',
                                                                loc: {
                                                                    start: {
                                                                        line: 67,
                                                                        column: 31,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/StatusColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 67,
                                                                        column: 35,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/StatusColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'MemberExpression',
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: '_ref10'
                                                                },
                                                                property: {
                                                                    type: 'Literal',
                                                                    value: 2
                                                                },
                                                                computed: true
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '5'
                                                },
                                                {
                                                    type: 'ReturnStatement',
                                                    argument: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'Span',
                                                                loc: {
                                                                    start: {
                                                                        line: 74,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/StatusColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 74,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/StatusColumn.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [{
                                                                    type: 'ObjectExpression',
                                                                    properties: [{
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'class',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 74,
                                                                                        column: 25,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/StatusColumn.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 74,
                                                                                        column: 30,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/StatusColumn.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'TaskStatusColumn'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        }]
                                                                }],
                                                            loc: {
                                                                start: {
                                                                    line: 74,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/StatusColumn.ion'
                                                                },
                                                                end: {
                                                                    line: 74,
                                                                    column: 51,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/StatusColumn.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'classList',
                                                                    loc: {
                                                                        start: {
                                                                            line: 75,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/StatusColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 75,
                                                                            column: 25,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/StatusColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'ObjectExpression',
                                                                    properties: [
                                                                        {
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'Identifier',
                                                                                name: 'color',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 76,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/StatusColumn.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 76,
                                                                                        column: 25,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/StatusColumn.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 76,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/StatusColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 76,
                                                                                    column: 25,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/StatusColumn.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'Identifier',
                                                                                name: 'type',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 77,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/StatusColumn.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 77,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/StatusColumn.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 77,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/StatusColumn.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 77,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/StatusColumn.ion'
                                                                                }
                                                                            },
                                                                            order: '1'
                                                                        }
                                                                    ]
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'Identifier',
                                                                    name: 'value',
                                                                    loc: {
                                                                        start: {
                                                                            line: 78,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/StatusColumn.ion'
                                                                        },
                                                                        end: {
                                                                            line: 78,
                                                                            column: 21,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/StatusColumn.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 78,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/StatusColumn.ion'
                                                                    },
                                                                    end: {
                                                                        line: 78,
                                                                        column: 21,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/StatusColumn.ion'
                                                                    }
                                                                },
                                                                order: '1'
                                                            }
                                                        ]
                                                    },
                                                    order: '6'
                                                }
                                            ],
                                            bound: false,
                                            name: {
                                                type: 'Identifier',
                                                name: 'createBodyCell',
                                                loc: {
                                                    start: {
                                                        line: 65,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'viewpath/html/StatusColumn.ion'
                                                    },
                                                    end: {
                                                        line: 65,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'viewpath/html/StatusColumn.ion'
                                                    }
                                                }
                                            },
                                            scope: {
                                                type: 'Identifier',
                                                name: '_ps'
                                            }
                                        }, {
                                            this: this,
                                            row: row,
                                            _ps: _ps,
                                            property: property,
                                            ion: ion,
                                            glass: glass,
                                            _ref: _ref,
                                            _ref2: _ref2,
                                            _ref3: _ref3,
                                            _ref4: _ref4,
                                            _ref5: _ref5,
                                            _ref6: _ref6,
                                            isLate: isLate,
                                            isOnSchedule: isOnSchedule,
                                            getColorCode: getColorCode,
                                            Task: Task,
                                            Project: Project,
                                            DocumentDialog: DocumentDialog,
                                            Schema: Schema,
                                            DefaultColumn: DefaultColumn,
                                            jsonValueToDisplayValue: jsonValueToDisplayValue,
                                            style: style,
                                            _ref11: _ref11
                                        }, _ps);
                                    });
                                }
                            },
                            kind: 'init',
                            order: '0'
                        }]
                },
                order: '1'
            }
        ],
        bound: false
    }, {
        this: this,
        ion: ion,
        property: property,
        glass: glass,
        _ref: _ref,
        _ref2: _ref2,
        _ref3: _ref3,
        _ref4: _ref4,
        _ref5: _ref5,
        _ref6: _ref6,
        isLate: isLate,
        isOnSchedule: isOnSchedule,
        getColorCode: getColorCode,
        Task: Task,
        Project: Project,
        DocumentDialog: DocumentDialog,
        Schema: Schema,
        DefaultColumn: DefaultColumn,
        jsonValueToDisplayValue: jsonValueToDisplayValue,
        style: style,
        _ref11: _ref11
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/StatusColumn',_viewpath_html_StatusColumn_);
    else
      _viewpath_html_StatusColumn_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_StatusColumn_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_SubscriptionNotice_ = function(module,exports,require){'use strict';
var ion = require('ion');
module.exports = exports = ion.template(function (action, mustBeDefined, onclick) {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'user',
                            loc: {
                                start: {
                                    line: 2,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/SubscriptionNotice.ion'
                                },
                                end: {
                                    line: 2,
                                    column: 12,
                                    fixed: true,
                                    source: 'viewpath/html/SubscriptionNotice.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            computed: false,
                            object: {
                                type: 'Identifier',
                                name: 'model',
                                loc: {
                                    start: {
                                        line: 2,
                                        column: 15,
                                        fixed: true,
                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                    },
                                    end: {
                                        line: 2,
                                        column: 20,
                                        fixed: true,
                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'user',
                                loc: {
                                    start: {
                                        line: 2,
                                        column: 21,
                                        fixed: true,
                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                    },
                                    end: {
                                        line: 2,
                                        column: 25,
                                        fixed: true,
                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 2,
                                    column: 15,
                                    fixed: true,
                                    source: 'viewpath/html/SubscriptionNotice.ion'
                                },
                                end: {
                                    line: 2,
                                    column: 25,
                                    fixed: true,
                                    source: 'viewpath/html/SubscriptionNotice.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'subscription',
                            loc: {
                                start: {
                                    line: 3,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/SubscriptionNotice.ion'
                                },
                                end: {
                                    line: 3,
                                    column: 20,
                                    fixed: true,
                                    source: 'viewpath/html/SubscriptionNotice.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            computed: false,
                            object: {
                                type: 'Identifier',
                                name: 'model',
                                loc: {
                                    start: {
                                        line: 3,
                                        column: 23,
                                        fixed: true,
                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                    },
                                    end: {
                                        line: 3,
                                        column: 28,
                                        fixed: true,
                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'subscription',
                                loc: {
                                    start: {
                                        line: 3,
                                        column: 29,
                                        fixed: true,
                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                    },
                                    end: {
                                        line: 3,
                                        column: 41,
                                        fixed: true,
                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 3,
                                    column: 23,
                                    fixed: true,
                                    source: 'viewpath/html/SubscriptionNotice.ion'
                                },
                                end: {
                                    line: 3,
                                    column: 41,
                                    fixed: true,
                                    source: 'viewpath/html/SubscriptionNotice.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'missingSubscription',
                            loc: {
                                start: {
                                    line: 6,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/SubscriptionNotice.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 27,
                                    fixed: true,
                                    source: 'viewpath/html/SubscriptionNotice.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ConditionalExpression',
                            test: {
                                type: 'Identifier',
                                name: 'mustBeDefined',
                                loc: {
                                    start: {
                                        line: 6,
                                        column: 31,
                                        fixed: true,
                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                    },
                                    end: {
                                        line: 6,
                                        column: 44,
                                        fixed: true,
                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                    }
                                }
                            },
                            consequent: {
                                type: 'UnaryExpression',
                                operator: '!',
                                argument: {
                                    type: 'UnaryExpression',
                                    operator: '?',
                                    argument: {
                                        type: 'Identifier',
                                        name: 'subscription',
                                        loc: {
                                            start: {
                                                line: 6,
                                                column: 51,
                                                fixed: true,
                                                source: 'viewpath/html/SubscriptionNotice.ion'
                                            },
                                            end: {
                                                line: 6,
                                                column: 63,
                                                fixed: true,
                                                source: 'viewpath/html/SubscriptionNotice.ion'
                                            }
                                        }
                                    }
                                }
                            },
                            alternate: {
                                type: 'BinaryExpression',
                                operator: '===',
                                left: {
                                    type: 'Identifier',
                                    name: 'subscription',
                                    loc: {
                                        start: {
                                            line: 6,
                                            column: 67,
                                            fixed: true,
                                            source: 'viewpath/html/SubscriptionNotice.ion'
                                        },
                                        end: {
                                            line: 6,
                                            column: 79,
                                            fixed: true,
                                            source: 'viewpath/html/SubscriptionNotice.ion'
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: null
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'IfStatement',
                test: {
                    type: 'BinaryExpression',
                    operator: '&&',
                    left: {
                        type: 'Identifier',
                        name: 'missingSubscription',
                        loc: {
                            start: {
                                line: 8,
                                column: 7,
                                fixed: true,
                                source: 'viewpath/html/SubscriptionNotice.ion'
                            },
                            end: {
                                line: 8,
                                column: 26,
                                fixed: true,
                                source: 'viewpath/html/SubscriptionNotice.ion'
                            }
                        }
                    },
                    right: {
                        type: 'UnaryExpression',
                        operator: '!',
                        argument: {
                            type: 'MemberExpression',
                            computed: false,
                            object: {
                                type: 'Identifier',
                                name: 'user',
                                loc: {
                                    start: {
                                        line: 8,
                                        column: 35,
                                        fixed: true,
                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                    },
                                    end: {
                                        line: 8,
                                        column: 39,
                                        fixed: true,
                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'InTrial',
                                loc: {
                                    start: {
                                        line: 8,
                                        column: 40,
                                        fixed: true,
                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                    },
                                    end: {
                                        line: 8,
                                        column: 47,
                                        fixed: true,
                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 8,
                                    column: 35,
                                    fixed: true,
                                    source: 'viewpath/html/SubscriptionNotice.ion'
                                },
                                end: {
                                    line: 8,
                                    column: 47,
                                    fixed: true,
                                    source: 'viewpath/html/SubscriptionNotice.ion'
                                }
                            }
                        }
                    }
                },
                consequent: {
                    type: 'BlockStatement',
                    body: [{
                            type: 'ReturnStatement',
                            argument: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'Identifier',
                                        name: 'Div',
                                        loc: {
                                            start: {
                                                line: 9,
                                                column: 15,
                                                fixed: true,
                                                source: 'viewpath/html/SubscriptionNotice.ion'
                                            },
                                            end: {
                                                line: 9,
                                                column: 18,
                                                fixed: true,
                                                source: 'viewpath/html/SubscriptionNotice.ion'
                                            }
                                        }
                                    },
                                    arguments: [{
                                            type: 'ObjectExpression',
                                            properties: [{
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'class',
                                                        loc: {
                                                            start: {
                                                                line: 9,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/SubscriptionNotice.ion'
                                                            },
                                                            end: {
                                                                line: 9,
                                                                column: 25,
                                                                fixed: true,
                                                                source: 'viewpath/html/SubscriptionNotice.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 'padding'
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                }]
                                        }],
                                    loc: {
                                        start: {
                                            line: 9,
                                            column: 15,
                                            fixed: true,
                                            source: 'viewpath/html/SubscriptionNotice.ion'
                                        },
                                        end: {
                                            line: 9,
                                            column: 37,
                                            fixed: true,
                                            source: 'viewpath/html/SubscriptionNotice.ion'
                                        }
                                    }
                                },
                                properties: [{
                                        type: 'IfStatement',
                                        test: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'user',
                                                loc: {
                                                    start: {
                                                        line: 10,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                                    },
                                                    end: {
                                                        line: 10,
                                                        column: 19,
                                                        fixed: true,
                                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'ExceededTrial',
                                                loc: {
                                                    start: {
                                                        line: 10,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                                    },
                                                    end: {
                                                        line: 10,
                                                        column: 33,
                                                        fixed: true,
                                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 10,
                                                    column: 15,
                                                    fixed: true,
                                                    source: 'viewpath/html/SubscriptionNotice.ion'
                                                },
                                                end: {
                                                    line: 10,
                                                    column: 33,
                                                    fixed: true,
                                                    source: 'viewpath/html/SubscriptionNotice.ion'
                                                }
                                            }
                                        },
                                        consequent: {
                                            type: 'BlockStatement',
                                            body: [
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'Span',
                                                                loc: {
                                                                    start: {
                                                                        line: 11,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                                                    },
                                                                    end: {
                                                                        line: 11,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [],
                                                            loc: {
                                                                start: {
                                                                    line: 11,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/SubscriptionNotice.ion'
                                                                },
                                                                end: {
                                                                    line: 11,
                                                                    column: 22,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/SubscriptionNotice.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [{
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '+',
                                                                    left: {
                                                                        type: 'BinaryExpression',
                                                                        operator: '+',
                                                                        left: {
                                                                            type: 'Literal',
                                                                            value: 'Your free trial has ended. You need to have a paid license to '
                                                                        },
                                                                        right: {
                                                                            type: 'Identifier',
                                                                            name: 'action',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 12,
                                                                                    column: 85,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/SubscriptionNotice.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 12,
                                                                                    column: 91,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/SubscriptionNotice.ion'
                                                                                }
                                                                            }
                                                                        }
                                                                    },
                                                                    right: {
                                                                        type: 'Literal',
                                                                        value: '. Click '
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 12,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                                                    },
                                                                    end: {
                                                                        line: 12,
                                                                        column: 102,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 11,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/SubscriptionNotice.ion'
                                                        },
                                                        end: {
                                                            line: 13,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'viewpath/html/SubscriptionNotice.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                },
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'Span',
                                                                loc: {
                                                                    start: {
                                                                        line: 13,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                                                    },
                                                                    end: {
                                                                        line: 13,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [{
                                                                    type: 'ObjectExpression',
                                                                    properties: [{
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'class',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 13,
                                                                                        column: 22,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 13,
                                                                                        column: 27,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'link'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        }]
                                                                }],
                                                            loc: {
                                                                start: {
                                                                    line: 13,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/SubscriptionNotice.ion'
                                                                },
                                                                end: {
                                                                    line: 13,
                                                                    column: 37,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/SubscriptionNotice.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'Literal',
                                                                    value: 'here'
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 14,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                                                    },
                                                                    end: {
                                                                        line: 14,
                                                                        column: 26,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'Function',
                                                                    context: true,
                                                                    value: function (_context) {
                                                                        return function click() {
                                                                            var onclick = _context.get('onclick');
                                                                            global.model.open({ id: 'Subscriptions' });
                                                                            onclick != null ? onclick() : void 0;
                                                                        };
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 15,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                                                    },
                                                                    end: {
                                                                        line: 18,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                                                    }
                                                                },
                                                                order: '1'
                                                            }
                                                        ]
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 13,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/SubscriptionNotice.ion'
                                                        },
                                                        end: {
                                                            line: 18,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'viewpath/html/SubscriptionNotice.ion'
                                                        }
                                                    },
                                                    order: '1'
                                                },
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'Span',
                                                                loc: {
                                                                    start: {
                                                                        line: 18,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                                                    },
                                                                    end: {
                                                                        line: 18,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [],
                                                            loc: {
                                                                start: {
                                                                    line: 18,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/SubscriptionNotice.ion'
                                                                },
                                                                end: {
                                                                    line: 18,
                                                                    column: 22,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/SubscriptionNotice.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [{
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'Literal',
                                                                    value: ' to upgrade.'
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 19,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                                                    },
                                                                    end: {
                                                                        line: 19,
                                                                        column: 34,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 18,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/SubscriptionNotice.ion'
                                                        },
                                                        end: {
                                                            line: 20,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'viewpath/html/SubscriptionNotice.ion'
                                                        }
                                                    },
                                                    order: '2'
                                                }
                                            ]
                                        },
                                        alternate: {
                                            type: 'BlockStatement',
                                            body: [
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'Span',
                                                                loc: {
                                                                    start: {
                                                                        line: 21,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                                                    },
                                                                    end: {
                                                                        line: 21,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [],
                                                            loc: {
                                                                start: {
                                                                    line: 21,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/SubscriptionNotice.ion'
                                                                },
                                                                end: {
                                                                    line: 21,
                                                                    column: 22,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/SubscriptionNotice.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [{
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '+',
                                                                    left: {
                                                                        type: 'BinaryExpression',
                                                                        operator: '+',
                                                                        left: {
                                                                            type: 'Literal',
                                                                            value: 'You need to have a license to '
                                                                        },
                                                                        right: {
                                                                            type: 'Identifier',
                                                                            name: 'action',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 22,
                                                                                    column: 53,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/SubscriptionNotice.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 22,
                                                                                    column: 59,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/SubscriptionNotice.ion'
                                                                                }
                                                                            }
                                                                        }
                                                                    },
                                                                    right: {
                                                                        type: 'Literal',
                                                                        value: '. Click '
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 22,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                                                    },
                                                                    end: {
                                                                        line: 22,
                                                                        column: 70,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 21,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/SubscriptionNotice.ion'
                                                        },
                                                        end: {
                                                            line: 23,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'viewpath/html/SubscriptionNotice.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                },
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'Span',
                                                                loc: {
                                                                    start: {
                                                                        line: 23,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                                                    },
                                                                    end: {
                                                                        line: 23,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [{
                                                                    type: 'ObjectExpression',
                                                                    properties: [{
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'class',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 23,
                                                                                        column: 22,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 23,
                                                                                        column: 27,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'link'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        }]
                                                                }],
                                                            loc: {
                                                                start: {
                                                                    line: 23,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/SubscriptionNotice.ion'
                                                                },
                                                                end: {
                                                                    line: 23,
                                                                    column: 37,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/SubscriptionNotice.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'Literal',
                                                                    value: 'here'
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 24,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                                                    },
                                                                    end: {
                                                                        line: 24,
                                                                        column: 26,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'Function',
                                                                    context: false,
                                                                    value: function click() {
                                                                        model.startTrial();
                                                                        require('ion').sync();
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 25,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                                                    },
                                                                    end: {
                                                                        line: 28,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                                                    }
                                                                },
                                                                order: '1'
                                                            }
                                                        ]
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 23,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/SubscriptionNotice.ion'
                                                        },
                                                        end: {
                                                            line: 28,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'viewpath/html/SubscriptionNotice.ion'
                                                        }
                                                    },
                                                    order: '1'
                                                },
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'Span',
                                                                loc: {
                                                                    start: {
                                                                        line: 28,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                                                    },
                                                                    end: {
                                                                        line: 28,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [],
                                                            loc: {
                                                                start: {
                                                                    line: 28,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/SubscriptionNotice.ion'
                                                                },
                                                                end: {
                                                                    line: 28,
                                                                    column: 22,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/SubscriptionNotice.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [{
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'Literal',
                                                                    value: ' to start your 30 day free trial.'
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 29,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                                                    },
                                                                    end: {
                                                                        line: 29,
                                                                        column: 55,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/SubscriptionNotice.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 28,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/SubscriptionNotice.ion'
                                                        },
                                                        end: {
                                                            line: 30,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'viewpath/html/SubscriptionNotice.ion'
                                                        }
                                                    },
                                                    order: '2'
                                                }
                                            ]
                                        },
                                        order: '0'
                                    }]
                            },
                            order: '0'
                        }]
                },
                alternate: null,
                order: '3'
            }
        ],
        bound: false
    }, {
        this: this,
        require: require,
        action: action,
        mustBeDefined: mustBeDefined,
        onclick: onclick
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/SubscriptionNotice',_viewpath_html_SubscriptionNotice_);
    else
      _viewpath_html_SubscriptionNotice_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_SubscriptionNotice_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_TaskItem_ = function(module,exports,require){'use strict';
var ion = require('ion');
var glass = require('glass'), _ref, _ref2, _ref3;
_ref = glass.html;
var style = _ref.style;
_ref2 = glass.html.material;
var Checkbox = _ref2.Checkbox;
var List = _ref2.List;
var Icon = _ref2.Icon;
var Field = _ref2.Field;
var Img = _ref2.Img;
_ref3 = require('../model');
var Project = _ref3.Project;
var Task = _ref3.Task;
var _ref5 = style.sheets;
_ref5[module.id] = '.comment-notification, .comment-notification > .Icon {\n    color:#ccc;\n    position:relative;\n}\n.task-action {\n    flex-basis:48px;\n    flex-grow:0;\n    flex-shrink:0;\n    position:relative;\n}\n.comment-notification {\n    position:absolute;\n    top:0;\n    left:0;\n    right:0;\n    bottom:0;\n    display:flex;\n    align-items:center;\n    justify-content:center;\n}\n.new-comment > .Icon{\n    color:' + style.color.accent + ';\n}\n.new-comment .comment-label {\n    visibility:visible;\n}\n.comment-label {\n    visibility:hidden;\n    position: absolute;\n    left: 0;\n    right: 0;\n    top: 0;\n    bottom: 0;\n    text-align: center;\n    font-size: 11px;\n    line-height: 18px;\n    color: white;\n    font-weight:600;\n}\n.task.item .task-schedule {\n    font-size:13px;\n    color:#aaa;\n}';
_ref5;
module.exports = exports = ion.template(function (_ref4) {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'item',
                            loc: {
                                start: {
                                    line: 55,
                                    column: 18,
                                    fixed: true,
                                    source: 'viewpath/html/TaskItem.ion'
                                },
                                end: {
                                    line: 55,
                                    column: 22,
                                    fixed: true,
                                    source: 'viewpath/html/TaskItem.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref4'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'item',
                                loc: {
                                    start: {
                                        line: 55,
                                        column: 18,
                                        fixed: true,
                                        source: 'viewpath/html/TaskItem.ion'
                                    },
                                    end: {
                                        line: 55,
                                        column: 22,
                                        fixed: true,
                                        source: 'viewpath/html/TaskItem.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'config',
                            loc: {
                                start: {
                                    line: 55,
                                    column: 24,
                                    fixed: true,
                                    source: 'viewpath/html/TaskItem.ion'
                                },
                                end: {
                                    line: 55,
                                    column: 30,
                                    fixed: true,
                                    source: 'viewpath/html/TaskItem.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref4'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'config',
                                loc: {
                                    start: {
                                        line: 55,
                                        column: 24,
                                        fixed: true,
                                        source: 'viewpath/html/TaskItem.ion'
                                    },
                                    end: {
                                        line: 55,
                                        column: 30,
                                        fixed: true,
                                        source: 'viewpath/html/TaskItem.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'IfStatement',
                test: {
                    type: 'UnaryExpression',
                    operator: '?',
                    argument: {
                        type: 'Identifier',
                        name: 'item',
                        loc: {
                            start: {
                                line: 56,
                                column: 7,
                                fixed: true,
                                source: 'viewpath/html/TaskItem.ion'
                            },
                            end: {
                                line: 56,
                                column: 11,
                                fixed: true,
                                source: 'viewpath/html/TaskItem.ion'
                            }
                        }
                    }
                },
                consequent: {
                    type: 'BlockStatement',
                    body: [{
                            type: 'ReturnStatement',
                            argument: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'Identifier',
                                        name: 'Li',
                                        loc: {
                                            start: {
                                                line: 57,
                                                column: 15,
                                                fixed: true,
                                                source: 'viewpath/html/TaskItem.ion'
                                            },
                                            end: {
                                                line: 57,
                                                column: 17,
                                                fixed: true,
                                                source: 'viewpath/html/TaskItem.ion'
                                            }
                                        }
                                    },
                                    arguments: [{
                                            type: 'ObjectExpression',
                                            properties: [{
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'class',
                                                        loc: {
                                                            start: {
                                                                line: 57,
                                                                column: 19,
                                                                fixed: true,
                                                                source: 'viewpath/html/TaskItem.ion'
                                                            },
                                                            end: {
                                                                line: 57,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'viewpath/html/TaskItem.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 'item task layout horizontal stretch'
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                }]
                                        }],
                                    loc: {
                                        start: {
                                            line: 57,
                                            column: 15,
                                            fixed: true,
                                            source: 'viewpath/html/TaskItem.ion'
                                        },
                                        end: {
                                            line: 57,
                                            column: 64,
                                            fixed: true,
                                            source: 'viewpath/html/TaskItem.ion'
                                        }
                                    }
                                },
                                properties: [
                                    {
                                        type: 'VariableDeclaration',
                                        declarations: [{
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'parentKey',
                                                    loc: {
                                                        start: {
                                                            line: 58,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskItem.ion'
                                                        },
                                                        end: {
                                                            line: 58,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskItem.ion'
                                                        }
                                                    }
                                                },
                                                init: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'item',
                                                                loc: {
                                                                    start: {
                                                                        line: 58,
                                                                        column: 28,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                    },
                                                                    end: {
                                                                        line: 58,
                                                                        column: 32,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'getKey',
                                                                loc: {
                                                                    start: {
                                                                        line: 58,
                                                                        column: 33,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                    },
                                                                    end: {
                                                                        line: 58,
                                                                        column: 39,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 58,
                                                                    column: 28,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                },
                                                                end: {
                                                                    line: 58,
                                                                    column: 39,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [],
                                                        loc: {
                                                            start: {
                                                                line: 58,
                                                                column: 28,
                                                                fixed: true,
                                                                source: 'viewpath/html/TaskItem.ion'
                                                            },
                                                            end: {
                                                                line: 58,
                                                                column: 41,
                                                                fixed: true,
                                                                source: 'viewpath/html/TaskItem.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'parent',
                                                        loc: {
                                                            start: {
                                                                line: 58,
                                                                column: 42,
                                                                fixed: true,
                                                                source: 'viewpath/html/TaskItem.ion'
                                                            },
                                                            end: {
                                                                line: 58,
                                                                column: 48,
                                                                fixed: true,
                                                                source: 'viewpath/html/TaskItem.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 58,
                                                            column: 28,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskItem.ion'
                                                        },
                                                        end: {
                                                            line: 58,
                                                            column: 48,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskItem.ion'
                                                        }
                                                    }
                                                }
                                            }],
                                        kind: 'let',
                                        order: '0'
                                    },
                                    {
                                        type: 'VariableDeclaration',
                                        declarations: [{
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'project',
                                                    loc: {
                                                        start: {
                                                            line: 59,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskItem.ion'
                                                        },
                                                        end: {
                                                            line: 59,
                                                            column: 23,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskItem.ion'
                                                        }
                                                    }
                                                },
                                                init: {
                                                    type: 'MemberExpression',
                                                    computed: true,
                                                    object: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'model',
                                                            loc: {
                                                                start: {
                                                                    line: 59,
                                                                    column: 26,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                },
                                                                end: {
                                                                    line: 59,
                                                                    column: 31,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'server',
                                                            loc: {
                                                                start: {
                                                                    line: 59,
                                                                    column: 32,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                },
                                                                end: {
                                                                    line: 59,
                                                                    column: 38,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 59,
                                                                column: 26,
                                                                fixed: true,
                                                                source: 'viewpath/html/TaskItem.ion'
                                                            },
                                                            end: {
                                                                line: 59,
                                                                column: 38,
                                                                fixed: true,
                                                                source: 'viewpath/html/TaskItem.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'parentKey',
                                                        loc: {
                                                            start: {
                                                                line: 59,
                                                                column: 39,
                                                                fixed: true,
                                                                source: 'viewpath/html/TaskItem.ion'
                                                            },
                                                            end: {
                                                                line: 59,
                                                                column: 48,
                                                                fixed: true,
                                                                source: 'viewpath/html/TaskItem.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 59,
                                                            column: 26,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskItem.ion'
                                                        },
                                                        end: {
                                                            line: 59,
                                                            column: 49,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskItem.ion'
                                                        }
                                                    }
                                                }
                                            }],
                                        kind: 'let',
                                        order: '1'
                                    },
                                    {
                                        type: 'VariableDeclaration',
                                        declarations: [{
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'lastReadComment',
                                                    loc: {
                                                        start: {
                                                            line: 60,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskItem.ion'
                                                        },
                                                        end: {
                                                            line: 60,
                                                            column: 31,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskItem.ion'
                                                        }
                                                    }
                                                },
                                                init: {
                                                    type: 'ConditionalExpression',
                                                    test: {
                                                        type: 'BinaryExpression',
                                                        operator: '!=',
                                                        left: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'MemberExpression',
                                                                computed: true,
                                                                object: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'item',
                                                                        loc: {
                                                                            start: {
                                                                                line: 60,
                                                                                column: 34,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                            },
                                                                            end: {
                                                                                line: 60,
                                                                                column: 38,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'subscribed',
                                                                        loc: {
                                                                            start: {
                                                                                line: 60,
                                                                                column: 39,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                            },
                                                                            end: {
                                                                                line: 60,
                                                                                column: 49,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 60,
                                                                            column: 34,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                        },
                                                                        end: {
                                                                            line: 60,
                                                                            column: 49,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'model',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 60,
                                                                                    column: 51,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 60,
                                                                                    column: 56,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'user',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 60,
                                                                                    column: 57,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 60,
                                                                                    column: 61,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 60,
                                                                                column: 51,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                            },
                                                                            end: {
                                                                                line: 60,
                                                                                column: 61,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'key',
                                                                        loc: {
                                                                            start: {
                                                                                line: 60,
                                                                                column: 62,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                            },
                                                                            end: {
                                                                                line: 60,
                                                                                column: 65,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 60,
                                                                            column: 51,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                        },
                                                                        end: {
                                                                            line: 60,
                                                                            column: 65,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                        }
                                                                    }
                                                                },
                                                                existential: true,
                                                                loc: {
                                                                    start: {
                                                                        line: 60,
                                                                        column: 34,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                    },
                                                                    end: {
                                                                        line: 60,
                                                                        column: 66,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'readCommentId',
                                                                loc: {
                                                                    start: {
                                                                        line: 60,
                                                                        column: 68,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                    },
                                                                    end: {
                                                                        line: 60,
                                                                        column: 81,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                    }
                                                                }
                                                            },
                                                            existential: true,
                                                            loc: {
                                                                start: {
                                                                    line: 60,
                                                                    column: 34,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                },
                                                                end: {
                                                                    line: 60,
                                                                    column: 81,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                }
                                                            }
                                                        },
                                                        right: {
                                                            type: 'Literal',
                                                            value: null
                                                        }
                                                    },
                                                    consequent: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'MemberExpression',
                                                            computed: true,
                                                            object: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'item',
                                                                    loc: {
                                                                        start: {
                                                                            line: 60,
                                                                            column: 34,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                        },
                                                                        end: {
                                                                            line: 60,
                                                                            column: 38,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'subscribed',
                                                                    loc: {
                                                                        start: {
                                                                            line: 60,
                                                                            column: 39,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                        },
                                                                        end: {
                                                                            line: 60,
                                                                            column: 49,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 60,
                                                                        column: 34,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                    },
                                                                    end: {
                                                                        line: 60,
                                                                        column: 49,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'model',
                                                                        loc: {
                                                                            start: {
                                                                                line: 60,
                                                                                column: 51,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                            },
                                                                            end: {
                                                                                line: 60,
                                                                                column: 56,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'user',
                                                                        loc: {
                                                                            start: {
                                                                                line: 60,
                                                                                column: 57,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                            },
                                                                            end: {
                                                                                line: 60,
                                                                                column: 61,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 60,
                                                                            column: 51,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                        },
                                                                        end: {
                                                                            line: 60,
                                                                            column: 61,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'key',
                                                                    loc: {
                                                                        start: {
                                                                            line: 60,
                                                                            column: 62,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                        },
                                                                        end: {
                                                                            line: 60,
                                                                            column: 65,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 60,
                                                                        column: 51,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                    },
                                                                    end: {
                                                                        line: 60,
                                                                        column: 65,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                    }
                                                                }
                                                            },
                                                            existential: true,
                                                            loc: {
                                                                start: {
                                                                    line: 60,
                                                                    column: 34,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                },
                                                                end: {
                                                                    line: 60,
                                                                    column: 66,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'readCommentId',
                                                            loc: {
                                                                start: {
                                                                    line: 60,
                                                                    column: 68,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                },
                                                                end: {
                                                                    line: 60,
                                                                    column: 81,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                }
                                                            }
                                                        },
                                                        existential: true,
                                                        loc: {
                                                            start: {
                                                                line: 60,
                                                                column: 34,
                                                                fixed: true,
                                                                source: 'viewpath/html/TaskItem.ion'
                                                            },
                                                            end: {
                                                                line: 60,
                                                                column: 81,
                                                                fixed: true,
                                                                source: 'viewpath/html/TaskItem.ion'
                                                            }
                                                        }
                                                    },
                                                    alternate: {
                                                        type: 'UnaryExpression',
                                                        operator: '-',
                                                        argument: {
                                                            type: 'Literal',
                                                            value: 1
                                                        }
                                                    }
                                                }
                                            }],
                                        kind: 'let',
                                        order: '2'
                                    },
                                    {
                                        type: 'VariableDeclaration',
                                        declarations: [{
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'commentCount',
                                                    loc: {
                                                        start: {
                                                            line: 61,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskItem.ion'
                                                        },
                                                        end: {
                                                            line: 61,
                                                            column: 28,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskItem.ion'
                                                        }
                                                    }
                                                },
                                                init: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'item',
                                                        loc: {
                                                            start: {
                                                                line: 61,
                                                                column: 31,
                                                                fixed: true,
                                                                source: 'viewpath/html/TaskItem.ion'
                                                            },
                                                            end: {
                                                                line: 61,
                                                                column: 35,
                                                                fixed: true,
                                                                source: 'viewpath/html/TaskItem.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'idCountComment',
                                                        loc: {
                                                            start: {
                                                                line: 61,
                                                                column: 36,
                                                                fixed: true,
                                                                source: 'viewpath/html/TaskItem.ion'
                                                            },
                                                            end: {
                                                                line: 61,
                                                                column: 50,
                                                                fixed: true,
                                                                source: 'viewpath/html/TaskItem.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 61,
                                                            column: 31,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskItem.ion'
                                                        },
                                                        end: {
                                                            line: 61,
                                                            column: 50,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskItem.ion'
                                                        }
                                                    }
                                                }
                                            }],
                                        kind: 'let',
                                        order: '3'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'Function',
                                            context: true,
                                            value: function (_context) {
                                                return function click(e) {
                                                    var item = _context.get('item');
                                                    model.open(item.paneConfig, {
                                                        target: 'dialog',
                                                        replace: true
                                                    });
                                                };
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 63,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/TaskItem.ion'
                                            },
                                            end: {
                                                line: 68,
                                                column: 16,
                                                fixed: true,
                                                source: 'viewpath/html/TaskItem.ion'
                                            }
                                        },
                                        order: '4'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'ObjectExpression',
                                            objectType: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'Div',
                                                    loc: {
                                                        start: {
                                                            line: 77,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskItem.ion'
                                                        },
                                                        end: {
                                                            line: 77,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskItem.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [{
                                                        type: 'ObjectExpression',
                                                        properties: [{
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'class',
                                                                    loc: {
                                                                        start: {
                                                                            line: 77,
                                                                            column: 17,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                        },
                                                                        end: {
                                                                            line: 77,
                                                                            column: 22,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: 'task-details flex'
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            }]
                                                    }],
                                                loc: {
                                                    start: {
                                                        line: 77,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/TaskItem.ion'
                                                    },
                                                    end: {
                                                        line: 77,
                                                        column: 44,
                                                        fixed: true,
                                                        source: 'viewpath/html/TaskItem.ion'
                                                    }
                                                }
                                            },
                                            properties: [
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'H2',
                                                                loc: {
                                                                    start: {
                                                                        line: 78,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                    },
                                                                    end: {
                                                                        line: 78,
                                                                        column: 18,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [{
                                                                    type: 'ObjectExpression',
                                                                    properties: [{
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'class',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 78,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 78,
                                                                                        column: 25,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'task-name heading'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        }]
                                                                }],
                                                            loc: {
                                                                start: {
                                                                    line: 78,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                },
                                                                end: {
                                                                    line: 78,
                                                                    column: 47,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [{
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'item',
                                                                        loc: {
                                                                            start: {
                                                                                line: 79,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                            },
                                                                            end: {
                                                                                line: 79,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'name',
                                                                        loc: {
                                                                            start: {
                                                                                line: 79,
                                                                                column: 25,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                            },
                                                                            end: {
                                                                                line: 79,
                                                                                column: 29,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 79,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                        },
                                                                        end: {
                                                                            line: 79,
                                                                            column: 29,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 79,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                    },
                                                                    end: {
                                                                        line: 79,
                                                                        column: 29,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 78,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskItem.ion'
                                                        },
                                                        end: {
                                                            line: 80,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskItem.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                },
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'Div',
                                                                loc: {
                                                                    start: {
                                                                        line: 80,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                    },
                                                                    end: {
                                                                        line: 80,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [{
                                                                    type: 'ObjectExpression',
                                                                    properties: [{
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'class',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 80,
                                                                                        column: 21,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 80,
                                                                                        column: 26,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'project-name subheading black secondary'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        }]
                                                                }],
                                                            loc: {
                                                                start: {
                                                                    line: 80,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                },
                                                                end: {
                                                                    line: 80,
                                                                    column: 70,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [{
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'project',
                                                                        loc: {
                                                                            start: {
                                                                                line: 81,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                            },
                                                                            end: {
                                                                                line: 81,
                                                                                column: 27,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'name',
                                                                        loc: {
                                                                            start: {
                                                                                line: 81,
                                                                                column: 28,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                            },
                                                                            end: {
                                                                                line: 81,
                                                                                column: 32,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 81,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                        },
                                                                        end: {
                                                                            line: 81,
                                                                            column: 32,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 81,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                    },
                                                                    end: {
                                                                        line: 81,
                                                                        column: 32,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 80,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskItem.ion'
                                                        },
                                                        end: {
                                                            line: 82,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskItem.ion'
                                                        }
                                                    },
                                                    order: '1'
                                                }
                                            ]
                                        },
                                        loc: {
                                            start: {
                                                line: 77,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/TaskItem.ion'
                                            },
                                            end: {
                                                line: 82,
                                                column: 16,
                                                fixed: true,
                                                source: 'viewpath/html/TaskItem.ion'
                                            }
                                        },
                                        order: '5'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'ObjectExpression',
                                            objectType: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'Div',
                                                    loc: {
                                                        start: {
                                                            line: 82,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskItem.ion'
                                                        },
                                                        end: {
                                                            line: 82,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskItem.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [{
                                                        type: 'ObjectExpression',
                                                        properties: [{
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'class',
                                                                    loc: {
                                                                        start: {
                                                                            line: 82,
                                                                            column: 17,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                        },
                                                                        end: {
                                                                            line: 82,
                                                                            column: 22,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: 'task-schedule layout center'
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            }]
                                                    }],
                                                loc: {
                                                    start: {
                                                        line: 82,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/TaskItem.ion'
                                                    },
                                                    end: {
                                                        line: 82,
                                                        column: 54,
                                                        fixed: true,
                                                        source: 'viewpath/html/TaskItem.ion'
                                                    }
                                                }
                                            },
                                            properties: [{
                                                    type: 'IfStatement',
                                                    test: {
                                                        type: 'UnaryExpression',
                                                        operator: '?',
                                                        argument: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'item',
                                                                loc: {
                                                                    start: {
                                                                        line: 83,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                    },
                                                                    end: {
                                                                        line: 83,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'start',
                                                                loc: {
                                                                    start: {
                                                                        line: 83,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                    },
                                                                    end: {
                                                                        line: 83,
                                                                        column: 29,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 83,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                },
                                                                end: {
                                                                    line: 83,
                                                                    column: 29,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                }
                                                            }
                                                        }
                                                    },
                                                    consequent: {
                                                        type: 'BlockStatement',
                                                        body: [{
                                                                type: 'IfStatement',
                                                                test: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'CallExpression',
                                                                            callee: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'Identifier',
                                                                                    name: 'Date',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 85,
                                                                                            column: 23,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 85,
                                                                                            column: 27,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'create',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 85,
                                                                                            column: 28,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 85,
                                                                                            column: 34,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 85,
                                                                                        column: 23,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 85,
                                                                                        column: 34,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            arguments: [{
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'item',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 85,
                                                                                                column: 35,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 85,
                                                                                                column: 39,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'start',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 85,
                                                                                                column: 40,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 85,
                                                                                                column: 45,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 85,
                                                                                            column: 35,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 85,
                                                                                            column: 45,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                                        }
                                                                                    }
                                                                                }],
                                                                            loc: {
                                                                                start: {
                                                                                    line: 85,
                                                                                    column: 23,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 85,
                                                                                    column: 46,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'is',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 85,
                                                                                    column: 47,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 85,
                                                                                    column: 49,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 85,
                                                                                column: 23,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                            },
                                                                            end: {
                                                                                line: 85,
                                                                                column: 49,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [{
                                                                            type: 'Literal',
                                                                            value: 'today'
                                                                        }],
                                                                    loc: {
                                                                        start: {
                                                                            line: 85,
                                                                            column: 23,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                        },
                                                                        end: {
                                                                            line: 85,
                                                                            column: 58,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                        }
                                                                    }
                                                                },
                                                                consequent: {
                                                                    type: 'BlockStatement',
                                                                    body: [
                                                                        {
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'Literal',
                                                                                value: 'Today'
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 86,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 86,
                                                                                    column: 31,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'IfStatement',
                                                                            test: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'item',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 87,
                                                                                                column: 27,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 87,
                                                                                                column: 31,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'Start',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 87,
                                                                                                column: 32,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 87,
                                                                                                column: 37,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 87,
                                                                                            column: 27,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 87,
                                                                                            column: 37,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'time',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 87,
                                                                                            column: 38,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 87,
                                                                                            column: 42,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 87,
                                                                                        column: 27,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 87,
                                                                                        column: 42,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            consequent: {
                                                                                type: 'BlockStatement',
                                                                                body: [{
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'CallExpression',
                                                                                            callee: {
                                                                                                type: 'MemberExpression',
                                                                                                computed: false,
                                                                                                object: {
                                                                                                    type: 'MemberExpression',
                                                                                                    computed: false,
                                                                                                    object: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'item',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 88,
                                                                                                                column: 28,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 88,
                                                                                                                column: 32,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    property: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'Start',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 88,
                                                                                                                column: 33,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 88,
                                                                                                                column: 38,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 88,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 88,
                                                                                                            column: 38,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'format',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 88,
                                                                                                            column: 39,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 88,
                                                                                                            column: 45,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 88,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 88,
                                                                                                        column: 45,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            arguments: [{
                                                                                                    type: 'Literal',
                                                                                                    value: ', {{tt}}'
                                                                                                }],
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 88,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 88,
                                                                                                    column: 57,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 88,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 88,
                                                                                                column: 57,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            alternate: null,
                                                                            order: '1'
                                                                        }
                                                                    ]
                                                                },
                                                                alternate: {
                                                                    type: 'IfStatement',
                                                                    test: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'CallExpression',
                                                                                callee: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'Date',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 89,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 89,
                                                                                                column: 32,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'create',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 89,
                                                                                                column: 33,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 89,
                                                                                                column: 39,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 89,
                                                                                            column: 28,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 89,
                                                                                            column: 39,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                arguments: [{
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'item',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 89,
                                                                                                    column: 40,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 89,
                                                                                                    column: 44,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'start',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 89,
                                                                                                    column: 45,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 89,
                                                                                                    column: 50,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 89,
                                                                                                column: 40,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 89,
                                                                                                column: 50,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                                            }
                                                                                        }
                                                                                    }],
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 89,
                                                                                        column: 28,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 89,
                                                                                        column: 51,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'is',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 89,
                                                                                        column: 52,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 89,
                                                                                        column: 54,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 89,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 89,
                                                                                    column: 54,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [{
                                                                                type: 'Literal',
                                                                                value: 'tomorrow'
                                                                            }],
                                                                        loc: {
                                                                            start: {
                                                                                line: 89,
                                                                                column: 28,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                            },
                                                                            end: {
                                                                                line: 89,
                                                                                column: 66,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    consequent: {
                                                                        type: 'BlockStatement',
                                                                        body: [
                                                                            {
                                                                                type: 'ExpressionStatement',
                                                                                expression: {
                                                                                    type: 'Literal',
                                                                                    value: 'Tomorrow'
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 90,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 90,
                                                                                        column: 34,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                                    }
                                                                                },
                                                                                order: '0'
                                                                            },
                                                                            {
                                                                                type: 'IfStatement',
                                                                                test: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'item',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 91,
                                                                                                    column: 27,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 91,
                                                                                                    column: 31,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'Start',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 91,
                                                                                                    column: 32,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 91,
                                                                                                    column: 37,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 91,
                                                                                                column: 27,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 91,
                                                                                                column: 37,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'time',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 91,
                                                                                                column: 38,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 91,
                                                                                                column: 42,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 91,
                                                                                            column: 27,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 91,
                                                                                            column: 42,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                consequent: {
                                                                                    type: 'BlockStatement',
                                                                                    body: [{
                                                                                            type: 'ExpressionStatement',
                                                                                            expression: {
                                                                                                type: 'CallExpression',
                                                                                                callee: {
                                                                                                    type: 'MemberExpression',
                                                                                                    computed: false,
                                                                                                    object: {
                                                                                                        type: 'MemberExpression',
                                                                                                        computed: false,
                                                                                                        object: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'item',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 92,
                                                                                                                    column: 28,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 92,
                                                                                                                    column: 32,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        property: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'Start',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 92,
                                                                                                                    column: 33,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 92,
                                                                                                                    column: 38,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 92,
                                                                                                                column: 28,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 92,
                                                                                                                column: 38,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    property: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'format',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 92,
                                                                                                                column: 39,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 92,
                                                                                                                column: 45,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 92,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 92,
                                                                                                            column: 45,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                arguments: [{
                                                                                                        type: 'Literal',
                                                                                                        value: ', {{tt}}'
                                                                                                    }],
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 92,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 92,
                                                                                                        column: 57,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 92,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 92,
                                                                                                    column: 57,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                                                }
                                                                                            },
                                                                                            order: '0'
                                                                                        }]
                                                                                },
                                                                                alternate: null,
                                                                                order: '1'
                                                                            }
                                                                        ]
                                                                    },
                                                                    alternate: {
                                                                        type: 'BlockStatement',
                                                                        body: [{
                                                                                type: 'ExpressionStatement',
                                                                                expression: {
                                                                                    type: 'CallExpression',
                                                                                    callee: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'MemberExpression',
                                                                                            computed: false,
                                                                                            object: {
                                                                                                type: 'Identifier',
                                                                                                name: 'item',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 95,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 95,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            property: {
                                                                                                type: 'Identifier',
                                                                                                name: 'Start',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 95,
                                                                                                        column: 29,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 95,
                                                                                                        column: 34,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 95,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 95,
                                                                                                    column: 34,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'format',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 95,
                                                                                                    column: 35,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 95,
                                                                                                    column: 41,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 95,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 95,
                                                                                                column: 41,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    arguments: [{
                                                                                            type: 'Literal',
                                                                                            value: 'short'
                                                                                        }],
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 95,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 95,
                                                                                            column: 50,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 95,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 95,
                                                                                        column: 50,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                                    }
                                                                                },
                                                                                order: '0'
                                                                            }]
                                                                    }
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    alternate: null,
                                                    order: '0'
                                                }]
                                        },
                                        loc: {
                                            start: {
                                                line: 82,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/TaskItem.ion'
                                            },
                                            end: {
                                                line: 99,
                                                column: 16,
                                                fixed: true,
                                                source: 'viewpath/html/TaskItem.ion'
                                            }
                                        },
                                        order: '6'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'ObjectExpression',
                                            objectType: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'Div',
                                                    loc: {
                                                        start: {
                                                            line: 99,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskItem.ion'
                                                        },
                                                        end: {
                                                            line: 99,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskItem.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [{
                                                        type: 'ObjectExpression',
                                                        properties: [{
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'class',
                                                                    loc: {
                                                                        start: {
                                                                            line: 99,
                                                                            column: 17,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                        },
                                                                        end: {
                                                                            line: 99,
                                                                            column: 22,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: 'task-action'
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            }]
                                                    }],
                                                loc: {
                                                    start: {
                                                        line: 99,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/TaskItem.ion'
                                                    },
                                                    end: {
                                                        line: 99,
                                                        column: 38,
                                                        fixed: true,
                                                        source: 'viewpath/html/TaskItem.ion'
                                                    }
                                                }
                                            },
                                            properties: [{
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'Div',
                                                                loc: {
                                                                    start: {
                                                                        line: 100,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                    },
                                                                    end: {
                                                                        line: 100,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [{
                                                                    type: 'ObjectExpression',
                                                                    properties: [{
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'class',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 100,
                                                                                        column: 21,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 100,
                                                                                        column: 26,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'comment-notification'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        }]
                                                                }],
                                                            loc: {
                                                                start: {
                                                                    line: 100,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                },
                                                                end: {
                                                                    line: 100,
                                                                    column: 51,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'classList',
                                                                    loc: {
                                                                        start: {
                                                                            line: 101,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                        },
                                                                        end: {
                                                                            line: 101,
                                                                            column: 29,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'ObjectExpression',
                                                                    properties: [{
                                                                            type: 'IfStatement',
                                                                            test: {
                                                                                type: 'BinaryExpression',
                                                                                operator: '&&',
                                                                                left: {
                                                                                    type: 'BinaryExpression',
                                                                                    operator: '>',
                                                                                    left: {
                                                                                        type: 'Identifier',
                                                                                        name: 'commentCount',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 102,
                                                                                                column: 27,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 102,
                                                                                                column: 39,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    right: {
                                                                                        type: 'Identifier',
                                                                                        name: 'lastReadComment',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 102,
                                                                                                column: 42,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 102,
                                                                                                column: 57,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                },
                                                                                right: {
                                                                                    type: 'BinaryExpression',
                                                                                    operator: '>',
                                                                                    left: {
                                                                                        type: 'Identifier',
                                                                                        name: 'commentCount',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 102,
                                                                                                column: 62,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 102,
                                                                                                column: 74,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    right: {
                                                                                        type: 'Literal',
                                                                                        value: 0
                                                                                    }
                                                                                }
                                                                            },
                                                                            consequent: {
                                                                                type: 'BlockStatement',
                                                                                body: [{
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'Literal',
                                                                                            value: 'new-comment'
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 103,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 103,
                                                                                                column: 41,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            alternate: null,
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'ObjectExpression',
                                                                    objectType: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'Identifier',
                                                                            name: 'Icon',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 104,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 104,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [{
                                                                                type: 'ObjectExpression',
                                                                                properties: [
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'name',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 104,
                                                                                                    column: 26,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 104,
                                                                                                    column: 30,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 'mode comment'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'size',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 104,
                                                                                                    column: 47,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 104,
                                                                                                    column: 51,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 20
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '1'
                                                                                    }
                                                                                ]
                                                                            }],
                                                                        loc: {
                                                                            start: {
                                                                                line: 104,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                            },
                                                                            end: {
                                                                                line: 104,
                                                                                column: 56,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    properties: [{
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'ObjectExpression',
                                                                                objectType: {
                                                                                    type: 'CallExpression',
                                                                                    callee: {
                                                                                        type: 'Identifier',
                                                                                        name: 'Span',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 105,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 105,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    arguments: [{
                                                                                            type: 'ObjectExpression',
                                                                                            properties: [{
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'class',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 105,
                                                                                                                column: 30,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 105,
                                                                                                                column: 35,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'Literal',
                                                                                                        value: 'comment-label'
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '0'
                                                                                                }]
                                                                                        }],
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 105,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 105,
                                                                                            column: 53,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/TaskItem.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                properties: [{
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'BinaryExpression',
                                                                                            operator: '-',
                                                                                            left: {
                                                                                                type: 'Identifier',
                                                                                                name: 'commentCount',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 106,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 106,
                                                                                                        column: 40,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            right: {
                                                                                                type: 'Identifier',
                                                                                                name: 'lastReadComment',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 106,
                                                                                                        column: 43,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 106,
                                                                                                        column: 58,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 106,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 106,
                                                                                                column: 58,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/TaskItem.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 105,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 107,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/TaskItem.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 104,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                    },
                                                                    end: {
                                                                        line: 107,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                    }
                                                                },
                                                                order: '1'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'Function',
                                                                    context: true,
                                                                    value: function (_context2) {
                                                                        return function click(e) {
                                                                            var item = _context2.get('item');
                                                                            e.stopPropagation();
                                                                            var discussionPaneConfig = item.paneConfig;
                                                                            discussionPaneConfig.tab = 'discussion';
                                                                            model.open(discussionPaneConfig, {
                                                                                target: 'dialog',
                                                                                replace: true
                                                                            });
                                                                        };
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 107,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                    },
                                                                    end: {
                                                                        line: 113,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskItem.ion'
                                                                    }
                                                                },
                                                                order: '2'
                                                            }
                                                        ]
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 100,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskItem.ion'
                                                        },
                                                        end: {
                                                            line: 113,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskItem.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        loc: {
                                            start: {
                                                line: 99,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/TaskItem.ion'
                                            },
                                            end: {
                                                line: 113,
                                                column: 16,
                                                fixed: true,
                                                source: 'viewpath/html/TaskItem.ion'
                                            }
                                        },
                                        order: '7'
                                    }
                                ]
                            },
                            order: '0'
                        }]
                },
                alternate: null,
                order: '2'
            }
        ],
        bound: false
    }, {
        this: this,
        _ref4: _ref4,
        glass: glass,
        _ref: _ref,
        _ref2: _ref2,
        _ref3: _ref3,
        style: style,
        Checkbox: Checkbox,
        List: List,
        Icon: Icon,
        Field: Field,
        Img: Img,
        Project: Project,
        Task: Task,
        _ref5: _ref5
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/TaskItem',_viewpath_html_TaskItem_);
    else
      _viewpath_html_TaskItem_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_TaskItem_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_TaskScheduleInput_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('../model');
var TimeUnit = _ref.TimeUnit;
module.exports = exports = ion.template(function TaskScheduleInput(attributes) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'TaskScheduleInput',
            loc: {
                start: {
                    line: 5,
                    column: 16,
                    fixed: true,
                    source: 'viewpath/html/TaskScheduleInput.ion'
                },
                end: {
                    line: 5,
                    column: 33,
                    fixed: true,
                    source: 'viewpath/html/TaskScheduleInput.ion'
                }
            }
        },
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'setOptionFromChar',
                            loc: {
                                start: {
                                    line: 6,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/TaskScheduleInput.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 25,
                                    fixed: true,
                                    source: 'viewpath/html/TaskScheduleInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'Function',
                            context: false,
                            value: function (select, key) {
                                var _ref2 = select;
                                var options = _ref2.options;
                                var selectedIndex = _ref2.selectedIndex;
                                var startIndex = select.selectedIndex + 1;
                                for (var i = 1; i <= options.length; i++) {
                                    var checkIndex = (selectedIndex + i) % options.length;
                                    var option = options[checkIndex];
                                    if (option.name.toLowerCase().startsWith(key.toLowerCase())) {
                                        option.selected = true;
                                        return;
                                    }
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'dateInput',
                            loc: {
                                start: {
                                    line: 17,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/TaskScheduleInput.ion'
                                },
                                end: {
                                    line: 17,
                                    column: 17,
                                    fixed: true,
                                    source: 'viewpath/html/TaskScheduleInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'PaperInput',
                                    loc: {
                                        start: {
                                            line: 17,
                                            column: 20,
                                            fixed: true,
                                            source: 'viewpath/html/TaskScheduleInput.ion'
                                        },
                                        end: {
                                            line: 17,
                                            column: 30,
                                            fixed: true,
                                            source: 'viewpath/html/TaskScheduleInput.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'type',
                                                    loc: {
                                                        start: {
                                                            line: 17,
                                                            column: 32,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskScheduleInput.ion'
                                                        },
                                                        end: {
                                                            line: 17,
                                                            column: 36,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskScheduleInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: 'number'
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    }],
                                loc: {
                                    start: {
                                        line: 17,
                                        column: 20,
                                        fixed: true,
                                        source: 'viewpath/html/TaskScheduleInput.ion'
                                    },
                                    end: {
                                        line: 17,
                                        column: 47,
                                        fixed: true,
                                        source: 'viewpath/html/TaskScheduleInput.ion'
                                    }
                                }
                            },
                            properties: [{
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'alwaysFloatLabel',
                                        loc: {
                                            start: {
                                                line: 18,
                                                column: 8,
                                                fixed: true,
                                                source: 'viewpath/html/TaskScheduleInput.ion'
                                            },
                                            end: {
                                                line: 18,
                                                column: 24,
                                                fixed: true,
                                                source: 'viewpath/html/TaskScheduleInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: true
                                    },
                                    kind: 'init',
                                    order: '0'
                                }]
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'constraintInput',
                            loc: {
                                start: {
                                    line: 19,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/TaskScheduleInput.ion'
                                },
                                end: {
                                    line: 19,
                                    column: 23,
                                    fixed: true,
                                    source: 'viewpath/html/TaskScheduleInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Select',
                                    loc: {
                                        start: {
                                            line: 19,
                                            column: 26,
                                            fixed: true,
                                            source: 'viewpath/html/TaskScheduleInput.ion'
                                        },
                                        end: {
                                            line: 19,
                                            column: 32,
                                            fixed: true,
                                            source: 'viewpath/html/TaskScheduleInput.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'prefix',
                                                    loc: {
                                                        start: {
                                                            line: 19,
                                                            column: 34,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskScheduleInput.ion'
                                                        },
                                                        end: {
                                                            line: 19,
                                                            column: 40,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskScheduleInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: true
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    }],
                                loc: {
                                    start: {
                                        line: 19,
                                        column: 26,
                                        fixed: true,
                                        source: 'viewpath/html/TaskScheduleInput.ion'
                                    },
                                    end: {
                                        line: 19,
                                        column: 47,
                                        fixed: true,
                                        source: 'viewpath/html/TaskScheduleInput.ion'
                                    }
                                }
                            },
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'style',
                                        loc: {
                                            start: {
                                                line: 20,
                                                column: 8,
                                                fixed: true,
                                                source: 'viewpath/html/TaskScheduleInput.ion'
                                            },
                                            end: {
                                                line: 20,
                                                column: 13,
                                                fixed: true,
                                                source: 'viewpath/html/TaskScheduleInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'border',
                                                    loc: {
                                                        start: {
                                                            line: 21,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskScheduleInput.ion'
                                                        },
                                                        end: {
                                                            line: 21,
                                                            column: 18,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskScheduleInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: 'none'
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'background',
                                                    loc: {
                                                        start: {
                                                            line: 22,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskScheduleInput.ion'
                                                        },
                                                        end: {
                                                            line: 22,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskScheduleInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: 'none'
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    order: '0'
                                },
                                {
                                    type: 'ForOfStatement',
                                    left: {
                                        type: 'VariableDeclaration',
                                        declarations: [{
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'item',
                                                    loc: {
                                                        start: {
                                                            line: 23,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskScheduleInput.ion'
                                                        },
                                                        end: {
                                                            line: 23,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskScheduleInput.ion'
                                                        }
                                                    }
                                                },
                                                init: null
                                            }],
                                        kind: 'let'
                                    },
                                    right: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'TimeUnit',
                                            loc: {
                                                start: {
                                                    line: 23,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'viewpath/html/TaskScheduleInput.ion'
                                                },
                                                end: {
                                                    line: 23,
                                                    column: 28,
                                                    fixed: true,
                                                    source: 'viewpath/html/TaskScheduleInput.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'values',
                                            loc: {
                                                start: {
                                                    line: 23,
                                                    column: 29,
                                                    fixed: true,
                                                    source: 'viewpath/html/TaskScheduleInput.ion'
                                                },
                                                end: {
                                                    line: 23,
                                                    column: 35,
                                                    fixed: true,
                                                    source: 'viewpath/html/TaskScheduleInput.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 23,
                                                column: 20,
                                                fixed: true,
                                                source: 'viewpath/html/TaskScheduleInput.ion'
                                            },
                                            end: {
                                                line: 23,
                                                column: 35,
                                                fixed: true,
                                                source: 'viewpath/html/TaskScheduleInput.ion'
                                            }
                                        }
                                    },
                                    body: {
                                        type: 'BlockStatement',
                                        body: [{
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'ObjectExpression',
                                                    objectType: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'Identifier',
                                                            name: 'Option',
                                                            loc: {
                                                                start: {
                                                                    line: 24,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskScheduleInput.ion'
                                                                },
                                                                end: {
                                                                    line: 24,
                                                                    column: 18,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskScheduleInput.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [{
                                                                type: 'ObjectExpression',
                                                                properties: [{
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'value',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 24,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/TaskScheduleInput.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 24,
                                                                                    column: 25,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/TaskScheduleInput.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'item',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 24,
                                                                                        column: 26,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/TaskScheduleInput.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 24,
                                                                                        column: 30,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/TaskScheduleInput.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'id',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 24,
                                                                                        column: 31,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/TaskScheduleInput.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 24,
                                                                                        column: 33,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/TaskScheduleInput.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 24,
                                                                                    column: 26,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/TaskScheduleInput.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 24,
                                                                                    column: 33,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/TaskScheduleInput.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    }]
                                                            }],
                                                        loc: {
                                                            start: {
                                                                line: 24,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'viewpath/html/TaskScheduleInput.ion'
                                                            },
                                                            end: {
                                                                line: 24,
                                                                column: 35,
                                                                fixed: true,
                                                                source: 'viewpath/html/TaskScheduleInput.ion'
                                                            }
                                                        }
                                                    },
                                                    properties: [
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'name',
                                                                loc: {
                                                                    start: {
                                                                        line: 25,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskScheduleInput.ion'
                                                                    },
                                                                    end: {
                                                                        line: 25,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskScheduleInput.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'item',
                                                                    loc: {
                                                                        start: {
                                                                            line: 25,
                                                                            column: 22,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskScheduleInput.ion'
                                                                        },
                                                                        end: {
                                                                            line: 25,
                                                                            column: 26,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskScheduleInput.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'name',
                                                                    loc: {
                                                                        start: {
                                                                            line: 25,
                                                                            column: 27,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskScheduleInput.ion'
                                                                        },
                                                                        end: {
                                                                            line: 25,
                                                                            column: 31,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskScheduleInput.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 25,
                                                                        column: 22,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskScheduleInput.ion'
                                                                    },
                                                                    end: {
                                                                        line: 25,
                                                                        column: 31,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskScheduleInput.ion'
                                                                    }
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        },
                                                        {
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'item',
                                                                    loc: {
                                                                        start: {
                                                                            line: 26,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskScheduleInput.ion'
                                                                        },
                                                                        end: {
                                                                            line: 26,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskScheduleInput.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'name',
                                                                    loc: {
                                                                        start: {
                                                                            line: 26,
                                                                            column: 21,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskScheduleInput.ion'
                                                                        },
                                                                        end: {
                                                                            line: 26,
                                                                            column: 25,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskScheduleInput.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 26,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskScheduleInput.ion'
                                                                    },
                                                                    end: {
                                                                        line: 26,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskScheduleInput.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 26,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskScheduleInput.ion'
                                                                },
                                                                end: {
                                                                    line: 26,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskScheduleInput.ion'
                                                                }
                                                            },
                                                            order: '1'
                                                        }
                                                    ]
                                                },
                                                loc: {
                                                    start: {
                                                        line: 24,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/TaskScheduleInput.ion'
                                                    },
                                                    end: {
                                                        line: 27,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'viewpath/html/TaskScheduleInput.ion'
                                                    }
                                                },
                                                order: '0'
                                            }]
                                    },
                                    remove: null,
                                    order: '1'
                                }
                            ]
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'CallExpression',
                    callee: {
                        type: 'MemberExpression',
                        object: {
                            type: 'Identifier',
                            name: 'Object'
                        },
                        property: {
                            type: 'Identifier',
                            name: 'defineProperties'
                        }
                    },
                    arguments: [
                        {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Div',
                                    loc: {
                                        start: {
                                            line: 27,
                                            column: 11,
                                            fixed: true,
                                            source: 'viewpath/html/TaskScheduleInput.ion'
                                        },
                                        end: {
                                            line: 27,
                                            column: 14,
                                            fixed: true,
                                            source: 'viewpath/html/TaskScheduleInput.ion'
                                        }
                                    }
                                },
                                arguments: [],
                                loc: {
                                    start: {
                                        line: 27,
                                        column: 11,
                                        fixed: true,
                                        source: 'viewpath/html/TaskScheduleInput.ion'
                                    },
                                    end: {
                                        line: 27,
                                        column: 16,
                                        fixed: true,
                                        source: 'viewpath/html/TaskScheduleInput.ion'
                                    }
                                }
                            },
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'dateInput',
                                        loc: {
                                            start: {
                                                line: 28,
                                                column: 8,
                                                fixed: true,
                                                source: 'viewpath/html/TaskScheduleInput.ion'
                                            },
                                            end: {
                                                line: 28,
                                                column: 17,
                                                fixed: true,
                                                source: 'viewpath/html/TaskScheduleInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Identifier',
                                        name: 'dateInput',
                                        loc: {
                                            start: {
                                                line: 28,
                                                column: 19,
                                                fixed: true,
                                                source: 'viewpath/html/TaskScheduleInput.ion'
                                            },
                                            end: {
                                                line: 28,
                                                column: 28,
                                                fixed: true,
                                                source: 'viewpath/html/TaskScheduleInput.ion'
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'constraintInput',
                                        loc: {
                                            start: {
                                                line: 29,
                                                column: 8,
                                                fixed: true,
                                                source: 'viewpath/html/TaskScheduleInput.ion'
                                            },
                                            end: {
                                                line: 29,
                                                column: 23,
                                                fixed: true,
                                                source: 'viewpath/html/TaskScheduleInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Identifier',
                                        name: 'constraintInput',
                                        loc: {
                                            start: {
                                                line: 29,
                                                column: 25,
                                                fixed: true,
                                                source: 'viewpath/html/TaskScheduleInput.ion'
                                            },
                                            end: {
                                                line: 29,
                                                column: 40,
                                                fixed: true,
                                                source: 'viewpath/html/TaskScheduleInput.ion'
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '1'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'focus',
                                        loc: {
                                            start: {
                                                line: 30,
                                                column: 8,
                                                fixed: true,
                                                source: 'viewpath/html/TaskScheduleInput.ion'
                                            },
                                            end: {
                                                line: 30,
                                                column: 13,
                                                fixed: true,
                                                source: 'viewpath/html/TaskScheduleInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context) {
                                            return function () {
                                                var dateInput = _context.get('dateInput');
                                                dateInput.inputElement.focus();
                                            };
                                        }
                                    },
                                    kind: 'init',
                                    order: '2'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'select',
                                        loc: {
                                            start: {
                                                line: 32,
                                                column: 8,
                                                fixed: true,
                                                source: 'viewpath/html/TaskScheduleInput.ion'
                                            },
                                            end: {
                                                line: 32,
                                                column: 14,
                                                fixed: true,
                                                source: 'viewpath/html/TaskScheduleInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context2) {
                                            return function () {
                                                var dateInput = _context2.get('dateInput');
                                                dateInput.inputElement.select();
                                            };
                                        }
                                    },
                                    kind: 'init',
                                    order: '3'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'ObjectExpression',
                                        objectType: {
                                            type: 'Identifier',
                                            name: 'dateInput',
                                            loc: {
                                                start: {
                                                    line: 34,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'viewpath/html/TaskScheduleInput.ion'
                                                },
                                                end: {
                                                    line: 34,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'viewpath/html/TaskScheduleInput.ion'
                                                }
                                            }
                                        },
                                        properties: [{
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'Identifier',
                                                    name: 'constraintInput',
                                                    loc: {
                                                        start: {
                                                            line: 35,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskScheduleInput.ion'
                                                        },
                                                        end: {
                                                            line: 35,
                                                            column: 27,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskScheduleInput.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 35,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/TaskScheduleInput.ion'
                                                    },
                                                    end: {
                                                        line: 35,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'viewpath/html/TaskScheduleInput.ion'
                                                    }
                                                },
                                                order: '0'
                                            }]
                                    },
                                    loc: {
                                        start: {
                                            line: 34,
                                            column: 8,
                                            fixed: true,
                                            source: 'viewpath/html/TaskScheduleInput.ion'
                                        },
                                        end: {
                                            line: 36,
                                            column: 12,
                                            fixed: true,
                                            source: 'viewpath/html/TaskScheduleInput.ion'
                                        }
                                    },
                                    order: '4'
                                }
                            ]
                        },
                        {
                            type: 'ObjectExpression',
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'label',
                                        loc: {
                                            start: {
                                                line: 36,
                                                column: 17,
                                                fixed: true,
                                                source: 'viewpath/html/TaskScheduleInput.ion'
                                            },
                                            end: {
                                                line: 36,
                                                column: 22,
                                                fixed: true,
                                                source: 'viewpath/html/TaskScheduleInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 37,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskScheduleInput.ion'
                                                        },
                                                        end: {
                                                            line: 37,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskScheduleInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context3) {
                                                        return function () {
                                                            var dateInput = _context3.get('dateInput');
                                                            return dateInput.label;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 38,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskScheduleInput.ion'
                                                        },
                                                        end: {
                                                            line: 38,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskScheduleInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context4) {
                                                        return function (value) {
                                                            var dateInput = _context4.get('dateInput');
                                                            return dateInput.label = value;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'value',
                                        loc: {
                                            start: {
                                                line: 39,
                                                column: 17,
                                                fixed: true,
                                                source: 'viewpath/html/TaskScheduleInput.ion'
                                            },
                                            end: {
                                                line: 39,
                                                column: 22,
                                                fixed: true,
                                                source: 'viewpath/html/TaskScheduleInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 40,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskScheduleInput.ion'
                                                        },
                                                        end: {
                                                            line: 40,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskScheduleInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: false,
                                                    value: function () {
                                                        console.log('TaskScheduleInput.get');
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 45,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskScheduleInput.ion'
                                                        },
                                                        end: {
                                                            line: 45,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskScheduleInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: false,
                                                    value: function (value) {
                                                        console.log('TaskScheduleInput.set', value);
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '1'
                                }
                            ]
                        }
                    ]
                },
                order: '3'
            }
        ],
        bound: false
    }, {
        this: this,
        attributes: attributes,
        _ref: _ref,
        TimeUnit: TimeUnit
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/TaskScheduleInput',_viewpath_html_TaskScheduleInput_);
    else
      _viewpath_html_TaskScheduleInput_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_TaskScheduleInput_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_TaskTimelineBox_ = function(module,exports,require){'use strict';
var ion = require('ion'), glass = require('glass'), _ref, _ref2, _ref3, _ref4, viewpathModel = require('../model'), _ref5, _ref6;
_ref = glass.data;
var Key = _ref.Key;
_ref2 = glass.html;
var style = _ref2.style;
_ref3 = glass.time;
var DateTime = _ref3.DateTime;
var Duration = _ref3.Duration;
_ref4 = glass.html;
var DragHelper = _ref4.DragHelper;
_ref5 = viewpathModel;
var ScheduleConstraint = _ref5.ScheduleConstraint;
_ref6 = glass.html.functions;
var getOffsetRelative = _ref6.getOffsetRelative;
var getAncestorByClass = _ref6.getAncestorByClass;
var triangleSize = 8;
var trianglePath = '<path fill="#748067" d="M 0 0 L ' + triangleSize + ' 0 L 0 ' + triangleSize + '">';
ion.template(function () {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [{
                type: 'ExpressionStatement',
                expression: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'MemberExpression',
                        computed: false,
                        object: {
                            type: 'Identifier',
                            name: 'style',
                            loc: {
                                start: {
                                    line: 18,
                                    column: 4,
                                    fixed: true,
                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                },
                                end: {
                                    line: 18,
                                    column: 9,
                                    fixed: true,
                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                }
                            }
                        },
                        property: {
                            type: 'Identifier',
                            name: 'sheets',
                            loc: {
                                start: {
                                    line: 18,
                                    column: 10,
                                    fixed: true,
                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                },
                                end: {
                                    line: 18,
                                    column: 16,
                                    fixed: true,
                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                }
                            }
                        },
                        loc: {
                            start: {
                                line: 18,
                                column: 4,
                                fixed: true,
                                source: 'viewpath/html/TaskTimelineBox.ion'
                            },
                            end: {
                                line: 18,
                                column: 16,
                                fixed: true,
                                source: 'viewpath/html/TaskTimelineBox.ion'
                            }
                        }
                    },
                    properties: [{
                            type: 'Property',
                            key: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'module',
                                    loc: {
                                        start: {
                                            line: 19,
                                            column: 9,
                                            fixed: true,
                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                        },
                                        end: {
                                            line: 19,
                                            column: 15,
                                            fixed: true,
                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'id',
                                    loc: {
                                        start: {
                                            line: 19,
                                            column: 16,
                                            fixed: true,
                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                        },
                                        end: {
                                            line: 19,
                                            column: 18,
                                            fixed: true,
                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 19,
                                        column: 9,
                                        fixed: true,
                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                    },
                                    end: {
                                        line: 19,
                                        column: 18,
                                        fixed: true,
                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'BinaryExpression',
                                operator: '+',
                                left: {
                                    type: 'BinaryExpression',
                                    operator: '+',
                                    left: {
                                        type: 'BinaryExpression',
                                        operator: '+',
                                        left: {
                                            type: 'BinaryExpression',
                                            operator: '+',
                                            left: {
                                                type: 'BinaryExpression',
                                                operator: '+',
                                                left: {
                                                    type: 'BinaryExpression',
                                                    operator: '+',
                                                    left: {
                                                        type: 'BinaryExpression',
                                                        operator: '+',
                                                        left: {
                                                            type: 'BinaryExpression',
                                                            operator: '+',
                                                            left: {
                                                                type: 'Literal',
                                                                value: '.TaskTimelineBox {\n    background: '
                                                            },
                                                            right: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'style',
                                                                        loc: {
                                                                            start: {
                                                                                line: 21,
                                                                                column: 30,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                                                            },
                                                                            end: {
                                                                                line: 21,
                                                                                column: 35,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'color',
                                                                        loc: {
                                                                            start: {
                                                                                line: 21,
                                                                                column: 36,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                                                            },
                                                                            end: {
                                                                                line: 21,
                                                                                column: 41,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 21,
                                                                            column: 30,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                                                        },
                                                                        end: {
                                                                            line: 21,
                                                                            column: 41,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'primaryDark',
                                                                    loc: {
                                                                        start: {
                                                                            line: 21,
                                                                            column: 42,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                                                        },
                                                                        end: {
                                                                            line: 21,
                                                                            column: 53,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 21,
                                                                        column: 30,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                                    },
                                                                    end: {
                                                                        line: 21,
                                                                        column: 53,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                                    }
                                                                }
                                                            }
                                                        },
                                                        right: {
                                                            type: 'Literal',
                                                            value: ';\n    display: inline-flex;\n    position: absolute;\n    /* changed from border to outline because otherwise you could not see small slices */\n    outline: solid 1px white;\n    transition:\n        box-shadow 600ms cubic-bezier(0.77, 0, 0.175, 1);\n}\n.TaskTimelineBox.small {\n    border: none;\n}\n.TaskTimelineBox.unscheduled {\n    background: none;\n    border: dashed 1px rgba(0,0,0,'
                                                        }
                                                    },
                                                    right: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'style',
                                                                loc: {
                                                                    start: {
                                                                        line: 34,
                                                                        column: 48,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                                    },
                                                                    end: {
                                                                        line: 34,
                                                                        column: 53,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'opacity',
                                                                loc: {
                                                                    start: {
                                                                        line: 34,
                                                                        column: 54,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                                    },
                                                                    end: {
                                                                        line: 34,
                                                                        column: 61,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 34,
                                                                    column: 48,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                                },
                                                                end: {
                                                                    line: 34,
                                                                    column: 61,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'hint',
                                                            loc: {
                                                                start: {
                                                                    line: 34,
                                                                    column: 62,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                                },
                                                                end: {
                                                                    line: 34,
                                                                    column: 66,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 34,
                                                                column: 48,
                                                                fixed: true,
                                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                                            },
                                                            end: {
                                                                line: 34,
                                                                column: 66,
                                                                fixed: true,
                                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                                            }
                                                        }
                                                    }
                                                },
                                                right: {
                                                    type: 'Literal',
                                                    value: ');\n}\n.TaskTimelineBox:not(.unscheduled):not(.summary) .name {\n    color: white;\n}\n.TaskTimelineBox.summary {\n    border: solid 1px #bbbbbb;\n    background: white;\n    color: #888888 !important;\n}\n.TaskTimelineBox .complete {\n    background: rgba(0,0,0,0.5);\n    position: absolute;\n    top: 0px;\n    left: 0px;\n    height: 100%;\n}\n.TaskTimelineBox .name {\n    display: inline-flex;\n    align-items: center;\n    position: absolute;\n    left: 0px;\n    top: 0px;\n    width: 100%;\n    height: 100%;\n    white-space: nowrap;\n    overflow: hidden;\n    padding-left: 4px;\n    font-weight: 400;\n    font-size: 10px;\n}\n.TaskTimelineBox .triangle {\n    opacity: 0;\n    position: absolute;\n    width: '
                                                }
                                            },
                                            right: {
                                                type: 'Identifier',
                                                name: 'triangleSize',
                                                loc: {
                                                    start: {
                                                        line: 68,
                                                        column: 25,
                                                        fixed: true,
                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                    },
                                                    end: {
                                                        line: 68,
                                                        column: 37,
                                                        fixed: true,
                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                    }
                                                }
                                            }
                                        },
                                        right: {
                                            type: 'Literal',
                                            value: 'px;\n    height: '
                                        }
                                    },
                                    right: {
                                        type: 'Identifier',
                                        name: 'triangleSize',
                                        loc: {
                                            start: {
                                                line: 69,
                                                column: 26,
                                                fixed: true,
                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                            },
                                            end: {
                                                line: 69,
                                                column: 38,
                                                fixed: true,
                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                            }
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: 'px;\n    top: calc(100% + 2px);\n    transform-origin: 0px 0px;\n    transition:\n        transform 200ms cubic-bezier(0.77, 0, 0.175, 1),\n        opacity 200ms cubic-bezier(0.77, 0, 0.175, 1);\n}\n.TaskTimelineBox .triangle.left {\n    left: -1px;\n    transform: translateY(-1px) rotateZ(-90deg) scale(0.8);\n}\n.TaskTimelineBox .triangle.right {\n    left: calc(100% + 1px);\n    transform: translateY(-1px) rotateZ(-180deg) scale(0.8);\n}\n.TaskTimelineBox.open .triangle.left {\n    opacity: 1;\n    transform:rotateZ(0deg);\n}\n.TaskTimelineBox.open .triangle.right {\n    opacity: 1;\n    transform:rotateZ(90deg);\n}\n.TaskTimelineBox.dragging {\n    opacity: 0;\n    transition:\n        left 0s,\n        top 0s,\n        box-shadow 600ms cubic-bezier(0.77, 0, 0.175, 1);\n    box-shadow: 0 10px 20px rgba(0,0,0,0.19), 0 6px 6px rgba(0,0,0,0.23);\n}\n.TaskTimelineBox-dragbox {\n    box-shadow: 0 10px 20px rgba(0,0,0,0.19), 0 6px 6px rgba(0,0,0,0.23);\n}\n.TaskTimelineBox.primary {\n    cursor: move; /* fallback if grab cursor is unsupported */\n    cursor: grab;\n    cursor: -moz-grab;\n    cursor: -webkit-grab;\n    z-index: 1;\n}\n.TaskTimelineBox:not(.primary) {\n    opacity: 0.3;\n    cursor: pointer;\n}\n.TaskTimelineBox.Manual {\n    border: solid 2px #000000;\n}\n.TaskTimelineBox.ASAP {\n    border: solid 1px #00FF00;\n}\n.TaskTimelineBox.ALAP {\n    border: solid 1px #FF0000;\n}'
                                }
                            },
                            kind: 'init',
                            computed: true,
                            order: '0'
                        }]
                },
                loc: {
                    start: {
                        line: 18,
                        column: 4,
                        fixed: true,
                        source: 'viewpath/html/TaskTimelineBox.ion'
                    },
                    end: {
                        line: 124,
                        column: 8,
                        fixed: true,
                        source: 'viewpath/html/TaskTimelineBox.ion'
                    }
                },
                order: '0'
            }],
        bound: false
    }, {
        this: this,
        module: module,
        ion: ion,
        glass: glass,
        _ref: _ref,
        _ref2: _ref2,
        _ref3: _ref3,
        _ref4: _ref4,
        viewpathModel: viewpathModel,
        _ref5: _ref5,
        _ref6: _ref6,
        Key: Key,
        style: style,
        DateTime: DateTime,
        Duration: Duration,
        DragHelper: DragHelper,
        ScheduleConstraint: ScheduleConstraint,
        getOffsetRelative: getOffsetRelative,
        getAncestorByClass: getAncestorByClass,
        triangleSize: triangleSize,
        trianglePath: trianglePath
    }, null);
})().observe();
module.exports = exports = ion.template(function TaskTimelineBox(_ref7) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'TaskTimelineBox',
            loc: {
                start: {
                    line: 124,
                    column: 16,
                    fixed: true,
                    source: 'viewpath/html/TaskTimelineBox.ion'
                },
                end: {
                    line: 124,
                    column: 31,
                    fixed: true,
                    source: 'viewpath/html/TaskTimelineBox.ion'
                }
            }
        },
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'record',
                            loc: {
                                start: {
                                    line: 124,
                                    column: 33,
                                    fixed: true,
                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                },
                                end: {
                                    line: 124,
                                    column: 39,
                                    fixed: true,
                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref7'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'record',
                                loc: {
                                    start: {
                                        line: 124,
                                        column: 33,
                                        fixed: true,
                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                    },
                                    end: {
                                        line: 124,
                                        column: 39,
                                        fixed: true,
                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'row',
                            loc: {
                                start: {
                                    line: 124,
                                    column: 40,
                                    fixed: true,
                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                },
                                end: {
                                    line: 124,
                                    column: 43,
                                    fixed: true,
                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref7'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'row',
                                loc: {
                                    start: {
                                        line: 124,
                                        column: 40,
                                        fixed: true,
                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                    },
                                    end: {
                                        line: 124,
                                        column: 43,
                                        fixed: true,
                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'column',
                            loc: {
                                start: {
                                    line: 124,
                                    column: 44,
                                    fixed: true,
                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                },
                                end: {
                                    line: 124,
                                    column: 50,
                                    fixed: true,
                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref7'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'column',
                                loc: {
                                    start: {
                                        line: 124,
                                        column: 44,
                                        fixed: true,
                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                    },
                                    end: {
                                        line: 124,
                                        column: 50,
                                        fixed: true,
                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'IfStatement',
                test: {
                    type: 'UnaryExpression',
                    operator: '?',
                    argument: {
                        type: 'Identifier',
                        name: 'record',
                        loc: {
                            start: {
                                line: 125,
                                column: 7,
                                fixed: true,
                                source: 'viewpath/html/TaskTimelineBox.ion'
                            },
                            end: {
                                line: 125,
                                column: 13,
                                fixed: true,
                                source: 'viewpath/html/TaskTimelineBox.ion'
                            }
                        }
                    }
                },
                consequent: {
                    type: 'BlockStatement',
                    body: [
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: '_ref8'
                                    },
                                    init: {
                                        type: 'Identifier',
                                        name: 'record',
                                        loc: {
                                            start: {
                                                line: 126,
                                                column: 20,
                                                fixed: true,
                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                            },
                                            end: {
                                                line: 126,
                                                column: 26,
                                                fixed: true,
                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '0'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'key',
                                        loc: {
                                            start: {
                                                line: 126,
                                                column: 13,
                                                fixed: true,
                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                            },
                                            end: {
                                                line: 126,
                                                column: 16,
                                                fixed: true,
                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'MemberExpression',
                                        object: {
                                            type: 'Identifier',
                                            name: '_ref8'
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'key',
                                            loc: {
                                                start: {
                                                    line: 126,
                                                    column: 13,
                                                    fixed: true,
                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                },
                                                end: {
                                                    line: 126,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                }
                                            }
                                        },
                                        computed: false
                                    }
                                }],
                            kind: 'let',
                            order: '1'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'start',
                                        loc: {
                                            start: {
                                                line: 127,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                            },
                                            end: {
                                                line: 127,
                                                column: 17,
                                                fixed: true,
                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'record',
                                            loc: {
                                                start: {
                                                    line: 127,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                },
                                                end: {
                                                    line: 127,
                                                    column: 26,
                                                    fixed: true,
                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'startWithTime',
                                            loc: {
                                                start: {
                                                    line: 127,
                                                    column: 27,
                                                    fixed: true,
                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                },
                                                end: {
                                                    line: 127,
                                                    column: 40,
                                                    fixed: true,
                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 127,
                                                column: 20,
                                                fixed: true,
                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                            },
                                            end: {
                                                line: 127,
                                                column: 40,
                                                fixed: true,
                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '2'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'finish',
                                        loc: {
                                            start: {
                                                line: 128,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                            },
                                            end: {
                                                line: 128,
                                                column: 18,
                                                fixed: true,
                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'record',
                                            loc: {
                                                start: {
                                                    line: 128,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                },
                                                end: {
                                                    line: 128,
                                                    column: 27,
                                                    fixed: true,
                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'finishWithTime',
                                            loc: {
                                                start: {
                                                    line: 128,
                                                    column: 28,
                                                    fixed: true,
                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                },
                                                end: {
                                                    line: 128,
                                                    column: 42,
                                                    fixed: true,
                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 128,
                                                column: 21,
                                                fixed: true,
                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                            },
                                            end: {
                                                line: 128,
                                                column: 42,
                                                fixed: true,
                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '3'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'parentKey',
                                        loc: {
                                            start: {
                                                line: 129,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                            },
                                            end: {
                                                line: 129,
                                                column: 21,
                                                fixed: true,
                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'Function',
                                            context: true,
                                            value: function (_context) {
                                                return function (key) {
                                                    var Key = _context.get('Key'), viewpathModel = _context.get('viewpathModel');
                                                    return key ? new Key(viewpathModel, key).parent : null;
                                                };
                                            }
                                        },
                                        arguments: [{
                                                type: 'Identifier',
                                                name: 'key',
                                                loc: {
                                                    start: {
                                                        line: 129,
                                                        column: 28,
                                                        fixed: true,
                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                    },
                                                    end: {
                                                        line: 129,
                                                        column: 31,
                                                        fixed: true,
                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                    }
                                                }
                                            }],
                                        loc: {
                                            start: {
                                                line: 129,
                                                column: 24,
                                                fixed: true,
                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                            },
                                            end: {
                                                line: 129,
                                                column: 83,
                                                fixed: true,
                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '4'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'project',
                                        loc: {
                                            start: {
                                                line: 130,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                            },
                                            end: {
                                                line: 130,
                                                column: 19,
                                                fixed: true,
                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'ConditionalExpression',
                                        test: {
                                            type: 'Identifier',
                                            name: 'parentKey',
                                            loc: {
                                                start: {
                                                    line: 130,
                                                    column: 22,
                                                    fixed: true,
                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                },
                                                end: {
                                                    line: 130,
                                                    column: 31,
                                                    fixed: true,
                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                }
                                            }
                                        },
                                        consequent: {
                                            type: 'MemberExpression',
                                            computed: true,
                                            object: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'model',
                                                    loc: {
                                                        start: {
                                                            line: 130,
                                                            column: 34,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                                        },
                                                        end: {
                                                            line: 130,
                                                            column: 39,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'server',
                                                    loc: {
                                                        start: {
                                                            line: 130,
                                                            column: 40,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                                        },
                                                        end: {
                                                            line: 130,
                                                            column: 46,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 130,
                                                        column: 34,
                                                        fixed: true,
                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                    },
                                                    end: {
                                                        line: 130,
                                                        column: 46,
                                                        fixed: true,
                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'parentKey',
                                                loc: {
                                                    start: {
                                                        line: 130,
                                                        column: 47,
                                                        fixed: true,
                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                    },
                                                    end: {
                                                        line: 130,
                                                        column: 56,
                                                        fixed: true,
                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 130,
                                                    column: 34,
                                                    fixed: true,
                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                },
                                                end: {
                                                    line: 130,
                                                    column: 57,
                                                    fixed: true,
                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                }
                                            }
                                        },
                                        alternate: {
                                            type: 'Literal',
                                            value: null
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '5'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'pageProject',
                                        loc: {
                                            start: {
                                                line: 131,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                            },
                                            end: {
                                                line: 131,
                                                column: 23,
                                                fixed: true,
                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'row',
                                                loc: {
                                                    start: {
                                                        line: 131,
                                                        column: 26,
                                                        fixed: true,
                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                    },
                                                    end: {
                                                        line: 131,
                                                        column: 29,
                                                        fixed: true,
                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'dataTableModel',
                                                loc: {
                                                    start: {
                                                        line: 131,
                                                        column: 30,
                                                        fixed: true,
                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                    },
                                                    end: {
                                                        line: 131,
                                                        column: 44,
                                                        fixed: true,
                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 131,
                                                    column: 26,
                                                    fixed: true,
                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                },
                                                end: {
                                                    line: 131,
                                                    column: 44,
                                                    fixed: true,
                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'project',
                                            loc: {
                                                start: {
                                                    line: 131,
                                                    column: 45,
                                                    fixed: true,
                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                },
                                                end: {
                                                    line: 131,
                                                    column: 52,
                                                    fixed: true,
                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 131,
                                                column: 26,
                                                fixed: true,
                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                            },
                                            end: {
                                                line: 131,
                                                column: 52,
                                                fixed: true,
                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '6'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'primary',
                                        loc: {
                                            start: {
                                                line: 133,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                            },
                                            end: {
                                                line: 133,
                                                column: 19,
                                                fixed: true,
                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'Function',
                                            context: false,
                                            value: function (project, pageProject) {
                                                return !(pageProject != null) || pageProject === project;
                                            }
                                        },
                                        arguments: [
                                            {
                                                type: 'Identifier',
                                                name: 'project',
                                                loc: {
                                                    start: {
                                                        line: 133,
                                                        column: 26,
                                                        fixed: true,
                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                    },
                                                    end: {
                                                        line: 133,
                                                        column: 33,
                                                        fixed: true,
                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                    }
                                                }
                                            },
                                            {
                                                type: 'Identifier',
                                                name: 'pageProject',
                                                loc: {
                                                    start: {
                                                        line: 133,
                                                        column: 35,
                                                        fixed: true,
                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                    },
                                                    end: {
                                                        line: 133,
                                                        column: 46,
                                                        fixed: true,
                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                    }
                                                }
                                            }
                                        ],
                                        loc: {
                                            start: {
                                                line: 133,
                                                column: 22,
                                                fixed: true,
                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                            },
                                            end: {
                                                line: 133,
                                                column: 93,
                                                fixed: true,
                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '7'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'summary',
                                        loc: {
                                            start: {
                                                line: 134,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                            },
                                            end: {
                                                line: 134,
                                                column: 19,
                                                fixed: true,
                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'record',
                                            loc: {
                                                start: {
                                                    line: 134,
                                                    column: 22,
                                                    fixed: true,
                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                },
                                                end: {
                                                    line: 134,
                                                    column: 28,
                                                    fixed: true,
                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'hasChildren',
                                            loc: {
                                                start: {
                                                    line: 134,
                                                    column: 29,
                                                    fixed: true,
                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                },
                                                end: {
                                                    line: 134,
                                                    column: 40,
                                                    fixed: true,
                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 134,
                                                column: 22,
                                                fixed: true,
                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                            },
                                            end: {
                                                line: 134,
                                                column: 40,
                                                fixed: true,
                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '8'
                        },
                        {
                            type: 'ReturnStatement',
                            argument: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'Identifier',
                                        name: 'Div',
                                        loc: {
                                            start: {
                                                line: 135,
                                                column: 15,
                                                fixed: true,
                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                            },
                                            end: {
                                                line: 135,
                                                column: 18,
                                                fixed: true,
                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                            }
                                        }
                                    },
                                    arguments: [{
                                            type: 'ObjectExpression',
                                            properties: [{
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'class',
                                                        loc: {
                                                            start: {
                                                                line: 135,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                                            },
                                                            end: {
                                                                line: 135,
                                                                column: 25,
                                                                fixed: true,
                                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 'TaskTimelineBox box transition'
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                }]
                                        }],
                                    loc: {
                                        start: {
                                            line: 135,
                                            column: 15,
                                            fixed: true,
                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                        },
                                        end: {
                                            line: 135,
                                            column: 60,
                                            fixed: true,
                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                        }
                                    }
                                },
                                properties: [
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'Function',
                                            context: true,
                                            value: function (_context2) {
                                                return function click(e) {
                                                    var record = _context2.get('record');
                                                    if (e.detail === 2) {
                                                        global.model.open(record.paneConfig, { target: 'dialog' });
                                                    }
                                                };
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 136,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                            },
                                            end: {
                                                line: 139,
                                                column: 16,
                                                fixed: true,
                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                            }
                                        },
                                        order: '0'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'Function',
                                            context: true,
                                            value: function (_context3) {
                                                return function mousedown(e) {
                                                    var Key = _context3.get('Key'), parentKey = _context3.get('parentKey'), project = _context3.get('project'), getOffsetRelative = _context3.get('getOffsetRelative'), row = _context3.get('row'), ion = _context3.get('ion'), column = _context3.get('column'), getAncestorByClass = _context3.get('getAncestorByClass'), DragHelper = _context3.get('DragHelper'), record = _context3.get('record'), summary = _context3.get('summary'), ScheduleConstraint = _context3.get('ScheduleConstraint');
                                                    var _ref9 = require('../model');
                                                    var Task = _ref9.Task;
                                                    var peers = model.server[new Key(parentKey, Task)];
                                                    if (!(project != null) || !(peers != null)) {
                                                        return;
                                                    }
                                                    var relativeElement = this.parentElement;
                                                    var _ref10 = getOffsetRelative(this);
                                                    var boxX = _ref10[0];
                                                    var boxY = _ref10[1];
                                                    var reassign = row.record.constructor.name === 'User';
                                                    var _ref11 = getOffsetRelative(relativeElement);
                                                    var offsetX = _ref11[0];
                                                    var offsetY = _ref11[1];
                                                    var startBoxLeft = e.offsetX;
                                                    var startLeft = this.style.left;
                                                    var startTop = this.style.top;
                                                    var state = {
                                                            startLeft: startLeft,
                                                            startTop: startTop
                                                        };
                                                    var snap = ion.bind(function (_ref12) {
                                                            var x = _ref12[0];
                                                            var y = _ref12[1];
                                                            if (x < 0) {
                                                                return null;
                                                            }
                                                            var start = column.getDate(x + startBoxLeft);
                                                            if (column.zoom.smallHours === 1) {
                                                                start = start.set({
                                                                    minutes: 0,
                                                                    seconds: 0,
                                                                    milliseconds: 0
                                                                });
                                                            } else {
                                                                start = start.set({
                                                                    hours: 0,
                                                                    minutes: 0,
                                                                    seconds: 0
                                                                });
                                                            }
                                                            var snappedX = column.getComponentLeft(start);
                                                            var snappedY = y;
                                                            var snappedRecord = null;
                                                            var element = document.elementFromPoint(offsetX + 10, offsetY + y);
                                                            if (element != null) {
                                                                var hoverRow = getAncestorByClass(element, 'row');
                                                                snappedRecord = hoverRow != null ? hoverRow.model != null ? hoverRow.model.record : void 0 : void 0;
                                                            }
                                                            return [
                                                                snappedX,
                                                                snappedY,
                                                                snappedRecord
                                                            ];
                                                        }, this);
                                                    var dragbox = null;
                                                    DragHelper.maybeBeginDrag({
                                                        event: e,
                                                        dragElement: this,
                                                        relativeElement: relativeElement,
                                                        state: state,
                                                        begin: ion.bind(function (e, properties) {
                                                            dragbox = this.cloneNode(true);
                                                            dragbox.classList.add('TaskTimelineBox-dragbox');
                                                            global.dragbox = dragbox;
                                                            dragbox.style.transition = 'left 0s, top 0s';
                                                            document.body.appendChild(dragbox);
                                                            this.classList.add('dragging');
                                                        }, this),
                                                        update: ion.bind(function (e, _ref13) {
                                                            var position = _ref13.position;
                                                            var snappedPosition = snap(position);
                                                            var _ref14 = snappedPosition != null ? snappedPosition : position;
                                                            var snappedX = _ref14[0];
                                                            var snappedY = _ref14[1];
                                                            if (!(snappedPosition != null)) {
                                                                snappedX = 0;
                                                                dragbox.classList.add('unscheduled');
                                                            } else {
                                                                dragbox.classList.remove('unscheduled');
                                                            }
                                                            dragbox.style.left = (reassign ? boxX : offsetX + snappedX) + 'px';
                                                            dragbox.style.top = (reassign ? offsetY + snappedY : boxY) + 'px';
                                                        }, this),
                                                        end: ion.bind(function (e, properties) {
                                                            this.classList.remove('dragging');
                                                            document.body.removeChild(dragbox);
                                                            if (!(properties != null)) {
                                                                return;
                                                            }
                                                            var _ref15 = properties;
                                                            var position = _ref15.position;
                                                            var snappedPosition = snap(position);
                                                            var _ref16 = snappedPosition != null ? snappedPosition : position;
                                                            var snappedX = _ref16[0];
                                                            var snappedY = _ref16[1];
                                                            var snappedRecord = _ref16[2];
                                                            if (reassign) {
                                                                if (record.assignedUser !== (snappedRecord != null ? snappedRecord.key : void 0)) {
                                                                    global.model.ops.begin();
                                                                    record.assignedUser = snappedRecord.key;
                                                                }
                                                            } else {
                                                                global.model.ops.begin();
                                                                if (snappedPosition != null) {
                                                                    if (summary) {
                                                                        record.ScheduleConstraint = ScheduleConstraint.ASAP.valueOf();
                                                                    } else {
                                                                        this.style.left = snappedX + 'px';
                                                                        var time = column.getDate(snappedX).set({
                                                                                minutes: 0,
                                                                                seconds: 0,
                                                                                milliseconds: 0
                                                                            }).toISOString();
                                                                        if (column.zoom.snapToHour.valueOf() === false) {
                                                                            time = time.substring(0, time.indexOf('T'));
                                                                        } else {
                                                                            time = record.convertUTCToLocal(time);
                                                                        }
                                                                        if (!(record.start != null ? record.start.startsWith(time) : void 0)) {
                                                                            record.manualStart = time;
                                                                        }
                                                                    }
                                                                } else {
                                                                    record.clearSchedule();
                                                                }
                                                            }
                                                        }, this)
                                                    });
                                                };
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 139,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                            },
                                            end: {
                                                line: 241,
                                                column: 16,
                                                fixed: true,
                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                            }
                                        },
                                        order: '1'
                                    },
                                    {
                                        type: 'IfStatement',
                                        test: {
                                            type: 'UnaryExpression',
                                            operator: '?',
                                            argument: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'record',
                                                    loc: {
                                                        start: {
                                                            line: 241,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                                        },
                                                        end: {
                                                            line: 241,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'color',
                                                    loc: {
                                                        start: {
                                                            line: 241,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                                        },
                                                        end: {
                                                            line: 241,
                                                            column: 27,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 241,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                    },
                                                    end: {
                                                        line: 241,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                    }
                                                }
                                            }
                                        },
                                        consequent: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'style',
                                                        loc: {
                                                            start: {
                                                                line: 242,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                                            },
                                                            end: {
                                                                line: 242,
                                                                column: 21,
                                                                fixed: true,
                                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'ObjectExpression',
                                                        properties: [{
                                                                type: 'IfStatement',
                                                                test: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '&&',
                                                                    left: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'record',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 243,
                                                                                    column: 23,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 243,
                                                                                    column: 29,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'start',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 243,
                                                                                    column: 30,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 243,
                                                                                    column: 35,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 243,
                                                                                column: 23,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                                                            },
                                                                            end: {
                                                                                line: 243,
                                                                                column: 35,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    right: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'record',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 243,
                                                                                    column: 40,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 243,
                                                                                    column: 46,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'finish',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 243,
                                                                                    column: 47,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 243,
                                                                                    column: 53,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 243,
                                                                                column: 40,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                                                            },
                                                                            end: {
                                                                                line: 243,
                                                                                column: 53,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                                                            }
                                                                        }
                                                                    }
                                                                },
                                                                consequent: {
                                                                    type: 'BlockStatement',
                                                                    body: [{
                                                                            type: 'IfStatement',
                                                                            test: {
                                                                                type: 'UnaryExpression',
                                                                                operator: '!',
                                                                                argument: {
                                                                                    type: 'Identifier',
                                                                                    name: 'summary',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 244,
                                                                                            column: 31,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 244,
                                                                                            column: 38,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                                                                        }
                                                                                    }
                                                                                }
                                                                            },
                                                                            consequent: {
                                                                                type: 'BlockStatement',
                                                                                body: [{
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'backgroundColor',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 245,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 245,
                                                                                                    column: 43,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'MemberExpression',
                                                                                            computed: false,
                                                                                            object: {
                                                                                                type: 'Identifier',
                                                                                                name: 'record',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 245,
                                                                                                        column: 45,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 245,
                                                                                                        column: 51,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            property: {
                                                                                                type: 'Identifier',
                                                                                                name: 'color',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 245,
                                                                                                        column: 52,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 245,
                                                                                                        column: 57,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 245,
                                                                                                    column: 45,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 245,
                                                                                                    column: 57,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            alternate: null,
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                alternate: {
                                                                    type: 'BlockStatement',
                                                                    body: [{
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'borderColor',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 247,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 247,
                                                                                        column: 35,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'Identifier',
                                                                                    name: 'record',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 247,
                                                                                            column: 37,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 247,
                                                                                            column: 43,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'color',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 247,
                                                                                            column: 44,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 247,
                                                                                            column: 49,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 247,
                                                                                        column: 37,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 247,
                                                                                        column: 49,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                }]
                                        },
                                        alternate: null,
                                        order: '2'
                                    },
                                    {
                                        type: 'IfStatement',
                                        test: {
                                            type: 'UnaryExpression',
                                            operator: '?',
                                            argument: {
                                                type: 'Identifier',
                                                name: 'project',
                                                loc: {
                                                    start: {
                                                        line: 248,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                    },
                                                    end: {
                                                        line: 248,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                    }
                                                }
                                            }
                                        },
                                        consequent: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'title',
                                                        loc: {
                                                            start: {
                                                                line: 249,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                                            },
                                                            end: {
                                                                line: 249,
                                                                column: 21,
                                                                fixed: true,
                                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'project',
                                                            loc: {
                                                                start: {
                                                                    line: 249,
                                                                    column: 23,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                                },
                                                                end: {
                                                                    line: 249,
                                                                    column: 30,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'name',
                                                            loc: {
                                                                start: {
                                                                    line: 249,
                                                                    column: 31,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                                },
                                                                end: {
                                                                    line: 249,
                                                                    column: 35,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 249,
                                                                column: 23,
                                                                fixed: true,
                                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                                            },
                                                            end: {
                                                                line: 249,
                                                                column: 35,
                                                                fixed: true,
                                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                                            }
                                                        }
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                }]
                                        },
                                        alternate: null,
                                        order: '3'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'key',
                                            loc: {
                                                start: {
                                                    line: 251,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                },
                                                end: {
                                                    line: 251,
                                                    column: 15,
                                                    fixed: true,
                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Identifier',
                                            name: 'key',
                                            loc: {
                                                start: {
                                                    line: 251,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                },
                                                end: {
                                                    line: 251,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                }
                                            }
                                        },
                                        kind: 'init',
                                        order: '4'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'start',
                                            loc: {
                                                start: {
                                                    line: 252,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                },
                                                end: {
                                                    line: 252,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Identifier',
                                            name: 'start',
                                            loc: {
                                                start: {
                                                    line: 252,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                },
                                                end: {
                                                    line: 252,
                                                    column: 24,
                                                    fixed: true,
                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                }
                                            }
                                        },
                                        kind: 'init',
                                        order: '5'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'finish',
                                            loc: {
                                                start: {
                                                    line: 253,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                },
                                                end: {
                                                    line: 253,
                                                    column: 18,
                                                    fixed: true,
                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Identifier',
                                            name: 'finish',
                                            loc: {
                                                start: {
                                                    line: 253,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                },
                                                end: {
                                                    line: 253,
                                                    column: 26,
                                                    fixed: true,
                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                }
                                            }
                                        },
                                        kind: 'init',
                                        order: '6'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'record',
                                            loc: {
                                                start: {
                                                    line: 254,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                },
                                                end: {
                                                    line: 254,
                                                    column: 18,
                                                    fixed: true,
                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Identifier',
                                            name: 'record',
                                            loc: {
                                                start: {
                                                    line: 254,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                },
                                                end: {
                                                    line: 254,
                                                    column: 26,
                                                    fixed: true,
                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                }
                                            }
                                        },
                                        kind: 'init',
                                        order: '7'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'classList',
                                            loc: {
                                                start: {
                                                    line: 255,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                },
                                                end: {
                                                    line: 255,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'ObjectExpression',
                                            properties: [
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'record',
                                                                loc: {
                                                                    start: {
                                                                        line: 256,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                                    },
                                                                    end: {
                                                                        line: 256,
                                                                        column: 22,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'ScheduleConstraint',
                                                                loc: {
                                                                    start: {
                                                                        line: 256,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                                    },
                                                                    end: {
                                                                        line: 256,
                                                                        column: 41,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 256,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                                },
                                                                end: {
                                                                    line: 256,
                                                                    column: 41,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'name',
                                                            loc: {
                                                                start: {
                                                                    line: 256,
                                                                    column: 42,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                                },
                                                                end: {
                                                                    line: 256,
                                                                    column: 46,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 256,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                                            },
                                                            end: {
                                                                line: 256,
                                                                column: 46,
                                                                fixed: true,
                                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 256,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                                        },
                                                        end: {
                                                            line: 256,
                                                            column: 46,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                },
                                                {
                                                    type: 'IfStatement',
                                                    test: {
                                                        type: 'UnaryExpression',
                                                        operator: '!',
                                                        argument: {
                                                            type: 'UnaryExpression',
                                                            operator: '?',
                                                            argument: {
                                                                type: 'Identifier',
                                                                name: 'start',
                                                                loc: {
                                                                    start: {
                                                                        line: 257,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                                    },
                                                                    end: {
                                                                        line: 257,
                                                                        column: 28,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    },
                                                    consequent: {
                                                        type: 'BlockStatement',
                                                        body: [{
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'Literal',
                                                                    value: 'unscheduled'
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 258,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                                    },
                                                                    end: {
                                                                        line: 258,
                                                                        column: 33,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    alternate: null,
                                                    order: '1'
                                                },
                                                {
                                                    type: 'IfStatement',
                                                    test: {
                                                        type: 'Identifier',
                                                        name: 'summary',
                                                        loc: {
                                                            start: {
                                                                line: 259,
                                                                column: 19,
                                                                fixed: true,
                                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                                            },
                                                            end: {
                                                                line: 259,
                                                                column: 26,
                                                                fixed: true,
                                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                                            }
                                                        }
                                                    },
                                                    consequent: {
                                                        type: 'BlockStatement',
                                                        body: [{
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'Literal',
                                                                    value: 'summary'
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 260,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                                    },
                                                                    end: {
                                                                        line: 260,
                                                                        column: 29,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    alternate: null,
                                                    order: '2'
                                                },
                                                {
                                                    type: 'IfStatement',
                                                    test: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'row',
                                                            loc: {
                                                                start: {
                                                                    line: 261,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                                },
                                                                end: {
                                                                    line: 261,
                                                                    column: 22,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'open',
                                                            loc: {
                                                                start: {
                                                                    line: 261,
                                                                    column: 23,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                                },
                                                                end: {
                                                                    line: 261,
                                                                    column: 27,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 261,
                                                                column: 19,
                                                                fixed: true,
                                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                                            },
                                                            end: {
                                                                line: 261,
                                                                column: 27,
                                                                fixed: true,
                                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                                            }
                                                        }
                                                    },
                                                    consequent: {
                                                        type: 'BlockStatement',
                                                        body: [{
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'Literal',
                                                                    value: 'open'
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 262,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                                    },
                                                                    end: {
                                                                        line: 262,
                                                                        column: 26,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    alternate: null,
                                                    order: '3'
                                                },
                                                {
                                                    type: 'IfStatement',
                                                    test: {
                                                        type: 'Identifier',
                                                        name: 'primary',
                                                        loc: {
                                                            start: {
                                                                line: 263,
                                                                column: 19,
                                                                fixed: true,
                                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                                            },
                                                            end: {
                                                                line: 263,
                                                                column: 26,
                                                                fixed: true,
                                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                                            }
                                                        }
                                                    },
                                                    consequent: {
                                                        type: 'BlockStatement',
                                                        body: [{
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'Literal',
                                                                    value: 'primary'
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 264,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                                    },
                                                                    end: {
                                                                        line: 264,
                                                                        column: 29,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    alternate: null,
                                                    order: '4'
                                                }
                                            ]
                                        },
                                        kind: 'init',
                                        order: '8'
                                    },
                                    {
                                        type: 'IfStatement',
                                        test: {
                                            type: 'BinaryExpression',
                                            operator: '>',
                                            left: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'record',
                                                    loc: {
                                                        start: {
                                                            line: 265,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                                        },
                                                        end: {
                                                            line: 265,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'percent',
                                                    loc: {
                                                        start: {
                                                            line: 265,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                                        },
                                                        end: {
                                                            line: 265,
                                                            column: 29,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 265,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                    },
                                                    end: {
                                                        line: 265,
                                                        column: 29,
                                                        fixed: true,
                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                    }
                                                }
                                            },
                                            right: {
                                                type: 'Literal',
                                                value: 0
                                            }
                                        },
                                        consequent: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'Div',
                                                                loc: {
                                                                    start: {
                                                                        line: 266,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                                    },
                                                                    end: {
                                                                        line: 266,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [{
                                                                    type: 'ObjectExpression',
                                                                    properties: [{
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'class',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 266,
                                                                                        column: 21,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 266,
                                                                                        column: 26,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'complete'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        }]
                                                                }],
                                                            loc: {
                                                                start: {
                                                                    line: 266,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                                },
                                                                end: {
                                                                    line: 266,
                                                                    column: 39,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [{
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'style',
                                                                    loc: {
                                                                        start: {
                                                                            line: 267,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                                                        },
                                                                        end: {
                                                                            line: 267,
                                                                            column: 25,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'ObjectExpression',
                                                                    properties: [{
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'width',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 268,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 268,
                                                                                        column: 29,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'BinaryExpression',
                                                                                operator: '+',
                                                                                left: {
                                                                                    type: 'BinaryExpression',
                                                                                    operator: '+',
                                                                                    left: {
                                                                                        type: 'Literal',
                                                                                        value: ''
                                                                                    },
                                                                                    right: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'record',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 268,
                                                                                                    column: 34,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 268,
                                                                                                    column: 40,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'percent',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 268,
                                                                                                    column: 41,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 268,
                                                                                                    column: 48,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 268,
                                                                                                column: 34,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 268,
                                                                                                column: 48,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                },
                                                                                right: {
                                                                                    type: 'Literal',
                                                                                    value: '%'
                                                                                }
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            }]
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 266,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                                        },
                                                        end: {
                                                            line: 269,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        alternate: null,
                                        order: '9'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'ObjectExpression',
                                            objectType: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'Div',
                                                    loc: {
                                                        start: {
                                                            line: 269,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                                        },
                                                        end: {
                                                            line: 269,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [{
                                                        type: 'ObjectExpression',
                                                        properties: [{
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'class',
                                                                    loc: {
                                                                        start: {
                                                                            line: 269,
                                                                            column: 17,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                                                        },
                                                                        end: {
                                                                            line: 269,
                                                                            column: 22,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: 'name'
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            }]
                                                    }],
                                                loc: {
                                                    start: {
                                                        line: 269,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                    },
                                                    end: {
                                                        line: 269,
                                                        column: 31,
                                                        fixed: true,
                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                    }
                                                }
                                            },
                                            properties: [{
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'record',
                                                            loc: {
                                                                start: {
                                                                    line: 270,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                                },
                                                                end: {
                                                                    line: 270,
                                                                    column: 22,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'name',
                                                            loc: {
                                                                start: {
                                                                    line: 270,
                                                                    column: 23,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                                },
                                                                end: {
                                                                    line: 270,
                                                                    column: 27,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 270,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                                            },
                                                            end: {
                                                                line: 270,
                                                                column: 27,
                                                                fixed: true,
                                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 270,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                                        },
                                                        end: {
                                                            line: 270,
                                                            column: 27,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        loc: {
                                            start: {
                                                line: 269,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                            },
                                            end: {
                                                line: 271,
                                                column: 16,
                                                fixed: true,
                                                source: 'viewpath/html/TaskTimelineBox.ion'
                                            }
                                        },
                                        order: ':'
                                    },
                                    {
                                        type: 'IfStatement',
                                        test: {
                                            type: 'Identifier',
                                            name: 'summary',
                                            loc: {
                                                start: {
                                                    line: 271,
                                                    column: 15,
                                                    fixed: true,
                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                },
                                                end: {
                                                    line: 271,
                                                    column: 22,
                                                    fixed: true,
                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                }
                                            }
                                        },
                                        consequent: {
                                            type: 'BlockStatement',
                                            body: [
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'Svg',
                                                                loc: {
                                                                    start: {
                                                                        line: 272,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                                    },
                                                                    end: {
                                                                        line: 272,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [{
                                                                    type: 'ObjectExpression',
                                                                    properties: [{
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'class',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 272,
                                                                                        column: 21,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 272,
                                                                                        column: 26,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'left triangle'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        }]
                                                                }],
                                                            loc: {
                                                                start: {
                                                                    line: 272,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                                },
                                                                end: {
                                                                    line: 272,
                                                                    column: 44,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [{
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'innerHTML',
                                                                    loc: {
                                                                        start: {
                                                                            line: 273,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                                                        },
                                                                        end: {
                                                                            line: 273,
                                                                            column: 29,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Identifier',
                                                                    name: 'trianglePath',
                                                                    loc: {
                                                                        start: {
                                                                            line: 273,
                                                                            column: 31,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                                                        },
                                                                        end: {
                                                                            line: 273,
                                                                            column: 43,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                                                        }
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            }]
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 272,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                                        },
                                                        end: {
                                                            line: 274,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                },
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'Svg',
                                                                loc: {
                                                                    start: {
                                                                        line: 274,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                                    },
                                                                    end: {
                                                                        line: 274,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [{
                                                                    type: 'ObjectExpression',
                                                                    properties: [{
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'class',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 274,
                                                                                        column: 21,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 274,
                                                                                        column: 26,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/TaskTimelineBox.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'right triangle'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        }]
                                                                }],
                                                            loc: {
                                                                start: {
                                                                    line: 274,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                                },
                                                                end: {
                                                                    line: 274,
                                                                    column: 45,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TaskTimelineBox.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [{
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'innerHTML',
                                                                    loc: {
                                                                        start: {
                                                                            line: 275,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                                                        },
                                                                        end: {
                                                                            line: 275,
                                                                            column: 29,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Identifier',
                                                                    name: 'trianglePath',
                                                                    loc: {
                                                                        start: {
                                                                            line: 275,
                                                                            column: 31,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                                                        },
                                                                        end: {
                                                                            line: 275,
                                                                            column: 43,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                                                        }
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            }]
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 274,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                                        },
                                                        end: {
                                                            line: 277,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'viewpath/html/TaskTimelineBox.ion'
                                                        }
                                                    },
                                                    order: '1'
                                                }
                                            ]
                                        },
                                        alternate: null,
                                        order: ';'
                                    }
                                ]
                            },
                            order: '9'
                        }
                    ]
                },
                alternate: null,
                order: '3'
            }
        ],
        bound: false
    }, {
        this: this,
        require: require,
        ion: ion,
        _ref7: _ref7,
        glass: glass,
        _ref: _ref,
        _ref2: _ref2,
        _ref3: _ref3,
        _ref4: _ref4,
        viewpathModel: viewpathModel,
        _ref5: _ref5,
        _ref6: _ref6,
        Key: Key,
        style: style,
        DateTime: DateTime,
        Duration: Duration,
        DragHelper: DragHelper,
        ScheduleConstraint: ScheduleConstraint,
        getOffsetRelative: getOffsetRelative,
        getAncestorByClass: getAncestorByClass,
        triangleSize: triangleSize,
        trianglePath: trianglePath
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/TaskTimelineBox',_viewpath_html_TaskTimelineBox_);
    else
      _viewpath_html_TaskTimelineBox_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_TaskTimelineBox_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_TimeAndUnitInput_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('../model');
var TimeUnit = _ref.TimeUnit;
module.exports = exports = ion.template(function TimeAndUnitInput(attributes) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'TimeAndUnitInput',
            loc: {
                start: {
                    line: 5,
                    column: 16,
                    fixed: true,
                    source: 'viewpath/html/TimeAndUnitInput.ion'
                },
                end: {
                    line: 5,
                    column: 32,
                    fixed: true,
                    source: 'viewpath/html/TimeAndUnitInput.ion'
                }
            }
        },
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'setUnitFromChar',
                            loc: {
                                start: {
                                    line: 6,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/TimeAndUnitInput.ion'
                                },
                                end: {
                                    line: 6,
                                    column: 23,
                                    fixed: true,
                                    source: 'viewpath/html/TimeAndUnitInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'Function',
                            context: true,
                            value: function (_context) {
                                return function (key) {
                                    var unitInput = _context.get('unitInput');
                                    var _ref2 = unitInput;
                                    var options = _ref2.options;
                                    var selectedIndex = _ref2.selectedIndex;
                                    var startIndex = unitInput.selectedIndex + 1;
                                    for (var i = 1; i <= options.length; i++) {
                                        var checkIndex = (selectedIndex + i) % options.length;
                                        var option = options[checkIndex];
                                        if (option.name.toLowerCase().startsWith(key.toLowerCase())) {
                                            option.selected = true;
                                            return;
                                        }
                                    }
                                };
                            }
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'numberInput',
                            loc: {
                                start: {
                                    line: 16,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/TimeAndUnitInput.ion'
                                },
                                end: {
                                    line: 16,
                                    column: 19,
                                    fixed: true,
                                    source: 'viewpath/html/TimeAndUnitInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'PaperInput',
                                    loc: {
                                        start: {
                                            line: 16,
                                            column: 22,
                                            fixed: true,
                                            source: 'viewpath/html/TimeAndUnitInput.ion'
                                        },
                                        end: {
                                            line: 16,
                                            column: 32,
                                            fixed: true,
                                            source: 'viewpath/html/TimeAndUnitInput.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'type',
                                                    loc: {
                                                        start: {
                                                            line: 16,
                                                            column: 34,
                                                            fixed: true,
                                                            source: 'viewpath/html/TimeAndUnitInput.ion'
                                                        },
                                                        end: {
                                                            line: 16,
                                                            column: 38,
                                                            fixed: true,
                                                            source: 'viewpath/html/TimeAndUnitInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: 'number'
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    }],
                                loc: {
                                    start: {
                                        line: 16,
                                        column: 22,
                                        fixed: true,
                                        source: 'viewpath/html/TimeAndUnitInput.ion'
                                    },
                                    end: {
                                        line: 16,
                                        column: 49,
                                        fixed: true,
                                        source: 'viewpath/html/TimeAndUnitInput.ion'
                                    }
                                }
                            },
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'alwaysFloatLabel',
                                        loc: {
                                            start: {
                                                line: 17,
                                                column: 8,
                                                fixed: true,
                                                source: 'viewpath/html/TimeAndUnitInput.ion'
                                            },
                                            end: {
                                                line: 17,
                                                column: 24,
                                                fixed: true,
                                                source: 'viewpath/html/TimeAndUnitInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: true
                                    },
                                    kind: 'init',
                                    order: '0'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context2) {
                                            return function keypress(e) {
                                                var setUnitFromChar = _context2.get('setUnitFromChar');
                                                if (!/^\d+$/.test(e.key)) {
                                                    setUnitFromChar(e.key);
                                                    e.preventDefault();
                                                }
                                            };
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 18,
                                            column: 8,
                                            fixed: true,
                                            source: 'viewpath/html/TimeAndUnitInput.ion'
                                        },
                                        end: {
                                            line: 23,
                                            column: 12,
                                            fixed: true,
                                            source: 'viewpath/html/TimeAndUnitInput.ion'
                                        }
                                    },
                                    order: '1'
                                }
                            ]
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'unitInput',
                            loc: {
                                start: {
                                    line: 23,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/TimeAndUnitInput.ion'
                                },
                                end: {
                                    line: 23,
                                    column: 17,
                                    fixed: true,
                                    source: 'viewpath/html/TimeAndUnitInput.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Select',
                                    loc: {
                                        start: {
                                            line: 23,
                                            column: 20,
                                            fixed: true,
                                            source: 'viewpath/html/TimeAndUnitInput.ion'
                                        },
                                        end: {
                                            line: 23,
                                            column: 26,
                                            fixed: true,
                                            source: 'viewpath/html/TimeAndUnitInput.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'suffix',
                                                    loc: {
                                                        start: {
                                                            line: 23,
                                                            column: 28,
                                                            fixed: true,
                                                            source: 'viewpath/html/TimeAndUnitInput.ion'
                                                        },
                                                        end: {
                                                            line: 23,
                                                            column: 34,
                                                            fixed: true,
                                                            source: 'viewpath/html/TimeAndUnitInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: true
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    }],
                                loc: {
                                    start: {
                                        line: 23,
                                        column: 20,
                                        fixed: true,
                                        source: 'viewpath/html/TimeAndUnitInput.ion'
                                    },
                                    end: {
                                        line: 23,
                                        column: 41,
                                        fixed: true,
                                        source: 'viewpath/html/TimeAndUnitInput.ion'
                                    }
                                }
                            },
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'style',
                                        loc: {
                                            start: {
                                                line: 24,
                                                column: 8,
                                                fixed: true,
                                                source: 'viewpath/html/TimeAndUnitInput.ion'
                                            },
                                            end: {
                                                line: 24,
                                                column: 13,
                                                fixed: true,
                                                source: 'viewpath/html/TimeAndUnitInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'border',
                                                    loc: {
                                                        start: {
                                                            line: 25,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/TimeAndUnitInput.ion'
                                                        },
                                                        end: {
                                                            line: 25,
                                                            column: 18,
                                                            fixed: true,
                                                            source: 'viewpath/html/TimeAndUnitInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: 'none'
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'background',
                                                    loc: {
                                                        start: {
                                                            line: 26,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/TimeAndUnitInput.ion'
                                                        },
                                                        end: {
                                                            line: 26,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'viewpath/html/TimeAndUnitInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: 'none'
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    order: '0'
                                },
                                {
                                    type: 'ForOfStatement',
                                    left: {
                                        type: 'VariableDeclaration',
                                        declarations: [{
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'item',
                                                    loc: {
                                                        start: {
                                                            line: 27,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/TimeAndUnitInput.ion'
                                                        },
                                                        end: {
                                                            line: 27,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/TimeAndUnitInput.ion'
                                                        }
                                                    }
                                                },
                                                init: null
                                            }],
                                        kind: 'let'
                                    },
                                    right: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'TimeUnit',
                                            loc: {
                                                start: {
                                                    line: 27,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'viewpath/html/TimeAndUnitInput.ion'
                                                },
                                                end: {
                                                    line: 27,
                                                    column: 28,
                                                    fixed: true,
                                                    source: 'viewpath/html/TimeAndUnitInput.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'values',
                                            loc: {
                                                start: {
                                                    line: 27,
                                                    column: 29,
                                                    fixed: true,
                                                    source: 'viewpath/html/TimeAndUnitInput.ion'
                                                },
                                                end: {
                                                    line: 27,
                                                    column: 35,
                                                    fixed: true,
                                                    source: 'viewpath/html/TimeAndUnitInput.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 27,
                                                column: 20,
                                                fixed: true,
                                                source: 'viewpath/html/TimeAndUnitInput.ion'
                                            },
                                            end: {
                                                line: 27,
                                                column: 35,
                                                fixed: true,
                                                source: 'viewpath/html/TimeAndUnitInput.ion'
                                            }
                                        }
                                    },
                                    body: {
                                        type: 'BlockStatement',
                                        body: [{
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'ObjectExpression',
                                                    objectType: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'Identifier',
                                                            name: 'Option',
                                                            loc: {
                                                                start: {
                                                                    line: 28,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TimeAndUnitInput.ion'
                                                                },
                                                                end: {
                                                                    line: 28,
                                                                    column: 18,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TimeAndUnitInput.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [{
                                                                type: 'ObjectExpression',
                                                                properties: [{
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'value',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 28,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/TimeAndUnitInput.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 28,
                                                                                    column: 25,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/TimeAndUnitInput.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'item',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 28,
                                                                                        column: 26,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/TimeAndUnitInput.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 28,
                                                                                        column: 30,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/TimeAndUnitInput.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'id',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 28,
                                                                                        column: 31,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/TimeAndUnitInput.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 28,
                                                                                        column: 33,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/TimeAndUnitInput.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 28,
                                                                                    column: 26,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/TimeAndUnitInput.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 28,
                                                                                    column: 33,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/TimeAndUnitInput.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    }]
                                                            }],
                                                        loc: {
                                                            start: {
                                                                line: 28,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'viewpath/html/TimeAndUnitInput.ion'
                                                            },
                                                            end: {
                                                                line: 28,
                                                                column: 35,
                                                                fixed: true,
                                                                source: 'viewpath/html/TimeAndUnitInput.ion'
                                                            }
                                                        }
                                                    },
                                                    properties: [
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'name',
                                                                loc: {
                                                                    start: {
                                                                        line: 29,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TimeAndUnitInput.ion'
                                                                    },
                                                                    end: {
                                                                        line: 29,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TimeAndUnitInput.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'item',
                                                                    loc: {
                                                                        start: {
                                                                            line: 29,
                                                                            column: 22,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TimeAndUnitInput.ion'
                                                                        },
                                                                        end: {
                                                                            line: 29,
                                                                            column: 26,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TimeAndUnitInput.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'name',
                                                                    loc: {
                                                                        start: {
                                                                            line: 29,
                                                                            column: 27,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TimeAndUnitInput.ion'
                                                                        },
                                                                        end: {
                                                                            line: 29,
                                                                            column: 31,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TimeAndUnitInput.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 29,
                                                                        column: 22,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TimeAndUnitInput.ion'
                                                                    },
                                                                    end: {
                                                                        line: 29,
                                                                        column: 31,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TimeAndUnitInput.ion'
                                                                    }
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        },
                                                        {
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'item',
                                                                    loc: {
                                                                        start: {
                                                                            line: 30,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TimeAndUnitInput.ion'
                                                                        },
                                                                        end: {
                                                                            line: 30,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TimeAndUnitInput.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'name',
                                                                    loc: {
                                                                        start: {
                                                                            line: 30,
                                                                            column: 21,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TimeAndUnitInput.ion'
                                                                        },
                                                                        end: {
                                                                            line: 30,
                                                                            column: 25,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/TimeAndUnitInput.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 30,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TimeAndUnitInput.ion'
                                                                    },
                                                                    end: {
                                                                        line: 30,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/TimeAndUnitInput.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 30,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TimeAndUnitInput.ion'
                                                                },
                                                                end: {
                                                                    line: 30,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/TimeAndUnitInput.ion'
                                                                }
                                                            },
                                                            order: '1'
                                                        }
                                                    ]
                                                },
                                                loc: {
                                                    start: {
                                                        line: 28,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/TimeAndUnitInput.ion'
                                                    },
                                                    end: {
                                                        line: 31,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'viewpath/html/TimeAndUnitInput.ion'
                                                    }
                                                },
                                                order: '0'
                                            }]
                                    },
                                    remove: null,
                                    order: '1'
                                }
                            ]
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'CallExpression',
                    callee: {
                        type: 'MemberExpression',
                        object: {
                            type: 'Identifier',
                            name: 'Object'
                        },
                        property: {
                            type: 'Identifier',
                            name: 'defineProperties'
                        }
                    },
                    arguments: [
                        {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Div',
                                    loc: {
                                        start: {
                                            line: 31,
                                            column: 11,
                                            fixed: true,
                                            source: 'viewpath/html/TimeAndUnitInput.ion'
                                        },
                                        end: {
                                            line: 31,
                                            column: 14,
                                            fixed: true,
                                            source: 'viewpath/html/TimeAndUnitInput.ion'
                                        }
                                    }
                                },
                                arguments: [],
                                loc: {
                                    start: {
                                        line: 31,
                                        column: 11,
                                        fixed: true,
                                        source: 'viewpath/html/TimeAndUnitInput.ion'
                                    },
                                    end: {
                                        line: 31,
                                        column: 16,
                                        fixed: true,
                                        source: 'viewpath/html/TimeAndUnitInput.ion'
                                    }
                                }
                            },
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'numberInput',
                                        loc: {
                                            start: {
                                                line: 32,
                                                column: 8,
                                                fixed: true,
                                                source: 'viewpath/html/TimeAndUnitInput.ion'
                                            },
                                            end: {
                                                line: 32,
                                                column: 19,
                                                fixed: true,
                                                source: 'viewpath/html/TimeAndUnitInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Identifier',
                                        name: 'numberInput',
                                        loc: {
                                            start: {
                                                line: 32,
                                                column: 21,
                                                fixed: true,
                                                source: 'viewpath/html/TimeAndUnitInput.ion'
                                            },
                                            end: {
                                                line: 32,
                                                column: 32,
                                                fixed: true,
                                                source: 'viewpath/html/TimeAndUnitInput.ion'
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'unitInput',
                                        loc: {
                                            start: {
                                                line: 33,
                                                column: 8,
                                                fixed: true,
                                                source: 'viewpath/html/TimeAndUnitInput.ion'
                                            },
                                            end: {
                                                line: 33,
                                                column: 17,
                                                fixed: true,
                                                source: 'viewpath/html/TimeAndUnitInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Identifier',
                                        name: 'unitInput',
                                        loc: {
                                            start: {
                                                line: 33,
                                                column: 19,
                                                fixed: true,
                                                source: 'viewpath/html/TimeAndUnitInput.ion'
                                            },
                                            end: {
                                                line: 33,
                                                column: 28,
                                                fixed: true,
                                                source: 'viewpath/html/TimeAndUnitInput.ion'
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '1'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'focus',
                                        loc: {
                                            start: {
                                                line: 34,
                                                column: 8,
                                                fixed: true,
                                                source: 'viewpath/html/TimeAndUnitInput.ion'
                                            },
                                            end: {
                                                line: 34,
                                                column: 13,
                                                fixed: true,
                                                source: 'viewpath/html/TimeAndUnitInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context3) {
                                            return function () {
                                                var numberInput = _context3.get('numberInput');
                                                numberInput.inputElement.focus();
                                            };
                                        }
                                    },
                                    kind: 'init',
                                    order: '2'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'select',
                                        loc: {
                                            start: {
                                                line: 36,
                                                column: 8,
                                                fixed: true,
                                                source: 'viewpath/html/TimeAndUnitInput.ion'
                                            },
                                            end: {
                                                line: 36,
                                                column: 14,
                                                fixed: true,
                                                source: 'viewpath/html/TimeAndUnitInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context4) {
                                            return function () {
                                                var numberInput = _context4.get('numberInput');
                                                numberInput.inputElement.select();
                                            };
                                        }
                                    },
                                    kind: 'init',
                                    order: '3'
                                },
                                {
                                    type: 'ExpressionStatement',
                                    expression: {
                                        type: 'ObjectExpression',
                                        objectType: {
                                            type: 'Identifier',
                                            name: 'numberInput',
                                            loc: {
                                                start: {
                                                    line: 38,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'viewpath/html/TimeAndUnitInput.ion'
                                                },
                                                end: {
                                                    line: 38,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'viewpath/html/TimeAndUnitInput.ion'
                                                }
                                            }
                                        },
                                        properties: [{
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'Identifier',
                                                    name: 'unitInput',
                                                    loc: {
                                                        start: {
                                                            line: 39,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/TimeAndUnitInput.ion'
                                                        },
                                                        end: {
                                                            line: 39,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'viewpath/html/TimeAndUnitInput.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 39,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/TimeAndUnitInput.ion'
                                                    },
                                                    end: {
                                                        line: 39,
                                                        column: 21,
                                                        fixed: true,
                                                        source: 'viewpath/html/TimeAndUnitInput.ion'
                                                    }
                                                },
                                                order: '0'
                                            }]
                                    },
                                    loc: {
                                        start: {
                                            line: 38,
                                            column: 8,
                                            fixed: true,
                                            source: 'viewpath/html/TimeAndUnitInput.ion'
                                        },
                                        end: {
                                            line: 40,
                                            column: 12,
                                            fixed: true,
                                            source: 'viewpath/html/TimeAndUnitInput.ion'
                                        }
                                    },
                                    order: '4'
                                }
                            ]
                        },
                        {
                            type: 'ObjectExpression',
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'label',
                                        loc: {
                                            start: {
                                                line: 40,
                                                column: 17,
                                                fixed: true,
                                                source: 'viewpath/html/TimeAndUnitInput.ion'
                                            },
                                            end: {
                                                line: 40,
                                                column: 22,
                                                fixed: true,
                                                source: 'viewpath/html/TimeAndUnitInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 41,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/TimeAndUnitInput.ion'
                                                        },
                                                        end: {
                                                            line: 41,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'viewpath/html/TimeAndUnitInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context5) {
                                                        return function () {
                                                            var numberInput = _context5.get('numberInput');
                                                            return numberInput.label;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 42,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/TimeAndUnitInput.ion'
                                                        },
                                                        end: {
                                                            line: 42,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'viewpath/html/TimeAndUnitInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context6) {
                                                        return function (value) {
                                                            var numberInput = _context6.get('numberInput');
                                                            return numberInput.label = value;
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'value',
                                        loc: {
                                            start: {
                                                line: 43,
                                                column: 17,
                                                fixed: true,
                                                source: 'viewpath/html/TimeAndUnitInput.ion'
                                            },
                                            end: {
                                                line: 43,
                                                column: 22,
                                                fixed: true,
                                                source: 'viewpath/html/TimeAndUnitInput.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'get',
                                                    loc: {
                                                        start: {
                                                            line: 44,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/TimeAndUnitInput.ion'
                                                        },
                                                        end: {
                                                            line: 44,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'viewpath/html/TimeAndUnitInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context7) {
                                                        return function () {
                                                            var numberInput = _context7.get('numberInput'), unitInput = _context7.get('unitInput');
                                                            var number = parseInt(numberInput.value);
                                                            var unit = unitInput.value;
                                                            return {
                                                                value: number,
                                                                unit: unit
                                                            };
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'set',
                                                    loc: {
                                                        start: {
                                                            line: 48,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/TimeAndUnitInput.ion'
                                                        },
                                                        end: {
                                                            line: 48,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'viewpath/html/TimeAndUnitInput.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_context8) {
                                                        return function (value) {
                                                            var numberInput = _context8.get('numberInput'), unitInput = _context8.get('unitInput');
                                                            if ((value != null ? value.length : void 0) === 1) {
                                                                numberInput.value = value;
                                                            } else {
                                                                numberInput.value = value.value;
                                                                unitInput.value = value.unit;
                                                            }
                                                        };
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    define: false,
                                    order: '1'
                                }
                            ]
                        }
                    ]
                },
                order: '3'
            }
        ],
        bound: false
    }, {
        this: this,
        attributes: attributes,
        _ref: _ref,
        TimeUnit: TimeUnit
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/TimeAndUnitInput',_viewpath_html_TimeAndUnitInput_);
    else
      _viewpath_html_TimeAndUnitInput_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_TimeAndUnitInput_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_UserAutoCompleteField_ = function(module,exports,require){'use strict';
var ion = require('ion');
var glass = require('glass'), _ref, _ref2;
_ref = glass.html.material;
var AutoCompleteField = _ref.AutoCompleteField;
var Checkbox = _ref.Checkbox;
var List = _ref.List;
var Icon = _ref.Icon;
var Field = _ref.Field;
var Img = _ref.Img;
_ref2 = require('../model');
var Project = _ref2.Project;
var Task = _ref2.Task;
module.exports = exports = ion.template(function (args) {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'assignedUserField',
                            loc: {
                                start: {
                                    line: 8,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/UserAutoCompleteField.ion'
                                },
                                end: {
                                    line: 8,
                                    column: 25,
                                    fixed: true,
                                    source: 'viewpath/html/UserAutoCompleteField.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'AutoCompleteField',
                                loc: {
                                    start: {
                                        line: 8,
                                        column: 28,
                                        fixed: true,
                                        source: 'viewpath/html/UserAutoCompleteField.ion'
                                    },
                                    end: {
                                        line: 8,
                                        column: 45,
                                        fixed: true,
                                        source: 'viewpath/html/UserAutoCompleteField.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ObjectExpression',
                                    properties: [
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'property',
                                                loc: {
                                                    start: {
                                                        line: 8,
                                                        column: 47,
                                                        fixed: true,
                                                        source: 'viewpath/html/UserAutoCompleteField.ion'
                                                    },
                                                    end: {
                                                        line: 8,
                                                        column: 55,
                                                        fixed: true,
                                                        source: 'viewpath/html/UserAutoCompleteField.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'Task',
                                                        loc: {
                                                            start: {
                                                                line: 8,
                                                                column: 56,
                                                                fixed: true,
                                                                source: 'viewpath/html/UserAutoCompleteField.ion'
                                                            },
                                                            end: {
                                                                line: 8,
                                                                column: 60,
                                                                fixed: true,
                                                                source: 'viewpath/html/UserAutoCompleteField.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'properties',
                                                        loc: {
                                                            start: {
                                                                line: 8,
                                                                column: 61,
                                                                fixed: true,
                                                                source: 'viewpath/html/UserAutoCompleteField.ion'
                                                            },
                                                            end: {
                                                                line: 8,
                                                                column: 71,
                                                                fixed: true,
                                                                source: 'viewpath/html/UserAutoCompleteField.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 8,
                                                            column: 56,
                                                            fixed: true,
                                                            source: 'viewpath/html/UserAutoCompleteField.ion'
                                                        },
                                                        end: {
                                                            line: 8,
                                                            column: 71,
                                                            fixed: true,
                                                            source: 'viewpath/html/UserAutoCompleteField.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'assigned',
                                                    loc: {
                                                        start: {
                                                            line: 8,
                                                            column: 72,
                                                            fixed: true,
                                                            source: 'viewpath/html/UserAutoCompleteField.ion'
                                                        },
                                                        end: {
                                                            line: 8,
                                                            column: 80,
                                                            fixed: true,
                                                            source: 'viewpath/html/UserAutoCompleteField.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 8,
                                                        column: 56,
                                                        fixed: true,
                                                        source: 'viewpath/html/UserAutoCompleteField.ion'
                                                    },
                                                    end: {
                                                        line: 8,
                                                        column: 80,
                                                        fixed: true,
                                                        source: 'viewpath/html/UserAutoCompleteField.ion'
                                                    }
                                                }
                                            },
                                            kind: 'init',
                                            order: '0'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'object',
                                                loc: {
                                                    start: {
                                                        line: 8,
                                                        column: 82,
                                                        fixed: true,
                                                        source: 'viewpath/html/UserAutoCompleteField.ion'
                                                    },
                                                    end: {
                                                        line: 8,
                                                        column: 88,
                                                        fixed: true,
                                                        source: 'viewpath/html/UserAutoCompleteField.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Identifier',
                                                name: 'task',
                                                loc: {
                                                    start: {
                                                        line: 8,
                                                        column: 89,
                                                        fixed: true,
                                                        source: 'viewpath/html/UserAutoCompleteField.ion'
                                                    },
                                                    end: {
                                                        line: 8,
                                                        column: 93,
                                                        fixed: true,
                                                        source: 'viewpath/html/UserAutoCompleteField.ion'
                                                    }
                                                }
                                            },
                                            kind: 'init',
                                            order: '1'
                                        }
                                    ]
                                }],
                            loc: {
                                start: {
                                    line: 8,
                                    column: 28,
                                    fixed: true,
                                    source: 'viewpath/html/UserAutoCompleteField.ion'
                                },
                                end: {
                                    line: 8,
                                    column: 95,
                                    fixed: true,
                                    source: 'viewpath/html/UserAutoCompleteField.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'ExpressionStatement',
                expression: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'Identifier',
                        name: 'assignedUserField',
                        loc: {
                            start: {
                                line: 9,
                                column: 4,
                                fixed: true,
                                source: 'viewpath/html/UserAutoCompleteField.ion'
                            },
                            end: {
                                line: 9,
                                column: 21,
                                fixed: true,
                                source: 'viewpath/html/UserAutoCompleteField.ion'
                            }
                        }
                    },
                    properties: [
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'Function',
                                context: false,
                                value: function change(e) {
                                    console.log('things they are a changin\'');
                                    task.assigned = this.value;
                                }
                            },
                            loc: {
                                start: {
                                    line: 10,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/UserAutoCompleteField.ion'
                                },
                                end: {
                                    line: 13,
                                    column: 12,
                                    fixed: true,
                                    source: 'viewpath/html/UserAutoCompleteField.ion'
                                }
                            },
                            order: '0'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'template',
                                loc: {
                                    start: {
                                        line: 13,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/html/UserAutoCompleteField.ion'
                                    },
                                    end: {
                                        line: 13,
                                        column: 16,
                                        fixed: true,
                                        source: 'viewpath/html/UserAutoCompleteField.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Identifier',
                                name: 'UserResult',
                                loc: {
                                    start: {
                                        line: 13,
                                        column: 18,
                                        fixed: true,
                                        source: 'viewpath/html/UserAutoCompleteField.ion'
                                    },
                                    end: {
                                        line: 13,
                                        column: 28,
                                        fixed: true,
                                        source: 'viewpath/html/UserAutoCompleteField.ion'
                                    }
                                }
                            },
                            kind: 'init',
                            order: '1'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'getValue',
                                loc: {
                                    start: {
                                        line: 14,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/html/UserAutoCompleteField.ion'
                                    },
                                    end: {
                                        line: 14,
                                        column: 16,
                                        fixed: true,
                                        source: 'viewpath/html/UserAutoCompleteField.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: false,
                                value: function (result) {
                                    return result.email;
                                }
                            },
                            kind: 'init',
                            order: '2'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'search',
                                loc: {
                                    start: {
                                        line: 16,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/html/UserAutoCompleteField.ion'
                                    },
                                    end: {
                                        line: 16,
                                        column: 14,
                                        fixed: true,
                                        source: 'viewpath/html/UserAutoCompleteField.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context) {
                                    return function (value) {
                                        var assignedUserField = _context.get('assignedUserField');
                                        var filteredUsers = filterUsers(value);
                                        assignedUserField.dispatchEvent(new CustomEvent('searchComplete', { detail: filteredUsers }));
                                    };
                                }
                            },
                            kind: 'init',
                            order: '3'
                        }
                    ]
                },
                loc: {
                    start: {
                        line: 9,
                        column: 4,
                        fixed: true,
                        source: 'viewpath/html/UserAutoCompleteField.ion'
                    },
                    end: {
                        line: 25,
                        column: 8,
                        fixed: true,
                        source: 'viewpath/html/UserAutoCompleteField.ion'
                    }
                },
                order: '1'
            }
        ],
        bound: false
    }, {
        this: this,
        args: args,
        glass: glass,
        _ref: _ref,
        _ref2: _ref2,
        AutoCompleteField: AutoCompleteField,
        Checkbox: Checkbox,
        List: List,
        Icon: Icon,
        Field: Field,
        Img: Img,
        Project: Project,
        Task: Task
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/UserAutoCompleteField',_viewpath_html_UserAutoCompleteField_);
    else
      _viewpath_html_UserAutoCompleteField_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_UserAutoCompleteField_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_UserChip_ = function(module,exports,require){'use strict';
var ion = require('ion');
var glass = require('glass'), _ref;
_ref = glass.html.material;
var Chip = _ref.Chip;
module.exports = exports = ion.template(function (_ref2) {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'user',
                            loc: {
                                start: {
                                    line: 5,
                                    column: 18,
                                    fixed: true,
                                    source: 'viewpath/html/UserChip.ion'
                                },
                                end: {
                                    line: 5,
                                    column: 22,
                                    fixed: true,
                                    source: 'viewpath/html/UserChip.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref2'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'user',
                                loc: {
                                    start: {
                                        line: 5,
                                        column: 18,
                                        fixed: true,
                                        source: 'viewpath/html/UserChip.ion'
                                    },
                                    end: {
                                        line: 5,
                                        column: 22,
                                        fixed: true,
                                        source: 'viewpath/html/UserChip.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'IfStatement',
                test: {
                    type: 'UnaryExpression',
                    operator: '?',
                    argument: {
                        type: 'Identifier',
                        name: 'user',
                        loc: {
                            start: {
                                line: 6,
                                column: 7,
                                fixed: true,
                                source: 'viewpath/html/UserChip.ion'
                            },
                            end: {
                                line: 6,
                                column: 11,
                                fixed: true,
                                source: 'viewpath/html/UserChip.ion'
                            }
                        }
                    }
                },
                consequent: {
                    type: 'BlockStatement',
                    body: [
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'userInitials',
                                        loc: {
                                            start: {
                                                line: 7,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/UserChip.ion'
                                            },
                                            end: {
                                                line: 7,
                                                column: 24,
                                                fixed: true,
                                                source: 'viewpath/html/UserChip.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'MemberExpression',
                                        computed: true,
                                        object: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'createdUser',
                                                loc: {
                                                    start: {
                                                        line: 7,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'viewpath/html/UserChip.ion'
                                                    },
                                                    end: {
                                                        line: 7,
                                                        column: 38,
                                                        fixed: true,
                                                        source: 'viewpath/html/UserChip.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'name',
                                                loc: {
                                                    start: {
                                                        line: 7,
                                                        column: 39,
                                                        fixed: true,
                                                        source: 'viewpath/html/UserChip.ion'
                                                    },
                                                    end: {
                                                        line: 7,
                                                        column: 43,
                                                        fixed: true,
                                                        source: 'viewpath/html/UserChip.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 7,
                                                    column: 27,
                                                    fixed: true,
                                                    source: 'viewpath/html/UserChip.ion'
                                                },
                                                end: {
                                                    line: 7,
                                                    column: 43,
                                                    fixed: true,
                                                    source: 'viewpath/html/UserChip.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Literal',
                                            value: 0
                                        },
                                        loc: {
                                            start: {
                                                line: 7,
                                                column: 27,
                                                fixed: true,
                                                source: 'viewpath/html/UserChip.ion'
                                            },
                                            end: {
                                                line: 7,
                                                column: 46,
                                                fixed: true,
                                                source: 'viewpath/html/UserChip.ion'
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '0'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'userChip',
                                        loc: {
                                            start: {
                                                line: 8,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/UserChip.ion'
                                            },
                                            end: {
                                                line: 8,
                                                column: 20,
                                                fixed: true,
                                                source: 'viewpath/html/UserChip.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'NewExpression',
                                        callee: {
                                            type: 'Identifier',
                                            name: 'Chip',
                                            loc: {
                                                start: {
                                                    line: 8,
                                                    column: 27,
                                                    fixed: true,
                                                    source: 'viewpath/html/UserChip.ion'
                                                },
                                                end: {
                                                    line: 8,
                                                    column: 31,
                                                    fixed: true,
                                                    source: 'viewpath/html/UserChip.ion'
                                                }
                                            }
                                        },
                                        arguments: [{
                                                type: 'ObjectExpression',
                                                properties: [
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'value',
                                                            loc: {
                                                                start: {
                                                                    line: 8,
                                                                    column: 33,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/UserChip.ion'
                                                                },
                                                                end: {
                                                                    line: 8,
                                                                    column: 38,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/UserChip.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Identifier',
                                                            name: 'user',
                                                            loc: {
                                                                start: {
                                                                    line: 8,
                                                                    column: 39,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/UserChip.ion'
                                                                },
                                                                end: {
                                                                    line: 8,
                                                                    column: 43,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/UserChip.ion'
                                                                }
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'text',
                                                            loc: {
                                                                start: {
                                                                    line: 8,
                                                                    column: 44,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/UserChip.ion'
                                                                },
                                                                end: {
                                                                    line: 8,
                                                                    column: 48,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/UserChip.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Identifier',
                                                            name: 'userInitials',
                                                            loc: {
                                                                start: {
                                                                    line: 8,
                                                                    column: 49,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/UserChip.ion'
                                                                },
                                                                end: {
                                                                    line: 8,
                                                                    column: 61,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/UserChip.ion'
                                                                }
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '1'
                                                    }
                                                ]
                                            }],
                                        loc: {
                                            start: {
                                                line: 8,
                                                column: 23,
                                                fixed: true,
                                                source: 'viewpath/html/UserChip.ion'
                                            },
                                            end: {
                                                line: 8,
                                                column: 63,
                                                fixed: true,
                                                source: 'viewpath/html/UserChip.ion'
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '1'
                        }
                    ]
                },
                alternate: null,
                order: '1'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'Identifier',
                    name: 'userChip',
                    loc: {
                        start: {
                            line: 9,
                            column: 11,
                            fixed: true,
                            source: 'viewpath/html/UserChip.ion'
                        },
                        end: {
                            line: 9,
                            column: 19,
                            fixed: true,
                            source: 'viewpath/html/UserChip.ion'
                        }
                    }
                },
                order: '2'
            }
        ],
        bound: false
    }, {
        this: this,
        _ref2: _ref2,
        glass: glass,
        _ref: _ref,
        Chip: Chip
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/UserChip',_viewpath_html_UserChip_);
    else
      _viewpath_html_UserChip_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_UserChip_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_UserItem_ = function(module,exports,require){'use strict';
var ion = require('ion');
var glass = require('glass');
module.exports = exports = ion.template(function (_ref) {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'User',
                            loc: {
                                start: {
                                    line: 5,
                                    column: 18,
                                    fixed: true,
                                    source: 'viewpath/html/UserItem.ion'
                                },
                                end: {
                                    line: 5,
                                    column: 22,
                                    fixed: true,
                                    source: 'viewpath/html/UserItem.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'User',
                                loc: {
                                    start: {
                                        line: 5,
                                        column: 18,
                                        fixed: true,
                                        source: 'viewpath/html/UserItem.ion'
                                    },
                                    end: {
                                        line: 5,
                                        column: 22,
                                        fixed: true,
                                        source: 'viewpath/html/UserItem.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'CallExpression',
                    callee: {
                        type: 'Identifier',
                        name: 'Li',
                        loc: {
                            start: {
                                line: 6,
                                column: 11,
                                fixed: true,
                                source: 'viewpath/html/UserItem.ion'
                            },
                            end: {
                                line: 6,
                                column: 13,
                                fixed: true,
                                source: 'viewpath/html/UserItem.ion'
                            }
                        }
                    },
                    arguments: [],
                    loc: {
                        start: {
                            line: 6,
                            column: 11,
                            fixed: true,
                            source: 'viewpath/html/UserItem.ion'
                        },
                        end: {
                            line: 6,
                            column: 15,
                            fixed: true,
                            source: 'viewpath/html/UserItem.ion'
                        }
                    }
                },
                order: '1'
            }
        ],
        bound: false
    }, {
        this: this,
        _ref: _ref,
        glass: glass
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/UserItem',_viewpath_html_UserItem_);
    else
      _viewpath_html_UserItem_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_UserItem_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_UserOrgAcceptedProperty_ = function(module,exports,require){'use strict';
module.exports = exports = function UserOrgAcceptedProperty(org) {
    return {
        get: function () {
            return this.orgs != null ? this.orgs[org.id] != null ? this.orgs[org.id].accepted : void 0 : void 0;
        },
        set: function (value) {
            return;
        },
        visible: true,
        name: 'accepted',
        type: 'boolean',
        editable: false,
        required: false
    };
};
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/UserOrgAcceptedProperty',_viewpath_html_UserOrgAcceptedProperty_);
    else
      _viewpath_html_UserOrgAcceptedProperty_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_UserOrgAcceptedProperty_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_UserOrgCalendarsProperty_ = function(module,exports,require){'use strict';
var ion = require('ion'), glass = require('glass'), _ref, _ref2;
_ref = glass.data;
var Key = _ref.Key;
_ref2 = require('../model');
var Project = _ref2.Project;
var ProjectType = _ref2.ProjectType;
module.exports = exports = function UserOrgCalendarsProperty(org) {
    return {
        get: function () {
            return this.orgs != null ? this.orgs[org.id] != null ? this.orgs[org.id].calendars : void 0 : void 0;
        },
        set: function (value) {
            this.orgs = this.orgs != null ? this.orgs : {};
            this.orgs[org.id] = this.orgs[org.id] != null ? this.orgs[org.id] : {};
            this.orgs[org.id].calendars = value;
            this.touch();
        },
        name: 'calendars',
        type: 'object',
        required: false,
        foreign: {
            type: 'Project',
            getSearchKeys: function (record, text) {
                var key = new Key(Project, {
                        where: {
                            orgId: org.id,
                            type: ProjectType.Calendar.id.valueOf()
                        },
                        sort: [{ name: true }]
                    });
                return [key.toString()];
            }
        }
    };
};
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/UserOrgCalendarsProperty',_viewpath_html_UserOrgCalendarsProperty_);
    else
      _viewpath_html_UserOrgCalendarsProperty_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_UserOrgCalendarsProperty_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_UserOrgInvitedProperty_ = function(module,exports,require){'use strict';
module.exports = exports = function UserOrgInvitedProperty(org) {
    return {
        get: function () {
            return this.orgs != null ? this.orgs[org.id] != null ? this.orgs[org.id].invited : void 0 : void 0;
        },
        set: function (value) {
            return;
        },
        visible: true,
        name: 'invited',
        type: 'date-time',
        format: 'date-time',
        required: false
    };
};
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/UserOrgInvitedProperty',_viewpath_html_UserOrgInvitedProperty_);
    else
      _viewpath_html_UserOrgInvitedProperty_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_UserOrgInvitedProperty_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_UserOrgTagsProperty_ = function(module,exports,require){'use strict';
var ion = require('ion'), glass = require('glass'), _ref;
_ref = glass.data;
var Key = _ref.Key;
module.exports = exports = function UserOrgTagsProperty(org) {
    return {
        get: function () {
            return this.orgs != null ? this.orgs[org.id] != null ? this.orgs[org.id].tags : void 0 : void 0;
        },
        set: function (value) {
            this.orgs = this.orgs != null ? this.orgs : {};
            this.orgs[org.id] = this.orgs[org.id] != null ? this.orgs[org.id] : {};
            this.orgs[org.id].tags = value;
            this.touch();
        },
        notFoundMessage: 'Tag does not yet exist. Contact your Viewpath Administrator to add the tag.',
        name: 'tags',
        type: 'object',
        required: false,
        foreign: {
            type: 'Tag',
            getSearchKeys: function (record, text) {
                var tagsKey = new Key(org.getKey(), ['tags'], {
                        where: { user: true },
                        sort: [{ name: true }]
                    });
                return [tagsKey.toString()];
            },
            getSource: ion.template(function (_ref2) {
                return ion.createRuntime({
                    type: 'Template',
                    id: null,
                    body: [
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'server',
                                        loc: {
                                            start: {
                                                line: 24,
                                                column: 34,
                                                fixed: true,
                                                source: 'viewpath/html/UserOrgTagsProperty.ion'
                                            },
                                            end: {
                                                line: 24,
                                                column: 40,
                                                fixed: true,
                                                source: 'viewpath/html/UserOrgTagsProperty.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'MemberExpression',
                                        object: {
                                            type: 'Identifier',
                                            name: '_ref2'
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'server',
                                            loc: {
                                                start: {
                                                    line: 24,
                                                    column: 34,
                                                    fixed: true,
                                                    source: 'viewpath/html/UserOrgTagsProperty.ion'
                                                },
                                                end: {
                                                    line: 24,
                                                    column: 40,
                                                    fixed: true,
                                                    source: 'viewpath/html/UserOrgTagsProperty.ion'
                                                }
                                            }
                                        },
                                        computed: false
                                    }
                                }],
                            kind: 'let',
                            order: '0'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'record',
                                        loc: {
                                            start: {
                                                line: 24,
                                                column: 42,
                                                fixed: true,
                                                source: 'viewpath/html/UserOrgTagsProperty.ion'
                                            },
                                            end: {
                                                line: 24,
                                                column: 48,
                                                fixed: true,
                                                source: 'viewpath/html/UserOrgTagsProperty.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'MemberExpression',
                                        object: {
                                            type: 'Identifier',
                                            name: '_ref2'
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'record',
                                            loc: {
                                                start: {
                                                    line: 24,
                                                    column: 42,
                                                    fixed: true,
                                                    source: 'viewpath/html/UserOrgTagsProperty.ion'
                                                },
                                                end: {
                                                    line: 24,
                                                    column: 48,
                                                    fixed: true,
                                                    source: 'viewpath/html/UserOrgTagsProperty.ion'
                                                }
                                            }
                                        },
                                        computed: false
                                    }
                                }],
                            kind: 'let',
                            order: '1'
                        },
                        {
                            type: 'ReturnStatement',
                            argument: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'org',
                                    loc: {
                                        start: {
                                            line: 24,
                                            column: 54,
                                            fixed: true,
                                            source: 'viewpath/html/UserOrgTagsProperty.ion'
                                        },
                                        end: {
                                            line: 24,
                                            column: 57,
                                            fixed: true,
                                            source: 'viewpath/html/UserOrgTagsProperty.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'tags',
                                    loc: {
                                        start: {
                                            line: 24,
                                            column: 59,
                                            fixed: true,
                                            source: 'viewpath/html/UserOrgTagsProperty.ion'
                                        },
                                        end: {
                                            line: 24,
                                            column: 63,
                                            fixed: true,
                                            source: 'viewpath/html/UserOrgTagsProperty.ion'
                                        }
                                    }
                                },
                                existential: true,
                                loc: {
                                    start: {
                                        line: 24,
                                        column: 54,
                                        fixed: true,
                                        source: 'viewpath/html/UserOrgTagsProperty.ion'
                                    },
                                    end: {
                                        line: 24,
                                        column: 63,
                                        fixed: true,
                                        source: 'viewpath/html/UserOrgTagsProperty.ion'
                                    }
                                }
                            },
                            order: '2'
                        }
                    ],
                    bound: false,
                    name: {
                        type: 'Identifier',
                        name: 'getSource',
                        loc: {
                            start: {
                                line: 24,
                                column: 12,
                                fixed: true,
                                source: 'viewpath/html/UserOrgTagsProperty.ion'
                            },
                            end: {
                                line: 24,
                                column: 21,
                                fixed: true,
                                source: 'viewpath/html/UserOrgTagsProperty.ion'
                            }
                        }
                    }
                }, {
                    this: this,
                    _ref2: _ref2,
                    org: org,
                    ion: ion,
                    glass: glass,
                    _ref: _ref,
                    Key: Key
                }, null);
            })
        }
    };
};
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/UserOrgTagsProperty',_viewpath_html_UserOrgTagsProperty_);
    else
      _viewpath_html_UserOrgTagsProperty_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_UserOrgTagsProperty_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_UserResult_ = function(module,exports,require){'use strict';
var ion = require('ion');
var glass = require('glass');
module.exports = exports = ion.template(function (_ref) {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'result',
                            loc: {
                                start: {
                                    line: 14,
                                    column: 18,
                                    fixed: true,
                                    source: 'viewpath/html/UserResult.ion'
                                },
                                end: {
                                    line: 14,
                                    column: 24,
                                    fixed: true,
                                    source: 'viewpath/html/UserResult.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'result',
                                loc: {
                                    start: {
                                        line: 14,
                                        column: 18,
                                        fixed: true,
                                        source: 'viewpath/html/UserResult.ion'
                                    },
                                    end: {
                                        line: 14,
                                        column: 24,
                                        fixed: true,
                                        source: 'viewpath/html/UserResult.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'value',
                            loc: {
                                start: {
                                    line: 14,
                                    column: 26,
                                    fixed: true,
                                    source: 'viewpath/html/UserResult.ion'
                                },
                                end: {
                                    line: 14,
                                    column: 31,
                                    fixed: true,
                                    source: 'viewpath/html/UserResult.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'value',
                                loc: {
                                    start: {
                                        line: 14,
                                        column: 26,
                                        fixed: true,
                                        source: 'viewpath/html/UserResult.ion'
                                    },
                                    end: {
                                        line: 14,
                                        column: 31,
                                        fixed: true,
                                        source: 'viewpath/html/UserResult.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'highlightedString',
                            loc: {
                                start: {
                                    line: 15,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/UserResult.ion'
                                },
                                end: {
                                    line: 15,
                                    column: 25,
                                    fixed: true,
                                    source: 'viewpath/html/UserResult.ion'
                                }
                            }
                        },
                        init: {
                            type: 'Function',
                            context: true,
                            value: function (_context) {
                                return function (str, val) {
                                    var value = _context.get('value'), ion = _context.get('ion');
                                    var valLen = value.length;
                                    var strLen = str.length;
                                    var idx = str.indexOf(val);
                                    console.log('idx');
                                    console.log(idx);
                                    if (valLen < 1 && strLen < 1) {
                                        return str;
                                    }
                                    if (idx > -1) {
                                        console.log('IDX > -1');
                                        if (valLen === strLen) {
                                            var _ref2 = Span({ class: 'highlight' });
                                            ion.add(_ref2, str);
                                            return _ref2;
                                        } else if (idx > 0) {
                                            if (idx + valLen - 1 === strLen) {
                                                var _ref3 = Span();
                                                {
                                                    ion.add(_ref3, str.substring(0, idx));
                                                    var _ref4 = Span({ class: 'highlight' });
                                                    ion.add(_ref4, str.substring(idx, valLen));
                                                    ion.add(_ref3, _ref4);
                                                }
                                                return _ref3;
                                            } else {
                                                console.log('MIDDLE MATCH');
                                                var _ref5 = Span();
                                                {
                                                    ion.add(_ref5, str.substring(0, idx));
                                                    var _ref6 = Span({ class: 'highlight' });
                                                    {
                                                        ion.add(_ref6, console.log('the IDX is...'));
                                                        ion.add(_ref6, console.log(idx));
                                                        ion.add(_ref6, str.substring(idx, valLen));
                                                    }
                                                    ion.add(_ref5, _ref6);
                                                    ion.add(_ref5, str.substring(idx + valLen, strLen - valLen - idx));
                                                }
                                                return _ref5;
                                            }
                                        } else if (idx === 0) {
                                            var _ref7 = Span();
                                            {
                                                var _ref8 = Span({ class: 'highlight' });
                                                ion.add(_ref8, str.substring(0, valLen));
                                                ion.add(_ref7, _ref8);
                                                ion.add(_ref7, str.substring(valLen));
                                            }
                                            return _ref7;
                                        }
                                    } else {
                                        return str;
                                    }
                                };
                            }
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'CallExpression',
                        callee: {
                            type: 'Identifier',
                            name: 'Div',
                            loc: {
                                start: {
                                    line: 59,
                                    column: 11,
                                    fixed: true,
                                    source: 'viewpath/html/UserResult.ion'
                                },
                                end: {
                                    line: 59,
                                    column: 14,
                                    fixed: true,
                                    source: 'viewpath/html/UserResult.ion'
                                }
                            }
                        },
                        arguments: [{
                                type: 'ObjectExpression',
                                properties: [{
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'class',
                                            loc: {
                                                start: {
                                                    line: 59,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/UserResult.ion'
                                                },
                                                end: {
                                                    line: 59,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'viewpath/html/UserResult.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: 'user-result'
                                        },
                                        kind: 'init',
                                        order: '0'
                                    }]
                            }],
                        loc: {
                            start: {
                                line: 59,
                                column: 11,
                                fixed: true,
                                source: 'viewpath/html/UserResult.ion'
                            },
                            end: {
                                line: 59,
                                column: 37,
                                fixed: true,
                                source: 'viewpath/html/UserResult.ion'
                            }
                        }
                    },
                    properties: [{
                            type: 'IfStatement',
                            test: {
                                type: 'UnaryExpression',
                                operator: '?',
                                argument: {
                                    type: 'Identifier',
                                    name: 'result',
                                    loc: {
                                        start: {
                                            line: 60,
                                            column: 11,
                                            fixed: true,
                                            source: 'viewpath/html/UserResult.ion'
                                        },
                                        end: {
                                            line: 60,
                                            column: 17,
                                            fixed: true,
                                            source: 'viewpath/html/UserResult.ion'
                                        }
                                    }
                                }
                            },
                            consequent: {
                                type: 'BlockStatement',
                                body: [
                                    {
                                        type: 'VariableDeclaration',
                                        declarations: [{
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'user',
                                                    loc: {
                                                        start: {
                                                            line: 61,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/UserResult.ion'
                                                        },
                                                        end: {
                                                            line: 61,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'viewpath/html/UserResult.ion'
                                                        }
                                                    }
                                                },
                                                init: {
                                                    type: 'Identifier',
                                                    name: 'result',
                                                    loc: {
                                                        start: {
                                                            line: 61,
                                                            column: 23,
                                                            fixed: true,
                                                            source: 'viewpath/html/UserResult.ion'
                                                        },
                                                        end: {
                                                            line: 61,
                                                            column: 29,
                                                            fixed: true,
                                                            source: 'viewpath/html/UserResult.ion'
                                                        }
                                                    }
                                                }
                                            }],
                                        kind: 'let',
                                        order: '0'
                                    },
                                    {
                                        type: 'IfStatement',
                                        test: {
                                            type: 'UnaryExpression',
                                            operator: '?',
                                            argument: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'user',
                                                    loc: {
                                                        start: {
                                                            line: 62,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'viewpath/html/UserResult.ion'
                                                        },
                                                        end: {
                                                            line: 62,
                                                            column: 19,
                                                            fixed: true,
                                                            source: 'viewpath/html/UserResult.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'name',
                                                    loc: {
                                                        start: {
                                                            line: 62,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'viewpath/html/UserResult.ion'
                                                        },
                                                        end: {
                                                            line: 62,
                                                            column: 24,
                                                            fixed: true,
                                                            source: 'viewpath/html/UserResult.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 62,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'viewpath/html/UserResult.ion'
                                                    },
                                                    end: {
                                                        line: 62,
                                                        column: 24,
                                                        fixed: true,
                                                        source: 'viewpath/html/UserResult.ion'
                                                    }
                                                }
                                            }
                                        },
                                        consequent: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'H1',
                                                                loc: {
                                                                    start: {
                                                                        line: 63,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/UserResult.ion'
                                                                    },
                                                                    end: {
                                                                        line: 63,
                                                                        column: 18,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/UserResult.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [{
                                                                    type: 'ObjectExpression',
                                                                    properties: [{
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'class',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 63,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/UserResult.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 63,
                                                                                        column: 25,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/UserResult.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'user-name black'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        }]
                                                                }],
                                                            loc: {
                                                                start: {
                                                                    line: 63,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/UserResult.ion'
                                                                },
                                                                end: {
                                                                    line: 63,
                                                                    column: 45,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/UserResult.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [{
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'user',
                                                                        loc: {
                                                                            start: {
                                                                                line: 64,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/UserResult.ion'
                                                                            },
                                                                            end: {
                                                                                line: 64,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/UserResult.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'name',
                                                                        loc: {
                                                                            start: {
                                                                                line: 64,
                                                                                column: 25,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/UserResult.ion'
                                                                            },
                                                                            end: {
                                                                                line: 64,
                                                                                column: 29,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/UserResult.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 64,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/UserResult.ion'
                                                                        },
                                                                        end: {
                                                                            line: 64,
                                                                            column: 29,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/UserResult.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 64,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/UserResult.ion'
                                                                    },
                                                                    end: {
                                                                        line: 64,
                                                                        column: 29,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/UserResult.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 63,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/UserResult.ion'
                                                        },
                                                        end: {
                                                            line: 66,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'viewpath/html/UserResult.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        alternate: null,
                                        order: '1'
                                    },
                                    {
                                        type: 'IfStatement',
                                        test: {
                                            type: 'UnaryExpression',
                                            operator: '?',
                                            argument: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'user',
                                                    loc: {
                                                        start: {
                                                            line: 66,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'viewpath/html/UserResult.ion'
                                                        },
                                                        end: {
                                                            line: 66,
                                                            column: 19,
                                                            fixed: true,
                                                            source: 'viewpath/html/UserResult.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'email',
                                                    loc: {
                                                        start: {
                                                            line: 66,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'viewpath/html/UserResult.ion'
                                                        },
                                                        end: {
                                                            line: 66,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'viewpath/html/UserResult.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 66,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'viewpath/html/UserResult.ion'
                                                    },
                                                    end: {
                                                        line: 66,
                                                        column: 25,
                                                        fixed: true,
                                                        source: 'viewpath/html/UserResult.ion'
                                                    }
                                                }
                                            }
                                        },
                                        consequent: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'H2',
                                                                loc: {
                                                                    start: {
                                                                        line: 67,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/UserResult.ion'
                                                                    },
                                                                    end: {
                                                                        line: 67,
                                                                        column: 18,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/UserResult.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [{
                                                                    type: 'ObjectExpression',
                                                                    properties: [{
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'class',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 67,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/UserResult.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 67,
                                                                                        column: 25,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/UserResult.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'user-email black secondary'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        }]
                                                                }],
                                                            loc: {
                                                                start: {
                                                                    line: 67,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/UserResult.ion'
                                                                },
                                                                end: {
                                                                    line: 67,
                                                                    column: 56,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/UserResult.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [{
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'user',
                                                                        loc: {
                                                                            start: {
                                                                                line: 68,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/UserResult.ion'
                                                                            },
                                                                            end: {
                                                                                line: 68,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/UserResult.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'email',
                                                                        loc: {
                                                                            start: {
                                                                                line: 68,
                                                                                column: 25,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/UserResult.ion'
                                                                            },
                                                                            end: {
                                                                                line: 68,
                                                                                column: 30,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/UserResult.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 68,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/UserResult.ion'
                                                                        },
                                                                        end: {
                                                                            line: 68,
                                                                            column: 30,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/UserResult.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 68,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/UserResult.ion'
                                                                    },
                                                                    end: {
                                                                        line: 68,
                                                                        column: 30,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/UserResult.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 67,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/UserResult.ion'
                                                        },
                                                        end: {
                                                            line: 70,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'viewpath/html/UserResult.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        alternate: null,
                                        order: '2'
                                    }
                                ]
                            },
                            alternate: null,
                            order: '0'
                        }]
                },
                order: '3'
            }
        ],
        bound: false
    }, {
        this: this,
        ion: ion,
        _ref: _ref,
        glass: glass
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/UserResult',_viewpath_html_UserResult_);
    else
      _viewpath_html_UserResult_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_UserResult_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_UserRowContent_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('./'), glass = require('glass'), _ref2, _ref3, _ref4, DataTable = glass.html.material.DataTable2, _ref5;
var UserOrgTagsProperty = _ref.UserOrgTagsProperty;
_ref2 = glass.data;
var Key = _ref2.Key;
_ref3 = glass.html;
var style = _ref3.style;
_ref4 = glass.html.material;
var RecordChip = _ref4.RecordChip;
_ref5 = require('../model');
var User = _ref5.User;
var Tag = _ref5.Tag;
var _ref11 = style.sheets;
_ref11[module.id] = '.subheader {\n    font-size: 12px;\n    color: rgba(0,0,0,0.54);\n    font-weight: 500;\n    padding: 16px;\n}';
_ref11;
var UserRow = ion.template(function (_ref6) {
        return ion.createRuntime({
            type: 'Template',
            id: null,
            body: [
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'key',
                                loc: {
                                    start: {
                                        line: 19,
                                        column: 27,
                                        fixed: true,
                                        source: 'viewpath/html/UserRowContent.ion'
                                    },
                                    end: {
                                        line: 19,
                                        column: 30,
                                        fixed: true,
                                        source: 'viewpath/html/UserRowContent.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref6'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'key',
                                    loc: {
                                        start: {
                                            line: 19,
                                            column: 27,
                                            fixed: true,
                                            source: 'viewpath/html/UserRowContent.ion'
                                        },
                                        end: {
                                            line: 19,
                                            column: 30,
                                            fixed: true,
                                            source: 'viewpath/html/UserRowContent.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '0'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'user',
                                loc: {
                                    start: {
                                        line: 19,
                                        column: 32,
                                        fixed: true,
                                        source: 'viewpath/html/UserRowContent.ion'
                                    },
                                    end: {
                                        line: 19,
                                        column: 36,
                                        fixed: true,
                                        source: 'viewpath/html/UserRowContent.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref6'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'user',
                                    loc: {
                                        start: {
                                            line: 19,
                                            column: 32,
                                            fixed: true,
                                            source: 'viewpath/html/UserRowContent.ion'
                                        },
                                        end: {
                                            line: 19,
                                            column: 36,
                                            fixed: true,
                                            source: 'viewpath/html/UserRowContent.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '1'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'record',
                                loc: {
                                    start: {
                                        line: 19,
                                        column: 38,
                                        fixed: true,
                                        source: 'viewpath/html/UserRowContent.ion'
                                    },
                                    end: {
                                        line: 19,
                                        column: 44,
                                        fixed: true,
                                        source: 'viewpath/html/UserRowContent.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref6'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'record',
                                    loc: {
                                        start: {
                                            line: 19,
                                            column: 38,
                                            fixed: true,
                                            source: 'viewpath/html/UserRowContent.ion'
                                        },
                                        end: {
                                            line: 19,
                                            column: 44,
                                            fixed: true,
                                            source: 'viewpath/html/UserRowContent.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '2'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'dataTableModel',
                                loc: {
                                    start: {
                                        line: 19,
                                        column: 46,
                                        fixed: true,
                                        source: 'viewpath/html/UserRowContent.ion'
                                    },
                                    end: {
                                        line: 19,
                                        column: 60,
                                        fixed: true,
                                        source: 'viewpath/html/UserRowContent.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref6'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'dataTableModel',
                                    loc: {
                                        start: {
                                            line: 19,
                                            column: 46,
                                            fixed: true,
                                            source: 'viewpath/html/UserRowContent.ion'
                                        },
                                        end: {
                                            line: 19,
                                            column: 60,
                                            fixed: true,
                                            source: 'viewpath/html/UserRowContent.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '3'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'tagsColumn',
                                loc: {
                                    start: {
                                        line: 19,
                                        column: 62,
                                        fixed: true,
                                        source: 'viewpath/html/UserRowContent.ion'
                                    },
                                    end: {
                                        line: 19,
                                        column: 72,
                                        fixed: true,
                                        source: 'viewpath/html/UserRowContent.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref6'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'tagsColumn',
                                    loc: {
                                        start: {
                                            line: 19,
                                            column: 62,
                                            fixed: true,
                                            source: 'viewpath/html/UserRowContent.ion'
                                        },
                                        end: {
                                            line: 19,
                                            column: 72,
                                            fixed: true,
                                            source: 'viewpath/html/UserRowContent.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '4'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'add',
                                loc: {
                                    start: {
                                        line: 19,
                                        column: 74,
                                        fixed: true,
                                        source: 'viewpath/html/UserRowContent.ion'
                                    },
                                    end: {
                                        line: 19,
                                        column: 77,
                                        fixed: true,
                                        source: 'viewpath/html/UserRowContent.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref6'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'add',
                                    loc: {
                                        start: {
                                            line: 19,
                                            column: 74,
                                            fixed: true,
                                            source: 'viewpath/html/UserRowContent.ion'
                                        },
                                        end: {
                                            line: 19,
                                            column: 77,
                                            fixed: true,
                                            source: 'viewpath/html/UserRowContent.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '5'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'userRowModel',
                                loc: {
                                    start: {
                                        line: 20,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/html/UserRowContent.ion'
                                    },
                                    end: {
                                        line: 20,
                                        column: 20,
                                        fixed: true,
                                        source: 'viewpath/html/UserRowContent.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'ObjectExpression',
                                properties: [
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'key',
                                            loc: {
                                                start: {
                                                    line: 20,
                                                    column: 24,
                                                    fixed: true,
                                                    source: 'viewpath/html/UserRowContent.ion'
                                                },
                                                end: {
                                                    line: 20,
                                                    column: 27,
                                                    fixed: true,
                                                    source: 'viewpath/html/UserRowContent.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Identifier',
                                            name: 'key',
                                            loc: {
                                                start: {
                                                    line: 20,
                                                    column: 24,
                                                    fixed: true,
                                                    source: 'viewpath/html/UserRowContent.ion'
                                                },
                                                end: {
                                                    line: 20,
                                                    column: 27,
                                                    fixed: true,
                                                    source: 'viewpath/html/UserRowContent.ion'
                                                }
                                            }
                                        },
                                        kind: 'init',
                                        order: '0'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'record',
                                            loc: {
                                                start: {
                                                    line: 20,
                                                    column: 29,
                                                    fixed: true,
                                                    source: 'viewpath/html/UserRowContent.ion'
                                                },
                                                end: {
                                                    line: 20,
                                                    column: 35,
                                                    fixed: true,
                                                    source: 'viewpath/html/UserRowContent.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Identifier',
                                            name: 'user',
                                            loc: {
                                                start: {
                                                    line: 20,
                                                    column: 37,
                                                    fixed: true,
                                                    source: 'viewpath/html/UserRowContent.ion'
                                                },
                                                end: {
                                                    line: 20,
                                                    column: 41,
                                                    fixed: true,
                                                    source: 'viewpath/html/UserRowContent.ion'
                                                }
                                            }
                                        },
                                        kind: 'init',
                                        order: '1'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'dataTableModel',
                                            loc: {
                                                start: {
                                                    line: 20,
                                                    column: 43,
                                                    fixed: true,
                                                    source: 'viewpath/html/UserRowContent.ion'
                                                },
                                                end: {
                                                    line: 20,
                                                    column: 57,
                                                    fixed: true,
                                                    source: 'viewpath/html/UserRowContent.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Identifier',
                                            name: 'dataTableModel',
                                            loc: {
                                                start: {
                                                    line: 20,
                                                    column: 43,
                                                    fixed: true,
                                                    source: 'viewpath/html/UserRowContent.ion'
                                                },
                                                end: {
                                                    line: 20,
                                                    column: 57,
                                                    fixed: true,
                                                    source: 'viewpath/html/UserRowContent.ion'
                                                }
                                            }
                                        },
                                        kind: 'init',
                                        order: '2'
                                    }
                                ]
                            }
                        }],
                    kind: 'let',
                    order: '6'
                },
                {
                    type: 'ReturnStatement',
                    argument: {
                        type: 'ObjectExpression',
                        objectType: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Div',
                                loc: {
                                    start: {
                                        line: 21,
                                        column: 11,
                                        fixed: true,
                                        source: 'viewpath/html/UserRowContent.ion'
                                    },
                                    end: {
                                        line: 21,
                                        column: 14,
                                        fixed: true,
                                        source: 'viewpath/html/UserRowContent.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ObjectExpression',
                                    properties: [{
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'class',
                                                loc: {
                                                    start: {
                                                        line: 21,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'viewpath/html/UserRowContent.ion'
                                                    },
                                                    end: {
                                                        line: 21,
                                                        column: 21,
                                                        fixed: true,
                                                        source: 'viewpath/html/UserRowContent.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: 'cells'
                                            },
                                            kind: 'init',
                                            order: '0'
                                        }]
                                }],
                            loc: {
                                start: {
                                    line: 21,
                                    column: 11,
                                    fixed: true,
                                    source: 'viewpath/html/UserRowContent.ion'
                                },
                                end: {
                                    line: 21,
                                    column: 31,
                                    fixed: true,
                                    source: 'viewpath/html/UserRowContent.ion'
                                }
                            }
                        },
                        properties: [{
                                type: 'ForOfStatement',
                                left: {
                                    type: 'VariableDeclaration',
                                    declarations: [{
                                            type: 'VariableDeclarator',
                                            id: {
                                                type: 'Identifier',
                                                name: 'column',
                                                loc: {
                                                    start: {
                                                        line: 22,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/UserRowContent.ion'
                                                    },
                                                    end: {
                                                        line: 22,
                                                        column: 18,
                                                        fixed: true,
                                                        source: 'viewpath/html/UserRowContent.ion'
                                                    }
                                                }
                                            },
                                            init: null
                                        }],
                                    kind: 'let'
                                },
                                right: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'dataTableModel',
                                        loc: {
                                            start: {
                                                line: 22,
                                                column: 22,
                                                fixed: true,
                                                source: 'viewpath/html/UserRowContent.ion'
                                            },
                                            end: {
                                                line: 22,
                                                column: 36,
                                                fixed: true,
                                                source: 'viewpath/html/UserRowContent.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'columns',
                                        loc: {
                                            start: {
                                                line: 22,
                                                column: 37,
                                                fixed: true,
                                                source: 'viewpath/html/UserRowContent.ion'
                                            },
                                            end: {
                                                line: 22,
                                                column: 44,
                                                fixed: true,
                                                source: 'viewpath/html/UserRowContent.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 22,
                                            column: 22,
                                            fixed: true,
                                            source: 'viewpath/html/UserRowContent.ion'
                                        },
                                        end: {
                                            line: 22,
                                            column: 44,
                                            fixed: true,
                                            source: 'viewpath/html/UserRowContent.ion'
                                        }
                                    }
                                },
                                body: {
                                    type: 'BlockStatement',
                                    body: [{
                                            type: 'IfStatement',
                                            test: {
                                                type: 'BinaryExpression',
                                                operator: '===',
                                                left: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'column',
                                                        loc: {
                                                            start: {
                                                                line: 24,
                                                                column: 15,
                                                                fixed: true,
                                                                source: 'viewpath/html/UserRowContent.ion'
                                                            },
                                                            end: {
                                                                line: 24,
                                                                column: 21,
                                                                fixed: true,
                                                                source: 'viewpath/html/UserRowContent.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'name',
                                                        loc: {
                                                            start: {
                                                                line: 24,
                                                                column: 22,
                                                                fixed: true,
                                                                source: 'viewpath/html/UserRowContent.ion'
                                                            },
                                                            end: {
                                                                line: 24,
                                                                column: 26,
                                                                fixed: true,
                                                                source: 'viewpath/html/UserRowContent.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 24,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'viewpath/html/UserRowContent.ion'
                                                        },
                                                        end: {
                                                            line: 24,
                                                            column: 26,
                                                            fixed: true,
                                                            source: 'viewpath/html/UserRowContent.ion'
                                                        }
                                                    }
                                                },
                                                right: {
                                                    type: 'Literal',
                                                    value: 'tags'
                                                }
                                            },
                                            consequent: {
                                                type: 'BlockStatement',
                                                body: [{
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'tagsColumn',
                                                                    loc: {
                                                                        start: {
                                                                            line: 25,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                        },
                                                                        end: {
                                                                            line: 25,
                                                                            column: 26,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'createBodyCell',
                                                                    loc: {
                                                                        start: {
                                                                            line: 25,
                                                                            column: 27,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                        },
                                                                        end: {
                                                                            line: 25,
                                                                            column: 41,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 25,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                    },
                                                                    end: {
                                                                        line: 25,
                                                                        column: 41,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [{
                                                                    type: 'Identifier',
                                                                    name: 'userRowModel',
                                                                    loc: {
                                                                        start: {
                                                                            line: 25,
                                                                            column: 42,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                        },
                                                                        end: {
                                                                            line: 25,
                                                                            column: 54,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                        }
                                                                    }
                                                                }],
                                                            loc: {
                                                                start: {
                                                                    line: 25,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                },
                                                                end: {
                                                                    line: 25,
                                                                    column: 55,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 25,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/UserRowContent.ion'
                                                            },
                                                            end: {
                                                                line: 25,
                                                                column: 55,
                                                                fixed: true,
                                                                source: 'viewpath/html/UserRowContent.ion'
                                                            }
                                                        },
                                                        order: '0'
                                                    }]
                                            },
                                            alternate: {
                                                type: 'IfStatement',
                                                test: {
                                                    type: 'BinaryExpression',
                                                    operator: '===',
                                                    left: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'column',
                                                            loc: {
                                                                start: {
                                                                    line: 26,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                },
                                                                end: {
                                                                    line: 26,
                                                                    column: 26,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'name',
                                                            loc: {
                                                                start: {
                                                                    line: 26,
                                                                    column: 27,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                },
                                                                end: {
                                                                    line: 26,
                                                                    column: 31,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 26,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/UserRowContent.ion'
                                                            },
                                                            end: {
                                                                line: 26,
                                                                column: 31,
                                                                fixed: true,
                                                                source: 'viewpath/html/UserRowContent.ion'
                                                            }
                                                        }
                                                    },
                                                    right: {
                                                        type: 'Literal',
                                                        value: 'assigned'
                                                    }
                                                },
                                                consequent: {
                                                    type: 'BlockStatement',
                                                    body: [{
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'ObjectExpression',
                                                                objectType: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'Identifier',
                                                                        name: 'Span',
                                                                        loc: {
                                                                            start: {
                                                                                line: 27,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                            },
                                                                            end: {
                                                                                line: 27,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [],
                                                                    loc: {
                                                                        start: {
                                                                            line: 27,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                        },
                                                                        end: {
                                                                            line: 27,
                                                                            column: 22,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                        }
                                                                    }
                                                                },
                                                                properties: [{
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'ObjectExpression',
                                                                            objectType: {
                                                                                type: 'CallExpression',
                                                                                callee: {
                                                                                    type: 'Identifier',
                                                                                    name: 'RecordChip',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 28,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 28,
                                                                                            column: 30,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                arguments: [{
                                                                                        type: 'ObjectExpression',
                                                                                        properties: [{
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'record',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 28,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 28,
                                                                                                            column: 38,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'user',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 28,
                                                                                                            column: 39,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 28,
                                                                                                            column: 43,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '0'
                                                                                            }]
                                                                                    }],
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 28,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 28,
                                                                                        column: 45,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            properties: [
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'classList',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 29,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 29,
                                                                                                column: 33,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'ObjectExpression',
                                                                                        properties: [{
                                                                                                type: 'ExpressionStatement',
                                                                                                expression: {
                                                                                                    type: 'Literal',
                                                                                                    value: 'fill'
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 30,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 30,
                                                                                                        column: 34,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                    }
                                                                                                },
                                                                                                order: '0'
                                                                                            }]
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                },
                                                                                {
                                                                                    type: 'ExpressionStatement',
                                                                                    expression: {
                                                                                        type: 'ObjectExpression',
                                                                                        objectType: {
                                                                                            type: 'CallExpression',
                                                                                            callee: {
                                                                                                type: 'Identifier',
                                                                                                name: 'IronIcon',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 31,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 31,
                                                                                                        column: 32,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            arguments: [],
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 31,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 31,
                                                                                                    column: 34,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        properties: [
                                                                                            {
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'icon',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 32,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 32,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'ConditionalExpression',
                                                                                                    test: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'add',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 32,
                                                                                                                column: 34,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 32,
                                                                                                                column: 37,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    consequent: {
                                                                                                        type: 'Literal',
                                                                                                        value: 'add-circle'
                                                                                                    },
                                                                                                    alternate: {
                                                                                                        type: 'Literal',
                                                                                                        value: 'remove-circle'
                                                                                                    }
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '0'
                                                                                            },
                                                                                            {
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'style',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 33,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 33,
                                                                                                            column: 33,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'ObjectExpression',
                                                                                                    properties: [
                                                                                                        {
                                                                                                            type: 'Property',
                                                                                                            key: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'cursor',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 34,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 34,
                                                                                                                        column: 38,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            value: {
                                                                                                                type: 'Literal',
                                                                                                                value: 'pointer'
                                                                                                            },
                                                                                                            kind: 'init',
                                                                                                            order: '0'
                                                                                                        },
                                                                                                        {
                                                                                                            type: 'Property',
                                                                                                            key: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'marginRight',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 35,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 35,
                                                                                                                        column: 43,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            value: {
                                                                                                                type: 'Literal',
                                                                                                                value: '4px'
                                                                                                            },
                                                                                                            kind: 'init',
                                                                                                            order: '1'
                                                                                                        }
                                                                                                    ]
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '1'
                                                                                            },
                                                                                            {
                                                                                                type: 'ExpressionStatement',
                                                                                                expression: {
                                                                                                    type: 'Function',
                                                                                                    context: true,
                                                                                                    value: function (_context) {
                                                                                                        return function click(e) {
                                                                                                            var record = _context.get('record'), add = _context.get('add'), key = _context.get('key');
                                                                                                            record.assigned = record.assigned != null ? record.assigned : {};
                                                                                                            if (add) {
                                                                                                                record.assigned[key] = {};
                                                                                                            } else {
                                                                                                                delete record.assigned[key];
                                                                                                            }
                                                                                                        };
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 36,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 42,
                                                                                                        column: 32,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                    }
                                                                                                },
                                                                                                order: '2'
                                                                                            }
                                                                                        ]
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 31,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 42,
                                                                                            column: 28,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                                        }
                                                                                    },
                                                                                    order: '1'
                                                                                }
                                                                            ]
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 28,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                            },
                                                                            end: {
                                                                                line: 42,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                            }
                                                                        },
                                                                        order: '0'
                                                                    }]
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 27,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                },
                                                                end: {
                                                                    line: 42,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                }
                                                            },
                                                            order: '0'
                                                        }]
                                                },
                                                alternate: {
                                                    type: 'IfStatement',
                                                    test: {
                                                        type: 'BinaryExpression',
                                                        operator: '===',
                                                        left: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'column',
                                                                loc: {
                                                                    start: {
                                                                        line: 42,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                    },
                                                                    end: {
                                                                        line: 42,
                                                                        column: 26,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'name',
                                                                loc: {
                                                                    start: {
                                                                        line: 42,
                                                                        column: 27,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                    },
                                                                    end: {
                                                                        line: 42,
                                                                        column: 31,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 42,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                },
                                                                end: {
                                                                    line: 42,
                                                                    column: 31,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                }
                                                            }
                                                        },
                                                        right: {
                                                            type: 'Literal',
                                                            value: 'Timeline'
                                                        }
                                                    },
                                                    consequent: {
                                                        type: 'BlockStatement',
                                                        body: [{
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'column',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 43,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 43,
                                                                                    column: 22,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'createBodyCell',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 43,
                                                                                    column: 23,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 43,
                                                                                    column: 37,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 43,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                            },
                                                                            end: {
                                                                                line: 43,
                                                                                column: 37,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [{
                                                                            type: 'Identifier',
                                                                            name: 'userRowModel',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 43,
                                                                                    column: 38,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 43,
                                                                                    column: 50,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                }
                                                                            }
                                                                        }],
                                                                    loc: {
                                                                        start: {
                                                                            line: 43,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                        },
                                                                        end: {
                                                                            line: 43,
                                                                            column: 51,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 43,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                    },
                                                                    end: {
                                                                        line: 43,
                                                                        column: 51,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    alternate: {
                                                        type: 'BlockStatement',
                                                        body: [{
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'Identifier',
                                                                        name: 'Span',
                                                                        loc: {
                                                                            start: {
                                                                                line: 45,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                            },
                                                                            end: {
                                                                                line: 45,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [],
                                                                    loc: {
                                                                        start: {
                                                                            line: 45,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                        },
                                                                        end: {
                                                                            line: 45,
                                                                            column: 22,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 45,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                    },
                                                                    end: {
                                                                        line: 45,
                                                                        column: 22,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            }]
                                                    }
                                                }
                                            },
                                            order: '0'
                                        }]
                                },
                                remove: null,
                                order: '0'
                            }]
                    },
                    order: '7'
                }
            ],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'UserRow',
                loc: {
                    start: {
                        line: 19,
                        column: 6,
                        fixed: true,
                        source: 'viewpath/html/UserRowContent.ion'
                    },
                    end: {
                        line: 19,
                        column: 13,
                        fixed: true,
                        source: 'viewpath/html/UserRowContent.ion'
                    }
                }
            }
        }, {
            this: this,
            _ref6: _ref6,
            _ref: _ref,
            glass: glass,
            _ref2: _ref2,
            _ref3: _ref3,
            _ref4: _ref4,
            DataTable: DataTable,
            _ref5: _ref5,
            UserOrgTagsProperty: UserOrgTagsProperty,
            Key: Key,
            style: style,
            RecordChip: RecordChip,
            User: User,
            Tag: Tag,
            _ref11: _ref11,
            UserRow: UserRow,
            HeaderRow: HeaderRow,
            getKeyQueryForTagIndexes: getKeyQueryForTagIndexes,
            getSuggestedUserSearchKeys: getSuggestedUserSearchKeys,
            getSuggestedUsers: getSuggestedUsers
        }, null);
    });
var HeaderRow = ion.template(function (_ref7) {
        return ion.createRuntime({
            type: 'Template',
            id: null,
            body: [
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'name',
                                loc: {
                                    start: {
                                        line: 49,
                                        column: 29,
                                        fixed: true,
                                        source: 'viewpath/html/UserRowContent.ion'
                                    },
                                    end: {
                                        line: 49,
                                        column: 33,
                                        fixed: true,
                                        source: 'viewpath/html/UserRowContent.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref7'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'name',
                                    loc: {
                                        start: {
                                            line: 49,
                                            column: 29,
                                            fixed: true,
                                            source: 'viewpath/html/UserRowContent.ion'
                                        },
                                        end: {
                                            line: 49,
                                            column: 33,
                                            fixed: true,
                                            source: 'viewpath/html/UserRowContent.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '0'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'dataTableModel',
                                loc: {
                                    start: {
                                        line: 49,
                                        column: 35,
                                        fixed: true,
                                        source: 'viewpath/html/UserRowContent.ion'
                                    },
                                    end: {
                                        line: 49,
                                        column: 49,
                                        fixed: true,
                                        source: 'viewpath/html/UserRowContent.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref7'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'dataTableModel',
                                    loc: {
                                        start: {
                                            line: 49,
                                            column: 35,
                                            fixed: true,
                                            source: 'viewpath/html/UserRowContent.ion'
                                        },
                                        end: {
                                            line: 49,
                                            column: 49,
                                            fixed: true,
                                            source: 'viewpath/html/UserRowContent.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '1'
                },
                {
                    type: 'ReturnStatement',
                    argument: {
                        type: 'ObjectExpression',
                        objectType: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Div',
                                loc: {
                                    start: {
                                        line: 50,
                                        column: 11,
                                        fixed: true,
                                        source: 'viewpath/html/UserRowContent.ion'
                                    },
                                    end: {
                                        line: 50,
                                        column: 14,
                                        fixed: true,
                                        source: 'viewpath/html/UserRowContent.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ObjectExpression',
                                    properties: [{
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'class',
                                                loc: {
                                                    start: {
                                                        line: 50,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'viewpath/html/UserRowContent.ion'
                                                    },
                                                    end: {
                                                        line: 50,
                                                        column: 21,
                                                        fixed: true,
                                                        source: 'viewpath/html/UserRowContent.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: 'cells'
                                            },
                                            kind: 'init',
                                            order: '0'
                                        }]
                                }],
                            loc: {
                                start: {
                                    line: 50,
                                    column: 11,
                                    fixed: true,
                                    source: 'viewpath/html/UserRowContent.ion'
                                },
                                end: {
                                    line: 50,
                                    column: 31,
                                    fixed: true,
                                    source: 'viewpath/html/UserRowContent.ion'
                                }
                            }
                        },
                        properties: [{
                                type: 'ForOfStatement',
                                left: {
                                    type: 'VariableDeclaration',
                                    declarations: [{
                                            type: 'VariableDeclarator',
                                            id: {
                                                type: 'Identifier',
                                                name: 'column',
                                                loc: {
                                                    start: {
                                                        line: 51,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/UserRowContent.ion'
                                                    },
                                                    end: {
                                                        line: 51,
                                                        column: 18,
                                                        fixed: true,
                                                        source: 'viewpath/html/UserRowContent.ion'
                                                    }
                                                }
                                            },
                                            init: null
                                        }],
                                    kind: 'let'
                                },
                                right: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'dataTableModel',
                                        loc: {
                                            start: {
                                                line: 51,
                                                column: 22,
                                                fixed: true,
                                                source: 'viewpath/html/UserRowContent.ion'
                                            },
                                            end: {
                                                line: 51,
                                                column: 36,
                                                fixed: true,
                                                source: 'viewpath/html/UserRowContent.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'columns',
                                        loc: {
                                            start: {
                                                line: 51,
                                                column: 37,
                                                fixed: true,
                                                source: 'viewpath/html/UserRowContent.ion'
                                            },
                                            end: {
                                                line: 51,
                                                column: 44,
                                                fixed: true,
                                                source: 'viewpath/html/UserRowContent.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 51,
                                            column: 22,
                                            fixed: true,
                                            source: 'viewpath/html/UserRowContent.ion'
                                        },
                                        end: {
                                            line: 51,
                                            column: 44,
                                            fixed: true,
                                            source: 'viewpath/html/UserRowContent.ion'
                                        }
                                    }
                                },
                                body: {
                                    type: 'BlockStatement',
                                    body: [{
                                            type: 'IfStatement',
                                            test: {
                                                type: 'BinaryExpression',
                                                operator: '===',
                                                left: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'column',
                                                        loc: {
                                                            start: {
                                                                line: 52,
                                                                column: 15,
                                                                fixed: true,
                                                                source: 'viewpath/html/UserRowContent.ion'
                                                            },
                                                            end: {
                                                                line: 52,
                                                                column: 21,
                                                                fixed: true,
                                                                source: 'viewpath/html/UserRowContent.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'name',
                                                        loc: {
                                                            start: {
                                                                line: 52,
                                                                column: 22,
                                                                fixed: true,
                                                                source: 'viewpath/html/UserRowContent.ion'
                                                            },
                                                            end: {
                                                                line: 52,
                                                                column: 26,
                                                                fixed: true,
                                                                source: 'viewpath/html/UserRowContent.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 52,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'viewpath/html/UserRowContent.ion'
                                                        },
                                                        end: {
                                                            line: 52,
                                                            column: 26,
                                                            fixed: true,
                                                            source: 'viewpath/html/UserRowContent.ion'
                                                        }
                                                    }
                                                },
                                                right: {
                                                    type: 'Literal',
                                                    value: 'assigned'
                                                }
                                            },
                                            consequent: {
                                                type: 'BlockStatement',
                                                body: [{
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'ObjectExpression',
                                                            objectType: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Identifier',
                                                                    name: 'Span',
                                                                    loc: {
                                                                        start: {
                                                                            line: 53,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                        },
                                                                        end: {
                                                                            line: 53,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'ObjectExpression',
                                                                        properties: [{
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'class',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 53,
                                                                                            column: 22,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 53,
                                                                                            column: 27,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Literal',
                                                                                    value: 'subheader'
                                                                                },
                                                                                kind: 'init',
                                                                                order: '0'
                                                                            }]
                                                                    }],
                                                                loc: {
                                                                    start: {
                                                                        line: 53,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                    },
                                                                    end: {
                                                                        line: 53,
                                                                        column: 41,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                    }
                                                                }
                                                            },
                                                            properties: [
                                                                {
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'style',
                                                                        loc: {
                                                                            start: {
                                                                                line: 54,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                            },
                                                                            end: {
                                                                                line: 54,
                                                                                column: 25,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'ObjectExpression',
                                                                        properties: [{
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'whiteSpace',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 55,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 55,
                                                                                            column: 34,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Literal',
                                                                                    value: 'normal'
                                                                                },
                                                                                kind: 'init',
                                                                                order: '0'
                                                                            }]
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                },
                                                                {
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'Identifier',
                                                                        name: 'name',
                                                                        loc: {
                                                                            start: {
                                                                                line: 56,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                            },
                                                                            end: {
                                                                                line: 56,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 56,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                        },
                                                                        end: {
                                                                            line: 56,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                        }
                                                                    },
                                                                    order: '1'
                                                                }
                                                            ]
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 53,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/UserRowContent.ion'
                                                            },
                                                            end: {
                                                                line: 57,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/UserRowContent.ion'
                                                            }
                                                        },
                                                        order: '0'
                                                    }]
                                            },
                                            alternate: {
                                                type: 'BlockStatement',
                                                body: [{
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'Span',
                                                                loc: {
                                                                    start: {
                                                                        line: 58,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                    },
                                                                    end: {
                                                                        line: 58,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [],
                                                            loc: {
                                                                start: {
                                                                    line: 58,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                },
                                                                end: {
                                                                    line: 58,
                                                                    column: 22,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 58,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/UserRowContent.ion'
                                                            },
                                                            end: {
                                                                line: 58,
                                                                column: 22,
                                                                fixed: true,
                                                                source: 'viewpath/html/UserRowContent.ion'
                                                            }
                                                        },
                                                        order: '0'
                                                    }]
                                            },
                                            order: '0'
                                        }]
                                },
                                remove: null,
                                order: '0'
                            }]
                    },
                    order: '2'
                }
            ],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'HeaderRow',
                loc: {
                    start: {
                        line: 49,
                        column: 6,
                        fixed: true,
                        source: 'viewpath/html/UserRowContent.ion'
                    },
                    end: {
                        line: 49,
                        column: 15,
                        fixed: true,
                        source: 'viewpath/html/UserRowContent.ion'
                    }
                }
            }
        }, {
            this: this,
            _ref7: _ref7,
            _ref: _ref,
            glass: glass,
            _ref2: _ref2,
            _ref3: _ref3,
            _ref4: _ref4,
            DataTable: DataTable,
            _ref5: _ref5,
            UserOrgTagsProperty: UserOrgTagsProperty,
            Key: Key,
            style: style,
            RecordChip: RecordChip,
            User: User,
            Tag: Tag,
            _ref11: _ref11,
            UserRow: UserRow,
            HeaderRow: HeaderRow,
            getKeyQueryForTagIndexes: getKeyQueryForTagIndexes,
            getSuggestedUserSearchKeys: getSuggestedUserSearchKeys,
            getSuggestedUsers: getSuggestedUsers
        }, null);
    });
var getKeyQueryForTagIndexes = function (org, tagIndexes) {
    var wheres = [];
    for (var _i = 0; _i < tagIndexes.length; _i++) {
        var tagIndex = tagIndexes[_i];
        wheres.push({ orgTags: Tag.getIndexValue(org.id, tagIndex) });
    }
    return new Key(User, { where: wheres.length > 1 ? wheres : wheres[0] }).toString();
};
var getSuggestedUserSearchKeys = function (org, tags) {
    var validTagIds = [];
    for (var tagId in tags) {
        if ((org.tags != null ? org.tags[tagId] : void 0) != null) {
            validTagIds.push(tagId);
        }
    }
    var queries = [];
    for (var _i2 = 0; _i2 < validTagIds.length; _i2++) {
        var tagId = validTagIds[_i2];
        queries.push(getKeyQueryForTagIndexes(org, [tagId]));
    }
    if (validTagIds.length > 1) {
        queries.unshift(getKeyQueryForTagIndexes(org, validTagIds));
    }
    return queries;
};
var getSuggestedUsers = ion.template(function (org, tags) {
        return ion.createRuntime({
            type: 'Template',
            id: null,
            body: [
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'keys',
                                loc: {
                                    start: {
                                        line: 81,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/html/UserRowContent.ion'
                                    },
                                    end: {
                                        line: 81,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/UserRowContent.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'getSuggestedUserSearchKeys',
                                    loc: {
                                        start: {
                                            line: 81,
                                            column: 15,
                                            fixed: true,
                                            source: 'viewpath/html/UserRowContent.ion'
                                        },
                                        end: {
                                            line: 81,
                                            column: 41,
                                            fixed: true,
                                            source: 'viewpath/html/UserRowContent.ion'
                                        }
                                    }
                                },
                                arguments: [
                                    {
                                        type: 'Identifier',
                                        name: 'org',
                                        loc: {
                                            start: {
                                                line: 81,
                                                column: 42,
                                                fixed: true,
                                                source: 'viewpath/html/UserRowContent.ion'
                                            },
                                            end: {
                                                line: 81,
                                                column: 45,
                                                fixed: true,
                                                source: 'viewpath/html/UserRowContent.ion'
                                            }
                                        }
                                    },
                                    {
                                        type: 'Identifier',
                                        name: 'tags',
                                        loc: {
                                            start: {
                                                line: 81,
                                                column: 47,
                                                fixed: true,
                                                source: 'viewpath/html/UserRowContent.ion'
                                            },
                                            end: {
                                                line: 81,
                                                column: 51,
                                                fixed: true,
                                                source: 'viewpath/html/UserRowContent.ion'
                                            }
                                        }
                                    }
                                ],
                                loc: {
                                    start: {
                                        line: 81,
                                        column: 15,
                                        fixed: true,
                                        source: 'viewpath/html/UserRowContent.ion'
                                    },
                                    end: {
                                        line: 81,
                                        column: 52,
                                        fixed: true,
                                        source: 'viewpath/html/UserRowContent.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '0'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'state',
                                loc: {
                                    start: {
                                        line: 82,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/html/UserRowContent.ion'
                                    },
                                    end: {
                                        line: 82,
                                        column: 13,
                                        fixed: true,
                                        source: 'viewpath/html/UserRowContent.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Function',
                                    context: false,
                                    value: function () {
                                        return { loaded: false };
                                    }
                                },
                                arguments: [],
                                loc: {
                                    start: {
                                        line: 82,
                                        column: 16,
                                        fixed: true,
                                        source: 'viewpath/html/UserRowContent.ion'
                                    },
                                    end: {
                                        line: 82,
                                        column: 36,
                                        fixed: true,
                                        source: 'viewpath/html/UserRowContent.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '1'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'allUsers',
                                loc: {
                                    start: {
                                        line: 83,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/html/UserRowContent.ion'
                                    },
                                    end: {
                                        line: 83,
                                        column: 16,
                                        fixed: true,
                                        source: 'viewpath/html/UserRowContent.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'ArrayExpression',
                                    elements: []
                                },
                                properties: [{
                                        type: 'ForOfStatement',
                                        left: {
                                            type: 'VariableDeclaration',
                                            declarations: [{
                                                    type: 'VariableDeclarator',
                                                    id: {
                                                        type: 'Identifier',
                                                        name: 'key',
                                                        loc: {
                                                            start: {
                                                                line: 84,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'viewpath/html/UserRowContent.ion'
                                                            },
                                                            end: {
                                                                line: 84,
                                                                column: 15,
                                                                fixed: true,
                                                                source: 'viewpath/html/UserRowContent.ion'
                                                            }
                                                        }
                                                    },
                                                    init: null
                                                }],
                                            kind: 'let'
                                        },
                                        right: {
                                            type: 'Identifier',
                                            name: 'keys',
                                            loc: {
                                                start: {
                                                    line: 84,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'viewpath/html/UserRowContent.ion'
                                                },
                                                end: {
                                                    line: 84,
                                                    column: 23,
                                                    fixed: true,
                                                    source: 'viewpath/html/UserRowContent.ion'
                                                }
                                            }
                                        },
                                        body: {
                                            type: 'BlockStatement',
                                            body: [
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'users',
                                                                loc: {
                                                                    start: {
                                                                        line: 85,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                    },
                                                                    end: {
                                                                        line: 85,
                                                                        column: 21,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'MemberExpression',
                                                                computed: true,
                                                                object: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'model',
                                                                        loc: {
                                                                            start: {
                                                                                line: 85,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                            },
                                                                            end: {
                                                                                line: 85,
                                                                                column: 29,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'server',
                                                                        loc: {
                                                                            start: {
                                                                                line: 85,
                                                                                column: 30,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                            },
                                                                            end: {
                                                                                line: 85,
                                                                                column: 36,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 85,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                        },
                                                                        end: {
                                                                            line: 85,
                                                                            column: 36,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'key',
                                                                    loc: {
                                                                        start: {
                                                                            line: 85,
                                                                            column: 37,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                        },
                                                                        end: {
                                                                            line: 85,
                                                                            column: 40,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 85,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                    },
                                                                    end: {
                                                                        line: 85,
                                                                        column: 41,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'IfStatement',
                                                    test: {
                                                        type: 'UnaryExpression',
                                                        operator: '?',
                                                        argument: {
                                                            type: 'Identifier',
                                                            name: 'users',
                                                            loc: {
                                                                start: {
                                                                    line: 86,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                },
                                                                end: {
                                                                    line: 86,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                }
                                                            }
                                                        }
                                                    },
                                                    consequent: {
                                                        type: 'BlockStatement',
                                                        body: [
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'Function',
                                                                        context: true,
                                                                        value: function (_context2) {
                                                                            return function () {
                                                                                var state = _context2.get('state');
                                                                                state.loaded = true;
                                                                            };
                                                                        }
                                                                    },
                                                                    arguments: [],
                                                                    loc: {
                                                                        start: {
                                                                            line: 87,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                        },
                                                                        end: {
                                                                            line: 89,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 87,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                    },
                                                                    end: {
                                                                        line: 89,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'ForInStatement',
                                                                left: {
                                                                    type: 'VariableDeclaration',
                                                                    declarations: [
                                                                        {
                                                                            type: 'VariableDeclarator',
                                                                            id: {
                                                                                type: 'Identifier',
                                                                                name: 'name',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 89,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 89,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            init: null
                                                                        },
                                                                        {
                                                                            type: 'VariableDeclarator',
                                                                            id: {
                                                                                type: 'Identifier',
                                                                                name: 'user',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 89,
                                                                                        column: 26,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 89,
                                                                                        column: 30,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            init: null
                                                                        }
                                                                    ],
                                                                    kind: 'let'
                                                                },
                                                                right: {
                                                                    type: 'Identifier',
                                                                    name: 'users',
                                                                    loc: {
                                                                        start: {
                                                                            line: 89,
                                                                            column: 34,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                        },
                                                                        end: {
                                                                            line: 89,
                                                                            column: 39,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                        }
                                                                    }
                                                                },
                                                                body: {
                                                                    type: 'BlockStatement',
                                                                    body: [{
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'Identifier',
                                                                                name: 'user',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 90,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 90,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 90,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 90,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                remove: null,
                                                                order: '1'
                                                            }
                                                        ]
                                                    },
                                                    alternate: null,
                                                    order: '1'
                                                }
                                            ]
                                        },
                                        remove: null,
                                        order: '0'
                                    }]
                            }
                        }],
                    kind: 'let',
                    order: '2'
                },
                {
                    type: 'ReturnStatement',
                    argument: {
                        type: 'ConditionalExpression',
                        test: {
                            type: 'MemberExpression',
                            computed: false,
                            object: {
                                type: 'Identifier',
                                name: 'state',
                                loc: {
                                    start: {
                                        line: 92,
                                        column: 11,
                                        fixed: true,
                                        source: 'viewpath/html/UserRowContent.ion'
                                    },
                                    end: {
                                        line: 92,
                                        column: 16,
                                        fixed: true,
                                        source: 'viewpath/html/UserRowContent.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'loaded',
                                loc: {
                                    start: {
                                        line: 92,
                                        column: 17,
                                        fixed: true,
                                        source: 'viewpath/html/UserRowContent.ion'
                                    },
                                    end: {
                                        line: 92,
                                        column: 23,
                                        fixed: true,
                                        source: 'viewpath/html/UserRowContent.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 92,
                                    column: 11,
                                    fixed: true,
                                    source: 'viewpath/html/UserRowContent.ion'
                                },
                                end: {
                                    line: 92,
                                    column: 23,
                                    fixed: true,
                                    source: 'viewpath/html/UserRowContent.ion'
                                }
                            }
                        },
                        consequent: {
                            type: 'Identifier',
                            name: 'allUsers',
                            loc: {
                                start: {
                                    line: 92,
                                    column: 26,
                                    fixed: true,
                                    source: 'viewpath/html/UserRowContent.ion'
                                },
                                end: {
                                    line: 92,
                                    column: 34,
                                    fixed: true,
                                    source: 'viewpath/html/UserRowContent.ion'
                                }
                            }
                        },
                        alternate: {
                            type: 'Literal',
                            value: null
                        }
                    },
                    order: '3'
                }
            ],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'getSuggestedUsers',
                loc: {
                    start: {
                        line: 80,
                        column: 6,
                        fixed: true,
                        source: 'viewpath/html/UserRowContent.ion'
                    },
                    end: {
                        line: 80,
                        column: 23,
                        fixed: true,
                        source: 'viewpath/html/UserRowContent.ion'
                    }
                }
            }
        }, {
            this: this,
            org: org,
            tags: tags,
            _ref: _ref,
            glass: glass,
            _ref2: _ref2,
            _ref3: _ref3,
            _ref4: _ref4,
            DataTable: DataTable,
            _ref5: _ref5,
            UserOrgTagsProperty: UserOrgTagsProperty,
            Key: Key,
            style: style,
            RecordChip: RecordChip,
            User: User,
            Tag: Tag,
            _ref11: _ref11,
            UserRow: UserRow,
            HeaderRow: HeaderRow,
            getKeyQueryForTagIndexes: getKeyQueryForTagIndexes,
            getSuggestedUserSearchKeys: getSuggestedUserSearchKeys,
            getSuggestedUsers: getSuggestedUsers
        }, null);
    });
module.exports = exports = ion.template(function UserRowContent(_ref8) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'UserRowContent',
            loc: {
                start: {
                    line: 94,
                    column: 16,
                    fixed: true,
                    source: 'viewpath/html/UserRowContent.ion'
                },
                end: {
                    line: 94,
                    column: 30,
                    fixed: true,
                    source: 'viewpath/html/UserRowContent.ion'
                }
            }
        },
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'rowModel',
                            loc: {
                                start: {
                                    line: 94,
                                    column: 32,
                                    fixed: true,
                                    source: 'viewpath/html/UserRowContent.ion'
                                },
                                end: {
                                    line: 94,
                                    column: 40,
                                    fixed: true,
                                    source: 'viewpath/html/UserRowContent.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref8'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'rowModel',
                                loc: {
                                    start: {
                                        line: 94,
                                        column: 32,
                                        fixed: true,
                                        source: 'viewpath/html/UserRowContent.ion'
                                    },
                                    end: {
                                        line: 94,
                                        column: 40,
                                        fixed: true,
                                        source: 'viewpath/html/UserRowContent.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: '_ref9'
                        },
                        init: {
                            type: 'Identifier',
                            name: 'rowModel',
                            loc: {
                                start: {
                                    line: 95,
                                    column: 27,
                                    fixed: true,
                                    source: 'viewpath/html/UserRowContent.ion'
                                },
                                end: {
                                    line: 95,
                                    column: 35,
                                    fixed: true,
                                    source: 'viewpath/html/UserRowContent.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'dataTableModel',
                            loc: {
                                start: {
                                    line: 95,
                                    column: 9,
                                    fixed: true,
                                    source: 'viewpath/html/UserRowContent.ion'
                                },
                                end: {
                                    line: 95,
                                    column: 23,
                                    fixed: true,
                                    source: 'viewpath/html/UserRowContent.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref9'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'dataTableModel',
                                loc: {
                                    start: {
                                        line: 95,
                                        column: 9,
                                        fixed: true,
                                        source: 'viewpath/html/UserRowContent.ion'
                                    },
                                    end: {
                                        line: 95,
                                        column: 23,
                                        fixed: true,
                                        source: 'viewpath/html/UserRowContent.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'expanded',
                            loc: {
                                start: {
                                    line: 96,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/UserRowContent.ion'
                                },
                                end: {
                                    line: 96,
                                    column: 16,
                                    fixed: true,
                                    source: 'viewpath/html/UserRowContent.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            computed: true,
                            object: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'dataTableModel',
                                        loc: {
                                            start: {
                                                line: 96,
                                                column: 19,
                                                fixed: true,
                                                source: 'viewpath/html/UserRowContent.ion'
                                            },
                                            end: {
                                                line: 96,
                                                column: 33,
                                                fixed: true,
                                                source: 'viewpath/html/UserRowContent.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'state',
                                        loc: {
                                            start: {
                                                line: 96,
                                                column: 34,
                                                fixed: true,
                                                source: 'viewpath/html/UserRowContent.ion'
                                            },
                                            end: {
                                                line: 96,
                                                column: 39,
                                                fixed: true,
                                                source: 'viewpath/html/UserRowContent.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 96,
                                            column: 19,
                                            fixed: true,
                                            source: 'viewpath/html/UserRowContent.ion'
                                        },
                                        end: {
                                            line: 96,
                                            column: 39,
                                            fixed: true,
                                            source: 'viewpath/html/UserRowContent.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'expandedAssignments',
                                    loc: {
                                        start: {
                                            line: 96,
                                            column: 40,
                                            fixed: true,
                                            source: 'viewpath/html/UserRowContent.ion'
                                        },
                                        end: {
                                            line: 96,
                                            column: 59,
                                            fixed: true,
                                            source: 'viewpath/html/UserRowContent.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 96,
                                        column: 19,
                                        fixed: true,
                                        source: 'viewpath/html/UserRowContent.ion'
                                    },
                                    end: {
                                        line: 96,
                                        column: 59,
                                        fixed: true,
                                        source: 'viewpath/html/UserRowContent.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'rowModel',
                                    loc: {
                                        start: {
                                            line: 96,
                                            column: 61,
                                            fixed: true,
                                            source: 'viewpath/html/UserRowContent.ion'
                                        },
                                        end: {
                                            line: 96,
                                            column: 69,
                                            fixed: true,
                                            source: 'viewpath/html/UserRowContent.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'key',
                                    loc: {
                                        start: {
                                            line: 96,
                                            column: 70,
                                            fixed: true,
                                            source: 'viewpath/html/UserRowContent.ion'
                                        },
                                        end: {
                                            line: 96,
                                            column: 73,
                                            fixed: true,
                                            source: 'viewpath/html/UserRowContent.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 96,
                                        column: 61,
                                        fixed: true,
                                        source: 'viewpath/html/UserRowContent.ion'
                                    },
                                    end: {
                                        line: 96,
                                        column: 73,
                                        fixed: true,
                                        source: 'viewpath/html/UserRowContent.ion'
                                    }
                                }
                            },
                            existential: true,
                            loc: {
                                start: {
                                    line: 96,
                                    column: 19,
                                    fixed: true,
                                    source: 'viewpath/html/UserRowContent.ion'
                                },
                                end: {
                                    line: 96,
                                    column: 74,
                                    fixed: true,
                                    source: 'viewpath/html/UserRowContent.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '3'
            },
            {
                type: 'IfStatement',
                test: {
                    type: 'Identifier',
                    name: 'expanded',
                    loc: {
                        start: {
                            line: 97,
                            column: 7,
                            fixed: true,
                            source: 'viewpath/html/UserRowContent.ion'
                        },
                        end: {
                            line: 97,
                            column: 15,
                            fixed: true,
                            source: 'viewpath/html/UserRowContent.ion'
                        }
                    }
                },
                consequent: {
                    type: 'BlockStatement',
                    body: [
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'record',
                                        loc: {
                                            start: {
                                                line: 98,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/UserRowContent.ion'
                                            },
                                            end: {
                                                line: 98,
                                                column: 18,
                                                fixed: true,
                                                source: 'viewpath/html/UserRowContent.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'rowModel',
                                            loc: {
                                                start: {
                                                    line: 98,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'viewpath/html/UserRowContent.ion'
                                                },
                                                end: {
                                                    line: 98,
                                                    column: 29,
                                                    fixed: true,
                                                    source: 'viewpath/html/UserRowContent.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'record',
                                            loc: {
                                                start: {
                                                    line: 98,
                                                    column: 30,
                                                    fixed: true,
                                                    source: 'viewpath/html/UserRowContent.ion'
                                                },
                                                end: {
                                                    line: 98,
                                                    column: 36,
                                                    fixed: true,
                                                    source: 'viewpath/html/UserRowContent.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 98,
                                                column: 21,
                                                fixed: true,
                                                source: 'viewpath/html/UserRowContent.ion'
                                            },
                                            end: {
                                                line: 98,
                                                column: 36,
                                                fixed: true,
                                                source: 'viewpath/html/UserRowContent.ion'
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '0'
                        },
                        {
                            type: 'ReturnStatement',
                            argument: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'Identifier',
                                        name: 'Div',
                                        loc: {
                                            start: {
                                                line: 99,
                                                column: 15,
                                                fixed: true,
                                                source: 'viewpath/html/UserRowContent.ion'
                                            },
                                            end: {
                                                line: 99,
                                                column: 18,
                                                fixed: true,
                                                source: 'viewpath/html/UserRowContent.ion'
                                            }
                                        }
                                    },
                                    arguments: [],
                                    loc: {
                                        start: {
                                            line: 99,
                                            column: 15,
                                            fixed: true,
                                            source: 'viewpath/html/UserRowContent.ion'
                                        },
                                        end: {
                                            line: 99,
                                            column: 20,
                                            fixed: true,
                                            source: 'viewpath/html/UserRowContent.ion'
                                        }
                                    }
                                },
                                properties: [
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'style',
                                            loc: {
                                                start: {
                                                    line: 100,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/UserRowContent.ion'
                                                },
                                                end: {
                                                    line: 100,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'viewpath/html/UserRowContent.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'ObjectExpression',
                                            properties: [{
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'background',
                                                        loc: {
                                                            start: {
                                                                line: 101,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/UserRowContent.ion'
                                                            },
                                                            end: {
                                                                line: 101,
                                                                column: 26,
                                                                fixed: true,
                                                                source: 'viewpath/html/UserRowContent.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'BinaryExpression',
                                                        operator: '+',
                                                        left: {
                                                            type: 'BinaryExpression',
                                                            operator: '+',
                                                            left: {
                                                                type: 'Literal',
                                                                value: 'rgba(0,0,0,'
                                                            },
                                                            right: {
                                                                type: 'BinaryExpression',
                                                                operator: '*',
                                                                left: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'DataTable',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 101,
                                                                                    column: 42,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 101,
                                                                                    column: 51,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'Style',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 101,
                                                                                    column: 52,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 101,
                                                                                    column: 57,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 101,
                                                                                column: 42,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                            },
                                                                            end: {
                                                                                line: 101,
                                                                                column: 57,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'selectOpacity',
                                                                        loc: {
                                                                            start: {
                                                                                line: 101,
                                                                                column: 58,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                            },
                                                                            end: {
                                                                                line: 101,
                                                                                column: 71,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 101,
                                                                            column: 42,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                        },
                                                                        end: {
                                                                            line: 101,
                                                                            column: 71,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                        }
                                                                    }
                                                                },
                                                                right: {
                                                                    type: 'Literal',
                                                                    value: 1
                                                                }
                                                            }
                                                        },
                                                        right: {
                                                            type: 'Literal',
                                                            value: ')'
                                                        }
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                }]
                                        },
                                        kind: 'init',
                                        order: '0'
                                    },
                                    {
                                        type: 'VariableDeclaration',
                                        declarations: [{
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'orgKey',
                                                    loc: {
                                                        start: {
                                                            line: 102,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/UserRowContent.ion'
                                                        },
                                                        end: {
                                                            line: 102,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'viewpath/html/UserRowContent.ion'
                                                        }
                                                    }
                                                },
                                                init: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'dataTableModel',
                                                            loc: {
                                                                start: {
                                                                    line: 102,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                },
                                                                end: {
                                                                    line: 102,
                                                                    column: 39,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'project',
                                                            loc: {
                                                                start: {
                                                                    line: 102,
                                                                    column: 40,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                },
                                                                end: {
                                                                    line: 102,
                                                                    column: 47,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 102,
                                                                column: 25,
                                                                fixed: true,
                                                                source: 'viewpath/html/UserRowContent.ion'
                                                            },
                                                            end: {
                                                                line: 102,
                                                                column: 47,
                                                                fixed: true,
                                                                source: 'viewpath/html/UserRowContent.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'orgKey',
                                                        loc: {
                                                            start: {
                                                                line: 102,
                                                                column: 48,
                                                                fixed: true,
                                                                source: 'viewpath/html/UserRowContent.ion'
                                                            },
                                                            end: {
                                                                line: 102,
                                                                column: 54,
                                                                fixed: true,
                                                                source: 'viewpath/html/UserRowContent.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 102,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'viewpath/html/UserRowContent.ion'
                                                        },
                                                        end: {
                                                            line: 102,
                                                            column: 54,
                                                            fixed: true,
                                                            source: 'viewpath/html/UserRowContent.ion'
                                                        }
                                                    }
                                                }
                                            }],
                                        kind: 'let',
                                        order: '1'
                                    },
                                    {
                                        type: 'VariableDeclaration',
                                        declarations: [{
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'org',
                                                    loc: {
                                                        start: {
                                                            line: 103,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/UserRowContent.ion'
                                                        },
                                                        end: {
                                                            line: 103,
                                                            column: 19,
                                                            fixed: true,
                                                            source: 'viewpath/html/UserRowContent.ion'
                                                        }
                                                    }
                                                },
                                                init: {
                                                    type: 'MemberExpression',
                                                    computed: true,
                                                    object: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'model',
                                                            loc: {
                                                                start: {
                                                                    line: 103,
                                                                    column: 22,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                },
                                                                end: {
                                                                    line: 103,
                                                                    column: 27,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'server',
                                                            loc: {
                                                                start: {
                                                                    line: 103,
                                                                    column: 28,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                },
                                                                end: {
                                                                    line: 103,
                                                                    column: 34,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 103,
                                                                column: 22,
                                                                fixed: true,
                                                                source: 'viewpath/html/UserRowContent.ion'
                                                            },
                                                            end: {
                                                                line: 103,
                                                                column: 34,
                                                                fixed: true,
                                                                source: 'viewpath/html/UserRowContent.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'orgKey',
                                                        loc: {
                                                            start: {
                                                                line: 103,
                                                                column: 35,
                                                                fixed: true,
                                                                source: 'viewpath/html/UserRowContent.ion'
                                                            },
                                                            end: {
                                                                line: 103,
                                                                column: 41,
                                                                fixed: true,
                                                                source: 'viewpath/html/UserRowContent.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 103,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'viewpath/html/UserRowContent.ion'
                                                        },
                                                        end: {
                                                            line: 103,
                                                            column: 42,
                                                            fixed: true,
                                                            source: 'viewpath/html/UserRowContent.ion'
                                                        }
                                                    }
                                                }
                                            }],
                                        kind: 'let',
                                        order: '2'
                                    },
                                    {
                                        type: 'IfStatement',
                                        test: {
                                            type: 'UnaryExpression',
                                            operator: '?',
                                            argument: {
                                                type: 'Identifier',
                                                name: 'org',
                                                loc: {
                                                    start: {
                                                        line: 104,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'viewpath/html/UserRowContent.ion'
                                                    },
                                                    end: {
                                                        line: 104,
                                                        column: 18,
                                                        fixed: true,
                                                        source: 'viewpath/html/UserRowContent.ion'
                                                    }
                                                }
                                            }
                                        },
                                        consequent: {
                                            type: 'BlockStatement',
                                            body: [
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'userTagsProperty',
                                                                loc: {
                                                                    start: {
                                                                        line: 105,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                    },
                                                                    end: {
                                                                        line: 105,
                                                                        column: 36,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Identifier',
                                                                    name: 'UserOrgTagsProperty',
                                                                    loc: {
                                                                        start: {
                                                                            line: 105,
                                                                            column: 39,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                        },
                                                                        end: {
                                                                            line: 105,
                                                                            column: 58,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'Identifier',
                                                                        name: 'org',
                                                                        loc: {
                                                                            start: {
                                                                                line: 105,
                                                                                column: 59,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                            },
                                                                            end: {
                                                                                line: 105,
                                                                                column: 62,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                            }
                                                                        }
                                                                    }],
                                                                loc: {
                                                                    start: {
                                                                        line: 105,
                                                                        column: 39,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                    },
                                                                    end: {
                                                                        line: 105,
                                                                        column: 63,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'VariableDeclaration',
                                                    declarations: [{
                                                            type: 'VariableDeclarator',
                                                            id: {
                                                                type: 'Identifier',
                                                                name: 'tagsColumn',
                                                                loc: {
                                                                    start: {
                                                                        line: 106,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                    },
                                                                    end: {
                                                                        line: 106,
                                                                        column: 30,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                    }
                                                                }
                                                            },
                                                            init: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'DataTable',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 106,
                                                                                    column: 33,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 106,
                                                                                    column: 42,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'getColumnType',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 106,
                                                                                    column: 43,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 106,
                                                                                    column: 56,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 106,
                                                                                column: 33,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                            },
                                                                            end: {
                                                                                line: 106,
                                                                                column: 56,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [{
                                                                            type: 'Identifier',
                                                                            name: 'userTagsProperty',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 106,
                                                                                    column: 57,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 106,
                                                                                    column: 73,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                }
                                                                            }
                                                                        }],
                                                                    loc: {
                                                                        start: {
                                                                            line: 106,
                                                                            column: 33,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                        },
                                                                        end: {
                                                                            line: 106,
                                                                            column: 74,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'Identifier',
                                                                        name: 'userTagsProperty',
                                                                        loc: {
                                                                            start: {
                                                                                line: 106,
                                                                                column: 75,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                            },
                                                                            end: {
                                                                                line: 106,
                                                                                column: 91,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                            }
                                                                        }
                                                                    }],
                                                                loc: {
                                                                    start: {
                                                                        line: 106,
                                                                        column: 33,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                    },
                                                                    end: {
                                                                        line: 106,
                                                                        column: 92,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                    }
                                                                }
                                                            }
                                                        }],
                                                    kind: 'let',
                                                    order: '1'
                                                },
                                                {
                                                    type: 'IfStatement',
                                                    test: {
                                                        type: 'UnaryExpression',
                                                        operator: '?',
                                                        argument: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'record',
                                                                loc: {
                                                                    start: {
                                                                        line: 107,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                    },
                                                                    end: {
                                                                        line: 107,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'assigned',
                                                                loc: {
                                                                    start: {
                                                                        line: 107,
                                                                        column: 26,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                    },
                                                                    end: {
                                                                        line: 107,
                                                                        column: 34,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 107,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                },
                                                                end: {
                                                                    line: 107,
                                                                    column: 34,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                }
                                                            }
                                                        }
                                                    },
                                                    consequent: {
                                                        type: 'BlockStatement',
                                                        body: [{
                                                                type: 'ForInStatement',
                                                                left: {
                                                                    type: 'VariableDeclaration',
                                                                    declarations: [{
                                                                            type: 'VariableDeclarator',
                                                                            id: {
                                                                                type: 'Identifier',
                                                                                name: 'key',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 108,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 108,
                                                                                        column: 27,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            init: null
                                                                        }],
                                                                    kind: 'let'
                                                                },
                                                                right: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'record',
                                                                        loc: {
                                                                            start: {
                                                                                line: 108,
                                                                                column: 31,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                            },
                                                                            end: {
                                                                                line: 108,
                                                                                column: 37,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'assigned',
                                                                        loc: {
                                                                            start: {
                                                                                line: 108,
                                                                                column: 38,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                            },
                                                                            end: {
                                                                                line: 108,
                                                                                column: 46,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 108,
                                                                            column: 31,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                        },
                                                                        end: {
                                                                            line: 108,
                                                                            column: 46,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                        }
                                                                    }
                                                                },
                                                                body: {
                                                                    type: 'BlockStatement',
                                                                    body: [
                                                                        {
                                                                            type: 'VariableDeclaration',
                                                                            declarations: [{
                                                                                    type: 'VariableDeclarator',
                                                                                    id: {
                                                                                        type: 'Identifier',
                                                                                        name: 'user',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 109,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 109,
                                                                                                column: 32,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    init: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: true,
                                                                                        object: {
                                                                                            type: 'MemberExpression',
                                                                                            computed: false,
                                                                                            object: {
                                                                                                type: 'Identifier',
                                                                                                name: 'model',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 109,
                                                                                                        column: 35,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 109,
                                                                                                        column: 40,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            property: {
                                                                                                type: 'Identifier',
                                                                                                name: 'server',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 109,
                                                                                                        column: 41,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 109,
                                                                                                        column: 47,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 109,
                                                                                                    column: 35,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 109,
                                                                                                    column: 47,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'key',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 109,
                                                                                                    column: 48,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 109,
                                                                                                    column: 51,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 109,
                                                                                                column: 35,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 109,
                                                                                                column: 52,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                }],
                                                                            kind: 'let',
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'IfStatement',
                                                                            test: {
                                                                                type: 'UnaryExpression',
                                                                                operator: '?',
                                                                                argument: {
                                                                                    type: 'Identifier',
                                                                                    name: 'user',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 110,
                                                                                            column: 27,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 110,
                                                                                            column: 31,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                                        }
                                                                                    }
                                                                                }
                                                                            },
                                                                            consequent: {
                                                                                type: 'BlockStatement',
                                                                                body: [{
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'CallExpression',
                                                                                            callee: {
                                                                                                type: 'Identifier',
                                                                                                name: 'UserRow',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 111,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 111,
                                                                                                        column: 35,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            arguments: [{
                                                                                                    type: 'ObjectExpression',
                                                                                                    properties: [
                                                                                                        {
                                                                                                            type: 'Property',
                                                                                                            key: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'key',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 111,
                                                                                                                        column: 37,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 111,
                                                                                                                        column: 40,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            value: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'key',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 111,
                                                                                                                        column: 37,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 111,
                                                                                                                        column: 40,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            kind: 'init',
                                                                                                            order: '0'
                                                                                                        },
                                                                                                        {
                                                                                                            type: 'Property',
                                                                                                            key: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'user',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 111,
                                                                                                                        column: 42,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 111,
                                                                                                                        column: 46,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            value: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'user',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 111,
                                                                                                                        column: 42,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 111,
                                                                                                                        column: 46,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            kind: 'init',
                                                                                                            order: '1'
                                                                                                        },
                                                                                                        {
                                                                                                            type: 'Property',
                                                                                                            key: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'dataTableModel',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 111,
                                                                                                                        column: 48,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 111,
                                                                                                                        column: 62,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            value: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'dataTableModel',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 111,
                                                                                                                        column: 48,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 111,
                                                                                                                        column: 62,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            kind: 'init',
                                                                                                            order: '2'
                                                                                                        },
                                                                                                        {
                                                                                                            type: 'Property',
                                                                                                            key: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'record',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 111,
                                                                                                                        column: 64,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 111,
                                                                                                                        column: 70,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            value: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'record',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 111,
                                                                                                                        column: 64,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 111,
                                                                                                                        column: 70,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            kind: 'init',
                                                                                                            order: '3'
                                                                                                        },
                                                                                                        {
                                                                                                            type: 'Property',
                                                                                                            key: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'tagsColumn',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 111,
                                                                                                                        column: 72,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 111,
                                                                                                                        column: 82,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            value: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'tagsColumn',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 111,
                                                                                                                        column: 72,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 111,
                                                                                                                        column: 82,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            kind: 'init',
                                                                                                            order: '4'
                                                                                                        },
                                                                                                        {
                                                                                                            type: 'Property',
                                                                                                            key: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'add',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 111,
                                                                                                                        column: 84,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 111,
                                                                                                                        column: 87,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            value: {
                                                                                                                type: 'Literal',
                                                                                                                value: false
                                                                                                            },
                                                                                                            kind: 'init',
                                                                                                            order: '5'
                                                                                                        }
                                                                                                    ]
                                                                                                }],
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 111,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 111,
                                                                                                    column: 95,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 111,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 111,
                                                                                                column: 95,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            alternate: null,
                                                                            order: '1'
                                                                        }
                                                                    ]
                                                                },
                                                                remove: null,
                                                                order: '0'
                                                            }]
                                                    },
                                                    alternate: null,
                                                    order: '2'
                                                },
                                                {
                                                    type: 'IfStatement',
                                                    test: {
                                                        type: 'BinaryExpression',
                                                        operator: '>',
                                                        left: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'Object',
                                                                        loc: {
                                                                            start: {
                                                                                line: 113,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                            },
                                                                            end: {
                                                                                line: 113,
                                                                                column: 26,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'keys',
                                                                        loc: {
                                                                            start: {
                                                                                line: 113,
                                                                                column: 27,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                            },
                                                                            end: {
                                                                                line: 113,
                                                                                column: 31,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 113,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                        },
                                                                        end: {
                                                                            line: 113,
                                                                            column: 31,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'ConditionalExpression',
                                                                        test: {
                                                                            type: 'BinaryExpression',
                                                                            operator: '!=',
                                                                            left: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'Identifier',
                                                                                    name: 'record',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 113,
                                                                                            column: 32,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 113,
                                                                                            column: 38,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'tags',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 113,
                                                                                            column: 39,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 113,
                                                                                            column: 43,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 113,
                                                                                        column: 32,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 113,
                                                                                        column: 43,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            right: {
                                                                                type: 'Literal',
                                                                                value: null
                                                                            }
                                                                        },
                                                                        consequent: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'record',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 113,
                                                                                        column: 32,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 113,
                                                                                        column: 38,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'tags',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 113,
                                                                                        column: 39,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 113,
                                                                                        column: 43,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 113,
                                                                                    column: 32,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 113,
                                                                                    column: 43,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        alternate: {
                                                                            type: 'ObjectExpression',
                                                                            properties: []
                                                                        }
                                                                    }],
                                                                loc: {
                                                                    start: {
                                                                        line: 113,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                    },
                                                                    end: {
                                                                        line: 113,
                                                                        column: 49,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'length',
                                                                loc: {
                                                                    start: {
                                                                        line: 113,
                                                                        column: 50,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                    },
                                                                    end: {
                                                                        line: 113,
                                                                        column: 56,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 113,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                },
                                                                end: {
                                                                    line: 113,
                                                                    column: 56,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                }
                                                            }
                                                        },
                                                        right: {
                                                            type: 'Literal',
                                                            value: 0
                                                        }
                                                    },
                                                    consequent: {
                                                        type: 'BlockStatement',
                                                        body: [
                                                            {
                                                                type: 'VariableDeclaration',
                                                                declarations: [{
                                                                        type: 'VariableDeclarator',
                                                                        id: {
                                                                            type: 'Identifier',
                                                                            name: 'users',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 114,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 114,
                                                                                    column: 29,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        init: {
                                                                            type: 'CallExpression',
                                                                            callee: {
                                                                                type: 'Identifier',
                                                                                name: 'getSuggestedUsers',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 114,
                                                                                        column: 32,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 114,
                                                                                        column: 49,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            arguments: [
                                                                                {
                                                                                    type: 'Identifier',
                                                                                    name: 'org',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 114,
                                                                                            column: 50,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 114,
                                                                                            column: 53,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'record',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 114,
                                                                                                column: 55,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 114,
                                                                                                column: 61,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'tags',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 114,
                                                                                                column: 62,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 114,
                                                                                                column: 66,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 114,
                                                                                            column: 55,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 114,
                                                                                            column: 66,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                                        }
                                                                                    }
                                                                                }
                                                                            ],
                                                                            loc: {
                                                                                start: {
                                                                                    line: 114,
                                                                                    column: 32,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 114,
                                                                                    column: 67,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                }
                                                                            }
                                                                        }
                                                                    }],
                                                                kind: 'let',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'VariableDeclaration',
                                                                declarations: [{
                                                                        type: 'VariableDeclarator',
                                                                        id: {
                                                                            type: 'Identifier',
                                                                            name: '_ref10'
                                                                        },
                                                                        init: {
                                                                            type: 'CallExpression',
                                                                            callee: {
                                                                                type: 'Function',
                                                                                context: false,
                                                                                value: function (users) {
                                                                                    if (!users) {
                                                                                        return ['Loading...'];
                                                                                    } else if (Object.keys(users != null ? users : {}).length === 0) {
                                                                                        return [
                                                                                            'No available suggestions',
                                                                                            'No current Members have matching tags. You may need to add tags to your Members to enable matching.'
                                                                                        ];
                                                                                    } else {
                                                                                        return ['Suggestions'];
                                                                                    }
                                                                                }
                                                                            },
                                                                            arguments: [{
                                                                                    type: 'Identifier',
                                                                                    name: 'users',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 115,
                                                                                            column: 47,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 115,
                                                                                            column: 52,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                                        }
                                                                                    }
                                                                                }],
                                                                            loc: {
                                                                                start: {
                                                                                    line: 115,
                                                                                    column: 43,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 122,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                }
                                                                            }
                                                                        }
                                                                    }],
                                                                kind: 'let',
                                                                order: '1'
                                                            },
                                                            {
                                                                type: 'VariableDeclaration',
                                                                declarations: [{
                                                                        type: 'VariableDeclarator',
                                                                        id: {
                                                                            type: 'Identifier',
                                                                            name: 'message',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 115,
                                                                                    column: 25,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 115,
                                                                                    column: 32,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        init: {
                                                                            type: 'MemberExpression',
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: '_ref10'
                                                                            },
                                                                            property: {
                                                                                type: 'Literal',
                                                                                value: 0
                                                                            },
                                                                            computed: true
                                                                        }
                                                                    }],
                                                                kind: 'let',
                                                                order: '2'
                                                            },
                                                            {
                                                                type: 'VariableDeclaration',
                                                                declarations: [{
                                                                        type: 'VariableDeclarator',
                                                                        id: {
                                                                            type: 'Identifier',
                                                                            name: 'title',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 115,
                                                                                    column: 34,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 115,
                                                                                    column: 39,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        init: {
                                                                            type: 'MemberExpression',
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: '_ref10'
                                                                            },
                                                                            property: {
                                                                                type: 'Literal',
                                                                                value: 1
                                                                            },
                                                                            computed: true
                                                                        }
                                                                    }],
                                                                kind: 'let',
                                                                order: '3'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'ObjectExpression',
                                                                    objectType: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'Identifier',
                                                                            name: 'HeaderRow',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 122,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 122,
                                                                                    column: 29,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [{
                                                                                type: 'ObjectExpression',
                                                                                properties: [
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'dataTableModel',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 122,
                                                                                                    column: 31,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 122,
                                                                                                    column: 45,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Identifier',
                                                                                            name: 'dataTableModel',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 122,
                                                                                                    column: 31,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 122,
                                                                                                    column: 45,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'name',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 122,
                                                                                                    column: 47,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 122,
                                                                                                    column: 51,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Identifier',
                                                                                            name: 'message',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 122,
                                                                                                    column: 53,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 122,
                                                                                                    column: 60,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '1'
                                                                                    }
                                                                                ]
                                                                            }],
                                                                        loc: {
                                                                            start: {
                                                                                line: 122,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                            },
                                                                            end: {
                                                                                line: 122,
                                                                                column: 62,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    properties: [{
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'title',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 123,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 123,
                                                                                        column: 29,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Identifier',
                                                                                name: 'title',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 123,
                                                                                        column: 31,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 123,
                                                                                        column: 36,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 122,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                    },
                                                                    end: {
                                                                        line: 124,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                    }
                                                                },
                                                                order: '4'
                                                            },
                                                            {
                                                                type: 'ForOfStatement',
                                                                left: {
                                                                    type: 'VariableDeclaration',
                                                                    declarations: [{
                                                                            type: 'VariableDeclarator',
                                                                            id: {
                                                                                type: 'Identifier',
                                                                                name: 'user',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 124,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 124,
                                                                                        column: 28,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            init: null
                                                                        }],
                                                                    kind: 'let'
                                                                },
                                                                right: {
                                                                    type: 'Identifier',
                                                                    name: 'users',
                                                                    loc: {
                                                                        start: {
                                                                            line: 124,
                                                                            column: 32,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                        },
                                                                        end: {
                                                                            line: 124,
                                                                            column: 37,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                        }
                                                                    }
                                                                },
                                                                body: {
                                                                    type: 'BlockStatement',
                                                                    body: [{
                                                                            type: 'IfStatement',
                                                                            test: {
                                                                                type: 'UnaryExpression',
                                                                                operator: '!',
                                                                                argument: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: true,
                                                                                    object: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'record',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 124,
                                                                                                    column: 45,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 124,
                                                                                                    column: 51,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'assigned',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 124,
                                                                                                    column: 52,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 124,
                                                                                                    column: 60,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 124,
                                                                                                column: 45,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 124,
                                                                                                column: 60,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'user',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 124,
                                                                                                    column: 61,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 124,
                                                                                                    column: 65,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'key',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 124,
                                                                                                    column: 66,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 124,
                                                                                                    column: 69,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 124,
                                                                                                column: 61,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 124,
                                                                                                column: 69,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 124,
                                                                                            column: 45,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 124,
                                                                                            column: 70,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                                        }
                                                                                    }
                                                                                }
                                                                            },
                                                                            consequent: {
                                                                                type: 'BlockStatement',
                                                                                body: [{
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'CallExpression',
                                                                                            callee: {
                                                                                                type: 'Identifier',
                                                                                                name: 'UserRow',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 125,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 125,
                                                                                                        column: 31,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            arguments: [{
                                                                                                    type: 'ObjectExpression',
                                                                                                    properties: [
                                                                                                        {
                                                                                                            type: 'Property',
                                                                                                            key: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'key',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 125,
                                                                                                                        column: 33,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 125,
                                                                                                                        column: 36,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            value: {
                                                                                                                type: 'MemberExpression',
                                                                                                                computed: false,
                                                                                                                object: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'user',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 125,
                                                                                                                            column: 37,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 125,
                                                                                                                            column: 41,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                property: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'key',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 125,
                                                                                                                            column: 42,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 125,
                                                                                                                            column: 45,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/UserRowContent.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 125,
                                                                                                                        column: 37,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 125,
                                                                                                                        column: 45,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            kind: 'init',
                                                                                                            order: '0'
                                                                                                        },
                                                                                                        {
                                                                                                            type: 'Property',
                                                                                                            key: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'user',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 125,
                                                                                                                        column: 47,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 125,
                                                                                                                        column: 51,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            value: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'user',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 125,
                                                                                                                        column: 47,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 125,
                                                                                                                        column: 51,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            kind: 'init',
                                                                                                            order: '1'
                                                                                                        },
                                                                                                        {
                                                                                                            type: 'Property',
                                                                                                            key: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'record',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 125,
                                                                                                                        column: 53,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 125,
                                                                                                                        column: 59,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            value: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'record',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 125,
                                                                                                                        column: 53,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 125,
                                                                                                                        column: 59,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            kind: 'init',
                                                                                                            order: '2'
                                                                                                        },
                                                                                                        {
                                                                                                            type: 'Property',
                                                                                                            key: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'dataTableModel',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 125,
                                                                                                                        column: 61,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 125,
                                                                                                                        column: 75,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            value: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'dataTableModel',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 125,
                                                                                                                        column: 61,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 125,
                                                                                                                        column: 75,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            kind: 'init',
                                                                                                            order: '3'
                                                                                                        },
                                                                                                        {
                                                                                                            type: 'Property',
                                                                                                            key: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'tagsColumn',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 125,
                                                                                                                        column: 77,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 125,
                                                                                                                        column: 87,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            value: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'tagsColumn',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 125,
                                                                                                                        column: 77,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 125,
                                                                                                                        column: 87,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            kind: 'init',
                                                                                                            order: '4'
                                                                                                        },
                                                                                                        {
                                                                                                            type: 'Property',
                                                                                                            key: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'add',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 125,
                                                                                                                        column: 89,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 125,
                                                                                                                        column: 92,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            value: {
                                                                                                                type: 'Literal',
                                                                                                                value: true
                                                                                                            },
                                                                                                            kind: 'init',
                                                                                                            order: '5'
                                                                                                        }
                                                                                                    ]
                                                                                                }],
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 125,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 125,
                                                                                                    column: 99,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 125,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 125,
                                                                                                column: 99,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                remove: null,
                                                                order: '5'
                                                            }
                                                        ]
                                                    },
                                                    alternate: {
                                                        type: 'BlockStatement',
                                                        body: [{
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'ObjectExpression',
                                                                    objectType: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'Identifier',
                                                                            name: 'HeaderRow',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 128,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 128,
                                                                                    column: 29,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [{
                                                                                type: 'ObjectExpression',
                                                                                properties: [
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'dataTableModel',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 128,
                                                                                                    column: 31,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 128,
                                                                                                    column: 45,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Identifier',
                                                                                            name: 'dataTableModel',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 128,
                                                                                                    column: 31,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 128,
                                                                                                    column: 45,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'name',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 128,
                                                                                                    column: 47,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 128,
                                                                                                    column: 51,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/UserRowContent.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 'Add Tags...'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '1'
                                                                                    }
                                                                                ]
                                                                            }],
                                                                        loc: {
                                                                            start: {
                                                                                line: 128,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                            },
                                                                            end: {
                                                                                line: 128,
                                                                                column: 68,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/UserRowContent.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    properties: [{
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'title',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 129,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 129,
                                                                                        column: 29,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'You must add Tags to the Task in order to see suggested Resources.'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 128,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                    },
                                                                    end: {
                                                                        line: 131,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/UserRowContent.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    order: '3'
                                                }
                                            ]
                                        },
                                        alternate: null,
                                        order: '3'
                                    }
                                ]
                            },
                            order: '1'
                        }
                    ]
                },
                alternate: null,
                order: '4'
            }
        ],
        bound: false
    }, {
        this: this,
        _ref8: _ref8,
        _ref: _ref,
        glass: glass,
        _ref2: _ref2,
        _ref3: _ref3,
        _ref4: _ref4,
        DataTable: DataTable,
        _ref5: _ref5,
        UserOrgTagsProperty: UserOrgTagsProperty,
        Key: Key,
        style: style,
        RecordChip: RecordChip,
        User: User,
        Tag: Tag,
        _ref11: _ref11,
        UserRow: UserRow,
        HeaderRow: HeaderRow,
        getKeyQueryForTagIndexes: getKeyQueryForTagIndexes,
        getSuggestedUserSearchKeys: getSuggestedUserSearchKeys,
        getSuggestedUsers: getSuggestedUsers
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/UserRowContent',_viewpath_html_UserRowContent_);
    else
      _viewpath_html_UserRowContent_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_UserRowContent_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_createProjectPrompt_ = function(module,exports,require){'use strict';
var ion = require('ion');
var glass = require('glass'), viewpath = require('../'), _ref, _ref2, _ref3, userOrgValues = function (projTypeName) {
        var user = global.model.user;
        var i = 0;
        var _ref6 = [];
        {
            {
                var _ref5 = user.acceptedOrgIds;
                for (var _i = 0; _i < _ref5.length; _i++) {
                    var orgId = _ref5[_i];
                    var org = global.model.orgs[new Key(Organization, orgId)];
                    _ref6.push({
                        id: i++,
                        name: (org != null ? org.name : void 0) != null ? org.name : orgId,
                        orgId: orgId
                    });
                }
            }
            _ref6.push({
                id: i++,
                name: '' + user.name + ' (My Personal ' + projTypeName + 's)',
                orgId: null
            });
        }
        return _ref6;
    }, createProjectPrompt = function (_ref4) {
        var title = _ref4.title;
        var name = _ref4.name;
        var properties = _ref4.properties;
        var create = _ref4.create;
        var callback = _ref4.callback;
        create = create != null ? create : !(callback != null);
        var user = global.model.user;
        var type = properties.type != null ? properties.type : ProjectType.project.id;
        var typeName = ProjectType[type].name;
        var orgValues = userOrgValues(typeName);
        var orgNum = orgValues.length;
        var _ref7 = [];
        {
            if (!(name != null)) {
                _ref7.push(Project.properties.name);
            }
            if (orgNum === 2) {
                _ref7.push({
                    type: 'boolean',
                    name: 'personal',
                    label: 'Personal ' + typeName
                });
            } else if (orgNum > 0) {
                _ref7.push({
                    values: orgValues,
                    name: 'orgId',
                    label: 'Organization'
                });
            }
        }
        PromptDialog.show({
            title: title,
            values: { orgId: 0 },
            properties: _ref7,
            callback: function (values) {
                var object = new Project(properties);
                if (orgNum === 1) {
                    object.orgId = null;
                }
                if (orgNum === 2) {
                    object.orgId = values.personal ? null : orgValues[0].orgId;
                } else if (orgNum != null) {
                    object.orgId = orgValues[values.orgId].orgId;
                }
                object.name = values.name != null ? values.name : name;
                var _ref8 = {};
                _ref8[user.key] = ion.patch.combine(_ref8[user.key], { permission: PermissionLevel.Owner.id });
                object.sharing = _ref8;
                object.key = new Key(Project, model.guid()).toString();
                callback != null ? callback(object) : void 0;
                if (create) {
                    model.server.source.patch(object.key, object);
                    ion.sync();
                    model.open(object.paneConfig);
                }
            }
        });
    };
_ref = glass.data;
var Key = _ref.Key;
_ref2 = glass.html.material;
var PromptDialog = _ref2.PromptDialog;
_ref3 = viewpath.model;
var Project = _ref3.Project;
var ProjectType = _ref3.ProjectType;
var PermissionLevel = _ref3.PermissionLevel;
var Organization = _ref3.Organization;
module.exports = exports = createProjectPrompt;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/createProjectPrompt',_viewpath_html_createProjectPrompt_);
    else
      _viewpath_html_createProjectPrompt_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_createProjectPrompt_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_embed_ApplicationElement_ = function(module,exports,require){if (global.window == null)
    return

const {ApplicationView} = require('./');

customElements.define(
    'viewpath-application',
    class ApplicationElement extends HTMLElement {
        constructor() {
            super()
            var self = this

            var token = this.getAttribute('token')
            var dataUrl = this.getAttribute('data-url')
            ApplicationView({token, dataUrl}, function(element) {
                self.appendChild(element)
            });
        }
        connectedCallback() {
            console.log('connected')
        }
        disconnectedCallback() {
            console.log('disconnected')
        }
        attributeChangedCallback(attributeName, oldValue, newValue, namespace) {
            console.log('attributeChanged', attributeName, oldValue, newValue, namespace)
        }
        adoptedCallback(oldDocument, newDocument) {
            console.log('adopted', oldDocument, newDocument)
        }

    }
)

  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/embed/ApplicationElement',_viewpath_html_embed_ApplicationElement_);
    else
      _viewpath_html_embed_ApplicationElement_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_embed_ApplicationElement_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_embed_ApplicationView_ = function(module,exports,require){'use strict';
var ion = require('ion');
var viewpath = require('../../'), _ref, _ref2, glass = require('glass'), _ref3, _ref4, _ref5;
_ref = viewpath.model;
var ApplicationModel = _ref.ApplicationModel;
_ref2 = viewpath.html;
var Application = _ref2.Application;
_ref3 = glass.html.material;
var LoginDialog = _ref3.LoginDialog;
_ref4 = glass.html;
var Theme = _ref4.Theme;
_ref5 = viewpath.html.themes;
var light = _ref5.light;
var ApplicationViewTemplate = ion.template(function (args) {
        return ion.createRuntime({
            type: 'Template',
            id: null,
            body: [
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: '_ref6'
                            },
                            init: {
                                type: 'Identifier',
                                name: 'args',
                                loc: {
                                    start: {
                                        line: 11,
                                        column: 30,
                                        fixed: true,
                                        source: 'viewpath/html/embed/ApplicationView.ion'
                                    },
                                    end: {
                                        line: 11,
                                        column: 34,
                                        fixed: true,
                                        source: 'viewpath/html/embed/ApplicationView.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '0'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'token',
                                loc: {
                                    start: {
                                        line: 11,
                                        column: 9,
                                        fixed: true,
                                        source: 'viewpath/html/embed/ApplicationView.ion'
                                    },
                                    end: {
                                        line: 11,
                                        column: 14,
                                        fixed: true,
                                        source: 'viewpath/html/embed/ApplicationView.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref6'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'token',
                                    loc: {
                                        start: {
                                            line: 11,
                                            column: 9,
                                            fixed: true,
                                            source: 'viewpath/html/embed/ApplicationView.ion'
                                        },
                                        end: {
                                            line: 11,
                                            column: 14,
                                            fixed: true,
                                            source: 'viewpath/html/embed/ApplicationView.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '1'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'key',
                                loc: {
                                    start: {
                                        line: 11,
                                        column: 15,
                                        fixed: true,
                                        source: 'viewpath/html/embed/ApplicationView.ion'
                                    },
                                    end: {
                                        line: 11,
                                        column: 18,
                                        fixed: true,
                                        source: 'viewpath/html/embed/ApplicationView.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref6'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'key',
                                    loc: {
                                        start: {
                                            line: 11,
                                            column: 15,
                                            fixed: true,
                                            source: 'viewpath/html/embed/ApplicationView.ion'
                                        },
                                        end: {
                                            line: 11,
                                            column: 18,
                                            fixed: true,
                                            source: 'viewpath/html/embed/ApplicationView.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '2'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'dataUrl',
                                loc: {
                                    start: {
                                        line: 11,
                                        column: 19,
                                        fixed: true,
                                        source: 'viewpath/html/embed/ApplicationView.ion'
                                    },
                                    end: {
                                        line: 11,
                                        column: 26,
                                        fixed: true,
                                        source: 'viewpath/html/embed/ApplicationView.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref6'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'dataUrl',
                                    loc: {
                                        start: {
                                            line: 11,
                                            column: 19,
                                            fixed: true,
                                            source: 'viewpath/html/embed/ApplicationView.ion'
                                        },
                                        end: {
                                            line: 11,
                                            column: 26,
                                            fixed: true,
                                            source: 'viewpath/html/embed/ApplicationView.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '3'
                },
                {
                    type: 'IfStatement',
                    test: {
                        type: 'UnaryExpression',
                        operator: '?',
                        argument: {
                            type: 'Identifier',
                            name: 'token',
                            loc: {
                                start: {
                                    line: 12,
                                    column: 7,
                                    fixed: true,
                                    source: 'viewpath/html/embed/ApplicationView.ion'
                                },
                                end: {
                                    line: 12,
                                    column: 12,
                                    fixed: true,
                                    source: 'viewpath/html/embed/ApplicationView.ion'
                                }
                            }
                        }
                    },
                    consequent: {
                        type: 'BlockStatement',
                        body: [{
                                type: 'ExpressionStatement',
                                expression: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'model',
                                            loc: {
                                                start: {
                                                    line: 13,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'viewpath/html/embed/ApplicationView.ion'
                                                },
                                                end: {
                                                    line: 13,
                                                    column: 13,
                                                    fixed: true,
                                                    source: 'viewpath/html/embed/ApplicationView.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'setToken',
                                            loc: {
                                                start: {
                                                    line: 13,
                                                    column: 14,
                                                    fixed: true,
                                                    source: 'viewpath/html/embed/ApplicationView.ion'
                                                },
                                                end: {
                                                    line: 13,
                                                    column: 22,
                                                    fixed: true,
                                                    source: 'viewpath/html/embed/ApplicationView.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 13,
                                                column: 8,
                                                fixed: true,
                                                source: 'viewpath/html/embed/ApplicationView.ion'
                                            },
                                            end: {
                                                line: 13,
                                                column: 22,
                                                fixed: true,
                                                source: 'viewpath/html/embed/ApplicationView.ion'
                                            }
                                        }
                                    },
                                    arguments: [{
                                            type: 'Identifier',
                                            name: 'token',
                                            loc: {
                                                start: {
                                                    line: 13,
                                                    column: 23,
                                                    fixed: true,
                                                    source: 'viewpath/html/embed/ApplicationView.ion'
                                                },
                                                end: {
                                                    line: 13,
                                                    column: 28,
                                                    fixed: true,
                                                    source: 'viewpath/html/embed/ApplicationView.ion'
                                                }
                                            }
                                        }],
                                    loc: {
                                        start: {
                                            line: 13,
                                            column: 8,
                                            fixed: true,
                                            source: 'viewpath/html/embed/ApplicationView.ion'
                                        },
                                        end: {
                                            line: 13,
                                            column: 29,
                                            fixed: true,
                                            source: 'viewpath/html/embed/ApplicationView.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 13,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/html/embed/ApplicationView.ion'
                                    },
                                    end: {
                                        line: 13,
                                        column: 29,
                                        fixed: true,
                                        source: 'viewpath/html/embed/ApplicationView.ion'
                                    }
                                },
                                order: '0'
                            }]
                    },
                    alternate: null,
                    order: '4'
                },
                {
                    type: 'ExpressionStatement',
                    expression: {
                        type: 'CallExpression',
                        callee: {
                            type: 'Identifier',
                            name: 'Theme',
                            loc: {
                                start: {
                                    line: 15,
                                    column: 4,
                                    fixed: true,
                                    source: 'viewpath/html/embed/ApplicationView.ion'
                                },
                                end: {
                                    line: 15,
                                    column: 9,
                                    fixed: true,
                                    source: 'viewpath/html/embed/ApplicationView.ion'
                                }
                            }
                        },
                        arguments: [{
                                type: 'Identifier',
                                name: 'light',
                                loc: {
                                    start: {
                                        line: 15,
                                        column: 10,
                                        fixed: true,
                                        source: 'viewpath/html/embed/ApplicationView.ion'
                                    },
                                    end: {
                                        line: 15,
                                        column: 15,
                                        fixed: true,
                                        source: 'viewpath/html/embed/ApplicationView.ion'
                                    }
                                }
                            }],
                        loc: {
                            start: {
                                line: 15,
                                column: 4,
                                fixed: true,
                                source: 'viewpath/html/embed/ApplicationView.ion'
                            },
                            end: {
                                line: 15,
                                column: 16,
                                fixed: true,
                                source: 'viewpath/html/embed/ApplicationView.ion'
                            }
                        }
                    },
                    loc: {
                        start: {
                            line: 15,
                            column: 4,
                            fixed: true,
                            source: 'viewpath/html/embed/ApplicationView.ion'
                        },
                        end: {
                            line: 15,
                            column: 16,
                            fixed: true,
                            source: 'viewpath/html/embed/ApplicationView.ion'
                        }
                    },
                    order: '5'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'model',
                                loc: {
                                    start: {
                                        line: 17,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/html/embed/ApplicationView.ion'
                                    },
                                    end: {
                                        line: 17,
                                        column: 13,
                                        fixed: true,
                                        source: 'viewpath/html/embed/ApplicationView.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'ApplicationModel',
                                    loc: {
                                        start: {
                                            line: 17,
                                            column: 16,
                                            fixed: true,
                                            source: 'viewpath/html/embed/ApplicationView.ion'
                                        },
                                        end: {
                                            line: 17,
                                            column: 32,
                                            fixed: true,
                                            source: 'viewpath/html/embed/ApplicationView.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'serverUrl',
                                                    loc: {
                                                        start: {
                                                            line: 18,
                                                            column: 8,
                                                            fixed: true,
                                                            source: 'viewpath/html/embed/ApplicationView.ion'
                                                        },
                                                        end: {
                                                            line: 18,
                                                            column: 17,
                                                            fixed: true,
                                                            source: 'viewpath/html/embed/ApplicationView.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'ConditionalExpression',
                                                    test: {
                                                        type: 'BinaryExpression',
                                                        operator: '!=',
                                                        left: {
                                                            type: 'Identifier',
                                                            name: 'dataUrl',
                                                            loc: {
                                                                start: {
                                                                    line: 18,
                                                                    column: 18,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/embed/ApplicationView.ion'
                                                                },
                                                                end: {
                                                                    line: 18,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/embed/ApplicationView.ion'
                                                                }
                                                            }
                                                        },
                                                        right: {
                                                            type: 'Literal',
                                                            value: null
                                                        }
                                                    },
                                                    consequent: {
                                                        type: 'Identifier',
                                                        name: 'dataUrl',
                                                        loc: {
                                                            start: {
                                                                line: 18,
                                                                column: 18,
                                                                fixed: true,
                                                                source: 'viewpath/html/embed/ApplicationView.ion'
                                                            },
                                                            end: {
                                                                line: 18,
                                                                column: 25,
                                                                fixed: true,
                                                                source: 'viewpath/html/embed/ApplicationView.ion'
                                                            }
                                                        }
                                                    },
                                                    alternate: {
                                                        type: 'Literal',
                                                        value: '/data/'
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'namespace',
                                                    loc: {
                                                        start: {
                                                            line: 19,
                                                            column: 8,
                                                            fixed: true,
                                                            source: 'viewpath/html/embed/ApplicationView.ion'
                                                        },
                                                        end: {
                                                            line: 19,
                                                            column: 17,
                                                            fixed: true,
                                                            source: 'viewpath/html/embed/ApplicationView.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'viewpath',
                                                        loc: {
                                                            start: {
                                                                line: 19,
                                                                column: 19,
                                                                fixed: true,
                                                                source: 'viewpath/html/embed/ApplicationView.ion'
                                                            },
                                                            end: {
                                                                line: 19,
                                                                column: 27,
                                                                fixed: true,
                                                                source: 'viewpath/html/embed/ApplicationView.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'model',
                                                        loc: {
                                                            start: {
                                                                line: 19,
                                                                column: 28,
                                                                fixed: true,
                                                                source: 'viewpath/html/embed/ApplicationView.ion'
                                                            },
                                                            end: {
                                                                line: 19,
                                                                column: 33,
                                                                fixed: true,
                                                                source: 'viewpath/html/embed/ApplicationView.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 19,
                                                            column: 19,
                                                            fixed: true,
                                                            source: 'viewpath/html/embed/ApplicationView.ion'
                                                        },
                                                        end: {
                                                            line: 19,
                                                            column: 33,
                                                            fixed: true,
                                                            source: 'viewpath/html/embed/ApplicationView.ion'
                                                        }
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'navigationDefaultState',
                                                    loc: {
                                                        start: {
                                                            line: 20,
                                                            column: 8,
                                                            fixed: true,
                                                            source: 'viewpath/html/embed/ApplicationView.ion'
                                                        },
                                                        end: {
                                                            line: 20,
                                                            column: 30,
                                                            fixed: true,
                                                            source: 'viewpath/html/embed/ApplicationView.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'ObjectExpression',
                                                    properties: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'panes',
                                                                loc: {
                                                                    start: {
                                                                        line: 20,
                                                                        column: 32,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/embed/ApplicationView.ion'
                                                                    },
                                                                    end: {
                                                                        line: 20,
                                                                        column: 37,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/embed/ApplicationView.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'ArrayExpression',
                                                                elements: [{
                                                                        type: 'ObjectExpression',
                                                                        properties: [{
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'id',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 20,
                                                                                            column: 40,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/embed/ApplicationView.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 20,
                                                                                            column: 42,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/embed/ApplicationView.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Literal',
                                                                                    value: 'Projects'
                                                                                },
                                                                                kind: 'init',
                                                                                order: '0'
                                                                            }]
                                                                    }]
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                },
                                                kind: 'init',
                                                order: '2'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'keepHashInSession',
                                                    loc: {
                                                        start: {
                                                            line: 21,
                                                            column: 8,
                                                            fixed: true,
                                                            source: 'viewpath/html/embed/ApplicationView.ion'
                                                        },
                                                        end: {
                                                            line: 21,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'viewpath/html/embed/ApplicationView.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: true
                                                },
                                                kind: 'init',
                                                order: '3'
                                            }
                                        ]
                                    }],
                                loc: {
                                    start: {
                                        line: 17,
                                        column: 16,
                                        fixed: true,
                                        source: 'viewpath/html/embed/ApplicationView.ion'
                                    },
                                    end: {
                                        line: 22,
                                        column: 5,
                                        fixed: true,
                                        source: 'viewpath/html/embed/ApplicationView.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '6'
                },
                {
                    type: 'ExpressionStatement',
                    expression: {
                        type: 'ObjectExpression',
                        objectType: {
                            type: 'Identifier',
                            name: 'window',
                            loc: {
                                start: {
                                    line: 23,
                                    column: 4,
                                    fixed: true,
                                    source: 'viewpath/html/embed/ApplicationView.ion'
                                },
                                end: {
                                    line: 23,
                                    column: 10,
                                    fixed: true,
                                    source: 'viewpath/html/embed/ApplicationView.ion'
                                }
                            }
                        },
                        properties: [
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'model',
                                    loc: {
                                        start: {
                                            line: 24,
                                            column: 8,
                                            fixed: true,
                                            source: 'viewpath/html/embed/ApplicationView.ion'
                                        },
                                        end: {
                                            line: 24,
                                            column: 13,
                                            fixed: true,
                                            source: 'viewpath/html/embed/ApplicationView.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'Identifier',
                                    name: 'model',
                                    loc: {
                                        start: {
                                            line: 24,
                                            column: 15,
                                            fixed: true,
                                            source: 'viewpath/html/embed/ApplicationView.ion'
                                        },
                                        end: {
                                            line: 24,
                                            column: 20,
                                            fixed: true,
                                            source: 'viewpath/html/embed/ApplicationView.ion'
                                        }
                                    }
                                },
                                kind: 'init',
                                order: '0'
                            },
                            {
                                type: 'ExpressionStatement',
                                expression: {
                                    type: 'Function',
                                    context: false,
                                    value: function error(e) {
                                        console.error(e);
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 25,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/html/embed/ApplicationView.ion'
                                    },
                                    end: {
                                        line: 28,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/embed/ApplicationView.ion'
                                    }
                                },
                                order: '1'
                            }
                        ]
                    },
                    loc: {
                        start: {
                            line: 23,
                            column: 4,
                            fixed: true,
                            source: 'viewpath/html/embed/ApplicationView.ion'
                        },
                        end: {
                            line: 28,
                            column: 8,
                            fixed: true,
                            source: 'viewpath/html/embed/ApplicationView.ion'
                        }
                    },
                    order: '7'
                },
                {
                    type: 'ReturnStatement',
                    argument: {
                        type: 'ObjectExpression',
                        objectType: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Application',
                                loc: {
                                    start: {
                                        line: 28,
                                        column: 11,
                                        fixed: true,
                                        source: 'viewpath/html/embed/ApplicationView.ion'
                                    },
                                    end: {
                                        line: 28,
                                        column: 22,
                                        fixed: true,
                                        source: 'viewpath/html/embed/ApplicationView.ion'
                                    }
                                }
                            },
                            arguments: [],
                            loc: {
                                start: {
                                    line: 28,
                                    column: 11,
                                    fixed: true,
                                    source: 'viewpath/html/embed/ApplicationView.ion'
                                },
                                end: {
                                    line: 28,
                                    column: 24,
                                    fixed: true,
                                    source: 'viewpath/html/embed/ApplicationView.ion'
                                }
                            }
                        },
                        properties: [
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'style',
                                    loc: {
                                        start: {
                                            line: 29,
                                            column: 8,
                                            fixed: true,
                                            source: 'viewpath/html/embed/ApplicationView.ion'
                                        },
                                        end: {
                                            line: 29,
                                            column: 13,
                                            fixed: true,
                                            source: 'viewpath/html/embed/ApplicationView.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'ObjectExpression',
                                    properties: [
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'width',
                                                loc: {
                                                    start: {
                                                        line: 30,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/embed/ApplicationView.ion'
                                                    },
                                                    end: {
                                                        line: 30,
                                                        column: 17,
                                                        fixed: true,
                                                        source: 'viewpath/html/embed/ApplicationView.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: 'inherit'
                                            },
                                            kind: 'init',
                                            order: '0'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'height',
                                                loc: {
                                                    start: {
                                                        line: 31,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/embed/ApplicationView.ion'
                                                    },
                                                    end: {
                                                        line: 31,
                                                        column: 18,
                                                        fixed: true,
                                                        source: 'viewpath/html/embed/ApplicationView.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: 'inherit'
                                            },
                                            kind: 'init',
                                            order: '1'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'minWidth',
                                                loc: {
                                                    start: {
                                                        line: 32,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/embed/ApplicationView.ion'
                                                    },
                                                    end: {
                                                        line: 32,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'viewpath/html/embed/ApplicationView.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: '600px'
                                            },
                                            kind: 'init',
                                            order: '2'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'minHeight',
                                                loc: {
                                                    start: {
                                                        line: 33,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/embed/ApplicationView.ion'
                                                    },
                                                    end: {
                                                        line: 33,
                                                        column: 21,
                                                        fixed: true,
                                                        source: 'viewpath/html/embed/ApplicationView.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: '400px'
                                            },
                                            kind: 'init',
                                            order: '3'
                                        }
                                    ]
                                },
                                kind: 'init',
                                order: '0'
                            },
                            {
                                type: 'IfStatement',
                                test: {
                                    type: 'UnaryExpression',
                                    operator: '!',
                                    argument: {
                                        type: 'UnaryExpression',
                                        operator: '?',
                                        argument: {
                                            type: 'Identifier',
                                            name: 'token',
                                            loc: {
                                                start: {
                                                    line: 34,
                                                    column: 15,
                                                    fixed: true,
                                                    source: 'viewpath/html/embed/ApplicationView.ion'
                                                },
                                                end: {
                                                    line: 34,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'viewpath/html/embed/ApplicationView.ion'
                                                }
                                            }
                                        }
                                    }
                                },
                                consequent: {
                                    type: 'BlockStatement',
                                    body: [{
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'LoginDialog',
                                                    loc: {
                                                        start: {
                                                            line: 35,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/embed/ApplicationView.ion'
                                                        },
                                                        end: {
                                                            line: 35,
                                                            column: 23,
                                                            fixed: true,
                                                            source: 'viewpath/html/embed/ApplicationView.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [{
                                                        type: 'ObjectExpression',
                                                        properties: [
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'title',
                                                                    loc: {
                                                                        start: {
                                                                            line: 35,
                                                                            column: 25,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/embed/ApplicationView.ion'
                                                                        },
                                                                        end: {
                                                                            line: 35,
                                                                            column: 30,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/embed/ApplicationView.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: 'Viewpath Login'
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'loader',
                                                                    loc: {
                                                                        start: {
                                                                            line: 35,
                                                                            column: 49,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/embed/ApplicationView.ion'
                                                                        },
                                                                        end: {
                                                                            line: 35,
                                                                            column: 55,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/embed/ApplicationView.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Identifier',
                                                                    name: 'Loader',
                                                                    loc: {
                                                                        start: {
                                                                            line: 35,
                                                                            column: 56,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/embed/ApplicationView.ion'
                                                                        },
                                                                        end: {
                                                                            line: 35,
                                                                            column: 62,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/embed/ApplicationView.ion'
                                                                        }
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '1'
                                                            }
                                                        ]
                                                    }],
                                                loc: {
                                                    start: {
                                                        line: 35,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/embed/ApplicationView.ion'
                                                    },
                                                    end: {
                                                        line: 35,
                                                        column: 64,
                                                        fixed: true,
                                                        source: 'viewpath/html/embed/ApplicationView.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 35,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/embed/ApplicationView.ion'
                                                },
                                                end: {
                                                    line: 35,
                                                    column: 64,
                                                    fixed: true,
                                                    source: 'viewpath/html/embed/ApplicationView.ion'
                                                }
                                            },
                                            order: '0'
                                        }]
                                },
                                alternate: null,
                                order: '1'
                            }
                        ]
                    },
                    order: '8'
                }
            ],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'ApplicationViewTemplate',
                loc: {
                    start: {
                        line: 10,
                        column: 6,
                        fixed: true,
                        source: 'viewpath/html/embed/ApplicationView.ion'
                    },
                    end: {
                        line: 10,
                        column: 29,
                        fixed: true,
                        source: 'viewpath/html/embed/ApplicationView.ion'
                    }
                }
            }
        }, {
            this: this,
            args: args,
            viewpath: viewpath,
            _ref: _ref,
            _ref2: _ref2,
            glass: glass,
            _ref3: _ref3,
            _ref4: _ref4,
            _ref5: _ref5,
            ApplicationModel: ApplicationModel,
            Application: Application,
            LoginDialog: LoginDialog,
            Theme: Theme,
            light: light,
            ApplicationViewTemplate: ApplicationViewTemplate
        }, null);
    });
module.exports = exports = function (args, callback) {
    return ApplicationViewTemplate(args).observe(callback);
};
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/embed/ApplicationView',_viewpath_html_embed_ApplicationView_);
    else
      _viewpath_html_embed_ApplicationView_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_embed_ApplicationView_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_embed_ProjectElement_ = function(module,exports,require){if (global.window == null)
    return

const {ProjectView} = require('./');

customElements.define(
    'viewpath-project',
    class ProjectElement extends HTMLElement {
        constructor() {
            super()
            var self = this

            var token = this.getAttribute('token')
            var key = this.getAttribute('key')
            var dataUrl = this.getAttribute('data-url')
            ProjectView({token, key, dataUrl}, function(element) {
                self.appendChild(element)
            });
        }
        connectedCallback() {
            console.log('connected')
        }
        disconnectedCallback() {
            console.log('disconnected')
        }
        attributeChangedCallback(attributeName, oldValue, newValue, namespace) {
            console.log('attributeChanged', attributeName, oldValue, newValue, namespace)
        }
        adoptedCallback(oldDocument, newDocument) {
            console.log('adopted', oldDocument, newDocument)
        }

    }
)

  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/embed/ProjectElement',_viewpath_html_embed_ProjectElement_);
    else
      _viewpath_html_embed_ProjectElement_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_embed_ProjectElement_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_embed_ProjectView_ = function(module,exports,require){'use strict';
var ion = require('ion');
var viewpath = require('../../'), _ref, _ref2, glass = require('glass'), _ref3, _ref4, _ref5;
_ref = viewpath.model;
var ApplicationModel = _ref.ApplicationModel;
_ref2 = viewpath.html;
var Application = _ref2.Application;
_ref3 = glass.html.material;
var LoginDialog = _ref3.LoginDialog;
_ref4 = glass.html;
var Theme = _ref4.Theme;
_ref5 = viewpath.html.themes;
var light = _ref5.light;
var ProjectViewTemplate = ion.template(function (_ref6) {
        return ion.createRuntime({
            type: 'Template',
            id: null,
            body: [
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'token',
                                loc: {
                                    start: {
                                        line: 11,
                                        column: 39,
                                        fixed: true,
                                        source: 'viewpath/html/embed/ProjectView.ion'
                                    },
                                    end: {
                                        line: 11,
                                        column: 44,
                                        fixed: true,
                                        source: 'viewpath/html/embed/ProjectView.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref6'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'token',
                                    loc: {
                                        start: {
                                            line: 11,
                                            column: 39,
                                            fixed: true,
                                            source: 'viewpath/html/embed/ProjectView.ion'
                                        },
                                        end: {
                                            line: 11,
                                            column: 44,
                                            fixed: true,
                                            source: 'viewpath/html/embed/ProjectView.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '0'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'key',
                                loc: {
                                    start: {
                                        line: 11,
                                        column: 45,
                                        fixed: true,
                                        source: 'viewpath/html/embed/ProjectView.ion'
                                    },
                                    end: {
                                        line: 11,
                                        column: 48,
                                        fixed: true,
                                        source: 'viewpath/html/embed/ProjectView.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref6'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'key',
                                    loc: {
                                        start: {
                                            line: 11,
                                            column: 45,
                                            fixed: true,
                                            source: 'viewpath/html/embed/ProjectView.ion'
                                        },
                                        end: {
                                            line: 11,
                                            column: 48,
                                            fixed: true,
                                            source: 'viewpath/html/embed/ProjectView.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '1'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'dataUrl',
                                loc: {
                                    start: {
                                        line: 11,
                                        column: 49,
                                        fixed: true,
                                        source: 'viewpath/html/embed/ProjectView.ion'
                                    },
                                    end: {
                                        line: 11,
                                        column: 56,
                                        fixed: true,
                                        source: 'viewpath/html/embed/ProjectView.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref6'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'dataUrl',
                                    loc: {
                                        start: {
                                            line: 11,
                                            column: 49,
                                            fixed: true,
                                            source: 'viewpath/html/embed/ProjectView.ion'
                                        },
                                        end: {
                                            line: 11,
                                            column: 56,
                                            fixed: true,
                                            source: 'viewpath/html/embed/ProjectView.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '2'
                },
                {
                    type: 'ExpressionStatement',
                    expression: {
                        type: 'CallExpression',
                        callee: {
                            type: 'Identifier',
                            name: 'Theme',
                            loc: {
                                start: {
                                    line: 12,
                                    column: 4,
                                    fixed: true,
                                    source: 'viewpath/html/embed/ProjectView.ion'
                                },
                                end: {
                                    line: 12,
                                    column: 9,
                                    fixed: true,
                                    source: 'viewpath/html/embed/ProjectView.ion'
                                }
                            }
                        },
                        arguments: [{
                                type: 'Identifier',
                                name: 'light',
                                loc: {
                                    start: {
                                        line: 12,
                                        column: 10,
                                        fixed: true,
                                        source: 'viewpath/html/embed/ProjectView.ion'
                                    },
                                    end: {
                                        line: 12,
                                        column: 15,
                                        fixed: true,
                                        source: 'viewpath/html/embed/ProjectView.ion'
                                    }
                                }
                            }],
                        loc: {
                            start: {
                                line: 12,
                                column: 4,
                                fixed: true,
                                source: 'viewpath/html/embed/ProjectView.ion'
                            },
                            end: {
                                line: 12,
                                column: 16,
                                fixed: true,
                                source: 'viewpath/html/embed/ProjectView.ion'
                            }
                        }
                    },
                    loc: {
                        start: {
                            line: 12,
                            column: 4,
                            fixed: true,
                            source: 'viewpath/html/embed/ProjectView.ion'
                        },
                        end: {
                            line: 12,
                            column: 16,
                            fixed: true,
                            source: 'viewpath/html/embed/ProjectView.ion'
                        }
                    },
                    order: '3'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'model',
                                loc: {
                                    start: {
                                        line: 13,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/html/embed/ProjectView.ion'
                                    },
                                    end: {
                                        line: 13,
                                        column: 13,
                                        fixed: true,
                                        source: 'viewpath/html/embed/ProjectView.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'ApplicationModel',
                                    loc: {
                                        start: {
                                            line: 13,
                                            column: 16,
                                            fixed: true,
                                            source: 'viewpath/html/embed/ProjectView.ion'
                                        },
                                        end: {
                                            line: 13,
                                            column: 32,
                                            fixed: true,
                                            source: 'viewpath/html/embed/ProjectView.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'serverUrl',
                                                    loc: {
                                                        start: {
                                                            line: 14,
                                                            column: 8,
                                                            fixed: true,
                                                            source: 'viewpath/html/embed/ProjectView.ion'
                                                        },
                                                        end: {
                                                            line: 14,
                                                            column: 17,
                                                            fixed: true,
                                                            source: 'viewpath/html/embed/ProjectView.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'ConditionalExpression',
                                                    test: {
                                                        type: 'BinaryExpression',
                                                        operator: '!=',
                                                        left: {
                                                            type: 'Identifier',
                                                            name: 'dataUrl',
                                                            loc: {
                                                                start: {
                                                                    line: 14,
                                                                    column: 18,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/embed/ProjectView.ion'
                                                                },
                                                                end: {
                                                                    line: 14,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/embed/ProjectView.ion'
                                                                }
                                                            }
                                                        },
                                                        right: {
                                                            type: 'Literal',
                                                            value: null
                                                        }
                                                    },
                                                    consequent: {
                                                        type: 'Identifier',
                                                        name: 'dataUrl',
                                                        loc: {
                                                            start: {
                                                                line: 14,
                                                                column: 18,
                                                                fixed: true,
                                                                source: 'viewpath/html/embed/ProjectView.ion'
                                                            },
                                                            end: {
                                                                line: 14,
                                                                column: 25,
                                                                fixed: true,
                                                                source: 'viewpath/html/embed/ProjectView.ion'
                                                            }
                                                        }
                                                    },
                                                    alternate: {
                                                        type: 'Literal',
                                                        value: '/data/'
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'namespace',
                                                    loc: {
                                                        start: {
                                                            line: 15,
                                                            column: 8,
                                                            fixed: true,
                                                            source: 'viewpath/html/embed/ProjectView.ion'
                                                        },
                                                        end: {
                                                            line: 15,
                                                            column: 17,
                                                            fixed: true,
                                                            source: 'viewpath/html/embed/ProjectView.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'viewpath',
                                                        loc: {
                                                            start: {
                                                                line: 15,
                                                                column: 19,
                                                                fixed: true,
                                                                source: 'viewpath/html/embed/ProjectView.ion'
                                                            },
                                                            end: {
                                                                line: 15,
                                                                column: 27,
                                                                fixed: true,
                                                                source: 'viewpath/html/embed/ProjectView.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'model',
                                                        loc: {
                                                            start: {
                                                                line: 15,
                                                                column: 28,
                                                                fixed: true,
                                                                source: 'viewpath/html/embed/ProjectView.ion'
                                                            },
                                                            end: {
                                                                line: 15,
                                                                column: 33,
                                                                fixed: true,
                                                                source: 'viewpath/html/embed/ProjectView.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 15,
                                                            column: 19,
                                                            fixed: true,
                                                            source: 'viewpath/html/embed/ProjectView.ion'
                                                        },
                                                        end: {
                                                            line: 15,
                                                            column: 33,
                                                            fixed: true,
                                                            source: 'viewpath/html/embed/ProjectView.ion'
                                                        }
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'navigationDefaultState',
                                                    loc: {
                                                        start: {
                                                            line: 16,
                                                            column: 8,
                                                            fixed: true,
                                                            source: 'viewpath/html/embed/ProjectView.ion'
                                                        },
                                                        end: {
                                                            line: 16,
                                                            column: 30,
                                                            fixed: true,
                                                            source: 'viewpath/html/embed/ProjectView.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'ObjectExpression',
                                                    properties: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'panes',
                                                                loc: {
                                                                    start: {
                                                                        line: 16,
                                                                        column: 33,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/embed/ProjectView.ion'
                                                                    },
                                                                    end: {
                                                                        line: 16,
                                                                        column: 38,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/embed/ProjectView.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'ArrayExpression',
                                                                elements: [{
                                                                        type: 'ObjectExpression',
                                                                        properties: [
                                                                            {
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'id',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 16,
                                                                                            column: 41,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/embed/ProjectView.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 16,
                                                                                            column: 43,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/embed/ProjectView.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Literal',
                                                                                    value: 'Project'
                                                                                },
                                                                                kind: 'init',
                                                                                order: '0'
                                                                            },
                                                                            {
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'key',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 16,
                                                                                            column: 55,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/embed/ProjectView.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 16,
                                                                                            column: 58,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/embed/ProjectView.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Identifier',
                                                                                    name: 'key',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 16,
                                                                                            column: 55,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/embed/ProjectView.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 16,
                                                                                            column: 58,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/embed/ProjectView.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                kind: 'init',
                                                                                order: '1'
                                                                            }
                                                                        ]
                                                                    }]
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                },
                                                kind: 'init',
                                                order: '2'
                                            }
                                        ]
                                    }],
                                loc: {
                                    start: {
                                        line: 13,
                                        column: 16,
                                        fixed: true,
                                        source: 'viewpath/html/embed/ProjectView.ion'
                                    },
                                    end: {
                                        line: 17,
                                        column: 5,
                                        fixed: true,
                                        source: 'viewpath/html/embed/ProjectView.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '4'
                },
                {
                    type: 'IfStatement',
                    test: {
                        type: 'UnaryExpression',
                        operator: '?',
                        argument: {
                            type: 'Identifier',
                            name: 'token',
                            loc: {
                                start: {
                                    line: 18,
                                    column: 7,
                                    fixed: true,
                                    source: 'viewpath/html/embed/ProjectView.ion'
                                },
                                end: {
                                    line: 18,
                                    column: 12,
                                    fixed: true,
                                    source: 'viewpath/html/embed/ProjectView.ion'
                                }
                            }
                        }
                    },
                    consequent: {
                        type: 'BlockStatement',
                        body: [{
                                type: 'ExpressionStatement',
                                expression: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'model',
                                            loc: {
                                                start: {
                                                    line: 19,
                                                    column: 8,
                                                    fixed: true,
                                                    source: 'viewpath/html/embed/ProjectView.ion'
                                                },
                                                end: {
                                                    line: 19,
                                                    column: 13,
                                                    fixed: true,
                                                    source: 'viewpath/html/embed/ProjectView.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'setToken',
                                            loc: {
                                                start: {
                                                    line: 19,
                                                    column: 14,
                                                    fixed: true,
                                                    source: 'viewpath/html/embed/ProjectView.ion'
                                                },
                                                end: {
                                                    line: 19,
                                                    column: 22,
                                                    fixed: true,
                                                    source: 'viewpath/html/embed/ProjectView.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 19,
                                                column: 8,
                                                fixed: true,
                                                source: 'viewpath/html/embed/ProjectView.ion'
                                            },
                                            end: {
                                                line: 19,
                                                column: 22,
                                                fixed: true,
                                                source: 'viewpath/html/embed/ProjectView.ion'
                                            }
                                        }
                                    },
                                    arguments: [{
                                            type: 'Identifier',
                                            name: 'token',
                                            loc: {
                                                start: {
                                                    line: 19,
                                                    column: 23,
                                                    fixed: true,
                                                    source: 'viewpath/html/embed/ProjectView.ion'
                                                },
                                                end: {
                                                    line: 19,
                                                    column: 28,
                                                    fixed: true,
                                                    source: 'viewpath/html/embed/ProjectView.ion'
                                                }
                                            }
                                        }],
                                    loc: {
                                        start: {
                                            line: 19,
                                            column: 8,
                                            fixed: true,
                                            source: 'viewpath/html/embed/ProjectView.ion'
                                        },
                                        end: {
                                            line: 19,
                                            column: 29,
                                            fixed: true,
                                            source: 'viewpath/html/embed/ProjectView.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 19,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/html/embed/ProjectView.ion'
                                    },
                                    end: {
                                        line: 19,
                                        column: 29,
                                        fixed: true,
                                        source: 'viewpath/html/embed/ProjectView.ion'
                                    }
                                },
                                order: '0'
                            }]
                    },
                    alternate: null,
                    order: '5'
                },
                {
                    type: 'ExpressionStatement',
                    expression: {
                        type: 'ObjectExpression',
                        objectType: {
                            type: 'Identifier',
                            name: 'window',
                            loc: {
                                start: {
                                    line: 20,
                                    column: 4,
                                    fixed: true,
                                    source: 'viewpath/html/embed/ProjectView.ion'
                                },
                                end: {
                                    line: 20,
                                    column: 10,
                                    fixed: true,
                                    source: 'viewpath/html/embed/ProjectView.ion'
                                }
                            }
                        },
                        properties: [{
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'model',
                                    loc: {
                                        start: {
                                            line: 21,
                                            column: 8,
                                            fixed: true,
                                            source: 'viewpath/html/embed/ProjectView.ion'
                                        },
                                        end: {
                                            line: 21,
                                            column: 13,
                                            fixed: true,
                                            source: 'viewpath/html/embed/ProjectView.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'Identifier',
                                    name: 'model',
                                    loc: {
                                        start: {
                                            line: 21,
                                            column: 15,
                                            fixed: true,
                                            source: 'viewpath/html/embed/ProjectView.ion'
                                        },
                                        end: {
                                            line: 21,
                                            column: 20,
                                            fixed: true,
                                            source: 'viewpath/html/embed/ProjectView.ion'
                                        }
                                    }
                                },
                                kind: 'init',
                                order: '0'
                            }]
                    },
                    loc: {
                        start: {
                            line: 20,
                            column: 4,
                            fixed: true,
                            source: 'viewpath/html/embed/ProjectView.ion'
                        },
                        end: {
                            line: 23,
                            column: 8,
                            fixed: true,
                            source: 'viewpath/html/embed/ProjectView.ion'
                        }
                    },
                    order: '6'
                },
                {
                    type: 'ReturnStatement',
                    argument: {
                        type: 'ObjectExpression',
                        objectType: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Application',
                                loc: {
                                    start: {
                                        line: 25,
                                        column: 11,
                                        fixed: true,
                                        source: 'viewpath/html/embed/ProjectView.ion'
                                    },
                                    end: {
                                        line: 25,
                                        column: 22,
                                        fixed: true,
                                        source: 'viewpath/html/embed/ProjectView.ion'
                                    }
                                }
                            },
                            arguments: [],
                            loc: {
                                start: {
                                    line: 25,
                                    column: 11,
                                    fixed: true,
                                    source: 'viewpath/html/embed/ProjectView.ion'
                                },
                                end: {
                                    line: 25,
                                    column: 24,
                                    fixed: true,
                                    source: 'viewpath/html/embed/ProjectView.ion'
                                }
                            }
                        },
                        properties: [
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'style',
                                    loc: {
                                        start: {
                                            line: 26,
                                            column: 8,
                                            fixed: true,
                                            source: 'viewpath/html/embed/ProjectView.ion'
                                        },
                                        end: {
                                            line: 26,
                                            column: 13,
                                            fixed: true,
                                            source: 'viewpath/html/embed/ProjectView.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'ObjectExpression',
                                    properties: [
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'width',
                                                loc: {
                                                    start: {
                                                        line: 27,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/embed/ProjectView.ion'
                                                    },
                                                    end: {
                                                        line: 27,
                                                        column: 17,
                                                        fixed: true,
                                                        source: 'viewpath/html/embed/ProjectView.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: 'inherit'
                                            },
                                            kind: 'init',
                                            order: '0'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'height',
                                                loc: {
                                                    start: {
                                                        line: 28,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/embed/ProjectView.ion'
                                                    },
                                                    end: {
                                                        line: 28,
                                                        column: 18,
                                                        fixed: true,
                                                        source: 'viewpath/html/embed/ProjectView.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: 'inherit'
                                            },
                                            kind: 'init',
                                            order: '1'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'minWidth',
                                                loc: {
                                                    start: {
                                                        line: 29,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/embed/ProjectView.ion'
                                                    },
                                                    end: {
                                                        line: 29,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'viewpath/html/embed/ProjectView.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: '600px'
                                            },
                                            kind: 'init',
                                            order: '2'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'minHeight',
                                                loc: {
                                                    start: {
                                                        line: 30,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/embed/ProjectView.ion'
                                                    },
                                                    end: {
                                                        line: 30,
                                                        column: 21,
                                                        fixed: true,
                                                        source: 'viewpath/html/embed/ProjectView.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: '400px'
                                            },
                                            kind: 'init',
                                            order: '3'
                                        }
                                    ]
                                },
                                kind: 'init',
                                order: '0'
                            },
                            {
                                type: 'IfStatement',
                                test: {
                                    type: 'UnaryExpression',
                                    operator: '!',
                                    argument: {
                                        type: 'UnaryExpression',
                                        operator: '?',
                                        argument: {
                                            type: 'Identifier',
                                            name: 'token',
                                            loc: {
                                                start: {
                                                    line: 31,
                                                    column: 15,
                                                    fixed: true,
                                                    source: 'viewpath/html/embed/ProjectView.ion'
                                                },
                                                end: {
                                                    line: 31,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'viewpath/html/embed/ProjectView.ion'
                                                }
                                            }
                                        }
                                    }
                                },
                                consequent: {
                                    type: 'BlockStatement',
                                    body: [{
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'LoginDialog',
                                                    loc: {
                                                        start: {
                                                            line: 32,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/embed/ProjectView.ion'
                                                        },
                                                        end: {
                                                            line: 32,
                                                            column: 23,
                                                            fixed: true,
                                                            source: 'viewpath/html/embed/ProjectView.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [{
                                                        type: 'ObjectExpression',
                                                        properties: [{
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'title',
                                                                    loc: {
                                                                        start: {
                                                                            line: 32,
                                                                            column: 25,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/embed/ProjectView.ion'
                                                                        },
                                                                        end: {
                                                                            line: 32,
                                                                            column: 30,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/embed/ProjectView.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: 'Viewpath Login'
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            }]
                                                    }],
                                                loc: {
                                                    start: {
                                                        line: 32,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/embed/ProjectView.ion'
                                                    },
                                                    end: {
                                                        line: 32,
                                                        column: 49,
                                                        fixed: true,
                                                        source: 'viewpath/html/embed/ProjectView.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 32,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/embed/ProjectView.ion'
                                                },
                                                end: {
                                                    line: 32,
                                                    column: 49,
                                                    fixed: true,
                                                    source: 'viewpath/html/embed/ProjectView.ion'
                                                }
                                            },
                                            order: '0'
                                        }]
                                },
                                alternate: null,
                                order: '1'
                            }
                        ]
                    },
                    order: '7'
                }
            ],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'ProjectViewTemplate',
                loc: {
                    start: {
                        line: 11,
                        column: 6,
                        fixed: true,
                        source: 'viewpath/html/embed/ProjectView.ion'
                    },
                    end: {
                        line: 11,
                        column: 25,
                        fixed: true,
                        source: 'viewpath/html/embed/ProjectView.ion'
                    }
                }
            }
        }, {
            this: this,
            _ref6: _ref6,
            viewpath: viewpath,
            _ref: _ref,
            _ref2: _ref2,
            glass: glass,
            _ref3: _ref3,
            _ref4: _ref4,
            _ref5: _ref5,
            ApplicationModel: ApplicationModel,
            Application: Application,
            LoginDialog: LoginDialog,
            Theme: Theme,
            light: light,
            ProjectViewTemplate: ProjectViewTemplate
        }, null);
    });
module.exports = exports = function (args, callback) {
    return ProjectViewTemplate(args).observe(callback);
};
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/embed/ProjectView',_viewpath_html_embed_ProjectView_);
    else
      _viewpath_html_embed_ProjectView_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_embed_ProjectView_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_embed_index_ = function(module,exports,require){Object.defineProperty(exports, 'ApplicationElement', {get:function(){ return require('./ApplicationElement') }, enumerable: true}) 
Object.defineProperty(exports, 'ApplicationView', {get:function(){ return require('./ApplicationView') }, enumerable: true}) 
Object.defineProperty(exports, 'ProjectElement', {get:function(){ return require('./ProjectElement') }, enumerable: true}) 
Object.defineProperty(exports, 'ProjectView', {get:function(){ return require('./ProjectView') }, enumerable: true}) 
Object.freeze(exports)
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/embed/index',_viewpath_html_embed_index_);
    else
      _viewpath_html_embed_index_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_embed_index_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_index_ = function(module,exports,require){Object.defineProperty(exports, 'AdminProperty', {get:function(){ return require('./AdminProperty') }, enumerable: true}) 
Object.defineProperty(exports, 'Application', {get:function(){ return require('./Application') }, enumerable: true}) 
Object.defineProperty(exports, 'AssignedColumn', {get:function(){ return require('./AssignedColumn') }, enumerable: true}) 
Object.defineProperty(exports, 'CommentItem', {get:function(){ return require('./CommentItem') }, enumerable: true}) 
Object.defineProperty(exports, 'DaysOfWeekField', {get:function(){ return require('./DaysOfWeekField') }, enumerable: true}) 
Object.defineProperty(exports, 'DiscussionEditor', {get:function(){ return require('./DiscussionEditor') }, enumerable: true}) 
Object.defineProperty(exports, 'DocumentColumn', {get:function(){ return require('./DocumentColumn') }, enumerable: true}) 
Object.defineProperty(exports, 'DocumentDialog', {get:function(){ return require('./DocumentDialog') }, enumerable: true}) 
Object.defineProperty(exports, 'GanttColumn', {get:function(){ return require('./GanttColumn') }, enumerable: true}) 
Object.defineProperty(exports, 'InviteUserDialog', {get:function(){ return require('./InviteUserDialog') }, enumerable: true}) 
Object.defineProperty(exports, 'Item', {get:function(){ return require('./Item') }, enumerable: true}) 
Object.defineProperty(exports, 'Items', {get:function(){ return require('./Items') }, enumerable: true}) 
Object.defineProperty(exports, 'ItemsDisplayToggle', {get:function(){ return require('./ItemsDisplayToggle') }, enumerable: true}) 
Object.defineProperty(exports, 'Loader', {get:function(){ return require('./Loader') }, enumerable: true}) 
Object.defineProperty(exports, 'NavDrawer', {get:function(){ return require('./NavDrawer') }, enumerable: true}) 
Object.defineProperty(exports, 'NewOrgDialog', {get:function(){ return require('./NewOrgDialog') }, enumerable: true}) 
Object.defineProperty(exports, 'NewOrgField', {get:function(){ return require('./NewOrgField') }, enumerable: true}) 
Object.defineProperty(exports, 'RepeatField', {get:function(){ return require('./RepeatField') }, enumerable: true}) 
Object.defineProperty(exports, 'SetupWizard', {get:function(){ return require('./SetupWizard') }, enumerable: true}) 
Object.defineProperty(exports, 'StatusColumn', {get:function(){ return require('./StatusColumn') }, enumerable: true}) 
Object.defineProperty(exports, 'SubscriptionNotice', {get:function(){ return require('./SubscriptionNotice') }, enumerable: true}) 
Object.defineProperty(exports, 'TaskItem', {get:function(){ return require('./TaskItem') }, enumerable: true}) 
Object.defineProperty(exports, 'TaskScheduleInput', {get:function(){ return require('./TaskScheduleInput') }, enumerable: true}) 
Object.defineProperty(exports, 'TaskTimelineBox', {get:function(){ return require('./TaskTimelineBox') }, enumerable: true}) 
Object.defineProperty(exports, 'TimeAndUnitInput', {get:function(){ return require('./TimeAndUnitInput') }, enumerable: true}) 
Object.defineProperty(exports, 'UserAutoCompleteField', {get:function(){ return require('./UserAutoCompleteField') }, enumerable: true}) 
Object.defineProperty(exports, 'UserChip', {get:function(){ return require('./UserChip') }, enumerable: true}) 
Object.defineProperty(exports, 'UserItem', {get:function(){ return require('./UserItem') }, enumerable: true}) 
Object.defineProperty(exports, 'UserOrgAcceptedProperty', {get:function(){ return require('./UserOrgAcceptedProperty') }, enumerable: true}) 
Object.defineProperty(exports, 'UserOrgCalendarsProperty', {get:function(){ return require('./UserOrgCalendarsProperty') }, enumerable: true}) 
Object.defineProperty(exports, 'UserOrgInvitedProperty', {get:function(){ return require('./UserOrgInvitedProperty') }, enumerable: true}) 
Object.defineProperty(exports, 'UserOrgTagsProperty', {get:function(){ return require('./UserOrgTagsProperty') }, enumerable: true}) 
Object.defineProperty(exports, 'UserResult', {get:function(){ return require('./UserResult') }, enumerable: true}) 
Object.defineProperty(exports, 'UserRowContent', {get:function(){ return require('./UserRowContent') }, enumerable: true}) 
Object.defineProperty(exports, 'createProjectPrompt', {get:function(){ return require('./createProjectPrompt') }, enumerable: true}) 
Object.defineProperty(exports, 'embed', {get:function(){ return require('./embed') }, enumerable: true}) 
Object.defineProperty(exports, 'panes', {get:function(){ return require('./panes') }, enumerable: true}) 
Object.defineProperty(exports, 'themes', {get:function(){ return require('./themes') }, enumerable: true}) 
Object.freeze(exports)
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/index',_viewpath_html_index_);
    else
      _viewpath_html_index_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_index_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_panes_DashboardPane_ = function(module,exports,require){'use strict';
var ion = require('ion'), glass = require('glass'), _ref, _ref2, _ref3, _ref4, style = glass.html.style, _ref5, namespace = require('../../model'), _ref6, _ref7;
_ref = glass.time;
var DateTime = _ref.DateTime;
_ref2 = glass.html.material;
var RecordChip = _ref2.RecordChip;
var RecordIcon = _ref2.RecordIcon;
_ref3 = glass.html.material;
var PromptDialog = _ref3.PromptDialog;
_ref4 = glass.data;
var Key = _ref4.Key;
_ref5 = require('../../html');
var SetupWizard = _ref5.SetupWizard;
var SubscriptionNotice = _ref5.SubscriptionNotice;
_ref6 = namespace;
var Task = _ref6.Task;
var Project = _ref6.Project;
var ProjectType = _ref6.ProjectType;
var User = _ref6.User;
var Comment = _ref6.Comment;
_ref7 = require('../');
var createProjectPrompt = _ref7.createProjectPrompt;
var lightGray = style.black(0.1), gray = style.black(0.21), darkGray = style.black(0.47);
ion.template(function () {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [{
                type: 'ExpressionStatement',
                expression: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'MemberExpression',
                        computed: false,
                        object: {
                            type: 'Identifier',
                            name: 'style',
                            loc: {
                                start: {
                                    line: 21,
                                    column: 4,
                                    fixed: true,
                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                },
                                end: {
                                    line: 21,
                                    column: 9,
                                    fixed: true,
                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                }
                            }
                        },
                        property: {
                            type: 'Identifier',
                            name: 'sheets',
                            loc: {
                                start: {
                                    line: 21,
                                    column: 10,
                                    fixed: true,
                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                },
                                end: {
                                    line: 21,
                                    column: 16,
                                    fixed: true,
                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                }
                            }
                        },
                        loc: {
                            start: {
                                line: 21,
                                column: 4,
                                fixed: true,
                                source: 'viewpath/html/panes/DashboardPane.ion'
                            },
                            end: {
                                line: 21,
                                column: 16,
                                fixed: true,
                                source: 'viewpath/html/panes/DashboardPane.ion'
                            }
                        }
                    },
                    properties: [{
                            type: 'Property',
                            key: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'module',
                                    loc: {
                                        start: {
                                            line: 22,
                                            column: 9,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        },
                                        end: {
                                            line: 22,
                                            column: 15,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'id',
                                    loc: {
                                        start: {
                                            line: 22,
                                            column: 16,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        },
                                        end: {
                                            line: 22,
                                            column: 18,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 22,
                                        column: 9,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 22,
                                        column: 18,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'BinaryExpression',
                                operator: '+',
                                left: {
                                    type: 'BinaryExpression',
                                    operator: '+',
                                    left: {
                                        type: 'BinaryExpression',
                                        operator: '+',
                                        left: {
                                            type: 'BinaryExpression',
                                            operator: '+',
                                            left: {
                                                type: 'BinaryExpression',
                                                operator: '+',
                                                left: {
                                                    type: 'BinaryExpression',
                                                    operator: '+',
                                                    left: {
                                                        type: 'BinaryExpression',
                                                        operator: '+',
                                                        left: {
                                                            type: 'BinaryExpression',
                                                            operator: '+',
                                                            left: {
                                                                type: 'BinaryExpression',
                                                                operator: '+',
                                                                left: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '+',
                                                                    left: {
                                                                        type: 'BinaryExpression',
                                                                        operator: '+',
                                                                        left: {
                                                                            type: 'BinaryExpression',
                                                                            operator: '+',
                                                                            left: {
                                                                                type: 'BinaryExpression',
                                                                                operator: '+',
                                                                                left: {
                                                                                    type: 'BinaryExpression',
                                                                                    operator: '+',
                                                                                    left: {
                                                                                        type: 'BinaryExpression',
                                                                                        operator: '+',
                                                                                        left: {
                                                                                            type: 'BinaryExpression',
                                                                                            operator: '+',
                                                                                            left: {
                                                                                                type: 'BinaryExpression',
                                                                                                operator: '+',
                                                                                                left: {
                                                                                                    type: 'BinaryExpression',
                                                                                                    operator: '+',
                                                                                                    left: {
                                                                                                        type: 'BinaryExpression',
                                                                                                        operator: '+',
                                                                                                        left: {
                                                                                                            type: 'BinaryExpression',
                                                                                                            operator: '+',
                                                                                                            left: {
                                                                                                                type: 'BinaryExpression',
                                                                                                                operator: '+',
                                                                                                                left: {
                                                                                                                    type: 'BinaryExpression',
                                                                                                                    operator: '+',
                                                                                                                    left: {
                                                                                                                        type: 'BinaryExpression',
                                                                                                                        operator: '+',
                                                                                                                        left: {
                                                                                                                            type: 'BinaryExpression',
                                                                                                                            operator: '+',
                                                                                                                            left: {
                                                                                                                                type: 'BinaryExpression',
                                                                                                                                operator: '+',
                                                                                                                                left: {
                                                                                                                                    type: 'BinaryExpression',
                                                                                                                                    operator: '+',
                                                                                                                                    left: {
                                                                                                                                        type: 'Literal',
                                                                                                                                        value: '.dashboard-content {\n    background-color: '
                                                                                                                                    },
                                                                                                                                    right: {
                                                                                                                                        type: 'MemberExpression',
                                                                                                                                        computed: false,
                                                                                                                                        object: {
                                                                                                                                            type: 'MemberExpression',
                                                                                                                                            computed: false,
                                                                                                                                            object: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'style',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 24,
                                                                                                                                                        column: 36,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 24,
                                                                                                                                                        column: 41,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            property: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'color',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 24,
                                                                                                                                                        column: 42,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 24,
                                                                                                                                                        column: 47,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 24,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 24,
                                                                                                                                                    column: 47,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        property: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'white',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 24,
                                                                                                                                                    column: 48,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 24,
                                                                                                                                                    column: 53,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 24,
                                                                                                                                                column: 36,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 24,
                                                                                                                                                column: 53,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                right: {
                                                                                                                                    type: 'Literal',
                                                                                                                                    value: ';\n    # min-width: 1200px;\n    min-width: 900px;\n    width: 70%;\n}\n\n.dashboard-side {\n    background-color: '
                                                                                                                                }
                                                                                                                            },
                                                                                                                            right: {
                                                                                                                                type: 'CallExpression',
                                                                                                                                callee: {
                                                                                                                                    type: 'MemberExpression',
                                                                                                                                    computed: false,
                                                                                                                                    object: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'style',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 31,
                                                                                                                                                column: 36,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 31,
                                                                                                                                                column: 41,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    property: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'black',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 31,
                                                                                                                                                column: 42,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 31,
                                                                                                                                                column: 47,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 31,
                                                                                                                                            column: 36,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 31,
                                                                                                                                            column: 47,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                arguments: [{
                                                                                                                                        type: 'Literal',
                                                                                                                                        value: 0.05
                                                                                                                                    }],
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 31,
                                                                                                                                        column: 36,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 31,
                                                                                                                                        column: 53,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        right: {
                                                                                                                            type: 'Literal',
                                                                                                                            value: ';\n}\n\n.dashboard-card {\n    border: 1px solid '
                                                                                                                        }
                                                                                                                    },
                                                                                                                    right: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'gray',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 35,
                                                                                                                                column: 36,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 35,
                                                                                                                                column: 40,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                right: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: ';\n    border-radius: 2px;\n}\n\n.dashboard-card-content {\n    overflow-y: auto;\n}\n\n.dashboard-title {\n    user-select: none;\n    border-bottom: 1px solid '
                                                                                                                }
                                                                                                            },
                                                                                                            right: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'gray',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 45,
                                                                                                                        column: 43,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 45,
                                                                                                                        column: 47,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        right: {
                                                                                                            type: 'Literal',
                                                                                                            value: ';\n    height: 48px;\n}\n\n.dashboard-gray {\n    color: '
                                                                                                        }
                                                                                                    },
                                                                                                    right: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'gray',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 50,
                                                                                                                column: 25,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 50,
                                                                                                                column: 29,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                right: {
                                                                                                    type: 'Literal',
                                                                                                    value: ';\n}\n\n.dashboard-darkgray {\n    color: '
                                                                                                }
                                                                                            },
                                                                                            right: {
                                                                                                type: 'Identifier',
                                                                                                name: 'darkGray',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 54,
                                                                                                        column: 25,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 54,
                                                                                                        column: 33,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        right: {
                                                                                            type: 'Literal',
                                                                                            value: ';\n}\n\n.dashboard-progress-inner {\n    background-color: '
                                                                                        }
                                                                                    },
                                                                                    right: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'MemberExpression',
                                                                                            computed: false,
                                                                                            object: {
                                                                                                type: 'Identifier',
                                                                                                name: 'style',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 58,
                                                                                                        column: 36,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 58,
                                                                                                        column: 41,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            property: {
                                                                                                type: 'Identifier',
                                                                                                name: 'color',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 58,
                                                                                                        column: 42,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 58,
                                                                                                        column: 47,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 58,
                                                                                                    column: 36,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 58,
                                                                                                    column: 47,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'primary',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 58,
                                                                                                    column: 48,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 58,
                                                                                                    column: 55,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 58,
                                                                                                column: 36,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 58,
                                                                                                column: 55,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                },
                                                                                right: {
                                                                                    type: 'Literal',
                                                                                    value: ';\n    position: absolute;\n    height: 15px;\n    left: 0px;\n    top: 0px;\n}\n\n.dashboard-progress {\n    background-color: '
                                                                                }
                                                                            },
                                                                            right: {
                                                                                type: 'CallExpression',
                                                                                callee: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'style',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 66,
                                                                                                column: 36,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 66,
                                                                                                column: 41,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'black',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 66,
                                                                                                column: 42,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 66,
                                                                                                column: 47,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 66,
                                                                                            column: 36,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 66,
                                                                                            column: 47,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                arguments: [{
                                                                                        type: 'Literal',
                                                                                        value: 0.15
                                                                                    }],
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 66,
                                                                                        column: 36,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 66,
                                                                                        column: 53,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                    }
                                                                                }
                                                                            }
                                                                        },
                                                                        right: {
                                                                            type: 'Literal',
                                                                            value: ';\n    position: relative;\n    width: 100px;\n    height: 15px;\n}\n\n.dashboard-item {\n    background-color: '
                                                                        }
                                                                    },
                                                                    right: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'style',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 73,
                                                                                        column: 36,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 73,
                                                                                        column: 41,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'color',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 73,
                                                                                        column: 42,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 73,
                                                                                        column: 47,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 73,
                                                                                    column: 36,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 73,
                                                                                    column: 47,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'white',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 73,
                                                                                    column: 48,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 73,
                                                                                    column: 53,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 73,
                                                                                column: 36,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 73,
                                                                                column: 53,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            }
                                                                        }
                                                                    }
                                                                },
                                                                right: {
                                                                    type: 'Literal',
                                                                    value: ';\n    padding: '
                                                                }
                                                            },
                                                            right: {
                                                                type: 'BinaryExpression',
                                                                operator: '/',
                                                                left: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'style',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 74,
                                                                                    column: 27,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 74,
                                                                                    column: 32,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'spacing',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 74,
                                                                                    column: 33,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 74,
                                                                                    column: 40,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 74,
                                                                                column: 27,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 74,
                                                                                column: 40,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'buffer',
                                                                        loc: {
                                                                            start: {
                                                                                line: 74,
                                                                                column: 41,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 74,
                                                                                column: 47,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 74,
                                                                            column: 27,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 74,
                                                                            column: 47,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                right: {
                                                                    type: 'Literal',
                                                                    value: 2
                                                                }
                                                            }
                                                        },
                                                        right: {
                                                            type: 'Literal',
                                                            value: 'px;\n    color: '
                                                        }
                                                    },
                                                    right: {
                                                        type: 'Identifier',
                                                        name: 'darkGray',
                                                        loc: {
                                                            start: {
                                                                line: 75,
                                                                column: 25,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                            },
                                                            end: {
                                                                line: 75,
                                                                column: 33,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                            }
                                                        }
                                                    }
                                                },
                                                right: {
                                                    type: 'Literal',
                                                    value: ';\n    cursor: pointer;\n}\n\n.dashboard-item:Hover {\n    background-color: '
                                                }
                                            },
                                            right: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'style',
                                                        loc: {
                                                            start: {
                                                                line: 80,
                                                                column: 36,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                            },
                                                            end: {
                                                                line: 80,
                                                                column: 41,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'black',
                                                        loc: {
                                                            start: {
                                                                line: 80,
                                                                column: 42,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                            },
                                                            end: {
                                                                line: 80,
                                                                column: 47,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 80,
                                                            column: 36,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                        },
                                                        end: {
                                                            line: 80,
                                                            column: 47,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [{
                                                        type: 'Literal',
                                                        value: 0.05
                                                    }],
                                                loc: {
                                                    start: {
                                                        line: 80,
                                                        column: 36,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                    },
                                                    end: {
                                                        line: 80,
                                                        column: 53,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                    }
                                                }
                                            }
                                        },
                                        right: {
                                            type: 'Literal',
                                            value: ';\n}\n\n.dashboard-calendar-tile {\n    height: 4vh;\n    width: 4vh;\n    color: white;\n    opacity: 0.7;\n    user-select: none;\n    margin: auto;\n}\n\n.dashboard-calendar-tile-outer {\n    height: 5vh;\n    width: 5vh;\n    border: 0.2vh;\n}\n\n\n.dashboard-calendar-tile:Hover {\n    opacity: 1;\n}\n\n.dashboard-calendar-tile.selected {\n    opacity: 1;\n}\n\n.dashboard-calendar-tile-outer.selected {\n    border: 0.2vh solid '
                                        }
                                    },
                                    right: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'style',
                                                loc: {
                                                    start: {
                                                        line: 108,
                                                        column: 38,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                    },
                                                    end: {
                                                        line: 108,
                                                        column: 43,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'color',
                                                loc: {
                                                    start: {
                                                        line: 108,
                                                        column: 44,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                    },
                                                    end: {
                                                        line: 108,
                                                        column: 49,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 108,
                                                    column: 38,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                },
                                                end: {
                                                    line: 108,
                                                    column: 49,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'accent',
                                            loc: {
                                                start: {
                                                    line: 108,
                                                    column: 50,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                },
                                                end: {
                                                    line: 108,
                                                    column: 56,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 108,
                                                column: 38,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            },
                                            end: {
                                                line: 108,
                                                column: 56,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            }
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: ';\n}'
                                }
                            },
                            kind: 'init',
                            computed: true,
                            order: '0'
                        }]
                },
                loc: {
                    start: {
                        line: 21,
                        column: 4,
                        fixed: true,
                        source: 'viewpath/html/panes/DashboardPane.ion'
                    },
                    end: {
                        line: 111,
                        column: 8,
                        fixed: true,
                        source: 'viewpath/html/panes/DashboardPane.ion'
                    }
                },
                order: '0'
            }],
        bound: false
    }, {
        this: this,
        module: module,
        ion: ion,
        glass: glass,
        _ref: _ref,
        _ref2: _ref2,
        _ref3: _ref3,
        _ref4: _ref4,
        style: style,
        _ref5: _ref5,
        namespace: namespace,
        _ref6: _ref6,
        _ref7: _ref7,
        DateTime: DateTime,
        RecordChip: RecordChip,
        RecordIcon: RecordIcon,
        PromptDialog: PromptDialog,
        Key: Key,
        SetupWizard: SetupWizard,
        SubscriptionNotice: SubscriptionNotice,
        Task: Task,
        Project: Project,
        ProjectType: ProjectType,
        User: User,
        Comment: Comment,
        createProjectPrompt: createProjectPrompt,
        lightGray: lightGray,
        gray: gray,
        darkGray: darkGray,
        DashboardCard: DashboardCard,
        dateString: dateString,
        getWeeks: getWeeks,
        workHoursOnDateFromTask: workHoursOnDateFromTask,
        getDays: getDays,
        TaskCalendarModel: TaskCalendarModel,
        capitalize: capitalize,
        displayDate: displayDate,
        dateColor: dateColor,
        TaskCalendar: TaskCalendar,
        TasksCard: TasksCard,
        ProjectsCard: ProjectsCard,
        MembersCard: MembersCard,
        mostRecentComment: mostRecentComment,
        DiscussionsCard: DiscussionsCard,
        getTaskComments: getTaskComments,
        Dashboard: Dashboard
    }, null);
})().observe();
var DashboardCard = ion.template(function (_ref8) {
        return ion.createRuntime({
            type: 'Template',
            id: null,
            body: [
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'title',
                                loc: {
                                    start: {
                                        line: 113,
                                        column: 31,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 113,
                                        column: 36,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref8'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'title',
                                    loc: {
                                        start: {
                                            line: 113,
                                            column: 31,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        },
                                        end: {
                                            line: 113,
                                            column: 36,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '0'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'paneId',
                                loc: {
                                    start: {
                                        line: 113,
                                        column: 38,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 113,
                                        column: 44,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref8'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'paneId',
                                    loc: {
                                        start: {
                                            line: 113,
                                            column: 38,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        },
                                        end: {
                                            line: 113,
                                            column: 44,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '1'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'toolbar',
                                loc: {
                                    start: {
                                        line: 113,
                                        column: 46,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 113,
                                        column: 53,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref8'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'toolbar',
                                    loc: {
                                        start: {
                                            line: 113,
                                            column: 46,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        },
                                        end: {
                                            line: 113,
                                            column: 53,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '2'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'content',
                                loc: {
                                    start: {
                                        line: 113,
                                        column: 55,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 113,
                                        column: 62,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref8'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'content',
                                    loc: {
                                        start: {
                                            line: 113,
                                            column: 55,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        },
                                        end: {
                                            line: 113,
                                            column: 62,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '3'
                },
                {
                    type: 'ReturnStatement',
                    argument: {
                        type: 'ObjectExpression',
                        objectType: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Div',
                                loc: {
                                    start: {
                                        line: 114,
                                        column: 15,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 114,
                                        column: 18,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ObjectExpression',
                                    properties: [{
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'class',
                                                loc: {
                                                    start: {
                                                        line: 114,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                    },
                                                    end: {
                                                        line: 114,
                                                        column: 25,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: 'layout vertical fill padding'
                                            },
                                            kind: 'init',
                                            order: '0'
                                        }]
                                }],
                            loc: {
                                start: {
                                    line: 114,
                                    column: 15,
                                    fixed: true,
                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                },
                                end: {
                                    line: 114,
                                    column: 59,
                                    fixed: true,
                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                }
                            }
                        },
                        properties: [{
                                type: 'ExpressionStatement',
                                expression: {
                                    type: 'ObjectExpression',
                                    objectType: {
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'Identifier',
                                            name: 'Div',
                                            loc: {
                                                start: {
                                                    line: 115,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                },
                                                end: {
                                                    line: 115,
                                                    column: 15,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                }
                                            }
                                        },
                                        arguments: [{
                                                type: 'ObjectExpression',
                                                properties: [{
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'class',
                                                            loc: {
                                                                start: {
                                                                    line: 115,
                                                                    column: 17,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                },
                                                                end: {
                                                                    line: 115,
                                                                    column: 22,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Literal',
                                                            value: 'dashboard-card layout vertical flex'
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    }]
                                            }],
                                        loc: {
                                            start: {
                                                line: 115,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            },
                                            end: {
                                                line: 115,
                                                column: 62,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            }
                                        }
                                    },
                                    properties: [
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'ObjectExpression',
                                                objectType: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'Identifier',
                                                        name: 'Div',
                                                        loc: {
                                                            start: {
                                                                line: 117,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                            },
                                                            end: {
                                                                line: 117,
                                                                column: 19,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [{
                                                            type: 'ObjectExpression',
                                                            properties: [{
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'class',
                                                                        loc: {
                                                                            start: {
                                                                                line: 117,
                                                                                column: 21,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 117,
                                                                                column: 26,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Literal',
                                                                        value: 'dashboard-title layout horizontal fixed center padding'
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                }]
                                                        }],
                                                    loc: {
                                                        start: {
                                                            line: 117,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                        },
                                                        end: {
                                                            line: 117,
                                                            column: 85,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                        }
                                                    }
                                                },
                                                properties: [
                                                    {
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'ObjectExpression',
                                                            objectType: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Identifier',
                                                                    name: 'Span',
                                                                    loc: {
                                                                        start: {
                                                                            line: 118,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 118,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'ObjectExpression',
                                                                        properties: [{
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'class',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 118,
                                                                                            column: 26,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 118,
                                                                                            column: 31,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'ConditionalExpression',
                                                                                    test: {
                                                                                        type: 'UnaryExpression',
                                                                                        operator: '?',
                                                                                        argument: {
                                                                                            type: 'Identifier',
                                                                                            name: 'paneId',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 118,
                                                                                                    column: 33,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 118,
                                                                                                    column: 39,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                }
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    consequent: {
                                                                                        type: 'Literal',
                                                                                        value: 'pointer'
                                                                                    },
                                                                                    alternate: {
                                                                                        type: 'Literal',
                                                                                        value: ''
                                                                                    }
                                                                                },
                                                                                kind: 'init',
                                                                                order: '0'
                                                                            }]
                                                                    }],
                                                                loc: {
                                                                    start: {
                                                                        line: 118,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 118,
                                                                        column: 59,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            properties: [
                                                                {
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'Identifier',
                                                                        name: 'title',
                                                                        loc: {
                                                                            start: {
                                                                                line: 119,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 119,
                                                                                column: 29,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 119,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 119,
                                                                            column: 29,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                        }
                                                                    },
                                                                    order: '0'
                                                                },
                                                                {
                                                                    type: 'IfStatement',
                                                                    test: {
                                                                        type: 'UnaryExpression',
                                                                        operator: '?',
                                                                        argument: {
                                                                            type: 'Identifier',
                                                                            name: 'paneId',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 120,
                                                                                    column: 27,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 120,
                                                                                    column: 33,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                }
                                                                            }
                                                                        }
                                                                    },
                                                                    consequent: {
                                                                        type: 'BlockStatement',
                                                                        body: [{
                                                                                type: 'ExpressionStatement',
                                                                                expression: {
                                                                                    type: 'Function',
                                                                                    context: true,
                                                                                    value: function (_context) {
                                                                                        return function click() {
                                                                                            var paneId = _context.get('paneId');
                                                                                            model.open({ id: paneId });
                                                                                        };
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 121,
                                                                                        column: 28,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 123,
                                                                                        column: 32,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                    }
                                                                                },
                                                                                order: '0'
                                                                            }]
                                                                    },
                                                                    alternate: null,
                                                                    order: '1'
                                                                }
                                                            ]
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 118,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                            },
                                                            end: {
                                                                line: 123,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                            }
                                                        },
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'Div',
                                                                loc: {
                                                                    start: {
                                                                        line: 123,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 123,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [{
                                                                    type: 'ObjectExpression',
                                                                    properties: [{
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'class',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 123,
                                                                                        column: 25,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 123,
                                                                                        column: 30,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'fill'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        }]
                                                                }],
                                                            loc: {
                                                                start: {
                                                                    line: 123,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                },
                                                                end: {
                                                                    line: 123,
                                                                    column: 39,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 123,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                            },
                                                            end: {
                                                                line: 123,
                                                                column: 39,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                            }
                                                        },
                                                        order: '1'
                                                    },
                                                    {
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'toolbar',
                                                                loc: {
                                                                    start: {
                                                                        line: 124,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 124,
                                                                        column: 27,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [],
                                                            existential: true,
                                                            loc: {
                                                                start: {
                                                                    line: 124,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                },
                                                                end: {
                                                                    line: 124,
                                                                    column: 30,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 124,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                            },
                                                            end: {
                                                                line: 124,
                                                                column: 30,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                            }
                                                        },
                                                        order: '2'
                                                    }
                                                ]
                                            },
                                            loc: {
                                                start: {
                                                    line: 117,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                },
                                                end: {
                                                    line: 126,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                }
                                            },
                                            order: '0'
                                        },
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'ObjectExpression',
                                                objectType: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'Identifier',
                                                        name: 'Div',
                                                        loc: {
                                                            start: {
                                                                line: 126,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                            },
                                                            end: {
                                                                line: 126,
                                                                column: 19,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [{
                                                            type: 'ObjectExpression',
                                                            properties: [{
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'class',
                                                                        loc: {
                                                                            start: {
                                                                                line: 126,
                                                                                column: 21,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 126,
                                                                                column: 26,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Literal',
                                                                        value: 'dashboard-card-content layout vertical flex'
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                }]
                                                        }],
                                                    loc: {
                                                        start: {
                                                            line: 126,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                        },
                                                        end: {
                                                            line: 126,
                                                            column: 74,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                        }
                                                    }
                                                },
                                                properties: [{
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'content',
                                                                loc: {
                                                                    start: {
                                                                        line: 127,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 127,
                                                                        column: 27,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [],
                                                            loc: {
                                                                start: {
                                                                    line: 127,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                },
                                                                end: {
                                                                    line: 127,
                                                                    column: 29,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 127,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                            },
                                                            end: {
                                                                line: 127,
                                                                column: 29,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                            }
                                                        },
                                                        order: '0'
                                                    }]
                                            },
                                            loc: {
                                                start: {
                                                    line: 126,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                },
                                                end: {
                                                    line: 129,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                }
                                            },
                                            order: '1'
                                        }
                                    ]
                                },
                                loc: {
                                    start: {
                                        line: 115,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 129,
                                        column: 16,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                },
                                order: '0'
                            }]
                    },
                    order: '4'
                }
            ],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'DashboardCard',
                loc: {
                    start: {
                        line: 113,
                        column: 4,
                        fixed: true,
                        source: 'viewpath/html/panes/DashboardPane.ion'
                    },
                    end: {
                        line: 113,
                        column: 17,
                        fixed: true,
                        source: 'viewpath/html/panes/DashboardPane.ion'
                    }
                }
            }
        }, {
            this: this,
            _ref8: _ref8,
            ion: ion,
            glass: glass,
            _ref: _ref,
            _ref2: _ref2,
            _ref3: _ref3,
            _ref4: _ref4,
            style: style,
            _ref5: _ref5,
            namespace: namespace,
            _ref6: _ref6,
            _ref7: _ref7,
            DateTime: DateTime,
            RecordChip: RecordChip,
            RecordIcon: RecordIcon,
            PromptDialog: PromptDialog,
            Key: Key,
            SetupWizard: SetupWizard,
            SubscriptionNotice: SubscriptionNotice,
            Task: Task,
            Project: Project,
            ProjectType: ProjectType,
            User: User,
            Comment: Comment,
            createProjectPrompt: createProjectPrompt,
            lightGray: lightGray,
            gray: gray,
            darkGray: darkGray,
            DashboardCard: DashboardCard,
            dateString: dateString,
            getWeeks: getWeeks,
            workHoursOnDateFromTask: workHoursOnDateFromTask,
            getDays: getDays,
            TaskCalendarModel: TaskCalendarModel,
            capitalize: capitalize,
            displayDate: displayDate,
            dateColor: dateColor,
            TaskCalendar: TaskCalendar,
            TasksCard: TasksCard,
            ProjectsCard: ProjectsCard,
            MembersCard: MembersCard,
            mostRecentComment: mostRecentComment,
            DiscussionsCard: DiscussionsCard,
            getTaskComments: getTaskComments,
            Dashboard: Dashboard
        }, null);
    });
var dateString = function (date) {
        return (date != null ? date.clone != null ? date.clone().format != null ? date.clone().format('{yyyy}/{MM}/{dd}') : void 0 : void 0 : void 0) != null ? date.clone().format('{yyyy}/{MM}/{dd}') : '';
    }, getWeeks = function (date) {
        var monthStart = date.clone().beginningOfMonth();
        var weekday = monthStart.clone().getWeekday();
        var dates = [];
        {
            for (var i = 0; i < weekday; i++) {
                dates.push(null);
            }
            for (var i = 0; i < monthStart.clone().daysInMonth(); i++) {
                dates.push(monthStart.clone().addDays(i));
            }
        }
        var weekCount = Math.ceil(dates.length / 7);
        var weeks = [];
        for (var week = 0; week < weekCount; week++) {
            var _ref12 = [];
            for (var day = 0; day < 7; day++)
                weeks.push(_ref12.push(dates[week * 7 + day]));
            weeks.push(_ref12);
        }
        return weeks;
    }, workHoursOnDateFromTask = function (date, task) {
        var dayStart = date.clone().beginningOfDay().getTime();
        var dayEnd = date.clone().endOfDay().getTime();
        var hasStartTime = task.Start.getIsoTime() !== '';
        var hasEndTime = task.Finish.getIsoTime() !== '';
        var taskStart = hasStartTime ? task.Start.toDate().getTime() : task.Start.toDate().beginningOfDay().getTime();
        var taskEnd = hasEndTime ? task.Finish.toDate().getTime() : task.Finish.toDate().endOfDay().getTime();
        var taskStartOnDate = Math.max(dayStart, taskStart);
        var taskEndOnDate = Math.min(dayEnd, taskEnd);
        var workMillis = taskEndOnDate - taskStartOnDate;
        var workHours = Math.min(workMillis / (1000 * 60 * 60), 8);
        return workHours;
    }, getDays = function (tasks, viewDate) {
        var sortedTasks = [];
        for (var key in tasks) {
            var task = tasks[key];
            sortedTasks.push(task);
            if (task.repeat) {
                {
                    var _ref13 = task.createInstances(viewDate.clone().beginningOfMonth(), viewDate.clone().endOfMonth(), { type: Object });
                    for (var _i = 0; _i < _ref13.length; _i++) {
                        var taskInstance = _ref13[_i];
                        sortedTasks.push(ion.patch.combine(ion.deserialize(ion.serialize(task), namespace), {
                            start: taskInstance.start,
                            finish: taskInstance.finish
                        }));
                    }
                }
            }
        }
        sortedTasks.sort(function (a, b) {
            return a.Start.toDate().getTime() - b.Start.toDate().getTime();
        });
        var days = {};
        if (tasks != null) {
            for (var key in sortedTasks) {
                var task = sortedTasks[key];
                var start = task.Start.withoutTime();
                var finish = task.Finish.withoutTime();
                var duration = finish.subtract(start);
                var numDays = 1 + duration.totalSeconds() / (60 * 60 * 24);
                for (var i = 0; i < numDays; i++) {
                    var date = task.Start.toDate().addDays(i);
                    if (date.isWeekend() && !(i === 0 || i + 1 === numDays)) {
                        continue;
                    }
                    var dateStr = dateString(date);
                    days[dateStr] = days[dateStr] != null ? days[dateStr] : {
                        date: date,
                        tasks: {},
                        workHours: 0
                    };
                    days[dateStr].tasks[task.key] = task;
                    days[dateStr].workHours += workHoursOnDateFromTask(date, task);
                }
            }
        }
        return days;
    }, TaskCalendarModel = ion.template(function () {
        return ion.createRuntime({
            type: 'Template',
            id: null,
            body: [
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'tasksKey',
                                loc: {
                                    start: {
                                        line: 202,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 202,
                                        column: 20,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'NewExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Key',
                                    loc: {
                                        start: {
                                            line: 202,
                                            column: 27,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        },
                                        end: {
                                            line: 202,
                                            column: 30,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        }
                                    }
                                },
                                arguments: [
                                    {
                                        type: 'Identifier',
                                        name: 'Task',
                                        loc: {
                                            start: {
                                                line: 203,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            },
                                            end: {
                                                line: 203,
                                                column: 16,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            }
                                        }
                                    },
                                    {
                                        type: 'ObjectExpression',
                                        objectType: {
                                            type: 'ObjectExpression',
                                            properties: []
                                        },
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'where',
                                                    loc: {
                                                        start: {
                                                            line: 205,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                        },
                                                        end: {
                                                            line: 205,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'ObjectExpression',
                                                    properties: [
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'assignedKeys',
                                                                loc: {
                                                                    start: {
                                                                        line: 206,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 206,
                                                                        column: 32,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'model',
                                                                    loc: {
                                                                        start: {
                                                                            line: 206,
                                                                            column: 34,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 206,
                                                                            column: 39,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'userKey',
                                                                    loc: {
                                                                        start: {
                                                                            line: 206,
                                                                            column: 40,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 206,
                                                                            column: 47,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 206,
                                                                        column: 34,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 206,
                                                                        column: 47,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        },
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'complete',
                                                                loc: {
                                                                    start: {
                                                                        line: 207,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 207,
                                                                        column: 28,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Literal',
                                                                value: false
                                                            },
                                                            kind: 'init',
                                                            order: '1'
                                                        },
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'start',
                                                                loc: {
                                                                    start: {
                                                                        line: 208,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 208,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'ObjectExpression',
                                                                properties: [{
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Literal',
                                                                            value: '!='
                                                                        },
                                                                        value: {
                                                                            type: 'Literal',
                                                                            value: null
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    }]
                                                            },
                                                            kind: 'init',
                                                            order: '2'
                                                        }
                                                    ]
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'watch',
                                                    loc: {
                                                        start: {
                                                            line: 209,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                        },
                                                        end: {
                                                            line: 209,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: true
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    }
                                ],
                                loc: {
                                    start: {
                                        line: 202,
                                        column: 23,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 210,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '0'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'tasks',
                                loc: {
                                    start: {
                                        line: 210,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 210,
                                        column: 17,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                computed: true,
                                object: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'model',
                                        loc: {
                                            start: {
                                                line: 210,
                                                column: 20,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            },
                                            end: {
                                                line: 210,
                                                column: 25,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'server',
                                        loc: {
                                            start: {
                                                line: 210,
                                                column: 26,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            },
                                            end: {
                                                line: 210,
                                                column: 32,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 210,
                                            column: 20,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        },
                                        end: {
                                            line: 210,
                                            column: 32,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'tasksKey',
                                    loc: {
                                        start: {
                                            line: 210,
                                            column: 33,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        },
                                        end: {
                                            line: 210,
                                            column: 41,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 210,
                                        column: 20,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 210,
                                        column: 42,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '1'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'viewDate',
                                loc: {
                                    start: {
                                        line: 212,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 212,
                                        column: 20,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'NewExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Date',
                                    loc: {
                                        start: {
                                            line: 212,
                                            column: 27,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        },
                                        end: {
                                            line: 212,
                                            column: 31,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        }
                                    }
                                },
                                arguments: [],
                                loc: {
                                    start: {
                                        line: 212,
                                        column: 23,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 212,
                                        column: 33,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '2'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'date',
                                loc: {
                                    start: {
                                        line: 213,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 213,
                                        column: 16,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'NewExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Date',
                                    loc: {
                                        start: {
                                            line: 213,
                                            column: 23,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        },
                                        end: {
                                            line: 213,
                                            column: 27,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        }
                                    }
                                },
                                arguments: [],
                                loc: {
                                    start: {
                                        line: 213,
                                        column: 19,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 213,
                                        column: 29,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '3'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'days',
                                loc: {
                                    start: {
                                        line: 215,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 215,
                                        column: 16,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'getDays',
                                    loc: {
                                        start: {
                                            line: 215,
                                            column: 19,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        },
                                        end: {
                                            line: 215,
                                            column: 26,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        }
                                    }
                                },
                                arguments: [
                                    {
                                        type: 'Identifier',
                                        name: 'tasks',
                                        loc: {
                                            start: {
                                                line: 215,
                                                column: 27,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            },
                                            end: {
                                                line: 215,
                                                column: 32,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            }
                                        }
                                    },
                                    {
                                        type: 'Identifier',
                                        name: 'viewDate',
                                        loc: {
                                            start: {
                                                line: 215,
                                                column: 34,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            },
                                            end: {
                                                line: 215,
                                                column: 42,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            }
                                        }
                                    }
                                ],
                                loc: {
                                    start: {
                                        line: 215,
                                        column: 19,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 215,
                                        column: 43,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '4'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'weeks',
                                loc: {
                                    start: {
                                        line: 217,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 217,
                                        column: 17,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'getWeeks',
                                    loc: {
                                        start: {
                                            line: 217,
                                            column: 20,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        },
                                        end: {
                                            line: 217,
                                            column: 28,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'Identifier',
                                        name: 'viewDate',
                                        loc: {
                                            start: {
                                                line: 217,
                                                column: 29,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            },
                                            end: {
                                                line: 217,
                                                column: 37,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            }
                                        }
                                    }],
                                loc: {
                                    start: {
                                        line: 217,
                                        column: 20,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 217,
                                        column: 38,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '5'
                },
                {
                    type: 'ReturnStatement',
                    argument: {
                        type: 'ObjectExpression',
                        objectType: {
                            type: 'ObjectExpression',
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'date',
                                        loc: {
                                            start: {
                                                line: 219,
                                                column: 16,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            },
                                            end: {
                                                line: 219,
                                                column: 20,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Identifier',
                                        name: 'date',
                                        loc: {
                                            start: {
                                                line: 219,
                                                column: 16,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            },
                                            end: {
                                                line: 219,
                                                column: 20,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'viewDate',
                                        loc: {
                                            start: {
                                                line: 219,
                                                column: 22,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            },
                                            end: {
                                                line: 219,
                                                column: 30,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Identifier',
                                        name: 'viewDate',
                                        loc: {
                                            start: {
                                                line: 219,
                                                column: 22,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            },
                                            end: {
                                                line: 219,
                                                column: 30,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '1'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'days',
                                        loc: {
                                            start: {
                                                line: 219,
                                                column: 32,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            },
                                            end: {
                                                line: 219,
                                                column: 36,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Identifier',
                                        name: 'days',
                                        loc: {
                                            start: {
                                                line: 219,
                                                column: 32,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            },
                                            end: {
                                                line: 219,
                                                column: 36,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '2'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'weeks',
                                        loc: {
                                            start: {
                                                line: 219,
                                                column: 38,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            },
                                            end: {
                                                line: 219,
                                                column: 43,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Identifier',
                                        name: 'weeks',
                                        loc: {
                                            start: {
                                                line: 219,
                                                column: 38,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            },
                                            end: {
                                                line: 219,
                                                column: 43,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '3'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'tasks',
                                        loc: {
                                            start: {
                                                line: 219,
                                                column: 45,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            },
                                            end: {
                                                line: 219,
                                                column: 50,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Identifier',
                                        name: 'tasks',
                                        loc: {
                                            start: {
                                                line: 219,
                                                column: 45,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            },
                                            end: {
                                                line: 219,
                                                column: 50,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '4'
                                }
                            ]
                        },
                        properties: [
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'getDay',
                                    loc: {
                                        start: {
                                            line: 220,
                                            column: 12,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        },
                                        end: {
                                            line: 220,
                                            column: 18,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'Function',
                                    context: true,
                                    value: function (_context2) {
                                        return function (date) {
                                            var dateString = _context2.get('dateString');
                                            return this.days[dateString(date)];
                                        };
                                    }
                                },
                                kind: 'init',
                                order: '0'
                            },
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'title',
                                    loc: {
                                        start: {
                                            line: 221,
                                            column: 12,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        },
                                        end: {
                                            line: 221,
                                            column: 17,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'Function',
                                    context: false,
                                    value: function () {
                                        return this.viewDate.format('{Mon} {yyyy}');
                                    }
                                },
                                kind: 'init',
                                order: '1'
                            },
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'selected',
                                    loc: {
                                        start: {
                                            line: 222,
                                            column: 12,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        },
                                        end: {
                                            line: 222,
                                            column: 20,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'Function',
                                    context: true,
                                    value: function (_context3) {
                                        return function (date) {
                                            var dateString = _context3.get('dateString');
                                            return dateString(date) === dateString(this.date);
                                        };
                                    }
                                },
                                kind: 'init',
                                order: '2'
                            },
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'addMonths',
                                    loc: {
                                        start: {
                                            line: 223,
                                            column: 12,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        },
                                        end: {
                                            line: 223,
                                            column: 21,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'Function',
                                    context: true,
                                    value: function (_context4) {
                                        return function (n) {
                                            var getWeeks = _context4.get('getWeeks'), getDays = _context4.get('getDays'), tasks = _context4.get('tasks');
                                            this.viewDate = this.viewDate.clone().addMonths(n);
                                            this.weeks = getWeeks(this.viewDate);
                                            this.days = getDays(tasks, this.viewDate);
                                        };
                                    }
                                },
                                kind: 'init',
                                order: '3'
                            }
                        ]
                    },
                    order: '6'
                }
            ],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'TaskCalendarModel',
                loc: {
                    start: {
                        line: 201,
                        column: 4,
                        fixed: true,
                        source: 'viewpath/html/panes/DashboardPane.ion'
                    },
                    end: {
                        line: 201,
                        column: 21,
                        fixed: true,
                        source: 'viewpath/html/panes/DashboardPane.ion'
                    }
                }
            }
        }, {
            this: this,
            ion: ion,
            glass: glass,
            _ref: _ref,
            _ref2: _ref2,
            _ref3: _ref3,
            _ref4: _ref4,
            style: style,
            _ref5: _ref5,
            namespace: namespace,
            _ref6: _ref6,
            _ref7: _ref7,
            DateTime: DateTime,
            RecordChip: RecordChip,
            RecordIcon: RecordIcon,
            PromptDialog: PromptDialog,
            Key: Key,
            SetupWizard: SetupWizard,
            SubscriptionNotice: SubscriptionNotice,
            Task: Task,
            Project: Project,
            ProjectType: ProjectType,
            User: User,
            Comment: Comment,
            createProjectPrompt: createProjectPrompt,
            lightGray: lightGray,
            gray: gray,
            darkGray: darkGray,
            DashboardCard: DashboardCard,
            dateString: dateString,
            getWeeks: getWeeks,
            workHoursOnDateFromTask: workHoursOnDateFromTask,
            getDays: getDays,
            TaskCalendarModel: TaskCalendarModel,
            capitalize: capitalize,
            displayDate: displayDate,
            dateColor: dateColor,
            TaskCalendar: TaskCalendar,
            TasksCard: TasksCard,
            ProjectsCard: ProjectsCard,
            MembersCard: MembersCard,
            mostRecentComment: mostRecentComment,
            DiscussionsCard: DiscussionsCard,
            getTaskComments: getTaskComments,
            Dashboard: Dashboard
        }, null);
    }), capitalize = function (string) {
        return string.charAt(0).toUpperCase() + string.slice(1);
    }, displayDate = function (date) {
        if (date.isToday()) {
            return 'today';
        } else if (date.isThisWeek()) {
            return date.format('{Weekday}');
        } else if (date.isThisYear()) {
            return date.format('{Mon} {dd}');
        } else {
            return date.format('{Mon} {dd} {yyyy}');
        }
    }, dateColor = function (workHours) {
        var booking = workHours / 8;
        if (booking === 0) {
            return gray;
        }
        if (booking <= 0.75) {
            return style.interpolate(gray, style.color.primary, 0.5);
        }
        if (booking <= 1) {
            return style.color.primary;
        }
        return style.color.error;
    }, TaskCalendar = ion.template(function (calendarModel) {
        return ion.createRuntime({
            type: 'Template',
            id: null,
            body: [{
                    type: 'ReturnStatement',
                    argument: {
                        type: 'ObjectExpression',
                        objectType: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Div',
                                loc: {
                                    start: {
                                        line: 251,
                                        column: 15,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 251,
                                        column: 18,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ObjectExpression',
                                    properties: [{
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'class',
                                                loc: {
                                                    start: {
                                                        line: 251,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                    },
                                                    end: {
                                                        line: 251,
                                                        column: 25,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: 'padding'
                                            },
                                            kind: 'init',
                                            order: '0'
                                        }]
                                }],
                            loc: {
                                start: {
                                    line: 251,
                                    column: 15,
                                    fixed: true,
                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                },
                                end: {
                                    line: 251,
                                    column: 37,
                                    fixed: true,
                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                }
                            }
                        },
                        properties: [
                            {
                                type: 'ExpressionStatement',
                                expression: {
                                    type: 'ObjectExpression',
                                    objectType: {
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'Identifier',
                                            name: 'Div',
                                            loc: {
                                                start: {
                                                    line: 252,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                },
                                                end: {
                                                    line: 252,
                                                    column: 15,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                }
                                            }
                                        },
                                        arguments: [{
                                                type: 'ObjectExpression',
                                                properties: [{
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'class',
                                                            loc: {
                                                                start: {
                                                                    line: 252,
                                                                    column: 17,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                },
                                                                end: {
                                                                    line: 252,
                                                                    column: 22,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Literal',
                                                            value: 'layout horizontal fill justified padding-half'
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    }]
                                            }],
                                        loc: {
                                            start: {
                                                line: 252,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            },
                                            end: {
                                                line: 252,
                                                column: 72,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            }
                                        }
                                    },
                                    properties: [
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'ObjectExpression',
                                                objectType: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'Identifier',
                                                        name: 'IronIcon',
                                                        loc: {
                                                            start: {
                                                                line: 253,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                            },
                                                            end: {
                                                                line: 253,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [{
                                                            type: 'ObjectExpression',
                                                            properties: [{
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'class',
                                                                        loc: {
                                                                            start: {
                                                                                line: 253,
                                                                                column: 26,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 253,
                                                                                column: 31,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Literal',
                                                                        value: 'pointer'
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                }]
                                                        }],
                                                    loc: {
                                                        start: {
                                                            line: 253,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                        },
                                                        end: {
                                                            line: 253,
                                                            column: 43,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                        }
                                                    }
                                                },
                                                properties: [
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'style',
                                                            loc: {
                                                                start: {
                                                                    line: 254,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                },
                                                                end: {
                                                                    line: 254,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'ObjectExpression',
                                                            properties: [{
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'transform',
                                                                        loc: {
                                                                            start: {
                                                                                line: 254,
                                                                                column: 28,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 254,
                                                                                column: 37,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Literal',
                                                                        value: 'rotateZ(180deg)'
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                }]
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'icon',
                                                            loc: {
                                                                start: {
                                                                    line: 255,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                },
                                                                end: {
                                                                    line: 255,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Literal',
                                                            value: 'av:play-arrow'
                                                        },
                                                        kind: 'init',
                                                        order: '1'
                                                    },
                                                    {
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'Function',
                                                            context: true,
                                                            value: function (_context5) {
                                                                return function click() {
                                                                    var calendarModel = _context5.get('calendarModel');
                                                                    return calendarModel.addMonths(-1);
                                                                };
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 256,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                            },
                                                            end: {
                                                                line: 256,
                                                                column: 58,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                            }
                                                        },
                                                        order: '2'
                                                    }
                                                ]
                                            },
                                            loc: {
                                                start: {
                                                    line: 253,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                },
                                                end: {
                                                    line: 257,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                }
                                            },
                                            order: '0'
                                        },
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'ObjectExpression',
                                                objectType: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'Identifier',
                                                        name: 'Div',
                                                        loc: {
                                                            start: {
                                                                line: 257,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                            },
                                                            end: {
                                                                line: 257,
                                                                column: 19,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [{
                                                            type: 'ObjectExpression',
                                                            properties: [{
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'class',
                                                                        loc: {
                                                                            start: {
                                                                                line: 257,
                                                                                column: 21,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 257,
                                                                                column: 26,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Literal',
                                                                        value: 'dashboard-darkgray '
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                }]
                                                        }],
                                                    loc: {
                                                        start: {
                                                            line: 257,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                        },
                                                        end: {
                                                            line: 257,
                                                            column: 50,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                        }
                                                    }
                                                },
                                                properties: [{
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'calendarModel',
                                                                    loc: {
                                                                        start: {
                                                                            line: 258,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 258,
                                                                            column: 33,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'title',
                                                                    loc: {
                                                                        start: {
                                                                            line: 258,
                                                                            column: 34,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 258,
                                                                            column: 39,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 258,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 258,
                                                                        column: 39,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [],
                                                            loc: {
                                                                start: {
                                                                    line: 258,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                },
                                                                end: {
                                                                    line: 258,
                                                                    column: 41,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 258,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                            },
                                                            end: {
                                                                line: 258,
                                                                column: 41,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                            }
                                                        },
                                                        order: '0'
                                                    }]
                                            },
                                            loc: {
                                                start: {
                                                    line: 257,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                },
                                                end: {
                                                    line: 259,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                }
                                            },
                                            order: '1'
                                        },
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'ObjectExpression',
                                                objectType: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'Identifier',
                                                        name: 'IronIcon',
                                                        loc: {
                                                            start: {
                                                                line: 259,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                            },
                                                            end: {
                                                                line: 259,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [{
                                                            type: 'ObjectExpression',
                                                            properties: [{
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'class',
                                                                        loc: {
                                                                            start: {
                                                                                line: 259,
                                                                                column: 26,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 259,
                                                                                column: 31,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Literal',
                                                                        value: 'pointer'
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                }]
                                                        }],
                                                    loc: {
                                                        start: {
                                                            line: 259,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                        },
                                                        end: {
                                                            line: 259,
                                                            column: 43,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                        }
                                                    }
                                                },
                                                properties: [
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'icon',
                                                            loc: {
                                                                start: {
                                                                    line: 260,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                },
                                                                end: {
                                                                    line: 260,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Literal',
                                                            value: 'av:play-arrow'
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'Function',
                                                            context: true,
                                                            value: function (_context6) {
                                                                return function click() {
                                                                    var calendarModel = _context6.get('calendarModel');
                                                                    return calendarModel.addMonths(1);
                                                                };
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 261,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                            },
                                                            end: {
                                                                line: 261,
                                                                column: 57,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                            }
                                                        },
                                                        order: '1'
                                                    }
                                                ]
                                            },
                                            loc: {
                                                start: {
                                                    line: 259,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                },
                                                end: {
                                                    line: 262,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                }
                                            },
                                            order: '2'
                                        }
                                    ]
                                },
                                loc: {
                                    start: {
                                        line: 252,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 262,
                                        column: 16,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                },
                                order: '0'
                            },
                            {
                                type: 'ExpressionStatement',
                                expression: {
                                    type: 'ObjectExpression',
                                    objectType: {
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'Identifier',
                                            name: 'Table',
                                            loc: {
                                                start: {
                                                    line: 262,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                },
                                                end: {
                                                    line: 262,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                }
                                            }
                                        },
                                        arguments: [{
                                                type: 'ObjectExpression',
                                                properties: [{
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'style',
                                                            loc: {
                                                                start: {
                                                                    line: 262,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                },
                                                                end: {
                                                                    line: 262,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Literal',
                                                            value: 'border-spacing: 0px'
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    }]
                                            }],
                                        loc: {
                                            start: {
                                                line: 262,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            },
                                            end: {
                                                line: 262,
                                                column: 48,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            }
                                        }
                                    },
                                    properties: [{
                                            type: 'ForInStatement',
                                            left: {
                                                type: 'VariableDeclaration',
                                                declarations: [
                                                    {
                                                        type: 'VariableDeclarator',
                                                        id: {
                                                            type: 'Identifier',
                                                            name: 'k0',
                                                            loc: {
                                                                start: {
                                                                    line: 263,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                },
                                                                end: {
                                                                    line: 263,
                                                                    column: 22,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                }
                                                            }
                                                        },
                                                        init: null
                                                    },
                                                    {
                                                        type: 'VariableDeclarator',
                                                        id: {
                                                            type: 'Identifier',
                                                            name: 'week',
                                                            loc: {
                                                                start: {
                                                                    line: 263,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                },
                                                                end: {
                                                                    line: 263,
                                                                    column: 28,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                }
                                                            }
                                                        },
                                                        init: null
                                                    }
                                                ],
                                                kind: 'let'
                                            },
                                            right: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'calendarModel',
                                                    loc: {
                                                        start: {
                                                            line: 263,
                                                            column: 32,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                        },
                                                        end: {
                                                            line: 263,
                                                            column: 45,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'weeks',
                                                    loc: {
                                                        start: {
                                                            line: 263,
                                                            column: 46,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                        },
                                                        end: {
                                                            line: 263,
                                                            column: 51,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 263,
                                                        column: 32,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                    },
                                                    end: {
                                                        line: 263,
                                                        column: 51,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                    }
                                                }
                                            },
                                            body: {
                                                type: 'BlockStatement',
                                                body: [{
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'ObjectExpression',
                                                            objectType: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Identifier',
                                                                    name: 'Tr',
                                                                    loc: {
                                                                        start: {
                                                                            line: 264,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 264,
                                                                            column: 22,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [],
                                                                loc: {
                                                                    start: {
                                                                        line: 264,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 264,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            properties: [{
                                                                    type: 'ForInStatement',
                                                                    left: {
                                                                        type: 'VariableDeclaration',
                                                                        declarations: [
                                                                            {
                                                                                type: 'VariableDeclarator',
                                                                                id: {
                                                                                    type: 'Identifier',
                                                                                    name: 'k1',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 265,
                                                                                            column: 28,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 265,
                                                                                            column: 30,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                init: null
                                                                            },
                                                                            {
                                                                                type: 'VariableDeclarator',
                                                                                id: {
                                                                                    type: 'Identifier',
                                                                                    name: 'date',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 265,
                                                                                            column: 32,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 265,
                                                                                            column: 36,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                init: null
                                                                            }
                                                                        ],
                                                                        kind: 'let'
                                                                    },
                                                                    right: {
                                                                        type: 'Identifier',
                                                                        name: 'week',
                                                                        loc: {
                                                                            start: {
                                                                                line: 265,
                                                                                column: 40,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 265,
                                                                                column: 44,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    body: {
                                                                        type: 'BlockStatement',
                                                                        body: [{
                                                                                type: 'ExpressionStatement',
                                                                                expression: {
                                                                                    type: 'ObjectExpression',
                                                                                    objectType: {
                                                                                        type: 'CallExpression',
                                                                                        callee: {
                                                                                            type: 'Identifier',
                                                                                            name: 'Td',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 266,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 266,
                                                                                                    column: 30,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        arguments: [{
                                                                                                type: 'ObjectExpression',
                                                                                                properties: [{
                                                                                                        type: 'Property',
                                                                                                        key: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'class',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 266,
                                                                                                                    column: 32,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 266,
                                                                                                                    column: 37,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        value: {
                                                                                                            type: 'Literal',
                                                                                                            value: 'dashboard-calendar-tile-outer'
                                                                                                        },
                                                                                                        kind: 'init',
                                                                                                        order: '0'
                                                                                                    }]
                                                                                            }],
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 266,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 266,
                                                                                                column: 71,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    properties: [
                                                                                        {
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'classList',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 267,
                                                                                                        column: 32,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 267,
                                                                                                        column: 41,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'ObjectExpression',
                                                                                                properties: [{
                                                                                                        type: 'IfStatement',
                                                                                                        test: {
                                                                                                            type: 'CallExpression',
                                                                                                            callee: {
                                                                                                                type: 'MemberExpression',
                                                                                                                computed: false,
                                                                                                                object: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'calendarModel',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 268,
                                                                                                                            column: 39,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 268,
                                                                                                                            column: 52,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                property: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'selected',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 268,
                                                                                                                            column: 53,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 268,
                                                                                                                            column: 61,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 268,
                                                                                                                        column: 39,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 268,
                                                                                                                        column: 61,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            arguments: [{
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'date',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 268,
                                                                                                                            column: 62,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 268,
                                                                                                                            column: 66,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                }],
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 268,
                                                                                                                    column: 39,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 268,
                                                                                                                    column: 67,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        consequent: {
                                                                                                            type: 'BlockStatement',
                                                                                                            body: [{
                                                                                                                    type: 'ExpressionStatement',
                                                                                                                    expression: {
                                                                                                                        type: 'Literal',
                                                                                                                        value: 'selected'
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 269,
                                                                                                                            column: 40,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 269,
                                                                                                                            column: 50,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        }
                                                                                                                    },
                                                                                                                    order: '0'
                                                                                                                }]
                                                                                                        },
                                                                                                        alternate: null,
                                                                                                        order: '0'
                                                                                                    }]
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '0'
                                                                                        },
                                                                                        {
                                                                                            type: 'IfStatement',
                                                                                            test: {
                                                                                                type: 'UnaryExpression',
                                                                                                operator: '!',
                                                                                                argument: {
                                                                                                    type: 'UnaryExpression',
                                                                                                    operator: '?',
                                                                                                    argument: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'date',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 270,
                                                                                                                column: 39,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 270,
                                                                                                                column: 43,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            consequent: {
                                                                                                type: 'BlockStatement',
                                                                                                body: [{
                                                                                                        type: 'ExpressionStatement',
                                                                                                        expression: {
                                                                                                            type: 'CallExpression',
                                                                                                            callee: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'Div',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 271,
                                                                                                                        column: 36,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 271,
                                                                                                                        column: 39,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            arguments: [{
                                                                                                                    type: 'ObjectExpression',
                                                                                                                    properties: [{
                                                                                                                            type: 'Property',
                                                                                                                            key: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'class',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 271,
                                                                                                                                        column: 41,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 271,
                                                                                                                                        column: 46,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            value: {
                                                                                                                                type: 'Literal',
                                                                                                                                value: 'dashboard-calendar-tile'
                                                                                                                            },
                                                                                                                            kind: 'init',
                                                                                                                            order: '0'
                                                                                                                        }]
                                                                                                                }],
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 271,
                                                                                                                    column: 36,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 271,
                                                                                                                    column: 74,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 271,
                                                                                                                column: 36,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 271,
                                                                                                                column: 74,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                            }
                                                                                                        },
                                                                                                        order: '0'
                                                                                                    }]
                                                                                            },
                                                                                            alternate: {
                                                                                                type: 'BlockStatement',
                                                                                                body: [{
                                                                                                        type: 'ExpressionStatement',
                                                                                                        expression: {
                                                                                                            type: 'ObjectExpression',
                                                                                                            objectType: {
                                                                                                                type: 'CallExpression',
                                                                                                                callee: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'Div',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 273,
                                                                                                                            column: 36,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 273,
                                                                                                                            column: 39,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                arguments: [{
                                                                                                                        type: 'ObjectExpression',
                                                                                                                        properties: [{
                                                                                                                                type: 'Property',
                                                                                                                                key: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'class',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 273,
                                                                                                                                            column: 41,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 273,
                                                                                                                                            column: 46,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                value: {
                                                                                                                                    type: 'Literal',
                                                                                                                                    value: 'dashboard-calendar-tile layout vertical around-justified center'
                                                                                                                                },
                                                                                                                                kind: 'init',
                                                                                                                                order: '0'
                                                                                                                            }]
                                                                                                                    }],
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 273,
                                                                                                                        column: 36,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 273,
                                                                                                                        column: 114,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            properties: [
                                                                                                                {
                                                                                                                    type: 'VariableDeclaration',
                                                                                                                    declarations: [{
                                                                                                                            type: 'VariableDeclarator',
                                                                                                                            id: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'day',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 274,
                                                                                                                                        column: 44,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 274,
                                                                                                                                        column: 47,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            init: {
                                                                                                                                type: 'CallExpression',
                                                                                                                                callee: {
                                                                                                                                    type: 'MemberExpression',
                                                                                                                                    computed: false,
                                                                                                                                    object: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'calendarModel',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 274,
                                                                                                                                                column: 50,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 274,
                                                                                                                                                column: 63,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    property: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'getDay',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 274,
                                                                                                                                                column: 64,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 274,
                                                                                                                                                column: 70,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 274,
                                                                                                                                            column: 50,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 274,
                                                                                                                                            column: 70,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                arguments: [{
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'date',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 274,
                                                                                                                                                column: 71,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 274,
                                                                                                                                                column: 75,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    }],
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 274,
                                                                                                                                        column: 50,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 274,
                                                                                                                                        column: 76,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            }
                                                                                                                        }],
                                                                                                                    kind: 'let',
                                                                                                                    order: '0'
                                                                                                                },
                                                                                                                {
                                                                                                                    type: 'ExpressionStatement',
                                                                                                                    expression: {
                                                                                                                        type: 'Function',
                                                                                                                        context: true,
                                                                                                                        value: function (_context7) {
                                                                                                                            return function click() {
                                                                                                                                var calendarModel = _context7.get('calendarModel'), date = _context7.get('date');
                                                                                                                                return calendarModel.date = date;
                                                                                                                            };
                                                                                                                        }
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 275,
                                                                                                                            column: 40,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 275,
                                                                                                                            column: 76,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        }
                                                                                                                    },
                                                                                                                    order: '1'
                                                                                                                },
                                                                                                                {
                                                                                                                    type: 'Property',
                                                                                                                    key: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'style',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 276,
                                                                                                                                column: 40,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 276,
                                                                                                                                column: 45,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    value: {
                                                                                                                        type: 'ObjectExpression',
                                                                                                                        properties: [{
                                                                                                                                type: 'Property',
                                                                                                                                key: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'backgroundColor',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 276,
                                                                                                                                            column: 48,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 276,
                                                                                                                                            column: 63,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                value: {
                                                                                                                                    type: 'CallExpression',
                                                                                                                                    callee: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'dateColor',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 276,
                                                                                                                                                column: 65,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 276,
                                                                                                                                                column: 74,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    arguments: [{
                                                                                                                                            type: 'ConditionalExpression',
                                                                                                                                            test: {
                                                                                                                                                type: 'BinaryExpression',
                                                                                                                                                operator: '!=',
                                                                                                                                                left: {
                                                                                                                                                    type: 'MemberExpression',
                                                                                                                                                    computed: false,
                                                                                                                                                    object: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'day',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 276,
                                                                                                                                                                column: 75,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 276,
                                                                                                                                                                column: 78,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    property: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'workHours',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 276,
                                                                                                                                                                column: 80,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 276,
                                                                                                                                                                column: 89,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    existential: true,
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 276,
                                                                                                                                                            column: 75,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 276,
                                                                                                                                                            column: 89,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                right: {
                                                                                                                                                    type: 'Literal',
                                                                                                                                                    value: null
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            consequent: {
                                                                                                                                                type: 'MemberExpression',
                                                                                                                                                computed: false,
                                                                                                                                                object: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'day',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 276,
                                                                                                                                                            column: 75,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 276,
                                                                                                                                                            column: 78,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                property: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'workHours',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 276,
                                                                                                                                                            column: 80,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 276,
                                                                                                                                                            column: 89,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                existential: true,
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 276,
                                                                                                                                                        column: 75,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 276,
                                                                                                                                                        column: 89,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            alternate: {
                                                                                                                                                type: 'Literal',
                                                                                                                                                value: 0
                                                                                                                                            }
                                                                                                                                        }],
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 276,
                                                                                                                                            column: 65,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 276,
                                                                                                                                            column: 94,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                kind: 'init',
                                                                                                                                order: '0'
                                                                                                                            }]
                                                                                                                    },
                                                                                                                    kind: 'init',
                                                                                                                    order: '2'
                                                                                                                },
                                                                                                                {
                                                                                                                    type: 'Property',
                                                                                                                    key: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'classList',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 277,
                                                                                                                                column: 40,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 277,
                                                                                                                                column: 49,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    value: {
                                                                                                                        type: 'ObjectExpression',
                                                                                                                        properties: [{
                                                                                                                                type: 'IfStatement',
                                                                                                                                test: {
                                                                                                                                    type: 'CallExpression',
                                                                                                                                    callee: {
                                                                                                                                        type: 'MemberExpression',
                                                                                                                                        computed: false,
                                                                                                                                        object: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'calendarModel',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 278,
                                                                                                                                                    column: 47,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 278,
                                                                                                                                                    column: 60,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        property: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'selected',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 278,
                                                                                                                                                    column: 61,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 278,
                                                                                                                                                    column: 69,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 278,
                                                                                                                                                column: 47,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 278,
                                                                                                                                                column: 69,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    arguments: [{
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'date',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 278,
                                                                                                                                                    column: 70,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 278,
                                                                                                                                                    column: 74,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        }],
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 278,
                                                                                                                                            column: 47,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 278,
                                                                                                                                            column: 75,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                consequent: {
                                                                                                                                    type: 'BlockStatement',
                                                                                                                                    body: [{
                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                            expression: {
                                                                                                                                                type: 'Literal',
                                                                                                                                                value: 'selected'
                                                                                                                                            },
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 279,
                                                                                                                                                    column: 48,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 279,
                                                                                                                                                    column: 58,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            order: '0'
                                                                                                                                        }]
                                                                                                                                },
                                                                                                                                alternate: null,
                                                                                                                                order: '0'
                                                                                                                            }]
                                                                                                                    },
                                                                                                                    kind: 'init',
                                                                                                                    order: '3'
                                                                                                                },
                                                                                                                {
                                                                                                                    type: 'ExpressionStatement',
                                                                                                                    expression: {
                                                                                                                        type: 'CallExpression',
                                                                                                                        callee: {
                                                                                                                            type: 'MemberExpression',
                                                                                                                            computed: false,
                                                                                                                            object: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'date',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 280,
                                                                                                                                        column: 40,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 280,
                                                                                                                                        column: 44,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            property: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'getDate',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 280,
                                                                                                                                        column: 45,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 280,
                                                                                                                                        column: 52,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 280,
                                                                                                                                    column: 40,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 280,
                                                                                                                                    column: 52,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        arguments: [],
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 280,
                                                                                                                                column: 40,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 280,
                                                                                                                                column: 54,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 280,
                                                                                                                            column: 40,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 280,
                                                                                                                            column: 54,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        }
                                                                                                                    },
                                                                                                                    order: '4'
                                                                                                                }
                                                                                                            ]
                                                                                                        },
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 273,
                                                                                                                column: 36,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 282,
                                                                                                                column: 40,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                            }
                                                                                                        },
                                                                                                        order: '0'
                                                                                                    }]
                                                                                            },
                                                                                            order: '1'
                                                                                        }
                                                                                    ]
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 266,
                                                                                        column: 28,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 282,
                                                                                        column: 32,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                    }
                                                                                },
                                                                                order: '0'
                                                                            }]
                                                                    },
                                                                    remove: null,
                                                                    order: '0'
                                                                }]
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 264,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                            },
                                                            end: {
                                                                line: 282,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                            }
                                                        },
                                                        order: '0'
                                                    }]
                                            },
                                            remove: null,
                                            order: '0'
                                        }]
                                },
                                loc: {
                                    start: {
                                        line: 262,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 282,
                                        column: 16,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                },
                                order: '1'
                            }
                        ]
                    },
                    order: '0'
                }],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'TaskCalendar',
                loc: {
                    start: {
                        line: 250,
                        column: 4,
                        fixed: true,
                        source: 'viewpath/html/panes/DashboardPane.ion'
                    },
                    end: {
                        line: 250,
                        column: 16,
                        fixed: true,
                        source: 'viewpath/html/panes/DashboardPane.ion'
                    }
                }
            }
        }, {
            this: this,
            calendarModel: calendarModel,
            ion: ion,
            glass: glass,
            _ref: _ref,
            _ref2: _ref2,
            _ref3: _ref3,
            _ref4: _ref4,
            style: style,
            _ref5: _ref5,
            namespace: namespace,
            _ref6: _ref6,
            _ref7: _ref7,
            DateTime: DateTime,
            RecordChip: RecordChip,
            RecordIcon: RecordIcon,
            PromptDialog: PromptDialog,
            Key: Key,
            SetupWizard: SetupWizard,
            SubscriptionNotice: SubscriptionNotice,
            Task: Task,
            Project: Project,
            ProjectType: ProjectType,
            User: User,
            Comment: Comment,
            createProjectPrompt: createProjectPrompt,
            lightGray: lightGray,
            gray: gray,
            darkGray: darkGray,
            DashboardCard: DashboardCard,
            dateString: dateString,
            getWeeks: getWeeks,
            workHoursOnDateFromTask: workHoursOnDateFromTask,
            getDays: getDays,
            TaskCalendarModel: TaskCalendarModel,
            capitalize: capitalize,
            displayDate: displayDate,
            dateColor: dateColor,
            TaskCalendar: TaskCalendar,
            TasksCard: TasksCard,
            ProjectsCard: ProjectsCard,
            MembersCard: MembersCard,
            mostRecentComment: mostRecentComment,
            DiscussionsCard: DiscussionsCard,
            getTaskComments: getTaskComments,
            Dashboard: Dashboard
        }, null);
    }), TasksCard = ion.template(function (_ref9) {
        return ion.createRuntime({
            type: 'Template',
            id: null,
            body: [
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'projects',
                                loc: {
                                    start: {
                                        line: 282,
                                        column: 26,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 282,
                                        column: 34,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref9'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'projects',
                                    loc: {
                                        start: {
                                            line: 282,
                                            column: 26,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        },
                                        end: {
                                            line: 282,
                                            column: 34,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '0'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'taskComments',
                                loc: {
                                    start: {
                                        line: 282,
                                        column: 36,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 282,
                                        column: 48,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref9'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'taskComments',
                                    loc: {
                                        start: {
                                            line: 282,
                                            column: 36,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        },
                                        end: {
                                            line: 282,
                                            column: 48,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '1'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'hasLicence',
                                loc: {
                                    start: {
                                        line: 282,
                                        column: 50,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 282,
                                        column: 60,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref9'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'hasLicence',
                                    loc: {
                                        start: {
                                            line: 282,
                                            column: 50,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        },
                                        end: {
                                            line: 282,
                                            column: 60,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '2'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'calendarModel',
                                loc: {
                                    start: {
                                        line: 283,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 283,
                                        column: 25,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'TaskCalendarModel',
                                    loc: {
                                        start: {
                                            line: 283,
                                            column: 28,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        },
                                        end: {
                                            line: 283,
                                            column: 45,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        }
                                    }
                                },
                                arguments: [],
                                loc: {
                                    start: {
                                        line: 283,
                                        column: 28,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 283,
                                        column: 47,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '3'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'date',
                                loc: {
                                    start: {
                                        line: 285,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 285,
                                        column: 16,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'calendarModel',
                                    loc: {
                                        start: {
                                            line: 285,
                                            column: 19,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        },
                                        end: {
                                            line: 285,
                                            column: 32,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'date',
                                    loc: {
                                        start: {
                                            line: 285,
                                            column: 33,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        },
                                        end: {
                                            line: 285,
                                            column: 37,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 285,
                                        column: 19,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 285,
                                        column: 37,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '4'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'day',
                                loc: {
                                    start: {
                                        line: 286,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 286,
                                        column: 15,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'calendarModel',
                                        loc: {
                                            start: {
                                                line: 286,
                                                column: 18,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            },
                                            end: {
                                                line: 286,
                                                column: 31,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'getDay',
                                        loc: {
                                            start: {
                                                line: 286,
                                                column: 32,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            },
                                            end: {
                                                line: 286,
                                                column: 38,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 286,
                                            column: 18,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        },
                                        end: {
                                            line: 286,
                                            column: 38,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'Identifier',
                                        name: 'date',
                                        loc: {
                                            start: {
                                                line: 286,
                                                column: 39,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            },
                                            end: {
                                                line: 286,
                                                column: 43,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            }
                                        }
                                    }],
                                loc: {
                                    start: {
                                        line: 286,
                                        column: 18,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 286,
                                        column: 44,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '5'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'tasks',
                                loc: {
                                    start: {
                                        line: 287,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 287,
                                        column: 17,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'calendarModel',
                                    loc: {
                                        start: {
                                            line: 287,
                                            column: 20,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        },
                                        end: {
                                            line: 287,
                                            column: 33,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'tasks',
                                    loc: {
                                        start: {
                                            line: 287,
                                            column: 34,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        },
                                        end: {
                                            line: 287,
                                            column: 39,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 287,
                                        column: 20,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 287,
                                        column: 39,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '6'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'calendar',
                                loc: {
                                    start: {
                                        line: 289,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 289,
                                        column: 20,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'TaskCalendar',
                                    loc: {
                                        start: {
                                            line: 289,
                                            column: 23,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        },
                                        end: {
                                            line: 289,
                                            column: 35,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'Identifier',
                                        name: 'calendarModel',
                                        loc: {
                                            start: {
                                                line: 289,
                                                column: 36,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            },
                                            end: {
                                                line: 289,
                                                column: 49,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            }
                                        }
                                    }],
                                loc: {
                                    start: {
                                        line: 289,
                                        column: 23,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 289,
                                        column: 50,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '7'
                },
                {
                    type: 'ReturnStatement',
                    argument: {
                        type: 'CallExpression',
                        callee: {
                            type: 'Identifier',
                            name: 'DashboardCard',
                            loc: {
                                start: {
                                    line: 291,
                                    column: 15,
                                    fixed: true,
                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                },
                                end: {
                                    line: 291,
                                    column: 28,
                                    fixed: true,
                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                }
                            }
                        },
                        arguments: [{
                                type: 'ObjectExpression',
                                properties: [
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'title',
                                            loc: {
                                                start: {
                                                    line: 292,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                },
                                                end: {
                                                    line: 292,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: 'Tasks'
                                        },
                                        kind: 'init',
                                        order: '0'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'paneId',
                                            loc: {
                                                start: {
                                                    line: 293,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                },
                                                end: {
                                                    line: 293,
                                                    column: 18,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: 'Tasks'
                                        },
                                        kind: 'init',
                                        order: '1'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'toolbar',
                                            loc: {
                                                start: {
                                                    line: 294,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                },
                                                end: {
                                                    line: 294,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Function',
                                            context: true,
                                            value: function (_ps) {
                                                return ion.template(function () {
                                                    return ion.createRuntime({
                                                        type: 'Template',
                                                        id: null,
                                                        body: [
                                                            {
                                                                type: 'VariableDeclaration',
                                                                declarations: [{
                                                                        type: 'VariableDeclarator',
                                                                        id: {
                                                                            type: 'Identifier',
                                                                            name: 'projectProperty',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 295,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 295,
                                                                                    column: 35,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        init: {
                                                                            type: 'ObjectExpression',
                                                                            objectType: {
                                                                                type: 'ObjectExpression',
                                                                                properties: []
                                                                            },
                                                                            properties: [
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'values',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 296,
                                                                                                column: 20,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 296,
                                                                                                column: 26,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'ObjectExpression',
                                                                                        objectType: {
                                                                                            type: 'ArrayExpression',
                                                                                            elements: []
                                                                                        },
                                                                                        properties: [{
                                                                                                type: 'IfStatement',
                                                                                                test: {
                                                                                                    type: 'UnaryExpression',
                                                                                                    operator: '?',
                                                                                                    argument: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'projects',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 297,
                                                                                                                column: 27,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 297,
                                                                                                                column: 35,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                consequent: {
                                                                                                    type: 'BlockStatement',
                                                                                                    body: [{
                                                                                                            type: 'ForInStatement',
                                                                                                            left: {
                                                                                                                type: 'VariableDeclaration',
                                                                                                                declarations: [
                                                                                                                    {
                                                                                                                        type: 'VariableDeclarator',
                                                                                                                        id: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'key',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 298,
                                                                                                                                    column: 32,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 298,
                                                                                                                                    column: 35,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        init: null
                                                                                                                    },
                                                                                                                    {
                                                                                                                        type: 'VariableDeclarator',
                                                                                                                        id: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'project',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 298,
                                                                                                                                    column: 37,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 298,
                                                                                                                                    column: 44,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        init: null
                                                                                                                    }
                                                                                                                ],
                                                                                                                kind: 'let'
                                                                                                            },
                                                                                                            right: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'projects',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 298,
                                                                                                                        column: 48,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 298,
                                                                                                                        column: 56,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            body: {
                                                                                                                type: 'BlockStatement',
                                                                                                                body: [{
                                                                                                                        type: 'ExpressionStatement',
                                                                                                                        expression: {
                                                                                                                            type: 'ObjectExpression',
                                                                                                                            properties: [
                                                                                                                                {
                                                                                                                                    type: 'Property',
                                                                                                                                    key: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'id',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 299,
                                                                                                                                                column: 33,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 299,
                                                                                                                                                column: 35,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    value: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'key',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 299,
                                                                                                                                                column: 36,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 299,
                                                                                                                                                column: 39,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    kind: 'init',
                                                                                                                                    order: '0'
                                                                                                                                },
                                                                                                                                {
                                                                                                                                    type: 'Property',
                                                                                                                                    key: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'name',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 299,
                                                                                                                                                column: 40,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 299,
                                                                                                                                                column: 44,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    value: {
                                                                                                                                        type: 'MemberExpression',
                                                                                                                                        computed: false,
                                                                                                                                        object: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'project',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 299,
                                                                                                                                                    column: 45,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 299,
                                                                                                                                                    column: 52,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        property: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'name',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 299,
                                                                                                                                                    column: 53,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 299,
                                                                                                                                                    column: 57,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 299,
                                                                                                                                                column: 45,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 299,
                                                                                                                                                column: 57,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    kind: 'init',
                                                                                                                                    order: '1'
                                                                                                                                }
                                                                                                                            ]
                                                                                                                        },
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 299,
                                                                                                                                column: 32,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 299,
                                                                                                                                column: 58,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                            }
                                                                                                                        },
                                                                                                                        order: '0'
                                                                                                                    }]
                                                                                                            },
                                                                                                            remove: null,
                                                                                                            order: '0'
                                                                                                        }]
                                                                                                },
                                                                                                alternate: null,
                                                                                                order: '0'
                                                                                            }]
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'name',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 300,
                                                                                                column: 20,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 300,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Literal',
                                                                                        value: 'projectKey'
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '1'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'label',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 301,
                                                                                                column: 20,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 301,
                                                                                                column: 25,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Literal',
                                                                                        value: 'Project'
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '2'
                                                                                }
                                                                            ]
                                                                        }
                                                                    }],
                                                                kind: 'let',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'VariableDeclaration',
                                                                declarations: [{
                                                                        type: 'VariableDeclarator',
                                                                        id: {
                                                                            type: 'Identifier',
                                                                            name: 'assignedProperty',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 303,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 303,
                                                                                    column: 36,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        init: {
                                                                            type: 'ObjectExpression',
                                                                            objectType: {
                                                                                type: 'ObjectExpression',
                                                                                properties: []
                                                                            },
                                                                            properties: [
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'name',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 304,
                                                                                                column: 20,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 304,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Literal',
                                                                                        value: 'assigned'
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'type',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 305,
                                                                                                column: 20,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 305,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Literal',
                                                                                        value: 'object'
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '1'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'foreign',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 306,
                                                                                                column: 20,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 306,
                                                                                                column: 27,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'ObjectExpression',
                                                                                        properties: [
                                                                                            {
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'type',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 307,
                                                                                                            column: 24,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 307,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'Literal',
                                                                                                    value: 'User'
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '0'
                                                                                            },
                                                                                            {
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'property',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 308,
                                                                                                            column: 24,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 308,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'Literal',
                                                                                                    value: 'key'
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '1'
                                                                                            },
                                                                                            {
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'getSearchKeys',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 309,
                                                                                                            column: 24,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 309,
                                                                                                            column: 37,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'Function',
                                                                                                    context: true,
                                                                                                    value: function (_context8) {
                                                                                                        return function (obj, text) {
                                                                                                            var User = _context8.get('User'), Key = _context8.get('Key');
                                                                                                            var results = new Set();
                                                                                                            {
                                                                                                                var _ref14 = model.user.acceptedOrgIds;
                                                                                                                for (var _i2 = 0; _i2 < _ref14.length; _i2++) {
                                                                                                                    var orgId = _ref14[_i2];
                                                                                                                    {
                                                                                                                        var _ref15 = User.getSearchKeys({
                                                                                                                                text: text,
                                                                                                                                orgId: orgId
                                                                                                                            });
                                                                                                                        for (var _i3 = 0; _i3 < _ref15.length; _i3++) {
                                                                                                                            var key = _ref15[_i3];
                                                                                                                            results.add(key);
                                                                                                                        }
                                                                                                                    }
                                                                                                                }
                                                                                                            }
                                                                                                            if (text.indexOf('@') > 0) {
                                                                                                                results.add(new Key(User, { where: { email: text } }).toString());
                                                                                                                results.add(new Key(User, text.toLowerCase()));
                                                                                                            }
                                                                                                            return Array.from(results);
                                                                                                        };
                                                                                                    }
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '2'
                                                                                            }
                                                                                        ]
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '2'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'additionalProperties',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 318,
                                                                                                column: 20,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 318,
                                                                                                column: 40,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'MemberExpression',
                                                                                            computed: false,
                                                                                            object: {
                                                                                                type: 'MemberExpression',
                                                                                                computed: false,
                                                                                                object: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'Task',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 318,
                                                                                                            column: 42,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 318,
                                                                                                            column: 46,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'properties',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 318,
                                                                                                            column: 47,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 318,
                                                                                                            column: 57,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 318,
                                                                                                        column: 42,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 318,
                                                                                                        column: 57,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            property: {
                                                                                                type: 'Identifier',
                                                                                                name: 'assigned',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 318,
                                                                                                        column: 58,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 318,
                                                                                                        column: 66,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 318,
                                                                                                    column: 42,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 318,
                                                                                                    column: 66,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'additionalProperties',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 318,
                                                                                                    column: 67,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 318,
                                                                                                    column: 87,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 318,
                                                                                                column: 42,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 318,
                                                                                                column: 87,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '3'
                                                                                }
                                                                            ]
                                                                        }
                                                                    }],
                                                                kind: 'let',
                                                                order: '1'
                                                            },
                                                            {
                                                                type: 'ReturnStatement',
                                                                argument: {
                                                                    type: 'ObjectExpression',
                                                                    objectType: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'Identifier',
                                                                            name: 'Div',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 320,
                                                                                    column: 23,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 320,
                                                                                    column: 26,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [],
                                                                        loc: {
                                                                            start: {
                                                                                line: 320,
                                                                                column: 23,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 320,
                                                                                column: 28,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    properties: [{
                                                                            type: 'IfStatement',
                                                                            test: {
                                                                                type: 'Identifier',
                                                                                name: 'hasLicence',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 321,
                                                                                        column: 23,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 321,
                                                                                        column: 33,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            consequent: {
                                                                                type: 'BlockStatement',
                                                                                body: [{
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'ObjectExpression',
                                                                                            objectType: {
                                                                                                type: 'CallExpression',
                                                                                                callee: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'PaperIconButton',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 322,
                                                                                                            column: 24,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 322,
                                                                                                            column: 39,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                arguments: [{
                                                                                                        type: 'ObjectExpression',
                                                                                                        properties: [{
                                                                                                                type: 'Property',
                                                                                                                key: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'class',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 322,
                                                                                                                            column: 41,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 322,
                                                                                                                            column: 46,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                value: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: 'dashboard-gray'
                                                                                                                },
                                                                                                                kind: 'init',
                                                                                                                order: '0'
                                                                                                            }]
                                                                                                    }],
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 322,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 322,
                                                                                                        column: 65,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            properties: [
                                                                                                {
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'icon',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 323,
                                                                                                                column: 32,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 323,
                                                                                                                column: 36,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'Literal',
                                                                                                        value: 'add'
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '0'
                                                                                                },
                                                                                                {
                                                                                                    type: 'ExpressionStatement',
                                                                                                    expression: {
                                                                                                        type: 'Function',
                                                                                                        context: true,
                                                                                                        value: function (_context9) {
                                                                                                            return function click() {
                                                                                                                var projectProperty = _context9.get('projectProperty'), projects = _context9.get('projects'), DateTime = _context9.get('DateTime'), date = _context9.get('date'), ion = _context9.get('ion'), PromptDialog = _context9.get('PromptDialog'), Task = _context9.get('Task'), assignedProperty = _context9.get('assignedProperty'), Key = _context9.get('Key'), namespace = _context9.get('namespace');
                                                                                                                var _ref16 = {};
                                                                                                                {
                                                                                                                    _ref16[projectProperty.name] = Object.keys(projects)[0];
                                                                                                                    _ref16.manualStart = new DateTime(date).withoutTime().iso();
                                                                                                                    _ref16.manualFinish = new DateTime(date).withoutTime().iso();
                                                                                                                    var _ref17 = {};
                                                                                                                    _ref17[model.userKey] = ion.patch.combine(_ref17[model.userKey], { percent: null });
                                                                                                                    _ref16.assigned = ion.patch.combine(_ref16.assigned, _ref17);
                                                                                                                }
                                                                                                                PromptDialog.show({
                                                                                                                    style: { width: '600px' },
                                                                                                                    title: 'New Task',
                                                                                                                    properties: [
                                                                                                                        projectProperty,
                                                                                                                        Task.properties.name,
                                                                                                                        Task.properties.description,
                                                                                                                        Task.properties.manualStart,
                                                                                                                        Task.properties.manualFinish,
                                                                                                                        assignedProperty
                                                                                                                    ],
                                                                                                                    values: _ref16,
                                                                                                                    callback: function (values) {
                                                                                                                        var projectKey = new Key(namespace, values.projectKey);
                                                                                                                        values.key = new Key(projectKey, Task, model.guid()).toString();
                                                                                                                        delete values.projectKey;
                                                                                                                        var task = new Task(values);
                                                                                                                        model.addEntities([task], function () {
                                                                                                                            return model.open(task.paneConfig, { target: 'dialog' });
                                                                                                                        });
                                                                                                                    }
                                                                                                                });
                                                                                                            };
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 324,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 347,
                                                                                                            column: 36,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        }
                                                                                                    },
                                                                                                    order: '1'
                                                                                                }
                                                                                            ]
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 322,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 347,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            alternate: null,
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                order: '2'
                                                            }
                                                        ],
                                                        bound: false,
                                                        name: {
                                                            type: 'Identifier',
                                                            name: 'toolbar',
                                                            loc: {
                                                                start: {
                                                                    line: 294,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                },
                                                                end: {
                                                                    line: 294,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                }
                                                            }
                                                        },
                                                        scope: {
                                                            type: 'Identifier',
                                                            name: '_ps'
                                                        }
                                                    }, {
                                                        this: this,
                                                        ion: ion,
                                                        _ps: _ps,
                                                        _ref9: _ref9,
                                                        glass: glass,
                                                        _ref: _ref,
                                                        _ref2: _ref2,
                                                        _ref3: _ref3,
                                                        _ref4: _ref4,
                                                        style: style,
                                                        _ref5: _ref5,
                                                        namespace: namespace,
                                                        _ref6: _ref6,
                                                        _ref7: _ref7,
                                                        DateTime: DateTime,
                                                        RecordChip: RecordChip,
                                                        RecordIcon: RecordIcon,
                                                        PromptDialog: PromptDialog,
                                                        Key: Key,
                                                        SetupWizard: SetupWizard,
                                                        SubscriptionNotice: SubscriptionNotice,
                                                        Task: Task,
                                                        Project: Project,
                                                        ProjectType: ProjectType,
                                                        User: User,
                                                        Comment: Comment,
                                                        createProjectPrompt: createProjectPrompt,
                                                        lightGray: lightGray,
                                                        gray: gray,
                                                        darkGray: darkGray,
                                                        DashboardCard: DashboardCard,
                                                        dateString: dateString,
                                                        getWeeks: getWeeks,
                                                        workHoursOnDateFromTask: workHoursOnDateFromTask,
                                                        getDays: getDays,
                                                        TaskCalendarModel: TaskCalendarModel,
                                                        capitalize: capitalize,
                                                        displayDate: displayDate,
                                                        dateColor: dateColor,
                                                        TaskCalendar: TaskCalendar,
                                                        TasksCard: TasksCard,
                                                        ProjectsCard: ProjectsCard,
                                                        MembersCard: MembersCard,
                                                        mostRecentComment: mostRecentComment,
                                                        DiscussionsCard: DiscussionsCard,
                                                        getTaskComments: getTaskComments,
                                                        Dashboard: Dashboard
                                                    }, _ps);
                                                });
                                            }
                                        },
                                        kind: 'init',
                                        order: '2'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'content',
                                            loc: {
                                                start: {
                                                    line: 347,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                },
                                                end: {
                                                    line: 347,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Function',
                                            context: true,
                                            value: function (_ps2) {
                                                return ion.template(function () {
                                                    return ion.createRuntime({
                                                        type: 'Template',
                                                        id: null,
                                                        body: [{
                                                                type: 'ReturnStatement',
                                                                argument: {
                                                                    type: 'ObjectExpression',
                                                                    objectType: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'Identifier',
                                                                            name: 'Div',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 348,
                                                                                    column: 23,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 348,
                                                                                    column: 26,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [{
                                                                                type: 'ObjectExpression',
                                                                                properties: [{
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'class',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 348,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 348,
                                                                                                    column: 33,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 'layout horizontal fill'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    }]
                                                                            }],
                                                                        loc: {
                                                                            start: {
                                                                                line: 348,
                                                                                column: 23,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 348,
                                                                                column: 60,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    properties: [
                                                                        {
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'ObjectExpression',
                                                                                objectType: {
                                                                                    type: 'CallExpression',
                                                                                    callee: {
                                                                                        type: 'Identifier',
                                                                                        name: 'Div',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 350,
                                                                                                column: 20,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 350,
                                                                                                column: 23,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    arguments: [{
                                                                                            type: 'ObjectExpression',
                                                                                            properties: [{
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'class',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 350,
                                                                                                                column: 25,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 350,
                                                                                                                column: 30,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'Literal',
                                                                                                        value: 'layout vertical fill padding'
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '0'
                                                                                                }]
                                                                                        }],
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 350,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 350,
                                                                                            column: 63,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                properties: [{
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'ObjectExpression',
                                                                                            objectType: {
                                                                                                type: 'CallExpression',
                                                                                                callee: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'Div',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 351,
                                                                                                            column: 24,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 351,
                                                                                                            column: 27,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                arguments: [{
                                                                                                        type: 'ObjectExpression',
                                                                                                        properties: [
                                                                                                            {
                                                                                                                type: 'Property',
                                                                                                                key: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'class',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 351,
                                                                                                                            column: 29,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 351,
                                                                                                                            column: 34,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                value: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: 'layout vertical flex content'
                                                                                                                },
                                                                                                                kind: 'init',
                                                                                                                order: '0'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'Property',
                                                                                                                key: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'style',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 351,
                                                                                                                            column: 66,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 351,
                                                                                                                            column: 71,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                value: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: 'max-width:80%'
                                                                                                                },
                                                                                                                kind: 'init',
                                                                                                                order: '1'
                                                                                                            }
                                                                                                        ]
                                                                                                    }],
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 351,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 351,
                                                                                                        column: 89,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            properties: [
                                                                                                {
                                                                                                    type: 'ExpressionStatement',
                                                                                                    expression: {
                                                                                                        type: 'ObjectExpression',
                                                                                                        objectType: {
                                                                                                            type: 'CallExpression',
                                                                                                            callee: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'Div',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 354,
                                                                                                                        column: 28,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 354,
                                                                                                                        column: 31,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            arguments: [{
                                                                                                                    type: 'ObjectExpression',
                                                                                                                    properties: [{
                                                                                                                            type: 'Property',
                                                                                                                            key: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'class',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 354,
                                                                                                                                        column: 33,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 354,
                                                                                                                                        column: 38,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            value: {
                                                                                                                                type: 'Literal',
                                                                                                                                value: 'dashboard-darkgray'
                                                                                                                            },
                                                                                                                            kind: 'init',
                                                                                                                            order: '0'
                                                                                                                        }]
                                                                                                                }],
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 354,
                                                                                                                    column: 28,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 354,
                                                                                                                    column: 61,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        properties: [{
                                                                                                                type: 'IfStatement',
                                                                                                                test: {
                                                                                                                    type: 'UnaryExpression',
                                                                                                                    operator: '!',
                                                                                                                    argument: {
                                                                                                                        type: 'UnaryExpression',
                                                                                                                        operator: '?',
                                                                                                                        argument: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'day',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 355,
                                                                                                                                    column: 39,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 355,
                                                                                                                                    column: 42,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                consequent: {
                                                                                                                    type: 'BlockStatement',
                                                                                                                    body: [{
                                                                                                                            type: 'ExpressionStatement',
                                                                                                                            expression: {
                                                                                                                                type: 'BinaryExpression',
                                                                                                                                operator: '+',
                                                                                                                                left: {
                                                                                                                                    type: 'Literal',
                                                                                                                                    value: 'Nothing is scheduled '
                                                                                                                                },
                                                                                                                                right: {
                                                                                                                                    type: 'CallExpression',
                                                                                                                                    callee: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'displayDate',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 356,
                                                                                                                                                column: 62,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 356,
                                                                                                                                                column: 73,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    arguments: [{
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'date',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 356,
                                                                                                                                                    column: 74,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 356,
                                                                                                                                                    column: 78,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        }],
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 356,
                                                                                                                                            column: 62,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 356,
                                                                                                                                            column: 79,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 356,
                                                                                                                                    column: 36,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 356,
                                                                                                                                    column: 79,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                }
                                                                                                                            },
                                                                                                                            order: '0'
                                                                                                                        }]
                                                                                                                },
                                                                                                                alternate: {
                                                                                                                    type: 'BlockStatement',
                                                                                                                    body: [{
                                                                                                                            type: 'ExpressionStatement',
                                                                                                                            expression: {
                                                                                                                                type: 'CallExpression',
                                                                                                                                callee: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'capitalize',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 358,
                                                                                                                                            column: 36,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 358,
                                                                                                                                            column: 46,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                arguments: [{
                                                                                                                                        type: 'CallExpression',
                                                                                                                                        callee: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'displayDate',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 358,
                                                                                                                                                    column: 47,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 358,
                                                                                                                                                    column: 58,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        arguments: [{
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'date',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 358,
                                                                                                                                                        column: 59,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 358,
                                                                                                                                                        column: 63,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            }],
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 358,
                                                                                                                                                column: 47,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 358,
                                                                                                                                                column: 64,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    }],
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 358,
                                                                                                                                        column: 36,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 358,
                                                                                                                                        column: 65,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 358,
                                                                                                                                    column: 36,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 358,
                                                                                                                                    column: 65,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                }
                                                                                                                            },
                                                                                                                            order: '0'
                                                                                                                        }]
                                                                                                                },
                                                                                                                order: '0'
                                                                                                            }]
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 354,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 360,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        }
                                                                                                    },
                                                                                                    order: '0'
                                                                                                },
                                                                                                {
                                                                                                    type: 'ForInStatement',
                                                                                                    left: {
                                                                                                        type: 'VariableDeclaration',
                                                                                                        declarations: [
                                                                                                            {
                                                                                                                type: 'VariableDeclarator',
                                                                                                                id: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'k1',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 360,
                                                                                                                            column: 32,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 360,
                                                                                                                            column: 34,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                init: null
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'VariableDeclarator',
                                                                                                                id: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'task',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 360,
                                                                                                                            column: 36,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 360,
                                                                                                                            column: 40,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                init: null
                                                                                                            }
                                                                                                        ],
                                                                                                        kind: 'let'
                                                                                                    },
                                                                                                    right: {
                                                                                                        type: 'MemberExpression',
                                                                                                        computed: false,
                                                                                                        object: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'day',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 360,
                                                                                                                    column: 44,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 360,
                                                                                                                    column: 47,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        property: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'tasks',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 360,
                                                                                                                    column: 48,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 360,
                                                                                                                    column: 53,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 360,
                                                                                                                column: 44,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 360,
                                                                                                                column: 53,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    body: {
                                                                                                        type: 'BlockStatement',
                                                                                                        body: [
                                                                                                            {
                                                                                                                type: 'VariableDeclaration',
                                                                                                                declarations: [{
                                                                                                                        type: 'VariableDeclarator',
                                                                                                                        id: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'project',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 361,
                                                                                                                                    column: 36,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 361,
                                                                                                                                    column: 43,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        init: {
                                                                                                                            type: 'MemberExpression',
                                                                                                                            computed: true,
                                                                                                                            object: {
                                                                                                                                type: 'MemberExpression',
                                                                                                                                computed: false,
                                                                                                                                object: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'model',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 361,
                                                                                                                                            column: 46,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 361,
                                                                                                                                            column: 51,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                property: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'server',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 361,
                                                                                                                                            column: 52,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 361,
                                                                                                                                            column: 58,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 361,
                                                                                                                                        column: 46,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 361,
                                                                                                                                        column: 58,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            property: {
                                                                                                                                type: 'MemberExpression',
                                                                                                                                computed: false,
                                                                                                                                object: {
                                                                                                                                    type: 'CallExpression',
                                                                                                                                    callee: {
                                                                                                                                        type: 'MemberExpression',
                                                                                                                                        computed: false,
                                                                                                                                        object: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'task',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 361,
                                                                                                                                                    column: 59,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 361,
                                                                                                                                                    column: 63,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        property: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'getKey',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 361,
                                                                                                                                                    column: 64,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 361,
                                                                                                                                                    column: 70,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 361,
                                                                                                                                                column: 59,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 361,
                                                                                                                                                column: 70,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    arguments: [],
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 361,
                                                                                                                                            column: 59,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 361,
                                                                                                                                            column: 72,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                property: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'parent',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 361,
                                                                                                                                            column: 73,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 361,
                                                                                                                                            column: 79,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 361,
                                                                                                                                        column: 59,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 361,
                                                                                                                                        column: 79,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 361,
                                                                                                                                    column: 46,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 361,
                                                                                                                                    column: 80,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        }
                                                                                                                    }],
                                                                                                                kind: 'let',
                                                                                                                order: '0'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'VariableDeclaration',
                                                                                                                declarations: [{
                                                                                                                        type: 'VariableDeclarator',
                                                                                                                        id: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'comments',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 363,
                                                                                                                                    column: 36,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 363,
                                                                                                                                    column: 44,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        init: {
                                                                                                                            type: 'MemberExpression',
                                                                                                                            computed: true,
                                                                                                                            object: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'taskComments',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 363,
                                                                                                                                        column: 47,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 363,
                                                                                                                                        column: 59,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            property: {
                                                                                                                                type: 'MemberExpression',
                                                                                                                                computed: false,
                                                                                                                                object: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'task',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 363,
                                                                                                                                            column: 60,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 363,
                                                                                                                                            column: 64,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                property: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'key',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 363,
                                                                                                                                            column: 65,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 363,
                                                                                                                                            column: 68,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 363,
                                                                                                                                        column: 60,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 363,
                                                                                                                                        column: 68,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 363,
                                                                                                                                    column: 47,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 363,
                                                                                                                                    column: 69,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        }
                                                                                                                    }],
                                                                                                                kind: 'let',
                                                                                                                order: '1'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'VariableDeclaration',
                                                                                                                declarations: [{
                                                                                                                        type: 'VariableDeclarator',
                                                                                                                        id: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'commentCount',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 364,
                                                                                                                                    column: 36,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 364,
                                                                                                                                    column: 48,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        init: {
                                                                                                                            type: 'MemberExpression',
                                                                                                                            computed: false,
                                                                                                                            object: {
                                                                                                                                type: 'CallExpression',
                                                                                                                                callee: {
                                                                                                                                    type: 'MemberExpression',
                                                                                                                                    computed: false,
                                                                                                                                    object: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'Object',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 364,
                                                                                                                                                column: 51,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 364,
                                                                                                                                                column: 57,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    property: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'keys',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 364,
                                                                                                                                                column: 58,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 364,
                                                                                                                                                column: 62,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 364,
                                                                                                                                            column: 51,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 364,
                                                                                                                                            column: 62,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                arguments: [{
                                                                                                                                        type: 'ConditionalExpression',
                                                                                                                                        test: {
                                                                                                                                            type: 'BinaryExpression',
                                                                                                                                            operator: '!=',
                                                                                                                                            left: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'comments',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 364,
                                                                                                                                                        column: 63,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 364,
                                                                                                                                                        column: 71,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            right: {
                                                                                                                                                type: 'Literal',
                                                                                                                                                value: null
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        consequent: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'comments',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 364,
                                                                                                                                                    column: 63,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 364,
                                                                                                                                                    column: 71,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        alternate: {
                                                                                                                                            type: 'ObjectExpression',
                                                                                                                                            properties: []
                                                                                                                                        }
                                                                                                                                    }],
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 364,
                                                                                                                                        column: 51,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 364,
                                                                                                                                        column: 77,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            property: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'length',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 364,
                                                                                                                                        column: 78,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 364,
                                                                                                                                        column: 84,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 364,
                                                                                                                                    column: 51,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 364,
                                                                                                                                    column: 84,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        }
                                                                                                                    }],
                                                                                                                kind: 'let',
                                                                                                                order: '2'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'ExpressionStatement',
                                                                                                                expression: {
                                                                                                                    type: 'ObjectExpression',
                                                                                                                    objectType: {
                                                                                                                        type: 'CallExpression',
                                                                                                                        callee: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'Div',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 367,
                                                                                                                                    column: 32,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 367,
                                                                                                                                    column: 35,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        arguments: [{
                                                                                                                                type: 'ObjectExpression',
                                                                                                                                properties: [
                                                                                                                                    {
                                                                                                                                        type: 'Property',
                                                                                                                                        key: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'class',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 367,
                                                                                                                                                    column: 37,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 367,
                                                                                                                                                    column: 42,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        value: {
                                                                                                                                            type: 'Literal',
                                                                                                                                            value: 'dashboard-item'
                                                                                                                                        },
                                                                                                                                        kind: 'init',
                                                                                                                                        order: '0'
                                                                                                                                    },
                                                                                                                                    {
                                                                                                                                        type: 'Property',
                                                                                                                                        key: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'style',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 367,
                                                                                                                                                    column: 60,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 367,
                                                                                                                                                    column: 65,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        value: {
                                                                                                                                            type: 'Literal',
                                                                                                                                            value: 'padding-left:0px'
                                                                                                                                        },
                                                                                                                                        kind: 'init',
                                                                                                                                        order: '1'
                                                                                                                                    }
                                                                                                                                ]
                                                                                                                            }],
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 367,
                                                                                                                                column: 32,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 367,
                                                                                                                                column: 86,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    properties: [
                                                                                                                        {
                                                                                                                            type: 'ExpressionStatement',
                                                                                                                            expression: {
                                                                                                                                type: 'Function',
                                                                                                                                context: true,
                                                                                                                                value: function (_context10) {
                                                                                                                                    return function click() {
                                                                                                                                        var task = _context10.get('task');
                                                                                                                                        return model.open(task.paneConfig, { target: 'dialog' });
                                                                                                                                    };
                                                                                                                                }
                                                                                                                            },
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 368,
                                                                                                                                    column: 36,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 368,
                                                                                                                                    column: 93,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                }
                                                                                                                            },
                                                                                                                            order: '0'
                                                                                                                        },
                                                                                                                        {
                                                                                                                            type: 'ExpressionStatement',
                                                                                                                            expression: {
                                                                                                                                type: 'ObjectExpression',
                                                                                                                                objectType: {
                                                                                                                                    type: 'CallExpression',
                                                                                                                                    callee: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'Div',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 370,
                                                                                                                                                column: 36,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 370,
                                                                                                                                                column: 39,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    arguments: [{
                                                                                                                                            type: 'ObjectExpression',
                                                                                                                                            properties: [{
                                                                                                                                                    type: 'Property',
                                                                                                                                                    key: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'class',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 370,
                                                                                                                                                                column: 41,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 370,
                                                                                                                                                                column: 46,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    value: {
                                                                                                                                                        type: 'Literal',
                                                                                                                                                        value: 'layout horizontal flex'
                                                                                                                                                    },
                                                                                                                                                    kind: 'init',
                                                                                                                                                    order: '0'
                                                                                                                                                }]
                                                                                                                                        }],
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 370,
                                                                                                                                            column: 36,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 370,
                                                                                                                                            column: 73,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                properties: [
                                                                                                                                    {
                                                                                                                                        type: 'ExpressionStatement',
                                                                                                                                        expression: {
                                                                                                                                            type: 'ObjectExpression',
                                                                                                                                            objectType: {
                                                                                                                                                type: 'CallExpression',
                                                                                                                                                callee: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'Div',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 373,
                                                                                                                                                            column: 40,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 373,
                                                                                                                                                            column: 43,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                arguments: [],
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 373,
                                                                                                                                                        column: 40,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 373,
                                                                                                                                                        column: 45,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            properties: [
                                                                                                                                                {
                                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                                    expression: {
                                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                                        objectType: {
                                                                                                                                                            type: 'CallExpression',
                                                                                                                                                            callee: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'Div',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 374,
                                                                                                                                                                        column: 44,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 374,
                                                                                                                                                                        column: 47,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            arguments: [{
                                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                                    properties: [
                                                                                                                                                                        {
                                                                                                                                                                            type: 'Property',
                                                                                                                                                                            key: {
                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                name: 'class',
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 374,
                                                                                                                                                                                        column: 49,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 374,
                                                                                                                                                                                        column: 54,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            value: {
                                                                                                                                                                                type: 'Literal',
                                                                                                                                                                                value: 'black'
                                                                                                                                                                            },
                                                                                                                                                                            kind: 'init',
                                                                                                                                                                            order: '0'
                                                                                                                                                                        },
                                                                                                                                                                        {
                                                                                                                                                                            type: 'Property',
                                                                                                                                                                            key: {
                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                name: 'style',
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 374,
                                                                                                                                                                                        column: 63,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 374,
                                                                                                                                                                                        column: 68,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            value: {
                                                                                                                                                                                type: 'Literal',
                                                                                                                                                                                value: 'font-size:20px'
                                                                                                                                                                            },
                                                                                                                                                                            kind: 'init',
                                                                                                                                                                            order: '1'
                                                                                                                                                                        }
                                                                                                                                                                    ]
                                                                                                                                                                }],
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 374,
                                                                                                                                                                    column: 44,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 374,
                                                                                                                                                                    column: 87,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        properties: [{
                                                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                                                expression: {
                                                                                                                                                                    type: 'MemberExpression',
                                                                                                                                                                    computed: false,
                                                                                                                                                                    object: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'task',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 375,
                                                                                                                                                                                column: 48,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 375,
                                                                                                                                                                                column: 52,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    property: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'name',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 375,
                                                                                                                                                                                column: 53,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 375,
                                                                                                                                                                                column: 57,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 375,
                                                                                                                                                                            column: 48,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 375,
                                                                                                                                                                            column: 57,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 375,
                                                                                                                                                                        column: 48,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 375,
                                                                                                                                                                        column: 57,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                order: '0'
                                                                                                                                                            }]
                                                                                                                                                    },
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 374,
                                                                                                                                                            column: 44,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 376,
                                                                                                                                                            column: 48,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    order: '0'
                                                                                                                                                },
                                                                                                                                                {
                                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                                    expression: {
                                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                                        objectType: {
                                                                                                                                                            type: 'CallExpression',
                                                                                                                                                            callee: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'Div',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 376,
                                                                                                                                                                        column: 44,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 376,
                                                                                                                                                                        column: 47,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            arguments: [{
                                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                                    properties: [
                                                                                                                                                                        {
                                                                                                                                                                            type: 'Property',
                                                                                                                                                                            key: {
                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                name: 'class',
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 376,
                                                                                                                                                                                        column: 49,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 376,
                                                                                                                                                                                        column: 54,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            value: {
                                                                                                                                                                                type: 'Literal',
                                                                                                                                                                                value: 'dashboard-darkgray'
                                                                                                                                                                            },
                                                                                                                                                                            kind: 'init',
                                                                                                                                                                            order: '0'
                                                                                                                                                                        },
                                                                                                                                                                        {
                                                                                                                                                                            type: 'Property',
                                                                                                                                                                            key: {
                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                name: 'style',
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 376,
                                                                                                                                                                                        column: 76,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 376,
                                                                                                                                                                                        column: 81,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            value: {
                                                                                                                                                                                type: 'Literal',
                                                                                                                                                                                value: 'font-size:14px'
                                                                                                                                                                            },
                                                                                                                                                                            kind: 'init',
                                                                                                                                                                            order: '1'
                                                                                                                                                                        }
                                                                                                                                                                    ]
                                                                                                                                                                }],
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 376,
                                                                                                                                                                    column: 44,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 376,
                                                                                                                                                                    column: 100,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        properties: [{
                                                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                                                expression: {
                                                                                                                                                                    type: 'MemberExpression',
                                                                                                                                                                    computed: false,
                                                                                                                                                                    object: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'project',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 377,
                                                                                                                                                                                column: 48,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 377,
                                                                                                                                                                                column: 55,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    property: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'name',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 377,
                                                                                                                                                                                column: 56,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 377,
                                                                                                                                                                                column: 60,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 377,
                                                                                                                                                                            column: 48,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 377,
                                                                                                                                                                            column: 60,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 377,
                                                                                                                                                                        column: 48,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 377,
                                                                                                                                                                        column: 60,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                order: '0'
                                                                                                                                                            }]
                                                                                                                                                    },
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 376,
                                                                                                                                                            column: 44,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 379,
                                                                                                                                                            column: 48,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    order: '1'
                                                                                                                                                },
                                                                                                                                                {
                                                                                                                                                    type: 'VariableDeclaration',
                                                                                                                                                    declarations: [{
                                                                                                                                                            type: 'VariableDeclarator',
                                                                                                                                                            id: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'startsViewedDay',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 379,
                                                                                                                                                                        column: 48,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 379,
                                                                                                                                                                        column: 63,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            init: {
                                                                                                                                                                type: 'BinaryExpression',
                                                                                                                                                                operator: '===',
                                                                                                                                                                left: {
                                                                                                                                                                    type: 'CallExpression',
                                                                                                                                                                    callee: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'dateString',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 379,
                                                                                                                                                                                column: 66,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 379,
                                                                                                                                                                                column: 76,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    arguments: [{
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'date',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 379,
                                                                                                                                                                                    column: 77,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 379,
                                                                                                                                                                                    column: 81,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        }],
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 379,
                                                                                                                                                                            column: 66,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 379,
                                                                                                                                                                            column: 82,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                right: {
                                                                                                                                                                    type: 'CallExpression',
                                                                                                                                                                    callee: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'dateString',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 379,
                                                                                                                                                                                column: 86,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 379,
                                                                                                                                                                                column: 96,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    arguments: [{
                                                                                                                                                                            type: 'CallExpression',
                                                                                                                                                                            callee: {
                                                                                                                                                                                type: 'MemberExpression',
                                                                                                                                                                                computed: false,
                                                                                                                                                                                object: {
                                                                                                                                                                                    type: 'MemberExpression',
                                                                                                                                                                                    computed: false,
                                                                                                                                                                                    object: {
                                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                                        name: 'task',
                                                                                                                                                                                        loc: {
                                                                                                                                                                                            start: {
                                                                                                                                                                                                line: 379,
                                                                                                                                                                                                column: 97,
                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                            },
                                                                                                                                                                                            end: {
                                                                                                                                                                                                line: 379,
                                                                                                                                                                                                column: 101,
                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                            }
                                                                                                                                                                                        }
                                                                                                                                                                                    },
                                                                                                                                                                                    property: {
                                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                                        name: 'Start',
                                                                                                                                                                                        loc: {
                                                                                                                                                                                            start: {
                                                                                                                                                                                                line: 379,
                                                                                                                                                                                                column: 102,
                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                            },
                                                                                                                                                                                            end: {
                                                                                                                                                                                                line: 379,
                                                                                                                                                                                                column: 107,
                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                            }
                                                                                                                                                                                        }
                                                                                                                                                                                    },
                                                                                                                                                                                    loc: {
                                                                                                                                                                                        start: {
                                                                                                                                                                                            line: 379,
                                                                                                                                                                                            column: 97,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                        },
                                                                                                                                                                                        end: {
                                                                                                                                                                                            line: 379,
                                                                                                                                                                                            column: 107,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                        }
                                                                                                                                                                                    }
                                                                                                                                                                                },
                                                                                                                                                                                property: {
                                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                                    name: 'toDate',
                                                                                                                                                                                    loc: {
                                                                                                                                                                                        start: {
                                                                                                                                                                                            line: 379,
                                                                                                                                                                                            column: 108,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                        },
                                                                                                                                                                                        end: {
                                                                                                                                                                                            line: 379,
                                                                                                                                                                                            column: 114,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                        }
                                                                                                                                                                                    }
                                                                                                                                                                                },
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 379,
                                                                                                                                                                                        column: 97,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 379,
                                                                                                                                                                                        column: 114,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            arguments: [],
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 379,
                                                                                                                                                                                    column: 97,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 379,
                                                                                                                                                                                    column: 116,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        }],
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 379,
                                                                                                                                                                            column: 86,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 379,
                                                                                                                                                                            column: 117,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        }],
                                                                                                                                                    kind: 'let',
                                                                                                                                                    order: '2'
                                                                                                                                                },
                                                                                                                                                {
                                                                                                                                                    type: 'VariableDeclaration',
                                                                                                                                                    declarations: [{
                                                                                                                                                            type: 'VariableDeclarator',
                                                                                                                                                            id: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'endsViewedDay',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 380,
                                                                                                                                                                        column: 48,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 380,
                                                                                                                                                                        column: 61,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            init: {
                                                                                                                                                                type: 'BinaryExpression',
                                                                                                                                                                operator: '===',
                                                                                                                                                                left: {
                                                                                                                                                                    type: 'CallExpression',
                                                                                                                                                                    callee: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'dateString',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 380,
                                                                                                                                                                                column: 64,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 380,
                                                                                                                                                                                column: 74,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    arguments: [{
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'date',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 380,
                                                                                                                                                                                    column: 75,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 380,
                                                                                                                                                                                    column: 79,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        }],
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 380,
                                                                                                                                                                            column: 64,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 380,
                                                                                                                                                                            column: 80,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                right: {
                                                                                                                                                                    type: 'CallExpression',
                                                                                                                                                                    callee: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'dateString',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 380,
                                                                                                                                                                                column: 84,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 380,
                                                                                                                                                                                column: 94,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    arguments: [{
                                                                                                                                                                            type: 'CallExpression',
                                                                                                                                                                            callee: {
                                                                                                                                                                                type: 'MemberExpression',
                                                                                                                                                                                computed: false,
                                                                                                                                                                                object: {
                                                                                                                                                                                    type: 'MemberExpression',
                                                                                                                                                                                    computed: false,
                                                                                                                                                                                    object: {
                                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                                        name: 'task',
                                                                                                                                                                                        loc: {
                                                                                                                                                                                            start: {
                                                                                                                                                                                                line: 380,
                                                                                                                                                                                                column: 95,
                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                            },
                                                                                                                                                                                            end: {
                                                                                                                                                                                                line: 380,
                                                                                                                                                                                                column: 99,
                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                            }
                                                                                                                                                                                        }
                                                                                                                                                                                    },
                                                                                                                                                                                    property: {
                                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                                        name: 'Finish',
                                                                                                                                                                                        loc: {
                                                                                                                                                                                            start: {
                                                                                                                                                                                                line: 380,
                                                                                                                                                                                                column: 100,
                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                            },
                                                                                                                                                                                            end: {
                                                                                                                                                                                                line: 380,
                                                                                                                                                                                                column: 106,
                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                            }
                                                                                                                                                                                        }
                                                                                                                                                                                    },
                                                                                                                                                                                    loc: {
                                                                                                                                                                                        start: {
                                                                                                                                                                                            line: 380,
                                                                                                                                                                                            column: 95,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                        },
                                                                                                                                                                                        end: {
                                                                                                                                                                                            line: 380,
                                                                                                                                                                                            column: 106,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                        }
                                                                                                                                                                                    }
                                                                                                                                                                                },
                                                                                                                                                                                property: {
                                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                                    name: 'toDate',
                                                                                                                                                                                    loc: {
                                                                                                                                                                                        start: {
                                                                                                                                                                                            line: 380,
                                                                                                                                                                                            column: 107,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                        },
                                                                                                                                                                                        end: {
                                                                                                                                                                                            line: 380,
                                                                                                                                                                                            column: 113,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                        }
                                                                                                                                                                                    }
                                                                                                                                                                                },
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 380,
                                                                                                                                                                                        column: 95,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 380,
                                                                                                                                                                                        column: 113,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            arguments: [],
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 380,
                                                                                                                                                                                    column: 95,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 380,
                                                                                                                                                                                    column: 115,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        }],
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 380,
                                                                                                                                                                            column: 84,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 380,
                                                                                                                                                                            column: 116,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        }],
                                                                                                                                                    kind: 'let',
                                                                                                                                                    order: '3'
                                                                                                                                                },
                                                                                                                                                {
                                                                                                                                                    type: 'VariableDeclaration',
                                                                                                                                                    declarations: [{
                                                                                                                                                            type: 'VariableDeclarator',
                                                                                                                                                            id: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'hasStartTime',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 381,
                                                                                                                                                                        column: 48,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 381,
                                                                                                                                                                        column: 60,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            init: {
                                                                                                                                                                type: 'BinaryExpression',
                                                                                                                                                                operator: '!==',
                                                                                                                                                                left: {
                                                                                                                                                                    type: 'CallExpression',
                                                                                                                                                                    callee: {
                                                                                                                                                                        type: 'MemberExpression',
                                                                                                                                                                        computed: false,
                                                                                                                                                                        object: {
                                                                                                                                                                            type: 'MemberExpression',
                                                                                                                                                                            computed: false,
                                                                                                                                                                            object: {
                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                name: 'task',
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 381,
                                                                                                                                                                                        column: 63,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 381,
                                                                                                                                                                                        column: 67,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            property: {
                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                name: 'Start',
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 381,
                                                                                                                                                                                        column: 68,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 381,
                                                                                                                                                                                        column: 73,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 381,
                                                                                                                                                                                    column: 63,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 381,
                                                                                                                                                                                    column: 73,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        property: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'getIsoTime',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 381,
                                                                                                                                                                                    column: 74,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 381,
                                                                                                                                                                                    column: 84,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 381,
                                                                                                                                                                                column: 63,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 381,
                                                                                                                                                                                column: 84,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    arguments: [],
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 381,
                                                                                                                                                                            column: 63,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 381,
                                                                                                                                                                            column: 86,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                right: {
                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                    value: ''
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        }],
                                                                                                                                                    kind: 'let',
                                                                                                                                                    order: '4'
                                                                                                                                                },
                                                                                                                                                {
                                                                                                                                                    type: 'VariableDeclaration',
                                                                                                                                                    declarations: [{
                                                                                                                                                            type: 'VariableDeclarator',
                                                                                                                                                            id: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'hasEndTime',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 382,
                                                                                                                                                                        column: 48,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 382,
                                                                                                                                                                        column: 58,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            init: {
                                                                                                                                                                type: 'BinaryExpression',
                                                                                                                                                                operator: '!==',
                                                                                                                                                                left: {
                                                                                                                                                                    type: 'CallExpression',
                                                                                                                                                                    callee: {
                                                                                                                                                                        type: 'MemberExpression',
                                                                                                                                                                        computed: false,
                                                                                                                                                                        object: {
                                                                                                                                                                            type: 'MemberExpression',
                                                                                                                                                                            computed: false,
                                                                                                                                                                            object: {
                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                name: 'task',
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 382,
                                                                                                                                                                                        column: 61,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 382,
                                                                                                                                                                                        column: 65,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            property: {
                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                name: 'Finish',
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 382,
                                                                                                                                                                                        column: 66,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 382,
                                                                                                                                                                                        column: 72,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 382,
                                                                                                                                                                                    column: 61,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 382,
                                                                                                                                                                                    column: 72,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        property: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'getIsoTime',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 382,
                                                                                                                                                                                    column: 73,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 382,
                                                                                                                                                                                    column: 83,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 382,
                                                                                                                                                                                column: 61,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 382,
                                                                                                                                                                                column: 83,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    arguments: [],
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 382,
                                                                                                                                                                            column: 61,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 382,
                                                                                                                                                                            column: 85,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                right: {
                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                    value: ''
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        }],
                                                                                                                                                    kind: 'let',
                                                                                                                                                    order: '5'
                                                                                                                                                },
                                                                                                                                                {
                                                                                                                                                    type: 'IfStatement',
                                                                                                                                                    test: {
                                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                                        operator: '&&',
                                                                                                                                                        left: {
                                                                                                                                                            type: 'BinaryExpression',
                                                                                                                                                            operator: '&&',
                                                                                                                                                            left: {
                                                                                                                                                                type: 'BinaryExpression',
                                                                                                                                                                operator: '&&',
                                                                                                                                                                left: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'startsViewedDay',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 383,
                                                                                                                                                                            column: 47,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 383,
                                                                                                                                                                            column: 62,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                right: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'endsViewedDay',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 383,
                                                                                                                                                                            column: 67,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 383,
                                                                                                                                                                            column: 80,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            right: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'hasStartTime',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 383,
                                                                                                                                                                        column: 85,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 383,
                                                                                                                                                                        column: 97,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        right: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'hasEndTime',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 383,
                                                                                                                                                                    column: 102,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 383,
                                                                                                                                                                    column: 112,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    consequent: {
                                                                                                                                                        type: 'BlockStatement',
                                                                                                                                                        body: [{
                                                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                                                expression: {
                                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                                    objectType: {
                                                                                                                                                                        type: 'CallExpression',
                                                                                                                                                                        callee: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'Div',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 384,
                                                                                                                                                                                    column: 48,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 384,
                                                                                                                                                                                    column: 51,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        arguments: [{
                                                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                                                properties: [
                                                                                                                                                                                    {
                                                                                                                                                                                        type: 'Property',
                                                                                                                                                                                        key: {
                                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                                            name: 'class',
                                                                                                                                                                                            loc: {
                                                                                                                                                                                                start: {
                                                                                                                                                                                                    line: 384,
                                                                                                                                                                                                    column: 53,
                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                                },
                                                                                                                                                                                                end: {
                                                                                                                                                                                                    line: 384,
                                                                                                                                                                                                    column: 58,
                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                                }
                                                                                                                                                                                            }
                                                                                                                                                                                        },
                                                                                                                                                                                        value: {
                                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                                            value: 'dashboard-darkgray'
                                                                                                                                                                                        },
                                                                                                                                                                                        kind: 'init',
                                                                                                                                                                                        order: '0'
                                                                                                                                                                                    },
                                                                                                                                                                                    {
                                                                                                                                                                                        type: 'Property',
                                                                                                                                                                                        key: {
                                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                                            name: 'style',
                                                                                                                                                                                            loc: {
                                                                                                                                                                                                start: {
                                                                                                                                                                                                    line: 384,
                                                                                                                                                                                                    column: 80,
                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                                },
                                                                                                                                                                                                end: {
                                                                                                                                                                                                    line: 384,
                                                                                                                                                                                                    column: 85,
                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                                }
                                                                                                                                                                                            }
                                                                                                                                                                                        },
                                                                                                                                                                                        value: {
                                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                                            value: 'font-size:14px'
                                                                                                                                                                                        },
                                                                                                                                                                                        kind: 'init',
                                                                                                                                                                                        order: '1'
                                                                                                                                                                                    }
                                                                                                                                                                                ]
                                                                                                                                                                            }],
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 384,
                                                                                                                                                                                column: 48,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 384,
                                                                                                                                                                                column: 104,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    properties: [{
                                                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                                                            expression: {
                                                                                                                                                                                type: 'BinaryExpression',
                                                                                                                                                                                operator: '+',
                                                                                                                                                                                left: {
                                                                                                                                                                                    type: 'BinaryExpression',
                                                                                                                                                                                    operator: '+',
                                                                                                                                                                                    left: {
                                                                                                                                                                                        type: 'CallExpression',
                                                                                                                                                                                        callee: {
                                                                                                                                                                                            type: 'MemberExpression',
                                                                                                                                                                                            computed: false,
                                                                                                                                                                                            object: {
                                                                                                                                                                                                type: 'CallExpression',
                                                                                                                                                                                                callee: {
                                                                                                                                                                                                    type: 'MemberExpression',
                                                                                                                                                                                                    computed: false,
                                                                                                                                                                                                    object: {
                                                                                                                                                                                                        type: 'MemberExpression',
                                                                                                                                                                                                        computed: false,
                                                                                                                                                                                                        object: {
                                                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                                                            name: 'task',
                                                                                                                                                                                                            loc: {
                                                                                                                                                                                                                start: {
                                                                                                                                                                                                                    line: 385,
                                                                                                                                                                                                                    column: 52,
                                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                                                },
                                                                                                                                                                                                                end: {
                                                                                                                                                                                                                    line: 385,
                                                                                                                                                                                                                    column: 56,
                                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                                                }
                                                                                                                                                                                                            }
                                                                                                                                                                                                        },
                                                                                                                                                                                                        property: {
                                                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                                                            name: 'Start',
                                                                                                                                                                                                            loc: {
                                                                                                                                                                                                                start: {
                                                                                                                                                                                                                    line: 385,
                                                                                                                                                                                                                    column: 57,
                                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                                                },
                                                                                                                                                                                                                end: {
                                                                                                                                                                                                                    line: 385,
                                                                                                                                                                                                                    column: 62,
                                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                                                }
                                                                                                                                                                                                            }
                                                                                                                                                                                                        },
                                                                                                                                                                                                        loc: {
                                                                                                                                                                                                            start: {
                                                                                                                                                                                                                line: 385,
                                                                                                                                                                                                                column: 52,
                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                                            },
                                                                                                                                                                                                            end: {
                                                                                                                                                                                                                line: 385,
                                                                                                                                                                                                                column: 62,
                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                                            }
                                                                                                                                                                                                        }
                                                                                                                                                                                                    },
                                                                                                                                                                                                    property: {
                                                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                                                        name: 'toDate',
                                                                                                                                                                                                        loc: {
                                                                                                                                                                                                            start: {
                                                                                                                                                                                                                line: 385,
                                                                                                                                                                                                                column: 63,
                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                                            },
                                                                                                                                                                                                            end: {
                                                                                                                                                                                                                line: 385,
                                                                                                                                                                                                                column: 69,
                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                                            }
                                                                                                                                                                                                        }
                                                                                                                                                                                                    },
                                                                                                                                                                                                    loc: {
                                                                                                                                                                                                        start: {
                                                                                                                                                                                                            line: 385,
                                                                                                                                                                                                            column: 52,
                                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                                        },
                                                                                                                                                                                                        end: {
                                                                                                                                                                                                            line: 385,
                                                                                                                                                                                                            column: 69,
                                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                                        }
                                                                                                                                                                                                    }
                                                                                                                                                                                                },
                                                                                                                                                                                                arguments: [],
                                                                                                                                                                                                loc: {
                                                                                                                                                                                                    start: {
                                                                                                                                                                                                        line: 385,
                                                                                                                                                                                                        column: 52,
                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                                    },
                                                                                                                                                                                                    end: {
                                                                                                                                                                                                        line: 385,
                                                                                                                                                                                                        column: 71,
                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                                    }
                                                                                                                                                                                                }
                                                                                                                                                                                            },
                                                                                                                                                                                            property: {
                                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                                name: 'format',
                                                                                                                                                                                                loc: {
                                                                                                                                                                                                    start: {
                                                                                                                                                                                                        line: 385,
                                                                                                                                                                                                        column: 72,
                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                                    },
                                                                                                                                                                                                    end: {
                                                                                                                                                                                                        line: 385,
                                                                                                                                                                                                        column: 78,
                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                                    }
                                                                                                                                                                                                }
                                                                                                                                                                                            },
                                                                                                                                                                                            loc: {
                                                                                                                                                                                                start: {
                                                                                                                                                                                                    line: 385,
                                                                                                                                                                                                    column: 52,
                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                                },
                                                                                                                                                                                                end: {
                                                                                                                                                                                                    line: 385,
                                                                                                                                                                                                    column: 78,
                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                                }
                                                                                                                                                                                            }
                                                                                                                                                                                        },
                                                                                                                                                                                        arguments: [{
                                                                                                                                                                                                type: 'Literal',
                                                                                                                                                                                                value: '{time}'
                                                                                                                                                                                            }],
                                                                                                                                                                                        loc: {
                                                                                                                                                                                            start: {
                                                                                                                                                                                                line: 385,
                                                                                                                                                                                                column: 52,
                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                            },
                                                                                                                                                                                            end: {
                                                                                                                                                                                                line: 385,
                                                                                                                                                                                                column: 88,
                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                            }
                                                                                                                                                                                        }
                                                                                                                                                                                    },
                                                                                                                                                                                    right: {
                                                                                                                                                                                        type: 'Literal',
                                                                                                                                                                                        value: ' - '
                                                                                                                                                                                    }
                                                                                                                                                                                },
                                                                                                                                                                                right: {
                                                                                                                                                                                    type: 'CallExpression',
                                                                                                                                                                                    callee: {
                                                                                                                                                                                        type: 'MemberExpression',
                                                                                                                                                                                        computed: false,
                                                                                                                                                                                        object: {
                                                                                                                                                                                            type: 'CallExpression',
                                                                                                                                                                                            callee: {
                                                                                                                                                                                                type: 'MemberExpression',
                                                                                                                                                                                                computed: false,
                                                                                                                                                                                                object: {
                                                                                                                                                                                                    type: 'MemberExpression',
                                                                                                                                                                                                    computed: false,
                                                                                                                                                                                                    object: {
                                                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                                                        name: 'task',
                                                                                                                                                                                                        loc: {
                                                                                                                                                                                                            start: {
                                                                                                                                                                                                                line: 385,
                                                                                                                                                                                                                column: 99,
                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                                            },
                                                                                                                                                                                                            end: {
                                                                                                                                                                                                                line: 385,
                                                                                                                                                                                                                column: 103,
                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                                            }
                                                                                                                                                                                                        }
                                                                                                                                                                                                    },
                                                                                                                                                                                                    property: {
                                                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                                                        name: 'Finish',
                                                                                                                                                                                                        loc: {
                                                                                                                                                                                                            start: {
                                                                                                                                                                                                                line: 385,
                                                                                                                                                                                                                column: 104,
                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                                            },
                                                                                                                                                                                                            end: {
                                                                                                                                                                                                                line: 385,
                                                                                                                                                                                                                column: 110,
                                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                                            }
                                                                                                                                                                                                        }
                                                                                                                                                                                                    },
                                                                                                                                                                                                    loc: {
                                                                                                                                                                                                        start: {
                                                                                                                                                                                                            line: 385,
                                                                                                                                                                                                            column: 99,
                                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                                        },
                                                                                                                                                                                                        end: {
                                                                                                                                                                                                            line: 385,
                                                                                                                                                                                                            column: 110,
                                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                                        }
                                                                                                                                                                                                    }
                                                                                                                                                                                                },
                                                                                                                                                                                                property: {
                                                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                                                    name: 'toDate',
                                                                                                                                                                                                    loc: {
                                                                                                                                                                                                        start: {
                                                                                                                                                                                                            line: 385,
                                                                                                                                                                                                            column: 111,
                                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                                        },
                                                                                                                                                                                                        end: {
                                                                                                                                                                                                            line: 385,
                                                                                                                                                                                                            column: 117,
                                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                                        }
                                                                                                                                                                                                    }
                                                                                                                                                                                                },
                                                                                                                                                                                                loc: {
                                                                                                                                                                                                    start: {
                                                                                                                                                                                                        line: 385,
                                                                                                                                                                                                        column: 99,
                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                                    },
                                                                                                                                                                                                    end: {
                                                                                                                                                                                                        line: 385,
                                                                                                                                                                                                        column: 117,
                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                                    }
                                                                                                                                                                                                }
                                                                                                                                                                                            },
                                                                                                                                                                                            arguments: [],
                                                                                                                                                                                            loc: {
                                                                                                                                                                                                start: {
                                                                                                                                                                                                    line: 385,
                                                                                                                                                                                                    column: 99,
                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                                },
                                                                                                                                                                                                end: {
                                                                                                                                                                                                    line: 385,
                                                                                                                                                                                                    column: 119,
                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                                }
                                                                                                                                                                                            }
                                                                                                                                                                                        },
                                                                                                                                                                                        property: {
                                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                                            name: 'format',
                                                                                                                                                                                            loc: {
                                                                                                                                                                                                start: {
                                                                                                                                                                                                    line: 385,
                                                                                                                                                                                                    column: 120,
                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                                },
                                                                                                                                                                                                end: {
                                                                                                                                                                                                    line: 385,
                                                                                                                                                                                                    column: 126,
                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                                }
                                                                                                                                                                                            }
                                                                                                                                                                                        },
                                                                                                                                                                                        loc: {
                                                                                                                                                                                            start: {
                                                                                                                                                                                                line: 385,
                                                                                                                                                                                                column: 99,
                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                            },
                                                                                                                                                                                            end: {
                                                                                                                                                                                                line: 385,
                                                                                                                                                                                                column: 126,
                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                            }
                                                                                                                                                                                        }
                                                                                                                                                                                    },
                                                                                                                                                                                    arguments: [{
                                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                                            value: '{time}'
                                                                                                                                                                                        }],
                                                                                                                                                                                    loc: {
                                                                                                                                                                                        start: {
                                                                                                                                                                                            line: 385,
                                                                                                                                                                                            column: 99,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                        },
                                                                                                                                                                                        end: {
                                                                                                                                                                                            line: 385,
                                                                                                                                                                                            column: 136,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                        }
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 385,
                                                                                                                                                                                    column: 52,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 385,
                                                                                                                                                                                    column: 136,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            order: '0'
                                                                                                                                                                        }]
                                                                                                                                                                },
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 384,
                                                                                                                                                                        column: 48,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 387,
                                                                                                                                                                        column: 52,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                order: '0'
                                                                                                                                                            }]
                                                                                                                                                    },
                                                                                                                                                    alternate: null,
                                                                                                                                                    order: '6'
                                                                                                                                                }
                                                                                                                                            ]
                                                                                                                                        },
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 373,
                                                                                                                                                column: 40,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 387,
                                                                                                                                                column: 44,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        order: '0'
                                                                                                                                    },
                                                                                                                                    {
                                                                                                                                        type: 'ExpressionStatement',
                                                                                                                                        expression: {
                                                                                                                                            type: 'ObjectExpression',
                                                                                                                                            objectType: {
                                                                                                                                                type: 'CallExpression',
                                                                                                                                                callee: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'Div',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 388,
                                                                                                                                                            column: 40,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 388,
                                                                                                                                                            column: 43,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                arguments: [{
                                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                                        properties: [
                                                                                                                                                            {
                                                                                                                                                                type: 'Property',
                                                                                                                                                                key: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'class',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 388,
                                                                                                                                                                            column: 45,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 388,
                                                                                                                                                                            column: 50,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                value: {
                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                    value: 'fill layout horizontal reverse center padding'
                                                                                                                                                                },
                                                                                                                                                                kind: 'init',
                                                                                                                                                                order: '0'
                                                                                                                                                            },
                                                                                                                                                            {
                                                                                                                                                                type: 'Property',
                                                                                                                                                                key: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'style',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 388,
                                                                                                                                                                            column: 100,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 388,
                                                                                                                                                                            column: 105,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                value: {
                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                    value: 'height:0px'
                                                                                                                                                                },
                                                                                                                                                                kind: 'init',
                                                                                                                                                                order: '1'
                                                                                                                                                            }
                                                                                                                                                        ]
                                                                                                                                                    }],
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 388,
                                                                                                                                                        column: 40,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 388,
                                                                                                                                                        column: 120,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            properties: [
                                                                                                                                                {
                                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                                    expression: {
                                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                                        objectType: {
                                                                                                                                                            type: 'CallExpression',
                                                                                                                                                            callee: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'PaperIconButton',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 389,
                                                                                                                                                                        column: 44,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 389,
                                                                                                                                                                        column: 59,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            arguments: [],
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 389,
                                                                                                                                                                    column: 44,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 389,
                                                                                                                                                                    column: 61,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        properties: [
                                                                                                                                                            {
                                                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                                                expression: {
                                                                                                                                                                    type: 'Function',
                                                                                                                                                                    context: true,
                                                                                                                                                                    value: function (_context11) {
                                                                                                                                                                        return function click(e) {
                                                                                                                                                                            var task = _context11.get('task');
                                                                                                                                                                            e.stopPropagation();
                                                                                                                                                                            model.open(Object.assign(task.paneConfig, { tab: 'discussion' }), { target: 'dialog' });
                                                                                                                                                                        };
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 390,
                                                                                                                                                                        column: 48,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 393,
                                                                                                                                                                        column: 52,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                order: '0'
                                                                                                                                                            },
                                                                                                                                                            {
                                                                                                                                                                type: 'Property',
                                                                                                                                                                key: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'icon',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 393,
                                                                                                                                                                            column: 48,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 393,
                                                                                                                                                                            column: 52,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                value: {
                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                    value: 'communication:comment'
                                                                                                                                                                },
                                                                                                                                                                kind: 'init',
                                                                                                                                                                order: '1'
                                                                                                                                                            }
                                                                                                                                                        ]
                                                                                                                                                    },
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 389,
                                                                                                                                                            column: 44,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 394,
                                                                                                                                                            column: 48,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    order: '0'
                                                                                                                                                },
                                                                                                                                                {
                                                                                                                                                    type: 'IfStatement',
                                                                                                                                                    test: {
                                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                                        operator: '>',
                                                                                                                                                        left: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'commentCount',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 394,
                                                                                                                                                                    column: 47,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 394,
                                                                                                                                                                    column: 59,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        right: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: 0
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    consequent: {
                                                                                                                                                        type: 'BlockStatement',
                                                                                                                                                        body: [{
                                                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                                                expression: {
                                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                                    objectType: {
                                                                                                                                                                        type: 'CallExpression',
                                                                                                                                                                        callee: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'Div',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 395,
                                                                                                                                                                                    column: 48,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 395,
                                                                                                                                                                                    column: 51,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        arguments: [{
                                                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                                                properties: [{
                                                                                                                                                                                        type: 'Property',
                                                                                                                                                                                        key: {
                                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                                            name: 'style',
                                                                                                                                                                                            loc: {
                                                                                                                                                                                                start: {
                                                                                                                                                                                                    line: 395,
                                                                                                                                                                                                    column: 53,
                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                                },
                                                                                                                                                                                                end: {
                                                                                                                                                                                                    line: 395,
                                                                                                                                                                                                    column: 58,
                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                                }
                                                                                                                                                                                            }
                                                                                                                                                                                        },
                                                                                                                                                                                        value: {
                                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                                            value: 'margin-top:-5px;margin-right:-5px'
                                                                                                                                                                                        },
                                                                                                                                                                                        kind: 'init',
                                                                                                                                                                                        order: '0'
                                                                                                                                                                                    }]
                                                                                                                                                                            }],
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 395,
                                                                                                                                                                                column: 48,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 395,
                                                                                                                                                                                column: 96,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    properties: [{
                                                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                                                            expression: {
                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                name: 'commentCount',
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 396,
                                                                                                                                                                                        column: 52,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 396,
                                                                                                                                                                                        column: 64,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 396,
                                                                                                                                                                                    column: 52,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 396,
                                                                                                                                                                                    column: 64,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            order: '0'
                                                                                                                                                                        }]
                                                                                                                                                                },
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 395,
                                                                                                                                                                        column: 48,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 398,
                                                                                                                                                                        column: 52,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                order: '0'
                                                                                                                                                            }]
                                                                                                                                                    },
                                                                                                                                                    alternate: null,
                                                                                                                                                    order: '1'
                                                                                                                                                }
                                                                                                                                            ]
                                                                                                                                        },
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 388,
                                                                                                                                                column: 40,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 398,
                                                                                                                                                column: 44,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        order: '1'
                                                                                                                                    }
                                                                                                                                ]
                                                                                                                            },
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 370,
                                                                                                                                    column: 36,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 398,
                                                                                                                                    column: 40,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                }
                                                                                                                            },
                                                                                                                            order: '1'
                                                                                                                        }
                                                                                                                    ]
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 367,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 398,
                                                                                                                        column: 36,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                    }
                                                                                                                },
                                                                                                                order: '3'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'ExpressionStatement',
                                                                                                                expression: {
                                                                                                                    type: 'ObjectExpression',
                                                                                                                    objectType: {
                                                                                                                        type: 'CallExpression',
                                                                                                                        callee: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'Div',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 399,
                                                                                                                                    column: 32,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 399,
                                                                                                                                    column: 35,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        arguments: [{
                                                                                                                                type: 'ObjectExpression',
                                                                                                                                properties: [{
                                                                                                                                        type: 'Property',
                                                                                                                                        key: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'style',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 399,
                                                                                                                                                    column: 37,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 399,
                                                                                                                                                    column: 42,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        value: {
                                                                                                                                            type: 'Literal',
                                                                                                                                            value: 'padding:1px'
                                                                                                                                        },
                                                                                                                                        kind: 'init',
                                                                                                                                        order: '0'
                                                                                                                                    }]
                                                                                                                            }],
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 399,
                                                                                                                                column: 32,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 399,
                                                                                                                                column: 58,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    properties: [{
                                                                                                                            type: 'ExpressionStatement',
                                                                                                                            expression: {
                                                                                                                                type: 'CallExpression',
                                                                                                                                callee: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'Div',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 400,
                                                                                                                                            column: 36,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 400,
                                                                                                                                            column: 39,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                arguments: [{
                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                        properties: [{
                                                                                                                                                type: 'Property',
                                                                                                                                                key: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'style',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 400,
                                                                                                                                                            column: 41,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 400,
                                                                                                                                                            column: 46,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                value: {
                                                                                                                                                    type: 'BinaryExpression',
                                                                                                                                                    operator: '+',
                                                                                                                                                    left: {
                                                                                                                                                        type: 'Literal',
                                                                                                                                                        value: 'height:1px;background-color:'
                                                                                                                                                    },
                                                                                                                                                    right: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'lightGray',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 400,
                                                                                                                                                                column: 78,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 400,
                                                                                                                                                                column: 87,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                kind: 'init',
                                                                                                                                                order: '0'
                                                                                                                                            }]
                                                                                                                                    }],
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 400,
                                                                                                                                        column: 36,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 400,
                                                                                                                                        column: 92,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 400,
                                                                                                                                    column: 36,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 400,
                                                                                                                                    column: 92,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                }
                                                                                                                            },
                                                                                                                            order: '0'
                                                                                                                        }]
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 399,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 402,
                                                                                                                        column: 36,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                    }
                                                                                                                },
                                                                                                                order: '4'
                                                                                                            }
                                                                                                        ]
                                                                                                    },
                                                                                                    remove: null,
                                                                                                    order: '1'
                                                                                                }
                                                                                            ]
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 351,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 402,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 350,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 402,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'Identifier',
                                                                                name: 'calendar',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 403,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 403,
                                                                                        column: 28,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 403,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 403,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                }
                                                                            },
                                                                            order: '1'
                                                                        },
                                                                        {
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'ObjectExpression',
                                                                                objectType: {
                                                                                    type: 'CallExpression',
                                                                                    callee: {
                                                                                        type: 'Identifier',
                                                                                        name: 'Div',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 407,
                                                                                                column: 20,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 407,
                                                                                                column: 23,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    arguments: [{
                                                                                            type: 'ObjectExpression',
                                                                                            properties: [{
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'class',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 407,
                                                                                                                column: 25,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 407,
                                                                                                                column: 30,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'Literal',
                                                                                                        value: 'fill layout vertical center-justified center padding'
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '0'
                                                                                                }]
                                                                                        }],
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 407,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 407,
                                                                                            column: 87,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                properties: [
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'ObjectExpression',
                                                                                            objectType: {
                                                                                                type: 'CallExpression',
                                                                                                callee: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'Div',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 408,
                                                                                                            column: 24,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 408,
                                                                                                            column: 27,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                arguments: [],
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 408,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 408,
                                                                                                        column: 29,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            properties: [
                                                                                                {
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'style',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 409,
                                                                                                                column: 28,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 409,
                                                                                                                column: 33,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'ObjectExpression',
                                                                                                        properties: [{
                                                                                                                type: 'Property',
                                                                                                                key: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'fontSize',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 409,
                                                                                                                            column: 36,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 409,
                                                                                                                            column: 44,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                value: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: '30px'
                                                                                                                },
                                                                                                                kind: 'init',
                                                                                                                order: '0'
                                                                                                            }]
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '0'
                                                                                                },
                                                                                                {
                                                                                                    type: 'ExpressionStatement',
                                                                                                    expression: {
                                                                                                        type: 'MemberExpression',
                                                                                                        computed: false,
                                                                                                        object: {
                                                                                                            type: 'CallExpression',
                                                                                                            callee: {
                                                                                                                type: 'MemberExpression',
                                                                                                                computed: false,
                                                                                                                object: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'Object',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 410,
                                                                                                                            column: 28,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 410,
                                                                                                                            column: 34,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                property: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'keys',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 410,
                                                                                                                            column: 35,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 410,
                                                                                                                            column: 39,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 410,
                                                                                                                        column: 28,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 410,
                                                                                                                        column: 39,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            arguments: [{
                                                                                                                    type: 'ConditionalExpression',
                                                                                                                    test: {
                                                                                                                        type: 'BinaryExpression',
                                                                                                                        operator: '!=',
                                                                                                                        left: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'tasks',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 410,
                                                                                                                                    column: 40,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 410,
                                                                                                                                    column: 45,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        right: {
                                                                                                                            type: 'Literal',
                                                                                                                            value: null
                                                                                                                        }
                                                                                                                    },
                                                                                                                    consequent: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'tasks',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 410,
                                                                                                                                column: 40,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 410,
                                                                                                                                column: 45,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    alternate: {
                                                                                                                        type: 'ObjectExpression',
                                                                                                                        properties: []
                                                                                                                    }
                                                                                                                }],
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 410,
                                                                                                                    column: 28,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 410,
                                                                                                                    column: 51,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        property: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'length',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 410,
                                                                                                                    column: 52,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 410,
                                                                                                                    column: 58,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 410,
                                                                                                                column: 28,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 410,
                                                                                                                column: 58,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 410,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 410,
                                                                                                            column: 58,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        }
                                                                                                    },
                                                                                                    order: '1'
                                                                                                }
                                                                                            ]
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 408,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 411,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'ObjectExpression',
                                                                                            objectType: {
                                                                                                type: 'CallExpression',
                                                                                                callee: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'Div',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 411,
                                                                                                            column: 24,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 411,
                                                                                                            column: 27,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                arguments: [{
                                                                                                        type: 'ObjectExpression',
                                                                                                        properties: [{
                                                                                                                type: 'Property',
                                                                                                                key: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'class',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 411,
                                                                                                                            column: 29,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 411,
                                                                                                                            column: 34,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                value: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: 'dashboard-darkgray'
                                                                                                                },
                                                                                                                kind: 'init',
                                                                                                                order: '0'
                                                                                                            }]
                                                                                                    }],
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 411,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 411,
                                                                                                        column: 57,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            properties: [{
                                                                                                    type: 'ExpressionStatement',
                                                                                                    expression: {
                                                                                                        type: 'Literal',
                                                                                                        value: 'Assigned tasks '
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 412,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 412,
                                                                                                            column: 45,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        }
                                                                                                    },
                                                                                                    order: '0'
                                                                                                }]
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 411,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 414,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '1'
                                                                                    }
                                                                                ]
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 407,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 414,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                }
                                                                            },
                                                                            order: '2'
                                                                        }
                                                                    ]
                                                                },
                                                                order: '0'
                                                            }],
                                                        bound: false,
                                                        name: {
                                                            type: 'Identifier',
                                                            name: 'content',
                                                            loc: {
                                                                start: {
                                                                    line: 347,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                },
                                                                end: {
                                                                    line: 347,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                }
                                                            }
                                                        },
                                                        scope: {
                                                            type: 'Identifier',
                                                            name: '_ps2'
                                                        }
                                                    }, {
                                                        this: this,
                                                        _ps2: _ps2,
                                                        _ref9: _ref9,
                                                        ion: ion,
                                                        glass: glass,
                                                        _ref: _ref,
                                                        _ref2: _ref2,
                                                        _ref3: _ref3,
                                                        _ref4: _ref4,
                                                        style: style,
                                                        _ref5: _ref5,
                                                        namespace: namespace,
                                                        _ref6: _ref6,
                                                        _ref7: _ref7,
                                                        DateTime: DateTime,
                                                        RecordChip: RecordChip,
                                                        RecordIcon: RecordIcon,
                                                        PromptDialog: PromptDialog,
                                                        Key: Key,
                                                        SetupWizard: SetupWizard,
                                                        SubscriptionNotice: SubscriptionNotice,
                                                        Task: Task,
                                                        Project: Project,
                                                        ProjectType: ProjectType,
                                                        User: User,
                                                        Comment: Comment,
                                                        createProjectPrompt: createProjectPrompt,
                                                        lightGray: lightGray,
                                                        gray: gray,
                                                        darkGray: darkGray,
                                                        DashboardCard: DashboardCard,
                                                        dateString: dateString,
                                                        getWeeks: getWeeks,
                                                        workHoursOnDateFromTask: workHoursOnDateFromTask,
                                                        getDays: getDays,
                                                        TaskCalendarModel: TaskCalendarModel,
                                                        capitalize: capitalize,
                                                        displayDate: displayDate,
                                                        dateColor: dateColor,
                                                        TaskCalendar: TaskCalendar,
                                                        TasksCard: TasksCard,
                                                        ProjectsCard: ProjectsCard,
                                                        MembersCard: MembersCard,
                                                        mostRecentComment: mostRecentComment,
                                                        DiscussionsCard: DiscussionsCard,
                                                        getTaskComments: getTaskComments,
                                                        Dashboard: Dashboard
                                                    }, _ps2);
                                                });
                                            }
                                        },
                                        kind: 'init',
                                        order: '3'
                                    }
                                ]
                            }],
                        loc: {
                            start: {
                                line: 291,
                                column: 15,
                                fixed: true,
                                source: 'viewpath/html/panes/DashboardPane.ion'
                            },
                            end: {
                                line: 414,
                                column: 12,
                                fixed: true,
                                source: 'viewpath/html/panes/DashboardPane.ion'
                            }
                        }
                    },
                    order: '8'
                }
            ],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'TasksCard',
                loc: {
                    start: {
                        line: 282,
                        column: 4,
                        fixed: true,
                        source: 'viewpath/html/panes/DashboardPane.ion'
                    },
                    end: {
                        line: 282,
                        column: 13,
                        fixed: true,
                        source: 'viewpath/html/panes/DashboardPane.ion'
                    }
                }
            }
        }, {
            this: this,
            ion: ion,
            _ref9: _ref9,
            glass: glass,
            _ref: _ref,
            _ref2: _ref2,
            _ref3: _ref3,
            _ref4: _ref4,
            style: style,
            _ref5: _ref5,
            namespace: namespace,
            _ref6: _ref6,
            _ref7: _ref7,
            DateTime: DateTime,
            RecordChip: RecordChip,
            RecordIcon: RecordIcon,
            PromptDialog: PromptDialog,
            Key: Key,
            SetupWizard: SetupWizard,
            SubscriptionNotice: SubscriptionNotice,
            Task: Task,
            Project: Project,
            ProjectType: ProjectType,
            User: User,
            Comment: Comment,
            createProjectPrompt: createProjectPrompt,
            lightGray: lightGray,
            gray: gray,
            darkGray: darkGray,
            DashboardCard: DashboardCard,
            dateString: dateString,
            getWeeks: getWeeks,
            workHoursOnDateFromTask: workHoursOnDateFromTask,
            getDays: getDays,
            TaskCalendarModel: TaskCalendarModel,
            capitalize: capitalize,
            displayDate: displayDate,
            dateColor: dateColor,
            TaskCalendar: TaskCalendar,
            TasksCard: TasksCard,
            ProjectsCard: ProjectsCard,
            MembersCard: MembersCard,
            mostRecentComment: mostRecentComment,
            DiscussionsCard: DiscussionsCard,
            getTaskComments: getTaskComments,
            Dashboard: Dashboard
        }, null);
    });
var ProjectsCard = ion.template(function (_ref10) {
        return ion.createRuntime({
            type: 'Template',
            id: null,
            body: [
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'projects',
                                loc: {
                                    start: {
                                        line: 416,
                                        column: 29,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 416,
                                        column: 37,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref10'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'projects',
                                    loc: {
                                        start: {
                                            line: 416,
                                            column: 29,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        },
                                        end: {
                                            line: 416,
                                            column: 37,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '0'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'hasLicence',
                                loc: {
                                    start: {
                                        line: 416,
                                        column: 39,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 416,
                                        column: 49,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref10'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'hasLicence',
                                    loc: {
                                        start: {
                                            line: 416,
                                            column: 39,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        },
                                        end: {
                                            line: 416,
                                            column: 49,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '1'
                },
                {
                    type: 'ReturnStatement',
                    argument: {
                        type: 'CallExpression',
                        callee: {
                            type: 'Identifier',
                            name: 'DashboardCard',
                            loc: {
                                start: {
                                    line: 417,
                                    column: 19,
                                    fixed: true,
                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                },
                                end: {
                                    line: 417,
                                    column: 32,
                                    fixed: true,
                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                }
                            }
                        },
                        arguments: [{
                                type: 'ObjectExpression',
                                properties: [
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'title',
                                            loc: {
                                                start: {
                                                    line: 418,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                },
                                                end: {
                                                    line: 418,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: 'Projects'
                                        },
                                        kind: 'init',
                                        order: '0'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'paneId',
                                            loc: {
                                                start: {
                                                    line: 419,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                },
                                                end: {
                                                    line: 419,
                                                    column: 22,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: 'Projects'
                                        },
                                        kind: 'init',
                                        order: '1'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'toolbar',
                                            loc: {
                                                start: {
                                                    line: 420,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                },
                                                end: {
                                                    line: 420,
                                                    column: 23,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Function',
                                            context: true,
                                            value: function (_ps3) {
                                                return ion.template(function () {
                                                    return ion.createRuntime({
                                                        type: 'Template',
                                                        id: null,
                                                        body: [{
                                                                type: 'ReturnStatement',
                                                                argument: {
                                                                    type: 'ObjectExpression',
                                                                    objectType: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'Identifier',
                                                                            name: 'Div',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 420,
                                                                                    column: 37,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 420,
                                                                                    column: 40,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [],
                                                                        loc: {
                                                                            start: {
                                                                                line: 420,
                                                                                column: 37,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 420,
                                                                                column: 42,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    properties: [{
                                                                            type: 'IfStatement',
                                                                            test: {
                                                                                type: 'Identifier',
                                                                                name: 'hasLicence',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 421,
                                                                                        column: 23,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 421,
                                                                                        column: 33,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            consequent: {
                                                                                type: 'BlockStatement',
                                                                                body: [{
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'ObjectExpression',
                                                                                            objectType: {
                                                                                                type: 'CallExpression',
                                                                                                callee: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'PaperIconButton',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 422,
                                                                                                            column: 24,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 422,
                                                                                                            column: 39,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                arguments: [{
                                                                                                        type: 'ObjectExpression',
                                                                                                        properties: [{
                                                                                                                type: 'Property',
                                                                                                                key: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'class',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 422,
                                                                                                                            column: 41,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 422,
                                                                                                                            column: 46,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                value: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: 'dashboard-gray'
                                                                                                                },
                                                                                                                kind: 'init',
                                                                                                                order: '0'
                                                                                                            }]
                                                                                                    }],
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 422,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 422,
                                                                                                        column: 65,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            properties: [
                                                                                                {
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'icon',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 423,
                                                                                                                column: 32,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 423,
                                                                                                                column: 36,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'Literal',
                                                                                                        value: 'add'
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '0'
                                                                                                },
                                                                                                {
                                                                                                    type: 'ExpressionStatement',
                                                                                                    expression: {
                                                                                                        type: 'Function',
                                                                                                        context: true,
                                                                                                        value: function (_context12) {
                                                                                                            return function click() {
                                                                                                                var ProjectType = _context12.get('ProjectType'), createProjectPrompt = _context12.get('createProjectPrompt');
                                                                                                                var title = 'New Project';
                                                                                                                var properties = {
                                                                                                                        name: 'New Project',
                                                                                                                        type: ProjectType.Project.id
                                                                                                                    };
                                                                                                                createProjectPrompt({
                                                                                                                    title: title,
                                                                                                                    properties: properties
                                                                                                                });
                                                                                                            };
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 424,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 428,
                                                                                                            column: 36,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        }
                                                                                                    },
                                                                                                    order: '1'
                                                                                                }
                                                                                            ]
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 422,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 428,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            alternate: null,
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                order: '0'
                                                            }],
                                                        bound: false,
                                                        name: {
                                                            type: 'Identifier',
                                                            name: 'toolbar',
                                                            loc: {
                                                                start: {
                                                                    line: 420,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                },
                                                                end: {
                                                                    line: 420,
                                                                    column: 23,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                }
                                                            }
                                                        },
                                                        scope: {
                                                            type: 'Identifier',
                                                            name: '_ps3'
                                                        }
                                                    }, {
                                                        this: this,
                                                        _ps3: _ps3,
                                                        _ref10: _ref10,
                                                        ion: ion,
                                                        glass: glass,
                                                        _ref: _ref,
                                                        _ref2: _ref2,
                                                        _ref3: _ref3,
                                                        _ref4: _ref4,
                                                        style: style,
                                                        _ref5: _ref5,
                                                        namespace: namespace,
                                                        _ref6: _ref6,
                                                        _ref7: _ref7,
                                                        DateTime: DateTime,
                                                        RecordChip: RecordChip,
                                                        RecordIcon: RecordIcon,
                                                        PromptDialog: PromptDialog,
                                                        Key: Key,
                                                        SetupWizard: SetupWizard,
                                                        SubscriptionNotice: SubscriptionNotice,
                                                        Task: Task,
                                                        Project: Project,
                                                        ProjectType: ProjectType,
                                                        User: User,
                                                        Comment: Comment,
                                                        createProjectPrompt: createProjectPrompt,
                                                        lightGray: lightGray,
                                                        gray: gray,
                                                        darkGray: darkGray,
                                                        DashboardCard: DashboardCard,
                                                        dateString: dateString,
                                                        getWeeks: getWeeks,
                                                        workHoursOnDateFromTask: workHoursOnDateFromTask,
                                                        getDays: getDays,
                                                        TaskCalendarModel: TaskCalendarModel,
                                                        capitalize: capitalize,
                                                        displayDate: displayDate,
                                                        dateColor: dateColor,
                                                        TaskCalendar: TaskCalendar,
                                                        TasksCard: TasksCard,
                                                        ProjectsCard: ProjectsCard,
                                                        MembersCard: MembersCard,
                                                        mostRecentComment: mostRecentComment,
                                                        DiscussionsCard: DiscussionsCard,
                                                        getTaskComments: getTaskComments,
                                                        Dashboard: Dashboard
                                                    }, _ps3);
                                                });
                                            }
                                        },
                                        kind: 'init',
                                        order: '2'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'content',
                                            loc: {
                                                start: {
                                                    line: 428,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                },
                                                end: {
                                                    line: 428,
                                                    column: 23,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Function',
                                            context: true,
                                            value: function (_ps4) {
                                                return ion.template(function () {
                                                    return ion.createRuntime({
                                                        type: 'Template',
                                                        id: null,
                                                        body: [{
                                                                type: 'ReturnStatement',
                                                                argument: {
                                                                    type: 'ObjectExpression',
                                                                    objectType: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'Identifier',
                                                                            name: 'Div',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 429,
                                                                                    column: 27,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 429,
                                                                                    column: 30,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [{
                                                                                type: 'ObjectExpression',
                                                                                properties: [{
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'class',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 429,
                                                                                                    column: 32,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 429,
                                                                                                    column: 37,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 'content'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    }]
                                                                            }],
                                                                        loc: {
                                                                            start: {
                                                                                line: 429,
                                                                                column: 27,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 429,
                                                                                column: 49,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    properties: [{
                                                                            type: 'IfStatement',
                                                                            test: {
                                                                                type: 'UnaryExpression',
                                                                                operator: '!',
                                                                                argument: {
                                                                                    type: 'Identifier',
                                                                                    name: 'hasLicence',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 430,
                                                                                            column: 31,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 430,
                                                                                            column: 41,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                        }
                                                                                    }
                                                                                }
                                                                            },
                                                                            consequent: {
                                                                                type: 'BlockStatement',
                                                                                body: [{
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'CallExpression',
                                                                                            callee: {
                                                                                                type: 'Identifier',
                                                                                                name: 'SubscriptionNotice',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 431,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 431,
                                                                                                        column: 46,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            arguments: [{
                                                                                                    type: 'Literal',
                                                                                                    value: 'create and manage projects'
                                                                                                }],
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 431,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 431,
                                                                                                    column: 76,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 431,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 431,
                                                                                                column: 76,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            alternate: {
                                                                                type: 'IfStatement',
                                                                                test: {
                                                                                    type: 'UnaryExpression',
                                                                                    operator: '?',
                                                                                    argument: {
                                                                                        type: 'Identifier',
                                                                                        name: 'projects',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 432,
                                                                                                column: 32,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 432,
                                                                                                column: 40,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                },
                                                                                consequent: {
                                                                                    type: 'BlockStatement',
                                                                                    body: [{
                                                                                            type: 'ForInStatement',
                                                                                            left: {
                                                                                                type: 'VariableDeclaration',
                                                                                                declarations: [
                                                                                                    {
                                                                                                        type: 'VariableDeclarator',
                                                                                                        id: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'key',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 433,
                                                                                                                    column: 32,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 433,
                                                                                                                    column: 35,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        init: null
                                                                                                    },
                                                                                                    {
                                                                                                        type: 'VariableDeclarator',
                                                                                                        id: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'project',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 433,
                                                                                                                    column: 37,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 433,
                                                                                                                    column: 44,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        init: null
                                                                                                    }
                                                                                                ],
                                                                                                kind: 'let'
                                                                                            },
                                                                                            right: {
                                                                                                type: 'Identifier',
                                                                                                name: 'projects',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 433,
                                                                                                        column: 48,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 433,
                                                                                                        column: 56,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            body: {
                                                                                                type: 'BlockStatement',
                                                                                                body: [{
                                                                                                        type: 'ExpressionStatement',
                                                                                                        expression: {
                                                                                                            type: 'ObjectExpression',
                                                                                                            objectType: {
                                                                                                                type: 'CallExpression',
                                                                                                                callee: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'Div',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 434,
                                                                                                                            column: 32,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 434,
                                                                                                                            column: 35,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                arguments: [{
                                                                                                                        type: 'ObjectExpression',
                                                                                                                        properties: [{
                                                                                                                                type: 'Property',
                                                                                                                                key: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'class',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 434,
                                                                                                                                            column: 37,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 434,
                                                                                                                                            column: 42,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                value: {
                                                                                                                                    type: 'Literal',
                                                                                                                                    value: 'dashboard-item layout horizontal flex center justified'
                                                                                                                                },
                                                                                                                                kind: 'init',
                                                                                                                                order: '0'
                                                                                                                            }]
                                                                                                                    }],
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 434,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 434,
                                                                                                                        column: 101,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            properties: [
                                                                                                                {
                                                                                                                    type: 'ExpressionStatement',
                                                                                                                    expression: {
                                                                                                                        type: 'Function',
                                                                                                                        context: true,
                                                                                                                        value: function (_context13) {
                                                                                                                            return function click() {
                                                                                                                                var project = _context13.get('project');
                                                                                                                                return model.open(project.paneConfig);
                                                                                                                            };
                                                                                                                        }
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 435,
                                                                                                                            column: 36,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 435,
                                                                                                                            column: 77,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        }
                                                                                                                    },
                                                                                                                    order: '0'
                                                                                                                },
                                                                                                                {
                                                                                                                    type: 'ExpressionStatement',
                                                                                                                    expression: {
                                                                                                                        type: 'ObjectExpression',
                                                                                                                        objectType: {
                                                                                                                            type: 'CallExpression',
                                                                                                                            callee: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'Div',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 436,
                                                                                                                                        column: 36,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 436,
                                                                                                                                        column: 39,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            arguments: [{
                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                    properties: [{
                                                                                                                                            type: 'Property',
                                                                                                                                            key: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'class',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 436,
                                                                                                                                                        column: 41,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 436,
                                                                                                                                                        column: 46,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            value: {
                                                                                                                                                type: 'Literal',
                                                                                                                                                value: 'black'
                                                                                                                                            },
                                                                                                                                            kind: 'init',
                                                                                                                                            order: '0'
                                                                                                                                        }]
                                                                                                                                }],
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 436,
                                                                                                                                    column: 36,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 436,
                                                                                                                                    column: 56,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        properties: [{
                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                expression: {
                                                                                                                                    type: 'MemberExpression',
                                                                                                                                    computed: false,
                                                                                                                                    object: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'project',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 437,
                                                                                                                                                column: 40,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 437,
                                                                                                                                                column: 47,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    property: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'name',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 437,
                                                                                                                                                column: 48,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 437,
                                                                                                                                                column: 52,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 437,
                                                                                                                                            column: 40,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 437,
                                                                                                                                            column: 52,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 437,
                                                                                                                                        column: 40,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 437,
                                                                                                                                        column: 52,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                order: '0'
                                                                                                                            }]
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 436,
                                                                                                                            column: 36,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 438,
                                                                                                                            column: 40,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        }
                                                                                                                    },
                                                                                                                    order: '1'
                                                                                                                },
                                                                                                                {
                                                                                                                    type: 'ExpressionStatement',
                                                                                                                    expression: {
                                                                                                                        type: 'CallExpression',
                                                                                                                        callee: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'Div',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 438,
                                                                                                                                    column: 36,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 438,
                                                                                                                                    column: 39,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        arguments: [{
                                                                                                                                type: 'ObjectExpression',
                                                                                                                                properties: [{
                                                                                                                                        type: 'Property',
                                                                                                                                        key: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'class',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 438,
                                                                                                                                                    column: 41,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 438,
                                                                                                                                                    column: 46,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        value: {
                                                                                                                                            type: 'Literal',
                                                                                                                                            value: 'fill'
                                                                                                                                        },
                                                                                                                                        kind: 'init',
                                                                                                                                        order: '0'
                                                                                                                                    }]
                                                                                                                            }],
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 438,
                                                                                                                                column: 36,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 438,
                                                                                                                                column: 55,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 438,
                                                                                                                            column: 36,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 438,
                                                                                                                            column: 55,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        }
                                                                                                                    },
                                                                                                                    order: '2'
                                                                                                                },
                                                                                                                {
                                                                                                                    type: 'ExpressionStatement',
                                                                                                                    expression: {
                                                                                                                        type: 'ObjectExpression',
                                                                                                                        objectType: {
                                                                                                                            type: 'CallExpression',
                                                                                                                            callee: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'Div',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 439,
                                                                                                                                        column: 36,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 439,
                                                                                                                                        column: 39,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            arguments: [],
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 439,
                                                                                                                                    column: 36,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 439,
                                                                                                                                    column: 41,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        properties: [{
                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                expression: {
                                                                                                                                    type: 'BinaryExpression',
                                                                                                                                    operator: '+',
                                                                                                                                    left: {
                                                                                                                                        type: 'MemberExpression',
                                                                                                                                        computed: false,
                                                                                                                                        object: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'project',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 440,
                                                                                                                                                    column: 40,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 440,
                                                                                                                                                    column: 47,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        property: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'percent',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 440,
                                                                                                                                                    column: 48,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 440,
                                                                                                                                                    column: 55,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 440,
                                                                                                                                                column: 40,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 440,
                                                                                                                                                column: 55,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    right: {
                                                                                                                                        type: 'Literal',
                                                                                                                                        value: '%'
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 440,
                                                                                                                                        column: 40,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 440,
                                                                                                                                        column: 61,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                order: '0'
                                                                                                                            }]
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 439,
                                                                                                                            column: 36,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 441,
                                                                                                                            column: 40,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        }
                                                                                                                    },
                                                                                                                    order: '3'
                                                                                                                },
                                                                                                                {
                                                                                                                    type: 'ExpressionStatement',
                                                                                                                    expression: {
                                                                                                                        type: 'CallExpression',
                                                                                                                        callee: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'Div',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 441,
                                                                                                                                    column: 36,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 441,
                                                                                                                                    column: 39,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        arguments: [{
                                                                                                                                type: 'ObjectExpression',
                                                                                                                                properties: [{
                                                                                                                                        type: 'Property',
                                                                                                                                        key: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'style',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 441,
                                                                                                                                                    column: 41,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 441,
                                                                                                                                                    column: 46,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        value: {
                                                                                                                                            type: 'Literal',
                                                                                                                                            value: 'padding:4px'
                                                                                                                                        },
                                                                                                                                        kind: 'init',
                                                                                                                                        order: '0'
                                                                                                                                    }]
                                                                                                                            }],
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 441,
                                                                                                                                column: 36,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 441,
                                                                                                                                column: 62,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 441,
                                                                                                                            column: 36,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 441,
                                                                                                                            column: 62,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        }
                                                                                                                    },
                                                                                                                    order: '4'
                                                                                                                },
                                                                                                                {
                                                                                                                    type: 'ExpressionStatement',
                                                                                                                    expression: {
                                                                                                                        type: 'ObjectExpression',
                                                                                                                        objectType: {
                                                                                                                            type: 'CallExpression',
                                                                                                                            callee: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'Div',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 442,
                                                                                                                                        column: 36,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 442,
                                                                                                                                        column: 39,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            arguments: [{
                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                    properties: [{
                                                                                                                                            type: 'Property',
                                                                                                                                            key: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'class',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 442,
                                                                                                                                                        column: 41,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 442,
                                                                                                                                                        column: 46,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            value: {
                                                                                                                                                type: 'Literal',
                                                                                                                                                value: 'dashboard-progress fixed'
                                                                                                                                            },
                                                                                                                                            kind: 'init',
                                                                                                                                            order: '0'
                                                                                                                                        }]
                                                                                                                                }],
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 442,
                                                                                                                                    column: 36,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 442,
                                                                                                                                    column: 75,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        properties: [{
                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                expression: {
                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                    objectType: {
                                                                                                                                        type: 'CallExpression',
                                                                                                                                        callee: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'Div',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 443,
                                                                                                                                                    column: 40,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 443,
                                                                                                                                                    column: 43,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        arguments: [{
                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                properties: [{
                                                                                                                                                        type: 'Property',
                                                                                                                                                        key: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'class',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 443,
                                                                                                                                                                    column: 45,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 443,
                                                                                                                                                                    column: 50,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        value: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: 'dashboard-progress-inner'
                                                                                                                                                        },
                                                                                                                                                        kind: 'init',
                                                                                                                                                        order: '0'
                                                                                                                                                    }]
                                                                                                                                            }],
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 443,
                                                                                                                                                column: 40,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 443,
                                                                                                                                                column: 79,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    properties: [{
                                                                                                                                            type: 'Property',
                                                                                                                                            key: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'style',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 444,
                                                                                                                                                        column: 44,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 444,
                                                                                                                                                        column: 49,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            value: {
                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                properties: [{
                                                                                                                                                        type: 'Property',
                                                                                                                                                        key: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'width',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 444,
                                                                                                                                                                    column: 52,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 444,
                                                                                                                                                                    column: 57,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        value: {
                                                                                                                                                            type: 'BinaryExpression',
                                                                                                                                                            operator: '+',
                                                                                                                                                            left: {
                                                                                                                                                                type: 'MemberExpression',
                                                                                                                                                                computed: false,
                                                                                                                                                                object: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'project',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 444,
                                                                                                                                                                            column: 59,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 444,
                                                                                                                                                                            column: 66,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                property: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'percent',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 444,
                                                                                                                                                                            column: 67,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 444,
                                                                                                                                                                            column: 74,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 444,
                                                                                                                                                                        column: 59,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 444,
                                                                                                                                                                        column: 74,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            right: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: 'px'
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        kind: 'init',
                                                                                                                                                        order: '0'
                                                                                                                                                    }]
                                                                                                                                            },
                                                                                                                                            kind: 'init',
                                                                                                                                            order: '0'
                                                                                                                                        }]
                                                                                                                                },
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 443,
                                                                                                                                        column: 40,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 446,
                                                                                                                                        column: 44,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                order: '0'
                                                                                                                            }]
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 442,
                                                                                                                            column: 36,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 446,
                                                                                                                            column: 40,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        }
                                                                                                                    },
                                                                                                                    order: '5'
                                                                                                                }
                                                                                                            ]
                                                                                                        },
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 434,
                                                                                                                column: 32,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 446,
                                                                                                                column: 36,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                            }
                                                                                                        },
                                                                                                        order: '0'
                                                                                                    }]
                                                                                            },
                                                                                            remove: null,
                                                                                            order: '0'
                                                                                        }]
                                                                                },
                                                                                alternate: null
                                                                            },
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                order: '0'
                                                            }],
                                                        bound: false,
                                                        name: {
                                                            type: 'Identifier',
                                                            name: 'content',
                                                            loc: {
                                                                start: {
                                                                    line: 428,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                },
                                                                end: {
                                                                    line: 428,
                                                                    column: 23,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                }
                                                            }
                                                        },
                                                        scope: {
                                                            type: 'Identifier',
                                                            name: '_ps4'
                                                        }
                                                    }, {
                                                        this: this,
                                                        _ps4: _ps4,
                                                        _ref10: _ref10,
                                                        ion: ion,
                                                        glass: glass,
                                                        _ref: _ref,
                                                        _ref2: _ref2,
                                                        _ref3: _ref3,
                                                        _ref4: _ref4,
                                                        style: style,
                                                        _ref5: _ref5,
                                                        namespace: namespace,
                                                        _ref6: _ref6,
                                                        _ref7: _ref7,
                                                        DateTime: DateTime,
                                                        RecordChip: RecordChip,
                                                        RecordIcon: RecordIcon,
                                                        PromptDialog: PromptDialog,
                                                        Key: Key,
                                                        SetupWizard: SetupWizard,
                                                        SubscriptionNotice: SubscriptionNotice,
                                                        Task: Task,
                                                        Project: Project,
                                                        ProjectType: ProjectType,
                                                        User: User,
                                                        Comment: Comment,
                                                        createProjectPrompt: createProjectPrompt,
                                                        lightGray: lightGray,
                                                        gray: gray,
                                                        darkGray: darkGray,
                                                        DashboardCard: DashboardCard,
                                                        dateString: dateString,
                                                        getWeeks: getWeeks,
                                                        workHoursOnDateFromTask: workHoursOnDateFromTask,
                                                        getDays: getDays,
                                                        TaskCalendarModel: TaskCalendarModel,
                                                        capitalize: capitalize,
                                                        displayDate: displayDate,
                                                        dateColor: dateColor,
                                                        TaskCalendar: TaskCalendar,
                                                        TasksCard: TasksCard,
                                                        ProjectsCard: ProjectsCard,
                                                        MembersCard: MembersCard,
                                                        mostRecentComment: mostRecentComment,
                                                        DiscussionsCard: DiscussionsCard,
                                                        getTaskComments: getTaskComments,
                                                        Dashboard: Dashboard
                                                    }, _ps4);
                                                });
                                            }
                                        },
                                        kind: 'init',
                                        order: '3'
                                    }
                                ]
                            }],
                        loc: {
                            start: {
                                line: 417,
                                column: 19,
                                fixed: true,
                                source: 'viewpath/html/panes/DashboardPane.ion'
                            },
                            end: {
                                line: 446,
                                column: 16,
                                fixed: true,
                                source: 'viewpath/html/panes/DashboardPane.ion'
                            }
                        }
                    },
                    order: '2'
                }
            ],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'ProjectsCard',
                loc: {
                    start: {
                        line: 416,
                        column: 4,
                        fixed: true,
                        source: 'viewpath/html/panes/DashboardPane.ion'
                    },
                    end: {
                        line: 416,
                        column: 16,
                        fixed: true,
                        source: 'viewpath/html/panes/DashboardPane.ion'
                    }
                }
            }
        }, {
            this: this,
            ion: ion,
            _ref10: _ref10,
            glass: glass,
            _ref: _ref,
            _ref2: _ref2,
            _ref3: _ref3,
            _ref4: _ref4,
            style: style,
            _ref5: _ref5,
            namespace: namespace,
            _ref6: _ref6,
            _ref7: _ref7,
            DateTime: DateTime,
            RecordChip: RecordChip,
            RecordIcon: RecordIcon,
            PromptDialog: PromptDialog,
            Key: Key,
            SetupWizard: SetupWizard,
            SubscriptionNotice: SubscriptionNotice,
            Task: Task,
            Project: Project,
            ProjectType: ProjectType,
            User: User,
            Comment: Comment,
            createProjectPrompt: createProjectPrompt,
            lightGray: lightGray,
            gray: gray,
            darkGray: darkGray,
            DashboardCard: DashboardCard,
            dateString: dateString,
            getWeeks: getWeeks,
            workHoursOnDateFromTask: workHoursOnDateFromTask,
            getDays: getDays,
            TaskCalendarModel: TaskCalendarModel,
            capitalize: capitalize,
            displayDate: displayDate,
            dateColor: dateColor,
            TaskCalendar: TaskCalendar,
            TasksCard: TasksCard,
            ProjectsCard: ProjectsCard,
            MembersCard: MembersCard,
            mostRecentComment: mostRecentComment,
            DiscussionsCard: DiscussionsCard,
            getTaskComments: getTaskComments,
            Dashboard: Dashboard
        }, null);
    });
var MembersCard = ion.template(function () {
        return ion.createRuntime({
            type: 'Template',
            id: null,
            body: [{
                    type: 'ReturnStatement',
                    argument: {
                        type: 'CallExpression',
                        callee: {
                            type: 'Identifier',
                            name: 'DashboardCard',
                            loc: {
                                start: {
                                    line: 449,
                                    column: 15,
                                    fixed: true,
                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                },
                                end: {
                                    line: 449,
                                    column: 28,
                                    fixed: true,
                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                }
                            }
                        },
                        arguments: [{
                                type: 'ObjectExpression',
                                properties: [
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'title',
                                            loc: {
                                                start: {
                                                    line: 450,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                },
                                                end: {
                                                    line: 450,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: 'Members'
                                        },
                                        kind: 'init',
                                        order: '0'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'toolbar',
                                            loc: {
                                                start: {
                                                    line: 451,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                },
                                                end: {
                                                    line: 451,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Function',
                                            context: true,
                                            value: function (_ps5) {
                                                return ion.template(function () {
                                                    return ion.createRuntime({
                                                        type: 'Template',
                                                        id: null,
                                                        body: [{
                                                                type: 'ReturnStatement',
                                                                argument: {
                                                                    type: 'ObjectExpression',
                                                                    objectType: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'Identifier',
                                                                            name: 'Div',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 452,
                                                                                    column: 23,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 452,
                                                                                    column: 26,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [],
                                                                        loc: {
                                                                            start: {
                                                                                line: 452,
                                                                                column: 23,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 452,
                                                                                column: 28,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    properties: []
                                                                },
                                                                order: '0'
                                                            }],
                                                        bound: false,
                                                        name: {
                                                            type: 'Identifier',
                                                            name: 'toolbar',
                                                            loc: {
                                                                start: {
                                                                    line: 451,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                },
                                                                end: {
                                                                    line: 451,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                }
                                                            }
                                                        },
                                                        scope: {
                                                            type: 'Identifier',
                                                            name: '_ps5'
                                                        }
                                                    }, {
                                                        this: this,
                                                        _ps5: _ps5,
                                                        ion: ion,
                                                        glass: glass,
                                                        _ref: _ref,
                                                        _ref2: _ref2,
                                                        _ref3: _ref3,
                                                        _ref4: _ref4,
                                                        style: style,
                                                        _ref5: _ref5,
                                                        namespace: namespace,
                                                        _ref6: _ref6,
                                                        _ref7: _ref7,
                                                        DateTime: DateTime,
                                                        RecordChip: RecordChip,
                                                        RecordIcon: RecordIcon,
                                                        PromptDialog: PromptDialog,
                                                        Key: Key,
                                                        SetupWizard: SetupWizard,
                                                        SubscriptionNotice: SubscriptionNotice,
                                                        Task: Task,
                                                        Project: Project,
                                                        ProjectType: ProjectType,
                                                        User: User,
                                                        Comment: Comment,
                                                        createProjectPrompt: createProjectPrompt,
                                                        lightGray: lightGray,
                                                        gray: gray,
                                                        darkGray: darkGray,
                                                        DashboardCard: DashboardCard,
                                                        dateString: dateString,
                                                        getWeeks: getWeeks,
                                                        workHoursOnDateFromTask: workHoursOnDateFromTask,
                                                        getDays: getDays,
                                                        TaskCalendarModel: TaskCalendarModel,
                                                        capitalize: capitalize,
                                                        displayDate: displayDate,
                                                        dateColor: dateColor,
                                                        TaskCalendar: TaskCalendar,
                                                        TasksCard: TasksCard,
                                                        ProjectsCard: ProjectsCard,
                                                        MembersCard: MembersCard,
                                                        mostRecentComment: mostRecentComment,
                                                        DiscussionsCard: DiscussionsCard,
                                                        getTaskComments: getTaskComments,
                                                        Dashboard: Dashboard
                                                    }, _ps5);
                                                });
                                            }
                                        },
                                        kind: 'init',
                                        order: '1'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'content',
                                            loc: {
                                                start: {
                                                    line: 455,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                },
                                                end: {
                                                    line: 455,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Function',
                                            context: true,
                                            value: function (_ps6) {
                                                return ion.template(function () {
                                                    return ion.createRuntime({
                                                        type: 'Template',
                                                        id: null,
                                                        body: [
                                                            {
                                                                type: 'VariableDeclaration',
                                                                declarations: [{
                                                                        type: 'VariableDeclarator',
                                                                        id: {
                                                                            type: 'Identifier',
                                                                            name: 'membersKey',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 456,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 456,
                                                                                    column: 30,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        init: {
                                                                            type: 'NewExpression',
                                                                            callee: {
                                                                                type: 'Identifier',
                                                                                name: 'Key',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 456,
                                                                                        column: 37,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 456,
                                                                                        column: 40,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            arguments: [
                                                                                {
                                                                                    type: 'Identifier',
                                                                                    name: 'User',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 457,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 457,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                {
                                                                                    type: 'ObjectExpression',
                                                                                    objectType: {
                                                                                        type: 'ObjectExpression',
                                                                                        properties: []
                                                                                    },
                                                                                    properties: [{
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'where',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 459,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 459,
                                                                                                        column: 29,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'ObjectExpression',
                                                                                                properties: [{
                                                                                                        type: 'Property',
                                                                                                        key: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'orgIds',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 460,
                                                                                                                    column: 28,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 460,
                                                                                                                    column: 34,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        value: {
                                                                                                            type: 'MemberExpression',
                                                                                                            computed: false,
                                                                                                            object: {
                                                                                                                type: 'MemberExpression',
                                                                                                                computed: false,
                                                                                                                object: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'model',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 460,
                                                                                                                            column: 36,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 460,
                                                                                                                            column: 41,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                property: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'user',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 460,
                                                                                                                            column: 42,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 460,
                                                                                                                            column: 46,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 460,
                                                                                                                        column: 36,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 460,
                                                                                                                        column: 46,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            property: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'orgIds',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 460,
                                                                                                                        column: 47,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 460,
                                                                                                                        column: 53,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 460,
                                                                                                                    column: 36,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 460,
                                                                                                                    column: 53,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        kind: 'init',
                                                                                                        order: '0'
                                                                                                    }]
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '0'
                                                                                        }]
                                                                                }
                                                                            ],
                                                                            loc: {
                                                                                start: {
                                                                                    line: 456,
                                                                                    column: 33,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 461,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                }
                                                                            }
                                                                        }
                                                                    }],
                                                                kind: 'let',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'VariableDeclaration',
                                                                declarations: [{
                                                                        type: 'VariableDeclarator',
                                                                        id: {
                                                                            type: 'Identifier',
                                                                            name: 'members',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 461,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 461,
                                                                                    column: 27,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        init: {
                                                                            type: 'MemberExpression',
                                                                            computed: true,
                                                                            object: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'Identifier',
                                                                                    name: 'model',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 461,
                                                                                            column: 30,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 461,
                                                                                            column: 35,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'server',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 461,
                                                                                            column: 36,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 461,
                                                                                            column: 42,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 461,
                                                                                        column: 30,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 461,
                                                                                        column: 42,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'membersKey',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 461,
                                                                                        column: 43,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 461,
                                                                                        column: 53,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 461,
                                                                                    column: 30,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 461,
                                                                                    column: 54,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                }
                                                                            }
                                                                        }
                                                                    }],
                                                                kind: 'let',
                                                                order: '1'
                                                            },
                                                            {
                                                                type: 'ReturnStatement',
                                                                argument: {
                                                                    type: 'ObjectExpression',
                                                                    objectType: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'Identifier',
                                                                            name: 'Div',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 462,
                                                                                    column: 23,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 462,
                                                                                    column: 26,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [{
                                                                                type: 'ObjectExpression',
                                                                                properties: [{
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'class',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 462,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 462,
                                                                                                    column: 33,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 'content'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    }]
                                                                            }],
                                                                        loc: {
                                                                            start: {
                                                                                line: 462,
                                                                                column: 23,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 462,
                                                                                column: 45,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    properties: [{
                                                                            type: 'ForInStatement',
                                                                            left: {
                                                                                type: 'VariableDeclaration',
                                                                                declarations: [
                                                                                    {
                                                                                        type: 'VariableDeclarator',
                                                                                        id: {
                                                                                            type: 'Identifier',
                                                                                            name: 'key',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 463,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 463,
                                                                                                    column: 27,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        init: null
                                                                                    },
                                                                                    {
                                                                                        type: 'VariableDeclarator',
                                                                                        id: {
                                                                                            type: 'Identifier',
                                                                                            name: 'member',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 463,
                                                                                                    column: 29,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 463,
                                                                                                    column: 35,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        init: null
                                                                                    }
                                                                                ],
                                                                                kind: 'let'
                                                                            },
                                                                            right: {
                                                                                type: 'Identifier',
                                                                                name: 'members',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 463,
                                                                                        column: 39,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 463,
                                                                                        column: 46,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            body: {
                                                                                type: 'BlockStatement',
                                                                                body: [{
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'ObjectExpression',
                                                                                            objectType: {
                                                                                                type: 'CallExpression',
                                                                                                callee: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'Div',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 464,
                                                                                                            column: 24,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 464,
                                                                                                            column: 27,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                arguments: [{
                                                                                                        type: 'ObjectExpression',
                                                                                                        properties: [{
                                                                                                                type: 'Property',
                                                                                                                key: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'class',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 464,
                                                                                                                            column: 29,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 464,
                                                                                                                            column: 34,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                value: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: 'dashboard-item layout horizontal flex center'
                                                                                                                },
                                                                                                                kind: 'init',
                                                                                                                order: '0'
                                                                                                            }]
                                                                                                    }],
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 464,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 464,
                                                                                                        column: 83,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            properties: [
                                                                                                {
                                                                                                    type: 'ExpressionStatement',
                                                                                                    expression: {
                                                                                                        type: 'Function',
                                                                                                        context: true,
                                                                                                        value: function (_context14) {
                                                                                                            return function click() {
                                                                                                                var member = _context14.get('member');
                                                                                                                return model.open(member.paneConfig);
                                                                                                            };
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 465,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 465,
                                                                                                            column: 68,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        }
                                                                                                    },
                                                                                                    order: '0'
                                                                                                },
                                                                                                {
                                                                                                    type: 'ExpressionStatement',
                                                                                                    expression: {
                                                                                                        type: 'CallExpression',
                                                                                                        callee: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'RecordIcon',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 466,
                                                                                                                    column: 28,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 466,
                                                                                                                    column: 38,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        arguments: [{
                                                                                                                type: 'ObjectExpression',
                                                                                                                properties: [{
                                                                                                                        type: 'Property',
                                                                                                                        key: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'record',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 466,
                                                                                                                                    column: 40,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 466,
                                                                                                                                    column: 46,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        value: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'member',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 466,
                                                                                                                                    column: 48,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 466,
                                                                                                                                    column: 54,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        kind: 'init',
                                                                                                                        order: '0'
                                                                                                                    }]
                                                                                                            }],
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 466,
                                                                                                                column: 28,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 466,
                                                                                                                column: 56,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 466,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 466,
                                                                                                            column: 56,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        }
                                                                                                    },
                                                                                                    order: '1'
                                                                                                },
                                                                                                {
                                                                                                    type: 'ExpressionStatement',
                                                                                                    expression: {
                                                                                                        type: 'CallExpression',
                                                                                                        callee: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'Div',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 467,
                                                                                                                    column: 28,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 467,
                                                                                                                    column: 31,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        arguments: [{
                                                                                                                type: 'ObjectExpression',
                                                                                                                properties: [{
                                                                                                                        type: 'Property',
                                                                                                                        key: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'style',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 467,
                                                                                                                                    column: 33,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 467,
                                                                                                                                    column: 38,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        value: {
                                                                                                                            type: 'Literal',
                                                                                                                            value: 'padding:4px'
                                                                                                                        },
                                                                                                                        kind: 'init',
                                                                                                                        order: '0'
                                                                                                                    }]
                                                                                                            }],
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 467,
                                                                                                                column: 28,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 467,
                                                                                                                column: 54,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 467,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 467,
                                                                                                            column: 54,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        }
                                                                                                    },
                                                                                                    order: '2'
                                                                                                },
                                                                                                {
                                                                                                    type: 'ExpressionStatement',
                                                                                                    expression: {
                                                                                                        type: 'ObjectExpression',
                                                                                                        objectType: {
                                                                                                            type: 'CallExpression',
                                                                                                            callee: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'Div',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 468,
                                                                                                                        column: 28,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 468,
                                                                                                                        column: 31,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            arguments: [],
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 468,
                                                                                                                    column: 28,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 468,
                                                                                                                    column: 33,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        properties: [{
                                                                                                                type: 'ExpressionStatement',
                                                                                                                expression: {
                                                                                                                    type: 'MemberExpression',
                                                                                                                    computed: false,
                                                                                                                    object: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'member',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 469,
                                                                                                                                column: 32,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 469,
                                                                                                                                column: 38,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    property: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'name',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 469,
                                                                                                                                column: 39,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 469,
                                                                                                                                column: 43,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 469,
                                                                                                                            column: 32,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 469,
                                                                                                                            column: 43,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 469,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 469,
                                                                                                                        column: 43,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                    }
                                                                                                                },
                                                                                                                order: '0'
                                                                                                            }]
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 468,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 471,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        }
                                                                                                    },
                                                                                                    order: '3'
                                                                                                }
                                                                                            ]
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 464,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 471,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            remove: null,
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                order: '2'
                                                            }
                                                        ],
                                                        bound: false,
                                                        name: {
                                                            type: 'Identifier',
                                                            name: 'content',
                                                            loc: {
                                                                start: {
                                                                    line: 455,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                },
                                                                end: {
                                                                    line: 455,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                }
                                                            }
                                                        },
                                                        scope: {
                                                            type: 'Identifier',
                                                            name: '_ps6'
                                                        }
                                                    }, {
                                                        this: this,
                                                        _ps6: _ps6,
                                                        ion: ion,
                                                        glass: glass,
                                                        _ref: _ref,
                                                        _ref2: _ref2,
                                                        _ref3: _ref3,
                                                        _ref4: _ref4,
                                                        style: style,
                                                        _ref5: _ref5,
                                                        namespace: namespace,
                                                        _ref6: _ref6,
                                                        _ref7: _ref7,
                                                        DateTime: DateTime,
                                                        RecordChip: RecordChip,
                                                        RecordIcon: RecordIcon,
                                                        PromptDialog: PromptDialog,
                                                        Key: Key,
                                                        SetupWizard: SetupWizard,
                                                        SubscriptionNotice: SubscriptionNotice,
                                                        Task: Task,
                                                        Project: Project,
                                                        ProjectType: ProjectType,
                                                        User: User,
                                                        Comment: Comment,
                                                        createProjectPrompt: createProjectPrompt,
                                                        lightGray: lightGray,
                                                        gray: gray,
                                                        darkGray: darkGray,
                                                        DashboardCard: DashboardCard,
                                                        dateString: dateString,
                                                        getWeeks: getWeeks,
                                                        workHoursOnDateFromTask: workHoursOnDateFromTask,
                                                        getDays: getDays,
                                                        TaskCalendarModel: TaskCalendarModel,
                                                        capitalize: capitalize,
                                                        displayDate: displayDate,
                                                        dateColor: dateColor,
                                                        TaskCalendar: TaskCalendar,
                                                        TasksCard: TasksCard,
                                                        ProjectsCard: ProjectsCard,
                                                        MembersCard: MembersCard,
                                                        mostRecentComment: mostRecentComment,
                                                        DiscussionsCard: DiscussionsCard,
                                                        getTaskComments: getTaskComments,
                                                        Dashboard: Dashboard
                                                    }, _ps6);
                                                });
                                            }
                                        },
                                        kind: 'init',
                                        order: '2'
                                    }
                                ]
                            }],
                        loc: {
                            start: {
                                line: 449,
                                column: 15,
                                fixed: true,
                                source: 'viewpath/html/panes/DashboardPane.ion'
                            },
                            end: {
                                line: 471,
                                column: 12,
                                fixed: true,
                                source: 'viewpath/html/panes/DashboardPane.ion'
                            }
                        }
                    },
                    order: '0'
                }],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'MembersCard',
                loc: {
                    start: {
                        line: 448,
                        column: 4,
                        fixed: true,
                        source: 'viewpath/html/panes/DashboardPane.ion'
                    },
                    end: {
                        line: 448,
                        column: 15,
                        fixed: true,
                        source: 'viewpath/html/panes/DashboardPane.ion'
                    }
                }
            }
        }, {
            this: this,
            ion: ion,
            glass: glass,
            _ref: _ref,
            _ref2: _ref2,
            _ref3: _ref3,
            _ref4: _ref4,
            style: style,
            _ref5: _ref5,
            namespace: namespace,
            _ref6: _ref6,
            _ref7: _ref7,
            DateTime: DateTime,
            RecordChip: RecordChip,
            RecordIcon: RecordIcon,
            PromptDialog: PromptDialog,
            Key: Key,
            SetupWizard: SetupWizard,
            SubscriptionNotice: SubscriptionNotice,
            Task: Task,
            Project: Project,
            ProjectType: ProjectType,
            User: User,
            Comment: Comment,
            createProjectPrompt: createProjectPrompt,
            lightGray: lightGray,
            gray: gray,
            darkGray: darkGray,
            DashboardCard: DashboardCard,
            dateString: dateString,
            getWeeks: getWeeks,
            workHoursOnDateFromTask: workHoursOnDateFromTask,
            getDays: getDays,
            TaskCalendarModel: TaskCalendarModel,
            capitalize: capitalize,
            displayDate: displayDate,
            dateColor: dateColor,
            TaskCalendar: TaskCalendar,
            TasksCard: TasksCard,
            ProjectsCard: ProjectsCard,
            MembersCard: MembersCard,
            mostRecentComment: mostRecentComment,
            DiscussionsCard: DiscussionsCard,
            getTaskComments: getTaskComments,
            Dashboard: Dashboard
        }, null);
    });
var mostRecentComment = function mostRecentComment(task) {
        return task[Object.keys(task)[0]];
    }, DiscussionsCard = ion.template(function (_ref11) {
        return ion.createRuntime({
            type: 'Template',
            id: null,
            body: [
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'taskComments',
                                loc: {
                                    start: {
                                        line: 474,
                                        column: 32,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 474,
                                        column: 44,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref11'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'taskComments',
                                    loc: {
                                        start: {
                                            line: 474,
                                            column: 32,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        },
                                        end: {
                                            line: 474,
                                            column: 44,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '0'
                },
                {
                    type: 'ReturnStatement',
                    argument: {
                        type: 'CallExpression',
                        callee: {
                            type: 'Identifier',
                            name: 'DashboardCard',
                            loc: {
                                start: {
                                    line: 475,
                                    column: 15,
                                    fixed: true,
                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                },
                                end: {
                                    line: 475,
                                    column: 28,
                                    fixed: true,
                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                }
                            }
                        },
                        arguments: [{
                                type: 'ObjectExpression',
                                properties: [
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'title',
                                            loc: {
                                                start: {
                                                    line: 476,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                },
                                                end: {
                                                    line: 476,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: 'Discussions'
                                        },
                                        kind: 'init',
                                        order: '0'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'content',
                                            loc: {
                                                start: {
                                                    line: 477,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                },
                                                end: {
                                                    line: 477,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Function',
                                            context: true,
                                            value: function (_ps7) {
                                                return ion.template(function () {
                                                    return ion.createRuntime({
                                                        type: 'Template',
                                                        id: null,
                                                        body: [{
                                                                type: 'ReturnStatement',
                                                                argument: {
                                                                    type: 'ObjectExpression',
                                                                    objectType: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'Identifier',
                                                                            name: 'Div',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 478,
                                                                                    column: 23,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 478,
                                                                                    column: 26,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [{
                                                                                type: 'ObjectExpression',
                                                                                properties: [{
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'class',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 478,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 478,
                                                                                                    column: 33,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 'content'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    }]
                                                                            }],
                                                                        loc: {
                                                                            start: {
                                                                                line: 478,
                                                                                column: 23,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 478,
                                                                                column: 45,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    properties: [{
                                                                            type: 'ForInStatement',
                                                                            left: {
                                                                                type: 'VariableDeclaration',
                                                                                declarations: [
                                                                                    {
                                                                                        type: 'VariableDeclarator',
                                                                                        id: {
                                                                                            type: 'Identifier',
                                                                                            name: 'key',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 479,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 479,
                                                                                                    column: 27,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        init: null
                                                                                    },
                                                                                    {
                                                                                        type: 'VariableDeclarator',
                                                                                        id: {
                                                                                            type: 'Identifier',
                                                                                            name: 'task',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 479,
                                                                                                    column: 29,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 479,
                                                                                                    column: 33,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        init: null
                                                                                    }
                                                                                ],
                                                                                kind: 'let'
                                                                            },
                                                                            right: {
                                                                                type: 'Identifier',
                                                                                name: 'taskComments',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 479,
                                                                                        column: 37,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 479,
                                                                                        column: 49,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            body: {
                                                                                type: 'BlockStatement',
                                                                                body: [
                                                                                    {
                                                                                        type: 'VariableDeclaration',
                                                                                        declarations: [{
                                                                                                type: 'VariableDeclarator',
                                                                                                id: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'taskRecord',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 480,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 480,
                                                                                                            column: 38,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                init: {
                                                                                                    type: 'MemberExpression',
                                                                                                    computed: true,
                                                                                                    object: {
                                                                                                        type: 'MemberExpression',
                                                                                                        computed: false,
                                                                                                        object: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'model',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 480,
                                                                                                                    column: 41,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 480,
                                                                                                                    column: 46,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        property: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'server',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 480,
                                                                                                                    column: 47,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 480,
                                                                                                                    column: 53,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 480,
                                                                                                                column: 41,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 480,
                                                                                                                column: 53,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    property: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'key',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 480,
                                                                                                                column: 54,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 480,
                                                                                                                column: 57,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 480,
                                                                                                            column: 41,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 480,
                                                                                                            column: 58,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                }
                                                                                            }],
                                                                                        kind: 'let',
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'VariableDeclaration',
                                                                                        declarations: [{
                                                                                                type: 'VariableDeclarator',
                                                                                                id: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'comment',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 481,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 481,
                                                                                                            column: 35,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                init: {
                                                                                                    type: 'CallExpression',
                                                                                                    callee: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'mostRecentComment',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 481,
                                                                                                                column: 38,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 481,
                                                                                                                column: 55,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    arguments: [{
                                                                                                            type: 'Identifier',
                                                                                                            name: 'task',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 481,
                                                                                                                    column: 61,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 481,
                                                                                                                    column: 65,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                }
                                                                                                            },
                                                                                                            deep: true
                                                                                                        }],
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 481,
                                                                                                            column: 38,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 481,
                                                                                                            column: 66,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                }
                                                                                            }],
                                                                                        kind: 'let',
                                                                                        order: '1'
                                                                                    },
                                                                                    {
                                                                                        type: 'IfStatement',
                                                                                        test: {
                                                                                            type: 'UnaryExpression',
                                                                                            operator: '?',
                                                                                            argument: {
                                                                                                type: 'Identifier',
                                                                                                name: 'taskRecord',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 482,
                                                                                                        column: 27,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 482,
                                                                                                        column: 37,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        consequent: {
                                                                                            type: 'BlockStatement',
                                                                                            body: [
                                                                                                {
                                                                                                    type: 'VariableDeclaration',
                                                                                                    declarations: [{
                                                                                                            type: 'VariableDeclarator',
                                                                                                            id: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'project',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 483,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 483,
                                                                                                                        column: 39,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            init: {
                                                                                                                type: 'MemberExpression',
                                                                                                                computed: true,
                                                                                                                object: {
                                                                                                                    type: 'MemberExpression',
                                                                                                                    computed: false,
                                                                                                                    object: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'model',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 483,
                                                                                                                                column: 42,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 483,
                                                                                                                                column: 47,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    property: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'server',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 483,
                                                                                                                                column: 48,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 483,
                                                                                                                                column: 54,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 483,
                                                                                                                            column: 42,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 483,
                                                                                                                            column: 54,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                property: {
                                                                                                                    type: 'MemberExpression',
                                                                                                                    computed: false,
                                                                                                                    object: {
                                                                                                                        type: 'CallExpression',
                                                                                                                        callee: {
                                                                                                                            type: 'MemberExpression',
                                                                                                                            computed: false,
                                                                                                                            object: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'taskRecord',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 483,
                                                                                                                                        column: 55,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 483,
                                                                                                                                        column: 65,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            property: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'getKey',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 483,
                                                                                                                                        column: 66,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 483,
                                                                                                                                        column: 72,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 483,
                                                                                                                                    column: 55,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 483,
                                                                                                                                    column: 72,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        arguments: [],
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 483,
                                                                                                                                column: 55,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 483,
                                                                                                                                column: 74,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    property: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'parent',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 483,
                                                                                                                                column: 75,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 483,
                                                                                                                                column: 81,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 483,
                                                                                                                            column: 55,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 483,
                                                                                                                            column: 81,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 483,
                                                                                                                        column: 42,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 483,
                                                                                                                        column: 82,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            }
                                                                                                        }],
                                                                                                    kind: 'let',
                                                                                                    order: '0'
                                                                                                },
                                                                                                {
                                                                                                    type: 'ExpressionStatement',
                                                                                                    expression: {
                                                                                                        type: 'ObjectExpression',
                                                                                                        objectType: {
                                                                                                            type: 'CallExpression',
                                                                                                            callee: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'Div',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 484,
                                                                                                                        column: 28,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 484,
                                                                                                                        column: 31,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            arguments: [{
                                                                                                                    type: 'ObjectExpression',
                                                                                                                    properties: [{
                                                                                                                            type: 'Property',
                                                                                                                            key: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'class',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 484,
                                                                                                                                        column: 33,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 484,
                                                                                                                                        column: 38,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            value: {
                                                                                                                                type: 'Literal',
                                                                                                                                value: 'dashboard-item layout horizontal flex center justified'
                                                                                                                            },
                                                                                                                            kind: 'init',
                                                                                                                            order: '0'
                                                                                                                        }]
                                                                                                                }],
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 484,
                                                                                                                    column: 28,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 484,
                                                                                                                    column: 97,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        properties: [
                                                                                                            {
                                                                                                                type: 'ExpressionStatement',
                                                                                                                expression: {
                                                                                                                    type: 'Function',
                                                                                                                    context: true,
                                                                                                                    value: function (_context15) {
                                                                                                                        return function click() {
                                                                                                                            var taskRecord = _context15.get('taskRecord');
                                                                                                                            return model.open(Object.assign(taskRecord.paneConfig, { tab: 'discussion' }), { target: 'dialog' });
                                                                                                                        };
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 485,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 485,
                                                                                                                        column: 130,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                    }
                                                                                                                },
                                                                                                                order: '0'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'ExpressionStatement',
                                                                                                                expression: {
                                                                                                                    type: 'ObjectExpression',
                                                                                                                    objectType: {
                                                                                                                        type: 'CallExpression',
                                                                                                                        callee: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'Div',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 486,
                                                                                                                                    column: 32,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 486,
                                                                                                                                    column: 35,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        arguments: [{
                                                                                                                                type: 'ObjectExpression',
                                                                                                                                properties: [{
                                                                                                                                        type: 'Property',
                                                                                                                                        key: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'class',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 486,
                                                                                                                                                    column: 37,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 486,
                                                                                                                                                    column: 42,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        value: {
                                                                                                                                            type: 'Literal',
                                                                                                                                            value: 'layout vertical fill'
                                                                                                                                        },
                                                                                                                                        kind: 'init',
                                                                                                                                        order: '0'
                                                                                                                                    }]
                                                                                                                            }],
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 486,
                                                                                                                                column: 32,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 486,
                                                                                                                                column: 67,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    properties: [
                                                                                                                        {
                                                                                                                            type: 'ExpressionStatement',
                                                                                                                            expression: {
                                                                                                                                type: 'ObjectExpression',
                                                                                                                                objectType: {
                                                                                                                                    type: 'CallExpression',
                                                                                                                                    callee: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'Div',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 487,
                                                                                                                                                column: 36,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 487,
                                                                                                                                                column: 39,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    arguments: [{
                                                                                                                                            type: 'ObjectExpression',
                                                                                                                                            properties: [
                                                                                                                                                {
                                                                                                                                                    type: 'Property',
                                                                                                                                                    key: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'class',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 487,
                                                                                                                                                                column: 41,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 487,
                                                                                                                                                                column: 46,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    value: {
                                                                                                                                                        type: 'Literal',
                                                                                                                                                        value: 'black'
                                                                                                                                                    },
                                                                                                                                                    kind: 'init',
                                                                                                                                                    order: '0'
                                                                                                                                                },
                                                                                                                                                {
                                                                                                                                                    type: 'Property',
                                                                                                                                                    key: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'style',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 487,
                                                                                                                                                                column: 55,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 487,
                                                                                                                                                                column: 60,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    value: {
                                                                                                                                                        type: 'Literal',
                                                                                                                                                        value: 'max-width:90%'
                                                                                                                                                    },
                                                                                                                                                    kind: 'init',
                                                                                                                                                    order: '1'
                                                                                                                                                }
                                                                                                                                            ]
                                                                                                                                        }],
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 487,
                                                                                                                                            column: 36,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 487,
                                                                                                                                            column: 78,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                properties: [{
                                                                                                                                        type: 'ExpressionStatement',
                                                                                                                                        expression: {
                                                                                                                                            type: 'MemberExpression',
                                                                                                                                            computed: false,
                                                                                                                                            object: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'taskRecord',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 488,
                                                                                                                                                        column: 40,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 488,
                                                                                                                                                        column: 50,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            property: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'name',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 488,
                                                                                                                                                        column: 51,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 488,
                                                                                                                                                        column: 55,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 488,
                                                                                                                                                    column: 40,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 488,
                                                                                                                                                    column: 55,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 488,
                                                                                                                                                column: 40,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 488,
                                                                                                                                                column: 55,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        order: '0'
                                                                                                                                    }]
                                                                                                                            },
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 487,
                                                                                                                                    column: 36,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 489,
                                                                                                                                    column: 40,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                }
                                                                                                                            },
                                                                                                                            order: '0'
                                                                                                                        },
                                                                                                                        {
                                                                                                                            type: 'ExpressionStatement',
                                                                                                                            expression: {
                                                                                                                                type: 'ObjectExpression',
                                                                                                                                objectType: {
                                                                                                                                    type: 'CallExpression',
                                                                                                                                    callee: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'Div',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 489,
                                                                                                                                                column: 36,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 489,
                                                                                                                                                column: 39,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    arguments: [{
                                                                                                                                            type: 'ObjectExpression',
                                                                                                                                            properties: [
                                                                                                                                                {
                                                                                                                                                    type: 'Property',
                                                                                                                                                    key: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'class',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 489,
                                                                                                                                                                column: 41,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 489,
                                                                                                                                                                column: 46,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    value: {
                                                                                                                                                        type: 'Literal',
                                                                                                                                                        value: 'dashboard-darkgray'
                                                                                                                                                    },
                                                                                                                                                    kind: 'init',
                                                                                                                                                    order: '0'
                                                                                                                                                },
                                                                                                                                                {
                                                                                                                                                    type: 'Property',
                                                                                                                                                    key: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'style',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 489,
                                                                                                                                                                column: 68,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 489,
                                                                                                                                                                column: 73,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    value: {
                                                                                                                                                        type: 'Literal',
                                                                                                                                                        value: 'font-size:14px'
                                                                                                                                                    },
                                                                                                                                                    kind: 'init',
                                                                                                                                                    order: '1'
                                                                                                                                                }
                                                                                                                                            ]
                                                                                                                                        }],
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 489,
                                                                                                                                            column: 36,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 489,
                                                                                                                                            column: 92,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                properties: [{
                                                                                                                                        type: 'ExpressionStatement',
                                                                                                                                        expression: {
                                                                                                                                            type: 'MemberExpression',
                                                                                                                                            computed: false,
                                                                                                                                            object: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'project',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 490,
                                                                                                                                                        column: 40,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 490,
                                                                                                                                                        column: 47,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            property: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'name',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 490,
                                                                                                                                                        column: 48,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 490,
                                                                                                                                                        column: 52,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 490,
                                                                                                                                                    column: 40,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 490,
                                                                                                                                                    column: 52,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 490,
                                                                                                                                                column: 40,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 490,
                                                                                                                                                column: 52,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        order: '0'
                                                                                                                                    }]
                                                                                                                            },
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 489,
                                                                                                                                    column: 36,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 491,
                                                                                                                                    column: 40,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                }
                                                                                                                            },
                                                                                                                            order: '1'
                                                                                                                        }
                                                                                                                    ]
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 486,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 491,
                                                                                                                        column: 36,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                    }
                                                                                                                },
                                                                                                                order: '1'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'ExpressionStatement',
                                                                                                                expression: {
                                                                                                                    type: 'ObjectExpression',
                                                                                                                    objectType: {
                                                                                                                        type: 'CallExpression',
                                                                                                                        callee: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'Div',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 491,
                                                                                                                                    column: 32,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 491,
                                                                                                                                    column: 35,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        arguments: [{
                                                                                                                                type: 'ObjectExpression',
                                                                                                                                properties: [
                                                                                                                                    {
                                                                                                                                        type: 'Property',
                                                                                                                                        key: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'class',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 491,
                                                                                                                                                    column: 37,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 491,
                                                                                                                                                    column: 42,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        value: {
                                                                                                                                            type: 'Literal',
                                                                                                                                            value: 'nowrap'
                                                                                                                                        },
                                                                                                                                        kind: 'init',
                                                                                                                                        order: '0'
                                                                                                                                    },
                                                                                                                                    {
                                                                                                                                        type: 'Property',
                                                                                                                                        key: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'style',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 491,
                                                                                                                                                    column: 52,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 491,
                                                                                                                                                    column: 57,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        value: {
                                                                                                                                            type: 'Literal',
                                                                                                                                            value: 'font-size:12px'
                                                                                                                                        },
                                                                                                                                        kind: 'init',
                                                                                                                                        order: '1'
                                                                                                                                    }
                                                                                                                                ]
                                                                                                                            }],
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 491,
                                                                                                                                column: 32,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 491,
                                                                                                                                column: 76,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    properties: [{
                                                                                                                            type: 'ExpressionStatement',
                                                                                                                            expression: {
                                                                                                                                type: 'CallExpression',
                                                                                                                                callee: {
                                                                                                                                    type: 'MemberExpression',
                                                                                                                                    computed: false,
                                                                                                                                    object: {
                                                                                                                                        type: 'NewExpression',
                                                                                                                                        callee: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'Date',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 492,
                                                                                                                                                    column: 40,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 492,
                                                                                                                                                    column: 44,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        arguments: [{
                                                                                                                                                type: 'MemberExpression',
                                                                                                                                                computed: false,
                                                                                                                                                object: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'comment',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 492,
                                                                                                                                                            column: 45,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 492,
                                                                                                                                                            column: 52,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                property: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'created',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 492,
                                                                                                                                                            column: 53,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 492,
                                                                                                                                                            column: 60,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 492,
                                                                                                                                                        column: 45,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 492,
                                                                                                                                                        column: 60,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            }],
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 492,
                                                                                                                                                column: 36,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 492,
                                                                                                                                                column: 61,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    property: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'format',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 492,
                                                                                                                                                column: 62,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 492,
                                                                                                                                                column: 68,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 492,
                                                                                                                                            column: 36,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 492,
                                                                                                                                            column: 68,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                arguments: [{
                                                                                                                                        type: 'Literal',
                                                                                                                                        value: '{MM}/{dd}/{yyyy} {time}'
                                                                                                                                    }],
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 492,
                                                                                                                                        column: 36,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 492,
                                                                                                                                        column: 95,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 492,
                                                                                                                                    column: 36,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 492,
                                                                                                                                    column: 95,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                                }
                                                                                                                            },
                                                                                                                            order: '0'
                                                                                                                        }]
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 491,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 494,
                                                                                                                        column: 36,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                                    }
                                                                                                                },
                                                                                                                order: '2'
                                                                                                            }
                                                                                                        ]
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 484,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 494,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                                        }
                                                                                                    },
                                                                                                    order: '1'
                                                                                                }
                                                                                            ]
                                                                                        },
                                                                                        alternate: null,
                                                                                        order: '2'
                                                                                    }
                                                                                ]
                                                                            },
                                                                            remove: null,
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                order: '0'
                                                            }],
                                                        bound: false,
                                                        name: {
                                                            type: 'Identifier',
                                                            name: 'content',
                                                            loc: {
                                                                start: {
                                                                    line: 477,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                },
                                                                end: {
                                                                    line: 477,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                }
                                                            }
                                                        },
                                                        scope: {
                                                            type: 'Identifier',
                                                            name: '_ps7'
                                                        }
                                                    }, {
                                                        this: this,
                                                        _ps7: _ps7,
                                                        _ref11: _ref11,
                                                        ion: ion,
                                                        glass: glass,
                                                        _ref: _ref,
                                                        _ref2: _ref2,
                                                        _ref3: _ref3,
                                                        _ref4: _ref4,
                                                        style: style,
                                                        _ref5: _ref5,
                                                        namespace: namespace,
                                                        _ref6: _ref6,
                                                        _ref7: _ref7,
                                                        DateTime: DateTime,
                                                        RecordChip: RecordChip,
                                                        RecordIcon: RecordIcon,
                                                        PromptDialog: PromptDialog,
                                                        Key: Key,
                                                        SetupWizard: SetupWizard,
                                                        SubscriptionNotice: SubscriptionNotice,
                                                        Task: Task,
                                                        Project: Project,
                                                        ProjectType: ProjectType,
                                                        User: User,
                                                        Comment: Comment,
                                                        createProjectPrompt: createProjectPrompt,
                                                        lightGray: lightGray,
                                                        gray: gray,
                                                        darkGray: darkGray,
                                                        DashboardCard: DashboardCard,
                                                        dateString: dateString,
                                                        getWeeks: getWeeks,
                                                        workHoursOnDateFromTask: workHoursOnDateFromTask,
                                                        getDays: getDays,
                                                        TaskCalendarModel: TaskCalendarModel,
                                                        capitalize: capitalize,
                                                        displayDate: displayDate,
                                                        dateColor: dateColor,
                                                        TaskCalendar: TaskCalendar,
                                                        TasksCard: TasksCard,
                                                        ProjectsCard: ProjectsCard,
                                                        MembersCard: MembersCard,
                                                        mostRecentComment: mostRecentComment,
                                                        DiscussionsCard: DiscussionsCard,
                                                        getTaskComments: getTaskComments,
                                                        Dashboard: Dashboard
                                                    }, _ps7);
                                                });
                                            }
                                        },
                                        kind: 'init',
                                        order: '1'
                                    }
                                ]
                            }],
                        loc: {
                            start: {
                                line: 475,
                                column: 15,
                                fixed: true,
                                source: 'viewpath/html/panes/DashboardPane.ion'
                            },
                            end: {
                                line: 494,
                                column: 12,
                                fixed: true,
                                source: 'viewpath/html/panes/DashboardPane.ion'
                            }
                        }
                    },
                    order: '1'
                }
            ],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'DiscussionsCard',
                loc: {
                    start: {
                        line: 474,
                        column: 4,
                        fixed: true,
                        source: 'viewpath/html/panes/DashboardPane.ion'
                    },
                    end: {
                        line: 474,
                        column: 19,
                        fixed: true,
                        source: 'viewpath/html/panes/DashboardPane.ion'
                    }
                }
            }
        }, {
            this: this,
            ion: ion,
            _ref11: _ref11,
            glass: glass,
            _ref: _ref,
            _ref2: _ref2,
            _ref3: _ref3,
            _ref4: _ref4,
            style: style,
            _ref5: _ref5,
            namespace: namespace,
            _ref6: _ref6,
            _ref7: _ref7,
            DateTime: DateTime,
            RecordChip: RecordChip,
            RecordIcon: RecordIcon,
            PromptDialog: PromptDialog,
            Key: Key,
            SetupWizard: SetupWizard,
            SubscriptionNotice: SubscriptionNotice,
            Task: Task,
            Project: Project,
            ProjectType: ProjectType,
            User: User,
            Comment: Comment,
            createProjectPrompt: createProjectPrompt,
            lightGray: lightGray,
            gray: gray,
            darkGray: darkGray,
            DashboardCard: DashboardCard,
            dateString: dateString,
            getWeeks: getWeeks,
            workHoursOnDateFromTask: workHoursOnDateFromTask,
            getDays: getDays,
            TaskCalendarModel: TaskCalendarModel,
            capitalize: capitalize,
            displayDate: displayDate,
            dateColor: dateColor,
            TaskCalendar: TaskCalendar,
            TasksCard: TasksCard,
            ProjectsCard: ProjectsCard,
            MembersCard: MembersCard,
            mostRecentComment: mostRecentComment,
            DiscussionsCard: DiscussionsCard,
            getTaskComments: getTaskComments,
            Dashboard: Dashboard
        }, null);
    });
var getTaskComments = function (comments) {
        var sortedComments = Object.values(comments != null ? comments : {});
        sortedComments.sort(function (a, b) {
            return b.Created.toDate().getTime() - a.Created.toDate().getTime();
        });
        var tasks = {};
        if (comments != null) {
            for (var _i4 = 0; _i4 < sortedComments.length; _i4++) {
                var comment = sortedComments[_i4];
                var taskKey = comment.getKey().parent;
                tasks[taskKey] = tasks[taskKey] != null ? tasks[taskKey] : {};
                tasks[taskKey][comment.key] = comment;
            }
        }
        return tasks;
    }, Dashboard = ion.template(function () {
        return ion.createRuntime({
            type: 'Template',
            id: null,
            body: [
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'projectsKey',
                                loc: {
                                    start: {
                                        line: 509,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 509,
                                        column: 23,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'NewExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Key',
                                    loc: {
                                        start: {
                                            line: 509,
                                            column: 30,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        },
                                        end: {
                                            line: 509,
                                            column: 33,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        }
                                    }
                                },
                                arguments: [
                                    {
                                        type: 'Identifier',
                                        name: 'Project',
                                        loc: {
                                            start: {
                                                line: 510,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            },
                                            end: {
                                                line: 510,
                                                column: 19,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            }
                                        }
                                    },
                                    {
                                        type: 'ObjectExpression',
                                        objectType: {
                                            type: 'ObjectExpression',
                                            properties: []
                                        },
                                        properties: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'where',
                                                    loc: {
                                                        start: {
                                                            line: 512,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                        },
                                                        end: {
                                                            line: 512,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'ObjectExpression',
                                                    properties: [
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'sharingUserKeys',
                                                                loc: {
                                                                    start: {
                                                                        line: 513,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 513,
                                                                        column: 35,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'model',
                                                                    loc: {
                                                                        start: {
                                                                            line: 513,
                                                                            column: 37,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 513,
                                                                            column: 42,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'userKey',
                                                                    loc: {
                                                                        start: {
                                                                            line: 513,
                                                                            column: 43,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 513,
                                                                            column: 50,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 513,
                                                                        column: 37,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 513,
                                                                        column: 50,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        },
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'type',
                                                                loc: {
                                                                    start: {
                                                                        line: 514,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 514,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'ProjectType',
                                                                        loc: {
                                                                            start: {
                                                                                line: 514,
                                                                                column: 26,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 514,
                                                                                column: 37,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'Project',
                                                                        loc: {
                                                                            start: {
                                                                                line: 514,
                                                                                column: 38,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 514,
                                                                                column: 45,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 514,
                                                                            column: 26,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 514,
                                                                            column: 45,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'id',
                                                                    loc: {
                                                                        start: {
                                                                            line: 514,
                                                                            column: 46,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 514,
                                                                            column: 48,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 514,
                                                                        column: 26,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 514,
                                                                        column: 48,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '1'
                                                        },
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'archived',
                                                                loc: {
                                                                    start: {
                                                                        line: 515,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 515,
                                                                        column: 28,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Literal',
                                                                value: false
                                                            },
                                                            kind: 'init',
                                                            order: '2'
                                                        }
                                                    ]
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    }
                                ],
                                loc: {
                                    start: {
                                        line: 509,
                                        column: 26,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 516,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '0'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'projects',
                                loc: {
                                    start: {
                                        line: 516,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 516,
                                        column: 20,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                computed: true,
                                object: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'model',
                                        loc: {
                                            start: {
                                                line: 516,
                                                column: 23,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            },
                                            end: {
                                                line: 516,
                                                column: 28,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'server',
                                        loc: {
                                            start: {
                                                line: 516,
                                                column: 29,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            },
                                            end: {
                                                line: 516,
                                                column: 35,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 516,
                                            column: 23,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        },
                                        end: {
                                            line: 516,
                                            column: 35,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'projectsKey',
                                    loc: {
                                        start: {
                                            line: 516,
                                            column: 36,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        },
                                        end: {
                                            line: 516,
                                            column: 47,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 516,
                                        column: 23,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 516,
                                        column: 48,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '1'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'commentKey',
                                loc: {
                                    start: {
                                        line: 518,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 518,
                                        column: 22,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'NewExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Key',
                                    loc: {
                                        start: {
                                            line: 518,
                                            column: 29,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        },
                                        end: {
                                            line: 518,
                                            column: 32,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        }
                                    }
                                },
                                arguments: [
                                    {
                                        type: 'Identifier',
                                        name: 'Comment',
                                        loc: {
                                            start: {
                                                line: 519,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            },
                                            end: {
                                                line: 519,
                                                column: 19,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            }
                                        }
                                    },
                                    {
                                        type: 'ObjectExpression',
                                        objectType: {
                                            type: 'ObjectExpression',
                                            properties: []
                                        },
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'where',
                                                    loc: {
                                                        start: {
                                                            line: 521,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                        },
                                                        end: {
                                                            line: 521,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'ObjectExpression',
                                                    properties: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'orgId',
                                                                loc: {
                                                                    start: {
                                                                        line: 522,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 522,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'model',
                                                                        loc: {
                                                                            start: {
                                                                                line: 522,
                                                                                column: 27,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 522,
                                                                                column: 32,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'user',
                                                                        loc: {
                                                                            start: {
                                                                                line: 522,
                                                                                column: 33,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 522,
                                                                                column: 37,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 522,
                                                                            column: 27,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 522,
                                                                            column: 37,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'orgIds',
                                                                    loc: {
                                                                        start: {
                                                                            line: 522,
                                                                            column: 38,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 522,
                                                                            column: 44,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 522,
                                                                        column: 27,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 522,
                                                                        column: 44,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'sort',
                                                    loc: {
                                                        start: {
                                                            line: 523,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                        },
                                                        end: {
                                                            line: 523,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'ArrayExpression',
                                                    elements: [{
                                                            type: 'ObjectExpression',
                                                            properties: [{
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'created',
                                                                        loc: {
                                                                            start: {
                                                                                line: 523,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 523,
                                                                                column: 31,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Literal',
                                                                        value: false
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                }]
                                                        }]
                                                },
                                                kind: 'init',
                                                order: '1'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'limit',
                                                    loc: {
                                                        start: {
                                                            line: 524,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                        },
                                                        end: {
                                                            line: 524,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: 50
                                                },
                                                kind: 'init',
                                                order: '2'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'watch',
                                                    loc: {
                                                        start: {
                                                            line: 525,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                        },
                                                        end: {
                                                            line: 525,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: true
                                                },
                                                kind: 'init',
                                                order: '3'
                                            }
                                        ]
                                    }
                                ],
                                loc: {
                                    start: {
                                        line: 518,
                                        column: 25,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 526,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '2'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'comments',
                                loc: {
                                    start: {
                                        line: 526,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 526,
                                        column: 20,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                computed: true,
                                object: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'model',
                                        loc: {
                                            start: {
                                                line: 526,
                                                column: 23,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            },
                                            end: {
                                                line: 526,
                                                column: 28,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'server',
                                        loc: {
                                            start: {
                                                line: 526,
                                                column: 29,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            },
                                            end: {
                                                line: 526,
                                                column: 35,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 526,
                                            column: 23,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        },
                                        end: {
                                            line: 526,
                                            column: 35,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'commentKey',
                                    loc: {
                                        start: {
                                            line: 526,
                                            column: 36,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        },
                                        end: {
                                            line: 526,
                                            column: 46,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 526,
                                        column: 23,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 526,
                                        column: 47,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '3'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'taskComments',
                                loc: {
                                    start: {
                                        line: 527,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 527,
                                        column: 24,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'getTaskComments',
                                    loc: {
                                        start: {
                                            line: 527,
                                            column: 27,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        },
                                        end: {
                                            line: 527,
                                            column: 42,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'Identifier',
                                        name: 'comments',
                                        loc: {
                                            start: {
                                                line: 527,
                                                column: 48,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            },
                                            end: {
                                                line: 527,
                                                column: 56,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            }
                                        },
                                        deep: true
                                    }],
                                loc: {
                                    start: {
                                        line: 527,
                                        column: 27,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 527,
                                        column: 57,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '4'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'subscription',
                                loc: {
                                    start: {
                                        line: 529,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 529,
                                        column: 24,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'model',
                                    loc: {
                                        start: {
                                            line: 529,
                                            column: 27,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        },
                                        end: {
                                            line: 529,
                                            column: 32,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'subscription',
                                    loc: {
                                        start: {
                                            line: 529,
                                            column: 33,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        },
                                        end: {
                                            line: 529,
                                            column: 45,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 529,
                                        column: 27,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 529,
                                        column: 45,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '5'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'inTrial',
                                loc: {
                                    start: {
                                        line: 530,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 530,
                                        column: 19,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'model',
                                        loc: {
                                            start: {
                                                line: 530,
                                                column: 22,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            },
                                            end: {
                                                line: 530,
                                                column: 27,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'user',
                                        loc: {
                                            start: {
                                                line: 530,
                                                column: 28,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            },
                                            end: {
                                                line: 530,
                                                column: 32,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 530,
                                            column: 22,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        },
                                        end: {
                                            line: 530,
                                            column: 32,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'InTrial',
                                    loc: {
                                        start: {
                                            line: 530,
                                            column: 33,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        },
                                        end: {
                                            line: 530,
                                            column: 40,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 530,
                                        column: 22,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 530,
                                        column: 40,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '6'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'hasLicence',
                                loc: {
                                    start: {
                                        line: 531,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 531,
                                        column: 22,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'BinaryExpression',
                                operator: '||',
                                left: {
                                    type: 'UnaryExpression',
                                    operator: '?',
                                    argument: {
                                        type: 'Identifier',
                                        name: 'subscription',
                                        loc: {
                                            start: {
                                                line: 531,
                                                column: 25,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            },
                                            end: {
                                                line: 531,
                                                column: 37,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            }
                                        }
                                    }
                                },
                                right: {
                                    type: 'Identifier',
                                    name: 'inTrial',
                                    loc: {
                                        start: {
                                            line: 531,
                                            column: 42,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        },
                                        end: {
                                            line: 531,
                                            column: 49,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        }
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '7'
                },
                {
                    type: 'ExpressionStatement',
                    expression: {
                        type: 'CallExpression',
                        callee: {
                            type: 'Function',
                            context: true,
                            value: function (_context16) {
                                return function (hasLicence) {
                                    var SetupWizard = _context16.get('SetupWizard');
                                    if (hasLicence && model.user.orgIds.length <= 0 && !model.local.dontShowWizardAgain) {
                                        model.local.dontShowWizardAgain = true;
                                        SetupWizard();
                                    }
                                };
                            }
                        },
                        arguments: [{
                                type: 'Identifier',
                                name: 'hasLicence',
                                loc: {
                                    start: {
                                        line: 532,
                                        column: 11,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 532,
                                        column: 21,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            }],
                        loc: {
                            start: {
                                line: 532,
                                column: 8,
                                fixed: true,
                                source: 'viewpath/html/panes/DashboardPane.ion'
                            },
                            end: {
                                line: 537,
                                column: 12,
                                fixed: true,
                                source: 'viewpath/html/panes/DashboardPane.ion'
                            }
                        }
                    },
                    loc: {
                        start: {
                            line: 532,
                            column: 8,
                            fixed: true,
                            source: 'viewpath/html/panes/DashboardPane.ion'
                        },
                        end: {
                            line: 537,
                            column: 12,
                            fixed: true,
                            source: 'viewpath/html/panes/DashboardPane.ion'
                        }
                    },
                    order: '8'
                },
                {
                    type: 'ReturnStatement',
                    argument: {
                        type: 'ObjectExpression',
                        objectType: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Div',
                                loc: {
                                    start: {
                                        line: 537,
                                        column: 15,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 537,
                                        column: 18,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ObjectExpression',
                                    properties: [
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'class',
                                                loc: {
                                                    start: {
                                                        line: 537,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                    },
                                                    end: {
                                                        line: 537,
                                                        column: 25,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: 'layout horizontal flex fill'
                                            },
                                            kind: 'init',
                                            order: '0'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'style',
                                                loc: {
                                                    start: {
                                                        line: 537,
                                                        column: 57,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                    },
                                                    end: {
                                                        line: 537,
                                                        column: 62,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: 'overflow-x:auto'
                                            },
                                            kind: 'init',
                                            order: '1'
                                        }
                                    ]
                                }],
                            loc: {
                                start: {
                                    line: 537,
                                    column: 15,
                                    fixed: true,
                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                },
                                end: {
                                    line: 537,
                                    column: 82,
                                    fixed: true,
                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                }
                            }
                        },
                        properties: [
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'name',
                                    loc: {
                                        start: {
                                            line: 538,
                                            column: 12,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        },
                                        end: {
                                            line: 538,
                                            column: 16,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'Literal',
                                    value: 'Dashboard'
                                },
                                kind: 'init',
                                order: '0'
                            },
                            {
                                type: 'ExpressionStatement',
                                expression: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'Identifier',
                                        name: 'Div',
                                        loc: {
                                            start: {
                                                line: 539,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            },
                                            end: {
                                                line: 539,
                                                column: 15,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            }
                                        }
                                    },
                                    arguments: [{
                                            type: 'ObjectExpression',
                                            properties: [{
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'class',
                                                        loc: {
                                                            start: {
                                                                line: 539,
                                                                column: 17,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                            },
                                                            end: {
                                                                line: 539,
                                                                column: 22,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 'dashboard-side fill'
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                }]
                                        }],
                                    loc: {
                                        start: {
                                            line: 539,
                                            column: 12,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        },
                                        end: {
                                            line: 539,
                                            column: 46,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 539,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 539,
                                        column: 46,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                },
                                order: '1'
                            },
                            {
                                type: 'ExpressionStatement',
                                expression: {
                                    type: 'ObjectExpression',
                                    objectType: {
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'Identifier',
                                            name: 'Div',
                                            loc: {
                                                start: {
                                                    line: 540,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                },
                                                end: {
                                                    line: 540,
                                                    column: 15,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                }
                                            }
                                        },
                                        arguments: [{
                                                type: 'ObjectExpression',
                                                properties: [{
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'class',
                                                            loc: {
                                                                start: {
                                                                    line: 540,
                                                                    column: 17,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                },
                                                                end: {
                                                                    line: 540,
                                                                    column: 22,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Literal',
                                                            value: 'dashboard-content layout vertical flex padding'
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    }]
                                            }],
                                        loc: {
                                            start: {
                                                line: 540,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            },
                                            end: {
                                                line: 540,
                                                column: 73,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            }
                                        }
                                    },
                                    properties: [
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'TasksCard',
                                                    loc: {
                                                        start: {
                                                            line: 541,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                        },
                                                        end: {
                                                            line: 541,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [{
                                                        type: 'ObjectExpression',
                                                        properties: [
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'projects',
                                                                    loc: {
                                                                        start: {
                                                                            line: 541,
                                                                            column: 27,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 541,
                                                                            column: 35,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Identifier',
                                                                    name: 'projects',
                                                                    loc: {
                                                                        start: {
                                                                            line: 541,
                                                                            column: 27,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 541,
                                                                            column: 35,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'taskComments',
                                                                    loc: {
                                                                        start: {
                                                                            line: 541,
                                                                            column: 36,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 541,
                                                                            column: 48,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Identifier',
                                                                    name: 'taskComments',
                                                                    loc: {
                                                                        start: {
                                                                            line: 541,
                                                                            column: 36,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 541,
                                                                            column: 48,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '1'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'hasLicence',
                                                                    loc: {
                                                                        start: {
                                                                            line: 541,
                                                                            column: 49,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 541,
                                                                            column: 59,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Identifier',
                                                                    name: 'hasLicence',
                                                                    loc: {
                                                                        start: {
                                                                            line: 541,
                                                                            column: 49,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 541,
                                                                            column: 59,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '2'
                                                            }
                                                        ]
                                                    }],
                                                loc: {
                                                    start: {
                                                        line: 541,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                    },
                                                    end: {
                                                        line: 541,
                                                        column: 61,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 541,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                },
                                                end: {
                                                    line: 541,
                                                    column: 61,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                }
                                            },
                                            order: '0'
                                        },
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'ObjectExpression',
                                                objectType: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'Identifier',
                                                        name: 'Div',
                                                        loc: {
                                                            start: {
                                                                line: 542,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                            },
                                                            end: {
                                                                line: 542,
                                                                column: 19,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [{
                                                            type: 'ObjectExpression',
                                                            properties: [{
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'class',
                                                                        loc: {
                                                                            start: {
                                                                                line: 542,
                                                                                column: 21,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 542,
                                                                                column: 26,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Literal',
                                                                        value: 'layout horizontal justified fill'
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                }]
                                                        }],
                                                    loc: {
                                                        start: {
                                                            line: 542,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                        },
                                                        end: {
                                                            line: 542,
                                                            column: 63,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                        }
                                                    }
                                                },
                                                properties: [
                                                    {
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'ObjectExpression',
                                                            objectType: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Identifier',
                                                                    name: 'ProjectsCard',
                                                                    loc: {
                                                                        start: {
                                                                            line: 543,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 543,
                                                                            column: 32,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'ObjectExpression',
                                                                        properties: [
                                                                            {
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'projects',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 543,
                                                                                            column: 34,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 543,
                                                                                            column: 42,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Identifier',
                                                                                    name: 'projects',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 543,
                                                                                            column: 34,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 543,
                                                                                            column: 42,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                kind: 'init',
                                                                                order: '0'
                                                                            },
                                                                            {
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'hasLicence',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 543,
                                                                                            column: 43,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 543,
                                                                                            column: 53,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Identifier',
                                                                                    name: 'hasLicence',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 543,
                                                                                            column: 43,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 543,
                                                                                            column: 53,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                kind: 'init',
                                                                                order: '1'
                                                                            }
                                                                        ]
                                                                    }],
                                                                loc: {
                                                                    start: {
                                                                        line: 543,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 543,
                                                                        column: 55,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            properties: [{
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'style',
                                                                        loc: {
                                                                            start: {
                                                                                line: 544,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 544,
                                                                                column: 29,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'ObjectExpression',
                                                                        properties: [{
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'flex',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 544,
                                                                                            column: 32,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 544,
                                                                                            column: 36,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Literal',
                                                                                    value: '1 0'
                                                                                },
                                                                                kind: 'init',
                                                                                order: '0'
                                                                            }]
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                }]
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 543,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                            },
                                                            end: {
                                                                line: 545,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                            }
                                                        },
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'ObjectExpression',
                                                            objectType: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Identifier',
                                                                    name: 'DiscussionsCard',
                                                                    loc: {
                                                                        start: {
                                                                            line: 545,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 545,
                                                                            column: 35,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'ObjectExpression',
                                                                        properties: [{
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'taskComments',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 545,
                                                                                            column: 37,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 545,
                                                                                            column: 49,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Identifier',
                                                                                    name: 'taskComments',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 545,
                                                                                            column: 37,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 545,
                                                                                            column: 49,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                kind: 'init',
                                                                                order: '0'
                                                                            }]
                                                                    }],
                                                                loc: {
                                                                    start: {
                                                                        line: 545,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 545,
                                                                        column: 51,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            properties: [{
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'style',
                                                                        loc: {
                                                                            start: {
                                                                                line: 546,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 546,
                                                                                column: 29,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'ObjectExpression',
                                                                        properties: [{
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'flex',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 546,
                                                                                            column: 32,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 546,
                                                                                            column: 36,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Literal',
                                                                                    value: '1 0'
                                                                                },
                                                                                kind: 'init',
                                                                                order: '0'
                                                                            }]
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                }]
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 545,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                            },
                                                            end: {
                                                                line: 547,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                            }
                                                        },
                                                        order: '1'
                                                    }
                                                ]
                                            },
                                            loc: {
                                                start: {
                                                    line: 542,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                },
                                                end: {
                                                    line: 547,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/DashboardPane.ion'
                                                }
                                            },
                                            order: '1'
                                        }
                                    ]
                                },
                                loc: {
                                    start: {
                                        line: 540,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 547,
                                        column: 16,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                },
                                order: '2'
                            },
                            {
                                type: 'ExpressionStatement',
                                expression: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'Identifier',
                                        name: 'Div',
                                        loc: {
                                            start: {
                                                line: 547,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            },
                                            end: {
                                                line: 547,
                                                column: 15,
                                                fixed: true,
                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                            }
                                        }
                                    },
                                    arguments: [{
                                            type: 'ObjectExpression',
                                            properties: [{
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'class',
                                                        loc: {
                                                            start: {
                                                                line: 547,
                                                                column: 17,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                            },
                                                            end: {
                                                                line: 547,
                                                                column: 22,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/DashboardPane.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 'dashboard-side fill'
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                }]
                                        }],
                                    loc: {
                                        start: {
                                            line: 547,
                                            column: 12,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        },
                                        end: {
                                            line: 547,
                                            column: 46,
                                            fixed: true,
                                            source: 'viewpath/html/panes/DashboardPane.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 547,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    },
                                    end: {
                                        line: 547,
                                        column: 46,
                                        fixed: true,
                                        source: 'viewpath/html/panes/DashboardPane.ion'
                                    }
                                },
                                order: '3'
                            }
                        ]
                    },
                    order: '9'
                }
            ],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'Dashboard',
                loc: {
                    start: {
                        line: 508,
                        column: 4,
                        fixed: true,
                        source: 'viewpath/html/panes/DashboardPane.ion'
                    },
                    end: {
                        line: 508,
                        column: 13,
                        fixed: true,
                        source: 'viewpath/html/panes/DashboardPane.ion'
                    }
                }
            }
        }, {
            this: this,
            ion: ion,
            glass: glass,
            _ref: _ref,
            _ref2: _ref2,
            _ref3: _ref3,
            _ref4: _ref4,
            style: style,
            _ref5: _ref5,
            namespace: namespace,
            _ref6: _ref6,
            _ref7: _ref7,
            DateTime: DateTime,
            RecordChip: RecordChip,
            RecordIcon: RecordIcon,
            PromptDialog: PromptDialog,
            Key: Key,
            SetupWizard: SetupWizard,
            SubscriptionNotice: SubscriptionNotice,
            Task: Task,
            Project: Project,
            ProjectType: ProjectType,
            User: User,
            Comment: Comment,
            createProjectPrompt: createProjectPrompt,
            lightGray: lightGray,
            gray: gray,
            darkGray: darkGray,
            DashboardCard: DashboardCard,
            dateString: dateString,
            getWeeks: getWeeks,
            workHoursOnDateFromTask: workHoursOnDateFromTask,
            getDays: getDays,
            TaskCalendarModel: TaskCalendarModel,
            capitalize: capitalize,
            displayDate: displayDate,
            dateColor: dateColor,
            TaskCalendar: TaskCalendar,
            TasksCard: TasksCard,
            ProjectsCard: ProjectsCard,
            MembersCard: MembersCard,
            mostRecentComment: mostRecentComment,
            DiscussionsCard: DiscussionsCard,
            getTaskComments: getTaskComments,
            Dashboard: Dashboard
        }, null);
    });
module.exports = exports = Dashboard;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/panes/DashboardPane',_viewpath_html_panes_DashboardPane_);
    else
      _viewpath_html_panes_DashboardPane_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_panes_DashboardPane_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_panes_GenericTypePane_ = function(module,exports,require){'use strict';
var ion = require('ion');
var glass = require('glass'), _ref, _ref2, _ref3, viewpath = require('../..'), _ref4, DataTable = glass.html.material.DataTable2, _ref5;
_ref = glass.html.material;
var Icon = _ref.Icon;
var Form = _ref.Form;
var Field = _ref.Field;
var Button = _ref.Button;
var TabContent = _ref.TabContent;
var Toolbar = _ref.Toolbar;
_ref2 = glass.html;
var style = _ref2.style;
_ref3 = glass.data;
var Schema = _ref3.Schema;
var Key = _ref3.Key;
_ref4 = viewpath.model;
var User = _ref4.User;
var Task = _ref4.Task;
_ref5 = require('./');
var GenericTypeView = _ref5.GenericTypeView;
module.exports = exports = ion.template(function GenericTypePane(config) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'GenericTypePane',
            loc: {
                start: {
                    line: 12,
                    column: 16,
                    fixed: true,
                    source: 'viewpath/html/panes/GenericTypePane.ion'
                },
                end: {
                    line: 12,
                    column: 31,
                    fixed: true,
                    source: 'viewpath/html/panes/GenericTypePane.ion'
                }
            }
        },
        body: [{
                type: 'ReturnStatement',
                argument: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'CallExpression',
                        callee: {
                            type: 'Identifier',
                            name: 'Div',
                            loc: {
                                start: {
                                    line: 13,
                                    column: 11,
                                    fixed: true,
                                    source: 'viewpath/html/panes/GenericTypePane.ion'
                                },
                                end: {
                                    line: 13,
                                    column: 14,
                                    fixed: true,
                                    source: 'viewpath/html/panes/GenericTypePane.ion'
                                }
                            }
                        },
                        arguments: [{
                                type: 'ObjectExpression',
                                properties: [{
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'class',
                                            loc: {
                                                start: {
                                                    line: 13,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/GenericTypePane.ion'
                                                },
                                                end: {
                                                    line: 13,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/GenericTypePane.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: 'fill layout vertical'
                                        },
                                        kind: 'init',
                                        order: '0'
                                    }]
                            }],
                        loc: {
                            start: {
                                line: 13,
                                column: 11,
                                fixed: true,
                                source: 'viewpath/html/panes/GenericTypePane.ion'
                            },
                            end: {
                                line: 13,
                                column: 46,
                                fixed: true,
                                source: 'viewpath/html/panes/GenericTypePane.ion'
                            }
                        }
                    },
                    properties: [
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'name',
                                loc: {
                                    start: {
                                        line: 14,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/html/panes/GenericTypePane.ion'
                                    },
                                    end: {
                                        line: 14,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/GenericTypePane.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'config',
                                    loc: {
                                        start: {
                                            line: 14,
                                            column: 14,
                                            fixed: true,
                                            source: 'viewpath/html/panes/GenericTypePane.ion'
                                        },
                                        end: {
                                            line: 14,
                                            column: 20,
                                            fixed: true,
                                            source: 'viewpath/html/panes/GenericTypePane.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'name',
                                    loc: {
                                        start: {
                                            line: 14,
                                            column: 21,
                                            fixed: true,
                                            source: 'viewpath/html/panes/GenericTypePane.ion'
                                        },
                                        end: {
                                            line: 14,
                                            column: 25,
                                            fixed: true,
                                            source: 'viewpath/html/panes/GenericTypePane.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 14,
                                        column: 14,
                                        fixed: true,
                                        source: 'viewpath/html/panes/GenericTypePane.ion'
                                    },
                                    end: {
                                        line: 14,
                                        column: 25,
                                        fixed: true,
                                        source: 'viewpath/html/panes/GenericTypePane.ion'
                                    }
                                }
                            },
                            kind: 'init',
                            order: '0'
                        },
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'TabContent',
                                    loc: {
                                        start: {
                                            line: 15,
                                            column: 8,
                                            fixed: true,
                                            source: 'viewpath/html/panes/GenericTypePane.ion'
                                        },
                                        end: {
                                            line: 15,
                                            column: 18,
                                            fixed: true,
                                            source: 'viewpath/html/panes/GenericTypePane.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'state',
                                                    loc: {
                                                        start: {
                                                            line: 16,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/GenericTypePane.ion'
                                                        },
                                                        end: {
                                                            line: 16,
                                                            column: 17,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/GenericTypePane.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'config',
                                                        loc: {
                                                            start: {
                                                                line: 16,
                                                                column: 19,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypePane.ion'
                                                            },
                                                            end: {
                                                                line: 16,
                                                                column: 25,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypePane.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'state',
                                                        loc: {
                                                            start: {
                                                                line: 16,
                                                                column: 26,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypePane.ion'
                                                            },
                                                            end: {
                                                                line: 16,
                                                                column: 31,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypePane.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 16,
                                                            column: 19,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/GenericTypePane.ion'
                                                        },
                                                        end: {
                                                            line: 16,
                                                            column: 31,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/GenericTypePane.ion'
                                                        }
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'path',
                                                    loc: {
                                                        start: {
                                                            line: 17,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/GenericTypePane.ion'
                                                        },
                                                        end: {
                                                            line: 17,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/GenericTypePane.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'ArrayExpression',
                                                    elements: []
                                                },
                                                kind: 'init',
                                                order: '1'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'step',
                                                    loc: {
                                                        start: {
                                                            line: 18,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/GenericTypePane.ion'
                                                        },
                                                        end: {
                                                            line: 18,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/GenericTypePane.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: 0
                                                },
                                                kind: 'init',
                                                order: '2'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'tabs',
                                                    loc: {
                                                        start: {
                                                            line: 19,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/GenericTypePane.ion'
                                                        },
                                                        end: {
                                                            line: 19,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/GenericTypePane.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'ObjectExpression',
                                                    objectType: {
                                                        type: 'ArrayExpression',
                                                        elements: []
                                                    },
                                                    properties: [{
                                                            type: 'ForOfStatement',
                                                            left: {
                                                                type: 'VariableDeclaration',
                                                                declarations: [{
                                                                        type: 'VariableDeclarator',
                                                                        id: {
                                                                            type: 'Identifier',
                                                                            name: 'tab',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 20,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 20,
                                                                                    column: 23,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        init: null
                                                                    }],
                                                                kind: 'let'
                                                            },
                                                            right: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'config',
                                                                    loc: {
                                                                        start: {
                                                                            line: 20,
                                                                            column: 27,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 20,
                                                                            column: 33,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'tabs',
                                                                    loc: {
                                                                        start: {
                                                                            line: 20,
                                                                            column: 34,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 20,
                                                                            column: 38,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 20,
                                                                        column: 27,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 20,
                                                                        column: 38,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                    }
                                                                }
                                                            },
                                                            body: {
                                                                type: 'BlockStatement',
                                                                body: [
                                                                    {
                                                                        type: 'VariableDeclaration',
                                                                        declarations: [{
                                                                                type: 'VariableDeclarator',
                                                                                id: {
                                                                                    type: 'Identifier',
                                                                                    name: 'type',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 21,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 21,
                                                                                            column: 28,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                init: {
                                                                                    type: 'ConditionalExpression',
                                                                                    test: {
                                                                                        type: 'BinaryExpression',
                                                                                        operator: '!=',
                                                                                        left: {
                                                                                            type: 'MemberExpression',
                                                                                            computed: false,
                                                                                            object: {
                                                                                                type: 'Identifier',
                                                                                                name: 'config',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 21,
                                                                                                        column: 31,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 21,
                                                                                                        column: 37,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            property: {
                                                                                                type: 'Identifier',
                                                                                                name: 'type',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 21,
                                                                                                        column: 38,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 21,
                                                                                                        column: 42,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 21,
                                                                                                    column: 31,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 21,
                                                                                                    column: 42,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        right: {
                                                                                            type: 'Literal',
                                                                                            value: null
                                                                                        }
                                                                                    },
                                                                                    consequent: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'config',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 21,
                                                                                                    column: 31,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 21,
                                                                                                    column: 37,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'type',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 21,
                                                                                                    column: 38,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 21,
                                                                                                    column: 42,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 21,
                                                                                                column: 31,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 21,
                                                                                                column: 42,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    alternate: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'tab',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 21,
                                                                                                    column: 45,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 21,
                                                                                                    column: 48,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'type',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 21,
                                                                                                    column: 49,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 21,
                                                                                                    column: 53,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 21,
                                                                                                column: 45,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 21,
                                                                                                column: 53,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                }
                                                                            }],
                                                                        kind: 'let',
                                                                        order: '0'
                                                                    },
                                                                    {
                                                                        type: 'VariableDeclaration',
                                                                        declarations: [{
                                                                                type: 'VariableDeclarator',
                                                                                id: {
                                                                                    type: 'Identifier',
                                                                                    name: 'id',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 22,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 22,
                                                                                            column: 26,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                init: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'tab',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 22,
                                                                                                column: 29,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 22,
                                                                                                column: 32,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'id',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 22,
                                                                                                column: 33,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 22,
                                                                                                column: 35,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 22,
                                                                                            column: 29,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 22,
                                                                                            column: 35,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                        }
                                                                                    }
                                                                                }
                                                                            }],
                                                                        kind: 'let',
                                                                        order: '1'
                                                                    },
                                                                    {
                                                                        type: 'VariableDeclaration',
                                                                        declarations: [{
                                                                                type: 'VariableDeclarator',
                                                                                id: {
                                                                                    type: 'Identifier',
                                                                                    name: 'viewConfig',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 23,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 23,
                                                                                            column: 34,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                init: {
                                                                                    type: 'CallExpression',
                                                                                    callee: {
                                                                                        type: 'Function',
                                                                                        context: true,
                                                                                        value: function (_context) {
                                                                                            return function () {
                                                                                                var config = _context.get('config'), tab = _context.get('tab'), id = _context.get('id');
                                                                                                return Object.assign({}, config, tab, { id: id });
                                                                                            };
                                                                                        }
                                                                                    },
                                                                                    arguments: [],
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 23,
                                                                                            column: 37,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 23,
                                                                                            column: 79,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                        }
                                                                                    }
                                                                                }
                                                                            }],
                                                                        kind: 'let',
                                                                        order: '2'
                                                                    },
                                                                    {
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'ObjectExpression',
                                                                            objectType: {
                                                                                type: 'ObjectExpression',
                                                                                properties: []
                                                                            },
                                                                            properties: [
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'name',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 25,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 25,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'viewConfig',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 25,
                                                                                                    column: 30,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 25,
                                                                                                    column: 40,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'id',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 25,
                                                                                                    column: 41,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 25,
                                                                                                    column: 43,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 25,
                                                                                                column: 30,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 25,
                                                                                                column: 43,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'tab',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 26,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 26,
                                                                                                column: 27,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Function',
                                                                                        context: true,
                                                                                        value: function (_context2) {
                                                                                            return function () {
                                                                                                var viewConfig = _context2.get('viewConfig');
                                                                                                return viewConfig.name;
                                                                                            };
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '1'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'content',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 27,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 27,
                                                                                                column: 31,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Function',
                                                                                        context: true,
                                                                                        value: function (_ps) {
                                                                                            return ion.template(function () {
                                                                                                return ion.createRuntime({
                                                                                                    type: 'Template',
                                                                                                    id: null,
                                                                                                    body: [{
                                                                                                            type: 'ReturnStatement',
                                                                                                            argument: {
                                                                                                                type: 'CallExpression',
                                                                                                                callee: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'GenericTypeView',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 28,
                                                                                                                            column: 35,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 28,
                                                                                                                            column: 50,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                arguments: [{
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'viewConfig',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 28,
                                                                                                                                column: 51,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 28,
                                                                                                                                column: 61,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    }],
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 28,
                                                                                                                        column: 35,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 28,
                                                                                                                        column: 62,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            order: '0'
                                                                                                        }],
                                                                                                    bound: false,
                                                                                                    name: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'content',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 27,
                                                                                                                column: 24,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 27,
                                                                                                                column: 31,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    scope: {
                                                                                                        type: 'Identifier',
                                                                                                        name: '_ps'
                                                                                                    }
                                                                                                }, {
                                                                                                    this: this,
                                                                                                    _ps: _ps,
                                                                                                    config: config,
                                                                                                    glass: glass,
                                                                                                    _ref: _ref,
                                                                                                    _ref2: _ref2,
                                                                                                    _ref3: _ref3,
                                                                                                    viewpath: viewpath,
                                                                                                    _ref4: _ref4,
                                                                                                    DataTable: DataTable,
                                                                                                    _ref5: _ref5,
                                                                                                    Icon: Icon,
                                                                                                    Form: Form,
                                                                                                    Field: Field,
                                                                                                    Button: Button,
                                                                                                    TabContent: TabContent,
                                                                                                    Toolbar: Toolbar,
                                                                                                    style: style,
                                                                                                    Schema: Schema,
                                                                                                    Key: Key,
                                                                                                    User: User,
                                                                                                    Task: Task,
                                                                                                    GenericTypeView: GenericTypeView
                                                                                                }, _ps);
                                                                                            });
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '2'
                                                                                }
                                                                            ]
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 24,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 29,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/GenericTypePane.ion'
                                                                            }
                                                                        },
                                                                        order: '3'
                                                                    }
                                                                ]
                                                            },
                                                            remove: null,
                                                            order: '0'
                                                        }]
                                                },
                                                kind: 'init',
                                                order: '3'
                                            }
                                        ]
                                    }],
                                loc: {
                                    start: {
                                        line: 15,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/html/panes/GenericTypePane.ion'
                                    },
                                    end: {
                                        line: 29,
                                        column: 9,
                                        fixed: true,
                                        source: 'viewpath/html/panes/GenericTypePane.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 15,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/panes/GenericTypePane.ion'
                                },
                                end: {
                                    line: 29,
                                    column: 9,
                                    fixed: true,
                                    source: 'viewpath/html/panes/GenericTypePane.ion'
                                }
                            },
                            order: '1'
                        }
                    ]
                },
                order: '0'
            }],
        bound: false
    }, {
        this: this,
        ion: ion,
        config: config,
        glass: glass,
        _ref: _ref,
        _ref2: _ref2,
        _ref3: _ref3,
        viewpath: viewpath,
        _ref4: _ref4,
        DataTable: DataTable,
        _ref5: _ref5,
        Icon: Icon,
        Form: Form,
        Field: Field,
        Button: Button,
        TabContent: TabContent,
        Toolbar: Toolbar,
        style: style,
        Schema: Schema,
        Key: Key,
        User: User,
        Task: Task,
        GenericTypeView: GenericTypeView
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/panes/GenericTypePane',_viewpath_html_panes_GenericTypePane_);
    else
      _viewpath_html_panes_GenericTypePane_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_panes_GenericTypePane_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_panes_GenericTypeView_ = function(module,exports,require){'use strict';
var ion = require('ion');
var glass = require('glass'), _ref, _ref2, _ref3, viewpath = require('../..'), _ref4, DataTable = glass.html.material.DataTable2;
_ref = glass.html.material;
var Icon = _ref.Icon;
var Form = _ref.Form;
var Field = _ref.Field;
var Button = _ref.Button;
var TabContent = _ref.TabContent;
var Toolbar = _ref.Toolbar;
_ref2 = glass.html;
var style = _ref2.style;
_ref3 = glass.data;
var Schema = _ref3.Schema;
var Key = _ref3.Key;
_ref4 = viewpath.model;
var User = _ref4.User;
var Task = _ref4.Task;
module.exports = exports = ion.template(function GenericTypeView(config) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'GenericTypeView',
            loc: {
                start: {
                    line: 10,
                    column: 16,
                    fixed: true,
                    source: 'viewpath/html/panes/GenericTypeView.ion'
                },
                end: {
                    line: 10,
                    column: 31,
                    fixed: true,
                    source: 'viewpath/html/panes/GenericTypeView.ion'
                }
            }
        },
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: '_ref5'
                        },
                        init: {
                            type: 'Identifier',
                            name: 'config',
                            loc: {
                                start: {
                                    line: 11,
                                    column: 25,
                                    fixed: true,
                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                },
                                end: {
                                    line: 11,
                                    column: 31,
                                    fixed: true,
                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'id',
                            loc: {
                                start: {
                                    line: 11,
                                    column: 9,
                                    fixed: true,
                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                },
                                end: {
                                    line: 11,
                                    column: 11,
                                    fixed: true,
                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref5'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'id',
                                loc: {
                                    start: {
                                        line: 11,
                                        column: 9,
                                        fixed: true,
                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                    },
                                    end: {
                                        line: 11,
                                        column: 11,
                                        fixed: true,
                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'editable',
                            loc: {
                                start: {
                                    line: 11,
                                    column: 13,
                                    fixed: true,
                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                },
                                end: {
                                    line: 11,
                                    column: 21,
                                    fixed: true,
                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            object: {
                                type: 'Identifier',
                                name: '_ref5'
                            },
                            property: {
                                type: 'Identifier',
                                name: 'editable',
                                loc: {
                                    start: {
                                        line: 11,
                                        column: 13,
                                        fixed: true,
                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                    },
                                    end: {
                                        line: 11,
                                        column: 21,
                                        fixed: true,
                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                    }
                                }
                            },
                            computed: false
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'type',
                            loc: {
                                start: {
                                    line: 12,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                },
                                end: {
                                    line: 12,
                                    column: 12,
                                    fixed: true,
                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ConditionalExpression',
                            test: {
                                type: 'BinaryExpression',
                                operator: '!=',
                                left: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'config',
                                        loc: {
                                            start: {
                                                line: 12,
                                                column: 15,
                                                fixed: true,
                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                            },
                                            end: {
                                                line: 12,
                                                column: 21,
                                                fixed: true,
                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'type',
                                        loc: {
                                            start: {
                                                line: 12,
                                                column: 22,
                                                fixed: true,
                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                            },
                                            end: {
                                                line: 12,
                                                column: 26,
                                                fixed: true,
                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 12,
                                            column: 15,
                                            fixed: true,
                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                        },
                                        end: {
                                            line: 12,
                                            column: 26,
                                            fixed: true,
                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: null
                                }
                            },
                            consequent: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'config',
                                    loc: {
                                        start: {
                                            line: 12,
                                            column: 15,
                                            fixed: true,
                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                        },
                                        end: {
                                            line: 12,
                                            column: 21,
                                            fixed: true,
                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'type',
                                    loc: {
                                        start: {
                                            line: 12,
                                            column: 22,
                                            fixed: true,
                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                        },
                                        end: {
                                            line: 12,
                                            column: 26,
                                            fixed: true,
                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 12,
                                        column: 15,
                                        fixed: true,
                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                    },
                                    end: {
                                        line: 12,
                                        column: 26,
                                        fixed: true,
                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                    }
                                }
                            },
                            alternate: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'config',
                                        loc: {
                                            start: {
                                                line: 12,
                                                column: 29,
                                                fixed: true,
                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                            },
                                            end: {
                                                line: 12,
                                                column: 35,
                                                fixed: true,
                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'key',
                                        loc: {
                                            start: {
                                                line: 12,
                                                column: 36,
                                                fixed: true,
                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                            },
                                            end: {
                                                line: 12,
                                                column: 39,
                                                fixed: true,
                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 12,
                                            column: 29,
                                            fixed: true,
                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                        },
                                        end: {
                                            line: 12,
                                            column: 39,
                                            fixed: true,
                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'type',
                                    loc: {
                                        start: {
                                            line: 12,
                                            column: 41,
                                            fixed: true,
                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                        },
                                        end: {
                                            line: 12,
                                            column: 45,
                                            fixed: true,
                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                        }
                                    }
                                },
                                existential: true,
                                loc: {
                                    start: {
                                        line: 12,
                                        column: 29,
                                        fixed: true,
                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                    },
                                    end: {
                                        line: 12,
                                        column: 45,
                                        fixed: true,
                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                    }
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '3'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'state',
                            loc: {
                                start: {
                                    line: 14,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                },
                                end: {
                                    line: 14,
                                    column: 13,
                                    fixed: true,
                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Function',
                                context: true,
                                value: function (_context) {
                                    return function () {
                                        var id = _context.get('id');
                                        return model.local[id] = model.local[id] != null ? model.local[id] : {};
                                    };
                                }
                            },
                            arguments: [],
                            loc: {
                                start: {
                                    line: 14,
                                    column: 16,
                                    fixed: true,
                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                },
                                end: {
                                    line: 14,
                                    column: 43,
                                    fixed: true,
                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '4'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'defaultLimit',
                            loc: {
                                start: {
                                    line: 15,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                },
                                end: {
                                    line: 15,
                                    column: 20,
                                    fixed: true,
                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                }
                            }
                        },
                        init: {
                            type: 'Literal',
                            value: 200
                        }
                    }],
                kind: 'let',
                order: '5'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'rowSource',
                            loc: {
                                start: {
                                    line: 16,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                },
                                end: {
                                    line: 16,
                                    column: 17,
                                    fixed: true,
                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ConditionalExpression',
                            test: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'config',
                                    loc: {
                                        start: {
                                            line: 16,
                                            column: 20,
                                            fixed: true,
                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                        },
                                        end: {
                                            line: 16,
                                            column: 26,
                                            fixed: true,
                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'key',
                                    loc: {
                                        start: {
                                            line: 16,
                                            column: 27,
                                            fixed: true,
                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                        },
                                        end: {
                                            line: 16,
                                            column: 30,
                                            fixed: true,
                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 16,
                                        column: 20,
                                        fixed: true,
                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                    },
                                    end: {
                                        line: 16,
                                        column: 30,
                                        fixed: true,
                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                    }
                                }
                            },
                            consequent: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'DataTable',
                                        loc: {
                                            start: {
                                                line: 16,
                                                column: 33,
                                                fixed: true,
                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                            },
                                            end: {
                                                line: 16,
                                                column: 42,
                                                fixed: true,
                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'FullRowSource',
                                        loc: {
                                            start: {
                                                line: 16,
                                                column: 43,
                                                fixed: true,
                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                            },
                                            end: {
                                                line: 16,
                                                column: 56,
                                                fixed: true,
                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 16,
                                            column: 33,
                                            fixed: true,
                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                        },
                                        end: {
                                            line: 16,
                                            column: 56,
                                            fixed: true,
                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'key',
                                                    loc: {
                                                        start: {
                                                            line: 16,
                                                            column: 58,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                        },
                                                        end: {
                                                            line: 16,
                                                            column: 61,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'config',
                                                        loc: {
                                                            start: {
                                                                line: 16,
                                                                column: 62,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            },
                                                            end: {
                                                                line: 16,
                                                                column: 68,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'key',
                                                        loc: {
                                                            start: {
                                                                line: 16,
                                                                column: 69,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            },
                                                            end: {
                                                                line: 16,
                                                                column: 72,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 16,
                                                            column: 62,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                        },
                                                        end: {
                                                            line: 16,
                                                            column: 72,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                        }
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    }],
                                loc: {
                                    start: {
                                        line: 16,
                                        column: 33,
                                        fixed: true,
                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                    },
                                    end: {
                                        line: 16,
                                        column: 74,
                                        fixed: true,
                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                    }
                                }
                            },
                            alternate: {
                                type: 'ConditionalExpression',
                                test: {
                                    type: 'BinaryExpression',
                                    operator: '!=',
                                    left: {
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'config',
                                                loc: {
                                                    start: {
                                                        line: 16,
                                                        column: 77,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                    },
                                                    end: {
                                                        line: 16,
                                                        column: 83,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'createRowSource',
                                                loc: {
                                                    start: {
                                                        line: 16,
                                                        column: 84,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                    },
                                                    end: {
                                                        line: 16,
                                                        column: 99,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 16,
                                                    column: 77,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                },
                                                end: {
                                                    line: 16,
                                                    column: 99,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                }
                                            }
                                        },
                                        arguments: [],
                                        existential: true,
                                        loc: {
                                            start: {
                                                line: 16,
                                                column: 77,
                                                fixed: true,
                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                            },
                                            end: {
                                                line: 16,
                                                column: 102,
                                                fixed: true,
                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                            }
                                        }
                                    },
                                    right: {
                                        type: 'Literal',
                                        value: null
                                    }
                                },
                                consequent: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'config',
                                            loc: {
                                                start: {
                                                    line: 16,
                                                    column: 77,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                },
                                                end: {
                                                    line: 16,
                                                    column: 83,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'createRowSource',
                                            loc: {
                                                start: {
                                                    line: 16,
                                                    column: 84,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                },
                                                end: {
                                                    line: 16,
                                                    column: 99,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 16,
                                                column: 77,
                                                fixed: true,
                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                            },
                                            end: {
                                                line: 16,
                                                column: 99,
                                                fixed: true,
                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                            }
                                        }
                                    },
                                    arguments: [],
                                    existential: true,
                                    loc: {
                                        start: {
                                            line: 16,
                                            column: 77,
                                            fixed: true,
                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                        },
                                        end: {
                                            line: 16,
                                            column: 102,
                                            fixed: true,
                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                        }
                                    }
                                },
                                alternate: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'DataTable',
                                            loc: {
                                                start: {
                                                    line: 16,
                                                    column: 105,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                },
                                                end: {
                                                    line: 16,
                                                    column: 114,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'PagedRowSource',
                                            loc: {
                                                start: {
                                                    line: 16,
                                                    column: 115,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                },
                                                end: {
                                                    line: 16,
                                                    column: 129,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 16,
                                                column: 105,
                                                fixed: true,
                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                            },
                                            end: {
                                                line: 16,
                                                column: 129,
                                                fixed: true,
                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                            }
                                        }
                                    },
                                    arguments: [{
                                            type: 'ObjectExpression',
                                            properties: [
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'state',
                                                        loc: {
                                                            start: {
                                                                line: 16,
                                                                column: 131,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            },
                                                            end: {
                                                                line: 16,
                                                                column: 136,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Identifier',
                                                        name: 'state',
                                                        loc: {
                                                            start: {
                                                                line: 16,
                                                                column: 131,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            },
                                                            end: {
                                                                line: 16,
                                                                column: 136,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            }
                                                        }
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'filter',
                                                        loc: {
                                                            start: {
                                                                line: 16,
                                                                column: 138,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            },
                                                            end: {
                                                                line: 16,
                                                                column: 144,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'config',
                                                            loc: {
                                                                start: {
                                                                    line: 16,
                                                                    column: 145,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                },
                                                                end: {
                                                                    line: 16,
                                                                    column: 151,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'where',
                                                            loc: {
                                                                start: {
                                                                    line: 16,
                                                                    column: 152,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                },
                                                                end: {
                                                                    line: 16,
                                                                    column: 157,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 16,
                                                                column: 145,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            },
                                                            end: {
                                                                line: 16,
                                                                column: 157,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            }
                                                        }
                                                    },
                                                    kind: 'init',
                                                    order: '1'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'defaultSort',
                                                        loc: {
                                                            start: {
                                                                line: 16,
                                                                column: 159,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            },
                                                            end: {
                                                                line: 16,
                                                                column: 170,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'MemberExpression',
                                                        computed: true,
                                                        object: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'config',
                                                                loc: {
                                                                    start: {
                                                                        line: 16,
                                                                        column: 171,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    },
                                                                    end: {
                                                                        line: 16,
                                                                        column: 177,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'sorts',
                                                                loc: {
                                                                    start: {
                                                                        line: 16,
                                                                        column: 178,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    },
                                                                    end: {
                                                                        line: 16,
                                                                        column: 183,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 16,
                                                                    column: 171,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                },
                                                                end: {
                                                                    line: 16,
                                                                    column: 183,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Literal',
                                                            value: 0
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 16,
                                                                column: 171,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            },
                                                            end: {
                                                                line: 16,
                                                                column: 186,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            }
                                                        }
                                                    },
                                                    kind: 'init',
                                                    order: '2'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'type',
                                                        loc: {
                                                            start: {
                                                                line: 16,
                                                                column: 188,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            },
                                                            end: {
                                                                line: 16,
                                                                column: 192,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Identifier',
                                                        name: 'type',
                                                        loc: {
                                                            start: {
                                                                line: 16,
                                                                column: 188,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            },
                                                            end: {
                                                                line: 16,
                                                                column: 192,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            }
                                                        }
                                                    },
                                                    kind: 'init',
                                                    order: '3'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'defaultLimit',
                                                        loc: {
                                                            start: {
                                                                line: 16,
                                                                column: 194,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            },
                                                            end: {
                                                                line: 16,
                                                                column: 206,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Identifier',
                                                        name: 'defaultLimit',
                                                        loc: {
                                                            start: {
                                                                line: 16,
                                                                column: 194,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            },
                                                            end: {
                                                                line: 16,
                                                                column: 206,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            }
                                                        }
                                                    },
                                                    kind: 'init',
                                                    order: '4'
                                                }
                                            ]
                                        }],
                                    loc: {
                                        start: {
                                            line: 16,
                                            column: 105,
                                            fixed: true,
                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                        },
                                        end: {
                                            line: 16,
                                            column: 208,
                                            fixed: true,
                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                        }
                                    }
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '6'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'dataTableModel',
                            loc: {
                                start: {
                                    line: 19,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                },
                                end: {
                                    line: 19,
                                    column: 22,
                                    fixed: true,
                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'DataTable',
                                        loc: {
                                            start: {
                                                line: 19,
                                                column: 25,
                                                fixed: true,
                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                            },
                                            end: {
                                                line: 19,
                                                column: 34,
                                                fixed: true,
                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'Model',
                                        loc: {
                                            start: {
                                                line: 19,
                                                column: 35,
                                                fixed: true,
                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                            },
                                            end: {
                                                line: 19,
                                                column: 40,
                                                fixed: true,
                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 19,
                                            column: 25,
                                            fixed: true,
                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                        },
                                        end: {
                                            line: 19,
                                            column: 40,
                                            fixed: true,
                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'ObjectExpression',
                                        objectType: {
                                            type: 'ObjectExpression',
                                            properties: [
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'id',
                                                        loc: {
                                                            start: {
                                                                line: 20,
                                                                column: 9,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            },
                                                            end: {
                                                                line: 20,
                                                                column: 11,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Identifier',
                                                        name: 'id',
                                                        loc: {
                                                            start: {
                                                                line: 20,
                                                                column: 9,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            },
                                                            end: {
                                                                line: 20,
                                                                column: 11,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            }
                                                        }
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'state',
                                                        loc: {
                                                            start: {
                                                                line: 20,
                                                                column: 13,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            },
                                                            end: {
                                                                line: 20,
                                                                column: 18,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Identifier',
                                                        name: 'state',
                                                        loc: {
                                                            start: {
                                                                line: 20,
                                                                column: 13,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            },
                                                            end: {
                                                                line: 20,
                                                                column: 18,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            }
                                                        }
                                                    },
                                                    kind: 'init',
                                                    order: '1'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'rowSource',
                                                        loc: {
                                                            start: {
                                                                line: 20,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            },
                                                            end: {
                                                                line: 20,
                                                                column: 29,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Identifier',
                                                        name: 'rowSource',
                                                        loc: {
                                                            start: {
                                                                line: 20,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            },
                                                            end: {
                                                                line: 20,
                                                                column: 29,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            }
                                                        }
                                                    },
                                                    kind: 'init',
                                                    order: '2'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'editable',
                                                        loc: {
                                                            start: {
                                                                line: 20,
                                                                column: 31,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            },
                                                            end: {
                                                                line: 20,
                                                                column: 39,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Identifier',
                                                        name: 'editable',
                                                        loc: {
                                                            start: {
                                                                line: 20,
                                                                column: 31,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            },
                                                            end: {
                                                                line: 20,
                                                                column: 39,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            }
                                                        }
                                                    },
                                                    kind: 'init',
                                                    order: '3'
                                                }
                                            ]
                                        },
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'properties',
                                                    loc: {
                                                        start: {
                                                            line: 21,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                        },
                                                        end: {
                                                            line: 21,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'ConditionalExpression',
                                                    test: {
                                                        type: 'BinaryExpression',
                                                        operator: '!=',
                                                        left: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'config',
                                                                loc: {
                                                                    start: {
                                                                        line: 21,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    },
                                                                    end: {
                                                                        line: 21,
                                                                        column: 30,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'properties',
                                                                loc: {
                                                                    start: {
                                                                        line: 21,
                                                                        column: 31,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    },
                                                                    end: {
                                                                        line: 21,
                                                                        column: 41,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 21,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                },
                                                                end: {
                                                                    line: 21,
                                                                    column: 41,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                }
                                                            }
                                                        },
                                                        right: {
                                                            type: 'Literal',
                                                            value: null
                                                        }
                                                    },
                                                    consequent: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'config',
                                                            loc: {
                                                                start: {
                                                                    line: 21,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                },
                                                                end: {
                                                                    line: 21,
                                                                    column: 30,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'properties',
                                                            loc: {
                                                                start: {
                                                                    line: 21,
                                                                    column: 31,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                },
                                                                end: {
                                                                    line: 21,
                                                                    column: 41,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 21,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            },
                                                            end: {
                                                                line: 21,
                                                                column: 41,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            }
                                                        }
                                                    },
                                                    alternate: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'type',
                                                            loc: {
                                                                start: {
                                                                    line: 21,
                                                                    column: 44,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                },
                                                                end: {
                                                                    line: 21,
                                                                    column: 48,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'properties',
                                                            loc: {
                                                                start: {
                                                                    line: 21,
                                                                    column: 49,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                },
                                                                end: {
                                                                    line: 21,
                                                                    column: 59,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 21,
                                                                column: 44,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            },
                                                            end: {
                                                                line: 21,
                                                                column: 59,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            }
                                                        }
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'fixedColumnNames',
                                                    loc: {
                                                        start: {
                                                            line: 22,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                        },
                                                        end: {
                                                            line: 22,
                                                            column: 28,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'ObjectExpression',
                                                    objectType: {
                                                        type: 'ArrayExpression',
                                                        elements: []
                                                    },
                                                    properties: [{
                                                            type: 'IfStatement',
                                                            test: {
                                                                type: 'BinaryExpression',
                                                                operator: '!==',
                                                                left: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'config',
                                                                        loc: {
                                                                            start: {
                                                                                line: 23,
                                                                                column: 19,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                            },
                                                                            end: {
                                                                                line: 23,
                                                                                column: 25,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'selectable',
                                                                        loc: {
                                                                            start: {
                                                                                line: 23,
                                                                                column: 26,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                            },
                                                                            end: {
                                                                                line: 23,
                                                                                column: 36,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 23,
                                                                            column: 19,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                        },
                                                                        end: {
                                                                            line: 23,
                                                                            column: 36,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                        }
                                                                    }
                                                                },
                                                                right: {
                                                                    type: 'Literal',
                                                                    value: false
                                                                }
                                                            },
                                                            consequent: {
                                                                type: 'BlockStatement',
                                                                body: [{
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'ObjectExpression',
                                                                            properties: [
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'columnType',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 24,
                                                                                                column: 21,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 24,
                                                                                                column: 31,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Literal',
                                                                                        value: 'glass/html/material/DataTable2/RowSelectColumn'
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'name',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 24,
                                                                                                column: 82,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 24,
                                                                                                column: 86,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Literal',
                                                                                        value: 'select'
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '1'
                                                                                }
                                                                            ]
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 24,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                            },
                                                                            end: {
                                                                                line: 24,
                                                                                column: 96,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                            }
                                                                        },
                                                                        order: '0'
                                                                    }]
                                                            },
                                                            alternate: null,
                                                            order: '0'
                                                        }]
                                                },
                                                kind: 'init',
                                                order: '1'
                                            },
                                            {
                                                type: 'IfStatement',
                                                test: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'state',
                                                        loc: {
                                                            start: {
                                                                line: 26,
                                                                column: 15,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            },
                                                            end: {
                                                                line: 26,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'timeline',
                                                        loc: {
                                                            start: {
                                                                line: 26,
                                                                column: 21,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            },
                                                            end: {
                                                                line: 26,
                                                                column: 29,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 26,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                        },
                                                        end: {
                                                            line: 26,
                                                            column: 29,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                        }
                                                    }
                                                },
                                                consequent: {
                                                    type: 'BlockStatement',
                                                    body: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'defaultColumnNames',
                                                                loc: {
                                                                    start: {
                                                                        line: 27,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    },
                                                                    end: {
                                                                        line: 27,
                                                                        column: 34,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'ConditionalExpression',
                                                                        test: {
                                                                            type: 'BinaryExpression',
                                                                            operator: '!=',
                                                                            left: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'config',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 27,
                                                                                                column: 37,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 27,
                                                                                                column: 43,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'timeline',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 27,
                                                                                                column: 44,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 27,
                                                                                                column: 52,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 27,
                                                                                            column: 37,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 27,
                                                                                            column: 52,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'columns',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 27,
                                                                                            column: 53,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 27,
                                                                                            column: 60,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 27,
                                                                                        column: 37,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 27,
                                                                                        column: 60,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            right: {
                                                                                type: 'Literal',
                                                                                value: null
                                                                            }
                                                                        },
                                                                        consequent: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'Identifier',
                                                                                    name: 'config',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 27,
                                                                                            column: 37,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 27,
                                                                                            column: 43,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'timeline',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 27,
                                                                                            column: 44,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 27,
                                                                                            column: 52,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 27,
                                                                                        column: 37,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 27,
                                                                                        column: 52,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'columns',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 27,
                                                                                        column: 53,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 27,
                                                                                        column: 60,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 27,
                                                                                    column: 37,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 27,
                                                                                    column: 60,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        alternate: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'config',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 27,
                                                                                        column: 63,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 27,
                                                                                        column: 69,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'columns',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 27,
                                                                                        column: 70,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 27,
                                                                                        column: 77,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 27,
                                                                                    column: 63,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 27,
                                                                                    column: 77,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                }
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'concat',
                                                                        loc: {
                                                                            start: {
                                                                                line: 27,
                                                                                column: 79,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                            },
                                                                            end: {
                                                                                line: 27,
                                                                                column: 85,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 27,
                                                                            column: 36,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                        },
                                                                        end: {
                                                                            line: 27,
                                                                            column: 85,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'ObjectExpression',
                                                                        objectType: {
                                                                            type: 'ArrayExpression',
                                                                            elements: []
                                                                        },
                                                                        properties: [{
                                                                                type: 'ExpressionStatement',
                                                                                expression: {
                                                                                    type: 'ObjectExpression',
                                                                                    properties: [
                                                                                        {
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'columnType',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 29,
                                                                                                        column: 25,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 29,
                                                                                                        column: 35,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'Literal',
                                                                                                value: 'viewpath/html/GanttColumn'
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '0'
                                                                                        },
                                                                                        {
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'name',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 29,
                                                                                                        column: 65,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 29,
                                                                                                        column: 69,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'Literal',
                                                                                                value: 'Timeline'
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '1'
                                                                                        }
                                                                                    ]
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 29,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 29,
                                                                                        column: 82,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                    }
                                                                                },
                                                                                order: '0'
                                                                            }]
                                                                    }],
                                                                loc: {
                                                                    start: {
                                                                        line: 27,
                                                                        column: 36,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    },
                                                                    end: {
                                                                        line: 30,
                                                                        column: 17,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    }
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                },
                                                alternate: {
                                                    type: 'BlockStatement',
                                                    body: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'defaultColumnNames',
                                                                loc: {
                                                                    start: {
                                                                        line: 32,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    },
                                                                    end: {
                                                                        line: 32,
                                                                        column: 34,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'config',
                                                                    loc: {
                                                                        start: {
                                                                            line: 32,
                                                                            column: 36,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                        },
                                                                        end: {
                                                                            line: 32,
                                                                            column: 42,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'columns',
                                                                    loc: {
                                                                        start: {
                                                                            line: 32,
                                                                            column: 43,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                        },
                                                                        end: {
                                                                            line: 32,
                                                                            column: 50,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 32,
                                                                        column: 36,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    },
                                                                    end: {
                                                                        line: 32,
                                                                        column: 50,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    }
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                },
                                                order: '2'
                                            }
                                        ]
                                    }],
                                loc: {
                                    start: {
                                        line: 19,
                                        column: 25,
                                        fixed: true,
                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                    },
                                    end: {
                                        line: 33,
                                        column: 5,
                                        fixed: true,
                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                    }
                                }
                            },
                            properties: [{
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'project',
                                        loc: {
                                            start: {
                                                line: 34,
                                                column: 8,
                                                fixed: true,
                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                            },
                                            end: {
                                                line: 34,
                                                column: 15,
                                                fixed: true,
                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'config',
                                            loc: {
                                                start: {
                                                    line: 34,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                },
                                                end: {
                                                    line: 34,
                                                    column: 23,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'project',
                                            loc: {
                                                start: {
                                                    line: 34,
                                                    column: 24,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                },
                                                end: {
                                                    line: 34,
                                                    column: 31,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 34,
                                                column: 17,
                                                fixed: true,
                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                            },
                                            end: {
                                                line: 34,
                                                column: 31,
                                                fixed: true,
                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '0'
                                }]
                        }
                    }],
                kind: 'let',
                order: '7'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'dataTable',
                            loc: {
                                start: {
                                    line: 36,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                },
                                end: {
                                    line: 36,
                                    column: 17,
                                    fixed: true,
                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'DataTable',
                                loc: {
                                    start: {
                                        line: 36,
                                        column: 20,
                                        fixed: true,
                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                    },
                                    end: {
                                        line: 36,
                                        column: 29,
                                        fixed: true,
                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ObjectExpression',
                                    properties: [{
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'model',
                                                loc: {
                                                    start: {
                                                        line: 36,
                                                        column: 31,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                    },
                                                    end: {
                                                        line: 36,
                                                        column: 36,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Identifier',
                                                name: 'dataTableModel',
                                                loc: {
                                                    start: {
                                                        line: 36,
                                                        column: 38,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                    },
                                                    end: {
                                                        line: 36,
                                                        column: 52,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                    }
                                                }
                                            },
                                            kind: 'init',
                                            order: '0'
                                        }]
                                }],
                            loc: {
                                start: {
                                    line: 36,
                                    column: 20,
                                    fixed: true,
                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                },
                                end: {
                                    line: 36,
                                    column: 54,
                                    fixed: true,
                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '8'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'CallExpression',
                        callee: {
                            type: 'Identifier',
                            name: 'Div',
                            loc: {
                                start: {
                                    line: 38,
                                    column: 11,
                                    fixed: true,
                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                },
                                end: {
                                    line: 38,
                                    column: 14,
                                    fixed: true,
                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                }
                            }
                        },
                        arguments: [{
                                type: 'ObjectExpression',
                                properties: [{
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'class',
                                            loc: {
                                                start: {
                                                    line: 38,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                },
                                                end: {
                                                    line: 38,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: 'layout vertical fill'
                                        },
                                        kind: 'init',
                                        order: '0'
                                    }]
                            }],
                        loc: {
                            start: {
                                line: 38,
                                column: 11,
                                fixed: true,
                                source: 'viewpath/html/panes/GenericTypeView.ion'
                            },
                            end: {
                                line: 38,
                                column: 46,
                                fixed: true,
                                source: 'viewpath/html/panes/GenericTypeView.ion'
                            }
                        }
                    },
                    properties: [
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'hasSelection',
                                        loc: {
                                            start: {
                                                line: 39,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                            },
                                            end: {
                                                line: 39,
                                                column: 24,
                                                fixed: true,
                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'dataTableModel',
                                            loc: {
                                                start: {
                                                    line: 39,
                                                    column: 27,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                },
                                                end: {
                                                    line: 39,
                                                    column: 41,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'hasSelection',
                                            loc: {
                                                start: {
                                                    line: 39,
                                                    column: 42,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                },
                                                end: {
                                                    line: 39,
                                                    column: 54,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 39,
                                                column: 27,
                                                fixed: true,
                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                            },
                                            end: {
                                                line: 39,
                                                column: 54,
                                                fixed: true,
                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '0'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'rowsSelected',
                                        loc: {
                                            start: {
                                                line: 40,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                            },
                                            end: {
                                                line: 40,
                                                column: 24,
                                                fixed: true,
                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'BinaryExpression',
                                        operator: '&&',
                                        left: {
                                            type: 'Identifier',
                                            name: 'hasSelection',
                                            loc: {
                                                start: {
                                                    line: 40,
                                                    column: 27,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                },
                                                end: {
                                                    line: 40,
                                                    column: 39,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                }
                                            }
                                        },
                                        right: {
                                            type: 'BinaryExpression',
                                            operator: '===',
                                            left: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'dataTableModel',
                                                        loc: {
                                                            start: {
                                                                line: 40,
                                                                column: 44,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            },
                                                            end: {
                                                                line: 40,
                                                                column: 58,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'selectedColumns',
                                                        loc: {
                                                            start: {
                                                                line: 40,
                                                                column: 59,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            },
                                                            end: {
                                                                line: 40,
                                                                column: 74,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 40,
                                                            column: 44,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                        },
                                                        end: {
                                                            line: 40,
                                                            column: 74,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'length',
                                                    loc: {
                                                        start: {
                                                            line: 40,
                                                            column: 75,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                        },
                                                        end: {
                                                            line: 40,
                                                            column: 81,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 40,
                                                        column: 44,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                    },
                                                    end: {
                                                        line: 40,
                                                        column: 81,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                    }
                                                }
                                            },
                                            right: {
                                                type: 'Literal',
                                                value: 0
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '1'
                        },
                        {
                            type: 'IfStatement',
                            test: {
                                type: 'UnaryExpression',
                                operator: '?',
                                argument: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'config',
                                        loc: {
                                            start: {
                                                line: 42,
                                                column: 11,
                                                fixed: true,
                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                            },
                                            end: {
                                                line: 42,
                                                column: 17,
                                                fixed: true,
                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'header',
                                        loc: {
                                            start: {
                                                line: 42,
                                                column: 18,
                                                fixed: true,
                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                            },
                                            end: {
                                                line: 42,
                                                column: 24,
                                                fixed: true,
                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 42,
                                            column: 11,
                                            fixed: true,
                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                        },
                                        end: {
                                            line: 42,
                                            column: 24,
                                            fixed: true,
                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                        }
                                    }
                                }
                            },
                            consequent: {
                                type: 'BlockStatement',
                                body: [{
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'config',
                                                    loc: {
                                                        start: {
                                                            line: 43,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                        },
                                                        end: {
                                                            line: 43,
                                                            column: 18,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'header',
                                                    loc: {
                                                        start: {
                                                            line: 43,
                                                            column: 19,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                        },
                                                        end: {
                                                            line: 43,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 43,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                    },
                                                    end: {
                                                        line: 43,
                                                        column: 25,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                    }
                                                }
                                            },
                                            arguments: [{
                                                    type: 'ObjectExpression',
                                                    properties: [
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'dataTable',
                                                                loc: {
                                                                    start: {
                                                                        line: 43,
                                                                        column: 27,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    },
                                                                    end: {
                                                                        line: 43,
                                                                        column: 36,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Identifier',
                                                                name: 'dataTable',
                                                                loc: {
                                                                    start: {
                                                                        line: 43,
                                                                        column: 27,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    },
                                                                    end: {
                                                                        line: 43,
                                                                        column: 36,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    }
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        },
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'dataTableModel',
                                                                loc: {
                                                                    start: {
                                                                        line: 43,
                                                                        column: 37,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    },
                                                                    end: {
                                                                        line: 43,
                                                                        column: 51,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Identifier',
                                                                name: 'dataTableModel',
                                                                loc: {
                                                                    start: {
                                                                        line: 43,
                                                                        column: 37,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    },
                                                                    end: {
                                                                        line: 43,
                                                                        column: 51,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    }
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '1'
                                                        }
                                                    ]
                                                }],
                                            loc: {
                                                start: {
                                                    line: 43,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                },
                                                end: {
                                                    line: 43,
                                                    column: 53,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 43,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                            },
                                            end: {
                                                line: 43,
                                                column: 53,
                                                fixed: true,
                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                            }
                                        },
                                        order: '0'
                                    }]
                            },
                            alternate: null,
                            order: '2'
                        },
                        {
                            type: 'IfStatement',
                            test: {
                                type: 'BinaryExpression',
                                operator: '!==',
                                left: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'config',
                                        loc: {
                                            start: {
                                                line: 45,
                                                column: 11,
                                                fixed: true,
                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                            },
                                            end: {
                                                line: 45,
                                                column: 17,
                                                fixed: true,
                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'toolbar',
                                        loc: {
                                            start: {
                                                line: 45,
                                                column: 18,
                                                fixed: true,
                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                            },
                                            end: {
                                                line: 45,
                                                column: 25,
                                                fixed: true,
                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 45,
                                            column: 11,
                                            fixed: true,
                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                        },
                                        end: {
                                            line: 45,
                                            column: 25,
                                            fixed: true,
                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: false
                                }
                            },
                            consequent: {
                                type: 'BlockStatement',
                                body: [{
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'ObjectExpression',
                                            objectType: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'Toolbar',
                                                    loc: {
                                                        start: {
                                                            line: 46,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                        },
                                                        end: {
                                                            line: 46,
                                                            column: 19,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [],
                                                loc: {
                                                    start: {
                                                        line: 46,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                    },
                                                    end: {
                                                        line: 46,
                                                        column: 21,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                    }
                                                }
                                            },
                                            properties: [
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'Identifier',
                                                            name: 'Div',
                                                            loc: {
                                                                start: {
                                                                    line: 47,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                },
                                                                end: {
                                                                    line: 47,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [],
                                                        loc: {
                                                            start: {
                                                                line: 47,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            },
                                                            end: {
                                                                line: 47,
                                                                column: 21,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 47,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                        },
                                                        end: {
                                                            line: 47,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                },
                                                {
                                                    type: 'IfStatement',
                                                    test: {
                                                        type: 'UnaryExpression',
                                                        operator: '?',
                                                        argument: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'config',
                                                                    loc: {
                                                                        start: {
                                                                            line: 48,
                                                                            column: 19,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                        },
                                                                        end: {
                                                                            line: 48,
                                                                            column: 25,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'toolbar',
                                                                    loc: {
                                                                        start: {
                                                                            line: 48,
                                                                            column: 26,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                        },
                                                                        end: {
                                                                            line: 48,
                                                                            column: 33,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 48,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    },
                                                                    end: {
                                                                        line: 48,
                                                                        column: 33,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'left',
                                                                loc: {
                                                                    start: {
                                                                        line: 48,
                                                                        column: 35,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    },
                                                                    end: {
                                                                        line: 48,
                                                                        column: 39,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    }
                                                                }
                                                            },
                                                            existential: true,
                                                            loc: {
                                                                start: {
                                                                    line: 48,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                },
                                                                end: {
                                                                    line: 48,
                                                                    column: 39,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                }
                                                            }
                                                        }
                                                    },
                                                    consequent: {
                                                        type: 'BlockStatement',
                                                        body: [{
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'config',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 49,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 49,
                                                                                        column: 26,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'toolbar',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 49,
                                                                                        column: 27,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 49,
                                                                                        column: 34,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 49,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 49,
                                                                                    column: 34,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'left',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 49,
                                                                                    column: 35,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 49,
                                                                                    column: 39,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 49,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                            },
                                                                            end: {
                                                                                line: 49,
                                                                                column: 39,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [{
                                                                            type: 'ObjectExpression',
                                                                            properties: [
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'dataTable',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 49,
                                                                                                column: 41,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 49,
                                                                                                column: 50,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Identifier',
                                                                                        name: 'dataTable',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 49,
                                                                                                column: 41,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 49,
                                                                                                column: 50,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'dataTableModel',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 49,
                                                                                                column: 51,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 49,
                                                                                                column: 65,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Identifier',
                                                                                        name: 'dataTableModel',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 49,
                                                                                                column: 51,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 49,
                                                                                                column: 65,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '1'
                                                                                }
                                                                            ]
                                                                        }],
                                                                    loc: {
                                                                        start: {
                                                                            line: 49,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                        },
                                                                        end: {
                                                                            line: 49,
                                                                            column: 67,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 49,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    },
                                                                    end: {
                                                                        line: 49,
                                                                        column: 67,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    alternate: null,
                                                    order: '1'
                                                },
                                                {
                                                    type: 'IfStatement',
                                                    test: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'config',
                                                            loc: {
                                                                start: {
                                                                    line: 50,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                },
                                                                end: {
                                                                    line: 50,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'create',
                                                            loc: {
                                                                start: {
                                                                    line: 50,
                                                                    column: 26,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                },
                                                                end: {
                                                                    line: 50,
                                                                    column: 32,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 50,
                                                                column: 19,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            },
                                                            end: {
                                                                line: 50,
                                                                column: 32,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            }
                                                        }
                                                    },
                                                    consequent: {
                                                        type: 'BlockStatement',
                                                        body: [{
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'ObjectExpression',
                                                                    objectType: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'Identifier',
                                                                            name: 'PaperIconButton',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 51,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 51,
                                                                                    column: 35,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [],
                                                                        loc: {
                                                                            start: {
                                                                                line: 51,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                            },
                                                                            end: {
                                                                                line: 51,
                                                                                column: 37,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    properties: [
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'icon',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 52,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 52,
                                                                                        column: 28,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'add'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'title',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 53,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 53,
                                                                                        column: 29,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'ConditionalExpression',
                                                                                test: {
                                                                                    type: 'BinaryExpression',
                                                                                    operator: '!=',
                                                                                    left: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'MemberExpression',
                                                                                            computed: false,
                                                                                            object: {
                                                                                                type: 'Identifier',
                                                                                                name: 'config',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 53,
                                                                                                        column: 31,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 53,
                                                                                                        column: 37,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            property: {
                                                                                                type: 'Identifier',
                                                                                                name: 'create',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 53,
                                                                                                        column: 38,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 53,
                                                                                                        column: 44,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 53,
                                                                                                    column: 31,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 53,
                                                                                                    column: 44,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'title',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 53,
                                                                                                    column: 45,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 53,
                                                                                                    column: 50,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 53,
                                                                                                column: 31,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 53,
                                                                                                column: 50,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    right: {
                                                                                        type: 'Literal',
                                                                                        value: null
                                                                                    }
                                                                                },
                                                                                consequent: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'config',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 53,
                                                                                                    column: 31,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 53,
                                                                                                    column: 37,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'create',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 53,
                                                                                                    column: 38,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 53,
                                                                                                    column: 44,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 53,
                                                                                                column: 31,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 53,
                                                                                                column: 44,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'title',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 53,
                                                                                                column: 45,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 53,
                                                                                                column: 50,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 53,
                                                                                            column: 31,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 53,
                                                                                            column: 50,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                alternate: {
                                                                                    type: 'BinaryExpression',
                                                                                    operator: '+',
                                                                                    left: {
                                                                                        type: 'Literal',
                                                                                        value: 'Add '
                                                                                    },
                                                                                    right: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'type',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 53,
                                                                                                    column: 60,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 53,
                                                                                                    column: 64,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'name',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 53,
                                                                                                    column: 65,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 53,
                                                                                                    column: 69,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 53,
                                                                                                column: 60,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 53,
                                                                                                column: 69,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                }
                                                                            },
                                                                            kind: 'init',
                                                                            order: '1'
                                                                        },
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'disabled',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 54,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 54,
                                                                                        column: 32,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'BinaryExpression',
                                                                                operator: '===',
                                                                                left: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'config',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 54,
                                                                                                column: 34,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 54,
                                                                                                column: 40,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'editable',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 54,
                                                                                                column: 41,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 54,
                                                                                                column: 49,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 54,
                                                                                            column: 34,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 54,
                                                                                            column: 49,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                right: {
                                                                                    type: 'Literal',
                                                                                    value: false
                                                                                }
                                                                            },
                                                                            kind: 'init',
                                                                            order: '2'
                                                                        },
                                                                        {
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'Function',
                                                                                context: true,
                                                                                value: function (_context2) {
                                                                                    return function click(e) {
                                                                                        var config = _context2.get('config'), dataTable = _context2.get('dataTable'), dataTableModel = _context2.get('dataTableModel');
                                                                                        if (config.create.handler != null) {
                                                                                            config.create.handler({
                                                                                                e: e,
                                                                                                dataTable: dataTable,
                                                                                                dataTableModel: dataTableModel
                                                                                            });
                                                                                        } else {
                                                                                            dataTableModel.createRecord(config.create.properties != null ? config.create.properties : {});
                                                                                        }
                                                                                    };
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 55,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 60,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                }
                                                                            },
                                                                            order: '3'
                                                                        }
                                                                    ]
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 51,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    },
                                                                    end: {
                                                                        line: 60,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    alternate: null,
                                                    order: '2'
                                                },
                                                {
                                                    type: 'IfStatement',
                                                    test: {
                                                        type: 'BinaryExpression',
                                                        operator: '!==',
                                                        left: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'config',
                                                                loc: {
                                                                    start: {
                                                                        line: 60,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    },
                                                                    end: {
                                                                        line: 60,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'standardControls',
                                                                loc: {
                                                                    start: {
                                                                        line: 60,
                                                                        column: 26,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    },
                                                                    end: {
                                                                        line: 60,
                                                                        column: 42,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 60,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                },
                                                                end: {
                                                                    line: 60,
                                                                    column: 42,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                }
                                                            }
                                                        },
                                                        right: {
                                                            type: 'Literal',
                                                            value: false
                                                        }
                                                    },
                                                    consequent: {
                                                        type: 'BlockStatement',
                                                        body: [
                                                            {
                                                                type: 'IfStatement',
                                                                test: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '&&',
                                                                    left: {
                                                                        type: 'BinaryExpression',
                                                                        operator: '!==',
                                                                        left: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'config',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 61,
                                                                                        column: 23,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 61,
                                                                                        column: 29,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'delete',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 61,
                                                                                        column: 30,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 61,
                                                                                        column: 36,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 61,
                                                                                    column: 23,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 61,
                                                                                    column: 36,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        right: {
                                                                            type: 'Literal',
                                                                            value: false
                                                                        }
                                                                    },
                                                                    right: {
                                                                        type: 'BinaryExpression',
                                                                        operator: '!==',
                                                                        left: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'config',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 61,
                                                                                        column: 52,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 61,
                                                                                        column: 58,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'cut',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 61,
                                                                                        column: 59,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 61,
                                                                                        column: 62,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 61,
                                                                                    column: 52,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 61,
                                                                                    column: 62,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        right: {
                                                                            type: 'Literal',
                                                                            value: false
                                                                        }
                                                                    }
                                                                },
                                                                consequent: {
                                                                    type: 'BlockStatement',
                                                                    body: [{
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'ObjectExpression',
                                                                                objectType: {
                                                                                    type: 'CallExpression',
                                                                                    callee: {
                                                                                        type: 'Identifier',
                                                                                        name: 'PaperIconButton',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 62,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 62,
                                                                                                column: 39,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    arguments: [],
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 62,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 62,
                                                                                            column: 41,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                properties: [
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'icon',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 63,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 63,
                                                                                                    column: 32,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 'content-cut'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'title',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 64,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 64,
                                                                                                    column: 33,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'BinaryExpression',
                                                                                            operator: '+',
                                                                                            left: {
                                                                                                type: 'Literal',
                                                                                                value: 'Cut Selected '
                                                                                            },
                                                                                            right: {
                                                                                                type: 'ConditionalExpression',
                                                                                                test: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'rowsSelected',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 64,
                                                                                                            column: 54,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 64,
                                                                                                            column: 66,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                consequent: {
                                                                                                    type: 'BinaryExpression',
                                                                                                    operator: '+',
                                                                                                    left: {
                                                                                                        type: 'BinaryExpression',
                                                                                                        operator: '+',
                                                                                                        left: {
                                                                                                            type: 'Literal',
                                                                                                            value: ''
                                                                                                        },
                                                                                                        right: {
                                                                                                            type: 'MemberExpression',
                                                                                                            computed: false,
                                                                                                            object: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'type',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 64,
                                                                                                                        column: 72,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 64,
                                                                                                                        column: 76,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            property: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'name',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 64,
                                                                                                                        column: 77,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 64,
                                                                                                                        column: 81,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 64,
                                                                                                                    column: 72,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 64,
                                                                                                                    column: 81,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    right: {
                                                                                                        type: 'Literal',
                                                                                                        value: '(s)'
                                                                                                    }
                                                                                                },
                                                                                                alternate: {
                                                                                                    type: 'Literal',
                                                                                                    value: 'Cells'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '1'
                                                                                    },
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'disabled',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 65,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 65,
                                                                                                    column: 36,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'BinaryExpression',
                                                                                            operator: '||',
                                                                                            left: {
                                                                                                type: 'UnaryExpression',
                                                                                                operator: '!',
                                                                                                argument: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'hasSelection',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 65,
                                                                                                            column: 42,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 65,
                                                                                                            column: 54,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                        }
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            right: {
                                                                                                type: 'BinaryExpression',
                                                                                                operator: '===',
                                                                                                left: {
                                                                                                    type: 'MemberExpression',
                                                                                                    computed: false,
                                                                                                    object: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'config',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 65,
                                                                                                                column: 58,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 65,
                                                                                                                column: 64,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    property: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'editable',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 65,
                                                                                                                column: 65,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 65,
                                                                                                                column: 73,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 65,
                                                                                                            column: 58,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 65,
                                                                                                            column: 73,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                right: {
                                                                                                    type: 'Literal',
                                                                                                    value: false
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '2'
                                                                                    },
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'Function',
                                                                                            context: true,
                                                                                            value: function (_context3) {
                                                                                                return function click(e) {
                                                                                                    var dataTableModel = _context3.get('dataTableModel');
                                                                                                    return dataTableModel.cutSelection();
                                                                                                };
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 66,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 66,
                                                                                                column: 69,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '3'
                                                                                    }
                                                                                ]
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 62,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 67,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                alternate: null,
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'IfStatement',
                                                                test: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '!==',
                                                                    left: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'config',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 67,
                                                                                    column: 23,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 67,
                                                                                    column: 29,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'copy',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 67,
                                                                                    column: 30,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 67,
                                                                                    column: 34,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 67,
                                                                                column: 23,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                            },
                                                                            end: {
                                                                                line: 67,
                                                                                column: 34,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    right: {
                                                                        type: 'Literal',
                                                                        value: false
                                                                    }
                                                                },
                                                                consequent: {
                                                                    type: 'BlockStatement',
                                                                    body: [{
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'ObjectExpression',
                                                                                objectType: {
                                                                                    type: 'CallExpression',
                                                                                    callee: {
                                                                                        type: 'Identifier',
                                                                                        name: 'PaperIconButton',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 68,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 68,
                                                                                                column: 39,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    arguments: [],
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 68,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 68,
                                                                                            column: 41,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                properties: [
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'icon',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 69,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 69,
                                                                                                    column: 32,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 'content-copy'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'title',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 70,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 70,
                                                                                                    column: 33,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'BinaryExpression',
                                                                                            operator: '+',
                                                                                            left: {
                                                                                                type: 'Literal',
                                                                                                value: 'Copy Selected '
                                                                                            },
                                                                                            right: {
                                                                                                type: 'ConditionalExpression',
                                                                                                test: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'rowsSelected',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 70,
                                                                                                            column: 55,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 70,
                                                                                                            column: 67,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                consequent: {
                                                                                                    type: 'BinaryExpression',
                                                                                                    operator: '+',
                                                                                                    left: {
                                                                                                        type: 'BinaryExpression',
                                                                                                        operator: '+',
                                                                                                        left: {
                                                                                                            type: 'Literal',
                                                                                                            value: ''
                                                                                                        },
                                                                                                        right: {
                                                                                                            type: 'MemberExpression',
                                                                                                            computed: false,
                                                                                                            object: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'type',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 70,
                                                                                                                        column: 73,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 70,
                                                                                                                        column: 77,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            property: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'name',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 70,
                                                                                                                        column: 78,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 70,
                                                                                                                        column: 82,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 70,
                                                                                                                    column: 73,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 70,
                                                                                                                    column: 82,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    right: {
                                                                                                        type: 'Literal',
                                                                                                        value: '(s)'
                                                                                                    }
                                                                                                },
                                                                                                alternate: {
                                                                                                    type: 'Literal',
                                                                                                    value: 'Cells'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '1'
                                                                                    },
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'disabled',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 71,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 71,
                                                                                                    column: 36,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'UnaryExpression',
                                                                                            operator: '!',
                                                                                            argument: {
                                                                                                type: 'Identifier',
                                                                                                name: 'hasSelection',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 71,
                                                                                                        column: 42,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 71,
                                                                                                        column: 54,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '2'
                                                                                    },
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'Function',
                                                                                            context: true,
                                                                                            value: function (_context4) {
                                                                                                return function click(e) {
                                                                                                    var dataTableModel = _context4.get('dataTableModel');
                                                                                                    return dataTableModel.copySelection();
                                                                                                };
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 72,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 72,
                                                                                                column: 70,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '3'
                                                                                    }
                                                                                ]
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 68,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 73,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                alternate: null,
                                                                order: '1'
                                                            },
                                                            {
                                                                type: 'IfStatement',
                                                                test: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '!==',
                                                                    left: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'config',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 73,
                                                                                    column: 23,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 73,
                                                                                    column: 29,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'paste',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 73,
                                                                                    column: 30,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 73,
                                                                                    column: 35,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 73,
                                                                                column: 23,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                            },
                                                                            end: {
                                                                                line: 73,
                                                                                column: 35,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    right: {
                                                                        type: 'Literal',
                                                                        value: false
                                                                    }
                                                                },
                                                                consequent: {
                                                                    type: 'BlockStatement',
                                                                    body: [{
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'ObjectExpression',
                                                                                objectType: {
                                                                                    type: 'CallExpression',
                                                                                    callee: {
                                                                                        type: 'Identifier',
                                                                                        name: 'PaperIconButton',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 74,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 74,
                                                                                                column: 39,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    arguments: [],
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 74,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 74,
                                                                                            column: 41,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                properties: [
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'icon',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 75,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 75,
                                                                                                    column: 32,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 'content-paste'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'title',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 76,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 76,
                                                                                                    column: 33,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'BinaryExpression',
                                                                                            operator: '+',
                                                                                            left: {
                                                                                                type: 'Literal',
                                                                                                value: 'Paste Copied '
                                                                                            },
                                                                                            right: {
                                                                                                type: 'ConditionalExpression',
                                                                                                test: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'rowsSelected',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 76,
                                                                                                            column: 54,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 76,
                                                                                                            column: 66,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                consequent: {
                                                                                                    type: 'BinaryExpression',
                                                                                                    operator: '+',
                                                                                                    left: {
                                                                                                        type: 'BinaryExpression',
                                                                                                        operator: '+',
                                                                                                        left: {
                                                                                                            type: 'Literal',
                                                                                                            value: ''
                                                                                                        },
                                                                                                        right: {
                                                                                                            type: 'MemberExpression',
                                                                                                            computed: false,
                                                                                                            object: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'type',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 76,
                                                                                                                        column: 72,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 76,
                                                                                                                        column: 76,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            property: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'name',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 76,
                                                                                                                        column: 77,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 76,
                                                                                                                        column: 81,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 76,
                                                                                                                    column: 72,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 76,
                                                                                                                    column: 81,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    right: {
                                                                                                        type: 'Literal',
                                                                                                        value: '(s)'
                                                                                                    }
                                                                                                },
                                                                                                alternate: {
                                                                                                    type: 'Literal',
                                                                                                    value: 'Cells'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '1'
                                                                                    },
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'disabled',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 77,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 77,
                                                                                                    column: 36,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'BinaryExpression',
                                                                                            operator: '||',
                                                                                            left: {
                                                                                                type: 'UnaryExpression',
                                                                                                operator: '!',
                                                                                                argument: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'hasSelection',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 77,
                                                                                                            column: 42,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 77,
                                                                                                            column: 54,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                        }
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            right: {
                                                                                                type: 'BinaryExpression',
                                                                                                operator: '===',
                                                                                                left: {
                                                                                                    type: 'MemberExpression',
                                                                                                    computed: false,
                                                                                                    object: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'config',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 77,
                                                                                                                column: 58,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 77,
                                                                                                                column: 64,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    property: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'editable',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 77,
                                                                                                                column: 65,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 77,
                                                                                                                column: 73,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 77,
                                                                                                            column: 58,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 77,
                                                                                                            column: 73,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                right: {
                                                                                                    type: 'Literal',
                                                                                                    value: false
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '2'
                                                                                    },
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'Function',
                                                                                            context: true,
                                                                                            value: function (_context5) {
                                                                                                return function click(e) {
                                                                                                    var dataTableModel = _context5.get('dataTableModel');
                                                                                                    return dataTableModel.pasteSelection();
                                                                                                };
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 78,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 78,
                                                                                                column: 71,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '3'
                                                                                    }
                                                                                ]
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 74,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 79,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                alternate: null,
                                                                order: '2'
                                                            },
                                                            {
                                                                type: 'IfStatement',
                                                                test: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '!==',
                                                                    left: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'config',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 79,
                                                                                    column: 23,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 79,
                                                                                    column: 29,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'delete',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 79,
                                                                                    column: 30,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 79,
                                                                                    column: 36,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 79,
                                                                                column: 23,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                            },
                                                                            end: {
                                                                                line: 79,
                                                                                column: 36,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    right: {
                                                                        type: 'Literal',
                                                                        value: false
                                                                    }
                                                                },
                                                                consequent: {
                                                                    type: 'BlockStatement',
                                                                    body: [{
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'ObjectExpression',
                                                                                objectType: {
                                                                                    type: 'CallExpression',
                                                                                    callee: {
                                                                                        type: 'Identifier',
                                                                                        name: 'PaperIconButton',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 80,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 80,
                                                                                                column: 39,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    arguments: [],
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 80,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 80,
                                                                                            column: 41,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                properties: [
                                                                                    {
                                                                                        type: 'IfStatement',
                                                                                        test: {
                                                                                            type: 'UnaryExpression',
                                                                                            operator: '?',
                                                                                            argument: {
                                                                                                type: 'MemberExpression',
                                                                                                computed: false,
                                                                                                object: {
                                                                                                    type: 'MemberExpression',
                                                                                                    computed: false,
                                                                                                    object: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'config',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 81,
                                                                                                                column: 31,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 81,
                                                                                                                column: 37,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    property: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'delete',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 81,
                                                                                                                column: 38,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 81,
                                                                                                                column: 44,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 81,
                                                                                                            column: 31,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 81,
                                                                                                            column: 44,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'title',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 81,
                                                                                                            column: 46,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 81,
                                                                                                            column: 51,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                existential: true,
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 81,
                                                                                                        column: 31,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 81,
                                                                                                        column: 51,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        consequent: {
                                                                                            type: 'BlockStatement',
                                                                                            body: [{
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'title',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 82,
                                                                                                                column: 32,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 82,
                                                                                                                column: 37,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'MemberExpression',
                                                                                                        computed: false,
                                                                                                        object: {
                                                                                                            type: 'MemberExpression',
                                                                                                            computed: false,
                                                                                                            object: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'config',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 82,
                                                                                                                        column: 39,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 82,
                                                                                                                        column: 45,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            property: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'delete',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 82,
                                                                                                                        column: 46,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 82,
                                                                                                                        column: 52,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 82,
                                                                                                                    column: 39,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 82,
                                                                                                                    column: 52,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        property: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'title',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 82,
                                                                                                                    column: 53,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 82,
                                                                                                                    column: 58,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 82,
                                                                                                                column: 39,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 82,
                                                                                                                column: 58,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '0'
                                                                                                }]
                                                                                        },
                                                                                        alternate: null,
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'icon',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 83,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 83,
                                                                                                    column: 32,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 'delete'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '1'
                                                                                    },
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'title',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 84,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 84,
                                                                                                    column: 33,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'BinaryExpression',
                                                                                            operator: '+',
                                                                                            left: {
                                                                                                type: 'Literal',
                                                                                                value: 'Delete Selected '
                                                                                            },
                                                                                            right: {
                                                                                                type: 'ConditionalExpression',
                                                                                                test: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'rowsSelected',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 84,
                                                                                                            column: 57,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 84,
                                                                                                            column: 69,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                consequent: {
                                                                                                    type: 'BinaryExpression',
                                                                                                    operator: '+',
                                                                                                    left: {
                                                                                                        type: 'BinaryExpression',
                                                                                                        operator: '+',
                                                                                                        left: {
                                                                                                            type: 'Literal',
                                                                                                            value: ''
                                                                                                        },
                                                                                                        right: {
                                                                                                            type: 'MemberExpression',
                                                                                                            computed: false,
                                                                                                            object: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'type',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 84,
                                                                                                                        column: 75,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 84,
                                                                                                                        column: 79,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            property: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'name',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 84,
                                                                                                                        column: 80,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 84,
                                                                                                                        column: 84,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 84,
                                                                                                                    column: 75,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 84,
                                                                                                                    column: 84,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    right: {
                                                                                                        type: 'Literal',
                                                                                                        value: '(s)'
                                                                                                    }
                                                                                                },
                                                                                                alternate: {
                                                                                                    type: 'Literal',
                                                                                                    value: 'Cells'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '2'
                                                                                    },
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'disabled',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 85,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 85,
                                                                                                    column: 36,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'BinaryExpression',
                                                                                            operator: '||',
                                                                                            left: {
                                                                                                type: 'UnaryExpression',
                                                                                                operator: '!',
                                                                                                argument: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'hasSelection',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 85,
                                                                                                            column: 42,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 85,
                                                                                                            column: 54,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                        }
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            right: {
                                                                                                type: 'BinaryExpression',
                                                                                                operator: '===',
                                                                                                left: {
                                                                                                    type: 'MemberExpression',
                                                                                                    computed: false,
                                                                                                    object: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'config',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 85,
                                                                                                                column: 58,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 85,
                                                                                                                column: 64,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    property: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'editable',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 85,
                                                                                                                column: 65,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 85,
                                                                                                                column: 73,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 85,
                                                                                                            column: 58,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 85,
                                                                                                            column: 73,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                right: {
                                                                                                    type: 'Literal',
                                                                                                    value: false
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '3'
                                                                                    },
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'Function',
                                                                                            context: true,
                                                                                            value: function (_context6) {
                                                                                                return function click(e) {
                                                                                                    var config = _context6.get('config'), dataTable = _context6.get('dataTable'), dataTableModel = _context6.get('dataTableModel');
                                                                                                    if ((config.delete != null ? config.delete.handler : void 0) != null) {
                                                                                                        config.delete.handler({
                                                                                                            e: e,
                                                                                                            dataTable: dataTable,
                                                                                                            dataTableModel: dataTableModel
                                                                                                        });
                                                                                                    } else {
                                                                                                        dataTableModel.deleteSelectedRows();
                                                                                                    }
                                                                                                };
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 86,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 92,
                                                                                                column: 32,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '4'
                                                                                    }
                                                                                ]
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 80,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 92,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                alternate: null,
                                                                order: '3'
                                                            }
                                                        ]
                                                    },
                                                    alternate: null,
                                                    order: '3'
                                                },
                                                {
                                                    type: 'IfStatement',
                                                    test: {
                                                        type: 'UnaryExpression',
                                                        operator: '?',
                                                        argument: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'config',
                                                                    loc: {
                                                                        start: {
                                                                            line: 92,
                                                                            column: 19,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                        },
                                                                        end: {
                                                                            line: 92,
                                                                            column: 25,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'toolbar',
                                                                    loc: {
                                                                        start: {
                                                                            line: 92,
                                                                            column: 26,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                        },
                                                                        end: {
                                                                            line: 92,
                                                                            column: 33,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 92,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    },
                                                                    end: {
                                                                        line: 92,
                                                                        column: 33,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'center',
                                                                loc: {
                                                                    start: {
                                                                        line: 92,
                                                                        column: 35,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    },
                                                                    end: {
                                                                        line: 92,
                                                                        column: 41,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    }
                                                                }
                                                            },
                                                            existential: true,
                                                            loc: {
                                                                start: {
                                                                    line: 92,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                },
                                                                end: {
                                                                    line: 92,
                                                                    column: 41,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                }
                                                            }
                                                        }
                                                    },
                                                    consequent: {
                                                        type: 'BlockStatement',
                                                        body: [{
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'config',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 93,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 93,
                                                                                        column: 26,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'toolbar',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 93,
                                                                                        column: 27,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 93,
                                                                                        column: 34,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 93,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 93,
                                                                                    column: 34,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'center',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 93,
                                                                                    column: 35,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 93,
                                                                                    column: 41,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 93,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                            },
                                                                            end: {
                                                                                line: 93,
                                                                                column: 41,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [{
                                                                            type: 'ObjectExpression',
                                                                            properties: [
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'dataTable',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 93,
                                                                                                column: 43,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 93,
                                                                                                column: 52,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Identifier',
                                                                                        name: 'dataTable',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 93,
                                                                                                column: 43,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 93,
                                                                                                column: 52,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'dataTableModel',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 93,
                                                                                                column: 53,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 93,
                                                                                                column: 67,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Identifier',
                                                                                        name: 'dataTableModel',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 93,
                                                                                                column: 53,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 93,
                                                                                                column: 67,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '1'
                                                                                }
                                                                            ]
                                                                        }],
                                                                    loc: {
                                                                        start: {
                                                                            line: 93,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                        },
                                                                        end: {
                                                                            line: 93,
                                                                            column: 69,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 93,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    },
                                                                    end: {
                                                                        line: 93,
                                                                        column: 69,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    alternate: null,
                                                    order: '4'
                                                },
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'Identifier',
                                                            name: 'Div',
                                                            loc: {
                                                                start: {
                                                                    line: 95,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                },
                                                                end: {
                                                                    line: 95,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [{
                                                                type: 'ObjectExpression',
                                                                properties: [{
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'class',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 95,
                                                                                    column: 21,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 95,
                                                                                    column: 26,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Literal',
                                                                            value: 'fill'
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    }]
                                                            }],
                                                        loc: {
                                                            start: {
                                                                line: 95,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            },
                                                            end: {
                                                                line: 95,
                                                                column: 35,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 95,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                        },
                                                        end: {
                                                            line: 95,
                                                            column: 35,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                        }
                                                    },
                                                    order: '5'
                                                },
                                                {
                                                    type: 'IfStatement',
                                                    test: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'config',
                                                            loc: {
                                                                start: {
                                                                    line: 97,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                },
                                                                end: {
                                                                    line: 97,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'timeline',
                                                            loc: {
                                                                start: {
                                                                    line: 97,
                                                                    column: 26,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                },
                                                                end: {
                                                                    line: 97,
                                                                    column: 34,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 97,
                                                                column: 19,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            },
                                                            end: {
                                                                line: 97,
                                                                column: 34,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                            }
                                                        }
                                                    },
                                                    consequent: {
                                                        type: 'BlockStatement',
                                                        body: [
                                                            {
                                                                type: 'IfStatement',
                                                                test: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '===',
                                                                    left: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'state',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 98,
                                                                                    column: 23,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 98,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'timeline',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 98,
                                                                                    column: 29,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 98,
                                                                                    column: 37,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 98,
                                                                                column: 23,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                            },
                                                                            end: {
                                                                                line: 98,
                                                                                column: 37,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    right: {
                                                                        type: 'Literal',
                                                                        value: true
                                                                    }
                                                                },
                                                                consequent: {
                                                                    type: 'BlockStatement',
                                                                    body: [
                                                                        {
                                                                            type: 'VariableDeclaration',
                                                                            declarations: [{
                                                                                    type: 'VariableDeclarator',
                                                                                    id: {
                                                                                        type: 'Identifier',
                                                                                        name: 'timelineColumn',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 99,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 99,
                                                                                                column: 42,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    init: {
                                                                                        type: 'CallExpression',
                                                                                        callee: {
                                                                                            type: 'MemberExpression',
                                                                                            computed: false,
                                                                                            object: {
                                                                                                type: 'Identifier',
                                                                                                name: 'dataTableModel',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 99,
                                                                                                        column: 45,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 99,
                                                                                                        column: 59,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            property: {
                                                                                                type: 'Identifier',
                                                                                                name: 'getColumn',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 99,
                                                                                                        column: 60,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 99,
                                                                                                        column: 69,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 99,
                                                                                                    column: 45,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 99,
                                                                                                    column: 69,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        arguments: [
                                                                                            {
                                                                                                type: 'Literal',
                                                                                                value: 'Timeline'
                                                                                            },
                                                                                            {
                                                                                                type: 'MemberExpression',
                                                                                                computed: false,
                                                                                                object: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'dataTableModel',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 99,
                                                                                                            column: 82,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 99,
                                                                                                            column: 96,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'columns',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 99,
                                                                                                            column: 97,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 99,
                                                                                                            column: 104,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 99,
                                                                                                        column: 82,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 99,
                                                                                                        column: 104,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        ],
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 99,
                                                                                                column: 45,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 99,
                                                                                                column: 105,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                }],
                                                                            kind: 'let',
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'ObjectExpression',
                                                                                objectType: {
                                                                                    type: 'CallExpression',
                                                                                    callee: {
                                                                                        type: 'Identifier',
                                                                                        name: 'PaperIconButton',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 100,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 100,
                                                                                                column: 39,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    arguments: [],
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 100,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 100,
                                                                                            column: 41,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                properties: [
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'icon',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 101,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 101,
                                                                                                    column: 32,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 'zoom-in'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'disabled',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 102,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 102,
                                                                                                    column: 36,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'UnaryExpression',
                                                                                            operator: '!',
                                                                                            argument: {
                                                                                                type: 'MemberExpression',
                                                                                                computed: false,
                                                                                                object: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'timelineColumn',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 102,
                                                                                                            column: 42,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 102,
                                                                                                            column: 56,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'canZoomIn',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 102,
                                                                                                            column: 58,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 102,
                                                                                                            column: 67,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                existential: true,
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 102,
                                                                                                        column: 42,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 102,
                                                                                                        column: 67,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '1'
                                                                                    },
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'Function',
                                                                                            context: true,
                                                                                            value: function (_context7) {
                                                                                                return function click(e) {
                                                                                                    var timelineColumn = _context7.get('timelineColumn');
                                                                                                    timelineColumn != null ? timelineColumn.zoomIn() : void 0;
                                                                                                };
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 103,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 105,
                                                                                                column: 32,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '2'
                                                                                    }
                                                                                ]
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 100,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 105,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                }
                                                                            },
                                                                            order: '1'
                                                                        },
                                                                        {
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'ObjectExpression',
                                                                                objectType: {
                                                                                    type: 'CallExpression',
                                                                                    callee: {
                                                                                        type: 'Identifier',
                                                                                        name: 'PaperIconButton',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 105,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 105,
                                                                                                column: 39,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    arguments: [],
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 105,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 105,
                                                                                            column: 41,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                properties: [
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'icon',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 106,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 106,
                                                                                                    column: 32,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 'zoom-out'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'disabled',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 107,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 107,
                                                                                                    column: 36,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'UnaryExpression',
                                                                                            operator: '!',
                                                                                            argument: {
                                                                                                type: 'MemberExpression',
                                                                                                computed: false,
                                                                                                object: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'timelineColumn',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 107,
                                                                                                            column: 42,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 107,
                                                                                                            column: 56,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'canZoomOut',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 107,
                                                                                                            column: 58,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 107,
                                                                                                            column: 68,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                existential: true,
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 107,
                                                                                                        column: 42,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 107,
                                                                                                        column: 68,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '1'
                                                                                    },
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'Function',
                                                                                            context: true,
                                                                                            value: function (_context8) {
                                                                                                return function click(e) {
                                                                                                    var timelineColumn = _context8.get('timelineColumn');
                                                                                                    timelineColumn != null ? timelineColumn.zoomOut() : void 0;
                                                                                                };
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 108,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 110,
                                                                                                column: 32,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '2'
                                                                                    }
                                                                                ]
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 105,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 110,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                }
                                                                            },
                                                                            order: '2'
                                                                        }
                                                                    ]
                                                                },
                                                                alternate: null,
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'ObjectExpression',
                                                                    objectType: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'Identifier',
                                                                            name: 'PaperToggleButton',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 110,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 110,
                                                                                    column: 37,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [],
                                                                        loc: {
                                                                            start: {
                                                                                line: 110,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                            },
                                                                            end: {
                                                                                line: 110,
                                                                                column: 39,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    properties: [
                                                                        {
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'Literal',
                                                                                value: 'Timeline'
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 111,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 111,
                                                                                    column: 34,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'checked',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 112,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 112,
                                                                                        column: 31,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'BinaryExpression',
                                                                                operator: '===',
                                                                                left: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'state',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 112,
                                                                                                column: 33,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 112,
                                                                                                column: 38,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'timeline',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 112,
                                                                                                column: 39,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 112,
                                                                                                column: 47,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 112,
                                                                                            column: 33,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 112,
                                                                                            column: 47,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                right: {
                                                                                    type: 'Literal',
                                                                                    value: true
                                                                                }
                                                                            },
                                                                            kind: 'init',
                                                                            order: '1'
                                                                        },
                                                                        {
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'Function',
                                                                                context: true,
                                                                                value: function (_context9) {
                                                                                    return function click(e) {
                                                                                        var dataTableModel = _context9.get('dataTableModel'), state = _context9.get('state');
                                                                                        dataTableModel.clearSelection();
                                                                                        state.timeline = this.checked;
                                                                                    };
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 113,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 117,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                }
                                                                            },
                                                                            order: '2'
                                                                        }
                                                                    ]
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 110,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    },
                                                                    end: {
                                                                        line: 117,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    }
                                                                },
                                                                order: '1'
                                                            }
                                                        ]
                                                    },
                                                    alternate: null,
                                                    order: '6'
                                                },
                                                {
                                                    type: 'IfStatement',
                                                    test: {
                                                        type: 'UnaryExpression',
                                                        operator: '?',
                                                        argument: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'config',
                                                                    loc: {
                                                                        start: {
                                                                            line: 117,
                                                                            column: 19,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                        },
                                                                        end: {
                                                                            line: 117,
                                                                            column: 25,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'toolbar',
                                                                    loc: {
                                                                        start: {
                                                                            line: 117,
                                                                            column: 26,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                        },
                                                                        end: {
                                                                            line: 117,
                                                                            column: 33,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 117,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    },
                                                                    end: {
                                                                        line: 117,
                                                                        column: 33,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'right',
                                                                loc: {
                                                                    start: {
                                                                        line: 117,
                                                                        column: 35,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    },
                                                                    end: {
                                                                        line: 117,
                                                                        column: 40,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    }
                                                                }
                                                            },
                                                            existential: true,
                                                            loc: {
                                                                start: {
                                                                    line: 117,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                },
                                                                end: {
                                                                    line: 117,
                                                                    column: 40,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                }
                                                            }
                                                        }
                                                    },
                                                    consequent: {
                                                        type: 'BlockStatement',
                                                        body: [{
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'config',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 118,
                                                                                        column: 20,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 118,
                                                                                        column: 26,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'toolbar',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 118,
                                                                                        column: 27,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 118,
                                                                                        column: 34,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 118,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 118,
                                                                                    column: 34,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'right',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 118,
                                                                                    column: 35,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 118,
                                                                                    column: 40,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 118,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                            },
                                                                            end: {
                                                                                line: 118,
                                                                                column: 40,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [{
                                                                            type: 'ObjectExpression',
                                                                            properties: [
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'dataTable',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 118,
                                                                                                column: 42,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 118,
                                                                                                column: 51,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Identifier',
                                                                                        name: 'dataTable',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 118,
                                                                                                column: 42,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 118,
                                                                                                column: 51,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'dataTableModel',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 118,
                                                                                                column: 52,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 118,
                                                                                                column: 66,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Identifier',
                                                                                        name: 'dataTableModel',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 118,
                                                                                                column: 52,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 118,
                                                                                                column: 66,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '1'
                                                                                }
                                                                            ]
                                                                        }],
                                                                    loc: {
                                                                        start: {
                                                                            line: 118,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                        },
                                                                        end: {
                                                                            line: 118,
                                                                            column: 68,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 118,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    },
                                                                    end: {
                                                                        line: 118,
                                                                        column: 68,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/GenericTypeView.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    alternate: null,
                                                    order: '7'
                                                }
                                            ]
                                        },
                                        loc: {
                                            start: {
                                                line: 46,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                            },
                                            end: {
                                                line: 120,
                                                column: 16,
                                                fixed: true,
                                                source: 'viewpath/html/panes/GenericTypeView.ion'
                                            }
                                        },
                                        order: '0'
                                    }]
                            },
                            alternate: null,
                            order: '3'
                        },
                        {
                            type: 'ExpressionStatement',
                            expression: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'Identifier',
                                    name: 'dataTable',
                                    loc: {
                                        start: {
                                            line: 120,
                                            column: 8,
                                            fixed: true,
                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                        },
                                        end: {
                                            line: 120,
                                            column: 17,
                                            fixed: true,
                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                        }
                                    }
                                },
                                properties: [{
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'classList',
                                            loc: {
                                                start: {
                                                    line: 121,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                },
                                                end: {
                                                    line: 121,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'ObjectExpression',
                                            properties: [{
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'Literal',
                                                        value: 'fill'
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 122,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                        },
                                                        end: {
                                                            line: 122,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/GenericTypeView.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        kind: 'init',
                                        order: '0'
                                    }]
                            },
                            loc: {
                                start: {
                                    line: 120,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                },
                                end: {
                                    line: 123,
                                    column: 12,
                                    fixed: true,
                                    source: 'viewpath/html/panes/GenericTypeView.ion'
                                }
                            },
                            order: '4'
                        }
                    ]
                },
                order: '9'
            }
        ],
        bound: false
    }, {
        this: this,
        config: config,
        glass: glass,
        _ref: _ref,
        _ref2: _ref2,
        _ref3: _ref3,
        viewpath: viewpath,
        _ref4: _ref4,
        DataTable: DataTable,
        Icon: Icon,
        Form: Form,
        Field: Field,
        Button: Button,
        TabContent: TabContent,
        Toolbar: Toolbar,
        style: style,
        Schema: Schema,
        Key: Key,
        User: User,
        Task: Task
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/panes/GenericTypeView',_viewpath_html_panes_GenericTypeView_);
    else
      _viewpath_html_panes_GenericTypeView_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_panes_GenericTypeView_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_panes_ManagersPane_ = function(module,exports,require){'use strict';
var ion = require('ion'), glass = require('glass'), _ref, viewpath = require('../../'), _ref2, _ref3, _ref4, _ref5, _ref6;
_ref = glass.data;
var Key = _ref.Key;
_ref2 = viewpath.model;
var User = _ref2.User;
var PermissionLevel = _ref2.PermissionLevel;
_ref3 = glass.html.material;
var PromptDialog = _ref3.PromptDialog;
_ref4 = require('./');
var GenericTypeView = _ref4.GenericTypeView;
_ref5 = require('../');
var UserOrgTagsProperty = _ref5.UserOrgTagsProperty;
_ref6 = require('../');
var SubscriptionNotice = _ref6.SubscriptionNotice;
var getManagerQuery = function (sharing) {
        var set = new Set();
        if (sharing != null) {
            for (var userKey in sharing) {
                var email = new Key(viewpath.model, userKey).id;
                set.add(email);
            }
        }
        return new Key(User, { where: { email: Array.from(set) } });
    }, getPermissionProperty = function (sharing) {
        return {
            name: 'permission',
            label: 'Permission',
            value: PermissionLevel.Observer,
            values: PermissionLevel.selectable,
            get: function () {
                return sharing[this.key] != null ? sharing[this.key].permission : void 0;
            },
            set: function (id) {
                sharing[this.key].permission = id;
                this.touch();
            }
        };
    }, addManagersPrompt = function (project) {
        PromptDialog.show({
            title: 'Add Managers',
            properties: [
                {
                    type: 'object',
                    name: 'users',
                    inline: true,
                    foreign: {
                        type: 'User',
                        property: 'key',
                        getSearchKeys: function (obj, text) {
                            return User.getSearchKeys({
                                text: text,
                                orgId: project.orgId
                            });
                        }
                    }
                },
                {
                    type: 'integer',
                    name: 'permission',
                    value: PermissionLevel.Observer,
                    values: PermissionLevel.selectable
                }
            ],
            callback: function (_ref7) {
                var users = _ref7.users;
                var permission = _ref7.permission;
                var userKeys = Object.keys(users);
                for (var _i = 0; _i < userKeys.length; _i++) {
                    var userKey = userKeys[_i];
                    project.sharing[userKey] = project.sharing[userKey] != null ? project.sharing[userKey] : {};
                    project.sharing[userKey].permission = permission;
                }
                project.touched++;
            }
        });
    };
module.exports = exports = ion.template(function (config, options) {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'subNotice',
                            loc: {
                                start: {
                                    line: 60,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/panes/ManagersPane.ion'
                                },
                                end: {
                                    line: 60,
                                    column: 17,
                                    fixed: true,
                                    source: 'viewpath/html/panes/ManagersPane.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'SubscriptionNotice',
                                loc: {
                                    start: {
                                        line: 60,
                                        column: 20,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ManagersPane.ion'
                                    },
                                    end: {
                                        line: 60,
                                        column: 38,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ManagersPane.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'Literal',
                                    value: 'create and manage projects'
                                }],
                            loc: {
                                start: {
                                    line: 60,
                                    column: 20,
                                    fixed: true,
                                    source: 'viewpath/html/panes/ManagersPane.ion'
                                },
                                end: {
                                    line: 60,
                                    column: 68,
                                    fixed: true,
                                    source: 'viewpath/html/panes/ManagersPane.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'IfStatement',
                test: {
                    type: 'UnaryExpression',
                    operator: '?',
                    argument: {
                        type: 'Identifier',
                        name: 'subNotice',
                        loc: {
                            start: {
                                line: 61,
                                column: 7,
                                fixed: true,
                                source: 'viewpath/html/panes/ManagersPane.ion'
                            },
                            end: {
                                line: 61,
                                column: 16,
                                fixed: true,
                                source: 'viewpath/html/panes/ManagersPane.ion'
                            }
                        }
                    }
                },
                consequent: {
                    type: 'BlockStatement',
                    body: [{
                            type: 'ReturnStatement',
                            argument: {
                                type: 'Identifier',
                                name: 'subNotice',
                                loc: {
                                    start: {
                                        line: 62,
                                        column: 15,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ManagersPane.ion'
                                    },
                                    end: {
                                        line: 62,
                                        column: 24,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ManagersPane.ion'
                                    }
                                }
                            },
                            order: '0'
                        }]
                },
                alternate: {
                    type: 'BlockStatement',
                    body: [
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'projKey',
                                        loc: {
                                            start: {
                                                line: 65,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ManagersPane.ion'
                                            },
                                            end: {
                                                line: 65,
                                                column: 19,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ManagersPane.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'NewExpression',
                                        callee: {
                                            type: 'Identifier',
                                            name: 'Key',
                                            loc: {
                                                start: {
                                                    line: 65,
                                                    column: 26,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ManagersPane.ion'
                                                },
                                                end: {
                                                    line: 65,
                                                    column: 29,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ManagersPane.ion'
                                                }
                                            }
                                        },
                                        arguments: [
                                            {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'viewpath',
                                                    loc: {
                                                        start: {
                                                            line: 65,
                                                            column: 30,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ManagersPane.ion'
                                                        },
                                                        end: {
                                                            line: 65,
                                                            column: 38,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ManagersPane.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'model',
                                                    loc: {
                                                        start: {
                                                            line: 65,
                                                            column: 39,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ManagersPane.ion'
                                                        },
                                                        end: {
                                                            line: 65,
                                                            column: 44,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ManagersPane.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 65,
                                                        column: 30,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ManagersPane.ion'
                                                    },
                                                    end: {
                                                        line: 65,
                                                        column: 44,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ManagersPane.ion'
                                                    }
                                                }
                                            },
                                            {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'config',
                                                    loc: {
                                                        start: {
                                                            line: 65,
                                                            column: 46,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ManagersPane.ion'
                                                        },
                                                        end: {
                                                            line: 65,
                                                            column: 52,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ManagersPane.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'key',
                                                    loc: {
                                                        start: {
                                                            line: 65,
                                                            column: 53,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ManagersPane.ion'
                                                        },
                                                        end: {
                                                            line: 65,
                                                            column: 56,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ManagersPane.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 65,
                                                        column: 46,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ManagersPane.ion'
                                                    },
                                                    end: {
                                                        line: 65,
                                                        column: 56,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ManagersPane.ion'
                                                    }
                                                }
                                            }
                                        ],
                                        loc: {
                                            start: {
                                                line: 65,
                                                column: 22,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ManagersPane.ion'
                                            },
                                            end: {
                                                line: 65,
                                                column: 57,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ManagersPane.ion'
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '0'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'project',
                                        loc: {
                                            start: {
                                                line: 66,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ManagersPane.ion'
                                            },
                                            end: {
                                                line: 66,
                                                column: 19,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ManagersPane.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'MemberExpression',
                                        computed: true,
                                        object: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'model',
                                                loc: {
                                                    start: {
                                                        line: 66,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ManagersPane.ion'
                                                    },
                                                    end: {
                                                        line: 66,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ManagersPane.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'server',
                                                loc: {
                                                    start: {
                                                        line: 66,
                                                        column: 28,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ManagersPane.ion'
                                                    },
                                                    end: {
                                                        line: 66,
                                                        column: 34,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ManagersPane.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 66,
                                                    column: 22,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ManagersPane.ion'
                                                },
                                                end: {
                                                    line: 66,
                                                    column: 34,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ManagersPane.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'projKey',
                                            loc: {
                                                start: {
                                                    line: 66,
                                                    column: 35,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ManagersPane.ion'
                                                },
                                                end: {
                                                    line: 66,
                                                    column: 42,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ManagersPane.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 66,
                                                column: 22,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ManagersPane.ion'
                                            },
                                            end: {
                                                line: 66,
                                                column: 43,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ManagersPane.ion'
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '1'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'org',
                                        loc: {
                                            start: {
                                                line: 67,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ManagersPane.ion'
                                            },
                                            end: {
                                                line: 67,
                                                column: 15,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ManagersPane.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'MemberExpression',
                                        computed: true,
                                        object: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'model',
                                                loc: {
                                                    start: {
                                                        line: 67,
                                                        column: 18,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ManagersPane.ion'
                                                    },
                                                    end: {
                                                        line: 67,
                                                        column: 23,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ManagersPane.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'orgs',
                                                loc: {
                                                    start: {
                                                        line: 67,
                                                        column: 24,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ManagersPane.ion'
                                                    },
                                                    end: {
                                                        line: 67,
                                                        column: 28,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ManagersPane.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 67,
                                                    column: 18,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ManagersPane.ion'
                                                },
                                                end: {
                                                    line: 67,
                                                    column: 28,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ManagersPane.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'project',
                                                loc: {
                                                    start: {
                                                        line: 67,
                                                        column: 29,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ManagersPane.ion'
                                                    },
                                                    end: {
                                                        line: 67,
                                                        column: 36,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ManagersPane.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'orgKey',
                                                loc: {
                                                    start: {
                                                        line: 67,
                                                        column: 37,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ManagersPane.ion'
                                                    },
                                                    end: {
                                                        line: 67,
                                                        column: 43,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ManagersPane.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 67,
                                                    column: 29,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ManagersPane.ion'
                                                },
                                                end: {
                                                    line: 67,
                                                    column: 43,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ManagersPane.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 67,
                                                column: 18,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ManagersPane.ion'
                                            },
                                            end: {
                                                line: 67,
                                                column: 44,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ManagersPane.ion'
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '2'
                        },
                        {
                            type: 'IfStatement',
                            test: {
                                type: 'UnaryExpression',
                                operator: '?',
                                argument: {
                                    type: 'Identifier',
                                    name: 'project',
                                    loc: {
                                        start: {
                                            line: 68,
                                            column: 11,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ManagersPane.ion'
                                        },
                                        end: {
                                            line: 68,
                                            column: 18,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ManagersPane.ion'
                                        }
                                    }
                                }
                            },
                            consequent: {
                                type: 'BlockStatement',
                                body: [{
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'Function',
                                                context: true,
                                                value: function (_context) {
                                                    return function () {
                                                        var project = _context.get('project');
                                                        return project.sharing = project.sharing != null ? project.sharing : {};
                                                    };
                                                }
                                            },
                                            arguments: [],
                                            loc: {
                                                start: {
                                                    line: 69,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ManagersPane.ion'
                                                },
                                                end: {
                                                    line: 69,
                                                    column: 39,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ManagersPane.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 69,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ManagersPane.ion'
                                            },
                                            end: {
                                                line: 69,
                                                column: 39,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ManagersPane.ion'
                                            }
                                        },
                                        order: '0'
                                    }]
                            },
                            alternate: null,
                            order: '3'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'touched',
                                        loc: {
                                            start: {
                                                line: 71,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ManagersPane.ion'
                                            },
                                            end: {
                                                line: 71,
                                                column: 19,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ManagersPane.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'project',
                                            loc: {
                                                start: {
                                                    line: 71,
                                                    column: 22,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ManagersPane.ion'
                                                },
                                                end: {
                                                    line: 71,
                                                    column: 29,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ManagersPane.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'touched',
                                            loc: {
                                                start: {
                                                    line: 71,
                                                    column: 31,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ManagersPane.ion'
                                                },
                                                end: {
                                                    line: 71,
                                                    column: 38,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ManagersPane.ion'
                                                }
                                            }
                                        },
                                        existential: true,
                                        loc: {
                                            start: {
                                                line: 71,
                                                column: 22,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ManagersPane.ion'
                                            },
                                            end: {
                                                line: 71,
                                                column: 38,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ManagersPane.ion'
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '4'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'sharing',
                                        loc: {
                                            start: {
                                                line: 72,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ManagersPane.ion'
                                            },
                                            end: {
                                                line: 72,
                                                column: 19,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ManagersPane.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'project',
                                            loc: {
                                                start: {
                                                    line: 72,
                                                    column: 22,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ManagersPane.ion'
                                                },
                                                end: {
                                                    line: 72,
                                                    column: 29,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ManagersPane.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'sharing',
                                            loc: {
                                                start: {
                                                    line: 72,
                                                    column: 31,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ManagersPane.ion'
                                                },
                                                end: {
                                                    line: 72,
                                                    column: 38,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ManagersPane.ion'
                                                }
                                            }
                                        },
                                        existential: true,
                                        loc: {
                                            start: {
                                                line: 72,
                                                column: 22,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ManagersPane.ion'
                                            },
                                            end: {
                                                line: 72,
                                                column: 38,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ManagersPane.ion'
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '5'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'viewConfig',
                                        loc: {
                                            start: {
                                                line: 73,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ManagersPane.ion'
                                            },
                                            end: {
                                                line: 73,
                                                column: 22,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ManagersPane.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'Function',
                                            context: true,
                                            value: function (_context2) {
                                                return function (touched, org) {
                                                    var getManagerQuery = _context2.get('getManagerQuery'), sharing = _context2.get('sharing'), User = _context2.get('User'), getPermissionProperty = _context2.get('getPermissionProperty'), UserOrgTagsProperty = _context2.get('UserOrgTagsProperty'), options = _context2.get('options'), ion = _context2.get('ion'), addManagersPrompt = _context2.get('addManagersPrompt'), project = _context2.get('project');
                                                    var _ref11 = {};
                                                    {
                                                        _ref11.id = 'managers';
                                                        _ref11.key = getManagerQuery(sharing);
                                                        _ref11.properties = function () {
                                                            var _ref12 = {};
                                                            {
                                                                {
                                                                    var _ref9 = User.properties;
                                                                    for (var key in _ref9) {
                                                                        var value = _ref9[key];
                                                                        _ref12[key] = value;
                                                                    }
                                                                }
                                                                _ref12.permission = getPermissionProperty(sharing);
                                                                if (org != null) {
                                                                    _ref12.tags = UserOrgTagsProperty(org);
                                                                }
                                                            }
                                                            return _ref12;
                                                        }();
                                                        var _ref13 = [
                                                                'name',
                                                                'permission'
                                                            ];
                                                        if ((options != null ? options.columns : void 0) != null) {
                                                            {
                                                                var _ref10 = options.columns;
                                                                for (var _i2 = 0; _i2 < _ref10.length; _i2++) {
                                                                    var column = _ref10[_i2];
                                                                    _ref13.push(column);
                                                                }
                                                            }
                                                        }
                                                        _ref11.columns = _ref13;
                                                        _ref11.standardControls = false;
                                                        _ref11.create = ion.patch.combine(_ref11.create, {
                                                            handler: function () {
                                                                return addManagersPrompt(project);
                                                            }
                                                        });
                                                        _ref11.toolbar = ion.patch.combine(_ref11.toolbar, {
                                                            center: ion.template(function (_ref8) {
                                                                return ion.createRuntime({
                                                                    type: 'Template',
                                                                    id: null,
                                                                    body: [
                                                                        {
                                                                            type: 'VariableDeclaration',
                                                                            declarations: [{
                                                                                    type: 'VariableDeclarator',
                                                                                    id: {
                                                                                        type: 'Identifier',
                                                                                        name: 'dataTableModel',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 93,
                                                                                                column: 35,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ManagersPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 93,
                                                                                                column: 49,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ManagersPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    init: {
                                                                                        type: 'MemberExpression',
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: '_ref8'
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'dataTableModel',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 93,
                                                                                                    column: 35,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ManagersPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 93,
                                                                                                    column: 49,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ManagersPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        computed: false
                                                                                    }
                                                                                }],
                                                                            kind: 'let',
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'ReturnStatement',
                                                                            argument: {
                                                                                type: 'ObjectExpression',
                                                                                objectType: {
                                                                                    type: 'CallExpression',
                                                                                    callee: {
                                                                                        type: 'Identifier',
                                                                                        name: 'PaperIconButton',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 94,
                                                                                                column: 27,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ManagersPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 94,
                                                                                                column: 42,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ManagersPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    arguments: [],
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 94,
                                                                                            column: 27,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/ManagersPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 94,
                                                                                            column: 44,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/ManagersPane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                properties: [
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'icon',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 95,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ManagersPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 95,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ManagersPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 'clear'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'Function',
                                                                                            context: true,
                                                                                            value: function (_context3) {
                                                                                                return function click() {
                                                                                                    var dataTableModel = _context3.get('dataTableModel'), project = _context3.get('project');
                                                                                                    var userKeys = dataTableModel.selectedRows.map(function (x) {
                                                                                                            return x.key;
                                                                                                        });
                                                                                                    for (var _i3 = 0; _i3 < userKeys.length; _i3++) {
                                                                                                        var userKey = userKeys[_i3];
                                                                                                        delete project.sharing[userKey];
                                                                                                    }
                                                                                                    project.touched++;
                                                                                                };
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 96,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ManagersPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 101,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ManagersPane.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '1'
                                                                                    }
                                                                                ]
                                                                            },
                                                                            order: '1'
                                                                        }
                                                                    ],
                                                                    bound: false,
                                                                    name: {
                                                                        type: 'Identifier',
                                                                        name: 'center',
                                                                        loc: {
                                                                            start: {
                                                                                line: 93,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ManagersPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 93,
                                                                                column: 22,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ManagersPane.ion'
                                                                            }
                                                                        }
                                                                    }
                                                                }, {
                                                                    this: this,
                                                                    _ref8: _ref8,
                                                                    _ref13: _ref13,
                                                                    getManagerQuery: getManagerQuery,
                                                                    sharing: sharing,
                                                                    User: User,
                                                                    getPermissionProperty: getPermissionProperty,
                                                                    UserOrgTagsProperty: UserOrgTagsProperty,
                                                                    options: options,
                                                                    ion: ion,
                                                                    addManagersPrompt: addManagersPrompt,
                                                                    project: project,
                                                                    _ref11: _ref11,
                                                                    touched: touched,
                                                                    org: org,
                                                                    _context2: _context2,
                                                                    config: config,
                                                                    glass: glass,
                                                                    _ref: _ref,
                                                                    viewpath: viewpath,
                                                                    _ref2: _ref2,
                                                                    _ref3: _ref3,
                                                                    _ref4: _ref4,
                                                                    _ref5: _ref5,
                                                                    _ref6: _ref6,
                                                                    Key: Key,
                                                                    PermissionLevel: PermissionLevel,
                                                                    PromptDialog: PromptDialog,
                                                                    GenericTypeView: GenericTypeView,
                                                                    SubscriptionNotice: SubscriptionNotice
                                                                }, null);
                                                            })
                                                        });
                                                        _ref11.sorts = [[{ name: true }]];
                                                        if ((options != null ? options.timeline : void 0) != null) {
                                                            _ref11.timeline = options.timeline;
                                                        }
                                                    }
                                                    return _ref11;
                                                };
                                            }
                                        },
                                        arguments: [
                                            {
                                                type: 'Identifier',
                                                name: 'touched',
                                                loc: {
                                                    start: {
                                                        line: 73,
                                                        column: 29,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ManagersPane.ion'
                                                    },
                                                    end: {
                                                        line: 73,
                                                        column: 36,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ManagersPane.ion'
                                                    }
                                                }
                                            },
                                            {
                                                type: 'Identifier',
                                                name: 'org',
                                                loc: {
                                                    start: {
                                                        line: 73,
                                                        column: 38,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ManagersPane.ion'
                                                    },
                                                    end: {
                                                        line: 73,
                                                        column: 41,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ManagersPane.ion'
                                                    }
                                                }
                                            }
                                        ],
                                        loc: {
                                            start: {
                                                line: 73,
                                                column: 25,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ManagersPane.ion'
                                            },
                                            end: {
                                                line: 106,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ManagersPane.ion'
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '6'
                        },
                        {
                            type: 'ReturnStatement',
                            argument: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'Identifier',
                                        name: 'GenericTypeView',
                                        loc: {
                                            start: {
                                                line: 106,
                                                column: 15,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ManagersPane.ion'
                                            },
                                            end: {
                                                line: 106,
                                                column: 30,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ManagersPane.ion'
                                            }
                                        }
                                    },
                                    arguments: [{
                                            type: 'Identifier',
                                            name: 'viewConfig',
                                            loc: {
                                                start: {
                                                    line: 106,
                                                    column: 31,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ManagersPane.ion'
                                                },
                                                end: {
                                                    line: 106,
                                                    column: 41,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ManagersPane.ion'
                                                }
                                            }
                                        }],
                                    loc: {
                                        start: {
                                            line: 106,
                                            column: 15,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ManagersPane.ion'
                                        },
                                        end: {
                                            line: 106,
                                            column: 42,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ManagersPane.ion'
                                        }
                                    }
                                },
                                properties: [{
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'name',
                                            loc: {
                                                start: {
                                                    line: 107,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ManagersPane.ion'
                                                },
                                                end: {
                                                    line: 107,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ManagersPane.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'ArrayExpression',
                                            elements: [
                                                {
                                                    type: 'Literal',
                                                    value: 'Project'
                                                },
                                                {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'project',
                                                        loc: {
                                                            start: {
                                                                line: 107,
                                                                column: 30,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ManagersPane.ion'
                                                            },
                                                            end: {
                                                                line: 107,
                                                                column: 37,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ManagersPane.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'name',
                                                        loc: {
                                                            start: {
                                                                line: 107,
                                                                column: 38,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ManagersPane.ion'
                                                            },
                                                            end: {
                                                                line: 107,
                                                                column: 42,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ManagersPane.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 107,
                                                            column: 30,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ManagersPane.ion'
                                                        },
                                                        end: {
                                                            line: 107,
                                                            column: 42,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ManagersPane.ion'
                                                        }
                                                    }
                                                },
                                                {
                                                    type: 'Literal',
                                                    value: 'Managers'
                                                }
                                            ]
                                        },
                                        kind: 'init',
                                        order: '0'
                                    }]
                            },
                            order: '7'
                        }
                    ]
                },
                order: '1'
            }
        ],
        bound: false
    }, {
        this: this,
        ion: ion,
        config: config,
        options: options,
        glass: glass,
        _ref: _ref,
        viewpath: viewpath,
        _ref2: _ref2,
        _ref3: _ref3,
        _ref4: _ref4,
        _ref5: _ref5,
        _ref6: _ref6,
        Key: Key,
        User: User,
        PermissionLevel: PermissionLevel,
        PromptDialog: PromptDialog,
        GenericTypeView: GenericTypeView,
        UserOrgTagsProperty: UserOrgTagsProperty,
        SubscriptionNotice: SubscriptionNotice,
        getManagerQuery: getManagerQuery,
        getPermissionProperty: getPermissionProperty,
        addManagersPrompt: addManagersPrompt
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/panes/ManagersPane',_viewpath_html_panes_ManagersPane_);
    else
      _viewpath_html_panes_ManagersPane_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_panes_ManagersPane_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_panes_OrgPane_ = function(module,exports,require){'use strict';
var ion = require('ion');
var glass = require('glass'), viewpath = require('../..'), _ref, _ref2, _ref3, _ref4, _ref5, _ref6, _ref7, _ref8, _ref9;
_ref = glass.data;
var Http = _ref.Http;
var Key = _ref.Key;
_ref2 = glass.html.material;
var Button = _ref2.Button;
var Icon = _ref2.Icon;
var Dialog = _ref2.Dialog;
var Renamer = _ref2.Renamer;
_ref3 = glass.html.material;
var PromptDialog = _ref3.PromptDialog;
_ref4 = viewpath.model;
var User = _ref4.User;
var Organization = _ref4.Organization;
var Tag = _ref4.Tag;
var Project = _ref4.Project;
_ref5 = viewpath.html.panes;
var GenericTypePane = _ref5.GenericTypePane;
_ref6 = viewpath.html;
var InviteUserDialog = _ref6.InviteUserDialog;
_ref7 = glass.html.material.DataTable2;
var ObjectRowSource = _ref7.ObjectRowSource;
_ref8 = require('../');
var UserOrgTagsProperty = _ref8.UserOrgTagsProperty;
var UserOrgCalendarsProperty = _ref8.UserOrgCalendarsProperty;
var UserOrgAcceptedProperty = _ref8.UserOrgAcceptedProperty;
var UserOrgInvitedProperty = _ref8.UserOrgInvitedProperty;
var AdminProperty = _ref8.AdminProperty;
_ref9 = require('../');
var SubscriptionNotice = _ref9.SubscriptionNotice;
var showInfoDialog = function (org) {
    Dialog.show(ion.template(function () {
        return ion.createRuntime({
            type: 'Template',
            id: null,
            body: [
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'dialog',
                                loc: {
                                    start: {
                                        line: 18,
                                        column: 20,
                                        fixed: true,
                                        source: 'viewpath/html/panes/OrgPane.ion'
                                    },
                                    end: {
                                        line: 18,
                                        column: 26,
                                        fixed: true,
                                        source: 'viewpath/html/panes/OrgPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Dialog',
                                    loc: {
                                        start: {
                                            line: 18,
                                            column: 29,
                                            fixed: true,
                                            source: 'viewpath/html/panes/OrgPane.ion'
                                        },
                                        end: {
                                            line: 18,
                                            column: 35,
                                            fixed: true,
                                            source: 'viewpath/html/panes/OrgPane.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'ObjectExpression',
                                        properties: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'class',
                                                    loc: {
                                                        start: {
                                                            line: 18,
                                                            column: 37,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                        },
                                                        end: {
                                                            line: 18,
                                                            column: 42,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: 'layout vertical'
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    }],
                                loc: {
                                    start: {
                                        line: 18,
                                        column: 29,
                                        fixed: true,
                                        source: 'viewpath/html/panes/OrgPane.ion'
                                    },
                                    end: {
                                        line: 18,
                                        column: 63,
                                        fixed: true,
                                        source: 'viewpath/html/panes/OrgPane.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '0'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'pairs',
                                loc: {
                                    start: {
                                        line: 19,
                                        column: 20,
                                        fixed: true,
                                        source: 'viewpath/html/panes/OrgPane.ion'
                                    },
                                    end: {
                                        line: 19,
                                        column: 25,
                                        fixed: true,
                                        source: 'viewpath/html/panes/OrgPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'ArrayExpression',
                                    elements: []
                                },
                                properties: [
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'ArrayExpression',
                                            elements: [
                                                {
                                                    type: 'Literal',
                                                    value: 'Name'
                                                },
                                                {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'org',
                                                        loc: {
                                                            start: {
                                                                line: 20,
                                                                column: 29,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                            },
                                                            end: {
                                                                line: 20,
                                                                column: 32,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'name',
                                                        loc: {
                                                            start: {
                                                                line: 20,
                                                                column: 33,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                            },
                                                            end: {
                                                                line: 20,
                                                                column: 37,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 20,
                                                            column: 29,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                        },
                                                        end: {
                                                            line: 20,
                                                            column: 37,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                        }
                                                    }
                                                }
                                            ]
                                        },
                                        loc: {
                                            start: {
                                                line: 20,
                                                column: 20,
                                                fixed: true,
                                                source: 'viewpath/html/panes/OrgPane.ion'
                                            },
                                            end: {
                                                line: 20,
                                                column: 38,
                                                fixed: true,
                                                source: 'viewpath/html/panes/OrgPane.ion'
                                            }
                                        },
                                        order: '0'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'ArrayExpression',
                                            elements: [
                                                {
                                                    type: 'Literal',
                                                    value: 'Id'
                                                },
                                                {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'org',
                                                        loc: {
                                                            start: {
                                                                line: 21,
                                                                column: 27,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                            },
                                                            end: {
                                                                line: 21,
                                                                column: 30,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'id',
                                                        loc: {
                                                            start: {
                                                                line: 21,
                                                                column: 31,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                            },
                                                            end: {
                                                                line: 21,
                                                                column: 33,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 21,
                                                            column: 27,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                        },
                                                        end: {
                                                            line: 21,
                                                            column: 33,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                        }
                                                    }
                                                }
                                            ]
                                        },
                                        loc: {
                                            start: {
                                                line: 21,
                                                column: 20,
                                                fixed: true,
                                                source: 'viewpath/html/panes/OrgPane.ion'
                                            },
                                            end: {
                                                line: 21,
                                                column: 34,
                                                fixed: true,
                                                source: 'viewpath/html/panes/OrgPane.ion'
                                            }
                                        },
                                        order: '1'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'ArrayExpression',
                                            elements: [
                                                {
                                                    type: 'Literal',
                                                    value: 'Created'
                                                },
                                                {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'org',
                                                                        loc: {
                                                                            start: {
                                                                                line: 22,
                                                                                column: 32,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 22,
                                                                                column: 35,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'Created',
                                                                        loc: {
                                                                            start: {
                                                                                line: 22,
                                                                                column: 36,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 22,
                                                                                column: 43,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 22,
                                                                            column: 32,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 22,
                                                                            column: 43,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'withoutTime',
                                                                    loc: {
                                                                        start: {
                                                                            line: 22,
                                                                            column: 44,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 22,
                                                                            column: 55,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 22,
                                                                        column: 32,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 22,
                                                                        column: 55,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [],
                                                            loc: {
                                                                start: {
                                                                    line: 22,
                                                                    column: 32,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                },
                                                                end: {
                                                                    line: 22,
                                                                    column: 57,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'format',
                                                            loc: {
                                                                start: {
                                                                    line: 22,
                                                                    column: 58,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                },
                                                                end: {
                                                                    line: 22,
                                                                    column: 64,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 22,
                                                                column: 32,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                            },
                                                            end: {
                                                                line: 22,
                                                                column: 64,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [],
                                                    loc: {
                                                        start: {
                                                            line: 22,
                                                            column: 32,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                        },
                                                        end: {
                                                            line: 22,
                                                            column: 66,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                        }
                                                    }
                                                }
                                            ]
                                        },
                                        loc: {
                                            start: {
                                                line: 22,
                                                column: 20,
                                                fixed: true,
                                                source: 'viewpath/html/panes/OrgPane.ion'
                                            },
                                            end: {
                                                line: 22,
                                                column: 67,
                                                fixed: true,
                                                source: 'viewpath/html/panes/OrgPane.ion'
                                            }
                                        },
                                        order: '2'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'ArrayExpression',
                                            elements: [
                                                {
                                                    type: 'Literal',
                                                    value: 'Created by'
                                                },
                                                {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'NewExpression',
                                                        callee: {
                                                            type: 'Identifier',
                                                            name: 'Key',
                                                            loc: {
                                                                start: {
                                                                    line: 23,
                                                                    column: 39,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                },
                                                                end: {
                                                                    line: 23,
                                                                    column: 42,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [
                                                            {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'viewpath',
                                                                    loc: {
                                                                        start: {
                                                                            line: 23,
                                                                            column: 43,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 23,
                                                                            column: 51,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'model',
                                                                    loc: {
                                                                        start: {
                                                                            line: 23,
                                                                            column: 52,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 23,
                                                                            column: 57,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 23,
                                                                        column: 43,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 23,
                                                                        column: 57,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'org',
                                                                    loc: {
                                                                        start: {
                                                                            line: 23,
                                                                            column: 59,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 23,
                                                                            column: 62,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'createdBy',
                                                                    loc: {
                                                                        start: {
                                                                            line: 23,
                                                                            column: 63,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 23,
                                                                            column: 72,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 23,
                                                                        column: 59,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 23,
                                                                        column: 72,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                    }
                                                                }
                                                            }
                                                        ],
                                                        loc: {
                                                            start: {
                                                                line: 23,
                                                                column: 35,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                            },
                                                            end: {
                                                                line: 23,
                                                                column: 73,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'id',
                                                        loc: {
                                                            start: {
                                                                line: 23,
                                                                column: 74,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                            },
                                                            end: {
                                                                line: 23,
                                                                column: 76,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 23,
                                                            column: 35,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                        },
                                                        end: {
                                                            line: 23,
                                                            column: 76,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                        }
                                                    }
                                                }
                                            ]
                                        },
                                        loc: {
                                            start: {
                                                line: 23,
                                                column: 20,
                                                fixed: true,
                                                source: 'viewpath/html/panes/OrgPane.ion'
                                            },
                                            end: {
                                                line: 23,
                                                column: 77,
                                                fixed: true,
                                                source: 'viewpath/html/panes/OrgPane.ion'
                                            }
                                        },
                                        order: '3'
                                    }
                                ]
                            }
                        }],
                    kind: 'let',
                    order: '1'
                },
                {
                    type: 'ReturnStatement',
                    argument: {
                        type: 'ObjectExpression',
                        objectType: {
                            type: 'Identifier',
                            name: 'dialog',
                            loc: {
                                start: {
                                    line: 24,
                                    column: 23,
                                    fixed: true,
                                    source: 'viewpath/html/panes/OrgPane.ion'
                                },
                                end: {
                                    line: 24,
                                    column: 29,
                                    fixed: true,
                                    source: 'viewpath/html/panes/OrgPane.ion'
                                }
                            }
                        },
                        properties: [{
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'frame',
                                    loc: {
                                        start: {
                                            line: 25,
                                            column: 20,
                                            fixed: true,
                                            source: 'viewpath/html/panes/OrgPane.ion'
                                        },
                                        end: {
                                            line: 25,
                                            column: 25,
                                            fixed: true,
                                            source: 'viewpath/html/panes/OrgPane.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'ObjectExpression',
                                    properties: [
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'style',
                                                loc: {
                                                    start: {
                                                        line: 26,
                                                        column: 24,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                    },
                                                    end: {
                                                        line: 26,
                                                        column: 29,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'ObjectExpression',
                                                properties: [{
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'width',
                                                            loc: {
                                                                start: {
                                                                    line: 27,
                                                                    column: 28,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                },
                                                                end: {
                                                                    line: 27,
                                                                    column: 33,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Literal',
                                                            value: '350px'
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    }]
                                            },
                                            kind: 'init',
                                            order: '0'
                                        },
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'ObjectExpression',
                                                objectType: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'Identifier',
                                                        name: 'Div',
                                                        loc: {
                                                            start: {
                                                                line: 28,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                            },
                                                            end: {
                                                                line: 28,
                                                                column: 27,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [{
                                                            type: 'ObjectExpression',
                                                            properties: [{
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'class',
                                                                        loc: {
                                                                            start: {
                                                                                line: 28,
                                                                                column: 29,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 28,
                                                                                column: 34,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Literal',
                                                                        value: 'title'
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                }]
                                                        }],
                                                    loc: {
                                                        start: {
                                                            line: 28,
                                                            column: 24,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                        },
                                                        end: {
                                                            line: 28,
                                                            column: 45,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                        }
                                                    }
                                                },
                                                properties: [{
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'Literal',
                                                            value: 'Organization Information'
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 29,
                                                                column: 28,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                            },
                                                            end: {
                                                                line: 29,
                                                                column: 54,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                            }
                                                        },
                                                        order: '0'
                                                    }]
                                            },
                                            loc: {
                                                start: {
                                                    line: 28,
                                                    column: 24,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                },
                                                end: {
                                                    line: 30,
                                                    column: 28,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                }
                                            },
                                            order: '1'
                                        },
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'ObjectExpression',
                                                objectType: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'Identifier',
                                                        name: 'Div',
                                                        loc: {
                                                            start: {
                                                                line: 30,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                            },
                                                            end: {
                                                                line: 30,
                                                                column: 27,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [{
                                                            type: 'ObjectExpression',
                                                            properties: [{
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'style',
                                                                        loc: {
                                                                            start: {
                                                                                line: 30,
                                                                                column: 29,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 30,
                                                                                column: 34,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Literal',
                                                                        value: 'font-size:14px'
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                }]
                                                        }],
                                                    loc: {
                                                        start: {
                                                            line: 30,
                                                            column: 24,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                        },
                                                        end: {
                                                            line: 30,
                                                            column: 53,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                        }
                                                    }
                                                },
                                                properties: [{
                                                        type: 'ForOfStatement',
                                                        left: {
                                                            type: 'VariableDeclaration',
                                                            declarations: [{
                                                                    type: 'VariableDeclarator',
                                                                    id: {
                                                                        type: 'Identifier',
                                                                        name: 'pair',
                                                                        loc: {
                                                                            start: {
                                                                                line: 31,
                                                                                column: 32,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 31,
                                                                                column: 36,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    init: null
                                                                }],
                                                            kind: 'let'
                                                        },
                                                        right: {
                                                            type: 'Identifier',
                                                            name: 'pairs',
                                                            loc: {
                                                                start: {
                                                                    line: 31,
                                                                    column: 40,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                },
                                                                end: {
                                                                    line: 31,
                                                                    column: 45,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                }
                                                            }
                                                        },
                                                        body: {
                                                            type: 'BlockStatement',
                                                            body: [{
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'ObjectExpression',
                                                                        objectType: {
                                                                            type: 'CallExpression',
                                                                            callee: {
                                                                                type: 'Identifier',
                                                                                name: 'Div',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 32,
                                                                                        column: 32,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 32,
                                                                                        column: 35,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            arguments: [{
                                                                                    type: 'ObjectExpression',
                                                                                    properties: [{
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'class',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 32,
                                                                                                        column: 37,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 32,
                                                                                                        column: 42,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'Literal',
                                                                                                value: 'layout horizontal'
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '0'
                                                                                        }]
                                                                                }],
                                                                            loc: {
                                                                                start: {
                                                                                    line: 32,
                                                                                    column: 32,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 32,
                                                                                    column: 65,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        properties: [
                                                                            {
                                                                                type: 'ExpressionStatement',
                                                                                expression: {
                                                                                    type: 'ObjectExpression',
                                                                                    objectType: {
                                                                                        type: 'CallExpression',
                                                                                        callee: {
                                                                                            type: 'Identifier',
                                                                                            name: 'Div',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 33,
                                                                                                    column: 36,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 33,
                                                                                                    column: 39,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        arguments: [],
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 33,
                                                                                                column: 36,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 33,
                                                                                                column: 41,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    properties: [{
                                                                                            type: 'ExpressionStatement',
                                                                                            expression: {
                                                                                                type: 'BinaryExpression',
                                                                                                operator: '+',
                                                                                                left: {
                                                                                                    type: 'MemberExpression',
                                                                                                    computed: true,
                                                                                                    object: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'pair',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 34,
                                                                                                                column: 40,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 34,
                                                                                                                column: 44,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    property: {
                                                                                                        type: 'Literal',
                                                                                                        value: 0
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 34,
                                                                                                            column: 40,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 34,
                                                                                                            column: 47,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                right: {
                                                                                                    type: 'Literal',
                                                                                                    value: ':'
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 34,
                                                                                                    column: 40,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 34,
                                                                                                    column: 53,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                }
                                                                                            },
                                                                                            order: '0'
                                                                                        }]
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 33,
                                                                                        column: 36,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 35,
                                                                                        column: 40,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                    }
                                                                                },
                                                                                order: '0'
                                                                            },
                                                                            {
                                                                                type: 'ExpressionStatement',
                                                                                expression: {
                                                                                    type: 'CallExpression',
                                                                                    callee: {
                                                                                        type: 'Identifier',
                                                                                        name: 'Div',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 35,
                                                                                                column: 36,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 35,
                                                                                                column: 39,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    arguments: [{
                                                                                            type: 'ObjectExpression',
                                                                                            properties: [{
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'class',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 35,
                                                                                                                column: 41,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 35,
                                                                                                                column: 46,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'Literal',
                                                                                                        value: 'fill'
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '0'
                                                                                                }]
                                                                                        }],
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 35,
                                                                                            column: 36,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 35,
                                                                                            column: 55,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 35,
                                                                                        column: 36,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 35,
                                                                                        column: 55,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                    }
                                                                                },
                                                                                order: '1'
                                                                            },
                                                                            {
                                                                                type: 'ExpressionStatement',
                                                                                expression: {
                                                                                    type: 'ObjectExpression',
                                                                                    objectType: {
                                                                                        type: 'CallExpression',
                                                                                        callee: {
                                                                                            type: 'Identifier',
                                                                                            name: 'Div',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 36,
                                                                                                    column: 36,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 36,
                                                                                                    column: 39,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        arguments: [],
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 36,
                                                                                                column: 36,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 36,
                                                                                                column: 41,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    properties: [{
                                                                                            type: 'ExpressionStatement',
                                                                                            expression: {
                                                                                                type: 'MemberExpression',
                                                                                                computed: true,
                                                                                                object: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'pair',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 37,
                                                                                                            column: 40,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 37,
                                                                                                            column: 44,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Literal',
                                                                                                    value: 1
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 37,
                                                                                                        column: 40,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 37,
                                                                                                        column: 47,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 37,
                                                                                                    column: 40,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 37,
                                                                                                    column: 47,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                }
                                                                                            },
                                                                                            order: '0'
                                                                                        }]
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 36,
                                                                                        column: 36,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 38,
                                                                                        column: 40,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                    }
                                                                                },
                                                                                order: '2'
                                                                            }
                                                                        ]
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 32,
                                                                            column: 32,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 38,
                                                                            column: 36,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                        }
                                                                    },
                                                                    order: '0'
                                                                }]
                                                        },
                                                        remove: null,
                                                        order: '0'
                                                    }]
                                            },
                                            loc: {
                                                start: {
                                                    line: 30,
                                                    column: 24,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                },
                                                end: {
                                                    line: 38,
                                                    column: 28,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                }
                                            },
                                            order: '2'
                                        },
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'ObjectExpression',
                                                objectType: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'Identifier',
                                                        name: 'Footer',
                                                        loc: {
                                                            start: {
                                                                line: 38,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                            },
                                                            end: {
                                                                line: 38,
                                                                column: 30,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [],
                                                    loc: {
                                                        start: {
                                                            line: 38,
                                                            column: 24,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                        },
                                                        end: {
                                                            line: 38,
                                                            column: 32,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                        }
                                                    }
                                                },
                                                properties: [{
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'ObjectExpression',
                                                            objectType: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Identifier',
                                                                    name: 'PaperButton',
                                                                    loc: {
                                                                        start: {
                                                                            line: 39,
                                                                            column: 28,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 39,
                                                                            column: 39,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [],
                                                                loc: {
                                                                    start: {
                                                                        line: 39,
                                                                        column: 28,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 39,
                                                                        column: 41,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            properties: [
                                                                {
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'Function',
                                                                        context: true,
                                                                        value: function (_context) {
                                                                            return function click() {
                                                                                var dialog = _context.get('dialog');
                                                                                dialog.open = false;
                                                                            };
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 40,
                                                                            column: 32,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 42,
                                                                            column: 36,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                        }
                                                                    },
                                                                    order: '0'
                                                                },
                                                                {
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'Literal',
                                                                        value: 'OK'
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 42,
                                                                            column: 32,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 42,
                                                                            column: 36,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                        }
                                                                    },
                                                                    order: '1'
                                                                }
                                                            ]
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 39,
                                                                column: 28,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                            },
                                                            end: {
                                                                line: 43,
                                                                column: 32,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                            }
                                                        },
                                                        order: '0'
                                                    }]
                                            },
                                            loc: {
                                                start: {
                                                    line: 38,
                                                    column: 24,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                },
                                                end: {
                                                    line: 43,
                                                    column: 28,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                }
                                            },
                                            order: '3'
                                        }
                                    ]
                                },
                                kind: 'init',
                                order: '0'
                            }]
                    },
                    order: '2'
                }
            ],
            bound: false
        }, {
            this: this,
            org: org,
            glass: glass,
            viewpath: viewpath,
            _ref: _ref,
            _ref2: _ref2,
            _ref3: _ref3,
            _ref4: _ref4,
            _ref5: _ref5,
            _ref6: _ref6,
            _ref7: _ref7,
            _ref8: _ref8,
            _ref9: _ref9,
            Http: Http,
            Key: Key,
            Button: Button,
            Icon: Icon,
            Dialog: Dialog,
            Renamer: Renamer,
            PromptDialog: PromptDialog,
            User: User,
            Organization: Organization,
            Tag: Tag,
            Project: Project,
            GenericTypePane: GenericTypePane,
            InviteUserDialog: InviteUserDialog,
            ObjectRowSource: ObjectRowSource,
            UserOrgTagsProperty: UserOrgTagsProperty,
            UserOrgCalendarsProperty: UserOrgCalendarsProperty,
            UserOrgAcceptedProperty: UserOrgAcceptedProperty,
            UserOrgInvitedProperty: UserOrgInvitedProperty,
            AdminProperty: AdminProperty,
            SubscriptionNotice: SubscriptionNotice,
            showInfoDialog: showInfoDialog
        }, null);
    }));
};
module.exports = exports = ion.template(function (urlConfig) {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'subNotice',
                            loc: {
                                start: {
                                    line: 46,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/panes/OrgPane.ion'
                                },
                                end: {
                                    line: 46,
                                    column: 17,
                                    fixed: true,
                                    source: 'viewpath/html/panes/OrgPane.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'SubscriptionNotice',
                                loc: {
                                    start: {
                                        line: 46,
                                        column: 20,
                                        fixed: true,
                                        source: 'viewpath/html/panes/OrgPane.ion'
                                    },
                                    end: {
                                        line: 46,
                                        column: 38,
                                        fixed: true,
                                        source: 'viewpath/html/panes/OrgPane.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'Literal',
                                    value: 'create and manage an organization'
                                }],
                            loc: {
                                start: {
                                    line: 46,
                                    column: 20,
                                    fixed: true,
                                    source: 'viewpath/html/panes/OrgPane.ion'
                                },
                                end: {
                                    line: 46,
                                    column: 75,
                                    fixed: true,
                                    source: 'viewpath/html/panes/OrgPane.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'IfStatement',
                test: {
                    type: 'UnaryExpression',
                    operator: '?',
                    argument: {
                        type: 'Identifier',
                        name: 'subNotice',
                        loc: {
                            start: {
                                line: 47,
                                column: 7,
                                fixed: true,
                                source: 'viewpath/html/panes/OrgPane.ion'
                            },
                            end: {
                                line: 47,
                                column: 16,
                                fixed: true,
                                source: 'viewpath/html/panes/OrgPane.ion'
                            }
                        }
                    }
                },
                consequent: {
                    type: 'BlockStatement',
                    body: [{
                            type: 'ReturnStatement',
                            argument: {
                                type: 'Identifier',
                                name: 'subNotice',
                                loc: {
                                    start: {
                                        line: 48,
                                        column: 15,
                                        fixed: true,
                                        source: 'viewpath/html/panes/OrgPane.ion'
                                    },
                                    end: {
                                        line: 48,
                                        column: 24,
                                        fixed: true,
                                        source: 'viewpath/html/panes/OrgPane.ion'
                                    }
                                }
                            },
                            order: '0'
                        }]
                },
                alternate: {
                    type: 'BlockStatement',
                    body: [
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: '_ref10'
                                    },
                                    init: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'global',
                                            loc: {
                                                start: {
                                                    line: 51,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                },
                                                end: {
                                                    line: 51,
                                                    column: 27,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'model',
                                            loc: {
                                                start: {
                                                    line: 51,
                                                    column: 28,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                },
                                                end: {
                                                    line: 51,
                                                    column: 33,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 51,
                                                column: 21,
                                                fixed: true,
                                                source: 'viewpath/html/panes/OrgPane.ion'
                                            },
                                            end: {
                                                line: 51,
                                                column: 33,
                                                fixed: true,
                                                source: 'viewpath/html/panes/OrgPane.ion'
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '0'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'user',
                                        loc: {
                                            start: {
                                                line: 51,
                                                column: 13,
                                                fixed: true,
                                                source: 'viewpath/html/panes/OrgPane.ion'
                                            },
                                            end: {
                                                line: 51,
                                                column: 17,
                                                fixed: true,
                                                source: 'viewpath/html/panes/OrgPane.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'MemberExpression',
                                        object: {
                                            type: 'Identifier',
                                            name: '_ref10'
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'user',
                                            loc: {
                                                start: {
                                                    line: 51,
                                                    column: 13,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                },
                                                end: {
                                                    line: 51,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                }
                                            }
                                        },
                                        computed: false
                                    }
                                }],
                            kind: 'let',
                            order: '1'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'orgKey',
                                        loc: {
                                            start: {
                                                line: 52,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/OrgPane.ion'
                                            },
                                            end: {
                                                line: 52,
                                                column: 18,
                                                fixed: true,
                                                source: 'viewpath/html/panes/OrgPane.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'NewExpression',
                                        callee: {
                                            type: 'Identifier',
                                            name: 'Key',
                                            loc: {
                                                start: {
                                                    line: 52,
                                                    column: 25,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                },
                                                end: {
                                                    line: 52,
                                                    column: 28,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                }
                                            }
                                        },
                                        arguments: [
                                            {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'viewpath',
                                                    loc: {
                                                        start: {
                                                            line: 52,
                                                            column: 29,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                        },
                                                        end: {
                                                            line: 52,
                                                            column: 37,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'model',
                                                    loc: {
                                                        start: {
                                                            line: 52,
                                                            column: 38,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                        },
                                                        end: {
                                                            line: 52,
                                                            column: 43,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 52,
                                                        column: 29,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                    },
                                                    end: {
                                                        line: 52,
                                                        column: 43,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                    }
                                                }
                                            },
                                            {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'urlConfig',
                                                    loc: {
                                                        start: {
                                                            line: 52,
                                                            column: 45,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                        },
                                                        end: {
                                                            line: 52,
                                                            column: 54,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'key',
                                                    loc: {
                                                        start: {
                                                            line: 52,
                                                            column: 55,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                        },
                                                        end: {
                                                            line: 52,
                                                            column: 58,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 52,
                                                        column: 45,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                    },
                                                    end: {
                                                        line: 52,
                                                        column: 58,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                    }
                                                }
                                            }
                                        ],
                                        loc: {
                                            start: {
                                                line: 52,
                                                column: 21,
                                                fixed: true,
                                                source: 'viewpath/html/panes/OrgPane.ion'
                                            },
                                            end: {
                                                line: 52,
                                                column: 59,
                                                fixed: true,
                                                source: 'viewpath/html/panes/OrgPane.ion'
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '2'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'org',
                                        loc: {
                                            start: {
                                                line: 53,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/OrgPane.ion'
                                            },
                                            end: {
                                                line: 53,
                                                column: 15,
                                                fixed: true,
                                                source: 'viewpath/html/panes/OrgPane.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'MemberExpression',
                                        computed: true,
                                        object: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'model',
                                                loc: {
                                                    start: {
                                                        line: 53,
                                                        column: 18,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                    },
                                                    end: {
                                                        line: 53,
                                                        column: 23,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'server',
                                                loc: {
                                                    start: {
                                                        line: 53,
                                                        column: 24,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                    },
                                                    end: {
                                                        line: 53,
                                                        column: 30,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 53,
                                                    column: 18,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                },
                                                end: {
                                                    line: 53,
                                                    column: 30,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'orgKey',
                                            loc: {
                                                start: {
                                                    line: 53,
                                                    column: 31,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                },
                                                end: {
                                                    line: 53,
                                                    column: 37,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 53,
                                                column: 18,
                                                fixed: true,
                                                source: 'viewpath/html/panes/OrgPane.ion'
                                            },
                                            end: {
                                                line: 53,
                                                column: 38,
                                                fixed: true,
                                                source: 'viewpath/html/panes/OrgPane.ion'
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '3'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'userKey',
                                        loc: {
                                            start: {
                                                line: 54,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/OrgPane.ion'
                                            },
                                            end: {
                                                line: 54,
                                                column: 19,
                                                fixed: true,
                                                source: 'viewpath/html/panes/OrgPane.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'user',
                                            loc: {
                                                start: {
                                                    line: 54,
                                                    column: 22,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                },
                                                end: {
                                                    line: 54,
                                                    column: 26,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'key',
                                            loc: {
                                                start: {
                                                    line: 54,
                                                    column: 27,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                },
                                                end: {
                                                    line: 54,
                                                    column: 30,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 54,
                                                column: 22,
                                                fixed: true,
                                                source: 'viewpath/html/panes/OrgPane.ion'
                                            },
                                            end: {
                                                line: 54,
                                                column: 30,
                                                fixed: true,
                                                source: 'viewpath/html/panes/OrgPane.ion'
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '4'
                        },
                        {
                            type: 'IfStatement',
                            test: {
                                type: 'UnaryExpression',
                                operator: '!',
                                argument: {
                                    type: 'UnaryExpression',
                                    operator: '?',
                                    argument: {
                                        type: 'Identifier',
                                        name: 'org',
                                        loc: {
                                            start: {
                                                line: 56,
                                                column: 15,
                                                fixed: true,
                                                source: 'viewpath/html/panes/OrgPane.ion'
                                            },
                                            end: {
                                                line: 56,
                                                column: 18,
                                                fixed: true,
                                                source: 'viewpath/html/panes/OrgPane.ion'
                                            }
                                        }
                                    }
                                }
                            },
                            consequent: {
                                type: 'BlockStatement',
                                body: [{
                                        type: 'ReturnStatement',
                                        argument: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'Identifier',
                                                name: 'Div',
                                                loc: {
                                                    start: {
                                                        line: 57,
                                                        column: 19,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                    },
                                                    end: {
                                                        line: 57,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                    }
                                                }
                                            },
                                            arguments: [],
                                            loc: {
                                                start: {
                                                    line: 57,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                },
                                                end: {
                                                    line: 57,
                                                    column: 24,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                }
                                            }
                                        },
                                        order: '0'
                                    }]
                            },
                            alternate: {
                                type: 'BlockStatement',
                                body: [
                                    {
                                        type: 'VariableDeclaration',
                                        declarations: [{
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'adminProperty',
                                                    loc: {
                                                        start: {
                                                            line: 59,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                        },
                                                        end: {
                                                            line: 59,
                                                            column: 29,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                        }
                                                    }
                                                },
                                                init: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'Identifier',
                                                        name: 'AdminProperty',
                                                        loc: {
                                                            start: {
                                                                line: 59,
                                                                column: 32,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                            },
                                                            end: {
                                                                line: 59,
                                                                column: 45,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [{
                                                            type: 'Identifier',
                                                            name: 'org',
                                                            loc: {
                                                                start: {
                                                                    line: 59,
                                                                    column: 51,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                },
                                                                end: {
                                                                    line: 59,
                                                                    column: 54,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                }
                                                            },
                                                            deep: true
                                                        }],
                                                    loc: {
                                                        start: {
                                                            line: 59,
                                                            column: 32,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                        },
                                                        end: {
                                                            line: 59,
                                                            column: 55,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                        }
                                                    }
                                                }
                                            }],
                                        kind: 'let',
                                        order: '0'
                                    },
                                    {
                                        type: 'VariableDeclaration',
                                        declarations: [{
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'isUserAdmin',
                                                    loc: {
                                                        start: {
                                                            line: 60,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                        },
                                                        end: {
                                                            line: 60,
                                                            column: 27,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                        }
                                                    }
                                                },
                                                init: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'adminProperty',
                                                                loc: {
                                                                    start: {
                                                                        line: 60,
                                                                        column: 30,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 60,
                                                                        column: 43,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'get',
                                                                loc: {
                                                                    start: {
                                                                        line: 60,
                                                                        column: 44,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 60,
                                                                        column: 47,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 60,
                                                                    column: 30,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                },
                                                                end: {
                                                                    line: 60,
                                                                    column: 47,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'call',
                                                            loc: {
                                                                start: {
                                                                    line: 60,
                                                                    column: 48,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                },
                                                                end: {
                                                                    line: 60,
                                                                    column: 52,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 60,
                                                                column: 30,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                            },
                                                            end: {
                                                                line: 60,
                                                                column: 52,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [{
                                                            type: 'Identifier',
                                                            name: 'user',
                                                            loc: {
                                                                start: {
                                                                    line: 60,
                                                                    column: 53,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                },
                                                                end: {
                                                                    line: 60,
                                                                    column: 57,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                }
                                                            }
                                                        }],
                                                    loc: {
                                                        start: {
                                                            line: 60,
                                                            column: 30,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                        },
                                                        end: {
                                                            line: 60,
                                                            column: 58,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                        }
                                                    }
                                                }
                                            }],
                                        kind: 'let',
                                        order: '1'
                                    },
                                    {
                                        type: 'ReturnStatement',
                                        argument: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'Identifier',
                                                name: 'GenericTypePane',
                                                loc: {
                                                    start: {
                                                        line: 61,
                                                        column: 19,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                    },
                                                    end: {
                                                        line: 61,
                                                        column: 34,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                    }
                                                }
                                            },
                                            arguments: [{
                                                    type: 'ObjectExpression',
                                                    objectType: {
                                                        type: 'ObjectExpression',
                                                        properties: []
                                                    },
                                                    properties: [
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'id',
                                                                loc: {
                                                                    start: {
                                                                        line: 63,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 63,
                                                                        column: 22,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Literal',
                                                                value: 'org'
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        },
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'name',
                                                                loc: {
                                                                    start: {
                                                                        line: 64,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 64,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'ArrayExpression',
                                                                elements: [
                                                                    {
                                                                        type: 'Literal',
                                                                        value: 'Organization'
                                                                    },
                                                                    {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'Identifier',
                                                                            name: 'Renamer',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 64,
                                                                                    column: 43,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 64,
                                                                                    column: 50,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [{
                                                                                type: 'ObjectExpression',
                                                                                properties: [
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'object',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 64,
                                                                                                    column: 52,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 64,
                                                                                                    column: 58,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Identifier',
                                                                                            name: 'org',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 64,
                                                                                                    column: 59,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 64,
                                                                                                    column: 62,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'prompt',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 64,
                                                                                                    column: 63,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 64,
                                                                                                    column: 69,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 'Rename the Organization'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '1'
                                                                                    }
                                                                                ]
                                                                            }],
                                                                        loc: {
                                                                            start: {
                                                                                line: 64,
                                                                                column: 43,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 64,
                                                                                column: 97,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                            }
                                                                        }
                                                                    }
                                                                ]
                                                            },
                                                            kind: 'init',
                                                            order: '1'
                                                        },
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'state',
                                                                loc: {
                                                                    start: {
                                                                        line: 65,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 65,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Identifier',
                                                                name: 'urlConfig',
                                                                loc: {
                                                                    start: {
                                                                        line: 65,
                                                                        column: 27,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 65,
                                                                        column: 36,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '2'
                                                        },
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'tabs',
                                                                loc: {
                                                                    start: {
                                                                        line: 66,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 66,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'ObjectExpression',
                                                                objectType: {
                                                                    type: 'ArrayExpression',
                                                                    elements: []
                                                                },
                                                                properties: [
                                                                    {
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'ObjectExpression',
                                                                            objectType: {
                                                                                type: 'ObjectExpression',
                                                                                properties: [
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'id',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 67,
                                                                                                    column: 25,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 67,
                                                                                                    column: 27,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 'users'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'name',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 67,
                                                                                                    column: 37,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 67,
                                                                                                    column: 41,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 'Members'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '1'
                                                                                    }
                                                                                ]
                                                                            },
                                                                            properties: [
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'type',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 68,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 68,
                                                                                                column: 32,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Identifier',
                                                                                        name: 'User',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 68,
                                                                                                column: 34,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 68,
                                                                                                column: 38,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'properties',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 69,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 69,
                                                                                                column: 38,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'ObjectExpression',
                                                                                        objectType: {
                                                                                            type: 'ObjectExpression',
                                                                                            properties: []
                                                                                        },
                                                                                        properties: [
                                                                                            {
                                                                                                type: 'ForInStatement',
                                                                                                left: {
                                                                                                    type: 'VariableDeclaration',
                                                                                                    declarations: [
                                                                                                        {
                                                                                                            type: 'VariableDeclarator',
                                                                                                            id: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'key',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 70,
                                                                                                                        column: 36,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 70,
                                                                                                                        column: 39,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            init: null
                                                                                                        },
                                                                                                        {
                                                                                                            type: 'VariableDeclarator',
                                                                                                            id: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'value',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 70,
                                                                                                                        column: 41,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 70,
                                                                                                                        column: 46,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            init: null
                                                                                                        }
                                                                                                    ],
                                                                                                    kind: 'let'
                                                                                                },
                                                                                                right: {
                                                                                                    type: 'MemberExpression',
                                                                                                    computed: false,
                                                                                                    object: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'User',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 70,
                                                                                                                column: 50,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 70,
                                                                                                                column: 54,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    property: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'properties',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 70,
                                                                                                                column: 55,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 70,
                                                                                                                column: 65,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 70,
                                                                                                            column: 50,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 70,
                                                                                                            column: 65,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                body: {
                                                                                                    type: 'BlockStatement',
                                                                                                    body: [{
                                                                                                            type: 'Property',
                                                                                                            key: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'key',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 71,
                                                                                                                        column: 37,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 71,
                                                                                                                        column: 40,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            value: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'value',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 71,
                                                                                                                        column: 43,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 71,
                                                                                                                        column: 48,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            kind: 'init',
                                                                                                            computed: true,
                                                                                                            order: '0'
                                                                                                        }]
                                                                                                },
                                                                                                remove: null,
                                                                                                order: '0'
                                                                                            },
                                                                                            {
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'tags',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 72,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 72,
                                                                                                            column: 36,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'CallExpression',
                                                                                                    callee: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'UserOrgTagsProperty',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 72,
                                                                                                                column: 38,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 72,
                                                                                                                column: 57,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    arguments: [{
                                                                                                            type: 'Identifier',
                                                                                                            name: 'org',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 72,
                                                                                                                    column: 58,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 72,
                                                                                                                    column: 61,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        }],
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 72,
                                                                                                            column: 38,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 72,
                                                                                                            column: 62,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '1'
                                                                                            },
                                                                                            {
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'invited',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 73,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 73,
                                                                                                            column: 39,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'CallExpression',
                                                                                                    callee: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'UserOrgInvitedProperty',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 73,
                                                                                                                column: 41,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 73,
                                                                                                                column: 63,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    arguments: [{
                                                                                                            type: 'Identifier',
                                                                                                            name: 'org',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 73,
                                                                                                                    column: 64,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 73,
                                                                                                                    column: 67,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        }],
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 73,
                                                                                                            column: 41,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 73,
                                                                                                            column: 68,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '2'
                                                                                            },
                                                                                            {
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'accepted',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 74,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 74,
                                                                                                            column: 40,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'CallExpression',
                                                                                                    callee: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'UserOrgAcceptedProperty',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 74,
                                                                                                                column: 42,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 74,
                                                                                                                column: 65,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    arguments: [{
                                                                                                            type: 'Identifier',
                                                                                                            name: 'org',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 74,
                                                                                                                    column: 66,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 74,
                                                                                                                    column: 69,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        }],
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 74,
                                                                                                            column: 42,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 74,
                                                                                                            column: 70,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '3'
                                                                                            },
                                                                                            {
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'calendars',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 75,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 75,
                                                                                                            column: 41,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'CallExpression',
                                                                                                    callee: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'UserOrgCalendarsProperty',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 75,
                                                                                                                column: 43,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 75,
                                                                                                                column: 67,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    arguments: [{
                                                                                                            type: 'Identifier',
                                                                                                            name: 'org',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 75,
                                                                                                                    column: 68,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 75,
                                                                                                                    column: 71,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        }],
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 75,
                                                                                                            column: 43,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 75,
                                                                                                            column: 72,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '4'
                                                                                            },
                                                                                            {
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'admin',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 76,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 76,
                                                                                                            column: 37,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'adminProperty',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 76,
                                                                                                            column: 39,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 76,
                                                                                                            column: 52,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '5'
                                                                                            },
                                                                                            {
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'timeline',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 77,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 77,
                                                                                                            column: 40,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'ObjectExpression',
                                                                                                    properties: [
                                                                                                        {
                                                                                                            type: 'Property',
                                                                                                            key: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'columnType',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 77,
                                                                                                                        column: 43,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 77,
                                                                                                                        column: 53,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            value: {
                                                                                                                type: 'Literal',
                                                                                                                value: 'glass/html/material/DataTable2/TimelineColumn'
                                                                                                            },
                                                                                                            kind: 'init',
                                                                                                            order: '0'
                                                                                                        },
                                                                                                        {
                                                                                                            type: 'Property',
                                                                                                            key: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'name',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 77,
                                                                                                                        column: 103,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 77,
                                                                                                                        column: 107,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            value: {
                                                                                                                type: 'Literal',
                                                                                                                value: 'Timeline'
                                                                                                            },
                                                                                                            kind: 'init',
                                                                                                            order: '1'
                                                                                                        }
                                                                                                    ]
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '6'
                                                                                            }
                                                                                        ]
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '1'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'columns',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 78,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 78,
                                                                                                column: 35,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'ObjectExpression',
                                                                                        objectType: {
                                                                                            type: 'ArrayExpression',
                                                                                            elements: []
                                                                                        },
                                                                                        properties: [
                                                                                            {
                                                                                                type: 'ExpressionStatement',
                                                                                                expression: {
                                                                                                    type: 'Literal',
                                                                                                    value: 'name'
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 79,
                                                                                                        column: 32,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 79,
                                                                                                        column: 38,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                    }
                                                                                                },
                                                                                                order: '0'
                                                                                            },
                                                                                            {
                                                                                                type: 'ExpressionStatement',
                                                                                                expression: {
                                                                                                    type: 'Literal',
                                                                                                    value: 'tags'
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 80,
                                                                                                        column: 32,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 80,
                                                                                                        column: 38,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                    }
                                                                                                },
                                                                                                order: '1'
                                                                                            },
                                                                                            {
                                                                                                type: 'ExpressionStatement',
                                                                                                expression: {
                                                                                                    type: 'Literal',
                                                                                                    value: 'email'
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 81,
                                                                                                        column: 32,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 81,
                                                                                                        column: 39,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                    }
                                                                                                },
                                                                                                order: '2'
                                                                                            },
                                                                                            {
                                                                                                type: 'ExpressionStatement',
                                                                                                expression: {
                                                                                                    type: 'Literal',
                                                                                                    value: 'admin'
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 82,
                                                                                                        column: 32,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 82,
                                                                                                        column: 39,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                    }
                                                                                                },
                                                                                                order: '3'
                                                                                            },
                                                                                            {
                                                                                                type: 'ExpressionStatement',
                                                                                                expression: {
                                                                                                    type: 'Literal',
                                                                                                    value: 'calendars'
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 83,
                                                                                                        column: 32,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 83,
                                                                                                        column: 43,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                    }
                                                                                                },
                                                                                                order: '4'
                                                                                            },
                                                                                            {
                                                                                                type: 'ExpressionStatement',
                                                                                                expression: {
                                                                                                    type: 'Literal',
                                                                                                    value: 'invited'
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 84,
                                                                                                        column: 32,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 84,
                                                                                                        column: 41,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                    }
                                                                                                },
                                                                                                order: '5'
                                                                                            },
                                                                                            {
                                                                                                type: 'ExpressionStatement',
                                                                                                expression: {
                                                                                                    type: 'Literal',
                                                                                                    value: 'accepted'
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 85,
                                                                                                        column: 32,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 85,
                                                                                                        column: 42,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                    }
                                                                                                },
                                                                                                order: '6'
                                                                                            },
                                                                                            {
                                                                                                type: 'ExpressionStatement',
                                                                                                expression: {
                                                                                                    type: 'Literal',
                                                                                                    value: 'timeline'
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 86,
                                                                                                        column: 32,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 86,
                                                                                                        column: 42,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                    }
                                                                                                },
                                                                                                order: '7'
                                                                                            }
                                                                                        ]
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '2'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'where',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 87,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 87,
                                                                                                column: 33,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'ObjectExpression',
                                                                                        properties: [{
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'orgIds',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 88,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 88,
                                                                                                            column: 38,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'MemberExpression',
                                                                                                    computed: false,
                                                                                                    object: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'orgKey',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 88,
                                                                                                                column: 40,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 88,
                                                                                                                column: 46,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    property: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'id',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 88,
                                                                                                                column: 47,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 88,
                                                                                                                column: 49,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 88,
                                                                                                            column: 40,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 88,
                                                                                                            column: 49,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '0'
                                                                                            }]
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '3'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'sorts',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 89,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 89,
                                                                                                column: 33,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'ObjectExpression',
                                                                                        objectType: {
                                                                                            type: 'ArrayExpression',
                                                                                            elements: []
                                                                                        },
                                                                                        properties: [{
                                                                                                type: 'ExpressionStatement',
                                                                                                expression: {
                                                                                                    type: 'ArrayExpression',
                                                                                                    elements: [{
                                                                                                            type: 'ObjectExpression',
                                                                                                            properties: [{
                                                                                                                    type: 'Property',
                                                                                                                    key: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'name',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 90,
                                                                                                                                column: 34,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 90,
                                                                                                                                column: 38,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    value: {
                                                                                                                        type: 'Literal',
                                                                                                                        value: true
                                                                                                                    },
                                                                                                                    kind: 'init',
                                                                                                                    order: '0'
                                                                                                                }]
                                                                                                        }]
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 90,
                                                                                                        column: 32,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 90,
                                                                                                        column: 45,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                    }
                                                                                                },
                                                                                                order: '0'
                                                                                            }]
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '4'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'create',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 91,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 91,
                                                                                                column: 34,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'ObjectExpression',
                                                                                        properties: [
                                                                                            {
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'title',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 92,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 92,
                                                                                                            column: 37,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'Literal',
                                                                                                    value: 'Invite new member'
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '0'
                                                                                            },
                                                                                            {
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'handler',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 93,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 93,
                                                                                                            column: 39,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'Function',
                                                                                                    context: true,
                                                                                                    value: function (_context2) {
                                                                                                        return function (_ref11) {
                                                                                                            var Dialog = _context2.get('Dialog'), InviteUserDialog = _context2.get('InviteUserDialog'), org = _context2.get('org');
                                                                                                            var e = _ref11.e;
                                                                                                            var dataTableModel = _ref11.dataTableModel;
                                                                                                            Dialog.show(InviteUserDialog, {
                                                                                                                model: global.model,
                                                                                                                org: org,
                                                                                                                callback: function (user) {
                                                                                                                    return dataTableModel.rowSource.insertRecord(user);
                                                                                                                }
                                                                                                            });
                                                                                                        };
                                                                                                    }
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '1'
                                                                                            }
                                                                                        ]
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '5'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Literal',
                                                                                        value: 'delete'
                                                                                    },
                                                                                    value: {
                                                                                        type: 'ObjectExpression',
                                                                                        properties: [
                                                                                            {
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'title',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 100,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 100,
                                                                                                            column: 37,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'Literal',
                                                                                                    value: 'Remove member'
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '0'
                                                                                            },
                                                                                            {
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'handler',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 101,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 101,
                                                                                                            column: 39,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'Function',
                                                                                                    context: true,
                                                                                                    value: function (_context3) {
                                                                                                        return function (_ref12) {
                                                                                                            var orgKey = _context3.get('orgKey');
                                                                                                            var e = _ref12.e;
                                                                                                            var dataTableModel = _ref12.dataTableModel;
                                                                                                            dataTableModel.beginOp();
                                                                                                            {
                                                                                                                var _ref16 = dataTableModel.selectedRows;
                                                                                                                for (var _i = 0; _i < _ref16.length; _i++) {
                                                                                                                    var row = _ref16[_i];
                                                                                                                    row.record.removeFromOrg(orgKey);
                                                                                                                }
                                                                                                            }
                                                                                                        };
                                                                                                    }
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '1'
                                                                                            }
                                                                                        ]
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '6'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'toolbar',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 105,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 105,
                                                                                                column: 35,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'ObjectExpression',
                                                                                        properties: [
                                                                                            {
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'center',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 106,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 106,
                                                                                                            column: 38,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'Function',
                                                                                                    context: true,
                                                                                                    value: function (_ps) {
                                                                                                        return ion.template(function (_ref13) {
                                                                                                            return ion.createRuntime({
                                                                                                                type: 'Template',
                                                                                                                id: null,
                                                                                                                body: [
                                                                                                                    {
                                                                                                                        type: 'VariableDeclaration',
                                                                                                                        declarations: [{
                                                                                                                                type: 'VariableDeclarator',
                                                                                                                                id: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'dataTableModel',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 106,
                                                                                                                                            column: 50,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 106,
                                                                                                                                            column: 64,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                init: {
                                                                                                                                    type: 'MemberExpression',
                                                                                                                                    object: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: '_ref13'
                                                                                                                                    },
                                                                                                                                    property: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'dataTableModel',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 106,
                                                                                                                                                column: 50,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 106,
                                                                                                                                                column: 64,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    computed: false
                                                                                                                                }
                                                                                                                            }],
                                                                                                                        kind: 'let',
                                                                                                                        order: '0'
                                                                                                                    },
                                                                                                                    {
                                                                                                                        type: 'ReturnStatement',
                                                                                                                        argument: {
                                                                                                                            type: 'ObjectExpression',
                                                                                                                            objectType: {
                                                                                                                                type: 'CallExpression',
                                                                                                                                callee: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'Div',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 107,
                                                                                                                                            column: 43,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 107,
                                                                                                                                            column: 46,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                arguments: [],
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 107,
                                                                                                                                        column: 43,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 107,
                                                                                                                                        column: 48,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            properties: [{
                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                    expression: {
                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                        objectType: {
                                                                                                                                            type: 'CallExpression',
                                                                                                                                            callee: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'PaperIconButton',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 108,
                                                                                                                                                        column: 40,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 108,
                                                                                                                                                        column: 55,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            arguments: [],
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 108,
                                                                                                                                                    column: 40,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 108,
                                                                                                                                                    column: 57,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        properties: [
                                                                                                                                            {
                                                                                                                                                type: 'Property',
                                                                                                                                                key: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'icon',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 109,
                                                                                                                                                            column: 44,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 109,
                                                                                                                                                            column: 48,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                value: {
                                                                                                                                                    type: 'Literal',
                                                                                                                                                    value: 'refresh'
                                                                                                                                                },
                                                                                                                                                kind: 'init',
                                                                                                                                                order: '0'
                                                                                                                                            },
                                                                                                                                            {
                                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                                expression: {
                                                                                                                                                    type: 'Function',
                                                                                                                                                    context: true,
                                                                                                                                                    value: function (_context4) {
                                                                                                                                                        return function click(e) {
                                                                                                                                                            var dataTableModel = _context4.get('dataTableModel');
                                                                                                                                                            dataTableModel.refresh();
                                                                                                                                                        };
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 110,
                                                                                                                                                        column: 44,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 112,
                                                                                                                                                        column: 48,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                order: '1'
                                                                                                                                            }
                                                                                                                                        ]
                                                                                                                                    },
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 108,
                                                                                                                                            column: 40,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 112,
                                                                                                                                            column: 44,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    order: '0'
                                                                                                                                }]
                                                                                                                        },
                                                                                                                        order: '1'
                                                                                                                    }
                                                                                                                ],
                                                                                                                bound: false,
                                                                                                                name: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'center',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 106,
                                                                                                                            column: 32,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 106,
                                                                                                                            column: 38,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                scope: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: '_ps'
                                                                                                                }
                                                                                                            }, {
                                                                                                                this: this,
                                                                                                                _ref13: _ref13,
                                                                                                                _ps: _ps,
                                                                                                                urlConfig: urlConfig,
                                                                                                                glass: glass,
                                                                                                                viewpath: viewpath,
                                                                                                                _ref: _ref,
                                                                                                                _ref2: _ref2,
                                                                                                                _ref3: _ref3,
                                                                                                                _ref4: _ref4,
                                                                                                                _ref5: _ref5,
                                                                                                                _ref6: _ref6,
                                                                                                                _ref7: _ref7,
                                                                                                                _ref8: _ref8,
                                                                                                                _ref9: _ref9,
                                                                                                                Http: Http,
                                                                                                                Key: Key,
                                                                                                                Button: Button,
                                                                                                                Icon: Icon,
                                                                                                                Dialog: Dialog,
                                                                                                                Renamer: Renamer,
                                                                                                                PromptDialog: PromptDialog,
                                                                                                                User: User,
                                                                                                                Organization: Organization,
                                                                                                                Tag: Tag,
                                                                                                                Project: Project,
                                                                                                                GenericTypePane: GenericTypePane,
                                                                                                                InviteUserDialog: InviteUserDialog,
                                                                                                                ObjectRowSource: ObjectRowSource,
                                                                                                                UserOrgTagsProperty: UserOrgTagsProperty,
                                                                                                                UserOrgCalendarsProperty: UserOrgCalendarsProperty,
                                                                                                                UserOrgAcceptedProperty: UserOrgAcceptedProperty,
                                                                                                                UserOrgInvitedProperty: UserOrgInvitedProperty,
                                                                                                                AdminProperty: AdminProperty,
                                                                                                                SubscriptionNotice: SubscriptionNotice,
                                                                                                                showInfoDialog: showInfoDialog
                                                                                                            }, _ps);
                                                                                                        });
                                                                                                    }
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '0'
                                                                                            },
                                                                                            {
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'right',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 112,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 112,
                                                                                                            column: 37,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'Function',
                                                                                                    context: true,
                                                                                                    value: function (_ps2) {
                                                                                                        return ion.template(function (_ref14) {
                                                                                                            return ion.createRuntime({
                                                                                                                type: 'Template',
                                                                                                                id: null,
                                                                                                                body: [
                                                                                                                    {
                                                                                                                        type: 'VariableDeclaration',
                                                                                                                        declarations: [{
                                                                                                                                type: 'VariableDeclarator',
                                                                                                                                id: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'dataTable',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 112,
                                                                                                                                            column: 50,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 112,
                                                                                                                                            column: 59,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                init: {
                                                                                                                                    type: 'MemberExpression',
                                                                                                                                    object: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: '_ref14'
                                                                                                                                    },
                                                                                                                                    property: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'dataTable',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 112,
                                                                                                                                                column: 50,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 112,
                                                                                                                                                column: 59,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    computed: false
                                                                                                                                }
                                                                                                                            }],
                                                                                                                        kind: 'let',
                                                                                                                        order: '0'
                                                                                                                    },
                                                                                                                    {
                                                                                                                        type: 'VariableDeclaration',
                                                                                                                        declarations: [{
                                                                                                                                type: 'VariableDeclarator',
                                                                                                                                id: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'dataTableModel',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 112,
                                                                                                                                            column: 60,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 112,
                                                                                                                                            column: 74,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                init: {
                                                                                                                                    type: 'MemberExpression',
                                                                                                                                    object: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: '_ref14'
                                                                                                                                    },
                                                                                                                                    property: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'dataTableModel',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 112,
                                                                                                                                                column: 60,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 112,
                                                                                                                                                column: 74,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    computed: false
                                                                                                                                }
                                                                                                                            }],
                                                                                                                        kind: 'let',
                                                                                                                        order: '1'
                                                                                                                    },
                                                                                                                    {
                                                                                                                        type: 'VariableDeclaration',
                                                                                                                        declarations: [{
                                                                                                                                type: 'VariableDeclarator',
                                                                                                                                id: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'timelineColumn',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 113,
                                                                                                                                            column: 40,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 113,
                                                                                                                                            column: 54,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                init: {
                                                                                                                                    type: 'CallExpression',
                                                                                                                                    callee: {
                                                                                                                                        type: 'MemberExpression',
                                                                                                                                        computed: false,
                                                                                                                                        object: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'dataTableModel',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 113,
                                                                                                                                                    column: 57,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 113,
                                                                                                                                                    column: 71,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        property: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'getColumn',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 113,
                                                                                                                                                    column: 72,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 113,
                                                                                                                                                    column: 81,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 113,
                                                                                                                                                column: 57,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 113,
                                                                                                                                                column: 81,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    arguments: [
                                                                                                                                        {
                                                                                                                                            type: 'Literal',
                                                                                                                                            value: 'Timeline'
                                                                                                                                        },
                                                                                                                                        {
                                                                                                                                            type: 'MemberExpression',
                                                                                                                                            computed: false,
                                                                                                                                            object: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'dataTableModel',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 113,
                                                                                                                                                        column: 94,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 113,
                                                                                                                                                        column: 108,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            property: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'columns',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 113,
                                                                                                                                                        column: 109,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 113,
                                                                                                                                                        column: 116,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 113,
                                                                                                                                                    column: 94,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 113,
                                                                                                                                                    column: 116,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    ],
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 113,
                                                                                                                                            column: 57,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 113,
                                                                                                                                            column: 117,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            }],
                                                                                                                        kind: 'let',
                                                                                                                        order: '2'
                                                                                                                    },
                                                                                                                    {
                                                                                                                        type: 'ReturnStatement',
                                                                                                                        argument: {
                                                                                                                            type: 'ObjectExpression',
                                                                                                                            objectType: {
                                                                                                                                type: 'CallExpression',
                                                                                                                                callee: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'Div',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 114,
                                                                                                                                            column: 43,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 114,
                                                                                                                                            column: 46,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                arguments: [{
                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                        properties: [{
                                                                                                                                                type: 'Property',
                                                                                                                                                key: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'class',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 114,
                                                                                                                                                            column: 48,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 114,
                                                                                                                                                            column: 53,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                value: {
                                                                                                                                                    type: 'Literal',
                                                                                                                                                    value: 'layout horizontal fill'
                                                                                                                                                },
                                                                                                                                                kind: 'init',
                                                                                                                                                order: '0'
                                                                                                                                            }]
                                                                                                                                    }],
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 114,
                                                                                                                                        column: 43,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 114,
                                                                                                                                        column: 80,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            properties: [
                                                                                                                                {
                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                    expression: {
                                                                                                                                        type: 'CallExpression',
                                                                                                                                        callee: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'Div',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 115,
                                                                                                                                                    column: 40,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 115,
                                                                                                                                                    column: 43,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        arguments: [{
                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                properties: [{
                                                                                                                                                        type: 'Property',
                                                                                                                                                        key: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'class',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 115,
                                                                                                                                                                    column: 45,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 115,
                                                                                                                                                                    column: 50,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        value: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: 'fill'
                                                                                                                                                        },
                                                                                                                                                        kind: 'init',
                                                                                                                                                        order: '0'
                                                                                                                                                    }]
                                                                                                                                            }],
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 115,
                                                                                                                                                column: 40,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 115,
                                                                                                                                                column: 59,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 115,
                                                                                                                                            column: 40,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 115,
                                                                                                                                            column: 59,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    order: '0'
                                                                                                                                },
                                                                                                                                {
                                                                                                                                    type: 'IfStatement',
                                                                                                                                    test: {
                                                                                                                                        type: 'UnaryExpression',
                                                                                                                                        operator: '?',
                                                                                                                                        argument: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'timelineColumn',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 116,
                                                                                                                                                    column: 43,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 116,
                                                                                                                                                    column: 57,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    consequent: {
                                                                                                                                        type: 'BlockStatement',
                                                                                                                                        body: [
                                                                                                                                            {
                                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                                expression: {
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    objectType: {
                                                                                                                                                        type: 'CallExpression',
                                                                                                                                                        callee: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'PaperIconButton',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 117,
                                                                                                                                                                    column: 44,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 117,
                                                                                                                                                                    column: 59,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        arguments: [],
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 117,
                                                                                                                                                                column: 44,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 117,
                                                                                                                                                                column: 61,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    properties: [
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'icon',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 118,
                                                                                                                                                                        column: 48,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 118,
                                                                                                                                                                        column: 52,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: 'zoom-in'
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '0'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'disabled',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 119,
                                                                                                                                                                        column: 48,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 119,
                                                                                                                                                                        column: 56,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'UnaryExpression',
                                                                                                                                                                operator: '!',
                                                                                                                                                                argument: {
                                                                                                                                                                    type: 'MemberExpression',
                                                                                                                                                                    computed: false,
                                                                                                                                                                    object: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'timelineColumn',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 119,
                                                                                                                                                                                column: 62,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 119,
                                                                                                                                                                                column: 76,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    property: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'canZoomIn',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 119,
                                                                                                                                                                                column: 77,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 119,
                                                                                                                                                                                column: 86,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 119,
                                                                                                                                                                            column: 62,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 119,
                                                                                                                                                                            column: 86,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '1'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                                            expression: {
                                                                                                                                                                type: 'Function',
                                                                                                                                                                context: true,
                                                                                                                                                                value: function (_context5) {
                                                                                                                                                                    return function click(e) {
                                                                                                                                                                        var timelineColumn = _context5.get('timelineColumn');
                                                                                                                                                                        timelineColumn.zoomIn();
                                                                                                                                                                    };
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 120,
                                                                                                                                                                    column: 48,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 122,
                                                                                                                                                                    column: 52,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            order: '2'
                                                                                                                                                        }
                                                                                                                                                    ]
                                                                                                                                                },
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 117,
                                                                                                                                                        column: 44,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 122,
                                                                                                                                                        column: 48,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                order: '0'
                                                                                                                                            },
                                                                                                                                            {
                                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                                expression: {
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    objectType: {
                                                                                                                                                        type: 'CallExpression',
                                                                                                                                                        callee: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'PaperIconButton',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 122,
                                                                                                                                                                    column: 44,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 122,
                                                                                                                                                                    column: 59,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        arguments: [],
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 122,
                                                                                                                                                                column: 44,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 122,
                                                                                                                                                                column: 61,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    properties: [
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'icon',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 123,
                                                                                                                                                                        column: 48,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 123,
                                                                                                                                                                        column: 52,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: 'zoom-out'
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '0'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'disabled',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 124,
                                                                                                                                                                        column: 48,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 124,
                                                                                                                                                                        column: 56,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'UnaryExpression',
                                                                                                                                                                operator: '!',
                                                                                                                                                                argument: {
                                                                                                                                                                    type: 'MemberExpression',
                                                                                                                                                                    computed: false,
                                                                                                                                                                    object: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'timelineColumn',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 124,
                                                                                                                                                                                column: 62,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 124,
                                                                                                                                                                                column: 76,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    property: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'canZoomOut',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 124,
                                                                                                                                                                                column: 77,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 124,
                                                                                                                                                                                column: 87,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 124,
                                                                                                                                                                            column: 62,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 124,
                                                                                                                                                                            column: 87,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '1'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                                            expression: {
                                                                                                                                                                type: 'Function',
                                                                                                                                                                context: true,
                                                                                                                                                                value: function (_context6) {
                                                                                                                                                                    return function click(e) {
                                                                                                                                                                        var timelineColumn = _context6.get('timelineColumn');
                                                                                                                                                                        timelineColumn.zoomOut();
                                                                                                                                                                    };
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 125,
                                                                                                                                                                    column: 48,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 127,
                                                                                                                                                                    column: 52,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            order: '2'
                                                                                                                                                        }
                                                                                                                                                    ]
                                                                                                                                                },
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 122,
                                                                                                                                                        column: 44,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 127,
                                                                                                                                                        column: 48,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                order: '1'
                                                                                                                                            }
                                                                                                                                        ]
                                                                                                                                    },
                                                                                                                                    alternate: null,
                                                                                                                                    order: '1'
                                                                                                                                },
                                                                                                                                {
                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                    expression: {
                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                        objectType: {
                                                                                                                                            type: 'CallExpression',
                                                                                                                                            callee: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'PaperMenuButton',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 127,
                                                                                                                                                        column: 40,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 127,
                                                                                                                                                        column: 55,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            arguments: [],
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 127,
                                                                                                                                                    column: 40,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 127,
                                                                                                                                                    column: 57,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        properties: [
                                                                                                                                            {
                                                                                                                                                type: 'Property',
                                                                                                                                                key: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'style',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 128,
                                                                                                                                                            column: 44,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 128,
                                                                                                                                                            column: 49,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                value: {
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    properties: [{
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'padding',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 128,
                                                                                                                                                                        column: 52,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 128,
                                                                                                                                                                        column: 59,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: '0px'
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '0'
                                                                                                                                                        }]
                                                                                                                                                },
                                                                                                                                                kind: 'init',
                                                                                                                                                order: '0'
                                                                                                                                            },
                                                                                                                                            {
                                                                                                                                                type: 'Property',
                                                                                                                                                key: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'closeOnActivate',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 129,
                                                                                                                                                            column: 44,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 129,
                                                                                                                                                            column: 59,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                value: {
                                                                                                                                                    type: 'Literal',
                                                                                                                                                    value: true
                                                                                                                                                },
                                                                                                                                                kind: 'init',
                                                                                                                                                order: '1'
                                                                                                                                            },
                                                                                                                                            {
                                                                                                                                                type: 'Property',
                                                                                                                                                key: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'restoreFocusOnClose',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 130,
                                                                                                                                                            column: 44,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 130,
                                                                                                                                                            column: 63,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                value: {
                                                                                                                                                    type: 'Literal',
                                                                                                                                                    value: false
                                                                                                                                                },
                                                                                                                                                kind: 'init',
                                                                                                                                                order: '2'
                                                                                                                                            },
                                                                                                                                            {
                                                                                                                                                type: 'Property',
                                                                                                                                                key: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'horizontalAlign',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 131,
                                                                                                                                                            column: 44,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 131,
                                                                                                                                                            column: 59,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                value: {
                                                                                                                                                    type: 'Literal',
                                                                                                                                                    value: 'right'
                                                                                                                                                },
                                                                                                                                                kind: 'init',
                                                                                                                                                order: '3'
                                                                                                                                            },
                                                                                                                                            {
                                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                                expression: {
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    objectType: {
                                                                                                                                                        type: 'CallExpression',
                                                                                                                                                        callee: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'PaperIconButton',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 132,
                                                                                                                                                                    column: 44,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 132,
                                                                                                                                                                    column: 59,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        arguments: [{
                                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                                properties: [{
                                                                                                                                                                        type: 'Property',
                                                                                                                                                                        key: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'class',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 132,
                                                                                                                                                                                    column: 61,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 132,
                                                                                                                                                                                    column: 66,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        value: {
                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                            value: 'dropdown-trigger'
                                                                                                                                                                        },
                                                                                                                                                                        kind: 'init',
                                                                                                                                                                        order: '0'
                                                                                                                                                                    }]
                                                                                                                                                            }],
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 132,
                                                                                                                                                                column: 44,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 132,
                                                                                                                                                                column: 87,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    properties: [{
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'icon',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 133,
                                                                                                                                                                        column: 48,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 133,
                                                                                                                                                                        column: 52,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: 'more-vert'
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '0'
                                                                                                                                                        }]
                                                                                                                                                },
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 132,
                                                                                                                                                        column: 44,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 134,
                                                                                                                                                        column: 48,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                order: '4'
                                                                                                                                            },
                                                                                                                                            {
                                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                                expression: {
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    objectType: {
                                                                                                                                                        type: 'CallExpression',
                                                                                                                                                        callee: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'PaperMenu',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 134,
                                                                                                                                                                    column: 44,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 134,
                                                                                                                                                                    column: 53,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        arguments: [{
                                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                                properties: [{
                                                                                                                                                                        type: 'Property',
                                                                                                                                                                        key: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'class',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 134,
                                                                                                                                                                                    column: 55,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 134,
                                                                                                                                                                                    column: 60,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        value: {
                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                            value: 'dropdown-content'
                                                                                                                                                                        },
                                                                                                                                                                        kind: 'init',
                                                                                                                                                                        order: '0'
                                                                                                                                                                    }]
                                                                                                                                                            }],
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 134,
                                                                                                                                                                column: 44,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 134,
                                                                                                                                                                column: 81,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    properties: [
                                                                                                                                                        {
                                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                                            expression: {
                                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                                objectType: {
                                                                                                                                                                    type: 'CallExpression',
                                                                                                                                                                    callee: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'PaperIconItem',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 135,
                                                                                                                                                                                column: 48,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 135,
                                                                                                                                                                                column: 61,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    arguments: [],
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 135,
                                                                                                                                                                            column: 48,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 135,
                                                                                                                                                                            column: 63,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                properties: [
                                                                                                                                                                    {
                                                                                                                                                                        type: 'ExpressionStatement',
                                                                                                                                                                        expression: {
                                                                                                                                                                            type: 'ObjectExpression',
                                                                                                                                                                            objectType: {
                                                                                                                                                                                type: 'CallExpression',
                                                                                                                                                                                callee: {
                                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                                    name: 'IronIcon',
                                                                                                                                                                                    loc: {
                                                                                                                                                                                        start: {
                                                                                                                                                                                            line: 136,
                                                                                                                                                                                            column: 52,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                                        },
                                                                                                                                                                                        end: {
                                                                                                                                                                                            line: 136,
                                                                                                                                                                                            column: 60,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                                        }
                                                                                                                                                                                    }
                                                                                                                                                                                },
                                                                                                                                                                                arguments: [{
                                                                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                                                                        properties: [{
                                                                                                                                                                                                type: 'Property',
                                                                                                                                                                                                key: {
                                                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                                                    value: 'item-icon'
                                                                                                                                                                                                },
                                                                                                                                                                                                value: {
                                                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                                                    value: true
                                                                                                                                                                                                },
                                                                                                                                                                                                kind: 'init',
                                                                                                                                                                                                order: '0'
                                                                                                                                                                                            }]
                                                                                                                                                                                    }],
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 136,
                                                                                                                                                                                        column: 52,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 136,
                                                                                                                                                                                        column: 80,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            properties: [{
                                                                                                                                                                                    type: 'Property',
                                                                                                                                                                                    key: {
                                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                                        name: 'icon',
                                                                                                                                                                                        loc: {
                                                                                                                                                                                            start: {
                                                                                                                                                                                                line: 137,
                                                                                                                                                                                                column: 56,
                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                                            },
                                                                                                                                                                                            end: {
                                                                                                                                                                                                line: 137,
                                                                                                                                                                                                column: 60,
                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                                            }
                                                                                                                                                                                        }
                                                                                                                                                                                    },
                                                                                                                                                                                    value: {
                                                                                                                                                                                        type: 'Literal',
                                                                                                                                                                                        value: 'info'
                                                                                                                                                                                    },
                                                                                                                                                                                    kind: 'init',
                                                                                                                                                                                    order: '0'
                                                                                                                                                                                }]
                                                                                                                                                                        },
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 136,
                                                                                                                                                                                column: 52,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 138,
                                                                                                                                                                                column: 56,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        order: '0'
                                                                                                                                                                    },
                                                                                                                                                                    {
                                                                                                                                                                        type: 'ExpressionStatement',
                                                                                                                                                                        expression: {
                                                                                                                                                                            type: 'ObjectExpression',
                                                                                                                                                                            objectType: {
                                                                                                                                                                                type: 'CallExpression',
                                                                                                                                                                                callee: {
                                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                                    name: 'Span',
                                                                                                                                                                                    loc: {
                                                                                                                                                                                        start: {
                                                                                                                                                                                            line: 138,
                                                                                                                                                                                            column: 52,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                                        },
                                                                                                                                                                                        end: {
                                                                                                                                                                                            line: 138,
                                                                                                                                                                                            column: 56,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                                        }
                                                                                                                                                                                    }
                                                                                                                                                                                },
                                                                                                                                                                                arguments: [],
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 138,
                                                                                                                                                                                        column: 52,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 138,
                                                                                                                                                                                        column: 58,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            properties: [{
                                                                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                                                                    expression: {
                                                                                                                                                                                        type: 'Literal',
                                                                                                                                                                                        value: 'Organization Information'
                                                                                                                                                                                    },
                                                                                                                                                                                    loc: {
                                                                                                                                                                                        start: {
                                                                                                                                                                                            line: 139,
                                                                                                                                                                                            column: 56,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                                        },
                                                                                                                                                                                        end: {
                                                                                                                                                                                            line: 139,
                                                                                                                                                                                            column: 82,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                                        }
                                                                                                                                                                                    },
                                                                                                                                                                                    order: '0'
                                                                                                                                                                                }]
                                                                                                                                                                        },
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 138,
                                                                                                                                                                                column: 52,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 140,
                                                                                                                                                                                column: 56,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        order: '1'
                                                                                                                                                                    },
                                                                                                                                                                    {
                                                                                                                                                                        type: 'ExpressionStatement',
                                                                                                                                                                        expression: {
                                                                                                                                                                            type: 'Function',
                                                                                                                                                                            context: true,
                                                                                                                                                                            value: function (_context7) {
                                                                                                                                                                                return function click(e) {
                                                                                                                                                                                    var showInfoDialog = _context7.get('showInfoDialog'), org = _context7.get('org');
                                                                                                                                                                                    showInfoDialog(org);
                                                                                                                                                                                };
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 140,
                                                                                                                                                                                column: 52,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 142,
                                                                                                                                                                                column: 56,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        order: '2'
                                                                                                                                                                    }
                                                                                                                                                                ]
                                                                                                                                                            },
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 135,
                                                                                                                                                                    column: 48,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 142,
                                                                                                                                                                    column: 52,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            order: '0'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                                            expression: {
                                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                                objectType: {
                                                                                                                                                                    type: 'CallExpression',
                                                                                                                                                                    callee: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'PaperIconItem',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 142,
                                                                                                                                                                                column: 48,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 142,
                                                                                                                                                                                column: 61,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    arguments: [],
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 142,
                                                                                                                                                                            column: 48,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 142,
                                                                                                                                                                            column: 63,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                properties: [
                                                                                                                                                                    {
                                                                                                                                                                        type: 'ExpressionStatement',
                                                                                                                                                                        expression: {
                                                                                                                                                                            type: 'ObjectExpression',
                                                                                                                                                                            objectType: {
                                                                                                                                                                                type: 'CallExpression',
                                                                                                                                                                                callee: {
                                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                                    name: 'IronIcon',
                                                                                                                                                                                    loc: {
                                                                                                                                                                                        start: {
                                                                                                                                                                                            line: 143,
                                                                                                                                                                                            column: 52,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                                        },
                                                                                                                                                                                        end: {
                                                                                                                                                                                            line: 143,
                                                                                                                                                                                            column: 60,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                                        }
                                                                                                                                                                                    }
                                                                                                                                                                                },
                                                                                                                                                                                arguments: [{
                                                                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                                                                        properties: [{
                                                                                                                                                                                                type: 'Property',
                                                                                                                                                                                                key: {
                                                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                                                    value: 'item-icon'
                                                                                                                                                                                                },
                                                                                                                                                                                                value: {
                                                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                                                    value: true
                                                                                                                                                                                                },
                                                                                                                                                                                                kind: 'init',
                                                                                                                                                                                                order: '0'
                                                                                                                                                                                            }]
                                                                                                                                                                                    }],
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 143,
                                                                                                                                                                                        column: 52,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 143,
                                                                                                                                                                                        column: 80,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            properties: [{
                                                                                                                                                                                    type: 'Property',
                                                                                                                                                                                    key: {
                                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                                        name: 'icon',
                                                                                                                                                                                        loc: {
                                                                                                                                                                                            start: {
                                                                                                                                                                                                line: 144,
                                                                                                                                                                                                column: 56,
                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                                            },
                                                                                                                                                                                            end: {
                                                                                                                                                                                                line: 144,
                                                                                                                                                                                                column: 60,
                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                                            }
                                                                                                                                                                                        }
                                                                                                                                                                                    },
                                                                                                                                                                                    value: {
                                                                                                                                                                                        type: 'Literal',
                                                                                                                                                                                        value: 'cloud'
                                                                                                                                                                                    },
                                                                                                                                                                                    kind: 'init',
                                                                                                                                                                                    order: '0'
                                                                                                                                                                                }]
                                                                                                                                                                        },
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 143,
                                                                                                                                                                                column: 52,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 145,
                                                                                                                                                                                column: 56,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        order: '0'
                                                                                                                                                                    },
                                                                                                                                                                    {
                                                                                                                                                                        type: 'ExpressionStatement',
                                                                                                                                                                        expression: {
                                                                                                                                                                            type: 'ObjectExpression',
                                                                                                                                                                            objectType: {
                                                                                                                                                                                type: 'CallExpression',
                                                                                                                                                                                callee: {
                                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                                    name: 'Span',
                                                                                                                                                                                    loc: {
                                                                                                                                                                                        start: {
                                                                                                                                                                                            line: 145,
                                                                                                                                                                                            column: 52,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                                        },
                                                                                                                                                                                        end: {
                                                                                                                                                                                            line: 145,
                                                                                                                                                                                            column: 56,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                                        }
                                                                                                                                                                                    }
                                                                                                                                                                                },
                                                                                                                                                                                arguments: [],
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 145,
                                                                                                                                                                                        column: 52,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 145,
                                                                                                                                                                                        column: 58,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            properties: [{
                                                                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                                                                    expression: {
                                                                                                                                                                                        type: 'Literal',
                                                                                                                                                                                        value: 'Setup Salesforce Sync'
                                                                                                                                                                                    },
                                                                                                                                                                                    loc: {
                                                                                                                                                                                        start: {
                                                                                                                                                                                            line: 146,
                                                                                                                                                                                            column: 56,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                                        },
                                                                                                                                                                                        end: {
                                                                                                                                                                                            line: 146,
                                                                                                                                                                                            column: 79,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                                        }
                                                                                                                                                                                    },
                                                                                                                                                                                    order: '0'
                                                                                                                                                                                }]
                                                                                                                                                                        },
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 145,
                                                                                                                                                                                column: 52,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 147,
                                                                                                                                                                                column: 56,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        order: '1'
                                                                                                                                                                    },
                                                                                                                                                                    {
                                                                                                                                                                        type: 'ExpressionStatement',
                                                                                                                                                                        expression: {
                                                                                                                                                                            type: 'Function',
                                                                                                                                                                            context: true,
                                                                                                                                                                            value: function (_context8) {
                                                                                                                                                                                return function click() {
                                                                                                                                                                                    var org = _context8.get('org');
                                                                                                                                                                                    model.setupSalesforceSync({
                                                                                                                                                                                        orgId: org.id,
                                                                                                                                                                                        sandbox: false
                                                                                                                                                                                    });
                                                                                                                                                                                };
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 147,
                                                                                                                                                                                column: 52,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 149,
                                                                                                                                                                                column: 56,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        order: '2'
                                                                                                                                                                    }
                                                                                                                                                                ]
                                                                                                                                                            },
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 142,
                                                                                                                                                                    column: 48,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 149,
                                                                                                                                                                    column: 52,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            order: '1'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                                            expression: {
                                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                                objectType: {
                                                                                                                                                                    type: 'CallExpression',
                                                                                                                                                                    callee: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'PaperIconItem',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 149,
                                                                                                                                                                                column: 48,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 149,
                                                                                                                                                                                column: 61,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    arguments: [],
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 149,
                                                                                                                                                                            column: 48,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 149,
                                                                                                                                                                            column: 63,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                properties: [
                                                                                                                                                                    {
                                                                                                                                                                        type: 'ExpressionStatement',
                                                                                                                                                                        expression: {
                                                                                                                                                                            type: 'ObjectExpression',
                                                                                                                                                                            objectType: {
                                                                                                                                                                                type: 'CallExpression',
                                                                                                                                                                                callee: {
                                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                                    name: 'IronIcon',
                                                                                                                                                                                    loc: {
                                                                                                                                                                                        start: {
                                                                                                                                                                                            line: 150,
                                                                                                                                                                                            column: 52,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                                        },
                                                                                                                                                                                        end: {
                                                                                                                                                                                            line: 150,
                                                                                                                                                                                            column: 60,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                                        }
                                                                                                                                                                                    }
                                                                                                                                                                                },
                                                                                                                                                                                arguments: [{
                                                                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                                                                        properties: [{
                                                                                                                                                                                                type: 'Property',
                                                                                                                                                                                                key: {
                                                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                                                    value: 'item-icon'
                                                                                                                                                                                                },
                                                                                                                                                                                                value: {
                                                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                                                    value: true
                                                                                                                                                                                                },
                                                                                                                                                                                                kind: 'init',
                                                                                                                                                                                                order: '0'
                                                                                                                                                                                            }]
                                                                                                                                                                                    }],
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 150,
                                                                                                                                                                                        column: 52,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 150,
                                                                                                                                                                                        column: 80,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            properties: [{
                                                                                                                                                                                    type: 'Property',
                                                                                                                                                                                    key: {
                                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                                        name: 'icon',
                                                                                                                                                                                        loc: {
                                                                                                                                                                                            start: {
                                                                                                                                                                                                line: 151,
                                                                                                                                                                                                column: 56,
                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                                            },
                                                                                                                                                                                            end: {
                                                                                                                                                                                                line: 151,
                                                                                                                                                                                                column: 60,
                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                                            }
                                                                                                                                                                                        }
                                                                                                                                                                                    },
                                                                                                                                                                                    value: {
                                                                                                                                                                                        type: 'Literal',
                                                                                                                                                                                        value: 'cloud'
                                                                                                                                                                                    },
                                                                                                                                                                                    kind: 'init',
                                                                                                                                                                                    order: '0'
                                                                                                                                                                                }]
                                                                                                                                                                        },
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 150,
                                                                                                                                                                                column: 52,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 152,
                                                                                                                                                                                column: 56,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        order: '0'
                                                                                                                                                                    },
                                                                                                                                                                    {
                                                                                                                                                                        type: 'ExpressionStatement',
                                                                                                                                                                        expression: {
                                                                                                                                                                            type: 'ObjectExpression',
                                                                                                                                                                            objectType: {
                                                                                                                                                                                type: 'CallExpression',
                                                                                                                                                                                callee: {
                                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                                    name: 'Span',
                                                                                                                                                                                    loc: {
                                                                                                                                                                                        start: {
                                                                                                                                                                                            line: 152,
                                                                                                                                                                                            column: 52,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                                        },
                                                                                                                                                                                        end: {
                                                                                                                                                                                            line: 152,
                                                                                                                                                                                            column: 56,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                                        }
                                                                                                                                                                                    }
                                                                                                                                                                                },
                                                                                                                                                                                arguments: [],
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 152,
                                                                                                                                                                                        column: 52,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 152,
                                                                                                                                                                                        column: 58,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            properties: [{
                                                                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                                                                    expression: {
                                                                                                                                                                                        type: 'Literal',
                                                                                                                                                                                        value: 'Setup Salesforce Sync for Sandbox Org'
                                                                                                                                                                                    },
                                                                                                                                                                                    loc: {
                                                                                                                                                                                        start: {
                                                                                                                                                                                            line: 153,
                                                                                                                                                                                            column: 56,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                                        },
                                                                                                                                                                                        end: {
                                                                                                                                                                                            line: 153,
                                                                                                                                                                                            column: 95,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                                        }
                                                                                                                                                                                    },
                                                                                                                                                                                    order: '0'
                                                                                                                                                                                }]
                                                                                                                                                                        },
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 152,
                                                                                                                                                                                column: 52,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 154,
                                                                                                                                                                                column: 56,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        order: '1'
                                                                                                                                                                    },
                                                                                                                                                                    {
                                                                                                                                                                        type: 'ExpressionStatement',
                                                                                                                                                                        expression: {
                                                                                                                                                                            type: 'Function',
                                                                                                                                                                            context: true,
                                                                                                                                                                            value: function (_context9) {
                                                                                                                                                                                return function click() {
                                                                                                                                                                                    var org = _context9.get('org');
                                                                                                                                                                                    model.setupSalesforceSync({
                                                                                                                                                                                        orgId: org.id,
                                                                                                                                                                                        sandbox: true
                                                                                                                                                                                    });
                                                                                                                                                                                };
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 154,
                                                                                                                                                                                column: 52,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 156,
                                                                                                                                                                                column: 56,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        order: '2'
                                                                                                                                                                    }
                                                                                                                                                                ]
                                                                                                                                                            },
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 149,
                                                                                                                                                                    column: 48,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 156,
                                                                                                                                                                    column: 52,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            order: '2'
                                                                                                                                                        }
                                                                                                                                                    ]
                                                                                                                                                },
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 134,
                                                                                                                                                        column: 44,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 156,
                                                                                                                                                        column: 48,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                order: '5'
                                                                                                                                            }
                                                                                                                                        ]
                                                                                                                                    },
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 127,
                                                                                                                                            column: 40,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 156,
                                                                                                                                            column: 44,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    order: '2'
                                                                                                                                }
                                                                                                                            ]
                                                                                                                        },
                                                                                                                        order: '3'
                                                                                                                    }
                                                                                                                ],
                                                                                                                bound: false,
                                                                                                                name: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'right',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 112,
                                                                                                                            column: 32,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 112,
                                                                                                                            column: 37,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                scope: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: '_ps2'
                                                                                                                }
                                                                                                            }, {
                                                                                                                this: this,
                                                                                                                _ref14: _ref14,
                                                                                                                _ps2: _ps2,
                                                                                                                urlConfig: urlConfig,
                                                                                                                glass: glass,
                                                                                                                viewpath: viewpath,
                                                                                                                _ref: _ref,
                                                                                                                _ref2: _ref2,
                                                                                                                _ref3: _ref3,
                                                                                                                _ref4: _ref4,
                                                                                                                _ref5: _ref5,
                                                                                                                _ref6: _ref6,
                                                                                                                _ref7: _ref7,
                                                                                                                _ref8: _ref8,
                                                                                                                _ref9: _ref9,
                                                                                                                Http: Http,
                                                                                                                Key: Key,
                                                                                                                Button: Button,
                                                                                                                Icon: Icon,
                                                                                                                Dialog: Dialog,
                                                                                                                Renamer: Renamer,
                                                                                                                PromptDialog: PromptDialog,
                                                                                                                User: User,
                                                                                                                Organization: Organization,
                                                                                                                Tag: Tag,
                                                                                                                Project: Project,
                                                                                                                GenericTypePane: GenericTypePane,
                                                                                                                InviteUserDialog: InviteUserDialog,
                                                                                                                ObjectRowSource: ObjectRowSource,
                                                                                                                UserOrgTagsProperty: UserOrgTagsProperty,
                                                                                                                UserOrgCalendarsProperty: UserOrgCalendarsProperty,
                                                                                                                UserOrgAcceptedProperty: UserOrgAcceptedProperty,
                                                                                                                UserOrgInvitedProperty: UserOrgInvitedProperty,
                                                                                                                AdminProperty: AdminProperty,
                                                                                                                SubscriptionNotice: SubscriptionNotice,
                                                                                                                showInfoDialog: showInfoDialog
                                                                                                            }, _ps2);
                                                                                                        });
                                                                                                    }
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '1'
                                                                                            }
                                                                                        ]
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '7'
                                                                                }
                                                                            ]
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 67,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 156,
                                                                                column: 28,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                            }
                                                                        },
                                                                        order: '0'
                                                                    },
                                                                    {
                                                                        type: 'IfStatement',
                                                                        test: {
                                                                            type: 'Identifier',
                                                                            name: 'isUserAdmin',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 156,
                                                                                    column: 27,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 156,
                                                                                    column: 38,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        consequent: {
                                                                            type: 'BlockStatement',
                                                                            body: [{
                                                                                    type: 'ExpressionStatement',
                                                                                    expression: {
                                                                                        type: 'ObjectExpression',
                                                                                        objectType: {
                                                                                            type: 'ObjectExpression',
                                                                                            properties: [
                                                                                                {
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'id',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 157,
                                                                                                                column: 29,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 157,
                                                                                                                column: 31,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'Literal',
                                                                                                        value: 'projects'
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '0'
                                                                                                },
                                                                                                {
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'name',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 157,
                                                                                                                column: 44,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 157,
                                                                                                                column: 48,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'Literal',
                                                                                                        value: 'Projects'
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '1'
                                                                                                }
                                                                                            ]
                                                                                        },
                                                                                        properties: [
                                                                                            {
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'type',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 158,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 158,
                                                                                                            column: 36,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'Project',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 158,
                                                                                                            column: 38,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 158,
                                                                                                            column: 45,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '0'
                                                                                            },
                                                                                            {
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'columns',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 159,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 159,
                                                                                                            column: 39,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'ArrayExpression',
                                                                                                    elements: [
                                                                                                        {
                                                                                                            type: 'Literal',
                                                                                                            value: 'name'
                                                                                                        },
                                                                                                        {
                                                                                                            type: 'Literal',
                                                                                                            value: 'type'
                                                                                                        },
                                                                                                        {
                                                                                                            type: 'Literal',
                                                                                                            value: 'createdBy'
                                                                                                        },
                                                                                                        {
                                                                                                            type: 'Literal',
                                                                                                            value: 'updatedBy'
                                                                                                        },
                                                                                                        {
                                                                                                            type: 'Literal',
                                                                                                            value: 'created'
                                                                                                        },
                                                                                                        {
                                                                                                            type: 'Literal',
                                                                                                            value: 'updated'
                                                                                                        },
                                                                                                        {
                                                                                                            type: 'Literal',
                                                                                                            value: 'description'
                                                                                                        }
                                                                                                    ]
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '1'
                                                                                            },
                                                                                            {
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'create',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 160,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 160,
                                                                                                            column: 38,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'Literal',
                                                                                                    value: false
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '2'
                                                                                            },
                                                                                            {
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'where',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 161,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 161,
                                                                                                            column: 37,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'ObjectExpression',
                                                                                                    properties: [
                                                                                                        {
                                                                                                            type: 'Property',
                                                                                                            key: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'orgId',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 162,
                                                                                                                        column: 36,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 162,
                                                                                                                        column: 41,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            value: {
                                                                                                                type: 'MemberExpression',
                                                                                                                computed: false,
                                                                                                                object: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'org',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 162,
                                                                                                                            column: 43,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 162,
                                                                                                                            column: 46,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                property: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'id',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 162,
                                                                                                                            column: 47,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 162,
                                                                                                                            column: 49,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 162,
                                                                                                                        column: 43,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 162,
                                                                                                                        column: 49,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            kind: 'init',
                                                                                                            order: '0'
                                                                                                        },
                                                                                                        {
                                                                                                            type: 'Property',
                                                                                                            key: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'archived',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 163,
                                                                                                                        column: 36,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 163,
                                                                                                                        column: 44,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            value: {
                                                                                                                type: 'Literal',
                                                                                                                value: false
                                                                                                            },
                                                                                                            kind: 'init',
                                                                                                            order: '1'
                                                                                                        }
                                                                                                    ]
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '3'
                                                                                            },
                                                                                            {
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'sorts',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 164,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 164,
                                                                                                            column: 37,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'ObjectExpression',
                                                                                                    objectType: {
                                                                                                        type: 'ArrayExpression',
                                                                                                        elements: []
                                                                                                    },
                                                                                                    properties: [{
                                                                                                            type: 'ExpressionStatement',
                                                                                                            expression: {
                                                                                                                type: 'ArrayExpression',
                                                                                                                elements: [{
                                                                                                                        type: 'ObjectExpression',
                                                                                                                        properties: [{
                                                                                                                                type: 'Property',
                                                                                                                                key: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'updated',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 165,
                                                                                                                                            column: 38,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 165,
                                                                                                                                            column: 45,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                value: {
                                                                                                                                    type: 'Literal',
                                                                                                                                    value: false
                                                                                                                                },
                                                                                                                                kind: 'init',
                                                                                                                                order: '0'
                                                                                                                            }]
                                                                                                                    }]
                                                                                                            },
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 165,
                                                                                                                    column: 36,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 165,
                                                                                                                    column: 53,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                }
                                                                                                            },
                                                                                                            order: '0'
                                                                                                        }]
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '4'
                                                                                            }
                                                                                        ]
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 157,
                                                                                            column: 28,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 166,
                                                                                            column: 32,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                        }
                                                                                    },
                                                                                    order: '0'
                                                                                }]
                                                                        },
                                                                        alternate: null,
                                                                        order: '1'
                                                                    },
                                                                    {
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'ObjectExpression',
                                                                            objectType: {
                                                                                type: 'ObjectExpression',
                                                                                properties: [
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'id',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 166,
                                                                                                    column: 25,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 166,
                                                                                                    column: 27,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 'tags'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'name',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 166,
                                                                                                    column: 36,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 166,
                                                                                                    column: 40,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 'Tags'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '1'
                                                                                    }
                                                                                ]
                                                                            },
                                                                            properties: [
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'type',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 167,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 167,
                                                                                                column: 32,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Identifier',
                                                                                        name: 'Tag',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 167,
                                                                                                column: 34,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 167,
                                                                                                column: 37,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'editable',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 168,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 168,
                                                                                                column: 36,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Identifier',
                                                                                        name: 'isUserAdmin',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 168,
                                                                                                column: 38,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 168,
                                                                                                column: 49,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '1'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'toolbar',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 169,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 169,
                                                                                                column: 35,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'ObjectExpression',
                                                                                        properties: [{
                                                                                                type: 'IfStatement',
                                                                                                test: {
                                                                                                    type: 'UnaryExpression',
                                                                                                    operator: '!',
                                                                                                    argument: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'isUserAdmin',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 170,
                                                                                                                column: 39,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 170,
                                                                                                                column: 50,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                consequent: {
                                                                                                    type: 'BlockStatement',
                                                                                                    body: [{
                                                                                                            type: 'Property',
                                                                                                            key: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'center',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 171,
                                                                                                                        column: 36,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 171,
                                                                                                                        column: 42,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            value: {
                                                                                                                type: 'Function',
                                                                                                                context: true,
                                                                                                                value: function (_ps3) {
                                                                                                                    return ion.template(function () {
                                                                                                                        return ion.createRuntime({
                                                                                                                            type: 'Template',
                                                                                                                            id: null,
                                                                                                                            body: [{
                                                                                                                                    type: 'ReturnStatement',
                                                                                                                                    argument: {
                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                        objectType: {
                                                                                                                                            type: 'CallExpression',
                                                                                                                                            callee: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'Div',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 172,
                                                                                                                                                        column: 47,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 172,
                                                                                                                                                        column: 50,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            arguments: [{
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    properties: [{
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'class',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 172,
                                                                                                                                                                        column: 52,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 172,
                                                                                                                                                                        column: 57,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: 'z2'
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '0'
                                                                                                                                                        }]
                                                                                                                                                }],
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 172,
                                                                                                                                                    column: 47,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 172,
                                                                                                                                                    column: 64,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        properties: [
                                                                                                                                            {
                                                                                                                                                type: 'Property',
                                                                                                                                                key: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'style',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 173,
                                                                                                                                                            column: 44,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 173,
                                                                                                                                                            column: 49,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                value: {
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    properties: [
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'cursor',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 174,
                                                                                                                                                                        column: 48,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 174,
                                                                                                                                                                        column: 54,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: 'default'
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '0'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'padding',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 175,
                                                                                                                                                                        column: 48,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 175,
                                                                                                                                                                        column: 55,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: '5px 20px'
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '1'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'color',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 176,
                                                                                                                                                                        column: 48,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 176,
                                                                                                                                                                        column: 53,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: 'darkorange'
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '2'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'marginLeft',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 177,
                                                                                                                                                                        column: 48,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 177,
                                                                                                                                                                        column: 58,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: '20px'
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '3'
                                                                                                                                                        }
                                                                                                                                                    ]
                                                                                                                                                },
                                                                                                                                                kind: 'init',
                                                                                                                                                order: '0'
                                                                                                                                            },
                                                                                                                                            {
                                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                                expression: {
                                                                                                                                                    type: 'Literal',
                                                                                                                                                    value: 'You must be an admin in order to edit Tags'
                                                                                                                                                },
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 178,
                                                                                                                                                        column: 44,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 178,
                                                                                                                                                        column: 88,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                order: '1'
                                                                                                                                            }
                                                                                                                                        ]
                                                                                                                                    },
                                                                                                                                    order: '0'
                                                                                                                                }],
                                                                                                                            bound: false,
                                                                                                                            name: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'center',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 171,
                                                                                                                                        column: 36,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 171,
                                                                                                                                        column: 42,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            scope: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: '_ps3'
                                                                                                                            }
                                                                                                                        }, {
                                                                                                                            this: this,
                                                                                                                            _ps3: _ps3,
                                                                                                                            urlConfig: urlConfig,
                                                                                                                            glass: glass,
                                                                                                                            viewpath: viewpath,
                                                                                                                            _ref: _ref,
                                                                                                                            _ref2: _ref2,
                                                                                                                            _ref3: _ref3,
                                                                                                                            _ref4: _ref4,
                                                                                                                            _ref5: _ref5,
                                                                                                                            _ref6: _ref6,
                                                                                                                            _ref7: _ref7,
                                                                                                                            _ref8: _ref8,
                                                                                                                            _ref9: _ref9,
                                                                                                                            Http: Http,
                                                                                                                            Key: Key,
                                                                                                                            Button: Button,
                                                                                                                            Icon: Icon,
                                                                                                                            Dialog: Dialog,
                                                                                                                            Renamer: Renamer,
                                                                                                                            PromptDialog: PromptDialog,
                                                                                                                            User: User,
                                                                                                                            Organization: Organization,
                                                                                                                            Tag: Tag,
                                                                                                                            Project: Project,
                                                                                                                            GenericTypePane: GenericTypePane,
                                                                                                                            InviteUserDialog: InviteUserDialog,
                                                                                                                            ObjectRowSource: ObjectRowSource,
                                                                                                                            UserOrgTagsProperty: UserOrgTagsProperty,
                                                                                                                            UserOrgCalendarsProperty: UserOrgCalendarsProperty,
                                                                                                                            UserOrgAcceptedProperty: UserOrgAcceptedProperty,
                                                                                                                            UserOrgInvitedProperty: UserOrgInvitedProperty,
                                                                                                                            AdminProperty: AdminProperty,
                                                                                                                            SubscriptionNotice: SubscriptionNotice,
                                                                                                                            showInfoDialog: showInfoDialog
                                                                                                                        }, _ps3);
                                                                                                                    });
                                                                                                                }
                                                                                                            },
                                                                                                            kind: 'init',
                                                                                                            order: '0'
                                                                                                        }]
                                                                                                },
                                                                                                alternate: null,
                                                                                                order: '0'
                                                                                            }]
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '2'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'columns',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 179,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 179,
                                                                                                column: 35,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'ArrayExpression',
                                                                                        elements: [
                                                                                            {
                                                                                                type: 'Literal',
                                                                                                value: 'name'
                                                                                            },
                                                                                            {
                                                                                                type: 'Literal',
                                                                                                value: 'color'
                                                                                            },
                                                                                            {
                                                                                                type: 'Literal',
                                                                                                value: 'user'
                                                                                            },
                                                                                            {
                                                                                                type: 'Literal',
                                                                                                value: 'task'
                                                                                            },
                                                                                            {
                                                                                                type: 'Literal',
                                                                                                value: 'project'
                                                                                            },
                                                                                            {
                                                                                                type: 'Literal',
                                                                                                value: 'description'
                                                                                            }
                                                                                        ]
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '3'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'createRowSource',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 180,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 180,
                                                                                                column: 43,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Function',
                                                                                        context: true,
                                                                                        value: function (_ps4) {
                                                                                            return ion.template(function () {
                                                                                                return ion.createRuntime({
                                                                                                    type: 'Template',
                                                                                                    id: null,
                                                                                                    body: [{
                                                                                                            type: 'ReturnStatement',
                                                                                                            argument: {
                                                                                                                type: 'CallExpression',
                                                                                                                callee: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'ObjectRowSource',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 181,
                                                                                                                            column: 39,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 181,
                                                                                                                            column: 54,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                arguments: [{
                                                                                                                        type: 'ObjectExpression',
                                                                                                                        objectType: {
                                                                                                                            type: 'ObjectExpression',
                                                                                                                            properties: [
                                                                                                                                {
                                                                                                                                    type: 'Property',
                                                                                                                                    key: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'object',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 182,
                                                                                                                                                column: 37,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 182,
                                                                                                                                                column: 43,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    value: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'org',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 182,
                                                                                                                                                column: 44,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 182,
                                                                                                                                                column: 47,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    kind: 'init',
                                                                                                                                    order: '0'
                                                                                                                                },
                                                                                                                                {
                                                                                                                                    type: 'Property',
                                                                                                                                    key: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'property',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 182,
                                                                                                                                                column: 49,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 182,
                                                                                                                                                column: 57,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    value: {
                                                                                                                                        type: 'Literal',
                                                                                                                                        value: 'tags'
                                                                                                                                    },
                                                                                                                                    kind: 'init',
                                                                                                                                    order: '1'
                                                                                                                                },
                                                                                                                                {
                                                                                                                                    type: 'Property',
                                                                                                                                    key: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'type',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 182,
                                                                                                                                                column: 66,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 182,
                                                                                                                                                column: 70,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    value: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'Tag',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 182,
                                                                                                                                                column: 71,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 182,
                                                                                                                                                column: 74,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    kind: 'init',
                                                                                                                                    order: '2'
                                                                                                                                },
                                                                                                                                {
                                                                                                                                    type: 'Property',
                                                                                                                                    key: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'sort',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 182,
                                                                                                                                                column: 76,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 182,
                                                                                                                                                column: 80,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    value: {
                                                                                                                                        type: 'ArrayExpression',
                                                                                                                                        elements: [{
                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                properties: [{
                                                                                                                                                        type: 'Property',
                                                                                                                                                        key: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'name',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 182,
                                                                                                                                                                    column: 84,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 182,
                                                                                                                                                                    column: 88,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        value: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: true
                                                                                                                                                        },
                                                                                                                                                        kind: 'init',
                                                                                                                                                        order: '0'
                                                                                                                                                    }]
                                                                                                                                            }]
                                                                                                                                    },
                                                                                                                                    kind: 'init',
                                                                                                                                    order: '3'
                                                                                                                                }
                                                                                                                            ]
                                                                                                                        },
                                                                                                                        properties: [{
                                                                                                                                type: 'Property',
                                                                                                                                key: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'getKey',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 183,
                                                                                                                                            column: 40,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 183,
                                                                                                                                            column: 46,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                value: {
                                                                                                                                    type: 'Function',
                                                                                                                                    context: false,
                                                                                                                                    value: function (record) {
                                                                                                                                        return record.name.trim().split(/\s/g).join('_').toLowerCase();
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                kind: 'init',
                                                                                                                                order: '0'
                                                                                                                            }]
                                                                                                                    }],
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 181,
                                                                                                                        column: 39,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 186,
                                                                                                                        column: 33,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            order: '0'
                                                                                                        }],
                                                                                                    bound: false,
                                                                                                    name: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'createRowSource',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 180,
                                                                                                                column: 28,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 180,
                                                                                                                column: 43,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    scope: {
                                                                                                        type: 'Identifier',
                                                                                                        name: '_ps4'
                                                                                                    }
                                                                                                }, {
                                                                                                    this: this,
                                                                                                    _ps4: _ps4,
                                                                                                    urlConfig: urlConfig,
                                                                                                    glass: glass,
                                                                                                    viewpath: viewpath,
                                                                                                    _ref: _ref,
                                                                                                    _ref2: _ref2,
                                                                                                    _ref3: _ref3,
                                                                                                    _ref4: _ref4,
                                                                                                    _ref5: _ref5,
                                                                                                    _ref6: _ref6,
                                                                                                    _ref7: _ref7,
                                                                                                    _ref8: _ref8,
                                                                                                    _ref9: _ref9,
                                                                                                    Http: Http,
                                                                                                    Key: Key,
                                                                                                    Button: Button,
                                                                                                    Icon: Icon,
                                                                                                    Dialog: Dialog,
                                                                                                    Renamer: Renamer,
                                                                                                    PromptDialog: PromptDialog,
                                                                                                    User: User,
                                                                                                    Organization: Organization,
                                                                                                    Tag: Tag,
                                                                                                    Project: Project,
                                                                                                    GenericTypePane: GenericTypePane,
                                                                                                    InviteUserDialog: InviteUserDialog,
                                                                                                    ObjectRowSource: ObjectRowSource,
                                                                                                    UserOrgTagsProperty: UserOrgTagsProperty,
                                                                                                    UserOrgCalendarsProperty: UserOrgCalendarsProperty,
                                                                                                    UserOrgAcceptedProperty: UserOrgAcceptedProperty,
                                                                                                    UserOrgInvitedProperty: UserOrgInvitedProperty,
                                                                                                    AdminProperty: AdminProperty,
                                                                                                    SubscriptionNotice: SubscriptionNotice,
                                                                                                    showInfoDialog: showInfoDialog
                                                                                                }, _ps4);
                                                                                            });
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '4'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'create',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 187,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 187,
                                                                                                column: 34,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'ObjectExpression',
                                                                                        properties: [
                                                                                            {
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'title',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 188,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 188,
                                                                                                            column: 37,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'Literal',
                                                                                                    value: 'Add new Tag'
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '0'
                                                                                            },
                                                                                            {
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'handler',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 189,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 189,
                                                                                                            column: 39,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/OrgPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'Function',
                                                                                                    context: true,
                                                                                                    value: function (_context10) {
                                                                                                        return function (_ref15) {
                                                                                                            var PromptDialog = _context10.get('PromptDialog');
                                                                                                            var e = _ref15.e;
                                                                                                            var dataTableModel = _ref15.dataTableModel;
                                                                                                            PromptDialog.show({
                                                                                                                properties: [{
                                                                                                                        name: 'name',
                                                                                                                        label: 'Tag Name'
                                                                                                                    }],
                                                                                                                title: 'Add New Tag',
                                                                                                                submitText: 'Create',
                                                                                                                callback: function (values) {
                                                                                                                    if (values.name != null && values.name) {
                                                                                                                        dataTableModel.beginOp();
                                                                                                                        dataTableModel.rowSource.insertRecord(values);
                                                                                                                    }
                                                                                                                }
                                                                                                            });
                                                                                                        };
                                                                                                    }
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '1'
                                                                                            }
                                                                                        ]
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '5'
                                                                                }
                                                                            ]
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 166,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 198,
                                                                                column: 28,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/OrgPane.ion'
                                                                            }
                                                                        },
                                                                        order: '2'
                                                                    }
                                                                ]
                                                            },
                                                            kind: 'init',
                                                            order: '3'
                                                        }
                                                    ]
                                                }],
                                            loc: {
                                                start: {
                                                    line: 61,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                },
                                                end: {
                                                    line: 198,
                                                    column: 13,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/OrgPane.ion'
                                                }
                                            }
                                        },
                                        order: '2'
                                    }
                                ]
                            },
                            order: '5'
                        }
                    ]
                },
                order: '1'
            }
        ],
        bound: false
    }, {
        this: this,
        ion: ion,
        urlConfig: urlConfig,
        glass: glass,
        viewpath: viewpath,
        _ref: _ref,
        _ref2: _ref2,
        _ref3: _ref3,
        _ref4: _ref4,
        _ref5: _ref5,
        _ref6: _ref6,
        _ref7: _ref7,
        _ref8: _ref8,
        _ref9: _ref9,
        Http: Http,
        Key: Key,
        Button: Button,
        Icon: Icon,
        Dialog: Dialog,
        Renamer: Renamer,
        PromptDialog: PromptDialog,
        User: User,
        Organization: Organization,
        Tag: Tag,
        Project: Project,
        GenericTypePane: GenericTypePane,
        InviteUserDialog: InviteUserDialog,
        ObjectRowSource: ObjectRowSource,
        UserOrgTagsProperty: UserOrgTagsProperty,
        UserOrgCalendarsProperty: UserOrgCalendarsProperty,
        UserOrgAcceptedProperty: UserOrgAcceptedProperty,
        UserOrgInvitedProperty: UserOrgInvitedProperty,
        AdminProperty: AdminProperty,
        SubscriptionNotice: SubscriptionNotice,
        showInfoDialog: showInfoDialog
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/panes/OrgPane',_viewpath_html_panes_OrgPane_);
    else
      _viewpath_html_panes_OrgPane_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_panes_OrgPane_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_panes_ProjectPane_ = function(module,exports,require){'use strict';
var ion = require('ion'), glass = require('glass'), _ref, _ref2, viewpath = require('../../'), _ref3, _ref4, _ref5, DataTable = glass.html.material.DataTable2, _ref6, _ref7, _ref8;
_ref = glass.data;
var Key = _ref.Key;
var Schema = _ref.Schema;
_ref2 = glass.html.forms;
var GlassForm = _ref2.GlassForm;
_ref3 = viewpath.model;
var User = _ref3.User;
var Task = _ref3.Task;
var Project = _ref3.Project;
var ProjectType = _ref3.ProjectType;
_ref4 = glass.html.material;
var Button = _ref4.Button;
var Checkbox = _ref4.Checkbox;
var Dialog = _ref4.Dialog;
var Field = _ref4.Field;
var Icon = _ref4.Icon;
var Toolbar = _ref4.Toolbar;
var TabContent = _ref4.TabContent;
_ref5 = glass.html.material;
var PromptDialog = _ref5.PromptDialog;
var Renamer = _ref5.Renamer;
_ref6 = require('./');
var GenericTypeView = _ref6.GenericTypeView;
var ManagersPane = _ref6.ManagersPane;
_ref7 = require('../');
var UserRowContent = _ref7.UserRowContent;
var UserOrgTagsProperty = _ref7.UserOrgTagsProperty;
_ref8 = require('../');
var SubscriptionNotice = _ref8.SubscriptionNotice;
var _ref9 = glass.html.material;
var ConfirmDialog = _ref9.ConfirmDialog;
var ProjectTasksTab = ion.template(function (_ref10) {
        return ion.createRuntime({
            type: 'Template',
            id: null,
            body: [
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'config',
                                loc: {
                                    start: {
                                        line: 18,
                                        column: 33,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 18,
                                        column: 39,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref10'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'config',
                                    loc: {
                                        start: {
                                            line: 18,
                                            column: 33,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        },
                                        end: {
                                            line: 18,
                                            column: 39,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '0'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'project',
                                loc: {
                                    start: {
                                        line: 18,
                                        column: 40,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 18,
                                        column: 47,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref10'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'project',
                                    loc: {
                                        start: {
                                            line: 18,
                                            column: 40,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        },
                                        end: {
                                            line: 18,
                                            column: 47,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '1'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'projectKey',
                                loc: {
                                    start: {
                                        line: 18,
                                        column: 48,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 18,
                                        column: 58,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref10'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'projectKey',
                                    loc: {
                                        start: {
                                            line: 18,
                                            column: 48,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        },
                                        end: {
                                            line: 18,
                                            column: 58,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '2'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'projectTasksKey',
                                loc: {
                                    start: {
                                        line: 18,
                                        column: 59,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 18,
                                        column: 74,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref10'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'projectTasksKey',
                                    loc: {
                                        start: {
                                            line: 18,
                                            column: 59,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        },
                                        end: {
                                            line: 18,
                                            column: 74,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '3'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'id',
                                loc: {
                                    start: {
                                        line: 19,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 19,
                                        column: 14,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'Literal',
                                value: 'ProjectPaneDataTable'
                            }
                        }],
                    kind: 'let',
                    order: '4'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'state',
                                loc: {
                                    start: {
                                        line: 20,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 20,
                                        column: 17,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Function',
                                    context: true,
                                    value: function (_context) {
                                        return function () {
                                            var id = _context.get('id');
                                            return global.model.local[id] = global.model.local[id] != null ? global.model.local[id] : {};
                                        };
                                    }
                                },
                                arguments: [],
                                loc: {
                                    start: {
                                        line: 20,
                                        column: 20,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 20,
                                        column: 54,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '5'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'rowSource',
                                loc: {
                                    start: {
                                        line: 21,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 21,
                                        column: 21,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'DataTable',
                                        loc: {
                                            start: {
                                                line: 21,
                                                column: 24,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            },
                                            end: {
                                                line: 21,
                                                column: 33,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'FullRowSource',
                                        loc: {
                                            start: {
                                                line: 21,
                                                column: 34,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            },
                                            end: {
                                                line: 21,
                                                column: 47,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 21,
                                            column: 24,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        },
                                        end: {
                                            line: 21,
                                            column: 47,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'key',
                                                    loc: {
                                                        start: {
                                                            line: 21,
                                                            column: 49,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        },
                                                        end: {
                                                            line: 21,
                                                            column: 52,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Identifier',
                                                    name: 'projectTasksKey',
                                                    loc: {
                                                        start: {
                                                            line: 21,
                                                            column: 53,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        },
                                                        end: {
                                                            line: 21,
                                                            column: 68,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        }
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'sort',
                                                    loc: {
                                                        start: {
                                                            line: 21,
                                                            column: 70,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        },
                                                        end: {
                                                            line: 21,
                                                            column: 74,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'ArrayExpression',
                                                    elements: [{
                                                            type: 'ObjectExpression',
                                                            properties: [{
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'order',
                                                                        loc: {
                                                                            start: {
                                                                                line: 21,
                                                                                column: 77,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 21,
                                                                                column: 82,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Literal',
                                                                        value: true
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                }]
                                                        }]
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    }],
                                loc: {
                                    start: {
                                        line: 21,
                                        column: 24,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 21,
                                        column: 91,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '6'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'tasks',
                                loc: {
                                    start: {
                                        line: 22,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 22,
                                        column: 17,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                computed: true,
                                object: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'model',
                                        loc: {
                                            start: {
                                                line: 22,
                                                column: 20,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            },
                                            end: {
                                                line: 22,
                                                column: 25,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'server',
                                        loc: {
                                            start: {
                                                line: 22,
                                                column: 26,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            },
                                            end: {
                                                line: 22,
                                                column: 32,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 22,
                                            column: 20,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        },
                                        end: {
                                            line: 22,
                                            column: 32,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'projectTasksKey',
                                    loc: {
                                        start: {
                                            line: 22,
                                            column: 33,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        },
                                        end: {
                                            line: 22,
                                            column: 48,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 22,
                                        column: 20,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 22,
                                        column: 49,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '7'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'dataTableModel',
                                loc: {
                                    start: {
                                        line: 23,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 23,
                                        column: 26,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'DataTable',
                                            loc: {
                                                start: {
                                                    line: 23,
                                                    column: 29,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                },
                                                end: {
                                                    line: 23,
                                                    column: 38,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'Model',
                                            loc: {
                                                start: {
                                                    line: 23,
                                                    column: 39,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                },
                                                end: {
                                                    line: 23,
                                                    column: 44,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 23,
                                                column: 29,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            },
                                            end: {
                                                line: 23,
                                                column: 44,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            }
                                        }
                                    },
                                    arguments: [{
                                            type: 'ObjectExpression',
                                            objectType: {
                                                type: 'ObjectExpression',
                                                properties: [
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'id',
                                                            loc: {
                                                                start: {
                                                                    line: 24,
                                                                    column: 13,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 24,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Identifier',
                                                            name: 'id',
                                                            loc: {
                                                                start: {
                                                                    line: 24,
                                                                    column: 13,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 24,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'state',
                                                            loc: {
                                                                start: {
                                                                    line: 24,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 24,
                                                                    column: 21,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Identifier',
                                                            name: 'state',
                                                            loc: {
                                                                start: {
                                                                    line: 24,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 24,
                                                                    column: 21,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '1'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'rowSource',
                                                            loc: {
                                                                start: {
                                                                    line: 24,
                                                                    column: 22,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 24,
                                                                    column: 31,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Identifier',
                                                            name: 'rowSource',
                                                            loc: {
                                                                start: {
                                                                    line: 24,
                                                                    column: 22,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 24,
                                                                    column: 31,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '2'
                                                    }
                                                ]
                                            },
                                            properties: [
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'columnStateId',
                                                        loc: {
                                                            start: {
                                                                line: 25,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 25,
                                                                column: 29,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'ConditionalExpression',
                                                        test: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'state',
                                                                loc: {
                                                                    start: {
                                                                        line: 25,
                                                                        column: 31,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 25,
                                                                        column: 36,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'timeline',
                                                                loc: {
                                                                    start: {
                                                                        line: 25,
                                                                        column: 37,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 25,
                                                                        column: 45,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 25,
                                                                    column: 31,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 25,
                                                                    column: 45,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        consequent: {
                                                            type: 'Literal',
                                                            value: 'timelineColumnState'
                                                        },
                                                        alternate: {
                                                            type: 'Literal',
                                                            value: 'basicColumnState'
                                                        }
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'properties',
                                                        loc: {
                                                            start: {
                                                                line: 26,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 26,
                                                                column: 26,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'Task',
                                                            loc: {
                                                                start: {
                                                                    line: 26,
                                                                    column: 28,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 26,
                                                                    column: 32,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'properties',
                                                            loc: {
                                                                start: {
                                                                    line: 26,
                                                                    column: 33,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 26,
                                                                    column: 43,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 26,
                                                                column: 28,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 26,
                                                                column: 43,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        }
                                                    },
                                                    kind: 'init',
                                                    order: '1'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'fixedColumnNames',
                                                        loc: {
                                                            start: {
                                                                line: 27,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 27,
                                                                column: 32,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'ArrayExpression',
                                                            elements: []
                                                        },
                                                        properties: [
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'ObjectExpression',
                                                                    properties: [
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'columnType',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 28,
                                                                                        column: 21,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 28,
                                                                                        column: 31,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'glass/html/material/DataTable2/RowSelectColumn'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'name',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 28,
                                                                                        column: 82,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 28,
                                                                                        column: 86,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'select'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '1'
                                                                        }
                                                                    ]
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 28,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 28,
                                                                        column: 96,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'ObjectExpression',
                                                                    properties: [
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'columnType',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 29,
                                                                                        column: 21,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 29,
                                                                                        column: 31,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'glass/html/material/DataTable2/PathColumn'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'name',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 29,
                                                                                        column: 77,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 29,
                                                                                        column: 81,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'WBS'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '1'
                                                                        }
                                                                    ]
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 29,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 29,
                                                                        column: 88,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    }
                                                                },
                                                                order: '1'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'Function',
                                                                        context: true,
                                                                        value: function (_context2) {
                                                                            return function () {
                                                                                var Task = _context2.get('Task');
                                                                                return Object.assign({}, Task.properties.name, {
                                                                                    columnType: 'glass/html/material/DataTable2/PrimaryColumn',
                                                                                    target: 'dialog',
                                                                                    name: 'name'
                                                                                });
                                                                            };
                                                                        }
                                                                    },
                                                                    arguments: [],
                                                                    loc: {
                                                                        start: {
                                                                            line: 30,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 30,
                                                                            column: 156,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 30,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 30,
                                                                        column: 156,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    }
                                                                },
                                                                order: '2'
                                                            }
                                                        ]
                                                    },
                                                    kind: 'init',
                                                    order: '2'
                                                },
                                                {
                                                    type: 'IfStatement',
                                                    test: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'state',
                                                            loc: {
                                                                start: {
                                                                    line: 31,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 31,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'timeline',
                                                            loc: {
                                                                start: {
                                                                    line: 31,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 31,
                                                                    column: 33,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 31,
                                                                column: 19,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 31,
                                                                column: 33,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        }
                                                    },
                                                    consequent: {
                                                        type: 'BlockStatement',
                                                        body: [{
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'defaultColumnNames',
                                                                    loc: {
                                                                        start: {
                                                                            line: 32,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 32,
                                                                            column: 38,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'ObjectExpression',
                                                                    objectType: {
                                                                        type: 'ArrayExpression',
                                                                        elements: []
                                                                    },
                                                                    properties: [
                                                                        {
                                                                            type: 'IfStatement',
                                                                            test: {
                                                                                type: 'BinaryExpression',
                                                                                operator: '!==',
                                                                                left: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'project',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 33,
                                                                                                column: 27,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 33,
                                                                                                column: 34,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'type',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 33,
                                                                                                column: 35,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 33,
                                                                                                column: 39,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 33,
                                                                                            column: 27,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 33,
                                                                                            column: 39,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                right: {
                                                                                    type: 'Literal',
                                                                                    value: 3
                                                                                }
                                                                            },
                                                                            consequent: {
                                                                                type: 'BlockStatement',
                                                                                body: [{
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'Literal',
                                                                                            value: 'assigned'
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 34,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 34,
                                                                                                column: 38,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            alternate: null,
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'Literal',
                                                                                value: 'tags'
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 35,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 35,
                                                                                    column: 30,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            },
                                                                            order: '1'
                                                                        },
                                                                        {
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'ObjectExpression',
                                                                                properties: [
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'columnType',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 36,
                                                                                                    column: 25,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 36,
                                                                                                    column: 35,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 'viewpath/html/GanttColumn'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'name',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 36,
                                                                                                    column: 65,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 36,
                                                                                                    column: 69,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 'Timeline'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '1'
                                                                                    }
                                                                                ]
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 36,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 36,
                                                                                    column: 82,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            },
                                                                            order: '2'
                                                                        }
                                                                    ]
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            }]
                                                    },
                                                    alternate: {
                                                        type: 'BlockStatement',
                                                        body: [{
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'defaultColumnNames',
                                                                    loc: {
                                                                        start: {
                                                                            line: 38,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 38,
                                                                            column: 38,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'ObjectExpression',
                                                                    objectType: {
                                                                        type: 'ArrayExpression',
                                                                        elements: []
                                                                    },
                                                                    properties: [
                                                                        {
                                                                            type: 'IfStatement',
                                                                            test: {
                                                                                type: 'BinaryExpression',
                                                                                operator: '!==',
                                                                                left: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'project',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 39,
                                                                                                column: 27,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 39,
                                                                                                column: 34,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'type',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 39,
                                                                                                column: 35,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 39,
                                                                                                column: 39,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 39,
                                                                                            column: 27,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 39,
                                                                                            column: 39,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                right: {
                                                                                    type: 'Literal',
                                                                                    value: 3
                                                                                }
                                                                            },
                                                                            consequent: {
                                                                                type: 'BlockStatement',
                                                                                body: [{
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'Literal',
                                                                                            value: 'percent'
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 40,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 40,
                                                                                                column: 37,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            alternate: null,
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'Literal',
                                                                                value: 'tags'
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 41,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 41,
                                                                                    column: 30,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            },
                                                                            order: '1'
                                                                        },
                                                                        {
                                                                            type: 'IfStatement',
                                                                            test: {
                                                                                type: 'BinaryExpression',
                                                                                operator: '!==',
                                                                                left: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'project',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 42,
                                                                                                column: 27,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 42,
                                                                                                column: 34,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'type',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 42,
                                                                                                column: 35,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 42,
                                                                                                column: 39,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 42,
                                                                                            column: 27,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 42,
                                                                                            column: 39,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                right: {
                                                                                    type: 'Literal',
                                                                                    value: 3
                                                                                }
                                                                            },
                                                                            consequent: {
                                                                                type: 'BlockStatement',
                                                                                body: [{
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'Literal',
                                                                                            value: 'assigned'
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 43,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 43,
                                                                                                column: 38,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            alternate: null,
                                                                            order: '2'
                                                                        },
                                                                        {
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'Literal',
                                                                                value: 'manualDuration'
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 44,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 44,
                                                                                    column: 40,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            },
                                                                            order: '3'
                                                                        },
                                                                        {
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'Literal',
                                                                                value: 'manualStart'
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 44,
                                                                                    column: 42,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 44,
                                                                                    column: 55,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            },
                                                                            order: '4'
                                                                        },
                                                                        {
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'Literal',
                                                                                value: 'manualFinish'
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 44,
                                                                                    column: 57,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 44,
                                                                                    column: 71,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            },
                                                                            order: '5'
                                                                        },
                                                                        {
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'Literal',
                                                                                value: 'description'
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 47,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 47,
                                                                                    column: 37,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            },
                                                                            order: '6'
                                                                        }
                                                                    ]
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            }]
                                                    },
                                                    order: '3'
                                                }
                                            ]
                                        }],
                                    loc: {
                                        start: {
                                            line: 23,
                                            column: 29,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        },
                                        end: {
                                            line: 49,
                                            column: 9,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        }
                                    }
                                },
                                properties: [{
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'project',
                                            loc: {
                                                start: {
                                                    line: 50,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                },
                                                end: {
                                                    line: 50,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Identifier',
                                            name: 'project',
                                            loc: {
                                                start: {
                                                    line: 50,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                },
                                                end: {
                                                    line: 50,
                                                    column: 28,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                }
                                            }
                                        },
                                        kind: 'init',
                                        order: '0'
                                    }]
                            }
                        }],
                    kind: 'let',
                    order: '8'
                },
                {
                    type: 'IfStatement',
                    test: {
                        type: 'UnaryExpression',
                        operator: '?',
                        argument: {
                            type: 'MemberExpression',
                            computed: false,
                            object: {
                                type: 'Identifier',
                                name: 'config',
                                loc: {
                                    start: {
                                        line: 52,
                                        column: 11,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 52,
                                        column: 17,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'viewTask',
                                loc: {
                                    start: {
                                        line: 52,
                                        column: 18,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 52,
                                        column: 26,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 52,
                                    column: 11,
                                    fixed: true,
                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                },
                                end: {
                                    line: 52,
                                    column: 26,
                                    fixed: true,
                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                }
                            }
                        }
                    },
                    consequent: {
                        type: 'BlockStatement',
                        body: [
                            {
                                type: 'VariableDeclaration',
                                declarations: [{
                                        type: 'VariableDeclarator',
                                        id: {
                                            type: 'Identifier',
                                            name: 'rows',
                                            loc: {
                                                start: {
                                                    line: 53,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                },
                                                end: {
                                                    line: 53,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                }
                                            }
                                        },
                                        init: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'dataTableModel',
                                                loc: {
                                                    start: {
                                                        line: 53,
                                                        column: 23,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                    },
                                                    end: {
                                                        line: 53,
                                                        column: 37,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'allRows',
                                                loc: {
                                                    start: {
                                                        line: 53,
                                                        column: 38,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                    },
                                                    end: {
                                                        line: 53,
                                                        column: 45,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 53,
                                                    column: 23,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                },
                                                end: {
                                                    line: 53,
                                                    column: 45,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                }
                                            }
                                        }
                                    }],
                                kind: 'let',
                                order: '0'
                            },
                            {
                                type: 'ExpressionStatement',
                                expression: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'Function',
                                        context: true,
                                        value: function (_context3) {
                                            return function (rows) {
                                                var config = _context3.get('config'), dataTableModel = _context3.get('dataTableModel');
                                                var taskKeys = rows.map(function (x) {
                                                        return x.key;
                                                    });
                                                var index = taskKeys.indexOf(config.viewTask);
                                                if (index > 0) {
                                                    dataTableModel.clearSelection();
                                                    rows[index].setSelected(true);
                                                    delete config.viewTask;
                                                }
                                            };
                                        }
                                    },
                                    arguments: [{
                                            type: 'Identifier',
                                            name: 'rows',
                                            loc: {
                                                start: {
                                                    line: 54,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                },
                                                end: {
                                                    line: 54,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                }
                                            }
                                        }],
                                    loc: {
                                        start: {
                                            line: 54,
                                            column: 12,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        },
                                        end: {
                                            line: 62,
                                            column: 16,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 54,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 62,
                                        column: 16,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                },
                                order: '1'
                            }
                        ]
                    },
                    alternate: null,
                    order: '9'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'scheduleState',
                                loc: {
                                    start: {
                                        line: 63,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 63,
                                        column: 25,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Function',
                                    context: false,
                                    value: function () {
                                        return {
                                            running: false,
                                            timeoutId: null,
                                            queueWhenDone: false
                                        };
                                    }
                                },
                                arguments: [],
                                loc: {
                                    start: {
                                        line: 63,
                                        column: 28,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 63,
                                        column: 89,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: ':'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'runSchedulerNow',
                                loc: {
                                    start: {
                                        line: 64,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 64,
                                        column: 27,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'Function',
                                context: true,
                                value: function (_context4) {
                                    return function (callback) {
                                        var scheduleState = _context4.get('scheduleState'), project = _context4.get('project'), tasks = _context4.get('tasks'), ion = _context4.get('ion'), queueRunScheduler = _context4.get('queueRunScheduler');
                                        scheduleState.timeoutId = null;
                                        if (project != null && tasks != null) {
                                            scheduleState.running = true;
                                            require('../../model/AutoScheduler').schedule({
                                                project: project,
                                                tasks: tasks,
                                                application: global.model,
                                                options: {
                                                    callbackAfter: function () {
                                                        scheduleState.running = false;
                                                        ion.sync();
                                                        if (scheduleState.queueWhenDone) {
                                                            queueRunScheduler();
                                                            scheduleState.queueWhenDone = false;
                                                        }
                                                    }
                                                }
                                            });
                                        } else {
                                            queueRunScheduler();
                                        }
                                    };
                                }
                            }
                        }],
                    kind: 'let',
                    order: ';'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'queueRunScheduler',
                                loc: {
                                    start: {
                                        line: 84,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 84,
                                        column: 29,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'Function',
                                context: true,
                                value: function (_context5) {
                                    return function () {
                                        var scheduleState = _context5.get('scheduleState'), runSchedulerNow = _context5.get('runSchedulerNow');
                                        if (scheduleState.running) {
                                            scheduleState.queueWhenDone = true;
                                        } else if (!(scheduleState.timeoutId != null)) {
                                            scheduleState.timeoutId = setTimeout(runSchedulerNow, 10);
                                        }
                                    };
                                }
                            }
                        }],
                    kind: 'let',
                    order: '<'
                },
                {
                    type: 'ReturnStatement',
                    argument: {
                        type: 'ArrayExpression',
                        elements: [
                            {
                                type: 'Identifier',
                                name: 'runSchedulerNow',
                                loc: {
                                    start: {
                                        line: 92,
                                        column: 16,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 92,
                                        column: 31,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            },
                            {
                                type: 'Identifier',
                                name: 'queueRunScheduler',
                                loc: {
                                    start: {
                                        line: 92,
                                        column: 33,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 92,
                                        column: 50,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            }
                        ]
                    },
                    order: '='
                },
                {
                    type: 'ExpressionStatement',
                    expression: {
                        type: 'CallExpression',
                        callee: {
                            type: 'Identifier',
                            name: 'queueRunScheduler',
                            loc: {
                                start: {
                                    line: 94,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                },
                                end: {
                                    line: 94,
                                    column: 25,
                                    fixed: true,
                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                }
                            }
                        },
                        arguments: [{
                                type: 'Identifier',
                                name: 'tasks',
                                loc: {
                                    start: {
                                        line: 94,
                                        column: 31,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 94,
                                        column: 36,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                },
                                deep: true
                            }],
                        loc: {
                            start: {
                                line: 94,
                                column: 8,
                                fixed: true,
                                source: 'viewpath/html/panes/ProjectPane.ion'
                            },
                            end: {
                                line: 94,
                                column: 37,
                                fixed: true,
                                source: 'viewpath/html/panes/ProjectPane.ion'
                            }
                        }
                    },
                    loc: {
                        start: {
                            line: 94,
                            column: 8,
                            fixed: true,
                            source: 'viewpath/html/panes/ProjectPane.ion'
                        },
                        end: {
                            line: 94,
                            column: 37,
                            fixed: true,
                            source: 'viewpath/html/panes/ProjectPane.ion'
                        }
                    },
                    order: '>'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'dataTable',
                                loc: {
                                    start: {
                                        line: 97,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 97,
                                        column: 21,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'DataTable',
                                    loc: {
                                        start: {
                                            line: 97,
                                            column: 24,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        },
                                        end: {
                                            line: 97,
                                            column: 33,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'ObjectExpression',
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'model',
                                                    loc: {
                                                        start: {
                                                            line: 97,
                                                            column: 35,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        },
                                                        end: {
                                                            line: 97,
                                                            column: 40,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Identifier',
                                                    name: 'dataTableModel',
                                                    loc: {
                                                        start: {
                                                            line: 97,
                                                            column: 42,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        },
                                                        end: {
                                                            line: 97,
                                                            column: 56,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        }
                                                    }
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'rowContent',
                                                    loc: {
                                                        start: {
                                                            line: 97,
                                                            column: 58,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        },
                                                        end: {
                                                            line: 97,
                                                            column: 68,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Identifier',
                                                    name: 'UserRowContent',
                                                    loc: {
                                                        start: {
                                                            line: 97,
                                                            column: 69,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        },
                                                        end: {
                                                            line: 97,
                                                            column: 83,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        }
                                                    }
                                                },
                                                kind: 'init',
                                                order: '1'
                                            }
                                        ]
                                    }],
                                loc: {
                                    start: {
                                        line: 97,
                                        column: 24,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 97,
                                        column: 85,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '?'
                },
                {
                    type: 'ReturnStatement',
                    argument: {
                        type: 'ObjectExpression',
                        objectType: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Div',
                                loc: {
                                    start: {
                                        line: 98,
                                        column: 15,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 98,
                                        column: 18,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ObjectExpression',
                                    properties: [{
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'class',
                                                loc: {
                                                    start: {
                                                        line: 98,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                    },
                                                    end: {
                                                        line: 98,
                                                        column: 25,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: 'fill layout vertical'
                                            },
                                            kind: 'init',
                                            order: '0'
                                        }]
                                }],
                            loc: {
                                start: {
                                    line: 98,
                                    column: 15,
                                    fixed: true,
                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                },
                                end: {
                                    line: 98,
                                    column: 50,
                                    fixed: true,
                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                }
                            }
                        },
                        properties: [
                            {
                                type: 'ExpressionStatement',
                                expression: {
                                    type: 'ObjectExpression',
                                    objectType: {
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'Identifier',
                                            name: 'Toolbar',
                                            loc: {
                                                start: {
                                                    line: 99,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                },
                                                end: {
                                                    line: 99,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                }
                                            }
                                        },
                                        arguments: [],
                                        loc: {
                                            start: {
                                                line: 99,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            },
                                            end: {
                                                line: 99,
                                                column: 21,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            }
                                        }
                                    },
                                    properties: [
                                        {
                                            type: 'VariableDeclaration',
                                            declarations: [{
                                                    type: 'VariableDeclarator',
                                                    id: {
                                                        type: 'Identifier',
                                                        name: 'type',
                                                        loc: {
                                                            start: {
                                                                line: 100,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 100,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        }
                                                    },
                                                    init: {
                                                        type: 'Identifier',
                                                        name: 'Task',
                                                        loc: {
                                                            start: {
                                                                line: 100,
                                                                column: 27,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 100,
                                                                column: 31,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        }
                                                    }
                                                }],
                                            kind: 'let',
                                            order: '0'
                                        },
                                        {
                                            type: 'VariableDeclaration',
                                            declarations: [{
                                                    type: 'VariableDeclarator',
                                                    id: {
                                                        type: 'Identifier',
                                                        name: 'hasSelection',
                                                        loc: {
                                                            start: {
                                                                line: 101,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 101,
                                                                column: 32,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        }
                                                    },
                                                    init: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'dataTableModel',
                                                            loc: {
                                                                start: {
                                                                    line: 101,
                                                                    column: 35,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 101,
                                                                    column: 49,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'hasSelection',
                                                            loc: {
                                                                start: {
                                                                    line: 101,
                                                                    column: 50,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 101,
                                                                    column: 62,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 101,
                                                                column: 35,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 101,
                                                                column: 62,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        }
                                                    }
                                                }],
                                            kind: 'let',
                                            order: '1'
                                        },
                                        {
                                            type: 'VariableDeclaration',
                                            declarations: [{
                                                    type: 'VariableDeclarator',
                                                    id: {
                                                        type: 'Identifier',
                                                        name: 'rowsSelected',
                                                        loc: {
                                                            start: {
                                                                line: 102,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 102,
                                                                column: 32,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        }
                                                    },
                                                    init: {
                                                        type: 'BinaryExpression',
                                                        operator: '&&',
                                                        left: {
                                                            type: 'Identifier',
                                                            name: 'hasSelection',
                                                            loc: {
                                                                start: {
                                                                    line: 102,
                                                                    column: 35,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 102,
                                                                    column: 47,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        right: {
                                                            type: 'BinaryExpression',
                                                            operator: '===',
                                                            left: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'dataTableModel',
                                                                        loc: {
                                                                            start: {
                                                                                line: 102,
                                                                                column: 52,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 102,
                                                                                column: 66,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'selectedColumns',
                                                                        loc: {
                                                                            start: {
                                                                                line: 102,
                                                                                column: 67,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 102,
                                                                                column: 82,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 102,
                                                                            column: 52,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 102,
                                                                            column: 82,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'length',
                                                                    loc: {
                                                                        start: {
                                                                            line: 102,
                                                                            column: 83,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 102,
                                                                            column: 89,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 102,
                                                                        column: 52,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 102,
                                                                        column: 89,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            right: {
                                                                type: 'Literal',
                                                                value: 0
                                                            }
                                                        }
                                                    }
                                                }],
                                            kind: 'let',
                                            order: '2'
                                        },
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'ObjectExpression',
                                                objectType: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'Identifier',
                                                        name: 'PaperIconButton',
                                                        loc: {
                                                            start: {
                                                                line: 103,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 103,
                                                                column: 31,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [],
                                                    loc: {
                                                        start: {
                                                            line: 103,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        },
                                                        end: {
                                                            line: 103,
                                                            column: 33,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        }
                                                    }
                                                },
                                                properties: [
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'icon',
                                                            loc: {
                                                                start: {
                                                                    line: 104,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 104,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Literal',
                                                            value: 'add'
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'title',
                                                            loc: {
                                                                start: {
                                                                    line: 105,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 105,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Literal',
                                                            value: 'Add Task'
                                                        },
                                                        kind: 'init',
                                                        order: '1'
                                                    },
                                                    {
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'Function',
                                                            context: true,
                                                            value: function (_context6) {
                                                                return function click(e) {
                                                                    var dataTable = _context6.get('dataTable');
                                                                    dataTable.addNewRow();
                                                                };
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 106,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 108,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        },
                                                        order: '2'
                                                    }
                                                ]
                                            },
                                            loc: {
                                                start: {
                                                    line: 103,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                },
                                                end: {
                                                    line: 108,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                }
                                            },
                                            order: '3'
                                        },
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'ObjectExpression',
                                                objectType: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'Identifier',
                                                        name: 'PaperIconButton',
                                                        loc: {
                                                            start: {
                                                                line: 108,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 108,
                                                                column: 31,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [],
                                                    loc: {
                                                        start: {
                                                            line: 108,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        },
                                                        end: {
                                                            line: 108,
                                                            column: 33,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        }
                                                    }
                                                },
                                                properties: [
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'icon',
                                                            loc: {
                                                                start: {
                                                                    line: 109,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 109,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Literal',
                                                            value: 'content-cut'
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'title',
                                                            loc: {
                                                                start: {
                                                                    line: 110,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 110,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'BinaryExpression',
                                                            operator: '+',
                                                            left: {
                                                                type: 'Literal',
                                                                value: 'Cut Selected '
                                                            },
                                                            right: {
                                                                type: 'ConditionalExpression',
                                                                test: {
                                                                    type: 'Identifier',
                                                                    name: 'rowsSelected',
                                                                    loc: {
                                                                        start: {
                                                                            line: 110,
                                                                            column: 46,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 110,
                                                                            column: 58,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                consequent: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '+',
                                                                    left: {
                                                                        type: 'BinaryExpression',
                                                                        operator: '+',
                                                                        left: {
                                                                            type: 'Literal',
                                                                            value: ''
                                                                        },
                                                                        right: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'type',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 110,
                                                                                        column: 64,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 110,
                                                                                        column: 68,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'name',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 110,
                                                                                        column: 69,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 110,
                                                                                        column: 73,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 110,
                                                                                    column: 64,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 110,
                                                                                    column: 73,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            }
                                                                        }
                                                                    },
                                                                    right: {
                                                                        type: 'Literal',
                                                                        value: '(s)'
                                                                    }
                                                                },
                                                                alternate: {
                                                                    type: 'Literal',
                                                                    value: 'Cells'
                                                                }
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '1'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'disabled',
                                                            loc: {
                                                                start: {
                                                                    line: 111,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 111,
                                                                    column: 28,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'UnaryExpression',
                                                            operator: '!',
                                                            argument: {
                                                                type: 'Identifier',
                                                                name: 'hasSelection',
                                                                loc: {
                                                                    start: {
                                                                        line: 111,
                                                                        column: 34,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 111,
                                                                        column: 46,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    }
                                                                }
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '2'
                                                    },
                                                    {
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'Function',
                                                            context: true,
                                                            value: function (_context7) {
                                                                return function click(e) {
                                                                    var dataTableModel = _context7.get('dataTableModel');
                                                                    return dataTableModel.cutSelection();
                                                                };
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 112,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 112,
                                                                column: 61,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        },
                                                        order: '3'
                                                    }
                                                ]
                                            },
                                            loc: {
                                                start: {
                                                    line: 108,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                },
                                                end: {
                                                    line: 113,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                }
                                            },
                                            order: '4'
                                        },
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'ObjectExpression',
                                                objectType: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'Identifier',
                                                        name: 'PaperIconButton',
                                                        loc: {
                                                            start: {
                                                                line: 113,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 113,
                                                                column: 31,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [],
                                                    loc: {
                                                        start: {
                                                            line: 113,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        },
                                                        end: {
                                                            line: 113,
                                                            column: 33,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        }
                                                    }
                                                },
                                                properties: [
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'icon',
                                                            loc: {
                                                                start: {
                                                                    line: 114,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 114,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Literal',
                                                            value: 'content-copy'
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'title',
                                                            loc: {
                                                                start: {
                                                                    line: 115,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 115,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'BinaryExpression',
                                                            operator: '+',
                                                            left: {
                                                                type: 'Literal',
                                                                value: 'Copy Selected '
                                                            },
                                                            right: {
                                                                type: 'ConditionalExpression',
                                                                test: {
                                                                    type: 'Identifier',
                                                                    name: 'rowsSelected',
                                                                    loc: {
                                                                        start: {
                                                                            line: 115,
                                                                            column: 47,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 115,
                                                                            column: 59,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                consequent: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '+',
                                                                    left: {
                                                                        type: 'BinaryExpression',
                                                                        operator: '+',
                                                                        left: {
                                                                            type: 'Literal',
                                                                            value: ''
                                                                        },
                                                                        right: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'type',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 115,
                                                                                        column: 65,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 115,
                                                                                        column: 69,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'name',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 115,
                                                                                        column: 70,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 115,
                                                                                        column: 74,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 115,
                                                                                    column: 65,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 115,
                                                                                    column: 74,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            }
                                                                        }
                                                                    },
                                                                    right: {
                                                                        type: 'Literal',
                                                                        value: '(s)'
                                                                    }
                                                                },
                                                                alternate: {
                                                                    type: 'Literal',
                                                                    value: 'Cells'
                                                                }
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '1'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'disabled',
                                                            loc: {
                                                                start: {
                                                                    line: 116,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 116,
                                                                    column: 28,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'UnaryExpression',
                                                            operator: '!',
                                                            argument: {
                                                                type: 'Identifier',
                                                                name: 'hasSelection',
                                                                loc: {
                                                                    start: {
                                                                        line: 116,
                                                                        column: 34,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 116,
                                                                        column: 46,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    }
                                                                }
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '2'
                                                    },
                                                    {
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'Function',
                                                            context: true,
                                                            value: function (_context8) {
                                                                return function click(e) {
                                                                    var dataTableModel = _context8.get('dataTableModel');
                                                                    return dataTableModel.copySelection();
                                                                };
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 117,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 117,
                                                                column: 62,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        },
                                                        order: '3'
                                                    }
                                                ]
                                            },
                                            loc: {
                                                start: {
                                                    line: 113,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                },
                                                end: {
                                                    line: 118,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                }
                                            },
                                            order: '5'
                                        },
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'ObjectExpression',
                                                objectType: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'Identifier',
                                                        name: 'PaperIconButton',
                                                        loc: {
                                                            start: {
                                                                line: 118,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 118,
                                                                column: 31,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [],
                                                    loc: {
                                                        start: {
                                                            line: 118,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        },
                                                        end: {
                                                            line: 118,
                                                            column: 33,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        }
                                                    }
                                                },
                                                properties: [
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'icon',
                                                            loc: {
                                                                start: {
                                                                    line: 119,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 119,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Literal',
                                                            value: 'content-paste'
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'title',
                                                            loc: {
                                                                start: {
                                                                    line: 120,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 120,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'BinaryExpression',
                                                            operator: '+',
                                                            left: {
                                                                type: 'Literal',
                                                                value: 'Paste Copied '
                                                            },
                                                            right: {
                                                                type: 'ConditionalExpression',
                                                                test: {
                                                                    type: 'Identifier',
                                                                    name: 'rowsSelected',
                                                                    loc: {
                                                                        start: {
                                                                            line: 120,
                                                                            column: 46,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 120,
                                                                            column: 58,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                consequent: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '+',
                                                                    left: {
                                                                        type: 'BinaryExpression',
                                                                        operator: '+',
                                                                        left: {
                                                                            type: 'Literal',
                                                                            value: ''
                                                                        },
                                                                        right: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'type',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 120,
                                                                                        column: 64,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 120,
                                                                                        column: 68,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'name',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 120,
                                                                                        column: 69,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 120,
                                                                                        column: 73,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 120,
                                                                                    column: 64,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 120,
                                                                                    column: 73,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            }
                                                                        }
                                                                    },
                                                                    right: {
                                                                        type: 'Literal',
                                                                        value: '(s)'
                                                                    }
                                                                },
                                                                alternate: {
                                                                    type: 'Literal',
                                                                    value: 'Cells'
                                                                }
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '1'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'disabled',
                                                            loc: {
                                                                start: {
                                                                    line: 121,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 121,
                                                                    column: 28,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'UnaryExpression',
                                                            operator: '!',
                                                            argument: {
                                                                type: 'Identifier',
                                                                name: 'hasSelection',
                                                                loc: {
                                                                    start: {
                                                                        line: 121,
                                                                        column: 34,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 121,
                                                                        column: 46,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    }
                                                                }
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '2'
                                                    },
                                                    {
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'Function',
                                                            context: true,
                                                            value: function (_context9) {
                                                                return function click(e) {
                                                                    var dataTableModel = _context9.get('dataTableModel');
                                                                    return dataTableModel.pasteSelection();
                                                                };
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 122,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 122,
                                                                column: 63,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        },
                                                        order: '3'
                                                    }
                                                ]
                                            },
                                            loc: {
                                                start: {
                                                    line: 118,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                },
                                                end: {
                                                    line: 123,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                }
                                            },
                                            order: '6'
                                        },
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'ObjectExpression',
                                                objectType: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'Identifier',
                                                        name: 'PaperIconButton',
                                                        loc: {
                                                            start: {
                                                                line: 127,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 127,
                                                                column: 31,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [],
                                                    loc: {
                                                        start: {
                                                            line: 127,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        },
                                                        end: {
                                                            line: 127,
                                                            column: 33,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        }
                                                    }
                                                },
                                                properties: [
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'icon',
                                                            loc: {
                                                                start: {
                                                                    line: 128,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 128,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Literal',
                                                            value: 'delete'
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'title',
                                                            loc: {
                                                                start: {
                                                                    line: 129,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 129,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'BinaryExpression',
                                                            operator: '+',
                                                            left: {
                                                                type: 'Literal',
                                                                value: 'Delete Selected '
                                                            },
                                                            right: {
                                                                type: 'ConditionalExpression',
                                                                test: {
                                                                    type: 'Identifier',
                                                                    name: 'rowsSelected',
                                                                    loc: {
                                                                        start: {
                                                                            line: 129,
                                                                            column: 49,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 129,
                                                                            column: 61,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                consequent: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '+',
                                                                    left: {
                                                                        type: 'BinaryExpression',
                                                                        operator: '+',
                                                                        left: {
                                                                            type: 'Literal',
                                                                            value: ''
                                                                        },
                                                                        right: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'type',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 129,
                                                                                        column: 67,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 129,
                                                                                        column: 71,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'name',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 129,
                                                                                        column: 72,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 129,
                                                                                        column: 76,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 129,
                                                                                    column: 67,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 129,
                                                                                    column: 76,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            }
                                                                        }
                                                                    },
                                                                    right: {
                                                                        type: 'Literal',
                                                                        value: '(s)'
                                                                    }
                                                                },
                                                                alternate: {
                                                                    type: 'Literal',
                                                                    value: 'Cells'
                                                                }
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '1'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'disabled',
                                                            loc: {
                                                                start: {
                                                                    line: 130,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 130,
                                                                    column: 28,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'UnaryExpression',
                                                            operator: '!',
                                                            argument: {
                                                                type: 'Identifier',
                                                                name: 'hasSelection',
                                                                loc: {
                                                                    start: {
                                                                        line: 130,
                                                                        column: 34,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 130,
                                                                        column: 46,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    }
                                                                }
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '2'
                                                    },
                                                    {
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'Function',
                                                            context: true,
                                                            value: function (_context10) {
                                                                return function click(e) {
                                                                    var dataTableModel = _context10.get('dataTableModel');
                                                                    return dataTableModel.deleteSelectedRows();
                                                                };
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 131,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 131,
                                                                column: 67,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        },
                                                        order: '3'
                                                    }
                                                ]
                                            },
                                            loc: {
                                                start: {
                                                    line: 127,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                },
                                                end: {
                                                    line: 132,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                }
                                            },
                                            order: '7'
                                        },
                                        {
                                            type: 'VariableDeclaration',
                                            declarations: [{
                                                    type: 'VariableDeclarator',
                                                    id: {
                                                        type: 'Identifier',
                                                        name: 'enableMovement',
                                                        loc: {
                                                            start: {
                                                                line: 132,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 132,
                                                                column: 34,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        }
                                                    },
                                                    init: {
                                                        type: 'BinaryExpression',
                                                        operator: '>',
                                                        left: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'dataTableModel',
                                                                    loc: {
                                                                        start: {
                                                                            line: 132,
                                                                            column: 37,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 132,
                                                                            column: 51,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'selectedRows',
                                                                    loc: {
                                                                        start: {
                                                                            line: 132,
                                                                            column: 52,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 132,
                                                                            column: 64,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 132,
                                                                        column: 37,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 132,
                                                                        column: 64,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'length',
                                                                loc: {
                                                                    start: {
                                                                        line: 132,
                                                                        column: 65,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 132,
                                                                        column: 71,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 132,
                                                                    column: 37,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 132,
                                                                    column: 71,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        right: {
                                                            type: 'Literal',
                                                            value: 0
                                                        }
                                                    }
                                                }],
                                            kind: 'let',
                                            order: '8'
                                        },
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'ObjectExpression',
                                                objectType: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'Identifier',
                                                        name: 'PaperIconButton',
                                                        loc: {
                                                            start: {
                                                                line: 133,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 133,
                                                                column: 31,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [],
                                                    loc: {
                                                        start: {
                                                            line: 133,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        },
                                                        end: {
                                                            line: 133,
                                                            column: 33,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        }
                                                    }
                                                },
                                                properties: [
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'icon',
                                                            loc: {
                                                                start: {
                                                                    line: 134,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 134,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Literal',
                                                            value: 'hardware:keyboard-arrow-left'
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'disabled',
                                                            loc: {
                                                                start: {
                                                                    line: 135,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 135,
                                                                    column: 28,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'UnaryExpression',
                                                            operator: '!',
                                                            argument: {
                                                                type: 'Identifier',
                                                                name: 'enableMovement',
                                                                loc: {
                                                                    start: {
                                                                        line: 135,
                                                                        column: 34,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 135,
                                                                        column: 48,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    }
                                                                }
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '1'
                                                    },
                                                    {
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'Function',
                                                            context: true,
                                                            value: function (_context11) {
                                                                return function click(e) {
                                                                    var dataTableModel = _context11.get('dataTableModel'), dataTable = _context11.get('dataTable');
                                                                    dataTableModel.outdentRows();
                                                                    dataTable.focus();
                                                                };
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 136,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 139,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        },
                                                        order: '2'
                                                    }
                                                ]
                                            },
                                            loc: {
                                                start: {
                                                    line: 133,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                },
                                                end: {
                                                    line: 139,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                }
                                            },
                                            order: '9'
                                        },
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'ObjectExpression',
                                                objectType: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'Identifier',
                                                        name: 'PaperIconButton',
                                                        loc: {
                                                            start: {
                                                                line: 139,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 139,
                                                                column: 31,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [],
                                                    loc: {
                                                        start: {
                                                            line: 139,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        },
                                                        end: {
                                                            line: 139,
                                                            column: 33,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        }
                                                    }
                                                },
                                                properties: [
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'icon',
                                                            loc: {
                                                                start: {
                                                                    line: 140,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 140,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Literal',
                                                            value: 'hardware:keyboard-arrow-right'
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'disabled',
                                                            loc: {
                                                                start: {
                                                                    line: 141,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 141,
                                                                    column: 28,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'UnaryExpression',
                                                            operator: '!',
                                                            argument: {
                                                                type: 'Identifier',
                                                                name: 'enableMovement',
                                                                loc: {
                                                                    start: {
                                                                        line: 141,
                                                                        column: 34,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 141,
                                                                        column: 48,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    }
                                                                }
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '1'
                                                    },
                                                    {
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'Function',
                                                            context: true,
                                                            value: function (_context12) {
                                                                return function click(e) {
                                                                    var dataTableModel = _context12.get('dataTableModel'), dataTable = _context12.get('dataTable');
                                                                    dataTableModel.indentRows();
                                                                    dataTable.focus();
                                                                };
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 142,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 145,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        },
                                                        order: '2'
                                                    }
                                                ]
                                            },
                                            loc: {
                                                start: {
                                                    line: 139,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                },
                                                end: {
                                                    line: 145,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                }
                                            },
                                            order: ':'
                                        },
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'ObjectExpression',
                                                objectType: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'Identifier',
                                                        name: 'PaperIconButton',
                                                        loc: {
                                                            start: {
                                                                line: 145,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 145,
                                                                column: 31,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [],
                                                    loc: {
                                                        start: {
                                                            line: 145,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        },
                                                        end: {
                                                            line: 145,
                                                            column: 33,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        }
                                                    }
                                                },
                                                properties: [
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'icon',
                                                            loc: {
                                                                start: {
                                                                    line: 146,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 146,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Literal',
                                                            value: 'hardware:keyboard-arrow-up'
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'disabled',
                                                            loc: {
                                                                start: {
                                                                    line: 147,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 147,
                                                                    column: 28,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'UnaryExpression',
                                                            operator: '!',
                                                            argument: {
                                                                type: 'Identifier',
                                                                name: 'enableMovement',
                                                                loc: {
                                                                    start: {
                                                                        line: 147,
                                                                        column: 34,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 147,
                                                                        column: 48,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    }
                                                                }
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '1'
                                                    },
                                                    {
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'Function',
                                                            context: true,
                                                            value: function (_context13) {
                                                                return function click(e) {
                                                                    var dataTableModel = _context13.get('dataTableModel'), dataTable = _context13.get('dataTable');
                                                                    dataTableModel.moveRowsUp();
                                                                    dataTable.focus();
                                                                };
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 148,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 151,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        },
                                                        order: '2'
                                                    }
                                                ]
                                            },
                                            loc: {
                                                start: {
                                                    line: 145,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                },
                                                end: {
                                                    line: 151,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                }
                                            },
                                            order: ';'
                                        },
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'ObjectExpression',
                                                objectType: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'Identifier',
                                                        name: 'PaperIconButton',
                                                        loc: {
                                                            start: {
                                                                line: 151,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 151,
                                                                column: 31,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [],
                                                    loc: {
                                                        start: {
                                                            line: 151,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        },
                                                        end: {
                                                            line: 151,
                                                            column: 33,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        }
                                                    }
                                                },
                                                properties: [
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'icon',
                                                            loc: {
                                                                start: {
                                                                    line: 152,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 152,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Literal',
                                                            value: 'hardware:keyboard-arrow-down'
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'disabled',
                                                            loc: {
                                                                start: {
                                                                    line: 153,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 153,
                                                                    column: 28,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'UnaryExpression',
                                                            operator: '!',
                                                            argument: {
                                                                type: 'Identifier',
                                                                name: 'enableMovement',
                                                                loc: {
                                                                    start: {
                                                                        line: 153,
                                                                        column: 34,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 153,
                                                                        column: 48,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    }
                                                                }
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '1'
                                                    },
                                                    {
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'Function',
                                                            context: true,
                                                            value: function (_context14) {
                                                                return function click(e) {
                                                                    var dataTableModel = _context14.get('dataTableModel'), dataTable = _context14.get('dataTable');
                                                                    dataTableModel.moveRowsDown();
                                                                    dataTable.focus();
                                                                };
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 154,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 158,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        },
                                                        order: '2'
                                                    }
                                                ]
                                            },
                                            loc: {
                                                start: {
                                                    line: 151,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                },
                                                end: {
                                                    line: 158,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                }
                                            },
                                            order: '<'
                                        },
                                        {
                                            type: 'VariableDeclaration',
                                            declarations: [{
                                                    type: 'VariableDeclarator',
                                                    id: {
                                                        type: 'Identifier',
                                                        name: 'link',
                                                        loc: {
                                                            start: {
                                                                line: 159,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 159,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        }
                                                    },
                                                    init: {
                                                        type: 'Function',
                                                        context: true,
                                                        value: function (_context15) {
                                                            return function (e, type, link) {
                                                                if (link == null)
                                                                    link = true;
                                                                var dataTableModel = _context15.get('dataTableModel');
                                                                global.model.ops.begin();
                                                                var _ref14 = [];
                                                                {
                                                                    var _ref15 = dataTableModel.selectedRows;
                                                                    for (var _i = 0; _i < _ref15.length; _i++) {
                                                                        var row = _ref15[_i];
                                                                        _ref14.push(row.getRecordAndAncestors());
                                                                    }
                                                                }
                                                                var recordLineages = _ref14;
                                                                var previous = null;
                                                                for (var _i2 = 0; _i2 < recordLineages.length; _i2++) {
                                                                    var current = recordLineages[_i2];
                                                                    if (previous != null && !previous.includes(current[0]) && !current.includes(previous[0])) {
                                                                        var dependee = previous[0];
                                                                        var dependent = current[0];
                                                                        if (link) {
                                                                            dependent.addPredecessor(dependee.getKey(), type);
                                                                        } else {
                                                                            dependee.removePredecessor(dependent.getKey());
                                                                            dependent.removePredecessor(dependee.getKey());
                                                                        }
                                                                    }
                                                                    previous = current;
                                                                }
                                                            };
                                                        }
                                                    }
                                                }],
                                            kind: 'let',
                                            order: '='
                                        },
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'ObjectExpression',
                                                objectType: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'Identifier',
                                                        name: 'PaperMenuButton',
                                                        loc: {
                                                            start: {
                                                                line: 177,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 177,
                                                                column: 31,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [],
                                                    loc: {
                                                        start: {
                                                            line: 177,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        },
                                                        end: {
                                                            line: 177,
                                                            column: 33,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        }
                                                    }
                                                },
                                                properties: [
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'title',
                                                            loc: {
                                                                start: {
                                                                    line: 178,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 178,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Literal',
                                                            value: 'Toggles dependency links between Tasks'
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'disabled',
                                                            loc: {
                                                                start: {
                                                                    line: 179,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 179,
                                                                    column: 28,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'BinaryExpression',
                                                            operator: '<',
                                                            left: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'dataTableModel',
                                                                        loc: {
                                                                            start: {
                                                                                line: 179,
                                                                                column: 30,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 179,
                                                                                column: 44,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'selectedRows',
                                                                        loc: {
                                                                            start: {
                                                                                line: 179,
                                                                                column: 45,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 179,
                                                                                column: 57,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 179,
                                                                            column: 30,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 179,
                                                                            column: 57,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'length',
                                                                    loc: {
                                                                        start: {
                                                                            line: 179,
                                                                            column: 58,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 179,
                                                                            column: 64,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 179,
                                                                        column: 30,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 179,
                                                                        column: 64,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            right: {
                                                                type: 'Literal',
                                                                value: 2
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '1'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'closeOnActivate',
                                                            loc: {
                                                                start: {
                                                                    line: 180,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 180,
                                                                    column: 35,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Literal',
                                                            value: true
                                                        },
                                                        kind: 'init',
                                                        order: '2'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'restoreFocusOnClose',
                                                            loc: {
                                                                start: {
                                                                    line: 181,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 181,
                                                                    column: 39,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Literal',
                                                            value: false
                                                        },
                                                        kind: 'init',
                                                        order: '3'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'horizontalAlign',
                                                            loc: {
                                                                start: {
                                                                    line: 182,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 182,
                                                                    column: 35,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Literal',
                                                            value: 'right'
                                                        },
                                                        kind: 'init',
                                                        order: '4'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'verticalAlign',
                                                            loc: {
                                                                start: {
                                                                    line: 183,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 183,
                                                                    column: 33,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Literal',
                                                            value: 'top'
                                                        },
                                                        kind: 'init',
                                                        order: '5'
                                                    },
                                                    {
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'ObjectExpression',
                                                            objectType: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Identifier',
                                                                    name: 'PaperIconButton',
                                                                    loc: {
                                                                        start: {
                                                                            line: 184,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 184,
                                                                            column: 35,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'ObjectExpression',
                                                                        properties: [{
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'class',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 184,
                                                                                            column: 37,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 184,
                                                                                            column: 42,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Literal',
                                                                                    value: 'dropdown-trigger'
                                                                                },
                                                                                kind: 'init',
                                                                                order: '0'
                                                                            }]
                                                                    }],
                                                                loc: {
                                                                    start: {
                                                                        line: 184,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 184,
                                                                        column: 63,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            properties: [{
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'icon',
                                                                        loc: {
                                                                            start: {
                                                                                line: 185,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 185,
                                                                                column: 28,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Literal',
                                                                        value: 'link'
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                }]
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 184,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 186,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        },
                                                        order: '6'
                                                    },
                                                    {
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'ObjectExpression',
                                                            objectType: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Identifier',
                                                                    name: 'PaperMenu',
                                                                    loc: {
                                                                        start: {
                                                                            line: 186,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 186,
                                                                            column: 29,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [{
                                                                        type: 'ObjectExpression',
                                                                        properties: [{
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'class',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 186,
                                                                                            column: 31,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 186,
                                                                                            column: 36,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Literal',
                                                                                    value: 'dropdown-content'
                                                                                },
                                                                                kind: 'init',
                                                                                order: '0'
                                                                            }]
                                                                    }],
                                                                loc: {
                                                                    start: {
                                                                        line: 186,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 186,
                                                                        column: 57,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            properties: [
                                                                {
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'ObjectExpression',
                                                                        objectType: {
                                                                            type: 'CallExpression',
                                                                            callee: {
                                                                                type: 'Identifier',
                                                                                name: 'PaperItem',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 187,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 187,
                                                                                        column: 33,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            arguments: [],
                                                                            loc: {
                                                                                start: {
                                                                                    line: 187,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 187,
                                                                                    column: 35,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        properties: [
                                                                            {
                                                                                type: 'ExpressionStatement',
                                                                                expression: {
                                                                                    type: 'Literal',
                                                                                    value: 'Link Finish to Start'
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 188,
                                                                                        column: 28,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 188,
                                                                                        column: 50,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                },
                                                                                order: '0'
                                                                            },
                                                                            {
                                                                                type: 'ExpressionStatement',
                                                                                expression: {
                                                                                    type: 'Function',
                                                                                    context: true,
                                                                                    value: function (_context16) {
                                                                                        return function click(e) {
                                                                                            var link = _context16.get('link');
                                                                                            return link(e, 'FS');
                                                                                        };
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 189,
                                                                                        column: 28,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 189,
                                                                                        column: 53,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                },
                                                                                order: '1'
                                                                            }
                                                                        ]
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 187,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 190,
                                                                            column: 28,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    },
                                                                    order: '0'
                                                                },
                                                                {
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'ObjectExpression',
                                                                        objectType: {
                                                                            type: 'CallExpression',
                                                                            callee: {
                                                                                type: 'Identifier',
                                                                                name: 'PaperItem',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 190,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 190,
                                                                                        column: 33,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            arguments: [],
                                                                            loc: {
                                                                                start: {
                                                                                    line: 190,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 190,
                                                                                    column: 35,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        properties: [
                                                                            {
                                                                                type: 'ExpressionStatement',
                                                                                expression: {
                                                                                    type: 'Literal',
                                                                                    value: 'Link Finish to Finish'
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 191,
                                                                                        column: 28,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 191,
                                                                                        column: 51,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                },
                                                                                order: '0'
                                                                            },
                                                                            {
                                                                                type: 'ExpressionStatement',
                                                                                expression: {
                                                                                    type: 'Function',
                                                                                    context: true,
                                                                                    value: function (_context17) {
                                                                                        return function click(e) {
                                                                                            var link = _context17.get('link');
                                                                                            return link(e, 'FF');
                                                                                        };
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 192,
                                                                                        column: 28,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 192,
                                                                                        column: 53,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                },
                                                                                order: '1'
                                                                            }
                                                                        ]
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 190,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 193,
                                                                            column: 28,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    },
                                                                    order: '1'
                                                                },
                                                                {
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'ObjectExpression',
                                                                        objectType: {
                                                                            type: 'CallExpression',
                                                                            callee: {
                                                                                type: 'Identifier',
                                                                                name: 'PaperItem',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 193,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 193,
                                                                                        column: 33,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            arguments: [],
                                                                            loc: {
                                                                                start: {
                                                                                    line: 193,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 193,
                                                                                    column: 35,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        properties: [
                                                                            {
                                                                                type: 'ExpressionStatement',
                                                                                expression: {
                                                                                    type: 'Literal',
                                                                                    value: 'Link Start to Start'
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 194,
                                                                                        column: 28,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 194,
                                                                                        column: 49,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                },
                                                                                order: '0'
                                                                            },
                                                                            {
                                                                                type: 'ExpressionStatement',
                                                                                expression: {
                                                                                    type: 'Function',
                                                                                    context: true,
                                                                                    value: function (_context18) {
                                                                                        return function click(e) {
                                                                                            var link = _context18.get('link');
                                                                                            return link(e, 'SS');
                                                                                        };
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 195,
                                                                                        column: 28,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 195,
                                                                                        column: 53,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                },
                                                                                order: '1'
                                                                            }
                                                                        ]
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 193,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 196,
                                                                            column: 28,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    },
                                                                    order: '2'
                                                                },
                                                                {
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'ObjectExpression',
                                                                        objectType: {
                                                                            type: 'CallExpression',
                                                                            callee: {
                                                                                type: 'Identifier',
                                                                                name: 'PaperItem',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 196,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 196,
                                                                                        column: 33,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            arguments: [],
                                                                            loc: {
                                                                                start: {
                                                                                    line: 196,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 196,
                                                                                    column: 35,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        properties: [
                                                                            {
                                                                                type: 'ExpressionStatement',
                                                                                expression: {
                                                                                    type: 'Literal',
                                                                                    value: 'Link Start to Finish'
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 197,
                                                                                        column: 28,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 197,
                                                                                        column: 50,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                },
                                                                                order: '0'
                                                                            },
                                                                            {
                                                                                type: 'ExpressionStatement',
                                                                                expression: {
                                                                                    type: 'Function',
                                                                                    context: true,
                                                                                    value: function (_context19) {
                                                                                        return function click(e) {
                                                                                            var link = _context19.get('link');
                                                                                            return link(e, 'SF');
                                                                                        };
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 199,
                                                                                        column: 28,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 199,
                                                                                        column: 53,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                },
                                                                                order: '1'
                                                                            }
                                                                        ]
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 196,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 200,
                                                                            column: 28,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    },
                                                                    order: '3'
                                                                },
                                                                {
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'ObjectExpression',
                                                                        objectType: {
                                                                            type: 'CallExpression',
                                                                            callee: {
                                                                                type: 'Identifier',
                                                                                name: 'PaperItem',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 200,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 200,
                                                                                        column: 33,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            arguments: [],
                                                                            loc: {
                                                                                start: {
                                                                                    line: 200,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 200,
                                                                                    column: 35,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        properties: [
                                                                            {
                                                                                type: 'ExpressionStatement',
                                                                                expression: {
                                                                                    type: 'Literal',
                                                                                    value: 'Unlink'
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 201,
                                                                                        column: 28,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 201,
                                                                                        column: 36,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                },
                                                                                order: '0'
                                                                            },
                                                                            {
                                                                                type: 'ExpressionStatement',
                                                                                expression: {
                                                                                    type: 'Function',
                                                                                    context: true,
                                                                                    value: function (_context20) {
                                                                                        return function click(e) {
                                                                                            var link = _context20.get('link');
                                                                                            return link(e, 'SF', false);
                                                                                        };
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 202,
                                                                                        column: 28,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 202,
                                                                                        column: 60,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                },
                                                                                order: '1'
                                                                            }
                                                                        ]
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 200,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 204,
                                                                            column: 28,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    },
                                                                    order: '4'
                                                                }
                                                            ]
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 186,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 204,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        },
                                                        order: '7'
                                                    }
                                                ]
                                            },
                                            loc: {
                                                start: {
                                                    line: 177,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                },
                                                end: {
                                                    line: 204,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                }
                                            },
                                            order: '>'
                                        },
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'ObjectExpression',
                                                objectType: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'Identifier',
                                                        name: 'PaperIconButton',
                                                        loc: {
                                                            start: {
                                                                line: 204,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 204,
                                                                column: 31,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [],
                                                    loc: {
                                                        start: {
                                                            line: 204,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        },
                                                        end: {
                                                            line: 204,
                                                            column: 33,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        }
                                                    }
                                                },
                                                properties: [
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'icon',
                                                            loc: {
                                                                start: {
                                                                    line: 205,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 205,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Literal',
                                                            value: 'refresh'
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'Function',
                                                            context: true,
                                                            value: function (_context21) {
                                                                return function click(e) {
                                                                    var dataTableModel = _context21.get('dataTableModel');
                                                                    dataTableModel.refresh();
                                                                };
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 206,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 209,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        },
                                                        order: '1'
                                                    }
                                                ]
                                            },
                                            loc: {
                                                start: {
                                                    line: 204,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                },
                                                end: {
                                                    line: 209,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                }
                                            },
                                            order: '?'
                                        },
                                        {
                                            type: 'IfStatement',
                                            test: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'project',
                                                    loc: {
                                                        start: {
                                                            line: 209,
                                                            column: 19,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        },
                                                        end: {
                                                            line: 209,
                                                            column: 26,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'isTemplate',
                                                    loc: {
                                                        start: {
                                                            line: 209,
                                                            column: 27,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        },
                                                        end: {
                                                            line: 209,
                                                            column: 37,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 209,
                                                        column: 19,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                    },
                                                    end: {
                                                        line: 209,
                                                        column: 37,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                    }
                                                }
                                            },
                                            consequent: {
                                                type: 'BlockStatement',
                                                body: [{
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'ObjectExpression',
                                                            objectType: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Identifier',
                                                                    name: 'PaperButton',
                                                                    loc: {
                                                                        start: {
                                                                            line: 210,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 210,
                                                                            column: 31,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [],
                                                                loc: {
                                                                    start: {
                                                                        line: 210,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 210,
                                                                        column: 33,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            properties: [
                                                                {
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'Function',
                                                                        context: true,
                                                                        value: function (_context22) {
                                                                            return function click(e) {
                                                                                var clone = _context22.get('clone'), ProjectType = _context22.get('ProjectType');
                                                                                clone({ type: ProjectType.Project.id });
                                                                            };
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 211,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 213,
                                                                            column: 28,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    },
                                                                    order: '0'
                                                                },
                                                                {
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'Literal',
                                                                        value: 'Create Project'
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 213,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 213,
                                                                            column: 40,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    },
                                                                    order: '1'
                                                                }
                                                            ]
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 210,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 216,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        },
                                                        order: '0'
                                                    }]
                                            },
                                            alternate: null,
                                            order: '@'
                                        },
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'Div',
                                                    loc: {
                                                        start: {
                                                            line: 216,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        },
                                                        end: {
                                                            line: 216,
                                                            column: 19,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [{
                                                        type: 'ObjectExpression',
                                                        properties: [{
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'class',
                                                                    loc: {
                                                                        start: {
                                                                            line: 216,
                                                                            column: 21,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 216,
                                                                            column: 26,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: 'fill'
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            }]
                                                    }],
                                                loc: {
                                                    start: {
                                                        line: 216,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                    },
                                                    end: {
                                                        line: 216,
                                                        column: 35,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 216,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                },
                                                end: {
                                                    line: 216,
                                                    column: 35,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                }
                                            },
                                            order: 'A'
                                        },
                                        {
                                            type: 'IfStatement',
                                            test: {
                                                type: 'BinaryExpression',
                                                operator: '===',
                                                left: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'state',
                                                        loc: {
                                                            start: {
                                                                line: 217,
                                                                column: 19,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 217,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'timeline',
                                                        loc: {
                                                            start: {
                                                                line: 217,
                                                                column: 25,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 217,
                                                                column: 33,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 217,
                                                            column: 19,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        },
                                                        end: {
                                                            line: 217,
                                                            column: 33,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        }
                                                    }
                                                },
                                                right: {
                                                    type: 'Literal',
                                                    value: true
                                                }
                                            },
                                            consequent: {
                                                type: 'BlockStatement',
                                                body: [
                                                    {
                                                        type: 'VariableDeclaration',
                                                        declarations: [{
                                                                type: 'VariableDeclarator',
                                                                id: {
                                                                    type: 'Identifier',
                                                                    name: 'timelineColumn',
                                                                    loc: {
                                                                        start: {
                                                                            line: 218,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 218,
                                                                            column: 38,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                init: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'dataTableModel',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 218,
                                                                                    column: 41,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 218,
                                                                                    column: 55,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'getColumn',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 218,
                                                                                    column: 56,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 218,
                                                                                    column: 65,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 218,
                                                                                column: 41,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 218,
                                                                                column: 65,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [
                                                                        {
                                                                            type: 'Literal',
                                                                            value: 'Timeline'
                                                                        },
                                                                        {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'dataTableModel',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 218,
                                                                                        column: 78,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 218,
                                                                                        column: 92,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'columns',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 218,
                                                                                        column: 93,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 218,
                                                                                        column: 100,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 218,
                                                                                    column: 78,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 218,
                                                                                    column: 100,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            }
                                                                        }
                                                                    ],
                                                                    loc: {
                                                                        start: {
                                                                            line: 218,
                                                                            column: 41,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 218,
                                                                            column: 101,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                }
                                                            }],
                                                        kind: 'let',
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'ObjectExpression',
                                                            objectType: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Identifier',
                                                                    name: 'PaperIconButton',
                                                                    loc: {
                                                                        start: {
                                                                            line: 219,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 219,
                                                                            column: 35,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [],
                                                                loc: {
                                                                    start: {
                                                                        line: 219,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 219,
                                                                        column: 37,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            properties: [
                                                                {
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'icon',
                                                                        loc: {
                                                                            start: {
                                                                                line: 220,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 220,
                                                                                column: 28,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Literal',
                                                                        value: 'zoom-in'
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                },
                                                                {
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'disabled',
                                                                        loc: {
                                                                            start: {
                                                                                line: 221,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 221,
                                                                                column: 32,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'UnaryExpression',
                                                                        operator: '!',
                                                                        argument: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'timelineColumn',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 221,
                                                                                        column: 38,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 221,
                                                                                        column: 52,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'canZoomIn',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 221,
                                                                                        column: 54,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 221,
                                                                                        column: 63,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            existential: true,
                                                                            loc: {
                                                                                start: {
                                                                                    line: 221,
                                                                                    column: 38,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 221,
                                                                                    column: 63,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            }
                                                                        }
                                                                    },
                                                                    kind: 'init',
                                                                    order: '1'
                                                                },
                                                                {
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'Function',
                                                                        context: true,
                                                                        value: function (_context23) {
                                                                            return function click(e) {
                                                                                var timelineColumn = _context23.get('timelineColumn');
                                                                                timelineColumn.zoomIn();
                                                                            };
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 222,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 224,
                                                                            column: 28,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    },
                                                                    order: '2'
                                                                }
                                                            ]
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 219,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 224,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        },
                                                        order: '1'
                                                    },
                                                    {
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'ObjectExpression',
                                                            objectType: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Identifier',
                                                                    name: 'PaperIconButton',
                                                                    loc: {
                                                                        start: {
                                                                            line: 224,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 224,
                                                                            column: 35,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [],
                                                                loc: {
                                                                    start: {
                                                                        line: 224,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 224,
                                                                        column: 37,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            properties: [
                                                                {
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'icon',
                                                                        loc: {
                                                                            start: {
                                                                                line: 225,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 225,
                                                                                column: 28,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Literal',
                                                                        value: 'zoom-out'
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                },
                                                                {
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'disabled',
                                                                        loc: {
                                                                            start: {
                                                                                line: 226,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 226,
                                                                                column: 32,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'UnaryExpression',
                                                                        operator: '!',
                                                                        argument: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'timelineColumn',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 226,
                                                                                        column: 38,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 226,
                                                                                        column: 52,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'canZoomOut',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 226,
                                                                                        column: 54,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 226,
                                                                                        column: 64,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            existential: true,
                                                                            loc: {
                                                                                start: {
                                                                                    line: 226,
                                                                                    column: 38,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 226,
                                                                                    column: 64,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            }
                                                                        }
                                                                    },
                                                                    kind: 'init',
                                                                    order: '1'
                                                                },
                                                                {
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'Function',
                                                                        context: true,
                                                                        value: function (_context24) {
                                                                            return function click(e) {
                                                                                var timelineColumn = _context24.get('timelineColumn');
                                                                                timelineColumn.zoomOut();
                                                                            };
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 227,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 229,
                                                                            column: 28,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    },
                                                                    order: '2'
                                                                }
                                                            ]
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 224,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 229,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        },
                                                        order: '2'
                                                    }
                                                ]
                                            },
                                            alternate: null,
                                            order: 'B'
                                        },
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'ObjectExpression',
                                                objectType: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'Identifier',
                                                        name: 'PaperToggleButton',
                                                        loc: {
                                                            start: {
                                                                line: 229,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 229,
                                                                column: 33,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [],
                                                    loc: {
                                                        start: {
                                                            line: 229,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        },
                                                        end: {
                                                            line: 229,
                                                            column: 35,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        }
                                                    }
                                                },
                                                properties: [
                                                    {
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'Literal',
                                                            value: 'Timeline'
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 230,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 230,
                                                                column: 30,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        },
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'checked',
                                                            loc: {
                                                                start: {
                                                                    line: 231,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 231,
                                                                    column: 27,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'BinaryExpression',
                                                            operator: '===',
                                                            left: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'state',
                                                                    loc: {
                                                                        start: {
                                                                            line: 231,
                                                                            column: 29,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 231,
                                                                            column: 34,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'timeline',
                                                                    loc: {
                                                                        start: {
                                                                            line: 231,
                                                                            column: 35,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 231,
                                                                            column: 43,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 231,
                                                                        column: 29,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 231,
                                                                        column: 43,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            right: {
                                                                type: 'Literal',
                                                                value: true
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '1'
                                                    },
                                                    {
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'Function',
                                                            context: true,
                                                            value: function (_context25) {
                                                                return function click(e) {
                                                                    var dataTableModel = _context25.get('dataTableModel'), state = _context25.get('state');
                                                                    dataTableModel.clearSelection();
                                                                    state.timeline = this.checked;
                                                                };
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 232,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 236,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        },
                                                        order: '2'
                                                    }
                                                ]
                                            },
                                            loc: {
                                                start: {
                                                    line: 229,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                },
                                                end: {
                                                    line: 236,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                }
                                            },
                                            order: 'C'
                                        },
                                        {
                                            type: 'VariableDeclaration',
                                            declarations: [{
                                                    type: 'VariableDeclarator',
                                                    id: {
                                                        type: 'Identifier',
                                                        name: 'clone',
                                                        loc: {
                                                            start: {
                                                                line: 236,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 236,
                                                                column: 25,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        }
                                                    },
                                                    init: {
                                                        type: 'Function',
                                                        context: true,
                                                        value: function (_context26) {
                                                            return function (properties) {
                                                                var ProjectType = _context26.get('ProjectType'), project = _context26.get('project'), PromptDialog = _context26.get('PromptDialog'), tasks = _context26.get('tasks');
                                                                var projectTypeName = ProjectType[(properties != null ? properties.type : void 0) != null ? properties.type : project.type].name;
                                                                PromptDialog.show({
                                                                    title: 'Clone this ' + projectTypeName,
                                                                    properties: [{
                                                                            name: 'name',
                                                                            label: '' + projectTypeName + ' Name'
                                                                        }],
                                                                    values: {},
                                                                    callback: function (values) {
                                                                        var name = values.name;
                                                                        if (name != null) {
                                                                            properties = properties != null ? properties : {};
                                                                            properties.name = name;
                                                                            global.model.cloneProject({
                                                                                project: project,
                                                                                properties: properties,
                                                                                tasks: tasks
                                                                            }, function (newProject) {
                                                                                model.open(newProject.paneConfig);
                                                                            });
                                                                        }
                                                                    }
                                                                });
                                                            };
                                                        }
                                                    }
                                                }],
                                            kind: 'let',
                                            order: 'D'
                                        },
                                        {
                                            type: 'IfStatement',
                                            test: {
                                                type: 'UnaryExpression',
                                                operator: '!',
                                                argument: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'config',
                                                        loc: {
                                                            start: {
                                                                line: 254,
                                                                column: 23,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 254,
                                                                column: 29,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'embedded',
                                                        loc: {
                                                            start: {
                                                                line: 254,
                                                                column: 30,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 254,
                                                                column: 38,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 254,
                                                            column: 23,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        },
                                                        end: {
                                                            line: 254,
                                                            column: 38,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        }
                                                    }
                                                }
                                            },
                                            consequent: {
                                                type: 'BlockStatement',
                                                body: [{
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'ObjectExpression',
                                                            objectType: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Identifier',
                                                                    name: 'PaperMenuButton',
                                                                    loc: {
                                                                        start: {
                                                                            line: 255,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 255,
                                                                            column: 35,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [],
                                                                loc: {
                                                                    start: {
                                                                        line: 255,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 255,
                                                                        column: 37,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            properties: [
                                                                {
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'closeOnActivate',
                                                                        loc: {
                                                                            start: {
                                                                                line: 256,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 256,
                                                                                column: 39,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Literal',
                                                                        value: true
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                },
                                                                {
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'restoreFocusOnClose',
                                                                        loc: {
                                                                            start: {
                                                                                line: 257,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 257,
                                                                                column: 43,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Literal',
                                                                        value: false
                                                                    },
                                                                    kind: 'init',
                                                                    order: '1'
                                                                },
                                                                {
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'horizontalAlign',
                                                                        loc: {
                                                                            start: {
                                                                                line: 258,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 258,
                                                                                column: 39,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Literal',
                                                                        value: 'right'
                                                                    },
                                                                    kind: 'init',
                                                                    order: '2'
                                                                },
                                                                {
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'ObjectExpression',
                                                                        objectType: {
                                                                            type: 'CallExpression',
                                                                            callee: {
                                                                                type: 'Identifier',
                                                                                name: 'PaperIconButton',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 259,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 259,
                                                                                        column: 39,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            arguments: [{
                                                                                    type: 'ObjectExpression',
                                                                                    properties: [{
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'class',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 259,
                                                                                                        column: 41,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 259,
                                                                                                        column: 46,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'Literal',
                                                                                                value: 'dropdown-trigger'
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '0'
                                                                                        }]
                                                                                }],
                                                                            loc: {
                                                                                start: {
                                                                                    line: 259,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 259,
                                                                                    column: 67,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        properties: [{
                                                                                type: 'Property',
                                                                                key: {
                                                                                    type: 'Identifier',
                                                                                    name: 'icon',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 260,
                                                                                            column: 28,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 260,
                                                                                            column: 32,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                value: {
                                                                                    type: 'Literal',
                                                                                    value: 'more-vert'
                                                                                },
                                                                                kind: 'init',
                                                                                order: '0'
                                                                            }]
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 259,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 261,
                                                                            column: 28,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    },
                                                                    order: '3'
                                                                },
                                                                {
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'ObjectExpression',
                                                                        objectType: {
                                                                            type: 'CallExpression',
                                                                            callee: {
                                                                                type: 'Identifier',
                                                                                name: 'PaperMenu',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 261,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 261,
                                                                                        column: 33,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            arguments: [{
                                                                                    type: 'ObjectExpression',
                                                                                    properties: [{
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'class',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 261,
                                                                                                        column: 35,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 261,
                                                                                                        column: 40,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'Literal',
                                                                                                value: 'dropdown-content'
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '0'
                                                                                        }]
                                                                                }],
                                                                            loc: {
                                                                                start: {
                                                                                    line: 261,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 261,
                                                                                    column: 61,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        properties: [
                                                                            {
                                                                                type: 'ExpressionStatement',
                                                                                expression: {
                                                                                    type: 'ObjectExpression',
                                                                                    objectType: {
                                                                                        type: 'CallExpression',
                                                                                        callee: {
                                                                                            type: 'Identifier',
                                                                                            name: 'PaperIconItem',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 262,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 262,
                                                                                                    column: 41,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        arguments: [],
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 262,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 262,
                                                                                                column: 43,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    properties: [
                                                                                        {
                                                                                            type: 'ExpressionStatement',
                                                                                            expression: {
                                                                                                type: 'ObjectExpression',
                                                                                                objectType: {
                                                                                                    type: 'CallExpression',
                                                                                                    callee: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'IronIcon',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 263,
                                                                                                                column: 32,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 263,
                                                                                                                column: 40,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    arguments: [{
                                                                                                            type: 'ObjectExpression',
                                                                                                            properties: [{
                                                                                                                    type: 'Property',
                                                                                                                    key: {
                                                                                                                        type: 'Literal',
                                                                                                                        value: 'item-icon'
                                                                                                                    },
                                                                                                                    value: {
                                                                                                                        type: 'Literal',
                                                                                                                        value: true
                                                                                                                    },
                                                                                                                    kind: 'init',
                                                                                                                    order: '0'
                                                                                                                }]
                                                                                                        }],
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 263,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 263,
                                                                                                            column: 60,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                properties: [{
                                                                                                        type: 'Property',
                                                                                                        key: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'icon',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 264,
                                                                                                                    column: 36,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 264,
                                                                                                                    column: 40,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        value: {
                                                                                                            type: 'Literal',
                                                                                                            value: 'image:edit'
                                                                                                        },
                                                                                                        kind: 'init',
                                                                                                        order: '0'
                                                                                                    }]
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 263,
                                                                                                    column: 32,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 265,
                                                                                                    column: 36,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                }
                                                                                            },
                                                                                            order: '0'
                                                                                        },
                                                                                        {
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'style',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 265,
                                                                                                        column: 32,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 265,
                                                                                                        column: 37,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'ObjectExpression',
                                                                                                properties: [{
                                                                                                        type: 'Property',
                                                                                                        key: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'whiteSpace',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 266,
                                                                                                                    column: 36,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 266,
                                                                                                                    column: 46,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        value: {
                                                                                                            type: 'Literal',
                                                                                                            value: 'nowrap'
                                                                                                        },
                                                                                                        kind: 'init',
                                                                                                        order: '0'
                                                                                                    }]
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '1'
                                                                                        },
                                                                                        {
                                                                                            type: 'ExpressionStatement',
                                                                                            expression: {
                                                                                                type: 'Function',
                                                                                                context: true,
                                                                                                value: function (_context27) {
                                                                                                    return function click(e) {
                                                                                                        var PromptDialog = _context27.get('PromptDialog'), project = _context27.get('project');
                                                                                                        PromptDialog.show({
                                                                                                            title: 'New Name',
                                                                                                            properties: [{ name: 'name' }],
                                                                                                            values: { name: project.name },
                                                                                                            callback: function (values) {
                                                                                                                var newname = values.name;
                                                                                                                if (newname != null) {
                                                                                                                    newname = newname.trim();
                                                                                                                    if (newname.length > 0) {
                                                                                                                        global.model.ops.begin();
                                                                                                                        project.name = newname;
                                                                                                                    }
                                                                                                                }
                                                                                                            }
                                                                                                        });
                                                                                                    };
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 267,
                                                                                                    column: 32,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 280,
                                                                                                    column: 36,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                }
                                                                                            },
                                                                                            order: '2'
                                                                                        },
                                                                                        {
                                                                                            type: 'ExpressionStatement',
                                                                                            expression: {
                                                                                                type: 'ObjectExpression',
                                                                                                objectType: {
                                                                                                    type: 'CallExpression',
                                                                                                    callee: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'Span',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 280,
                                                                                                                column: 32,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 280,
                                                                                                                column: 36,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    arguments: [],
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 280,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 280,
                                                                                                            column: 38,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                properties: [{
                                                                                                        type: 'ExpressionStatement',
                                                                                                        expression: {
                                                                                                            type: 'BinaryExpression',
                                                                                                            operator: '+',
                                                                                                            left: {
                                                                                                                type: 'Literal',
                                                                                                                value: 'Rename this '
                                                                                                            },
                                                                                                            right: {
                                                                                                                type: 'MemberExpression',
                                                                                                                computed: false,
                                                                                                                object: {
                                                                                                                    type: 'MemberExpression',
                                                                                                                    computed: false,
                                                                                                                    object: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'project',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 281,
                                                                                                                                column: 51,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 281,
                                                                                                                                column: 58,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    property: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'Type',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 281,
                                                                                                                                column: 59,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 281,
                                                                                                                                column: 63,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 281,
                                                                                                                            column: 51,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 281,
                                                                                                                            column: 63,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                property: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'name',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 281,
                                                                                                                            column: 64,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 281,
                                                                                                                            column: 68,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 281,
                                                                                                                        column: 51,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 281,
                                                                                                                        column: 68,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 281,
                                                                                                                column: 36,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 281,
                                                                                                                column: 71,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                            }
                                                                                                        },
                                                                                                        order: '0'
                                                                                                    }]
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 280,
                                                                                                    column: 32,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 282,
                                                                                                    column: 36,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                }
                                                                                            },
                                                                                            order: '3'
                                                                                        }
                                                                                    ]
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 262,
                                                                                        column: 28,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 282,
                                                                                        column: 32,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                },
                                                                                order: '0'
                                                                            },
                                                                            {
                                                                                type: 'ExpressionStatement',
                                                                                expression: {
                                                                                    type: 'ObjectExpression',
                                                                                    objectType: {
                                                                                        type: 'CallExpression',
                                                                                        callee: {
                                                                                            type: 'Identifier',
                                                                                            name: 'PaperIconItem',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 282,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 282,
                                                                                                    column: 41,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        arguments: [],
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 282,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 282,
                                                                                                column: 43,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    properties: [
                                                                                        {
                                                                                            type: 'ExpressionStatement',
                                                                                            expression: {
                                                                                                type: 'ObjectExpression',
                                                                                                objectType: {
                                                                                                    type: 'CallExpression',
                                                                                                    callee: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'IronIcon',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 283,
                                                                                                                column: 32,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 283,
                                                                                                                column: 40,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    arguments: [{
                                                                                                            type: 'ObjectExpression',
                                                                                                            properties: [{
                                                                                                                    type: 'Property',
                                                                                                                    key: {
                                                                                                                        type: 'Literal',
                                                                                                                        value: 'item-icon'
                                                                                                                    },
                                                                                                                    value: {
                                                                                                                        type: 'Literal',
                                                                                                                        value: true
                                                                                                                    },
                                                                                                                    kind: 'init',
                                                                                                                    order: '0'
                                                                                                                }]
                                                                                                        }],
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 283,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 283,
                                                                                                            column: 60,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                properties: [{
                                                                                                        type: 'Property',
                                                                                                        key: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'icon',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 284,
                                                                                                                    column: 36,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 284,
                                                                                                                    column: 40,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        value: {
                                                                                                            type: 'Literal',
                                                                                                            value: 'content-copy'
                                                                                                        },
                                                                                                        kind: 'init',
                                                                                                        order: '0'
                                                                                                    }]
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 283,
                                                                                                    column: 32,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 285,
                                                                                                    column: 36,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                }
                                                                                            },
                                                                                            order: '0'
                                                                                        },
                                                                                        {
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'style',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 285,
                                                                                                        column: 32,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 285,
                                                                                                        column: 37,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'ObjectExpression',
                                                                                                properties: [{
                                                                                                        type: 'Property',
                                                                                                        key: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'whiteSpace',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 286,
                                                                                                                    column: 36,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 286,
                                                                                                                    column: 46,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        value: {
                                                                                                            type: 'Literal',
                                                                                                            value: 'nowrap'
                                                                                                        },
                                                                                                        kind: 'init',
                                                                                                        order: '0'
                                                                                                    }]
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '1'
                                                                                        },
                                                                                        {
                                                                                            type: 'ExpressionStatement',
                                                                                            expression: {
                                                                                                type: 'Function',
                                                                                                context: true,
                                                                                                value: function (_context28) {
                                                                                                    return function click(e) {
                                                                                                        var clone = _context28.get('clone');
                                                                                                        clone();
                                                                                                    };
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 287,
                                                                                                    column: 32,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 289,
                                                                                                    column: 36,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                }
                                                                                            },
                                                                                            order: '2'
                                                                                        },
                                                                                        {
                                                                                            type: 'ExpressionStatement',
                                                                                            expression: {
                                                                                                type: 'ObjectExpression',
                                                                                                objectType: {
                                                                                                    type: 'CallExpression',
                                                                                                    callee: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'Span',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 289,
                                                                                                                column: 32,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 289,
                                                                                                                column: 36,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    arguments: [],
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 289,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 289,
                                                                                                            column: 38,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                properties: [{
                                                                                                        type: 'ExpressionStatement',
                                                                                                        expression: {
                                                                                                            type: 'BinaryExpression',
                                                                                                            operator: '+',
                                                                                                            left: {
                                                                                                                type: 'Literal',
                                                                                                                value: 'Clone this '
                                                                                                            },
                                                                                                            right: {
                                                                                                                type: 'MemberExpression',
                                                                                                                computed: false,
                                                                                                                object: {
                                                                                                                    type: 'MemberExpression',
                                                                                                                    computed: false,
                                                                                                                    object: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'project',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 290,
                                                                                                                                column: 50,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 290,
                                                                                                                                column: 57,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    property: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'Type',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 290,
                                                                                                                                column: 58,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 290,
                                                                                                                                column: 62,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 290,
                                                                                                                            column: 50,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 290,
                                                                                                                            column: 62,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                property: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'name',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 290,
                                                                                                                            column: 63,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 290,
                                                                                                                            column: 67,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 290,
                                                                                                                        column: 50,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 290,
                                                                                                                        column: 67,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 290,
                                                                                                                column: 36,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 290,
                                                                                                                column: 70,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                            }
                                                                                                        },
                                                                                                        order: '0'
                                                                                                    }]
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 289,
                                                                                                    column: 32,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 291,
                                                                                                    column: 36,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                }
                                                                                            },
                                                                                            order: '3'
                                                                                        }
                                                                                    ]
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 282,
                                                                                        column: 28,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 291,
                                                                                        column: 32,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                },
                                                                                order: '1'
                                                                            },
                                                                            {
                                                                                type: 'ExpressionStatement',
                                                                                expression: {
                                                                                    type: 'ObjectExpression',
                                                                                    objectType: {
                                                                                        type: 'CallExpression',
                                                                                        callee: {
                                                                                            type: 'Identifier',
                                                                                            name: 'PaperIconItem',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 291,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 291,
                                                                                                    column: 41,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        arguments: [],
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 291,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 291,
                                                                                                column: 43,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    properties: [
                                                                                        {
                                                                                            type: 'ExpressionStatement',
                                                                                            expression: {
                                                                                                type: 'ObjectExpression',
                                                                                                objectType: {
                                                                                                    type: 'CallExpression',
                                                                                                    callee: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'IronIcon',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 292,
                                                                                                                column: 32,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 292,
                                                                                                                column: 40,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    arguments: [{
                                                                                                            type: 'ObjectExpression',
                                                                                                            properties: [{
                                                                                                                    type: 'Property',
                                                                                                                    key: {
                                                                                                                        type: 'Literal',
                                                                                                                        value: 'item-icon'
                                                                                                                    },
                                                                                                                    value: {
                                                                                                                        type: 'Literal',
                                                                                                                        value: true
                                                                                                                    },
                                                                                                                    kind: 'init',
                                                                                                                    order: '0'
                                                                                                                }]
                                                                                                        }],
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 292,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 292,
                                                                                                            column: 60,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                properties: [{
                                                                                                        type: 'Property',
                                                                                                        key: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'icon',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 293,
                                                                                                                    column: 36,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 293,
                                                                                                                    column: 40,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        value: {
                                                                                                            type: 'Literal',
                                                                                                            value: 'social:people'
                                                                                                        },
                                                                                                        kind: 'init',
                                                                                                        order: '0'
                                                                                                    }]
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 292,
                                                                                                    column: 32,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 294,
                                                                                                    column: 36,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                }
                                                                                            },
                                                                                            order: '0'
                                                                                        },
                                                                                        {
                                                                                            type: 'ExpressionStatement',
                                                                                            expression: {
                                                                                                type: 'Function',
                                                                                                context: true,
                                                                                                value: function (_context29) {
                                                                                                    return function click(e) {
                                                                                                        var projectKey = _context29.get('projectKey');
                                                                                                        model.open({
                                                                                                            id: 'Managers',
                                                                                                            key: projectKey.toString()
                                                                                                        }, { target: 'dialog' });
                                                                                                    };
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 294,
                                                                                                    column: 32,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 296,
                                                                                                    column: 36,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                }
                                                                                            },
                                                                                            order: '1'
                                                                                        },
                                                                                        {
                                                                                            type: 'ExpressionStatement',
                                                                                            expression: {
                                                                                                type: 'Literal',
                                                                                                value: 'Managers'
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 296,
                                                                                                    column: 32,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 296,
                                                                                                    column: 42,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                }
                                                                                            },
                                                                                            order: '2'
                                                                                        }
                                                                                    ]
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 291,
                                                                                        column: 28,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 297,
                                                                                        column: 32,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                },
                                                                                order: '2'
                                                                            }
                                                                        ]
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 261,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 297,
                                                                            column: 28,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    },
                                                                    order: '4'
                                                                }
                                                            ]
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 255,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 297,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        },
                                                        order: '0'
                                                    }]
                                            },
                                            alternate: null,
                                            order: 'E'
                                        },
                                        {
                                            type: 'IfStatement',
                                            test: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'config',
                                                    loc: {
                                                        start: {
                                                            line: 297,
                                                            column: 19,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        },
                                                        end: {
                                                            line: 297,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'embedded',
                                                    loc: {
                                                        start: {
                                                            line: 297,
                                                            column: 26,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        },
                                                        end: {
                                                            line: 297,
                                                            column: 34,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 297,
                                                        column: 19,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                    },
                                                    end: {
                                                        line: 297,
                                                        column: 34,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                    }
                                                }
                                            },
                                            consequent: {
                                                type: 'BlockStatement',
                                                body: [
                                                    {
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'ObjectExpression',
                                                            objectType: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Identifier',
                                                                    name: 'PaperIconButton',
                                                                    loc: {
                                                                        start: {
                                                                            line: 298,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 298,
                                                                            column: 35,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [],
                                                                loc: {
                                                                    start: {
                                                                        line: 298,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 298,
                                                                        column: 37,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            properties: [
                                                                {
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'icon',
                                                                        loc: {
                                                                            start: {
                                                                                line: 299,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 299,
                                                                                column: 28,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Literal',
                                                                        value: 'undo'
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                },
                                                                {
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'title',
                                                                        loc: {
                                                                            start: {
                                                                                line: 300,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 300,
                                                                                column: 29,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Literal',
                                                                        value: 'Undo'
                                                                    },
                                                                    kind: 'init',
                                                                    order: '1'
                                                                },
                                                                {
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'disabled',
                                                                        loc: {
                                                                            start: {
                                                                                line: 301,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 301,
                                                                                column: 32,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'BinaryExpression',
                                                                        operator: '===',
                                                                        left: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'global',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 301,
                                                                                                    column: 34,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 301,
                                                                                                    column: 40,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'model',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 301,
                                                                                                    column: 41,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 301,
                                                                                                    column: 46,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 301,
                                                                                                column: 34,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 301,
                                                                                                column: 46,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'ops',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 301,
                                                                                                column: 47,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 301,
                                                                                                column: 50,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 301,
                                                                                            column: 34,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 301,
                                                                                            column: 50,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'undoStack',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 301,
                                                                                            column: 51,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 301,
                                                                                            column: 60,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 301,
                                                                                        column: 34,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 301,
                                                                                        column: 60,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'length',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 301,
                                                                                        column: 61,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 301,
                                                                                        column: 67,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 301,
                                                                                    column: 34,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 301,
                                                                                    column: 67,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        right: {
                                                                            type: 'Literal',
                                                                            value: 0
                                                                        }
                                                                    },
                                                                    kind: 'init',
                                                                    order: '2'
                                                                },
                                                                {
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'Function',
                                                                        context: false,
                                                                        value: function click(e) {
                                                                            model.ops.undo();
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 302,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 304,
                                                                            column: 28,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    },
                                                                    order: '3'
                                                                }
                                                            ]
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 298,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 304,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        },
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'ObjectExpression',
                                                            objectType: {
                                                                type: 'CallExpression',
                                                                callee: {
                                                                    type: 'Identifier',
                                                                    name: 'PaperIconButton',
                                                                    loc: {
                                                                        start: {
                                                                            line: 304,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 304,
                                                                            column: 35,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                arguments: [],
                                                                loc: {
                                                                    start: {
                                                                        line: 304,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 304,
                                                                        column: 37,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            properties: [
                                                                {
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'icon',
                                                                        loc: {
                                                                            start: {
                                                                                line: 305,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 305,
                                                                                column: 28,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Literal',
                                                                        value: 'redo'
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                },
                                                                {
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'title',
                                                                        loc: {
                                                                            start: {
                                                                                line: 306,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 306,
                                                                                column: 29,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Literal',
                                                                        value: 'Redo'
                                                                    },
                                                                    kind: 'init',
                                                                    order: '1'
                                                                },
                                                                {
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'disabled',
                                                                        loc: {
                                                                            start: {
                                                                                line: 307,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 307,
                                                                                column: 32,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'BinaryExpression',
                                                                        operator: '===',
                                                                        left: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'global',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 307,
                                                                                                    column: 34,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 307,
                                                                                                    column: 40,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'model',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 307,
                                                                                                    column: 41,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 307,
                                                                                                    column: 46,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 307,
                                                                                                column: 34,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 307,
                                                                                                column: 46,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'ops',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 307,
                                                                                                column: 47,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 307,
                                                                                                column: 50,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 307,
                                                                                            column: 34,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 307,
                                                                                            column: 50,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'redoStack',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 307,
                                                                                            column: 51,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 307,
                                                                                            column: 60,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 307,
                                                                                        column: 34,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 307,
                                                                                        column: 60,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'length',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 307,
                                                                                        column: 61,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 307,
                                                                                        column: 67,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 307,
                                                                                    column: 34,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 307,
                                                                                    column: 67,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        right: {
                                                                            type: 'Literal',
                                                                            value: 0
                                                                        }
                                                                    },
                                                                    kind: 'init',
                                                                    order: '2'
                                                                },
                                                                {
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'Function',
                                                                        context: false,
                                                                        value: function click(e) {
                                                                            model.ops.redo();
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 308,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 311,
                                                                            column: 28,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    },
                                                                    order: '3'
                                                                }
                                                            ]
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 304,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 311,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        },
                                                        order: '1'
                                                    }
                                                ]
                                            },
                                            alternate: null,
                                            order: 'F'
                                        }
                                    ]
                                },
                                loc: {
                                    start: {
                                        line: 99,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 311,
                                        column: 16,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                },
                                order: '0'
                            },
                            {
                                type: 'ExpressionStatement',
                                expression: {
                                    type: 'Identifier',
                                    name: 'dataTable',
                                    loc: {
                                        start: {
                                            line: 311,
                                            column: 12,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        },
                                        end: {
                                            line: 311,
                                            column: 21,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 311,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 311,
                                        column: 21,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                },
                                order: '1'
                            }
                        ]
                    },
                    order: '@'
                }
            ],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'ProjectTasksTab',
                loc: {
                    start: {
                        line: 18,
                        column: 4,
                        fixed: true,
                        source: 'viewpath/html/panes/ProjectPane.ion'
                    },
                    end: {
                        line: 18,
                        column: 19,
                        fixed: true,
                        source: 'viewpath/html/panes/ProjectPane.ion'
                    }
                }
            }
        }, {
            this: this,
            require: require,
            ion: ion,
            _ref10: _ref10,
            glass: glass,
            _ref: _ref,
            _ref2: _ref2,
            viewpath: viewpath,
            _ref3: _ref3,
            _ref4: _ref4,
            _ref5: _ref5,
            DataTable: DataTable,
            _ref6: _ref6,
            _ref7: _ref7,
            _ref8: _ref8,
            Key: Key,
            Schema: Schema,
            GlassForm: GlassForm,
            User: User,
            Task: Task,
            Project: Project,
            ProjectType: ProjectType,
            Button: Button,
            Checkbox: Checkbox,
            Dialog: Dialog,
            Field: Field,
            Icon: Icon,
            Toolbar: Toolbar,
            TabContent: TabContent,
            PromptDialog: PromptDialog,
            Renamer: Renamer,
            GenericTypeView: GenericTypeView,
            ManagersPane: ManagersPane,
            UserRowContent: UserRowContent,
            UserOrgTagsProperty: UserOrgTagsProperty,
            SubscriptionNotice: SubscriptionNotice,
            _ref9: _ref9,
            ConfirmDialog: ConfirmDialog,
            ProjectTasksTab: ProjectTasksTab,
            getResourceQuery: getResourceQuery,
            ProjectResourcesTab: ProjectResourcesTab,
            ProjectManagersTab: ProjectManagersTab,
            ProjectSummaryTab: ProjectSummaryTab
        }, null);
    }), getResourceQuery = function (tasks) {
        var set = new Set();
        if (tasks != null) {
            for (var taskKey in tasks) {
                var _ref18 = tasks[taskKey];
                var complete = _ref18.complete;
                var assigned = _ref18.assigned;
                if (assigned != null && !complete) {
                    for (var userKey in assigned) {
                        var email = userKey.split('/').pop();
                        set.add(email);
                    }
                }
            }
        }
        return new Key(User, { where: { email: Array.from(set) } });
    }, ProjectResourcesTab = ion.template(function (_ref11) {
        return ion.createRuntime({
            type: 'Template',
            id: null,
            body: [
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'config',
                                loc: {
                                    start: {
                                        line: 323,
                                        column: 37,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 323,
                                        column: 43,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref11'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'config',
                                    loc: {
                                        start: {
                                            line: 323,
                                            column: 37,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        },
                                        end: {
                                            line: 323,
                                            column: 43,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '0'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'project',
                                loc: {
                                    start: {
                                        line: 323,
                                        column: 45,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 323,
                                        column: 52,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref11'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'project',
                                    loc: {
                                        start: {
                                            line: 323,
                                            column: 45,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        },
                                        end: {
                                            line: 323,
                                            column: 52,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '1'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'projectKey',
                                loc: {
                                    start: {
                                        line: 323,
                                        column: 54,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 323,
                                        column: 64,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref11'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'projectKey',
                                    loc: {
                                        start: {
                                            line: 323,
                                            column: 54,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        },
                                        end: {
                                            line: 323,
                                            column: 64,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '2'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'projectTasksKey',
                                loc: {
                                    start: {
                                        line: 323,
                                        column: 66,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 323,
                                        column: 81,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref11'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'projectTasksKey',
                                    loc: {
                                        start: {
                                            line: 323,
                                            column: 66,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        },
                                        end: {
                                            line: 323,
                                            column: 81,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '3'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'tasks',
                                loc: {
                                    start: {
                                        line: 324,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 324,
                                        column: 17,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                computed: true,
                                object: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'model',
                                        loc: {
                                            start: {
                                                line: 324,
                                                column: 20,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            },
                                            end: {
                                                line: 324,
                                                column: 25,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'server',
                                        loc: {
                                            start: {
                                                line: 324,
                                                column: 26,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            },
                                            end: {
                                                line: 324,
                                                column: 32,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 324,
                                            column: 20,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        },
                                        end: {
                                            line: 324,
                                            column: 32,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'projectTasksKey',
                                    loc: {
                                        start: {
                                            line: 324,
                                            column: 33,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        },
                                        end: {
                                            line: 324,
                                            column: 48,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 324,
                                        column: 20,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 324,
                                        column: 49,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '4'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'org',
                                loc: {
                                    start: {
                                        line: 325,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 325,
                                        column: 15,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                computed: true,
                                object: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'model',
                                        loc: {
                                            start: {
                                                line: 325,
                                                column: 18,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            },
                                            end: {
                                                line: 325,
                                                column: 23,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'orgs',
                                        loc: {
                                            start: {
                                                line: 325,
                                                column: 24,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            },
                                            end: {
                                                line: 325,
                                                column: 28,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 325,
                                            column: 18,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        },
                                        end: {
                                            line: 325,
                                            column: 28,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'project',
                                        loc: {
                                            start: {
                                                line: 325,
                                                column: 29,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            },
                                            end: {
                                                line: 325,
                                                column: 36,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'orgKey',
                                        loc: {
                                            start: {
                                                line: 325,
                                                column: 37,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            },
                                            end: {
                                                line: 325,
                                                column: 43,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 325,
                                            column: 29,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        },
                                        end: {
                                            line: 325,
                                            column: 43,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 325,
                                        column: 18,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 325,
                                        column: 44,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '5'
                },
                {
                    type: 'IfStatement',
                    test: {
                        type: 'UnaryExpression',
                        operator: '?',
                        argument: {
                            type: 'Identifier',
                            name: 'tasks',
                            loc: {
                                start: {
                                    line: 326,
                                    column: 11,
                                    fixed: true,
                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                },
                                end: {
                                    line: 326,
                                    column: 16,
                                    fixed: true,
                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                }
                            }
                        }
                    },
                    consequent: {
                        type: 'BlockStatement',
                        body: [
                            {
                                type: 'VariableDeclaration',
                                declarations: [{
                                        type: 'VariableDeclarator',
                                        id: {
                                            type: 'Identifier',
                                            name: 'resourceKey',
                                            loc: {
                                                start: {
                                                    line: 327,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                },
                                                end: {
                                                    line: 327,
                                                    column: 27,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                }
                                            }
                                        },
                                        init: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'Identifier',
                                                name: 'getResourceQuery',
                                                loc: {
                                                    start: {
                                                        line: 327,
                                                        column: 30,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                    },
                                                    end: {
                                                        line: 327,
                                                        column: 46,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                    }
                                                }
                                            },
                                            arguments: [{
                                                    type: 'Identifier',
                                                    name: 'tasks',
                                                    loc: {
                                                        start: {
                                                            line: 327,
                                                            column: 47,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        },
                                                        end: {
                                                            line: 327,
                                                            column: 52,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        }
                                                    }
                                                }],
                                            loc: {
                                                start: {
                                                    line: 327,
                                                    column: 30,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                },
                                                end: {
                                                    line: 327,
                                                    column: 53,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                }
                                            }
                                        }
                                    }],
                                kind: 'let',
                                order: '0'
                            },
                            {
                                type: 'VariableDeclaration',
                                declarations: [{
                                        type: 'VariableDeclarator',
                                        id: {
                                            type: 'Identifier',
                                            name: 'viewConfig',
                                            loc: {
                                                start: {
                                                    line: 330,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                },
                                                end: {
                                                    line: 330,
                                                    column: 26,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                }
                                            }
                                        },
                                        init: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'Function',
                                                context: true,
                                                value: function (_context30) {
                                                    return function () {
                                                        var User = _context30.get('User'), org = _context30.get('org'), UserOrgTagsProperty = _context30.get('UserOrgTagsProperty'), resourceKey = _context30.get('resourceKey'), project = _context30.get('project');
                                                        var _ref17 = {};
                                                        {
                                                            {
                                                                var _ref16 = User.properties;
                                                                for (var key in _ref16) {
                                                                    var value = _ref16[key];
                                                                    _ref17[key] = value;
                                                                }
                                                            }
                                                            if (org != null) {
                                                                _ref17.tags = UserOrgTagsProperty(org);
                                                            }
                                                        }
                                                        return {
                                                            id: 'resources',
                                                            key: resourceKey,
                                                            properties: _ref17,
                                                            columns: [
                                                                'name',
                                                                'email',
                                                                'tags'
                                                            ],
                                                            project: project,
                                                            create: false,
                                                            delete: false,
                                                            sorts: [[{ name: true }]],
                                                            timeline: {
                                                                columns: [
                                                                    'name',
                                                                    'tags'
                                                                ]
                                                            }
                                                        };
                                                    };
                                                }
                                            },
                                            arguments: [],
                                            loc: {
                                                start: {
                                                    line: 330,
                                                    column: 29,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                },
                                                end: {
                                                    line: 347,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                }
                                            }
                                        }
                                    }],
                                kind: 'let',
                                order: '1'
                            },
                            {
                                type: 'ReturnStatement',
                                argument: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'Identifier',
                                        name: 'GenericTypeView',
                                        loc: {
                                            start: {
                                                line: 347,
                                                column: 19,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            },
                                            end: {
                                                line: 347,
                                                column: 34,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            }
                                        }
                                    },
                                    arguments: [{
                                            type: 'Identifier',
                                            name: 'viewConfig',
                                            loc: {
                                                start: {
                                                    line: 347,
                                                    column: 35,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                },
                                                end: {
                                                    line: 347,
                                                    column: 45,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                }
                                            }
                                        }],
                                    loc: {
                                        start: {
                                            line: 347,
                                            column: 19,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        },
                                        end: {
                                            line: 347,
                                            column: 46,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        }
                                    }
                                },
                                order: '2'
                            }
                        ]
                    },
                    alternate: null,
                    order: '6'
                }
            ],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'ProjectResourcesTab',
                loc: {
                    start: {
                        line: 323,
                        column: 4,
                        fixed: true,
                        source: 'viewpath/html/panes/ProjectPane.ion'
                    },
                    end: {
                        line: 323,
                        column: 23,
                        fixed: true,
                        source: 'viewpath/html/panes/ProjectPane.ion'
                    }
                }
            }
        }, {
            this: this,
            _ref11: _ref11,
            ion: ion,
            glass: glass,
            _ref: _ref,
            _ref2: _ref2,
            viewpath: viewpath,
            _ref3: _ref3,
            _ref4: _ref4,
            _ref5: _ref5,
            DataTable: DataTable,
            _ref6: _ref6,
            _ref7: _ref7,
            _ref8: _ref8,
            Key: Key,
            Schema: Schema,
            GlassForm: GlassForm,
            User: User,
            Task: Task,
            Project: Project,
            ProjectType: ProjectType,
            Button: Button,
            Checkbox: Checkbox,
            Dialog: Dialog,
            Field: Field,
            Icon: Icon,
            Toolbar: Toolbar,
            TabContent: TabContent,
            PromptDialog: PromptDialog,
            Renamer: Renamer,
            GenericTypeView: GenericTypeView,
            ManagersPane: ManagersPane,
            UserRowContent: UserRowContent,
            UserOrgTagsProperty: UserOrgTagsProperty,
            SubscriptionNotice: SubscriptionNotice,
            _ref9: _ref9,
            ConfirmDialog: ConfirmDialog,
            ProjectTasksTab: ProjectTasksTab,
            getResourceQuery: getResourceQuery,
            ProjectResourcesTab: ProjectResourcesTab,
            ProjectManagersTab: ProjectManagersTab,
            ProjectSummaryTab: ProjectSummaryTab
        }, null);
    }), ProjectManagersTab = ion.template(function (_ref12) {
        return ion.createRuntime({
            type: 'Template',
            id: null,
            body: [
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'config',
                                loc: {
                                    start: {
                                        line: 349,
                                        column: 36,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 349,
                                        column: 42,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref12'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'config',
                                    loc: {
                                        start: {
                                            line: 349,
                                            column: 36,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        },
                                        end: {
                                            line: 349,
                                            column: 42,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '0'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'project',
                                loc: {
                                    start: {
                                        line: 349,
                                        column: 44,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 349,
                                        column: 51,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref12'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'project',
                                    loc: {
                                        start: {
                                            line: 349,
                                            column: 44,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        },
                                        end: {
                                            line: 349,
                                            column: 51,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '1'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'projectKey',
                                loc: {
                                    start: {
                                        line: 349,
                                        column: 53,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 349,
                                        column: 63,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref12'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'projectKey',
                                    loc: {
                                        start: {
                                            line: 349,
                                            column: 53,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        },
                                        end: {
                                            line: 349,
                                            column: 63,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '2'
                },
                {
                    type: 'ReturnStatement',
                    argument: {
                        type: 'CallExpression',
                        callee: {
                            type: 'Identifier',
                            name: 'ManagersPane',
                            loc: {
                                start: {
                                    line: 350,
                                    column: 19,
                                    fixed: true,
                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                },
                                end: {
                                    line: 350,
                                    column: 31,
                                    fixed: true,
                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                }
                            }
                        },
                        arguments: [
                            {
                                type: 'Identifier',
                                name: 'config',
                                loc: {
                                    start: {
                                        line: 351,
                                        column: 16,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 351,
                                        column: 22,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            },
                            {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'ObjectExpression',
                                    properties: []
                                },
                                properties: [
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'columns',
                                            loc: {
                                                start: {
                                                    line: 353,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                },
                                                end: {
                                                    line: 353,
                                                    column: 27,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'ArrayExpression',
                                            elements: [
                                                {
                                                    type: 'Literal',
                                                    value: 'email'
                                                },
                                                {
                                                    type: 'Literal',
                                                    value: 'tags'
                                                }
                                            ]
                                        },
                                        kind: 'init',
                                        order: '0'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'timeline',
                                            loc: {
                                                start: {
                                                    line: 354,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                },
                                                end: {
                                                    line: 354,
                                                    column: 28,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'ObjectExpression',
                                            properties: [{
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'columns',
                                                        loc: {
                                                            start: {
                                                                line: 355,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 355,
                                                                column: 31,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'ArrayExpression',
                                                        elements: [
                                                            {
                                                                type: 'Literal',
                                                                value: 'name'
                                                            },
                                                            {
                                                                type: 'Literal',
                                                                value: 'tags'
                                                            }
                                                        ]
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                }]
                                        },
                                        kind: 'init',
                                        order: '1'
                                    }
                                ]
                            }
                        ],
                        loc: {
                            start: {
                                line: 350,
                                column: 19,
                                fixed: true,
                                source: 'viewpath/html/panes/ProjectPane.ion'
                            },
                            end: {
                                line: 356,
                                column: 13,
                                fixed: true,
                                source: 'viewpath/html/panes/ProjectPane.ion'
                            }
                        }
                    },
                    order: '3'
                }
            ],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'ProjectManagersTab',
                loc: {
                    start: {
                        line: 349,
                        column: 4,
                        fixed: true,
                        source: 'viewpath/html/panes/ProjectPane.ion'
                    },
                    end: {
                        line: 349,
                        column: 22,
                        fixed: true,
                        source: 'viewpath/html/panes/ProjectPane.ion'
                    }
                }
            }
        }, {
            this: this,
            _ref12: _ref12,
            ion: ion,
            glass: glass,
            _ref: _ref,
            _ref2: _ref2,
            viewpath: viewpath,
            _ref3: _ref3,
            _ref4: _ref4,
            _ref5: _ref5,
            DataTable: DataTable,
            _ref6: _ref6,
            _ref7: _ref7,
            _ref8: _ref8,
            Key: Key,
            Schema: Schema,
            GlassForm: GlassForm,
            User: User,
            Task: Task,
            Project: Project,
            ProjectType: ProjectType,
            Button: Button,
            Checkbox: Checkbox,
            Dialog: Dialog,
            Field: Field,
            Icon: Icon,
            Toolbar: Toolbar,
            TabContent: TabContent,
            PromptDialog: PromptDialog,
            Renamer: Renamer,
            GenericTypeView: GenericTypeView,
            ManagersPane: ManagersPane,
            UserRowContent: UserRowContent,
            UserOrgTagsProperty: UserOrgTagsProperty,
            SubscriptionNotice: SubscriptionNotice,
            _ref9: _ref9,
            ConfirmDialog: ConfirmDialog,
            ProjectTasksTab: ProjectTasksTab,
            getResourceQuery: getResourceQuery,
            ProjectResourcesTab: ProjectResourcesTab,
            ProjectManagersTab: ProjectManagersTab,
            ProjectSummaryTab: ProjectSummaryTab
        }, null);
    }), ProjectSummaryTab = ion.template(function (_ref13) {
        return ion.createRuntime({
            type: 'Template',
            id: null,
            body: [
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'config',
                                loc: {
                                    start: {
                                        line: 358,
                                        column: 35,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 358,
                                        column: 41,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref13'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'config',
                                    loc: {
                                        start: {
                                            line: 358,
                                            column: 35,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        },
                                        end: {
                                            line: 358,
                                            column: 41,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '0'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'project',
                                loc: {
                                    start: {
                                        line: 358,
                                        column: 43,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 358,
                                        column: 50,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref13'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'project',
                                    loc: {
                                        start: {
                                            line: 358,
                                            column: 43,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        },
                                        end: {
                                            line: 358,
                                            column: 50,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '1'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'projectKey',
                                loc: {
                                    start: {
                                        line: 358,
                                        column: 52,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 358,
                                        column: 62,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref13'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'projectKey',
                                    loc: {
                                        start: {
                                            line: 358,
                                            column: 52,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        },
                                        end: {
                                            line: 358,
                                            column: 62,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '2'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'projectTasksKey',
                                loc: {
                                    start: {
                                        line: 358,
                                        column: 64,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 358,
                                        column: 79,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref13'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'projectTasksKey',
                                    loc: {
                                        start: {
                                            line: 358,
                                            column: 64,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        },
                                        end: {
                                            line: 358,
                                            column: 79,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '3'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'tasks',
                                loc: {
                                    start: {
                                        line: 359,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 359,
                                        column: 17,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                computed: true,
                                object: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'model',
                                        loc: {
                                            start: {
                                                line: 359,
                                                column: 20,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            },
                                            end: {
                                                line: 359,
                                                column: 25,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'server',
                                        loc: {
                                            start: {
                                                line: 359,
                                                column: 26,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            },
                                            end: {
                                                line: 359,
                                                column: 32,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 359,
                                            column: 20,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        },
                                        end: {
                                            line: 359,
                                            column: 32,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'projectTasksKey',
                                    loc: {
                                        start: {
                                            line: 359,
                                            column: 33,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        },
                                        end: {
                                            line: 359,
                                            column: 48,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 359,
                                        column: 20,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 359,
                                        column: 49,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '4'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'terminalTasks',
                                loc: {
                                    start: {
                                        line: 360,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 360,
                                        column: 25,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'ArrayExpression',
                                    elements: []
                                },
                                properties: [{
                                        type: 'IfStatement',
                                        test: {
                                            type: 'UnaryExpression',
                                            operator: '?',
                                            argument: {
                                                type: 'Identifier',
                                                name: 'tasks',
                                                loc: {
                                                    start: {
                                                        line: 361,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                    },
                                                    end: {
                                                        line: 361,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                    }
                                                }
                                            }
                                        },
                                        consequent: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'ForInStatement',
                                                    left: {
                                                        type: 'VariableDeclaration',
                                                        declarations: [
                                                            {
                                                                type: 'VariableDeclarator',
                                                                id: {
                                                                    type: 'Identifier',
                                                                    name: 'name',
                                                                    loc: {
                                                                        start: {
                                                                            line: 362,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 362,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                init: null
                                                            },
                                                            {
                                                                type: 'VariableDeclarator',
                                                                id: {
                                                                    type: 'Identifier',
                                                                    name: 'task',
                                                                    loc: {
                                                                        start: {
                                                                            line: 362,
                                                                            column: 26,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 362,
                                                                            column: 30,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                init: null
                                                            }
                                                        ],
                                                        kind: 'let'
                                                    },
                                                    right: {
                                                        type: 'Identifier',
                                                        name: 'tasks',
                                                        loc: {
                                                            start: {
                                                                line: 362,
                                                                column: 34,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 362,
                                                                column: 39,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        }
                                                    },
                                                    body: {
                                                        type: 'BlockStatement',
                                                        body: [{
                                                                type: 'IfStatement',
                                                                test: {
                                                                    type: 'UnaryExpression',
                                                                    operator: '!',
                                                                    argument: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'task',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 363,
                                                                                    column: 27,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 363,
                                                                                    column: 31,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'hasChildren',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 363,
                                                                                    column: 32,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 363,
                                                                                    column: 43,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 363,
                                                                                column: 27,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 363,
                                                                                column: 43,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            }
                                                                        }
                                                                    }
                                                                },
                                                                consequent: {
                                                                    type: 'BlockStatement',
                                                                    body: [{
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'Identifier',
                                                                                name: 'task',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 364,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 364,
                                                                                        column: 28,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 364,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 364,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                alternate: null,
                                                                order: '0'
                                                            }]
                                                    },
                                                    remove: null,
                                                    order: '0'
                                                }]
                                        },
                                        alternate: null,
                                        order: '0'
                                    }]
                            }
                        }],
                    kind: 'let',
                    order: '5'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'completeTasks',
                                loc: {
                                    start: {
                                        line: 365,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 365,
                                        column: 25,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'ArrayExpression',
                                    elements: []
                                },
                                properties: [{
                                        type: 'IfStatement',
                                        test: {
                                            type: 'UnaryExpression',
                                            operator: '?',
                                            argument: {
                                                type: 'Identifier',
                                                name: 'tasks',
                                                loc: {
                                                    start: {
                                                        line: 366,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                    },
                                                    end: {
                                                        line: 366,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                    }
                                                }
                                            }
                                        },
                                        consequent: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'ForInStatement',
                                                    left: {
                                                        type: 'VariableDeclaration',
                                                        declarations: [
                                                            {
                                                                type: 'VariableDeclarator',
                                                                id: {
                                                                    type: 'Identifier',
                                                                    name: 'name',
                                                                    loc: {
                                                                        start: {
                                                                            line: 367,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 367,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                init: null
                                                            },
                                                            {
                                                                type: 'VariableDeclarator',
                                                                id: {
                                                                    type: 'Identifier',
                                                                    name: 'task',
                                                                    loc: {
                                                                        start: {
                                                                            line: 367,
                                                                            column: 26,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 367,
                                                                            column: 30,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                init: null
                                                            }
                                                        ],
                                                        kind: 'let'
                                                    },
                                                    right: {
                                                        type: 'Identifier',
                                                        name: 'tasks',
                                                        loc: {
                                                            start: {
                                                                line: 367,
                                                                column: 34,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 367,
                                                                column: 39,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        }
                                                    },
                                                    body: {
                                                        type: 'BlockStatement',
                                                        body: [{
                                                                type: 'IfStatement',
                                                                test: {
                                                                    type: 'BinaryExpression',
                                                                    operator: '&&',
                                                                    left: {
                                                                        type: 'UnaryExpression',
                                                                        operator: '!',
                                                                        argument: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'task',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 368,
                                                                                        column: 27,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 368,
                                                                                        column: 31,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'hasChildren',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 368,
                                                                                        column: 32,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 368,
                                                                                        column: 43,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 368,
                                                                                    column: 27,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 368,
                                                                                    column: 43,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            }
                                                                        }
                                                                    },
                                                                    right: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'task',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 368,
                                                                                    column: 48,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 368,
                                                                                    column: 52,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'complete',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 368,
                                                                                    column: 53,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 368,
                                                                                    column: 61,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 368,
                                                                                column: 48,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 368,
                                                                                column: 61,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            }
                                                                        }
                                                                    }
                                                                },
                                                                consequent: {
                                                                    type: 'BlockStatement',
                                                                    body: [{
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'Identifier',
                                                                                name: 'task',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 369,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 369,
                                                                                        column: 28,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 369,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 369,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                alternate: null,
                                                                order: '0'
                                                            }]
                                                    },
                                                    remove: null,
                                                    order: '0'
                                                }]
                                        },
                                        alternate: null,
                                        order: '0'
                                    }]
                            }
                        }],
                    kind: 'let',
                    order: '6'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'total',
                                loc: {
                                    start: {
                                        line: 370,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 370,
                                        column: 17,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'ConditionalExpression',
                                test: {
                                    type: 'BinaryExpression',
                                    operator: '!=',
                                    left: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'terminalTasks',
                                            loc: {
                                                start: {
                                                    line: 370,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                },
                                                end: {
                                                    line: 370,
                                                    column: 33,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'length',
                                            loc: {
                                                start: {
                                                    line: 370,
                                                    column: 34,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                },
                                                end: {
                                                    line: 370,
                                                    column: 40,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 370,
                                                column: 20,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            },
                                            end: {
                                                line: 370,
                                                column: 40,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            }
                                        }
                                    },
                                    right: {
                                        type: 'Literal',
                                        value: null
                                    }
                                },
                                consequent: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'terminalTasks',
                                        loc: {
                                            start: {
                                                line: 370,
                                                column: 20,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            },
                                            end: {
                                                line: 370,
                                                column: 33,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'length',
                                        loc: {
                                            start: {
                                                line: 370,
                                                column: 34,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            },
                                            end: {
                                                line: 370,
                                                column: 40,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 370,
                                            column: 20,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        },
                                        end: {
                                            line: 370,
                                            column: 40,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        }
                                    }
                                },
                                alternate: {
                                    type: 'UnaryExpression',
                                    operator: '-',
                                    argument: {
                                        type: 'Literal',
                                        value: 1
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '7'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'complete',
                                loc: {
                                    start: {
                                        line: 371,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 371,
                                        column: 20,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'ConditionalExpression',
                                test: {
                                    type: 'BinaryExpression',
                                    operator: '!=',
                                    left: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'completeTasks',
                                            loc: {
                                                start: {
                                                    line: 371,
                                                    column: 23,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                },
                                                end: {
                                                    line: 371,
                                                    column: 36,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'length',
                                            loc: {
                                                start: {
                                                    line: 371,
                                                    column: 37,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                },
                                                end: {
                                                    line: 371,
                                                    column: 43,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 371,
                                                column: 23,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            },
                                            end: {
                                                line: 371,
                                                column: 43,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            }
                                        }
                                    },
                                    right: {
                                        type: 'Literal',
                                        value: null
                                    }
                                },
                                consequent: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'completeTasks',
                                        loc: {
                                            start: {
                                                line: 371,
                                                column: 23,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            },
                                            end: {
                                                line: 371,
                                                column: 36,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'length',
                                        loc: {
                                            start: {
                                                line: 371,
                                                column: 37,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            },
                                            end: {
                                                line: 371,
                                                column: 43,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 371,
                                            column: 23,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        },
                                        end: {
                                            line: 371,
                                            column: 43,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        }
                                    }
                                },
                                alternate: {
                                    type: 'UnaryExpression',
                                    operator: '-',
                                    argument: {
                                        type: 'Literal',
                                        value: 1
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '8'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'org',
                                loc: {
                                    start: {
                                        line: 372,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 372,
                                        column: 15,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                computed: true,
                                object: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'model',
                                        loc: {
                                            start: {
                                                line: 372,
                                                column: 18,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            },
                                            end: {
                                                line: 372,
                                                column: 23,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'orgs',
                                        loc: {
                                            start: {
                                                line: 372,
                                                column: 24,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            },
                                            end: {
                                                line: 372,
                                                column: 28,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 372,
                                            column: 18,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        },
                                        end: {
                                            line: 372,
                                            column: 28,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'project',
                                        loc: {
                                            start: {
                                                line: 372,
                                                column: 29,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            },
                                            end: {
                                                line: 372,
                                                column: 36,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'orgKey',
                                        loc: {
                                            start: {
                                                line: 372,
                                                column: 37,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            },
                                            end: {
                                                line: 372,
                                                column: 43,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 372,
                                            column: 29,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        },
                                        end: {
                                            line: 372,
                                            column: 43,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 372,
                                        column: 18,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 372,
                                        column: 44,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '9'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'projectTypeName',
                                loc: {
                                    start: {
                                        line: 373,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 373,
                                        column: 27,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'project',
                                        loc: {
                                            start: {
                                                line: 373,
                                                column: 30,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            },
                                            end: {
                                                line: 373,
                                                column: 37,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'Type',
                                        loc: {
                                            start: {
                                                line: 373,
                                                column: 38,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            },
                                            end: {
                                                line: 373,
                                                column: 42,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 373,
                                            column: 30,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        },
                                        end: {
                                            line: 373,
                                            column: 42,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'name',
                                    loc: {
                                        start: {
                                            line: 373,
                                            column: 43,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        },
                                        end: {
                                            line: 373,
                                            column: 47,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 373,
                                        column: 30,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 373,
                                        column: 47,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: ':'
                },
                {
                    type: 'ReturnStatement',
                    argument: {
                        type: 'ObjectExpression',
                        objectType: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Div',
                                loc: {
                                    start: {
                                        line: 374,
                                        column: 15,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 374,
                                        column: 18,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ObjectExpression',
                                    properties: [{
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'class',
                                                loc: {
                                                    start: {
                                                        line: 374,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                    },
                                                    end: {
                                                        line: 374,
                                                        column: 25,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: 'layout vertical'
                                            },
                                            kind: 'init',
                                            order: '0'
                                        }]
                                }],
                            loc: {
                                start: {
                                    line: 374,
                                    column: 15,
                                    fixed: true,
                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                },
                                end: {
                                    line: 374,
                                    column: 45,
                                    fixed: true,
                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                }
                            }
                        },
                        properties: [{
                                type: 'ExpressionStatement',
                                expression: {
                                    type: 'ObjectExpression',
                                    objectType: {
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'Identifier',
                                            name: 'GlassForm',
                                            loc: {
                                                start: {
                                                    line: 375,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                },
                                                end: {
                                                    line: 375,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                }
                                            }
                                        },
                                        arguments: [],
                                        loc: {
                                            start: {
                                                line: 375,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            },
                                            end: {
                                                line: 375,
                                                column: 23,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            }
                                        }
                                    },
                                    properties: [
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'ObjectExpression',
                                                objectType: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'Identifier',
                                                        name: 'Div',
                                                        loc: {
                                                            start: {
                                                                line: 376,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 376,
                                                                column: 19,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [],
                                                    loc: {
                                                        start: {
                                                            line: 376,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        },
                                                        end: {
                                                            line: 376,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        }
                                                    }
                                                },
                                                properties: [{
                                                        type: 'IfStatement',
                                                        test: {
                                                            type: 'BinaryExpression',
                                                            operator: '>=',
                                                            left: {
                                                                type: 'Identifier',
                                                                name: 'total',
                                                                loc: {
                                                                    start: {
                                                                        line: 377,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 377,
                                                                        column: 28,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            right: {
                                                                type: 'Literal',
                                                                value: 0
                                                            }
                                                        },
                                                        consequent: {
                                                            type: 'BlockStatement',
                                                            body: [{
                                                                    type: 'IfStatement',
                                                                    test: {
                                                                        type: 'BinaryExpression',
                                                                        operator: '===',
                                                                        left: {
                                                                            type: 'Identifier',
                                                                            name: 'total',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 378,
                                                                                    column: 27,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 378,
                                                                                    column: 32,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        right: {
                                                                            type: 'Literal',
                                                                            value: 0
                                                                        }
                                                                    },
                                                                    consequent: {
                                                                        type: 'BlockStatement',
                                                                        body: [{
                                                                                type: 'ExpressionStatement',
                                                                                expression: {
                                                                                    type: 'BinaryExpression',
                                                                                    operator: '+',
                                                                                    left: {
                                                                                        type: 'BinaryExpression',
                                                                                        operator: '+',
                                                                                        left: {
                                                                                            type: 'Literal',
                                                                                            value: 'Click on the Tasks tab to add Tasks to this '
                                                                                        },
                                                                                        right: {
                                                                                            type: 'Identifier',
                                                                                            name: 'projectTypeName',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 379,
                                                                                                    column: 75,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 379,
                                                                                                    column: 90,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                }
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    right: {
                                                                                        type: 'Literal',
                                                                                        value: '.'
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 379,
                                                                                        column: 28,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 379,
                                                                                        column: 94,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                },
                                                                                order: '0'
                                                                            }]
                                                                    },
                                                                    alternate: {
                                                                        type: 'IfStatement',
                                                                        test: {
                                                                            type: 'BinaryExpression',
                                                                            operator: '===',
                                                                            left: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'Identifier',
                                                                                    name: 'project',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 380,
                                                                                            column: 32,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 380,
                                                                                            column: 39,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'Type',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 380,
                                                                                            column: 40,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 380,
                                                                                            column: 44,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 380,
                                                                                        column: 32,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 380,
                                                                                        column: 44,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            right: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'Identifier',
                                                                                    name: 'ProjectType',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 380,
                                                                                            column: 48,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 380,
                                                                                            column: 59,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'project',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 380,
                                                                                            column: 60,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 380,
                                                                                            column: 67,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 380,
                                                                                        column: 48,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 380,
                                                                                        column: 67,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                }
                                                                            }
                                                                        },
                                                                        consequent: {
                                                                            type: 'BlockStatement',
                                                                            body: [{
                                                                                    type: 'IfStatement',
                                                                                    test: {
                                                                                        type: 'BinaryExpression',
                                                                                        operator: '===',
                                                                                        left: {
                                                                                            type: 'Identifier',
                                                                                            name: 'complete',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 381,
                                                                                                    column: 31,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 381,
                                                                                                    column: 39,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        right: {
                                                                                            type: 'Literal',
                                                                                            value: 0
                                                                                        }
                                                                                    },
                                                                                    consequent: {
                                                                                        type: 'BlockStatement',
                                                                                        body: [{
                                                                                                type: 'ExpressionStatement',
                                                                                                expression: {
                                                                                                    type: 'BinaryExpression',
                                                                                                    operator: '+',
                                                                                                    left: {
                                                                                                        type: 'BinaryExpression',
                                                                                                        operator: '+',
                                                                                                        left: {
                                                                                                            type: 'Literal',
                                                                                                            value: 'Project not started yet: '
                                                                                                        },
                                                                                                        right: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'total',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 382,
                                                                                                                    column: 60,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 382,
                                                                                                                    column: 65,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    right: {
                                                                                                        type: 'Literal',
                                                                                                        value: ' Tasks created.'
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 382,
                                                                                                        column: 32,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 382,
                                                                                                        column: 83,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                    }
                                                                                                },
                                                                                                order: '0'
                                                                                            }]
                                                                                    },
                                                                                    alternate: {
                                                                                        type: 'IfStatement',
                                                                                        test: {
                                                                                            type: 'BinaryExpression',
                                                                                            operator: '===',
                                                                                            left: {
                                                                                                type: 'Identifier',
                                                                                                name: 'complete',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 383,
                                                                                                        column: 36,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 383,
                                                                                                        column: 44,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            right: {
                                                                                                type: 'Identifier',
                                                                                                name: 'total',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 383,
                                                                                                        column: 48,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 383,
                                                                                                        column: 53,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        consequent: {
                                                                                            type: 'BlockStatement',
                                                                                            body: [{
                                                                                                    type: 'ExpressionStatement',
                                                                                                    expression: {
                                                                                                        type: 'BinaryExpression',
                                                                                                        operator: '+',
                                                                                                        left: {
                                                                                                            type: 'BinaryExpression',
                                                                                                            operator: '+',
                                                                                                            left: {
                                                                                                                type: 'BinaryExpression',
                                                                                                                operator: '+',
                                                                                                                left: {
                                                                                                                    type: 'BinaryExpression',
                                                                                                                    operator: '+',
                                                                                                                    left: {
                                                                                                                        type: 'Literal',
                                                                                                                        value: 'Project finished: '
                                                                                                                    },
                                                                                                                    right: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'complete',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 384,
                                                                                                                                column: 53,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 384,
                                                                                                                                column: 61,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                right: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: ' of '
                                                                                                                }
                                                                                                            },
                                                                                                            right: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'total',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 384,
                                                                                                                        column: 69,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 384,
                                                                                                                        column: 74,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        right: {
                                                                                                            type: 'Literal',
                                                                                                            value: ' Tasks complete.'
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 384,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 384,
                                                                                                            column: 93,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                        }
                                                                                                    },
                                                                                                    order: '0'
                                                                                                }]
                                                                                        },
                                                                                        alternate: {
                                                                                            type: 'BlockStatement',
                                                                                            body: [{
                                                                                                    type: 'ExpressionStatement',
                                                                                                    expression: {
                                                                                                        type: 'BinaryExpression',
                                                                                                        operator: '+',
                                                                                                        left: {
                                                                                                            type: 'BinaryExpression',
                                                                                                            operator: '+',
                                                                                                            left: {
                                                                                                                type: 'BinaryExpression',
                                                                                                                operator: '+',
                                                                                                                left: {
                                                                                                                    type: 'BinaryExpression',
                                                                                                                    operator: '+',
                                                                                                                    left: {
                                                                                                                        type: 'Literal',
                                                                                                                        value: 'Project progress: '
                                                                                                                    },
                                                                                                                    right: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'complete',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 386,
                                                                                                                                column: 53,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 386,
                                                                                                                                column: 61,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                right: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: ' of '
                                                                                                                }
                                                                                                            },
                                                                                                            right: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'total',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 386,
                                                                                                                        column: 69,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 386,
                                                                                                                        column: 74,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        right: {
                                                                                                            type: 'Literal',
                                                                                                            value: ' Tasks complete.'
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 386,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 386,
                                                                                                            column: 93,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                        }
                                                                                                    },
                                                                                                    order: '0'
                                                                                                }]
                                                                                        }
                                                                                    },
                                                                                    order: '0'
                                                                                }]
                                                                        },
                                                                        alternate: null
                                                                    },
                                                                    order: '0'
                                                                }]
                                                        },
                                                        alternate: null,
                                                        order: '0'
                                                    }]
                                            },
                                            loc: {
                                                start: {
                                                    line: 376,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                },
                                                end: {
                                                    line: 388,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                }
                                            },
                                            order: '0'
                                        },
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'Field',
                                                    loc: {
                                                        start: {
                                                            line: 388,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        },
                                                        end: {
                                                            line: 388,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [{
                                                        type: 'ObjectExpression',
                                                        properties: [
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'property',
                                                                    loc: {
                                                                        start: {
                                                                            line: 388,
                                                                            column: 23,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 388,
                                                                            column: 31,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'Project',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 388,
                                                                                    column: 32,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 388,
                                                                                    column: 39,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'properties',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 388,
                                                                                    column: 40,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 388,
                                                                                    column: 50,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 388,
                                                                                column: 32,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 388,
                                                                                column: 50,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'name',
                                                                        loc: {
                                                                            start: {
                                                                                line: 388,
                                                                                column: 51,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 388,
                                                                                column: 55,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 388,
                                                                            column: 32,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 388,
                                                                            column: 55,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'object',
                                                                    loc: {
                                                                        start: {
                                                                            line: 388,
                                                                            column: 57,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 388,
                                                                            column: 63,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Identifier',
                                                                    name: 'project',
                                                                    loc: {
                                                                        start: {
                                                                            line: 388,
                                                                            column: 64,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 388,
                                                                            column: 71,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '1'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'bind',
                                                                    loc: {
                                                                        start: {
                                                                            line: 388,
                                                                            column: 73,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 388,
                                                                            column: 77,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: true
                                                                },
                                                                kind: 'init',
                                                                order: '2'
                                                            }
                                                        ]
                                                    }],
                                                loc: {
                                                    start: {
                                                        line: 388,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                    },
                                                    end: {
                                                        line: 388,
                                                        column: 84,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 388,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                },
                                                end: {
                                                    line: 388,
                                                    column: 84,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                }
                                            },
                                            order: '1'
                                        },
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'Field',
                                                    loc: {
                                                        start: {
                                                            line: 389,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        },
                                                        end: {
                                                            line: 389,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [{
                                                        type: 'ObjectExpression',
                                                        properties: [
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'property',
                                                                    loc: {
                                                                        start: {
                                                                            line: 389,
                                                                            column: 23,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 389,
                                                                            column: 31,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'Project',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 389,
                                                                                    column: 32,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 389,
                                                                                    column: 39,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'properties',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 389,
                                                                                    column: 40,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 389,
                                                                                    column: 50,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 389,
                                                                                column: 32,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 389,
                                                                                column: 50,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'description',
                                                                        loc: {
                                                                            start: {
                                                                                line: 389,
                                                                                column: 51,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 389,
                                                                                column: 62,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 389,
                                                                            column: 32,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 389,
                                                                            column: 62,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'object',
                                                                    loc: {
                                                                        start: {
                                                                            line: 389,
                                                                            column: 64,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 389,
                                                                            column: 70,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Identifier',
                                                                    name: 'project',
                                                                    loc: {
                                                                        start: {
                                                                            line: 389,
                                                                            column: 71,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 389,
                                                                            column: 78,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '1'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'bind',
                                                                    loc: {
                                                                        start: {
                                                                            line: 389,
                                                                            column: 80,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 389,
                                                                            column: 84,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: true
                                                                },
                                                                kind: 'init',
                                                                order: '2'
                                                            }
                                                        ]
                                                    }],
                                                loc: {
                                                    start: {
                                                        line: 389,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                    },
                                                    end: {
                                                        line: 389,
                                                        column: 91,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 389,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                },
                                                end: {
                                                    line: 389,
                                                    column: 91,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                }
                                            },
                                            order: '2'
                                        },
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'Field',
                                                    loc: {
                                                        start: {
                                                            line: 390,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        },
                                                        end: {
                                                            line: 390,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [{
                                                        type: 'ObjectExpression',
                                                        properties: [
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'property',
                                                                    loc: {
                                                                        start: {
                                                                            line: 390,
                                                                            column: 23,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 390,
                                                                            column: 31,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'User',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 390,
                                                                                    column: 32,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 390,
                                                                                    column: 36,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'properties',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 390,
                                                                                    column: 37,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 390,
                                                                                    column: 47,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 390,
                                                                                column: 32,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 390,
                                                                                column: 47,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'timezone',
                                                                        loc: {
                                                                            start: {
                                                                                line: 390,
                                                                                column: 48,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 390,
                                                                                column: 56,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 390,
                                                                            column: 32,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 390,
                                                                            column: 56,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'object',
                                                                    loc: {
                                                                        start: {
                                                                            line: 390,
                                                                            column: 58,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 390,
                                                                            column: 64,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Identifier',
                                                                    name: 'project',
                                                                    loc: {
                                                                        start: {
                                                                            line: 390,
                                                                            column: 65,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 390,
                                                                            column: 72,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '1'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'bind',
                                                                    loc: {
                                                                        start: {
                                                                            line: 390,
                                                                            column: 74,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 390,
                                                                            column: 78,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: true
                                                                },
                                                                kind: 'init',
                                                                order: '2'
                                                            }
                                                        ]
                                                    }],
                                                loc: {
                                                    start: {
                                                        line: 390,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                    },
                                                    end: {
                                                        line: 390,
                                                        column: 85,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 390,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                },
                                                end: {
                                                    line: 390,
                                                    column: 85,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                }
                                            },
                                            order: '3'
                                        },
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'Field',
                                                    loc: {
                                                        start: {
                                                            line: 391,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        },
                                                        end: {
                                                            line: 391,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [{
                                                        type: 'ObjectExpression',
                                                        properties: [
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'property',
                                                                    loc: {
                                                                        start: {
                                                                            line: 391,
                                                                            column: 23,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 391,
                                                                            column: 31,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'Project',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 391,
                                                                                    column: 32,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 391,
                                                                                    column: 39,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'properties',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 391,
                                                                                    column: 40,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 391,
                                                                                    column: 50,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 391,
                                                                                column: 32,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 391,
                                                                                column: 50,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'percent',
                                                                        loc: {
                                                                            start: {
                                                                                line: 391,
                                                                                column: 51,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 391,
                                                                                column: 58,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 391,
                                                                            column: 32,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 391,
                                                                            column: 58,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'object',
                                                                    loc: {
                                                                        start: {
                                                                            line: 391,
                                                                            column: 60,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 391,
                                                                            column: 66,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Identifier',
                                                                    name: 'project',
                                                                    loc: {
                                                                        start: {
                                                                            line: 391,
                                                                            column: 67,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 391,
                                                                            column: 74,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '1'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'bind',
                                                                    loc: {
                                                                        start: {
                                                                            line: 391,
                                                                            column: 76,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 391,
                                                                            column: 80,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: true
                                                                },
                                                                kind: 'init',
                                                                order: '2'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'label',
                                                                    loc: {
                                                                        start: {
                                                                            line: 391,
                                                                            column: 87,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 391,
                                                                            column: 92,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: 'Percent'
                                                                },
                                                                kind: 'init',
                                                                order: '3'
                                                            }
                                                        ]
                                                    }],
                                                loc: {
                                                    start: {
                                                        line: 391,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                    },
                                                    end: {
                                                        line: 391,
                                                        column: 104,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 391,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                },
                                                end: {
                                                    line: 391,
                                                    column: 104,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                }
                                            },
                                            order: '4'
                                        },
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'Field',
                                                    loc: {
                                                        start: {
                                                            line: 392,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        },
                                                        end: {
                                                            line: 392,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [{
                                                        type: 'ObjectExpression',
                                                        properties: [
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'property',
                                                                    loc: {
                                                                        start: {
                                                                            line: 392,
                                                                            column: 23,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 392,
                                                                            column: 31,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'Project',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 392,
                                                                                    column: 32,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 392,
                                                                                    column: 39,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'properties',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 392,
                                                                                    column: 40,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 392,
                                                                                    column: 50,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 392,
                                                                                column: 32,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 392,
                                                                                column: 50,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'plannedStart',
                                                                        loc: {
                                                                            start: {
                                                                                line: 392,
                                                                                column: 51,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 392,
                                                                                column: 63,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 392,
                                                                            column: 32,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 392,
                                                                            column: 63,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'object',
                                                                    loc: {
                                                                        start: {
                                                                            line: 392,
                                                                            column: 65,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 392,
                                                                            column: 71,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Identifier',
                                                                    name: 'project',
                                                                    loc: {
                                                                        start: {
                                                                            line: 392,
                                                                            column: 72,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 392,
                                                                            column: 79,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '1'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'bind',
                                                                    loc: {
                                                                        start: {
                                                                            line: 392,
                                                                            column: 81,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 392,
                                                                            column: 85,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: true
                                                                },
                                                                kind: 'init',
                                                                order: '2'
                                                            }
                                                        ]
                                                    }],
                                                loc: {
                                                    start: {
                                                        line: 392,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                    },
                                                    end: {
                                                        line: 392,
                                                        column: 92,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 392,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                },
                                                end: {
                                                    line: 392,
                                                    column: 92,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                }
                                            },
                                            order: '5'
                                        },
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'Field',
                                                    loc: {
                                                        start: {
                                                            line: 393,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        },
                                                        end: {
                                                            line: 393,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [{
                                                        type: 'ObjectExpression',
                                                        properties: [
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'property',
                                                                    loc: {
                                                                        start: {
                                                                            line: 393,
                                                                            column: 23,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 393,
                                                                            column: 31,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'Project',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 393,
                                                                                    column: 32,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 393,
                                                                                    column: 39,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'properties',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 393,
                                                                                    column: 40,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 393,
                                                                                    column: 50,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 393,
                                                                                column: 32,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 393,
                                                                                column: 50,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'plannedFinish',
                                                                        loc: {
                                                                            start: {
                                                                                line: 393,
                                                                                column: 51,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 393,
                                                                                column: 64,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 393,
                                                                            column: 32,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 393,
                                                                            column: 64,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'object',
                                                                    loc: {
                                                                        start: {
                                                                            line: 393,
                                                                            column: 66,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 393,
                                                                            column: 72,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Identifier',
                                                                    name: 'project',
                                                                    loc: {
                                                                        start: {
                                                                            line: 393,
                                                                            column: 73,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 393,
                                                                            column: 80,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '1'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'bind',
                                                                    loc: {
                                                                        start: {
                                                                            line: 393,
                                                                            column: 82,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 393,
                                                                            column: 86,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: true
                                                                },
                                                                kind: 'init',
                                                                order: '2'
                                                            }
                                                        ]
                                                    }],
                                                loc: {
                                                    start: {
                                                        line: 393,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                    },
                                                    end: {
                                                        line: 393,
                                                        column: 93,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 393,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                },
                                                end: {
                                                    line: 393,
                                                    column: 93,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                }
                                            },
                                            order: '6'
                                        },
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'Field',
                                                    loc: {
                                                        start: {
                                                            line: 394,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        },
                                                        end: {
                                                            line: 394,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [{
                                                        type: 'ObjectExpression',
                                                        properties: [
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'property',
                                                                    loc: {
                                                                        start: {
                                                                            line: 394,
                                                                            column: 23,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 394,
                                                                            column: 31,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'Project',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 394,
                                                                                    column: 32,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 394,
                                                                                    column: 39,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'properties',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 394,
                                                                                    column: 40,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 394,
                                                                                    column: 50,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 394,
                                                                                column: 32,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 394,
                                                                                column: 50,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'start',
                                                                        loc: {
                                                                            start: {
                                                                                line: 394,
                                                                                column: 51,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 394,
                                                                                column: 56,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 394,
                                                                            column: 32,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 394,
                                                                            column: 56,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'object',
                                                                    loc: {
                                                                        start: {
                                                                            line: 394,
                                                                            column: 58,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 394,
                                                                            column: 64,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Identifier',
                                                                    name: 'project',
                                                                    loc: {
                                                                        start: {
                                                                            line: 394,
                                                                            column: 65,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 394,
                                                                            column: 72,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '1'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'bind',
                                                                    loc: {
                                                                        start: {
                                                                            line: 394,
                                                                            column: 74,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 394,
                                                                            column: 78,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: true
                                                                },
                                                                kind: 'init',
                                                                order: '2'
                                                            }
                                                        ]
                                                    }],
                                                loc: {
                                                    start: {
                                                        line: 394,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                    },
                                                    end: {
                                                        line: 394,
                                                        column: 85,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 394,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                },
                                                end: {
                                                    line: 394,
                                                    column: 85,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                }
                                            },
                                            order: '7'
                                        },
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'Field',
                                                    loc: {
                                                        start: {
                                                            line: 395,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        },
                                                        end: {
                                                            line: 395,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [{
                                                        type: 'ObjectExpression',
                                                        properties: [
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'property',
                                                                    loc: {
                                                                        start: {
                                                                            line: 395,
                                                                            column: 23,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 395,
                                                                            column: 31,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'Project',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 395,
                                                                                    column: 32,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 395,
                                                                                    column: 39,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'properties',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 395,
                                                                                    column: 40,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 395,
                                                                                    column: 50,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 395,
                                                                                column: 32,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 395,
                                                                                column: 50,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'finish',
                                                                        loc: {
                                                                            start: {
                                                                                line: 395,
                                                                                column: 51,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 395,
                                                                                column: 57,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 395,
                                                                            column: 32,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 395,
                                                                            column: 57,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'object',
                                                                    loc: {
                                                                        start: {
                                                                            line: 395,
                                                                            column: 59,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 395,
                                                                            column: 65,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Identifier',
                                                                    name: 'project',
                                                                    loc: {
                                                                        start: {
                                                                            line: 395,
                                                                            column: 66,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 395,
                                                                            column: 73,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '1'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'bind',
                                                                    loc: {
                                                                        start: {
                                                                            line: 395,
                                                                            column: 75,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 395,
                                                                            column: 79,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: true
                                                                },
                                                                kind: 'init',
                                                                order: '2'
                                                            }
                                                        ]
                                                    }],
                                                loc: {
                                                    start: {
                                                        line: 395,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                    },
                                                    end: {
                                                        line: 395,
                                                        column: 86,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 395,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                },
                                                end: {
                                                    line: 395,
                                                    column: 86,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                }
                                            },
                                            order: '8'
                                        },
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'Field',
                                                    loc: {
                                                        start: {
                                                            line: 396,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        },
                                                        end: {
                                                            line: 396,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [{
                                                        type: 'ObjectExpression',
                                                        properties: [
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'property',
                                                                    loc: {
                                                                        start: {
                                                                            line: 396,
                                                                            column: 23,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 396,
                                                                            column: 31,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'Project',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 396,
                                                                                    column: 32,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 396,
                                                                                    column: 39,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'properties',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 396,
                                                                                    column: 40,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 396,
                                                                                    column: 50,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 396,
                                                                                column: 32,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 396,
                                                                                column: 50,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'work',
                                                                        loc: {
                                                                            start: {
                                                                                line: 396,
                                                                                column: 51,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 396,
                                                                                column: 55,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 396,
                                                                            column: 32,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 396,
                                                                            column: 55,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'object',
                                                                    loc: {
                                                                        start: {
                                                                            line: 396,
                                                                            column: 57,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 396,
                                                                            column: 63,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Identifier',
                                                                    name: 'project',
                                                                    loc: {
                                                                        start: {
                                                                            line: 396,
                                                                            column: 64,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 396,
                                                                            column: 71,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '1'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'bind',
                                                                    loc: {
                                                                        start: {
                                                                            line: 396,
                                                                            column: 73,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 396,
                                                                            column: 77,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: true
                                                                },
                                                                kind: 'init',
                                                                order: '2'
                                                            }
                                                        ]
                                                    }],
                                                loc: {
                                                    start: {
                                                        line: 396,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                    },
                                                    end: {
                                                        line: 396,
                                                        column: 84,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 396,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                },
                                                end: {
                                                    line: 396,
                                                    column: 84,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                }
                                            },
                                            order: '9'
                                        }
                                    ]
                                },
                                loc: {
                                    start: {
                                        line: 375,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 398,
                                        column: 16,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                },
                                order: '0'
                            }]
                    },
                    order: ';'
                }
            ],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'ProjectSummaryTab',
                loc: {
                    start: {
                        line: 358,
                        column: 4,
                        fixed: true,
                        source: 'viewpath/html/panes/ProjectPane.ion'
                    },
                    end: {
                        line: 358,
                        column: 21,
                        fixed: true,
                        source: 'viewpath/html/panes/ProjectPane.ion'
                    }
                }
            }
        }, {
            this: this,
            _ref13: _ref13,
            ion: ion,
            glass: glass,
            _ref: _ref,
            _ref2: _ref2,
            viewpath: viewpath,
            _ref3: _ref3,
            _ref4: _ref4,
            _ref5: _ref5,
            DataTable: DataTable,
            _ref6: _ref6,
            _ref7: _ref7,
            _ref8: _ref8,
            Key: Key,
            Schema: Schema,
            GlassForm: GlassForm,
            User: User,
            Task: Task,
            Project: Project,
            ProjectType: ProjectType,
            Button: Button,
            Checkbox: Checkbox,
            Dialog: Dialog,
            Field: Field,
            Icon: Icon,
            Toolbar: Toolbar,
            TabContent: TabContent,
            PromptDialog: PromptDialog,
            Renamer: Renamer,
            GenericTypeView: GenericTypeView,
            ManagersPane: ManagersPane,
            UserRowContent: UserRowContent,
            UserOrgTagsProperty: UserOrgTagsProperty,
            SubscriptionNotice: SubscriptionNotice,
            _ref9: _ref9,
            ConfirmDialog: ConfirmDialog,
            ProjectTasksTab: ProjectTasksTab,
            getResourceQuery: getResourceQuery,
            ProjectResourcesTab: ProjectResourcesTab,
            ProjectManagersTab: ProjectManagersTab,
            ProjectSummaryTab: ProjectSummaryTab
        }, null);
    });
module.exports = exports = ion.template(function (config) {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'subNotice',
                            loc: {
                                start: {
                                    line: 399,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                },
                                end: {
                                    line: 399,
                                    column: 17,
                                    fixed: true,
                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'SubscriptionNotice',
                                loc: {
                                    start: {
                                        line: 399,
                                        column: 20,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 399,
                                        column: 38,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'Literal',
                                    value: 'create and manage projects'
                                }],
                            loc: {
                                start: {
                                    line: 399,
                                    column: 20,
                                    fixed: true,
                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                },
                                end: {
                                    line: 399,
                                    column: 68,
                                    fixed: true,
                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'IfStatement',
                test: {
                    type: 'UnaryExpression',
                    operator: '?',
                    argument: {
                        type: 'Identifier',
                        name: 'subNotice',
                        loc: {
                            start: {
                                line: 400,
                                column: 7,
                                fixed: true,
                                source: 'viewpath/html/panes/ProjectPane.ion'
                            },
                            end: {
                                line: 400,
                                column: 16,
                                fixed: true,
                                source: 'viewpath/html/panes/ProjectPane.ion'
                            }
                        }
                    }
                },
                consequent: {
                    type: 'BlockStatement',
                    body: [{
                            type: 'ReturnStatement',
                            argument: {
                                type: 'Identifier',
                                name: 'subNotice',
                                loc: {
                                    start: {
                                        line: 401,
                                        column: 15,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    },
                                    end: {
                                        line: 401,
                                        column: 24,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                    }
                                }
                            },
                            order: '0'
                        }]
                },
                alternate: {
                    type: 'BlockStatement',
                    body: [
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'user',
                                        loc: {
                                            start: {
                                                line: 403,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            },
                                            end: {
                                                line: 403,
                                                column: 16,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'model',
                                            loc: {
                                                start: {
                                                    line: 403,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                },
                                                end: {
                                                    line: 403,
                                                    column: 24,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'user',
                                            loc: {
                                                start: {
                                                    line: 403,
                                                    column: 25,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                },
                                                end: {
                                                    line: 403,
                                                    column: 29,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 403,
                                                column: 19,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            },
                                            end: {
                                                line: 403,
                                                column: 29,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '0'
                        },
                        {
                            type: 'IfStatement',
                            test: {
                                type: 'UnaryExpression',
                                operator: '!',
                                argument: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'config',
                                        loc: {
                                            start: {
                                                line: 406,
                                                column: 15,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            },
                                            end: {
                                                line: 406,
                                                column: 21,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'key',
                                        loc: {
                                            start: {
                                                line: 406,
                                                column: 22,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            },
                                            end: {
                                                line: 406,
                                                column: 25,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 406,
                                            column: 15,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        },
                                        end: {
                                            line: 406,
                                            column: 25,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                        }
                                    }
                                }
                            },
                            consequent: {
                                type: 'BlockStatement',
                                body: [{
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'console',
                                                    loc: {
                                                        start: {
                                                            line: 407,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        },
                                                        end: {
                                                            line: 407,
                                                            column: 19,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'warn',
                                                    loc: {
                                                        start: {
                                                            line: 407,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        },
                                                        end: {
                                                            line: 407,
                                                            column: 24,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 407,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                    },
                                                    end: {
                                                        line: 407,
                                                        column: 24,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                    }
                                                }
                                            },
                                            arguments: [{
                                                    type: 'Literal',
                                                    value: 'ProjectPane config.key missing, which indicates out of order execution of dependent code'
                                                }],
                                            loc: {
                                                start: {
                                                    line: 407,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                },
                                                end: {
                                                    line: 407,
                                                    column: 116,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 407,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            },
                                            end: {
                                                line: 407,
                                                column: 116,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                            }
                                        },
                                        order: '0'
                                    }]
                            },
                            alternate: {
                                type: 'BlockStatement',
                                body: [
                                    {
                                        type: 'VariableDeclaration',
                                        declarations: [{
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'projectKey',
                                                    loc: {
                                                        start: {
                                                            line: 409,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        },
                                                        end: {
                                                            line: 409,
                                                            column: 26,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        }
                                                    }
                                                },
                                                init: {
                                                    type: 'NewExpression',
                                                    callee: {
                                                        type: 'Identifier',
                                                        name: 'Key',
                                                        loc: {
                                                            start: {
                                                                line: 409,
                                                                column: 33,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 409,
                                                                column: 36,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [
                                                        {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'viewpath',
                                                                loc: {
                                                                    start: {
                                                                        line: 409,
                                                                        column: 37,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 409,
                                                                        column: 45,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'model',
                                                                loc: {
                                                                    start: {
                                                                        line: 409,
                                                                        column: 46,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 409,
                                                                        column: 51,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 409,
                                                                    column: 37,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 409,
                                                                    column: 51,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'config',
                                                                loc: {
                                                                    start: {
                                                                        line: 409,
                                                                        column: 53,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 409,
                                                                        column: 59,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'key',
                                                                loc: {
                                                                    start: {
                                                                        line: 409,
                                                                        column: 60,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 409,
                                                                        column: 63,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 409,
                                                                    column: 53,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 409,
                                                                    column: 63,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        }
                                                    ],
                                                    loc: {
                                                        start: {
                                                            line: 409,
                                                            column: 29,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        },
                                                        end: {
                                                            line: 409,
                                                            column: 64,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        }
                                                    }
                                                }
                                            }],
                                        kind: 'let',
                                        order: '0'
                                    },
                                    {
                                        type: 'VariableDeclaration',
                                        declarations: [{
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'project',
                                                    loc: {
                                                        start: {
                                                            line: 410,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        },
                                                        end: {
                                                            line: 410,
                                                            column: 23,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        }
                                                    }
                                                },
                                                init: {
                                                    type: 'MemberExpression',
                                                    computed: true,
                                                    object: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'model',
                                                            loc: {
                                                                start: {
                                                                    line: 410,
                                                                    column: 26,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 410,
                                                                    column: 31,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'server',
                                                            loc: {
                                                                start: {
                                                                    line: 410,
                                                                    column: 32,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 410,
                                                                    column: 38,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 410,
                                                                column: 26,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 410,
                                                                column: 38,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'projectKey',
                                                        loc: {
                                                            start: {
                                                                line: 410,
                                                                column: 39,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 410,
                                                                column: 49,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 410,
                                                            column: 26,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        },
                                                        end: {
                                                            line: 410,
                                                            column: 50,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        }
                                                    }
                                                }
                                            }],
                                        kind: 'let',
                                        order: '1'
                                    },
                                    {
                                        type: 'VariableDeclaration',
                                        declarations: [{
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'projectTasksKey',
                                                    loc: {
                                                        start: {
                                                            line: 411,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        },
                                                        end: {
                                                            line: 411,
                                                            column: 31,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        }
                                                    }
                                                },
                                                init: {
                                                    type: 'NewExpression',
                                                    callee: {
                                                        type: 'Identifier',
                                                        name: 'Key',
                                                        loc: {
                                                            start: {
                                                                line: 411,
                                                                column: 38,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 411,
                                                                column: 41,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [
                                                        {
                                                            type: 'Identifier',
                                                            name: 'projectKey',
                                                            loc: {
                                                                start: {
                                                                    line: 411,
                                                                    column: 42,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 411,
                                                                    column: 52,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        {
                                                            type: 'Identifier',
                                                            name: 'Task',
                                                            loc: {
                                                                start: {
                                                                    line: 411,
                                                                    column: 54,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 411,
                                                                    column: 58,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        }
                                                    ],
                                                    loc: {
                                                        start: {
                                                            line: 411,
                                                            column: 34,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        },
                                                        end: {
                                                            line: 411,
                                                            column: 59,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        }
                                                    }
                                                }
                                            }],
                                        kind: 'let',
                                        order: '2'
                                    },
                                    {
                                        type: 'VariableDeclaration',
                                        declarations: [{
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'tasks',
                                                    loc: {
                                                        start: {
                                                            line: 412,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        },
                                                        end: {
                                                            line: 412,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        }
                                                    }
                                                },
                                                init: {
                                                    type: 'MemberExpression',
                                                    computed: true,
                                                    object: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'model',
                                                            loc: {
                                                                start: {
                                                                    line: 412,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 412,
                                                                    column: 29,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'server',
                                                            loc: {
                                                                start: {
                                                                    line: 412,
                                                                    column: 30,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 412,
                                                                    column: 36,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 412,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 412,
                                                                column: 36,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'projectTasksKey',
                                                        loc: {
                                                            start: {
                                                                line: 412,
                                                                column: 37,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            },
                                                            end: {
                                                                line: 412,
                                                                column: 52,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 412,
                                                            column: 24,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        },
                                                        end: {
                                                            line: 412,
                                                            column: 53,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        }
                                                    }
                                                }
                                            }],
                                        kind: 'let',
                                        order: '3'
                                    },
                                    {
                                        type: 'ReturnStatement',
                                        argument: {
                                            type: 'ObjectExpression',
                                            objectType: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'Div',
                                                    loc: {
                                                        start: {
                                                            line: 413,
                                                            column: 19,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        },
                                                        end: {
                                                            line: 413,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [{
                                                        type: 'ObjectExpression',
                                                        properties: [{
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'class',
                                                                    loc: {
                                                                        start: {
                                                                            line: 413,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 413,
                                                                            column: 29,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: 'fill layout vertical'
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            }]
                                                    }],
                                                loc: {
                                                    start: {
                                                        line: 413,
                                                        column: 19,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                    },
                                                    end: {
                                                        line: 413,
                                                        column: 54,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                    }
                                                }
                                            },
                                            properties: [{
                                                    type: 'IfStatement',
                                                    test: {
                                                        type: 'BinaryExpression',
                                                        operator: '===',
                                                        left: {
                                                            type: 'Identifier',
                                                            name: 'project',
                                                            loc: {
                                                                start: {
                                                                    line: 414,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                },
                                                                end: {
                                                                    line: 414,
                                                                    column: 26,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                }
                                                            }
                                                        },
                                                        right: {
                                                            type: 'Literal',
                                                            value: null
                                                        }
                                                    },
                                                    consequent: {
                                                        type: 'BlockStatement',
                                                        body: [
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'name',
                                                                    loc: {
                                                                        start: {
                                                                            line: 415,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 415,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: 'Project not found'
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'Literal',
                                                                    value: 'Project not found'
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 416,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 416,
                                                                        column: 39,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    }
                                                                },
                                                                order: '1'
                                                            }
                                                        ]
                                                    },
                                                    alternate: {
                                                        type: 'IfStatement',
                                                        test: {
                                                            type: 'UnaryExpression',
                                                            operator: '?',
                                                            argument: {
                                                                type: 'Identifier',
                                                                name: 'project',
                                                                loc: {
                                                                    start: {
                                                                        line: 417,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 417,
                                                                        column: 31,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                    }
                                                                }
                                                            }
                                                        },
                                                        consequent: {
                                                            type: 'BlockStatement',
                                                            body: [
                                                                {
                                                                    type: 'VariableDeclaration',
                                                                    declarations: [{
                                                                            type: 'VariableDeclarator',
                                                                            id: {
                                                                                type: 'Identifier',
                                                                                name: 'projectTypeName',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 418,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 418,
                                                                                        column: 39,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            init: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'project',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 418,
                                                                                                column: 42,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 418,
                                                                                                column: 49,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'Type',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 418,
                                                                                                column: 50,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 418,
                                                                                                column: 54,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 418,
                                                                                            column: 42,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 418,
                                                                                            column: 54,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'name',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 418,
                                                                                            column: 55,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 418,
                                                                                            column: 59,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 418,
                                                                                        column: 42,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 418,
                                                                                        column: 59,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                }
                                                                            }
                                                                        }],
                                                                    kind: 'let',
                                                                    order: '0'
                                                                },
                                                                {
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'name',
                                                                        loc: {
                                                                            start: {
                                                                                line: 419,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 419,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'ArrayExpression',
                                                                        elements: [
                                                                            {
                                                                                type: 'Identifier',
                                                                                name: 'projectTypeName',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 419,
                                                                                        column: 27,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 419,
                                                                                        column: 42,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            {
                                                                                type: 'CallExpression',
                                                                                callee: {
                                                                                    type: 'Identifier',
                                                                                    name: 'Renamer',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 419,
                                                                                            column: 44,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 419,
                                                                                            column: 51,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                arguments: [{
                                                                                        type: 'ObjectExpression',
                                                                                        properties: [
                                                                                            {
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'object',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 419,
                                                                                                            column: 53,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 419,
                                                                                                            column: 59,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'project',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 419,
                                                                                                            column: 60,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 419,
                                                                                                            column: 67,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '0'
                                                                                            },
                                                                                            {
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'prompt',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 419,
                                                                                                            column: 68,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 419,
                                                                                                            column: 74,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'BinaryExpression',
                                                                                                    operator: '+',
                                                                                                    left: {
                                                                                                        type: 'Literal',
                                                                                                        value: 'Rename the '
                                                                                                    },
                                                                                                    right: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'projectTypeName',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 419,
                                                                                                                column: 89,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 419,
                                                                                                                column: 104,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '1'
                                                                                            }
                                                                                        ]
                                                                                    }],
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 419,
                                                                                        column: 44,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 419,
                                                                                        column: 109,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                    }
                                                                                }
                                                                            }
                                                                        ]
                                                                    },
                                                                    kind: 'init',
                                                                    order: '1'
                                                                },
                                                                {
                                                                    type: 'ExpressionStatement',
                                                                    expression: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'Identifier',
                                                                            name: 'TabContent',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 420,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 420,
                                                                                    column: 30,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [{
                                                                                type: 'ObjectExpression',
                                                                                properties: [
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'state',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 421,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 421,
                                                                                                    column: 29,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Identifier',
                                                                                            name: 'config',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 421,
                                                                                                    column: 31,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 421,
                                                                                                    column: 37,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'path',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 422,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 422,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'ArrayExpression',
                                                                                            elements: []
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '1'
                                                                                    },
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'step',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 423,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 423,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 0
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '2'
                                                                                    },
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'defaultTab',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 424,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 424,
                                                                                                    column: 34,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 'tasks'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '3'
                                                                                    },
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'tabs',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 425,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 425,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'ObjectExpression',
                                                                                            objectType: {
                                                                                                type: 'ArrayExpression',
                                                                                                elements: []
                                                                                            },
                                                                                            properties: [
                                                                                                {
                                                                                                    type: 'ExpressionStatement',
                                                                                                    expression: {
                                                                                                        type: 'ObjectExpression',
                                                                                                        objectType: {
                                                                                                            type: 'ObjectExpression',
                                                                                                            properties: []
                                                                                                        },
                                                                                                        properties: [
                                                                                                            {
                                                                                                                type: 'Property',
                                                                                                                key: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'name',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 427,
                                                                                                                            column: 32,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 427,
                                                                                                                            column: 36,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                value: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: 'summary'
                                                                                                                },
                                                                                                                kind: 'init',
                                                                                                                order: '0'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'Property',
                                                                                                                key: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'tab',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 428,
                                                                                                                            column: 32,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 428,
                                                                                                                            column: 35,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                value: {
                                                                                                                    type: 'Function',
                                                                                                                    context: false,
                                                                                                                    value: function () {
                                                                                                                        return 'Summary';
                                                                                                                    }
                                                                                                                },
                                                                                                                kind: 'init',
                                                                                                                order: '1'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'Property',
                                                                                                                key: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'content',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 429,
                                                                                                                            column: 32,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 429,
                                                                                                                            column: 39,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                value: {
                                                                                                                    type: 'Function',
                                                                                                                    context: true,
                                                                                                                    value: function (_ps) {
                                                                                                                        return ion.template(function () {
                                                                                                                            return ion.createRuntime({
                                                                                                                                type: 'Template',
                                                                                                                                id: null,
                                                                                                                                body: [{
                                                                                                                                        type: 'ReturnStatement',
                                                                                                                                        argument: {
                                                                                                                                            type: 'CallExpression',
                                                                                                                                            callee: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'ProjectSummaryTab',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 430,
                                                                                                                                                        column: 43,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 430,
                                                                                                                                                        column: 60,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            arguments: [{
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    properties: [
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'config',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 430,
                                                                                                                                                                        column: 62,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 430,
                                                                                                                                                                        column: 68,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'config',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 430,
                                                                                                                                                                        column: 62,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 430,
                                                                                                                                                                        column: 68,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '0'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'project',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 430,
                                                                                                                                                                        column: 69,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 430,
                                                                                                                                                                        column: 76,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'project',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 430,
                                                                                                                                                                        column: 69,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 430,
                                                                                                                                                                        column: 76,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '1'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'projectKey',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 430,
                                                                                                                                                                        column: 77,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 430,
                                                                                                                                                                        column: 87,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'projectKey',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 430,
                                                                                                                                                                        column: 77,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 430,
                                                                                                                                                                        column: 87,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '2'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'projectTasksKey',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 430,
                                                                                                                                                                        column: 88,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 430,
                                                                                                                                                                        column: 103,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'projectTasksKey',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 430,
                                                                                                                                                                        column: 88,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 430,
                                                                                                                                                                        column: 103,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '3'
                                                                                                                                                        }
                                                                                                                                                    ]
                                                                                                                                                }],
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 430,
                                                                                                                                                    column: 43,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 430,
                                                                                                                                                    column: 105,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        order: '0'
                                                                                                                                    }],
                                                                                                                                bound: false,
                                                                                                                                name: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'content',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 429,
                                                                                                                                            column: 32,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 429,
                                                                                                                                            column: 39,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                scope: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: '_ps'
                                                                                                                                }
                                                                                                                            }, {
                                                                                                                                this: this,
                                                                                                                                _ps: _ps,
                                                                                                                                config: config,
                                                                                                                                ion: ion,
                                                                                                                                glass: glass,
                                                                                                                                _ref: _ref,
                                                                                                                                _ref2: _ref2,
                                                                                                                                viewpath: viewpath,
                                                                                                                                _ref3: _ref3,
                                                                                                                                _ref4: _ref4,
                                                                                                                                _ref5: _ref5,
                                                                                                                                DataTable: DataTable,
                                                                                                                                _ref6: _ref6,
                                                                                                                                _ref7: _ref7,
                                                                                                                                _ref8: _ref8,
                                                                                                                                Key: Key,
                                                                                                                                Schema: Schema,
                                                                                                                                GlassForm: GlassForm,
                                                                                                                                User: User,
                                                                                                                                Task: Task,
                                                                                                                                Project: Project,
                                                                                                                                ProjectType: ProjectType,
                                                                                                                                Button: Button,
                                                                                                                                Checkbox: Checkbox,
                                                                                                                                Dialog: Dialog,
                                                                                                                                Field: Field,
                                                                                                                                Icon: Icon,
                                                                                                                                Toolbar: Toolbar,
                                                                                                                                TabContent: TabContent,
                                                                                                                                PromptDialog: PromptDialog,
                                                                                                                                Renamer: Renamer,
                                                                                                                                GenericTypeView: GenericTypeView,
                                                                                                                                ManagersPane: ManagersPane,
                                                                                                                                UserRowContent: UserRowContent,
                                                                                                                                UserOrgTagsProperty: UserOrgTagsProperty,
                                                                                                                                SubscriptionNotice: SubscriptionNotice,
                                                                                                                                _ref9: _ref9,
                                                                                                                                ConfirmDialog: ConfirmDialog,
                                                                                                                                ProjectTasksTab: ProjectTasksTab,
                                                                                                                                getResourceQuery: getResourceQuery,
                                                                                                                                ProjectResourcesTab: ProjectResourcesTab,
                                                                                                                                ProjectManagersTab: ProjectManagersTab,
                                                                                                                                ProjectSummaryTab: ProjectSummaryTab
                                                                                                                            }, _ps);
                                                                                                                        });
                                                                                                                    }
                                                                                                                },
                                                                                                                kind: 'init',
                                                                                                                order: '2'
                                                                                                            }
                                                                                                        ]
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 426,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 431,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                        }
                                                                                                    },
                                                                                                    order: '0'
                                                                                                },
                                                                                                {
                                                                                                    type: 'ExpressionStatement',
                                                                                                    expression: {
                                                                                                        type: 'ObjectExpression',
                                                                                                        objectType: {
                                                                                                            type: 'ObjectExpression',
                                                                                                            properties: []
                                                                                                        },
                                                                                                        properties: [
                                                                                                            {
                                                                                                                type: 'Property',
                                                                                                                key: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'name',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 432,
                                                                                                                            column: 32,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 432,
                                                                                                                            column: 36,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                value: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: 'tasks'
                                                                                                                },
                                                                                                                kind: 'init',
                                                                                                                order: '0'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'Property',
                                                                                                                key: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'tab',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 433,
                                                                                                                            column: 32,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 433,
                                                                                                                            column: 35,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                value: {
                                                                                                                    type: 'Function',
                                                                                                                    context: false,
                                                                                                                    value: function () {
                                                                                                                        return 'Tasks';
                                                                                                                    }
                                                                                                                },
                                                                                                                kind: 'init',
                                                                                                                order: '1'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'Property',
                                                                                                                key: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'content',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 434,
                                                                                                                            column: 32,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 434,
                                                                                                                            column: 39,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                value: {
                                                                                                                    type: 'Function',
                                                                                                                    context: true,
                                                                                                                    value: function (_ps2) {
                                                                                                                        return ion.template(function () {
                                                                                                                            return ion.createRuntime({
                                                                                                                                type: 'Template',
                                                                                                                                id: null,
                                                                                                                                body: [{
                                                                                                                                        type: 'ReturnStatement',
                                                                                                                                        argument: {
                                                                                                                                            type: 'CallExpression',
                                                                                                                                            callee: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'ProjectTasksTab',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 435,
                                                                                                                                                        column: 43,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 435,
                                                                                                                                                        column: 58,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            arguments: [{
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    properties: [
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'config',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 435,
                                                                                                                                                                        column: 60,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 435,
                                                                                                                                                                        column: 66,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'config',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 435,
                                                                                                                                                                        column: 60,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 435,
                                                                                                                                                                        column: 66,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '0'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'project',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 435,
                                                                                                                                                                        column: 67,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 435,
                                                                                                                                                                        column: 74,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'project',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 435,
                                                                                                                                                                        column: 67,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 435,
                                                                                                                                                                        column: 74,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '1'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'projectKey',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 435,
                                                                                                                                                                        column: 75,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 435,
                                                                                                                                                                        column: 85,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'projectKey',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 435,
                                                                                                                                                                        column: 75,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 435,
                                                                                                                                                                        column: 85,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '2'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'projectTasksKey',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 435,
                                                                                                                                                                        column: 86,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 435,
                                                                                                                                                                        column: 101,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'projectTasksKey',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 435,
                                                                                                                                                                        column: 86,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 435,
                                                                                                                                                                        column: 101,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '3'
                                                                                                                                                        }
                                                                                                                                                    ]
                                                                                                                                                }],
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 435,
                                                                                                                                                    column: 43,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 435,
                                                                                                                                                    column: 103,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        order: '0'
                                                                                                                                    }],
                                                                                                                                bound: false,
                                                                                                                                name: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'content',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 434,
                                                                                                                                            column: 32,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 434,
                                                                                                                                            column: 39,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                scope: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: '_ps2'
                                                                                                                                }
                                                                                                                            }, {
                                                                                                                                this: this,
                                                                                                                                _ps2: _ps2,
                                                                                                                                config: config,
                                                                                                                                ion: ion,
                                                                                                                                glass: glass,
                                                                                                                                _ref: _ref,
                                                                                                                                _ref2: _ref2,
                                                                                                                                viewpath: viewpath,
                                                                                                                                _ref3: _ref3,
                                                                                                                                _ref4: _ref4,
                                                                                                                                _ref5: _ref5,
                                                                                                                                DataTable: DataTable,
                                                                                                                                _ref6: _ref6,
                                                                                                                                _ref7: _ref7,
                                                                                                                                _ref8: _ref8,
                                                                                                                                Key: Key,
                                                                                                                                Schema: Schema,
                                                                                                                                GlassForm: GlassForm,
                                                                                                                                User: User,
                                                                                                                                Task: Task,
                                                                                                                                Project: Project,
                                                                                                                                ProjectType: ProjectType,
                                                                                                                                Button: Button,
                                                                                                                                Checkbox: Checkbox,
                                                                                                                                Dialog: Dialog,
                                                                                                                                Field: Field,
                                                                                                                                Icon: Icon,
                                                                                                                                Toolbar: Toolbar,
                                                                                                                                TabContent: TabContent,
                                                                                                                                PromptDialog: PromptDialog,
                                                                                                                                Renamer: Renamer,
                                                                                                                                GenericTypeView: GenericTypeView,
                                                                                                                                ManagersPane: ManagersPane,
                                                                                                                                UserRowContent: UserRowContent,
                                                                                                                                UserOrgTagsProperty: UserOrgTagsProperty,
                                                                                                                                SubscriptionNotice: SubscriptionNotice,
                                                                                                                                _ref9: _ref9,
                                                                                                                                ConfirmDialog: ConfirmDialog,
                                                                                                                                ProjectTasksTab: ProjectTasksTab,
                                                                                                                                getResourceQuery: getResourceQuery,
                                                                                                                                ProjectResourcesTab: ProjectResourcesTab,
                                                                                                                                ProjectManagersTab: ProjectManagersTab,
                                                                                                                                ProjectSummaryTab: ProjectSummaryTab
                                                                                                                            }, _ps2);
                                                                                                                        });
                                                                                                                    }
                                                                                                                },
                                                                                                                kind: 'init',
                                                                                                                order: '2'
                                                                                                            }
                                                                                                        ]
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 431,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 436,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                        }
                                                                                                    },
                                                                                                    order: '1'
                                                                                                },
                                                                                                {
                                                                                                    type: 'ExpressionStatement',
                                                                                                    expression: {
                                                                                                        type: 'ObjectExpression',
                                                                                                        objectType: {
                                                                                                            type: 'ObjectExpression',
                                                                                                            properties: []
                                                                                                        },
                                                                                                        properties: [
                                                                                                            {
                                                                                                                type: 'Property',
                                                                                                                key: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'name',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 437,
                                                                                                                            column: 32,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 437,
                                                                                                                            column: 36,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                value: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: 'resources'
                                                                                                                },
                                                                                                                kind: 'init',
                                                                                                                order: '0'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'Property',
                                                                                                                key: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'tab',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 438,
                                                                                                                            column: 32,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 438,
                                                                                                                            column: 35,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                value: {
                                                                                                                    type: 'Function',
                                                                                                                    context: false,
                                                                                                                    value: function () {
                                                                                                                        return 'Resources';
                                                                                                                    }
                                                                                                                },
                                                                                                                kind: 'init',
                                                                                                                order: '1'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'Property',
                                                                                                                key: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'content',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 439,
                                                                                                                            column: 32,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 439,
                                                                                                                            column: 39,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                value: {
                                                                                                                    type: 'Function',
                                                                                                                    context: true,
                                                                                                                    value: function (_ps3) {
                                                                                                                        return ion.template(function () {
                                                                                                                            return ion.createRuntime({
                                                                                                                                type: 'Template',
                                                                                                                                id: null,
                                                                                                                                body: [{
                                                                                                                                        type: 'ReturnStatement',
                                                                                                                                        argument: {
                                                                                                                                            type: 'CallExpression',
                                                                                                                                            callee: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'ProjectResourcesTab',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 440,
                                                                                                                                                        column: 43,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 440,
                                                                                                                                                        column: 62,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            arguments: [{
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    properties: [
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'config',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 440,
                                                                                                                                                                        column: 64,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 440,
                                                                                                                                                                        column: 70,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'config',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 440,
                                                                                                                                                                        column: 64,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 440,
                                                                                                                                                                        column: 70,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '0'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'project',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 440,
                                                                                                                                                                        column: 71,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 440,
                                                                                                                                                                        column: 78,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'project',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 440,
                                                                                                                                                                        column: 71,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 440,
                                                                                                                                                                        column: 78,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '1'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'projectKey',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 440,
                                                                                                                                                                        column: 79,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 440,
                                                                                                                                                                        column: 89,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'projectKey',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 440,
                                                                                                                                                                        column: 79,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 440,
                                                                                                                                                                        column: 89,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '2'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'projectTasksKey',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 440,
                                                                                                                                                                        column: 90,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 440,
                                                                                                                                                                        column: 105,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'projectTasksKey',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 440,
                                                                                                                                                                        column: 90,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 440,
                                                                                                                                                                        column: 105,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '3'
                                                                                                                                                        }
                                                                                                                                                    ]
                                                                                                                                                }],
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 440,
                                                                                                                                                    column: 43,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 440,
                                                                                                                                                    column: 107,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        order: '0'
                                                                                                                                    }],
                                                                                                                                bound: false,
                                                                                                                                name: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'content',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 439,
                                                                                                                                            column: 32,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 439,
                                                                                                                                            column: 39,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                scope: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: '_ps3'
                                                                                                                                }
                                                                                                                            }, {
                                                                                                                                this: this,
                                                                                                                                _ps3: _ps3,
                                                                                                                                config: config,
                                                                                                                                ion: ion,
                                                                                                                                glass: glass,
                                                                                                                                _ref: _ref,
                                                                                                                                _ref2: _ref2,
                                                                                                                                viewpath: viewpath,
                                                                                                                                _ref3: _ref3,
                                                                                                                                _ref4: _ref4,
                                                                                                                                _ref5: _ref5,
                                                                                                                                DataTable: DataTable,
                                                                                                                                _ref6: _ref6,
                                                                                                                                _ref7: _ref7,
                                                                                                                                _ref8: _ref8,
                                                                                                                                Key: Key,
                                                                                                                                Schema: Schema,
                                                                                                                                GlassForm: GlassForm,
                                                                                                                                User: User,
                                                                                                                                Task: Task,
                                                                                                                                Project: Project,
                                                                                                                                ProjectType: ProjectType,
                                                                                                                                Button: Button,
                                                                                                                                Checkbox: Checkbox,
                                                                                                                                Dialog: Dialog,
                                                                                                                                Field: Field,
                                                                                                                                Icon: Icon,
                                                                                                                                Toolbar: Toolbar,
                                                                                                                                TabContent: TabContent,
                                                                                                                                PromptDialog: PromptDialog,
                                                                                                                                Renamer: Renamer,
                                                                                                                                GenericTypeView: GenericTypeView,
                                                                                                                                ManagersPane: ManagersPane,
                                                                                                                                UserRowContent: UserRowContent,
                                                                                                                                UserOrgTagsProperty: UserOrgTagsProperty,
                                                                                                                                SubscriptionNotice: SubscriptionNotice,
                                                                                                                                _ref9: _ref9,
                                                                                                                                ConfirmDialog: ConfirmDialog,
                                                                                                                                ProjectTasksTab: ProjectTasksTab,
                                                                                                                                getResourceQuery: getResourceQuery,
                                                                                                                                ProjectResourcesTab: ProjectResourcesTab,
                                                                                                                                ProjectManagersTab: ProjectManagersTab,
                                                                                                                                ProjectSummaryTab: ProjectSummaryTab
                                                                                                                            }, _ps3);
                                                                                                                        });
                                                                                                                    }
                                                                                                                },
                                                                                                                kind: 'init',
                                                                                                                order: '2'
                                                                                                            }
                                                                                                        ]
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 436,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 441,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                        }
                                                                                                    },
                                                                                                    order: '2'
                                                                                                },
                                                                                                {
                                                                                                    type: 'ExpressionStatement',
                                                                                                    expression: {
                                                                                                        type: 'ObjectExpression',
                                                                                                        objectType: {
                                                                                                            type: 'ObjectExpression',
                                                                                                            properties: []
                                                                                                        },
                                                                                                        properties: [
                                                                                                            {
                                                                                                                type: 'Property',
                                                                                                                key: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'name',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 442,
                                                                                                                            column: 32,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 442,
                                                                                                                            column: 36,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                value: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: 'managers'
                                                                                                                },
                                                                                                                kind: 'init',
                                                                                                                order: '0'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'Property',
                                                                                                                key: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'tab',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 443,
                                                                                                                            column: 32,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 443,
                                                                                                                            column: 35,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                value: {
                                                                                                                    type: 'Function',
                                                                                                                    context: false,
                                                                                                                    value: function () {
                                                                                                                        return 'Managers';
                                                                                                                    }
                                                                                                                },
                                                                                                                kind: 'init',
                                                                                                                order: '1'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'Property',
                                                                                                                key: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'content',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 444,
                                                                                                                            column: 32,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 444,
                                                                                                                            column: 39,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                value: {
                                                                                                                    type: 'Function',
                                                                                                                    context: true,
                                                                                                                    value: function (_ps4) {
                                                                                                                        return ion.template(function () {
                                                                                                                            return ion.createRuntime({
                                                                                                                                type: 'Template',
                                                                                                                                id: null,
                                                                                                                                body: [{
                                                                                                                                        type: 'ReturnStatement',
                                                                                                                                        argument: {
                                                                                                                                            type: 'CallExpression',
                                                                                                                                            callee: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'ProjectManagersTab',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 445,
                                                                                                                                                        column: 43,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 445,
                                                                                                                                                        column: 61,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            arguments: [{
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    properties: [
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'config',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 445,
                                                                                                                                                                        column: 63,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 445,
                                                                                                                                                                        column: 69,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'config',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 445,
                                                                                                                                                                        column: 63,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 445,
                                                                                                                                                                        column: 69,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '0'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'project',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 445,
                                                                                                                                                                        column: 70,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 445,
                                                                                                                                                                        column: 77,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'project',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 445,
                                                                                                                                                                        column: 70,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 445,
                                                                                                                                                                        column: 77,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '1'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'projectKey',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 445,
                                                                                                                                                                        column: 78,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 445,
                                                                                                                                                                        column: 88,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'projectKey',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 445,
                                                                                                                                                                        column: 78,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 445,
                                                                                                                                                                        column: 88,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '2'
                                                                                                                                                        }
                                                                                                                                                    ]
                                                                                                                                                }],
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 445,
                                                                                                                                                    column: 43,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 445,
                                                                                                                                                    column: 90,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        order: '0'
                                                                                                                                    }],
                                                                                                                                bound: false,
                                                                                                                                name: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'content',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 444,
                                                                                                                                            column: 32,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 444,
                                                                                                                                            column: 39,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                scope: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: '_ps4'
                                                                                                                                }
                                                                                                                            }, {
                                                                                                                                this: this,
                                                                                                                                _ps4: _ps4,
                                                                                                                                config: config,
                                                                                                                                ion: ion,
                                                                                                                                glass: glass,
                                                                                                                                _ref: _ref,
                                                                                                                                _ref2: _ref2,
                                                                                                                                viewpath: viewpath,
                                                                                                                                _ref3: _ref3,
                                                                                                                                _ref4: _ref4,
                                                                                                                                _ref5: _ref5,
                                                                                                                                DataTable: DataTable,
                                                                                                                                _ref6: _ref6,
                                                                                                                                _ref7: _ref7,
                                                                                                                                _ref8: _ref8,
                                                                                                                                Key: Key,
                                                                                                                                Schema: Schema,
                                                                                                                                GlassForm: GlassForm,
                                                                                                                                User: User,
                                                                                                                                Task: Task,
                                                                                                                                Project: Project,
                                                                                                                                ProjectType: ProjectType,
                                                                                                                                Button: Button,
                                                                                                                                Checkbox: Checkbox,
                                                                                                                                Dialog: Dialog,
                                                                                                                                Field: Field,
                                                                                                                                Icon: Icon,
                                                                                                                                Toolbar: Toolbar,
                                                                                                                                TabContent: TabContent,
                                                                                                                                PromptDialog: PromptDialog,
                                                                                                                                Renamer: Renamer,
                                                                                                                                GenericTypeView: GenericTypeView,
                                                                                                                                ManagersPane: ManagersPane,
                                                                                                                                UserRowContent: UserRowContent,
                                                                                                                                UserOrgTagsProperty: UserOrgTagsProperty,
                                                                                                                                SubscriptionNotice: SubscriptionNotice,
                                                                                                                                _ref9: _ref9,
                                                                                                                                ConfirmDialog: ConfirmDialog,
                                                                                                                                ProjectTasksTab: ProjectTasksTab,
                                                                                                                                getResourceQuery: getResourceQuery,
                                                                                                                                ProjectResourcesTab: ProjectResourcesTab,
                                                                                                                                ProjectManagersTab: ProjectManagersTab,
                                                                                                                                ProjectSummaryTab: ProjectSummaryTab
                                                                                                                            }, _ps4);
                                                                                                                        });
                                                                                                                    }
                                                                                                                },
                                                                                                                kind: 'init',
                                                                                                                order: '2'
                                                                                                            }
                                                                                                        ]
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 441,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 446,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                                                        }
                                                                                                    },
                                                                                                    order: '3'
                                                                                                }
                                                                                            ]
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '4'
                                                                                    }
                                                                                ]
                                                                            }],
                                                                        loc: {
                                                                            start: {
                                                                                line: 420,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 446,
                                                                                column: 21,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/ProjectPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 420,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 446,
                                                                            column: 21,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/ProjectPane.ion'
                                                                        }
                                                                    },
                                                                    order: '2'
                                                                }
                                                            ]
                                                        },
                                                        alternate: null
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        order: '4'
                                    }
                                ]
                            },
                            order: '1'
                        }
                    ]
                },
                order: '1'
            }
        ],
        bound: false
    }, {
        this: this,
        ion: ion,
        config: config,
        glass: glass,
        _ref: _ref,
        _ref2: _ref2,
        viewpath: viewpath,
        _ref3: _ref3,
        _ref4: _ref4,
        _ref5: _ref5,
        DataTable: DataTable,
        _ref6: _ref6,
        _ref7: _ref7,
        _ref8: _ref8,
        Key: Key,
        Schema: Schema,
        GlassForm: GlassForm,
        User: User,
        Task: Task,
        Project: Project,
        ProjectType: ProjectType,
        Button: Button,
        Checkbox: Checkbox,
        Dialog: Dialog,
        Field: Field,
        Icon: Icon,
        Toolbar: Toolbar,
        TabContent: TabContent,
        PromptDialog: PromptDialog,
        Renamer: Renamer,
        GenericTypeView: GenericTypeView,
        ManagersPane: ManagersPane,
        UserRowContent: UserRowContent,
        UserOrgTagsProperty: UserOrgTagsProperty,
        SubscriptionNotice: SubscriptionNotice,
        _ref9: _ref9,
        ConfirmDialog: ConfirmDialog,
        ProjectTasksTab: ProjectTasksTab,
        getResourceQuery: getResourceQuery,
        ProjectResourcesTab: ProjectResourcesTab,
        ProjectManagersTab: ProjectManagersTab,
        ProjectSummaryTab: ProjectSummaryTab
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/panes/ProjectPane',_viewpath_html_panes_ProjectPane_);
    else
      _viewpath_html_panes_ProjectPane_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_panes_ProjectPane_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_panes_ProjectsPane_ = function(module,exports,require){'use strict';
var ion = require('ion');
var glass = require('glass'), viewpath = require('../..'), _ref, _ref2, _ref3;
_ref = viewpath.model;
var Project = _ref.Project;
var ProjectType = _ref.ProjectType;
var Task = _ref.Task;
_ref2 = require('./');
var GenericTypePane = _ref2.GenericTypePane;
_ref3 = require('../');
var SubscriptionNotice = _ref3.SubscriptionNotice;
var createProjectPrompt = _ref3.createProjectPrompt;
var _ref4 = glass.html.material, _ref5, createCalendarPrompt = function (_ref6) {
        var title = _ref6.title;
        var name = _ref6.name;
        var callback = _ref6.callback;
        createProjectPrompt({
            title: title,
            name: name,
            callback: callback,
            properties: { type: ProjectType.Calendar.id }
        });
    };
var ConfirmDialog = _ref4.ConfirmDialog;
var AlertDialog = _ref4.AlertDialog;
_ref5 = glass.data;
var Key = _ref5.Key;
var DeleteButton = ion.template(function (_ref7) {
        return ion.createRuntime({
            type: 'Template',
            id: null,
            body: [
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'dataTableModel',
                                loc: {
                                    start: {
                                        line: 18,
                                        column: 32,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                    },
                                    end: {
                                        line: 18,
                                        column: 46,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'MemberExpression',
                                object: {
                                    type: 'Identifier',
                                    name: '_ref7'
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'dataTableModel',
                                    loc: {
                                        start: {
                                            line: 18,
                                            column: 32,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                        },
                                        end: {
                                            line: 18,
                                            column: 46,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                        }
                                    }
                                },
                                computed: false
                            }
                        }],
                    kind: 'let',
                    order: '0'
                },
                {
                    type: 'ReturnStatement',
                    argument: {
                        type: 'ObjectExpression',
                        objectType: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'PaperIconButton',
                                loc: {
                                    start: {
                                        line: 19,
                                        column: 11,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                    },
                                    end: {
                                        line: 19,
                                        column: 26,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                    }
                                }
                            },
                            arguments: [],
                            loc: {
                                start: {
                                    line: 19,
                                    column: 11,
                                    fixed: true,
                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                },
                                end: {
                                    line: 19,
                                    column: 28,
                                    fixed: true,
                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                }
                            }
                        },
                        properties: [
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'icon',
                                    loc: {
                                        start: {
                                            line: 20,
                                            column: 8,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                        },
                                        end: {
                                            line: 20,
                                            column: 12,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'Literal',
                                    value: 'delete'
                                },
                                kind: 'init',
                                order: '0'
                            },
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'title',
                                    loc: {
                                        start: {
                                            line: 21,
                                            column: 8,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                        },
                                        end: {
                                            line: 21,
                                            column: 13,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'Literal',
                                    value: 'Permanently delete this project.'
                                },
                                kind: 'init',
                                order: '1'
                            },
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'disabled',
                                    loc: {
                                        start: {
                                            line: 22,
                                            column: 8,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                        },
                                        end: {
                                            line: 22,
                                            column: 16,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'BinaryExpression',
                                    operator: '!==',
                                    left: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'dataTableModel',
                                                loc: {
                                                    start: {
                                                        line: 22,
                                                        column: 18,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                    },
                                                    end: {
                                                        line: 22,
                                                        column: 32,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'selectedRows',
                                                loc: {
                                                    start: {
                                                        line: 22,
                                                        column: 33,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                    },
                                                    end: {
                                                        line: 22,
                                                        column: 45,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 22,
                                                    column: 18,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                },
                                                end: {
                                                    line: 22,
                                                    column: 45,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'length',
                                            loc: {
                                                start: {
                                                    line: 22,
                                                    column: 46,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                },
                                                end: {
                                                    line: 22,
                                                    column: 52,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 22,
                                                column: 18,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                            },
                                            end: {
                                                line: 22,
                                                column: 52,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                            }
                                        }
                                    },
                                    right: {
                                        type: 'Literal',
                                        value: 1
                                    }
                                },
                                kind: 'init',
                                order: '2'
                            },
                            {
                                type: 'ExpressionStatement',
                                expression: {
                                    type: 'Function',
                                    context: true,
                                    value: function (_context) {
                                        return function click(e) {
                                            var dataTableModel = _context.get('dataTableModel'), Key = _context.get('Key'), Task = _context.get('Task'), AlertDialog = _context.get('AlertDialog'), ConfirmDialog = _context.get('ConfirmDialog');
                                            var row = dataTableModel.selectedRows[0];
                                            var project = row.record;
                                            var projectTasksKey = new Key(project.getKey(), Task, { limit: 1 });
                                            global.model.server.source.read(projectTasksKey, { cached: false }, function (tasks) {
                                                if (Object.keys(tasks).length > 0) {
                                                    AlertDialog.show({ text: 'You must delete all tasks before deleting this project.' });
                                                } else {
                                                    ConfirmDialog({
                                                        text: 'Permanently delete \'' + project.name + '\'?',
                                                        confirmText: 'Delete',
                                                        callback: function (confirmed) {
                                                            if (confirmed) {
                                                                dataTableModel.deleteSelectedRows();
                                                            }
                                                        }
                                                    });
                                                }
                                            });
                                        };
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 23,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                    },
                                    end: {
                                        line: 46,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                    }
                                },
                                order: '3'
                            }
                        ]
                    },
                    order: '1'
                }
            ],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'DeleteButton',
                loc: {
                    start: {
                        line: 18,
                        column: 6,
                        fixed: true,
                        source: 'viewpath/html/panes/ProjectsPane.ion'
                    },
                    end: {
                        line: 18,
                        column: 18,
                        fixed: true,
                        source: 'viewpath/html/panes/ProjectsPane.ion'
                    }
                }
            }
        }, {
            this: this,
            _ref7: _ref7,
            glass: glass,
            viewpath: viewpath,
            _ref: _ref,
            _ref2: _ref2,
            _ref3: _ref3,
            Project: Project,
            ProjectType: ProjectType,
            Task: Task,
            GenericTypePane: GenericTypePane,
            SubscriptionNotice: SubscriptionNotice,
            createProjectPrompt: createProjectPrompt,
            _ref4: _ref4,
            _ref5: _ref5,
            createCalendarPrompt: createCalendarPrompt,
            ConfirmDialog: ConfirmDialog,
            AlertDialog: AlertDialog,
            Key: Key,
            DeleteButton: DeleteButton
        }, null);
    });
module.exports = exports = ion.template(function (urlConfig) {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'subNotice',
                            loc: {
                                start: {
                                    line: 47,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                },
                                end: {
                                    line: 47,
                                    column: 17,
                                    fixed: true,
                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'SubscriptionNotice',
                                loc: {
                                    start: {
                                        line: 47,
                                        column: 20,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                    },
                                    end: {
                                        line: 47,
                                        column: 38,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'Literal',
                                    value: 'create and manage projects'
                                }],
                            loc: {
                                start: {
                                    line: 47,
                                    column: 20,
                                    fixed: true,
                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                },
                                end: {
                                    line: 47,
                                    column: 68,
                                    fixed: true,
                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'IfStatement',
                test: {
                    type: 'UnaryExpression',
                    operator: '?',
                    argument: {
                        type: 'Identifier',
                        name: 'subNotice',
                        loc: {
                            start: {
                                line: 48,
                                column: 7,
                                fixed: true,
                                source: 'viewpath/html/panes/ProjectsPane.ion'
                            },
                            end: {
                                line: 48,
                                column: 16,
                                fixed: true,
                                source: 'viewpath/html/panes/ProjectsPane.ion'
                            }
                        }
                    }
                },
                consequent: {
                    type: 'BlockStatement',
                    body: [{
                            type: 'ReturnStatement',
                            argument: {
                                type: 'Identifier',
                                name: 'subNotice',
                                loc: {
                                    start: {
                                        line: 49,
                                        column: 15,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                    },
                                    end: {
                                        line: 49,
                                        column: 24,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                    }
                                }
                            },
                            order: '0'
                        }]
                },
                alternate: {
                    type: 'BlockStatement',
                    body: [
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: '_ref8'
                                    },
                                    init: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'global',
                                            loc: {
                                                start: {
                                                    line: 52,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                },
                                                end: {
                                                    line: 52,
                                                    column: 27,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'model',
                                            loc: {
                                                start: {
                                                    line: 52,
                                                    column: 28,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                },
                                                end: {
                                                    line: 52,
                                                    column: 33,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 52,
                                                column: 21,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                            },
                                            end: {
                                                line: 52,
                                                column: 33,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '0'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'user',
                                        loc: {
                                            start: {
                                                line: 52,
                                                column: 13,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                            },
                                            end: {
                                                line: 52,
                                                column: 17,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'MemberExpression',
                                        object: {
                                            type: 'Identifier',
                                            name: '_ref8'
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'user',
                                            loc: {
                                                start: {
                                                    line: 52,
                                                    column: 13,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                },
                                                end: {
                                                    line: 52,
                                                    column: 17,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                }
                                            }
                                        },
                                        computed: false
                                    }
                                }],
                            kind: 'let',
                            order: '1'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'userKey',
                                        loc: {
                                            start: {
                                                line: 53,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                            },
                                            end: {
                                                line: 53,
                                                column: 19,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'user',
                                            loc: {
                                                start: {
                                                    line: 53,
                                                    column: 22,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                },
                                                end: {
                                                    line: 53,
                                                    column: 26,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'key',
                                            loc: {
                                                start: {
                                                    line: 53,
                                                    column: 27,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                },
                                                end: {
                                                    line: 53,
                                                    column: 30,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 53,
                                                column: 22,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                            },
                                            end: {
                                                line: 53,
                                                column: 30,
                                                fixed: true,
                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '2'
                        },
                        {
                            type: 'ReturnStatement',
                            argument: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'GenericTypePane',
                                    loc: {
                                        start: {
                                            line: 54,
                                            column: 15,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                        },
                                        end: {
                                            line: 54,
                                            column: 30,
                                            fixed: true,
                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                        }
                                    }
                                },
                                arguments: [{
                                        type: 'ObjectExpression',
                                        objectType: {
                                            type: 'ObjectExpression',
                                            properties: []
                                        },
                                        properties: [
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'id',
                                                    loc: {
                                                        start: {
                                                            line: 56,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                        },
                                                        end: {
                                                            line: 56,
                                                            column: 18,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: 'projects'
                                                },
                                                kind: 'init',
                                                order: '0'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'name',
                                                    loc: {
                                                        start: {
                                                            line: 57,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                        },
                                                        end: {
                                                            line: 57,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: 'Projects'
                                                },
                                                kind: 'init',
                                                order: '1'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'type',
                                                    loc: {
                                                        start: {
                                                            line: 58,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                        },
                                                        end: {
                                                            line: 58,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Identifier',
                                                    name: 'Project',
                                                    loc: {
                                                        start: {
                                                            line: 58,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                        },
                                                        end: {
                                                            line: 58,
                                                            column: 29,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                        }
                                                    }
                                                },
                                                kind: 'init',
                                                order: '2'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'state',
                                                    loc: {
                                                        start: {
                                                            line: 59,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                        },
                                                        end: {
                                                            line: 59,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Identifier',
                                                    name: 'urlConfig',
                                                    loc: {
                                                        start: {
                                                            line: 59,
                                                            column: 23,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                        },
                                                        end: {
                                                            line: 59,
                                                            column: 32,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                        }
                                                    }
                                                },
                                                kind: 'init',
                                                order: '3'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'cut',
                                                    loc: {
                                                        start: {
                                                            line: 60,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                        },
                                                        end: {
                                                            line: 60,
                                                            column: 19,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: false
                                                },
                                                kind: 'init',
                                                order: '4'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'copy',
                                                    loc: {
                                                        start: {
                                                            line: 61,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                        },
                                                        end: {
                                                            line: 61,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: false
                                                },
                                                kind: 'init',
                                                order: '5'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'paste',
                                                    loc: {
                                                        start: {
                                                            line: 62,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                        },
                                                        end: {
                                                            line: 62,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'Literal',
                                                    value: false
                                                },
                                                kind: 'init',
                                                order: '6'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'delete',
                                                    loc: {
                                                        start: {
                                                            line: 63,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                        },
                                                        end: {
                                                            line: 63,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'ObjectExpression',
                                                    objectType: {
                                                        type: 'Literal',
                                                        value: false
                                                    },
                                                    properties: []
                                                },
                                                kind: 'init',
                                                order: '7'
                                            },
                                            {
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'tabs',
                                                    loc: {
                                                        start: {
                                                            line: 80,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                        },
                                                        end: {
                                                            line: 80,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'ObjectExpression',
                                                    objectType: {
                                                        type: 'ArrayExpression',
                                                        elements: []
                                                    },
                                                    properties: [
                                                        {
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'ObjectExpression',
                                                                objectType: {
                                                                    type: 'ObjectExpression',
                                                                    properties: [
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'id',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 81,
                                                                                        column: 21,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 81,
                                                                                        column: 23,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'projects'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'name',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 81,
                                                                                        column: 36,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 81,
                                                                                        column: 40,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'Active'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '1'
                                                                        }
                                                                    ]
                                                                },
                                                                properties: [
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'columns',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 82,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 82,
                                                                                    column: 31,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'ArrayExpression',
                                                                            elements: [
                                                                                {
                                                                                    type: 'Literal',
                                                                                    value: 'name'
                                                                                },
                                                                                {
                                                                                    type: 'Literal',
                                                                                    value: 'percent'
                                                                                },
                                                                                {
                                                                                    type: 'Literal',
                                                                                    value: 'orgKey'
                                                                                },
                                                                                {
                                                                                    type: 'Literal',
                                                                                    value: 'tags'
                                                                                },
                                                                                {
                                                                                    type: 'Literal',
                                                                                    value: 'calendars'
                                                                                },
                                                                                {
                                                                                    type: 'Literal',
                                                                                    value: 'created'
                                                                                },
                                                                                {
                                                                                    type: 'Literal',
                                                                                    value: 'updated'
                                                                                },
                                                                                {
                                                                                    type: 'Literal',
                                                                                    value: 'description'
                                                                                }
                                                                            ]
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    },
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'create',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 83,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 83,
                                                                                    column: 30,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'ObjectExpression',
                                                                            properties: [{
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'handler',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 84,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 84,
                                                                                                column: 35,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Function',
                                                                                        context: true,
                                                                                        value: function (_context2) {
                                                                                            return function () {
                                                                                                var ProjectType = _context2.get('ProjectType'), createProjectPrompt = _context2.get('createProjectPrompt');
                                                                                                var title = 'New Project';
                                                                                                var properties = {
                                                                                                        name: 'New Project',
                                                                                                        type: ProjectType.Project.id
                                                                                                    };
                                                                                                createProjectPrompt({
                                                                                                    title: title,
                                                                                                    properties: properties
                                                                                                });
                                                                                            };
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                }]
                                                                        },
                                                                        kind: 'init',
                                                                        order: '1'
                                                                    },
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'toolbar',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 90,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 90,
                                                                                    column: 31,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'ObjectExpression',
                                                                            properties: [{
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'center',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 91,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 91,
                                                                                                column: 34,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Identifier',
                                                                                        name: 'DeleteButton',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 91,
                                                                                                column: 36,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 91,
                                                                                                column: 48,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                }]
                                                                        },
                                                                        kind: 'init',
                                                                        order: '2'
                                                                    },
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'where',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 92,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 92,
                                                                                    column: 29,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'ObjectExpression',
                                                                            properties: [
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'sharingUserKeys',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 93,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 93,
                                                                                                column: 43,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Identifier',
                                                                                        name: 'userKey',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 93,
                                                                                                column: 45,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 93,
                                                                                                column: 52,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'type',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 94,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 94,
                                                                                                column: 32,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'MemberExpression',
                                                                                            computed: false,
                                                                                            object: {
                                                                                                type: 'Identifier',
                                                                                                name: 'ProjectType',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 94,
                                                                                                        column: 34,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 94,
                                                                                                        column: 45,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            property: {
                                                                                                type: 'Identifier',
                                                                                                name: 'Project',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 94,
                                                                                                        column: 46,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 94,
                                                                                                        column: 53,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 94,
                                                                                                    column: 34,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 94,
                                                                                                    column: 53,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'id',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 94,
                                                                                                    column: 54,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 94,
                                                                                                    column: 56,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 94,
                                                                                                column: 34,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 94,
                                                                                                column: 56,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '1'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'archived',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 95,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 95,
                                                                                                column: 36,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Literal',
                                                                                        value: false
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '2'
                                                                                }
                                                                            ]
                                                                        },
                                                                        kind: 'init',
                                                                        order: '3'
                                                                    },
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'sorts',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 96,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 96,
                                                                                    column: 29,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'ObjectExpression',
                                                                            objectType: {
                                                                                type: 'ArrayExpression',
                                                                                elements: []
                                                                            },
                                                                            properties: [{
                                                                                    type: 'ExpressionStatement',
                                                                                    expression: {
                                                                                        type: 'ArrayExpression',
                                                                                        elements: [{
                                                                                                type: 'ObjectExpression',
                                                                                                properties: [{
                                                                                                        type: 'Property',
                                                                                                        key: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'updated',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 97,
                                                                                                                    column: 30,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 97,
                                                                                                                    column: 37,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        value: {
                                                                                                            type: 'Literal',
                                                                                                            value: false
                                                                                                        },
                                                                                                        kind: 'init',
                                                                                                        order: '0'
                                                                                                    }]
                                                                                            }]
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 97,
                                                                                            column: 28,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 97,
                                                                                            column: 45,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                        }
                                                                                    },
                                                                                    order: '0'
                                                                                }]
                                                                        },
                                                                        kind: 'init',
                                                                        order: '4'
                                                                    },
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'timeline',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 98,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 98,
                                                                                    column: 32,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'ObjectExpression',
                                                                            objectType: {
                                                                                type: 'ObjectExpression',
                                                                                properties: []
                                                                            },
                                                                            properties: [{
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'columns',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 99,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 99,
                                                                                                column: 35,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'ArrayExpression',
                                                                                        elements: [
                                                                                            {
                                                                                                type: 'Literal',
                                                                                                value: 'name'
                                                                                            },
                                                                                            {
                                                                                                type: 'Literal',
                                                                                                value: 'orgKey'
                                                                                            },
                                                                                            {
                                                                                                type: 'Literal',
                                                                                                value: 'tags'
                                                                                            },
                                                                                            {
                                                                                                type: 'Literal',
                                                                                                value: 'calendars'
                                                                                            }
                                                                                        ]
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                }]
                                                                        },
                                                                        kind: 'init',
                                                                        order: '5'
                                                                    }
                                                                ]
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 81,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                },
                                                                end: {
                                                                    line: 100,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                }
                                                            },
                                                            order: '0'
                                                        },
                                                        {
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'ObjectExpression',
                                                                objectType: {
                                                                    type: 'ObjectExpression',
                                                                    properties: [
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'id',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 100,
                                                                                        column: 21,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 100,
                                                                                        column: 23,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'templates'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'name',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 100,
                                                                                        column: 37,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 100,
                                                                                        column: 41,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'Templates'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '1'
                                                                        }
                                                                    ]
                                                                },
                                                                properties: [
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'columns',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 101,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 101,
                                                                                    column: 31,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'ArrayExpression',
                                                                            elements: [
                                                                                {
                                                                                    type: 'Literal',
                                                                                    value: 'name'
                                                                                },
                                                                                {
                                                                                    type: 'Literal',
                                                                                    value: 'orgKey'
                                                                                },
                                                                                {
                                                                                    type: 'Literal',
                                                                                    value: 'tags'
                                                                                },
                                                                                {
                                                                                    type: 'Literal',
                                                                                    value: 'calendars'
                                                                                },
                                                                                {
                                                                                    type: 'Literal',
                                                                                    value: 'created'
                                                                                },
                                                                                {
                                                                                    type: 'Literal',
                                                                                    value: 'updated'
                                                                                },
                                                                                {
                                                                                    type: 'Literal',
                                                                                    value: 'description'
                                                                                }
                                                                            ]
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    },
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'create',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 102,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 102,
                                                                                    column: 30,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'ObjectExpression',
                                                                            properties: [{
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'handler',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 103,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 103,
                                                                                                column: 35,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Function',
                                                                                        context: true,
                                                                                        value: function (_context3) {
                                                                                            return function () {
                                                                                                var ProjectType = _context3.get('ProjectType'), createProjectPrompt = _context3.get('createProjectPrompt');
                                                                                                var title = 'New Template';
                                                                                                var properties = {
                                                                                                        name: 'New Template',
                                                                                                        type: ProjectType.Template.id
                                                                                                    };
                                                                                                createProjectPrompt({
                                                                                                    title: title,
                                                                                                    properties: properties
                                                                                                });
                                                                                            };
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                }]
                                                                        },
                                                                        kind: 'init',
                                                                        order: '1'
                                                                    },
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'toolbar',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 109,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 109,
                                                                                    column: 31,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'ObjectExpression',
                                                                            properties: [{
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'center',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 110,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 110,
                                                                                                column: 34,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Identifier',
                                                                                        name: 'DeleteButton',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 110,
                                                                                                column: 36,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 110,
                                                                                                column: 48,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                }]
                                                                        },
                                                                        kind: 'init',
                                                                        order: '2'
                                                                    },
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'where',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 111,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 111,
                                                                                    column: 29,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'ObjectExpression',
                                                                            properties: [
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'sharingUserKeys',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 112,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 112,
                                                                                                column: 43,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Identifier',
                                                                                        name: 'userKey',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 112,
                                                                                                column: 45,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 112,
                                                                                                column: 52,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'type',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 113,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 113,
                                                                                                column: 32,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'MemberExpression',
                                                                                            computed: false,
                                                                                            object: {
                                                                                                type: 'Identifier',
                                                                                                name: 'ProjectType',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 113,
                                                                                                        column: 34,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 113,
                                                                                                        column: 45,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            property: {
                                                                                                type: 'Identifier',
                                                                                                name: 'Template',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 113,
                                                                                                        column: 46,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 113,
                                                                                                        column: 54,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 113,
                                                                                                    column: 34,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 113,
                                                                                                    column: 54,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'id',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 113,
                                                                                                    column: 55,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 113,
                                                                                                    column: 57,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 113,
                                                                                                column: 34,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 113,
                                                                                                column: 57,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '1'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'archived',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 114,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 114,
                                                                                                column: 36,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Literal',
                                                                                        value: false
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '2'
                                                                                }
                                                                            ]
                                                                        },
                                                                        kind: 'init',
                                                                        order: '3'
                                                                    },
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'sorts',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 115,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 115,
                                                                                    column: 29,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'ObjectExpression',
                                                                            objectType: {
                                                                                type: 'ArrayExpression',
                                                                                elements: []
                                                                            },
                                                                            properties: [{
                                                                                    type: 'ExpressionStatement',
                                                                                    expression: {
                                                                                        type: 'ArrayExpression',
                                                                                        elements: [{
                                                                                                type: 'ObjectExpression',
                                                                                                properties: [{
                                                                                                        type: 'Property',
                                                                                                        key: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'name',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 116,
                                                                                                                    column: 30,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 116,
                                                                                                                    column: 34,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        value: {
                                                                                                            type: 'Literal',
                                                                                                            value: true
                                                                                                        },
                                                                                                        kind: 'init',
                                                                                                        order: '0'
                                                                                                    }]
                                                                                            }]
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 116,
                                                                                            column: 28,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 116,
                                                                                            column: 41,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                        }
                                                                                    },
                                                                                    order: '0'
                                                                                }]
                                                                        },
                                                                        kind: 'init',
                                                                        order: '4'
                                                                    }
                                                                ]
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 100,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                },
                                                                end: {
                                                                    line: 117,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                }
                                                            },
                                                            order: '1'
                                                        },
                                                        {
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'ObjectExpression',
                                                                objectType: {
                                                                    type: 'ObjectExpression',
                                                                    properties: [
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'id',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 117,
                                                                                        column: 21,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 117,
                                                                                        column: 23,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'calendar'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'name',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 117,
                                                                                        column: 36,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 117,
                                                                                        column: 40,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'Calendars'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '1'
                                                                        }
                                                                    ]
                                                                },
                                                                properties: [
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'properties',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 118,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 118,
                                                                                    column: 34,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'ObjectExpression',
                                                                            objectType: {
                                                                                type: 'ObjectExpression',
                                                                                properties: []
                                                                            },
                                                                            properties: [
                                                                                {
                                                                                    type: 'ForInStatement',
                                                                                    left: {
                                                                                        type: 'VariableDeclaration',
                                                                                        declarations: [
                                                                                            {
                                                                                                type: 'VariableDeclarator',
                                                                                                id: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'key',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 119,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 119,
                                                                                                            column: 35,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                init: null
                                                                                            },
                                                                                            {
                                                                                                type: 'VariableDeclarator',
                                                                                                id: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'value',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 119,
                                                                                                            column: 37,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 119,
                                                                                                            column: 42,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                init: null
                                                                                            }
                                                                                        ],
                                                                                        kind: 'let'
                                                                                    },
                                                                                    right: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'Identifier',
                                                                                            name: 'Project',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 119,
                                                                                                    column: 46,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 119,
                                                                                                    column: 53,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'properties',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 119,
                                                                                                    column: 54,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 119,
                                                                                                    column: 64,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 119,
                                                                                                column: 46,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 119,
                                                                                                column: 64,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    body: {
                                                                                        type: 'BlockStatement',
                                                                                        body: [{
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'key',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 120,
                                                                                                            column: 33,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 120,
                                                                                                            column: 36,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'value',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 120,
                                                                                                            column: 39,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 120,
                                                                                                            column: 44,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                kind: 'init',
                                                                                                computed: true,
                                                                                                order: '0'
                                                                                            }]
                                                                                    },
                                                                                    remove: null,
                                                                                    order: '0'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'default',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 121,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 121,
                                                                                                column: 35,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'ObjectExpression',
                                                                                        objectType: {
                                                                                            type: 'ObjectExpression',
                                                                                            properties: [
                                                                                                {
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'name',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 121,
                                                                                                                column: 38,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 121,
                                                                                                                column: 42,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'Literal',
                                                                                                        value: 'default'
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '0'
                                                                                                },
                                                                                                {
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'type',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 121,
                                                                                                                column: 54,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 121,
                                                                                                                column: 58,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'Literal',
                                                                                                        value: 'boolean'
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '1'
                                                                                                },
                                                                                                {
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'required',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 121,
                                                                                                                column: 70,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 121,
                                                                                                                column: 78,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'Literal',
                                                                                                        value: false
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '2'
                                                                                                }
                                                                                            ]
                                                                                        },
                                                                                        properties: [
                                                                                            {
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'get',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 122,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 122,
                                                                                                            column: 35,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'Function',
                                                                                                    context: false,
                                                                                                    value: function () {
                                                                                                        if (this.orgId != null) {
                                                                                                            return (model.orgs != null ? model.orgs[this.orgKey] != null ? model.orgs[this.orgKey].calendars != null ? model.orgs[this.orgKey].calendars[this.key] : void 0 : void 0 : void 0) != null;
                                                                                                        }
                                                                                                        return false;
                                                                                                    }
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '0'
                                                                                            },
                                                                                            {
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'set',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 126,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 126,
                                                                                                            column: 35,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'Function',
                                                                                                    context: false,
                                                                                                    value: function (value) {
                                                                                                        var org = model.orgs != null ? model.orgs[this.orgKey] : void 0;
                                                                                                        if (org != null) {
                                                                                                            org.calendars = org.calendars != null ? org.calendars : {};
                                                                                                            if (value) {
                                                                                                                org.calendars[this.key] = org.calendars[this.key] != null ? org.calendars[this.key] : {};
                                                                                                            } else {
                                                                                                                delete org.calendars[this.key];
                                                                                                            }
                                                                                                            this.touch();
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '1'
                                                                                            }
                                                                                        ]
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '1'
                                                                                }
                                                                            ]
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    },
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'columns',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 135,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 135,
                                                                                    column: 31,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'ArrayExpression',
                                                                            elements: [
                                                                                {
                                                                                    type: 'Literal',
                                                                                    value: 'name'
                                                                                },
                                                                                {
                                                                                    type: 'Literal',
                                                                                    value: 'orgKey'
                                                                                },
                                                                                {
                                                                                    type: 'Literal',
                                                                                    value: 'default'
                                                                                },
                                                                                {
                                                                                    type: 'Literal',
                                                                                    value: 'created'
                                                                                },
                                                                                {
                                                                                    type: 'Literal',
                                                                                    value: 'updated'
                                                                                },
                                                                                {
                                                                                    type: 'Literal',
                                                                                    value: 'description'
                                                                                }
                                                                            ]
                                                                        },
                                                                        kind: 'init',
                                                                        order: '1'
                                                                    },
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'toolbar',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 136,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 136,
                                                                                    column: 31,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'ObjectExpression',
                                                                            properties: [{
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'right',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 137,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 137,
                                                                                                column: 33,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Function',
                                                                                        context: true,
                                                                                        value: function (_ps) {
                                                                                            return ion.template(function (_ref9) {
                                                                                                return ion.createRuntime({
                                                                                                    type: 'Template',
                                                                                                    id: null,
                                                                                                    body: [
                                                                                                        {
                                                                                                            type: 'VariableDeclaration',
                                                                                                            declarations: [{
                                                                                                                    type: 'VariableDeclarator',
                                                                                                                    id: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'dataTable',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 137,
                                                                                                                                column: 46,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 137,
                                                                                                                                column: 55,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    init: {
                                                                                                                        type: 'MemberExpression',
                                                                                                                        object: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: '_ref9'
                                                                                                                        },
                                                                                                                        property: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'dataTable',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 137,
                                                                                                                                    column: 46,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 137,
                                                                                                                                    column: 55,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        computed: false
                                                                                                                    }
                                                                                                                }],
                                                                                                            kind: 'let',
                                                                                                            order: '0'
                                                                                                        },
                                                                                                        {
                                                                                                            type: 'VariableDeclaration',
                                                                                                            declarations: [{
                                                                                                                    type: 'VariableDeclarator',
                                                                                                                    id: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'dataTableModel',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 137,
                                                                                                                                column: 56,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 137,
                                                                                                                                column: 70,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    init: {
                                                                                                                        type: 'MemberExpression',
                                                                                                                        object: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: '_ref9'
                                                                                                                        },
                                                                                                                        property: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'dataTableModel',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 137,
                                                                                                                                    column: 56,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 137,
                                                                                                                                    column: 70,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        computed: false
                                                                                                                    }
                                                                                                                }],
                                                                                                            kind: 'let',
                                                                                                            order: '1'
                                                                                                        },
                                                                                                        {
                                                                                                            type: 'ReturnStatement',
                                                                                                            argument: {
                                                                                                                type: 'ObjectExpression',
                                                                                                                objectType: {
                                                                                                                    type: 'CallExpression',
                                                                                                                    callee: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'PaperMenuButton',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 138,
                                                                                                                                column: 39,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 138,
                                                                                                                                column: 54,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    arguments: [],
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 138,
                                                                                                                            column: 39,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 138,
                                                                                                                            column: 56,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                properties: [
                                                                                                                    {
                                                                                                                        type: 'Property',
                                                                                                                        key: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'closeOnActivate',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 139,
                                                                                                                                    column: 36,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 139,
                                                                                                                                    column: 51,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        value: {
                                                                                                                            type: 'Literal',
                                                                                                                            value: true
                                                                                                                        },
                                                                                                                        kind: 'init',
                                                                                                                        order: '0'
                                                                                                                    },
                                                                                                                    {
                                                                                                                        type: 'Property',
                                                                                                                        key: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'restoreFocusOnClose',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 140,
                                                                                                                                    column: 36,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 140,
                                                                                                                                    column: 55,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        value: {
                                                                                                                            type: 'Literal',
                                                                                                                            value: false
                                                                                                                        },
                                                                                                                        kind: 'init',
                                                                                                                        order: '1'
                                                                                                                    },
                                                                                                                    {
                                                                                                                        type: 'Property',
                                                                                                                        key: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'horizontalAlign',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 141,
                                                                                                                                    column: 36,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 141,
                                                                                                                                    column: 51,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        value: {
                                                                                                                            type: 'Literal',
                                                                                                                            value: 'right'
                                                                                                                        },
                                                                                                                        kind: 'init',
                                                                                                                        order: '2'
                                                                                                                    },
                                                                                                                    {
                                                                                                                        type: 'ExpressionStatement',
                                                                                                                        expression: {
                                                                                                                            type: 'ObjectExpression',
                                                                                                                            objectType: {
                                                                                                                                type: 'CallExpression',
                                                                                                                                callee: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'PaperIconButton',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 142,
                                                                                                                                            column: 36,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 142,
                                                                                                                                            column: 51,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                arguments: [{
                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                        properties: [{
                                                                                                                                                type: 'Property',
                                                                                                                                                key: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'class',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 142,
                                                                                                                                                            column: 53,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 142,
                                                                                                                                                            column: 58,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                value: {
                                                                                                                                                    type: 'Literal',
                                                                                                                                                    value: 'dropdown-trigger'
                                                                                                                                                },
                                                                                                                                                kind: 'init',
                                                                                                                                                order: '0'
                                                                                                                                            }]
                                                                                                                                    }],
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 142,
                                                                                                                                        column: 36,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 142,
                                                                                                                                        column: 79,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            properties: [{
                                                                                                                                    type: 'Property',
                                                                                                                                    key: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'icon',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 143,
                                                                                                                                                column: 40,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 143,
                                                                                                                                                column: 44,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    value: {
                                                                                                                                        type: 'Literal',
                                                                                                                                        value: 'more-vert'
                                                                                                                                    },
                                                                                                                                    kind: 'init',
                                                                                                                                    order: '0'
                                                                                                                                }]
                                                                                                                        },
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 142,
                                                                                                                                column: 36,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 144,
                                                                                                                                column: 40,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                            }
                                                                                                                        },
                                                                                                                        order: '3'
                                                                                                                    },
                                                                                                                    {
                                                                                                                        type: 'ExpressionStatement',
                                                                                                                        expression: {
                                                                                                                            type: 'ObjectExpression',
                                                                                                                            objectType: {
                                                                                                                                type: 'CallExpression',
                                                                                                                                callee: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'PaperMenu',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 144,
                                                                                                                                            column: 36,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 144,
                                                                                                                                            column: 45,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                arguments: [{
                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                        properties: [{
                                                                                                                                                type: 'Property',
                                                                                                                                                key: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'class',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 144,
                                                                                                                                                            column: 47,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 144,
                                                                                                                                                            column: 52,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                value: {
                                                                                                                                                    type: 'Literal',
                                                                                                                                                    value: 'dropdown-content'
                                                                                                                                                },
                                                                                                                                                kind: 'init',
                                                                                                                                                order: '0'
                                                                                                                                            }]
                                                                                                                                    }],
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 144,
                                                                                                                                        column: 36,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 144,
                                                                                                                                        column: 73,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            properties: [
                                                                                                                                {
                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                    expression: {
                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                        objectType: {
                                                                                                                                            type: 'CallExpression',
                                                                                                                                            callee: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'PaperIconItem',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 145,
                                                                                                                                                        column: 40,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 145,
                                                                                                                                                        column: 53,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            arguments: [],
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 145,
                                                                                                                                                    column: 40,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 145,
                                                                                                                                                    column: 55,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        properties: [
                                                                                                                                            {
                                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                                expression: {
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    objectType: {
                                                                                                                                                        type: 'CallExpression',
                                                                                                                                                        callee: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'IronIcon',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 146,
                                                                                                                                                                    column: 44,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 146,
                                                                                                                                                                    column: 52,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        arguments: [{
                                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                                properties: [{
                                                                                                                                                                        type: 'Property',
                                                                                                                                                                        key: {
                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                            value: 'item-icon'
                                                                                                                                                                        },
                                                                                                                                                                        value: {
                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                            value: true
                                                                                                                                                                        },
                                                                                                                                                                        kind: 'init',
                                                                                                                                                                        order: '0'
                                                                                                                                                                    }]
                                                                                                                                                            }],
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 146,
                                                                                                                                                                column: 44,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 146,
                                                                                                                                                                column: 72,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    properties: [{
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'icon',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 147,
                                                                                                                                                                        column: 48,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 147,
                                                                                                                                                                        column: 52,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: 'date-range'
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '0'
                                                                                                                                                        }]
                                                                                                                                                },
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 146,
                                                                                                                                                        column: 44,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 148,
                                                                                                                                                        column: 48,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                order: '0'
                                                                                                                                            },
                                                                                                                                            {
                                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                                expression: {
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    objectType: {
                                                                                                                                                        type: 'CallExpression',
                                                                                                                                                        callee: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'Span',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 148,
                                                                                                                                                                    column: 44,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 148,
                                                                                                                                                                    column: 48,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        arguments: [],
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 148,
                                                                                                                                                                column: 44,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 148,
                                                                                                                                                                column: 50,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    properties: [{
                                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                                            expression: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: 'Add standard work week'
                                                                                                                                                            },
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 149,
                                                                                                                                                                    column: 48,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 149,
                                                                                                                                                                    column: 72,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            order: '0'
                                                                                                                                                        }]
                                                                                                                                                },
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 148,
                                                                                                                                                        column: 44,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 150,
                                                                                                                                                        column: 48,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                order: '1'
                                                                                                                                            },
                                                                                                                                            {
                                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                                expression: {
                                                                                                                                                    type: 'Function',
                                                                                                                                                    context: true,
                                                                                                                                                    value: function (_context4) {
                                                                                                                                                        return function click() {
                                                                                                                                                            var createCalendarPrompt = _context4.get('createCalendarPrompt'), ion = _context4.get('ion');
                                                                                                                                                            createCalendarPrompt({
                                                                                                                                                                title: 'Add standard work week',
                                                                                                                                                                name: 'Standard Work Week',
                                                                                                                                                                callback: function (project) {
                                                                                                                                                                    global.model.addStandardWorkWeek(project, function () {
                                                                                                                                                                        ion.sync();
                                                                                                                                                                        model.open(project.paneConfig);
                                                                                                                                                                    });
                                                                                                                                                                }
                                                                                                                                                            });
                                                                                                                                                        };
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 150,
                                                                                                                                                        column: 44,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 162,
                                                                                                                                                        column: 48,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                order: '2'
                                                                                                                                            }
                                                                                                                                        ]
                                                                                                                                    },
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 145,
                                                                                                                                            column: 40,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 162,
                                                                                                                                            column: 44,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    order: '0'
                                                                                                                                },
                                                                                                                                {
                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                    expression: {
                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                        objectType: {
                                                                                                                                            type: 'CallExpression',
                                                                                                                                            callee: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'PaperIconItem',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 162,
                                                                                                                                                        column: 40,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 162,
                                                                                                                                                        column: 53,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            arguments: [],
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 162,
                                                                                                                                                    column: 40,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 162,
                                                                                                                                                    column: 55,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        properties: [
                                                                                                                                            {
                                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                                expression: {
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    objectType: {
                                                                                                                                                        type: 'CallExpression',
                                                                                                                                                        callee: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'IronIcon',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 163,
                                                                                                                                                                    column: 44,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 163,
                                                                                                                                                                    column: 52,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        arguments: [{
                                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                                properties: [{
                                                                                                                                                                        type: 'Property',
                                                                                                                                                                        key: {
                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                            value: 'item-icon'
                                                                                                                                                                        },
                                                                                                                                                                        value: {
                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                            value: true
                                                                                                                                                                        },
                                                                                                                                                                        kind: 'init',
                                                                                                                                                                        order: '0'
                                                                                                                                                                    }]
                                                                                                                                                            }],
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 163,
                                                                                                                                                                column: 44,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 163,
                                                                                                                                                                column: 72,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    properties: [{
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'icon',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 164,
                                                                                                                                                                        column: 48,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 164,
                                                                                                                                                                        column: 52,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: 'date-range'
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '0'
                                                                                                                                                        }]
                                                                                                                                                },
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 163,
                                                                                                                                                        column: 44,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 165,
                                                                                                                                                        column: 48,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                order: '0'
                                                                                                                                            },
                                                                                                                                            {
                                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                                expression: {
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    objectType: {
                                                                                                                                                        type: 'CallExpression',
                                                                                                                                                        callee: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'Span',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 165,
                                                                                                                                                                    column: 44,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 165,
                                                                                                                                                                    column: 48,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        arguments: [],
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 165,
                                                                                                                                                                column: 44,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 165,
                                                                                                                                                                column: 50,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    properties: [{
                                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                                            expression: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: 'Add US holidays'
                                                                                                                                                            },
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 166,
                                                                                                                                                                    column: 48,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 166,
                                                                                                                                                                    column: 65,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            order: '0'
                                                                                                                                                        }]
                                                                                                                                                },
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 165,
                                                                                                                                                        column: 44,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 167,
                                                                                                                                                        column: 48,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                order: '1'
                                                                                                                                            },
                                                                                                                                            {
                                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                                expression: {
                                                                                                                                                    type: 'Function',
                                                                                                                                                    context: true,
                                                                                                                                                    value: function (_context5) {
                                                                                                                                                        return function click() {
                                                                                                                                                            var createCalendarPrompt = _context5.get('createCalendarPrompt'), ion = _context5.get('ion');
                                                                                                                                                            createCalendarPrompt({
                                                                                                                                                                title: 'Add US holidays',
                                                                                                                                                                name: 'US Holidays',
                                                                                                                                                                callback: function (project) {
                                                                                                                                                                    global.model.addUSHolidays(project, function () {
                                                                                                                                                                        ion.sync();
                                                                                                                                                                        model.open(project.paneConfig);
                                                                                                                                                                    });
                                                                                                                                                                }
                                                                                                                                                            });
                                                                                                                                                        };
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 167,
                                                                                                                                                        column: 44,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 179,
                                                                                                                                                        column: 48,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                order: '2'
                                                                                                                                            }
                                                                                                                                        ]
                                                                                                                                    },
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 162,
                                                                                                                                            column: 40,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 179,
                                                                                                                                            column: 44,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    order: '1'
                                                                                                                                }
                                                                                                                            ]
                                                                                                                        },
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 144,
                                                                                                                                column: 36,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 179,
                                                                                                                                column: 40,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                            }
                                                                                                                        },
                                                                                                                        order: '4'
                                                                                                                    }
                                                                                                                ]
                                                                                                            },
                                                                                                            order: '2'
                                                                                                        }
                                                                                                    ],
                                                                                                    bound: false,
                                                                                                    name: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'right',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 137,
                                                                                                                column: 28,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 137,
                                                                                                                column: 33,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    scope: {
                                                                                                        type: 'Identifier',
                                                                                                        name: '_ps'
                                                                                                    }
                                                                                                }, {
                                                                                                    this: this,
                                                                                                    ion: ion,
                                                                                                    _ref9: _ref9,
                                                                                                    _ps: _ps,
                                                                                                    urlConfig: urlConfig,
                                                                                                    glass: glass,
                                                                                                    viewpath: viewpath,
                                                                                                    _ref: _ref,
                                                                                                    _ref2: _ref2,
                                                                                                    _ref3: _ref3,
                                                                                                    Project: Project,
                                                                                                    ProjectType: ProjectType,
                                                                                                    Task: Task,
                                                                                                    GenericTypePane: GenericTypePane,
                                                                                                    SubscriptionNotice: SubscriptionNotice,
                                                                                                    createProjectPrompt: createProjectPrompt,
                                                                                                    _ref4: _ref4,
                                                                                                    _ref5: _ref5,
                                                                                                    createCalendarPrompt: createCalendarPrompt,
                                                                                                    ConfirmDialog: ConfirmDialog,
                                                                                                    AlertDialog: AlertDialog,
                                                                                                    Key: Key,
                                                                                                    DeleteButton: DeleteButton
                                                                                                }, _ps);
                                                                                            });
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                }]
                                                                        },
                                                                        kind: 'init',
                                                                        order: '2'
                                                                    },
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'create',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 179,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 179,
                                                                                    column: 30,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'ObjectExpression',
                                                                            properties: [{
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'handler',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 180,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 180,
                                                                                                column: 35,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Function',
                                                                                        context: true,
                                                                                        value: function (_context6) {
                                                                                            return function (_ref10) {
                                                                                                var ProjectType = _context6.get('ProjectType'), createProjectPrompt = _context6.get('createProjectPrompt');
                                                                                                var e = _ref10.e;
                                                                                                var dataTableModel = _ref10.dataTableModel;
                                                                                                var dataTable = _ref10.dataTable;
                                                                                                var title = 'New Calendar';
                                                                                                var properties = {
                                                                                                        name: 'New Calendar',
                                                                                                        type: ProjectType.Calendar.id
                                                                                                    };
                                                                                                createProjectPrompt({
                                                                                                    e: e,
                                                                                                    dataTable: dataTable,
                                                                                                    dataTableModel: dataTableModel,
                                                                                                    title: title,
                                                                                                    properties: properties
                                                                                                });
                                                                                            };
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                }]
                                                                        },
                                                                        kind: 'init',
                                                                        order: '3'
                                                                    },
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'toolbar',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 186,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 186,
                                                                                    column: 31,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'ObjectExpression',
                                                                            properties: [{
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'center',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 187,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 187,
                                                                                                column: 34,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Identifier',
                                                                                        name: 'DeleteButton',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 187,
                                                                                                column: 36,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 187,
                                                                                                column: 48,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                }]
                                                                        },
                                                                        kind: 'init',
                                                                        order: '4'
                                                                    },
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'where',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 188,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 188,
                                                                                    column: 29,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'ObjectExpression',
                                                                            properties: [
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'sharingUserKeys',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 189,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 189,
                                                                                                column: 43,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Identifier',
                                                                                        name: 'userKey',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 189,
                                                                                                column: 45,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 189,
                                                                                                column: 52,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'type',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 190,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 190,
                                                                                                column: 32,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'MemberExpression',
                                                                                        computed: false,
                                                                                        object: {
                                                                                            type: 'MemberExpression',
                                                                                            computed: false,
                                                                                            object: {
                                                                                                type: 'Identifier',
                                                                                                name: 'ProjectType',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 190,
                                                                                                        column: 34,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 190,
                                                                                                        column: 45,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            property: {
                                                                                                type: 'Identifier',
                                                                                                name: 'Calendar',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 190,
                                                                                                        column: 46,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 190,
                                                                                                        column: 54,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 190,
                                                                                                    column: 34,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 190,
                                                                                                    column: 54,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        property: {
                                                                                            type: 'Identifier',
                                                                                            name: 'id',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 190,
                                                                                                    column: 55,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 190,
                                                                                                    column: 57,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 190,
                                                                                                column: 34,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 190,
                                                                                                column: 57,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '1'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'archived',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 191,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 191,
                                                                                                column: 36,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Literal',
                                                                                        value: false
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '2'
                                                                                }
                                                                            ]
                                                                        },
                                                                        kind: 'init',
                                                                        order: '5'
                                                                    },
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'sorts',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 192,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 192,
                                                                                    column: 29,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'ObjectExpression',
                                                                            objectType: {
                                                                                type: 'ArrayExpression',
                                                                                elements: []
                                                                            },
                                                                            properties: [{
                                                                                    type: 'ExpressionStatement',
                                                                                    expression: {
                                                                                        type: 'ArrayExpression',
                                                                                        elements: [{
                                                                                                type: 'ObjectExpression',
                                                                                                properties: [{
                                                                                                        type: 'Property',
                                                                                                        key: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'name',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 193,
                                                                                                                    column: 30,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 193,
                                                                                                                    column: 34,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        value: {
                                                                                                            type: 'Literal',
                                                                                                            value: true
                                                                                                        },
                                                                                                        kind: 'init',
                                                                                                        order: '0'
                                                                                                    }]
                                                                                            }]
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 193,
                                                                                            column: 28,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 193,
                                                                                            column: 41,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                        }
                                                                                    },
                                                                                    order: '0'
                                                                                }]
                                                                        },
                                                                        kind: 'init',
                                                                        order: '6'
                                                                    },
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'timeline',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 194,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 194,
                                                                                    column: 32,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'ObjectExpression',
                                                                            objectType: {
                                                                                type: 'ObjectExpression',
                                                                                properties: []
                                                                            },
                                                                            properties: [{
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'columns',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 195,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 195,
                                                                                                column: 35,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'ArrayExpression',
                                                                                        elements: [
                                                                                            {
                                                                                                type: 'Literal',
                                                                                                value: 'name'
                                                                                            },
                                                                                            {
                                                                                                type: 'Literal',
                                                                                                value: 'orgKey'
                                                                                            },
                                                                                            {
                                                                                                type: 'Literal',
                                                                                                value: 'default'
                                                                                            }
                                                                                        ]
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                }]
                                                                        },
                                                                        kind: 'init',
                                                                        order: '7'
                                                                    }
                                                                ]
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 117,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                },
                                                                end: {
                                                                    line: 196,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                }
                                                            },
                                                            order: '2'
                                                        },
                                                        {
                                                            type: 'ExpressionStatement',
                                                            expression: {
                                                                type: 'ObjectExpression',
                                                                objectType: {
                                                                    type: 'ObjectExpression',
                                                                    properties: [
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'id',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 196,
                                                                                        column: 21,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 196,
                                                                                        column: 23,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'archives'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'name',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 196,
                                                                                        column: 36,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 196,
                                                                                        column: 40,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'Archived'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '1'
                                                                        }
                                                                    ]
                                                                },
                                                                properties: [
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'columns',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 197,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 197,
                                                                                    column: 31,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'ArrayExpression',
                                                                            elements: [
                                                                                {
                                                                                    type: 'Literal',
                                                                                    value: 'name'
                                                                                },
                                                                                {
                                                                                    type: 'Literal',
                                                                                    value: 'orgKey'
                                                                                },
                                                                                {
                                                                                    type: 'Literal',
                                                                                    value: 'type'
                                                                                },
                                                                                {
                                                                                    type: 'Literal',
                                                                                    value: 'created'
                                                                                },
                                                                                {
                                                                                    type: 'Literal',
                                                                                    value: 'updated'
                                                                                },
                                                                                {
                                                                                    type: 'Literal',
                                                                                    value: 'description'
                                                                                }
                                                                            ]
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    },
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'toolbar',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 198,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 198,
                                                                                    column: 31,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'ObjectExpression',
                                                                            properties: [{
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'center',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 199,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 199,
                                                                                                column: 34,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Identifier',
                                                                                        name: 'DeleteButton',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 199,
                                                                                                column: 36,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 199,
                                                                                                column: 48,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                }]
                                                                        },
                                                                        kind: 'init',
                                                                        order: '1'
                                                                    },
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'where',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 200,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 200,
                                                                                    column: 29,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'ObjectExpression',
                                                                            properties: [
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'sharingUserKeys',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 201,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 201,
                                                                                                column: 43,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Identifier',
                                                                                        name: 'userKey',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 201,
                                                                                                column: 45,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 201,
                                                                                                column: 52,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'archived',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 202,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 202,
                                                                                                column: 36,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Literal',
                                                                                        value: true
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '1'
                                                                                }
                                                                            ]
                                                                        },
                                                                        kind: 'init',
                                                                        order: '2'
                                                                    },
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'sorts',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 203,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 203,
                                                                                    column: 29,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'ObjectExpression',
                                                                            objectType: {
                                                                                type: 'ArrayExpression',
                                                                                elements: []
                                                                            },
                                                                            properties: [{
                                                                                    type: 'ExpressionStatement',
                                                                                    expression: {
                                                                                        type: 'ArrayExpression',
                                                                                        elements: [{
                                                                                                type: 'ObjectExpression',
                                                                                                properties: [{
                                                                                                        type: 'Property',
                                                                                                        key: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'updated',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 204,
                                                                                                                    column: 30,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 204,
                                                                                                                    column: 37,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        value: {
                                                                                                            type: 'Literal',
                                                                                                            value: false
                                                                                                        },
                                                                                                        kind: 'init',
                                                                                                        order: '0'
                                                                                                    }]
                                                                                            }]
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 204,
                                                                                            column: 28,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 204,
                                                                                            column: 45,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                                        }
                                                                                    },
                                                                                    order: '0'
                                                                                }]
                                                                        },
                                                                        kind: 'init',
                                                                        order: '3'
                                                                    }
                                                                ]
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 196,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                },
                                                                end: {
                                                                    line: 205,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/ProjectsPane.ion'
                                                                }
                                                            },
                                                            order: '3'
                                                        }
                                                    ]
                                                },
                                                kind: 'init',
                                                order: '8'
                                            }
                                        ]
                                    }],
                                loc: {
                                    start: {
                                        line: 54,
                                        column: 15,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                    },
                                    end: {
                                        line: 205,
                                        column: 9,
                                        fixed: true,
                                        source: 'viewpath/html/panes/ProjectsPane.ion'
                                    }
                                }
                            },
                            order: '3'
                        }
                    ]
                },
                order: '1'
            }
        ],
        bound: false
    }, {
        this: this,
        ion: ion,
        urlConfig: urlConfig,
        glass: glass,
        viewpath: viewpath,
        _ref: _ref,
        _ref2: _ref2,
        _ref3: _ref3,
        Project: Project,
        ProjectType: ProjectType,
        Task: Task,
        GenericTypePane: GenericTypePane,
        SubscriptionNotice: SubscriptionNotice,
        createProjectPrompt: createProjectPrompt,
        _ref4: _ref4,
        _ref5: _ref5,
        createCalendarPrompt: createCalendarPrompt,
        ConfirmDialog: ConfirmDialog,
        AlertDialog: AlertDialog,
        Key: Key,
        DeleteButton: DeleteButton
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/panes/ProjectsPane',_viewpath_html_panes_ProjectsPane_);
    else
      _viewpath_html_panes_ProjectsPane_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_panes_ProjectsPane_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_panes_SubscriptionPane_ = function(module,exports,require){'use strict';
var ion = require('ion');
var glass = require('glass'), _ref, viewpath = require('../../'), _ref2, _ref3, _ref4, getUserSearchKeys = function (task, text) {
    }, userSearchKeys = function (text, user) {
        var results = new Set();
        {
            var _ref8 = user.acceptedOrgIds;
            for (var _i = 0; _i < _ref8.length; _i++) {
                var orgId = _ref8[_i];
                {
                    var _ref9 = User.getSearchKeys({
                            text: text,
                            orgId: orgId
                        });
                    for (var _i2 = 0; _i2 < _ref9.length; _i2++) {
                        var key = _ref9[_i2];
                        results.add(key);
                    }
                }
            }
        }
        if (text.indexOf('@') > 0) {
            results.add(new Key(User, { where: { email: text } }).toString());
            results.add(new Key(User, text.toLowerCase()));
        }
        if (text === '') {
            results.add(user.key);
        }
        return Array.from(results);
    };
_ref = glass.data;
var Key = _ref.Key;
_ref2 = glass.html.material;
var AlertDialog = _ref2.AlertDialog;
var PromptDialog = _ref2.PromptDialog;
_ref3 = viewpath.model;
var Subscription = _ref3.Subscription;
var User = _ref3.User;
_ref4 = require('./');
var GenericTypeView = _ref4.GenericTypeView;
var addUsersPrompt = function (_ref5) {
    var user = _ref5.user;
    var productName = _ref5.productName;
    var subKey = _ref5.subKey;
    var dataTableModel = _ref5.dataTableModel;
    PromptDialog.show({
        title: 'Add users to ' + productName,
        style: { height: '400px' },
        text: 'If more licenses are required, they will be purchased.',
        properties: [{
                type: 'object',
                name: 'users',
                inline: true,
                foreign: {
                    type: 'User',
                    property: 'key',
                    showMissingEntities: true,
                    getSearchKeys: function (obj, text) {
                        var result = userSearchKeys(text, user);
                        return result;
                    }
                }
            }],
        callback: function (values) {
            window.model.local.hasAddedUsers = true;
            var userKeys = Object.keys(values.users);
            model.addUsersToSub({
                userKeys: userKeys,
                subKey: subKey.toString(),
                callback: function (response) {
                    dataTableModel.refresh();
                    if (response.errors.length > 0) {
                        AlertDialog.show({
                            title: 'Something when wrong adding users to ' + productName,
                            text: response.errors.join('\n')
                        });
                    }
                }
            });
        }
    });
};
module.exports = exports = ion.template(function (config) {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'user',
                            loc: {
                                start: {
                                    line: 58,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                },
                                end: {
                                    line: 58,
                                    column: 12,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            computed: false,
                            object: {
                                type: 'Identifier',
                                name: 'model',
                                loc: {
                                    start: {
                                        line: 58,
                                        column: 15,
                                        fixed: true,
                                        source: 'viewpath/html/panes/SubscriptionPane.ion'
                                    },
                                    end: {
                                        line: 58,
                                        column: 20,
                                        fixed: true,
                                        source: 'viewpath/html/panes/SubscriptionPane.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'user',
                                loc: {
                                    start: {
                                        line: 58,
                                        column: 21,
                                        fixed: true,
                                        source: 'viewpath/html/panes/SubscriptionPane.ion'
                                    },
                                    end: {
                                        line: 58,
                                        column: 25,
                                        fixed: true,
                                        source: 'viewpath/html/panes/SubscriptionPane.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 58,
                                    column: 15,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                },
                                end: {
                                    line: 58,
                                    column: 25,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'userKey',
                            loc: {
                                start: {
                                    line: 59,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                },
                                end: {
                                    line: 59,
                                    column: 15,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            computed: false,
                            object: {
                                type: 'Identifier',
                                name: 'user',
                                loc: {
                                    start: {
                                        line: 59,
                                        column: 18,
                                        fixed: true,
                                        source: 'viewpath/html/panes/SubscriptionPane.ion'
                                    },
                                    end: {
                                        line: 59,
                                        column: 22,
                                        fixed: true,
                                        source: 'viewpath/html/panes/SubscriptionPane.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'key',
                                loc: {
                                    start: {
                                        line: 59,
                                        column: 23,
                                        fixed: true,
                                        source: 'viewpath/html/panes/SubscriptionPane.ion'
                                    },
                                    end: {
                                        line: 59,
                                        column: 26,
                                        fixed: true,
                                        source: 'viewpath/html/panes/SubscriptionPane.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 59,
                                    column: 18,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                },
                                end: {
                                    line: 59,
                                    column: 26,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'subKey',
                            loc: {
                                start: {
                                    line: 60,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                },
                                end: {
                                    line: 60,
                                    column: 14,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                }
                            }
                        },
                        init: {
                            type: 'NewExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Key',
                                loc: {
                                    start: {
                                        line: 60,
                                        column: 21,
                                        fixed: true,
                                        source: 'viewpath/html/panes/SubscriptionPane.ion'
                                    },
                                    end: {
                                        line: 60,
                                        column: 24,
                                        fixed: true,
                                        source: 'viewpath/html/panes/SubscriptionPane.ion'
                                    }
                                }
                            },
                            arguments: [
                                {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'viewpath',
                                        loc: {
                                            start: {
                                                line: 60,
                                                column: 25,
                                                fixed: true,
                                                source: 'viewpath/html/panes/SubscriptionPane.ion'
                                            },
                                            end: {
                                                line: 60,
                                                column: 33,
                                                fixed: true,
                                                source: 'viewpath/html/panes/SubscriptionPane.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'model',
                                        loc: {
                                            start: {
                                                line: 60,
                                                column: 34,
                                                fixed: true,
                                                source: 'viewpath/html/panes/SubscriptionPane.ion'
                                            },
                                            end: {
                                                line: 60,
                                                column: 39,
                                                fixed: true,
                                                source: 'viewpath/html/panes/SubscriptionPane.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 60,
                                            column: 25,
                                            fixed: true,
                                            source: 'viewpath/html/panes/SubscriptionPane.ion'
                                        },
                                        end: {
                                            line: 60,
                                            column: 39,
                                            fixed: true,
                                            source: 'viewpath/html/panes/SubscriptionPane.ion'
                                        }
                                    }
                                },
                                {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'config',
                                        loc: {
                                            start: {
                                                line: 60,
                                                column: 41,
                                                fixed: true,
                                                source: 'viewpath/html/panes/SubscriptionPane.ion'
                                            },
                                            end: {
                                                line: 60,
                                                column: 47,
                                                fixed: true,
                                                source: 'viewpath/html/panes/SubscriptionPane.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'key',
                                        loc: {
                                            start: {
                                                line: 60,
                                                column: 48,
                                                fixed: true,
                                                source: 'viewpath/html/panes/SubscriptionPane.ion'
                                            },
                                            end: {
                                                line: 60,
                                                column: 51,
                                                fixed: true,
                                                source: 'viewpath/html/panes/SubscriptionPane.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 60,
                                            column: 41,
                                            fixed: true,
                                            source: 'viewpath/html/panes/SubscriptionPane.ion'
                                        },
                                        end: {
                                            line: 60,
                                            column: 51,
                                            fixed: true,
                                            source: 'viewpath/html/panes/SubscriptionPane.ion'
                                        }
                                    }
                                }
                            ],
                            loc: {
                                start: {
                                    line: 60,
                                    column: 17,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                },
                                end: {
                                    line: 60,
                                    column: 52,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'subscription',
                            loc: {
                                start: {
                                    line: 61,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                },
                                end: {
                                    line: 61,
                                    column: 20,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            computed: true,
                            object: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'model',
                                    loc: {
                                        start: {
                                            line: 61,
                                            column: 23,
                                            fixed: true,
                                            source: 'viewpath/html/panes/SubscriptionPane.ion'
                                        },
                                        end: {
                                            line: 61,
                                            column: 28,
                                            fixed: true,
                                            source: 'viewpath/html/panes/SubscriptionPane.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'server',
                                    loc: {
                                        start: {
                                            line: 61,
                                            column: 29,
                                            fixed: true,
                                            source: 'viewpath/html/panes/SubscriptionPane.ion'
                                        },
                                        end: {
                                            line: 61,
                                            column: 35,
                                            fixed: true,
                                            source: 'viewpath/html/panes/SubscriptionPane.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 61,
                                        column: 23,
                                        fixed: true,
                                        source: 'viewpath/html/panes/SubscriptionPane.ion'
                                    },
                                    end: {
                                        line: 61,
                                        column: 35,
                                        fixed: true,
                                        source: 'viewpath/html/panes/SubscriptionPane.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'subKey',
                                loc: {
                                    start: {
                                        line: 61,
                                        column: 36,
                                        fixed: true,
                                        source: 'viewpath/html/panes/SubscriptionPane.ion'
                                    },
                                    end: {
                                        line: 61,
                                        column: 42,
                                        fixed: true,
                                        source: 'viewpath/html/panes/SubscriptionPane.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 61,
                                    column: 23,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                },
                                end: {
                                    line: 61,
                                    column: 43,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '3'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'planName',
                            loc: {
                                start: {
                                    line: 62,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                },
                                end: {
                                    line: 62,
                                    column: 16,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ConditionalExpression',
                            test: {
                                type: 'UnaryExpression',
                                operator: '?',
                                argument: {
                                    type: 'Identifier',
                                    name: 'subscription',
                                    loc: {
                                        start: {
                                            line: 62,
                                            column: 19,
                                            fixed: true,
                                            source: 'viewpath/html/panes/SubscriptionPane.ion'
                                        },
                                        end: {
                                            line: 62,
                                            column: 31,
                                            fixed: true,
                                            source: 'viewpath/html/panes/SubscriptionPane.ion'
                                        }
                                    }
                                }
                            },
                            consequent: {
                                type: 'BinaryExpression',
                                operator: '+',
                                left: {
                                    type: 'BinaryExpression',
                                    operator: '+',
                                    left: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'subscription',
                                            loc: {
                                                start: {
                                                    line: 62,
                                                    column: 36,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                },
                                                end: {
                                                    line: 62,
                                                    column: 48,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'ProductName',
                                            loc: {
                                                start: {
                                                    line: 62,
                                                    column: 49,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                },
                                                end: {
                                                    line: 62,
                                                    column: 60,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 62,
                                                column: 36,
                                                fixed: true,
                                                source: 'viewpath/html/panes/SubscriptionPane.ion'
                                            },
                                            end: {
                                                line: 62,
                                                column: 60,
                                                fixed: true,
                                                source: 'viewpath/html/panes/SubscriptionPane.ion'
                                            }
                                        }
                                    },
                                    right: {
                                        type: 'Literal',
                                        value: '-'
                                    }
                                },
                                right: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'subscription',
                                        loc: {
                                            start: {
                                                line: 62,
                                                column: 69,
                                                fixed: true,
                                                source: 'viewpath/html/panes/SubscriptionPane.ion'
                                            },
                                            end: {
                                                line: 62,
                                                column: 81,
                                                fixed: true,
                                                source: 'viewpath/html/panes/SubscriptionPane.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'PeriodName',
                                        loc: {
                                            start: {
                                                line: 62,
                                                column: 82,
                                                fixed: true,
                                                source: 'viewpath/html/panes/SubscriptionPane.ion'
                                            },
                                            end: {
                                                line: 62,
                                                column: 92,
                                                fixed: true,
                                                source: 'viewpath/html/panes/SubscriptionPane.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 62,
                                            column: 69,
                                            fixed: true,
                                            source: 'viewpath/html/panes/SubscriptionPane.ion'
                                        },
                                        end: {
                                            line: 62,
                                            column: 92,
                                            fixed: true,
                                            source: 'viewpath/html/panes/SubscriptionPane.ion'
                                        }
                                    }
                                }
                            },
                            alternate: {
                                type: 'UnaryExpression',
                                operator: 'void',
                                prefix: true,
                                argument: {
                                    type: 'Literal',
                                    value: 0
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '4'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'productName',
                            loc: {
                                start: {
                                    line: 63,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                },
                                end: {
                                    line: 63,
                                    column: 19,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ConditionalExpression',
                            test: {
                                type: 'UnaryExpression',
                                operator: '?',
                                argument: {
                                    type: 'Identifier',
                                    name: 'subscription',
                                    loc: {
                                        start: {
                                            line: 63,
                                            column: 22,
                                            fixed: true,
                                            source: 'viewpath/html/panes/SubscriptionPane.ion'
                                        },
                                        end: {
                                            line: 63,
                                            column: 34,
                                            fixed: true,
                                            source: 'viewpath/html/panes/SubscriptionPane.ion'
                                        }
                                    }
                                }
                            },
                            consequent: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'subscription',
                                    loc: {
                                        start: {
                                            line: 63,
                                            column: 38,
                                            fixed: true,
                                            source: 'viewpath/html/panes/SubscriptionPane.ion'
                                        },
                                        end: {
                                            line: 63,
                                            column: 50,
                                            fixed: true,
                                            source: 'viewpath/html/panes/SubscriptionPane.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'ProductName',
                                    loc: {
                                        start: {
                                            line: 63,
                                            column: 51,
                                            fixed: true,
                                            source: 'viewpath/html/panes/SubscriptionPane.ion'
                                        },
                                        end: {
                                            line: 63,
                                            column: 62,
                                            fixed: true,
                                            source: 'viewpath/html/panes/SubscriptionPane.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 63,
                                        column: 38,
                                        fixed: true,
                                        source: 'viewpath/html/panes/SubscriptionPane.ion'
                                    },
                                    end: {
                                        line: 63,
                                        column: 62,
                                        fixed: true,
                                        source: 'viewpath/html/panes/SubscriptionPane.ion'
                                    }
                                }
                            },
                            alternate: {
                                type: 'Literal',
                                value: 'Subscription'
                            }
                        }
                    }],
                kind: 'let',
                order: '5'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'pane',
                            loc: {
                                start: {
                                    line: 64,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                },
                                end: {
                                    line: 64,
                                    column: 12,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'GenericTypeView',
                                loc: {
                                    start: {
                                        line: 64,
                                        column: 15,
                                        fixed: true,
                                        source: 'viewpath/html/panes/SubscriptionPane.ion'
                                    },
                                    end: {
                                        line: 64,
                                        column: 30,
                                        fixed: true,
                                        source: 'viewpath/html/panes/SubscriptionPane.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ObjectExpression',
                                    properties: [
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'id',
                                                loc: {
                                                    start: {
                                                        line: 65,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                    },
                                                    end: {
                                                        line: 65,
                                                        column: 10,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: 'subscription'
                                            },
                                            kind: 'init',
                                            order: '0'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'type',
                                                loc: {
                                                    start: {
                                                        line: 66,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                    },
                                                    end: {
                                                        line: 66,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Identifier',
                                                name: 'User',
                                                loc: {
                                                    start: {
                                                        line: 66,
                                                        column: 14,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                    },
                                                    end: {
                                                        line: 66,
                                                        column: 18,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                    }
                                                }
                                            },
                                            kind: 'init',
                                            order: '1'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'columns',
                                                loc: {
                                                    start: {
                                                        line: 67,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                    },
                                                    end: {
                                                        line: 67,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'ArrayExpression',
                                                elements: [
                                                    {
                                                        type: 'Literal',
                                                        value: 'name'
                                                    },
                                                    {
                                                        type: 'Literal',
                                                        value: 'email'
                                                    }
                                                ]
                                            },
                                            kind: 'init',
                                            order: '2'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'where',
                                                loc: {
                                                    start: {
                                                        line: 68,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                    },
                                                    end: {
                                                        line: 68,
                                                        column: 13,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'ObjectExpression',
                                                properties: [{
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'subscription',
                                                            loc: {
                                                                start: {
                                                                    line: 69,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                                },
                                                                end: {
                                                                    line: 69,
                                                                    column: 24,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'subKey',
                                                                    loc: {
                                                                        start: {
                                                                            line: 69,
                                                                            column: 26,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 69,
                                                                            column: 32,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'toString',
                                                                    loc: {
                                                                        start: {
                                                                            line: 69,
                                                                            column: 33,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 69,
                                                                            column: 41,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 69,
                                                                        column: 26,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 69,
                                                                        column: 41,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [],
                                                            loc: {
                                                                start: {
                                                                    line: 69,
                                                                    column: 26,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                                },
                                                                end: {
                                                                    line: 69,
                                                                    column: 43,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                                }
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    }]
                                            },
                                            kind: 'init',
                                            order: '3'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'standardControls',
                                                loc: {
                                                    start: {
                                                        line: 70,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                    },
                                                    end: {
                                                        line: 70,
                                                        column: 24,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: false
                                            },
                                            kind: 'init',
                                            order: '4'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'create',
                                                loc: {
                                                    start: {
                                                        line: 71,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                    },
                                                    end: {
                                                        line: 71,
                                                        column: 14,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'ObjectExpression',
                                                properties: [
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'title',
                                                            loc: {
                                                                start: {
                                                                    line: 72,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                                },
                                                                end: {
                                                                    line: 72,
                                                                    column: 17,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Literal',
                                                            value: 'Add Users'
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'handler',
                                                            loc: {
                                                                start: {
                                                                    line: 73,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                                },
                                                                end: {
                                                                    line: 73,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Function',
                                                            context: true,
                                                            value: function (_context) {
                                                                return function (_ref6) {
                                                                    var addUsersPrompt = _context.get('addUsersPrompt'), user = _context.get('user'), productName = _context.get('productName'), subKey = _context.get('subKey');
                                                                    var dataTableModel = _ref6.dataTableModel;
                                                                    return addUsersPrompt({
                                                                        user: user,
                                                                        productName: productName,
                                                                        subKey: subKey,
                                                                        dataTableModel: dataTableModel
                                                                    });
                                                                };
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '1'
                                                    }
                                                ]
                                            },
                                            kind: 'init',
                                            order: '5'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'toolbar',
                                                loc: {
                                                    start: {
                                                        line: 74,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                    },
                                                    end: {
                                                        line: 74,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'ObjectExpression',
                                                properties: [{
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'center',
                                                            loc: {
                                                                start: {
                                                                    line: 75,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                                },
                                                                end: {
                                                                    line: 75,
                                                                    column: 18,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Function',
                                                            context: true,
                                                            value: function (_ps) {
                                                                return ion.template(function (_ref7) {
                                                                    return ion.createRuntime({
                                                                        type: 'Template',
                                                                        id: null,
                                                                        body: [
                                                                            {
                                                                                type: 'VariableDeclaration',
                                                                                declarations: [{
                                                                                        type: 'VariableDeclarator',
                                                                                        id: {
                                                                                            type: 'Identifier',
                                                                                            name: 'dataTableModel',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 75,
                                                                                                    column: 31,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 75,
                                                                                                    column: 45,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        init: {
                                                                                            type: 'MemberExpression',
                                                                                            object: {
                                                                                                type: 'Identifier',
                                                                                                name: '_ref7'
                                                                                            },
                                                                                            property: {
                                                                                                type: 'Identifier',
                                                                                                name: 'dataTableModel',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 75,
                                                                                                        column: 31,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 75,
                                                                                                        column: 45,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            computed: false
                                                                                        }
                                                                                    }],
                                                                                kind: 'let',
                                                                                order: '0'
                                                                            },
                                                                            {
                                                                                type: 'ReturnStatement',
                                                                                argument: {
                                                                                    type: 'ObjectExpression',
                                                                                    objectType: {
                                                                                        type: 'CallExpression',
                                                                                        callee: {
                                                                                            type: 'Identifier',
                                                                                            name: 'PaperIconButton',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 76,
                                                                                                    column: 23,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 76,
                                                                                                    column: 38,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        arguments: [],
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 76,
                                                                                                column: 23,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 76,
                                                                                                column: 40,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    properties: [
                                                                                        {
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'title',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 77,
                                                                                                        column: 20,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 77,
                                                                                                        column: 25,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'Literal',
                                                                                                value: 'Remove Selected Users'
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '0'
                                                                                        },
                                                                                        {
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'icon',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 78,
                                                                                                        column: 20,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 78,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'Literal',
                                                                                                value: 'clear'
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '1'
                                                                                        },
                                                                                        {
                                                                                            type: 'ExpressionStatement',
                                                                                            expression: {
                                                                                                type: 'Function',
                                                                                                context: true,
                                                                                                value: function (_context2) {
                                                                                                    return function click() {
                                                                                                        var dataTableModel = _context2.get('dataTableModel'), subKey = _context2.get('subKey');
                                                                                                        var userKeys = dataTableModel.selectedRows.map(function (x) {
                                                                                                                return x.key;
                                                                                                            });
                                                                                                        model.removeUsersFromSub({
                                                                                                            userKeys: userKeys,
                                                                                                            subKey: subKey.toString(),
                                                                                                            callback: dataTableModel.refresh
                                                                                                        });
                                                                                                    };
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 79,
                                                                                                    column: 20,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 86,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                                                                }
                                                                                            },
                                                                                            order: '2'
                                                                                        }
                                                                                    ]
                                                                                },
                                                                                order: '1'
                                                                            }
                                                                        ],
                                                                        bound: false,
                                                                        name: {
                                                                            type: 'Identifier',
                                                                            name: 'center',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 75,
                                                                                    column: 12,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 75,
                                                                                    column: 18,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        scope: {
                                                                            type: 'Identifier',
                                                                            name: '_ps'
                                                                        }
                                                                    }, {
                                                                        this: this,
                                                                        _ref7: _ref7,
                                                                        _ps: _ps,
                                                                        config: config,
                                                                        glass: glass,
                                                                        _ref: _ref,
                                                                        viewpath: viewpath,
                                                                        _ref2: _ref2,
                                                                        _ref3: _ref3,
                                                                        _ref4: _ref4,
                                                                        getUserSearchKeys: getUserSearchKeys,
                                                                        userSearchKeys: userSearchKeys,
                                                                        Key: Key,
                                                                        AlertDialog: AlertDialog,
                                                                        PromptDialog: PromptDialog,
                                                                        Subscription: Subscription,
                                                                        User: User,
                                                                        GenericTypeView: GenericTypeView,
                                                                        addUsersPrompt: addUsersPrompt
                                                                    }, _ps);
                                                                });
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    }]
                                            },
                                            kind: 'init',
                                            order: '6'
                                        }
                                    ]
                                }],
                            loc: {
                                start: {
                                    line: 64,
                                    column: 15,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                },
                                end: {
                                    line: 86,
                                    column: 5,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '6'
            },
            {
                type: 'ExpressionStatement',
                expression: {
                    type: 'CallExpression',
                    callee: {
                        type: 'Function',
                        context: false,
                        value: function () {
                            if (window.model.local.hasAddedUsers !== true) {
                                model.info({
                                    text: 'Click the plus button to add users to this subscription.',
                                    name: 'SubscriptionPane.addUsers'
                                });
                            }
                        }
                    },
                    arguments: [],
                    loc: {
                        start: {
                            line: 88,
                            column: 4,
                            fixed: true,
                            source: 'viewpath/html/panes/SubscriptionPane.ion'
                        },
                        end: {
                            line: 95,
                            column: 8,
                            fixed: true,
                            source: 'viewpath/html/panes/SubscriptionPane.ion'
                        }
                    }
                },
                loc: {
                    start: {
                        line: 88,
                        column: 4,
                        fixed: true,
                        source: 'viewpath/html/panes/SubscriptionPane.ion'
                    },
                    end: {
                        line: 95,
                        column: 8,
                        fixed: true,
                        source: 'viewpath/html/panes/SubscriptionPane.ion'
                    }
                },
                order: '7'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'Identifier',
                        name: 'pane',
                        loc: {
                            start: {
                                line: 95,
                                column: 11,
                                fixed: true,
                                source: 'viewpath/html/panes/SubscriptionPane.ion'
                            },
                            end: {
                                line: 95,
                                column: 15,
                                fixed: true,
                                source: 'viewpath/html/panes/SubscriptionPane.ion'
                            }
                        }
                    },
                    properties: [
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'style',
                                loc: {
                                    start: {
                                        line: 96,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/html/panes/SubscriptionPane.ion'
                                    },
                                    end: {
                                        line: 96,
                                        column: 13,
                                        fixed: true,
                                        source: 'viewpath/html/panes/SubscriptionPane.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'ObjectExpression',
                                properties: [{
                                        type: 'IfStatement',
                                        test: {
                                            type: 'BinaryExpression',
                                            operator: '===',
                                            left: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'config',
                                                    loc: {
                                                        start: {
                                                            line: 97,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                        },
                                                        end: {
                                                            line: 97,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'target',
                                                    loc: {
                                                        start: {
                                                            line: 97,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                        },
                                                        end: {
                                                            line: 97,
                                                            column: 28,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 97,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                    },
                                                    end: {
                                                        line: 97,
                                                        column: 28,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                    }
                                                }
                                            },
                                            right: {
                                                type: 'Literal',
                                                value: 'dialog'
                                            }
                                        },
                                        consequent: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'width',
                                                        loc: {
                                                            start: {
                                                                line: 98,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                            },
                                                            end: {
                                                                line: 98,
                                                                column: 21,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: '500px'
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                }]
                                        },
                                        alternate: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'width',
                                                        loc: {
                                                            start: {
                                                                line: 100,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                            },
                                                            end: {
                                                                line: 100,
                                                                column: 21,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: '100%'
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                }]
                                        },
                                        order: '0'
                                    }]
                            },
                            kind: 'init',
                            order: '0'
                        },
                        {
                            type: 'IfStatement',
                            test: {
                                type: 'UnaryExpression',
                                operator: '?',
                                argument: {
                                    type: 'Identifier',
                                    name: 'planName',
                                    loc: {
                                        start: {
                                            line: 101,
                                            column: 11,
                                            fixed: true,
                                            source: 'viewpath/html/panes/SubscriptionPane.ion'
                                        },
                                        end: {
                                            line: 101,
                                            column: 19,
                                            fixed: true,
                                            source: 'viewpath/html/panes/SubscriptionPane.ion'
                                        }
                                    }
                                }
                            },
                            consequent: {
                                type: 'BlockStatement',
                                body: [{
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'name',
                                            loc: {
                                                start: {
                                                    line: 102,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                },
                                                end: {
                                                    line: 102,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'ArrayExpression',
                                            elements: [
                                                {
                                                    type: 'Literal',
                                                    value: 'Subscription'
                                                },
                                                {
                                                    type: 'Identifier',
                                                    name: 'planName',
                                                    loc: {
                                                        start: {
                                                            line: 102,
                                                            column: 35,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                        },
                                                        end: {
                                                            line: 102,
                                                            column: 43,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                        }
                                                    }
                                                }
                                            ]
                                        },
                                        kind: 'init',
                                        order: '0'
                                    }]
                            },
                            alternate: {
                                type: 'BlockStatement',
                                body: [{
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'name',
                                            loc: {
                                                start: {
                                                    line: 104,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                },
                                                end: {
                                                    line: 104,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/SubscriptionPane.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: 'Subscription'
                                        },
                                        kind: 'init',
                                        order: '0'
                                    }]
                            },
                            order: '1'
                        }
                    ]
                },
                order: '8'
            }
        ],
        bound: false
    }, {
        this: this,
        ion: ion,
        config: config,
        glass: glass,
        _ref: _ref,
        viewpath: viewpath,
        _ref2: _ref2,
        _ref3: _ref3,
        _ref4: _ref4,
        getUserSearchKeys: getUserSearchKeys,
        userSearchKeys: userSearchKeys,
        Key: Key,
        AlertDialog: AlertDialog,
        PromptDialog: PromptDialog,
        Subscription: Subscription,
        User: User,
        GenericTypeView: GenericTypeView,
        addUsersPrompt: addUsersPrompt
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/panes/SubscriptionPane',_viewpath_html_panes_SubscriptionPane_);
    else
      _viewpath_html_panes_SubscriptionPane_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_panes_SubscriptionPane_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_panes_SubscriptionsPane_ = function(module,exports,require){'use strict';
var ion = require('ion');
var glass = require('glass'), _ref, viewpath = require('../../'), _ref2, _ref3, _ref4, recurlyUrl = 'https://viewpath.recurly.com/';
_ref = glass.data;
var Http = _ref.Http;
var Key = _ref.Key;
_ref2 = glass.html.material;
var PromptDialog = _ref2.PromptDialog;
_ref3 = viewpath.model;
var Subscription = _ref3.Subscription;
var User = _ref3.User;
_ref4 = require('./');
var GenericTypeView = _ref4.GenericTypeView;
var newSubPrompt = function () {
    PromptDialog.show({
        title: 'Select a subscription type and period length.',
        text: 'After you create a subscription, you can assign licenses within that subscription to users.',
        submitText: 'Signup',
        properties: [
            Subscription.properties.product,
            Subscription.properties.months
        ],
        callback: function (values) {
            var user = model.user;
            var productName = Subscription.Product[values.product].name;
            var period = Subscription.Period[values.months].name;
            var productCode = (productName + '-' + period).toLowerCase();
            var url = Http.getUrl(recurlyUrl + 'subscribe/' + productCode, { email: user.email });
            window.open(url);
        }
    });
};
module.exports = exports = ion.template(function (config) {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'user',
                            loc: {
                                start: {
                                    line: 33,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                },
                                end: {
                                    line: 33,
                                    column: 12,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            computed: false,
                            object: {
                                type: 'Identifier',
                                name: 'model',
                                loc: {
                                    start: {
                                        line: 33,
                                        column: 15,
                                        fixed: true,
                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                    },
                                    end: {
                                        line: 33,
                                        column: 20,
                                        fixed: true,
                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'user',
                                loc: {
                                    start: {
                                        line: 33,
                                        column: 21,
                                        fixed: true,
                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                    },
                                    end: {
                                        line: 33,
                                        column: 25,
                                        fixed: true,
                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 33,
                                    column: 15,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                },
                                end: {
                                    line: 33,
                                    column: 25,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'userKey',
                            loc: {
                                start: {
                                    line: 34,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                },
                                end: {
                                    line: 34,
                                    column: 15,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            computed: false,
                            object: {
                                type: 'Identifier',
                                name: 'user',
                                loc: {
                                    start: {
                                        line: 34,
                                        column: 18,
                                        fixed: true,
                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                    },
                                    end: {
                                        line: 34,
                                        column: 22,
                                        fixed: true,
                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'key',
                                loc: {
                                    start: {
                                        line: 34,
                                        column: 23,
                                        fixed: true,
                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                    },
                                    end: {
                                        line: 34,
                                        column: 26,
                                        fixed: true,
                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 34,
                                    column: 18,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                },
                                end: {
                                    line: 34,
                                    column: 26,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'subsKey',
                            loc: {
                                start: {
                                    line: 35,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                },
                                end: {
                                    line: 35,
                                    column: 15,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                }
                            }
                        },
                        init: {
                            type: 'NewExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Key',
                                loc: {
                                    start: {
                                        line: 35,
                                        column: 22,
                                        fixed: true,
                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                    },
                                    end: {
                                        line: 35,
                                        column: 25,
                                        fixed: true,
                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                    }
                                }
                            },
                            arguments: [
                                {
                                    type: 'Identifier',
                                    name: 'Subscription',
                                    loc: {
                                        start: {
                                            line: 35,
                                            column: 26,
                                            fixed: true,
                                            source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                        },
                                        end: {
                                            line: 35,
                                            column: 38,
                                            fixed: true,
                                            source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                        }
                                    }
                                },
                                {
                                    type: 'ObjectExpression',
                                    properties: [{
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'where',
                                                loc: {
                                                    start: {
                                                        line: 35,
                                                        column: 41,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                    },
                                                    end: {
                                                        line: 35,
                                                        column: 46,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'ObjectExpression',
                                                properties: [{
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'createdBy',
                                                            loc: {
                                                                start: {
                                                                    line: 35,
                                                                    column: 49,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                },
                                                                end: {
                                                                    line: 35,
                                                                    column: 58,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'userKey',
                                                                    loc: {
                                                                        start: {
                                                                            line: 35,
                                                                            column: 60,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 35,
                                                                            column: 67,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'toString',
                                                                    loc: {
                                                                        start: {
                                                                            line: 35,
                                                                            column: 68,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 35,
                                                                            column: 76,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 35,
                                                                        column: 60,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 35,
                                                                        column: 76,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [],
                                                            loc: {
                                                                start: {
                                                                    line: 35,
                                                                    column: 60,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                },
                                                                end: {
                                                                    line: 35,
                                                                    column: 78,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                }
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    }]
                                            },
                                            kind: 'init',
                                            order: '0'
                                        }]
                                }
                            ],
                            loc: {
                                start: {
                                    line: 35,
                                    column: 18,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                },
                                end: {
                                    line: 35,
                                    column: 81,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'subscriptions',
                            loc: {
                                start: {
                                    line: 36,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                },
                                end: {
                                    line: 36,
                                    column: 21,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            computed: true,
                            object: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'model',
                                    loc: {
                                        start: {
                                            line: 36,
                                            column: 24,
                                            fixed: true,
                                            source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                        },
                                        end: {
                                            line: 36,
                                            column: 29,
                                            fixed: true,
                                            source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'server',
                                    loc: {
                                        start: {
                                            line: 36,
                                            column: 30,
                                            fixed: true,
                                            source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                        },
                                        end: {
                                            line: 36,
                                            column: 36,
                                            fixed: true,
                                            source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 36,
                                        column: 24,
                                        fixed: true,
                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                    },
                                    end: {
                                        line: 36,
                                        column: 36,
                                        fixed: true,
                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'subsKey',
                                loc: {
                                    start: {
                                        line: 36,
                                        column: 37,
                                        fixed: true,
                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                    },
                                    end: {
                                        line: 36,
                                        column: 44,
                                        fixed: true,
                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 36,
                                    column: 24,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                },
                                end: {
                                    line: 36,
                                    column: 45,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '3'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'subscription',
                            loc: {
                                start: {
                                    line: 38,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                },
                                end: {
                                    line: 38,
                                    column: 20,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            computed: false,
                            object: {
                                type: 'Identifier',
                                name: 'model',
                                loc: {
                                    start: {
                                        line: 38,
                                        column: 23,
                                        fixed: true,
                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                    },
                                    end: {
                                        line: 38,
                                        column: 28,
                                        fixed: true,
                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'subscription',
                                loc: {
                                    start: {
                                        line: 38,
                                        column: 29,
                                        fixed: true,
                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                    },
                                    end: {
                                        line: 38,
                                        column: 41,
                                        fixed: true,
                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 38,
                                    column: 23,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                },
                                end: {
                                    line: 38,
                                    column: 41,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '4'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'createdBy',
                            loc: {
                                start: {
                                    line: 39,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                },
                                end: {
                                    line: 39,
                                    column: 17,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            computed: false,
                            object: {
                                type: 'Identifier',
                                name: 'subscription',
                                loc: {
                                    start: {
                                        line: 39,
                                        column: 20,
                                        fixed: true,
                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                    },
                                    end: {
                                        line: 39,
                                        column: 32,
                                        fixed: true,
                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'createdBy',
                                loc: {
                                    start: {
                                        line: 39,
                                        column: 33,
                                        fixed: true,
                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                    },
                                    end: {
                                        line: 39,
                                        column: 42,
                                        fixed: true,
                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 39,
                                    column: 20,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                },
                                end: {
                                    line: 39,
                                    column: 42,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '5'
            },
            {
                type: 'ExpressionStatement',
                expression: {
                    type: 'CallExpression',
                    callee: {
                        type: 'Function',
                        context: true,
                        value: function (_context) {
                            return function (subscription) {
                                var createdBy = _context.get('createdBy'), userKey = _context.get('userKey'), Key = _context.get('Key'), viewpath = _context.get('viewpath');
                                if (subscription != null && createdBy !== userKey) {
                                    var key = new Key(viewpath.model, createdBy);
                                    model.info({
                                        text: 'Your license is managed by ' + key.id + '.',
                                        subtext: 'Please contact them for assistance.'
                                    });
                                }
                            };
                        }
                    },
                    arguments: [{
                            type: 'Identifier',
                            name: 'subscription',
                            loc: {
                                start: {
                                    line: 40,
                                    column: 7,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                },
                                end: {
                                    line: 40,
                                    column: 19,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                }
                            }
                        }],
                    loc: {
                        start: {
                            line: 40,
                            column: 4,
                            fixed: true,
                            source: 'viewpath/html/panes/SubscriptionsPane.ion'
                        },
                        end: {
                            line: 48,
                            column: 8,
                            fixed: true,
                            source: 'viewpath/html/panes/SubscriptionsPane.ion'
                        }
                    }
                },
                loc: {
                    start: {
                        line: 40,
                        column: 4,
                        fixed: true,
                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                    },
                    end: {
                        line: 48,
                        column: 8,
                        fixed: true,
                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                    }
                },
                order: '6'
            },
            {
                type: 'ExpressionStatement',
                expression: {
                    type: 'CallExpression',
                    callee: {
                        type: 'Function',
                        context: true,
                        value: function (_context2) {
                            return function (subscriptions) {
                                var newSubPrompt = _context2.get('newSubPrompt');
                                if (subscriptions != null) {
                                    var count = Object.keys(subscriptions != null ? subscriptions : {}).length;
                                    if (count === 0) {
                                        newSubPrompt();
                                    } else if (count === 1) {
                                        for (var key in subscriptions) {
                                            var sub = subscriptions[key];
                                            global.model.open(sub.paneConfig, { target: 'dialog' });
                                        }
                                    }
                                }
                            };
                        }
                    },
                    arguments: [{
                            type: 'Identifier',
                            name: 'subscriptions',
                            loc: {
                                start: {
                                    line: 48,
                                    column: 7,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                },
                                end: {
                                    line: 48,
                                    column: 20,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                }
                            }
                        }],
                    loc: {
                        start: {
                            line: 48,
                            column: 4,
                            fixed: true,
                            source: 'viewpath/html/panes/SubscriptionsPane.ion'
                        },
                        end: {
                            line: 57,
                            column: 8,
                            fixed: true,
                            source: 'viewpath/html/panes/SubscriptionsPane.ion'
                        }
                    }
                },
                loc: {
                    start: {
                        line: 48,
                        column: 4,
                        fixed: true,
                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                    },
                    end: {
                        line: 57,
                        column: 8,
                        fixed: true,
                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                    }
                },
                order: '7'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'pane',
                            loc: {
                                start: {
                                    line: 57,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                },
                                end: {
                                    line: 57,
                                    column: 12,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'GenericTypeView',
                                loc: {
                                    start: {
                                        line: 57,
                                        column: 15,
                                        fixed: true,
                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                    },
                                    end: {
                                        line: 57,
                                        column: 30,
                                        fixed: true,
                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ObjectExpression',
                                    properties: [
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'id',
                                                loc: {
                                                    start: {
                                                        line: 58,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                    },
                                                    end: {
                                                        line: 58,
                                                        column: 10,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: 'subscriptions'
                                            },
                                            kind: 'init',
                                            order: '0'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'type',
                                                loc: {
                                                    start: {
                                                        line: 59,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                    },
                                                    end: {
                                                        line: 59,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Identifier',
                                                name: 'Subscription',
                                                loc: {
                                                    start: {
                                                        line: 59,
                                                        column: 14,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                    },
                                                    end: {
                                                        line: 59,
                                                        column: 26,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                    }
                                                }
                                            },
                                            kind: 'init',
                                            order: '1'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'columns',
                                                loc: {
                                                    start: {
                                                        line: 60,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                    },
                                                    end: {
                                                        line: 60,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'ArrayExpression',
                                                elements: [
                                                    {
                                                        type: 'Literal',
                                                        value: 'ProductName'
                                                    },
                                                    {
                                                        type: 'Literal',
                                                        value: 'PeriodName'
                                                    },
                                                    {
                                                        type: 'Literal',
                                                        value: 'quantity'
                                                    },
                                                    {
                                                        type: 'Literal',
                                                        value: 'StateName'
                                                    },
                                                    {
                                                        type: 'Literal',
                                                        value: 'expires'
                                                    }
                                                ]
                                            },
                                            kind: 'init',
                                            order: '2'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'where',
                                                loc: {
                                                    start: {
                                                        line: 61,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                    },
                                                    end: {
                                                        line: 61,
                                                        column: 13,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'ObjectExpression',
                                                properties: [{
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'createdBy',
                                                            loc: {
                                                                start: {
                                                                    line: 62,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                },
                                                                end: {
                                                                    line: 62,
                                                                    column: 21,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'userKey',
                                                                    loc: {
                                                                        start: {
                                                                            line: 62,
                                                                            column: 23,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 62,
                                                                            column: 30,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'toString',
                                                                    loc: {
                                                                        start: {
                                                                            line: 62,
                                                                            column: 31,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 62,
                                                                            column: 39,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 62,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 62,
                                                                        column: 39,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [],
                                                            loc: {
                                                                start: {
                                                                    line: 62,
                                                                    column: 23,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                },
                                                                end: {
                                                                    line: 62,
                                                                    column: 41,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                }
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    }]
                                            },
                                            kind: 'init',
                                            order: '3'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'standardControls',
                                                loc: {
                                                    start: {
                                                        line: 63,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                    },
                                                    end: {
                                                        line: 63,
                                                        column: 24,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: false
                                            },
                                            kind: 'init',
                                            order: '4'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'selectable',
                                                loc: {
                                                    start: {
                                                        line: 64,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                    },
                                                    end: {
                                                        line: 64,
                                                        column: 18,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Literal',
                                                value: false
                                            },
                                            kind: 'init',
                                            order: '5'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'create',
                                                loc: {
                                                    start: {
                                                        line: 65,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                    },
                                                    end: {
                                                        line: 65,
                                                        column: 14,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'ObjectExpression',
                                                properties: [
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'title',
                                                            loc: {
                                                                start: {
                                                                    line: 66,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                },
                                                                end: {
                                                                    line: 66,
                                                                    column: 17,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Literal',
                                                            value: 'Create Subscription'
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'handler',
                                                            loc: {
                                                                start: {
                                                                    line: 67,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                },
                                                                end: {
                                                                    line: 67,
                                                                    column: 19,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Function',
                                                            context: true,
                                                            value: function (_context3) {
                                                                return function (_ref5) {
                                                                    var newSubPrompt = _context3.get('newSubPrompt');
                                                                    var dataTable = _ref5.dataTable;
                                                                    return newSubPrompt();
                                                                };
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '1'
                                                    }
                                                ]
                                            },
                                            kind: 'init',
                                            order: '6'
                                        },
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'toolbar',
                                                loc: {
                                                    start: {
                                                        line: 68,
                                                        column: 8,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                    },
                                                    end: {
                                                        line: 68,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'ObjectExpression',
                                                properties: [{
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'left',
                                                            loc: {
                                                                start: {
                                                                    line: 69,
                                                                    column: 12,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                },
                                                                end: {
                                                                    line: 69,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Function',
                                                            context: true,
                                                            value: function (_ps) {
                                                                return ion.template(function () {
                                                                    return ion.createRuntime({
                                                                        type: 'Template',
                                                                        id: null,
                                                                        body: [{
                                                                                type: 'ReturnStatement',
                                                                                argument: {
                                                                                    type: 'ObjectExpression',
                                                                                    objectType: {
                                                                                        type: 'CallExpression',
                                                                                        callee: {
                                                                                            type: 'Identifier',
                                                                                            name: 'PaperIconButton',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 70,
                                                                                                    column: 23,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 70,
                                                                                                    column: 38,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        arguments: [],
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 70,
                                                                                                column: 23,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 70,
                                                                                                column: 40,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    properties: [
                                                                                        {
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'title',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 71,
                                                                                                        column: 20,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 71,
                                                                                                        column: 25,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'Literal',
                                                                                                value: 'Cancel or Reactivate a Subscription'
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '0'
                                                                                        },
                                                                                        {
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'icon',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 72,
                                                                                                        column: 20,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 72,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'Literal',
                                                                                                value: 'settings'
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '1'
                                                                                        },
                                                                                        {
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'disabled',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 73,
                                                                                                        column: 20,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 73,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'BinaryExpression',
                                                                                                operator: '===',
                                                                                                left: {
                                                                                                    type: 'MemberExpression',
                                                                                                    computed: false,
                                                                                                    object: {
                                                                                                        type: 'CallExpression',
                                                                                                        callee: {
                                                                                                            type: 'MemberExpression',
                                                                                                            computed: false,
                                                                                                            object: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'Object',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 73,
                                                                                                                        column: 30,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 73,
                                                                                                                        column: 36,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            property: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'keys',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 73,
                                                                                                                        column: 37,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 73,
                                                                                                                        column: 41,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 73,
                                                                                                                    column: 30,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 73,
                                                                                                                    column: 41,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        arguments: [{
                                                                                                                type: 'ConditionalExpression',
                                                                                                                test: {
                                                                                                                    type: 'BinaryExpression',
                                                                                                                    operator: '!=',
                                                                                                                    left: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'subscriptions',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 73,
                                                                                                                                column: 42,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 73,
                                                                                                                                column: 55,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    right: {
                                                                                                                        type: 'Literal',
                                                                                                                        value: null
                                                                                                                    }
                                                                                                                },
                                                                                                                consequent: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'subscriptions',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 73,
                                                                                                                            column: 42,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 73,
                                                                                                                            column: 55,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                alternate: {
                                                                                                                    type: 'ObjectExpression',
                                                                                                                    properties: []
                                                                                                                }
                                                                                                            }],
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 73,
                                                                                                                column: 30,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 73,
                                                                                                                column: 61,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    property: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'length',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 73,
                                                                                                                column: 62,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 73,
                                                                                                                column: 68,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 73,
                                                                                                            column: 30,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 73,
                                                                                                            column: 68,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                right: {
                                                                                                    type: 'Literal',
                                                                                                    value: 0
                                                                                                }
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '2'
                                                                                        },
                                                                                        {
                                                                                            type: 'ExpressionStatement',
                                                                                            expression: {
                                                                                                type: 'Function',
                                                                                                context: false,
                                                                                                value: function click(e) {
                                                                                                    model.manageSubscriptions();
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 74,
                                                                                                    column: 20,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 76,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                                                }
                                                                                            },
                                                                                            order: '3'
                                                                                        }
                                                                                    ]
                                                                                },
                                                                                order: '0'
                                                                            }],
                                                                        bound: false,
                                                                        name: {
                                                                            type: 'Identifier',
                                                                            name: 'left',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 69,
                                                                                    column: 12,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 69,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        scope: {
                                                                            type: 'Identifier',
                                                                            name: '_ps'
                                                                        }
                                                                    }, {
                                                                        this: this,
                                                                        _ps: _ps,
                                                                        config: config,
                                                                        glass: glass,
                                                                        _ref: _ref,
                                                                        viewpath: viewpath,
                                                                        _ref2: _ref2,
                                                                        _ref3: _ref3,
                                                                        _ref4: _ref4,
                                                                        recurlyUrl: recurlyUrl,
                                                                        Http: Http,
                                                                        Key: Key,
                                                                        PromptDialog: PromptDialog,
                                                                        Subscription: Subscription,
                                                                        User: User,
                                                                        GenericTypeView: GenericTypeView,
                                                                        newSubPrompt: newSubPrompt
                                                                    }, _ps);
                                                                });
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    }]
                                            },
                                            kind: 'init',
                                            order: '7'
                                        }
                                    ]
                                }],
                            loc: {
                                start: {
                                    line: 57,
                                    column: 15,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                },
                                end: {
                                    line: 76,
                                    column: 5,
                                    fixed: true,
                                    source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '8'
            },
            {
                type: 'ExpressionStatement',
                expression: {
                    type: 'CallExpression',
                    callee: {
                        type: 'Function',
                        context: false,
                        value: function () {
                            if (window.model.local.hasAddedUsers !== true) {
                                model.info({
                                    text: 'Click a subscription\'s name to add or remove users.',
                                    name: 'SubscriptionsPane.openSub'
                                });
                            }
                        }
                    },
                    arguments: [],
                    loc: {
                        start: {
                            line: 78,
                            column: 4,
                            fixed: true,
                            source: 'viewpath/html/panes/SubscriptionsPane.ion'
                        },
                        end: {
                            line: 85,
                            column: 8,
                            fixed: true,
                            source: 'viewpath/html/panes/SubscriptionsPane.ion'
                        }
                    }
                },
                loc: {
                    start: {
                        line: 78,
                        column: 4,
                        fixed: true,
                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                    },
                    end: {
                        line: 85,
                        column: 8,
                        fixed: true,
                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                    }
                },
                order: '9'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'Identifier',
                        name: 'pane',
                        loc: {
                            start: {
                                line: 85,
                                column: 11,
                                fixed: true,
                                source: 'viewpath/html/panes/SubscriptionsPane.ion'
                            },
                            end: {
                                line: 85,
                                column: 15,
                                fixed: true,
                                source: 'viewpath/html/panes/SubscriptionsPane.ion'
                            }
                        }
                    },
                    properties: [{
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'name',
                                loc: {
                                    start: {
                                        line: 86,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                    },
                                    end: {
                                        line: 86,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/SubscriptionsPane.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Literal',
                                value: 'Subscriptions'
                            },
                            kind: 'init',
                            order: '0'
                        }]
                },
                order: ':'
            }
        ],
        bound: false
    }, {
        this: this,
        ion: ion,
        config: config,
        glass: glass,
        _ref: _ref,
        viewpath: viewpath,
        _ref2: _ref2,
        _ref3: _ref3,
        _ref4: _ref4,
        recurlyUrl: recurlyUrl,
        Http: Http,
        Key: Key,
        PromptDialog: PromptDialog,
        Subscription: Subscription,
        User: User,
        GenericTypeView: GenericTypeView,
        newSubPrompt: newSubPrompt
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/panes/SubscriptionsPane',_viewpath_html_panes_SubscriptionsPane_);
    else
      _viewpath_html_panes_SubscriptionsPane_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_panes_SubscriptionsPane_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_panes_TaskPane_ = function(module,exports,require){'use strict';
var ion = require('ion'), glass = require('glass'), _ref, _ref2, _ref3, viewpath = require('../../'), _ref4, _ref5, _ref6;
_ref = glass.html;
var style = _ref.style;
_ref2 = glass.data;
var Key = _ref2.Key;
var Schema = _ref2.Schema;
_ref3 = require('../');
var CommentItem = _ref3.CommentItem;
var Loader = _ref3.Loader;
var DiscussionEditor = _ref3.DiscussionEditor;
_ref4 = viewpath.model;
var User = _ref4.User;
var Task = _ref4.Task;
var Project = _ref4.Project;
var Organization = _ref4.Organization;
var Comment = _ref4.Comment;
_ref5 = glass.html.material;
var TabContent = _ref5.TabContent;
var Renamer = _ref5.Renamer;
_ref6 = glass.html.forms;
var Field = _ref6.Field;
var GlassForm = _ref6.GlassForm;
var lightGray = '#F2F2F2';
var _ref7 = style.custom;
_ref7[module.id] = '.TaskNameInput paper-input {\n    --paper-input-container-color: ' + style.black(0.2) + ';\n}';
_ref7;
var _ref8 = style.sheets;
_ref8[module.id] = '.comments {\n    list-style:none;\n    margin:0;\n    flex:1;\n    padding:20px;\n    overflow-y:auto;\n}\n\n.Discussion {\n    position:relative;\n}\n\n.Discussion.tab-content{\n    padding:0;\n}\n\n.comments h2.heading{\n    font-size:16px;\n    font-weight:400;\n    margin:0 0 8px 0;\n}\n\n.comments .subheading{\n    font-size:14px;\n    font-weight:400;\n    margin:0;\n}\n\n.Discussion .comments {\n    list-style:none;\n    margin:0;\n    padding:0;\n    transition:margin-right 200ms;\n}\n\n.Discussion .comments li {\n    cursor:pointer;\n    padding: 20px;\n    border-radius: 2px;\n    font-size: 14px;\n    display:flex;\n}\n\n.TaskPane .Tab {\n    background-color: ' + lightGray + ';\n}\n\n.TaskPane .Tabs {\n    box-shadow: 0 3px 2px rgba(0,0,0,0.10), 0 3px 2px rgba(0,0,0,0.20);\n    background-color: ' + lightGray + ';\n}';
_ref8;
var apply = function (diff, task) {
        for (var key in diff) {
            var value = diff[key];
            Schema.set(task, Task.properties[key], value);
        }
    }, TaskInfoRow = ion.template(function (label, text, paneConfig) {
        return ion.createRuntime({
            type: 'Template',
            id: null,
            body: [{
                    type: 'ReturnStatement',
                    argument: {
                        type: 'ObjectExpression',
                        objectType: {
                            type: 'CallExpression',
                            callee: {
                                type: 'Identifier',
                                name: 'Tr',
                                loc: {
                                    start: {
                                        line: 81,
                                        column: 15,
                                        fixed: true,
                                        source: 'viewpath/html/panes/TaskPane.ion'
                                    },
                                    end: {
                                        line: 81,
                                        column: 17,
                                        fixed: true,
                                        source: 'viewpath/html/panes/TaskPane.ion'
                                    }
                                }
                            },
                            arguments: [],
                            loc: {
                                start: {
                                    line: 81,
                                    column: 15,
                                    fixed: true,
                                    source: 'viewpath/html/panes/TaskPane.ion'
                                },
                                end: {
                                    line: 81,
                                    column: 19,
                                    fixed: true,
                                    source: 'viewpath/html/panes/TaskPane.ion'
                                }
                            }
                        },
                        properties: [
                            {
                                type: 'ExpressionStatement',
                                expression: {
                                    type: 'ObjectExpression',
                                    objectType: {
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'Identifier',
                                            name: 'Td',
                                            loc: {
                                                start: {
                                                    line: 82,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                },
                                                end: {
                                                    line: 82,
                                                    column: 14,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                }
                                            }
                                        },
                                        arguments: [],
                                        loc: {
                                            start: {
                                                line: 82,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/TaskPane.ion'
                                            },
                                            end: {
                                                line: 82,
                                                column: 16,
                                                fixed: true,
                                                source: 'viewpath/html/panes/TaskPane.ion'
                                            }
                                        }
                                    },
                                    properties: [{
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'Identifier',
                                                name: 'label',
                                                loc: {
                                                    start: {
                                                        line: 83,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                    },
                                                    end: {
                                                        line: 83,
                                                        column: 21,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 83,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                },
                                                end: {
                                                    line: 83,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                }
                                            },
                                            order: '0'
                                        }]
                                },
                                loc: {
                                    start: {
                                        line: 82,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/TaskPane.ion'
                                    },
                                    end: {
                                        line: 84,
                                        column: 16,
                                        fixed: true,
                                        source: 'viewpath/html/panes/TaskPane.ion'
                                    }
                                },
                                order: '0'
                            },
                            {
                                type: 'ExpressionStatement',
                                expression: {
                                    type: 'ObjectExpression',
                                    objectType: {
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'Identifier',
                                            name: 'Td',
                                            loc: {
                                                start: {
                                                    line: 84,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                },
                                                end: {
                                                    line: 84,
                                                    column: 14,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                }
                                            }
                                        },
                                        arguments: [{
                                                type: 'ObjectExpression',
                                                properties: [{
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'class',
                                                            loc: {
                                                                start: {
                                                                    line: 84,
                                                                    column: 15,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                },
                                                                end: {
                                                                    line: 84,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'ConditionalExpression',
                                                            test: {
                                                                type: 'UnaryExpression',
                                                                operator: '?',
                                                                argument: {
                                                                    type: 'Identifier',
                                                                    name: 'paneConfig',
                                                                    loc: {
                                                                        start: {
                                                                            line: 84,
                                                                            column: 21,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 84,
                                                                            column: 31,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                        }
                                                                    }
                                                                }
                                                            },
                                                            consequent: {
                                                                type: 'Literal',
                                                                value: 'link'
                                                            },
                                                            alternate: {
                                                                type: 'Literal',
                                                                value: 'black'
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    }]
                                            }],
                                        loc: {
                                            start: {
                                                line: 84,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/TaskPane.ion'
                                            },
                                            end: {
                                                line: 84,
                                                column: 52,
                                                fixed: true,
                                                source: 'viewpath/html/panes/TaskPane.ion'
                                            }
                                        }
                                    },
                                    properties: [
                                        {
                                            type: 'IfStatement',
                                            test: {
                                                type: 'Identifier',
                                                name: 'paneConfig',
                                                loc: {
                                                    start: {
                                                        line: 85,
                                                        column: 19,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                    },
                                                    end: {
                                                        line: 85,
                                                        column: 29,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                    }
                                                }
                                            },
                                            consequent: {
                                                type: 'BlockStatement',
                                                body: [{
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'Function',
                                                            context: true,
                                                            value: function (_context) {
                                                                return function click() {
                                                                    var paneConfig = _context.get('paneConfig');
                                                                    return model.open(paneConfig);
                                                                };
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 86,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                            },
                                                            end: {
                                                                line: 86,
                                                                column: 53,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                            }
                                                        },
                                                        order: '0'
                                                    }]
                                            },
                                            alternate: null,
                                            order: '0'
                                        },
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'Identifier',
                                                name: 'text',
                                                loc: {
                                                    start: {
                                                        line: 87,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                    },
                                                    end: {
                                                        line: 87,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 87,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                },
                                                end: {
                                                    line: 87,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                }
                                            },
                                            order: '1'
                                        }
                                    ]
                                },
                                loc: {
                                    start: {
                                        line: 84,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/TaskPane.ion'
                                    },
                                    end: {
                                        line: 89,
                                        column: 16,
                                        fixed: true,
                                        source: 'viewpath/html/panes/TaskPane.ion'
                                    }
                                },
                                order: '1'
                            }
                        ]
                    },
                    order: '0'
                }],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'TaskInfoRow',
                loc: {
                    start: {
                        line: 80,
                        column: 4,
                        fixed: true,
                        source: 'viewpath/html/panes/TaskPane.ion'
                    },
                    end: {
                        line: 80,
                        column: 15,
                        fixed: true,
                        source: 'viewpath/html/panes/TaskPane.ion'
                    }
                }
            }
        }, {
            this: this,
            label: label,
            text: text,
            paneConfig: paneConfig,
            ion: ion,
            glass: glass,
            _ref: _ref,
            _ref2: _ref2,
            _ref3: _ref3,
            viewpath: viewpath,
            _ref4: _ref4,
            _ref5: _ref5,
            _ref6: _ref6,
            style: style,
            Key: Key,
            Schema: Schema,
            CommentItem: CommentItem,
            Loader: Loader,
            DiscussionEditor: DiscussionEditor,
            User: User,
            Task: Task,
            Project: Project,
            Organization: Organization,
            Comment: Comment,
            TabContent: TabContent,
            Renamer: Renamer,
            Field: Field,
            GlassForm: GlassForm,
            lightGray: lightGray,
            _ref7: _ref7,
            _ref8: _ref8,
            apply: apply,
            TaskInfoRow: TaskInfoRow
        }, null);
    });
module.exports = exports = ion.template(function (config) {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'isDialog',
                            loc: {
                                start: {
                                    line: 91,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/panes/TaskPane.ion'
                                },
                                end: {
                                    line: 91,
                                    column: 16,
                                    fixed: true,
                                    source: 'viewpath/html/panes/TaskPane.ion'
                                }
                            }
                        },
                        init: {
                            type: 'BinaryExpression',
                            operator: '===',
                            left: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'config',
                                    loc: {
                                        start: {
                                            line: 91,
                                            column: 19,
                                            fixed: true,
                                            source: 'viewpath/html/panes/TaskPane.ion'
                                        },
                                        end: {
                                            line: 91,
                                            column: 25,
                                            fixed: true,
                                            source: 'viewpath/html/panes/TaskPane.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'target',
                                    loc: {
                                        start: {
                                            line: 91,
                                            column: 26,
                                            fixed: true,
                                            source: 'viewpath/html/panes/TaskPane.ion'
                                        },
                                        end: {
                                            line: 91,
                                            column: 32,
                                            fixed: true,
                                            source: 'viewpath/html/panes/TaskPane.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 91,
                                        column: 19,
                                        fixed: true,
                                        source: 'viewpath/html/panes/TaskPane.ion'
                                    },
                                    end: {
                                        line: 91,
                                        column: 32,
                                        fixed: true,
                                        source: 'viewpath/html/panes/TaskPane.ion'
                                    }
                                }
                            },
                            right: {
                                type: 'Literal',
                                value: 'dialog'
                            }
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'user',
                            loc: {
                                start: {
                                    line: 93,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/panes/TaskPane.ion'
                                },
                                end: {
                                    line: 93,
                                    column: 12,
                                    fixed: true,
                                    source: 'viewpath/html/panes/TaskPane.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            computed: false,
                            object: {
                                type: 'Identifier',
                                name: 'model',
                                loc: {
                                    start: {
                                        line: 93,
                                        column: 15,
                                        fixed: true,
                                        source: 'viewpath/html/panes/TaskPane.ion'
                                    },
                                    end: {
                                        line: 93,
                                        column: 20,
                                        fixed: true,
                                        source: 'viewpath/html/panes/TaskPane.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'user',
                                loc: {
                                    start: {
                                        line: 93,
                                        column: 21,
                                        fixed: true,
                                        source: 'viewpath/html/panes/TaskPane.ion'
                                    },
                                    end: {
                                        line: 93,
                                        column: 25,
                                        fixed: true,
                                        source: 'viewpath/html/panes/TaskPane.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 93,
                                    column: 15,
                                    fixed: true,
                                    source: 'viewpath/html/panes/TaskPane.ion'
                                },
                                end: {
                                    line: 93,
                                    column: 25,
                                    fixed: true,
                                    source: 'viewpath/html/panes/TaskPane.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'sourceKey',
                            loc: {
                                start: {
                                    line: 94,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/panes/TaskPane.ion'
                                },
                                end: {
                                    line: 94,
                                    column: 17,
                                    fixed: true,
                                    source: 'viewpath/html/panes/TaskPane.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            computed: false,
                            object: {
                                type: 'Identifier',
                                name: 'config',
                                loc: {
                                    start: {
                                        line: 94,
                                        column: 20,
                                        fixed: true,
                                        source: 'viewpath/html/panes/TaskPane.ion'
                                    },
                                    end: {
                                        line: 94,
                                        column: 26,
                                        fixed: true,
                                        source: 'viewpath/html/panes/TaskPane.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'sourceKey',
                                loc: {
                                    start: {
                                        line: 94,
                                        column: 27,
                                        fixed: true,
                                        source: 'viewpath/html/panes/TaskPane.ion'
                                    },
                                    end: {
                                        line: 94,
                                        column: 36,
                                        fixed: true,
                                        source: 'viewpath/html/panes/TaskPane.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 94,
                                    column: 20,
                                    fixed: true,
                                    source: 'viewpath/html/panes/TaskPane.ion'
                                },
                                end: {
                                    line: 94,
                                    column: 36,
                                    fixed: true,
                                    source: 'viewpath/html/panes/TaskPane.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'source',
                            loc: {
                                start: {
                                    line: 95,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/panes/TaskPane.ion'
                                },
                                end: {
                                    line: 95,
                                    column: 14,
                                    fixed: true,
                                    source: 'viewpath/html/panes/TaskPane.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ConditionalExpression',
                            test: {
                                type: 'Identifier',
                                name: 'sourceKey',
                                loc: {
                                    start: {
                                        line: 95,
                                        column: 17,
                                        fixed: true,
                                        source: 'viewpath/html/panes/TaskPane.ion'
                                    },
                                    end: {
                                        line: 95,
                                        column: 26,
                                        fixed: true,
                                        source: 'viewpath/html/panes/TaskPane.ion'
                                    }
                                }
                            },
                            consequent: {
                                type: 'MemberExpression',
                                computed: true,
                                object: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'model',
                                        loc: {
                                            start: {
                                                line: 95,
                                                column: 29,
                                                fixed: true,
                                                source: 'viewpath/html/panes/TaskPane.ion'
                                            },
                                            end: {
                                                line: 95,
                                                column: 34,
                                                fixed: true,
                                                source: 'viewpath/html/panes/TaskPane.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'server',
                                        loc: {
                                            start: {
                                                line: 95,
                                                column: 35,
                                                fixed: true,
                                                source: 'viewpath/html/panes/TaskPane.ion'
                                            },
                                            end: {
                                                line: 95,
                                                column: 41,
                                                fixed: true,
                                                source: 'viewpath/html/panes/TaskPane.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 95,
                                            column: 29,
                                            fixed: true,
                                            source: 'viewpath/html/panes/TaskPane.ion'
                                        },
                                        end: {
                                            line: 95,
                                            column: 41,
                                            fixed: true,
                                            source: 'viewpath/html/panes/TaskPane.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'sourceKey',
                                    loc: {
                                        start: {
                                            line: 95,
                                            column: 42,
                                            fixed: true,
                                            source: 'viewpath/html/panes/TaskPane.ion'
                                        },
                                        end: {
                                            line: 95,
                                            column: 51,
                                            fixed: true,
                                            source: 'viewpath/html/panes/TaskPane.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 95,
                                        column: 29,
                                        fixed: true,
                                        source: 'viewpath/html/panes/TaskPane.ion'
                                    },
                                    end: {
                                        line: 95,
                                        column: 52,
                                        fixed: true,
                                        source: 'viewpath/html/panes/TaskPane.ion'
                                    }
                                }
                            },
                            alternate: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'model',
                                    loc: {
                                        start: {
                                            line: 95,
                                            column: 55,
                                            fixed: true,
                                            source: 'viewpath/html/panes/TaskPane.ion'
                                        },
                                        end: {
                                            line: 95,
                                            column: 60,
                                            fixed: true,
                                            source: 'viewpath/html/panes/TaskPane.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'server',
                                    loc: {
                                        start: {
                                            line: 95,
                                            column: 61,
                                            fixed: true,
                                            source: 'viewpath/html/panes/TaskPane.ion'
                                        },
                                        end: {
                                            line: 95,
                                            column: 67,
                                            fixed: true,
                                            source: 'viewpath/html/panes/TaskPane.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 95,
                                        column: 55,
                                        fixed: true,
                                        source: 'viewpath/html/panes/TaskPane.ion'
                                    },
                                    end: {
                                        line: 95,
                                        column: 67,
                                        fixed: true,
                                        source: 'viewpath/html/panes/TaskPane.ion'
                                    }
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '3'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'taskKey',
                            loc: {
                                start: {
                                    line: 96,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/panes/TaskPane.ion'
                                },
                                end: {
                                    line: 96,
                                    column: 15,
                                    fixed: true,
                                    source: 'viewpath/html/panes/TaskPane.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            computed: false,
                            object: {
                                type: 'Identifier',
                                name: 'config',
                                loc: {
                                    start: {
                                        line: 96,
                                        column: 18,
                                        fixed: true,
                                        source: 'viewpath/html/panes/TaskPane.ion'
                                    },
                                    end: {
                                        line: 96,
                                        column: 24,
                                        fixed: true,
                                        source: 'viewpath/html/panes/TaskPane.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'key',
                                loc: {
                                    start: {
                                        line: 96,
                                        column: 25,
                                        fixed: true,
                                        source: 'viewpath/html/panes/TaskPane.ion'
                                    },
                                    end: {
                                        line: 96,
                                        column: 28,
                                        fixed: true,
                                        source: 'viewpath/html/panes/TaskPane.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 96,
                                    column: 18,
                                    fixed: true,
                                    source: 'viewpath/html/panes/TaskPane.ion'
                                },
                                end: {
                                    line: 96,
                                    column: 28,
                                    fixed: true,
                                    source: 'viewpath/html/panes/TaskPane.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '4'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'task',
                            loc: {
                                start: {
                                    line: 97,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/panes/TaskPane.ion'
                                },
                                end: {
                                    line: 97,
                                    column: 12,
                                    fixed: true,
                                    source: 'viewpath/html/panes/TaskPane.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            computed: true,
                            object: {
                                type: 'Identifier',
                                name: 'source',
                                loc: {
                                    start: {
                                        line: 97,
                                        column: 15,
                                        fixed: true,
                                        source: 'viewpath/html/panes/TaskPane.ion'
                                    },
                                    end: {
                                        line: 97,
                                        column: 21,
                                        fixed: true,
                                        source: 'viewpath/html/panes/TaskPane.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'taskKey',
                                loc: {
                                    start: {
                                        line: 97,
                                        column: 22,
                                        fixed: true,
                                        source: 'viewpath/html/panes/TaskPane.ion'
                                    },
                                    end: {
                                        line: 97,
                                        column: 29,
                                        fixed: true,
                                        source: 'viewpath/html/panes/TaskPane.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 97,
                                    column: 15,
                                    fixed: true,
                                    source: 'viewpath/html/panes/TaskPane.ion'
                                },
                                end: {
                                    line: 97,
                                    column: 30,
                                    fixed: true,
                                    source: 'viewpath/html/panes/TaskPane.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '5'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'taskClone',
                            loc: {
                                start: {
                                    line: 99,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/panes/TaskPane.ion'
                                },
                                end: {
                                    line: 99,
                                    column: 17,
                                    fixed: true,
                                    source: 'viewpath/html/panes/TaskPane.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'ion',
                                    loc: {
                                        start: {
                                            line: 99,
                                            column: 20,
                                            fixed: true,
                                            source: 'viewpath/html/panes/TaskPane.ion'
                                        },
                                        end: {
                                            line: 99,
                                            column: 23,
                                            fixed: true,
                                            source: 'viewpath/html/panes/TaskPane.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'deserialize',
                                    loc: {
                                        start: {
                                            line: 99,
                                            column: 24,
                                            fixed: true,
                                            source: 'viewpath/html/panes/TaskPane.ion'
                                        },
                                        end: {
                                            line: 99,
                                            column: 35,
                                            fixed: true,
                                            source: 'viewpath/html/panes/TaskPane.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 99,
                                        column: 20,
                                        fixed: true,
                                        source: 'viewpath/html/panes/TaskPane.ion'
                                    },
                                    end: {
                                        line: 99,
                                        column: 35,
                                        fixed: true,
                                        source: 'viewpath/html/panes/TaskPane.ion'
                                    }
                                }
                            },
                            arguments: [
                                {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'ion',
                                            loc: {
                                                start: {
                                                    line: 99,
                                                    column: 36,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                },
                                                end: {
                                                    line: 99,
                                                    column: 39,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'serialize',
                                            loc: {
                                                start: {
                                                    line: 99,
                                                    column: 40,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                },
                                                end: {
                                                    line: 99,
                                                    column: 49,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 99,
                                                column: 36,
                                                fixed: true,
                                                source: 'viewpath/html/panes/TaskPane.ion'
                                            },
                                            end: {
                                                line: 99,
                                                column: 49,
                                                fixed: true,
                                                source: 'viewpath/html/panes/TaskPane.ion'
                                            }
                                        }
                                    },
                                    arguments: [{
                                            type: 'Identifier',
                                            name: 'task',
                                            loc: {
                                                start: {
                                                    line: 99,
                                                    column: 50,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                },
                                                end: {
                                                    line: 99,
                                                    column: 54,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                }
                                            }
                                        }],
                                    loc: {
                                        start: {
                                            line: 99,
                                            column: 36,
                                            fixed: true,
                                            source: 'viewpath/html/panes/TaskPane.ion'
                                        },
                                        end: {
                                            line: 99,
                                            column: 55,
                                            fixed: true,
                                            source: 'viewpath/html/panes/TaskPane.ion'
                                        }
                                    }
                                },
                                {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'viewpath',
                                        loc: {
                                            start: {
                                                line: 99,
                                                column: 56,
                                                fixed: true,
                                                source: 'viewpath/html/panes/TaskPane.ion'
                                            },
                                            end: {
                                                line: 99,
                                                column: 64,
                                                fixed: true,
                                                source: 'viewpath/html/panes/TaskPane.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'model',
                                        loc: {
                                            start: {
                                                line: 99,
                                                column: 65,
                                                fixed: true,
                                                source: 'viewpath/html/panes/TaskPane.ion'
                                            },
                                            end: {
                                                line: 99,
                                                column: 70,
                                                fixed: true,
                                                source: 'viewpath/html/panes/TaskPane.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 99,
                                            column: 56,
                                            fixed: true,
                                            source: 'viewpath/html/panes/TaskPane.ion'
                                        },
                                        end: {
                                            line: 99,
                                            column: 70,
                                            fixed: true,
                                            source: 'viewpath/html/panes/TaskPane.ion'
                                        }
                                    }
                                }
                            ],
                            loc: {
                                start: {
                                    line: 99,
                                    column: 20,
                                    fixed: true,
                                    source: 'viewpath/html/panes/TaskPane.ion'
                                },
                                end: {
                                    line: 99,
                                    column: 71,
                                    fixed: true,
                                    source: 'viewpath/html/panes/TaskPane.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '6'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'CallExpression',
                        callee: {
                            type: 'Identifier',
                            name: 'Div',
                            loc: {
                                start: {
                                    line: 101,
                                    column: 11,
                                    fixed: true,
                                    source: 'viewpath/html/panes/TaskPane.ion'
                                },
                                end: {
                                    line: 101,
                                    column: 14,
                                    fixed: true,
                                    source: 'viewpath/html/panes/TaskPane.ion'
                                }
                            }
                        },
                        arguments: [{
                                type: 'ObjectExpression',
                                properties: [{
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'class',
                                            loc: {
                                                start: {
                                                    line: 101,
                                                    column: 15,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                },
                                                end: {
                                                    line: 101,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: 'fill layout vertical TaskPane'
                                        },
                                        kind: 'init',
                                        order: '0'
                                    }]
                            }],
                        loc: {
                            start: {
                                line: 101,
                                column: 11,
                                fixed: true,
                                source: 'viewpath/html/panes/TaskPane.ion'
                            },
                            end: {
                                line: 101,
                                column: 53,
                                fixed: true,
                                source: 'viewpath/html/panes/TaskPane.ion'
                            }
                        }
                    },
                    properties: [
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'style',
                                loc: {
                                    start: {
                                        line: 102,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/html/panes/TaskPane.ion'
                                    },
                                    end: {
                                        line: 102,
                                        column: 13,
                                        fixed: true,
                                        source: 'viewpath/html/panes/TaskPane.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'ObjectExpression',
                                properties: [{
                                        type: 'IfStatement',
                                        test: {
                                            type: 'Identifier',
                                            name: 'isDialog',
                                            loc: {
                                                start: {
                                                    line: 103,
                                                    column: 15,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                },
                                                end: {
                                                    line: 103,
                                                    column: 23,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                }
                                            }
                                        },
                                        consequent: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'width',
                                                        loc: {
                                                            start: {
                                                                line: 104,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                            },
                                                            end: {
                                                                line: 104,
                                                                column: 21,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: '800px'
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                }]
                                        },
                                        alternate: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'width',
                                                        loc: {
                                                            start: {
                                                                line: 106,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                            },
                                                            end: {
                                                                line: 106,
                                                                column: 21,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: '100%'
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                }]
                                        },
                                        order: '0'
                                    }]
                            },
                            kind: 'init',
                            order: '0'
                        },
                        {
                            type: 'IfStatement',
                            test: {
                                type: 'UnaryExpression',
                                operator: '?',
                                argument: {
                                    type: 'Identifier',
                                    name: 'taskClone',
                                    loc: {
                                        start: {
                                            line: 107,
                                            column: 11,
                                            fixed: true,
                                            source: 'viewpath/html/panes/TaskPane.ion'
                                        },
                                        end: {
                                            line: 107,
                                            column: 20,
                                            fixed: true,
                                            source: 'viewpath/html/panes/TaskPane.ion'
                                        }
                                    }
                                }
                            },
                            consequent: {
                                type: 'BlockStatement',
                                body: [
                                    {
                                        type: 'VariableDeclaration',
                                        declarations: [{
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'parentKey',
                                                    loc: {
                                                        start: {
                                                            line: 108,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                        },
                                                        end: {
                                                            line: 108,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                        }
                                                    }
                                                },
                                                init: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'task',
                                                                loc: {
                                                                    start: {
                                                                        line: 108,
                                                                        column: 28,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 108,
                                                                        column: 32,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'getKey',
                                                                loc: {
                                                                    start: {
                                                                        line: 108,
                                                                        column: 33,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 108,
                                                                        column: 39,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 108,
                                                                    column: 28,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                },
                                                                end: {
                                                                    line: 108,
                                                                    column: 39,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [],
                                                        loc: {
                                                            start: {
                                                                line: 108,
                                                                column: 28,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                            },
                                                            end: {
                                                                line: 108,
                                                                column: 41,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'parent',
                                                        loc: {
                                                            start: {
                                                                line: 108,
                                                                column: 42,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                            },
                                                            end: {
                                                                line: 108,
                                                                column: 48,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 108,
                                                            column: 28,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                        },
                                                        end: {
                                                            line: 108,
                                                            column: 48,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                        }
                                                    }
                                                }
                                            }],
                                        kind: 'let',
                                        order: '0'
                                    },
                                    {
                                        type: 'VariableDeclaration',
                                        declarations: [{
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'project',
                                                    loc: {
                                                        start: {
                                                            line: 109,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                        },
                                                        end: {
                                                            line: 109,
                                                            column: 23,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                        }
                                                    }
                                                },
                                                init: {
                                                    type: 'MemberExpression',
                                                    computed: true,
                                                    object: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'model',
                                                            loc: {
                                                                start: {
                                                                    line: 109,
                                                                    column: 26,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                },
                                                                end: {
                                                                    line: 109,
                                                                    column: 31,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'server',
                                                            loc: {
                                                                start: {
                                                                    line: 109,
                                                                    column: 32,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                },
                                                                end: {
                                                                    line: 109,
                                                                    column: 38,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 109,
                                                                column: 26,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                            },
                                                            end: {
                                                                line: 109,
                                                                column: 38,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'parentKey',
                                                        loc: {
                                                            start: {
                                                                line: 109,
                                                                column: 39,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                            },
                                                            end: {
                                                                line: 109,
                                                                column: 48,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 109,
                                                            column: 26,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                        },
                                                        end: {
                                                            line: 109,
                                                            column: 49,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                        }
                                                    }
                                                }
                                            }],
                                        kind: 'let',
                                        order: '1'
                                    },
                                    {
                                        type: 'VariableDeclaration',
                                        declarations: [{
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'state',
                                                    loc: {
                                                        start: {
                                                            line: 110,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                        },
                                                        end: {
                                                            line: 110,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                        }
                                                    }
                                                },
                                                init: {
                                                    type: 'ObjectExpression',
                                                    properties: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'view',
                                                                loc: {
                                                                    start: {
                                                                        line: 110,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 110,
                                                                        column: 29,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Literal',
                                                                value: 'properties'
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                }
                                            }],
                                        kind: 'let',
                                        order: '2'
                                    },
                                    {
                                        type: 'VariableDeclaration',
                                        declarations: [{
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'orgKey',
                                                    loc: {
                                                        start: {
                                                            line: 112,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                        },
                                                        end: {
                                                            line: 112,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                        }
                                                    }
                                                },
                                                init: {
                                                    type: 'NewExpression',
                                                    callee: {
                                                        type: 'Identifier',
                                                        name: 'Key',
                                                        loc: {
                                                            start: {
                                                                line: 112,
                                                                column: 29,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                            },
                                                            end: {
                                                                line: 112,
                                                                column: 32,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [
                                                        {
                                                            type: 'Identifier',
                                                            name: 'Organization',
                                                            loc: {
                                                                start: {
                                                                    line: 112,
                                                                    column: 33,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                },
                                                                end: {
                                                                    line: 112,
                                                                    column: 45,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                }
                                                            }
                                                        },
                                                        {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'task',
                                                                loc: {
                                                                    start: {
                                                                        line: 112,
                                                                        column: 47,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 112,
                                                                        column: 51,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'orgId',
                                                                loc: {
                                                                    start: {
                                                                        line: 112,
                                                                        column: 52,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 112,
                                                                        column: 57,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 112,
                                                                    column: 47,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                },
                                                                end: {
                                                                    line: 112,
                                                                    column: 57,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                }
                                                            }
                                                        }
                                                    ],
                                                    loc: {
                                                        start: {
                                                            line: 112,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                        },
                                                        end: {
                                                            line: 112,
                                                            column: 58,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                        }
                                                    }
                                                }
                                            }],
                                        kind: 'let',
                                        order: '3'
                                    },
                                    {
                                        type: 'VariableDeclaration',
                                        declarations: [{
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'org',
                                                    loc: {
                                                        start: {
                                                            line: 113,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                        },
                                                        end: {
                                                            line: 113,
                                                            column: 19,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                        }
                                                    }
                                                },
                                                init: {
                                                    type: 'MemberExpression',
                                                    computed: true,
                                                    object: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'model',
                                                            loc: {
                                                                start: {
                                                                    line: 113,
                                                                    column: 22,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                },
                                                                end: {
                                                                    line: 113,
                                                                    column: 27,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'server',
                                                            loc: {
                                                                start: {
                                                                    line: 113,
                                                                    column: 28,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                },
                                                                end: {
                                                                    line: 113,
                                                                    column: 34,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 113,
                                                                column: 22,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                            },
                                                            end: {
                                                                line: 113,
                                                                column: 34,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'orgKey',
                                                        loc: {
                                                            start: {
                                                                line: 113,
                                                                column: 35,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                            },
                                                            end: {
                                                                line: 113,
                                                                column: 41,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 113,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                        },
                                                        end: {
                                                            line: 113,
                                                            column: 42,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                        }
                                                    }
                                                }
                                            }],
                                        kind: 'let',
                                        order: '4'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'noPaneBar',
                                            loc: {
                                                start: {
                                                    line: 115,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                },
                                                end: {
                                                    line: 115,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: true
                                        },
                                        kind: 'init',
                                        order: '5'
                                    },
                                    {
                                        type: 'VariableDeclaration',
                                        declarations: [{
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'diff',
                                                    loc: {
                                                        start: {
                                                            line: 120,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                        },
                                                        end: {
                                                            line: 120,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                        }
                                                    }
                                                },
                                                init: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'ion',
                                                                loc: {
                                                                    start: {
                                                                        line: 120,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 120,
                                                                        column: 26,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'patch',
                                                                loc: {
                                                                    start: {
                                                                        line: 120,
                                                                        column: 27,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 120,
                                                                        column: 32,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 120,
                                                                    column: 23,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                },
                                                                end: {
                                                                    line: 120,
                                                                    column: 32,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'diff',
                                                            loc: {
                                                                start: {
                                                                    line: 120,
                                                                    column: 33,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                },
                                                                end: {
                                                                    line: 120,
                                                                    column: 37,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 120,
                                                                column: 23,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                            },
                                                            end: {
                                                                line: 120,
                                                                column: 37,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [
                                                        {
                                                            type: 'Identifier',
                                                            name: 'task',
                                                            loc: {
                                                                start: {
                                                                    line: 120,
                                                                    column: 43,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                },
                                                                end: {
                                                                    line: 120,
                                                                    column: 47,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                }
                                                            },
                                                            deep: true
                                                        },
                                                        {
                                                            type: 'Identifier',
                                                            name: 'taskClone',
                                                            loc: {
                                                                start: {
                                                                    line: 120,
                                                                    column: 54,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                },
                                                                end: {
                                                                    line: 120,
                                                                    column: 63,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                }
                                                            },
                                                            deep: true
                                                        }
                                                    ],
                                                    loc: {
                                                        start: {
                                                            line: 120,
                                                            column: 23,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                        },
                                                        end: {
                                                            line: 120,
                                                            column: 64,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                        }
                                                    }
                                                }
                                            }],
                                        kind: 'let',
                                        order: '6'
                                    },
                                    {
                                        type: 'VariableDeclaration',
                                        declarations: [{
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'hasChanges',
                                                    loc: {
                                                        start: {
                                                            line: 121,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                        },
                                                        end: {
                                                            line: 121,
                                                            column: 26,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                        }
                                                    }
                                                },
                                                init: {
                                                    type: 'BinaryExpression',
                                                    operator: '!==',
                                                    left: {
                                                        type: 'Identifier',
                                                        name: 'diff',
                                                        loc: {
                                                            start: {
                                                                line: 121,
                                                                column: 29,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                            },
                                                            end: {
                                                                line: 121,
                                                                column: 33,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                            }
                                                        }
                                                    },
                                                    right: {
                                                        type: 'UnaryExpression',
                                                        operator: 'void',
                                                        prefix: true,
                                                        argument: {
                                                            type: 'Literal',
                                                            value: 0
                                                        }
                                                    }
                                                }
                                            }],
                                        kind: 'let',
                                        order: '7'
                                    },
                                    {
                                        type: 'VariableDeclaration',
                                        declarations: [{
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'FormFooter',
                                                    loc: {
                                                        start: {
                                                            line: 124,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                        },
                                                        end: {
                                                            line: 124,
                                                            column: 26,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                        }
                                                    }
                                                },
                                                init: {
                                                    type: 'Function',
                                                    context: true,
                                                    value: function (_ps) {
                                                        return ion.template(function () {
                                                            return ion.createRuntime({
                                                                type: 'Template',
                                                                id: null,
                                                                body: [{
                                                                        type: 'ReturnStatement',
                                                                        argument: {
                                                                            type: 'ObjectExpression',
                                                                            objectType: {
                                                                                type: 'CallExpression',
                                                                                callee: {
                                                                                    type: 'Identifier',
                                                                                    name: 'Footer',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 125,
                                                                                            column: 23,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 125,
                                                                                            column: 29,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                arguments: [{
                                                                                        type: 'ObjectExpression',
                                                                                        properties: [{
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'class',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 125,
                                                                                                            column: 30,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 125,
                                                                                                            column: 35,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'Literal',
                                                                                                    value: 'layout horizontal reverse'
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '0'
                                                                                            }]
                                                                                    }],
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 125,
                                                                                        column: 23,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 125,
                                                                                        column: 64,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            properties: [
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'style',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 126,
                                                                                                column: 20,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 126,
                                                                                                column: 25,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'ObjectExpression',
                                                                                        properties: [
                                                                                            {
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'padding',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 127,
                                                                                                            column: 24,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 127,
                                                                                                            column: 31,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'Literal',
                                                                                                    value: '0px'
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '0'
                                                                                            },
                                                                                            {
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'margin',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 128,
                                                                                                            column: 24,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 128,
                                                                                                            column: 30,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'Literal',
                                                                                                    value: '8px 2px'
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '1'
                                                                                            }
                                                                                        ]
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                },
                                                                                {
                                                                                    type: 'ExpressionStatement',
                                                                                    expression: {
                                                                                        type: 'ObjectExpression',
                                                                                        objectType: {
                                                                                            type: 'CallExpression',
                                                                                            callee: {
                                                                                                type: 'Identifier',
                                                                                                name: 'PaperButton',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 129,
                                                                                                        column: 20,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 129,
                                                                                                        column: 31,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            arguments: [],
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 129,
                                                                                                    column: 20,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 129,
                                                                                                    column: 33,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        properties: [
                                                                                            {
                                                                                                type: 'ExpressionStatement',
                                                                                                expression: {
                                                                                                    type: 'Function',
                                                                                                    context: true,
                                                                                                    value: function (_context2) {
                                                                                                        return function click() {
                                                                                                            var apply = _context2.get('apply'), ion = _context2.get('ion'), task = _context2.get('task'), taskClone = _context2.get('taskClone'), isDialog = _context2.get('isDialog'), config = _context2.get('config');
                                                                                                            apply(ion.patch.diff(task, taskClone), task);
                                                                                                            if (isDialog) {
                                                                                                                model.close(config);
                                                                                                            }
                                                                                                        };
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 130,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 134,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                    }
                                                                                                },
                                                                                                order: '0'
                                                                                            },
                                                                                            {
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'disabled',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 134,
                                                                                                            column: 24,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 134,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'UnaryExpression',
                                                                                                    operator: '!',
                                                                                                    argument: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'hasChanges',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 134,
                                                                                                                column: 38,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 134,
                                                                                                                column: 48,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '1'
                                                                                            },
                                                                                            {
                                                                                                type: 'ExpressionStatement',
                                                                                                expression: {
                                                                                                    type: 'Literal',
                                                                                                    value: 'Apply'
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 135,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 135,
                                                                                                        column: 31,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                    }
                                                                                                },
                                                                                                order: '2'
                                                                                            }
                                                                                        ]
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 129,
                                                                                            column: 20,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 136,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                        }
                                                                                    },
                                                                                    order: '1'
                                                                                },
                                                                                {
                                                                                    type: 'IfStatement',
                                                                                    test: {
                                                                                        type: 'Identifier',
                                                                                        name: 'isDialog',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 136,
                                                                                                column: 23,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 136,
                                                                                                column: 31,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    consequent: {
                                                                                        type: 'BlockStatement',
                                                                                        body: [{
                                                                                                type: 'ExpressionStatement',
                                                                                                expression: {
                                                                                                    type: 'ObjectExpression',
                                                                                                    objectType: {
                                                                                                        type: 'CallExpression',
                                                                                                        callee: {
                                                                                                            type: 'Identifier',
                                                                                                            name: 'PaperButton',
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 137,
                                                                                                                    column: 24,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 137,
                                                                                                                    column: 35,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        arguments: [],
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 137,
                                                                                                                column: 24,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 137,
                                                                                                                column: 37,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    properties: [
                                                                                                        {
                                                                                                            type: 'ExpressionStatement',
                                                                                                            expression: {
                                                                                                                type: 'Function',
                                                                                                                context: true,
                                                                                                                value: function (_context3) {
                                                                                                                    return function click() {
                                                                                                                        var config = _context3.get('config');
                                                                                                                        return model.close(config);
                                                                                                                    };
                                                                                                                }
                                                                                                            },
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 138,
                                                                                                                    column: 28,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 138,
                                                                                                                    column: 58,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                }
                                                                                                            },
                                                                                                            order: '0'
                                                                                                        },
                                                                                                        {
                                                                                                            type: 'ExpressionStatement',
                                                                                                            expression: {
                                                                                                                type: 'ConditionalExpression',
                                                                                                                test: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'hasChanges',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 139,
                                                                                                                            column: 28,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 139,
                                                                                                                            column: 38,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                consequent: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: 'Cancel'
                                                                                                                },
                                                                                                                alternate: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: 'Close'
                                                                                                                }
                                                                                                            },
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 139,
                                                                                                                    column: 28,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 139,
                                                                                                                    column: 59,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                }
                                                                                                            },
                                                                                                            order: '1'
                                                                                                        }
                                                                                                    ]
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 137,
                                                                                                        column: 24,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 141,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                    }
                                                                                                },
                                                                                                order: '0'
                                                                                            }]
                                                                                    },
                                                                                    alternate: null,
                                                                                    order: '2'
                                                                                }
                                                                            ]
                                                                        },
                                                                        order: '0'
                                                                    }],
                                                                bound: false,
                                                                name: {
                                                                    type: 'Identifier',
                                                                    name: 'FormFooter',
                                                                    loc: {
                                                                        start: {
                                                                            line: 124,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 124,
                                                                            column: 26,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                scope: {
                                                                    type: 'Identifier',
                                                                    name: '_ps'
                                                                }
                                                            }, {
                                                                this: this,
                                                                ion: ion,
                                                                _ps: _ps,
                                                                config: config,
                                                                glass: glass,
                                                                _ref: _ref,
                                                                _ref2: _ref2,
                                                                _ref3: _ref3,
                                                                viewpath: viewpath,
                                                                _ref4: _ref4,
                                                                _ref5: _ref5,
                                                                _ref6: _ref6,
                                                                style: style,
                                                                Key: Key,
                                                                Schema: Schema,
                                                                CommentItem: CommentItem,
                                                                Loader: Loader,
                                                                DiscussionEditor: DiscussionEditor,
                                                                User: User,
                                                                Task: Task,
                                                                Project: Project,
                                                                Organization: Organization,
                                                                Comment: Comment,
                                                                TabContent: TabContent,
                                                                Renamer: Renamer,
                                                                Field: Field,
                                                                GlassForm: GlassForm,
                                                                lightGray: lightGray,
                                                                _ref7: _ref7,
                                                                _ref8: _ref8,
                                                                apply: apply,
                                                                TaskInfoRow: TaskInfoRow
                                                            }, _ps);
                                                        });
                                                    }
                                                }
                                            }],
                                        kind: 'let',
                                        order: '8'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'ObjectExpression',
                                            objectType: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'Div',
                                                    loc: {
                                                        start: {
                                                            line: 141,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                        },
                                                        end: {
                                                            line: 141,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [{
                                                        type: 'ObjectExpression',
                                                        properties: [{
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'class',
                                                                    loc: {
                                                                        start: {
                                                                            line: 141,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 141,
                                                                            column: 21,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: 'layout fixed horizontal center center-justified TaskNameInput'
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            }]
                                                    }],
                                                loc: {
                                                    start: {
                                                        line: 141,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                    },
                                                    end: {
                                                        line: 141,
                                                        column: 86,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                    }
                                                }
                                            },
                                            properties: [
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'style',
                                                        loc: {
                                                            start: {
                                                                line: 142,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                            },
                                                            end: {
                                                                line: 142,
                                                                column: 21,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'ObjectExpression',
                                                        properties: [
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'backgroundColor',
                                                                    loc: {
                                                                        start: {
                                                                            line: 143,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 143,
                                                                            column: 35,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Identifier',
                                                                    name: 'lightGray',
                                                                    loc: {
                                                                        start: {
                                                                            line: 143,
                                                                            column: 37,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 143,
                                                                            column: 46,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'position',
                                                                    loc: {
                                                                        start: {
                                                                            line: 144,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 144,
                                                                            column: 28,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: 'relative'
                                                                },
                                                                kind: 'init',
                                                                order: '1'
                                                            }
                                                        ]
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'PaperIconButton',
                                                                loc: {
                                                                    start: {
                                                                        line: 145,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 145,
                                                                        column: 31,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [{
                                                                    type: 'ObjectExpression',
                                                                    properties: [{
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'class',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 145,
                                                                                        column: 32,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 145,
                                                                                        column: 37,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'secondary'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        }]
                                                                }],
                                                            loc: {
                                                                start: {
                                                                    line: 145,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                },
                                                                end: {
                                                                    line: 145,
                                                                    column: 50,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'Function',
                                                                    context: true,
                                                                    value: function (_context4) {
                                                                        return function click() {
                                                                            var config = _context4.get('config');
                                                                            return model.close(config);
                                                                        };
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 146,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 146,
                                                                        column: 50,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'icon',
                                                                    loc: {
                                                                        start: {
                                                                            line: 147,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 147,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: 'clear'
                                                                },
                                                                kind: 'init',
                                                                order: '1'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'style',
                                                                    loc: {
                                                                        start: {
                                                                            line: 148,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 148,
                                                                            column: 25,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'ObjectExpression',
                                                                    properties: [
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'position',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 149,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 149,
                                                                                        column: 32,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'absolute'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'top',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 150,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 150,
                                                                                        column: 27,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: '4px'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '1'
                                                                        },
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'right',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 151,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 151,
                                                                                        column: 29,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: '4px'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '2'
                                                                        }
                                                                    ]
                                                                },
                                                                kind: 'init',
                                                                order: '2'
                                                            }
                                                        ]
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 145,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                        },
                                                        end: {
                                                            line: 152,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                        }
                                                    },
                                                    order: '1'
                                                },
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'Field',
                                                                loc: {
                                                                    start: {
                                                                        line: 152,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 152,
                                                                        column: 21,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [{
                                                                    type: 'ObjectExpression',
                                                                    properties: [
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'property',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 152,
                                                                                        column: 22,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 152,
                                                                                        column: 30,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'Task',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 152,
                                                                                                column: 31,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 152,
                                                                                                column: 35,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'properties',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 152,
                                                                                                column: 36,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 152,
                                                                                                column: 46,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 152,
                                                                                            column: 31,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 152,
                                                                                            column: 46,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'name',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 152,
                                                                                            column: 47,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 152,
                                                                                            column: 51,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 152,
                                                                                        column: 31,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 152,
                                                                                        column: 51,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'object',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 152,
                                                                                        column: 53,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 152,
                                                                                        column: 59,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Identifier',
                                                                                name: 'taskClone',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 152,
                                                                                        column: 60,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 152,
                                                                                        column: 69,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            kind: 'init',
                                                                            order: '1'
                                                                        },
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'bind',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 152,
                                                                                        column: 71,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 152,
                                                                                        column: 75,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: true
                                                                            },
                                                                            kind: 'init',
                                                                            order: '2'
                                                                        }
                                                                    ]
                                                                }],
                                                            loc: {
                                                                start: {
                                                                    line: 152,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                },
                                                                end: {
                                                                    line: 152,
                                                                    column: 81,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'label',
                                                                    loc: {
                                                                        start: {
                                                                            line: 153,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 153,
                                                                            column: 25,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: ''
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'classList',
                                                                    loc: {
                                                                        start: {
                                                                            line: 154,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 154,
                                                                            column: 29,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'ArrayExpression',
                                                                    elements: [{
                                                                            type: 'Literal',
                                                                            value: 'flex'
                                                                        }]
                                                                },
                                                                kind: 'init',
                                                                order: '1'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'style',
                                                                    loc: {
                                                                        start: {
                                                                            line: 155,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 155,
                                                                            column: 25,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'ObjectExpression',
                                                                    properties: [
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'paddingLeft',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 156,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 156,
                                                                                        column: 35,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: '24px'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'paddingRight',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 157,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 157,
                                                                                        column: 36,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: '24px'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '1'
                                                                        }
                                                                    ]
                                                                },
                                                                kind: 'init',
                                                                order: '2'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'ObjectExpression',
                                                                    objectType: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'Identifier',
                                                                            name: 'Div',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 158,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 158,
                                                                                    column: 23,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [{
                                                                                type: 'ObjectExpression',
                                                                                properties: [{
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'prefix',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 158,
                                                                                                    column: 24,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 158,
                                                                                                    column: 30,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: true
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    }]
                                                                            }],
                                                                        loc: {
                                                                            start: {
                                                                                line: 158,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 158,
                                                                                column: 36,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    properties: [
                                                                        {
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'ObjectExpression',
                                                                                objectType: {
                                                                                    type: 'CallExpression',
                                                                                    callee: {
                                                                                        type: 'Identifier',
                                                                                        name: 'Span',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 159,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 159,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    arguments: [],
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 159,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 159,
                                                                                            column: 30,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                properties: [
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'Function',
                                                                                            context: true,
                                                                                            value: function (_context5) {
                                                                                                return function click() {
                                                                                                    var task = _context5.get('task');
                                                                                                    return model.open(task.projectPaneConfig, { replace: true });
                                                                                                };
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 160,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 160,
                                                                                                column: 90,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'style',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 161,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 161,
                                                                                                    column: 33,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'ObjectExpression',
                                                                                            properties: [
                                                                                                {
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'borderBottom',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 162,
                                                                                                                column: 32,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 162,
                                                                                                                column: 44,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'BinaryExpression',
                                                                                                        operator: '+',
                                                                                                        left: {
                                                                                                            type: 'Literal',
                                                                                                            value: '2px solid '
                                                                                                        },
                                                                                                        right: {
                                                                                                            type: 'CallExpression',
                                                                                                            callee: {
                                                                                                                type: 'MemberExpression',
                                                                                                                computed: false,
                                                                                                                object: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'style',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 162,
                                                                                                                            column: 59,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 162,
                                                                                                                            column: 64,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                property: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'toRgba',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 162,
                                                                                                                            column: 65,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 162,
                                                                                                                            column: 71,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 162,
                                                                                                                        column: 59,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 162,
                                                                                                                        column: 71,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            arguments: [
                                                                                                                {
                                                                                                                    type: 'MemberExpression',
                                                                                                                    computed: false,
                                                                                                                    object: {
                                                                                                                        type: 'MemberExpression',
                                                                                                                        computed: false,
                                                                                                                        object: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'style',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 162,
                                                                                                                                    column: 72,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 162,
                                                                                                                                    column: 77,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        property: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'color',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 162,
                                                                                                                                    column: 78,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 162,
                                                                                                                                    column: 83,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 162,
                                                                                                                                column: 72,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 162,
                                                                                                                                column: 83,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    property: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'black',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 162,
                                                                                                                                column: 84,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 162,
                                                                                                                                column: 89,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 162,
                                                                                                                            column: 72,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 162,
                                                                                                                            column: 89,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                {
                                                                                                                    type: 'MemberExpression',
                                                                                                                    computed: false,
                                                                                                                    object: {
                                                                                                                        type: 'MemberExpression',
                                                                                                                        computed: false,
                                                                                                                        object: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'style',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 162,
                                                                                                                                    column: 91,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 162,
                                                                                                                                    column: 96,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        property: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'opacity',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 162,
                                                                                                                                    column: 97,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 162,
                                                                                                                                    column: 104,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 162,
                                                                                                                                column: 91,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 162,
                                                                                                                                column: 104,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    property: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'secondary',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 162,
                                                                                                                                column: 105,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 162,
                                                                                                                                column: 114,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 162,
                                                                                                                            column: 91,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 162,
                                                                                                                            column: 114,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                }
                                                                                                            ],
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 162,
                                                                                                                    column: 59,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 162,
                                                                                                                    column: 115,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '0'
                                                                                                },
                                                                                                {
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'cursor',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 163,
                                                                                                                column: 32,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 163,
                                                                                                                column: 38,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'Literal',
                                                                                                        value: 'pointer'
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '1'
                                                                                                }
                                                                                            ]
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '1'
                                                                                    },
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'ConditionalExpression',
                                                                                            test: {
                                                                                                type: 'BinaryExpression',
                                                                                                operator: '!=',
                                                                                                left: {
                                                                                                    type: 'MemberExpression',
                                                                                                    computed: false,
                                                                                                    object: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'project',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 164,
                                                                                                                column: 28,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 164,
                                                                                                                column: 35,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    property: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'name',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 164,
                                                                                                                column: 36,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 164,
                                                                                                                column: 40,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 164,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 164,
                                                                                                            column: 40,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                right: {
                                                                                                    type: 'Literal',
                                                                                                    value: null
                                                                                                }
                                                                                            },
                                                                                            consequent: {
                                                                                                type: 'MemberExpression',
                                                                                                computed: false,
                                                                                                object: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'project',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 164,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 164,
                                                                                                            column: 35,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'name',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 164,
                                                                                                            column: 36,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 164,
                                                                                                            column: 40,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 164,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 164,
                                                                                                        column: 40,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            alternate: {
                                                                                                type: 'Literal',
                                                                                                value: '...'
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 164,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 164,
                                                                                                column: 48,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '2'
                                                                                    }
                                                                                ]
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 159,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 165,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'ObjectExpression',
                                                                                objectType: {
                                                                                    type: 'CallExpression',
                                                                                    callee: {
                                                                                        type: 'Identifier',
                                                                                        name: 'Span',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 165,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 165,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    arguments: [{
                                                                                            type: 'ObjectExpression',
                                                                                            properties: [{
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'style',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 165,
                                                                                                                column: 29,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 165,
                                                                                                                column: 34,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'Literal',
                                                                                                        value: 'padding-right:4px'
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '0'
                                                                                                }]
                                                                                        }],
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 165,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 165,
                                                                                            column: 55,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                properties: [{
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'Literal',
                                                                                            value: ' \u25B8 '
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 166,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 166,
                                                                                                column: 38,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 165,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 168,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                }
                                                                            },
                                                                            order: '1'
                                                                        }
                                                                    ]
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 158,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 168,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                    }
                                                                },
                                                                order: '3'
                                                            }
                                                        ]
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 152,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                        },
                                                        end: {
                                                            line: 168,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                        }
                                                    },
                                                    order: '2'
                                                }
                                            ]
                                        },
                                        loc: {
                                            start: {
                                                line: 141,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/TaskPane.ion'
                                            },
                                            end: {
                                                line: 168,
                                                column: 16,
                                                fixed: true,
                                                source: 'viewpath/html/panes/TaskPane.ion'
                                            }
                                        },
                                        order: '9'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'Identifier',
                                                name: 'TabContent',
                                                loc: {
                                                    start: {
                                                        line: 168,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                    },
                                                    end: {
                                                        line: 168,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                    }
                                                }
                                            },
                                            arguments: [{
                                                    type: 'ObjectExpression',
                                                    properties: [
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'state',
                                                                loc: {
                                                                    start: {
                                                                        line: 169,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 169,
                                                                        column: 21,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Identifier',
                                                                name: 'config',
                                                                loc: {
                                                                    start: {
                                                                        line: 169,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 169,
                                                                        column: 29,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        },
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'tabs',
                                                                loc: {
                                                                    start: {
                                                                        line: 170,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 170,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'ObjectExpression',
                                                                objectType: {
                                                                    type: 'ArrayExpression',
                                                                    elements: []
                                                                },
                                                                properties: [
                                                                    {
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'ObjectExpression',
                                                                            objectType: {
                                                                                type: 'ObjectExpression',
                                                                                properties: []
                                                                            },
                                                                            properties: [
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'name',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 172,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 172,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Literal',
                                                                                        value: 'schedule'
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'tab',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 173,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 173,
                                                                                                column: 27,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Function',
                                                                                        context: false,
                                                                                        value: function () {
                                                                                            return 'Schedule';
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '1'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'content',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 174,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 174,
                                                                                                column: 31,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Function',
                                                                                        context: true,
                                                                                        value: function (_ps2) {
                                                                                            return ion.template(function () {
                                                                                                return ion.createRuntime({
                                                                                                    type: 'Template',
                                                                                                    id: null,
                                                                                                    body: [{
                                                                                                            type: 'ReturnStatement',
                                                                                                            argument: {
                                                                                                                type: 'ObjectExpression',
                                                                                                                objectType: {
                                                                                                                    type: 'CallExpression',
                                                                                                                    callee: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'GlassForm',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 175,
                                                                                                                                column: 35,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 175,
                                                                                                                                column: 44,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    arguments: [{
                                                                                                                            type: 'ObjectExpression',
                                                                                                                            properties: [{
                                                                                                                                    type: 'Property',
                                                                                                                                    key: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'class',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 175,
                                                                                                                                                column: 45,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 175,
                                                                                                                                                column: 50,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    value: {
                                                                                                                                        type: 'Literal',
                                                                                                                                        value: 'layout vertical flex'
                                                                                                                                    },
                                                                                                                                    kind: 'init',
                                                                                                                                    order: '0'
                                                                                                                                }]
                                                                                                                        }],
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 175,
                                                                                                                            column: 35,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 175,
                                                                                                                            column: 74,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                properties: [
                                                                                                                    {
                                                                                                                        type: 'ExpressionStatement',
                                                                                                                        expression: {
                                                                                                                            type: 'ObjectExpression',
                                                                                                                            objectType: {
                                                                                                                                type: 'CallExpression',
                                                                                                                                callee: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'Div',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 176,
                                                                                                                                            column: 32,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 176,
                                                                                                                                            column: 35,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                arguments: [{
                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                        properties: [{
                                                                                                                                                type: 'Property',
                                                                                                                                                key: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'class',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 176,
                                                                                                                                                            column: 36,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 176,
                                                                                                                                                            column: 41,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                value: {
                                                                                                                                                    type: 'Literal',
                                                                                                                                                    value: 'layout horizontal'
                                                                                                                                                },
                                                                                                                                                kind: 'init',
                                                                                                                                                order: '0'
                                                                                                                                            }]
                                                                                                                                    }],
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 176,
                                                                                                                                        column: 32,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 176,
                                                                                                                                        column: 62,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            properties: [
                                                                                                                                {
                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                    expression: {
                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                        objectType: {
                                                                                                                                            type: 'CallExpression',
                                                                                                                                            callee: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'Field',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 177,
                                                                                                                                                        column: 36,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 177,
                                                                                                                                                        column: 41,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            arguments: [{
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    properties: [
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'property',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 177,
                                                                                                                                                                        column: 42,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 177,
                                                                                                                                                                        column: 50,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'MemberExpression',
                                                                                                                                                                computed: false,
                                                                                                                                                                object: {
                                                                                                                                                                    type: 'MemberExpression',
                                                                                                                                                                    computed: false,
                                                                                                                                                                    object: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'Task',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 177,
                                                                                                                                                                                column: 51,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 177,
                                                                                                                                                                                column: 55,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    property: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'properties',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 177,
                                                                                                                                                                                column: 56,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 177,
                                                                                                                                                                                column: 66,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 177,
                                                                                                                                                                            column: 51,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 177,
                                                                                                                                                                            column: 66,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                property: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'assigned',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 177,
                                                                                                                                                                            column: 67,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 177,
                                                                                                                                                                            column: 75,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 177,
                                                                                                                                                                        column: 51,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 177,
                                                                                                                                                                        column: 75,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '0'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'object',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 177,
                                                                                                                                                                        column: 77,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 177,
                                                                                                                                                                        column: 83,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'taskClone',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 177,
                                                                                                                                                                        column: 84,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 177,
                                                                                                                                                                        column: 93,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '1'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'inline',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 177,
                                                                                                                                                                        column: 95,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 177,
                                                                                                                                                                        column: 101,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: false
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '2'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'bind',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 177,
                                                                                                                                                                        column: 109,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 177,
                                                                                                                                                                        column: 113,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: true
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '3'
                                                                                                                                                        }
                                                                                                                                                    ]
                                                                                                                                                }],
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 177,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 177,
                                                                                                                                                    column: 119,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        properties: [{
                                                                                                                                                type: 'Property',
                                                                                                                                                key: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'style',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 178,
                                                                                                                                                            column: 40,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 178,
                                                                                                                                                            column: 45,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                value: {
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    properties: [{
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'flex',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 178,
                                                                                                                                                                        column: 47,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 178,
                                                                                                                                                                        column: 51,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: '11 0'
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '0'
                                                                                                                                                        }]
                                                                                                                                                },
                                                                                                                                                kind: 'init',
                                                                                                                                                order: '0'
                                                                                                                                            }]
                                                                                                                                    },
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 177,
                                                                                                                                            column: 36,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 179,
                                                                                                                                            column: 40,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    order: '0'
                                                                                                                                },
                                                                                                                                {
                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                    expression: {
                                                                                                                                        type: 'CallExpression',
                                                                                                                                        callee: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'Div',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 179,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 179,
                                                                                                                                                    column: 39,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        arguments: [{
                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                properties: [{
                                                                                                                                                        type: 'Property',
                                                                                                                                                        key: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'style',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 179,
                                                                                                                                                                    column: 40,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 179,
                                                                                                                                                                    column: 45,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        value: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: 'flex: 1 1'
                                                                                                                                                        },
                                                                                                                                                        kind: 'init',
                                                                                                                                                        order: '0'
                                                                                                                                                    }]
                                                                                                                                            }],
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 179,
                                                                                                                                                column: 36,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 179,
                                                                                                                                                column: 58,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 179,
                                                                                                                                            column: 36,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 179,
                                                                                                                                            column: 58,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    order: '1'
                                                                                                                                },
                                                                                                                                {
                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                    expression: {
                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                        objectType: {
                                                                                                                                            type: 'CallExpression',
                                                                                                                                            callee: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'Field',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 180,
                                                                                                                                                        column: 36,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 180,
                                                                                                                                                        column: 41,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            arguments: [{
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    properties: [
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'property',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 180,
                                                                                                                                                                        column: 42,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 180,
                                                                                                                                                                        column: 50,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'MemberExpression',
                                                                                                                                                                computed: false,
                                                                                                                                                                object: {
                                                                                                                                                                    type: 'MemberExpression',
                                                                                                                                                                    computed: false,
                                                                                                                                                                    object: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'Task',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 180,
                                                                                                                                                                                column: 51,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 180,
                                                                                                                                                                                column: 55,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    property: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'properties',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 180,
                                                                                                                                                                                column: 56,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 180,
                                                                                                                                                                                column: 66,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 180,
                                                                                                                                                                            column: 51,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 180,
                                                                                                                                                                            column: 66,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                property: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'percent',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 180,
                                                                                                                                                                            column: 67,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 180,
                                                                                                                                                                            column: 74,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 180,
                                                                                                                                                                        column: 51,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 180,
                                                                                                                                                                        column: 74,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '0'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'object',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 180,
                                                                                                                                                                        column: 76,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 180,
                                                                                                                                                                        column: 82,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'taskClone',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 180,
                                                                                                                                                                        column: 83,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 180,
                                                                                                                                                                        column: 92,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '1'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'bind',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 180,
                                                                                                                                                                        column: 94,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 180,
                                                                                                                                                                        column: 98,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: true
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '2'
                                                                                                                                                        }
                                                                                                                                                    ]
                                                                                                                                                }],
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 180,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 180,
                                                                                                                                                    column: 104,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        properties: [
                                                                                                                                            {
                                                                                                                                                type: 'Property',
                                                                                                                                                key: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'style',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 181,
                                                                                                                                                            column: 40,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 181,
                                                                                                                                                            column: 45,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                value: {
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    properties: [{
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'flex',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 181,
                                                                                                                                                                        column: 47,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 181,
                                                                                                                                                                        column: 51,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: '5 0'
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '0'
                                                                                                                                                        }]
                                                                                                                                                },
                                                                                                                                                kind: 'init',
                                                                                                                                                order: '0'
                                                                                                                                            },
                                                                                                                                            {
                                                                                                                                                type: 'Property',
                                                                                                                                                key: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'label',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 182,
                                                                                                                                                            column: 40,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 182,
                                                                                                                                                            column: 45,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                value: {
                                                                                                                                                    type: 'Literal',
                                                                                                                                                    value: 'Complete'
                                                                                                                                                },
                                                                                                                                                kind: 'init',
                                                                                                                                                order: '1'
                                                                                                                                            }
                                                                                                                                        ]
                                                                                                                                    },
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 180,
                                                                                                                                            column: 36,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 183,
                                                                                                                                            column: 40,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    order: '2'
                                                                                                                                }
                                                                                                                            ]
                                                                                                                        },
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 176,
                                                                                                                                column: 32,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 183,
                                                                                                                                column: 36,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            }
                                                                                                                        },
                                                                                                                        order: '0'
                                                                                                                    },
                                                                                                                    {
                                                                                                                        type: 'ExpressionStatement',
                                                                                                                        expression: {
                                                                                                                            type: 'ObjectExpression',
                                                                                                                            objectType: {
                                                                                                                                type: 'CallExpression',
                                                                                                                                callee: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'Div',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 183,
                                                                                                                                            column: 32,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 183,
                                                                                                                                            column: 35,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                arguments: [{
                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                        properties: [{
                                                                                                                                                type: 'Property',
                                                                                                                                                key: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'class',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 183,
                                                                                                                                                            column: 36,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 183,
                                                                                                                                                            column: 41,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                value: {
                                                                                                                                                    type: 'Literal',
                                                                                                                                                    value: 'layout horizontal'
                                                                                                                                                },
                                                                                                                                                kind: 'init',
                                                                                                                                                order: '0'
                                                                                                                                            }]
                                                                                                                                    }],
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 183,
                                                                                                                                        column: 32,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 183,
                                                                                                                                        column: 62,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            properties: [
                                                                                                                                {
                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                    expression: {
                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                        objectType: {
                                                                                                                                            type: 'CallExpression',
                                                                                                                                            callee: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'Field',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 184,
                                                                                                                                                        column: 36,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 184,
                                                                                                                                                        column: 41,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            arguments: [{
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    properties: [
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'property',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 184,
                                                                                                                                                                        column: 42,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 184,
                                                                                                                                                                        column: 50,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'MemberExpression',
                                                                                                                                                                computed: false,
                                                                                                                                                                object: {
                                                                                                                                                                    type: 'MemberExpression',
                                                                                                                                                                    computed: false,
                                                                                                                                                                    object: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'Task',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 184,
                                                                                                                                                                                column: 51,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 184,
                                                                                                                                                                                column: 55,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    property: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'properties',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 184,
                                                                                                                                                                                column: 56,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 184,
                                                                                                                                                                                column: 66,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 184,
                                                                                                                                                                            column: 51,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 184,
                                                                                                                                                                            column: 66,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                property: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'manualStart',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 184,
                                                                                                                                                                            column: 67,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 184,
                                                                                                                                                                            column: 78,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 184,
                                                                                                                                                                        column: 51,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 184,
                                                                                                                                                                        column: 78,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '0'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'object',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 184,
                                                                                                                                                                        column: 80,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 184,
                                                                                                                                                                        column: 86,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'taskClone',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 184,
                                                                                                                                                                        column: 87,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 184,
                                                                                                                                                                        column: 96,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '1'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'bind',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 184,
                                                                                                                                                                        column: 98,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 184,
                                                                                                                                                                        column: 102,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: true
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '2'
                                                                                                                                                        }
                                                                                                                                                    ]
                                                                                                                                                }],
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 184,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 184,
                                                                                                                                                    column: 108,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        properties: [{
                                                                                                                                                type: 'Property',
                                                                                                                                                key: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'style',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 185,
                                                                                                                                                            column: 40,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 185,
                                                                                                                                                            column: 45,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                value: {
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    properties: [{
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'flex',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 185,
                                                                                                                                                                        column: 47,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 185,
                                                                                                                                                                        column: 51,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: '11 0'
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '0'
                                                                                                                                                        }]
                                                                                                                                                },
                                                                                                                                                kind: 'init',
                                                                                                                                                order: '0'
                                                                                                                                            }]
                                                                                                                                    },
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 184,
                                                                                                                                            column: 36,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 186,
                                                                                                                                            column: 40,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    order: '0'
                                                                                                                                },
                                                                                                                                {
                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                    expression: {
                                                                                                                                        type: 'CallExpression',
                                                                                                                                        callee: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'Div',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 186,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 186,
                                                                                                                                                    column: 39,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        arguments: [{
                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                properties: [{
                                                                                                                                                        type: 'Property',
                                                                                                                                                        key: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'style',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 186,
                                                                                                                                                                    column: 40,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 186,
                                                                                                                                                                    column: 45,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        value: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: 'flex: 1 1'
                                                                                                                                                        },
                                                                                                                                                        kind: 'init',
                                                                                                                                                        order: '0'
                                                                                                                                                    }]
                                                                                                                                            }],
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 186,
                                                                                                                                                column: 36,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 186,
                                                                                                                                                column: 58,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 186,
                                                                                                                                            column: 36,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 186,
                                                                                                                                            column: 58,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    order: '1'
                                                                                                                                },
                                                                                                                                {
                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                    expression: {
                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                        objectType: {
                                                                                                                                            type: 'CallExpression',
                                                                                                                                            callee: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'Field',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 187,
                                                                                                                                                        column: 36,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 187,
                                                                                                                                                        column: 41,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            arguments: [{
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    properties: [
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'property',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 187,
                                                                                                                                                                        column: 42,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 187,
                                                                                                                                                                        column: 50,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'MemberExpression',
                                                                                                                                                                computed: false,
                                                                                                                                                                object: {
                                                                                                                                                                    type: 'MemberExpression',
                                                                                                                                                                    computed: false,
                                                                                                                                                                    object: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'Task',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 187,
                                                                                                                                                                                column: 51,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 187,
                                                                                                                                                                                column: 55,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    property: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'properties',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 187,
                                                                                                                                                                                column: 56,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 187,
                                                                                                                                                                                column: 66,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 187,
                                                                                                                                                                            column: 51,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 187,
                                                                                                                                                                            column: 66,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                property: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'manualDuration',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 187,
                                                                                                                                                                            column: 67,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 187,
                                                                                                                                                                            column: 81,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 187,
                                                                                                                                                                        column: 51,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 187,
                                                                                                                                                                        column: 81,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '0'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'object',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 187,
                                                                                                                                                                        column: 83,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 187,
                                                                                                                                                                        column: 89,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'taskClone',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 187,
                                                                                                                                                                        column: 90,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 187,
                                                                                                                                                                        column: 99,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '1'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'bind',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 187,
                                                                                                                                                                        column: 101,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 187,
                                                                                                                                                                        column: 105,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: true
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '2'
                                                                                                                                                        }
                                                                                                                                                    ]
                                                                                                                                                }],
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 187,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 187,
                                                                                                                                                    column: 111,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        properties: [{
                                                                                                                                                type: 'Property',
                                                                                                                                                key: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'style',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 188,
                                                                                                                                                            column: 40,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 188,
                                                                                                                                                            column: 45,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                value: {
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    properties: [{
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'flex',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 188,
                                                                                                                                                                        column: 47,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 188,
                                                                                                                                                                        column: 51,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: '5 0'
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '0'
                                                                                                                                                        }]
                                                                                                                                                },
                                                                                                                                                kind: 'init',
                                                                                                                                                order: '0'
                                                                                                                                            }]
                                                                                                                                    },
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 187,
                                                                                                                                            column: 36,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 189,
                                                                                                                                            column: 40,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    order: '2'
                                                                                                                                }
                                                                                                                            ]
                                                                                                                        },
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 183,
                                                                                                                                column: 32,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 189,
                                                                                                                                column: 36,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            }
                                                                                                                        },
                                                                                                                        order: '1'
                                                                                                                    },
                                                                                                                    {
                                                                                                                        type: 'ExpressionStatement',
                                                                                                                        expression: {
                                                                                                                            type: 'ObjectExpression',
                                                                                                                            objectType: {
                                                                                                                                type: 'CallExpression',
                                                                                                                                callee: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'Div',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 189,
                                                                                                                                            column: 32,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 189,
                                                                                                                                            column: 35,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                arguments: [{
                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                        properties: [{
                                                                                                                                                type: 'Property',
                                                                                                                                                key: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'class',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 189,
                                                                                                                                                            column: 36,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 189,
                                                                                                                                                            column: 41,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                value: {
                                                                                                                                                    type: 'Literal',
                                                                                                                                                    value: 'layout horizontal'
                                                                                                                                                },
                                                                                                                                                kind: 'init',
                                                                                                                                                order: '0'
                                                                                                                                            }]
                                                                                                                                    }],
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 189,
                                                                                                                                        column: 32,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 189,
                                                                                                                                        column: 62,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            properties: [
                                                                                                                                {
                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                    expression: {
                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                        objectType: {
                                                                                                                                            type: 'CallExpression',
                                                                                                                                            callee: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'Field',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 190,
                                                                                                                                                        column: 36,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 190,
                                                                                                                                                        column: 41,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            arguments: [{
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    properties: [
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'property',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 190,
                                                                                                                                                                        column: 42,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 190,
                                                                                                                                                                        column: 50,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'MemberExpression',
                                                                                                                                                                computed: false,
                                                                                                                                                                object: {
                                                                                                                                                                    type: 'MemberExpression',
                                                                                                                                                                    computed: false,
                                                                                                                                                                    object: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'Task',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 190,
                                                                                                                                                                                column: 51,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 190,
                                                                                                                                                                                column: 55,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    property: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'properties',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 190,
                                                                                                                                                                                column: 56,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 190,
                                                                                                                                                                                column: 66,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 190,
                                                                                                                                                                            column: 51,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 190,
                                                                                                                                                                            column: 66,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                property: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'manualFinish',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 190,
                                                                                                                                                                            column: 67,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 190,
                                                                                                                                                                            column: 79,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 190,
                                                                                                                                                                        column: 51,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 190,
                                                                                                                                                                        column: 79,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '0'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'object',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 190,
                                                                                                                                                                        column: 81,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 190,
                                                                                                                                                                        column: 87,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'taskClone',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 190,
                                                                                                                                                                        column: 88,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 190,
                                                                                                                                                                        column: 97,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '1'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'bind',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 190,
                                                                                                                                                                        column: 99,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 190,
                                                                                                                                                                        column: 103,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: true
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '2'
                                                                                                                                                        }
                                                                                                                                                    ]
                                                                                                                                                }],
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 190,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 190,
                                                                                                                                                    column: 109,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        properties: [{
                                                                                                                                                type: 'Property',
                                                                                                                                                key: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'style',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 191,
                                                                                                                                                            column: 40,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 191,
                                                                                                                                                            column: 45,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                value: {
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    properties: [{
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'flex',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 191,
                                                                                                                                                                        column: 47,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 191,
                                                                                                                                                                        column: 51,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: '11 0'
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '0'
                                                                                                                                                        }]
                                                                                                                                                },
                                                                                                                                                kind: 'init',
                                                                                                                                                order: '0'
                                                                                                                                            }]
                                                                                                                                    },
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 190,
                                                                                                                                            column: 36,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 192,
                                                                                                                                            column: 40,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    order: '0'
                                                                                                                                },
                                                                                                                                {
                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                    expression: {
                                                                                                                                        type: 'CallExpression',
                                                                                                                                        callee: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'Div',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 192,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 192,
                                                                                                                                                    column: 39,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        arguments: [{
                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                properties: [{
                                                                                                                                                        type: 'Property',
                                                                                                                                                        key: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'style',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 192,
                                                                                                                                                                    column: 40,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 192,
                                                                                                                                                                    column: 45,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        value: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: 'flex: 1 1'
                                                                                                                                                        },
                                                                                                                                                        kind: 'init',
                                                                                                                                                        order: '0'
                                                                                                                                                    }]
                                                                                                                                            }],
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 192,
                                                                                                                                                column: 36,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 192,
                                                                                                                                                column: 58,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 192,
                                                                                                                                            column: 36,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 192,
                                                                                                                                            column: 58,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    order: '1'
                                                                                                                                },
                                                                                                                                {
                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                    expression: {
                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                        objectType: {
                                                                                                                                            type: 'CallExpression',
                                                                                                                                            callee: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'Field',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 193,
                                                                                                                                                        column: 36,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 193,
                                                                                                                                                        column: 41,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            arguments: [{
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    properties: [
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'property',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 193,
                                                                                                                                                                        column: 42,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 193,
                                                                                                                                                                        column: 50,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'MemberExpression',
                                                                                                                                                                computed: false,
                                                                                                                                                                object: {
                                                                                                                                                                    type: 'MemberExpression',
                                                                                                                                                                    computed: false,
                                                                                                                                                                    object: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'Task',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 193,
                                                                                                                                                                                column: 51,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 193,
                                                                                                                                                                                column: 55,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    property: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'properties',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 193,
                                                                                                                                                                                column: 56,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 193,
                                                                                                                                                                                column: 66,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 193,
                                                                                                                                                                            column: 51,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 193,
                                                                                                                                                                            column: 66,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                property: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'work',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 193,
                                                                                                                                                                            column: 67,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 193,
                                                                                                                                                                            column: 71,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 193,
                                                                                                                                                                        column: 51,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 193,
                                                                                                                                                                        column: 71,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '0'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'object',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 193,
                                                                                                                                                                        column: 73,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 193,
                                                                                                                                                                        column: 79,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'taskClone',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 193,
                                                                                                                                                                        column: 80,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 193,
                                                                                                                                                                        column: 89,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '1'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'bind',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 193,
                                                                                                                                                                        column: 91,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 193,
                                                                                                                                                                        column: 95,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: true
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '2'
                                                                                                                                                        }
                                                                                                                                                    ]
                                                                                                                                                }],
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 193,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 193,
                                                                                                                                                    column: 101,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        properties: [{
                                                                                                                                                type: 'Property',
                                                                                                                                                key: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'style',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 194,
                                                                                                                                                            column: 40,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 194,
                                                                                                                                                            column: 45,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                value: {
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    properties: [{
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'flex',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 194,
                                                                                                                                                                        column: 47,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 194,
                                                                                                                                                                        column: 51,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: '5 0'
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '0'
                                                                                                                                                        }]
                                                                                                                                                },
                                                                                                                                                kind: 'init',
                                                                                                                                                order: '0'
                                                                                                                                            }]
                                                                                                                                    },
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 193,
                                                                                                                                            column: 36,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 196,
                                                                                                                                            column: 40,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    order: '2'
                                                                                                                                }
                                                                                                                            ]
                                                                                                                        },
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 189,
                                                                                                                                column: 32,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 196,
                                                                                                                                column: 36,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            }
                                                                                                                        },
                                                                                                                        order: '2'
                                                                                                                    },
                                                                                                                    {
                                                                                                                        type: 'ExpressionStatement',
                                                                                                                        expression: {
                                                                                                                            type: 'ObjectExpression',
                                                                                                                            objectType: {
                                                                                                                                type: 'CallExpression',
                                                                                                                                callee: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'Div',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 197,
                                                                                                                                            column: 32,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 197,
                                                                                                                                            column: 35,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                arguments: [{
                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                        properties: [{
                                                                                                                                                type: 'Property',
                                                                                                                                                key: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'style',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 197,
                                                                                                                                                            column: 36,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 197,
                                                                                                                                                            column: 41,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                value: {
                                                                                                                                                    type: 'Literal',
                                                                                                                                                    value: 'padding:1px'
                                                                                                                                                },
                                                                                                                                                kind: 'init',
                                                                                                                                                order: '0'
                                                                                                                                            }]
                                                                                                                                    }],
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 197,
                                                                                                                                        column: 32,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 197,
                                                                                                                                        column: 56,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            properties: [{
                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                    expression: {
                                                                                                                                        type: 'CallExpression',
                                                                                                                                        callee: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'Div',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 198,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 198,
                                                                                                                                                    column: 39,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        arguments: [{
                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                properties: [{
                                                                                                                                                        type: 'Property',
                                                                                                                                                        key: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'style',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 198,
                                                                                                                                                                    column: 40,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 198,
                                                                                                                                                                    column: 45,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        value: {
                                                                                                                                                            type: 'BinaryExpression',
                                                                                                                                                            operator: '+',
                                                                                                                                                            left: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: 'height:1px;background-color:'
                                                                                                                                                            },
                                                                                                                                                            right: {
                                                                                                                                                                type: 'CallExpression',
                                                                                                                                                                callee: {
                                                                                                                                                                    type: 'MemberExpression',
                                                                                                                                                                    computed: false,
                                                                                                                                                                    object: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'style',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 198,
                                                                                                                                                                                column: 77,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 198,
                                                                                                                                                                                column: 82,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    property: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'black',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 198,
                                                                                                                                                                                column: 83,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 198,
                                                                                                                                                                                column: 88,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 198,
                                                                                                                                                                            column: 77,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 198,
                                                                                                                                                                            column: 88,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                arguments: [{
                                                                                                                                                                        type: 'Literal',
                                                                                                                                                                        value: 0.1
                                                                                                                                                                    }],
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 198,
                                                                                                                                                                        column: 77,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 198,
                                                                                                                                                                        column: 94,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        kind: 'init',
                                                                                                                                                        order: '0'
                                                                                                                                                    }]
                                                                                                                                            }],
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 198,
                                                                                                                                                column: 36,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 198,
                                                                                                                                                column: 98,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 198,
                                                                                                                                            column: 36,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 198,
                                                                                                                                            column: 98,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    order: '0'
                                                                                                                                }]
                                                                                                                        },
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 197,
                                                                                                                                column: 32,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 200,
                                                                                                                                column: 36,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            }
                                                                                                                        },
                                                                                                                        order: '3'
                                                                                                                    },
                                                                                                                    {
                                                                                                                        type: 'ExpressionStatement',
                                                                                                                        expression: {
                                                                                                                            type: 'ObjectExpression',
                                                                                                                            objectType: {
                                                                                                                                type: 'CallExpression',
                                                                                                                                callee: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'Div',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 200,
                                                                                                                                            column: 32,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 200,
                                                                                                                                            column: 35,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                arguments: [{
                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                        properties: [{
                                                                                                                                                type: 'Property',
                                                                                                                                                key: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'class',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 200,
                                                                                                                                                            column: 36,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 200,
                                                                                                                                                            column: 41,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                value: {
                                                                                                                                                    type: 'Literal',
                                                                                                                                                    value: 'layout horizontal'
                                                                                                                                                },
                                                                                                                                                kind: 'init',
                                                                                                                                                order: '0'
                                                                                                                                            }]
                                                                                                                                    }],
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 200,
                                                                                                                                        column: 32,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 200,
                                                                                                                                        column: 62,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            properties: [
                                                                                                                                {
                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                    expression: {
                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                        objectType: {
                                                                                                                                            type: 'CallExpression',
                                                                                                                                            callee: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'Field',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 201,
                                                                                                                                                        column: 36,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 201,
                                                                                                                                                        column: 41,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            arguments: [{
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    properties: [
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'property',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 201,
                                                                                                                                                                        column: 42,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 201,
                                                                                                                                                                        column: 50,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'MemberExpression',
                                                                                                                                                                computed: false,
                                                                                                                                                                object: {
                                                                                                                                                                    type: 'MemberExpression',
                                                                                                                                                                    computed: false,
                                                                                                                                                                    object: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'Task',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 201,
                                                                                                                                                                                column: 51,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 201,
                                                                                                                                                                                column: 55,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    property: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'properties',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 201,
                                                                                                                                                                                column: 56,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 201,
                                                                                                                                                                                column: 66,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 201,
                                                                                                                                                                            column: 51,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 201,
                                                                                                                                                                            column: 66,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                property: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'scheduleConstraint',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 201,
                                                                                                                                                                            column: 67,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 201,
                                                                                                                                                                            column: 85,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 201,
                                                                                                                                                                        column: 51,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 201,
                                                                                                                                                                        column: 85,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '0'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'object',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 201,
                                                                                                                                                                        column: 87,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 201,
                                                                                                                                                                        column: 93,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'taskClone',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 201,
                                                                                                                                                                        column: 94,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 201,
                                                                                                                                                                        column: 103,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '1'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'bind',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 201,
                                                                                                                                                                        column: 105,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 201,
                                                                                                                                                                        column: 109,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: true
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '2'
                                                                                                                                                        }
                                                                                                                                                    ]
                                                                                                                                                }],
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 201,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 201,
                                                                                                                                                    column: 115,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        properties: [{
                                                                                                                                                type: 'Property',
                                                                                                                                                key: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'style',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 202,
                                                                                                                                                            column: 40,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 202,
                                                                                                                                                            column: 45,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                value: {
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    properties: [{
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'flex',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 202,
                                                                                                                                                                        column: 47,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 202,
                                                                                                                                                                        column: 51,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: '5 0'
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '0'
                                                                                                                                                        }]
                                                                                                                                                },
                                                                                                                                                kind: 'init',
                                                                                                                                                order: '0'
                                                                                                                                            }]
                                                                                                                                    },
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 201,
                                                                                                                                            column: 36,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 203,
                                                                                                                                            column: 40,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    order: '0'
                                                                                                                                },
                                                                                                                                {
                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                    expression: {
                                                                                                                                        type: 'CallExpression',
                                                                                                                                        callee: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'Div',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 203,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 203,
                                                                                                                                                    column: 39,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        arguments: [{
                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                properties: [{
                                                                                                                                                        type: 'Property',
                                                                                                                                                        key: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'style',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 203,
                                                                                                                                                                    column: 40,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 203,
                                                                                                                                                                    column: 45,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        value: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: 'flex: 1 1'
                                                                                                                                                        },
                                                                                                                                                        kind: 'init',
                                                                                                                                                        order: '0'
                                                                                                                                                    }]
                                                                                                                                            }],
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 203,
                                                                                                                                                column: 36,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 203,
                                                                                                                                                column: 58,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 203,
                                                                                                                                            column: 36,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 203,
                                                                                                                                            column: 58,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    order: '1'
                                                                                                                                },
                                                                                                                                {
                                                                                                                                    type: 'IfStatement',
                                                                                                                                    test: {
                                                                                                                                        type: 'MemberExpression',
                                                                                                                                        computed: false,
                                                                                                                                        object: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'taskClone',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 204,
                                                                                                                                                    column: 39,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 204,
                                                                                                                                                    column: 48,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        property: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'repeat',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 204,
                                                                                                                                                    column: 49,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 204,
                                                                                                                                                    column: 55,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 204,
                                                                                                                                                column: 39,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 204,
                                                                                                                                                column: 55,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    consequent: {
                                                                                                                                        type: 'BlockStatement',
                                                                                                                                        body: [{
                                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                                expression: {
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    objectType: {
                                                                                                                                                        type: 'CallExpression',
                                                                                                                                                        callee: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'Field',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 205,
                                                                                                                                                                    column: 40,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 205,
                                                                                                                                                                    column: 45,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        arguments: [{
                                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                                properties: [
                                                                                                                                                                    {
                                                                                                                                                                        type: 'Property',
                                                                                                                                                                        key: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'property',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 205,
                                                                                                                                                                                    column: 46,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 205,
                                                                                                                                                                                    column: 54,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        value: {
                                                                                                                                                                            type: 'MemberExpression',
                                                                                                                                                                            computed: false,
                                                                                                                                                                            object: {
                                                                                                                                                                                type: 'MemberExpression',
                                                                                                                                                                                computed: false,
                                                                                                                                                                                object: {
                                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                                    name: 'Task',
                                                                                                                                                                                    loc: {
                                                                                                                                                                                        start: {
                                                                                                                                                                                            line: 205,
                                                                                                                                                                                            column: 55,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                        },
                                                                                                                                                                                        end: {
                                                                                                                                                                                            line: 205,
                                                                                                                                                                                            column: 59,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                        }
                                                                                                                                                                                    }
                                                                                                                                                                                },
                                                                                                                                                                                property: {
                                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                                    name: 'properties',
                                                                                                                                                                                    loc: {
                                                                                                                                                                                        start: {
                                                                                                                                                                                            line: 205,
                                                                                                                                                                                            column: 60,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                        },
                                                                                                                                                                                        end: {
                                                                                                                                                                                            line: 205,
                                                                                                                                                                                            column: 70,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                        }
                                                                                                                                                                                    }
                                                                                                                                                                                },
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 205,
                                                                                                                                                                                        column: 55,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 205,
                                                                                                                                                                                        column: 70,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            property: {
                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                name: 'repeatUnit',
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 205,
                                                                                                                                                                                        column: 71,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 205,
                                                                                                                                                                                        column: 81,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 205,
                                                                                                                                                                                    column: 55,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 205,
                                                                                                                                                                                    column: 81,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        kind: 'init',
                                                                                                                                                                        order: '0'
                                                                                                                                                                    },
                                                                                                                                                                    {
                                                                                                                                                                        type: 'Property',
                                                                                                                                                                        key: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'object',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 205,
                                                                                                                                                                                    column: 83,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 205,
                                                                                                                                                                                    column: 89,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        value: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'taskClone',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 205,
                                                                                                                                                                                    column: 90,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 205,
                                                                                                                                                                                    column: 99,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        kind: 'init',
                                                                                                                                                                        order: '1'
                                                                                                                                                                    },
                                                                                                                                                                    {
                                                                                                                                                                        type: 'Property',
                                                                                                                                                                        key: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'bind',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 205,
                                                                                                                                                                                    column: 101,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 205,
                                                                                                                                                                                    column: 105,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        value: {
                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                            value: true
                                                                                                                                                                        },
                                                                                                                                                                        kind: 'init',
                                                                                                                                                                        order: '2'
                                                                                                                                                                    }
                                                                                                                                                                ]
                                                                                                                                                            }],
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 205,
                                                                                                                                                                column: 40,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 205,
                                                                                                                                                                column: 111,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    properties: [{
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'style',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 206,
                                                                                                                                                                        column: 44,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 206,
                                                                                                                                                                        column: 49,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                                properties: [{
                                                                                                                                                                        type: 'Property',
                                                                                                                                                                        key: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'flex',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 206,
                                                                                                                                                                                    column: 51,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 206,
                                                                                                                                                                                    column: 55,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        value: {
                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                            value: '5 0'
                                                                                                                                                                        },
                                                                                                                                                                        kind: 'init',
                                                                                                                                                                        order: '0'
                                                                                                                                                                    }]
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '0'
                                                                                                                                                        }]
                                                                                                                                                },
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 205,
                                                                                                                                                        column: 40,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 207,
                                                                                                                                                        column: 44,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                order: '0'
                                                                                                                                            }]
                                                                                                                                    },
                                                                                                                                    alternate: null,
                                                                                                                                    order: '2'
                                                                                                                                },
                                                                                                                                {
                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                    expression: {
                                                                                                                                        type: 'CallExpression',
                                                                                                                                        callee: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'Div',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 207,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 207,
                                                                                                                                                    column: 39,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        arguments: [{
                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                properties: [{
                                                                                                                                                        type: 'Property',
                                                                                                                                                        key: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'style',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 207,
                                                                                                                                                                    column: 40,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 207,
                                                                                                                                                                    column: 45,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        value: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: 'flex: 1 1'
                                                                                                                                                        },
                                                                                                                                                        kind: 'init',
                                                                                                                                                        order: '0'
                                                                                                                                                    }]
                                                                                                                                            }],
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 207,
                                                                                                                                                column: 36,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 207,
                                                                                                                                                column: 58,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 207,
                                                                                                                                            column: 36,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 207,
                                                                                                                                            column: 58,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    order: '3'
                                                                                                                                },
                                                                                                                                {
                                                                                                                                    type: 'IfStatement',
                                                                                                                                    test: {
                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                        operator: '&&',
                                                                                                                                        left: {
                                                                                                                                            type: 'MemberExpression',
                                                                                                                                            computed: false,
                                                                                                                                            object: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'taskClone',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 208,
                                                                                                                                                        column: 39,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 208,
                                                                                                                                                        column: 48,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            property: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'repeat',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 208,
                                                                                                                                                        column: 49,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 208,
                                                                                                                                                        column: 55,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 208,
                                                                                                                                                    column: 39,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 208,
                                                                                                                                                    column: 55,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        right: {
                                                                                                                                            type: 'BinaryExpression',
                                                                                                                                            operator: '===',
                                                                                                                                            left: {
                                                                                                                                                type: 'MemberExpression',
                                                                                                                                                computed: false,
                                                                                                                                                object: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'taskClone',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 208,
                                                                                                                                                            column: 60,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 208,
                                                                                                                                                            column: 69,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                property: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'repeatUnit',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 208,
                                                                                                                                                            column: 70,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 208,
                                                                                                                                                            column: 80,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 208,
                                                                                                                                                        column: 60,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 208,
                                                                                                                                                        column: 80,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            right: {
                                                                                                                                                type: 'Literal',
                                                                                                                                                value: 2
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    consequent: {
                                                                                                                                        type: 'BlockStatement',
                                                                                                                                        body: [{
                                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                                expression: {
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    objectType: {
                                                                                                                                                        type: 'CallExpression',
                                                                                                                                                        callee: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'Field',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 209,
                                                                                                                                                                    column: 40,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 209,
                                                                                                                                                                    column: 45,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        arguments: [{
                                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                                properties: [
                                                                                                                                                                    {
                                                                                                                                                                        type: 'Property',
                                                                                                                                                                        key: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'property',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 209,
                                                                                                                                                                                    column: 46,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 209,
                                                                                                                                                                                    column: 54,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        value: {
                                                                                                                                                                            type: 'MemberExpression',
                                                                                                                                                                            computed: false,
                                                                                                                                                                            object: {
                                                                                                                                                                                type: 'MemberExpression',
                                                                                                                                                                                computed: false,
                                                                                                                                                                                object: {
                                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                                    name: 'Task',
                                                                                                                                                                                    loc: {
                                                                                                                                                                                        start: {
                                                                                                                                                                                            line: 209,
                                                                                                                                                                                            column: 55,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                        },
                                                                                                                                                                                        end: {
                                                                                                                                                                                            line: 209,
                                                                                                                                                                                            column: 59,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                        }
                                                                                                                                                                                    }
                                                                                                                                                                                },
                                                                                                                                                                                property: {
                                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                                    name: 'properties',
                                                                                                                                                                                    loc: {
                                                                                                                                                                                        start: {
                                                                                                                                                                                            line: 209,
                                                                                                                                                                                            column: 60,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                        },
                                                                                                                                                                                        end: {
                                                                                                                                                                                            line: 209,
                                                                                                                                                                                            column: 70,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                        }
                                                                                                                                                                                    }
                                                                                                                                                                                },
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 209,
                                                                                                                                                                                        column: 55,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 209,
                                                                                                                                                                                        column: 70,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            property: {
                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                name: 'repeatByDayOfWeek',
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 209,
                                                                                                                                                                                        column: 71,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 209,
                                                                                                                                                                                        column: 88,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 209,
                                                                                                                                                                                    column: 55,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 209,
                                                                                                                                                                                    column: 88,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        kind: 'init',
                                                                                                                                                                        order: '0'
                                                                                                                                                                    },
                                                                                                                                                                    {
                                                                                                                                                                        type: 'Property',
                                                                                                                                                                        key: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'object',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 209,
                                                                                                                                                                                    column: 90,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 209,
                                                                                                                                                                                    column: 96,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        value: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'taskClone',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 209,
                                                                                                                                                                                    column: 97,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 209,
                                                                                                                                                                                    column: 106,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        kind: 'init',
                                                                                                                                                                        order: '1'
                                                                                                                                                                    },
                                                                                                                                                                    {
                                                                                                                                                                        type: 'Property',
                                                                                                                                                                        key: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'bind',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 209,
                                                                                                                                                                                    column: 108,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 209,
                                                                                                                                                                                    column: 112,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        value: {
                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                            value: true
                                                                                                                                                                        },
                                                                                                                                                                        kind: 'init',
                                                                                                                                                                        order: '2'
                                                                                                                                                                    }
                                                                                                                                                                ]
                                                                                                                                                            }],
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 209,
                                                                                                                                                                column: 40,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 209,
                                                                                                                                                                column: 118,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    properties: [{
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'style',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 210,
                                                                                                                                                                        column: 44,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 210,
                                                                                                                                                                        column: 49,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                                properties: [{
                                                                                                                                                                        type: 'Property',
                                                                                                                                                                        key: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'flex',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 210,
                                                                                                                                                                                    column: 51,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 210,
                                                                                                                                                                                    column: 55,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        value: {
                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                            value: '5 0'
                                                                                                                                                                        },
                                                                                                                                                                        kind: 'init',
                                                                                                                                                                        order: '0'
                                                                                                                                                                    }]
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '0'
                                                                                                                                                        }]
                                                                                                                                                },
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 209,
                                                                                                                                                        column: 40,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 211,
                                                                                                                                                        column: 44,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                order: '0'
                                                                                                                                            }]
                                                                                                                                    },
                                                                                                                                    alternate: {
                                                                                                                                        type: 'BlockStatement',
                                                                                                                                        body: [{
                                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                                expression: {
                                                                                                                                                    type: 'CallExpression',
                                                                                                                                                    callee: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'Div',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 212,
                                                                                                                                                                column: 40,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 212,
                                                                                                                                                                column: 43,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    arguments: [{
                                                                                                                                                            type: 'ObjectExpression',
                                                                                                                                                            properties: [{
                                                                                                                                                                    type: 'Property',
                                                                                                                                                                    key: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'style',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 212,
                                                                                                                                                                                column: 44,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 212,
                                                                                                                                                                                column: 49,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    value: {
                                                                                                                                                                        type: 'Literal',
                                                                                                                                                                        value: 'flex: 5 1'
                                                                                                                                                                    },
                                                                                                                                                                    kind: 'init',
                                                                                                                                                                    order: '0'
                                                                                                                                                                }]
                                                                                                                                                        }],
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 212,
                                                                                                                                                            column: 40,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 212,
                                                                                                                                                            column: 62,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 212,
                                                                                                                                                        column: 40,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 212,
                                                                                                                                                        column: 62,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                order: '0'
                                                                                                                                            }]
                                                                                                                                    },
                                                                                                                                    order: '4'
                                                                                                                                }
                                                                                                                            ]
                                                                                                                        },
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 200,
                                                                                                                                column: 32,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 214,
                                                                                                                                column: 36,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            }
                                                                                                                        },
                                                                                                                        order: '4'
                                                                                                                    },
                                                                                                                    {
                                                                                                                        type: 'IfStatement',
                                                                                                                        test: {
                                                                                                                            type: 'MemberExpression',
                                                                                                                            computed: false,
                                                                                                                            object: {
                                                                                                                                type: 'MemberExpression',
                                                                                                                                computed: false,
                                                                                                                                object: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'taskClone',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 214,
                                                                                                                                            column: 35,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 214,
                                                                                                                                            column: 44,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                property: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'ScheduleConstraint',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 214,
                                                                                                                                            column: 45,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 214,
                                                                                                                                            column: 63,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 214,
                                                                                                                                        column: 35,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 214,
                                                                                                                                        column: 63,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            property: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'date',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 214,
                                                                                                                                        column: 64,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 214,
                                                                                                                                        column: 68,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 214,
                                                                                                                                    column: 35,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 214,
                                                                                                                                    column: 68,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        consequent: {
                                                                                                                            type: 'BlockStatement',
                                                                                                                            body: [{
                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                    expression: {
                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                        objectType: {
                                                                                                                                            type: 'CallExpression',
                                                                                                                                            callee: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'Field',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 215,
                                                                                                                                                        column: 36,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 215,
                                                                                                                                                        column: 41,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            arguments: [{
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    properties: [
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'property',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 215,
                                                                                                                                                                        column: 42,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 215,
                                                                                                                                                                        column: 50,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'MemberExpression',
                                                                                                                                                                computed: false,
                                                                                                                                                                object: {
                                                                                                                                                                    type: 'MemberExpression',
                                                                                                                                                                    computed: false,
                                                                                                                                                                    object: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'Task',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 215,
                                                                                                                                                                                column: 51,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 215,
                                                                                                                                                                                column: 55,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    property: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'properties',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 215,
                                                                                                                                                                                column: 56,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 215,
                                                                                                                                                                                column: 66,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 215,
                                                                                                                                                                            column: 51,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 215,
                                                                                                                                                                            column: 66,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                property: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'scheduleDate',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 215,
                                                                                                                                                                            column: 67,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 215,
                                                                                                                                                                            column: 79,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 215,
                                                                                                                                                                        column: 51,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 215,
                                                                                                                                                                        column: 79,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '0'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'object',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 215,
                                                                                                                                                                        column: 81,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 215,
                                                                                                                                                                        column: 87,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'taskClone',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 215,
                                                                                                                                                                        column: 88,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 215,
                                                                                                                                                                        column: 97,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '1'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'bind',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 215,
                                                                                                                                                                        column: 99,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 215,
                                                                                                                                                                        column: 103,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: true
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '2'
                                                                                                                                                        }
                                                                                                                                                    ]
                                                                                                                                                }],
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 215,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 215,
                                                                                                                                                    column: 109,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        properties: [{
                                                                                                                                                type: 'Property',
                                                                                                                                                key: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'label',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 216,
                                                                                                                                                            column: 40,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 216,
                                                                                                                                                            column: 45,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                value: {
                                                                                                                                                    type: 'Literal',
                                                                                                                                                    value: 'Constraint Date'
                                                                                                                                                },
                                                                                                                                                kind: 'init',
                                                                                                                                                order: '0'
                                                                                                                                            }]
                                                                                                                                    },
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 215,
                                                                                                                                            column: 36,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 217,
                                                                                                                                            column: 40,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    order: '0'
                                                                                                                                }]
                                                                                                                        },
                                                                                                                        alternate: null,
                                                                                                                        order: '5'
                                                                                                                    },
                                                                                                                    {
                                                                                                                        type: 'ExpressionStatement',
                                                                                                                        expression: {
                                                                                                                            type: 'ObjectExpression',
                                                                                                                            objectType: {
                                                                                                                                type: 'CallExpression',
                                                                                                                                callee: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'Div',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 218,
                                                                                                                                            column: 32,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 218,
                                                                                                                                            column: 35,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                arguments: [],
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 218,
                                                                                                                                        column: 32,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 218,
                                                                                                                                        column: 37,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            properties: [
                                                                                                                                {
                                                                                                                                    type: 'Property',
                                                                                                                                    key: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'style',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 219,
                                                                                                                                                column: 36,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 219,
                                                                                                                                                column: 41,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    value: {
                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                        properties: [{
                                                                                                                                                type: 'Property',
                                                                                                                                                key: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'display',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 220,
                                                                                                                                                            column: 40,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 220,
                                                                                                                                                            column: 47,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                value: {
                                                                                                                                                    type: 'ConditionalExpression',
                                                                                                                                                    test: {
                                                                                                                                                        type: 'MemberExpression',
                                                                                                                                                        computed: false,
                                                                                                                                                        object: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'taskClone',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 220,
                                                                                                                                                                    column: 49,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 220,
                                                                                                                                                                    column: 58,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        property: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'repeat',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 220,
                                                                                                                                                                    column: 59,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 220,
                                                                                                                                                                    column: 65,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 220,
                                                                                                                                                                column: 49,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 220,
                                                                                                                                                                column: 65,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    consequent: {
                                                                                                                                                        type: 'Literal',
                                                                                                                                                        value: 'initial'
                                                                                                                                                    },
                                                                                                                                                    alternate: {
                                                                                                                                                        type: 'Literal',
                                                                                                                                                        value: 'none'
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                kind: 'init',
                                                                                                                                                order: '0'
                                                                                                                                            }]
                                                                                                                                    },
                                                                                                                                    kind: 'init',
                                                                                                                                    order: '0'
                                                                                                                                },
                                                                                                                                {
                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                    expression: {
                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                        objectType: {
                                                                                                                                            type: 'CallExpression',
                                                                                                                                            callee: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'Div',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 221,
                                                                                                                                                        column: 36,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 221,
                                                                                                                                                        column: 39,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            arguments: [{
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    properties: [{
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'class',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 221,
                                                                                                                                                                        column: 40,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 221,
                                                                                                                                                                        column: 45,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: 'layout horizontal'
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '0'
                                                                                                                                                        }]
                                                                                                                                                }],
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 221,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 221,
                                                                                                                                                    column: 66,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        properties: [
                                                                                                                                            {
                                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                                expression: {
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    objectType: {
                                                                                                                                                        type: 'CallExpression',
                                                                                                                                                        callee: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'Field',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 222,
                                                                                                                                                                    column: 40,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 222,
                                                                                                                                                                    column: 45,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        arguments: [{
                                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                                properties: [
                                                                                                                                                                    {
                                                                                                                                                                        type: 'Property',
                                                                                                                                                                        key: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'property',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 222,
                                                                                                                                                                                    column: 46,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 222,
                                                                                                                                                                                    column: 54,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        value: {
                                                                                                                                                                            type: 'MemberExpression',
                                                                                                                                                                            computed: false,
                                                                                                                                                                            object: {
                                                                                                                                                                                type: 'MemberExpression',
                                                                                                                                                                                computed: false,
                                                                                                                                                                                object: {
                                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                                    name: 'Task',
                                                                                                                                                                                    loc: {
                                                                                                                                                                                        start: {
                                                                                                                                                                                            line: 222,
                                                                                                                                                                                            column: 55,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                        },
                                                                                                                                                                                        end: {
                                                                                                                                                                                            line: 222,
                                                                                                                                                                                            column: 59,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                        }
                                                                                                                                                                                    }
                                                                                                                                                                                },
                                                                                                                                                                                property: {
                                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                                    name: 'properties',
                                                                                                                                                                                    loc: {
                                                                                                                                                                                        start: {
                                                                                                                                                                                            line: 222,
                                                                                                                                                                                            column: 60,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                        },
                                                                                                                                                                                        end: {
                                                                                                                                                                                            line: 222,
                                                                                                                                                                                            column: 70,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                        }
                                                                                                                                                                                    }
                                                                                                                                                                                },
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 222,
                                                                                                                                                                                        column: 55,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 222,
                                                                                                                                                                                        column: 70,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            property: {
                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                name: 'repeatFinish',
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 222,
                                                                                                                                                                                        column: 71,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 222,
                                                                                                                                                                                        column: 83,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 222,
                                                                                                                                                                                    column: 55,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 222,
                                                                                                                                                                                    column: 83,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        kind: 'init',
                                                                                                                                                                        order: '0'
                                                                                                                                                                    },
                                                                                                                                                                    {
                                                                                                                                                                        type: 'Property',
                                                                                                                                                                        key: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'object',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 222,
                                                                                                                                                                                    column: 85,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 222,
                                                                                                                                                                                    column: 91,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        value: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'taskClone',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 222,
                                                                                                                                                                                    column: 92,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 222,
                                                                                                                                                                                    column: 101,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        kind: 'init',
                                                                                                                                                                        order: '1'
                                                                                                                                                                    },
                                                                                                                                                                    {
                                                                                                                                                                        type: 'Property',
                                                                                                                                                                        key: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'bind',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 222,
                                                                                                                                                                                    column: 103,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 222,
                                                                                                                                                                                    column: 107,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        value: {
                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                            value: true
                                                                                                                                                                        },
                                                                                                                                                                        kind: 'init',
                                                                                                                                                                        order: '2'
                                                                                                                                                                    }
                                                                                                                                                                ]
                                                                                                                                                            }],
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 222,
                                                                                                                                                                column: 40,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 222,
                                                                                                                                                                column: 113,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    properties: [{
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'style',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 223,
                                                                                                                                                                        column: 44,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 223,
                                                                                                                                                                        column: 49,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                                properties: [{
                                                                                                                                                                        type: 'Property',
                                                                                                                                                                        key: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'flex',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 223,
                                                                                                                                                                                    column: 51,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 223,
                                                                                                                                                                                    column: 55,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        value: {
                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                            value: '11 0'
                                                                                                                                                                        },
                                                                                                                                                                        kind: 'init',
                                                                                                                                                                        order: '0'
                                                                                                                                                                    }]
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '0'
                                                                                                                                                        }]
                                                                                                                                                },
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 222,
                                                                                                                                                        column: 40,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 224,
                                                                                                                                                        column: 44,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                order: '0'
                                                                                                                                            },
                                                                                                                                            {
                                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                                expression: {
                                                                                                                                                    type: 'CallExpression',
                                                                                                                                                    callee: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'Div',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 224,
                                                                                                                                                                column: 40,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 224,
                                                                                                                                                                column: 43,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    arguments: [{
                                                                                                                                                            type: 'ObjectExpression',
                                                                                                                                                            properties: [{
                                                                                                                                                                    type: 'Property',
                                                                                                                                                                    key: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'style',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 224,
                                                                                                                                                                                column: 44,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 224,
                                                                                                                                                                                column: 49,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    value: {
                                                                                                                                                                        type: 'Literal',
                                                                                                                                                                        value: 'flex: 1 1'
                                                                                                                                                                    },
                                                                                                                                                                    kind: 'init',
                                                                                                                                                                    order: '0'
                                                                                                                                                                }]
                                                                                                                                                        }],
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 224,
                                                                                                                                                            column: 40,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 224,
                                                                                                                                                            column: 62,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 224,
                                                                                                                                                        column: 40,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 224,
                                                                                                                                                        column: 62,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                order: '1'
                                                                                                                                            },
                                                                                                                                            {
                                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                                expression: {
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    objectType: {
                                                                                                                                                        type: 'CallExpression',
                                                                                                                                                        callee: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'Field',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 225,
                                                                                                                                                                    column: 40,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 225,
                                                                                                                                                                    column: 45,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        arguments: [{
                                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                                properties: [
                                                                                                                                                                    {
                                                                                                                                                                        type: 'Property',
                                                                                                                                                                        key: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'property',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 225,
                                                                                                                                                                                    column: 46,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 225,
                                                                                                                                                                                    column: 54,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        value: {
                                                                                                                                                                            type: 'MemberExpression',
                                                                                                                                                                            computed: false,
                                                                                                                                                                            object: {
                                                                                                                                                                                type: 'MemberExpression',
                                                                                                                                                                                computed: false,
                                                                                                                                                                                object: {
                                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                                    name: 'Task',
                                                                                                                                                                                    loc: {
                                                                                                                                                                                        start: {
                                                                                                                                                                                            line: 225,
                                                                                                                                                                                            column: 55,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                        },
                                                                                                                                                                                        end: {
                                                                                                                                                                                            line: 225,
                                                                                                                                                                                            column: 59,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                        }
                                                                                                                                                                                    }
                                                                                                                                                                                },
                                                                                                                                                                                property: {
                                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                                    name: 'properties',
                                                                                                                                                                                    loc: {
                                                                                                                                                                                        start: {
                                                                                                                                                                                            line: 225,
                                                                                                                                                                                            column: 60,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                        },
                                                                                                                                                                                        end: {
                                                                                                                                                                                            line: 225,
                                                                                                                                                                                            column: 70,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                        }
                                                                                                                                                                                    }
                                                                                                                                                                                },
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 225,
                                                                                                                                                                                        column: 55,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 225,
                                                                                                                                                                                        column: 70,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            property: {
                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                name: 'repeatCount',
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 225,
                                                                                                                                                                                        column: 71,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 225,
                                                                                                                                                                                        column: 82,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 225,
                                                                                                                                                                                    column: 55,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 225,
                                                                                                                                                                                    column: 82,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        kind: 'init',
                                                                                                                                                                        order: '0'
                                                                                                                                                                    },
                                                                                                                                                                    {
                                                                                                                                                                        type: 'Property',
                                                                                                                                                                        key: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'object',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 225,
                                                                                                                                                                                    column: 84,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 225,
                                                                                                                                                                                    column: 90,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        value: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'taskClone',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 225,
                                                                                                                                                                                    column: 91,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 225,
                                                                                                                                                                                    column: 100,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        kind: 'init',
                                                                                                                                                                        order: '1'
                                                                                                                                                                    },
                                                                                                                                                                    {
                                                                                                                                                                        type: 'Property',
                                                                                                                                                                        key: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'bind',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 225,
                                                                                                                                                                                    column: 102,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 225,
                                                                                                                                                                                    column: 106,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        value: {
                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                            value: true
                                                                                                                                                                        },
                                                                                                                                                                        kind: 'init',
                                                                                                                                                                        order: '2'
                                                                                                                                                                    }
                                                                                                                                                                ]
                                                                                                                                                            }],
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 225,
                                                                                                                                                                column: 40,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 225,
                                                                                                                                                                column: 112,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    properties: [{
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'style',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 226,
                                                                                                                                                                        column: 44,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 226,
                                                                                                                                                                        column: 49,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                                properties: [{
                                                                                                                                                                        type: 'Property',
                                                                                                                                                                        key: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'flex',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 226,
                                                                                                                                                                                    column: 51,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 226,
                                                                                                                                                                                    column: 55,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        value: {
                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                            value: '5 0'
                                                                                                                                                                        },
                                                                                                                                                                        kind: 'init',
                                                                                                                                                                        order: '0'
                                                                                                                                                                    }]
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '0'
                                                                                                                                                        }]
                                                                                                                                                },
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 225,
                                                                                                                                                        column: 40,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 227,
                                                                                                                                                        column: 44,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                order: '2'
                                                                                                                                            }
                                                                                                                                        ]
                                                                                                                                    },
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 221,
                                                                                                                                            column: 36,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 227,
                                                                                                                                            column: 40,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    order: '1'
                                                                                                                                },
                                                                                                                                {
                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                    expression: {
                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                        objectType: {
                                                                                                                                            type: 'CallExpression',
                                                                                                                                            callee: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'Field',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 227,
                                                                                                                                                        column: 36,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 227,
                                                                                                                                                        column: 41,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            arguments: [{
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    properties: [
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'property',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 227,
                                                                                                                                                                        column: 42,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 227,
                                                                                                                                                                        column: 50,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'MemberExpression',
                                                                                                                                                                computed: false,
                                                                                                                                                                object: {
                                                                                                                                                                    type: 'MemberExpression',
                                                                                                                                                                    computed: false,
                                                                                                                                                                    object: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'Task',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 227,
                                                                                                                                                                                column: 51,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 227,
                                                                                                                                                                                column: 55,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    property: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'properties',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 227,
                                                                                                                                                                                column: 56,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 227,
                                                                                                                                                                                column: 66,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 227,
                                                                                                                                                                            column: 51,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 227,
                                                                                                                                                                            column: 66,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                property: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'repeatDays',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 227,
                                                                                                                                                                            column: 67,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 227,
                                                                                                                                                                            column: 77,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 227,
                                                                                                                                                                        column: 51,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 227,
                                                                                                                                                                        column: 77,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '0'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'object',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 227,
                                                                                                                                                                        column: 79,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 227,
                                                                                                                                                                        column: 85,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'taskClone',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 227,
                                                                                                                                                                        column: 86,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 227,
                                                                                                                                                                        column: 95,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '1'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'bind',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 227,
                                                                                                                                                                        column: 97,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 227,
                                                                                                                                                                        column: 101,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: true
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '2'
                                                                                                                                                        }
                                                                                                                                                    ]
                                                                                                                                                }],
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 227,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 227,
                                                                                                                                                    column: 107,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        properties: [{
                                                                                                                                                type: 'Property',
                                                                                                                                                key: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'style',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 228,
                                                                                                                                                            column: 44,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 228,
                                                                                                                                                            column: 49,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                value: {
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    properties: [{
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'display',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 228,
                                                                                                                                                                        column: 52,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 228,
                                                                                                                                                                        column: 59,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'ConditionalExpression',
                                                                                                                                                                test: {
                                                                                                                                                                    type: 'BinaryExpression',
                                                                                                                                                                    operator: '===',
                                                                                                                                                                    left: {
                                                                                                                                                                        type: 'MemberExpression',
                                                                                                                                                                        computed: false,
                                                                                                                                                                        object: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'taskClone',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 228,
                                                                                                                                                                                    column: 61,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 228,
                                                                                                                                                                                    column: 70,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        property: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'repeatUnit',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 228,
                                                                                                                                                                                    column: 71,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 228,
                                                                                                                                                                                    column: 81,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 228,
                                                                                                                                                                                column: 61,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 228,
                                                                                                                                                                                column: 81,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    right: {
                                                                                                                                                                        type: 'Literal',
                                                                                                                                                                        value: 1
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                consequent: {
                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                    value: 'initial'
                                                                                                                                                                },
                                                                                                                                                                alternate: {
                                                                                                                                                                    type: 'Literal',
                                                                                                                                                                    value: 'none'
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '0'
                                                                                                                                                        }]
                                                                                                                                                },
                                                                                                                                                kind: 'init',
                                                                                                                                                order: '0'
                                                                                                                                            }]
                                                                                                                                    },
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 227,
                                                                                                                                            column: 36,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 229,
                                                                                                                                            column: 40,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    order: '2'
                                                                                                                                }
                                                                                                                            ]
                                                                                                                        },
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 218,
                                                                                                                                column: 32,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 229,
                                                                                                                                column: 36,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            }
                                                                                                                        },
                                                                                                                        order: '6'
                                                                                                                    },
                                                                                                                    {
                                                                                                                        type: 'ExpressionStatement',
                                                                                                                        expression: {
                                                                                                                            type: 'CallExpression',
                                                                                                                            callee: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'Div',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 229,
                                                                                                                                        column: 32,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 229,
                                                                                                                                        column: 35,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            arguments: [{
                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                    properties: [{
                                                                                                                                            type: 'Property',
                                                                                                                                            key: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'class',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 229,
                                                                                                                                                        column: 36,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 229,
                                                                                                                                                        column: 41,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            value: {
                                                                                                                                                type: 'Literal',
                                                                                                                                                value: 'fill'
                                                                                                                                            },
                                                                                                                                            kind: 'init',
                                                                                                                                            order: '0'
                                                                                                                                        }]
                                                                                                                                }],
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 229,
                                                                                                                                    column: 32,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 229,
                                                                                                                                    column: 49,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 229,
                                                                                                                                column: 32,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 229,
                                                                                                                                column: 49,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            }
                                                                                                                        },
                                                                                                                        order: '7'
                                                                                                                    },
                                                                                                                    {
                                                                                                                        type: 'ExpressionStatement',
                                                                                                                        expression: {
                                                                                                                            type: 'ObjectExpression',
                                                                                                                            objectType: {
                                                                                                                                type: 'CallExpression',
                                                                                                                                callee: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'FormFooter',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 230,
                                                                                                                                            column: 32,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 230,
                                                                                                                                            column: 42,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                arguments: [],
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 230,
                                                                                                                                        column: 32,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 230,
                                                                                                                                        column: 44,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            properties: [{
                                                                                                                                    type: 'IfStatement',
                                                                                                                                    test: {
                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                        operator: '||',
                                                                                                                                        left: {
                                                                                                                                            type: 'MemberExpression',
                                                                                                                                            computed: false,
                                                                                                                                            object: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'taskClone',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 231,
                                                                                                                                                        column: 39,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 231,
                                                                                                                                                        column: 48,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            property: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'start',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 231,
                                                                                                                                                        column: 49,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 231,
                                                                                                                                                        column: 54,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 231,
                                                                                                                                                    column: 39,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 231,
                                                                                                                                                    column: 54,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        right: {
                                                                                                                                            type: 'MemberExpression',
                                                                                                                                            computed: false,
                                                                                                                                            object: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'taskClone',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 231,
                                                                                                                                                        column: 58,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 231,
                                                                                                                                                        column: 67,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            property: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'finish',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 231,
                                                                                                                                                        column: 68,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 231,
                                                                                                                                                        column: 74,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 231,
                                                                                                                                                    column: 58,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 231,
                                                                                                                                                    column: 74,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    consequent: {
                                                                                                                                        type: 'BlockStatement',
                                                                                                                                        body: [
                                                                                                                                            {
                                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                                expression: {
                                                                                                                                                    type: 'CallExpression',
                                                                                                                                                    callee: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'Div',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 232,
                                                                                                                                                                column: 40,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 232,
                                                                                                                                                                column: 43,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    arguments: [{
                                                                                                                                                            type: 'ObjectExpression',
                                                                                                                                                            properties: [{
                                                                                                                                                                    type: 'Property',
                                                                                                                                                                    key: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'class',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 232,
                                                                                                                                                                                column: 44,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 232,
                                                                                                                                                                                column: 49,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    value: {
                                                                                                                                                                        type: 'Literal',
                                                                                                                                                                        value: 'fill'
                                                                                                                                                                    },
                                                                                                                                                                    kind: 'init',
                                                                                                                                                                    order: '0'
                                                                                                                                                                }]
                                                                                                                                                        }],
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 232,
                                                                                                                                                            column: 40,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 232,
                                                                                                                                                            column: 57,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 232,
                                                                                                                                                        column: 40,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 232,
                                                                                                                                                        column: 57,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                order: '0'
                                                                                                                                            },
                                                                                                                                            {
                                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                                expression: {
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    objectType: {
                                                                                                                                                        type: 'CallExpression',
                                                                                                                                                        callee: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'Div',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 233,
                                                                                                                                                                    column: 40,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 233,
                                                                                                                                                                    column: 43,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        arguments: [],
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 233,
                                                                                                                                                                column: 40,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 233,
                                                                                                                                                                column: 45,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    properties: [{
                                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                                            expression: {
                                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                                objectType: {
                                                                                                                                                                    type: 'CallExpression',
                                                                                                                                                                    callee: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'PaperButton',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 234,
                                                                                                                                                                                column: 44,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 234,
                                                                                                                                                                                column: 55,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    arguments: [],
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 234,
                                                                                                                                                                            column: 44,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 234,
                                                                                                                                                                            column: 57,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                properties: [
                                                                                                                                                                    {
                                                                                                                                                                        type: 'ExpressionStatement',
                                                                                                                                                                        expression: {
                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                            value: 'Unschedule'
                                                                                                                                                                        },
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 235,
                                                                                                                                                                                column: 48,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 235,
                                                                                                                                                                                column: 60,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        order: '0'
                                                                                                                                                                    },
                                                                                                                                                                    {
                                                                                                                                                                        type: 'ExpressionStatement',
                                                                                                                                                                        expression: {
                                                                                                                                                                            type: 'Function',
                                                                                                                                                                            context: true,
                                                                                                                                                                            value: function (_context6) {
                                                                                                                                                                                return function click() {
                                                                                                                                                                                    var taskClone = _context6.get('taskClone');
                                                                                                                                                                                    taskClone.clearSchedule();
                                                                                                                                                                                };
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 236,
                                                                                                                                                                                column: 48,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 238,
                                                                                                                                                                                column: 52,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        order: '1'
                                                                                                                                                                    }
                                                                                                                                                                ]
                                                                                                                                                            },
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 234,
                                                                                                                                                                    column: 44,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 238,
                                                                                                                                                                    column: 48,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            order: '0'
                                                                                                                                                        }]
                                                                                                                                                },
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 233,
                                                                                                                                                        column: 40,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 238,
                                                                                                                                                        column: 44,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                order: '1'
                                                                                                                                            }
                                                                                                                                        ]
                                                                                                                                    },
                                                                                                                                    alternate: null,
                                                                                                                                    order: '0'
                                                                                                                                }]
                                                                                                                        },
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 230,
                                                                                                                                column: 32,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 238,
                                                                                                                                column: 36,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            }
                                                                                                                        },
                                                                                                                        order: '8'
                                                                                                                    }
                                                                                                                ]
                                                                                                            },
                                                                                                            order: '0'
                                                                                                        }],
                                                                                                    bound: false,
                                                                                                    name: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'content',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 174,
                                                                                                                column: 24,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 174,
                                                                                                                column: 31,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    scope: {
                                                                                                        type: 'Identifier',
                                                                                                        name: '_ps2'
                                                                                                    }
                                                                                                }, {
                                                                                                    this: this,
                                                                                                    _ps2: _ps2,
                                                                                                    config: config,
                                                                                                    ion: ion,
                                                                                                    glass: glass,
                                                                                                    _ref: _ref,
                                                                                                    _ref2: _ref2,
                                                                                                    _ref3: _ref3,
                                                                                                    viewpath: viewpath,
                                                                                                    _ref4: _ref4,
                                                                                                    _ref5: _ref5,
                                                                                                    _ref6: _ref6,
                                                                                                    style: style,
                                                                                                    Key: Key,
                                                                                                    Schema: Schema,
                                                                                                    CommentItem: CommentItem,
                                                                                                    Loader: Loader,
                                                                                                    DiscussionEditor: DiscussionEditor,
                                                                                                    User: User,
                                                                                                    Task: Task,
                                                                                                    Project: Project,
                                                                                                    Organization: Organization,
                                                                                                    Comment: Comment,
                                                                                                    TabContent: TabContent,
                                                                                                    Renamer: Renamer,
                                                                                                    Field: Field,
                                                                                                    GlassForm: GlassForm,
                                                                                                    lightGray: lightGray,
                                                                                                    _ref7: _ref7,
                                                                                                    _ref8: _ref8,
                                                                                                    apply: apply,
                                                                                                    TaskInfoRow: TaskInfoRow
                                                                                                }, _ps2);
                                                                                            });
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '2'
                                                                                }
                                                                            ]
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 171,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 238,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                            }
                                                                        },
                                                                        order: '0'
                                                                    },
                                                                    {
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'ObjectExpression',
                                                                            objectType: {
                                                                                type: 'ObjectExpression',
                                                                                properties: []
                                                                            },
                                                                            properties: [
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'name',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 239,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 239,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Literal',
                                                                                        value: 'properties'
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'tab',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 240,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 240,
                                                                                                column: 27,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Function',
                                                                                        context: false,
                                                                                        value: function () {
                                                                                            return 'Properties';
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '1'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'content',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 241,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 241,
                                                                                                column: 31,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Function',
                                                                                        context: true,
                                                                                        value: function (_ps3) {
                                                                                            return ion.template(function () {
                                                                                                return ion.createRuntime({
                                                                                                    type: 'Template',
                                                                                                    id: null,
                                                                                                    body: [{
                                                                                                            type: 'ReturnStatement',
                                                                                                            argument: {
                                                                                                                type: 'ObjectExpression',
                                                                                                                objectType: {
                                                                                                                    type: 'CallExpression',
                                                                                                                    callee: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'GlassForm',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 242,
                                                                                                                                column: 35,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 242,
                                                                                                                                column: 44,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    arguments: [{
                                                                                                                            type: 'ObjectExpression',
                                                                                                                            properties: [{
                                                                                                                                    type: 'Property',
                                                                                                                                    key: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'class',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 242,
                                                                                                                                                column: 45,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 242,
                                                                                                                                                column: 50,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    value: {
                                                                                                                                        type: 'Literal',
                                                                                                                                        value: 'layout vertical flex'
                                                                                                                                    },
                                                                                                                                    kind: 'init',
                                                                                                                                    order: '0'
                                                                                                                                }]
                                                                                                                        }],
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 242,
                                                                                                                            column: 35,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 242,
                                                                                                                            column: 74,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                properties: [
                                                                                                                    {
                                                                                                                        type: 'ExpressionStatement',
                                                                                                                        expression: {
                                                                                                                            type: 'ObjectExpression',
                                                                                                                            objectType: {
                                                                                                                                type: 'CallExpression',
                                                                                                                                callee: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'Div',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 243,
                                                                                                                                            column: 32,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 243,
                                                                                                                                            column: 35,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                arguments: [{
                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                        properties: [{
                                                                                                                                                type: 'Property',
                                                                                                                                                key: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'class',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 243,
                                                                                                                                                            column: 36,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 243,
                                                                                                                                                            column: 41,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                value: {
                                                                                                                                                    type: 'Literal',
                                                                                                                                                    value: 'layout horizontal'
                                                                                                                                                },
                                                                                                                                                kind: 'init',
                                                                                                                                                order: '0'
                                                                                                                                            }]
                                                                                                                                    }],
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 243,
                                                                                                                                        column: 32,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 243,
                                                                                                                                        column: 62,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            properties: [
                                                                                                                                {
                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                    expression: {
                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                        objectType: {
                                                                                                                                            type: 'CallExpression',
                                                                                                                                            callee: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'Field',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 244,
                                                                                                                                                        column: 36,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 244,
                                                                                                                                                        column: 41,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            arguments: [{
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    properties: [
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'property',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 244,
                                                                                                                                                                        column: 42,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 244,
                                                                                                                                                                        column: 50,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'MemberExpression',
                                                                                                                                                                computed: false,
                                                                                                                                                                object: {
                                                                                                                                                                    type: 'MemberExpression',
                                                                                                                                                                    computed: false,
                                                                                                                                                                    object: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'Task',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 244,
                                                                                                                                                                                column: 51,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 244,
                                                                                                                                                                                column: 55,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    property: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'properties',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 244,
                                                                                                                                                                                column: 56,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 244,
                                                                                                                                                                                column: 66,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 244,
                                                                                                                                                                            column: 51,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 244,
                                                                                                                                                                            column: 66,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                property: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'description',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 244,
                                                                                                                                                                            column: 67,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 244,
                                                                                                                                                                            column: 78,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 244,
                                                                                                                                                                        column: 51,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 244,
                                                                                                                                                                        column: 78,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '0'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'object',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 244,
                                                                                                                                                                        column: 80,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 244,
                                                                                                                                                                        column: 86,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'taskClone',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 244,
                                                                                                                                                                        column: 87,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 244,
                                                                                                                                                                        column: 96,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '1'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'bind',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 244,
                                                                                                                                                                        column: 98,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 244,
                                                                                                                                                                        column: 102,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: true
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '2'
                                                                                                                                                        }
                                                                                                                                                    ]
                                                                                                                                                }],
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 244,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 244,
                                                                                                                                                    column: 108,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        properties: [{
                                                                                                                                                type: 'Property',
                                                                                                                                                key: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'style',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 245,
                                                                                                                                                            column: 40,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 245,
                                                                                                                                                            column: 45,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                value: {
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    properties: [{
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'flex',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 245,
                                                                                                                                                                        column: 47,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 245,
                                                                                                                                                                        column: 51,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: '11 0'
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '0'
                                                                                                                                                        }]
                                                                                                                                                },
                                                                                                                                                kind: 'init',
                                                                                                                                                order: '0'
                                                                                                                                            }]
                                                                                                                                    },
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 244,
                                                                                                                                            column: 36,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 246,
                                                                                                                                            column: 40,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    order: '0'
                                                                                                                                },
                                                                                                                                {
                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                    expression: {
                                                                                                                                        type: 'CallExpression',
                                                                                                                                        callee: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'Div',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 246,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 246,
                                                                                                                                                    column: 39,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        arguments: [{
                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                properties: [{
                                                                                                                                                        type: 'Property',
                                                                                                                                                        key: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'style',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 246,
                                                                                                                                                                    column: 40,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 246,
                                                                                                                                                                    column: 45,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        value: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: 'flex: 1 1'
                                                                                                                                                        },
                                                                                                                                                        kind: 'init',
                                                                                                                                                        order: '0'
                                                                                                                                                    }]
                                                                                                                                            }],
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 246,
                                                                                                                                                column: 36,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 246,
                                                                                                                                                column: 58,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 246,
                                                                                                                                            column: 36,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 246,
                                                                                                                                            column: 58,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    order: '1'
                                                                                                                                },
                                                                                                                                {
                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                    expression: {
                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                        objectType: {
                                                                                                                                            type: 'CallExpression',
                                                                                                                                            callee: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'Field',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 247,
                                                                                                                                                        column: 36,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 247,
                                                                                                                                                        column: 41,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            arguments: [{
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    properties: [
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'property',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 247,
                                                                                                                                                                        column: 42,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 247,
                                                                                                                                                                        column: 50,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'MemberExpression',
                                                                                                                                                                computed: false,
                                                                                                                                                                object: {
                                                                                                                                                                    type: 'MemberExpression',
                                                                                                                                                                    computed: false,
                                                                                                                                                                    object: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'Task',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 247,
                                                                                                                                                                                column: 51,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 247,
                                                                                                                                                                                column: 55,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    property: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'properties',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 247,
                                                                                                                                                                                column: 56,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 247,
                                                                                                                                                                                column: 66,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 247,
                                                                                                                                                                            column: 51,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 247,
                                                                                                                                                                            column: 66,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                property: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'priority',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 247,
                                                                                                                                                                            column: 67,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 247,
                                                                                                                                                                            column: 75,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 247,
                                                                                                                                                                        column: 51,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 247,
                                                                                                                                                                        column: 75,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '0'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'object',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 247,
                                                                                                                                                                        column: 77,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 247,
                                                                                                                                                                        column: 83,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'taskClone',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 247,
                                                                                                                                                                        column: 84,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 247,
                                                                                                                                                                        column: 93,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '1'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'bind',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 247,
                                                                                                                                                                        column: 95,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 247,
                                                                                                                                                                        column: 99,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: true
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '2'
                                                                                                                                                        }
                                                                                                                                                    ]
                                                                                                                                                }],
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 247,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 247,
                                                                                                                                                    column: 105,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        properties: [{
                                                                                                                                                type: 'Property',
                                                                                                                                                key: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'style',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 248,
                                                                                                                                                            column: 40,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 248,
                                                                                                                                                            column: 45,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                value: {
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    properties: [{
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'flex',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 248,
                                                                                                                                                                        column: 47,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 248,
                                                                                                                                                                        column: 51,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: '5 0'
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '0'
                                                                                                                                                        }]
                                                                                                                                                },
                                                                                                                                                kind: 'init',
                                                                                                                                                order: '0'
                                                                                                                                            }]
                                                                                                                                    },
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 247,
                                                                                                                                            column: 36,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 250,
                                                                                                                                            column: 40,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    order: '2'
                                                                                                                                }
                                                                                                                            ]
                                                                                                                        },
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 243,
                                                                                                                                column: 32,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 250,
                                                                                                                                column: 36,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            }
                                                                                                                        },
                                                                                                                        order: '0'
                                                                                                                    },
                                                                                                                    {
                                                                                                                        type: 'ExpressionStatement',
                                                                                                                        expression: {
                                                                                                                            type: 'ObjectExpression',
                                                                                                                            objectType: {
                                                                                                                                type: 'CallExpression',
                                                                                                                                callee: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'Div',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 250,
                                                                                                                                            column: 32,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 250,
                                                                                                                                            column: 35,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                arguments: [{
                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                        properties: [{
                                                                                                                                                type: 'Property',
                                                                                                                                                key: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'class',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 250,
                                                                                                                                                            column: 36,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 250,
                                                                                                                                                            column: 41,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                value: {
                                                                                                                                                    type: 'Literal',
                                                                                                                                                    value: 'layout horizontal'
                                                                                                                                                },
                                                                                                                                                kind: 'init',
                                                                                                                                                order: '0'
                                                                                                                                            }]
                                                                                                                                    }],
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 250,
                                                                                                                                        column: 32,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 250,
                                                                                                                                        column: 62,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            properties: [
                                                                                                                                {
                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                    expression: {
                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                        objectType: {
                                                                                                                                            type: 'CallExpression',
                                                                                                                                            callee: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'Field',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 251,
                                                                                                                                                        column: 36,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 251,
                                                                                                                                                        column: 41,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            arguments: [{
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    properties: [
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'property',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 251,
                                                                                                                                                                        column: 42,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 251,
                                                                                                                                                                        column: 50,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'MemberExpression',
                                                                                                                                                                computed: false,
                                                                                                                                                                object: {
                                                                                                                                                                    type: 'MemberExpression',
                                                                                                                                                                    computed: false,
                                                                                                                                                                    object: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'Task',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 251,
                                                                                                                                                                                column: 51,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 251,
                                                                                                                                                                                column: 55,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    property: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'properties',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 251,
                                                                                                                                                                                column: 56,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 251,
                                                                                                                                                                                column: 66,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 251,
                                                                                                                                                                            column: 51,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 251,
                                                                                                                                                                            column: 66,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                property: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'tags',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 251,
                                                                                                                                                                            column: 67,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 251,
                                                                                                                                                                            column: 71,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 251,
                                                                                                                                                                        column: 51,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 251,
                                                                                                                                                                        column: 71,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '0'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'inline',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 251,
                                                                                                                                                                        column: 73,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 251,
                                                                                                                                                                        column: 79,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: false
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '1'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'object',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 251,
                                                                                                                                                                        column: 87,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 251,
                                                                                                                                                                        column: 93,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'taskClone',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 251,
                                                                                                                                                                        column: 94,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 251,
                                                                                                                                                                        column: 103,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '2'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'bind',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 251,
                                                                                                                                                                        column: 105,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 251,
                                                                                                                                                                        column: 109,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: true
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '3'
                                                                                                                                                        }
                                                                                                                                                    ]
                                                                                                                                                }],
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 251,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 251,
                                                                                                                                                    column: 115,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        properties: [{
                                                                                                                                                type: 'Property',
                                                                                                                                                key: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'style',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 252,
                                                                                                                                                            column: 40,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 252,
                                                                                                                                                            column: 45,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                value: {
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    properties: [{
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'flex',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 252,
                                                                                                                                                                        column: 47,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 252,
                                                                                                                                                                        column: 51,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: '11 0'
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '0'
                                                                                                                                                        }]
                                                                                                                                                },
                                                                                                                                                kind: 'init',
                                                                                                                                                order: '0'
                                                                                                                                            }]
                                                                                                                                    },
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 251,
                                                                                                                                            column: 36,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 253,
                                                                                                                                            column: 40,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    order: '0'
                                                                                                                                },
                                                                                                                                {
                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                    expression: {
                                                                                                                                        type: 'CallExpression',
                                                                                                                                        callee: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'Div',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 253,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 253,
                                                                                                                                                    column: 39,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        arguments: [{
                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                properties: [{
                                                                                                                                                        type: 'Property',
                                                                                                                                                        key: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'style',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 253,
                                                                                                                                                                    column: 40,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 253,
                                                                                                                                                                    column: 45,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        value: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: 'flex: 1 1'
                                                                                                                                                        },
                                                                                                                                                        kind: 'init',
                                                                                                                                                        order: '0'
                                                                                                                                                    }]
                                                                                                                                            }],
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 253,
                                                                                                                                                column: 36,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 253,
                                                                                                                                                column: 58,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 253,
                                                                                                                                            column: 36,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 253,
                                                                                                                                            column: 58,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    order: '1'
                                                                                                                                },
                                                                                                                                {
                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                    expression: {
                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                        objectType: {
                                                                                                                                            type: 'CallExpression',
                                                                                                                                            callee: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'Field',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 254,
                                                                                                                                                        column: 36,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 254,
                                                                                                                                                        column: 41,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            arguments: [{
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    properties: [
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'property',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 254,
                                                                                                                                                                        column: 42,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 254,
                                                                                                                                                                        column: 50,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'MemberExpression',
                                                                                                                                                                computed: false,
                                                                                                                                                                object: {
                                                                                                                                                                    type: 'MemberExpression',
                                                                                                                                                                    computed: false,
                                                                                                                                                                    object: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'Task',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 254,
                                                                                                                                                                                column: 51,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 254,
                                                                                                                                                                                column: 55,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    property: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'properties',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 254,
                                                                                                                                                                                column: 56,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 254,
                                                                                                                                                                                column: 66,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 254,
                                                                                                                                                                            column: 51,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 254,
                                                                                                                                                                            column: 66,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                property: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'timezone',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 254,
                                                                                                                                                                            column: 67,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 254,
                                                                                                                                                                            column: 75,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 254,
                                                                                                                                                                        column: 51,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 254,
                                                                                                                                                                        column: 75,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '0'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'object',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 254,
                                                                                                                                                                        column: 77,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 254,
                                                                                                                                                                        column: 83,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'taskClone',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 254,
                                                                                                                                                                        column: 84,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 254,
                                                                                                                                                                        column: 93,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '1'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'bind',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 254,
                                                                                                                                                                        column: 95,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 254,
                                                                                                                                                                        column: 99,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: true
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '2'
                                                                                                                                                        }
                                                                                                                                                    ]
                                                                                                                                                }],
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 254,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 254,
                                                                                                                                                    column: 105,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        properties: [{
                                                                                                                                                type: 'Property',
                                                                                                                                                key: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'style',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 255,
                                                                                                                                                            column: 40,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 255,
                                                                                                                                                            column: 45,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                value: {
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    properties: [{
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'flex',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 255,
                                                                                                                                                                        column: 47,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 255,
                                                                                                                                                                        column: 51,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: '5 0'
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '0'
                                                                                                                                                        }]
                                                                                                                                                },
                                                                                                                                                kind: 'init',
                                                                                                                                                order: '0'
                                                                                                                                            }]
                                                                                                                                    },
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 254,
                                                                                                                                            column: 36,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 257,
                                                                                                                                            column: 40,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    order: '2'
                                                                                                                                }
                                                                                                                            ]
                                                                                                                        },
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 250,
                                                                                                                                column: 32,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 257,
                                                                                                                                column: 36,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            }
                                                                                                                        },
                                                                                                                        order: '1'
                                                                                                                    },
                                                                                                                    {
                                                                                                                        type: 'ExpressionStatement',
                                                                                                                        expression: {
                                                                                                                            type: 'ObjectExpression',
                                                                                                                            objectType: {
                                                                                                                                type: 'CallExpression',
                                                                                                                                callee: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'Div',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 257,
                                                                                                                                            column: 32,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 257,
                                                                                                                                            column: 35,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                arguments: [{
                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                        properties: [{
                                                                                                                                                type: 'Property',
                                                                                                                                                key: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'class',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 257,
                                                                                                                                                            column: 36,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 257,
                                                                                                                                                            column: 41,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                value: {
                                                                                                                                                    type: 'Literal',
                                                                                                                                                    value: 'layout horizontal'
                                                                                                                                                },
                                                                                                                                                kind: 'init',
                                                                                                                                                order: '0'
                                                                                                                                            }]
                                                                                                                                    }],
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 257,
                                                                                                                                        column: 32,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 257,
                                                                                                                                        column: 62,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            properties: [
                                                                                                                                {
                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                    expression: {
                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                        objectType: {
                                                                                                                                            type: 'CallExpression',
                                                                                                                                            callee: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'Div',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 258,
                                                                                                                                                        column: 36,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 258,
                                                                                                                                                        column: 39,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            arguments: [{
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    properties: [
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'class',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 258,
                                                                                                                                                                        column: 40,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 258,
                                                                                                                                                                        column: 45,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: 'layout vertical flex'
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '0'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'style',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 258,
                                                                                                                                                                        column: 70,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 258,
                                                                                                                                                                        column: 75,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: 'flex: 11 1'
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '1'
                                                                                                                                                        }
                                                                                                                                                    ]
                                                                                                                                                }],
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 258,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 258,
                                                                                                                                                    column: 89,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        properties: [{
                                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                                expression: {
                                                                                                                                                    type: 'CallExpression',
                                                                                                                                                    callee: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'Field',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 260,
                                                                                                                                                                column: 40,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 260,
                                                                                                                                                                column: 45,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    arguments: [{
                                                                                                                                                            type: 'ObjectExpression',
                                                                                                                                                            properties: [
                                                                                                                                                                {
                                                                                                                                                                    type: 'Property',
                                                                                                                                                                    key: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'property',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 260,
                                                                                                                                                                                column: 46,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 260,
                                                                                                                                                                                column: 54,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    value: {
                                                                                                                                                                        type: 'MemberExpression',
                                                                                                                                                                        computed: false,
                                                                                                                                                                        object: {
                                                                                                                                                                            type: 'MemberExpression',
                                                                                                                                                                            computed: false,
                                                                                                                                                                            object: {
                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                name: 'Task',
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 260,
                                                                                                                                                                                        column: 55,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 260,
                                                                                                                                                                                        column: 59,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            property: {
                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                name: 'properties',
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 260,
                                                                                                                                                                                        column: 60,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 260,
                                                                                                                                                                                        column: 70,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 260,
                                                                                                                                                                                    column: 55,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 260,
                                                                                                                                                                                    column: 70,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        property: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'color',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 260,
                                                                                                                                                                                    column: 71,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 260,
                                                                                                                                                                                    column: 76,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 260,
                                                                                                                                                                                column: 55,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 260,
                                                                                                                                                                                column: 76,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    kind: 'init',
                                                                                                                                                                    order: '0'
                                                                                                                                                                },
                                                                                                                                                                {
                                                                                                                                                                    type: 'Property',
                                                                                                                                                                    key: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'object',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 260,
                                                                                                                                                                                column: 78,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 260,
                                                                                                                                                                                column: 84,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    value: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'taskClone',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 260,
                                                                                                                                                                                column: 85,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 260,
                                                                                                                                                                                column: 94,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    kind: 'init',
                                                                                                                                                                    order: '1'
                                                                                                                                                                },
                                                                                                                                                                {
                                                                                                                                                                    type: 'Property',
                                                                                                                                                                    key: {
                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                        name: 'bind',
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 260,
                                                                                                                                                                                column: 96,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 260,
                                                                                                                                                                                column: 100,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    value: {
                                                                                                                                                                        type: 'Literal',
                                                                                                                                                                        value: true
                                                                                                                                                                    },
                                                                                                                                                                    kind: 'init',
                                                                                                                                                                    order: '2'
                                                                                                                                                                }
                                                                                                                                                            ]
                                                                                                                                                        }],
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 260,
                                                                                                                                                            column: 40,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 260,
                                                                                                                                                            column: 106,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 260,
                                                                                                                                                        column: 40,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 260,
                                                                                                                                                        column: 106,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                order: '0'
                                                                                                                                            }]
                                                                                                                                    },
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 258,
                                                                                                                                            column: 36,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 261,
                                                                                                                                            column: 40,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    order: '0'
                                                                                                                                },
                                                                                                                                {
                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                    expression: {
                                                                                                                                        type: 'CallExpression',
                                                                                                                                        callee: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'Div',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 261,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 261,
                                                                                                                                                    column: 39,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        arguments: [{
                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                properties: [{
                                                                                                                                                        type: 'Property',
                                                                                                                                                        key: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'style',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 261,
                                                                                                                                                                    column: 40,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 261,
                                                                                                                                                                    column: 45,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        value: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: 'flex: 1 1'
                                                                                                                                                        },
                                                                                                                                                        kind: 'init',
                                                                                                                                                        order: '0'
                                                                                                                                                    }]
                                                                                                                                            }],
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 261,
                                                                                                                                                column: 36,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 261,
                                                                                                                                                column: 58,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 261,
                                                                                                                                            column: 36,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 261,
                                                                                                                                            column: 58,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    order: '1'
                                                                                                                                },
                                                                                                                                {
                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                    expression: {
                                                                                                                                        type: 'ObjectExpression',
                                                                                                                                        objectType: {
                                                                                                                                            type: 'CallExpression',
                                                                                                                                            callee: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'Div',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 262,
                                                                                                                                                        column: 36,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 262,
                                                                                                                                                        column: 39,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            arguments: [{
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    properties: [{
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'style',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 262,
                                                                                                                                                                        column: 40,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 262,
                                                                                                                                                                        column: 45,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: 'flex: 5 1'
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '0'
                                                                                                                                                        }]
                                                                                                                                                }],
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 262,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 262,
                                                                                                                                                    column: 58,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        properties: [
                                                                                                                                            {
                                                                                                                                                type: 'VariableDeclaration',
                                                                                                                                                declarations: [{
                                                                                                                                                        type: 'VariableDeclarator',
                                                                                                                                                        id: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'creator',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 263,
                                                                                                                                                                    column: 44,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 263,
                                                                                                                                                                    column: 51,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        init: {
                                                                                                                                                            type: 'MemberExpression',
                                                                                                                                                            computed: true,
                                                                                                                                                            object: {
                                                                                                                                                                type: 'MemberExpression',
                                                                                                                                                                computed: false,
                                                                                                                                                                object: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'model',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 263,
                                                                                                                                                                            column: 54,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 263,
                                                                                                                                                                            column: 59,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                property: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'server',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 263,
                                                                                                                                                                            column: 60,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 263,
                                                                                                                                                                            column: 66,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 263,
                                                                                                                                                                        column: 54,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 263,
                                                                                                                                                                        column: 66,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            property: {
                                                                                                                                                                type: 'MemberExpression',
                                                                                                                                                                computed: false,
                                                                                                                                                                object: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'task',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 263,
                                                                                                                                                                            column: 67,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 263,
                                                                                                                                                                            column: 71,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                property: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'createdBy',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 263,
                                                                                                                                                                            column: 72,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 263,
                                                                                                                                                                            column: 81,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 263,
                                                                                                                                                                        column: 67,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 263,
                                                                                                                                                                        column: 81,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 263,
                                                                                                                                                                    column: 54,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 263,
                                                                                                                                                                    column: 82,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    }],
                                                                                                                                                kind: 'let',
                                                                                                                                                order: '0'
                                                                                                                                            },
                                                                                                                                            {
                                                                                                                                                type: 'VariableDeclaration',
                                                                                                                                                declarations: [{
                                                                                                                                                        type: 'VariableDeclarator',
                                                                                                                                                        id: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'updater',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 264,
                                                                                                                                                                    column: 44,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 264,
                                                                                                                                                                    column: 51,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        init: {
                                                                                                                                                            type: 'MemberExpression',
                                                                                                                                                            computed: true,
                                                                                                                                                            object: {
                                                                                                                                                                type: 'MemberExpression',
                                                                                                                                                                computed: false,
                                                                                                                                                                object: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'model',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 264,
                                                                                                                                                                            column: 54,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 264,
                                                                                                                                                                            column: 59,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                property: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'server',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 264,
                                                                                                                                                                            column: 60,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 264,
                                                                                                                                                                            column: 66,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 264,
                                                                                                                                                                        column: 54,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 264,
                                                                                                                                                                        column: 66,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            property: {
                                                                                                                                                                type: 'MemberExpression',
                                                                                                                                                                computed: false,
                                                                                                                                                                object: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'task',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 264,
                                                                                                                                                                            column: 67,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 264,
                                                                                                                                                                            column: 71,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                property: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'updatedBy',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 264,
                                                                                                                                                                            column: 72,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 264,
                                                                                                                                                                            column: 81,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 264,
                                                                                                                                                                        column: 67,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 264,
                                                                                                                                                                        column: 81,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 264,
                                                                                                                                                                    column: 54,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 264,
                                                                                                                                                                    column: 82,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    }],
                                                                                                                                                kind: 'let',
                                                                                                                                                order: '1'
                                                                                                                                            },
                                                                                                                                            {
                                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                                expression: {
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    objectType: {
                                                                                                                                                        type: 'CallExpression',
                                                                                                                                                        callee: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'Table',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 265,
                                                                                                                                                                    column: 40,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 265,
                                                                                                                                                                    column: 45,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        arguments: [{
                                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                                properties: [
                                                                                                                                                                    {
                                                                                                                                                                        type: 'Property',
                                                                                                                                                                        key: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'width',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 265,
                                                                                                                                                                                    column: 46,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 265,
                                                                                                                                                                                    column: 51,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        value: {
                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                            value: '100%'
                                                                                                                                                                        },
                                                                                                                                                                        kind: 'init',
                                                                                                                                                                        order: '0'
                                                                                                                                                                    },
                                                                                                                                                                    {
                                                                                                                                                                        type: 'Property',
                                                                                                                                                                        key: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'style',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 265,
                                                                                                                                                                                    column: 59,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 265,
                                                                                                                                                                                    column: 64,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        value: {
                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                            value: 'color:#828282;font-size:14px'
                                                                                                                                                                        },
                                                                                                                                                                        kind: 'init',
                                                                                                                                                                        order: '1'
                                                                                                                                                                    }
                                                                                                                                                                ]
                                                                                                                                                            }],
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 265,
                                                                                                                                                                column: 40,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 265,
                                                                                                                                                                column: 96,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    properties: [
                                                                                                                                                        {
                                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                                            expression: {
                                                                                                                                                                type: 'CallExpression',
                                                                                                                                                                callee: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'TaskInfoRow',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 266,
                                                                                                                                                                            column: 44,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 266,
                                                                                                                                                                            column: 55,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                arguments: [
                                                                                                                                                                    {
                                                                                                                                                                        type: 'Literal',
                                                                                                                                                                        value: 'Project'
                                                                                                                                                                    },
                                                                                                                                                                    {
                                                                                                                                                                        type: 'MemberExpression',
                                                                                                                                                                        computed: false,
                                                                                                                                                                        object: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'project',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 266,
                                                                                                                                                                                    column: 67,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 266,
                                                                                                                                                                                    column: 74,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        property: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'name',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 266,
                                                                                                                                                                                    column: 75,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 266,
                                                                                                                                                                                    column: 79,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 266,
                                                                                                                                                                                column: 67,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 266,
                                                                                                                                                                                column: 79,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    {
                                                                                                                                                                        type: 'MemberExpression',
                                                                                                                                                                        computed: false,
                                                                                                                                                                        object: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'task',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 266,
                                                                                                                                                                                    column: 81,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 266,
                                                                                                                                                                                    column: 85,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        property: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'projectPaneConfig',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 266,
                                                                                                                                                                                    column: 86,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 266,
                                                                                                                                                                                    column: 103,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 266,
                                                                                                                                                                                column: 81,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 266,
                                                                                                                                                                                column: 103,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                ],
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 266,
                                                                                                                                                                        column: 44,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 266,
                                                                                                                                                                        column: 104,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 266,
                                                                                                                                                                    column: 44,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 266,
                                                                                                                                                                    column: 104,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            order: '0'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                                            expression: {
                                                                                                                                                                type: 'CallExpression',
                                                                                                                                                                callee: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'TaskInfoRow',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 267,
                                                                                                                                                                            column: 44,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 267,
                                                                                                                                                                            column: 55,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                arguments: [
                                                                                                                                                                    {
                                                                                                                                                                        type: 'Literal',
                                                                                                                                                                        value: 'Organization'
                                                                                                                                                                    },
                                                                                                                                                                    {
                                                                                                                                                                        type: 'MemberExpression',
                                                                                                                                                                        computed: false,
                                                                                                                                                                        object: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'org',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 267,
                                                                                                                                                                                    column: 72,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 267,
                                                                                                                                                                                    column: 75,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        property: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'name',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 267,
                                                                                                                                                                                    column: 76,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 267,
                                                                                                                                                                                    column: 80,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 267,
                                                                                                                                                                                column: 72,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 267,
                                                                                                                                                                                column: 80,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    {
                                                                                                                                                                        type: 'MemberExpression',
                                                                                                                                                                        computed: false,
                                                                                                                                                                        object: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'org',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 267,
                                                                                                                                                                                    column: 82,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 267,
                                                                                                                                                                                    column: 85,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        property: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'paneConfig',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 267,
                                                                                                                                                                                    column: 86,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 267,
                                                                                                                                                                                    column: 96,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 267,
                                                                                                                                                                                column: 82,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 267,
                                                                                                                                                                                column: 96,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                ],
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 267,
                                                                                                                                                                        column: 44,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 267,
                                                                                                                                                                        column: 97,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 267,
                                                                                                                                                                    column: 44,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 267,
                                                                                                                                                                    column: 97,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            order: '1'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                                            expression: {
                                                                                                                                                                type: 'CallExpression',
                                                                                                                                                                callee: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'TaskInfoRow',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 268,
                                                                                                                                                                            column: 44,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 268,
                                                                                                                                                                            column: 55,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                arguments: [
                                                                                                                                                                    {
                                                                                                                                                                        type: 'Literal',
                                                                                                                                                                        value: 'Created'
                                                                                                                                                                    },
                                                                                                                                                                    {
                                                                                                                                                                        type: 'CallExpression',
                                                                                                                                                                        callee: {
                                                                                                                                                                            type: 'MemberExpression',
                                                                                                                                                                            computed: false,
                                                                                                                                                                            object: {
                                                                                                                                                                                type: 'CallExpression',
                                                                                                                                                                                callee: {
                                                                                                                                                                                    type: 'MemberExpression',
                                                                                                                                                                                    computed: false,
                                                                                                                                                                                    object: {
                                                                                                                                                                                        type: 'MemberExpression',
                                                                                                                                                                                        computed: false,
                                                                                                                                                                                        object: {
                                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                                            name: 'task',
                                                                                                                                                                                            loc: {
                                                                                                                                                                                                start: {
                                                                                                                                                                                                    line: 268,
                                                                                                                                                                                                    column: 67,
                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                                },
                                                                                                                                                                                                end: {
                                                                                                                                                                                                    line: 268,
                                                                                                                                                                                                    column: 71,
                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                                }
                                                                                                                                                                                            }
                                                                                                                                                                                        },
                                                                                                                                                                                        property: {
                                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                                            name: 'Created',
                                                                                                                                                                                            loc: {
                                                                                                                                                                                                start: {
                                                                                                                                                                                                    line: 268,
                                                                                                                                                                                                    column: 72,
                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                                },
                                                                                                                                                                                                end: {
                                                                                                                                                                                                    line: 268,
                                                                                                                                                                                                    column: 79,
                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                                }
                                                                                                                                                                                            }
                                                                                                                                                                                        },
                                                                                                                                                                                        loc: {
                                                                                                                                                                                            start: {
                                                                                                                                                                                                line: 268,
                                                                                                                                                                                                column: 67,
                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                            },
                                                                                                                                                                                            end: {
                                                                                                                                                                                                line: 268,
                                                                                                                                                                                                column: 79,
                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                            }
                                                                                                                                                                                        }
                                                                                                                                                                                    },
                                                                                                                                                                                    property: {
                                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                                        name: 'toDate',
                                                                                                                                                                                        loc: {
                                                                                                                                                                                            start: {
                                                                                                                                                                                                line: 268,
                                                                                                                                                                                                column: 80,
                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                            },
                                                                                                                                                                                            end: {
                                                                                                                                                                                                line: 268,
                                                                                                                                                                                                column: 86,
                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                            }
                                                                                                                                                                                        }
                                                                                                                                                                                    },
                                                                                                                                                                                    loc: {
                                                                                                                                                                                        start: {
                                                                                                                                                                                            line: 268,
                                                                                                                                                                                            column: 67,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                        },
                                                                                                                                                                                        end: {
                                                                                                                                                                                            line: 268,
                                                                                                                                                                                            column: 86,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                        }
                                                                                                                                                                                    }
                                                                                                                                                                                },
                                                                                                                                                                                arguments: [],
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 268,
                                                                                                                                                                                        column: 67,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 268,
                                                                                                                                                                                        column: 88,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            property: {
                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                name: 'format',
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 268,
                                                                                                                                                                                        column: 89,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 268,
                                                                                                                                                                                        column: 95,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 268,
                                                                                                                                                                                    column: 67,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 268,
                                                                                                                                                                                    column: 95,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        arguments: [{
                                                                                                                                                                                type: 'Literal',
                                                                                                                                                                                value: '{MM}/{dd}/{yyyy} {time}'
                                                                                                                                                                            }],
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 268,
                                                                                                                                                                                column: 67,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 268,
                                                                                                                                                                                column: 122,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                ],
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 268,
                                                                                                                                                                        column: 44,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 268,
                                                                                                                                                                        column: 123,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 268,
                                                                                                                                                                    column: 44,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 268,
                                                                                                                                                                    column: 123,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            order: '2'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                                            expression: {
                                                                                                                                                                type: 'CallExpression',
                                                                                                                                                                callee: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'TaskInfoRow',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 269,
                                                                                                                                                                            column: 44,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 269,
                                                                                                                                                                            column: 55,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                arguments: [
                                                                                                                                                                    {
                                                                                                                                                                        type: 'Literal',
                                                                                                                                                                        value: 'Created by'
                                                                                                                                                                    },
                                                                                                                                                                    {
                                                                                                                                                                        type: 'MemberExpression',
                                                                                                                                                                        computed: false,
                                                                                                                                                                        object: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'creator',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 269,
                                                                                                                                                                                    column: 70,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 269,
                                                                                                                                                                                    column: 77,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        property: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'name',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 269,
                                                                                                                                                                                    column: 78,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 269,
                                                                                                                                                                                    column: 82,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 269,
                                                                                                                                                                                column: 70,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 269,
                                                                                                                                                                                column: 82,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    {
                                                                                                                                                                        type: 'MemberExpression',
                                                                                                                                                                        computed: false,
                                                                                                                                                                        object: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'creator',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 269,
                                                                                                                                                                                    column: 84,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 269,
                                                                                                                                                                                    column: 91,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        property: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'paneConfig',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 269,
                                                                                                                                                                                    column: 92,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 269,
                                                                                                                                                                                    column: 102,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 269,
                                                                                                                                                                                column: 84,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 269,
                                                                                                                                                                                column: 102,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                ],
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 269,
                                                                                                                                                                        column: 44,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 269,
                                                                                                                                                                        column: 103,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 269,
                                                                                                                                                                    column: 44,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 269,
                                                                                                                                                                    column: 103,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            order: '3'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                                            expression: {
                                                                                                                                                                type: 'CallExpression',
                                                                                                                                                                callee: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'TaskInfoRow',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 270,
                                                                                                                                                                            column: 44,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 270,
                                                                                                                                                                            column: 55,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                arguments: [
                                                                                                                                                                    {
                                                                                                                                                                        type: 'Literal',
                                                                                                                                                                        value: 'Updated'
                                                                                                                                                                    },
                                                                                                                                                                    {
                                                                                                                                                                        type: 'CallExpression',
                                                                                                                                                                        callee: {
                                                                                                                                                                            type: 'MemberExpression',
                                                                                                                                                                            computed: false,
                                                                                                                                                                            object: {
                                                                                                                                                                                type: 'CallExpression',
                                                                                                                                                                                callee: {
                                                                                                                                                                                    type: 'MemberExpression',
                                                                                                                                                                                    computed: false,
                                                                                                                                                                                    object: {
                                                                                                                                                                                        type: 'MemberExpression',
                                                                                                                                                                                        computed: false,
                                                                                                                                                                                        object: {
                                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                                            name: 'task',
                                                                                                                                                                                            loc: {
                                                                                                                                                                                                start: {
                                                                                                                                                                                                    line: 270,
                                                                                                                                                                                                    column: 67,
                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                                },
                                                                                                                                                                                                end: {
                                                                                                                                                                                                    line: 270,
                                                                                                                                                                                                    column: 71,
                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                                }
                                                                                                                                                                                            }
                                                                                                                                                                                        },
                                                                                                                                                                                        property: {
                                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                                            name: 'Updated',
                                                                                                                                                                                            loc: {
                                                                                                                                                                                                start: {
                                                                                                                                                                                                    line: 270,
                                                                                                                                                                                                    column: 72,
                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                                },
                                                                                                                                                                                                end: {
                                                                                                                                                                                                    line: 270,
                                                                                                                                                                                                    column: 79,
                                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                                }
                                                                                                                                                                                            }
                                                                                                                                                                                        },
                                                                                                                                                                                        loc: {
                                                                                                                                                                                            start: {
                                                                                                                                                                                                line: 270,
                                                                                                                                                                                                column: 67,
                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                            },
                                                                                                                                                                                            end: {
                                                                                                                                                                                                line: 270,
                                                                                                                                                                                                column: 79,
                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                            }
                                                                                                                                                                                        }
                                                                                                                                                                                    },
                                                                                                                                                                                    property: {
                                                                                                                                                                                        type: 'Identifier',
                                                                                                                                                                                        name: 'toDate',
                                                                                                                                                                                        loc: {
                                                                                                                                                                                            start: {
                                                                                                                                                                                                line: 270,
                                                                                                                                                                                                column: 80,
                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                            },
                                                                                                                                                                                            end: {
                                                                                                                                                                                                line: 270,
                                                                                                                                                                                                column: 86,
                                                                                                                                                                                                fixed: true,
                                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                            }
                                                                                                                                                                                        }
                                                                                                                                                                                    },
                                                                                                                                                                                    loc: {
                                                                                                                                                                                        start: {
                                                                                                                                                                                            line: 270,
                                                                                                                                                                                            column: 67,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                        },
                                                                                                                                                                                        end: {
                                                                                                                                                                                            line: 270,
                                                                                                                                                                                            column: 86,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                        }
                                                                                                                                                                                    }
                                                                                                                                                                                },
                                                                                                                                                                                arguments: [],
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 270,
                                                                                                                                                                                        column: 67,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 270,
                                                                                                                                                                                        column: 88,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            property: {
                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                name: 'format',
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 270,
                                                                                                                                                                                        column: 89,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 270,
                                                                                                                                                                                        column: 95,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 270,
                                                                                                                                                                                    column: 67,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 270,
                                                                                                                                                                                    column: 95,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        arguments: [{
                                                                                                                                                                                type: 'Literal',
                                                                                                                                                                                value: '{MM}/{dd}/{yyyy} {time}'
                                                                                                                                                                            }],
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 270,
                                                                                                                                                                                column: 67,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 270,
                                                                                                                                                                                column: 122,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                ],
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 270,
                                                                                                                                                                        column: 44,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 270,
                                                                                                                                                                        column: 123,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 270,
                                                                                                                                                                    column: 44,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 270,
                                                                                                                                                                    column: 123,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            order: '4'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                                            expression: {
                                                                                                                                                                type: 'CallExpression',
                                                                                                                                                                callee: {
                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                    name: 'TaskInfoRow',
                                                                                                                                                                    loc: {
                                                                                                                                                                        start: {
                                                                                                                                                                            line: 271,
                                                                                                                                                                            column: 44,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        },
                                                                                                                                                                        end: {
                                                                                                                                                                            line: 271,
                                                                                                                                                                            column: 55,
                                                                                                                                                                            fixed: true,
                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                },
                                                                                                                                                                arguments: [
                                                                                                                                                                    {
                                                                                                                                                                        type: 'Literal',
                                                                                                                                                                        value: 'Updated by'
                                                                                                                                                                    },
                                                                                                                                                                    {
                                                                                                                                                                        type: 'MemberExpression',
                                                                                                                                                                        computed: false,
                                                                                                                                                                        object: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'updater',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 271,
                                                                                                                                                                                    column: 70,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 271,
                                                                                                                                                                                    column: 77,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        property: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'name',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 271,
                                                                                                                                                                                    column: 78,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 271,
                                                                                                                                                                                    column: 82,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 271,
                                                                                                                                                                                column: 70,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 271,
                                                                                                                                                                                column: 82,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    },
                                                                                                                                                                    {
                                                                                                                                                                        type: 'MemberExpression',
                                                                                                                                                                        computed: false,
                                                                                                                                                                        object: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'updater',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 271,
                                                                                                                                                                                    column: 84,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 271,
                                                                                                                                                                                    column: 91,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        property: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'paneConfig',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 271,
                                                                                                                                                                                    column: 92,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 271,
                                                                                                                                                                                    column: 102,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 271,
                                                                                                                                                                                column: 84,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 271,
                                                                                                                                                                                column: 102,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                ],
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 271,
                                                                                                                                                                        column: 44,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 271,
                                                                                                                                                                        column: 103,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 271,
                                                                                                                                                                    column: 44,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 271,
                                                                                                                                                                    column: 103,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            order: '5'
                                                                                                                                                        }
                                                                                                                                                    ]
                                                                                                                                                },
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 265,
                                                                                                                                                        column: 40,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 273,
                                                                                                                                                        column: 44,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                order: '2'
                                                                                                                                            }
                                                                                                                                        ]
                                                                                                                                    },
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 262,
                                                                                                                                            column: 36,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 273,
                                                                                                                                            column: 40,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    order: '2'
                                                                                                                                }
                                                                                                                            ]
                                                                                                                        },
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 257,
                                                                                                                                column: 32,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 273,
                                                                                                                                column: 36,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            }
                                                                                                                        },
                                                                                                                        order: '2'
                                                                                                                    },
                                                                                                                    {
                                                                                                                        type: 'ExpressionStatement',
                                                                                                                        expression: {
                                                                                                                            type: 'CallExpression',
                                                                                                                            callee: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'Div',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 273,
                                                                                                                                        column: 32,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 273,
                                                                                                                                        column: 35,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            arguments: [{
                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                    properties: [{
                                                                                                                                            type: 'Property',
                                                                                                                                            key: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'class',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 273,
                                                                                                                                                        column: 36,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 273,
                                                                                                                                                        column: 41,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            value: {
                                                                                                                                                type: 'Literal',
                                                                                                                                                value: 'fill'
                                                                                                                                            },
                                                                                                                                            kind: 'init',
                                                                                                                                            order: '0'
                                                                                                                                        }]
                                                                                                                                }],
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 273,
                                                                                                                                    column: 32,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 273,
                                                                                                                                    column: 49,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 273,
                                                                                                                                column: 32,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 273,
                                                                                                                                column: 49,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            }
                                                                                                                        },
                                                                                                                        order: '3'
                                                                                                                    },
                                                                                                                    {
                                                                                                                        type: 'ExpressionStatement',
                                                                                                                        expression: {
                                                                                                                            type: 'CallExpression',
                                                                                                                            callee: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'FormFooter',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 274,
                                                                                                                                        column: 32,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 274,
                                                                                                                                        column: 42,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            arguments: [],
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 274,
                                                                                                                                    column: 32,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 274,
                                                                                                                                    column: 44,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 274,
                                                                                                                                column: 32,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 274,
                                                                                                                                column: 44,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            }
                                                                                                                        },
                                                                                                                        order: '4'
                                                                                                                    }
                                                                                                                ]
                                                                                                            },
                                                                                                            order: '0'
                                                                                                        }],
                                                                                                    bound: false,
                                                                                                    name: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'content',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 241,
                                                                                                                column: 24,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 241,
                                                                                                                column: 31,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    scope: {
                                                                                                        type: 'Identifier',
                                                                                                        name: '_ps3'
                                                                                                    }
                                                                                                }, {
                                                                                                    this: this,
                                                                                                    _ps3: _ps3,
                                                                                                    config: config,
                                                                                                    ion: ion,
                                                                                                    glass: glass,
                                                                                                    _ref: _ref,
                                                                                                    _ref2: _ref2,
                                                                                                    _ref3: _ref3,
                                                                                                    viewpath: viewpath,
                                                                                                    _ref4: _ref4,
                                                                                                    _ref5: _ref5,
                                                                                                    _ref6: _ref6,
                                                                                                    style: style,
                                                                                                    Key: Key,
                                                                                                    Schema: Schema,
                                                                                                    CommentItem: CommentItem,
                                                                                                    Loader: Loader,
                                                                                                    DiscussionEditor: DiscussionEditor,
                                                                                                    User: User,
                                                                                                    Task: Task,
                                                                                                    Project: Project,
                                                                                                    Organization: Organization,
                                                                                                    Comment: Comment,
                                                                                                    TabContent: TabContent,
                                                                                                    Renamer: Renamer,
                                                                                                    Field: Field,
                                                                                                    GlassForm: GlassForm,
                                                                                                    lightGray: lightGray,
                                                                                                    _ref7: _ref7,
                                                                                                    _ref8: _ref8,
                                                                                                    apply: apply,
                                                                                                    TaskInfoRow: TaskInfoRow
                                                                                                }, _ps3);
                                                                                            });
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '2'
                                                                                }
                                                                            ]
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 238,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 275,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                            }
                                                                        },
                                                                        order: '1'
                                                                    },
                                                                    {
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'ObjectExpression',
                                                                            objectType: {
                                                                                type: 'ObjectExpression',
                                                                                properties: []
                                                                            },
                                                                            properties: [
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'name',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 276,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 276,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Literal',
                                                                                        value: 'discussion'
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'tab',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 277,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 277,
                                                                                                column: 27,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Function',
                                                                                        context: false,
                                                                                        value: function () {
                                                                                            return 'Discussion';
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '1'
                                                                                },
                                                                                {
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'content',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 278,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 278,
                                                                                                column: 31,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Function',
                                                                                        context: true,
                                                                                        value: function (_ps4) {
                                                                                            return ion.template(function () {
                                                                                                return ion.createRuntime({
                                                                                                    type: 'Template',
                                                                                                    id: null,
                                                                                                    body: [
                                                                                                        {
                                                                                                            type: 'VariableDeclaration',
                                                                                                            declarations: [{
                                                                                                                    type: 'VariableDeclarator',
                                                                                                                    id: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'commentsKey',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 279,
                                                                                                                                column: 32,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 279,
                                                                                                                                column: 43,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    init: {
                                                                                                                        type: 'NewExpression',
                                                                                                                        callee: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'Key',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 279,
                                                                                                                                    column: 50,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 279,
                                                                                                                                    column: 53,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        arguments: [
                                                                                                                            {
                                                                                                                                type: 'CallExpression',
                                                                                                                                callee: {
                                                                                                                                    type: 'MemberExpression',
                                                                                                                                    computed: false,
                                                                                                                                    object: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'task',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 279,
                                                                                                                                                column: 54,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 279,
                                                                                                                                                column: 58,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    property: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'getKey',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 279,
                                                                                                                                                column: 59,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 279,
                                                                                                                                                column: 65,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 279,
                                                                                                                                            column: 54,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 279,
                                                                                                                                            column: 65,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                arguments: [],
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 279,
                                                                                                                                        column: 54,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 279,
                                                                                                                                        column: 67,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'Comment',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 279,
                                                                                                                                        column: 69,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 279,
                                                                                                                                        column: 76,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            {
                                                                                                                                type: 'ObjectExpression',
                                                                                                                                properties: [
                                                                                                                                    {
                                                                                                                                        type: 'Property',
                                                                                                                                        key: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'sort',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 279,
                                                                                                                                                    column: 79,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 279,
                                                                                                                                                    column: 83,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        value: {
                                                                                                                                            type: 'ArrayExpression',
                                                                                                                                            elements: [{
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    properties: [{
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: 'created'
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: false
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '0'
                                                                                                                                                        }]
                                                                                                                                                }]
                                                                                                                                        },
                                                                                                                                        kind: 'init',
                                                                                                                                        order: '0'
                                                                                                                                    },
                                                                                                                                    {
                                                                                                                                        type: 'Property',
                                                                                                                                        key: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'watch',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 279,
                                                                                                                                                    column: 104,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 279,
                                                                                                                                                    column: 109,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        value: {
                                                                                                                                            type: 'Literal',
                                                                                                                                            value: true
                                                                                                                                        },
                                                                                                                                        kind: 'init',
                                                                                                                                        order: '1'
                                                                                                                                    }
                                                                                                                                ]
                                                                                                                            }
                                                                                                                        ],
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 279,
                                                                                                                                column: 46,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 279,
                                                                                                                                column: 116,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    }
                                                                                                                }],
                                                                                                            kind: 'let',
                                                                                                            order: '0'
                                                                                                        },
                                                                                                        {
                                                                                                            type: 'VariableDeclaration',
                                                                                                            declarations: [{
                                                                                                                    type: 'VariableDeclarator',
                                                                                                                    id: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'comments',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 282,
                                                                                                                                column: 32,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 282,
                                                                                                                                column: 40,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    init: {
                                                                                                                        type: 'MemberExpression',
                                                                                                                        computed: true,
                                                                                                                        object: {
                                                                                                                            type: 'MemberExpression',
                                                                                                                            computed: false,
                                                                                                                            object: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'model',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 282,
                                                                                                                                        column: 43,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 282,
                                                                                                                                        column: 48,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            property: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'server',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 282,
                                                                                                                                        column: 49,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 282,
                                                                                                                                        column: 55,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 282,
                                                                                                                                    column: 43,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 282,
                                                                                                                                    column: 55,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        property: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'commentsKey',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 282,
                                                                                                                                    column: 56,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 282,
                                                                                                                                    column: 67,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 282,
                                                                                                                                column: 43,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 282,
                                                                                                                                column: 68,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    }
                                                                                                                }],
                                                                                                            kind: 'let',
                                                                                                            order: '1'
                                                                                                        },
                                                                                                        {
                                                                                                            type: 'VariableDeclaration',
                                                                                                            declarations: [{
                                                                                                                    type: 'VariableDeclarator',
                                                                                                                    id: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'discussionTab',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 283,
                                                                                                                                column: 32,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 283,
                                                                                                                                column: 45,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    init: {
                                                                                                                        type: 'CallExpression',
                                                                                                                        callee: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'Section',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 283,
                                                                                                                                    column: 48,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 283,
                                                                                                                                    column: 55,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        arguments: [{
                                                                                                                                type: 'ObjectExpression',
                                                                                                                                properties: [{
                                                                                                                                        type: 'Property',
                                                                                                                                        key: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'class',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 283,
                                                                                                                                                    column: 56,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 283,
                                                                                                                                                    column: 61,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        value: {
                                                                                                                                            type: 'Literal',
                                                                                                                                            value: 'Discussion tab-content layout vertical fill content'
                                                                                                                                        },
                                                                                                                                        kind: 'init',
                                                                                                                                        order: '0'
                                                                                                                                    }]
                                                                                                                            }],
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 283,
                                                                                                                                column: 48,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 283,
                                                                                                                                column: 116,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    }
                                                                                                                }],
                                                                                                            kind: 'let',
                                                                                                            order: '2'
                                                                                                        },
                                                                                                        {
                                                                                                            type: 'VariableDeclaration',
                                                                                                            declarations: [{
                                                                                                                    type: 'VariableDeclarator',
                                                                                                                    id: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'discussionState',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 285,
                                                                                                                                column: 32,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 285,
                                                                                                                                column: 47,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    init: {
                                                                                                                        type: 'ObjectExpression',
                                                                                                                        properties: [{
                                                                                                                                type: 'Property',
                                                                                                                                key: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'clientHeight',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 285,
                                                                                                                                            column: 51,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 285,
                                                                                                                                            column: 63,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                value: {
                                                                                                                                    type: 'Literal',
                                                                                                                                    value: 0
                                                                                                                                },
                                                                                                                                kind: 'init',
                                                                                                                                order: '0'
                                                                                                                            }]
                                                                                                                    }
                                                                                                                }],
                                                                                                            kind: 'let',
                                                                                                            order: '3'
                                                                                                        },
                                                                                                        {
                                                                                                            type: 'ReturnStatement',
                                                                                                            argument: {
                                                                                                                type: 'ObjectExpression',
                                                                                                                objectType: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'discussionTab',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 286,
                                                                                                                            column: 35,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 286,
                                                                                                                            column: 48,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                properties: [{
                                                                                                                        type: 'IfStatement',
                                                                                                                        test: {
                                                                                                                            type: 'UnaryExpression',
                                                                                                                            operator: '?',
                                                                                                                            argument: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'comments',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 287,
                                                                                                                                        column: 35,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 287,
                                                                                                                                        column: 43,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        consequent: {
                                                                                                                            type: 'BlockStatement',
                                                                                                                            body: [
                                                                                                                                {
                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                    expression: {
                                                                                                                                        type: 'CallExpression',
                                                                                                                                        callee: {
                                                                                                                                            type: 'Function',
                                                                                                                                            context: true,
                                                                                                                                            value: function (_context7) {
                                                                                                                                                return function () {
                                                                                                                                                    var task = _context7.get('task');
                                                                                                                                                    ((task.subscribed = task.subscribed != null ? task.subscribed : {})[model.user.key] = (task.subscribed = task.subscribed != null ? task.subscribed : {})[model.user.key] != null ? (task.subscribed = task.subscribed != null ? task.subscribed : {})[model.user.key] : {}).readCommentId = task.idCountComment;
                                                                                                                                                };
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        arguments: [],
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 288,
                                                                                                                                                column: 36,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 292,
                                                                                                                                                column: 40,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 288,
                                                                                                                                            column: 36,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 292,
                                                                                                                                            column: 40,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    order: '0'
                                                                                                                                },
                                                                                                                                {
                                                                                                                                    type: 'IfStatement',
                                                                                                                                    test: {
                                                                                                                                        type: 'BinaryExpression',
                                                                                                                                        operator: '===',
                                                                                                                                        left: {
                                                                                                                                            type: 'MemberExpression',
                                                                                                                                            computed: false,
                                                                                                                                            object: {
                                                                                                                                                type: 'CallExpression',
                                                                                                                                                callee: {
                                                                                                                                                    type: 'MemberExpression',
                                                                                                                                                    computed: false,
                                                                                                                                                    object: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'Object',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 292,
                                                                                                                                                                column: 39,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 292,
                                                                                                                                                                column: 45,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    property: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'keys',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 292,
                                                                                                                                                                column: 46,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 292,
                                                                                                                                                                column: 50,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 292,
                                                                                                                                                            column: 39,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 292,
                                                                                                                                                            column: 50,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                arguments: [{
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'comments',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 292,
                                                                                                                                                                column: 51,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 292,
                                                                                                                                                                column: 59,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    }],
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 292,
                                                                                                                                                        column: 39,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 292,
                                                                                                                                                        column: 60,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            property: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'length',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 292,
                                                                                                                                                        column: 61,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 292,
                                                                                                                                                        column: 67,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 292,
                                                                                                                                                    column: 39,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 292,
                                                                                                                                                    column: 67,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        right: {
                                                                                                                                            type: 'Literal',
                                                                                                                                            value: 0
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    consequent: {
                                                                                                                                        type: 'BlockStatement',
                                                                                                                                        body: [{
                                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                                expression: {
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    objectType: {
                                                                                                                                                        type: 'CallExpression',
                                                                                                                                                        callee: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'Section',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 293,
                                                                                                                                                                    column: 40,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 293,
                                                                                                                                                                    column: 47,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        arguments: [{
                                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                                properties: [{
                                                                                                                                                                        type: 'Property',
                                                                                                                                                                        key: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'class',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 293,
                                                                                                                                                                                    column: 48,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 293,
                                                                                                                                                                                    column: 53,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        value: {
                                                                                                                                                                            type: 'Literal',
                                                                                                                                                                            value: 'flex layout center center-justified'
                                                                                                                                                                        },
                                                                                                                                                                        kind: 'init',
                                                                                                                                                                        order: '0'
                                                                                                                                                                    }]
                                                                                                                                                            }],
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 293,
                                                                                                                                                                column: 40,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 293,
                                                                                                                                                                column: 92,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    properties: [{
                                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                                            expression: {
                                                                                                                                                                type: 'Literal',
                                                                                                                                                                value: 'No discussion for this task. Start by commenting below.'
                                                                                                                                                            },
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 294,
                                                                                                                                                                    column: 44,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 294,
                                                                                                                                                                    column: 101,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            order: '0'
                                                                                                                                                        }]
                                                                                                                                                },
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 293,
                                                                                                                                                        column: 40,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 295,
                                                                                                                                                        column: 44,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                order: '0'
                                                                                                                                            }]
                                                                                                                                    },
                                                                                                                                    alternate: {
                                                                                                                                        type: 'BlockStatement',
                                                                                                                                        body: [
                                                                                                                                            {
                                                                                                                                                type: 'VariableDeclaration',
                                                                                                                                                declarations: [{
                                                                                                                                                        type: 'VariableDeclarator',
                                                                                                                                                        id: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'commentElement',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 296,
                                                                                                                                                                    column: 44,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 296,
                                                                                                                                                                    column: 58,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        init: {
                                                                                                                                                            type: 'CallExpression',
                                                                                                                                                            callee: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'Ul',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 296,
                                                                                                                                                                        column: 61,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 296,
                                                                                                                                                                        column: 63,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            arguments: [{
                                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                                    properties: [{
                                                                                                                                                                            type: 'Property',
                                                                                                                                                                            key: {
                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                name: 'class',
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 296,
                                                                                                                                                                                        column: 64,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 296,
                                                                                                                                                                                        column: 69,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            value: {
                                                                                                                                                                                type: 'Literal',
                                                                                                                                                                                value: 'comments layout vertical scroll flex'
                                                                                                                                                                            },
                                                                                                                                                                            kind: 'init',
                                                                                                                                                                            order: '0'
                                                                                                                                                                        }]
                                                                                                                                                                }],
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 296,
                                                                                                                                                                    column: 61,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 296,
                                                                                                                                                                    column: 109,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    }],
                                                                                                                                                kind: 'let',
                                                                                                                                                order: '0'
                                                                                                                                            },
                                                                                                                                            {
                                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                                expression: {
                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                    objectType: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'commentElement',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 297,
                                                                                                                                                                column: 40,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 297,
                                                                                                                                                                column: 54,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    properties: [
                                                                                                                                                        {
                                                                                                                                                            type: 'ForInStatement',
                                                                                                                                                            left: {
                                                                                                                                                                type: 'VariableDeclaration',
                                                                                                                                                                declarations: [
                                                                                                                                                                    {
                                                                                                                                                                        type: 'VariableDeclarator',
                                                                                                                                                                        id: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'key',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 298,
                                                                                                                                                                                    column: 48,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 298,
                                                                                                                                                                                    column: 51,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        init: null
                                                                                                                                                                    },
                                                                                                                                                                    {
                                                                                                                                                                        type: 'VariableDeclarator',
                                                                                                                                                                        id: {
                                                                                                                                                                            type: 'Identifier',
                                                                                                                                                                            name: 'comment',
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 298,
                                                                                                                                                                                    column: 53,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 298,
                                                                                                                                                                                    column: 60,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        init: null
                                                                                                                                                                    }
                                                                                                                                                                ],
                                                                                                                                                                kind: 'let'
                                                                                                                                                            },
                                                                                                                                                            right: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'comments',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 298,
                                                                                                                                                                        column: 64,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 298,
                                                                                                                                                                        column: 72,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            body: {
                                                                                                                                                                type: 'BlockStatement',
                                                                                                                                                                body: [{
                                                                                                                                                                        type: 'ExpressionStatement',
                                                                                                                                                                        expression: {
                                                                                                                                                                            type: 'CallExpression',
                                                                                                                                                                            callee: {
                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                name: 'CommentItem',
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 300,
                                                                                                                                                                                        column: 48,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 300,
                                                                                                                                                                                        column: 59,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            arguments: [{
                                                                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                                                                    properties: [
                                                                                                                                                                                        {
                                                                                                                                                                                            type: 'Property',
                                                                                                                                                                                            key: {
                                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                                name: 'item',
                                                                                                                                                                                                loc: {
                                                                                                                                                                                                    start: {
                                                                                                                                                                                                        line: 300,
                                                                                                                                                                                                        column: 60,
                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                                    },
                                                                                                                                                                                                    end: {
                                                                                                                                                                                                        line: 300,
                                                                                                                                                                                                        column: 64,
                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                                    }
                                                                                                                                                                                                }
                                                                                                                                                                                            },
                                                                                                                                                                                            value: {
                                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                                name: 'comment',
                                                                                                                                                                                                loc: {
                                                                                                                                                                                                    start: {
                                                                                                                                                                                                        line: 300,
                                                                                                                                                                                                        column: 65,
                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                                    },
                                                                                                                                                                                                    end: {
                                                                                                                                                                                                        line: 300,
                                                                                                                                                                                                        column: 72,
                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                                    }
                                                                                                                                                                                                }
                                                                                                                                                                                            },
                                                                                                                                                                                            kind: 'init',
                                                                                                                                                                                            order: '0'
                                                                                                                                                                                        },
                                                                                                                                                                                        {
                                                                                                                                                                                            type: 'Property',
                                                                                                                                                                                            key: {
                                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                                name: 'comments',
                                                                                                                                                                                                loc: {
                                                                                                                                                                                                    start: {
                                                                                                                                                                                                        line: 300,
                                                                                                                                                                                                        column: 73,
                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                                    },
                                                                                                                                                                                                    end: {
                                                                                                                                                                                                        line: 300,
                                                                                                                                                                                                        column: 81,
                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                                    }
                                                                                                                                                                                                }
                                                                                                                                                                                            },
                                                                                                                                                                                            value: {
                                                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                                                name: 'comments',
                                                                                                                                                                                                loc: {
                                                                                                                                                                                                    start: {
                                                                                                                                                                                                        line: 300,
                                                                                                                                                                                                        column: 73,
                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                                    },
                                                                                                                                                                                                    end: {
                                                                                                                                                                                                        line: 300,
                                                                                                                                                                                                        column: 81,
                                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                                    }
                                                                                                                                                                                                }
                                                                                                                                                                                            },
                                                                                                                                                                                            kind: 'init',
                                                                                                                                                                                            order: '1'
                                                                                                                                                                                        }
                                                                                                                                                                                    ]
                                                                                                                                                                                }],
                                                                                                                                                                            loc: {
                                                                                                                                                                                start: {
                                                                                                                                                                                    line: 300,
                                                                                                                                                                                    column: 48,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                },
                                                                                                                                                                                end: {
                                                                                                                                                                                    line: 300,
                                                                                                                                                                                    column: 82,
                                                                                                                                                                                    fixed: true,
                                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        loc: {
                                                                                                                                                                            start: {
                                                                                                                                                                                line: 300,
                                                                                                                                                                                column: 48,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            },
                                                                                                                                                                            end: {
                                                                                                                                                                                line: 300,
                                                                                                                                                                                column: 82,
                                                                                                                                                                                fixed: true,
                                                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        order: '0'
                                                                                                                                                                    }]
                                                                                                                                                            },
                                                                                                                                                            remove: null,
                                                                                                                                                            order: '0'
                                                                                                                                                        },
                                                                                                                                                        {
                                                                                                                                                            type: 'Property',
                                                                                                                                                            key: {
                                                                                                                                                                type: 'Identifier',
                                                                                                                                                                name: 'classList',
                                                                                                                                                                loc: {
                                                                                                                                                                    start: {
                                                                                                                                                                        line: 301,
                                                                                                                                                                        column: 44,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    },
                                                                                                                                                                    end: {
                                                                                                                                                                        line: 301,
                                                                                                                                                                        column: 53,
                                                                                                                                                                        fixed: true,
                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                    }
                                                                                                                                                                }
                                                                                                                                                            },
                                                                                                                                                            value: {
                                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                                properties: [{
                                                                                                                                                                        type: 'IfStatement',
                                                                                                                                                                        test: {
                                                                                                                                                                            type: 'BinaryExpression',
                                                                                                                                                                            operator: '>',
                                                                                                                                                                            left: {
                                                                                                                                                                                type: 'MemberExpression',
                                                                                                                                                                                computed: false,
                                                                                                                                                                                object: {
                                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                                    name: 'commentElement',
                                                                                                                                                                                    loc: {
                                                                                                                                                                                        start: {
                                                                                                                                                                                            line: 302,
                                                                                                                                                                                            column: 51,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                        },
                                                                                                                                                                                        end: {
                                                                                                                                                                                            line: 302,
                                                                                                                                                                                            column: 65,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                        }
                                                                                                                                                                                    }
                                                                                                                                                                                },
                                                                                                                                                                                property: {
                                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                                    name: 'clientHeight',
                                                                                                                                                                                    loc: {
                                                                                                                                                                                        start: {
                                                                                                                                                                                            line: 302,
                                                                                                                                                                                            column: 66,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                        },
                                                                                                                                                                                        end: {
                                                                                                                                                                                            line: 302,
                                                                                                                                                                                            column: 78,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                        }
                                                                                                                                                                                    }
                                                                                                                                                                                },
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 302,
                                                                                                                                                                                        column: 51,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 302,
                                                                                                                                                                                        column: 78,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            },
                                                                                                                                                                            right: {
                                                                                                                                                                                type: 'MemberExpression',
                                                                                                                                                                                computed: false,
                                                                                                                                                                                object: {
                                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                                    name: 'commentElement',
                                                                                                                                                                                    loc: {
                                                                                                                                                                                        start: {
                                                                                                                                                                                            line: 302,
                                                                                                                                                                                            column: 81,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                        },
                                                                                                                                                                                        end: {
                                                                                                                                                                                            line: 302,
                                                                                                                                                                                            column: 95,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                        }
                                                                                                                                                                                    }
                                                                                                                                                                                },
                                                                                                                                                                                property: {
                                                                                                                                                                                    type: 'Identifier',
                                                                                                                                                                                    name: 'scrollHeight',
                                                                                                                                                                                    loc: {
                                                                                                                                                                                        start: {
                                                                                                                                                                                            line: 302,
                                                                                                                                                                                            column: 96,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                        },
                                                                                                                                                                                        end: {
                                                                                                                                                                                            line: 302,
                                                                                                                                                                                            column: 108,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                        }
                                                                                                                                                                                    }
                                                                                                                                                                                },
                                                                                                                                                                                loc: {
                                                                                                                                                                                    start: {
                                                                                                                                                                                        line: 302,
                                                                                                                                                                                        column: 81,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                    },
                                                                                                                                                                                    end: {
                                                                                                                                                                                        line: 302,
                                                                                                                                                                                        column: 108,
                                                                                                                                                                                        fixed: true,
                                                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                    }
                                                                                                                                                                                }
                                                                                                                                                                            }
                                                                                                                                                                        },
                                                                                                                                                                        consequent: {
                                                                                                                                                                            type: 'BlockStatement',
                                                                                                                                                                            body: [{
                                                                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                                                                    expression: {
                                                                                                                                                                                        type: 'Literal',
                                                                                                                                                                                        value: 'reverse'
                                                                                                                                                                                    },
                                                                                                                                                                                    loc: {
                                                                                                                                                                                        start: {
                                                                                                                                                                                            line: 303,
                                                                                                                                                                                            column: 52,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                        },
                                                                                                                                                                                        end: {
                                                                                                                                                                                            line: 303,
                                                                                                                                                                                            column: 61,
                                                                                                                                                                                            fixed: true,
                                                                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                                        }
                                                                                                                                                                                    },
                                                                                                                                                                                    order: '0'
                                                                                                                                                                                }]
                                                                                                                                                                        },
                                                                                                                                                                        alternate: null,
                                                                                                                                                                        order: '0'
                                                                                                                                                                    }]
                                                                                                                                                            },
                                                                                                                                                            kind: 'init',
                                                                                                                                                            order: '1'
                                                                                                                                                        }
                                                                                                                                                    ]
                                                                                                                                                },
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 297,
                                                                                                                                                        column: 40,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 305,
                                                                                                                                                        column: 44,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                order: '1'
                                                                                                                                            }
                                                                                                                                        ]
                                                                                                                                    },
                                                                                                                                    order: '1'
                                                                                                                                },
                                                                                                                                {
                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                    expression: {
                                                                                                                                        type: 'CallExpression',
                                                                                                                                        callee: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'DiscussionEditor',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 305,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 305,
                                                                                                                                                    column: 52,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        arguments: [{
                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                properties: [
                                                                                                                                                    {
                                                                                                                                                        type: 'Property',
                                                                                                                                                        key: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'comments',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 305,
                                                                                                                                                                    column: 53,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 305,
                                                                                                                                                                    column: 61,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        value: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'comments',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 305,
                                                                                                                                                                    column: 62,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 305,
                                                                                                                                                                    column: 70,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        kind: 'init',
                                                                                                                                                        order: '0'
                                                                                                                                                    },
                                                                                                                                                    {
                                                                                                                                                        type: 'Property',
                                                                                                                                                        key: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'task',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 305,
                                                                                                                                                                    column: 72,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 305,
                                                                                                                                                                    column: 76,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        value: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'task',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 305,
                                                                                                                                                                    column: 77,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 305,
                                                                                                                                                                    column: 81,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        kind: 'init',
                                                                                                                                                        order: '1'
                                                                                                                                                    }
                                                                                                                                                ]
                                                                                                                                            }],
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 305,
                                                                                                                                                column: 36,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 305,
                                                                                                                                                column: 82,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 305,
                                                                                                                                            column: 36,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 305,
                                                                                                                                            column: 82,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    order: '2'
                                                                                                                                }
                                                                                                                            ]
                                                                                                                        },
                                                                                                                        alternate: {
                                                                                                                            type: 'BlockStatement',
                                                                                                                            body: [{
                                                                                                                                    type: 'ExpressionStatement',
                                                                                                                                    expression: {
                                                                                                                                        type: 'CallExpression',
                                                                                                                                        callee: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'Loader',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 308,
                                                                                                                                                    column: 36,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 308,
                                                                                                                                                    column: 42,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        arguments: [],
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 308,
                                                                                                                                                column: 36,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 308,
                                                                                                                                                column: 44,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 308,
                                                                                                                                            column: 36,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 308,
                                                                                                                                            column: 44,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    order: '0'
                                                                                                                                }]
                                                                                                                        },
                                                                                                                        order: '0'
                                                                                                                    }]
                                                                                                            },
                                                                                                            order: '4'
                                                                                                        }
                                                                                                    ],
                                                                                                    bound: false,
                                                                                                    name: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'content',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 278,
                                                                                                                column: 24,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 278,
                                                                                                                column: 31,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    scope: {
                                                                                                        type: 'Identifier',
                                                                                                        name: '_ps4'
                                                                                                    }
                                                                                                }, {
                                                                                                    this: this,
                                                                                                    _ps4: _ps4,
                                                                                                    config: config,
                                                                                                    ion: ion,
                                                                                                    glass: glass,
                                                                                                    _ref: _ref,
                                                                                                    _ref2: _ref2,
                                                                                                    _ref3: _ref3,
                                                                                                    viewpath: viewpath,
                                                                                                    _ref4: _ref4,
                                                                                                    _ref5: _ref5,
                                                                                                    _ref6: _ref6,
                                                                                                    style: style,
                                                                                                    Key: Key,
                                                                                                    Schema: Schema,
                                                                                                    CommentItem: CommentItem,
                                                                                                    Loader: Loader,
                                                                                                    DiscussionEditor: DiscussionEditor,
                                                                                                    User: User,
                                                                                                    Task: Task,
                                                                                                    Project: Project,
                                                                                                    Organization: Organization,
                                                                                                    Comment: Comment,
                                                                                                    TabContent: TabContent,
                                                                                                    Renamer: Renamer,
                                                                                                    Field: Field,
                                                                                                    GlassForm: GlassForm,
                                                                                                    lightGray: lightGray,
                                                                                                    _ref7: _ref7,
                                                                                                    _ref8: _ref8,
                                                                                                    apply: apply,
                                                                                                    TaskInfoRow: TaskInfoRow
                                                                                                }, _ps4);
                                                                                            });
                                                                                        }
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '2'
                                                                                }
                                                                            ]
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 275,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 309,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/TaskPane.ion'
                                                                            }
                                                                        },
                                                                        order: '2'
                                                                    }
                                                                ]
                                                            },
                                                            kind: 'init',
                                                            order: '1'
                                                        }
                                                    ]
                                                }],
                                            loc: {
                                                start: {
                                                    line: 168,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                },
                                                end: {
                                                    line: 309,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 168,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/TaskPane.ion'
                                            },
                                            end: {
                                                line: 309,
                                                column: 16,
                                                fixed: true,
                                                source: 'viewpath/html/panes/TaskPane.ion'
                                            }
                                        },
                                        order: ':'
                                    }
                                ]
                            },
                            alternate: {
                                type: 'BlockStatement',
                                body: [
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'noPaneBar',
                                            loc: {
                                                start: {
                                                    line: 310,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                },
                                                end: {
                                                    line: 310,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: true
                                        },
                                        kind: 'init',
                                        order: '0'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'name',
                                            loc: {
                                                start: {
                                                    line: 311,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                },
                                                end: {
                                                    line: 311,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'ArrayExpression',
                                            elements: [
                                                {
                                                    type: 'Literal',
                                                    value: 'Task'
                                                },
                                                {
                                                    type: 'Literal',
                                                    value: '...'
                                                }
                                            ]
                                        },
                                        kind: 'init',
                                        order: '1'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'Identifier',
                                                name: 'Loader',
                                                loc: {
                                                    start: {
                                                        line: 312,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                    },
                                                    end: {
                                                        line: 312,
                                                        column: 18,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/TaskPane.ion'
                                                    }
                                                }
                                            },
                                            arguments: [],
                                            loc: {
                                                start: {
                                                    line: 312,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                },
                                                end: {
                                                    line: 312,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/TaskPane.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 312,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/TaskPane.ion'
                                            },
                                            end: {
                                                line: 312,
                                                column: 20,
                                                fixed: true,
                                                source: 'viewpath/html/panes/TaskPane.ion'
                                            }
                                        },
                                        order: '2'
                                    }
                                ]
                            },
                            order: '1'
                        }
                    ]
                },
                order: '7'
            }
        ],
        bound: false
    }, {
        this: this,
        ion: ion,
        config: config,
        glass: glass,
        _ref: _ref,
        _ref2: _ref2,
        _ref3: _ref3,
        viewpath: viewpath,
        _ref4: _ref4,
        _ref5: _ref5,
        _ref6: _ref6,
        style: style,
        Key: Key,
        Schema: Schema,
        CommentItem: CommentItem,
        Loader: Loader,
        DiscussionEditor: DiscussionEditor,
        User: User,
        Task: Task,
        Project: Project,
        Organization: Organization,
        Comment: Comment,
        TabContent: TabContent,
        Renamer: Renamer,
        Field: Field,
        GlassForm: GlassForm,
        lightGray: lightGray,
        _ref7: _ref7,
        _ref8: _ref8,
        apply: apply,
        TaskInfoRow: TaskInfoRow
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/panes/TaskPane',_viewpath_html_panes_TaskPane_);
    else
      _viewpath_html_panes_TaskPane_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_panes_TaskPane_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_panes_TasksPane_ = function(module,exports,require){'use strict';
var ion = require('ion');
var glass = require('glass'), viewpath = require('../..'), _ref, _ref2;
_ref = viewpath.model;
var User = _ref.User;
var Task = _ref.Task;
_ref2 = require('./');
var GenericTypePane = _ref2.GenericTypePane;
module.exports = exports = ion.template(function (urlConfig, config) {
    return ion.createRuntime({
        type: 'Template',
        id: null,
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'userKey',
                            loc: {
                                start: {
                                    line: 9,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/panes/TasksPane.ion'
                                },
                                end: {
                                    line: 9,
                                    column: 15,
                                    fixed: true,
                                    source: 'viewpath/html/panes/TasksPane.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ConditionalExpression',
                            test: {
                                type: 'BinaryExpression',
                                operator: '!=',
                                left: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'urlConfig',
                                        loc: {
                                            start: {
                                                line: 9,
                                                column: 18,
                                                fixed: true,
                                                source: 'viewpath/html/panes/TasksPane.ion'
                                            },
                                            end: {
                                                line: 9,
                                                column: 27,
                                                fixed: true,
                                                source: 'viewpath/html/panes/TasksPane.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'key',
                                        loc: {
                                            start: {
                                                line: 9,
                                                column: 28,
                                                fixed: true,
                                                source: 'viewpath/html/panes/TasksPane.ion'
                                            },
                                            end: {
                                                line: 9,
                                                column: 31,
                                                fixed: true,
                                                source: 'viewpath/html/panes/TasksPane.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 9,
                                            column: 18,
                                            fixed: true,
                                            source: 'viewpath/html/panes/TasksPane.ion'
                                        },
                                        end: {
                                            line: 9,
                                            column: 31,
                                            fixed: true,
                                            source: 'viewpath/html/panes/TasksPane.ion'
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: null
                                }
                            },
                            consequent: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'urlConfig',
                                    loc: {
                                        start: {
                                            line: 9,
                                            column: 18,
                                            fixed: true,
                                            source: 'viewpath/html/panes/TasksPane.ion'
                                        },
                                        end: {
                                            line: 9,
                                            column: 27,
                                            fixed: true,
                                            source: 'viewpath/html/panes/TasksPane.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'key',
                                    loc: {
                                        start: {
                                            line: 9,
                                            column: 28,
                                            fixed: true,
                                            source: 'viewpath/html/panes/TasksPane.ion'
                                        },
                                        end: {
                                            line: 9,
                                            column: 31,
                                            fixed: true,
                                            source: 'viewpath/html/panes/TasksPane.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 9,
                                        column: 18,
                                        fixed: true,
                                        source: 'viewpath/html/panes/TasksPane.ion'
                                    },
                                    end: {
                                        line: 9,
                                        column: 31,
                                        fixed: true,
                                        source: 'viewpath/html/panes/TasksPane.ion'
                                    }
                                }
                            },
                            alternate: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'model',
                                        loc: {
                                            start: {
                                                line: 9,
                                                column: 34,
                                                fixed: true,
                                                source: 'viewpath/html/panes/TasksPane.ion'
                                            },
                                            end: {
                                                line: 9,
                                                column: 39,
                                                fixed: true,
                                                source: 'viewpath/html/panes/TasksPane.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'user',
                                        loc: {
                                            start: {
                                                line: 9,
                                                column: 40,
                                                fixed: true,
                                                source: 'viewpath/html/panes/TasksPane.ion'
                                            },
                                            end: {
                                                line: 9,
                                                column: 44,
                                                fixed: true,
                                                source: 'viewpath/html/panes/TasksPane.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 9,
                                            column: 34,
                                            fixed: true,
                                            source: 'viewpath/html/panes/TasksPane.ion'
                                        },
                                        end: {
                                            line: 9,
                                            column: 44,
                                            fixed: true,
                                            source: 'viewpath/html/panes/TasksPane.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'key',
                                    loc: {
                                        start: {
                                            line: 9,
                                            column: 45,
                                            fixed: true,
                                            source: 'viewpath/html/panes/TasksPane.ion'
                                        },
                                        end: {
                                            line: 9,
                                            column: 48,
                                            fixed: true,
                                            source: 'viewpath/html/panes/TasksPane.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 9,
                                        column: 34,
                                        fixed: true,
                                        source: 'viewpath/html/panes/TasksPane.ion'
                                    },
                                    end: {
                                        line: 9,
                                        column: 48,
                                        fixed: true,
                                        source: 'viewpath/html/panes/TasksPane.ion'
                                    }
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'user',
                            loc: {
                                start: {
                                    line: 10,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/panes/TasksPane.ion'
                                },
                                end: {
                                    line: 10,
                                    column: 12,
                                    fixed: true,
                                    source: 'viewpath/html/panes/TasksPane.ion'
                                }
                            }
                        },
                        init: {
                            type: 'MemberExpression',
                            computed: true,
                            object: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'model',
                                    loc: {
                                        start: {
                                            line: 10,
                                            column: 15,
                                            fixed: true,
                                            source: 'viewpath/html/panes/TasksPane.ion'
                                        },
                                        end: {
                                            line: 10,
                                            column: 20,
                                            fixed: true,
                                            source: 'viewpath/html/panes/TasksPane.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'server',
                                    loc: {
                                        start: {
                                            line: 10,
                                            column: 21,
                                            fixed: true,
                                            source: 'viewpath/html/panes/TasksPane.ion'
                                        },
                                        end: {
                                            line: 10,
                                            column: 27,
                                            fixed: true,
                                            source: 'viewpath/html/panes/TasksPane.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 10,
                                        column: 15,
                                        fixed: true,
                                        source: 'viewpath/html/panes/TasksPane.ion'
                                    },
                                    end: {
                                        line: 10,
                                        column: 27,
                                        fixed: true,
                                        source: 'viewpath/html/panes/TasksPane.ion'
                                    }
                                }
                            },
                            property: {
                                type: 'Identifier',
                                name: 'userKey',
                                loc: {
                                    start: {
                                        line: 10,
                                        column: 28,
                                        fixed: true,
                                        source: 'viewpath/html/panes/TasksPane.ion'
                                    },
                                    end: {
                                        line: 10,
                                        column: 35,
                                        fixed: true,
                                        source: 'viewpath/html/panes/TasksPane.ion'
                                    }
                                }
                            },
                            loc: {
                                start: {
                                    line: 10,
                                    column: 15,
                                    fixed: true,
                                    source: 'viewpath/html/panes/TasksPane.ion'
                                },
                                end: {
                                    line: 10,
                                    column: 36,
                                    fixed: true,
                                    source: 'viewpath/html/panes/TasksPane.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'CallExpression',
                    callee: {
                        type: 'Identifier',
                        name: 'GenericTypePane',
                        loc: {
                            start: {
                                line: 11,
                                column: 11,
                                fixed: true,
                                source: 'viewpath/html/panes/TasksPane.ion'
                            },
                            end: {
                                line: 11,
                                column: 26,
                                fixed: true,
                                source: 'viewpath/html/panes/TasksPane.ion'
                            }
                        }
                    },
                    arguments: [{
                            type: 'ObjectExpression',
                            objectType: {
                                type: 'Identifier',
                                name: 'config',
                                loc: {
                                    start: {
                                        line: 12,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/html/panes/TasksPane.ion'
                                    },
                                    end: {
                                        line: 12,
                                        column: 14,
                                        fixed: true,
                                        source: 'viewpath/html/panes/TasksPane.ion'
                                    }
                                }
                            },
                            properties: [
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'id',
                                        loc: {
                                            start: {
                                                line: 13,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/TasksPane.ion'
                                            },
                                            end: {
                                                line: 13,
                                                column: 14,
                                                fixed: true,
                                                source: 'viewpath/html/panes/TasksPane.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: 'tasks'
                                    },
                                    kind: 'init',
                                    order: '0'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'name',
                                        loc: {
                                            start: {
                                                line: 14,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/TasksPane.ion'
                                            },
                                            end: {
                                                line: 14,
                                                column: 16,
                                                fixed: true,
                                                source: 'viewpath/html/panes/TasksPane.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Literal',
                                        value: 'My Tasks'
                                    },
                                    kind: 'init',
                                    order: '1'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'type',
                                        loc: {
                                            start: {
                                                line: 15,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/TasksPane.ion'
                                            },
                                            end: {
                                                line: 15,
                                                column: 16,
                                                fixed: true,
                                                source: 'viewpath/html/panes/TasksPane.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Identifier',
                                        name: 'Task',
                                        loc: {
                                            start: {
                                                line: 15,
                                                column: 18,
                                                fixed: true,
                                                source: 'viewpath/html/panes/TasksPane.ion'
                                            },
                                            end: {
                                                line: 15,
                                                column: 22,
                                                fixed: true,
                                                source: 'viewpath/html/panes/TasksPane.ion'
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '2'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'state',
                                        loc: {
                                            start: {
                                                line: 16,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/TasksPane.ion'
                                            },
                                            end: {
                                                line: 16,
                                                column: 17,
                                                fixed: true,
                                                source: 'viewpath/html/panes/TasksPane.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'Identifier',
                                        name: 'urlConfig',
                                        loc: {
                                            start: {
                                                line: 16,
                                                column: 19,
                                                fixed: true,
                                                source: 'viewpath/html/panes/TasksPane.ion'
                                            },
                                            end: {
                                                line: 16,
                                                column: 28,
                                                fixed: true,
                                                source: 'viewpath/html/panes/TasksPane.ion'
                                            }
                                        }
                                    },
                                    kind: 'init',
                                    order: '3'
                                },
                                {
                                    type: 'Property',
                                    key: {
                                        type: 'Identifier',
                                        name: 'tabs',
                                        loc: {
                                            start: {
                                                line: 17,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/TasksPane.ion'
                                            },
                                            end: {
                                                line: 17,
                                                column: 16,
                                                fixed: true,
                                                source: 'viewpath/html/panes/TasksPane.ion'
                                            }
                                        }
                                    },
                                    value: {
                                        type: 'ObjectExpression',
                                        objectType: {
                                            type: 'ArrayExpression',
                                            elements: []
                                        },
                                        properties: [
                                            {
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'ObjectExpression',
                                                    objectType: {
                                                        type: 'ObjectExpression',
                                                        properties: [
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'id',
                                                                    loc: {
                                                                        start: {
                                                                            line: 18,
                                                                            column: 17,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/TasksPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 18,
                                                                            column: 19,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/TasksPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: 'scheduled'
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'name',
                                                                    loc: {
                                                                        start: {
                                                                            line: 18,
                                                                            column: 33,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/TasksPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 18,
                                                                            column: 37,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/TasksPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: 'Scheduled'
                                                                },
                                                                kind: 'init',
                                                                order: '1'
                                                            }
                                                        ]
                                                    },
                                                    properties: [
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'columns',
                                                                loc: {
                                                                    start: {
                                                                        line: 19,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/TasksPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 19,
                                                                        column: 27,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/TasksPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'ArrayExpression',
                                                                elements: [
                                                                    {
                                                                        type: 'Literal',
                                                                        value: 'name'
                                                                    },
                                                                    {
                                                                        type: 'Literal',
                                                                        value: 'priority'
                                                                    },
                                                                    {
                                                                        type: 'Literal',
                                                                        value: 'complete'
                                                                    },
                                                                    {
                                                                        type: 'Literal',
                                                                        value: 'assigned'
                                                                    },
                                                                    {
                                                                        type: 'Literal',
                                                                        value: 'start'
                                                                    },
                                                                    {
                                                                        type: 'Literal',
                                                                        value: 'finish'
                                                                    }
                                                                ]
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        },
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'where',
                                                                loc: {
                                                                    start: {
                                                                        line: 20,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/TasksPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 20,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/TasksPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'ObjectExpression',
                                                                properties: [
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'assignedKeys',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 21,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/TasksPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 21,
                                                                                    column: 36,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/TasksPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Identifier',
                                                                            name: 'userKey',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 21,
                                                                                    column: 38,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/TasksPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 21,
                                                                                    column: 45,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/TasksPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    },
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'complete',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 22,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/TasksPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 22,
                                                                                    column: 32,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/TasksPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Literal',
                                                                            value: false
                                                                        },
                                                                        kind: 'init',
                                                                        order: '1'
                                                                    },
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'start',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 23,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/TasksPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 23,
                                                                                    column: 29,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/TasksPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'ObjectExpression',
                                                                            properties: [{
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Literal',
                                                                                        value: '!='
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Literal',
                                                                                        value: null
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                }]
                                                                        },
                                                                        kind: 'init',
                                                                        order: '2'
                                                                    }
                                                                ]
                                                            },
                                                            kind: 'init',
                                                            order: '1'
                                                        },
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'sorts',
                                                                loc: {
                                                                    start: {
                                                                        line: 24,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/TasksPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 24,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/TasksPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'ObjectExpression',
                                                                objectType: {
                                                                    type: 'ArrayExpression',
                                                                    elements: []
                                                                },
                                                                properties: [{
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'ArrayExpression',
                                                                            elements: [{
                                                                                    type: 'ObjectExpression',
                                                                                    properties: [{
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'start',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 25,
                                                                                                        column: 26,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/TasksPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 25,
                                                                                                        column: 31,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/TasksPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'Literal',
                                                                                                value: true
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '0'
                                                                                        }]
                                                                                }]
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 25,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/TasksPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 25,
                                                                                column: 38,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/TasksPane.ion'
                                                                            }
                                                                        },
                                                                        order: '0'
                                                                    }]
                                                            },
                                                            kind: 'init',
                                                            order: '2'
                                                        }
                                                    ]
                                                },
                                                loc: {
                                                    start: {
                                                        line: 18,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/TasksPane.ion'
                                                    },
                                                    end: {
                                                        line: 26,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/TasksPane.ion'
                                                    }
                                                },
                                                order: '0'
                                            },
                                            {
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'ObjectExpression',
                                                    objectType: {
                                                        type: 'ObjectExpression',
                                                        properties: [
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'id',
                                                                    loc: {
                                                                        start: {
                                                                            line: 26,
                                                                            column: 17,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/TasksPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 26,
                                                                            column: 19,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/TasksPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: 'unscheduled'
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'name',
                                                                    loc: {
                                                                        start: {
                                                                            line: 26,
                                                                            column: 35,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/TasksPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 26,
                                                                            column: 39,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/TasksPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: 'Unscheduled'
                                                                },
                                                                kind: 'init',
                                                                order: '1'
                                                            }
                                                        ]
                                                    },
                                                    properties: [
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'columns',
                                                                loc: {
                                                                    start: {
                                                                        line: 27,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/TasksPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 27,
                                                                        column: 27,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/TasksPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'ArrayExpression',
                                                                elements: [
                                                                    {
                                                                        type: 'Literal',
                                                                        value: 'name'
                                                                    },
                                                                    {
                                                                        type: 'Literal',
                                                                        value: 'priority'
                                                                    },
                                                                    {
                                                                        type: 'Literal',
                                                                        value: 'complete'
                                                                    },
                                                                    {
                                                                        type: 'Literal',
                                                                        value: 'assigned'
                                                                    },
                                                                    {
                                                                        type: 'Literal',
                                                                        value: 'duration'
                                                                    },
                                                                    {
                                                                        type: 'Literal',
                                                                        value: 'start'
                                                                    },
                                                                    {
                                                                        type: 'Literal',
                                                                        value: 'finish'
                                                                    }
                                                                ]
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        },
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'where',
                                                                loc: {
                                                                    start: {
                                                                        line: 28,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/TasksPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 28,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/TasksPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'ObjectExpression',
                                                                properties: [
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'assignedKeys',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 29,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/TasksPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 29,
                                                                                    column: 36,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/TasksPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Identifier',
                                                                            name: 'userKey',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 29,
                                                                                    column: 38,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/TasksPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 29,
                                                                                    column: 45,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/TasksPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    },
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'start',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 30,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/TasksPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 30,
                                                                                    column: 29,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/TasksPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Literal',
                                                                            value: null
                                                                        },
                                                                        kind: 'init',
                                                                        order: '1'
                                                                    },
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'percent',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 31,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/TasksPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 31,
                                                                                    column: 31,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/TasksPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'ObjectExpression',
                                                                            properties: [{
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Literal',
                                                                                        value: '<'
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Literal',
                                                                                        value: 100
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                }]
                                                                        },
                                                                        kind: 'init',
                                                                        order: '2'
                                                                    }
                                                                ]
                                                            },
                                                            kind: 'init',
                                                            order: '1'
                                                        },
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'sorts',
                                                                loc: {
                                                                    start: {
                                                                        line: 32,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/TasksPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 32,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/TasksPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'ObjectExpression',
                                                                objectType: {
                                                                    type: 'ArrayExpression',
                                                                    elements: []
                                                                },
                                                                properties: [
                                                                    {
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'ArrayExpression',
                                                                            elements: [
                                                                                {
                                                                                    type: 'ObjectExpression',
                                                                                    properties: [{
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'percent',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 33,
                                                                                                        column: 26,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/TasksPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 33,
                                                                                                        column: 33,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/TasksPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'Literal',
                                                                                                value: true
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '0'
                                                                                        }]
                                                                                },
                                                                                {
                                                                                    type: 'ObjectExpression',
                                                                                    properties: [{
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'updated',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 33,
                                                                                                        column: 41,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/TasksPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 33,
                                                                                                        column: 48,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/TasksPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'Literal',
                                                                                                value: false
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '0'
                                                                                        }]
                                                                                }
                                                                            ]
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 33,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/TasksPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 33,
                                                                                column: 56,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/TasksPane.ion'
                                                                            }
                                                                        },
                                                                        order: '0'
                                                                    },
                                                                    {
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'ArrayExpression',
                                                                            elements: [
                                                                                {
                                                                                    type: 'ObjectExpression',
                                                                                    properties: [{
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'percent',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 34,
                                                                                                        column: 26,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/TasksPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 34,
                                                                                                        column: 33,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/TasksPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'Literal',
                                                                                                value: true
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '0'
                                                                                        }]
                                                                                },
                                                                                {
                                                                                    type: 'ObjectExpression',
                                                                                    properties: [{
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'priority',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 34,
                                                                                                        column: 41,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/TasksPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 34,
                                                                                                        column: 49,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/TasksPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'Literal',
                                                                                                value: false
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '0'
                                                                                        }]
                                                                                }
                                                                            ]
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 34,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/TasksPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 34,
                                                                                column: 57,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/TasksPane.ion'
                                                                            }
                                                                        },
                                                                        order: '1'
                                                                    }
                                                                ]
                                                            },
                                                            kind: 'init',
                                                            order: '2'
                                                        }
                                                    ]
                                                },
                                                loc: {
                                                    start: {
                                                        line: 26,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/TasksPane.ion'
                                                    },
                                                    end: {
                                                        line: 35,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/TasksPane.ion'
                                                    }
                                                },
                                                order: '1'
                                            },
                                            {
                                                type: 'ExpressionStatement',
                                                expression: {
                                                    type: 'ObjectExpression',
                                                    objectType: {
                                                        type: 'ObjectExpression',
                                                        properties: [
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'id',
                                                                    loc: {
                                                                        start: {
                                                                            line: 35,
                                                                            column: 17,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/TasksPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 35,
                                                                            column: 19,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/TasksPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: 'subscribed'
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'name',
                                                                    loc: {
                                                                        start: {
                                                                            line: 35,
                                                                            column: 34,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/TasksPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 35,
                                                                            column: 38,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/TasksPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: 'Subscribed'
                                                                },
                                                                kind: 'init',
                                                                order: '1'
                                                            }
                                                        ]
                                                    },
                                                    properties: [
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'columns',
                                                                loc: {
                                                                    start: {
                                                                        line: 36,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/TasksPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 36,
                                                                        column: 27,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/TasksPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'ArrayExpression',
                                                                elements: [
                                                                    {
                                                                        type: 'Literal',
                                                                        value: 'name'
                                                                    },
                                                                    {
                                                                        type: 'Literal',
                                                                        value: 'priority'
                                                                    },
                                                                    {
                                                                        type: 'Literal',
                                                                        value: 'percent'
                                                                    },
                                                                    {
                                                                        type: 'Literal',
                                                                        value: 'assigned'
                                                                    },
                                                                    {
                                                                        type: 'Literal',
                                                                        value: 'duration'
                                                                    },
                                                                    {
                                                                        type: 'Literal',
                                                                        value: 'start'
                                                                    },
                                                                    {
                                                                        type: 'Literal',
                                                                        value: 'finish'
                                                                    },
                                                                    {
                                                                        type: 'Literal',
                                                                        value: 'updated'
                                                                    }
                                                                ]
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        },
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'where',
                                                                loc: {
                                                                    start: {
                                                                        line: 37,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/TasksPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 37,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/TasksPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'ObjectExpression',
                                                                properties: [{
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'subscribedKeys',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 38,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/TasksPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 38,
                                                                                    column: 38,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/TasksPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'MemberExpression',
                                                                                computed: false,
                                                                                object: {
                                                                                    type: 'Identifier',
                                                                                    name: 'model',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 38,
                                                                                            column: 39,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/TasksPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 38,
                                                                                            column: 44,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/TasksPane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                property: {
                                                                                    type: 'Identifier',
                                                                                    name: 'user',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 38,
                                                                                            column: 45,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/TasksPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 38,
                                                                                            column: 49,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/TasksPane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 38,
                                                                                        column: 39,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/TasksPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 38,
                                                                                        column: 49,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/TasksPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'key',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 38,
                                                                                        column: 50,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/TasksPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 38,
                                                                                        column: 53,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/TasksPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 38,
                                                                                    column: 39,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/TasksPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 38,
                                                                                    column: 53,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/TasksPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    }]
                                                            },
                                                            kind: 'init',
                                                            order: '1'
                                                        },
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'sorts',
                                                                loc: {
                                                                    start: {
                                                                        line: 39,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/TasksPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 39,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/TasksPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'ObjectExpression',
                                                                objectType: {
                                                                    type: 'ArrayExpression',
                                                                    elements: []
                                                                },
                                                                properties: [{
                                                                        type: 'ExpressionStatement',
                                                                        expression: {
                                                                            type: 'ArrayExpression',
                                                                            elements: [{
                                                                                    type: 'ObjectExpression',
                                                                                    properties: [{
                                                                                            type: 'Property',
                                                                                            key: {
                                                                                                type: 'Identifier',
                                                                                                name: 'updated',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 40,
                                                                                                        column: 26,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/TasksPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 40,
                                                                                                        column: 33,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/TasksPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            value: {
                                                                                                type: 'Literal',
                                                                                                value: false
                                                                                            },
                                                                                            kind: 'init',
                                                                                            order: '0'
                                                                                        }]
                                                                                }]
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 40,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/TasksPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 40,
                                                                                column: 41,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/TasksPane.ion'
                                                                            }
                                                                        },
                                                                        order: '0'
                                                                    }]
                                                            },
                                                            kind: 'init',
                                                            order: '2'
                                                        }
                                                    ]
                                                },
                                                loc: {
                                                    start: {
                                                        line: 35,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/TasksPane.ion'
                                                    },
                                                    end: {
                                                        line: 41,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/TasksPane.ion'
                                                    }
                                                },
                                                order: '2'
                                            }
                                        ]
                                    },
                                    kind: 'init',
                                    order: '4'
                                }
                            ]
                        }],
                    loc: {
                        start: {
                            line: 11,
                            column: 11,
                            fixed: true,
                            source: 'viewpath/html/panes/TasksPane.ion'
                        },
                        end: {
                            line: 41,
                            column: 5,
                            fixed: true,
                            source: 'viewpath/html/panes/TasksPane.ion'
                        }
                    }
                },
                order: '2'
            }
        ],
        bound: false
    }, {
        this: this,
        urlConfig: urlConfig,
        config: config,
        glass: glass,
        viewpath: viewpath,
        _ref: _ref,
        _ref2: _ref2,
        User: User,
        Task: Task,
        GenericTypePane: GenericTypePane
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/panes/TasksPane',_viewpath_html_panes_TasksPane_);
    else
      _viewpath_html_panes_TasksPane_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_panes_TasksPane_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_panes_UserPane_ = function(module,exports,require){'use strict';
var ion = require('ion');
var glass = require('glass'), _ref, _ref2, _ref3, _ref4, viewpath = require('../../'), _ref5, _ref6;
_ref = glass.html.material;
var Icon = _ref.Icon;
var Form = _ref.Form;
var Button = _ref.Button;
var TabContent = _ref.TabContent;
var Dialog = _ref.Dialog;
_ref2 = glass.html.forms;
var GlassForm = _ref2.GlassForm;
var CancelButton = _ref2.CancelButton;
var SubmitButton = _ref2.SubmitButton;
var Field = _ref2.Field;
var EditForm = _ref2.EditForm;
_ref3 = glass.html;
var style = _ref3.style;
_ref4 = glass.data;
var Key = _ref4.Key;
var Schema = _ref4.Schema;
_ref5 = viewpath.model;
var User = _ref5.User;
var Task = _ref5.Task;
_ref6 = require('./');
var TasksPane = _ref6.TasksPane;
var _ref7 = style.sheets;
_ref7[module.id] = '.HoverDim:hover {\n    background-color: rgb(240,240,240);\n    border-radius: 2px;\n    position: relative;\n}\n\n*:hover > .hoverIcon {\n    display: inline-block;\n}\n\n.hoverIcon {\n    display: none;\n    position: absolute;\n    right: 0;\n    bottom: 0;\n}\n\n.IconItem > iron-icon {\n    padding-right: 8px;\n}';
_ref7;
var editUserDialog = ion.template(function (user) {
        return ion.createRuntime({
            type: 'Template',
            id: null,
            body: [
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'dialog',
                                loc: {
                                    start: {
                                        line: 36,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/UserPane.ion'
                                    },
                                    end: {
                                        line: 36,
                                        column: 18,
                                        fixed: true,
                                        source: 'viewpath/html/panes/UserPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'CallExpression',
                                callee: {
                                    type: 'Identifier',
                                    name: 'Dialog',
                                    loc: {
                                        start: {
                                            line: 36,
                                            column: 21,
                                            fixed: true,
                                            source: 'viewpath/html/panes/UserPane.ion'
                                        },
                                        end: {
                                            line: 36,
                                            column: 27,
                                            fixed: true,
                                            source: 'viewpath/html/panes/UserPane.ion'
                                        }
                                    }
                                },
                                arguments: [],
                                loc: {
                                    start: {
                                        line: 36,
                                        column: 21,
                                        fixed: true,
                                        source: 'viewpath/html/panes/UserPane.ion'
                                    },
                                    end: {
                                        line: 36,
                                        column: 29,
                                        fixed: true,
                                        source: 'viewpath/html/panes/UserPane.ion'
                                    }
                                }
                            }
                        }],
                    kind: 'let',
                    order: '0'
                },
                {
                    type: 'VariableDeclaration',
                    declarations: [{
                            type: 'VariableDeclarator',
                            id: {
                                type: 'Identifier',
                                name: 'form',
                                loc: {
                                    start: {
                                        line: 37,
                                        column: 12,
                                        fixed: true,
                                        source: 'viewpath/html/panes/UserPane.ion'
                                    },
                                    end: {
                                        line: 37,
                                        column: 16,
                                        fixed: true,
                                        source: 'viewpath/html/panes/UserPane.ion'
                                    }
                                }
                            },
                            init: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'Identifier',
                                        name: 'EditForm',
                                        loc: {
                                            start: {
                                                line: 37,
                                                column: 19,
                                                fixed: true,
                                                source: 'viewpath/html/panes/UserPane.ion'
                                            },
                                            end: {
                                                line: 37,
                                                column: 27,
                                                fixed: true,
                                                source: 'viewpath/html/panes/UserPane.ion'
                                            }
                                        }
                                    },
                                    arguments: [{
                                            type: 'ObjectExpression',
                                            properties: [
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'properties',
                                                        loc: {
                                                            start: {
                                                                line: 38,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                            },
                                                            end: {
                                                                line: 38,
                                                                column: 22,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'ArrayExpression',
                                                            elements: []
                                                        },
                                                        properties: [
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'User',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 39,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 39,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'properties',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 39,
                                                                                    column: 21,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 39,
                                                                                    column: 31,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 39,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 39,
                                                                                column: 31,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'name',
                                                                        loc: {
                                                                            start: {
                                                                                line: 39,
                                                                                column: 32,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 39,
                                                                                column: 36,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 39,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 39,
                                                                            column: 36,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 39,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 39,
                                                                        column: 36,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'User',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 40,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 40,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'properties',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 40,
                                                                                    column: 21,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 40,
                                                                                    column: 31,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 40,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 40,
                                                                                column: 31,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'email',
                                                                        loc: {
                                                                            start: {
                                                                                line: 40,
                                                                                column: 32,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 40,
                                                                                column: 37,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 40,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 40,
                                                                            column: 37,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 40,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 40,
                                                                        column: 37,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    }
                                                                },
                                                                order: '1'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'User',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 41,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 41,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'properties',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 41,
                                                                                    column: 21,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 41,
                                                                                    column: 31,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 41,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 41,
                                                                                column: 31,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'picture',
                                                                        loc: {
                                                                            start: {
                                                                                line: 41,
                                                                                column: 32,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 41,
                                                                                column: 39,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 41,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 41,
                                                                            column: 39,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 41,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 41,
                                                                        column: 39,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    }
                                                                },
                                                                order: '2'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'User',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 42,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 42,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'properties',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 42,
                                                                                    column: 21,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 42,
                                                                                    column: 31,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 42,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 42,
                                                                                column: 31,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'timezone',
                                                                        loc: {
                                                                            start: {
                                                                                line: 42,
                                                                                column: 32,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 42,
                                                                                column: 40,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 42,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 42,
                                                                            column: 40,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 42,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 42,
                                                                        column: 40,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    }
                                                                },
                                                                order: '3'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'User',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 43,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 43,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'properties',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 43,
                                                                                    column: 21,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 43,
                                                                                    column: 31,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 43,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 43,
                                                                                column: 31,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'phoneHome',
                                                                        loc: {
                                                                            start: {
                                                                                line: 43,
                                                                                column: 32,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 43,
                                                                                column: 41,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 43,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 43,
                                                                            column: 41,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 43,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 43,
                                                                        column: 41,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    }
                                                                },
                                                                order: '4'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'User',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 44,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 44,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'properties',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 44,
                                                                                    column: 21,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 44,
                                                                                    column: 31,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 44,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 44,
                                                                                column: 31,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'phoneWork',
                                                                        loc: {
                                                                            start: {
                                                                                line: 44,
                                                                                column: 32,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 44,
                                                                                column: 41,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 44,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 44,
                                                                            column: 41,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 44,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 44,
                                                                        column: 41,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    }
                                                                },
                                                                order: '5'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'MemberExpression',
                                                                        computed: false,
                                                                        object: {
                                                                            type: 'Identifier',
                                                                            name: 'User',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 45,
                                                                                    column: 16,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 45,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'properties',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 45,
                                                                                    column: 21,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 45,
                                                                                    column: 31,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 45,
                                                                                column: 16,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 45,
                                                                                column: 31,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'phoneCell',
                                                                        loc: {
                                                                            start: {
                                                                                line: 45,
                                                                                column: 32,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 45,
                                                                                column: 41,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 45,
                                                                            column: 16,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 45,
                                                                            column: 41,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 45,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 45,
                                                                        column: 41,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    }
                                                                },
                                                                order: '6'
                                                            }
                                                        ]
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'object',
                                                        loc: {
                                                            start: {
                                                                line: 46,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                            },
                                                            end: {
                                                                line: 46,
                                                                column: 18,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Identifier',
                                                        name: 'user',
                                                        loc: {
                                                            start: {
                                                                line: 46,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                            },
                                                            end: {
                                                                line: 46,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                            }
                                                        }
                                                    },
                                                    kind: 'init',
                                                    order: '1'
                                                },
                                                {
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'values',
                                                        loc: {
                                                            start: {
                                                                line: 47,
                                                                column: 12,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                            },
                                                            end: {
                                                                line: 47,
                                                                column: 18,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Identifier',
                                                        name: 'user',
                                                        loc: {
                                                            start: {
                                                                line: 47,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                            },
                                                            end: {
                                                                line: 47,
                                                                column: 24,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                            }
                                                        }
                                                    },
                                                    kind: 'init',
                                                    order: '2'
                                                }
                                            ]
                                        }],
                                    loc: {
                                        start: {
                                            line: 37,
                                            column: 19,
                                            fixed: true,
                                            source: 'viewpath/html/panes/UserPane.ion'
                                        },
                                        end: {
                                            line: 48,
                                            column: 9,
                                            fixed: true,
                                            source: 'viewpath/html/panes/UserPane.ion'
                                        }
                                    }
                                },
                                properties: [
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'autoApplyValues',
                                            loc: {
                                                start: {
                                                    line: 49,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                },
                                                end: {
                                                    line: 49,
                                                    column: 27,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'Literal',
                                            value: true
                                        },
                                        kind: 'init',
                                        order: '0'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'Function',
                                            context: true,
                                            value: function (_context) {
                                                return function cancel() {
                                                    var dialog = _context.get('dialog');
                                                    return dialog.open = false;
                                                };
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 50,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/UserPane.ion'
                                            },
                                            end: {
                                                line: 50,
                                                column: 43,
                                                fixed: true,
                                                source: 'viewpath/html/panes/UserPane.ion'
                                            }
                                        },
                                        order: '1'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'Function',
                                            context: true,
                                            value: function (_context2) {
                                                return function complete() {
                                                    var dialog = _context2.get('dialog');
                                                    return dialog.open = false;
                                                };
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 51,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/UserPane.ion'
                                            },
                                            end: {
                                                line: 51,
                                                column: 45,
                                                fixed: true,
                                                source: 'viewpath/html/panes/UserPane.ion'
                                            }
                                        },
                                        order: '2'
                                    },
                                    {
                                        type: 'ExpressionStatement',
                                        expression: {
                                            type: 'ObjectExpression',
                                            objectType: {
                                                type: 'CallExpression',
                                                callee: {
                                                    type: 'Identifier',
                                                    name: 'Footer',
                                                    loc: {
                                                        start: {
                                                            line: 52,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                        },
                                                        end: {
                                                            line: 52,
                                                            column: 18,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                        }
                                                    }
                                                },
                                                arguments: [],
                                                loc: {
                                                    start: {
                                                        line: 52,
                                                        column: 12,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                    },
                                                    end: {
                                                        line: 52,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                    }
                                                }
                                            },
                                            properties: [
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'CancelButton',
                                                                loc: {
                                                                    start: {
                                                                        line: 53,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 53,
                                                                        column: 28,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [],
                                                            loc: {
                                                                start: {
                                                                    line: 53,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                },
                                                                end: {
                                                                    line: 53,
                                                                    column: 30,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [
                                                            {
                                                                type: 'Property',
                                                                key: {
                                                                    type: 'Identifier',
                                                                    name: 'raised',
                                                                    loc: {
                                                                        start: {
                                                                            line: 54,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 54,
                                                                            column: 26,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                value: {
                                                                    type: 'Literal',
                                                                    value: false
                                                                },
                                                                kind: 'init',
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'Literal',
                                                                    value: 'Cancel'
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 55,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 55,
                                                                        column: 28,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    }
                                                                },
                                                                order: '1'
                                                            }
                                                        ]
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 53,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                        },
                                                        end: {
                                                            line: 56,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                },
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'SubmitButton',
                                                                loc: {
                                                                    start: {
                                                                        line: 56,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 56,
                                                                        column: 28,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [],
                                                            loc: {
                                                                start: {
                                                                    line: 56,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                },
                                                                end: {
                                                                    line: 56,
                                                                    column: 30,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [{
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'Literal',
                                                                    value: 'Submit'
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 57,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 57,
                                                                        column: 28,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 56,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                        },
                                                        end: {
                                                            line: 58,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                        }
                                                    },
                                                    order: '1'
                                                }
                                            ]
                                        },
                                        loc: {
                                            start: {
                                                line: 52,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/UserPane.ion'
                                            },
                                            end: {
                                                line: 58,
                                                column: 16,
                                                fixed: true,
                                                source: 'viewpath/html/panes/UserPane.ion'
                                            }
                                        },
                                        order: '3'
                                    }
                                ]
                            }
                        }],
                    kind: 'let',
                    order: '1'
                },
                {
                    type: 'ReturnStatement',
                    argument: {
                        type: 'ObjectExpression',
                        objectType: {
                            type: 'Identifier',
                            name: 'dialog',
                            loc: {
                                start: {
                                    line: 58,
                                    column: 15,
                                    fixed: true,
                                    source: 'viewpath/html/panes/UserPane.ion'
                                },
                                end: {
                                    line: 58,
                                    column: 21,
                                    fixed: true,
                                    source: 'viewpath/html/panes/UserPane.ion'
                                }
                            }
                        },
                        properties: [
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'focus',
                                    loc: {
                                        start: {
                                            line: 59,
                                            column: 12,
                                            fixed: true,
                                            source: 'viewpath/html/panes/UserPane.ion'
                                        },
                                        end: {
                                            line: 59,
                                            column: 17,
                                            fixed: true,
                                            source: 'viewpath/html/panes/UserPane.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'Function',
                                    context: true,
                                    value: function (_context3) {
                                        return function () {
                                            var form = _context3.get('form');
                                            form.focus();
                                        };
                                    }
                                },
                                kind: 'init',
                                order: '0'
                            },
                            {
                                type: 'Property',
                                key: {
                                    type: 'Identifier',
                                    name: 'frame',
                                    loc: {
                                        start: {
                                            line: 61,
                                            column: 12,
                                            fixed: true,
                                            source: 'viewpath/html/panes/UserPane.ion'
                                        },
                                        end: {
                                            line: 61,
                                            column: 17,
                                            fixed: true,
                                            source: 'viewpath/html/panes/UserPane.ion'
                                        }
                                    }
                                },
                                value: {
                                    type: 'ObjectExpression',
                                    properties: [
                                        {
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'style',
                                                loc: {
                                                    start: {
                                                        line: 62,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                    },
                                                    end: {
                                                        line: 62,
                                                        column: 21,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'ObjectExpression',
                                                properties: [{
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'width',
                                                            loc: {
                                                                start: {
                                                                    line: 63,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                },
                                                                end: {
                                                                    line: 63,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Literal',
                                                            value: '400px'
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    }]
                                            },
                                            kind: 'init',
                                            order: '0'
                                        },
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'ObjectExpression',
                                                objectType: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'Identifier',
                                                        name: 'Div',
                                                        loc: {
                                                            start: {
                                                                line: 64,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                            },
                                                            end: {
                                                                line: 64,
                                                                column: 19,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                            }
                                                        }
                                                    },
                                                    arguments: [{
                                                            type: 'ObjectExpression',
                                                            properties: [{
                                                                    type: 'Property',
                                                                    key: {
                                                                        type: 'Identifier',
                                                                        name: 'class',
                                                                        loc: {
                                                                            start: {
                                                                                line: 64,
                                                                                column: 21,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 64,
                                                                                column: 26,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    value: {
                                                                        type: 'Literal',
                                                                        value: 'title'
                                                                    },
                                                                    kind: 'init',
                                                                    order: '0'
                                                                }]
                                                        }],
                                                    loc: {
                                                        start: {
                                                            line: 64,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                        },
                                                        end: {
                                                            line: 64,
                                                            column: 37,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                        }
                                                    }
                                                },
                                                properties: [{
                                                        type: 'ExpressionStatement',
                                                        expression: {
                                                            type: 'ConditionalExpression',
                                                            test: {
                                                                type: 'BinaryExpression',
                                                                operator: '!=',
                                                                left: {
                                                                    type: 'MemberExpression',
                                                                    computed: false,
                                                                    object: {
                                                                        type: 'Identifier',
                                                                        name: 'user',
                                                                        loc: {
                                                                            start: {
                                                                                line: 65,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 65,
                                                                                column: 24,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    property: {
                                                                        type: 'Identifier',
                                                                        name: 'name',
                                                                        loc: {
                                                                            start: {
                                                                                line: 65,
                                                                                column: 25,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 65,
                                                                                column: 29,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    loc: {
                                                                        start: {
                                                                            line: 65,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 65,
                                                                            column: 29,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                right: {
                                                                    type: 'Literal',
                                                                    value: null
                                                                }
                                                            },
                                                            consequent: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'user',
                                                                    loc: {
                                                                        start: {
                                                                            line: 65,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 65,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'name',
                                                                    loc: {
                                                                        start: {
                                                                            line: 65,
                                                                            column: 25,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 65,
                                                                            column: 29,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 65,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 65,
                                                                        column: 29,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            alternate: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'user',
                                                                    loc: {
                                                                        start: {
                                                                            line: 65,
                                                                            column: 32,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 65,
                                                                            column: 36,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'email',
                                                                    loc: {
                                                                        start: {
                                                                            line: 65,
                                                                            column: 37,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 65,
                                                                            column: 42,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 65,
                                                                        column: 32,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 65,
                                                                        column: 42,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    }
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 65,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                            },
                                                            end: {
                                                                line: 65,
                                                                column: 42,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                            }
                                                        },
                                                        order: '0'
                                                    }]
                                            },
                                            loc: {
                                                start: {
                                                    line: 64,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                },
                                                end: {
                                                    line: 66,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                }
                                            },
                                            order: '1'
                                        },
                                        {
                                            type: 'ExpressionStatement',
                                            expression: {
                                                type: 'Identifier',
                                                name: 'form',
                                                loc: {
                                                    start: {
                                                        line: 66,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                    },
                                                    end: {
                                                        line: 66,
                                                        column: 20,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 66,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                },
                                                end: {
                                                    line: 66,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                }
                                            },
                                            order: '2'
                                        }
                                    ]
                                },
                                kind: 'init',
                                order: '1'
                            }
                        ]
                    },
                    order: '2'
                }
            ],
            bound: false,
            name: {
                type: 'Identifier',
                name: 'editUserDialog',
                loc: {
                    start: {
                        line: 35,
                        column: 4,
                        fixed: true,
                        source: 'viewpath/html/panes/UserPane.ion'
                    },
                    end: {
                        line: 35,
                        column: 18,
                        fixed: true,
                        source: 'viewpath/html/panes/UserPane.ion'
                    }
                }
            }
        }, {
            this: this,
            user: user,
            glass: glass,
            _ref: _ref,
            _ref2: _ref2,
            _ref3: _ref3,
            _ref4: _ref4,
            viewpath: viewpath,
            _ref5: _ref5,
            _ref6: _ref6,
            Icon: Icon,
            Form: Form,
            Button: Button,
            TabContent: TabContent,
            Dialog: Dialog,
            GlassForm: GlassForm,
            CancelButton: CancelButton,
            SubmitButton: SubmitButton,
            Field: Field,
            EditForm: EditForm,
            style: style,
            Key: Key,
            Schema: Schema,
            User: User,
            Task: Task,
            TasksPane: TasksPane,
            _ref7: _ref7,
            editUserDialog: editUserDialog
        }, null);
    });
module.exports = exports = ion.template(function UserPane(config) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'UserPane',
            loc: {
                start: {
                    line: 68,
                    column: 16,
                    fixed: true,
                    source: 'viewpath/html/panes/UserPane.ion'
                },
                end: {
                    line: 68,
                    column: 24,
                    fixed: true,
                    source: 'viewpath/html/panes/UserPane.ion'
                }
            }
        },
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'key',
                            loc: {
                                start: {
                                    line: 69,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/html/panes/UserPane.ion'
                                },
                                end: {
                                    line: 69,
                                    column: 11,
                                    fixed: true,
                                    source: 'viewpath/html/panes/UserPane.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ConditionalExpression',
                            test: {
                                type: 'BinaryExpression',
                                operator: '!=',
                                left: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'config',
                                        loc: {
                                            start: {
                                                line: 69,
                                                column: 14,
                                                fixed: true,
                                                source: 'viewpath/html/panes/UserPane.ion'
                                            },
                                            end: {
                                                line: 69,
                                                column: 20,
                                                fixed: true,
                                                source: 'viewpath/html/panes/UserPane.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'key',
                                        loc: {
                                            start: {
                                                line: 69,
                                                column: 21,
                                                fixed: true,
                                                source: 'viewpath/html/panes/UserPane.ion'
                                            },
                                            end: {
                                                line: 69,
                                                column: 24,
                                                fixed: true,
                                                source: 'viewpath/html/panes/UserPane.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 69,
                                            column: 14,
                                            fixed: true,
                                            source: 'viewpath/html/panes/UserPane.ion'
                                        },
                                        end: {
                                            line: 69,
                                            column: 24,
                                            fixed: true,
                                            source: 'viewpath/html/panes/UserPane.ion'
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: null
                                }
                            },
                            consequent: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'Identifier',
                                    name: 'config',
                                    loc: {
                                        start: {
                                            line: 69,
                                            column: 14,
                                            fixed: true,
                                            source: 'viewpath/html/panes/UserPane.ion'
                                        },
                                        end: {
                                            line: 69,
                                            column: 20,
                                            fixed: true,
                                            source: 'viewpath/html/panes/UserPane.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'key',
                                    loc: {
                                        start: {
                                            line: 69,
                                            column: 21,
                                            fixed: true,
                                            source: 'viewpath/html/panes/UserPane.ion'
                                        },
                                        end: {
                                            line: 69,
                                            column: 24,
                                            fixed: true,
                                            source: 'viewpath/html/panes/UserPane.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 69,
                                        column: 14,
                                        fixed: true,
                                        source: 'viewpath/html/panes/UserPane.ion'
                                    },
                                    end: {
                                        line: 69,
                                        column: 24,
                                        fixed: true,
                                        source: 'viewpath/html/panes/UserPane.ion'
                                    }
                                }
                            },
                            alternate: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'model',
                                        loc: {
                                            start: {
                                                line: 69,
                                                column: 27,
                                                fixed: true,
                                                source: 'viewpath/html/panes/UserPane.ion'
                                            },
                                            end: {
                                                line: 69,
                                                column: 32,
                                                fixed: true,
                                                source: 'viewpath/html/panes/UserPane.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'user',
                                        loc: {
                                            start: {
                                                line: 69,
                                                column: 33,
                                                fixed: true,
                                                source: 'viewpath/html/panes/UserPane.ion'
                                            },
                                            end: {
                                                line: 69,
                                                column: 37,
                                                fixed: true,
                                                source: 'viewpath/html/panes/UserPane.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 69,
                                            column: 27,
                                            fixed: true,
                                            source: 'viewpath/html/panes/UserPane.ion'
                                        },
                                        end: {
                                            line: 69,
                                            column: 37,
                                            fixed: true,
                                            source: 'viewpath/html/panes/UserPane.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'key',
                                    loc: {
                                        start: {
                                            line: 69,
                                            column: 38,
                                            fixed: true,
                                            source: 'viewpath/html/panes/UserPane.ion'
                                        },
                                        end: {
                                            line: 69,
                                            column: 41,
                                            fixed: true,
                                            source: 'viewpath/html/panes/UserPane.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 69,
                                        column: 27,
                                        fixed: true,
                                        source: 'viewpath/html/panes/UserPane.ion'
                                    },
                                    end: {
                                        line: 69,
                                        column: 41,
                                        fixed: true,
                                        source: 'viewpath/html/panes/UserPane.ion'
                                    }
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'IfStatement',
                test: {
                    type: 'UnaryExpression',
                    operator: '?',
                    argument: {
                        type: 'Identifier',
                        name: 'key',
                        loc: {
                            start: {
                                line: 70,
                                column: 7,
                                fixed: true,
                                source: 'viewpath/html/panes/UserPane.ion'
                            },
                            end: {
                                line: 70,
                                column: 10,
                                fixed: true,
                                source: 'viewpath/html/panes/UserPane.ion'
                            }
                        }
                    }
                },
                consequent: {
                    type: 'BlockStatement',
                    body: [
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'userKey',
                                        loc: {
                                            start: {
                                                line: 71,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/UserPane.ion'
                                            },
                                            end: {
                                                line: 71,
                                                column: 19,
                                                fixed: true,
                                                source: 'viewpath/html/panes/UserPane.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'NewExpression',
                                        callee: {
                                            type: 'Identifier',
                                            name: 'Key',
                                            loc: {
                                                start: {
                                                    line: 71,
                                                    column: 26,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                },
                                                end: {
                                                    line: 71,
                                                    column: 29,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                }
                                            }
                                        },
                                        arguments: [
                                            {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'viewpath',
                                                    loc: {
                                                        start: {
                                                            line: 71,
                                                            column: 30,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                        },
                                                        end: {
                                                            line: 71,
                                                            column: 38,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'model',
                                                    loc: {
                                                        start: {
                                                            line: 71,
                                                            column: 39,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                        },
                                                        end: {
                                                            line: 71,
                                                            column: 44,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 71,
                                                        column: 30,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                    },
                                                    end: {
                                                        line: 71,
                                                        column: 44,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                    }
                                                }
                                            },
                                            {
                                                type: 'Identifier',
                                                name: 'key',
                                                loc: {
                                                    start: {
                                                        line: 71,
                                                        column: 46,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                    },
                                                    end: {
                                                        line: 71,
                                                        column: 49,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                    }
                                                }
                                            }
                                        ],
                                        loc: {
                                            start: {
                                                line: 71,
                                                column: 22,
                                                fixed: true,
                                                source: 'viewpath/html/panes/UserPane.ion'
                                            },
                                            end: {
                                                line: 71,
                                                column: 50,
                                                fixed: true,
                                                source: 'viewpath/html/panes/UserPane.ion'
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '0'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'user',
                                        loc: {
                                            start: {
                                                line: 72,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/UserPane.ion'
                                            },
                                            end: {
                                                line: 72,
                                                column: 16,
                                                fixed: true,
                                                source: 'viewpath/html/panes/UserPane.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'MemberExpression',
                                        computed: true,
                                        object: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'model',
                                                loc: {
                                                    start: {
                                                        line: 72,
                                                        column: 19,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                    },
                                                    end: {
                                                        line: 72,
                                                        column: 24,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'server',
                                                loc: {
                                                    start: {
                                                        line: 72,
                                                        column: 25,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                    },
                                                    end: {
                                                        line: 72,
                                                        column: 31,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 72,
                                                    column: 19,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                },
                                                end: {
                                                    line: 72,
                                                    column: 31,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'userKey',
                                            loc: {
                                                start: {
                                                    line: 72,
                                                    column: 32,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                },
                                                end: {
                                                    line: 72,
                                                    column: 39,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 72,
                                                column: 19,
                                                fixed: true,
                                                source: 'viewpath/html/panes/UserPane.ion'
                                            },
                                            end: {
                                                line: 72,
                                                column: 40,
                                                fixed: true,
                                                source: 'viewpath/html/panes/UserPane.ion'
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '1'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'subscription',
                                        loc: {
                                            start: {
                                                line: 73,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/UserPane.ion'
                                            },
                                            end: {
                                                line: 73,
                                                column: 24,
                                                fixed: true,
                                                source: 'viewpath/html/panes/UserPane.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'MemberExpression',
                                        computed: true,
                                        object: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'model',
                                                loc: {
                                                    start: {
                                                        line: 73,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                    },
                                                    end: {
                                                        line: 73,
                                                        column: 32,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'server',
                                                loc: {
                                                    start: {
                                                        line: 73,
                                                        column: 33,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                    },
                                                    end: {
                                                        line: 73,
                                                        column: 39,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 73,
                                                    column: 27,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                },
                                                end: {
                                                    line: 73,
                                                    column: 39,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'user',
                                                loc: {
                                                    start: {
                                                        line: 73,
                                                        column: 40,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                    },
                                                    end: {
                                                        line: 73,
                                                        column: 44,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'subscription',
                                                loc: {
                                                    start: {
                                                        line: 73,
                                                        column: 45,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                    },
                                                    end: {
                                                        line: 73,
                                                        column: 57,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 73,
                                                    column: 40,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                },
                                                end: {
                                                    line: 73,
                                                    column: 57,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 73,
                                                column: 27,
                                                fixed: true,
                                                source: 'viewpath/html/panes/UserPane.ion'
                                            },
                                            end: {
                                                line: 73,
                                                column: 58,
                                                fixed: true,
                                                source: 'viewpath/html/panes/UserPane.ion'
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '2'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'product',
                                        loc: {
                                            start: {
                                                line: 74,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/UserPane.ion'
                                            },
                                            end: {
                                                line: 74,
                                                column: 19,
                                                fixed: true,
                                                source: 'viewpath/html/panes/UserPane.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'user',
                                                loc: {
                                                    start: {
                                                        line: 74,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                    },
                                                    end: {
                                                        line: 74,
                                                        column: 26,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'getProduct',
                                                loc: {
                                                    start: {
                                                        line: 74,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                    },
                                                    end: {
                                                        line: 74,
                                                        column: 37,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 74,
                                                    column: 22,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                },
                                                end: {
                                                    line: 74,
                                                    column: 37,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                }
                                            }
                                        },
                                        arguments: [{
                                                type: 'Identifier',
                                                name: 'subscription',
                                                loc: {
                                                    start: {
                                                        line: 74,
                                                        column: 38,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                    },
                                                    end: {
                                                        line: 74,
                                                        column: 50,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                    }
                                                }
                                            }],
                                        loc: {
                                            start: {
                                                line: 74,
                                                column: 22,
                                                fixed: true,
                                                source: 'viewpath/html/panes/UserPane.ion'
                                            },
                                            end: {
                                                line: 74,
                                                column: 51,
                                                fixed: true,
                                                source: 'viewpath/html/panes/UserPane.ion'
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '3'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'isViewerProvider',
                                        loc: {
                                            start: {
                                                line: 75,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/UserPane.ion'
                                            },
                                            end: {
                                                line: 75,
                                                column: 28,
                                                fixed: true,
                                                source: 'viewpath/html/panes/UserPane.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'BinaryExpression',
                                        operator: '===',
                                        left: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'subscription',
                                                loc: {
                                                    start: {
                                                        line: 75,
                                                        column: 31,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                    },
                                                    end: {
                                                        line: 75,
                                                        column: 43,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'createdBy',
                                                loc: {
                                                    start: {
                                                        line: 75,
                                                        column: 45,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                    },
                                                    end: {
                                                        line: 75,
                                                        column: 54,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                    }
                                                }
                                            },
                                            existential: true,
                                            loc: {
                                                start: {
                                                    line: 75,
                                                    column: 31,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                },
                                                end: {
                                                    line: 75,
                                                    column: 54,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                }
                                            }
                                        },
                                        right: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'model',
                                                    loc: {
                                                        start: {
                                                            line: 75,
                                                            column: 58,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                        },
                                                        end: {
                                                            line: 75,
                                                            column: 63,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'user',
                                                    loc: {
                                                        start: {
                                                            line: 75,
                                                            column: 64,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                        },
                                                        end: {
                                                            line: 75,
                                                            column: 68,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 75,
                                                        column: 58,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                    },
                                                    end: {
                                                        line: 75,
                                                        column: 68,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'key',
                                                loc: {
                                                    start: {
                                                        line: 75,
                                                        column: 69,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                    },
                                                    end: {
                                                        line: 75,
                                                        column: 72,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 75,
                                                    column: 58,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                },
                                                end: {
                                                    line: 75,
                                                    column: 72,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                }
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '4'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'isViewingSelf',
                                        loc: {
                                            start: {
                                                line: 76,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/UserPane.ion'
                                            },
                                            end: {
                                                line: 76,
                                                column: 25,
                                                fixed: true,
                                                source: 'viewpath/html/panes/UserPane.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'BinaryExpression',
                                        operator: '===',
                                        left: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'model',
                                                loc: {
                                                    start: {
                                                        line: 76,
                                                        column: 28,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                    },
                                                    end: {
                                                        line: 76,
                                                        column: 33,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'userKey',
                                                loc: {
                                                    start: {
                                                        line: 76,
                                                        column: 34,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                    },
                                                    end: {
                                                        line: 76,
                                                        column: 41,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 76,
                                                    column: 28,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                },
                                                end: {
                                                    line: 76,
                                                    column: 41,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                }
                                            }
                                        },
                                        right: {
                                            type: 'Identifier',
                                            name: 'key',
                                            loc: {
                                                start: {
                                                    line: 76,
                                                    column: 45,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                },
                                                end: {
                                                    line: 76,
                                                    column: 48,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                }
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '5'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'img',
                                        loc: {
                                            start: {
                                                line: 79,
                                                column: 12,
                                                fixed: true,
                                                source: 'viewpath/html/panes/UserPane.ion'
                                            },
                                            end: {
                                                line: 79,
                                                column: 15,
                                                fixed: true,
                                                source: 'viewpath/html/panes/UserPane.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'ObjectExpression',
                                        objectType: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'Identifier',
                                                name: 'Img',
                                                loc: {
                                                    start: {
                                                        line: 79,
                                                        column: 18,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                    },
                                                    end: {
                                                        line: 79,
                                                        column: 21,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                    }
                                                }
                                            },
                                            arguments: [{
                                                    type: 'ObjectExpression',
                                                    properties: [{
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'src',
                                                                loc: {
                                                                    start: {
                                                                        line: 79,
                                                                        column: 23,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 79,
                                                                        column: 26,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'user',
                                                                    loc: {
                                                                        start: {
                                                                            line: 79,
                                                                            column: 28,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 79,
                                                                            column: 32,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'picture',
                                                                    loc: {
                                                                        start: {
                                                                            line: 79,
                                                                            column: 33,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 79,
                                                                            column: 40,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 79,
                                                                        column: 28,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 79,
                                                                        column: 40,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        }]
                                                }],
                                            loc: {
                                                start: {
                                                    line: 79,
                                                    column: 18,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                },
                                                end: {
                                                    line: 79,
                                                    column: 42,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                }
                                            }
                                        },
                                        properties: [{
                                                type: 'Property',
                                                key: {
                                                    type: 'Identifier',
                                                    name: 'style',
                                                    loc: {
                                                        start: {
                                                            line: 80,
                                                            column: 12,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                        },
                                                        end: {
                                                            line: 80,
                                                            column: 17,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                        }
                                                    }
                                                },
                                                value: {
                                                    type: 'ObjectExpression',
                                                    properties: [
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'height',
                                                                loc: {
                                                                    start: {
                                                                        line: 81,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 81,
                                                                        column: 22,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Literal',
                                                                value: '20vmin'
                                                            },
                                                            kind: 'init',
                                                            order: '0'
                                                        },
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'width',
                                                                loc: {
                                                                    start: {
                                                                        line: 82,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 82,
                                                                        column: 21,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Literal',
                                                                value: '20vmin'
                                                            },
                                                            kind: 'init',
                                                            order: '1'
                                                        },
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'borderRadius',
                                                                loc: {
                                                                    start: {
                                                                        line: 83,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 83,
                                                                        column: 28,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Literal',
                                                                value: '50%'
                                                            },
                                                            kind: 'init',
                                                            order: '2'
                                                        },
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'objectFit',
                                                                loc: {
                                                                    start: {
                                                                        line: 84,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 84,
                                                                        column: 25,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Literal',
                                                                value: 'cover'
                                                            },
                                                            kind: 'init',
                                                            order: '3'
                                                        },
                                                        {
                                                            type: 'Property',
                                                            key: {
                                                                type: 'Identifier',
                                                                name: 'objectPosition',
                                                                loc: {
                                                                    start: {
                                                                        line: 85,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 85,
                                                                        column: 30,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            value: {
                                                                type: 'Literal',
                                                                value: '50% 0%'
                                                            },
                                                            kind: 'init',
                                                            order: '4'
                                                        }
                                                    ]
                                                },
                                                kind: 'init',
                                                order: '0'
                                            }]
                                    }
                                }],
                            kind: 'let',
                            order: '6'
                        },
                        {
                            type: 'ReturnStatement',
                            argument: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'CallExpression',
                                    callee: {
                                        type: 'Identifier',
                                        name: 'Div',
                                        loc: {
                                            start: {
                                                line: 87,
                                                column: 15,
                                                fixed: true,
                                                source: 'viewpath/html/panes/UserPane.ion'
                                            },
                                            end: {
                                                line: 87,
                                                column: 18,
                                                fixed: true,
                                                source: 'viewpath/html/panes/UserPane.ion'
                                            }
                                        }
                                    },
                                    arguments: [{
                                            type: 'ObjectExpression',
                                            properties: [{
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'class',
                                                        loc: {
                                                            start: {
                                                                line: 87,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                            },
                                                            end: {
                                                                line: 87,
                                                                column: 25,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: 'fill layout vertical'
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                }]
                                        }],
                                    loc: {
                                        start: {
                                            line: 87,
                                            column: 15,
                                            fixed: true,
                                            source: 'viewpath/html/panes/UserPane.ion'
                                        },
                                        end: {
                                            line: 87,
                                            column: 50,
                                            fixed: true,
                                            source: 'viewpath/html/panes/UserPane.ion'
                                        }
                                    }
                                },
                                properties: [
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'name',
                                            loc: {
                                                start: {
                                                    line: 88,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                },
                                                end: {
                                                    line: 88,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'ArrayExpression',
                                            elements: [
                                                {
                                                    type: 'Literal',
                                                    value: 'User'
                                                },
                                                {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'user',
                                                        loc: {
                                                            start: {
                                                                line: 88,
                                                                column: 27,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                            },
                                                            end: {
                                                                line: 88,
                                                                column: 31,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'name',
                                                        loc: {
                                                            start: {
                                                                line: 88,
                                                                column: 32,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                            },
                                                            end: {
                                                                line: 88,
                                                                column: 36,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 88,
                                                            column: 27,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                        },
                                                        end: {
                                                            line: 88,
                                                            column: 36,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                        }
                                                    }
                                                }
                                            ]
                                        },
                                        kind: 'init',
                                        order: '0'
                                    },
                                    {
                                        type: 'IfStatement',
                                        test: {
                                            type: 'UnaryExpression',
                                            operator: '?',
                                            argument: {
                                                type: 'Identifier',
                                                name: 'user',
                                                loc: {
                                                    start: {
                                                        line: 89,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                    },
                                                    end: {
                                                        line: 89,
                                                        column: 19,
                                                        fixed: true,
                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                    }
                                                }
                                            }
                                        },
                                        consequent: {
                                            type: 'BlockStatement',
                                            body: [
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'ObjectExpression',
                                                        objectType: {
                                                            type: 'CallExpression',
                                                            callee: {
                                                                type: 'Identifier',
                                                                name: 'Div',
                                                                loc: {
                                                                    start: {
                                                                        line: 91,
                                                                        column: 16,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 91,
                                                                        column: 19,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            arguments: [{
                                                                    type: 'ObjectExpression',
                                                                    properties: [
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'class',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 91,
                                                                                        column: 21,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 91,
                                                                                        column: 26,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'layout start-justified center padding nowrap'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'Property',
                                                                            key: {
                                                                                type: 'Identifier',
                                                                                name: 'style',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 91,
                                                                                        column: 75,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 91,
                                                                                        column: 80,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            value: {
                                                                                type: 'Literal',
                                                                                value: 'overflow-x:auto'
                                                                            },
                                                                            kind: 'init',
                                                                            order: '1'
                                                                        }
                                                                    ]
                                                                }],
                                                            loc: {
                                                                start: {
                                                                    line: 91,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                },
                                                                end: {
                                                                    line: 91,
                                                                    column: 100,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                }
                                                            }
                                                        },
                                                        properties: [
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'ObjectExpression',
                                                                    objectType: {
                                                                        type: 'CallExpression',
                                                                        callee: {
                                                                            type: 'Identifier',
                                                                            name: 'Div',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 94,
                                                                                    column: 20,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 94,
                                                                                    column: 23,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        arguments: [{
                                                                                type: 'ObjectExpression',
                                                                                properties: [{
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'class',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 94,
                                                                                                    column: 25,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 94,
                                                                                                    column: 30,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 'HoverDim padding-quarter layout horizontal start-justified center'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '0'
                                                                                    }]
                                                                            }],
                                                                        loc: {
                                                                            start: {
                                                                                line: 94,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 94,
                                                                                column: 101,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    properties: [
                                                                        {
                                                                            type: 'IfStatement',
                                                                            test: {
                                                                                type: 'BinaryExpression',
                                                                                operator: '&&',
                                                                                left: {
                                                                                    type: 'BinaryExpression',
                                                                                    operator: '&&',
                                                                                    left: {
                                                                                        type: 'UnaryExpression',
                                                                                        operator: '?',
                                                                                        argument: {
                                                                                            type: 'MemberExpression',
                                                                                            computed: false,
                                                                                            object: {
                                                                                                type: 'Identifier',
                                                                                                name: 'user',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 95,
                                                                                                        column: 27,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 95,
                                                                                                        column: 31,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            property: {
                                                                                                type: 'Identifier',
                                                                                                name: 'picture',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 95,
                                                                                                        column: 32,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 95,
                                                                                                        column: 39,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 95,
                                                                                                    column: 27,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 95,
                                                                                                    column: 39,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                }
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    right: {
                                                                                        type: 'BinaryExpression',
                                                                                        operator: '>',
                                                                                        left: {
                                                                                            type: 'MemberExpression',
                                                                                            computed: false,
                                                                                            object: {
                                                                                                type: 'Identifier',
                                                                                                name: 'img',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 95,
                                                                                                        column: 45,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 95,
                                                                                                        column: 48,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            property: {
                                                                                                type: 'Identifier',
                                                                                                name: 'width',
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 95,
                                                                                                        column: 49,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 95,
                                                                                                        column: 54,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 95,
                                                                                                    column: 45,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 95,
                                                                                                    column: 54,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        right: {
                                                                                            type: 'Literal',
                                                                                            value: 0
                                                                                        }
                                                                                    }
                                                                                },
                                                                                right: {
                                                                                    type: 'MemberExpression',
                                                                                    computed: false,
                                                                                    object: {
                                                                                        type: 'Identifier',
                                                                                        name: 'img',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 95,
                                                                                                column: 63,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 95,
                                                                                                column: 66,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    property: {
                                                                                        type: 'Identifier',
                                                                                        name: 'complete',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 95,
                                                                                                column: 67,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 95,
                                                                                                column: 75,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 95,
                                                                                            column: 63,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 95,
                                                                                            column: 75,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                        }
                                                                                    }
                                                                                }
                                                                            },
                                                                            consequent: {
                                                                                type: 'BlockStatement',
                                                                                body: [{
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'Identifier',
                                                                                            name: 'img',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 96,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 96,
                                                                                                    column: 31,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 96,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 96,
                                                                                                column: 31,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    }]
                                                                            },
                                                                            alternate: null,
                                                                            order: '0'
                                                                        },
                                                                        {
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'ObjectExpression',
                                                                                objectType: {
                                                                                    type: 'CallExpression',
                                                                                    callee: {
                                                                                        type: 'Identifier',
                                                                                        name: 'Div',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 97,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 97,
                                                                                                column: 27,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    arguments: [{
                                                                                            type: 'ObjectExpression',
                                                                                            properties: [{
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'class',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 97,
                                                                                                                column: 29,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 97,
                                                                                                                column: 34,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'Literal',
                                                                                                        value: 'UserTextInfo layout vertical flex padding'
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '0'
                                                                                                }]
                                                                                        }],
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 97,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 97,
                                                                                            column: 80,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                properties: [
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'ObjectExpression',
                                                                                            objectType: {
                                                                                                type: 'CallExpression',
                                                                                                callee: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'Div',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 98,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 98,
                                                                                                            column: 31,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                arguments: [{
                                                                                                        type: 'ObjectExpression',
                                                                                                        properties: [
                                                                                                            {
                                                                                                                type: 'Property',
                                                                                                                key: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'class',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 98,
                                                                                                                            column: 33,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 98,
                                                                                                                            column: 38,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                value: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: 'UserName'
                                                                                                                },
                                                                                                                kind: 'init',
                                                                                                                order: '0'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'Property',
                                                                                                                key: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'style',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 98,
                                                                                                                            column: 52,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 98,
                                                                                                                            column: 57,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                value: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: 'font-size: 30px'
                                                                                                                },
                                                                                                                kind: 'init',
                                                                                                                order: '1'
                                                                                                            }
                                                                                                        ]
                                                                                                    }],
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 98,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 98,
                                                                                                        column: 78,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            properties: [{
                                                                                                    type: 'ExpressionStatement',
                                                                                                    expression: {
                                                                                                        type: 'ConditionalExpression',
                                                                                                        test: {
                                                                                                            type: 'BinaryExpression',
                                                                                                            operator: '!=',
                                                                                                            left: {
                                                                                                                type: 'MemberExpression',
                                                                                                                computed: false,
                                                                                                                object: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'user',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 99,
                                                                                                                            column: 32,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 99,
                                                                                                                            column: 36,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                property: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'name',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 99,
                                                                                                                            column: 37,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 99,
                                                                                                                            column: 41,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 99,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 99,
                                                                                                                        column: 41,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            right: {
                                                                                                                type: 'Literal',
                                                                                                                value: null
                                                                                                            }
                                                                                                        },
                                                                                                        consequent: {
                                                                                                            type: 'MemberExpression',
                                                                                                            computed: false,
                                                                                                            object: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'user',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 99,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 99,
                                                                                                                        column: 36,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            property: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'name',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 99,
                                                                                                                        column: 37,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 99,
                                                                                                                        column: 41,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 99,
                                                                                                                    column: 32,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 99,
                                                                                                                    column: 41,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        alternate: {
                                                                                                            type: 'MemberExpression',
                                                                                                            computed: false,
                                                                                                            object: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'user',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 99,
                                                                                                                        column: 44,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 99,
                                                                                                                        column: 48,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            property: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'email',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 99,
                                                                                                                        column: 49,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 99,
                                                                                                                        column: 54,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 99,
                                                                                                                    column: 44,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 99,
                                                                                                                    column: 54,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 99,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 99,
                                                                                                            column: 54,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                        }
                                                                                                    },
                                                                                                    order: '0'
                                                                                                }]
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 98,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 100,
                                                                                                column: 32,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'ObjectExpression',
                                                                                            objectType: {
                                                                                                type: 'CallExpression',
                                                                                                callee: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'Div',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 100,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 100,
                                                                                                            column: 31,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                arguments: [],
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 100,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 100,
                                                                                                        column: 33,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            properties: [
                                                                                                {
                                                                                                    type: 'ExpressionStatement',
                                                                                                    expression: {
                                                                                                        type: 'ObjectExpression',
                                                                                                        objectType: {
                                                                                                            type: 'CallExpression',
                                                                                                            callee: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'Div',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 101,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 101,
                                                                                                                        column: 35,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            arguments: [{
                                                                                                                    type: 'ObjectExpression',
                                                                                                                    properties: [{
                                                                                                                            type: 'Property',
                                                                                                                            key: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'class',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 101,
                                                                                                                                        column: 37,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 101,
                                                                                                                                        column: 42,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            value: {
                                                                                                                                type: 'Literal',
                                                                                                                                value: 'IconItem'
                                                                                                                            },
                                                                                                                            kind: 'init',
                                                                                                                            order: '0'
                                                                                                                        }]
                                                                                                                }],
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 101,
                                                                                                                    column: 32,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 101,
                                                                                                                    column: 55,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        properties: [
                                                                                                            {
                                                                                                                type: 'ExpressionStatement',
                                                                                                                expression: {
                                                                                                                    type: 'ObjectExpression',
                                                                                                                    objectType: {
                                                                                                                        type: 'CallExpression',
                                                                                                                        callee: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'IronIcon',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 102,
                                                                                                                                    column: 36,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 102,
                                                                                                                                    column: 44,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        arguments: [],
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 102,
                                                                                                                                column: 36,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 102,
                                                                                                                                column: 46,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    properties: [{
                                                                                                                            type: 'Property',
                                                                                                                            key: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'icon',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 103,
                                                                                                                                        column: 40,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 103,
                                                                                                                                        column: 44,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            value: {
                                                                                                                                type: 'Literal',
                                                                                                                                value: 'communication:email'
                                                                                                                            },
                                                                                                                            kind: 'init',
                                                                                                                            order: '0'
                                                                                                                        }]
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 102,
                                                                                                                        column: 36,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 104,
                                                                                                                        column: 40,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                    }
                                                                                                                },
                                                                                                                order: '0'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'ExpressionStatement',
                                                                                                                expression: {
                                                                                                                    type: 'MemberExpression',
                                                                                                                    computed: false,
                                                                                                                    object: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'user',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 104,
                                                                                                                                column: 36,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 104,
                                                                                                                                column: 40,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    property: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'email',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 104,
                                                                                                                                column: 41,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 104,
                                                                                                                                column: 46,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 104,
                                                                                                                            column: 36,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 104,
                                                                                                                            column: 46,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 104,
                                                                                                                        column: 36,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 104,
                                                                                                                        column: 46,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                    }
                                                                                                                },
                                                                                                                order: '1'
                                                                                                            }
                                                                                                        ]
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 101,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 105,
                                                                                                            column: 36,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                        }
                                                                                                    },
                                                                                                    order: '0'
                                                                                                },
                                                                                                {
                                                                                                    type: 'ForInStatement',
                                                                                                    left: {
                                                                                                        type: 'VariableDeclaration',
                                                                                                        declarations: [
                                                                                                            {
                                                                                                                type: 'VariableDeclarator',
                                                                                                                id: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'name',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 105,
                                                                                                                            column: 36,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 105,
                                                                                                                            column: 40,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                init: null
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'VariableDeclarator',
                                                                                                                id: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'number',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 105,
                                                                                                                            column: 42,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 105,
                                                                                                                            column: 48,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                init: null
                                                                                                            }
                                                                                                        ],
                                                                                                        kind: 'let'
                                                                                                    },
                                                                                                    right: {
                                                                                                        type: 'ObjectExpression',
                                                                                                        properties: [
                                                                                                            {
                                                                                                                type: 'Property',
                                                                                                                key: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'Home',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 105,
                                                                                                                            column: 53,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 105,
                                                                                                                            column: 57,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                value: {
                                                                                                                    type: 'MemberExpression',
                                                                                                                    computed: false,
                                                                                                                    object: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'user',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 105,
                                                                                                                                column: 59,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 105,
                                                                                                                                column: 63,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    property: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'phoneHome',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 105,
                                                                                                                                column: 64,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 105,
                                                                                                                                column: 73,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 105,
                                                                                                                            column: 59,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 105,
                                                                                                                            column: 73,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                kind: 'init',
                                                                                                                order: '0'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'Property',
                                                                                                                key: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'Work',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 105,
                                                                                                                            column: 75,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 105,
                                                                                                                            column: 79,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                value: {
                                                                                                                    type: 'MemberExpression',
                                                                                                                    computed: false,
                                                                                                                    object: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'user',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 105,
                                                                                                                                column: 81,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 105,
                                                                                                                                column: 85,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    property: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'phoneWork',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 105,
                                                                                                                                column: 86,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 105,
                                                                                                                                column: 95,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 105,
                                                                                                                            column: 81,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 105,
                                                                                                                            column: 95,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                kind: 'init',
                                                                                                                order: '1'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'Property',
                                                                                                                key: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'Cell',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 105,
                                                                                                                            column: 97,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 105,
                                                                                                                            column: 101,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                value: {
                                                                                                                    type: 'MemberExpression',
                                                                                                                    computed: false,
                                                                                                                    object: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'user',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 105,
                                                                                                                                column: 103,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 105,
                                                                                                                                column: 107,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    property: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'phoneCell',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 105,
                                                                                                                                column: 108,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 105,
                                                                                                                                column: 117,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 105,
                                                                                                                            column: 103,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 105,
                                                                                                                            column: 117,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                kind: 'init',
                                                                                                                order: '2'
                                                                                                            }
                                                                                                        ]
                                                                                                    },
                                                                                                    body: {
                                                                                                        type: 'BlockStatement',
                                                                                                        body: [{
                                                                                                                type: 'IfStatement',
                                                                                                                test: {
                                                                                                                    type: 'BinaryExpression',
                                                                                                                    operator: '&&',
                                                                                                                    left: {
                                                                                                                        type: 'UnaryExpression',
                                                                                                                        operator: '?',
                                                                                                                        argument: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'number',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 106,
                                                                                                                                    column: 39,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 106,
                                                                                                                                    column: 45,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    right: {
                                                                                                                        type: 'BinaryExpression',
                                                                                                                        operator: '!==',
                                                                                                                        left: {
                                                                                                                            type: 'Identifier',
                                                                                                                            name: 'number',
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 106,
                                                                                                                                    column: 51,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 106,
                                                                                                                                    column: 57,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        right: {
                                                                                                                            type: 'Literal',
                                                                                                                            value: ''
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                consequent: {
                                                                                                                    type: 'BlockStatement',
                                                                                                                    body: [{
                                                                                                                            type: 'ExpressionStatement',
                                                                                                                            expression: {
                                                                                                                                type: 'ObjectExpression',
                                                                                                                                objectType: {
                                                                                                                                    type: 'CallExpression',
                                                                                                                                    callee: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'Div',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 107,
                                                                                                                                                column: 40,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 107,
                                                                                                                                                column: 43,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    arguments: [{
                                                                                                                                            type: 'ObjectExpression',
                                                                                                                                            properties: [{
                                                                                                                                                    type: 'Property',
                                                                                                                                                    key: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'class',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 107,
                                                                                                                                                                column: 45,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 107,
                                                                                                                                                                column: 50,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    value: {
                                                                                                                                                        type: 'Literal',
                                                                                                                                                        value: 'IconItem'
                                                                                                                                                    },
                                                                                                                                                    kind: 'init',
                                                                                                                                                    order: '0'
                                                                                                                                                }]
                                                                                                                                        }],
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 107,
                                                                                                                                            column: 40,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 107,
                                                                                                                                            column: 63,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                properties: [
                                                                                                                                    {
                                                                                                                                        type: 'ExpressionStatement',
                                                                                                                                        expression: {
                                                                                                                                            type: 'ObjectExpression',
                                                                                                                                            objectType: {
                                                                                                                                                type: 'CallExpression',
                                                                                                                                                callee: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'IronIcon',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 108,
                                                                                                                                                            column: 44,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 108,
                                                                                                                                                            column: 52,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                arguments: [],
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 108,
                                                                                                                                                        column: 44,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 108,
                                                                                                                                                        column: 54,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            properties: [{
                                                                                                                                                    type: 'Property',
                                                                                                                                                    key: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'icon',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 109,
                                                                                                                                                                column: 48,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 109,
                                                                                                                                                                column: 52,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    value: {
                                                                                                                                                        type: 'Literal',
                                                                                                                                                        value: 'communication:phone'
                                                                                                                                                    },
                                                                                                                                                    kind: 'init',
                                                                                                                                                    order: '0'
                                                                                                                                                }]
                                                                                                                                        },
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 108,
                                                                                                                                                column: 44,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 110,
                                                                                                                                                column: 48,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        order: '0'
                                                                                                                                    },
                                                                                                                                    {
                                                                                                                                        type: 'ExpressionStatement',
                                                                                                                                        expression: {
                                                                                                                                            type: 'BinaryExpression',
                                                                                                                                            operator: '+',
                                                                                                                                            left: {
                                                                                                                                                type: 'BinaryExpression',
                                                                                                                                                operator: '+',
                                                                                                                                                left: {
                                                                                                                                                    type: 'Identifier',
                                                                                                                                                    name: 'name',
                                                                                                                                                    loc: {
                                                                                                                                                        start: {
                                                                                                                                                            line: 110,
                                                                                                                                                            column: 44,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                                        },
                                                                                                                                                        end: {
                                                                                                                                                            line: 110,
                                                                                                                                                            column: 48,
                                                                                                                                                            fixed: true,
                                                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                },
                                                                                                                                                right: {
                                                                                                                                                    type: 'Literal',
                                                                                                                                                    value: ': '
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            right: {
                                                                                                                                                type: 'Identifier',
                                                                                                                                                name: 'number',
                                                                                                                                                loc: {
                                                                                                                                                    start: {
                                                                                                                                                        line: 110,
                                                                                                                                                        column: 58,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                                    },
                                                                                                                                                    end: {
                                                                                                                                                        line: 110,
                                                                                                                                                        column: 64,
                                                                                                                                                        fixed: true,
                                                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 110,
                                                                                                                                                column: 44,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 110,
                                                                                                                                                column: 64,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        order: '1'
                                                                                                                                    }
                                                                                                                                ]
                                                                                                                            },
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 107,
                                                                                                                                    column: 40,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 111,
                                                                                                                                    column: 44,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                }
                                                                                                                            },
                                                                                                                            order: '0'
                                                                                                                        }]
                                                                                                                },
                                                                                                                alternate: null,
                                                                                                                order: '0'
                                                                                                            }]
                                                                                                    },
                                                                                                    remove: null,
                                                                                                    order: '1'
                                                                                                }
                                                                                            ]
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 100,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 111,
                                                                                                column: 32,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '1'
                                                                                    }
                                                                                ]
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 97,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 111,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                }
                                                                            },
                                                                            order: '1'
                                                                        },
                                                                        {
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'ObjectExpression',
                                                                                objectType: {
                                                                                    type: 'CallExpression',
                                                                                    callee: {
                                                                                        type: 'Identifier',
                                                                                        name: 'PaperIconButton',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 111,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 111,
                                                                                                column: 39,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    arguments: [{
                                                                                            type: 'ObjectExpression',
                                                                                            properties: [{
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'class',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 111,
                                                                                                                column: 41,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 111,
                                                                                                                column: 46,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'Literal',
                                                                                                        value: 'hoverIcon'
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '0'
                                                                                                }]
                                                                                        }],
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 111,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 111,
                                                                                            column: 61,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                properties: [
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'Function',
                                                                                            context: true,
                                                                                            value: function (_context4) {
                                                                                                return function click() {
                                                                                                    var Dialog = _context4.get('Dialog'), editUserDialog = _context4.get('editUserDialog'), user = _context4.get('user');
                                                                                                    return Dialog.show(editUserDialog, user);
                                                                                                };
                                                                                            }
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 112,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 112,
                                                                                                column: 72,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'Property',
                                                                                        key: {
                                                                                            type: 'Identifier',
                                                                                            name: 'icon',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 113,
                                                                                                    column: 28,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 113,
                                                                                                    column: 32,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        value: {
                                                                                            type: 'Literal',
                                                                                            value: 'create'
                                                                                        },
                                                                                        kind: 'init',
                                                                                        order: '1'
                                                                                    }
                                                                                ]
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 111,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 115,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                }
                                                                            },
                                                                            order: '2'
                                                                        }
                                                                    ]
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 94,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 115,
                                                                        column: 24,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    }
                                                                },
                                                                order: '0'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'Identifier',
                                                                        name: 'Div',
                                                                        loc: {
                                                                            start: {
                                                                                line: 115,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 115,
                                                                                column: 23,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [{
                                                                            type: 'ObjectExpression',
                                                                            properties: [{
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'class',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 115,
                                                                                                column: 25,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 115,
                                                                                                column: 30,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Literal',
                                                                                        value: 'fill'
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                }]
                                                                        }],
                                                                    loc: {
                                                                        start: {
                                                                            line: 115,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 115,
                                                                            column: 40,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 115,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 115,
                                                                        column: 40,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    }
                                                                },
                                                                order: '1'
                                                            },
                                                            {
                                                                type: 'IfStatement',
                                                                test: {
                                                                    type: 'UnaryExpression',
                                                                    operator: '?',
                                                                    argument: {
                                                                        type: 'Identifier',
                                                                        name: 'product',
                                                                        loc: {
                                                                            start: {
                                                                                line: 118,
                                                                                column: 23,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 118,
                                                                                column: 30,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                            }
                                                                        }
                                                                    }
                                                                },
                                                                consequent: {
                                                                    type: 'BlockStatement',
                                                                    body: [{
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'ObjectExpression',
                                                                                objectType: {
                                                                                    type: 'CallExpression',
                                                                                    callee: {
                                                                                        type: 'Identifier',
                                                                                        name: 'Div',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 119,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 119,
                                                                                                column: 27,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    arguments: [{
                                                                                            type: 'ObjectExpression',
                                                                                            properties: [{
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'class',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 119,
                                                                                                                column: 29,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 119,
                                                                                                                column: 34,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'Literal',
                                                                                                        value: 'padding layout start-justified start vertical'
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '0'
                                                                                                }]
                                                                                        }],
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 119,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 119,
                                                                                            column: 85,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                properties: [
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'ObjectExpression',
                                                                                            objectType: {
                                                                                                type: 'CallExpression',
                                                                                                callee: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'Div',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 120,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 120,
                                                                                                            column: 31,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                arguments: [{
                                                                                                        type: 'ObjectExpression',
                                                                                                        properties: [{
                                                                                                                type: 'Property',
                                                                                                                key: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'style',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 120,
                                                                                                                            column: 33,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 120,
                                                                                                                            column: 38,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                value: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: 'font-size: 30px'
                                                                                                                },
                                                                                                                kind: 'init',
                                                                                                                order: '0'
                                                                                                            }]
                                                                                                    }],
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 120,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 120,
                                                                                                        column: 59,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            properties: [
                                                                                                {
                                                                                                    type: 'ExpressionStatement',
                                                                                                    expression: {
                                                                                                        type: 'BinaryExpression',
                                                                                                        operator: '+',
                                                                                                        left: {
                                                                                                            type: 'MemberExpression',
                                                                                                            computed: false,
                                                                                                            object: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'product',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 121,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 121,
                                                                                                                        column: 39,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            property: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'name',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 121,
                                                                                                                        column: 40,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 121,
                                                                                                                        column: 44,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 121,
                                                                                                                    column: 32,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 121,
                                                                                                                    column: 44,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        right: {
                                                                                                            type: 'Literal',
                                                                                                            value: ' Edition'
                                                                                                        }
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 121,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 121,
                                                                                                            column: 57,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                        }
                                                                                                    },
                                                                                                    order: '0'
                                                                                                },
                                                                                                {
                                                                                                    type: 'IfStatement',
                                                                                                    test: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'isViewerProvider',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 122,
                                                                                                                column: 35,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 122,
                                                                                                                column: 51,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    consequent: {
                                                                                                        type: 'BlockStatement',
                                                                                                        body: [
                                                                                                            {
                                                                                                                type: 'Property',
                                                                                                                key: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'classList',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 123,
                                                                                                                            column: 36,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 123,
                                                                                                                            column: 45,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                value: {
                                                                                                                    type: 'ArrayExpression',
                                                                                                                    elements: [{
                                                                                                                            type: 'Literal',
                                                                                                                            value: 'link'
                                                                                                                        }]
                                                                                                                },
                                                                                                                kind: 'init',
                                                                                                                order: '0'
                                                                                                            },
                                                                                                            {
                                                                                                                type: 'ExpressionStatement',
                                                                                                                expression: {
                                                                                                                    type: 'Function',
                                                                                                                    context: true,
                                                                                                                    value: function (_context5) {
                                                                                                                        return function click() {
                                                                                                                            var subscription = _context5.get('subscription');
                                                                                                                            global.model.open({ id: 'Subscriptions' });
                                                                                                                            global.model.open(subscription.paneConfig, { target: 'dialog' });
                                                                                                                        };
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 124,
                                                                                                                        column: 36,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 127,
                                                                                                                        column: 40,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                    }
                                                                                                                },
                                                                                                                order: '1'
                                                                                                            }
                                                                                                        ]
                                                                                                    },
                                                                                                    alternate: null,
                                                                                                    order: '1'
                                                                                                }
                                                                                            ]
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 120,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 127,
                                                                                                column: 32,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'IfStatement',
                                                                                        test: {
                                                                                            type: 'BinaryExpression',
                                                                                            operator: '&&',
                                                                                            left: {
                                                                                                type: 'UnaryExpression',
                                                                                                operator: '?',
                                                                                                argument: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'subscription',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 127,
                                                                                                            column: 31,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 127,
                                                                                                            column: 43,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            right: {
                                                                                                type: 'UnaryExpression',
                                                                                                operator: '!',
                                                                                                argument: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'isViewerProvider',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 127,
                                                                                                            column: 53,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 127,
                                                                                                            column: 69,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        consequent: {
                                                                                            type: 'BlockStatement',
                                                                                            body: [{
                                                                                                    type: 'ExpressionStatement',
                                                                                                    expression: {
                                                                                                        type: 'ObjectExpression',
                                                                                                        objectType: {
                                                                                                            type: 'CallExpression',
                                                                                                            callee: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'Div',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 128,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 128,
                                                                                                                        column: 35,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            arguments: [],
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 128,
                                                                                                                    column: 32,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 128,
                                                                                                                    column: 37,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        properties: [{
                                                                                                                type: 'ExpressionStatement',
                                                                                                                expression: {
                                                                                                                    type: 'BinaryExpression',
                                                                                                                    operator: '+',
                                                                                                                    left: {
                                                                                                                        type: 'Literal',
                                                                                                                        value: 'Managed by: '
                                                                                                                    },
                                                                                                                    right: {
                                                                                                                        type: 'MemberExpression',
                                                                                                                        computed: true,
                                                                                                                        object: {
                                                                                                                            type: 'CallExpression',
                                                                                                                            callee: {
                                                                                                                                type: 'MemberExpression',
                                                                                                                                computed: false,
                                                                                                                                object: {
                                                                                                                                    type: 'MemberExpression',
                                                                                                                                    computed: false,
                                                                                                                                    object: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'subscription',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 129,
                                                                                                                                                column: 53,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 129,
                                                                                                                                                column: 65,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    property: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'createdBy',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 129,
                                                                                                                                                column: 66,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 129,
                                                                                                                                                column: 75,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 129,
                                                                                                                                            column: 53,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 129,
                                                                                                                                            column: 75,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                property: {
                                                                                                                                    type: 'Identifier',
                                                                                                                                    name: 'split',
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 129,
                                                                                                                                            column: 76,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 129,
                                                                                                                                            column: 81,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 129,
                                                                                                                                        column: 53,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 129,
                                                                                                                                        column: 81,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            arguments: [{
                                                                                                                                    type: 'Literal',
                                                                                                                                    value: '/'
                                                                                                                                }],
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 129,
                                                                                                                                    column: 53,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 129,
                                                                                                                                    column: 86,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        property: {
                                                                                                                            type: 'Literal',
                                                                                                                            value: 1
                                                                                                                        },
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 129,
                                                                                                                                column: 53,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 129,
                                                                                                                                column: 89,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 129,
                                                                                                                        column: 36,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 129,
                                                                                                                        column: 89,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                    }
                                                                                                                },
                                                                                                                order: '0'
                                                                                                            }]
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 128,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 130,
                                                                                                            column: 36,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                        }
                                                                                                    },
                                                                                                    order: '0'
                                                                                                }]
                                                                                        },
                                                                                        alternate: null,
                                                                                        order: '1'
                                                                                    },
                                                                                    {
                                                                                        type: 'IfStatement',
                                                                                        test: {
                                                                                            type: 'UnaryExpression',
                                                                                            operator: '!',
                                                                                            argument: {
                                                                                                type: 'UnaryExpression',
                                                                                                operator: '?',
                                                                                                argument: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'subscription',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 130,
                                                                                                            column: 35,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 130,
                                                                                                            column: 47,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        consequent: {
                                                                                            type: 'BlockStatement',
                                                                                            body: [{
                                                                                                    type: 'ExpressionStatement',
                                                                                                    expression: {
                                                                                                        type: 'ObjectExpression',
                                                                                                        objectType: {
                                                                                                            type: 'CallExpression',
                                                                                                            callee: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'Div',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 131,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 131,
                                                                                                                        column: 35,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            arguments: [],
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 131,
                                                                                                                    column: 32,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 131,
                                                                                                                    column: 37,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        properties: [{
                                                                                                                type: 'ExpressionStatement',
                                                                                                                expression: {
                                                                                                                    type: 'BinaryExpression',
                                                                                                                    operator: '+',
                                                                                                                    left: {
                                                                                                                        type: 'Literal',
                                                                                                                        value: 'Trial Ends: '
                                                                                                                    },
                                                                                                                    right: {
                                                                                                                        type: 'CallExpression',
                                                                                                                        callee: {
                                                                                                                            type: 'MemberExpression',
                                                                                                                            computed: false,
                                                                                                                            object: {
                                                                                                                                type: 'CallExpression',
                                                                                                                                callee: {
                                                                                                                                    type: 'MemberExpression',
                                                                                                                                    computed: false,
                                                                                                                                    object: {
                                                                                                                                        type: 'MemberExpression',
                                                                                                                                        computed: false,
                                                                                                                                        object: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'user',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 132,
                                                                                                                                                    column: 54,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 132,
                                                                                                                                                    column: 58,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        property: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'TrialEnd',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 132,
                                                                                                                                                    column: 59,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 132,
                                                                                                                                                    column: 67,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 132,
                                                                                                                                                column: 54,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 132,
                                                                                                                                                column: 67,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    property: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'withoutTime',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 132,
                                                                                                                                                column: 68,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 132,
                                                                                                                                                column: 79,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 132,
                                                                                                                                            column: 54,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 132,
                                                                                                                                            column: 79,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                arguments: [],
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 132,
                                                                                                                                        column: 54,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 132,
                                                                                                                                        column: 81,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            property: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'format',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 132,
                                                                                                                                        column: 82,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 132,
                                                                                                                                        column: 88,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 132,
                                                                                                                                    column: 54,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 132,
                                                                                                                                    column: 88,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        arguments: [],
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 132,
                                                                                                                                column: 54,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 132,
                                                                                                                                column: 90,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 132,
                                                                                                                        column: 36,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 132,
                                                                                                                        column: 90,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                    }
                                                                                                                },
                                                                                                                order: '0'
                                                                                                            }]
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 131,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 133,
                                                                                                            column: 36,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                        }
                                                                                                    },
                                                                                                    order: '0'
                                                                                                }]
                                                                                        },
                                                                                        alternate: null,
                                                                                        order: '2'
                                                                                    },
                                                                                    {
                                                                                        type: 'IfStatement',
                                                                                        test: {
                                                                                            type: 'UnaryExpression',
                                                                                            operator: '?',
                                                                                            argument: {
                                                                                                type: 'MemberExpression',
                                                                                                computed: false,
                                                                                                object: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'subscription',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 133,
                                                                                                            column: 31,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 133,
                                                                                                            column: 43,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                property: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'Expires',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 133,
                                                                                                            column: 45,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 133,
                                                                                                            column: 52,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                existential: true,
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 133,
                                                                                                        column: 31,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 133,
                                                                                                        column: 52,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        consequent: {
                                                                                            type: 'BlockStatement',
                                                                                            body: [{
                                                                                                    type: 'ExpressionStatement',
                                                                                                    expression: {
                                                                                                        type: 'ObjectExpression',
                                                                                                        objectType: {
                                                                                                            type: 'CallExpression',
                                                                                                            callee: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'Div',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 134,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 134,
                                                                                                                        column: 35,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            arguments: [],
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 134,
                                                                                                                    column: 32,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 134,
                                                                                                                    column: 37,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        properties: [{
                                                                                                                type: 'ExpressionStatement',
                                                                                                                expression: {
                                                                                                                    type: 'BinaryExpression',
                                                                                                                    operator: '+',
                                                                                                                    left: {
                                                                                                                        type: 'Literal',
                                                                                                                        value: 'Expires: '
                                                                                                                    },
                                                                                                                    right: {
                                                                                                                        type: 'CallExpression',
                                                                                                                        callee: {
                                                                                                                            type: 'MemberExpression',
                                                                                                                            computed: false,
                                                                                                                            object: {
                                                                                                                                type: 'CallExpression',
                                                                                                                                callee: {
                                                                                                                                    type: 'MemberExpression',
                                                                                                                                    computed: false,
                                                                                                                                    object: {
                                                                                                                                        type: 'MemberExpression',
                                                                                                                                        computed: false,
                                                                                                                                        object: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'subscription',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 135,
                                                                                                                                                    column: 51,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 135,
                                                                                                                                                    column: 63,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        property: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'Expires',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 135,
                                                                                                                                                    column: 64,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 135,
                                                                                                                                                    column: 71,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 135,
                                                                                                                                                column: 51,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 135,
                                                                                                                                                column: 71,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    property: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'withoutTime',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 135,
                                                                                                                                                column: 72,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 135,
                                                                                                                                                column: 83,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 135,
                                                                                                                                            column: 51,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 135,
                                                                                                                                            column: 83,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                arguments: [],
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 135,
                                                                                                                                        column: 51,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 135,
                                                                                                                                        column: 85,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            property: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'format',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 135,
                                                                                                                                        column: 86,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 135,
                                                                                                                                        column: 92,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 135,
                                                                                                                                    column: 51,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 135,
                                                                                                                                    column: 92,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        },
                                                                                                                        arguments: [],
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 135,
                                                                                                                                column: 51,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 135,
                                                                                                                                column: 94,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 135,
                                                                                                                        column: 36,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 135,
                                                                                                                        column: 94,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                    }
                                                                                                                },
                                                                                                                order: '0'
                                                                                                            }]
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 134,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 136,
                                                                                                            column: 36,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                        }
                                                                                                    },
                                                                                                    order: '0'
                                                                                                }]
                                                                                        },
                                                                                        alternate: null,
                                                                                        order: '3'
                                                                                    }
                                                                                ]
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 119,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 136,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                alternate: {
                                                                    type: 'BlockStatement',
                                                                    body: [{
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'ObjectExpression',
                                                                                objectType: {
                                                                                    type: 'CallExpression',
                                                                                    callee: {
                                                                                        type: 'Identifier',
                                                                                        name: 'Div',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 137,
                                                                                                column: 24,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 137,
                                                                                                column: 27,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    arguments: [{
                                                                                            type: 'ObjectExpression',
                                                                                            properties: [{
                                                                                                    type: 'Property',
                                                                                                    key: {
                                                                                                        type: 'Identifier',
                                                                                                        name: 'class',
                                                                                                        loc: {
                                                                                                            start: {
                                                                                                                line: 137,
                                                                                                                column: 29,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                            },
                                                                                                            end: {
                                                                                                                line: 137,
                                                                                                                column: 34,
                                                                                                                fixed: true,
                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                            }
                                                                                                        }
                                                                                                    },
                                                                                                    value: {
                                                                                                        type: 'Literal',
                                                                                                        value: 'padding'
                                                                                                    },
                                                                                                    kind: 'init',
                                                                                                    order: '0'
                                                                                                }]
                                                                                        }],
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 137,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 137,
                                                                                            column: 47,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                properties: [
                                                                                    {
                                                                                        type: 'ExpressionStatement',
                                                                                        expression: {
                                                                                            type: 'ObjectExpression',
                                                                                            objectType: {
                                                                                                type: 'CallExpression',
                                                                                                callee: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'Div',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 138,
                                                                                                            column: 28,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 138,
                                                                                                            column: 31,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                arguments: [{
                                                                                                        type: 'ObjectExpression',
                                                                                                        properties: [{
                                                                                                                type: 'Property',
                                                                                                                key: {
                                                                                                                    type: 'Identifier',
                                                                                                                    name: 'style',
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 138,
                                                                                                                            column: 33,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 138,
                                                                                                                            column: 38,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                value: {
                                                                                                                    type: 'Literal',
                                                                                                                    value: 'font-size: 30px'
                                                                                                                },
                                                                                                                kind: 'init',
                                                                                                                order: '0'
                                                                                                            }]
                                                                                                    }],
                                                                                                loc: {
                                                                                                    start: {
                                                                                                        line: 138,
                                                                                                        column: 28,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                    },
                                                                                                    end: {
                                                                                                        line: 138,
                                                                                                        column: 59,
                                                                                                        fixed: true,
                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                    }
                                                                                                }
                                                                                            },
                                                                                            properties: [{
                                                                                                    type: 'ExpressionStatement',
                                                                                                    expression: {
                                                                                                        type: 'Literal',
                                                                                                        value: 'Free Collaborator'
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 139,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 139,
                                                                                                            column: 51,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                        }
                                                                                                    },
                                                                                                    order: '0'
                                                                                                }]
                                                                                        },
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 138,
                                                                                                column: 28,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 140,
                                                                                                column: 32,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                            }
                                                                                        },
                                                                                        order: '0'
                                                                                    },
                                                                                    {
                                                                                        type: 'IfStatement',
                                                                                        test: {
                                                                                            type: 'Identifier',
                                                                                            name: 'isViewingSelf',
                                                                                            loc: {
                                                                                                start: {
                                                                                                    line: 140,
                                                                                                    column: 31,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                },
                                                                                                end: {
                                                                                                    line: 140,
                                                                                                    column: 44,
                                                                                                    fixed: true,
                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                }
                                                                                            }
                                                                                        },
                                                                                        consequent: {
                                                                                            type: 'BlockStatement',
                                                                                            body: [{
                                                                                                    type: 'ExpressionStatement',
                                                                                                    expression: {
                                                                                                        type: 'ObjectExpression',
                                                                                                        objectType: {
                                                                                                            type: 'CallExpression',
                                                                                                            callee: {
                                                                                                                type: 'Identifier',
                                                                                                                name: 'Div',
                                                                                                                loc: {
                                                                                                                    start: {
                                                                                                                        line: 141,
                                                                                                                        column: 32,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                    },
                                                                                                                    end: {
                                                                                                                        line: 141,
                                                                                                                        column: 35,
                                                                                                                        fixed: true,
                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                    }
                                                                                                                }
                                                                                                            },
                                                                                                            arguments: [],
                                                                                                            loc: {
                                                                                                                start: {
                                                                                                                    line: 141,
                                                                                                                    column: 32,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                },
                                                                                                                end: {
                                                                                                                    line: 141,
                                                                                                                    column: 37,
                                                                                                                    fixed: true,
                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                }
                                                                                                            }
                                                                                                        },
                                                                                                        properties: [{
                                                                                                                type: 'IfStatement',
                                                                                                                test: {
                                                                                                                    type: 'MemberExpression',
                                                                                                                    computed: false,
                                                                                                                    object: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'user',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 142,
                                                                                                                                column: 39,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 142,
                                                                                                                                column: 43,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    property: {
                                                                                                                        type: 'Identifier',
                                                                                                                        name: 'ExceededTrial',
                                                                                                                        loc: {
                                                                                                                            start: {
                                                                                                                                line: 142,
                                                                                                                                column: 44,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                            },
                                                                                                                            end: {
                                                                                                                                line: 142,
                                                                                                                                column: 57,
                                                                                                                                fixed: true,
                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    loc: {
                                                                                                                        start: {
                                                                                                                            line: 142,
                                                                                                                            column: 39,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                        },
                                                                                                                        end: {
                                                                                                                            line: 142,
                                                                                                                            column: 57,
                                                                                                                            fixed: true,
                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                        }
                                                                                                                    }
                                                                                                                },
                                                                                                                consequent: {
                                                                                                                    type: 'BlockStatement',
                                                                                                                    body: [
                                                                                                                        {
                                                                                                                            type: 'ExpressionStatement',
                                                                                                                            expression: {
                                                                                                                                type: 'ObjectExpression',
                                                                                                                                objectType: {
                                                                                                                                    type: 'CallExpression',
                                                                                                                                    callee: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'Span',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 143,
                                                                                                                                                column: 40,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 143,
                                                                                                                                                column: 44,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    arguments: [],
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 143,
                                                                                                                                            column: 40,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 143,
                                                                                                                                            column: 46,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                properties: [{
                                                                                                                                        type: 'ExpressionStatement',
                                                                                                                                        expression: {
                                                                                                                                            type: 'Literal',
                                                                                                                                            value: 'Your free trial has expired. Click '
                                                                                                                                        },
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 144,
                                                                                                                                                column: 44,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 144,
                                                                                                                                                column: 81,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        order: '0'
                                                                                                                                    }]
                                                                                                                            },
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 143,
                                                                                                                                    column: 40,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 145,
                                                                                                                                    column: 44,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                }
                                                                                                                            },
                                                                                                                            order: '0'
                                                                                                                        },
                                                                                                                        {
                                                                                                                            type: 'ExpressionStatement',
                                                                                                                            expression: {
                                                                                                                                type: 'ObjectExpression',
                                                                                                                                objectType: {
                                                                                                                                    type: 'CallExpression',
                                                                                                                                    callee: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'Span',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 145,
                                                                                                                                                column: 40,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 145,
                                                                                                                                                column: 44,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    arguments: [{
                                                                                                                                            type: 'ObjectExpression',
                                                                                                                                            properties: [{
                                                                                                                                                    type: 'Property',
                                                                                                                                                    key: {
                                                                                                                                                        type: 'Identifier',
                                                                                                                                                        name: 'class',
                                                                                                                                                        loc: {
                                                                                                                                                            start: {
                                                                                                                                                                line: 145,
                                                                                                                                                                column: 46,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                                            },
                                                                                                                                                            end: {
                                                                                                                                                                line: 145,
                                                                                                                                                                column: 51,
                                                                                                                                                                fixed: true,
                                                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                                            }
                                                                                                                                                        }
                                                                                                                                                    },
                                                                                                                                                    value: {
                                                                                                                                                        type: 'Literal',
                                                                                                                                                        value: 'link'
                                                                                                                                                    },
                                                                                                                                                    kind: 'init',
                                                                                                                                                    order: '0'
                                                                                                                                                }]
                                                                                                                                        }],
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 145,
                                                                                                                                            column: 40,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 145,
                                                                                                                                            column: 61,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                properties: [
                                                                                                                                    {
                                                                                                                                        type: 'ExpressionStatement',
                                                                                                                                        expression: {
                                                                                                                                            type: 'Function',
                                                                                                                                            context: false,
                                                                                                                                            value: function click() {
                                                                                                                                                return global.model.open({ id: 'Subscriptions' });
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 146,
                                                                                                                                                column: 44,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 146,
                                                                                                                                                column: 95,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        order: '0'
                                                                                                                                    },
                                                                                                                                    {
                                                                                                                                        type: 'ExpressionStatement',
                                                                                                                                        expression: {
                                                                                                                                            type: 'Literal',
                                                                                                                                            value: 'here'
                                                                                                                                        },
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 147,
                                                                                                                                                column: 44,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 147,
                                                                                                                                                column: 50,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        order: '1'
                                                                                                                                    }
                                                                                                                                ]
                                                                                                                            },
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 145,
                                                                                                                                    column: 40,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 148,
                                                                                                                                    column: 44,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                }
                                                                                                                            },
                                                                                                                            order: '1'
                                                                                                                        },
                                                                                                                        {
                                                                                                                            type: 'ExpressionStatement',
                                                                                                                            expression: {
                                                                                                                                type: 'ObjectExpression',
                                                                                                                                objectType: {
                                                                                                                                    type: 'CallExpression',
                                                                                                                                    callee: {
                                                                                                                                        type: 'Identifier',
                                                                                                                                        name: 'Span',
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 148,
                                                                                                                                                column: 40,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 148,
                                                                                                                                                column: 44,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    arguments: [],
                                                                                                                                    loc: {
                                                                                                                                        start: {
                                                                                                                                            line: 148,
                                                                                                                                            column: 40,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                        },
                                                                                                                                        end: {
                                                                                                                                            line: 148,
                                                                                                                                            column: 46,
                                                                                                                                            fixed: true,
                                                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                properties: [{
                                                                                                                                        type: 'ExpressionStatement',
                                                                                                                                        expression: {
                                                                                                                                            type: 'Literal',
                                                                                                                                            value: ' to subscribe.'
                                                                                                                                        },
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 149,
                                                                                                                                                column: 44,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 149,
                                                                                                                                                column: 60,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        order: '0'
                                                                                                                                    }]
                                                                                                                            },
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 148,
                                                                                                                                    column: 40,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 150,
                                                                                                                                    column: 44,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                }
                                                                                                                            },
                                                                                                                            order: '2'
                                                                                                                        }
                                                                                                                    ]
                                                                                                                },
                                                                                                                alternate: {
                                                                                                                    type: 'IfStatement',
                                                                                                                    test: {
                                                                                                                        type: 'UnaryExpression',
                                                                                                                        operator: '!',
                                                                                                                        argument: {
                                                                                                                            type: 'MemberExpression',
                                                                                                                            computed: false,
                                                                                                                            object: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'user',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 150,
                                                                                                                                        column: 48,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 150,
                                                                                                                                        column: 52,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            property: {
                                                                                                                                type: 'Identifier',
                                                                                                                                name: 'InTrial',
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 150,
                                                                                                                                        column: 53,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 150,
                                                                                                                                        column: 60,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            },
                                                                                                                            loc: {
                                                                                                                                start: {
                                                                                                                                    line: 150,
                                                                                                                                    column: 48,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                },
                                                                                                                                end: {
                                                                                                                                    line: 150,
                                                                                                                                    column: 60,
                                                                                                                                    fixed: true,
                                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                }
                                                                                                                            }
                                                                                                                        }
                                                                                                                    },
                                                                                                                    consequent: {
                                                                                                                        type: 'BlockStatement',
                                                                                                                        body: [
                                                                                                                            {
                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                expression: {
                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                    objectType: {
                                                                                                                                        type: 'CallExpression',
                                                                                                                                        callee: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'Span',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 151,
                                                                                                                                                    column: 40,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 151,
                                                                                                                                                    column: 44,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        arguments: [],
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 151,
                                                                                                                                                column: 40,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 151,
                                                                                                                                                column: 46,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    properties: [{
                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                            expression: {
                                                                                                                                                type: 'Literal',
                                                                                                                                                value: 'Click '
                                                                                                                                            },
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 152,
                                                                                                                                                    column: 44,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 152,
                                                                                                                                                    column: 52,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            order: '0'
                                                                                                                                        }]
                                                                                                                                },
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 151,
                                                                                                                                        column: 40,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 153,
                                                                                                                                        column: 44,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                order: '0'
                                                                                                                            },
                                                                                                                            {
                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                expression: {
                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                    objectType: {
                                                                                                                                        type: 'CallExpression',
                                                                                                                                        callee: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'Span',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 153,
                                                                                                                                                    column: 40,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 153,
                                                                                                                                                    column: 44,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        arguments: [{
                                                                                                                                                type: 'ObjectExpression',
                                                                                                                                                properties: [{
                                                                                                                                                        type: 'Property',
                                                                                                                                                        key: {
                                                                                                                                                            type: 'Identifier',
                                                                                                                                                            name: 'class',
                                                                                                                                                            loc: {
                                                                                                                                                                start: {
                                                                                                                                                                    line: 153,
                                                                                                                                                                    column: 46,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                                                },
                                                                                                                                                                end: {
                                                                                                                                                                    line: 153,
                                                                                                                                                                    column: 51,
                                                                                                                                                                    fixed: true,
                                                                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                        },
                                                                                                                                                        value: {
                                                                                                                                                            type: 'Literal',
                                                                                                                                                            value: 'link'
                                                                                                                                                        },
                                                                                                                                                        kind: 'init',
                                                                                                                                                        order: '0'
                                                                                                                                                    }]
                                                                                                                                            }],
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 153,
                                                                                                                                                column: 40,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 153,
                                                                                                                                                column: 61,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    properties: [
                                                                                                                                        {
                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                            expression: {
                                                                                                                                                type: 'Function',
                                                                                                                                                context: false,
                                                                                                                                                value: function click() {
                                                                                                                                                    return model.startTrial();
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 154,
                                                                                                                                                    column: 44,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 154,
                                                                                                                                                    column: 73,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            order: '0'
                                                                                                                                        },
                                                                                                                                        {
                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                            expression: {
                                                                                                                                                type: 'Literal',
                                                                                                                                                value: 'here'
                                                                                                                                            },
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 155,
                                                                                                                                                    column: 44,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 155,
                                                                                                                                                    column: 50,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            order: '1'
                                                                                                                                        }
                                                                                                                                    ]
                                                                                                                                },
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 153,
                                                                                                                                        column: 40,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 156,
                                                                                                                                        column: 44,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                order: '1'
                                                                                                                            },
                                                                                                                            {
                                                                                                                                type: 'ExpressionStatement',
                                                                                                                                expression: {
                                                                                                                                    type: 'ObjectExpression',
                                                                                                                                    objectType: {
                                                                                                                                        type: 'CallExpression',
                                                                                                                                        callee: {
                                                                                                                                            type: 'Identifier',
                                                                                                                                            name: 'Span',
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 156,
                                                                                                                                                    column: 40,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 156,
                                                                                                                                                    column: 44,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        },
                                                                                                                                        arguments: [],
                                                                                                                                        loc: {
                                                                                                                                            start: {
                                                                                                                                                line: 156,
                                                                                                                                                column: 40,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                            },
                                                                                                                                            end: {
                                                                                                                                                line: 156,
                                                                                                                                                column: 46,
                                                                                                                                                fixed: true,
                                                                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    },
                                                                                                                                    properties: [{
                                                                                                                                            type: 'ExpressionStatement',
                                                                                                                                            expression: {
                                                                                                                                                type: 'Literal',
                                                                                                                                                value: ' to start your 30 day free trial.'
                                                                                                                                            },
                                                                                                                                            loc: {
                                                                                                                                                start: {
                                                                                                                                                    line: 157,
                                                                                                                                                    column: 44,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                                },
                                                                                                                                                end: {
                                                                                                                                                    line: 157,
                                                                                                                                                    column: 79,
                                                                                                                                                    fixed: true,
                                                                                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                                }
                                                                                                                                            },
                                                                                                                                            order: '0'
                                                                                                                                        }]
                                                                                                                                },
                                                                                                                                loc: {
                                                                                                                                    start: {
                                                                                                                                        line: 156,
                                                                                                                                        column: 40,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                    },
                                                                                                                                    end: {
                                                                                                                                        line: 159,
                                                                                                                                        column: 44,
                                                                                                                                        fixed: true,
                                                                                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                                                                                    }
                                                                                                                                },
                                                                                                                                order: '2'
                                                                                                                            }
                                                                                                                        ]
                                                                                                                    },
                                                                                                                    alternate: null
                                                                                                                },
                                                                                                                order: '0'
                                                                                                            }]
                                                                                                    },
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 141,
                                                                                                            column: 32,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 159,
                                                                                                            column: 36,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                                                        }
                                                                                                    },
                                                                                                    order: '0'
                                                                                                }]
                                                                                        },
                                                                                        alternate: null,
                                                                                        order: '1'
                                                                                    }
                                                                                ]
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 137,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 159,
                                                                                    column: 28,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                order: '2'
                                                            },
                                                            {
                                                                type: 'ExpressionStatement',
                                                                expression: {
                                                                    type: 'CallExpression',
                                                                    callee: {
                                                                        type: 'Identifier',
                                                                        name: 'Div',
                                                                        loc: {
                                                                            start: {
                                                                                line: 159,
                                                                                column: 20,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                            },
                                                                            end: {
                                                                                line: 159,
                                                                                column: 23,
                                                                                fixed: true,
                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                            }
                                                                        }
                                                                    },
                                                                    arguments: [{
                                                                            type: 'ObjectExpression',
                                                                            properties: [{
                                                                                    type: 'Property',
                                                                                    key: {
                                                                                        type: 'Identifier',
                                                                                        name: 'class',
                                                                                        loc: {
                                                                                            start: {
                                                                                                line: 159,
                                                                                                column: 25,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                            },
                                                                                            end: {
                                                                                                line: 159,
                                                                                                column: 30,
                                                                                                fixed: true,
                                                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                                                            }
                                                                                        }
                                                                                    },
                                                                                    value: {
                                                                                        type: 'Literal',
                                                                                        value: 'fill'
                                                                                    },
                                                                                    kind: 'init',
                                                                                    order: '0'
                                                                                }]
                                                                        }],
                                                                    loc: {
                                                                        start: {
                                                                            line: 159,
                                                                            column: 20,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                        },
                                                                        end: {
                                                                            line: 159,
                                                                            column: 40,
                                                                            fixed: true,
                                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 159,
                                                                        column: 20,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 159,
                                                                        column: 40,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    }
                                                                },
                                                                order: '3'
                                                            }
                                                        ]
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 91,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                        },
                                                        end: {
                                                            line: 161,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                },
                                                {
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'Identifier',
                                                            name: 'TasksPane',
                                                            loc: {
                                                                start: {
                                                                    line: 162,
                                                                    column: 16,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                },
                                                                end: {
                                                                    line: 162,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [
                                                            {
                                                                type: 'Identifier',
                                                                name: 'config',
                                                                loc: {
                                                                    start: {
                                                                        line: 162,
                                                                        column: 26,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    },
                                                                    end: {
                                                                        line: 162,
                                                                        column: 32,
                                                                        fixed: true,
                                                                        source: 'viewpath/html/panes/UserPane.ion'
                                                                    }
                                                                }
                                                            },
                                                            {
                                                                type: 'ObjectExpression',
                                                                properties: [
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'toolbar',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 162,
                                                                                    column: 35,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 162,
                                                                                    column: 42,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Literal',
                                                                            value: false
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    },
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'selectable',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 162,
                                                                                    column: 51,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 162,
                                                                                    column: 61,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/html/panes/UserPane.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Literal',
                                                                            value: true
                                                                        },
                                                                        kind: 'init',
                                                                        order: '1'
                                                                    }
                                                                ]
                                                            }
                                                        ],
                                                        loc: {
                                                            start: {
                                                                line: 162,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                            },
                                                            end: {
                                                                line: 162,
                                                                column: 69,
                                                                fixed: true,
                                                                source: 'viewpath/html/panes/UserPane.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 162,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                        },
                                                        end: {
                                                            line: 162,
                                                            column: 69,
                                                            fixed: true,
                                                            source: 'viewpath/html/panes/UserPane.ion'
                                                        }
                                                    },
                                                    order: '1'
                                                }
                                            ]
                                        },
                                        alternate: null,
                                        order: '1'
                                    }
                                ]
                            },
                            order: '7'
                        }
                    ]
                },
                alternate: null,
                order: '1'
            }
        ],
        bound: false
    }, {
        this: this,
        config: config,
        glass: glass,
        _ref: _ref,
        _ref2: _ref2,
        _ref3: _ref3,
        _ref4: _ref4,
        viewpath: viewpath,
        _ref5: _ref5,
        _ref6: _ref6,
        Icon: Icon,
        Form: Form,
        Button: Button,
        TabContent: TabContent,
        Dialog: Dialog,
        GlassForm: GlassForm,
        CancelButton: CancelButton,
        SubmitButton: SubmitButton,
        Field: Field,
        EditForm: EditForm,
        style: style,
        Key: Key,
        Schema: Schema,
        User: User,
        Task: Task,
        TasksPane: TasksPane,
        _ref7: _ref7,
        editUserDialog: editUserDialog
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/panes/UserPane',_viewpath_html_panes_UserPane_);
    else
      _viewpath_html_panes_UserPane_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_panes_UserPane_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_panes_index_ = function(module,exports,require){Object.defineProperty(exports, 'DashboardPane', {get:function(){ return require('./DashboardPane') }, enumerable: true}) 
Object.defineProperty(exports, 'GenericTypePane', {get:function(){ return require('./GenericTypePane') }, enumerable: true}) 
Object.defineProperty(exports, 'GenericTypeView', {get:function(){ return require('./GenericTypeView') }, enumerable: true}) 
Object.defineProperty(exports, 'ManagersPane', {get:function(){ return require('./ManagersPane') }, enumerable: true}) 
Object.defineProperty(exports, 'OrgPane', {get:function(){ return require('./OrgPane') }, enumerable: true}) 
Object.defineProperty(exports, 'ProjectPane', {get:function(){ return require('./ProjectPane') }, enumerable: true}) 
Object.defineProperty(exports, 'ProjectsPane', {get:function(){ return require('./ProjectsPane') }, enumerable: true}) 
Object.defineProperty(exports, 'SubscriptionPane', {get:function(){ return require('./SubscriptionPane') }, enumerable: true}) 
Object.defineProperty(exports, 'SubscriptionsPane', {get:function(){ return require('./SubscriptionsPane') }, enumerable: true}) 
Object.defineProperty(exports, 'TaskPane', {get:function(){ return require('./TaskPane') }, enumerable: true}) 
Object.defineProperty(exports, 'TasksPane', {get:function(){ return require('./TasksPane') }, enumerable: true}) 
Object.defineProperty(exports, 'UserPane', {get:function(){ return require('./UserPane') }, enumerable: true}) 
Object.freeze(exports)
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/panes/index',_viewpath_html_panes_index_);
    else
      _viewpath_html_panes_index_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_panes_index_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_themes_index_ = function(module,exports,require){Object.defineProperty(exports, 'light', {get:function(){ return require('./light') }, enumerable: true}) 
Object.freeze(exports)
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/themes/index',_viewpath_html_themes_index_);
    else
      _viewpath_html_themes_index_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_themes_index_.call(this);
  }
}).call(this)
void (function(){var _viewpath_html_themes_light_ = function(module,exports,require){'use strict';
module.exports = exports = {
    color: {
        white: '#FFFFFF',
        black: '#000000',
        primary: '#8BC34A',
        primaryDarker: '#689F38',
        primaryLighter: '#DCEDC8',
        accent: '#00BCD4',
        accentLighter: '#26C6DA',
        accentDarker: '#00ACC1'
    }
};
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/html/themes/light',_viewpath_html_themes_light_);
    else
      _viewpath_html_themes_light_.call(this, module, exports, require);
  }
  else {
    _viewpath_html_themes_light_.call(this);
  }
}).call(this)
void (function(){var _viewpath_index_ = function(module,exports,require){Object.defineProperty(exports, 'ScheduleFunctions', {get:function(){ return require('./ScheduleFunctions') }, enumerable: true}) 
Object.defineProperty(exports, 'html', {get:function(){ return require('./html') }, enumerable: true}) 
Object.defineProperty(exports, 'model', {get:function(){ return require('./model') }, enumerable: true}) 
Object.defineProperty(exports, 'root', {get:function(){ return require('./root') }, enumerable: true}) 
Object.freeze(exports)
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/index',_viewpath_index_);
    else
      _viewpath_index_.call(this, module, exports, require);
  }
  else {
    _viewpath_index_.call(this);
  }
}).call(this)
void (function(){var _viewpath_model_ApplicationModel_ = function(module,exports,require){'use strict';
var ion = require('ion');
var glass = require('glass'), _ref, _ref2, _ref3, _ref4, _ref5, cloneRecursive = function (object, changeMap) {
        if (!(object != null) || typeof object !== 'object') {
            return (changeMap != null ? changeMap[object] : void 0) != null ? changeMap[object] : object;
        }
        var clone = new object.constructor();
        for (var key in object) {
            var value = object[key];
            clone[cloneRecursive(key, changeMap)] = cloneRecursive(value, changeMap);
        }
        return clone;
    };
_ref = glass;
var crypt = _ref.crypt;
_ref2 = glass.time;
var DateTime = _ref2.DateTime;
var Timezone = _ref2.Timezone;
_ref3 = glass.data;
var Http = _ref3.Http;
var Key = _ref3.Key;
_ref4 = glass.state;
var HashState = _ref4.HashState;
_ref5 = require('./');
var Organization = _ref5.Organization;
var Project = _ref5.Project;
var ProjectType = _ref5.ProjectType;
var ScheduleConstraint = _ref5.ScheduleConstraint;
var Task = _ref5.Task;
var TaskType = _ref5.TaskType;
var PermissionLevel = _ref5.PermissionLevel;
var TimeUnit = _ref5.TimeUnit;
module.exports = exports = ion.template(function ViewpathApplicationModel(options) {
    return ion.createRuntime({
        type: 'Template',
        id: {
            type: 'Identifier',
            name: 'ViewpathApplicationModel',
            loc: {
                start: {
                    line: 18,
                    column: 16,
                    fixed: true,
                    source: 'viewpath/model/ApplicationModel.ion'
                },
                end: {
                    line: 18,
                    column: 40,
                    fixed: true,
                    source: 'viewpath/model/ApplicationModel.ion'
                }
            }
        },
        body: [
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'model',
                            loc: {
                                start: {
                                    line: 19,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/model/ApplicationModel.ion'
                                },
                                end: {
                                    line: 19,
                                    column: 13,
                                    fixed: true,
                                    source: 'viewpath/model/ApplicationModel.ion'
                                }
                            }
                        },
                        init: {
                            type: 'CallExpression',
                            callee: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'glass',
                                        loc: {
                                            start: {
                                                line: 19,
                                                column: 16,
                                                fixed: true,
                                                source: 'viewpath/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 19,
                                                column: 21,
                                                fixed: true,
                                                source: 'viewpath/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'model',
                                        loc: {
                                            start: {
                                                line: 19,
                                                column: 22,
                                                fixed: true,
                                                source: 'viewpath/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 19,
                                                column: 27,
                                                fixed: true,
                                                source: 'viewpath/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 19,
                                            column: 16,
                                            fixed: true,
                                            source: 'viewpath/model/ApplicationModel.ion'
                                        },
                                        end: {
                                            line: 19,
                                            column: 27,
                                            fixed: true,
                                            source: 'viewpath/model/ApplicationModel.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'ApplicationModel',
                                    loc: {
                                        start: {
                                            line: 19,
                                            column: 28,
                                            fixed: true,
                                            source: 'viewpath/model/ApplicationModel.ion'
                                        },
                                        end: {
                                            line: 19,
                                            column: 44,
                                            fixed: true,
                                            source: 'viewpath/model/ApplicationModel.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 19,
                                        column: 16,
                                        fixed: true,
                                        source: 'viewpath/model/ApplicationModel.ion'
                                    },
                                    end: {
                                        line: 19,
                                        column: 44,
                                        fixed: true,
                                        source: 'viewpath/model/ApplicationModel.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'Identifier',
                                    name: 'options',
                                    loc: {
                                        start: {
                                            line: 19,
                                            column: 45,
                                            fixed: true,
                                            source: 'viewpath/model/ApplicationModel.ion'
                                        },
                                        end: {
                                            line: 19,
                                            column: 52,
                                            fixed: true,
                                            source: 'viewpath/model/ApplicationModel.ion'
                                        }
                                    }
                                }],
                            loc: {
                                start: {
                                    line: 19,
                                    column: 16,
                                    fixed: true,
                                    source: 'viewpath/model/ApplicationModel.ion'
                                },
                                end: {
                                    line: 19,
                                    column: 53,
                                    fixed: true,
                                    source: 'viewpath/model/ApplicationModel.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '0'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'ops',
                            loc: {
                                start: {
                                    line: 20,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/model/ApplicationModel.ion'
                                },
                                end: {
                                    line: 20,
                                    column: 11,
                                    fixed: true,
                                    source: 'viewpath/model/ApplicationModel.ion'
                                }
                            }
                        },
                        init: {
                            type: 'NewExpression',
                            callee: {
                                type: 'MemberExpression',
                                computed: false,
                                object: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'glass',
                                        loc: {
                                            start: {
                                                line: 20,
                                                column: 18,
                                                fixed: true,
                                                source: 'viewpath/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 20,
                                                column: 23,
                                                fixed: true,
                                                source: 'viewpath/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'model',
                                        loc: {
                                            start: {
                                                line: 20,
                                                column: 24,
                                                fixed: true,
                                                source: 'viewpath/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 20,
                                                column: 29,
                                                fixed: true,
                                                source: 'viewpath/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 20,
                                            column: 18,
                                            fixed: true,
                                            source: 'viewpath/model/ApplicationModel.ion'
                                        },
                                        end: {
                                            line: 20,
                                            column: 29,
                                            fixed: true,
                                            source: 'viewpath/model/ApplicationModel.ion'
                                        }
                                    }
                                },
                                property: {
                                    type: 'Identifier',
                                    name: 'OperationManager',
                                    loc: {
                                        start: {
                                            line: 20,
                                            column: 30,
                                            fixed: true,
                                            source: 'viewpath/model/ApplicationModel.ion'
                                        },
                                        end: {
                                            line: 20,
                                            column: 46,
                                            fixed: true,
                                            source: 'viewpath/model/ApplicationModel.ion'
                                        }
                                    }
                                },
                                loc: {
                                    start: {
                                        line: 20,
                                        column: 18,
                                        fixed: true,
                                        source: 'viewpath/model/ApplicationModel.ion'
                                    },
                                    end: {
                                        line: 20,
                                        column: 46,
                                        fixed: true,
                                        source: 'viewpath/model/ApplicationModel.ion'
                                    }
                                }
                            },
                            arguments: [{
                                    type: 'ObjectExpression',
                                    properties: [{
                                            type: 'Property',
                                            key: {
                                                type: 'Identifier',
                                                name: 'model',
                                                loc: {
                                                    start: {
                                                        line: 20,
                                                        column: 48,
                                                        fixed: true,
                                                        source: 'viewpath/model/ApplicationModel.ion'
                                                    },
                                                    end: {
                                                        line: 20,
                                                        column: 53,
                                                        fixed: true,
                                                        source: 'viewpath/model/ApplicationModel.ion'
                                                    }
                                                }
                                            },
                                            value: {
                                                type: 'Identifier',
                                                name: 'model',
                                                loc: {
                                                    start: {
                                                        line: 20,
                                                        column: 48,
                                                        fixed: true,
                                                        source: 'viewpath/model/ApplicationModel.ion'
                                                    },
                                                    end: {
                                                        line: 20,
                                                        column: 53,
                                                        fixed: true,
                                                        source: 'viewpath/model/ApplicationModel.ion'
                                                    }
                                                }
                                            },
                                            kind: 'init',
                                            order: '0'
                                        }]
                                }],
                            loc: {
                                start: {
                                    line: 20,
                                    column: 14,
                                    fixed: true,
                                    source: 'viewpath/model/ApplicationModel.ion'
                                },
                                end: {
                                    line: 20,
                                    column: 55,
                                    fixed: true,
                                    source: 'viewpath/model/ApplicationModel.ion'
                                }
                            }
                        }
                    }],
                kind: 'let',
                order: '1'
            },
            {
                type: 'VariableDeclaration',
                declarations: [{
                        type: 'VariableDeclarator',
                        id: {
                            type: 'Identifier',
                            name: 'token',
                            loc: {
                                start: {
                                    line: 21,
                                    column: 8,
                                    fixed: true,
                                    source: 'viewpath/model/ApplicationModel.ion'
                                },
                                end: {
                                    line: 21,
                                    column: 13,
                                    fixed: true,
                                    source: 'viewpath/model/ApplicationModel.ion'
                                }
                            }
                        },
                        init: {
                            type: 'ConditionalExpression',
                            test: {
                                type: 'BinaryExpression',
                                operator: '!=',
                                left: {
                                    type: 'ConditionalExpression',
                                    test: {
                                        type: 'BinaryExpression',
                                        operator: '!=',
                                        left: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'model',
                                                    loc: {
                                                        start: {
                                                            line: 21,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/model/ApplicationModel.ion'
                                                        },
                                                        end: {
                                                            line: 21,
                                                            column: 21,
                                                            fixed: true,
                                                            source: 'viewpath/model/ApplicationModel.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'session',
                                                    loc: {
                                                        start: {
                                                            line: 21,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'viewpath/model/ApplicationModel.ion'
                                                        },
                                                        end: {
                                                            line: 21,
                                                            column: 29,
                                                            fixed: true,
                                                            source: 'viewpath/model/ApplicationModel.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 21,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'viewpath/model/ApplicationModel.ion'
                                                    },
                                                    end: {
                                                        line: 21,
                                                        column: 29,
                                                        fixed: true,
                                                        source: 'viewpath/model/ApplicationModel.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'token',
                                                loc: {
                                                    start: {
                                                        line: 21,
                                                        column: 30,
                                                        fixed: true,
                                                        source: 'viewpath/model/ApplicationModel.ion'
                                                    },
                                                    end: {
                                                        line: 21,
                                                        column: 35,
                                                        fixed: true,
                                                        source: 'viewpath/model/ApplicationModel.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 21,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/model/ApplicationModel.ion'
                                                },
                                                end: {
                                                    line: 21,
                                                    column: 35,
                                                    fixed: true,
                                                    source: 'viewpath/model/ApplicationModel.ion'
                                                }
                                            }
                                        },
                                        right: {
                                            type: 'Literal',
                                            value: null
                                        }
                                    },
                                    consequent: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'model',
                                                loc: {
                                                    start: {
                                                        line: 21,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'viewpath/model/ApplicationModel.ion'
                                                    },
                                                    end: {
                                                        line: 21,
                                                        column: 21,
                                                        fixed: true,
                                                        source: 'viewpath/model/ApplicationModel.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'session',
                                                loc: {
                                                    start: {
                                                        line: 21,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'viewpath/model/ApplicationModel.ion'
                                                    },
                                                    end: {
                                                        line: 21,
                                                        column: 29,
                                                        fixed: true,
                                                        source: 'viewpath/model/ApplicationModel.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 21,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/model/ApplicationModel.ion'
                                                },
                                                end: {
                                                    line: 21,
                                                    column: 29,
                                                    fixed: true,
                                                    source: 'viewpath/model/ApplicationModel.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'token',
                                            loc: {
                                                start: {
                                                    line: 21,
                                                    column: 30,
                                                    fixed: true,
                                                    source: 'viewpath/model/ApplicationModel.ion'
                                                },
                                                end: {
                                                    line: 21,
                                                    column: 35,
                                                    fixed: true,
                                                    source: 'viewpath/model/ApplicationModel.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 21,
                                                column: 16,
                                                fixed: true,
                                                source: 'viewpath/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 21,
                                                column: 35,
                                                fixed: true,
                                                source: 'viewpath/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    alternate: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'model',
                                                loc: {
                                                    start: {
                                                        line: 21,
                                                        column: 38,
                                                        fixed: true,
                                                        source: 'viewpath/model/ApplicationModel.ion'
                                                    },
                                                    end: {
                                                        line: 21,
                                                        column: 43,
                                                        fixed: true,
                                                        source: 'viewpath/model/ApplicationModel.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'local',
                                                loc: {
                                                    start: {
                                                        line: 21,
                                                        column: 44,
                                                        fixed: true,
                                                        source: 'viewpath/model/ApplicationModel.ion'
                                                    },
                                                    end: {
                                                        line: 21,
                                                        column: 49,
                                                        fixed: true,
                                                        source: 'viewpath/model/ApplicationModel.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 21,
                                                    column: 38,
                                                    fixed: true,
                                                    source: 'viewpath/model/ApplicationModel.ion'
                                                },
                                                end: {
                                                    line: 21,
                                                    column: 49,
                                                    fixed: true,
                                                    source: 'viewpath/model/ApplicationModel.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'token',
                                            loc: {
                                                start: {
                                                    line: 21,
                                                    column: 50,
                                                    fixed: true,
                                                    source: 'viewpath/model/ApplicationModel.ion'
                                                },
                                                end: {
                                                    line: 21,
                                                    column: 55,
                                                    fixed: true,
                                                    source: 'viewpath/model/ApplicationModel.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 21,
                                                column: 38,
                                                fixed: true,
                                                source: 'viewpath/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 21,
                                                column: 55,
                                                fixed: true,
                                                source: 'viewpath/model/ApplicationModel.ion'
                                            }
                                        }
                                    }
                                },
                                right: {
                                    type: 'Literal',
                                    value: null
                                }
                            },
                            consequent: {
                                type: 'ConditionalExpression',
                                test: {
                                    type: 'BinaryExpression',
                                    operator: '!=',
                                    left: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'model',
                                                loc: {
                                                    start: {
                                                        line: 21,
                                                        column: 16,
                                                        fixed: true,
                                                        source: 'viewpath/model/ApplicationModel.ion'
                                                    },
                                                    end: {
                                                        line: 21,
                                                        column: 21,
                                                        fixed: true,
                                                        source: 'viewpath/model/ApplicationModel.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'session',
                                                loc: {
                                                    start: {
                                                        line: 21,
                                                        column: 22,
                                                        fixed: true,
                                                        source: 'viewpath/model/ApplicationModel.ion'
                                                    },
                                                    end: {
                                                        line: 21,
                                                        column: 29,
                                                        fixed: true,
                                                        source: 'viewpath/model/ApplicationModel.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 21,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/model/ApplicationModel.ion'
                                                },
                                                end: {
                                                    line: 21,
                                                    column: 29,
                                                    fixed: true,
                                                    source: 'viewpath/model/ApplicationModel.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'token',
                                            loc: {
                                                start: {
                                                    line: 21,
                                                    column: 30,
                                                    fixed: true,
                                                    source: 'viewpath/model/ApplicationModel.ion'
                                                },
                                                end: {
                                                    line: 21,
                                                    column: 35,
                                                    fixed: true,
                                                    source: 'viewpath/model/ApplicationModel.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 21,
                                                column: 16,
                                                fixed: true,
                                                source: 'viewpath/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 21,
                                                column: 35,
                                                fixed: true,
                                                source: 'viewpath/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    right: {
                                        type: 'Literal',
                                        value: null
                                    }
                                },
                                consequent: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'model',
                                            loc: {
                                                start: {
                                                    line: 21,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/model/ApplicationModel.ion'
                                                },
                                                end: {
                                                    line: 21,
                                                    column: 21,
                                                    fixed: true,
                                                    source: 'viewpath/model/ApplicationModel.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'session',
                                            loc: {
                                                start: {
                                                    line: 21,
                                                    column: 22,
                                                    fixed: true,
                                                    source: 'viewpath/model/ApplicationModel.ion'
                                                },
                                                end: {
                                                    line: 21,
                                                    column: 29,
                                                    fixed: true,
                                                    source: 'viewpath/model/ApplicationModel.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 21,
                                                column: 16,
                                                fixed: true,
                                                source: 'viewpath/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 21,
                                                column: 29,
                                                fixed: true,
                                                source: 'viewpath/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'token',
                                        loc: {
                                            start: {
                                                line: 21,
                                                column: 30,
                                                fixed: true,
                                                source: 'viewpath/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 21,
                                                column: 35,
                                                fixed: true,
                                                source: 'viewpath/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 21,
                                            column: 16,
                                            fixed: true,
                                            source: 'viewpath/model/ApplicationModel.ion'
                                        },
                                        end: {
                                            line: 21,
                                            column: 35,
                                            fixed: true,
                                            source: 'viewpath/model/ApplicationModel.ion'
                                        }
                                    }
                                },
                                alternate: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: {
                                            type: 'Identifier',
                                            name: 'model',
                                            loc: {
                                                start: {
                                                    line: 21,
                                                    column: 38,
                                                    fixed: true,
                                                    source: 'viewpath/model/ApplicationModel.ion'
                                                },
                                                end: {
                                                    line: 21,
                                                    column: 43,
                                                    fixed: true,
                                                    source: 'viewpath/model/ApplicationModel.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'local',
                                            loc: {
                                                start: {
                                                    line: 21,
                                                    column: 44,
                                                    fixed: true,
                                                    source: 'viewpath/model/ApplicationModel.ion'
                                                },
                                                end: {
                                                    line: 21,
                                                    column: 49,
                                                    fixed: true,
                                                    source: 'viewpath/model/ApplicationModel.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 21,
                                                column: 38,
                                                fixed: true,
                                                source: 'viewpath/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 21,
                                                column: 49,
                                                fixed: true,
                                                source: 'viewpath/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'token',
                                        loc: {
                                            start: {
                                                line: 21,
                                                column: 50,
                                                fixed: true,
                                                source: 'viewpath/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 21,
                                                column: 55,
                                                fixed: true,
                                                source: 'viewpath/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 21,
                                            column: 38,
                                            fixed: true,
                                            source: 'viewpath/model/ApplicationModel.ion'
                                        },
                                        end: {
                                            line: 21,
                                            column: 55,
                                            fixed: true,
                                            source: 'viewpath/model/ApplicationModel.ion'
                                        }
                                    }
                                }
                            },
                            alternate: {
                                type: 'Literal',
                                value: null
                            }
                        }
                    }],
                kind: 'let',
                order: '2'
            },
            {
                type: 'ReturnStatement',
                argument: {
                    type: 'ObjectExpression',
                    objectType: {
                        type: 'Identifier',
                        name: 'model',
                        loc: {
                            start: {
                                line: 22,
                                column: 11,
                                fixed: true,
                                source: 'viewpath/model/ApplicationModel.ion'
                            },
                            end: {
                                line: 22,
                                column: 16,
                                fixed: true,
                                source: 'viewpath/model/ApplicationModel.ion'
                            }
                        }
                    },
                    properties: [
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'ops',
                                loc: {
                                    start: {
                                        line: 23,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/model/ApplicationModel.ion'
                                    },
                                    end: {
                                        line: 23,
                                        column: 11,
                                        fixed: true,
                                        source: 'viewpath/model/ApplicationModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Identifier',
                                name: 'ops',
                                loc: {
                                    start: {
                                        line: 23,
                                        column: 13,
                                        fixed: true,
                                        source: 'viewpath/model/ApplicationModel.ion'
                                    },
                                    end: {
                                        line: 23,
                                        column: 16,
                                        fixed: true,
                                        source: 'viewpath/model/ApplicationModel.ion'
                                    }
                                }
                            },
                            kind: 'init',
                            order: '0'
                        },
                        {
                            type: 'IfStatement',
                            test: {
                                type: 'UnaryExpression',
                                operator: '?',
                                argument: {
                                    type: 'MemberExpression',
                                    computed: false,
                                    object: {
                                        type: 'Identifier',
                                        name: 'model',
                                        loc: {
                                            start: {
                                                line: 24,
                                                column: 11,
                                                fixed: true,
                                                source: 'viewpath/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 24,
                                                column: 16,
                                                fixed: true,
                                                source: 'viewpath/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    property: {
                                        type: 'Identifier',
                                        name: 'user',
                                        loc: {
                                            start: {
                                                line: 24,
                                                column: 17,
                                                fixed: true,
                                                source: 'viewpath/model/ApplicationModel.ion'
                                            },
                                            end: {
                                                line: 24,
                                                column: 21,
                                                fixed: true,
                                                source: 'viewpath/model/ApplicationModel.ion'
                                            }
                                        }
                                    },
                                    loc: {
                                        start: {
                                            line: 24,
                                            column: 11,
                                            fixed: true,
                                            source: 'viewpath/model/ApplicationModel.ion'
                                        },
                                        end: {
                                            line: 24,
                                            column: 21,
                                            fixed: true,
                                            source: 'viewpath/model/ApplicationModel.ion'
                                        }
                                    }
                                }
                            },
                            consequent: {
                                type: 'BlockStatement',
                                body: [
                                    {
                                        type: 'VariableDeclaration',
                                        declarations: [{
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'orgIds',
                                                    loc: {
                                                        start: {
                                                            line: 30,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/model/ApplicationModel.ion'
                                                        },
                                                        end: {
                                                            line: 30,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'viewpath/model/ApplicationModel.ion'
                                                        }
                                                    }
                                                },
                                                init: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'model',
                                                            loc: {
                                                                start: {
                                                                    line: 30,
                                                                    column: 25,
                                                                    fixed: true,
                                                                    source: 'viewpath/model/ApplicationModel.ion'
                                                                },
                                                                end: {
                                                                    line: 30,
                                                                    column: 30,
                                                                    fixed: true,
                                                                    source: 'viewpath/model/ApplicationModel.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'user',
                                                            loc: {
                                                                start: {
                                                                    line: 30,
                                                                    column: 31,
                                                                    fixed: true,
                                                                    source: 'viewpath/model/ApplicationModel.ion'
                                                                },
                                                                end: {
                                                                    line: 30,
                                                                    column: 35,
                                                                    fixed: true,
                                                                    source: 'viewpath/model/ApplicationModel.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 30,
                                                                column: 25,
                                                                fixed: true,
                                                                source: 'viewpath/model/ApplicationModel.ion'
                                                            },
                                                            end: {
                                                                line: 30,
                                                                column: 35,
                                                                fixed: true,
                                                                source: 'viewpath/model/ApplicationModel.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'orgIds',
                                                        loc: {
                                                            start: {
                                                                line: 30,
                                                                column: 36,
                                                                fixed: true,
                                                                source: 'viewpath/model/ApplicationModel.ion'
                                                            },
                                                            end: {
                                                                line: 30,
                                                                column: 42,
                                                                fixed: true,
                                                                source: 'viewpath/model/ApplicationModel.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 30,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'viewpath/model/ApplicationModel.ion'
                                                        },
                                                        end: {
                                                            line: 30,
                                                            column: 42,
                                                            fixed: true,
                                                            source: 'viewpath/model/ApplicationModel.ion'
                                                        }
                                                    }
                                                }
                                            }],
                                        kind: 'let',
                                        order: '0'
                                    },
                                    {
                                        type: 'VariableDeclaration',
                                        declarations: [{
                                                type: 'VariableDeclarator',
                                                id: {
                                                    type: 'Identifier',
                                                    name: 'orgKey',
                                                    loc: {
                                                        start: {
                                                            line: 31,
                                                            column: 16,
                                                            fixed: true,
                                                            source: 'viewpath/model/ApplicationModel.ion'
                                                        },
                                                        end: {
                                                            line: 31,
                                                            column: 22,
                                                            fixed: true,
                                                            source: 'viewpath/model/ApplicationModel.ion'
                                                        }
                                                    }
                                                },
                                                init: {
                                                    type: 'CallExpression',
                                                    callee: {
                                                        type: 'Function',
                                                        context: true,
                                                        value: function (_context) {
                                                            return function (orgIds) {
                                                                var Key = _context.get('Key'), Organization = _context.get('Organization');
                                                                return new Key(Organization, { where: { id: orgIds } });
                                                            };
                                                        }
                                                    },
                                                    arguments: [{
                                                            type: 'Identifier',
                                                            name: 'orgIds',
                                                            loc: {
                                                                start: {
                                                                    line: 31,
                                                                    column: 28,
                                                                    fixed: true,
                                                                    source: 'viewpath/model/ApplicationModel.ion'
                                                                },
                                                                end: {
                                                                    line: 31,
                                                                    column: 34,
                                                                    fixed: true,
                                                                    source: 'viewpath/model/ApplicationModel.ion'
                                                                }
                                                            }
                                                        }],
                                                    loc: {
                                                        start: {
                                                            line: 31,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'viewpath/model/ApplicationModel.ion'
                                                        },
                                                        end: {
                                                            line: 31,
                                                            column: 81,
                                                            fixed: true,
                                                            source: 'viewpath/model/ApplicationModel.ion'
                                                        }
                                                    }
                                                }
                                            }],
                                        kind: 'let',
                                        order: '1'
                                    },
                                    {
                                        type: 'Property',
                                        key: {
                                            type: 'Identifier',
                                            name: 'orgs',
                                            loc: {
                                                start: {
                                                    line: 33,
                                                    column: 12,
                                                    fixed: true,
                                                    source: 'viewpath/model/ApplicationModel.ion'
                                                },
                                                end: {
                                                    line: 33,
                                                    column: 16,
                                                    fixed: true,
                                                    source: 'viewpath/model/ApplicationModel.ion'
                                                }
                                            }
                                        },
                                        value: {
                                            type: 'MemberExpression',
                                            computed: true,
                                            object: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'model',
                                                    loc: {
                                                        start: {
                                                            line: 33,
                                                            column: 18,
                                                            fixed: true,
                                                            source: 'viewpath/model/ApplicationModel.ion'
                                                        },
                                                        end: {
                                                            line: 33,
                                                            column: 23,
                                                            fixed: true,
                                                            source: 'viewpath/model/ApplicationModel.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'server',
                                                    loc: {
                                                        start: {
                                                            line: 33,
                                                            column: 24,
                                                            fixed: true,
                                                            source: 'viewpath/model/ApplicationModel.ion'
                                                        },
                                                        end: {
                                                            line: 33,
                                                            column: 30,
                                                            fixed: true,
                                                            source: 'viewpath/model/ApplicationModel.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 33,
                                                        column: 18,
                                                        fixed: true,
                                                        source: 'viewpath/model/ApplicationModel.ion'
                                                    },
                                                    end: {
                                                        line: 33,
                                                        column: 30,
                                                        fixed: true,
                                                        source: 'viewpath/model/ApplicationModel.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'orgKey',
                                                loc: {
                                                    start: {
                                                        line: 33,
                                                        column: 31,
                                                        fixed: true,
                                                        source: 'viewpath/model/ApplicationModel.ion'
                                                    },
                                                    end: {
                                                        line: 33,
                                                        column: 37,
                                                        fixed: true,
                                                        source: 'viewpath/model/ApplicationModel.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 33,
                                                    column: 18,
                                                    fixed: true,
                                                    source: 'viewpath/model/ApplicationModel.ion'
                                                },
                                                end: {
                                                    line: 33,
                                                    column: 38,
                                                    fixed: true,
                                                    source: 'viewpath/model/ApplicationModel.ion'
                                                }
                                            }
                                        },
                                        kind: 'init',
                                        order: '2'
                                    },
                                    {
                                        type: 'IfStatement',
                                        test: {
                                            type: 'UnaryExpression',
                                            operator: '?',
                                            argument: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'model',
                                                        loc: {
                                                            start: {
                                                                line: 35,
                                                                column: 15,
                                                                fixed: true,
                                                                source: 'viewpath/model/ApplicationModel.ion'
                                                            },
                                                            end: {
                                                                line: 35,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/model/ApplicationModel.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'user',
                                                        loc: {
                                                            start: {
                                                                line: 35,
                                                                column: 21,
                                                                fixed: true,
                                                                source: 'viewpath/model/ApplicationModel.ion'
                                                            },
                                                            end: {
                                                                line: 35,
                                                                column: 25,
                                                                fixed: true,
                                                                source: 'viewpath/model/ApplicationModel.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 35,
                                                            column: 15,
                                                            fixed: true,
                                                            source: 'viewpath/model/ApplicationModel.ion'
                                                        },
                                                        end: {
                                                            line: 35,
                                                            column: 25,
                                                            fixed: true,
                                                            source: 'viewpath/model/ApplicationModel.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'subscription',
                                                    loc: {
                                                        start: {
                                                            line: 35,
                                                            column: 26,
                                                            fixed: true,
                                                            source: 'viewpath/model/ApplicationModel.ion'
                                                        },
                                                        end: {
                                                            line: 35,
                                                            column: 38,
                                                            fixed: true,
                                                            source: 'viewpath/model/ApplicationModel.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 35,
                                                        column: 15,
                                                        fixed: true,
                                                        source: 'viewpath/model/ApplicationModel.ion'
                                                    },
                                                    end: {
                                                        line: 35,
                                                        column: 38,
                                                        fixed: true,
                                                        source: 'viewpath/model/ApplicationModel.ion'
                                                    }
                                                }
                                            }
                                        },
                                        consequent: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'subscription',
                                                        loc: {
                                                            start: {
                                                                line: 36,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/model/ApplicationModel.ion'
                                                            },
                                                            end: {
                                                                line: 36,
                                                                column: 28,
                                                                fixed: true,
                                                                source: 'viewpath/model/ApplicationModel.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'MemberExpression',
                                                        computed: true,
                                                        object: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'Identifier',
                                                                name: 'model',
                                                                loc: {
                                                                    start: {
                                                                        line: 36,
                                                                        column: 30,
                                                                        fixed: true,
                                                                        source: 'viewpath/model/ApplicationModel.ion'
                                                                    },
                                                                    end: {
                                                                        line: 36,
                                                                        column: 35,
                                                                        fixed: true,
                                                                        source: 'viewpath/model/ApplicationModel.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'server',
                                                                loc: {
                                                                    start: {
                                                                        line: 36,
                                                                        column: 36,
                                                                        fixed: true,
                                                                        source: 'viewpath/model/ApplicationModel.ion'
                                                                    },
                                                                    end: {
                                                                        line: 36,
                                                                        column: 42,
                                                                        fixed: true,
                                                                        source: 'viewpath/model/ApplicationModel.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 36,
                                                                    column: 30,
                                                                    fixed: true,
                                                                    source: 'viewpath/model/ApplicationModel.ion'
                                                                },
                                                                end: {
                                                                    line: 36,
                                                                    column: 42,
                                                                    fixed: true,
                                                                    source: 'viewpath/model/ApplicationModel.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'MemberExpression',
                                                            computed: false,
                                                            object: {
                                                                type: 'MemberExpression',
                                                                computed: false,
                                                                object: {
                                                                    type: 'Identifier',
                                                                    name: 'model',
                                                                    loc: {
                                                                        start: {
                                                                            line: 36,
                                                                            column: 43,
                                                                            fixed: true,
                                                                            source: 'viewpath/model/ApplicationModel.ion'
                                                                        },
                                                                        end: {
                                                                            line: 36,
                                                                            column: 48,
                                                                            fixed: true,
                                                                            source: 'viewpath/model/ApplicationModel.ion'
                                                                        }
                                                                    }
                                                                },
                                                                property: {
                                                                    type: 'Identifier',
                                                                    name: 'user',
                                                                    loc: {
                                                                        start: {
                                                                            line: 36,
                                                                            column: 49,
                                                                            fixed: true,
                                                                            source: 'viewpath/model/ApplicationModel.ion'
                                                                        },
                                                                        end: {
                                                                            line: 36,
                                                                            column: 53,
                                                                            fixed: true,
                                                                            source: 'viewpath/model/ApplicationModel.ion'
                                                                        }
                                                                    }
                                                                },
                                                                loc: {
                                                                    start: {
                                                                        line: 36,
                                                                        column: 43,
                                                                        fixed: true,
                                                                        source: 'viewpath/model/ApplicationModel.ion'
                                                                    },
                                                                    end: {
                                                                        line: 36,
                                                                        column: 53,
                                                                        fixed: true,
                                                                        source: 'viewpath/model/ApplicationModel.ion'
                                                                    }
                                                                }
                                                            },
                                                            property: {
                                                                type: 'Identifier',
                                                                name: 'subscription',
                                                                loc: {
                                                                    start: {
                                                                        line: 36,
                                                                        column: 54,
                                                                        fixed: true,
                                                                        source: 'viewpath/model/ApplicationModel.ion'
                                                                    },
                                                                    end: {
                                                                        line: 36,
                                                                        column: 66,
                                                                        fixed: true,
                                                                        source: 'viewpath/model/ApplicationModel.ion'
                                                                    }
                                                                }
                                                            },
                                                            loc: {
                                                                start: {
                                                                    line: 36,
                                                                    column: 43,
                                                                    fixed: true,
                                                                    source: 'viewpath/model/ApplicationModel.ion'
                                                                },
                                                                end: {
                                                                    line: 36,
                                                                    column: 66,
                                                                    fixed: true,
                                                                    source: 'viewpath/model/ApplicationModel.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 36,
                                                                column: 30,
                                                                fixed: true,
                                                                source: 'viewpath/model/ApplicationModel.ion'
                                                            },
                                                            end: {
                                                                line: 36,
                                                                column: 67,
                                                                fixed: true,
                                                                source: 'viewpath/model/ApplicationModel.ion'
                                                            }
                                                        }
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                }]
                                        },
                                        alternate: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'Property',
                                                    key: {
                                                        type: 'Identifier',
                                                        name: 'subscription',
                                                        loc: {
                                                            start: {
                                                                line: 38,
                                                                column: 16,
                                                                fixed: true,
                                                                source: 'viewpath/model/ApplicationModel.ion'
                                                            },
                                                            end: {
                                                                line: 38,
                                                                column: 28,
                                                                fixed: true,
                                                                source: 'viewpath/model/ApplicationModel.ion'
                                                            }
                                                        }
                                                    },
                                                    value: {
                                                        type: 'Literal',
                                                        value: null
                                                    },
                                                    kind: 'init',
                                                    order: '0'
                                                }]
                                        },
                                        order: '3'
                                    }
                                ]
                            },
                            alternate: null,
                            order: '1'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'signup',
                                loc: {
                                    start: {
                                        line: 40,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/model/ApplicationModel.ion'
                                    },
                                    end: {
                                        line: 40,
                                        column: 14,
                                        fixed: true,
                                        source: 'viewpath/model/ApplicationModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context2) {
                                    return function (_ref6) {
                                        var crypt = _context2.get('crypt'), Http = _context2.get('Http');
                                        var name = _ref6.name;
                                        var email = _ref6.email;
                                        var password = _ref6.password;
                                        var passwordHash = crypt.hash(password);
                                        var signupUrl = Http.getUrl('/email/signup', {
                                                name: name,
                                                email: email,
                                                passwordHash: passwordHash
                                            });
                                        this.setLastLoginTimeNow();
                                        document.location = signupUrl;
                                    };
                                }
                            },
                            kind: 'init',
                            order: '2'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'invite',
                                loc: {
                                    start: {
                                        line: 47,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/model/ApplicationModel.ion'
                                    },
                                    end: {
                                        line: 47,
                                        column: 14,
                                        fixed: true,
                                        source: 'viewpath/model/ApplicationModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context3) {
                                    return function (_ref7) {
                                        var Http = _context3.get('Http');
                                        var name = _ref7.name;
                                        var email = _ref7.email;
                                        var orgId = _ref7.orgId;
                                        var message = _ref7.message;
                                        var callback = _ref7.callback;
                                        var url = Http.getUrl('/email/invite', {
                                                name: name,
                                                email: email,
                                                orgId: orgId,
                                                message: message
                                            });
                                        this.ajax(url, void 0, function (res) {
                                            return callback != null ? callback(res) : void 0;
                                        });
                                    };
                                }
                            },
                            kind: 'init',
                            order: '3'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'startTrial',
                                loc: {
                                    start: {
                                        line: 51,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/model/ApplicationModel.ion'
                                    },
                                    end: {
                                        line: 51,
                                        column: 18,
                                        fixed: true,
                                        source: 'viewpath/model/ApplicationModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context4) {
                                    return function () {
                                        var model = _context4.get('model');
                                        model.user.startTrial();
                                        model.info({ text: 'Your 30 day free trial has begun!' });
                                        model.subscribeToMailchimp();
                                    };
                                }
                            },
                            kind: 'init',
                            order: '4'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'subscribeToMailchimp',
                                loc: {
                                    start: {
                                        line: 56,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/model/ApplicationModel.ion'
                                    },
                                    end: {
                                        line: 56,
                                        column: 28,
                                        fixed: true,
                                        source: 'viewpath/model/ApplicationModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context5) {
                                    return function () {
                                        var Http = _context5.get('Http');
                                        return this.ajax(Http.getUrl('/mailchimp'), void 0, function () {
                                        });
                                    };
                                }
                            },
                            kind: 'init',
                            order: '5'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'setupSalesforceSync',
                                loc: {
                                    start: {
                                        line: 58,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/model/ApplicationModel.ion'
                                    },
                                    end: {
                                        line: 58,
                                        column: 27,
                                        fixed: true,
                                        source: 'viewpath/model/ApplicationModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context6) {
                                    return function (_ref8) {
                                        var Http = _context6.get('Http');
                                        var sandbox = _ref8.sandbox;
                                        var orgId = _ref8.orgId;
                                        var url = Http.getUrl('/salesforce/setup', {
                                                sandbox: sandbox,
                                                orgId: orgId
                                            });
                                        window.open(url, '_blank', 'width=600,height=700,location=no,resizable=yes,toolbar=no,status=no,menubar=no,scrollbars=1', 1);
                                    };
                                }
                            },
                            kind: 'init',
                            order: '6'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'addRemoveSubUsers',
                                loc: {
                                    start: {
                                        line: 66,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/model/ApplicationModel.ion'
                                    },
                                    end: {
                                        line: 66,
                                        column: 25,
                                        fixed: true,
                                        source: 'viewpath/model/ApplicationModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context7) {
                                    return function (_ref9) {
                                        var Http = _context7.get('Http');
                                        var userKeys = _ref9.userKeys;
                                        var subKey = _ref9.subKey;
                                        var remove = _ref9.remove;
                                        var callback = _ref9.callback;
                                        var url = Http.getUrl('/subscription/addremove', {
                                                subKey: subKey,
                                                remove: remove,
                                                userKeys: JSON.stringify(userKeys)
                                            });
                                        var patch = this.server.source.patch;
                                        this.ajax(url, void 0, function (res) {
                                            return callback(res);
                                        });
                                    };
                                }
                            },
                            kind: 'init',
                            order: '7'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'addUsersToSub',
                                loc: {
                                    start: {
                                        line: 71,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/model/ApplicationModel.ion'
                                    },
                                    end: {
                                        line: 71,
                                        column: 21,
                                        fixed: true,
                                        source: 'viewpath/model/ApplicationModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: false,
                                value: function (_ref10) {
                                    var userKeys = _ref10.userKeys;
                                    var subKey = _ref10.subKey;
                                    var callback = _ref10.callback;
                                    this.addRemoveSubUsers({
                                        userKeys: userKeys,
                                        subKey: subKey,
                                        remove: false,
                                        callback: callback
                                    });
                                }
                            },
                            kind: 'init',
                            order: '8'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'removeUsersFromSub',
                                loc: {
                                    start: {
                                        line: 74,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/model/ApplicationModel.ion'
                                    },
                                    end: {
                                        line: 74,
                                        column: 26,
                                        fixed: true,
                                        source: 'viewpath/model/ApplicationModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: false,
                                value: function (_ref11) {
                                    var userKeys = _ref11.userKeys;
                                    var subKey = _ref11.subKey;
                                    var callback = _ref11.callback;
                                    this.addRemoveSubUsers({
                                        userKeys: userKeys,
                                        subKey: subKey,
                                        remove: true,
                                        callback: callback
                                    });
                                }
                            },
                            kind: 'init',
                            order: '9'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'manageSubscriptions',
                                loc: {
                                    start: {
                                        line: 77,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/model/ApplicationModel.ion'
                                    },
                                    end: {
                                        line: 77,
                                        column: 27,
                                        fixed: true,
                                        source: 'viewpath/model/ApplicationModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context8) {
                                    return function () {
                                        var Http = _context8.get('Http'), token = _context8.get('token');
                                        window.open(Http.getUrl('/subscription/manage', { token: token }));
                                    };
                                }
                            },
                            kind: 'init',
                            order: ':'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'changePassword',
                                loc: {
                                    start: {
                                        line: 80,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/model/ApplicationModel.ion'
                                    },
                                    end: {
                                        line: 80,
                                        column: 22,
                                        fixed: true,
                                        source: 'viewpath/model/ApplicationModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context9) {
                                    return function (_ref12) {
                                        var crypt = _context9.get('crypt'), Http = _context9.get('Http');
                                        var email = _ref12.email;
                                        var password = _ref12.password;
                                        var passwordHash = crypt.hash(password);
                                        var signupUrl = Http.getUrl('/email/changePassword', {
                                                email: email,
                                                passwordHash: passwordHash
                                            });
                                        document.location = signupUrl;
                                    };
                                }
                            },
                            kind: 'init',
                            order: ';'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'cloneProject',
                                loc: {
                                    start: {
                                        line: 85,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/model/ApplicationModel.ion'
                                    },
                                    end: {
                                        line: 85,
                                        column: 20,
                                        fixed: true,
                                        source: 'viewpath/model/ApplicationModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context10) {
                                    return function (_ref13, callback) {
                                        var Key = _context10.get('Key'), Project = _context10.get('Project'), Task = _context10.get('Task'), cloneRecursive = _context10.get('cloneRecursive');
                                        var project = _ref13.project;
                                        var properties = _ref13.properties;
                                        var tasks = _ref13.tasks;
                                        var newProjectKey = new Key(Project, this.guid());
                                        var newChangeMap = {};
                                        newChangeMap[project.key] = newProjectKey;
                                        for (var key in tasks) {
                                            var task = tasks[key];
                                            var newTaskKey = new Key(newProjectKey, Task, task.id);
                                            newChangeMap[task.key] = newTaskKey.toString();
                                            newChangeMap[task.id] = newTaskKey.id;
                                        }
                                        var newProject = cloneRecursive(project, newChangeMap);
                                        if (properties != null) {
                                            for (var key in properties) {
                                                var value = properties[key];
                                                newProject[key] = cloneRecursive(value);
                                            }
                                        }
                                        newProject.key = newProjectKey.toString();
                                        newProject.master = project.key;
                                        var newTasks = cloneRecursive(tasks, newChangeMap);
                                        var patch = {};
                                        patch[newProject.key] = newProject;
                                        for (var key in newTasks) {
                                            var newTask = newTasks[key];
                                            patch[key] = newTask;
                                        }
                                        this.request('', patch, function (object) {
                                            callback(newProject);
                                        });
                                    };
                                }
                            },
                            kind: 'init',
                            order: '<'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'addEntities',
                                loc: {
                                    start: {
                                        line: 113,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/model/ApplicationModel.ion'
                                    },
                                    end: {
                                        line: 113,
                                        column: 19,
                                        fixed: true,
                                        source: 'viewpath/model/ApplicationModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: false,
                                value: function (entities, callback) {
                                    var patch = {};
                                    for (var _i = 0; _i < entities.length; _i++) {
                                        var entity = entities[_i];
                                        patch[entity.key] = entity;
                                    }
                                    this.request('', patch, function (object) {
                                        callback != null ? callback(object) : void 0;
                                    });
                                }
                            },
                            kind: 'init',
                            order: '='
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'addStandardWorkWeek',
                                loc: {
                                    start: {
                                        line: 123,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/model/ApplicationModel.ion'
                                    },
                                    end: {
                                        line: 123,
                                        column: 27,
                                        fixed: true,
                                        source: 'viewpath/model/ApplicationModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context11) {
                                    return function (project, callback) {
                                        var ion = _context11.get('ion'), ProjectType = _context11.get('ProjectType'), Key = _context11.get('Key'), Task = _context11.get('Task'), TaskType = _context11.get('TaskType'), TimeUnit = _context11.get('TimeUnit'), Timezone = _context11.get('Timezone');
                                        ion.patch.combine(project, {
                                            type: ProjectType.Calendar.id,
                                            name: 'Standard Work Week'
                                        });
                                        var taskKey = new Key(project.getKey(), Task, this.guid());
                                        var task = new Task({
                                                repeat: true,
                                                repeatCount: 1,
                                                repeatUnit: 1,
                                                type: TaskType.Shift.id,
                                                repeatDays: 62,
                                                name: 'Work Day',
                                                duration: {
                                                    value: 8,
                                                    unit: TimeUnit.hours.id
                                                },
                                                start: Timezone.toLocal(Date.create('last monday 9am').iso()),
                                                finish: Timezone.toLocal(Date.create('last monday 5pm').iso()),
                                                key: taskKey.toString(),
                                                orgId: project.orgId
                                            });
                                        this.addEntities([
                                            task,
                                            project
                                        ], callback);
                                        return project;
                                    };
                                }
                            },
                            kind: 'init',
                            order: '>'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'addUSHolidays',
                                loc: {
                                    start: {
                                        line: 146,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/model/ApplicationModel.ion'
                                    },
                                    end: {
                                        line: 146,
                                        column: 21,
                                        fixed: true,
                                        source: 'viewpath/model/ApplicationModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context12) {
                                    return function (project, callback) {
                                        var ion = _context12.get('ion'), ProjectType = _context12.get('ProjectType'), Key = _context12.get('Key'), Task = _context12.get('Task'), TaskType = _context12.get('TaskType'), TimeUnit = _context12.get('TimeUnit');
                                        ion.patch.combine(project, {
                                            type: ProjectType.Calendar.id,
                                            name: 'US Holidays'
                                        });
                                        var holidays = {
                                                'New Years Day': { date: '2017-01-01' },
                                                'Memorial Day': {
                                                    date: '2017-05-28',
                                                    repeatCount: 12,
                                                    repeatUnit: 2
                                                },
                                                'Fourth of July': { date: '2017-07-04' },
                                                'Labor Day': {
                                                    date: '2017-09-04',
                                                    repeatCount: 12,
                                                    repeatUnit: 2
                                                },
                                                'Thanksgiving': {
                                                    date: '2017-11-23',
                                                    repeatCount: 12,
                                                    repeatUnit: 2
                                                },
                                                'Christmas Eve': { date: '2017-12-24' },
                                                'Christmas': { date: '2017-12-25' }
                                            };
                                        var tasks = [];
                                        for (var name in holidays) {
                                            var properties = holidays[name];
                                            var taskKey = new Key(project.getKey(), Task, this.guid());
                                            tasks.push(new Task({
                                                repeat: true,
                                                repeatCount: properties.repeatCount != null ? properties.repeatCount : 1,
                                                repeatUnit: properties.repeatUnit != null ? properties.repeatUnit : 3,
                                                type: TaskType.Holiday.id,
                                                name: name,
                                                duration: {
                                                    value: 1,
                                                    unit: TimeUnit.days.id
                                                },
                                                start: properties.date,
                                                finish: properties.date,
                                                key: taskKey.toString(),
                                                orgId: project.orgId
                                            }));
                                        }
                                        this.addEntities(tasks.concat([project]), callback);
                                    };
                                }
                            },
                            kind: 'init',
                            order: '?'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'orgNameToBaseId',
                                loc: {
                                    start: {
                                        line: 189,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/model/ApplicationModel.ion'
                                    },
                                    end: {
                                        line: 189,
                                        column: 23,
                                        fixed: true,
                                        source: 'viewpath/model/ApplicationModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: false,
                                value: function (name) {
                                    return name.trim().split(/\s/g).join('').toLowerCase().replace(/[^a-z0-9]/g, '');
                                }
                            },
                            kind: 'init',
                            order: '@'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'findAvailableOrgId',
                                loc: {
                                    start: {
                                        line: 190,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/model/ApplicationModel.ion'
                                    },
                                    end: {
                                        line: 190,
                                        column: 26,
                                        fixed: true,
                                        source: 'viewpath/model/ApplicationModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context13) {
                                    return function (name, callback, start) {
                                        if (start == null)
                                            start = 0;
                                        var model = _context13.get('model'), Key = _context13.get('Key'), Organization = _context13.get('Organization');
                                        var baseId = model.orgNameToBaseId(name);
                                        var numberedId = function (i) {
                                            return baseId + (i === 0 ? '' : i);
                                        };
                                        var stride = 10;
                                        var _ref15 = [];
                                        for (var i = start; i < start + stride; i++)
                                            _ref15.push(numberedId(i));
                                        model.request(new Key(Organization, { where: { id: _ref15 } }), void 0, function (result) {
                                            for (var i = start; i < start + stride; i++) {
                                                var id = numberedId(i);
                                                var key = new Key(Organization, id);
                                                if (!(result[key] != null)) {
                                                    return callback(id);
                                                }
                                            }
                                            model.findAvailableOrgId(name, callback, start + stride);
                                        });
                                    };
                                }
                            },
                            kind: 'init',
                            order: 'A'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'createOrg',
                                loc: {
                                    start: {
                                        line: 207,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/model/ApplicationModel.ion'
                                    },
                                    end: {
                                        line: 207,
                                        column: 17,
                                        fixed: true,
                                        source: 'viewpath/model/ApplicationModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: true,
                                value: function (_context14) {
                                    return function (_ref14, callback) {
                                        var model = _context14.get('model'), Key = _context14.get('Key'), Organization = _context14.get('Organization'), ion = _context14.get('ion'), PermissionLevel = _context14.get('PermissionLevel'), Project = _context14.get('Project'), ProjectType = _context14.get('ProjectType');
                                        var name = _ref14.name;
                                        var adminKey = _ref14.adminKey;
                                        model.findAvailableOrgId(name, function (id) {
                                            var orgKey = new Key(Organization, id);
                                            var _ref16 = {};
                                            _ref16[adminKey] = ion.patch.combine(_ref16[adminKey], { owner: true });
                                            var org = new Organization({
                                                    key: orgKey.toString(),
                                                    name: name,
                                                    admins: _ref16
                                                });
                                            var _ref17 = {};
                                            {
                                                _ref17[orgKey] = org;
                                                var _ref20 = {};
                                                _ref20[orgKey.id.valueOf()] = ion.patch.combine(_ref20[orgKey.id.valueOf()], {});
                                                _ref17[adminKey] = ion.patch.combine(_ref17[adminKey], { orgs: _ref20 });
                                            }
                                            model.request('', _ref17, function () {
                                                var _ref18 = {};
                                                _ref18[adminKey] = ion.patch.combine(_ref18[adminKey], { permission: PermissionLevel.Owner.id });
                                                var calendar = model.addStandardWorkWeek(new Project({
                                                        key: new Key(Project, model.guid()).toString(),
                                                        type: ProjectType.Calendar.id,
                                                        name: 'Standard Work Week',
                                                        orgId: id,
                                                        createdBy: adminKey,
                                                        sharing: _ref18
                                                    }), function () {
                                                        var _ref19 = {};
                                                        _ref19[calendar.key] = ion.patch.combine(_ref19[calendar.key], {});
                                                        model.request(orgKey, { calendars: _ref19 }, function () {
                                                            return callback({
                                                                org: org,
                                                                orgKey: orgKey
                                                            });
                                                        });
                                                    });
                                            });
                                        });
                                    };
                                }
                            },
                            kind: 'init',
                            order: 'B'
                        },
                        {
                            type: 'Property',
                            key: {
                                type: 'Identifier',
                                name: 'openInDatastore',
                                loc: {
                                    start: {
                                        line: 235,
                                        column: 8,
                                        fixed: true,
                                        source: 'viewpath/model/ApplicationModel.ion'
                                    },
                                    end: {
                                        line: 235,
                                        column: 23,
                                        fixed: true,
                                        source: 'viewpath/model/ApplicationModel.ion'
                                    }
                                }
                            },
                            value: {
                                type: 'Function',
                                context: false,
                                value: function (key) {
                                    (function (key) {
                                        var parts = key.toString().split('/');
                                        for (var i = 0; i < parts.length; i++) {
                                            var part = i % 2 === 0 ? parts[i] : 'name:' + parts[i];
                                            part = part;
                                            parts[i] = '' + part.length + '/' + part;
                                        }
                                        var uriKey = '0/|' + parts.join('|');
                                        var url = 'https://console.cloud.google.com/datastore/entities/edit?key=' + uriKey + '&project=viewpath4';
                                        url = encodeURI(url);
                                        window.open(url);
                                    }(key));
                                }
                            },
                            kind: 'init',
                            order: 'C'
                        }
                    ]
                },
                order: '3'
            }
        ],
        bound: false
    }, {
        this: this,
        ion: ion,
        options: options,
        glass: glass,
        _ref: _ref,
        _ref2: _ref2,
        _ref3: _ref3,
        _ref4: _ref4,
        _ref5: _ref5,
        cloneRecursive: cloneRecursive,
        crypt: crypt,
        DateTime: DateTime,
        Timezone: Timezone,
        Http: Http,
        Key: Key,
        HashState: HashState,
        Organization: Organization,
        Project: Project,
        ProjectType: ProjectType,
        ScheduleConstraint: ScheduleConstraint,
        Task: Task,
        TaskType: TaskType,
        PermissionLevel: PermissionLevel,
        TimeUnit: TimeUnit
    }, null);
});
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/model/ApplicationModel',_viewpath_model_ApplicationModel_);
    else
      _viewpath_model_ApplicationModel_.call(this, module, exports, require);
  }
  else {
    _viewpath_model_ApplicationModel_.call(this);
  }
}).call(this)
void (function(){var _viewpath_model_AutoScheduler_ = function(module,exports,require){'use strict';
var _ref = require('./'), glass = require('glass'), ion = require('ion'), _ref2;
var Availability = _ref.Availability;
var Task = _ref.Task;
var Project = _ref.Project;
var User = _ref.User;
var Organization = _ref.Organization;
var ScheduleConstraint = _ref.ScheduleConstraint;
var TimeUnit = _ref.TimeUnit;
_ref2 = require('./ScheduleFunctions');
var ScheduleOptions = _ref2.ScheduleOptions;
var _ref3 = glass, min = function (values) {
        var value = null;
        for (var _i = 0; _i < values.length; _i++) {
            var check = values[_i];
            if (!(value != null) || check < value) {
                value = check;
            }
        }
        return value;
    }, max = function (values) {
        var value = null;
        for (var _i2 = 0; _i2 < values.length; _i2++) {
            var check = values[_i2];
            if (!(value != null) || check > value) {
                value = check;
            }
        }
        return value;
    }, createLookup = function (tasks, addId) {
        if (addId == null)
            addId = true;
        var lookup = {};
        for (var index in tasks) {
            var task = tasks[index];
            if (!(task.id != null) || !(task.key != null)) {
                console.warn('Task no id or key: ' + JSON.stringify(task));
                continue;
            }
            if (addId) {
                lookup[task.id] = task;
            }
            lookup[task.key] = task;
        }
        return lookup;
    }, mapToObject = function (map) {
        var object = {};
        map.forEach(function (value, key) {
            object[key] = value;
        });
        return object;
    }, getCalendarOwnerKeys = function (tasks, project, organization) {
        var calendarOwnerKeys = new Set();
        calendarOwnerKeys.add(project.key);
        if (organization) {
            calendarOwnerKeys.add(organization.key);
        }
        for (var taskKey in tasks) {
            var task = tasks[taskKey];
            var _ref4 = task;
            var assigned = _ref4.assigned;
            if (assigned != null) {
                for (var key in assigned) {
                    calendarOwnerKeys.add(key);
                }
            }
        }
        return calendarOwnerKeys;
    }, getAllUserScheduleQueryKeys = function (userMap, orgId) {
        var queryKeys = new Set();
        userMap.forEach(function (user, userKey) {
            var calendars = user.getCalendars(orgId);
            if (calendars != null) {
                for (var calendarKey in calendars) {
                    queryKeys.add(calendarKey);
                    queryKeys.add(calendarKey + '/Task');
                }
            }
        });
        return queryKeys;
    }, loadScheduleData = function (project, tasks, application, callback) {
        var organization = application.orgs[project.orgKey];
        var calendarOwnerKeys = getCalendarOwnerKeys(tasks, project, organization);
        application.server.waitForLoad(calendarOwnerKeys, function (userMap) {
            var queryKeys = getAllUserScheduleQueryKeys(userMap, project.orgId);
            application.server.waitForLoad(queryKeys, function (queryMap) {
                callback({
                    userMap: userMap,
                    queryMap: queryMap
                });
            });
        });
    }, getScheduleCalculator = function (_ref5, callback) {
        var project = _ref5.project;
        var tasks = _ref5.tasks;
        var application = _ref5.application;
        var options = _ref5.options;
        loadScheduleData(project, tasks, application, function (_ref6) {
            var userMap = _ref6.userMap;
            var queryMap = _ref6.queryMap;
            callback(new AutoScheduler({
                project: project,
                tasks: tasks,
                application: application,
                options: options,
                users: mapToObject(userMap),
                schedules: mapToObject(queryMap)
            }));
        });
    }, removeUnscheduledTasksAndClearSchedules = function (tasks) {
        var scheduledKeys = {};
        for (var key in tasks) {
            var task = tasks[key];
            if (task.ScheduleConstraint !== ScheduleConstraint.None) {
                scheduledKeys[key] = true;
            }
            if (task.predecessors != null) {
                for (var predecessorKey in task.predecessors) {
                    scheduledKeys[predecessorKey] = true;
                    scheduledKeys[key] = true;
                }
            }
        }
        var hasScheduledAncestor = function (task) {
            var parent = tasks[task.parentTaskKey];
            if (!(parent != null)) {
                return false;
            }
            return scheduledKeys[parent.key] || hasScheduledAncestor(parent);
        };
        var scheduleAncestors = function (task) {
            if (task != null) {
                scheduledKeys[task.key] = true;
                scheduleAncestors(tasks[task.parentTaskKey]);
            }
        };
        for (var key in tasks) {
            var task = tasks[key];
            if (scheduledKeys[key]) {
                scheduleAncestors(task);
            }
        }
        for (var key in tasks) {
            var task = tasks[key];
            if (hasScheduledAncestor(task)) {
                scheduledKeys[key] = true;
            }
        }
        var scheduledTasks = {};
        var unscheduledTasks = [];
        for (var key in tasks) {
            var task = tasks[key];
            if (scheduledKeys[key]) {
                scheduledTasks[key] = task;
            } else {
                unscheduledTasks.push(task);
            }
        }
        for (var _i3 = 0; _i3 < unscheduledTasks.length; _i3++) {
            var task = unscheduledTasks[_i3];
            task.clearSchedule();
        }
        return scheduledTasks;
    }, sortChildrenBeforeParents = function (tasks, lookup) {
        if (lookup == null)
            lookup = createLookup(tasks);
        var root = { name: 'root' };
        var edges = [];
        for (var key in tasks) {
            var task = tasks[key];
            edges.push([
                task,
                root
            ]);
            var children = task.children;
            if (children != null) {
                for (var id in children) {
                    var child = lookup[id];
                    if (child != null) {
                        edges.push([
                            child,
                            task
                        ]);
                    }
                }
            }
        }
        var results = toposort(edges);
        return results.slice(0, -1);
    }, getDateRangeFromTasks = function (tasks) {
        var min = new Date().beginningOfDay().toISOString();
        var max = min;
        var check = function (date) {
            if (date != null) {
                if (date < min) {
                    min = date;
                }
                if (date > max) {
                    max = date;
                }
            }
        };
        for (var name in tasks) {
            var task = tasks[name];
            check(task.start);
            check(task.finish);
            check(task.scheduleDate);
        }
        max = Date.create(max).addYears(1).beginningOfDay().toISOString();
        return [
            min,
            max
        ];
    }, getChildrenTotalWorkMinutesAndCompletedWorkMinutes = function (children) {
        var totalWorkMinutes = 0;
        var completedWorkMinutes = 0;
        for (var _i4 = 0; _i4 < children.length; _i4++) {
            var child = children[_i4];
            var value = child.workValue;
            var unit = child.workUnit;
            if (!(value != null)) {
                var assigned = Math.max(1, child.assignedCount);
                value = child.durationValue * assigned;
                unit = child.durationUnit;
            }
            var childWorkMinutes = TimeUnit[unit].workMinutes * value;
            totalWorkMinutes += childWorkMinutes;
            completedWorkMinutes += Math.round(childWorkMinutes * child.percent / 100);
        }
        return [
            totalWorkMinutes,
            completedWorkMinutes
        ];
    }, toPercent = function (completedUnits, totalUnits) {
        var percent = Math.round(completedUnits / totalUnits * 100);
        if (percent === 0 && completedUnits > 0) {
            percent = 1;
        }
        if (percent === 100 && completedUnits < totalUnits) {
            percent = 99;
        }
        return percent;
    }, calculateSummaryValues = function (children) {
        var _ref13 = [];
        for (var _i5 = 0; _i5 < children.length; _i5++) {
            var child = children[_i5];
            _ref13.push(child.startWithTime);
        }
        var start = min(_ref13);
        var _ref14 = [];
        for (var _i6 = 0; _i6 < children.length; _i6++) {
            var child = children[_i6];
            _ref14.push(child.finishWithTime);
        }
        var finish = max(_ref14);
        var _ref7 = getChildrenTotalWorkMinutesAndCompletedWorkMinutes(children);
        var total = _ref7[0];
        var completed = _ref7[1];
        var percent = toPercent(completed, total);
        var _ref8 = TimeUnit.totalMinutesToUnitValue(total);
        var value = _ref8.value;
        var unit = _ref8.unit;
        var workValue = value;
        var workUnit = unit;
        return {
            start: start,
            finish: finish,
            percent: percent,
            workValue: workValue,
            workUnit: workUnit
        };
    };
var toposort = _ref3.toposort;
var AutoScheduler = ion.defineClass({
        name: 'AutoScheduler',
        constructor: function AutoScheduler(_ref9) {
            var project = _ref9.project;
            var tasks = _ref9.tasks;
            var application = _ref9.application;
            var options = _ref9.options;
            var users = _ref9.users;
            var schedules = _ref9.schedules;
            this.org = application.orgs[project.orgKey];
            this.project = project;
            this.tasks = tasks;
            this.options = options != null ? options : {};
            this.taskLookup = createLookup(tasks);
            this.users = users;
            this.application = application;
            this.schedules = schedules;
            var _ref10 = getDateRangeFromTasks(tasks);
            var min = _ref10[0];
            var max = _ref10[1];
            this.start = min;
            this.finish = max;
            this.availabilityCache = {};
            this.defaultAvailability = (this.createAvailability(project) != null ? this.createAvailability(project) : this.createAvailability(this.org)) != null ? this.createAvailability(project) != null ? this.createAvailability(project) : this.createAvailability(this.org) : this.createDefaultAvailability(this.org);
            this.defaultAvailability.readonly = true;
            this.childrenLookup = {};
            for (var key in tasks) {
                var task = tasks[key];
                var parentId = task.parentId != null ? task.parentId : 'null';
                var children = this.childrenLookup[parentId] = this.childrenLookup[parentId] != null ? this.childrenLookup[parentId] : [];
                children.push(task);
            }
        },
        properties: {
            calculate: function () {
                this.removeBrokenLinksAndUpdatePredecessorPercent();
                {
                    var _ref19 = this.users;
                    for (var userKey in _ref19) {
                        var user = _ref19[userKey];
                        var availability = this.getAvailability(user);
                    }
                }
                var sortedTasks = this.getTasksInOrderOfOptimalCompletion({ tasks: this.tasks });
                var sortedForwards = [];
                for (var _i7 = 0; _i7 < sortedTasks.length; _i7++) {
                    var task = sortedTasks[_i7];
                    sortedForwards.push({
                        task: task,
                        constraints: this.getTaskConstraintProperties(task)
                    });
                }
                var sortedBackwards = sortedForwards.slice(0).reverse();
                var _ref15 = [];
                for (var _i8 = 0; _i8 < sortedBackwards.length; _i8++) {
                    var item = sortedBackwards[_i8];
                    if (item.constraints.ScheduleConstraint.alap.valueOf()) {
                        _ref15.push(item);
                    }
                }
                var alapTasks = _ref15;
                var _ref16 = [];
                for (var _i9 = 0; _i9 < sortedForwards.length; _i9++) {
                    var item = sortedForwards[_i9];
                    if (item.constraints.ScheduleConstraint.asap.valueOf()) {
                        _ref16.push(item);
                    }
                }
                var asapTasks = _ref16;
                for (var _i10 = 0; _i10 < alapTasks.length; _i10++) {
                    var _ref27 = alapTasks[_i10];
                    var task = _ref27.task;
                    var constraints = _ref27.constraints;
                    this.scheduleTask(task, constraints);
                }
                for (var _i11 = 0; _i11 < asapTasks.length; _i11++) {
                    var _ref28 = asapTasks[_i11];
                    var task = _ref28.task;
                    var constraints = _ref28.constraints;
                    this.scheduleTask(task, constraints);
                }
                this.calculateParentRollups();
                {
                    var _ref20 = this.tasks;
                    for (var name in _ref20) {
                        var task = _ref20[name];
                        var children = this.getChildren(task);
                        task.childCount = (children != null ? children.length : void 0) != null ? children.length : 0;
                    }
                }
                var _ref17 = [];
                {
                    var _ref21 = this.tasks;
                    for (var name in _ref21) {
                        var task = _ref21[name];
                        if (!(task.parentId != null)) {
                            _ref17.push(task);
                        }
                    }
                }
                var rootTasks = _ref17;
                {
                    var _ref22 = calculateSummaryValues(rootTasks);
                    for (var name in _ref22) {
                        var value = _ref22[name];
                        this.project[name] = value;
                    }
                }
            },
            removeBrokenLinksAndUpdatePredecessorPercent: function () {
                {
                    var _ref23 = this.tasks;
                    for (var path in _ref23) {
                        var task = _ref23[path];
                        if (task.parentId != null) {
                            if (!(this.taskLookup[task.parentId] != null)) {
                                delete task.parentId;
                            }
                        }
                        if (task.predecessors != null) {
                            for (var key in task.predecessors) {
                                var pred = this.taskLookup[key];
                                if (!pred) {
                                    delete task.predecessors[key];
                                } else {
                                    task.predecessors[key].percent = pred.percent;
                                }
                            }
                        }
                    }
                }
            },
            calculateParentRollups: function () {
                var sorted = sortChildrenBeforeParents(this.tasks, this.taskLookup);
                for (var _i12 = 0; _i12 < sorted.length; _i12++) {
                    var task = sorted[_i12];
                    var children = this.getChildren(task);
                    var setDuration = children != null || task.workValue != null;
                    if (children) {
                        var summaryValues = calculateSummaryValues(children);
                        for (var name in summaryValues) {
                            var value = summaryValues[name];
                            task[name] = value;
                        }
                    }
                    if (setDuration) {
                        task._calculateDuration();
                    }
                }
            },
            getTasksInOrderOfOptimalCompletion: function (_ref11) {
                var tasks = _ref11.tasks;
                tasks = removeUnscheduledTasksAndClearSchedules(tasks);
                var virtualRoot = {
                        name: 'Virtual Root',
                        virtual: true,
                        children: {}
                    };
                var virtualStartPrefix = '-start';
                var empty = {};
                var nodeProperties = 'id,key,priority,order,name,predecessors,parentId'.split(',');
                var createNode = ion.bind(function (task, virtualStart) {
                        var children = this.getChildren(task);
                        if (virtualStart && !children) {
                            return null;
                        }
                        var node = {
                                task: task,
                                children: children
                            };
                        for (var _i13 = 0; _i13 < nodeProperties.length; _i13++) {
                            var property = nodeProperties[_i13];
                            node[property] = task[property];
                        }
                        if (children) {
                            if (virtualStart) {
                                node.virtual = true;
                                node.id = node.id + virtualStartPrefix;
                                node.key = node.key + virtualStartPrefix;
                                node.name = node.name + virtualStartPrefix;
                            } else {
                                node.parentId = null;
                                node.predecessors = children;
                                node.children = empty;
                            }
                        }
                        return node;
                    }, this);
                var nodes = [];
                for (var name in tasks) {
                    var task = tasks[name];
                    var virtualNode = createNode(task, true);
                    if (virtualNode) {
                        nodes.push(virtualNode);
                    }
                    var actualNode = createNode(task, false);
                    if (actualNode) {
                        nodes.push(actualNode);
                    }
                }
                var lookup = createLookup(nodes, true);
                var getSortString = function (task, depth) {
                    if (depth == null)
                        depth = 0;
                    if (!(task != null)) {
                        return '';
                    }
                    if (depth > 20) {
                        debugger;
                    }
                    if (!(task.sortString != null)) {
                        task.sortString = getSortString(lookup[task.parentId], depth + 1) + String.fromCharCode(task.priority, task.order != null ? task.order : 0);
                    }
                    return task.sortString;
                };
                for (var _i14 = 0; _i14 < nodes.length; _i14++) {
                    var node = nodes[_i14];
                    getSortString(node);
                }
                var sortFunction = ion.createSortFunction([{ sortString: true }]);
                nodes = nodes.sort(sortFunction);
                var lookupTasks = function (object) {
                    var tasks = [];
                    if (Array.isArray(object)) {
                        object = createLookup(object);
                    }
                    for (var keyOrId in object) {
                        var task = lookup[keyOrId];
                        if (task != null) {
                            tasks.push(task);
                        }
                    }
                    return tasks;
                };
                var edges = [];
                for (var _i15 = 0; _i15 < nodes.length; _i15++) {
                    var task = nodes[_i15];
                    var added = 0;
                    var _ref12 = task;
                    var predecessors = _ref12.predecessors;
                    if (predecessors != null) {
                        predecessors = lookupTasks(predecessors);
                        if (Object.keys(predecessors).length < Object.keys(task.predecessors).length) {
                            console.error('predecessors length < task.predecessors length');
                        }
                        predecessors.sort(sortFunction);
                        for (var _i16 = 0; _i16 < predecessors.length; _i16++) {
                            var predecessor = predecessors[_i16];
                            added++;
                            edges.push([
                                predecessor,
                                task
                            ]);
                        }
                    }
                    if (task.parentId != null) {
                        var ancestor = lookup[task.parentId + virtualStartPrefix];
                        if (ancestor != null) {
                            added++;
                            edges.push([
                                ancestor,
                                task
                            ]);
                        }
                    }
                    if (added === 0) {
                        edges.push([
                            virtualRoot,
                            task
                        ]);
                    }
                }
                nodes = toposort(edges);
                for (var _i17 = 0; _i17 < nodes.length; _i17++) {
                    var node = nodes[_i17];
                    delete node.sortString;
                }
                var _ref18 = [];
                for (var _i18 = 0; _i18 < nodes.length; _i18++) {
                    var node = nodes[_i18];
                    if (!node.virtual) {
                        _ref18.push(node.task);
                    }
                }
                return _ref18;
            },
            defaultConstraintProperties: { value: { ScheduleConstraint: ScheduleConstraint.ASAP.valueOf() } },
            getTaskConstraintProperties: function (task) {
                var constraint = task != null ? task.ScheduleConstraint : void 0;
                if (constraint != null ? constraint.inherit : void 0) {
                    return this.getTaskConstraintProperties(this.taskLookup[task.parentId]);
                }
                return task != null ? task : this.defaultConstraintProperties;
            },
            scheduleTask: function (task, constraints) {
                var children = this.getChildren(task);
                if (children != null) {
                    var summary = calculateSummaryValues(children);
                    task.start = summary.start;
                    task.finish = summary.finish;
                } else {
                    if (task.complete && task.start != null && task.finish != null) {
                        return;
                    }
                    var predecessors = createLookup(this.getAllPredecessors(task), false);
                    var successors = createLookup(this.getAllSuccessors(task), false);
                    var scheduleOptions = ScheduleOptions.calculate(task, this.project, this.taskLookup);
                    var availability = this.getAvailability(this.getTaskAssignees(task));
                    availability.schedule(task, scheduleOptions);
                }
            },
            getAllSuccessors: function (task) {
                var _ref25 = [];
                {
                    var _ref24 = this.tasks;
                    for (var key in _ref24) {
                        var check = _ref24[key];
                        if (check.predecessors != null ? check.predecessors[task.key] : void 0) {
                            _ref25.push(check);
                        }
                    }
                }
                return _ref25;
            },
            getAllPredecessors: function (task) {
                return this.getTasksFromKeysOrIds(this.getAllPredecessorsKeys(task));
            },
            getAllPredecessorsKeys: function (task, addToThisObject) {
                if (addToThisObject == null)
                    addToThisObject = {};
                var predecessors = task.predecessors;
                if (predecessors != null) {
                    for (var id in predecessors) {
                        addToThisObject[id] = true;
                    }
                }
                var parent = this.taskLookup[task.parentId];
                if (parent != null) {
                    this.getAllPredecessorsKeys(parent, addToThisObject);
                }
                return addToThisObject;
            },
            getTasksFromKeysOrIds: function (object) {
                var _ref26 = [];
                if (object != null) {
                    for (var id in object) {
                        var task = this.taskLookup[id];
                        if (task != null) {
                            _ref26.push(task);
                        }
                    }
                }
                return _ref26;
            },
            getChildren: function (task) {
                return this.childrenLookup[task.id != null ? task.id : 'null'];
            },
            getPredecessors: function (task) {
                return this.getTasksFromKeysOrIds(task.predecessors);
            },
            getTaskAssignees: function (task) {
                for (var i = 0; i < 100; i++) {
                    if (!(task != null)) {
                        return null;
                    }
                    var assignedKeys = task.assignedKeys;
                    if (assignedKeys.length > 0) {
                        return assignedKeys;
                    }
                    task = this.taskLookup[task.parentId];
                }
            },
            getAvailability: function (owner) {
                if (Array.isArray(owner)) {
                    owner = owner[0];
                }
                if (typeof owner === 'string') {
                    owner = this.users[owner];
                }
                if (!(owner != null)) {
                    return this.defaultAvailability;
                }
                return this.availabilityCache[(owner != null ? owner.key : void 0) != null ? owner.key : 'default'] = this.availabilityCache[(owner != null ? owner.key : void 0) != null ? owner.key : 'default'] != null ? this.availabilityCache[(owner != null ? owner.key : void 0) != null ? owner.key : 'default'] : this.createAvailability(owner) != null ? this.createAvailability(owner) : this.defaultAvailability.clone({ readonly: true });
            },
            createAvailability: function (owner) {
                return Availability.createFromOwnersCalendar({
                    owner: owner,
                    orgId: this.project.orgId,
                    schedules: this.schedules,
                    start: this.start,
                    finish: this.finish
                });
            },
            createDefaultAvailability: function (owner) {
                return Availability.createFromDefaultTasks({
                    owner: owner,
                    start: this.start,
                    finish: this.finish
                });
            }
        }
    });
AutoScheduler;
var schedule = exports.schedule = function (args) {
        getScheduleCalculator(args, function (calculator) {
            args.options != null ? args.options.callbackBefore != null ? args.options.callbackBefore(calculator) : void 0 : void 0;
            calculator.calculate();
            args.options != null ? args.options.callbackAfter != null ? args.options.callbackAfter(calculator) : void 0 : void 0;
        });
    };
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/model/AutoScheduler',_viewpath_model_AutoScheduler_);
    else
      _viewpath_model_AutoScheduler_.call(this, module, exports, require);
  }
  else {
    _viewpath_model_AutoScheduler_.call(this);
  }
}).call(this)
void (function(){var _viewpath_model_Availability_ = function(module,exports,require){'use strict';
var ion = require('ion'), glass = require('glass'), _ref, _ref2, getMinutesSinceEpoch = function (isoDateString) {
        var millis = Date.parse(isoDateString);
        if (isNaN(millis)) {
            return -1;
        }
        return Math.round(millis / (60 * 1000));
    }, getIsoDateStringFromMinute = function (minute) {
        return new Date(minute * 60 * 1000).iso();
    }, overlaps = function (a, b, x, y) {
        return x < b && y > a;
    }, isEmpty = function (object) {
        if (!(object != null)) {
            return true;
        }
        for (var property in object) {
            return false;
        }
        return true;
    };
_ref = glass.time;
var DateTime = _ref.DateTime;
_ref2 = require('./');
var Task = _ref2.Task;
var TimeUnit = _ref2.TimeUnit;
var Availability = ion.defineClass({
        name: 'Availability',
        constructor: function Availability(dates, readonly) {
            if (readonly == null)
                readonly = false;
            if (dates.length === 0) {
                throw new Error('Dates must not be empty.');
            }
            this.dates = dates.constructor === Uint32Array ? dates : new Uint32Array(dates);
            this.readonly = readonly;
        },
        properties: {
            clone: function () {
                var availability = new Availability(this.dates.slice(0));
                {
                    var _ref15 = this;
                    for (var name in _ref15) {
                        var value = _ref15[name];
                        if (!availability.hasOwnProperty(name)) {
                            availability[name] = this[name];
                        }
                    }
                }
                return availability;
            },
            consumeUnknownInterval: function (startMinutes, finishMinutes, startIndex) {
                if (startIndex == null)
                    startIndex = 0;
                var _ref3 = this;
                var dates = _ref3.dates;
                var i = startIndex;
                while (i < dates.length) {
                    var start = dates[i + 0];
                    var finish = dates[i + 2];
                    if (overlaps(start, finish, startMinutes, finishMinutes)) {
                        this.consumeKnownInterval(startMinutes, finishMinutes, i);
                    } else if (start > finishMinutes) {
                        break;
                    }
                    i += 3;
                }
                return i;
            },
            consumeKnownInterval: function (startMinutes, finishMinutes, intervalIndex) {
                var _ref4 = this;
                var dates = _ref4.dates;
                if (startMinutes > finishMinutes) {
                    var temp = startMinutes;
                    startMinutes = finishMinutes;
                    finishMinutes = temp;
                }
                var intervalStart = dates[intervalIndex + 0];
                var intervalWasted = dates[intervalIndex + 1];
                var intervalFinish = dates[intervalIndex + 2];
                if (startMinutes > intervalStart && finishMinutes < intervalFinish) {
                    intervalWasted += finishMinutes - startMinutes;
                } else {
                    intervalStart = Math.min(intervalFinish, Math.max(intervalStart, finishMinutes));
                    intervalFinish = Math.max(intervalStart, Math.min(intervalFinish, startMinutes));
                }
                if (intervalWasted >= intervalFinish - intervalStart) {
                    intervalWasted = 0;
                    intervalStart = intervalFinish;
                }
                dates[intervalIndex + 0] = intervalStart;
                dates[intervalIndex + 1] = intervalWasted;
                dates[intervalIndex + 2] = intervalFinish;
            },
            schedule: function (task, options) {
                var unit = task.WorkUnit;
                var count = task.workValue;
                if (count > 0) {
                    var assignedCount = Math.max(1, task.assignedCount);
                    if (assignedCount > 0) {
                        count = Math.round(count * unit.workMinutes / assignedCount);
                        unit = TimeUnit.minutes.valueOf();
                    }
                } else {
                    unit = task.DurationUnit;
                    count = task.durationValue;
                }
                if (unit.workDays) {
                    count = count * unit.workDays;
                    unit = TimeUnit.days;
                }
                var consume = options.consume != null ? options.consume : true;
                var startMinimum = options.startMinimum != null ? options.startMinimum : 0;
                var finishMaximum = options.finishMaximum != null ? options.finishMaximum : Number.MAX_SAFE_INTEGER;
                var startMaximum = options.startMaximum != null ? options.startMaximum : null;
                var finishMinimum = options.finishMinimum != null ? options.finishMinimum : null;
                var reverse = options.asap === false;
                var forward = !reverse;
                if (typeof startMinimum === 'string') {
                    startMinimum = getMinutesSinceEpoch(startMinimum);
                }
                if (typeof finishMaximum === 'string') {
                    finishMaximum = getMinutesSinceEpoch(finishMaximum);
                }
                if (typeof startMaximum === 'string') {
                    startMaximum = getMinutesSinceEpoch(startMaximum);
                }
                if (typeof finishMinimum === 'string') {
                    finishMinimum = getMinutesSinceEpoch(finishMinimum);
                }
                var scheduleOption1 = this.scheduleInternal({
                        unit: unit,
                        count: count,
                        reverse: reverse,
                        consume: consume,
                        timeMinimum: startMinimum,
                        timeMaximum: finishMaximum
                    });
                var scheduleOption2 = null;
                if (forward && finishMinimum != null || reverse && startMaximum) {
                    scheduleOption2 = this.scheduleInternal({
                        unit: unit,
                        count: count,
                        reverse: !reverse,
                        consume: consume,
                        timeMinimum: startMaximum != null ? startMaximum : startMinimum,
                        timeMaximum: finishMinimum != null ? finishMinimum : finishMaximum
                    });
                }
                var constrain = function (scheduled) {
                    var start = scheduled[0];
                    var finish = scheduled[scheduled.length - 1];
                    start = Math.min(start, startMaximum != null ? startMaximum : finishMaximum);
                    finish = Math.max(finish, finishMinimum != null ? finishMinimum : startMinimum);
                    return [
                        start,
                        finish,
                        finish - start
                    ];
                };
                var option1 = constrain(scheduleOption1);
                var option2 = constrain(scheduleOption2 != null ? scheduleOption2 : scheduleOption1);
                var bestOption = option1[2] < option2[2] ? option1 : option2;
                var _ref5 = bestOption;
                var startMinute = _ref5[0];
                var finishMinute = _ref5[1];
                var startUTC = getIsoDateStringFromMinute(startMinute);
                var finishUTC = getIsoDateStringFromMinute(finishMinute);
                var notime = unit.elapsed && unit.minutes >= 1440 && (reverse ? (task.finish != null ? task.finish.indexOf('T') : void 0) < 0 : (task.start != null ? task.start.indexOf('T') : void 0) < 0);
                if (notime) {
                    task.start = startUTC.substring(0, startUTC.indexOf('T'));
                    task.finish = finishUTC.substring(0, finishUTC.indexOf('T'));
                } else {
                    task.setStartUTC(startUTC);
                    task.setFinishUTC(finishUTC);
                }
            },
            scheduleInternal: function (_ref6) {
                var unit = _ref6.unit;
                var count = _ref6.count;
                var reverse = _ref6.reverse;
                var consume = _ref6.consume;
                var timeMinimum = _ref6.timeMinimum;
                var timeMaximum = _ref6.timeMaximum;
                if (count === 0) {
                    var start = Math.max(timeMinimum, getMinutesSinceEpoch(new Date().beginningOfDay().toISOString()));
                    var finish = start;
                    return [
                        start,
                        finish
                    ];
                }
                var _ref7 = this;
                var dates = _ref7.dates;
                var direction = reverse ? -1 : +1;
                var minutes = unit.minutes;
                var minimum = unit.minimum != null ? unit.minimum : minutes;
                var maximum = unit.maximum != null ? unit.maximum : minutes;
                var scheduled = [];
                if (unit.elapsed) {
                    if (reverse) {
                        return [
                            timeMaximum - unit.minutes * count,
                            timeMaximum
                        ];
                    } else {
                        return [
                            timeMinimum,
                            timeMinimum + unit.minutes * count
                        ];
                    }
                }
                var constrain = function (value) {
                    if (reverse) {
                        return Math.min(timeMaximum, value);
                    } else {
                        return Math.max(timeMinimum, value);
                    }
                };
                var i = reverse ? dates.length - 1 : 0;
                while (i >= 0 && i < dates.length && count > 0) {
                    var start = constrain(dates[i]);
                    var wasted = dates[i + direction];
                    var finish = dates[i + direction * 2];
                    var interval = (finish - start) * direction;
                    var availableMinutes = interval - wasted;
                    if (availableMinutes > minimum) {
                        var availableUnits = Math.max(1, Math.floor(availableMinutes / minutes));
                        var consumeUnits = Math.min(count, availableUnits);
                        var consumeMinutes = Math.min(interval, consumeUnits * minutes);
                        var greedyMinutes = maximum - minutes;
                        if (consumeMinutes < interval) {
                            consumeMinutes = Math.min(interval, consumeMinutes + greedyMinutes);
                        }
                        var consumeFrom = start;
                        var consumeTo = consumeFrom + consumeMinutes * direction;
                        scheduled.push(consumeFrom, consumeTo);
                        if (consume && !this.readonly) {
                            this.consumeKnownInterval(consumeFrom, consumeTo, i);
                        }
                        count -= consumeUnits;
                    }
                    i += 3 * direction;
                }
                if (reverse) {
                    scheduled.reverse();
                }
                return scheduled;
            }
        },
        createFromVirtualTasks: function (_ref8) {
            var owner = _ref8.owner;
            var tasks = _ref8.tasks;
            var readonly = _ref8.readonly;
            var _ref12 = [];
            for (var _i = 0; _i < tasks.length; _i++) {
                var task = tasks[_i];
                if (task.start != null && task.finish != null) {
                    _ref12.push(task);
                }
            }
            var scheduledTasks = _ref12;
            scheduledTasks.sort(ion.createSortFunction([{ start: true }]));
            var _ref13 = [];
            for (var _i2 = 0; _i2 < scheduledTasks.length; _i2++) {
                var task = scheduledTasks[_i2];
                if (task.Type.scheduleOpen) {
                    _ref13.push(task);
                }
            }
            var shifts = _ref13;
            var dates = [];
            for (var _i3 = 0; _i3 < shifts.length; _i3++) {
                var task = shifts[_i3];
                var sm = getMinutesSinceEpoch(task.getStartUTC(owner));
                var fm = getMinutesSinceEpoch(task.getFinishUTC(owner));
                if (fm < 0) {
                    continue;
                }
                var lastFinish = dates[dates.length - 1];
                if (sm < lastFinish) {
                    sm = lastFinish;
                }
                if (sm >= fm) {
                    continue;
                }
                dates.push(sm, 0, fm);
            }
            if (dates.length === 0) {
                return null;
            }
            var availability = new Availability(dates, readonly);
            if (availability != null) {
                var _ref14 = [];
                for (var _i4 = 0; _i4 < scheduledTasks.length; _i4++) {
                    var task = scheduledTasks[_i4];
                    if (!task.Type.scheduleOpen) {
                        _ref14.push(task);
                    }
                }
                var busy = _ref14;
                var lastIndex = 0;
                for (var _i5 = 0; _i5 < busy.length; _i5++) {
                    var task = busy[_i5];
                    var start = getMinutesSinceEpoch(task.getStartUTC(owner));
                    var finish = getMinutesSinceEpoch(task.getFinishUTC(owner));
                    lastIndex = availability.consumeUnknownInterval(start, finish, lastIndex);
                }
            }
            return availability;
        },
        defaultTasks: {
            'Task/defaultWorkDay': new Task({
                name: 'Default Work Day',
                type: 4,
                repeatDays: 62,
                repeatCount: 1,
                repeatUnit: 1,
                durationValue: 8,
                durationUnit: 'hours',
                scheduleConstraint: 9,
                start: '2017-09-01T09:00:00',
                finish: '2017-09-01T17:00:00'
            })
        },
        createFromDefaultTasks: function (_ref9) {
            var owner = _ref9.owner;
            var start = _ref9.start;
            var finish = _ref9.finish;
            var readonly = _ref9.readonly;
            return this.createFromActualTasks({
                owner: owner,
                tasks: this.defaultTasks,
                start: start,
                finish: finish,
                readonly: readonly
            });
        },
        createFromActualTasks: function (_ref10) {
            var owner = _ref10.owner;
            var tasks = _ref10.tasks;
            var start = _ref10.start;
            var finish = _ref10.finish;
            var readonly = _ref10.readonly;
            if (isEmpty(tasks)) {
                return null;
            }
            var virtualTasks = [];
            for (var akey in tasks) {
                var atask = tasks[akey];
                {
                    var _ref16 = atask.getTimelineInstances({
                            start: start,
                            finish: finish
                        });
                    for (var _i6 = 0; _i6 < _ref16.length; _i6++) {
                        var vtask = _ref16[_i6];
                        virtualTasks.push(vtask);
                    }
                }
            }
            var availability = Availability.createFromVirtualTasks({
                    owner: owner,
                    tasks: virtualTasks,
                    readonly: readonly
                });
            if (availability != null) {
                availability.actualTasks = tasks;
            }
            return availability;
        },
        createFromOwnersCalendar: function (_ref11) {
            var owner = _ref11.owner;
            var orgId = _ref11.orgId;
            var schedules = _ref11.schedules;
            var start = _ref11.start;
            var finish = _ref11.finish;
            var filter = _ref11.filter;
            if (!(owner != null)) {
                return null;
            }
            var tasks = {};
            var calendars = owner.getCalendars(orgId);
            if (!(calendars != null)) {
                return null;
            }
            if (Object.keys(calendars).length === 0) {
                return null;
            }
            var readonly = owner.areCalendarsReadonly(orgId);
            for (var calendarKey in calendars) {
                var calendarTasksKey = calendarKey + '/Task';
                var calendarTasks = schedules[calendarTasksKey];
                if (calendarTasks != null) {
                    for (var key in calendarTasks) {
                        var task = calendarTasks[key];
                        tasks[key] = task;
                    }
                }
            }
            var availability = Availability.createFromActualTasks({
                    owner: owner,
                    tasks: tasks,
                    start: start,
                    finish: finish,
                    readonly: readonly
                });
            if (availability != null) {
                availability.owner = owner;
            }
            return availability;
        }
    });
module.exports = exports = Availability;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/model/Availability',_viewpath_model_Availability_);
    else
      _viewpath_model_Availability_.call(this, module, exports, require);
  }
  else {
    _viewpath_model_Availability_.call(this);
  }
}).call(this)
void (function(){var _viewpath_model_Comment_ = function(module,exports,require){'use strict';
var ion = require('ion');
var glass = require('glass');
var Comment = ion.defineClass({
        name: 'Comment',
        id: module.id,
        persistent: true,
        description: 'Represents a Users Comment on a Task',
        defaultProperties: ['text'],
        access: true,
        properties: {
            text: {
                type: 'string',
                format: 'markdown',
                required: true,
                minLength: 1,
                maxLength: 20000
            },
            toString: function () {
                return this.text;
            }
        }
    }, require('./OwnedEntity'));
module.exports = exports = Comment;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/model/Comment',_viewpath_model_Comment_);
    else
      _viewpath_model_Comment_.call(this, module, exports, require);
  }
  else {
    _viewpath_model_Comment_.call(this);
  }
}).call(this)
void (function(){var _viewpath_model_Document_ = function(module,exports,require){'use strict';
var ion = require('ion');
var glass = require('glass'), Tag = require('./Tag');
var Document = ion.defineClass({
        name: 'Document',
        id: module.id,
        serializable: true,
        description: 'Represents an uploaded or linked Document',
        properties: {
            link: {
                required: false,
                minLength: 8,
                maxLength: 500
            },
            file: {
                required: false,
                minLength: 1,
                maxLength: 500
            },
            getUrl: function () {
                return this.link;
            },
            toString: function () {
                return this.name;
            }
        }
    });
module.exports = exports = Document;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/model/Document',_viewpath_model_Document_);
    else
      _viewpath_model_Document_.call(this, module, exports, require);
  }
  else {
    _viewpath_model_Document_.call(this);
  }
}).call(this)
void (function(){var _viewpath_model_Notification_ = function(module,exports,require){'use strict';
var ion = require('ion'), glass = require('glass'), _ref, _ref2, getTimeStamp = function (minutes) {
        if (minutes !== 60) {
            throw new Error('didn\'t implement these minutes yet cuz I\'m lazy: ' + minutes);
        }
        var date = new Date().toISOString();
        return date.substring(0, date.indexOf('T') + 3);
    };
_ref = glass.data;
var Key = _ref.Key;
_ref2 = require('./');
var NotificationType = _ref2.NotificationType;
var Notification = ion.defineClass({
        name: 'Notification',
        id: module.id,
        persistent: true,
        merge: false,
        access: {
            read: true,
            write: false
        },
        properties: {
            type: {
                index: true,
                type: 'integer',
                enum: NotificationType.keys,
                values: NotificationType.values,
                required: true
            },
            Type: {
                get: function () {
                    return NotificationType[this.type];
                }
            },
            details: {
                type: 'object',
                required: true
            },
            subscribed: {
                index: true,
                type: 'array',
                items: {
                    type: 'string',
                    format: 'email'
                }
            },
            priority: {
                index: true,
                get: function () {
                    return this.Type.priority;
                }
            },
            sent: {
                index: true,
                type: 'boolean',
                value: false,
                required: true
            }
        },
        create: function (_ref3) {
            var parentKey = _ref3.parentKey;
            var type = _ref3.type;
            var details = _ref3.details;
            var subscribed = _ref3.subscribed;
            var changes = _ref3.changes;
            type = NotificationType[type.id != null ? type.id : type];
            var newKey = parentKey + '/Notification/' + type.name + '@' + getTimeStamp(type.minutes);
            changes[newKey] = new Notification({
                type: type.id,
                details: details,
                subscribed: subscribed
            });
        },
        test: function () {
        }
    }, glass.model.Entity);
module.exports = exports = Notification;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/model/Notification',_viewpath_model_Notification_);
    else
      _viewpath_model_Notification_.call(this, module, exports, require);
  }
  else {
    _viewpath_model_Notification_.call(this);
  }
}).call(this)
void (function(){var _viewpath_model_NotificationPriority_ = function(module,exports,require){'use strict';
var items = [
        {
            id: 0,
            name: 'minute'
        },
        {
            id: 1,
            name: 'hour'
        },
        {
            id: 2,
            name: 'day'
        }
    ];
var _ref = {};
{
    _ref.keys = items.map(function (x) {
        return x.id;
    });
    _ref.values = items;
    for (var key in items) {
        var value = items[key];
        _ref[value.name] = value;
    }
}
module.exports = exports = _ref;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/model/NotificationPriority',_viewpath_model_NotificationPriority_);
    else
      _viewpath_model_NotificationPriority_.call(this, module, exports, require);
  }
  else {
    _viewpath_model_NotificationPriority_.call(this);
  }
}).call(this)
void (function(){var _viewpath_model_NotificationType_ = function(module,exports,require){'use strict';
var ion = require('ion');
var _ref = require('./');
var NotificationPriority = _ref.NotificationPriority;
var items = [{
            id: 0,
            name: 'Reassigned',
            minutes: 60,
            priority: NotificationPriority.minute.id,
            message: function (notification, user) {
                var _ref2 = notification;
                var details = _ref2.details;
                var _ref3 = {};
                {
                    if (details.assigned.indexOf(user.key) >= 0) {
                        _ref3.body = 'You\'ve been assigned to ' + details.taskName + '.';
                    } else if (details.unassigned.indexOf(user.key) >= 0) {
                        _ref3.body = 'You\'ve been unassigned from ' + details.taskName + '.';
                    } else {
                        _ref3.body = 'The task {{{{details.taskName}}}} has been reassigned.';
                    }
                    _ref3.config = ion.patch.combine(_ref3.config, {
                        panes: [
                            { id: 'Dashboard' },
                            {
                                id: 'Task',
                                key: notification.getKey().parent,
                                target: 'dialog'
                            }
                        ]
                    });
                }
                return _ref3;
            }
        }];
var _ref4 = {};
{
    _ref4.keys = items.map(function (x) {
        return x.id;
    });
    _ref4.values = items;
    for (var key in items) {
        var value = items[key];
        _ref4[value.id] = value;
        _ref4[value.name] = value;
    }
}
module.exports = exports = _ref4;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/model/NotificationType',_viewpath_model_NotificationType_);
    else
      _viewpath_model_NotificationType_.call(this, module, exports, require);
  }
  else {
    _viewpath_model_NotificationType_.call(this);
  }
}).call(this)
void (function(){var _viewpath_model_Organization_ = function(module,exports,require){'use strict';
var ion = require('ion');
var glass = require('glass'), Tag = require('./Tag'), ProjectType = require('./ProjectType');
var Organization = ion.defineClass({
        name: 'Organization',
        id: module.id,
        persistent: true,
        description: 'Represents a Viewpath Organizations account settings and administrative permissions',
        getIdFromUrl: function (url) {
            var match = url.match(/\/org\/([a-z0-9]+)/);
            return match != null ? match[1] : void 0;
        },
        access: {
            read: function (c) {
                if (this.admins[c.user.key] != null || c.user.isInOrg(this.id)) {
                    return true;
                }
                if (c.key.id != null || Array.isArray(c.key.query != null ? c.key.query.where != null ? c.key.query.where.id : void 0 : void 0)) {
                    return null;
                } else {
                    return false;
                }
            },
            write: function (c) {
                return this.admins[c.user.key] != null;
            },
            delete: function (c) {
                return this.admins[c.user.key] != null && Object.keys(this.admins).length === 1 && this.createdBy === c.user.key;
            }
        },
        properties: {
            id: {
                index: true,
                minLength: 2,
                maxLength: 32,
                pattern: '[a-z0-9]+',
                errorMessage: 'Valid unique id is required',
                required: true
            },
            name: {
                type: 'string',
                required: true,
                minLength: 1,
                maxLength: 200,
                index: true,
                errorMessage: 'Name is required'
            },
            getCalendars: function (orgId) {
                return this.calendars;
            },
            areCalendarsReadonly: function (orgId) {
                return true;
            },
            calendars: {
                name: 'Default Calendars',
                type: 'object',
                required: false,
                foreign: {
                    type: 'Project',
                    getSearchKeys: function (record, text) {
                        var key = new Key(Project, {
                                where: {
                                    orgId: this.id,
                                    type: ProjectType.Calendar.id.valueOf()
                                },
                                sort: [{ name: true }]
                            });
                        return [key.toString()];
                    }
                }
            },
            tags: {
                type: 'object',
                required: false,
                additionalProperties: Object.assign({}, Tag)
            },
            url: {
                get: function () {
                    return '#org/' + this.id;
                }
            },
            paneConfig: {
                get: function () {
                    return {
                        id: 'Org',
                        key: this.key,
                        tab: 'users'
                    };
                }
            },
            admins: {
                type: 'object',
                required: true
            },
            adminKeys: {
                type: 'array',
                index: true,
                get: function () {
                    return Object.keys(this.admins);
                }
            },
            dirty: {
                type: 'boolean',
                index: true,
                access: false
            },
            lastSync: {
                type: 'string',
                format: 'date-time'
            },
            salesforceToken: {
                type: 'object',
                access: {
                    read: false,
                    write: function (c) {
                        return this.admins[c.user.key] != null;
                    }
                }
            },
            salesforceSyncEnabled: {
                type: 'boolean',
                index: true,
                get: function () {
                    return this.salesforceToken != null;
                }
            },
            toString: function () {
                return this.name;
            }
        }
    }, glass.model.Entity);
module.exports = exports = Organization;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/model/Organization',_viewpath_model_Organization_);
    else
      _viewpath_model_Organization_.call(this, module, exports, require);
  }
  else {
    _viewpath_model_Organization_.call(this);
  }
}).call(this)
void (function(){var _viewpath_model_OwnedEntity_ = function(module,exports,require){'use strict';
var ion = require('ion');
var glass = require('glass');
var accessFunction = function (c) {
    var orgId = this.orgId;
    if (orgId != null) {
        return c.user.isInOrg(orgId);
    } else {
        return this.createdBy === c.user.key;
    }
};
var OwnedEntity = ion.defineClass({
        name: 'OwnedEntity',
        id: module.id,
        access: {
            read: accessFunction,
            write: accessFunction,
            delete: accessFunction
        },
        properties: {
            orgId: {
                external: false,
                type: 'string',
                index: true,
                foreign: {
                    type: 'Organization',
                    property: 'id'
                },
                stamp: {
                    type: 'custom',
                    overwrite: false,
                    custom: function (_ref) {
                        var key = _ref.key;
                        var securityObjects = _ref.securityObjects;
                        return securityObjects[key.root] != null ? securityObjects[key.root].orgId : void 0;
                    }
                }
            },
            orgKey: {
                label: 'Organization',
                format: 'key',
                foreign: {
                    type: 'Organization',
                    property: 'key'
                },
                get: function () {
                    return this.orgId ? this.constructor.getKey('Organization/' + this.orgId) : null;
                },
                visible: true
            }
        }
    }, glass.model.Entity);
module.exports = exports = OwnedEntity;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/model/OwnedEntity',_viewpath_model_OwnedEntity_);
    else
      _viewpath_model_OwnedEntity_.call(this, module, exports, require);
  }
  else {
    _viewpath_model_OwnedEntity_.call(this);
  }
}).call(this)
void (function(){var _viewpath_model_PermissionLevel_ = function(module,exports,require){'use strict';
var observer = {
        id: 0,
        name: 'Observer',
        selectable: true,
        read: true,
        write: false,
        writeTasks: false,
        delete: false,
        deleteTasks: false,
        manager: false
    }, editor = {
        id: 1,
        name: 'Editor',
        selectable: true,
        read: true,
        write: false,
        writeTasks: true,
        delete: false,
        deleteTasks: true,
        manager: false
    }, owner = {
        id: 2,
        name: 'Owner',
        selectable: true,
        read: true,
        write: true,
        writeTasks: true,
        delete: true,
        deleteTasks: true,
        manager: true
    }, collaborator = {
        id: 3,
        name: 'Collaborator',
        selectable: false,
        read: true,
        write: false,
        writeTasks: false,
        delete: false,
        deleteTasks: false,
        manager: false
    };
var items = [
        observer,
        editor,
        owner,
        collaborator
    ];
var _ref = {};
{
    _ref.keys = items.map(function (x) {
        return x.id;
    });
    _ref.values = items;
    var _ref2 = [];
    for (var _i = 0; _i < items.length; _i++) {
        var value = items[_i];
        if (value.selectable) {
            _ref2.push(value);
        }
    }
    _ref.selectable = _ref2;
    for (var key in items) {
        var value = items[key];
        _ref[value.id] = value;
        _ref[value.name] = value;
    }
    _ref.default = collaborator;
}
module.exports = exports = _ref;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/model/PermissionLevel',_viewpath_model_PermissionLevel_);
    else
      _viewpath_model_PermissionLevel_.call(this, module, exports, require);
  }
  else {
    _viewpath_model_PermissionLevel_.call(this);
  }
}).call(this)
void (function(){var _viewpath_model_Priority_ = function(module,exports,require){'use strict';
var items = [
        {
            id: 0,
            name: 'Urgent'
        },
        {
            id: 1,
            name: 'High'
        },
        {
            id: 2,
            name: 'Medium'
        },
        {
            id: 3,
            name: 'Low'
        },
        {
            id: 4,
            name: 'None'
        }
    ];
var _ref = {};
{
    _ref.keys = items.map(function (x) {
        return x.id;
    });
    _ref.values = items;
    for (var key in items) {
        var value = items[key];
        _ref[value.name] = value;
    }
}
module.exports = exports = _ref;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/model/Priority',_viewpath_model_Priority_);
    else
      _viewpath_model_Priority_.call(this, module, exports, require);
  }
  else {
    _viewpath_model_Priority_.call(this);
  }
}).call(this)
void (function(){var _viewpath_model_Project_ = function(module,exports,require){'use strict';
var ion = require('ion');
var glass = require('glass'), _ref, _ref2, _ref3, _ref4;
_ref = glass.data;
var Key = _ref.Key;
_ref2 = glass.time;
var DateTime = _ref2.DateTime;
_ref3 = require('./');
var User = _ref3.User;
var Organization = _ref3.Organization;
var ProjectType = _ref3.ProjectType;
var PermissionLevel = _ref3.PermissionLevel;
var TimeUnit = _ref3.TimeUnit;
var OwnedEntity = _ref3.OwnedEntity;
var TaskStatus = _ref3.TaskStatus;
_ref4 = require('../html');
var TaskTimelineBox = _ref4.TaskTimelineBox;
var alreadyWarned = false;
var Project = ion.defineClass({
        name: 'Project',
        id: module.id,
        persistent: true,
        description: 'Represents a scheduled Project or an ongoing Process',
        defaultProperties: [
            'name',
            'ownerId',
            'updated',
            'updatedBy',
            'created',
            'createdBy'
        ],
        descendantTypes: { Task: true },
        getSearchKeys: function (_ref5) {
            var text = _ref5.text;
            var orgId = _ref5.orgId;
            text = text.trim();
            var stem = text.substring(0, Project.properties.stems.items.maxLength);
            var _ref8 = [];
            if (stem.length >= Project.properties.stems.items.minLength) {
                _ref8.push(new Key(Project, {
                    where: {
                        orgId: orgId,
                        stems: stem
                    },
                    limit: 50
                }).toString());
            }
            return _ref8;
        },
        access: {
            read: function (c) {
                return this.getPermission(c.user.key).read;
            },
            write: function (c) {
                return this.getPermission(c.user.key).write;
            },
            delete: function (c) {
                return this.getPermission(c.user.key).delete;
            }
        },
        properties: {
            getTimelineComponents: ion.template(function (_ref6) {
                return ion.createRuntime({
                    type: 'Template',
                    id: null,
                    body: [
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'start',
                                        loc: {
                                            start: {
                                                line: 34,
                                                column: 42,
                                                fixed: true,
                                                source: 'viewpath/model/Project.ion'
                                            },
                                            end: {
                                                line: 34,
                                                column: 47,
                                                fixed: true,
                                                source: 'viewpath/model/Project.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'MemberExpression',
                                        object: {
                                            type: 'Identifier',
                                            name: '_ref6'
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'start',
                                            loc: {
                                                start: {
                                                    line: 34,
                                                    column: 42,
                                                    fixed: true,
                                                    source: 'viewpath/model/Project.ion'
                                                },
                                                end: {
                                                    line: 34,
                                                    column: 47,
                                                    fixed: true,
                                                    source: 'viewpath/model/Project.ion'
                                                }
                                            }
                                        },
                                        computed: false
                                    }
                                }],
                            kind: 'let',
                            order: '0'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'finish',
                                        loc: {
                                            start: {
                                                line: 34,
                                                column: 48,
                                                fixed: true,
                                                source: 'viewpath/model/Project.ion'
                                            },
                                            end: {
                                                line: 34,
                                                column: 54,
                                                fixed: true,
                                                source: 'viewpath/model/Project.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'MemberExpression',
                                        object: {
                                            type: 'Identifier',
                                            name: '_ref6'
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'finish',
                                            loc: {
                                                start: {
                                                    line: 34,
                                                    column: 48,
                                                    fixed: true,
                                                    source: 'viewpath/model/Project.ion'
                                                },
                                                end: {
                                                    line: 34,
                                                    column: 54,
                                                    fixed: true,
                                                    source: 'viewpath/model/Project.ion'
                                                }
                                            }
                                        },
                                        computed: false
                                    }
                                }],
                            kind: 'let',
                            order: '1'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'row',
                                        loc: {
                                            start: {
                                                line: 34,
                                                column: 55,
                                                fixed: true,
                                                source: 'viewpath/model/Project.ion'
                                            },
                                            end: {
                                                line: 34,
                                                column: 58,
                                                fixed: true,
                                                source: 'viewpath/model/Project.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'MemberExpression',
                                        object: {
                                            type: 'Identifier',
                                            name: '_ref6'
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'row',
                                            loc: {
                                                start: {
                                                    line: 34,
                                                    column: 55,
                                                    fixed: true,
                                                    source: 'viewpath/model/Project.ion'
                                                },
                                                end: {
                                                    line: 34,
                                                    column: 58,
                                                    fixed: true,
                                                    source: 'viewpath/model/Project.ion'
                                                }
                                            }
                                        },
                                        computed: false
                                    }
                                }],
                            kind: 'let',
                            order: '2'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'column',
                                        loc: {
                                            start: {
                                                line: 34,
                                                column: 59,
                                                fixed: true,
                                                source: 'viewpath/model/Project.ion'
                                            },
                                            end: {
                                                line: 34,
                                                column: 65,
                                                fixed: true,
                                                source: 'viewpath/model/Project.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'MemberExpression',
                                        object: {
                                            type: 'Identifier',
                                            name: '_ref6'
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'column',
                                            loc: {
                                                start: {
                                                    line: 34,
                                                    column: 59,
                                                    fixed: true,
                                                    source: 'viewpath/model/Project.ion'
                                                },
                                                end: {
                                                    line: 34,
                                                    column: 65,
                                                    fixed: true,
                                                    source: 'viewpath/model/Project.ion'
                                                }
                                            }
                                        },
                                        computed: false
                                    }
                                }],
                            kind: 'let',
                            order: '3'
                        },
                        {
                            type: 'ReturnStatement',
                            argument: {
                                type: 'ArrayExpression',
                                elements: [{
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'Identifier',
                                            name: 'TaskTimelineBox',
                                            loc: {
                                                start: {
                                                    line: 35,
                                                    column: 20,
                                                    fixed: true,
                                                    source: 'viewpath/model/Project.ion'
                                                },
                                                end: {
                                                    line: 35,
                                                    column: 35,
                                                    fixed: true,
                                                    source: 'viewpath/model/Project.ion'
                                                }
                                            }
                                        },
                                        arguments: [{
                                                type: 'ObjectExpression',
                                                properties: [
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'record',
                                                            loc: {
                                                                start: {
                                                                    line: 35,
                                                                    column: 37,
                                                                    fixed: true,
                                                                    source: 'viewpath/model/Project.ion'
                                                                },
                                                                end: {
                                                                    line: 35,
                                                                    column: 43,
                                                                    fixed: true,
                                                                    source: 'viewpath/model/Project.ion'
                                                                }
                                                            }
                                                        },
                                                        value: { type: 'ThisExpression' },
                                                        kind: 'init',
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'row',
                                                            loc: {
                                                                start: {
                                                                    line: 35,
                                                                    column: 49,
                                                                    fixed: true,
                                                                    source: 'viewpath/model/Project.ion'
                                                                },
                                                                end: {
                                                                    line: 35,
                                                                    column: 52,
                                                                    fixed: true,
                                                                    source: 'viewpath/model/Project.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Identifier',
                                                            name: 'row',
                                                            loc: {
                                                                start: {
                                                                    line: 35,
                                                                    column: 49,
                                                                    fixed: true,
                                                                    source: 'viewpath/model/Project.ion'
                                                                },
                                                                end: {
                                                                    line: 35,
                                                                    column: 52,
                                                                    fixed: true,
                                                                    source: 'viewpath/model/Project.ion'
                                                                }
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '1'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'column',
                                                            loc: {
                                                                start: {
                                                                    line: 35,
                                                                    column: 53,
                                                                    fixed: true,
                                                                    source: 'viewpath/model/Project.ion'
                                                                },
                                                                end: {
                                                                    line: 35,
                                                                    column: 59,
                                                                    fixed: true,
                                                                    source: 'viewpath/model/Project.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Identifier',
                                                            name: 'column',
                                                            loc: {
                                                                start: {
                                                                    line: 35,
                                                                    column: 53,
                                                                    fixed: true,
                                                                    source: 'viewpath/model/Project.ion'
                                                                },
                                                                end: {
                                                                    line: 35,
                                                                    column: 59,
                                                                    fixed: true,
                                                                    source: 'viewpath/model/Project.ion'
                                                                }
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '2'
                                                    }
                                                ]
                                            }],
                                        loc: {
                                            start: {
                                                line: 35,
                                                column: 20,
                                                fixed: true,
                                                source: 'viewpath/model/Project.ion'
                                            },
                                            end: {
                                                line: 35,
                                                column: 61,
                                                fixed: true,
                                                source: 'viewpath/model/Project.ion'
                                            }
                                        }
                                    }]
                            },
                            order: '4'
                        }
                    ],
                    bound: false,
                    name: {
                        type: 'Identifier',
                        name: 'getTimelineComponents',
                        loc: {
                            start: {
                                line: 34,
                                column: 8,
                                fixed: true,
                                source: 'viewpath/model/Project.ion'
                            },
                            end: {
                                line: 34,
                                column: 29,
                                fixed: true,
                                source: 'viewpath/model/Project.ion'
                            }
                        }
                    }
                }, {
                    this: this,
                    _ref6: _ref6,
                    glass: glass,
                    _ref: _ref,
                    _ref2: _ref2,
                    _ref3: _ref3,
                    _ref4: _ref4,
                    Key: Key,
                    DateTime: DateTime,
                    User: User,
                    Organization: Organization,
                    ProjectType: ProjectType,
                    PermissionLevel: PermissionLevel,
                    TimeUnit: TimeUnit,
                    OwnedEntity: OwnedEntity,
                    TaskStatus: TaskStatus,
                    TaskTimelineBox: TaskTimelineBox,
                    alreadyWarned: alreadyWarned,
                    Project: Project
                }, null);
            }),
            name: {
                index: true,
                search: { weight: 4 },
                type: 'string',
                required: true,
                minLength: 1,
                averageLength: 40,
                maxLength: 200,
                value: 'New Project',
                link: 'url',
                primary: true
            },
            status: {
                index: true,
                visible: true,
                enum: TaskStatus.keys,
                values: TaskStatus.values,
                columnType: 'viewpath/html/StatusColumn',
                get: function () {
                    if (this.percent === 100) {
                        return TaskStatus.Complete.id;
                    }
                    if (this.percent > 0) {
                        return TaskStatus.Started.id;
                    }
                    if (this.start != null) {
                        return TaskStatus.Scheduled.id;
                    }
                    return TaskStatus.Unscheduled.id;
                }
            },
            plannedStart: {
                visible: true,
                type: 'string',
                format: 'date-time',
                required: false
            },
            plannedFinish: {
                visible: true,
                type: 'string',
                format: 'date-time',
                required: false
            },
            alap: {
                label: 'Schedule from Planned Finish',
                visible: true,
                type: 'boolean',
                value: false
            },
            start: {
                label: 'Actual Start',
                editable: false,
                visible: true,
                type: 'string',
                format: 'date-time'
            },
            finish: {
                label: 'Actual Finish',
                editable: false,
                visible: true,
                type: 'string',
                format: 'date-time'
            },
            startWithTime: {
                get: function () {
                    var start = this.start;
                    if (start && start.indexOf('T') < 0) {
                        start += 'T00:00:00';
                    }
                    return start;
                }
            },
            finishWithTime: {
                get: function () {
                    var finish = this.finish;
                    if (finish && finish.indexOf('T') < 0) {
                        finish += 'T24:00:00';
                    }
                    return finish;
                }
            },
            Start: {
                description: 'Returns start as a glass.time.DateTime object or null',
                get: function () {
                    return DateTime.parse(this.start);
                },
                set: function (value) {
                    return this.start = (value != null ? value.iso != null ? value.iso() : void 0 : void 0) != null ? value.iso() : null;
                }
            },
            Finish: {
                description: 'Returns finish as a glass.time.DateTime object or null',
                get: function () {
                    return DateTime.parse(this.finish);
                },
                set: function (value) {
                    return this.finish = (value != null ? value.iso != null ? value.iso() : void 0 : void 0) != null ? value.iso() : null;
                }
            },
            percent: {
                editable: false,
                visible: true,
                label: '%',
                index: true,
                minimum: 0,
                maximum: 100,
                percent: true,
                value: 0,
                type: 'integer'
            },
            workValue: {
                visible: false,
                type: 'integer',
                minimum: 0,
                value: null
            },
            workUnit: {
                visible: false,
                type: 'string',
                enum: TimeUnit.keys,
                values: TimeUnit.values,
                value: TimeUnit.Days.id
            },
            work: {
                label: 'Actual Work',
                visible: true,
                editable: false,
                get: function () {
                    return {
                        value: this.workValue,
                        unit: this.workUnit,
                        toString: function () {
                            if (!(this.value != null)) {
                                return '';
                            } else {
                                return '' + this.value + ' ' + TimeUnit[this.unit][this.value === 1 ? 'labelSingular' : 'labelPlural'];
                            }
                        }
                    };
                }
            },
            timezone: {
                type: 'string',
                required: false,
                format: 'timezone'
            },
            master: {
                type: 'string',
                format: 'key',
                foreign: {
                    type: 'Project',
                    property: 'key'
                }
            },
            description: {
                search: { weight: 1 },
                visible: true,
                type: 'string',
                averageLength: 100,
                maxLength: 2000
            },
            picture: {
                type: 'string',
                format: 'url'
            },
            typeId: {
                visible: false,
                get: function () {
                    return this.type;
                },
                set: function (value) {
                    this.type = value != null ? value : 0;
                }
            },
            type: {
                index: true,
                type: 'integer',
                enum: ProjectType.keys,
                values: ProjectType.values,
                value: 0
            },
            Type: {
                get: function () {
                    return ProjectType[this.type];
                }
            },
            isTemplate: {
                get: function () {
                    return this.type === ProjectType.Template.id;
                }
            },
            getCalendars: function (orgId) {
                return this.calendars;
            },
            areCalendarsReadonly: function (orgId) {
                return true;
            },
            calendars: {
                type: 'object',
                required: false,
                foreign: {
                    type: 'Project',
                    getSearchKeys: function (record, text) {
                        if (record.orgId != null) {
                            return [new Key(Project, {
                                    where: {
                                        orgId: record.orgId,
                                        type: ProjectType.Calendar.id.valueOf()
                                    },
                                    sort: [{ name: true }]
                                })];
                        }
                        return [];
                    }
                }
            },
            active: {
                index: true,
                type: 'boolean',
                get: function () {
                    return !this.archived;
                }
            },
            archived: {
                index: true,
                type: 'boolean',
                value: false
            },
            getPermission: function (userKey) {
                this.sharing = this.sharing != null ? this.sharing : {};
                if (!(this.sharing[userKey] != null) || !(PermissionLevel[this.sharing[userKey].permission] != null)) {
                    return PermissionLevel.default;
                }
                return PermissionLevel[this.sharing[userKey].permission];
            },
            sharing: {
                type: 'object',
                access: {
                    write: function (c) {
                        return this.getPermission(c.user.key).manager;
                    }
                }
            },
            sharingUserKeys: {
                index: true,
                type: 'array',
                get: function () {
                    var keys = Object.keys(this.sharing != null ? this.sharing : {});
                    if (!keys.contains(this.createdBy)) {
                        keys.push(this.createdBy);
                    }
                    return keys;
                },
                set: function (value) {
                    if (typeof value === 'string') {
                        this.sharing = this.sharing != null ? this.sharing : {};
                        this.sharing[value] = { access: 0 };
                    }
                }
            },
            stems: {
                index: true,
                items: {
                    minLength: 3,
                    maxLength: 3
                }
            },
            tags: {
                visible: true,
                type: 'object',
                required: false,
                notFoundMessage: 'Tag does not yet exist. Contact your Viewpath Administrator to add the tag.',
                foreign: {
                    type: 'Tag',
                    getSearchKeys: function (record, text) {
                        var orgKey = record.orgKey;
                        if (!(orgKey != null)) {
                            return [];
                        }
                        var tagsKey = new Key(orgKey, ['tags'], {
                                where: { project: true },
                                sort: [{ name: true }]
                            });
                        return [tagsKey.toString()];
                    },
                    getSource: ion.template(function (_ref7) {
                        return ion.createRuntime({
                            type: 'Template',
                            id: null,
                            body: [
                                {
                                    type: 'VariableDeclaration',
                                    declarations: [{
                                            type: 'VariableDeclarator',
                                            id: {
                                                type: 'Identifier',
                                                name: 'server',
                                                loc: {
                                                    start: {
                                                        line: 256,
                                                        column: 38,
                                                        fixed: true,
                                                        source: 'viewpath/model/Project.ion'
                                                    },
                                                    end: {
                                                        line: 256,
                                                        column: 44,
                                                        fixed: true,
                                                        source: 'viewpath/model/Project.ion'
                                                    }
                                                }
                                            },
                                            init: {
                                                type: 'MemberExpression',
                                                object: {
                                                    type: 'Identifier',
                                                    name: '_ref7'
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'server',
                                                    loc: {
                                                        start: {
                                                            line: 256,
                                                            column: 38,
                                                            fixed: true,
                                                            source: 'viewpath/model/Project.ion'
                                                        },
                                                        end: {
                                                            line: 256,
                                                            column: 44,
                                                            fixed: true,
                                                            source: 'viewpath/model/Project.ion'
                                                        }
                                                    }
                                                },
                                                computed: false
                                            }
                                        }],
                                    kind: 'let',
                                    order: '0'
                                },
                                {
                                    type: 'VariableDeclaration',
                                    declarations: [{
                                            type: 'VariableDeclarator',
                                            id: {
                                                type: 'Identifier',
                                                name: 'record',
                                                loc: {
                                                    start: {
                                                        line: 256,
                                                        column: 46,
                                                        fixed: true,
                                                        source: 'viewpath/model/Project.ion'
                                                    },
                                                    end: {
                                                        line: 256,
                                                        column: 52,
                                                        fixed: true,
                                                        source: 'viewpath/model/Project.ion'
                                                    }
                                                }
                                            },
                                            init: {
                                                type: 'MemberExpression',
                                                object: {
                                                    type: 'Identifier',
                                                    name: '_ref7'
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'record',
                                                    loc: {
                                                        start: {
                                                            line: 256,
                                                            column: 46,
                                                            fixed: true,
                                                            source: 'viewpath/model/Project.ion'
                                                        },
                                                        end: {
                                                            line: 256,
                                                            column: 52,
                                                            fixed: true,
                                                            source: 'viewpath/model/Project.ion'
                                                        }
                                                    }
                                                },
                                                computed: false
                                            }
                                        }],
                                    kind: 'let',
                                    order: '1'
                                },
                                {
                                    type: 'ReturnStatement',
                                    argument: {
                                        type: 'ConditionalExpression',
                                        test: {
                                            type: 'BinaryExpression',
                                            operator: '!=',
                                            left: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'MemberExpression',
                                                    computed: true,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'server',
                                                        loc: {
                                                            start: {
                                                                line: 257,
                                                                column: 27,
                                                                fixed: true,
                                                                source: 'viewpath/model/Project.ion'
                                                            },
                                                            end: {
                                                                line: 257,
                                                                column: 33,
                                                                fixed: true,
                                                                source: 'viewpath/model/Project.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'record',
                                                            loc: {
                                                                start: {
                                                                    line: 257,
                                                                    column: 34,
                                                                    fixed: true,
                                                                    source: 'viewpath/model/Project.ion'
                                                                },
                                                                end: {
                                                                    line: 257,
                                                                    column: 40,
                                                                    fixed: true,
                                                                    source: 'viewpath/model/Project.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'orgKey',
                                                            loc: {
                                                                start: {
                                                                    line: 257,
                                                                    column: 41,
                                                                    fixed: true,
                                                                    source: 'viewpath/model/Project.ion'
                                                                },
                                                                end: {
                                                                    line: 257,
                                                                    column: 47,
                                                                    fixed: true,
                                                                    source: 'viewpath/model/Project.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 257,
                                                                column: 34,
                                                                fixed: true,
                                                                source: 'viewpath/model/Project.ion'
                                                            },
                                                            end: {
                                                                line: 257,
                                                                column: 47,
                                                                fixed: true,
                                                                source: 'viewpath/model/Project.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 257,
                                                            column: 27,
                                                            fixed: true,
                                                            source: 'viewpath/model/Project.ion'
                                                        },
                                                        end: {
                                                            line: 257,
                                                            column: 48,
                                                            fixed: true,
                                                            source: 'viewpath/model/Project.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'tags',
                                                    loc: {
                                                        start: {
                                                            line: 257,
                                                            column: 50,
                                                            fixed: true,
                                                            source: 'viewpath/model/Project.ion'
                                                        },
                                                        end: {
                                                            line: 257,
                                                            column: 54,
                                                            fixed: true,
                                                            source: 'viewpath/model/Project.ion'
                                                        }
                                                    }
                                                },
                                                existential: true,
                                                loc: {
                                                    start: {
                                                        line: 257,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'viewpath/model/Project.ion'
                                                    },
                                                    end: {
                                                        line: 257,
                                                        column: 54,
                                                        fixed: true,
                                                        source: 'viewpath/model/Project.ion'
                                                    }
                                                }
                                            },
                                            right: {
                                                type: 'Literal',
                                                value: null
                                            }
                                        },
                                        consequent: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'MemberExpression',
                                                computed: true,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'server',
                                                    loc: {
                                                        start: {
                                                            line: 257,
                                                            column: 27,
                                                            fixed: true,
                                                            source: 'viewpath/model/Project.ion'
                                                        },
                                                        end: {
                                                            line: 257,
                                                            column: 33,
                                                            fixed: true,
                                                            source: 'viewpath/model/Project.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'record',
                                                        loc: {
                                                            start: {
                                                                line: 257,
                                                                column: 34,
                                                                fixed: true,
                                                                source: 'viewpath/model/Project.ion'
                                                            },
                                                            end: {
                                                                line: 257,
                                                                column: 40,
                                                                fixed: true,
                                                                source: 'viewpath/model/Project.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'orgKey',
                                                        loc: {
                                                            start: {
                                                                line: 257,
                                                                column: 41,
                                                                fixed: true,
                                                                source: 'viewpath/model/Project.ion'
                                                            },
                                                            end: {
                                                                line: 257,
                                                                column: 47,
                                                                fixed: true,
                                                                source: 'viewpath/model/Project.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 257,
                                                            column: 34,
                                                            fixed: true,
                                                            source: 'viewpath/model/Project.ion'
                                                        },
                                                        end: {
                                                            line: 257,
                                                            column: 47,
                                                            fixed: true,
                                                            source: 'viewpath/model/Project.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 257,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'viewpath/model/Project.ion'
                                                    },
                                                    end: {
                                                        line: 257,
                                                        column: 48,
                                                        fixed: true,
                                                        source: 'viewpath/model/Project.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'tags',
                                                loc: {
                                                    start: {
                                                        line: 257,
                                                        column: 50,
                                                        fixed: true,
                                                        source: 'viewpath/model/Project.ion'
                                                    },
                                                    end: {
                                                        line: 257,
                                                        column: 54,
                                                        fixed: true,
                                                        source: 'viewpath/model/Project.ion'
                                                    }
                                                }
                                            },
                                            existential: true,
                                            loc: {
                                                start: {
                                                    line: 257,
                                                    column: 27,
                                                    fixed: true,
                                                    source: 'viewpath/model/Project.ion'
                                                },
                                                end: {
                                                    line: 257,
                                                    column: 54,
                                                    fixed: true,
                                                    source: 'viewpath/model/Project.ion'
                                                }
                                            }
                                        },
                                        alternate: {
                                            type: 'ObjectExpression',
                                            properties: []
                                        }
                                    },
                                    order: '2'
                                }
                            ],
                            bound: false,
                            name: {
                                type: 'Identifier',
                                name: 'getSource',
                                loc: {
                                    start: {
                                        line: 256,
                                        column: 16,
                                        fixed: true,
                                        source: 'viewpath/model/Project.ion'
                                    },
                                    end: {
                                        line: 256,
                                        column: 25,
                                        fixed: true,
                                        source: 'viewpath/model/Project.ion'
                                    }
                                }
                            }
                        }, {
                            this: this,
                            _ref7: _ref7,
                            glass: glass,
                            _ref: _ref,
                            _ref2: _ref2,
                            _ref3: _ref3,
                            _ref4: _ref4,
                            Key: Key,
                            DateTime: DateTime,
                            User: User,
                            Organization: Organization,
                            ProjectType: ProjectType,
                            PermissionLevel: PermissionLevel,
                            TimeUnit: TimeUnit,
                            OwnedEntity: OwnedEntity,
                            TaskStatus: TaskStatus,
                            TaskTimelineBox: TaskTimelineBox,
                            alreadyWarned: alreadyWarned,
                            Project: Project
                        }, null);
                    })
                }
            },
            url: {
                get: function () {
                    return '#project/' + this.id;
                }
            },
            paneConfig: {
                get: function () {
                    return {
                        id: 'Project',
                        key: this.key
                    };
                }
            },
            toString: function () {
                return this.name;
            }
        },
        test: function () {
            if (!((Project.access != null ? Project.access.read : void 0) !== (OwnedEntity.access != null ? OwnedEntity.access.read : void 0)))
                throw new Error('Assertion Failed: ((Project.access?.read isnt OwnedEntity.access?.read))');
        }
    }, OwnedEntity);
module.exports = exports = Project;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/model/Project',_viewpath_model_Project_);
    else
      _viewpath_model_Project_.call(this, module, exports, require);
  }
  else {
    _viewpath_model_Project_.call(this);
  }
}).call(this)
void (function(){var _viewpath_model_ProjectType_ = function(module,exports,require){'use strict';
var items = [
        {
            id: 0,
            name: 'Project',
            assign: true
        },
        {
            id: 1,
            name: 'List',
            assign: true
        },
        {
            id: 2,
            name: 'Template',
            assign: false
        },
        {
            id: 3,
            name: 'Calendar',
            assign: false
        }
    ];
var _ref = {};
{
    _ref.keys = items.map(function (x) {
        return x.id;
    });
    _ref.values = items;
    for (var key in items) {
        var value = items[key];
        _ref[value.id] = value;
        _ref[value.name] = value;
    }
}
module.exports = exports = _ref;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/model/ProjectType',_viewpath_model_ProjectType_);
    else
      _viewpath_model_ProjectType_.call(this, module, exports, require);
  }
  else {
    _viewpath_model_ProjectType_.call(this);
  }
}).call(this)
void (function(){var _viewpath_model_RepeatUnit_ = function(module,exports,require){'use strict';
var items = [
        {
            id: 0,
            name: 'days',
            singular: 'day',
            plural: 'days',
            duration: 'P1D'
        },
        {
            id: 1,
            name: 'weeks',
            singular: 'week',
            plural: 'weeks',
            duration: 'P1W'
        },
        {
            id: 2,
            name: 'months',
            singular: 'month',
            plural: 'months',
            duration: 'P1M'
        },
        {
            id: 3,
            name: 'years',
            singular: 'year',
            plural: 'years',
            duration: 'P1Y'
        }
    ];
var _ref = {};
{
    _ref.keys = items.map(function (x) {
        return x.id;
    });
    _ref.values = items;
    for (var key in items) {
        var value = items[key];
        _ref[value.id] = value;
        _ref[value.name] = value;
    }
}
module.exports = exports = _ref;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/model/RepeatUnit',_viewpath_model_RepeatUnit_);
    else
      _viewpath_model_RepeatUnit_.call(this, module, exports, require);
  }
  else {
    _viewpath_model_RepeatUnit_.call(this);
  }
}).call(this)
void (function(){var _viewpath_model_ScheduleConstraint_ = function(module,exports,require){'use strict';
var x = true, _ = false;
var items = [
        {
            id: -1,
            name: 'None',
            asap: _,
            alap: _,
            date: _,
            start: _,
            finish: _,
            earlier: _,
            later: _,
            description: 'default scheduling behavior',
            inherit: true,
            label: ''
        },
        {
            id: 0,
            name: 'ASAP',
            asap: x,
            alap: _,
            date: _,
            start: _,
            finish: _,
            earlier: x,
            later: _,
            description: 'as soon as possible'
        },
        {
            id: 1,
            name: 'ALAP',
            asap: _,
            alap: x,
            date: _,
            start: _,
            finish: _,
            earlier: _,
            later: x,
            description: 'as late as possible'
        },
        {
            id: 2,
            name: 'SNET',
            asap: x,
            alap: _,
            date: x,
            start: x,
            finish: _,
            earlier: _,
            later: x,
            description: 'start no earlier than'
        },
        {
            id: 3,
            name: 'SNLT',
            asap: x,
            alap: _,
            date: x,
            start: x,
            finish: _,
            earlier: x,
            later: _,
            description: 'start no later than'
        },
        {
            id: 4,
            name: 'FNET',
            asap: _,
            alap: x,
            date: x,
            start: _,
            finish: x,
            earlier: _,
            later: x,
            description: 'finish no earlier than'
        },
        {
            id: 5,
            name: 'FNLT',
            asap: x,
            alap: _,
            date: x,
            start: _,
            finish: x,
            earlier: x,
            later: _,
            description: 'finish no later than'
        },
        {
            id: 6,
            name: 'MSO',
            asap: x,
            alap: _,
            date: x,
            start: x,
            finish: _,
            earlier: _,
            later: _,
            description: 'must start on'
        },
        {
            id: 7,
            name: 'MFO',
            asap: _,
            alap: x,
            date: x,
            start: _,
            finish: x,
            earlier: _,
            later: _,
            description: 'must finish on'
        },
        {
            id: 8,
            name: 'Manual',
            asap: _,
            alap: _,
            date: _,
            start: x,
            finish: x,
            earlier: _,
            later: _,
            description: 'do not auto schedule'
        },
        {
            id: 9,
            name: 'Repeating',
            asap: _,
            alap: _,
            date: _,
            start: _,
            finish: _,
            earlier: _,
            later: _,
            description: 'recurring, not auto scheduled',
            repeat: true
        }
    ];
var _ref = {};
{
    _ref.keys = items.map(function (value) {
        return value.id;
    });
    _ref.values = items;
    for (var key in items) {
        var value = items[key];
        _ref[value.id] = value;
        _ref[value.name] = value;
    }
}
module.exports = exports = _ref;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/model/ScheduleConstraint',_viewpath_model_ScheduleConstraint_);
    else
      _viewpath_model_ScheduleConstraint_.call(this, module, exports, require);
  }
  else {
    _viewpath_model_ScheduleConstraint_.call(this);
  }
}).call(this)
void (function(){var _viewpath_model_ScheduleFunctions_ = function(module,exports,require){"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function min(a, b) {
    if (a != null && b != null)
        return a < b ? a : b;
    if (a != null)
        return a;
    if (b != null)
        return b;
    return undefined;
}
function max(a, b) {
    if (a != null && b != null)
        return a > b ? a : b;
    if (a != null)
        return a;
    if (b != null)
        return b;
    return undefined;
}
function addTimeIfMissing(date, endOfDay = false) {
    if (date != null && date.indexOf('T') < 0)
        date += endOfDay ? "T24:00:00" : "T00:00:00";
    return date;
}
const dependencyTypeInfo = {
    FS: { propagate: { asap: true, alap: true }, inherit: { asap: true, alap: true } },
    SS: { propagate: { asap: true, alap: false }, inherit: { asap: true, alap: false } },
    FF: { propagate: { asap: true, alap: false }, inherit: { asap: false, alap: true } },
    SF: { propagate: { asap: true, alap: false }, inherit: { asap: false, alap: false } }
};
const dependencyTypeCharToField = { S: "startWithTime", F: "finishWithTime" };
function getAncestors(task, lookup) {
    let ancestors = [];
    for (let i = 0; i < 1000 && task && task.parentId; i++) {
        task = lookup[task.parentId || ""];
        if (task)
            ancestors.push(task);
    }
    return ancestors;
}
function getPredecessorDependencies(task, ancestors, result = {}) {
    let areWeRootSelf = ancestors != null;
    if (ancestors != null) {
        for (let ancestor of ancestors) {
            getPredecessorDependencies(ancestor, null, result);
        }
    }
    if (task.predecessors) {
        for (let key in task.predecessors) {
            let dependency = task.predecessors[key];
            if (areWeRootSelf || dependencyTypeInfo[dependency.type || "FS"].inherit.asap)
                result[key] = dependency;
        }
    }
    return result;
}
function getSuccessorLookup(tasks) {
    let sucLookup = {};
    for (let sucKey in tasks) {
        let suc = tasks[sucKey];
        if (suc.predecessors) {
            for (let predKey in suc.predecessors) {
                let dependency = suc.predecessors[predKey];
                let successors = sucLookup[predKey];
                if (successors == null)
                    successors = sucLookup[predKey] = {};
                successors[sucKey] = dependency;
            }
        }
    }
    return sucLookup;
}
function getSuccessorDependencies(task, ancestors, successorsLookup, result = {}) {
    let areWeRootSelf = ancestors != null;
    if (ancestors != null) {
        for (let ancestor of ancestors) {
            getSuccessorDependencies(ancestor, null, successorsLookup, result);
        }
    }
    let successors = successorsLookup[task.key || ""];
    if (successors) {
        for (let key in successors) {
            let dependency = successors[key];
            if (areWeRootSelf || dependencyTypeInfo[dependency.type || "FS"].inherit.alap)
                result[key] = dependency;
        }
    }
    return result;
}
function getScheduleOptionsFromProject(project) {
    let asap = project.alap !== true;
    return new ScheduleOptions(project.plannedStart, null, null, project.plannedFinish, asap);
}
function getScheduleOptionsFromPredecessor(predecessor, dependency) {
    let type = dependency.type || "FS";
    let startMinimum = null;
    let startMaximum = null;
    let finishMinimum = null;
    let finishMaximum = null;
    if (dependencyTypeInfo[type].propagate.asap) {
        let predProperty = dependencyTypeCharToField[type[0]];
        let succProperty = dependencyTypeCharToField[type[1]];
        let predDate = predecessor[predProperty];
        if (predDate) {
            if (succProperty == 'startWithTime')
                startMinimum = predDate;
            else
                finishMinimum = predDate;
        }
    }
    return new ScheduleOptions(startMinimum, startMaximum, finishMinimum, finishMaximum);
}
function getScheduleOptionsFromSuccessor(successor, dependency) {
    let type = dependency.type || "FS";
    let startMinimum = null;
    let startMaximum = null;
    let finishMinimum = null;
    let finishMaximum = null;
    if (dependencyTypeInfo[type].propagate.alap) {
        let predProperty = dependencyTypeCharToField[type[0]];
        let succProperty = dependencyTypeCharToField[type[1]];
        let succDate = successor[succProperty];
        if (succDate) {
            if (predProperty == 'startWithTime')
                startMaximum = succDate;
            else
                finishMaximum = succDate;
        }
    }
    return new ScheduleOptions(startMinimum, startMaximum, finishMinimum, finishMaximum);
}
function getScheduleOptionsFromTaskConstraints(task) {
    let startMinimum = null;
    let startMaximum = null;
    let finishMinimum = null;
    let finishMaximum = null;
    let asap = null;
    let constraint = task.ScheduleConstraint;
    if (constraint != null) {
        if (constraint.asap || constraint.alap)
            asap = constraint.asap == true;
        if (constraint.date && task.scheduleDate) {
            let date = task.scheduleDate;
            if (constraint.start) {
                if (!constraint.earlier)
                    startMinimum = date;
                if (!constraint.later)
                    startMaximum = date;
            }
            if (constraint.finish) {
                if (!constraint.earlier)
                    finishMinimum = date;
                if (!constraint.later)
                    finishMaximum = date;
            }
        }
    }
    return new ScheduleOptions(startMinimum, startMaximum, finishMinimum, finishMaximum, asap);
}
function combine(a, b) {
    return new ScheduleOptions(max(a.startMinimum, b.startMinimum), min(a.startMaximum, b.startMaximum), max(a.finishMinimum, b.finishMinimum), min(a.finishMaximum, b.finishMaximum), a.asap != null ? a.asap : b.asap);
}
class ScheduleOptions {
    constructor(startMinimum = null, startMaximum = null, finishMinimum = null, finishMaximum = null, asap = null) {
        this.startMinimum = addTimeIfMissing(startMinimum);
        this.startMaximum = addTimeIfMissing(startMaximum, true);
        this.finishMinimum = addTimeIfMissing(finishMinimum);
        this.finishMaximum = addTimeIfMissing(finishMaximum, true);
        this.asap = asap;
    }
    normalize() {
        if (this.startMinimum && this.startMaximum && this.startMaximum < this.startMinimum)
            this.startMinimum = null;
        if (this.finishMinimum && this.finishMaximum && this.finishMaximum < this.finishMinimum)
            this.finishMinimum = null;
    }
    static calculate(task, project, lookup) {
        function debug(...args) {
        }
        let ancestors = getAncestors(task, lookup);
        let options = getScheduleOptionsFromTaskConstraints(task);
        debug('A', options);
        for (let ancestor of ancestors) {
            options = combine(options, getScheduleOptionsFromTaskConstraints(ancestor));
            debug('B', ancestor, options);
        }
        options = combine(options, getScheduleOptionsFromProject(project));
        debug('C', options);
        if (options.asap == null)
            throw new Error("asap missing");
        if (options.asap) {
            let predecessors = getPredecessorDependencies(task, ancestors);
            for (let key in predecessors) {
                let dependency = predecessors[key];
                let predecessor = lookup[key];
                if (predecessor) {
                    options = combine(options, getScheduleOptionsFromPredecessor(predecessor, dependency));
                    debug('D', predecessor, options);
                }
            }
        }
        else {
            let successorLookup = getSuccessorLookup(lookup);
            let successors = getSuccessorDependencies(task, ancestors, successorLookup);
            for (let key in successors) {
                let dependency = successors[key];
                let successor = lookup[key];
                if (successor) {
                    options = combine(options, getScheduleOptionsFromSuccessor(successor, dependency));
                    debug('E', successor, options);
                }
            }
        }
        return options;
    }
}
exports.ScheduleOptions = ScheduleOptions;
function test() {
    function assert(name, actual, expected) {
        if (JSON.stringify(actual) !== JSON.stringify(expected)) {
            console.log(JSON.stringify({ expected, actual }, null, 2));
            throw new Error(name + " assertion failed");
        }
    }
    assert("predecessor type:null", getScheduleOptionsFromPredecessor({ startWithTime: "2018-12-09T00:00:00", finishWithTime: "2018-12-11T24:00:00" }, {}), { "startMinimum": "2018-12-11T24:00:00", "startMaximum": null, "finishMinimum": null, "finishMaximum": null, "asap": null });
    assert("predecessor type:FS", getScheduleOptionsFromPredecessor({ startWithTime: "2018-12-09T00:00:00", finishWithTime: "2018-12-11T24:00:00" }, { type: "FS" }), { "startMinimum": "2018-12-11T24:00:00", "startMaximum": null, "finishMinimum": null, "finishMaximum": null, "asap": null });
    assert("predecessor type:SS", getScheduleOptionsFromPredecessor({ startWithTime: "2018-12-09T00:00:00", finishWithTime: "2018-12-11T24:00:00" }, { type: "SS" }), { "startMinimum": "2018-12-09T00:00:00", "startMaximum": null, "finishMinimum": null, "finishMaximum": null, "asap": null });
    assert("predecessor type:FF", getScheduleOptionsFromPredecessor({ startWithTime: "2018-12-09T00:00:00", finishWithTime: "2018-12-11T24:00:00" }, { type: "FF" }), { "startMinimum": null, "startMaximum": null, "finishMinimum": "2018-12-11T24:00:00", "finishMaximum": null, "asap": null });
    assert("predecessor type:SF", getScheduleOptionsFromPredecessor({ startWithTime: "2018-12-09T00:00:00", finishWithTime: "2018-12-11T24:00:00" }, { type: "SF" }), { "startMinimum": null, "startMaximum": null, "finishMinimum": "2018-12-09T00:00:00", "finishMaximum": null, "asap": null });
    assert("successor type:null", getScheduleOptionsFromSuccessor({ startWithTime: "2018-12-09T00:00:00", finishWithTime: "2018-12-11T24:00:00" }, {}), { "startMinimum": null, "startMaximum": null, "finishMinimum": null, "finishMaximum": "2018-12-09T00:00:00", "asap": null });
    assert("successor type:FS", getScheduleOptionsFromSuccessor({ startWithTime: "2018-12-09T00:00:00", finishWithTime: "2018-12-11T24:00:00" }, { type: "FS" }), { "startMinimum": null, "startMaximum": null, "finishMinimum": null, "finishMaximum": "2018-12-09T00:00:00", "asap": null });
    assert("successor type:SS", getScheduleOptionsFromSuccessor({ startWithTime: "2018-12-09T00:00:00", finishWithTime: "2018-12-11T24:00:00" }, { type: "SS" }), { "startMinimum": null, "startMaximum": null, "finishMinimum": null, "finishMaximum": null, "asap": null });
    assert("successor type:FF", getScheduleOptionsFromSuccessor({ startWithTime: "2018-12-09T00:00:00", finishWithTime: "2018-12-11T24:00:00" }, { type: "FF" }), { "startMinimum": null, "startMaximum": null, "finishMinimum": null, "finishMaximum": null, "asap": null });
    assert("successorLookupWorks", getSuccessorLookup({ A: { key: "A" }, B: { key: "B", predecessors: { A: { type: "SS" } } }, C: { key: "C", predecessors: { A: { type: "FS" } } } }), { A: { B: { type: "SS" }, C: { type: "FS" } } });
}
exports.test = test;
//# sourceMappingURL=ScheduleFunctions.js.map
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/model/ScheduleFunctions',_viewpath_model_ScheduleFunctions_);
    else
      _viewpath_model_ScheduleFunctions_.call(this, module, exports, require);
  }
  else {
    _viewpath_model_ScheduleFunctions_.call(this);
  }
}).call(this)
void (function(){var _viewpath_model_Subscription_ = function(module,exports,require){'use strict';
var ion = require('ion');
var glass = require('glass'), _ref;
_ref = glass.time;
var DateTime = _ref.DateTime;
var capitalize = function (text) {
    return text[0].toUpperCase() + text.substring(1);
};
var displayText = function (text) {
    return text.split('_').map(capitalize).join(' ');
};
var makeEnum = function (items) {
    var _ref4 = {};
    {
        _ref4.keys = items.map(function (x) {
            return x.id;
        });
        _ref4.values = items;
        for (var key in items) {
            var value = items[key];
            _ref4[value.id] = value;
            _ref4[value.name] = value;
            _ref4[value.name.toLowerCase()] = value;
        }
    }
    return _ref4;
};
var Period = makeEnum([
        {
            id: 1,
            name: 'Monthly'
        },
        {
            id: 12,
            name: 'Yearly'
        }
    ]);
var State = makeEnum([
        {
            id: 0,
            name: 'active'
        },
        {
            id: 1,
            name: 'canceled'
        },
        {
            id: 2,
            name: 'expired'
        }
    ]);
var Product = makeEnum([
        {
            id: 0,
            name: 'Enterprise'
        },
        {
            id: 1,
            name: 'Professional'
        },
        {
            id: 3,
            name: 'Team'
        },
        {
            id: 2,
            name: 'Starter'
        }
    ]);
var Subscription = ion.defineClass({
        name: 'Subscription',
        id: module.id,
        persistent: true,
        Period: Period,
        State: State,
        Product: Product,
        isValidPlan: function (code) {
            var parts = code.split('-');
            if (parts.length !== 2) {
                return false;
            }
            var _ref2 = parts;
            var product = _ref2[0];
            var period = _ref2[1];
            return Product[product] != null && Period[period] != null;
        },
        access: {
            read: function (c) {
                return true;
            },
            write: function (c) {
                return false;
            }
        },
        properties: {
            product: {
                type: 'integer',
                enum: Product.keys,
                values: Product.values,
                value: Product.Enterprise,
                required: true
            },
            Product: {
                get: function () {
                    return Product[this.product];
                },
                set: function (value) {
                    this.product = value.id;
                }
            },
            ProductName: {
                type: 'string',
                label: 'Product',
                editable: false,
                link: 'url',
                primary: true,
                target: 'dialog',
                get: function () {
                    return displayText(this.Product.name);
                }
            },
            months: {
                label: 'Period',
                type: 'integer',
                enum: Period.keys,
                values: Period.values,
                value: Period.Yearly,
                required: true
            },
            Period: {
                get: function () {
                    return Period[this.months];
                },
                set: function (value) {
                    this.months = value.id;
                }
            },
            PeriodName: {
                label: 'Period',
                editable: false,
                get: function () {
                    return displayText(this.Period.name);
                }
            },
            setPlanCode: function (code) {
                var _ref3 = code.split('-');
                var product = _ref3[0];
                var period = _ref3[1];
                this.Product = Product[product];
                this.Period = Period[period];
            },
            state: {
                type: 'integer',
                enum: State.keys,
                values: State.values,
                required: true
            },
            State: {
                get: function () {
                    return State[this.state];
                },
                set: function (value) {
                    this.state = value.id;
                }
            },
            StateName: {
                label: 'Status',
                editable: false,
                get: function () {
                    return displayText(this.State.name);
                }
            },
            quantity: {
                label: 'Licenses',
                type: 'integer',
                required: true
            },
            uuid: {
                type: 'string',
                index: true,
                required: true
            },
            expires: {
                type: 'string',
                format: 'date-time',
                editable: false
            },
            Expires: {
                get: function () {
                    return this.expires != null ? DateTime.parse(this.expires) : null;
                },
                set: function (value) {
                    return this.expires = (value != null ? value.iso() : void 0) != null ? value.iso() : null;
                }
            },
            paneConfig: {
                get: function () {
                    return {
                        id: 'Subscription',
                        key: this.key
                    };
                }
            }
        }
    }, glass.model.Entity);
module.exports = exports = Subscription;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/model/Subscription',_viewpath_model_Subscription_);
    else
      _viewpath_model_Subscription_.call(this, module, exports, require);
  }
  else {
    _viewpath_model_Subscription_.call(this);
  }
}).call(this)
void (function(){var _viewpath_model_Tag_ = function(module,exports,require){'use strict';
var ion = require('ion');
var glass = require('glass');
var _ref = glass.model;
var Entity = _ref.Entity;
var Tag = ion.defineClass({
        name: 'Tag',
        id: module.id,
        serializable: true,
        getIndexValue: function (orgId, tagId) {
            return orgId + '.' + tagId;
        },
        square: true,
        properties: {
            getSearchPhrases: Entity.properties.getSearchPhrases,
            getSearchRank: Entity.properties.getSearchRank,
            getInitials: function () {
                return (this.name != null ? this.name : this.id) != null ? (this.name != null ? this.name : this.id).split(' ').map(function (x) {
                    return x[0];
                }).join('').toUpperCase().slice(0, 2) : void 0;
            },
            name: {
                type: 'string',
                minLength: 1,
                maxLength: 100,
                required: true,
                visible: true,
                search: { weight: 4 }
            },
            color: {
                type: 'string',
                format: 'color',
                pattern: '[0-9A-F][0-9A-F][0-9A-F][0-9A-F][0-9A-F][0-9A-F]',
                value: 'CCCCCC',
                required: true,
                visible: true
            },
            description: {
                type: 'string',
                maxLength: 500,
                visible: true,
                search: { weight: 1 }
            },
            user: {
                title: 'Valid on Users',
                type: 'boolean',
                required: true,
                value: true,
                visible: true
            },
            task: {
                title: 'Valid on Tasks',
                type: 'boolean',
                required: true,
                value: true,
                visible: true
            },
            project: {
                title: 'Valid on Projects',
                type: 'boolean',
                required: true,
                value: false,
                visible: true
            },
            toString: function () {
                return this.name;
            }
        }
    });
module.exports = exports = Tag;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/model/Tag',_viewpath_model_Tag_);
    else
      _viewpath_model_Tag_.call(this, module, exports, require);
  }
  else {
    _viewpath_model_Tag_.call(this);
  }
}).call(this)
void (function(){var _viewpath_model_Task_ = function(module,exports,require){'use strict';
var ion = require('ion');
var glass = require('glass'), _ref, getDate = function (date, time) {
        return date ? new Date('' + date + 'T' + time) : null;
    }, _ref2, _ref3, _ref4, namespace = require('./'), getUserSearchKeys = function (task, text) {
        var _ref6 = require('./');
        var User = _ref6.User;
        return User.getSearchKeys({
            text: text,
            orgId: task.orgId
        });
    }, _ref5;
_ref = require('./');
var Priority = _ref.Priority;
var TaskType = _ref.TaskType;
var OwnedEntity = _ref.OwnedEntity;
var ScheduleConstraint = _ref.ScheduleConstraint;
var TimeUnit = _ref.TimeUnit;
var RepeatUnit = _ref.RepeatUnit;
var Project = _ref.Project;
var PermissionLevel = _ref.PermissionLevel;
var TaskStatus = _ref.TaskStatus;
var Notification = _ref.Notification;
var NotificationType = _ref.NotificationType;
var Document = _ref.Document;
_ref2 = glass.data;
var Key = _ref2.Key;
_ref3 = glass;
var convert = _ref3.convert;
_ref4 = glass.time;
var DateTime = _ref4.DateTime;
var Duration = _ref4.Duration;
var moment = _ref4.moment;
var Timezone = _ref4.Timezone;
_ref5 = require('../html');
var TaskTimelineBox = _ref5.TaskTimelineBox;
var DocumentColumn = _ref5.DocumentColumn;
var alreadyWarned = false;
var finishKey = Symbol('finish');
var _ref20 = {};
{
    _ref20.query = function (key) {
        return true;
    };
    var isCreator = function (c) {
        return (c.user != null ? c.user.id : void 0) === this.createdBy;
    };
    _ref20.read = isCreator;
    _ref20.write = isCreator;
}
var Task = ion.defineClass({
        name: 'Task',
        id: module.id,
        persistent: true,
        description: 'Represents a Task, Issue, Event or any item which can be assigned, scheduled and completed.',
        defaultProperties: [
            'name',
            'tags',
            'assigned',
            'estimate',
            'schedule',
            'complete',
            'predecessorsText',
            'description'
        ],
        descendantTypes: {
            Comment: true,
            Notification: true
        },
        getSearchKeys: function (_ref7) {
            var text = _ref7.text;
            var orgId = _ref7.orgId;
            var projectId = _ref7.projectId;
            var _ref8 = require('./');
            var Project = _ref8.Project;
            text = text.trim();
            var stem = text.substring(0, Task.properties.stems.items.maxLength);
            var _ref19 = [];
            if (stem.length >= Task.properties.stems.items.minLength) {
                if (projectId != null) {
                    _ref19.push(new Key(Project, projectId, Task, { where: { stems: stem } }).toString());
                } else {
                    _ref19.push(new Key(Task, {
                        where: {
                            orgId: orgId,
                            stems: stem
                        },
                        limit: 20
                    }).toString());
                }
            }
            return _ref19;
        },
        security: _ref20,
        trigger: function (_ref9) {
            var key = _ref9.key;
            var oldEntity = _ref9.oldEntity;
            var newEntity = _ref9.newEntity;
            var oldValues = _ref9.oldValues;
            var newValues = _ref9.newValues;
            var related = _ref9.related;
            var changes = _ref9.changes;
            var assignedChanges = (changes[key] != null ? changes[key].assigned : void 0) != null ? changes[key].assigned : {};
            if (assignedChanges != null) {
                var assigned = [];
                var unassigned = [];
                for (var userKey in assignedChanges) {
                    var value = assignedChanges[userKey];
                    if (value != null) {
                        assigned.push(userKey);
                    } else {
                        unassigned.push(userKey);
                    }
                }
                if (assigned.length > 0 || unassigned.length > 0) {
                    Notification.create({
                        parentKey: key,
                        type: NotificationType.Reassigned,
                        details: {
                            unassigned: unassigned,
                            assigned: assigned,
                            taskName: newEntity.name
                        },
                        subscribed: function () {
                            var subscribed = [];
                            {
                                for (var _i = 0; _i < assigned.length; _i++) {
                                    var assignee = assigned[_i];
                                    subscribed.push(new Key(namespace, assignee.toString()).id);
                                }
                                for (var _i2 = 0; _i2 < unassigned.length; _i2++) {
                                    var unassignee = unassigned[_i2];
                                    subscribed.push(new Key(namespace, unassignee.toString()).id);
                                }
                            }
                            return subscribed;
                        }(),
                        changes: changes
                    });
                }
            }
        },
        access: {
            read: function (c) {
                if ((this.assigned != null ? this.assigned[c.user.key] : void 0) != null) {
                    return true;
                }
                return Task.getPermission(this.getKey(), c).read;
            },
            write: function (c) {
                var permission = Task.getPermission(this.getKey(), c).writeTasks;
                if (permission === false && (this.assigned != null ? this.assigned[c.user.key] : void 0) != null) {
                    return null;
                }
                return permission;
            },
            delete: function (c) {
                return Task.getPermission(this.getKey(), c).deleteTasks;
            }
        },
        getPermission: function (key, c) {
            if ((c.object != null ? c.object.$ : void 0) === 'Project') {
                return c.object.getPermission(c.user.key);
            }
            var proj = (c.related != null ? c.related[key.parent] : void 0) != null ? c.related[key.parent] : (c.oldRecords != null ? c.oldRecords[key.parent] : void 0) != null ? c.oldRecords[key.parent] : c.newRecords != null ? c.newRecords[key.parent] : void 0;
            if (!(proj != null)) {
                if (!alreadyWarned) {
                    console.log('\nParent project missing. Defaulting to collaborator.');
                    alreadyWarned = true;
                }
                return PermissionLevel.default;
            }
            return proj.getPermission(c.user.key);
        },
        properties: {
            getInitials: function (_ref10) {
                var property = _ref10.property;
                var details = _ref10.details;
                if ((property != null ? property.name : void 0) === 'predecessors' && details) {
                    return details.type != null ? details.type : 'FS';
                } else {
                    return OwnedEntity.properties.getInitials.call(this);
                }
            },
            getChildrenPercent: function () {
                var total = 0;
                var count = 0;
                {
                    var _ref18 = this.children;
                    for (var key in _ref18) {
                        var _ref22 = _ref18[key];
                        var percent = _ref22.percent;
                        total += percent;
                        count++;
                    }
                }
                var floatValue = total / count;
                if (floatValue === 0 || floatValue === 100) {
                    return floatValue;
                }
                return Math.max(1, Math.min(99, Math.round(floatValue)));
            },
            getTimelineInstances: function (_ref11) {
                var start = _ref11.start;
                var finish = _ref11.finish;
                if (this.repeat) {
                    var instances = this.createInstances(start, finish);
                    return instances;
                } else {
                    return [this];
                }
            },
            getTimelineComponents: ion.template(function (_ref12) {
                return ion.createRuntime({
                    type: 'Template',
                    id: null,
                    body: [
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'start',
                                        loc: {
                                            start: {
                                                line: 114,
                                                column: 42,
                                                fixed: true,
                                                source: 'viewpath/model/Task.ion'
                                            },
                                            end: {
                                                line: 114,
                                                column: 47,
                                                fixed: true,
                                                source: 'viewpath/model/Task.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'MemberExpression',
                                        object: {
                                            type: 'Identifier',
                                            name: '_ref12'
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'start',
                                            loc: {
                                                start: {
                                                    line: 114,
                                                    column: 42,
                                                    fixed: true,
                                                    source: 'viewpath/model/Task.ion'
                                                },
                                                end: {
                                                    line: 114,
                                                    column: 47,
                                                    fixed: true,
                                                    source: 'viewpath/model/Task.ion'
                                                }
                                            }
                                        },
                                        computed: false
                                    }
                                }],
                            kind: 'let',
                            order: '0'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'finish',
                                        loc: {
                                            start: {
                                                line: 114,
                                                column: 48,
                                                fixed: true,
                                                source: 'viewpath/model/Task.ion'
                                            },
                                            end: {
                                                line: 114,
                                                column: 54,
                                                fixed: true,
                                                source: 'viewpath/model/Task.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'MemberExpression',
                                        object: {
                                            type: 'Identifier',
                                            name: '_ref12'
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'finish',
                                            loc: {
                                                start: {
                                                    line: 114,
                                                    column: 48,
                                                    fixed: true,
                                                    source: 'viewpath/model/Task.ion'
                                                },
                                                end: {
                                                    line: 114,
                                                    column: 54,
                                                    fixed: true,
                                                    source: 'viewpath/model/Task.ion'
                                                }
                                            }
                                        },
                                        computed: false
                                    }
                                }],
                            kind: 'let',
                            order: '1'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'row',
                                        loc: {
                                            start: {
                                                line: 114,
                                                column: 55,
                                                fixed: true,
                                                source: 'viewpath/model/Task.ion'
                                            },
                                            end: {
                                                line: 114,
                                                column: 58,
                                                fixed: true,
                                                source: 'viewpath/model/Task.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'MemberExpression',
                                        object: {
                                            type: 'Identifier',
                                            name: '_ref12'
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'row',
                                            loc: {
                                                start: {
                                                    line: 114,
                                                    column: 55,
                                                    fixed: true,
                                                    source: 'viewpath/model/Task.ion'
                                                },
                                                end: {
                                                    line: 114,
                                                    column: 58,
                                                    fixed: true,
                                                    source: 'viewpath/model/Task.ion'
                                                }
                                            }
                                        },
                                        computed: false
                                    }
                                }],
                            kind: 'let',
                            order: '2'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'column',
                                        loc: {
                                            start: {
                                                line: 114,
                                                column: 59,
                                                fixed: true,
                                                source: 'viewpath/model/Task.ion'
                                            },
                                            end: {
                                                line: 114,
                                                column: 65,
                                                fixed: true,
                                                source: 'viewpath/model/Task.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'MemberExpression',
                                        object: {
                                            type: 'Identifier',
                                            name: '_ref12'
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'column',
                                            loc: {
                                                start: {
                                                    line: 114,
                                                    column: 59,
                                                    fixed: true,
                                                    source: 'viewpath/model/Task.ion'
                                                },
                                                end: {
                                                    line: 114,
                                                    column: 65,
                                                    fixed: true,
                                                    source: 'viewpath/model/Task.ion'
                                                }
                                            }
                                        },
                                        computed: false
                                    }
                                }],
                            kind: 'let',
                            order: '3'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'instances',
                                        loc: {
                                            start: {
                                                line: 115,
                                                column: 16,
                                                fixed: true,
                                                source: 'viewpath/model/Task.ion'
                                            },
                                            end: {
                                                line: 115,
                                                column: 25,
                                                fixed: true,
                                                source: 'viewpath/model/Task.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'CallExpression',
                                        callee: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: { type: 'ThisExpression' },
                                            property: {
                                                type: 'Identifier',
                                                name: 'getTimelineInstances',
                                                loc: {
                                                    start: {
                                                        line: 115,
                                                        column: 33,
                                                        fixed: true,
                                                        source: 'viewpath/model/Task.ion'
                                                    },
                                                    end: {
                                                        line: 115,
                                                        column: 53,
                                                        fixed: true,
                                                        source: 'viewpath/model/Task.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 115,
                                                    column: 28,
                                                    fixed: true,
                                                    source: 'viewpath/model/Task.ion'
                                                },
                                                end: {
                                                    line: 115,
                                                    column: 53,
                                                    fixed: true,
                                                    source: 'viewpath/model/Task.ion'
                                                }
                                            }
                                        },
                                        arguments: [{
                                                type: 'ObjectExpression',
                                                properties: [
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'start',
                                                            loc: {
                                                                start: {
                                                                    line: 115,
                                                                    column: 55,
                                                                    fixed: true,
                                                                    source: 'viewpath/model/Task.ion'
                                                                },
                                                                end: {
                                                                    line: 115,
                                                                    column: 60,
                                                                    fixed: true,
                                                                    source: 'viewpath/model/Task.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Identifier',
                                                            name: 'start',
                                                            loc: {
                                                                start: {
                                                                    line: 115,
                                                                    column: 55,
                                                                    fixed: true,
                                                                    source: 'viewpath/model/Task.ion'
                                                                },
                                                                end: {
                                                                    line: 115,
                                                                    column: 60,
                                                                    fixed: true,
                                                                    source: 'viewpath/model/Task.ion'
                                                                }
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '0'
                                                    },
                                                    {
                                                        type: 'Property',
                                                        key: {
                                                            type: 'Identifier',
                                                            name: 'finish',
                                                            loc: {
                                                                start: {
                                                                    line: 115,
                                                                    column: 61,
                                                                    fixed: true,
                                                                    source: 'viewpath/model/Task.ion'
                                                                },
                                                                end: {
                                                                    line: 115,
                                                                    column: 67,
                                                                    fixed: true,
                                                                    source: 'viewpath/model/Task.ion'
                                                                }
                                                            }
                                                        },
                                                        value: {
                                                            type: 'Identifier',
                                                            name: 'finish',
                                                            loc: {
                                                                start: {
                                                                    line: 115,
                                                                    column: 61,
                                                                    fixed: true,
                                                                    source: 'viewpath/model/Task.ion'
                                                                },
                                                                end: {
                                                                    line: 115,
                                                                    column: 67,
                                                                    fixed: true,
                                                                    source: 'viewpath/model/Task.ion'
                                                                }
                                                            }
                                                        },
                                                        kind: 'init',
                                                        order: '1'
                                                    }
                                                ]
                                            }],
                                        loc: {
                                            start: {
                                                line: 115,
                                                column: 28,
                                                fixed: true,
                                                source: 'viewpath/model/Task.ion'
                                            },
                                            end: {
                                                line: 115,
                                                column: 69,
                                                fixed: true,
                                                source: 'viewpath/model/Task.ion'
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '4'
                        },
                        {
                            type: 'ReturnStatement',
                            argument: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'ArrayExpression',
                                    elements: []
                                },
                                properties: [{
                                        type: 'ForOfStatement',
                                        left: {
                                            type: 'VariableDeclaration',
                                            declarations: [{
                                                    type: 'VariableDeclarator',
                                                    id: {
                                                        type: 'Identifier',
                                                        name: 'record',
                                                        loc: {
                                                            start: {
                                                                line: 117,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/model/Task.ion'
                                                            },
                                                            end: {
                                                                line: 117,
                                                                column: 26,
                                                                fixed: true,
                                                                source: 'viewpath/model/Task.ion'
                                                            }
                                                        }
                                                    },
                                                    init: null
                                                }],
                                            kind: 'let'
                                        },
                                        right: {
                                            type: 'Identifier',
                                            name: 'instances',
                                            loc: {
                                                start: {
                                                    line: 117,
                                                    column: 30,
                                                    fixed: true,
                                                    source: 'viewpath/model/Task.ion'
                                                },
                                                end: {
                                                    line: 117,
                                                    column: 39,
                                                    fixed: true,
                                                    source: 'viewpath/model/Task.ion'
                                                }
                                            }
                                        },
                                        body: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'ExpressionStatement',
                                                    expression: {
                                                        type: 'CallExpression',
                                                        callee: {
                                                            type: 'Identifier',
                                                            name: 'TaskTimelineBox',
                                                            loc: {
                                                                start: {
                                                                    line: 118,
                                                                    column: 20,
                                                                    fixed: true,
                                                                    source: 'viewpath/model/Task.ion'
                                                                },
                                                                end: {
                                                                    line: 118,
                                                                    column: 35,
                                                                    fixed: true,
                                                                    source: 'viewpath/model/Task.ion'
                                                                }
                                                            }
                                                        },
                                                        arguments: [{
                                                                type: 'ObjectExpression',
                                                                properties: [
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'record',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 118,
                                                                                    column: 37,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/model/Task.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 118,
                                                                                    column: 43,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/model/Task.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Identifier',
                                                                            name: 'record',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 118,
                                                                                    column: 37,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/model/Task.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 118,
                                                                                    column: 43,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/model/Task.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        kind: 'init',
                                                                        order: '0'
                                                                    },
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'row',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 118,
                                                                                    column: 44,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/model/Task.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 118,
                                                                                    column: 47,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/model/Task.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Identifier',
                                                                            name: 'row',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 118,
                                                                                    column: 44,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/model/Task.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 118,
                                                                                    column: 47,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/model/Task.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        kind: 'init',
                                                                        order: '1'
                                                                    },
                                                                    {
                                                                        type: 'Property',
                                                                        key: {
                                                                            type: 'Identifier',
                                                                            name: 'column',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 118,
                                                                                    column: 48,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/model/Task.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 118,
                                                                                    column: 54,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/model/Task.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        value: {
                                                                            type: 'Identifier',
                                                                            name: 'column',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 118,
                                                                                    column: 48,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/model/Task.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 118,
                                                                                    column: 54,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/model/Task.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        kind: 'init',
                                                                        order: '2'
                                                                    }
                                                                ]
                                                            }],
                                                        loc: {
                                                            start: {
                                                                line: 118,
                                                                column: 20,
                                                                fixed: true,
                                                                source: 'viewpath/model/Task.ion'
                                                            },
                                                            end: {
                                                                line: 118,
                                                                column: 56,
                                                                fixed: true,
                                                                source: 'viewpath/model/Task.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 118,
                                                            column: 20,
                                                            fixed: true,
                                                            source: 'viewpath/model/Task.ion'
                                                        },
                                                        end: {
                                                            line: 118,
                                                            column: 56,
                                                            fixed: true,
                                                            source: 'viewpath/model/Task.ion'
                                                        }
                                                    },
                                                    order: '0'
                                                }]
                                        },
                                        remove: null,
                                        order: '0'
                                    }]
                            },
                            order: '5'
                        }
                    ],
                    bound: false,
                    name: {
                        type: 'Identifier',
                        name: 'getTimelineComponents',
                        loc: {
                            start: {
                                line: 114,
                                column: 8,
                                fixed: true,
                                source: 'viewpath/model/Task.ion'
                            },
                            end: {
                                line: 114,
                                column: 29,
                                fixed: true,
                                source: 'viewpath/model/Task.ion'
                            }
                        }
                    }
                }, {
                    this: this,
                    _ref12: _ref12,
                    glass: glass,
                    _ref: _ref,
                    getDate: getDate,
                    _ref2: _ref2,
                    _ref3: _ref3,
                    _ref4: _ref4,
                    namespace: namespace,
                    getUserSearchKeys: getUserSearchKeys,
                    _ref5: _ref5,
                    Priority: Priority,
                    TaskType: TaskType,
                    OwnedEntity: OwnedEntity,
                    ScheduleConstraint: ScheduleConstraint,
                    TimeUnit: TimeUnit,
                    RepeatUnit: RepeatUnit,
                    Project: Project,
                    PermissionLevel: PermissionLevel,
                    TaskStatus: TaskStatus,
                    Notification: Notification,
                    NotificationType: NotificationType,
                    Document: Document,
                    Key: Key,
                    convert: convert,
                    DateTime: DateTime,
                    Duration: Duration,
                    moment: moment,
                    Timezone: Timezone,
                    TaskTimelineBox: TaskTimelineBox,
                    DocumentColumn: DocumentColumn,
                    alreadyWarned: alreadyWarned,
                    finishKey: finishKey,
                    _ref20: _ref20,
                    Task: Task
                }, null);
            }),
            order: {
                visible: true,
                type: 'integer',
                index: true,
                sort: false
            },
            name: {
                search: { weight: 4 },
                visible: false,
                type: 'string',
                index: true,
                required: true,
                primary: true,
                minLength: 1,
                maxLength: 500,
                averageLength: 25,
                value: 'New Task',
                link: 'url'
            },
            customColor: {
                label: 'Color',
                type: 'string',
                format: 'color',
                pattern: '#[0-9A-F][0-9A-F][0-9A-F][0-9A-F][0-9A-F][0-9A-F]',
                required: false
            },
            color: {
                type: 'string',
                format: 'color',
                visible: true,
                get: function () {
                    return this.customColor != null ? this.customColor : this.Type.color;
                },
                set: function (value) {
                    if (value != null) {
                        if (/^[0-9A-F]{6}$/.test(value)) {
                            value = '#' + value;
                        }
                        this.customColor = value;
                    } else {
                        delete this.customColor;
                    }
                }
            },
            icon: {
                get: function () {
                    return 'account-circle';
                }
            },
            owner: {
                type: 'string',
                format: 'key',
                index: true,
                stamp: {
                    type: 'user',
                    overwrite: false
                },
                foreign: {
                    type: 'User',
                    property: 'key',
                    getSearchKeys: getUserSearchKeys
                }
            },
            typeId: {
                visible: false,
                get: function () {
                    return this.type;
                },
                set: function (value) {
                    this.type = value;
                }
            },
            type: {
                visible: true,
                index: true,
                type: 'integer',
                enum: TaskType.keys,
                values: TaskType.values,
                value: 0
            },
            Type: {
                get: function () {
                    return TaskType.values[this.type != null ? this.type : 0];
                }
            },
            priority: {
                visible: true,
                index: true,
                type: 'number',
                enum: Priority.keys,
                values: Priority.values,
                value: Priority.Medium.id
            },
            Priority: {
                get: function () {
                    return Priority.values[this.priority];
                },
                set: function (value) {
                    if ((value != null ? value.value : void 0) != null) {
                        this.priority = value.value;
                    } else {
                        delete this.priority;
                    }
                }
            },
            description: {
                search: { weight: 1 },
                visible: true,
                type: 'string',
                averageLength: 100,
                maxLength: 2000
            },
            status: {
                index: true,
                visible: true,
                enum: TaskStatus.keys,
                values: TaskStatus.values,
                columnType: 'viewpath/html/StatusColumn',
                get: function () {
                    if (this.repeat) {
                        return TaskStatus.Repeating.id;
                    }
                    if (this.complete) {
                        return TaskStatus.Complete.id;
                    }
                    if (this.blocked) {
                        return TaskStatus.Blocked.id;
                    }
                    if (this.percent > 0) {
                        return TaskStatus.Started.id;
                    }
                    if (this.start != null) {
                        return TaskStatus.Scheduled.id;
                    }
                    return TaskStatus.Unscheduled.id;
                }
            },
            Status: {
                get: function () {
                    return TaskStatus[this.status];
                }
            },
            percent: {
                access: {
                    write: function (c) {
                        if ((this.assigned != null ? this.assigned[c.user.key] : void 0) != null) {
                            return true;
                        }
                    }
                },
                visible: true,
                label: '%',
                index: true,
                minimum: 0,
                maximum: 100,
                percent: true,
                required: true,
                value: 0,
                type: 'integer'
            },
            schedule: {
                visible: true,
                getEditProperties: function () {
                    return [
                        Task.properties.scheduleConstraint,
                        Task.properties.scheduleDate
                    ];
                },
                getEditValues: function (char) {
                    return [
                        this.scheduleConstraint,
                        this.scheduleDate
                    ];
                },
                get: function () {
                    return {
                        constraint: this.scheduleConstraint,
                        date: this.scheduleDate,
                        toString: function () {
                            return '' + (ScheduleConstraint[this.constraint].label != null ? ScheduleConstraint[this.constraint].label : ScheduleConstraint[this.constraint].name) + ' ' + (ScheduleConstraint[this.constraint].date ? convert.jsonValueToDisplayValue({ format: 'date-time' }, this.date) : '');
                        }
                    };
                },
                set: function (value) {
                    if (value != null && value.start != null && value.finish != null && value.duration != null) {
                        this.start = value.start;
                        this.finish = value.finish;
                        this.duration = value.duration;
                        return;
                    }
                    if (value != null) {
                        if (value.constraint) {
                            this.scheduleConstraint = value.constraint;
                        }
                        if (value.date) {
                            this.scheduleDate = value.date;
                        }
                    } else {
                        delete this.scheduleConstraint;
                        delete this.scheduleDate;
                    }
                }
            },
            scheduleDate: {
                value: null,
                visible: false,
                type: 'string',
                format: 'date-time'
            },
            scheduleConstraint: {
                label: 'Constraint',
                visible: false,
                enum: ScheduleConstraint.keys,
                values: ScheduleConstraint.values,
                value: ScheduleConstraint.None.id
            },
            ScheduleConstraint: {
                get: function () {
                    return ScheduleConstraint[this.scheduleConstraint] != null ? ScheduleConstraint[this.scheduleConstraint] : ScheduleConstraint.None;
                },
                set: function (value) {
                    this.scheduleConstraint = (value != null ? value.id : void 0) != null ? value.id : ScheduleConstraint.None.id;
                }
            },
            assignedWorkMinutes: {
                visible: false,
                get: function () {
                    return this.durationWorkMinutes * this.assignedCount;
                }
            },
            durationWorkMinutes: {
                visible: false,
                get: function () {
                    return this.DurationUnit.workMinutes * this.durationValue;
                }
            },
            assignedCount: {
                visible: false,
                get: function () {
                    var count = 0;
                    if (this.assigned != null) {
                        for (var key in this.assigned) {
                            count++;
                        }
                    }
                    return Math.max(1, count);
                }
            },
            workValue: {
                visible: false,
                type: 'integer',
                minimum: 0,
                value: null
            },
            workUnit: {
                visible: false,
                type: 'string',
                enum: TimeUnit.keys,
                values: TimeUnit.values,
                value: TimeUnit.Days.id
            },
            WorkUnit: {
                get: function () {
                    return TimeUnit[this.workUnit != null ? this.workUnit : TimeUnit.Days.id];
                },
                set: function (value) {
                    if (value) {
                        this.workUnit = value.id;
                    } else {
                        delete this.workUnit;
                    }
                }
            },
            work: {
                visible: true,
                getInputType: function () {
                    return require('../html/TimeAndUnitInput');
                },
                get: function () {
                    return {
                        value: this.workValue,
                        unit: this.workUnit,
                        toString: function () {
                            if (!(this.value != null)) {
                                return '';
                            } else {
                                return '' + this.value + ' ' + TimeUnit[this.unit][this.value === 1 ? 'labelSingular' : 'labelPlural'];
                            }
                        }
                    };
                },
                set: function (arg) {
                    if (!(arg != null)) {
                        delete this.workValue;
                        delete this.workUnit;
                    } else {
                        var value, unit;
                        if (typeof arg === 'object') {
                            var _ref13 = arg != null ? arg : {
                                    value: 0,
                                    unit: 'days'
                                };
                            value = _ref13.value;
                            unit = _ref13.unit;
                        } else {
                            throw new Error('Unrecognized format: ' + arg);
                        }
                        this.workValue = value;
                        this.workUnit = unit;
                    }
                }
            },
            durationValue: {
                visible: false,
                type: 'integer',
                minimum: 0,
                value: 1
            },
            durationUnit: {
                visible: false,
                type: 'string',
                enum: TimeUnit.keys,
                values: TimeUnit.values,
                value: TimeUnit.Days.id
            },
            DurationUnit: {
                get: function () {
                    return TimeUnit[this.durationUnit != null ? this.durationUnit : TimeUnit.Days.id];
                },
                set: function (value) {
                    if (value) {
                        this.durationUnit = value.id;
                    } else {
                        delete this.durationUnit;
                    }
                }
            },
            isoDuration: {
                get: function () {
                    return this.DurationUnit.isoFormat.replace(/0/g, this.durationValue != null ? this.durationValue : 0);
                }
            },
            IsoDuration: {
                get: function () {
                    return new Duration(this.isoDuration);
                },
                set: function (value) {
                    if (value != null) {
                        this.duration = value.toString();
                    } else {
                        delete this.duration;
                    }
                }
            },
            getIsoDurationToAddOrSubtract: function (dateTime) {
                var duration = this.IsoDuration;
                if (!dateTime.time) {
                    duration = duration.subtract(new Duration({ days: 1 }));
                }
                return duration;
            },
            getIsoDurationFromStartFinish: function () {
                var duration = this.Finish.subtract(this.Start).toSimpleDuration();
                if (!duration.time) {
                    duration = duration.add(new Duration({ days: 1 }));
                }
                return duration.toString();
            },
            clearSchedule: function () {
                this.ScheduleConstraint = ScheduleConstraint.None;
                delete this.scheduleDate;
                delete this.start;
                delete this.finish;
            },
            duration: {
                visible: false,
                getInputType: function () {
                    return require('../html/TimeAndUnitInput');
                },
                get: function () {
                    return {
                        value: this.durationValue,
                        unit: this.durationUnit,
                        toString: function () {
                            return '' + this.value + ' ' + TimeUnit[this.unit][this.value === 1 ? 'labelSingular' : 'labelPlural'];
                        }
                    };
                },
                set: function (arg) {
                    if (!(arg != null)) {
                        delete this.durationValue;
                        delete this.durationUnit;
                    } else {
                        var value, unit;
                        if (typeof arg === 'string') {
                            arg = new Duration(arg).toSimpleDuration().toValueUnit();
                        }
                        if (typeof arg === 'object') {
                            var _ref14 = arg != null ? arg : {
                                    value: 0,
                                    unit: 'days'
                                };
                            value = _ref14.value;
                            unit = _ref14.unit;
                        } else {
                            throw new Error('Unrecognized format: ' + arg);
                        }
                        this.durationValue = value;
                        this.durationUnit = unit;
                    }
                }
            },
            _calculateStart: function () {
                var finish = this.Finish;
                if (finish != null) {
                    this.Start = finish.subtract(this.getIsoDurationToAddOrSubtract(finish));
                }
            },
            _calculateFinish: function () {
                var start = this.Start;
                if (start != null) {
                    this.Finish = start.add(this.getIsoDurationToAddOrSubtract(start));
                }
            },
            _calculateDuration: function () {
                if (this.start != null && this.finish != null) {
                    this.duration = this.getIsoDurationFromStartFinish();
                }
            },
            manualDuration: {
                visible: true,
                getInputType: function () {
                    return require('../html/TimeAndUnitInput');
                },
                label: 'Duration',
                get: function () {
                    return this.duration;
                },
                set: function (value) {
                    this.duration = value;
                    if (this.ScheduleConstraint === ScheduleConstraint.Manual.valueOf() && this.start != null) {
                        this._calculateFinish();
                    }
                }
            },
            manualStart: {
                visible: true,
                label: 'Start',
                type: 'string',
                format: 'date-time',
                get: function () {
                    return this.start;
                },
                set: function (value) {
                    if (value != null) {
                        this.start = value;
                        this.ScheduleConstraint = ScheduleConstraint.Manual;
                        this._calculateFinish();
                    } else {
                        this.clearSchedule();
                    }
                }
            },
            manualFinish: {
                visible: true,
                label: 'Finish',
                type: 'string',
                format: 'date-time',
                get: function () {
                    return this.finish;
                },
                set: function (value) {
                    if (value != null) {
                        this.finish = value;
                        this.ScheduleConstraint = ScheduleConstraint.Manual;
                        if (!(this.start != null)) {
                            this._calculateStart();
                        } else {
                            this._calculateDuration();
                        }
                    } else {
                        this.clearSchedule();
                    }
                }
            },
            start: {
                flat: true,
                index: true,
                type: 'string',
                format: 'date-time'
            },
            finish: {
                flat: true,
                index: true,
                type: 'string',
                format: 'date-time'
            },
            startWithTime: {
                get: function () {
                    var start = this.start;
                    if (start && start.indexOf('T') < 0) {
                        start += 'T00:00:00';
                    }
                    return start;
                }
            },
            finishWithTime: {
                get: function () {
                    var finish = this.finish;
                    if (finish && finish.indexOf('T') < 0) {
                        finish += 'T24:00:00';
                    }
                    return finish;
                }
            },
            getTimezone: function (data) {
                if (data == null)
                    data = global.model != null ? global.model.server : void 0;
                var timezone = this.timezone;
                if (!(timezone != null)) {
                    var key = this.getKey();
                    var project = data[key.parent];
                    timezone = project != null ? project.timezone : void 0;
                    if (!(timezone != null)) {
                        var user = data[this.assignedUser];
                        timezone = user != null ? user.timezone : void 0;
                        if (!(timezone != null)) {
                            timezone = moment.tz.guess();
                            if (!(timezone != null)) {
                                timezone = 'America/Los_Angeles';
                            }
                        }
                    }
                }
                return timezone;
            },
            convertLocalToUTC: function (time, data) {
                if (!(time != null)) {
                    return null;
                }
                if (time.indexOf('T') < 0) {
                    return time;
                }
                var timezone = this.getTimezone(data);
                return moment.tz(time, timezone).toISOString();
            },
            convertUTCToLocal: function (time, data) {
                var timezone = this.getTimezone(data);
                return Timezone.toLocal(time, timezone);
            },
            getStartUTC: function (data) {
                return this.convertLocalToUTC(this.start, data);
            },
            getFinishUTC: function (data) {
                return this.convertLocalToUTC(this.finish, data);
            },
            setStartUTC: function (time, data) {
                return this.start = this.convertUTCToLocal(time, data);
            },
            setFinishUTC: function (time, data) {
                return this.finish = this.convertUTCToLocal(time, data);
            },
            startDate: {
                get: function () {
                    return this.start != null ? this.start.slice(0, this.start.indexOf('T')) : null;
                }
            },
            finishDate: {
                get: function () {
                    return this.finish != null ? this.finish.slice(0, this.finish.indexOf('T')) : null;
                }
            },
            Start: {
                description: 'Returns start as a glass.time.DateTime object or null',
                get: function () {
                    return DateTime.parse(this.start);
                },
                set: function (value) {
                    return this.start = (value != null ? value.iso != null ? value.iso() : void 0 : void 0) != null ? value.iso() : null;
                }
            },
            Finish: {
                description: 'Returns finish as a glass.time.DateTime object or null',
                get: function () {
                    return DateTime.parse(this.finish);
                },
                set: function (value) {
                    return this.finish = (value != null ? value.iso != null ? value.iso() : void 0 : void 0) != null ? value.iso() : null;
                }
            },
            timezone: {
                type: 'string',
                required: false,
                format: 'timezone'
            },
            complete: {
                visible: true,
                index: true,
                icon: 'done',
                type: 'boolean',
                get: function () {
                    return this.percent === 100;
                },
                set: function (value) {
                    return this.percent = value ? 100 : 0;
                }
            },
            dates: {
                index: true,
                type: 'array',
                items: {
                    type: 'string',
                    format: 'date-time'
                },
                get: function () {
                    var dates = [];
                    var start = this.startDate;
                    if (start != null) {
                        dates.push(start);
                    }
                    var finish = this.finishDate;
                    if (finish != null && finish !== start) {
                        dates.push(finish);
                    }
                    return dates;
                }
            },
            assignedUser: {
                flat: true,
                get: function () {
                    var assigned = this.assigned;
                    if (assigned != null) {
                        for (var key in assigned) {
                            return key;
                        }
                    }
                    return null;
                },
                set: function (value) {
                    if (value != null) {
                        var _ref15 = require('./');
                        var User = _ref15.User;
                        var key = this.getKey(value);
                        if (key.type === User && key.id != null) {
                            var _ref21 = {};
                            _ref21[key] = ion.patch.combine(_ref21[key], {});
                            this.assigned = _ref21;
                        } else {
                            throw new Error('Invalid key: ' + value);
                        }
                    } else {
                        this.assigned = null;
                    }
                }
            },
            documents: {
                editable: false,
                visible: true,
                columnType: DocumentColumn,
                type: 'object',
                required: false,
                additionalProperties: Object.assign({}, Document)
            },
            tags: {
                visible: true,
                type: 'object',
                required: false,
                notFoundMessage: 'Tag does not yet exist. Contact your Viewpath Administrator to add the tag.',
                foreign: {
                    type: 'Tag',
                    getSearchKeys: function (record, text) {
                        var orgKey = record.orgKey;
                        if (!(orgKey != null)) {
                            return [];
                        }
                        var tagsKey = new Key(orgKey, ['tags'], {
                                where: { task: true },
                                sort: [{ name: true }]
                            });
                        return [tagsKey.toString()];
                    },
                    getSource: ion.template(function (_ref16) {
                        return ion.createRuntime({
                            type: 'Template',
                            id: null,
                            body: [
                                {
                                    type: 'VariableDeclaration',
                                    declarations: [{
                                            type: 'VariableDeclarator',
                                            id: {
                                                type: 'Identifier',
                                                name: 'server',
                                                loc: {
                                                    start: {
                                                        line: 623,
                                                        column: 38,
                                                        fixed: true,
                                                        source: 'viewpath/model/Task.ion'
                                                    },
                                                    end: {
                                                        line: 623,
                                                        column: 44,
                                                        fixed: true,
                                                        source: 'viewpath/model/Task.ion'
                                                    }
                                                }
                                            },
                                            init: {
                                                type: 'MemberExpression',
                                                object: {
                                                    type: 'Identifier',
                                                    name: '_ref16'
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'server',
                                                    loc: {
                                                        start: {
                                                            line: 623,
                                                            column: 38,
                                                            fixed: true,
                                                            source: 'viewpath/model/Task.ion'
                                                        },
                                                        end: {
                                                            line: 623,
                                                            column: 44,
                                                            fixed: true,
                                                            source: 'viewpath/model/Task.ion'
                                                        }
                                                    }
                                                },
                                                computed: false
                                            }
                                        }],
                                    kind: 'let',
                                    order: '0'
                                },
                                {
                                    type: 'VariableDeclaration',
                                    declarations: [{
                                            type: 'VariableDeclarator',
                                            id: {
                                                type: 'Identifier',
                                                name: 'record',
                                                loc: {
                                                    start: {
                                                        line: 623,
                                                        column: 46,
                                                        fixed: true,
                                                        source: 'viewpath/model/Task.ion'
                                                    },
                                                    end: {
                                                        line: 623,
                                                        column: 52,
                                                        fixed: true,
                                                        source: 'viewpath/model/Task.ion'
                                                    }
                                                }
                                            },
                                            init: {
                                                type: 'MemberExpression',
                                                object: {
                                                    type: 'Identifier',
                                                    name: '_ref16'
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'record',
                                                    loc: {
                                                        start: {
                                                            line: 623,
                                                            column: 46,
                                                            fixed: true,
                                                            source: 'viewpath/model/Task.ion'
                                                        },
                                                        end: {
                                                            line: 623,
                                                            column: 52,
                                                            fixed: true,
                                                            source: 'viewpath/model/Task.ion'
                                                        }
                                                    }
                                                },
                                                computed: false
                                            }
                                        }],
                                    kind: 'let',
                                    order: '1'
                                },
                                {
                                    type: 'ReturnStatement',
                                    argument: {
                                        type: 'ConditionalExpression',
                                        test: {
                                            type: 'BinaryExpression',
                                            operator: '!=',
                                            left: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: {
                                                    type: 'MemberExpression',
                                                    computed: true,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'server',
                                                        loc: {
                                                            start: {
                                                                line: 624,
                                                                column: 27,
                                                                fixed: true,
                                                                source: 'viewpath/model/Task.ion'
                                                            },
                                                            end: {
                                                                line: 624,
                                                                column: 33,
                                                                fixed: true,
                                                                source: 'viewpath/model/Task.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'MemberExpression',
                                                        computed: false,
                                                        object: {
                                                            type: 'Identifier',
                                                            name: 'record',
                                                            loc: {
                                                                start: {
                                                                    line: 624,
                                                                    column: 34,
                                                                    fixed: true,
                                                                    source: 'viewpath/model/Task.ion'
                                                                },
                                                                end: {
                                                                    line: 624,
                                                                    column: 40,
                                                                    fixed: true,
                                                                    source: 'viewpath/model/Task.ion'
                                                                }
                                                            }
                                                        },
                                                        property: {
                                                            type: 'Identifier',
                                                            name: 'orgKey',
                                                            loc: {
                                                                start: {
                                                                    line: 624,
                                                                    column: 41,
                                                                    fixed: true,
                                                                    source: 'viewpath/model/Task.ion'
                                                                },
                                                                end: {
                                                                    line: 624,
                                                                    column: 47,
                                                                    fixed: true,
                                                                    source: 'viewpath/model/Task.ion'
                                                                }
                                                            }
                                                        },
                                                        loc: {
                                                            start: {
                                                                line: 624,
                                                                column: 34,
                                                                fixed: true,
                                                                source: 'viewpath/model/Task.ion'
                                                            },
                                                            end: {
                                                                line: 624,
                                                                column: 47,
                                                                fixed: true,
                                                                source: 'viewpath/model/Task.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 624,
                                                            column: 27,
                                                            fixed: true,
                                                            source: 'viewpath/model/Task.ion'
                                                        },
                                                        end: {
                                                            line: 624,
                                                            column: 48,
                                                            fixed: true,
                                                            source: 'viewpath/model/Task.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'tags',
                                                    loc: {
                                                        start: {
                                                            line: 624,
                                                            column: 50,
                                                            fixed: true,
                                                            source: 'viewpath/model/Task.ion'
                                                        },
                                                        end: {
                                                            line: 624,
                                                            column: 54,
                                                            fixed: true,
                                                            source: 'viewpath/model/Task.ion'
                                                        }
                                                    }
                                                },
                                                existential: true,
                                                loc: {
                                                    start: {
                                                        line: 624,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'viewpath/model/Task.ion'
                                                    },
                                                    end: {
                                                        line: 624,
                                                        column: 54,
                                                        fixed: true,
                                                        source: 'viewpath/model/Task.ion'
                                                    }
                                                }
                                            },
                                            right: {
                                                type: 'Literal',
                                                value: null
                                            }
                                        },
                                        consequent: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'MemberExpression',
                                                computed: true,
                                                object: {
                                                    type: 'Identifier',
                                                    name: 'server',
                                                    loc: {
                                                        start: {
                                                            line: 624,
                                                            column: 27,
                                                            fixed: true,
                                                            source: 'viewpath/model/Task.ion'
                                                        },
                                                        end: {
                                                            line: 624,
                                                            column: 33,
                                                            fixed: true,
                                                            source: 'viewpath/model/Task.ion'
                                                        }
                                                    }
                                                },
                                                property: {
                                                    type: 'MemberExpression',
                                                    computed: false,
                                                    object: {
                                                        type: 'Identifier',
                                                        name: 'record',
                                                        loc: {
                                                            start: {
                                                                line: 624,
                                                                column: 34,
                                                                fixed: true,
                                                                source: 'viewpath/model/Task.ion'
                                                            },
                                                            end: {
                                                                line: 624,
                                                                column: 40,
                                                                fixed: true,
                                                                source: 'viewpath/model/Task.ion'
                                                            }
                                                        }
                                                    },
                                                    property: {
                                                        type: 'Identifier',
                                                        name: 'orgKey',
                                                        loc: {
                                                            start: {
                                                                line: 624,
                                                                column: 41,
                                                                fixed: true,
                                                                source: 'viewpath/model/Task.ion'
                                                            },
                                                            end: {
                                                                line: 624,
                                                                column: 47,
                                                                fixed: true,
                                                                source: 'viewpath/model/Task.ion'
                                                            }
                                                        }
                                                    },
                                                    loc: {
                                                        start: {
                                                            line: 624,
                                                            column: 34,
                                                            fixed: true,
                                                            source: 'viewpath/model/Task.ion'
                                                        },
                                                        end: {
                                                            line: 624,
                                                            column: 47,
                                                            fixed: true,
                                                            source: 'viewpath/model/Task.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 624,
                                                        column: 27,
                                                        fixed: true,
                                                        source: 'viewpath/model/Task.ion'
                                                    },
                                                    end: {
                                                        line: 624,
                                                        column: 48,
                                                        fixed: true,
                                                        source: 'viewpath/model/Task.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'tags',
                                                loc: {
                                                    start: {
                                                        line: 624,
                                                        column: 50,
                                                        fixed: true,
                                                        source: 'viewpath/model/Task.ion'
                                                    },
                                                    end: {
                                                        line: 624,
                                                        column: 54,
                                                        fixed: true,
                                                        source: 'viewpath/model/Task.ion'
                                                    }
                                                }
                                            },
                                            existential: true,
                                            loc: {
                                                start: {
                                                    line: 624,
                                                    column: 27,
                                                    fixed: true,
                                                    source: 'viewpath/model/Task.ion'
                                                },
                                                end: {
                                                    line: 624,
                                                    column: 54,
                                                    fixed: true,
                                                    source: 'viewpath/model/Task.ion'
                                                }
                                            }
                                        },
                                        alternate: {
                                            type: 'ObjectExpression',
                                            properties: []
                                        }
                                    },
                                    order: '2'
                                }
                            ],
                            bound: false,
                            name: {
                                type: 'Identifier',
                                name: 'getSource',
                                loc: {
                                    start: {
                                        line: 623,
                                        column: 16,
                                        fixed: true,
                                        source: 'viewpath/model/Task.ion'
                                    },
                                    end: {
                                        line: 623,
                                        column: 25,
                                        fixed: true,
                                        source: 'viewpath/model/Task.ion'
                                    }
                                }
                            }
                        }, {
                            this: this,
                            _ref16: _ref16,
                            glass: glass,
                            _ref: _ref,
                            getDate: getDate,
                            _ref2: _ref2,
                            _ref3: _ref3,
                            _ref4: _ref4,
                            namespace: namespace,
                            getUserSearchKeys: getUserSearchKeys,
                            _ref5: _ref5,
                            Priority: Priority,
                            TaskType: TaskType,
                            OwnedEntity: OwnedEntity,
                            ScheduleConstraint: ScheduleConstraint,
                            TimeUnit: TimeUnit,
                            RepeatUnit: RepeatUnit,
                            Project: Project,
                            PermissionLevel: PermissionLevel,
                            TaskStatus: TaskStatus,
                            Notification: Notification,
                            NotificationType: NotificationType,
                            Document: Document,
                            Key: Key,
                            convert: convert,
                            DateTime: DateTime,
                            Duration: Duration,
                            moment: moment,
                            Timezone: Timezone,
                            TaskTimelineBox: TaskTimelineBox,
                            DocumentColumn: DocumentColumn,
                            alreadyWarned: alreadyWarned,
                            finishKey: finishKey,
                            _ref20: _ref20,
                            Task: Task
                        }, null);
                    })
                }
            },
            assigned: {
                type: 'object',
                visible: true,
                notFoundMessage: 'User does not exist. Invite them from the Organization Members Tab.',
                foreign: {
                    type: 'User',
                    property: 'key',
                    getSearchKeys: getUserSearchKeys
                },
                additionalProperties: {
                    type: 'object',
                    pattern: 'User/[^/@]+@[^/@]+',
                    additionalProperties: false,
                    properties: {
                        percent: {
                            type: 'integer',
                            minimum: 0,
                            value: 100
                        }
                    }
                },
                columnType: 'viewpath/html/AssignedColumn',
                hasOwnValue: function (object) {
                    return true;
                }
            },
            assignedCount: {
                get: function () {
                    var count = 0;
                    if (this.assigned != null) {
                        for (var key in this.assigned) {
                            count++;
                        }
                    }
                    return count;
                }
            },
            assignedKeys: {
                index: true,
                items: { type: 'string' },
                get: function () {
                    return Object.keys(this.assigned != null ? this.assigned : {});
                }
            },
            blocked: {
                get: function () {
                    var preds = this.predecessors;
                    if (preds) {
                        for (var key in preds) {
                            var _ref23 = preds[key];
                            var percent = _ref23.percent;
                            if (percent < 100) {
                                return true;
                            }
                        }
                    }
                    return false;
                }
            },
            predecessors: {
                type: 'object',
                visible: true,
                foreign: {
                    type: 'Task',
                    property: 'key',
                    getSearchKeys: function (task, text) {
                        var key = task.getKey();
                        var projectId = key.parent.id;
                        console.log('predecessors.getSearchKeys', projectId);
                        return Task.getSearchKeys({
                            text: text,
                            orgId: task.orgId,
                            projectId: projectId
                        });
                    }
                },
                additionalProperties: {
                    type: 'object',
                    additionalProperties: false,
                    properties: {
                        percent: {
                            required: false,
                            type: 'integer',
                            minimum: 0,
                            maximum: 100
                        },
                        lag: {
                            required: false,
                            type: 'string',
                            format: 'duration'
                        },
                        type: {
                            required: false,
                            type: 'string',
                            enum: [
                                'FS',
                                'FF',
                                'SF',
                                'SS'
                            ]
                        }
                    }
                }
            },
            addPredecessor: function (predecessorKey, type) {
                if (type == null)
                    type = 'FS';
                this.predecessors = this.predecessors != null ? this.predecessors : {};
                this.predecessors[predecessorKey] = { type: type };
                this.touch();
            },
            removePredecessor: function (predecessorKey) {
                if (this.predecessors != null) {
                    delete this.predecessors[predecessorKey];
                    this.touch();
                }
            },
            subscribed: {
                type: 'object',
                additionalProperties: {
                    type: 'object',
                    additionalProperties: false,
                    properties: {
                        readCommentId: {
                            type: 'integer',
                            minimum: 0
                        }
                    }
                }
            },
            subscribedKeys: {
                index: true,
                get: function () {
                    var keys = {};
                    {
                        if (this.subscribed) {
                            for (var key in this.subscribed) {
                                keys[key] = true;
                            }
                        }
                        if (this.assigned) {
                            for (var key in this.assigned) {
                                keys[key] = true;
                            }
                        }
                    }
                    return Object.keys(keys);
                }
            },
            hasChildren: {
                type: 'boolean',
                get: function () {
                    return this.childCount > 0;
                }
            },
            childCount: {
                enumerable: true,
                type: 'integer',
                value: 0
            },
            parentId: {
                index: true,
                type: 'string',
                format: 'id',
                value: null,
                foreign: {
                    type: 'Task',
                    property: 'id'
                }
            },
            parentTaskKey: {
                parent: true,
                format: 'key',
                description: 'The parent Task Key if this Task is nested or else null.',
                get: function () {
                    if (this.parentId != null && this.parentId.indexOf('/') >= 0) {
                        console.error('Task ' + this.getKey() + ' has an invalid parentId: ' + this.parentId);
                        this.parentId = this.parentId.split('/').pop();
                    }
                    return this.parentId ? new Key(this.getKey().parent, Task, this.parentId) : null;
                },
                set: function (value) {
                    if (value != null) {
                        value = this.getKey(value);
                    }
                    this.parentId = (value != null ? value.id : void 0) != null ? value.id : null;
                },
                foreign: {
                    cache: {
                        property: 'children',
                        predicate: function (task) {
                            return true;
                        },
                        properties: [
                            'percent',
                            'workValue',
                            'workUnit',
                            'durationValue',
                            'durationUnit'
                        ]
                    }
                }
            },
            children: { type: 'object' },
            parentKey: {
                format: 'key',
                description: 'The parentTaskKey or else the containing Entity key (probably a Project Key or User Key).',
                get: function () {
                    return this.parentTaskKey != null ? this.parentTaskKey : this.getKey() != null ? this.getKey().parent : void 0;
                }
            },
            getPeerKey: function (id) {
                return new Key(this.getKey().parent, Task, id);
            },
            childrenKey: {
                get: function () {
                    return new Key(this.getKey().parent, Task, {
                        where: { parentId: this.id },
                        sort: [{ order: true }]
                    });
                }
            },
            childrenSource: {
                get: function () {
                    return global.model != null ? global.model.server : void 0;
                }
            },
            url: {
                get: function () {
                    return '#task/' + this.id;
                }
            },
            paneConfig: {
                get: function () {
                    return {
                        id: 'Task',
                        key: this.key,
                        target: 'dialog'
                    };
                }
            },
            getPaneConfig: function (_ref17) {
                var sourceKey = _ref17.sourceKey;
                console.log('33333333');
                return {
                    id: 'Task',
                    key: this.key,
                    sourceKey: sourceKey,
                    target: 'dialog'
                };
            },
            projectPaneConfig: {
                get: function () {
                    return {
                        id: 'Project',
                        key: this.getKey().parent != null ? this.getKey().parent.toString() : void 0,
                        viewTask: this.key
                    };
                }
            },
            stems: {
                index: true,
                items: {
                    minLength: 3,
                    maxLength: 3
                }
            },
            createdCountComment: {
                serializable: false,
                type: 'integer',
                minimum: 0,
                value: 0
            },
            deletedCountComment: {
                serializable: false,
                type: 'integer',
                minimum: 0,
                value: 0
            },
            totalCountComment: {
                get: function () {
                    return this.createdCountComment - this.deletedCountComment;
                }
            },
            toString: function () {
                return this.name;
            },
            repeat: {
                type: 'boolean',
                get: function () {
                    return this.ScheduleConstraint.repeat === true;
                },
                set: function (value) {
                    if (value) {
                        this.ScheduleConstraint = ScheduleConstraint.Repeating.valueOf();
                    } else if (this.repeat) {
                        this.ScheduleConstraint = ScheduleConstraint.Default.valueOf();
                    }
                }
            },
            repeatFinish: {
                type: 'string',
                format: 'date',
                required: false
            },
            repeatByDayOfWeek: {
                label: 'Repeat by',
                description: 'Used when reapeating by month',
                type: 'integer',
                required: false,
                value: 0,
                values: [
                    {
                        id: 0,
                        name: 'day of the week'
                    },
                    {
                        id: 1,
                        name: 'day of the month'
                    }
                ]
            },
            repeatUnit: {
                description: 'The basic unit of repetition',
                visible: true,
                type: 'integer',
                enum: RepeatUnit.keys,
                values: RepeatUnit.values,
                value: 0
            },
            RepeatUnit: {
                get: function () {
                    return RepeatUnit.values[this.repeatUnit];
                }
            },
            repeatCount: {
                type: 'integer',
                description: 'How many units between repetitions',
                minimum: 1,
                maximum: 30
            },
            repeatDays: {
                getInputType: function () {
                    return require('../html/DaysOfWeekField');
                },
                type: 'integer',
                description: 'each bit is a day of the week: 1:sunday, 2:monday, 4:tuesday etc',
                minimum: 1,
                maximum: 127,
                value: 2
            },
            RepeatDays: {
                get: function () {
                    if (!(this.repeatDays != null)) {
                        return [];
                    }
                    var bits = this.repeatDays;
                    var results = [];
                    var days = 'Sunday,Monday,Tuesday,Wednesday,Thursday,Friday,Saturday'.split(',');
                    for (var i = 0; i < days.length; i++) {
                        var mask = 1 << i;
                        if ((mask & bits) === mask) {
                            results.push(days[i]);
                        }
                    }
                    return results;
                }
            },
            createInstances: function (beginRange, endRange, options) {
                var type = options != null ? options.type : void 0;
                var start = this.start;
                var duration = this.isoDuration;
                var instances = [];
                endRange = this.repeatFinish < endRange ? this.repeatFinish != null ? this.repeatFinish : endRange : endRange;
                beginRange = Date.parse(beginRange);
                endRange = Date.parse(endRange);
                duration = new Duration(duration);
                var stepDuration = new Duration(RepeatUnit[this.repeatUnit].duration).multiply(this.repeatCount);
                var startDate = new DateTime(start);
                var startTime = startDate.getIsoTimeAsDuration();
                var cursorDate = startDate.withoutTime().toDate();
                var ordinalDayOfMonth = Math.min(3, Math.floor((startDate.date - 1) / 7));
                var startDayOfMonth = startDate.toDate().getDay();
                var endCheckRange = stepDuration.addToDate(new Date(endRange)).getTime();
                var maxInstances = 365;
                var add = ion.bind(function (start) {
                        if (instances.length < maxInstances && start >= beginRange && start <= endRange) {
                            var instanceStart = new DateTime(start).add(startTime);
                            var instanceFinish = instanceStart.add(duration);
                            var instance = ion.patch.combine(type ? new type() : new Task({
                                    name: this.name,
                                    type: this.type
                                }), {
                                    start: instanceStart.iso(),
                                    finish: instanceFinish.iso()
                                });
                            instances.push(instance);
                            return true;
                        }
                        return false;
                    }, this);
                if (this.repeatUnit === RepeatUnit.weeks.id) {
                    cursorDate = cursorDate.beginningOfWeek();
                }
                var maxIterations = 1000;
                for (var i = 0; i < maxIterations && instances.length < maxInstances && cursorDate <= endCheckRange; i++) {
                    var saveTime = cursorDate.getTime();
                    if (this.repeatUnit === RepeatUnit.weeks.id) {
                        for (var day = 0; day < 7; day++) {
                            if (this.repeatDays & 1 << day) {
                                add(cursorDate);
                            }
                            cursorDate.addDays(1);
                        }
                    } else if (this.repeatUnit === RepeatUnit.months.id && this.repeatByDayOfWeek) {
                        var first = cursorDate.beginningOfMonth().getUTCDay();
                        var date = ordinalDayOfMonth * 7 + startDayOfMonth - first + 1;
                        if (first >= startDayOfMonth) {
                            date += 7;
                        }
                        cursorDate.setUTCDate(date);
                        add(cursorDate);
                    } else {
                        add(cursorDate);
                    }
                    cursorDate.setTime(saveTime);
                    stepDuration.addToDate(cursorDate);
                }
                return instances;
            }
        },
        test: {
            statusTest: function () {
                var tasks = [
                        new Task({}),
                        new Task({ start: '2017-12-09' }),
                        new Task({
                            start: '2017-12-09',
                            percent: 10
                        }),
                        new Task({
                            start: '2017-12-09',
                            percent: 10,
                            predecessors: { 'Task/blocker': { percent: 99 } }
                        }),
                        new Task({
                            start: '2017-12-09',
                            percent: 100,
                            predecessors: { 'Task/blocker': { percent: 99 } }
                        }),
                        new Task({
                            start: '2017-12-09',
                            percent: 100,
                            predecessors: { 'Task/blocker': { percent: 99 } },
                            scheduleConstraint: ScheduleConstraint.Repeating.id
                        })
                    ];
                for (var _i3 = 0; _i3 < tasks.length; _i3++) {
                    var index = _i3;
                    var task = tasks[_i3];
                    if (!(task.Status.id === index))
                        throw new Error('Assertion Failed: (task.Status.id is index)');
                }
            },
            repeat: function () {
                if (!(JSON.stringify(new Task({
                        start: '2017-01-01T09:00',
                        duration: 'PT8H',
                        repeatFinish: '2017-08-31',
                        repeatUnit: 0,
                        repeatCount: 4
                    }).createInstances('2017-08-01', '2017-10-31', { type: Object })) === '[{"start":"2017-08-01T09:00:00","finish":"2017-08-01T17:00:00"},{"start":"2017-08-05T09:00:00","finish":"2017-08-05T17:00:00"},{"start":"2017-08-09T09:00:00","finish":"2017-08-09T17:00:00"},{"start":"2017-08-13T09:00:00","finish":"2017-08-13T17:00:00"},{"start":"2017-08-17T09:00:00","finish":"2017-08-17T17:00:00"},{"start":"2017-08-21T09:00:00","finish":"2017-08-21T17:00:00"},{"start":"2017-08-25T09:00:00","finish":"2017-08-25T17:00:00"},{"start":"2017-08-29T09:00:00","finish":"2017-08-29T17:00:00"}]'))
                    throw new Error('Assertion Failed: (JSON.stringify(new Task({start:\'2017-01-01T09:00\', duration:\'PT8H\',repeatFinish:\'2017-08-31\',repeatUnit:0,repeatCount:4}).createInstances(\'2017-08-01\',\'2017-10-31\',{type:Object})) is \'[{"start":"2017-08-01T09:00:00","finish":"2017-08-01T17:00:00"},{"start":"2017-08-05T09:00:00","finish":"2017-08-05T17:00:00"},{"start":"2017-08-09T09:00:00","finish":"2017-08-09T17:00:00"},{"start":"2017-08-13T09:00:00","finish":"2017-08-13T17:00:00"},{"start":"2017-08-17T09:00:00","finish":"2017-08-17T17:00:00"},{"start":"2017-08-21T09:00:00","finish":"2017-08-21T17:00:00"},{"start":"2017-08-25T09:00:00","finish":"2017-08-25T17:00:00"},{"start":"2017-08-29T09:00:00","finish":"2017-08-29T17:00:00"}]\')');
                if (!(JSON.stringify(new Task({
                        start: '2017-01-01T09:00',
                        duration: 'PT8H',
                        repeatFinish: '2017-08-31',
                        repeatUnit: 1,
                        repeatCount: 2,
                        repeatDays: 62
                    }).createInstances('2017-08-01', '2017-10-31', { type: Object })) === '[{"start":"2017-08-01T09:00:00","finish":"2017-08-01T17:00:00"},{"start":"2017-08-02T09:00:00","finish":"2017-08-02T17:00:00"},{"start":"2017-08-03T09:00:00","finish":"2017-08-03T17:00:00"},{"start":"2017-08-04T09:00:00","finish":"2017-08-04T17:00:00"},{"start":"2017-08-14T09:00:00","finish":"2017-08-14T17:00:00"},{"start":"2017-08-15T09:00:00","finish":"2017-08-15T17:00:00"},{"start":"2017-08-16T09:00:00","finish":"2017-08-16T17:00:00"},{"start":"2017-08-17T09:00:00","finish":"2017-08-17T17:00:00"},{"start":"2017-08-18T09:00:00","finish":"2017-08-18T17:00:00"},{"start":"2017-08-28T09:00:00","finish":"2017-08-28T17:00:00"},{"start":"2017-08-29T09:00:00","finish":"2017-08-29T17:00:00"},{"start":"2017-08-30T09:00:00","finish":"2017-08-30T17:00:00"},{"start":"2017-08-31T09:00:00","finish":"2017-08-31T17:00:00"}]'))
                    throw new Error('Assertion Failed: (JSON.stringify(new Task({start:\'2017-01-01T09:00\', duration:\'PT8H\', repeatFinish:\'2017-08-31\',repeatUnit:1,repeatCount:2,repeatDays:62}).createInstances(\'2017-08-01\',\'2017-10-31\',{type:Object})) is \'[{"start":"2017-08-01T09:00:00","finish":"2017-08-01T17:00:00"},{"start":"2017-08-02T09:00:00","finish":"2017-08-02T17:00:00"},{"start":"2017-08-03T09:00:00","finish":"2017-08-03T17:00:00"},{"start":"2017-08-04T09:00:00","finish":"2017-08-04T17:00:00"},{"start":"2017-08-14T09:00:00","finish":"2017-08-14T17:00:00"},{"start":"2017-08-15T09:00:00","finish":"2017-08-15T17:00:00"},{"start":"2017-08-16T09:00:00","finish":"2017-08-16T17:00:00"},{"start":"2017-08-17T09:00:00","finish":"2017-08-17T17:00:00"},{"start":"2017-08-18T09:00:00","finish":"2017-08-18T17:00:00"},{"start":"2017-08-28T09:00:00","finish":"2017-08-28T17:00:00"},{"start":"2017-08-29T09:00:00","finish":"2017-08-29T17:00:00"},{"start":"2017-08-30T09:00:00","finish":"2017-08-30T17:00:00"},{"start":"2017-08-31T09:00:00","finish":"2017-08-31T17:00:00"}]\')');
                if (!(JSON.stringify(new Task({
                        start: '2017-01-09T09:00',
                        duration: 'PT8H',
                        repeatFinish: '2017-08-31',
                        repeatUnit: 2,
                        repeatCount: 1
                    }).createInstances('2017-05-01', '2017-10-31', { type: Object })) === '[{"start":"2017-05-09T09:00:00","finish":"2017-05-09T17:00:00"},{"start":"2017-06-09T09:00:00","finish":"2017-06-09T17:00:00"},{"start":"2017-07-09T09:00:00","finish":"2017-07-09T17:00:00"},{"start":"2017-08-09T09:00:00","finish":"2017-08-09T17:00:00"}]'))
                    throw new Error('Assertion Failed: (JSON.stringify(new Task({start:\'2017-01-09T09:00\', duration:\'PT8H\', repeatFinish:\'2017-08-31\',repeatUnit:2,repeatCount:1}).createInstances(\'2017-05-01\',\'2017-10-31\',{type:Object})) is \'[{"start":"2017-05-09T09:00:00","finish":"2017-05-09T17:00:00"},{"start":"2017-06-09T09:00:00","finish":"2017-06-09T17:00:00"},{"start":"2017-07-09T09:00:00","finish":"2017-07-09T17:00:00"},{"start":"2017-08-09T09:00:00","finish":"2017-08-09T17:00:00"}]\')');
                if (!(JSON.stringify(new Task({
                        start: '2016-12-23T09:00',
                        duration: 'PT8H',
                        repeatFinish: '2017-08-31',
                        repeatUnit: 2,
                        repeatCount: 1,
                        repeatByDayOfWeek: true
                    }).createInstances('2017-01-01', '2017-10-31', { type: Object })) === '[{"start":"2017-01-27T09:00:00","finish":"2017-01-27T17:00:00"},{"start":"2017-02-24T09:00:00","finish":"2017-02-24T17:00:00"},{"start":"2017-03-24T09:00:00","finish":"2017-03-24T17:00:00"},{"start":"2017-04-28T09:00:00","finish":"2017-04-28T17:00:00"},{"start":"2017-05-26T09:00:00","finish":"2017-05-26T17:00:00"},{"start":"2017-06-23T09:00:00","finish":"2017-06-23T17:00:00"},{"start":"2017-07-28T09:00:00","finish":"2017-07-28T17:00:00"},{"start":"2017-08-25T09:00:00","finish":"2017-08-25T17:00:00"}]'))
                    throw new Error('Assertion Failed: (JSON.stringify(new Task({start:\'2016-12-23T09:00\', duration:\'PT8H\', repeatFinish:\'2017-08-31\',repeatUnit:2,repeatCount:1,repeatByDayOfWeek:true}).createInstances(\'2017-01-01\',\'2017-10-31\',{type:Object})) is \'[{"start":"2017-01-27T09:00:00","finish":"2017-01-27T17:00:00"},{"start":"2017-02-24T09:00:00","finish":"2017-02-24T17:00:00"},{"start":"2017-03-24T09:00:00","finish":"2017-03-24T17:00:00"},{"start":"2017-04-28T09:00:00","finish":"2017-04-28T17:00:00"},{"start":"2017-05-26T09:00:00","finish":"2017-05-26T17:00:00"},{"start":"2017-06-23T09:00:00","finish":"2017-06-23T17:00:00"},{"start":"2017-07-28T09:00:00","finish":"2017-07-28T17:00:00"},{"start":"2017-08-25T09:00:00","finish":"2017-08-25T17:00:00"}]\')');
                if (!(JSON.stringify(new Task({
                        start: '2014-12-09T09:00',
                        duration: 'PT8H',
                        repeatFinish: '2017-08-31',
                        repeatUnit: 3,
                        repeatCount: 1
                    }).createInstances('2012-05-01', '2017-10-31', { type: Object })) === '[{"start":"2014-12-09T09:00:00","finish":"2014-12-09T17:00:00"},{"start":"2015-12-09T09:00:00","finish":"2015-12-09T17:00:00"},{"start":"2016-12-09T09:00:00","finish":"2016-12-09T17:00:00"}]'))
                    throw new Error('Assertion Failed: (JSON.stringify(new Task({start:\'2014-12-09T09:00\', duration:\'PT8H\', repeatFinish:\'2017-08-31\',repeatUnit:3,repeatCount:1}).createInstances(\'2012-05-01\',\'2017-10-31\',{type:Object})) is \'[{"start":"2014-12-09T09:00:00","finish":"2014-12-09T17:00:00"},{"start":"2015-12-09T09:00:00","finish":"2015-12-09T17:00:00"},{"start":"2016-12-09T09:00:00","finish":"2016-12-09T17:00:00"}]\')');
            },
            search: function () {
                var task = new Task({
                        name: 'Must work soon',
                        description: 'Things need to get done foo@bar.com'
                    });
                if (!(JSON.stringify(task.getSearchPhrases()) === '[["Must work soon",4],["Things need to get done foo@bar.com",1]]'))
                    throw new Error('Assertion Failed: (JSON.stringify(task.getSearchPhrases()) is \'[["Must work soon",4],["Things need to get done foo@bar.com",1]]\')');
                if (!(task.getSearchRank('oon') === -1))
                    throw new Error('Assertion Failed: (task.getSearchRank(\'oon\') is -1)');
                if (!(task.getSearchRank('must') === 4))
                    throw new Error('Assertion Failed: (task.getSearchRank(\'must\') is 4)');
                if (!(task.getSearchRank('don') === 1))
                    throw new Error('Assertion Failed: (task.getSearchRank(\'don\') is 1)');
                if (!(task.getSearchRank('com') === -1))
                    throw new Error('Assertion Failed: (task.getSearchRank(\'com\') is -1)');
            }
        }
    }, OwnedEntity);
module.exports = exports = Task;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/model/Task',_viewpath_model_Task_);
    else
      _viewpath_model_Task_.call(this, module, exports, require);
  }
  else {
    _viewpath_model_Task_.call(this);
  }
}).call(this)
void (function(){var _viewpath_model_TaskRepeat_ = function(module,exports,require){'use strict';
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/model/TaskRepeat',_viewpath_model_TaskRepeat_);
    else
      _viewpath_model_TaskRepeat_.call(this, module, exports, require);
  }
  else {
    _viewpath_model_TaskRepeat_.call(this);
  }
}).call(this)
void (function(){var _viewpath_model_TaskStatus_ = function(module,exports,require){'use strict';
var items = [
        {
            id: 0,
            name: 'Unscheduled'
        },
        {
            id: 1,
            name: 'Scheduled'
        },
        {
            id: 2,
            name: 'Started'
        },
        {
            id: 3,
            name: 'Blocked'
        },
        {
            id: 4,
            name: 'Complete'
        },
        {
            id: 5,
            name: 'Repeating'
        }
    ];
var _ref = {};
{
    _ref.keys = items.map(function (x) {
        return x.id;
    });
    _ref.values = items;
    for (var key in items) {
        var value = items[key];
        _ref[value.id] = value;
        _ref[value.name] = value;
    }
}
module.exports = exports = _ref;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/model/TaskStatus',_viewpath_model_TaskStatus_);
    else
      _viewpath_model_TaskStatus_.call(this, module, exports, require);
  }
  else {
    _viewpath_model_TaskStatus_.call(this);
  }
}).call(this)
void (function(){var _viewpath_model_TaskType_ = function(module,exports,require){'use strict';
var items = [
        {
            id: 0,
            scheduleOrder: 6,
            scheduleOpen: false,
            name: 'Task',
            color: '#8BC34A'
        },
        {
            id: 1,
            scheduleOrder: 5,
            scheduleOpen: false,
            name: 'Milestone',
            color: '#607D8B'
        },
        {
            id: 2,
            scheduleOrder: 4,
            scheduleOpen: false,
            name: 'Issue',
            color: '#FFC107'
        },
        {
            id: 3,
            scheduleOrder: 3,
            scheduleOpen: false,
            name: 'Event',
            color: '#4c9d9f'
        },
        {
            id: 4,
            scheduleOrder: 0,
            scheduleOpen: true,
            name: 'Shift',
            color: '#727272'
        },
        {
            id: 5,
            scheduleOrder: 1,
            scheduleOpen: false,
            name: 'Holiday',
            color: '#c3f4ed'
        },
        {
            id: 6,
            scheduleOrder: 2,
            scheduleOpen: false,
            name: 'Vacation',
            color: '#00BCD4'
        }
    ];
var _ref = {};
{
    _ref.keys = items.map(function (x) {
        return x.id;
    });
    _ref.values = items;
    for (var key in items) {
        var value = items[key];
        _ref[value.name] = value;
    }
}
module.exports = exports = _ref;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/model/TaskType',_viewpath_model_TaskType_);
    else
      _viewpath_model_TaskType_.call(this, module, exports, require);
  }
  else {
    _viewpath_model_TaskType_.call(this);
  }
}).call(this)
void (function(){var _viewpath_model_TimeUnit_ = function(module,exports,require){'use strict';
var items = [
        {
            id: 'minutes',
            isoFormat: 'PT0M',
            name: 'Minutes',
            labelSingular: 'minute',
            labelPlural: 'minutes',
            workMinutes: 1,
            minutes: 1
        },
        {
            id: 'hours',
            isoFormat: 'PT0H',
            name: 'Hours',
            labelSingular: 'hour',
            labelPlural: 'hours',
            workMinutes: 60,
            minutes: 60
        },
        {
            id: 'days',
            isoFormat: 'P0D',
            name: 'Days',
            labelSingular: 'day',
            labelPlural: 'days',
            workMinutes: 60 * 8,
            minutes: 60 * 24,
            minimum: 60 * 5,
            maximum: 60 * 12
        },
        {
            id: 'weeks',
            isoFormat: 'P0W',
            name: 'Weeks',
            labelSingular: 'week',
            labelPlural: 'weeks',
            workMinutes: 60 * 8 * 5,
            minutes: 60 * 24 * 7,
            days: 7,
            workDays: 5
        },
        {
            id: 'months',
            isoFormat: 'P0M',
            name: 'Months',
            labelSingular: 'month',
            labelPlural: 'months',
            workMinutes: 60 * 8 * 20,
            minutes: 60 * 24 * 30,
            days: 30,
            workDays: 20
        }
    ];
var totalMinutesToUnitValue = function (minutes) {
    if (!(minutes > 0)) {
        return {
            value: 0,
            unit: 'days'
        };
    }
    for (var i = items.length - 1; i >= 0; i--) {
        var unit = items[i];
        if (i === 0 || minutes >= unit.workMinutes * 3) {
            var value = Math.round(minutes / unit.workMinutes);
            return {
                value: value,
                unit: unit.id
            };
        }
    }
};
var _ref = {};
{
    _ref.keys = items.map(function (x) {
        return x.id;
    });
    _ref.values = items;
    for (var key in items) {
        var value = items[key];
        _ref[value.id] = value;
        _ref[value.name] = value;
    }
    _ref.totalMinutesToUnitValue = totalMinutesToUnitValue;
}
module.exports = exports = _ref;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/model/TimeUnit',_viewpath_model_TimeUnit_);
    else
      _viewpath_model_TimeUnit_.call(this, module, exports, require);
  }
  else {
    _viewpath_model_TimeUnit_.call(this);
  }
}).call(this)
void (function(){var _viewpath_model_User_ = function(module,exports,require){'use strict';
var ion = require('ion'), glass = require('glass'), _ref, _ref2, _ref3, _ref4;
_ref = glass.data;
var Key = _ref.Key;
_ref2 = require('../html');
var TaskTimelineBox = _ref2.TaskTimelineBox;
_ref3 = require('./');
var Tag = _ref3.Tag;
var Subscription = _ref3.Subscription;
var Organization = _ref3.Organization;
_ref4 = glass.time;
var DateTime = _ref4.DateTime;
var Duration = _ref4.Duration;
var User = ion.defineClass({
        name: 'User',
        id: module.id,
        persistent: true,
        defaultProperties: [
            'id',
            'name',
            'email',
            'picture',
            'validated'
        ],
        getSearchKeys: function (_ref5) {
            var text = _ref5.text;
            var orgId = _ref5.orgId;
            text = (text != null ? text.trim() : void 0) != null ? text.trim() : '';
            var stem = text.substring(0, User.properties.stems.items.maxLength);
            var _ref8 = [];
            if (stem.length >= User.properties.stems.items.minLength) {
                _ref8.push(new Key(User, {
                    where: {
                        orgIds: orgId,
                        stems: stem
                    },
                    limit: 50
                }).toString());
                if (text.indexOf('@') > 0) {
                    _ref8.push(new Key(User, { where: { email: text } }).toString());
                }
            }
            return _ref8;
        },
        access: {
            read: function (c) {
                if (c.user.email === this.email) {
                    return true;
                }
            },
            write: function (c) {
                if (c.user.email === this.email) {
                    return true;
                }
            }
        },
        properties: {
            key: { pattern: 'User/[^/@]+@[^/@]+' },
            getCalendars: function (orgId) {
                return this.orgs != null ? this.orgs[orgId] != null ? this.orgs[orgId].calendars : void 0 : void 0;
            },
            areCalendarsReadonly: function (orgId) {
                return false;
            },
            getTimelineComponentKey: function () {
                var Task = require('./Task');
                var startRange = function () {
                        return new Date().addMonths(-2).beginningOfDay().toISOString();
                    }();
                var tasksKey = new Key(Task, {
                        where: {
                            assignedKeys: this.getKey(),
                            dates: { '>': startRange }
                        },
                        sort: [{ dates: true }],
                        watch: true
                    });
                return tasksKey;
            },
            getTimelineComponents: ion.template(function (_ref6) {
                return ion.createRuntime({
                    type: 'Template',
                    id: null,
                    body: [
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'start',
                                        loc: {
                                            start: {
                                                line: 40,
                                                column: 42,
                                                fixed: true,
                                                source: 'viewpath/model/User.ion'
                                            },
                                            end: {
                                                line: 40,
                                                column: 47,
                                                fixed: true,
                                                source: 'viewpath/model/User.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'MemberExpression',
                                        object: {
                                            type: 'Identifier',
                                            name: '_ref6'
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'start',
                                            loc: {
                                                start: {
                                                    line: 40,
                                                    column: 42,
                                                    fixed: true,
                                                    source: 'viewpath/model/User.ion'
                                                },
                                                end: {
                                                    line: 40,
                                                    column: 47,
                                                    fixed: true,
                                                    source: 'viewpath/model/User.ion'
                                                }
                                            }
                                        },
                                        computed: false
                                    }
                                }],
                            kind: 'let',
                            order: '0'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'finish',
                                        loc: {
                                            start: {
                                                line: 40,
                                                column: 48,
                                                fixed: true,
                                                source: 'viewpath/model/User.ion'
                                            },
                                            end: {
                                                line: 40,
                                                column: 54,
                                                fixed: true,
                                                source: 'viewpath/model/User.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'MemberExpression',
                                        object: {
                                            type: 'Identifier',
                                            name: '_ref6'
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'finish',
                                            loc: {
                                                start: {
                                                    line: 40,
                                                    column: 48,
                                                    fixed: true,
                                                    source: 'viewpath/model/User.ion'
                                                },
                                                end: {
                                                    line: 40,
                                                    column: 54,
                                                    fixed: true,
                                                    source: 'viewpath/model/User.ion'
                                                }
                                            }
                                        },
                                        computed: false
                                    }
                                }],
                            kind: 'let',
                            order: '1'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'row',
                                        loc: {
                                            start: {
                                                line: 40,
                                                column: 55,
                                                fixed: true,
                                                source: 'viewpath/model/User.ion'
                                            },
                                            end: {
                                                line: 40,
                                                column: 58,
                                                fixed: true,
                                                source: 'viewpath/model/User.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'MemberExpression',
                                        object: {
                                            type: 'Identifier',
                                            name: '_ref6'
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'row',
                                            loc: {
                                                start: {
                                                    line: 40,
                                                    column: 55,
                                                    fixed: true,
                                                    source: 'viewpath/model/User.ion'
                                                },
                                                end: {
                                                    line: 40,
                                                    column: 58,
                                                    fixed: true,
                                                    source: 'viewpath/model/User.ion'
                                                }
                                            }
                                        },
                                        computed: false
                                    }
                                }],
                            kind: 'let',
                            order: '2'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'column',
                                        loc: {
                                            start: {
                                                line: 40,
                                                column: 59,
                                                fixed: true,
                                                source: 'viewpath/model/User.ion'
                                            },
                                            end: {
                                                line: 40,
                                                column: 65,
                                                fixed: true,
                                                source: 'viewpath/model/User.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'MemberExpression',
                                        object: {
                                            type: 'Identifier',
                                            name: '_ref6'
                                        },
                                        property: {
                                            type: 'Identifier',
                                            name: 'column',
                                            loc: {
                                                start: {
                                                    line: 40,
                                                    column: 59,
                                                    fixed: true,
                                                    source: 'viewpath/model/User.ion'
                                                },
                                                end: {
                                                    line: 40,
                                                    column: 65,
                                                    fixed: true,
                                                    source: 'viewpath/model/User.ion'
                                                }
                                            }
                                        },
                                        computed: false
                                    }
                                }],
                            kind: 'let',
                            order: '3'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'tasks',
                                        loc: {
                                            start: {
                                                line: 41,
                                                column: 16,
                                                fixed: true,
                                                source: 'viewpath/model/User.ion'
                                            },
                                            end: {
                                                line: 41,
                                                column: 21,
                                                fixed: true,
                                                source: 'viewpath/model/User.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'MemberExpression',
                                        computed: true,
                                        object: {
                                            type: 'MemberExpression',
                                            computed: false,
                                            object: {
                                                type: 'Identifier',
                                                name: 'model',
                                                loc: {
                                                    start: {
                                                        line: 41,
                                                        column: 24,
                                                        fixed: true,
                                                        source: 'viewpath/model/User.ion'
                                                    },
                                                    end: {
                                                        line: 41,
                                                        column: 29,
                                                        fixed: true,
                                                        source: 'viewpath/model/User.ion'
                                                    }
                                                }
                                            },
                                            property: {
                                                type: 'Identifier',
                                                name: 'server',
                                                loc: {
                                                    start: {
                                                        line: 41,
                                                        column: 30,
                                                        fixed: true,
                                                        source: 'viewpath/model/User.ion'
                                                    },
                                                    end: {
                                                        line: 41,
                                                        column: 36,
                                                        fixed: true,
                                                        source: 'viewpath/model/User.ion'
                                                    }
                                                }
                                            },
                                            loc: {
                                                start: {
                                                    line: 41,
                                                    column: 24,
                                                    fixed: true,
                                                    source: 'viewpath/model/User.ion'
                                                },
                                                end: {
                                                    line: 41,
                                                    column: 36,
                                                    fixed: true,
                                                    source: 'viewpath/model/User.ion'
                                                }
                                            }
                                        },
                                        property: {
                                            type: 'CallExpression',
                                            callee: {
                                                type: 'MemberExpression',
                                                computed: false,
                                                object: { type: 'ThisExpression' },
                                                property: {
                                                    type: 'Identifier',
                                                    name: 'getTimelineComponentKey',
                                                    loc: {
                                                        start: {
                                                            line: 41,
                                                            column: 42,
                                                            fixed: true,
                                                            source: 'viewpath/model/User.ion'
                                                        },
                                                        end: {
                                                            line: 41,
                                                            column: 65,
                                                            fixed: true,
                                                            source: 'viewpath/model/User.ion'
                                                        }
                                                    }
                                                },
                                                loc: {
                                                    start: {
                                                        line: 41,
                                                        column: 37,
                                                        fixed: true,
                                                        source: 'viewpath/model/User.ion'
                                                    },
                                                    end: {
                                                        line: 41,
                                                        column: 65,
                                                        fixed: true,
                                                        source: 'viewpath/model/User.ion'
                                                    }
                                                }
                                            },
                                            arguments: [],
                                            loc: {
                                                start: {
                                                    line: 41,
                                                    column: 37,
                                                    fixed: true,
                                                    source: 'viewpath/model/User.ion'
                                                },
                                                end: {
                                                    line: 41,
                                                    column: 67,
                                                    fixed: true,
                                                    source: 'viewpath/model/User.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 41,
                                                column: 24,
                                                fixed: true,
                                                source: 'viewpath/model/User.ion'
                                            },
                                            end: {
                                                line: 41,
                                                column: 68,
                                                fixed: true,
                                                source: 'viewpath/model/User.ion'
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '4'
                        },
                        {
                            type: 'VariableDeclaration',
                            declarations: [{
                                    type: 'VariableDeclarator',
                                    id: {
                                        type: 'Identifier',
                                        name: 'thisKey',
                                        loc: {
                                            start: {
                                                line: 42,
                                                column: 16,
                                                fixed: true,
                                                source: 'viewpath/model/User.ion'
                                            },
                                            end: {
                                                line: 42,
                                                column: 23,
                                                fixed: true,
                                                source: 'viewpath/model/User.ion'
                                            }
                                        }
                                    },
                                    init: {
                                        type: 'MemberExpression',
                                        computed: false,
                                        object: { type: 'ThisExpression' },
                                        property: {
                                            type: 'Identifier',
                                            name: 'key',
                                            loc: {
                                                start: {
                                                    line: 42,
                                                    column: 31,
                                                    fixed: true,
                                                    source: 'viewpath/model/User.ion'
                                                },
                                                end: {
                                                    line: 42,
                                                    column: 34,
                                                    fixed: true,
                                                    source: 'viewpath/model/User.ion'
                                                }
                                            }
                                        },
                                        loc: {
                                            start: {
                                                line: 42,
                                                column: 26,
                                                fixed: true,
                                                source: 'viewpath/model/User.ion'
                                            },
                                            end: {
                                                line: 42,
                                                column: 34,
                                                fixed: true,
                                                source: 'viewpath/model/User.ion'
                                            }
                                        }
                                    }
                                }],
                            kind: 'let',
                            order: '5'
                        },
                        {
                            type: 'ReturnStatement',
                            argument: {
                                type: 'ObjectExpression',
                                objectType: {
                                    type: 'ArrayExpression',
                                    elements: []
                                },
                                properties: [{
                                        type: 'IfStatement',
                                        test: {
                                            type: 'UnaryExpression',
                                            operator: '?',
                                            argument: {
                                                type: 'Identifier',
                                                name: 'tasks',
                                                loc: {
                                                    start: {
                                                        line: 44,
                                                        column: 19,
                                                        fixed: true,
                                                        source: 'viewpath/model/User.ion'
                                                    },
                                                    end: {
                                                        line: 44,
                                                        column: 24,
                                                        fixed: true,
                                                        source: 'viewpath/model/User.ion'
                                                    }
                                                }
                                            }
                                        },
                                        consequent: {
                                            type: 'BlockStatement',
                                            body: [{
                                                    type: 'ForInStatement',
                                                    left: {
                                                        type: 'VariableDeclaration',
                                                        declarations: [
                                                            {
                                                                type: 'VariableDeclarator',
                                                                id: {
                                                                    type: 'Identifier',
                                                                    name: 'key',
                                                                    loc: {
                                                                        start: {
                                                                            line: 45,
                                                                            column: 24,
                                                                            fixed: true,
                                                                            source: 'viewpath/model/User.ion'
                                                                        },
                                                                        end: {
                                                                            line: 45,
                                                                            column: 27,
                                                                            fixed: true,
                                                                            source: 'viewpath/model/User.ion'
                                                                        }
                                                                    }
                                                                },
                                                                init: null
                                                            },
                                                            {
                                                                type: 'VariableDeclarator',
                                                                id: {
                                                                    type: 'Identifier',
                                                                    name: 'task',
                                                                    loc: {
                                                                        start: {
                                                                            line: 45,
                                                                            column: 29,
                                                                            fixed: true,
                                                                            source: 'viewpath/model/User.ion'
                                                                        },
                                                                        end: {
                                                                            line: 45,
                                                                            column: 33,
                                                                            fixed: true,
                                                                            source: 'viewpath/model/User.ion'
                                                                        }
                                                                    }
                                                                },
                                                                init: null
                                                            }
                                                        ],
                                                        kind: 'let'
                                                    },
                                                    right: {
                                                        type: 'Identifier',
                                                        name: 'tasks',
                                                        loc: {
                                                            start: {
                                                                line: 45,
                                                                column: 37,
                                                                fixed: true,
                                                                source: 'viewpath/model/User.ion'
                                                            },
                                                            end: {
                                                                line: 45,
                                                                column: 42,
                                                                fixed: true,
                                                                source: 'viewpath/model/User.ion'
                                                            }
                                                        }
                                                    },
                                                    body: {
                                                        type: 'BlockStatement',
                                                        body: [{
                                                                type: 'IfStatement',
                                                                test: {
                                                                    type: 'UnaryExpression',
                                                                    operator: '?',
                                                                    argument: {
                                                                        type: 'MemberExpression',
                                                                        computed: true,
                                                                        object: {
                                                                            type: 'MemberExpression',
                                                                            computed: false,
                                                                            object: {
                                                                                type: 'Identifier',
                                                                                name: 'task',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 45,
                                                                                        column: 46,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/model/User.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 45,
                                                                                        column: 50,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/model/User.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            property: {
                                                                                type: 'Identifier',
                                                                                name: 'assigned',
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 45,
                                                                                        column: 51,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/model/User.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 45,
                                                                                        column: 59,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/model/User.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 45,
                                                                                    column: 46,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/model/User.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 45,
                                                                                    column: 59,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/model/User.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        property: {
                                                                            type: 'Identifier',
                                                                            name: 'thisKey',
                                                                            loc: {
                                                                                start: {
                                                                                    line: 45,
                                                                                    column: 60,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/model/User.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 45,
                                                                                    column: 67,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/model/User.ion'
                                                                                }
                                                                            }
                                                                        },
                                                                        loc: {
                                                                            start: {
                                                                                line: 45,
                                                                                column: 46,
                                                                                fixed: true,
                                                                                source: 'viewpath/model/User.ion'
                                                                            },
                                                                            end: {
                                                                                line: 45,
                                                                                column: 68,
                                                                                fixed: true,
                                                                                source: 'viewpath/model/User.ion'
                                                                            }
                                                                        }
                                                                    }
                                                                },
                                                                consequent: {
                                                                    type: 'BlockStatement',
                                                                    body: [{
                                                                            type: 'ExpressionStatement',
                                                                            expression: {
                                                                                type: 'CallExpression',
                                                                                callee: {
                                                                                    type: 'Identifier',
                                                                                    name: 'TaskTimelineBox',
                                                                                    loc: {
                                                                                        start: {
                                                                                            line: 46,
                                                                                            column: 24,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/model/User.ion'
                                                                                        },
                                                                                        end: {
                                                                                            line: 46,
                                                                                            column: 39,
                                                                                            fixed: true,
                                                                                            source: 'viewpath/model/User.ion'
                                                                                        }
                                                                                    }
                                                                                },
                                                                                arguments: [{
                                                                                        type: 'ObjectExpression',
                                                                                        properties: [
                                                                                            {
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'record',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 46,
                                                                                                            column: 41,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/model/User.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 46,
                                                                                                            column: 47,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/model/User.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'task',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 46,
                                                                                                            column: 48,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/model/User.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 46,
                                                                                                            column: 52,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/model/User.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '0'
                                                                                            },
                                                                                            {
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'row',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 46,
                                                                                                            column: 53,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/model/User.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 46,
                                                                                                            column: 56,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/model/User.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'row',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 46,
                                                                                                            column: 53,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/model/User.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 46,
                                                                                                            column: 56,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/model/User.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '1'
                                                                                            },
                                                                                            {
                                                                                                type: 'Property',
                                                                                                key: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'column',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 46,
                                                                                                            column: 57,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/model/User.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 46,
                                                                                                            column: 63,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/model/User.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                value: {
                                                                                                    type: 'Identifier',
                                                                                                    name: 'column',
                                                                                                    loc: {
                                                                                                        start: {
                                                                                                            line: 46,
                                                                                                            column: 57,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/model/User.ion'
                                                                                                        },
                                                                                                        end: {
                                                                                                            line: 46,
                                                                                                            column: 63,
                                                                                                            fixed: true,
                                                                                                            source: 'viewpath/model/User.ion'
                                                                                                        }
                                                                                                    }
                                                                                                },
                                                                                                kind: 'init',
                                                                                                order: '2'
                                                                                            }
                                                                                        ]
                                                                                    }],
                                                                                loc: {
                                                                                    start: {
                                                                                        line: 46,
                                                                                        column: 24,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/model/User.ion'
                                                                                    },
                                                                                    end: {
                                                                                        line: 46,
                                                                                        column: 65,
                                                                                        fixed: true,
                                                                                        source: 'viewpath/model/User.ion'
                                                                                    }
                                                                                }
                                                                            },
                                                                            loc: {
                                                                                start: {
                                                                                    line: 46,
                                                                                    column: 24,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/model/User.ion'
                                                                                },
                                                                                end: {
                                                                                    line: 46,
                                                                                    column: 65,
                                                                                    fixed: true,
                                                                                    source: 'viewpath/model/User.ion'
                                                                                }
                                                                            },
                                                                            order: '0'
                                                                        }]
                                                                },
                                                                order: '0'
                                                            }]
                                                    },
                                                    remove: null,
                                                    order: '0'
                                                }]
                                        },
                                        alternate: null,
                                        order: '0'
                                    }]
                            },
                            order: '6'
                        }
                    ],
                    bound: false,
                    name: {
                        type: 'Identifier',
                        name: 'getTimelineComponents',
                        loc: {
                            start: {
                                line: 40,
                                column: 8,
                                fixed: true,
                                source: 'viewpath/model/User.ion'
                            },
                            end: {
                                line: 40,
                                column: 29,
                                fixed: true,
                                source: 'viewpath/model/User.ion'
                            }
                        }
                    }
                }, {
                    this: this,
                    _ref6: _ref6,
                    ion: ion,
                    glass: glass,
                    _ref: _ref,
                    _ref2: _ref2,
                    _ref3: _ref3,
                    _ref4: _ref4,
                    Key: Key,
                    TaskTimelineBox: TaskTimelineBox,
                    Tag: Tag,
                    Subscription: Subscription,
                    Organization: Organization,
                    DateTime: DateTime,
                    Duration: Duration,
                    User: User
                }, null);
            }),
            name: {
                access: { read: true },
                search: { weight: 1 }
            },
            email: {
                index: function () {
                    return this.email.toLowerCase();
                },
                access: {
                    read: true,
                    write: false
                },
                search: { weight: 2 }
            },
            timezone: {
                type: 'string',
                required: false,
                format: 'timezone'
            },
            phoneCell: {
                label: 'Cell Number',
                type: 'string',
                format: 'phone'
            },
            phoneHome: {
                label: 'Home Number',
                type: 'string',
                format: 'phone'
            },
            phoneWork: {
                label: 'Work Number',
                type: 'string',
                format: 'phone'
            },
            addToOrg: function (orgKey) {
                this.orgs = this.orgs != null ? this.orgs : {};
                this.orgs[orgKey.id.valueOf()] = {};
            },
            removeFromOrg: function (orgKey) {
                this.orgs = this.orgs != null ? this.orgs : {};
                delete this.orgs[orgKey.id.valueOf()];
            },
            inviteToOrg: function (orgKey) {
                this.orgs = this.orgs != null ? this.orgs : {};
                if (this.orgs[orgKey.id.valueOf()] != null) {
                    return;
                }
                this.orgs[orgKey.id.valueOf()] = {
                    invited: new DateTime().iso(),
                    accepted: false
                };
            },
            acceptInvitation: function (orgKey) {
                if (this.orgs[orgKey.id.valueOf()] != null) {
                    this.orgs[orgKey.id.valueOf()].accepted = true;
                }
            },
            isInOrg: function (orgId) {
                return this.orgs != null && this.orgs[orgId] != null && (!(this.orgs[orgId].invited != null) || this.orgs[orgId].accepted);
            },
            orgs: {
                type: 'object',
                access: {
                    write: function (c) {
                        var touchedOrgIds = Object.keys(c.object != null ? c.object : {});
                        for (var _i = 0; _i < touchedOrgIds.length; _i++) {
                            var touchedOrgId = touchedOrgIds[_i];
                            var orgKey = new Key(Organization, touchedOrgId);
                            var oldOrg = c.oldRecords[orgKey];
                            var newOrg = c.newRecords[orgKey];
                            var isCreating = newOrg != null && !(oldOrg != null);
                            if (!c.user.isInOrg(touchedOrgId) && !isCreating) {
                                return false;
                            }
                        }
                        return true;
                    }
                },
                additionalProperties: {
                    type: 'object',
                    access: function (c) {
                        var orgId = c.name;
                        if (c.user.isInOrg(orgId)) {
                            return true;
                        }
                    },
                    properties: {
                        tags: {
                            type: 'object',
                            additionalProperties: {
                                type: 'object',
                                foreign: { type: 'Tag' }
                            }
                        },
                        calendars: {
                            name: 'calendars',
                            type: 'object',
                            additionalProperties: {
                                type: 'object',
                                foreign: { type: 'Project' }
                            }
                        },
                        invited: {
                            type: 'string',
                            format: 'date-time',
                            access: { write: false }
                        },
                        accepted: {
                            type: 'boolean',
                            access: { write: false }
                        }
                    }
                }
            },
            tags: {
                type: 'object',
                set: function (value) {
                    if (value != null) {
                        for (var orgId in value) {
                            var tags = value[orgId];
                            var _ref9 = {};
                            _ref9[orgId] = ion.patch.combine(_ref9[orgId], { tags: tags });
                            ion.patch(this, { orgs: _ref9 });
                        }
                    }
                }
            },
            orgTags: {
                index: true,
                get: function () {
                    var result = [];
                    if (this.orgs != null) {
                        {
                            var _ref7 = this.orgs;
                            for (var orgId in _ref7) {
                                var value = _ref7[orgId];
                                if (!(value != null)) {
                                    continue;
                                }
                                var tags = value.tags;
                                for (var tagId in tags) {
                                    var indexValue = Tag.getIndexValue(orgId, tagId);
                                    result.push(indexValue);
                                }
                            }
                        }
                    }
                    return result;
                }
            },
            orgIds: {
                index: true,
                get: function () {
                    return Object.keys(this.orgs != null ? this.orgs : {});
                }
            },
            acceptedOrgIds: {
                get: function () {
                    var self = this;
                    return this.orgIds.filter(function (orgId) {
                        return self.isInOrg(orgId);
                    });
                }
            },
            stems: {
                index: true,
                items: {
                    minLength: 1,
                    maxLength: 3
                }
            },
            paneConfig: {
                get: function () {
                    return {
                        id: 'User',
                        key: this.key
                    };
                }
            },
            toString: function () {
                return (this.name != null ? this.name : this.email) != null ? this.name != null ? this.name : this.email : this.id;
            },
            subscription: {
                type: 'string',
                format: 'key',
                index: true,
                foreign: {
                    type: 'Subscription',
                    property: 'key'
                },
                access: {
                    read: function (c) {
                        return true;
                    },
                    write: function (c) {
                        return c.user.email === this.email && c.object === null;
                    }
                }
            },
            trialDays: {
                type: 'integer',
                value: 30,
                access: {
                    read: true,
                    write: false
                }
            },
            trialStart: {
                type: 'string',
                format: 'date-time',
                editable: false,
                access: {
                    write: function (c) {
                        return c.user.email === this.email && !(this.trialStart != null);
                    }
                }
            },
            TrialStart: {
                get: function () {
                    return this.trialStart != null ? DateTime.parse(this.trialStart) : null;
                },
                set: function (value) {
                    return this.trialStart = (value != null ? value.iso() : void 0) != null ? value.iso() : null;
                }
            },
            TrialEnd: {
                get: function () {
                    if (!(this.trialStart != null)) {
                        return null;
                    }
                    return this.TrialStart.add(new Duration({ days: this.trialDays }));
                }
            },
            InTrial: {
                get: function () {
                    if (!(this.trialStart != null)) {
                        return false;
                    }
                    var padding = 1000 * 60 * 60;
                    var now = Date.now();
                    var start = this.TrialStart.toDate().getTime() - padding;
                    var end = this.TrialEnd.toDate().getTime() + padding;
                    return now > start && now < end;
                }
            },
            ExceededTrial: {
                get: function () {
                    return this.trialStart != null && !this.InTrial;
                }
            },
            startTrial: function () {
                this.TrialStart = new DateTime();
            },
            getProduct: function (subscription) {
                return this.InTrial ? Subscription.Product.Enterprise : subscription != null ? subscription.Product : void 0;
            }
        },
        test: function () {
            var user = new User({
                    name: 'Kris Nye',
                    email: 'krisnye@gmail.com'
                });
            if (!(JSON.stringify(user.stems) === '["kri","nye","kr","ny","k","n"]'))
                throw new Error('Assertion Failed: (JSON.stringify(user.stems) is \'["kri","nye","kr","ny","k","n"]\')');
        }
    }, glass.model.User);
module.exports = exports = User;
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/model/User',_viewpath_model_User_);
    else
      _viewpath_model_User_.call(this, module, exports, require);
  }
  else {
    _viewpath_model_User_.call(this);
  }
}).call(this)
void (function(){var _viewpath_model_index_ = function(module,exports,require){Object.defineProperty(exports, 'ApplicationModel', {get:function(){ return require('./ApplicationModel') }, enumerable: true}) 
Object.defineProperty(exports, 'AutoScheduler', {get:function(){ return require('./AutoScheduler') }, enumerable: true}) 
Object.defineProperty(exports, 'Availability', {get:function(){ return require('./Availability') }, enumerable: true}) 
Object.defineProperty(exports, 'Comment', {get:function(){ return require('./Comment') }, enumerable: true}) 
Object.defineProperty(exports, 'Document', {get:function(){ return require('./Document') }, enumerable: true}) 
Object.defineProperty(exports, 'Notification', {get:function(){ return require('./Notification') }, enumerable: true}) 
Object.defineProperty(exports, 'NotificationPriority', {get:function(){ return require('./NotificationPriority') }, enumerable: true}) 
Object.defineProperty(exports, 'NotificationType', {get:function(){ return require('./NotificationType') }, enumerable: true}) 
Object.defineProperty(exports, 'Organization', {get:function(){ return require('./Organization') }, enumerable: true}) 
Object.defineProperty(exports, 'OwnedEntity', {get:function(){ return require('./OwnedEntity') }, enumerable: true}) 
Object.defineProperty(exports, 'PermissionLevel', {get:function(){ return require('./PermissionLevel') }, enumerable: true}) 
Object.defineProperty(exports, 'Priority', {get:function(){ return require('./Priority') }, enumerable: true}) 
Object.defineProperty(exports, 'Project', {get:function(){ return require('./Project') }, enumerable: true}) 
Object.defineProperty(exports, 'ProjectType', {get:function(){ return require('./ProjectType') }, enumerable: true}) 
Object.defineProperty(exports, 'RepeatUnit', {get:function(){ return require('./RepeatUnit') }, enumerable: true}) 
Object.defineProperty(exports, 'ScheduleConstraint', {get:function(){ return require('./ScheduleConstraint') }, enumerable: true}) 
Object.defineProperty(exports, 'ScheduleFunctions', {get:function(){ return require('./ScheduleFunctions') }, enumerable: true}) 
Object.defineProperty(exports, 'Subscription', {get:function(){ return require('./Subscription') }, enumerable: true}) 
Object.defineProperty(exports, 'Tag', {get:function(){ return require('./Tag') }, enumerable: true}) 
Object.defineProperty(exports, 'Task', {get:function(){ return require('./Task') }, enumerable: true}) 
Object.defineProperty(exports, 'TaskRepeat', {get:function(){ return require('./TaskRepeat') }, enumerable: true}) 
Object.defineProperty(exports, 'TaskStatus', {get:function(){ return require('./TaskStatus') }, enumerable: true}) 
Object.defineProperty(exports, 'TaskType', {get:function(){ return require('./TaskType') }, enumerable: true}) 
Object.defineProperty(exports, 'TimeUnit', {get:function(){ return require('./TimeUnit') }, enumerable: true}) 
Object.defineProperty(exports, 'User', {get:function(){ return require('./User') }, enumerable: true}) 
Object.freeze(exports)
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/model/index',_viewpath_model_index_);
    else
      _viewpath_model_index_.call(this, module, exports, require);
  }
  else {
    _viewpath_model_index_.call(this);
  }
}).call(this)
void (function(){var _viewpath_root_ = function(module,exports,require){"use strict";
//# sourceMappingURL=root.js.map
  }
  if (typeof require === 'function') {
    if (require.register)
      require.register('viewpath/root',_viewpath_root_);
    else
      _viewpath_root_.call(this, module, exports, require);
  }
  else {
    _viewpath_root_.call(this);
  }
}).call(this)